# !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
# This file is machine-generated by lib/unicore/mktables from the Unicode
# database, Version 10.0.0.  Any changes made here will be lost!

sub TODO_FAILING_BREAKS { 0 }

use strict;
use warnings;

# Test qr/\X/ and the \p{} regular expression constructs.  This file is
# constructed by mktables from the tables it generates, so if mktables is
# buggy, this won't necessarily catch those bugs.  Tests are generated for all
# feasible properties; a few aren't currently feasible; see
# is_code_point_usable() in mktables for details.

# Standard test packages are not used because this manipulates SIG_WARN.  It
# exits 0 if every non-skipped test succeeded; -1 if any failed.

my $Tests = 0;
my $Fails = 0;

# loc_tools.pl requires this function to be defined
sub ok($@) {
    my ($pass, @msg) = @_;
    print "not " unless $pass;
    print "ok ";
    print ++$Tests;
    print " - ", join "", @msg if @msg;
    print "\n";
}

sub Expect($$$$) {
    my $expected = shift;
    my $ord = shift;
    my $regex  = shift;
    my $warning_type = shift;   # Type of warning message, like 'deprecated'
                                # or empty if none
    my $line   = (caller)[2];

    # Convert the code point to hex form
    my $string = sprintf "\"\\x{%04X}\"", $ord;

    my @tests = "";

    # The first time through, use all warnings.  If the input should generate
    # a warning, add another time through with them turned off
    push @tests, "no warnings '$warning_type';" if $warning_type;

    foreach my $no_warnings (@tests) {

        # Store any warning messages instead of outputting them
        local $SIG{__WARN__} = $SIG{__WARN__};
        my $warning_message;
        $SIG{__WARN__} = sub { $warning_message = $_[0] };

        $Tests++;

        # A string eval is needed because of the 'no warnings'.
        # Assumes no parentheses in the regular expression
        my $result = eval "$no_warnings
                            my \$RegObj = qr($regex);
                            $string =~ \$RegObj ? 1 : 0";
        if (not defined $result) {
            print "not ok $Tests - couldn't compile /$regex/; line $line: $@\n";
            $Fails++;
        }
        elsif ($result ^ $expected) {
            print "not ok $Tests - expected $expected but got $result for $string =~ qr/$regex/; line $line\n";
            $Fails++;
        }
        elsif ($warning_message) {
            if (! $warning_type || ($warning_type && $no_warnings)) {
                print "not ok $Tests - for qr/$regex/ did not expect warning message '$warning_message'; line $line\n";
                $Fails++;
            }
            else {
                print "ok $Tests - expected and got a warning message for qr/$regex/; line $line\n";
            }
        }
        elsif ($warning_type && ! $no_warnings) {
            print "not ok $Tests - for qr/$regex/ expected a $warning_type warning message, but got none; line $line\n";
            $Fails++;
        }
        else {
            print "ok $Tests - got $result for $string =~ qr/$regex/; line $line\n";
        }
    }
    return;
}

sub Error($) {
    my $regex  = shift;
    $Tests++;
    if (eval { 'x' =~ qr/$regex/; 1 }) {
        $Fails++;
        my $line = (caller)[2];
        print "not ok $Tests - re compiled ok, but expected error for qr/$regex/; line $line: $@\n";
    }
    else {
        my $line = (caller)[2];
        print "ok $Tests - got and expected error for qr/$regex/; line $line\n";
    }
    return;
}

# Break test files (e.g. GCBTest.txt) character that break allowed here
my $breakable_utf8 = my $breakable = chr(utf8::unicode_to_native(0xF7));
utf8::upgrade($breakable_utf8);

# Break test files (e.g. GCBTest.txt) character that indicates can't break
# here
my $nobreak_utf8 = my $nobreak = chr(utf8::unicode_to_native(0xD7));
utf8::upgrade($nobreak_utf8);

my $are_ctype_locales_available;
my $utf8_locale;
chdir 't' if -d 't';
eval { require "./loc_tools.pl" };
if (defined &locales_enabled) {
    $are_ctype_locales_available = locales_enabled('LC_CTYPE');
    if ($are_ctype_locales_available) {
        $utf8_locale = &find_utf8_ctype_locale;
    }
}

# Eval'd so can run on versions earlier than the property is available in
my $WB_Extend_or_Format_re = eval 'qr/[\p{WB=Extend}\p{WB=Format}\p{WB=ZWJ}]/';
if (! defined $WB_Extend_or_Format_re) {
    $WB_Extend_or_Format_re = eval 'qr/[\p{WB=Extend}\p{WB=Format}]/';
}

sub _test_break($$) {
    # Test various break property matches.  The 2nd parameter gives the
    # property name.  The input is a line from auxiliary/*Test.txt for the
    # given property.  Each such line is a sequence of Unicode (not native)
    # code points given by their hex numbers, separated by the two characters
    # defined just before this subroutine that indicate that either there can
    # or cannot be a break between the adjacent code points.  All these are
    # tested.
    #
    # For the gcb property extra tests are made.  if there isn't a break, that
    # means the sequence forms an extended grapheme cluster, which means that
    # \X should match the whole thing.  If there is a break, \X should stop
    # there.  This is all converted by this routine into a match: $string =~
    # /(\X)/, Each \X should match the next cluster; and that is what is
    # checked.

    my $template = shift;
    my $break_type = shift;

    my $line   = (caller 1)[2];   # Line number
    my $comment = "";

    if ($template =~ / ( .*? ) \s* \# (.*) /x) {
        $template = $1;
        $comment = $2;

        # Replace leading spaces with a single one.
        $comment =~ s/ ^ \s* / # /x;
    }

    # The line contains characters above the ASCII range, but in Latin1.  It
    # may or may not be in utf8, and if it is, it may or may not know it.  So,
    # convert these characters to 8 bits.  If knows is in utf8, simply
    # downgrade.
    if (utf8::is_utf8($template)) {
        utf8::downgrade($template);
    } else {

        # Otherwise, if it is in utf8, but doesn't know it, the next lines
        # convert the two problematic characters to their 8-bit equivalents.
        # If it isn't in utf8, they don't harm anything.
        use bytes;
        $template =~ s/$nobreak_utf8/$nobreak/g;
        $template =~ s/$breakable_utf8/$breakable/g;
    }

    # Perl customizes wb.  So change the official tests accordingly
    if ($break_type eq 'wb' && $WB_Extend_or_Format_re) {

        # Split into elements that alternate between code point and
        # break/no-break
        my @line = split / +/, $template;

        # Look at each code point and its following one
        for (my $i = 1; $i <  @line - 1 - 1; $i+=2) {

            # The customization only involves changing some breaks to
            # non-breaks.
            next if $line[$i+1] =~ /$nobreak/;

            my $lhs = chr utf8::unicode_to_native(hex $line[$i]);
            my $rhs = chr utf8::unicode_to_native(hex $line[$i+2]);

            # And it only affects adjacent space characters.
            next if $lhs !~ /\s/u;

            # But, we want to make sure to test spaces followed by a Extend
            # or Format.
            next if $rhs !~ /\s|$WB_Extend_or_Format_re/;

            # To test the customization, add some white-space before this to
            # create a span.  The $lhs white space may or may not be bound to
            # that span, and also with the $rhs.  If the $rhs is a binding
            # character, the $lhs is bound to it and not to the span, unless
            # $lhs is vertical space.  In all other cases, the $lhs is bound
            # to the span.  If the $rhs is white space, it is bound to the
            # $lhs
            my $bound;
            my $span;
            if ($rhs =~ /$WB_Extend_or_Format_re/) {
                if ($lhs =~ /\v/) {
                    $bound = $breakable;
                    $span = $nobreak;
                }
                else {
                    $bound = $nobreak;
                    $span = $breakable;
                }
            }
            else {
                $span = $nobreak;
                $bound = $nobreak;
            }

            splice @line, $i, 0, ( '0020', $nobreak, '0020', $span);
            $i += 4;
            $line[$i+1] = $bound;
        }
        $template = join " ", @line;
    }

    # The input is just the break/no-break symbols and sequences of Unicode
    # code points as hex digits separated by spaces for legibility. e.g.:
    # ÷ 0020 × 0308 ÷ 0020 ÷
    # Convert to native \x format
    $template =~ s/ \s* ( [[:xdigit:]]+ ) \s* /sprintf("\\x{%02X}", utf8::unicode_to_native(hex $1))/gex;
    $template =~ s/ \s* //gx;   # Probably the line above removed all spaces;
                                # but be sure

    # Make a copy of the input with the symbols replaced by \b{} and \B{} as
    # appropriate
    my $break_pattern = $template =~ s/ $breakable /\\b{$break_type}/grx;
    $break_pattern =~ s/ $nobreak /\\B{$break_type}/gx;

    my $display_string = $template =~ s/[$breakable$nobreak]//gr;
    my $string = eval "\"$display_string\"";

    # The remaining massaging of the input is for the \X tests.  Get rid of
    # the leading and trailing breakables
    $template =~ s/^ \s* $breakable \s* //x;
    $template =~ s/ \s* $breakable \s* $ //x;

    # Delete no-breaks
    $template =~ s/ \s* $nobreak \s* //xg;

    # Split the input into segments that are breakable between them.
    my @should_display = split /\s*$breakable\s*/, $template;
    my @should_match = map { eval "\"$_\"" } @should_display;

    # If a string can be represented in both non-ut8 and utf8, test both cases
    my $display_upgrade = "";
    UPGRADE:
    for my $to_upgrade (0 .. 1) {

        if ($to_upgrade) {

            # If already in utf8, would just be a repeat
            next UPGRADE if utf8::is_utf8($string);

            utf8::upgrade($string);
            $display_upgrade = " (utf8-upgraded)";
        }

        my @modifiers = qw(a aa d u i);
        if ($are_ctype_locales_available) {
            push @modifiers, "l$utf8_locale" if defined $utf8_locale;

            # The /l modifier has C after it to indicate the locale to try
            push @modifiers, "lC";
        }

        # Test for each of the regex modifiers.
        for my $modifier (@modifiers) {
            my $display_locale = "";

            # For /l, set the locale to what it says to.
            if ($modifier =~ / ^ l (.*) /x) {
                my $locale = $1;
                $display_locale = "(locale = $locale)";
                POSIX::setlocale(&POSIX::LC_CTYPE, $locale);
                $modifier = 'l';
            }

            no warnings qw(locale regexp surrogate);
            my $pattern = "(?$modifier:$break_pattern)";

            # Actually do the test
            my $matched_text;
            my $matched = $string =~ qr/$pattern/;
            if ($matched) {
                $matched_text = "matched";
            }
            else {
                $matched_text = "failed to match";
                print "not ";

                if (TODO_FAILING_BREAKS) {
                    $comment = " # $comment" unless $comment =~ / ^ \s* \# /x;
                    $comment =~ s/#/# TODO/;
                }
            }
            print "ok ", ++$Tests, " - \"$display_string\" $matched_text /$pattern/$display_upgrade; line $line $display_locale$comment\n";

            # Only print the comment on the first use of this line
            $comment = "";

            # Repeat with the first \B{} in the pattern.  This makes sure the
            # code in regexec.c:find_byclass() for \B gets executed
            if ($pattern =~ / ( .*? : ) .* ( \\B\{ .* ) /x) {
                my $B_pattern = "$1$2";
                $matched = $string =~ qr/$B_pattern/;
                print "not " unless $matched;
                $matched_text = ($matched) ? "matched" : "failed to match";
                print "ok ", ++$Tests, " - \"$display_string\" $matched_text /$B_pattern/$display_upgrade; line $line $display_locale";
                print " # TODO" if TODO_FAILING_BREAKS && ! $matched;
                print "\n";
            }
        }

        next if $break_type ne 'gcb';

        # Finally, do the \X match.
        my @matches = $string =~ /(\X)/g;

        # Look through each matched cluster to verify that it matches what we
        # expect.
        my $min = (@matches < @should_match) ? @matches : @should_match;
        for my $i (0 .. $min - 1) {
            $Tests++;
            if ($matches[$i] eq $should_match[$i]) {
                print "ok $Tests - ";
                if ($i == 0) {
                    print "In \"$display_string\" =~ /(\\X)/g, \\X #1";
                } else {
                    print "And \\X #", $i + 1,
                }
                print " correctly matched $should_display[$i]; line $line\n";
            } else {
                $matches[$i] = join("", map { sprintf "\\x{%04X}", ord $_ }
                                                    split "", $matches[$i]);
                print "not ok $Tests -";
                print " # TODO" if TODO_FAILING_BREAKS;
                print " In \"$display_string\" =~ /(\\X)/g, \\X #",
                    $i + 1,
                    " should have matched $should_display[$i]",
                    " but instead matched $matches[$i]",
                    ".  Abandoning rest of line $line\n";
                next UPGRADE;
            }
        }

        # And the number of matches should equal the number of expected matches.
        $Tests++;
        if (@matches == @should_match) {
            print "ok $Tests - Nothing was left over; line $line\n";
        } else {
            print "not ok $Tests - There were ", scalar @should_match, " \\X matches expected, but got ", scalar @matches, " instead; line $line";
            print " # TODO" if TODO_FAILING_BREAKS;
            print "\n";
        }
    }

    return;
}

sub Test_GCB($) {
    _test_break(shift, 'gcb');
}

sub Test_LB($) {
    _test_break(shift, 'lb');
}

sub Test_SB($) {
    _test_break(shift, 'sb');
}

sub Test_WB($) {
    _test_break(shift, 'wb');
}

sub Finished() {
    print "1..$Tests\n";
    exit($Fails ? -1 : 0);
}

if (!$::TESTCHUNK or $::TESTCHUNK == 1) {
    Error('\p{Script=InGreek}');    # Bug #69018
    Test_GCB("1100 $nobreak 1161");  # Bug #70940
    Expect(0, 0x2028, '\p{Print}', ""); # Bug # 71722
    Expect(0, 0x2029, '\p{Print}', ""); # Bug # 71722
    Expect(1, 0xFF10, '\p{XDigit}', ""); # Bug # 71726
    
    # Make sure this gets tested; it was not part of the official test suite at
    # the time this was added.  Note that this is as it would appear in the
    # official suite, and gets modified to check for the perl tailoring by
    # Test_WB()
    Test_WB("$breakable 0020 $breakable 0020 $breakable 0308 $breakable");
    Test_LB("$nobreak 200B $nobreak 0020 $nobreak 0020 $breakable 2060 $breakable");
    Error('\p{_perllb}');
    Error('\P{_perllb}');
    Error('\p{_perlscx}');
    Error('\P{_perlscx}');
    Error('\p{_perlwb}');
    Error('\P{_perlwb}');
    Error('\p{age}');
    Error('\P{age}');
    Error('\p{Age=_V1_1/a/}');
    Error('\P{Age=_V1_1/a/}');
    Expect(1, 65533, '\p{Age=v11}', "");
    Expect(0, 65533, '\p{^Age=v11}', "");
    Expect(0, 65533, '\P{Age=v11}', "");
    Expect(1, 65533, '\P{^Age=v11}', "");
    Expect(0, 65536, '\p{Age=v11}', "");
    Expect(1, 65536, '\p{^Age=v11}', "");
    Expect(1, 65536, '\P{Age=v11}', "");
    Expect(0, 65536, '\P{^Age=v11}', "");
    Expect(1, 65533, '\p{Age=	v1_1}', "");
    Expect(0, 65533, '\p{^Age=	v1_1}', "");
    Expect(0, 65533, '\P{Age=	v1_1}', "");
    Expect(1, 65533, '\P{^Age=	v1_1}', "");
    Expect(0, 65536, '\p{Age=	v1_1}', "");
    Expect(1, 65536, '\p{^Age=	v1_1}', "");
    Expect(1, 65536, '\P{Age=	v1_1}', "");
    Expect(0, 65536, '\P{^Age=	v1_1}', "");
    Error('\p{Is_Age=:=	 000000001.1}');
    Error('\P{Is_Age=:=	 000000001.1}');
    Expect(1, 65533, '\p{Is_Age=+0_1.1}', "");
    Expect(0, 65533, '\p{^Is_Age=+0_1.1}', "");
    Expect(0, 65533, '\P{Is_Age=+0_1.1}', "");
    Expect(1, 65533, '\P{^Is_Age=+0_1.1}', "");
    Expect(0, 65536, '\p{Is_Age=+0_1.1}', "");
    Expect(1, 65536, '\p{^Is_Age=+0_1.1}', "");
    Expect(1, 65536, '\P{Is_Age=+0_1.1}', "");
    Expect(0, 65536, '\P{^Is_Age=+0_1.1}', "");
    Error('\p{Age=		v10_0:=}');
    Error('\P{Age=		v10_0:=}');
    Expect(1, 191456, '\p{Age=v100}', "");
    Expect(0, 191456, '\p{^Age=v100}', "");
    Expect(0, 191456, '\P{Age=v100}', "");
    Expect(1, 191456, '\P{^Age=v100}', "");
    Expect(0, 191457, '\p{Age=v100}', "");
    Expect(1, 191457, '\p{^Age=v100}', "");
    Expect(1, 191457, '\P{Age=v100}', "");
    Expect(0, 191457, '\P{^Age=v100}', "");
    Expect(1, 191456, '\p{Age=	-V10_0}', "");
    Expect(0, 191456, '\p{^Age=	-V10_0}', "");
    Expect(0, 191456, '\P{Age=	-V10_0}', "");
    Expect(1, 191456, '\P{^Age=	-V10_0}', "");
    Expect(0, 191457, '\p{Age=	-V10_0}', "");
    Expect(1, 191457, '\p{^Age=	-V10_0}', "");
    Expect(1, 191457, '\P{Age=	-V10_0}', "");
    Expect(0, 191457, '\P{^Age=	-V10_0}', "");
    Error('\p{Is_Age:   __0_0_0_0_0_0_0010.0/a/}');
    Error('\P{Is_Age:   __0_0_0_0_0_0_0010.0/a/}');
    Expect(1, 191456, '\p{Is_Age=0000010.0}', "");
    Expect(0, 191456, '\p{^Is_Age=0000010.0}', "");
    Expect(0, 191456, '\P{Is_Age=0000010.0}', "");
    Expect(1, 191456, '\P{^Is_Age=0000010.0}', "");
    Expect(0, 191457, '\p{Is_Age=0000010.0}', "");
    Expect(1, 191457, '\p{^Is_Age=0000010.0}', "");
    Expect(1, 191457, '\P{Is_Age=0000010.0}', "");
    Expect(0, 191457, '\P{^Is_Age=0000010.0}', "");
    Error('\p{Age=/a/V2_0}');
    Error('\P{Age=/a/V2_0}');
    Expect(1, 983040, '\p{Age=v20}', "");
    Expect(0, 983040, '\p{^Age=v20}', "");
    Expect(0, 983040, '\P{Age=v20}', "");
    Expect(1, 983040, '\P{^Age=v20}', "");
    Expect(0, 983037, '\p{Age=v20}', "");
    Expect(1, 983037, '\p{^Age=v20}', "");
    Expect(1, 983037, '\P{Age=v20}', "");
    Expect(0, 983037, '\P{^Age=v20}', "");
    Expect(1, 983040, '\p{Age= _V2_0}', "");
    Expect(0, 983040, '\p{^Age= _V2_0}', "");
    Expect(0, 983040, '\P{Age= _V2_0}', "");
    Expect(1, 983040, '\P{^Age= _V2_0}', "");
    Expect(0, 983037, '\p{Age= _V2_0}', "");
    Expect(1, 983037, '\p{^Age= _V2_0}', "");
    Expect(1, 983037, '\P{Age= _V2_0}', "");
    Expect(0, 983037, '\P{^Age= _V2_0}', "");
    Error('\p{Is_Age=_ +000002.0:=}');
    Error('\P{Is_Age=_ +000002.0:=}');
    Expect(1, 983040, '\p{Is_Age=2.0}', "");
    Expect(0, 983040, '\p{^Is_Age=2.0}', "");
    Expect(0, 983040, '\P{Is_Age=2.0}', "");
    Expect(1, 983040, '\P{^Is_Age=2.0}', "");
    Expect(0, 983037, '\p{Is_Age=2.0}', "");
    Expect(1, 983037, '\p{^Is_Age=2.0}', "");
    Expect(1, 983037, '\P{Is_Age=2.0}', "");
    Expect(0, 983037, '\P{^Is_Age=2.0}', "");
    Error('\p{Age=_:=V2_1}');
    Error('\P{Age=_:=V2_1}');
    Expect(1, 65532, '\p{Age=v21}', "");
    Expect(0, 65532, '\p{^Age=v21}', "");
    Expect(0, 65532, '\P{Age=v21}', "");
    Expect(1, 65532, '\P{^Age=v21}', "");
    Expect(0, 65533, '\p{Age=v21}', "");
    Expect(1, 65533, '\p{^Age=v21}', "");
    Expect(1, 65533, '\P{Age=v21}', "");
    Expect(0, 65533, '\P{^Age=v21}', "");
    Expect(1, 65532, '\p{Age=_-V2_1}', "");
    Expect(0, 65532, '\p{^Age=_-V2_1}', "");
    Expect(0, 65532, '\P{Age=_-V2_1}', "");
    Expect(1, 65532, '\P{^Age=_-V2_1}', "");
    Expect(0, 65533, '\p{Age=_-V2_1}', "");
    Expect(1, 65533, '\p{^Age=_-V2_1}', "");
    Expect(1, 65533, '\P{Age=_-V2_1}', "");
    Expect(0, 65533, '\P{^Age=_-V2_1}', "");
    Error('\p{Is_Age=		0_0_0_02.1/a/}');
    Error('\P{Is_Age=		0_0_0_02.1/a/}');
    Expect(1, 65532, '\p{Is_Age=+0_0_02.1}', "");
    Expect(0, 65532, '\p{^Is_Age=+0_0_02.1}', "");
    Expect(0, 65532, '\P{Is_Age=+0_0_02.1}', "");
    Expect(1, 65532, '\P{^Is_Age=+0_0_02.1}', "");
    Expect(0, 65533, '\p{Is_Age=+0_0_02.1}', "");
    Expect(1, 65533, '\p{^Is_Age=+0_0_02.1}', "");
    Expect(1, 65533, '\P{Is_Age=+0_0_02.1}', "");
    Expect(0, 65533, '\P{^Is_Age=+0_0_02.1}', "");
    Error('\p{Age=_V3_0/a/}');
    Error('\P{Age=_V3_0/a/}');
    Expect(1, 65531, '\p{Age=v30}', "");
    Expect(0, 65531, '\p{^Age=v30}', "");
    Expect(0, 65531, '\P{Age=v30}', "");
    Expect(1, 65531, '\P{^Age=v30}', "");
    Expect(0, 65532, '\p{Age=v30}', "");
    Expect(1, 65532, '\p{^Age=v30}', "");
    Expect(1, 65532, '\P{Age=v30}', "");
    Expect(0, 65532, '\P{^Age=v30}', "");
    Expect(1, 65531, '\p{Age= 	V3_0}', "");
    Expect(0, 65531, '\p{^Age= 	V3_0}', "");
    Expect(0, 65531, '\P{Age= 	V3_0}', "");
    Expect(1, 65531, '\P{^Age= 	V3_0}', "");
    Expect(0, 65532, '\p{Age= 	V3_0}', "");
    Expect(1, 65532, '\p{^Age= 	V3_0}', "");
    Expect(1, 65532, '\P{Age= 	V3_0}', "");
    Expect(0, 65532, '\P{^Age= 	V3_0}', "");
    Error('\p{Is_Age=:=-+03.0}');
    Error('\P{Is_Age=:=-+03.0}');
    Expect(1, 65531, '\p{Is_Age=00000003.0}', "");
    Expect(0, 65531, '\p{^Is_Age=00000003.0}', "");
    Expect(0, 65531, '\P{Is_Age=00000003.0}', "");
    Expect(1, 65531, '\P{^Is_Age=00000003.0}', "");
    Expect(0, 65532, '\p{Is_Age=00000003.0}', "");
    Expect(1, 65532, '\p{^Is_Age=00000003.0}', "");
    Expect(1, 65532, '\P{Is_Age=00000003.0}', "");
    Expect(0, 65532, '\P{^Is_Age=00000003.0}', "");
    Error('\p{Age=--V3_1/a/}');
    Error('\P{Age=--V3_1/a/}');
    Expect(1, 917631, '\p{Age=v31}', "");
    Expect(0, 917631, '\p{^Age=v31}', "");
    Expect(0, 917631, '\P{Age=v31}', "");
    Expect(1, 917631, '\P{^Age=v31}', "");
    Expect(0, 917632, '\p{Age=v31}', "");
    Expect(1, 917632, '\p{^Age=v31}', "");
    Expect(1, 917632, '\P{Age=v31}', "");
    Expect(0, 917632, '\P{^Age=v31}', "");
    Expect(1, 917631, '\p{Age= V3_1}', "");
    Expect(0, 917631, '\p{^Age= V3_1}', "");
    Expect(0, 917631, '\P{Age= V3_1}', "");
    Expect(1, 917631, '\P{^Age= V3_1}', "");
    Expect(0, 917632, '\p{Age= V3_1}', "");
    Expect(1, 917632, '\p{^Age= V3_1}', "");
    Expect(1, 917632, '\P{Age= V3_1}', "");
    Expect(0, 917632, '\P{^Age= V3_1}', "");
    Error('\p{Is_Age=	0_3.1/a/}');
    Error('\P{Is_Age=	0_3.1/a/}');
    Expect(1, 917631, '\p{Is_Age=+0000003.1}', "");
    Expect(0, 917631, '\p{^Is_Age=+0000003.1}', "");
    Expect(0, 917631, '\P{Is_Age=+0000003.1}', "");
    Expect(1, 917631, '\P{^Is_Age=+0000003.1}', "");
    Expect(0, 917632, '\p{Is_Age=+0000003.1}', "");
    Expect(1, 917632, '\p{^Is_Age=+0000003.1}', "");
    Expect(1, 917632, '\P{Is_Age=+0000003.1}', "");
    Expect(0, 917632, '\P{^Is_Age=+0000003.1}', "");
    Error('\p{Age=	V3_2/a/}');
    Error('\P{Age=	V3_2/a/}');
    Expect(1, 65376, '\p{Age=v32}', "");
    Expect(0, 65376, '\p{^Age=v32}', "");
    Expect(0, 65376, '\P{Age=v32}', "");
    Expect(1, 65376, '\P{^Age=v32}', "");
    Expect(0, 65377, '\p{Age=v32}', "");
    Expect(1, 65377, '\p{^Age=v32}', "");
    Expect(1, 65377, '\P{Age=v32}', "");
    Expect(0, 65377, '\P{^Age=v32}', "");
    Expect(1, 65376, '\p{Age=  V3_2}', "");
    Expect(0, 65376, '\p{^Age=  V3_2}', "");
    Expect(0, 65376, '\P{Age=  V3_2}', "");
    Expect(1, 65376, '\P{^Age=  V3_2}', "");
    Expect(0, 65377, '\p{Age=  V3_2}', "");
    Expect(1, 65377, '\p{^Age=  V3_2}', "");
    Expect(1, 65377, '\P{Age=  V3_2}', "");
    Expect(0, 65377, '\P{^Age=  V3_2}', "");
    Error('\p{Is_Age=:=	-+0000003.2}');
    Error('\P{Is_Age=:=	-+0000003.2}');
    Expect(1, 65376, '\p{Is_Age=00_00_00_3.2}', "");
    Expect(0, 65376, '\p{^Is_Age=00_00_00_3.2}', "");
    Expect(0, 65376, '\P{Is_Age=00_00_00_3.2}', "");
    Expect(1, 65376, '\P{^Is_Age=00_00_00_3.2}', "");
    Expect(0, 65377, '\p{Is_Age=00_00_00_3.2}', "");
    Expect(1, 65377, '\p{^Is_Age=00_00_00_3.2}', "");
    Expect(1, 65377, '\P{Is_Age=00_00_00_3.2}', "");
    Expect(0, 65377, '\P{^Is_Age=00_00_00_3.2}', "");
    Error('\p{Age= :=V4_0}');
    Error('\P{Age= :=V4_0}');
    Expect(1, 917999, '\p{Age=v40}', "");
    Expect(0, 917999, '\p{^Age=v40}', "");
    Expect(0, 917999, '\P{Age=v40}', "");
    Expect(1, 917999, '\P{^Age=v40}', "");
    Expect(0, 918000, '\p{Age=v40}', "");
    Expect(1, 918000, '\p{^Age=v40}', "");
    Expect(1, 918000, '\P{Age=v40}', "");
    Expect(0, 918000, '\P{^Age=v40}', "");
    Expect(1, 917999, '\p{Age=V4_0}', "");
    Expect(0, 917999, '\p{^Age=V4_0}', "");
    Expect(0, 917999, '\P{Age=V4_0}', "");
    Expect(1, 917999, '\P{^Age=V4_0}', "");
    Expect(0, 918000, '\p{Age=V4_0}', "");
    Expect(1, 918000, '\p{^Age=V4_0}', "");
    Expect(1, 918000, '\P{Age=V4_0}', "");
    Expect(0, 918000, '\P{^Age=V4_0}', "");
    Error('\p{Is_Age=/a/ -+0000004.0}');
    Error('\P{Is_Age=/a/ -+0000004.0}');
    Expect(1, 917999, '\p{Is_Age=4.0}', "");
    Expect(0, 917999, '\p{^Is_Age=4.0}', "");
    Expect(0, 917999, '\P{Is_Age=4.0}', "");
    Expect(1, 917999, '\P{^Is_Age=4.0}', "");
    Expect(0, 918000, '\p{Is_Age=4.0}', "");
    Expect(1, 918000, '\p{^Is_Age=4.0}', "");
    Expect(1, 918000, '\P{Is_Age=4.0}', "");
    Expect(0, 918000, '\P{^Is_Age=4.0}', "");
    Error('\p{Age: := _V4_1}');
    Error('\P{Age: := _V4_1}');
    Expect(1, 120485, '\p{Age=v41}', "");
    Expect(0, 120485, '\p{^Age=v41}', "");
    Expect(0, 120485, '\P{Age=v41}', "");
    Expect(1, 120485, '\P{^Age=v41}', "");
    Expect(0, 120486, '\p{Age=v41}', "");
    Expect(1, 120486, '\p{^Age=v41}', "");
    Expect(1, 120486, '\P{Age=v41}', "");
    Expect(0, 120486, '\P{^Age=v41}', "");
    Expect(1, 120485, '\p{Age=	_V4_1}', "");
    Expect(0, 120485, '\p{^Age=	_V4_1}', "");
    Expect(0, 120485, '\P{Age=	_V4_1}', "");
    Expect(1, 120485, '\P{^Age=	_V4_1}', "");
    Expect(0, 120486, '\p{Age=	_V4_1}', "");
    Expect(1, 120486, '\p{^Age=	_V4_1}', "");
    Expect(1, 120486, '\P{Age=	_V4_1}', "");
    Expect(0, 120486, '\P{^Age=	_V4_1}', "");
    Error('\p{Is_Age=:=  004.1}');
    Error('\P{Is_Age=:=  004.1}');
    Expect(1, 120485, '\p{Is_Age=+004.1}', "");
    Expect(0, 120485, '\p{^Is_Age=+004.1}', "");
    Expect(0, 120485, '\P{Is_Age=+004.1}', "");
    Expect(1, 120485, '\P{^Is_Age=+004.1}', "");
    Expect(0, 120486, '\p{Is_Age=+004.1}', "");
    Expect(1, 120486, '\p{^Is_Age=+004.1}', "");
    Expect(1, 120486, '\P{Is_Age=+004.1}', "");
    Expect(0, 120486, '\P{^Is_Age=+004.1}', "");
    Error('\p{Age=-/a/v5_0}');
    Error('\P{Age=-/a/v5_0}');
    Expect(1, 120779, '\p{Age=v50}', "");
    Expect(0, 120779, '\p{^Age=v50}', "");
    Expect(0, 120779, '\P{Age=v50}', "");
    Expect(1, 120779, '\P{^Age=v50}', "");
    Expect(0, 120780, '\p{Age=v50}', "");
    Expect(1, 120780, '\p{^Age=v50}', "");
    Expect(1, 120780, '\P{Age=v50}', "");
    Expect(0, 120780, '\P{^Age=v50}', "");
    Expect(1, 120779, '\p{Age=	V5_0}', "");
    Expect(0, 120779, '\p{^Age=	V5_0}', "");
    Expect(0, 120779, '\P{Age=	V5_0}', "");
    Expect(1, 120779, '\P{^Age=	V5_0}', "");
    Expect(0, 120780, '\p{Age=	V5_0}', "");
    Expect(1, 120780, '\p{^Age=	V5_0}', "");
    Expect(1, 120780, '\P{Age=	V5_0}', "");
    Expect(0, 120780, '\P{^Age=	V5_0}', "");
    Error('\p{Is_Age=:= 5.0}');
    Error('\P{Is_Age=:= 5.0}');
    Expect(1, 120779, '\p{Is_Age=5.0}', "");
    Expect(0, 120779, '\p{^Is_Age=5.0}', "");
    Expect(0, 120779, '\P{Is_Age=5.0}', "");
    Expect(1, 120779, '\P{^Is_Age=5.0}', "");
    Expect(0, 120780, '\p{Is_Age=5.0}', "");
    Expect(1, 120780, '\p{^Is_Age=5.0}', "");
    Expect(1, 120780, '\P{Is_Age=5.0}', "");
    Expect(0, 120780, '\P{^Is_Age=5.0}', "");
    Error('\p{Age=-/a/V5_1}');
    Error('\P{Age=-/a/V5_1}');
    Expect(1, 127123, '\p{Age=v51}', "");
    Expect(0, 127123, '\p{^Age=v51}', "");
    Expect(0, 127123, '\P{Age=v51}', "");
    Expect(1, 127123, '\P{^Age=v51}', "");
    Expect(0, 127124, '\p{Age=v51}', "");
    Expect(1, 127124, '\p{^Age=v51}', "");
    Expect(1, 127124, '\P{Age=v51}', "");
    Expect(0, 127124, '\P{^Age=v51}', "");
    Expect(1, 127123, '\p{Age=		V5_1}', "");
    Expect(0, 127123, '\p{^Age=		V5_1}', "");
    Expect(0, 127123, '\P{Age=		V5_1}', "");
    Expect(1, 127123, '\P{^Age=		V5_1}', "");
    Expect(0, 127124, '\p{Age=		V5_1}', "");
    Expect(1, 127124, '\p{^Age=		V5_1}', "");
    Expect(1, 127124, '\P{Age=		V5_1}', "");
    Expect(0, 127124, '\P{^Age=		V5_1}', "");
    Error('\p{Is_Age=:=- 0005.1}');
    Error('\P{Is_Age=:=- 0005.1}');
    Expect(1, 127123, '\p{Is_Age=+000005.1}', "");
    Expect(0, 127123, '\p{^Is_Age=+000005.1}', "");
    Expect(0, 127123, '\P{Is_Age=+000005.1}', "");
    Expect(1, 127123, '\P{^Is_Age=+000005.1}', "");
    Expect(0, 127124, '\p{Is_Age=+000005.1}', "");
    Expect(1, 127124, '\p{^Is_Age=+000005.1}', "");
    Expect(1, 127124, '\P{Is_Age=+000005.1}', "");
    Expect(0, 127124, '\P{^Is_Age=+000005.1}', "");
    Error('\p{Age=/a/__V5_2}');
    Error('\P{Age=/a/__V5_2}');
    Expect(1, 177972, '\p{Age=v52}', "");
    Expect(0, 177972, '\p{^Age=v52}', "");
    Expect(0, 177972, '\P{Age=v52}', "");
    Expect(1, 177972, '\P{^Age=v52}', "");
    Expect(0, 177973, '\p{Age=v52}', "");
    Expect(1, 177973, '\p{^Age=v52}', "");
    Expect(1, 177973, '\P{Age=v52}', "");
    Expect(0, 177973, '\P{^Age=v52}', "");
    Expect(1, 177972, '\p{Age=_	v5_2}', "");
    Expect(0, 177972, '\p{^Age=_	v5_2}', "");
    Expect(0, 177972, '\P{Age=_	v5_2}', "");
    Expect(1, 177972, '\P{^Age=_	v5_2}', "");
    Expect(0, 177973, '\p{Age=_	v5_2}', "");
    Expect(1, 177973, '\p{^Age=_	v5_2}', "");
    Expect(1, 177973, '\P{Age=_	v5_2}', "");
    Expect(0, 177973, '\P{^Age=_	v5_2}', "");
    Error('\p{Is_Age=:=-	0_0_05.2}');
    Error('\P{Is_Age=:=-	0_0_05.2}');
    Expect(1, 177972, '\p{Is_Age=+0000_5.2}', "");
    Expect(0, 177972, '\p{^Is_Age=+0000_5.2}', "");
    Expect(0, 177972, '\P{Is_Age=+0000_5.2}', "");
    Expect(1, 177972, '\P{^Is_Age=+0000_5.2}', "");
    Expect(0, 177973, '\p{Is_Age=+0000_5.2}', "");
    Expect(1, 177973, '\p{^Is_Age=+0000_5.2}', "");
    Expect(1, 177973, '\P{Is_Age=+0000_5.2}', "");
    Expect(0, 177973, '\P{^Is_Age=+0000_5.2}', "");
    Error('\p{Age=:=V6_0}');
    Error('\P{Age=:=V6_0}');
    Expect(1, 178205, '\p{Age:	v60}', "");
    Expect(0, 178205, '\p{^Age:	v60}', "");
    Expect(0, 178205, '\P{Age:	v60}', "");
    Expect(1, 178205, '\P{^Age:	v60}', "");
    Expect(0, 178206, '\p{Age:	v60}', "");
    Expect(1, 178206, '\p{^Age:	v60}', "");
    Expect(1, 178206, '\P{Age:	v60}', "");
    Expect(0, 178206, '\P{^Age:	v60}', "");
    Expect(1, 178205, '\p{Age= -v6_0}', "");
    Expect(0, 178205, '\p{^Age= -v6_0}', "");
    Expect(0, 178205, '\P{Age= -v6_0}', "");
    Expect(1, 178205, '\P{^Age= -v6_0}', "");
    Expect(0, 178206, '\p{Age= -v6_0}', "");
    Expect(1, 178206, '\p{^Age= -v6_0}', "");
    Expect(1, 178206, '\P{Age= -v6_0}', "");
    Expect(0, 178206, '\P{^Age= -v6_0}', "");
    Error('\p{Is_Age=_0_6.0:=}');
    Error('\P{Is_Age=_0_6.0:=}');
    Expect(1, 178205, '\p{Is_Age=+00006.0}', "");
    Expect(0, 178205, '\p{^Is_Age=+00006.0}', "");
    Expect(0, 178205, '\P{Is_Age=+00006.0}', "");
    Expect(1, 178205, '\P{^Is_Age=+00006.0}', "");
    Expect(0, 178206, '\p{Is_Age=+00006.0}', "");
    Expect(1, 178206, '\p{^Is_Age=+00006.0}', "");
    Expect(1, 178206, '\P{Is_Age=+00006.0}', "");
    Expect(0, 178206, '\P{^Is_Age=+00006.0}', "");
    Error('\p{Age=:=_V6_1}');
    Error('\P{Age=:=_V6_1}');
    Expect(1, 128564, '\p{Age:	v61}', "");
    Expect(0, 128564, '\p{^Age:	v61}', "");
    Expect(0, 128564, '\P{Age:	v61}', "");
    Expect(1, 128564, '\P{^Age:	v61}', "");
    Expect(0, 128565, '\p{Age:	v61}', "");
    Expect(1, 128565, '\p{^Age:	v61}', "");
    Expect(1, 128565, '\P{Age:	v61}', "");
    Expect(0, 128565, '\P{^Age:	v61}', "");
    Expect(1, 128564, '\p{Age=		v6_1}', "");
    Expect(0, 128564, '\p{^Age=		v6_1}', "");
    Expect(0, 128564, '\P{Age=		v6_1}', "");
    Expect(1, 128564, '\P{^Age=		v6_1}', "");
    Expect(0, 128565, '\p{Age=		v6_1}', "");
    Expect(1, 128565, '\p{^Age=		v6_1}', "");
    Expect(1, 128565, '\P{Age=		v6_1}', "");
    Expect(0, 128565, '\P{^Age=		v6_1}', "");
    Error('\p{Is_Age=:=00_6.1}');
    Error('\P{Is_Age=:=00_6.1}');
    Expect(1, 128564, '\p{Is_Age=00_00_6.1}', "");
    Expect(0, 128564, '\p{^Is_Age=00_00_6.1}', "");
    Expect(0, 128564, '\P{Is_Age=00_00_6.1}', "");
    Expect(1, 128564, '\P{^Is_Age=00_00_6.1}', "");
    Expect(0, 128565, '\p{Is_Age=00_00_6.1}', "");
    Expect(1, 128565, '\p{^Is_Age=00_00_6.1}', "");
    Expect(1, 128565, '\P{Is_Age=00_00_6.1}', "");
    Expect(0, 128565, '\P{^Is_Age=00_00_6.1}', "");
    Error('\p{Age:/a/_V6_2}');
    Error('\P{Age:/a/_V6_2}');
    Expect(1, 8378, '\p{Age=v62}', "");
    Expect(0, 8378, '\p{^Age=v62}', "");
    Expect(0, 8378, '\P{Age=v62}', "");
    Expect(1, 8378, '\P{^Age=v62}', "");
    Expect(0, 8379, '\p{Age=v62}', "");
    Expect(1, 8379, '\p{^Age=v62}', "");
    Expect(1, 8379, '\P{Age=v62}', "");
    Expect(0, 8379, '\P{^Age=v62}', "");
    Expect(1, 8378, '\p{Age=	-V6_2}', "");
    Expect(0, 8378, '\p{^Age=	-V6_2}', "");
    Expect(0, 8378, '\P{Age=	-V6_2}', "");
    Expect(1, 8378, '\P{^Age=	-V6_2}', "");
    Expect(0, 8379, '\p{Age=	-V6_2}', "");
    Expect(1, 8379, '\p{^Age=	-V6_2}', "");
    Expect(1, 8379, '\P{Age=	-V6_2}', "");
    Expect(0, 8379, '\P{^Age=	-V6_2}', "");
    Error('\p{Is_Age=/a/-_+0_6.2}');
    Error('\P{Is_Age=/a/-_+0_6.2}');
    Expect(1, 8378, '\p{Is_Age=+00_00_00_006.2}', "");
    Expect(0, 8378, '\p{^Is_Age=+00_00_00_006.2}', "");
    Expect(0, 8378, '\P{Is_Age=+00_00_00_006.2}', "");
    Expect(1, 8378, '\P{^Is_Age=+00_00_00_006.2}', "");
    Expect(0, 8379, '\p{Is_Age=+00_00_00_006.2}', "");
    Expect(1, 8379, '\p{^Is_Age=+00_00_00_006.2}', "");
    Expect(1, 8379, '\P{Is_Age=+00_00_00_006.2}', "");
    Expect(0, 8379, '\P{^Is_Age=+00_00_00_006.2}', "");
    Error('\p{Age=V6_3:=}');
    Error('\P{Age=V6_3:=}');
    Expect(1, 8297, '\p{Age=v63}', "");
    Expect(0, 8297, '\p{^Age=v63}', "");
    Expect(0, 8297, '\P{Age=v63}', "");
    Expect(1, 8297, '\P{^Age=v63}', "");
    Expect(0, 8298, '\p{Age=v63}', "");
    Expect(1, 8298, '\p{^Age=v63}', "");
    Expect(1, 8298, '\P{Age=v63}', "");
    Expect(0, 8298, '\P{^Age=v63}', "");
    Expect(1, 8297, '\p{Age=	V6_3}', "");
    Expect(0, 8297, '\p{^Age=	V6_3}', "");
    Expect(0, 8297, '\P{Age=	V6_3}', "");
    Expect(1, 8297, '\P{^Age=	V6_3}', "");
    Expect(0, 8298, '\p{Age=	V6_3}', "");
    Expect(1, 8298, '\p{^Age=	V6_3}', "");
    Expect(1, 8298, '\P{Age=	V6_3}', "");
    Expect(0, 8298, '\P{^Age=	V6_3}', "");
    Error('\p{Is_Age=/a/		6.3}');
    Error('\P{Is_Age=/a/		6.3}');
    Expect(1, 8297, '\p{Is_Age=0_0_0_06.3}', "");
    Expect(0, 8297, '\p{^Is_Age=0_0_0_06.3}', "");
    Expect(0, 8297, '\P{Is_Age=0_0_0_06.3}', "");
    Expect(1, 8297, '\P{^Is_Age=0_0_0_06.3}', "");
    Expect(0, 8298, '\p{Is_Age=0_0_0_06.3}', "");
    Expect(1, 8298, '\p{^Is_Age=0_0_0_06.3}', "");
    Expect(1, 8298, '\P{Is_Age=0_0_0_06.3}', "");
    Expect(0, 8298, '\P{^Is_Age=0_0_0_06.3}', "");
    Error('\p{Age=	:=V7_0}');
    Error('\P{Age=	:=V7_0}');
    Expect(1, 129197, '\p{Age: v70}', "");
    Expect(0, 129197, '\p{^Age: v70}', "");
    Expect(0, 129197, '\P{Age: v70}', "");
    Expect(1, 129197, '\P{^Age: v70}', "");
    Expect(0, 129198, '\p{Age: v70}', "");
    Expect(1, 129198, '\p{^Age: v70}', "");
    Expect(1, 129198, '\P{Age: v70}', "");
    Expect(0, 129198, '\P{^Age: v70}', "");
    Expect(1, 129197, '\p{Age= _V7_0}', "");
    Expect(0, 129197, '\p{^Age= _V7_0}', "");
    Expect(0, 129197, '\P{Age= _V7_0}', "");
    Expect(1, 129197, '\P{^Age= _V7_0}', "");
    Expect(0, 129198, '\p{Age= _V7_0}', "");
    Expect(1, 129198, '\p{^Age= _V7_0}', "");
    Expect(1, 129198, '\P{Age= _V7_0}', "");
    Expect(0, 129198, '\P{^Age= _V7_0}', "");
    Error('\p{Is_Age=_+000007.0:=}');
    Error('\P{Is_Age=_+000007.0:=}');
    Expect(1, 129197, '\p{Is_Age=+0000000007.0}', "");
    Expect(0, 129197, '\p{^Is_Age=+0000000007.0}', "");
    Expect(0, 129197, '\P{Is_Age=+0000000007.0}', "");
    Expect(1, 129197, '\P{^Is_Age=+0000000007.0}', "");
    Expect(0, 129198, '\p{Is_Age=+0000000007.0}', "");
    Expect(1, 129198, '\p{^Is_Age=+0000000007.0}', "");
    Expect(1, 129198, '\P{Is_Age=+0000000007.0}', "");
    Expect(0, 129198, '\P{^Is_Age=+0000000007.0}', "");
    Error('\p{Age:		/a/V8_0}');
    Error('\P{Age:		/a/V8_0}');
    Expect(1, 183969, '\p{Age=v80}', "");
    Expect(0, 183969, '\p{^Age=v80}', "");
    Expect(0, 183969, '\P{Age=v80}', "");
    Expect(1, 183969, '\P{^Age=v80}', "");
    Expect(0, 183970, '\p{Age=v80}', "");
    Expect(1, 183970, '\p{^Age=v80}', "");
    Expect(1, 183970, '\P{Age=v80}', "");
    Expect(0, 183970, '\P{^Age=v80}', "");
    Expect(1, 183969, '\p{Age=_ v8_0}', "");
    Expect(0, 183969, '\p{^Age=_ v8_0}', "");
    Expect(0, 183969, '\P{Age=_ v8_0}', "");
    Expect(1, 183969, '\P{^Age=_ v8_0}', "");
    Expect(0, 183970, '\p{Age=_ v8_0}', "");
    Expect(1, 183970, '\p{^Age=_ v8_0}', "");
    Expect(1, 183970, '\P{Age=_ v8_0}', "");
    Expect(0, 183970, '\P{^Age=_ v8_0}', "");
    Error('\p{Is_Age=- +00_8.0:=}');
    Error('\P{Is_Age=- +00_8.0:=}');
    Expect(1, 183969, '\p{Is_Age:	0_8.0}', "");
    Expect(0, 183969, '\p{^Is_Age:	0_8.0}', "");
    Expect(0, 183969, '\P{Is_Age:	0_8.0}', "");
    Expect(1, 183969, '\P{^Is_Age:	0_8.0}', "");
    Expect(0, 183970, '\p{Is_Age:	0_8.0}', "");
    Expect(1, 183970, '\p{^Is_Age:	0_8.0}', "");
    Expect(1, 183970, '\P{Is_Age:	0_8.0}', "");
    Expect(0, 183970, '\P{^Is_Age:	0_8.0}', "");
    Error('\p{Age=/a/V9_0}');
    Error('\P{Age=/a/V9_0}');
    Expect(1, 129425, '\p{Age=v90}', "");
    Expect(0, 129425, '\p{^Age=v90}', "");
    Expect(0, 129425, '\P{Age=v90}', "");
    Expect(1, 129425, '\P{^Age=v90}', "");
    Expect(0, 129426, '\p{Age=v90}', "");
    Expect(1, 129426, '\p{^Age=v90}', "");
    Expect(1, 129426, '\P{Age=v90}', "");
    Expect(0, 129426, '\P{^Age=v90}', "");
    Expect(1, 129425, '\p{Age=_V9_0}', "");
    Expect(0, 129425, '\p{^Age=_V9_0}', "");
    Expect(0, 129425, '\P{Age=_V9_0}', "");
    Expect(1, 129425, '\P{^Age=_V9_0}', "");
    Expect(0, 129426, '\p{Age=_V9_0}', "");
    Expect(1, 129426, '\p{^Age=_V9_0}', "");
    Expect(1, 129426, '\P{Age=_V9_0}', "");
    Expect(0, 129426, '\P{^Age=_V9_0}', "");
    Error('\p{Is_Age= 00000000_9.0:=}');
    Error('\P{Is_Age= 00000000_9.0:=}');
    Expect(1, 129425, '\p{Is_Age=+0_9.0}', "");
    Expect(0, 129425, '\p{^Is_Age=+0_9.0}', "");
    Expect(0, 129425, '\P{Is_Age=+0_9.0}', "");
    Expect(1, 129425, '\P{^Is_Age=+0_9.0}', "");
    Expect(0, 129426, '\p{Is_Age=+0_9.0}', "");
    Expect(1, 129426, '\p{^Is_Age=+0_9.0}', "");
    Expect(1, 129426, '\P{Is_Age=+0_9.0}', "");
    Expect(0, 129426, '\P{^Is_Age=+0_9.0}', "");
    Error('\p{Age=:= unassigned}');
    Error('\P{Age=:= unassigned}');
    Expect(1, 983037, '\p{Age=unassigned}', "");
    Expect(0, 983037, '\p{^Age=unassigned}', "");
    Expect(0, 983037, '\P{Age=unassigned}', "");
    Expect(1, 983037, '\P{^Age=unassigned}', "");
    Expect(0, 983040, '\p{Age=unassigned}', "");
    Expect(1, 983040, '\p{^Age=unassigned}', "");
    Expect(1, 983040, '\P{Age=unassigned}', "");
    Expect(0, 983040, '\P{^Age=unassigned}', "");
    Expect(1, 983037, '\p{Age=  Unassigned}', "");
    Expect(0, 983037, '\p{^Age=  Unassigned}', "");
    Expect(0, 983037, '\P{Age=  Unassigned}', "");
    Expect(1, 983037, '\P{^Age=  Unassigned}', "");
    Expect(0, 983040, '\p{Age=  Unassigned}', "");
    Expect(1, 983040, '\p{^Age=  Unassigned}', "");
    Expect(1, 983040, '\P{Age=  Unassigned}', "");
    Expect(0, 983040, '\P{^Age=  Unassigned}', "");
    Error('\p{Is_Age=_:=NA}');
    Error('\P{Is_Age=_:=NA}');
    Expect(1, 983037, '\p{Is_Age=na}', "");
    Expect(0, 983037, '\p{^Is_Age=na}', "");
    Expect(0, 983037, '\P{Is_Age=na}', "");
    Expect(1, 983037, '\P{^Is_Age=na}', "");
    Expect(0, 983040, '\p{Is_Age=na}', "");
    Expect(1, 983040, '\p{^Is_Age=na}', "");
    Expect(1, 983040, '\P{Is_Age=na}', "");
    Expect(0, 983040, '\P{^Is_Age=na}', "");
    Expect(1, 983037, '\p{Is_Age= NA}', "");
    Expect(0, 983037, '\p{^Is_Age= NA}', "");
    Expect(0, 983037, '\P{Is_Age= NA}', "");
    Expect(1, 983037, '\P{^Is_Age= NA}', "");
    Expect(0, 983040, '\p{Is_Age= NA}', "");
    Expect(1, 983040, '\p{^Is_Age= NA}', "");
    Expect(1, 983040, '\P{Is_Age= NA}', "");
    Expect(0, 983040, '\P{^Is_Age= NA}', "");
    Error('\p{ASCII_Hex_Digit=__No/a/}');
    Error('\P{ASCII_Hex_Digit=__No/a/}');
    Expect(1, 103, '\p{ASCII_Hex_Digit=no}', "");
    Expect(0, 103, '\p{^ASCII_Hex_Digit=no}', "");
    Expect(0, 103, '\P{ASCII_Hex_Digit=no}', "");
    Expect(1, 103, '\P{^ASCII_Hex_Digit=no}', "");
    Expect(0, 102, '\p{ASCII_Hex_Digit=no}', "");
    Expect(1, 102, '\p{^ASCII_Hex_Digit=no}', "");
    Expect(1, 102, '\P{ASCII_Hex_Digit=no}', "");
    Expect(0, 102, '\P{^ASCII_Hex_Digit=no}', "");
    Expect(1, 103, '\p{ASCII_Hex_Digit= _No}', "");
    Expect(0, 103, '\p{^ASCII_Hex_Digit= _No}', "");
    Expect(0, 103, '\P{ASCII_Hex_Digit= _No}', "");
    Expect(1, 103, '\P{^ASCII_Hex_Digit= _No}', "");
    Expect(0, 102, '\p{ASCII_Hex_Digit= _No}', "");
    Expect(1, 102, '\p{^ASCII_Hex_Digit= _No}', "");
    Expect(1, 102, '\P{ASCII_Hex_Digit= _No}', "");
    Expect(0, 102, '\P{^ASCII_Hex_Digit= _No}', "");
    Error('\p{AHex:_n:=}');
    Error('\P{AHex:_n:=}');
    Expect(1, 103, '\p{AHex=n}', "");
    Expect(0, 103, '\p{^AHex=n}', "");
    Expect(0, 103, '\P{AHex=n}', "");
    Expect(1, 103, '\P{^AHex=n}', "");
    Expect(0, 102, '\p{AHex=n}', "");
    Expect(1, 102, '\p{^AHex=n}', "");
    Expect(1, 102, '\P{AHex=n}', "");
    Expect(0, 102, '\P{^AHex=n}', "");
    Expect(1, 103, '\p{AHex=  N}', "");
    Expect(0, 103, '\p{^AHex=  N}', "");
    Expect(0, 103, '\P{AHex=  N}', "");
    Expect(1, 103, '\P{^AHex=  N}', "");
    Expect(0, 102, '\p{AHex=  N}', "");
    Expect(1, 102, '\p{^AHex=  N}', "");
    Expect(1, 102, '\P{AHex=  N}', "");
    Expect(0, 102, '\P{^AHex=  N}', "");
    Error('\p{Is_ASCII_Hex_Digit= /a/F}');
    Error('\P{Is_ASCII_Hex_Digit= /a/F}');
    Expect(1, 103, '\p{Is_ASCII_Hex_Digit=f}', "");
    Expect(0, 103, '\p{^Is_ASCII_Hex_Digit=f}', "");
    Expect(0, 103, '\P{Is_ASCII_Hex_Digit=f}', "");
    Expect(1, 103, '\P{^Is_ASCII_Hex_Digit=f}', "");
    Expect(0, 102, '\p{Is_ASCII_Hex_Digit=f}', "");
    Expect(1, 102, '\p{^Is_ASCII_Hex_Digit=f}', "");
    Expect(1, 102, '\P{Is_ASCII_Hex_Digit=f}', "");
    Expect(0, 102, '\P{^Is_ASCII_Hex_Digit=f}', "");
    Expect(1, 103, '\p{Is_ASCII_Hex_Digit=_F}', "");
    Expect(0, 103, '\p{^Is_ASCII_Hex_Digit=_F}', "");
    Expect(0, 103, '\P{Is_ASCII_Hex_Digit=_F}', "");
    Expect(1, 103, '\P{^Is_ASCII_Hex_Digit=_F}', "");
    Expect(0, 102, '\p{Is_ASCII_Hex_Digit=_F}', "");
    Expect(1, 102, '\p{^Is_ASCII_Hex_Digit=_F}', "");
    Expect(1, 102, '\P{Is_ASCII_Hex_Digit=_F}', "");
    Expect(0, 102, '\P{^Is_ASCII_Hex_Digit=_F}', "");
    Error('\p{Is_AHex=/a/False}');
    Error('\P{Is_AHex=/a/False}');
    Expect(1, 103, '\p{Is_AHex=false}', "");
    Expect(0, 103, '\p{^Is_AHex=false}', "");
    Expect(0, 103, '\P{Is_AHex=false}', "");
    Expect(1, 103, '\P{^Is_AHex=false}', "");
    Expect(0, 102, '\p{Is_AHex=false}', "");
    Expect(1, 102, '\p{^Is_AHex=false}', "");
    Expect(1, 102, '\P{Is_AHex=false}', "");
    Expect(0, 102, '\P{^Is_AHex=false}', "");
    Expect(1, 103, '\p{Is_AHex=-False}', "");
    Expect(0, 103, '\p{^Is_AHex=-False}', "");
    Expect(0, 103, '\P{Is_AHex=-False}', "");
    Expect(1, 103, '\P{^Is_AHex=-False}', "");
    Expect(0, 102, '\p{Is_AHex=-False}', "");
    Expect(1, 102, '\p{^Is_AHex=-False}', "");
    Expect(1, 102, '\P{Is_AHex=-False}', "");
    Expect(0, 102, '\P{^Is_AHex=-False}', "");
    Error('\p{ASCII_Hex_Digit=	_yes:=}');
    Error('\P{ASCII_Hex_Digit=	_yes:=}');
    Expect(1, 102, '\p{ASCII_Hex_Digit:yes}', "");
    Expect(0, 102, '\p{^ASCII_Hex_Digit:yes}', "");
    Expect(0, 102, '\P{ASCII_Hex_Digit:yes}', "");
    Expect(1, 102, '\P{^ASCII_Hex_Digit:yes}', "");
    Expect(0, 103, '\p{ASCII_Hex_Digit:yes}', "");
    Expect(1, 103, '\p{^ASCII_Hex_Digit:yes}', "");
    Expect(1, 103, '\P{ASCII_Hex_Digit:yes}', "");
    Expect(0, 103, '\P{^ASCII_Hex_Digit:yes}', "");
    Expect(1, 102, '\p{ASCII_Hex_Digit=--YES}', "");
    Expect(0, 102, '\p{^ASCII_Hex_Digit=--YES}', "");
    Expect(0, 102, '\P{ASCII_Hex_Digit=--YES}', "");
    Expect(1, 102, '\P{^ASCII_Hex_Digit=--YES}', "");
    Expect(0, 103, '\p{ASCII_Hex_Digit=--YES}', "");
    Expect(1, 103, '\p{^ASCII_Hex_Digit=--YES}', "");
    Expect(1, 103, '\P{ASCII_Hex_Digit=--YES}', "");
    Expect(0, 103, '\P{^ASCII_Hex_Digit=--YES}', "");
    Error('\p{AHex=:=_	y}');
    Error('\P{AHex=:=_	y}');
    Expect(1, 102, '\p{AHex=y}', "");
    Expect(0, 102, '\p{^AHex=y}', "");
    Expect(0, 102, '\P{AHex=y}', "");
    Expect(1, 102, '\P{^AHex=y}', "");
    Expect(0, 103, '\p{AHex=y}', "");
    Expect(1, 103, '\p{^AHex=y}', "");
    Expect(1, 103, '\P{AHex=y}', "");
    Expect(0, 103, '\P{^AHex=y}', "");
    Expect(1, 102, '\p{AHex=-Y}', "");
    Expect(0, 102, '\p{^AHex=-Y}', "");
    Expect(0, 102, '\P{AHex=-Y}', "");
    Expect(1, 102, '\P{^AHex=-Y}', "");
    Expect(0, 103, '\p{AHex=-Y}', "");
    Expect(1, 103, '\p{^AHex=-Y}', "");
    Expect(1, 103, '\P{AHex=-Y}', "");
    Expect(0, 103, '\P{^AHex=-Y}', "");
    Error('\p{Is_ASCII_Hex_Digit=/a/--T}');
    Error('\P{Is_ASCII_Hex_Digit=/a/--T}');
    Expect(1, 102, '\p{Is_ASCII_Hex_Digit=t}', "");
    Expect(0, 102, '\p{^Is_ASCII_Hex_Digit=t}', "");
    Expect(0, 102, '\P{Is_ASCII_Hex_Digit=t}', "");
    Expect(1, 102, '\P{^Is_ASCII_Hex_Digit=t}', "");
    Expect(0, 103, '\p{Is_ASCII_Hex_Digit=t}', "");
    Expect(1, 103, '\p{^Is_ASCII_Hex_Digit=t}', "");
    Expect(1, 103, '\P{Is_ASCII_Hex_Digit=t}', "");
    Expect(0, 103, '\P{^Is_ASCII_Hex_Digit=t}', "");
    Expect(1, 102, '\p{Is_ASCII_Hex_Digit=	 T}', "");
    Expect(0, 102, '\p{^Is_ASCII_Hex_Digit=	 T}', "");
    Expect(0, 102, '\P{Is_ASCII_Hex_Digit=	 T}', "");
    Expect(1, 102, '\P{^Is_ASCII_Hex_Digit=	 T}', "");
    Expect(0, 103, '\p{Is_ASCII_Hex_Digit=	 T}', "");
    Expect(1, 103, '\p{^Is_ASCII_Hex_Digit=	 T}', "");
    Expect(1, 103, '\P{Is_ASCII_Hex_Digit=	 T}', "");
    Expect(0, 103, '\P{^Is_ASCII_Hex_Digit=	 T}', "");
    Error('\p{Is_AHex=/a/		True}');
    Error('\P{Is_AHex=/a/		True}');
    Expect(1, 102, '\p{Is_AHex:true}', "");
    Expect(0, 102, '\p{^Is_AHex:true}', "");
    Expect(0, 102, '\P{Is_AHex:true}', "");
    Expect(1, 102, '\P{^Is_AHex:true}', "");
    Expect(0, 103, '\p{Is_AHex:true}', "");
    Expect(1, 103, '\p{^Is_AHex:true}', "");
    Expect(1, 103, '\P{Is_AHex:true}', "");
    Expect(0, 103, '\P{^Is_AHex:true}', "");
    Expect(1, 102, '\p{Is_AHex= TRUE}', "");
    Expect(0, 102, '\p{^Is_AHex= TRUE}', "");
    Expect(0, 102, '\P{Is_AHex= TRUE}', "");
    Expect(1, 102, '\P{^Is_AHex= TRUE}', "");
    Expect(0, 103, '\p{Is_AHex= TRUE}', "");
    Expect(1, 103, '\p{^Is_AHex= TRUE}', "");
    Expect(1, 103, '\P{Is_AHex= TRUE}', "");
    Expect(0, 103, '\P{^Is_AHex= TRUE}', "");
    Error('\p{Alphabetic=- no/a/}');
    Error('\P{Alphabetic=- no/a/}');
    Expect(1, 195102, '\p{Alphabetic:no}', "");
    Expect(0, 195102, '\p{^Alphabetic:no}', "");
    Expect(0, 195102, '\P{Alphabetic:no}', "");
    Expect(1, 195102, '\P{^Alphabetic:no}', "");
    Expect(0, 195101, '\p{Alphabetic:no}', "");
    Expect(1, 195101, '\p{^Alphabetic:no}', "");
    Expect(1, 195101, '\P{Alphabetic:no}', "");
    Expect(0, 195101, '\P{^Alphabetic:no}', "");
    Expect(1, 195102, '\p{Alphabetic=-	No}', "");
    Expect(0, 195102, '\p{^Alphabetic=-	No}', "");
    Expect(0, 195102, '\P{Alphabetic=-	No}', "");
    Expect(1, 195102, '\P{^Alphabetic=-	No}', "");
    Expect(0, 195101, '\p{Alphabetic=-	No}', "");
    Expect(1, 195101, '\p{^Alphabetic=-	No}', "");
    Expect(1, 195101, '\P{Alphabetic=-	No}', "");
    Expect(0, 195101, '\P{^Alphabetic=-	No}', "");
    Error('\p{Alpha=_ N:=}');
    Error('\P{Alpha=_ N:=}');
    Expect(1, 195102, '\p{Alpha=n}', "");
    Expect(0, 195102, '\p{^Alpha=n}', "");
    Expect(0, 195102, '\P{Alpha=n}', "");
    Expect(1, 195102, '\P{^Alpha=n}', "");
    Expect(0, 195101, '\p{Alpha=n}', "");
    Expect(1, 195101, '\p{^Alpha=n}', "");
    Expect(1, 195101, '\P{Alpha=n}', "");
    Expect(0, 195101, '\P{^Alpha=n}', "");
    Expect(1, 195102, '\p{Alpha=__n}', "");
    Expect(0, 195102, '\p{^Alpha=__n}', "");
    Expect(0, 195102, '\P{Alpha=__n}', "");
    Expect(1, 195102, '\P{^Alpha=__n}', "");
    Expect(0, 195101, '\p{Alpha=__n}', "");
    Expect(1, 195101, '\p{^Alpha=__n}', "");
    Expect(1, 195101, '\P{Alpha=__n}', "");
    Expect(0, 195101, '\P{^Alpha=__n}', "");
    Error('\p{Is_Alphabetic:		_F/a/}');
    Error('\P{Is_Alphabetic:		_F/a/}');
    Expect(1, 195102, '\p{Is_Alphabetic=f}', "");
    Expect(0, 195102, '\p{^Is_Alphabetic=f}', "");
    Expect(0, 195102, '\P{Is_Alphabetic=f}', "");
    Expect(1, 195102, '\P{^Is_Alphabetic=f}', "");
    Expect(0, 195101, '\p{Is_Alphabetic=f}', "");
    Expect(1, 195101, '\p{^Is_Alphabetic=f}', "");
    Expect(1, 195101, '\P{Is_Alphabetic=f}', "");
    Expect(0, 195101, '\P{^Is_Alphabetic=f}', "");
    Expect(1, 195102, '\p{Is_Alphabetic=-_F}', "");
    Expect(0, 195102, '\p{^Is_Alphabetic=-_F}', "");
    Expect(0, 195102, '\P{Is_Alphabetic=-_F}', "");
    Expect(1, 195102, '\P{^Is_Alphabetic=-_F}', "");
    Expect(0, 195101, '\p{Is_Alphabetic=-_F}', "");
    Expect(1, 195101, '\p{^Is_Alphabetic=-_F}', "");
    Expect(1, 195101, '\P{Is_Alphabetic=-_F}', "");
    Expect(0, 195101, '\P{^Is_Alphabetic=-_F}', "");
    Error('\p{Is_Alpha=-	false:=}');
    Error('\P{Is_Alpha=-	false:=}');
    Expect(1, 195102, '\p{Is_Alpha=false}', "");
    Expect(0, 195102, '\p{^Is_Alpha=false}', "");
    Expect(0, 195102, '\P{Is_Alpha=false}', "");
    Expect(1, 195102, '\P{^Is_Alpha=false}', "");
    Expect(0, 195101, '\p{Is_Alpha=false}', "");
    Expect(1, 195101, '\p{^Is_Alpha=false}', "");
    Expect(1, 195101, '\P{Is_Alpha=false}', "");
    Expect(0, 195101, '\P{^Is_Alpha=false}', "");
    Expect(1, 195102, '\p{Is_Alpha=-	False}', "");
    Expect(0, 195102, '\p{^Is_Alpha=-	False}', "");
    Expect(0, 195102, '\P{Is_Alpha=-	False}', "");
    Expect(1, 195102, '\P{^Is_Alpha=-	False}', "");
    Expect(0, 195101, '\p{Is_Alpha=-	False}', "");
    Expect(1, 195101, '\p{^Is_Alpha=-	False}', "");
    Expect(1, 195101, '\P{Is_Alpha=-	False}', "");
    Expect(0, 195101, '\P{^Is_Alpha=-	False}', "");
    Error('\p{Alphabetic=-yes/a/}');
    Error('\P{Alphabetic=-yes/a/}');
    Expect(1, 195101, '\p{Alphabetic:	yes}', "");
    Expect(0, 195101, '\p{^Alphabetic:	yes}', "");
    Expect(0, 195101, '\P{Alphabetic:	yes}', "");
    Expect(1, 195101, '\P{^Alphabetic:	yes}', "");
    Expect(0, 195102, '\p{Alphabetic:	yes}', "");
    Expect(1, 195102, '\p{^Alphabetic:	yes}', "");
    Expect(1, 195102, '\P{Alphabetic:	yes}', "");
    Expect(0, 195102, '\P{^Alphabetic:	yes}', "");
    Expect(1, 195101, '\p{Alphabetic= -yes}', "");
    Expect(0, 195101, '\p{^Alphabetic= -yes}', "");
    Expect(0, 195101, '\P{Alphabetic= -yes}', "");
    Expect(1, 195101, '\P{^Alphabetic= -yes}', "");
    Expect(0, 195102, '\p{Alphabetic= -yes}', "");
    Expect(1, 195102, '\p{^Alphabetic= -yes}', "");
    Expect(1, 195102, '\P{Alphabetic= -yes}', "");
    Expect(0, 195102, '\P{^Alphabetic= -yes}', "");
    Error('\p{Alpha=/a/y}');
    Error('\P{Alpha=/a/y}');
    Expect(1, 195101, '\p{Alpha=y}', "");
    Expect(0, 195101, '\p{^Alpha=y}', "");
    Expect(0, 195101, '\P{Alpha=y}', "");
    Expect(1, 195101, '\P{^Alpha=y}', "");
    Expect(0, 195102, '\p{Alpha=y}', "");
    Expect(1, 195102, '\p{^Alpha=y}', "");
    Expect(1, 195102, '\P{Alpha=y}', "");
    Expect(0, 195102, '\P{^Alpha=y}', "");
    Expect(1, 195101, '\p{Alpha=-y}', "");
    Expect(0, 195101, '\p{^Alpha=-y}', "");
    Expect(0, 195101, '\P{Alpha=-y}', "");
    Expect(1, 195101, '\P{^Alpha=-y}', "");
    Expect(0, 195102, '\p{Alpha=-y}', "");
    Expect(1, 195102, '\p{^Alpha=-y}', "");
    Expect(1, 195102, '\P{Alpha=-y}', "");
    Expect(0, 195102, '\P{^Alpha=-y}', "");
    Error('\p{Is_Alphabetic:   _T:=}');
    Error('\P{Is_Alphabetic:   _T:=}');
    Expect(1, 195101, '\p{Is_Alphabetic:   t}', "");
    Expect(0, 195101, '\p{^Is_Alphabetic:   t}', "");
    Expect(0, 195101, '\P{Is_Alphabetic:   t}', "");
    Expect(1, 195101, '\P{^Is_Alphabetic:   t}', "");
    Expect(0, 195102, '\p{Is_Alphabetic:   t}', "");
    Expect(1, 195102, '\p{^Is_Alphabetic:   t}', "");
    Expect(1, 195102, '\P{Is_Alphabetic:   t}', "");
    Expect(0, 195102, '\P{^Is_Alphabetic:   t}', "");
    Expect(1, 195101, '\p{Is_Alphabetic=		T}', "");
    Expect(0, 195101, '\p{^Is_Alphabetic=		T}', "");
    Expect(0, 195101, '\P{Is_Alphabetic=		T}', "");
    Expect(1, 195101, '\P{^Is_Alphabetic=		T}', "");
    Expect(0, 195102, '\p{Is_Alphabetic=		T}', "");
    Expect(1, 195102, '\p{^Is_Alphabetic=		T}', "");
    Expect(1, 195102, '\P{Is_Alphabetic=		T}', "");
    Expect(0, 195102, '\P{^Is_Alphabetic=		T}', "");
    Error('\p{Is_Alpha=	True:=}');
    Error('\P{Is_Alpha=	True:=}');
    Expect(1, 195101, '\p{Is_Alpha=true}', "");
    Expect(0, 195101, '\p{^Is_Alpha=true}', "");
    Expect(0, 195101, '\P{Is_Alpha=true}', "");
    Expect(1, 195101, '\P{^Is_Alpha=true}', "");
    Expect(0, 195102, '\p{Is_Alpha=true}', "");
    Expect(1, 195102, '\p{^Is_Alpha=true}', "");
    Expect(1, 195102, '\P{Is_Alpha=true}', "");
    Expect(0, 195102, '\P{^Is_Alpha=true}', "");
    Expect(1, 195101, '\p{Is_Alpha= 	true}', "");
    Expect(0, 195101, '\p{^Is_Alpha= 	true}', "");
    Expect(0, 195101, '\P{Is_Alpha= 	true}', "");
    Expect(1, 195101, '\P{^Is_Alpha= 	true}', "");
    Expect(0, 195102, '\p{Is_Alpha= 	true}', "");
    Expect(1, 195102, '\p{^Is_Alpha= 	true}', "");
    Expect(1, 195102, '\P{Is_Alpha= 	true}', "");
    Expect(0, 195102, '\P{^Is_Alpha= 	true}', "");
    Error('\p{bidiclass}');
    Error('\P{bidiclass}');
    Error('\p{bc}');
    Error('\P{bc}');
    Error('\p{Bidi_Class=__Arabic_Letter:=}');
    Error('\P{Bidi_Class=__Arabic_Letter:=}');
    Expect(1, 126719, '\p{Bidi_Class=arabicletter}', "");
    Expect(0, 126719, '\p{^Bidi_Class=arabicletter}', "");
    Expect(0, 126719, '\P{Bidi_Class=arabicletter}', "");
    Expect(1, 126719, '\P{^Bidi_Class=arabicletter}', "");
    Expect(0, 126720, '\p{Bidi_Class=arabicletter}', "");
    Expect(1, 126720, '\p{^Bidi_Class=arabicletter}', "");
    Expect(1, 126720, '\P{Bidi_Class=arabicletter}', "");
    Expect(0, 126720, '\P{^Bidi_Class=arabicletter}', "");
    Expect(1, 126719, '\p{Bidi_Class=	Arabic_letter}', "");
    Expect(0, 126719, '\p{^Bidi_Class=	Arabic_letter}', "");
    Expect(0, 126719, '\P{Bidi_Class=	Arabic_letter}', "");
    Expect(1, 126719, '\P{^Bidi_Class=	Arabic_letter}', "");
    Expect(0, 126720, '\p{Bidi_Class=	Arabic_letter}', "");
    Expect(1, 126720, '\p{^Bidi_Class=	Arabic_letter}', "");
    Expect(1, 126720, '\P{Bidi_Class=	Arabic_letter}', "");
    Expect(0, 126720, '\P{^Bidi_Class=	Arabic_letter}', "");
    Error('\p{Bc=	AL/a/}');
    Error('\P{Bc=	AL/a/}');
    Expect(1, 126719, '\p{Bc:   al}', "");
    Expect(0, 126719, '\p{^Bc:   al}', "");
    Expect(0, 126719, '\P{Bc:   al}', "");
    Expect(1, 126719, '\P{^Bc:   al}', "");
    Expect(0, 126720, '\p{Bc:   al}', "");
    Expect(1, 126720, '\p{^Bc:   al}', "");
    Expect(1, 126720, '\P{Bc:   al}', "");
    Expect(0, 126720, '\P{^Bc:   al}', "");
    Expect(1, 126719, '\p{Bc=_ AL}', "");
    Expect(0, 126719, '\p{^Bc=_ AL}', "");
    Expect(0, 126719, '\P{Bc=_ AL}', "");
    Expect(1, 126719, '\P{^Bc=_ AL}', "");
    Expect(0, 126720, '\p{Bc=_ AL}', "");
    Expect(1, 126720, '\p{^Bc=_ AL}', "");
    Expect(1, 126720, '\P{Bc=_ AL}', "");
    Expect(0, 126720, '\P{^Bc=_ AL}', "");
    Error('\p{Is_Bidi_Class=		Arabic_letter/a/}');
    Error('\P{Is_Bidi_Class=		Arabic_letter/a/}');
    Expect(1, 126719, '\p{Is_Bidi_Class=arabicletter}', "");
    Expect(0, 126719, '\p{^Is_Bidi_Class=arabicletter}', "");
    Expect(0, 126719, '\P{Is_Bidi_Class=arabicletter}', "");
    Expect(1, 126719, '\P{^Is_Bidi_Class=arabicletter}', "");
    Expect(0, 126720, '\p{Is_Bidi_Class=arabicletter}', "");
    Expect(1, 126720, '\p{^Is_Bidi_Class=arabicletter}', "");
    Expect(1, 126720, '\P{Is_Bidi_Class=arabicletter}', "");
    Expect(0, 126720, '\P{^Is_Bidi_Class=arabicletter}', "");
    Expect(1, 126719, '\p{Is_Bidi_Class=		arabic_Letter}', "");
    Expect(0, 126719, '\p{^Is_Bidi_Class=		arabic_Letter}', "");
    Expect(0, 126719, '\P{Is_Bidi_Class=		arabic_Letter}', "");
    Expect(1, 126719, '\P{^Is_Bidi_Class=		arabic_Letter}', "");
    Expect(0, 126720, '\p{Is_Bidi_Class=		arabic_Letter}', "");
    Expect(1, 126720, '\p{^Is_Bidi_Class=		arabic_Letter}', "");
    Expect(1, 126720, '\P{Is_Bidi_Class=		arabic_Letter}', "");
    Expect(0, 126720, '\P{^Is_Bidi_Class=		arabic_Letter}', "");
    Error('\p{Is_Bc=-al/a/}');
    Error('\P{Is_Bc=-al/a/}');
    Expect(1, 126719, '\p{Is_Bc=al}', "");
    Expect(0, 126719, '\p{^Is_Bc=al}', "");
    Expect(0, 126719, '\P{Is_Bc=al}', "");
    Expect(1, 126719, '\P{^Is_Bc=al}', "");
    Expect(0, 126720, '\p{Is_Bc=al}', "");
    Expect(1, 126720, '\p{^Is_Bc=al}', "");
    Expect(1, 126720, '\P{Is_Bc=al}', "");
    Expect(0, 126720, '\P{^Is_Bc=al}', "");
    Expect(1, 126719, '\p{Is_Bc=		al}', "");
    Expect(0, 126719, '\p{^Is_Bc=		al}', "");
    Expect(0, 126719, '\P{Is_Bc=		al}', "");
    Expect(1, 126719, '\P{^Is_Bc=		al}', "");
    Expect(0, 126720, '\p{Is_Bc=		al}', "");
    Expect(1, 126720, '\p{^Is_Bc=		al}', "");
    Expect(1, 126720, '\P{Is_Bc=		al}', "");
    Expect(0, 126720, '\P{^Is_Bc=		al}', "");
    Error('\p{Bidi_Class= ARABIC_Number:=}');
    Error('\P{Bidi_Class= ARABIC_Number:=}');
    Expect(1, 69246, '\p{Bidi_Class=arabicnumber}', "");
    Expect(0, 69246, '\p{^Bidi_Class=arabicnumber}', "");
    Expect(0, 69246, '\P{Bidi_Class=arabicnumber}', "");
    Expect(1, 69246, '\P{^Bidi_Class=arabicnumber}', "");
    Expect(0, 69247, '\p{Bidi_Class=arabicnumber}', "");
    Expect(1, 69247, '\p{^Bidi_Class=arabicnumber}', "");
    Expect(1, 69247, '\P{Bidi_Class=arabicnumber}', "");
    Expect(0, 69247, '\P{^Bidi_Class=arabicnumber}', "");
    Expect(1, 69246, '\p{Bidi_Class=	-arabic_NUMBER}', "");
    Expect(0, 69246, '\p{^Bidi_Class=	-arabic_NUMBER}', "");
    Expect(0, 69246, '\P{Bidi_Class=	-arabic_NUMBER}', "");
    Expect(1, 69246, '\P{^Bidi_Class=	-arabic_NUMBER}', "");
    Expect(0, 69247, '\p{Bidi_Class=	-arabic_NUMBER}', "");
    Expect(1, 69247, '\p{^Bidi_Class=	-arabic_NUMBER}', "");
    Expect(1, 69247, '\P{Bidi_Class=	-arabic_NUMBER}', "");
    Expect(0, 69247, '\P{^Bidi_Class=	-arabic_NUMBER}', "");
    Error('\p{Bc=	_an:=}');
    Error('\P{Bc=	_an:=}');
    Expect(1, 69246, '\p{Bc=an}', "");
    Expect(0, 69246, '\p{^Bc=an}', "");
    Expect(0, 69246, '\P{Bc=an}', "");
    Expect(1, 69246, '\P{^Bc=an}', "");
    Expect(0, 69247, '\p{Bc=an}', "");
    Expect(1, 69247, '\p{^Bc=an}', "");
    Expect(1, 69247, '\P{Bc=an}', "");
    Expect(0, 69247, '\P{^Bc=an}', "");
    Expect(1, 69246, '\p{Bc=_-AN}', "");
    Expect(0, 69246, '\p{^Bc=_-AN}', "");
    Expect(0, 69246, '\P{Bc=_-AN}', "");
    Expect(1, 69246, '\P{^Bc=_-AN}', "");
    Expect(0, 69247, '\p{Bc=_-AN}', "");
    Expect(1, 69247, '\p{^Bc=_-AN}', "");
    Expect(1, 69247, '\P{Bc=_-AN}', "");
    Expect(0, 69247, '\P{^Bc=_-AN}', "");
    Error('\p{Is_Bidi_Class:_ARABIC_Number:=}');
    Error('\P{Is_Bidi_Class:_ARABIC_Number:=}');
    Expect(1, 69246, '\p{Is_Bidi_Class=arabicnumber}', "");
    Expect(0, 69246, '\p{^Is_Bidi_Class=arabicnumber}', "");
    Expect(0, 69246, '\P{Is_Bidi_Class=arabicnumber}', "");
    Expect(1, 69246, '\P{^Is_Bidi_Class=arabicnumber}', "");
    Expect(0, 69247, '\p{Is_Bidi_Class=arabicnumber}', "");
    Expect(1, 69247, '\p{^Is_Bidi_Class=arabicnumber}', "");
    Expect(1, 69247, '\P{Is_Bidi_Class=arabicnumber}', "");
    Expect(0, 69247, '\P{^Is_Bidi_Class=arabicnumber}', "");
    Expect(1, 69246, '\p{Is_Bidi_Class=_Arabic_Number}', "");
    Expect(0, 69246, '\p{^Is_Bidi_Class=_Arabic_Number}', "");
    Expect(0, 69246, '\P{Is_Bidi_Class=_Arabic_Number}', "");
    Expect(1, 69246, '\P{^Is_Bidi_Class=_Arabic_Number}', "");
    Expect(0, 69247, '\p{Is_Bidi_Class=_Arabic_Number}', "");
    Expect(1, 69247, '\p{^Is_Bidi_Class=_Arabic_Number}', "");
    Expect(1, 69247, '\P{Is_Bidi_Class=_Arabic_Number}', "");
    Expect(0, 69247, '\P{^Is_Bidi_Class=_Arabic_Number}', "");
    Error('\p{Is_Bc= AN:=}');
    Error('\P{Is_Bc= AN:=}');
    Expect(1, 69246, '\p{Is_Bc=an}', "");
    Expect(0, 69246, '\p{^Is_Bc=an}', "");
    Expect(0, 69246, '\P{Is_Bc=an}', "");
    Expect(1, 69246, '\P{^Is_Bc=an}', "");
    Expect(0, 69247, '\p{Is_Bc=an}', "");
    Expect(1, 69247, '\p{^Is_Bc=an}', "");
    Expect(1, 69247, '\P{Is_Bc=an}', "");
    Expect(0, 69247, '\P{^Is_Bc=an}', "");
    Expect(1, 69246, '\p{Is_Bc=__AN}', "");
    Expect(0, 69246, '\p{^Is_Bc=__AN}', "");
    Expect(0, 69246, '\P{Is_Bc=__AN}', "");
    Expect(1, 69246, '\P{^Is_Bc=__AN}', "");
    Expect(0, 69247, '\p{Is_Bc=__AN}', "");
    Expect(1, 69247, '\p{^Is_Bc=__AN}', "");
    Expect(1, 69247, '\P{Is_Bc=__AN}', "");
    Expect(0, 69247, '\P{^Is_Bc=__AN}', "");
    Error('\p{Bidi_Class=:=--paragraph_SEPARATOR}');
    Error('\P{Bidi_Class=:=--paragraph_SEPARATOR}');
    Expect(1, 8233, '\p{Bidi_Class=paragraphseparator}', "");
    Expect(0, 8233, '\p{^Bidi_Class=paragraphseparator}', "");
    Expect(0, 8233, '\P{Bidi_Class=paragraphseparator}', "");
    Expect(1, 8233, '\P{^Bidi_Class=paragraphseparator}', "");
    Expect(0, 8234, '\p{Bidi_Class=paragraphseparator}', "");
    Expect(1, 8234, '\p{^Bidi_Class=paragraphseparator}', "");
    Expect(1, 8234, '\P{Bidi_Class=paragraphseparator}', "");
    Expect(0, 8234, '\P{^Bidi_Class=paragraphseparator}', "");
    Expect(1, 8233, '\p{Bidi_Class=-_Paragraph_separator}', "");
    Expect(0, 8233, '\p{^Bidi_Class=-_Paragraph_separator}', "");
    Expect(0, 8233, '\P{Bidi_Class=-_Paragraph_separator}', "");
    Expect(1, 8233, '\P{^Bidi_Class=-_Paragraph_separator}', "");
    Expect(0, 8234, '\p{Bidi_Class=-_Paragraph_separator}', "");
    Expect(1, 8234, '\p{^Bidi_Class=-_Paragraph_separator}', "");
    Expect(1, 8234, '\P{Bidi_Class=-_Paragraph_separator}', "");
    Expect(0, 8234, '\P{^Bidi_Class=-_Paragraph_separator}', "");
    Error('\p{Bc=	:=B}');
    Error('\P{Bc=	:=B}');
    Expect(1, 8233, '\p{Bc=b}', "");
    Expect(0, 8233, '\p{^Bc=b}', "");
    Expect(0, 8233, '\P{Bc=b}', "");
    Expect(1, 8233, '\P{^Bc=b}', "");
    Expect(0, 8234, '\p{Bc=b}', "");
    Expect(1, 8234, '\p{^Bc=b}', "");
    Expect(1, 8234, '\P{Bc=b}', "");
    Expect(0, 8234, '\P{^Bc=b}', "");
    Expect(1, 8233, '\p{Bc: 		b}', "");
    Expect(0, 8233, '\p{^Bc: 		b}', "");
    Expect(0, 8233, '\P{Bc: 		b}', "");
    Expect(1, 8233, '\P{^Bc: 		b}', "");
    Expect(0, 8234, '\p{Bc: 		b}', "");
    Expect(1, 8234, '\p{^Bc: 		b}', "");
    Expect(1, 8234, '\P{Bc: 		b}', "");
    Expect(0, 8234, '\P{^Bc: 		b}', "");
    Error('\p{Is_Bidi_Class= PARAGRAPH_Separator/a/}');
    Error('\P{Is_Bidi_Class= PARAGRAPH_Separator/a/}');
    Expect(1, 8233, '\p{Is_Bidi_Class=paragraphseparator}', "");
    Expect(0, 8233, '\p{^Is_Bidi_Class=paragraphseparator}', "");
    Expect(0, 8233, '\P{Is_Bidi_Class=paragraphseparator}', "");
    Expect(1, 8233, '\P{^Is_Bidi_Class=paragraphseparator}', "");
    Expect(0, 8234, '\p{Is_Bidi_Class=paragraphseparator}', "");
    Expect(1, 8234, '\p{^Is_Bidi_Class=paragraphseparator}', "");
    Expect(1, 8234, '\P{Is_Bidi_Class=paragraphseparator}', "");
    Expect(0, 8234, '\P{^Is_Bidi_Class=paragraphseparator}', "");
    Expect(1, 8233, '\p{Is_Bidi_Class=	_paragraph_SEPARATOR}', "");
    Expect(0, 8233, '\p{^Is_Bidi_Class=	_paragraph_SEPARATOR}', "");
    Expect(0, 8233, '\P{Is_Bidi_Class=	_paragraph_SEPARATOR}', "");
    Expect(1, 8233, '\P{^Is_Bidi_Class=	_paragraph_SEPARATOR}', "");
    Expect(0, 8234, '\p{Is_Bidi_Class=	_paragraph_SEPARATOR}', "");
    Expect(1, 8234, '\p{^Is_Bidi_Class=	_paragraph_SEPARATOR}', "");
    Expect(1, 8234, '\P{Is_Bidi_Class=	_paragraph_SEPARATOR}', "");
    Expect(0, 8234, '\P{^Is_Bidi_Class=	_paragraph_SEPARATOR}', "");
    Error('\p{Is_Bc=:=	 b}');
    Error('\P{Is_Bc=:=	 b}');
    Expect(1, 8233, '\p{Is_Bc=b}', "");
    Expect(0, 8233, '\p{^Is_Bc=b}', "");
    Expect(0, 8233, '\P{Is_Bc=b}', "");
    Expect(1, 8233, '\P{^Is_Bc=b}', "");
    Expect(0, 8234, '\p{Is_Bc=b}', "");
    Expect(1, 8234, '\p{^Is_Bc=b}', "");
    Expect(1, 8234, '\P{Is_Bc=b}', "");
    Expect(0, 8234, '\P{^Is_Bc=b}', "");
    Expect(1, 8233, '\p{Is_Bc= B}', "");
    Expect(0, 8233, '\p{^Is_Bc= B}', "");
    Expect(0, 8233, '\P{Is_Bc= B}', "");
    Expect(1, 8233, '\P{^Is_Bc= B}', "");
    Expect(0, 8234, '\p{Is_Bc= B}', "");
    Expect(1, 8234, '\p{^Is_Bc= B}', "");
    Expect(1, 8234, '\P{Is_Bc= B}', "");
    Expect(0, 8234, '\P{^Is_Bc= B}', "");
    Error('\p{Bidi_Class=:=-Boundary_Neutral}');
    Error('\P{Bidi_Class=:=-Boundary_Neutral}');
    Expect(1, 921599, '\p{Bidi_Class=boundaryneutral}', "");
    Expect(0, 921599, '\p{^Bidi_Class=boundaryneutral}', "");
    Expect(0, 921599, '\P{Bidi_Class=boundaryneutral}', "");
    Expect(1, 921599, '\P{^Bidi_Class=boundaryneutral}', "");
    Expect(0, 1114109, '\p{Bidi_Class=boundaryneutral}', "");
    Expect(1, 1114109, '\p{^Bidi_Class=boundaryneutral}', "");
    Expect(1, 1114109, '\P{Bidi_Class=boundaryneutral}', "");
    Expect(0, 1114109, '\P{^Bidi_Class=boundaryneutral}', "");
    Expect(1, 921599, '\p{Bidi_Class= 	boundary_neutral}', "");
    Expect(0, 921599, '\p{^Bidi_Class= 	boundary_neutral}', "");
    Expect(0, 921599, '\P{Bidi_Class= 	boundary_neutral}', "");
    Expect(1, 921599, '\P{^Bidi_Class= 	boundary_neutral}', "");
    Expect(0, 1114109, '\p{Bidi_Class= 	boundary_neutral}', "");
    Expect(1, 1114109, '\p{^Bidi_Class= 	boundary_neutral}', "");
    Expect(1, 1114109, '\P{Bidi_Class= 	boundary_neutral}', "");
    Expect(0, 1114109, '\P{^Bidi_Class= 	boundary_neutral}', "");
    Error('\p{Bc=_ BN/a/}');
    Error('\P{Bc=_ BN/a/}');
    Expect(1, 921599, '\p{Bc=bn}', "");
    Expect(0, 921599, '\p{^Bc=bn}', "");
    Expect(0, 921599, '\P{Bc=bn}', "");
    Expect(1, 921599, '\P{^Bc=bn}', "");
    Expect(0, 1114109, '\p{Bc=bn}', "");
    Expect(1, 1114109, '\p{^Bc=bn}', "");
    Expect(1, 1114109, '\P{Bc=bn}', "");
    Expect(0, 1114109, '\P{^Bc=bn}', "");
    Error('\p{Is_Bidi_Class=	:=BOUNDARY_neutral}');
    Error('\P{Is_Bidi_Class=	:=BOUNDARY_neutral}');
    Expect(1, 921599, '\p{Is_Bidi_Class=boundaryneutral}', "");
    Expect(0, 921599, '\p{^Is_Bidi_Class=boundaryneutral}', "");
    Expect(0, 921599, '\P{Is_Bidi_Class=boundaryneutral}', "");
    Expect(1, 921599, '\P{^Is_Bidi_Class=boundaryneutral}', "");
    Expect(0, 1114109, '\p{Is_Bidi_Class=boundaryneutral}', "");
    Expect(1, 1114109, '\p{^Is_Bidi_Class=boundaryneutral}', "");
    Expect(1, 1114109, '\P{Is_Bidi_Class=boundaryneutral}', "");
    Expect(0, 1114109, '\P{^Is_Bidi_Class=boundaryneutral}', "");
    Expect(1, 921599, '\p{Is_Bidi_Class=- Boundary_Neutral}', "");
    Expect(0, 921599, '\p{^Is_Bidi_Class=- Boundary_Neutral}', "");
    Expect(0, 921599, '\P{Is_Bidi_Class=- Boundary_Neutral}', "");
    Expect(1, 921599, '\P{^Is_Bidi_Class=- Boundary_Neutral}', "");
    Expect(0, 1114109, '\p{Is_Bidi_Class=- Boundary_Neutral}', "");
    Expect(1, 1114109, '\p{^Is_Bidi_Class=- Boundary_Neutral}', "");
    Expect(1, 1114109, '\P{Is_Bidi_Class=- Boundary_Neutral}', "");
    Expect(0, 1114109, '\P{^Is_Bidi_Class=- Boundary_Neutral}', "");
    Error('\p{Is_Bc:   	/a/bn}');
    Error('\P{Is_Bc:   	/a/bn}');
    Expect(1, 921599, '\p{Is_Bc:   bn}', "");
    Expect(0, 921599, '\p{^Is_Bc:   bn}', "");
    Expect(0, 921599, '\P{Is_Bc:   bn}', "");
    Expect(1, 921599, '\P{^Is_Bc:   bn}', "");
    Expect(0, 1114109, '\p{Is_Bc:   bn}', "");
    Expect(1, 1114109, '\p{^Is_Bc:   bn}', "");
    Expect(1, 1114109, '\P{Is_Bc:   bn}', "");
    Expect(0, 1114109, '\P{^Is_Bc:   bn}', "");
    Expect(1, 921599, '\p{Is_Bc:    	BN}', "");
    Expect(0, 921599, '\p{^Is_Bc:    	BN}', "");
    Expect(0, 921599, '\P{Is_Bc:    	BN}', "");
    Expect(1, 921599, '\P{^Is_Bc:    	BN}', "");
    Expect(0, 1114109, '\p{Is_Bc:    	BN}', "");
    Expect(1, 1114109, '\p{^Is_Bc:    	BN}', "");
    Expect(1, 1114109, '\P{Is_Bc:    	BN}', "");
    Expect(0, 1114109, '\P{^Is_Bc:    	BN}', "");
    Error('\p{Bidi_Class= _Common_Separator:=}');
    Error('\P{Bidi_Class= _Common_Separator:=}');
    Expect(1, 65306, '\p{Bidi_Class=commonseparator}', "");
    Expect(0, 65306, '\p{^Bidi_Class=commonseparator}', "");
    Expect(0, 65306, '\P{Bidi_Class=commonseparator}', "");
    Expect(1, 65306, '\P{^Bidi_Class=commonseparator}', "");
    Expect(0, 65307, '\p{Bidi_Class=commonseparator}', "");
    Expect(1, 65307, '\p{^Bidi_Class=commonseparator}', "");
    Expect(1, 65307, '\P{Bidi_Class=commonseparator}', "");
    Expect(0, 65307, '\P{^Bidi_Class=commonseparator}', "");
    Expect(1, 65306, '\p{Bidi_Class=_	COMMON_Separator}', "");
    Expect(0, 65306, '\p{^Bidi_Class=_	COMMON_Separator}', "");
    Expect(0, 65306, '\P{Bidi_Class=_	COMMON_Separator}', "");
    Expect(1, 65306, '\P{^Bidi_Class=_	COMMON_Separator}', "");
    Expect(0, 65307, '\p{Bidi_Class=_	COMMON_Separator}', "");
    Expect(1, 65307, '\p{^Bidi_Class=_	COMMON_Separator}', "");
    Expect(1, 65307, '\P{Bidi_Class=_	COMMON_Separator}', "");
    Expect(0, 65307, '\P{^Bidi_Class=_	COMMON_Separator}', "");
    Error('\p{Bc=_:=CS}');
    Error('\P{Bc=_:=CS}');
    Expect(1, 65306, '\p{Bc=cs}', "");
    Expect(0, 65306, '\p{^Bc=cs}', "");
    Expect(0, 65306, '\P{Bc=cs}', "");
    Expect(1, 65306, '\P{^Bc=cs}', "");
    Expect(0, 65307, '\p{Bc=cs}', "");
    Expect(1, 65307, '\p{^Bc=cs}', "");
    Expect(1, 65307, '\P{Bc=cs}', "");
    Expect(0, 65307, '\P{^Bc=cs}', "");
    Expect(1, 65306, '\p{Bc=  cs}', "");
    Expect(0, 65306, '\p{^Bc=  cs}', "");
    Expect(0, 65306, '\P{Bc=  cs}', "");
    Expect(1, 65306, '\P{^Bc=  cs}', "");
    Expect(0, 65307, '\p{Bc=  cs}', "");
    Expect(1, 65307, '\p{^Bc=  cs}', "");
    Expect(1, 65307, '\P{Bc=  cs}', "");
    Expect(0, 65307, '\P{^Bc=  cs}', "");
    Error('\p{Is_Bidi_Class= common_separator/a/}');
    Error('\P{Is_Bidi_Class= common_separator/a/}');
    Expect(1, 65306, '\p{Is_Bidi_Class=commonseparator}', "");
    Expect(0, 65306, '\p{^Is_Bidi_Class=commonseparator}', "");
    Expect(0, 65306, '\P{Is_Bidi_Class=commonseparator}', "");
    Expect(1, 65306, '\P{^Is_Bidi_Class=commonseparator}', "");
    Expect(0, 65307, '\p{Is_Bidi_Class=commonseparator}', "");
    Expect(1, 65307, '\p{^Is_Bidi_Class=commonseparator}', "");
    Expect(1, 65307, '\P{Is_Bidi_Class=commonseparator}', "");
    Expect(0, 65307, '\P{^Is_Bidi_Class=commonseparator}', "");
    Expect(1, 65306, '\p{Is_Bidi_Class=_-COMMON_separator}', "");
    Expect(0, 65306, '\p{^Is_Bidi_Class=_-COMMON_separator}', "");
    Expect(0, 65306, '\P{Is_Bidi_Class=_-COMMON_separator}', "");
    Expect(1, 65306, '\P{^Is_Bidi_Class=_-COMMON_separator}', "");
    Expect(0, 65307, '\p{Is_Bidi_Class=_-COMMON_separator}', "");
    Expect(1, 65307, '\p{^Is_Bidi_Class=_-COMMON_separator}', "");
    Expect(1, 65307, '\P{Is_Bidi_Class=_-COMMON_separator}', "");
    Expect(0, 65307, '\P{^Is_Bidi_Class=_-COMMON_separator}', "");
    Error('\p{Is_Bc= _CS/a/}');
    Error('\P{Is_Bc= _CS/a/}');
    Expect(1, 65306, '\p{Is_Bc=cs}', "");
    Expect(0, 65306, '\p{^Is_Bc=cs}', "");
    Expect(0, 65306, '\P{Is_Bc=cs}', "");
    Expect(1, 65306, '\P{^Is_Bc=cs}', "");
    Expect(0, 65307, '\p{Is_Bc=cs}', "");
    Expect(1, 65307, '\p{^Is_Bc=cs}', "");
    Expect(1, 65307, '\P{Is_Bc=cs}', "");
    Expect(0, 65307, '\P{^Is_Bc=cs}', "");
    Expect(1, 65306, '\p{Is_Bc=  CS}', "");
    Expect(0, 65306, '\p{^Is_Bc=  CS}', "");
    Expect(0, 65306, '\P{Is_Bc=  CS}', "");
    Expect(1, 65306, '\P{^Is_Bc=  CS}', "");
    Expect(0, 65307, '\p{Is_Bc=  CS}', "");
    Expect(1, 65307, '\p{^Is_Bc=  CS}', "");
    Expect(1, 65307, '\P{Is_Bc=  CS}', "");
    Expect(0, 65307, '\P{^Is_Bc=  CS}', "");
    Error('\p{Bidi_Class=__European_Number:=}');
    Error('\P{Bidi_Class=__European_Number:=}');
    Expect(1, 127242, '\p{Bidi_Class=europeannumber}', "");
    Expect(0, 127242, '\p{^Bidi_Class=europeannumber}', "");
    Expect(0, 127242, '\P{Bidi_Class=europeannumber}', "");
    Expect(1, 127242, '\P{^Bidi_Class=europeannumber}', "");
    Expect(0, 127243, '\p{Bidi_Class=europeannumber}', "");
    Expect(1, 127243, '\p{^Bidi_Class=europeannumber}', "");
    Expect(1, 127243, '\P{Bidi_Class=europeannumber}', "");
    Expect(0, 127243, '\P{^Bidi_Class=europeannumber}', "");
    Expect(1, 127242, '\p{Bidi_Class= _EUROPEAN_Number}', "");
    Expect(0, 127242, '\p{^Bidi_Class= _EUROPEAN_Number}', "");
    Expect(0, 127242, '\P{Bidi_Class= _EUROPEAN_Number}', "");
    Expect(1, 127242, '\P{^Bidi_Class= _EUROPEAN_Number}', "");
    Expect(0, 127243, '\p{Bidi_Class= _EUROPEAN_Number}', "");
    Expect(1, 127243, '\p{^Bidi_Class= _EUROPEAN_Number}', "");
    Expect(1, 127243, '\P{Bidi_Class= _EUROPEAN_Number}', "");
    Expect(0, 127243, '\P{^Bidi_Class= _EUROPEAN_Number}', "");
    Error('\p{Bc=/a/en}');
    Error('\P{Bc=/a/en}');
    Expect(1, 127242, '\p{Bc:en}', "");
    Expect(0, 127242, '\p{^Bc:en}', "");
    Expect(0, 127242, '\P{Bc:en}', "");
    Expect(1, 127242, '\P{^Bc:en}', "");
    Expect(0, 127243, '\p{Bc:en}', "");
    Expect(1, 127243, '\p{^Bc:en}', "");
    Expect(1, 127243, '\P{Bc:en}', "");
    Expect(0, 127243, '\P{^Bc:en}', "");
    Expect(1, 127242, '\p{Bc=_-EN}', "");
    Expect(0, 127242, '\p{^Bc=_-EN}', "");
    Expect(0, 127242, '\P{Bc=_-EN}', "");
    Expect(1, 127242, '\P{^Bc=_-EN}', "");
    Expect(0, 127243, '\p{Bc=_-EN}', "");
    Expect(1, 127243, '\p{^Bc=_-EN}', "");
    Expect(1, 127243, '\P{Bc=_-EN}', "");
    Expect(0, 127243, '\P{^Bc=_-EN}', "");
    Error('\p{Is_Bidi_Class=_European_NUMBER:=}');
    Error('\P{Is_Bidi_Class=_European_NUMBER:=}');
    Expect(1, 127242, '\p{Is_Bidi_Class=europeannumber}', "");
    Expect(0, 127242, '\p{^Is_Bidi_Class=europeannumber}', "");
    Expect(0, 127242, '\P{Is_Bidi_Class=europeannumber}', "");
    Expect(1, 127242, '\P{^Is_Bidi_Class=europeannumber}', "");
    Expect(0, 127243, '\p{Is_Bidi_Class=europeannumber}', "");
    Expect(1, 127243, '\p{^Is_Bidi_Class=europeannumber}', "");
    Expect(1, 127243, '\P{Is_Bidi_Class=europeannumber}', "");
    Expect(0, 127243, '\P{^Is_Bidi_Class=europeannumber}', "");
    Expect(1, 127242, '\p{Is_Bidi_Class= -EUROPEAN_NUMBER}', "");
    Expect(0, 127242, '\p{^Is_Bidi_Class= -EUROPEAN_NUMBER}', "");
    Expect(0, 127242, '\P{Is_Bidi_Class= -EUROPEAN_NUMBER}', "");
    Expect(1, 127242, '\P{^Is_Bidi_Class= -EUROPEAN_NUMBER}', "");
    Expect(0, 127243, '\p{Is_Bidi_Class= -EUROPEAN_NUMBER}', "");
    Expect(1, 127243, '\p{^Is_Bidi_Class= -EUROPEAN_NUMBER}', "");
    Expect(1, 127243, '\P{Is_Bidi_Class= -EUROPEAN_NUMBER}', "");
    Expect(0, 127243, '\P{^Is_Bidi_Class= -EUROPEAN_NUMBER}', "");
    Error('\p{Is_Bc=:=	en}');
    Error('\P{Is_Bc=:=	en}');
    Expect(1, 127242, '\p{Is_Bc:	en}', "");
    Expect(0, 127242, '\p{^Is_Bc:	en}', "");
    Expect(0, 127242, '\P{Is_Bc:	en}', "");
    Expect(1, 127242, '\P{^Is_Bc:	en}', "");
    Expect(0, 127243, '\p{Is_Bc:	en}', "");
    Expect(1, 127243, '\p{^Is_Bc:	en}', "");
    Expect(1, 127243, '\P{Is_Bc:	en}', "");
    Expect(0, 127243, '\P{^Is_Bc:	en}', "");
    Expect(1, 127242, '\p{Is_Bc=_	EN}', "");
    Expect(0, 127242, '\p{^Is_Bc=_	EN}', "");
    Expect(0, 127242, '\P{Is_Bc=_	EN}', "");
    Expect(1, 127242, '\P{^Is_Bc=_	EN}', "");
    Expect(0, 127243, '\p{Is_Bc=_	EN}', "");
    Expect(1, 127243, '\p{^Is_Bc=_	EN}', "");
    Expect(1, 127243, '\P{Is_Bc=_	EN}', "");
    Expect(0, 127243, '\P{^Is_Bc=_	EN}', "");
    Error('\p{Bidi_Class:    /a/European_Separator}');
    Error('\P{Bidi_Class:    /a/European_Separator}');
    Expect(1, 65293, '\p{Bidi_Class=europeanseparator}', "");
    Expect(0, 65293, '\p{^Bidi_Class=europeanseparator}', "");
    Expect(0, 65293, '\P{Bidi_Class=europeanseparator}', "");
    Expect(1, 65293, '\P{^Bidi_Class=europeanseparator}', "");
    Expect(0, 65294, '\p{Bidi_Class=europeanseparator}', "");
    Expect(1, 65294, '\p{^Bidi_Class=europeanseparator}', "");
    Expect(1, 65294, '\P{Bidi_Class=europeanseparator}', "");
    Expect(0, 65294, '\P{^Bidi_Class=europeanseparator}', "");
    Expect(1, 65293, '\p{Bidi_Class=-_EUROPEAN_Separator}', "");
    Expect(0, 65293, '\p{^Bidi_Class=-_EUROPEAN_Separator}', "");
    Expect(0, 65293, '\P{Bidi_Class=-_EUROPEAN_Separator}', "");
    Expect(1, 65293, '\P{^Bidi_Class=-_EUROPEAN_Separator}', "");
    Expect(0, 65294, '\p{Bidi_Class=-_EUROPEAN_Separator}', "");
    Expect(1, 65294, '\p{^Bidi_Class=-_EUROPEAN_Separator}', "");
    Expect(1, 65294, '\P{Bidi_Class=-_EUROPEAN_Separator}', "");
    Expect(0, 65294, '\P{^Bidi_Class=-_EUROPEAN_Separator}', "");
    Error('\p{Bc=:=		ES}');
    Error('\P{Bc=:=		ES}');
    Expect(1, 65293, '\p{Bc=es}', "");
    Expect(0, 65293, '\p{^Bc=es}', "");
    Expect(0, 65293, '\P{Bc=es}', "");
    Expect(1, 65293, '\P{^Bc=es}', "");
    Expect(0, 65294, '\p{Bc=es}', "");
    Expect(1, 65294, '\p{^Bc=es}', "");
    Expect(1, 65294, '\P{Bc=es}', "");
    Expect(0, 65294, '\P{^Bc=es}', "");
    Expect(1, 65293, '\p{Bc= _es}', "");
    Expect(0, 65293, '\p{^Bc= _es}', "");
    Expect(0, 65293, '\P{Bc= _es}', "");
    Expect(1, 65293, '\P{^Bc= _es}', "");
    Expect(0, 65294, '\p{Bc= _es}', "");
    Expect(1, 65294, '\p{^Bc= _es}', "");
    Expect(1, 65294, '\P{Bc= _es}', "");
    Expect(0, 65294, '\P{^Bc= _es}', "");
    Error('\p{Is_Bidi_Class=:=	European_Separator}');
    Error('\P{Is_Bidi_Class=:=	European_Separator}');
    Expect(1, 65293, '\p{Is_Bidi_Class=europeanseparator}', "");
    Expect(0, 65293, '\p{^Is_Bidi_Class=europeanseparator}', "");
    Expect(0, 65293, '\P{Is_Bidi_Class=europeanseparator}', "");
    Expect(1, 65293, '\P{^Is_Bidi_Class=europeanseparator}', "");
    Expect(0, 65294, '\p{Is_Bidi_Class=europeanseparator}', "");
    Expect(1, 65294, '\p{^Is_Bidi_Class=europeanseparator}', "");
    Expect(1, 65294, '\P{Is_Bidi_Class=europeanseparator}', "");
    Expect(0, 65294, '\P{^Is_Bidi_Class=europeanseparator}', "");
    Expect(1, 65293, '\p{Is_Bidi_Class=-EUROPEAN_Separator}', "");
    Expect(0, 65293, '\p{^Is_Bidi_Class=-EUROPEAN_Separator}', "");
    Expect(0, 65293, '\P{Is_Bidi_Class=-EUROPEAN_Separator}', "");
    Expect(1, 65293, '\P{^Is_Bidi_Class=-EUROPEAN_Separator}', "");
    Expect(0, 65294, '\p{Is_Bidi_Class=-EUROPEAN_Separator}', "");
    Expect(1, 65294, '\p{^Is_Bidi_Class=-EUROPEAN_Separator}', "");
    Expect(1, 65294, '\P{Is_Bidi_Class=-EUROPEAN_Separator}', "");
    Expect(0, 65294, '\P{^Is_Bidi_Class=-EUROPEAN_Separator}', "");
    Error('\p{Is_Bc=/a/ _es}');
    Error('\P{Is_Bc=/a/ _es}');
    Expect(1, 65293, '\p{Is_Bc=es}', "");
    Expect(0, 65293, '\p{^Is_Bc=es}', "");
    Expect(0, 65293, '\P{Is_Bc=es}', "");
    Expect(1, 65293, '\P{^Is_Bc=es}', "");
    Expect(0, 65294, '\p{Is_Bc=es}', "");
    Expect(1, 65294, '\p{^Is_Bc=es}', "");
    Expect(1, 65294, '\P{Is_Bc=es}', "");
    Expect(0, 65294, '\P{^Is_Bc=es}', "");
    Expect(1, 65293, '\p{Is_Bc=	-ES}', "");
    Expect(0, 65293, '\p{^Is_Bc=	-ES}', "");
    Expect(0, 65293, '\P{Is_Bc=	-ES}', "");
    Expect(1, 65293, '\P{^Is_Bc=	-ES}', "");
    Expect(0, 65294, '\p{Is_Bc=	-ES}', "");
    Expect(1, 65294, '\p{^Is_Bc=	-ES}', "");
    Expect(1, 65294, '\P{Is_Bc=	-ES}', "");
    Expect(0, 65294, '\P{^Is_Bc=	-ES}', "");
    Error('\p{Bidi_Class=_european_Terminator:=}');
    Error('\P{Bidi_Class=_european_Terminator:=}');
    Expect(1, 65510, '\p{Bidi_Class=europeanterminator}', "");
    Expect(0, 65510, '\p{^Bidi_Class=europeanterminator}', "");
    Expect(0, 65510, '\P{Bidi_Class=europeanterminator}', "");
    Expect(1, 65510, '\P{^Bidi_Class=europeanterminator}', "");
    Expect(0, 65511, '\p{Bidi_Class=europeanterminator}', "");
    Expect(1, 65511, '\p{^Bidi_Class=europeanterminator}', "");
    Expect(1, 65511, '\P{Bidi_Class=europeanterminator}', "");
    Expect(0, 65511, '\P{^Bidi_Class=europeanterminator}', "");
    Expect(1, 65510, '\p{Bidi_Class= european_Terminator}', "");
    Expect(0, 65510, '\p{^Bidi_Class= european_Terminator}', "");
    Expect(0, 65510, '\P{Bidi_Class= european_Terminator}', "");
    Expect(1, 65510, '\P{^Bidi_Class= european_Terminator}', "");
    Expect(0, 65511, '\p{Bidi_Class= european_Terminator}', "");
    Expect(1, 65511, '\p{^Bidi_Class= european_Terminator}', "");
    Expect(1, 65511, '\P{Bidi_Class= european_Terminator}', "");
    Expect(0, 65511, '\P{^Bidi_Class= european_Terminator}', "");
    Error('\p{Bc:   -/a/ET}');
    Error('\P{Bc:   -/a/ET}');
    Expect(1, 65510, '\p{Bc=et}', "");
    Expect(0, 65510, '\p{^Bc=et}', "");
    Expect(0, 65510, '\P{Bc=et}', "");
    Expect(1, 65510, '\P{^Bc=et}', "");
    Expect(0, 65511, '\p{Bc=et}', "");
    Expect(1, 65511, '\p{^Bc=et}', "");
    Expect(1, 65511, '\P{Bc=et}', "");
    Expect(0, 65511, '\P{^Bc=et}', "");
    Expect(1, 65510, '\p{Bc=	_ET}', "");
    Expect(0, 65510, '\p{^Bc=	_ET}', "");
    Expect(0, 65510, '\P{Bc=	_ET}', "");
    Expect(1, 65510, '\P{^Bc=	_ET}', "");
    Expect(0, 65511, '\p{Bc=	_ET}', "");
    Expect(1, 65511, '\p{^Bc=	_ET}', "");
    Expect(1, 65511, '\P{Bc=	_ET}', "");
    Expect(0, 65511, '\P{^Bc=	_ET}', "");
    Error('\p{Is_Bidi_Class=--european_terminator/a/}');
    Error('\P{Is_Bidi_Class=--european_terminator/a/}');
    Expect(1, 65510, '\p{Is_Bidi_Class=europeanterminator}', "");
    Expect(0, 65510, '\p{^Is_Bidi_Class=europeanterminator}', "");
    Expect(0, 65510, '\P{Is_Bidi_Class=europeanterminator}', "");
    Expect(1, 65510, '\P{^Is_Bidi_Class=europeanterminator}', "");
    Expect(0, 65511, '\p{Is_Bidi_Class=europeanterminator}', "");
    Expect(1, 65511, '\p{^Is_Bidi_Class=europeanterminator}', "");
    Expect(1, 65511, '\P{Is_Bidi_Class=europeanterminator}', "");
    Expect(0, 65511, '\P{^Is_Bidi_Class=europeanterminator}', "");
    Expect(1, 65510, '\p{Is_Bidi_Class=__European_terminator}', "");
    Expect(0, 65510, '\p{^Is_Bidi_Class=__European_terminator}', "");
    Expect(0, 65510, '\P{Is_Bidi_Class=__European_terminator}', "");
    Expect(1, 65510, '\P{^Is_Bidi_Class=__European_terminator}', "");
    Expect(0, 65511, '\p{Is_Bidi_Class=__European_terminator}', "");
    Expect(1, 65511, '\p{^Is_Bidi_Class=__European_terminator}', "");
    Expect(1, 65511, '\P{Is_Bidi_Class=__European_terminator}', "");
    Expect(0, 65511, '\P{^Is_Bidi_Class=__European_terminator}', "");
    Error('\p{Is_Bc=	-et:=}');
    Error('\P{Is_Bc=	-et:=}');
    Expect(1, 65510, '\p{Is_Bc:et}', "");
    Expect(0, 65510, '\p{^Is_Bc:et}', "");
    Expect(0, 65510, '\P{Is_Bc:et}', "");
    Expect(1, 65510, '\P{^Is_Bc:et}', "");
    Expect(0, 65511, '\p{Is_Bc:et}', "");
    Expect(1, 65511, '\p{^Is_Bc:et}', "");
    Expect(1, 65511, '\P{Is_Bc:et}', "");
    Expect(0, 65511, '\P{^Is_Bc:et}', "");
    Expect(1, 65510, '\p{Is_Bc=-_ET}', "");
    Expect(0, 65510, '\p{^Is_Bc=-_ET}', "");
    Expect(0, 65510, '\P{Is_Bc=-_ET}', "");
    Expect(1, 65510, '\P{^Is_Bc=-_ET}', "");
    Expect(0, 65511, '\p{Is_Bc=-_ET}', "");
    Expect(1, 65511, '\p{^Is_Bc=-_ET}', "");
    Expect(1, 65511, '\P{Is_Bc=-_ET}', "");
    Expect(0, 65511, '\P{^Is_Bc=-_ET}', "");
    Error('\p{Bidi_Class=:= -FIRST_Strong_ISOLATE}');
    Error('\P{Bidi_Class=:= -FIRST_Strong_ISOLATE}');
    Expect(1, 8296, '\p{Bidi_Class=firststrongisolate}', "");
    Expect(0, 8296, '\p{^Bidi_Class=firststrongisolate}', "");
    Expect(0, 8296, '\P{Bidi_Class=firststrongisolate}', "");
    Expect(1, 8296, '\P{^Bidi_Class=firststrongisolate}', "");
    Expect(0, 8297, '\p{Bidi_Class=firststrongisolate}', "");
    Expect(1, 8297, '\p{^Bidi_Class=firststrongisolate}', "");
    Expect(1, 8297, '\P{Bidi_Class=firststrongisolate}', "");
    Expect(0, 8297, '\P{^Bidi_Class=firststrongisolate}', "");
    Expect(1, 8296, '\p{Bidi_Class=-FIRST_Strong_Isolate}', "");
    Expect(0, 8296, '\p{^Bidi_Class=-FIRST_Strong_Isolate}', "");
    Expect(0, 8296, '\P{Bidi_Class=-FIRST_Strong_Isolate}', "");
    Expect(1, 8296, '\P{^Bidi_Class=-FIRST_Strong_Isolate}', "");
    Expect(0, 8297, '\p{Bidi_Class=-FIRST_Strong_Isolate}', "");
    Expect(1, 8297, '\p{^Bidi_Class=-FIRST_Strong_Isolate}', "");
    Expect(1, 8297, '\P{Bidi_Class=-FIRST_Strong_Isolate}', "");
    Expect(0, 8297, '\P{^Bidi_Class=-FIRST_Strong_Isolate}', "");
    Error('\p{Bc=/a/FSI}');
    Error('\P{Bc=/a/FSI}');
    Expect(1, 8296, '\p{Bc=fsi}', "");
    Expect(0, 8296, '\p{^Bc=fsi}', "");
    Expect(0, 8296, '\P{Bc=fsi}', "");
    Expect(1, 8296, '\P{^Bc=fsi}', "");
    Expect(0, 8297, '\p{Bc=fsi}', "");
    Expect(1, 8297, '\p{^Bc=fsi}', "");
    Expect(1, 8297, '\P{Bc=fsi}', "");
    Expect(0, 8297, '\P{^Bc=fsi}', "");
    Expect(1, 8296, '\p{Bc=_ fsi}', "");
    Expect(0, 8296, '\p{^Bc=_ fsi}', "");
    Expect(0, 8296, '\P{Bc=_ fsi}', "");
    Expect(1, 8296, '\P{^Bc=_ fsi}', "");
    Expect(0, 8297, '\p{Bc=_ fsi}', "");
    Expect(1, 8297, '\p{^Bc=_ fsi}', "");
    Expect(1, 8297, '\P{Bc=_ fsi}', "");
    Expect(0, 8297, '\P{^Bc=_ fsi}', "");
    Error('\p{Is_Bidi_Class=/a/__FIRST_Strong_ISOLATE}');
    Error('\P{Is_Bidi_Class=/a/__FIRST_Strong_ISOLATE}');
    Expect(1, 8296, '\p{Is_Bidi_Class=firststrongisolate}', "");
    Expect(0, 8296, '\p{^Is_Bidi_Class=firststrongisolate}', "");
    Expect(0, 8296, '\P{Is_Bidi_Class=firststrongisolate}', "");
    Expect(1, 8296, '\P{^Is_Bidi_Class=firststrongisolate}', "");
    Expect(0, 8297, '\p{Is_Bidi_Class=firststrongisolate}', "");
    Expect(1, 8297, '\p{^Is_Bidi_Class=firststrongisolate}', "");
    Expect(1, 8297, '\P{Is_Bidi_Class=firststrongisolate}', "");
    Expect(0, 8297, '\P{^Is_Bidi_Class=firststrongisolate}', "");
    Expect(1, 8296, '\p{Is_Bidi_Class=_FIRST_Strong_Isolate}', "");
    Expect(0, 8296, '\p{^Is_Bidi_Class=_FIRST_Strong_Isolate}', "");
    Expect(0, 8296, '\P{Is_Bidi_Class=_FIRST_Strong_Isolate}', "");
    Expect(1, 8296, '\P{^Is_Bidi_Class=_FIRST_Strong_Isolate}', "");
    Expect(0, 8297, '\p{Is_Bidi_Class=_FIRST_Strong_Isolate}', "");
    Expect(1, 8297, '\p{^Is_Bidi_Class=_FIRST_Strong_Isolate}', "");
    Expect(1, 8297, '\P{Is_Bidi_Class=_FIRST_Strong_Isolate}', "");
    Expect(0, 8297, '\P{^Is_Bidi_Class=_FIRST_Strong_Isolate}', "");
    Error('\p{Is_Bc=	 FSI/a/}');
    Error('\P{Is_Bc=	 FSI/a/}');
    Expect(1, 8296, '\p{Is_Bc=fsi}', "");
    Expect(0, 8296, '\p{^Is_Bc=fsi}', "");
    Expect(0, 8296, '\P{Is_Bc=fsi}', "");
    Expect(1, 8296, '\P{^Is_Bc=fsi}', "");
    Expect(0, 8297, '\p{Is_Bc=fsi}', "");
    Expect(1, 8297, '\p{^Is_Bc=fsi}', "");
    Expect(1, 8297, '\P{Is_Bc=fsi}', "");
    Expect(0, 8297, '\P{^Is_Bc=fsi}', "");
    Expect(1, 8296, '\p{Is_Bc=	_FSI}', "");
    Expect(0, 8296, '\p{^Is_Bc=	_FSI}', "");
    Expect(0, 8296, '\P{Is_Bc=	_FSI}', "");
    Expect(1, 8296, '\P{^Is_Bc=	_FSI}', "");
    Expect(0, 8297, '\p{Is_Bc=	_FSI}', "");
    Expect(1, 8297, '\p{^Is_Bc=	_FSI}', "");
    Expect(1, 8297, '\P{Is_Bc=	_FSI}', "");
    Expect(0, 8297, '\P{^Is_Bc=	_FSI}', "");
    Error('\p{Bidi_Class=_/a/LEFT_to_Right}');
    Error('\P{Bidi_Class=_/a/LEFT_to_Right}');
    Expect(1, 1114109, '\p{Bidi_Class=lefttoright}', "");
    Expect(0, 1114109, '\p{^Bidi_Class=lefttoright}', "");
    Expect(0, 1114109, '\P{Bidi_Class=lefttoright}', "");
    Expect(1, 1114109, '\P{^Bidi_Class=lefttoright}', "");
    Expect(0, 921599, '\p{Bidi_Class=lefttoright}', "");
    Expect(1, 921599, '\p{^Bidi_Class=lefttoright}', "");
    Expect(1, 921599, '\P{Bidi_Class=lefttoright}', "");
    Expect(0, 921599, '\P{^Bidi_Class=lefttoright}', "");
    Expect(1, 1114109, '\p{Bidi_Class=-_LEFT_To_Right}', "");
    Expect(0, 1114109, '\p{^Bidi_Class=-_LEFT_To_Right}', "");
    Expect(0, 1114109, '\P{Bidi_Class=-_LEFT_To_Right}', "");
    Expect(1, 1114109, '\P{^Bidi_Class=-_LEFT_To_Right}', "");
    Expect(0, 921599, '\p{Bidi_Class=-_LEFT_To_Right}', "");
    Expect(1, 921599, '\p{^Bidi_Class=-_LEFT_To_Right}', "");
    Expect(1, 921599, '\P{Bidi_Class=-_LEFT_To_Right}', "");
    Expect(0, 921599, '\P{^Bidi_Class=-_LEFT_To_Right}', "");
    Error('\p{Bc=L:=}');
    Error('\P{Bc=L:=}');
    Expect(1, 1114109, '\p{Bc=l}', "");
    Expect(0, 1114109, '\p{^Bc=l}', "");
    Expect(0, 1114109, '\P{Bc=l}', "");
    Expect(1, 1114109, '\P{^Bc=l}', "");
    Expect(0, 921599, '\p{Bc=l}', "");
    Expect(1, 921599, '\p{^Bc=l}', "");
    Expect(1, 921599, '\P{Bc=l}', "");
    Expect(0, 921599, '\P{^Bc=l}', "");
    Expect(1, 1114109, '\p{Bc=_	l}', "");
    Expect(0, 1114109, '\p{^Bc=_	l}', "");
    Expect(0, 1114109, '\P{Bc=_	l}', "");
    Expect(1, 1114109, '\P{^Bc=_	l}', "");
    Expect(0, 921599, '\p{Bc=_	l}', "");
    Expect(1, 921599, '\p{^Bc=_	l}', "");
    Expect(1, 921599, '\P{Bc=_	l}', "");
    Expect(0, 921599, '\P{^Bc=_	l}', "");
    Error('\p{Is_Bidi_Class:	-LEFT_TO_right/a/}');
    Error('\P{Is_Bidi_Class:	-LEFT_TO_right/a/}');
    Expect(1, 1114109, '\p{Is_Bidi_Class:	lefttoright}', "");
    Expect(0, 1114109, '\p{^Is_Bidi_Class:	lefttoright}', "");
    Expect(0, 1114109, '\P{Is_Bidi_Class:	lefttoright}', "");
    Expect(1, 1114109, '\P{^Is_Bidi_Class:	lefttoright}', "");
    Expect(0, 921599, '\p{Is_Bidi_Class:	lefttoright}', "");
    Expect(1, 921599, '\p{^Is_Bidi_Class:	lefttoright}', "");
    Expect(1, 921599, '\P{Is_Bidi_Class:	lefttoright}', "");
    Expect(0, 921599, '\P{^Is_Bidi_Class:	lefttoright}', "");
    Expect(1, 1114109, '\p{Is_Bidi_Class=-Left_To_Right}', "");
    Expect(0, 1114109, '\p{^Is_Bidi_Class=-Left_To_Right}', "");
    Expect(0, 1114109, '\P{Is_Bidi_Class=-Left_To_Right}', "");
    Expect(1, 1114109, '\P{^Is_Bidi_Class=-Left_To_Right}', "");
    Expect(0, 921599, '\p{Is_Bidi_Class=-Left_To_Right}', "");
    Expect(1, 921599, '\p{^Is_Bidi_Class=-Left_To_Right}', "");
    Expect(1, 921599, '\P{Is_Bidi_Class=-Left_To_Right}', "");
    Expect(0, 921599, '\P{^Is_Bidi_Class=-Left_To_Right}', "");
    Error('\p{Is_Bc=/a/	L}');
    Error('\P{Is_Bc=/a/	L}');
    Expect(1, 1114109, '\p{Is_Bc=l}', "");
    Expect(0, 1114109, '\p{^Is_Bc=l}', "");
    Expect(0, 1114109, '\P{Is_Bc=l}', "");
    Expect(1, 1114109, '\P{^Is_Bc=l}', "");
    Expect(0, 921599, '\p{Is_Bc=l}', "");
    Expect(1, 921599, '\p{^Is_Bc=l}', "");
    Expect(1, 921599, '\P{Is_Bc=l}', "");
    Expect(0, 921599, '\P{^Is_Bc=l}', "");
    Expect(1, 1114109, '\p{Is_Bc=- L}', "");
    Expect(0, 1114109, '\p{^Is_Bc=- L}', "");
    Expect(0, 1114109, '\P{Is_Bc=- L}', "");
    Expect(1, 1114109, '\P{^Is_Bc=- L}', "");
    Expect(0, 921599, '\p{Is_Bc=- L}', "");
    Expect(1, 921599, '\p{^Is_Bc=- L}', "");
    Expect(1, 921599, '\P{Is_Bc=- L}', "");
    Expect(0, 921599, '\P{^Is_Bc=- L}', "");
    Error('\p{Bidi_Class=Left_TO_Right_Embedding/a/}');
    Error('\P{Bidi_Class=Left_TO_Right_Embedding/a/}');
    Expect(1, 8234, '\p{Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8234, '\p{^Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8234, '\P{Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8234, '\P{^Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8235, '\p{Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8235, '\p{^Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8235, '\P{Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8235, '\P{^Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8234, '\p{Bidi_Class=_Left_To_Right_embedding}', "");
    Expect(0, 8234, '\p{^Bidi_Class=_Left_To_Right_embedding}', "");
    Expect(0, 8234, '\P{Bidi_Class=_Left_To_Right_embedding}', "");
    Expect(1, 8234, '\P{^Bidi_Class=_Left_To_Right_embedding}', "");
    Expect(0, 8235, '\p{Bidi_Class=_Left_To_Right_embedding}', "");
    Expect(1, 8235, '\p{^Bidi_Class=_Left_To_Right_embedding}', "");
    Expect(1, 8235, '\P{Bidi_Class=_Left_To_Right_embedding}', "");
    Expect(0, 8235, '\P{^Bidi_Class=_Left_To_Right_embedding}', "");
    Error('\p{Bc=LRE/a/}');
    Error('\P{Bc=LRE/a/}');
    Expect(1, 8234, '\p{Bc=lre}', "");
    Expect(0, 8234, '\p{^Bc=lre}', "");
    Expect(0, 8234, '\P{Bc=lre}', "");
    Expect(1, 8234, '\P{^Bc=lre}', "");
    Expect(0, 8235, '\p{Bc=lre}', "");
    Expect(1, 8235, '\p{^Bc=lre}', "");
    Expect(1, 8235, '\P{Bc=lre}', "");
    Expect(0, 8235, '\P{^Bc=lre}', "");
    Expect(1, 8234, '\p{Bc:	 lre}', "");
    Expect(0, 8234, '\p{^Bc:	 lre}', "");
    Expect(0, 8234, '\P{Bc:	 lre}', "");
    Expect(1, 8234, '\P{^Bc:	 lre}', "");
    Expect(0, 8235, '\p{Bc:	 lre}', "");
    Expect(1, 8235, '\p{^Bc:	 lre}', "");
    Expect(1, 8235, '\P{Bc:	 lre}', "");
    Expect(0, 8235, '\P{^Bc:	 lre}', "");
    Error('\p{Is_Bidi_Class=	Left_To_Right_Embedding:=}');
    Error('\P{Is_Bidi_Class=	Left_To_Right_Embedding:=}');
    Expect(1, 8234, '\p{Is_Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8234, '\p{^Is_Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8234, '\P{Is_Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8234, '\P{^Is_Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8235, '\p{Is_Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8235, '\p{^Is_Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8235, '\P{Is_Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8235, '\P{^Is_Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8234, '\p{Is_Bidi_Class= left_To_Right_Embedding}', "");
    Expect(0, 8234, '\p{^Is_Bidi_Class= left_To_Right_Embedding}', "");
    Expect(0, 8234, '\P{Is_Bidi_Class= left_To_Right_Embedding}', "");
    Expect(1, 8234, '\P{^Is_Bidi_Class= left_To_Right_Embedding}', "");
    Expect(0, 8235, '\p{Is_Bidi_Class= left_To_Right_Embedding}', "");
    Expect(1, 8235, '\p{^Is_Bidi_Class= left_To_Right_Embedding}', "");
    Expect(1, 8235, '\P{Is_Bidi_Class= left_To_Right_Embedding}', "");
    Expect(0, 8235, '\P{^Is_Bidi_Class= left_To_Right_Embedding}', "");
    Error('\p{Is_Bc=/a/ _LRE}');
    Error('\P{Is_Bc=/a/ _LRE}');
    Expect(1, 8234, '\p{Is_Bc=lre}', "");
    Expect(0, 8234, '\p{^Is_Bc=lre}', "");
    Expect(0, 8234, '\P{Is_Bc=lre}', "");
    Expect(1, 8234, '\P{^Is_Bc=lre}', "");
    Expect(0, 8235, '\p{Is_Bc=lre}', "");
    Expect(1, 8235, '\p{^Is_Bc=lre}', "");
    Expect(1, 8235, '\P{Is_Bc=lre}', "");
    Expect(0, 8235, '\P{^Is_Bc=lre}', "");
    Expect(1, 8234, '\p{Is_Bc=-LRE}', "");
    Expect(0, 8234, '\p{^Is_Bc=-LRE}', "");
    Expect(0, 8234, '\P{Is_Bc=-LRE}', "");
    Expect(1, 8234, '\P{^Is_Bc=-LRE}', "");
    Expect(0, 8235, '\p{Is_Bc=-LRE}', "");
    Expect(1, 8235, '\p{^Is_Bc=-LRE}', "");
    Expect(1, 8235, '\P{Is_Bc=-LRE}', "");
    Expect(0, 8235, '\P{^Is_Bc=-LRE}', "");
    Error('\p{Bidi_Class=/a/--Left_to_Right_Isolate}');
    Error('\P{Bidi_Class=/a/--Left_to_Right_Isolate}');
    Expect(1, 8294, '\p{Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8294, '\p{^Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8294, '\P{Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8294, '\P{^Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8295, '\p{Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8295, '\p{^Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8295, '\P{Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8295, '\P{^Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8294, '\p{Bidi_Class=_	Left_To_right_isolate}', "");
    Expect(0, 8294, '\p{^Bidi_Class=_	Left_To_right_isolate}', "");
    Expect(0, 8294, '\P{Bidi_Class=_	Left_To_right_isolate}', "");
    Expect(1, 8294, '\P{^Bidi_Class=_	Left_To_right_isolate}', "");
    Expect(0, 8295, '\p{Bidi_Class=_	Left_To_right_isolate}', "");
    Expect(1, 8295, '\p{^Bidi_Class=_	Left_To_right_isolate}', "");
    Expect(1, 8295, '\P{Bidi_Class=_	Left_To_right_isolate}', "");
    Expect(0, 8295, '\P{^Bidi_Class=_	Left_To_right_isolate}', "");
    Error('\p{Bc=:=		LRI}');
    Error('\P{Bc=:=		LRI}');
    Expect(1, 8294, '\p{Bc=lri}', "");
    Expect(0, 8294, '\p{^Bc=lri}', "");
    Expect(0, 8294, '\P{Bc=lri}', "");
    Expect(1, 8294, '\P{^Bc=lri}', "");
    Expect(0, 8295, '\p{Bc=lri}', "");
    Expect(1, 8295, '\p{^Bc=lri}', "");
    Expect(1, 8295, '\P{Bc=lri}', "");
    Expect(0, 8295, '\P{^Bc=lri}', "");
    Expect(1, 8294, '\p{Bc= -LRI}', "");
    Expect(0, 8294, '\p{^Bc= -LRI}', "");
    Expect(0, 8294, '\P{Bc= -LRI}', "");
    Expect(1, 8294, '\P{^Bc= -LRI}', "");
    Expect(0, 8295, '\p{Bc= -LRI}', "");
    Expect(1, 8295, '\p{^Bc= -LRI}', "");
    Expect(1, 8295, '\P{Bc= -LRI}', "");
    Expect(0, 8295, '\P{^Bc= -LRI}', "");
    Error('\p{Is_Bidi_Class=:=_-LEFT_TO_Right_Isolate}');
    Error('\P{Is_Bidi_Class=:=_-LEFT_TO_Right_Isolate}');
    Expect(1, 8294, '\p{Is_Bidi_Class: lefttorightisolate}', "");
    Expect(0, 8294, '\p{^Is_Bidi_Class: lefttorightisolate}', "");
    Expect(0, 8294, '\P{Is_Bidi_Class: lefttorightisolate}', "");
    Expect(1, 8294, '\P{^Is_Bidi_Class: lefttorightisolate}', "");
    Expect(0, 8295, '\p{Is_Bidi_Class: lefttorightisolate}', "");
    Expect(1, 8295, '\p{^Is_Bidi_Class: lefttorightisolate}', "");
    Expect(1, 8295, '\P{Is_Bidi_Class: lefttorightisolate}', "");
    Expect(0, 8295, '\P{^Is_Bidi_Class: lefttorightisolate}', "");
    Expect(1, 8294, '\p{Is_Bidi_Class=-left_to_Right_ISOLATE}', "");
    Expect(0, 8294, '\p{^Is_Bidi_Class=-left_to_Right_ISOLATE}', "");
    Expect(0, 8294, '\P{Is_Bidi_Class=-left_to_Right_ISOLATE}', "");
    Expect(1, 8294, '\P{^Is_Bidi_Class=-left_to_Right_ISOLATE}', "");
    Expect(0, 8295, '\p{Is_Bidi_Class=-left_to_Right_ISOLATE}', "");
    Expect(1, 8295, '\p{^Is_Bidi_Class=-left_to_Right_ISOLATE}', "");
    Expect(1, 8295, '\P{Is_Bidi_Class=-left_to_Right_ISOLATE}', "");
    Expect(0, 8295, '\P{^Is_Bidi_Class=-left_to_Right_ISOLATE}', "");
    Error('\p{Is_Bc=-lri:=}');
    Error('\P{Is_Bc=-lri:=}');
    Expect(1, 8294, '\p{Is_Bc: lri}', "");
    Expect(0, 8294, '\p{^Is_Bc: lri}', "");
    Expect(0, 8294, '\P{Is_Bc: lri}', "");
    Expect(1, 8294, '\P{^Is_Bc: lri}', "");
    Expect(0, 8295, '\p{Is_Bc: lri}', "");
    Expect(1, 8295, '\p{^Is_Bc: lri}', "");
    Expect(1, 8295, '\P{Is_Bc: lri}', "");
    Expect(0, 8295, '\P{^Is_Bc: lri}', "");
    Expect(1, 8294, '\p{Is_Bc=-	LRI}', "");
    Expect(0, 8294, '\p{^Is_Bc=-	LRI}', "");
    Expect(0, 8294, '\P{Is_Bc=-	LRI}', "");
    Expect(1, 8294, '\P{^Is_Bc=-	LRI}', "");
    Expect(0, 8295, '\p{Is_Bc=-	LRI}', "");
    Expect(1, 8295, '\p{^Is_Bc=-	LRI}', "");
    Expect(1, 8295, '\P{Is_Bc=-	LRI}', "");
    Expect(0, 8295, '\P{^Is_Bc=-	LRI}', "");
    Error('\p{Bidi_Class=-/a/Left_TO_right_OVERRIDE}');
    Error('\P{Bidi_Class=-/a/Left_TO_right_OVERRIDE}');
    Expect(1, 8237, '\p{Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8237, '\p{^Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8237, '\P{Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8237, '\P{^Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8238, '\p{Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8238, '\p{^Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8238, '\P{Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8238, '\P{^Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8237, '\p{Bidi_Class=	-left_To_Right_override}', "");
    Expect(0, 8237, '\p{^Bidi_Class=	-left_To_Right_override}', "");
    Expect(0, 8237, '\P{Bidi_Class=	-left_To_Right_override}', "");
    Expect(1, 8237, '\P{^Bidi_Class=	-left_To_Right_override}', "");
    Expect(0, 8238, '\p{Bidi_Class=	-left_To_Right_override}', "");
    Expect(1, 8238, '\p{^Bidi_Class=	-left_To_Right_override}', "");
    Expect(1, 8238, '\P{Bidi_Class=	-left_To_Right_override}', "");
    Expect(0, 8238, '\P{^Bidi_Class=	-left_To_Right_override}', "");
    Error('\p{Bc=LRO:=}');
    Error('\P{Bc=LRO:=}');
    Expect(1, 8237, '\p{Bc=lro}', "");
    Expect(0, 8237, '\p{^Bc=lro}', "");
    Expect(0, 8237, '\P{Bc=lro}', "");
    Expect(1, 8237, '\P{^Bc=lro}', "");
    Expect(0, 8238, '\p{Bc=lro}', "");
    Expect(1, 8238, '\p{^Bc=lro}', "");
    Expect(1, 8238, '\P{Bc=lro}', "");
    Expect(0, 8238, '\P{^Bc=lro}', "");
    Expect(1, 8237, '\p{Bc=		LRO}', "");
    Expect(0, 8237, '\p{^Bc=		LRO}', "");
    Expect(0, 8237, '\P{Bc=		LRO}', "");
    Expect(1, 8237, '\P{^Bc=		LRO}', "");
    Expect(0, 8238, '\p{Bc=		LRO}', "");
    Expect(1, 8238, '\p{^Bc=		LRO}', "");
    Expect(1, 8238, '\P{Bc=		LRO}', "");
    Expect(0, 8238, '\P{^Bc=		LRO}', "");
    Error('\p{Is_Bidi_Class=-Left_To_RIGHT_OVERRIDE/a/}');
    Error('\P{Is_Bidi_Class=-Left_To_RIGHT_OVERRIDE/a/}');
    Expect(1, 8237, '\p{Is_Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8237, '\p{^Is_Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8237, '\P{Is_Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8237, '\P{^Is_Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8238, '\p{Is_Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8238, '\p{^Is_Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8238, '\P{Is_Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8238, '\P{^Is_Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8237, '\p{Is_Bidi_Class=--Left_To_RIGHT_Override}', "");
    Expect(0, 8237, '\p{^Is_Bidi_Class=--Left_To_RIGHT_Override}', "");
    Expect(0, 8237, '\P{Is_Bidi_Class=--Left_To_RIGHT_Override}', "");
    Expect(1, 8237, '\P{^Is_Bidi_Class=--Left_To_RIGHT_Override}', "");
    Expect(0, 8238, '\p{Is_Bidi_Class=--Left_To_RIGHT_Override}', "");
    Expect(1, 8238, '\p{^Is_Bidi_Class=--Left_To_RIGHT_Override}', "");
    Expect(1, 8238, '\P{Is_Bidi_Class=--Left_To_RIGHT_Override}', "");
    Expect(0, 8238, '\P{^Is_Bidi_Class=--Left_To_RIGHT_Override}', "");
    Error('\p{Is_Bc=/a/ -LRO}');
    Error('\P{Is_Bc=/a/ -LRO}');
    Expect(1, 8237, '\p{Is_Bc=lro}', "");
    Expect(0, 8237, '\p{^Is_Bc=lro}', "");
    Expect(0, 8237, '\P{Is_Bc=lro}', "");
    Expect(1, 8237, '\P{^Is_Bc=lro}', "");
    Expect(0, 8238, '\p{Is_Bc=lro}', "");
    Expect(1, 8238, '\p{^Is_Bc=lro}', "");
    Expect(1, 8238, '\P{Is_Bc=lro}', "");
    Expect(0, 8238, '\P{^Is_Bc=lro}', "");
    Expect(1, 8237, '\p{Is_Bc=  LRO}', "");
    Expect(0, 8237, '\p{^Is_Bc=  LRO}', "");
    Expect(0, 8237, '\P{Is_Bc=  LRO}', "");
    Expect(1, 8237, '\P{^Is_Bc=  LRO}', "");
    Expect(0, 8238, '\p{Is_Bc=  LRO}', "");
    Expect(1, 8238, '\p{^Is_Bc=  LRO}', "");
    Expect(1, 8238, '\P{Is_Bc=  LRO}', "");
    Expect(0, 8238, '\P{^Is_Bc=  LRO}', "");
    Error('\p{Bidi_Class=		NONSPACING_Mark/a/}');
    Error('\P{Bidi_Class=		NONSPACING_Mark/a/}');
    Expect(1, 917999, '\p{Bidi_Class=nonspacingmark}', "");
    Expect(0, 917999, '\p{^Bidi_Class=nonspacingmark}', "");
    Expect(0, 917999, '\P{Bidi_Class=nonspacingmark}', "");
    Expect(1, 917999, '\P{^Bidi_Class=nonspacingmark}', "");
    Expect(0, 918000, '\p{Bidi_Class=nonspacingmark}', "");
    Expect(1, 918000, '\p{^Bidi_Class=nonspacingmark}', "");
    Expect(1, 918000, '\P{Bidi_Class=nonspacingmark}', "");
    Expect(0, 918000, '\P{^Bidi_Class=nonspacingmark}', "");
    Expect(1, 917999, '\p{Bidi_Class=-NONSPACING_mark}', "");
    Expect(0, 917999, '\p{^Bidi_Class=-NONSPACING_mark}', "");
    Expect(0, 917999, '\P{Bidi_Class=-NONSPACING_mark}', "");
    Expect(1, 917999, '\P{^Bidi_Class=-NONSPACING_mark}', "");
    Expect(0, 918000, '\p{Bidi_Class=-NONSPACING_mark}', "");
    Expect(1, 918000, '\p{^Bidi_Class=-NONSPACING_mark}', "");
    Expect(1, 918000, '\P{Bidi_Class=-NONSPACING_mark}', "");
    Expect(0, 918000, '\P{^Bidi_Class=-NONSPACING_mark}', "");
    Error('\p{Bc:	_-NSM:=}');
    Error('\P{Bc:	_-NSM:=}');
    Expect(1, 917999, '\p{Bc=nsm}', "");
    Expect(0, 917999, '\p{^Bc=nsm}', "");
    Expect(0, 917999, '\P{Bc=nsm}', "");
    Expect(1, 917999, '\P{^Bc=nsm}', "");
    Expect(0, 918000, '\p{Bc=nsm}', "");
    Expect(1, 918000, '\p{^Bc=nsm}', "");
    Expect(1, 918000, '\P{Bc=nsm}', "");
    Expect(0, 918000, '\P{^Bc=nsm}', "");
    Expect(1, 917999, '\p{Bc= 	NSM}', "");
    Expect(0, 917999, '\p{^Bc= 	NSM}', "");
    Expect(0, 917999, '\P{Bc= 	NSM}', "");
    Expect(1, 917999, '\P{^Bc= 	NSM}', "");
    Expect(0, 918000, '\p{Bc= 	NSM}', "");
    Expect(1, 918000, '\p{^Bc= 	NSM}', "");
    Expect(1, 918000, '\P{Bc= 	NSM}', "");
    Expect(0, 918000, '\P{^Bc= 	NSM}', "");
    Error('\p{Is_Bidi_Class=:= 	Nonspacing_mark}');
    Error('\P{Is_Bidi_Class=:= 	Nonspacing_mark}');
    Expect(1, 917999, '\p{Is_Bidi_Class=nonspacingmark}', "");
    Expect(0, 917999, '\p{^Is_Bidi_Class=nonspacingmark}', "");
    Expect(0, 917999, '\P{Is_Bidi_Class=nonspacingmark}', "");
    Expect(1, 917999, '\P{^Is_Bidi_Class=nonspacingmark}', "");
    Expect(0, 918000, '\p{Is_Bidi_Class=nonspacingmark}', "");
    Expect(1, 918000, '\p{^Is_Bidi_Class=nonspacingmark}', "");
    Expect(1, 918000, '\P{Is_Bidi_Class=nonspacingmark}', "");
    Expect(0, 918000, '\P{^Is_Bidi_Class=nonspacingmark}', "");
    Expect(1, 917999, '\p{Is_Bidi_Class=--nonspacing_Mark}', "");
    Expect(0, 917999, '\p{^Is_Bidi_Class=--nonspacing_Mark}', "");
    Expect(0, 917999, '\P{Is_Bidi_Class=--nonspacing_Mark}', "");
    Expect(1, 917999, '\P{^Is_Bidi_Class=--nonspacing_Mark}', "");
    Expect(0, 918000, '\p{Is_Bidi_Class=--nonspacing_Mark}', "");
    Expect(1, 918000, '\p{^Is_Bidi_Class=--nonspacing_Mark}', "");
    Expect(1, 918000, '\P{Is_Bidi_Class=--nonspacing_Mark}', "");
    Expect(0, 918000, '\P{^Is_Bidi_Class=--nonspacing_Mark}', "");
    Error('\p{Is_Bc=NSM/a/}');
    Error('\P{Is_Bc=NSM/a/}');
    Expect(1, 917999, '\p{Is_Bc=nsm}', "");
    Expect(0, 917999, '\p{^Is_Bc=nsm}', "");
    Expect(0, 917999, '\P{Is_Bc=nsm}', "");
    Expect(1, 917999, '\P{^Is_Bc=nsm}', "");
    Expect(0, 918000, '\p{Is_Bc=nsm}', "");
    Expect(1, 918000, '\p{^Is_Bc=nsm}', "");
    Expect(1, 918000, '\P{Is_Bc=nsm}', "");
    Expect(0, 918000, '\P{^Is_Bc=nsm}', "");
    Expect(1, 917999, '\p{Is_Bc=--NSM}', "");
    Expect(0, 917999, '\p{^Is_Bc=--NSM}', "");
    Expect(0, 917999, '\P{Is_Bc=--NSM}', "");
    Expect(1, 917999, '\P{^Is_Bc=--NSM}', "");
    Expect(0, 918000, '\p{Is_Bc=--NSM}', "");
    Expect(1, 918000, '\p{^Is_Bc=--NSM}', "");
    Expect(1, 918000, '\P{Is_Bc=--NSM}', "");
    Expect(0, 918000, '\P{^Is_Bc=--NSM}', "");
    Error('\p{Bidi_Class:	  OTHER_neutral/a/}');
    Error('\P{Bidi_Class:	  OTHER_neutral/a/}');
    Expect(1, 129510, '\p{Bidi_Class=otherneutral}', "");
    Expect(0, 129510, '\p{^Bidi_Class=otherneutral}', "");
    Expect(0, 129510, '\P{Bidi_Class=otherneutral}', "");
    Expect(1, 129510, '\P{^Bidi_Class=otherneutral}', "");
    Expect(0, 129511, '\p{Bidi_Class=otherneutral}', "");
    Expect(1, 129511, '\p{^Bidi_Class=otherneutral}', "");
    Expect(1, 129511, '\P{Bidi_Class=otherneutral}', "");
    Expect(0, 129511, '\P{^Bidi_Class=otherneutral}', "");
    Expect(1, 129510, '\p{Bidi_Class=-	Other_Neutral}', "");
    Expect(0, 129510, '\p{^Bidi_Class=-	Other_Neutral}', "");
    Expect(0, 129510, '\P{Bidi_Class=-	Other_Neutral}', "");
    Expect(1, 129510, '\P{^Bidi_Class=-	Other_Neutral}', "");
    Expect(0, 129511, '\p{Bidi_Class=-	Other_Neutral}', "");
    Expect(1, 129511, '\p{^Bidi_Class=-	Other_Neutral}', "");
    Expect(1, 129511, '\P{Bidi_Class=-	Other_Neutral}', "");
    Expect(0, 129511, '\P{^Bidi_Class=-	Other_Neutral}', "");
    Error('\p{Bc=:=  ON}');
    Error('\P{Bc=:=  ON}');
    Expect(1, 129510, '\p{Bc=on}', "");
    Expect(0, 129510, '\p{^Bc=on}', "");
    Expect(0, 129510, '\P{Bc=on}', "");
    Expect(1, 129510, '\P{^Bc=on}', "");
    Expect(0, 129511, '\p{Bc=on}', "");
    Expect(1, 129511, '\p{^Bc=on}', "");
    Expect(1, 129511, '\P{Bc=on}', "");
    Expect(0, 129511, '\P{^Bc=on}', "");
    Expect(1, 129510, '\p{Bc=- ON}', "");
    Expect(0, 129510, '\p{^Bc=- ON}', "");
    Expect(0, 129510, '\P{Bc=- ON}', "");
    Expect(1, 129510, '\P{^Bc=- ON}', "");
    Expect(0, 129511, '\p{Bc=- ON}', "");
    Expect(1, 129511, '\p{^Bc=- ON}', "");
    Expect(1, 129511, '\P{Bc=- ON}', "");
    Expect(0, 129511, '\P{^Bc=- ON}', "");
    Error('\p{Is_Bidi_Class=	/a/other_NEUTRAL}');
    Error('\P{Is_Bidi_Class=	/a/other_NEUTRAL}');
    Expect(1, 129510, '\p{Is_Bidi_Class=otherneutral}', "");
    Expect(0, 129510, '\p{^Is_Bidi_Class=otherneutral}', "");
    Expect(0, 129510, '\P{Is_Bidi_Class=otherneutral}', "");
    Expect(1, 129510, '\P{^Is_Bidi_Class=otherneutral}', "");
    Expect(0, 129511, '\p{Is_Bidi_Class=otherneutral}', "");
    Expect(1, 129511, '\p{^Is_Bidi_Class=otherneutral}', "");
    Expect(1, 129511, '\P{Is_Bidi_Class=otherneutral}', "");
    Expect(0, 129511, '\P{^Is_Bidi_Class=otherneutral}', "");
    Expect(1, 129510, '\p{Is_Bidi_Class=	 other_Neutral}', "");
    Expect(0, 129510, '\p{^Is_Bidi_Class=	 other_Neutral}', "");
    Expect(0, 129510, '\P{Is_Bidi_Class=	 other_Neutral}', "");
    Expect(1, 129510, '\P{^Is_Bidi_Class=	 other_Neutral}', "");
    Expect(0, 129511, '\p{Is_Bidi_Class=	 other_Neutral}', "");
    Expect(1, 129511, '\p{^Is_Bidi_Class=	 other_Neutral}', "");
    Expect(1, 129511, '\P{Is_Bidi_Class=	 other_Neutral}', "");
    Expect(0, 129511, '\P{^Is_Bidi_Class=	 other_Neutral}', "");
    Error('\p{Is_Bc=_/a/ON}');
    Error('\P{Is_Bc=_/a/ON}');
    Expect(1, 129510, '\p{Is_Bc=on}', "");
    Expect(0, 129510, '\p{^Is_Bc=on}', "");
    Expect(0, 129510, '\P{Is_Bc=on}', "");
    Expect(1, 129510, '\P{^Is_Bc=on}', "");
    Expect(0, 129511, '\p{Is_Bc=on}', "");
    Expect(1, 129511, '\p{^Is_Bc=on}', "");
    Expect(1, 129511, '\P{Is_Bc=on}', "");
    Expect(0, 129511, '\P{^Is_Bc=on}', "");
    Expect(1, 129510, '\p{Is_Bc=_ON}', "");
    Expect(0, 129510, '\p{^Is_Bc=_ON}', "");
    Expect(0, 129510, '\P{Is_Bc=_ON}', "");
    Expect(1, 129510, '\P{^Is_Bc=_ON}', "");
    Expect(0, 129511, '\p{Is_Bc=_ON}', "");
    Expect(1, 129511, '\p{^Is_Bc=_ON}', "");
    Expect(1, 129511, '\P{Is_Bc=_ON}', "");
    Expect(0, 129511, '\P{^Is_Bc=_ON}', "");
    Error('\p{Bidi_Class=_	Pop_DIRECTIONAL_Format:=}');
    Error('\P{Bidi_Class=_	Pop_DIRECTIONAL_Format:=}');
    Expect(1, 8236, '\p{Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8236, '\p{^Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8236, '\P{Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8236, '\P{^Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8237, '\p{Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8237, '\p{^Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8237, '\P{Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8237, '\P{^Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8236, '\p{Bidi_Class=	Pop_Directional_FORMAT}', "");
    Expect(0, 8236, '\p{^Bidi_Class=	Pop_Directional_FORMAT}', "");
    Expect(0, 8236, '\P{Bidi_Class=	Pop_Directional_FORMAT}', "");
    Expect(1, 8236, '\P{^Bidi_Class=	Pop_Directional_FORMAT}', "");
    Expect(0, 8237, '\p{Bidi_Class=	Pop_Directional_FORMAT}', "");
    Expect(1, 8237, '\p{^Bidi_Class=	Pop_Directional_FORMAT}', "");
    Expect(1, 8237, '\P{Bidi_Class=	Pop_Directional_FORMAT}', "");
    Expect(0, 8237, '\P{^Bidi_Class=	Pop_Directional_FORMAT}', "");
    Error('\p{Bc:/a/_PDF}');
    Error('\P{Bc:/a/_PDF}');
    Expect(1, 8236, '\p{Bc=pdf}', "");
    Expect(0, 8236, '\p{^Bc=pdf}', "");
    Expect(0, 8236, '\P{Bc=pdf}', "");
    Expect(1, 8236, '\P{^Bc=pdf}', "");
    Expect(0, 8237, '\p{Bc=pdf}', "");
    Expect(1, 8237, '\p{^Bc=pdf}', "");
    Expect(1, 8237, '\P{Bc=pdf}', "");
    Expect(0, 8237, '\P{^Bc=pdf}', "");
    Expect(1, 8236, '\p{Bc=_	PDF}', "");
    Expect(0, 8236, '\p{^Bc=_	PDF}', "");
    Expect(0, 8236, '\P{Bc=_	PDF}', "");
    Expect(1, 8236, '\P{^Bc=_	PDF}', "");
    Expect(0, 8237, '\p{Bc=_	PDF}', "");
    Expect(1, 8237, '\p{^Bc=_	PDF}', "");
    Expect(1, 8237, '\P{Bc=_	PDF}', "");
    Expect(0, 8237, '\P{^Bc=_	PDF}', "");
    Error('\p{Is_Bidi_Class=_:=POP_directional_format}');
    Error('\P{Is_Bidi_Class=_:=POP_directional_format}');
    Expect(1, 8236, '\p{Is_Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8236, '\p{^Is_Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8236, '\P{Is_Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8236, '\P{^Is_Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8237, '\p{Is_Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8237, '\p{^Is_Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8237, '\P{Is_Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8237, '\P{^Is_Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8236, '\p{Is_Bidi_Class=	 pop_DIRECTIONAL_format}', "");
    Expect(0, 8236, '\p{^Is_Bidi_Class=	 pop_DIRECTIONAL_format}', "");
    Expect(0, 8236, '\P{Is_Bidi_Class=	 pop_DIRECTIONAL_format}', "");
    Expect(1, 8236, '\P{^Is_Bidi_Class=	 pop_DIRECTIONAL_format}', "");
    Expect(0, 8237, '\p{Is_Bidi_Class=	 pop_DIRECTIONAL_format}', "");
    Expect(1, 8237, '\p{^Is_Bidi_Class=	 pop_DIRECTIONAL_format}', "");
    Expect(1, 8237, '\P{Is_Bidi_Class=	 pop_DIRECTIONAL_format}', "");
    Expect(0, 8237, '\P{^Is_Bidi_Class=	 pop_DIRECTIONAL_format}', "");
    Error('\p{Is_Bc=:= 	PDF}');
    Error('\P{Is_Bc=:= 	PDF}');
    Expect(1, 8236, '\p{Is_Bc=pdf}', "");
    Expect(0, 8236, '\p{^Is_Bc=pdf}', "");
    Expect(0, 8236, '\P{Is_Bc=pdf}', "");
    Expect(1, 8236, '\P{^Is_Bc=pdf}', "");
    Expect(0, 8237, '\p{Is_Bc=pdf}', "");
    Expect(1, 8237, '\p{^Is_Bc=pdf}', "");
    Expect(1, 8237, '\P{Is_Bc=pdf}', "");
    Expect(0, 8237, '\P{^Is_Bc=pdf}', "");
    Expect(1, 8236, '\p{Is_Bc=		PDF}', "");
    Expect(0, 8236, '\p{^Is_Bc=		PDF}', "");
    Expect(0, 8236, '\P{Is_Bc=		PDF}', "");
    Expect(1, 8236, '\P{^Is_Bc=		PDF}', "");
    Expect(0, 8237, '\p{Is_Bc=		PDF}', "");
    Expect(1, 8237, '\p{^Is_Bc=		PDF}', "");
    Expect(1, 8237, '\P{Is_Bc=		PDF}', "");
    Expect(0, 8237, '\P{^Is_Bc=		PDF}', "");
    Error('\p{Bidi_Class=/a/	pop_Directional_isolate}');
    Error('\P{Bidi_Class=/a/	pop_Directional_isolate}');
    Expect(1, 8297, '\p{Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8297, '\p{^Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8297, '\P{Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8297, '\P{^Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8298, '\p{Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8298, '\p{^Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8298, '\P{Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8298, '\P{^Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8297, '\p{Bidi_Class=_ Pop_Directional_ISOLATE}', "");
    Expect(0, 8297, '\p{^Bidi_Class=_ Pop_Directional_ISOLATE}', "");
    Expect(0, 8297, '\P{Bidi_Class=_ Pop_Directional_ISOLATE}', "");
    Expect(1, 8297, '\P{^Bidi_Class=_ Pop_Directional_ISOLATE}', "");
    Expect(0, 8298, '\p{Bidi_Class=_ Pop_Directional_ISOLATE}', "");
    Expect(1, 8298, '\p{^Bidi_Class=_ Pop_Directional_ISOLATE}', "");
    Expect(1, 8298, '\P{Bidi_Class=_ Pop_Directional_ISOLATE}', "");
    Expect(0, 8298, '\P{^Bidi_Class=_ Pop_Directional_ISOLATE}', "");
    Error('\p{Bc= pdi/a/}');
    Error('\P{Bc= pdi/a/}');
    Expect(1, 8297, '\p{Bc=pdi}', "");
    Expect(0, 8297, '\p{^Bc=pdi}', "");
    Expect(0, 8297, '\P{Bc=pdi}', "");
    Expect(1, 8297, '\P{^Bc=pdi}', "");
    Expect(0, 8298, '\p{Bc=pdi}', "");
    Expect(1, 8298, '\p{^Bc=pdi}', "");
    Expect(1, 8298, '\P{Bc=pdi}', "");
    Expect(0, 8298, '\P{^Bc=pdi}', "");
    Expect(1, 8297, '\p{Bc= PDI}', "");
    Expect(0, 8297, '\p{^Bc= PDI}', "");
    Expect(0, 8297, '\P{Bc= PDI}', "");
    Expect(1, 8297, '\P{^Bc= PDI}', "");
    Expect(0, 8298, '\p{Bc= PDI}', "");
    Expect(1, 8298, '\p{^Bc= PDI}', "");
    Expect(1, 8298, '\P{Bc= PDI}', "");
    Expect(0, 8298, '\P{^Bc= PDI}', "");
    Error('\p{Is_Bidi_Class= POP_Directional_isolate:=}');
    Error('\P{Is_Bidi_Class= POP_Directional_isolate:=}');
    Expect(1, 8297, '\p{Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8297, '\p{^Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8297, '\P{Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8297, '\P{^Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8298, '\p{Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8298, '\p{^Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8298, '\P{Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8298, '\P{^Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8297, '\p{Is_Bidi_Class:_Pop_DIRECTIONAL_isolate}', "");
    Expect(0, 8297, '\p{^Is_Bidi_Class:_Pop_DIRECTIONAL_isolate}', "");
    Expect(0, 8297, '\P{Is_Bidi_Class:_Pop_DIRECTIONAL_isolate}', "");
    Expect(1, 8297, '\P{^Is_Bidi_Class:_Pop_DIRECTIONAL_isolate}', "");
    Expect(0, 8298, '\p{Is_Bidi_Class:_Pop_DIRECTIONAL_isolate}', "");
    Expect(1, 8298, '\p{^Is_Bidi_Class:_Pop_DIRECTIONAL_isolate}', "");
    Expect(1, 8298, '\P{Is_Bidi_Class:_Pop_DIRECTIONAL_isolate}', "");
    Expect(0, 8298, '\P{^Is_Bidi_Class:_Pop_DIRECTIONAL_isolate}', "");
    Error('\p{Is_Bc=:=_-PDI}');
    Error('\P{Is_Bc=:=_-PDI}');
    Expect(1, 8297, '\p{Is_Bc=pdi}', "");
    Expect(0, 8297, '\p{^Is_Bc=pdi}', "");
    Expect(0, 8297, '\P{Is_Bc=pdi}', "");
    Expect(1, 8297, '\P{^Is_Bc=pdi}', "");
    Expect(0, 8298, '\p{Is_Bc=pdi}', "");
    Expect(1, 8298, '\p{^Is_Bc=pdi}', "");
    Expect(1, 8298, '\P{Is_Bc=pdi}', "");
    Expect(0, 8298, '\P{^Is_Bc=pdi}', "");
    Expect(1, 8297, '\p{Is_Bc=-_pdi}', "");
    Expect(0, 8297, '\p{^Is_Bc=-_pdi}', "");
    Expect(0, 8297, '\P{Is_Bc=-_pdi}', "");
    Expect(1, 8297, '\P{^Is_Bc=-_pdi}', "");
    Expect(0, 8298, '\p{Is_Bc=-_pdi}', "");
    Expect(1, 8298, '\p{^Is_Bc=-_pdi}', "");
    Expect(1, 8298, '\P{Is_Bc=-_pdi}', "");
    Expect(0, 8298, '\P{^Is_Bc=-_pdi}', "");
    Error('\p{Bidi_Class=	/a/right_To_LEFT}');
    Error('\P{Bidi_Class=	/a/right_To_LEFT}');
    Expect(1, 126975, '\p{Bidi_Class=righttoleft}', "");
    Expect(0, 126975, '\p{^Bidi_Class=righttoleft}', "");
    Expect(0, 126975, '\P{Bidi_Class=righttoleft}', "");
    Expect(1, 126975, '\P{^Bidi_Class=righttoleft}', "");
    Expect(0, 126976, '\p{Bidi_Class=righttoleft}', "");
    Expect(1, 126976, '\p{^Bidi_Class=righttoleft}', "");
    Expect(1, 126976, '\P{Bidi_Class=righttoleft}', "");
    Expect(0, 126976, '\P{^Bidi_Class=righttoleft}', "");
    Expect(1, 126975, '\p{Bidi_Class= right_To_left}', "");
    Expect(0, 126975, '\p{^Bidi_Class= right_To_left}', "");
    Expect(0, 126975, '\P{Bidi_Class= right_To_left}', "");
    Expect(1, 126975, '\P{^Bidi_Class= right_To_left}', "");
    Expect(0, 126976, '\p{Bidi_Class= right_To_left}', "");
    Expect(1, 126976, '\p{^Bidi_Class= right_To_left}', "");
    Expect(1, 126976, '\P{Bidi_Class= right_To_left}', "");
    Expect(0, 126976, '\P{^Bidi_Class= right_To_left}', "");
    Error('\p{Bc=:=R}');
    Error('\P{Bc=:=R}');
    Expect(1, 126975, '\p{Bc=r}', "");
    Expect(0, 126975, '\p{^Bc=r}', "");
    Expect(0, 126975, '\P{Bc=r}', "");
    Expect(1, 126975, '\P{^Bc=r}', "");
    Expect(0, 126976, '\p{Bc=r}', "");
    Expect(1, 126976, '\p{^Bc=r}', "");
    Expect(1, 126976, '\P{Bc=r}', "");
    Expect(0, 126976, '\P{^Bc=r}', "");
    Expect(1, 126975, '\p{Bc=	-R}', "");
    Expect(0, 126975, '\p{^Bc=	-R}', "");
    Expect(0, 126975, '\P{Bc=	-R}', "");
    Expect(1, 126975, '\P{^Bc=	-R}', "");
    Expect(0, 126976, '\p{Bc=	-R}', "");
    Expect(1, 126976, '\p{^Bc=	-R}', "");
    Expect(1, 126976, '\P{Bc=	-R}', "");
    Expect(0, 126976, '\P{^Bc=	-R}', "");
    Error('\p{Is_Bidi_Class=/a/ _Right_to_left}');
    Error('\P{Is_Bidi_Class=/a/ _Right_to_left}');
    Expect(1, 126975, '\p{Is_Bidi_Class:righttoleft}', "");
    Expect(0, 126975, '\p{^Is_Bidi_Class:righttoleft}', "");
    Expect(0, 126975, '\P{Is_Bidi_Class:righttoleft}', "");
    Expect(1, 126975, '\P{^Is_Bidi_Class:righttoleft}', "");
    Expect(0, 126976, '\p{Is_Bidi_Class:righttoleft}', "");
    Expect(1, 126976, '\p{^Is_Bidi_Class:righttoleft}', "");
    Expect(1, 126976, '\P{Is_Bidi_Class:righttoleft}', "");
    Expect(0, 126976, '\P{^Is_Bidi_Class:righttoleft}', "");
    Expect(1, 126975, '\p{Is_Bidi_Class=_Right_to_left}', "");
    Expect(0, 126975, '\p{^Is_Bidi_Class=_Right_to_left}', "");
    Expect(0, 126975, '\P{Is_Bidi_Class=_Right_to_left}', "");
    Expect(1, 126975, '\P{^Is_Bidi_Class=_Right_to_left}', "");
    Expect(0, 126976, '\p{Is_Bidi_Class=_Right_to_left}', "");
    Expect(1, 126976, '\p{^Is_Bidi_Class=_Right_to_left}', "");
    Expect(1, 126976, '\P{Is_Bidi_Class=_Right_to_left}', "");
    Expect(0, 126976, '\P{^Is_Bidi_Class=_Right_to_left}', "");
    Error('\p{Is_Bc=	-r:=}');
    Error('\P{Is_Bc=	-r:=}');
    Expect(1, 126975, '\p{Is_Bc=r}', "");
    Expect(0, 126975, '\p{^Is_Bc=r}', "");
    Expect(0, 126975, '\P{Is_Bc=r}', "");
    Expect(1, 126975, '\P{^Is_Bc=r}', "");
    Expect(0, 126976, '\p{Is_Bc=r}', "");
    Expect(1, 126976, '\p{^Is_Bc=r}', "");
    Expect(1, 126976, '\P{Is_Bc=r}', "");
    Expect(0, 126976, '\P{^Is_Bc=r}', "");
    Expect(1, 126975, '\p{Is_Bc=R}', "");
    Expect(0, 126975, '\p{^Is_Bc=R}', "");
    Expect(0, 126975, '\P{Is_Bc=R}', "");
    Expect(1, 126975, '\P{^Is_Bc=R}', "");
    Expect(0, 126976, '\p{Is_Bc=R}', "");
    Expect(1, 126976, '\p{^Is_Bc=R}', "");
    Expect(1, 126976, '\P{Is_Bc=R}', "");
    Expect(0, 126976, '\P{^Is_Bc=R}', "");
    Error('\p{Bidi_Class=/a/-	Right_To_Left_Embedding}');
    Error('\P{Bidi_Class=/a/-	Right_To_Left_Embedding}');
    Expect(1, 8235, '\p{Bidi_Class:righttoleftembedding}', "");
    Expect(0, 8235, '\p{^Bidi_Class:righttoleftembedding}', "");
    Expect(0, 8235, '\P{Bidi_Class:righttoleftembedding}', "");
    Expect(1, 8235, '\P{^Bidi_Class:righttoleftembedding}', "");
    Expect(0, 8236, '\p{Bidi_Class:righttoleftembedding}', "");
    Expect(1, 8236, '\p{^Bidi_Class:righttoleftembedding}', "");
    Expect(1, 8236, '\P{Bidi_Class:righttoleftembedding}', "");
    Expect(0, 8236, '\P{^Bidi_Class:righttoleftembedding}', "");
    Expect(1, 8235, '\p{Bidi_Class= Right_to_LEFT_EMBEDDING}', "");
    Expect(0, 8235, '\p{^Bidi_Class= Right_to_LEFT_EMBEDDING}', "");
    Expect(0, 8235, '\P{Bidi_Class= Right_to_LEFT_EMBEDDING}', "");
    Expect(1, 8235, '\P{^Bidi_Class= Right_to_LEFT_EMBEDDING}', "");
    Expect(0, 8236, '\p{Bidi_Class= Right_to_LEFT_EMBEDDING}', "");
    Expect(1, 8236, '\p{^Bidi_Class= Right_to_LEFT_EMBEDDING}', "");
    Expect(1, 8236, '\P{Bidi_Class= Right_to_LEFT_EMBEDDING}', "");
    Expect(0, 8236, '\P{^Bidi_Class= Right_to_LEFT_EMBEDDING}', "");
    Error('\p{Bc=:=	 RLE}');
    Error('\P{Bc=:=	 RLE}');
    Expect(1, 8235, '\p{Bc=rle}', "");
    Expect(0, 8235, '\p{^Bc=rle}', "");
    Expect(0, 8235, '\P{Bc=rle}', "");
    Expect(1, 8235, '\P{^Bc=rle}', "");
    Expect(0, 8236, '\p{Bc=rle}', "");
    Expect(1, 8236, '\p{^Bc=rle}', "");
    Expect(1, 8236, '\P{Bc=rle}', "");
    Expect(0, 8236, '\P{^Bc=rle}', "");
    Expect(1, 8235, '\p{Bc= 	RLE}', "");
    Expect(0, 8235, '\p{^Bc= 	RLE}', "");
    Expect(0, 8235, '\P{Bc= 	RLE}', "");
    Expect(1, 8235, '\P{^Bc= 	RLE}', "");
    Expect(0, 8236, '\p{Bc= 	RLE}', "");
    Expect(1, 8236, '\p{^Bc= 	RLE}', "");
    Expect(1, 8236, '\P{Bc= 	RLE}', "");
    Expect(0, 8236, '\P{^Bc= 	RLE}', "");
    Error('\p{Is_Bidi_Class=:=	right_to_Left_Embedding}');
    Error('\P{Is_Bidi_Class=:=	right_to_Left_Embedding}');
    Expect(1, 8235, '\p{Is_Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8235, '\p{^Is_Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8235, '\P{Is_Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8235, '\P{^Is_Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8236, '\p{Is_Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8236, '\p{^Is_Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8236, '\P{Is_Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8236, '\P{^Is_Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8235, '\p{Is_Bidi_Class=-Right_To_LEFT_embedding}', "");
    Expect(0, 8235, '\p{^Is_Bidi_Class=-Right_To_LEFT_embedding}', "");
    Expect(0, 8235, '\P{Is_Bidi_Class=-Right_To_LEFT_embedding}', "");
    Expect(1, 8235, '\P{^Is_Bidi_Class=-Right_To_LEFT_embedding}', "");
    Expect(0, 8236, '\p{Is_Bidi_Class=-Right_To_LEFT_embedding}', "");
    Expect(1, 8236, '\p{^Is_Bidi_Class=-Right_To_LEFT_embedding}', "");
    Expect(1, 8236, '\P{Is_Bidi_Class=-Right_To_LEFT_embedding}', "");
    Expect(0, 8236, '\P{^Is_Bidi_Class=-Right_To_LEFT_embedding}', "");
    Error('\p{Is_Bc=/a/_ RLE}');
    Error('\P{Is_Bc=/a/_ RLE}');
    Expect(1, 8235, '\p{Is_Bc=rle}', "");
    Expect(0, 8235, '\p{^Is_Bc=rle}', "");
    Expect(0, 8235, '\P{Is_Bc=rle}', "");
    Expect(1, 8235, '\P{^Is_Bc=rle}', "");
    Expect(0, 8236, '\p{Is_Bc=rle}', "");
    Expect(1, 8236, '\p{^Is_Bc=rle}', "");
    Expect(1, 8236, '\P{Is_Bc=rle}', "");
    Expect(0, 8236, '\P{^Is_Bc=rle}', "");
    Expect(1, 8235, '\p{Is_Bc:			RLE}', "");
    Expect(0, 8235, '\p{^Is_Bc:			RLE}', "");
    Expect(0, 8235, '\P{Is_Bc:			RLE}', "");
    Expect(1, 8235, '\P{^Is_Bc:			RLE}', "");
    Expect(0, 8236, '\p{Is_Bc:			RLE}', "");
    Expect(1, 8236, '\p{^Is_Bc:			RLE}', "");
    Expect(1, 8236, '\P{Is_Bc:			RLE}', "");
    Expect(0, 8236, '\P{^Is_Bc:			RLE}', "");
    Error('\p{Bidi_Class=:= Right_TO_left_Isolate}');
    Error('\P{Bidi_Class=:= Right_TO_left_Isolate}');
    Expect(1, 8295, '\p{Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8295, '\p{^Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8295, '\P{Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8295, '\P{^Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8296, '\p{Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8296, '\p{^Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8296, '\P{Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8296, '\P{^Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8295, '\p{Bidi_Class=-Right_TO_LEFT_Isolate}', "");
    Expect(0, 8295, '\p{^Bidi_Class=-Right_TO_LEFT_Isolate}', "");
    Expect(0, 8295, '\P{Bidi_Class=-Right_TO_LEFT_Isolate}', "");
    Expect(1, 8295, '\P{^Bidi_Class=-Right_TO_LEFT_Isolate}', "");
    Expect(0, 8296, '\p{Bidi_Class=-Right_TO_LEFT_Isolate}', "");
    Expect(1, 8296, '\p{^Bidi_Class=-Right_TO_LEFT_Isolate}', "");
    Expect(1, 8296, '\P{Bidi_Class=-Right_TO_LEFT_Isolate}', "");
    Expect(0, 8296, '\P{^Bidi_Class=-Right_TO_LEFT_Isolate}', "");
    Error('\p{Bc=/a/ RLI}');
    Error('\P{Bc=/a/ RLI}');
    Expect(1, 8295, '\p{Bc=rli}', "");
    Expect(0, 8295, '\p{^Bc=rli}', "");
    Expect(0, 8295, '\P{Bc=rli}', "");
    Expect(1, 8295, '\P{^Bc=rli}', "");
    Expect(0, 8296, '\p{Bc=rli}', "");
    Expect(1, 8296, '\p{^Bc=rli}', "");
    Expect(1, 8296, '\P{Bc=rli}', "");
    Expect(0, 8296, '\P{^Bc=rli}', "");
    Expect(1, 8295, '\p{Bc= 	RLI}', "");
    Expect(0, 8295, '\p{^Bc= 	RLI}', "");
    Expect(0, 8295, '\P{Bc= 	RLI}', "");
    Expect(1, 8295, '\P{^Bc= 	RLI}', "");
    Expect(0, 8296, '\p{Bc= 	RLI}', "");
    Expect(1, 8296, '\p{^Bc= 	RLI}', "");
    Expect(1, 8296, '\P{Bc= 	RLI}', "");
    Expect(0, 8296, '\P{^Bc= 	RLI}', "");
    Error('\p{Is_Bidi_Class= 	Right_TO_left_Isolate/a/}');
    Error('\P{Is_Bidi_Class= 	Right_TO_left_Isolate/a/}');
    Expect(1, 8295, '\p{Is_Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8295, '\p{^Is_Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8295, '\P{Is_Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8295, '\P{^Is_Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8296, '\p{Is_Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8296, '\p{^Is_Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8296, '\P{Is_Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8296, '\P{^Is_Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8295, '\p{Is_Bidi_Class=__Right_to_LEFT_Isolate}', "");
    Expect(0, 8295, '\p{^Is_Bidi_Class=__Right_to_LEFT_Isolate}', "");
    Expect(0, 8295, '\P{Is_Bidi_Class=__Right_to_LEFT_Isolate}', "");
    Expect(1, 8295, '\P{^Is_Bidi_Class=__Right_to_LEFT_Isolate}', "");
    Expect(0, 8296, '\p{Is_Bidi_Class=__Right_to_LEFT_Isolate}', "");
    Expect(1, 8296, '\p{^Is_Bidi_Class=__Right_to_LEFT_Isolate}', "");
    Expect(1, 8296, '\P{Is_Bidi_Class=__Right_to_LEFT_Isolate}', "");
    Expect(0, 8296, '\P{^Is_Bidi_Class=__Right_to_LEFT_Isolate}', "");
    Error('\p{Is_Bc=  RLI:=}');
    Error('\P{Is_Bc=  RLI:=}');
    Expect(1, 8295, '\p{Is_Bc=rli}', "");
    Expect(0, 8295, '\p{^Is_Bc=rli}', "");
    Expect(0, 8295, '\P{Is_Bc=rli}', "");
    Expect(1, 8295, '\P{^Is_Bc=rli}', "");
    Expect(0, 8296, '\p{Is_Bc=rli}', "");
    Expect(1, 8296, '\p{^Is_Bc=rli}', "");
    Expect(1, 8296, '\P{Is_Bc=rli}', "");
    Expect(0, 8296, '\P{^Is_Bc=rli}', "");
    Expect(1, 8295, '\p{Is_Bc= -RLI}', "");
    Expect(0, 8295, '\p{^Is_Bc= -RLI}', "");
    Expect(0, 8295, '\P{Is_Bc= -RLI}', "");
    Expect(1, 8295, '\P{^Is_Bc= -RLI}', "");
    Expect(0, 8296, '\p{Is_Bc= -RLI}', "");
    Expect(1, 8296, '\p{^Is_Bc= -RLI}', "");
    Expect(1, 8296, '\P{Is_Bc= -RLI}', "");
    Expect(0, 8296, '\P{^Is_Bc= -RLI}', "");
    Error('\p{Bidi_Class:	 	right_To_Left_OVERRIDE:=}');
    Error('\P{Bidi_Class:	 	right_To_Left_OVERRIDE:=}');
    Expect(1, 8238, '\p{Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8238, '\p{^Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8238, '\P{Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8238, '\P{^Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8239, '\p{Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8239, '\p{^Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8239, '\P{Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8239, '\P{^Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8238, '\p{Bidi_Class=__Right_To_left_Override}', "");
    Expect(0, 8238, '\p{^Bidi_Class=__Right_To_left_Override}', "");
    Expect(0, 8238, '\P{Bidi_Class=__Right_To_left_Override}', "");
    Expect(1, 8238, '\P{^Bidi_Class=__Right_To_left_Override}', "");
    Expect(0, 8239, '\p{Bidi_Class=__Right_To_left_Override}', "");
    Expect(1, 8239, '\p{^Bidi_Class=__Right_To_left_Override}', "");
    Expect(1, 8239, '\P{Bidi_Class=__Right_To_left_Override}', "");
    Expect(0, 8239, '\P{^Bidi_Class=__Right_To_left_Override}', "");
    Error('\p{Bc=-/a/RLO}');
    Error('\P{Bc=-/a/RLO}');
    Expect(1, 8238, '\p{Bc=rlo}', "");
    Expect(0, 8238, '\p{^Bc=rlo}', "");
    Expect(0, 8238, '\P{Bc=rlo}', "");
    Expect(1, 8238, '\P{^Bc=rlo}', "");
    Expect(0, 8239, '\p{Bc=rlo}', "");
    Expect(1, 8239, '\p{^Bc=rlo}', "");
    Expect(1, 8239, '\P{Bc=rlo}', "");
    Expect(0, 8239, '\P{^Bc=rlo}', "");
    Expect(1, 8238, '\p{Bc= RLO}', "");
    Expect(0, 8238, '\p{^Bc= RLO}', "");
    Expect(0, 8238, '\P{Bc= RLO}', "");
    Expect(1, 8238, '\P{^Bc= RLO}', "");
    Expect(0, 8239, '\p{Bc= RLO}', "");
    Expect(1, 8239, '\p{^Bc= RLO}', "");
    Expect(1, 8239, '\P{Bc= RLO}', "");
    Expect(0, 8239, '\P{^Bc= RLO}', "");
    Error('\p{Is_Bidi_Class=:=_ Right_To_Left_override}');
    Error('\P{Is_Bidi_Class=:=_ Right_To_Left_override}');
    Expect(1, 8238, '\p{Is_Bidi_Class:   righttoleftoverride}', "");
    Expect(0, 8238, '\p{^Is_Bidi_Class:   righttoleftoverride}', "");
    Expect(0, 8238, '\P{Is_Bidi_Class:   righttoleftoverride}', "");
    Expect(1, 8238, '\P{^Is_Bidi_Class:   righttoleftoverride}', "");
    Expect(0, 8239, '\p{Is_Bidi_Class:   righttoleftoverride}', "");
    Expect(1, 8239, '\p{^Is_Bidi_Class:   righttoleftoverride}', "");
    Expect(1, 8239, '\P{Is_Bidi_Class:   righttoleftoverride}', "");
    Expect(0, 8239, '\P{^Is_Bidi_Class:   righttoleftoverride}', "");
    Expect(1, 8238, '\p{Is_Bidi_Class= 	Right_To_left_override}', "");
    Expect(0, 8238, '\p{^Is_Bidi_Class= 	Right_To_left_override}', "");
    Expect(0, 8238, '\P{Is_Bidi_Class= 	Right_To_left_override}', "");
    Expect(1, 8238, '\P{^Is_Bidi_Class= 	Right_To_left_override}', "");
    Expect(0, 8239, '\p{Is_Bidi_Class= 	Right_To_left_override}', "");
    Expect(1, 8239, '\p{^Is_Bidi_Class= 	Right_To_left_override}', "");
    Expect(1, 8239, '\P{Is_Bidi_Class= 	Right_To_left_override}', "");
    Expect(0, 8239, '\P{^Is_Bidi_Class= 	Right_To_left_override}', "");
    Error('\p{Is_Bc=	:=RLO}');
    Error('\P{Is_Bc=	:=RLO}');
    Expect(1, 8238, '\p{Is_Bc=rlo}', "");
    Expect(0, 8238, '\p{^Is_Bc=rlo}', "");
    Expect(0, 8238, '\P{Is_Bc=rlo}', "");
    Expect(1, 8238, '\P{^Is_Bc=rlo}', "");
    Expect(0, 8239, '\p{Is_Bc=rlo}', "");
    Expect(1, 8239, '\p{^Is_Bc=rlo}', "");
    Expect(1, 8239, '\P{Is_Bc=rlo}', "");
    Expect(0, 8239, '\P{^Is_Bc=rlo}', "");
    Expect(1, 8238, '\p{Is_Bc=-RLO}', "");
    Expect(0, 8238, '\p{^Is_Bc=-RLO}', "");
    Expect(0, 8238, '\P{Is_Bc=-RLO}', "");
    Expect(1, 8238, '\P{^Is_Bc=-RLO}', "");
    Expect(0, 8239, '\p{Is_Bc=-RLO}', "");
    Expect(1, 8239, '\p{^Is_Bc=-RLO}', "");
    Expect(1, 8239, '\P{Is_Bc=-RLO}', "");
    Expect(0, 8239, '\P{^Is_Bc=-RLO}', "");
    Error('\p{Bidi_Class=	_segment_SEPARATOR/a/}');
    Error('\P{Bidi_Class=	_segment_SEPARATOR/a/}');
    Expect(1, 31, '\p{Bidi_Class=segmentseparator}', "");
    Expect(0, 31, '\p{^Bidi_Class=segmentseparator}', "");
    Expect(0, 31, '\P{Bidi_Class=segmentseparator}', "");
    Expect(1, 31, '\P{^Bidi_Class=segmentseparator}', "");
    Expect(0, 32, '\p{Bidi_Class=segmentseparator}', "");
    Expect(1, 32, '\p{^Bidi_Class=segmentseparator}', "");
    Expect(1, 32, '\P{Bidi_Class=segmentseparator}', "");
    Expect(0, 32, '\P{^Bidi_Class=segmentseparator}', "");
    Expect(1, 31, '\p{Bidi_Class=	 Segment_Separator}', "");
    Expect(0, 31, '\p{^Bidi_Class=	 Segment_Separator}', "");
    Expect(0, 31, '\P{Bidi_Class=	 Segment_Separator}', "");
    Expect(1, 31, '\P{^Bidi_Class=	 Segment_Separator}', "");
    Expect(0, 32, '\p{Bidi_Class=	 Segment_Separator}', "");
    Expect(1, 32, '\p{^Bidi_Class=	 Segment_Separator}', "");
    Expect(1, 32, '\P{Bidi_Class=	 Segment_Separator}', "");
    Expect(0, 32, '\P{^Bidi_Class=	 Segment_Separator}', "");
    Error('\p{Bc=:=_-S}');
    Error('\P{Bc=:=_-S}');
    Expect(1, 31, '\p{Bc=s}', "");
    Expect(0, 31, '\p{^Bc=s}', "");
    Expect(0, 31, '\P{Bc=s}', "");
    Expect(1, 31, '\P{^Bc=s}', "");
    Expect(0, 32, '\p{Bc=s}', "");
    Expect(1, 32, '\p{^Bc=s}', "");
    Expect(1, 32, '\P{Bc=s}', "");
    Expect(0, 32, '\P{^Bc=s}', "");
    Expect(1, 31, '\p{Bc=	S}', "");
    Expect(0, 31, '\p{^Bc=	S}', "");
    Expect(0, 31, '\P{Bc=	S}', "");
    Expect(1, 31, '\P{^Bc=	S}', "");
    Expect(0, 32, '\p{Bc=	S}', "");
    Expect(1, 32, '\p{^Bc=	S}', "");
    Expect(1, 32, '\P{Bc=	S}', "");
    Expect(0, 32, '\P{^Bc=	S}', "");
    Error('\p{Is_Bidi_Class= /a/Segment_Separator}');
    Error('\P{Is_Bidi_Class= /a/Segment_Separator}');
    Expect(1, 31, '\p{Is_Bidi_Class=segmentseparator}', "");
    Expect(0, 31, '\p{^Is_Bidi_Class=segmentseparator}', "");
    Expect(0, 31, '\P{Is_Bidi_Class=segmentseparator}', "");
    Expect(1, 31, '\P{^Is_Bidi_Class=segmentseparator}', "");
    Expect(0, 32, '\p{Is_Bidi_Class=segmentseparator}', "");
    Expect(1, 32, '\p{^Is_Bidi_Class=segmentseparator}', "");
    Expect(1, 32, '\P{Is_Bidi_Class=segmentseparator}', "");
    Expect(0, 32, '\P{^Is_Bidi_Class=segmentseparator}', "");
    Expect(1, 31, '\p{Is_Bidi_Class= Segment_SEPARATOR}', "");
    Expect(0, 31, '\p{^Is_Bidi_Class= Segment_SEPARATOR}', "");
    Expect(0, 31, '\P{Is_Bidi_Class= Segment_SEPARATOR}', "");
    Expect(1, 31, '\P{^Is_Bidi_Class= Segment_SEPARATOR}', "");
    Expect(0, 32, '\p{Is_Bidi_Class= Segment_SEPARATOR}', "");
    Expect(1, 32, '\p{^Is_Bidi_Class= Segment_SEPARATOR}', "");
    Expect(1, 32, '\P{Is_Bidi_Class= Segment_SEPARATOR}', "");
    Expect(0, 32, '\P{^Is_Bidi_Class= Segment_SEPARATOR}', "");
    Error('\p{Is_Bc:  s/a/}');
    Error('\P{Is_Bc:  s/a/}');
    Expect(1, 31, '\p{Is_Bc:s}', "");
    Expect(0, 31, '\p{^Is_Bc:s}', "");
    Expect(0, 31, '\P{Is_Bc:s}', "");
    Expect(1, 31, '\P{^Is_Bc:s}', "");
    Expect(0, 32, '\p{Is_Bc:s}', "");
    Expect(1, 32, '\p{^Is_Bc:s}', "");
    Expect(1, 32, '\P{Is_Bc:s}', "");
    Expect(0, 32, '\P{^Is_Bc:s}', "");
    Expect(1, 31, '\p{Is_Bc=	S}', "");
    Expect(0, 31, '\p{^Is_Bc=	S}', "");
    Expect(0, 31, '\P{Is_Bc=	S}', "");
    Expect(1, 31, '\P{^Is_Bc=	S}', "");
    Expect(0, 32, '\p{Is_Bc=	S}', "");
    Expect(1, 32, '\p{^Is_Bc=	S}', "");
    Expect(1, 32, '\P{Is_Bc=	S}', "");
    Expect(0, 32, '\P{^Is_Bc=	S}', "");
    Error('\p{Bidi_Class=:=white_space}');
    Error('\P{Bidi_Class=:=white_space}');
    Expect(1, 12288, '\p{Bidi_Class=whitespace}', "");
    Expect(0, 12288, '\p{^Bidi_Class=whitespace}', "");
    Expect(0, 12288, '\P{Bidi_Class=whitespace}', "");
    Expect(1, 12288, '\P{^Bidi_Class=whitespace}', "");
    Expect(0, 12289, '\p{Bidi_Class=whitespace}', "");
    Expect(1, 12289, '\p{^Bidi_Class=whitespace}', "");
    Expect(1, 12289, '\P{Bidi_Class=whitespace}', "");
    Expect(0, 12289, '\P{^Bidi_Class=whitespace}', "");
    Expect(1, 12288, '\p{Bidi_Class: __White_space}', "");
    Expect(0, 12288, '\p{^Bidi_Class: __White_space}', "");
    Expect(0, 12288, '\P{Bidi_Class: __White_space}', "");
    Expect(1, 12288, '\P{^Bidi_Class: __White_space}', "");
    Expect(0, 12289, '\p{Bidi_Class: __White_space}', "");
    Expect(1, 12289, '\p{^Bidi_Class: __White_space}', "");
    Expect(1, 12289, '\P{Bidi_Class: __White_space}', "");
    Expect(0, 12289, '\P{^Bidi_Class: __White_space}', "");
    Error('\p{Bc=	ws/a/}');
    Error('\P{Bc=	ws/a/}');
    Expect(1, 12288, '\p{Bc=ws}', "");
    Expect(0, 12288, '\p{^Bc=ws}', "");
    Expect(0, 12288, '\P{Bc=ws}', "");
    Expect(1, 12288, '\P{^Bc=ws}', "");
    Expect(0, 12289, '\p{Bc=ws}', "");
    Expect(1, 12289, '\p{^Bc=ws}', "");
    Expect(1, 12289, '\P{Bc=ws}', "");
    Expect(0, 12289, '\P{^Bc=ws}', "");
    Expect(1, 12288, '\p{Bc= 	WS}', "");
    Expect(0, 12288, '\p{^Bc= 	WS}', "");
    Expect(0, 12288, '\P{Bc= 	WS}', "");
    Expect(1, 12288, '\P{^Bc= 	WS}', "");
    Expect(0, 12289, '\p{Bc= 	WS}', "");
    Expect(1, 12289, '\p{^Bc= 	WS}', "");
    Expect(1, 12289, '\P{Bc= 	WS}', "");
    Expect(0, 12289, '\P{^Bc= 	WS}', "");
    Error('\p{Is_Bidi_Class:		/a/white_Space}');
    Error('\P{Is_Bidi_Class:		/a/white_Space}');
    Expect(1, 12288, '\p{Is_Bidi_Class=whitespace}', "");
    Expect(0, 12288, '\p{^Is_Bidi_Class=whitespace}', "");
    Expect(0, 12288, '\P{Is_Bidi_Class=whitespace}', "");
    Expect(1, 12288, '\P{^Is_Bidi_Class=whitespace}', "");
    Expect(0, 12289, '\p{Is_Bidi_Class=whitespace}', "");
    Expect(1, 12289, '\p{^Is_Bidi_Class=whitespace}', "");
    Expect(1, 12289, '\P{Is_Bidi_Class=whitespace}', "");
    Expect(0, 12289, '\P{^Is_Bidi_Class=whitespace}', "");
    Expect(1, 12288, '\p{Is_Bidi_Class=	white_space}', "");
    Expect(0, 12288, '\p{^Is_Bidi_Class=	white_space}', "");
    Expect(0, 12288, '\P{Is_Bidi_Class=	white_space}', "");
    Expect(1, 12288, '\P{^Is_Bidi_Class=	white_space}', "");
    Expect(0, 12289, '\p{Is_Bidi_Class=	white_space}', "");
    Expect(1, 12289, '\p{^Is_Bidi_Class=	white_space}', "");
    Expect(1, 12289, '\P{Is_Bidi_Class=	white_space}', "");
    Expect(0, 12289, '\P{^Is_Bidi_Class=	white_space}', "");
    Error('\p{Is_Bc=_/a/ws}');
    Error('\P{Is_Bc=_/a/ws}');
    Expect(1, 12288, '\p{Is_Bc=ws}', "");
    Expect(0, 12288, '\p{^Is_Bc=ws}', "");
    Expect(0, 12288, '\P{Is_Bc=ws}', "");
    Expect(1, 12288, '\P{^Is_Bc=ws}', "");
    Expect(0, 12289, '\p{Is_Bc=ws}', "");
    Expect(1, 12289, '\p{^Is_Bc=ws}', "");
    Expect(1, 12289, '\P{Is_Bc=ws}', "");
    Expect(0, 12289, '\P{^Is_Bc=ws}', "");
    Expect(1, 12288, '\p{Is_Bc=	-WS}', "");
    Expect(0, 12288, '\p{^Is_Bc=	-WS}', "");
    Expect(0, 12288, '\P{Is_Bc=	-WS}', "");
    Expect(1, 12288, '\P{^Is_Bc=	-WS}', "");
    Expect(0, 12289, '\p{Is_Bc=	-WS}', "");
    Expect(1, 12289, '\p{^Is_Bc=	-WS}', "");
    Expect(1, 12289, '\P{Is_Bc=	-WS}', "");
    Expect(0, 12289, '\P{^Is_Bc=	-WS}', "");
    Error('\p{Bidi_Control=__No/a/}');
    Error('\P{Bidi_Control=__No/a/}');
    Expect(1, 8298, '\p{Bidi_Control:   no}', "");
    Expect(0, 8298, '\p{^Bidi_Control:   no}', "");
    Expect(0, 8298, '\P{Bidi_Control:   no}', "");
    Expect(1, 8298, '\P{^Bidi_Control:   no}', "");
    Expect(0, 8297, '\p{Bidi_Control:   no}', "");
    Expect(1, 8297, '\p{^Bidi_Control:   no}', "");
    Expect(1, 8297, '\P{Bidi_Control:   no}', "");
    Expect(0, 8297, '\P{^Bidi_Control:   no}', "");
    Expect(1, 8298, '\p{Bidi_Control=- NO}', "");
    Expect(0, 8298, '\p{^Bidi_Control=- NO}', "");
    Expect(0, 8298, '\P{Bidi_Control=- NO}', "");
    Expect(1, 8298, '\P{^Bidi_Control=- NO}', "");
    Expect(0, 8297, '\p{Bidi_Control=- NO}', "");
    Expect(1, 8297, '\p{^Bidi_Control=- NO}', "");
    Expect(1, 8297, '\P{Bidi_Control=- NO}', "");
    Expect(0, 8297, '\P{^Bidi_Control=- NO}', "");
    Error('\p{Bidi_C=	/a/N}');
    Error('\P{Bidi_C=	/a/N}');
    Expect(1, 8298, '\p{Bidi_C=n}', "");
    Expect(0, 8298, '\p{^Bidi_C=n}', "");
    Expect(0, 8298, '\P{Bidi_C=n}', "");
    Expect(1, 8298, '\P{^Bidi_C=n}', "");
    Expect(0, 8297, '\p{Bidi_C=n}', "");
    Expect(1, 8297, '\p{^Bidi_C=n}', "");
    Expect(1, 8297, '\P{Bidi_C=n}', "");
    Expect(0, 8297, '\P{^Bidi_C=n}', "");
    Expect(1, 8298, '\p{Bidi_C:    N}', "");
    Expect(0, 8298, '\p{^Bidi_C:    N}', "");
    Expect(0, 8298, '\P{Bidi_C:    N}', "");
    Expect(1, 8298, '\P{^Bidi_C:    N}', "");
    Expect(0, 8297, '\p{Bidi_C:    N}', "");
    Expect(1, 8297, '\p{^Bidi_C:    N}', "");
    Expect(1, 8297, '\P{Bidi_C:    N}', "");
    Expect(0, 8297, '\P{^Bidi_C:    N}', "");
    Error('\p{Is_Bidi_Control=/a/	_F}');
    Error('\P{Is_Bidi_Control=/a/	_F}');
    Expect(1, 8298, '\p{Is_Bidi_Control=f}', "");
    Expect(0, 8298, '\p{^Is_Bidi_Control=f}', "");
    Expect(0, 8298, '\P{Is_Bidi_Control=f}', "");
    Expect(1, 8298, '\P{^Is_Bidi_Control=f}', "");
    Expect(0, 8297, '\p{Is_Bidi_Control=f}', "");
    Expect(1, 8297, '\p{^Is_Bidi_Control=f}', "");
    Expect(1, 8297, '\P{Is_Bidi_Control=f}', "");
    Expect(0, 8297, '\P{^Is_Bidi_Control=f}', "");
    Expect(1, 8298, '\p{Is_Bidi_Control=-F}', "");
    Expect(0, 8298, '\p{^Is_Bidi_Control=-F}', "");
    Expect(0, 8298, '\P{Is_Bidi_Control=-F}', "");
    Expect(1, 8298, '\P{^Is_Bidi_Control=-F}', "");
    Expect(0, 8297, '\p{Is_Bidi_Control=-F}', "");
    Expect(1, 8297, '\p{^Is_Bidi_Control=-F}', "");
    Expect(1, 8297, '\P{Is_Bidi_Control=-F}', "");
    Expect(0, 8297, '\P{^Is_Bidi_Control=-F}', "");
    Error('\p{Is_Bidi_C=:=_-FALSE}');
    Error('\P{Is_Bidi_C=:=_-FALSE}');
    Expect(1, 8298, '\p{Is_Bidi_C=false}', "");
    Expect(0, 8298, '\p{^Is_Bidi_C=false}', "");
    Expect(0, 8298, '\P{Is_Bidi_C=false}', "");
    Expect(1, 8298, '\P{^Is_Bidi_C=false}', "");
    Expect(0, 8297, '\p{Is_Bidi_C=false}', "");
    Expect(1, 8297, '\p{^Is_Bidi_C=false}', "");
    Expect(1, 8297, '\P{Is_Bidi_C=false}', "");
    Expect(0, 8297, '\P{^Is_Bidi_C=false}', "");
    Expect(1, 8298, '\p{Is_Bidi_C:	_ false}', "");
    Expect(0, 8298, '\p{^Is_Bidi_C:	_ false}', "");
    Expect(0, 8298, '\P{Is_Bidi_C:	_ false}', "");
    Expect(1, 8298, '\P{^Is_Bidi_C:	_ false}', "");
    Expect(0, 8297, '\p{Is_Bidi_C:	_ false}', "");
    Expect(1, 8297, '\p{^Is_Bidi_C:	_ false}', "");
    Expect(1, 8297, '\P{Is_Bidi_C:	_ false}', "");
    Expect(0, 8297, '\P{^Is_Bidi_C:	_ false}', "");
    Error('\p{Bidi_Control=/a/_Yes}');
    Error('\P{Bidi_Control=/a/_Yes}');
    Expect(1, 8297, '\p{Bidi_Control=yes}', "");
    Expect(0, 8297, '\p{^Bidi_Control=yes}', "");
    Expect(0, 8297, '\P{Bidi_Control=yes}', "");
    Expect(1, 8297, '\P{^Bidi_Control=yes}', "");
    Expect(0, 8298, '\p{Bidi_Control=yes}', "");
    Expect(1, 8298, '\p{^Bidi_Control=yes}', "");
    Expect(1, 8298, '\P{Bidi_Control=yes}', "");
    Expect(0, 8298, '\P{^Bidi_Control=yes}', "");
    Expect(1, 8297, '\p{Bidi_Control=-YES}', "");
    Expect(0, 8297, '\p{^Bidi_Control=-YES}', "");
    Expect(0, 8297, '\P{Bidi_Control=-YES}', "");
    Expect(1, 8297, '\P{^Bidi_Control=-YES}', "");
    Expect(0, 8298, '\p{Bidi_Control=-YES}', "");
    Expect(1, 8298, '\p{^Bidi_Control=-YES}', "");
    Expect(1, 8298, '\P{Bidi_Control=-YES}', "");
    Expect(0, 8298, '\P{^Bidi_Control=-YES}', "");
    Error('\p{Bidi_C=:=-_Y}');
    Error('\P{Bidi_C=:=-_Y}');
    Expect(1, 8297, '\p{Bidi_C=y}', "");
    Expect(0, 8297, '\p{^Bidi_C=y}', "");
    Expect(0, 8297, '\P{Bidi_C=y}', "");
    Expect(1, 8297, '\P{^Bidi_C=y}', "");
    Expect(0, 8298, '\p{Bidi_C=y}', "");
    Expect(1, 8298, '\p{^Bidi_C=y}', "");
    Expect(1, 8298, '\P{Bidi_C=y}', "");
    Expect(0, 8298, '\P{^Bidi_C=y}', "");
    Expect(1, 8297, '\p{Bidi_C=__Y}', "");
    Expect(0, 8297, '\p{^Bidi_C=__Y}', "");
    Expect(0, 8297, '\P{Bidi_C=__Y}', "");
    Expect(1, 8297, '\P{^Bidi_C=__Y}', "");
    Expect(0, 8298, '\p{Bidi_C=__Y}', "");
    Expect(1, 8298, '\p{^Bidi_C=__Y}', "");
    Expect(1, 8298, '\P{Bidi_C=__Y}', "");
    Expect(0, 8298, '\P{^Bidi_C=__Y}', "");
    Error('\p{Is_Bidi_Control= :=T}');
    Error('\P{Is_Bidi_Control= :=T}');
    Expect(1, 8297, '\p{Is_Bidi_Control=t}', "");
    Expect(0, 8297, '\p{^Is_Bidi_Control=t}', "");
    Expect(0, 8297, '\P{Is_Bidi_Control=t}', "");
    Expect(1, 8297, '\P{^Is_Bidi_Control=t}', "");
    Expect(0, 8298, '\p{Is_Bidi_Control=t}', "");
    Expect(1, 8298, '\p{^Is_Bidi_Control=t}', "");
    Expect(1, 8298, '\P{Is_Bidi_Control=t}', "");
    Expect(0, 8298, '\P{^Is_Bidi_Control=t}', "");
    Expect(1, 8297, '\p{Is_Bidi_Control=	 t}', "");
    Expect(0, 8297, '\p{^Is_Bidi_Control=	 t}', "");
    Expect(0, 8297, '\P{Is_Bidi_Control=	 t}', "");
    Expect(1, 8297, '\P{^Is_Bidi_Control=	 t}', "");
    Expect(0, 8298, '\p{Is_Bidi_Control=	 t}', "");
    Expect(1, 8298, '\p{^Is_Bidi_Control=	 t}', "");
    Expect(1, 8298, '\P{Is_Bidi_Control=	 t}', "");
    Expect(0, 8298, '\P{^Is_Bidi_Control=	 t}', "");
    Error('\p{Is_Bidi_C=:=	True}');
    Error('\P{Is_Bidi_C=:=	True}');
    Expect(1, 8297, '\p{Is_Bidi_C=true}', "");
    Expect(0, 8297, '\p{^Is_Bidi_C=true}', "");
    Expect(0, 8297, '\P{Is_Bidi_C=true}', "");
    Expect(1, 8297, '\P{^Is_Bidi_C=true}', "");
    Expect(0, 8298, '\p{Is_Bidi_C=true}', "");
    Expect(1, 8298, '\p{^Is_Bidi_C=true}', "");
    Expect(1, 8298, '\P{Is_Bidi_C=true}', "");
    Expect(0, 8298, '\P{^Is_Bidi_C=true}', "");
    Expect(1, 8297, '\p{Is_Bidi_C=-True}', "");
    Expect(0, 8297, '\p{^Is_Bidi_C=-True}', "");
    Expect(0, 8297, '\P{Is_Bidi_C=-True}', "");
    Expect(1, 8297, '\P{^Is_Bidi_C=-True}', "");
    Expect(0, 8298, '\p{Is_Bidi_C=-True}', "");
    Expect(1, 8298, '\p{^Is_Bidi_C=-True}', "");
    Expect(1, 8298, '\P{Is_Bidi_C=-True}', "");
    Expect(0, 8298, '\P{^Is_Bidi_C=-True}', "");
    Error('\p{Bidi_Mirrored:	 No/a/}');
    Error('\P{Bidi_Mirrored:	 No/a/}');
    Expect(1, 120772, '\p{Bidi_Mirrored=no}', "");
    Expect(0, 120772, '\p{^Bidi_Mirrored=no}', "");
    Expect(0, 120772, '\P{Bidi_Mirrored=no}', "");
    Expect(1, 120772, '\P{^Bidi_Mirrored=no}', "");
    Expect(0, 120771, '\p{Bidi_Mirrored=no}', "");
    Expect(1, 120771, '\p{^Bidi_Mirrored=no}', "");
    Expect(1, 120771, '\P{Bidi_Mirrored=no}', "");
    Expect(0, 120771, '\P{^Bidi_Mirrored=no}', "");
    Expect(1, 120772, '\p{Bidi_Mirrored=_-NO}', "");
    Expect(0, 120772, '\p{^Bidi_Mirrored=_-NO}', "");
    Expect(0, 120772, '\P{Bidi_Mirrored=_-NO}', "");
    Expect(1, 120772, '\P{^Bidi_Mirrored=_-NO}', "");
    Expect(0, 120771, '\p{Bidi_Mirrored=_-NO}', "");
    Expect(1, 120771, '\p{^Bidi_Mirrored=_-NO}', "");
    Expect(1, 120771, '\P{Bidi_Mirrored=_-NO}', "");
    Expect(0, 120771, '\P{^Bidi_Mirrored=_-NO}', "");
    Error('\p{Bidi_M=:=  N}');
    Error('\P{Bidi_M=:=  N}');
    Expect(1, 120772, '\p{Bidi_M=n}', "");
    Expect(0, 120772, '\p{^Bidi_M=n}', "");
    Expect(0, 120772, '\P{Bidi_M=n}', "");
    Expect(1, 120772, '\P{^Bidi_M=n}', "");
    Expect(0, 120771, '\p{Bidi_M=n}', "");
    Expect(1, 120771, '\p{^Bidi_M=n}', "");
    Expect(1, 120771, '\P{Bidi_M=n}', "");
    Expect(0, 120771, '\P{^Bidi_M=n}', "");
    Expect(1, 120772, '\p{Bidi_M=--N}', "");
    Expect(0, 120772, '\p{^Bidi_M=--N}', "");
    Expect(0, 120772, '\P{Bidi_M=--N}', "");
    Expect(1, 120772, '\P{^Bidi_M=--N}', "");
    Expect(0, 120771, '\p{Bidi_M=--N}', "");
    Expect(1, 120771, '\p{^Bidi_M=--N}', "");
    Expect(1, 120771, '\P{Bidi_M=--N}', "");
    Expect(0, 120771, '\P{^Bidi_M=--N}', "");
    Error('\p{Is_Bidi_Mirrored=:= -F}');
    Error('\P{Is_Bidi_Mirrored=:= -F}');
    Expect(1, 120772, '\p{Is_Bidi_Mirrored=f}', "");
    Expect(0, 120772, '\p{^Is_Bidi_Mirrored=f}', "");
    Expect(0, 120772, '\P{Is_Bidi_Mirrored=f}', "");
    Expect(1, 120772, '\P{^Is_Bidi_Mirrored=f}', "");
    Expect(0, 120771, '\p{Is_Bidi_Mirrored=f}', "");
    Expect(1, 120771, '\p{^Is_Bidi_Mirrored=f}', "");
    Expect(1, 120771, '\P{Is_Bidi_Mirrored=f}', "");
    Expect(0, 120771, '\P{^Is_Bidi_Mirrored=f}', "");
    Expect(1, 120772, '\p{Is_Bidi_Mirrored=F}', "");
    Expect(0, 120772, '\p{^Is_Bidi_Mirrored=F}', "");
    Expect(0, 120772, '\P{Is_Bidi_Mirrored=F}', "");
    Expect(1, 120772, '\P{^Is_Bidi_Mirrored=F}', "");
    Expect(0, 120771, '\p{Is_Bidi_Mirrored=F}', "");
    Expect(1, 120771, '\p{^Is_Bidi_Mirrored=F}', "");
    Expect(1, 120771, '\P{Is_Bidi_Mirrored=F}', "");
    Expect(0, 120771, '\P{^Is_Bidi_Mirrored=F}', "");
    Error('\p{Is_Bidi_M= /a/FALSE}');
    Error('\P{Is_Bidi_M= /a/FALSE}');
    Expect(1, 120772, '\p{Is_Bidi_M=false}', "");
    Expect(0, 120772, '\p{^Is_Bidi_M=false}', "");
    Expect(0, 120772, '\P{Is_Bidi_M=false}', "");
    Expect(1, 120772, '\P{^Is_Bidi_M=false}', "");
    Expect(0, 120771, '\p{Is_Bidi_M=false}', "");
    Expect(1, 120771, '\p{^Is_Bidi_M=false}', "");
    Expect(1, 120771, '\P{Is_Bidi_M=false}', "");
    Expect(0, 120771, '\P{^Is_Bidi_M=false}', "");
    Expect(1, 120772, '\p{Is_Bidi_M=_False}', "");
    Expect(0, 120772, '\p{^Is_Bidi_M=_False}', "");
    Expect(0, 120772, '\P{Is_Bidi_M=_False}', "");
    Expect(1, 120772, '\P{^Is_Bidi_M=_False}', "");
    Expect(0, 120771, '\p{Is_Bidi_M=_False}', "");
    Expect(1, 120771, '\p{^Is_Bidi_M=_False}', "");
    Expect(1, 120771, '\P{Is_Bidi_M=_False}', "");
    Expect(0, 120771, '\P{^Is_Bidi_M=_False}', "");
    Error('\p{Bidi_Mirrored=-_Yes:=}');
    Error('\P{Bidi_Mirrored=-_Yes:=}');
    Expect(1, 120771, '\p{Bidi_Mirrored=yes}', "");
    Expect(0, 120771, '\p{^Bidi_Mirrored=yes}', "");
    Expect(0, 120771, '\P{Bidi_Mirrored=yes}', "");
    Expect(1, 120771, '\P{^Bidi_Mirrored=yes}', "");
    Expect(0, 120772, '\p{Bidi_Mirrored=yes}', "");
    Expect(1, 120772, '\p{^Bidi_Mirrored=yes}', "");
    Expect(1, 120772, '\P{Bidi_Mirrored=yes}', "");
    Expect(0, 120772, '\P{^Bidi_Mirrored=yes}', "");
    Expect(1, 120771, '\p{Bidi_Mirrored= YES}', "");
    Expect(0, 120771, '\p{^Bidi_Mirrored= YES}', "");
    Expect(0, 120771, '\P{Bidi_Mirrored= YES}', "");
    Expect(1, 120771, '\P{^Bidi_Mirrored= YES}', "");
    Expect(0, 120772, '\p{Bidi_Mirrored= YES}', "");
    Expect(1, 120772, '\p{^Bidi_Mirrored= YES}', "");
    Expect(1, 120772, '\P{Bidi_Mirrored= YES}', "");
    Expect(0, 120772, '\P{^Bidi_Mirrored= YES}', "");
    Error('\p{Bidi_M=:= _Y}');
    Error('\P{Bidi_M=:= _Y}');
    Expect(1, 120771, '\p{Bidi_M:   y}', "");
    Expect(0, 120771, '\p{^Bidi_M:   y}', "");
    Expect(0, 120771, '\P{Bidi_M:   y}', "");
    Expect(1, 120771, '\P{^Bidi_M:   y}', "");
    Expect(0, 120772, '\p{Bidi_M:   y}', "");
    Expect(1, 120772, '\p{^Bidi_M:   y}', "");
    Expect(1, 120772, '\P{Bidi_M:   y}', "");
    Expect(0, 120772, '\P{^Bidi_M:   y}', "");
    Expect(1, 120771, '\p{Bidi_M=	-Y}', "");
    Expect(0, 120771, '\p{^Bidi_M=	-Y}', "");
    Expect(0, 120771, '\P{Bidi_M=	-Y}', "");
    Expect(1, 120771, '\P{^Bidi_M=	-Y}', "");
    Expect(0, 120772, '\p{Bidi_M=	-Y}', "");
    Expect(1, 120772, '\p{^Bidi_M=	-Y}', "");
    Expect(1, 120772, '\P{Bidi_M=	-Y}', "");
    Expect(0, 120772, '\P{^Bidi_M=	-Y}', "");
    Error('\p{Is_Bidi_Mirrored=:=t}');
    Error('\P{Is_Bidi_Mirrored=:=t}');
    Expect(1, 120771, '\p{Is_Bidi_Mirrored=t}', "");
    Expect(0, 120771, '\p{^Is_Bidi_Mirrored=t}', "");
    Expect(0, 120771, '\P{Is_Bidi_Mirrored=t}', "");
    Expect(1, 120771, '\P{^Is_Bidi_Mirrored=t}', "");
    Expect(0, 120772, '\p{Is_Bidi_Mirrored=t}', "");
    Expect(1, 120772, '\p{^Is_Bidi_Mirrored=t}', "");
    Expect(1, 120772, '\P{Is_Bidi_Mirrored=t}', "");
    Expect(0, 120772, '\P{^Is_Bidi_Mirrored=t}', "");
    Expect(1, 120771, '\p{Is_Bidi_Mirrored= T}', "");
    Expect(0, 120771, '\p{^Is_Bidi_Mirrored= T}', "");
    Expect(0, 120771, '\P{Is_Bidi_Mirrored= T}', "");
    Expect(1, 120771, '\P{^Is_Bidi_Mirrored= T}', "");
    Expect(0, 120772, '\p{Is_Bidi_Mirrored= T}', "");
    Expect(1, 120772, '\p{^Is_Bidi_Mirrored= T}', "");
    Expect(1, 120772, '\P{Is_Bidi_Mirrored= T}', "");
    Expect(0, 120772, '\P{^Is_Bidi_Mirrored= T}', "");
    Error('\p{Is_Bidi_M=	_TRUE:=}');
    Error('\P{Is_Bidi_M=	_TRUE:=}');
    Expect(1, 120771, '\p{Is_Bidi_M=true}', "");
    Expect(0, 120771, '\p{^Is_Bidi_M=true}', "");
    Expect(0, 120771, '\P{Is_Bidi_M=true}', "");
    Expect(1, 120771, '\P{^Is_Bidi_M=true}', "");
    Expect(0, 120772, '\p{Is_Bidi_M=true}', "");
    Expect(1, 120772, '\p{^Is_Bidi_M=true}', "");
    Expect(1, 120772, '\P{Is_Bidi_M=true}', "");
    Expect(0, 120772, '\P{^Is_Bidi_M=true}', "");
    Expect(1, 120771, '\p{Is_Bidi_M= -True}', "");
    Expect(0, 120771, '\p{^Is_Bidi_M= -True}', "");
    Expect(0, 120771, '\P{Is_Bidi_M= -True}', "");
    Expect(1, 120771, '\P{^Is_Bidi_M= -True}', "");
    Expect(0, 120772, '\p{Is_Bidi_M= -True}', "");
    Expect(1, 120772, '\p{^Is_Bidi_M= -True}', "");
    Expect(1, 120772, '\P{Is_Bidi_M= -True}', "");
    Expect(0, 120772, '\P{^Is_Bidi_M= -True}', "");
    Error('\p{block}');
    Error('\P{block}');
    Error('\p{blk}');
    Error('\P{blk}');
    Error('\p{Block=/a/--Adlam}');
    Error('\P{Block=/a/--Adlam}');
    Expect(1, 125279, '\p{Block=adlam}', "");
    Expect(0, 125279, '\p{^Block=adlam}', "");
    Expect(0, 125279, '\P{Block=adlam}', "");
    Expect(1, 125279, '\P{^Block=adlam}', "");
    Expect(0, 125280, '\p{Block=adlam}', "");
    Expect(1, 125280, '\p{^Block=adlam}', "");
    Expect(1, 125280, '\P{Block=adlam}', "");
    Expect(0, 125280, '\P{^Block=adlam}', "");
    Expect(1, 125279, '\p{Block=	_Adlam}', "");
    Expect(0, 125279, '\p{^Block=	_Adlam}', "");
    Expect(0, 125279, '\P{Block=	_Adlam}', "");
    Expect(1, 125279, '\P{^Block=	_Adlam}', "");
    Expect(0, 125280, '\p{Block=	_Adlam}', "");
    Expect(1, 125280, '\p{^Block=	_Adlam}', "");
    Expect(1, 125280, '\P{Block=	_Adlam}', "");
    Expect(0, 125280, '\P{^Block=	_Adlam}', "");
    Error('\p{Blk=:=Adlam}');
    Error('\P{Blk=:=Adlam}');
    Expect(1, 125279, '\p{Blk=adlam}', "");
    Expect(0, 125279, '\p{^Blk=adlam}', "");
    Expect(0, 125279, '\P{Blk=adlam}', "");
    Expect(1, 125279, '\P{^Blk=adlam}', "");
    Expect(0, 125280, '\p{Blk=adlam}', "");
    Expect(1, 125280, '\p{^Blk=adlam}', "");
    Expect(1, 125280, '\P{Blk=adlam}', "");
    Expect(0, 125280, '\P{^Blk=adlam}', "");
    Expect(1, 125279, '\p{Blk=_ADLAM}', "");
    Expect(0, 125279, '\p{^Blk=_ADLAM}', "");
    Expect(0, 125279, '\P{Blk=_ADLAM}', "");
    Expect(1, 125279, '\P{^Blk=_ADLAM}', "");
    Expect(0, 125280, '\p{Blk=_ADLAM}', "");
    Expect(1, 125280, '\p{^Blk=_ADLAM}', "");
    Expect(1, 125280, '\P{Blk=_ADLAM}', "");
    Expect(0, 125280, '\P{^Blk=_ADLAM}', "");
    Error('\p{Is_Block=/a/_ Adlam}');
    Error('\P{Is_Block=/a/_ Adlam}');
    Expect(1, 125279, '\p{Is_Block=adlam}', "");
    Expect(0, 125279, '\p{^Is_Block=adlam}', "");
    Expect(0, 125279, '\P{Is_Block=adlam}', "");
    Expect(1, 125279, '\P{^Is_Block=adlam}', "");
    Expect(0, 125280, '\p{Is_Block=adlam}', "");
    Expect(1, 125280, '\p{^Is_Block=adlam}', "");
    Expect(1, 125280, '\P{Is_Block=adlam}', "");
    Expect(0, 125280, '\P{^Is_Block=adlam}', "");
    Expect(1, 125279, '\p{Is_Block=--ADLAM}', "");
    Expect(0, 125279, '\p{^Is_Block=--ADLAM}', "");
    Expect(0, 125279, '\P{Is_Block=--ADLAM}', "");
    Expect(1, 125279, '\P{^Is_Block=--ADLAM}', "");
    Expect(0, 125280, '\p{Is_Block=--ADLAM}', "");
    Expect(1, 125280, '\p{^Is_Block=--ADLAM}', "");
    Expect(1, 125280, '\P{Is_Block=--ADLAM}', "");
    Expect(0, 125280, '\P{^Is_Block=--ADLAM}', "");
    Error('\p{Is_Blk=:=-	ADLAM}');
    Error('\P{Is_Blk=:=-	ADLAM}');
    Expect(1, 125279, '\p{Is_Blk=adlam}', "");
    Expect(0, 125279, '\p{^Is_Blk=adlam}', "");
    Expect(0, 125279, '\P{Is_Blk=adlam}', "");
    Expect(1, 125279, '\P{^Is_Blk=adlam}', "");
    Expect(0, 125280, '\p{Is_Blk=adlam}', "");
    Expect(1, 125280, '\p{^Is_Blk=adlam}', "");
    Expect(1, 125280, '\P{Is_Blk=adlam}', "");
    Expect(0, 125280, '\P{^Is_Blk=adlam}', "");
    Expect(1, 125279, '\p{Is_Blk=- Adlam}', "");
    Expect(0, 125279, '\p{^Is_Blk=- Adlam}', "");
    Expect(0, 125279, '\P{Is_Blk=- Adlam}', "");
    Expect(1, 125279, '\P{^Is_Blk=- Adlam}', "");
    Expect(0, 125280, '\p{Is_Blk=- Adlam}', "");
    Expect(1, 125280, '\p{^Is_Blk=- Adlam}', "");
    Expect(1, 125280, '\P{Is_Blk=- Adlam}', "");
    Expect(0, 125280, '\P{^Is_Blk=- Adlam}', "");
    Error('\p{Block= -AEGEAN_NUMBERS:=}');
    Error('\P{Block= -AEGEAN_NUMBERS:=}');
    Expect(1, 65855, '\p{Block=aegeannumbers}', "");
    Expect(0, 65855, '\p{^Block=aegeannumbers}', "");
    Expect(0, 65855, '\P{Block=aegeannumbers}', "");
    Expect(1, 65855, '\P{^Block=aegeannumbers}', "");
    Expect(0, 65856, '\p{Block=aegeannumbers}', "");
    Expect(1, 65856, '\p{^Block=aegeannumbers}', "");
    Expect(1, 65856, '\P{Block=aegeannumbers}', "");
    Expect(0, 65856, '\P{^Block=aegeannumbers}', "");
    Expect(1, 65855, '\p{Block= Aegean_NUMBERS}', "");
    Expect(0, 65855, '\p{^Block= Aegean_NUMBERS}', "");
    Expect(0, 65855, '\P{Block= Aegean_NUMBERS}', "");
    Expect(1, 65855, '\P{^Block= Aegean_NUMBERS}', "");
    Expect(0, 65856, '\p{Block= Aegean_NUMBERS}', "");
    Expect(1, 65856, '\p{^Block= Aegean_NUMBERS}', "");
    Expect(1, 65856, '\P{Block= Aegean_NUMBERS}', "");
    Expect(0, 65856, '\P{^Block= Aegean_NUMBERS}', "");
    Error('\p{Blk=	_Aegean_Numbers/a/}');
    Error('\P{Blk=	_Aegean_Numbers/a/}');
    Expect(1, 65855, '\p{Blk=aegeannumbers}', "");
    Expect(0, 65855, '\p{^Blk=aegeannumbers}', "");
    Expect(0, 65855, '\P{Blk=aegeannumbers}', "");
    Expect(1, 65855, '\P{^Blk=aegeannumbers}', "");
    Expect(0, 65856, '\p{Blk=aegeannumbers}', "");
    Expect(1, 65856, '\p{^Blk=aegeannumbers}', "");
    Expect(1, 65856, '\P{Blk=aegeannumbers}', "");
    Expect(0, 65856, '\P{^Blk=aegeannumbers}', "");
    Expect(1, 65855, '\p{Blk=_AEGEAN_NUMBERS}', "");
    Expect(0, 65855, '\p{^Blk=_AEGEAN_NUMBERS}', "");
    Expect(0, 65855, '\P{Blk=_AEGEAN_NUMBERS}', "");
    Expect(1, 65855, '\P{^Blk=_AEGEAN_NUMBERS}', "");
    Expect(0, 65856, '\p{Blk=_AEGEAN_NUMBERS}', "");
    Expect(1, 65856, '\p{^Blk=_AEGEAN_NUMBERS}', "");
    Expect(1, 65856, '\P{Blk=_AEGEAN_NUMBERS}', "");
    Expect(0, 65856, '\P{^Blk=_AEGEAN_NUMBERS}', "");
    Error('\p{Is_Block=-aegean_Numbers:=}');
    Error('\P{Is_Block=-aegean_Numbers:=}');
    Expect(1, 65855, '\p{Is_Block=aegeannumbers}', "");
    Expect(0, 65855, '\p{^Is_Block=aegeannumbers}', "");
    Expect(0, 65855, '\P{Is_Block=aegeannumbers}', "");
    Expect(1, 65855, '\P{^Is_Block=aegeannumbers}', "");
    Expect(0, 65856, '\p{Is_Block=aegeannumbers}', "");
    Expect(1, 65856, '\p{^Is_Block=aegeannumbers}', "");
    Expect(1, 65856, '\P{Is_Block=aegeannumbers}', "");
    Expect(0, 65856, '\P{^Is_Block=aegeannumbers}', "");
    Expect(1, 65855, '\p{Is_Block=_	Aegean_Numbers}', "");
    Expect(0, 65855, '\p{^Is_Block=_	Aegean_Numbers}', "");
    Expect(0, 65855, '\P{Is_Block=_	Aegean_Numbers}', "");
    Expect(1, 65855, '\P{^Is_Block=_	Aegean_Numbers}', "");
    Expect(0, 65856, '\p{Is_Block=_	Aegean_Numbers}', "");
    Expect(1, 65856, '\p{^Is_Block=_	Aegean_Numbers}', "");
    Expect(1, 65856, '\P{Is_Block=_	Aegean_Numbers}', "");
    Expect(0, 65856, '\P{^Is_Block=_	Aegean_Numbers}', "");
    Error('\p{Is_Blk=		aegean_Numbers:=}');
    Error('\P{Is_Blk=		aegean_Numbers:=}');
    Expect(1, 65855, '\p{Is_Blk:   aegeannumbers}', "");
    Expect(0, 65855, '\p{^Is_Blk:   aegeannumbers}', "");
    Expect(0, 65855, '\P{Is_Blk:   aegeannumbers}', "");
    Expect(1, 65855, '\P{^Is_Blk:   aegeannumbers}', "");
    Expect(0, 65856, '\p{Is_Blk:   aegeannumbers}', "");
    Expect(1, 65856, '\p{^Is_Blk:   aegeannumbers}', "");
    Expect(1, 65856, '\P{Is_Blk:   aegeannumbers}', "");
    Expect(0, 65856, '\P{^Is_Blk:   aegeannumbers}', "");
    Expect(1, 65855, '\p{Is_Blk= Aegean_Numbers}', "");
    Expect(0, 65855, '\p{^Is_Blk= Aegean_Numbers}', "");
    Expect(0, 65855, '\P{Is_Blk= Aegean_Numbers}', "");
    Expect(1, 65855, '\P{^Is_Blk= Aegean_Numbers}', "");
    Expect(0, 65856, '\p{Is_Blk= Aegean_Numbers}', "");
    Expect(1, 65856, '\p{^Is_Blk= Aegean_Numbers}', "");
    Expect(1, 65856, '\P{Is_Blk= Aegean_Numbers}', "");
    Expect(0, 65856, '\P{^Is_Blk= Aegean_Numbers}', "");
    Error('\p{Block=-/a/AHOM}');
    Error('\P{Block=-/a/AHOM}');
    Expect(1, 71487, '\p{Block=ahom}', "");
    Expect(0, 71487, '\p{^Block=ahom}', "");
    Expect(0, 71487, '\P{Block=ahom}', "");
    Expect(1, 71487, '\P{^Block=ahom}', "");
    Expect(0, 71488, '\p{Block=ahom}', "");
    Expect(1, 71488, '\p{^Block=ahom}', "");
    Expect(1, 71488, '\P{Block=ahom}', "");
    Expect(0, 71488, '\P{^Block=ahom}', "");
    Expect(1, 71487, '\p{Block:		-Ahom}', "");
    Expect(0, 71487, '\p{^Block:		-Ahom}', "");
    Expect(0, 71487, '\P{Block:		-Ahom}', "");
    Expect(1, 71487, '\P{^Block:		-Ahom}', "");
    Expect(0, 71488, '\p{Block:		-Ahom}', "");
    Expect(1, 71488, '\p{^Block:		-Ahom}', "");
    Expect(1, 71488, '\P{Block:		-Ahom}', "");
    Expect(0, 71488, '\P{^Block:		-Ahom}', "");
    Error('\p{Blk= :=ahom}');
    Error('\P{Blk= :=ahom}');
    Expect(1, 71487, '\p{Blk=ahom}', "");
    Expect(0, 71487, '\p{^Blk=ahom}', "");
    Expect(0, 71487, '\P{Blk=ahom}', "");
    Expect(1, 71487, '\P{^Blk=ahom}', "");
    Expect(0, 71488, '\p{Blk=ahom}', "");
    Expect(1, 71488, '\p{^Blk=ahom}', "");
    Expect(1, 71488, '\P{Blk=ahom}', "");
    Expect(0, 71488, '\P{^Blk=ahom}', "");
    Expect(1, 71487, '\p{Blk=	_AHOM}', "");
    Expect(0, 71487, '\p{^Blk=	_AHOM}', "");
    Expect(0, 71487, '\P{Blk=	_AHOM}', "");
    Expect(1, 71487, '\P{^Blk=	_AHOM}', "");
    Expect(0, 71488, '\p{Blk=	_AHOM}', "");
    Expect(1, 71488, '\p{^Blk=	_AHOM}', "");
    Expect(1, 71488, '\P{Blk=	_AHOM}', "");
    Expect(0, 71488, '\P{^Blk=	_AHOM}', "");
    Error('\p{Is_Block:   -	ahom/a/}');
    Error('\P{Is_Block:   -	ahom/a/}');
    Expect(1, 71487, '\p{Is_Block=ahom}', "");
    Expect(0, 71487, '\p{^Is_Block=ahom}', "");
    Expect(0, 71487, '\P{Is_Block=ahom}', "");
    Expect(1, 71487, '\P{^Is_Block=ahom}', "");
    Expect(0, 71488, '\p{Is_Block=ahom}', "");
    Expect(1, 71488, '\p{^Is_Block=ahom}', "");
    Expect(1, 71488, '\P{Is_Block=ahom}', "");
    Expect(0, 71488, '\P{^Is_Block=ahom}', "");
    Expect(1, 71487, '\p{Is_Block=	ahom}', "");
    Expect(0, 71487, '\p{^Is_Block=	ahom}', "");
    Expect(0, 71487, '\P{Is_Block=	ahom}', "");
    Expect(1, 71487, '\P{^Is_Block=	ahom}', "");
    Expect(0, 71488, '\p{Is_Block=	ahom}', "");
    Expect(1, 71488, '\p{^Is_Block=	ahom}', "");
    Expect(1, 71488, '\P{Is_Block=	ahom}', "");
    Expect(0, 71488, '\P{^Is_Block=	ahom}', "");
    Error('\p{Is_Blk= _Ahom:=}');
    Error('\P{Is_Blk= _Ahom:=}');
    Expect(1, 71487, '\p{Is_Blk=ahom}', "");
    Expect(0, 71487, '\p{^Is_Blk=ahom}', "");
    Expect(0, 71487, '\P{Is_Blk=ahom}', "");
    Expect(1, 71487, '\P{^Is_Blk=ahom}', "");
    Expect(0, 71488, '\p{Is_Blk=ahom}', "");
    Expect(1, 71488, '\p{^Is_Blk=ahom}', "");
    Expect(1, 71488, '\P{Is_Blk=ahom}', "");
    Expect(0, 71488, '\P{^Is_Blk=ahom}', "");
    Expect(1, 71487, '\p{Is_Blk=_-Ahom}', "");
    Expect(0, 71487, '\p{^Is_Blk=_-Ahom}', "");
    Expect(0, 71487, '\P{Is_Blk=_-Ahom}', "");
    Expect(1, 71487, '\P{^Is_Blk=_-Ahom}', "");
    Expect(0, 71488, '\p{Is_Blk=_-Ahom}', "");
    Expect(1, 71488, '\p{^Is_Blk=_-Ahom}', "");
    Expect(1, 71488, '\P{Is_Blk=_-Ahom}', "");
    Expect(0, 71488, '\P{^Is_Blk=_-Ahom}', "");
    Error('\p{Block=/a/ -ALCHEMICAL_symbols}');
    Error('\P{Block=/a/ -ALCHEMICAL_symbols}');
    Expect(1, 128895, '\p{Block=alchemicalsymbols}', "");
    Expect(0, 128895, '\p{^Block=alchemicalsymbols}', "");
    Expect(0, 128895, '\P{Block=alchemicalsymbols}', "");
    Expect(1, 128895, '\P{^Block=alchemicalsymbols}', "");
    Expect(0, 128896, '\p{Block=alchemicalsymbols}', "");
    Expect(1, 128896, '\p{^Block=alchemicalsymbols}', "");
    Expect(1, 128896, '\P{Block=alchemicalsymbols}', "");
    Expect(0, 128896, '\P{^Block=alchemicalsymbols}', "");
    Expect(1, 128895, '\p{Block=		alchemical_Symbols}', "");
    Expect(0, 128895, '\p{^Block=		alchemical_Symbols}', "");
    Expect(0, 128895, '\P{Block=		alchemical_Symbols}', "");
    Expect(1, 128895, '\P{^Block=		alchemical_Symbols}', "");
    Expect(0, 128896, '\p{Block=		alchemical_Symbols}', "");
    Expect(1, 128896, '\p{^Block=		alchemical_Symbols}', "");
    Expect(1, 128896, '\P{Block=		alchemical_Symbols}', "");
    Expect(0, 128896, '\P{^Block=		alchemical_Symbols}', "");
    Error('\p{Blk=:=__alchemical}');
    Error('\P{Blk=:=__alchemical}');
    Expect(1, 128895, '\p{Blk=alchemical}', "");
    Expect(0, 128895, '\p{^Blk=alchemical}', "");
    Expect(0, 128895, '\P{Blk=alchemical}', "");
    Expect(1, 128895, '\P{^Blk=alchemical}', "");
    Expect(0, 128896, '\p{Blk=alchemical}', "");
    Expect(1, 128896, '\p{^Blk=alchemical}', "");
    Expect(1, 128896, '\P{Blk=alchemical}', "");
    Expect(0, 128896, '\P{^Blk=alchemical}', "");
    Expect(1, 128895, '\p{Blk= Alchemical}', "");
    Expect(0, 128895, '\p{^Blk= Alchemical}', "");
    Expect(0, 128895, '\P{Blk= Alchemical}', "");
    Expect(1, 128895, '\P{^Blk= Alchemical}', "");
    Expect(0, 128896, '\p{Blk= Alchemical}', "");
    Expect(1, 128896, '\p{^Blk= Alchemical}', "");
    Expect(1, 128896, '\P{Blk= Alchemical}', "");
    Expect(0, 128896, '\P{^Blk= Alchemical}', "");
    Error('\p{Is_Block=_:=alchemical_Symbols}');
    Error('\P{Is_Block=_:=alchemical_Symbols}');
    Expect(1, 128895, '\p{Is_Block=alchemicalsymbols}', "");
    Expect(0, 128895, '\p{^Is_Block=alchemicalsymbols}', "");
    Expect(0, 128895, '\P{Is_Block=alchemicalsymbols}', "");
    Expect(1, 128895, '\P{^Is_Block=alchemicalsymbols}', "");
    Expect(0, 128896, '\p{Is_Block=alchemicalsymbols}', "");
    Expect(1, 128896, '\p{^Is_Block=alchemicalsymbols}', "");
    Expect(1, 128896, '\P{Is_Block=alchemicalsymbols}', "");
    Expect(0, 128896, '\P{^Is_Block=alchemicalsymbols}', "");
    Expect(1, 128895, '\p{Is_Block= _alchemical_SYMBOLS}', "");
    Expect(0, 128895, '\p{^Is_Block= _alchemical_SYMBOLS}', "");
    Expect(0, 128895, '\P{Is_Block= _alchemical_SYMBOLS}', "");
    Expect(1, 128895, '\P{^Is_Block= _alchemical_SYMBOLS}', "");
    Expect(0, 128896, '\p{Is_Block= _alchemical_SYMBOLS}', "");
    Expect(1, 128896, '\p{^Is_Block= _alchemical_SYMBOLS}', "");
    Expect(1, 128896, '\P{Is_Block= _alchemical_SYMBOLS}', "");
    Expect(0, 128896, '\P{^Is_Block= _alchemical_SYMBOLS}', "");
    Error('\p{Is_Blk:   /a/--Alchemical}');
    Error('\P{Is_Blk:   /a/--Alchemical}');
    Expect(1, 128895, '\p{Is_Blk=alchemical}', "");
    Expect(0, 128895, '\p{^Is_Blk=alchemical}', "");
    Expect(0, 128895, '\P{Is_Blk=alchemical}', "");
    Expect(1, 128895, '\P{^Is_Blk=alchemical}', "");
    Expect(0, 128896, '\p{Is_Blk=alchemical}', "");
    Expect(1, 128896, '\p{^Is_Blk=alchemical}', "");
    Expect(1, 128896, '\P{Is_Blk=alchemical}', "");
    Expect(0, 128896, '\P{^Is_Blk=alchemical}', "");
    Expect(1, 128895, '\p{Is_Blk= Alchemical}', "");
    Expect(0, 128895, '\p{^Is_Blk= Alchemical}', "");
    Expect(0, 128895, '\P{Is_Blk= Alchemical}', "");
    Expect(1, 128895, '\P{^Is_Blk= Alchemical}', "");
    Expect(0, 128896, '\p{Is_Blk= Alchemical}', "");
    Expect(1, 128896, '\p{^Is_Blk= Alchemical}', "");
    Expect(1, 128896, '\P{Is_Blk= Alchemical}', "");
    Expect(0, 128896, '\P{^Is_Blk= Alchemical}', "");
    Error('\p{Block=:=Alphabetic_Presentation_forms}');
    Error('\P{Block=:=Alphabetic_Presentation_forms}');
    Expect(1, 64335, '\p{Block=alphabeticpresentationforms}', "");
    Expect(0, 64335, '\p{^Block=alphabeticpresentationforms}', "");
    Expect(0, 64335, '\P{Block=alphabeticpresentationforms}', "");
    Expect(1, 64335, '\P{^Block=alphabeticpresentationforms}', "");
    Expect(0, 64336, '\p{Block=alphabeticpresentationforms}', "");
    Expect(1, 64336, '\p{^Block=alphabeticpresentationforms}', "");
    Expect(1, 64336, '\P{Block=alphabeticpresentationforms}', "");
    Expect(0, 64336, '\P{^Block=alphabeticpresentationforms}', "");
    Expect(1, 64335, '\p{Block=-	Alphabetic_Presentation_forms}', "");
    Expect(0, 64335, '\p{^Block=-	Alphabetic_Presentation_forms}', "");
    Expect(0, 64335, '\P{Block=-	Alphabetic_Presentation_forms}', "");
    Expect(1, 64335, '\P{^Block=-	Alphabetic_Presentation_forms}', "");
    Expect(0, 64336, '\p{Block=-	Alphabetic_Presentation_forms}', "");
    Expect(1, 64336, '\p{^Block=-	Alphabetic_Presentation_forms}', "");
    Expect(1, 64336, '\P{Block=-	Alphabetic_Presentation_forms}', "");
    Expect(0, 64336, '\P{^Block=-	Alphabetic_Presentation_forms}', "");
    Error('\p{Blk=:=-ALPHABETIC_pf}');
    Error('\P{Blk=:=-ALPHABETIC_pf}');
    Expect(1, 64335, '\p{Blk=alphabeticpf}', "");
    Expect(0, 64335, '\p{^Blk=alphabeticpf}', "");
    Expect(0, 64335, '\P{Blk=alphabeticpf}', "");
    Expect(1, 64335, '\P{^Blk=alphabeticpf}', "");
    Expect(0, 64336, '\p{Blk=alphabeticpf}', "");
    Expect(1, 64336, '\p{^Blk=alphabeticpf}', "");
    Expect(1, 64336, '\P{Blk=alphabeticpf}', "");
    Expect(0, 64336, '\P{^Blk=alphabeticpf}', "");
    Expect(1, 64335, '\p{Blk=_alphabetic_pf}', "");
    Expect(0, 64335, '\p{^Blk=_alphabetic_pf}', "");
    Expect(0, 64335, '\P{Blk=_alphabetic_pf}', "");
    Expect(1, 64335, '\P{^Blk=_alphabetic_pf}', "");
    Expect(0, 64336, '\p{Blk=_alphabetic_pf}', "");
    Expect(1, 64336, '\p{^Blk=_alphabetic_pf}', "");
    Expect(1, 64336, '\P{Blk=_alphabetic_pf}', "");
    Expect(0, 64336, '\P{^Blk=_alphabetic_pf}', "");
    Error('\p{Is_Block= _alphabetic_Presentation_forms:=}');
    Error('\P{Is_Block= _alphabetic_Presentation_forms:=}');
    Expect(1, 64335, '\p{Is_Block=alphabeticpresentationforms}', "");
    Expect(0, 64335, '\p{^Is_Block=alphabeticpresentationforms}', "");
    Expect(0, 64335, '\P{Is_Block=alphabeticpresentationforms}', "");
    Expect(1, 64335, '\P{^Is_Block=alphabeticpresentationforms}', "");
    Expect(0, 64336, '\p{Is_Block=alphabeticpresentationforms}', "");
    Expect(1, 64336, '\p{^Is_Block=alphabeticpresentationforms}', "");
    Expect(1, 64336, '\P{Is_Block=alphabeticpresentationforms}', "");
    Expect(0, 64336, '\P{^Is_Block=alphabeticpresentationforms}', "");
    Expect(1, 64335, '\p{Is_Block=-ALPHABETIC_presentation_Forms}', "");
    Expect(0, 64335, '\p{^Is_Block=-ALPHABETIC_presentation_Forms}', "");
    Expect(0, 64335, '\P{Is_Block=-ALPHABETIC_presentation_Forms}', "");
    Expect(1, 64335, '\P{^Is_Block=-ALPHABETIC_presentation_Forms}', "");
    Expect(0, 64336, '\p{Is_Block=-ALPHABETIC_presentation_Forms}', "");
    Expect(1, 64336, '\p{^Is_Block=-ALPHABETIC_presentation_Forms}', "");
    Expect(1, 64336, '\P{Is_Block=-ALPHABETIC_presentation_Forms}', "");
    Expect(0, 64336, '\P{^Is_Block=-ALPHABETIC_presentation_Forms}', "");
    Error('\p{Is_Blk=	:=Alphabetic_pf}');
    Error('\P{Is_Blk=	:=Alphabetic_pf}');
    Expect(1, 64335, '\p{Is_Blk=alphabeticpf}', "");
    Expect(0, 64335, '\p{^Is_Blk=alphabeticpf}', "");
    Expect(0, 64335, '\P{Is_Blk=alphabeticpf}', "");
    Expect(1, 64335, '\P{^Is_Blk=alphabeticpf}', "");
    Expect(0, 64336, '\p{Is_Blk=alphabeticpf}', "");
    Expect(1, 64336, '\p{^Is_Blk=alphabeticpf}', "");
    Expect(1, 64336, '\P{Is_Blk=alphabeticpf}', "");
    Expect(0, 64336, '\P{^Is_Blk=alphabeticpf}', "");
    Expect(1, 64335, '\p{Is_Blk= Alphabetic_PF}', "");
    Expect(0, 64335, '\p{^Is_Blk= Alphabetic_PF}', "");
    Expect(0, 64335, '\P{Is_Blk= Alphabetic_PF}', "");
    Expect(1, 64335, '\P{^Is_Blk= Alphabetic_PF}', "");
    Expect(0, 64336, '\p{Is_Blk= Alphabetic_PF}', "");
    Expect(1, 64336, '\p{^Is_Blk= Alphabetic_PF}', "");
    Expect(1, 64336, '\P{Is_Blk= Alphabetic_PF}', "");
    Expect(0, 64336, '\P{^Is_Blk= Alphabetic_PF}', "");
    Error('\p{Block=Anatolian_Hieroglyphs/a/}');
    Error('\P{Block=Anatolian_Hieroglyphs/a/}');
    Expect(1, 83583, '\p{Block=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\p{^Block=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\P{Block=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\P{^Block=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\p{Block=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\p{^Block=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\P{Block=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\P{^Block=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\p{Block=  Anatolian_Hieroglyphs}', "");
    Expect(0, 83583, '\p{^Block=  Anatolian_Hieroglyphs}', "");
    Expect(0, 83583, '\P{Block=  Anatolian_Hieroglyphs}', "");
    Expect(1, 83583, '\P{^Block=  Anatolian_Hieroglyphs}', "");
    Expect(0, 83584, '\p{Block=  Anatolian_Hieroglyphs}', "");
    Expect(1, 83584, '\p{^Block=  Anatolian_Hieroglyphs}', "");
    Expect(1, 83584, '\P{Block=  Anatolian_Hieroglyphs}', "");
    Expect(0, 83584, '\P{^Block=  Anatolian_Hieroglyphs}', "");
    Error('\p{Blk=/a/	Anatolian_Hieroglyphs}');
    Error('\P{Blk=/a/	Anatolian_Hieroglyphs}');
    Expect(1, 83583, '\p{Blk=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\p{^Blk=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\P{Blk=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\P{^Blk=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\p{Blk=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\p{^Blk=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\P{Blk=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\P{^Blk=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\p{Blk=-ANATOLIAN_hieroglyphs}', "");
    Expect(0, 83583, '\p{^Blk=-ANATOLIAN_hieroglyphs}', "");
    Expect(0, 83583, '\P{Blk=-ANATOLIAN_hieroglyphs}', "");
    Expect(1, 83583, '\P{^Blk=-ANATOLIAN_hieroglyphs}', "");
    Expect(0, 83584, '\p{Blk=-ANATOLIAN_hieroglyphs}', "");
    Expect(1, 83584, '\p{^Blk=-ANATOLIAN_hieroglyphs}', "");
    Expect(1, 83584, '\P{Blk=-ANATOLIAN_hieroglyphs}', "");
    Expect(0, 83584, '\P{^Blk=-ANATOLIAN_hieroglyphs}', "");
    Error('\p{Is_Block=	/a/Anatolian_HIEROGLYPHS}');
    Error('\P{Is_Block=	/a/Anatolian_HIEROGLYPHS}');
    Expect(1, 83583, '\p{Is_Block:anatolianhieroglyphs}', "");
    Expect(0, 83583, '\p{^Is_Block:anatolianhieroglyphs}', "");
    Expect(0, 83583, '\P{Is_Block:anatolianhieroglyphs}', "");
    Expect(1, 83583, '\P{^Is_Block:anatolianhieroglyphs}', "");
    Expect(0, 83584, '\p{Is_Block:anatolianhieroglyphs}', "");
    Expect(1, 83584, '\p{^Is_Block:anatolianhieroglyphs}', "");
    Expect(1, 83584, '\P{Is_Block:anatolianhieroglyphs}', "");
    Expect(0, 83584, '\P{^Is_Block:anatolianhieroglyphs}', "");
    Expect(1, 83583, '\p{Is_Block:_	anatolian_HIEROGLYPHS}', "");
    Expect(0, 83583, '\p{^Is_Block:_	anatolian_HIEROGLYPHS}', "");
    Expect(0, 83583, '\P{Is_Block:_	anatolian_HIEROGLYPHS}', "");
    Expect(1, 83583, '\P{^Is_Block:_	anatolian_HIEROGLYPHS}', "");
    Expect(0, 83584, '\p{Is_Block:_	anatolian_HIEROGLYPHS}', "");
    Expect(1, 83584, '\p{^Is_Block:_	anatolian_HIEROGLYPHS}', "");
    Expect(1, 83584, '\P{Is_Block:_	anatolian_HIEROGLYPHS}', "");
    Expect(0, 83584, '\P{^Is_Block:_	anatolian_HIEROGLYPHS}', "");
    Error('\p{Is_Blk=	/a/Anatolian_HIEROGLYPHS}');
    Error('\P{Is_Blk=	/a/Anatolian_HIEROGLYPHS}');
    Expect(1, 83583, '\p{Is_Blk=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\p{^Is_Blk=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\P{Is_Blk=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\P{^Is_Blk=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\p{Is_Blk=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\p{^Is_Blk=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\P{Is_Blk=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\P{^Is_Blk=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\p{Is_Blk=-Anatolian_hieroglyphs}', "");
    Expect(0, 83583, '\p{^Is_Blk=-Anatolian_hieroglyphs}', "");
    Expect(0, 83583, '\P{Is_Blk=-Anatolian_hieroglyphs}', "");
    Expect(1, 83583, '\P{^Is_Blk=-Anatolian_hieroglyphs}', "");
    Expect(0, 83584, '\p{Is_Blk=-Anatolian_hieroglyphs}', "");
    Expect(1, 83584, '\p{^Is_Blk=-Anatolian_hieroglyphs}', "");
    Expect(1, 83584, '\P{Is_Blk=-Anatolian_hieroglyphs}', "");
    Expect(0, 83584, '\P{^Is_Blk=-Anatolian_hieroglyphs}', "");
    Error('\p{Block=:=-	ANCIENT_GREEK_Musical_NOTATION}');
    Error('\P{Block=:=-	ANCIENT_GREEK_Musical_NOTATION}');
    Expect(1, 119375, '\p{Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\p{^Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\P{Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\P{^Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\p{Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\p{^Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\P{Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\P{^Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\p{Block= Ancient_greek_musical_NOTATION}', "");
    Expect(0, 119375, '\p{^Block= Ancient_greek_musical_NOTATION}', "");
    Expect(0, 119375, '\P{Block= Ancient_greek_musical_NOTATION}', "");
    Expect(1, 119375, '\P{^Block= Ancient_greek_musical_NOTATION}', "");
    Expect(0, 119376, '\p{Block= Ancient_greek_musical_NOTATION}', "");
    Expect(1, 119376, '\p{^Block= Ancient_greek_musical_NOTATION}', "");
    Expect(1, 119376, '\P{Block= Ancient_greek_musical_NOTATION}', "");
    Expect(0, 119376, '\P{^Block= Ancient_greek_musical_NOTATION}', "");
    Error('\p{Blk= -Ancient_greek_Music/a/}');
    Error('\P{Blk= -Ancient_greek_Music/a/}');
    Expect(1, 119375, '\p{Blk=ancientgreekmusic}', "");
    Expect(0, 119375, '\p{^Blk=ancientgreekmusic}', "");
    Expect(0, 119375, '\P{Blk=ancientgreekmusic}', "");
    Expect(1, 119375, '\P{^Blk=ancientgreekmusic}', "");
    Expect(0, 119376, '\p{Blk=ancientgreekmusic}', "");
    Expect(1, 119376, '\p{^Blk=ancientgreekmusic}', "");
    Expect(1, 119376, '\P{Blk=ancientgreekmusic}', "");
    Expect(0, 119376, '\P{^Blk=ancientgreekmusic}', "");
    Expect(1, 119375, '\p{Blk=_ANCIENT_GREEK_MUSIC}', "");
    Expect(0, 119375, '\p{^Blk=_ANCIENT_GREEK_MUSIC}', "");
    Expect(0, 119375, '\P{Blk=_ANCIENT_GREEK_MUSIC}', "");
    Expect(1, 119375, '\P{^Blk=_ANCIENT_GREEK_MUSIC}', "");
    Expect(0, 119376, '\p{Blk=_ANCIENT_GREEK_MUSIC}', "");
    Expect(1, 119376, '\p{^Blk=_ANCIENT_GREEK_MUSIC}', "");
    Expect(1, 119376, '\P{Blk=_ANCIENT_GREEK_MUSIC}', "");
    Expect(0, 119376, '\P{^Blk=_ANCIENT_GREEK_MUSIC}', "");
    Error('\p{Is_Block=/a/__ancient_GREEK_Musical_Notation}');
    Error('\P{Is_Block=/a/__ancient_GREEK_Musical_Notation}');
    Expect(1, 119375, '\p{Is_Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\p{^Is_Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\P{Is_Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\P{^Is_Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\p{Is_Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\p{^Is_Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\P{Is_Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\P{^Is_Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\p{Is_Block= -ancient_Greek_Musical_Notation}', "");
    Expect(0, 119375, '\p{^Is_Block= -ancient_Greek_Musical_Notation}', "");
    Expect(0, 119375, '\P{Is_Block= -ancient_Greek_Musical_Notation}', "");
    Expect(1, 119375, '\P{^Is_Block= -ancient_Greek_Musical_Notation}', "");
    Expect(0, 119376, '\p{Is_Block= -ancient_Greek_Musical_Notation}', "");
    Expect(1, 119376, '\p{^Is_Block= -ancient_Greek_Musical_Notation}', "");
    Expect(1, 119376, '\P{Is_Block= -ancient_Greek_Musical_Notation}', "");
    Expect(0, 119376, '\P{^Is_Block= -ancient_Greek_Musical_Notation}', "");
    Error('\p{Is_Blk=/a/	_ANCIENT_greek_Music}');
    Error('\P{Is_Blk=/a/	_ANCIENT_greek_Music}');
    Expect(1, 119375, '\p{Is_Blk=ancientgreekmusic}', "");
    Expect(0, 119375, '\p{^Is_Blk=ancientgreekmusic}', "");
    Expect(0, 119375, '\P{Is_Blk=ancientgreekmusic}', "");
    Expect(1, 119375, '\P{^Is_Blk=ancientgreekmusic}', "");
    Expect(0, 119376, '\p{Is_Blk=ancientgreekmusic}', "");
    Expect(1, 119376, '\p{^Is_Blk=ancientgreekmusic}', "");
    Expect(1, 119376, '\P{Is_Blk=ancientgreekmusic}', "");
    Expect(0, 119376, '\P{^Is_Blk=ancientgreekmusic}', "");
    Expect(1, 119375, '\p{Is_Blk=	Ancient_greek_Music}', "");
    Expect(0, 119375, '\p{^Is_Blk=	Ancient_greek_Music}', "");
    Expect(0, 119375, '\P{Is_Blk=	Ancient_greek_Music}', "");
    Expect(1, 119375, '\P{^Is_Blk=	Ancient_greek_Music}', "");
    Expect(0, 119376, '\p{Is_Blk=	Ancient_greek_Music}', "");
    Expect(1, 119376, '\p{^Is_Blk=	Ancient_greek_Music}', "");
    Expect(1, 119376, '\P{Is_Blk=	Ancient_greek_Music}', "");
    Expect(0, 119376, '\P{^Is_Blk=	Ancient_greek_Music}', "");
    Error('\p{Block=:=_Ancient_GREEK_Numbers}');
    Error('\P{Block=:=_Ancient_GREEK_Numbers}');
    Expect(1, 65935, '\p{Block=ancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^Block=ancientgreeknumbers}', "");
    Expect(0, 65935, '\P{Block=ancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^Block=ancientgreeknumbers}', "");
    Expect(0, 65936, '\p{Block=ancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^Block=ancientgreeknumbers}', "");
    Expect(1, 65936, '\P{Block=ancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^Block=ancientgreeknumbers}', "");
    Expect(1, 65935, '\p{Block=-Ancient_Greek_Numbers}', "");
    Expect(0, 65935, '\p{^Block=-Ancient_Greek_Numbers}', "");
    Expect(0, 65935, '\P{Block=-Ancient_Greek_Numbers}', "");
    Expect(1, 65935, '\P{^Block=-Ancient_Greek_Numbers}', "");
    Expect(0, 65936, '\p{Block=-Ancient_Greek_Numbers}', "");
    Expect(1, 65936, '\p{^Block=-Ancient_Greek_Numbers}', "");
    Expect(1, 65936, '\P{Block=-Ancient_Greek_Numbers}', "");
    Expect(0, 65936, '\P{^Block=-Ancient_Greek_Numbers}', "");
    Error('\p{Blk=- Ancient_Greek_numbers/a/}');
    Error('\P{Blk=- Ancient_Greek_numbers/a/}');
    Expect(1, 65935, '\p{Blk=ancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^Blk=ancientgreeknumbers}', "");
    Expect(0, 65935, '\P{Blk=ancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^Blk=ancientgreeknumbers}', "");
    Expect(0, 65936, '\p{Blk=ancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^Blk=ancientgreeknumbers}', "");
    Expect(1, 65936, '\P{Blk=ancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^Blk=ancientgreeknumbers}', "");
    Expect(1, 65935, '\p{Blk=	ancient_Greek_numbers}', "");
    Expect(0, 65935, '\p{^Blk=	ancient_Greek_numbers}', "");
    Expect(0, 65935, '\P{Blk=	ancient_Greek_numbers}', "");
    Expect(1, 65935, '\P{^Blk=	ancient_Greek_numbers}', "");
    Expect(0, 65936, '\p{Blk=	ancient_Greek_numbers}', "");
    Expect(1, 65936, '\p{^Blk=	ancient_Greek_numbers}', "");
    Expect(1, 65936, '\P{Blk=	ancient_Greek_numbers}', "");
    Expect(0, 65936, '\P{^Blk=	ancient_Greek_numbers}', "");
    Error('\p{Is_Block=-	Ancient_Greek_NUMBERS/a/}');
    Error('\P{Is_Block=-	Ancient_Greek_NUMBERS/a/}');
    Expect(1, 65935, '\p{Is_Block=ancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^Is_Block=ancientgreeknumbers}', "");
    Expect(0, 65935, '\P{Is_Block=ancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^Is_Block=ancientgreeknumbers}', "");
    Expect(0, 65936, '\p{Is_Block=ancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^Is_Block=ancientgreeknumbers}', "");
    Expect(1, 65936, '\P{Is_Block=ancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^Is_Block=ancientgreeknumbers}', "");
    Expect(1, 65935, '\p{Is_Block=  Ancient_GREEK_Numbers}', "");
    Expect(0, 65935, '\p{^Is_Block=  Ancient_GREEK_Numbers}', "");
    Expect(0, 65935, '\P{Is_Block=  Ancient_GREEK_Numbers}', "");
    Expect(1, 65935, '\P{^Is_Block=  Ancient_GREEK_Numbers}', "");
    Expect(0, 65936, '\p{Is_Block=  Ancient_GREEK_Numbers}', "");
    Expect(1, 65936, '\p{^Is_Block=  Ancient_GREEK_Numbers}', "");
    Expect(1, 65936, '\P{Is_Block=  Ancient_GREEK_Numbers}', "");
    Expect(0, 65936, '\P{^Is_Block=  Ancient_GREEK_Numbers}', "");
    Error('\p{Is_Blk=:=--ancient_Greek_numbers}');
    Error('\P{Is_Blk=:=--ancient_Greek_numbers}');
    Expect(1, 65935, '\p{Is_Blk=ancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^Is_Blk=ancientgreeknumbers}', "");
    Expect(0, 65935, '\P{Is_Blk=ancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^Is_Blk=ancientgreeknumbers}', "");
    Expect(0, 65936, '\p{Is_Blk=ancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^Is_Blk=ancientgreeknumbers}', "");
    Expect(1, 65936, '\P{Is_Blk=ancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^Is_Blk=ancientgreeknumbers}', "");
    Expect(1, 65935, '\p{Is_Blk=-ancient_Greek_Numbers}', "");
    Expect(0, 65935, '\p{^Is_Blk=-ancient_Greek_Numbers}', "");
    Expect(0, 65935, '\P{Is_Blk=-ancient_Greek_Numbers}', "");
    Expect(1, 65935, '\P{^Is_Blk=-ancient_Greek_Numbers}', "");
    Expect(0, 65936, '\p{Is_Blk=-ancient_Greek_Numbers}', "");
    Expect(1, 65936, '\p{^Is_Blk=-ancient_Greek_Numbers}', "");
    Expect(1, 65936, '\P{Is_Blk=-ancient_Greek_Numbers}', "");
    Expect(0, 65936, '\P{^Is_Blk=-ancient_Greek_Numbers}', "");
    Error('\p{Block= _ancient_symbols:=}');
    Error('\P{Block= _ancient_symbols:=}');
    Expect(1, 65999, '\p{Block=ancientsymbols}', "");
    Expect(0, 65999, '\p{^Block=ancientsymbols}', "");
    Expect(0, 65999, '\P{Block=ancientsymbols}', "");
    Expect(1, 65999, '\P{^Block=ancientsymbols}', "");
    Expect(0, 66000, '\p{Block=ancientsymbols}', "");
    Expect(1, 66000, '\p{^Block=ancientsymbols}', "");
    Expect(1, 66000, '\P{Block=ancientsymbols}', "");
    Expect(0, 66000, '\P{^Block=ancientsymbols}', "");
    Expect(1, 65999, '\p{Block=_	ANCIENT_symbols}', "");
    Expect(0, 65999, '\p{^Block=_	ANCIENT_symbols}', "");
    Expect(0, 65999, '\P{Block=_	ANCIENT_symbols}', "");
    Expect(1, 65999, '\P{^Block=_	ANCIENT_symbols}', "");
    Expect(0, 66000, '\p{Block=_	ANCIENT_symbols}', "");
    Expect(1, 66000, '\p{^Block=_	ANCIENT_symbols}', "");
    Expect(1, 66000, '\P{Block=_	ANCIENT_symbols}', "");
    Expect(0, 66000, '\P{^Block=_	ANCIENT_symbols}', "");
    Error('\p{Blk=:=-	ancient_SYMBOLS}');
    Error('\P{Blk=:=-	ancient_SYMBOLS}');
    Expect(1, 65999, '\p{Blk=ancientsymbols}', "");
    Expect(0, 65999, '\p{^Blk=ancientsymbols}', "");
    Expect(0, 65999, '\P{Blk=ancientsymbols}', "");
    Expect(1, 65999, '\P{^Blk=ancientsymbols}', "");
    Expect(0, 66000, '\p{Blk=ancientsymbols}', "");
    Expect(1, 66000, '\p{^Blk=ancientsymbols}', "");
    Expect(1, 66000, '\P{Blk=ancientsymbols}', "");
    Expect(0, 66000, '\P{^Blk=ancientsymbols}', "");
    Expect(1, 65999, '\p{Blk=	ANCIENT_symbols}', "");
    Expect(0, 65999, '\p{^Blk=	ANCIENT_symbols}', "");
    Expect(0, 65999, '\P{Blk=	ANCIENT_symbols}', "");
    Expect(1, 65999, '\P{^Blk=	ANCIENT_symbols}', "");
    Expect(0, 66000, '\p{Blk=	ANCIENT_symbols}', "");
    Expect(1, 66000, '\p{^Blk=	ANCIENT_symbols}', "");
    Expect(1, 66000, '\P{Blk=	ANCIENT_symbols}', "");
    Expect(0, 66000, '\P{^Blk=	ANCIENT_symbols}', "");
    Error('\p{Is_Block=/a/		ancient_symbols}');
    Error('\P{Is_Block=/a/		ancient_symbols}');
    Expect(1, 65999, '\p{Is_Block=ancientsymbols}', "");
    Expect(0, 65999, '\p{^Is_Block=ancientsymbols}', "");
    Expect(0, 65999, '\P{Is_Block=ancientsymbols}', "");
    Expect(1, 65999, '\P{^Is_Block=ancientsymbols}', "");
    Expect(0, 66000, '\p{Is_Block=ancientsymbols}', "");
    Expect(1, 66000, '\p{^Is_Block=ancientsymbols}', "");
    Expect(1, 66000, '\P{Is_Block=ancientsymbols}', "");
    Expect(0, 66000, '\P{^Is_Block=ancientsymbols}', "");
    Expect(1, 65999, '\p{Is_Block:		ANCIENT_Symbols}', "");
    Expect(0, 65999, '\p{^Is_Block:		ANCIENT_Symbols}', "");
    Expect(0, 65999, '\P{Is_Block:		ANCIENT_Symbols}', "");
    Expect(1, 65999, '\P{^Is_Block:		ANCIENT_Symbols}', "");
    Expect(0, 66000, '\p{Is_Block:		ANCIENT_Symbols}', "");
    Expect(1, 66000, '\p{^Is_Block:		ANCIENT_Symbols}', "");
    Expect(1, 66000, '\P{Is_Block:		ANCIENT_Symbols}', "");
    Expect(0, 66000, '\P{^Is_Block:		ANCIENT_Symbols}', "");
    Error('\p{Is_Blk=	_ancient_Symbols/a/}');
    Error('\P{Is_Blk=	_ancient_Symbols/a/}');
    Expect(1, 65999, '\p{Is_Blk=ancientsymbols}', "");
    Expect(0, 65999, '\p{^Is_Blk=ancientsymbols}', "");
    Expect(0, 65999, '\P{Is_Blk=ancientsymbols}', "");
    Expect(1, 65999, '\P{^Is_Blk=ancientsymbols}', "");
    Expect(0, 66000, '\p{Is_Blk=ancientsymbols}', "");
    Expect(1, 66000, '\p{^Is_Blk=ancientsymbols}', "");
    Expect(1, 66000, '\P{Is_Blk=ancientsymbols}', "");
    Expect(0, 66000, '\P{^Is_Blk=ancientsymbols}', "");
    Expect(1, 65999, '\p{Is_Blk=-Ancient_Symbols}', "");
    Expect(0, 65999, '\p{^Is_Blk=-Ancient_Symbols}', "");
    Expect(0, 65999, '\P{Is_Blk=-Ancient_Symbols}', "");
    Expect(1, 65999, '\P{^Is_Blk=-Ancient_Symbols}', "");
    Expect(0, 66000, '\p{Is_Blk=-Ancient_Symbols}', "");
    Expect(1, 66000, '\p{^Is_Blk=-Ancient_Symbols}', "");
    Expect(1, 66000, '\P{Is_Blk=-Ancient_Symbols}', "");
    Expect(0, 66000, '\P{^Is_Blk=-Ancient_Symbols}', "");
    Error('\p{Block=:=-_ARABIC}');
    Error('\P{Block=:=-_ARABIC}');
    Expect(1, 1791, '\p{Block=arabic}', "");
    Expect(0, 1791, '\p{^Block=arabic}', "");
    Expect(0, 1791, '\P{Block=arabic}', "");
    Expect(1, 1791, '\P{^Block=arabic}', "");
    Expect(0, 1792, '\p{Block=arabic}', "");
    Expect(1, 1792, '\p{^Block=arabic}', "");
    Expect(1, 1792, '\P{Block=arabic}', "");
    Expect(0, 1792, '\P{^Block=arabic}', "");
    Expect(1, 1791, '\p{Block= _Arabic}', "");
    Expect(0, 1791, '\p{^Block= _Arabic}', "");
    Expect(0, 1791, '\P{Block= _Arabic}', "");
    Expect(1, 1791, '\P{^Block= _Arabic}', "");
    Expect(0, 1792, '\p{Block= _Arabic}', "");
    Expect(1, 1792, '\p{^Block= _Arabic}', "");
    Expect(1, 1792, '\P{Block= _Arabic}', "");
    Expect(0, 1792, '\P{^Block= _Arabic}', "");
    Error('\p{Blk=:=  Arabic}');
    Error('\P{Blk=:=  Arabic}');
    Expect(1, 1791, '\p{Blk=arabic}', "");
    Expect(0, 1791, '\p{^Blk=arabic}', "");
    Expect(0, 1791, '\P{Blk=arabic}', "");
    Expect(1, 1791, '\P{^Blk=arabic}', "");
    Expect(0, 1792, '\p{Blk=arabic}', "");
    Expect(1, 1792, '\p{^Blk=arabic}', "");
    Expect(1, 1792, '\P{Blk=arabic}', "");
    Expect(0, 1792, '\P{^Blk=arabic}', "");
    Expect(1, 1791, '\p{Blk=__arabic}', "");
    Expect(0, 1791, '\p{^Blk=__arabic}', "");
    Expect(0, 1791, '\P{Blk=__arabic}', "");
    Expect(1, 1791, '\P{^Blk=__arabic}', "");
    Expect(0, 1792, '\p{Blk=__arabic}', "");
    Expect(1, 1792, '\p{^Blk=__arabic}', "");
    Expect(1, 1792, '\P{Blk=__arabic}', "");
    Expect(0, 1792, '\P{^Blk=__arabic}', "");
    Error('\p{Is_Block=:=Arabic}');
    Error('\P{Is_Block=:=Arabic}');
    Expect(1, 1791, '\p{Is_Block=arabic}', "");
    Expect(0, 1791, '\p{^Is_Block=arabic}', "");
    Expect(0, 1791, '\P{Is_Block=arabic}', "");
    Expect(1, 1791, '\P{^Is_Block=arabic}', "");
    Expect(0, 1792, '\p{Is_Block=arabic}', "");
    Expect(1, 1792, '\p{^Is_Block=arabic}', "");
    Expect(1, 1792, '\P{Is_Block=arabic}', "");
    Expect(0, 1792, '\P{^Is_Block=arabic}', "");
    Expect(1, 1791, '\p{Is_Block=-_ARABIC}', "");
    Expect(0, 1791, '\p{^Is_Block=-_ARABIC}', "");
    Expect(0, 1791, '\P{Is_Block=-_ARABIC}', "");
    Expect(1, 1791, '\P{^Is_Block=-_ARABIC}', "");
    Expect(0, 1792, '\p{Is_Block=-_ARABIC}', "");
    Expect(1, 1792, '\p{^Is_Block=-_ARABIC}', "");
    Expect(1, 1792, '\P{Is_Block=-_ARABIC}', "");
    Expect(0, 1792, '\P{^Is_Block=-_ARABIC}', "");
    Error('\p{Is_Blk=	-Arabic/a/}');
    Error('\P{Is_Blk=	-Arabic/a/}');
    Expect(1, 1791, '\p{Is_Blk=arabic}', "");
    Expect(0, 1791, '\p{^Is_Blk=arabic}', "");
    Expect(0, 1791, '\P{Is_Blk=arabic}', "");
    Expect(1, 1791, '\P{^Is_Blk=arabic}', "");
    Expect(0, 1792, '\p{Is_Blk=arabic}', "");
    Expect(1, 1792, '\p{^Is_Blk=arabic}', "");
    Expect(1, 1792, '\P{Is_Blk=arabic}', "");
    Expect(0, 1792, '\P{^Is_Blk=arabic}', "");
    Expect(1, 1791, '\p{Is_Blk:_Arabic}', "");
    Expect(0, 1791, '\p{^Is_Blk:_Arabic}', "");
    Expect(0, 1791, '\P{Is_Blk:_Arabic}', "");
    Expect(1, 1791, '\P{^Is_Blk:_Arabic}', "");
    Expect(0, 1792, '\p{Is_Blk:_Arabic}', "");
    Expect(1, 1792, '\p{^Is_Blk:_Arabic}', "");
    Expect(1, 1792, '\P{Is_Blk:_Arabic}', "");
    Expect(0, 1792, '\P{^Is_Blk:_Arabic}', "");
    Error('\p{Block=-arabic_EXTENDED_a:=}');
    Error('\P{Block=-arabic_EXTENDED_a:=}');
    Expect(1, 2303, '\p{Block=arabicextendeda}', "");
    Expect(0, 2303, '\p{^Block=arabicextendeda}', "");
    Expect(0, 2303, '\P{Block=arabicextendeda}', "");
    Expect(1, 2303, '\P{^Block=arabicextendeda}', "");
    Expect(0, 2304, '\p{Block=arabicextendeda}', "");
    Expect(1, 2304, '\p{^Block=arabicextendeda}', "");
    Expect(1, 2304, '\P{Block=arabicextendeda}', "");
    Expect(0, 2304, '\P{^Block=arabicextendeda}', "");
    Expect(1, 2303, '\p{Block:	 Arabic_Extended_a}', "");
    Expect(0, 2303, '\p{^Block:	 Arabic_Extended_a}', "");
    Expect(0, 2303, '\P{Block:	 Arabic_Extended_a}', "");
    Expect(1, 2303, '\P{^Block:	 Arabic_Extended_a}', "");
    Expect(0, 2304, '\p{Block:	 Arabic_Extended_a}', "");
    Expect(1, 2304, '\p{^Block:	 Arabic_Extended_a}', "");
    Expect(1, 2304, '\P{Block:	 Arabic_Extended_a}', "");
    Expect(0, 2304, '\P{^Block:	 Arabic_Extended_a}', "");
    Error('\p{Blk=	-arabic_Ext_A:=}');
    Error('\P{Blk=	-arabic_Ext_A:=}');
    Expect(1, 2303, '\p{Blk:   arabicexta}', "");
    Expect(0, 2303, '\p{^Blk:   arabicexta}', "");
    Expect(0, 2303, '\P{Blk:   arabicexta}', "");
    Expect(1, 2303, '\P{^Blk:   arabicexta}', "");
    Expect(0, 2304, '\p{Blk:   arabicexta}', "");
    Expect(1, 2304, '\p{^Blk:   arabicexta}', "");
    Expect(1, 2304, '\P{Blk:   arabicexta}', "");
    Expect(0, 2304, '\P{^Blk:   arabicexta}', "");
    Expect(1, 2303, '\p{Blk=_-arabic_Ext_A}', "");
    Expect(0, 2303, '\p{^Blk=_-arabic_Ext_A}', "");
    Expect(0, 2303, '\P{Blk=_-arabic_Ext_A}', "");
    Expect(1, 2303, '\P{^Blk=_-arabic_Ext_A}', "");
    Expect(0, 2304, '\p{Blk=_-arabic_Ext_A}', "");
    Expect(1, 2304, '\p{^Blk=_-arabic_Ext_A}', "");
    Expect(1, 2304, '\P{Blk=_-arabic_Ext_A}', "");
    Expect(0, 2304, '\P{^Blk=_-arabic_Ext_A}', "");
    Error('\p{Is_Block=	/a/Arabic_Extended_A}');
    Error('\P{Is_Block=	/a/Arabic_Extended_A}');
    Expect(1, 2303, '\p{Is_Block=arabicextendeda}', "");
    Expect(0, 2303, '\p{^Is_Block=arabicextendeda}', "");
    Expect(0, 2303, '\P{Is_Block=arabicextendeda}', "");
    Expect(1, 2303, '\P{^Is_Block=arabicextendeda}', "");
    Expect(0, 2304, '\p{Is_Block=arabicextendeda}', "");
    Expect(1, 2304, '\p{^Is_Block=arabicextendeda}', "");
    Expect(1, 2304, '\P{Is_Block=arabicextendeda}', "");
    Expect(0, 2304, '\P{^Is_Block=arabicextendeda}', "");
    Expect(1, 2303, '\p{Is_Block= ARABIC_extended_A}', "");
    Expect(0, 2303, '\p{^Is_Block= ARABIC_extended_A}', "");
    Expect(0, 2303, '\P{Is_Block= ARABIC_extended_A}', "");
    Expect(1, 2303, '\P{^Is_Block= ARABIC_extended_A}', "");
    Expect(0, 2304, '\p{Is_Block= ARABIC_extended_A}', "");
    Expect(1, 2304, '\p{^Is_Block= ARABIC_extended_A}', "");
    Expect(1, 2304, '\P{Is_Block= ARABIC_extended_A}', "");
    Expect(0, 2304, '\P{^Is_Block= ARABIC_extended_A}', "");
    Error('\p{Is_Blk= /a/ARABIC_EXT_A}');
    Error('\P{Is_Blk= /a/ARABIC_EXT_A}');
    Expect(1, 2303, '\p{Is_Blk=arabicexta}', "");
    Expect(0, 2303, '\p{^Is_Blk=arabicexta}', "");
    Expect(0, 2303, '\P{Is_Blk=arabicexta}', "");
    Expect(1, 2303, '\P{^Is_Blk=arabicexta}', "");
    Expect(0, 2304, '\p{Is_Blk=arabicexta}', "");
    Expect(1, 2304, '\p{^Is_Blk=arabicexta}', "");
    Expect(1, 2304, '\P{Is_Blk=arabicexta}', "");
    Expect(0, 2304, '\P{^Is_Blk=arabicexta}', "");
    Expect(1, 2303, '\p{Is_Blk=_Arabic_ext_A}', "");
    Expect(0, 2303, '\p{^Is_Blk=_Arabic_ext_A}', "");
    Expect(0, 2303, '\P{Is_Blk=_Arabic_ext_A}', "");
    Expect(1, 2303, '\P{^Is_Blk=_Arabic_ext_A}', "");
    Expect(0, 2304, '\p{Is_Blk=_Arabic_ext_A}', "");
    Expect(1, 2304, '\p{^Is_Blk=_Arabic_ext_A}', "");
    Expect(1, 2304, '\P{Is_Blk=_Arabic_ext_A}', "");
    Expect(0, 2304, '\P{^Is_Blk=_Arabic_ext_A}', "");
    Error('\p{Block=	ARABIC_Mathematical_alphabetic_symbols/a/}');
    Error('\P{Block=	ARABIC_Mathematical_alphabetic_symbols/a/}');
    Expect(1, 126719, '\p{Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\p{^Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\P{Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\P{^Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\p{Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\p{^Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\P{Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\P{^Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\p{Block=		ARABIC_mathematical_Alphabetic_Symbols}', "");
    Expect(0, 126719, '\p{^Block=		ARABIC_mathematical_Alphabetic_Symbols}', "");
    Expect(0, 126719, '\P{Block=		ARABIC_mathematical_Alphabetic_Symbols}', "");
    Expect(1, 126719, '\P{^Block=		ARABIC_mathematical_Alphabetic_Symbols}', "");
    Expect(0, 126720, '\p{Block=		ARABIC_mathematical_Alphabetic_Symbols}', "");
    Expect(1, 126720, '\p{^Block=		ARABIC_mathematical_Alphabetic_Symbols}', "");
    Expect(1, 126720, '\P{Block=		ARABIC_mathematical_Alphabetic_Symbols}', "");
    Expect(0, 126720, '\P{^Block=		ARABIC_mathematical_Alphabetic_Symbols}', "");
    Error('\p{Blk=	/a/Arabic_Math}');
    Error('\P{Blk=	/a/Arabic_Math}');
    Expect(1, 126719, '\p{Blk:   arabicmath}', "");
    Expect(0, 126719, '\p{^Blk:   arabicmath}', "");
    Expect(0, 126719, '\P{Blk:   arabicmath}', "");
    Expect(1, 126719, '\P{^Blk:   arabicmath}', "");
    Expect(0, 126720, '\p{Blk:   arabicmath}', "");
    Expect(1, 126720, '\p{^Blk:   arabicmath}', "");
    Expect(1, 126720, '\P{Blk:   arabicmath}', "");
    Expect(0, 126720, '\P{^Blk:   arabicmath}', "");
    Expect(1, 126719, '\p{Blk:	_-arabic_Math}', "");
    Expect(0, 126719, '\p{^Blk:	_-arabic_Math}', "");
    Expect(0, 126719, '\P{Blk:	_-arabic_Math}', "");
    Expect(1, 126719, '\P{^Blk:	_-arabic_Math}', "");
    Expect(0, 126720, '\p{Blk:	_-arabic_Math}', "");
    Expect(1, 126720, '\p{^Blk:	_-arabic_Math}', "");
    Expect(1, 126720, '\P{Blk:	_-arabic_Math}', "");
    Expect(0, 126720, '\P{^Blk:	_-arabic_Math}', "");
    Error('\p{Is_Block=	ARABIC_Mathematical_Alphabetic_SYMBOLS/a/}');
    Error('\P{Is_Block=	ARABIC_Mathematical_Alphabetic_SYMBOLS/a/}');
    Expect(1, 126719, '\p{Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\p{^Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\P{Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\P{^Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\p{Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\p{^Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\P{Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\P{^Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\p{Is_Block=_	ARABIC_Mathematical_Alphabetic_SYMBOLS}', "");
    Expect(0, 126719, '\p{^Is_Block=_	ARABIC_Mathematical_Alphabetic_SYMBOLS}', "");
    Expect(0, 126719, '\P{Is_Block=_	ARABIC_Mathematical_Alphabetic_SYMBOLS}', "");
    Expect(1, 126719, '\P{^Is_Block=_	ARABIC_Mathematical_Alphabetic_SYMBOLS}', "");
    Expect(0, 126720, '\p{Is_Block=_	ARABIC_Mathematical_Alphabetic_SYMBOLS}', "");
    Expect(1, 126720, '\p{^Is_Block=_	ARABIC_Mathematical_Alphabetic_SYMBOLS}', "");
    Expect(1, 126720, '\P{Is_Block=_	ARABIC_Mathematical_Alphabetic_SYMBOLS}', "");
    Expect(0, 126720, '\P{^Is_Block=_	ARABIC_Mathematical_Alphabetic_SYMBOLS}', "");
    Error('\p{Is_Blk=--ARABIC_Math:=}');
    Error('\P{Is_Blk=--ARABIC_Math:=}');
    Expect(1, 126719, '\p{Is_Blk=arabicmath}', "");
    Expect(0, 126719, '\p{^Is_Blk=arabicmath}', "");
    Expect(0, 126719, '\P{Is_Blk=arabicmath}', "");
    Expect(1, 126719, '\P{^Is_Blk=arabicmath}', "");
    Expect(0, 126720, '\p{Is_Blk=arabicmath}', "");
    Expect(1, 126720, '\p{^Is_Blk=arabicmath}', "");
    Expect(1, 126720, '\P{Is_Blk=arabicmath}', "");
    Expect(0, 126720, '\P{^Is_Blk=arabicmath}', "");
    Expect(1, 126719, '\p{Is_Blk=_arabic_MATH}', "");
    Expect(0, 126719, '\p{^Is_Blk=_arabic_MATH}', "");
    Expect(0, 126719, '\P{Is_Blk=_arabic_MATH}', "");
    Expect(1, 126719, '\P{^Is_Blk=_arabic_MATH}', "");
    Expect(0, 126720, '\p{Is_Blk=_arabic_MATH}', "");
    Expect(1, 126720, '\p{^Is_Blk=_arabic_MATH}', "");
    Expect(1, 126720, '\P{Is_Blk=_arabic_MATH}', "");
    Expect(0, 126720, '\P{^Is_Blk=_arabic_MATH}', "");
    Error('\p{Block=/a/		ARABIC_PRESENTATION_Forms_a}');
    Error('\P{Block=/a/		ARABIC_PRESENTATION_Forms_a}');
    Expect(1, 65023, '\p{Block=arabicpresentationformsa}', "");
    Expect(0, 65023, '\p{^Block=arabicpresentationformsa}', "");
    Expect(0, 65023, '\P{Block=arabicpresentationformsa}', "");
    Expect(1, 65023, '\P{^Block=arabicpresentationformsa}', "");
    Expect(0, 65024, '\p{Block=arabicpresentationformsa}', "");
    Expect(1, 65024, '\p{^Block=arabicpresentationformsa}', "");
    Expect(1, 65024, '\P{Block=arabicpresentationformsa}', "");
    Expect(0, 65024, '\P{^Block=arabicpresentationformsa}', "");
    Expect(1, 65023, '\p{Block= _ARABIC_Presentation_Forms_A}', "");
    Expect(0, 65023, '\p{^Block= _ARABIC_Presentation_Forms_A}', "");
    Expect(0, 65023, '\P{Block= _ARABIC_Presentation_Forms_A}', "");
    Expect(1, 65023, '\P{^Block= _ARABIC_Presentation_Forms_A}', "");
    Expect(0, 65024, '\p{Block= _ARABIC_Presentation_Forms_A}', "");
    Expect(1, 65024, '\p{^Block= _ARABIC_Presentation_Forms_A}', "");
    Expect(1, 65024, '\P{Block= _ARABIC_Presentation_Forms_A}', "");
    Expect(0, 65024, '\P{^Block= _ARABIC_Presentation_Forms_A}', "");
    Error('\p{Blk=	Arabic_pf_A:=}');
    Error('\P{Blk=	Arabic_pf_A:=}');
    Expect(1, 65023, '\p{Blk=arabicpfa}', "");
    Expect(0, 65023, '\p{^Blk=arabicpfa}', "");
    Expect(0, 65023, '\P{Blk=arabicpfa}', "");
    Expect(1, 65023, '\P{^Blk=arabicpfa}', "");
    Expect(0, 65024, '\p{Blk=arabicpfa}', "");
    Expect(1, 65024, '\p{^Blk=arabicpfa}', "");
    Expect(1, 65024, '\P{Blk=arabicpfa}', "");
    Expect(0, 65024, '\P{^Blk=arabicpfa}', "");
    Expect(1, 65023, '\p{Blk= arabic_PF_A}', "");
    Expect(0, 65023, '\p{^Blk= arabic_PF_A}', "");
    Expect(0, 65023, '\P{Blk= arabic_PF_A}', "");
    Expect(1, 65023, '\P{^Blk= arabic_PF_A}', "");
    Expect(0, 65024, '\p{Blk= arabic_PF_A}', "");
    Expect(1, 65024, '\p{^Blk= arabic_PF_A}', "");
    Expect(1, 65024, '\P{Blk= arabic_PF_A}', "");
    Expect(0, 65024, '\P{^Blk= arabic_PF_A}', "");
    Error('\p{Is_Block=:=Arabic_presentation_Forms_A}');
    Error('\P{Is_Block=:=Arabic_presentation_Forms_A}');
    Expect(1, 65023, '\p{Is_Block=arabicpresentationformsa}', "");
    Expect(0, 65023, '\p{^Is_Block=arabicpresentationformsa}', "");
    Expect(0, 65023, '\P{Is_Block=arabicpresentationformsa}', "");
    Expect(1, 65023, '\P{^Is_Block=arabicpresentationformsa}', "");
    Expect(0, 65024, '\p{Is_Block=arabicpresentationformsa}', "");
    Expect(1, 65024, '\p{^Is_Block=arabicpresentationformsa}', "");
    Expect(1, 65024, '\P{Is_Block=arabicpresentationformsa}', "");
    Expect(0, 65024, '\P{^Is_Block=arabicpresentationformsa}', "");
    Expect(1, 65023, '\p{Is_Block=--Arabic_Presentation_Forms_A}', "");
    Expect(0, 65023, '\p{^Is_Block=--Arabic_Presentation_Forms_A}', "");
    Expect(0, 65023, '\P{Is_Block=--Arabic_Presentation_Forms_A}', "");
    Expect(1, 65023, '\P{^Is_Block=--Arabic_Presentation_Forms_A}', "");
    Expect(0, 65024, '\p{Is_Block=--Arabic_Presentation_Forms_A}', "");
    Expect(1, 65024, '\p{^Is_Block=--Arabic_Presentation_Forms_A}', "");
    Expect(1, 65024, '\P{Is_Block=--Arabic_Presentation_Forms_A}', "");
    Expect(0, 65024, '\P{^Is_Block=--Arabic_Presentation_Forms_A}', "");
    Error('\p{Is_Blk=/a/ _Arabic_PF_A}');
    Error('\P{Is_Blk=/a/ _Arabic_PF_A}');
    Expect(1, 65023, '\p{Is_Blk=arabicpfa}', "");
    Expect(0, 65023, '\p{^Is_Blk=arabicpfa}', "");
    Expect(0, 65023, '\P{Is_Blk=arabicpfa}', "");
    Expect(1, 65023, '\P{^Is_Blk=arabicpfa}', "");
    Expect(0, 65024, '\p{Is_Blk=arabicpfa}', "");
    Expect(1, 65024, '\p{^Is_Blk=arabicpfa}', "");
    Expect(1, 65024, '\P{Is_Blk=arabicpfa}', "");
    Expect(0, 65024, '\P{^Is_Blk=arabicpfa}', "");
    Expect(1, 65023, '\p{Is_Blk=	Arabic_pf_A}', "");
    Expect(0, 65023, '\p{^Is_Blk=	Arabic_pf_A}', "");
    Expect(0, 65023, '\P{Is_Blk=	Arabic_pf_A}', "");
    Expect(1, 65023, '\P{^Is_Blk=	Arabic_pf_A}', "");
    Expect(0, 65024, '\p{Is_Blk=	Arabic_pf_A}', "");
    Expect(1, 65024, '\p{^Is_Blk=	Arabic_pf_A}', "");
    Expect(1, 65024, '\P{Is_Blk=	Arabic_pf_A}', "");
    Expect(0, 65024, '\P{^Is_Blk=	Arabic_pf_A}', "");
    Error('\p{Block=  ARABIC_presentation_FORMS_b:=}');
    Error('\P{Block=  ARABIC_presentation_FORMS_b:=}');
    Expect(1, 65279, '\p{Block=arabicpresentationformsb}', "");
    Expect(0, 65279, '\p{^Block=arabicpresentationformsb}', "");
    Expect(0, 65279, '\P{Block=arabicpresentationformsb}', "");
    Expect(1, 65279, '\P{^Block=arabicpresentationformsb}', "");
    Expect(0, 65280, '\p{Block=arabicpresentationformsb}', "");
    Expect(1, 65280, '\p{^Block=arabicpresentationformsb}', "");
    Expect(1, 65280, '\P{Block=arabicpresentationformsb}', "");
    Expect(0, 65280, '\P{^Block=arabicpresentationformsb}', "");
    Expect(1, 65279, '\p{Block:		Arabic_PRESENTATION_forms_B}', "");
    Expect(0, 65279, '\p{^Block:		Arabic_PRESENTATION_forms_B}', "");
    Expect(0, 65279, '\P{Block:		Arabic_PRESENTATION_forms_B}', "");
    Expect(1, 65279, '\P{^Block:		Arabic_PRESENTATION_forms_B}', "");
    Expect(0, 65280, '\p{Block:		Arabic_PRESENTATION_forms_B}', "");
    Expect(1, 65280, '\p{^Block:		Arabic_PRESENTATION_forms_B}', "");
    Expect(1, 65280, '\P{Block:		Arabic_PRESENTATION_forms_B}', "");
    Expect(0, 65280, '\P{^Block:		Arabic_PRESENTATION_forms_B}', "");
    Error('\p{Blk=:=--Arabic_pf_B}');
    Error('\P{Blk=:=--Arabic_pf_B}');
    Expect(1, 65279, '\p{Blk=arabicpfb}', "");
    Expect(0, 65279, '\p{^Blk=arabicpfb}', "");
    Expect(0, 65279, '\P{Blk=arabicpfb}', "");
    Expect(1, 65279, '\P{^Blk=arabicpfb}', "");
    Expect(0, 65280, '\p{Blk=arabicpfb}', "");
    Expect(1, 65280, '\p{^Blk=arabicpfb}', "");
    Expect(1, 65280, '\P{Blk=arabicpfb}', "");
    Expect(0, 65280, '\P{^Blk=arabicpfb}', "");
    Expect(1, 65279, '\p{Blk=_ Arabic_pf_B}', "");
    Expect(0, 65279, '\p{^Blk=_ Arabic_pf_B}', "");
    Expect(0, 65279, '\P{Blk=_ Arabic_pf_B}', "");
    Expect(1, 65279, '\P{^Blk=_ Arabic_pf_B}', "");
    Expect(0, 65280, '\p{Blk=_ Arabic_pf_B}', "");
    Expect(1, 65280, '\p{^Blk=_ Arabic_pf_B}', "");
    Expect(1, 65280, '\P{Blk=_ Arabic_pf_B}', "");
    Expect(0, 65280, '\P{^Blk=_ Arabic_pf_B}', "");
    Error('\p{Is_Block=/a/-_arabic_PRESENTATION_Forms_B}');
    Error('\P{Is_Block=/a/-_arabic_PRESENTATION_Forms_B}');
    Expect(1, 65279, '\p{Is_Block:arabicpresentationformsb}', "");
    Expect(0, 65279, '\p{^Is_Block:arabicpresentationformsb}', "");
    Expect(0, 65279, '\P{Is_Block:arabicpresentationformsb}', "");
    Expect(1, 65279, '\P{^Is_Block:arabicpresentationformsb}', "");
    Expect(0, 65280, '\p{Is_Block:arabicpresentationformsb}', "");
    Expect(1, 65280, '\p{^Is_Block:arabicpresentationformsb}', "");
    Expect(1, 65280, '\P{Is_Block:arabicpresentationformsb}', "");
    Expect(0, 65280, '\P{^Is_Block:arabicpresentationformsb}', "");
    Expect(1, 65279, '\p{Is_Block=-_ARABIC_presentation_FORMS_B}', "");
    Expect(0, 65279, '\p{^Is_Block=-_ARABIC_presentation_FORMS_B}', "");
    Expect(0, 65279, '\P{Is_Block=-_ARABIC_presentation_FORMS_B}', "");
    Expect(1, 65279, '\P{^Is_Block=-_ARABIC_presentation_FORMS_B}', "");
    Expect(0, 65280, '\p{Is_Block=-_ARABIC_presentation_FORMS_B}', "");
    Expect(1, 65280, '\p{^Is_Block=-_ARABIC_presentation_FORMS_B}', "");
    Expect(1, 65280, '\P{Is_Block=-_ARABIC_presentation_FORMS_B}', "");
    Expect(0, 65280, '\P{^Is_Block=-_ARABIC_presentation_FORMS_B}', "");
    Error('\p{Is_Blk: /a/__Arabic_PF_b}');
    Error('\P{Is_Blk: /a/__Arabic_PF_b}');
    Expect(1, 65279, '\p{Is_Blk=arabicpfb}', "");
    Expect(0, 65279, '\p{^Is_Blk=arabicpfb}', "");
    Expect(0, 65279, '\P{Is_Blk=arabicpfb}', "");
    Expect(1, 65279, '\P{^Is_Blk=arabicpfb}', "");
    Expect(0, 65280, '\p{Is_Blk=arabicpfb}', "");
    Expect(1, 65280, '\p{^Is_Blk=arabicpfb}', "");
    Expect(1, 65280, '\P{Is_Blk=arabicpfb}', "");
    Expect(0, 65280, '\P{^Is_Blk=arabicpfb}', "");
    Expect(1, 65279, '\p{Is_Blk=_ARABIC_pf_B}', "");
    Expect(0, 65279, '\p{^Is_Blk=_ARABIC_pf_B}', "");
    Expect(0, 65279, '\P{Is_Blk=_ARABIC_pf_B}', "");
    Expect(1, 65279, '\P{^Is_Blk=_ARABIC_pf_B}', "");
    Expect(0, 65280, '\p{Is_Blk=_ARABIC_pf_B}', "");
    Expect(1, 65280, '\p{^Is_Blk=_ARABIC_pf_B}', "");
    Expect(1, 65280, '\P{Is_Blk=_ARABIC_pf_B}', "");
    Expect(0, 65280, '\P{^Is_Blk=_ARABIC_pf_B}', "");
    Error('\p{Block=-:=arabic_Supplement}');
    Error('\P{Block=-:=arabic_Supplement}');
    Expect(1, 1919, '\p{Block=arabicsupplement}', "");
    Expect(0, 1919, '\p{^Block=arabicsupplement}', "");
    Expect(0, 1919, '\P{Block=arabicsupplement}', "");
    Expect(1, 1919, '\P{^Block=arabicsupplement}', "");
    Expect(0, 1920, '\p{Block=arabicsupplement}', "");
    Expect(1, 1920, '\p{^Block=arabicsupplement}', "");
    Expect(1, 1920, '\P{Block=arabicsupplement}', "");
    Expect(0, 1920, '\P{^Block=arabicsupplement}', "");
    Expect(1, 1919, '\p{Block=	-ARABIC_Supplement}', "");
    Expect(0, 1919, '\p{^Block=	-ARABIC_Supplement}', "");
    Expect(0, 1919, '\P{Block=	-ARABIC_Supplement}', "");
    Expect(1, 1919, '\P{^Block=	-ARABIC_Supplement}', "");
    Expect(0, 1920, '\p{Block=	-ARABIC_Supplement}', "");
    Expect(1, 1920, '\p{^Block=	-ARABIC_Supplement}', "");
    Expect(1, 1920, '\P{Block=	-ARABIC_Supplement}', "");
    Expect(0, 1920, '\P{^Block=	-ARABIC_Supplement}', "");
    Error('\p{Blk=:=-	arabic_Sup}');
    Error('\P{Blk=:=-	arabic_Sup}');
    Expect(1, 1919, '\p{Blk=arabicsup}', "");
    Expect(0, 1919, '\p{^Blk=arabicsup}', "");
    Expect(0, 1919, '\P{Blk=arabicsup}', "");
    Expect(1, 1919, '\P{^Blk=arabicsup}', "");
    Expect(0, 1920, '\p{Blk=arabicsup}', "");
    Expect(1, 1920, '\p{^Blk=arabicsup}', "");
    Expect(1, 1920, '\P{Blk=arabicsup}', "");
    Expect(0, 1920, '\P{^Blk=arabicsup}', "");
    Expect(1, 1919, '\p{Blk:	_arabic_sup}', "");
    Expect(0, 1919, '\p{^Blk:	_arabic_sup}', "");
    Expect(0, 1919, '\P{Blk:	_arabic_sup}', "");
    Expect(1, 1919, '\P{^Blk:	_arabic_sup}', "");
    Expect(0, 1920, '\p{Blk:	_arabic_sup}', "");
    Expect(1, 1920, '\p{^Blk:	_arabic_sup}', "");
    Expect(1, 1920, '\P{Blk:	_arabic_sup}', "");
    Expect(0, 1920, '\P{^Blk:	_arabic_sup}', "");
    Error('\p{Is_Block=/a/ARABIC_supplement}');
    Error('\P{Is_Block=/a/ARABIC_supplement}');
    Expect(1, 1919, '\p{Is_Block=arabicsupplement}', "");
    Expect(0, 1919, '\p{^Is_Block=arabicsupplement}', "");
    Expect(0, 1919, '\P{Is_Block=arabicsupplement}', "");
    Expect(1, 1919, '\P{^Is_Block=arabicsupplement}', "");
    Expect(0, 1920, '\p{Is_Block=arabicsupplement}', "");
    Expect(1, 1920, '\p{^Is_Block=arabicsupplement}', "");
    Expect(1, 1920, '\P{Is_Block=arabicsupplement}', "");
    Expect(0, 1920, '\P{^Is_Block=arabicsupplement}', "");
    Expect(1, 1919, '\p{Is_Block=-Arabic_SUPPLEMENT}', "");
    Expect(0, 1919, '\p{^Is_Block=-Arabic_SUPPLEMENT}', "");
    Expect(0, 1919, '\P{Is_Block=-Arabic_SUPPLEMENT}', "");
    Expect(1, 1919, '\P{^Is_Block=-Arabic_SUPPLEMENT}', "");
    Expect(0, 1920, '\p{Is_Block=-Arabic_SUPPLEMENT}', "");
    Expect(1, 1920, '\p{^Is_Block=-Arabic_SUPPLEMENT}', "");
    Expect(1, 1920, '\P{Is_Block=-Arabic_SUPPLEMENT}', "");
    Expect(0, 1920, '\P{^Is_Block=-Arabic_SUPPLEMENT}', "");
    Error('\p{Is_Blk:    _Arabic_Sup:=}');
    Error('\P{Is_Blk:    _Arabic_Sup:=}');
    Expect(1, 1919, '\p{Is_Blk=arabicsup}', "");
    Expect(0, 1919, '\p{^Is_Blk=arabicsup}', "");
    Expect(0, 1919, '\P{Is_Blk=arabicsup}', "");
    Expect(1, 1919, '\P{^Is_Blk=arabicsup}', "");
    Expect(0, 1920, '\p{Is_Blk=arabicsup}', "");
    Expect(1, 1920, '\p{^Is_Blk=arabicsup}', "");
    Expect(1, 1920, '\P{Is_Blk=arabicsup}', "");
    Expect(0, 1920, '\P{^Is_Blk=arabicsup}', "");
    Expect(1, 1919, '\p{Is_Blk:	-ARABIC_SUP}', "");
    Expect(0, 1919, '\p{^Is_Blk:	-ARABIC_SUP}', "");
    Expect(0, 1919, '\P{Is_Blk:	-ARABIC_SUP}', "");
    Expect(1, 1919, '\P{^Is_Blk:	-ARABIC_SUP}', "");
    Expect(0, 1920, '\p{Is_Blk:	-ARABIC_SUP}', "");
    Expect(1, 1920, '\p{^Is_Blk:	-ARABIC_SUP}', "");
    Expect(1, 1920, '\P{Is_Blk:	-ARABIC_SUP}', "");
    Expect(0, 1920, '\P{^Is_Blk:	-ARABIC_SUP}', "");
    Error('\p{Block=/a/	-armenian}');
    Error('\P{Block=/a/	-armenian}');
    Expect(1, 1423, '\p{Block=armenian}', "");
    Expect(0, 1423, '\p{^Block=armenian}', "");
    Expect(0, 1423, '\P{Block=armenian}', "");
    Expect(1, 1423, '\P{^Block=armenian}', "");
    Expect(0, 1424, '\p{Block=armenian}', "");
    Expect(1, 1424, '\p{^Block=armenian}', "");
    Expect(1, 1424, '\P{Block=armenian}', "");
    Expect(0, 1424, '\P{^Block=armenian}', "");
    Expect(1, 1423, '\p{Block= 	Armenian}', "");
    Expect(0, 1423, '\p{^Block= 	Armenian}', "");
    Expect(0, 1423, '\P{Block= 	Armenian}', "");
    Expect(1, 1423, '\P{^Block= 	Armenian}', "");
    Expect(0, 1424, '\p{Block= 	Armenian}', "");
    Expect(1, 1424, '\p{^Block= 	Armenian}', "");
    Expect(1, 1424, '\P{Block= 	Armenian}', "");
    Expect(0, 1424, '\P{^Block= 	Armenian}', "");
    Error('\p{Blk=	_ARMENIAN:=}');
    Error('\P{Blk=	_ARMENIAN:=}');
    Expect(1, 1423, '\p{Blk=armenian}', "");
    Expect(0, 1423, '\p{^Blk=armenian}', "");
    Expect(0, 1423, '\P{Blk=armenian}', "");
    Expect(1, 1423, '\P{^Blk=armenian}', "");
    Expect(0, 1424, '\p{Blk=armenian}', "");
    Expect(1, 1424, '\p{^Blk=armenian}', "");
    Expect(1, 1424, '\P{Blk=armenian}', "");
    Expect(0, 1424, '\P{^Blk=armenian}', "");
    Expect(1, 1423, '\p{Blk= -Armenian}', "");
    Expect(0, 1423, '\p{^Blk= -Armenian}', "");
    Expect(0, 1423, '\P{Blk= -Armenian}', "");
    Expect(1, 1423, '\P{^Blk= -Armenian}', "");
    Expect(0, 1424, '\p{Blk= -Armenian}', "");
    Expect(1, 1424, '\p{^Blk= -Armenian}', "");
    Expect(1, 1424, '\P{Blk= -Armenian}', "");
    Expect(0, 1424, '\P{^Blk= -Armenian}', "");
    Error('\p{Is_Block=- Armenian/a/}');
    Error('\P{Is_Block=- Armenian/a/}');
    Expect(1, 1423, '\p{Is_Block=armenian}', "");
    Expect(0, 1423, '\p{^Is_Block=armenian}', "");
    Expect(0, 1423, '\P{Is_Block=armenian}', "");
    Expect(1, 1423, '\P{^Is_Block=armenian}', "");
    Expect(0, 1424, '\p{Is_Block=armenian}', "");
    Expect(1, 1424, '\p{^Is_Block=armenian}', "");
    Expect(1, 1424, '\P{Is_Block=armenian}', "");
    Expect(0, 1424, '\P{^Is_Block=armenian}', "");
    Error('\p{Is_Blk=	-Armenian/a/}');
    Error('\P{Is_Blk=	-Armenian/a/}');
    Expect(1, 1423, '\p{Is_Blk=armenian}', "");
    Expect(0, 1423, '\p{^Is_Blk=armenian}', "");
    Expect(0, 1423, '\P{Is_Blk=armenian}', "");
    Expect(1, 1423, '\P{^Is_Blk=armenian}', "");
    Expect(0, 1424, '\p{Is_Blk=armenian}', "");
    Expect(1, 1424, '\p{^Is_Blk=armenian}', "");
    Expect(1, 1424, '\P{Is_Blk=armenian}', "");
    Expect(0, 1424, '\P{^Is_Blk=armenian}', "");
    Expect(1, 1423, '\p{Is_Blk=	-Armenian}', "");
    Expect(0, 1423, '\p{^Is_Blk=	-Armenian}', "");
    Expect(0, 1423, '\P{Is_Blk=	-Armenian}', "");
    Expect(1, 1423, '\P{^Is_Blk=	-Armenian}', "");
    Expect(0, 1424, '\p{Is_Blk=	-Armenian}', "");
    Expect(1, 1424, '\p{^Is_Blk=	-Armenian}', "");
    Expect(1, 1424, '\P{Is_Blk=	-Armenian}', "");
    Expect(0, 1424, '\P{^Is_Blk=	-Armenian}', "");
    Error('\p{Block=	:=Arrows}');
    Error('\P{Block=	:=Arrows}');
    Expect(1, 8703, '\p{Block=arrows}', "");
    Expect(0, 8703, '\p{^Block=arrows}', "");
    Expect(0, 8703, '\P{Block=arrows}', "");
    Expect(1, 8703, '\P{^Block=arrows}', "");
    Expect(0, 8704, '\p{Block=arrows}', "");
    Expect(1, 8704, '\p{^Block=arrows}', "");
    Expect(1, 8704, '\P{Block=arrows}', "");
    Expect(0, 8704, '\P{^Block=arrows}', "");
    Expect(1, 8703, '\p{Block=_	arrows}', "");
    Expect(0, 8703, '\p{^Block=_	arrows}', "");
    Expect(0, 8703, '\P{Block=_	arrows}', "");
    Expect(1, 8703, '\P{^Block=_	arrows}', "");
    Expect(0, 8704, '\p{Block=_	arrows}', "");
    Expect(1, 8704, '\p{^Block=_	arrows}', "");
    Expect(1, 8704, '\P{Block=_	arrows}', "");
    Expect(0, 8704, '\P{^Block=_	arrows}', "");
    Error('\p{Blk=- ARROWS:=}');
    Error('\P{Blk=- ARROWS:=}');
    Expect(1, 8703, '\p{Blk=arrows}', "");
    Expect(0, 8703, '\p{^Blk=arrows}', "");
    Expect(0, 8703, '\P{Blk=arrows}', "");
    Expect(1, 8703, '\P{^Blk=arrows}', "");
    Expect(0, 8704, '\p{Blk=arrows}', "");
    Expect(1, 8704, '\p{^Blk=arrows}', "");
    Expect(1, 8704, '\P{Blk=arrows}', "");
    Expect(0, 8704, '\P{^Blk=arrows}', "");
    Expect(1, 8703, '\p{Blk:   	Arrows}', "");
    Expect(0, 8703, '\p{^Blk:   	Arrows}', "");
    Expect(0, 8703, '\P{Blk:   	Arrows}', "");
    Expect(1, 8703, '\P{^Blk:   	Arrows}', "");
    Expect(0, 8704, '\p{Blk:   	Arrows}', "");
    Expect(1, 8704, '\p{^Blk:   	Arrows}', "");
    Expect(1, 8704, '\P{Blk:   	Arrows}', "");
    Expect(0, 8704, '\P{^Blk:   	Arrows}', "");
    Error('\p{Is_Block=:=_Arrows}');
    Error('\P{Is_Block=:=_Arrows}');
    Expect(1, 8703, '\p{Is_Block=arrows}', "");
    Expect(0, 8703, '\p{^Is_Block=arrows}', "");
    Expect(0, 8703, '\P{Is_Block=arrows}', "");
    Expect(1, 8703, '\P{^Is_Block=arrows}', "");
    Expect(0, 8704, '\p{Is_Block=arrows}', "");
    Expect(1, 8704, '\p{^Is_Block=arrows}', "");
    Expect(1, 8704, '\P{Is_Block=arrows}', "");
    Expect(0, 8704, '\P{^Is_Block=arrows}', "");
    Expect(1, 8703, '\p{Is_Block=-_ARROWS}', "");
    Expect(0, 8703, '\p{^Is_Block=-_ARROWS}', "");
    Expect(0, 8703, '\P{Is_Block=-_ARROWS}', "");
    Expect(1, 8703, '\P{^Is_Block=-_ARROWS}', "");
    Expect(0, 8704, '\p{Is_Block=-_ARROWS}', "");
    Expect(1, 8704, '\p{^Is_Block=-_ARROWS}', "");
    Expect(1, 8704, '\P{Is_Block=-_ARROWS}', "");
    Expect(0, 8704, '\P{^Is_Block=-_ARROWS}', "");
    Error('\p{Is_Blk=:=  Arrows}');
    Error('\P{Is_Blk=:=  Arrows}');
    Expect(1, 8703, '\p{Is_Blk=arrows}', "");
    Expect(0, 8703, '\p{^Is_Blk=arrows}', "");
    Expect(0, 8703, '\P{Is_Blk=arrows}', "");
    Expect(1, 8703, '\P{^Is_Blk=arrows}', "");
    Expect(0, 8704, '\p{Is_Blk=arrows}', "");
    Expect(1, 8704, '\p{^Is_Blk=arrows}', "");
    Expect(1, 8704, '\P{Is_Blk=arrows}', "");
    Expect(0, 8704, '\P{^Is_Blk=arrows}', "");
    Expect(1, 8703, '\p{Is_Blk= 	ARROWS}', "");
    Expect(0, 8703, '\p{^Is_Blk= 	ARROWS}', "");
    Expect(0, 8703, '\P{Is_Blk= 	ARROWS}', "");
    Expect(1, 8703, '\P{^Is_Blk= 	ARROWS}', "");
    Expect(0, 8704, '\p{Is_Blk= 	ARROWS}', "");
    Expect(1, 8704, '\p{^Is_Blk= 	ARROWS}', "");
    Expect(1, 8704, '\P{Is_Blk= 	ARROWS}', "");
    Expect(0, 8704, '\P{^Is_Blk= 	ARROWS}', "");
    Error('\p{Block=		BASIC_Latin:=}');
    Error('\P{Block=		BASIC_Latin:=}');
    Expect(1, 127, '\p{Block=basiclatin}', "");
    Expect(0, 127, '\p{^Block=basiclatin}', "");
    Expect(0, 127, '\P{Block=basiclatin}', "");
    Expect(1, 127, '\P{^Block=basiclatin}', "");
    Expect(0, 128, '\p{Block=basiclatin}', "");
    Expect(1, 128, '\p{^Block=basiclatin}', "");
    Expect(1, 128, '\P{Block=basiclatin}', "");
    Expect(0, 128, '\P{^Block=basiclatin}', "");
    Expect(1, 127, '\p{Block=	 basic_Latin}', "");
    Expect(0, 127, '\p{^Block=	 basic_Latin}', "");
    Expect(0, 127, '\P{Block=	 basic_Latin}', "");
    Expect(1, 127, '\P{^Block=	 basic_Latin}', "");
    Expect(0, 128, '\p{Block=	 basic_Latin}', "");
    Expect(1, 128, '\p{^Block=	 basic_Latin}', "");
    Expect(1, 128, '\P{Block=	 basic_Latin}', "");
    Expect(0, 128, '\P{^Block=	 basic_Latin}', "");
    Error('\p{Blk=	 ascii/a/}');
    Error('\P{Blk=	 ascii/a/}');
    Expect(1, 127, '\p{Blk=ascii}', "");
    Expect(0, 127, '\p{^Blk=ascii}', "");
    Expect(0, 127, '\P{Blk=ascii}', "");
    Expect(1, 127, '\P{^Blk=ascii}', "");
    Expect(0, 128, '\p{Blk=ascii}', "");
    Expect(1, 128, '\p{^Blk=ascii}', "");
    Expect(1, 128, '\P{Blk=ascii}', "");
    Expect(0, 128, '\P{^Blk=ascii}', "");
    Expect(1, 127, '\p{Blk=- ASCII}', "");
    Expect(0, 127, '\p{^Blk=- ASCII}', "");
    Expect(0, 127, '\P{Blk=- ASCII}', "");
    Expect(1, 127, '\P{^Blk=- ASCII}', "");
    Expect(0, 128, '\p{Blk=- ASCII}', "");
    Expect(1, 128, '\p{^Blk=- ASCII}', "");
    Expect(1, 128, '\P{Blk=- ASCII}', "");
    Expect(0, 128, '\P{^Blk=- ASCII}', "");
    Error('\p{Is_Block= :=basic_Latin}');
    Error('\P{Is_Block= :=basic_Latin}');
    Expect(1, 127, '\p{Is_Block: basiclatin}', "");
    Expect(0, 127, '\p{^Is_Block: basiclatin}', "");
    Expect(0, 127, '\P{Is_Block: basiclatin}', "");
    Expect(1, 127, '\P{^Is_Block: basiclatin}', "");
    Expect(0, 128, '\p{Is_Block: basiclatin}', "");
    Expect(1, 128, '\p{^Is_Block: basiclatin}', "");
    Expect(1, 128, '\P{Is_Block: basiclatin}', "");
    Expect(0, 128, '\P{^Is_Block: basiclatin}', "");
    Expect(1, 127, '\p{Is_Block=  basic_LATIN}', "");
    Expect(0, 127, '\p{^Is_Block=  basic_LATIN}', "");
    Expect(0, 127, '\P{Is_Block=  basic_LATIN}', "");
    Expect(1, 127, '\P{^Is_Block=  basic_LATIN}', "");
    Expect(0, 128, '\p{Is_Block=  basic_LATIN}', "");
    Expect(1, 128, '\p{^Is_Block=  basic_LATIN}', "");
    Expect(1, 128, '\P{Is_Block=  basic_LATIN}', "");
    Expect(0, 128, '\P{^Is_Block=  basic_LATIN}', "");
    Error('\p{Is_Blk:	 ASCII/a/}');
    Error('\P{Is_Blk:	 ASCII/a/}');
    Expect(1, 127, '\p{Is_Blk=ascii}', "");
    Expect(0, 127, '\p{^Is_Blk=ascii}', "");
    Expect(0, 127, '\P{Is_Blk=ascii}', "");
    Expect(1, 127, '\P{^Is_Blk=ascii}', "");
    Expect(0, 128, '\p{Is_Blk=ascii}', "");
    Expect(1, 128, '\p{^Is_Blk=ascii}', "");
    Expect(1, 128, '\P{Is_Blk=ascii}', "");
    Expect(0, 128, '\P{^Is_Blk=ascii}', "");
    Expect(1, 127, '\p{Is_Blk=-ASCII}', "");
    Expect(0, 127, '\p{^Is_Blk=-ASCII}', "");
    Expect(0, 127, '\P{Is_Blk=-ASCII}', "");
    Expect(1, 127, '\P{^Is_Blk=-ASCII}', "");
    Expect(0, 128, '\p{Is_Blk=-ASCII}', "");
    Expect(1, 128, '\p{^Is_Blk=-ASCII}', "");
    Expect(1, 128, '\P{Is_Blk=-ASCII}', "");
    Expect(0, 128, '\P{^Is_Blk=-ASCII}', "");
    Error('\p{Block=_/a/AVESTAN}');
    Error('\P{Block=_/a/AVESTAN}');
    Expect(1, 68415, '\p{Block=avestan}', "");
    Expect(0, 68415, '\p{^Block=avestan}', "");
    Expect(0, 68415, '\P{Block=avestan}', "");
    Expect(1, 68415, '\P{^Block=avestan}', "");
    Expect(0, 68416, '\p{Block=avestan}', "");
    Expect(1, 68416, '\p{^Block=avestan}', "");
    Expect(1, 68416, '\P{Block=avestan}', "");
    Expect(0, 68416, '\P{^Block=avestan}', "");
    Expect(1, 68415, '\p{Block=-AVESTAN}', "");
    Expect(0, 68415, '\p{^Block=-AVESTAN}', "");
    Expect(0, 68415, '\P{Block=-AVESTAN}', "");
    Expect(1, 68415, '\P{^Block=-AVESTAN}', "");
    Expect(0, 68416, '\p{Block=-AVESTAN}', "");
    Expect(1, 68416, '\p{^Block=-AVESTAN}', "");
    Expect(1, 68416, '\P{Block=-AVESTAN}', "");
    Expect(0, 68416, '\P{^Block=-AVESTAN}', "");
    Error('\p{Blk=:=Avestan}');
    Error('\P{Blk=:=Avestan}');
    Expect(1, 68415, '\p{Blk=avestan}', "");
    Expect(0, 68415, '\p{^Blk=avestan}', "");
    Expect(0, 68415, '\P{Blk=avestan}', "");
    Expect(1, 68415, '\P{^Blk=avestan}', "");
    Expect(0, 68416, '\p{Blk=avestan}', "");
    Expect(1, 68416, '\p{^Blk=avestan}', "");
    Expect(1, 68416, '\P{Blk=avestan}', "");
    Expect(0, 68416, '\P{^Blk=avestan}', "");
    Expect(1, 68415, '\p{Blk=	AVESTAN}', "");
    Expect(0, 68415, '\p{^Blk=	AVESTAN}', "");
    Expect(0, 68415, '\P{Blk=	AVESTAN}', "");
    Expect(1, 68415, '\P{^Blk=	AVESTAN}', "");
    Expect(0, 68416, '\p{Blk=	AVESTAN}', "");
    Expect(1, 68416, '\p{^Blk=	AVESTAN}', "");
    Expect(1, 68416, '\P{Blk=	AVESTAN}', "");
    Expect(0, 68416, '\P{^Blk=	AVESTAN}', "");
    Error('\p{Is_Block: _	AVESTAN/a/}');
    Error('\P{Is_Block: _	AVESTAN/a/}');
    Expect(1, 68415, '\p{Is_Block=avestan}', "");
    Expect(0, 68415, '\p{^Is_Block=avestan}', "");
    Expect(0, 68415, '\P{Is_Block=avestan}', "");
    Expect(1, 68415, '\P{^Is_Block=avestan}', "");
    Expect(0, 68416, '\p{Is_Block=avestan}', "");
    Expect(1, 68416, '\p{^Is_Block=avestan}', "");
    Expect(1, 68416, '\P{Is_Block=avestan}', "");
    Expect(0, 68416, '\P{^Is_Block=avestan}', "");
    Expect(1, 68415, '\p{Is_Block= 	avestan}', "");
    Expect(0, 68415, '\p{^Is_Block= 	avestan}', "");
    Expect(0, 68415, '\P{Is_Block= 	avestan}', "");
    Expect(1, 68415, '\P{^Is_Block= 	avestan}', "");
    Expect(0, 68416, '\p{Is_Block= 	avestan}', "");
    Expect(1, 68416, '\p{^Is_Block= 	avestan}', "");
    Expect(1, 68416, '\P{Is_Block= 	avestan}', "");
    Expect(0, 68416, '\P{^Is_Block= 	avestan}', "");
    Error('\p{Is_Blk=	/a/avestan}');
    Error('\P{Is_Blk=	/a/avestan}');
    Expect(1, 68415, '\p{Is_Blk=avestan}', "");
    Expect(0, 68415, '\p{^Is_Blk=avestan}', "");
    Expect(0, 68415, '\P{Is_Blk=avestan}', "");
    Expect(1, 68415, '\P{^Is_Blk=avestan}', "");
    Expect(0, 68416, '\p{Is_Blk=avestan}', "");
    Expect(1, 68416, '\p{^Is_Blk=avestan}', "");
    Expect(1, 68416, '\P{Is_Blk=avestan}', "");
    Expect(0, 68416, '\P{^Is_Blk=avestan}', "");
    Expect(1, 68415, '\p{Is_Blk=-	avestan}', "");
    Expect(0, 68415, '\p{^Is_Blk=-	avestan}', "");
    Expect(0, 68415, '\P{Is_Blk=-	avestan}', "");
    Expect(1, 68415, '\P{^Is_Blk=-	avestan}', "");
    Expect(0, 68416, '\p{Is_Blk=-	avestan}', "");
    Expect(1, 68416, '\p{^Is_Blk=-	avestan}', "");
    Expect(1, 68416, '\P{Is_Blk=-	avestan}', "");
    Expect(0, 68416, '\P{^Is_Blk=-	avestan}', "");
    Error('\p{Block: _balinese/a/}');
    Error('\P{Block: _balinese/a/}');
    Expect(1, 7039, '\p{Block=balinese}', "");
    Expect(0, 7039, '\p{^Block=balinese}', "");
    Expect(0, 7039, '\P{Block=balinese}', "");
    Expect(1, 7039, '\P{^Block=balinese}', "");
    Expect(0, 7040, '\p{Block=balinese}', "");
    Expect(1, 7040, '\p{^Block=balinese}', "");
    Expect(1, 7040, '\P{Block=balinese}', "");
    Expect(0, 7040, '\P{^Block=balinese}', "");
    Expect(1, 7039, '\p{Block=BALINESE}', "");
    Expect(0, 7039, '\p{^Block=BALINESE}', "");
    Expect(0, 7039, '\P{Block=BALINESE}', "");
    Expect(1, 7039, '\P{^Block=BALINESE}', "");
    Expect(0, 7040, '\p{Block=BALINESE}', "");
    Expect(1, 7040, '\p{^Block=BALINESE}', "");
    Expect(1, 7040, '\P{Block=BALINESE}', "");
    Expect(0, 7040, '\P{^Block=BALINESE}', "");
    Error('\p{Blk=_-Balinese:=}');
    Error('\P{Blk=_-Balinese:=}');
    Expect(1, 7039, '\p{Blk=balinese}', "");
    Expect(0, 7039, '\p{^Blk=balinese}', "");
    Expect(0, 7039, '\P{Blk=balinese}', "");
    Expect(1, 7039, '\P{^Blk=balinese}', "");
    Expect(0, 7040, '\p{Blk=balinese}', "");
    Expect(1, 7040, '\p{^Blk=balinese}', "");
    Expect(1, 7040, '\P{Blk=balinese}', "");
    Expect(0, 7040, '\P{^Blk=balinese}', "");
    Expect(1, 7039, '\p{Blk= _Balinese}', "");
    Expect(0, 7039, '\p{^Blk= _Balinese}', "");
    Expect(0, 7039, '\P{Blk= _Balinese}', "");
    Expect(1, 7039, '\P{^Blk= _Balinese}', "");
    Expect(0, 7040, '\p{Blk= _Balinese}', "");
    Expect(1, 7040, '\p{^Blk= _Balinese}', "");
    Expect(1, 7040, '\P{Blk= _Balinese}', "");
    Expect(0, 7040, '\P{^Blk= _Balinese}', "");
    Error('\p{Is_Block=  balinese/a/}');
    Error('\P{Is_Block=  balinese/a/}');
    Expect(1, 7039, '\p{Is_Block=balinese}', "");
    Expect(0, 7039, '\p{^Is_Block=balinese}', "");
    Expect(0, 7039, '\P{Is_Block=balinese}', "");
    Expect(1, 7039, '\P{^Is_Block=balinese}', "");
    Expect(0, 7040, '\p{Is_Block=balinese}', "");
    Expect(1, 7040, '\p{^Is_Block=balinese}', "");
    Expect(1, 7040, '\P{Is_Block=balinese}', "");
    Expect(0, 7040, '\P{^Is_Block=balinese}', "");
    Expect(1, 7039, '\p{Is_Block=	Balinese}', "");
    Expect(0, 7039, '\p{^Is_Block=	Balinese}', "");
    Expect(0, 7039, '\P{Is_Block=	Balinese}', "");
    Expect(1, 7039, '\P{^Is_Block=	Balinese}', "");
    Expect(0, 7040, '\p{Is_Block=	Balinese}', "");
    Expect(1, 7040, '\p{^Is_Block=	Balinese}', "");
    Expect(1, 7040, '\P{Is_Block=	Balinese}', "");
    Expect(0, 7040, '\P{^Is_Block=	Balinese}', "");
    Error('\p{Is_Blk=/a/Balinese}');
    Error('\P{Is_Blk=/a/Balinese}');
    Expect(1, 7039, '\p{Is_Blk=balinese}', "");
    Expect(0, 7039, '\p{^Is_Blk=balinese}', "");
    Expect(0, 7039, '\P{Is_Blk=balinese}', "");
    Expect(1, 7039, '\P{^Is_Blk=balinese}', "");
    Expect(0, 7040, '\p{Is_Blk=balinese}', "");
    Expect(1, 7040, '\p{^Is_Blk=balinese}', "");
    Expect(1, 7040, '\P{Is_Blk=balinese}', "");
    Expect(0, 7040, '\P{^Is_Blk=balinese}', "");
    Expect(1, 7039, '\p{Is_Blk=_ Balinese}', "");
    Expect(0, 7039, '\p{^Is_Blk=_ Balinese}', "");
    Expect(0, 7039, '\P{Is_Blk=_ Balinese}', "");
    Expect(1, 7039, '\P{^Is_Blk=_ Balinese}', "");
    Expect(0, 7040, '\p{Is_Blk=_ Balinese}', "");
    Expect(1, 7040, '\p{^Is_Blk=_ Balinese}', "");
    Expect(1, 7040, '\P{Is_Blk=_ Balinese}', "");
    Expect(0, 7040, '\P{^Is_Blk=_ Balinese}', "");
    Error('\p{Block:   :=__Bamum}');
    Error('\P{Block:   :=__Bamum}');
    Expect(1, 42751, '\p{Block=bamum}', "");
    Expect(0, 42751, '\p{^Block=bamum}', "");
    Expect(0, 42751, '\P{Block=bamum}', "");
    Expect(1, 42751, '\P{^Block=bamum}', "");
    Expect(0, 42752, '\p{Block=bamum}', "");
    Expect(1, 42752, '\p{^Block=bamum}', "");
    Expect(1, 42752, '\P{Block=bamum}', "");
    Expect(0, 42752, '\P{^Block=bamum}', "");
    Expect(1, 42751, '\p{Block=-_bamum}', "");
    Expect(0, 42751, '\p{^Block=-_bamum}', "");
    Expect(0, 42751, '\P{Block=-_bamum}', "");
    Expect(1, 42751, '\P{^Block=-_bamum}', "");
    Expect(0, 42752, '\p{Block=-_bamum}', "");
    Expect(1, 42752, '\p{^Block=-_bamum}', "");
    Expect(1, 42752, '\P{Block=-_bamum}', "");
    Expect(0, 42752, '\P{^Block=-_bamum}', "");
    Error('\p{Blk: 	_BAMUM:=}');
    Error('\P{Blk: 	_BAMUM:=}');
    Expect(1, 42751, '\p{Blk=bamum}', "");
    Expect(0, 42751, '\p{^Blk=bamum}', "");
    Expect(0, 42751, '\P{Blk=bamum}', "");
    Expect(1, 42751, '\P{^Blk=bamum}', "");
    Expect(0, 42752, '\p{Blk=bamum}', "");
    Expect(1, 42752, '\p{^Blk=bamum}', "");
    Expect(1, 42752, '\P{Blk=bamum}', "");
    Expect(0, 42752, '\P{^Blk=bamum}', "");
    Expect(1, 42751, '\p{Blk=-Bamum}', "");
    Expect(0, 42751, '\p{^Blk=-Bamum}', "");
    Expect(0, 42751, '\P{Blk=-Bamum}', "");
    Expect(1, 42751, '\P{^Blk=-Bamum}', "");
    Expect(0, 42752, '\p{Blk=-Bamum}', "");
    Expect(1, 42752, '\p{^Blk=-Bamum}', "");
    Expect(1, 42752, '\P{Blk=-Bamum}', "");
    Expect(0, 42752, '\P{^Blk=-Bamum}', "");
    Error('\p{Is_Block:	-	BAMUM:=}');
    Error('\P{Is_Block:	-	BAMUM:=}');
    Expect(1, 42751, '\p{Is_Block=bamum}', "");
    Expect(0, 42751, '\p{^Is_Block=bamum}', "");
    Expect(0, 42751, '\P{Is_Block=bamum}', "");
    Expect(1, 42751, '\P{^Is_Block=bamum}', "");
    Expect(0, 42752, '\p{Is_Block=bamum}', "");
    Expect(1, 42752, '\p{^Is_Block=bamum}', "");
    Expect(1, 42752, '\P{Is_Block=bamum}', "");
    Expect(0, 42752, '\P{^Is_Block=bamum}', "");
    Expect(1, 42751, '\p{Is_Block=-	Bamum}', "");
    Expect(0, 42751, '\p{^Is_Block=-	Bamum}', "");
    Expect(0, 42751, '\P{Is_Block=-	Bamum}', "");
    Expect(1, 42751, '\P{^Is_Block=-	Bamum}', "");
    Expect(0, 42752, '\p{Is_Block=-	Bamum}', "");
    Expect(1, 42752, '\p{^Is_Block=-	Bamum}', "");
    Expect(1, 42752, '\P{Is_Block=-	Bamum}', "");
    Expect(0, 42752, '\P{^Is_Block=-	Bamum}', "");
    Error('\p{Is_Blk=/a/-BAMUM}');
    Error('\P{Is_Blk=/a/-BAMUM}');
    Expect(1, 42751, '\p{Is_Blk=bamum}', "");
    Expect(0, 42751, '\p{^Is_Blk=bamum}', "");
    Expect(0, 42751, '\P{Is_Blk=bamum}', "");
    Expect(1, 42751, '\P{^Is_Blk=bamum}', "");
    Expect(0, 42752, '\p{Is_Blk=bamum}', "");
    Expect(1, 42752, '\p{^Is_Blk=bamum}', "");
    Expect(1, 42752, '\P{Is_Blk=bamum}', "");
    Expect(0, 42752, '\P{^Is_Blk=bamum}', "");
    Expect(1, 42751, '\p{Is_Blk=-Bamum}', "");
    Expect(0, 42751, '\p{^Is_Blk=-Bamum}', "");
    Expect(0, 42751, '\P{Is_Blk=-Bamum}', "");
    Expect(1, 42751, '\P{^Is_Blk=-Bamum}', "");
    Expect(0, 42752, '\p{Is_Blk=-Bamum}', "");
    Expect(1, 42752, '\p{^Is_Blk=-Bamum}', "");
    Expect(1, 42752, '\P{Is_Blk=-Bamum}', "");
    Expect(0, 42752, '\P{^Is_Blk=-Bamum}', "");
    Error('\p{Block: :=	Bamum_SUPPLEMENT}');
    Error('\P{Block: :=	Bamum_SUPPLEMENT}');
    Expect(1, 92735, '\p{Block=bamumsupplement}', "");
    Expect(0, 92735, '\p{^Block=bamumsupplement}', "");
    Expect(0, 92735, '\P{Block=bamumsupplement}', "");
    Expect(1, 92735, '\P{^Block=bamumsupplement}', "");
    Expect(0, 92736, '\p{Block=bamumsupplement}', "");
    Expect(1, 92736, '\p{^Block=bamumsupplement}', "");
    Expect(1, 92736, '\P{Block=bamumsupplement}', "");
    Expect(0, 92736, '\P{^Block=bamumsupplement}', "");
    Expect(1, 92735, '\p{Block=Bamum_Supplement}', "");
    Expect(0, 92735, '\p{^Block=Bamum_Supplement}', "");
    Expect(0, 92735, '\P{Block=Bamum_Supplement}', "");
    Expect(1, 92735, '\P{^Block=Bamum_Supplement}', "");
    Expect(0, 92736, '\p{Block=Bamum_Supplement}', "");
    Expect(1, 92736, '\p{^Block=Bamum_Supplement}', "");
    Expect(1, 92736, '\P{Block=Bamum_Supplement}', "");
    Expect(0, 92736, '\P{^Block=Bamum_Supplement}', "");
    Error('\p{Blk=_/a/BAMUM_Sup}');
    Error('\P{Blk=_/a/BAMUM_Sup}');
    Expect(1, 92735, '\p{Blk=bamumsup}', "");
    Expect(0, 92735, '\p{^Blk=bamumsup}', "");
    Expect(0, 92735, '\P{Blk=bamumsup}', "");
    Expect(1, 92735, '\P{^Blk=bamumsup}', "");
    Expect(0, 92736, '\p{Blk=bamumsup}', "");
    Expect(1, 92736, '\p{^Blk=bamumsup}', "");
    Expect(1, 92736, '\P{Blk=bamumsup}', "");
    Expect(0, 92736, '\P{^Blk=bamumsup}', "");
    Expect(1, 92735, '\p{Blk:   -Bamum_SUP}', "");
    Expect(0, 92735, '\p{^Blk:   -Bamum_SUP}', "");
    Expect(0, 92735, '\P{Blk:   -Bamum_SUP}', "");
    Expect(1, 92735, '\P{^Blk:   -Bamum_SUP}', "");
    Expect(0, 92736, '\p{Blk:   -Bamum_SUP}', "");
    Expect(1, 92736, '\p{^Blk:   -Bamum_SUP}', "");
    Expect(1, 92736, '\P{Blk:   -Bamum_SUP}', "");
    Expect(0, 92736, '\P{^Blk:   -Bamum_SUP}', "");
    Error('\p{Is_Block=:=	 bamum_Supplement}');
    Error('\P{Is_Block=:=	 bamum_Supplement}');
    Expect(1, 92735, '\p{Is_Block=bamumsupplement}', "");
    Expect(0, 92735, '\p{^Is_Block=bamumsupplement}', "");
    Expect(0, 92735, '\P{Is_Block=bamumsupplement}', "");
    Expect(1, 92735, '\P{^Is_Block=bamumsupplement}', "");
    Expect(0, 92736, '\p{Is_Block=bamumsupplement}', "");
    Expect(1, 92736, '\p{^Is_Block=bamumsupplement}', "");
    Expect(1, 92736, '\P{Is_Block=bamumsupplement}', "");
    Expect(0, 92736, '\P{^Is_Block=bamumsupplement}', "");
    Expect(1, 92735, '\p{Is_Block=-Bamum_SUPPLEMENT}', "");
    Expect(0, 92735, '\p{^Is_Block=-Bamum_SUPPLEMENT}', "");
    Expect(0, 92735, '\P{Is_Block=-Bamum_SUPPLEMENT}', "");
    Expect(1, 92735, '\P{^Is_Block=-Bamum_SUPPLEMENT}', "");
    Expect(0, 92736, '\p{Is_Block=-Bamum_SUPPLEMENT}', "");
    Expect(1, 92736, '\p{^Is_Block=-Bamum_SUPPLEMENT}', "");
    Expect(1, 92736, '\P{Is_Block=-Bamum_SUPPLEMENT}', "");
    Expect(0, 92736, '\P{^Is_Block=-Bamum_SUPPLEMENT}', "");
    Error('\p{Is_Blk=		bamum_Sup:=}');
    Error('\P{Is_Blk=		bamum_Sup:=}');
    Expect(1, 92735, '\p{Is_Blk=bamumsup}', "");
    Expect(0, 92735, '\p{^Is_Blk=bamumsup}', "");
    Expect(0, 92735, '\P{Is_Blk=bamumsup}', "");
    Expect(1, 92735, '\P{^Is_Blk=bamumsup}', "");
    Expect(0, 92736, '\p{Is_Blk=bamumsup}', "");
    Expect(1, 92736, '\p{^Is_Blk=bamumsup}', "");
    Expect(1, 92736, '\P{Is_Blk=bamumsup}', "");
    Expect(0, 92736, '\P{^Is_Blk=bamumsup}', "");
    Expect(1, 92735, '\p{Is_Blk=-BAMUM_Sup}', "");
    Expect(0, 92735, '\p{^Is_Blk=-BAMUM_Sup}', "");
    Expect(0, 92735, '\P{Is_Blk=-BAMUM_Sup}', "");
    Expect(1, 92735, '\P{^Is_Blk=-BAMUM_Sup}', "");
    Expect(0, 92736, '\p{Is_Blk=-BAMUM_Sup}', "");
    Expect(1, 92736, '\p{^Is_Blk=-BAMUM_Sup}', "");
    Expect(1, 92736, '\P{Is_Blk=-BAMUM_Sup}', "");
    Expect(0, 92736, '\P{^Is_Blk=-BAMUM_Sup}', "");
    Error('\p{Block=:=__Bassa_Vah}');
    Error('\P{Block=:=__Bassa_Vah}');
    Expect(1, 92927, '\p{Block=bassavah}', "");
    Expect(0, 92927, '\p{^Block=bassavah}', "");
    Expect(0, 92927, '\P{Block=bassavah}', "");
    Expect(1, 92927, '\P{^Block=bassavah}', "");
    Expect(0, 92928, '\p{Block=bassavah}', "");
    Expect(1, 92928, '\p{^Block=bassavah}', "");
    Expect(1, 92928, '\P{Block=bassavah}', "");
    Expect(0, 92928, '\P{^Block=bassavah}', "");
    Expect(1, 92927, '\p{Block=- Bassa_Vah}', "");
    Expect(0, 92927, '\p{^Block=- Bassa_Vah}', "");
    Expect(0, 92927, '\P{Block=- Bassa_Vah}', "");
    Expect(1, 92927, '\P{^Block=- Bassa_Vah}', "");
    Expect(0, 92928, '\p{Block=- Bassa_Vah}', "");
    Expect(1, 92928, '\p{^Block=- Bassa_Vah}', "");
    Expect(1, 92928, '\P{Block=- Bassa_Vah}', "");
    Expect(0, 92928, '\P{^Block=- Bassa_Vah}', "");
    Error('\p{Blk=-:=bassa_VAH}');
    Error('\P{Blk=-:=bassa_VAH}');
    Expect(1, 92927, '\p{Blk:	bassavah}', "");
    Expect(0, 92927, '\p{^Blk:	bassavah}', "");
    Expect(0, 92927, '\P{Blk:	bassavah}', "");
    Expect(1, 92927, '\P{^Blk:	bassavah}', "");
    Expect(0, 92928, '\p{Blk:	bassavah}', "");
    Expect(1, 92928, '\p{^Blk:	bassavah}', "");
    Expect(1, 92928, '\P{Blk:	bassavah}', "");
    Expect(0, 92928, '\P{^Blk:	bassavah}', "");
    Expect(1, 92927, '\p{Blk=	_Bassa_Vah}', "");
    Expect(0, 92927, '\p{^Blk=	_Bassa_Vah}', "");
    Expect(0, 92927, '\P{Blk=	_Bassa_Vah}', "");
    Expect(1, 92927, '\P{^Blk=	_Bassa_Vah}', "");
    Expect(0, 92928, '\p{Blk=	_Bassa_Vah}', "");
    Expect(1, 92928, '\p{^Blk=	_Bassa_Vah}', "");
    Expect(1, 92928, '\P{Blk=	_Bassa_Vah}', "");
    Expect(0, 92928, '\P{^Blk=	_Bassa_Vah}', "");
    Error('\p{Is_Block= /a/Bassa_vah}');
    Error('\P{Is_Block= /a/Bassa_vah}');
    Expect(1, 92927, '\p{Is_Block=bassavah}', "");
    Expect(0, 92927, '\p{^Is_Block=bassavah}', "");
    Expect(0, 92927, '\P{Is_Block=bassavah}', "");
    Expect(1, 92927, '\P{^Is_Block=bassavah}', "");
    Expect(0, 92928, '\p{Is_Block=bassavah}', "");
    Expect(1, 92928, '\p{^Is_Block=bassavah}', "");
    Expect(1, 92928, '\P{Is_Block=bassavah}', "");
    Expect(0, 92928, '\P{^Is_Block=bassavah}', "");
    Expect(1, 92927, '\p{Is_Block=__bassa_VAH}', "");
    Expect(0, 92927, '\p{^Is_Block=__bassa_VAH}', "");
    Expect(0, 92927, '\P{Is_Block=__bassa_VAH}', "");
    Expect(1, 92927, '\P{^Is_Block=__bassa_VAH}', "");
    Expect(0, 92928, '\p{Is_Block=__bassa_VAH}', "");
    Expect(1, 92928, '\p{^Is_Block=__bassa_VAH}', "");
    Expect(1, 92928, '\P{Is_Block=__bassa_VAH}', "");
    Expect(0, 92928, '\P{^Is_Block=__bassa_VAH}', "");
    Error('\p{Is_Blk=-	Bassa_Vah:=}');
    Error('\P{Is_Blk=-	Bassa_Vah:=}');
    Expect(1, 92927, '\p{Is_Blk=bassavah}', "");
    Expect(0, 92927, '\p{^Is_Blk=bassavah}', "");
    Expect(0, 92927, '\P{Is_Blk=bassavah}', "");
    Expect(1, 92927, '\P{^Is_Blk=bassavah}', "");
    Expect(0, 92928, '\p{Is_Blk=bassavah}', "");
    Expect(1, 92928, '\p{^Is_Blk=bassavah}', "");
    Expect(1, 92928, '\P{Is_Blk=bassavah}', "");
    Expect(0, 92928, '\P{^Is_Blk=bassavah}', "");
    Expect(1, 92927, '\p{Is_Blk=_ Bassa_VAH}', "");
    Expect(0, 92927, '\p{^Is_Blk=_ Bassa_VAH}', "");
    Expect(0, 92927, '\P{Is_Blk=_ Bassa_VAH}', "");
    Expect(1, 92927, '\P{^Is_Blk=_ Bassa_VAH}', "");
    Expect(0, 92928, '\p{Is_Blk=_ Bassa_VAH}', "");
    Expect(1, 92928, '\p{^Is_Blk=_ Bassa_VAH}', "");
    Expect(1, 92928, '\P{Is_Blk=_ Bassa_VAH}', "");
    Expect(0, 92928, '\P{^Is_Blk=_ Bassa_VAH}', "");
    Error('\p{Block=/a/	_BATAK}');
    Error('\P{Block=/a/	_BATAK}');
    Expect(1, 7167, '\p{Block=batak}', "");
    Expect(0, 7167, '\p{^Block=batak}', "");
    Expect(0, 7167, '\P{Block=batak}', "");
    Expect(1, 7167, '\P{^Block=batak}', "");
    Expect(0, 7168, '\p{Block=batak}', "");
    Expect(1, 7168, '\p{^Block=batak}', "");
    Expect(1, 7168, '\P{Block=batak}', "");
    Expect(0, 7168, '\P{^Block=batak}', "");
    Expect(1, 7167, '\p{Block= Batak}', "");
    Expect(0, 7167, '\p{^Block= Batak}', "");
    Expect(0, 7167, '\P{Block= Batak}', "");
    Expect(1, 7167, '\P{^Block= Batak}', "");
    Expect(0, 7168, '\p{Block= Batak}', "");
    Expect(1, 7168, '\p{^Block= Batak}', "");
    Expect(1, 7168, '\P{Block= Batak}', "");
    Expect(0, 7168, '\P{^Block= Batak}', "");
    Error('\p{Blk:_ Batak/a/}');
    Error('\P{Blk:_ Batak/a/}');
    Expect(1, 7167, '\p{Blk=batak}', "");
    Expect(0, 7167, '\p{^Blk=batak}', "");
    Expect(0, 7167, '\P{Blk=batak}', "");
    Expect(1, 7167, '\P{^Blk=batak}', "");
    Expect(0, 7168, '\p{Blk=batak}', "");
    Expect(1, 7168, '\p{^Blk=batak}', "");
    Expect(1, 7168, '\P{Blk=batak}', "");
    Expect(0, 7168, '\P{^Blk=batak}', "");
    Expect(1, 7167, '\p{Blk=-	Batak}', "");
    Expect(0, 7167, '\p{^Blk=-	Batak}', "");
    Expect(0, 7167, '\P{Blk=-	Batak}', "");
    Expect(1, 7167, '\P{^Blk=-	Batak}', "");
    Expect(0, 7168, '\p{Blk=-	Batak}', "");
    Expect(1, 7168, '\p{^Blk=-	Batak}', "");
    Expect(1, 7168, '\P{Blk=-	Batak}', "");
    Expect(0, 7168, '\P{^Blk=-	Batak}', "");
    Error('\p{Is_Block=/a/Batak}');
    Error('\P{Is_Block=/a/Batak}');
    Expect(1, 7167, '\p{Is_Block=batak}', "");
    Expect(0, 7167, '\p{^Is_Block=batak}', "");
    Expect(0, 7167, '\P{Is_Block=batak}', "");
    Expect(1, 7167, '\P{^Is_Block=batak}', "");
    Expect(0, 7168, '\p{Is_Block=batak}', "");
    Expect(1, 7168, '\p{^Is_Block=batak}', "");
    Expect(1, 7168, '\P{Is_Block=batak}', "");
    Expect(0, 7168, '\P{^Is_Block=batak}', "");
    Expect(1, 7167, '\p{Is_Block= -BATAK}', "");
    Expect(0, 7167, '\p{^Is_Block= -BATAK}', "");
    Expect(0, 7167, '\P{Is_Block= -BATAK}', "");
    Expect(1, 7167, '\P{^Is_Block= -BATAK}', "");
    Expect(0, 7168, '\p{Is_Block= -BATAK}', "");
    Expect(1, 7168, '\p{^Is_Block= -BATAK}', "");
    Expect(1, 7168, '\P{Is_Block= -BATAK}', "");
    Expect(0, 7168, '\P{^Is_Block= -BATAK}', "");
    Error('\p{Is_Blk=-:=batak}');
    Error('\P{Is_Blk=-:=batak}');
    Expect(1, 7167, '\p{Is_Blk=batak}', "");
    Expect(0, 7167, '\p{^Is_Blk=batak}', "");
    Expect(0, 7167, '\P{Is_Blk=batak}', "");
    Expect(1, 7167, '\P{^Is_Blk=batak}', "");
    Expect(0, 7168, '\p{Is_Blk=batak}', "");
    Expect(1, 7168, '\p{^Is_Blk=batak}', "");
    Expect(1, 7168, '\P{Is_Blk=batak}', "");
    Expect(0, 7168, '\P{^Is_Blk=batak}', "");
    Expect(1, 7167, '\p{Is_Blk=-_Batak}', "");
    Expect(0, 7167, '\p{^Is_Blk=-_Batak}', "");
    Expect(0, 7167, '\P{Is_Blk=-_Batak}', "");
    Expect(1, 7167, '\P{^Is_Blk=-_Batak}', "");
    Expect(0, 7168, '\p{Is_Blk=-_Batak}', "");
    Expect(1, 7168, '\p{^Is_Blk=-_Batak}', "");
    Expect(1, 7168, '\P{Is_Blk=-_Batak}', "");
    Expect(0, 7168, '\P{^Is_Blk=-_Batak}', "");
    Error('\p{Block=-_BENGALI:=}');
    Error('\P{Block=-_BENGALI:=}');
    Expect(1, 2559, '\p{Block=bengali}', "");
    Expect(0, 2559, '\p{^Block=bengali}', "");
    Expect(0, 2559, '\P{Block=bengali}', "");
    Expect(1, 2559, '\P{^Block=bengali}', "");
    Expect(0, 2560, '\p{Block=bengali}', "");
    Expect(1, 2560, '\p{^Block=bengali}', "");
    Expect(1, 2560, '\P{Block=bengali}', "");
    Expect(0, 2560, '\P{^Block=bengali}', "");
    Expect(1, 2559, '\p{Block=-_BENGALI}', "");
    Expect(0, 2559, '\p{^Block=-_BENGALI}', "");
    Expect(0, 2559, '\P{Block=-_BENGALI}', "");
    Expect(1, 2559, '\P{^Block=-_BENGALI}', "");
    Expect(0, 2560, '\p{Block=-_BENGALI}', "");
    Expect(1, 2560, '\p{^Block=-_BENGALI}', "");
    Expect(1, 2560, '\P{Block=-_BENGALI}', "");
    Expect(0, 2560, '\P{^Block=-_BENGALI}', "");
    Error('\p{Blk=__BENGALI/a/}');
    Error('\P{Blk=__BENGALI/a/}');
    Expect(1, 2559, '\p{Blk=bengali}', "");
    Expect(0, 2559, '\p{^Blk=bengali}', "");
    Expect(0, 2559, '\P{Blk=bengali}', "");
    Expect(1, 2559, '\P{^Blk=bengali}', "");
    Expect(0, 2560, '\p{Blk=bengali}', "");
    Expect(1, 2560, '\p{^Blk=bengali}', "");
    Expect(1, 2560, '\P{Blk=bengali}', "");
    Expect(0, 2560, '\P{^Blk=bengali}', "");
    Expect(1, 2559, '\p{Blk=_	BENGALI}', "");
    Expect(0, 2559, '\p{^Blk=_	BENGALI}', "");
    Expect(0, 2559, '\P{Blk=_	BENGALI}', "");
    Expect(1, 2559, '\P{^Blk=_	BENGALI}', "");
    Expect(0, 2560, '\p{Blk=_	BENGALI}', "");
    Expect(1, 2560, '\p{^Blk=_	BENGALI}', "");
    Expect(1, 2560, '\P{Blk=_	BENGALI}', "");
    Expect(0, 2560, '\P{^Blk=_	BENGALI}', "");
    Error('\p{Is_Block=/a/ _Bengali}');
    Error('\P{Is_Block=/a/ _Bengali}');
    Expect(1, 2559, '\p{Is_Block=bengali}', "");
    Expect(0, 2559, '\p{^Is_Block=bengali}', "");
    Expect(0, 2559, '\P{Is_Block=bengali}', "");
    Expect(1, 2559, '\P{^Is_Block=bengali}', "");
    Expect(0, 2560, '\p{Is_Block=bengali}', "");
    Expect(1, 2560, '\p{^Is_Block=bengali}', "");
    Expect(1, 2560, '\P{Is_Block=bengali}', "");
    Expect(0, 2560, '\P{^Is_Block=bengali}', "");
    Expect(1, 2559, '\p{Is_Block=-Bengali}', "");
    Expect(0, 2559, '\p{^Is_Block=-Bengali}', "");
    Expect(0, 2559, '\P{Is_Block=-Bengali}', "");
    Expect(1, 2559, '\P{^Is_Block=-Bengali}', "");
    Expect(0, 2560, '\p{Is_Block=-Bengali}', "");
    Expect(1, 2560, '\p{^Is_Block=-Bengali}', "");
    Expect(1, 2560, '\P{Is_Block=-Bengali}', "");
    Expect(0, 2560, '\P{^Is_Block=-Bengali}', "");
    Error('\p{Is_Blk=:=_bengali}');
    Error('\P{Is_Blk=:=_bengali}');
    Expect(1, 2559, '\p{Is_Blk:	bengali}', "");
    Expect(0, 2559, '\p{^Is_Blk:	bengali}', "");
    Expect(0, 2559, '\P{Is_Blk:	bengali}', "");
    Expect(1, 2559, '\P{^Is_Blk:	bengali}', "");
    Expect(0, 2560, '\p{Is_Blk:	bengali}', "");
    Expect(1, 2560, '\p{^Is_Blk:	bengali}', "");
    Expect(1, 2560, '\P{Is_Blk:	bengali}', "");
    Expect(0, 2560, '\P{^Is_Blk:	bengali}', "");
    Expect(1, 2559, '\p{Is_Blk:  Bengali}', "");
    Expect(0, 2559, '\p{^Is_Blk:  Bengali}', "");
    Expect(0, 2559, '\P{Is_Blk:  Bengali}', "");
    Expect(1, 2559, '\P{^Is_Blk:  Bengali}', "");
    Expect(0, 2560, '\p{Is_Blk:  Bengali}', "");
    Expect(1, 2560, '\p{^Is_Blk:  Bengali}', "");
    Expect(1, 2560, '\P{Is_Blk:  Bengali}', "");
    Expect(0, 2560, '\P{^Is_Blk:  Bengali}', "");
    Error('\p{Block=/a/  Bhaiksuki}');
    Error('\P{Block=/a/  Bhaiksuki}');
    Expect(1, 72815, '\p{Block=bhaiksuki}', "");
    Expect(0, 72815, '\p{^Block=bhaiksuki}', "");
    Expect(0, 72815, '\P{Block=bhaiksuki}', "");
    Expect(1, 72815, '\P{^Block=bhaiksuki}', "");
    Expect(0, 72816, '\p{Block=bhaiksuki}', "");
    Expect(1, 72816, '\p{^Block=bhaiksuki}', "");
    Expect(1, 72816, '\P{Block=bhaiksuki}', "");
    Expect(0, 72816, '\P{^Block=bhaiksuki}', "");
    Expect(1, 72815, '\p{Block= bhaiksuki}', "");
    Expect(0, 72815, '\p{^Block= bhaiksuki}', "");
    Expect(0, 72815, '\P{Block= bhaiksuki}', "");
    Expect(1, 72815, '\P{^Block= bhaiksuki}', "");
    Expect(0, 72816, '\p{Block= bhaiksuki}', "");
    Expect(1, 72816, '\p{^Block= bhaiksuki}', "");
    Expect(1, 72816, '\P{Block= bhaiksuki}', "");
    Expect(0, 72816, '\P{^Block= bhaiksuki}', "");
    Error('\p{Blk=:=		bhaiksuki}');
    Error('\P{Blk=:=		bhaiksuki}');
    Expect(1, 72815, '\p{Blk=bhaiksuki}', "");
    Expect(0, 72815, '\p{^Blk=bhaiksuki}', "");
    Expect(0, 72815, '\P{Blk=bhaiksuki}', "");
    Expect(1, 72815, '\P{^Blk=bhaiksuki}', "");
    Expect(0, 72816, '\p{Blk=bhaiksuki}', "");
    Expect(1, 72816, '\p{^Blk=bhaiksuki}', "");
    Expect(1, 72816, '\P{Blk=bhaiksuki}', "");
    Expect(0, 72816, '\P{^Blk=bhaiksuki}', "");
    Expect(1, 72815, '\p{Blk= Bhaiksuki}', "");
    Expect(0, 72815, '\p{^Blk= Bhaiksuki}', "");
    Expect(0, 72815, '\P{Blk= Bhaiksuki}', "");
    Expect(1, 72815, '\P{^Blk= Bhaiksuki}', "");
    Expect(0, 72816, '\p{Blk= Bhaiksuki}', "");
    Expect(1, 72816, '\p{^Blk= Bhaiksuki}', "");
    Expect(1, 72816, '\P{Blk= Bhaiksuki}', "");
    Expect(0, 72816, '\P{^Blk= Bhaiksuki}', "");
    Error('\p{Is_Block= /a/bhaiksuki}');
    Error('\P{Is_Block= /a/bhaiksuki}');
    Expect(1, 72815, '\p{Is_Block=bhaiksuki}', "");
    Expect(0, 72815, '\p{^Is_Block=bhaiksuki}', "");
    Expect(0, 72815, '\P{Is_Block=bhaiksuki}', "");
    Expect(1, 72815, '\P{^Is_Block=bhaiksuki}', "");
    Expect(0, 72816, '\p{Is_Block=bhaiksuki}', "");
    Expect(1, 72816, '\p{^Is_Block=bhaiksuki}', "");
    Expect(1, 72816, '\P{Is_Block=bhaiksuki}', "");
    Expect(0, 72816, '\P{^Is_Block=bhaiksuki}', "");
    Expect(1, 72815, '\p{Is_Block= BHAIKSUKI}', "");
    Expect(0, 72815, '\p{^Is_Block= BHAIKSUKI}', "");
    Expect(0, 72815, '\P{Is_Block= BHAIKSUKI}', "");
    Expect(1, 72815, '\P{^Is_Block= BHAIKSUKI}', "");
    Expect(0, 72816, '\p{Is_Block= BHAIKSUKI}', "");
    Expect(1, 72816, '\p{^Is_Block= BHAIKSUKI}', "");
    Expect(1, 72816, '\P{Is_Block= BHAIKSUKI}', "");
    Expect(0, 72816, '\P{^Is_Block= BHAIKSUKI}', "");
    Error('\p{Is_Blk=:= 	Bhaiksuki}');
    Error('\P{Is_Blk=:= 	Bhaiksuki}');
    Expect(1, 72815, '\p{Is_Blk=bhaiksuki}', "");
    Expect(0, 72815, '\p{^Is_Blk=bhaiksuki}', "");
    Expect(0, 72815, '\P{Is_Blk=bhaiksuki}', "");
    Expect(1, 72815, '\P{^Is_Blk=bhaiksuki}', "");
    Expect(0, 72816, '\p{Is_Blk=bhaiksuki}', "");
    Expect(1, 72816, '\p{^Is_Blk=bhaiksuki}', "");
    Expect(1, 72816, '\P{Is_Blk=bhaiksuki}', "");
    Expect(0, 72816, '\P{^Is_Blk=bhaiksuki}', "");
    Expect(1, 72815, '\p{Is_Blk=_-BHAIKSUKI}', "");
    Expect(0, 72815, '\p{^Is_Blk=_-BHAIKSUKI}', "");
    Expect(0, 72815, '\P{Is_Blk=_-BHAIKSUKI}', "");
    Expect(1, 72815, '\P{^Is_Blk=_-BHAIKSUKI}', "");
    Expect(0, 72816, '\p{Is_Blk=_-BHAIKSUKI}', "");
    Expect(1, 72816, '\p{^Is_Blk=_-BHAIKSUKI}', "");
    Expect(1, 72816, '\P{Is_Blk=_-BHAIKSUKI}', "");
    Expect(0, 72816, '\P{^Is_Blk=_-BHAIKSUKI}', "");
    Error('\p{Block: /a/	-Block_Elements}');
    Error('\P{Block: /a/	-Block_Elements}');
    Expect(1, 9631, '\p{Block=blockelements}', "");
    Expect(0, 9631, '\p{^Block=blockelements}', "");
    Expect(0, 9631, '\P{Block=blockelements}', "");
    Expect(1, 9631, '\P{^Block=blockelements}', "");
    Expect(0, 9632, '\p{Block=blockelements}', "");
    Expect(1, 9632, '\p{^Block=blockelements}', "");
    Expect(1, 9632, '\P{Block=blockelements}', "");
    Expect(0, 9632, '\P{^Block=blockelements}', "");
    Expect(1, 9631, '\p{Block=block_elements}', "");
    Expect(0, 9631, '\p{^Block=block_elements}', "");
    Expect(0, 9631, '\P{Block=block_elements}', "");
    Expect(1, 9631, '\P{^Block=block_elements}', "");
    Expect(0, 9632, '\p{Block=block_elements}', "");
    Expect(1, 9632, '\p{^Block=block_elements}', "");
    Expect(1, 9632, '\P{Block=block_elements}', "");
    Expect(0, 9632, '\P{^Block=block_elements}', "");
    Error('\p{Blk= :=Block_Elements}');
    Error('\P{Blk= :=Block_Elements}');
    Expect(1, 9631, '\p{Blk=blockelements}', "");
    Expect(0, 9631, '\p{^Blk=blockelements}', "");
    Expect(0, 9631, '\P{Blk=blockelements}', "");
    Expect(1, 9631, '\P{^Blk=blockelements}', "");
    Expect(0, 9632, '\p{Blk=blockelements}', "");
    Expect(1, 9632, '\p{^Blk=blockelements}', "");
    Expect(1, 9632, '\P{Blk=blockelements}', "");
    Expect(0, 9632, '\P{^Blk=blockelements}', "");
    Expect(1, 9631, '\p{Blk=		block_elements}', "");
    Expect(0, 9631, '\p{^Blk=		block_elements}', "");
    Expect(0, 9631, '\P{Blk=		block_elements}', "");
    Expect(1, 9631, '\P{^Blk=		block_elements}', "");
    Expect(0, 9632, '\p{Blk=		block_elements}', "");
    Expect(1, 9632, '\p{^Blk=		block_elements}', "");
    Expect(1, 9632, '\P{Blk=		block_elements}', "");
    Expect(0, 9632, '\P{^Blk=		block_elements}', "");
    Error('\p{Is_Block= /a/BLOCK_elements}');
    Error('\P{Is_Block= /a/BLOCK_elements}');
    Expect(1, 9631, '\p{Is_Block=blockelements}', "");
    Expect(0, 9631, '\p{^Is_Block=blockelements}', "");
    Expect(0, 9631, '\P{Is_Block=blockelements}', "");
    Expect(1, 9631, '\P{^Is_Block=blockelements}', "");
    Expect(0, 9632, '\p{Is_Block=blockelements}', "");
    Expect(1, 9632, '\p{^Is_Block=blockelements}', "");
    Expect(1, 9632, '\P{Is_Block=blockelements}', "");
    Expect(0, 9632, '\P{^Is_Block=blockelements}', "");
    Expect(1, 9631, '\p{Is_Block=-_Block_elements}', "");
    Expect(0, 9631, '\p{^Is_Block=-_Block_elements}', "");
    Expect(0, 9631, '\P{Is_Block=-_Block_elements}', "");
    Expect(1, 9631, '\P{^Is_Block=-_Block_elements}', "");
    Expect(0, 9632, '\p{Is_Block=-_Block_elements}', "");
    Expect(1, 9632, '\p{^Is_Block=-_Block_elements}', "");
    Expect(1, 9632, '\P{Is_Block=-_Block_elements}', "");
    Expect(0, 9632, '\P{^Is_Block=-_Block_elements}', "");
    Error('\p{Is_Blk=/a/_-Block_elements}');
    Error('\P{Is_Blk=/a/_-Block_elements}');
    Expect(1, 9631, '\p{Is_Blk=blockelements}', "");
    Expect(0, 9631, '\p{^Is_Blk=blockelements}', "");
    Expect(0, 9631, '\P{Is_Blk=blockelements}', "");
    Expect(1, 9631, '\P{^Is_Blk=blockelements}', "");
    Expect(0, 9632, '\p{Is_Blk=blockelements}', "");
    Expect(1, 9632, '\p{^Is_Blk=blockelements}', "");
    Expect(1, 9632, '\P{Is_Blk=blockelements}', "");
    Expect(0, 9632, '\P{^Is_Blk=blockelements}', "");
    Expect(1, 9631, '\p{Is_Blk= block_ELEMENTS}', "");
    Expect(0, 9631, '\p{^Is_Blk= block_ELEMENTS}', "");
    Expect(0, 9631, '\P{Is_Blk= block_ELEMENTS}', "");
    Expect(1, 9631, '\P{^Is_Blk= block_ELEMENTS}', "");
    Expect(0, 9632, '\p{Is_Blk= block_ELEMENTS}', "");
    Expect(1, 9632, '\p{^Is_Blk= block_ELEMENTS}', "");
    Expect(1, 9632, '\P{Is_Blk= block_ELEMENTS}', "");
    Expect(0, 9632, '\P{^Is_Blk= block_ELEMENTS}', "");
    Error('\p{Block=	/a/Bopomofo}');
    Error('\P{Block=	/a/Bopomofo}');
    Expect(1, 12591, '\p{Block=bopomofo}', "");
    Expect(0, 12591, '\p{^Block=bopomofo}', "");
    Expect(0, 12591, '\P{Block=bopomofo}', "");
    Expect(1, 12591, '\P{^Block=bopomofo}', "");
    Expect(0, 12592, '\p{Block=bopomofo}', "");
    Expect(1, 12592, '\p{^Block=bopomofo}', "");
    Expect(1, 12592, '\P{Block=bopomofo}', "");
    Expect(0, 12592, '\P{^Block=bopomofo}', "");
    Expect(1, 12591, '\p{Block=__bopomofo}', "");
    Expect(0, 12591, '\p{^Block=__bopomofo}', "");
    Expect(0, 12591, '\P{Block=__bopomofo}', "");
    Expect(1, 12591, '\P{^Block=__bopomofo}', "");
    Expect(0, 12592, '\p{Block=__bopomofo}', "");
    Expect(1, 12592, '\p{^Block=__bopomofo}', "");
    Expect(1, 12592, '\P{Block=__bopomofo}', "");
    Expect(0, 12592, '\P{^Block=__bopomofo}', "");
    Error('\p{Blk=_/a/Bopomofo}');
    Error('\P{Blk=_/a/Bopomofo}');
    Expect(1, 12591, '\p{Blk=bopomofo}', "");
    Expect(0, 12591, '\p{^Blk=bopomofo}', "");
    Expect(0, 12591, '\P{Blk=bopomofo}', "");
    Expect(1, 12591, '\P{^Blk=bopomofo}', "");
    Expect(0, 12592, '\p{Blk=bopomofo}', "");
    Expect(1, 12592, '\p{^Blk=bopomofo}', "");
    Expect(1, 12592, '\P{Blk=bopomofo}', "");
    Expect(0, 12592, '\P{^Blk=bopomofo}', "");
    Expect(1, 12591, '\p{Blk=_	Bopomofo}', "");
    Expect(0, 12591, '\p{^Blk=_	Bopomofo}', "");
    Expect(0, 12591, '\P{Blk=_	Bopomofo}', "");
    Expect(1, 12591, '\P{^Blk=_	Bopomofo}', "");
    Expect(0, 12592, '\p{Blk=_	Bopomofo}', "");
    Expect(1, 12592, '\p{^Blk=_	Bopomofo}', "");
    Expect(1, 12592, '\P{Blk=_	Bopomofo}', "");
    Expect(0, 12592, '\P{^Blk=_	Bopomofo}', "");
    Error('\p{Is_Block=:=	-bopomofo}');
    Error('\P{Is_Block=:=	-bopomofo}');
    Expect(1, 12591, '\p{Is_Block=bopomofo}', "");
    Expect(0, 12591, '\p{^Is_Block=bopomofo}', "");
    Expect(0, 12591, '\P{Is_Block=bopomofo}', "");
    Expect(1, 12591, '\P{^Is_Block=bopomofo}', "");
    Expect(0, 12592, '\p{Is_Block=bopomofo}', "");
    Expect(1, 12592, '\p{^Is_Block=bopomofo}', "");
    Expect(1, 12592, '\P{Is_Block=bopomofo}', "");
    Expect(0, 12592, '\P{^Is_Block=bopomofo}', "");
    Expect(1, 12591, '\p{Is_Block=-	BOPOMOFO}', "");
    Expect(0, 12591, '\p{^Is_Block=-	BOPOMOFO}', "");
    Expect(0, 12591, '\P{Is_Block=-	BOPOMOFO}', "");
    Expect(1, 12591, '\P{^Is_Block=-	BOPOMOFO}', "");
    Expect(0, 12592, '\p{Is_Block=-	BOPOMOFO}', "");
    Expect(1, 12592, '\p{^Is_Block=-	BOPOMOFO}', "");
    Expect(1, 12592, '\P{Is_Block=-	BOPOMOFO}', "");
    Expect(0, 12592, '\P{^Is_Block=-	BOPOMOFO}', "");
    Error('\p{Is_Blk:   -/a/Bopomofo}');
    Error('\P{Is_Blk:   -/a/Bopomofo}');
    Expect(1, 12591, '\p{Is_Blk=bopomofo}', "");
    Expect(0, 12591, '\p{^Is_Blk=bopomofo}', "");
    Expect(0, 12591, '\P{Is_Blk=bopomofo}', "");
    Expect(1, 12591, '\P{^Is_Blk=bopomofo}', "");
    Expect(0, 12592, '\p{Is_Blk=bopomofo}', "");
    Expect(1, 12592, '\p{^Is_Blk=bopomofo}', "");
    Expect(1, 12592, '\P{Is_Blk=bopomofo}', "");
    Expect(0, 12592, '\P{^Is_Blk=bopomofo}', "");
    Expect(1, 12591, '\p{Is_Blk= -BOPOMOFO}', "");
    Expect(0, 12591, '\p{^Is_Blk= -BOPOMOFO}', "");
    Expect(0, 12591, '\P{Is_Blk= -BOPOMOFO}', "");
    Expect(1, 12591, '\P{^Is_Blk= -BOPOMOFO}', "");
    Expect(0, 12592, '\p{Is_Blk= -BOPOMOFO}', "");
    Expect(1, 12592, '\p{^Is_Blk= -BOPOMOFO}', "");
    Expect(1, 12592, '\P{Is_Blk= -BOPOMOFO}', "");
    Expect(0, 12592, '\P{^Is_Blk= -BOPOMOFO}', "");
    Error('\p{Block=/a/Bopomofo_Extended}');
    Error('\P{Block=/a/Bopomofo_Extended}');
    Expect(1, 12735, '\p{Block=bopomofoextended}', "");
    Expect(0, 12735, '\p{^Block=bopomofoextended}', "");
    Expect(0, 12735, '\P{Block=bopomofoextended}', "");
    Expect(1, 12735, '\P{^Block=bopomofoextended}', "");
    Expect(0, 12736, '\p{Block=bopomofoextended}', "");
    Expect(1, 12736, '\p{^Block=bopomofoextended}', "");
    Expect(1, 12736, '\P{Block=bopomofoextended}', "");
    Expect(0, 12736, '\P{^Block=bopomofoextended}', "");
    Expect(1, 12735, '\p{Block=		Bopomofo_Extended}', "");
    Expect(0, 12735, '\p{^Block=		Bopomofo_Extended}', "");
    Expect(0, 12735, '\P{Block=		Bopomofo_Extended}', "");
    Expect(1, 12735, '\P{^Block=		Bopomofo_Extended}', "");
    Expect(0, 12736, '\p{Block=		Bopomofo_Extended}', "");
    Expect(1, 12736, '\p{^Block=		Bopomofo_Extended}', "");
    Expect(1, 12736, '\P{Block=		Bopomofo_Extended}', "");
    Expect(0, 12736, '\P{^Block=		Bopomofo_Extended}', "");
    Error('\p{Blk=- BOPOMOFO_EXT/a/}');
    Error('\P{Blk=- BOPOMOFO_EXT/a/}');
    Expect(1, 12735, '\p{Blk=bopomofoext}', "");
    Expect(0, 12735, '\p{^Blk=bopomofoext}', "");
    Expect(0, 12735, '\P{Blk=bopomofoext}', "");
    Expect(1, 12735, '\P{^Blk=bopomofoext}', "");
    Expect(0, 12736, '\p{Blk=bopomofoext}', "");
    Expect(1, 12736, '\p{^Blk=bopomofoext}', "");
    Expect(1, 12736, '\P{Blk=bopomofoext}', "");
    Expect(0, 12736, '\P{^Blk=bopomofoext}', "");
    Expect(1, 12735, '\p{Blk=-	Bopomofo_Ext}', "");
    Expect(0, 12735, '\p{^Blk=-	Bopomofo_Ext}', "");
    Expect(0, 12735, '\P{Blk=-	Bopomofo_Ext}', "");
    Expect(1, 12735, '\P{^Blk=-	Bopomofo_Ext}', "");
    Expect(0, 12736, '\p{Blk=-	Bopomofo_Ext}', "");
    Expect(1, 12736, '\p{^Blk=-	Bopomofo_Ext}', "");
    Expect(1, 12736, '\P{Blk=-	Bopomofo_Ext}', "");
    Expect(0, 12736, '\P{^Blk=-	Bopomofo_Ext}', "");
    Error('\p{Is_Block=:=_BOPOMOFO_Extended}');
    Error('\P{Is_Block=:=_BOPOMOFO_Extended}');
    Expect(1, 12735, '\p{Is_Block:   bopomofoextended}', "");
    Expect(0, 12735, '\p{^Is_Block:   bopomofoextended}', "");
    Expect(0, 12735, '\P{Is_Block:   bopomofoextended}', "");
    Expect(1, 12735, '\P{^Is_Block:   bopomofoextended}', "");
    Expect(0, 12736, '\p{Is_Block:   bopomofoextended}', "");
    Expect(1, 12736, '\p{^Is_Block:   bopomofoextended}', "");
    Expect(1, 12736, '\P{Is_Block:   bopomofoextended}', "");
    Expect(0, 12736, '\P{^Is_Block:   bopomofoextended}', "");
    Expect(1, 12735, '\p{Is_Block=- bopomofo_EXTENDED}', "");
    Expect(0, 12735, '\p{^Is_Block=- bopomofo_EXTENDED}', "");
    Expect(0, 12735, '\P{Is_Block=- bopomofo_EXTENDED}', "");
    Expect(1, 12735, '\P{^Is_Block=- bopomofo_EXTENDED}', "");
    Expect(0, 12736, '\p{Is_Block=- bopomofo_EXTENDED}', "");
    Expect(1, 12736, '\p{^Is_Block=- bopomofo_EXTENDED}', "");
    Expect(1, 12736, '\P{Is_Block=- bopomofo_EXTENDED}', "");
    Expect(0, 12736, '\P{^Is_Block=- bopomofo_EXTENDED}', "");
    Error('\p{Is_Blk=-/a/Bopomofo_Ext}');
    Error('\P{Is_Blk=-/a/Bopomofo_Ext}');
    Expect(1, 12735, '\p{Is_Blk=bopomofoext}', "");
    Expect(0, 12735, '\p{^Is_Blk=bopomofoext}', "");
    Expect(0, 12735, '\P{Is_Blk=bopomofoext}', "");
    Expect(1, 12735, '\P{^Is_Blk=bopomofoext}', "");
    Expect(0, 12736, '\p{Is_Blk=bopomofoext}', "");
    Expect(1, 12736, '\p{^Is_Blk=bopomofoext}', "");
    Expect(1, 12736, '\P{Is_Blk=bopomofoext}', "");
    Expect(0, 12736, '\P{^Is_Blk=bopomofoext}', "");
    Expect(1, 12735, '\p{Is_Blk=-Bopomofo_EXT}', "");
    Expect(0, 12735, '\p{^Is_Blk=-Bopomofo_EXT}', "");
    Expect(0, 12735, '\P{Is_Blk=-Bopomofo_EXT}', "");
    Expect(1, 12735, '\P{^Is_Blk=-Bopomofo_EXT}', "");
    Expect(0, 12736, '\p{Is_Blk=-Bopomofo_EXT}', "");
    Expect(1, 12736, '\p{^Is_Blk=-Bopomofo_EXT}', "");
    Expect(1, 12736, '\P{Is_Blk=-Bopomofo_EXT}', "");
    Expect(0, 12736, '\P{^Is_Blk=-Bopomofo_EXT}', "");
    Error('\p{Block=Box_Drawing/a/}');
    Error('\P{Block=Box_Drawing/a/}');
    Expect(1, 9599, '\p{Block=boxdrawing}', "");
    Expect(0, 9599, '\p{^Block=boxdrawing}', "");
    Expect(0, 9599, '\P{Block=boxdrawing}', "");
    Expect(1, 9599, '\P{^Block=boxdrawing}', "");
    Expect(0, 9600, '\p{Block=boxdrawing}', "");
    Expect(1, 9600, '\p{^Block=boxdrawing}', "");
    Expect(1, 9600, '\P{Block=boxdrawing}', "");
    Expect(0, 9600, '\P{^Block=boxdrawing}', "");
    Expect(1, 9599, '\p{Block=_Box_Drawing}', "");
    Expect(0, 9599, '\p{^Block=_Box_Drawing}', "");
    Expect(0, 9599, '\P{Block=_Box_Drawing}', "");
    Expect(1, 9599, '\P{^Block=_Box_Drawing}', "");
    Expect(0, 9600, '\p{Block=_Box_Drawing}', "");
    Expect(1, 9600, '\p{^Block=_Box_Drawing}', "");
    Expect(1, 9600, '\P{Block=_Box_Drawing}', "");
    Expect(0, 9600, '\P{^Block=_Box_Drawing}', "");
    Error('\p{Blk=_Box_DRAWING:=}');
    Error('\P{Blk=_Box_DRAWING:=}');
    Expect(1, 9599, '\p{Blk=boxdrawing}', "");
    Expect(0, 9599, '\p{^Blk=boxdrawing}', "");
    Expect(0, 9599, '\P{Blk=boxdrawing}', "");
    Expect(1, 9599, '\P{^Blk=boxdrawing}', "");
    Expect(0, 9600, '\p{Blk=boxdrawing}', "");
    Expect(1, 9600, '\p{^Blk=boxdrawing}', "");
    Expect(1, 9600, '\P{Blk=boxdrawing}', "");
    Expect(0, 9600, '\P{^Blk=boxdrawing}', "");
    Expect(1, 9599, '\p{Blk:-_Box_Drawing}', "");
    Expect(0, 9599, '\p{^Blk:-_Box_Drawing}', "");
    Expect(0, 9599, '\P{Blk:-_Box_Drawing}', "");
    Expect(1, 9599, '\P{^Blk:-_Box_Drawing}', "");
    Expect(0, 9600, '\p{Blk:-_Box_Drawing}', "");
    Expect(1, 9600, '\p{^Blk:-_Box_Drawing}', "");
    Expect(1, 9600, '\P{Blk:-_Box_Drawing}', "");
    Expect(0, 9600, '\P{^Blk:-_Box_Drawing}', "");
    Error('\p{Is_Block= 	box_drawing:=}');
    Error('\P{Is_Block= 	box_drawing:=}');
    Expect(1, 9599, '\p{Is_Block=boxdrawing}', "");
    Expect(0, 9599, '\p{^Is_Block=boxdrawing}', "");
    Expect(0, 9599, '\P{Is_Block=boxdrawing}', "");
    Expect(1, 9599, '\P{^Is_Block=boxdrawing}', "");
    Expect(0, 9600, '\p{Is_Block=boxdrawing}', "");
    Expect(1, 9600, '\p{^Is_Block=boxdrawing}', "");
    Expect(1, 9600, '\P{Is_Block=boxdrawing}', "");
    Expect(0, 9600, '\P{^Is_Block=boxdrawing}', "");
    Expect(1, 9599, '\p{Is_Block:--BOX_Drawing}', "");
    Expect(0, 9599, '\p{^Is_Block:--BOX_Drawing}', "");
    Expect(0, 9599, '\P{Is_Block:--BOX_Drawing}', "");
    Expect(1, 9599, '\P{^Is_Block:--BOX_Drawing}', "");
    Expect(0, 9600, '\p{Is_Block:--BOX_Drawing}', "");
    Expect(1, 9600, '\p{^Is_Block:--BOX_Drawing}', "");
    Expect(1, 9600, '\P{Is_Block:--BOX_Drawing}', "");
    Expect(0, 9600, '\P{^Is_Block:--BOX_Drawing}', "");
    Error('\p{Is_Blk= -Box_drawing/a/}');
    Error('\P{Is_Blk= -Box_drawing/a/}');
    Expect(1, 9599, '\p{Is_Blk=boxdrawing}', "");
    Expect(0, 9599, '\p{^Is_Blk=boxdrawing}', "");
    Expect(0, 9599, '\P{Is_Blk=boxdrawing}', "");
    Expect(1, 9599, '\P{^Is_Blk=boxdrawing}', "");
    Expect(0, 9600, '\p{Is_Blk=boxdrawing}', "");
    Expect(1, 9600, '\p{^Is_Blk=boxdrawing}', "");
    Expect(1, 9600, '\P{Is_Blk=boxdrawing}', "");
    Expect(0, 9600, '\P{^Is_Blk=boxdrawing}', "");
    Expect(1, 9599, '\p{Is_Blk=	_box_Drawing}', "");
    Expect(0, 9599, '\p{^Is_Blk=	_box_Drawing}', "");
    Expect(0, 9599, '\P{Is_Blk=	_box_Drawing}', "");
    Expect(1, 9599, '\P{^Is_Blk=	_box_Drawing}', "");
    Expect(0, 9600, '\p{Is_Blk=	_box_Drawing}', "");
    Expect(1, 9600, '\p{^Is_Blk=	_box_Drawing}', "");
    Expect(1, 9600, '\P{Is_Blk=	_box_Drawing}', "");
    Expect(0, 9600, '\P{^Is_Blk=	_box_Drawing}', "");
    Error('\p{Block=-:=Brahmi}');
    Error('\P{Block=-:=Brahmi}');
    Expect(1, 69759, '\p{Block=brahmi}', "");
    Expect(0, 69759, '\p{^Block=brahmi}', "");
    Expect(0, 69759, '\P{Block=brahmi}', "");
    Expect(1, 69759, '\P{^Block=brahmi}', "");
    Expect(0, 69760, '\p{Block=brahmi}', "");
    Expect(1, 69760, '\p{^Block=brahmi}', "");
    Expect(1, 69760, '\P{Block=brahmi}', "");
    Expect(0, 69760, '\P{^Block=brahmi}', "");
    Expect(1, 69759, '\p{Block=	BRAHMI}', "");
    Expect(0, 69759, '\p{^Block=	BRAHMI}', "");
    Expect(0, 69759, '\P{Block=	BRAHMI}', "");
    Expect(1, 69759, '\P{^Block=	BRAHMI}', "");
    Expect(0, 69760, '\p{Block=	BRAHMI}', "");
    Expect(1, 69760, '\p{^Block=	BRAHMI}', "");
    Expect(1, 69760, '\P{Block=	BRAHMI}', "");
    Expect(0, 69760, '\P{^Block=	BRAHMI}', "");
    Error('\p{Blk:   /a/ Brahmi}');
    Error('\P{Blk:   /a/ Brahmi}');
    Expect(1, 69759, '\p{Blk:brahmi}', "");
    Expect(0, 69759, '\p{^Blk:brahmi}', "");
    Expect(0, 69759, '\P{Blk:brahmi}', "");
    Expect(1, 69759, '\P{^Blk:brahmi}', "");
    Expect(0, 69760, '\p{Blk:brahmi}', "");
    Expect(1, 69760, '\p{^Blk:brahmi}', "");
    Expect(1, 69760, '\P{Blk:brahmi}', "");
    Expect(0, 69760, '\P{^Blk:brahmi}', "");
    Expect(1, 69759, '\p{Blk=	BRAHMI}', "");
    Expect(0, 69759, '\p{^Blk=	BRAHMI}', "");
    Expect(0, 69759, '\P{Blk=	BRAHMI}', "");
    Expect(1, 69759, '\P{^Blk=	BRAHMI}', "");
    Expect(0, 69760, '\p{Blk=	BRAHMI}', "");
    Expect(1, 69760, '\p{^Blk=	BRAHMI}', "");
    Expect(1, 69760, '\P{Blk=	BRAHMI}', "");
    Expect(0, 69760, '\P{^Blk=	BRAHMI}', "");
    Error('\p{Is_Block=-/a/Brahmi}');
    Error('\P{Is_Block=-/a/Brahmi}');
    Expect(1, 69759, '\p{Is_Block=brahmi}', "");
    Expect(0, 69759, '\p{^Is_Block=brahmi}', "");
    Expect(0, 69759, '\P{Is_Block=brahmi}', "");
    Expect(1, 69759, '\P{^Is_Block=brahmi}', "");
    Expect(0, 69760, '\p{Is_Block=brahmi}', "");
    Expect(1, 69760, '\p{^Is_Block=brahmi}', "");
    Expect(1, 69760, '\P{Is_Block=brahmi}', "");
    Expect(0, 69760, '\P{^Is_Block=brahmi}', "");
    Expect(1, 69759, '\p{Is_Block=-BRAHMI}', "");
    Expect(0, 69759, '\p{^Is_Block=-BRAHMI}', "");
    Expect(0, 69759, '\P{Is_Block=-BRAHMI}', "");
    Expect(1, 69759, '\P{^Is_Block=-BRAHMI}', "");
    Expect(0, 69760, '\p{Is_Block=-BRAHMI}', "");
    Expect(1, 69760, '\p{^Is_Block=-BRAHMI}', "");
    Expect(1, 69760, '\P{Is_Block=-BRAHMI}', "");
    Expect(0, 69760, '\P{^Is_Block=-BRAHMI}', "");
    Error('\p{Is_Blk=/a/Brahmi}');
    Error('\P{Is_Blk=/a/Brahmi}');
    Expect(1, 69759, '\p{Is_Blk:brahmi}', "");
    Expect(0, 69759, '\p{^Is_Blk:brahmi}', "");
    Expect(0, 69759, '\P{Is_Blk:brahmi}', "");
    Expect(1, 69759, '\P{^Is_Blk:brahmi}', "");
    Expect(0, 69760, '\p{Is_Blk:brahmi}', "");
    Expect(1, 69760, '\p{^Is_Blk:brahmi}', "");
    Expect(1, 69760, '\P{Is_Blk:brahmi}', "");
    Expect(0, 69760, '\P{^Is_Blk:brahmi}', "");
    Expect(1, 69759, '\p{Is_Blk=_ brahmi}', "");
    Expect(0, 69759, '\p{^Is_Blk=_ brahmi}', "");
    Expect(0, 69759, '\P{Is_Blk=_ brahmi}', "");
    Expect(1, 69759, '\P{^Is_Blk=_ brahmi}', "");
    Expect(0, 69760, '\p{Is_Blk=_ brahmi}', "");
    Expect(1, 69760, '\p{^Is_Blk=_ brahmi}', "");
    Expect(1, 69760, '\P{Is_Blk=_ brahmi}', "");
    Expect(0, 69760, '\P{^Is_Blk=_ brahmi}', "");
    Error('\p{Block=:=-	braille_patterns}');
    Error('\P{Block=:=-	braille_patterns}');
    Expect(1, 10495, '\p{Block=braillepatterns}', "");
    Expect(0, 10495, '\p{^Block=braillepatterns}', "");
    Expect(0, 10495, '\P{Block=braillepatterns}', "");
    Expect(1, 10495, '\P{^Block=braillepatterns}', "");
    Expect(0, 10496, '\p{Block=braillepatterns}', "");
    Expect(1, 10496, '\p{^Block=braillepatterns}', "");
    Expect(1, 10496, '\P{Block=braillepatterns}', "");
    Expect(0, 10496, '\P{^Block=braillepatterns}', "");
    Expect(1, 10495, '\p{Block=_braille_Patterns}', "");
    Expect(0, 10495, '\p{^Block=_braille_Patterns}', "");
    Expect(0, 10495, '\P{Block=_braille_Patterns}', "");
    Expect(1, 10495, '\P{^Block=_braille_Patterns}', "");
    Expect(0, 10496, '\p{Block=_braille_Patterns}', "");
    Expect(1, 10496, '\p{^Block=_braille_Patterns}', "");
    Expect(1, 10496, '\P{Block=_braille_Patterns}', "");
    Expect(0, 10496, '\P{^Block=_braille_Patterns}', "");
    Error('\p{Blk=:=Braille}');
    Error('\P{Blk=:=Braille}');
    Expect(1, 10495, '\p{Blk=braille}', "");
    Expect(0, 10495, '\p{^Blk=braille}', "");
    Expect(0, 10495, '\P{Blk=braille}', "");
    Expect(1, 10495, '\P{^Blk=braille}', "");
    Expect(0, 10496, '\p{Blk=braille}', "");
    Expect(1, 10496, '\p{^Blk=braille}', "");
    Expect(1, 10496, '\P{Blk=braille}', "");
    Expect(0, 10496, '\P{^Blk=braille}', "");
    Expect(1, 10495, '\p{Blk=		Braille}', "");
    Expect(0, 10495, '\p{^Blk=		Braille}', "");
    Expect(0, 10495, '\P{Blk=		Braille}', "");
    Expect(1, 10495, '\P{^Blk=		Braille}', "");
    Expect(0, 10496, '\p{Blk=		Braille}', "");
    Expect(1, 10496, '\p{^Blk=		Braille}', "");
    Expect(1, 10496, '\P{Blk=		Braille}', "");
    Expect(0, 10496, '\P{^Blk=		Braille}', "");
    Error('\p{Is_Block=__braille_Patterns:=}');
    Error('\P{Is_Block=__braille_Patterns:=}');
    Expect(1, 10495, '\p{Is_Block=braillepatterns}', "");
    Expect(0, 10495, '\p{^Is_Block=braillepatterns}', "");
    Expect(0, 10495, '\P{Is_Block=braillepatterns}', "");
    Expect(1, 10495, '\P{^Is_Block=braillepatterns}', "");
    Expect(0, 10496, '\p{Is_Block=braillepatterns}', "");
    Expect(1, 10496, '\p{^Is_Block=braillepatterns}', "");
    Expect(1, 10496, '\P{Is_Block=braillepatterns}', "");
    Expect(0, 10496, '\P{^Is_Block=braillepatterns}', "");
    Expect(1, 10495, '\p{Is_Block= BRAILLE_Patterns}', "");
    Expect(0, 10495, '\p{^Is_Block= BRAILLE_Patterns}', "");
    Expect(0, 10495, '\P{Is_Block= BRAILLE_Patterns}', "");
    Expect(1, 10495, '\P{^Is_Block= BRAILLE_Patterns}', "");
    Expect(0, 10496, '\p{Is_Block= BRAILLE_Patterns}', "");
    Expect(1, 10496, '\p{^Is_Block= BRAILLE_Patterns}', "");
    Expect(1, 10496, '\P{Is_Block= BRAILLE_Patterns}', "");
    Expect(0, 10496, '\P{^Is_Block= BRAILLE_Patterns}', "");
    Error('\p{Is_Blk: --Braille/a/}');
    Error('\P{Is_Blk: --Braille/a/}');
    Expect(1, 10495, '\p{Is_Blk=braille}', "");
    Expect(0, 10495, '\p{^Is_Blk=braille}', "");
    Expect(0, 10495, '\P{Is_Blk=braille}', "");
    Expect(1, 10495, '\P{^Is_Blk=braille}', "");
    Expect(0, 10496, '\p{Is_Blk=braille}', "");
    Expect(1, 10496, '\p{^Is_Blk=braille}', "");
    Expect(1, 10496, '\P{Is_Blk=braille}', "");
    Expect(0, 10496, '\P{^Is_Blk=braille}', "");
    Expect(1, 10495, '\p{Is_Blk=_BRAILLE}', "");
    Expect(0, 10495, '\p{^Is_Blk=_BRAILLE}', "");
    Expect(0, 10495, '\P{Is_Blk=_BRAILLE}', "");
    Expect(1, 10495, '\P{^Is_Blk=_BRAILLE}', "");
    Expect(0, 10496, '\p{Is_Blk=_BRAILLE}', "");
    Expect(1, 10496, '\p{^Is_Blk=_BRAILLE}', "");
    Expect(1, 10496, '\P{Is_Blk=_BRAILLE}', "");
    Expect(0, 10496, '\P{^Is_Blk=_BRAILLE}', "");
    Error('\p{Block=_/a/buginese}');
    Error('\P{Block=_/a/buginese}');
    Expect(1, 6687, '\p{Block:buginese}', "");
    Expect(0, 6687, '\p{^Block:buginese}', "");
    Expect(0, 6687, '\P{Block:buginese}', "");
    Expect(1, 6687, '\P{^Block:buginese}', "");
    Expect(0, 6688, '\p{Block:buginese}', "");
    Expect(1, 6688, '\p{^Block:buginese}', "");
    Expect(1, 6688, '\P{Block:buginese}', "");
    Expect(0, 6688, '\P{^Block:buginese}', "");
    Expect(1, 6687, '\p{Block:   	Buginese}', "");
    Expect(0, 6687, '\p{^Block:   	Buginese}', "");
    Expect(0, 6687, '\P{Block:   	Buginese}', "");
    Expect(1, 6687, '\P{^Block:   	Buginese}', "");
    Expect(0, 6688, '\p{Block:   	Buginese}', "");
    Expect(1, 6688, '\p{^Block:   	Buginese}', "");
    Expect(1, 6688, '\P{Block:   	Buginese}', "");
    Expect(0, 6688, '\P{^Block:   	Buginese}', "");
    Error('\p{Blk=_BUGINESE:=}');
    Error('\P{Blk=_BUGINESE:=}');
    Expect(1, 6687, '\p{Blk=buginese}', "");
    Expect(0, 6687, '\p{^Blk=buginese}', "");
    Expect(0, 6687, '\P{Blk=buginese}', "");
    Expect(1, 6687, '\P{^Blk=buginese}', "");
    Expect(0, 6688, '\p{Blk=buginese}', "");
    Expect(1, 6688, '\p{^Blk=buginese}', "");
    Expect(1, 6688, '\P{Blk=buginese}', "");
    Expect(0, 6688, '\P{^Blk=buginese}', "");
    Expect(1, 6687, '\p{Blk=	BUGINESE}', "");
    Expect(0, 6687, '\p{^Blk=	BUGINESE}', "");
    Expect(0, 6687, '\P{Blk=	BUGINESE}', "");
    Expect(1, 6687, '\P{^Blk=	BUGINESE}', "");
    Expect(0, 6688, '\p{Blk=	BUGINESE}', "");
    Expect(1, 6688, '\p{^Blk=	BUGINESE}', "");
    Expect(1, 6688, '\P{Blk=	BUGINESE}', "");
    Expect(0, 6688, '\P{^Blk=	BUGINESE}', "");
    Error('\p{Is_Block:   	BUGINESE/a/}');
    Error('\P{Is_Block:   	BUGINESE/a/}');
    Expect(1, 6687, '\p{Is_Block: buginese}', "");
    Expect(0, 6687, '\p{^Is_Block: buginese}', "");
    Expect(0, 6687, '\P{Is_Block: buginese}', "");
    Expect(1, 6687, '\P{^Is_Block: buginese}', "");
    Expect(0, 6688, '\p{Is_Block: buginese}', "");
    Expect(1, 6688, '\p{^Is_Block: buginese}', "");
    Expect(1, 6688, '\P{Is_Block: buginese}', "");
    Expect(0, 6688, '\P{^Is_Block: buginese}', "");
    Expect(1, 6687, '\p{Is_Block=	buginese}', "");
    Expect(0, 6687, '\p{^Is_Block=	buginese}', "");
    Expect(0, 6687, '\P{Is_Block=	buginese}', "");
    Expect(1, 6687, '\P{^Is_Block=	buginese}', "");
    Expect(0, 6688, '\p{Is_Block=	buginese}', "");
    Expect(1, 6688, '\p{^Is_Block=	buginese}', "");
    Expect(1, 6688, '\P{Is_Block=	buginese}', "");
    Expect(0, 6688, '\P{^Is_Block=	buginese}', "");
    Error('\p{Is_Blk=:=-_Buginese}');
    Error('\P{Is_Blk=:=-_Buginese}');
    Expect(1, 6687, '\p{Is_Blk=buginese}', "");
    Expect(0, 6687, '\p{^Is_Blk=buginese}', "");
    Expect(0, 6687, '\P{Is_Blk=buginese}', "");
    Expect(1, 6687, '\P{^Is_Blk=buginese}', "");
    Expect(0, 6688, '\p{Is_Blk=buginese}', "");
    Expect(1, 6688, '\p{^Is_Blk=buginese}', "");
    Expect(1, 6688, '\P{Is_Blk=buginese}', "");
    Expect(0, 6688, '\P{^Is_Blk=buginese}', "");
    Expect(1, 6687, '\p{Is_Blk: _ Buginese}', "");
    Expect(0, 6687, '\p{^Is_Blk: _ Buginese}', "");
    Expect(0, 6687, '\P{Is_Blk: _ Buginese}', "");
    Expect(1, 6687, '\P{^Is_Blk: _ Buginese}', "");
    Expect(0, 6688, '\p{Is_Blk: _ Buginese}', "");
    Expect(1, 6688, '\p{^Is_Blk: _ Buginese}', "");
    Expect(1, 6688, '\P{Is_Blk: _ Buginese}', "");
    Expect(0, 6688, '\P{^Is_Blk: _ Buginese}', "");
    Error('\p{Block=:=_-Buhid}');
    Error('\P{Block=:=_-Buhid}');
    Expect(1, 5983, '\p{Block=buhid}', "");
    Expect(0, 5983, '\p{^Block=buhid}', "");
    Expect(0, 5983, '\P{Block=buhid}', "");
    Expect(1, 5983, '\P{^Block=buhid}', "");
    Expect(0, 5984, '\p{Block=buhid}', "");
    Expect(1, 5984, '\p{^Block=buhid}', "");
    Expect(1, 5984, '\P{Block=buhid}', "");
    Expect(0, 5984, '\P{^Block=buhid}', "");
    Expect(1, 5983, '\p{Block=- Buhid}', "");
    Expect(0, 5983, '\p{^Block=- Buhid}', "");
    Expect(0, 5983, '\P{Block=- Buhid}', "");
    Expect(1, 5983, '\P{^Block=- Buhid}', "");
    Expect(0, 5984, '\p{Block=- Buhid}', "");
    Expect(1, 5984, '\p{^Block=- Buhid}', "");
    Expect(1, 5984, '\P{Block=- Buhid}', "");
    Expect(0, 5984, '\P{^Block=- Buhid}', "");
    Error('\p{Blk: _ buhid/a/}');
    Error('\P{Blk: _ buhid/a/}');
    Expect(1, 5983, '\p{Blk=buhid}', "");
    Expect(0, 5983, '\p{^Blk=buhid}', "");
    Expect(0, 5983, '\P{Blk=buhid}', "");
    Expect(1, 5983, '\P{^Blk=buhid}', "");
    Expect(0, 5984, '\p{Blk=buhid}', "");
    Expect(1, 5984, '\p{^Blk=buhid}', "");
    Expect(1, 5984, '\P{Blk=buhid}', "");
    Expect(0, 5984, '\P{^Blk=buhid}', "");
    Expect(1, 5983, '\p{Blk=-	buhid}', "");
    Expect(0, 5983, '\p{^Blk=-	buhid}', "");
    Expect(0, 5983, '\P{Blk=-	buhid}', "");
    Expect(1, 5983, '\P{^Blk=-	buhid}', "");
    Expect(0, 5984, '\p{Blk=-	buhid}', "");
    Expect(1, 5984, '\p{^Blk=-	buhid}', "");
    Expect(1, 5984, '\P{Blk=-	buhid}', "");
    Expect(0, 5984, '\P{^Blk=-	buhid}', "");
    Error('\p{Is_Block=		buhid/a/}');
    Error('\P{Is_Block=		buhid/a/}');
    Expect(1, 5983, '\p{Is_Block=buhid}', "");
    Expect(0, 5983, '\p{^Is_Block=buhid}', "");
    Expect(0, 5983, '\P{Is_Block=buhid}', "");
    Expect(1, 5983, '\P{^Is_Block=buhid}', "");
    Expect(0, 5984, '\p{Is_Block=buhid}', "");
    Expect(1, 5984, '\p{^Is_Block=buhid}', "");
    Expect(1, 5984, '\P{Is_Block=buhid}', "");
    Expect(0, 5984, '\P{^Is_Block=buhid}', "");
    Expect(1, 5983, '\p{Is_Block=		BUHID}', "");
    Expect(0, 5983, '\p{^Is_Block=		BUHID}', "");
    Expect(0, 5983, '\P{Is_Block=		BUHID}', "");
    Expect(1, 5983, '\P{^Is_Block=		BUHID}', "");
    Expect(0, 5984, '\p{Is_Block=		BUHID}', "");
    Expect(1, 5984, '\p{^Is_Block=		BUHID}', "");
    Expect(1, 5984, '\P{Is_Block=		BUHID}', "");
    Expect(0, 5984, '\P{^Is_Block=		BUHID}', "");
    Error('\p{Is_Blk:_-buhid:=}');
    Error('\P{Is_Blk:_-buhid:=}');
    Expect(1, 5983, '\p{Is_Blk=buhid}', "");
    Expect(0, 5983, '\p{^Is_Blk=buhid}', "");
    Expect(0, 5983, '\P{Is_Blk=buhid}', "");
    Expect(1, 5983, '\P{^Is_Blk=buhid}', "");
    Expect(0, 5984, '\p{Is_Blk=buhid}', "");
    Expect(1, 5984, '\p{^Is_Blk=buhid}', "");
    Expect(1, 5984, '\P{Is_Blk=buhid}', "");
    Expect(0, 5984, '\P{^Is_Blk=buhid}', "");
    Expect(1, 5983, '\p{Is_Blk= BUHID}', "");
    Expect(0, 5983, '\p{^Is_Blk= BUHID}', "");
    Expect(0, 5983, '\P{Is_Blk= BUHID}', "");
    Expect(1, 5983, '\P{^Is_Blk= BUHID}', "");
    Expect(0, 5984, '\p{Is_Blk= BUHID}', "");
    Expect(1, 5984, '\p{^Is_Blk= BUHID}', "");
    Expect(1, 5984, '\P{Is_Blk= BUHID}', "");
    Expect(0, 5984, '\P{^Is_Blk= BUHID}', "");
    Error('\p{Block=:=-_BYZANTINE_Musical_Symbols}');
    Error('\P{Block=:=-_BYZANTINE_Musical_Symbols}');
    Expect(1, 119039, '\p{Block=byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\p{^Block=byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\P{Block=byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\P{^Block=byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\p{Block=byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\p{^Block=byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\P{Block=byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\P{^Block=byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\p{Block= Byzantine_Musical_symbols}', "");
    Expect(0, 119039, '\p{^Block= Byzantine_Musical_symbols}', "");
    Expect(0, 119039, '\P{Block= Byzantine_Musical_symbols}', "");
    Expect(1, 119039, '\P{^Block= Byzantine_Musical_symbols}', "");
    Expect(0, 119040, '\p{Block= Byzantine_Musical_symbols}', "");
    Expect(1, 119040, '\p{^Block= Byzantine_Musical_symbols}', "");
    Expect(1, 119040, '\P{Block= Byzantine_Musical_symbols}', "");
    Expect(0, 119040, '\P{^Block= Byzantine_Musical_symbols}', "");
    Error('\p{Blk: :=BYZANTINE_Music}');
    Error('\P{Blk: :=BYZANTINE_Music}');
    Expect(1, 119039, '\p{Blk=byzantinemusic}', "");
    Expect(0, 119039, '\p{^Blk=byzantinemusic}', "");
    Expect(0, 119039, '\P{Blk=byzantinemusic}', "");
    Expect(1, 119039, '\P{^Blk=byzantinemusic}', "");
    Expect(0, 119040, '\p{Blk=byzantinemusic}', "");
    Expect(1, 119040, '\p{^Blk=byzantinemusic}', "");
    Expect(1, 119040, '\P{Blk=byzantinemusic}', "");
    Expect(0, 119040, '\P{^Blk=byzantinemusic}', "");
    Expect(1, 119039, '\p{Blk=-_byzantine_MUSIC}', "");
    Expect(0, 119039, '\p{^Blk=-_byzantine_MUSIC}', "");
    Expect(0, 119039, '\P{Blk=-_byzantine_MUSIC}', "");
    Expect(1, 119039, '\P{^Blk=-_byzantine_MUSIC}', "");
    Expect(0, 119040, '\p{Blk=-_byzantine_MUSIC}', "");
    Expect(1, 119040, '\p{^Blk=-_byzantine_MUSIC}', "");
    Expect(1, 119040, '\P{Blk=-_byzantine_MUSIC}', "");
    Expect(0, 119040, '\P{^Blk=-_byzantine_MUSIC}', "");
    Error('\p{Is_Block=/a/	Byzantine_Musical_symbols}');
    Error('\P{Is_Block=/a/	Byzantine_Musical_symbols}');
    Expect(1, 119039, '\p{Is_Block=byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\p{^Is_Block=byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\P{Is_Block=byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\P{^Is_Block=byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\p{Is_Block=byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\p{^Is_Block=byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\P{Is_Block=byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\P{^Is_Block=byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\p{Is_Block=_	byzantine_Musical_SYMBOLS}', "");
    Expect(0, 119039, '\p{^Is_Block=_	byzantine_Musical_SYMBOLS}', "");
    Expect(0, 119039, '\P{Is_Block=_	byzantine_Musical_SYMBOLS}', "");
    Expect(1, 119039, '\P{^Is_Block=_	byzantine_Musical_SYMBOLS}', "");
    Expect(0, 119040, '\p{Is_Block=_	byzantine_Musical_SYMBOLS}', "");
    Expect(1, 119040, '\p{^Is_Block=_	byzantine_Musical_SYMBOLS}', "");
    Expect(1, 119040, '\P{Is_Block=_	byzantine_Musical_SYMBOLS}', "");
    Expect(0, 119040, '\P{^Is_Block=_	byzantine_Musical_SYMBOLS}', "");
    Error('\p{Is_Blk=_:=byzantine_MUSIC}');
    Error('\P{Is_Blk=_:=byzantine_MUSIC}');
    Expect(1, 119039, '\p{Is_Blk=byzantinemusic}', "");
    Expect(0, 119039, '\p{^Is_Blk=byzantinemusic}', "");
    Expect(0, 119039, '\P{Is_Blk=byzantinemusic}', "");
    Expect(1, 119039, '\P{^Is_Blk=byzantinemusic}', "");
    Expect(0, 119040, '\p{Is_Blk=byzantinemusic}', "");
    Expect(1, 119040, '\p{^Is_Blk=byzantinemusic}', "");
    Expect(1, 119040, '\P{Is_Blk=byzantinemusic}', "");
    Expect(0, 119040, '\P{^Is_Blk=byzantinemusic}', "");
    Expect(1, 119039, '\p{Is_Blk=	-Byzantine_Music}', "");
    Expect(0, 119039, '\p{^Is_Blk=	-Byzantine_Music}', "");
    Expect(0, 119039, '\P{Is_Blk=	-Byzantine_Music}', "");
    Expect(1, 119039, '\P{^Is_Blk=	-Byzantine_Music}', "");
    Expect(0, 119040, '\p{Is_Blk=	-Byzantine_Music}', "");
    Expect(1, 119040, '\p{^Is_Blk=	-Byzantine_Music}', "");
    Expect(1, 119040, '\P{Is_Blk=	-Byzantine_Music}', "");
    Expect(0, 119040, '\P{^Is_Blk=	-Byzantine_Music}', "");
    Error('\p{Block=--CARIAN:=}');
    Error('\P{Block=--CARIAN:=}');
    Expect(1, 66271, '\p{Block=carian}', "");
    Expect(0, 66271, '\p{^Block=carian}', "");
    Expect(0, 66271, '\P{Block=carian}', "");
    Expect(1, 66271, '\P{^Block=carian}', "");
    Expect(0, 66272, '\p{Block=carian}', "");
    Expect(1, 66272, '\p{^Block=carian}', "");
    Expect(1, 66272, '\P{Block=carian}', "");
    Expect(0, 66272, '\P{^Block=carian}', "");
    Expect(1, 66271, '\p{Block=		Carian}', "");
    Expect(0, 66271, '\p{^Block=		Carian}', "");
    Expect(0, 66271, '\P{Block=		Carian}', "");
    Expect(1, 66271, '\P{^Block=		Carian}', "");
    Expect(0, 66272, '\p{Block=		Carian}', "");
    Expect(1, 66272, '\p{^Block=		Carian}', "");
    Expect(1, 66272, '\P{Block=		Carian}', "");
    Expect(0, 66272, '\P{^Block=		Carian}', "");
    Error('\p{Blk:   /a/- carian}');
    Error('\P{Blk:   /a/- carian}');
    Expect(1, 66271, '\p{Blk=carian}', "");
    Expect(0, 66271, '\p{^Blk=carian}', "");
    Expect(0, 66271, '\P{Blk=carian}', "");
    Expect(1, 66271, '\P{^Blk=carian}', "");
    Expect(0, 66272, '\p{Blk=carian}', "");
    Expect(1, 66272, '\p{^Blk=carian}', "");
    Expect(1, 66272, '\P{Blk=carian}', "");
    Expect(0, 66272, '\P{^Blk=carian}', "");
    Expect(1, 66271, '\p{Blk=- CARIAN}', "");
    Expect(0, 66271, '\p{^Blk=- CARIAN}', "");
    Expect(0, 66271, '\P{Blk=- CARIAN}', "");
    Expect(1, 66271, '\P{^Blk=- CARIAN}', "");
    Expect(0, 66272, '\p{Blk=- CARIAN}', "");
    Expect(1, 66272, '\p{^Blk=- CARIAN}', "");
    Expect(1, 66272, '\P{Blk=- CARIAN}', "");
    Expect(0, 66272, '\P{^Blk=- CARIAN}', "");
    Error('\p{Is_Block=:=	Carian}');
    Error('\P{Is_Block=:=	Carian}');
    Expect(1, 66271, '\p{Is_Block: carian}', "");
    Expect(0, 66271, '\p{^Is_Block: carian}', "");
    Expect(0, 66271, '\P{Is_Block: carian}', "");
    Expect(1, 66271, '\P{^Is_Block: carian}', "");
    Expect(0, 66272, '\p{Is_Block: carian}', "");
    Expect(1, 66272, '\p{^Is_Block: carian}', "");
    Expect(1, 66272, '\P{Is_Block: carian}', "");
    Expect(0, 66272, '\P{^Is_Block: carian}', "");
    Expect(1, 66271, '\p{Is_Block=  Carian}', "");
    Expect(0, 66271, '\p{^Is_Block=  Carian}', "");
    Expect(0, 66271, '\P{Is_Block=  Carian}', "");
    Expect(1, 66271, '\P{^Is_Block=  Carian}', "");
    Expect(0, 66272, '\p{Is_Block=  Carian}', "");
    Expect(1, 66272, '\p{^Is_Block=  Carian}', "");
    Expect(1, 66272, '\P{Is_Block=  Carian}', "");
    Expect(0, 66272, '\P{^Is_Block=  Carian}', "");
    Error('\p{Is_Blk=:=	-Carian}');
    Error('\P{Is_Blk=:=	-Carian}');
    Expect(1, 66271, '\p{Is_Blk=carian}', "");
    Expect(0, 66271, '\p{^Is_Blk=carian}', "");
    Expect(0, 66271, '\P{Is_Blk=carian}', "");
    Expect(1, 66271, '\P{^Is_Blk=carian}', "");
    Expect(0, 66272, '\p{Is_Blk=carian}', "");
    Expect(1, 66272, '\p{^Is_Blk=carian}', "");
    Expect(1, 66272, '\P{Is_Blk=carian}', "");
    Expect(0, 66272, '\P{^Is_Blk=carian}', "");
    Expect(1, 66271, '\p{Is_Blk=_	CARIAN}', "");
    Expect(0, 66271, '\p{^Is_Blk=_	CARIAN}', "");
    Expect(0, 66271, '\P{Is_Blk=_	CARIAN}', "");
    Expect(1, 66271, '\P{^Is_Blk=_	CARIAN}', "");
    Expect(0, 66272, '\p{Is_Blk=_	CARIAN}', "");
    Expect(1, 66272, '\p{^Is_Blk=_	CARIAN}', "");
    Expect(1, 66272, '\P{Is_Blk=_	CARIAN}', "");
    Expect(0, 66272, '\P{^Is_Blk=_	CARIAN}', "");
    Error('\p{Block=-:=CAUCASIAN_Albanian}');
    Error('\P{Block=-:=CAUCASIAN_Albanian}');
    Expect(1, 66927, '\p{Block=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Block=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Block=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Block=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Block=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Block=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Block=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Block=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Block=_ caucasian_ALBANIAN}', "");
    Expect(0, 66927, '\p{^Block=_ caucasian_ALBANIAN}', "");
    Expect(0, 66927, '\P{Block=_ caucasian_ALBANIAN}', "");
    Expect(1, 66927, '\P{^Block=_ caucasian_ALBANIAN}', "");
    Expect(0, 66928, '\p{Block=_ caucasian_ALBANIAN}', "");
    Expect(1, 66928, '\p{^Block=_ caucasian_ALBANIAN}', "");
    Expect(1, 66928, '\P{Block=_ caucasian_ALBANIAN}', "");
    Expect(0, 66928, '\P{^Block=_ caucasian_ALBANIAN}', "");
    Error('\p{Blk:   :=		Caucasian_Albanian}');
    Error('\P{Blk:   :=		Caucasian_Albanian}');
    Expect(1, 66927, '\p{Blk=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Blk=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Blk=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Blk=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Blk=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Blk=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Blk=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Blk=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Blk=-_caucasian_albanian}', "");
    Expect(0, 66927, '\p{^Blk=-_caucasian_albanian}', "");
    Expect(0, 66927, '\P{Blk=-_caucasian_albanian}', "");
    Expect(1, 66927, '\P{^Blk=-_caucasian_albanian}', "");
    Expect(0, 66928, '\p{Blk=-_caucasian_albanian}', "");
    Expect(1, 66928, '\p{^Blk=-_caucasian_albanian}', "");
    Expect(1, 66928, '\P{Blk=-_caucasian_albanian}', "");
    Expect(0, 66928, '\P{^Blk=-_caucasian_albanian}', "");
    Error('\p{Is_Block=-:=caucasian_Albanian}');
    Error('\P{Is_Block=-:=caucasian_Albanian}');
    Expect(1, 66927, '\p{Is_Block=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Is_Block=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Is_Block=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Is_Block=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Is_Block=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Is_Block=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Is_Block=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Is_Block=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Is_Block=	Caucasian_ALBANIAN}', "");
    Expect(0, 66927, '\p{^Is_Block=	Caucasian_ALBANIAN}', "");
    Expect(0, 66927, '\P{Is_Block=	Caucasian_ALBANIAN}', "");
    Expect(1, 66927, '\P{^Is_Block=	Caucasian_ALBANIAN}', "");
    Expect(0, 66928, '\p{Is_Block=	Caucasian_ALBANIAN}', "");
    Expect(1, 66928, '\p{^Is_Block=	Caucasian_ALBANIAN}', "");
    Expect(1, 66928, '\P{Is_Block=	Caucasian_ALBANIAN}', "");
    Expect(0, 66928, '\P{^Is_Block=	Caucasian_ALBANIAN}', "");
    Error('\p{Is_Blk=	:=caucasian_Albanian}');
    Error('\P{Is_Blk=	:=caucasian_Albanian}');
    Expect(1, 66927, '\p{Is_Blk=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Is_Blk=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Is_Blk=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Is_Blk=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Is_Blk=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Is_Blk=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Is_Blk=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Is_Blk=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Is_Blk=-_CAUCASIAN_albanian}', "");
    Expect(0, 66927, '\p{^Is_Blk=-_CAUCASIAN_albanian}', "");
    Expect(0, 66927, '\P{Is_Blk=-_CAUCASIAN_albanian}', "");
    Expect(1, 66927, '\P{^Is_Blk=-_CAUCASIAN_albanian}', "");
    Expect(0, 66928, '\p{Is_Blk=-_CAUCASIAN_albanian}', "");
    Expect(1, 66928, '\p{^Is_Blk=-_CAUCASIAN_albanian}', "");
    Expect(1, 66928, '\P{Is_Blk=-_CAUCASIAN_albanian}', "");
    Expect(0, 66928, '\P{^Is_Blk=-_CAUCASIAN_albanian}', "");
    Error('\p{Block=_	Chakma:=}');
    Error('\P{Block=_	Chakma:=}');
    Expect(1, 69967, '\p{Block=chakma}', "");
    Expect(0, 69967, '\p{^Block=chakma}', "");
    Expect(0, 69967, '\P{Block=chakma}', "");
    Expect(1, 69967, '\P{^Block=chakma}', "");
    Expect(0, 69968, '\p{Block=chakma}', "");
    Expect(1, 69968, '\p{^Block=chakma}', "");
    Expect(1, 69968, '\P{Block=chakma}', "");
    Expect(0, 69968, '\P{^Block=chakma}', "");
    Expect(1, 69967, '\p{Block=_-chakma}', "");
    Expect(0, 69967, '\p{^Block=_-chakma}', "");
    Expect(0, 69967, '\P{Block=_-chakma}', "");
    Expect(1, 69967, '\P{^Block=_-chakma}', "");
    Expect(0, 69968, '\p{Block=_-chakma}', "");
    Expect(1, 69968, '\p{^Block=_-chakma}', "");
    Expect(1, 69968, '\P{Block=_-chakma}', "");
    Expect(0, 69968, '\P{^Block=_-chakma}', "");
    Error('\p{Blk=/a/_Chakma}');
    Error('\P{Blk=/a/_Chakma}');
    Expect(1, 69967, '\p{Blk=chakma}', "");
    Expect(0, 69967, '\p{^Blk=chakma}', "");
    Expect(0, 69967, '\P{Blk=chakma}', "");
    Expect(1, 69967, '\P{^Blk=chakma}', "");
    Expect(0, 69968, '\p{Blk=chakma}', "");
    Expect(1, 69968, '\p{^Blk=chakma}', "");
    Expect(1, 69968, '\P{Blk=chakma}', "");
    Expect(0, 69968, '\P{^Blk=chakma}', "");
    Expect(1, 69967, '\p{Blk=_-CHAKMA}', "");
    Expect(0, 69967, '\p{^Blk=_-CHAKMA}', "");
    Expect(0, 69967, '\P{Blk=_-CHAKMA}', "");
    Expect(1, 69967, '\P{^Blk=_-CHAKMA}', "");
    Expect(0, 69968, '\p{Blk=_-CHAKMA}', "");
    Expect(1, 69968, '\p{^Blk=_-CHAKMA}', "");
    Expect(1, 69968, '\P{Blk=_-CHAKMA}', "");
    Expect(0, 69968, '\P{^Blk=_-CHAKMA}', "");
    Error('\p{Is_Block=_:=CHAKMA}');
    Error('\P{Is_Block=_:=CHAKMA}');
    Expect(1, 69967, '\p{Is_Block=chakma}', "");
    Expect(0, 69967, '\p{^Is_Block=chakma}', "");
    Expect(0, 69967, '\P{Is_Block=chakma}', "");
    Expect(1, 69967, '\P{^Is_Block=chakma}', "");
    Expect(0, 69968, '\p{Is_Block=chakma}', "");
    Expect(1, 69968, '\p{^Is_Block=chakma}', "");
    Expect(1, 69968, '\P{Is_Block=chakma}', "");
    Expect(0, 69968, '\P{^Is_Block=chakma}', "");
    Expect(1, 69967, '\p{Is_Block: _	Chakma}', "");
    Expect(0, 69967, '\p{^Is_Block: _	Chakma}', "");
    Expect(0, 69967, '\P{Is_Block: _	Chakma}', "");
    Expect(1, 69967, '\P{^Is_Block: _	Chakma}', "");
    Expect(0, 69968, '\p{Is_Block: _	Chakma}', "");
    Expect(1, 69968, '\p{^Is_Block: _	Chakma}', "");
    Expect(1, 69968, '\P{Is_Block: _	Chakma}', "");
    Expect(0, 69968, '\P{^Is_Block: _	Chakma}', "");
    Error('\p{Is_Blk=-/a/CHAKMA}');
    Error('\P{Is_Blk=-/a/CHAKMA}');
    Expect(1, 69967, '\p{Is_Blk=chakma}', "");
    Expect(0, 69967, '\p{^Is_Blk=chakma}', "");
    Expect(0, 69967, '\P{Is_Blk=chakma}', "");
    Expect(1, 69967, '\P{^Is_Blk=chakma}', "");
    Expect(0, 69968, '\p{Is_Blk=chakma}', "");
    Expect(1, 69968, '\p{^Is_Blk=chakma}', "");
    Expect(1, 69968, '\P{Is_Blk=chakma}', "");
    Expect(0, 69968, '\P{^Is_Blk=chakma}', "");
    Expect(1, 69967, '\p{Is_Blk:CHAKMA}', "");
    Expect(0, 69967, '\p{^Is_Blk:CHAKMA}', "");
    Expect(0, 69967, '\P{Is_Blk:CHAKMA}', "");
    Expect(1, 69967, '\P{^Is_Blk:CHAKMA}', "");
    Expect(0, 69968, '\p{Is_Blk:CHAKMA}', "");
    Expect(1, 69968, '\p{^Is_Blk:CHAKMA}', "");
    Expect(1, 69968, '\P{Is_Blk:CHAKMA}', "");
    Expect(0, 69968, '\P{^Is_Blk:CHAKMA}', "");
    Error('\p{Block: Cham:=}');
    Error('\P{Block: Cham:=}');
    Expect(1, 43615, '\p{Block=cham}', "");
    Expect(0, 43615, '\p{^Block=cham}', "");
    Expect(0, 43615, '\P{Block=cham}', "");
    Expect(1, 43615, '\P{^Block=cham}', "");
    Expect(0, 43616, '\p{Block=cham}', "");
    Expect(1, 43616, '\p{^Block=cham}', "");
    Expect(1, 43616, '\P{Block=cham}', "");
    Expect(0, 43616, '\P{^Block=cham}', "");
    Expect(1, 43615, '\p{Block=_-CHAM}', "");
    Expect(0, 43615, '\p{^Block=_-CHAM}', "");
    Expect(0, 43615, '\P{Block=_-CHAM}', "");
    Expect(1, 43615, '\P{^Block=_-CHAM}', "");
    Expect(0, 43616, '\p{Block=_-CHAM}', "");
    Expect(1, 43616, '\p{^Block=_-CHAM}', "");
    Expect(1, 43616, '\P{Block=_-CHAM}', "");
    Expect(0, 43616, '\P{^Block=_-CHAM}', "");
    Error('\p{Blk: /a/		Cham}');
    Error('\P{Blk: /a/		Cham}');
    Expect(1, 43615, '\p{Blk=cham}', "");
    Expect(0, 43615, '\p{^Blk=cham}', "");
    Expect(0, 43615, '\P{Blk=cham}', "");
    Expect(1, 43615, '\P{^Blk=cham}', "");
    Expect(0, 43616, '\p{Blk=cham}', "");
    Expect(1, 43616, '\p{^Blk=cham}', "");
    Expect(1, 43616, '\P{Blk=cham}', "");
    Expect(0, 43616, '\P{^Blk=cham}', "");
    Expect(1, 43615, '\p{Blk= 	cham}', "");
    Expect(0, 43615, '\p{^Blk= 	cham}', "");
    Expect(0, 43615, '\P{Blk= 	cham}', "");
    Expect(1, 43615, '\P{^Blk= 	cham}', "");
    Expect(0, 43616, '\p{Blk= 	cham}', "");
    Expect(1, 43616, '\p{^Blk= 	cham}', "");
    Expect(1, 43616, '\P{Blk= 	cham}', "");
    Expect(0, 43616, '\P{^Blk= 	cham}', "");
    Error('\p{Is_Block= cham:=}');
    Error('\P{Is_Block= cham:=}');
    Expect(1, 43615, '\p{Is_Block=cham}', "");
    Expect(0, 43615, '\p{^Is_Block=cham}', "");
    Expect(0, 43615, '\P{Is_Block=cham}', "");
    Expect(1, 43615, '\P{^Is_Block=cham}', "");
    Expect(0, 43616, '\p{Is_Block=cham}', "");
    Expect(1, 43616, '\p{^Is_Block=cham}', "");
    Expect(1, 43616, '\P{Is_Block=cham}', "");
    Expect(0, 43616, '\P{^Is_Block=cham}', "");
    Expect(1, 43615, '\p{Is_Block=CHAM}', "");
    Expect(0, 43615, '\p{^Is_Block=CHAM}', "");
    Expect(0, 43615, '\P{Is_Block=CHAM}', "");
    Expect(1, 43615, '\P{^Is_Block=CHAM}', "");
    Expect(0, 43616, '\p{Is_Block=CHAM}', "");
    Expect(1, 43616, '\p{^Is_Block=CHAM}', "");
    Expect(1, 43616, '\P{Is_Block=CHAM}', "");
    Expect(0, 43616, '\P{^Is_Block=CHAM}', "");
    Error('\p{Is_Blk= :=cham}');
    Error('\P{Is_Blk= :=cham}');
    Expect(1, 43615, '\p{Is_Blk=cham}', "");
    Expect(0, 43615, '\p{^Is_Blk=cham}', "");
    Expect(0, 43615, '\P{Is_Blk=cham}', "");
    Expect(1, 43615, '\P{^Is_Blk=cham}', "");
    Expect(0, 43616, '\p{Is_Blk=cham}', "");
    Expect(1, 43616, '\p{^Is_Blk=cham}', "");
    Expect(1, 43616, '\P{Is_Blk=cham}', "");
    Expect(0, 43616, '\P{^Is_Blk=cham}', "");
    Expect(1, 43615, '\p{Is_Blk: _CHAM}', "");
    Expect(0, 43615, '\p{^Is_Blk: _CHAM}', "");
    Expect(0, 43615, '\P{Is_Blk: _CHAM}', "");
    Expect(1, 43615, '\P{^Is_Blk: _CHAM}', "");
    Expect(0, 43616, '\p{Is_Blk: _CHAM}', "");
    Expect(1, 43616, '\p{^Is_Blk: _CHAM}', "");
    Expect(1, 43616, '\P{Is_Blk: _CHAM}', "");
    Expect(0, 43616, '\P{^Is_Blk: _CHAM}', "");
    Error('\p{Block: :=_-cherokee}');
    Error('\P{Block: :=_-cherokee}');
    Expect(1, 5119, '\p{Block=cherokee}', "");
    Expect(0, 5119, '\p{^Block=cherokee}', "");
    Expect(0, 5119, '\P{Block=cherokee}', "");
    Expect(1, 5119, '\P{^Block=cherokee}', "");
    Expect(0, 5120, '\p{Block=cherokee}', "");
    Expect(1, 5120, '\p{^Block=cherokee}', "");
    Expect(1, 5120, '\P{Block=cherokee}', "");
    Expect(0, 5120, '\P{^Block=cherokee}', "");
    Expect(1, 5119, '\p{Block=_-Cherokee}', "");
    Expect(0, 5119, '\p{^Block=_-Cherokee}', "");
    Expect(0, 5119, '\P{Block=_-Cherokee}', "");
    Expect(1, 5119, '\P{^Block=_-Cherokee}', "");
    Expect(0, 5120, '\p{Block=_-Cherokee}', "");
    Expect(1, 5120, '\p{^Block=_-Cherokee}', "");
    Expect(1, 5120, '\P{Block=_-Cherokee}', "");
    Expect(0, 5120, '\P{^Block=_-Cherokee}', "");
    Error('\p{Blk=/a/CHEROKEE}');
    Error('\P{Blk=/a/CHEROKEE}');
    Expect(1, 5119, '\p{Blk=cherokee}', "");
    Expect(0, 5119, '\p{^Blk=cherokee}', "");
    Expect(0, 5119, '\P{Blk=cherokee}', "");
    Expect(1, 5119, '\P{^Blk=cherokee}', "");
    Expect(0, 5120, '\p{Blk=cherokee}', "");
    Expect(1, 5120, '\p{^Blk=cherokee}', "");
    Expect(1, 5120, '\P{Blk=cherokee}', "");
    Expect(0, 5120, '\P{^Blk=cherokee}', "");
    Expect(1, 5119, '\p{Blk=_CHEROKEE}', "");
    Expect(0, 5119, '\p{^Blk=_CHEROKEE}', "");
    Expect(0, 5119, '\P{Blk=_CHEROKEE}', "");
    Expect(1, 5119, '\P{^Blk=_CHEROKEE}', "");
    Expect(0, 5120, '\p{Blk=_CHEROKEE}', "");
    Expect(1, 5120, '\p{^Blk=_CHEROKEE}', "");
    Expect(1, 5120, '\P{Blk=_CHEROKEE}', "");
    Expect(0, 5120, '\P{^Blk=_CHEROKEE}', "");
    Error('\p{Is_Block= cherokee:=}');
    Error('\P{Is_Block= cherokee:=}');
    Expect(1, 5119, '\p{Is_Block=cherokee}', "");
    Expect(0, 5119, '\p{^Is_Block=cherokee}', "");
    Expect(0, 5119, '\P{Is_Block=cherokee}', "");
    Expect(1, 5119, '\P{^Is_Block=cherokee}', "");
    Expect(0, 5120, '\p{Is_Block=cherokee}', "");
    Expect(1, 5120, '\p{^Is_Block=cherokee}', "");
    Expect(1, 5120, '\P{Is_Block=cherokee}', "");
    Expect(0, 5120, '\P{^Is_Block=cherokee}', "");
    Expect(1, 5119, '\p{Is_Block=_-cherokee}', "");
    Expect(0, 5119, '\p{^Is_Block=_-cherokee}', "");
    Expect(0, 5119, '\P{Is_Block=_-cherokee}', "");
    Expect(1, 5119, '\P{^Is_Block=_-cherokee}', "");
    Expect(0, 5120, '\p{Is_Block=_-cherokee}', "");
    Expect(1, 5120, '\p{^Is_Block=_-cherokee}', "");
    Expect(1, 5120, '\P{Is_Block=_-cherokee}', "");
    Expect(0, 5120, '\P{^Is_Block=_-cherokee}', "");
    Error('\p{Is_Blk=/a/ Cherokee}');
    Error('\P{Is_Blk=/a/ Cherokee}');
    Expect(1, 5119, '\p{Is_Blk=cherokee}', "");
    Expect(0, 5119, '\p{^Is_Blk=cherokee}', "");
    Expect(0, 5119, '\P{Is_Blk=cherokee}', "");
    Expect(1, 5119, '\P{^Is_Blk=cherokee}', "");
    Expect(0, 5120, '\p{Is_Blk=cherokee}', "");
    Expect(1, 5120, '\p{^Is_Blk=cherokee}', "");
    Expect(1, 5120, '\P{Is_Blk=cherokee}', "");
    Expect(0, 5120, '\P{^Is_Blk=cherokee}', "");
    Expect(1, 5119, '\p{Is_Blk= _CHEROKEE}', "");
    Expect(0, 5119, '\p{^Is_Blk= _CHEROKEE}', "");
    Expect(0, 5119, '\P{Is_Blk= _CHEROKEE}', "");
    Expect(1, 5119, '\P{^Is_Blk= _CHEROKEE}', "");
    Expect(0, 5120, '\p{Is_Blk= _CHEROKEE}', "");
    Expect(1, 5120, '\p{^Is_Blk= _CHEROKEE}', "");
    Expect(1, 5120, '\P{Is_Blk= _CHEROKEE}', "");
    Expect(0, 5120, '\P{^Is_Blk= _CHEROKEE}', "");
    Error('\p{Block=/a/  Cherokee_Supplement}');
    Error('\P{Block=/a/  Cherokee_Supplement}');
    Expect(1, 43967, '\p{Block: cherokeesupplement}', "");
    Expect(0, 43967, '\p{^Block: cherokeesupplement}', "");
    Expect(0, 43967, '\P{Block: cherokeesupplement}', "");
    Expect(1, 43967, '\P{^Block: cherokeesupplement}', "");
    Expect(0, 43968, '\p{Block: cherokeesupplement}', "");
    Expect(1, 43968, '\p{^Block: cherokeesupplement}', "");
    Expect(1, 43968, '\P{Block: cherokeesupplement}', "");
    Expect(0, 43968, '\P{^Block: cherokeesupplement}', "");
    Expect(1, 43967, '\p{Block=-CHEROKEE_SUPPLEMENT}', "");
    Expect(0, 43967, '\p{^Block=-CHEROKEE_SUPPLEMENT}', "");
    Expect(0, 43967, '\P{Block=-CHEROKEE_SUPPLEMENT}', "");
    Expect(1, 43967, '\P{^Block=-CHEROKEE_SUPPLEMENT}', "");
    Expect(0, 43968, '\p{Block=-CHEROKEE_SUPPLEMENT}', "");
    Expect(1, 43968, '\p{^Block=-CHEROKEE_SUPPLEMENT}', "");
    Expect(1, 43968, '\P{Block=-CHEROKEE_SUPPLEMENT}', "");
    Expect(0, 43968, '\P{^Block=-CHEROKEE_SUPPLEMENT}', "");
    Error('\p{Blk:	/a/_	cherokee_SUP}');
    Error('\P{Blk:	/a/_	cherokee_SUP}');
    Expect(1, 43967, '\p{Blk=cherokeesup}', "");
    Expect(0, 43967, '\p{^Blk=cherokeesup}', "");
    Expect(0, 43967, '\P{Blk=cherokeesup}', "");
    Expect(1, 43967, '\P{^Blk=cherokeesup}', "");
    Expect(0, 43968, '\p{Blk=cherokeesup}', "");
    Expect(1, 43968, '\p{^Blk=cherokeesup}', "");
    Expect(1, 43968, '\P{Blk=cherokeesup}', "");
    Expect(0, 43968, '\P{^Blk=cherokeesup}', "");
    Expect(1, 43967, '\p{Blk=_Cherokee_sup}', "");
    Expect(0, 43967, '\p{^Blk=_Cherokee_sup}', "");
    Expect(0, 43967, '\P{Blk=_Cherokee_sup}', "");
    Expect(1, 43967, '\P{^Blk=_Cherokee_sup}', "");
    Expect(0, 43968, '\p{Blk=_Cherokee_sup}', "");
    Expect(1, 43968, '\p{^Blk=_Cherokee_sup}', "");
    Expect(1, 43968, '\P{Blk=_Cherokee_sup}', "");
    Expect(0, 43968, '\P{^Blk=_Cherokee_sup}', "");
    Error('\p{Is_Block: Cherokee_supplement/a/}');
    Error('\P{Is_Block: Cherokee_supplement/a/}');
    Expect(1, 43967, '\p{Is_Block=cherokeesupplement}', "");
    Expect(0, 43967, '\p{^Is_Block=cherokeesupplement}', "");
    Expect(0, 43967, '\P{Is_Block=cherokeesupplement}', "");
    Expect(1, 43967, '\P{^Is_Block=cherokeesupplement}', "");
    Expect(0, 43968, '\p{Is_Block=cherokeesupplement}', "");
    Expect(1, 43968, '\p{^Is_Block=cherokeesupplement}', "");
    Expect(1, 43968, '\P{Is_Block=cherokeesupplement}', "");
    Expect(0, 43968, '\P{^Is_Block=cherokeesupplement}', "");
    Expect(1, 43967, '\p{Is_Block:   - Cherokee_Supplement}', "");
    Expect(0, 43967, '\p{^Is_Block:   - Cherokee_Supplement}', "");
    Expect(0, 43967, '\P{Is_Block:   - Cherokee_Supplement}', "");
    Expect(1, 43967, '\P{^Is_Block:   - Cherokee_Supplement}', "");
    Expect(0, 43968, '\p{Is_Block:   - Cherokee_Supplement}', "");
    Expect(1, 43968, '\p{^Is_Block:   - Cherokee_Supplement}', "");
    Expect(1, 43968, '\P{Is_Block:   - Cherokee_Supplement}', "");
    Expect(0, 43968, '\P{^Is_Block:   - Cherokee_Supplement}', "");
    Error('\p{Is_Blk=/a/-CHEROKEE_SUP}');
    Error('\P{Is_Blk=/a/-CHEROKEE_SUP}');
    Expect(1, 43967, '\p{Is_Blk=cherokeesup}', "");
    Expect(0, 43967, '\p{^Is_Blk=cherokeesup}', "");
    Expect(0, 43967, '\P{Is_Blk=cherokeesup}', "");
    Expect(1, 43967, '\P{^Is_Blk=cherokeesup}', "");
    Expect(0, 43968, '\p{Is_Blk=cherokeesup}', "");
    Expect(1, 43968, '\p{^Is_Blk=cherokeesup}', "");
    Expect(1, 43968, '\P{Is_Blk=cherokeesup}', "");
    Expect(0, 43968, '\P{^Is_Blk=cherokeesup}', "");
    Expect(1, 43967, '\p{Is_Blk= Cherokee_sup}', "");
    Expect(0, 43967, '\p{^Is_Blk= Cherokee_sup}', "");
    Expect(0, 43967, '\P{Is_Blk= Cherokee_sup}', "");
    Expect(1, 43967, '\P{^Is_Blk= Cherokee_sup}', "");
    Expect(0, 43968, '\p{Is_Blk= Cherokee_sup}', "");
    Expect(1, 43968, '\p{^Is_Blk= Cherokee_sup}', "");
    Expect(1, 43968, '\P{Is_Blk= Cherokee_sup}', "");
    Expect(0, 43968, '\P{^Is_Blk= Cherokee_sup}', "");
    Error('\p{Block=_	CJK_Unified_Ideographs/a/}');
    Error('\P{Block=_	CJK_Unified_Ideographs/a/}');
    Expect(1, 40959, '\p{Block=cjkunifiedideographs}', "");
    Expect(0, 40959, '\p{^Block=cjkunifiedideographs}', "");
    Expect(0, 40959, '\P{Block=cjkunifiedideographs}', "");
    Expect(1, 40959, '\P{^Block=cjkunifiedideographs}', "");
    Expect(0, 40960, '\p{Block=cjkunifiedideographs}', "");
    Expect(1, 40960, '\p{^Block=cjkunifiedideographs}', "");
    Expect(1, 40960, '\P{Block=cjkunifiedideographs}', "");
    Expect(0, 40960, '\P{^Block=cjkunifiedideographs}', "");
    Expect(1, 40959, '\p{Block=	 CJK_unified_ideographs}', "");
    Expect(0, 40959, '\p{^Block=	 CJK_unified_ideographs}', "");
    Expect(0, 40959, '\P{Block=	 CJK_unified_ideographs}', "");
    Expect(1, 40959, '\P{^Block=	 CJK_unified_ideographs}', "");
    Expect(0, 40960, '\p{Block=	 CJK_unified_ideographs}', "");
    Expect(1, 40960, '\p{^Block=	 CJK_unified_ideographs}', "");
    Expect(1, 40960, '\P{Block=	 CJK_unified_ideographs}', "");
    Expect(0, 40960, '\P{^Block=	 CJK_unified_ideographs}', "");
    Error('\p{Blk=:=	 cjk}');
    Error('\P{Blk=:=	 cjk}');
    Expect(1, 40959, '\p{Blk=cjk}', "");
    Expect(0, 40959, '\p{^Blk=cjk}', "");
    Expect(0, 40959, '\P{Blk=cjk}', "");
    Expect(1, 40959, '\P{^Blk=cjk}', "");
    Expect(0, 40960, '\p{Blk=cjk}', "");
    Expect(1, 40960, '\p{^Blk=cjk}', "");
    Expect(1, 40960, '\P{Blk=cjk}', "");
    Expect(0, 40960, '\P{^Blk=cjk}', "");
    Expect(1, 40959, '\p{Blk=-_CJK}', "");
    Expect(0, 40959, '\p{^Blk=-_CJK}', "");
    Expect(0, 40959, '\P{Blk=-_CJK}', "");
    Expect(1, 40959, '\P{^Blk=-_CJK}', "");
    Expect(0, 40960, '\p{Blk=-_CJK}', "");
    Expect(1, 40960, '\p{^Blk=-_CJK}', "");
    Expect(1, 40960, '\P{Blk=-_CJK}', "");
    Expect(0, 40960, '\P{^Blk=-_CJK}', "");
    Error('\p{Is_Block=	-CJK_Unified_Ideographs/a/}');
    Error('\P{Is_Block=	-CJK_Unified_Ideographs/a/}');
    Expect(1, 40959, '\p{Is_Block=cjkunifiedideographs}', "");
    Expect(0, 40959, '\p{^Is_Block=cjkunifiedideographs}', "");
    Expect(0, 40959, '\P{Is_Block=cjkunifiedideographs}', "");
    Expect(1, 40959, '\P{^Is_Block=cjkunifiedideographs}', "");
    Expect(0, 40960, '\p{Is_Block=cjkunifiedideographs}', "");
    Expect(1, 40960, '\p{^Is_Block=cjkunifiedideographs}', "");
    Expect(1, 40960, '\P{Is_Block=cjkunifiedideographs}', "");
    Expect(0, 40960, '\P{^Is_Block=cjkunifiedideographs}', "");
    Expect(1, 40959, '\p{Is_Block=_CJK_Unified_Ideographs}', "");
    Expect(0, 40959, '\p{^Is_Block=_CJK_Unified_Ideographs}', "");
    Expect(0, 40959, '\P{Is_Block=_CJK_Unified_Ideographs}', "");
    Expect(1, 40959, '\P{^Is_Block=_CJK_Unified_Ideographs}', "");
    Expect(0, 40960, '\p{Is_Block=_CJK_Unified_Ideographs}', "");
    Expect(1, 40960, '\p{^Is_Block=_CJK_Unified_Ideographs}', "");
    Expect(1, 40960, '\P{Is_Block=_CJK_Unified_Ideographs}', "");
    Expect(0, 40960, '\P{^Is_Block=_CJK_Unified_Ideographs}', "");
    Error('\p{Is_Blk=/a/-CJK}');
    Error('\P{Is_Blk=/a/-CJK}');
    Expect(1, 40959, '\p{Is_Blk=cjk}', "");
    Expect(0, 40959, '\p{^Is_Blk=cjk}', "");
    Expect(0, 40959, '\P{Is_Blk=cjk}', "");
    Expect(1, 40959, '\P{^Is_Blk=cjk}', "");
    Expect(0, 40960, '\p{Is_Blk=cjk}', "");
    Expect(1, 40960, '\p{^Is_Blk=cjk}', "");
    Expect(1, 40960, '\P{Is_Blk=cjk}', "");
    Expect(0, 40960, '\P{^Is_Blk=cjk}', "");
    Expect(1, 40959, '\p{Is_Blk=-	CJK}', "");
    Expect(0, 40959, '\p{^Is_Blk=-	CJK}', "");
    Expect(0, 40959, '\P{Is_Blk=-	CJK}', "");
    Expect(1, 40959, '\P{^Is_Blk=-	CJK}', "");
    Expect(0, 40960, '\p{Is_Blk=-	CJK}', "");
    Expect(1, 40960, '\p{^Is_Blk=-	CJK}', "");
    Expect(1, 40960, '\P{Is_Blk=-	CJK}', "");
    Expect(0, 40960, '\P{^Is_Blk=-	CJK}', "");
    Error('\p{Block=/a/_ cjk_Compatibility}');
    Error('\P{Block=/a/_ cjk_Compatibility}');
    Expect(1, 13311, '\p{Block=cjkcompatibility}', "");
    Expect(0, 13311, '\p{^Block=cjkcompatibility}', "");
    Expect(0, 13311, '\P{Block=cjkcompatibility}', "");
    Expect(1, 13311, '\P{^Block=cjkcompatibility}', "");
    Expect(0, 13312, '\p{Block=cjkcompatibility}', "");
    Expect(1, 13312, '\p{^Block=cjkcompatibility}', "");
    Expect(1, 13312, '\P{Block=cjkcompatibility}', "");
    Expect(0, 13312, '\P{^Block=cjkcompatibility}', "");
    Expect(1, 13311, '\p{Block=- cjk_Compatibility}', "");
    Expect(0, 13311, '\p{^Block=- cjk_Compatibility}', "");
    Expect(0, 13311, '\P{Block=- cjk_Compatibility}', "");
    Expect(1, 13311, '\P{^Block=- cjk_Compatibility}', "");
    Expect(0, 13312, '\p{Block=- cjk_Compatibility}', "");
    Expect(1, 13312, '\p{^Block=- cjk_Compatibility}', "");
    Expect(1, 13312, '\P{Block=- cjk_Compatibility}', "");
    Expect(0, 13312, '\P{^Block=- cjk_Compatibility}', "");
    Error('\p{Blk=  cjk_COMPAT:=}');
    Error('\P{Blk=  cjk_COMPAT:=}');
    Expect(1, 13311, '\p{Blk=cjkcompat}', "");
    Expect(0, 13311, '\p{^Blk=cjkcompat}', "");
    Expect(0, 13311, '\P{Blk=cjkcompat}', "");
    Expect(1, 13311, '\P{^Blk=cjkcompat}', "");
    Expect(0, 13312, '\p{Blk=cjkcompat}', "");
    Expect(1, 13312, '\p{^Blk=cjkcompat}', "");
    Expect(1, 13312, '\P{Blk=cjkcompat}', "");
    Expect(0, 13312, '\P{^Blk=cjkcompat}', "");
    Expect(1, 13311, '\p{Blk=_CJK_Compat}', "");
    Expect(0, 13311, '\p{^Blk=_CJK_Compat}', "");
    Expect(0, 13311, '\P{Blk=_CJK_Compat}', "");
    Expect(1, 13311, '\P{^Blk=_CJK_Compat}', "");
    Expect(0, 13312, '\p{Blk=_CJK_Compat}', "");
    Expect(1, 13312, '\p{^Blk=_CJK_Compat}', "");
    Expect(1, 13312, '\P{Blk=_CJK_Compat}', "");
    Expect(0, 13312, '\P{^Blk=_CJK_Compat}', "");
    Error('\p{Is_Block=/a/  cjk_Compatibility}');
    Error('\P{Is_Block=/a/  cjk_Compatibility}');
    Expect(1, 13311, '\p{Is_Block=cjkcompatibility}', "");
    Expect(0, 13311, '\p{^Is_Block=cjkcompatibility}', "");
    Expect(0, 13311, '\P{Is_Block=cjkcompatibility}', "");
    Expect(1, 13311, '\P{^Is_Block=cjkcompatibility}', "");
    Expect(0, 13312, '\p{Is_Block=cjkcompatibility}', "");
    Expect(1, 13312, '\p{^Is_Block=cjkcompatibility}', "");
    Expect(1, 13312, '\P{Is_Block=cjkcompatibility}', "");
    Expect(0, 13312, '\P{^Is_Block=cjkcompatibility}', "");
    Expect(1, 13311, '\p{Is_Block=_CJK_COMPATIBILITY}', "");
    Expect(0, 13311, '\p{^Is_Block=_CJK_COMPATIBILITY}', "");
    Expect(0, 13311, '\P{Is_Block=_CJK_COMPATIBILITY}', "");
    Expect(1, 13311, '\P{^Is_Block=_CJK_COMPATIBILITY}', "");
    Expect(0, 13312, '\p{Is_Block=_CJK_COMPATIBILITY}', "");
    Expect(1, 13312, '\p{^Is_Block=_CJK_COMPATIBILITY}', "");
    Expect(1, 13312, '\P{Is_Block=_CJK_COMPATIBILITY}', "");
    Expect(0, 13312, '\P{^Is_Block=_CJK_COMPATIBILITY}', "");
    Error('\p{Is_Blk=/a/ 	CJK_COMPAT}');
    Error('\P{Is_Blk=/a/ 	CJK_COMPAT}');
    Expect(1, 13311, '\p{Is_Blk=cjkcompat}', "");
    Expect(0, 13311, '\p{^Is_Blk=cjkcompat}', "");
    Expect(0, 13311, '\P{Is_Blk=cjkcompat}', "");
    Expect(1, 13311, '\P{^Is_Blk=cjkcompat}', "");
    Expect(0, 13312, '\p{Is_Blk=cjkcompat}', "");
    Expect(1, 13312, '\p{^Is_Blk=cjkcompat}', "");
    Expect(1, 13312, '\P{Is_Blk=cjkcompat}', "");
    Expect(0, 13312, '\P{^Is_Blk=cjkcompat}', "");
    Expect(1, 13311, '\p{Is_Blk= _cjk_compat}', "");
    Expect(0, 13311, '\p{^Is_Blk= _cjk_compat}', "");
    Expect(0, 13311, '\P{Is_Blk= _cjk_compat}', "");
    Expect(1, 13311, '\P{^Is_Blk= _cjk_compat}', "");
    Expect(0, 13312, '\p{Is_Blk= _cjk_compat}', "");
    Expect(1, 13312, '\p{^Is_Blk= _cjk_compat}', "");
    Expect(1, 13312, '\P{Is_Blk= _cjk_compat}', "");
    Expect(0, 13312, '\P{^Is_Blk= _cjk_compat}', "");
    Error('\p{Block=_:=CJK_Compatibility_FORMS}');
    Error('\P{Block=_:=CJK_Compatibility_FORMS}');
    Expect(1, 65103, '\p{Block=cjkcompatibilityforms}', "");
    Expect(0, 65103, '\p{^Block=cjkcompatibilityforms}', "");
    Expect(0, 65103, '\P{Block=cjkcompatibilityforms}', "");
    Expect(1, 65103, '\P{^Block=cjkcompatibilityforms}', "");
    Expect(0, 65104, '\p{Block=cjkcompatibilityforms}', "");
    Expect(1, 65104, '\p{^Block=cjkcompatibilityforms}', "");
    Expect(1, 65104, '\P{Block=cjkcompatibilityforms}', "");
    Expect(0, 65104, '\P{^Block=cjkcompatibilityforms}', "");
    Expect(1, 65103, '\p{Block:   _-CJK_COMPATIBILITY_Forms}', "");
    Expect(0, 65103, '\p{^Block:   _-CJK_COMPATIBILITY_Forms}', "");
    Expect(0, 65103, '\P{Block:   _-CJK_COMPATIBILITY_Forms}', "");
    Expect(1, 65103, '\P{^Block:   _-CJK_COMPATIBILITY_Forms}', "");
    Expect(0, 65104, '\p{Block:   _-CJK_COMPATIBILITY_Forms}', "");
    Expect(1, 65104, '\p{^Block:   _-CJK_COMPATIBILITY_Forms}', "");
    Expect(1, 65104, '\P{Block:   _-CJK_COMPATIBILITY_Forms}', "");
    Expect(0, 65104, '\P{^Block:   _-CJK_COMPATIBILITY_Forms}', "");
    Error('\p{Blk=	:=CJK_Compat_FORMS}');
    Error('\P{Blk=	:=CJK_Compat_FORMS}');
    Expect(1, 65103, '\p{Blk=cjkcompatforms}', "");
    Expect(0, 65103, '\p{^Blk=cjkcompatforms}', "");
    Expect(0, 65103, '\P{Blk=cjkcompatforms}', "");
    Expect(1, 65103, '\P{^Blk=cjkcompatforms}', "");
    Expect(0, 65104, '\p{Blk=cjkcompatforms}', "");
    Expect(1, 65104, '\p{^Blk=cjkcompatforms}', "");
    Expect(1, 65104, '\P{Blk=cjkcompatforms}', "");
    Expect(0, 65104, '\P{^Blk=cjkcompatforms}', "");
    Expect(1, 65103, '\p{Blk=		cjk_Compat_Forms}', "");
    Expect(0, 65103, '\p{^Blk=		cjk_Compat_Forms}', "");
    Expect(0, 65103, '\P{Blk=		cjk_Compat_Forms}', "");
    Expect(1, 65103, '\P{^Blk=		cjk_Compat_Forms}', "");
    Expect(0, 65104, '\p{Blk=		cjk_Compat_Forms}', "");
    Expect(1, 65104, '\p{^Blk=		cjk_Compat_Forms}', "");
    Expect(1, 65104, '\P{Blk=		cjk_Compat_Forms}', "");
    Expect(0, 65104, '\P{^Blk=		cjk_Compat_Forms}', "");
    Error('\p{Is_Block=-:=CJK_Compatibility_Forms}');
    Error('\P{Is_Block=-:=CJK_Compatibility_Forms}');
    Expect(1, 65103, '\p{Is_Block=cjkcompatibilityforms}', "");
    Expect(0, 65103, '\p{^Is_Block=cjkcompatibilityforms}', "");
    Expect(0, 65103, '\P{Is_Block=cjkcompatibilityforms}', "");
    Expect(1, 65103, '\P{^Is_Block=cjkcompatibilityforms}', "");
    Expect(0, 65104, '\p{Is_Block=cjkcompatibilityforms}', "");
    Expect(1, 65104, '\p{^Is_Block=cjkcompatibilityforms}', "");
    Expect(1, 65104, '\P{Is_Block=cjkcompatibilityforms}', "");
    Expect(0, 65104, '\P{^Is_Block=cjkcompatibilityforms}', "");
    Expect(1, 65103, '\p{Is_Block= CJK_compatibility_Forms}', "");
    Expect(0, 65103, '\p{^Is_Block= CJK_compatibility_Forms}', "");
    Expect(0, 65103, '\P{Is_Block= CJK_compatibility_Forms}', "");
    Expect(1, 65103, '\P{^Is_Block= CJK_compatibility_Forms}', "");
    Expect(0, 65104, '\p{Is_Block= CJK_compatibility_Forms}', "");
    Expect(1, 65104, '\p{^Is_Block= CJK_compatibility_Forms}', "");
    Expect(1, 65104, '\P{Is_Block= CJK_compatibility_Forms}', "");
    Expect(0, 65104, '\P{^Is_Block= CJK_compatibility_Forms}', "");
    Error('\p{Is_Blk=/a/- CJK_Compat_Forms}');
    Error('\P{Is_Blk=/a/- CJK_Compat_Forms}');
    Expect(1, 65103, '\p{Is_Blk=cjkcompatforms}', "");
    Expect(0, 65103, '\p{^Is_Blk=cjkcompatforms}', "");
    Expect(0, 65103, '\P{Is_Blk=cjkcompatforms}', "");
    Expect(1, 65103, '\P{^Is_Blk=cjkcompatforms}', "");
    Expect(0, 65104, '\p{Is_Blk=cjkcompatforms}', "");
    Expect(1, 65104, '\p{^Is_Blk=cjkcompatforms}', "");
    Expect(1, 65104, '\P{Is_Blk=cjkcompatforms}', "");
    Expect(0, 65104, '\P{^Is_Blk=cjkcompatforms}', "");
    Expect(1, 65103, '\p{Is_Blk= CJK_Compat_forms}', "");
    Expect(0, 65103, '\p{^Is_Blk= CJK_Compat_forms}', "");
    Expect(0, 65103, '\P{Is_Blk= CJK_Compat_forms}', "");
    Expect(1, 65103, '\P{^Is_Blk= CJK_Compat_forms}', "");
    Expect(0, 65104, '\p{Is_Blk= CJK_Compat_forms}', "");
    Expect(1, 65104, '\p{^Is_Blk= CJK_Compat_forms}', "");
    Expect(1, 65104, '\P{Is_Blk= CJK_Compat_forms}', "");
    Expect(0, 65104, '\P{^Is_Blk= CJK_Compat_forms}', "");
    Error('\p{Block=:=-	cjk_compatibility_IDEOGRAPHS}');
    Error('\P{Block=:=-	cjk_compatibility_IDEOGRAPHS}');
    Expect(1, 64255, '\p{Block=cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\p{^Block=cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\P{Block=cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\P{^Block=cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\p{Block=cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\p{^Block=cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\P{Block=cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\P{^Block=cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\p{Block=-cjk_Compatibility_Ideographs}', "");
    Expect(0, 64255, '\p{^Block=-cjk_Compatibility_Ideographs}', "");
    Expect(0, 64255, '\P{Block=-cjk_Compatibility_Ideographs}', "");
    Expect(1, 64255, '\P{^Block=-cjk_Compatibility_Ideographs}', "");
    Expect(0, 64256, '\p{Block=-cjk_Compatibility_Ideographs}', "");
    Expect(1, 64256, '\p{^Block=-cjk_Compatibility_Ideographs}', "");
    Expect(1, 64256, '\P{Block=-cjk_Compatibility_Ideographs}', "");
    Expect(0, 64256, '\P{^Block=-cjk_Compatibility_Ideographs}', "");
    Error('\p{Blk=/a/CJK_compat_IDEOGRAPHS}');
    Error('\P{Blk=/a/CJK_compat_IDEOGRAPHS}');
    Expect(1, 64255, '\p{Blk=cjkcompatideographs}', "");
    Expect(0, 64255, '\p{^Blk=cjkcompatideographs}', "");
    Expect(0, 64255, '\P{Blk=cjkcompatideographs}', "");
    Expect(1, 64255, '\P{^Blk=cjkcompatideographs}', "");
    Expect(0, 64256, '\p{Blk=cjkcompatideographs}', "");
    Expect(1, 64256, '\p{^Blk=cjkcompatideographs}', "");
    Expect(1, 64256, '\P{Blk=cjkcompatideographs}', "");
    Expect(0, 64256, '\P{^Blk=cjkcompatideographs}', "");
    Expect(1, 64255, '\p{Blk=		CJK_Compat_Ideographs}', "");
    Expect(0, 64255, '\p{^Blk=		CJK_Compat_Ideographs}', "");
    Expect(0, 64255, '\P{Blk=		CJK_Compat_Ideographs}', "");
    Expect(1, 64255, '\P{^Blk=		CJK_Compat_Ideographs}', "");
    Expect(0, 64256, '\p{Blk=		CJK_Compat_Ideographs}', "");
    Expect(1, 64256, '\p{^Blk=		CJK_Compat_Ideographs}', "");
    Expect(1, 64256, '\P{Blk=		CJK_Compat_Ideographs}', "");
    Expect(0, 64256, '\P{^Blk=		CJK_Compat_Ideographs}', "");
    Error('\p{Is_Block=_	CJK_compatibility_Ideographs:=}');
    Error('\P{Is_Block=_	CJK_compatibility_Ideographs:=}');
    Expect(1, 64255, '\p{Is_Block=cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\p{^Is_Block=cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\P{Is_Block=cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\P{^Is_Block=cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\p{Is_Block=cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\p{^Is_Block=cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\P{Is_Block=cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\P{^Is_Block=cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\p{Is_Block=CJK_compatibility_IDEOGRAPHS}', "");
    Expect(0, 64255, '\p{^Is_Block=CJK_compatibility_IDEOGRAPHS}', "");
    Expect(0, 64255, '\P{Is_Block=CJK_compatibility_IDEOGRAPHS}', "");
    Expect(1, 64255, '\P{^Is_Block=CJK_compatibility_IDEOGRAPHS}', "");
    Expect(0, 64256, '\p{Is_Block=CJK_compatibility_IDEOGRAPHS}', "");
    Expect(1, 64256, '\p{^Is_Block=CJK_compatibility_IDEOGRAPHS}', "");
    Expect(1, 64256, '\P{Is_Block=CJK_compatibility_IDEOGRAPHS}', "");
    Expect(0, 64256, '\P{^Is_Block=CJK_compatibility_IDEOGRAPHS}', "");
    Error('\p{Is_Blk=- CJK_COMPAT_Ideographs:=}');
    Error('\P{Is_Blk=- CJK_COMPAT_Ideographs:=}');
    Expect(1, 64255, '\p{Is_Blk:	cjkcompatideographs}', "");
    Expect(0, 64255, '\p{^Is_Blk:	cjkcompatideographs}', "");
    Expect(0, 64255, '\P{Is_Blk:	cjkcompatideographs}', "");
    Expect(1, 64255, '\P{^Is_Blk:	cjkcompatideographs}', "");
    Expect(0, 64256, '\p{Is_Blk:	cjkcompatideographs}', "");
    Expect(1, 64256, '\p{^Is_Blk:	cjkcompatideographs}', "");
    Expect(1, 64256, '\P{Is_Blk:	cjkcompatideographs}', "");
    Expect(0, 64256, '\P{^Is_Blk:	cjkcompatideographs}', "");
    Expect(1, 64255, '\p{Is_Blk=CJK_Compat_ideographs}', "");
    Expect(0, 64255, '\p{^Is_Blk=CJK_Compat_ideographs}', "");
    Expect(0, 64255, '\P{Is_Blk=CJK_Compat_ideographs}', "");
    Expect(1, 64255, '\P{^Is_Blk=CJK_Compat_ideographs}', "");
    Expect(0, 64256, '\p{Is_Blk=CJK_Compat_ideographs}', "");
    Expect(1, 64256, '\p{^Is_Blk=CJK_Compat_ideographs}', "");
    Expect(1, 64256, '\P{Is_Blk=CJK_Compat_ideographs}', "");
    Expect(0, 64256, '\P{^Is_Blk=CJK_Compat_ideographs}', "");
    Error('\p{Block=/a/-CJK_compatibility_IDEOGRAPHS_Supplement}');
    Error('\P{Block=/a/-CJK_compatibility_IDEOGRAPHS_Supplement}');
    Expect(1, 195103, '\p{Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\p{^Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\P{Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\P{^Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\p{Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\p{^Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\P{Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\P{^Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\p{Block=-cjk_COMPATIBILITY_IDEOGRAPHS_SUPPLEMENT}', "");
    Expect(0, 195103, '\p{^Block=-cjk_COMPATIBILITY_IDEOGRAPHS_SUPPLEMENT}', "");
    Expect(0, 195103, '\P{Block=-cjk_COMPATIBILITY_IDEOGRAPHS_SUPPLEMENT}', "");
    Expect(1, 195103, '\P{^Block=-cjk_COMPATIBILITY_IDEOGRAPHS_SUPPLEMENT}', "");
    Expect(0, 195104, '\p{Block=-cjk_COMPATIBILITY_IDEOGRAPHS_SUPPLEMENT}', "");
    Expect(1, 195104, '\p{^Block=-cjk_COMPATIBILITY_IDEOGRAPHS_SUPPLEMENT}', "");
    Expect(1, 195104, '\P{Block=-cjk_COMPATIBILITY_IDEOGRAPHS_SUPPLEMENT}', "");
    Expect(0, 195104, '\P{^Block=-cjk_COMPATIBILITY_IDEOGRAPHS_SUPPLEMENT}', "");
    Error('\p{Blk=/a/ CJK_COMPAT_Ideographs_SUP}');
    Error('\P{Blk=/a/ CJK_COMPAT_Ideographs_SUP}');
    Expect(1, 195103, '\p{Blk=cjkcompatideographssup}', "");
    Expect(0, 195103, '\p{^Blk=cjkcompatideographssup}', "");
    Expect(0, 195103, '\P{Blk=cjkcompatideographssup}', "");
    Expect(1, 195103, '\P{^Blk=cjkcompatideographssup}', "");
    Expect(0, 195104, '\p{Blk=cjkcompatideographssup}', "");
    Expect(1, 195104, '\p{^Blk=cjkcompatideographssup}', "");
    Expect(1, 195104, '\P{Blk=cjkcompatideographssup}', "");
    Expect(0, 195104, '\P{^Blk=cjkcompatideographssup}', "");
    Expect(1, 195103, '\p{Blk= -CJK_Compat_IDEOGRAPHS_Sup}', "");
    Expect(0, 195103, '\p{^Blk= -CJK_Compat_IDEOGRAPHS_Sup}', "");
    Expect(0, 195103, '\P{Blk= -CJK_Compat_IDEOGRAPHS_Sup}', "");
    Expect(1, 195103, '\P{^Blk= -CJK_Compat_IDEOGRAPHS_Sup}', "");
    Expect(0, 195104, '\p{Blk= -CJK_Compat_IDEOGRAPHS_Sup}', "");
    Expect(1, 195104, '\p{^Blk= -CJK_Compat_IDEOGRAPHS_Sup}', "");
    Expect(1, 195104, '\P{Blk= -CJK_Compat_IDEOGRAPHS_Sup}', "");
    Expect(0, 195104, '\P{^Blk= -CJK_Compat_IDEOGRAPHS_Sup}', "");
    Error('\p{Is_Block:	:= _cjk_Compatibility_IDEOGRAPHS_Supplement}');
    Error('\P{Is_Block:	:= _cjk_Compatibility_IDEOGRAPHS_Supplement}');
    Expect(1, 195103, '\p{Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\p{^Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\P{Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\P{^Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\p{Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\p{^Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\P{Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\P{^Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\p{Is_Block= _CJK_Compatibility_Ideographs_Supplement}', "");
    Expect(0, 195103, '\p{^Is_Block= _CJK_Compatibility_Ideographs_Supplement}', "");
    Expect(0, 195103, '\P{Is_Block= _CJK_Compatibility_Ideographs_Supplement}', "");
    Expect(1, 195103, '\P{^Is_Block= _CJK_Compatibility_Ideographs_Supplement}', "");
    Expect(0, 195104, '\p{Is_Block= _CJK_Compatibility_Ideographs_Supplement}', "");
    Expect(1, 195104, '\p{^Is_Block= _CJK_Compatibility_Ideographs_Supplement}', "");
    Expect(1, 195104, '\P{Is_Block= _CJK_Compatibility_Ideographs_Supplement}', "");
    Expect(0, 195104, '\P{^Is_Block= _CJK_Compatibility_Ideographs_Supplement}', "");
    Error('\p{Is_Blk=/a/--CJK_Compat_IDEOGRAPHS_SUP}');
    Error('\P{Is_Blk=/a/--CJK_Compat_IDEOGRAPHS_SUP}');
    Expect(1, 195103, '\p{Is_Blk=cjkcompatideographssup}', "");
    Expect(0, 195103, '\p{^Is_Blk=cjkcompatideographssup}', "");
    Expect(0, 195103, '\P{Is_Blk=cjkcompatideographssup}', "");
    Expect(1, 195103, '\P{^Is_Blk=cjkcompatideographssup}', "");
    Expect(0, 195104, '\p{Is_Blk=cjkcompatideographssup}', "");
    Expect(1, 195104, '\p{^Is_Blk=cjkcompatideographssup}', "");
    Expect(1, 195104, '\P{Is_Blk=cjkcompatideographssup}', "");
    Expect(0, 195104, '\P{^Is_Blk=cjkcompatideographssup}', "");
    Expect(1, 195103, '\p{Is_Blk: --cjk_compat_Ideographs_Sup}', "");
    Expect(0, 195103, '\p{^Is_Blk: --cjk_compat_Ideographs_Sup}', "");
    Expect(0, 195103, '\P{Is_Blk: --cjk_compat_Ideographs_Sup}', "");
    Expect(1, 195103, '\P{^Is_Blk: --cjk_compat_Ideographs_Sup}', "");
    Expect(0, 195104, '\p{Is_Blk: --cjk_compat_Ideographs_Sup}', "");
    Expect(1, 195104, '\p{^Is_Blk: --cjk_compat_Ideographs_Sup}', "");
    Expect(1, 195104, '\P{Is_Blk: --cjk_compat_Ideographs_Sup}', "");
    Expect(0, 195104, '\P{^Is_Blk: --cjk_compat_Ideographs_Sup}', "");
    Error('\p{Block=:=CJK_unified_Ideographs_Extension_A}');
    Error('\P{Block=:=CJK_unified_Ideographs_Extension_A}');
    Expect(1, 19903, '\p{Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\p{^Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\P{Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\P{^Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\p{Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\p{^Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\P{Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\P{^Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\p{Block=_	CJK_Unified_Ideographs_EXTENSION_A}', "");
    Expect(0, 19903, '\p{^Block=_	CJK_Unified_Ideographs_EXTENSION_A}', "");
    Expect(0, 19903, '\P{Block=_	CJK_Unified_Ideographs_EXTENSION_A}', "");
    Expect(1, 19903, '\P{^Block=_	CJK_Unified_Ideographs_EXTENSION_A}', "");
    Expect(0, 19904, '\p{Block=_	CJK_Unified_Ideographs_EXTENSION_A}', "");
    Expect(1, 19904, '\p{^Block=_	CJK_Unified_Ideographs_EXTENSION_A}', "");
    Expect(1, 19904, '\P{Block=_	CJK_Unified_Ideographs_EXTENSION_A}', "");
    Expect(0, 19904, '\P{^Block=_	CJK_Unified_Ideographs_EXTENSION_A}', "");
    Error('\p{Blk=-/a/CJK_EXT_A}');
    Error('\P{Blk=-/a/CJK_EXT_A}');
    Expect(1, 19903, '\p{Blk=cjkexta}', "");
    Expect(0, 19903, '\p{^Blk=cjkexta}', "");
    Expect(0, 19903, '\P{Blk=cjkexta}', "");
    Expect(1, 19903, '\P{^Blk=cjkexta}', "");
    Expect(0, 19904, '\p{Blk=cjkexta}', "");
    Expect(1, 19904, '\p{^Blk=cjkexta}', "");
    Expect(1, 19904, '\P{Blk=cjkexta}', "");
    Expect(0, 19904, '\P{^Blk=cjkexta}', "");
    Expect(1, 19903, '\p{Blk= _CJK_Ext_a}', "");
    Expect(0, 19903, '\p{^Blk= _CJK_Ext_a}', "");
    Expect(0, 19903, '\P{Blk= _CJK_Ext_a}', "");
    Expect(1, 19903, '\P{^Blk= _CJK_Ext_a}', "");
    Expect(0, 19904, '\p{Blk= _CJK_Ext_a}', "");
    Expect(1, 19904, '\p{^Blk= _CJK_Ext_a}', "");
    Expect(1, 19904, '\P{Blk= _CJK_Ext_a}', "");
    Expect(0, 19904, '\P{^Blk= _CJK_Ext_a}', "");
    Error('\p{Is_Block=-	CJK_Unified_Ideographs_EXTENSION_a/a/}');
    Error('\P{Is_Block=-	CJK_Unified_Ideographs_EXTENSION_a/a/}');
    Expect(1, 19903, '\p{Is_Block:	cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\p{^Is_Block:	cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\P{Is_Block:	cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\P{^Is_Block:	cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\p{Is_Block:	cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\p{^Is_Block:	cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\P{Is_Block:	cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\P{^Is_Block:	cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\p{Is_Block=	 CJK_unified_Ideographs_EXTENSION_a}', "");
    Expect(0, 19903, '\p{^Is_Block=	 CJK_unified_Ideographs_EXTENSION_a}', "");
    Expect(0, 19903, '\P{Is_Block=	 CJK_unified_Ideographs_EXTENSION_a}', "");
    Expect(1, 19903, '\P{^Is_Block=	 CJK_unified_Ideographs_EXTENSION_a}', "");
    Expect(0, 19904, '\p{Is_Block=	 CJK_unified_Ideographs_EXTENSION_a}', "");
    Expect(1, 19904, '\p{^Is_Block=	 CJK_unified_Ideographs_EXTENSION_a}', "");
    Expect(1, 19904, '\P{Is_Block=	 CJK_unified_Ideographs_EXTENSION_a}', "");
    Expect(0, 19904, '\P{^Is_Block=	 CJK_unified_Ideographs_EXTENSION_a}', "");
    Error('\p{Is_Blk:	 /a/CJK_EXT_a}');
    Error('\P{Is_Blk:	 /a/CJK_EXT_a}');
    Expect(1, 19903, '\p{Is_Blk=cjkexta}', "");
    Expect(0, 19903, '\p{^Is_Blk=cjkexta}', "");
    Expect(0, 19903, '\P{Is_Blk=cjkexta}', "");
    Expect(1, 19903, '\P{^Is_Blk=cjkexta}', "");
    Expect(0, 19904, '\p{Is_Blk=cjkexta}', "");
    Expect(1, 19904, '\p{^Is_Blk=cjkexta}', "");
    Expect(1, 19904, '\P{Is_Blk=cjkexta}', "");
    Expect(0, 19904, '\P{^Is_Blk=cjkexta}', "");
    Expect(1, 19903, '\p{Is_Blk=_	CJK_EXT_A}', "");
    Expect(0, 19903, '\p{^Is_Blk=_	CJK_EXT_A}', "");
    Expect(0, 19903, '\P{Is_Blk=_	CJK_EXT_A}', "");
    Expect(1, 19903, '\P{^Is_Blk=_	CJK_EXT_A}', "");
    Expect(0, 19904, '\p{Is_Blk=_	CJK_EXT_A}', "");
    Expect(1, 19904, '\p{^Is_Blk=_	CJK_EXT_A}', "");
    Expect(1, 19904, '\P{Is_Blk=_	CJK_EXT_A}', "");
    Expect(0, 19904, '\P{^Is_Blk=_	CJK_EXT_A}', "");
    Error('\p{Block=:=-_CJK_Unified_ideographs_Extension_b}');
    Error('\P{Block=:=-_CJK_Unified_ideographs_Extension_b}');
    Expect(1, 173791, '\p{Block=cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\p{^Block=cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\P{Block=cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\P{^Block=cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\p{Block=cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\p{^Block=cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\P{Block=cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\P{^Block=cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\p{Block=-	CJK_Unified_Ideographs_EXTENSION_b}', "");
    Expect(0, 173791, '\p{^Block=-	CJK_Unified_Ideographs_EXTENSION_b}', "");
    Expect(0, 173791, '\P{Block=-	CJK_Unified_Ideographs_EXTENSION_b}', "");
    Expect(1, 173791, '\P{^Block=-	CJK_Unified_Ideographs_EXTENSION_b}', "");
    Expect(0, 173792, '\p{Block=-	CJK_Unified_Ideographs_EXTENSION_b}', "");
    Expect(1, 173792, '\p{^Block=-	CJK_Unified_Ideographs_EXTENSION_b}', "");
    Expect(1, 173792, '\P{Block=-	CJK_Unified_Ideographs_EXTENSION_b}', "");
    Expect(0, 173792, '\P{^Block=-	CJK_Unified_Ideographs_EXTENSION_b}', "");
    Error('\p{Blk: -:=cjk_Ext_B}');
    Error('\P{Blk: -:=cjk_Ext_B}');
    Expect(1, 173791, '\p{Blk=cjkextb}', "");
    Expect(0, 173791, '\p{^Blk=cjkextb}', "");
    Expect(0, 173791, '\P{Blk=cjkextb}', "");
    Expect(1, 173791, '\P{^Blk=cjkextb}', "");
    Expect(0, 173792, '\p{Blk=cjkextb}', "");
    Expect(1, 173792, '\p{^Blk=cjkextb}', "");
    Expect(1, 173792, '\P{Blk=cjkextb}', "");
    Expect(0, 173792, '\P{^Blk=cjkextb}', "");
    Expect(1, 173791, '\p{Blk=_	CJK_Ext_B}', "");
    Expect(0, 173791, '\p{^Blk=_	CJK_Ext_B}', "");
    Expect(0, 173791, '\P{Blk=_	CJK_Ext_B}', "");
    Expect(1, 173791, '\P{^Blk=_	CJK_Ext_B}', "");
    Expect(0, 173792, '\p{Blk=_	CJK_Ext_B}', "");
    Expect(1, 173792, '\p{^Blk=_	CJK_Ext_B}', "");
    Expect(1, 173792, '\P{Blk=_	CJK_Ext_B}', "");
    Expect(0, 173792, '\P{^Blk=_	CJK_Ext_B}', "");
    Error('\p{Is_Block=	/a/CJK_Unified_IDEOGRAPHS_Extension_B}');
    Error('\P{Is_Block=	/a/CJK_Unified_IDEOGRAPHS_Extension_B}');
    Expect(1, 173791, '\p{Is_Block=cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\p{^Is_Block=cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\P{Is_Block=cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\P{^Is_Block=cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\p{Is_Block=cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\p{^Is_Block=cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\P{Is_Block=cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\P{^Is_Block=cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\p{Is_Block=-cjk_Unified_Ideographs_Extension_B}', "");
    Expect(0, 173791, '\p{^Is_Block=-cjk_Unified_Ideographs_Extension_B}', "");
    Expect(0, 173791, '\P{Is_Block=-cjk_Unified_Ideographs_Extension_B}', "");
    Expect(1, 173791, '\P{^Is_Block=-cjk_Unified_Ideographs_Extension_B}', "");
    Expect(0, 173792, '\p{Is_Block=-cjk_Unified_Ideographs_Extension_B}', "");
    Expect(1, 173792, '\p{^Is_Block=-cjk_Unified_Ideographs_Extension_B}', "");
    Expect(1, 173792, '\P{Is_Block=-cjk_Unified_Ideographs_Extension_B}', "");
    Expect(0, 173792, '\P{^Is_Block=-cjk_Unified_Ideographs_Extension_B}', "");
    Error('\p{Is_Blk=	/a/CJK_Ext_B}');
    Error('\P{Is_Blk=	/a/CJK_Ext_B}');
    Expect(1, 173791, '\p{Is_Blk=cjkextb}', "");
    Expect(0, 173791, '\p{^Is_Blk=cjkextb}', "");
    Expect(0, 173791, '\P{Is_Blk=cjkextb}', "");
    Expect(1, 173791, '\P{^Is_Blk=cjkextb}', "");
    Expect(0, 173792, '\p{Is_Blk=cjkextb}', "");
    Expect(1, 173792, '\p{^Is_Blk=cjkextb}', "");
    Expect(1, 173792, '\P{Is_Blk=cjkextb}', "");
    Expect(0, 173792, '\P{^Is_Blk=cjkextb}', "");
    Expect(1, 173791, '\p{Is_Blk= -CJK_EXT_B}', "");
    Expect(0, 173791, '\p{^Is_Blk= -CJK_EXT_B}', "");
    Expect(0, 173791, '\P{Is_Blk= -CJK_EXT_B}', "");
    Expect(1, 173791, '\P{^Is_Blk= -CJK_EXT_B}', "");
    Expect(0, 173792, '\p{Is_Blk= -CJK_EXT_B}', "");
    Expect(1, 173792, '\p{^Is_Blk= -CJK_EXT_B}', "");
    Expect(1, 173792, '\P{Is_Blk= -CJK_EXT_B}', "");
    Expect(0, 173792, '\P{^Is_Blk= -CJK_EXT_B}', "");
    Error('\p{Block=:=-	CJK_UNIFIED_Ideographs_Extension_c}');
    Error('\P{Block=:=-	CJK_UNIFIED_Ideographs_Extension_c}');
    Expect(1, 177983, '\p{Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\p{^Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\P{Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\P{^Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\p{Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\p{^Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\P{Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\P{^Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\p{Block=	_CJK_UNIFIED_ideographs_extension_C}', "");
    Expect(0, 177983, '\p{^Block=	_CJK_UNIFIED_ideographs_extension_C}', "");
    Expect(0, 177983, '\P{Block=	_CJK_UNIFIED_ideographs_extension_C}', "");
    Expect(1, 177983, '\P{^Block=	_CJK_UNIFIED_ideographs_extension_C}', "");
    Expect(0, 177984, '\p{Block=	_CJK_UNIFIED_ideographs_extension_C}', "");
    Expect(1, 177984, '\p{^Block=	_CJK_UNIFIED_ideographs_extension_C}', "");
    Expect(1, 177984, '\P{Block=	_CJK_UNIFIED_ideographs_extension_C}', "");
    Expect(0, 177984, '\P{^Block=	_CJK_UNIFIED_ideographs_extension_C}', "");
    Error('\p{Blk=/a/CJK_ext_c}');
    Error('\P{Blk=/a/CJK_ext_c}');
    Expect(1, 177983, '\p{Blk=cjkextc}', "");
    Expect(0, 177983, '\p{^Blk=cjkextc}', "");
    Expect(0, 177983, '\P{Blk=cjkextc}', "");
    Expect(1, 177983, '\P{^Blk=cjkextc}', "");
    Expect(0, 177984, '\p{Blk=cjkextc}', "");
    Expect(1, 177984, '\p{^Blk=cjkextc}', "");
    Expect(1, 177984, '\P{Blk=cjkextc}', "");
    Expect(0, 177984, '\P{^Blk=cjkextc}', "");
    Expect(1, 177983, '\p{Blk=	-CJK_Ext_C}', "");
    Expect(0, 177983, '\p{^Blk=	-CJK_Ext_C}', "");
    Expect(0, 177983, '\P{Blk=	-CJK_Ext_C}', "");
    Expect(1, 177983, '\P{^Blk=	-CJK_Ext_C}', "");
    Expect(0, 177984, '\p{Blk=	-CJK_Ext_C}', "");
    Expect(1, 177984, '\p{^Blk=	-CJK_Ext_C}', "");
    Expect(1, 177984, '\P{Blk=	-CJK_Ext_C}', "");
    Expect(0, 177984, '\P{^Blk=	-CJK_Ext_C}', "");
    Error('\p{Is_Block= 	CJK_Unified_IDEOGRAPHS_Extension_C/a/}');
    Error('\P{Is_Block= 	CJK_Unified_IDEOGRAPHS_Extension_C/a/}');
    Expect(1, 177983, '\p{Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\p{^Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\P{Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\P{^Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\p{Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\p{^Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\P{Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\P{^Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\p{Is_Block=__cjk_Unified_Ideographs_EXTENSION_C}', "");
    Expect(0, 177983, '\p{^Is_Block=__cjk_Unified_Ideographs_EXTENSION_C}', "");
    Expect(0, 177983, '\P{Is_Block=__cjk_Unified_Ideographs_EXTENSION_C}', "");
    Expect(1, 177983, '\P{^Is_Block=__cjk_Unified_Ideographs_EXTENSION_C}', "");
    Expect(0, 177984, '\p{Is_Block=__cjk_Unified_Ideographs_EXTENSION_C}', "");
    Expect(1, 177984, '\p{^Is_Block=__cjk_Unified_Ideographs_EXTENSION_C}', "");
    Expect(1, 177984, '\P{Is_Block=__cjk_Unified_Ideographs_EXTENSION_C}', "");
    Expect(0, 177984, '\P{^Is_Block=__cjk_Unified_Ideographs_EXTENSION_C}', "");
    Error('\p{Is_Blk=:= -CJK_ext_C}');
    Error('\P{Is_Blk=:= -CJK_ext_C}');
    Expect(1, 177983, '\p{Is_Blk=cjkextc}', "");
    Expect(0, 177983, '\p{^Is_Blk=cjkextc}', "");
    Expect(0, 177983, '\P{Is_Blk=cjkextc}', "");
    Expect(1, 177983, '\P{^Is_Blk=cjkextc}', "");
    Expect(0, 177984, '\p{Is_Blk=cjkextc}', "");
    Expect(1, 177984, '\p{^Is_Blk=cjkextc}', "");
    Expect(1, 177984, '\P{Is_Blk=cjkextc}', "");
    Expect(0, 177984, '\P{^Is_Blk=cjkextc}', "");
    Expect(1, 177983, '\p{Is_Blk=--CJK_Ext_C}', "");
    Expect(0, 177983, '\p{^Is_Blk=--CJK_Ext_C}', "");
    Expect(0, 177983, '\P{Is_Blk=--CJK_Ext_C}', "");
    Expect(1, 177983, '\P{^Is_Blk=--CJK_Ext_C}', "");
    Expect(0, 177984, '\p{Is_Blk=--CJK_Ext_C}', "");
    Expect(1, 177984, '\p{^Is_Blk=--CJK_Ext_C}', "");
    Expect(1, 177984, '\P{Is_Blk=--CJK_Ext_C}', "");
    Expect(0, 177984, '\P{^Is_Blk=--CJK_Ext_C}', "");
    Error('\p{Block= /a/CJK_Unified_IDEOGRAPHS_EXTENSION_D}');
    Error('\P{Block= /a/CJK_Unified_IDEOGRAPHS_EXTENSION_D}');
    Expect(1, 178207, '\p{Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\p{^Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\P{Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\P{^Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\p{Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\p{^Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\P{Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\P{^Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\p{Block=--CJK_UNIFIED_IDEOGRAPHS_Extension_D}', "");
    Expect(0, 178207, '\p{^Block=--CJK_UNIFIED_IDEOGRAPHS_Extension_D}', "");
    Expect(0, 178207, '\P{Block=--CJK_UNIFIED_IDEOGRAPHS_Extension_D}', "");
    Expect(1, 178207, '\P{^Block=--CJK_UNIFIED_IDEOGRAPHS_Extension_D}', "");
    Expect(0, 178208, '\p{Block=--CJK_UNIFIED_IDEOGRAPHS_Extension_D}', "");
    Expect(1, 178208, '\p{^Block=--CJK_UNIFIED_IDEOGRAPHS_Extension_D}', "");
    Expect(1, 178208, '\P{Block=--CJK_UNIFIED_IDEOGRAPHS_Extension_D}', "");
    Expect(0, 178208, '\P{^Block=--CJK_UNIFIED_IDEOGRAPHS_Extension_D}', "");
    Error('\p{Blk=		CJK_EXT_D/a/}');
    Error('\P{Blk=		CJK_EXT_D/a/}');
    Expect(1, 178207, '\p{Blk=cjkextd}', "");
    Expect(0, 178207, '\p{^Blk=cjkextd}', "");
    Expect(0, 178207, '\P{Blk=cjkextd}', "");
    Expect(1, 178207, '\P{^Blk=cjkextd}', "");
    Expect(0, 178208, '\p{Blk=cjkextd}', "");
    Expect(1, 178208, '\p{^Blk=cjkextd}', "");
    Expect(1, 178208, '\P{Blk=cjkextd}', "");
    Expect(0, 178208, '\P{^Blk=cjkextd}', "");
    Expect(1, 178207, '\p{Blk=-CJK_Ext_D}', "");
    Expect(0, 178207, '\p{^Blk=-CJK_Ext_D}', "");
    Expect(0, 178207, '\P{Blk=-CJK_Ext_D}', "");
    Expect(1, 178207, '\P{^Blk=-CJK_Ext_D}', "");
    Expect(0, 178208, '\p{Blk=-CJK_Ext_D}', "");
    Expect(1, 178208, '\p{^Blk=-CJK_Ext_D}', "");
    Expect(1, 178208, '\P{Blk=-CJK_Ext_D}', "");
    Expect(0, 178208, '\P{^Blk=-CJK_Ext_D}', "");
    Error('\p{Is_Block= :=CJK_Unified_IDEOGRAPHS_extension_D}');
    Error('\P{Is_Block= :=CJK_Unified_IDEOGRAPHS_extension_D}');
    Expect(1, 178207, '\p{Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\p{^Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\P{Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\P{^Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\p{Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\p{^Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\P{Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\P{^Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\p{Is_Block=-CJK_unified_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(0, 178207, '\p{^Is_Block=-CJK_unified_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(0, 178207, '\P{Is_Block=-CJK_unified_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(1, 178207, '\P{^Is_Block=-CJK_unified_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(0, 178208, '\p{Is_Block=-CJK_unified_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(1, 178208, '\p{^Is_Block=-CJK_unified_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(1, 178208, '\P{Is_Block=-CJK_unified_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(0, 178208, '\P{^Is_Block=-CJK_unified_IDEOGRAPHS_EXTENSION_D}', "");
    Error('\p{Is_Blk=/a/ -CJK_EXT_D}');
    Error('\P{Is_Blk=/a/ -CJK_EXT_D}');
    Expect(1, 178207, '\p{Is_Blk=cjkextd}', "");
    Expect(0, 178207, '\p{^Is_Blk=cjkextd}', "");
    Expect(0, 178207, '\P{Is_Blk=cjkextd}', "");
    Expect(1, 178207, '\P{^Is_Blk=cjkextd}', "");
    Expect(0, 178208, '\p{Is_Blk=cjkextd}', "");
    Expect(1, 178208, '\p{^Is_Blk=cjkextd}', "");
    Expect(1, 178208, '\P{Is_Blk=cjkextd}', "");
    Expect(0, 178208, '\P{^Is_Blk=cjkextd}', "");
    Expect(1, 178207, '\p{Is_Blk=	 CJK_ext_D}', "");
    Expect(0, 178207, '\p{^Is_Blk=	 CJK_ext_D}', "");
    Expect(0, 178207, '\P{Is_Blk=	 CJK_ext_D}', "");
    Expect(1, 178207, '\P{^Is_Blk=	 CJK_ext_D}', "");
    Expect(0, 178208, '\p{Is_Blk=	 CJK_ext_D}', "");
    Expect(1, 178208, '\p{^Is_Blk=	 CJK_ext_D}', "");
    Expect(1, 178208, '\P{Is_Blk=	 CJK_ext_D}', "");
    Expect(0, 178208, '\P{^Is_Blk=	 CJK_ext_D}', "");
    Error('\p{Block=	/a/cjk_unified_IDEOGRAPHS_EXTENSION_E}');
    Error('\P{Block=	/a/cjk_unified_IDEOGRAPHS_EXTENSION_E}');
    Expect(1, 183983, '\p{Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\p{^Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\P{Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\P{^Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\p{Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\p{^Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\P{Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\P{^Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\p{Block=--CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Expect(0, 183983, '\p{^Block=--CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Expect(0, 183983, '\P{Block=--CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Expect(1, 183983, '\P{^Block=--CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Expect(0, 183984, '\p{Block=--CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Expect(1, 183984, '\p{^Block=--CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Expect(1, 183984, '\P{Block=--CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Expect(0, 183984, '\P{^Block=--CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Error('\p{Blk=:=	 CJK_ext_e}');
    Error('\P{Blk=:=	 CJK_ext_e}');
    Expect(1, 183983, '\p{Blk=cjkexte}', "");
    Expect(0, 183983, '\p{^Blk=cjkexte}', "");
    Expect(0, 183983, '\P{Blk=cjkexte}', "");
    Expect(1, 183983, '\P{^Blk=cjkexte}', "");
    Expect(0, 183984, '\p{Blk=cjkexte}', "");
    Expect(1, 183984, '\p{^Blk=cjkexte}', "");
    Expect(1, 183984, '\P{Blk=cjkexte}', "");
    Expect(0, 183984, '\P{^Blk=cjkexte}', "");
    Expect(1, 183983, '\p{Blk=-CJK_ext_E}', "");
    Expect(0, 183983, '\p{^Blk=-CJK_ext_E}', "");
    Expect(0, 183983, '\P{Blk=-CJK_ext_E}', "");
    Expect(1, 183983, '\P{^Blk=-CJK_ext_E}', "");
    Expect(0, 183984, '\p{Blk=-CJK_ext_E}', "");
    Expect(1, 183984, '\p{^Blk=-CJK_ext_E}', "");
    Expect(1, 183984, '\P{Blk=-CJK_ext_E}', "");
    Expect(0, 183984, '\P{^Blk=-CJK_ext_E}', "");
    Error('\p{Is_Block: :=-CJK_UNIFIED_ideographs_extension_E}');
    Error('\P{Is_Block: :=-CJK_UNIFIED_ideographs_extension_E}');
    Expect(1, 183983, '\p{Is_Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\p{^Is_Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\P{Is_Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\P{^Is_Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\p{Is_Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\p{^Is_Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\P{Is_Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\P{^Is_Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\p{Is_Block=	-cjk_unified_Ideographs_Extension_E}', "");
    Expect(0, 183983, '\p{^Is_Block=	-cjk_unified_Ideographs_Extension_E}', "");
    Expect(0, 183983, '\P{Is_Block=	-cjk_unified_Ideographs_Extension_E}', "");
    Expect(1, 183983, '\P{^Is_Block=	-cjk_unified_Ideographs_Extension_E}', "");
    Expect(0, 183984, '\p{Is_Block=	-cjk_unified_Ideographs_Extension_E}', "");
    Expect(1, 183984, '\p{^Is_Block=	-cjk_unified_Ideographs_Extension_E}', "");
    Expect(1, 183984, '\P{Is_Block=	-cjk_unified_Ideographs_Extension_E}', "");
    Expect(0, 183984, '\P{^Is_Block=	-cjk_unified_Ideographs_Extension_E}', "");
    Error('\p{Is_Blk=/a/	 CJK_Ext_E}');
    Error('\P{Is_Blk=/a/	 CJK_Ext_E}');
    Expect(1, 183983, '\p{Is_Blk=cjkexte}', "");
    Expect(0, 183983, '\p{^Is_Blk=cjkexte}', "");
    Expect(0, 183983, '\P{Is_Blk=cjkexte}', "");
    Expect(1, 183983, '\P{^Is_Blk=cjkexte}', "");
    Expect(0, 183984, '\p{Is_Blk=cjkexte}', "");
    Expect(1, 183984, '\p{^Is_Blk=cjkexte}', "");
    Expect(1, 183984, '\P{Is_Blk=cjkexte}', "");
    Expect(0, 183984, '\P{^Is_Blk=cjkexte}', "");
    Expect(1, 183983, '\p{Is_Blk=	CJK_ext_E}', "");
    Expect(0, 183983, '\p{^Is_Blk=	CJK_ext_E}', "");
    Expect(0, 183983, '\P{Is_Blk=	CJK_ext_E}', "");
    Expect(1, 183983, '\P{^Is_Blk=	CJK_ext_E}', "");
    Expect(0, 183984, '\p{Is_Blk=	CJK_ext_E}', "");
    Expect(1, 183984, '\p{^Is_Blk=	CJK_ext_E}', "");
    Expect(1, 183984, '\P{Is_Blk=	CJK_ext_E}', "");
    Expect(0, 183984, '\P{^Is_Blk=	CJK_ext_E}', "");
    Error('\p{Block=/a/		CJK_Unified_Ideographs_Extension_f}');
    Error('\P{Block=/a/		CJK_Unified_Ideographs_Extension_f}');
    Expect(1, 191471, '\p{Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\p{^Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\P{Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\P{^Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\p{Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\p{^Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\P{Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\P{^Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\p{Block=	CJK_Unified_IDEOGRAPHS_extension_f}', "");
    Expect(0, 191471, '\p{^Block=	CJK_Unified_IDEOGRAPHS_extension_f}', "");
    Expect(0, 191471, '\P{Block=	CJK_Unified_IDEOGRAPHS_extension_f}', "");
    Expect(1, 191471, '\P{^Block=	CJK_Unified_IDEOGRAPHS_extension_f}', "");
    Expect(0, 191472, '\p{Block=	CJK_Unified_IDEOGRAPHS_extension_f}', "");
    Expect(1, 191472, '\p{^Block=	CJK_Unified_IDEOGRAPHS_extension_f}', "");
    Expect(1, 191472, '\P{Block=	CJK_Unified_IDEOGRAPHS_extension_f}', "");
    Expect(0, 191472, '\P{^Block=	CJK_Unified_IDEOGRAPHS_extension_f}', "");
    Error('\p{Blk: 	_cjk_Ext_F/a/}');
    Error('\P{Blk: 	_cjk_Ext_F/a/}');
    Expect(1, 191471, '\p{Blk=cjkextf}', "");
    Expect(0, 191471, '\p{^Blk=cjkextf}', "");
    Expect(0, 191471, '\P{Blk=cjkextf}', "");
    Expect(1, 191471, '\P{^Blk=cjkextf}', "");
    Expect(0, 191472, '\p{Blk=cjkextf}', "");
    Expect(1, 191472, '\p{^Blk=cjkextf}', "");
    Expect(1, 191472, '\P{Blk=cjkextf}', "");
    Expect(0, 191472, '\P{^Blk=cjkextf}', "");
    Expect(1, 191471, '\p{Blk=-cjk_ext_f}', "");
    Expect(0, 191471, '\p{^Blk=-cjk_ext_f}', "");
    Expect(0, 191471, '\P{Blk=-cjk_ext_f}', "");
    Expect(1, 191471, '\P{^Blk=-cjk_ext_f}', "");
    Expect(0, 191472, '\p{Blk=-cjk_ext_f}', "");
    Expect(1, 191472, '\p{^Blk=-cjk_ext_f}', "");
    Expect(1, 191472, '\P{Blk=-cjk_ext_f}', "");
    Expect(0, 191472, '\P{^Blk=-cjk_ext_f}', "");
    Error('\p{Is_Block=	/a/CJK_UNIFIED_IDEOGRAPHS_Extension_F}');
    Error('\P{Is_Block=	/a/CJK_UNIFIED_IDEOGRAPHS_Extension_F}');
    Expect(1, 191471, '\p{Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\p{^Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\P{Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\P{^Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\p{Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\p{^Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\P{Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\P{^Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\p{Is_Block: _-CJK_Unified_Ideographs_Extension_F}', "");
    Expect(0, 191471, '\p{^Is_Block: _-CJK_Unified_Ideographs_Extension_F}', "");
    Expect(0, 191471, '\P{Is_Block: _-CJK_Unified_Ideographs_Extension_F}', "");
    Expect(1, 191471, '\P{^Is_Block: _-CJK_Unified_Ideographs_Extension_F}', "");
    Expect(0, 191472, '\p{Is_Block: _-CJK_Unified_Ideographs_Extension_F}', "");
    Expect(1, 191472, '\p{^Is_Block: _-CJK_Unified_Ideographs_Extension_F}', "");
    Expect(1, 191472, '\P{Is_Block: _-CJK_Unified_Ideographs_Extension_F}', "");
    Expect(0, 191472, '\P{^Is_Block: _-CJK_Unified_Ideographs_Extension_F}', "");
    Error('\p{Is_Blk= CJK_Ext_F:=}');
    Error('\P{Is_Blk= CJK_Ext_F:=}');
    Expect(1, 191471, '\p{Is_Blk=cjkextf}', "");
    Expect(0, 191471, '\p{^Is_Blk=cjkextf}', "");
    Expect(0, 191471, '\P{Is_Blk=cjkextf}', "");
    Expect(1, 191471, '\P{^Is_Blk=cjkextf}', "");
    Expect(0, 191472, '\p{Is_Blk=cjkextf}', "");
    Expect(1, 191472, '\p{^Is_Blk=cjkextf}', "");
    Expect(1, 191472, '\P{Is_Blk=cjkextf}', "");
    Expect(0, 191472, '\P{^Is_Blk=cjkextf}', "");
    Expect(1, 191471, '\p{Is_Blk=_	CJK_EXT_f}', "");
    Expect(0, 191471, '\p{^Is_Blk=_	CJK_EXT_f}', "");
    Expect(0, 191471, '\P{Is_Blk=_	CJK_EXT_f}', "");
    Expect(1, 191471, '\P{^Is_Blk=_	CJK_EXT_f}', "");
    Expect(0, 191472, '\p{Is_Blk=_	CJK_EXT_f}', "");
    Expect(1, 191472, '\p{^Is_Blk=_	CJK_EXT_f}', "");
    Expect(1, 191472, '\P{Is_Blk=_	CJK_EXT_f}', "");
    Expect(0, 191472, '\P{^Is_Blk=_	CJK_EXT_f}', "");
    Error('\p{Block=	CJK_Radicals_Supplement:=}');
    Error('\P{Block=	CJK_Radicals_Supplement:=}');
    Expect(1, 12031, '\p{Block:	cjkradicalssupplement}', "");
    Expect(0, 12031, '\p{^Block:	cjkradicalssupplement}', "");
    Expect(0, 12031, '\P{Block:	cjkradicalssupplement}', "");
    Expect(1, 12031, '\P{^Block:	cjkradicalssupplement}', "");
    Expect(0, 12032, '\p{Block:	cjkradicalssupplement}', "");
    Expect(1, 12032, '\p{^Block:	cjkradicalssupplement}', "");
    Expect(1, 12032, '\P{Block:	cjkradicalssupplement}', "");
    Expect(0, 12032, '\P{^Block:	cjkradicalssupplement}', "");
    Expect(1, 12031, '\p{Block=	CJK_RADICALS_supplement}', "");
    Expect(0, 12031, '\p{^Block=	CJK_RADICALS_supplement}', "");
    Expect(0, 12031, '\P{Block=	CJK_RADICALS_supplement}', "");
    Expect(1, 12031, '\P{^Block=	CJK_RADICALS_supplement}', "");
    Expect(0, 12032, '\p{Block=	CJK_RADICALS_supplement}', "");
    Expect(1, 12032, '\p{^Block=	CJK_RADICALS_supplement}', "");
    Expect(1, 12032, '\P{Block=	CJK_RADICALS_supplement}', "");
    Expect(0, 12032, '\P{^Block=	CJK_RADICALS_supplement}', "");
    Error('\p{Blk=- CJK_radicals_sup:=}');
    Error('\P{Blk=- CJK_radicals_sup:=}');
    Expect(1, 12031, '\p{Blk=cjkradicalssup}', "");
    Expect(0, 12031, '\p{^Blk=cjkradicalssup}', "");
    Expect(0, 12031, '\P{Blk=cjkradicalssup}', "");
    Expect(1, 12031, '\P{^Blk=cjkradicalssup}', "");
    Expect(0, 12032, '\p{Blk=cjkradicalssup}', "");
    Expect(1, 12032, '\p{^Blk=cjkradicalssup}', "");
    Expect(1, 12032, '\P{Blk=cjkradicalssup}', "");
    Expect(0, 12032, '\P{^Blk=cjkradicalssup}', "");
    Expect(1, 12031, '\p{Blk: - CJK_RADICALS_sup}', "");
    Expect(0, 12031, '\p{^Blk: - CJK_RADICALS_sup}', "");
    Expect(0, 12031, '\P{Blk: - CJK_RADICALS_sup}', "");
    Expect(1, 12031, '\P{^Blk: - CJK_RADICALS_sup}', "");
    Expect(0, 12032, '\p{Blk: - CJK_RADICALS_sup}', "");
    Expect(1, 12032, '\p{^Blk: - CJK_RADICALS_sup}', "");
    Expect(1, 12032, '\P{Blk: - CJK_RADICALS_sup}', "");
    Expect(0, 12032, '\P{^Blk: - CJK_RADICALS_sup}', "");
    Error('\p{Is_Block=-/a/CJK_Radicals_SUPPLEMENT}');
    Error('\P{Is_Block=-/a/CJK_Radicals_SUPPLEMENT}');
    Expect(1, 12031, '\p{Is_Block=cjkradicalssupplement}', "");
    Expect(0, 12031, '\p{^Is_Block=cjkradicalssupplement}', "");
    Expect(0, 12031, '\P{Is_Block=cjkradicalssupplement}', "");
    Expect(1, 12031, '\P{^Is_Block=cjkradicalssupplement}', "");
    Expect(0, 12032, '\p{Is_Block=cjkradicalssupplement}', "");
    Expect(1, 12032, '\p{^Is_Block=cjkradicalssupplement}', "");
    Expect(1, 12032, '\P{Is_Block=cjkradicalssupplement}', "");
    Expect(0, 12032, '\P{^Is_Block=cjkradicalssupplement}', "");
    Expect(1, 12031, '\p{Is_Block=-CJK_Radicals_Supplement}', "");
    Expect(0, 12031, '\p{^Is_Block=-CJK_Radicals_Supplement}', "");
    Expect(0, 12031, '\P{Is_Block=-CJK_Radicals_Supplement}', "");
    Expect(1, 12031, '\P{^Is_Block=-CJK_Radicals_Supplement}', "");
    Expect(0, 12032, '\p{Is_Block=-CJK_Radicals_Supplement}', "");
    Expect(1, 12032, '\p{^Is_Block=-CJK_Radicals_Supplement}', "");
    Expect(1, 12032, '\P{Is_Block=-CJK_Radicals_Supplement}', "");
    Expect(0, 12032, '\P{^Is_Block=-CJK_Radicals_Supplement}', "");
    Error('\p{Is_Blk=_:=CJK_RADICALS_SUP}');
    Error('\P{Is_Blk=_:=CJK_RADICALS_SUP}');
    Expect(1, 12031, '\p{Is_Blk=cjkradicalssup}', "");
    Expect(0, 12031, '\p{^Is_Blk=cjkradicalssup}', "");
    Expect(0, 12031, '\P{Is_Blk=cjkradicalssup}', "");
    Expect(1, 12031, '\P{^Is_Blk=cjkradicalssup}', "");
    Expect(0, 12032, '\p{Is_Blk=cjkradicalssup}', "");
    Expect(1, 12032, '\p{^Is_Blk=cjkradicalssup}', "");
    Expect(1, 12032, '\P{Is_Blk=cjkradicalssup}', "");
    Expect(0, 12032, '\P{^Is_Blk=cjkradicalssup}', "");
    Expect(1, 12031, '\p{Is_Blk= cjk_Radicals_Sup}', "");
    Expect(0, 12031, '\p{^Is_Blk= cjk_Radicals_Sup}', "");
    Expect(0, 12031, '\P{Is_Blk= cjk_Radicals_Sup}', "");
    Expect(1, 12031, '\P{^Is_Blk= cjk_Radicals_Sup}', "");
    Expect(0, 12032, '\p{Is_Blk= cjk_Radicals_Sup}', "");
    Expect(1, 12032, '\p{^Is_Blk= cjk_Radicals_Sup}', "");
    Expect(1, 12032, '\P{Is_Blk= cjk_Radicals_Sup}', "");
    Expect(0, 12032, '\P{^Is_Blk= cjk_Radicals_Sup}', "");
    Error('\p{Block=:=__CJK_Strokes}');
    Error('\P{Block=:=__CJK_Strokes}');
    Expect(1, 12783, '\p{Block: cjkstrokes}', "");
    Expect(0, 12783, '\p{^Block: cjkstrokes}', "");
    Expect(0, 12783, '\P{Block: cjkstrokes}', "");
    Expect(1, 12783, '\P{^Block: cjkstrokes}', "");
    Expect(0, 12784, '\p{Block: cjkstrokes}', "");
    Expect(1, 12784, '\p{^Block: cjkstrokes}', "");
    Expect(1, 12784, '\P{Block: cjkstrokes}', "");
    Expect(0, 12784, '\P{^Block: cjkstrokes}', "");
    Expect(1, 12783, '\p{Block=	 CJK_STROKES}', "");
    Expect(0, 12783, '\p{^Block=	 CJK_STROKES}', "");
    Expect(0, 12783, '\P{Block=	 CJK_STROKES}', "");
    Expect(1, 12783, '\P{^Block=	 CJK_STROKES}', "");
    Expect(0, 12784, '\p{Block=	 CJK_STROKES}', "");
    Expect(1, 12784, '\p{^Block=	 CJK_STROKES}', "");
    Expect(1, 12784, '\P{Block=	 CJK_STROKES}', "");
    Expect(0, 12784, '\P{^Block=	 CJK_STROKES}', "");
    Error('\p{Blk=-CJK_Strokes/a/}');
    Error('\P{Blk=-CJK_Strokes/a/}');
    Expect(1, 12783, '\p{Blk=cjkstrokes}', "");
    Expect(0, 12783, '\p{^Blk=cjkstrokes}', "");
    Expect(0, 12783, '\P{Blk=cjkstrokes}', "");
    Expect(1, 12783, '\P{^Blk=cjkstrokes}', "");
    Expect(0, 12784, '\p{Blk=cjkstrokes}', "");
    Expect(1, 12784, '\p{^Blk=cjkstrokes}', "");
    Expect(1, 12784, '\P{Blk=cjkstrokes}', "");
    Expect(0, 12784, '\P{^Blk=cjkstrokes}', "");
    Expect(1, 12783, '\p{Blk=		cjk_STROKES}', "");
    Expect(0, 12783, '\p{^Blk=		cjk_STROKES}', "");
    Expect(0, 12783, '\P{Blk=		cjk_STROKES}', "");
    Expect(1, 12783, '\P{^Blk=		cjk_STROKES}', "");
    Expect(0, 12784, '\p{Blk=		cjk_STROKES}', "");
    Expect(1, 12784, '\p{^Blk=		cjk_STROKES}', "");
    Expect(1, 12784, '\P{Blk=		cjk_STROKES}', "");
    Expect(0, 12784, '\P{^Blk=		cjk_STROKES}', "");
    Error('\p{Is_Block=	CJK_strokes:=}');
    Error('\P{Is_Block=	CJK_strokes:=}');
    Expect(1, 12783, '\p{Is_Block=cjkstrokes}', "");
    Expect(0, 12783, '\p{^Is_Block=cjkstrokes}', "");
    Expect(0, 12783, '\P{Is_Block=cjkstrokes}', "");
    Expect(1, 12783, '\P{^Is_Block=cjkstrokes}', "");
    Expect(0, 12784, '\p{Is_Block=cjkstrokes}', "");
    Expect(1, 12784, '\p{^Is_Block=cjkstrokes}', "");
    Expect(1, 12784, '\P{Is_Block=cjkstrokes}', "");
    Expect(0, 12784, '\P{^Is_Block=cjkstrokes}', "");
    Expect(1, 12783, '\p{Is_Block=	 CJK_STROKES}', "");
    Expect(0, 12783, '\p{^Is_Block=	 CJK_STROKES}', "");
    Expect(0, 12783, '\P{Is_Block=	 CJK_STROKES}', "");
    Expect(1, 12783, '\P{^Is_Block=	 CJK_STROKES}', "");
    Expect(0, 12784, '\p{Is_Block=	 CJK_STROKES}', "");
    Expect(1, 12784, '\p{^Is_Block=	 CJK_STROKES}', "");
    Expect(1, 12784, '\P{Is_Block=	 CJK_STROKES}', "");
    Expect(0, 12784, '\P{^Is_Block=	 CJK_STROKES}', "");
    Error('\p{Is_Blk=_cjk_strokes/a/}');
    Error('\P{Is_Blk=_cjk_strokes/a/}');
    Expect(1, 12783, '\p{Is_Blk=cjkstrokes}', "");
    Expect(0, 12783, '\p{^Is_Blk=cjkstrokes}', "");
    Expect(0, 12783, '\P{Is_Blk=cjkstrokes}', "");
    Expect(1, 12783, '\P{^Is_Blk=cjkstrokes}', "");
    Expect(0, 12784, '\p{Is_Blk=cjkstrokes}', "");
    Expect(1, 12784, '\p{^Is_Blk=cjkstrokes}', "");
    Expect(1, 12784, '\P{Is_Blk=cjkstrokes}', "");
    Expect(0, 12784, '\P{^Is_Blk=cjkstrokes}', "");
    Expect(1, 12783, '\p{Is_Blk=--CJK_STROKES}', "");
    Expect(0, 12783, '\p{^Is_Blk=--CJK_STROKES}', "");
    Expect(0, 12783, '\P{Is_Blk=--CJK_STROKES}', "");
    Expect(1, 12783, '\P{^Is_Blk=--CJK_STROKES}', "");
    Expect(0, 12784, '\p{Is_Blk=--CJK_STROKES}', "");
    Expect(1, 12784, '\p{^Is_Blk=--CJK_STROKES}', "");
    Expect(1, 12784, '\P{Is_Blk=--CJK_STROKES}', "");
    Expect(0, 12784, '\P{^Is_Blk=--CJK_STROKES}', "");
    Error('\p{Block=	-CJK_SYMBOLS_AND_PUNCTUATION:=}');
    Error('\P{Block=	-CJK_SYMBOLS_AND_PUNCTUATION:=}');
    Expect(1, 12351, '\p{Block:cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\p{^Block:cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\P{Block:cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\P{^Block:cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\p{Block:cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\p{^Block:cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\P{Block:cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\P{^Block:cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\p{Block=	-CJK_Symbols_AND_Punctuation}', "");
    Expect(0, 12351, '\p{^Block=	-CJK_Symbols_AND_Punctuation}', "");
    Expect(0, 12351, '\P{Block=	-CJK_Symbols_AND_Punctuation}', "");
    Expect(1, 12351, '\P{^Block=	-CJK_Symbols_AND_Punctuation}', "");
    Expect(0, 12352, '\p{Block=	-CJK_Symbols_AND_Punctuation}', "");
    Expect(1, 12352, '\p{^Block=	-CJK_Symbols_AND_Punctuation}', "");
    Expect(1, 12352, '\P{Block=	-CJK_Symbols_AND_Punctuation}', "");
    Expect(0, 12352, '\P{^Block=	-CJK_Symbols_AND_Punctuation}', "");
    Error('\p{Blk=	/a/CJK_Symbols}');
    Error('\P{Blk=	/a/CJK_Symbols}');
    Expect(1, 12351, '\p{Blk=cjksymbols}', "");
    Expect(0, 12351, '\p{^Blk=cjksymbols}', "");
    Expect(0, 12351, '\P{Blk=cjksymbols}', "");
    Expect(1, 12351, '\P{^Blk=cjksymbols}', "");
    Expect(0, 12352, '\p{Blk=cjksymbols}', "");
    Expect(1, 12352, '\p{^Blk=cjksymbols}', "");
    Expect(1, 12352, '\P{Blk=cjksymbols}', "");
    Expect(0, 12352, '\P{^Blk=cjksymbols}', "");
    Expect(1, 12351, '\p{Blk= 	CJK_SYMBOLS}', "");
    Expect(0, 12351, '\p{^Blk= 	CJK_SYMBOLS}', "");
    Expect(0, 12351, '\P{Blk= 	CJK_SYMBOLS}', "");
    Expect(1, 12351, '\P{^Blk= 	CJK_SYMBOLS}', "");
    Expect(0, 12352, '\p{Blk= 	CJK_SYMBOLS}', "");
    Expect(1, 12352, '\p{^Blk= 	CJK_SYMBOLS}', "");
    Expect(1, 12352, '\P{Blk= 	CJK_SYMBOLS}', "");
    Expect(0, 12352, '\P{^Blk= 	CJK_SYMBOLS}', "");
    Error('\p{Is_Block: :=_	CJK_Symbols_and_Punctuation}');
    Error('\P{Is_Block: :=_	CJK_Symbols_and_Punctuation}');
    Expect(1, 12351, '\p{Is_Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\p{^Is_Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\P{Is_Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\P{^Is_Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\p{Is_Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\p{^Is_Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\P{Is_Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\P{^Is_Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\p{Is_Block= CJK_Symbols_and_Punctuation}', "");
    Expect(0, 12351, '\p{^Is_Block= CJK_Symbols_and_Punctuation}', "");
    Expect(0, 12351, '\P{Is_Block= CJK_Symbols_and_Punctuation}', "");
    Expect(1, 12351, '\P{^Is_Block= CJK_Symbols_and_Punctuation}', "");
    Expect(0, 12352, '\p{Is_Block= CJK_Symbols_and_Punctuation}', "");
    Expect(1, 12352, '\p{^Is_Block= CJK_Symbols_and_Punctuation}', "");
    Expect(1, 12352, '\P{Is_Block= CJK_Symbols_and_Punctuation}', "");
    Expect(0, 12352, '\P{^Is_Block= CJK_Symbols_and_Punctuation}', "");
    Error('\p{Is_Blk=/a/  cjk_symbols}');
    Error('\P{Is_Blk=/a/  cjk_symbols}');
    Expect(1, 12351, '\p{Is_Blk=cjksymbols}', "");
    Expect(0, 12351, '\p{^Is_Blk=cjksymbols}', "");
    Expect(0, 12351, '\P{Is_Blk=cjksymbols}', "");
    Expect(1, 12351, '\P{^Is_Blk=cjksymbols}', "");
    Expect(0, 12352, '\p{Is_Blk=cjksymbols}', "");
    Expect(1, 12352, '\p{^Is_Blk=cjksymbols}', "");
    Expect(1, 12352, '\P{Is_Blk=cjksymbols}', "");
    Expect(0, 12352, '\P{^Is_Blk=cjksymbols}', "");
    Expect(1, 12351, '\p{Is_Blk:   _CJK_Symbols}', "");
    Expect(0, 12351, '\p{^Is_Blk:   _CJK_Symbols}', "");
    Expect(0, 12351, '\P{Is_Blk:   _CJK_Symbols}', "");
    Expect(1, 12351, '\P{^Is_Blk:   _CJK_Symbols}', "");
    Expect(0, 12352, '\p{Is_Blk:   _CJK_Symbols}', "");
    Expect(1, 12352, '\p{^Is_Blk:   _CJK_Symbols}', "");
    Expect(1, 12352, '\P{Is_Blk:   _CJK_Symbols}', "");
    Expect(0, 12352, '\P{^Is_Blk:   _CJK_Symbols}', "");
    Error('\p{Block:   :=__Hangul_Compatibility_Jamo}');
    Error('\P{Block:   :=__Hangul_Compatibility_Jamo}');
    Expect(1, 12687, '\p{Block=hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\p{^Block=hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\P{Block=hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\P{^Block=hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\p{Block=hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\p{^Block=hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\P{Block=hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\P{^Block=hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\p{Block= Hangul_COMPATIBILITY_Jamo}', "");
    Expect(0, 12687, '\p{^Block= Hangul_COMPATIBILITY_Jamo}', "");
    Expect(0, 12687, '\P{Block= Hangul_COMPATIBILITY_Jamo}', "");
    Expect(1, 12687, '\P{^Block= Hangul_COMPATIBILITY_Jamo}', "");
    Expect(0, 12688, '\p{Block= Hangul_COMPATIBILITY_Jamo}', "");
    Expect(1, 12688, '\p{^Block= Hangul_COMPATIBILITY_Jamo}', "");
    Expect(1, 12688, '\P{Block= Hangul_COMPATIBILITY_Jamo}', "");
    Expect(0, 12688, '\P{^Block= Hangul_COMPATIBILITY_Jamo}', "");
    Error('\p{Blk:-_Compat_Jamo/a/}');
    Error('\P{Blk:-_Compat_Jamo/a/}');
    Expect(1, 12687, '\p{Blk=compatjamo}', "");
    Expect(0, 12687, '\p{^Blk=compatjamo}', "");
    Expect(0, 12687, '\P{Blk=compatjamo}', "");
    Expect(1, 12687, '\P{^Blk=compatjamo}', "");
    Expect(0, 12688, '\p{Blk=compatjamo}', "");
    Expect(1, 12688, '\p{^Blk=compatjamo}', "");
    Expect(1, 12688, '\P{Blk=compatjamo}', "");
    Expect(0, 12688, '\P{^Blk=compatjamo}', "");
    Expect(1, 12687, '\p{Blk= _COMPAT_jamo}', "");
    Expect(0, 12687, '\p{^Blk= _COMPAT_jamo}', "");
    Expect(0, 12687, '\P{Blk= _COMPAT_jamo}', "");
    Expect(1, 12687, '\P{^Blk= _COMPAT_jamo}', "");
    Expect(0, 12688, '\p{Blk= _COMPAT_jamo}', "");
    Expect(1, 12688, '\p{^Blk= _COMPAT_jamo}', "");
    Expect(1, 12688, '\P{Blk= _COMPAT_jamo}', "");
    Expect(0, 12688, '\P{^Blk= _COMPAT_jamo}', "");
    Error('\p{Is_Block: _:=hangul_compatibility_Jamo}');
    Error('\P{Is_Block: _:=hangul_compatibility_Jamo}');
    Expect(1, 12687, '\p{Is_Block=hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\p{^Is_Block=hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\P{Is_Block=hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\P{^Is_Block=hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\p{Is_Block=hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\p{^Is_Block=hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\P{Is_Block=hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\P{^Is_Block=hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\p{Is_Block=HANGUL_compatibility_Jamo}', "");
    Expect(0, 12687, '\p{^Is_Block=HANGUL_compatibility_Jamo}', "");
    Expect(0, 12687, '\P{Is_Block=HANGUL_compatibility_Jamo}', "");
    Expect(1, 12687, '\P{^Is_Block=HANGUL_compatibility_Jamo}', "");
    Expect(0, 12688, '\p{Is_Block=HANGUL_compatibility_Jamo}', "");
    Expect(1, 12688, '\p{^Is_Block=HANGUL_compatibility_Jamo}', "");
    Expect(1, 12688, '\P{Is_Block=HANGUL_compatibility_Jamo}', "");
    Expect(0, 12688, '\P{^Is_Block=HANGUL_compatibility_Jamo}', "");
    Error('\p{Is_Blk=-/a/Compat_JAMO}');
    Error('\P{Is_Blk=-/a/Compat_JAMO}');
    Expect(1, 12687, '\p{Is_Blk=compatjamo}', "");
    Expect(0, 12687, '\p{^Is_Blk=compatjamo}', "");
    Expect(0, 12687, '\P{Is_Blk=compatjamo}', "");
    Expect(1, 12687, '\P{^Is_Blk=compatjamo}', "");
    Expect(0, 12688, '\p{Is_Blk=compatjamo}', "");
    Expect(1, 12688, '\p{^Is_Blk=compatjamo}', "");
    Expect(1, 12688, '\P{Is_Blk=compatjamo}', "");
    Expect(0, 12688, '\P{^Is_Blk=compatjamo}', "");
    Expect(1, 12687, '\p{Is_Blk=	 COMPAT_jamo}', "");
    Expect(0, 12687, '\p{^Is_Blk=	 COMPAT_jamo}', "");
    Expect(0, 12687, '\P{Is_Blk=	 COMPAT_jamo}', "");
    Expect(1, 12687, '\P{^Is_Blk=	 COMPAT_jamo}', "");
    Expect(0, 12688, '\p{Is_Blk=	 COMPAT_jamo}', "");
    Expect(1, 12688, '\p{^Is_Blk=	 COMPAT_jamo}', "");
    Expect(1, 12688, '\P{Is_Blk=	 COMPAT_jamo}', "");
    Expect(0, 12688, '\P{^Is_Blk=	 COMPAT_jamo}', "");
    Error('\p{Block=control_pictures:=}');
    Error('\P{Block=control_pictures:=}');
    Expect(1, 9279, '\p{Block=controlpictures}', "");
    Expect(0, 9279, '\p{^Block=controlpictures}', "");
    Expect(0, 9279, '\P{Block=controlpictures}', "");
    Expect(1, 9279, '\P{^Block=controlpictures}', "");
    Expect(0, 9280, '\p{Block=controlpictures}', "");
    Expect(1, 9280, '\p{^Block=controlpictures}', "");
    Expect(1, 9280, '\P{Block=controlpictures}', "");
    Expect(0, 9280, '\P{^Block=controlpictures}', "");
    Expect(1, 9279, '\p{Block=		Control_Pictures}', "");
    Expect(0, 9279, '\p{^Block=		Control_Pictures}', "");
    Expect(0, 9279, '\P{Block=		Control_Pictures}', "");
    Expect(1, 9279, '\P{^Block=		Control_Pictures}', "");
    Expect(0, 9280, '\p{Block=		Control_Pictures}', "");
    Expect(1, 9280, '\p{^Block=		Control_Pictures}', "");
    Expect(1, 9280, '\P{Block=		Control_Pictures}', "");
    Expect(0, 9280, '\P{^Block=		Control_Pictures}', "");
    Error('\p{Blk=_Control_pictures:=}');
    Error('\P{Blk=_Control_pictures:=}');
    Expect(1, 9279, '\p{Blk=controlpictures}', "");
    Expect(0, 9279, '\p{^Blk=controlpictures}', "");
    Expect(0, 9279, '\P{Blk=controlpictures}', "");
    Expect(1, 9279, '\P{^Blk=controlpictures}', "");
    Expect(0, 9280, '\p{Blk=controlpictures}', "");
    Expect(1, 9280, '\p{^Blk=controlpictures}', "");
    Expect(1, 9280, '\P{Blk=controlpictures}', "");
    Expect(0, 9280, '\P{^Blk=controlpictures}', "");
    Expect(1, 9279, '\p{Blk:   CONTROL_PICTURES}', "");
    Expect(0, 9279, '\p{^Blk:   CONTROL_PICTURES}', "");
    Expect(0, 9279, '\P{Blk:   CONTROL_PICTURES}', "");
    Expect(1, 9279, '\P{^Blk:   CONTROL_PICTURES}', "");
    Expect(0, 9280, '\p{Blk:   CONTROL_PICTURES}', "");
    Expect(1, 9280, '\p{^Blk:   CONTROL_PICTURES}', "");
    Expect(1, 9280, '\P{Blk:   CONTROL_PICTURES}', "");
    Expect(0, 9280, '\P{^Blk:   CONTROL_PICTURES}', "");
    Error('\p{Is_Block=:=-_Control_Pictures}');
    Error('\P{Is_Block=:=-_Control_Pictures}');
    Expect(1, 9279, '\p{Is_Block=controlpictures}', "");
    Expect(0, 9279, '\p{^Is_Block=controlpictures}', "");
    Expect(0, 9279, '\P{Is_Block=controlpictures}', "");
    Expect(1, 9279, '\P{^Is_Block=controlpictures}', "");
    Expect(0, 9280, '\p{Is_Block=controlpictures}', "");
    Expect(1, 9280, '\p{^Is_Block=controlpictures}', "");
    Expect(1, 9280, '\P{Is_Block=controlpictures}', "");
    Expect(0, 9280, '\P{^Is_Block=controlpictures}', "");
    Expect(1, 9279, '\p{Is_Block= -CONTROL_Pictures}', "");
    Expect(0, 9279, '\p{^Is_Block= -CONTROL_Pictures}', "");
    Expect(0, 9279, '\P{Is_Block= -CONTROL_Pictures}', "");
    Expect(1, 9279, '\P{^Is_Block= -CONTROL_Pictures}', "");
    Expect(0, 9280, '\p{Is_Block= -CONTROL_Pictures}', "");
    Expect(1, 9280, '\p{^Is_Block= -CONTROL_Pictures}', "");
    Expect(1, 9280, '\P{Is_Block= -CONTROL_Pictures}', "");
    Expect(0, 9280, '\P{^Is_Block= -CONTROL_Pictures}', "");
    Error('\p{Is_Blk=/a/_Control_pictures}');
    Error('\P{Is_Blk=/a/_Control_pictures}');
    Expect(1, 9279, '\p{Is_Blk=controlpictures}', "");
    Expect(0, 9279, '\p{^Is_Blk=controlpictures}', "");
    Expect(0, 9279, '\P{Is_Blk=controlpictures}', "");
    Expect(1, 9279, '\P{^Is_Blk=controlpictures}', "");
    Expect(0, 9280, '\p{Is_Blk=controlpictures}', "");
    Expect(1, 9280, '\p{^Is_Blk=controlpictures}', "");
    Expect(1, 9280, '\P{Is_Blk=controlpictures}', "");
    Expect(0, 9280, '\P{^Is_Blk=controlpictures}', "");
    Expect(1, 9279, '\p{Is_Blk=_Control_Pictures}', "");
    Expect(0, 9279, '\p{^Is_Blk=_Control_Pictures}', "");
    Expect(0, 9279, '\P{Is_Blk=_Control_Pictures}', "");
    Expect(1, 9279, '\P{^Is_Blk=_Control_Pictures}', "");
    Expect(0, 9280, '\p{Is_Blk=_Control_Pictures}', "");
    Expect(1, 9280, '\p{^Is_Blk=_Control_Pictures}', "");
    Expect(1, 9280, '\P{Is_Blk=_Control_Pictures}', "");
    Expect(0, 9280, '\P{^Is_Blk=_Control_Pictures}', "");
    Error('\p{Block= :=Coptic}');
    Error('\P{Block= :=Coptic}');
    Expect(1, 11519, '\p{Block=coptic}', "");
    Expect(0, 11519, '\p{^Block=coptic}', "");
    Expect(0, 11519, '\P{Block=coptic}', "");
    Expect(1, 11519, '\P{^Block=coptic}', "");
    Expect(0, 11520, '\p{Block=coptic}', "");
    Expect(1, 11520, '\p{^Block=coptic}', "");
    Expect(1, 11520, '\P{Block=coptic}', "");
    Expect(0, 11520, '\P{^Block=coptic}', "");
    Expect(1, 11519, '\p{Block=-_coptic}', "");
    Expect(0, 11519, '\p{^Block=-_coptic}', "");
    Expect(0, 11519, '\P{Block=-_coptic}', "");
    Expect(1, 11519, '\P{^Block=-_coptic}', "");
    Expect(0, 11520, '\p{Block=-_coptic}', "");
    Expect(1, 11520, '\p{^Block=-_coptic}', "");
    Expect(1, 11520, '\P{Block=-_coptic}', "");
    Expect(0, 11520, '\P{^Block=-_coptic}', "");
    Error('\p{Blk=:=_-Coptic}');
    Error('\P{Blk=:=_-Coptic}');
    Expect(1, 11519, '\p{Blk=coptic}', "");
    Expect(0, 11519, '\p{^Blk=coptic}', "");
    Expect(0, 11519, '\P{Blk=coptic}', "");
    Expect(1, 11519, '\P{^Blk=coptic}', "");
    Expect(0, 11520, '\p{Blk=coptic}', "");
    Expect(1, 11520, '\p{^Blk=coptic}', "");
    Expect(1, 11520, '\P{Blk=coptic}', "");
    Expect(0, 11520, '\P{^Blk=coptic}', "");
    Error('\p{Is_Block= COPTIC:=}');
    Error('\P{Is_Block= COPTIC:=}');
    Expect(1, 11519, '\p{Is_Block:   coptic}', "");
    Expect(0, 11519, '\p{^Is_Block:   coptic}', "");
    Expect(0, 11519, '\P{Is_Block:   coptic}', "");
    Expect(1, 11519, '\P{^Is_Block:   coptic}', "");
    Expect(0, 11520, '\p{Is_Block:   coptic}', "");
    Expect(1, 11520, '\p{^Is_Block:   coptic}', "");
    Expect(1, 11520, '\P{Is_Block:   coptic}', "");
    Expect(0, 11520, '\P{^Is_Block:   coptic}', "");
    Expect(1, 11519, '\p{Is_Block=--coptic}', "");
    Expect(0, 11519, '\p{^Is_Block=--coptic}', "");
    Expect(0, 11519, '\P{Is_Block=--coptic}', "");
    Expect(1, 11519, '\P{^Is_Block=--coptic}', "");
    Expect(0, 11520, '\p{Is_Block=--coptic}', "");
    Expect(1, 11520, '\p{^Is_Block=--coptic}', "");
    Expect(1, 11520, '\P{Is_Block=--coptic}', "");
    Expect(0, 11520, '\P{^Is_Block=--coptic}', "");
    Error('\p{Is_Blk=	_coptic:=}');
    Error('\P{Is_Blk=	_coptic:=}');
    Expect(1, 11519, '\p{Is_Blk=coptic}', "");
    Expect(0, 11519, '\p{^Is_Blk=coptic}', "");
    Expect(0, 11519, '\P{Is_Blk=coptic}', "");
    Expect(1, 11519, '\P{^Is_Blk=coptic}', "");
    Expect(0, 11520, '\p{Is_Blk=coptic}', "");
    Expect(1, 11520, '\p{^Is_Blk=coptic}', "");
    Expect(1, 11520, '\P{Is_Blk=coptic}', "");
    Expect(0, 11520, '\P{^Is_Blk=coptic}', "");
    Expect(1, 11519, '\p{Is_Blk=--coptic}', "");
    Expect(0, 11519, '\p{^Is_Blk=--coptic}', "");
    Expect(0, 11519, '\P{Is_Blk=--coptic}', "");
    Expect(1, 11519, '\P{^Is_Blk=--coptic}', "");
    Expect(0, 11520, '\p{Is_Blk=--coptic}', "");
    Expect(1, 11520, '\p{^Is_Blk=--coptic}', "");
    Expect(1, 11520, '\P{Is_Blk=--coptic}', "");
    Expect(0, 11520, '\P{^Is_Blk=--coptic}', "");
    Error('\p{Block= Coptic_epact_Numbers:=}');
    Error('\P{Block= Coptic_epact_Numbers:=}');
    Expect(1, 66303, '\p{Block: copticepactnumbers}', "");
    Expect(0, 66303, '\p{^Block: copticepactnumbers}', "");
    Expect(0, 66303, '\P{Block: copticepactnumbers}', "");
    Expect(1, 66303, '\P{^Block: copticepactnumbers}', "");
    Expect(0, 66304, '\p{Block: copticepactnumbers}', "");
    Expect(1, 66304, '\p{^Block: copticepactnumbers}', "");
    Expect(1, 66304, '\P{Block: copticepactnumbers}', "");
    Expect(0, 66304, '\P{^Block: copticepactnumbers}', "");
    Expect(1, 66303, '\p{Block:	--coptic_Epact_Numbers}', "");
    Expect(0, 66303, '\p{^Block:	--coptic_Epact_Numbers}', "");
    Expect(0, 66303, '\P{Block:	--coptic_Epact_Numbers}', "");
    Expect(1, 66303, '\P{^Block:	--coptic_Epact_Numbers}', "");
    Expect(0, 66304, '\p{Block:	--coptic_Epact_Numbers}', "");
    Expect(1, 66304, '\p{^Block:	--coptic_Epact_Numbers}', "");
    Expect(1, 66304, '\P{Block:	--coptic_Epact_Numbers}', "");
    Expect(0, 66304, '\P{^Block:	--coptic_Epact_Numbers}', "");
    Error('\p{Blk=:=- Coptic_Epact_Numbers}');
    Error('\P{Blk=:=- Coptic_Epact_Numbers}');
    Expect(1, 66303, '\p{Blk=copticepactnumbers}', "");
    Expect(0, 66303, '\p{^Blk=copticepactnumbers}', "");
    Expect(0, 66303, '\P{Blk=copticepactnumbers}', "");
    Expect(1, 66303, '\P{^Blk=copticepactnumbers}', "");
    Expect(0, 66304, '\p{Blk=copticepactnumbers}', "");
    Expect(1, 66304, '\p{^Blk=copticepactnumbers}', "");
    Expect(1, 66304, '\P{Blk=copticepactnumbers}', "");
    Expect(0, 66304, '\P{^Blk=copticepactnumbers}', "");
    Expect(1, 66303, '\p{Blk=	COPTIC_EPACT_Numbers}', "");
    Expect(0, 66303, '\p{^Blk=	COPTIC_EPACT_Numbers}', "");
    Expect(0, 66303, '\P{Blk=	COPTIC_EPACT_Numbers}', "");
    Expect(1, 66303, '\P{^Blk=	COPTIC_EPACT_Numbers}', "");
    Expect(0, 66304, '\p{Blk=	COPTIC_EPACT_Numbers}', "");
    Expect(1, 66304, '\p{^Blk=	COPTIC_EPACT_Numbers}', "");
    Expect(1, 66304, '\P{Blk=	COPTIC_EPACT_Numbers}', "");
    Expect(0, 66304, '\P{^Blk=	COPTIC_EPACT_Numbers}', "");
    Error('\p{Is_Block=:=--Coptic_epact_NUMBERS}');
    Error('\P{Is_Block=:=--Coptic_epact_NUMBERS}');
    Expect(1, 66303, '\p{Is_Block:	copticepactnumbers}', "");
    Expect(0, 66303, '\p{^Is_Block:	copticepactnumbers}', "");
    Expect(0, 66303, '\P{Is_Block:	copticepactnumbers}', "");
    Expect(1, 66303, '\P{^Is_Block:	copticepactnumbers}', "");
    Expect(0, 66304, '\p{Is_Block:	copticepactnumbers}', "");
    Expect(1, 66304, '\p{^Is_Block:	copticepactnumbers}', "");
    Expect(1, 66304, '\P{Is_Block:	copticepactnumbers}', "");
    Expect(0, 66304, '\P{^Is_Block:	copticepactnumbers}', "");
    Expect(1, 66303, '\p{Is_Block=		coptic_Epact_NUMBERS}', "");
    Expect(0, 66303, '\p{^Is_Block=		coptic_Epact_NUMBERS}', "");
    Expect(0, 66303, '\P{Is_Block=		coptic_Epact_NUMBERS}', "");
    Expect(1, 66303, '\P{^Is_Block=		coptic_Epact_NUMBERS}', "");
    Expect(0, 66304, '\p{Is_Block=		coptic_Epact_NUMBERS}', "");
    Expect(1, 66304, '\p{^Is_Block=		coptic_Epact_NUMBERS}', "");
    Expect(1, 66304, '\P{Is_Block=		coptic_Epact_NUMBERS}', "");
    Expect(0, 66304, '\P{^Is_Block=		coptic_Epact_NUMBERS}', "");
    Error('\p{Is_Blk:	-:=Coptic_EPACT_NUMBERS}');
    Error('\P{Is_Blk:	-:=Coptic_EPACT_NUMBERS}');
    Expect(1, 66303, '\p{Is_Blk=copticepactnumbers}', "");
    Expect(0, 66303, '\p{^Is_Blk=copticepactnumbers}', "");
    Expect(0, 66303, '\P{Is_Blk=copticepactnumbers}', "");
    Expect(1, 66303, '\P{^Is_Blk=copticepactnumbers}', "");
    Expect(0, 66304, '\p{Is_Blk=copticepactnumbers}', "");
    Expect(1, 66304, '\p{^Is_Blk=copticepactnumbers}', "");
    Expect(1, 66304, '\P{Is_Blk=copticepactnumbers}', "");
    Expect(0, 66304, '\P{^Is_Blk=copticepactnumbers}', "");
    Expect(1, 66303, '\p{Is_Blk=_COPTIC_Epact_Numbers}', "");
    Expect(0, 66303, '\p{^Is_Blk=_COPTIC_Epact_Numbers}', "");
    Expect(0, 66303, '\P{Is_Blk=_COPTIC_Epact_Numbers}', "");
    Expect(1, 66303, '\P{^Is_Blk=_COPTIC_Epact_Numbers}', "");
    Expect(0, 66304, '\p{Is_Blk=_COPTIC_Epact_Numbers}', "");
    Expect(1, 66304, '\p{^Is_Blk=_COPTIC_Epact_Numbers}', "");
    Expect(1, 66304, '\P{Is_Blk=_COPTIC_Epact_Numbers}', "");
    Expect(0, 66304, '\P{^Is_Blk=_COPTIC_Epact_Numbers}', "");
    Error('\p{Block=:= 	Counting_Rod_Numerals}');
    Error('\P{Block=:= 	Counting_Rod_Numerals}');
    Expect(1, 119679, '\p{Block=countingrodnumerals}', "");
    Expect(0, 119679, '\p{^Block=countingrodnumerals}', "");
    Expect(0, 119679, '\P{Block=countingrodnumerals}', "");
    Expect(1, 119679, '\P{^Block=countingrodnumerals}', "");
    Expect(0, 119680, '\p{Block=countingrodnumerals}', "");
    Expect(1, 119680, '\p{^Block=countingrodnumerals}', "");
    Expect(1, 119680, '\P{Block=countingrodnumerals}', "");
    Expect(0, 119680, '\P{^Block=countingrodnumerals}', "");
    Expect(1, 119679, '\p{Block=_counting_Rod_NUMERALS}', "");
    Expect(0, 119679, '\p{^Block=_counting_Rod_NUMERALS}', "");
    Expect(0, 119679, '\P{Block=_counting_Rod_NUMERALS}', "");
    Expect(1, 119679, '\P{^Block=_counting_Rod_NUMERALS}', "");
    Expect(0, 119680, '\p{Block=_counting_Rod_NUMERALS}', "");
    Expect(1, 119680, '\p{^Block=_counting_Rod_NUMERALS}', "");
    Expect(1, 119680, '\P{Block=_counting_Rod_NUMERALS}', "");
    Expect(0, 119680, '\P{^Block=_counting_Rod_NUMERALS}', "");
    Error('\p{Blk= Counting_Rod:=}');
    Error('\P{Blk= Counting_Rod:=}');
    Expect(1, 119679, '\p{Blk=countingrod}', "");
    Expect(0, 119679, '\p{^Blk=countingrod}', "");
    Expect(0, 119679, '\P{Blk=countingrod}', "");
    Expect(1, 119679, '\P{^Blk=countingrod}', "");
    Expect(0, 119680, '\p{Blk=countingrod}', "");
    Expect(1, 119680, '\p{^Blk=countingrod}', "");
    Expect(1, 119680, '\P{Blk=countingrod}', "");
    Expect(0, 119680, '\P{^Blk=countingrod}', "");
    Expect(1, 119679, '\p{Blk=	counting_Rod}', "");
    Expect(0, 119679, '\p{^Blk=	counting_Rod}', "");
    Expect(0, 119679, '\P{Blk=	counting_Rod}', "");
    Expect(1, 119679, '\P{^Blk=	counting_Rod}', "");
    Expect(0, 119680, '\p{Blk=	counting_Rod}', "");
    Expect(1, 119680, '\p{^Blk=	counting_Rod}', "");
    Expect(1, 119680, '\P{Blk=	counting_Rod}', "");
    Expect(0, 119680, '\P{^Blk=	counting_Rod}', "");
    Error('\p{Is_Block:	:=	COUNTING_rod_numerals}');
    Error('\P{Is_Block:	:=	COUNTING_rod_numerals}');
    Expect(1, 119679, '\p{Is_Block=countingrodnumerals}', "");
    Expect(0, 119679, '\p{^Is_Block=countingrodnumerals}', "");
    Expect(0, 119679, '\P{Is_Block=countingrodnumerals}', "");
    Expect(1, 119679, '\P{^Is_Block=countingrodnumerals}', "");
    Expect(0, 119680, '\p{Is_Block=countingrodnumerals}', "");
    Expect(1, 119680, '\p{^Is_Block=countingrodnumerals}', "");
    Expect(1, 119680, '\P{Is_Block=countingrodnumerals}', "");
    Expect(0, 119680, '\P{^Is_Block=countingrodnumerals}', "");
    Expect(1, 119679, '\p{Is_Block=counting_ROD_Numerals}', "");
    Expect(0, 119679, '\p{^Is_Block=counting_ROD_Numerals}', "");
    Expect(0, 119679, '\P{Is_Block=counting_ROD_Numerals}', "");
    Expect(1, 119679, '\P{^Is_Block=counting_ROD_Numerals}', "");
    Expect(0, 119680, '\p{Is_Block=counting_ROD_Numerals}', "");
    Expect(1, 119680, '\p{^Is_Block=counting_ROD_Numerals}', "");
    Expect(1, 119680, '\P{Is_Block=counting_ROD_Numerals}', "");
    Expect(0, 119680, '\P{^Is_Block=counting_ROD_Numerals}', "");
    Error('\p{Is_Blk=	Counting_ROD/a/}');
    Error('\P{Is_Blk=	Counting_ROD/a/}');
    Expect(1, 119679, '\p{Is_Blk=countingrod}', "");
    Expect(0, 119679, '\p{^Is_Blk=countingrod}', "");
    Expect(0, 119679, '\P{Is_Blk=countingrod}', "");
    Expect(1, 119679, '\P{^Is_Blk=countingrod}', "");
    Expect(0, 119680, '\p{Is_Blk=countingrod}', "");
    Expect(1, 119680, '\p{^Is_Blk=countingrod}', "");
    Expect(1, 119680, '\P{Is_Blk=countingrod}', "");
    Expect(0, 119680, '\P{^Is_Blk=countingrod}', "");
    Expect(1, 119679, '\p{Is_Blk=-_counting_Rod}', "");
    Expect(0, 119679, '\p{^Is_Blk=-_counting_Rod}', "");
    Expect(0, 119679, '\P{Is_Blk=-_counting_Rod}', "");
    Expect(1, 119679, '\P{^Is_Blk=-_counting_Rod}', "");
    Expect(0, 119680, '\p{Is_Blk=-_counting_Rod}', "");
    Expect(1, 119680, '\p{^Is_Blk=-_counting_Rod}', "");
    Expect(1, 119680, '\P{Is_Blk=-_counting_Rod}', "");
    Expect(0, 119680, '\P{^Is_Blk=-_counting_Rod}', "");
    Error('\p{Block=__CUNEIFORM/a/}');
    Error('\P{Block=__CUNEIFORM/a/}');
    Expect(1, 74751, '\p{Block=cuneiform}', "");
    Expect(0, 74751, '\p{^Block=cuneiform}', "");
    Expect(0, 74751, '\P{Block=cuneiform}', "");
    Expect(1, 74751, '\P{^Block=cuneiform}', "");
    Expect(0, 74752, '\p{Block=cuneiform}', "");
    Expect(1, 74752, '\p{^Block=cuneiform}', "");
    Expect(1, 74752, '\P{Block=cuneiform}', "");
    Expect(0, 74752, '\P{^Block=cuneiform}', "");
    Expect(1, 74751, '\p{Block=Cuneiform}', "");
    Expect(0, 74751, '\p{^Block=Cuneiform}', "");
    Expect(0, 74751, '\P{Block=Cuneiform}', "");
    Expect(1, 74751, '\P{^Block=Cuneiform}', "");
    Expect(0, 74752, '\p{Block=Cuneiform}', "");
    Expect(1, 74752, '\p{^Block=Cuneiform}', "");
    Expect(1, 74752, '\P{Block=Cuneiform}', "");
    Expect(0, 74752, '\P{^Block=Cuneiform}', "");
    Error('\p{Blk=	:=cuneiform}');
    Error('\P{Blk=	:=cuneiform}');
    Expect(1, 74751, '\p{Blk=cuneiform}', "");
    Expect(0, 74751, '\p{^Blk=cuneiform}', "");
    Expect(0, 74751, '\P{Blk=cuneiform}', "");
    Expect(1, 74751, '\P{^Blk=cuneiform}', "");
    Expect(0, 74752, '\p{Blk=cuneiform}', "");
    Expect(1, 74752, '\p{^Blk=cuneiform}', "");
    Expect(1, 74752, '\P{Blk=cuneiform}', "");
    Expect(0, 74752, '\P{^Blk=cuneiform}', "");
    Expect(1, 74751, '\p{Blk= cuneiform}', "");
    Expect(0, 74751, '\p{^Blk= cuneiform}', "");
    Expect(0, 74751, '\P{Blk= cuneiform}', "");
    Expect(1, 74751, '\P{^Blk= cuneiform}', "");
    Expect(0, 74752, '\p{Blk= cuneiform}', "");
    Expect(1, 74752, '\p{^Blk= cuneiform}', "");
    Expect(1, 74752, '\P{Blk= cuneiform}', "");
    Expect(0, 74752, '\P{^Blk= cuneiform}', "");
    Error('\p{Is_Block=/a/ 	Cuneiform}');
    Error('\P{Is_Block=/a/ 	Cuneiform}');
    Expect(1, 74751, '\p{Is_Block=cuneiform}', "");
    Expect(0, 74751, '\p{^Is_Block=cuneiform}', "");
    Expect(0, 74751, '\P{Is_Block=cuneiform}', "");
    Expect(1, 74751, '\P{^Is_Block=cuneiform}', "");
    Expect(0, 74752, '\p{Is_Block=cuneiform}', "");
    Expect(1, 74752, '\p{^Is_Block=cuneiform}', "");
    Expect(1, 74752, '\P{Is_Block=cuneiform}', "");
    Expect(0, 74752, '\P{^Is_Block=cuneiform}', "");
    Expect(1, 74751, '\p{Is_Block=-cuneiform}', "");
    Expect(0, 74751, '\p{^Is_Block=-cuneiform}', "");
    Expect(0, 74751, '\P{Is_Block=-cuneiform}', "");
    Expect(1, 74751, '\P{^Is_Block=-cuneiform}', "");
    Expect(0, 74752, '\p{Is_Block=-cuneiform}', "");
    Expect(1, 74752, '\p{^Is_Block=-cuneiform}', "");
    Expect(1, 74752, '\P{Is_Block=-cuneiform}', "");
    Expect(0, 74752, '\P{^Is_Block=-cuneiform}', "");
    Error('\p{Is_Blk=:=-cuneiform}');
    Error('\P{Is_Blk=:=-cuneiform}');
    Expect(1, 74751, '\p{Is_Blk=cuneiform}', "");
    Expect(0, 74751, '\p{^Is_Blk=cuneiform}', "");
    Expect(0, 74751, '\P{Is_Blk=cuneiform}', "");
    Expect(1, 74751, '\P{^Is_Blk=cuneiform}', "");
    Expect(0, 74752, '\p{Is_Blk=cuneiform}', "");
    Expect(1, 74752, '\p{^Is_Blk=cuneiform}', "");
    Expect(1, 74752, '\P{Is_Blk=cuneiform}', "");
    Expect(0, 74752, '\P{^Is_Blk=cuneiform}', "");
    Expect(1, 74751, '\p{Is_Blk=_-cuneiform}', "");
    Expect(0, 74751, '\p{^Is_Blk=_-cuneiform}', "");
    Expect(0, 74751, '\P{Is_Blk=_-cuneiform}', "");
    Expect(1, 74751, '\P{^Is_Blk=_-cuneiform}', "");
    Expect(0, 74752, '\p{Is_Blk=_-cuneiform}', "");
    Expect(1, 74752, '\p{^Is_Blk=_-cuneiform}', "");
    Expect(1, 74752, '\P{Is_Blk=_-cuneiform}', "");
    Expect(0, 74752, '\P{^Is_Blk=_-cuneiform}', "");
    Error('\p{Block=_-Cuneiform_NUMBERS_and_Punctuation/a/}');
    Error('\P{Block=_-Cuneiform_NUMBERS_and_Punctuation/a/}');
    Expect(1, 74879, '\p{Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\p{^Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\P{Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\P{^Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\p{Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\p{^Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\P{Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\P{^Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\p{Block:   _CUNEIFORM_Numbers_And_Punctuation}', "");
    Expect(0, 74879, '\p{^Block:   _CUNEIFORM_Numbers_And_Punctuation}', "");
    Expect(0, 74879, '\P{Block:   _CUNEIFORM_Numbers_And_Punctuation}', "");
    Expect(1, 74879, '\P{^Block:   _CUNEIFORM_Numbers_And_Punctuation}', "");
    Expect(0, 74880, '\p{Block:   _CUNEIFORM_Numbers_And_Punctuation}', "");
    Expect(1, 74880, '\p{^Block:   _CUNEIFORM_Numbers_And_Punctuation}', "");
    Expect(1, 74880, '\P{Block:   _CUNEIFORM_Numbers_And_Punctuation}', "");
    Expect(0, 74880, '\P{^Block:   _CUNEIFORM_Numbers_And_Punctuation}', "");
    Error('\p{Blk=_/a/Cuneiform_Numbers}');
    Error('\P{Blk=_/a/Cuneiform_Numbers}');
    Expect(1, 74879, '\p{Blk=cuneiformnumbers}', "");
    Expect(0, 74879, '\p{^Blk=cuneiformnumbers}', "");
    Expect(0, 74879, '\P{Blk=cuneiformnumbers}', "");
    Expect(1, 74879, '\P{^Blk=cuneiformnumbers}', "");
    Expect(0, 74880, '\p{Blk=cuneiformnumbers}', "");
    Expect(1, 74880, '\p{^Blk=cuneiformnumbers}', "");
    Expect(1, 74880, '\P{Blk=cuneiformnumbers}', "");
    Expect(0, 74880, '\P{^Blk=cuneiformnumbers}', "");
    Expect(1, 74879, '\p{Blk=__cuneiform_Numbers}', "");
    Expect(0, 74879, '\p{^Blk=__cuneiform_Numbers}', "");
    Expect(0, 74879, '\P{Blk=__cuneiform_Numbers}', "");
    Expect(1, 74879, '\P{^Blk=__cuneiform_Numbers}', "");
    Expect(0, 74880, '\p{Blk=__cuneiform_Numbers}', "");
    Expect(1, 74880, '\p{^Blk=__cuneiform_Numbers}', "");
    Expect(1, 74880, '\P{Blk=__cuneiform_Numbers}', "");
    Expect(0, 74880, '\P{^Blk=__cuneiform_Numbers}', "");
    Error('\p{Is_Block=	/a/CUNEIFORM_NUMBERS_And_PUNCTUATION}');
    Error('\P{Is_Block=	/a/CUNEIFORM_NUMBERS_And_PUNCTUATION}');
    Expect(1, 74879, '\p{Is_Block:	cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\p{^Is_Block:	cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\P{Is_Block:	cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\P{^Is_Block:	cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\p{Is_Block:	cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\p{^Is_Block:	cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\P{Is_Block:	cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\P{^Is_Block:	cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\p{Is_Block=_CUNEIFORM_Numbers_and_punctuation}', "");
    Expect(0, 74879, '\p{^Is_Block=_CUNEIFORM_Numbers_and_punctuation}', "");
    Expect(0, 74879, '\P{Is_Block=_CUNEIFORM_Numbers_and_punctuation}', "");
    Expect(1, 74879, '\P{^Is_Block=_CUNEIFORM_Numbers_and_punctuation}', "");
    Expect(0, 74880, '\p{Is_Block=_CUNEIFORM_Numbers_and_punctuation}', "");
    Expect(1, 74880, '\p{^Is_Block=_CUNEIFORM_Numbers_and_punctuation}', "");
    Expect(1, 74880, '\P{Is_Block=_CUNEIFORM_Numbers_and_punctuation}', "");
    Expect(0, 74880, '\P{^Is_Block=_CUNEIFORM_Numbers_and_punctuation}', "");
    Error('\p{Is_Blk=	Cuneiform_Numbers:=}');
    Error('\P{Is_Blk=	Cuneiform_Numbers:=}');
    Expect(1, 74879, '\p{Is_Blk=cuneiformnumbers}', "");
    Expect(0, 74879, '\p{^Is_Blk=cuneiformnumbers}', "");
    Expect(0, 74879, '\P{Is_Blk=cuneiformnumbers}', "");
    Expect(1, 74879, '\P{^Is_Blk=cuneiformnumbers}', "");
    Expect(0, 74880, '\p{Is_Blk=cuneiformnumbers}', "");
    Expect(1, 74880, '\p{^Is_Blk=cuneiformnumbers}', "");
    Expect(1, 74880, '\P{Is_Blk=cuneiformnumbers}', "");
    Expect(0, 74880, '\P{^Is_Blk=cuneiformnumbers}', "");
    Expect(1, 74879, '\p{Is_Blk=_ Cuneiform_Numbers}', "");
    Expect(0, 74879, '\p{^Is_Blk=_ Cuneiform_Numbers}', "");
    Expect(0, 74879, '\P{Is_Blk=_ Cuneiform_Numbers}', "");
    Expect(1, 74879, '\P{^Is_Blk=_ Cuneiform_Numbers}', "");
    Expect(0, 74880, '\p{Is_Blk=_ Cuneiform_Numbers}', "");
    Expect(1, 74880, '\p{^Is_Blk=_ Cuneiform_Numbers}', "");
    Expect(1, 74880, '\P{Is_Blk=_ Cuneiform_Numbers}', "");
    Expect(0, 74880, '\P{^Is_Blk=_ Cuneiform_Numbers}', "");
    Error('\p{Block=__currency_Symbols/a/}');
    Error('\P{Block=__currency_Symbols/a/}');
    Expect(1, 8399, '\p{Block=currencysymbols}', "");
    Expect(0, 8399, '\p{^Block=currencysymbols}', "");
    Expect(0, 8399, '\P{Block=currencysymbols}', "");
    Expect(1, 8399, '\P{^Block=currencysymbols}', "");
    Expect(0, 8400, '\p{Block=currencysymbols}', "");
    Expect(1, 8400, '\p{^Block=currencysymbols}', "");
    Expect(1, 8400, '\P{Block=currencysymbols}', "");
    Expect(0, 8400, '\P{^Block=currencysymbols}', "");
    Expect(1, 8399, '\p{Block=--Currency_Symbols}', "");
    Expect(0, 8399, '\p{^Block=--Currency_Symbols}', "");
    Expect(0, 8399, '\P{Block=--Currency_Symbols}', "");
    Expect(1, 8399, '\P{^Block=--Currency_Symbols}', "");
    Expect(0, 8400, '\p{Block=--Currency_Symbols}', "");
    Expect(1, 8400, '\p{^Block=--Currency_Symbols}', "");
    Expect(1, 8400, '\P{Block=--Currency_Symbols}', "");
    Expect(0, 8400, '\P{^Block=--Currency_Symbols}', "");
    Error('\p{Blk=	CURRENCY_Symbols/a/}');
    Error('\P{Blk=	CURRENCY_Symbols/a/}');
    Expect(1, 8399, '\p{Blk=currencysymbols}', "");
    Expect(0, 8399, '\p{^Blk=currencysymbols}', "");
    Expect(0, 8399, '\P{Blk=currencysymbols}', "");
    Expect(1, 8399, '\P{^Blk=currencysymbols}', "");
    Expect(0, 8400, '\p{Blk=currencysymbols}', "");
    Expect(1, 8400, '\p{^Blk=currencysymbols}', "");
    Expect(1, 8400, '\P{Blk=currencysymbols}', "");
    Expect(0, 8400, '\P{^Blk=currencysymbols}', "");
    Expect(1, 8399, '\p{Blk= Currency_Symbols}', "");
    Expect(0, 8399, '\p{^Blk= Currency_Symbols}', "");
    Expect(0, 8399, '\P{Blk= Currency_Symbols}', "");
    Expect(1, 8399, '\P{^Blk= Currency_Symbols}', "");
    Expect(0, 8400, '\p{Blk= Currency_Symbols}', "");
    Expect(1, 8400, '\p{^Blk= Currency_Symbols}', "");
    Expect(1, 8400, '\P{Blk= Currency_Symbols}', "");
    Expect(0, 8400, '\P{^Blk= Currency_Symbols}', "");
    Error('\p{Is_Block= /a/CURRENCY_symbols}');
    Error('\P{Is_Block= /a/CURRENCY_symbols}');
    Expect(1, 8399, '\p{Is_Block=currencysymbols}', "");
    Expect(0, 8399, '\p{^Is_Block=currencysymbols}', "");
    Expect(0, 8399, '\P{Is_Block=currencysymbols}', "");
    Expect(1, 8399, '\P{^Is_Block=currencysymbols}', "");
    Expect(0, 8400, '\p{Is_Block=currencysymbols}', "");
    Expect(1, 8400, '\p{^Is_Block=currencysymbols}', "");
    Expect(1, 8400, '\P{Is_Block=currencysymbols}', "");
    Expect(0, 8400, '\P{^Is_Block=currencysymbols}', "");
    Expect(1, 8399, '\p{Is_Block=_	currency_symbols}', "");
    Expect(0, 8399, '\p{^Is_Block=_	currency_symbols}', "");
    Expect(0, 8399, '\P{Is_Block=_	currency_symbols}', "");
    Expect(1, 8399, '\P{^Is_Block=_	currency_symbols}', "");
    Expect(0, 8400, '\p{Is_Block=_	currency_symbols}', "");
    Expect(1, 8400, '\p{^Is_Block=_	currency_symbols}', "");
    Expect(1, 8400, '\P{Is_Block=_	currency_symbols}', "");
    Expect(0, 8400, '\P{^Is_Block=_	currency_symbols}', "");
    Error('\p{Is_Blk:   _	Currency_symbols/a/}');
    Error('\P{Is_Blk:   _	Currency_symbols/a/}');
    Expect(1, 8399, '\p{Is_Blk=currencysymbols}', "");
    Expect(0, 8399, '\p{^Is_Blk=currencysymbols}', "");
    Expect(0, 8399, '\P{Is_Blk=currencysymbols}', "");
    Expect(1, 8399, '\P{^Is_Blk=currencysymbols}', "");
    Expect(0, 8400, '\p{Is_Blk=currencysymbols}', "");
    Expect(1, 8400, '\p{^Is_Blk=currencysymbols}', "");
    Expect(1, 8400, '\P{Is_Blk=currencysymbols}', "");
    Expect(0, 8400, '\P{^Is_Blk=currencysymbols}', "");
    Expect(1, 8399, '\p{Is_Blk=_CURRENCY_Symbols}', "");
    Expect(0, 8399, '\p{^Is_Blk=_CURRENCY_Symbols}', "");
    Expect(0, 8399, '\P{Is_Blk=_CURRENCY_Symbols}', "");
    Expect(1, 8399, '\P{^Is_Blk=_CURRENCY_Symbols}', "");
    Expect(0, 8400, '\p{Is_Blk=_CURRENCY_Symbols}', "");
    Expect(1, 8400, '\p{^Is_Blk=_CURRENCY_Symbols}', "");
    Expect(1, 8400, '\P{Is_Blk=_CURRENCY_Symbols}', "");
    Expect(0, 8400, '\P{^Is_Blk=_CURRENCY_Symbols}', "");
    Error('\p{Block= _Cypriot_Syllabary/a/}');
    Error('\P{Block= _Cypriot_Syllabary/a/}');
    Expect(1, 67647, '\p{Block=cypriotsyllabary}', "");
    Expect(0, 67647, '\p{^Block=cypriotsyllabary}', "");
    Expect(0, 67647, '\P{Block=cypriotsyllabary}', "");
    Expect(1, 67647, '\P{^Block=cypriotsyllabary}', "");
    Expect(0, 67648, '\p{Block=cypriotsyllabary}', "");
    Expect(1, 67648, '\p{^Block=cypriotsyllabary}', "");
    Expect(1, 67648, '\P{Block=cypriotsyllabary}', "");
    Expect(0, 67648, '\P{^Block=cypriotsyllabary}', "");
    Expect(1, 67647, '\p{Block=	_cypriot_Syllabary}', "");
    Expect(0, 67647, '\p{^Block=	_cypriot_Syllabary}', "");
    Expect(0, 67647, '\P{Block=	_cypriot_Syllabary}', "");
    Expect(1, 67647, '\P{^Block=	_cypriot_Syllabary}', "");
    Expect(0, 67648, '\p{Block=	_cypriot_Syllabary}', "");
    Expect(1, 67648, '\p{^Block=	_cypriot_Syllabary}', "");
    Expect(1, 67648, '\P{Block=	_cypriot_Syllabary}', "");
    Expect(0, 67648, '\P{^Block=	_cypriot_Syllabary}', "");
    Error('\p{Blk=:=Cypriot_Syllabary}');
    Error('\P{Blk=:=Cypriot_Syllabary}');
    Expect(1, 67647, '\p{Blk=cypriotsyllabary}', "");
    Expect(0, 67647, '\p{^Blk=cypriotsyllabary}', "");
    Expect(0, 67647, '\P{Blk=cypriotsyllabary}', "");
    Expect(1, 67647, '\P{^Blk=cypriotsyllabary}', "");
    Expect(0, 67648, '\p{Blk=cypriotsyllabary}', "");
    Expect(1, 67648, '\p{^Blk=cypriotsyllabary}', "");
    Expect(1, 67648, '\P{Blk=cypriotsyllabary}', "");
    Expect(0, 67648, '\P{^Blk=cypriotsyllabary}', "");
    Expect(1, 67647, '\p{Blk: 	_CYPRIOT_syllabary}', "");
    Expect(0, 67647, '\p{^Blk: 	_CYPRIOT_syllabary}', "");
    Expect(0, 67647, '\P{Blk: 	_CYPRIOT_syllabary}', "");
    Expect(1, 67647, '\P{^Blk: 	_CYPRIOT_syllabary}', "");
    Expect(0, 67648, '\p{Blk: 	_CYPRIOT_syllabary}', "");
    Expect(1, 67648, '\p{^Blk: 	_CYPRIOT_syllabary}', "");
    Expect(1, 67648, '\P{Blk: 	_CYPRIOT_syllabary}', "");
    Expect(0, 67648, '\P{^Blk: 	_CYPRIOT_syllabary}', "");
    Error('\p{Is_Block= cypriot_syllabary/a/}');
    Error('\P{Is_Block= cypriot_syllabary/a/}');
    Expect(1, 67647, '\p{Is_Block=cypriotsyllabary}', "");
    Expect(0, 67647, '\p{^Is_Block=cypriotsyllabary}', "");
    Expect(0, 67647, '\P{Is_Block=cypriotsyllabary}', "");
    Expect(1, 67647, '\P{^Is_Block=cypriotsyllabary}', "");
    Expect(0, 67648, '\p{Is_Block=cypriotsyllabary}', "");
    Expect(1, 67648, '\p{^Is_Block=cypriotsyllabary}', "");
    Expect(1, 67648, '\P{Is_Block=cypriotsyllabary}', "");
    Expect(0, 67648, '\P{^Is_Block=cypriotsyllabary}', "");
    Expect(1, 67647, '\p{Is_Block=-_Cypriot_Syllabary}', "");
    Expect(0, 67647, '\p{^Is_Block=-_Cypriot_Syllabary}', "");
    Expect(0, 67647, '\P{Is_Block=-_Cypriot_Syllabary}', "");
    Expect(1, 67647, '\P{^Is_Block=-_Cypriot_Syllabary}', "");
    Expect(0, 67648, '\p{Is_Block=-_Cypriot_Syllabary}', "");
    Expect(1, 67648, '\p{^Is_Block=-_Cypriot_Syllabary}', "");
    Expect(1, 67648, '\P{Is_Block=-_Cypriot_Syllabary}', "");
    Expect(0, 67648, '\P{^Is_Block=-_Cypriot_Syllabary}', "");
    Error('\p{Is_Blk=-/a/Cypriot_SYLLABARY}');
    Error('\P{Is_Blk=-/a/Cypriot_SYLLABARY}');
    Expect(1, 67647, '\p{Is_Blk=cypriotsyllabary}', "");
    Expect(0, 67647, '\p{^Is_Blk=cypriotsyllabary}', "");
    Expect(0, 67647, '\P{Is_Blk=cypriotsyllabary}', "");
    Expect(1, 67647, '\P{^Is_Blk=cypriotsyllabary}', "");
    Expect(0, 67648, '\p{Is_Blk=cypriotsyllabary}', "");
    Expect(1, 67648, '\p{^Is_Blk=cypriotsyllabary}', "");
    Expect(1, 67648, '\P{Is_Blk=cypriotsyllabary}', "");
    Expect(0, 67648, '\P{^Is_Blk=cypriotsyllabary}', "");
    Expect(1, 67647, '\p{Is_Blk=CYPRIOT_syllabary}', "");
    Expect(0, 67647, '\p{^Is_Blk=CYPRIOT_syllabary}', "");
    Expect(0, 67647, '\P{Is_Blk=CYPRIOT_syllabary}', "");
    Expect(1, 67647, '\P{^Is_Blk=CYPRIOT_syllabary}', "");
    Expect(0, 67648, '\p{Is_Blk=CYPRIOT_syllabary}', "");
    Expect(1, 67648, '\p{^Is_Blk=CYPRIOT_syllabary}', "");
    Expect(1, 67648, '\P{Is_Blk=CYPRIOT_syllabary}', "");
    Expect(0, 67648, '\P{^Is_Blk=CYPRIOT_syllabary}', "");
    Error('\p{Block=	:=cyrillic}');
    Error('\P{Block=	:=cyrillic}');
    Expect(1, 1279, '\p{Block=cyrillic}', "");
    Expect(0, 1279, '\p{^Block=cyrillic}', "");
    Expect(0, 1279, '\P{Block=cyrillic}', "");
    Expect(1, 1279, '\P{^Block=cyrillic}', "");
    Expect(0, 1280, '\p{Block=cyrillic}', "");
    Expect(1, 1280, '\p{^Block=cyrillic}', "");
    Expect(1, 1280, '\P{Block=cyrillic}', "");
    Expect(0, 1280, '\P{^Block=cyrillic}', "");
    Expect(1, 1279, '\p{Block=-	CYRILLIC}', "");
    Expect(0, 1279, '\p{^Block=-	CYRILLIC}', "");
    Expect(0, 1279, '\P{Block=-	CYRILLIC}', "");
    Expect(1, 1279, '\P{^Block=-	CYRILLIC}', "");
    Expect(0, 1280, '\p{Block=-	CYRILLIC}', "");
    Expect(1, 1280, '\p{^Block=-	CYRILLIC}', "");
    Expect(1, 1280, '\P{Block=-	CYRILLIC}', "");
    Expect(0, 1280, '\P{^Block=-	CYRILLIC}', "");
    Error('\p{Blk:		:=Cyrillic}');
    Error('\P{Blk:		:=Cyrillic}');
    Expect(1, 1279, '\p{Blk=cyrillic}', "");
    Expect(0, 1279, '\p{^Blk=cyrillic}', "");
    Expect(0, 1279, '\P{Blk=cyrillic}', "");
    Expect(1, 1279, '\P{^Blk=cyrillic}', "");
    Expect(0, 1280, '\p{Blk=cyrillic}', "");
    Expect(1, 1280, '\p{^Blk=cyrillic}', "");
    Expect(1, 1280, '\P{Blk=cyrillic}', "");
    Expect(0, 1280, '\P{^Blk=cyrillic}', "");
    Expect(1, 1279, '\p{Blk=_CYRILLIC}', "");
    Expect(0, 1279, '\p{^Blk=_CYRILLIC}', "");
    Expect(0, 1279, '\P{Blk=_CYRILLIC}', "");
    Expect(1, 1279, '\P{^Blk=_CYRILLIC}', "");
    Expect(0, 1280, '\p{Blk=_CYRILLIC}', "");
    Expect(1, 1280, '\p{^Blk=_CYRILLIC}', "");
    Expect(1, 1280, '\P{Blk=_CYRILLIC}', "");
    Expect(0, 1280, '\P{^Blk=_CYRILLIC}', "");
    Error('\p{Is_Block=-/a/cyrillic}');
    Error('\P{Is_Block=-/a/cyrillic}');
    Expect(1, 1279, '\p{Is_Block:	cyrillic}', "");
    Expect(0, 1279, '\p{^Is_Block:	cyrillic}', "");
    Expect(0, 1279, '\P{Is_Block:	cyrillic}', "");
    Expect(1, 1279, '\P{^Is_Block:	cyrillic}', "");
    Expect(0, 1280, '\p{Is_Block:	cyrillic}', "");
    Expect(1, 1280, '\p{^Is_Block:	cyrillic}', "");
    Expect(1, 1280, '\P{Is_Block:	cyrillic}', "");
    Expect(0, 1280, '\P{^Is_Block:	cyrillic}', "");
    Expect(1, 1279, '\p{Is_Block= -Cyrillic}', "");
    Expect(0, 1279, '\p{^Is_Block= -Cyrillic}', "");
    Expect(0, 1279, '\P{Is_Block= -Cyrillic}', "");
    Expect(1, 1279, '\P{^Is_Block= -Cyrillic}', "");
    Expect(0, 1280, '\p{Is_Block= -Cyrillic}', "");
    Expect(1, 1280, '\p{^Is_Block= -Cyrillic}', "");
    Expect(1, 1280, '\P{Is_Block= -Cyrillic}', "");
    Expect(0, 1280, '\P{^Is_Block= -Cyrillic}', "");
    Error('\p{Is_Blk= 	Cyrillic/a/}');
    Error('\P{Is_Blk= 	Cyrillic/a/}');
    Expect(1, 1279, '\p{Is_Blk=cyrillic}', "");
    Expect(0, 1279, '\p{^Is_Blk=cyrillic}', "");
    Expect(0, 1279, '\P{Is_Blk=cyrillic}', "");
    Expect(1, 1279, '\P{^Is_Blk=cyrillic}', "");
    Expect(0, 1280, '\p{Is_Blk=cyrillic}', "");
    Expect(1, 1280, '\p{^Is_Blk=cyrillic}', "");
    Expect(1, 1280, '\P{Is_Blk=cyrillic}', "");
    Expect(0, 1280, '\P{^Is_Blk=cyrillic}', "");
    Expect(1, 1279, '\p{Is_Blk=--cyrillic}', "");
    Expect(0, 1279, '\p{^Is_Blk=--cyrillic}', "");
    Expect(0, 1279, '\P{Is_Blk=--cyrillic}', "");
    Expect(1, 1279, '\P{^Is_Blk=--cyrillic}', "");
    Expect(0, 1280, '\p{Is_Blk=--cyrillic}', "");
    Expect(1, 1280, '\p{^Is_Blk=--cyrillic}', "");
    Expect(1, 1280, '\P{Is_Blk=--cyrillic}', "");
    Expect(0, 1280, '\P{^Is_Blk=--cyrillic}', "");
    Error('\p{Block:   :=_-cyrillic_extended_A}');
    Error('\P{Block:   :=_-cyrillic_extended_A}');
    Expect(1, 11775, '\p{Block=cyrillicextendeda}', "");
    Expect(0, 11775, '\p{^Block=cyrillicextendeda}', "");
    Expect(0, 11775, '\P{Block=cyrillicextendeda}', "");
    Expect(1, 11775, '\P{^Block=cyrillicextendeda}', "");
    Expect(0, 11776, '\p{Block=cyrillicextendeda}', "");
    Expect(1, 11776, '\p{^Block=cyrillicextendeda}', "");
    Expect(1, 11776, '\P{Block=cyrillicextendeda}', "");
    Expect(0, 11776, '\P{^Block=cyrillicextendeda}', "");
    Expect(1, 11775, '\p{Block=- Cyrillic_Extended_A}', "");
    Expect(0, 11775, '\p{^Block=- Cyrillic_Extended_A}', "");
    Expect(0, 11775, '\P{Block=- Cyrillic_Extended_A}', "");
    Expect(1, 11775, '\P{^Block=- Cyrillic_Extended_A}', "");
    Expect(0, 11776, '\p{Block=- Cyrillic_Extended_A}', "");
    Expect(1, 11776, '\p{^Block=- Cyrillic_Extended_A}', "");
    Expect(1, 11776, '\P{Block=- Cyrillic_Extended_A}', "");
    Expect(0, 11776, '\P{^Block=- Cyrillic_Extended_A}', "");
    Error('\p{Blk=-	CYRILLIC_ext_A:=}');
    Error('\P{Blk=-	CYRILLIC_ext_A:=}');
    Expect(1, 11775, '\p{Blk=cyrillicexta}', "");
    Expect(0, 11775, '\p{^Blk=cyrillicexta}', "");
    Expect(0, 11775, '\P{Blk=cyrillicexta}', "");
    Expect(1, 11775, '\P{^Blk=cyrillicexta}', "");
    Expect(0, 11776, '\p{Blk=cyrillicexta}', "");
    Expect(1, 11776, '\p{^Blk=cyrillicexta}', "");
    Expect(1, 11776, '\P{Blk=cyrillicexta}', "");
    Expect(0, 11776, '\P{^Blk=cyrillicexta}', "");
    Expect(1, 11775, '\p{Blk=	 cyrillic_EXT_a}', "");
    Expect(0, 11775, '\p{^Blk=	 cyrillic_EXT_a}', "");
    Expect(0, 11775, '\P{Blk=	 cyrillic_EXT_a}', "");
    Expect(1, 11775, '\P{^Blk=	 cyrillic_EXT_a}', "");
    Expect(0, 11776, '\p{Blk=	 cyrillic_EXT_a}', "");
    Expect(1, 11776, '\p{^Blk=	 cyrillic_EXT_a}', "");
    Expect(1, 11776, '\P{Blk=	 cyrillic_EXT_a}', "");
    Expect(0, 11776, '\P{^Blk=	 cyrillic_EXT_a}', "");
    Error('\p{Is_Block:   _	CYRILLIC_Extended_A:=}');
    Error('\P{Is_Block:   _	CYRILLIC_Extended_A:=}');
    Expect(1, 11775, '\p{Is_Block=cyrillicextendeda}', "");
    Expect(0, 11775, '\p{^Is_Block=cyrillicextendeda}', "");
    Expect(0, 11775, '\P{Is_Block=cyrillicextendeda}', "");
    Expect(1, 11775, '\P{^Is_Block=cyrillicextendeda}', "");
    Expect(0, 11776, '\p{Is_Block=cyrillicextendeda}', "");
    Expect(1, 11776, '\p{^Is_Block=cyrillicextendeda}', "");
    Expect(1, 11776, '\P{Is_Block=cyrillicextendeda}', "");
    Expect(0, 11776, '\P{^Is_Block=cyrillicextendeda}', "");
    Expect(1, 11775, '\p{Is_Block= -CYRILLIC_Extended_A}', "");
    Expect(0, 11775, '\p{^Is_Block= -CYRILLIC_Extended_A}', "");
    Expect(0, 11775, '\P{Is_Block= -CYRILLIC_Extended_A}', "");
    Expect(1, 11775, '\P{^Is_Block= -CYRILLIC_Extended_A}', "");
    Expect(0, 11776, '\p{Is_Block= -CYRILLIC_Extended_A}', "");
    Expect(1, 11776, '\p{^Is_Block= -CYRILLIC_Extended_A}', "");
    Expect(1, 11776, '\P{Is_Block= -CYRILLIC_Extended_A}', "");
    Expect(0, 11776, '\P{^Is_Block= -CYRILLIC_Extended_A}', "");
    Error('\p{Is_Blk=	/a/CYRILLIC_Ext_A}');
    Error('\P{Is_Blk=	/a/CYRILLIC_Ext_A}');
    Expect(1, 11775, '\p{Is_Blk=cyrillicexta}', "");
    Expect(0, 11775, '\p{^Is_Blk=cyrillicexta}', "");
    Expect(0, 11775, '\P{Is_Blk=cyrillicexta}', "");
    Expect(1, 11775, '\P{^Is_Blk=cyrillicexta}', "");
    Expect(0, 11776, '\p{Is_Blk=cyrillicexta}', "");
    Expect(1, 11776, '\p{^Is_Blk=cyrillicexta}', "");
    Expect(1, 11776, '\P{Is_Blk=cyrillicexta}', "");
    Expect(0, 11776, '\P{^Is_Blk=cyrillicexta}', "");
    Expect(1, 11775, '\p{Is_Blk=		cyrillic_ext_A}', "");
    Expect(0, 11775, '\p{^Is_Blk=		cyrillic_ext_A}', "");
    Expect(0, 11775, '\P{Is_Blk=		cyrillic_ext_A}', "");
    Expect(1, 11775, '\P{^Is_Blk=		cyrillic_ext_A}', "");
    Expect(0, 11776, '\p{Is_Blk=		cyrillic_ext_A}', "");
    Expect(1, 11776, '\p{^Is_Blk=		cyrillic_ext_A}', "");
    Expect(1, 11776, '\P{Is_Blk=		cyrillic_ext_A}', "");
    Expect(0, 11776, '\P{^Is_Blk=		cyrillic_ext_A}', "");
    Error('\p{Block=-_Cyrillic_extended_B/a/}');
    Error('\P{Block=-_Cyrillic_extended_B/a/}');
    Expect(1, 42655, '\p{Block=cyrillicextendedb}', "");
    Expect(0, 42655, '\p{^Block=cyrillicextendedb}', "");
    Expect(0, 42655, '\P{Block=cyrillicextendedb}', "");
    Expect(1, 42655, '\P{^Block=cyrillicextendedb}', "");
    Expect(0, 42656, '\p{Block=cyrillicextendedb}', "");
    Expect(1, 42656, '\p{^Block=cyrillicextendedb}', "");
    Expect(1, 42656, '\P{Block=cyrillicextendedb}', "");
    Expect(0, 42656, '\P{^Block=cyrillicextendedb}', "");
    Expect(1, 42655, '\p{Block:-	Cyrillic_Extended_B}', "");
    Expect(0, 42655, '\p{^Block:-	Cyrillic_Extended_B}', "");
    Expect(0, 42655, '\P{Block:-	Cyrillic_Extended_B}', "");
    Expect(1, 42655, '\P{^Block:-	Cyrillic_Extended_B}', "");
    Expect(0, 42656, '\p{Block:-	Cyrillic_Extended_B}', "");
    Expect(1, 42656, '\p{^Block:-	Cyrillic_Extended_B}', "");
    Expect(1, 42656, '\P{Block:-	Cyrillic_Extended_B}', "");
    Expect(0, 42656, '\P{^Block:-	Cyrillic_Extended_B}', "");
    Error('\p{Blk=:=	CYRILLIC_Ext_b}');
    Error('\P{Blk=:=	CYRILLIC_Ext_b}');
    Expect(1, 42655, '\p{Blk=cyrillicextb}', "");
    Expect(0, 42655, '\p{^Blk=cyrillicextb}', "");
    Expect(0, 42655, '\P{Blk=cyrillicextb}', "");
    Expect(1, 42655, '\P{^Blk=cyrillicextb}', "");
    Expect(0, 42656, '\p{Blk=cyrillicextb}', "");
    Expect(1, 42656, '\p{^Blk=cyrillicextb}', "");
    Expect(1, 42656, '\P{Blk=cyrillicextb}', "");
    Expect(0, 42656, '\P{^Blk=cyrillicextb}', "");
    Expect(1, 42655, '\p{Blk=_ CYRILLIC_Ext_B}', "");
    Expect(0, 42655, '\p{^Blk=_ CYRILLIC_Ext_B}', "");
    Expect(0, 42655, '\P{Blk=_ CYRILLIC_Ext_B}', "");
    Expect(1, 42655, '\P{^Blk=_ CYRILLIC_Ext_B}', "");
    Expect(0, 42656, '\p{Blk=_ CYRILLIC_Ext_B}', "");
    Expect(1, 42656, '\p{^Blk=_ CYRILLIC_Ext_B}', "");
    Expect(1, 42656, '\P{Blk=_ CYRILLIC_Ext_B}', "");
    Expect(0, 42656, '\P{^Blk=_ CYRILLIC_Ext_B}', "");
    Error('\p{Is_Block=	:=Cyrillic_EXTENDED_B}');
    Error('\P{Is_Block=	:=Cyrillic_EXTENDED_B}');
    Expect(1, 42655, '\p{Is_Block=cyrillicextendedb}', "");
    Expect(0, 42655, '\p{^Is_Block=cyrillicextendedb}', "");
    Expect(0, 42655, '\P{Is_Block=cyrillicextendedb}', "");
    Expect(1, 42655, '\P{^Is_Block=cyrillicextendedb}', "");
    Expect(0, 42656, '\p{Is_Block=cyrillicextendedb}', "");
    Expect(1, 42656, '\p{^Is_Block=cyrillicextendedb}', "");
    Expect(1, 42656, '\P{Is_Block=cyrillicextendedb}', "");
    Expect(0, 42656, '\P{^Is_Block=cyrillicextendedb}', "");
    Expect(1, 42655, '\p{Is_Block=		Cyrillic_EXTENDED_B}', "");
    Expect(0, 42655, '\p{^Is_Block=		Cyrillic_EXTENDED_B}', "");
    Expect(0, 42655, '\P{Is_Block=		Cyrillic_EXTENDED_B}', "");
    Expect(1, 42655, '\P{^Is_Block=		Cyrillic_EXTENDED_B}', "");
    Expect(0, 42656, '\p{Is_Block=		Cyrillic_EXTENDED_B}', "");
    Expect(1, 42656, '\p{^Is_Block=		Cyrillic_EXTENDED_B}', "");
    Expect(1, 42656, '\P{Is_Block=		Cyrillic_EXTENDED_B}', "");
    Expect(0, 42656, '\P{^Is_Block=		Cyrillic_EXTENDED_B}', "");
    Error('\p{Is_Blk=:=	_Cyrillic_EXT_b}');
    Error('\P{Is_Blk=:=	_Cyrillic_EXT_b}');
    Expect(1, 42655, '\p{Is_Blk=cyrillicextb}', "");
    Expect(0, 42655, '\p{^Is_Blk=cyrillicextb}', "");
    Expect(0, 42655, '\P{Is_Blk=cyrillicextb}', "");
    Expect(1, 42655, '\P{^Is_Blk=cyrillicextb}', "");
    Expect(0, 42656, '\p{Is_Blk=cyrillicextb}', "");
    Expect(1, 42656, '\p{^Is_Blk=cyrillicextb}', "");
    Expect(1, 42656, '\P{Is_Blk=cyrillicextb}', "");
    Expect(0, 42656, '\P{^Is_Blk=cyrillicextb}', "");
    Expect(1, 42655, '\p{Is_Blk=-_Cyrillic_EXT_B}', "");
    Expect(0, 42655, '\p{^Is_Blk=-_Cyrillic_EXT_B}', "");
    Expect(0, 42655, '\P{Is_Blk=-_Cyrillic_EXT_B}', "");
    Expect(1, 42655, '\P{^Is_Blk=-_Cyrillic_EXT_B}', "");
    Expect(0, 42656, '\p{Is_Blk=-_Cyrillic_EXT_B}', "");
    Expect(1, 42656, '\p{^Is_Blk=-_Cyrillic_EXT_B}', "");
    Expect(1, 42656, '\P{Is_Blk=-_Cyrillic_EXT_B}', "");
    Expect(0, 42656, '\P{^Is_Blk=-_Cyrillic_EXT_B}', "");
    Error('\p{Block=:= -CYRILLIC_Extended_C}');
    Error('\P{Block=:= -CYRILLIC_Extended_C}');
    Expect(1, 7311, '\p{Block=cyrillicextendedc}', "");
    Expect(0, 7311, '\p{^Block=cyrillicextendedc}', "");
    Expect(0, 7311, '\P{Block=cyrillicextendedc}', "");
    Expect(1, 7311, '\P{^Block=cyrillicextendedc}', "");
    Expect(0, 7312, '\p{Block=cyrillicextendedc}', "");
    Expect(1, 7312, '\p{^Block=cyrillicextendedc}', "");
    Expect(1, 7312, '\P{Block=cyrillicextendedc}', "");
    Expect(0, 7312, '\P{^Block=cyrillicextendedc}', "");
    Expect(1, 7311, '\p{Block=_-CYRILLIC_extended_c}', "");
    Expect(0, 7311, '\p{^Block=_-CYRILLIC_extended_c}', "");
    Expect(0, 7311, '\P{Block=_-CYRILLIC_extended_c}', "");
    Expect(1, 7311, '\P{^Block=_-CYRILLIC_extended_c}', "");
    Expect(0, 7312, '\p{Block=_-CYRILLIC_extended_c}', "");
    Expect(1, 7312, '\p{^Block=_-CYRILLIC_extended_c}', "");
    Expect(1, 7312, '\P{Block=_-CYRILLIC_extended_c}', "");
    Expect(0, 7312, '\P{^Block=_-CYRILLIC_extended_c}', "");
    Error('\p{Blk=:= cyrillic_EXT_c}');
    Error('\P{Blk=:= cyrillic_EXT_c}');
    Expect(1, 7311, '\p{Blk=cyrillicextc}', "");
    Expect(0, 7311, '\p{^Blk=cyrillicextc}', "");
    Expect(0, 7311, '\P{Blk=cyrillicextc}', "");
    Expect(1, 7311, '\P{^Blk=cyrillicextc}', "");
    Expect(0, 7312, '\p{Blk=cyrillicextc}', "");
    Expect(1, 7312, '\p{^Blk=cyrillicextc}', "");
    Expect(1, 7312, '\P{Blk=cyrillicextc}', "");
    Expect(0, 7312, '\P{^Blk=cyrillicextc}', "");
    Expect(1, 7311, '\p{Blk=		CYRILLIC_EXT_C}', "");
    Expect(0, 7311, '\p{^Blk=		CYRILLIC_EXT_C}', "");
    Expect(0, 7311, '\P{Blk=		CYRILLIC_EXT_C}', "");
    Expect(1, 7311, '\P{^Blk=		CYRILLIC_EXT_C}', "");
    Expect(0, 7312, '\p{Blk=		CYRILLIC_EXT_C}', "");
    Expect(1, 7312, '\p{^Blk=		CYRILLIC_EXT_C}', "");
    Expect(1, 7312, '\P{Blk=		CYRILLIC_EXT_C}', "");
    Expect(0, 7312, '\P{^Blk=		CYRILLIC_EXT_C}', "");
    Error('\p{Is_Block=:=Cyrillic_Extended_C}');
    Error('\P{Is_Block=:=Cyrillic_Extended_C}');
    Expect(1, 7311, '\p{Is_Block=cyrillicextendedc}', "");
    Expect(0, 7311, '\p{^Is_Block=cyrillicextendedc}', "");
    Expect(0, 7311, '\P{Is_Block=cyrillicextendedc}', "");
    Expect(1, 7311, '\P{^Is_Block=cyrillicextendedc}', "");
    Expect(0, 7312, '\p{Is_Block=cyrillicextendedc}', "");
    Expect(1, 7312, '\p{^Is_Block=cyrillicextendedc}', "");
    Expect(1, 7312, '\P{Is_Block=cyrillicextendedc}', "");
    Expect(0, 7312, '\P{^Is_Block=cyrillicextendedc}', "");
    Expect(1, 7311, '\p{Is_Block:   	CYRILLIC_EXTENDED_C}', "");
    Expect(0, 7311, '\p{^Is_Block:   	CYRILLIC_EXTENDED_C}', "");
    Expect(0, 7311, '\P{Is_Block:   	CYRILLIC_EXTENDED_C}', "");
    Expect(1, 7311, '\P{^Is_Block:   	CYRILLIC_EXTENDED_C}', "");
    Expect(0, 7312, '\p{Is_Block:   	CYRILLIC_EXTENDED_C}', "");
    Expect(1, 7312, '\p{^Is_Block:   	CYRILLIC_EXTENDED_C}', "");
    Expect(1, 7312, '\P{Is_Block:   	CYRILLIC_EXTENDED_C}', "");
    Expect(0, 7312, '\P{^Is_Block:   	CYRILLIC_EXTENDED_C}', "");
    Error('\p{Is_Blk= _Cyrillic_EXT_c/a/}');
    Error('\P{Is_Blk= _Cyrillic_EXT_c/a/}');
    Expect(1, 7311, '\p{Is_Blk=cyrillicextc}', "");
    Expect(0, 7311, '\p{^Is_Blk=cyrillicextc}', "");
    Expect(0, 7311, '\P{Is_Blk=cyrillicextc}', "");
    Expect(1, 7311, '\P{^Is_Blk=cyrillicextc}', "");
    Expect(0, 7312, '\p{Is_Blk=cyrillicextc}', "");
    Expect(1, 7312, '\p{^Is_Blk=cyrillicextc}', "");
    Expect(1, 7312, '\P{Is_Blk=cyrillicextc}', "");
    Expect(0, 7312, '\P{^Is_Blk=cyrillicextc}', "");
    Expect(1, 7311, '\p{Is_Blk= 	Cyrillic_Ext_C}', "");
    Expect(0, 7311, '\p{^Is_Blk= 	Cyrillic_Ext_C}', "");
    Expect(0, 7311, '\P{Is_Blk= 	Cyrillic_Ext_C}', "");
    Expect(1, 7311, '\P{^Is_Blk= 	Cyrillic_Ext_C}', "");
    Expect(0, 7312, '\p{Is_Blk= 	Cyrillic_Ext_C}', "");
    Expect(1, 7312, '\p{^Is_Blk= 	Cyrillic_Ext_C}', "");
    Expect(1, 7312, '\P{Is_Blk= 	Cyrillic_Ext_C}', "");
    Expect(0, 7312, '\P{^Is_Blk= 	Cyrillic_Ext_C}', "");
    Error('\p{Block=-/a/Cyrillic_supplement}');
    Error('\P{Block=-/a/Cyrillic_supplement}');
    Expect(1, 1327, '\p{Block=cyrillicsupplement}', "");
    Expect(0, 1327, '\p{^Block=cyrillicsupplement}', "");
    Expect(0, 1327, '\P{Block=cyrillicsupplement}', "");
    Expect(1, 1327, '\P{^Block=cyrillicsupplement}', "");
    Expect(0, 1328, '\p{Block=cyrillicsupplement}', "");
    Expect(1, 1328, '\p{^Block=cyrillicsupplement}', "");
    Expect(1, 1328, '\P{Block=cyrillicsupplement}', "");
    Expect(0, 1328, '\P{^Block=cyrillicsupplement}', "");
    Expect(1, 1327, '\p{Block= cyrillic_Supplement}', "");
    Expect(0, 1327, '\p{^Block= cyrillic_Supplement}', "");
    Expect(0, 1327, '\P{Block= cyrillic_Supplement}', "");
    Expect(1, 1327, '\P{^Block= cyrillic_Supplement}', "");
    Expect(0, 1328, '\p{Block= cyrillic_Supplement}', "");
    Expect(1, 1328, '\p{^Block= cyrillic_Supplement}', "");
    Expect(1, 1328, '\P{Block= cyrillic_Supplement}', "");
    Expect(0, 1328, '\P{^Block= cyrillic_Supplement}', "");
    Error('\p{Blk=/a/_	cyrillic_Sup}');
    Error('\P{Blk=/a/_	cyrillic_Sup}');
    Expect(1, 1327, '\p{Blk:cyrillicsup}', "");
    Expect(0, 1327, '\p{^Blk:cyrillicsup}', "");
    Expect(0, 1327, '\P{Blk:cyrillicsup}', "");
    Expect(1, 1327, '\P{^Blk:cyrillicsup}', "");
    Expect(0, 1328, '\p{Blk:cyrillicsup}', "");
    Expect(1, 1328, '\p{^Blk:cyrillicsup}', "");
    Expect(1, 1328, '\P{Blk:cyrillicsup}', "");
    Expect(0, 1328, '\P{^Blk:cyrillicsup}', "");
    Expect(1, 1327, '\p{Blk=_cyrillic_SUP}', "");
    Expect(0, 1327, '\p{^Blk=_cyrillic_SUP}', "");
    Expect(0, 1327, '\P{Blk=_cyrillic_SUP}', "");
    Expect(1, 1327, '\P{^Blk=_cyrillic_SUP}', "");
    Expect(0, 1328, '\p{Blk=_cyrillic_SUP}', "");
    Expect(1, 1328, '\p{^Blk=_cyrillic_SUP}', "");
    Expect(1, 1328, '\P{Blk=_cyrillic_SUP}', "");
    Expect(0, 1328, '\P{^Blk=_cyrillic_SUP}', "");
    Error('\p{Is_Block=:=	 cyrillic_Supplementary}');
    Error('\P{Is_Block=:=	 cyrillic_Supplementary}');
    Expect(1, 1327, '\p{Is_Block:   cyrillicsupplementary}', "");
    Expect(0, 1327, '\p{^Is_Block:   cyrillicsupplementary}', "");
    Expect(0, 1327, '\P{Is_Block:   cyrillicsupplementary}', "");
    Expect(1, 1327, '\P{^Is_Block:   cyrillicsupplementary}', "");
    Expect(0, 1328, '\p{Is_Block:   cyrillicsupplementary}', "");
    Expect(1, 1328, '\p{^Is_Block:   cyrillicsupplementary}', "");
    Expect(1, 1328, '\P{Is_Block:   cyrillicsupplementary}', "");
    Expect(0, 1328, '\P{^Is_Block:   cyrillicsupplementary}', "");
    Expect(1, 1327, '\p{Is_Block= -Cyrillic_supplementary}', "");
    Expect(0, 1327, '\p{^Is_Block= -Cyrillic_supplementary}', "");
    Expect(0, 1327, '\P{Is_Block= -Cyrillic_supplementary}', "");
    Expect(1, 1327, '\P{^Is_Block= -Cyrillic_supplementary}', "");
    Expect(0, 1328, '\p{Is_Block= -Cyrillic_supplementary}', "");
    Expect(1, 1328, '\p{^Is_Block= -Cyrillic_supplementary}', "");
    Expect(1, 1328, '\P{Is_Block= -Cyrillic_supplementary}', "");
    Expect(0, 1328, '\P{^Is_Block= -Cyrillic_supplementary}', "");
    Error('\p{Is_Blk= :=cyrillic_Supplement}');
    Error('\P{Is_Blk= :=cyrillic_Supplement}');
    Expect(1, 1327, '\p{Is_Blk=cyrillicsupplement}', "");
    Expect(0, 1327, '\p{^Is_Blk=cyrillicsupplement}', "");
    Expect(0, 1327, '\P{Is_Blk=cyrillicsupplement}', "");
    Expect(1, 1327, '\P{^Is_Blk=cyrillicsupplement}', "");
    Expect(0, 1328, '\p{Is_Blk=cyrillicsupplement}', "");
    Expect(1, 1328, '\p{^Is_Blk=cyrillicsupplement}', "");
    Expect(1, 1328, '\P{Is_Blk=cyrillicsupplement}', "");
    Expect(0, 1328, '\P{^Is_Blk=cyrillicsupplement}', "");
    Expect(1, 1327, '\p{Is_Blk=_ Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1327, '\p{^Is_Blk=_ Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1327, '\P{Is_Blk=_ Cyrillic_SUPPLEMENT}', "");
    Expect(1, 1327, '\P{^Is_Blk=_ Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1328, '\p{Is_Blk=_ Cyrillic_SUPPLEMENT}', "");
    Expect(1, 1328, '\p{^Is_Blk=_ Cyrillic_SUPPLEMENT}', "");
    Expect(1, 1328, '\P{Is_Blk=_ Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1328, '\P{^Is_Blk=_ Cyrillic_SUPPLEMENT}', "");
    Error('\p{Block=:=_-Deseret}');
    Error('\P{Block=:=_-Deseret}');
    Expect(1, 66639, '\p{Block=deseret}', "");
    Expect(0, 66639, '\p{^Block=deseret}', "");
    Expect(0, 66639, '\P{Block=deseret}', "");
    Expect(1, 66639, '\P{^Block=deseret}', "");
    Expect(0, 66640, '\p{Block=deseret}', "");
    Expect(1, 66640, '\p{^Block=deseret}', "");
    Expect(1, 66640, '\P{Block=deseret}', "");
    Expect(0, 66640, '\P{^Block=deseret}', "");
    Expect(1, 66639, '\p{Block=_-Deseret}', "");
    Expect(0, 66639, '\p{^Block=_-Deseret}', "");
    Expect(0, 66639, '\P{Block=_-Deseret}', "");
    Expect(1, 66639, '\P{^Block=_-Deseret}', "");
    Expect(0, 66640, '\p{Block=_-Deseret}', "");
    Expect(1, 66640, '\p{^Block=_-Deseret}', "");
    Expect(1, 66640, '\P{Block=_-Deseret}', "");
    Expect(0, 66640, '\P{^Block=_-Deseret}', "");
    Error('\p{Blk=/a/ Deseret}');
    Error('\P{Blk=/a/ Deseret}');
    Expect(1, 66639, '\p{Blk=deseret}', "");
    Expect(0, 66639, '\p{^Blk=deseret}', "");
    Expect(0, 66639, '\P{Blk=deseret}', "");
    Expect(1, 66639, '\P{^Blk=deseret}', "");
    Expect(0, 66640, '\p{Blk=deseret}', "");
    Expect(1, 66640, '\p{^Blk=deseret}', "");
    Expect(1, 66640, '\P{Blk=deseret}', "");
    Expect(0, 66640, '\P{^Blk=deseret}', "");
    Expect(1, 66639, '\p{Blk=__DESERET}', "");
    Expect(0, 66639, '\p{^Blk=__DESERET}', "");
    Expect(0, 66639, '\P{Blk=__DESERET}', "");
    Expect(1, 66639, '\P{^Blk=__DESERET}', "");
    Expect(0, 66640, '\p{Blk=__DESERET}', "");
    Expect(1, 66640, '\p{^Blk=__DESERET}', "");
    Expect(1, 66640, '\P{Blk=__DESERET}', "");
    Expect(0, 66640, '\P{^Blk=__DESERET}', "");
    Error('\p{Is_Block=_-deseret/a/}');
    Error('\P{Is_Block=_-deseret/a/}');
    Expect(1, 66639, '\p{Is_Block=deseret}', "");
    Expect(0, 66639, '\p{^Is_Block=deseret}', "");
    Expect(0, 66639, '\P{Is_Block=deseret}', "");
    Expect(1, 66639, '\P{^Is_Block=deseret}', "");
    Expect(0, 66640, '\p{Is_Block=deseret}', "");
    Expect(1, 66640, '\p{^Is_Block=deseret}', "");
    Expect(1, 66640, '\P{Is_Block=deseret}', "");
    Expect(0, 66640, '\P{^Is_Block=deseret}', "");
    Expect(1, 66639, '\p{Is_Block=-	deseret}', "");
    Expect(0, 66639, '\p{^Is_Block=-	deseret}', "");
    Expect(0, 66639, '\P{Is_Block=-	deseret}', "");
    Expect(1, 66639, '\P{^Is_Block=-	deseret}', "");
    Expect(0, 66640, '\p{Is_Block=-	deseret}', "");
    Expect(1, 66640, '\p{^Is_Block=-	deseret}', "");
    Expect(1, 66640, '\P{Is_Block=-	deseret}', "");
    Expect(0, 66640, '\P{^Is_Block=-	deseret}', "");
    Error('\p{Is_Blk=-:=Deseret}');
    Error('\P{Is_Blk=-:=Deseret}');
    Expect(1, 66639, '\p{Is_Blk=deseret}', "");
    Expect(0, 66639, '\p{^Is_Blk=deseret}', "");
    Expect(0, 66639, '\P{Is_Blk=deseret}', "");
    Expect(1, 66639, '\P{^Is_Blk=deseret}', "");
    Expect(0, 66640, '\p{Is_Blk=deseret}', "");
    Expect(1, 66640, '\p{^Is_Blk=deseret}', "");
    Expect(1, 66640, '\P{Is_Blk=deseret}', "");
    Expect(0, 66640, '\P{^Is_Blk=deseret}', "");
    Expect(1, 66639, '\p{Is_Blk:   DESERET}', "");
    Expect(0, 66639, '\p{^Is_Blk:   DESERET}', "");
    Expect(0, 66639, '\P{Is_Blk:   DESERET}', "");
    Expect(1, 66639, '\P{^Is_Blk:   DESERET}', "");
    Expect(0, 66640, '\p{Is_Blk:   DESERET}', "");
    Expect(1, 66640, '\p{^Is_Blk:   DESERET}', "");
    Expect(1, 66640, '\P{Is_Blk:   DESERET}', "");
    Expect(0, 66640, '\P{^Is_Blk:   DESERET}', "");
    Error('\p{Block=/a/_	DEVANAGARI}');
    Error('\P{Block=/a/_	DEVANAGARI}');
    Expect(1, 2431, '\p{Block=devanagari}', "");
    Expect(0, 2431, '\p{^Block=devanagari}', "");
    Expect(0, 2431, '\P{Block=devanagari}', "");
    Expect(1, 2431, '\P{^Block=devanagari}', "");
    Expect(0, 2432, '\p{Block=devanagari}', "");
    Expect(1, 2432, '\p{^Block=devanagari}', "");
    Expect(1, 2432, '\P{Block=devanagari}', "");
    Expect(0, 2432, '\P{^Block=devanagari}', "");
    Expect(1, 2431, '\p{Block:   - Devanagari}', "");
    Expect(0, 2431, '\p{^Block:   - Devanagari}', "");
    Expect(0, 2431, '\P{Block:   - Devanagari}', "");
    Expect(1, 2431, '\P{^Block:   - Devanagari}', "");
    Expect(0, 2432, '\p{Block:   - Devanagari}', "");
    Expect(1, 2432, '\p{^Block:   - Devanagari}', "");
    Expect(1, 2432, '\P{Block:   - Devanagari}', "");
    Expect(0, 2432, '\P{^Block:   - Devanagari}', "");
    Error('\p{Blk=--DEVANAGARI:=}');
    Error('\P{Blk=--DEVANAGARI:=}');
    Expect(1, 2431, '\p{Blk=devanagari}', "");
    Expect(0, 2431, '\p{^Blk=devanagari}', "");
    Expect(0, 2431, '\P{Blk=devanagari}', "");
    Expect(1, 2431, '\P{^Blk=devanagari}', "");
    Expect(0, 2432, '\p{Blk=devanagari}', "");
    Expect(1, 2432, '\p{^Blk=devanagari}', "");
    Expect(1, 2432, '\P{Blk=devanagari}', "");
    Expect(0, 2432, '\P{^Blk=devanagari}', "");
    Expect(1, 2431, '\p{Blk=_	Devanagari}', "");
    Expect(0, 2431, '\p{^Blk=_	Devanagari}', "");
    Expect(0, 2431, '\P{Blk=_	Devanagari}', "");
    Expect(1, 2431, '\P{^Blk=_	Devanagari}', "");
    Expect(0, 2432, '\p{Blk=_	Devanagari}', "");
    Expect(1, 2432, '\p{^Blk=_	Devanagari}', "");
    Expect(1, 2432, '\P{Blk=_	Devanagari}', "");
    Expect(0, 2432, '\P{^Blk=_	Devanagari}', "");
    Error('\p{Is_Block=-:=devanagari}');
    Error('\P{Is_Block=-:=devanagari}');
    Expect(1, 2431, '\p{Is_Block=devanagari}', "");
    Expect(0, 2431, '\p{^Is_Block=devanagari}', "");
    Expect(0, 2431, '\P{Is_Block=devanagari}', "");
    Expect(1, 2431, '\P{^Is_Block=devanagari}', "");
    Expect(0, 2432, '\p{Is_Block=devanagari}', "");
    Expect(1, 2432, '\p{^Is_Block=devanagari}', "");
    Expect(1, 2432, '\P{Is_Block=devanagari}', "");
    Expect(0, 2432, '\P{^Is_Block=devanagari}', "");
    Expect(1, 2431, '\p{Is_Block=_Devanagari}', "");
    Expect(0, 2431, '\p{^Is_Block=_Devanagari}', "");
    Expect(0, 2431, '\P{Is_Block=_Devanagari}', "");
    Expect(1, 2431, '\P{^Is_Block=_Devanagari}', "");
    Expect(0, 2432, '\p{Is_Block=_Devanagari}', "");
    Expect(1, 2432, '\p{^Is_Block=_Devanagari}', "");
    Expect(1, 2432, '\P{Is_Block=_Devanagari}', "");
    Expect(0, 2432, '\P{^Is_Block=_Devanagari}', "");
    Error('\p{Is_Blk=/a/	-DEVANAGARI}');
    Error('\P{Is_Blk=/a/	-DEVANAGARI}');
    Expect(1, 2431, '\p{Is_Blk=devanagari}', "");
    Expect(0, 2431, '\p{^Is_Blk=devanagari}', "");
    Expect(0, 2431, '\P{Is_Blk=devanagari}', "");
    Expect(1, 2431, '\P{^Is_Blk=devanagari}', "");
    Expect(0, 2432, '\p{Is_Blk=devanagari}', "");
    Expect(1, 2432, '\p{^Is_Blk=devanagari}', "");
    Expect(1, 2432, '\P{Is_Blk=devanagari}', "");
    Expect(0, 2432, '\P{^Is_Blk=devanagari}', "");
    Expect(1, 2431, '\p{Is_Blk=-_Devanagari}', "");
    Expect(0, 2431, '\p{^Is_Blk=-_Devanagari}', "");
    Expect(0, 2431, '\P{Is_Blk=-_Devanagari}', "");
    Expect(1, 2431, '\P{^Is_Blk=-_Devanagari}', "");
    Expect(0, 2432, '\p{Is_Blk=-_Devanagari}', "");
    Expect(1, 2432, '\p{^Is_Blk=-_Devanagari}', "");
    Expect(1, 2432, '\P{Is_Blk=-_Devanagari}', "");
    Expect(0, 2432, '\P{^Is_Blk=-_Devanagari}', "");
    Error('\p{Block=:= devanagari_extended}');
    Error('\P{Block=:= devanagari_extended}');
    Expect(1, 43263, '\p{Block=devanagariextended}', "");
    Expect(0, 43263, '\p{^Block=devanagariextended}', "");
    Expect(0, 43263, '\P{Block=devanagariextended}', "");
    Expect(1, 43263, '\P{^Block=devanagariextended}', "");
    Expect(0, 43264, '\p{Block=devanagariextended}', "");
    Expect(1, 43264, '\p{^Block=devanagariextended}', "");
    Expect(1, 43264, '\P{Block=devanagariextended}', "");
    Expect(0, 43264, '\P{^Block=devanagariextended}', "");
    Expect(1, 43263, '\p{Block:_-Devanagari_Extended}', "");
    Expect(0, 43263, '\p{^Block:_-Devanagari_Extended}', "");
    Expect(0, 43263, '\P{Block:_-Devanagari_Extended}', "");
    Expect(1, 43263, '\P{^Block:_-Devanagari_Extended}', "");
    Expect(0, 43264, '\p{Block:_-Devanagari_Extended}', "");
    Expect(1, 43264, '\p{^Block:_-Devanagari_Extended}', "");
    Expect(1, 43264, '\P{Block:_-Devanagari_Extended}', "");
    Expect(0, 43264, '\P{^Block:_-Devanagari_Extended}', "");
    Error('\p{Blk=_DEVANAGARI_Ext/a/}');
    Error('\P{Blk=_DEVANAGARI_Ext/a/}');
    Expect(1, 43263, '\p{Blk=devanagariext}', "");
    Expect(0, 43263, '\p{^Blk=devanagariext}', "");
    Expect(0, 43263, '\P{Blk=devanagariext}', "");
    Expect(1, 43263, '\P{^Blk=devanagariext}', "");
    Expect(0, 43264, '\p{Blk=devanagariext}', "");
    Expect(1, 43264, '\p{^Blk=devanagariext}', "");
    Expect(1, 43264, '\P{Blk=devanagariext}', "");
    Expect(0, 43264, '\P{^Blk=devanagariext}', "");
    Expect(1, 43263, '\p{Blk=	_Devanagari_Ext}', "");
    Expect(0, 43263, '\p{^Blk=	_Devanagari_Ext}', "");
    Expect(0, 43263, '\P{Blk=	_Devanagari_Ext}', "");
    Expect(1, 43263, '\P{^Blk=	_Devanagari_Ext}', "");
    Expect(0, 43264, '\p{Blk=	_Devanagari_Ext}', "");
    Expect(1, 43264, '\p{^Blk=	_Devanagari_Ext}', "");
    Expect(1, 43264, '\P{Blk=	_Devanagari_Ext}', "");
    Expect(0, 43264, '\P{^Blk=	_Devanagari_Ext}', "");
    Error('\p{Is_Block: 	 devanagari_Extended:=}');
    Error('\P{Is_Block: 	 devanagari_Extended:=}');
    Expect(1, 43263, '\p{Is_Block=devanagariextended}', "");
    Expect(0, 43263, '\p{^Is_Block=devanagariextended}', "");
    Expect(0, 43263, '\P{Is_Block=devanagariextended}', "");
    Expect(1, 43263, '\P{^Is_Block=devanagariextended}', "");
    Expect(0, 43264, '\p{Is_Block=devanagariextended}', "");
    Expect(1, 43264, '\p{^Is_Block=devanagariextended}', "");
    Expect(1, 43264, '\P{Is_Block=devanagariextended}', "");
    Expect(0, 43264, '\P{^Is_Block=devanagariextended}', "");
    Expect(1, 43263, '\p{Is_Block:--Devanagari_Extended}', "");
    Expect(0, 43263, '\p{^Is_Block:--Devanagari_Extended}', "");
    Expect(0, 43263, '\P{Is_Block:--Devanagari_Extended}', "");
    Expect(1, 43263, '\P{^Is_Block:--Devanagari_Extended}', "");
    Expect(0, 43264, '\p{Is_Block:--Devanagari_Extended}', "");
    Expect(1, 43264, '\p{^Is_Block:--Devanagari_Extended}', "");
    Expect(1, 43264, '\P{Is_Block:--Devanagari_Extended}', "");
    Expect(0, 43264, '\P{^Is_Block:--Devanagari_Extended}', "");
    Error('\p{Is_Blk:   :=_Devanagari_EXT}');
    Error('\P{Is_Blk:   :=_Devanagari_EXT}');
    Expect(1, 43263, '\p{Is_Blk=devanagariext}', "");
    Expect(0, 43263, '\p{^Is_Blk=devanagariext}', "");
    Expect(0, 43263, '\P{Is_Blk=devanagariext}', "");
    Expect(1, 43263, '\P{^Is_Blk=devanagariext}', "");
    Expect(0, 43264, '\p{Is_Blk=devanagariext}', "");
    Expect(1, 43264, '\p{^Is_Blk=devanagariext}', "");
    Expect(1, 43264, '\P{Is_Blk=devanagariext}', "");
    Expect(0, 43264, '\P{^Is_Blk=devanagariext}', "");
    Expect(1, 43263, '\p{Is_Blk=	-devanagari_Ext}', "");
    Expect(0, 43263, '\p{^Is_Blk=	-devanagari_Ext}', "");
    Expect(0, 43263, '\P{Is_Blk=	-devanagari_Ext}', "");
    Expect(1, 43263, '\P{^Is_Blk=	-devanagari_Ext}', "");
    Expect(0, 43264, '\p{Is_Blk=	-devanagari_Ext}', "");
    Expect(1, 43264, '\p{^Is_Blk=	-devanagari_Ext}', "");
    Expect(1, 43264, '\P{Is_Blk=	-devanagari_Ext}', "");
    Expect(0, 43264, '\P{^Is_Blk=	-devanagari_Ext}', "");
    Error('\p{Block=/a/-COMBINING_Diacritical_Marks}');
    Error('\P{Block=/a/-COMBINING_Diacritical_Marks}');
    Expect(1, 879, '\p{Block=combiningdiacriticalmarks}', "");
    Expect(0, 879, '\p{^Block=combiningdiacriticalmarks}', "");
    Expect(0, 879, '\P{Block=combiningdiacriticalmarks}', "");
    Expect(1, 879, '\P{^Block=combiningdiacriticalmarks}', "");
    Expect(0, 880, '\p{Block=combiningdiacriticalmarks}', "");
    Expect(1, 880, '\p{^Block=combiningdiacriticalmarks}', "");
    Expect(1, 880, '\P{Block=combiningdiacriticalmarks}', "");
    Expect(0, 880, '\P{^Block=combiningdiacriticalmarks}', "");
    Expect(1, 879, '\p{Block=_ Combining_diacritical_Marks}', "");
    Expect(0, 879, '\p{^Block=_ Combining_diacritical_Marks}', "");
    Expect(0, 879, '\P{Block=_ Combining_diacritical_Marks}', "");
    Expect(1, 879, '\P{^Block=_ Combining_diacritical_Marks}', "");
    Expect(0, 880, '\p{Block=_ Combining_diacritical_Marks}', "");
    Expect(1, 880, '\p{^Block=_ Combining_diacritical_Marks}', "");
    Expect(1, 880, '\P{Block=_ Combining_diacritical_Marks}', "");
    Expect(0, 880, '\P{^Block=_ Combining_diacritical_Marks}', "");
    Error('\p{Blk=	-Diacriticals/a/}');
    Error('\P{Blk=	-Diacriticals/a/}');
    Expect(1, 879, '\p{Blk=diacriticals}', "");
    Expect(0, 879, '\p{^Blk=diacriticals}', "");
    Expect(0, 879, '\P{Blk=diacriticals}', "");
    Expect(1, 879, '\P{^Blk=diacriticals}', "");
    Expect(0, 880, '\p{Blk=diacriticals}', "");
    Expect(1, 880, '\p{^Blk=diacriticals}', "");
    Expect(1, 880, '\P{Blk=diacriticals}', "");
    Expect(0, 880, '\P{^Blk=diacriticals}', "");
    Expect(1, 879, '\p{Blk= Diacriticals}', "");
    Expect(0, 879, '\p{^Blk= Diacriticals}', "");
    Expect(0, 879, '\P{Blk= Diacriticals}', "");
    Expect(1, 879, '\P{^Blk= Diacriticals}', "");
    Expect(0, 880, '\p{Blk= Diacriticals}', "");
    Expect(1, 880, '\p{^Blk= Diacriticals}', "");
    Expect(1, 880, '\P{Blk= Diacriticals}', "");
    Expect(0, 880, '\P{^Blk= Diacriticals}', "");
    Error('\p{Is_Block= _combining_diacritical_Marks/a/}');
    Error('\P{Is_Block= _combining_diacritical_Marks/a/}');
    Expect(1, 879, '\p{Is_Block=combiningdiacriticalmarks}', "");
    Expect(0, 879, '\p{^Is_Block=combiningdiacriticalmarks}', "");
    Expect(0, 879, '\P{Is_Block=combiningdiacriticalmarks}', "");
    Expect(1, 879, '\P{^Is_Block=combiningdiacriticalmarks}', "");
    Expect(0, 880, '\p{Is_Block=combiningdiacriticalmarks}', "");
    Expect(1, 880, '\p{^Is_Block=combiningdiacriticalmarks}', "");
    Expect(1, 880, '\P{Is_Block=combiningdiacriticalmarks}', "");
    Expect(0, 880, '\P{^Is_Block=combiningdiacriticalmarks}', "");
    Expect(1, 879, '\p{Is_Block=_Combining_Diacritical_Marks}', "");
    Expect(0, 879, '\p{^Is_Block=_Combining_Diacritical_Marks}', "");
    Expect(0, 879, '\P{Is_Block=_Combining_Diacritical_Marks}', "");
    Expect(1, 879, '\P{^Is_Block=_Combining_Diacritical_Marks}', "");
    Expect(0, 880, '\p{Is_Block=_Combining_Diacritical_Marks}', "");
    Expect(1, 880, '\p{^Is_Block=_Combining_Diacritical_Marks}', "");
    Expect(1, 880, '\P{Is_Block=_Combining_Diacritical_Marks}', "");
    Expect(0, 880, '\P{^Is_Block=_Combining_Diacritical_Marks}', "");
    Error('\p{Is_Blk=/a/Diacriticals}');
    Error('\P{Is_Blk=/a/Diacriticals}');
    Expect(1, 879, '\p{Is_Blk:diacriticals}', "");
    Expect(0, 879, '\p{^Is_Blk:diacriticals}', "");
    Expect(0, 879, '\P{Is_Blk:diacriticals}', "");
    Expect(1, 879, '\P{^Is_Blk:diacriticals}', "");
    Expect(0, 880, '\p{Is_Blk:diacriticals}', "");
    Expect(1, 880, '\p{^Is_Blk:diacriticals}', "");
    Expect(1, 880, '\P{Is_Blk:diacriticals}', "");
    Expect(0, 880, '\P{^Is_Blk:diacriticals}', "");
    Expect(1, 879, '\p{Is_Blk=_DIACRITICALS}', "");
    Expect(0, 879, '\p{^Is_Blk=_DIACRITICALS}', "");
    Expect(0, 879, '\P{Is_Blk=_DIACRITICALS}', "");
    Expect(1, 879, '\P{^Is_Blk=_DIACRITICALS}', "");
    Expect(0, 880, '\p{Is_Blk=_DIACRITICALS}', "");
    Expect(1, 880, '\p{^Is_Blk=_DIACRITICALS}', "");
    Expect(1, 880, '\P{Is_Blk=_DIACRITICALS}', "");
    Expect(0, 880, '\P{^Is_Blk=_DIACRITICALS}', "");
    Error('\p{Block=:=combining_DIACRITICAL_MARKS_extended}');
    Error('\P{Block=:=combining_DIACRITICAL_MARKS_extended}');
    Expect(1, 6911, '\p{Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\p{^Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\P{Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\P{^Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\p{Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\p{^Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\P{Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\P{^Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\p{Block:--combining_Diacritical_marks_Extended}', "");
    Expect(0, 6911, '\p{^Block:--combining_Diacritical_marks_Extended}', "");
    Expect(0, 6911, '\P{Block:--combining_Diacritical_marks_Extended}', "");
    Expect(1, 6911, '\P{^Block:--combining_Diacritical_marks_Extended}', "");
    Expect(0, 6912, '\p{Block:--combining_Diacritical_marks_Extended}', "");
    Expect(1, 6912, '\p{^Block:--combining_Diacritical_marks_Extended}', "");
    Expect(1, 6912, '\P{Block:--combining_Diacritical_marks_Extended}', "");
    Expect(0, 6912, '\P{^Block:--combining_Diacritical_marks_Extended}', "");
    Error('\p{Blk=:= Diacriticals_EXT}');
    Error('\P{Blk=:= Diacriticals_EXT}');
    Expect(1, 6911, '\p{Blk=diacriticalsext}', "");
    Expect(0, 6911, '\p{^Blk=diacriticalsext}', "");
    Expect(0, 6911, '\P{Blk=diacriticalsext}', "");
    Expect(1, 6911, '\P{^Blk=diacriticalsext}', "");
    Expect(0, 6912, '\p{Blk=diacriticalsext}', "");
    Expect(1, 6912, '\p{^Blk=diacriticalsext}', "");
    Expect(1, 6912, '\P{Blk=diacriticalsext}', "");
    Expect(0, 6912, '\P{^Blk=diacriticalsext}', "");
    Expect(1, 6911, '\p{Blk=  Diacriticals_Ext}', "");
    Expect(0, 6911, '\p{^Blk=  Diacriticals_Ext}', "");
    Expect(0, 6911, '\P{Blk=  Diacriticals_Ext}', "");
    Expect(1, 6911, '\P{^Blk=  Diacriticals_Ext}', "");
    Expect(0, 6912, '\p{Blk=  Diacriticals_Ext}', "");
    Expect(1, 6912, '\p{^Blk=  Diacriticals_Ext}', "");
    Expect(1, 6912, '\P{Blk=  Diacriticals_Ext}', "");
    Expect(0, 6912, '\P{^Blk=  Diacriticals_Ext}', "");
    Error('\p{Is_Block=-	Combining_DIACRITICAL_MARKS_Extended/a/}');
    Error('\P{Is_Block=-	Combining_DIACRITICAL_MARKS_Extended/a/}');
    Expect(1, 6911, '\p{Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\p{^Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\P{Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\P{^Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\p{Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\p{^Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\P{Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\P{^Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\p{Is_Block=	Combining_DIACRITICAL_marks_EXTENDED}', "");
    Expect(0, 6911, '\p{^Is_Block=	Combining_DIACRITICAL_marks_EXTENDED}', "");
    Expect(0, 6911, '\P{Is_Block=	Combining_DIACRITICAL_marks_EXTENDED}', "");
    Expect(1, 6911, '\P{^Is_Block=	Combining_DIACRITICAL_marks_EXTENDED}', "");
    Expect(0, 6912, '\p{Is_Block=	Combining_DIACRITICAL_marks_EXTENDED}', "");
    Expect(1, 6912, '\p{^Is_Block=	Combining_DIACRITICAL_marks_EXTENDED}', "");
    Expect(1, 6912, '\P{Is_Block=	Combining_DIACRITICAL_marks_EXTENDED}', "");
    Expect(0, 6912, '\P{^Is_Block=	Combining_DIACRITICAL_marks_EXTENDED}', "");
    Error('\p{Is_Blk=-/a/Diacriticals_Ext}');
    Error('\P{Is_Blk=-/a/Diacriticals_Ext}');
    Expect(1, 6911, '\p{Is_Blk:   diacriticalsext}', "");
    Expect(0, 6911, '\p{^Is_Blk:   diacriticalsext}', "");
    Expect(0, 6911, '\P{Is_Blk:   diacriticalsext}', "");
    Expect(1, 6911, '\P{^Is_Blk:   diacriticalsext}', "");
    Expect(0, 6912, '\p{Is_Blk:   diacriticalsext}', "");
    Expect(1, 6912, '\p{^Is_Blk:   diacriticalsext}', "");
    Expect(1, 6912, '\P{Is_Blk:   diacriticalsext}', "");
    Expect(0, 6912, '\P{^Is_Blk:   diacriticalsext}', "");
    Expect(1, 6911, '\p{Is_Blk=_-Diacriticals_EXT}', "");
    Expect(0, 6911, '\p{^Is_Blk=_-Diacriticals_EXT}', "");
    Expect(0, 6911, '\P{Is_Blk=_-Diacriticals_EXT}', "");
    Expect(1, 6911, '\P{^Is_Blk=_-Diacriticals_EXT}', "");
    Expect(0, 6912, '\p{Is_Blk=_-Diacriticals_EXT}', "");
    Expect(1, 6912, '\p{^Is_Blk=_-Diacriticals_EXT}', "");
    Expect(1, 6912, '\P{Is_Blk=_-Diacriticals_EXT}', "");
    Expect(0, 6912, '\P{^Is_Blk=_-Diacriticals_EXT}', "");
    Error('\p{Block=-_COMBINING_diacritical_MARKS_For_symbols:=}');
    Error('\P{Block=-_COMBINING_diacritical_MARKS_For_symbols:=}');
    Expect(1, 8447, '\p{Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\p{^Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\P{Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\P{^Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\p{Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\p{^Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\P{Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\P{^Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\p{Block=-	COMBINING_DIACRITICAL_MARKS_for_symbols}', "");
    Expect(0, 8447, '\p{^Block=-	COMBINING_DIACRITICAL_MARKS_for_symbols}', "");
    Expect(0, 8447, '\P{Block=-	COMBINING_DIACRITICAL_MARKS_for_symbols}', "");
    Expect(1, 8447, '\P{^Block=-	COMBINING_DIACRITICAL_MARKS_for_symbols}', "");
    Expect(0, 8448, '\p{Block=-	COMBINING_DIACRITICAL_MARKS_for_symbols}', "");
    Expect(1, 8448, '\p{^Block=-	COMBINING_DIACRITICAL_MARKS_for_symbols}', "");
    Expect(1, 8448, '\P{Block=-	COMBINING_DIACRITICAL_MARKS_for_symbols}', "");
    Expect(0, 8448, '\P{^Block=-	COMBINING_DIACRITICAL_MARKS_for_symbols}', "");
    Error('\p{Blk=:=Diacriticals_FOR_Symbols}');
    Error('\P{Blk=:=Diacriticals_FOR_Symbols}');
    Expect(1, 8447, '\p{Blk=diacriticalsforsymbols}', "");
    Expect(0, 8447, '\p{^Blk=diacriticalsforsymbols}', "");
    Expect(0, 8447, '\P{Blk=diacriticalsforsymbols}', "");
    Expect(1, 8447, '\P{^Blk=diacriticalsforsymbols}', "");
    Expect(0, 8448, '\p{Blk=diacriticalsforsymbols}', "");
    Expect(1, 8448, '\p{^Blk=diacriticalsforsymbols}', "");
    Expect(1, 8448, '\P{Blk=diacriticalsforsymbols}', "");
    Expect(0, 8448, '\P{^Blk=diacriticalsforsymbols}', "");
    Expect(1, 8447, '\p{Blk=-_diacriticals_For_symbols}', "");
    Expect(0, 8447, '\p{^Blk=-_diacriticals_For_symbols}', "");
    Expect(0, 8447, '\P{Blk=-_diacriticals_For_symbols}', "");
    Expect(1, 8447, '\P{^Blk=-_diacriticals_For_symbols}', "");
    Expect(0, 8448, '\p{Blk=-_diacriticals_For_symbols}', "");
    Expect(1, 8448, '\p{^Blk=-_diacriticals_For_symbols}', "");
    Expect(1, 8448, '\P{Blk=-_diacriticals_For_symbols}', "");
    Expect(0, 8448, '\P{^Blk=-_diacriticals_For_symbols}', "");
    Error('\p{Is_Block=  Combining_MARKS_For_SYMBOLS:=}');
    Error('\P{Is_Block=  Combining_MARKS_For_SYMBOLS:=}');
    Expect(1, 8447, '\p{Is_Block=combiningmarksforsymbols}', "");
    Expect(0, 8447, '\p{^Is_Block=combiningmarksforsymbols}', "");
    Expect(0, 8447, '\P{Is_Block=combiningmarksforsymbols}', "");
    Expect(1, 8447, '\P{^Is_Block=combiningmarksforsymbols}', "");
    Expect(0, 8448, '\p{Is_Block=combiningmarksforsymbols}', "");
    Expect(1, 8448, '\p{^Is_Block=combiningmarksforsymbols}', "");
    Expect(1, 8448, '\P{Is_Block=combiningmarksforsymbols}', "");
    Expect(0, 8448, '\P{^Is_Block=combiningmarksforsymbols}', "");
    Expect(1, 8447, '\p{Is_Block=_combining_marks_FOR_Symbols}', "");
    Expect(0, 8447, '\p{^Is_Block=_combining_marks_FOR_Symbols}', "");
    Expect(0, 8447, '\P{Is_Block=_combining_marks_FOR_Symbols}', "");
    Expect(1, 8447, '\P{^Is_Block=_combining_marks_FOR_Symbols}', "");
    Expect(0, 8448, '\p{Is_Block=_combining_marks_FOR_Symbols}', "");
    Expect(1, 8448, '\p{^Is_Block=_combining_marks_FOR_Symbols}', "");
    Expect(1, 8448, '\P{Is_Block=_combining_marks_FOR_Symbols}', "");
    Expect(0, 8448, '\P{^Is_Block=_combining_marks_FOR_Symbols}', "");
    Error('\p{Is_Blk= Combining_Diacritical_marks_For_Symbols:=}');
    Error('\P{Is_Blk= Combining_Diacritical_marks_For_Symbols:=}');
    Expect(1, 8447, '\p{Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\p{^Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\P{Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\P{^Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\p{Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\p{^Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\P{Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\P{^Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\p{Is_Blk=	Combining_Diacritical_Marks_FOR_SYMBOLS}', "");
    Expect(0, 8447, '\p{^Is_Blk=	Combining_Diacritical_Marks_FOR_SYMBOLS}', "");
    Expect(0, 8447, '\P{Is_Blk=	Combining_Diacritical_Marks_FOR_SYMBOLS}', "");
    Expect(1, 8447, '\P{^Is_Blk=	Combining_Diacritical_Marks_FOR_SYMBOLS}', "");
    Expect(0, 8448, '\p{Is_Blk=	Combining_Diacritical_Marks_FOR_SYMBOLS}', "");
    Expect(1, 8448, '\p{^Is_Blk=	Combining_Diacritical_Marks_FOR_SYMBOLS}', "");
    Expect(1, 8448, '\P{Is_Blk=	Combining_Diacritical_Marks_FOR_SYMBOLS}', "");
    Expect(0, 8448, '\P{^Is_Blk=	Combining_Diacritical_Marks_FOR_SYMBOLS}', "");
    Error('\p{Block=-_Combining_DIACRITICAL_Marks_Supplement/a/}');
    Error('\P{Block=-_Combining_DIACRITICAL_Marks_Supplement/a/}');
    Expect(1, 7679, '\p{Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\p{^Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\P{Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\P{^Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\p{Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\p{^Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\P{Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\P{^Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\p{Block:	_	Combining_DIACRITICAL_Marks_Supplement}', "");
    Expect(0, 7679, '\p{^Block:	_	Combining_DIACRITICAL_Marks_Supplement}', "");
    Expect(0, 7679, '\P{Block:	_	Combining_DIACRITICAL_Marks_Supplement}', "");
    Expect(1, 7679, '\P{^Block:	_	Combining_DIACRITICAL_Marks_Supplement}', "");
    Expect(0, 7680, '\p{Block:	_	Combining_DIACRITICAL_Marks_Supplement}', "");
    Expect(1, 7680, '\p{^Block:	_	Combining_DIACRITICAL_Marks_Supplement}', "");
    Expect(1, 7680, '\P{Block:	_	Combining_DIACRITICAL_Marks_Supplement}', "");
    Expect(0, 7680, '\P{^Block:	_	Combining_DIACRITICAL_Marks_Supplement}', "");
    Error('\p{Blk= :=Diacriticals_Sup}');
    Error('\P{Blk= :=Diacriticals_Sup}');
    Expect(1, 7679, '\p{Blk=diacriticalssup}', "");
    Expect(0, 7679, '\p{^Blk=diacriticalssup}', "");
    Expect(0, 7679, '\P{Blk=diacriticalssup}', "");
    Expect(1, 7679, '\P{^Blk=diacriticalssup}', "");
    Expect(0, 7680, '\p{Blk=diacriticalssup}', "");
    Expect(1, 7680, '\p{^Blk=diacriticalssup}', "");
    Expect(1, 7680, '\P{Blk=diacriticalssup}', "");
    Expect(0, 7680, '\P{^Blk=diacriticalssup}', "");
    Expect(1, 7679, '\p{Blk=__Diacriticals_Sup}', "");
    Expect(0, 7679, '\p{^Blk=__Diacriticals_Sup}', "");
    Expect(0, 7679, '\P{Blk=__Diacriticals_Sup}', "");
    Expect(1, 7679, '\P{^Blk=__Diacriticals_Sup}', "");
    Expect(0, 7680, '\p{Blk=__Diacriticals_Sup}', "");
    Expect(1, 7680, '\p{^Blk=__Diacriticals_Sup}', "");
    Expect(1, 7680, '\P{Blk=__Diacriticals_Sup}', "");
    Expect(0, 7680, '\P{^Blk=__Diacriticals_Sup}', "");
    Error('\p{Is_Block:	_combining_DIACRITICAL_marks_supplement/a/}');
    Error('\P{Is_Block:	_combining_DIACRITICAL_marks_supplement/a/}');
    Expect(1, 7679, '\p{Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\p{^Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\P{Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\P{^Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\p{Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\p{^Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\P{Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\P{^Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\p{Is_Block: 	COMBINING_diacritical_marks_Supplement}', "");
    Expect(0, 7679, '\p{^Is_Block: 	COMBINING_diacritical_marks_Supplement}', "");
    Expect(0, 7679, '\P{Is_Block: 	COMBINING_diacritical_marks_Supplement}', "");
    Expect(1, 7679, '\P{^Is_Block: 	COMBINING_diacritical_marks_Supplement}', "");
    Expect(0, 7680, '\p{Is_Block: 	COMBINING_diacritical_marks_Supplement}', "");
    Expect(1, 7680, '\p{^Is_Block: 	COMBINING_diacritical_marks_Supplement}', "");
    Expect(1, 7680, '\P{Is_Block: 	COMBINING_diacritical_marks_Supplement}', "");
    Expect(0, 7680, '\P{^Is_Block: 	COMBINING_diacritical_marks_Supplement}', "");
    Error('\p{Is_Blk:-_diacriticals_Sup/a/}');
    Error('\P{Is_Blk:-_diacriticals_Sup/a/}');
    Expect(1, 7679, '\p{Is_Blk=diacriticalssup}', "");
    Expect(0, 7679, '\p{^Is_Blk=diacriticalssup}', "");
    Expect(0, 7679, '\P{Is_Blk=diacriticalssup}', "");
    Expect(1, 7679, '\P{^Is_Blk=diacriticalssup}', "");
    Expect(0, 7680, '\p{Is_Blk=diacriticalssup}', "");
    Expect(1, 7680, '\p{^Is_Blk=diacriticalssup}', "");
    Expect(1, 7680, '\P{Is_Blk=diacriticalssup}', "");
    Expect(0, 7680, '\P{^Is_Blk=diacriticalssup}', "");
    Expect(1, 7679, '\p{Is_Blk=- Diacriticals_Sup}', "");
    Expect(0, 7679, '\p{^Is_Blk=- Diacriticals_Sup}', "");
    Expect(0, 7679, '\P{Is_Blk=- Diacriticals_Sup}', "");
    Expect(1, 7679, '\P{^Is_Blk=- Diacriticals_Sup}', "");
    Expect(0, 7680, '\p{Is_Blk=- Diacriticals_Sup}', "");
    Expect(1, 7680, '\p{^Is_Blk=- Diacriticals_Sup}', "");
    Expect(1, 7680, '\P{Is_Blk=- Diacriticals_Sup}', "");
    Expect(0, 7680, '\P{^Is_Blk=- Diacriticals_Sup}', "");
    Error('\p{Block=	/a/dingbats}');
    Error('\P{Block=	/a/dingbats}');
    Expect(1, 10175, '\p{Block=dingbats}', "");
    Expect(0, 10175, '\p{^Block=dingbats}', "");
    Expect(0, 10175, '\P{Block=dingbats}', "");
    Expect(1, 10175, '\P{^Block=dingbats}', "");
    Expect(0, 10176, '\p{Block=dingbats}', "");
    Expect(1, 10176, '\p{^Block=dingbats}', "");
    Expect(1, 10176, '\P{Block=dingbats}', "");
    Expect(0, 10176, '\P{^Block=dingbats}', "");
    Expect(1, 10175, '\p{Block= _Dingbats}', "");
    Expect(0, 10175, '\p{^Block= _Dingbats}', "");
    Expect(0, 10175, '\P{Block= _Dingbats}', "");
    Expect(1, 10175, '\P{^Block= _Dingbats}', "");
    Expect(0, 10176, '\p{Block= _Dingbats}', "");
    Expect(1, 10176, '\p{^Block= _Dingbats}', "");
    Expect(1, 10176, '\P{Block= _Dingbats}', "");
    Expect(0, 10176, '\P{^Block= _Dingbats}', "");
    Error('\p{Blk=/a/Dingbats}');
    Error('\P{Blk=/a/Dingbats}');
    Expect(1, 10175, '\p{Blk=dingbats}', "");
    Expect(0, 10175, '\p{^Blk=dingbats}', "");
    Expect(0, 10175, '\P{Blk=dingbats}', "");
    Expect(1, 10175, '\P{^Blk=dingbats}', "");
    Expect(0, 10176, '\p{Blk=dingbats}', "");
    Expect(1, 10176, '\p{^Blk=dingbats}', "");
    Expect(1, 10176, '\P{Blk=dingbats}', "");
    Expect(0, 10176, '\P{^Blk=dingbats}', "");
    Expect(1, 10175, '\p{Blk=	 DINGBATS}', "");
    Expect(0, 10175, '\p{^Blk=	 DINGBATS}', "");
    Expect(0, 10175, '\P{Blk=	 DINGBATS}', "");
    Expect(1, 10175, '\P{^Blk=	 DINGBATS}', "");
    Expect(0, 10176, '\p{Blk=	 DINGBATS}', "");
    Expect(1, 10176, '\p{^Blk=	 DINGBATS}', "");
    Expect(1, 10176, '\P{Blk=	 DINGBATS}', "");
    Expect(0, 10176, '\P{^Blk=	 DINGBATS}', "");
    Error('\p{Is_Block=--Dingbats/a/}');
    Error('\P{Is_Block=--Dingbats/a/}');
    Expect(1, 10175, '\p{Is_Block=dingbats}', "");
    Expect(0, 10175, '\p{^Is_Block=dingbats}', "");
    Expect(0, 10175, '\P{Is_Block=dingbats}', "");
    Expect(1, 10175, '\P{^Is_Block=dingbats}', "");
    Expect(0, 10176, '\p{Is_Block=dingbats}', "");
    Expect(1, 10176, '\p{^Is_Block=dingbats}', "");
    Expect(1, 10176, '\P{Is_Block=dingbats}', "");
    Expect(0, 10176, '\P{^Is_Block=dingbats}', "");
    Expect(1, 10175, '\p{Is_Block=_Dingbats}', "");
    Expect(0, 10175, '\p{^Is_Block=_Dingbats}', "");
    Expect(0, 10175, '\P{Is_Block=_Dingbats}', "");
    Expect(1, 10175, '\P{^Is_Block=_Dingbats}', "");
    Expect(0, 10176, '\p{Is_Block=_Dingbats}', "");
    Expect(1, 10176, '\p{^Is_Block=_Dingbats}', "");
    Expect(1, 10176, '\P{Is_Block=_Dingbats}', "");
    Expect(0, 10176, '\P{^Is_Block=_Dingbats}', "");
    Error('\p{Is_Blk=:=dingbats}');
    Error('\P{Is_Blk=:=dingbats}');
    Expect(1, 10175, '\p{Is_Blk=dingbats}', "");
    Expect(0, 10175, '\p{^Is_Blk=dingbats}', "");
    Expect(0, 10175, '\P{Is_Blk=dingbats}', "");
    Expect(1, 10175, '\P{^Is_Blk=dingbats}', "");
    Expect(0, 10176, '\p{Is_Blk=dingbats}', "");
    Expect(1, 10176, '\p{^Is_Blk=dingbats}', "");
    Expect(1, 10176, '\P{Is_Blk=dingbats}', "");
    Expect(0, 10176, '\P{^Is_Blk=dingbats}', "");
    Expect(1, 10175, '\p{Is_Blk=- dingbats}', "");
    Expect(0, 10175, '\p{^Is_Blk=- dingbats}', "");
    Expect(0, 10175, '\P{Is_Blk=- dingbats}', "");
    Expect(1, 10175, '\P{^Is_Blk=- dingbats}', "");
    Expect(0, 10176, '\p{Is_Blk=- dingbats}', "");
    Expect(1, 10176, '\p{^Is_Blk=- dingbats}', "");
    Expect(1, 10176, '\P{Is_Blk=- dingbats}', "");
    Expect(0, 10176, '\P{^Is_Blk=- dingbats}', "");
    Error('\p{Block=/a/		DOMINO_Tiles}');
    Error('\P{Block=/a/		DOMINO_Tiles}');
    Expect(1, 127135, '\p{Block=dominotiles}', "");
    Expect(0, 127135, '\p{^Block=dominotiles}', "");
    Expect(0, 127135, '\P{Block=dominotiles}', "");
    Expect(1, 127135, '\P{^Block=dominotiles}', "");
    Expect(0, 127136, '\p{Block=dominotiles}', "");
    Expect(1, 127136, '\p{^Block=dominotiles}', "");
    Expect(1, 127136, '\P{Block=dominotiles}', "");
    Expect(0, 127136, '\P{^Block=dominotiles}', "");
    Expect(1, 127135, '\p{Block=		domino_Tiles}', "");
    Expect(0, 127135, '\p{^Block=		domino_Tiles}', "");
    Expect(0, 127135, '\P{Block=		domino_Tiles}', "");
    Expect(1, 127135, '\P{^Block=		domino_Tiles}', "");
    Expect(0, 127136, '\p{Block=		domino_Tiles}', "");
    Expect(1, 127136, '\p{^Block=		domino_Tiles}', "");
    Expect(1, 127136, '\P{Block=		domino_Tiles}', "");
    Expect(0, 127136, '\P{^Block=		domino_Tiles}', "");
    Error('\p{Blk=Domino:=}');
    Error('\P{Blk=Domino:=}');
    Expect(1, 127135, '\p{Blk=domino}', "");
    Expect(0, 127135, '\p{^Blk=domino}', "");
    Expect(0, 127135, '\P{Blk=domino}', "");
    Expect(1, 127135, '\P{^Blk=domino}', "");
    Expect(0, 127136, '\p{Blk=domino}', "");
    Expect(1, 127136, '\p{^Blk=domino}', "");
    Expect(1, 127136, '\P{Blk=domino}', "");
    Expect(0, 127136, '\P{^Blk=domino}', "");
    Expect(1, 127135, '\p{Blk=		Domino}', "");
    Expect(0, 127135, '\p{^Blk=		Domino}', "");
    Expect(0, 127135, '\P{Blk=		Domino}', "");
    Expect(1, 127135, '\P{^Blk=		Domino}', "");
    Expect(0, 127136, '\p{Blk=		Domino}', "");
    Expect(1, 127136, '\p{^Blk=		Domino}', "");
    Expect(1, 127136, '\P{Blk=		Domino}', "");
    Expect(0, 127136, '\P{^Blk=		Domino}', "");
    Error('\p{Is_Block=:=_	DOMINO_TILES}');
    Error('\P{Is_Block=:=_	DOMINO_TILES}');
    Expect(1, 127135, '\p{Is_Block=dominotiles}', "");
    Expect(0, 127135, '\p{^Is_Block=dominotiles}', "");
    Expect(0, 127135, '\P{Is_Block=dominotiles}', "");
    Expect(1, 127135, '\P{^Is_Block=dominotiles}', "");
    Expect(0, 127136, '\p{Is_Block=dominotiles}', "");
    Expect(1, 127136, '\p{^Is_Block=dominotiles}', "");
    Expect(1, 127136, '\P{Is_Block=dominotiles}', "");
    Expect(0, 127136, '\P{^Is_Block=dominotiles}', "");
    Expect(1, 127135, '\p{Is_Block:    	DOMINO_TILES}', "");
    Expect(0, 127135, '\p{^Is_Block:    	DOMINO_TILES}', "");
    Expect(0, 127135, '\P{Is_Block:    	DOMINO_TILES}', "");
    Expect(1, 127135, '\P{^Is_Block:    	DOMINO_TILES}', "");
    Expect(0, 127136, '\p{Is_Block:    	DOMINO_TILES}', "");
    Expect(1, 127136, '\p{^Is_Block:    	DOMINO_TILES}', "");
    Expect(1, 127136, '\P{Is_Block:    	DOMINO_TILES}', "");
    Expect(0, 127136, '\P{^Is_Block:    	DOMINO_TILES}', "");
    Error('\p{Is_Blk= /a/DOMINO}');
    Error('\P{Is_Blk= /a/DOMINO}');
    Expect(1, 127135, '\p{Is_Blk=domino}', "");
    Expect(0, 127135, '\p{^Is_Blk=domino}', "");
    Expect(0, 127135, '\P{Is_Blk=domino}', "");
    Expect(1, 127135, '\P{^Is_Blk=domino}', "");
    Expect(0, 127136, '\p{Is_Blk=domino}', "");
    Expect(1, 127136, '\p{^Is_Blk=domino}', "");
    Expect(1, 127136, '\P{Is_Blk=domino}', "");
    Expect(0, 127136, '\P{^Is_Blk=domino}', "");
    Expect(1, 127135, '\p{Is_Blk:   _-Domino}', "");
    Expect(0, 127135, '\p{^Is_Blk:   _-Domino}', "");
    Expect(0, 127135, '\P{Is_Blk:   _-Domino}', "");
    Expect(1, 127135, '\P{^Is_Blk:   _-Domino}', "");
    Expect(0, 127136, '\p{Is_Blk:   _-Domino}', "");
    Expect(1, 127136, '\p{^Is_Blk:   _-Domino}', "");
    Expect(1, 127136, '\P{Is_Blk:   _-Domino}', "");
    Expect(0, 127136, '\P{^Is_Blk:   _-Domino}', "");
    Error('\p{Block=/a/ Duployan}');
    Error('\P{Block=/a/ Duployan}');
    Expect(1, 113823, '\p{Block=duployan}', "");
    Expect(0, 113823, '\p{^Block=duployan}', "");
    Expect(0, 113823, '\P{Block=duployan}', "");
    Expect(1, 113823, '\P{^Block=duployan}', "");
    Expect(0, 113824, '\p{Block=duployan}', "");
    Expect(1, 113824, '\p{^Block=duployan}', "");
    Expect(1, 113824, '\P{Block=duployan}', "");
    Expect(0, 113824, '\P{^Block=duployan}', "");
    Expect(1, 113823, '\p{Block= 	DUPLOYAN}', "");
    Expect(0, 113823, '\p{^Block= 	DUPLOYAN}', "");
    Expect(0, 113823, '\P{Block= 	DUPLOYAN}', "");
    Expect(1, 113823, '\P{^Block= 	DUPLOYAN}', "");
    Expect(0, 113824, '\p{Block= 	DUPLOYAN}', "");
    Expect(1, 113824, '\p{^Block= 	DUPLOYAN}', "");
    Expect(1, 113824, '\P{Block= 	DUPLOYAN}', "");
    Expect(0, 113824, '\P{^Block= 	DUPLOYAN}', "");
    Error('\p{Blk:	:=duployan}');
    Error('\P{Blk:	:=duployan}');
    Expect(1, 113823, '\p{Blk=duployan}', "");
    Expect(0, 113823, '\p{^Blk=duployan}', "");
    Expect(0, 113823, '\P{Blk=duployan}', "");
    Expect(1, 113823, '\P{^Blk=duployan}', "");
    Expect(0, 113824, '\p{Blk=duployan}', "");
    Expect(1, 113824, '\p{^Blk=duployan}', "");
    Expect(1, 113824, '\P{Blk=duployan}', "");
    Expect(0, 113824, '\P{^Blk=duployan}', "");
    Expect(1, 113823, '\p{Blk=_ Duployan}', "");
    Expect(0, 113823, '\p{^Blk=_ Duployan}', "");
    Expect(0, 113823, '\P{Blk=_ Duployan}', "");
    Expect(1, 113823, '\P{^Blk=_ Duployan}', "");
    Expect(0, 113824, '\p{Blk=_ Duployan}', "");
    Expect(1, 113824, '\p{^Blk=_ Duployan}', "");
    Expect(1, 113824, '\P{Blk=_ Duployan}', "");
    Expect(0, 113824, '\P{^Blk=_ Duployan}', "");
    Error('\p{Is_Block=	/a/duployan}');
    Error('\P{Is_Block=	/a/duployan}');
    Expect(1, 113823, '\p{Is_Block=duployan}', "");
    Expect(0, 113823, '\p{^Is_Block=duployan}', "");
    Expect(0, 113823, '\P{Is_Block=duployan}', "");
    Expect(1, 113823, '\P{^Is_Block=duployan}', "");
    Expect(0, 113824, '\p{Is_Block=duployan}', "");
    Expect(1, 113824, '\p{^Is_Block=duployan}', "");
    Expect(1, 113824, '\P{Is_Block=duployan}', "");
    Expect(0, 113824, '\P{^Is_Block=duployan}', "");
    Expect(1, 113823, '\p{Is_Block=-DUPLOYAN}', "");
    Expect(0, 113823, '\p{^Is_Block=-DUPLOYAN}', "");
    Expect(0, 113823, '\P{Is_Block=-DUPLOYAN}', "");
    Expect(1, 113823, '\P{^Is_Block=-DUPLOYAN}', "");
    Expect(0, 113824, '\p{Is_Block=-DUPLOYAN}', "");
    Expect(1, 113824, '\p{^Is_Block=-DUPLOYAN}', "");
    Expect(1, 113824, '\P{Is_Block=-DUPLOYAN}', "");
    Expect(0, 113824, '\P{^Is_Block=-DUPLOYAN}', "");
    Error('\p{Is_Blk:	:= Duployan}');
    Error('\P{Is_Blk:	:= Duployan}');
    Expect(1, 113823, '\p{Is_Blk:duployan}', "");
    Expect(0, 113823, '\p{^Is_Blk:duployan}', "");
    Expect(0, 113823, '\P{Is_Blk:duployan}', "");
    Expect(1, 113823, '\P{^Is_Blk:duployan}', "");
    Expect(0, 113824, '\p{Is_Blk:duployan}', "");
    Expect(1, 113824, '\p{^Is_Blk:duployan}', "");
    Expect(1, 113824, '\P{Is_Blk:duployan}', "");
    Expect(0, 113824, '\P{^Is_Blk:duployan}', "");
    Expect(1, 113823, '\p{Is_Blk=	 duployan}', "");
    Expect(0, 113823, '\p{^Is_Blk=	 duployan}', "");
    Expect(0, 113823, '\P{Is_Blk=	 duployan}', "");
    Expect(1, 113823, '\P{^Is_Blk=	 duployan}', "");
    Expect(0, 113824, '\p{Is_Blk=	 duployan}', "");
    Expect(1, 113824, '\p{^Is_Blk=	 duployan}', "");
    Expect(1, 113824, '\P{Is_Blk=	 duployan}', "");
    Expect(0, 113824, '\P{^Is_Blk=	 duployan}', "");
    Error('\p{Block= :=Early_dynastic_CUNEIFORM}');
    Error('\P{Block= :=Early_dynastic_CUNEIFORM}');
    Expect(1, 75087, '\p{Block=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^Block=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{Block=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^Block=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{Block=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^Block=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{Block=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^Block=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{Block= Early_Dynastic_CUNEIFORM}', "");
    Expect(0, 75087, '\p{^Block= Early_Dynastic_CUNEIFORM}', "");
    Expect(0, 75087, '\P{Block= Early_Dynastic_CUNEIFORM}', "");
    Expect(1, 75087, '\P{^Block= Early_Dynastic_CUNEIFORM}', "");
    Expect(0, 75088, '\p{Block= Early_Dynastic_CUNEIFORM}', "");
    Expect(1, 75088, '\p{^Block= Early_Dynastic_CUNEIFORM}', "");
    Expect(1, 75088, '\P{Block= Early_Dynastic_CUNEIFORM}', "");
    Expect(0, 75088, '\P{^Block= Early_Dynastic_CUNEIFORM}', "");
    Error('\p{Blk=-:=early_Dynastic_cuneiform}');
    Error('\P{Blk=-:=early_Dynastic_cuneiform}');
    Expect(1, 75087, '\p{Blk=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^Blk=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{Blk=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^Blk=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{Blk=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^Blk=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{Blk=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^Blk=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{Blk=- EARLY_dynastic_CUNEIFORM}', "");
    Expect(0, 75087, '\p{^Blk=- EARLY_dynastic_CUNEIFORM}', "");
    Expect(0, 75087, '\P{Blk=- EARLY_dynastic_CUNEIFORM}', "");
    Expect(1, 75087, '\P{^Blk=- EARLY_dynastic_CUNEIFORM}', "");
    Expect(0, 75088, '\p{Blk=- EARLY_dynastic_CUNEIFORM}', "");
    Expect(1, 75088, '\p{^Blk=- EARLY_dynastic_CUNEIFORM}', "");
    Expect(1, 75088, '\P{Blk=- EARLY_dynastic_CUNEIFORM}', "");
    Expect(0, 75088, '\P{^Blk=- EARLY_dynastic_CUNEIFORM}', "");
    Error('\p{Is_Block=:=Early_DYNASTIC_cuneiform}');
    Error('\P{Is_Block=:=Early_DYNASTIC_cuneiform}');
    Expect(1, 75087, '\p{Is_Block:	earlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^Is_Block:	earlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{Is_Block:	earlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^Is_Block:	earlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{Is_Block:	earlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^Is_Block:	earlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{Is_Block:	earlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^Is_Block:	earlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{Is_Block=--Early_Dynastic_Cuneiform}', "");
    Expect(0, 75087, '\p{^Is_Block=--Early_Dynastic_Cuneiform}', "");
    Expect(0, 75087, '\P{Is_Block=--Early_Dynastic_Cuneiform}', "");
    Expect(1, 75087, '\P{^Is_Block=--Early_Dynastic_Cuneiform}', "");
    Expect(0, 75088, '\p{Is_Block=--Early_Dynastic_Cuneiform}', "");
    Expect(1, 75088, '\p{^Is_Block=--Early_Dynastic_Cuneiform}', "");
    Expect(1, 75088, '\P{Is_Block=--Early_Dynastic_Cuneiform}', "");
    Expect(0, 75088, '\P{^Is_Block=--Early_Dynastic_Cuneiform}', "");
    Error('\p{Is_Blk=/a/_Early_Dynastic_Cuneiform}');
    Error('\P{Is_Blk=/a/_Early_Dynastic_Cuneiform}');
    Expect(1, 75087, '\p{Is_Blk=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^Is_Blk=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{Is_Blk=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^Is_Blk=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{Is_Blk=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^Is_Blk=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{Is_Blk=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^Is_Blk=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{Is_Blk: -EARLY_dynastic_cuneiform}', "");
    Expect(0, 75087, '\p{^Is_Blk: -EARLY_dynastic_cuneiform}', "");
    Expect(0, 75087, '\P{Is_Blk: -EARLY_dynastic_cuneiform}', "");
    Expect(1, 75087, '\P{^Is_Blk: -EARLY_dynastic_cuneiform}', "");
    Expect(0, 75088, '\p{Is_Blk: -EARLY_dynastic_cuneiform}', "");
    Expect(1, 75088, '\p{^Is_Blk: -EARLY_dynastic_cuneiform}', "");
    Expect(1, 75088, '\P{Is_Blk: -EARLY_dynastic_cuneiform}', "");
    Expect(0, 75088, '\P{^Is_Blk: -EARLY_dynastic_cuneiform}', "");
    Error('\p{Block= :=egyptian_HIEROGLYPHS}');
    Error('\P{Block= :=egyptian_HIEROGLYPHS}');
    Expect(1, 78895, '\p{Block=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{^Block=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{Block=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{^Block=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\p{Block=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\p{^Block=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\P{Block=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\P{^Block=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{Block=_ Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\p{^Block=_ Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\P{Block=_ Egyptian_Hieroglyphs}', "");
    Expect(1, 78895, '\P{^Block=_ Egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\p{Block=_ Egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\p{^Block=_ Egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\P{Block=_ Egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\P{^Block=_ Egyptian_Hieroglyphs}', "");
    Error('\p{Blk=_-Egyptian_Hieroglyphs/a/}');
    Error('\P{Blk=_-Egyptian_Hieroglyphs/a/}');
    Expect(1, 78895, '\p{Blk=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{^Blk=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{Blk=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{^Blk=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\p{Blk=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\p{^Blk=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\P{Blk=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\P{^Blk=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{Blk=  egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\p{^Blk=  egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\P{Blk=  egyptian_Hieroglyphs}', "");
    Expect(1, 78895, '\P{^Blk=  egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\p{Blk=  egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\p{^Blk=  egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\P{Blk=  egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\P{^Blk=  egyptian_Hieroglyphs}', "");
    Error('\p{Is_Block=/a/-_Egyptian_HIEROGLYPHS}');
    Error('\P{Is_Block=/a/-_Egyptian_HIEROGLYPHS}');
    Expect(1, 78895, '\p{Is_Block=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{^Is_Block=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{Is_Block=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{^Is_Block=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\p{Is_Block=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\p{^Is_Block=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\P{Is_Block=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\P{^Is_Block=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{Is_Block=_	EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78895, '\p{^Is_Block=_	EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78895, '\P{Is_Block=_	EGYPTIAN_Hieroglyphs}', "");
    Expect(1, 78895, '\P{^Is_Block=_	EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78896, '\p{Is_Block=_	EGYPTIAN_Hieroglyphs}', "");
    Expect(1, 78896, '\p{^Is_Block=_	EGYPTIAN_Hieroglyphs}', "");
    Expect(1, 78896, '\P{Is_Block=_	EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78896, '\P{^Is_Block=_	EGYPTIAN_Hieroglyphs}', "");
    Error('\p{Is_Blk=:= egyptian_hieroglyphs}');
    Error('\P{Is_Blk=:= egyptian_hieroglyphs}');
    Expect(1, 78895, '\p{Is_Blk=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{^Is_Blk=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{Is_Blk=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{^Is_Blk=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\p{Is_Blk=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\p{^Is_Blk=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\P{Is_Blk=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\P{^Is_Blk=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{Is_Blk= -Egyptian_hieroglyphs}', "");
    Expect(0, 78895, '\p{^Is_Blk= -Egyptian_hieroglyphs}', "");
    Expect(0, 78895, '\P{Is_Blk= -Egyptian_hieroglyphs}', "");
    Expect(1, 78895, '\P{^Is_Blk= -Egyptian_hieroglyphs}', "");
    Expect(0, 78896, '\p{Is_Blk= -Egyptian_hieroglyphs}', "");
    Expect(1, 78896, '\p{^Is_Blk= -Egyptian_hieroglyphs}', "");
    Expect(1, 78896, '\P{Is_Blk= -Egyptian_hieroglyphs}', "");
    Expect(0, 78896, '\P{^Is_Blk= -Egyptian_hieroglyphs}', "");
    Error('\p{Block=/a/ 	Elbasan}');
    Error('\P{Block=/a/ 	Elbasan}');
    Expect(1, 66863, '\p{Block=elbasan}', "");
    Expect(0, 66863, '\p{^Block=elbasan}', "");
    Expect(0, 66863, '\P{Block=elbasan}', "");
    Expect(1, 66863, '\P{^Block=elbasan}', "");
    Expect(0, 66864, '\p{Block=elbasan}', "");
    Expect(1, 66864, '\p{^Block=elbasan}', "");
    Expect(1, 66864, '\P{Block=elbasan}', "");
    Expect(0, 66864, '\P{^Block=elbasan}', "");
    Expect(1, 66863, '\p{Block=-_elbasan}', "");
    Expect(0, 66863, '\p{^Block=-_elbasan}', "");
    Expect(0, 66863, '\P{Block=-_elbasan}', "");
    Expect(1, 66863, '\P{^Block=-_elbasan}', "");
    Expect(0, 66864, '\p{Block=-_elbasan}', "");
    Expect(1, 66864, '\p{^Block=-_elbasan}', "");
    Expect(1, 66864, '\P{Block=-_elbasan}', "");
    Expect(0, 66864, '\P{^Block=-_elbasan}', "");
    Error('\p{Blk=:=	elbasan}');
    Error('\P{Blk=:=	elbasan}');
    Expect(1, 66863, '\p{Blk=elbasan}', "");
    Expect(0, 66863, '\p{^Blk=elbasan}', "");
    Expect(0, 66863, '\P{Blk=elbasan}', "");
    Expect(1, 66863, '\P{^Blk=elbasan}', "");
    Expect(0, 66864, '\p{Blk=elbasan}', "");
    Expect(1, 66864, '\p{^Blk=elbasan}', "");
    Expect(1, 66864, '\P{Blk=elbasan}', "");
    Expect(0, 66864, '\P{^Blk=elbasan}', "");
    Expect(1, 66863, '\p{Blk=	-Elbasan}', "");
    Expect(0, 66863, '\p{^Blk=	-Elbasan}', "");
    Expect(0, 66863, '\P{Blk=	-Elbasan}', "");
    Expect(1, 66863, '\P{^Blk=	-Elbasan}', "");
    Expect(0, 66864, '\p{Blk=	-Elbasan}', "");
    Expect(1, 66864, '\p{^Blk=	-Elbasan}', "");
    Expect(1, 66864, '\P{Blk=	-Elbasan}', "");
    Expect(0, 66864, '\P{^Blk=	-Elbasan}', "");
    Error('\p{Is_Block=:=	 ELBASAN}');
    Error('\P{Is_Block=:=	 ELBASAN}');
    Expect(1, 66863, '\p{Is_Block=elbasan}', "");
    Expect(0, 66863, '\p{^Is_Block=elbasan}', "");
    Expect(0, 66863, '\P{Is_Block=elbasan}', "");
    Expect(1, 66863, '\P{^Is_Block=elbasan}', "");
    Expect(0, 66864, '\p{Is_Block=elbasan}', "");
    Expect(1, 66864, '\p{^Is_Block=elbasan}', "");
    Expect(1, 66864, '\P{Is_Block=elbasan}', "");
    Expect(0, 66864, '\P{^Is_Block=elbasan}', "");
    Expect(1, 66863, '\p{Is_Block=	_Elbasan}', "");
    Expect(0, 66863, '\p{^Is_Block=	_Elbasan}', "");
    Expect(0, 66863, '\P{Is_Block=	_Elbasan}', "");
    Expect(1, 66863, '\P{^Is_Block=	_Elbasan}', "");
    Expect(0, 66864, '\p{Is_Block=	_Elbasan}', "");
    Expect(1, 66864, '\p{^Is_Block=	_Elbasan}', "");
    Expect(1, 66864, '\P{Is_Block=	_Elbasan}', "");
    Expect(0, 66864, '\P{^Is_Block=	_Elbasan}', "");
    Error('\p{Is_Blk=:= elbasan}');
    Error('\P{Is_Blk=:= elbasan}');
    Expect(1, 66863, '\p{Is_Blk=elbasan}', "");
    Expect(0, 66863, '\p{^Is_Blk=elbasan}', "");
    Expect(0, 66863, '\P{Is_Blk=elbasan}', "");
    Expect(1, 66863, '\P{^Is_Blk=elbasan}', "");
    Expect(0, 66864, '\p{Is_Blk=elbasan}', "");
    Expect(1, 66864, '\p{^Is_Blk=elbasan}', "");
    Expect(1, 66864, '\P{Is_Blk=elbasan}', "");
    Expect(0, 66864, '\P{^Is_Blk=elbasan}', "");
    Expect(1, 66863, '\p{Is_Blk=		Elbasan}', "");
    Expect(0, 66863, '\p{^Is_Blk=		Elbasan}', "");
    Expect(0, 66863, '\P{Is_Blk=		Elbasan}', "");
    Expect(1, 66863, '\P{^Is_Blk=		Elbasan}', "");
    Expect(0, 66864, '\p{Is_Blk=		Elbasan}', "");
    Expect(1, 66864, '\p{^Is_Blk=		Elbasan}', "");
    Expect(1, 66864, '\P{Is_Blk=		Elbasan}', "");
    Expect(0, 66864, '\P{^Is_Blk=		Elbasan}', "");
    Error('\p{Block=/a/Emoticons}');
    Error('\P{Block=/a/Emoticons}');
    Expect(1, 128591, '\p{Block=emoticons}', "");
    Expect(0, 128591, '\p{^Block=emoticons}', "");
    Expect(0, 128591, '\P{Block=emoticons}', "");
    Expect(1, 128591, '\P{^Block=emoticons}', "");
    Expect(0, 128592, '\p{Block=emoticons}', "");
    Expect(1, 128592, '\p{^Block=emoticons}', "");
    Expect(1, 128592, '\P{Block=emoticons}', "");
    Expect(0, 128592, '\P{^Block=emoticons}', "");
    Expect(1, 128591, '\p{Block= -Emoticons}', "");
    Expect(0, 128591, '\p{^Block= -Emoticons}', "");
    Expect(0, 128591, '\P{Block= -Emoticons}', "");
    Expect(1, 128591, '\P{^Block= -Emoticons}', "");
    Expect(0, 128592, '\p{Block= -Emoticons}', "");
    Expect(1, 128592, '\p{^Block= -Emoticons}', "");
    Expect(1, 128592, '\P{Block= -Emoticons}', "");
    Expect(0, 128592, '\P{^Block= -Emoticons}', "");
    Error('\p{Blk=_	EMOTICONS:=}');
    Error('\P{Blk=_	EMOTICONS:=}');
    Expect(1, 128591, '\p{Blk=emoticons}', "");
    Expect(0, 128591, '\p{^Blk=emoticons}', "");
    Expect(0, 128591, '\P{Blk=emoticons}', "");
    Expect(1, 128591, '\P{^Blk=emoticons}', "");
    Expect(0, 128592, '\p{Blk=emoticons}', "");
    Expect(1, 128592, '\p{^Blk=emoticons}', "");
    Expect(1, 128592, '\P{Blk=emoticons}', "");
    Expect(0, 128592, '\P{^Blk=emoticons}', "");
    Expect(1, 128591, '\p{Blk=_-Emoticons}', "");
    Expect(0, 128591, '\p{^Blk=_-Emoticons}', "");
    Expect(0, 128591, '\P{Blk=_-Emoticons}', "");
    Expect(1, 128591, '\P{^Blk=_-Emoticons}', "");
    Expect(0, 128592, '\p{Blk=_-Emoticons}', "");
    Expect(1, 128592, '\p{^Blk=_-Emoticons}', "");
    Expect(1, 128592, '\P{Blk=_-Emoticons}', "");
    Expect(0, 128592, '\P{^Blk=_-Emoticons}', "");
    Error('\p{Is_Block=-	EMOTICONS/a/}');
    Error('\P{Is_Block=-	EMOTICONS/a/}');
    Expect(1, 128591, '\p{Is_Block=emoticons}', "");
    Expect(0, 128591, '\p{^Is_Block=emoticons}', "");
    Expect(0, 128591, '\P{Is_Block=emoticons}', "");
    Expect(1, 128591, '\P{^Is_Block=emoticons}', "");
    Expect(0, 128592, '\p{Is_Block=emoticons}', "");
    Expect(1, 128592, '\p{^Is_Block=emoticons}', "");
    Expect(1, 128592, '\P{Is_Block=emoticons}', "");
    Expect(0, 128592, '\P{^Is_Block=emoticons}', "");
    Expect(1, 128591, '\p{Is_Block=	Emoticons}', "");
    Expect(0, 128591, '\p{^Is_Block=	Emoticons}', "");
    Expect(0, 128591, '\P{Is_Block=	Emoticons}', "");
    Expect(1, 128591, '\P{^Is_Block=	Emoticons}', "");
    Expect(0, 128592, '\p{Is_Block=	Emoticons}', "");
    Expect(1, 128592, '\p{^Is_Block=	Emoticons}', "");
    Expect(1, 128592, '\P{Is_Block=	Emoticons}', "");
    Expect(0, 128592, '\P{^Is_Block=	Emoticons}', "");
    Error('\p{Is_Blk=:=Emoticons}');
    Error('\P{Is_Blk=:=Emoticons}');
    Expect(1, 128591, '\p{Is_Blk=emoticons}', "");
    Expect(0, 128591, '\p{^Is_Blk=emoticons}', "");
    Expect(0, 128591, '\P{Is_Blk=emoticons}', "");
    Expect(1, 128591, '\P{^Is_Blk=emoticons}', "");
    Expect(0, 128592, '\p{Is_Blk=emoticons}', "");
    Expect(1, 128592, '\p{^Is_Blk=emoticons}', "");
    Expect(1, 128592, '\P{Is_Blk=emoticons}', "");
    Expect(0, 128592, '\P{^Is_Blk=emoticons}', "");
    Expect(1, 128591, '\p{Is_Blk=-emoticons}', "");
    Expect(0, 128591, '\p{^Is_Blk=-emoticons}', "");
    Expect(0, 128591, '\P{Is_Blk=-emoticons}', "");
    Expect(1, 128591, '\P{^Is_Blk=-emoticons}', "");
    Expect(0, 128592, '\p{Is_Blk=-emoticons}', "");
    Expect(1, 128592, '\p{^Is_Blk=-emoticons}', "");
    Expect(1, 128592, '\P{Is_Blk=-emoticons}', "");
    Expect(0, 128592, '\P{^Is_Blk=-emoticons}', "");
    Error('\p{Block= :=ENCLOSED_Alphanumerics}');
    Error('\P{Block= :=ENCLOSED_Alphanumerics}');
    Expect(1, 9471, '\p{Block=enclosedalphanumerics}', "");
    Expect(0, 9471, '\p{^Block=enclosedalphanumerics}', "");
    Expect(0, 9471, '\P{Block=enclosedalphanumerics}', "");
    Expect(1, 9471, '\P{^Block=enclosedalphanumerics}', "");
    Expect(0, 9472, '\p{Block=enclosedalphanumerics}', "");
    Expect(1, 9472, '\p{^Block=enclosedalphanumerics}', "");
    Expect(1, 9472, '\P{Block=enclosedalphanumerics}', "");
    Expect(0, 9472, '\P{^Block=enclosedalphanumerics}', "");
    Expect(1, 9471, '\p{Block= Enclosed_ALPHANUMERICS}', "");
    Expect(0, 9471, '\p{^Block= Enclosed_ALPHANUMERICS}', "");
    Expect(0, 9471, '\P{Block= Enclosed_ALPHANUMERICS}', "");
    Expect(1, 9471, '\P{^Block= Enclosed_ALPHANUMERICS}', "");
    Expect(0, 9472, '\p{Block= Enclosed_ALPHANUMERICS}', "");
    Expect(1, 9472, '\p{^Block= Enclosed_ALPHANUMERICS}', "");
    Expect(1, 9472, '\P{Block= Enclosed_ALPHANUMERICS}', "");
    Expect(0, 9472, '\P{^Block= Enclosed_ALPHANUMERICS}', "");
    Error('\p{Blk: /a/Enclosed_Alphanum}');
    Error('\P{Blk: /a/Enclosed_Alphanum}');
    Expect(1, 9471, '\p{Blk=enclosedalphanum}', "");
    Expect(0, 9471, '\p{^Blk=enclosedalphanum}', "");
    Expect(0, 9471, '\P{Blk=enclosedalphanum}', "");
    Expect(1, 9471, '\P{^Blk=enclosedalphanum}', "");
    Expect(0, 9472, '\p{Blk=enclosedalphanum}', "");
    Expect(1, 9472, '\p{^Blk=enclosedalphanum}', "");
    Expect(1, 9472, '\P{Blk=enclosedalphanum}', "");
    Expect(0, 9472, '\P{^Blk=enclosedalphanum}', "");
    Expect(1, 9471, '\p{Blk: _Enclosed_alphanum}', "");
    Expect(0, 9471, '\p{^Blk: _Enclosed_alphanum}', "");
    Expect(0, 9471, '\P{Blk: _Enclosed_alphanum}', "");
    Expect(1, 9471, '\P{^Blk: _Enclosed_alphanum}', "");
    Expect(0, 9472, '\p{Blk: _Enclosed_alphanum}', "");
    Expect(1, 9472, '\p{^Blk: _Enclosed_alphanum}', "");
    Expect(1, 9472, '\P{Blk: _Enclosed_alphanum}', "");
    Expect(0, 9472, '\P{^Blk: _Enclosed_alphanum}', "");
    Error('\p{Is_Block=/a/ Enclosed_Alphanumerics}');
    Error('\P{Is_Block=/a/ Enclosed_Alphanumerics}');
    Expect(1, 9471, '\p{Is_Block=enclosedalphanumerics}', "");
    Expect(0, 9471, '\p{^Is_Block=enclosedalphanumerics}', "");
    Expect(0, 9471, '\P{Is_Block=enclosedalphanumerics}', "");
    Expect(1, 9471, '\P{^Is_Block=enclosedalphanumerics}', "");
    Expect(0, 9472, '\p{Is_Block=enclosedalphanumerics}', "");
    Expect(1, 9472, '\p{^Is_Block=enclosedalphanumerics}', "");
    Expect(1, 9472, '\P{Is_Block=enclosedalphanumerics}', "");
    Expect(0, 9472, '\P{^Is_Block=enclosedalphanumerics}', "");
    Expect(1, 9471, '\p{Is_Block=	enclosed_Alphanumerics}', "");
    Expect(0, 9471, '\p{^Is_Block=	enclosed_Alphanumerics}', "");
    Expect(0, 9471, '\P{Is_Block=	enclosed_Alphanumerics}', "");
    Expect(1, 9471, '\P{^Is_Block=	enclosed_Alphanumerics}', "");
    Expect(0, 9472, '\p{Is_Block=	enclosed_Alphanumerics}', "");
    Expect(1, 9472, '\p{^Is_Block=	enclosed_Alphanumerics}', "");
    Expect(1, 9472, '\P{Is_Block=	enclosed_Alphanumerics}', "");
    Expect(0, 9472, '\P{^Is_Block=	enclosed_Alphanumerics}', "");
    Error('\p{Is_Blk: 	ENCLOSED_Alphanum/a/}');
    Error('\P{Is_Blk: 	ENCLOSED_Alphanum/a/}');
    Expect(1, 9471, '\p{Is_Blk=enclosedalphanum}', "");
    Expect(0, 9471, '\p{^Is_Blk=enclosedalphanum}', "");
    Expect(0, 9471, '\P{Is_Blk=enclosedalphanum}', "");
    Expect(1, 9471, '\P{^Is_Blk=enclosedalphanum}', "");
    Expect(0, 9472, '\p{Is_Blk=enclosedalphanum}', "");
    Expect(1, 9472, '\p{^Is_Blk=enclosedalphanum}', "");
    Expect(1, 9472, '\P{Is_Blk=enclosedalphanum}', "");
    Expect(0, 9472, '\P{^Is_Blk=enclosedalphanum}', "");
    Expect(1, 9471, '\p{Is_Blk=Enclosed_ALPHANUM}', "");
    Expect(0, 9471, '\p{^Is_Blk=Enclosed_ALPHANUM}', "");
    Expect(0, 9471, '\P{Is_Blk=Enclosed_ALPHANUM}', "");
    Expect(1, 9471, '\P{^Is_Blk=Enclosed_ALPHANUM}', "");
    Expect(0, 9472, '\p{Is_Blk=Enclosed_ALPHANUM}', "");
    Expect(1, 9472, '\p{^Is_Blk=Enclosed_ALPHANUM}', "");
    Expect(1, 9472, '\P{Is_Blk=Enclosed_ALPHANUM}', "");
    Expect(0, 9472, '\P{^Is_Blk=Enclosed_ALPHANUM}', "");
    Error('\p{Block=_/a/enclosed_alphanumeric_SUPPLEMENT}');
    Error('\P{Block=_/a/enclosed_alphanumeric_SUPPLEMENT}');
    Expect(1, 127487, '\p{Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\p{^Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\P{Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\P{^Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\p{Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\p{^Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\P{Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\P{^Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\p{Block=  Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127487, '\p{^Block=  Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127487, '\P{Block=  Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(1, 127487, '\P{^Block=  Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127488, '\p{Block=  Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(1, 127488, '\p{^Block=  Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(1, 127488, '\P{Block=  Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127488, '\P{^Block=  Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Error('\p{Blk=_-ENCLOSED_Alphanum_Sup/a/}');
    Error('\P{Blk=_-ENCLOSED_Alphanum_Sup/a/}');
    Expect(1, 127487, '\p{Blk=enclosedalphanumsup}', "");
    Expect(0, 127487, '\p{^Blk=enclosedalphanumsup}', "");
    Expect(0, 127487, '\P{Blk=enclosedalphanumsup}', "");
    Expect(1, 127487, '\P{^Blk=enclosedalphanumsup}', "");
    Expect(0, 127488, '\p{Blk=enclosedalphanumsup}', "");
    Expect(1, 127488, '\p{^Blk=enclosedalphanumsup}', "");
    Expect(1, 127488, '\P{Blk=enclosedalphanumsup}', "");
    Expect(0, 127488, '\P{^Blk=enclosedalphanumsup}', "");
    Expect(1, 127487, '\p{Blk=- Enclosed_Alphanum_sup}', "");
    Expect(0, 127487, '\p{^Blk=- Enclosed_Alphanum_sup}', "");
    Expect(0, 127487, '\P{Blk=- Enclosed_Alphanum_sup}', "");
    Expect(1, 127487, '\P{^Blk=- Enclosed_Alphanum_sup}', "");
    Expect(0, 127488, '\p{Blk=- Enclosed_Alphanum_sup}', "");
    Expect(1, 127488, '\p{^Blk=- Enclosed_Alphanum_sup}', "");
    Expect(1, 127488, '\P{Blk=- Enclosed_Alphanum_sup}', "");
    Expect(0, 127488, '\P{^Blk=- Enclosed_Alphanum_sup}', "");
    Error('\p{Is_Block=:=Enclosed_alphanumeric_Supplement}');
    Error('\P{Is_Block=:=Enclosed_alphanumeric_Supplement}');
    Expect(1, 127487, '\p{Is_Block:enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\p{^Is_Block:enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\P{Is_Block:enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\P{^Is_Block:enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\p{Is_Block:enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\p{^Is_Block:enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\P{Is_Block:enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\P{^Is_Block:enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\p{Is_Block:  	Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127487, '\p{^Is_Block:  	Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127487, '\P{Is_Block:  	Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(1, 127487, '\P{^Is_Block:  	Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127488, '\p{Is_Block:  	Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(1, 127488, '\p{^Is_Block:  	Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(1, 127488, '\P{Is_Block:  	Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127488, '\P{^Is_Block:  	Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Error('\p{Is_Blk=:= _ENCLOSED_Alphanum_Sup}');
    Error('\P{Is_Blk=:= _ENCLOSED_Alphanum_Sup}');
    Expect(1, 127487, '\p{Is_Blk=enclosedalphanumsup}', "");
    Expect(0, 127487, '\p{^Is_Blk=enclosedalphanumsup}', "");
    Expect(0, 127487, '\P{Is_Blk=enclosedalphanumsup}', "");
    Expect(1, 127487, '\P{^Is_Blk=enclosedalphanumsup}', "");
    Expect(0, 127488, '\p{Is_Blk=enclosedalphanumsup}', "");
    Expect(1, 127488, '\p{^Is_Blk=enclosedalphanumsup}', "");
    Expect(1, 127488, '\P{Is_Blk=enclosedalphanumsup}', "");
    Expect(0, 127488, '\P{^Is_Blk=enclosedalphanumsup}', "");
    Expect(1, 127487, '\p{Is_Blk= -enclosed_Alphanum_sup}', "");
    Expect(0, 127487, '\p{^Is_Blk= -enclosed_Alphanum_sup}', "");
    Expect(0, 127487, '\P{Is_Blk= -enclosed_Alphanum_sup}', "");
    Expect(1, 127487, '\P{^Is_Blk= -enclosed_Alphanum_sup}', "");
    Expect(0, 127488, '\p{Is_Blk= -enclosed_Alphanum_sup}', "");
    Expect(1, 127488, '\p{^Is_Blk= -enclosed_Alphanum_sup}', "");
    Expect(1, 127488, '\P{Is_Blk= -enclosed_Alphanum_sup}', "");
    Expect(0, 127488, '\P{^Is_Blk= -enclosed_Alphanum_sup}', "");
    Error('\p{Block=_-Enclosed_CJK_LETTERS_AND_Months/a/}');
    Error('\P{Block=_-Enclosed_CJK_LETTERS_AND_Months/a/}');
    Expect(1, 13055, '\p{Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\p{^Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\P{Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\P{^Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\p{Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\p{^Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\P{Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\P{^Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\p{Block= -enclosed_cjk_Letters_And_Months}', "");
    Expect(0, 13055, '\p{^Block= -enclosed_cjk_Letters_And_Months}', "");
    Expect(0, 13055, '\P{Block= -enclosed_cjk_Letters_And_Months}', "");
    Expect(1, 13055, '\P{^Block= -enclosed_cjk_Letters_And_Months}', "");
    Expect(0, 13056, '\p{Block= -enclosed_cjk_Letters_And_Months}', "");
    Expect(1, 13056, '\p{^Block= -enclosed_cjk_Letters_And_Months}', "");
    Expect(1, 13056, '\P{Block= -enclosed_cjk_Letters_And_Months}', "");
    Expect(0, 13056, '\P{^Block= -enclosed_cjk_Letters_And_Months}', "");
    Error('\p{Blk=/a/ENCLOSED_CJK}');
    Error('\P{Blk=/a/ENCLOSED_CJK}');
    Expect(1, 13055, '\p{Blk=enclosedcjk}', "");
    Expect(0, 13055, '\p{^Blk=enclosedcjk}', "");
    Expect(0, 13055, '\P{Blk=enclosedcjk}', "");
    Expect(1, 13055, '\P{^Blk=enclosedcjk}', "");
    Expect(0, 13056, '\p{Blk=enclosedcjk}', "");
    Expect(1, 13056, '\p{^Blk=enclosedcjk}', "");
    Expect(1, 13056, '\P{Blk=enclosedcjk}', "");
    Expect(0, 13056, '\P{^Blk=enclosedcjk}', "");
    Expect(1, 13055, '\p{Blk=-	Enclosed_cjk}', "");
    Expect(0, 13055, '\p{^Blk=-	Enclosed_cjk}', "");
    Expect(0, 13055, '\P{Blk=-	Enclosed_cjk}', "");
    Expect(1, 13055, '\P{^Blk=-	Enclosed_cjk}', "");
    Expect(0, 13056, '\p{Blk=-	Enclosed_cjk}', "");
    Expect(1, 13056, '\p{^Blk=-	Enclosed_cjk}', "");
    Expect(1, 13056, '\P{Blk=-	Enclosed_cjk}', "");
    Expect(0, 13056, '\P{^Blk=-	Enclosed_cjk}', "");
    Error('\p{Is_Block= _Enclosed_CJK_letters_AND_MONTHS:=}');
    Error('\P{Is_Block= _Enclosed_CJK_letters_AND_MONTHS:=}');
    Expect(1, 13055, '\p{Is_Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\p{^Is_Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\P{Is_Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\P{^Is_Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\p{Is_Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\p{^Is_Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\P{Is_Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\P{^Is_Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\p{Is_Block=	-enclosed_CJK_Letters_And_MONTHS}', "");
    Expect(0, 13055, '\p{^Is_Block=	-enclosed_CJK_Letters_And_MONTHS}', "");
    Expect(0, 13055, '\P{Is_Block=	-enclosed_CJK_Letters_And_MONTHS}', "");
    Expect(1, 13055, '\P{^Is_Block=	-enclosed_CJK_Letters_And_MONTHS}', "");
    Expect(0, 13056, '\p{Is_Block=	-enclosed_CJK_Letters_And_MONTHS}', "");
    Expect(1, 13056, '\p{^Is_Block=	-enclosed_CJK_Letters_And_MONTHS}', "");
    Expect(1, 13056, '\P{Is_Block=	-enclosed_CJK_Letters_And_MONTHS}', "");
    Expect(0, 13056, '\P{^Is_Block=	-enclosed_CJK_Letters_And_MONTHS}', "");
    Error('\p{Is_Blk=_ ENCLOSED_cjk/a/}');
    Error('\P{Is_Blk=_ ENCLOSED_cjk/a/}');
    Expect(1, 13055, '\p{Is_Blk: enclosedcjk}', "");
    Expect(0, 13055, '\p{^Is_Blk: enclosedcjk}', "");
    Expect(0, 13055, '\P{Is_Blk: enclosedcjk}', "");
    Expect(1, 13055, '\P{^Is_Blk: enclosedcjk}', "");
    Expect(0, 13056, '\p{Is_Blk: enclosedcjk}', "");
    Expect(1, 13056, '\p{^Is_Blk: enclosedcjk}', "");
    Expect(1, 13056, '\P{Is_Blk: enclosedcjk}', "");
    Expect(0, 13056, '\P{^Is_Blk: enclosedcjk}', "");
    Expect(1, 13055, '\p{Is_Blk=_ENCLOSED_cjk}', "");
    Expect(0, 13055, '\p{^Is_Blk=_ENCLOSED_cjk}', "");
    Expect(0, 13055, '\P{Is_Blk=_ENCLOSED_cjk}', "");
    Expect(1, 13055, '\P{^Is_Blk=_ENCLOSED_cjk}', "");
    Expect(0, 13056, '\p{Is_Blk=_ENCLOSED_cjk}', "");
    Expect(1, 13056, '\p{^Is_Blk=_ENCLOSED_cjk}', "");
    Expect(1, 13056, '\P{Is_Blk=_ENCLOSED_cjk}', "");
    Expect(0, 13056, '\P{^Is_Blk=_ENCLOSED_cjk}', "");
    Error('\p{Block= -enclosed_IDEOGRAPHIC_supplement/a/}');
    Error('\P{Block= -enclosed_IDEOGRAPHIC_supplement/a/}');
    Expect(1, 127743, '\p{Block: enclosedideographicsupplement}', "");
    Expect(0, 127743, '\p{^Block: enclosedideographicsupplement}', "");
    Expect(0, 127743, '\P{Block: enclosedideographicsupplement}', "");
    Expect(1, 127743, '\P{^Block: enclosedideographicsupplement}', "");
    Expect(0, 127744, '\p{Block: enclosedideographicsupplement}', "");
    Expect(1, 127744, '\p{^Block: enclosedideographicsupplement}', "");
    Expect(1, 127744, '\P{Block: enclosedideographicsupplement}', "");
    Expect(0, 127744, '\P{^Block: enclosedideographicsupplement}', "");
    Expect(1, 127743, '\p{Block=_	Enclosed_Ideographic_SUPPLEMENT}', "");
    Expect(0, 127743, '\p{^Block=_	Enclosed_Ideographic_SUPPLEMENT}', "");
    Expect(0, 127743, '\P{Block=_	Enclosed_Ideographic_SUPPLEMENT}', "");
    Expect(1, 127743, '\P{^Block=_	Enclosed_Ideographic_SUPPLEMENT}', "");
    Expect(0, 127744, '\p{Block=_	Enclosed_Ideographic_SUPPLEMENT}', "");
    Expect(1, 127744, '\p{^Block=_	Enclosed_Ideographic_SUPPLEMENT}', "");
    Expect(1, 127744, '\P{Block=_	Enclosed_Ideographic_SUPPLEMENT}', "");
    Expect(0, 127744, '\P{^Block=_	Enclosed_Ideographic_SUPPLEMENT}', "");
    Error('\p{Blk=_enclosed_Ideographic_sup:=}');
    Error('\P{Blk=_enclosed_Ideographic_sup:=}');
    Expect(1, 127743, '\p{Blk=enclosedideographicsup}', "");
    Expect(0, 127743, '\p{^Blk=enclosedideographicsup}', "");
    Expect(0, 127743, '\P{Blk=enclosedideographicsup}', "");
    Expect(1, 127743, '\P{^Blk=enclosedideographicsup}', "");
    Expect(0, 127744, '\p{Blk=enclosedideographicsup}', "");
    Expect(1, 127744, '\p{^Blk=enclosedideographicsup}', "");
    Expect(1, 127744, '\P{Blk=enclosedideographicsup}', "");
    Expect(0, 127744, '\P{^Blk=enclosedideographicsup}', "");
    Expect(1, 127743, '\p{Blk: 	Enclosed_Ideographic_Sup}', "");
    Expect(0, 127743, '\p{^Blk: 	Enclosed_Ideographic_Sup}', "");
    Expect(0, 127743, '\P{Blk: 	Enclosed_Ideographic_Sup}', "");
    Expect(1, 127743, '\P{^Blk: 	Enclosed_Ideographic_Sup}', "");
    Expect(0, 127744, '\p{Blk: 	Enclosed_Ideographic_Sup}', "");
    Expect(1, 127744, '\p{^Blk: 	Enclosed_Ideographic_Sup}', "");
    Expect(1, 127744, '\P{Blk: 	Enclosed_Ideographic_Sup}', "");
    Expect(0, 127744, '\P{^Blk: 	Enclosed_Ideographic_Sup}', "");
    Error('\p{Is_Block=	:=Enclosed_Ideographic_supplement}');
    Error('\P{Is_Block=	:=Enclosed_Ideographic_supplement}');
    Expect(1, 127743, '\p{Is_Block=enclosedideographicsupplement}', "");
    Expect(0, 127743, '\p{^Is_Block=enclosedideographicsupplement}', "");
    Expect(0, 127743, '\P{Is_Block=enclosedideographicsupplement}', "");
    Expect(1, 127743, '\P{^Is_Block=enclosedideographicsupplement}', "");
    Expect(0, 127744, '\p{Is_Block=enclosedideographicsupplement}', "");
    Expect(1, 127744, '\p{^Is_Block=enclosedideographicsupplement}', "");
    Expect(1, 127744, '\P{Is_Block=enclosedideographicsupplement}', "");
    Expect(0, 127744, '\P{^Is_Block=enclosedideographicsupplement}', "");
    Expect(1, 127743, '\p{Is_Block= 	Enclosed_Ideographic_Supplement}', "");
    Expect(0, 127743, '\p{^Is_Block= 	Enclosed_Ideographic_Supplement}', "");
    Expect(0, 127743, '\P{Is_Block= 	Enclosed_Ideographic_Supplement}', "");
    Expect(1, 127743, '\P{^Is_Block= 	Enclosed_Ideographic_Supplement}', "");
    Expect(0, 127744, '\p{Is_Block= 	Enclosed_Ideographic_Supplement}', "");
    Expect(1, 127744, '\p{^Is_Block= 	Enclosed_Ideographic_Supplement}', "");
    Expect(1, 127744, '\P{Is_Block= 	Enclosed_Ideographic_Supplement}', "");
    Expect(0, 127744, '\P{^Is_Block= 	Enclosed_Ideographic_Supplement}', "");
    Error('\p{Is_Blk=_ ENCLOSED_ideographic_Sup/a/}');
    Error('\P{Is_Blk=_ ENCLOSED_ideographic_Sup/a/}');
    Expect(1, 127743, '\p{Is_Blk=enclosedideographicsup}', "");
    Expect(0, 127743, '\p{^Is_Blk=enclosedideographicsup}', "");
    Expect(0, 127743, '\P{Is_Blk=enclosedideographicsup}', "");
    Expect(1, 127743, '\P{^Is_Blk=enclosedideographicsup}', "");
    Expect(0, 127744, '\p{Is_Blk=enclosedideographicsup}', "");
    Expect(1, 127744, '\p{^Is_Blk=enclosedideographicsup}', "");
    Expect(1, 127744, '\P{Is_Blk=enclosedideographicsup}', "");
    Expect(0, 127744, '\P{^Is_Blk=enclosedideographicsup}', "");
    Expect(1, 127743, '\p{Is_Blk= Enclosed_Ideographic_Sup}', "");
    Expect(0, 127743, '\p{^Is_Blk= Enclosed_Ideographic_Sup}', "");
    Expect(0, 127743, '\P{Is_Blk= Enclosed_Ideographic_Sup}', "");
    Expect(1, 127743, '\P{^Is_Blk= Enclosed_Ideographic_Sup}', "");
    Expect(0, 127744, '\p{Is_Blk= Enclosed_Ideographic_Sup}', "");
    Expect(1, 127744, '\p{^Is_Blk= Enclosed_Ideographic_Sup}', "");
    Expect(1, 127744, '\P{Is_Blk= Enclosed_Ideographic_Sup}', "");
    Expect(0, 127744, '\P{^Is_Blk= Enclosed_Ideographic_Sup}', "");
    Error('\p{Block=-	ETHIOPIC:=}');
    Error('\P{Block=-	ETHIOPIC:=}');
    Expect(1, 4991, '\p{Block=ethiopic}', "");
    Expect(0, 4991, '\p{^Block=ethiopic}', "");
    Expect(0, 4991, '\P{Block=ethiopic}', "");
    Expect(1, 4991, '\P{^Block=ethiopic}', "");
    Expect(0, 4992, '\p{Block=ethiopic}', "");
    Expect(1, 4992, '\p{^Block=ethiopic}', "");
    Expect(1, 4992, '\P{Block=ethiopic}', "");
    Expect(0, 4992, '\P{^Block=ethiopic}', "");
    Expect(1, 4991, '\p{Block=-	ETHIOPIC}', "");
    Expect(0, 4991, '\p{^Block=-	ETHIOPIC}', "");
    Expect(0, 4991, '\P{Block=-	ETHIOPIC}', "");
    Expect(1, 4991, '\P{^Block=-	ETHIOPIC}', "");
    Expect(0, 4992, '\p{Block=-	ETHIOPIC}', "");
    Expect(1, 4992, '\p{^Block=-	ETHIOPIC}', "");
    Expect(1, 4992, '\P{Block=-	ETHIOPIC}', "");
    Expect(0, 4992, '\P{^Block=-	ETHIOPIC}', "");
    Error('\p{Blk=_Ethiopic:=}');
    Error('\P{Blk=_Ethiopic:=}');
    Expect(1, 4991, '\p{Blk=ethiopic}', "");
    Expect(0, 4991, '\p{^Blk=ethiopic}', "");
    Expect(0, 4991, '\P{Blk=ethiopic}', "");
    Expect(1, 4991, '\P{^Blk=ethiopic}', "");
    Expect(0, 4992, '\p{Blk=ethiopic}', "");
    Expect(1, 4992, '\p{^Blk=ethiopic}', "");
    Expect(1, 4992, '\P{Blk=ethiopic}', "");
    Expect(0, 4992, '\P{^Blk=ethiopic}', "");
    Expect(1, 4991, '\p{Blk=-	ethiopic}', "");
    Expect(0, 4991, '\p{^Blk=-	ethiopic}', "");
    Expect(0, 4991, '\P{Blk=-	ethiopic}', "");
    Expect(1, 4991, '\P{^Blk=-	ethiopic}', "");
    Expect(0, 4992, '\p{Blk=-	ethiopic}', "");
    Expect(1, 4992, '\p{^Blk=-	ethiopic}', "");
    Expect(1, 4992, '\P{Blk=-	ethiopic}', "");
    Expect(0, 4992, '\P{^Blk=-	ethiopic}', "");
    Error('\p{Is_Block=/a/ 	ETHIOPIC}');
    Error('\P{Is_Block=/a/ 	ETHIOPIC}');
    Expect(1, 4991, '\p{Is_Block=ethiopic}', "");
    Expect(0, 4991, '\p{^Is_Block=ethiopic}', "");
    Expect(0, 4991, '\P{Is_Block=ethiopic}', "");
    Expect(1, 4991, '\P{^Is_Block=ethiopic}', "");
    Expect(0, 4992, '\p{Is_Block=ethiopic}', "");
    Expect(1, 4992, '\p{^Is_Block=ethiopic}', "");
    Expect(1, 4992, '\P{Is_Block=ethiopic}', "");
    Expect(0, 4992, '\P{^Is_Block=ethiopic}', "");
    Expect(1, 4991, '\p{Is_Block=__Ethiopic}', "");
    Expect(0, 4991, '\p{^Is_Block=__Ethiopic}', "");
    Expect(0, 4991, '\P{Is_Block=__Ethiopic}', "");
    Expect(1, 4991, '\P{^Is_Block=__Ethiopic}', "");
    Expect(0, 4992, '\p{Is_Block=__Ethiopic}', "");
    Expect(1, 4992, '\p{^Is_Block=__Ethiopic}', "");
    Expect(1, 4992, '\P{Is_Block=__Ethiopic}', "");
    Expect(0, 4992, '\P{^Is_Block=__Ethiopic}', "");
    Error('\p{Is_Blk=	/a/Ethiopic}');
    Error('\P{Is_Blk=	/a/Ethiopic}');
    Expect(1, 4991, '\p{Is_Blk=ethiopic}', "");
    Expect(0, 4991, '\p{^Is_Blk=ethiopic}', "");
    Expect(0, 4991, '\P{Is_Blk=ethiopic}', "");
    Expect(1, 4991, '\P{^Is_Blk=ethiopic}', "");
    Expect(0, 4992, '\p{Is_Blk=ethiopic}', "");
    Expect(1, 4992, '\p{^Is_Blk=ethiopic}', "");
    Expect(1, 4992, '\P{Is_Blk=ethiopic}', "");
    Expect(0, 4992, '\P{^Is_Blk=ethiopic}', "");
    Expect(1, 4991, '\p{Is_Blk=- Ethiopic}', "");
    Expect(0, 4991, '\p{^Is_Blk=- Ethiopic}', "");
    Expect(0, 4991, '\P{Is_Blk=- Ethiopic}', "");
    Expect(1, 4991, '\P{^Is_Blk=- Ethiopic}', "");
    Expect(0, 4992, '\p{Is_Blk=- Ethiopic}', "");
    Expect(1, 4992, '\p{^Is_Blk=- Ethiopic}', "");
    Expect(1, 4992, '\P{Is_Blk=- Ethiopic}', "");
    Expect(0, 4992, '\P{^Is_Blk=- Ethiopic}', "");
    Error('\p{Block=:=	 Ethiopic_extended}');
    Error('\P{Block=:=	 Ethiopic_extended}');
    Expect(1, 11743, '\p{Block=ethiopicextended}', "");
    Expect(0, 11743, '\p{^Block=ethiopicextended}', "");
    Expect(0, 11743, '\P{Block=ethiopicextended}', "");
    Expect(1, 11743, '\P{^Block=ethiopicextended}', "");
    Expect(0, 11744, '\p{Block=ethiopicextended}', "");
    Expect(1, 11744, '\p{^Block=ethiopicextended}', "");
    Expect(1, 11744, '\P{Block=ethiopicextended}', "");
    Expect(0, 11744, '\P{^Block=ethiopicextended}', "");
    Expect(1, 11743, '\p{Block=_	Ethiopic_extended}', "");
    Expect(0, 11743, '\p{^Block=_	Ethiopic_extended}', "");
    Expect(0, 11743, '\P{Block=_	Ethiopic_extended}', "");
    Expect(1, 11743, '\P{^Block=_	Ethiopic_extended}', "");
    Expect(0, 11744, '\p{Block=_	Ethiopic_extended}', "");
    Expect(1, 11744, '\p{^Block=_	Ethiopic_extended}', "");
    Expect(1, 11744, '\P{Block=_	Ethiopic_extended}', "");
    Expect(0, 11744, '\P{^Block=_	Ethiopic_extended}', "");
    Error('\p{Blk=:=	 Ethiopic_Ext}');
    Error('\P{Blk=:=	 Ethiopic_Ext}');
    Expect(1, 11743, '\p{Blk=ethiopicext}', "");
    Expect(0, 11743, '\p{^Blk=ethiopicext}', "");
    Expect(0, 11743, '\P{Blk=ethiopicext}', "");
    Expect(1, 11743, '\P{^Blk=ethiopicext}', "");
    Expect(0, 11744, '\p{Blk=ethiopicext}', "");
    Expect(1, 11744, '\p{^Blk=ethiopicext}', "");
    Expect(1, 11744, '\P{Blk=ethiopicext}', "");
    Expect(0, 11744, '\P{^Blk=ethiopicext}', "");
    Expect(1, 11743, '\p{Blk=--Ethiopic_Ext}', "");
    Expect(0, 11743, '\p{^Blk=--Ethiopic_Ext}', "");
    Expect(0, 11743, '\P{Blk=--Ethiopic_Ext}', "");
    Expect(1, 11743, '\P{^Blk=--Ethiopic_Ext}', "");
    Expect(0, 11744, '\p{Blk=--Ethiopic_Ext}', "");
    Expect(1, 11744, '\p{^Blk=--Ethiopic_Ext}', "");
    Expect(1, 11744, '\P{Blk=--Ethiopic_Ext}', "");
    Expect(0, 11744, '\P{^Blk=--Ethiopic_Ext}', "");
    Error('\p{Is_Block=:=Ethiopic_Extended}');
    Error('\P{Is_Block=:=Ethiopic_Extended}');
    Expect(1, 11743, '\p{Is_Block=ethiopicextended}', "");
    Expect(0, 11743, '\p{^Is_Block=ethiopicextended}', "");
    Expect(0, 11743, '\P{Is_Block=ethiopicextended}', "");
    Expect(1, 11743, '\P{^Is_Block=ethiopicextended}', "");
    Expect(0, 11744, '\p{Is_Block=ethiopicextended}', "");
    Expect(1, 11744, '\p{^Is_Block=ethiopicextended}', "");
    Expect(1, 11744, '\P{Is_Block=ethiopicextended}', "");
    Expect(0, 11744, '\P{^Is_Block=ethiopicextended}', "");
    Expect(1, 11743, '\p{Is_Block=_-Ethiopic_EXTENDED}', "");
    Expect(0, 11743, '\p{^Is_Block=_-Ethiopic_EXTENDED}', "");
    Expect(0, 11743, '\P{Is_Block=_-Ethiopic_EXTENDED}', "");
    Expect(1, 11743, '\P{^Is_Block=_-Ethiopic_EXTENDED}', "");
    Expect(0, 11744, '\p{Is_Block=_-Ethiopic_EXTENDED}', "");
    Expect(1, 11744, '\p{^Is_Block=_-Ethiopic_EXTENDED}', "");
    Expect(1, 11744, '\P{Is_Block=_-Ethiopic_EXTENDED}', "");
    Expect(0, 11744, '\P{^Is_Block=_-Ethiopic_EXTENDED}', "");
    Error('\p{Is_Blk= :=ethiopic_EXT}');
    Error('\P{Is_Blk= :=ethiopic_EXT}');
    Expect(1, 11743, '\p{Is_Blk=ethiopicext}', "");
    Expect(0, 11743, '\p{^Is_Blk=ethiopicext}', "");
    Expect(0, 11743, '\P{Is_Blk=ethiopicext}', "");
    Expect(1, 11743, '\P{^Is_Blk=ethiopicext}', "");
    Expect(0, 11744, '\p{Is_Blk=ethiopicext}', "");
    Expect(1, 11744, '\p{^Is_Blk=ethiopicext}', "");
    Expect(1, 11744, '\P{Is_Blk=ethiopicext}', "");
    Expect(0, 11744, '\P{^Is_Blk=ethiopicext}', "");
    Expect(1, 11743, '\p{Is_Blk=_-ethiopic_EXT}', "");
    Expect(0, 11743, '\p{^Is_Blk=_-ethiopic_EXT}', "");
    Expect(0, 11743, '\P{Is_Blk=_-ethiopic_EXT}', "");
    Expect(1, 11743, '\P{^Is_Blk=_-ethiopic_EXT}', "");
    Expect(0, 11744, '\p{Is_Blk=_-ethiopic_EXT}', "");
    Expect(1, 11744, '\p{^Is_Blk=_-ethiopic_EXT}', "");
    Expect(1, 11744, '\P{Is_Blk=_-ethiopic_EXT}', "");
    Expect(0, 11744, '\P{^Is_Blk=_-ethiopic_EXT}', "");
    Error('\p{Block:   /a/ _Ethiopic_extended_a}');
    Error('\P{Block:   /a/ _Ethiopic_extended_a}');
    Expect(1, 43823, '\p{Block=ethiopicextendeda}', "");
    Expect(0, 43823, '\p{^Block=ethiopicextendeda}', "");
    Expect(0, 43823, '\P{Block=ethiopicextendeda}', "");
    Expect(1, 43823, '\P{^Block=ethiopicextendeda}', "");
    Expect(0, 43824, '\p{Block=ethiopicextendeda}', "");
    Expect(1, 43824, '\p{^Block=ethiopicextendeda}', "");
    Expect(1, 43824, '\P{Block=ethiopicextendeda}', "");
    Expect(0, 43824, '\P{^Block=ethiopicextendeda}', "");
    Expect(1, 43823, '\p{Block= ethiopic_EXTENDED_a}', "");
    Expect(0, 43823, '\p{^Block= ethiopic_EXTENDED_a}', "");
    Expect(0, 43823, '\P{Block= ethiopic_EXTENDED_a}', "");
    Expect(1, 43823, '\P{^Block= ethiopic_EXTENDED_a}', "");
    Expect(0, 43824, '\p{Block= ethiopic_EXTENDED_a}', "");
    Expect(1, 43824, '\p{^Block= ethiopic_EXTENDED_a}', "");
    Expect(1, 43824, '\P{Block= ethiopic_EXTENDED_a}', "");
    Expect(0, 43824, '\P{^Block= ethiopic_EXTENDED_a}', "");
    Error('\p{Blk:	:=- ethiopic_EXT_a}');
    Error('\P{Blk:	:=- ethiopic_EXT_a}');
    Expect(1, 43823, '\p{Blk=ethiopicexta}', "");
    Expect(0, 43823, '\p{^Blk=ethiopicexta}', "");
    Expect(0, 43823, '\P{Blk=ethiopicexta}', "");
    Expect(1, 43823, '\P{^Blk=ethiopicexta}', "");
    Expect(0, 43824, '\p{Blk=ethiopicexta}', "");
    Expect(1, 43824, '\p{^Blk=ethiopicexta}', "");
    Expect(1, 43824, '\P{Blk=ethiopicexta}', "");
    Expect(0, 43824, '\P{^Blk=ethiopicexta}', "");
    Expect(1, 43823, '\p{Blk=_ETHIOPIC_EXT_A}', "");
    Expect(0, 43823, '\p{^Blk=_ETHIOPIC_EXT_A}', "");
    Expect(0, 43823, '\P{Blk=_ETHIOPIC_EXT_A}', "");
    Expect(1, 43823, '\P{^Blk=_ETHIOPIC_EXT_A}', "");
    Expect(0, 43824, '\p{Blk=_ETHIOPIC_EXT_A}', "");
    Expect(1, 43824, '\p{^Blk=_ETHIOPIC_EXT_A}', "");
    Expect(1, 43824, '\P{Blk=_ETHIOPIC_EXT_A}', "");
    Expect(0, 43824, '\P{^Blk=_ETHIOPIC_EXT_A}', "");
    Error('\p{Is_Block=_/a/Ethiopic_Extended_a}');
    Error('\P{Is_Block=_/a/Ethiopic_Extended_a}');
    Expect(1, 43823, '\p{Is_Block=ethiopicextendeda}', "");
    Expect(0, 43823, '\p{^Is_Block=ethiopicextendeda}', "");
    Expect(0, 43823, '\P{Is_Block=ethiopicextendeda}', "");
    Expect(1, 43823, '\P{^Is_Block=ethiopicextendeda}', "");
    Expect(0, 43824, '\p{Is_Block=ethiopicextendeda}', "");
    Expect(1, 43824, '\p{^Is_Block=ethiopicextendeda}', "");
    Expect(1, 43824, '\P{Is_Block=ethiopicextendeda}', "");
    Expect(0, 43824, '\P{^Is_Block=ethiopicextendeda}', "");
    Expect(1, 43823, '\p{Is_Block=	Ethiopic_EXTENDED_A}', "");
    Expect(0, 43823, '\p{^Is_Block=	Ethiopic_EXTENDED_A}', "");
    Expect(0, 43823, '\P{Is_Block=	Ethiopic_EXTENDED_A}', "");
    Expect(1, 43823, '\P{^Is_Block=	Ethiopic_EXTENDED_A}', "");
    Expect(0, 43824, '\p{Is_Block=	Ethiopic_EXTENDED_A}', "");
    Expect(1, 43824, '\p{^Is_Block=	Ethiopic_EXTENDED_A}', "");
    Expect(1, 43824, '\P{Is_Block=	Ethiopic_EXTENDED_A}', "");
    Expect(0, 43824, '\P{^Is_Block=	Ethiopic_EXTENDED_A}', "");
    Error('\p{Is_Blk=/a/ ETHIOPIC_Ext_a}');
    Error('\P{Is_Blk=/a/ ETHIOPIC_Ext_a}');
    Expect(1, 43823, '\p{Is_Blk=ethiopicexta}', "");
    Expect(0, 43823, '\p{^Is_Blk=ethiopicexta}', "");
    Expect(0, 43823, '\P{Is_Blk=ethiopicexta}', "");
    Expect(1, 43823, '\P{^Is_Blk=ethiopicexta}', "");
    Expect(0, 43824, '\p{Is_Blk=ethiopicexta}', "");
    Expect(1, 43824, '\p{^Is_Blk=ethiopicexta}', "");
    Expect(1, 43824, '\P{Is_Blk=ethiopicexta}', "");
    Expect(0, 43824, '\P{^Is_Blk=ethiopicexta}', "");
    Expect(1, 43823, '\p{Is_Blk=--ETHIOPIC_EXT_A}', "");
    Expect(0, 43823, '\p{^Is_Blk=--ETHIOPIC_EXT_A}', "");
    Expect(0, 43823, '\P{Is_Blk=--ETHIOPIC_EXT_A}', "");
    Expect(1, 43823, '\P{^Is_Blk=--ETHIOPIC_EXT_A}', "");
    Expect(0, 43824, '\p{Is_Blk=--ETHIOPIC_EXT_A}', "");
    Expect(1, 43824, '\p{^Is_Blk=--ETHIOPIC_EXT_A}', "");
    Expect(1, 43824, '\P{Is_Blk=--ETHIOPIC_EXT_A}', "");
    Expect(0, 43824, '\P{^Is_Blk=--ETHIOPIC_EXT_A}', "");
    Error('\p{Block: /a/	-ethiopic_Supplement}');
    Error('\P{Block: /a/	-ethiopic_Supplement}');
    Expect(1, 5023, '\p{Block=ethiopicsupplement}', "");
    Expect(0, 5023, '\p{^Block=ethiopicsupplement}', "");
    Expect(0, 5023, '\P{Block=ethiopicsupplement}', "");
    Expect(1, 5023, '\P{^Block=ethiopicsupplement}', "");
    Expect(0, 5024, '\p{Block=ethiopicsupplement}', "");
    Expect(1, 5024, '\p{^Block=ethiopicsupplement}', "");
    Expect(1, 5024, '\P{Block=ethiopicsupplement}', "");
    Expect(0, 5024, '\P{^Block=ethiopicsupplement}', "");
    Expect(1, 5023, '\p{Block=_-Ethiopic_Supplement}', "");
    Expect(0, 5023, '\p{^Block=_-Ethiopic_Supplement}', "");
    Expect(0, 5023, '\P{Block=_-Ethiopic_Supplement}', "");
    Expect(1, 5023, '\P{^Block=_-Ethiopic_Supplement}', "");
    Expect(0, 5024, '\p{Block=_-Ethiopic_Supplement}', "");
    Expect(1, 5024, '\p{^Block=_-Ethiopic_Supplement}', "");
    Expect(1, 5024, '\P{Block=_-Ethiopic_Supplement}', "");
    Expect(0, 5024, '\P{^Block=_-Ethiopic_Supplement}', "");
    Error('\p{Blk= _ethiopic_sup/a/}');
    Error('\P{Blk= _ethiopic_sup/a/}');
    Expect(1, 5023, '\p{Blk=ethiopicsup}', "");
    Expect(0, 5023, '\p{^Blk=ethiopicsup}', "");
    Expect(0, 5023, '\P{Blk=ethiopicsup}', "");
    Expect(1, 5023, '\P{^Blk=ethiopicsup}', "");
    Expect(0, 5024, '\p{Blk=ethiopicsup}', "");
    Expect(1, 5024, '\p{^Blk=ethiopicsup}', "");
    Expect(1, 5024, '\P{Blk=ethiopicsup}', "");
    Expect(0, 5024, '\P{^Blk=ethiopicsup}', "");
    Expect(1, 5023, '\p{Blk=--Ethiopic_Sup}', "");
    Expect(0, 5023, '\p{^Blk=--Ethiopic_Sup}', "");
    Expect(0, 5023, '\P{Blk=--Ethiopic_Sup}', "");
    Expect(1, 5023, '\P{^Blk=--Ethiopic_Sup}', "");
    Expect(0, 5024, '\p{Blk=--Ethiopic_Sup}', "");
    Expect(1, 5024, '\p{^Blk=--Ethiopic_Sup}', "");
    Expect(1, 5024, '\P{Blk=--Ethiopic_Sup}', "");
    Expect(0, 5024, '\P{^Blk=--Ethiopic_Sup}', "");
    Error('\p{Is_Block=	-Ethiopic_supplement:=}');
    Error('\P{Is_Block=	-Ethiopic_supplement:=}');
    Expect(1, 5023, '\p{Is_Block=ethiopicsupplement}', "");
    Expect(0, 5023, '\p{^Is_Block=ethiopicsupplement}', "");
    Expect(0, 5023, '\P{Is_Block=ethiopicsupplement}', "");
    Expect(1, 5023, '\P{^Is_Block=ethiopicsupplement}', "");
    Expect(0, 5024, '\p{Is_Block=ethiopicsupplement}', "");
    Expect(1, 5024, '\p{^Is_Block=ethiopicsupplement}', "");
    Expect(1, 5024, '\P{Is_Block=ethiopicsupplement}', "");
    Expect(0, 5024, '\P{^Is_Block=ethiopicsupplement}', "");
    Expect(1, 5023, '\p{Is_Block= _Ethiopic_Supplement}', "");
    Expect(0, 5023, '\p{^Is_Block= _Ethiopic_Supplement}', "");
    Expect(0, 5023, '\P{Is_Block= _Ethiopic_Supplement}', "");
    Expect(1, 5023, '\P{^Is_Block= _Ethiopic_Supplement}', "");
    Expect(0, 5024, '\p{Is_Block= _Ethiopic_Supplement}', "");
    Expect(1, 5024, '\p{^Is_Block= _Ethiopic_Supplement}', "");
    Expect(1, 5024, '\P{Is_Block= _Ethiopic_Supplement}', "");
    Expect(0, 5024, '\P{^Is_Block= _Ethiopic_Supplement}', "");
    Error('\p{Is_Blk=:=Ethiopic_Sup}');
    Error('\P{Is_Blk=:=Ethiopic_Sup}');
    Expect(1, 5023, '\p{Is_Blk=ethiopicsup}', "");
    Expect(0, 5023, '\p{^Is_Blk=ethiopicsup}', "");
    Expect(0, 5023, '\P{Is_Blk=ethiopicsup}', "");
    Expect(1, 5023, '\P{^Is_Blk=ethiopicsup}', "");
    Expect(0, 5024, '\p{Is_Blk=ethiopicsup}', "");
    Expect(1, 5024, '\p{^Is_Blk=ethiopicsup}', "");
    Expect(1, 5024, '\P{Is_Blk=ethiopicsup}', "");
    Expect(0, 5024, '\P{^Is_Blk=ethiopicsup}', "");
    Expect(1, 5023, '\p{Is_Blk= 	Ethiopic_sup}', "");
    Expect(0, 5023, '\p{^Is_Blk= 	Ethiopic_sup}', "");
    Expect(0, 5023, '\P{Is_Blk= 	Ethiopic_sup}', "");
    Expect(1, 5023, '\P{^Is_Blk= 	Ethiopic_sup}', "");
    Expect(0, 5024, '\p{Is_Blk= 	Ethiopic_sup}', "");
    Expect(1, 5024, '\p{^Is_Blk= 	Ethiopic_sup}', "");
    Expect(1, 5024, '\P{Is_Blk= 	Ethiopic_sup}', "");
    Expect(0, 5024, '\P{^Is_Blk= 	Ethiopic_sup}', "");
    Error('\p{Block=	geometric_Shapes/a/}');
    Error('\P{Block=	geometric_Shapes/a/}');
    Expect(1, 9727, '\p{Block=geometricshapes}', "");
    Expect(0, 9727, '\p{^Block=geometricshapes}', "");
    Expect(0, 9727, '\P{Block=geometricshapes}', "");
    Expect(1, 9727, '\P{^Block=geometricshapes}', "");
    Expect(0, 9728, '\p{Block=geometricshapes}', "");
    Expect(1, 9728, '\p{^Block=geometricshapes}', "");
    Expect(1, 9728, '\P{Block=geometricshapes}', "");
    Expect(0, 9728, '\P{^Block=geometricshapes}', "");
    Expect(1, 9727, '\p{Block= Geometric_Shapes}', "");
    Expect(0, 9727, '\p{^Block= Geometric_Shapes}', "");
    Expect(0, 9727, '\P{Block= Geometric_Shapes}', "");
    Expect(1, 9727, '\P{^Block= Geometric_Shapes}', "");
    Expect(0, 9728, '\p{Block= Geometric_Shapes}', "");
    Expect(1, 9728, '\p{^Block= Geometric_Shapes}', "");
    Expect(1, 9728, '\P{Block= Geometric_Shapes}', "");
    Expect(0, 9728, '\P{^Block= Geometric_Shapes}', "");
    Error('\p{Blk:		Geometric_Shapes/a/}');
    Error('\P{Blk:		Geometric_Shapes/a/}');
    Expect(1, 9727, '\p{Blk=geometricshapes}', "");
    Expect(0, 9727, '\p{^Blk=geometricshapes}', "");
    Expect(0, 9727, '\P{Blk=geometricshapes}', "");
    Expect(1, 9727, '\P{^Blk=geometricshapes}', "");
    Expect(0, 9728, '\p{Blk=geometricshapes}', "");
    Expect(1, 9728, '\p{^Blk=geometricshapes}', "");
    Expect(1, 9728, '\P{Blk=geometricshapes}', "");
    Expect(0, 9728, '\P{^Blk=geometricshapes}', "");
    Expect(1, 9727, '\p{Blk:   -_GEOMETRIC_shapes}', "");
    Expect(0, 9727, '\p{^Blk:   -_GEOMETRIC_shapes}', "");
    Expect(0, 9727, '\P{Blk:   -_GEOMETRIC_shapes}', "");
    Expect(1, 9727, '\P{^Blk:   -_GEOMETRIC_shapes}', "");
    Expect(0, 9728, '\p{Blk:   -_GEOMETRIC_shapes}', "");
    Expect(1, 9728, '\p{^Blk:   -_GEOMETRIC_shapes}', "");
    Expect(1, 9728, '\P{Blk:   -_GEOMETRIC_shapes}', "");
    Expect(0, 9728, '\P{^Blk:   -_GEOMETRIC_shapes}', "");
    Error('\p{Is_Block: :=	_GEOMETRIC_Shapes}');
    Error('\P{Is_Block: :=	_GEOMETRIC_Shapes}');
    Expect(1, 9727, '\p{Is_Block=geometricshapes}', "");
    Expect(0, 9727, '\p{^Is_Block=geometricshapes}', "");
    Expect(0, 9727, '\P{Is_Block=geometricshapes}', "");
    Expect(1, 9727, '\P{^Is_Block=geometricshapes}', "");
    Expect(0, 9728, '\p{Is_Block=geometricshapes}', "");
    Expect(1, 9728, '\p{^Is_Block=geometricshapes}', "");
    Expect(1, 9728, '\P{Is_Block=geometricshapes}', "");
    Expect(0, 9728, '\P{^Is_Block=geometricshapes}', "");
    Expect(1, 9727, '\p{Is_Block=	geometric_shapes}', "");
    Expect(0, 9727, '\p{^Is_Block=	geometric_shapes}', "");
    Expect(0, 9727, '\P{Is_Block=	geometric_shapes}', "");
    Expect(1, 9727, '\P{^Is_Block=	geometric_shapes}', "");
    Expect(0, 9728, '\p{Is_Block=	geometric_shapes}', "");
    Expect(1, 9728, '\p{^Is_Block=	geometric_shapes}', "");
    Expect(1, 9728, '\P{Is_Block=	geometric_shapes}', "");
    Expect(0, 9728, '\P{^Is_Block=	geometric_shapes}', "");
    Error('\p{Is_Blk=:=_GEOMETRIC_shapes}');
    Error('\P{Is_Blk=:=_GEOMETRIC_shapes}');
    Expect(1, 9727, '\p{Is_Blk=geometricshapes}', "");
    Expect(0, 9727, '\p{^Is_Blk=geometricshapes}', "");
    Expect(0, 9727, '\P{Is_Blk=geometricshapes}', "");
    Expect(1, 9727, '\P{^Is_Blk=geometricshapes}', "");
    Expect(0, 9728, '\p{Is_Blk=geometricshapes}', "");
    Expect(1, 9728, '\p{^Is_Blk=geometricshapes}', "");
    Expect(1, 9728, '\P{Is_Blk=geometricshapes}', "");
    Expect(0, 9728, '\P{^Is_Blk=geometricshapes}', "");
    Expect(1, 9727, '\p{Is_Blk=geometric_Shapes}', "");
    Expect(0, 9727, '\p{^Is_Blk=geometric_Shapes}', "");
    Expect(0, 9727, '\P{Is_Blk=geometric_Shapes}', "");
    Expect(1, 9727, '\P{^Is_Blk=geometric_Shapes}', "");
    Expect(0, 9728, '\p{Is_Blk=geometric_Shapes}', "");
    Expect(1, 9728, '\p{^Is_Blk=geometric_Shapes}', "");
    Expect(1, 9728, '\P{Is_Blk=geometric_Shapes}', "");
    Expect(0, 9728, '\P{^Is_Blk=geometric_Shapes}', "");
    Error('\p{Block=_/a/Geometric_Shapes_extended}');
    Error('\P{Block=_/a/Geometric_Shapes_extended}');
    Expect(1, 129023, '\p{Block: geometricshapesextended}', "");
    Expect(0, 129023, '\p{^Block: geometricshapesextended}', "");
    Expect(0, 129023, '\P{Block: geometricshapesextended}', "");
    Expect(1, 129023, '\P{^Block: geometricshapesextended}', "");
    Expect(0, 129024, '\p{Block: geometricshapesextended}', "");
    Expect(1, 129024, '\p{^Block: geometricshapesextended}', "");
    Expect(1, 129024, '\P{Block: geometricshapesextended}', "");
    Expect(0, 129024, '\P{^Block: geometricshapesextended}', "");
    Expect(1, 129023, '\p{Block=	-Geometric_SHAPES_Extended}', "");
    Expect(0, 129023, '\p{^Block=	-Geometric_SHAPES_Extended}', "");
    Expect(0, 129023, '\P{Block=	-Geometric_SHAPES_Extended}', "");
    Expect(1, 129023, '\P{^Block=	-Geometric_SHAPES_Extended}', "");
    Expect(0, 129024, '\p{Block=	-Geometric_SHAPES_Extended}', "");
    Expect(1, 129024, '\p{^Block=	-Geometric_SHAPES_Extended}', "");
    Expect(1, 129024, '\P{Block=	-Geometric_SHAPES_Extended}', "");
    Expect(0, 129024, '\P{^Block=	-Geometric_SHAPES_Extended}', "");
    Error('\p{Blk: --Geometric_shapes_Ext/a/}');
    Error('\P{Blk: --Geometric_shapes_Ext/a/}');
    Expect(1, 129023, '\p{Blk:   geometricshapesext}', "");
    Expect(0, 129023, '\p{^Blk:   geometricshapesext}', "");
    Expect(0, 129023, '\P{Blk:   geometricshapesext}', "");
    Expect(1, 129023, '\P{^Blk:   geometricshapesext}', "");
    Expect(0, 129024, '\p{Blk:   geometricshapesext}', "");
    Expect(1, 129024, '\p{^Blk:   geometricshapesext}', "");
    Expect(1, 129024, '\P{Blk:   geometricshapesext}', "");
    Expect(0, 129024, '\P{^Blk:   geometricshapesext}', "");
    Expect(1, 129023, '\p{Blk= 	GEOMETRIC_Shapes_EXT}', "");
    Expect(0, 129023, '\p{^Blk= 	GEOMETRIC_Shapes_EXT}', "");
    Expect(0, 129023, '\P{Blk= 	GEOMETRIC_Shapes_EXT}', "");
    Expect(1, 129023, '\P{^Blk= 	GEOMETRIC_Shapes_EXT}', "");
    Expect(0, 129024, '\p{Blk= 	GEOMETRIC_Shapes_EXT}', "");
    Expect(1, 129024, '\p{^Blk= 	GEOMETRIC_Shapes_EXT}', "");
    Expect(1, 129024, '\P{Blk= 	GEOMETRIC_Shapes_EXT}', "");
    Expect(0, 129024, '\P{^Blk= 	GEOMETRIC_Shapes_EXT}', "");
    Error('\p{Is_Block= /a/geometric_Shapes_Extended}');
    Error('\P{Is_Block= /a/geometric_Shapes_Extended}');
    Expect(1, 129023, '\p{Is_Block=geometricshapesextended}', "");
    Expect(0, 129023, '\p{^Is_Block=geometricshapesextended}', "");
    Expect(0, 129023, '\P{Is_Block=geometricshapesextended}', "");
    Expect(1, 129023, '\P{^Is_Block=geometricshapesextended}', "");
    Expect(0, 129024, '\p{Is_Block=geometricshapesextended}', "");
    Expect(1, 129024, '\p{^Is_Block=geometricshapesextended}', "");
    Expect(1, 129024, '\P{Is_Block=geometricshapesextended}', "");
    Expect(0, 129024, '\P{^Is_Block=geometricshapesextended}', "");
    Expect(1, 129023, '\p{Is_Block=_GEOMETRIC_Shapes_EXTENDED}', "");
    Expect(0, 129023, '\p{^Is_Block=_GEOMETRIC_Shapes_EXTENDED}', "");
    Expect(0, 129023, '\P{Is_Block=_GEOMETRIC_Shapes_EXTENDED}', "");
    Expect(1, 129023, '\P{^Is_Block=_GEOMETRIC_Shapes_EXTENDED}', "");
    Expect(0, 129024, '\p{Is_Block=_GEOMETRIC_Shapes_EXTENDED}', "");
    Expect(1, 129024, '\p{^Is_Block=_GEOMETRIC_Shapes_EXTENDED}', "");
    Expect(1, 129024, '\P{Is_Block=_GEOMETRIC_Shapes_EXTENDED}', "");
    Expect(0, 129024, '\P{^Is_Block=_GEOMETRIC_Shapes_EXTENDED}', "");
    Error('\p{Is_Blk=- Geometric_SHAPES_Ext/a/}');
    Error('\P{Is_Blk=- Geometric_SHAPES_Ext/a/}');
    Expect(1, 129023, '\p{Is_Blk=geometricshapesext}', "");
    Expect(0, 129023, '\p{^Is_Blk=geometricshapesext}', "");
    Expect(0, 129023, '\P{Is_Blk=geometricshapesext}', "");
    Expect(1, 129023, '\P{^Is_Blk=geometricshapesext}', "");
    Expect(0, 129024, '\p{Is_Blk=geometricshapesext}', "");
    Expect(1, 129024, '\p{^Is_Blk=geometricshapesext}', "");
    Expect(1, 129024, '\P{Is_Blk=geometricshapesext}', "");
    Expect(0, 129024, '\P{^Is_Blk=geometricshapesext}', "");
    Expect(1, 129023, '\p{Is_Blk= Geometric_Shapes_ext}', "");
    Expect(0, 129023, '\p{^Is_Blk= Geometric_Shapes_ext}', "");
    Expect(0, 129023, '\P{Is_Blk= Geometric_Shapes_ext}', "");
    Expect(1, 129023, '\P{^Is_Blk= Geometric_Shapes_ext}', "");
    Expect(0, 129024, '\p{Is_Blk= Geometric_Shapes_ext}', "");
    Expect(1, 129024, '\p{^Is_Blk= Geometric_Shapes_ext}', "");
    Expect(1, 129024, '\P{Is_Blk= Geometric_Shapes_ext}', "");
    Expect(0, 129024, '\P{^Is_Blk= Geometric_Shapes_ext}', "");
    Error('\p{Block:	/a/-_Georgian}');
    Error('\P{Block:	/a/-_Georgian}');
    Expect(1, 4351, '\p{Block=georgian}', "");
    Expect(0, 4351, '\p{^Block=georgian}', "");
    Expect(0, 4351, '\P{Block=georgian}', "");
    Expect(1, 4351, '\P{^Block=georgian}', "");
    Expect(0, 4352, '\p{Block=georgian}', "");
    Expect(1, 4352, '\p{^Block=georgian}', "");
    Expect(1, 4352, '\P{Block=georgian}', "");
    Expect(0, 4352, '\P{^Block=georgian}', "");
    Expect(1, 4351, '\p{Block=__GEORGIAN}', "");
    Expect(0, 4351, '\p{^Block=__GEORGIAN}', "");
    Expect(0, 4351, '\P{Block=__GEORGIAN}', "");
    Expect(1, 4351, '\P{^Block=__GEORGIAN}', "");
    Expect(0, 4352, '\p{Block=__GEORGIAN}', "");
    Expect(1, 4352, '\p{^Block=__GEORGIAN}', "");
    Expect(1, 4352, '\P{Block=__GEORGIAN}', "");
    Expect(0, 4352, '\P{^Block=__GEORGIAN}', "");
    Error('\p{Blk=:= -Georgian}');
    Error('\P{Blk=:= -Georgian}');
    Expect(1, 4351, '\p{Blk=georgian}', "");
    Expect(0, 4351, '\p{^Blk=georgian}', "");
    Expect(0, 4351, '\P{Blk=georgian}', "");
    Expect(1, 4351, '\P{^Blk=georgian}', "");
    Expect(0, 4352, '\p{Blk=georgian}', "");
    Expect(1, 4352, '\p{^Blk=georgian}', "");
    Expect(1, 4352, '\P{Blk=georgian}', "");
    Expect(0, 4352, '\P{^Blk=georgian}', "");
    Expect(1, 4351, '\p{Blk=-Georgian}', "");
    Expect(0, 4351, '\p{^Blk=-Georgian}', "");
    Expect(0, 4351, '\P{Blk=-Georgian}', "");
    Expect(1, 4351, '\P{^Blk=-Georgian}', "");
    Expect(0, 4352, '\p{Blk=-Georgian}', "");
    Expect(1, 4352, '\p{^Blk=-Georgian}', "");
    Expect(1, 4352, '\P{Blk=-Georgian}', "");
    Expect(0, 4352, '\P{^Blk=-Georgian}', "");
    Error('\p{Is_Block=/a/ georgian}');
    Error('\P{Is_Block=/a/ georgian}');
    Expect(1, 4351, '\p{Is_Block=georgian}', "");
    Expect(0, 4351, '\p{^Is_Block=georgian}', "");
    Expect(0, 4351, '\P{Is_Block=georgian}', "");
    Expect(1, 4351, '\P{^Is_Block=georgian}', "");
    Expect(0, 4352, '\p{Is_Block=georgian}', "");
    Expect(1, 4352, '\p{^Is_Block=georgian}', "");
    Expect(1, 4352, '\P{Is_Block=georgian}', "");
    Expect(0, 4352, '\P{^Is_Block=georgian}', "");
    Expect(1, 4351, '\p{Is_Block=_ Georgian}', "");
    Expect(0, 4351, '\p{^Is_Block=_ Georgian}', "");
    Expect(0, 4351, '\P{Is_Block=_ Georgian}', "");
    Expect(1, 4351, '\P{^Is_Block=_ Georgian}', "");
    Expect(0, 4352, '\p{Is_Block=_ Georgian}', "");
    Expect(1, 4352, '\p{^Is_Block=_ Georgian}', "");
    Expect(1, 4352, '\P{Is_Block=_ Georgian}', "");
    Expect(0, 4352, '\P{^Is_Block=_ Georgian}', "");
    Error('\p{Is_Blk=/a/--Georgian}');
    Error('\P{Is_Blk=/a/--Georgian}');
    Expect(1, 4351, '\p{Is_Blk=georgian}', "");
    Expect(0, 4351, '\p{^Is_Blk=georgian}', "");
    Expect(0, 4351, '\P{Is_Blk=georgian}', "");
    Expect(1, 4351, '\P{^Is_Blk=georgian}', "");
    Expect(0, 4352, '\p{Is_Blk=georgian}', "");
    Expect(1, 4352, '\p{^Is_Blk=georgian}', "");
    Expect(1, 4352, '\P{Is_Blk=georgian}', "");
    Expect(0, 4352, '\P{^Is_Blk=georgian}', "");
    Expect(1, 4351, '\p{Is_Blk:   georgian}', "");
    Expect(0, 4351, '\p{^Is_Blk:   georgian}', "");
    Expect(0, 4351, '\P{Is_Blk:   georgian}', "");
    Expect(1, 4351, '\P{^Is_Blk:   georgian}', "");
    Expect(0, 4352, '\p{Is_Blk:   georgian}', "");
    Expect(1, 4352, '\p{^Is_Blk:   georgian}', "");
    Expect(1, 4352, '\P{Is_Blk:   georgian}', "");
    Expect(0, 4352, '\P{^Is_Blk:   georgian}', "");
    Error('\p{Block:   /a/ _Georgian_Supplement}');
    Error('\P{Block:   /a/ _Georgian_Supplement}');
    Expect(1, 11567, '\p{Block=georgiansupplement}', "");
    Expect(0, 11567, '\p{^Block=georgiansupplement}', "");
    Expect(0, 11567, '\P{Block=georgiansupplement}', "");
    Expect(1, 11567, '\P{^Block=georgiansupplement}', "");
    Expect(0, 11568, '\p{Block=georgiansupplement}', "");
    Expect(1, 11568, '\p{^Block=georgiansupplement}', "");
    Expect(1, 11568, '\P{Block=georgiansupplement}', "");
    Expect(0, 11568, '\P{^Block=georgiansupplement}', "");
    Expect(1, 11567, '\p{Block:	 georgian_SUPPLEMENT}', "");
    Expect(0, 11567, '\p{^Block:	 georgian_SUPPLEMENT}', "");
    Expect(0, 11567, '\P{Block:	 georgian_SUPPLEMENT}', "");
    Expect(1, 11567, '\P{^Block:	 georgian_SUPPLEMENT}', "");
    Expect(0, 11568, '\p{Block:	 georgian_SUPPLEMENT}', "");
    Expect(1, 11568, '\p{^Block:	 georgian_SUPPLEMENT}', "");
    Expect(1, 11568, '\P{Block:	 georgian_SUPPLEMENT}', "");
    Expect(0, 11568, '\P{^Block:	 georgian_SUPPLEMENT}', "");
    Error('\p{Blk=-/a/GEORGIAN_sup}');
    Error('\P{Blk=-/a/GEORGIAN_sup}');
    Expect(1, 11567, '\p{Blk=georgiansup}', "");
    Expect(0, 11567, '\p{^Blk=georgiansup}', "");
    Expect(0, 11567, '\P{Blk=georgiansup}', "");
    Expect(1, 11567, '\P{^Blk=georgiansup}', "");
    Expect(0, 11568, '\p{Blk=georgiansup}', "");
    Expect(1, 11568, '\p{^Blk=georgiansup}', "");
    Expect(1, 11568, '\P{Blk=georgiansup}', "");
    Expect(0, 11568, '\P{^Blk=georgiansup}', "");
    Expect(1, 11567, '\p{Blk=	_Georgian_Sup}', "");
    Expect(0, 11567, '\p{^Blk=	_Georgian_Sup}', "");
    Expect(0, 11567, '\P{Blk=	_Georgian_Sup}', "");
    Expect(1, 11567, '\P{^Blk=	_Georgian_Sup}', "");
    Expect(0, 11568, '\p{Blk=	_Georgian_Sup}', "");
    Expect(1, 11568, '\p{^Blk=	_Georgian_Sup}', "");
    Expect(1, 11568, '\P{Blk=	_Georgian_Sup}', "");
    Expect(0, 11568, '\P{^Blk=	_Georgian_Sup}', "");
    Error('\p{Is_Block= georgian_SUPPLEMENT/a/}');
    Error('\P{Is_Block= georgian_SUPPLEMENT/a/}');
    Expect(1, 11567, '\p{Is_Block=georgiansupplement}', "");
    Expect(0, 11567, '\p{^Is_Block=georgiansupplement}', "");
    Expect(0, 11567, '\P{Is_Block=georgiansupplement}', "");
    Expect(1, 11567, '\P{^Is_Block=georgiansupplement}', "");
    Expect(0, 11568, '\p{Is_Block=georgiansupplement}', "");
    Expect(1, 11568, '\p{^Is_Block=georgiansupplement}', "");
    Expect(1, 11568, '\P{Is_Block=georgiansupplement}', "");
    Expect(0, 11568, '\P{^Is_Block=georgiansupplement}', "");
    Expect(1, 11567, '\p{Is_Block=GEORGIAN_supplement}', "");
    Expect(0, 11567, '\p{^Is_Block=GEORGIAN_supplement}', "");
    Expect(0, 11567, '\P{Is_Block=GEORGIAN_supplement}', "");
    Expect(1, 11567, '\P{^Is_Block=GEORGIAN_supplement}', "");
    Expect(0, 11568, '\p{Is_Block=GEORGIAN_supplement}', "");
    Expect(1, 11568, '\p{^Is_Block=GEORGIAN_supplement}', "");
    Expect(1, 11568, '\P{Is_Block=GEORGIAN_supplement}', "");
    Expect(0, 11568, '\P{^Is_Block=GEORGIAN_supplement}', "");
    Error('\p{Is_Blk=	/a/GEORGIAN_Sup}');
    Error('\P{Is_Blk=	/a/GEORGIAN_Sup}');
    Expect(1, 11567, '\p{Is_Blk=georgiansup}', "");
    Expect(0, 11567, '\p{^Is_Blk=georgiansup}', "");
    Expect(0, 11567, '\P{Is_Blk=georgiansup}', "");
    Expect(1, 11567, '\P{^Is_Blk=georgiansup}', "");
    Expect(0, 11568, '\p{Is_Blk=georgiansup}', "");
    Expect(1, 11568, '\p{^Is_Blk=georgiansup}', "");
    Expect(1, 11568, '\P{Is_Blk=georgiansup}', "");
    Expect(0, 11568, '\P{^Is_Blk=georgiansup}', "");
    Expect(1, 11567, '\p{Is_Blk:   -_Georgian_sup}', "");
    Expect(0, 11567, '\p{^Is_Blk:   -_Georgian_sup}', "");
    Expect(0, 11567, '\P{Is_Blk:   -_Georgian_sup}', "");
    Expect(1, 11567, '\P{^Is_Blk:   -_Georgian_sup}', "");
    Expect(0, 11568, '\p{Is_Blk:   -_Georgian_sup}', "");
    Expect(1, 11568, '\p{^Is_Blk:   -_Georgian_sup}', "");
    Expect(1, 11568, '\P{Is_Blk:   -_Georgian_sup}', "");
    Expect(0, 11568, '\P{^Is_Blk:   -_Georgian_sup}', "");
    Error('\p{Block=:=_ GLAGOLITIC}');
    Error('\P{Block=:=_ GLAGOLITIC}');
    Expect(1, 11359, '\p{Block=glagolitic}', "");
    Expect(0, 11359, '\p{^Block=glagolitic}', "");
    Expect(0, 11359, '\P{Block=glagolitic}', "");
    Expect(1, 11359, '\P{^Block=glagolitic}', "");
    Expect(0, 11360, '\p{Block=glagolitic}', "");
    Expect(1, 11360, '\p{^Block=glagolitic}', "");
    Expect(1, 11360, '\P{Block=glagolitic}', "");
    Expect(0, 11360, '\P{^Block=glagolitic}', "");
    Expect(1, 11359, '\p{Block:  GLAGOLITIC}', "");
    Expect(0, 11359, '\p{^Block:  GLAGOLITIC}', "");
    Expect(0, 11359, '\P{Block:  GLAGOLITIC}', "");
    Expect(1, 11359, '\P{^Block:  GLAGOLITIC}', "");
    Expect(0, 11360, '\p{Block:  GLAGOLITIC}', "");
    Expect(1, 11360, '\p{^Block:  GLAGOLITIC}', "");
    Expect(1, 11360, '\P{Block:  GLAGOLITIC}', "");
    Expect(0, 11360, '\P{^Block:  GLAGOLITIC}', "");
    Error('\p{Blk=-Glagolitic/a/}');
    Error('\P{Blk=-Glagolitic/a/}');
    Expect(1, 11359, '\p{Blk=glagolitic}', "");
    Expect(0, 11359, '\p{^Blk=glagolitic}', "");
    Expect(0, 11359, '\P{Blk=glagolitic}', "");
    Expect(1, 11359, '\P{^Blk=glagolitic}', "");
    Expect(0, 11360, '\p{Blk=glagolitic}', "");
    Expect(1, 11360, '\p{^Blk=glagolitic}', "");
    Expect(1, 11360, '\P{Blk=glagolitic}', "");
    Expect(0, 11360, '\P{^Blk=glagolitic}', "");
    Expect(1, 11359, '\p{Blk=-glagolitic}', "");
    Expect(0, 11359, '\p{^Blk=-glagolitic}', "");
    Expect(0, 11359, '\P{Blk=-glagolitic}', "");
    Expect(1, 11359, '\P{^Blk=-glagolitic}', "");
    Expect(0, 11360, '\p{Blk=-glagolitic}', "");
    Expect(1, 11360, '\p{^Blk=-glagolitic}', "");
    Expect(1, 11360, '\P{Blk=-glagolitic}', "");
    Expect(0, 11360, '\P{^Blk=-glagolitic}', "");
    Error('\p{Is_Block=/a/	GLAGOLITIC}');
    Error('\P{Is_Block=/a/	GLAGOLITIC}');
    Expect(1, 11359, '\p{Is_Block=glagolitic}', "");
    Expect(0, 11359, '\p{^Is_Block=glagolitic}', "");
    Expect(0, 11359, '\P{Is_Block=glagolitic}', "");
    Expect(1, 11359, '\P{^Is_Block=glagolitic}', "");
    Expect(0, 11360, '\p{Is_Block=glagolitic}', "");
    Expect(1, 11360, '\p{^Is_Block=glagolitic}', "");
    Expect(1, 11360, '\P{Is_Block=glagolitic}', "");
    Expect(0, 11360, '\P{^Is_Block=glagolitic}', "");
    Expect(1, 11359, '\p{Is_Block=_Glagolitic}', "");
    Expect(0, 11359, '\p{^Is_Block=_Glagolitic}', "");
    Expect(0, 11359, '\P{Is_Block=_Glagolitic}', "");
    Expect(1, 11359, '\P{^Is_Block=_Glagolitic}', "");
    Expect(0, 11360, '\p{Is_Block=_Glagolitic}', "");
    Expect(1, 11360, '\p{^Is_Block=_Glagolitic}', "");
    Expect(1, 11360, '\P{Is_Block=_Glagolitic}', "");
    Expect(0, 11360, '\P{^Is_Block=_Glagolitic}', "");
    Error('\p{Is_Blk=/a/  glagolitic}');
    Error('\P{Is_Blk=/a/  glagolitic}');
    Expect(1, 11359, '\p{Is_Blk=glagolitic}', "");
    Expect(0, 11359, '\p{^Is_Blk=glagolitic}', "");
    Expect(0, 11359, '\P{Is_Blk=glagolitic}', "");
    Expect(1, 11359, '\P{^Is_Blk=glagolitic}', "");
    Expect(0, 11360, '\p{Is_Blk=glagolitic}', "");
    Expect(1, 11360, '\p{^Is_Blk=glagolitic}', "");
    Expect(1, 11360, '\P{Is_Blk=glagolitic}', "");
    Expect(0, 11360, '\P{^Is_Blk=glagolitic}', "");
    Expect(1, 11359, '\p{Is_Blk=		Glagolitic}', "");
    Expect(0, 11359, '\p{^Is_Blk=		Glagolitic}', "");
    Expect(0, 11359, '\P{Is_Blk=		Glagolitic}', "");
    Expect(1, 11359, '\P{^Is_Blk=		Glagolitic}', "");
    Expect(0, 11360, '\p{Is_Blk=		Glagolitic}', "");
    Expect(1, 11360, '\p{^Is_Blk=		Glagolitic}', "");
    Expect(1, 11360, '\P{Is_Blk=		Glagolitic}', "");
    Expect(0, 11360, '\P{^Is_Blk=		Glagolitic}', "");
    Error('\p{Block=:=_	GLAGOLITIC_Supplement}');
    Error('\P{Block=:=_	GLAGOLITIC_Supplement}');
    Expect(1, 122927, '\p{Block:glagoliticsupplement}', "");
    Expect(0, 122927, '\p{^Block:glagoliticsupplement}', "");
    Expect(0, 122927, '\P{Block:glagoliticsupplement}', "");
    Expect(1, 122927, '\P{^Block:glagoliticsupplement}', "");
    Expect(0, 122928, '\p{Block:glagoliticsupplement}', "");
    Expect(1, 122928, '\p{^Block:glagoliticsupplement}', "");
    Expect(1, 122928, '\P{Block:glagoliticsupplement}', "");
    Expect(0, 122928, '\P{^Block:glagoliticsupplement}', "");
    Expect(1, 122927, '\p{Block= GLAGOLITIC_Supplement}', "");
    Expect(0, 122927, '\p{^Block= GLAGOLITIC_Supplement}', "");
    Expect(0, 122927, '\P{Block= GLAGOLITIC_Supplement}', "");
    Expect(1, 122927, '\P{^Block= GLAGOLITIC_Supplement}', "");
    Expect(0, 122928, '\p{Block= GLAGOLITIC_Supplement}', "");
    Expect(1, 122928, '\p{^Block= GLAGOLITIC_Supplement}', "");
    Expect(1, 122928, '\P{Block= GLAGOLITIC_Supplement}', "");
    Expect(0, 122928, '\P{^Block= GLAGOLITIC_Supplement}', "");
    Error('\p{Blk=/a/--GLAGOLITIC_sup}');
    Error('\P{Blk=/a/--GLAGOLITIC_sup}');
    Expect(1, 122927, '\p{Blk=glagoliticsup}', "");
    Expect(0, 122927, '\p{^Blk=glagoliticsup}', "");
    Expect(0, 122927, '\P{Blk=glagoliticsup}', "");
    Expect(1, 122927, '\P{^Blk=glagoliticsup}', "");
    Expect(0, 122928, '\p{Blk=glagoliticsup}', "");
    Expect(1, 122928, '\p{^Blk=glagoliticsup}', "");
    Expect(1, 122928, '\P{Blk=glagoliticsup}', "");
    Expect(0, 122928, '\P{^Blk=glagoliticsup}', "");
    Expect(1, 122927, '\p{Blk=	_glagolitic_Sup}', "");
    Expect(0, 122927, '\p{^Blk=	_glagolitic_Sup}', "");
    Expect(0, 122927, '\P{Blk=	_glagolitic_Sup}', "");
    Expect(1, 122927, '\P{^Blk=	_glagolitic_Sup}', "");
    Expect(0, 122928, '\p{Blk=	_glagolitic_Sup}', "");
    Expect(1, 122928, '\p{^Blk=	_glagolitic_Sup}', "");
    Expect(1, 122928, '\P{Blk=	_glagolitic_Sup}', "");
    Expect(0, 122928, '\P{^Blk=	_glagolitic_Sup}', "");
    Error('\p{Is_Block=	_glagolitic_supplement/a/}');
    Error('\P{Is_Block=	_glagolitic_supplement/a/}');
    Expect(1, 122927, '\p{Is_Block=glagoliticsupplement}', "");
    Expect(0, 122927, '\p{^Is_Block=glagoliticsupplement}', "");
    Expect(0, 122927, '\P{Is_Block=glagoliticsupplement}', "");
    Expect(1, 122927, '\P{^Is_Block=glagoliticsupplement}', "");
    Expect(0, 122928, '\p{Is_Block=glagoliticsupplement}', "");
    Expect(1, 122928, '\p{^Is_Block=glagoliticsupplement}', "");
    Expect(1, 122928, '\P{Is_Block=glagoliticsupplement}', "");
    Expect(0, 122928, '\P{^Is_Block=glagoliticsupplement}', "");
    Expect(1, 122927, '\p{Is_Block:			GLAGOLITIC_Supplement}', "");
    Expect(0, 122927, '\p{^Is_Block:			GLAGOLITIC_Supplement}', "");
    Expect(0, 122927, '\P{Is_Block:			GLAGOLITIC_Supplement}', "");
    Expect(1, 122927, '\P{^Is_Block:			GLAGOLITIC_Supplement}', "");
    Expect(0, 122928, '\p{Is_Block:			GLAGOLITIC_Supplement}', "");
    Expect(1, 122928, '\p{^Is_Block:			GLAGOLITIC_Supplement}', "");
    Expect(1, 122928, '\P{Is_Block:			GLAGOLITIC_Supplement}', "");
    Expect(0, 122928, '\P{^Is_Block:			GLAGOLITIC_Supplement}', "");
    Error('\p{Is_Blk= GLAGOLITIC_sup/a/}');
    Error('\P{Is_Blk= GLAGOLITIC_sup/a/}');
    Expect(1, 122927, '\p{Is_Blk=glagoliticsup}', "");
    Expect(0, 122927, '\p{^Is_Blk=glagoliticsup}', "");
    Expect(0, 122927, '\P{Is_Blk=glagoliticsup}', "");
    Expect(1, 122927, '\P{^Is_Blk=glagoliticsup}', "");
    Expect(0, 122928, '\p{Is_Blk=glagoliticsup}', "");
    Expect(1, 122928, '\p{^Is_Blk=glagoliticsup}', "");
    Expect(1, 122928, '\P{Is_Blk=glagoliticsup}', "");
    Expect(0, 122928, '\P{^Is_Blk=glagoliticsup}', "");
    Expect(1, 122927, '\p{Is_Blk= GLAGOLITIC_Sup}', "");
    Expect(0, 122927, '\p{^Is_Blk= GLAGOLITIC_Sup}', "");
    Expect(0, 122927, '\P{Is_Blk= GLAGOLITIC_Sup}', "");
    Expect(1, 122927, '\P{^Is_Blk= GLAGOLITIC_Sup}', "");
    Expect(0, 122928, '\p{Is_Blk= GLAGOLITIC_Sup}', "");
    Expect(1, 122928, '\p{^Is_Blk= GLAGOLITIC_Sup}', "");
    Expect(1, 122928, '\P{Is_Blk= GLAGOLITIC_Sup}', "");
    Expect(0, 122928, '\P{^Is_Blk= GLAGOLITIC_Sup}', "");
    Error('\p{Block=-gothic/a/}');
    Error('\P{Block=-gothic/a/}');
    Expect(1, 66383, '\p{Block=gothic}', "");
    Expect(0, 66383, '\p{^Block=gothic}', "");
    Expect(0, 66383, '\P{Block=gothic}', "");
    Expect(1, 66383, '\P{^Block=gothic}', "");
    Expect(0, 66384, '\p{Block=gothic}', "");
    Expect(1, 66384, '\p{^Block=gothic}', "");
    Expect(1, 66384, '\P{Block=gothic}', "");
    Expect(0, 66384, '\P{^Block=gothic}', "");
    Expect(1, 66383, '\p{Block=  gothic}', "");
    Expect(0, 66383, '\p{^Block=  gothic}', "");
    Expect(0, 66383, '\P{Block=  gothic}', "");
    Expect(1, 66383, '\P{^Block=  gothic}', "");
    Expect(0, 66384, '\p{Block=  gothic}', "");
    Expect(1, 66384, '\p{^Block=  gothic}', "");
    Expect(1, 66384, '\P{Block=  gothic}', "");
    Expect(0, 66384, '\P{^Block=  gothic}', "");
    Error('\p{Blk=:=	-GOTHIC}');
    Error('\P{Blk=:=	-GOTHIC}');
    Expect(1, 66383, '\p{Blk=gothic}', "");
    Expect(0, 66383, '\p{^Blk=gothic}', "");
    Expect(0, 66383, '\P{Blk=gothic}', "");
    Expect(1, 66383, '\P{^Blk=gothic}', "");
    Expect(0, 66384, '\p{Blk=gothic}', "");
    Expect(1, 66384, '\p{^Blk=gothic}', "");
    Expect(1, 66384, '\P{Blk=gothic}', "");
    Expect(0, 66384, '\P{^Blk=gothic}', "");
    Expect(1, 66383, '\p{Blk=- gothic}', "");
    Expect(0, 66383, '\p{^Blk=- gothic}', "");
    Expect(0, 66383, '\P{Blk=- gothic}', "");
    Expect(1, 66383, '\P{^Blk=- gothic}', "");
    Expect(0, 66384, '\p{Blk=- gothic}', "");
    Expect(1, 66384, '\p{^Blk=- gothic}', "");
    Expect(1, 66384, '\P{Blk=- gothic}', "");
    Expect(0, 66384, '\P{^Blk=- gothic}', "");
    Error('\p{Is_Block=:= -Gothic}');
    Error('\P{Is_Block=:= -Gothic}');
    Expect(1, 66383, '\p{Is_Block=gothic}', "");
    Expect(0, 66383, '\p{^Is_Block=gothic}', "");
    Expect(0, 66383, '\P{Is_Block=gothic}', "");
    Expect(1, 66383, '\P{^Is_Block=gothic}', "");
    Expect(0, 66384, '\p{Is_Block=gothic}', "");
    Expect(1, 66384, '\p{^Is_Block=gothic}', "");
    Expect(1, 66384, '\P{Is_Block=gothic}', "");
    Expect(0, 66384, '\P{^Is_Block=gothic}', "");
    Expect(1, 66383, '\p{Is_Block=_	GOTHIC}', "");
    Expect(0, 66383, '\p{^Is_Block=_	GOTHIC}', "");
    Expect(0, 66383, '\P{Is_Block=_	GOTHIC}', "");
    Expect(1, 66383, '\P{^Is_Block=_	GOTHIC}', "");
    Expect(0, 66384, '\p{Is_Block=_	GOTHIC}', "");
    Expect(1, 66384, '\p{^Is_Block=_	GOTHIC}', "");
    Expect(1, 66384, '\P{Is_Block=_	GOTHIC}', "");
    Expect(0, 66384, '\P{^Is_Block=_	GOTHIC}', "");
    Error('\p{Is_Blk=:= _GOTHIC}');
    Error('\P{Is_Blk=:= _GOTHIC}');
    Expect(1, 66383, '\p{Is_Blk=gothic}', "");
    Expect(0, 66383, '\p{^Is_Blk=gothic}', "");
    Expect(0, 66383, '\P{Is_Blk=gothic}', "");
    Expect(1, 66383, '\P{^Is_Blk=gothic}', "");
    Expect(0, 66384, '\p{Is_Blk=gothic}', "");
    Expect(1, 66384, '\p{^Is_Blk=gothic}', "");
    Expect(1, 66384, '\P{Is_Blk=gothic}', "");
    Expect(0, 66384, '\P{^Is_Blk=gothic}', "");
    Expect(1, 66383, '\p{Is_Blk=_GOTHIC}', "");
    Expect(0, 66383, '\p{^Is_Blk=_GOTHIC}', "");
    Expect(0, 66383, '\P{Is_Blk=_GOTHIC}', "");
    Expect(1, 66383, '\P{^Is_Blk=_GOTHIC}', "");
    Expect(0, 66384, '\p{Is_Blk=_GOTHIC}', "");
    Expect(1, 66384, '\p{^Is_Blk=_GOTHIC}', "");
    Expect(1, 66384, '\P{Is_Blk=_GOTHIC}', "");
    Expect(0, 66384, '\P{^Is_Blk=_GOTHIC}', "");
    Error('\p{Block:/a/		Grantha}');
    Error('\P{Block:/a/		Grantha}');
    Expect(1, 70527, '\p{Block=grantha}', "");
    Expect(0, 70527, '\p{^Block=grantha}', "");
    Expect(0, 70527, '\P{Block=grantha}', "");
    Expect(1, 70527, '\P{^Block=grantha}', "");
    Expect(0, 70528, '\p{Block=grantha}', "");
    Expect(1, 70528, '\p{^Block=grantha}', "");
    Expect(1, 70528, '\P{Block=grantha}', "");
    Expect(0, 70528, '\P{^Block=grantha}', "");
    Expect(1, 70527, '\p{Block=-_GRANTHA}', "");
    Expect(0, 70527, '\p{^Block=-_GRANTHA}', "");
    Expect(0, 70527, '\P{Block=-_GRANTHA}', "");
    Expect(1, 70527, '\P{^Block=-_GRANTHA}', "");
    Expect(0, 70528, '\p{Block=-_GRANTHA}', "");
    Expect(1, 70528, '\p{^Block=-_GRANTHA}', "");
    Expect(1, 70528, '\P{Block=-_GRANTHA}', "");
    Expect(0, 70528, '\P{^Block=-_GRANTHA}', "");
    Error('\p{Blk=_Grantha/a/}');
    Error('\P{Blk=_Grantha/a/}');
    Expect(1, 70527, '\p{Blk=grantha}', "");
    Expect(0, 70527, '\p{^Blk=grantha}', "");
    Expect(0, 70527, '\P{Blk=grantha}', "");
    Expect(1, 70527, '\P{^Blk=grantha}', "");
    Expect(0, 70528, '\p{Blk=grantha}', "");
    Expect(1, 70528, '\p{^Blk=grantha}', "");
    Expect(1, 70528, '\P{Blk=grantha}', "");
    Expect(0, 70528, '\P{^Blk=grantha}', "");
    Expect(1, 70527, '\p{Blk:   -_GRANTHA}', "");
    Expect(0, 70527, '\p{^Blk:   -_GRANTHA}', "");
    Expect(0, 70527, '\P{Blk:   -_GRANTHA}', "");
    Expect(1, 70527, '\P{^Blk:   -_GRANTHA}', "");
    Expect(0, 70528, '\p{Blk:   -_GRANTHA}', "");
    Expect(1, 70528, '\p{^Blk:   -_GRANTHA}', "");
    Expect(1, 70528, '\P{Blk:   -_GRANTHA}', "");
    Expect(0, 70528, '\P{^Blk:   -_GRANTHA}', "");
    Error('\p{Is_Block= :=Grantha}');
    Error('\P{Is_Block= :=Grantha}');
    Expect(1, 70527, '\p{Is_Block: grantha}', "");
    Expect(0, 70527, '\p{^Is_Block: grantha}', "");
    Expect(0, 70527, '\P{Is_Block: grantha}', "");
    Expect(1, 70527, '\P{^Is_Block: grantha}', "");
    Expect(0, 70528, '\p{Is_Block: grantha}', "");
    Expect(1, 70528, '\p{^Is_Block: grantha}', "");
    Expect(1, 70528, '\P{Is_Block: grantha}', "");
    Expect(0, 70528, '\P{^Is_Block: grantha}', "");
    Expect(1, 70527, '\p{Is_Block=--Grantha}', "");
    Expect(0, 70527, '\p{^Is_Block=--Grantha}', "");
    Expect(0, 70527, '\P{Is_Block=--Grantha}', "");
    Expect(1, 70527, '\P{^Is_Block=--Grantha}', "");
    Expect(0, 70528, '\p{Is_Block=--Grantha}', "");
    Expect(1, 70528, '\p{^Is_Block=--Grantha}', "");
    Expect(1, 70528, '\P{Is_Block=--Grantha}', "");
    Expect(0, 70528, '\P{^Is_Block=--Grantha}', "");
    Error('\p{Is_Blk=/a/-grantha}');
    Error('\P{Is_Blk=/a/-grantha}');
    Expect(1, 70527, '\p{Is_Blk=grantha}', "");
    Expect(0, 70527, '\p{^Is_Blk=grantha}', "");
    Expect(0, 70527, '\P{Is_Blk=grantha}', "");
    Expect(1, 70527, '\P{^Is_Blk=grantha}', "");
    Expect(0, 70528, '\p{Is_Blk=grantha}', "");
    Expect(1, 70528, '\p{^Is_Blk=grantha}', "");
    Expect(1, 70528, '\P{Is_Blk=grantha}', "");
    Expect(0, 70528, '\P{^Is_Blk=grantha}', "");
    Expect(1, 70527, '\p{Is_Blk:__Grantha}', "");
    Expect(0, 70527, '\p{^Is_Blk:__Grantha}', "");
    Expect(0, 70527, '\P{Is_Blk:__Grantha}', "");
    Expect(1, 70527, '\P{^Is_Blk:__Grantha}', "");
    Expect(0, 70528, '\p{Is_Blk:__Grantha}', "");
    Expect(1, 70528, '\p{^Is_Blk:__Grantha}', "");
    Expect(1, 70528, '\P{Is_Blk:__Grantha}', "");
    Expect(0, 70528, '\P{^Is_Blk:__Grantha}', "");
    Error('\p{Block=:=Greek_and_coptic}');
    Error('\P{Block=:=Greek_and_coptic}');
    Expect(1, 1023, '\p{Block:	greekandcoptic}', "");
    Expect(0, 1023, '\p{^Block:	greekandcoptic}', "");
    Expect(0, 1023, '\P{Block:	greekandcoptic}', "");
    Expect(1, 1023, '\P{^Block:	greekandcoptic}', "");
    Expect(0, 1024, '\p{Block:	greekandcoptic}', "");
    Expect(1, 1024, '\p{^Block:	greekandcoptic}', "");
    Expect(1, 1024, '\P{Block:	greekandcoptic}', "");
    Expect(0, 1024, '\P{^Block:	greekandcoptic}', "");
    Expect(1, 1023, '\p{Block= -greek_and_Coptic}', "");
    Expect(0, 1023, '\p{^Block= -greek_and_Coptic}', "");
    Expect(0, 1023, '\P{Block= -greek_and_Coptic}', "");
    Expect(1, 1023, '\P{^Block= -greek_and_Coptic}', "");
    Expect(0, 1024, '\p{Block= -greek_and_Coptic}', "");
    Expect(1, 1024, '\p{^Block= -greek_and_Coptic}', "");
    Expect(1, 1024, '\P{Block= -greek_and_Coptic}', "");
    Expect(0, 1024, '\P{^Block= -greek_and_Coptic}', "");
    Error('\p{Blk=-_Greek:=}');
    Error('\P{Blk=-_Greek:=}');
    Expect(1, 1023, '\p{Blk=greek}', "");
    Expect(0, 1023, '\p{^Blk=greek}', "");
    Expect(0, 1023, '\P{Blk=greek}', "");
    Expect(1, 1023, '\P{^Blk=greek}', "");
    Expect(0, 1024, '\p{Blk=greek}', "");
    Expect(1, 1024, '\p{^Blk=greek}', "");
    Expect(1, 1024, '\P{Blk=greek}', "");
    Expect(0, 1024, '\P{^Blk=greek}', "");
    Expect(1, 1023, '\p{Blk=	_GREEK}', "");
    Expect(0, 1023, '\p{^Blk=	_GREEK}', "");
    Expect(0, 1023, '\P{Blk=	_GREEK}', "");
    Expect(1, 1023, '\P{^Blk=	_GREEK}', "");
    Expect(0, 1024, '\p{Blk=	_GREEK}', "");
    Expect(1, 1024, '\p{^Blk=	_GREEK}', "");
    Expect(1, 1024, '\P{Blk=	_GREEK}', "");
    Expect(0, 1024, '\P{^Blk=	_GREEK}', "");
    Error('\p{Is_Block=-greek_And_Coptic:=}');
    Error('\P{Is_Block=-greek_And_Coptic:=}');
    Expect(1, 1023, '\p{Is_Block=greekandcoptic}', "");
    Expect(0, 1023, '\p{^Is_Block=greekandcoptic}', "");
    Expect(0, 1023, '\P{Is_Block=greekandcoptic}', "");
    Expect(1, 1023, '\P{^Is_Block=greekandcoptic}', "");
    Expect(0, 1024, '\p{Is_Block=greekandcoptic}', "");
    Expect(1, 1024, '\p{^Is_Block=greekandcoptic}', "");
    Expect(1, 1024, '\P{Is_Block=greekandcoptic}', "");
    Expect(0, 1024, '\P{^Is_Block=greekandcoptic}', "");
    Expect(1, 1023, '\p{Is_Block= -Greek_And_Coptic}', "");
    Expect(0, 1023, '\p{^Is_Block= -Greek_And_Coptic}', "");
    Expect(0, 1023, '\P{Is_Block= -Greek_And_Coptic}', "");
    Expect(1, 1023, '\P{^Is_Block= -Greek_And_Coptic}', "");
    Expect(0, 1024, '\p{Is_Block= -Greek_And_Coptic}', "");
    Expect(1, 1024, '\p{^Is_Block= -Greek_And_Coptic}', "");
    Expect(1, 1024, '\P{Is_Block= -Greek_And_Coptic}', "");
    Expect(0, 1024, '\P{^Is_Block= -Greek_And_Coptic}', "");
    Error('\p{Is_Blk=:= GREEK}');
    Error('\P{Is_Blk=:= GREEK}');
    Expect(1, 1023, '\p{Is_Blk=greek}', "");
    Expect(0, 1023, '\p{^Is_Blk=greek}', "");
    Expect(0, 1023, '\P{Is_Blk=greek}', "");
    Expect(1, 1023, '\P{^Is_Blk=greek}', "");
    Expect(0, 1024, '\p{Is_Blk=greek}', "");
    Expect(1, 1024, '\p{^Is_Blk=greek}', "");
    Expect(1, 1024, '\P{Is_Blk=greek}', "");
    Expect(0, 1024, '\P{^Is_Blk=greek}', "");
    Expect(1, 1023, '\p{Is_Blk=  GREEK}', "");
    Expect(0, 1023, '\p{^Is_Blk=  GREEK}', "");
    Expect(0, 1023, '\P{Is_Blk=  GREEK}', "");
    Expect(1, 1023, '\P{^Is_Blk=  GREEK}', "");
    Expect(0, 1024, '\p{Is_Blk=  GREEK}', "");
    Expect(1, 1024, '\p{^Is_Blk=  GREEK}', "");
    Expect(1, 1024, '\P{Is_Blk=  GREEK}', "");
    Expect(0, 1024, '\P{^Is_Blk=  GREEK}', "");
    Error('\p{Block= GREEK_Extended:=}');
    Error('\P{Block= GREEK_Extended:=}');
    Expect(1, 8191, '\p{Block=greekextended}', "");
    Expect(0, 8191, '\p{^Block=greekextended}', "");
    Expect(0, 8191, '\P{Block=greekextended}', "");
    Expect(1, 8191, '\P{^Block=greekextended}', "");
    Expect(0, 8192, '\p{Block=greekextended}', "");
    Expect(1, 8192, '\p{^Block=greekextended}', "");
    Expect(1, 8192, '\P{Block=greekextended}', "");
    Expect(0, 8192, '\P{^Block=greekextended}', "");
    Expect(1, 8191, '\p{Block=_-Greek_Extended}', "");
    Expect(0, 8191, '\p{^Block=_-Greek_Extended}', "");
    Expect(0, 8191, '\P{Block=_-Greek_Extended}', "");
    Expect(1, 8191, '\P{^Block=_-Greek_Extended}', "");
    Expect(0, 8192, '\p{Block=_-Greek_Extended}', "");
    Expect(1, 8192, '\p{^Block=_-Greek_Extended}', "");
    Expect(1, 8192, '\P{Block=_-Greek_Extended}', "");
    Expect(0, 8192, '\P{^Block=_-Greek_Extended}', "");
    Error('\p{Blk=/a/GREEK_Ext}');
    Error('\P{Blk=/a/GREEK_Ext}');
    Expect(1, 8191, '\p{Blk=greekext}', "");
    Expect(0, 8191, '\p{^Blk=greekext}', "");
    Expect(0, 8191, '\P{Blk=greekext}', "");
    Expect(1, 8191, '\P{^Blk=greekext}', "");
    Expect(0, 8192, '\p{Blk=greekext}', "");
    Expect(1, 8192, '\p{^Blk=greekext}', "");
    Expect(1, 8192, '\P{Blk=greekext}', "");
    Expect(0, 8192, '\P{^Blk=greekext}', "");
    Expect(1, 8191, '\p{Blk=_Greek_EXT}', "");
    Expect(0, 8191, '\p{^Blk=_Greek_EXT}', "");
    Expect(0, 8191, '\P{Blk=_Greek_EXT}', "");
    Expect(1, 8191, '\P{^Blk=_Greek_EXT}', "");
    Expect(0, 8192, '\p{Blk=_Greek_EXT}', "");
    Expect(1, 8192, '\p{^Blk=_Greek_EXT}', "");
    Expect(1, 8192, '\P{Blk=_Greek_EXT}', "");
    Expect(0, 8192, '\P{^Blk=_Greek_EXT}', "");
    Error('\p{Is_Block=_/a/greek_EXTENDED}');
    Error('\P{Is_Block=_/a/greek_EXTENDED}');
    Expect(1, 8191, '\p{Is_Block=greekextended}', "");
    Expect(0, 8191, '\p{^Is_Block=greekextended}', "");
    Expect(0, 8191, '\P{Is_Block=greekextended}', "");
    Expect(1, 8191, '\P{^Is_Block=greekextended}', "");
    Expect(0, 8192, '\p{Is_Block=greekextended}', "");
    Expect(1, 8192, '\p{^Is_Block=greekextended}', "");
    Expect(1, 8192, '\P{Is_Block=greekextended}', "");
    Expect(0, 8192, '\P{^Is_Block=greekextended}', "");
    Expect(1, 8191, '\p{Is_Block=  Greek_Extended}', "");
    Expect(0, 8191, '\p{^Is_Block=  Greek_Extended}', "");
    Expect(0, 8191, '\P{Is_Block=  Greek_Extended}', "");
    Expect(1, 8191, '\P{^Is_Block=  Greek_Extended}', "");
    Expect(0, 8192, '\p{Is_Block=  Greek_Extended}', "");
    Expect(1, 8192, '\p{^Is_Block=  Greek_Extended}', "");
    Expect(1, 8192, '\P{Is_Block=  Greek_Extended}', "");
    Expect(0, 8192, '\P{^Is_Block=  Greek_Extended}', "");
    Error('\p{Is_Blk:  _Greek_ext/a/}');
    Error('\P{Is_Blk:  _Greek_ext/a/}');
    Expect(1, 8191, '\p{Is_Blk=greekext}', "");
    Expect(0, 8191, '\p{^Is_Blk=greekext}', "");
    Expect(0, 8191, '\P{Is_Blk=greekext}', "");
    Expect(1, 8191, '\P{^Is_Blk=greekext}', "");
    Expect(0, 8192, '\p{Is_Blk=greekext}', "");
    Expect(1, 8192, '\p{^Is_Blk=greekext}', "");
    Expect(1, 8192, '\P{Is_Blk=greekext}', "");
    Expect(0, 8192, '\P{^Is_Blk=greekext}', "");
    Expect(1, 8191, '\p{Is_Blk= Greek_EXT}', "");
    Expect(0, 8191, '\p{^Is_Blk= Greek_EXT}', "");
    Expect(0, 8191, '\P{Is_Blk= Greek_EXT}', "");
    Expect(1, 8191, '\P{^Is_Blk= Greek_EXT}', "");
    Expect(0, 8192, '\p{Is_Blk= Greek_EXT}', "");
    Expect(1, 8192, '\p{^Is_Blk= Greek_EXT}', "");
    Expect(1, 8192, '\P{Is_Blk= Greek_EXT}', "");
    Expect(0, 8192, '\P{^Is_Blk= Greek_EXT}', "");
    Error('\p{Block=/a/Gujarati}');
    Error('\P{Block=/a/Gujarati}');
    Expect(1, 2815, '\p{Block=gujarati}', "");
    Expect(0, 2815, '\p{^Block=gujarati}', "");
    Expect(0, 2815, '\P{Block=gujarati}', "");
    Expect(1, 2815, '\P{^Block=gujarati}', "");
    Expect(0, 2816, '\p{Block=gujarati}', "");
    Expect(1, 2816, '\p{^Block=gujarati}', "");
    Expect(1, 2816, '\P{Block=gujarati}', "");
    Expect(0, 2816, '\P{^Block=gujarati}', "");
    Expect(1, 2815, '\p{Block=_-Gujarati}', "");
    Expect(0, 2815, '\p{^Block=_-Gujarati}', "");
    Expect(0, 2815, '\P{Block=_-Gujarati}', "");
    Expect(1, 2815, '\P{^Block=_-Gujarati}', "");
    Expect(0, 2816, '\p{Block=_-Gujarati}', "");
    Expect(1, 2816, '\p{^Block=_-Gujarati}', "");
    Expect(1, 2816, '\P{Block=_-Gujarati}', "");
    Expect(0, 2816, '\P{^Block=_-Gujarati}', "");
    Error('\p{Blk= -gujarati/a/}');
    Error('\P{Blk= -gujarati/a/}');
    Expect(1, 2815, '\p{Blk=gujarati}', "");
    Expect(0, 2815, '\p{^Blk=gujarati}', "");
    Expect(0, 2815, '\P{Blk=gujarati}', "");
    Expect(1, 2815, '\P{^Blk=gujarati}', "");
    Expect(0, 2816, '\p{Blk=gujarati}', "");
    Expect(1, 2816, '\p{^Blk=gujarati}', "");
    Expect(1, 2816, '\P{Blk=gujarati}', "");
    Expect(0, 2816, '\P{^Blk=gujarati}', "");
    Expect(1, 2815, '\p{Blk= Gujarati}', "");
    Expect(0, 2815, '\p{^Blk= Gujarati}', "");
    Expect(0, 2815, '\P{Blk= Gujarati}', "");
    Expect(1, 2815, '\P{^Blk= Gujarati}', "");
    Expect(0, 2816, '\p{Blk= Gujarati}', "");
    Expect(1, 2816, '\p{^Blk= Gujarati}', "");
    Expect(1, 2816, '\P{Blk= Gujarati}', "");
    Expect(0, 2816, '\P{^Blk= Gujarati}', "");
    Error('\p{Is_Block=/a/-gujarati}');
    Error('\P{Is_Block=/a/-gujarati}');
    Expect(1, 2815, '\p{Is_Block:	gujarati}', "");
    Expect(0, 2815, '\p{^Is_Block:	gujarati}', "");
    Expect(0, 2815, '\P{Is_Block:	gujarati}', "");
    Expect(1, 2815, '\P{^Is_Block:	gujarati}', "");
    Expect(0, 2816, '\p{Is_Block:	gujarati}', "");
    Expect(1, 2816, '\p{^Is_Block:	gujarati}', "");
    Expect(1, 2816, '\P{Is_Block:	gujarati}', "");
    Expect(0, 2816, '\P{^Is_Block:	gujarati}', "");
    Expect(1, 2815, '\p{Is_Block=	Gujarati}', "");
    Expect(0, 2815, '\p{^Is_Block=	Gujarati}', "");
    Expect(0, 2815, '\P{Is_Block=	Gujarati}', "");
    Expect(1, 2815, '\P{^Is_Block=	Gujarati}', "");
    Expect(0, 2816, '\p{Is_Block=	Gujarati}', "");
    Expect(1, 2816, '\p{^Is_Block=	Gujarati}', "");
    Expect(1, 2816, '\P{Is_Block=	Gujarati}', "");
    Expect(0, 2816, '\P{^Is_Block=	Gujarati}', "");
    Error('\p{Is_Blk=  Gujarati:=}');
    Error('\P{Is_Blk=  Gujarati:=}');
    Expect(1, 2815, '\p{Is_Blk=gujarati}', "");
    Expect(0, 2815, '\p{^Is_Blk=gujarati}', "");
    Expect(0, 2815, '\P{Is_Blk=gujarati}', "");
    Expect(1, 2815, '\P{^Is_Blk=gujarati}', "");
    Expect(0, 2816, '\p{Is_Blk=gujarati}', "");
    Expect(1, 2816, '\p{^Is_Blk=gujarati}', "");
    Expect(1, 2816, '\P{Is_Blk=gujarati}', "");
    Expect(0, 2816, '\P{^Is_Blk=gujarati}', "");
    Expect(1, 2815, '\p{Is_Blk=  Gujarati}', "");
    Expect(0, 2815, '\p{^Is_Blk=  Gujarati}', "");
    Expect(0, 2815, '\P{Is_Blk=  Gujarati}', "");
    Expect(1, 2815, '\P{^Is_Blk=  Gujarati}', "");
    Expect(0, 2816, '\p{Is_Blk=  Gujarati}', "");
    Expect(1, 2816, '\p{^Is_Blk=  Gujarati}', "");
    Expect(1, 2816, '\P{Is_Blk=  Gujarati}', "");
    Expect(0, 2816, '\P{^Is_Blk=  Gujarati}', "");
    Error('\p{Block=:=__gurmukhi}');
    Error('\P{Block=:=__gurmukhi}');
    Expect(1, 2687, '\p{Block:   gurmukhi}', "");
    Expect(0, 2687, '\p{^Block:   gurmukhi}', "");
    Expect(0, 2687, '\P{Block:   gurmukhi}', "");
    Expect(1, 2687, '\P{^Block:   gurmukhi}', "");
    Expect(0, 2688, '\p{Block:   gurmukhi}', "");
    Expect(1, 2688, '\p{^Block:   gurmukhi}', "");
    Expect(1, 2688, '\P{Block:   gurmukhi}', "");
    Expect(0, 2688, '\P{^Block:   gurmukhi}', "");
    Expect(1, 2687, '\p{Block:   	_GURMUKHI}', "");
    Expect(0, 2687, '\p{^Block:   	_GURMUKHI}', "");
    Expect(0, 2687, '\P{Block:   	_GURMUKHI}', "");
    Expect(1, 2687, '\P{^Block:   	_GURMUKHI}', "");
    Expect(0, 2688, '\p{Block:   	_GURMUKHI}', "");
    Expect(1, 2688, '\p{^Block:   	_GURMUKHI}', "");
    Expect(1, 2688, '\P{Block:   	_GURMUKHI}', "");
    Expect(0, 2688, '\P{^Block:   	_GURMUKHI}', "");
    Error('\p{Blk=-Gurmukhi:=}');
    Error('\P{Blk=-Gurmukhi:=}');
    Expect(1, 2687, '\p{Blk=gurmukhi}', "");
    Expect(0, 2687, '\p{^Blk=gurmukhi}', "");
    Expect(0, 2687, '\P{Blk=gurmukhi}', "");
    Expect(1, 2687, '\P{^Blk=gurmukhi}', "");
    Expect(0, 2688, '\p{Blk=gurmukhi}', "");
    Expect(1, 2688, '\p{^Blk=gurmukhi}', "");
    Expect(1, 2688, '\P{Blk=gurmukhi}', "");
    Expect(0, 2688, '\P{^Blk=gurmukhi}', "");
    Expect(1, 2687, '\p{Blk=	Gurmukhi}', "");
    Expect(0, 2687, '\p{^Blk=	Gurmukhi}', "");
    Expect(0, 2687, '\P{Blk=	Gurmukhi}', "");
    Expect(1, 2687, '\P{^Blk=	Gurmukhi}', "");
    Expect(0, 2688, '\p{Blk=	Gurmukhi}', "");
    Expect(1, 2688, '\p{^Blk=	Gurmukhi}', "");
    Expect(1, 2688, '\P{Blk=	Gurmukhi}', "");
    Expect(0, 2688, '\P{^Blk=	Gurmukhi}', "");
    Error('\p{Is_Block= /a/Gurmukhi}');
    Error('\P{Is_Block= /a/Gurmukhi}');
    Expect(1, 2687, '\p{Is_Block=gurmukhi}', "");
    Expect(0, 2687, '\p{^Is_Block=gurmukhi}', "");
    Expect(0, 2687, '\P{Is_Block=gurmukhi}', "");
    Expect(1, 2687, '\P{^Is_Block=gurmukhi}', "");
    Expect(0, 2688, '\p{Is_Block=gurmukhi}', "");
    Expect(1, 2688, '\p{^Is_Block=gurmukhi}', "");
    Expect(1, 2688, '\P{Is_Block=gurmukhi}', "");
    Expect(0, 2688, '\P{^Is_Block=gurmukhi}', "");
    Expect(1, 2687, '\p{Is_Block=_	GURMUKHI}', "");
    Expect(0, 2687, '\p{^Is_Block=_	GURMUKHI}', "");
    Expect(0, 2687, '\P{Is_Block=_	GURMUKHI}', "");
    Expect(1, 2687, '\P{^Is_Block=_	GURMUKHI}', "");
    Expect(0, 2688, '\p{Is_Block=_	GURMUKHI}', "");
    Expect(1, 2688, '\p{^Is_Block=_	GURMUKHI}', "");
    Expect(1, 2688, '\P{Is_Block=_	GURMUKHI}', "");
    Expect(0, 2688, '\P{^Is_Block=_	GURMUKHI}', "");
    Error('\p{Is_Blk=:=	 Gurmukhi}');
    Error('\P{Is_Blk=:=	 Gurmukhi}');
    Expect(1, 2687, '\p{Is_Blk=gurmukhi}', "");
    Expect(0, 2687, '\p{^Is_Blk=gurmukhi}', "");
    Expect(0, 2687, '\P{Is_Blk=gurmukhi}', "");
    Expect(1, 2687, '\P{^Is_Blk=gurmukhi}', "");
    Expect(0, 2688, '\p{Is_Blk=gurmukhi}', "");
    Expect(1, 2688, '\p{^Is_Blk=gurmukhi}', "");
    Expect(1, 2688, '\P{Is_Blk=gurmukhi}', "");
    Expect(0, 2688, '\P{^Is_Blk=gurmukhi}', "");
    Expect(1, 2687, '\p{Is_Blk=_Gurmukhi}', "");
    Expect(0, 2687, '\p{^Is_Blk=_Gurmukhi}', "");
    Expect(0, 2687, '\P{Is_Blk=_Gurmukhi}', "");
    Expect(1, 2687, '\P{^Is_Blk=_Gurmukhi}', "");
    Expect(0, 2688, '\p{Is_Blk=_Gurmukhi}', "");
    Expect(1, 2688, '\p{^Is_Blk=_Gurmukhi}', "");
    Expect(1, 2688, '\P{Is_Blk=_Gurmukhi}', "");
    Expect(0, 2688, '\P{^Is_Blk=_Gurmukhi}', "");
    Error('\p{Block=	Halfwidth_AND_Fullwidth_Forms:=}');
    Error('\P{Block=	Halfwidth_AND_Fullwidth_Forms:=}');
    Expect(1, 65519, '\p{Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\p{^Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\P{Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\P{^Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\p{Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\p{^Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\P{Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\P{^Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\p{Block=_halfwidth_And_Fullwidth_Forms}', "");
    Expect(0, 65519, '\p{^Block=_halfwidth_And_Fullwidth_Forms}', "");
    Expect(0, 65519, '\P{Block=_halfwidth_And_Fullwidth_Forms}', "");
    Expect(1, 65519, '\P{^Block=_halfwidth_And_Fullwidth_Forms}', "");
    Expect(0, 65520, '\p{Block=_halfwidth_And_Fullwidth_Forms}', "");
    Expect(1, 65520, '\p{^Block=_halfwidth_And_Fullwidth_Forms}', "");
    Expect(1, 65520, '\P{Block=_halfwidth_And_Fullwidth_Forms}', "");
    Expect(0, 65520, '\P{^Block=_halfwidth_And_Fullwidth_Forms}', "");
    Error('\p{Blk=_/a/half_And_Full_Forms}');
    Error('\P{Blk=_/a/half_And_Full_Forms}');
    Expect(1, 65519, '\p{Blk=halfandfullforms}', "");
    Expect(0, 65519, '\p{^Blk=halfandfullforms}', "");
    Expect(0, 65519, '\P{Blk=halfandfullforms}', "");
    Expect(1, 65519, '\P{^Blk=halfandfullforms}', "");
    Expect(0, 65520, '\p{Blk=halfandfullforms}', "");
    Expect(1, 65520, '\p{^Blk=halfandfullforms}', "");
    Expect(1, 65520, '\P{Blk=halfandfullforms}', "");
    Expect(0, 65520, '\P{^Blk=halfandfullforms}', "");
    Expect(1, 65519, '\p{Blk=	_half_And_full_Forms}', "");
    Expect(0, 65519, '\p{^Blk=	_half_And_full_Forms}', "");
    Expect(0, 65519, '\P{Blk=	_half_And_full_Forms}', "");
    Expect(1, 65519, '\P{^Blk=	_half_And_full_Forms}', "");
    Expect(0, 65520, '\p{Blk=	_half_And_full_Forms}', "");
    Expect(1, 65520, '\p{^Blk=	_half_And_full_Forms}', "");
    Expect(1, 65520, '\P{Blk=	_half_And_full_Forms}', "");
    Expect(0, 65520, '\P{^Blk=	_half_And_full_Forms}', "");
    Error('\p{Is_Block= :=halfwidth_and_fullwidth_Forms}');
    Error('\P{Is_Block= :=halfwidth_and_fullwidth_Forms}');
    Expect(1, 65519, '\p{Is_Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\p{^Is_Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\P{Is_Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\P{^Is_Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\p{Is_Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\p{^Is_Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\P{Is_Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\P{^Is_Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\p{Is_Block:   -Halfwidth_and_fullwidth_FORMS}', "");
    Expect(0, 65519, '\p{^Is_Block:   -Halfwidth_and_fullwidth_FORMS}', "");
    Expect(0, 65519, '\P{Is_Block:   -Halfwidth_and_fullwidth_FORMS}', "");
    Expect(1, 65519, '\P{^Is_Block:   -Halfwidth_and_fullwidth_FORMS}', "");
    Expect(0, 65520, '\p{Is_Block:   -Halfwidth_and_fullwidth_FORMS}', "");
    Expect(1, 65520, '\p{^Is_Block:   -Halfwidth_and_fullwidth_FORMS}', "");
    Expect(1, 65520, '\P{Is_Block:   -Halfwidth_and_fullwidth_FORMS}', "");
    Expect(0, 65520, '\P{^Is_Block:   -Halfwidth_and_fullwidth_FORMS}', "");
    Error('\p{Is_Blk= /a/HALF_AND_Full_forms}');
    Error('\P{Is_Blk= /a/HALF_AND_Full_forms}');
    Expect(1, 65519, '\p{Is_Blk=halfandfullforms}', "");
    Expect(0, 65519, '\p{^Is_Blk=halfandfullforms}', "");
    Expect(0, 65519, '\P{Is_Blk=halfandfullforms}', "");
    Expect(1, 65519, '\P{^Is_Blk=halfandfullforms}', "");
    Expect(0, 65520, '\p{Is_Blk=halfandfullforms}', "");
    Expect(1, 65520, '\p{^Is_Blk=halfandfullforms}', "");
    Expect(1, 65520, '\P{Is_Blk=halfandfullforms}', "");
    Expect(0, 65520, '\P{^Is_Blk=halfandfullforms}', "");
    Expect(1, 65519, '\p{Is_Blk= -half_and_Full_FORMS}', "");
    Expect(0, 65519, '\p{^Is_Blk= -half_and_Full_FORMS}', "");
    Expect(0, 65519, '\P{Is_Blk= -half_and_Full_FORMS}', "");
    Expect(1, 65519, '\P{^Is_Blk= -half_and_Full_FORMS}', "");
    Expect(0, 65520, '\p{Is_Blk= -half_and_Full_FORMS}', "");
    Expect(1, 65520, '\p{^Is_Blk= -half_and_Full_FORMS}', "");
    Expect(1, 65520, '\P{Is_Blk= -half_and_Full_FORMS}', "");
    Expect(0, 65520, '\P{^Is_Blk= -half_and_Full_FORMS}', "");
    Error('\p{Block=-Combining_HALF_Marks:=}');
    Error('\P{Block=-Combining_HALF_Marks:=}');
    Expect(1, 65071, '\p{Block:   combininghalfmarks}', "");
    Expect(0, 65071, '\p{^Block:   combininghalfmarks}', "");
    Expect(0, 65071, '\P{Block:   combininghalfmarks}', "");
    Expect(1, 65071, '\P{^Block:   combininghalfmarks}', "");
    Expect(0, 65072, '\p{Block:   combininghalfmarks}', "");
    Expect(1, 65072, '\p{^Block:   combininghalfmarks}', "");
    Expect(1, 65072, '\P{Block:   combininghalfmarks}', "");
    Expect(0, 65072, '\P{^Block:   combininghalfmarks}', "");
    Expect(1, 65071, '\p{Block:		Combining_half_Marks}', "");
    Expect(0, 65071, '\p{^Block:		Combining_half_Marks}', "");
    Expect(0, 65071, '\P{Block:		Combining_half_Marks}', "");
    Expect(1, 65071, '\P{^Block:		Combining_half_Marks}', "");
    Expect(0, 65072, '\p{Block:		Combining_half_Marks}', "");
    Expect(1, 65072, '\p{^Block:		Combining_half_Marks}', "");
    Expect(1, 65072, '\P{Block:		Combining_half_Marks}', "");
    Expect(0, 65072, '\P{^Block:		Combining_half_Marks}', "");
    Error('\p{Blk=:= 	Half_Marks}');
    Error('\P{Blk=:= 	Half_Marks}');
    Expect(1, 65071, '\p{Blk=halfmarks}', "");
    Expect(0, 65071, '\p{^Blk=halfmarks}', "");
    Expect(0, 65071, '\P{Blk=halfmarks}', "");
    Expect(1, 65071, '\P{^Blk=halfmarks}', "");
    Expect(0, 65072, '\p{Blk=halfmarks}', "");
    Expect(1, 65072, '\p{^Blk=halfmarks}', "");
    Expect(1, 65072, '\P{Blk=halfmarks}', "");
    Expect(0, 65072, '\P{^Blk=halfmarks}', "");
    Expect(1, 65071, '\p{Blk=	 half_marks}', "");
    Expect(0, 65071, '\p{^Blk=	 half_marks}', "");
    Expect(0, 65071, '\P{Blk=	 half_marks}', "");
    Expect(1, 65071, '\P{^Blk=	 half_marks}', "");
    Expect(0, 65072, '\p{Blk=	 half_marks}', "");
    Expect(1, 65072, '\p{^Blk=	 half_marks}', "");
    Expect(1, 65072, '\P{Blk=	 half_marks}', "");
    Expect(0, 65072, '\P{^Blk=	 half_marks}', "");
    Error('\p{Is_Block=/a/combining_Half_MARKS}');
    Error('\P{Is_Block=/a/combining_Half_MARKS}');
    Expect(1, 65071, '\p{Is_Block=combininghalfmarks}', "");
    Expect(0, 65071, '\p{^Is_Block=combininghalfmarks}', "");
    Expect(0, 65071, '\P{Is_Block=combininghalfmarks}', "");
    Expect(1, 65071, '\P{^Is_Block=combininghalfmarks}', "");
    Expect(0, 65072, '\p{Is_Block=combininghalfmarks}', "");
    Expect(1, 65072, '\p{^Is_Block=combininghalfmarks}', "");
    Expect(1, 65072, '\P{Is_Block=combininghalfmarks}', "");
    Expect(0, 65072, '\P{^Is_Block=combininghalfmarks}', "");
    Expect(1, 65071, '\p{Is_Block:   -Combining_Half_marks}', "");
    Expect(0, 65071, '\p{^Is_Block:   -Combining_Half_marks}', "");
    Expect(0, 65071, '\P{Is_Block:   -Combining_Half_marks}', "");
    Expect(1, 65071, '\P{^Is_Block:   -Combining_Half_marks}', "");
    Expect(0, 65072, '\p{Is_Block:   -Combining_Half_marks}', "");
    Expect(1, 65072, '\p{^Is_Block:   -Combining_Half_marks}', "");
    Expect(1, 65072, '\P{Is_Block:   -Combining_Half_marks}', "");
    Expect(0, 65072, '\P{^Is_Block:   -Combining_Half_marks}', "");
    Error('\p{Is_Blk=_	Half_Marks:=}');
    Error('\P{Is_Blk=_	Half_Marks:=}');
    Expect(1, 65071, '\p{Is_Blk=halfmarks}', "");
    Expect(0, 65071, '\p{^Is_Blk=halfmarks}', "");
    Expect(0, 65071, '\P{Is_Blk=halfmarks}', "");
    Expect(1, 65071, '\P{^Is_Blk=halfmarks}', "");
    Expect(0, 65072, '\p{Is_Blk=halfmarks}', "");
    Expect(1, 65072, '\p{^Is_Blk=halfmarks}', "");
    Expect(1, 65072, '\P{Is_Blk=halfmarks}', "");
    Expect(0, 65072, '\P{^Is_Blk=halfmarks}', "");
    Expect(1, 65071, '\p{Is_Blk=-Half_marks}', "");
    Expect(0, 65071, '\p{^Is_Blk=-Half_marks}', "");
    Expect(0, 65071, '\P{Is_Blk=-Half_marks}', "");
    Expect(1, 65071, '\P{^Is_Blk=-Half_marks}', "");
    Expect(0, 65072, '\p{Is_Blk=-Half_marks}', "");
    Expect(1, 65072, '\p{^Is_Blk=-Half_marks}', "");
    Expect(1, 65072, '\P{Is_Blk=-Half_marks}', "");
    Expect(0, 65072, '\P{^Is_Blk=-Half_marks}', "");
    Error('\p{Block=-/a/HANGUL_syllables}');
    Error('\P{Block=-/a/HANGUL_syllables}');
    Expect(1, 55215, '\p{Block=hangulsyllables}', "");
    Expect(0, 55215, '\p{^Block=hangulsyllables}', "");
    Expect(0, 55215, '\P{Block=hangulsyllables}', "");
    Expect(1, 55215, '\P{^Block=hangulsyllables}', "");
    Expect(0, 55216, '\p{Block=hangulsyllables}', "");
    Expect(1, 55216, '\p{^Block=hangulsyllables}', "");
    Expect(1, 55216, '\P{Block=hangulsyllables}', "");
    Expect(0, 55216, '\P{^Block=hangulsyllables}', "");
    Expect(1, 55215, '\p{Block=-	HANGUL_Syllables}', "");
    Expect(0, 55215, '\p{^Block=-	HANGUL_Syllables}', "");
    Expect(0, 55215, '\P{Block=-	HANGUL_Syllables}', "");
    Expect(1, 55215, '\P{^Block=-	HANGUL_Syllables}', "");
    Expect(0, 55216, '\p{Block=-	HANGUL_Syllables}', "");
    Expect(1, 55216, '\p{^Block=-	HANGUL_Syllables}', "");
    Expect(1, 55216, '\P{Block=-	HANGUL_Syllables}', "");
    Expect(0, 55216, '\P{^Block=-	HANGUL_Syllables}', "");
    Error('\p{Blk=:=HANGUL}');
    Error('\P{Blk=:=HANGUL}');
    Expect(1, 55215, '\p{Blk=hangul}', "");
    Expect(0, 55215, '\p{^Blk=hangul}', "");
    Expect(0, 55215, '\P{Blk=hangul}', "");
    Expect(1, 55215, '\P{^Blk=hangul}', "");
    Expect(0, 55216, '\p{Blk=hangul}', "");
    Expect(1, 55216, '\p{^Blk=hangul}', "");
    Expect(1, 55216, '\P{Blk=hangul}', "");
    Expect(0, 55216, '\P{^Blk=hangul}', "");
    Expect(1, 55215, '\p{Blk=- HANGUL}', "");
    Expect(0, 55215, '\p{^Blk=- HANGUL}', "");
    Expect(0, 55215, '\P{Blk=- HANGUL}', "");
    Expect(1, 55215, '\P{^Blk=- HANGUL}', "");
    Expect(0, 55216, '\p{Blk=- HANGUL}', "");
    Expect(1, 55216, '\p{^Blk=- HANGUL}', "");
    Expect(1, 55216, '\P{Blk=- HANGUL}', "");
    Expect(0, 55216, '\P{^Blk=- HANGUL}', "");
    Error('\p{Is_Block=/a/-_Hangul_syllables}');
    Error('\P{Is_Block=/a/-_Hangul_syllables}');
    Expect(1, 55215, '\p{Is_Block:	hangulsyllables}', "");
    Expect(0, 55215, '\p{^Is_Block:	hangulsyllables}', "");
    Expect(0, 55215, '\P{Is_Block:	hangulsyllables}', "");
    Expect(1, 55215, '\P{^Is_Block:	hangulsyllables}', "");
    Expect(0, 55216, '\p{Is_Block:	hangulsyllables}', "");
    Expect(1, 55216, '\p{^Is_Block:	hangulsyllables}', "");
    Expect(1, 55216, '\P{Is_Block:	hangulsyllables}', "");
    Expect(0, 55216, '\P{^Is_Block:	hangulsyllables}', "");
    Expect(1, 55215, '\p{Is_Block=_Hangul_Syllables}', "");
    Expect(0, 55215, '\p{^Is_Block=_Hangul_Syllables}', "");
    Expect(0, 55215, '\P{Is_Block=_Hangul_Syllables}', "");
    Expect(1, 55215, '\P{^Is_Block=_Hangul_Syllables}', "");
    Expect(0, 55216, '\p{Is_Block=_Hangul_Syllables}', "");
    Expect(1, 55216, '\p{^Is_Block=_Hangul_Syllables}', "");
    Expect(1, 55216, '\P{Is_Block=_Hangul_Syllables}', "");
    Expect(0, 55216, '\P{^Is_Block=_Hangul_Syllables}', "");
    Error('\p{Is_Blk=	hangul/a/}');
    Error('\P{Is_Blk=	hangul/a/}');
    Expect(1, 55215, '\p{Is_Blk=hangul}', "");
    Expect(0, 55215, '\p{^Is_Blk=hangul}', "");
    Expect(0, 55215, '\P{Is_Blk=hangul}', "");
    Expect(1, 55215, '\P{^Is_Blk=hangul}', "");
    Expect(0, 55216, '\p{Is_Blk=hangul}', "");
    Expect(1, 55216, '\p{^Is_Blk=hangul}', "");
    Expect(1, 55216, '\P{Is_Blk=hangul}', "");
    Expect(0, 55216, '\P{^Is_Blk=hangul}', "");
    Expect(1, 55215, '\p{Is_Blk=--HANGUL}', "");
    Expect(0, 55215, '\p{^Is_Blk=--HANGUL}', "");
    Expect(0, 55215, '\P{Is_Blk=--HANGUL}', "");
    Expect(1, 55215, '\P{^Is_Blk=--HANGUL}', "");
    Expect(0, 55216, '\p{Is_Blk=--HANGUL}', "");
    Expect(1, 55216, '\p{^Is_Blk=--HANGUL}', "");
    Expect(1, 55216, '\P{Is_Blk=--HANGUL}', "");
    Expect(0, 55216, '\P{^Is_Blk=--HANGUL}', "");
    Error('\p{Block: := HANUNOO}');
    Error('\P{Block: := HANUNOO}');
    Expect(1, 5951, '\p{Block=hanunoo}', "");
    Expect(0, 5951, '\p{^Block=hanunoo}', "");
    Expect(0, 5951, '\P{Block=hanunoo}', "");
    Expect(1, 5951, '\P{^Block=hanunoo}', "");
    Expect(0, 5952, '\p{Block=hanunoo}', "");
    Expect(1, 5952, '\p{^Block=hanunoo}', "");
    Expect(1, 5952, '\P{Block=hanunoo}', "");
    Expect(0, 5952, '\P{^Block=hanunoo}', "");
    Expect(1, 5951, '\p{Block= _HANUNOO}', "");
    Expect(0, 5951, '\p{^Block= _HANUNOO}', "");
    Expect(0, 5951, '\P{Block= _HANUNOO}', "");
    Expect(1, 5951, '\P{^Block= _HANUNOO}', "");
    Expect(0, 5952, '\p{Block= _HANUNOO}', "");
    Expect(1, 5952, '\p{^Block= _HANUNOO}', "");
    Expect(1, 5952, '\P{Block= _HANUNOO}', "");
    Expect(0, 5952, '\P{^Block= _HANUNOO}', "");
    Error('\p{Blk=/a/	_hanunoo}');
    Error('\P{Blk=/a/	_hanunoo}');
    Expect(1, 5951, '\p{Blk=hanunoo}', "");
    Expect(0, 5951, '\p{^Blk=hanunoo}', "");
    Expect(0, 5951, '\P{Blk=hanunoo}', "");
    Expect(1, 5951, '\P{^Blk=hanunoo}', "");
    Expect(0, 5952, '\p{Blk=hanunoo}', "");
    Expect(1, 5952, '\p{^Blk=hanunoo}', "");
    Expect(1, 5952, '\P{Blk=hanunoo}', "");
    Expect(0, 5952, '\P{^Blk=hanunoo}', "");
    Expect(1, 5951, '\p{Blk=-	Hanunoo}', "");
    Expect(0, 5951, '\p{^Blk=-	Hanunoo}', "");
    Expect(0, 5951, '\P{Blk=-	Hanunoo}', "");
    Expect(1, 5951, '\P{^Blk=-	Hanunoo}', "");
    Expect(0, 5952, '\p{Blk=-	Hanunoo}', "");
    Expect(1, 5952, '\p{^Blk=-	Hanunoo}', "");
    Expect(1, 5952, '\P{Blk=-	Hanunoo}', "");
    Expect(0, 5952, '\P{^Blk=-	Hanunoo}', "");
    Error('\p{Is_Block:		hanunoo/a/}');
    Error('\P{Is_Block:		hanunoo/a/}');
    Expect(1, 5951, '\p{Is_Block: hanunoo}', "");
    Expect(0, 5951, '\p{^Is_Block: hanunoo}', "");
    Expect(0, 5951, '\P{Is_Block: hanunoo}', "");
    Expect(1, 5951, '\P{^Is_Block: hanunoo}', "");
    Expect(0, 5952, '\p{Is_Block: hanunoo}', "");
    Expect(1, 5952, '\p{^Is_Block: hanunoo}', "");
    Expect(1, 5952, '\P{Is_Block: hanunoo}', "");
    Expect(0, 5952, '\P{^Is_Block: hanunoo}', "");
    Expect(1, 5951, '\p{Is_Block=  Hanunoo}', "");
    Expect(0, 5951, '\p{^Is_Block=  Hanunoo}', "");
    Expect(0, 5951, '\P{Is_Block=  Hanunoo}', "");
    Expect(1, 5951, '\P{^Is_Block=  Hanunoo}', "");
    Expect(0, 5952, '\p{Is_Block=  Hanunoo}', "");
    Expect(1, 5952, '\p{^Is_Block=  Hanunoo}', "");
    Expect(1, 5952, '\P{Is_Block=  Hanunoo}', "");
    Expect(0, 5952, '\P{^Is_Block=  Hanunoo}', "");
    Error('\p{Is_Blk=	/a/Hanunoo}');
    Error('\P{Is_Blk=	/a/Hanunoo}');
    Expect(1, 5951, '\p{Is_Blk:	hanunoo}', "");
    Expect(0, 5951, '\p{^Is_Blk:	hanunoo}', "");
    Expect(0, 5951, '\P{Is_Blk:	hanunoo}', "");
    Expect(1, 5951, '\P{^Is_Blk:	hanunoo}', "");
    Expect(0, 5952, '\p{Is_Blk:	hanunoo}', "");
    Expect(1, 5952, '\p{^Is_Blk:	hanunoo}', "");
    Expect(1, 5952, '\P{Is_Blk:	hanunoo}', "");
    Expect(0, 5952, '\P{^Is_Blk:	hanunoo}', "");
    Expect(1, 5951, '\p{Is_Blk= -Hanunoo}', "");
    Expect(0, 5951, '\p{^Is_Blk= -Hanunoo}', "");
    Expect(0, 5951, '\P{Is_Blk= -Hanunoo}', "");
    Expect(1, 5951, '\P{^Is_Blk= -Hanunoo}', "");
    Expect(0, 5952, '\p{Is_Blk= -Hanunoo}', "");
    Expect(1, 5952, '\p{^Is_Blk= -Hanunoo}', "");
    Expect(1, 5952, '\P{Is_Blk= -Hanunoo}', "");
    Expect(0, 5952, '\P{^Is_Blk= -Hanunoo}', "");
    Error('\p{Block=_/a/Hatran}');
    Error('\P{Block=_/a/Hatran}');
    Expect(1, 67839, '\p{Block=hatran}', "");
    Expect(0, 67839, '\p{^Block=hatran}', "");
    Expect(0, 67839, '\P{Block=hatran}', "");
    Expect(1, 67839, '\P{^Block=hatran}', "");
    Expect(0, 67840, '\p{Block=hatran}', "");
    Expect(1, 67840, '\p{^Block=hatran}', "");
    Expect(1, 67840, '\P{Block=hatran}', "");
    Expect(0, 67840, '\P{^Block=hatran}', "");
    Expect(1, 67839, '\p{Block=-HATRAN}', "");
    Expect(0, 67839, '\p{^Block=-HATRAN}', "");
    Expect(0, 67839, '\P{Block=-HATRAN}', "");
    Expect(1, 67839, '\P{^Block=-HATRAN}', "");
    Expect(0, 67840, '\p{Block=-HATRAN}', "");
    Expect(1, 67840, '\p{^Block=-HATRAN}', "");
    Expect(1, 67840, '\P{Block=-HATRAN}', "");
    Expect(0, 67840, '\P{^Block=-HATRAN}', "");
    Error('\p{Blk=-:=hatran}');
    Error('\P{Blk=-:=hatran}');
    Expect(1, 67839, '\p{Blk=hatran}', "");
    Expect(0, 67839, '\p{^Blk=hatran}', "");
    Expect(0, 67839, '\P{Blk=hatran}', "");
    Expect(1, 67839, '\P{^Blk=hatran}', "");
    Expect(0, 67840, '\p{Blk=hatran}', "");
    Expect(1, 67840, '\p{^Blk=hatran}', "");
    Expect(1, 67840, '\P{Blk=hatran}', "");
    Expect(0, 67840, '\P{^Blk=hatran}', "");
    Expect(1, 67839, '\p{Blk=_ Hatran}', "");
    Expect(0, 67839, '\p{^Blk=_ Hatran}', "");
    Expect(0, 67839, '\P{Blk=_ Hatran}', "");
    Expect(1, 67839, '\P{^Blk=_ Hatran}', "");
    Expect(0, 67840, '\p{Blk=_ Hatran}', "");
    Expect(1, 67840, '\p{^Blk=_ Hatran}', "");
    Expect(1, 67840, '\P{Blk=_ Hatran}', "");
    Expect(0, 67840, '\P{^Blk=_ Hatran}', "");
    Error('\p{Is_Block: 	HATRAN:=}');
    Error('\P{Is_Block: 	HATRAN:=}');
    Expect(1, 67839, '\p{Is_Block: hatran}', "");
    Expect(0, 67839, '\p{^Is_Block: hatran}', "");
    Expect(0, 67839, '\P{Is_Block: hatran}', "");
    Expect(1, 67839, '\P{^Is_Block: hatran}', "");
    Expect(0, 67840, '\p{Is_Block: hatran}', "");
    Expect(1, 67840, '\p{^Is_Block: hatran}', "");
    Expect(1, 67840, '\P{Is_Block: hatran}', "");
    Expect(0, 67840, '\P{^Is_Block: hatran}', "");
    Expect(1, 67839, '\p{Is_Block=_Hatran}', "");
    Expect(0, 67839, '\p{^Is_Block=_Hatran}', "");
    Expect(0, 67839, '\P{Is_Block=_Hatran}', "");
    Expect(1, 67839, '\P{^Is_Block=_Hatran}', "");
    Expect(0, 67840, '\p{Is_Block=_Hatran}', "");
    Expect(1, 67840, '\p{^Is_Block=_Hatran}', "");
    Expect(1, 67840, '\P{Is_Block=_Hatran}', "");
    Expect(0, 67840, '\P{^Is_Block=_Hatran}', "");
    Error('\p{Is_Blk=/a/Hatran}');
    Error('\P{Is_Blk=/a/Hatran}');
    Expect(1, 67839, '\p{Is_Blk=hatran}', "");
    Expect(0, 67839, '\p{^Is_Blk=hatran}', "");
    Expect(0, 67839, '\P{Is_Blk=hatran}', "");
    Expect(1, 67839, '\P{^Is_Blk=hatran}', "");
    Expect(0, 67840, '\p{Is_Blk=hatran}', "");
    Expect(1, 67840, '\p{^Is_Blk=hatran}', "");
    Expect(1, 67840, '\P{Is_Blk=hatran}', "");
    Expect(0, 67840, '\P{^Is_Blk=hatran}', "");
    Expect(1, 67839, '\p{Is_Blk=_-HATRAN}', "");
    Expect(0, 67839, '\p{^Is_Blk=_-HATRAN}', "");
    Expect(0, 67839, '\P{Is_Blk=_-HATRAN}', "");
    Expect(1, 67839, '\P{^Is_Blk=_-HATRAN}', "");
    Expect(0, 67840, '\p{Is_Blk=_-HATRAN}', "");
    Expect(1, 67840, '\p{^Is_Blk=_-HATRAN}', "");
    Expect(1, 67840, '\P{Is_Blk=_-HATRAN}', "");
    Expect(0, 67840, '\P{^Is_Blk=_-HATRAN}', "");
    Error('\p{Block=:=_	Hebrew}');
    Error('\P{Block=:=_	Hebrew}');
    Expect(1, 1535, '\p{Block=hebrew}', "");
    Expect(0, 1535, '\p{^Block=hebrew}', "");
    Expect(0, 1535, '\P{Block=hebrew}', "");
    Expect(1, 1535, '\P{^Block=hebrew}', "");
    Expect(0, 1536, '\p{Block=hebrew}', "");
    Expect(1, 1536, '\p{^Block=hebrew}', "");
    Expect(1, 1536, '\P{Block=hebrew}', "");
    Expect(0, 1536, '\P{^Block=hebrew}', "");
    Expect(1, 1535, '\p{Block=--HEBREW}', "");
    Expect(0, 1535, '\p{^Block=--HEBREW}', "");
    Expect(0, 1535, '\P{Block=--HEBREW}', "");
    Expect(1, 1535, '\P{^Block=--HEBREW}', "");
    Expect(0, 1536, '\p{Block=--HEBREW}', "");
    Expect(1, 1536, '\p{^Block=--HEBREW}', "");
    Expect(1, 1536, '\P{Block=--HEBREW}', "");
    Expect(0, 1536, '\P{^Block=--HEBREW}', "");
    Error('\p{Blk=_/a/hebrew}');
    Error('\P{Blk=_/a/hebrew}');
    Expect(1, 1535, '\p{Blk=hebrew}', "");
    Expect(0, 1535, '\p{^Blk=hebrew}', "");
    Expect(0, 1535, '\P{Blk=hebrew}', "");
    Expect(1, 1535, '\P{^Blk=hebrew}', "");
    Expect(0, 1536, '\p{Blk=hebrew}', "");
    Expect(1, 1536, '\p{^Blk=hebrew}', "");
    Expect(1, 1536, '\P{Blk=hebrew}', "");
    Expect(0, 1536, '\P{^Blk=hebrew}', "");
    Expect(1, 1535, '\p{Blk=	_hebrew}', "");
    Expect(0, 1535, '\p{^Blk=	_hebrew}', "");
    Expect(0, 1535, '\P{Blk=	_hebrew}', "");
    Expect(1, 1535, '\P{^Blk=	_hebrew}', "");
    Expect(0, 1536, '\p{Blk=	_hebrew}', "");
    Expect(1, 1536, '\p{^Blk=	_hebrew}', "");
    Expect(1, 1536, '\P{Blk=	_hebrew}', "");
    Expect(0, 1536, '\P{^Blk=	_hebrew}', "");
    Error('\p{Is_Block=-:=Hebrew}');
    Error('\P{Is_Block=-:=Hebrew}');
    Expect(1, 1535, '\p{Is_Block=hebrew}', "");
    Expect(0, 1535, '\p{^Is_Block=hebrew}', "");
    Expect(0, 1535, '\P{Is_Block=hebrew}', "");
    Expect(1, 1535, '\P{^Is_Block=hebrew}', "");
    Expect(0, 1536, '\p{Is_Block=hebrew}', "");
    Expect(1, 1536, '\p{^Is_Block=hebrew}', "");
    Expect(1, 1536, '\P{Is_Block=hebrew}', "");
    Expect(0, 1536, '\P{^Is_Block=hebrew}', "");
    Expect(1, 1535, '\p{Is_Block= Hebrew}', "");
    Expect(0, 1535, '\p{^Is_Block= Hebrew}', "");
    Expect(0, 1535, '\P{Is_Block= Hebrew}', "");
    Expect(1, 1535, '\P{^Is_Block= Hebrew}', "");
    Expect(0, 1536, '\p{Is_Block= Hebrew}', "");
    Expect(1, 1536, '\p{^Is_Block= Hebrew}', "");
    Expect(1, 1536, '\P{Is_Block= Hebrew}', "");
    Expect(0, 1536, '\P{^Is_Block= Hebrew}', "");
    Error('\p{Is_Blk=	/a/HEBREW}');
    Error('\P{Is_Blk=	/a/HEBREW}');
    Expect(1, 1535, '\p{Is_Blk=hebrew}', "");
    Expect(0, 1535, '\p{^Is_Blk=hebrew}', "");
    Expect(0, 1535, '\P{Is_Blk=hebrew}', "");
    Expect(1, 1535, '\P{^Is_Blk=hebrew}', "");
    Expect(0, 1536, '\p{Is_Blk=hebrew}', "");
    Expect(1, 1536, '\p{^Is_Blk=hebrew}', "");
    Expect(1, 1536, '\P{Is_Blk=hebrew}', "");
    Expect(0, 1536, '\P{^Is_Blk=hebrew}', "");
    Expect(1, 1535, '\p{Is_Blk=	hebrew}', "");
    Expect(0, 1535, '\p{^Is_Blk=	hebrew}', "");
    Expect(0, 1535, '\P{Is_Blk=	hebrew}', "");
    Expect(1, 1535, '\P{^Is_Blk=	hebrew}', "");
    Expect(0, 1536, '\p{Is_Blk=	hebrew}', "");
    Expect(1, 1536, '\p{^Is_Blk=	hebrew}', "");
    Expect(1, 1536, '\P{Is_Blk=	hebrew}', "");
    Expect(0, 1536, '\P{^Is_Blk=	hebrew}', "");
    Error('\p{Block=-/a/High_Private_use_surrogates}');
    Error('\P{Block=-/a/High_Private_use_surrogates}');
    Expect(1, 56319, '\p{Block=highprivateusesurrogates}', "");
    Expect(0, 56319, '\p{^Block=highprivateusesurrogates}', "");
    Expect(0, 56319, '\P{Block=highprivateusesurrogates}', "");
    Expect(1, 56319, '\P{^Block=highprivateusesurrogates}', "");
    Expect(0, 57344, '\p{Block=highprivateusesurrogates}', "");
    Expect(1, 57344, '\p{^Block=highprivateusesurrogates}', "");
    Expect(1, 57344, '\P{Block=highprivateusesurrogates}', "");
    Expect(0, 57344, '\P{^Block=highprivateusesurrogates}', "");
    Expect(1, 56319, '\p{Block=  HIGH_Private_Use_Surrogates}', "");
    Expect(0, 56319, '\p{^Block=  HIGH_Private_Use_Surrogates}', "");
    Expect(0, 56319, '\P{Block=  HIGH_Private_Use_Surrogates}', "");
    Expect(1, 56319, '\P{^Block=  HIGH_Private_Use_Surrogates}', "");
    Expect(0, 57344, '\p{Block=  HIGH_Private_Use_Surrogates}', "");
    Expect(1, 57344, '\p{^Block=  HIGH_Private_Use_Surrogates}', "");
    Expect(1, 57344, '\P{Block=  HIGH_Private_Use_Surrogates}', "");
    Expect(0, 57344, '\P{^Block=  HIGH_Private_Use_Surrogates}', "");
    Error('\p{Blk=:=_	High_pu_surrogates}');
    Error('\P{Blk=:=_	High_pu_surrogates}');
    Expect(1, 56319, '\p{Blk=highpusurrogates}', "");
    Expect(0, 56319, '\p{^Blk=highpusurrogates}', "");
    Expect(0, 56319, '\P{Blk=highpusurrogates}', "");
    Expect(1, 56319, '\P{^Blk=highpusurrogates}', "");
    Expect(0, 57344, '\p{Blk=highpusurrogates}', "");
    Expect(1, 57344, '\p{^Blk=highpusurrogates}', "");
    Expect(1, 57344, '\P{Blk=highpusurrogates}', "");
    Expect(0, 57344, '\P{^Blk=highpusurrogates}', "");
    Expect(1, 56319, '\p{Blk=_-High_pu_Surrogates}', "");
    Expect(0, 56319, '\p{^Blk=_-High_pu_Surrogates}', "");
    Expect(0, 56319, '\P{Blk=_-High_pu_Surrogates}', "");
    Expect(1, 56319, '\P{^Blk=_-High_pu_Surrogates}', "");
    Expect(0, 57344, '\p{Blk=_-High_pu_Surrogates}', "");
    Expect(1, 57344, '\p{^Blk=_-High_pu_Surrogates}', "");
    Expect(1, 57344, '\P{Blk=_-High_pu_Surrogates}', "");
    Expect(0, 57344, '\P{^Blk=_-High_pu_Surrogates}', "");
    Error('\p{Is_Block=/a/HIGH_PRIVATE_Use_surrogates}');
    Error('\P{Is_Block=/a/HIGH_PRIVATE_Use_surrogates}');
    Expect(1, 56319, '\p{Is_Block=highprivateusesurrogates}', "");
    Expect(0, 56319, '\p{^Is_Block=highprivateusesurrogates}', "");
    Expect(0, 56319, '\P{Is_Block=highprivateusesurrogates}', "");
    Expect(1, 56319, '\P{^Is_Block=highprivateusesurrogates}', "");
    Expect(0, 57344, '\p{Is_Block=highprivateusesurrogates}', "");
    Expect(1, 57344, '\p{^Is_Block=highprivateusesurrogates}', "");
    Expect(1, 57344, '\P{Is_Block=highprivateusesurrogates}', "");
    Expect(0, 57344, '\P{^Is_Block=highprivateusesurrogates}', "");
    Expect(1, 56319, '\p{Is_Block=_-HIGH_Private_Use_surrogates}', "");
    Expect(0, 56319, '\p{^Is_Block=_-HIGH_Private_Use_surrogates}', "");
    Expect(0, 56319, '\P{Is_Block=_-HIGH_Private_Use_surrogates}', "");
    Expect(1, 56319, '\P{^Is_Block=_-HIGH_Private_Use_surrogates}', "");
    Expect(0, 57344, '\p{Is_Block=_-HIGH_Private_Use_surrogates}', "");
    Expect(1, 57344, '\p{^Is_Block=_-HIGH_Private_Use_surrogates}', "");
    Expect(1, 57344, '\P{Is_Block=_-HIGH_Private_Use_surrogates}', "");
    Expect(0, 57344, '\P{^Is_Block=_-HIGH_Private_Use_surrogates}', "");
    Error('\p{Is_Blk=_/a/High_pu_SURROGATES}');
    Error('\P{Is_Blk=_/a/High_pu_SURROGATES}');
    Expect(1, 56319, '\p{Is_Blk=highpusurrogates}', "");
    Expect(0, 56319, '\p{^Is_Blk=highpusurrogates}', "");
    Expect(0, 56319, '\P{Is_Blk=highpusurrogates}', "");
    Expect(1, 56319, '\P{^Is_Blk=highpusurrogates}', "");
    Expect(0, 57344, '\p{Is_Blk=highpusurrogates}', "");
    Expect(1, 57344, '\p{^Is_Blk=highpusurrogates}', "");
    Expect(1, 57344, '\P{Is_Blk=highpusurrogates}', "");
    Expect(0, 57344, '\P{^Is_Blk=highpusurrogates}', "");
    Expect(1, 56319, '\p{Is_Blk:   -	high_pu_SURROGATES}', "");
    Expect(0, 56319, '\p{^Is_Blk:   -	high_pu_SURROGATES}', "");
    Expect(0, 56319, '\P{Is_Blk:   -	high_pu_SURROGATES}', "");
    Expect(1, 56319, '\P{^Is_Blk:   -	high_pu_SURROGATES}', "");
    Expect(0, 57344, '\p{Is_Blk:   -	high_pu_SURROGATES}', "");
    Expect(1, 57344, '\p{^Is_Blk:   -	high_pu_SURROGATES}', "");
    Expect(1, 57344, '\P{Is_Blk:   -	high_pu_SURROGATES}', "");
    Expect(0, 57344, '\P{^Is_Blk:   -	high_pu_SURROGATES}', "");
    Error('\p{Block= /a/high_Surrogates}');
    Error('\P{Block= /a/high_Surrogates}');
    Expect(1, 56191, '\p{Block: highsurrogates}', "");
    Expect(0, 56191, '\p{^Block: highsurrogates}', "");
    Expect(0, 56191, '\P{Block: highsurrogates}', "");
    Expect(1, 56191, '\P{^Block: highsurrogates}', "");
    Expect(0, 57344, '\p{Block: highsurrogates}', "");
    Expect(1, 57344, '\p{^Block: highsurrogates}', "");
    Expect(1, 57344, '\P{Block: highsurrogates}', "");
    Expect(0, 57344, '\P{^Block: highsurrogates}', "");
    Expect(1, 56191, '\p{Block=High_Surrogates}', "");
    Expect(0, 56191, '\p{^Block=High_Surrogates}', "");
    Expect(0, 56191, '\P{Block=High_Surrogates}', "");
    Expect(1, 56191, '\P{^Block=High_Surrogates}', "");
    Expect(0, 57344, '\p{Block=High_Surrogates}', "");
    Expect(1, 57344, '\p{^Block=High_Surrogates}', "");
    Expect(1, 57344, '\P{Block=High_Surrogates}', "");
    Expect(0, 57344, '\P{^Block=High_Surrogates}', "");
    Error('\p{Blk= HIGH_SURROGATES:=}');
    Error('\P{Blk= HIGH_SURROGATES:=}');
    Expect(1, 56191, '\p{Blk=highsurrogates}', "");
    Expect(0, 56191, '\p{^Blk=highsurrogates}', "");
    Expect(0, 56191, '\P{Blk=highsurrogates}', "");
    Expect(1, 56191, '\P{^Blk=highsurrogates}', "");
    Expect(0, 57344, '\p{Blk=highsurrogates}', "");
    Expect(1, 57344, '\p{^Blk=highsurrogates}', "");
    Expect(1, 57344, '\P{Blk=highsurrogates}', "");
    Expect(0, 57344, '\P{^Blk=highsurrogates}', "");
    Expect(1, 56191, '\p{Blk=-High_surrogates}', "");
    Expect(0, 56191, '\p{^Blk=-High_surrogates}', "");
    Expect(0, 56191, '\P{Blk=-High_surrogates}', "");
    Expect(1, 56191, '\P{^Blk=-High_surrogates}', "");
    Expect(0, 57344, '\p{Blk=-High_surrogates}', "");
    Expect(1, 57344, '\p{^Blk=-High_surrogates}', "");
    Expect(1, 57344, '\P{Blk=-High_surrogates}', "");
    Expect(0, 57344, '\P{^Blk=-High_surrogates}', "");
    Error('\p{Is_Block=/a/-	High_Surrogates}');
    Error('\P{Is_Block=/a/-	High_Surrogates}');
    Expect(1, 56191, '\p{Is_Block=highsurrogates}', "");
    Expect(0, 56191, '\p{^Is_Block=highsurrogates}', "");
    Expect(0, 56191, '\P{Is_Block=highsurrogates}', "");
    Expect(1, 56191, '\P{^Is_Block=highsurrogates}', "");
    Expect(0, 57344, '\p{Is_Block=highsurrogates}', "");
    Expect(1, 57344, '\p{^Is_Block=highsurrogates}', "");
    Expect(1, 57344, '\P{Is_Block=highsurrogates}', "");
    Expect(0, 57344, '\P{^Is_Block=highsurrogates}', "");
    Expect(1, 56191, '\p{Is_Block= High_Surrogates}', "");
    Expect(0, 56191, '\p{^Is_Block= High_Surrogates}', "");
    Expect(0, 56191, '\P{Is_Block= High_Surrogates}', "");
    Expect(1, 56191, '\P{^Is_Block= High_Surrogates}', "");
    Expect(0, 57344, '\p{Is_Block= High_Surrogates}', "");
    Expect(1, 57344, '\p{^Is_Block= High_Surrogates}', "");
    Expect(1, 57344, '\P{Is_Block= High_Surrogates}', "");
    Expect(0, 57344, '\P{^Is_Block= High_Surrogates}', "");
    Error('\p{Is_Blk: 	High_surrogates:=}');
    Error('\P{Is_Blk: 	High_surrogates:=}');
    Expect(1, 56191, '\p{Is_Blk=highsurrogates}', "");
    Expect(0, 56191, '\p{^Is_Blk=highsurrogates}', "");
    Expect(0, 56191, '\P{Is_Blk=highsurrogates}', "");
    Expect(1, 56191, '\P{^Is_Blk=highsurrogates}', "");
    Expect(0, 57344, '\p{Is_Blk=highsurrogates}', "");
    Expect(1, 57344, '\p{^Is_Blk=highsurrogates}', "");
    Expect(1, 57344, '\P{Is_Blk=highsurrogates}', "");
    Expect(0, 57344, '\P{^Is_Blk=highsurrogates}', "");
    Expect(1, 56191, '\p{Is_Blk=-high_Surrogates}', "");
    Expect(0, 56191, '\p{^Is_Blk=-high_Surrogates}', "");
    Expect(0, 56191, '\P{Is_Blk=-high_Surrogates}', "");
    Expect(1, 56191, '\P{^Is_Blk=-high_Surrogates}', "");
    Expect(0, 57344, '\p{Is_Blk=-high_Surrogates}', "");
    Expect(1, 57344, '\p{^Is_Blk=-high_Surrogates}', "");
    Expect(1, 57344, '\P{Is_Blk=-high_Surrogates}', "");
    Expect(0, 57344, '\P{^Is_Blk=-high_Surrogates}', "");
    Error('\p{Block=/a/_HIRAGANA}');
    Error('\P{Block=/a/_HIRAGANA}');
    Expect(1, 12447, '\p{Block=hiragana}', "");
    Expect(0, 12447, '\p{^Block=hiragana}', "");
    Expect(0, 12447, '\P{Block=hiragana}', "");
    Expect(1, 12447, '\P{^Block=hiragana}', "");
    Expect(0, 12448, '\p{Block=hiragana}', "");
    Expect(1, 12448, '\p{^Block=hiragana}', "");
    Expect(1, 12448, '\P{Block=hiragana}', "");
    Expect(0, 12448, '\P{^Block=hiragana}', "");
    Expect(1, 12447, '\p{Block=__Hiragana}', "");
    Expect(0, 12447, '\p{^Block=__Hiragana}', "");
    Expect(0, 12447, '\P{Block=__Hiragana}', "");
    Expect(1, 12447, '\P{^Block=__Hiragana}', "");
    Expect(0, 12448, '\p{Block=__Hiragana}', "");
    Expect(1, 12448, '\p{^Block=__Hiragana}', "");
    Expect(1, 12448, '\P{Block=__Hiragana}', "");
    Expect(0, 12448, '\P{^Block=__Hiragana}', "");
    Error('\p{Blk= Hiragana:=}');
    Error('\P{Blk= Hiragana:=}');
    Expect(1, 12447, '\p{Blk:hiragana}', "");
    Expect(0, 12447, '\p{^Blk:hiragana}', "");
    Expect(0, 12447, '\P{Blk:hiragana}', "");
    Expect(1, 12447, '\P{^Blk:hiragana}', "");
    Expect(0, 12448, '\p{Blk:hiragana}', "");
    Expect(1, 12448, '\p{^Blk:hiragana}', "");
    Expect(1, 12448, '\P{Blk:hiragana}', "");
    Expect(0, 12448, '\P{^Blk:hiragana}', "");
    Expect(1, 12447, '\p{Blk=	HIRAGANA}', "");
    Expect(0, 12447, '\p{^Blk=	HIRAGANA}', "");
    Expect(0, 12447, '\P{Blk=	HIRAGANA}', "");
    Expect(1, 12447, '\P{^Blk=	HIRAGANA}', "");
    Expect(0, 12448, '\p{Blk=	HIRAGANA}', "");
    Expect(1, 12448, '\p{^Blk=	HIRAGANA}', "");
    Expect(1, 12448, '\P{Blk=	HIRAGANA}', "");
    Expect(0, 12448, '\P{^Blk=	HIRAGANA}', "");
    Error('\p{Is_Block=:=	-hiragana}');
    Error('\P{Is_Block=:=	-hiragana}');
    Expect(1, 12447, '\p{Is_Block=hiragana}', "");
    Expect(0, 12447, '\p{^Is_Block=hiragana}', "");
    Expect(0, 12447, '\P{Is_Block=hiragana}', "");
    Expect(1, 12447, '\P{^Is_Block=hiragana}', "");
    Expect(0, 12448, '\p{Is_Block=hiragana}', "");
    Expect(1, 12448, '\p{^Is_Block=hiragana}', "");
    Expect(1, 12448, '\P{Is_Block=hiragana}', "");
    Expect(0, 12448, '\P{^Is_Block=hiragana}', "");
    Expect(1, 12447, '\p{Is_Block=	-Hiragana}', "");
    Expect(0, 12447, '\p{^Is_Block=	-Hiragana}', "");
    Expect(0, 12447, '\P{Is_Block=	-Hiragana}', "");
    Expect(1, 12447, '\P{^Is_Block=	-Hiragana}', "");
    Expect(0, 12448, '\p{Is_Block=	-Hiragana}', "");
    Expect(1, 12448, '\p{^Is_Block=	-Hiragana}', "");
    Expect(1, 12448, '\P{Is_Block=	-Hiragana}', "");
    Expect(0, 12448, '\P{^Is_Block=	-Hiragana}', "");
    Error('\p{Is_Blk=--HIRAGANA:=}');
    Error('\P{Is_Blk=--HIRAGANA:=}');
    Expect(1, 12447, '\p{Is_Blk=hiragana}', "");
    Expect(0, 12447, '\p{^Is_Blk=hiragana}', "");
    Expect(0, 12447, '\P{Is_Blk=hiragana}', "");
    Expect(1, 12447, '\P{^Is_Blk=hiragana}', "");
    Expect(0, 12448, '\p{Is_Blk=hiragana}', "");
    Expect(1, 12448, '\p{^Is_Blk=hiragana}', "");
    Expect(1, 12448, '\P{Is_Blk=hiragana}', "");
    Expect(0, 12448, '\P{^Is_Blk=hiragana}', "");
    Expect(1, 12447, '\p{Is_Blk= hiragana}', "");
    Expect(0, 12447, '\p{^Is_Blk= hiragana}', "");
    Expect(0, 12447, '\P{Is_Blk= hiragana}', "");
    Expect(1, 12447, '\P{^Is_Blk= hiragana}', "");
    Expect(0, 12448, '\p{Is_Blk= hiragana}', "");
    Expect(1, 12448, '\p{^Is_Blk= hiragana}', "");
    Expect(1, 12448, '\P{Is_Blk= hiragana}', "");
    Expect(0, 12448, '\P{^Is_Blk= hiragana}', "");
    Error('\p{Block=_Ideographic_Description_characters/a/}');
    Error('\P{Block=_Ideographic_Description_characters/a/}');
    Expect(1, 12287, '\p{Block=ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\p{^Block=ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\P{Block=ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\P{^Block=ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\p{Block=ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\p{^Block=ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\P{Block=ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\P{^Block=ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\p{Block=	 IDEOGRAPHIC_Description_characters}', "");
    Expect(0, 12287, '\p{^Block=	 IDEOGRAPHIC_Description_characters}', "");
    Expect(0, 12287, '\P{Block=	 IDEOGRAPHIC_Description_characters}', "");
    Expect(1, 12287, '\P{^Block=	 IDEOGRAPHIC_Description_characters}', "");
    Expect(0, 12288, '\p{Block=	 IDEOGRAPHIC_Description_characters}', "");
    Expect(1, 12288, '\p{^Block=	 IDEOGRAPHIC_Description_characters}', "");
    Expect(1, 12288, '\P{Block=	 IDEOGRAPHIC_Description_characters}', "");
    Expect(0, 12288, '\P{^Block=	 IDEOGRAPHIC_Description_characters}', "");
    Error('\p{Blk:	:= 	IDC}');
    Error('\P{Blk:	:= 	IDC}');
    Expect(1, 12287, '\p{Blk=idc}', "");
    Expect(0, 12287, '\p{^Blk=idc}', "");
    Expect(0, 12287, '\P{Blk=idc}', "");
    Expect(1, 12287, '\P{^Blk=idc}', "");
    Expect(0, 12288, '\p{Blk=idc}', "");
    Expect(1, 12288, '\p{^Blk=idc}', "");
    Expect(1, 12288, '\P{Blk=idc}', "");
    Expect(0, 12288, '\P{^Blk=idc}', "");
    Expect(1, 12287, '\p{Blk=_idc}', "");
    Expect(0, 12287, '\p{^Blk=_idc}', "");
    Expect(0, 12287, '\P{Blk=_idc}', "");
    Expect(1, 12287, '\P{^Blk=_idc}', "");
    Expect(0, 12288, '\p{Blk=_idc}', "");
    Expect(1, 12288, '\p{^Blk=_idc}', "");
    Expect(1, 12288, '\P{Blk=_idc}', "");
    Expect(0, 12288, '\P{^Blk=_idc}', "");
    Error('\p{Is_Block=--Ideographic_description_Characters:=}');
    Error('\P{Is_Block=--Ideographic_description_Characters:=}');
    Expect(1, 12287, '\p{Is_Block: ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\p{^Is_Block: ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\P{Is_Block: ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\P{^Is_Block: ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\p{Is_Block: ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\p{^Is_Block: ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\P{Is_Block: ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\P{^Is_Block: ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\p{Is_Block=  ideographic_Description_CHARACTERS}', "");
    Expect(0, 12287, '\p{^Is_Block=  ideographic_Description_CHARACTERS}', "");
    Expect(0, 12287, '\P{Is_Block=  ideographic_Description_CHARACTERS}', "");
    Expect(1, 12287, '\P{^Is_Block=  ideographic_Description_CHARACTERS}', "");
    Expect(0, 12288, '\p{Is_Block=  ideographic_Description_CHARACTERS}', "");
    Expect(1, 12288, '\p{^Is_Block=  ideographic_Description_CHARACTERS}', "");
    Expect(1, 12288, '\P{Is_Block=  ideographic_Description_CHARACTERS}', "");
    Expect(0, 12288, '\P{^Is_Block=  ideographic_Description_CHARACTERS}', "");
    Error('\p{Is_Blk=_IDC:=}');
    Error('\P{Is_Blk=_IDC:=}');
    Expect(1, 12287, '\p{Is_Blk=idc}', "");
    Expect(0, 12287, '\p{^Is_Blk=idc}', "");
    Expect(0, 12287, '\P{Is_Blk=idc}', "");
    Expect(1, 12287, '\P{^Is_Blk=idc}', "");
    Expect(0, 12288, '\p{Is_Blk=idc}', "");
    Expect(1, 12288, '\p{^Is_Blk=idc}', "");
    Expect(1, 12288, '\P{Is_Blk=idc}', "");
    Expect(0, 12288, '\P{^Is_Blk=idc}', "");
    Expect(1, 12287, '\p{Is_Blk=_IDC}', "");
    Expect(0, 12287, '\p{^Is_Blk=_IDC}', "");
    Expect(0, 12287, '\P{Is_Blk=_IDC}', "");
    Expect(1, 12287, '\P{^Is_Blk=_IDC}', "");
    Expect(0, 12288, '\p{Is_Blk=_IDC}', "");
    Expect(1, 12288, '\p{^Is_Blk=_IDC}', "");
    Expect(1, 12288, '\P{Is_Blk=_IDC}', "");
    Expect(0, 12288, '\P{^Is_Blk=_IDC}', "");
    Error('\p{Block=-/a/ideographic_Symbols_and_Punctuation}');
    Error('\P{Block=-/a/ideographic_Symbols_and_Punctuation}');
    Expect(1, 94207, '\p{Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\p{^Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\P{Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\P{^Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\p{Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\p{^Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\P{Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\P{^Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\p{Block=  Ideographic_SYMBOLS_And_PUNCTUATION}', "");
    Expect(0, 94207, '\p{^Block=  Ideographic_SYMBOLS_And_PUNCTUATION}', "");
    Expect(0, 94207, '\P{Block=  Ideographic_SYMBOLS_And_PUNCTUATION}', "");
    Expect(1, 94207, '\P{^Block=  Ideographic_SYMBOLS_And_PUNCTUATION}', "");
    Expect(0, 94208, '\p{Block=  Ideographic_SYMBOLS_And_PUNCTUATION}', "");
    Expect(1, 94208, '\p{^Block=  Ideographic_SYMBOLS_And_PUNCTUATION}', "");
    Expect(1, 94208, '\P{Block=  Ideographic_SYMBOLS_And_PUNCTUATION}', "");
    Expect(0, 94208, '\P{^Block=  Ideographic_SYMBOLS_And_PUNCTUATION}', "");
    Error('\p{Blk= -ideographic_SYMBOLS:=}');
    Error('\P{Blk= -ideographic_SYMBOLS:=}');
    Expect(1, 94207, '\p{Blk=ideographicsymbols}', "");
    Expect(0, 94207, '\p{^Blk=ideographicsymbols}', "");
    Expect(0, 94207, '\P{Blk=ideographicsymbols}', "");
    Expect(1, 94207, '\P{^Blk=ideographicsymbols}', "");
    Expect(0, 94208, '\p{Blk=ideographicsymbols}', "");
    Expect(1, 94208, '\p{^Blk=ideographicsymbols}', "");
    Expect(1, 94208, '\P{Blk=ideographicsymbols}', "");
    Expect(0, 94208, '\P{^Blk=ideographicsymbols}', "");
    Expect(1, 94207, '\p{Blk=	-IDEOGRAPHIC_symbols}', "");
    Expect(0, 94207, '\p{^Blk=	-IDEOGRAPHIC_symbols}', "");
    Expect(0, 94207, '\P{Blk=	-IDEOGRAPHIC_symbols}', "");
    Expect(1, 94207, '\P{^Blk=	-IDEOGRAPHIC_symbols}', "");
    Expect(0, 94208, '\p{Blk=	-IDEOGRAPHIC_symbols}', "");
    Expect(1, 94208, '\p{^Blk=	-IDEOGRAPHIC_symbols}', "");
    Expect(1, 94208, '\P{Blk=	-IDEOGRAPHIC_symbols}', "");
    Expect(0, 94208, '\P{^Blk=	-IDEOGRAPHIC_symbols}', "");
    Error('\p{Is_Block=:=_ Ideographic_Symbols_AND_Punctuation}');
    Error('\P{Is_Block=:=_ Ideographic_Symbols_AND_Punctuation}');
    Expect(1, 94207, '\p{Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\p{^Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\P{Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\P{^Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\p{Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\p{^Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\P{Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\P{^Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\p{Is_Block:	_IDEOGRAPHIC_Symbols_And_Punctuation}', "");
    Expect(0, 94207, '\p{^Is_Block:	_IDEOGRAPHIC_Symbols_And_Punctuation}', "");
    Expect(0, 94207, '\P{Is_Block:	_IDEOGRAPHIC_Symbols_And_Punctuation}', "");
    Expect(1, 94207, '\P{^Is_Block:	_IDEOGRAPHIC_Symbols_And_Punctuation}', "");
    Expect(0, 94208, '\p{Is_Block:	_IDEOGRAPHIC_Symbols_And_Punctuation}', "");
    Expect(1, 94208, '\p{^Is_Block:	_IDEOGRAPHIC_Symbols_And_Punctuation}', "");
    Expect(1, 94208, '\P{Is_Block:	_IDEOGRAPHIC_Symbols_And_Punctuation}', "");
    Expect(0, 94208, '\P{^Is_Block:	_IDEOGRAPHIC_Symbols_And_Punctuation}', "");
    Error('\p{Is_Blk=:=-Ideographic_Symbols}');
    Error('\P{Is_Blk=:=-Ideographic_Symbols}');
    Expect(1, 94207, '\p{Is_Blk=ideographicsymbols}', "");
    Expect(0, 94207, '\p{^Is_Blk=ideographicsymbols}', "");
    Expect(0, 94207, '\P{Is_Blk=ideographicsymbols}', "");
    Expect(1, 94207, '\P{^Is_Blk=ideographicsymbols}', "");
    Expect(0, 94208, '\p{Is_Blk=ideographicsymbols}', "");
    Expect(1, 94208, '\p{^Is_Blk=ideographicsymbols}', "");
    Expect(1, 94208, '\P{Is_Blk=ideographicsymbols}', "");
    Expect(0, 94208, '\P{^Is_Blk=ideographicsymbols}', "");
    Expect(1, 94207, '\p{Is_Blk= -IDEOGRAPHIC_Symbols}', "");
    Expect(0, 94207, '\p{^Is_Blk= -IDEOGRAPHIC_Symbols}', "");
    Expect(0, 94207, '\P{Is_Blk= -IDEOGRAPHIC_Symbols}', "");
    Expect(1, 94207, '\P{^Is_Blk= -IDEOGRAPHIC_Symbols}', "");
    Expect(0, 94208, '\p{Is_Blk= -IDEOGRAPHIC_Symbols}', "");
    Expect(1, 94208, '\p{^Is_Blk= -IDEOGRAPHIC_Symbols}', "");
    Expect(1, 94208, '\P{Is_Blk= -IDEOGRAPHIC_Symbols}', "");
    Expect(0, 94208, '\P{^Is_Blk= -IDEOGRAPHIC_Symbols}', "");
    Error('\p{Block=	-imperial_ARAMAIC/a/}');
    Error('\P{Block=	-imperial_ARAMAIC/a/}');
    Expect(1, 67679, '\p{Block=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Block=imperialaramaic}', "");
    Expect(0, 67679, '\P{Block=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Block=imperialaramaic}', "");
    Expect(0, 67680, '\p{Block=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Block=imperialaramaic}', "");
    Expect(1, 67680, '\P{Block=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Block=imperialaramaic}', "");
    Expect(1, 67679, '\p{Block=_	Imperial_aramaic}', "");
    Expect(0, 67679, '\p{^Block=_	Imperial_aramaic}', "");
    Expect(0, 67679, '\P{Block=_	Imperial_aramaic}', "");
    Expect(1, 67679, '\P{^Block=_	Imperial_aramaic}', "");
    Expect(0, 67680, '\p{Block=_	Imperial_aramaic}', "");
    Expect(1, 67680, '\p{^Block=_	Imperial_aramaic}', "");
    Expect(1, 67680, '\P{Block=_	Imperial_aramaic}', "");
    Expect(0, 67680, '\P{^Block=_	Imperial_aramaic}', "");
    Error('\p{Blk= /a/imperial_aramaic}');
    Error('\P{Blk= /a/imperial_aramaic}');
    Expect(1, 67679, '\p{Blk=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Blk=imperialaramaic}', "");
    Expect(0, 67679, '\P{Blk=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Blk=imperialaramaic}', "");
    Expect(0, 67680, '\p{Blk=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Blk=imperialaramaic}', "");
    Expect(1, 67680, '\P{Blk=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Blk=imperialaramaic}', "");
    Expect(1, 67679, '\p{Blk= IMPERIAL_aramaic}', "");
    Expect(0, 67679, '\p{^Blk= IMPERIAL_aramaic}', "");
    Expect(0, 67679, '\P{Blk= IMPERIAL_aramaic}', "");
    Expect(1, 67679, '\P{^Blk= IMPERIAL_aramaic}', "");
    Expect(0, 67680, '\p{Blk= IMPERIAL_aramaic}', "");
    Expect(1, 67680, '\p{^Blk= IMPERIAL_aramaic}', "");
    Expect(1, 67680, '\P{Blk= IMPERIAL_aramaic}', "");
    Expect(0, 67680, '\P{^Blk= IMPERIAL_aramaic}', "");
    Error('\p{Is_Block=-	Imperial_ARAMAIC/a/}');
    Error('\P{Is_Block=-	Imperial_ARAMAIC/a/}');
    Expect(1, 67679, '\p{Is_Block: imperialaramaic}', "");
    Expect(0, 67679, '\p{^Is_Block: imperialaramaic}', "");
    Expect(0, 67679, '\P{Is_Block: imperialaramaic}', "");
    Expect(1, 67679, '\P{^Is_Block: imperialaramaic}', "");
    Expect(0, 67680, '\p{Is_Block: imperialaramaic}', "");
    Expect(1, 67680, '\p{^Is_Block: imperialaramaic}', "");
    Expect(1, 67680, '\P{Is_Block: imperialaramaic}', "");
    Expect(0, 67680, '\P{^Is_Block: imperialaramaic}', "");
    Expect(1, 67679, '\p{Is_Block=_ Imperial_Aramaic}', "");
    Expect(0, 67679, '\p{^Is_Block=_ Imperial_Aramaic}', "");
    Expect(0, 67679, '\P{Is_Block=_ Imperial_Aramaic}', "");
    Expect(1, 67679, '\P{^Is_Block=_ Imperial_Aramaic}', "");
    Expect(0, 67680, '\p{Is_Block=_ Imperial_Aramaic}', "");
    Expect(1, 67680, '\p{^Is_Block=_ Imperial_Aramaic}', "");
    Expect(1, 67680, '\P{Is_Block=_ Imperial_Aramaic}', "");
    Expect(0, 67680, '\P{^Is_Block=_ Imperial_Aramaic}', "");
    Error('\p{Is_Blk=-/a/Imperial_Aramaic}');
    Error('\P{Is_Blk=-/a/Imperial_Aramaic}');
    Expect(1, 67679, '\p{Is_Blk=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Is_Blk=imperialaramaic}', "");
    Expect(0, 67679, '\P{Is_Blk=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Is_Blk=imperialaramaic}', "");
    Expect(0, 67680, '\p{Is_Blk=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Is_Blk=imperialaramaic}', "");
    Expect(1, 67680, '\P{Is_Blk=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Is_Blk=imperialaramaic}', "");
    Expect(1, 67679, '\p{Is_Blk=_Imperial_ARAMAIC}', "");
    Expect(0, 67679, '\p{^Is_Blk=_Imperial_ARAMAIC}', "");
    Expect(0, 67679, '\P{Is_Blk=_Imperial_ARAMAIC}', "");
    Expect(1, 67679, '\P{^Is_Blk=_Imperial_ARAMAIC}', "");
    Expect(0, 67680, '\p{Is_Blk=_Imperial_ARAMAIC}', "");
    Expect(1, 67680, '\p{^Is_Blk=_Imperial_ARAMAIC}', "");
    Expect(1, 67680, '\P{Is_Blk=_Imperial_ARAMAIC}', "");
    Expect(0, 67680, '\P{^Is_Blk=_Imperial_ARAMAIC}', "");
    Error('\p{Block=-/a/common_Indic_number_forms}');
    Error('\P{Block=-/a/common_Indic_number_forms}');
    Expect(1, 43071, '\p{Block=commonindicnumberforms}', "");
    Expect(0, 43071, '\p{^Block=commonindicnumberforms}', "");
    Expect(0, 43071, '\P{Block=commonindicnumberforms}', "");
    Expect(1, 43071, '\P{^Block=commonindicnumberforms}', "");
    Expect(0, 43072, '\p{Block=commonindicnumberforms}', "");
    Expect(1, 43072, '\p{^Block=commonindicnumberforms}', "");
    Expect(1, 43072, '\P{Block=commonindicnumberforms}', "");
    Expect(0, 43072, '\P{^Block=commonindicnumberforms}', "");
    Expect(1, 43071, '\p{Block=__common_Indic_Number_Forms}', "");
    Expect(0, 43071, '\p{^Block=__common_Indic_Number_Forms}', "");
    Expect(0, 43071, '\P{Block=__common_Indic_Number_Forms}', "");
    Expect(1, 43071, '\P{^Block=__common_Indic_Number_Forms}', "");
    Expect(0, 43072, '\p{Block=__common_Indic_Number_Forms}', "");
    Expect(1, 43072, '\p{^Block=__common_Indic_Number_Forms}', "");
    Expect(1, 43072, '\P{Block=__common_Indic_Number_Forms}', "");
    Expect(0, 43072, '\P{^Block=__common_Indic_Number_Forms}', "");
    Error('\p{Blk=	:=Indic_Number_Forms}');
    Error('\P{Blk=	:=Indic_Number_Forms}');
    Expect(1, 43071, '\p{Blk=indicnumberforms}', "");
    Expect(0, 43071, '\p{^Blk=indicnumberforms}', "");
    Expect(0, 43071, '\P{Blk=indicnumberforms}', "");
    Expect(1, 43071, '\P{^Blk=indicnumberforms}', "");
    Expect(0, 43072, '\p{Blk=indicnumberforms}', "");
    Expect(1, 43072, '\p{^Blk=indicnumberforms}', "");
    Expect(1, 43072, '\P{Blk=indicnumberforms}', "");
    Expect(0, 43072, '\P{^Blk=indicnumberforms}', "");
    Expect(1, 43071, '\p{Blk=__INDIC_Number_Forms}', "");
    Expect(0, 43071, '\p{^Blk=__INDIC_Number_Forms}', "");
    Expect(0, 43071, '\P{Blk=__INDIC_Number_Forms}', "");
    Expect(1, 43071, '\P{^Blk=__INDIC_Number_Forms}', "");
    Expect(0, 43072, '\p{Blk=__INDIC_Number_Forms}', "");
    Expect(1, 43072, '\p{^Blk=__INDIC_Number_Forms}', "");
    Expect(1, 43072, '\P{Blk=__INDIC_Number_Forms}', "");
    Expect(0, 43072, '\P{^Blk=__INDIC_Number_Forms}', "");
    Error('\p{Is_Block=/a/_ Common_Indic_NUMBER_Forms}');
    Error('\P{Is_Block=/a/_ Common_Indic_NUMBER_Forms}');
    Expect(1, 43071, '\p{Is_Block: commonindicnumberforms}', "");
    Expect(0, 43071, '\p{^Is_Block: commonindicnumberforms}', "");
    Expect(0, 43071, '\P{Is_Block: commonindicnumberforms}', "");
    Expect(1, 43071, '\P{^Is_Block: commonindicnumberforms}', "");
    Expect(0, 43072, '\p{Is_Block: commonindicnumberforms}', "");
    Expect(1, 43072, '\p{^Is_Block: commonindicnumberforms}', "");
    Expect(1, 43072, '\P{Is_Block: commonindicnumberforms}', "");
    Expect(0, 43072, '\P{^Is_Block: commonindicnumberforms}', "");
    Expect(1, 43071, '\p{Is_Block=_Common_INDIC_Number_Forms}', "");
    Expect(0, 43071, '\p{^Is_Block=_Common_INDIC_Number_Forms}', "");
    Expect(0, 43071, '\P{Is_Block=_Common_INDIC_Number_Forms}', "");
    Expect(1, 43071, '\P{^Is_Block=_Common_INDIC_Number_Forms}', "");
    Expect(0, 43072, '\p{Is_Block=_Common_INDIC_Number_Forms}', "");
    Expect(1, 43072, '\p{^Is_Block=_Common_INDIC_Number_Forms}', "");
    Expect(1, 43072, '\P{Is_Block=_Common_INDIC_Number_Forms}', "");
    Expect(0, 43072, '\P{^Is_Block=_Common_INDIC_Number_Forms}', "");
    Error('\p{Is_Blk=- indic_number_Forms:=}');
    Error('\P{Is_Blk=- indic_number_Forms:=}');
    Expect(1, 43071, '\p{Is_Blk=indicnumberforms}', "");
    Expect(0, 43071, '\p{^Is_Blk=indicnumberforms}', "");
    Expect(0, 43071, '\P{Is_Blk=indicnumberforms}', "");
    Expect(1, 43071, '\P{^Is_Blk=indicnumberforms}', "");
    Expect(0, 43072, '\p{Is_Blk=indicnumberforms}', "");
    Expect(1, 43072, '\p{^Is_Blk=indicnumberforms}', "");
    Expect(1, 43072, '\P{Is_Blk=indicnumberforms}', "");
    Expect(0, 43072, '\P{^Is_Blk=indicnumberforms}', "");
    Expect(1, 43071, '\p{Is_Blk=_INDIC_number_forms}', "");
    Expect(0, 43071, '\p{^Is_Blk=_INDIC_number_forms}', "");
    Expect(0, 43071, '\P{Is_Blk=_INDIC_number_forms}', "");
    Expect(1, 43071, '\P{^Is_Blk=_INDIC_number_forms}', "");
    Expect(0, 43072, '\p{Is_Blk=_INDIC_number_forms}', "");
    Expect(1, 43072, '\p{^Is_Blk=_INDIC_number_forms}', "");
    Expect(1, 43072, '\P{Is_Blk=_INDIC_number_forms}', "");
    Expect(0, 43072, '\P{^Is_Blk=_INDIC_number_forms}', "");
    Error('\p{Block= /a/INSCRIPTIONAL_Pahlavi}');
    Error('\P{Block= /a/INSCRIPTIONAL_Pahlavi}');
    Expect(1, 68479, '\p{Block=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Block=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Block=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Block=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Block=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Block=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Block=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Block=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Block=-inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\p{^Block=-inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\P{Block=-inscriptional_Pahlavi}', "");
    Expect(1, 68479, '\P{^Block=-inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\p{Block=-inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\p{^Block=-inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\P{Block=-inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\P{^Block=-inscriptional_Pahlavi}', "");
    Error('\p{Blk=/a/	inscriptional_pahlavi}');
    Error('\P{Blk=/a/	inscriptional_pahlavi}');
    Expect(1, 68479, '\p{Blk=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Blk=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Blk=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Blk=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Blk=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Blk=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Blk=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Blk=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Blk=  INSCRIPTIONAL_PAHLAVI}', "");
    Expect(0, 68479, '\p{^Blk=  INSCRIPTIONAL_PAHLAVI}', "");
    Expect(0, 68479, '\P{Blk=  INSCRIPTIONAL_PAHLAVI}', "");
    Expect(1, 68479, '\P{^Blk=  INSCRIPTIONAL_PAHLAVI}', "");
    Expect(0, 68480, '\p{Blk=  INSCRIPTIONAL_PAHLAVI}', "");
    Expect(1, 68480, '\p{^Blk=  INSCRIPTIONAL_PAHLAVI}', "");
    Expect(1, 68480, '\P{Blk=  INSCRIPTIONAL_PAHLAVI}', "");
    Expect(0, 68480, '\P{^Blk=  INSCRIPTIONAL_PAHLAVI}', "");
    Error('\p{Is_Block=:=-_INSCRIPTIONAL_PAHLAVI}');
    Error('\P{Is_Block=:=-_INSCRIPTIONAL_PAHLAVI}');
    Expect(1, 68479, '\p{Is_Block:inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Is_Block:inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Is_Block:inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Is_Block:inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Is_Block:inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Is_Block:inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Is_Block:inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Is_Block:inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Is_Block=_inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\p{^Is_Block=_inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\P{Is_Block=_inscriptional_Pahlavi}', "");
    Expect(1, 68479, '\P{^Is_Block=_inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\p{Is_Block=_inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\p{^Is_Block=_inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\P{Is_Block=_inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\P{^Is_Block=_inscriptional_Pahlavi}', "");
    Error('\p{Is_Blk=:=_-inscriptional_Pahlavi}');
    Error('\P{Is_Blk=:=_-inscriptional_Pahlavi}');
    Expect(1, 68479, '\p{Is_Blk=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Is_Blk=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Is_Blk=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Is_Blk=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Is_Blk=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Is_Blk=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Is_Blk=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Is_Blk=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Is_Blk:  	Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\p{^Is_Blk:  	Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\P{Is_Blk:  	Inscriptional_Pahlavi}', "");
    Expect(1, 68479, '\P{^Is_Blk:  	Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\p{Is_Blk:  	Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\p{^Is_Blk:  	Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\P{Is_Blk:  	Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\P{^Is_Blk:  	Inscriptional_Pahlavi}', "");
    Error('\p{Block=/a/Inscriptional_parthian}');
    Error('\P{Block=/a/Inscriptional_parthian}');
    Expect(1, 68447, '\p{Block=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Block=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Block=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Block=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Block=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Block=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Block=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Block=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Block:	-Inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\p{^Block:	-Inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\P{Block:	-Inscriptional_PARTHIAN}', "");
    Expect(1, 68447, '\P{^Block:	-Inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\p{Block:	-Inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\p{^Block:	-Inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\P{Block:	-Inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\P{^Block:	-Inscriptional_PARTHIAN}', "");
    Error('\p{Blk=_:=inscriptional_parthian}');
    Error('\P{Blk=_:=inscriptional_parthian}');
    Expect(1, 68447, '\p{Blk: inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Blk: inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Blk: inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Blk: inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Blk: inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Blk: inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Blk: inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Blk: inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Blk=	_Inscriptional_Parthian}', "");
    Expect(0, 68447, '\p{^Blk=	_Inscriptional_Parthian}', "");
    Expect(0, 68447, '\P{Blk=	_Inscriptional_Parthian}', "");
    Expect(1, 68447, '\P{^Blk=	_Inscriptional_Parthian}', "");
    Expect(0, 68448, '\p{Blk=	_Inscriptional_Parthian}', "");
    Expect(1, 68448, '\p{^Blk=	_Inscriptional_Parthian}', "");
    Expect(1, 68448, '\P{Blk=	_Inscriptional_Parthian}', "");
    Expect(0, 68448, '\P{^Blk=	_Inscriptional_Parthian}', "");
    Error('\p{Is_Block= :=Inscriptional_Parthian}');
    Error('\P{Is_Block= :=Inscriptional_Parthian}');
    Expect(1, 68447, '\p{Is_Block=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Is_Block=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Is_Block=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Is_Block=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Is_Block=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Is_Block=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Is_Block=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Is_Block=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Is_Block:  -Inscriptional_Parthian}', "");
    Expect(0, 68447, '\p{^Is_Block:  -Inscriptional_Parthian}', "");
    Expect(0, 68447, '\P{Is_Block:  -Inscriptional_Parthian}', "");
    Expect(1, 68447, '\P{^Is_Block:  -Inscriptional_Parthian}', "");
    Expect(0, 68448, '\p{Is_Block:  -Inscriptional_Parthian}', "");
    Expect(1, 68448, '\p{^Is_Block:  -Inscriptional_Parthian}', "");
    Expect(1, 68448, '\P{Is_Block:  -Inscriptional_Parthian}', "");
    Expect(0, 68448, '\P{^Is_Block:  -Inscriptional_Parthian}', "");
    Error('\p{Is_Blk=:=-_INSCRIPTIONAL_PARTHIAN}');
    Error('\P{Is_Blk=:=-_INSCRIPTIONAL_PARTHIAN}');
    Expect(1, 68447, '\p{Is_Blk=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Is_Blk=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Is_Blk=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Is_Blk=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Is_Blk=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Is_Blk=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Is_Blk=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Is_Blk=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Is_Blk=	-Inscriptional_parthian}', "");
    Expect(0, 68447, '\p{^Is_Blk=	-Inscriptional_parthian}', "");
    Expect(0, 68447, '\P{Is_Blk=	-Inscriptional_parthian}', "");
    Expect(1, 68447, '\P{^Is_Blk=	-Inscriptional_parthian}', "");
    Expect(0, 68448, '\p{Is_Blk=	-Inscriptional_parthian}', "");
    Expect(1, 68448, '\p{^Is_Blk=	-Inscriptional_parthian}', "");
    Expect(1, 68448, '\P{Is_Blk=	-Inscriptional_parthian}', "");
    Expect(0, 68448, '\P{^Is_Blk=	-Inscriptional_parthian}', "");
    Error('\p{Block:	 :=IPA_Extensions}');
    Error('\P{Block:	 :=IPA_Extensions}');
    Expect(1, 687, '\p{Block=ipaextensions}', "");
    Expect(0, 687, '\p{^Block=ipaextensions}', "");
    Expect(0, 687, '\P{Block=ipaextensions}', "");
    Expect(1, 687, '\P{^Block=ipaextensions}', "");
    Expect(0, 688, '\p{Block=ipaextensions}', "");
    Expect(1, 688, '\p{^Block=ipaextensions}', "");
    Expect(1, 688, '\P{Block=ipaextensions}', "");
    Expect(0, 688, '\P{^Block=ipaextensions}', "");
    Expect(1, 687, '\p{Block=--ipa_Extensions}', "");
    Expect(0, 687, '\p{^Block=--ipa_Extensions}', "");
    Expect(0, 687, '\P{Block=--ipa_Extensions}', "");
    Expect(1, 687, '\P{^Block=--ipa_Extensions}', "");
    Expect(0, 688, '\p{Block=--ipa_Extensions}', "");
    Expect(1, 688, '\p{^Block=--ipa_Extensions}', "");
    Expect(1, 688, '\P{Block=--ipa_Extensions}', "");
    Expect(0, 688, '\P{^Block=--ipa_Extensions}', "");
    Error('\p{Blk=:=- IPA_EXT}');
    Error('\P{Blk=:=- IPA_EXT}');
    Expect(1, 687, '\p{Blk=ipaext}', "");
    Expect(0, 687, '\p{^Blk=ipaext}', "");
    Expect(0, 687, '\P{Blk=ipaext}', "");
    Expect(1, 687, '\P{^Blk=ipaext}', "");
    Expect(0, 688, '\p{Blk=ipaext}', "");
    Expect(1, 688, '\p{^Blk=ipaext}', "");
    Expect(1, 688, '\P{Blk=ipaext}', "");
    Expect(0, 688, '\P{^Blk=ipaext}', "");
    Expect(1, 687, '\p{Blk=_-IPA_Ext}', "");
    Expect(0, 687, '\p{^Blk=_-IPA_Ext}', "");
    Expect(0, 687, '\P{Blk=_-IPA_Ext}', "");
    Expect(1, 687, '\P{^Blk=_-IPA_Ext}', "");
    Expect(0, 688, '\p{Blk=_-IPA_Ext}', "");
    Expect(1, 688, '\p{^Blk=_-IPA_Ext}', "");
    Expect(1, 688, '\P{Blk=_-IPA_Ext}', "");
    Expect(0, 688, '\P{^Blk=_-IPA_Ext}', "");
    Error('\p{Is_Block=/a/ -IPA_extensions}');
    Error('\P{Is_Block=/a/ -IPA_extensions}');
    Expect(1, 687, '\p{Is_Block=ipaextensions}', "");
    Expect(0, 687, '\p{^Is_Block=ipaextensions}', "");
    Expect(0, 687, '\P{Is_Block=ipaextensions}', "");
    Expect(1, 687, '\P{^Is_Block=ipaextensions}', "");
    Expect(0, 688, '\p{Is_Block=ipaextensions}', "");
    Expect(1, 688, '\p{^Is_Block=ipaextensions}', "");
    Expect(1, 688, '\P{Is_Block=ipaextensions}', "");
    Expect(0, 688, '\P{^Is_Block=ipaextensions}', "");
    Expect(1, 687, '\p{Is_Block=-ipa_EXTENSIONS}', "");
    Expect(0, 687, '\p{^Is_Block=-ipa_EXTENSIONS}', "");
    Expect(0, 687, '\P{Is_Block=-ipa_EXTENSIONS}', "");
    Expect(1, 687, '\P{^Is_Block=-ipa_EXTENSIONS}', "");
    Expect(0, 688, '\p{Is_Block=-ipa_EXTENSIONS}', "");
    Expect(1, 688, '\p{^Is_Block=-ipa_EXTENSIONS}', "");
    Expect(1, 688, '\P{Is_Block=-ipa_EXTENSIONS}', "");
    Expect(0, 688, '\P{^Is_Block=-ipa_EXTENSIONS}', "");
    Error('\p{Is_Blk=:=	IPA_ext}');
    Error('\P{Is_Blk=:=	IPA_ext}');
    Expect(1, 687, '\p{Is_Blk:   ipaext}', "");
    Expect(0, 687, '\p{^Is_Blk:   ipaext}', "");
    Expect(0, 687, '\P{Is_Blk:   ipaext}', "");
    Expect(1, 687, '\P{^Is_Blk:   ipaext}', "");
    Expect(0, 688, '\p{Is_Blk:   ipaext}', "");
    Expect(1, 688, '\p{^Is_Blk:   ipaext}', "");
    Expect(1, 688, '\P{Is_Blk:   ipaext}', "");
    Expect(0, 688, '\P{^Is_Blk:   ipaext}', "");
    Expect(1, 687, '\p{Is_Blk=_	ipa_ext}', "");
    Expect(0, 687, '\p{^Is_Blk=_	ipa_ext}', "");
    Expect(0, 687, '\P{Is_Blk=_	ipa_ext}', "");
    Expect(1, 687, '\P{^Is_Blk=_	ipa_ext}', "");
    Expect(0, 688, '\p{Is_Blk=_	ipa_ext}', "");
    Expect(1, 688, '\p{^Is_Blk=_	ipa_ext}', "");
    Expect(1, 688, '\P{Is_Blk=_	ipa_ext}', "");
    Expect(0, 688, '\P{^Is_Blk=_	ipa_ext}', "");
    Error('\p{Block=	:=HANGUL_jamo}');
    Error('\P{Block=	:=HANGUL_jamo}');
    Expect(1, 4607, '\p{Block=hanguljamo}', "");
    Expect(0, 4607, '\p{^Block=hanguljamo}', "");
    Expect(0, 4607, '\P{Block=hanguljamo}', "");
    Expect(1, 4607, '\P{^Block=hanguljamo}', "");
    Expect(0, 4608, '\p{Block=hanguljamo}', "");
    Expect(1, 4608, '\p{^Block=hanguljamo}', "");
    Expect(1, 4608, '\P{Block=hanguljamo}', "");
    Expect(0, 4608, '\P{^Block=hanguljamo}', "");
    Expect(1, 4607, '\p{Block=__hangul_Jamo}', "");
    Expect(0, 4607, '\p{^Block=__hangul_Jamo}', "");
    Expect(0, 4607, '\P{Block=__hangul_Jamo}', "");
    Expect(1, 4607, '\P{^Block=__hangul_Jamo}', "");
    Expect(0, 4608, '\p{Block=__hangul_Jamo}', "");
    Expect(1, 4608, '\p{^Block=__hangul_Jamo}', "");
    Expect(1, 4608, '\P{Block=__hangul_Jamo}', "");
    Expect(0, 4608, '\P{^Block=__hangul_Jamo}', "");
    Error('\p{Blk=_ Jamo:=}');
    Error('\P{Blk=_ Jamo:=}');
    Expect(1, 4607, '\p{Blk=jamo}', "");
    Expect(0, 4607, '\p{^Blk=jamo}', "");
    Expect(0, 4607, '\P{Blk=jamo}', "");
    Expect(1, 4607, '\P{^Blk=jamo}', "");
    Expect(0, 4608, '\p{Blk=jamo}', "");
    Expect(1, 4608, '\p{^Blk=jamo}', "");
    Expect(1, 4608, '\P{Blk=jamo}', "");
    Expect(0, 4608, '\P{^Blk=jamo}', "");
    Expect(1, 4607, '\p{Blk=Jamo}', "");
    Expect(0, 4607, '\p{^Blk=Jamo}', "");
    Expect(0, 4607, '\P{Blk=Jamo}', "");
    Expect(1, 4607, '\P{^Blk=Jamo}', "");
    Expect(0, 4608, '\p{Blk=Jamo}', "");
    Expect(1, 4608, '\p{^Blk=Jamo}', "");
    Expect(1, 4608, '\P{Blk=Jamo}', "");
    Expect(0, 4608, '\P{^Blk=Jamo}', "");
    Error('\p{Is_Block=_Hangul_JAMO:=}');
    Error('\P{Is_Block=_Hangul_JAMO:=}');
    Expect(1, 4607, '\p{Is_Block: hanguljamo}', "");
    Expect(0, 4607, '\p{^Is_Block: hanguljamo}', "");
    Expect(0, 4607, '\P{Is_Block: hanguljamo}', "");
    Expect(1, 4607, '\P{^Is_Block: hanguljamo}', "");
    Expect(0, 4608, '\p{Is_Block: hanguljamo}', "");
    Expect(1, 4608, '\p{^Is_Block: hanguljamo}', "");
    Expect(1, 4608, '\P{Is_Block: hanguljamo}', "");
    Expect(0, 4608, '\P{^Is_Block: hanguljamo}', "");
    Expect(1, 4607, '\p{Is_Block=		HANGUL_JAMO}', "");
    Expect(0, 4607, '\p{^Is_Block=		HANGUL_JAMO}', "");
    Expect(0, 4607, '\P{Is_Block=		HANGUL_JAMO}', "");
    Expect(1, 4607, '\P{^Is_Block=		HANGUL_JAMO}', "");
    Expect(0, 4608, '\p{Is_Block=		HANGUL_JAMO}', "");
    Expect(1, 4608, '\p{^Is_Block=		HANGUL_JAMO}', "");
    Expect(1, 4608, '\P{Is_Block=		HANGUL_JAMO}', "");
    Expect(0, 4608, '\P{^Is_Block=		HANGUL_JAMO}', "");
    Error('\p{Is_Blk= -Jamo/a/}');
    Error('\P{Is_Blk= -Jamo/a/}');
    Expect(1, 4607, '\p{Is_Blk: jamo}', "");
    Expect(0, 4607, '\p{^Is_Blk: jamo}', "");
    Expect(0, 4607, '\P{Is_Blk: jamo}', "");
    Expect(1, 4607, '\P{^Is_Blk: jamo}', "");
    Expect(0, 4608, '\p{Is_Blk: jamo}', "");
    Expect(1, 4608, '\p{^Is_Blk: jamo}', "");
    Expect(1, 4608, '\P{Is_Blk: jamo}', "");
    Expect(0, 4608, '\P{^Is_Blk: jamo}', "");
    Expect(1, 4607, '\p{Is_Blk=_jamo}', "");
    Expect(0, 4607, '\p{^Is_Blk=_jamo}', "");
    Expect(0, 4607, '\P{Is_Blk=_jamo}', "");
    Expect(1, 4607, '\P{^Is_Blk=_jamo}', "");
    Expect(0, 4608, '\p{Is_Blk=_jamo}', "");
    Expect(1, 4608, '\p{^Is_Blk=_jamo}', "");
    Expect(1, 4608, '\P{Is_Blk=_jamo}', "");
    Expect(0, 4608, '\P{^Is_Blk=_jamo}', "");
    Error('\p{Block=/a/--HANGUL_JAMO_Extended_A}');
    Error('\P{Block=/a/--HANGUL_JAMO_Extended_A}');
    Expect(1, 43391, '\p{Block=hanguljamoextendeda}', "");
    Expect(0, 43391, '\p{^Block=hanguljamoextendeda}', "");
    Expect(0, 43391, '\P{Block=hanguljamoextendeda}', "");
    Expect(1, 43391, '\P{^Block=hanguljamoextendeda}', "");
    Expect(0, 43392, '\p{Block=hanguljamoextendeda}', "");
    Expect(1, 43392, '\p{^Block=hanguljamoextendeda}', "");
    Expect(1, 43392, '\P{Block=hanguljamoextendeda}', "");
    Expect(0, 43392, '\P{^Block=hanguljamoextendeda}', "");
    Expect(1, 43391, '\p{Block=	Hangul_jamo_EXTENDED_A}', "");
    Expect(0, 43391, '\p{^Block=	Hangul_jamo_EXTENDED_A}', "");
    Expect(0, 43391, '\P{Block=	Hangul_jamo_EXTENDED_A}', "");
    Expect(1, 43391, '\P{^Block=	Hangul_jamo_EXTENDED_A}', "");
    Expect(0, 43392, '\p{Block=	Hangul_jamo_EXTENDED_A}', "");
    Expect(1, 43392, '\p{^Block=	Hangul_jamo_EXTENDED_A}', "");
    Expect(1, 43392, '\P{Block=	Hangul_jamo_EXTENDED_A}', "");
    Expect(0, 43392, '\P{^Block=	Hangul_jamo_EXTENDED_A}', "");
    Error('\p{Blk= -Jamo_ext_A:=}');
    Error('\P{Blk= -Jamo_ext_A:=}');
    Expect(1, 43391, '\p{Blk=jamoexta}', "");
    Expect(0, 43391, '\p{^Blk=jamoexta}', "");
    Expect(0, 43391, '\P{Blk=jamoexta}', "");
    Expect(1, 43391, '\P{^Blk=jamoexta}', "");
    Expect(0, 43392, '\p{Blk=jamoexta}', "");
    Expect(1, 43392, '\p{^Blk=jamoexta}', "");
    Expect(1, 43392, '\P{Blk=jamoexta}', "");
    Expect(0, 43392, '\P{^Blk=jamoexta}', "");
    Expect(1, 43391, '\p{Blk=_jamo_ext_A}', "");
    Expect(0, 43391, '\p{^Blk=_jamo_ext_A}', "");
    Expect(0, 43391, '\P{Blk=_jamo_ext_A}', "");
    Expect(1, 43391, '\P{^Blk=_jamo_ext_A}', "");
    Expect(0, 43392, '\p{Blk=_jamo_ext_A}', "");
    Expect(1, 43392, '\p{^Blk=_jamo_ext_A}', "");
    Expect(1, 43392, '\P{Blk=_jamo_ext_A}', "");
    Expect(0, 43392, '\P{^Blk=_jamo_ext_A}', "");
    Error('\p{Is_Block=/a/_	hangul_jamo_EXTENDED_A}');
    Error('\P{Is_Block=/a/_	hangul_jamo_EXTENDED_A}');
    Expect(1, 43391, '\p{Is_Block: hanguljamoextendeda}', "");
    Expect(0, 43391, '\p{^Is_Block: hanguljamoextendeda}', "");
    Expect(0, 43391, '\P{Is_Block: hanguljamoextendeda}', "");
    Expect(1, 43391, '\P{^Is_Block: hanguljamoextendeda}', "");
    Expect(0, 43392, '\p{Is_Block: hanguljamoextendeda}', "");
    Expect(1, 43392, '\p{^Is_Block: hanguljamoextendeda}', "");
    Expect(1, 43392, '\P{Is_Block: hanguljamoextendeda}', "");
    Expect(0, 43392, '\P{^Is_Block: hanguljamoextendeda}', "");
    Expect(1, 43391, '\p{Is_Block:    Hangul_Jamo_Extended_a}', "");
    Expect(0, 43391, '\p{^Is_Block:    Hangul_Jamo_Extended_a}', "");
    Expect(0, 43391, '\P{Is_Block:    Hangul_Jamo_Extended_a}', "");
    Expect(1, 43391, '\P{^Is_Block:    Hangul_Jamo_Extended_a}', "");
    Expect(0, 43392, '\p{Is_Block:    Hangul_Jamo_Extended_a}', "");
    Expect(1, 43392, '\p{^Is_Block:    Hangul_Jamo_Extended_a}', "");
    Expect(1, 43392, '\P{Is_Block:    Hangul_Jamo_Extended_a}', "");
    Expect(0, 43392, '\P{^Is_Block:    Hangul_Jamo_Extended_a}', "");
    Error('\p{Is_Blk=_	Jamo_ext_A:=}');
    Error('\P{Is_Blk=_	Jamo_ext_A:=}');
    Expect(1, 43391, '\p{Is_Blk=jamoexta}', "");
    Expect(0, 43391, '\p{^Is_Blk=jamoexta}', "");
    Expect(0, 43391, '\P{Is_Blk=jamoexta}', "");
    Expect(1, 43391, '\P{^Is_Blk=jamoexta}', "");
    Expect(0, 43392, '\p{Is_Blk=jamoexta}', "");
    Expect(1, 43392, '\p{^Is_Blk=jamoexta}', "");
    Expect(1, 43392, '\P{Is_Blk=jamoexta}', "");
    Expect(0, 43392, '\P{^Is_Blk=jamoexta}', "");
    Expect(1, 43391, '\p{Is_Blk=_-Jamo_Ext_A}', "");
    Expect(0, 43391, '\p{^Is_Blk=_-Jamo_Ext_A}', "");
    Expect(0, 43391, '\P{Is_Blk=_-Jamo_Ext_A}', "");
    Expect(1, 43391, '\P{^Is_Blk=_-Jamo_Ext_A}', "");
    Expect(0, 43392, '\p{Is_Blk=_-Jamo_Ext_A}', "");
    Expect(1, 43392, '\p{^Is_Blk=_-Jamo_Ext_A}', "");
    Expect(1, 43392, '\P{Is_Blk=_-Jamo_Ext_A}', "");
    Expect(0, 43392, '\P{^Is_Blk=_-Jamo_Ext_A}', "");
    Error('\p{Block:-_hangul_Jamo_extended_b/a/}');
    Error('\P{Block:-_hangul_Jamo_extended_b/a/}');
    Expect(1, 55295, '\p{Block=hanguljamoextendedb}', "");
    Expect(0, 55295, '\p{^Block=hanguljamoextendedb}', "");
    Expect(0, 55295, '\P{Block=hanguljamoextendedb}', "");
    Expect(1, 55295, '\P{^Block=hanguljamoextendedb}', "");
    Expect(0, 57344, '\p{Block=hanguljamoextendedb}', "");
    Expect(1, 57344, '\p{^Block=hanguljamoextendedb}', "");
    Expect(1, 57344, '\P{Block=hanguljamoextendedb}', "");
    Expect(0, 57344, '\P{^Block=hanguljamoextendedb}', "");
    Expect(1, 55295, '\p{Block=-_Hangul_Jamo_Extended_B}', "");
    Expect(0, 55295, '\p{^Block=-_Hangul_Jamo_Extended_B}', "");
    Expect(0, 55295, '\P{Block=-_Hangul_Jamo_Extended_B}', "");
    Expect(1, 55295, '\P{^Block=-_Hangul_Jamo_Extended_B}', "");
    Expect(0, 57344, '\p{Block=-_Hangul_Jamo_Extended_B}', "");
    Expect(1, 57344, '\p{^Block=-_Hangul_Jamo_Extended_B}', "");
    Expect(1, 57344, '\P{Block=-_Hangul_Jamo_Extended_B}', "");
    Expect(0, 57344, '\P{^Block=-_Hangul_Jamo_Extended_B}', "");
    Error('\p{Blk=_ Jamo_EXT_B/a/}');
    Error('\P{Blk=_ Jamo_EXT_B/a/}');
    Expect(1, 55295, '\p{Blk=jamoextb}', "");
    Expect(0, 55295, '\p{^Blk=jamoextb}', "");
    Expect(0, 55295, '\P{Blk=jamoextb}', "");
    Expect(1, 55295, '\P{^Blk=jamoextb}', "");
    Expect(0, 57344, '\p{Blk=jamoextb}', "");
    Expect(1, 57344, '\p{^Blk=jamoextb}', "");
    Expect(1, 57344, '\P{Blk=jamoextb}', "");
    Expect(0, 57344, '\P{^Blk=jamoextb}', "");
    Expect(1, 55295, '\p{Blk=	_JAMO_Ext_b}', "");
    Expect(0, 55295, '\p{^Blk=	_JAMO_Ext_b}', "");
    Expect(0, 55295, '\P{Blk=	_JAMO_Ext_b}', "");
    Expect(1, 55295, '\P{^Blk=	_JAMO_Ext_b}', "");
    Expect(0, 57344, '\p{Blk=	_JAMO_Ext_b}', "");
    Expect(1, 57344, '\p{^Blk=	_JAMO_Ext_b}', "");
    Expect(1, 57344, '\P{Blk=	_JAMO_Ext_b}', "");
    Expect(0, 57344, '\P{^Blk=	_JAMO_Ext_b}', "");
    Error('\p{Is_Block:    :=Hangul_Jamo_Extended_B}');
    Error('\P{Is_Block:    :=Hangul_Jamo_Extended_B}');
    Expect(1, 55295, '\p{Is_Block=hanguljamoextendedb}', "");
    Expect(0, 55295, '\p{^Is_Block=hanguljamoextendedb}', "");
    Expect(0, 55295, '\P{Is_Block=hanguljamoextendedb}', "");
    Expect(1, 55295, '\P{^Is_Block=hanguljamoextendedb}', "");
    Expect(0, 57344, '\p{Is_Block=hanguljamoextendedb}', "");
    Expect(1, 57344, '\p{^Is_Block=hanguljamoextendedb}', "");
    Expect(1, 57344, '\P{Is_Block=hanguljamoextendedb}', "");
    Expect(0, 57344, '\P{^Is_Block=hanguljamoextendedb}', "");
    Expect(1, 55295, '\p{Is_Block=_ HANGUL_Jamo_extended_B}', "");
    Expect(0, 55295, '\p{^Is_Block=_ HANGUL_Jamo_extended_B}', "");
    Expect(0, 55295, '\P{Is_Block=_ HANGUL_Jamo_extended_B}', "");
    Expect(1, 55295, '\P{^Is_Block=_ HANGUL_Jamo_extended_B}', "");
    Expect(0, 57344, '\p{Is_Block=_ HANGUL_Jamo_extended_B}', "");
    Expect(1, 57344, '\p{^Is_Block=_ HANGUL_Jamo_extended_B}', "");
    Expect(1, 57344, '\P{Is_Block=_ HANGUL_Jamo_extended_B}', "");
    Expect(0, 57344, '\P{^Is_Block=_ HANGUL_Jamo_extended_B}', "");
    Error('\p{Is_Blk: :=jamo_Ext_B}');
    Error('\P{Is_Blk: :=jamo_Ext_B}');
    Expect(1, 55295, '\p{Is_Blk=jamoextb}', "");
    Expect(0, 55295, '\p{^Is_Blk=jamoextb}', "");
    Expect(0, 55295, '\P{Is_Blk=jamoextb}', "");
    Expect(1, 55295, '\P{^Is_Blk=jamoextb}', "");
    Expect(0, 57344, '\p{Is_Blk=jamoextb}', "");
    Expect(1, 57344, '\p{^Is_Blk=jamoextb}', "");
    Expect(1, 57344, '\P{Is_Blk=jamoextb}', "");
    Expect(0, 57344, '\P{^Is_Blk=jamoextb}', "");
    Expect(1, 55295, '\p{Is_Blk=-jamo_ext_B}', "");
    Expect(0, 55295, '\p{^Is_Blk=-jamo_ext_B}', "");
    Expect(0, 55295, '\P{Is_Blk=-jamo_ext_B}', "");
    Expect(1, 55295, '\P{^Is_Blk=-jamo_ext_B}', "");
    Expect(0, 57344, '\p{Is_Blk=-jamo_ext_B}', "");
    Expect(1, 57344, '\p{^Is_Blk=-jamo_ext_B}', "");
    Expect(1, 57344, '\P{Is_Blk=-jamo_ext_B}', "");
    Expect(0, 57344, '\P{^Is_Blk=-jamo_ext_B}', "");
    Error('\p{Block=_ Javanese/a/}');
    Error('\P{Block=_ Javanese/a/}');
    Expect(1, 43487, '\p{Block:javanese}', "");
    Expect(0, 43487, '\p{^Block:javanese}', "");
    Expect(0, 43487, '\P{Block:javanese}', "");
    Expect(1, 43487, '\P{^Block:javanese}', "");
    Expect(0, 43488, '\p{Block:javanese}', "");
    Expect(1, 43488, '\p{^Block:javanese}', "");
    Expect(1, 43488, '\P{Block:javanese}', "");
    Expect(0, 43488, '\P{^Block:javanese}', "");
    Expect(1, 43487, '\p{Block=  javanese}', "");
    Expect(0, 43487, '\p{^Block=  javanese}', "");
    Expect(0, 43487, '\P{Block=  javanese}', "");
    Expect(1, 43487, '\P{^Block=  javanese}', "");
    Expect(0, 43488, '\p{Block=  javanese}', "");
    Expect(1, 43488, '\p{^Block=  javanese}', "");
    Expect(1, 43488, '\P{Block=  javanese}', "");
    Expect(0, 43488, '\P{^Block=  javanese}', "");
    Error('\p{Blk=_:=JAVANESE}');
    Error('\P{Blk=_:=JAVANESE}');
    Expect(1, 43487, '\p{Blk=javanese}', "");
    Expect(0, 43487, '\p{^Blk=javanese}', "");
    Expect(0, 43487, '\P{Blk=javanese}', "");
    Expect(1, 43487, '\P{^Blk=javanese}', "");
    Expect(0, 43488, '\p{Blk=javanese}', "");
    Expect(1, 43488, '\p{^Blk=javanese}', "");
    Expect(1, 43488, '\P{Blk=javanese}', "");
    Expect(0, 43488, '\P{^Blk=javanese}', "");
    Expect(1, 43487, '\p{Blk=Javanese}', "");
    Expect(0, 43487, '\p{^Blk=Javanese}', "");
    Expect(0, 43487, '\P{Blk=Javanese}', "");
    Expect(1, 43487, '\P{^Blk=Javanese}', "");
    Expect(0, 43488, '\p{Blk=Javanese}', "");
    Expect(1, 43488, '\p{^Blk=Javanese}', "");
    Expect(1, 43488, '\P{Blk=Javanese}', "");
    Expect(0, 43488, '\P{^Blk=Javanese}', "");
    Error('\p{Is_Block=:= _JAVANESE}');
    Error('\P{Is_Block=:= _JAVANESE}');
    Expect(1, 43487, '\p{Is_Block=javanese}', "");
    Expect(0, 43487, '\p{^Is_Block=javanese}', "");
    Expect(0, 43487, '\P{Is_Block=javanese}', "");
    Expect(1, 43487, '\P{^Is_Block=javanese}', "");
    Expect(0, 43488, '\p{Is_Block=javanese}', "");
    Expect(1, 43488, '\p{^Is_Block=javanese}', "");
    Expect(1, 43488, '\P{Is_Block=javanese}', "");
    Expect(0, 43488, '\P{^Is_Block=javanese}', "");
    Expect(1, 43487, '\p{Is_Block= javanese}', "");
    Expect(0, 43487, '\p{^Is_Block= javanese}', "");
    Expect(0, 43487, '\P{Is_Block= javanese}', "");
    Expect(1, 43487, '\P{^Is_Block= javanese}', "");
    Expect(0, 43488, '\p{Is_Block= javanese}', "");
    Expect(1, 43488, '\p{^Is_Block= javanese}', "");
    Expect(1, 43488, '\P{Is_Block= javanese}', "");
    Expect(0, 43488, '\P{^Is_Block= javanese}', "");
    Error('\p{Is_Blk=:=__JAVANESE}');
    Error('\P{Is_Blk=:=__JAVANESE}');
    Expect(1, 43487, '\p{Is_Blk=javanese}', "");
    Expect(0, 43487, '\p{^Is_Blk=javanese}', "");
    Expect(0, 43487, '\P{Is_Blk=javanese}', "");
    Expect(1, 43487, '\P{^Is_Blk=javanese}', "");
    Expect(0, 43488, '\p{Is_Blk=javanese}', "");
    Expect(1, 43488, '\p{^Is_Blk=javanese}', "");
    Expect(1, 43488, '\P{Is_Blk=javanese}', "");
    Expect(0, 43488, '\P{^Is_Blk=javanese}', "");
    Expect(1, 43487, '\p{Is_Blk= Javanese}', "");
    Expect(0, 43487, '\p{^Is_Blk= Javanese}', "");
    Expect(0, 43487, '\P{Is_Blk= Javanese}', "");
    Expect(1, 43487, '\P{^Is_Blk= Javanese}', "");
    Expect(0, 43488, '\p{Is_Blk= Javanese}', "");
    Expect(1, 43488, '\p{^Is_Blk= Javanese}', "");
    Expect(1, 43488, '\P{Is_Blk= Javanese}', "");
    Expect(0, 43488, '\P{^Is_Blk= Javanese}', "");
    Error('\p{Block=/a/  Kaithi}');
    Error('\P{Block=/a/  Kaithi}');
    Expect(1, 69839, '\p{Block=kaithi}', "");
    Expect(0, 69839, '\p{^Block=kaithi}', "");
    Expect(0, 69839, '\P{Block=kaithi}', "");
    Expect(1, 69839, '\P{^Block=kaithi}', "");
    Expect(0, 69840, '\p{Block=kaithi}', "");
    Expect(1, 69840, '\p{^Block=kaithi}', "");
    Expect(1, 69840, '\P{Block=kaithi}', "");
    Expect(0, 69840, '\P{^Block=kaithi}', "");
    Expect(1, 69839, '\p{Block=		Kaithi}', "");
    Expect(0, 69839, '\p{^Block=		Kaithi}', "");
    Expect(0, 69839, '\P{Block=		Kaithi}', "");
    Expect(1, 69839, '\P{^Block=		Kaithi}', "");
    Expect(0, 69840, '\p{Block=		Kaithi}', "");
    Expect(1, 69840, '\p{^Block=		Kaithi}', "");
    Expect(1, 69840, '\P{Block=		Kaithi}', "");
    Expect(0, 69840, '\P{^Block=		Kaithi}', "");
    Error('\p{Blk= -KAITHI:=}');
    Error('\P{Blk= -KAITHI:=}');
    Expect(1, 69839, '\p{Blk:kaithi}', "");
    Expect(0, 69839, '\p{^Blk:kaithi}', "");
    Expect(0, 69839, '\P{Blk:kaithi}', "");
    Expect(1, 69839, '\P{^Blk:kaithi}', "");
    Expect(0, 69840, '\p{Blk:kaithi}', "");
    Expect(1, 69840, '\p{^Blk:kaithi}', "");
    Expect(1, 69840, '\P{Blk:kaithi}', "");
    Expect(0, 69840, '\P{^Blk:kaithi}', "");
    Expect(1, 69839, '\p{Blk= 	kaithi}', "");
    Expect(0, 69839, '\p{^Blk= 	kaithi}', "");
    Expect(0, 69839, '\P{Blk= 	kaithi}', "");
    Expect(1, 69839, '\P{^Blk= 	kaithi}', "");
    Expect(0, 69840, '\p{Blk= 	kaithi}', "");
    Expect(1, 69840, '\p{^Blk= 	kaithi}', "");
    Expect(1, 69840, '\P{Blk= 	kaithi}', "");
    Expect(0, 69840, '\P{^Blk= 	kaithi}', "");
    Error('\p{Is_Block=__KAITHI:=}');
    Error('\P{Is_Block=__KAITHI:=}');
    Expect(1, 69839, '\p{Is_Block=kaithi}', "");
    Expect(0, 69839, '\p{^Is_Block=kaithi}', "");
    Expect(0, 69839, '\P{Is_Block=kaithi}', "");
    Expect(1, 69839, '\P{^Is_Block=kaithi}', "");
    Expect(0, 69840, '\p{Is_Block=kaithi}', "");
    Expect(1, 69840, '\p{^Is_Block=kaithi}', "");
    Expect(1, 69840, '\P{Is_Block=kaithi}', "");
    Expect(0, 69840, '\P{^Is_Block=kaithi}', "");
    Expect(1, 69839, '\p{Is_Block= -KAITHI}', "");
    Expect(0, 69839, '\p{^Is_Block= -KAITHI}', "");
    Expect(0, 69839, '\P{Is_Block= -KAITHI}', "");
    Expect(1, 69839, '\P{^Is_Block= -KAITHI}', "");
    Expect(0, 69840, '\p{Is_Block= -KAITHI}', "");
    Expect(1, 69840, '\p{^Is_Block= -KAITHI}', "");
    Expect(1, 69840, '\P{Is_Block= -KAITHI}', "");
    Expect(0, 69840, '\P{^Is_Block= -KAITHI}', "");
    Error('\p{Is_Blk=:=-Kaithi}');
    Error('\P{Is_Blk=:=-Kaithi}');
    Expect(1, 69839, '\p{Is_Blk=kaithi}', "");
    Expect(0, 69839, '\p{^Is_Blk=kaithi}', "");
    Expect(0, 69839, '\P{Is_Blk=kaithi}', "");
    Expect(1, 69839, '\P{^Is_Blk=kaithi}', "");
    Expect(0, 69840, '\p{Is_Blk=kaithi}', "");
    Expect(1, 69840, '\p{^Is_Blk=kaithi}', "");
    Expect(1, 69840, '\P{Is_Blk=kaithi}', "");
    Expect(0, 69840, '\P{^Is_Blk=kaithi}', "");
    Expect(1, 69839, '\p{Is_Blk=		Kaithi}', "");
    Expect(0, 69839, '\p{^Is_Blk=		Kaithi}', "");
    Expect(0, 69839, '\P{Is_Blk=		Kaithi}', "");
    Expect(1, 69839, '\P{^Is_Blk=		Kaithi}', "");
    Expect(0, 69840, '\p{Is_Blk=		Kaithi}', "");
    Expect(1, 69840, '\p{^Is_Blk=		Kaithi}', "");
    Expect(1, 69840, '\P{Is_Blk=		Kaithi}', "");
    Expect(0, 69840, '\P{^Is_Blk=		Kaithi}', "");
    Error('\p{Block=:= 	Kana_extended_A}');
    Error('\P{Block=:= 	Kana_extended_A}');
    Expect(1, 110895, '\p{Block:   kanaextendeda}', "");
    Expect(0, 110895, '\p{^Block:   kanaextendeda}', "");
    Expect(0, 110895, '\P{Block:   kanaextendeda}', "");
    Expect(1, 110895, '\P{^Block:   kanaextendeda}', "");
    Expect(0, 110896, '\p{Block:   kanaextendeda}', "");
    Expect(1, 110896, '\p{^Block:   kanaextendeda}', "");
    Expect(1, 110896, '\P{Block:   kanaextendeda}', "");
    Expect(0, 110896, '\P{^Block:   kanaextendeda}', "");
    Expect(1, 110895, '\p{Block=	 Kana_EXTENDED_a}', "");
    Expect(0, 110895, '\p{^Block=	 Kana_EXTENDED_a}', "");
    Expect(0, 110895, '\P{Block=	 Kana_EXTENDED_a}', "");
    Expect(1, 110895, '\P{^Block=	 Kana_EXTENDED_a}', "");
    Expect(0, 110896, '\p{Block=	 Kana_EXTENDED_a}', "");
    Expect(1, 110896, '\p{^Block=	 Kana_EXTENDED_a}', "");
    Expect(1, 110896, '\P{Block=	 Kana_EXTENDED_a}', "");
    Expect(0, 110896, '\P{^Block=	 Kana_EXTENDED_a}', "");
    Error('\p{Blk=-	Kana_Ext_a:=}');
    Error('\P{Blk=-	Kana_Ext_a:=}');
    Expect(1, 110895, '\p{Blk=kanaexta}', "");
    Expect(0, 110895, '\p{^Blk=kanaexta}', "");
    Expect(0, 110895, '\P{Blk=kanaexta}', "");
    Expect(1, 110895, '\P{^Blk=kanaexta}', "");
    Expect(0, 110896, '\p{Blk=kanaexta}', "");
    Expect(1, 110896, '\p{^Blk=kanaexta}', "");
    Expect(1, 110896, '\P{Blk=kanaexta}', "");
    Expect(0, 110896, '\P{^Blk=kanaexta}', "");
    Expect(1, 110895, '\p{Blk=_	Kana_Ext_a}', "");
    Expect(0, 110895, '\p{^Blk=_	Kana_Ext_a}', "");
    Expect(0, 110895, '\P{Blk=_	Kana_Ext_a}', "");
    Expect(1, 110895, '\P{^Blk=_	Kana_Ext_a}', "");
    Expect(0, 110896, '\p{Blk=_	Kana_Ext_a}', "");
    Expect(1, 110896, '\p{^Blk=_	Kana_Ext_a}', "");
    Expect(1, 110896, '\P{Blk=_	Kana_Ext_a}', "");
    Expect(0, 110896, '\P{^Blk=_	Kana_Ext_a}', "");
    Error('\p{Is_Block=/a/_	Kana_EXTENDED_a}');
    Error('\P{Is_Block=/a/_	Kana_EXTENDED_a}');
    Expect(1, 110895, '\p{Is_Block=kanaextendeda}', "");
    Expect(0, 110895, '\p{^Is_Block=kanaextendeda}', "");
    Expect(0, 110895, '\P{Is_Block=kanaextendeda}', "");
    Expect(1, 110895, '\P{^Is_Block=kanaextendeda}', "");
    Expect(0, 110896, '\p{Is_Block=kanaextendeda}', "");
    Expect(1, 110896, '\p{^Is_Block=kanaextendeda}', "");
    Expect(1, 110896, '\P{Is_Block=kanaextendeda}', "");
    Expect(0, 110896, '\P{^Is_Block=kanaextendeda}', "");
    Expect(1, 110895, '\p{Is_Block:   -Kana_EXTENDED_A}', "");
    Expect(0, 110895, '\p{^Is_Block:   -Kana_EXTENDED_A}', "");
    Expect(0, 110895, '\P{Is_Block:   -Kana_EXTENDED_A}', "");
    Expect(1, 110895, '\P{^Is_Block:   -Kana_EXTENDED_A}', "");
    Expect(0, 110896, '\p{Is_Block:   -Kana_EXTENDED_A}', "");
    Expect(1, 110896, '\p{^Is_Block:   -Kana_EXTENDED_A}', "");
    Expect(1, 110896, '\P{Is_Block:   -Kana_EXTENDED_A}', "");
    Expect(0, 110896, '\P{^Is_Block:   -Kana_EXTENDED_A}', "");
    Error('\p{Is_Blk: _/a/KANA_ext_A}');
    Error('\P{Is_Blk: _/a/KANA_ext_A}');
    Expect(1, 110895, '\p{Is_Blk=kanaexta}', "");
    Expect(0, 110895, '\p{^Is_Blk=kanaexta}', "");
    Expect(0, 110895, '\P{Is_Blk=kanaexta}', "");
    Expect(1, 110895, '\P{^Is_Blk=kanaexta}', "");
    Expect(0, 110896, '\p{Is_Blk=kanaexta}', "");
    Expect(1, 110896, '\p{^Is_Blk=kanaexta}', "");
    Expect(1, 110896, '\P{Is_Blk=kanaexta}', "");
    Expect(0, 110896, '\P{^Is_Blk=kanaexta}', "");
    Expect(1, 110895, '\p{Is_Blk= _Kana_Ext_A}', "");
    Expect(0, 110895, '\p{^Is_Blk= _Kana_Ext_A}', "");
    Expect(0, 110895, '\P{Is_Blk= _Kana_Ext_A}', "");
    Expect(1, 110895, '\P{^Is_Blk= _Kana_Ext_A}', "");
    Expect(0, 110896, '\p{Is_Blk= _Kana_Ext_A}', "");
    Expect(1, 110896, '\p{^Is_Blk= _Kana_Ext_A}', "");
    Expect(1, 110896, '\P{Is_Blk= _Kana_Ext_A}', "");
    Expect(0, 110896, '\P{^Is_Blk= _Kana_Ext_A}', "");
    Error('\p{Block=_/a/kana_Supplement}');
    Error('\P{Block=_/a/kana_Supplement}');
    Expect(1, 110847, '\p{Block=kanasupplement}', "");
    Expect(0, 110847, '\p{^Block=kanasupplement}', "");
    Expect(0, 110847, '\P{Block=kanasupplement}', "");
    Expect(1, 110847, '\P{^Block=kanasupplement}', "");
    Expect(0, 110848, '\p{Block=kanasupplement}', "");
    Expect(1, 110848, '\p{^Block=kanasupplement}', "");
    Expect(1, 110848, '\P{Block=kanasupplement}', "");
    Expect(0, 110848, '\P{^Block=kanasupplement}', "");
    Expect(1, 110847, '\p{Block=-kana_SUPPLEMENT}', "");
    Expect(0, 110847, '\p{^Block=-kana_SUPPLEMENT}', "");
    Expect(0, 110847, '\P{Block=-kana_SUPPLEMENT}', "");
    Expect(1, 110847, '\P{^Block=-kana_SUPPLEMENT}', "");
    Expect(0, 110848, '\p{Block=-kana_SUPPLEMENT}', "");
    Expect(1, 110848, '\p{^Block=-kana_SUPPLEMENT}', "");
    Expect(1, 110848, '\P{Block=-kana_SUPPLEMENT}', "");
    Expect(0, 110848, '\P{^Block=-kana_SUPPLEMENT}', "");
    Error('\p{Blk=/a/  KANA_sup}');
    Error('\P{Blk=/a/  KANA_sup}');
    Expect(1, 110847, '\p{Blk:   kanasup}', "");
    Expect(0, 110847, '\p{^Blk:   kanasup}', "");
    Expect(0, 110847, '\P{Blk:   kanasup}', "");
    Expect(1, 110847, '\P{^Blk:   kanasup}', "");
    Expect(0, 110848, '\p{Blk:   kanasup}', "");
    Expect(1, 110848, '\p{^Blk:   kanasup}', "");
    Expect(1, 110848, '\P{Blk:   kanasup}', "");
    Expect(0, 110848, '\P{^Blk:   kanasup}', "");
    Expect(1, 110847, '\p{Blk=-Kana_Sup}', "");
    Expect(0, 110847, '\p{^Blk=-Kana_Sup}', "");
    Expect(0, 110847, '\P{Blk=-Kana_Sup}', "");
    Expect(1, 110847, '\P{^Blk=-Kana_Sup}', "");
    Expect(0, 110848, '\p{Blk=-Kana_Sup}', "");
    Expect(1, 110848, '\p{^Blk=-Kana_Sup}', "");
    Expect(1, 110848, '\P{Blk=-Kana_Sup}', "");
    Expect(0, 110848, '\P{^Blk=-Kana_Sup}', "");
    Error('\p{Is_Block=-kana_SUPPLEMENT:=}');
    Error('\P{Is_Block=-kana_SUPPLEMENT:=}');
    Expect(1, 110847, '\p{Is_Block=kanasupplement}', "");
    Expect(0, 110847, '\p{^Is_Block=kanasupplement}', "");
    Expect(0, 110847, '\P{Is_Block=kanasupplement}', "");
    Expect(1, 110847, '\P{^Is_Block=kanasupplement}', "");
    Expect(0, 110848, '\p{Is_Block=kanasupplement}', "");
    Expect(1, 110848, '\p{^Is_Block=kanasupplement}', "");
    Expect(1, 110848, '\P{Is_Block=kanasupplement}', "");
    Expect(0, 110848, '\P{^Is_Block=kanasupplement}', "");
    Expect(1, 110847, '\p{Is_Block= 	kana_Supplement}', "");
    Expect(0, 110847, '\p{^Is_Block= 	kana_Supplement}', "");
    Expect(0, 110847, '\P{Is_Block= 	kana_Supplement}', "");
    Expect(1, 110847, '\P{^Is_Block= 	kana_Supplement}', "");
    Expect(0, 110848, '\p{Is_Block= 	kana_Supplement}', "");
    Expect(1, 110848, '\p{^Is_Block= 	kana_Supplement}', "");
    Expect(1, 110848, '\P{Is_Block= 	kana_Supplement}', "");
    Expect(0, 110848, '\P{^Is_Block= 	kana_Supplement}', "");
    Error('\p{Is_Blk=:=-KANA_Sup}');
    Error('\P{Is_Blk=:=-KANA_Sup}');
    Expect(1, 110847, '\p{Is_Blk=kanasup}', "");
    Expect(0, 110847, '\p{^Is_Blk=kanasup}', "");
    Expect(0, 110847, '\P{Is_Blk=kanasup}', "");
    Expect(1, 110847, '\P{^Is_Blk=kanasup}', "");
    Expect(0, 110848, '\p{Is_Blk=kanasup}', "");
    Expect(1, 110848, '\p{^Is_Blk=kanasup}', "");
    Expect(1, 110848, '\P{Is_Blk=kanasup}', "");
    Expect(0, 110848, '\P{^Is_Blk=kanasup}', "");
    Expect(1, 110847, '\p{Is_Blk= _Kana_Sup}', "");
    Expect(0, 110847, '\p{^Is_Blk= _Kana_Sup}', "");
    Expect(0, 110847, '\P{Is_Blk= _Kana_Sup}', "");
    Expect(1, 110847, '\P{^Is_Blk= _Kana_Sup}', "");
    Expect(0, 110848, '\p{Is_Blk= _Kana_Sup}', "");
    Expect(1, 110848, '\p{^Is_Blk= _Kana_Sup}', "");
    Expect(1, 110848, '\P{Is_Blk= _Kana_Sup}', "");
    Expect(0, 110848, '\P{^Is_Blk= _Kana_Sup}', "");
    Error('\p{Block:  	kanbun:=}');
    Error('\P{Block:  	kanbun:=}');
    Expect(1, 12703, '\p{Block=kanbun}', "");
    Expect(0, 12703, '\p{^Block=kanbun}', "");
    Expect(0, 12703, '\P{Block=kanbun}', "");
    Expect(1, 12703, '\P{^Block=kanbun}', "");
    Expect(0, 12704, '\p{Block=kanbun}', "");
    Expect(1, 12704, '\p{^Block=kanbun}', "");
    Expect(1, 12704, '\P{Block=kanbun}', "");
    Expect(0, 12704, '\P{^Block=kanbun}', "");
    Expect(1, 12703, '\p{Block=-_kanbun}', "");
    Expect(0, 12703, '\p{^Block=-_kanbun}', "");
    Expect(0, 12703, '\P{Block=-_kanbun}', "");
    Expect(1, 12703, '\P{^Block=-_kanbun}', "");
    Expect(0, 12704, '\p{Block=-_kanbun}', "");
    Expect(1, 12704, '\p{^Block=-_kanbun}', "");
    Expect(1, 12704, '\P{Block=-_kanbun}', "");
    Expect(0, 12704, '\P{^Block=-_kanbun}', "");
    Error('\p{Blk=/a/ _Kanbun}');
    Error('\P{Blk=/a/ _Kanbun}');
    Expect(1, 12703, '\p{Blk=kanbun}', "");
    Expect(0, 12703, '\p{^Blk=kanbun}', "");
    Expect(0, 12703, '\P{Blk=kanbun}', "");
    Expect(1, 12703, '\P{^Blk=kanbun}', "");
    Expect(0, 12704, '\p{Blk=kanbun}', "");
    Expect(1, 12704, '\p{^Blk=kanbun}', "");
    Expect(1, 12704, '\P{Blk=kanbun}', "");
    Expect(0, 12704, '\P{^Blk=kanbun}', "");
    Expect(1, 12703, '\p{Blk:-Kanbun}', "");
    Expect(0, 12703, '\p{^Blk:-Kanbun}', "");
    Expect(0, 12703, '\P{Blk:-Kanbun}', "");
    Expect(1, 12703, '\P{^Blk:-Kanbun}', "");
    Expect(0, 12704, '\p{Blk:-Kanbun}', "");
    Expect(1, 12704, '\p{^Blk:-Kanbun}', "");
    Expect(1, 12704, '\P{Blk:-Kanbun}', "");
    Expect(0, 12704, '\P{^Blk:-Kanbun}', "");
    Error('\p{Is_Block= /a/kanbun}');
    Error('\P{Is_Block= /a/kanbun}');
    Expect(1, 12703, '\p{Is_Block=kanbun}', "");
    Expect(0, 12703, '\p{^Is_Block=kanbun}', "");
    Expect(0, 12703, '\P{Is_Block=kanbun}', "");
    Expect(1, 12703, '\P{^Is_Block=kanbun}', "");
    Expect(0, 12704, '\p{Is_Block=kanbun}', "");
    Expect(1, 12704, '\p{^Is_Block=kanbun}', "");
    Expect(1, 12704, '\P{Is_Block=kanbun}', "");
    Expect(0, 12704, '\P{^Is_Block=kanbun}', "");
    Expect(1, 12703, '\p{Is_Block=_-Kanbun}', "");
    Expect(0, 12703, '\p{^Is_Block=_-Kanbun}', "");
    Expect(0, 12703, '\P{Is_Block=_-Kanbun}', "");
    Expect(1, 12703, '\P{^Is_Block=_-Kanbun}', "");
    Expect(0, 12704, '\p{Is_Block=_-Kanbun}', "");
    Expect(1, 12704, '\p{^Is_Block=_-Kanbun}', "");
    Expect(1, 12704, '\P{Is_Block=_-Kanbun}', "");
    Expect(0, 12704, '\P{^Is_Block=_-Kanbun}', "");
    Error('\p{Is_Blk=_:=KANBUN}');
    Error('\P{Is_Blk=_:=KANBUN}');
    Expect(1, 12703, '\p{Is_Blk=kanbun}', "");
    Expect(0, 12703, '\p{^Is_Blk=kanbun}', "");
    Expect(0, 12703, '\P{Is_Blk=kanbun}', "");
    Expect(1, 12703, '\P{^Is_Blk=kanbun}', "");
    Expect(0, 12704, '\p{Is_Blk=kanbun}', "");
    Expect(1, 12704, '\p{^Is_Blk=kanbun}', "");
    Expect(1, 12704, '\P{Is_Blk=kanbun}', "");
    Expect(0, 12704, '\P{^Is_Blk=kanbun}', "");
    Expect(1, 12703, '\p{Is_Blk=	KANBUN}', "");
    Expect(0, 12703, '\p{^Is_Blk=	KANBUN}', "");
    Expect(0, 12703, '\P{Is_Blk=	KANBUN}', "");
    Expect(1, 12703, '\P{^Is_Blk=	KANBUN}', "");
    Expect(0, 12704, '\p{Is_Blk=	KANBUN}', "");
    Expect(1, 12704, '\p{^Is_Blk=	KANBUN}', "");
    Expect(1, 12704, '\P{Is_Blk=	KANBUN}', "");
    Expect(0, 12704, '\P{^Is_Blk=	KANBUN}', "");
    Error('\p{Block= :=kangxi_Radicals}');
    Error('\P{Block= :=kangxi_Radicals}');
    Expect(1, 12255, '\p{Block:kangxiradicals}', "");
    Expect(0, 12255, '\p{^Block:kangxiradicals}', "");
    Expect(0, 12255, '\P{Block:kangxiradicals}', "");
    Expect(1, 12255, '\P{^Block:kangxiradicals}', "");
    Expect(0, 12256, '\p{Block:kangxiradicals}', "");
    Expect(1, 12256, '\p{^Block:kangxiradicals}', "");
    Expect(1, 12256, '\P{Block:kangxiradicals}', "");
    Expect(0, 12256, '\P{^Block:kangxiradicals}', "");
    Expect(1, 12255, '\p{Block:	-Kangxi_Radicals}', "");
    Expect(0, 12255, '\p{^Block:	-Kangxi_Radicals}', "");
    Expect(0, 12255, '\P{Block:	-Kangxi_Radicals}', "");
    Expect(1, 12255, '\P{^Block:	-Kangxi_Radicals}', "");
    Expect(0, 12256, '\p{Block:	-Kangxi_Radicals}', "");
    Expect(1, 12256, '\p{^Block:	-Kangxi_Radicals}', "");
    Expect(1, 12256, '\P{Block:	-Kangxi_Radicals}', "");
    Expect(0, 12256, '\P{^Block:	-Kangxi_Radicals}', "");
    Error('\p{Blk=:= -kangxi}');
    Error('\P{Blk=:= -kangxi}');
    Expect(1, 12255, '\p{Blk=kangxi}', "");
    Expect(0, 12255, '\p{^Blk=kangxi}', "");
    Expect(0, 12255, '\P{Blk=kangxi}', "");
    Expect(1, 12255, '\P{^Blk=kangxi}', "");
    Expect(0, 12256, '\p{Blk=kangxi}', "");
    Expect(1, 12256, '\p{^Blk=kangxi}', "");
    Expect(1, 12256, '\P{Blk=kangxi}', "");
    Expect(0, 12256, '\P{^Blk=kangxi}', "");
    Expect(1, 12255, '\p{Blk= 	Kangxi}', "");
    Expect(0, 12255, '\p{^Blk= 	Kangxi}', "");
    Expect(0, 12255, '\P{Blk= 	Kangxi}', "");
    Expect(1, 12255, '\P{^Blk= 	Kangxi}', "");
    Expect(0, 12256, '\p{Blk= 	Kangxi}', "");
    Expect(1, 12256, '\p{^Blk= 	Kangxi}', "");
    Expect(1, 12256, '\P{Blk= 	Kangxi}', "");
    Expect(0, 12256, '\P{^Blk= 	Kangxi}', "");
    Error('\p{Is_Block:   :=	KANGXI_Radicals}');
    Error('\P{Is_Block:   :=	KANGXI_Radicals}');
    Expect(1, 12255, '\p{Is_Block=kangxiradicals}', "");
    Expect(0, 12255, '\p{^Is_Block=kangxiradicals}', "");
    Expect(0, 12255, '\P{Is_Block=kangxiradicals}', "");
    Expect(1, 12255, '\P{^Is_Block=kangxiradicals}', "");
    Expect(0, 12256, '\p{Is_Block=kangxiradicals}', "");
    Expect(1, 12256, '\p{^Is_Block=kangxiradicals}', "");
    Expect(1, 12256, '\P{Is_Block=kangxiradicals}', "");
    Expect(0, 12256, '\P{^Is_Block=kangxiradicals}', "");
    Expect(1, 12255, '\p{Is_Block=- KANGXI_radicals}', "");
    Expect(0, 12255, '\p{^Is_Block=- KANGXI_radicals}', "");
    Expect(0, 12255, '\P{Is_Block=- KANGXI_radicals}', "");
    Expect(1, 12255, '\P{^Is_Block=- KANGXI_radicals}', "");
    Expect(0, 12256, '\p{Is_Block=- KANGXI_radicals}', "");
    Expect(1, 12256, '\p{^Is_Block=- KANGXI_radicals}', "");
    Expect(1, 12256, '\P{Is_Block=- KANGXI_radicals}', "");
    Expect(0, 12256, '\P{^Is_Block=- KANGXI_radicals}', "");
    Error('\p{Is_Blk=:=-	kangxi}');
    Error('\P{Is_Blk=:=-	kangxi}');
    Expect(1, 12255, '\p{Is_Blk=kangxi}', "");
    Expect(0, 12255, '\p{^Is_Blk=kangxi}', "");
    Expect(0, 12255, '\P{Is_Blk=kangxi}', "");
    Expect(1, 12255, '\P{^Is_Blk=kangxi}', "");
    Expect(0, 12256, '\p{Is_Blk=kangxi}', "");
    Expect(1, 12256, '\p{^Is_Blk=kangxi}', "");
    Expect(1, 12256, '\P{Is_Blk=kangxi}', "");
    Expect(0, 12256, '\P{^Is_Blk=kangxi}', "");
    Expect(1, 12255, '\p{Is_Blk= _Kangxi}', "");
    Expect(0, 12255, '\p{^Is_Blk= _Kangxi}', "");
    Expect(0, 12255, '\P{Is_Blk= _Kangxi}', "");
    Expect(1, 12255, '\P{^Is_Blk= _Kangxi}', "");
    Expect(0, 12256, '\p{Is_Blk= _Kangxi}', "");
    Expect(1, 12256, '\p{^Is_Blk= _Kangxi}', "");
    Expect(1, 12256, '\P{Is_Blk= _Kangxi}', "");
    Expect(0, 12256, '\P{^Is_Blk= _Kangxi}', "");
    Error('\p{Block: Kannada:=}');
    Error('\P{Block: Kannada:=}');
    Expect(1, 3327, '\p{Block=kannada}', "");
    Expect(0, 3327, '\p{^Block=kannada}', "");
    Expect(0, 3327, '\P{Block=kannada}', "");
    Expect(1, 3327, '\P{^Block=kannada}', "");
    Expect(0, 3328, '\p{Block=kannada}', "");
    Expect(1, 3328, '\p{^Block=kannada}', "");
    Expect(1, 3328, '\P{Block=kannada}', "");
    Expect(0, 3328, '\P{^Block=kannada}', "");
    Expect(1, 3327, '\p{Block:-KANNADA}', "");
    Expect(0, 3327, '\p{^Block:-KANNADA}', "");
    Expect(0, 3327, '\P{Block:-KANNADA}', "");
    Expect(1, 3327, '\P{^Block:-KANNADA}', "");
    Expect(0, 3328, '\p{Block:-KANNADA}', "");
    Expect(1, 3328, '\p{^Block:-KANNADA}', "");
    Expect(1, 3328, '\P{Block:-KANNADA}', "");
    Expect(0, 3328, '\P{^Block:-KANNADA}', "");
    Error('\p{Blk= :=Kannada}');
    Error('\P{Blk= :=Kannada}');
    Expect(1, 3327, '\p{Blk=kannada}', "");
    Expect(0, 3327, '\p{^Blk=kannada}', "");
    Expect(0, 3327, '\P{Blk=kannada}', "");
    Expect(1, 3327, '\P{^Blk=kannada}', "");
    Expect(0, 3328, '\p{Blk=kannada}', "");
    Expect(1, 3328, '\p{^Blk=kannada}', "");
    Expect(1, 3328, '\P{Blk=kannada}', "");
    Expect(0, 3328, '\P{^Blk=kannada}', "");
    Expect(1, 3327, '\p{Blk= _Kannada}', "");
    Expect(0, 3327, '\p{^Blk= _Kannada}', "");
    Expect(0, 3327, '\P{Blk= _Kannada}', "");
    Expect(1, 3327, '\P{^Blk= _Kannada}', "");
    Expect(0, 3328, '\p{Blk= _Kannada}', "");
    Expect(1, 3328, '\p{^Blk= _Kannada}', "");
    Expect(1, 3328, '\P{Blk= _Kannada}', "");
    Expect(0, 3328, '\P{^Blk= _Kannada}', "");
    Error('\p{Is_Block=_kannada/a/}');
    Error('\P{Is_Block=_kannada/a/}');
    Expect(1, 3327, '\p{Is_Block=kannada}', "");
    Expect(0, 3327, '\p{^Is_Block=kannada}', "");
    Expect(0, 3327, '\P{Is_Block=kannada}', "");
    Expect(1, 3327, '\P{^Is_Block=kannada}', "");
    Expect(0, 3328, '\p{Is_Block=kannada}', "");
    Expect(1, 3328, '\p{^Is_Block=kannada}', "");
    Expect(1, 3328, '\P{Is_Block=kannada}', "");
    Expect(0, 3328, '\P{^Is_Block=kannada}', "");
    Expect(1, 3327, '\p{Is_Block=-KANNADA}', "");
    Expect(0, 3327, '\p{^Is_Block=-KANNADA}', "");
    Expect(0, 3327, '\P{Is_Block=-KANNADA}', "");
    Expect(1, 3327, '\P{^Is_Block=-KANNADA}', "");
    Expect(0, 3328, '\p{Is_Block=-KANNADA}', "");
    Expect(1, 3328, '\p{^Is_Block=-KANNADA}', "");
    Expect(1, 3328, '\P{Is_Block=-KANNADA}', "");
    Expect(0, 3328, '\P{^Is_Block=-KANNADA}', "");
    Error('\p{Is_Blk=/a/-KANNADA}');
    Error('\P{Is_Blk=/a/-KANNADA}');
    Expect(1, 3327, '\p{Is_Blk=kannada}', "");
    Expect(0, 3327, '\p{^Is_Blk=kannada}', "");
    Expect(0, 3327, '\P{Is_Blk=kannada}', "");
    Expect(1, 3327, '\P{^Is_Blk=kannada}', "");
    Expect(0, 3328, '\p{Is_Blk=kannada}', "");
    Expect(1, 3328, '\p{^Is_Blk=kannada}', "");
    Expect(1, 3328, '\P{Is_Blk=kannada}', "");
    Expect(0, 3328, '\P{^Is_Blk=kannada}', "");
    Expect(1, 3327, '\p{Is_Blk=		Kannada}', "");
    Expect(0, 3327, '\p{^Is_Blk=		Kannada}', "");
    Expect(0, 3327, '\P{Is_Blk=		Kannada}', "");
    Expect(1, 3327, '\P{^Is_Blk=		Kannada}', "");
    Expect(0, 3328, '\p{Is_Blk=		Kannada}', "");
    Expect(1, 3328, '\p{^Is_Blk=		Kannada}', "");
    Expect(1, 3328, '\P{Is_Blk=		Kannada}', "");
    Expect(0, 3328, '\P{^Is_Blk=		Kannada}', "");
    Error('\p{Block:	 /a/Katakana}');
    Error('\P{Block:	 /a/Katakana}');
    Expect(1, 12543, '\p{Block:	katakana}', "");
    Expect(0, 12543, '\p{^Block:	katakana}', "");
    Expect(0, 12543, '\P{Block:	katakana}', "");
    Expect(1, 12543, '\P{^Block:	katakana}', "");
    Expect(0, 12544, '\p{Block:	katakana}', "");
    Expect(1, 12544, '\p{^Block:	katakana}', "");
    Expect(1, 12544, '\P{Block:	katakana}', "");
    Expect(0, 12544, '\P{^Block:	katakana}', "");
    Expect(1, 12543, '\p{Block=		KATAKANA}', "");
    Expect(0, 12543, '\p{^Block=		KATAKANA}', "");
    Expect(0, 12543, '\P{Block=		KATAKANA}', "");
    Expect(1, 12543, '\P{^Block=		KATAKANA}', "");
    Expect(0, 12544, '\p{Block=		KATAKANA}', "");
    Expect(1, 12544, '\p{^Block=		KATAKANA}', "");
    Expect(1, 12544, '\P{Block=		KATAKANA}', "");
    Expect(0, 12544, '\P{^Block=		KATAKANA}', "");
    Error('\p{Blk=:=KATAKANA}');
    Error('\P{Blk=:=KATAKANA}');
    Expect(1, 12543, '\p{Blk=katakana}', "");
    Expect(0, 12543, '\p{^Blk=katakana}', "");
    Expect(0, 12543, '\P{Blk=katakana}', "");
    Expect(1, 12543, '\P{^Blk=katakana}', "");
    Expect(0, 12544, '\p{Blk=katakana}', "");
    Expect(1, 12544, '\p{^Blk=katakana}', "");
    Expect(1, 12544, '\P{Blk=katakana}', "");
    Expect(0, 12544, '\P{^Blk=katakana}', "");
    Expect(1, 12543, '\p{Blk=		KATAKANA}', "");
    Expect(0, 12543, '\p{^Blk=		KATAKANA}', "");
    Expect(0, 12543, '\P{Blk=		KATAKANA}', "");
    Expect(1, 12543, '\P{^Blk=		KATAKANA}', "");
    Expect(0, 12544, '\p{Blk=		KATAKANA}', "");
    Expect(1, 12544, '\p{^Blk=		KATAKANA}', "");
    Expect(1, 12544, '\P{Blk=		KATAKANA}', "");
    Expect(0, 12544, '\P{^Blk=		KATAKANA}', "");
    Error('\p{Is_Block=--KATAKANA:=}');
    Error('\P{Is_Block=--KATAKANA:=}');
    Expect(1, 12543, '\p{Is_Block=katakana}', "");
    Expect(0, 12543, '\p{^Is_Block=katakana}', "");
    Expect(0, 12543, '\P{Is_Block=katakana}', "");
    Expect(1, 12543, '\P{^Is_Block=katakana}', "");
    Expect(0, 12544, '\p{Is_Block=katakana}', "");
    Expect(1, 12544, '\p{^Is_Block=katakana}', "");
    Expect(1, 12544, '\P{Is_Block=katakana}', "");
    Expect(0, 12544, '\P{^Is_Block=katakana}', "");
    Expect(1, 12543, '\p{Is_Block:   	katakana}', "");
    Expect(0, 12543, '\p{^Is_Block:   	katakana}', "");
    Expect(0, 12543, '\P{Is_Block:   	katakana}', "");
    Expect(1, 12543, '\P{^Is_Block:   	katakana}', "");
    Expect(0, 12544, '\p{Is_Block:   	katakana}', "");
    Expect(1, 12544, '\p{^Is_Block:   	katakana}', "");
    Expect(1, 12544, '\P{Is_Block:   	katakana}', "");
    Expect(0, 12544, '\P{^Is_Block:   	katakana}', "");
    Error('\p{Is_Blk:-	KATAKANA:=}');
    Error('\P{Is_Blk:-	KATAKANA:=}');
    Expect(1, 12543, '\p{Is_Blk=katakana}', "");
    Expect(0, 12543, '\p{^Is_Blk=katakana}', "");
    Expect(0, 12543, '\P{Is_Blk=katakana}', "");
    Expect(1, 12543, '\P{^Is_Blk=katakana}', "");
    Expect(0, 12544, '\p{Is_Blk=katakana}', "");
    Expect(1, 12544, '\p{^Is_Blk=katakana}', "");
    Expect(1, 12544, '\P{Is_Blk=katakana}', "");
    Expect(0, 12544, '\P{^Is_Blk=katakana}', "");
    Expect(1, 12543, '\p{Is_Blk=		Katakana}', "");
    Expect(0, 12543, '\p{^Is_Blk=		Katakana}', "");
    Expect(0, 12543, '\P{Is_Blk=		Katakana}', "");
    Expect(1, 12543, '\P{^Is_Blk=		Katakana}', "");
    Expect(0, 12544, '\p{Is_Blk=		Katakana}', "");
    Expect(1, 12544, '\p{^Is_Blk=		Katakana}', "");
    Expect(1, 12544, '\P{Is_Blk=		Katakana}', "");
    Expect(0, 12544, '\P{^Is_Blk=		Katakana}', "");
    Error('\p{Block=KATAKANA_PHONETIC_EXTENSIONS:=}');
    Error('\P{Block=KATAKANA_PHONETIC_EXTENSIONS:=}');
    Expect(1, 12799, '\p{Block=katakanaphoneticextensions}', "");
    Expect(0, 12799, '\p{^Block=katakanaphoneticextensions}', "");
    Expect(0, 12799, '\P{Block=katakanaphoneticextensions}', "");
    Expect(1, 12799, '\P{^Block=katakanaphoneticextensions}', "");
    Expect(0, 12800, '\p{Block=katakanaphoneticextensions}', "");
    Expect(1, 12800, '\p{^Block=katakanaphoneticextensions}', "");
    Expect(1, 12800, '\P{Block=katakanaphoneticextensions}', "");
    Expect(0, 12800, '\P{^Block=katakanaphoneticextensions}', "");
    Expect(1, 12799, '\p{Block=_-Katakana_PHONETIC_Extensions}', "");
    Expect(0, 12799, '\p{^Block=_-Katakana_PHONETIC_Extensions}', "");
    Expect(0, 12799, '\P{Block=_-Katakana_PHONETIC_Extensions}', "");
    Expect(1, 12799, '\P{^Block=_-Katakana_PHONETIC_Extensions}', "");
    Expect(0, 12800, '\p{Block=_-Katakana_PHONETIC_Extensions}', "");
    Expect(1, 12800, '\p{^Block=_-Katakana_PHONETIC_Extensions}', "");
    Expect(1, 12800, '\P{Block=_-Katakana_PHONETIC_Extensions}', "");
    Expect(0, 12800, '\P{^Block=_-Katakana_PHONETIC_Extensions}', "");
    Error('\p{Blk=_	katakana_Ext:=}');
    Error('\P{Blk=_	katakana_Ext:=}');
    Expect(1, 12799, '\p{Blk=katakanaext}', "");
    Expect(0, 12799, '\p{^Blk=katakanaext}', "");
    Expect(0, 12799, '\P{Blk=katakanaext}', "");
    Expect(1, 12799, '\P{^Blk=katakanaext}', "");
    Expect(0, 12800, '\p{Blk=katakanaext}', "");
    Expect(1, 12800, '\p{^Blk=katakanaext}', "");
    Expect(1, 12800, '\P{Blk=katakanaext}', "");
    Expect(0, 12800, '\P{^Blk=katakanaext}', "");
    Expect(1, 12799, '\p{Blk:    katakana_Ext}', "");
    Expect(0, 12799, '\p{^Blk:    katakana_Ext}', "");
    Expect(0, 12799, '\P{Blk:    katakana_Ext}', "");
    Expect(1, 12799, '\P{^Blk:    katakana_Ext}', "");
    Expect(0, 12800, '\p{Blk:    katakana_Ext}', "");
    Expect(1, 12800, '\p{^Blk:    katakana_Ext}', "");
    Expect(1, 12800, '\P{Blk:    katakana_Ext}', "");
    Expect(0, 12800, '\P{^Blk:    katakana_Ext}', "");
    Error('\p{Is_Block=	KATAKANA_Phonetic_Extensions/a/}');
    Error('\P{Is_Block=	KATAKANA_Phonetic_Extensions/a/}');
    Expect(1, 12799, '\p{Is_Block=katakanaphoneticextensions}', "");
    Expect(0, 12799, '\p{^Is_Block=katakanaphoneticextensions}', "");
    Expect(0, 12799, '\P{Is_Block=katakanaphoneticextensions}', "");
    Expect(1, 12799, '\P{^Is_Block=katakanaphoneticextensions}', "");
    Expect(0, 12800, '\p{Is_Block=katakanaphoneticextensions}', "");
    Expect(1, 12800, '\p{^Is_Block=katakanaphoneticextensions}', "");
    Expect(1, 12800, '\P{Is_Block=katakanaphoneticextensions}', "");
    Expect(0, 12800, '\P{^Is_Block=katakanaphoneticextensions}', "");
    Expect(1, 12799, '\p{Is_Block= Katakana_Phonetic_Extensions}', "");
    Expect(0, 12799, '\p{^Is_Block= Katakana_Phonetic_Extensions}', "");
    Expect(0, 12799, '\P{Is_Block= Katakana_Phonetic_Extensions}', "");
    Expect(1, 12799, '\P{^Is_Block= Katakana_Phonetic_Extensions}', "");
    Expect(0, 12800, '\p{Is_Block= Katakana_Phonetic_Extensions}', "");
    Expect(1, 12800, '\p{^Is_Block= Katakana_Phonetic_Extensions}', "");
    Expect(1, 12800, '\P{Is_Block= Katakana_Phonetic_Extensions}', "");
    Expect(0, 12800, '\P{^Is_Block= Katakana_Phonetic_Extensions}', "");
    Error('\p{Is_Blk=/a/_KATAKANA_Ext}');
    Error('\P{Is_Blk=/a/_KATAKANA_Ext}');
    Expect(1, 12799, '\p{Is_Blk=katakanaext}', "");
    Expect(0, 12799, '\p{^Is_Blk=katakanaext}', "");
    Expect(0, 12799, '\P{Is_Blk=katakanaext}', "");
    Expect(1, 12799, '\P{^Is_Blk=katakanaext}', "");
    Expect(0, 12800, '\p{Is_Blk=katakanaext}', "");
    Expect(1, 12800, '\p{^Is_Blk=katakanaext}', "");
    Expect(1, 12800, '\P{Is_Blk=katakanaext}', "");
    Expect(0, 12800, '\P{^Is_Blk=katakanaext}', "");
    Expect(1, 12799, '\p{Is_Blk=	katakana_ext}', "");
    Expect(0, 12799, '\p{^Is_Blk=	katakana_ext}', "");
    Expect(0, 12799, '\P{Is_Blk=	katakana_ext}', "");
    Expect(1, 12799, '\P{^Is_Blk=	katakana_ext}', "");
    Expect(0, 12800, '\p{Is_Blk=	katakana_ext}', "");
    Expect(1, 12800, '\p{^Is_Blk=	katakana_ext}', "");
    Expect(1, 12800, '\P{Is_Blk=	katakana_ext}', "");
    Expect(0, 12800, '\P{^Is_Blk=	katakana_ext}', "");
    Error('\p{Block=/a/--kayah_li}');
    Error('\P{Block=/a/--kayah_li}');
    Expect(1, 43311, '\p{Block=kayahli}', "");
    Expect(0, 43311, '\p{^Block=kayahli}', "");
    Expect(0, 43311, '\P{Block=kayahli}', "");
    Expect(1, 43311, '\P{^Block=kayahli}', "");
    Expect(0, 43312, '\p{Block=kayahli}', "");
    Expect(1, 43312, '\p{^Block=kayahli}', "");
    Expect(1, 43312, '\P{Block=kayahli}', "");
    Expect(0, 43312, '\P{^Block=kayahli}', "");
    Expect(1, 43311, '\p{Block= Kayah_LI}', "");
    Expect(0, 43311, '\p{^Block= Kayah_LI}', "");
    Expect(0, 43311, '\P{Block= Kayah_LI}', "");
    Expect(1, 43311, '\P{^Block= Kayah_LI}', "");
    Expect(0, 43312, '\p{Block= Kayah_LI}', "");
    Expect(1, 43312, '\p{^Block= Kayah_LI}', "");
    Expect(1, 43312, '\P{Block= Kayah_LI}', "");
    Expect(0, 43312, '\P{^Block= Kayah_LI}', "");
    Error('\p{Blk=:= 	KAYAH_li}');
    Error('\P{Blk=:= 	KAYAH_li}');
    Expect(1, 43311, '\p{Blk=kayahli}', "");
    Expect(0, 43311, '\p{^Blk=kayahli}', "");
    Expect(0, 43311, '\P{Blk=kayahli}', "");
    Expect(1, 43311, '\P{^Blk=kayahli}', "");
    Expect(0, 43312, '\p{Blk=kayahli}', "");
    Expect(1, 43312, '\p{^Blk=kayahli}', "");
    Expect(1, 43312, '\P{Blk=kayahli}', "");
    Expect(0, 43312, '\P{^Blk=kayahli}', "");
    Expect(1, 43311, '\p{Blk=		KAYAH_LI}', "");
    Expect(0, 43311, '\p{^Blk=		KAYAH_LI}', "");
    Expect(0, 43311, '\P{Blk=		KAYAH_LI}', "");
    Expect(1, 43311, '\P{^Blk=		KAYAH_LI}', "");
    Expect(0, 43312, '\p{Blk=		KAYAH_LI}', "");
    Expect(1, 43312, '\p{^Blk=		KAYAH_LI}', "");
    Expect(1, 43312, '\P{Blk=		KAYAH_LI}', "");
    Expect(0, 43312, '\P{^Blk=		KAYAH_LI}', "");
    Error('\p{Is_Block=:=_-Kayah_LI}');
    Error('\P{Is_Block=:=_-Kayah_LI}');
    Expect(1, 43311, '\p{Is_Block=kayahli}', "");
    Expect(0, 43311, '\p{^Is_Block=kayahli}', "");
    Expect(0, 43311, '\P{Is_Block=kayahli}', "");
    Expect(1, 43311, '\P{^Is_Block=kayahli}', "");
    Expect(0, 43312, '\p{Is_Block=kayahli}', "");
    Expect(1, 43312, '\p{^Is_Block=kayahli}', "");
    Expect(1, 43312, '\P{Is_Block=kayahli}', "");
    Expect(0, 43312, '\P{^Is_Block=kayahli}', "");
    Expect(1, 43311, '\p{Is_Block=	kayah_li}', "");
    Expect(0, 43311, '\p{^Is_Block=	kayah_li}', "");
    Expect(0, 43311, '\P{Is_Block=	kayah_li}', "");
    Expect(1, 43311, '\P{^Is_Block=	kayah_li}', "");
    Expect(0, 43312, '\p{Is_Block=	kayah_li}', "");
    Expect(1, 43312, '\p{^Is_Block=	kayah_li}', "");
    Expect(1, 43312, '\P{Is_Block=	kayah_li}', "");
    Expect(0, 43312, '\P{^Is_Block=	kayah_li}', "");
    Error('\p{Is_Blk:   :=_-Kayah_LI}');
    Error('\P{Is_Blk:   :=_-Kayah_LI}');
    Expect(1, 43311, '\p{Is_Blk=kayahli}', "");
    Expect(0, 43311, '\p{^Is_Blk=kayahli}', "");
    Expect(0, 43311, '\P{Is_Blk=kayahli}', "");
    Expect(1, 43311, '\P{^Is_Blk=kayahli}', "");
    Expect(0, 43312, '\p{Is_Blk=kayahli}', "");
    Expect(1, 43312, '\p{^Is_Blk=kayahli}', "");
    Expect(1, 43312, '\P{Is_Blk=kayahli}', "");
    Expect(0, 43312, '\P{^Is_Blk=kayahli}', "");
    Expect(1, 43311, '\p{Is_Blk=_ kayah_Li}', "");
    Expect(0, 43311, '\p{^Is_Blk=_ kayah_Li}', "");
    Expect(0, 43311, '\P{Is_Blk=_ kayah_Li}', "");
    Expect(1, 43311, '\P{^Is_Blk=_ kayah_Li}', "");
    Expect(0, 43312, '\p{Is_Blk=_ kayah_Li}', "");
    Expect(1, 43312, '\p{^Is_Blk=_ kayah_Li}', "");
    Expect(1, 43312, '\P{Is_Blk=_ kayah_Li}', "");
    Expect(0, 43312, '\P{^Is_Blk=_ kayah_Li}', "");
    Error('\p{Block=Kharoshthi:=}');
    Error('\P{Block=Kharoshthi:=}');
    Expect(1, 68191, '\p{Block=kharoshthi}', "");
    Expect(0, 68191, '\p{^Block=kharoshthi}', "");
    Expect(0, 68191, '\P{Block=kharoshthi}', "");
    Expect(1, 68191, '\P{^Block=kharoshthi}', "");
    Expect(0, 68192, '\p{Block=kharoshthi}', "");
    Expect(1, 68192, '\p{^Block=kharoshthi}', "");
    Expect(1, 68192, '\P{Block=kharoshthi}', "");
    Expect(0, 68192, '\P{^Block=kharoshthi}', "");
    Expect(1, 68191, '\p{Block=		Kharoshthi}', "");
    Expect(0, 68191, '\p{^Block=		Kharoshthi}', "");
    Expect(0, 68191, '\P{Block=		Kharoshthi}', "");
    Expect(1, 68191, '\P{^Block=		Kharoshthi}', "");
    Expect(0, 68192, '\p{Block=		Kharoshthi}', "");
    Expect(1, 68192, '\p{^Block=		Kharoshthi}', "");
    Expect(1, 68192, '\P{Block=		Kharoshthi}', "");
    Expect(0, 68192, '\P{^Block=		Kharoshthi}', "");
    Error('\p{Blk:	:=	_KHAROSHTHI}');
    Error('\P{Blk:	:=	_KHAROSHTHI}');
    Expect(1, 68191, '\p{Blk=kharoshthi}', "");
    Expect(0, 68191, '\p{^Blk=kharoshthi}', "");
    Expect(0, 68191, '\P{Blk=kharoshthi}', "");
    Expect(1, 68191, '\P{^Blk=kharoshthi}', "");
    Expect(0, 68192, '\p{Blk=kharoshthi}', "");
    Expect(1, 68192, '\p{^Blk=kharoshthi}', "");
    Expect(1, 68192, '\P{Blk=kharoshthi}', "");
    Expect(0, 68192, '\P{^Blk=kharoshthi}', "");
    Expect(1, 68191, '\p{Blk= kharoshthi}', "");
    Expect(0, 68191, '\p{^Blk= kharoshthi}', "");
    Expect(0, 68191, '\P{Blk= kharoshthi}', "");
    Expect(1, 68191, '\P{^Blk= kharoshthi}', "");
    Expect(0, 68192, '\p{Blk= kharoshthi}', "");
    Expect(1, 68192, '\p{^Blk= kharoshthi}', "");
    Expect(1, 68192, '\P{Blk= kharoshthi}', "");
    Expect(0, 68192, '\P{^Blk= kharoshthi}', "");
    Error('\p{Is_Block=-/a/KHAROSHTHI}');
    Error('\P{Is_Block=-/a/KHAROSHTHI}');
    Expect(1, 68191, '\p{Is_Block=kharoshthi}', "");
    Expect(0, 68191, '\p{^Is_Block=kharoshthi}', "");
    Expect(0, 68191, '\P{Is_Block=kharoshthi}', "");
    Expect(1, 68191, '\P{^Is_Block=kharoshthi}', "");
    Expect(0, 68192, '\p{Is_Block=kharoshthi}', "");
    Expect(1, 68192, '\p{^Is_Block=kharoshthi}', "");
    Expect(1, 68192, '\P{Is_Block=kharoshthi}', "");
    Expect(0, 68192, '\P{^Is_Block=kharoshthi}', "");
    Expect(1, 68191, '\p{Is_Block:  Kharoshthi}', "");
    Expect(0, 68191, '\p{^Is_Block:  Kharoshthi}', "");
    Expect(0, 68191, '\P{Is_Block:  Kharoshthi}', "");
    Expect(1, 68191, '\P{^Is_Block:  Kharoshthi}', "");
    Expect(0, 68192, '\p{Is_Block:  Kharoshthi}', "");
    Expect(1, 68192, '\p{^Is_Block:  Kharoshthi}', "");
    Expect(1, 68192, '\P{Is_Block:  Kharoshthi}', "");
    Expect(0, 68192, '\P{^Is_Block:  Kharoshthi}', "");
    Error('\p{Is_Blk= /a/kharoshthi}');
    Error('\P{Is_Blk= /a/kharoshthi}');
    Expect(1, 68191, '\p{Is_Blk=kharoshthi}', "");
    Expect(0, 68191, '\p{^Is_Blk=kharoshthi}', "");
    Expect(0, 68191, '\P{Is_Blk=kharoshthi}', "");
    Expect(1, 68191, '\P{^Is_Blk=kharoshthi}', "");
    Expect(0, 68192, '\p{Is_Blk=kharoshthi}', "");
    Expect(1, 68192, '\p{^Is_Blk=kharoshthi}', "");
    Expect(1, 68192, '\P{Is_Blk=kharoshthi}', "");
    Expect(0, 68192, '\P{^Is_Blk=kharoshthi}', "");
    Expect(1, 68191, '\p{Is_Blk=  KHAROSHTHI}', "");
    Expect(0, 68191, '\p{^Is_Blk=  KHAROSHTHI}', "");
    Expect(0, 68191, '\P{Is_Blk=  KHAROSHTHI}', "");
    Expect(1, 68191, '\P{^Is_Blk=  KHAROSHTHI}', "");
    Expect(0, 68192, '\p{Is_Blk=  KHAROSHTHI}', "");
    Expect(1, 68192, '\p{^Is_Blk=  KHAROSHTHI}', "");
    Expect(1, 68192, '\P{Is_Blk=  KHAROSHTHI}', "");
    Expect(0, 68192, '\P{^Is_Blk=  KHAROSHTHI}', "");
    Error('\p{Block= :=KHMER}');
    Error('\P{Block= :=KHMER}');
    Expect(1, 6143, '\p{Block=khmer}', "");
    Expect(0, 6143, '\p{^Block=khmer}', "");
    Expect(0, 6143, '\P{Block=khmer}', "");
    Expect(1, 6143, '\P{^Block=khmer}', "");
    Expect(0, 6144, '\p{Block=khmer}', "");
    Expect(1, 6144, '\p{^Block=khmer}', "");
    Expect(1, 6144, '\P{Block=khmer}', "");
    Expect(0, 6144, '\P{^Block=khmer}', "");
    Expect(1, 6143, '\p{Block= KHMER}', "");
    Expect(0, 6143, '\p{^Block= KHMER}', "");
    Expect(0, 6143, '\P{Block= KHMER}', "");
    Expect(1, 6143, '\P{^Block= KHMER}', "");
    Expect(0, 6144, '\p{Block= KHMER}', "");
    Expect(1, 6144, '\p{^Block= KHMER}', "");
    Expect(1, 6144, '\P{Block= KHMER}', "");
    Expect(0, 6144, '\P{^Block= KHMER}', "");
    Error('\p{Blk=_:=khmer}');
    Error('\P{Blk=_:=khmer}');
    Expect(1, 6143, '\p{Blk=khmer}', "");
    Expect(0, 6143, '\p{^Blk=khmer}', "");
    Expect(0, 6143, '\P{Blk=khmer}', "");
    Expect(1, 6143, '\P{^Blk=khmer}', "");
    Expect(0, 6144, '\p{Blk=khmer}', "");
    Expect(1, 6144, '\p{^Blk=khmer}', "");
    Expect(1, 6144, '\P{Blk=khmer}', "");
    Expect(0, 6144, '\P{^Blk=khmer}', "");
    Expect(1, 6143, '\p{Blk=_Khmer}', "");
    Expect(0, 6143, '\p{^Blk=_Khmer}', "");
    Expect(0, 6143, '\P{Blk=_Khmer}', "");
    Expect(1, 6143, '\P{^Blk=_Khmer}', "");
    Expect(0, 6144, '\p{Blk=_Khmer}', "");
    Expect(1, 6144, '\p{^Blk=_Khmer}', "");
    Expect(1, 6144, '\P{Blk=_Khmer}', "");
    Expect(0, 6144, '\P{^Blk=_Khmer}', "");
    Error('\p{Is_Block= _KHMER/a/}');
    Error('\P{Is_Block= _KHMER/a/}');
    Expect(1, 6143, '\p{Is_Block=khmer}', "");
    Expect(0, 6143, '\p{^Is_Block=khmer}', "");
    Expect(0, 6143, '\P{Is_Block=khmer}', "");
    Expect(1, 6143, '\P{^Is_Block=khmer}', "");
    Expect(0, 6144, '\p{Is_Block=khmer}', "");
    Expect(1, 6144, '\p{^Is_Block=khmer}', "");
    Expect(1, 6144, '\P{Is_Block=khmer}', "");
    Expect(0, 6144, '\P{^Is_Block=khmer}', "");
    Expect(1, 6143, '\p{Is_Block=	Khmer}', "");
    Expect(0, 6143, '\p{^Is_Block=	Khmer}', "");
    Expect(0, 6143, '\P{Is_Block=	Khmer}', "");
    Expect(1, 6143, '\P{^Is_Block=	Khmer}', "");
    Expect(0, 6144, '\p{Is_Block=	Khmer}', "");
    Expect(1, 6144, '\p{^Is_Block=	Khmer}', "");
    Expect(1, 6144, '\P{Is_Block=	Khmer}', "");
    Expect(0, 6144, '\P{^Is_Block=	Khmer}', "");
    Error('\p{Is_Blk= Khmer/a/}');
    Error('\P{Is_Blk= Khmer/a/}');
    Expect(1, 6143, '\p{Is_Blk=khmer}', "");
    Expect(0, 6143, '\p{^Is_Blk=khmer}', "");
    Expect(0, 6143, '\P{Is_Blk=khmer}', "");
    Expect(1, 6143, '\P{^Is_Blk=khmer}', "");
    Expect(0, 6144, '\p{Is_Blk=khmer}', "");
    Expect(1, 6144, '\p{^Is_Blk=khmer}', "");
    Expect(1, 6144, '\P{Is_Blk=khmer}', "");
    Expect(0, 6144, '\P{^Is_Blk=khmer}', "");
    Expect(1, 6143, '\p{Is_Blk= 	Khmer}', "");
    Expect(0, 6143, '\p{^Is_Blk= 	Khmer}', "");
    Expect(0, 6143, '\P{Is_Blk= 	Khmer}', "");
    Expect(1, 6143, '\P{^Is_Blk= 	Khmer}', "");
    Expect(0, 6144, '\p{Is_Blk= 	Khmer}', "");
    Expect(1, 6144, '\p{^Is_Blk= 	Khmer}', "");
    Expect(1, 6144, '\P{Is_Blk= 	Khmer}', "");
    Expect(0, 6144, '\P{^Is_Blk= 	Khmer}', "");
    Error('\p{Block: -	khmer_Symbols:=}');
    Error('\P{Block: -	khmer_Symbols:=}');
    Expect(1, 6655, '\p{Block=khmersymbols}', "");
    Expect(0, 6655, '\p{^Block=khmersymbols}', "");
    Expect(0, 6655, '\P{Block=khmersymbols}', "");
    Expect(1, 6655, '\P{^Block=khmersymbols}', "");
    Expect(0, 6656, '\p{Block=khmersymbols}', "");
    Expect(1, 6656, '\p{^Block=khmersymbols}', "");
    Expect(1, 6656, '\P{Block=khmersymbols}', "");
    Expect(0, 6656, '\P{^Block=khmersymbols}', "");
    Expect(1, 6655, '\p{Block=	-Khmer_symbols}', "");
    Expect(0, 6655, '\p{^Block=	-Khmer_symbols}', "");
    Expect(0, 6655, '\P{Block=	-Khmer_symbols}', "");
    Expect(1, 6655, '\P{^Block=	-Khmer_symbols}', "");
    Expect(0, 6656, '\p{Block=	-Khmer_symbols}', "");
    Expect(1, 6656, '\p{^Block=	-Khmer_symbols}', "");
    Expect(1, 6656, '\P{Block=	-Khmer_symbols}', "");
    Expect(0, 6656, '\P{^Block=	-Khmer_symbols}', "");
    Error('\p{Blk:	 /a/Khmer_Symbols}');
    Error('\P{Blk:	 /a/Khmer_Symbols}');
    Expect(1, 6655, '\p{Blk=khmersymbols}', "");
    Expect(0, 6655, '\p{^Blk=khmersymbols}', "");
    Expect(0, 6655, '\P{Blk=khmersymbols}', "");
    Expect(1, 6655, '\P{^Blk=khmersymbols}', "");
    Expect(0, 6656, '\p{Blk=khmersymbols}', "");
    Expect(1, 6656, '\p{^Blk=khmersymbols}', "");
    Expect(1, 6656, '\P{Blk=khmersymbols}', "");
    Expect(0, 6656, '\P{^Blk=khmersymbols}', "");
    Expect(1, 6655, '\p{Blk=-KHMER_symbols}', "");
    Expect(0, 6655, '\p{^Blk=-KHMER_symbols}', "");
    Expect(0, 6655, '\P{Blk=-KHMER_symbols}', "");
    Expect(1, 6655, '\P{^Blk=-KHMER_symbols}', "");
    Expect(0, 6656, '\p{Blk=-KHMER_symbols}', "");
    Expect(1, 6656, '\p{^Blk=-KHMER_symbols}', "");
    Expect(1, 6656, '\P{Blk=-KHMER_symbols}', "");
    Expect(0, 6656, '\P{^Blk=-KHMER_symbols}', "");
    Error('\p{Is_Block=-:=Khmer_Symbols}');
    Error('\P{Is_Block=-:=Khmer_Symbols}');
    Expect(1, 6655, '\p{Is_Block:khmersymbols}', "");
    Expect(0, 6655, '\p{^Is_Block:khmersymbols}', "");
    Expect(0, 6655, '\P{Is_Block:khmersymbols}', "");
    Expect(1, 6655, '\P{^Is_Block:khmersymbols}', "");
    Expect(0, 6656, '\p{Is_Block:khmersymbols}', "");
    Expect(1, 6656, '\p{^Is_Block:khmersymbols}', "");
    Expect(1, 6656, '\P{Is_Block:khmersymbols}', "");
    Expect(0, 6656, '\P{^Is_Block:khmersymbols}', "");
    Expect(1, 6655, '\p{Is_Block=		khmer_symbols}', "");
    Expect(0, 6655, '\p{^Is_Block=		khmer_symbols}', "");
    Expect(0, 6655, '\P{Is_Block=		khmer_symbols}', "");
    Expect(1, 6655, '\P{^Is_Block=		khmer_symbols}', "");
    Expect(0, 6656, '\p{Is_Block=		khmer_symbols}', "");
    Expect(1, 6656, '\p{^Is_Block=		khmer_symbols}', "");
    Expect(1, 6656, '\P{Is_Block=		khmer_symbols}', "");
    Expect(0, 6656, '\P{^Is_Block=		khmer_symbols}', "");
    Error('\p{Is_Blk:		 Khmer_symbols:=}');
    Error('\P{Is_Blk:		 Khmer_symbols:=}');
    Expect(1, 6655, '\p{Is_Blk:	khmersymbols}', "");
    Expect(0, 6655, '\p{^Is_Blk:	khmersymbols}', "");
    Expect(0, 6655, '\P{Is_Blk:	khmersymbols}', "");
    Expect(1, 6655, '\P{^Is_Blk:	khmersymbols}', "");
    Expect(0, 6656, '\p{Is_Blk:	khmersymbols}', "");
    Expect(1, 6656, '\p{^Is_Blk:	khmersymbols}', "");
    Expect(1, 6656, '\P{Is_Blk:	khmersymbols}', "");
    Expect(0, 6656, '\P{^Is_Blk:	khmersymbols}', "");
    Expect(1, 6655, '\p{Is_Blk=-Khmer_SYMBOLS}', "");
    Expect(0, 6655, '\p{^Is_Blk=-Khmer_SYMBOLS}', "");
    Expect(0, 6655, '\P{Is_Blk=-Khmer_SYMBOLS}', "");
    Expect(1, 6655, '\P{^Is_Blk=-Khmer_SYMBOLS}', "");
    Expect(0, 6656, '\p{Is_Blk=-Khmer_SYMBOLS}', "");
    Expect(1, 6656, '\p{^Is_Blk=-Khmer_SYMBOLS}', "");
    Expect(1, 6656, '\P{Is_Blk=-Khmer_SYMBOLS}', "");
    Expect(0, 6656, '\P{^Is_Blk=-Khmer_SYMBOLS}', "");
    Error('\p{Block=:=_Khojki}');
    Error('\P{Block=:=_Khojki}');
    Expect(1, 70223, '\p{Block=khojki}', "");
    Expect(0, 70223, '\p{^Block=khojki}', "");
    Expect(0, 70223, '\P{Block=khojki}', "");
    Expect(1, 70223, '\P{^Block=khojki}', "");
    Expect(0, 70224, '\p{Block=khojki}', "");
    Expect(1, 70224, '\p{^Block=khojki}', "");
    Expect(1, 70224, '\P{Block=khojki}', "");
    Expect(0, 70224, '\P{^Block=khojki}', "");
    Expect(1, 70223, '\p{Block=	-khojki}', "");
    Expect(0, 70223, '\p{^Block=	-khojki}', "");
    Expect(0, 70223, '\P{Block=	-khojki}', "");
    Expect(1, 70223, '\P{^Block=	-khojki}', "");
    Expect(0, 70224, '\p{Block=	-khojki}', "");
    Expect(1, 70224, '\p{^Block=	-khojki}', "");
    Expect(1, 70224, '\P{Block=	-khojki}', "");
    Expect(0, 70224, '\P{^Block=	-khojki}', "");
    Error('\p{Blk=/a/__KHOJKI}');
    Error('\P{Blk=/a/__KHOJKI}');
    Expect(1, 70223, '\p{Blk=khojki}', "");
    Expect(0, 70223, '\p{^Blk=khojki}', "");
    Expect(0, 70223, '\P{Blk=khojki}', "");
    Expect(1, 70223, '\P{^Blk=khojki}', "");
    Expect(0, 70224, '\p{Blk=khojki}', "");
    Expect(1, 70224, '\p{^Blk=khojki}', "");
    Expect(1, 70224, '\P{Blk=khojki}', "");
    Expect(0, 70224, '\P{^Blk=khojki}', "");
    Expect(1, 70223, '\p{Blk:-Khojki}', "");
    Expect(0, 70223, '\p{^Blk:-Khojki}', "");
    Expect(0, 70223, '\P{Blk:-Khojki}', "");
    Expect(1, 70223, '\P{^Blk:-Khojki}', "");
    Expect(0, 70224, '\p{Blk:-Khojki}', "");
    Expect(1, 70224, '\p{^Blk:-Khojki}', "");
    Expect(1, 70224, '\P{Blk:-Khojki}', "");
    Expect(0, 70224, '\P{^Blk:-Khojki}', "");
    Error('\p{Is_Block=/a/_khojki}');
    Error('\P{Is_Block=/a/_khojki}');
    Expect(1, 70223, '\p{Is_Block=khojki}', "");
    Expect(0, 70223, '\p{^Is_Block=khojki}', "");
    Expect(0, 70223, '\P{Is_Block=khojki}', "");
    Expect(1, 70223, '\P{^Is_Block=khojki}', "");
    Expect(0, 70224, '\p{Is_Block=khojki}', "");
    Expect(1, 70224, '\p{^Is_Block=khojki}', "");
    Expect(1, 70224, '\P{Is_Block=khojki}', "");
    Expect(0, 70224, '\P{^Is_Block=khojki}', "");
    Expect(1, 70223, '\p{Is_Block=		KHOJKI}', "");
    Expect(0, 70223, '\p{^Is_Block=		KHOJKI}', "");
    Expect(0, 70223, '\P{Is_Block=		KHOJKI}', "");
    Expect(1, 70223, '\P{^Is_Block=		KHOJKI}', "");
    Expect(0, 70224, '\p{Is_Block=		KHOJKI}', "");
    Expect(1, 70224, '\p{^Is_Block=		KHOJKI}', "");
    Expect(1, 70224, '\P{Is_Block=		KHOJKI}', "");
    Expect(0, 70224, '\P{^Is_Block=		KHOJKI}', "");
    Error('\p{Is_Blk=:=KHOJKI}');
    Error('\P{Is_Blk=:=KHOJKI}');
    Expect(1, 70223, '\p{Is_Blk=khojki}', "");
    Expect(0, 70223, '\p{^Is_Blk=khojki}', "");
    Expect(0, 70223, '\P{Is_Blk=khojki}', "");
    Expect(1, 70223, '\P{^Is_Blk=khojki}', "");
    Expect(0, 70224, '\p{Is_Blk=khojki}', "");
    Expect(1, 70224, '\p{^Is_Blk=khojki}', "");
    Expect(1, 70224, '\P{Is_Blk=khojki}', "");
    Expect(0, 70224, '\P{^Is_Blk=khojki}', "");
    Expect(1, 70223, '\p{Is_Blk:   	 Khojki}', "");
    Expect(0, 70223, '\p{^Is_Blk:   	 Khojki}', "");
    Expect(0, 70223, '\P{Is_Blk:   	 Khojki}', "");
    Expect(1, 70223, '\P{^Is_Blk:   	 Khojki}', "");
    Expect(0, 70224, '\p{Is_Blk:   	 Khojki}', "");
    Expect(1, 70224, '\p{^Is_Blk:   	 Khojki}', "");
    Expect(1, 70224, '\P{Is_Blk:   	 Khojki}', "");
    Expect(0, 70224, '\P{^Is_Blk:   	 Khojki}', "");
    Error('\p{Block=:=_ khudawadi}');
    Error('\P{Block=:=_ khudawadi}');
    Expect(1, 70399, '\p{Block=khudawadi}', "");
    Expect(0, 70399, '\p{^Block=khudawadi}', "");
    Expect(0, 70399, '\P{Block=khudawadi}', "");
    Expect(1, 70399, '\P{^Block=khudawadi}', "");
    Expect(0, 70400, '\p{Block=khudawadi}', "");
    Expect(1, 70400, '\p{^Block=khudawadi}', "");
    Expect(1, 70400, '\P{Block=khudawadi}', "");
    Expect(0, 70400, '\P{^Block=khudawadi}', "");
    Expect(1, 70399, '\p{Block=--khudawadi}', "");
    Expect(0, 70399, '\p{^Block=--khudawadi}', "");
    Expect(0, 70399, '\P{Block=--khudawadi}', "");
    Expect(1, 70399, '\P{^Block=--khudawadi}', "");
    Expect(0, 70400, '\p{Block=--khudawadi}', "");
    Expect(1, 70400, '\p{^Block=--khudawadi}', "");
    Expect(1, 70400, '\P{Block=--khudawadi}', "");
    Expect(0, 70400, '\P{^Block=--khudawadi}', "");
    Error('\p{Blk=		Khudawadi/a/}');
    Error('\P{Blk=		Khudawadi/a/}');
    Expect(1, 70399, '\p{Blk=khudawadi}', "");
    Expect(0, 70399, '\p{^Blk=khudawadi}', "");
    Expect(0, 70399, '\P{Blk=khudawadi}', "");
    Expect(1, 70399, '\P{^Blk=khudawadi}', "");
    Expect(0, 70400, '\p{Blk=khudawadi}', "");
    Expect(1, 70400, '\p{^Blk=khudawadi}', "");
    Expect(1, 70400, '\P{Blk=khudawadi}', "");
    Expect(0, 70400, '\P{^Blk=khudawadi}', "");
    Expect(1, 70399, '\p{Blk=-KHUDAWADI}', "");
    Expect(0, 70399, '\p{^Blk=-KHUDAWADI}', "");
    Expect(0, 70399, '\P{Blk=-KHUDAWADI}', "");
    Expect(1, 70399, '\P{^Blk=-KHUDAWADI}', "");
    Expect(0, 70400, '\p{Blk=-KHUDAWADI}', "");
    Expect(1, 70400, '\p{^Blk=-KHUDAWADI}', "");
    Expect(1, 70400, '\P{Blk=-KHUDAWADI}', "");
    Expect(0, 70400, '\P{^Blk=-KHUDAWADI}', "");
    Error('\p{Is_Block=__Khudawadi/a/}');
    Error('\P{Is_Block=__Khudawadi/a/}');
    Expect(1, 70399, '\p{Is_Block=khudawadi}', "");
    Expect(0, 70399, '\p{^Is_Block=khudawadi}', "");
    Expect(0, 70399, '\P{Is_Block=khudawadi}', "");
    Expect(1, 70399, '\P{^Is_Block=khudawadi}', "");
    Expect(0, 70400, '\p{Is_Block=khudawadi}', "");
    Expect(1, 70400, '\p{^Is_Block=khudawadi}', "");
    Expect(1, 70400, '\P{Is_Block=khudawadi}', "");
    Expect(0, 70400, '\P{^Is_Block=khudawadi}', "");
    Expect(1, 70399, '\p{Is_Block=_Khudawadi}', "");
    Expect(0, 70399, '\p{^Is_Block=_Khudawadi}', "");
    Expect(0, 70399, '\P{Is_Block=_Khudawadi}', "");
    Expect(1, 70399, '\P{^Is_Block=_Khudawadi}', "");
    Expect(0, 70400, '\p{Is_Block=_Khudawadi}', "");
    Expect(1, 70400, '\p{^Is_Block=_Khudawadi}', "");
    Expect(1, 70400, '\P{Is_Block=_Khudawadi}', "");
    Expect(0, 70400, '\P{^Is_Block=_Khudawadi}', "");
    Error('\p{Is_Blk=	_KHUDAWADI:=}');
    Error('\P{Is_Blk=	_KHUDAWADI:=}');
    Expect(1, 70399, '\p{Is_Blk=khudawadi}', "");
    Expect(0, 70399, '\p{^Is_Blk=khudawadi}', "");
    Expect(0, 70399, '\P{Is_Blk=khudawadi}', "");
    Expect(1, 70399, '\P{^Is_Blk=khudawadi}', "");
    Expect(0, 70400, '\p{Is_Blk=khudawadi}', "");
    Expect(1, 70400, '\p{^Is_Blk=khudawadi}', "");
    Expect(1, 70400, '\P{Is_Blk=khudawadi}', "");
    Expect(0, 70400, '\P{^Is_Blk=khudawadi}', "");
    Expect(1, 70399, '\p{Is_Blk=- Khudawadi}', "");
    Expect(0, 70399, '\p{^Is_Blk=- Khudawadi}', "");
    Expect(0, 70399, '\P{Is_Blk=- Khudawadi}', "");
    Expect(1, 70399, '\P{^Is_Blk=- Khudawadi}', "");
    Expect(0, 70400, '\p{Is_Blk=- Khudawadi}', "");
    Expect(1, 70400, '\p{^Is_Blk=- Khudawadi}', "");
    Expect(1, 70400, '\P{Is_Blk=- Khudawadi}', "");
    Expect(0, 70400, '\P{^Is_Blk=- Khudawadi}', "");
    Error('\p{Block=	 LAO:=}');
    Error('\P{Block=	 LAO:=}');
    Expect(1, 3839, '\p{Block=lao}', "");
    Expect(0, 3839, '\p{^Block=lao}', "");
    Expect(0, 3839, '\P{Block=lao}', "");
    Expect(1, 3839, '\P{^Block=lao}', "");
    Expect(0, 3840, '\p{Block=lao}', "");
    Expect(1, 3840, '\p{^Block=lao}', "");
    Expect(1, 3840, '\P{Block=lao}', "");
    Expect(0, 3840, '\P{^Block=lao}', "");
    Expect(1, 3839, '\p{Block=	Lao}', "");
    Expect(0, 3839, '\p{^Block=	Lao}', "");
    Expect(0, 3839, '\P{Block=	Lao}', "");
    Expect(1, 3839, '\P{^Block=	Lao}', "");
    Expect(0, 3840, '\p{Block=	Lao}', "");
    Expect(1, 3840, '\p{^Block=	Lao}', "");
    Expect(1, 3840, '\P{Block=	Lao}', "");
    Expect(0, 3840, '\P{^Block=	Lao}', "");
    Error('\p{Blk=/a/Lao}');
    Error('\P{Blk=/a/Lao}');
    Expect(1, 3839, '\p{Blk:   lao}', "");
    Expect(0, 3839, '\p{^Blk:   lao}', "");
    Expect(0, 3839, '\P{Blk:   lao}', "");
    Expect(1, 3839, '\P{^Blk:   lao}', "");
    Expect(0, 3840, '\p{Blk:   lao}', "");
    Expect(1, 3840, '\p{^Blk:   lao}', "");
    Expect(1, 3840, '\P{Blk:   lao}', "");
    Expect(0, 3840, '\P{^Blk:   lao}', "");
    Expect(1, 3839, '\p{Blk= 	lao}', "");
    Expect(0, 3839, '\p{^Blk= 	lao}', "");
    Expect(0, 3839, '\P{Blk= 	lao}', "");
    Expect(1, 3839, '\P{^Blk= 	lao}', "");
    Expect(0, 3840, '\p{Blk= 	lao}', "");
    Expect(1, 3840, '\p{^Blk= 	lao}', "");
    Expect(1, 3840, '\P{Blk= 	lao}', "");
    Expect(0, 3840, '\P{^Blk= 	lao}', "");
    Error('\p{Is_Block=:=	_lao}');
    Error('\P{Is_Block=:=	_lao}');
    Expect(1, 3839, '\p{Is_Block=lao}', "");
    Expect(0, 3839, '\p{^Is_Block=lao}', "");
    Expect(0, 3839, '\P{Is_Block=lao}', "");
    Expect(1, 3839, '\P{^Is_Block=lao}', "");
    Expect(0, 3840, '\p{Is_Block=lao}', "");
    Expect(1, 3840, '\p{^Is_Block=lao}', "");
    Expect(1, 3840, '\P{Is_Block=lao}', "");
    Expect(0, 3840, '\P{^Is_Block=lao}', "");
    Expect(1, 3839, '\p{Is_Block=Lao}', "");
    Expect(0, 3839, '\p{^Is_Block=Lao}', "");
    Expect(0, 3839, '\P{Is_Block=Lao}', "");
    Expect(1, 3839, '\P{^Is_Block=Lao}', "");
    Expect(0, 3840, '\p{Is_Block=Lao}', "");
    Expect(1, 3840, '\p{^Is_Block=Lao}', "");
    Expect(1, 3840, '\P{Is_Block=Lao}', "");
    Expect(0, 3840, '\P{^Is_Block=Lao}', "");
    Error('\p{Is_Blk: --Lao/a/}');
    Error('\P{Is_Blk: --Lao/a/}');
    Expect(1, 3839, '\p{Is_Blk=lao}', "");
    Expect(0, 3839, '\p{^Is_Blk=lao}', "");
    Expect(0, 3839, '\P{Is_Blk=lao}', "");
    Expect(1, 3839, '\P{^Is_Blk=lao}', "");
    Expect(0, 3840, '\p{Is_Blk=lao}', "");
    Expect(1, 3840, '\p{^Is_Blk=lao}', "");
    Expect(1, 3840, '\P{Is_Blk=lao}', "");
    Expect(0, 3840, '\P{^Is_Blk=lao}', "");
    Expect(1, 3839, '\p{Is_Blk= 	Lao}', "");
    Expect(0, 3839, '\p{^Is_Blk= 	Lao}', "");
    Expect(0, 3839, '\P{Is_Blk= 	Lao}', "");
    Expect(1, 3839, '\P{^Is_Blk= 	Lao}', "");
    Expect(0, 3840, '\p{Is_Blk= 	Lao}', "");
    Expect(1, 3840, '\p{^Is_Blk= 	Lao}', "");
    Expect(1, 3840, '\P{Is_Blk= 	Lao}', "");
    Expect(0, 3840, '\P{^Is_Blk= 	Lao}', "");
    Error('\p{Block=-/a/Latin_1_Supplement}');
    Error('\P{Block=-/a/Latin_1_Supplement}');
    Expect(1, 255, '\p{Block=latin1supplement}', "");
    Expect(0, 255, '\p{^Block=latin1supplement}', "");
    Expect(0, 255, '\P{Block=latin1supplement}', "");
    Expect(1, 255, '\P{^Block=latin1supplement}', "");
    Expect(0, 256, '\p{Block=latin1supplement}', "");
    Expect(1, 256, '\p{^Block=latin1supplement}', "");
    Expect(1, 256, '\P{Block=latin1supplement}', "");
    Expect(0, 256, '\P{^Block=latin1supplement}', "");
    Expect(1, 255, '\p{Block=-	Latin_1_Supplement}', "");
    Expect(0, 255, '\p{^Block=-	Latin_1_Supplement}', "");
    Expect(0, 255, '\P{Block=-	Latin_1_Supplement}', "");
    Expect(1, 255, '\P{^Block=-	Latin_1_Supplement}', "");
    Expect(0, 256, '\p{Block=-	Latin_1_Supplement}', "");
    Expect(1, 256, '\p{^Block=-	Latin_1_Supplement}', "");
    Expect(1, 256, '\P{Block=-	Latin_1_Supplement}', "");
    Expect(0, 256, '\P{^Block=-	Latin_1_Supplement}', "");
    Error('\p{Blk= /a/LATIN_1_SUP}');
    Error('\P{Blk= /a/LATIN_1_SUP}');
    Expect(1, 255, '\p{Blk=latin1sup}', "");
    Expect(0, 255, '\p{^Blk=latin1sup}', "");
    Expect(0, 255, '\P{Blk=latin1sup}', "");
    Expect(1, 255, '\P{^Blk=latin1sup}', "");
    Expect(0, 256, '\p{Blk=latin1sup}', "");
    Expect(1, 256, '\p{^Blk=latin1sup}', "");
    Expect(1, 256, '\P{Blk=latin1sup}', "");
    Expect(0, 256, '\P{^Blk=latin1sup}', "");
    Expect(1, 255, '\p{Blk:	 Latin_1_sup}', "");
    Expect(0, 255, '\p{^Blk:	 Latin_1_sup}', "");
    Expect(0, 255, '\P{Blk:	 Latin_1_sup}', "");
    Expect(1, 255, '\P{^Blk:	 Latin_1_sup}', "");
    Expect(0, 256, '\p{Blk:	 Latin_1_sup}', "");
    Expect(1, 256, '\p{^Blk:	 Latin_1_sup}', "");
    Expect(1, 256, '\P{Blk:	 Latin_1_sup}', "");
    Expect(0, 256, '\P{^Blk:	 Latin_1_sup}', "");
    Error('\p{Is_Block=:=_Latin_1}');
    Error('\P{Is_Block=:=_Latin_1}');
    Expect(1, 255, '\p{Is_Block=latin1}', "");
    Expect(0, 255, '\p{^Is_Block=latin1}', "");
    Expect(0, 255, '\P{Is_Block=latin1}', "");
    Expect(1, 255, '\P{^Is_Block=latin1}', "");
    Expect(0, 256, '\p{Is_Block=latin1}', "");
    Expect(1, 256, '\p{^Is_Block=latin1}', "");
    Expect(1, 256, '\P{Is_Block=latin1}', "");
    Expect(0, 256, '\P{^Is_Block=latin1}', "");
    Expect(1, 255, '\p{Is_Block=_ latin_1}', "");
    Expect(0, 255, '\p{^Is_Block=_ latin_1}', "");
    Expect(0, 255, '\P{Is_Block=_ latin_1}', "");
    Expect(1, 255, '\P{^Is_Block=_ latin_1}', "");
    Expect(0, 256, '\p{Is_Block=_ latin_1}', "");
    Expect(1, 256, '\p{^Is_Block=_ latin_1}', "");
    Expect(1, 256, '\P{Is_Block=_ latin_1}', "");
    Expect(0, 256, '\P{^Is_Block=_ latin_1}', "");
    Error('\p{Is_Blk:   /a/LATIN_1_SUPPLEMENT}');
    Error('\P{Is_Blk:   /a/LATIN_1_SUPPLEMENT}');
    Expect(1, 255, '\p{Is_Blk=latin1supplement}', "");
    Expect(0, 255, '\p{^Is_Blk=latin1supplement}', "");
    Expect(0, 255, '\P{Is_Blk=latin1supplement}', "");
    Expect(1, 255, '\P{^Is_Blk=latin1supplement}', "");
    Expect(0, 256, '\p{Is_Blk=latin1supplement}', "");
    Expect(1, 256, '\p{^Is_Blk=latin1supplement}', "");
    Expect(1, 256, '\P{Is_Blk=latin1supplement}', "");
    Expect(0, 256, '\P{^Is_Blk=latin1supplement}', "");
    Expect(1, 255, '\p{Is_Blk=_ Latin_1_Supplement}', "");
    Expect(0, 255, '\p{^Is_Blk=_ Latin_1_Supplement}', "");
    Expect(0, 255, '\P{Is_Blk=_ Latin_1_Supplement}', "");
    Expect(1, 255, '\P{^Is_Blk=_ Latin_1_Supplement}', "");
    Expect(0, 256, '\p{Is_Blk=_ Latin_1_Supplement}', "");
    Expect(1, 256, '\p{^Is_Blk=_ Latin_1_Supplement}', "");
    Expect(1, 256, '\P{Is_Blk=_ Latin_1_Supplement}', "");
    Expect(0, 256, '\P{^Is_Blk=_ Latin_1_Supplement}', "");
    Error('\p{Block=:= -LATIN_Extended_A}');
    Error('\P{Block=:= -LATIN_Extended_A}');
    Expect(1, 383, '\p{Block=latinextendeda}', "");
    Expect(0, 383, '\p{^Block=latinextendeda}', "");
    Expect(0, 383, '\P{Block=latinextendeda}', "");
    Expect(1, 383, '\P{^Block=latinextendeda}', "");
    Expect(0, 384, '\p{Block=latinextendeda}', "");
    Expect(1, 384, '\p{^Block=latinextendeda}', "");
    Expect(1, 384, '\P{Block=latinextendeda}', "");
    Expect(0, 384, '\P{^Block=latinextendeda}', "");
    Expect(1, 383, '\p{Block=		LATIN_extended_A}', "");
    Expect(0, 383, '\p{^Block=		LATIN_extended_A}', "");
    Expect(0, 383, '\P{Block=		LATIN_extended_A}', "");
    Expect(1, 383, '\P{^Block=		LATIN_extended_A}', "");
    Expect(0, 384, '\p{Block=		LATIN_extended_A}', "");
    Expect(1, 384, '\p{^Block=		LATIN_extended_A}', "");
    Expect(1, 384, '\P{Block=		LATIN_extended_A}', "");
    Expect(0, 384, '\P{^Block=		LATIN_extended_A}', "");
    Error('\p{Blk=_LATIN_Ext_a/a/}');
    Error('\P{Blk=_LATIN_Ext_a/a/}');
    Expect(1, 383, '\p{Blk=latinexta}', "");
    Expect(0, 383, '\p{^Blk=latinexta}', "");
    Expect(0, 383, '\P{Blk=latinexta}', "");
    Expect(1, 383, '\P{^Blk=latinexta}', "");
    Expect(0, 384, '\p{Blk=latinexta}', "");
    Expect(1, 384, '\p{^Blk=latinexta}', "");
    Expect(1, 384, '\P{Blk=latinexta}', "");
    Expect(0, 384, '\P{^Blk=latinexta}', "");
    Expect(1, 383, '\p{Blk= -Latin_ext_A}', "");
    Expect(0, 383, '\p{^Blk= -Latin_ext_A}', "");
    Expect(0, 383, '\P{Blk= -Latin_ext_A}', "");
    Expect(1, 383, '\P{^Blk= -Latin_ext_A}', "");
    Expect(0, 384, '\p{Blk= -Latin_ext_A}', "");
    Expect(1, 384, '\p{^Blk= -Latin_ext_A}', "");
    Expect(1, 384, '\P{Blk= -Latin_ext_A}', "");
    Expect(0, 384, '\P{^Blk= -Latin_ext_A}', "");
    Error('\p{Is_Block: 	-latin_extended_a:=}');
    Error('\P{Is_Block: 	-latin_extended_a:=}');
    Expect(1, 383, '\p{Is_Block:	latinextendeda}', "");
    Expect(0, 383, '\p{^Is_Block:	latinextendeda}', "");
    Expect(0, 383, '\P{Is_Block:	latinextendeda}', "");
    Expect(1, 383, '\P{^Is_Block:	latinextendeda}', "");
    Expect(0, 384, '\p{Is_Block:	latinextendeda}', "");
    Expect(1, 384, '\p{^Is_Block:	latinextendeda}', "");
    Expect(1, 384, '\P{Is_Block:	latinextendeda}', "");
    Expect(0, 384, '\P{^Is_Block:	latinextendeda}', "");
    Expect(1, 383, '\p{Is_Block=- LATIN_Extended_A}', "");
    Expect(0, 383, '\p{^Is_Block=- LATIN_Extended_A}', "");
    Expect(0, 383, '\P{Is_Block=- LATIN_Extended_A}', "");
    Expect(1, 383, '\P{^Is_Block=- LATIN_Extended_A}', "");
    Expect(0, 384, '\p{Is_Block=- LATIN_Extended_A}', "");
    Expect(1, 384, '\p{^Is_Block=- LATIN_Extended_A}', "");
    Expect(1, 384, '\P{Is_Block=- LATIN_Extended_A}', "");
    Expect(0, 384, '\P{^Is_Block=- LATIN_Extended_A}', "");
    Error('\p{Is_Blk=	/a/Latin_Ext_A}');
    Error('\P{Is_Blk=	/a/Latin_Ext_A}');
    Expect(1, 383, '\p{Is_Blk=latinexta}', "");
    Expect(0, 383, '\p{^Is_Blk=latinexta}', "");
    Expect(0, 383, '\P{Is_Blk=latinexta}', "");
    Expect(1, 383, '\P{^Is_Blk=latinexta}', "");
    Expect(0, 384, '\p{Is_Blk=latinexta}', "");
    Expect(1, 384, '\p{^Is_Blk=latinexta}', "");
    Expect(1, 384, '\P{Is_Blk=latinexta}', "");
    Expect(0, 384, '\P{^Is_Blk=latinexta}', "");
    Expect(1, 383, '\p{Is_Blk=-Latin_EXT_A}', "");
    Expect(0, 383, '\p{^Is_Blk=-Latin_EXT_A}', "");
    Expect(0, 383, '\P{Is_Blk=-Latin_EXT_A}', "");
    Expect(1, 383, '\P{^Is_Blk=-Latin_EXT_A}', "");
    Expect(0, 384, '\p{Is_Blk=-Latin_EXT_A}', "");
    Expect(1, 384, '\p{^Is_Blk=-Latin_EXT_A}', "");
    Expect(1, 384, '\P{Is_Blk=-Latin_EXT_A}', "");
    Expect(0, 384, '\P{^Is_Blk=-Latin_EXT_A}', "");
    Error('\p{Block=Latin_Extended_Additional:=}');
    Error('\P{Block=Latin_Extended_Additional:=}');
    Expect(1, 7935, '\p{Block=latinextendedadditional}', "");
    Expect(0, 7935, '\p{^Block=latinextendedadditional}', "");
    Expect(0, 7935, '\P{Block=latinextendedadditional}', "");
    Expect(1, 7935, '\P{^Block=latinextendedadditional}', "");
    Expect(0, 7936, '\p{Block=latinextendedadditional}', "");
    Expect(1, 7936, '\p{^Block=latinextendedadditional}', "");
    Expect(1, 7936, '\P{Block=latinextendedadditional}', "");
    Expect(0, 7936, '\P{^Block=latinextendedadditional}', "");
    Expect(1, 7935, '\p{Block=__latin_EXTENDED_Additional}', "");
    Expect(0, 7935, '\p{^Block=__latin_EXTENDED_Additional}', "");
    Expect(0, 7935, '\P{Block=__latin_EXTENDED_Additional}', "");
    Expect(1, 7935, '\P{^Block=__latin_EXTENDED_Additional}', "");
    Expect(0, 7936, '\p{Block=__latin_EXTENDED_Additional}', "");
    Expect(1, 7936, '\p{^Block=__latin_EXTENDED_Additional}', "");
    Expect(1, 7936, '\P{Block=__latin_EXTENDED_Additional}', "");
    Expect(0, 7936, '\P{^Block=__latin_EXTENDED_Additional}', "");
    Error('\p{Blk=	LATIN_Ext_ADDITIONAL:=}');
    Error('\P{Blk=	LATIN_Ext_ADDITIONAL:=}');
    Expect(1, 7935, '\p{Blk=latinextadditional}', "");
    Expect(0, 7935, '\p{^Blk=latinextadditional}', "");
    Expect(0, 7935, '\P{Blk=latinextadditional}', "");
    Expect(1, 7935, '\P{^Blk=latinextadditional}', "");
    Expect(0, 7936, '\p{Blk=latinextadditional}', "");
    Expect(1, 7936, '\p{^Blk=latinextadditional}', "");
    Expect(1, 7936, '\P{Blk=latinextadditional}', "");
    Expect(0, 7936, '\P{^Blk=latinextadditional}', "");
    Expect(1, 7935, '\p{Blk=-Latin_Ext_Additional}', "");
    Expect(0, 7935, '\p{^Blk=-Latin_Ext_Additional}', "");
    Expect(0, 7935, '\P{Blk=-Latin_Ext_Additional}', "");
    Expect(1, 7935, '\P{^Blk=-Latin_Ext_Additional}', "");
    Expect(0, 7936, '\p{Blk=-Latin_Ext_Additional}', "");
    Expect(1, 7936, '\p{^Blk=-Latin_Ext_Additional}', "");
    Expect(1, 7936, '\P{Blk=-Latin_Ext_Additional}', "");
    Expect(0, 7936, '\P{^Blk=-Latin_Ext_Additional}', "");
    Error('\p{Is_Block:	/a/-latin_EXTENDED_Additional}');
    Error('\P{Is_Block:	/a/-latin_EXTENDED_Additional}');
    Expect(1, 7935, '\p{Is_Block=latinextendedadditional}', "");
    Expect(0, 7935, '\p{^Is_Block=latinextendedadditional}', "");
    Expect(0, 7935, '\P{Is_Block=latinextendedadditional}', "");
    Expect(1, 7935, '\P{^Is_Block=latinextendedadditional}', "");
    Expect(0, 7936, '\p{Is_Block=latinextendedadditional}', "");
    Expect(1, 7936, '\p{^Is_Block=latinextendedadditional}', "");
    Expect(1, 7936, '\P{Is_Block=latinextendedadditional}', "");
    Expect(0, 7936, '\P{^Is_Block=latinextendedadditional}', "");
    Expect(1, 7935, '\p{Is_Block=	Latin_extended_Additional}', "");
    Expect(0, 7935, '\p{^Is_Block=	Latin_extended_Additional}', "");
    Expect(0, 7935, '\P{Is_Block=	Latin_extended_Additional}', "");
    Expect(1, 7935, '\P{^Is_Block=	Latin_extended_Additional}', "");
    Expect(0, 7936, '\p{Is_Block=	Latin_extended_Additional}', "");
    Expect(1, 7936, '\p{^Is_Block=	Latin_extended_Additional}', "");
    Expect(1, 7936, '\P{Is_Block=	Latin_extended_Additional}', "");
    Expect(0, 7936, '\P{^Is_Block=	Latin_extended_Additional}', "");
    Error('\p{Is_Blk=:= 	LATIN_ext_additional}');
    Error('\P{Is_Blk=:= 	LATIN_ext_additional}');
    Expect(1, 7935, '\p{Is_Blk=latinextadditional}', "");
    Expect(0, 7935, '\p{^Is_Blk=latinextadditional}', "");
    Expect(0, 7935, '\P{Is_Blk=latinextadditional}', "");
    Expect(1, 7935, '\P{^Is_Blk=latinextadditional}', "");
    Expect(0, 7936, '\p{Is_Blk=latinextadditional}', "");
    Expect(1, 7936, '\p{^Is_Blk=latinextadditional}', "");
    Expect(1, 7936, '\P{Is_Blk=latinextadditional}', "");
    Expect(0, 7936, '\P{^Is_Blk=latinextadditional}', "");
    Expect(1, 7935, '\p{Is_Blk=_Latin_ext_Additional}', "");
    Expect(0, 7935, '\p{^Is_Blk=_Latin_ext_Additional}', "");
    Expect(0, 7935, '\P{Is_Blk=_Latin_ext_Additional}', "");
    Expect(1, 7935, '\P{^Is_Blk=_Latin_ext_Additional}', "");
    Expect(0, 7936, '\p{Is_Blk=_Latin_ext_Additional}', "");
    Expect(1, 7936, '\p{^Is_Blk=_Latin_ext_Additional}', "");
    Expect(1, 7936, '\P{Is_Blk=_Latin_ext_Additional}', "");
    Expect(0, 7936, '\P{^Is_Blk=_Latin_ext_Additional}', "");
    Error('\p{Block=-/a/LATIN_EXTENDED_B}');
    Error('\P{Block=-/a/LATIN_EXTENDED_B}');
    Expect(1, 591, '\p{Block=latinextendedb}', "");
    Expect(0, 591, '\p{^Block=latinextendedb}', "");
    Expect(0, 591, '\P{Block=latinextendedb}', "");
    Expect(1, 591, '\P{^Block=latinextendedb}', "");
    Expect(0, 592, '\p{Block=latinextendedb}', "");
    Expect(1, 592, '\p{^Block=latinextendedb}', "");
    Expect(1, 592, '\P{Block=latinextendedb}', "");
    Expect(0, 592, '\P{^Block=latinextendedb}', "");
    Expect(1, 591, '\p{Block= _latin_extended_b}', "");
    Expect(0, 591, '\p{^Block= _latin_extended_b}', "");
    Expect(0, 591, '\P{Block= _latin_extended_b}', "");
    Expect(1, 591, '\P{^Block= _latin_extended_b}', "");
    Expect(0, 592, '\p{Block= _latin_extended_b}', "");
    Expect(1, 592, '\p{^Block= _latin_extended_b}', "");
    Expect(1, 592, '\P{Block= _latin_extended_b}', "");
    Expect(0, 592, '\P{^Block= _latin_extended_b}', "");
    Error('\p{Blk=:=-latin_ext_B}');
    Error('\P{Blk=:=-latin_ext_B}');
    Expect(1, 591, '\p{Blk=latinextb}', "");
    Expect(0, 591, '\p{^Blk=latinextb}', "");
    Expect(0, 591, '\P{Blk=latinextb}', "");
    Expect(1, 591, '\P{^Blk=latinextb}', "");
    Expect(0, 592, '\p{Blk=latinextb}', "");
    Expect(1, 592, '\p{^Blk=latinextb}', "");
    Expect(1, 592, '\P{Blk=latinextb}', "");
    Expect(0, 592, '\P{^Blk=latinextb}', "");
    Expect(1, 591, '\p{Blk=		LATIN_ext_B}', "");
    Expect(0, 591, '\p{^Blk=		LATIN_ext_B}', "");
    Expect(0, 591, '\P{Blk=		LATIN_ext_B}', "");
    Expect(1, 591, '\P{^Blk=		LATIN_ext_B}', "");
    Expect(0, 592, '\p{Blk=		LATIN_ext_B}', "");
    Expect(1, 592, '\p{^Blk=		LATIN_ext_B}', "");
    Expect(1, 592, '\P{Blk=		LATIN_ext_B}', "");
    Expect(0, 592, '\P{^Blk=		LATIN_ext_B}', "");
    Error('\p{Is_Block= -latin_Extended_B/a/}');
    Error('\P{Is_Block= -latin_Extended_B/a/}');
    Expect(1, 591, '\p{Is_Block=latinextendedb}', "");
    Expect(0, 591, '\p{^Is_Block=latinextendedb}', "");
    Expect(0, 591, '\P{Is_Block=latinextendedb}', "");
    Expect(1, 591, '\P{^Is_Block=latinextendedb}', "");
    Expect(0, 592, '\p{Is_Block=latinextendedb}', "");
    Expect(1, 592, '\p{^Is_Block=latinextendedb}', "");
    Expect(1, 592, '\P{Is_Block=latinextendedb}', "");
    Expect(0, 592, '\P{^Is_Block=latinextendedb}', "");
    Expect(1, 591, '\p{Is_Block=-_LATIN_Extended_B}', "");
    Expect(0, 591, '\p{^Is_Block=-_LATIN_Extended_B}', "");
    Expect(0, 591, '\P{Is_Block=-_LATIN_Extended_B}', "");
    Expect(1, 591, '\P{^Is_Block=-_LATIN_Extended_B}', "");
    Expect(0, 592, '\p{Is_Block=-_LATIN_Extended_B}', "");
    Expect(1, 592, '\p{^Is_Block=-_LATIN_Extended_B}', "");
    Expect(1, 592, '\P{Is_Block=-_LATIN_Extended_B}', "");
    Expect(0, 592, '\P{^Is_Block=-_LATIN_Extended_B}', "");
    Error('\p{Is_Blk::= _latin_ext_B}');
    Error('\P{Is_Blk::= _latin_ext_B}');
    Expect(1, 591, '\p{Is_Blk=latinextb}', "");
    Expect(0, 591, '\p{^Is_Blk=latinextb}', "");
    Expect(0, 591, '\P{Is_Blk=latinextb}', "");
    Expect(1, 591, '\P{^Is_Blk=latinextb}', "");
    Expect(0, 592, '\p{Is_Blk=latinextb}', "");
    Expect(1, 592, '\p{^Is_Blk=latinextb}', "");
    Expect(1, 592, '\P{Is_Blk=latinextb}', "");
    Expect(0, 592, '\P{^Is_Blk=latinextb}', "");
    Expect(1, 591, '\p{Is_Blk=-latin_Ext_B}', "");
    Expect(0, 591, '\p{^Is_Blk=-latin_Ext_B}', "");
    Expect(0, 591, '\P{Is_Blk=-latin_Ext_B}', "");
    Expect(1, 591, '\P{^Is_Blk=-latin_Ext_B}', "");
    Expect(0, 592, '\p{Is_Blk=-latin_Ext_B}', "");
    Expect(1, 592, '\p{^Is_Blk=-latin_Ext_B}', "");
    Expect(1, 592, '\P{Is_Blk=-latin_Ext_B}', "");
    Expect(0, 592, '\P{^Is_Blk=-latin_Ext_B}', "");
    Error('\p{Block=	-latin_extended_c/a/}');
    Error('\P{Block=	-latin_extended_c/a/}');
    Expect(1, 11391, '\p{Block=latinextendedc}', "");
    Expect(0, 11391, '\p{^Block=latinextendedc}', "");
    Expect(0, 11391, '\P{Block=latinextendedc}', "");
    Expect(1, 11391, '\P{^Block=latinextendedc}', "");
    Expect(0, 11392, '\p{Block=latinextendedc}', "");
    Expect(1, 11392, '\p{^Block=latinextendedc}', "");
    Expect(1, 11392, '\P{Block=latinextendedc}', "");
    Expect(0, 11392, '\P{^Block=latinextendedc}', "");
    Expect(1, 11391, '\p{Block=		LATIN_Extended_C}', "");
    Expect(0, 11391, '\p{^Block=		LATIN_Extended_C}', "");
    Expect(0, 11391, '\P{Block=		LATIN_Extended_C}', "");
    Expect(1, 11391, '\P{^Block=		LATIN_Extended_C}', "");
    Expect(0, 11392, '\p{Block=		LATIN_Extended_C}', "");
    Expect(1, 11392, '\p{^Block=		LATIN_Extended_C}', "");
    Expect(1, 11392, '\P{Block=		LATIN_Extended_C}', "");
    Expect(0, 11392, '\P{^Block=		LATIN_Extended_C}', "");
    Error('\p{Blk=_/a/Latin_ext_C}');
    Error('\P{Blk=_/a/Latin_ext_C}');
    Expect(1, 11391, '\p{Blk:   latinextc}', "");
    Expect(0, 11391, '\p{^Blk:   latinextc}', "");
    Expect(0, 11391, '\P{Blk:   latinextc}', "");
    Expect(1, 11391, '\P{^Blk:   latinextc}', "");
    Expect(0, 11392, '\p{Blk:   latinextc}', "");
    Expect(1, 11392, '\p{^Blk:   latinextc}', "");
    Expect(1, 11392, '\P{Blk:   latinextc}', "");
    Expect(0, 11392, '\P{^Blk:   latinextc}', "");
    Expect(1, 11391, '\p{Blk=_ Latin_Ext_c}', "");
    Expect(0, 11391, '\p{^Blk=_ Latin_Ext_c}', "");
    Expect(0, 11391, '\P{Blk=_ Latin_Ext_c}', "");
    Expect(1, 11391, '\P{^Blk=_ Latin_Ext_c}', "");
    Expect(0, 11392, '\p{Blk=_ Latin_Ext_c}', "");
    Expect(1, 11392, '\p{^Blk=_ Latin_Ext_c}', "");
    Expect(1, 11392, '\P{Blk=_ Latin_Ext_c}', "");
    Expect(0, 11392, '\P{^Blk=_ Latin_Ext_c}', "");
    Error('\p{Is_Block=/a/latin_Extended_C}');
    Error('\P{Is_Block=/a/latin_Extended_C}');
    Expect(1, 11391, '\p{Is_Block=latinextendedc}', "");
    Expect(0, 11391, '\p{^Is_Block=latinextendedc}', "");
    Expect(0, 11391, '\P{Is_Block=latinextendedc}', "");
    Expect(1, 11391, '\P{^Is_Block=latinextendedc}', "");
    Expect(0, 11392, '\p{Is_Block=latinextendedc}', "");
    Expect(1, 11392, '\p{^Is_Block=latinextendedc}', "");
    Expect(1, 11392, '\P{Is_Block=latinextendedc}', "");
    Expect(0, 11392, '\P{^Is_Block=latinextendedc}', "");
    Expect(1, 11391, '\p{Is_Block=	Latin_EXTENDED_C}', "");
    Expect(0, 11391, '\p{^Is_Block=	Latin_EXTENDED_C}', "");
    Expect(0, 11391, '\P{Is_Block=	Latin_EXTENDED_C}', "");
    Expect(1, 11391, '\P{^Is_Block=	Latin_EXTENDED_C}', "");
    Expect(0, 11392, '\p{Is_Block=	Latin_EXTENDED_C}', "");
    Expect(1, 11392, '\p{^Is_Block=	Latin_EXTENDED_C}', "");
    Expect(1, 11392, '\P{Is_Block=	Latin_EXTENDED_C}', "");
    Expect(0, 11392, '\P{^Is_Block=	Latin_EXTENDED_C}', "");
    Error('\p{Is_Blk= :=LATIN_Ext_c}');
    Error('\P{Is_Blk= :=LATIN_Ext_c}');
    Expect(1, 11391, '\p{Is_Blk=latinextc}', "");
    Expect(0, 11391, '\p{^Is_Blk=latinextc}', "");
    Expect(0, 11391, '\P{Is_Blk=latinextc}', "");
    Expect(1, 11391, '\P{^Is_Blk=latinextc}', "");
    Expect(0, 11392, '\p{Is_Blk=latinextc}', "");
    Expect(1, 11392, '\p{^Is_Blk=latinextc}', "");
    Expect(1, 11392, '\P{Is_Blk=latinextc}', "");
    Expect(0, 11392, '\P{^Is_Blk=latinextc}', "");
    Expect(1, 11391, '\p{Is_Blk=		Latin_ext_C}', "");
    Expect(0, 11391, '\p{^Is_Blk=		Latin_ext_C}', "");
    Expect(0, 11391, '\P{Is_Blk=		Latin_ext_C}', "");
    Expect(1, 11391, '\P{^Is_Blk=		Latin_ext_C}', "");
    Expect(0, 11392, '\p{Is_Blk=		Latin_ext_C}', "");
    Expect(1, 11392, '\p{^Is_Blk=		Latin_ext_C}', "");
    Expect(1, 11392, '\P{Is_Blk=		Latin_ext_C}', "");
    Expect(0, 11392, '\P{^Is_Blk=		Latin_ext_C}', "");
    Error('\p{Block=:=	_Latin_Extended_d}');
    Error('\P{Block=:=	_Latin_Extended_d}');
    Expect(1, 43007, '\p{Block=latinextendedd}', "");
    Expect(0, 43007, '\p{^Block=latinextendedd}', "");
    Expect(0, 43007, '\P{Block=latinextendedd}', "");
    Expect(1, 43007, '\P{^Block=latinextendedd}', "");
    Expect(0, 43008, '\p{Block=latinextendedd}', "");
    Expect(1, 43008, '\p{^Block=latinextendedd}', "");
    Expect(1, 43008, '\P{Block=latinextendedd}', "");
    Expect(0, 43008, '\P{^Block=latinextendedd}', "");
    Expect(1, 43007, '\p{Block= Latin_Extended_d}', "");
    Expect(0, 43007, '\p{^Block= Latin_Extended_d}', "");
    Expect(0, 43007, '\P{Block= Latin_Extended_d}', "");
    Expect(1, 43007, '\P{^Block= Latin_Extended_d}', "");
    Expect(0, 43008, '\p{Block= Latin_Extended_d}', "");
    Expect(1, 43008, '\p{^Block= Latin_Extended_d}', "");
    Expect(1, 43008, '\P{Block= Latin_Extended_d}', "");
    Expect(0, 43008, '\P{^Block= Latin_Extended_d}', "");
    Error('\p{Blk=/a/ _LATIN_Ext_d}');
    Error('\P{Blk=/a/ _LATIN_Ext_d}');
    Expect(1, 43007, '\p{Blk=latinextd}', "");
    Expect(0, 43007, '\p{^Blk=latinextd}', "");
    Expect(0, 43007, '\P{Blk=latinextd}', "");
    Expect(1, 43007, '\P{^Blk=latinextd}', "");
    Expect(0, 43008, '\p{Blk=latinextd}', "");
    Expect(1, 43008, '\p{^Blk=latinextd}', "");
    Expect(1, 43008, '\P{Blk=latinextd}', "");
    Expect(0, 43008, '\P{^Blk=latinextd}', "");
    Expect(1, 43007, '\p{Blk=-Latin_ext_D}', "");
    Expect(0, 43007, '\p{^Blk=-Latin_ext_D}', "");
    Expect(0, 43007, '\P{Blk=-Latin_ext_D}', "");
    Expect(1, 43007, '\P{^Blk=-Latin_ext_D}', "");
    Expect(0, 43008, '\p{Blk=-Latin_ext_D}', "");
    Expect(1, 43008, '\p{^Blk=-Latin_ext_D}', "");
    Expect(1, 43008, '\P{Blk=-Latin_ext_D}', "");
    Expect(0, 43008, '\P{^Blk=-Latin_ext_D}', "");
    Error('\p{Is_Block:	 /a/Latin_Extended_d}');
    Error('\P{Is_Block:	 /a/Latin_Extended_d}');
    Expect(1, 43007, '\p{Is_Block=latinextendedd}', "");
    Expect(0, 43007, '\p{^Is_Block=latinextendedd}', "");
    Expect(0, 43007, '\P{Is_Block=latinextendedd}', "");
    Expect(1, 43007, '\P{^Is_Block=latinextendedd}', "");
    Expect(0, 43008, '\p{Is_Block=latinextendedd}', "");
    Expect(1, 43008, '\p{^Is_Block=latinextendedd}', "");
    Expect(1, 43008, '\P{Is_Block=latinextendedd}', "");
    Expect(0, 43008, '\P{^Is_Block=latinextendedd}', "");
    Expect(1, 43007, '\p{Is_Block=_	latin_Extended_d}', "");
    Expect(0, 43007, '\p{^Is_Block=_	latin_Extended_d}', "");
    Expect(0, 43007, '\P{Is_Block=_	latin_Extended_d}', "");
    Expect(1, 43007, '\P{^Is_Block=_	latin_Extended_d}', "");
    Expect(0, 43008, '\p{Is_Block=_	latin_Extended_d}', "");
    Expect(1, 43008, '\p{^Is_Block=_	latin_Extended_d}', "");
    Expect(1, 43008, '\P{Is_Block=_	latin_Extended_d}', "");
    Expect(0, 43008, '\P{^Is_Block=_	latin_Extended_d}', "");
    Error('\p{Is_Blk=	_Latin_EXT_D/a/}');
    Error('\P{Is_Blk=	_Latin_EXT_D/a/}');
    Expect(1, 43007, '\p{Is_Blk=latinextd}', "");
    Expect(0, 43007, '\p{^Is_Blk=latinextd}', "");
    Expect(0, 43007, '\P{Is_Blk=latinextd}', "");
    Expect(1, 43007, '\P{^Is_Blk=latinextd}', "");
    Expect(0, 43008, '\p{Is_Blk=latinextd}', "");
    Expect(1, 43008, '\p{^Is_Blk=latinextd}', "");
    Expect(1, 43008, '\P{Is_Blk=latinextd}', "");
    Expect(0, 43008, '\P{^Is_Blk=latinextd}', "");
    Expect(1, 43007, '\p{Is_Blk=-latin_ext_D}', "");
    Expect(0, 43007, '\p{^Is_Blk=-latin_ext_D}', "");
    Expect(0, 43007, '\P{Is_Blk=-latin_ext_D}', "");
    Expect(1, 43007, '\P{^Is_Blk=-latin_ext_D}', "");
    Expect(0, 43008, '\p{Is_Blk=-latin_ext_D}', "");
    Expect(1, 43008, '\p{^Is_Blk=-latin_ext_D}', "");
    Expect(1, 43008, '\P{Is_Blk=-latin_ext_D}', "");
    Expect(0, 43008, '\P{^Is_Blk=-latin_ext_D}', "");
    Error('\p{Block:/a/_	Latin_EXTENDED_e}');
    Error('\P{Block:/a/_	Latin_EXTENDED_e}');
    Expect(1, 43887, '\p{Block=latinextendede}', "");
    Expect(0, 43887, '\p{^Block=latinextendede}', "");
    Expect(0, 43887, '\P{Block=latinextendede}', "");
    Expect(1, 43887, '\P{^Block=latinextendede}', "");
    Expect(0, 43888, '\p{Block=latinextendede}', "");
    Expect(1, 43888, '\p{^Block=latinextendede}', "");
    Expect(1, 43888, '\P{Block=latinextendede}', "");
    Expect(0, 43888, '\P{^Block=latinextendede}', "");
    Expect(1, 43887, '\p{Block=  Latin_extended_e}', "");
    Expect(0, 43887, '\p{^Block=  Latin_extended_e}', "");
    Expect(0, 43887, '\P{Block=  Latin_extended_e}', "");
    Expect(1, 43887, '\P{^Block=  Latin_extended_e}', "");
    Expect(0, 43888, '\p{Block=  Latin_extended_e}', "");
    Expect(1, 43888, '\p{^Block=  Latin_extended_e}', "");
    Expect(1, 43888, '\P{Block=  Latin_extended_e}', "");
    Expect(0, 43888, '\P{^Block=  Latin_extended_e}', "");
    Error('\p{Blk= :=Latin_ext_E}');
    Error('\P{Blk= :=Latin_ext_E}');
    Expect(1, 43887, '\p{Blk=latinexte}', "");
    Expect(0, 43887, '\p{^Blk=latinexte}', "");
    Expect(0, 43887, '\P{Blk=latinexte}', "");
    Expect(1, 43887, '\P{^Blk=latinexte}', "");
    Expect(0, 43888, '\p{Blk=latinexte}', "");
    Expect(1, 43888, '\p{^Blk=latinexte}', "");
    Expect(1, 43888, '\P{Blk=latinexte}', "");
    Expect(0, 43888, '\P{^Blk=latinexte}', "");
    Expect(1, 43887, '\p{Blk=LATIN_EXT_E}', "");
    Expect(0, 43887, '\p{^Blk=LATIN_EXT_E}', "");
    Expect(0, 43887, '\P{Blk=LATIN_EXT_E}', "");
    Expect(1, 43887, '\P{^Blk=LATIN_EXT_E}', "");
    Expect(0, 43888, '\p{Blk=LATIN_EXT_E}', "");
    Expect(1, 43888, '\p{^Blk=LATIN_EXT_E}', "");
    Expect(1, 43888, '\P{Blk=LATIN_EXT_E}', "");
    Expect(0, 43888, '\P{^Blk=LATIN_EXT_E}', "");
    Error('\p{Is_Block=/a/	_Latin_EXTENDED_E}');
    Error('\P{Is_Block=/a/	_Latin_EXTENDED_E}');
    Expect(1, 43887, '\p{Is_Block=latinextendede}', "");
    Expect(0, 43887, '\p{^Is_Block=latinextendede}', "");
    Expect(0, 43887, '\P{Is_Block=latinextendede}', "");
    Expect(1, 43887, '\P{^Is_Block=latinextendede}', "");
    Expect(0, 43888, '\p{Is_Block=latinextendede}', "");
    Expect(1, 43888, '\p{^Is_Block=latinextendede}', "");
    Expect(1, 43888, '\P{Is_Block=latinextendede}', "");
    Expect(0, 43888, '\P{^Is_Block=latinextendede}', "");
    Expect(1, 43887, '\p{Is_Block=	LATIN_extended_E}', "");
    Expect(0, 43887, '\p{^Is_Block=	LATIN_extended_E}', "");
    Expect(0, 43887, '\P{Is_Block=	LATIN_extended_E}', "");
    Expect(1, 43887, '\P{^Is_Block=	LATIN_extended_E}', "");
    Expect(0, 43888, '\p{Is_Block=	LATIN_extended_E}', "");
    Expect(1, 43888, '\p{^Is_Block=	LATIN_extended_E}', "");
    Expect(1, 43888, '\P{Is_Block=	LATIN_extended_E}', "");
    Expect(0, 43888, '\P{^Is_Block=	LATIN_extended_E}', "");
    Error('\p{Is_Blk=/a/Latin_ext_e}');
    Error('\P{Is_Blk=/a/Latin_ext_e}');
    Expect(1, 43887, '\p{Is_Blk=latinexte}', "");
    Expect(0, 43887, '\p{^Is_Blk=latinexte}', "");
    Expect(0, 43887, '\P{Is_Blk=latinexte}', "");
    Expect(1, 43887, '\P{^Is_Blk=latinexte}', "");
    Expect(0, 43888, '\p{Is_Blk=latinexte}', "");
    Expect(1, 43888, '\p{^Is_Blk=latinexte}', "");
    Expect(1, 43888, '\P{Is_Blk=latinexte}', "");
    Expect(0, 43888, '\P{^Is_Blk=latinexte}', "");
    Expect(1, 43887, '\p{Is_Blk=_LATIN_Ext_E}', "");
    Expect(0, 43887, '\p{^Is_Blk=_LATIN_Ext_E}', "");
    Expect(0, 43887, '\P{Is_Blk=_LATIN_Ext_E}', "");
    Expect(1, 43887, '\P{^Is_Blk=_LATIN_Ext_E}', "");
    Expect(0, 43888, '\p{Is_Blk=_LATIN_Ext_E}', "");
    Expect(1, 43888, '\p{^Is_Blk=_LATIN_Ext_E}', "");
    Expect(1, 43888, '\P{Is_Blk=_LATIN_Ext_E}', "");
    Expect(0, 43888, '\P{^Is_Blk=_LATIN_Ext_E}', "");
    Error('\p{Block=	_Lepcha/a/}');
    Error('\P{Block=	_Lepcha/a/}');
    Expect(1, 7247, '\p{Block=lepcha}', "");
    Expect(0, 7247, '\p{^Block=lepcha}', "");
    Expect(0, 7247, '\P{Block=lepcha}', "");
    Expect(1, 7247, '\P{^Block=lepcha}', "");
    Expect(0, 7248, '\p{Block=lepcha}', "");
    Expect(1, 7248, '\p{^Block=lepcha}', "");
    Expect(1, 7248, '\P{Block=lepcha}', "");
    Expect(0, 7248, '\P{^Block=lepcha}', "");
    Expect(1, 7247, '\p{Block=_	Lepcha}', "");
    Expect(0, 7247, '\p{^Block=_	Lepcha}', "");
    Expect(0, 7247, '\P{Block=_	Lepcha}', "");
    Expect(1, 7247, '\P{^Block=_	Lepcha}', "");
    Expect(0, 7248, '\p{Block=_	Lepcha}', "");
    Expect(1, 7248, '\p{^Block=_	Lepcha}', "");
    Expect(1, 7248, '\P{Block=_	Lepcha}', "");
    Expect(0, 7248, '\P{^Block=_	Lepcha}', "");
    Error('\p{Blk=:= -LEPCHA}');
    Error('\P{Blk=:= -LEPCHA}');
    Expect(1, 7247, '\p{Blk=lepcha}', "");
    Expect(0, 7247, '\p{^Blk=lepcha}', "");
    Expect(0, 7247, '\P{Blk=lepcha}', "");
    Expect(1, 7247, '\P{^Blk=lepcha}', "");
    Expect(0, 7248, '\p{Blk=lepcha}', "");
    Expect(1, 7248, '\p{^Blk=lepcha}', "");
    Expect(1, 7248, '\P{Blk=lepcha}', "");
    Expect(0, 7248, '\P{^Blk=lepcha}', "");
    Expect(1, 7247, '\p{Blk= Lepcha}', "");
    Expect(0, 7247, '\p{^Blk= Lepcha}', "");
    Expect(0, 7247, '\P{Blk= Lepcha}', "");
    Expect(1, 7247, '\P{^Blk= Lepcha}', "");
    Expect(0, 7248, '\p{Blk= Lepcha}', "");
    Expect(1, 7248, '\p{^Blk= Lepcha}', "");
    Expect(1, 7248, '\P{Blk= Lepcha}', "");
    Expect(0, 7248, '\P{^Blk= Lepcha}', "");
    Error('\p{Is_Block= :=LEPCHA}');
    Error('\P{Is_Block= :=LEPCHA}');
    Expect(1, 7247, '\p{Is_Block=lepcha}', "");
    Expect(0, 7247, '\p{^Is_Block=lepcha}', "");
    Expect(0, 7247, '\P{Is_Block=lepcha}', "");
    Expect(1, 7247, '\P{^Is_Block=lepcha}', "");
    Expect(0, 7248, '\p{Is_Block=lepcha}', "");
    Expect(1, 7248, '\p{^Is_Block=lepcha}', "");
    Expect(1, 7248, '\P{Is_Block=lepcha}', "");
    Expect(0, 7248, '\P{^Is_Block=lepcha}', "");
    Expect(1, 7247, '\p{Is_Block= _LEPCHA}', "");
    Expect(0, 7247, '\p{^Is_Block= _LEPCHA}', "");
    Expect(0, 7247, '\P{Is_Block= _LEPCHA}', "");
    Expect(1, 7247, '\P{^Is_Block= _LEPCHA}', "");
    Expect(0, 7248, '\p{Is_Block= _LEPCHA}', "");
    Expect(1, 7248, '\p{^Is_Block= _LEPCHA}', "");
    Expect(1, 7248, '\P{Is_Block= _LEPCHA}', "");
    Expect(0, 7248, '\P{^Is_Block= _LEPCHA}', "");
    Error('\p{Is_Blk=/a/	_Lepcha}');
    Error('\P{Is_Blk=/a/	_Lepcha}');
    Expect(1, 7247, '\p{Is_Blk=lepcha}', "");
    Expect(0, 7247, '\p{^Is_Blk=lepcha}', "");
    Expect(0, 7247, '\P{Is_Blk=lepcha}', "");
    Expect(1, 7247, '\P{^Is_Blk=lepcha}', "");
    Expect(0, 7248, '\p{Is_Blk=lepcha}', "");
    Expect(1, 7248, '\p{^Is_Blk=lepcha}', "");
    Expect(1, 7248, '\P{Is_Blk=lepcha}', "");
    Expect(0, 7248, '\P{^Is_Blk=lepcha}', "");
    Expect(1, 7247, '\p{Is_Blk=_	LEPCHA}', "");
    Expect(0, 7247, '\p{^Is_Blk=_	LEPCHA}', "");
    Expect(0, 7247, '\P{Is_Blk=_	LEPCHA}', "");
    Expect(1, 7247, '\P{^Is_Blk=_	LEPCHA}', "");
    Expect(0, 7248, '\p{Is_Blk=_	LEPCHA}', "");
    Expect(1, 7248, '\p{^Is_Blk=_	LEPCHA}', "");
    Expect(1, 7248, '\P{Is_Blk=_	LEPCHA}', "");
    Expect(0, 7248, '\P{^Is_Blk=_	LEPCHA}', "");
    Error('\p{Block=:=Letterlike_symbols}');
    Error('\P{Block=:=Letterlike_symbols}');
    Expect(1, 8527, '\p{Block=letterlikesymbols}', "");
    Expect(0, 8527, '\p{^Block=letterlikesymbols}', "");
    Expect(0, 8527, '\P{Block=letterlikesymbols}', "");
    Expect(1, 8527, '\P{^Block=letterlikesymbols}', "");
    Expect(0, 8528, '\p{Block=letterlikesymbols}', "");
    Expect(1, 8528, '\p{^Block=letterlikesymbols}', "");
    Expect(1, 8528, '\P{Block=letterlikesymbols}', "");
    Expect(0, 8528, '\P{^Block=letterlikesymbols}', "");
    Expect(1, 8527, '\p{Block=-LETTERLIKE_Symbols}', "");
    Expect(0, 8527, '\p{^Block=-LETTERLIKE_Symbols}', "");
    Expect(0, 8527, '\P{Block=-LETTERLIKE_Symbols}', "");
    Expect(1, 8527, '\P{^Block=-LETTERLIKE_Symbols}', "");
    Expect(0, 8528, '\p{Block=-LETTERLIKE_Symbols}', "");
    Expect(1, 8528, '\p{^Block=-LETTERLIKE_Symbols}', "");
    Expect(1, 8528, '\P{Block=-LETTERLIKE_Symbols}', "");
    Expect(0, 8528, '\P{^Block=-LETTERLIKE_Symbols}', "");
    Error('\p{Blk=:=--letterlike_Symbols}');
    Error('\P{Blk=:=--letterlike_Symbols}');
    Expect(1, 8527, '\p{Blk=letterlikesymbols}', "");
    Expect(0, 8527, '\p{^Blk=letterlikesymbols}', "");
    Expect(0, 8527, '\P{Blk=letterlikesymbols}', "");
    Expect(1, 8527, '\P{^Blk=letterlikesymbols}', "");
    Expect(0, 8528, '\p{Blk=letterlikesymbols}', "");
    Expect(1, 8528, '\p{^Blk=letterlikesymbols}', "");
    Expect(1, 8528, '\P{Blk=letterlikesymbols}', "");
    Expect(0, 8528, '\P{^Blk=letterlikesymbols}', "");
    Expect(1, 8527, '\p{Blk=LETTERLIKE_symbols}', "");
    Expect(0, 8527, '\p{^Blk=LETTERLIKE_symbols}', "");
    Expect(0, 8527, '\P{Blk=LETTERLIKE_symbols}', "");
    Expect(1, 8527, '\P{^Blk=LETTERLIKE_symbols}', "");
    Expect(0, 8528, '\p{Blk=LETTERLIKE_symbols}', "");
    Expect(1, 8528, '\p{^Blk=LETTERLIKE_symbols}', "");
    Expect(1, 8528, '\P{Blk=LETTERLIKE_symbols}', "");
    Expect(0, 8528, '\P{^Blk=LETTERLIKE_symbols}', "");
    Error('\p{Is_Block=_Letterlike_Symbols:=}');
    Error('\P{Is_Block=_Letterlike_Symbols:=}');
    Expect(1, 8527, '\p{Is_Block=letterlikesymbols}', "");
    Expect(0, 8527, '\p{^Is_Block=letterlikesymbols}', "");
    Expect(0, 8527, '\P{Is_Block=letterlikesymbols}', "");
    Expect(1, 8527, '\P{^Is_Block=letterlikesymbols}', "");
    Expect(0, 8528, '\p{Is_Block=letterlikesymbols}', "");
    Expect(1, 8528, '\p{^Is_Block=letterlikesymbols}', "");
    Expect(1, 8528, '\P{Is_Block=letterlikesymbols}', "");
    Expect(0, 8528, '\P{^Is_Block=letterlikesymbols}', "");
    Expect(1, 8527, '\p{Is_Block=		letterlike_symbols}', "");
    Expect(0, 8527, '\p{^Is_Block=		letterlike_symbols}', "");
    Expect(0, 8527, '\P{Is_Block=		letterlike_symbols}', "");
    Expect(1, 8527, '\P{^Is_Block=		letterlike_symbols}', "");
    Expect(0, 8528, '\p{Is_Block=		letterlike_symbols}', "");
    Expect(1, 8528, '\p{^Is_Block=		letterlike_symbols}', "");
    Expect(1, 8528, '\P{Is_Block=		letterlike_symbols}', "");
    Expect(0, 8528, '\P{^Is_Block=		letterlike_symbols}', "");
    Error('\p{Is_Blk=  Letterlike_symbols/a/}');
    Error('\P{Is_Blk=  Letterlike_symbols/a/}');
    Expect(1, 8527, '\p{Is_Blk=letterlikesymbols}', "");
    Expect(0, 8527, '\p{^Is_Blk=letterlikesymbols}', "");
    Expect(0, 8527, '\P{Is_Blk=letterlikesymbols}', "");
    Expect(1, 8527, '\P{^Is_Blk=letterlikesymbols}', "");
    Expect(0, 8528, '\p{Is_Blk=letterlikesymbols}', "");
    Expect(1, 8528, '\p{^Is_Blk=letterlikesymbols}', "");
    Expect(1, 8528, '\P{Is_Blk=letterlikesymbols}', "");
    Expect(0, 8528, '\P{^Is_Blk=letterlikesymbols}', "");
    Expect(1, 8527, '\p{Is_Blk=	_LETTERLIKE_Symbols}', "");
    Expect(0, 8527, '\p{^Is_Blk=	_LETTERLIKE_Symbols}', "");
    Expect(0, 8527, '\P{Is_Blk=	_LETTERLIKE_Symbols}', "");
    Expect(1, 8527, '\P{^Is_Blk=	_LETTERLIKE_Symbols}', "");
    Expect(0, 8528, '\p{Is_Blk=	_LETTERLIKE_Symbols}', "");
    Expect(1, 8528, '\p{^Is_Blk=	_LETTERLIKE_Symbols}', "");
    Expect(1, 8528, '\P{Is_Blk=	_LETTERLIKE_Symbols}', "");
    Expect(0, 8528, '\P{^Is_Blk=	_LETTERLIKE_Symbols}', "");
    Error('\p{Block=:=-Limbu}');
    Error('\P{Block=:=-Limbu}');
    Expect(1, 6479, '\p{Block:	limbu}', "");
    Expect(0, 6479, '\p{^Block:	limbu}', "");
    Expect(0, 6479, '\P{Block:	limbu}', "");
    Expect(1, 6479, '\P{^Block:	limbu}', "");
    Expect(0, 6480, '\p{Block:	limbu}', "");
    Expect(1, 6480, '\p{^Block:	limbu}', "");
    Expect(1, 6480, '\P{Block:	limbu}', "");
    Expect(0, 6480, '\P{^Block:	limbu}', "");
    Expect(1, 6479, '\p{Block=_ Limbu}', "");
    Expect(0, 6479, '\p{^Block=_ Limbu}', "");
    Expect(0, 6479, '\P{Block=_ Limbu}', "");
    Expect(1, 6479, '\P{^Block=_ Limbu}', "");
    Expect(0, 6480, '\p{Block=_ Limbu}', "");
    Expect(1, 6480, '\p{^Block=_ Limbu}', "");
    Expect(1, 6480, '\P{Block=_ Limbu}', "");
    Expect(0, 6480, '\P{^Block=_ Limbu}', "");
    Error('\p{Blk=_LIMBU:=}');
    Error('\P{Blk=_LIMBU:=}');
    Expect(1, 6479, '\p{Blk=limbu}', "");
    Expect(0, 6479, '\p{^Blk=limbu}', "");
    Expect(0, 6479, '\P{Blk=limbu}', "");
    Expect(1, 6479, '\P{^Blk=limbu}', "");
    Expect(0, 6480, '\p{Blk=limbu}', "");
    Expect(1, 6480, '\p{^Blk=limbu}', "");
    Expect(1, 6480, '\P{Blk=limbu}', "");
    Expect(0, 6480, '\P{^Blk=limbu}', "");
    Expect(1, 6479, '\p{Blk=-limbu}', "");
    Expect(0, 6479, '\p{^Blk=-limbu}', "");
    Expect(0, 6479, '\P{Blk=-limbu}', "");
    Expect(1, 6479, '\P{^Blk=-limbu}', "");
    Expect(0, 6480, '\p{Blk=-limbu}', "");
    Expect(1, 6480, '\p{^Blk=-limbu}', "");
    Expect(1, 6480, '\P{Blk=-limbu}', "");
    Expect(0, 6480, '\P{^Blk=-limbu}', "");
    Error('\p{Is_Block=__Limbu/a/}');
    Error('\P{Is_Block=__Limbu/a/}');
    Expect(1, 6479, '\p{Is_Block=limbu}', "");
    Expect(0, 6479, '\p{^Is_Block=limbu}', "");
    Expect(0, 6479, '\P{Is_Block=limbu}', "");
    Expect(1, 6479, '\P{^Is_Block=limbu}', "");
    Expect(0, 6480, '\p{Is_Block=limbu}', "");
    Expect(1, 6480, '\p{^Is_Block=limbu}', "");
    Expect(1, 6480, '\P{Is_Block=limbu}', "");
    Expect(0, 6480, '\P{^Is_Block=limbu}', "");
    Expect(1, 6479, '\p{Is_Block=- limbu}', "");
    Expect(0, 6479, '\p{^Is_Block=- limbu}', "");
    Expect(0, 6479, '\P{Is_Block=- limbu}', "");
    Expect(1, 6479, '\P{^Is_Block=- limbu}', "");
    Expect(0, 6480, '\p{Is_Block=- limbu}', "");
    Expect(1, 6480, '\p{^Is_Block=- limbu}', "");
    Expect(1, 6480, '\P{Is_Block=- limbu}', "");
    Expect(0, 6480, '\P{^Is_Block=- limbu}', "");
    Error('\p{Is_Blk=/a/Limbu}');
    Error('\P{Is_Blk=/a/Limbu}');
    Expect(1, 6479, '\p{Is_Blk=limbu}', "");
    Expect(0, 6479, '\p{^Is_Blk=limbu}', "");
    Expect(0, 6479, '\P{Is_Blk=limbu}', "");
    Expect(1, 6479, '\P{^Is_Blk=limbu}', "");
    Expect(0, 6480, '\p{Is_Blk=limbu}', "");
    Expect(1, 6480, '\p{^Is_Blk=limbu}', "");
    Expect(1, 6480, '\P{Is_Blk=limbu}', "");
    Expect(0, 6480, '\P{^Is_Blk=limbu}', "");
    Expect(1, 6479, '\p{Is_Blk=_ LIMBU}', "");
    Expect(0, 6479, '\p{^Is_Blk=_ LIMBU}', "");
    Expect(0, 6479, '\P{Is_Blk=_ LIMBU}', "");
    Expect(1, 6479, '\P{^Is_Blk=_ LIMBU}', "");
    Expect(0, 6480, '\p{Is_Blk=_ LIMBU}', "");
    Expect(1, 6480, '\p{^Is_Blk=_ LIMBU}', "");
    Expect(1, 6480, '\P{Is_Blk=_ LIMBU}', "");
    Expect(0, 6480, '\P{^Is_Blk=_ LIMBU}', "");
    Error('\p{Block:   	_Linear_a/a/}');
    Error('\P{Block:   	_Linear_a/a/}');
    Expect(1, 67455, '\p{Block=lineara}', "");
    Expect(0, 67455, '\p{^Block=lineara}', "");
    Expect(0, 67455, '\P{Block=lineara}', "");
    Expect(1, 67455, '\P{^Block=lineara}', "");
    Expect(0, 67456, '\p{Block=lineara}', "");
    Expect(1, 67456, '\p{^Block=lineara}', "");
    Expect(1, 67456, '\P{Block=lineara}', "");
    Expect(0, 67456, '\P{^Block=lineara}', "");
    Expect(1, 67455, '\p{Block:   	Linear_A}', "");
    Expect(0, 67455, '\p{^Block:   	Linear_A}', "");
    Expect(0, 67455, '\P{Block:   	Linear_A}', "");
    Expect(1, 67455, '\P{^Block:   	Linear_A}', "");
    Expect(0, 67456, '\p{Block:   	Linear_A}', "");
    Expect(1, 67456, '\p{^Block:   	Linear_A}', "");
    Expect(1, 67456, '\P{Block:   	Linear_A}', "");
    Expect(0, 67456, '\P{^Block:   	Linear_A}', "");
    Error('\p{Blk:  	Linear_A:=}');
    Error('\P{Blk:  	Linear_A:=}');
    Expect(1, 67455, '\p{Blk=lineara}', "");
    Expect(0, 67455, '\p{^Blk=lineara}', "");
    Expect(0, 67455, '\P{Blk=lineara}', "");
    Expect(1, 67455, '\P{^Blk=lineara}', "");
    Expect(0, 67456, '\p{Blk=lineara}', "");
    Expect(1, 67456, '\p{^Blk=lineara}', "");
    Expect(1, 67456, '\P{Blk=lineara}', "");
    Expect(0, 67456, '\P{^Blk=lineara}', "");
    Expect(1, 67455, '\p{Blk=Linear_A}', "");
    Expect(0, 67455, '\p{^Blk=Linear_A}', "");
    Expect(0, 67455, '\P{Blk=Linear_A}', "");
    Expect(1, 67455, '\P{^Blk=Linear_A}', "");
    Expect(0, 67456, '\p{Blk=Linear_A}', "");
    Expect(1, 67456, '\p{^Blk=Linear_A}', "");
    Expect(1, 67456, '\P{Blk=Linear_A}', "");
    Expect(0, 67456, '\P{^Blk=Linear_A}', "");
    Error('\p{Is_Block: 	-LINEAR_A:=}');
    Error('\P{Is_Block: 	-LINEAR_A:=}');
    Expect(1, 67455, '\p{Is_Block=lineara}', "");
    Expect(0, 67455, '\p{^Is_Block=lineara}', "");
    Expect(0, 67455, '\P{Is_Block=lineara}', "");
    Expect(1, 67455, '\P{^Is_Block=lineara}', "");
    Expect(0, 67456, '\p{Is_Block=lineara}', "");
    Expect(1, 67456, '\p{^Is_Block=lineara}', "");
    Expect(1, 67456, '\P{Is_Block=lineara}', "");
    Expect(0, 67456, '\P{^Is_Block=lineara}', "");
    Expect(1, 67455, '\p{Is_Block=	_linear_a}', "");
    Expect(0, 67455, '\p{^Is_Block=	_linear_a}', "");
    Expect(0, 67455, '\P{Is_Block=	_linear_a}', "");
    Expect(1, 67455, '\P{^Is_Block=	_linear_a}', "");
    Expect(0, 67456, '\p{Is_Block=	_linear_a}', "");
    Expect(1, 67456, '\p{^Is_Block=	_linear_a}', "");
    Expect(1, 67456, '\P{Is_Block=	_linear_a}', "");
    Expect(0, 67456, '\P{^Is_Block=	_linear_a}', "");
    Error('\p{Is_Blk=:=	Linear_a}');
    Error('\P{Is_Blk=:=	Linear_a}');
    Expect(1, 67455, '\p{Is_Blk=lineara}', "");
    Expect(0, 67455, '\p{^Is_Blk=lineara}', "");
    Expect(0, 67455, '\P{Is_Blk=lineara}', "");
    Expect(1, 67455, '\P{^Is_Blk=lineara}', "");
    Expect(0, 67456, '\p{Is_Blk=lineara}', "");
    Expect(1, 67456, '\p{^Is_Blk=lineara}', "");
    Expect(1, 67456, '\P{Is_Blk=lineara}', "");
    Expect(0, 67456, '\P{^Is_Blk=lineara}', "");
    Expect(1, 67455, '\p{Is_Blk:   -	Linear_a}', "");
    Expect(0, 67455, '\p{^Is_Blk:   -	Linear_a}', "");
    Expect(0, 67455, '\P{Is_Blk:   -	Linear_a}', "");
    Expect(1, 67455, '\P{^Is_Blk:   -	Linear_a}', "");
    Expect(0, 67456, '\p{Is_Blk:   -	Linear_a}', "");
    Expect(1, 67456, '\p{^Is_Blk:   -	Linear_a}', "");
    Expect(1, 67456, '\P{Is_Blk:   -	Linear_a}', "");
    Expect(0, 67456, '\P{^Is_Blk:   -	Linear_a}', "");
    Error('\p{Block:	_ LINEAR_B_Ideograms/a/}');
    Error('\P{Block:	_ LINEAR_B_Ideograms/a/}');
    Expect(1, 65791, '\p{Block=linearbideograms}', "");
    Expect(0, 65791, '\p{^Block=linearbideograms}', "");
    Expect(0, 65791, '\P{Block=linearbideograms}', "");
    Expect(1, 65791, '\P{^Block=linearbideograms}', "");
    Expect(0, 65792, '\p{Block=linearbideograms}', "");
    Expect(1, 65792, '\p{^Block=linearbideograms}', "");
    Expect(1, 65792, '\P{Block=linearbideograms}', "");
    Expect(0, 65792, '\P{^Block=linearbideograms}', "");
    Expect(1, 65791, '\p{Block=-Linear_B_ideograms}', "");
    Expect(0, 65791, '\p{^Block=-Linear_B_ideograms}', "");
    Expect(0, 65791, '\P{Block=-Linear_B_ideograms}', "");
    Expect(1, 65791, '\P{^Block=-Linear_B_ideograms}', "");
    Expect(0, 65792, '\p{Block=-Linear_B_ideograms}', "");
    Expect(1, 65792, '\p{^Block=-Linear_B_ideograms}', "");
    Expect(1, 65792, '\P{Block=-Linear_B_ideograms}', "");
    Expect(0, 65792, '\P{^Block=-Linear_B_ideograms}', "");
    Error('\p{Blk:-_LINEAR_b_IDEOGRAMS:=}');
    Error('\P{Blk:-_LINEAR_b_IDEOGRAMS:=}');
    Expect(1, 65791, '\p{Blk=linearbideograms}', "");
    Expect(0, 65791, '\p{^Blk=linearbideograms}', "");
    Expect(0, 65791, '\P{Blk=linearbideograms}', "");
    Expect(1, 65791, '\P{^Blk=linearbideograms}', "");
    Expect(0, 65792, '\p{Blk=linearbideograms}', "");
    Expect(1, 65792, '\p{^Blk=linearbideograms}', "");
    Expect(1, 65792, '\P{Blk=linearbideograms}', "");
    Expect(0, 65792, '\P{^Blk=linearbideograms}', "");
    Expect(1, 65791, '\p{Blk=	 linear_B_Ideograms}', "");
    Expect(0, 65791, '\p{^Blk=	 linear_B_Ideograms}', "");
    Expect(0, 65791, '\P{Blk=	 linear_B_Ideograms}', "");
    Expect(1, 65791, '\P{^Blk=	 linear_B_Ideograms}', "");
    Expect(0, 65792, '\p{Blk=	 linear_B_Ideograms}', "");
    Expect(1, 65792, '\p{^Blk=	 linear_B_Ideograms}', "");
    Expect(1, 65792, '\P{Blk=	 linear_B_Ideograms}', "");
    Expect(0, 65792, '\P{^Blk=	 linear_B_Ideograms}', "");
    Error('\p{Is_Block= LINEAR_B_Ideograms:=}');
    Error('\P{Is_Block= LINEAR_B_Ideograms:=}');
    Expect(1, 65791, '\p{Is_Block=linearbideograms}', "");
    Expect(0, 65791, '\p{^Is_Block=linearbideograms}', "");
    Expect(0, 65791, '\P{Is_Block=linearbideograms}', "");
    Expect(1, 65791, '\P{^Is_Block=linearbideograms}', "");
    Expect(0, 65792, '\p{Is_Block=linearbideograms}', "");
    Expect(1, 65792, '\p{^Is_Block=linearbideograms}', "");
    Expect(1, 65792, '\P{Is_Block=linearbideograms}', "");
    Expect(0, 65792, '\P{^Is_Block=linearbideograms}', "");
    Expect(1, 65791, '\p{Is_Block=	_LINEAR_B_Ideograms}', "");
    Expect(0, 65791, '\p{^Is_Block=	_LINEAR_B_Ideograms}', "");
    Expect(0, 65791, '\P{Is_Block=	_LINEAR_B_Ideograms}', "");
    Expect(1, 65791, '\P{^Is_Block=	_LINEAR_B_Ideograms}', "");
    Expect(0, 65792, '\p{Is_Block=	_LINEAR_B_Ideograms}', "");
    Expect(1, 65792, '\p{^Is_Block=	_LINEAR_B_Ideograms}', "");
    Expect(1, 65792, '\P{Is_Block=	_LINEAR_B_Ideograms}', "");
    Expect(0, 65792, '\P{^Is_Block=	_LINEAR_B_Ideograms}', "");
    Error('\p{Is_Blk=_/a/Linear_B_Ideograms}');
    Error('\P{Is_Blk=_/a/Linear_B_Ideograms}');
    Expect(1, 65791, '\p{Is_Blk=linearbideograms}', "");
    Expect(0, 65791, '\p{^Is_Blk=linearbideograms}', "");
    Expect(0, 65791, '\P{Is_Blk=linearbideograms}', "");
    Expect(1, 65791, '\P{^Is_Blk=linearbideograms}', "");
    Expect(0, 65792, '\p{Is_Blk=linearbideograms}', "");
    Expect(1, 65792, '\p{^Is_Blk=linearbideograms}', "");
    Expect(1, 65792, '\P{Is_Blk=linearbideograms}', "");
    Expect(0, 65792, '\P{^Is_Blk=linearbideograms}', "");
    Expect(1, 65791, '\p{Is_Blk= _Linear_B_Ideograms}', "");
    Expect(0, 65791, '\p{^Is_Blk= _Linear_B_Ideograms}', "");
    Expect(0, 65791, '\P{Is_Blk= _Linear_B_Ideograms}', "");
    Expect(1, 65791, '\P{^Is_Blk= _Linear_B_Ideograms}', "");
    Expect(0, 65792, '\p{Is_Blk= _Linear_B_Ideograms}', "");
    Expect(1, 65792, '\p{^Is_Blk= _Linear_B_Ideograms}', "");
    Expect(1, 65792, '\P{Is_Blk= _Linear_B_Ideograms}', "");
    Expect(0, 65792, '\P{^Is_Blk= _Linear_B_Ideograms}', "");
    Error('\p{Block= LINEAR_B_Syllabary/a/}');
    Error('\P{Block= LINEAR_B_Syllabary/a/}');
    Expect(1, 65663, '\p{Block=linearbsyllabary}', "");
    Expect(0, 65663, '\p{^Block=linearbsyllabary}', "");
    Expect(0, 65663, '\P{Block=linearbsyllabary}', "");
    Expect(1, 65663, '\P{^Block=linearbsyllabary}', "");
    Expect(0, 65664, '\p{Block=linearbsyllabary}', "");
    Expect(1, 65664, '\p{^Block=linearbsyllabary}', "");
    Expect(1, 65664, '\P{Block=linearbsyllabary}', "");
    Expect(0, 65664, '\P{^Block=linearbsyllabary}', "");
    Expect(1, 65663, '\p{Block=	Linear_b_Syllabary}', "");
    Expect(0, 65663, '\p{^Block=	Linear_b_Syllabary}', "");
    Expect(0, 65663, '\P{Block=	Linear_b_Syllabary}', "");
    Expect(1, 65663, '\P{^Block=	Linear_b_Syllabary}', "");
    Expect(0, 65664, '\p{Block=	Linear_b_Syllabary}', "");
    Expect(1, 65664, '\p{^Block=	Linear_b_Syllabary}', "");
    Expect(1, 65664, '\P{Block=	Linear_b_Syllabary}', "");
    Expect(0, 65664, '\P{^Block=	Linear_b_Syllabary}', "");
    Error('\p{Blk=-	LINEAR_B_syllabary:=}');
    Error('\P{Blk=-	LINEAR_B_syllabary:=}');
    Expect(1, 65663, '\p{Blk=linearbsyllabary}', "");
    Expect(0, 65663, '\p{^Blk=linearbsyllabary}', "");
    Expect(0, 65663, '\P{Blk=linearbsyllabary}', "");
    Expect(1, 65663, '\P{^Blk=linearbsyllabary}', "");
    Expect(0, 65664, '\p{Blk=linearbsyllabary}', "");
    Expect(1, 65664, '\p{^Blk=linearbsyllabary}', "");
    Expect(1, 65664, '\P{Blk=linearbsyllabary}', "");
    Expect(0, 65664, '\P{^Blk=linearbsyllabary}', "");
    Expect(1, 65663, '\p{Blk= -LINEAR_B_SYLLABARY}', "");
    Expect(0, 65663, '\p{^Blk= -LINEAR_B_SYLLABARY}', "");
    Expect(0, 65663, '\P{Blk= -LINEAR_B_SYLLABARY}', "");
    Expect(1, 65663, '\P{^Blk= -LINEAR_B_SYLLABARY}', "");
    Expect(0, 65664, '\p{Blk= -LINEAR_B_SYLLABARY}', "");
    Expect(1, 65664, '\p{^Blk= -LINEAR_B_SYLLABARY}', "");
    Expect(1, 65664, '\P{Blk= -LINEAR_B_SYLLABARY}', "");
    Expect(0, 65664, '\P{^Blk= -LINEAR_B_SYLLABARY}', "");
    Error('\p{Is_Block=	:=Linear_B_Syllabary}');
    Error('\P{Is_Block=	:=Linear_B_Syllabary}');
    Expect(1, 65663, '\p{Is_Block=linearbsyllabary}', "");
    Expect(0, 65663, '\p{^Is_Block=linearbsyllabary}', "");
    Expect(0, 65663, '\P{Is_Block=linearbsyllabary}', "");
    Expect(1, 65663, '\P{^Is_Block=linearbsyllabary}', "");
    Expect(0, 65664, '\p{Is_Block=linearbsyllabary}', "");
    Expect(1, 65664, '\p{^Is_Block=linearbsyllabary}', "");
    Expect(1, 65664, '\P{Is_Block=linearbsyllabary}', "");
    Expect(0, 65664, '\P{^Is_Block=linearbsyllabary}', "");
    Expect(1, 65663, '\p{Is_Block=-	linear_B_SYLLABARY}', "");
    Expect(0, 65663, '\p{^Is_Block=-	linear_B_SYLLABARY}', "");
    Expect(0, 65663, '\P{Is_Block=-	linear_B_SYLLABARY}', "");
    Expect(1, 65663, '\P{^Is_Block=-	linear_B_SYLLABARY}', "");
    Expect(0, 65664, '\p{Is_Block=-	linear_B_SYLLABARY}', "");
    Expect(1, 65664, '\p{^Is_Block=-	linear_B_SYLLABARY}', "");
    Expect(1, 65664, '\P{Is_Block=-	linear_B_SYLLABARY}', "");
    Expect(0, 65664, '\P{^Is_Block=-	linear_B_SYLLABARY}', "");
    Error('\p{Is_Blk= -Linear_B_SYLLABARY/a/}');
    Error('\P{Is_Blk= -Linear_B_SYLLABARY/a/}');
    Expect(1, 65663, '\p{Is_Blk=linearbsyllabary}', "");
    Expect(0, 65663, '\p{^Is_Blk=linearbsyllabary}', "");
    Expect(0, 65663, '\P{Is_Blk=linearbsyllabary}', "");
    Expect(1, 65663, '\P{^Is_Blk=linearbsyllabary}', "");
    Expect(0, 65664, '\p{Is_Blk=linearbsyllabary}', "");
    Expect(1, 65664, '\p{^Is_Blk=linearbsyllabary}', "");
    Expect(1, 65664, '\P{Is_Blk=linearbsyllabary}', "");
    Expect(0, 65664, '\P{^Is_Blk=linearbsyllabary}', "");
    Expect(1, 65663, '\p{Is_Blk=__LINEAR_B_SYLLABARY}', "");
    Expect(0, 65663, '\p{^Is_Blk=__LINEAR_B_SYLLABARY}', "");
    Expect(0, 65663, '\P{Is_Blk=__LINEAR_B_SYLLABARY}', "");
    Expect(1, 65663, '\P{^Is_Blk=__LINEAR_B_SYLLABARY}', "");
    Expect(0, 65664, '\p{Is_Blk=__LINEAR_B_SYLLABARY}', "");
    Expect(1, 65664, '\p{^Is_Blk=__LINEAR_B_SYLLABARY}', "");
    Expect(1, 65664, '\P{Is_Blk=__LINEAR_B_SYLLABARY}', "");
    Expect(0, 65664, '\P{^Is_Blk=__LINEAR_B_SYLLABARY}', "");
    Error('\p{Block=-	LISU/a/}');
    Error('\P{Block=-	LISU/a/}');
    Expect(1, 42239, '\p{Block=lisu}', "");
    Expect(0, 42239, '\p{^Block=lisu}', "");
    Expect(0, 42239, '\P{Block=lisu}', "");
    Expect(1, 42239, '\P{^Block=lisu}', "");
    Expect(0, 42240, '\p{Block=lisu}', "");
    Expect(1, 42240, '\p{^Block=lisu}', "");
    Expect(1, 42240, '\P{Block=lisu}', "");
    Expect(0, 42240, '\P{^Block=lisu}', "");
    Expect(1, 42239, '\p{Block=	 LISU}', "");
    Expect(0, 42239, '\p{^Block=	 LISU}', "");
    Expect(0, 42239, '\P{Block=	 LISU}', "");
    Expect(1, 42239, '\P{^Block=	 LISU}', "");
    Expect(0, 42240, '\p{Block=	 LISU}', "");
    Expect(1, 42240, '\p{^Block=	 LISU}', "");
    Expect(1, 42240, '\P{Block=	 LISU}', "");
    Expect(0, 42240, '\P{^Block=	 LISU}', "");
    Error('\p{Blk=_/a/Lisu}');
    Error('\P{Blk=_/a/Lisu}');
    Expect(1, 42239, '\p{Blk:	lisu}', "");
    Expect(0, 42239, '\p{^Blk:	lisu}', "");
    Expect(0, 42239, '\P{Blk:	lisu}', "");
    Expect(1, 42239, '\P{^Blk:	lisu}', "");
    Expect(0, 42240, '\p{Blk:	lisu}', "");
    Expect(1, 42240, '\p{^Blk:	lisu}', "");
    Expect(1, 42240, '\P{Blk:	lisu}', "");
    Expect(0, 42240, '\P{^Blk:	lisu}', "");
    Expect(1, 42239, '\p{Blk=_lisu}', "");
    Expect(0, 42239, '\p{^Blk=_lisu}', "");
    Expect(0, 42239, '\P{Blk=_lisu}', "");
    Expect(1, 42239, '\P{^Blk=_lisu}', "");
    Expect(0, 42240, '\p{Blk=_lisu}', "");
    Expect(1, 42240, '\p{^Blk=_lisu}', "");
    Expect(1, 42240, '\P{Blk=_lisu}', "");
    Expect(0, 42240, '\P{^Blk=_lisu}', "");
    Error('\p{Is_Block=/a/--LISU}');
    Error('\P{Is_Block=/a/--LISU}');
    Expect(1, 42239, '\p{Is_Block=lisu}', "");
    Expect(0, 42239, '\p{^Is_Block=lisu}', "");
    Expect(0, 42239, '\P{Is_Block=lisu}', "");
    Expect(1, 42239, '\P{^Is_Block=lisu}', "");
    Expect(0, 42240, '\p{Is_Block=lisu}', "");
    Expect(1, 42240, '\p{^Is_Block=lisu}', "");
    Expect(1, 42240, '\P{Is_Block=lisu}', "");
    Expect(0, 42240, '\P{^Is_Block=lisu}', "");
    Expect(1, 42239, '\p{Is_Block=_-Lisu}', "");
    Expect(0, 42239, '\p{^Is_Block=_-Lisu}', "");
    Expect(0, 42239, '\P{Is_Block=_-Lisu}', "");
    Expect(1, 42239, '\P{^Is_Block=_-Lisu}', "");
    Expect(0, 42240, '\p{Is_Block=_-Lisu}', "");
    Expect(1, 42240, '\p{^Is_Block=_-Lisu}', "");
    Expect(1, 42240, '\P{Is_Block=_-Lisu}', "");
    Expect(0, 42240, '\P{^Is_Block=_-Lisu}', "");
    Error('\p{Is_Blk=:=_ Lisu}');
    Error('\P{Is_Blk=:=_ Lisu}');
    Expect(1, 42239, '\p{Is_Blk: lisu}', "");
    Expect(0, 42239, '\p{^Is_Blk: lisu}', "");
    Expect(0, 42239, '\P{Is_Blk: lisu}', "");
    Expect(1, 42239, '\P{^Is_Blk: lisu}', "");
    Expect(0, 42240, '\p{Is_Blk: lisu}', "");
    Expect(1, 42240, '\p{^Is_Blk: lisu}', "");
    Expect(1, 42240, '\P{Is_Blk: lisu}', "");
    Expect(0, 42240, '\P{^Is_Blk: lisu}', "");
    Expect(1, 42239, '\p{Is_Blk= _Lisu}', "");
    Expect(0, 42239, '\p{^Is_Blk= _Lisu}', "");
    Expect(0, 42239, '\P{Is_Blk= _Lisu}', "");
    Expect(1, 42239, '\P{^Is_Blk= _Lisu}', "");
    Expect(0, 42240, '\p{Is_Blk= _Lisu}', "");
    Expect(1, 42240, '\p{^Is_Blk= _Lisu}', "");
    Expect(1, 42240, '\P{Is_Blk= _Lisu}', "");
    Expect(0, 42240, '\P{^Is_Blk= _Lisu}', "");
    Error('\p{Block:-LOW_Surrogates:=}');
    Error('\P{Block:-LOW_Surrogates:=}');
    Expect(1, 57343, '\p{Block=lowsurrogates}', "");
    Expect(0, 57343, '\p{^Block=lowsurrogates}', "");
    Expect(0, 57343, '\P{Block=lowsurrogates}', "");
    Expect(1, 57343, '\P{^Block=lowsurrogates}', "");
    Expect(0, 57344, '\p{Block=lowsurrogates}', "");
    Expect(1, 57344, '\p{^Block=lowsurrogates}', "");
    Expect(1, 57344, '\P{Block=lowsurrogates}', "");
    Expect(0, 57344, '\P{^Block=lowsurrogates}', "");
    Expect(1, 57343, '\p{Block=	-low_Surrogates}', "");
    Expect(0, 57343, '\p{^Block=	-low_Surrogates}', "");
    Expect(0, 57343, '\P{Block=	-low_Surrogates}', "");
    Expect(1, 57343, '\P{^Block=	-low_Surrogates}', "");
    Expect(0, 57344, '\p{Block=	-low_Surrogates}', "");
    Expect(1, 57344, '\p{^Block=	-low_Surrogates}', "");
    Expect(1, 57344, '\P{Block=	-low_Surrogates}', "");
    Expect(0, 57344, '\P{^Block=	-low_Surrogates}', "");
    Error('\p{Blk=- low_SURROGATES/a/}');
    Error('\P{Blk=- low_SURROGATES/a/}');
    Expect(1, 57343, '\p{Blk=lowsurrogates}', "");
    Expect(0, 57343, '\p{^Blk=lowsurrogates}', "");
    Expect(0, 57343, '\P{Blk=lowsurrogates}', "");
    Expect(1, 57343, '\P{^Blk=lowsurrogates}', "");
    Expect(0, 57344, '\p{Blk=lowsurrogates}', "");
    Expect(1, 57344, '\p{^Blk=lowsurrogates}', "");
    Expect(1, 57344, '\P{Blk=lowsurrogates}', "");
    Expect(0, 57344, '\P{^Blk=lowsurrogates}', "");
    Expect(1, 57343, '\p{Blk=		low_SURROGATES}', "");
    Expect(0, 57343, '\p{^Blk=		low_SURROGATES}', "");
    Expect(0, 57343, '\P{Blk=		low_SURROGATES}', "");
    Expect(1, 57343, '\P{^Blk=		low_SURROGATES}', "");
    Expect(0, 57344, '\p{Blk=		low_SURROGATES}', "");
    Expect(1, 57344, '\p{^Blk=		low_SURROGATES}', "");
    Expect(1, 57344, '\P{Blk=		low_SURROGATES}', "");
    Expect(0, 57344, '\P{^Blk=		low_SURROGATES}', "");
    Error('\p{Is_Block: 	Low_Surrogates:=}');
    Error('\P{Is_Block: 	Low_Surrogates:=}');
    Expect(1, 57343, '\p{Is_Block=lowsurrogates}', "");
    Expect(0, 57343, '\p{^Is_Block=lowsurrogates}', "");
    Expect(0, 57343, '\P{Is_Block=lowsurrogates}', "");
    Expect(1, 57343, '\P{^Is_Block=lowsurrogates}', "");
    Expect(0, 57344, '\p{Is_Block=lowsurrogates}', "");
    Expect(1, 57344, '\p{^Is_Block=lowsurrogates}', "");
    Expect(1, 57344, '\P{Is_Block=lowsurrogates}', "");
    Expect(0, 57344, '\P{^Is_Block=lowsurrogates}', "");
    Expect(1, 57343, '\p{Is_Block=  Low_SURROGATES}', "");
    Expect(0, 57343, '\p{^Is_Block=  Low_SURROGATES}', "");
    Expect(0, 57343, '\P{Is_Block=  Low_SURROGATES}', "");
    Expect(1, 57343, '\P{^Is_Block=  Low_SURROGATES}', "");
    Expect(0, 57344, '\p{Is_Block=  Low_SURROGATES}', "");
    Expect(1, 57344, '\p{^Is_Block=  Low_SURROGATES}', "");
    Expect(1, 57344, '\P{Is_Block=  Low_SURROGATES}', "");
    Expect(0, 57344, '\P{^Is_Block=  Low_SURROGATES}', "");
    Error('\p{Is_Blk:/a/- Low_SURROGATES}');
    Error('\P{Is_Blk:/a/- Low_SURROGATES}');
    Expect(1, 57343, '\p{Is_Blk=lowsurrogates}', "");
    Expect(0, 57343, '\p{^Is_Blk=lowsurrogates}', "");
    Expect(0, 57343, '\P{Is_Blk=lowsurrogates}', "");
    Expect(1, 57343, '\P{^Is_Blk=lowsurrogates}', "");
    Expect(0, 57344, '\p{Is_Blk=lowsurrogates}', "");
    Expect(1, 57344, '\p{^Is_Blk=lowsurrogates}', "");
    Expect(1, 57344, '\P{Is_Blk=lowsurrogates}', "");
    Expect(0, 57344, '\P{^Is_Blk=lowsurrogates}', "");
    Expect(1, 57343, '\p{Is_Blk=	-Low_SURROGATES}', "");
    Expect(0, 57343, '\p{^Is_Blk=	-Low_SURROGATES}', "");
    Expect(0, 57343, '\P{Is_Blk=	-Low_SURROGATES}', "");
    Expect(1, 57343, '\P{^Is_Blk=	-Low_SURROGATES}', "");
    Expect(0, 57344, '\p{Is_Blk=	-Low_SURROGATES}', "");
    Expect(1, 57344, '\p{^Is_Blk=	-Low_SURROGATES}', "");
    Expect(1, 57344, '\P{Is_Blk=	-Low_SURROGATES}', "");
    Expect(0, 57344, '\P{^Is_Blk=	-Low_SURROGATES}', "");
    Error('\p{Block=-/a/Lycian}');
    Error('\P{Block=-/a/Lycian}');
    Expect(1, 66207, '\p{Block=lycian}', "");
    Expect(0, 66207, '\p{^Block=lycian}', "");
    Expect(0, 66207, '\P{Block=lycian}', "");
    Expect(1, 66207, '\P{^Block=lycian}', "");
    Expect(0, 66208, '\p{Block=lycian}', "");
    Expect(1, 66208, '\p{^Block=lycian}', "");
    Expect(1, 66208, '\P{Block=lycian}', "");
    Expect(0, 66208, '\P{^Block=lycian}', "");
    Expect(1, 66207, '\p{Block=	Lycian}', "");
    Expect(0, 66207, '\p{^Block=	Lycian}', "");
    Expect(0, 66207, '\P{Block=	Lycian}', "");
    Expect(1, 66207, '\P{^Block=	Lycian}', "");
    Expect(0, 66208, '\p{Block=	Lycian}', "");
    Expect(1, 66208, '\p{^Block=	Lycian}', "");
    Expect(1, 66208, '\P{Block=	Lycian}', "");
    Expect(0, 66208, '\P{^Block=	Lycian}', "");
    Error('\p{Blk=	-Lycian:=}');
    Error('\P{Blk=	-Lycian:=}');
    Expect(1, 66207, '\p{Blk=lycian}', "");
    Expect(0, 66207, '\p{^Blk=lycian}', "");
    Expect(0, 66207, '\P{Blk=lycian}', "");
    Expect(1, 66207, '\P{^Blk=lycian}', "");
    Expect(0, 66208, '\p{Blk=lycian}', "");
    Expect(1, 66208, '\p{^Blk=lycian}', "");
    Expect(1, 66208, '\P{Blk=lycian}', "");
    Expect(0, 66208, '\P{^Blk=lycian}', "");
    Expect(1, 66207, '\p{Blk=-	Lycian}', "");
    Expect(0, 66207, '\p{^Blk=-	Lycian}', "");
    Expect(0, 66207, '\P{Blk=-	Lycian}', "");
    Expect(1, 66207, '\P{^Blk=-	Lycian}', "");
    Expect(0, 66208, '\p{Blk=-	Lycian}', "");
    Expect(1, 66208, '\p{^Blk=-	Lycian}', "");
    Expect(1, 66208, '\P{Blk=-	Lycian}', "");
    Expect(0, 66208, '\P{^Blk=-	Lycian}', "");
    Error('\p{Is_Block=:=_ Lycian}');
    Error('\P{Is_Block=:=_ Lycian}');
    Expect(1, 66207, '\p{Is_Block=lycian}', "");
    Expect(0, 66207, '\p{^Is_Block=lycian}', "");
    Expect(0, 66207, '\P{Is_Block=lycian}', "");
    Expect(1, 66207, '\P{^Is_Block=lycian}', "");
    Expect(0, 66208, '\p{Is_Block=lycian}', "");
    Expect(1, 66208, '\p{^Is_Block=lycian}', "");
    Expect(1, 66208, '\P{Is_Block=lycian}', "");
    Expect(0, 66208, '\P{^Is_Block=lycian}', "");
    Expect(1, 66207, '\p{Is_Block=  Lycian}', "");
    Expect(0, 66207, '\p{^Is_Block=  Lycian}', "");
    Expect(0, 66207, '\P{Is_Block=  Lycian}', "");
    Expect(1, 66207, '\P{^Is_Block=  Lycian}', "");
    Expect(0, 66208, '\p{Is_Block=  Lycian}', "");
    Expect(1, 66208, '\p{^Is_Block=  Lycian}', "");
    Expect(1, 66208, '\P{Is_Block=  Lycian}', "");
    Expect(0, 66208, '\P{^Is_Block=  Lycian}', "");
    Error('\p{Is_Blk=_/a/lycian}');
    Error('\P{Is_Blk=_/a/lycian}');
    Expect(1, 66207, '\p{Is_Blk=lycian}', "");
    Expect(0, 66207, '\p{^Is_Blk=lycian}', "");
    Expect(0, 66207, '\P{Is_Blk=lycian}', "");
    Expect(1, 66207, '\P{^Is_Blk=lycian}', "");
    Expect(0, 66208, '\p{Is_Blk=lycian}', "");
    Expect(1, 66208, '\p{^Is_Blk=lycian}', "");
    Expect(1, 66208, '\P{Is_Blk=lycian}', "");
    Expect(0, 66208, '\P{^Is_Blk=lycian}', "");
    Expect(1, 66207, '\p{Is_Blk=-Lycian}', "");
    Expect(0, 66207, '\p{^Is_Blk=-Lycian}', "");
    Expect(0, 66207, '\P{Is_Blk=-Lycian}', "");
    Expect(1, 66207, '\P{^Is_Blk=-Lycian}', "");
    Expect(0, 66208, '\p{Is_Blk=-Lycian}', "");
    Expect(1, 66208, '\p{^Is_Blk=-Lycian}', "");
    Expect(1, 66208, '\P{Is_Blk=-Lycian}', "");
    Expect(0, 66208, '\P{^Is_Blk=-Lycian}', "");
    Error('\p{Block=	LYDIAN:=}');
    Error('\P{Block=	LYDIAN:=}');
    Expect(1, 67903, '\p{Block=lydian}', "");
    Expect(0, 67903, '\p{^Block=lydian}', "");
    Expect(0, 67903, '\P{Block=lydian}', "");
    Expect(1, 67903, '\P{^Block=lydian}', "");
    Expect(0, 67904, '\p{Block=lydian}', "");
    Expect(1, 67904, '\p{^Block=lydian}', "");
    Expect(1, 67904, '\P{Block=lydian}', "");
    Expect(0, 67904, '\P{^Block=lydian}', "");
    Expect(1, 67903, '\p{Block=- Lydian}', "");
    Expect(0, 67903, '\p{^Block=- Lydian}', "");
    Expect(0, 67903, '\P{Block=- Lydian}', "");
    Expect(1, 67903, '\P{^Block=- Lydian}', "");
    Expect(0, 67904, '\p{Block=- Lydian}', "");
    Expect(1, 67904, '\p{^Block=- Lydian}', "");
    Expect(1, 67904, '\P{Block=- Lydian}', "");
    Expect(0, 67904, '\P{^Block=- Lydian}', "");
    Error('\p{Blk=/a/ -LYDIAN}');
    Error('\P{Blk=/a/ -LYDIAN}');
    Expect(1, 67903, '\p{Blk=lydian}', "");
    Expect(0, 67903, '\p{^Blk=lydian}', "");
    Expect(0, 67903, '\P{Blk=lydian}', "");
    Expect(1, 67903, '\P{^Blk=lydian}', "");
    Expect(0, 67904, '\p{Blk=lydian}', "");
    Expect(1, 67904, '\p{^Blk=lydian}', "");
    Expect(1, 67904, '\P{Blk=lydian}', "");
    Expect(0, 67904, '\P{^Blk=lydian}', "");
    Expect(1, 67903, '\p{Blk=	Lydian}', "");
    Expect(0, 67903, '\p{^Blk=	Lydian}', "");
    Expect(0, 67903, '\P{Blk=	Lydian}', "");
    Expect(1, 67903, '\P{^Blk=	Lydian}', "");
    Expect(0, 67904, '\p{Blk=	Lydian}', "");
    Expect(1, 67904, '\p{^Blk=	Lydian}', "");
    Expect(1, 67904, '\P{Blk=	Lydian}', "");
    Expect(0, 67904, '\P{^Blk=	Lydian}', "");
    Error('\p{Is_Block=_Lydian:=}');
    Error('\P{Is_Block=_Lydian:=}');
    Expect(1, 67903, '\p{Is_Block=lydian}', "");
    Expect(0, 67903, '\p{^Is_Block=lydian}', "");
    Expect(0, 67903, '\P{Is_Block=lydian}', "");
    Expect(1, 67903, '\P{^Is_Block=lydian}', "");
    Expect(0, 67904, '\p{Is_Block=lydian}', "");
    Expect(1, 67904, '\p{^Is_Block=lydian}', "");
    Expect(1, 67904, '\P{Is_Block=lydian}', "");
    Expect(0, 67904, '\P{^Is_Block=lydian}', "");
    Expect(1, 67903, '\p{Is_Block=_	Lydian}', "");
    Expect(0, 67903, '\p{^Is_Block=_	Lydian}', "");
    Expect(0, 67903, '\P{Is_Block=_	Lydian}', "");
    Expect(1, 67903, '\P{^Is_Block=_	Lydian}', "");
    Expect(0, 67904, '\p{Is_Block=_	Lydian}', "");
    Expect(1, 67904, '\p{^Is_Block=_	Lydian}', "");
    Expect(1, 67904, '\P{Is_Block=_	Lydian}', "");
    Expect(0, 67904, '\P{^Is_Block=_	Lydian}', "");
    Error('\p{Is_Blk=/a/-	LYDIAN}');
    Error('\P{Is_Blk=/a/-	LYDIAN}');
    Expect(1, 67903, '\p{Is_Blk: lydian}', "");
    Expect(0, 67903, '\p{^Is_Blk: lydian}', "");
    Expect(0, 67903, '\P{Is_Blk: lydian}', "");
    Expect(1, 67903, '\P{^Is_Blk: lydian}', "");
    Expect(0, 67904, '\p{Is_Blk: lydian}', "");
    Expect(1, 67904, '\p{^Is_Blk: lydian}', "");
    Expect(1, 67904, '\P{Is_Blk: lydian}', "");
    Expect(0, 67904, '\P{^Is_Blk: lydian}', "");
    Expect(1, 67903, '\p{Is_Blk= 	Lydian}', "");
    Expect(0, 67903, '\p{^Is_Blk= 	Lydian}', "");
    Expect(0, 67903, '\P{Is_Blk= 	Lydian}', "");
    Expect(1, 67903, '\P{^Is_Blk= 	Lydian}', "");
    Expect(0, 67904, '\p{Is_Blk= 	Lydian}', "");
    Expect(1, 67904, '\p{^Is_Blk= 	Lydian}', "");
    Expect(1, 67904, '\P{Is_Blk= 	Lydian}', "");
    Expect(0, 67904, '\P{^Is_Blk= 	Lydian}', "");
    Error('\p{Block: Mahajani/a/}');
    Error('\P{Block: Mahajani/a/}');
    Expect(1, 70015, '\p{Block: mahajani}', "");
    Expect(0, 70015, '\p{^Block: mahajani}', "");
    Expect(0, 70015, '\P{Block: mahajani}', "");
    Expect(1, 70015, '\P{^Block: mahajani}', "");
    Expect(0, 70016, '\p{Block: mahajani}', "");
    Expect(1, 70016, '\p{^Block: mahajani}', "");
    Expect(1, 70016, '\P{Block: mahajani}', "");
    Expect(0, 70016, '\P{^Block: mahajani}', "");
    Expect(1, 70015, '\p{Block=_ Mahajani}', "");
    Expect(0, 70015, '\p{^Block=_ Mahajani}', "");
    Expect(0, 70015, '\P{Block=_ Mahajani}', "");
    Expect(1, 70015, '\P{^Block=_ Mahajani}', "");
    Expect(0, 70016, '\p{Block=_ Mahajani}', "");
    Expect(1, 70016, '\p{^Block=_ Mahajani}', "");
    Expect(1, 70016, '\P{Block=_ Mahajani}', "");
    Expect(0, 70016, '\P{^Block=_ Mahajani}', "");
    Error('\p{Blk::=  Mahajani}');
    Error('\P{Blk::=  Mahajani}');
    Expect(1, 70015, '\p{Blk=mahajani}', "");
    Expect(0, 70015, '\p{^Blk=mahajani}', "");
    Expect(0, 70015, '\P{Blk=mahajani}', "");
    Expect(1, 70015, '\P{^Blk=mahajani}', "");
    Expect(0, 70016, '\p{Blk=mahajani}', "");
    Expect(1, 70016, '\p{^Blk=mahajani}', "");
    Expect(1, 70016, '\P{Blk=mahajani}', "");
    Expect(0, 70016, '\P{^Blk=mahajani}', "");
    Expect(1, 70015, '\p{Blk=	 Mahajani}', "");
    Expect(0, 70015, '\p{^Blk=	 Mahajani}', "");
    Expect(0, 70015, '\P{Blk=	 Mahajani}', "");
    Expect(1, 70015, '\P{^Blk=	 Mahajani}', "");
    Expect(0, 70016, '\p{Blk=	 Mahajani}', "");
    Expect(1, 70016, '\p{^Blk=	 Mahajani}', "");
    Expect(1, 70016, '\P{Blk=	 Mahajani}', "");
    Expect(0, 70016, '\P{^Blk=	 Mahajani}', "");
    Error('\p{Is_Block=_/a/MAHAJANI}');
    Error('\P{Is_Block=_/a/MAHAJANI}');
    Expect(1, 70015, '\p{Is_Block=mahajani}', "");
    Expect(0, 70015, '\p{^Is_Block=mahajani}', "");
    Expect(0, 70015, '\P{Is_Block=mahajani}', "");
    Expect(1, 70015, '\P{^Is_Block=mahajani}', "");
    Expect(0, 70016, '\p{Is_Block=mahajani}', "");
    Expect(1, 70016, '\p{^Is_Block=mahajani}', "");
    Expect(1, 70016, '\P{Is_Block=mahajani}', "");
    Expect(0, 70016, '\P{^Is_Block=mahajani}', "");
    Expect(1, 70015, '\p{Is_Block=__Mahajani}', "");
    Expect(0, 70015, '\p{^Is_Block=__Mahajani}', "");
    Expect(0, 70015, '\P{Is_Block=__Mahajani}', "");
    Expect(1, 70015, '\P{^Is_Block=__Mahajani}', "");
    Expect(0, 70016, '\p{Is_Block=__Mahajani}', "");
    Expect(1, 70016, '\p{^Is_Block=__Mahajani}', "");
    Expect(1, 70016, '\P{Is_Block=__Mahajani}', "");
    Expect(0, 70016, '\P{^Is_Block=__Mahajani}', "");
    Error('\p{Is_Blk=/a/	Mahajani}');
    Error('\P{Is_Blk=/a/	Mahajani}');
    Expect(1, 70015, '\p{Is_Blk=mahajani}', "");
    Expect(0, 70015, '\p{^Is_Blk=mahajani}', "");
    Expect(0, 70015, '\P{Is_Blk=mahajani}', "");
    Expect(1, 70015, '\P{^Is_Blk=mahajani}', "");
    Expect(0, 70016, '\p{Is_Blk=mahajani}', "");
    Expect(1, 70016, '\p{^Is_Blk=mahajani}', "");
    Expect(1, 70016, '\P{Is_Blk=mahajani}', "");
    Expect(0, 70016, '\P{^Is_Blk=mahajani}', "");
    Expect(1, 70015, '\p{Is_Blk=- Mahajani}', "");
    Expect(0, 70015, '\p{^Is_Blk=- Mahajani}', "");
    Expect(0, 70015, '\P{Is_Blk=- Mahajani}', "");
    Expect(1, 70015, '\P{^Is_Blk=- Mahajani}', "");
    Expect(0, 70016, '\p{Is_Blk=- Mahajani}', "");
    Expect(1, 70016, '\p{^Is_Blk=- Mahajani}', "");
    Expect(1, 70016, '\P{Is_Blk=- Mahajani}', "");
    Expect(0, 70016, '\P{^Is_Blk=- Mahajani}', "");
    Error('\p{Block=:=		mahjong_Tiles}');
    Error('\P{Block=:=		mahjong_Tiles}');
    Expect(1, 127023, '\p{Block=mahjongtiles}', "");
    Expect(0, 127023, '\p{^Block=mahjongtiles}', "");
    Expect(0, 127023, '\P{Block=mahjongtiles}', "");
    Expect(1, 127023, '\P{^Block=mahjongtiles}', "");
    Expect(0, 127024, '\p{Block=mahjongtiles}', "");
    Expect(1, 127024, '\p{^Block=mahjongtiles}', "");
    Expect(1, 127024, '\P{Block=mahjongtiles}', "");
    Expect(0, 127024, '\P{^Block=mahjongtiles}', "");
    Expect(1, 127023, '\p{Block= _Mahjong_tiles}', "");
    Expect(0, 127023, '\p{^Block= _Mahjong_tiles}', "");
    Expect(0, 127023, '\P{Block= _Mahjong_tiles}', "");
    Expect(1, 127023, '\P{^Block= _Mahjong_tiles}', "");
    Expect(0, 127024, '\p{Block= _Mahjong_tiles}', "");
    Expect(1, 127024, '\p{^Block= _Mahjong_tiles}', "");
    Expect(1, 127024, '\P{Block= _Mahjong_tiles}', "");
    Expect(0, 127024, '\P{^Block= _Mahjong_tiles}', "");
    Error('\p{Blk=_Mahjong:=}');
    Error('\P{Blk=_Mahjong:=}');
    Expect(1, 127023, '\p{Blk=mahjong}', "");
    Expect(0, 127023, '\p{^Blk=mahjong}', "");
    Expect(0, 127023, '\P{Blk=mahjong}', "");
    Expect(1, 127023, '\P{^Blk=mahjong}', "");
    Expect(0, 127024, '\p{Blk=mahjong}', "");
    Expect(1, 127024, '\p{^Blk=mahjong}', "");
    Expect(1, 127024, '\P{Blk=mahjong}', "");
    Expect(0, 127024, '\P{^Blk=mahjong}', "");
    Expect(1, 127023, '\p{Blk=	_mahjong}', "");
    Expect(0, 127023, '\p{^Blk=	_mahjong}', "");
    Expect(0, 127023, '\P{Blk=	_mahjong}', "");
    Expect(1, 127023, '\P{^Blk=	_mahjong}', "");
    Expect(0, 127024, '\p{Blk=	_mahjong}', "");
    Expect(1, 127024, '\p{^Blk=	_mahjong}', "");
    Expect(1, 127024, '\P{Blk=	_mahjong}', "");
    Expect(0, 127024, '\P{^Blk=	_mahjong}', "");
    Error('\p{Is_Block=-MAHJONG_TILES/a/}');
    Error('\P{Is_Block=-MAHJONG_TILES/a/}');
    Expect(1, 127023, '\p{Is_Block=mahjongtiles}', "");
    Expect(0, 127023, '\p{^Is_Block=mahjongtiles}', "");
    Expect(0, 127023, '\P{Is_Block=mahjongtiles}', "");
    Expect(1, 127023, '\P{^Is_Block=mahjongtiles}', "");
    Expect(0, 127024, '\p{Is_Block=mahjongtiles}', "");
    Expect(1, 127024, '\p{^Is_Block=mahjongtiles}', "");
    Expect(1, 127024, '\P{Is_Block=mahjongtiles}', "");
    Expect(0, 127024, '\P{^Is_Block=mahjongtiles}', "");
    Expect(1, 127023, '\p{Is_Block=_Mahjong_tiles}', "");
    Expect(0, 127023, '\p{^Is_Block=_Mahjong_tiles}', "");
    Expect(0, 127023, '\P{Is_Block=_Mahjong_tiles}', "");
    Expect(1, 127023, '\P{^Is_Block=_Mahjong_tiles}', "");
    Expect(0, 127024, '\p{Is_Block=_Mahjong_tiles}', "");
    Expect(1, 127024, '\p{^Is_Block=_Mahjong_tiles}', "");
    Expect(1, 127024, '\P{Is_Block=_Mahjong_tiles}', "");
    Expect(0, 127024, '\P{^Is_Block=_Mahjong_tiles}', "");
    Error('\p{Is_Blk=:= Mahjong}');
    Error('\P{Is_Blk=:= Mahjong}');
    Expect(1, 127023, '\p{Is_Blk=mahjong}', "");
    Expect(0, 127023, '\p{^Is_Blk=mahjong}', "");
    Expect(0, 127023, '\P{Is_Blk=mahjong}', "");
    Expect(1, 127023, '\P{^Is_Blk=mahjong}', "");
    Expect(0, 127024, '\p{Is_Blk=mahjong}', "");
    Expect(1, 127024, '\p{^Is_Blk=mahjong}', "");
    Expect(1, 127024, '\P{Is_Blk=mahjong}', "");
    Expect(0, 127024, '\P{^Is_Blk=mahjong}', "");
    Expect(1, 127023, '\p{Is_Blk:	 MAHJONG}', "");
    Expect(0, 127023, '\p{^Is_Blk:	 MAHJONG}', "");
    Expect(0, 127023, '\P{Is_Blk:	 MAHJONG}', "");
    Expect(1, 127023, '\P{^Is_Blk:	 MAHJONG}', "");
    Expect(0, 127024, '\p{Is_Blk:	 MAHJONG}', "");
    Expect(1, 127024, '\p{^Is_Blk:	 MAHJONG}', "");
    Expect(1, 127024, '\P{Is_Blk:	 MAHJONG}', "");
    Expect(0, 127024, '\P{^Is_Blk:	 MAHJONG}', "");
    Error('\p{Block=	malayalam/a/}');
    Error('\P{Block=	malayalam/a/}');
    Expect(1, 3455, '\p{Block=malayalam}', "");
    Expect(0, 3455, '\p{^Block=malayalam}', "");
    Expect(0, 3455, '\P{Block=malayalam}', "");
    Expect(1, 3455, '\P{^Block=malayalam}', "");
    Expect(0, 3456, '\p{Block=malayalam}', "");
    Expect(1, 3456, '\p{^Block=malayalam}', "");
    Expect(1, 3456, '\P{Block=malayalam}', "");
    Expect(0, 3456, '\P{^Block=malayalam}', "");
    Expect(1, 3455, '\p{Block= _malayalam}', "");
    Expect(0, 3455, '\p{^Block= _malayalam}', "");
    Expect(0, 3455, '\P{Block= _malayalam}', "");
    Expect(1, 3455, '\P{^Block= _malayalam}', "");
    Expect(0, 3456, '\p{Block= _malayalam}', "");
    Expect(1, 3456, '\p{^Block= _malayalam}', "");
    Expect(1, 3456, '\P{Block= _malayalam}', "");
    Expect(0, 3456, '\P{^Block= _malayalam}', "");
    Error('\p{Blk=		malayalam:=}');
    Error('\P{Blk=		malayalam:=}');
    Expect(1, 3455, '\p{Blk=malayalam}', "");
    Expect(0, 3455, '\p{^Blk=malayalam}', "");
    Expect(0, 3455, '\P{Blk=malayalam}', "");
    Expect(1, 3455, '\P{^Blk=malayalam}', "");
    Expect(0, 3456, '\p{Blk=malayalam}', "");
    Expect(1, 3456, '\p{^Blk=malayalam}', "");
    Expect(1, 3456, '\P{Blk=malayalam}', "");
    Expect(0, 3456, '\P{^Blk=malayalam}', "");
    Expect(1, 3455, '\p{Blk=	-Malayalam}', "");
    Expect(0, 3455, '\p{^Blk=	-Malayalam}', "");
    Expect(0, 3455, '\P{Blk=	-Malayalam}', "");
    Expect(1, 3455, '\P{^Blk=	-Malayalam}', "");
    Expect(0, 3456, '\p{Blk=	-Malayalam}', "");
    Expect(1, 3456, '\p{^Blk=	-Malayalam}', "");
    Expect(1, 3456, '\P{Blk=	-Malayalam}', "");
    Expect(0, 3456, '\P{^Blk=	-Malayalam}', "");
    Error('\p{Is_Block=:=MALAYALAM}');
    Error('\P{Is_Block=:=MALAYALAM}');
    Expect(1, 3455, '\p{Is_Block=malayalam}', "");
    Expect(0, 3455, '\p{^Is_Block=malayalam}', "");
    Expect(0, 3455, '\P{Is_Block=malayalam}', "");
    Expect(1, 3455, '\P{^Is_Block=malayalam}', "");
    Expect(0, 3456, '\p{Is_Block=malayalam}', "");
    Expect(1, 3456, '\p{^Is_Block=malayalam}', "");
    Expect(1, 3456, '\P{Is_Block=malayalam}', "");
    Expect(0, 3456, '\P{^Is_Block=malayalam}', "");
    Expect(1, 3455, '\p{Is_Block=		Malayalam}', "");
    Expect(0, 3455, '\p{^Is_Block=		Malayalam}', "");
    Expect(0, 3455, '\P{Is_Block=		Malayalam}', "");
    Expect(1, 3455, '\P{^Is_Block=		Malayalam}', "");
    Expect(0, 3456, '\p{Is_Block=		Malayalam}', "");
    Expect(1, 3456, '\p{^Is_Block=		Malayalam}', "");
    Expect(1, 3456, '\P{Is_Block=		Malayalam}', "");
    Expect(0, 3456, '\P{^Is_Block=		Malayalam}', "");
    Error('\p{Is_Blk=:=	-Malayalam}');
    Error('\P{Is_Blk=:=	-Malayalam}');
    Expect(1, 3455, '\p{Is_Blk:malayalam}', "");
    Expect(0, 3455, '\p{^Is_Blk:malayalam}', "");
    Expect(0, 3455, '\P{Is_Blk:malayalam}', "");
    Expect(1, 3455, '\P{^Is_Blk:malayalam}', "");
    Expect(0, 3456, '\p{Is_Blk:malayalam}', "");
    Expect(1, 3456, '\p{^Is_Blk:malayalam}', "");
    Expect(1, 3456, '\P{Is_Blk:malayalam}', "");
    Expect(0, 3456, '\P{^Is_Blk:malayalam}', "");
    Expect(1, 3455, '\p{Is_Blk=_-MALAYALAM}', "");
    Expect(0, 3455, '\p{^Is_Blk=_-MALAYALAM}', "");
    Expect(0, 3455, '\P{Is_Blk=_-MALAYALAM}', "");
    Expect(1, 3455, '\P{^Is_Blk=_-MALAYALAM}', "");
    Expect(0, 3456, '\p{Is_Blk=_-MALAYALAM}', "");
    Expect(1, 3456, '\p{^Is_Blk=_-MALAYALAM}', "");
    Expect(1, 3456, '\P{Is_Blk=_-MALAYALAM}', "");
    Expect(0, 3456, '\P{^Is_Blk=_-MALAYALAM}', "");
    Error('\p{Block=-Mandaic:=}');
    Error('\P{Block=-Mandaic:=}');
    Expect(1, 2143, '\p{Block=mandaic}', "");
    Expect(0, 2143, '\p{^Block=mandaic}', "");
    Expect(0, 2143, '\P{Block=mandaic}', "");
    Expect(1, 2143, '\P{^Block=mandaic}', "");
    Expect(0, 2144, '\p{Block=mandaic}', "");
    Expect(1, 2144, '\p{^Block=mandaic}', "");
    Expect(1, 2144, '\P{Block=mandaic}', "");
    Expect(0, 2144, '\P{^Block=mandaic}', "");
    Expect(1, 2143, '\p{Block=	_MANDAIC}', "");
    Expect(0, 2143, '\p{^Block=	_MANDAIC}', "");
    Expect(0, 2143, '\P{Block=	_MANDAIC}', "");
    Expect(1, 2143, '\P{^Block=	_MANDAIC}', "");
    Expect(0, 2144, '\p{Block=	_MANDAIC}', "");
    Expect(1, 2144, '\p{^Block=	_MANDAIC}', "");
    Expect(1, 2144, '\P{Block=	_MANDAIC}', "");
    Expect(0, 2144, '\P{^Block=	_MANDAIC}', "");
    Error('\p{Blk:	 mandaic/a/}');
    Error('\P{Blk:	 mandaic/a/}');
    Expect(1, 2143, '\p{Blk=mandaic}', "");
    Expect(0, 2143, '\p{^Blk=mandaic}', "");
    Expect(0, 2143, '\P{Blk=mandaic}', "");
    Expect(1, 2143, '\P{^Blk=mandaic}', "");
    Expect(0, 2144, '\p{Blk=mandaic}', "");
    Expect(1, 2144, '\p{^Blk=mandaic}', "");
    Expect(1, 2144, '\P{Blk=mandaic}', "");
    Expect(0, 2144, '\P{^Blk=mandaic}', "");
    Expect(1, 2143, '\p{Blk= 	Mandaic}', "");
    Expect(0, 2143, '\p{^Blk= 	Mandaic}', "");
    Expect(0, 2143, '\P{Blk= 	Mandaic}', "");
    Expect(1, 2143, '\P{^Blk= 	Mandaic}', "");
    Expect(0, 2144, '\p{Blk= 	Mandaic}', "");
    Expect(1, 2144, '\p{^Blk= 	Mandaic}', "");
    Expect(1, 2144, '\P{Blk= 	Mandaic}', "");
    Expect(0, 2144, '\P{^Blk= 	Mandaic}', "");
    Error('\p{Is_Block=__mandaic:=}');
    Error('\P{Is_Block=__mandaic:=}');
    Expect(1, 2143, '\p{Is_Block=mandaic}', "");
    Expect(0, 2143, '\p{^Is_Block=mandaic}', "");
    Expect(0, 2143, '\P{Is_Block=mandaic}', "");
    Expect(1, 2143, '\P{^Is_Block=mandaic}', "");
    Expect(0, 2144, '\p{Is_Block=mandaic}', "");
    Expect(1, 2144, '\p{^Is_Block=mandaic}', "");
    Expect(1, 2144, '\P{Is_Block=mandaic}', "");
    Expect(0, 2144, '\P{^Is_Block=mandaic}', "");
    Expect(1, 2143, '\p{Is_Block:	 Mandaic}', "");
    Expect(0, 2143, '\p{^Is_Block:	 Mandaic}', "");
    Expect(0, 2143, '\P{Is_Block:	 Mandaic}', "");
    Expect(1, 2143, '\P{^Is_Block:	 Mandaic}', "");
    Expect(0, 2144, '\p{Is_Block:	 Mandaic}', "");
    Expect(1, 2144, '\p{^Is_Block:	 Mandaic}', "");
    Expect(1, 2144, '\P{Is_Block:	 Mandaic}', "");
    Expect(0, 2144, '\P{^Is_Block:	 Mandaic}', "");
    Error('\p{Is_Blk:	:=Mandaic}');
    Error('\P{Is_Blk:	:=Mandaic}');
    Expect(1, 2143, '\p{Is_Blk=mandaic}', "");
    Expect(0, 2143, '\p{^Is_Blk=mandaic}', "");
    Expect(0, 2143, '\P{Is_Blk=mandaic}', "");
    Expect(1, 2143, '\P{^Is_Blk=mandaic}', "");
    Expect(0, 2144, '\p{Is_Blk=mandaic}', "");
    Expect(1, 2144, '\p{^Is_Blk=mandaic}', "");
    Expect(1, 2144, '\P{Is_Blk=mandaic}', "");
    Expect(0, 2144, '\P{^Is_Blk=mandaic}', "");
    Expect(1, 2143, '\p{Is_Blk: 	_Mandaic}', "");
    Expect(0, 2143, '\p{^Is_Blk: 	_Mandaic}', "");
    Expect(0, 2143, '\P{Is_Blk: 	_Mandaic}', "");
    Expect(1, 2143, '\P{^Is_Blk: 	_Mandaic}', "");
    Expect(0, 2144, '\p{Is_Blk: 	_Mandaic}', "");
    Expect(1, 2144, '\p{^Is_Blk: 	_Mandaic}', "");
    Expect(1, 2144, '\P{Is_Blk: 	_Mandaic}', "");
    Expect(0, 2144, '\P{^Is_Blk: 	_Mandaic}', "");
    Error('\p{Block=:=manichaean}');
    Error('\P{Block=:=manichaean}');
    Expect(1, 68351, '\p{Block=manichaean}', "");
    Expect(0, 68351, '\p{^Block=manichaean}', "");
    Expect(0, 68351, '\P{Block=manichaean}', "");
    Expect(1, 68351, '\P{^Block=manichaean}', "");
    Expect(0, 68352, '\p{Block=manichaean}', "");
    Expect(1, 68352, '\p{^Block=manichaean}', "");
    Expect(1, 68352, '\P{Block=manichaean}', "");
    Expect(0, 68352, '\P{^Block=manichaean}', "");
    Expect(1, 68351, '\p{Block=__Manichaean}', "");
    Expect(0, 68351, '\p{^Block=__Manichaean}', "");
    Expect(0, 68351, '\P{Block=__Manichaean}', "");
    Expect(1, 68351, '\P{^Block=__Manichaean}', "");
    Expect(0, 68352, '\p{Block=__Manichaean}', "");
    Expect(1, 68352, '\p{^Block=__Manichaean}', "");
    Expect(1, 68352, '\P{Block=__Manichaean}', "");
    Expect(0, 68352, '\P{^Block=__Manichaean}', "");
    Error('\p{Blk=:=	manichaean}');
    Error('\P{Blk=:=	manichaean}');
    Expect(1, 68351, '\p{Blk=manichaean}', "");
    Expect(0, 68351, '\p{^Blk=manichaean}', "");
    Expect(0, 68351, '\P{Blk=manichaean}', "");
    Expect(1, 68351, '\P{^Blk=manichaean}', "");
    Expect(0, 68352, '\p{Blk=manichaean}', "");
    Expect(1, 68352, '\p{^Blk=manichaean}', "");
    Expect(1, 68352, '\P{Blk=manichaean}', "");
    Expect(0, 68352, '\P{^Blk=manichaean}', "");
    Expect(1, 68351, '\p{Blk=	 manichaean}', "");
    Expect(0, 68351, '\p{^Blk=	 manichaean}', "");
    Expect(0, 68351, '\P{Blk=	 manichaean}', "");
    Expect(1, 68351, '\P{^Blk=	 manichaean}', "");
    Expect(0, 68352, '\p{Blk=	 manichaean}', "");
    Expect(1, 68352, '\p{^Blk=	 manichaean}', "");
    Expect(1, 68352, '\P{Blk=	 manichaean}', "");
    Expect(0, 68352, '\P{^Blk=	 manichaean}', "");
    Error('\p{Is_Block=/a/MANICHAEAN}');
    Error('\P{Is_Block=/a/MANICHAEAN}');
    Expect(1, 68351, '\p{Is_Block:manichaean}', "");
    Expect(0, 68351, '\p{^Is_Block:manichaean}', "");
    Expect(0, 68351, '\P{Is_Block:manichaean}', "");
    Expect(1, 68351, '\P{^Is_Block:manichaean}', "");
    Expect(0, 68352, '\p{Is_Block:manichaean}', "");
    Expect(1, 68352, '\p{^Is_Block:manichaean}', "");
    Expect(1, 68352, '\P{Is_Block:manichaean}', "");
    Expect(0, 68352, '\P{^Is_Block:manichaean}', "");
    Expect(1, 68351, '\p{Is_Block= manichaean}', "");
    Expect(0, 68351, '\p{^Is_Block= manichaean}', "");
    Expect(0, 68351, '\P{Is_Block= manichaean}', "");
    Expect(1, 68351, '\P{^Is_Block= manichaean}', "");
    Expect(0, 68352, '\p{Is_Block= manichaean}', "");
    Expect(1, 68352, '\p{^Is_Block= manichaean}', "");
    Expect(1, 68352, '\P{Is_Block= manichaean}', "");
    Expect(0, 68352, '\P{^Is_Block= manichaean}', "");
    Error('\p{Is_Blk=/a/ _Manichaean}');
    Error('\P{Is_Blk=/a/ _Manichaean}');
    Expect(1, 68351, '\p{Is_Blk=manichaean}', "");
    Expect(0, 68351, '\p{^Is_Blk=manichaean}', "");
    Expect(0, 68351, '\P{Is_Blk=manichaean}', "");
    Expect(1, 68351, '\P{^Is_Blk=manichaean}', "");
    Expect(0, 68352, '\p{Is_Blk=manichaean}', "");
    Expect(1, 68352, '\p{^Is_Blk=manichaean}', "");
    Expect(1, 68352, '\P{Is_Blk=manichaean}', "");
    Expect(0, 68352, '\P{^Is_Blk=manichaean}', "");
    Expect(1, 68351, '\p{Is_Blk=-_MANICHAEAN}', "");
    Expect(0, 68351, '\p{^Is_Blk=-_MANICHAEAN}', "");
    Expect(0, 68351, '\P{Is_Blk=-_MANICHAEAN}', "");
    Expect(1, 68351, '\P{^Is_Blk=-_MANICHAEAN}', "");
    Expect(0, 68352, '\p{Is_Blk=-_MANICHAEAN}', "");
    Expect(1, 68352, '\p{^Is_Blk=-_MANICHAEAN}', "");
    Expect(1, 68352, '\P{Is_Blk=-_MANICHAEAN}', "");
    Expect(0, 68352, '\P{^Is_Blk=-_MANICHAEAN}', "");
    Error('\p{Block=:=	-Marchen}');
    Error('\P{Block=:=	-Marchen}');
    Expect(1, 72895, '\p{Block=marchen}', "");
    Expect(0, 72895, '\p{^Block=marchen}', "");
    Expect(0, 72895, '\P{Block=marchen}', "");
    Expect(1, 72895, '\P{^Block=marchen}', "");
    Expect(0, 72896, '\p{Block=marchen}', "");
    Expect(1, 72896, '\p{^Block=marchen}', "");
    Expect(1, 72896, '\P{Block=marchen}', "");
    Expect(0, 72896, '\P{^Block=marchen}', "");
    Expect(1, 72895, '\p{Block=_	marchen}', "");
    Expect(0, 72895, '\p{^Block=_	marchen}', "");
    Expect(0, 72895, '\P{Block=_	marchen}', "");
    Expect(1, 72895, '\P{^Block=_	marchen}', "");
    Expect(0, 72896, '\p{Block=_	marchen}', "");
    Expect(1, 72896, '\p{^Block=_	marchen}', "");
    Expect(1, 72896, '\P{Block=_	marchen}', "");
    Expect(0, 72896, '\P{^Block=_	marchen}', "");
    Error('\p{Blk:   	_marchen/a/}');
    Error('\P{Blk:   	_marchen/a/}');
    Expect(1, 72895, '\p{Blk=marchen}', "");
    Expect(0, 72895, '\p{^Blk=marchen}', "");
    Expect(0, 72895, '\P{Blk=marchen}', "");
    Expect(1, 72895, '\P{^Blk=marchen}', "");
    Expect(0, 72896, '\p{Blk=marchen}', "");
    Expect(1, 72896, '\p{^Blk=marchen}', "");
    Expect(1, 72896, '\P{Blk=marchen}', "");
    Expect(0, 72896, '\P{^Blk=marchen}', "");
    Expect(1, 72895, '\p{Blk=_ marchen}', "");
    Expect(0, 72895, '\p{^Blk=_ marchen}', "");
    Expect(0, 72895, '\P{Blk=_ marchen}', "");
    Expect(1, 72895, '\P{^Blk=_ marchen}', "");
    Expect(0, 72896, '\p{Blk=_ marchen}', "");
    Expect(1, 72896, '\p{^Blk=_ marchen}', "");
    Expect(1, 72896, '\P{Blk=_ marchen}', "");
    Expect(0, 72896, '\P{^Blk=_ marchen}', "");
    Error('\p{Is_Block= /a/MARCHEN}');
    Error('\P{Is_Block= /a/MARCHEN}');
    Expect(1, 72895, '\p{Is_Block=marchen}', "");
    Expect(0, 72895, '\p{^Is_Block=marchen}', "");
    Expect(0, 72895, '\P{Is_Block=marchen}', "");
    Expect(1, 72895, '\P{^Is_Block=marchen}', "");
    Expect(0, 72896, '\p{Is_Block=marchen}', "");
    Expect(1, 72896, '\p{^Is_Block=marchen}', "");
    Expect(1, 72896, '\P{Is_Block=marchen}', "");
    Expect(0, 72896, '\P{^Is_Block=marchen}', "");
    Expect(1, 72895, '\p{Is_Block:  -marchen}', "");
    Expect(0, 72895, '\p{^Is_Block:  -marchen}', "");
    Expect(0, 72895, '\P{Is_Block:  -marchen}', "");
    Expect(1, 72895, '\P{^Is_Block:  -marchen}', "");
    Expect(0, 72896, '\p{Is_Block:  -marchen}', "");
    Expect(1, 72896, '\p{^Is_Block:  -marchen}', "");
    Expect(1, 72896, '\P{Is_Block:  -marchen}', "");
    Expect(0, 72896, '\P{^Is_Block:  -marchen}', "");
    Error('\p{Is_Blk=/a/Marchen}');
    Error('\P{Is_Blk=/a/Marchen}');
    Expect(1, 72895, '\p{Is_Blk=marchen}', "");
    Expect(0, 72895, '\p{^Is_Blk=marchen}', "");
    Expect(0, 72895, '\P{Is_Blk=marchen}', "");
    Expect(1, 72895, '\P{^Is_Blk=marchen}', "");
    Expect(0, 72896, '\p{Is_Blk=marchen}', "");
    Expect(1, 72896, '\p{^Is_Blk=marchen}', "");
    Expect(1, 72896, '\P{Is_Blk=marchen}', "");
    Expect(0, 72896, '\P{^Is_Blk=marchen}', "");
    Expect(1, 72895, '\p{Is_Blk=	 marchen}', "");
    Expect(0, 72895, '\p{^Is_Blk=	 marchen}', "");
    Expect(0, 72895, '\P{Is_Blk=	 marchen}', "");
    Expect(1, 72895, '\P{^Is_Blk=	 marchen}', "");
    Expect(0, 72896, '\p{Is_Blk=	 marchen}', "");
    Expect(1, 72896, '\p{^Is_Blk=	 marchen}', "");
    Expect(1, 72896, '\P{Is_Blk=	 marchen}', "");
    Expect(0, 72896, '\P{^Is_Blk=	 marchen}', "");
    Error('\p{Block=:=-masaram_Gondi}');
    Error('\P{Block=:=-masaram_Gondi}');
    Expect(1, 73055, '\p{Block=masaramgondi}', "");
    Expect(0, 73055, '\p{^Block=masaramgondi}', "");
    Expect(0, 73055, '\P{Block=masaramgondi}', "");
    Expect(1, 73055, '\P{^Block=masaramgondi}', "");
    Expect(0, 73056, '\p{Block=masaramgondi}', "");
    Expect(1, 73056, '\p{^Block=masaramgondi}', "");
    Expect(1, 73056, '\P{Block=masaramgondi}', "");
    Expect(0, 73056, '\P{^Block=masaramgondi}', "");
    Expect(1, 73055, '\p{Block=-Masaram_GONDI}', "");
    Expect(0, 73055, '\p{^Block=-Masaram_GONDI}', "");
    Expect(0, 73055, '\P{Block=-Masaram_GONDI}', "");
    Expect(1, 73055, '\P{^Block=-Masaram_GONDI}', "");
    Expect(0, 73056, '\p{Block=-Masaram_GONDI}', "");
    Expect(1, 73056, '\p{^Block=-Masaram_GONDI}', "");
    Expect(1, 73056, '\P{Block=-Masaram_GONDI}', "");
    Expect(0, 73056, '\P{^Block=-Masaram_GONDI}', "");
    Error('\p{Blk=		MASARAM_gondi/a/}');
    Error('\P{Blk=		MASARAM_gondi/a/}');
    Expect(1, 73055, '\p{Blk=masaramgondi}', "");
    Expect(0, 73055, '\p{^Blk=masaramgondi}', "");
    Expect(0, 73055, '\P{Blk=masaramgondi}', "");
    Expect(1, 73055, '\P{^Blk=masaramgondi}', "");
    Expect(0, 73056, '\p{Blk=masaramgondi}', "");
    Expect(1, 73056, '\p{^Blk=masaramgondi}', "");
    Expect(1, 73056, '\P{Blk=masaramgondi}', "");
    Expect(0, 73056, '\P{^Blk=masaramgondi}', "");
    Expect(1, 73055, '\p{Blk= Masaram_gondi}', "");
    Expect(0, 73055, '\p{^Blk= Masaram_gondi}', "");
    Expect(0, 73055, '\P{Blk= Masaram_gondi}', "");
    Expect(1, 73055, '\P{^Blk= Masaram_gondi}', "");
    Expect(0, 73056, '\p{Blk= Masaram_gondi}', "");
    Expect(1, 73056, '\p{^Blk= Masaram_gondi}', "");
    Expect(1, 73056, '\P{Blk= Masaram_gondi}', "");
    Expect(0, 73056, '\P{^Blk= Masaram_gondi}', "");
    Error('\p{Is_Block=/a/ masaram_Gondi}');
    Error('\P{Is_Block=/a/ masaram_Gondi}');
    Expect(1, 73055, '\p{Is_Block=masaramgondi}', "");
    Expect(0, 73055, '\p{^Is_Block=masaramgondi}', "");
    Expect(0, 73055, '\P{Is_Block=masaramgondi}', "");
    Expect(1, 73055, '\P{^Is_Block=masaramgondi}', "");
    Expect(0, 73056, '\p{Is_Block=masaramgondi}', "");
    Expect(1, 73056, '\p{^Is_Block=masaramgondi}', "");
    Expect(1, 73056, '\P{Is_Block=masaramgondi}', "");
    Expect(0, 73056, '\P{^Is_Block=masaramgondi}', "");
    Expect(1, 73055, '\p{Is_Block=__Masaram_GONDI}', "");
    Expect(0, 73055, '\p{^Is_Block=__Masaram_GONDI}', "");
    Expect(0, 73055, '\P{Is_Block=__Masaram_GONDI}', "");
    Expect(1, 73055, '\P{^Is_Block=__Masaram_GONDI}', "");
    Expect(0, 73056, '\p{Is_Block=__Masaram_GONDI}', "");
    Expect(1, 73056, '\p{^Is_Block=__Masaram_GONDI}', "");
    Expect(1, 73056, '\P{Is_Block=__Masaram_GONDI}', "");
    Expect(0, 73056, '\P{^Is_Block=__Masaram_GONDI}', "");
    Error('\p{Is_Blk=	-masaram_Gondi/a/}');
    Error('\P{Is_Blk=	-masaram_Gondi/a/}');
    Expect(1, 73055, '\p{Is_Blk=masaramgondi}', "");
    Expect(0, 73055, '\p{^Is_Blk=masaramgondi}', "");
    Expect(0, 73055, '\P{Is_Blk=masaramgondi}', "");
    Expect(1, 73055, '\P{^Is_Blk=masaramgondi}', "");
    Expect(0, 73056, '\p{Is_Blk=masaramgondi}', "");
    Expect(1, 73056, '\p{^Is_Blk=masaramgondi}', "");
    Expect(1, 73056, '\P{Is_Blk=masaramgondi}', "");
    Expect(0, 73056, '\P{^Is_Blk=masaramgondi}', "");
    Expect(1, 73055, '\p{Is_Blk=-Masaram_Gondi}', "");
    Expect(0, 73055, '\p{^Is_Blk=-Masaram_Gondi}', "");
    Expect(0, 73055, '\P{Is_Blk=-Masaram_Gondi}', "");
    Expect(1, 73055, '\P{^Is_Blk=-Masaram_Gondi}', "");
    Expect(0, 73056, '\p{Is_Blk=-Masaram_Gondi}', "");
    Expect(1, 73056, '\p{^Is_Blk=-Masaram_Gondi}', "");
    Expect(1, 73056, '\P{Is_Blk=-Masaram_Gondi}', "");
    Expect(0, 73056, '\P{^Is_Blk=-Masaram_Gondi}', "");
    Error('\p{Block=:=--Mathematical_ALPHANUMERIC_symbols}');
    Error('\P{Block=:=--Mathematical_ALPHANUMERIC_symbols}');
    Expect(1, 120831, '\p{Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\p{^Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\P{Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\P{^Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\p{Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\p{^Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\P{Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\P{^Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\p{Block=_Mathematical_ALPHANUMERIC_Symbols}', "");
    Expect(0, 120831, '\p{^Block=_Mathematical_ALPHANUMERIC_Symbols}', "");
    Expect(0, 120831, '\P{Block=_Mathematical_ALPHANUMERIC_Symbols}', "");
    Expect(1, 120831, '\P{^Block=_Mathematical_ALPHANUMERIC_Symbols}', "");
    Expect(0, 120832, '\p{Block=_Mathematical_ALPHANUMERIC_Symbols}', "");
    Expect(1, 120832, '\p{^Block=_Mathematical_ALPHANUMERIC_Symbols}', "");
    Expect(1, 120832, '\P{Block=_Mathematical_ALPHANUMERIC_Symbols}', "");
    Expect(0, 120832, '\P{^Block=_Mathematical_ALPHANUMERIC_Symbols}', "");
    Error('\p{Blk=/a/--Math_Alphanum}');
    Error('\P{Blk=/a/--Math_Alphanum}');
    Expect(1, 120831, '\p{Blk=mathalphanum}', "");
    Expect(0, 120831, '\p{^Blk=mathalphanum}', "");
    Expect(0, 120831, '\P{Blk=mathalphanum}', "");
    Expect(1, 120831, '\P{^Blk=mathalphanum}', "");
    Expect(0, 120832, '\p{Blk=mathalphanum}', "");
    Expect(1, 120832, '\p{^Blk=mathalphanum}', "");
    Expect(1, 120832, '\P{Blk=mathalphanum}', "");
    Expect(0, 120832, '\P{^Blk=mathalphanum}', "");
    Expect(1, 120831, '\p{Blk:   	_Math_alphanum}', "");
    Expect(0, 120831, '\p{^Blk:   	_Math_alphanum}', "");
    Expect(0, 120831, '\P{Blk:   	_Math_alphanum}', "");
    Expect(1, 120831, '\P{^Blk:   	_Math_alphanum}', "");
    Expect(0, 120832, '\p{Blk:   	_Math_alphanum}', "");
    Expect(1, 120832, '\p{^Blk:   	_Math_alphanum}', "");
    Expect(1, 120832, '\P{Blk:   	_Math_alphanum}', "");
    Expect(0, 120832, '\P{^Blk:   	_Math_alphanum}', "");
    Error('\p{Is_Block=	:=Mathematical_Alphanumeric_Symbols}');
    Error('\P{Is_Block=	:=Mathematical_Alphanumeric_Symbols}');
    Expect(1, 120831, '\p{Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\p{^Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\P{Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\P{^Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\p{Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\p{^Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\P{Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\P{^Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\p{Is_Block=- mathematical_alphanumeric_SYMBOLS}', "");
    Expect(0, 120831, '\p{^Is_Block=- mathematical_alphanumeric_SYMBOLS}', "");
    Expect(0, 120831, '\P{Is_Block=- mathematical_alphanumeric_SYMBOLS}', "");
    Expect(1, 120831, '\P{^Is_Block=- mathematical_alphanumeric_SYMBOLS}', "");
    Expect(0, 120832, '\p{Is_Block=- mathematical_alphanumeric_SYMBOLS}', "");
    Expect(1, 120832, '\p{^Is_Block=- mathematical_alphanumeric_SYMBOLS}', "");
    Expect(1, 120832, '\P{Is_Block=- mathematical_alphanumeric_SYMBOLS}', "");
    Expect(0, 120832, '\P{^Is_Block=- mathematical_alphanumeric_SYMBOLS}', "");
    Error('\p{Is_Blk=		MATH_Alphanum:=}');
    Error('\P{Is_Blk=		MATH_Alphanum:=}');
    Expect(1, 120831, '\p{Is_Blk=mathalphanum}', "");
    Expect(0, 120831, '\p{^Is_Blk=mathalphanum}', "");
    Expect(0, 120831, '\P{Is_Blk=mathalphanum}', "");
    Expect(1, 120831, '\P{^Is_Blk=mathalphanum}', "");
    Expect(0, 120832, '\p{Is_Blk=mathalphanum}', "");
    Expect(1, 120832, '\p{^Is_Blk=mathalphanum}', "");
    Expect(1, 120832, '\P{Is_Blk=mathalphanum}', "");
    Expect(0, 120832, '\P{^Is_Blk=mathalphanum}', "");
    Expect(1, 120831, '\p{Is_Blk=	Math_Alphanum}', "");
    Expect(0, 120831, '\p{^Is_Blk=	Math_Alphanum}', "");
    Expect(0, 120831, '\P{Is_Blk=	Math_Alphanum}', "");
    Expect(1, 120831, '\P{^Is_Blk=	Math_Alphanum}', "");
    Expect(0, 120832, '\p{Is_Blk=	Math_Alphanum}', "");
    Expect(1, 120832, '\p{^Is_Blk=	Math_Alphanum}', "");
    Expect(1, 120832, '\P{Is_Blk=	Math_Alphanum}', "");
    Expect(0, 120832, '\P{^Is_Blk=	Math_Alphanum}', "");
    Error('\p{Block=/a/mathematical_Operators}');
    Error('\P{Block=/a/mathematical_Operators}');
    Expect(1, 8959, '\p{Block=mathematicaloperators}', "");
    Expect(0, 8959, '\p{^Block=mathematicaloperators}', "");
    Expect(0, 8959, '\P{Block=mathematicaloperators}', "");
    Expect(1, 8959, '\P{^Block=mathematicaloperators}', "");
    Expect(0, 8960, '\p{Block=mathematicaloperators}', "");
    Expect(1, 8960, '\p{^Block=mathematicaloperators}', "");
    Expect(1, 8960, '\P{Block=mathematicaloperators}', "");
    Expect(0, 8960, '\P{^Block=mathematicaloperators}', "");
    Expect(1, 8959, '\p{Block:   -Mathematical_Operators}', "");
    Expect(0, 8959, '\p{^Block:   -Mathematical_Operators}', "");
    Expect(0, 8959, '\P{Block:   -Mathematical_Operators}', "");
    Expect(1, 8959, '\P{^Block:   -Mathematical_Operators}', "");
    Expect(0, 8960, '\p{Block:   -Mathematical_Operators}', "");
    Expect(1, 8960, '\p{^Block:   -Mathematical_Operators}', "");
    Expect(1, 8960, '\P{Block:   -Mathematical_Operators}', "");
    Expect(0, 8960, '\P{^Block:   -Mathematical_Operators}', "");
    Error('\p{Blk=:=	MATH_operators}');
    Error('\P{Blk=:=	MATH_operators}');
    Expect(1, 8959, '\p{Blk: mathoperators}', "");
    Expect(0, 8959, '\p{^Blk: mathoperators}', "");
    Expect(0, 8959, '\P{Blk: mathoperators}', "");
    Expect(1, 8959, '\P{^Blk: mathoperators}', "");
    Expect(0, 8960, '\p{Blk: mathoperators}', "");
    Expect(1, 8960, '\p{^Blk: mathoperators}', "");
    Expect(1, 8960, '\P{Blk: mathoperators}', "");
    Expect(0, 8960, '\P{^Blk: mathoperators}', "");
    Expect(1, 8959, '\p{Blk=_-Math_operators}', "");
    Expect(0, 8959, '\p{^Blk=_-Math_operators}', "");
    Expect(0, 8959, '\P{Blk=_-Math_operators}', "");
    Expect(1, 8959, '\P{^Blk=_-Math_operators}', "");
    Expect(0, 8960, '\p{Blk=_-Math_operators}', "");
    Expect(1, 8960, '\p{^Blk=_-Math_operators}', "");
    Expect(1, 8960, '\P{Blk=_-Math_operators}', "");
    Expect(0, 8960, '\P{^Blk=_-Math_operators}', "");
    Error('\p{Is_Block=_	Mathematical_OPERATORS:=}');
    Error('\P{Is_Block=_	Mathematical_OPERATORS:=}');
    Expect(1, 8959, '\p{Is_Block=mathematicaloperators}', "");
    Expect(0, 8959, '\p{^Is_Block=mathematicaloperators}', "");
    Expect(0, 8959, '\P{Is_Block=mathematicaloperators}', "");
    Expect(1, 8959, '\P{^Is_Block=mathematicaloperators}', "");
    Expect(0, 8960, '\p{Is_Block=mathematicaloperators}', "");
    Expect(1, 8960, '\p{^Is_Block=mathematicaloperators}', "");
    Expect(1, 8960, '\P{Is_Block=mathematicaloperators}', "");
    Expect(0, 8960, '\P{^Is_Block=mathematicaloperators}', "");
    Expect(1, 8959, '\p{Is_Block=	MATHEMATICAL_Operators}', "");
    Expect(0, 8959, '\p{^Is_Block=	MATHEMATICAL_Operators}', "");
    Expect(0, 8959, '\P{Is_Block=	MATHEMATICAL_Operators}', "");
    Expect(1, 8959, '\P{^Is_Block=	MATHEMATICAL_Operators}', "");
    Expect(0, 8960, '\p{Is_Block=	MATHEMATICAL_Operators}', "");
    Expect(1, 8960, '\p{^Is_Block=	MATHEMATICAL_Operators}', "");
    Expect(1, 8960, '\P{Is_Block=	MATHEMATICAL_Operators}', "");
    Expect(0, 8960, '\P{^Is_Block=	MATHEMATICAL_Operators}', "");
    Error('\p{Is_Blk= _MATH_Operators/a/}');
    Error('\P{Is_Blk= _MATH_Operators/a/}');
    Expect(1, 8959, '\p{Is_Blk=mathoperators}', "");
    Expect(0, 8959, '\p{^Is_Blk=mathoperators}', "");
    Expect(0, 8959, '\P{Is_Blk=mathoperators}', "");
    Expect(1, 8959, '\P{^Is_Blk=mathoperators}', "");
    Expect(0, 8960, '\p{Is_Blk=mathoperators}', "");
    Expect(1, 8960, '\p{^Is_Blk=mathoperators}', "");
    Expect(1, 8960, '\P{Is_Blk=mathoperators}', "");
    Expect(0, 8960, '\P{^Is_Blk=mathoperators}', "");
    Expect(1, 8959, '\p{Is_Blk=-_Math_operators}', "");
    Expect(0, 8959, '\p{^Is_Blk=-_Math_operators}', "");
    Expect(0, 8959, '\P{Is_Blk=-_Math_operators}', "");
    Expect(1, 8959, '\P{^Is_Blk=-_Math_operators}', "");
    Expect(0, 8960, '\p{Is_Blk=-_Math_operators}', "");
    Expect(1, 8960, '\p{^Is_Blk=-_Math_operators}', "");
    Expect(1, 8960, '\P{Is_Blk=-_Math_operators}', "");
    Expect(0, 8960, '\P{^Is_Blk=-_Math_operators}', "");
    Error('\p{Block=:=_	meetei_MAYEK}');
    Error('\P{Block=:=_	meetei_MAYEK}');
    Expect(1, 44031, '\p{Block=meeteimayek}', "");
    Expect(0, 44031, '\p{^Block=meeteimayek}', "");
    Expect(0, 44031, '\P{Block=meeteimayek}', "");
    Expect(1, 44031, '\P{^Block=meeteimayek}', "");
    Expect(0, 44032, '\p{Block=meeteimayek}', "");
    Expect(1, 44032, '\p{^Block=meeteimayek}', "");
    Expect(1, 44032, '\P{Block=meeteimayek}', "");
    Expect(0, 44032, '\P{^Block=meeteimayek}', "");
    Expect(1, 44031, '\p{Block=	Meetei_mayek}', "");
    Expect(0, 44031, '\p{^Block=	Meetei_mayek}', "");
    Expect(0, 44031, '\P{Block=	Meetei_mayek}', "");
    Expect(1, 44031, '\P{^Block=	Meetei_mayek}', "");
    Expect(0, 44032, '\p{Block=	Meetei_mayek}', "");
    Expect(1, 44032, '\p{^Block=	Meetei_mayek}', "");
    Expect(1, 44032, '\P{Block=	Meetei_mayek}', "");
    Expect(0, 44032, '\P{^Block=	Meetei_mayek}', "");
    Error('\p{Blk=meetei_Mayek/a/}');
    Error('\P{Blk=meetei_Mayek/a/}');
    Expect(1, 44031, '\p{Blk=meeteimayek}', "");
    Expect(0, 44031, '\p{^Blk=meeteimayek}', "");
    Expect(0, 44031, '\P{Blk=meeteimayek}', "");
    Expect(1, 44031, '\P{^Blk=meeteimayek}', "");
    Expect(0, 44032, '\p{Blk=meeteimayek}', "");
    Expect(1, 44032, '\p{^Blk=meeteimayek}', "");
    Expect(1, 44032, '\P{Blk=meeteimayek}', "");
    Expect(0, 44032, '\P{^Blk=meeteimayek}', "");
    Expect(1, 44031, '\p{Blk=--MEETEI_Mayek}', "");
    Expect(0, 44031, '\p{^Blk=--MEETEI_Mayek}', "");
    Expect(0, 44031, '\P{Blk=--MEETEI_Mayek}', "");
    Expect(1, 44031, '\P{^Blk=--MEETEI_Mayek}', "");
    Expect(0, 44032, '\p{Blk=--MEETEI_Mayek}', "");
    Expect(1, 44032, '\p{^Blk=--MEETEI_Mayek}', "");
    Expect(1, 44032, '\P{Blk=--MEETEI_Mayek}', "");
    Expect(0, 44032, '\P{^Blk=--MEETEI_Mayek}', "");
    Error('\p{Is_Block: :=	 Meetei_mayek}');
    Error('\P{Is_Block: :=	 Meetei_mayek}');
    Expect(1, 44031, '\p{Is_Block=meeteimayek}', "");
    Expect(0, 44031, '\p{^Is_Block=meeteimayek}', "");
    Expect(0, 44031, '\P{Is_Block=meeteimayek}', "");
    Expect(1, 44031, '\P{^Is_Block=meeteimayek}', "");
    Expect(0, 44032, '\p{Is_Block=meeteimayek}', "");
    Expect(1, 44032, '\p{^Is_Block=meeteimayek}', "");
    Expect(1, 44032, '\P{Is_Block=meeteimayek}', "");
    Expect(0, 44032, '\P{^Is_Block=meeteimayek}', "");
    Expect(1, 44031, '\p{Is_Block= 	meetei_Mayek}', "");
    Expect(0, 44031, '\p{^Is_Block= 	meetei_Mayek}', "");
    Expect(0, 44031, '\P{Is_Block= 	meetei_Mayek}', "");
    Expect(1, 44031, '\P{^Is_Block= 	meetei_Mayek}', "");
    Expect(0, 44032, '\p{Is_Block= 	meetei_Mayek}', "");
    Expect(1, 44032, '\p{^Is_Block= 	meetei_Mayek}', "");
    Expect(1, 44032, '\P{Is_Block= 	meetei_Mayek}', "");
    Expect(0, 44032, '\P{^Is_Block= 	meetei_Mayek}', "");
    Error('\p{Is_Blk=	:=MEETEI_Mayek}');
    Error('\P{Is_Blk=	:=MEETEI_Mayek}');
    Expect(1, 44031, '\p{Is_Blk:meeteimayek}', "");
    Expect(0, 44031, '\p{^Is_Blk:meeteimayek}', "");
    Expect(0, 44031, '\P{Is_Blk:meeteimayek}', "");
    Expect(1, 44031, '\P{^Is_Blk:meeteimayek}', "");
    Expect(0, 44032, '\p{Is_Blk:meeteimayek}', "");
    Expect(1, 44032, '\p{^Is_Blk:meeteimayek}', "");
    Expect(1, 44032, '\P{Is_Blk:meeteimayek}', "");
    Expect(0, 44032, '\P{^Is_Blk:meeteimayek}', "");
    Expect(1, 44031, '\p{Is_Blk=		meetei_mayek}', "");
    Expect(0, 44031, '\p{^Is_Blk=		meetei_mayek}', "");
    Expect(0, 44031, '\P{Is_Blk=		meetei_mayek}', "");
    Expect(1, 44031, '\P{^Is_Blk=		meetei_mayek}', "");
    Expect(0, 44032, '\p{Is_Blk=		meetei_mayek}', "");
    Expect(1, 44032, '\p{^Is_Blk=		meetei_mayek}', "");
    Expect(1, 44032, '\P{Is_Blk=		meetei_mayek}', "");
    Expect(0, 44032, '\P{^Is_Blk=		meetei_mayek}', "");
    Error('\p{Block=_MEETEI_mayek_Extensions:=}');
    Error('\P{Block=_MEETEI_mayek_Extensions:=}');
    Expect(1, 43775, '\p{Block=meeteimayekextensions}', "");
    Expect(0, 43775, '\p{^Block=meeteimayekextensions}', "");
    Expect(0, 43775, '\P{Block=meeteimayekextensions}', "");
    Expect(1, 43775, '\P{^Block=meeteimayekextensions}', "");
    Expect(0, 43776, '\p{Block=meeteimayekextensions}', "");
    Expect(1, 43776, '\p{^Block=meeteimayekextensions}', "");
    Expect(1, 43776, '\P{Block=meeteimayekextensions}', "");
    Expect(0, 43776, '\P{^Block=meeteimayekextensions}', "");
    Expect(1, 43775, '\p{Block=_ MEETEI_mayek_Extensions}', "");
    Expect(0, 43775, '\p{^Block=_ MEETEI_mayek_Extensions}', "");
    Expect(0, 43775, '\P{Block=_ MEETEI_mayek_Extensions}', "");
    Expect(1, 43775, '\P{^Block=_ MEETEI_mayek_Extensions}', "");
    Expect(0, 43776, '\p{Block=_ MEETEI_mayek_Extensions}', "");
    Expect(1, 43776, '\p{^Block=_ MEETEI_mayek_Extensions}', "");
    Expect(1, 43776, '\P{Block=_ MEETEI_mayek_Extensions}', "");
    Expect(0, 43776, '\P{^Block=_ MEETEI_mayek_Extensions}', "");
    Error('\p{Blk=	:=Meetei_Mayek_Ext}');
    Error('\P{Blk=	:=Meetei_Mayek_Ext}');
    Expect(1, 43775, '\p{Blk=meeteimayekext}', "");
    Expect(0, 43775, '\p{^Blk=meeteimayekext}', "");
    Expect(0, 43775, '\P{Blk=meeteimayekext}', "");
    Expect(1, 43775, '\P{^Blk=meeteimayekext}', "");
    Expect(0, 43776, '\p{Blk=meeteimayekext}', "");
    Expect(1, 43776, '\p{^Blk=meeteimayekext}', "");
    Expect(1, 43776, '\P{Blk=meeteimayekext}', "");
    Expect(0, 43776, '\P{^Blk=meeteimayekext}', "");
    Expect(1, 43775, '\p{Blk=	_Meetei_mayek_ext}', "");
    Expect(0, 43775, '\p{^Blk=	_Meetei_mayek_ext}', "");
    Expect(0, 43775, '\P{Blk=	_Meetei_mayek_ext}', "");
    Expect(1, 43775, '\P{^Blk=	_Meetei_mayek_ext}', "");
    Expect(0, 43776, '\p{Blk=	_Meetei_mayek_ext}', "");
    Expect(1, 43776, '\p{^Blk=	_Meetei_mayek_ext}', "");
    Expect(1, 43776, '\P{Blk=	_Meetei_mayek_ext}', "");
    Expect(0, 43776, '\P{^Blk=	_Meetei_mayek_ext}', "");
    Error('\p{Is_Block=_ Meetei_MAYEK_extensions:=}');
    Error('\P{Is_Block=_ Meetei_MAYEK_extensions:=}');
    Expect(1, 43775, '\p{Is_Block=meeteimayekextensions}', "");
    Expect(0, 43775, '\p{^Is_Block=meeteimayekextensions}', "");
    Expect(0, 43775, '\P{Is_Block=meeteimayekextensions}', "");
    Expect(1, 43775, '\P{^Is_Block=meeteimayekextensions}', "");
    Expect(0, 43776, '\p{Is_Block=meeteimayekextensions}', "");
    Expect(1, 43776, '\p{^Is_Block=meeteimayekextensions}', "");
    Expect(1, 43776, '\P{Is_Block=meeteimayekextensions}', "");
    Expect(0, 43776, '\P{^Is_Block=meeteimayekextensions}', "");
    Expect(1, 43775, '\p{Is_Block=	_meetei_Mayek_Extensions}', "");
    Expect(0, 43775, '\p{^Is_Block=	_meetei_Mayek_Extensions}', "");
    Expect(0, 43775, '\P{Is_Block=	_meetei_Mayek_Extensions}', "");
    Expect(1, 43775, '\P{^Is_Block=	_meetei_Mayek_Extensions}', "");
    Expect(0, 43776, '\p{Is_Block=	_meetei_Mayek_Extensions}', "");
    Expect(1, 43776, '\p{^Is_Block=	_meetei_Mayek_Extensions}', "");
    Expect(1, 43776, '\P{Is_Block=	_meetei_Mayek_Extensions}', "");
    Expect(0, 43776, '\P{^Is_Block=	_meetei_Mayek_Extensions}', "");
    Error('\p{Is_Blk:	/a/ Meetei_Mayek_Ext}');
    Error('\P{Is_Blk:	/a/ Meetei_Mayek_Ext}');
    Expect(1, 43775, '\p{Is_Blk=meeteimayekext}', "");
    Expect(0, 43775, '\p{^Is_Blk=meeteimayekext}', "");
    Expect(0, 43775, '\P{Is_Blk=meeteimayekext}', "");
    Expect(1, 43775, '\P{^Is_Blk=meeteimayekext}', "");
    Expect(0, 43776, '\p{Is_Blk=meeteimayekext}', "");
    Expect(1, 43776, '\p{^Is_Blk=meeteimayekext}', "");
    Expect(1, 43776, '\P{Is_Blk=meeteimayekext}', "");
    Expect(0, 43776, '\P{^Is_Blk=meeteimayekext}', "");
    Expect(1, 43775, '\p{Is_Blk=_ meetei_MAYEK_ext}', "");
    Expect(0, 43775, '\p{^Is_Blk=_ meetei_MAYEK_ext}', "");
    Expect(0, 43775, '\P{Is_Blk=_ meetei_MAYEK_ext}', "");
    Expect(1, 43775, '\P{^Is_Blk=_ meetei_MAYEK_ext}', "");
    Expect(0, 43776, '\p{Is_Blk=_ meetei_MAYEK_ext}', "");
    Expect(1, 43776, '\p{^Is_Blk=_ meetei_MAYEK_ext}', "");
    Expect(1, 43776, '\P{Is_Blk=_ meetei_MAYEK_ext}', "");
    Expect(0, 43776, '\P{^Is_Blk=_ meetei_MAYEK_ext}', "");
    Error('\p{Block:-/a/MENDE_Kikakui}');
    Error('\P{Block:-/a/MENDE_Kikakui}');
    Expect(1, 125151, '\p{Block=mendekikakui}', "");
    Expect(0, 125151, '\p{^Block=mendekikakui}', "");
    Expect(0, 125151, '\P{Block=mendekikakui}', "");
    Expect(1, 125151, '\P{^Block=mendekikakui}', "");
    Expect(0, 125152, '\p{Block=mendekikakui}', "");
    Expect(1, 125152, '\p{^Block=mendekikakui}', "");
    Expect(1, 125152, '\P{Block=mendekikakui}', "");
    Expect(0, 125152, '\P{^Block=mendekikakui}', "");
    Expect(1, 125151, '\p{Block=-	MENDE_Kikakui}', "");
    Expect(0, 125151, '\p{^Block=-	MENDE_Kikakui}', "");
    Expect(0, 125151, '\P{Block=-	MENDE_Kikakui}', "");
    Expect(1, 125151, '\P{^Block=-	MENDE_Kikakui}', "");
    Expect(0, 125152, '\p{Block=-	MENDE_Kikakui}', "");
    Expect(1, 125152, '\p{^Block=-	MENDE_Kikakui}', "");
    Expect(1, 125152, '\P{Block=-	MENDE_Kikakui}', "");
    Expect(0, 125152, '\P{^Block=-	MENDE_Kikakui}', "");
    Error('\p{Blk=	 Mende_Kikakui/a/}');
    Error('\P{Blk=	 Mende_Kikakui/a/}');
    Expect(1, 125151, '\p{Blk=mendekikakui}', "");
    Expect(0, 125151, '\p{^Blk=mendekikakui}', "");
    Expect(0, 125151, '\P{Blk=mendekikakui}', "");
    Expect(1, 125151, '\P{^Blk=mendekikakui}', "");
    Expect(0, 125152, '\p{Blk=mendekikakui}', "");
    Expect(1, 125152, '\p{^Blk=mendekikakui}', "");
    Expect(1, 125152, '\P{Blk=mendekikakui}', "");
    Expect(0, 125152, '\P{^Blk=mendekikakui}', "");
    Expect(1, 125151, '\p{Blk:   	_mende_Kikakui}', "");
    Expect(0, 125151, '\p{^Blk:   	_mende_Kikakui}', "");
    Expect(0, 125151, '\P{Blk:   	_mende_Kikakui}', "");
    Expect(1, 125151, '\P{^Blk:   	_mende_Kikakui}', "");
    Expect(0, 125152, '\p{Blk:   	_mende_Kikakui}', "");
    Expect(1, 125152, '\p{^Blk:   	_mende_Kikakui}', "");
    Expect(1, 125152, '\P{Blk:   	_mende_Kikakui}', "");
    Expect(0, 125152, '\P{^Blk:   	_mende_Kikakui}', "");
    Error('\p{Is_Block=:=-_Mende_Kikakui}');
    Error('\P{Is_Block=:=-_Mende_Kikakui}');
    Expect(1, 125151, '\p{Is_Block=mendekikakui}', "");
    Expect(0, 125151, '\p{^Is_Block=mendekikakui}', "");
    Expect(0, 125151, '\P{Is_Block=mendekikakui}', "");
    Expect(1, 125151, '\P{^Is_Block=mendekikakui}', "");
    Expect(0, 125152, '\p{Is_Block=mendekikakui}', "");
    Expect(1, 125152, '\p{^Is_Block=mendekikakui}', "");
    Expect(1, 125152, '\P{Is_Block=mendekikakui}', "");
    Expect(0, 125152, '\P{^Is_Block=mendekikakui}', "");
    Expect(1, 125151, '\p{Is_Block=_-Mende_KIKAKUI}', "");
    Expect(0, 125151, '\p{^Is_Block=_-Mende_KIKAKUI}', "");
    Expect(0, 125151, '\P{Is_Block=_-Mende_KIKAKUI}', "");
    Expect(1, 125151, '\P{^Is_Block=_-Mende_KIKAKUI}', "");
    Expect(0, 125152, '\p{Is_Block=_-Mende_KIKAKUI}', "");
    Expect(1, 125152, '\p{^Is_Block=_-Mende_KIKAKUI}', "");
    Expect(1, 125152, '\P{Is_Block=_-Mende_KIKAKUI}', "");
    Expect(0, 125152, '\P{^Is_Block=_-Mende_KIKAKUI}', "");
    Error('\p{Is_Blk:   /a/_ MENDE_kikakui}');
    Error('\P{Is_Blk:   /a/_ MENDE_kikakui}');
    Expect(1, 125151, '\p{Is_Blk=mendekikakui}', "");
    Expect(0, 125151, '\p{^Is_Blk=mendekikakui}', "");
    Expect(0, 125151, '\P{Is_Blk=mendekikakui}', "");
    Expect(1, 125151, '\P{^Is_Blk=mendekikakui}', "");
    Expect(0, 125152, '\p{Is_Blk=mendekikakui}', "");
    Expect(1, 125152, '\p{^Is_Blk=mendekikakui}', "");
    Expect(1, 125152, '\P{Is_Blk=mendekikakui}', "");
    Expect(0, 125152, '\P{^Is_Blk=mendekikakui}', "");
    Expect(1, 125151, '\p{Is_Blk= Mende_KIKAKUI}', "");
    Expect(0, 125151, '\p{^Is_Blk= Mende_KIKAKUI}', "");
    Expect(0, 125151, '\P{Is_Blk= Mende_KIKAKUI}', "");
    Expect(1, 125151, '\P{^Is_Blk= Mende_KIKAKUI}', "");
    Expect(0, 125152, '\p{Is_Blk= Mende_KIKAKUI}', "");
    Expect(1, 125152, '\p{^Is_Blk= Mende_KIKAKUI}', "");
    Expect(1, 125152, '\P{Is_Blk= Mende_KIKAKUI}', "");
    Expect(0, 125152, '\P{^Is_Blk= Mende_KIKAKUI}', "");
    Error('\p{Block=/a/--Meroitic_Cursive}');
    Error('\P{Block=/a/--Meroitic_Cursive}');
    Expect(1, 68095, '\p{Block=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Block=meroiticcursive}', "");
    Expect(0, 68095, '\P{Block=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Block=meroiticcursive}', "");
    Expect(0, 68096, '\p{Block=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Block=meroiticcursive}', "");
    Expect(1, 68096, '\P{Block=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Block=meroiticcursive}', "");
    Expect(1, 68095, '\p{Block=	Meroitic_Cursive}', "");
    Expect(0, 68095, '\p{^Block=	Meroitic_Cursive}', "");
    Expect(0, 68095, '\P{Block=	Meroitic_Cursive}', "");
    Expect(1, 68095, '\P{^Block=	Meroitic_Cursive}', "");
    Expect(0, 68096, '\p{Block=	Meroitic_Cursive}', "");
    Expect(1, 68096, '\p{^Block=	Meroitic_Cursive}', "");
    Expect(1, 68096, '\P{Block=	Meroitic_Cursive}', "");
    Expect(0, 68096, '\P{^Block=	Meroitic_Cursive}', "");
    Error('\p{Blk=	/a/MEROITIC_cursive}');
    Error('\P{Blk=	/a/MEROITIC_cursive}');
    Expect(1, 68095, '\p{Blk:meroiticcursive}', "");
    Expect(0, 68095, '\p{^Blk:meroiticcursive}', "");
    Expect(0, 68095, '\P{Blk:meroiticcursive}', "");
    Expect(1, 68095, '\P{^Blk:meroiticcursive}', "");
    Expect(0, 68096, '\p{Blk:meroiticcursive}', "");
    Expect(1, 68096, '\p{^Blk:meroiticcursive}', "");
    Expect(1, 68096, '\P{Blk:meroiticcursive}', "");
    Expect(0, 68096, '\P{^Blk:meroiticcursive}', "");
    Expect(1, 68095, '\p{Blk=		meroitic_CURSIVE}', "");
    Expect(0, 68095, '\p{^Blk=		meroitic_CURSIVE}', "");
    Expect(0, 68095, '\P{Blk=		meroitic_CURSIVE}', "");
    Expect(1, 68095, '\P{^Blk=		meroitic_CURSIVE}', "");
    Expect(0, 68096, '\p{Blk=		meroitic_CURSIVE}', "");
    Expect(1, 68096, '\p{^Blk=		meroitic_CURSIVE}', "");
    Expect(1, 68096, '\P{Blk=		meroitic_CURSIVE}', "");
    Expect(0, 68096, '\P{^Blk=		meroitic_CURSIVE}', "");
    Error('\p{Is_Block=:=-	meroitic_CURSIVE}');
    Error('\P{Is_Block=:=-	meroitic_CURSIVE}');
    Expect(1, 68095, '\p{Is_Block=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Is_Block=meroiticcursive}', "");
    Expect(0, 68095, '\P{Is_Block=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Is_Block=meroiticcursive}', "");
    Expect(0, 68096, '\p{Is_Block=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Is_Block=meroiticcursive}', "");
    Expect(1, 68096, '\P{Is_Block=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Is_Block=meroiticcursive}', "");
    Expect(1, 68095, '\p{Is_Block=	 meroitic_Cursive}', "");
    Expect(0, 68095, '\p{^Is_Block=	 meroitic_Cursive}', "");
    Expect(0, 68095, '\P{Is_Block=	 meroitic_Cursive}', "");
    Expect(1, 68095, '\P{^Is_Block=	 meroitic_Cursive}', "");
    Expect(0, 68096, '\p{Is_Block=	 meroitic_Cursive}', "");
    Expect(1, 68096, '\p{^Is_Block=	 meroitic_Cursive}', "");
    Expect(1, 68096, '\P{Is_Block=	 meroitic_Cursive}', "");
    Expect(0, 68096, '\P{^Is_Block=	 meroitic_Cursive}', "");
    Error('\p{Is_Blk=:= _MEROITIC_CURSIVE}');
    Error('\P{Is_Blk=:= _MEROITIC_CURSIVE}');
    Expect(1, 68095, '\p{Is_Blk=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Is_Blk=meroiticcursive}', "");
    Expect(0, 68095, '\P{Is_Blk=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Is_Blk=meroiticcursive}', "");
    Expect(0, 68096, '\p{Is_Blk=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Is_Blk=meroiticcursive}', "");
    Expect(1, 68096, '\P{Is_Blk=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Is_Blk=meroiticcursive}', "");
    Expect(1, 68095, '\p{Is_Blk=-_Meroitic_Cursive}', "");
    Expect(0, 68095, '\p{^Is_Blk=-_Meroitic_Cursive}', "");
    Expect(0, 68095, '\P{Is_Blk=-_Meroitic_Cursive}', "");
    Expect(1, 68095, '\P{^Is_Blk=-_Meroitic_Cursive}', "");
    Expect(0, 68096, '\p{Is_Blk=-_Meroitic_Cursive}', "");
    Expect(1, 68096, '\p{^Is_Blk=-_Meroitic_Cursive}', "");
    Expect(1, 68096, '\P{Is_Blk=-_Meroitic_Cursive}', "");
    Expect(0, 68096, '\P{^Is_Blk=-_Meroitic_Cursive}', "");
    Error('\p{Block=:=__meroitic_hieroglyphs}');
    Error('\P{Block=:=__meroitic_hieroglyphs}');
    Expect(1, 67999, '\p{Block=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Block=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Block=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Block=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Block=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Block=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Block=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Block=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Block=		Meroitic_HIEROGLYPHS}', "");
    Expect(0, 67999, '\p{^Block=		Meroitic_HIEROGLYPHS}', "");
    Expect(0, 67999, '\P{Block=		Meroitic_HIEROGLYPHS}', "");
    Expect(1, 67999, '\P{^Block=		Meroitic_HIEROGLYPHS}', "");
    Expect(0, 68000, '\p{Block=		Meroitic_HIEROGLYPHS}', "");
    Expect(1, 68000, '\p{^Block=		Meroitic_HIEROGLYPHS}', "");
    Expect(1, 68000, '\P{Block=		Meroitic_HIEROGLYPHS}', "");
    Expect(0, 68000, '\P{^Block=		Meroitic_HIEROGLYPHS}', "");
    Error('\p{Blk=	_meroitic_Hieroglyphs:=}');
    Error('\P{Blk=	_meroitic_Hieroglyphs:=}');
    Expect(1, 67999, '\p{Blk=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Blk=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Blk=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Blk=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Blk=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Blk=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Blk=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Blk=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Blk=_meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^Blk=_meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\P{Blk=_meroitic_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^Blk=_meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\p{Blk=_meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^Blk=_meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\P{Blk=_meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^Blk=_meroitic_Hieroglyphs}', "");
    Error('\p{Is_Block=:=	-meroitic_HIEROGLYPHS}');
    Error('\P{Is_Block=:=	-meroitic_HIEROGLYPHS}');
    Expect(1, 67999, '\p{Is_Block=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Block=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Block=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Block=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Block=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Block=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Block=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Block=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Is_Block=-meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Block=-meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Block=-meroitic_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Block=-meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Block=-meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Block=-meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Block=-meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Block=-meroitic_Hieroglyphs}', "");
    Error('\p{Is_Blk=:=Meroitic_Hieroglyphs}');
    Error('\P{Is_Blk=:=Meroitic_Hieroglyphs}');
    Expect(1, 67999, '\p{Is_Blk=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Blk=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Blk=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Blk=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Blk=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Blk=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Blk=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Blk=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Is_Blk=__Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Blk=__Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Blk=__Meroitic_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Blk=__Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Blk=__Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Blk=__Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Blk=__Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Blk=__Meroitic_Hieroglyphs}', "");
    Error('\p{Block:	 miao/a/}');
    Error('\P{Block:	 miao/a/}');
    Expect(1, 94111, '\p{Block=miao}', "");
    Expect(0, 94111, '\p{^Block=miao}', "");
    Expect(0, 94111, '\P{Block=miao}', "");
    Expect(1, 94111, '\P{^Block=miao}', "");
    Expect(0, 94112, '\p{Block=miao}', "");
    Expect(1, 94112, '\p{^Block=miao}', "");
    Expect(1, 94112, '\P{Block=miao}', "");
    Expect(0, 94112, '\P{^Block=miao}', "");
    Expect(1, 94111, '\p{Block: Miao}', "");
    Expect(0, 94111, '\p{^Block: Miao}', "");
    Expect(0, 94111, '\P{Block: Miao}', "");
    Expect(1, 94111, '\P{^Block: Miao}', "");
    Expect(0, 94112, '\p{Block: Miao}', "");
    Expect(1, 94112, '\p{^Block: Miao}', "");
    Expect(1, 94112, '\P{Block: Miao}', "");
    Expect(0, 94112, '\P{^Block: Miao}', "");
    Error('\p{Blk: /a/Miao}');
    Error('\P{Blk: /a/Miao}');
    Expect(1, 94111, '\p{Blk=miao}', "");
    Expect(0, 94111, '\p{^Blk=miao}', "");
    Expect(0, 94111, '\P{Blk=miao}', "");
    Expect(1, 94111, '\P{^Blk=miao}', "");
    Expect(0, 94112, '\p{Blk=miao}', "");
    Expect(1, 94112, '\p{^Blk=miao}', "");
    Expect(1, 94112, '\P{Blk=miao}', "");
    Expect(0, 94112, '\P{^Blk=miao}', "");
    Expect(1, 94111, '\p{Blk=_	Miao}', "");
    Expect(0, 94111, '\p{^Blk=_	Miao}', "");
    Expect(0, 94111, '\P{Blk=_	Miao}', "");
    Expect(1, 94111, '\P{^Blk=_	Miao}', "");
    Expect(0, 94112, '\p{Blk=_	Miao}', "");
    Expect(1, 94112, '\p{^Blk=_	Miao}', "");
    Expect(1, 94112, '\P{Blk=_	Miao}', "");
    Expect(0, 94112, '\P{^Blk=_	Miao}', "");
    Error('\p{Is_Block=	:=Miao}');
    Error('\P{Is_Block=	:=Miao}');
    Expect(1, 94111, '\p{Is_Block=miao}', "");
    Expect(0, 94111, '\p{^Is_Block=miao}', "");
    Expect(0, 94111, '\P{Is_Block=miao}', "");
    Expect(1, 94111, '\P{^Is_Block=miao}', "");
    Expect(0, 94112, '\p{Is_Block=miao}', "");
    Expect(1, 94112, '\p{^Is_Block=miao}', "");
    Expect(1, 94112, '\P{Is_Block=miao}', "");
    Expect(0, 94112, '\P{^Is_Block=miao}', "");
    Expect(1, 94111, '\p{Is_Block:	_-Miao}', "");
    Expect(0, 94111, '\p{^Is_Block:	_-Miao}', "");
    Expect(0, 94111, '\P{Is_Block:	_-Miao}', "");
    Expect(1, 94111, '\P{^Is_Block:	_-Miao}', "");
    Expect(0, 94112, '\p{Is_Block:	_-Miao}', "");
    Expect(1, 94112, '\p{^Is_Block:	_-Miao}', "");
    Expect(1, 94112, '\P{Is_Block:	_-Miao}', "");
    Expect(0, 94112, '\P{^Is_Block:	_-Miao}', "");
    Error('\p{Is_Blk=:=miao}');
    Error('\P{Is_Blk=:=miao}');
    Expect(1, 94111, '\p{Is_Blk=miao}', "");
    Expect(0, 94111, '\p{^Is_Blk=miao}', "");
    Expect(0, 94111, '\P{Is_Blk=miao}', "");
    Expect(1, 94111, '\P{^Is_Blk=miao}', "");
    Expect(0, 94112, '\p{Is_Blk=miao}', "");
    Expect(1, 94112, '\p{^Is_Blk=miao}', "");
    Expect(1, 94112, '\P{Is_Blk=miao}', "");
    Expect(0, 94112, '\P{^Is_Blk=miao}', "");
    Expect(1, 94111, '\p{Is_Blk=		miao}', "");
    Expect(0, 94111, '\p{^Is_Blk=		miao}', "");
    Expect(0, 94111, '\P{Is_Blk=		miao}', "");
    Expect(1, 94111, '\P{^Is_Blk=		miao}', "");
    Expect(0, 94112, '\p{Is_Blk=		miao}', "");
    Expect(1, 94112, '\p{^Is_Blk=		miao}', "");
    Expect(1, 94112, '\P{Is_Blk=		miao}', "");
    Expect(0, 94112, '\P{^Is_Blk=		miao}', "");
    Error('\p{Block=	:=Miscellaneous_symbols_And_arrows}');
    Error('\P{Block=	:=Miscellaneous_symbols_And_arrows}');
    Expect(1, 11263, '\p{Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\p{^Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\P{Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\P{^Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\p{Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\p{^Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\P{Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\P{^Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\p{Block=-	miscellaneous_Symbols_AND_arrows}', "");
    Expect(0, 11263, '\p{^Block=-	miscellaneous_Symbols_AND_arrows}', "");
    Expect(0, 11263, '\P{Block=-	miscellaneous_Symbols_AND_arrows}', "");
    Expect(1, 11263, '\P{^Block=-	miscellaneous_Symbols_AND_arrows}', "");
    Expect(0, 11264, '\p{Block=-	miscellaneous_Symbols_AND_arrows}', "");
    Expect(1, 11264, '\p{^Block=-	miscellaneous_Symbols_AND_arrows}', "");
    Expect(1, 11264, '\P{Block=-	miscellaneous_Symbols_AND_arrows}', "");
    Expect(0, 11264, '\P{^Block=-	miscellaneous_Symbols_AND_arrows}', "");
    Error('\p{Blk=:=	misc_Arrows}');
    Error('\P{Blk=:=	misc_Arrows}');
    Expect(1, 11263, '\p{Blk:   miscarrows}', "");
    Expect(0, 11263, '\p{^Blk:   miscarrows}', "");
    Expect(0, 11263, '\P{Blk:   miscarrows}', "");
    Expect(1, 11263, '\P{^Blk:   miscarrows}', "");
    Expect(0, 11264, '\p{Blk:   miscarrows}', "");
    Expect(1, 11264, '\p{^Blk:   miscarrows}', "");
    Expect(1, 11264, '\P{Blk:   miscarrows}', "");
    Expect(0, 11264, '\P{^Blk:   miscarrows}', "");
    Expect(1, 11263, '\p{Blk=		Misc_arrows}', "");
    Expect(0, 11263, '\p{^Blk=		Misc_arrows}', "");
    Expect(0, 11263, '\P{Blk=		Misc_arrows}', "");
    Expect(1, 11263, '\P{^Blk=		Misc_arrows}', "");
    Expect(0, 11264, '\p{Blk=		Misc_arrows}', "");
    Expect(1, 11264, '\p{^Blk=		Misc_arrows}', "");
    Expect(1, 11264, '\P{Blk=		Misc_arrows}', "");
    Expect(0, 11264, '\P{^Blk=		Misc_arrows}', "");
    Error('\p{Is_Block=-:=miscellaneous_Symbols_AND_ARROWS}');
    Error('\P{Is_Block=-:=miscellaneous_Symbols_AND_ARROWS}');
    Expect(1, 11263, '\p{Is_Block:miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\p{^Is_Block:miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\P{Is_Block:miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\P{^Is_Block:miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\p{Is_Block:miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\p{^Is_Block:miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\P{Is_Block:miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\P{^Is_Block:miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\p{Is_Block=--MISCELLANEOUS_SYMBOLS_And_Arrows}', "");
    Expect(0, 11263, '\p{^Is_Block=--MISCELLANEOUS_SYMBOLS_And_Arrows}', "");
    Expect(0, 11263, '\P{Is_Block=--MISCELLANEOUS_SYMBOLS_And_Arrows}', "");
    Expect(1, 11263, '\P{^Is_Block=--MISCELLANEOUS_SYMBOLS_And_Arrows}', "");
    Expect(0, 11264, '\p{Is_Block=--MISCELLANEOUS_SYMBOLS_And_Arrows}', "");
    Expect(1, 11264, '\p{^Is_Block=--MISCELLANEOUS_SYMBOLS_And_Arrows}', "");
    Expect(1, 11264, '\P{Is_Block=--MISCELLANEOUS_SYMBOLS_And_Arrows}', "");
    Expect(0, 11264, '\P{^Is_Block=--MISCELLANEOUS_SYMBOLS_And_Arrows}', "");
    Error('\p{Is_Blk=/a/misc_Arrows}');
    Error('\P{Is_Blk=/a/misc_Arrows}');
    Expect(1, 11263, '\p{Is_Blk=miscarrows}', "");
    Expect(0, 11263, '\p{^Is_Blk=miscarrows}', "");
    Expect(0, 11263, '\P{Is_Blk=miscarrows}', "");
    Expect(1, 11263, '\P{^Is_Blk=miscarrows}', "");
    Expect(0, 11264, '\p{Is_Blk=miscarrows}', "");
    Expect(1, 11264, '\p{^Is_Blk=miscarrows}', "");
    Expect(1, 11264, '\P{Is_Blk=miscarrows}', "");
    Expect(0, 11264, '\P{^Is_Blk=miscarrows}', "");
    Expect(1, 11263, '\p{Is_Blk=_	Misc_Arrows}', "");
    Expect(0, 11263, '\p{^Is_Blk=_	Misc_Arrows}', "");
    Expect(0, 11263, '\P{Is_Blk=_	Misc_Arrows}', "");
    Expect(1, 11263, '\P{^Is_Blk=_	Misc_Arrows}', "");
    Expect(0, 11264, '\p{Is_Blk=_	Misc_Arrows}', "");
    Expect(1, 11264, '\p{^Is_Blk=_	Misc_Arrows}', "");
    Expect(1, 11264, '\P{Is_Blk=_	Misc_Arrows}', "");
    Expect(0, 11264, '\P{^Is_Blk=_	Misc_Arrows}', "");
    Error('\p{Block=-_miscellaneous_mathematical_SYMBOLS_a/a/}');
    Error('\P{Block=-_miscellaneous_mathematical_SYMBOLS_a/a/}');
    Expect(1, 10223, '\p{Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\p{^Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\P{Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\P{^Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\p{Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\p{^Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\P{Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\P{^Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\p{Block:	 	miscellaneous_Mathematical_SYMBOLS_A}', "");
    Expect(0, 10223, '\p{^Block:	 	miscellaneous_Mathematical_SYMBOLS_A}', "");
    Expect(0, 10223, '\P{Block:	 	miscellaneous_Mathematical_SYMBOLS_A}', "");
    Expect(1, 10223, '\P{^Block:	 	miscellaneous_Mathematical_SYMBOLS_A}', "");
    Expect(0, 10224, '\p{Block:	 	miscellaneous_Mathematical_SYMBOLS_A}', "");
    Expect(1, 10224, '\p{^Block:	 	miscellaneous_Mathematical_SYMBOLS_A}', "");
    Expect(1, 10224, '\P{Block:	 	miscellaneous_Mathematical_SYMBOLS_A}', "");
    Expect(0, 10224, '\P{^Block:	 	miscellaneous_Mathematical_SYMBOLS_A}', "");
    Error('\p{Blk=_:=MISC_math_symbols_A}');
    Error('\P{Blk=_:=MISC_math_symbols_A}');
    Expect(1, 10223, '\p{Blk=miscmathsymbolsa}', "");
    Expect(0, 10223, '\p{^Blk=miscmathsymbolsa}', "");
    Expect(0, 10223, '\P{Blk=miscmathsymbolsa}', "");
    Expect(1, 10223, '\P{^Blk=miscmathsymbolsa}', "");
    Expect(0, 10224, '\p{Blk=miscmathsymbolsa}', "");
    Expect(1, 10224, '\p{^Blk=miscmathsymbolsa}', "");
    Expect(1, 10224, '\P{Blk=miscmathsymbolsa}', "");
    Expect(0, 10224, '\P{^Blk=miscmathsymbolsa}', "");
    Expect(1, 10223, '\p{Blk=	 MISC_MATH_Symbols_A}', "");
    Expect(0, 10223, '\p{^Blk=	 MISC_MATH_Symbols_A}', "");
    Expect(0, 10223, '\P{Blk=	 MISC_MATH_Symbols_A}', "");
    Expect(1, 10223, '\P{^Blk=	 MISC_MATH_Symbols_A}', "");
    Expect(0, 10224, '\p{Blk=	 MISC_MATH_Symbols_A}', "");
    Expect(1, 10224, '\p{^Blk=	 MISC_MATH_Symbols_A}', "");
    Expect(1, 10224, '\P{Blk=	 MISC_MATH_Symbols_A}', "");
    Expect(0, 10224, '\P{^Blk=	 MISC_MATH_Symbols_A}', "");
    Error('\p{Is_Block= :=Miscellaneous_MATHEMATICAL_Symbols_A}');
    Error('\P{Is_Block= :=Miscellaneous_MATHEMATICAL_Symbols_A}');
    Expect(1, 10223, '\p{Is_Block:miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\p{^Is_Block:miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\P{Is_Block:miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\P{^Is_Block:miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\p{Is_Block:miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\p{^Is_Block:miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\P{Is_Block:miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\P{^Is_Block:miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\p{Is_Block= MISCELLANEOUS_mathematical_Symbols_A}', "");
    Expect(0, 10223, '\p{^Is_Block= MISCELLANEOUS_mathematical_Symbols_A}', "");
    Expect(0, 10223, '\P{Is_Block= MISCELLANEOUS_mathematical_Symbols_A}', "");
    Expect(1, 10223, '\P{^Is_Block= MISCELLANEOUS_mathematical_Symbols_A}', "");
    Expect(0, 10224, '\p{Is_Block= MISCELLANEOUS_mathematical_Symbols_A}', "");
    Expect(1, 10224, '\p{^Is_Block= MISCELLANEOUS_mathematical_Symbols_A}', "");
    Expect(1, 10224, '\P{Is_Block= MISCELLANEOUS_mathematical_Symbols_A}', "");
    Expect(0, 10224, '\P{^Is_Block= MISCELLANEOUS_mathematical_Symbols_A}', "");
    Error('\p{Is_Blk=	/a/MISC_Math_SYMBOLS_A}');
    Error('\P{Is_Blk=	/a/MISC_Math_SYMBOLS_A}');
    Expect(1, 10223, '\p{Is_Blk=miscmathsymbolsa}', "");
    Expect(0, 10223, '\p{^Is_Blk=miscmathsymbolsa}', "");
    Expect(0, 10223, '\P{Is_Blk=miscmathsymbolsa}', "");
    Expect(1, 10223, '\P{^Is_Blk=miscmathsymbolsa}', "");
    Expect(0, 10224, '\p{Is_Blk=miscmathsymbolsa}', "");
    Expect(1, 10224, '\p{^Is_Blk=miscmathsymbolsa}', "");
    Expect(1, 10224, '\P{Is_Blk=miscmathsymbolsa}', "");
    Expect(0, 10224, '\P{^Is_Blk=miscmathsymbolsa}', "");
    Expect(1, 10223, '\p{Is_Blk=- Misc_Math_SYMBOLS_A}', "");
    Expect(0, 10223, '\p{^Is_Blk=- Misc_Math_SYMBOLS_A}', "");
    Expect(0, 10223, '\P{Is_Blk=- Misc_Math_SYMBOLS_A}', "");
    Expect(1, 10223, '\P{^Is_Blk=- Misc_Math_SYMBOLS_A}', "");
    Expect(0, 10224, '\p{Is_Blk=- Misc_Math_SYMBOLS_A}', "");
    Expect(1, 10224, '\p{^Is_Blk=- Misc_Math_SYMBOLS_A}', "");
    Expect(1, 10224, '\P{Is_Blk=- Misc_Math_SYMBOLS_A}', "");
    Expect(0, 10224, '\P{^Is_Blk=- Misc_Math_SYMBOLS_A}', "");
    Error('\p{Block=_/a/MISCELLANEOUS_Mathematical_Symbols_B}');
    Error('\P{Block=_/a/MISCELLANEOUS_Mathematical_Symbols_B}');
    Expect(1, 10751, '\p{Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\p{^Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\P{Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\P{^Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\p{Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\p{^Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\P{Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\P{^Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\p{Block=_-miscellaneous_MATHEMATICAL_symbols_b}', "");
    Expect(0, 10751, '\p{^Block=_-miscellaneous_MATHEMATICAL_symbols_b}', "");
    Expect(0, 10751, '\P{Block=_-miscellaneous_MATHEMATICAL_symbols_b}', "");
    Expect(1, 10751, '\P{^Block=_-miscellaneous_MATHEMATICAL_symbols_b}', "");
    Expect(0, 10752, '\p{Block=_-miscellaneous_MATHEMATICAL_symbols_b}', "");
    Expect(1, 10752, '\p{^Block=_-miscellaneous_MATHEMATICAL_symbols_b}', "");
    Expect(1, 10752, '\P{Block=_-miscellaneous_MATHEMATICAL_symbols_b}', "");
    Expect(0, 10752, '\P{^Block=_-miscellaneous_MATHEMATICAL_symbols_b}', "");
    Error('\p{Blk=:=	 Misc_math_SYMBOLS_B}');
    Error('\P{Blk=:=	 Misc_math_SYMBOLS_B}');
    Expect(1, 10751, '\p{Blk=miscmathsymbolsb}', "");
    Expect(0, 10751, '\p{^Blk=miscmathsymbolsb}', "");
    Expect(0, 10751, '\P{Blk=miscmathsymbolsb}', "");
    Expect(1, 10751, '\P{^Blk=miscmathsymbolsb}', "");
    Expect(0, 10752, '\p{Blk=miscmathsymbolsb}', "");
    Expect(1, 10752, '\p{^Blk=miscmathsymbolsb}', "");
    Expect(1, 10752, '\P{Blk=miscmathsymbolsb}', "");
    Expect(0, 10752, '\P{^Blk=miscmathsymbolsb}', "");
    Expect(1, 10751, '\p{Blk=	 MISC_math_SYMBOLS_B}', "");
    Expect(0, 10751, '\p{^Blk=	 MISC_math_SYMBOLS_B}', "");
    Expect(0, 10751, '\P{Blk=	 MISC_math_SYMBOLS_B}', "");
    Expect(1, 10751, '\P{^Blk=	 MISC_math_SYMBOLS_B}', "");
    Expect(0, 10752, '\p{Blk=	 MISC_math_SYMBOLS_B}', "");
    Expect(1, 10752, '\p{^Blk=	 MISC_math_SYMBOLS_B}', "");
    Expect(1, 10752, '\P{Blk=	 MISC_math_SYMBOLS_B}', "");
    Expect(0, 10752, '\P{^Blk=	 MISC_math_SYMBOLS_B}', "");
    Error('\p{Is_Block=MISCELLANEOUS_mathematical_Symbols_B/a/}');
    Error('\P{Is_Block=MISCELLANEOUS_mathematical_Symbols_B/a/}');
    Expect(1, 10751, '\p{Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\p{^Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\P{Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\P{^Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\p{Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\p{^Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\P{Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\P{^Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\p{Is_Block: -miscellaneous_Mathematical_SYMBOLS_B}', "");
    Expect(0, 10751, '\p{^Is_Block: -miscellaneous_Mathematical_SYMBOLS_B}', "");
    Expect(0, 10751, '\P{Is_Block: -miscellaneous_Mathematical_SYMBOLS_B}', "");
    Expect(1, 10751, '\P{^Is_Block: -miscellaneous_Mathematical_SYMBOLS_B}', "");
    Expect(0, 10752, '\p{Is_Block: -miscellaneous_Mathematical_SYMBOLS_B}', "");
    Expect(1, 10752, '\p{^Is_Block: -miscellaneous_Mathematical_SYMBOLS_B}', "");
    Expect(1, 10752, '\P{Is_Block: -miscellaneous_Mathematical_SYMBOLS_B}', "");
    Expect(0, 10752, '\P{^Is_Block: -miscellaneous_Mathematical_SYMBOLS_B}', "");
    Error('\p{Is_Blk: -Misc_math_symbols_B/a/}');
    Error('\P{Is_Blk: -Misc_math_symbols_B/a/}');
    Expect(1, 10751, '\p{Is_Blk=miscmathsymbolsb}', "");
    Expect(0, 10751, '\p{^Is_Blk=miscmathsymbolsb}', "");
    Expect(0, 10751, '\P{Is_Blk=miscmathsymbolsb}', "");
    Expect(1, 10751, '\P{^Is_Blk=miscmathsymbolsb}', "");
    Expect(0, 10752, '\p{Is_Blk=miscmathsymbolsb}', "");
    Expect(1, 10752, '\p{^Is_Blk=miscmathsymbolsb}', "");
    Expect(1, 10752, '\P{Is_Blk=miscmathsymbolsb}', "");
    Expect(0, 10752, '\P{^Is_Blk=miscmathsymbolsb}', "");
    Expect(1, 10751, '\p{Is_Blk=_	MISC_math_symbols_B}', "");
    Expect(0, 10751, '\p{^Is_Blk=_	MISC_math_symbols_B}', "");
    Expect(0, 10751, '\P{Is_Blk=_	MISC_math_symbols_B}', "");
    Expect(1, 10751, '\P{^Is_Blk=_	MISC_math_symbols_B}', "");
    Expect(0, 10752, '\p{Is_Blk=_	MISC_math_symbols_B}', "");
    Expect(1, 10752, '\p{^Is_Blk=_	MISC_math_symbols_B}', "");
    Expect(1, 10752, '\P{Is_Blk=_	MISC_math_symbols_B}', "");
    Expect(0, 10752, '\P{^Is_Blk=_	MISC_math_symbols_B}', "");
    Error('\p{Block=/a/Miscellaneous_Symbols_And_Pictographs}');
    Error('\P{Block=/a/Miscellaneous_Symbols_And_Pictographs}');
    Expect(1, 128511, '\p{Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\p{^Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\P{Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\P{^Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\p{Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\p{^Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\P{Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\P{^Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\p{Block=- miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 128511, '\p{^Block=- miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 128511, '\P{Block=- miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(1, 128511, '\P{^Block=- miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 128512, '\p{Block=- miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(1, 128512, '\p{^Block=- miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(1, 128512, '\P{Block=- miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 128512, '\P{^Block=- miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Error('\p{Blk=	/a/Misc_pictographs}');
    Error('\P{Blk=	/a/Misc_pictographs}');
    Expect(1, 128511, '\p{Blk=miscpictographs}', "");
    Expect(0, 128511, '\p{^Blk=miscpictographs}', "");
    Expect(0, 128511, '\P{Blk=miscpictographs}', "");
    Expect(1, 128511, '\P{^Blk=miscpictographs}', "");
    Expect(0, 128512, '\p{Blk=miscpictographs}', "");
    Expect(1, 128512, '\p{^Blk=miscpictographs}', "");
    Expect(1, 128512, '\P{Blk=miscpictographs}', "");
    Expect(0, 128512, '\P{^Blk=miscpictographs}', "");
    Expect(1, 128511, '\p{Blk: -misc_Pictographs}', "");
    Expect(0, 128511, '\p{^Blk: -misc_Pictographs}', "");
    Expect(0, 128511, '\P{Blk: -misc_Pictographs}', "");
    Expect(1, 128511, '\P{^Blk: -misc_Pictographs}', "");
    Expect(0, 128512, '\p{Blk: -misc_Pictographs}', "");
    Expect(1, 128512, '\p{^Blk: -misc_Pictographs}', "");
    Expect(1, 128512, '\P{Blk: -misc_Pictographs}', "");
    Expect(0, 128512, '\P{^Blk: -misc_Pictographs}', "");
    Error('\p{Is_Block=-:=miscellaneous_SYMBOLS_AND_PICTOGRAPHS}');
    Error('\P{Is_Block=-:=miscellaneous_SYMBOLS_AND_PICTOGRAPHS}');
    Expect(1, 128511, '\p{Is_Block:   miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\p{^Is_Block:   miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\P{Is_Block:   miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\P{^Is_Block:   miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\p{Is_Block:   miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\p{^Is_Block:   miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\P{Is_Block:   miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\P{^Is_Block:   miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\p{Is_Block=-	Miscellaneous_SYMBOLS_And_PICTOGRAPHS}', "");
    Expect(0, 128511, '\p{^Is_Block=-	Miscellaneous_SYMBOLS_And_PICTOGRAPHS}', "");
    Expect(0, 128511, '\P{Is_Block=-	Miscellaneous_SYMBOLS_And_PICTOGRAPHS}', "");
    Expect(1, 128511, '\P{^Is_Block=-	Miscellaneous_SYMBOLS_And_PICTOGRAPHS}', "");
    Expect(0, 128512, '\p{Is_Block=-	Miscellaneous_SYMBOLS_And_PICTOGRAPHS}', "");
    Expect(1, 128512, '\p{^Is_Block=-	Miscellaneous_SYMBOLS_And_PICTOGRAPHS}', "");
    Expect(1, 128512, '\P{Is_Block=-	Miscellaneous_SYMBOLS_And_PICTOGRAPHS}', "");
    Expect(0, 128512, '\P{^Is_Block=-	Miscellaneous_SYMBOLS_And_PICTOGRAPHS}', "");
    Error('\p{Is_Blk: :=	-misc_Pictographs}');
    Error('\P{Is_Blk: :=	-misc_Pictographs}');
    Expect(1, 128511, '\p{Is_Blk=miscpictographs}', "");
    Expect(0, 128511, '\p{^Is_Blk=miscpictographs}', "");
    Expect(0, 128511, '\P{Is_Blk=miscpictographs}', "");
    Expect(1, 128511, '\P{^Is_Blk=miscpictographs}', "");
    Expect(0, 128512, '\p{Is_Blk=miscpictographs}', "");
    Expect(1, 128512, '\p{^Is_Blk=miscpictographs}', "");
    Expect(1, 128512, '\P{Is_Blk=miscpictographs}', "");
    Expect(0, 128512, '\P{^Is_Blk=miscpictographs}', "");
    Expect(1, 128511, '\p{Is_Blk=	-MISC_PICTOGRAPHS}', "");
    Expect(0, 128511, '\p{^Is_Blk=	-MISC_PICTOGRAPHS}', "");
    Expect(0, 128511, '\P{Is_Blk=	-MISC_PICTOGRAPHS}', "");
    Expect(1, 128511, '\P{^Is_Blk=	-MISC_PICTOGRAPHS}', "");
    Expect(0, 128512, '\p{Is_Blk=	-MISC_PICTOGRAPHS}', "");
    Expect(1, 128512, '\p{^Is_Blk=	-MISC_PICTOGRAPHS}', "");
    Expect(1, 128512, '\P{Is_Blk=	-MISC_PICTOGRAPHS}', "");
    Expect(0, 128512, '\P{^Is_Blk=	-MISC_PICTOGRAPHS}', "");
    Error('\p{Block=_Miscellaneous_Symbols:=}');
    Error('\P{Block=_Miscellaneous_Symbols:=}');
    Expect(1, 9983, '\p{Block=miscellaneoussymbols}', "");
    Expect(0, 9983, '\p{^Block=miscellaneoussymbols}', "");
    Expect(0, 9983, '\P{Block=miscellaneoussymbols}', "");
    Expect(1, 9983, '\P{^Block=miscellaneoussymbols}', "");
    Expect(0, 9984, '\p{Block=miscellaneoussymbols}', "");
    Expect(1, 9984, '\p{^Block=miscellaneoussymbols}', "");
    Expect(1, 9984, '\P{Block=miscellaneoussymbols}', "");
    Expect(0, 9984, '\P{^Block=miscellaneoussymbols}', "");
    Expect(1, 9983, '\p{Block=  miscellaneous_Symbols}', "");
    Expect(0, 9983, '\p{^Block=  miscellaneous_Symbols}', "");
    Expect(0, 9983, '\P{Block=  miscellaneous_Symbols}', "");
    Expect(1, 9983, '\P{^Block=  miscellaneous_Symbols}', "");
    Expect(0, 9984, '\p{Block=  miscellaneous_Symbols}', "");
    Expect(1, 9984, '\p{^Block=  miscellaneous_Symbols}', "");
    Expect(1, 9984, '\P{Block=  miscellaneous_Symbols}', "");
    Expect(0, 9984, '\P{^Block=  miscellaneous_Symbols}', "");
    Error('\p{Blk=:=  Misc_Symbols}');
    Error('\P{Blk=:=  Misc_Symbols}');
    Expect(1, 9983, '\p{Blk=miscsymbols}', "");
    Expect(0, 9983, '\p{^Blk=miscsymbols}', "");
    Expect(0, 9983, '\P{Blk=miscsymbols}', "");
    Expect(1, 9983, '\P{^Blk=miscsymbols}', "");
    Expect(0, 9984, '\p{Blk=miscsymbols}', "");
    Expect(1, 9984, '\p{^Blk=miscsymbols}', "");
    Expect(1, 9984, '\P{Blk=miscsymbols}', "");
    Expect(0, 9984, '\P{^Blk=miscsymbols}', "");
    Expect(1, 9983, '\p{Blk=_-MISC_Symbols}', "");
    Expect(0, 9983, '\p{^Blk=_-MISC_Symbols}', "");
    Expect(0, 9983, '\P{Blk=_-MISC_Symbols}', "");
    Expect(1, 9983, '\P{^Blk=_-MISC_Symbols}', "");
    Expect(0, 9984, '\p{Blk=_-MISC_Symbols}', "");
    Expect(1, 9984, '\p{^Blk=_-MISC_Symbols}', "");
    Expect(1, 9984, '\P{Blk=_-MISC_Symbols}', "");
    Expect(0, 9984, '\P{^Blk=_-MISC_Symbols}', "");
    Error('\p{Is_Block=:= 	MISCELLANEOUS_symbols}');
    Error('\P{Is_Block=:= 	MISCELLANEOUS_symbols}');
    Expect(1, 9983, '\p{Is_Block=miscellaneoussymbols}', "");
    Expect(0, 9983, '\p{^Is_Block=miscellaneoussymbols}', "");
    Expect(0, 9983, '\P{Is_Block=miscellaneoussymbols}', "");
    Expect(1, 9983, '\P{^Is_Block=miscellaneoussymbols}', "");
    Expect(0, 9984, '\p{Is_Block=miscellaneoussymbols}', "");
    Expect(1, 9984, '\p{^Is_Block=miscellaneoussymbols}', "");
    Expect(1, 9984, '\P{Is_Block=miscellaneoussymbols}', "");
    Expect(0, 9984, '\P{^Is_Block=miscellaneoussymbols}', "");
    Expect(1, 9983, '\p{Is_Block:   _ Miscellaneous_Symbols}', "");
    Expect(0, 9983, '\p{^Is_Block:   _ Miscellaneous_Symbols}', "");
    Expect(0, 9983, '\P{Is_Block:   _ Miscellaneous_Symbols}', "");
    Expect(1, 9983, '\P{^Is_Block:   _ Miscellaneous_Symbols}', "");
    Expect(0, 9984, '\p{Is_Block:   _ Miscellaneous_Symbols}', "");
    Expect(1, 9984, '\p{^Is_Block:   _ Miscellaneous_Symbols}', "");
    Expect(1, 9984, '\P{Is_Block:   _ Miscellaneous_Symbols}', "");
    Expect(0, 9984, '\P{^Is_Block:   _ Miscellaneous_Symbols}', "");
    Error('\p{Is_Blk=:=_Misc_SYMBOLS}');
    Error('\P{Is_Blk=:=_Misc_SYMBOLS}');
    Expect(1, 9983, '\p{Is_Blk=miscsymbols}', "");
    Expect(0, 9983, '\p{^Is_Blk=miscsymbols}', "");
    Expect(0, 9983, '\P{Is_Blk=miscsymbols}', "");
    Expect(1, 9983, '\P{^Is_Blk=miscsymbols}', "");
    Expect(0, 9984, '\p{Is_Blk=miscsymbols}', "");
    Expect(1, 9984, '\p{^Is_Blk=miscsymbols}', "");
    Expect(1, 9984, '\P{Is_Blk=miscsymbols}', "");
    Expect(0, 9984, '\P{^Is_Blk=miscsymbols}', "");
    Expect(1, 9983, '\p{Is_Blk= _Misc_Symbols}', "");
    Expect(0, 9983, '\p{^Is_Blk= _Misc_Symbols}', "");
    Expect(0, 9983, '\P{Is_Blk= _Misc_Symbols}', "");
    Expect(1, 9983, '\P{^Is_Blk= _Misc_Symbols}', "");
    Expect(0, 9984, '\p{Is_Blk= _Misc_Symbols}', "");
    Expect(1, 9984, '\p{^Is_Blk= _Misc_Symbols}', "");
    Expect(1, 9984, '\P{Is_Blk= _Misc_Symbols}', "");
    Expect(0, 9984, '\P{^Is_Blk= _Misc_Symbols}', "");
    Error('\p{Block=:=	miscellaneous_TECHNICAL}');
    Error('\P{Block=:=	miscellaneous_TECHNICAL}');
    Expect(1, 9215, '\p{Block=miscellaneoustechnical}', "");
    Expect(0, 9215, '\p{^Block=miscellaneoustechnical}', "");
    Expect(0, 9215, '\P{Block=miscellaneoustechnical}', "");
    Expect(1, 9215, '\P{^Block=miscellaneoustechnical}', "");
    Expect(0, 9216, '\p{Block=miscellaneoustechnical}', "");
    Expect(1, 9216, '\p{^Block=miscellaneoustechnical}', "");
    Expect(1, 9216, '\P{Block=miscellaneoustechnical}', "");
    Expect(0, 9216, '\P{^Block=miscellaneoustechnical}', "");
    Expect(1, 9215, '\p{Block:	__Miscellaneous_technical}', "");
    Expect(0, 9215, '\p{^Block:	__Miscellaneous_technical}', "");
    Expect(0, 9215, '\P{Block:	__Miscellaneous_technical}', "");
    Expect(1, 9215, '\P{^Block:	__Miscellaneous_technical}', "");
    Expect(0, 9216, '\p{Block:	__Miscellaneous_technical}', "");
    Expect(1, 9216, '\p{^Block:	__Miscellaneous_technical}', "");
    Expect(1, 9216, '\P{Block:	__Miscellaneous_technical}', "");
    Expect(0, 9216, '\P{^Block:	__Miscellaneous_technical}', "");
    Error('\p{Blk=_Misc_TECHNICAL/a/}');
    Error('\P{Blk=_Misc_TECHNICAL/a/}');
    Expect(1, 9215, '\p{Blk=misctechnical}', "");
    Expect(0, 9215, '\p{^Blk=misctechnical}', "");
    Expect(0, 9215, '\P{Blk=misctechnical}', "");
    Expect(1, 9215, '\P{^Blk=misctechnical}', "");
    Expect(0, 9216, '\p{Blk=misctechnical}', "");
    Expect(1, 9216, '\p{^Blk=misctechnical}', "");
    Expect(1, 9216, '\P{Blk=misctechnical}', "");
    Expect(0, 9216, '\P{^Blk=misctechnical}', "");
    Expect(1, 9215, '\p{Blk=-MISC_TECHNICAL}', "");
    Expect(0, 9215, '\p{^Blk=-MISC_TECHNICAL}', "");
    Expect(0, 9215, '\P{Blk=-MISC_TECHNICAL}', "");
    Expect(1, 9215, '\P{^Blk=-MISC_TECHNICAL}', "");
    Expect(0, 9216, '\p{Blk=-MISC_TECHNICAL}', "");
    Expect(1, 9216, '\p{^Blk=-MISC_TECHNICAL}', "");
    Expect(1, 9216, '\P{Blk=-MISC_TECHNICAL}', "");
    Expect(0, 9216, '\P{^Blk=-MISC_TECHNICAL}', "");
    Error('\p{Is_Block=:=-_miscellaneous_TECHNICAL}');
    Error('\P{Is_Block=:=-_miscellaneous_TECHNICAL}');
    Expect(1, 9215, '\p{Is_Block=miscellaneoustechnical}', "");
    Expect(0, 9215, '\p{^Is_Block=miscellaneoustechnical}', "");
    Expect(0, 9215, '\P{Is_Block=miscellaneoustechnical}', "");
    Expect(1, 9215, '\P{^Is_Block=miscellaneoustechnical}', "");
    Expect(0, 9216, '\p{Is_Block=miscellaneoustechnical}', "");
    Expect(1, 9216, '\p{^Is_Block=miscellaneoustechnical}', "");
    Expect(1, 9216, '\P{Is_Block=miscellaneoustechnical}', "");
    Expect(0, 9216, '\P{^Is_Block=miscellaneoustechnical}', "");
    Expect(1, 9215, '\p{Is_Block=-Miscellaneous_Technical}', "");
    Expect(0, 9215, '\p{^Is_Block=-Miscellaneous_Technical}', "");
    Expect(0, 9215, '\P{Is_Block=-Miscellaneous_Technical}', "");
    Expect(1, 9215, '\P{^Is_Block=-Miscellaneous_Technical}', "");
    Expect(0, 9216, '\p{Is_Block=-Miscellaneous_Technical}', "");
    Expect(1, 9216, '\p{^Is_Block=-Miscellaneous_Technical}', "");
    Expect(1, 9216, '\P{Is_Block=-Miscellaneous_Technical}', "");
    Expect(0, 9216, '\P{^Is_Block=-Miscellaneous_Technical}', "");
    Error('\p{Is_Blk:	/a/misc_Technical}');
    Error('\P{Is_Blk:	/a/misc_Technical}');
    Expect(1, 9215, '\p{Is_Blk=misctechnical}', "");
    Expect(0, 9215, '\p{^Is_Blk=misctechnical}', "");
    Expect(0, 9215, '\P{Is_Blk=misctechnical}', "");
    Expect(1, 9215, '\P{^Is_Blk=misctechnical}', "");
    Expect(0, 9216, '\p{Is_Blk=misctechnical}', "");
    Expect(1, 9216, '\p{^Is_Blk=misctechnical}', "");
    Expect(1, 9216, '\P{Is_Blk=misctechnical}', "");
    Expect(0, 9216, '\P{^Is_Blk=misctechnical}', "");
    Expect(1, 9215, '\p{Is_Blk=-	Misc_technical}', "");
    Expect(0, 9215, '\p{^Is_Blk=-	Misc_technical}', "");
    Expect(0, 9215, '\P{Is_Blk=-	Misc_technical}', "");
    Expect(1, 9215, '\P{^Is_Blk=-	Misc_technical}', "");
    Expect(0, 9216, '\p{Is_Blk=-	Misc_technical}', "");
    Expect(1, 9216, '\p{^Is_Blk=-	Misc_technical}', "");
    Expect(1, 9216, '\P{Is_Blk=-	Misc_technical}', "");
    Expect(0, 9216, '\P{^Is_Blk=-	Misc_technical}', "");
    Error('\p{Block: _/a/Modi}');
    Error('\P{Block: _/a/Modi}');
    Expect(1, 71263, '\p{Block=modi}', "");
    Expect(0, 71263, '\p{^Block=modi}', "");
    Expect(0, 71263, '\P{Block=modi}', "");
    Expect(1, 71263, '\P{^Block=modi}', "");
    Expect(0, 71264, '\p{Block=modi}', "");
    Expect(1, 71264, '\p{^Block=modi}', "");
    Expect(1, 71264, '\P{Block=modi}', "");
    Expect(0, 71264, '\P{^Block=modi}', "");
    Expect(1, 71263, '\p{Block: 	_MODI}', "");
    Expect(0, 71263, '\p{^Block: 	_MODI}', "");
    Expect(0, 71263, '\P{Block: 	_MODI}', "");
    Expect(1, 71263, '\P{^Block: 	_MODI}', "");
    Expect(0, 71264, '\p{Block: 	_MODI}', "");
    Expect(1, 71264, '\p{^Block: 	_MODI}', "");
    Expect(1, 71264, '\P{Block: 	_MODI}', "");
    Expect(0, 71264, '\P{^Block: 	_MODI}', "");
    Error('\p{Blk=_modi:=}');
    Error('\P{Blk=_modi:=}');
    Expect(1, 71263, '\p{Blk=modi}', "");
    Expect(0, 71263, '\p{^Blk=modi}', "");
    Expect(0, 71263, '\P{Blk=modi}', "");
    Expect(1, 71263, '\P{^Blk=modi}', "");
    Expect(0, 71264, '\p{Blk=modi}', "");
    Expect(1, 71264, '\p{^Blk=modi}', "");
    Expect(1, 71264, '\P{Blk=modi}', "");
    Expect(0, 71264, '\P{^Blk=modi}', "");
    Expect(1, 71263, '\p{Blk=- Modi}', "");
    Expect(0, 71263, '\p{^Blk=- Modi}', "");
    Expect(0, 71263, '\P{Blk=- Modi}', "");
    Expect(1, 71263, '\P{^Blk=- Modi}', "");
    Expect(0, 71264, '\p{Blk=- Modi}', "");
    Expect(1, 71264, '\p{^Blk=- Modi}', "");
    Expect(1, 71264, '\P{Blk=- Modi}', "");
    Expect(0, 71264, '\P{^Blk=- Modi}', "");
    Error('\p{Is_Block= _Modi/a/}');
    Error('\P{Is_Block= _Modi/a/}');
    Expect(1, 71263, '\p{Is_Block=modi}', "");
    Expect(0, 71263, '\p{^Is_Block=modi}', "");
    Expect(0, 71263, '\P{Is_Block=modi}', "");
    Expect(1, 71263, '\P{^Is_Block=modi}', "");
    Expect(0, 71264, '\p{Is_Block=modi}', "");
    Expect(1, 71264, '\p{^Is_Block=modi}', "");
    Expect(1, 71264, '\P{Is_Block=modi}', "");
    Expect(0, 71264, '\P{^Is_Block=modi}', "");
    Expect(1, 71263, '\p{Is_Block= modi}', "");
    Expect(0, 71263, '\p{^Is_Block= modi}', "");
    Expect(0, 71263, '\P{Is_Block= modi}', "");
    Expect(1, 71263, '\P{^Is_Block= modi}', "");
    Expect(0, 71264, '\p{Is_Block= modi}', "");
    Expect(1, 71264, '\p{^Is_Block= modi}', "");
    Expect(1, 71264, '\P{Is_Block= modi}', "");
    Expect(0, 71264, '\P{^Is_Block= modi}', "");
    Error('\p{Is_Blk=_MODI/a/}');
    Error('\P{Is_Blk=_MODI/a/}');
    Expect(1, 71263, '\p{Is_Blk=modi}', "");
    Expect(0, 71263, '\p{^Is_Blk=modi}', "");
    Expect(0, 71263, '\P{Is_Blk=modi}', "");
    Expect(1, 71263, '\P{^Is_Blk=modi}', "");
    Expect(0, 71264, '\p{Is_Blk=modi}', "");
    Expect(1, 71264, '\p{^Is_Blk=modi}', "");
    Expect(1, 71264, '\P{Is_Blk=modi}', "");
    Expect(0, 71264, '\P{^Is_Blk=modi}', "");
    Expect(1, 71263, '\p{Is_Blk=--Modi}', "");
    Expect(0, 71263, '\p{^Is_Blk=--Modi}', "");
    Expect(0, 71263, '\P{Is_Blk=--Modi}', "");
    Expect(1, 71263, '\P{^Is_Blk=--Modi}', "");
    Expect(0, 71264, '\p{Is_Blk=--Modi}', "");
    Expect(1, 71264, '\p{^Is_Blk=--Modi}', "");
    Expect(1, 71264, '\P{Is_Blk=--Modi}', "");
    Expect(0, 71264, '\P{^Is_Blk=--Modi}', "");
    Error('\p{Block=_:=SPACING_modifier_letters}');
    Error('\P{Block=_:=SPACING_modifier_letters}');
    Expect(1, 767, '\p{Block=spacingmodifierletters}', "");
    Expect(0, 767, '\p{^Block=spacingmodifierletters}', "");
    Expect(0, 767, '\P{Block=spacingmodifierletters}', "");
    Expect(1, 767, '\P{^Block=spacingmodifierletters}', "");
    Expect(0, 768, '\p{Block=spacingmodifierletters}', "");
    Expect(1, 768, '\p{^Block=spacingmodifierletters}', "");
    Expect(1, 768, '\P{Block=spacingmodifierletters}', "");
    Expect(0, 768, '\P{^Block=spacingmodifierletters}', "");
    Expect(1, 767, '\p{Block=_spacing_modifier_LETTERS}', "");
    Expect(0, 767, '\p{^Block=_spacing_modifier_LETTERS}', "");
    Expect(0, 767, '\P{Block=_spacing_modifier_LETTERS}', "");
    Expect(1, 767, '\P{^Block=_spacing_modifier_LETTERS}', "");
    Expect(0, 768, '\p{Block=_spacing_modifier_LETTERS}', "");
    Expect(1, 768, '\p{^Block=_spacing_modifier_LETTERS}', "");
    Expect(1, 768, '\P{Block=_spacing_modifier_LETTERS}', "");
    Expect(0, 768, '\P{^Block=_spacing_modifier_LETTERS}', "");
    Error('\p{Blk=/a/--Modifier_letters}');
    Error('\P{Blk=/a/--Modifier_letters}');
    Expect(1, 767, '\p{Blk=modifierletters}', "");
    Expect(0, 767, '\p{^Blk=modifierletters}', "");
    Expect(0, 767, '\P{Blk=modifierletters}', "");
    Expect(1, 767, '\P{^Blk=modifierletters}', "");
    Expect(0, 768, '\p{Blk=modifierletters}', "");
    Expect(1, 768, '\p{^Blk=modifierletters}', "");
    Expect(1, 768, '\P{Blk=modifierletters}', "");
    Expect(0, 768, '\P{^Blk=modifierletters}', "");
    Expect(1, 767, '\p{Blk=Modifier_letters}', "");
    Expect(0, 767, '\p{^Blk=Modifier_letters}', "");
    Expect(0, 767, '\P{Blk=Modifier_letters}', "");
    Expect(1, 767, '\P{^Blk=Modifier_letters}', "");
    Expect(0, 768, '\p{Blk=Modifier_letters}', "");
    Expect(1, 768, '\p{^Blk=Modifier_letters}', "");
    Expect(1, 768, '\P{Blk=Modifier_letters}', "");
    Expect(0, 768, '\P{^Blk=Modifier_letters}', "");
    Error('\p{Is_Block=- SPACING_Modifier_LETTERS:=}');
    Error('\P{Is_Block=- SPACING_Modifier_LETTERS:=}');
    Expect(1, 767, '\p{Is_Block=spacingmodifierletters}', "");
    Expect(0, 767, '\p{^Is_Block=spacingmodifierletters}', "");
    Expect(0, 767, '\P{Is_Block=spacingmodifierletters}', "");
    Expect(1, 767, '\P{^Is_Block=spacingmodifierletters}', "");
    Expect(0, 768, '\p{Is_Block=spacingmodifierletters}', "");
    Expect(1, 768, '\p{^Is_Block=spacingmodifierletters}', "");
    Expect(1, 768, '\P{Is_Block=spacingmodifierletters}', "");
    Expect(0, 768, '\P{^Is_Block=spacingmodifierletters}', "");
    Expect(1, 767, '\p{Is_Block=Spacing_MODIFIER_letters}', "");
    Expect(0, 767, '\p{^Is_Block=Spacing_MODIFIER_letters}', "");
    Expect(0, 767, '\P{Is_Block=Spacing_MODIFIER_letters}', "");
    Expect(1, 767, '\P{^Is_Block=Spacing_MODIFIER_letters}', "");
    Expect(0, 768, '\p{Is_Block=Spacing_MODIFIER_letters}', "");
    Expect(1, 768, '\p{^Is_Block=Spacing_MODIFIER_letters}', "");
    Expect(1, 768, '\P{Is_Block=Spacing_MODIFIER_letters}', "");
    Expect(0, 768, '\P{^Is_Block=Spacing_MODIFIER_letters}', "");
    Error('\p{Is_Blk=-_modifier_Letters:=}');
    Error('\P{Is_Blk=-_modifier_Letters:=}');
    Expect(1, 767, '\p{Is_Blk: modifierletters}', "");
    Expect(0, 767, '\p{^Is_Blk: modifierletters}', "");
    Expect(0, 767, '\P{Is_Blk: modifierletters}', "");
    Expect(1, 767, '\P{^Is_Blk: modifierletters}', "");
    Expect(0, 768, '\p{Is_Blk: modifierletters}', "");
    Expect(1, 768, '\p{^Is_Blk: modifierletters}', "");
    Expect(1, 768, '\P{Is_Blk: modifierletters}', "");
    Expect(0, 768, '\P{^Is_Blk: modifierletters}', "");
    Expect(1, 767, '\p{Is_Blk=	-Modifier_Letters}', "");
    Expect(0, 767, '\p{^Is_Blk=	-Modifier_Letters}', "");
    Expect(0, 767, '\P{Is_Blk=	-Modifier_Letters}', "");
    Expect(1, 767, '\P{^Is_Blk=	-Modifier_Letters}', "");
    Expect(0, 768, '\p{Is_Blk=	-Modifier_Letters}', "");
    Expect(1, 768, '\p{^Is_Blk=	-Modifier_Letters}', "");
    Expect(1, 768, '\P{Is_Blk=	-Modifier_Letters}', "");
    Expect(0, 768, '\P{^Is_Blk=	-Modifier_Letters}', "");
    Error('\p{Block=/a/modifier_Tone_LETTERS}');
    Error('\P{Block=/a/modifier_Tone_LETTERS}');
    Expect(1, 42783, '\p{Block=modifiertoneletters}', "");
    Expect(0, 42783, '\p{^Block=modifiertoneletters}', "");
    Expect(0, 42783, '\P{Block=modifiertoneletters}', "");
    Expect(1, 42783, '\P{^Block=modifiertoneletters}', "");
    Expect(0, 42784, '\p{Block=modifiertoneletters}', "");
    Expect(1, 42784, '\p{^Block=modifiertoneletters}', "");
    Expect(1, 42784, '\P{Block=modifiertoneletters}', "");
    Expect(0, 42784, '\P{^Block=modifiertoneletters}', "");
    Expect(1, 42783, '\p{Block= modifier_TONE_LETTERS}', "");
    Expect(0, 42783, '\p{^Block= modifier_TONE_LETTERS}', "");
    Expect(0, 42783, '\P{Block= modifier_TONE_LETTERS}', "");
    Expect(1, 42783, '\P{^Block= modifier_TONE_LETTERS}', "");
    Expect(0, 42784, '\p{Block= modifier_TONE_LETTERS}', "");
    Expect(1, 42784, '\p{^Block= modifier_TONE_LETTERS}', "");
    Expect(1, 42784, '\P{Block= modifier_TONE_LETTERS}', "");
    Expect(0, 42784, '\P{^Block= modifier_TONE_LETTERS}', "");
    Error('\p{Blk=:= _Modifier_Tone_letters}');
    Error('\P{Blk=:= _Modifier_Tone_letters}');
    Expect(1, 42783, '\p{Blk=modifiertoneletters}', "");
    Expect(0, 42783, '\p{^Blk=modifiertoneletters}', "");
    Expect(0, 42783, '\P{Blk=modifiertoneletters}', "");
    Expect(1, 42783, '\P{^Blk=modifiertoneletters}', "");
    Expect(0, 42784, '\p{Blk=modifiertoneletters}', "");
    Expect(1, 42784, '\p{^Blk=modifiertoneletters}', "");
    Expect(1, 42784, '\P{Blk=modifiertoneletters}', "");
    Expect(0, 42784, '\P{^Blk=modifiertoneletters}', "");
    Expect(1, 42783, '\p{Blk=-	MODIFIER_Tone_Letters}', "");
    Expect(0, 42783, '\p{^Blk=-	MODIFIER_Tone_Letters}', "");
    Expect(0, 42783, '\P{Blk=-	MODIFIER_Tone_Letters}', "");
    Expect(1, 42783, '\P{^Blk=-	MODIFIER_Tone_Letters}', "");
    Expect(0, 42784, '\p{Blk=-	MODIFIER_Tone_Letters}', "");
    Expect(1, 42784, '\p{^Blk=-	MODIFIER_Tone_Letters}', "");
    Expect(1, 42784, '\P{Blk=-	MODIFIER_Tone_Letters}', "");
    Expect(0, 42784, '\P{^Blk=-	MODIFIER_Tone_Letters}', "");
    Error('\p{Is_Block=_	modifier_TONE_Letters:=}');
    Error('\P{Is_Block=_	modifier_TONE_Letters:=}');
    Expect(1, 42783, '\p{Is_Block=modifiertoneletters}', "");
    Expect(0, 42783, '\p{^Is_Block=modifiertoneletters}', "");
    Expect(0, 42783, '\P{Is_Block=modifiertoneletters}', "");
    Expect(1, 42783, '\P{^Is_Block=modifiertoneletters}', "");
    Expect(0, 42784, '\p{Is_Block=modifiertoneletters}', "");
    Expect(1, 42784, '\p{^Is_Block=modifiertoneletters}', "");
    Expect(1, 42784, '\P{Is_Block=modifiertoneletters}', "");
    Expect(0, 42784, '\P{^Is_Block=modifiertoneletters}', "");
    Expect(1, 42783, '\p{Is_Block= -Modifier_tone_Letters}', "");
    Expect(0, 42783, '\p{^Is_Block= -Modifier_tone_Letters}', "");
    Expect(0, 42783, '\P{Is_Block= -Modifier_tone_Letters}', "");
    Expect(1, 42783, '\P{^Is_Block= -Modifier_tone_Letters}', "");
    Expect(0, 42784, '\p{Is_Block= -Modifier_tone_Letters}', "");
    Expect(1, 42784, '\p{^Is_Block= -Modifier_tone_Letters}', "");
    Expect(1, 42784, '\P{Is_Block= -Modifier_tone_Letters}', "");
    Expect(0, 42784, '\P{^Is_Block= -Modifier_tone_Letters}', "");
    Error('\p{Is_Blk=:=	MODIFIER_TONE_Letters}');
    Error('\P{Is_Blk=:=	MODIFIER_TONE_Letters}');
    Expect(1, 42783, '\p{Is_Blk=modifiertoneletters}', "");
    Expect(0, 42783, '\p{^Is_Blk=modifiertoneletters}', "");
    Expect(0, 42783, '\P{Is_Blk=modifiertoneletters}', "");
    Expect(1, 42783, '\P{^Is_Blk=modifiertoneletters}', "");
    Expect(0, 42784, '\p{Is_Blk=modifiertoneletters}', "");
    Expect(1, 42784, '\p{^Is_Blk=modifiertoneletters}', "");
    Expect(1, 42784, '\P{Is_Blk=modifiertoneletters}', "");
    Expect(0, 42784, '\P{^Is_Blk=modifiertoneletters}', "");
    Expect(1, 42783, '\p{Is_Blk=_modifier_Tone_LETTERS}', "");
    Expect(0, 42783, '\p{^Is_Blk=_modifier_Tone_LETTERS}', "");
    Expect(0, 42783, '\P{Is_Blk=_modifier_Tone_LETTERS}', "");
    Expect(1, 42783, '\P{^Is_Blk=_modifier_Tone_LETTERS}', "");
    Expect(0, 42784, '\p{Is_Blk=_modifier_Tone_LETTERS}', "");
    Expect(1, 42784, '\p{^Is_Blk=_modifier_Tone_LETTERS}', "");
    Expect(1, 42784, '\P{Is_Blk=_modifier_Tone_LETTERS}', "");
    Expect(0, 42784, '\P{^Is_Blk=_modifier_Tone_LETTERS}', "");
    Error('\p{Block=:=MONGOLIAN}');
    Error('\P{Block=:=MONGOLIAN}');
    Expect(1, 6319, '\p{Block=mongolian}', "");
    Expect(0, 6319, '\p{^Block=mongolian}', "");
    Expect(0, 6319, '\P{Block=mongolian}', "");
    Expect(1, 6319, '\P{^Block=mongolian}', "");
    Expect(0, 6320, '\p{Block=mongolian}', "");
    Expect(1, 6320, '\p{^Block=mongolian}', "");
    Expect(1, 6320, '\P{Block=mongolian}', "");
    Expect(0, 6320, '\P{^Block=mongolian}', "");
    Expect(1, 6319, '\p{Block= 	Mongolian}', "");
    Expect(0, 6319, '\p{^Block= 	Mongolian}', "");
    Expect(0, 6319, '\P{Block= 	Mongolian}', "");
    Expect(1, 6319, '\P{^Block= 	Mongolian}', "");
    Expect(0, 6320, '\p{Block= 	Mongolian}', "");
    Expect(1, 6320, '\p{^Block= 	Mongolian}', "");
    Expect(1, 6320, '\P{Block= 	Mongolian}', "");
    Expect(0, 6320, '\P{^Block= 	Mongolian}', "");
    Error('\p{Blk: :=- mongolian}');
    Error('\P{Blk: :=- mongolian}');
    Expect(1, 6319, '\p{Blk=mongolian}', "");
    Expect(0, 6319, '\p{^Blk=mongolian}', "");
    Expect(0, 6319, '\P{Blk=mongolian}', "");
    Expect(1, 6319, '\P{^Blk=mongolian}', "");
    Expect(0, 6320, '\p{Blk=mongolian}', "");
    Expect(1, 6320, '\p{^Blk=mongolian}', "");
    Expect(1, 6320, '\P{Blk=mongolian}', "");
    Expect(0, 6320, '\P{^Blk=mongolian}', "");
    Expect(1, 6319, '\p{Blk=- mongolian}', "");
    Expect(0, 6319, '\p{^Blk=- mongolian}', "");
    Expect(0, 6319, '\P{Blk=- mongolian}', "");
    Expect(1, 6319, '\P{^Blk=- mongolian}', "");
    Expect(0, 6320, '\p{Blk=- mongolian}', "");
    Expect(1, 6320, '\p{^Blk=- mongolian}', "");
    Expect(1, 6320, '\P{Blk=- mongolian}', "");
    Expect(0, 6320, '\P{^Blk=- mongolian}', "");
    Error('\p{Is_Block= /a/Mongolian}');
    Error('\P{Is_Block= /a/Mongolian}');
    Expect(1, 6319, '\p{Is_Block=mongolian}', "");
    Expect(0, 6319, '\p{^Is_Block=mongolian}', "");
    Expect(0, 6319, '\P{Is_Block=mongolian}', "");
    Expect(1, 6319, '\P{^Is_Block=mongolian}', "");
    Expect(0, 6320, '\p{Is_Block=mongolian}', "");
    Expect(1, 6320, '\p{^Is_Block=mongolian}', "");
    Expect(1, 6320, '\P{Is_Block=mongolian}', "");
    Expect(0, 6320, '\P{^Is_Block=mongolian}', "");
    Expect(1, 6319, '\p{Is_Block=	-mongolian}', "");
    Expect(0, 6319, '\p{^Is_Block=	-mongolian}', "");
    Expect(0, 6319, '\P{Is_Block=	-mongolian}', "");
    Expect(1, 6319, '\P{^Is_Block=	-mongolian}', "");
    Expect(0, 6320, '\p{Is_Block=	-mongolian}', "");
    Expect(1, 6320, '\p{^Is_Block=	-mongolian}', "");
    Expect(1, 6320, '\P{Is_Block=	-mongolian}', "");
    Expect(0, 6320, '\P{^Is_Block=	-mongolian}', "");
    Error('\p{Is_Blk=	/a/Mongolian}');
    Error('\P{Is_Blk=	/a/Mongolian}');
    Expect(1, 6319, '\p{Is_Blk=mongolian}', "");
    Expect(0, 6319, '\p{^Is_Blk=mongolian}', "");
    Expect(0, 6319, '\P{Is_Blk=mongolian}', "");
    Expect(1, 6319, '\P{^Is_Blk=mongolian}', "");
    Expect(0, 6320, '\p{Is_Blk=mongolian}', "");
    Expect(1, 6320, '\p{^Is_Blk=mongolian}', "");
    Expect(1, 6320, '\P{Is_Blk=mongolian}', "");
    Expect(0, 6320, '\P{^Is_Blk=mongolian}', "");
    Expect(1, 6319, '\p{Is_Blk:_Mongolian}', "");
    Expect(0, 6319, '\p{^Is_Blk:_Mongolian}', "");
    Expect(0, 6319, '\P{Is_Blk:_Mongolian}', "");
    Expect(1, 6319, '\P{^Is_Blk:_Mongolian}', "");
    Expect(0, 6320, '\p{Is_Blk:_Mongolian}', "");
    Expect(1, 6320, '\p{^Is_Blk:_Mongolian}', "");
    Expect(1, 6320, '\P{Is_Blk:_Mongolian}', "");
    Expect(0, 6320, '\P{^Is_Blk:_Mongolian}', "");
    Error('\p{Block=_	mongolian_SUPPLEMENT/a/}');
    Error('\P{Block=_	mongolian_SUPPLEMENT/a/}');
    Expect(1, 71295, '\p{Block=mongoliansupplement}', "");
    Expect(0, 71295, '\p{^Block=mongoliansupplement}', "");
    Expect(0, 71295, '\P{Block=mongoliansupplement}', "");
    Expect(1, 71295, '\P{^Block=mongoliansupplement}', "");
    Expect(0, 71296, '\p{Block=mongoliansupplement}', "");
    Expect(1, 71296, '\p{^Block=mongoliansupplement}', "");
    Expect(1, 71296, '\P{Block=mongoliansupplement}', "");
    Expect(0, 71296, '\P{^Block=mongoliansupplement}', "");
    Expect(1, 71295, '\p{Block=MONGOLIAN_Supplement}', "");
    Expect(0, 71295, '\p{^Block=MONGOLIAN_Supplement}', "");
    Expect(0, 71295, '\P{Block=MONGOLIAN_Supplement}', "");
    Expect(1, 71295, '\P{^Block=MONGOLIAN_Supplement}', "");
    Expect(0, 71296, '\p{Block=MONGOLIAN_Supplement}', "");
    Expect(1, 71296, '\p{^Block=MONGOLIAN_Supplement}', "");
    Expect(1, 71296, '\P{Block=MONGOLIAN_Supplement}', "");
    Expect(0, 71296, '\P{^Block=MONGOLIAN_Supplement}', "");
    Error('\p{Blk=	Mongolian_SUP:=}');
    Error('\P{Blk=	Mongolian_SUP:=}');
    Expect(1, 71295, '\p{Blk=mongoliansup}', "");
    Expect(0, 71295, '\p{^Blk=mongoliansup}', "");
    Expect(0, 71295, '\P{Blk=mongoliansup}', "");
    Expect(1, 71295, '\P{^Blk=mongoliansup}', "");
    Expect(0, 71296, '\p{Blk=mongoliansup}', "");
    Expect(1, 71296, '\p{^Blk=mongoliansup}', "");
    Expect(1, 71296, '\P{Blk=mongoliansup}', "");
    Expect(0, 71296, '\P{^Blk=mongoliansup}', "");
    Expect(1, 71295, '\p{Blk= 	MONGOLIAN_Sup}', "");
    Expect(0, 71295, '\p{^Blk= 	MONGOLIAN_Sup}', "");
    Expect(0, 71295, '\P{Blk= 	MONGOLIAN_Sup}', "");
    Expect(1, 71295, '\P{^Blk= 	MONGOLIAN_Sup}', "");
    Expect(0, 71296, '\p{Blk= 	MONGOLIAN_Sup}', "");
    Expect(1, 71296, '\p{^Blk= 	MONGOLIAN_Sup}', "");
    Expect(1, 71296, '\P{Blk= 	MONGOLIAN_Sup}', "");
    Expect(0, 71296, '\P{^Blk= 	MONGOLIAN_Sup}', "");
    Error('\p{Is_Block=_/a/MONGOLIAN_SUPPLEMENT}');
    Error('\P{Is_Block=_/a/MONGOLIAN_SUPPLEMENT}');
    Expect(1, 71295, '\p{Is_Block=mongoliansupplement}', "");
    Expect(0, 71295, '\p{^Is_Block=mongoliansupplement}', "");
    Expect(0, 71295, '\P{Is_Block=mongoliansupplement}', "");
    Expect(1, 71295, '\P{^Is_Block=mongoliansupplement}', "");
    Expect(0, 71296, '\p{Is_Block=mongoliansupplement}', "");
    Expect(1, 71296, '\p{^Is_Block=mongoliansupplement}', "");
    Expect(1, 71296, '\P{Is_Block=mongoliansupplement}', "");
    Expect(0, 71296, '\P{^Is_Block=mongoliansupplement}', "");
    Expect(1, 71295, '\p{Is_Block=-_Mongolian_supplement}', "");
    Expect(0, 71295, '\p{^Is_Block=-_Mongolian_supplement}', "");
    Expect(0, 71295, '\P{Is_Block=-_Mongolian_supplement}', "");
    Expect(1, 71295, '\P{^Is_Block=-_Mongolian_supplement}', "");
    Expect(0, 71296, '\p{Is_Block=-_Mongolian_supplement}', "");
    Expect(1, 71296, '\p{^Is_Block=-_Mongolian_supplement}', "");
    Expect(1, 71296, '\P{Is_Block=-_Mongolian_supplement}', "");
    Expect(0, 71296, '\P{^Is_Block=-_Mongolian_supplement}', "");
    Error('\p{Is_Blk:	/a/	-Mongolian_sup}');
    Error('\P{Is_Blk:	/a/	-Mongolian_sup}');
    Expect(1, 71295, '\p{Is_Blk=mongoliansup}', "");
    Expect(0, 71295, '\p{^Is_Blk=mongoliansup}', "");
    Expect(0, 71295, '\P{Is_Blk=mongoliansup}', "");
    Expect(1, 71295, '\P{^Is_Blk=mongoliansup}', "");
    Expect(0, 71296, '\p{Is_Blk=mongoliansup}', "");
    Expect(1, 71296, '\p{^Is_Blk=mongoliansup}', "");
    Expect(1, 71296, '\P{Is_Blk=mongoliansup}', "");
    Expect(0, 71296, '\P{^Is_Blk=mongoliansup}', "");
    Expect(1, 71295, '\p{Is_Blk=_ Mongolian_sup}', "");
    Expect(0, 71295, '\p{^Is_Blk=_ Mongolian_sup}', "");
    Expect(0, 71295, '\P{Is_Blk=_ Mongolian_sup}', "");
    Expect(1, 71295, '\P{^Is_Blk=_ Mongolian_sup}', "");
    Expect(0, 71296, '\p{Is_Blk=_ Mongolian_sup}', "");
    Expect(1, 71296, '\p{^Is_Blk=_ Mongolian_sup}', "");
    Expect(1, 71296, '\P{Is_Blk=_ Mongolian_sup}', "");
    Expect(0, 71296, '\P{^Is_Blk=_ Mongolian_sup}', "");
    Error('\p{Block=	MRO/a/}');
    Error('\P{Block=	MRO/a/}');
    Expect(1, 92783, '\p{Block=mro}', "");
    Expect(0, 92783, '\p{^Block=mro}', "");
    Expect(0, 92783, '\P{Block=mro}', "");
    Expect(1, 92783, '\P{^Block=mro}', "");
    Expect(0, 92784, '\p{Block=mro}', "");
    Expect(1, 92784, '\p{^Block=mro}', "");
    Expect(1, 92784, '\P{Block=mro}', "");
    Expect(0, 92784, '\P{^Block=mro}', "");
    Expect(1, 92783, '\p{Block=	Mro}', "");
    Expect(0, 92783, '\p{^Block=	Mro}', "");
    Expect(0, 92783, '\P{Block=	Mro}', "");
    Expect(1, 92783, '\P{^Block=	Mro}', "");
    Expect(0, 92784, '\p{Block=	Mro}', "");
    Expect(1, 92784, '\p{^Block=	Mro}', "");
    Expect(1, 92784, '\P{Block=	Mro}', "");
    Expect(0, 92784, '\P{^Block=	Mro}', "");
    Error('\p{Blk:  -mro:=}');
    Error('\P{Blk:  -mro:=}');
    Expect(1, 92783, '\p{Blk=mro}', "");
    Expect(0, 92783, '\p{^Blk=mro}', "");
    Expect(0, 92783, '\P{Blk=mro}', "");
    Expect(1, 92783, '\P{^Blk=mro}', "");
    Expect(0, 92784, '\p{Blk=mro}', "");
    Expect(1, 92784, '\p{^Blk=mro}', "");
    Expect(1, 92784, '\P{Blk=mro}', "");
    Expect(0, 92784, '\P{^Blk=mro}', "");
    Expect(1, 92783, '\p{Blk= _MRO}', "");
    Expect(0, 92783, '\p{^Blk= _MRO}', "");
    Expect(0, 92783, '\P{Blk= _MRO}', "");
    Expect(1, 92783, '\P{^Blk= _MRO}', "");
    Expect(0, 92784, '\p{Blk= _MRO}', "");
    Expect(1, 92784, '\p{^Blk= _MRO}', "");
    Expect(1, 92784, '\P{Blk= _MRO}', "");
    Expect(0, 92784, '\P{^Blk= _MRO}', "");
    Error('\p{Is_Block=-:=MRO}');
    Error('\P{Is_Block=-:=MRO}');
    Expect(1, 92783, '\p{Is_Block=mro}', "");
    Expect(0, 92783, '\p{^Is_Block=mro}', "");
    Expect(0, 92783, '\P{Is_Block=mro}', "");
    Expect(1, 92783, '\P{^Is_Block=mro}', "");
    Expect(0, 92784, '\p{Is_Block=mro}', "");
    Expect(1, 92784, '\p{^Is_Block=mro}', "");
    Expect(1, 92784, '\P{Is_Block=mro}', "");
    Expect(0, 92784, '\P{^Is_Block=mro}', "");
    Expect(1, 92783, '\p{Is_Block=-_Mro}', "");
    Expect(0, 92783, '\p{^Is_Block=-_Mro}', "");
    Expect(0, 92783, '\P{Is_Block=-_Mro}', "");
    Expect(1, 92783, '\P{^Is_Block=-_Mro}', "");
    Expect(0, 92784, '\p{Is_Block=-_Mro}', "");
    Expect(1, 92784, '\p{^Is_Block=-_Mro}', "");
    Expect(1, 92784, '\P{Is_Block=-_Mro}', "");
    Expect(0, 92784, '\P{^Is_Block=-_Mro}', "");
    Error('\p{Is_Blk=	:=mro}');
    Error('\P{Is_Blk=	:=mro}');
    Expect(1, 92783, '\p{Is_Blk=mro}', "");
    Expect(0, 92783, '\p{^Is_Blk=mro}', "");
    Expect(0, 92783, '\P{Is_Blk=mro}', "");
    Expect(1, 92783, '\P{^Is_Blk=mro}', "");
    Expect(0, 92784, '\p{Is_Blk=mro}', "");
    Expect(1, 92784, '\p{^Is_Blk=mro}', "");
    Expect(1, 92784, '\P{Is_Blk=mro}', "");
    Expect(0, 92784, '\P{^Is_Blk=mro}', "");
    Expect(1, 92783, '\p{Is_Blk=  Mro}', "");
    Expect(0, 92783, '\p{^Is_Blk=  Mro}', "");
    Expect(0, 92783, '\P{Is_Blk=  Mro}', "");
    Expect(1, 92783, '\P{^Is_Blk=  Mro}', "");
    Expect(0, 92784, '\p{Is_Blk=  Mro}', "");
    Expect(1, 92784, '\p{^Is_Blk=  Mro}', "");
    Expect(1, 92784, '\P{Is_Blk=  Mro}', "");
    Expect(0, 92784, '\P{^Is_Blk=  Mro}', "");
    Error('\p{Block=__MULTANI:=}');
    Error('\P{Block=__MULTANI:=}');
    Expect(1, 70319, '\p{Block:	multani}', "");
    Expect(0, 70319, '\p{^Block:	multani}', "");
    Expect(0, 70319, '\P{Block:	multani}', "");
    Expect(1, 70319, '\P{^Block:	multani}', "");
    Expect(0, 70320, '\p{Block:	multani}', "");
    Expect(1, 70320, '\p{^Block:	multani}', "");
    Expect(1, 70320, '\P{Block:	multani}', "");
    Expect(0, 70320, '\P{^Block:	multani}', "");
    Expect(1, 70319, '\p{Block=	_Multani}', "");
    Expect(0, 70319, '\p{^Block=	_Multani}', "");
    Expect(0, 70319, '\P{Block=	_Multani}', "");
    Expect(1, 70319, '\P{^Block=	_Multani}', "");
    Expect(0, 70320, '\p{Block=	_Multani}', "");
    Expect(1, 70320, '\p{^Block=	_Multani}', "");
    Expect(1, 70320, '\P{Block=	_Multani}', "");
    Expect(0, 70320, '\P{^Block=	_Multani}', "");
    Error('\p{Blk=-/a/Multani}');
    Error('\P{Blk=-/a/Multani}');
    Expect(1, 70319, '\p{Blk=multani}', "");
    Expect(0, 70319, '\p{^Blk=multani}', "");
    Expect(0, 70319, '\P{Blk=multani}', "");
    Expect(1, 70319, '\P{^Blk=multani}', "");
    Expect(0, 70320, '\p{Blk=multani}', "");
    Expect(1, 70320, '\p{^Blk=multani}', "");
    Expect(1, 70320, '\P{Blk=multani}', "");
    Expect(0, 70320, '\P{^Blk=multani}', "");
    Expect(1, 70319, '\p{Blk=	multani}', "");
    Expect(0, 70319, '\p{^Blk=	multani}', "");
    Expect(0, 70319, '\P{Blk=	multani}', "");
    Expect(1, 70319, '\P{^Blk=	multani}', "");
    Expect(0, 70320, '\p{Blk=	multani}', "");
    Expect(1, 70320, '\p{^Blk=	multani}', "");
    Expect(1, 70320, '\P{Blk=	multani}', "");
    Expect(0, 70320, '\P{^Blk=	multani}', "");
    Error('\p{Is_Block=/a/MULTANI}');
    Error('\P{Is_Block=/a/MULTANI}');
    Expect(1, 70319, '\p{Is_Block:multani}', "");
    Expect(0, 70319, '\p{^Is_Block:multani}', "");
    Expect(0, 70319, '\P{Is_Block:multani}', "");
    Expect(1, 70319, '\P{^Is_Block:multani}', "");
    Expect(0, 70320, '\p{Is_Block:multani}', "");
    Expect(1, 70320, '\p{^Is_Block:multani}', "");
    Expect(1, 70320, '\P{Is_Block:multani}', "");
    Expect(0, 70320, '\P{^Is_Block:multani}', "");
    Expect(1, 70319, '\p{Is_Block=	_multani}', "");
    Expect(0, 70319, '\p{^Is_Block=	_multani}', "");
    Expect(0, 70319, '\P{Is_Block=	_multani}', "");
    Expect(1, 70319, '\P{^Is_Block=	_multani}', "");
    Expect(0, 70320, '\p{Is_Block=	_multani}', "");
    Expect(1, 70320, '\p{^Is_Block=	_multani}', "");
    Expect(1, 70320, '\P{Is_Block=	_multani}', "");
    Expect(0, 70320, '\P{^Is_Block=	_multani}', "");
    Error('\p{Is_Blk=:=-	multani}');
    Error('\P{Is_Blk=:=-	multani}');
    Expect(1, 70319, '\p{Is_Blk:   multani}', "");
    Expect(0, 70319, '\p{^Is_Blk:   multani}', "");
    Expect(0, 70319, '\P{Is_Blk:   multani}', "");
    Expect(1, 70319, '\P{^Is_Blk:   multani}', "");
    Expect(0, 70320, '\p{Is_Blk:   multani}', "");
    Expect(1, 70320, '\p{^Is_Blk:   multani}', "");
    Expect(1, 70320, '\P{Is_Blk:   multani}', "");
    Expect(0, 70320, '\P{^Is_Blk:   multani}', "");
    Expect(1, 70319, '\p{Is_Blk=--Multani}', "");
    Expect(0, 70319, '\p{^Is_Blk=--Multani}', "");
    Expect(0, 70319, '\P{Is_Blk=--Multani}', "");
    Expect(1, 70319, '\P{^Is_Blk=--Multani}', "");
    Expect(0, 70320, '\p{Is_Blk=--Multani}', "");
    Expect(1, 70320, '\p{^Is_Blk=--Multani}', "");
    Expect(1, 70320, '\P{Is_Blk=--Multani}', "");
    Expect(0, 70320, '\P{^Is_Blk=--Multani}', "");
    Error('\p{Block: :=_musical_SYMBOLS}');
    Error('\P{Block: :=_musical_SYMBOLS}');
    Expect(1, 119295, '\p{Block=musicalsymbols}', "");
    Expect(0, 119295, '\p{^Block=musicalsymbols}', "");
    Expect(0, 119295, '\P{Block=musicalsymbols}', "");
    Expect(1, 119295, '\P{^Block=musicalsymbols}', "");
    Expect(0, 119296, '\p{Block=musicalsymbols}', "");
    Expect(1, 119296, '\p{^Block=musicalsymbols}', "");
    Expect(1, 119296, '\P{Block=musicalsymbols}', "");
    Expect(0, 119296, '\P{^Block=musicalsymbols}', "");
    Expect(1, 119295, '\p{Block=	Musical_symbols}', "");
    Expect(0, 119295, '\p{^Block=	Musical_symbols}', "");
    Expect(0, 119295, '\P{Block=	Musical_symbols}', "");
    Expect(1, 119295, '\P{^Block=	Musical_symbols}', "");
    Expect(0, 119296, '\p{Block=	Musical_symbols}', "");
    Expect(1, 119296, '\p{^Block=	Musical_symbols}', "");
    Expect(1, 119296, '\P{Block=	Musical_symbols}', "");
    Expect(0, 119296, '\P{^Block=	Musical_symbols}', "");
    Error('\p{Blk=	Music:=}');
    Error('\P{Blk=	Music:=}');
    Expect(1, 119295, '\p{Blk=music}', "");
    Expect(0, 119295, '\p{^Blk=music}', "");
    Expect(0, 119295, '\P{Blk=music}', "");
    Expect(1, 119295, '\P{^Blk=music}', "");
    Expect(0, 119296, '\p{Blk=music}', "");
    Expect(1, 119296, '\p{^Blk=music}', "");
    Expect(1, 119296, '\P{Blk=music}', "");
    Expect(0, 119296, '\P{^Blk=music}', "");
    Expect(1, 119295, '\p{Blk= _Music}', "");
    Expect(0, 119295, '\p{^Blk= _Music}', "");
    Expect(0, 119295, '\P{Blk= _Music}', "");
    Expect(1, 119295, '\P{^Blk= _Music}', "");
    Expect(0, 119296, '\p{Blk= _Music}', "");
    Expect(1, 119296, '\p{^Blk= _Music}', "");
    Expect(1, 119296, '\P{Blk= _Music}', "");
    Expect(0, 119296, '\P{^Blk= _Music}', "");
    Error('\p{Is_Block=--Musical_Symbols/a/}');
    Error('\P{Is_Block=--Musical_Symbols/a/}');
    Expect(1, 119295, '\p{Is_Block=musicalsymbols}', "");
    Expect(0, 119295, '\p{^Is_Block=musicalsymbols}', "");
    Expect(0, 119295, '\P{Is_Block=musicalsymbols}', "");
    Expect(1, 119295, '\P{^Is_Block=musicalsymbols}', "");
    Expect(0, 119296, '\p{Is_Block=musicalsymbols}', "");
    Expect(1, 119296, '\p{^Is_Block=musicalsymbols}', "");
    Expect(1, 119296, '\P{Is_Block=musicalsymbols}', "");
    Expect(0, 119296, '\P{^Is_Block=musicalsymbols}', "");
    Expect(1, 119295, '\p{Is_Block= musical_Symbols}', "");
    Expect(0, 119295, '\p{^Is_Block= musical_Symbols}', "");
    Expect(0, 119295, '\P{Is_Block= musical_Symbols}', "");
    Expect(1, 119295, '\P{^Is_Block= musical_Symbols}', "");
    Expect(0, 119296, '\p{Is_Block= musical_Symbols}', "");
    Expect(1, 119296, '\p{^Is_Block= musical_Symbols}', "");
    Expect(1, 119296, '\P{Is_Block= musical_Symbols}', "");
    Expect(0, 119296, '\P{^Is_Block= musical_Symbols}', "");
    Error('\p{Is_Blk=-	Music:=}');
    Error('\P{Is_Blk=-	Music:=}');
    Expect(1, 119295, '\p{Is_Blk=music}', "");
    Expect(0, 119295, '\p{^Is_Blk=music}', "");
    Expect(0, 119295, '\P{Is_Blk=music}', "");
    Expect(1, 119295, '\P{^Is_Blk=music}', "");
    Expect(0, 119296, '\p{Is_Blk=music}', "");
    Expect(1, 119296, '\p{^Is_Blk=music}', "");
    Expect(1, 119296, '\P{Is_Blk=music}', "");
    Expect(0, 119296, '\P{^Is_Blk=music}', "");
    Expect(1, 119295, '\p{Is_Blk=_-MUSIC}', "");
    Expect(0, 119295, '\p{^Is_Blk=_-MUSIC}', "");
    Expect(0, 119295, '\P{Is_Blk=_-MUSIC}', "");
    Expect(1, 119295, '\P{^Is_Blk=_-MUSIC}', "");
    Expect(0, 119296, '\p{Is_Blk=_-MUSIC}', "");
    Expect(1, 119296, '\p{^Is_Blk=_-MUSIC}', "");
    Expect(1, 119296, '\P{Is_Blk=_-MUSIC}', "");
    Expect(0, 119296, '\P{^Is_Blk=_-MUSIC}', "");
    Error('\p{Block=-Myanmar/a/}');
    Error('\P{Block=-Myanmar/a/}');
    Expect(1, 4255, '\p{Block=myanmar}', "");
    Expect(0, 4255, '\p{^Block=myanmar}', "");
    Expect(0, 4255, '\P{Block=myanmar}', "");
    Expect(1, 4255, '\P{^Block=myanmar}', "");
    Expect(0, 4256, '\p{Block=myanmar}', "");
    Expect(1, 4256, '\p{^Block=myanmar}', "");
    Expect(1, 4256, '\P{Block=myanmar}', "");
    Expect(0, 4256, '\P{^Block=myanmar}', "");
    Expect(1, 4255, '\p{Block:    _Myanmar}', "");
    Expect(0, 4255, '\p{^Block:    _Myanmar}', "");
    Expect(0, 4255, '\P{Block:    _Myanmar}', "");
    Expect(1, 4255, '\P{^Block:    _Myanmar}', "");
    Expect(0, 4256, '\p{Block:    _Myanmar}', "");
    Expect(1, 4256, '\p{^Block:    _Myanmar}', "");
    Expect(1, 4256, '\P{Block:    _Myanmar}', "");
    Expect(0, 4256, '\P{^Block:    _Myanmar}', "");
    Error('\p{Blk=/a/__MYANMAR}');
    Error('\P{Blk=/a/__MYANMAR}');
    Expect(1, 4255, '\p{Blk:	myanmar}', "");
    Expect(0, 4255, '\p{^Blk:	myanmar}', "");
    Expect(0, 4255, '\P{Blk:	myanmar}', "");
    Expect(1, 4255, '\P{^Blk:	myanmar}', "");
    Expect(0, 4256, '\p{Blk:	myanmar}', "");
    Expect(1, 4256, '\p{^Blk:	myanmar}', "");
    Expect(1, 4256, '\P{Blk:	myanmar}', "");
    Expect(0, 4256, '\P{^Blk:	myanmar}', "");
    Expect(1, 4255, '\p{Blk=-MYANMAR}', "");
    Expect(0, 4255, '\p{^Blk=-MYANMAR}', "");
    Expect(0, 4255, '\P{Blk=-MYANMAR}', "");
    Expect(1, 4255, '\P{^Blk=-MYANMAR}', "");
    Expect(0, 4256, '\p{Blk=-MYANMAR}', "");
    Expect(1, 4256, '\p{^Blk=-MYANMAR}', "");
    Expect(1, 4256, '\P{Blk=-MYANMAR}', "");
    Expect(0, 4256, '\P{^Blk=-MYANMAR}', "");
    Error('\p{Is_Block=:=_-Myanmar}');
    Error('\P{Is_Block=:=_-Myanmar}');
    Expect(1, 4255, '\p{Is_Block:   myanmar}', "");
    Expect(0, 4255, '\p{^Is_Block:   myanmar}', "");
    Expect(0, 4255, '\P{Is_Block:   myanmar}', "");
    Expect(1, 4255, '\P{^Is_Block:   myanmar}', "");
    Expect(0, 4256, '\p{Is_Block:   myanmar}', "");
    Expect(1, 4256, '\p{^Is_Block:   myanmar}', "");
    Expect(1, 4256, '\P{Is_Block:   myanmar}', "");
    Expect(0, 4256, '\P{^Is_Block:   myanmar}', "");
    Expect(1, 4255, '\p{Is_Block=	 Myanmar}', "");
    Expect(0, 4255, '\p{^Is_Block=	 Myanmar}', "");
    Expect(0, 4255, '\P{Is_Block=	 Myanmar}', "");
    Expect(1, 4255, '\P{^Is_Block=	 Myanmar}', "");
    Expect(0, 4256, '\p{Is_Block=	 Myanmar}', "");
    Expect(1, 4256, '\p{^Is_Block=	 Myanmar}', "");
    Expect(1, 4256, '\P{Is_Block=	 Myanmar}', "");
    Expect(0, 4256, '\P{^Is_Block=	 Myanmar}', "");
    Error('\p{Is_Blk: /a/  Myanmar}');
    Error('\P{Is_Blk: /a/  Myanmar}');
    Expect(1, 4255, '\p{Is_Blk=myanmar}', "");
    Expect(0, 4255, '\p{^Is_Blk=myanmar}', "");
    Expect(0, 4255, '\P{Is_Blk=myanmar}', "");
    Expect(1, 4255, '\P{^Is_Blk=myanmar}', "");
    Expect(0, 4256, '\p{Is_Blk=myanmar}', "");
    Expect(1, 4256, '\p{^Is_Blk=myanmar}', "");
    Expect(1, 4256, '\P{Is_Blk=myanmar}', "");
    Expect(0, 4256, '\P{^Is_Blk=myanmar}', "");
    Expect(1, 4255, '\p{Is_Blk= -MYANMAR}', "");
    Expect(0, 4255, '\p{^Is_Blk= -MYANMAR}', "");
    Expect(0, 4255, '\P{Is_Blk= -MYANMAR}', "");
    Expect(1, 4255, '\P{^Is_Blk= -MYANMAR}', "");
    Expect(0, 4256, '\p{Is_Blk= -MYANMAR}', "");
    Expect(1, 4256, '\p{^Is_Blk= -MYANMAR}', "");
    Expect(1, 4256, '\P{Is_Blk= -MYANMAR}', "");
    Expect(0, 4256, '\P{^Is_Blk= -MYANMAR}', "");
    Error('\p{Block=/a/-Myanmar_extended_A}');
    Error('\P{Block=/a/-Myanmar_extended_A}');
    Expect(1, 43647, '\p{Block=myanmarextendeda}', "");
    Expect(0, 43647, '\p{^Block=myanmarextendeda}', "");
    Expect(0, 43647, '\P{Block=myanmarextendeda}', "");
    Expect(1, 43647, '\P{^Block=myanmarextendeda}', "");
    Expect(0, 43648, '\p{Block=myanmarextendeda}', "");
    Expect(1, 43648, '\p{^Block=myanmarextendeda}', "");
    Expect(1, 43648, '\P{Block=myanmarextendeda}', "");
    Expect(0, 43648, '\P{^Block=myanmarextendeda}', "");
    Expect(1, 43647, '\p{Block:		Myanmar_extended_A}', "");
    Expect(0, 43647, '\p{^Block:		Myanmar_extended_A}', "");
    Expect(0, 43647, '\P{Block:		Myanmar_extended_A}', "");
    Expect(1, 43647, '\P{^Block:		Myanmar_extended_A}', "");
    Expect(0, 43648, '\p{Block:		Myanmar_extended_A}', "");
    Expect(1, 43648, '\p{^Block:		Myanmar_extended_A}', "");
    Expect(1, 43648, '\P{Block:		Myanmar_extended_A}', "");
    Expect(0, 43648, '\P{^Block:		Myanmar_extended_A}', "");
    Error('\p{Blk= :=MYANMAR_Ext_A}');
    Error('\P{Blk= :=MYANMAR_Ext_A}');
    Expect(1, 43647, '\p{Blk=myanmarexta}', "");
    Expect(0, 43647, '\p{^Blk=myanmarexta}', "");
    Expect(0, 43647, '\P{Blk=myanmarexta}', "");
    Expect(1, 43647, '\P{^Blk=myanmarexta}', "");
    Expect(0, 43648, '\p{Blk=myanmarexta}', "");
    Expect(1, 43648, '\p{^Blk=myanmarexta}', "");
    Expect(1, 43648, '\P{Blk=myanmarexta}', "");
    Expect(0, 43648, '\P{^Blk=myanmarexta}', "");
    Expect(1, 43647, '\p{Blk= _MYANMAR_ext_A}', "");
    Expect(0, 43647, '\p{^Blk= _MYANMAR_ext_A}', "");
    Expect(0, 43647, '\P{Blk= _MYANMAR_ext_A}', "");
    Expect(1, 43647, '\P{^Blk= _MYANMAR_ext_A}', "");
    Expect(0, 43648, '\p{Blk= _MYANMAR_ext_A}', "");
    Expect(1, 43648, '\p{^Blk= _MYANMAR_ext_A}', "");
    Expect(1, 43648, '\P{Blk= _MYANMAR_ext_A}', "");
    Expect(0, 43648, '\P{^Blk= _MYANMAR_ext_A}', "");
    Error('\p{Is_Block=	:=Myanmar_Extended_A}');
    Error('\P{Is_Block=	:=Myanmar_Extended_A}');
    Expect(1, 43647, '\p{Is_Block=myanmarextendeda}', "");
    Expect(0, 43647, '\p{^Is_Block=myanmarextendeda}', "");
    Expect(0, 43647, '\P{Is_Block=myanmarextendeda}', "");
    Expect(1, 43647, '\P{^Is_Block=myanmarextendeda}', "");
    Expect(0, 43648, '\p{Is_Block=myanmarextendeda}', "");
    Expect(1, 43648, '\p{^Is_Block=myanmarextendeda}', "");
    Expect(1, 43648, '\P{Is_Block=myanmarextendeda}', "");
    Expect(0, 43648, '\P{^Is_Block=myanmarextendeda}', "");
    Expect(1, 43647, '\p{Is_Block= 	Myanmar_EXTENDED_A}', "");
    Expect(0, 43647, '\p{^Is_Block= 	Myanmar_EXTENDED_A}', "");
    Expect(0, 43647, '\P{Is_Block= 	Myanmar_EXTENDED_A}', "");
    Expect(1, 43647, '\P{^Is_Block= 	Myanmar_EXTENDED_A}', "");
    Expect(0, 43648, '\p{Is_Block= 	Myanmar_EXTENDED_A}', "");
    Expect(1, 43648, '\p{^Is_Block= 	Myanmar_EXTENDED_A}', "");
    Expect(1, 43648, '\P{Is_Block= 	Myanmar_EXTENDED_A}', "");
    Expect(0, 43648, '\P{^Is_Block= 	Myanmar_EXTENDED_A}', "");
    Error('\p{Is_Blk:  /a/MYANMAR_ext_A}');
    Error('\P{Is_Blk:  /a/MYANMAR_ext_A}');
    Expect(1, 43647, '\p{Is_Blk=myanmarexta}', "");
    Expect(0, 43647, '\p{^Is_Blk=myanmarexta}', "");
    Expect(0, 43647, '\P{Is_Blk=myanmarexta}', "");
    Expect(1, 43647, '\P{^Is_Blk=myanmarexta}', "");
    Expect(0, 43648, '\p{Is_Blk=myanmarexta}', "");
    Expect(1, 43648, '\p{^Is_Blk=myanmarexta}', "");
    Expect(1, 43648, '\P{Is_Blk=myanmarexta}', "");
    Expect(0, 43648, '\P{^Is_Blk=myanmarexta}', "");
    Expect(1, 43647, '\p{Is_Blk=_Myanmar_EXT_a}', "");
    Expect(0, 43647, '\p{^Is_Blk=_Myanmar_EXT_a}', "");
    Expect(0, 43647, '\P{Is_Blk=_Myanmar_EXT_a}', "");
    Expect(1, 43647, '\P{^Is_Blk=_Myanmar_EXT_a}', "");
    Expect(0, 43648, '\p{Is_Blk=_Myanmar_EXT_a}', "");
    Expect(1, 43648, '\p{^Is_Blk=_Myanmar_EXT_a}', "");
    Expect(1, 43648, '\P{Is_Blk=_Myanmar_EXT_a}', "");
    Expect(0, 43648, '\P{^Is_Blk=_Myanmar_EXT_a}', "");
    Error('\p{Block= _Myanmar_Extended_b/a/}');
    Error('\P{Block= _Myanmar_Extended_b/a/}');
    Expect(1, 43519, '\p{Block=myanmarextendedb}', "");
    Expect(0, 43519, '\p{^Block=myanmarextendedb}', "");
    Expect(0, 43519, '\P{Block=myanmarextendedb}', "");
    Expect(1, 43519, '\P{^Block=myanmarextendedb}', "");
    Expect(0, 43520, '\p{Block=myanmarextendedb}', "");
    Expect(1, 43520, '\p{^Block=myanmarextendedb}', "");
    Expect(1, 43520, '\P{Block=myanmarextendedb}', "");
    Expect(0, 43520, '\P{^Block=myanmarextendedb}', "");
    Expect(1, 43519, '\p{Block:--MYANMAR_extended_B}', "");
    Expect(0, 43519, '\p{^Block:--MYANMAR_extended_B}', "");
    Expect(0, 43519, '\P{Block:--MYANMAR_extended_B}', "");
    Expect(1, 43519, '\P{^Block:--MYANMAR_extended_B}', "");
    Expect(0, 43520, '\p{Block:--MYANMAR_extended_B}', "");
    Expect(1, 43520, '\p{^Block:--MYANMAR_extended_B}', "");
    Expect(1, 43520, '\P{Block:--MYANMAR_extended_B}', "");
    Expect(0, 43520, '\P{^Block:--MYANMAR_extended_B}', "");
    Error('\p{Blk=-:=Myanmar_Ext_B}');
    Error('\P{Blk=-:=Myanmar_Ext_B}');
    Expect(1, 43519, '\p{Blk=myanmarextb}', "");
    Expect(0, 43519, '\p{^Blk=myanmarextb}', "");
    Expect(0, 43519, '\P{Blk=myanmarextb}', "");
    Expect(1, 43519, '\P{^Blk=myanmarextb}', "");
    Expect(0, 43520, '\p{Blk=myanmarextb}', "");
    Expect(1, 43520, '\p{^Blk=myanmarextb}', "");
    Expect(1, 43520, '\P{Blk=myanmarextb}', "");
    Expect(0, 43520, '\P{^Blk=myanmarextb}', "");
    Expect(1, 43519, '\p{Blk=		Myanmar_EXT_B}', "");
    Expect(0, 43519, '\p{^Blk=		Myanmar_EXT_B}', "");
    Expect(0, 43519, '\P{Blk=		Myanmar_EXT_B}', "");
    Expect(1, 43519, '\P{^Blk=		Myanmar_EXT_B}', "");
    Expect(0, 43520, '\p{Blk=		Myanmar_EXT_B}', "");
    Expect(1, 43520, '\p{^Blk=		Myanmar_EXT_B}', "");
    Expect(1, 43520, '\P{Blk=		Myanmar_EXT_B}', "");
    Expect(0, 43520, '\P{^Blk=		Myanmar_EXT_B}', "");
    Error('\p{Is_Block::=	myanmar_EXTENDED_B}');
    Error('\P{Is_Block::=	myanmar_EXTENDED_B}');
    Expect(1, 43519, '\p{Is_Block=myanmarextendedb}', "");
    Expect(0, 43519, '\p{^Is_Block=myanmarextendedb}', "");
    Expect(0, 43519, '\P{Is_Block=myanmarextendedb}', "");
    Expect(1, 43519, '\P{^Is_Block=myanmarextendedb}', "");
    Expect(0, 43520, '\p{Is_Block=myanmarextendedb}', "");
    Expect(1, 43520, '\p{^Is_Block=myanmarextendedb}', "");
    Expect(1, 43520, '\P{Is_Block=myanmarextendedb}', "");
    Expect(0, 43520, '\P{^Is_Block=myanmarextendedb}', "");
    Expect(1, 43519, '\p{Is_Block=_ Myanmar_Extended_B}', "");
    Expect(0, 43519, '\p{^Is_Block=_ Myanmar_Extended_B}', "");
    Expect(0, 43519, '\P{Is_Block=_ Myanmar_Extended_B}', "");
    Expect(1, 43519, '\P{^Is_Block=_ Myanmar_Extended_B}', "");
    Expect(0, 43520, '\p{Is_Block=_ Myanmar_Extended_B}', "");
    Expect(1, 43520, '\p{^Is_Block=_ Myanmar_Extended_B}', "");
    Expect(1, 43520, '\P{Is_Block=_ Myanmar_Extended_B}', "");
    Expect(0, 43520, '\P{^Is_Block=_ Myanmar_Extended_B}', "");
    Error('\p{Is_Blk=	-myanmar_Ext_B/a/}');
    Error('\P{Is_Blk=	-myanmar_Ext_B/a/}');
    Expect(1, 43519, '\p{Is_Blk=myanmarextb}', "");
    Expect(0, 43519, '\p{^Is_Blk=myanmarextb}', "");
    Expect(0, 43519, '\P{Is_Blk=myanmarextb}', "");
    Expect(1, 43519, '\P{^Is_Blk=myanmarextb}', "");
    Expect(0, 43520, '\p{Is_Blk=myanmarextb}', "");
    Expect(1, 43520, '\p{^Is_Blk=myanmarextb}', "");
    Expect(1, 43520, '\P{Is_Blk=myanmarextb}', "");
    Expect(0, 43520, '\P{^Is_Blk=myanmarextb}', "");
    Expect(1, 43519, '\p{Is_Blk:	-Myanmar_Ext_B}', "");
    Expect(0, 43519, '\p{^Is_Blk:	-Myanmar_Ext_B}', "");
    Expect(0, 43519, '\P{Is_Blk:	-Myanmar_Ext_B}', "");
    Expect(1, 43519, '\P{^Is_Blk:	-Myanmar_Ext_B}', "");
    Expect(0, 43520, '\p{Is_Blk:	-Myanmar_Ext_B}', "");
    Expect(1, 43520, '\p{^Is_Blk:	-Myanmar_Ext_B}', "");
    Expect(1, 43520, '\P{Is_Blk:	-Myanmar_Ext_B}', "");
    Expect(0, 43520, '\P{^Is_Blk:	-Myanmar_Ext_B}', "");
    Error('\p{Block=:=nabataean}');
    Error('\P{Block=:=nabataean}');
    Expect(1, 67759, '\p{Block=nabataean}', "");
    Expect(0, 67759, '\p{^Block=nabataean}', "");
    Expect(0, 67759, '\P{Block=nabataean}', "");
    Expect(1, 67759, '\P{^Block=nabataean}', "");
    Expect(0, 67760, '\p{Block=nabataean}', "");
    Expect(1, 67760, '\p{^Block=nabataean}', "");
    Expect(1, 67760, '\P{Block=nabataean}', "");
    Expect(0, 67760, '\P{^Block=nabataean}', "");
    Expect(1, 67759, '\p{Block= -Nabataean}', "");
    Expect(0, 67759, '\p{^Block= -Nabataean}', "");
    Expect(0, 67759, '\P{Block= -Nabataean}', "");
    Expect(1, 67759, '\P{^Block= -Nabataean}', "");
    Expect(0, 67760, '\p{Block= -Nabataean}', "");
    Expect(1, 67760, '\p{^Block= -Nabataean}', "");
    Expect(1, 67760, '\P{Block= -Nabataean}', "");
    Expect(0, 67760, '\P{^Block= -Nabataean}', "");
    Error('\p{Blk:	 /a/Nabataean}');
    Error('\P{Blk:	 /a/Nabataean}');
    Expect(1, 67759, '\p{Blk=nabataean}', "");
    Expect(0, 67759, '\p{^Blk=nabataean}', "");
    Expect(0, 67759, '\P{Blk=nabataean}', "");
    Expect(1, 67759, '\P{^Blk=nabataean}', "");
    Expect(0, 67760, '\p{Blk=nabataean}', "");
    Expect(1, 67760, '\p{^Blk=nabataean}', "");
    Expect(1, 67760, '\P{Blk=nabataean}', "");
    Expect(0, 67760, '\P{^Blk=nabataean}', "");
    Error('\p{Is_Block=/a/	nabataean}');
    Error('\P{Is_Block=/a/	nabataean}');
    Expect(1, 67759, '\p{Is_Block:	nabataean}', "");
    Expect(0, 67759, '\p{^Is_Block:	nabataean}', "");
    Expect(0, 67759, '\P{Is_Block:	nabataean}', "");
    Expect(1, 67759, '\P{^Is_Block:	nabataean}', "");
    Expect(0, 67760, '\p{Is_Block:	nabataean}', "");
    Expect(1, 67760, '\p{^Is_Block:	nabataean}', "");
    Expect(1, 67760, '\P{Is_Block:	nabataean}', "");
    Expect(0, 67760, '\P{^Is_Block:	nabataean}', "");
    Expect(1, 67759, '\p{Is_Block=_nabataean}', "");
    Expect(0, 67759, '\p{^Is_Block=_nabataean}', "");
    Expect(0, 67759, '\P{Is_Block=_nabataean}', "");
    Expect(1, 67759, '\P{^Is_Block=_nabataean}', "");
    Expect(0, 67760, '\p{Is_Block=_nabataean}', "");
    Expect(1, 67760, '\p{^Is_Block=_nabataean}', "");
    Expect(1, 67760, '\P{Is_Block=_nabataean}', "");
    Expect(0, 67760, '\P{^Is_Block=_nabataean}', "");
    Error('\p{Is_Blk=/a/-Nabataean}');
    Error('\P{Is_Blk=/a/-Nabataean}');
    Expect(1, 67759, '\p{Is_Blk=nabataean}', "");
    Expect(0, 67759, '\p{^Is_Blk=nabataean}', "");
    Expect(0, 67759, '\P{Is_Blk=nabataean}', "");
    Expect(1, 67759, '\P{^Is_Blk=nabataean}', "");
    Expect(0, 67760, '\p{Is_Blk=nabataean}', "");
    Expect(1, 67760, '\p{^Is_Blk=nabataean}', "");
    Expect(1, 67760, '\P{Is_Blk=nabataean}', "");
    Expect(0, 67760, '\P{^Is_Blk=nabataean}', "");
    Expect(1, 67759, '\p{Is_Blk= _Nabataean}', "");
    Expect(0, 67759, '\p{^Is_Blk= _Nabataean}', "");
    Expect(0, 67759, '\P{Is_Blk= _Nabataean}', "");
    Expect(1, 67759, '\P{^Is_Blk= _Nabataean}', "");
    Expect(0, 67760, '\p{Is_Blk= _Nabataean}', "");
    Expect(1, 67760, '\p{^Is_Blk= _Nabataean}', "");
    Expect(1, 67760, '\P{Is_Blk= _Nabataean}', "");
    Expect(0, 67760, '\P{^Is_Blk= _Nabataean}', "");
    Error('\p{Block:	-No_BLOCK/a/}');
    Error('\P{Block:	-No_BLOCK/a/}');
    Expect(1, 918000, '\p{Block=noblock}', "");
    Expect(0, 918000, '\p{^Block=noblock}', "");
    Expect(0, 918000, '\P{Block=noblock}', "");
    Expect(1, 918000, '\P{^Block=noblock}', "");
    Expect(0, 983040, '\p{Block=noblock}', "");
    Expect(1, 983040, '\p{^Block=noblock}', "");
    Expect(1, 983040, '\P{Block=noblock}', "");
    Expect(0, 983040, '\P{^Block=noblock}', "");
    Expect(1, 918000, '\p{Block=	No_Block}', "");
    Expect(0, 918000, '\p{^Block=	No_Block}', "");
    Expect(0, 918000, '\P{Block=	No_Block}', "");
    Expect(1, 918000, '\P{^Block=	No_Block}', "");
    Expect(0, 983040, '\p{Block=	No_Block}', "");
    Expect(1, 983040, '\p{^Block=	No_Block}', "");
    Expect(1, 983040, '\P{Block=	No_Block}', "");
    Expect(0, 983040, '\P{^Block=	No_Block}', "");
    Error('\p{Blk= :=NB}');
    Error('\P{Blk= :=NB}');
    Expect(1, 918000, '\p{Blk=nb}', "");
    Expect(0, 918000, '\p{^Blk=nb}', "");
    Expect(0, 918000, '\P{Blk=nb}', "");
    Expect(1, 918000, '\P{^Blk=nb}', "");
    Expect(0, 983040, '\p{Blk=nb}', "");
    Expect(1, 983040, '\p{^Blk=nb}', "");
    Expect(1, 983040, '\P{Blk=nb}', "");
    Expect(0, 983040, '\P{^Blk=nb}', "");
    Expect(1, 918000, '\p{Blk=	_nb}', "");
    Expect(0, 918000, '\p{^Blk=	_nb}', "");
    Expect(0, 918000, '\P{Blk=	_nb}', "");
    Expect(1, 918000, '\P{^Blk=	_nb}', "");
    Expect(0, 983040, '\p{Blk=	_nb}', "");
    Expect(1, 983040, '\p{^Blk=	_nb}', "");
    Expect(1, 983040, '\P{Blk=	_nb}', "");
    Expect(0, 983040, '\P{^Blk=	_nb}', "");
    Error('\p{Is_Block=--No_block:=}');
    Error('\P{Is_Block=--No_block:=}');
    Expect(1, 918000, '\p{Is_Block=noblock}', "");
    Expect(0, 918000, '\p{^Is_Block=noblock}', "");
    Expect(0, 918000, '\P{Is_Block=noblock}', "");
    Expect(1, 918000, '\P{^Is_Block=noblock}', "");
    Expect(0, 983040, '\p{Is_Block=noblock}', "");
    Expect(1, 983040, '\p{^Is_Block=noblock}', "");
    Expect(1, 983040, '\P{Is_Block=noblock}', "");
    Expect(0, 983040, '\P{^Is_Block=noblock}', "");
    Expect(1, 918000, '\p{Is_Block=  no_Block}', "");
    Expect(0, 918000, '\p{^Is_Block=  no_Block}', "");
    Expect(0, 918000, '\P{Is_Block=  no_Block}', "");
    Expect(1, 918000, '\P{^Is_Block=  no_Block}', "");
    Expect(0, 983040, '\p{Is_Block=  no_Block}', "");
    Expect(1, 983040, '\p{^Is_Block=  no_Block}', "");
    Expect(1, 983040, '\P{Is_Block=  no_Block}', "");
    Expect(0, 983040, '\P{^Is_Block=  no_Block}', "");
    Error('\p{Is_Blk=_:=nb}');
    Error('\P{Is_Blk=_:=nb}');
    Expect(1, 918000, '\p{Is_Blk=nb}', "");
    Expect(0, 918000, '\p{^Is_Blk=nb}', "");
    Expect(0, 918000, '\P{Is_Blk=nb}', "");
    Expect(1, 918000, '\P{^Is_Blk=nb}', "");
    Expect(0, 983040, '\p{Is_Blk=nb}', "");
    Expect(1, 983040, '\p{^Is_Blk=nb}', "");
    Expect(1, 983040, '\P{Is_Blk=nb}', "");
    Expect(0, 983040, '\P{^Is_Blk=nb}', "");
    Expect(1, 918000, '\p{Is_Blk= -NB}', "");
    Expect(0, 918000, '\p{^Is_Blk= -NB}', "");
    Expect(0, 918000, '\P{Is_Blk= -NB}', "");
    Expect(1, 918000, '\P{^Is_Blk= -NB}', "");
    Expect(0, 983040, '\p{Is_Blk= -NB}', "");
    Expect(1, 983040, '\p{^Is_Blk= -NB}', "");
    Expect(1, 983040, '\P{Is_Blk= -NB}', "");
    Expect(0, 983040, '\P{^Is_Blk= -NB}', "");
    Error('\p{Block=-:=New_Tai_LUE}');
    Error('\P{Block=-:=New_Tai_LUE}');
    Expect(1, 6623, '\p{Block=newtailue}', "");
    Expect(0, 6623, '\p{^Block=newtailue}', "");
    Expect(0, 6623, '\P{Block=newtailue}', "");
    Expect(1, 6623, '\P{^Block=newtailue}', "");
    Expect(0, 6624, '\p{Block=newtailue}', "");
    Expect(1, 6624, '\p{^Block=newtailue}', "");
    Expect(1, 6624, '\P{Block=newtailue}', "");
    Expect(0, 6624, '\P{^Block=newtailue}', "");
    Expect(1, 6623, '\p{Block:_NEW_Tai_Lue}', "");
    Expect(0, 6623, '\p{^Block:_NEW_Tai_Lue}', "");
    Expect(0, 6623, '\P{Block:_NEW_Tai_Lue}', "");
    Expect(1, 6623, '\P{^Block:_NEW_Tai_Lue}', "");
    Expect(0, 6624, '\p{Block:_NEW_Tai_Lue}', "");
    Expect(1, 6624, '\p{^Block:_NEW_Tai_Lue}', "");
    Expect(1, 6624, '\P{Block:_NEW_Tai_Lue}', "");
    Expect(0, 6624, '\P{^Block:_NEW_Tai_Lue}', "");
    Error('\p{Blk=-New_Tai_lue:=}');
    Error('\P{Blk=-New_Tai_lue:=}');
    Expect(1, 6623, '\p{Blk=newtailue}', "");
    Expect(0, 6623, '\p{^Blk=newtailue}', "");
    Expect(0, 6623, '\P{Blk=newtailue}', "");
    Expect(1, 6623, '\P{^Blk=newtailue}', "");
    Expect(0, 6624, '\p{Blk=newtailue}', "");
    Expect(1, 6624, '\p{^Blk=newtailue}', "");
    Expect(1, 6624, '\P{Blk=newtailue}', "");
    Expect(0, 6624, '\P{^Blk=newtailue}', "");
    Expect(1, 6623, '\p{Blk:   -New_Tai_Lue}', "");
    Expect(0, 6623, '\p{^Blk:   -New_Tai_Lue}', "");
    Expect(0, 6623, '\P{Blk:   -New_Tai_Lue}', "");
    Expect(1, 6623, '\P{^Blk:   -New_Tai_Lue}', "");
    Expect(0, 6624, '\p{Blk:   -New_Tai_Lue}', "");
    Expect(1, 6624, '\p{^Blk:   -New_Tai_Lue}', "");
    Expect(1, 6624, '\P{Blk:   -New_Tai_Lue}', "");
    Expect(0, 6624, '\P{^Blk:   -New_Tai_Lue}', "");
    Error('\p{Is_Block=:= 	New_Tai_LUE}');
    Error('\P{Is_Block=:= 	New_Tai_LUE}');
    Expect(1, 6623, '\p{Is_Block=newtailue}', "");
    Expect(0, 6623, '\p{^Is_Block=newtailue}', "");
    Expect(0, 6623, '\P{Is_Block=newtailue}', "");
    Expect(1, 6623, '\P{^Is_Block=newtailue}', "");
    Expect(0, 6624, '\p{Is_Block=newtailue}', "");
    Expect(1, 6624, '\p{^Is_Block=newtailue}', "");
    Expect(1, 6624, '\P{Is_Block=newtailue}', "");
    Expect(0, 6624, '\P{^Is_Block=newtailue}', "");
    Expect(1, 6623, '\p{Is_Block:	--NEW_tai_lue}', "");
    Expect(0, 6623, '\p{^Is_Block:	--NEW_tai_lue}', "");
    Expect(0, 6623, '\P{Is_Block:	--NEW_tai_lue}', "");
    Expect(1, 6623, '\P{^Is_Block:	--NEW_tai_lue}', "");
    Expect(0, 6624, '\p{Is_Block:	--NEW_tai_lue}', "");
    Expect(1, 6624, '\p{^Is_Block:	--NEW_tai_lue}', "");
    Expect(1, 6624, '\P{Is_Block:	--NEW_tai_lue}', "");
    Expect(0, 6624, '\P{^Is_Block:	--NEW_tai_lue}', "");
    Error('\p{Is_Blk=--New_tai_Lue:=}');
    Error('\P{Is_Blk=--New_tai_Lue:=}');
    Expect(1, 6623, '\p{Is_Blk=newtailue}', "");
    Expect(0, 6623, '\p{^Is_Blk=newtailue}', "");
    Expect(0, 6623, '\P{Is_Blk=newtailue}', "");
    Expect(1, 6623, '\P{^Is_Blk=newtailue}', "");
    Expect(0, 6624, '\p{Is_Blk=newtailue}', "");
    Expect(1, 6624, '\p{^Is_Blk=newtailue}', "");
    Expect(1, 6624, '\P{Is_Blk=newtailue}', "");
    Expect(0, 6624, '\P{^Is_Blk=newtailue}', "");
    Expect(1, 6623, '\p{Is_Blk:    -new_tai_LUE}', "");
    Expect(0, 6623, '\p{^Is_Blk:    -new_tai_LUE}', "");
    Expect(0, 6623, '\P{Is_Blk:    -new_tai_LUE}', "");
    Expect(1, 6623, '\P{^Is_Blk:    -new_tai_LUE}', "");
    Expect(0, 6624, '\p{Is_Blk:    -new_tai_LUE}', "");
    Expect(1, 6624, '\p{^Is_Blk:    -new_tai_LUE}', "");
    Expect(1, 6624, '\P{Is_Blk:    -new_tai_LUE}', "");
    Expect(0, 6624, '\P{^Is_Blk:    -new_tai_LUE}', "");
    Error('\p{Block=/a/	-Newa}');
    Error('\P{Block=/a/	-Newa}');
    Expect(1, 70783, '\p{Block=newa}', "");
    Expect(0, 70783, '\p{^Block=newa}', "");
    Expect(0, 70783, '\P{Block=newa}', "");
    Expect(1, 70783, '\P{^Block=newa}', "");
    Expect(0, 70784, '\p{Block=newa}', "");
    Expect(1, 70784, '\p{^Block=newa}', "");
    Expect(1, 70784, '\P{Block=newa}', "");
    Expect(0, 70784, '\P{^Block=newa}', "");
    Expect(1, 70783, '\p{Block:_Newa}', "");
    Expect(0, 70783, '\p{^Block:_Newa}', "");
    Expect(0, 70783, '\P{Block:_Newa}', "");
    Expect(1, 70783, '\P{^Block:_Newa}', "");
    Expect(0, 70784, '\p{Block:_Newa}', "");
    Expect(1, 70784, '\p{^Block:_Newa}', "");
    Expect(1, 70784, '\P{Block:_Newa}', "");
    Expect(0, 70784, '\P{^Block:_Newa}', "");
    Error('\p{Blk=/a/ _Newa}');
    Error('\P{Blk=/a/ _Newa}');
    Expect(1, 70783, '\p{Blk=newa}', "");
    Expect(0, 70783, '\p{^Blk=newa}', "");
    Expect(0, 70783, '\P{Blk=newa}', "");
    Expect(1, 70783, '\P{^Blk=newa}', "");
    Expect(0, 70784, '\p{Blk=newa}', "");
    Expect(1, 70784, '\p{^Blk=newa}', "");
    Expect(1, 70784, '\P{Blk=newa}', "");
    Expect(0, 70784, '\P{^Blk=newa}', "");
    Expect(1, 70783, '\p{Blk=-Newa}', "");
    Expect(0, 70783, '\p{^Blk=-Newa}', "");
    Expect(0, 70783, '\P{Blk=-Newa}', "");
    Expect(1, 70783, '\P{^Blk=-Newa}', "");
    Expect(0, 70784, '\p{Blk=-Newa}', "");
    Expect(1, 70784, '\p{^Blk=-Newa}', "");
    Expect(1, 70784, '\P{Blk=-Newa}', "");
    Expect(0, 70784, '\P{^Blk=-Newa}', "");
    Error('\p{Is_Block=/a/_NEWA}');
    Error('\P{Is_Block=/a/_NEWA}');
    Expect(1, 70783, '\p{Is_Block=newa}', "");
    Expect(0, 70783, '\p{^Is_Block=newa}', "");
    Expect(0, 70783, '\P{Is_Block=newa}', "");
    Expect(1, 70783, '\P{^Is_Block=newa}', "");
    Expect(0, 70784, '\p{Is_Block=newa}', "");
    Expect(1, 70784, '\p{^Is_Block=newa}', "");
    Expect(1, 70784, '\P{Is_Block=newa}', "");
    Expect(0, 70784, '\P{^Is_Block=newa}', "");
    Expect(1, 70783, '\p{Is_Block:   -_NEWA}', "");
    Expect(0, 70783, '\p{^Is_Block:   -_NEWA}', "");
    Expect(0, 70783, '\P{Is_Block:   -_NEWA}', "");
    Expect(1, 70783, '\P{^Is_Block:   -_NEWA}', "");
    Expect(0, 70784, '\p{Is_Block:   -_NEWA}', "");
    Expect(1, 70784, '\p{^Is_Block:   -_NEWA}', "");
    Expect(1, 70784, '\P{Is_Block:   -_NEWA}', "");
    Expect(0, 70784, '\P{^Is_Block:   -_NEWA}', "");
    Error('\p{Is_Blk=NEWA:=}');
    Error('\P{Is_Blk=NEWA:=}');
    Expect(1, 70783, '\p{Is_Blk=newa}', "");
    Expect(0, 70783, '\p{^Is_Blk=newa}', "");
    Expect(0, 70783, '\P{Is_Blk=newa}', "");
    Expect(1, 70783, '\P{^Is_Blk=newa}', "");
    Expect(0, 70784, '\p{Is_Blk=newa}', "");
    Expect(1, 70784, '\p{^Is_Blk=newa}', "");
    Expect(1, 70784, '\P{Is_Blk=newa}', "");
    Expect(0, 70784, '\P{^Is_Blk=newa}', "");
    Expect(1, 70783, '\p{Is_Blk=	Newa}', "");
    Expect(0, 70783, '\p{^Is_Blk=	Newa}', "");
    Expect(0, 70783, '\P{Is_Blk=	Newa}', "");
    Expect(1, 70783, '\P{^Is_Blk=	Newa}', "");
    Expect(0, 70784, '\p{Is_Blk=	Newa}', "");
    Expect(1, 70784, '\p{^Is_Blk=	Newa}', "");
    Expect(1, 70784, '\P{Is_Blk=	Newa}', "");
    Expect(0, 70784, '\P{^Is_Blk=	Newa}', "");
    Error('\p{Block:		:=NKO}');
    Error('\P{Block:		:=NKO}');
    Expect(1, 2047, '\p{Block=nko}', "");
    Expect(0, 2047, '\p{^Block=nko}', "");
    Expect(0, 2047, '\P{Block=nko}', "");
    Expect(1, 2047, '\P{^Block=nko}', "");
    Expect(0, 2048, '\p{Block=nko}', "");
    Expect(1, 2048, '\p{^Block=nko}', "");
    Expect(1, 2048, '\P{Block=nko}', "");
    Expect(0, 2048, '\P{^Block=nko}', "");
    Expect(1, 2047, '\p{Block=__NKo}', "");
    Expect(0, 2047, '\p{^Block=__NKo}', "");
    Expect(0, 2047, '\P{Block=__NKo}', "");
    Expect(1, 2047, '\P{^Block=__NKo}', "");
    Expect(0, 2048, '\p{Block=__NKo}', "");
    Expect(1, 2048, '\p{^Block=__NKo}', "");
    Expect(1, 2048, '\P{Block=__NKo}', "");
    Expect(0, 2048, '\P{^Block=__NKo}', "");
    Error('\p{Blk=/a/NKo}');
    Error('\P{Blk=/a/NKo}');
    Expect(1, 2047, '\p{Blk=nko}', "");
    Expect(0, 2047, '\p{^Blk=nko}', "");
    Expect(0, 2047, '\P{Blk=nko}', "");
    Expect(1, 2047, '\P{^Blk=nko}', "");
    Expect(0, 2048, '\p{Blk=nko}', "");
    Expect(1, 2048, '\p{^Blk=nko}', "");
    Expect(1, 2048, '\P{Blk=nko}', "");
    Expect(0, 2048, '\P{^Blk=nko}', "");
    Expect(1, 2047, '\p{Blk=	nko}', "");
    Expect(0, 2047, '\p{^Blk=	nko}', "");
    Expect(0, 2047, '\P{Blk=	nko}', "");
    Expect(1, 2047, '\P{^Blk=	nko}', "");
    Expect(0, 2048, '\p{Blk=	nko}', "");
    Expect(1, 2048, '\p{^Blk=	nko}', "");
    Expect(1, 2048, '\P{Blk=	nko}', "");
    Expect(0, 2048, '\P{^Blk=	nko}', "");
    Error('\p{Is_Block=/a/ nko}');
    Error('\P{Is_Block=/a/ nko}');
    Expect(1, 2047, '\p{Is_Block=nko}', "");
    Expect(0, 2047, '\p{^Is_Block=nko}', "");
    Expect(0, 2047, '\P{Is_Block=nko}', "");
    Expect(1, 2047, '\P{^Is_Block=nko}', "");
    Expect(0, 2048, '\p{Is_Block=nko}', "");
    Expect(1, 2048, '\p{^Is_Block=nko}', "");
    Expect(1, 2048, '\P{Is_Block=nko}', "");
    Expect(0, 2048, '\P{^Is_Block=nko}', "");
    Expect(1, 2047, '\p{Is_Block: - NKo}', "");
    Expect(0, 2047, '\p{^Is_Block: - NKo}', "");
    Expect(0, 2047, '\P{Is_Block: - NKo}', "");
    Expect(1, 2047, '\P{^Is_Block: - NKo}', "");
    Expect(0, 2048, '\p{Is_Block: - NKo}', "");
    Expect(1, 2048, '\p{^Is_Block: - NKo}', "");
    Expect(1, 2048, '\P{Is_Block: - NKo}', "");
    Expect(0, 2048, '\P{^Is_Block: - NKo}', "");
    Error('\p{Is_Blk=  NKo:=}');
    Error('\P{Is_Blk=  NKo:=}');
    Expect(1, 2047, '\p{Is_Blk=nko}', "");
    Expect(0, 2047, '\p{^Is_Blk=nko}', "");
    Expect(0, 2047, '\P{Is_Blk=nko}', "");
    Expect(1, 2047, '\P{^Is_Blk=nko}', "");
    Expect(0, 2048, '\p{Is_Blk=nko}', "");
    Expect(1, 2048, '\p{^Is_Blk=nko}', "");
    Expect(1, 2048, '\P{Is_Blk=nko}', "");
    Expect(0, 2048, '\P{^Is_Blk=nko}', "");
    Expect(1, 2047, '\p{Is_Blk=_NKo}', "");
    Expect(0, 2047, '\p{^Is_Blk=_NKo}', "");
    Expect(0, 2047, '\P{Is_Blk=_NKo}', "");
    Expect(1, 2047, '\P{^Is_Blk=_NKo}', "");
    Expect(0, 2048, '\p{Is_Blk=_NKo}', "");
    Expect(1, 2048, '\p{^Is_Blk=_NKo}', "");
    Expect(1, 2048, '\P{Is_Blk=_NKo}', "");
    Expect(0, 2048, '\P{^Is_Blk=_NKo}', "");
    Error('\p{Block= :=number_Forms}');
    Error('\P{Block= :=number_Forms}');
    Expect(1, 8591, '\p{Block=numberforms}', "");
    Expect(0, 8591, '\p{^Block=numberforms}', "");
    Expect(0, 8591, '\P{Block=numberforms}', "");
    Expect(1, 8591, '\P{^Block=numberforms}', "");
    Expect(0, 8592, '\p{Block=numberforms}', "");
    Expect(1, 8592, '\p{^Block=numberforms}', "");
    Expect(1, 8592, '\P{Block=numberforms}', "");
    Expect(0, 8592, '\P{^Block=numberforms}', "");
    Expect(1, 8591, '\p{Block=-_Number_Forms}', "");
    Expect(0, 8591, '\p{^Block=-_Number_Forms}', "");
    Expect(0, 8591, '\P{Block=-_Number_Forms}', "");
    Expect(1, 8591, '\P{^Block=-_Number_Forms}', "");
    Expect(0, 8592, '\p{Block=-_Number_Forms}', "");
    Expect(1, 8592, '\p{^Block=-_Number_Forms}', "");
    Expect(1, 8592, '\P{Block=-_Number_Forms}', "");
    Expect(0, 8592, '\P{^Block=-_Number_Forms}', "");
    Error('\p{Blk=-number_forms:=}');
    Error('\P{Blk=-number_forms:=}');
    Expect(1, 8591, '\p{Blk=numberforms}', "");
    Expect(0, 8591, '\p{^Blk=numberforms}', "");
    Expect(0, 8591, '\P{Blk=numberforms}', "");
    Expect(1, 8591, '\P{^Blk=numberforms}', "");
    Expect(0, 8592, '\p{Blk=numberforms}', "");
    Expect(1, 8592, '\p{^Blk=numberforms}', "");
    Expect(1, 8592, '\P{Blk=numberforms}', "");
    Expect(0, 8592, '\P{^Blk=numberforms}', "");
    Expect(1, 8591, '\p{Blk:_ Number_forms}', "");
    Expect(0, 8591, '\p{^Blk:_ Number_forms}', "");
    Expect(0, 8591, '\P{Blk:_ Number_forms}', "");
    Expect(1, 8591, '\P{^Blk:_ Number_forms}', "");
    Expect(0, 8592, '\p{Blk:_ Number_forms}', "");
    Expect(1, 8592, '\p{^Blk:_ Number_forms}', "");
    Expect(1, 8592, '\P{Blk:_ Number_forms}', "");
    Expect(0, 8592, '\P{^Blk:_ Number_forms}', "");
    Error('\p{Is_Block:   -:=Number_FORMS}');
    Error('\P{Is_Block:   -:=Number_FORMS}');
    Expect(1, 8591, '\p{Is_Block: numberforms}', "");
    Expect(0, 8591, '\p{^Is_Block: numberforms}', "");
    Expect(0, 8591, '\P{Is_Block: numberforms}', "");
    Expect(1, 8591, '\P{^Is_Block: numberforms}', "");
    Expect(0, 8592, '\p{Is_Block: numberforms}', "");
    Expect(1, 8592, '\p{^Is_Block: numberforms}', "");
    Expect(1, 8592, '\P{Is_Block: numberforms}', "");
    Expect(0, 8592, '\P{^Is_Block: numberforms}', "");
    Expect(1, 8591, '\p{Is_Block=Number_FORMS}', "");
    Expect(0, 8591, '\p{^Is_Block=Number_FORMS}', "");
    Expect(0, 8591, '\P{Is_Block=Number_FORMS}', "");
    Expect(1, 8591, '\P{^Is_Block=Number_FORMS}', "");
    Expect(0, 8592, '\p{Is_Block=Number_FORMS}', "");
    Expect(1, 8592, '\p{^Is_Block=Number_FORMS}', "");
    Expect(1, 8592, '\P{Is_Block=Number_FORMS}', "");
    Expect(0, 8592, '\P{^Is_Block=Number_FORMS}', "");
    Error('\p{Is_Blk=	:=NUMBER_Forms}');
    Error('\P{Is_Blk=	:=NUMBER_Forms}');
    Expect(1, 8591, '\p{Is_Blk=numberforms}', "");
    Expect(0, 8591, '\p{^Is_Blk=numberforms}', "");
    Expect(0, 8591, '\P{Is_Blk=numberforms}', "");
    Expect(1, 8591, '\P{^Is_Blk=numberforms}', "");
    Expect(0, 8592, '\p{Is_Blk=numberforms}', "");
    Expect(1, 8592, '\p{^Is_Blk=numberforms}', "");
    Expect(1, 8592, '\P{Is_Blk=numberforms}', "");
    Expect(0, 8592, '\P{^Is_Blk=numberforms}', "");
    Expect(1, 8591, '\p{Is_Blk=- Number_Forms}', "");
    Expect(0, 8591, '\p{^Is_Blk=- Number_Forms}', "");
    Expect(0, 8591, '\P{Is_Blk=- Number_Forms}', "");
    Expect(1, 8591, '\P{^Is_Blk=- Number_Forms}', "");
    Expect(0, 8592, '\p{Is_Blk=- Number_Forms}', "");
    Expect(1, 8592, '\p{^Is_Blk=- Number_Forms}', "");
    Expect(1, 8592, '\P{Is_Blk=- Number_Forms}', "");
    Expect(0, 8592, '\P{^Is_Blk=- Number_Forms}', "");
    Error('\p{Block=:=-NUSHU}');
    Error('\P{Block=:=-NUSHU}');
    Expect(1, 111359, '\p{Block=nushu}', "");
    Expect(0, 111359, '\p{^Block=nushu}', "");
    Expect(0, 111359, '\P{Block=nushu}', "");
    Expect(1, 111359, '\P{^Block=nushu}', "");
    Expect(0, 111360, '\p{Block=nushu}', "");
    Expect(1, 111360, '\p{^Block=nushu}', "");
    Expect(1, 111360, '\P{Block=nushu}', "");
    Expect(0, 111360, '\P{^Block=nushu}', "");
    Expect(1, 111359, '\p{Block=		NUSHU}', "");
    Expect(0, 111359, '\p{^Block=		NUSHU}', "");
    Expect(0, 111359, '\P{Block=		NUSHU}', "");
    Expect(1, 111359, '\P{^Block=		NUSHU}', "");
    Expect(0, 111360, '\p{Block=		NUSHU}', "");
    Expect(1, 111360, '\p{^Block=		NUSHU}', "");
    Expect(1, 111360, '\P{Block=		NUSHU}', "");
    Expect(0, 111360, '\P{^Block=		NUSHU}', "");
    Error('\p{Blk=-/a/Nushu}');
    Error('\P{Blk=-/a/Nushu}');
    Expect(1, 111359, '\p{Blk=nushu}', "");
    Expect(0, 111359, '\p{^Blk=nushu}', "");
    Expect(0, 111359, '\P{Blk=nushu}', "");
    Expect(1, 111359, '\P{^Blk=nushu}', "");
    Expect(0, 111360, '\p{Blk=nushu}', "");
    Expect(1, 111360, '\p{^Blk=nushu}', "");
    Expect(1, 111360, '\P{Blk=nushu}', "");
    Expect(0, 111360, '\P{^Blk=nushu}', "");
    Expect(1, 111359, '\p{Blk=	_nushu}', "");
    Expect(0, 111359, '\p{^Blk=	_nushu}', "");
    Expect(0, 111359, '\P{Blk=	_nushu}', "");
    Expect(1, 111359, '\P{^Blk=	_nushu}', "");
    Expect(0, 111360, '\p{Blk=	_nushu}', "");
    Expect(1, 111360, '\p{^Blk=	_nushu}', "");
    Expect(1, 111360, '\P{Blk=	_nushu}', "");
    Expect(0, 111360, '\P{^Blk=	_nushu}', "");
    Error('\p{Is_Block=:=nushu}');
    Error('\P{Is_Block=:=nushu}');
    Expect(1, 111359, '\p{Is_Block=nushu}', "");
    Expect(0, 111359, '\p{^Is_Block=nushu}', "");
    Expect(0, 111359, '\P{Is_Block=nushu}', "");
    Expect(1, 111359, '\P{^Is_Block=nushu}', "");
    Expect(0, 111360, '\p{Is_Block=nushu}', "");
    Expect(1, 111360, '\p{^Is_Block=nushu}', "");
    Expect(1, 111360, '\P{Is_Block=nushu}', "");
    Expect(0, 111360, '\P{^Is_Block=nushu}', "");
    Expect(1, 111359, '\p{Is_Block=	_Nushu}', "");
    Expect(0, 111359, '\p{^Is_Block=	_Nushu}', "");
    Expect(0, 111359, '\P{Is_Block=	_Nushu}', "");
    Expect(1, 111359, '\P{^Is_Block=	_Nushu}', "");
    Expect(0, 111360, '\p{Is_Block=	_Nushu}', "");
    Expect(1, 111360, '\p{^Is_Block=	_Nushu}', "");
    Expect(1, 111360, '\P{Is_Block=	_Nushu}', "");
    Expect(0, 111360, '\P{^Is_Block=	_Nushu}', "");
    Error('\p{Is_Blk=/a/_ NUSHU}');
    Error('\P{Is_Blk=/a/_ NUSHU}');
    Expect(1, 111359, '\p{Is_Blk=nushu}', "");
    Expect(0, 111359, '\p{^Is_Blk=nushu}', "");
    Expect(0, 111359, '\P{Is_Blk=nushu}', "");
    Expect(1, 111359, '\P{^Is_Blk=nushu}', "");
    Expect(0, 111360, '\p{Is_Blk=nushu}', "");
    Expect(1, 111360, '\p{^Is_Blk=nushu}', "");
    Expect(1, 111360, '\P{Is_Blk=nushu}', "");
    Expect(0, 111360, '\P{^Is_Blk=nushu}', "");
    Expect(1, 111359, '\p{Is_Blk=	Nushu}', "");
    Expect(0, 111359, '\p{^Is_Blk=	Nushu}', "");
    Expect(0, 111359, '\P{Is_Blk=	Nushu}', "");
    Expect(1, 111359, '\P{^Is_Blk=	Nushu}', "");
    Expect(0, 111360, '\p{Is_Blk=	Nushu}', "");
    Expect(1, 111360, '\p{^Is_Blk=	Nushu}', "");
    Expect(1, 111360, '\P{Is_Blk=	Nushu}', "");
    Expect(0, 111360, '\P{^Is_Blk=	Nushu}', "");
    Error('\p{Block=	:=Optical_Character_Recognition}');
    Error('\P{Block=	:=Optical_Character_Recognition}');
    Expect(1, 9311, '\p{Block=opticalcharacterrecognition}', "");
    Expect(0, 9311, '\p{^Block=opticalcharacterrecognition}', "");
    Expect(0, 9311, '\P{Block=opticalcharacterrecognition}', "");
    Expect(1, 9311, '\P{^Block=opticalcharacterrecognition}', "");
    Expect(0, 9312, '\p{Block=opticalcharacterrecognition}', "");
    Expect(1, 9312, '\p{^Block=opticalcharacterrecognition}', "");
    Expect(1, 9312, '\P{Block=opticalcharacterrecognition}', "");
    Expect(0, 9312, '\P{^Block=opticalcharacterrecognition}', "");
    Expect(1, 9311, '\p{Block:	Optical_CHARACTER_Recognition}', "");
    Expect(0, 9311, '\p{^Block:	Optical_CHARACTER_Recognition}', "");
    Expect(0, 9311, '\P{Block:	Optical_CHARACTER_Recognition}', "");
    Expect(1, 9311, '\P{^Block:	Optical_CHARACTER_Recognition}', "");
    Expect(0, 9312, '\p{Block:	Optical_CHARACTER_Recognition}', "");
    Expect(1, 9312, '\p{^Block:	Optical_CHARACTER_Recognition}', "");
    Expect(1, 9312, '\P{Block:	Optical_CHARACTER_Recognition}', "");
    Expect(0, 9312, '\P{^Block:	Optical_CHARACTER_Recognition}', "");
    Error('\p{Blk=__OCR/a/}');
    Error('\P{Blk=__OCR/a/}');
    Expect(1, 9311, '\p{Blk=ocr}', "");
    Expect(0, 9311, '\p{^Blk=ocr}', "");
    Expect(0, 9311, '\P{Blk=ocr}', "");
    Expect(1, 9311, '\P{^Blk=ocr}', "");
    Expect(0, 9312, '\p{Blk=ocr}', "");
    Expect(1, 9312, '\p{^Blk=ocr}', "");
    Expect(1, 9312, '\P{Blk=ocr}', "");
    Expect(0, 9312, '\P{^Blk=ocr}', "");
    Expect(1, 9311, '\p{Blk=_OCR}', "");
    Expect(0, 9311, '\p{^Blk=_OCR}', "");
    Expect(0, 9311, '\P{Blk=_OCR}', "");
    Expect(1, 9311, '\P{^Blk=_OCR}', "");
    Expect(0, 9312, '\p{Blk=_OCR}', "");
    Expect(1, 9312, '\p{^Blk=_OCR}', "");
    Expect(1, 9312, '\P{Blk=_OCR}', "");
    Expect(0, 9312, '\P{^Blk=_OCR}', "");
    Error('\p{Is_Block=	:=OPTICAL_Character_recognition}');
    Error('\P{Is_Block=	:=OPTICAL_Character_recognition}');
    Expect(1, 9311, '\p{Is_Block=opticalcharacterrecognition}', "");
    Expect(0, 9311, '\p{^Is_Block=opticalcharacterrecognition}', "");
    Expect(0, 9311, '\P{Is_Block=opticalcharacterrecognition}', "");
    Expect(1, 9311, '\P{^Is_Block=opticalcharacterrecognition}', "");
    Expect(0, 9312, '\p{Is_Block=opticalcharacterrecognition}', "");
    Expect(1, 9312, '\p{^Is_Block=opticalcharacterrecognition}', "");
    Expect(1, 9312, '\P{Is_Block=opticalcharacterrecognition}', "");
    Expect(0, 9312, '\P{^Is_Block=opticalcharacterrecognition}', "");
    Expect(1, 9311, '\p{Is_Block=_	Optical_character_Recognition}', "");
    Expect(0, 9311, '\p{^Is_Block=_	Optical_character_Recognition}', "");
    Expect(0, 9311, '\P{Is_Block=_	Optical_character_Recognition}', "");
    Expect(1, 9311, '\P{^Is_Block=_	Optical_character_Recognition}', "");
    Expect(0, 9312, '\p{Is_Block=_	Optical_character_Recognition}', "");
    Expect(1, 9312, '\p{^Is_Block=_	Optical_character_Recognition}', "");
    Expect(1, 9312, '\P{Is_Block=_	Optical_character_Recognition}', "");
    Expect(0, 9312, '\P{^Is_Block=_	Optical_character_Recognition}', "");
    Error('\p{Is_Blk=_	ocr/a/}');
    Error('\P{Is_Blk=_	ocr/a/}');
    Expect(1, 9311, '\p{Is_Blk: ocr}', "");
    Expect(0, 9311, '\p{^Is_Blk: ocr}', "");
    Expect(0, 9311, '\P{Is_Blk: ocr}', "");
    Expect(1, 9311, '\P{^Is_Blk: ocr}', "");
    Expect(0, 9312, '\p{Is_Blk: ocr}', "");
    Expect(1, 9312, '\p{^Is_Blk: ocr}', "");
    Expect(1, 9312, '\P{Is_Blk: ocr}', "");
    Expect(0, 9312, '\P{^Is_Blk: ocr}', "");
    Expect(1, 9311, '\p{Is_Blk=--ocr}', "");
    Expect(0, 9311, '\p{^Is_Blk=--ocr}', "");
    Expect(0, 9311, '\P{Is_Blk=--ocr}', "");
    Expect(1, 9311, '\P{^Is_Blk=--ocr}', "");
    Expect(0, 9312, '\p{Is_Blk=--ocr}', "");
    Expect(1, 9312, '\p{^Is_Blk=--ocr}', "");
    Expect(1, 9312, '\P{Is_Blk=--ocr}', "");
    Expect(0, 9312, '\P{^Is_Blk=--ocr}', "");
    Error('\p{Block=-Ogham/a/}');
    Error('\P{Block=-Ogham/a/}');
    Expect(1, 5791, '\p{Block=ogham}', "");
    Expect(0, 5791, '\p{^Block=ogham}', "");
    Expect(0, 5791, '\P{Block=ogham}', "");
    Expect(1, 5791, '\P{^Block=ogham}', "");
    Expect(0, 5792, '\p{Block=ogham}', "");
    Expect(1, 5792, '\p{^Block=ogham}', "");
    Expect(1, 5792, '\P{Block=ogham}', "");
    Expect(0, 5792, '\P{^Block=ogham}', "");
    Expect(1, 5791, '\p{Block=-Ogham}', "");
    Expect(0, 5791, '\p{^Block=-Ogham}', "");
    Expect(0, 5791, '\P{Block=-Ogham}', "");
    Expect(1, 5791, '\P{^Block=-Ogham}', "");
    Expect(0, 5792, '\p{Block=-Ogham}', "");
    Expect(1, 5792, '\p{^Block=-Ogham}', "");
    Expect(1, 5792, '\P{Block=-Ogham}', "");
    Expect(0, 5792, '\P{^Block=-Ogham}', "");
    Error('\p{Blk:   :=	Ogham}');
    Error('\P{Blk:   :=	Ogham}');
    Expect(1, 5791, '\p{Blk=ogham}', "");
    Expect(0, 5791, '\p{^Blk=ogham}', "");
    Expect(0, 5791, '\P{Blk=ogham}', "");
    Expect(1, 5791, '\P{^Blk=ogham}', "");
    Expect(0, 5792, '\p{Blk=ogham}', "");
    Expect(1, 5792, '\p{^Blk=ogham}', "");
    Expect(1, 5792, '\P{Blk=ogham}', "");
    Expect(0, 5792, '\P{^Blk=ogham}', "");
    Expect(1, 5791, '\p{Blk=_ ogham}', "");
    Expect(0, 5791, '\p{^Blk=_ ogham}', "");
    Expect(0, 5791, '\P{Blk=_ ogham}', "");
    Expect(1, 5791, '\P{^Blk=_ ogham}', "");
    Expect(0, 5792, '\p{Blk=_ ogham}', "");
    Expect(1, 5792, '\p{^Blk=_ ogham}', "");
    Expect(1, 5792, '\P{Blk=_ ogham}', "");
    Expect(0, 5792, '\P{^Blk=_ ogham}', "");
    Error('\p{Is_Block= :=ogham}');
    Error('\P{Is_Block= :=ogham}');
    Expect(1, 5791, '\p{Is_Block=ogham}', "");
    Expect(0, 5791, '\p{^Is_Block=ogham}', "");
    Expect(0, 5791, '\P{Is_Block=ogham}', "");
    Expect(1, 5791, '\P{^Is_Block=ogham}', "");
    Expect(0, 5792, '\p{Is_Block=ogham}', "");
    Expect(1, 5792, '\p{^Is_Block=ogham}', "");
    Expect(1, 5792, '\P{Is_Block=ogham}', "");
    Expect(0, 5792, '\P{^Is_Block=ogham}', "");
    Expect(1, 5791, '\p{Is_Block=		Ogham}', "");
    Expect(0, 5791, '\p{^Is_Block=		Ogham}', "");
    Expect(0, 5791, '\P{Is_Block=		Ogham}', "");
    Expect(1, 5791, '\P{^Is_Block=		Ogham}', "");
    Expect(0, 5792, '\p{Is_Block=		Ogham}', "");
    Expect(1, 5792, '\p{^Is_Block=		Ogham}', "");
    Expect(1, 5792, '\P{Is_Block=		Ogham}', "");
    Expect(0, 5792, '\P{^Is_Block=		Ogham}', "");
    Error('\p{Is_Blk=_ Ogham/a/}');
    Error('\P{Is_Blk=_ Ogham/a/}');
    Expect(1, 5791, '\p{Is_Blk=ogham}', "");
    Expect(0, 5791, '\p{^Is_Blk=ogham}', "");
    Expect(0, 5791, '\P{Is_Blk=ogham}', "");
    Expect(1, 5791, '\P{^Is_Blk=ogham}', "");
    Expect(0, 5792, '\p{Is_Blk=ogham}', "");
    Expect(1, 5792, '\p{^Is_Blk=ogham}', "");
    Expect(1, 5792, '\P{Is_Blk=ogham}', "");
    Expect(0, 5792, '\P{^Is_Blk=ogham}', "");
    Expect(1, 5791, '\p{Is_Blk=_-ogham}', "");
    Expect(0, 5791, '\p{^Is_Blk=_-ogham}', "");
    Expect(0, 5791, '\P{Is_Blk=_-ogham}', "");
    Expect(1, 5791, '\P{^Is_Blk=_-ogham}', "");
    Expect(0, 5792, '\p{Is_Blk=_-ogham}', "");
    Expect(1, 5792, '\p{^Is_Blk=_-ogham}', "");
    Expect(1, 5792, '\P{Is_Blk=_-ogham}', "");
    Expect(0, 5792, '\P{^Is_Blk=_-ogham}', "");
    Error('\p{Block=	-Ol_CHIKI/a/}');
    Error('\P{Block=	-Ol_CHIKI/a/}');
    Expect(1, 7295, '\p{Block=olchiki}', "");
    Expect(0, 7295, '\p{^Block=olchiki}', "");
    Expect(0, 7295, '\P{Block=olchiki}', "");
    Expect(1, 7295, '\P{^Block=olchiki}', "");
    Expect(0, 7296, '\p{Block=olchiki}', "");
    Expect(1, 7296, '\p{^Block=olchiki}', "");
    Expect(1, 7296, '\P{Block=olchiki}', "");
    Expect(0, 7296, '\P{^Block=olchiki}', "");
    Expect(1, 7295, '\p{Block=_ ol_Chiki}', "");
    Expect(0, 7295, '\p{^Block=_ ol_Chiki}', "");
    Expect(0, 7295, '\P{Block=_ ol_Chiki}', "");
    Expect(1, 7295, '\P{^Block=_ ol_Chiki}', "");
    Expect(0, 7296, '\p{Block=_ ol_Chiki}', "");
    Expect(1, 7296, '\p{^Block=_ ol_Chiki}', "");
    Expect(1, 7296, '\P{Block=_ ol_Chiki}', "");
    Expect(0, 7296, '\P{^Block=_ ol_Chiki}', "");
    Error('\p{Blk= -OL_Chiki:=}');
    Error('\P{Blk= -OL_Chiki:=}');
    Expect(1, 7295, '\p{Blk=olchiki}', "");
    Expect(0, 7295, '\p{^Blk=olchiki}', "");
    Expect(0, 7295, '\P{Blk=olchiki}', "");
    Expect(1, 7295, '\P{^Blk=olchiki}', "");
    Expect(0, 7296, '\p{Blk=olchiki}', "");
    Expect(1, 7296, '\p{^Blk=olchiki}', "");
    Expect(1, 7296, '\P{Blk=olchiki}', "");
    Expect(0, 7296, '\P{^Blk=olchiki}', "");
    Expect(1, 7295, '\p{Blk=Ol_Chiki}', "");
    Expect(0, 7295, '\p{^Blk=Ol_Chiki}', "");
    Expect(0, 7295, '\P{Blk=Ol_Chiki}', "");
    Expect(1, 7295, '\P{^Blk=Ol_Chiki}', "");
    Expect(0, 7296, '\p{Blk=Ol_Chiki}', "");
    Expect(1, 7296, '\p{^Blk=Ol_Chiki}', "");
    Expect(1, 7296, '\P{Blk=Ol_Chiki}', "");
    Expect(0, 7296, '\P{^Blk=Ol_Chiki}', "");
    Error('\p{Is_Block=	Ol_CHIKI/a/}');
    Error('\P{Is_Block=	Ol_CHIKI/a/}');
    Expect(1, 7295, '\p{Is_Block=olchiki}', "");
    Expect(0, 7295, '\p{^Is_Block=olchiki}', "");
    Expect(0, 7295, '\P{Is_Block=olchiki}', "");
    Expect(1, 7295, '\P{^Is_Block=olchiki}', "");
    Expect(0, 7296, '\p{Is_Block=olchiki}', "");
    Expect(1, 7296, '\p{^Is_Block=olchiki}', "");
    Expect(1, 7296, '\P{Is_Block=olchiki}', "");
    Expect(0, 7296, '\P{^Is_Block=olchiki}', "");
    Expect(1, 7295, '\p{Is_Block:_OL_chiki}', "");
    Expect(0, 7295, '\p{^Is_Block:_OL_chiki}', "");
    Expect(0, 7295, '\P{Is_Block:_OL_chiki}', "");
    Expect(1, 7295, '\P{^Is_Block:_OL_chiki}', "");
    Expect(0, 7296, '\p{Is_Block:_OL_chiki}', "");
    Expect(1, 7296, '\p{^Is_Block:_OL_chiki}', "");
    Expect(1, 7296, '\P{Is_Block:_OL_chiki}', "");
    Expect(0, 7296, '\P{^Is_Block:_OL_chiki}', "");
    Error('\p{Is_Blk=:= _ol_chiki}');
    Error('\P{Is_Blk=:= _ol_chiki}');
    Expect(1, 7295, '\p{Is_Blk=olchiki}', "");
    Expect(0, 7295, '\p{^Is_Blk=olchiki}', "");
    Expect(0, 7295, '\P{Is_Blk=olchiki}', "");
    Expect(1, 7295, '\P{^Is_Blk=olchiki}', "");
    Expect(0, 7296, '\p{Is_Blk=olchiki}', "");
    Expect(1, 7296, '\p{^Is_Blk=olchiki}', "");
    Expect(1, 7296, '\P{Is_Blk=olchiki}', "");
    Expect(0, 7296, '\P{^Is_Blk=olchiki}', "");
    Expect(1, 7295, '\p{Is_Blk=_ ol_chiki}', "");
    Expect(0, 7295, '\p{^Is_Blk=_ ol_chiki}', "");
    Expect(0, 7295, '\P{Is_Blk=_ ol_chiki}', "");
    Expect(1, 7295, '\P{^Is_Blk=_ ol_chiki}', "");
    Expect(0, 7296, '\p{Is_Blk=_ ol_chiki}', "");
    Expect(1, 7296, '\p{^Is_Blk=_ ol_chiki}', "");
    Expect(1, 7296, '\P{Is_Blk=_ ol_chiki}', "");
    Expect(0, 7296, '\P{^Is_Blk=_ ol_chiki}', "");
    Error('\p{Block: -:=old_Hungarian}');
    Error('\P{Block: -:=old_Hungarian}');
    Expect(1, 68863, '\p{Block:oldhungarian}', "");
    Expect(0, 68863, '\p{^Block:oldhungarian}', "");
    Expect(0, 68863, '\P{Block:oldhungarian}', "");
    Expect(1, 68863, '\P{^Block:oldhungarian}', "");
    Expect(0, 68864, '\p{Block:oldhungarian}', "");
    Expect(1, 68864, '\p{^Block:oldhungarian}', "");
    Expect(1, 68864, '\P{Block:oldhungarian}', "");
    Expect(0, 68864, '\P{^Block:oldhungarian}', "");
    Expect(1, 68863, '\p{Block=old_hungarian}', "");
    Expect(0, 68863, '\p{^Block=old_hungarian}', "");
    Expect(0, 68863, '\P{Block=old_hungarian}', "");
    Expect(1, 68863, '\P{^Block=old_hungarian}', "");
    Expect(0, 68864, '\p{Block=old_hungarian}', "");
    Expect(1, 68864, '\p{^Block=old_hungarian}', "");
    Expect(1, 68864, '\P{Block=old_hungarian}', "");
    Expect(0, 68864, '\P{^Block=old_hungarian}', "");
    Error('\p{Blk=/a/old_Hungarian}');
    Error('\P{Blk=/a/old_Hungarian}');
    Expect(1, 68863, '\p{Blk=oldhungarian}', "");
    Expect(0, 68863, '\p{^Blk=oldhungarian}', "");
    Expect(0, 68863, '\P{Blk=oldhungarian}', "");
    Expect(1, 68863, '\P{^Blk=oldhungarian}', "");
    Expect(0, 68864, '\p{Blk=oldhungarian}', "");
    Expect(1, 68864, '\p{^Blk=oldhungarian}', "");
    Expect(1, 68864, '\P{Blk=oldhungarian}', "");
    Expect(0, 68864, '\P{^Blk=oldhungarian}', "");
    Expect(1, 68863, '\p{Blk=	OLD_Hungarian}', "");
    Expect(0, 68863, '\p{^Blk=	OLD_Hungarian}', "");
    Expect(0, 68863, '\P{Blk=	OLD_Hungarian}', "");
    Expect(1, 68863, '\P{^Blk=	OLD_Hungarian}', "");
    Expect(0, 68864, '\p{Blk=	OLD_Hungarian}', "");
    Expect(1, 68864, '\p{^Blk=	OLD_Hungarian}', "");
    Expect(1, 68864, '\P{Blk=	OLD_Hungarian}', "");
    Expect(0, 68864, '\P{^Blk=	OLD_Hungarian}', "");
    Error('\p{Is_Block=--Old_Hungarian/a/}');
    Error('\P{Is_Block=--Old_Hungarian/a/}');
    Expect(1, 68863, '\p{Is_Block:   oldhungarian}', "");
    Expect(0, 68863, '\p{^Is_Block:   oldhungarian}', "");
    Expect(0, 68863, '\P{Is_Block:   oldhungarian}', "");
    Expect(1, 68863, '\P{^Is_Block:   oldhungarian}', "");
    Expect(0, 68864, '\p{Is_Block:   oldhungarian}', "");
    Expect(1, 68864, '\p{^Is_Block:   oldhungarian}', "");
    Expect(1, 68864, '\P{Is_Block:   oldhungarian}', "");
    Expect(0, 68864, '\P{^Is_Block:   oldhungarian}', "");
    Expect(1, 68863, '\p{Is_Block=OLD_Hungarian}', "");
    Expect(0, 68863, '\p{^Is_Block=OLD_Hungarian}', "");
    Expect(0, 68863, '\P{Is_Block=OLD_Hungarian}', "");
    Expect(1, 68863, '\P{^Is_Block=OLD_Hungarian}', "");
    Expect(0, 68864, '\p{Is_Block=OLD_Hungarian}', "");
    Expect(1, 68864, '\p{^Is_Block=OLD_Hungarian}', "");
    Expect(1, 68864, '\P{Is_Block=OLD_Hungarian}', "");
    Expect(0, 68864, '\P{^Is_Block=OLD_Hungarian}', "");
    Error('\p{Is_Blk=:=		old_hungarian}');
    Error('\P{Is_Blk=:=		old_hungarian}');
    Expect(1, 68863, '\p{Is_Blk=oldhungarian}', "");
    Expect(0, 68863, '\p{^Is_Blk=oldhungarian}', "");
    Expect(0, 68863, '\P{Is_Blk=oldhungarian}', "");
    Expect(1, 68863, '\P{^Is_Blk=oldhungarian}', "");
    Expect(0, 68864, '\p{Is_Blk=oldhungarian}', "");
    Expect(1, 68864, '\p{^Is_Blk=oldhungarian}', "");
    Expect(1, 68864, '\P{Is_Blk=oldhungarian}', "");
    Expect(0, 68864, '\P{^Is_Blk=oldhungarian}', "");
    Expect(1, 68863, '\p{Is_Blk=_old_HUNGARIAN}', "");
    Expect(0, 68863, '\p{^Is_Blk=_old_HUNGARIAN}', "");
    Expect(0, 68863, '\P{Is_Blk=_old_HUNGARIAN}', "");
    Expect(1, 68863, '\P{^Is_Blk=_old_HUNGARIAN}', "");
    Expect(0, 68864, '\p{Is_Blk=_old_HUNGARIAN}', "");
    Expect(1, 68864, '\p{^Is_Blk=_old_HUNGARIAN}', "");
    Expect(1, 68864, '\P{Is_Blk=_old_HUNGARIAN}', "");
    Expect(0, 68864, '\P{^Is_Blk=_old_HUNGARIAN}', "");
    Error('\p{Block= -Old_Italic/a/}');
    Error('\P{Block= -Old_Italic/a/}');
    Expect(1, 66351, '\p{Block=olditalic}', "");
    Expect(0, 66351, '\p{^Block=olditalic}', "");
    Expect(0, 66351, '\P{Block=olditalic}', "");
    Expect(1, 66351, '\P{^Block=olditalic}', "");
    Expect(0, 66352, '\p{Block=olditalic}', "");
    Expect(1, 66352, '\p{^Block=olditalic}', "");
    Expect(1, 66352, '\P{Block=olditalic}', "");
    Expect(0, 66352, '\P{^Block=olditalic}', "");
    Expect(1, 66351, '\p{Block= Old_ITALIC}', "");
    Expect(0, 66351, '\p{^Block= Old_ITALIC}', "");
    Expect(0, 66351, '\P{Block= Old_ITALIC}', "");
    Expect(1, 66351, '\P{^Block= Old_ITALIC}', "");
    Expect(0, 66352, '\p{Block= Old_ITALIC}', "");
    Expect(1, 66352, '\p{^Block= Old_ITALIC}', "");
    Expect(1, 66352, '\P{Block= Old_ITALIC}', "");
    Expect(0, 66352, '\P{^Block= Old_ITALIC}', "");
    Error('\p{Blk=	:=Old_Italic}');
    Error('\P{Blk=	:=Old_Italic}');
    Expect(1, 66351, '\p{Blk=olditalic}', "");
    Expect(0, 66351, '\p{^Blk=olditalic}', "");
    Expect(0, 66351, '\P{Blk=olditalic}', "");
    Expect(1, 66351, '\P{^Blk=olditalic}', "");
    Expect(0, 66352, '\p{Blk=olditalic}', "");
    Expect(1, 66352, '\p{^Blk=olditalic}', "");
    Expect(1, 66352, '\P{Blk=olditalic}', "");
    Expect(0, 66352, '\P{^Blk=olditalic}', "");
    Expect(1, 66351, '\p{Blk=	Old_italic}', "");
    Expect(0, 66351, '\p{^Blk=	Old_italic}', "");
    Expect(0, 66351, '\P{Blk=	Old_italic}', "");
    Expect(1, 66351, '\P{^Blk=	Old_italic}', "");
    Expect(0, 66352, '\p{Blk=	Old_italic}', "");
    Expect(1, 66352, '\p{^Blk=	Old_italic}', "");
    Expect(1, 66352, '\P{Blk=	Old_italic}', "");
    Expect(0, 66352, '\P{^Blk=	Old_italic}', "");
    Error('\p{Is_Block=_:=Old_ITALIC}');
    Error('\P{Is_Block=_:=Old_ITALIC}');
    Expect(1, 66351, '\p{Is_Block:	olditalic}', "");
    Expect(0, 66351, '\p{^Is_Block:	olditalic}', "");
    Expect(0, 66351, '\P{Is_Block:	olditalic}', "");
    Expect(1, 66351, '\P{^Is_Block:	olditalic}', "");
    Expect(0, 66352, '\p{Is_Block:	olditalic}', "");
    Expect(1, 66352, '\p{^Is_Block:	olditalic}', "");
    Expect(1, 66352, '\P{Is_Block:	olditalic}', "");
    Expect(0, 66352, '\P{^Is_Block:	olditalic}', "");
    Expect(1, 66351, '\p{Is_Block=_Old_Italic}', "");
    Expect(0, 66351, '\p{^Is_Block=_Old_Italic}', "");
    Expect(0, 66351, '\P{Is_Block=_Old_Italic}', "");
    Expect(1, 66351, '\P{^Is_Block=_Old_Italic}', "");
    Expect(0, 66352, '\p{Is_Block=_Old_Italic}', "");
    Expect(1, 66352, '\p{^Is_Block=_Old_Italic}', "");
    Expect(1, 66352, '\P{Is_Block=_Old_Italic}', "");
    Expect(0, 66352, '\P{^Is_Block=_Old_Italic}', "");
    Error('\p{Is_Blk=/a/OLD_Italic}');
    Error('\P{Is_Blk=/a/OLD_Italic}');
    Expect(1, 66351, '\p{Is_Blk=olditalic}', "");
    Expect(0, 66351, '\p{^Is_Blk=olditalic}', "");
    Expect(0, 66351, '\P{Is_Blk=olditalic}', "");
    Expect(1, 66351, '\P{^Is_Blk=olditalic}', "");
    Expect(0, 66352, '\p{Is_Blk=olditalic}', "");
    Expect(1, 66352, '\p{^Is_Blk=olditalic}', "");
    Expect(1, 66352, '\P{Is_Blk=olditalic}', "");
    Expect(0, 66352, '\P{^Is_Blk=olditalic}', "");
    Expect(1, 66351, '\p{Is_Blk=_OLD_Italic}', "");
    Expect(0, 66351, '\p{^Is_Blk=_OLD_Italic}', "");
    Expect(0, 66351, '\P{Is_Blk=_OLD_Italic}', "");
    Expect(1, 66351, '\P{^Is_Blk=_OLD_Italic}', "");
    Expect(0, 66352, '\p{Is_Blk=_OLD_Italic}', "");
    Expect(1, 66352, '\p{^Is_Blk=_OLD_Italic}', "");
    Expect(1, 66352, '\P{Is_Blk=_OLD_Italic}', "");
    Expect(0, 66352, '\P{^Is_Blk=_OLD_Italic}', "");
    Error('\p{Block=:=Old_north_arabian}');
    Error('\P{Block=:=Old_north_arabian}');
    Expect(1, 68255, '\p{Block=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Block=oldnortharabian}', "");
    Expect(0, 68255, '\P{Block=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Block=oldnortharabian}', "");
    Expect(0, 68256, '\p{Block=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Block=oldnortharabian}', "");
    Expect(1, 68256, '\P{Block=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Block=oldnortharabian}', "");
    Expect(1, 68255, '\p{Block=	Old_North_Arabian}', "");
    Expect(0, 68255, '\p{^Block=	Old_North_Arabian}', "");
    Expect(0, 68255, '\P{Block=	Old_North_Arabian}', "");
    Expect(1, 68255, '\P{^Block=	Old_North_Arabian}', "");
    Expect(0, 68256, '\p{Block=	Old_North_Arabian}', "");
    Expect(1, 68256, '\p{^Block=	Old_North_Arabian}', "");
    Expect(1, 68256, '\P{Block=	Old_North_Arabian}', "");
    Expect(0, 68256, '\P{^Block=	Old_North_Arabian}', "");
    Error('\p{Blk=_old_NORTH_Arabian:=}');
    Error('\P{Blk=_old_NORTH_Arabian:=}');
    Expect(1, 68255, '\p{Blk=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Blk=oldnortharabian}', "");
    Expect(0, 68255, '\P{Blk=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Blk=oldnortharabian}', "");
    Expect(0, 68256, '\p{Blk=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Blk=oldnortharabian}', "");
    Expect(1, 68256, '\P{Blk=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Blk=oldnortharabian}', "");
    Expect(1, 68255, '\p{Blk=-	old_NORTH_arabian}', "");
    Expect(0, 68255, '\p{^Blk=-	old_NORTH_arabian}', "");
    Expect(0, 68255, '\P{Blk=-	old_NORTH_arabian}', "");
    Expect(1, 68255, '\P{^Blk=-	old_NORTH_arabian}', "");
    Expect(0, 68256, '\p{Blk=-	old_NORTH_arabian}', "");
    Expect(1, 68256, '\p{^Blk=-	old_NORTH_arabian}', "");
    Expect(1, 68256, '\P{Blk=-	old_NORTH_arabian}', "");
    Expect(0, 68256, '\P{^Blk=-	old_NORTH_arabian}', "");
    Error('\p{Is_Block=/a/- OLD_North_Arabian}');
    Error('\P{Is_Block=/a/- OLD_North_Arabian}');
    Expect(1, 68255, '\p{Is_Block=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Is_Block=oldnortharabian}', "");
    Expect(0, 68255, '\P{Is_Block=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Is_Block=oldnortharabian}', "");
    Expect(0, 68256, '\p{Is_Block=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Is_Block=oldnortharabian}', "");
    Expect(1, 68256, '\P{Is_Block=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Is_Block=oldnortharabian}', "");
    Expect(1, 68255, '\p{Is_Block=_-OLD_North_Arabian}', "");
    Expect(0, 68255, '\p{^Is_Block=_-OLD_North_Arabian}', "");
    Expect(0, 68255, '\P{Is_Block=_-OLD_North_Arabian}', "");
    Expect(1, 68255, '\P{^Is_Block=_-OLD_North_Arabian}', "");
    Expect(0, 68256, '\p{Is_Block=_-OLD_North_Arabian}', "");
    Expect(1, 68256, '\p{^Is_Block=_-OLD_North_Arabian}', "");
    Expect(1, 68256, '\P{Is_Block=_-OLD_North_Arabian}', "");
    Expect(0, 68256, '\P{^Is_Block=_-OLD_North_Arabian}', "");
    Error('\p{Is_Blk=_/a/old_NORTH_ARABIAN}');
    Error('\P{Is_Blk=_/a/old_NORTH_ARABIAN}');
    Expect(1, 68255, '\p{Is_Blk=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Is_Blk=oldnortharabian}', "");
    Expect(0, 68255, '\P{Is_Blk=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Is_Blk=oldnortharabian}', "");
    Expect(0, 68256, '\p{Is_Blk=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Is_Blk=oldnortharabian}', "");
    Expect(1, 68256, '\P{Is_Blk=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Is_Blk=oldnortharabian}', "");
    Expect(1, 68255, '\p{Is_Blk=	-Old_NORTH_Arabian}', "");
    Expect(0, 68255, '\p{^Is_Blk=	-Old_NORTH_Arabian}', "");
    Expect(0, 68255, '\P{Is_Blk=	-Old_NORTH_Arabian}', "");
    Expect(1, 68255, '\P{^Is_Blk=	-Old_NORTH_Arabian}', "");
    Expect(0, 68256, '\p{Is_Blk=	-Old_NORTH_Arabian}', "");
    Expect(1, 68256, '\p{^Is_Blk=	-Old_NORTH_Arabian}', "");
    Expect(1, 68256, '\P{Is_Blk=	-Old_NORTH_Arabian}', "");
    Expect(0, 68256, '\P{^Is_Blk=	-Old_NORTH_Arabian}', "");
    Error('\p{Block=-OLD_Permic/a/}');
    Error('\P{Block=-OLD_Permic/a/}');
    Expect(1, 66431, '\p{Block=oldpermic}', "");
    Expect(0, 66431, '\p{^Block=oldpermic}', "");
    Expect(0, 66431, '\P{Block=oldpermic}', "");
    Expect(1, 66431, '\P{^Block=oldpermic}', "");
    Expect(0, 66432, '\p{Block=oldpermic}', "");
    Expect(1, 66432, '\p{^Block=oldpermic}', "");
    Expect(1, 66432, '\P{Block=oldpermic}', "");
    Expect(0, 66432, '\P{^Block=oldpermic}', "");
    Expect(1, 66431, '\p{Block=__OLD_permic}', "");
    Expect(0, 66431, '\p{^Block=__OLD_permic}', "");
    Expect(0, 66431, '\P{Block=__OLD_permic}', "");
    Expect(1, 66431, '\P{^Block=__OLD_permic}', "");
    Expect(0, 66432, '\p{Block=__OLD_permic}', "");
    Expect(1, 66432, '\p{^Block=__OLD_permic}', "");
    Expect(1, 66432, '\P{Block=__OLD_permic}', "");
    Expect(0, 66432, '\P{^Block=__OLD_permic}', "");
    Error('\p{Blk=--old_PERMIC/a/}');
    Error('\P{Blk=--old_PERMIC/a/}');
    Expect(1, 66431, '\p{Blk=oldpermic}', "");
    Expect(0, 66431, '\p{^Blk=oldpermic}', "");
    Expect(0, 66431, '\P{Blk=oldpermic}', "");
    Expect(1, 66431, '\P{^Blk=oldpermic}', "");
    Expect(0, 66432, '\p{Blk=oldpermic}', "");
    Expect(1, 66432, '\p{^Blk=oldpermic}', "");
    Expect(1, 66432, '\P{Blk=oldpermic}', "");
    Expect(0, 66432, '\P{^Blk=oldpermic}', "");
    Expect(1, 66431, '\p{Blk=_	Old_Permic}', "");
    Expect(0, 66431, '\p{^Blk=_	Old_Permic}', "");
    Expect(0, 66431, '\P{Blk=_	Old_Permic}', "");
    Expect(1, 66431, '\P{^Blk=_	Old_Permic}', "");
    Expect(0, 66432, '\p{Blk=_	Old_Permic}', "");
    Expect(1, 66432, '\p{^Blk=_	Old_Permic}', "");
    Expect(1, 66432, '\P{Blk=_	Old_Permic}', "");
    Expect(0, 66432, '\P{^Blk=_	Old_Permic}', "");
    Error('\p{Is_Block= 	Old_Permic/a/}');
    Error('\P{Is_Block= 	Old_Permic/a/}');
    Expect(1, 66431, '\p{Is_Block=oldpermic}', "");
    Expect(0, 66431, '\p{^Is_Block=oldpermic}', "");
    Expect(0, 66431, '\P{Is_Block=oldpermic}', "");
    Expect(1, 66431, '\P{^Is_Block=oldpermic}', "");
    Expect(0, 66432, '\p{Is_Block=oldpermic}', "");
    Expect(1, 66432, '\p{^Is_Block=oldpermic}', "");
    Expect(1, 66432, '\P{Is_Block=oldpermic}', "");
    Expect(0, 66432, '\P{^Is_Block=oldpermic}', "");
    Expect(1, 66431, '\p{Is_Block= Old_permic}', "");
    Expect(0, 66431, '\p{^Is_Block= Old_permic}', "");
    Expect(0, 66431, '\P{Is_Block= Old_permic}', "");
    Expect(1, 66431, '\P{^Is_Block= Old_permic}', "");
    Expect(0, 66432, '\p{Is_Block= Old_permic}', "");
    Expect(1, 66432, '\p{^Is_Block= Old_permic}', "");
    Expect(1, 66432, '\P{Is_Block= Old_permic}', "");
    Expect(0, 66432, '\P{^Is_Block= Old_permic}', "");
    Error('\p{Is_Blk=:=-_OLD_PERMIC}');
    Error('\P{Is_Blk=:=-_OLD_PERMIC}');
    Expect(1, 66431, '\p{Is_Blk=oldpermic}', "");
    Expect(0, 66431, '\p{^Is_Blk=oldpermic}', "");
    Expect(0, 66431, '\P{Is_Blk=oldpermic}', "");
    Expect(1, 66431, '\P{^Is_Blk=oldpermic}', "");
    Expect(0, 66432, '\p{Is_Blk=oldpermic}', "");
    Expect(1, 66432, '\p{^Is_Blk=oldpermic}', "");
    Expect(1, 66432, '\P{Is_Blk=oldpermic}', "");
    Expect(0, 66432, '\P{^Is_Blk=oldpermic}', "");
    Expect(1, 66431, '\p{Is_Blk= Old_PERMIC}', "");
    Expect(0, 66431, '\p{^Is_Blk= Old_PERMIC}', "");
    Expect(0, 66431, '\P{Is_Blk= Old_PERMIC}', "");
    Expect(1, 66431, '\P{^Is_Blk= Old_PERMIC}', "");
    Expect(0, 66432, '\p{Is_Blk= Old_PERMIC}', "");
    Expect(1, 66432, '\p{^Is_Blk= Old_PERMIC}', "");
    Expect(1, 66432, '\P{Is_Blk= Old_PERMIC}', "");
    Expect(0, 66432, '\P{^Is_Blk= Old_PERMIC}', "");
    Error('\p{Block= :=Old_PERSIAN}');
    Error('\P{Block= :=Old_PERSIAN}');
    Expect(1, 66527, '\p{Block=oldpersian}', "");
    Expect(0, 66527, '\p{^Block=oldpersian}', "");
    Expect(0, 66527, '\P{Block=oldpersian}', "");
    Expect(1, 66527, '\P{^Block=oldpersian}', "");
    Expect(0, 66528, '\p{Block=oldpersian}', "");
    Expect(1, 66528, '\p{^Block=oldpersian}', "");
    Expect(1, 66528, '\P{Block=oldpersian}', "");
    Expect(0, 66528, '\P{^Block=oldpersian}', "");
    Expect(1, 66527, '\p{Block=	-OLD_persian}', "");
    Expect(0, 66527, '\p{^Block=	-OLD_persian}', "");
    Expect(0, 66527, '\P{Block=	-OLD_persian}', "");
    Expect(1, 66527, '\P{^Block=	-OLD_persian}', "");
    Expect(0, 66528, '\p{Block=	-OLD_persian}', "");
    Expect(1, 66528, '\p{^Block=	-OLD_persian}', "");
    Expect(1, 66528, '\P{Block=	-OLD_persian}', "");
    Expect(0, 66528, '\P{^Block=	-OLD_persian}', "");
    Error('\p{Blk=:=- Old_PERSIAN}');
    Error('\P{Blk=:=- Old_PERSIAN}');
    Expect(1, 66527, '\p{Blk=oldpersian}', "");
    Expect(0, 66527, '\p{^Blk=oldpersian}', "");
    Expect(0, 66527, '\P{Blk=oldpersian}', "");
    Expect(1, 66527, '\P{^Blk=oldpersian}', "");
    Expect(0, 66528, '\p{Blk=oldpersian}', "");
    Expect(1, 66528, '\p{^Blk=oldpersian}', "");
    Expect(1, 66528, '\P{Blk=oldpersian}', "");
    Expect(0, 66528, '\P{^Blk=oldpersian}', "");
    Expect(1, 66527, '\p{Blk=-OLD_Persian}', "");
    Expect(0, 66527, '\p{^Blk=-OLD_Persian}', "");
    Expect(0, 66527, '\P{Blk=-OLD_Persian}', "");
    Expect(1, 66527, '\P{^Blk=-OLD_Persian}', "");
    Expect(0, 66528, '\p{Blk=-OLD_Persian}', "");
    Expect(1, 66528, '\p{^Blk=-OLD_Persian}', "");
    Expect(1, 66528, '\P{Blk=-OLD_Persian}', "");
    Expect(0, 66528, '\P{^Blk=-OLD_Persian}', "");
    Error('\p{Is_Block=	old_persian:=}');
    Error('\P{Is_Block=	old_persian:=}');
    Expect(1, 66527, '\p{Is_Block=oldpersian}', "");
    Expect(0, 66527, '\p{^Is_Block=oldpersian}', "");
    Expect(0, 66527, '\P{Is_Block=oldpersian}', "");
    Expect(1, 66527, '\P{^Is_Block=oldpersian}', "");
    Expect(0, 66528, '\p{Is_Block=oldpersian}', "");
    Expect(1, 66528, '\p{^Is_Block=oldpersian}', "");
    Expect(1, 66528, '\P{Is_Block=oldpersian}', "");
    Expect(0, 66528, '\P{^Is_Block=oldpersian}', "");
    Expect(1, 66527, '\p{Is_Block= old_Persian}', "");
    Expect(0, 66527, '\p{^Is_Block= old_Persian}', "");
    Expect(0, 66527, '\P{Is_Block= old_Persian}', "");
    Expect(1, 66527, '\P{^Is_Block= old_Persian}', "");
    Expect(0, 66528, '\p{Is_Block= old_Persian}', "");
    Expect(1, 66528, '\p{^Is_Block= old_Persian}', "");
    Expect(1, 66528, '\P{Is_Block= old_Persian}', "");
    Expect(0, 66528, '\P{^Is_Block= old_Persian}', "");
    Error('\p{Is_Blk:   -Old_Persian:=}');
    Error('\P{Is_Blk:   -Old_Persian:=}');
    Expect(1, 66527, '\p{Is_Blk=oldpersian}', "");
    Expect(0, 66527, '\p{^Is_Blk=oldpersian}', "");
    Expect(0, 66527, '\P{Is_Blk=oldpersian}', "");
    Expect(1, 66527, '\P{^Is_Blk=oldpersian}', "");
    Expect(0, 66528, '\p{Is_Blk=oldpersian}', "");
    Expect(1, 66528, '\p{^Is_Blk=oldpersian}', "");
    Expect(1, 66528, '\P{Is_Blk=oldpersian}', "");
    Expect(0, 66528, '\P{^Is_Blk=oldpersian}', "");
    Expect(1, 66527, '\p{Is_Blk= -Old_persian}', "");
    Expect(0, 66527, '\p{^Is_Blk= -Old_persian}', "");
    Expect(0, 66527, '\P{Is_Blk= -Old_persian}', "");
    Expect(1, 66527, '\P{^Is_Blk= -Old_persian}', "");
    Expect(0, 66528, '\p{Is_Blk= -Old_persian}', "");
    Expect(1, 66528, '\p{^Is_Blk= -Old_persian}', "");
    Expect(1, 66528, '\P{Is_Blk= -Old_persian}', "");
    Expect(0, 66528, '\P{^Is_Blk= -Old_persian}', "");
    Error('\p{Block:  /a/Old_South_ARABIAN}');
    Error('\P{Block:  /a/Old_South_ARABIAN}');
    Expect(1, 68223, '\p{Block=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Block=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Block=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Block=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Block=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Block=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Block=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Block=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Block=_ old_South_Arabian}', "");
    Expect(0, 68223, '\p{^Block=_ old_South_Arabian}', "");
    Expect(0, 68223, '\P{Block=_ old_South_Arabian}', "");
    Expect(1, 68223, '\P{^Block=_ old_South_Arabian}', "");
    Expect(0, 68224, '\p{Block=_ old_South_Arabian}', "");
    Expect(1, 68224, '\p{^Block=_ old_South_Arabian}', "");
    Expect(1, 68224, '\P{Block=_ old_South_Arabian}', "");
    Expect(0, 68224, '\P{^Block=_ old_South_Arabian}', "");
    Error('\p{Blk: OLD_South_arabian:=}');
    Error('\P{Blk: OLD_South_arabian:=}');
    Expect(1, 68223, '\p{Blk:   oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Blk:   oldsoutharabian}', "");
    Expect(0, 68223, '\P{Blk:   oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Blk:   oldsoutharabian}', "");
    Expect(0, 68224, '\p{Blk:   oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Blk:   oldsoutharabian}', "");
    Expect(1, 68224, '\P{Blk:   oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Blk:   oldsoutharabian}', "");
    Expect(1, 68223, '\p{Blk=	-Old_SOUTH_Arabian}', "");
    Expect(0, 68223, '\p{^Blk=	-Old_SOUTH_Arabian}', "");
    Expect(0, 68223, '\P{Blk=	-Old_SOUTH_Arabian}', "");
    Expect(1, 68223, '\P{^Blk=	-Old_SOUTH_Arabian}', "");
    Expect(0, 68224, '\p{Blk=	-Old_SOUTH_Arabian}', "");
    Expect(1, 68224, '\p{^Blk=	-Old_SOUTH_Arabian}', "");
    Expect(1, 68224, '\P{Blk=	-Old_SOUTH_Arabian}', "");
    Expect(0, 68224, '\P{^Blk=	-Old_SOUTH_Arabian}', "");
    Error('\p{Is_Block=	_Old_South_ARABIAN/a/}');
    Error('\P{Is_Block=	_Old_South_ARABIAN/a/}');
    Expect(1, 68223, '\p{Is_Block=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Is_Block=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Is_Block=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Is_Block=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Is_Block=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Is_Block=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Is_Block=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Is_Block=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Is_Block=	OLD_south_Arabian}', "");
    Expect(0, 68223, '\p{^Is_Block=	OLD_south_Arabian}', "");
    Expect(0, 68223, '\P{Is_Block=	OLD_south_Arabian}', "");
    Expect(1, 68223, '\P{^Is_Block=	OLD_south_Arabian}', "");
    Expect(0, 68224, '\p{Is_Block=	OLD_south_Arabian}', "");
    Expect(1, 68224, '\p{^Is_Block=	OLD_south_Arabian}', "");
    Expect(1, 68224, '\P{Is_Block=	OLD_south_Arabian}', "");
    Expect(0, 68224, '\P{^Is_Block=	OLD_south_Arabian}', "");
    Error('\p{Is_Blk=_:=OLD_south_arabian}');
    Error('\P{Is_Blk=_:=OLD_south_arabian}');
    Expect(1, 68223, '\p{Is_Blk=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Is_Blk=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Is_Blk=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Is_Blk=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Is_Blk=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Is_Blk=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Is_Blk=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Is_Blk=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Is_Blk:    -Old_south_Arabian}', "");
    Expect(0, 68223, '\p{^Is_Blk:    -Old_south_Arabian}', "");
    Expect(0, 68223, '\P{Is_Blk:    -Old_south_Arabian}', "");
    Expect(1, 68223, '\P{^Is_Blk:    -Old_south_Arabian}', "");
    Expect(0, 68224, '\p{Is_Blk:    -Old_south_Arabian}', "");
    Expect(1, 68224, '\p{^Is_Blk:    -Old_south_Arabian}', "");
    Expect(1, 68224, '\P{Is_Blk:    -Old_south_Arabian}', "");
    Expect(0, 68224, '\P{^Is_Blk:    -Old_south_Arabian}', "");
    Error('\p{Block=__Old_TURKIC/a/}');
    Error('\P{Block=__Old_TURKIC/a/}');
    Expect(1, 68687, '\p{Block=oldturkic}', "");
    Expect(0, 68687, '\p{^Block=oldturkic}', "");
    Expect(0, 68687, '\P{Block=oldturkic}', "");
    Expect(1, 68687, '\P{^Block=oldturkic}', "");
    Expect(0, 68688, '\p{Block=oldturkic}', "");
    Expect(1, 68688, '\p{^Block=oldturkic}', "");
    Expect(1, 68688, '\P{Block=oldturkic}', "");
    Expect(0, 68688, '\P{^Block=oldturkic}', "");
    Expect(1, 68687, '\p{Block=	OLD_TURKIC}', "");
    Expect(0, 68687, '\p{^Block=	OLD_TURKIC}', "");
    Expect(0, 68687, '\P{Block=	OLD_TURKIC}', "");
    Expect(1, 68687, '\P{^Block=	OLD_TURKIC}', "");
    Expect(0, 68688, '\p{Block=	OLD_TURKIC}', "");
    Expect(1, 68688, '\p{^Block=	OLD_TURKIC}', "");
    Expect(1, 68688, '\P{Block=	OLD_TURKIC}', "");
    Expect(0, 68688, '\P{^Block=	OLD_TURKIC}', "");
    Error('\p{Blk=_:=OLD_Turkic}');
    Error('\P{Blk=_:=OLD_Turkic}');
    Expect(1, 68687, '\p{Blk:   oldturkic}', "");
    Expect(0, 68687, '\p{^Blk:   oldturkic}', "");
    Expect(0, 68687, '\P{Blk:   oldturkic}', "");
    Expect(1, 68687, '\P{^Blk:   oldturkic}', "");
    Expect(0, 68688, '\p{Blk:   oldturkic}', "");
    Expect(1, 68688, '\p{^Blk:   oldturkic}', "");
    Expect(1, 68688, '\P{Blk:   oldturkic}', "");
    Expect(0, 68688, '\P{^Blk:   oldturkic}', "");
    Expect(1, 68687, '\p{Blk=	 Old_Turkic}', "");
    Expect(0, 68687, '\p{^Blk=	 Old_Turkic}', "");
    Expect(0, 68687, '\P{Blk=	 Old_Turkic}', "");
    Expect(1, 68687, '\P{^Blk=	 Old_Turkic}', "");
    Expect(0, 68688, '\p{Blk=	 Old_Turkic}', "");
    Expect(1, 68688, '\p{^Blk=	 Old_Turkic}', "");
    Expect(1, 68688, '\P{Blk=	 Old_Turkic}', "");
    Expect(0, 68688, '\P{^Blk=	 Old_Turkic}', "");
    Error('\p{Is_Block=/a/	 old_Turkic}');
    Error('\P{Is_Block=/a/	 old_Turkic}');
    Expect(1, 68687, '\p{Is_Block=oldturkic}', "");
    Expect(0, 68687, '\p{^Is_Block=oldturkic}', "");
    Expect(0, 68687, '\P{Is_Block=oldturkic}', "");
    Expect(1, 68687, '\P{^Is_Block=oldturkic}', "");
    Expect(0, 68688, '\p{Is_Block=oldturkic}', "");
    Expect(1, 68688, '\p{^Is_Block=oldturkic}', "");
    Expect(1, 68688, '\P{Is_Block=oldturkic}', "");
    Expect(0, 68688, '\P{^Is_Block=oldturkic}', "");
    Expect(1, 68687, '\p{Is_Block=Old_TURKIC}', "");
    Expect(0, 68687, '\p{^Is_Block=Old_TURKIC}', "");
    Expect(0, 68687, '\P{Is_Block=Old_TURKIC}', "");
    Expect(1, 68687, '\P{^Is_Block=Old_TURKIC}', "");
    Expect(0, 68688, '\p{Is_Block=Old_TURKIC}', "");
    Expect(1, 68688, '\p{^Is_Block=Old_TURKIC}', "");
    Expect(1, 68688, '\P{Is_Block=Old_TURKIC}', "");
    Expect(0, 68688, '\P{^Is_Block=Old_TURKIC}', "");
    Error('\p{Is_Blk= Old_Turkic/a/}');
    Error('\P{Is_Blk= Old_Turkic/a/}');
    Expect(1, 68687, '\p{Is_Blk=oldturkic}', "");
    Expect(0, 68687, '\p{^Is_Blk=oldturkic}', "");
    Expect(0, 68687, '\P{Is_Blk=oldturkic}', "");
    Expect(1, 68687, '\P{^Is_Blk=oldturkic}', "");
    Expect(0, 68688, '\p{Is_Blk=oldturkic}', "");
    Expect(1, 68688, '\p{^Is_Blk=oldturkic}', "");
    Expect(1, 68688, '\P{Is_Blk=oldturkic}', "");
    Expect(0, 68688, '\P{^Is_Blk=oldturkic}', "");
    Expect(1, 68687, '\p{Is_Blk=_	old_TURKIC}', "");
    Expect(0, 68687, '\p{^Is_Blk=_	old_TURKIC}', "");
    Expect(0, 68687, '\P{Is_Blk=_	old_TURKIC}', "");
    Expect(1, 68687, '\P{^Is_Blk=_	old_TURKIC}', "");
    Expect(0, 68688, '\p{Is_Blk=_	old_TURKIC}', "");
    Expect(1, 68688, '\p{^Is_Blk=_	old_TURKIC}', "");
    Expect(1, 68688, '\P{Is_Blk=_	old_TURKIC}', "");
    Expect(0, 68688, '\P{^Is_Blk=_	old_TURKIC}', "");
    Error('\p{Block=- ORIYA:=}');
    Error('\P{Block=- ORIYA:=}');
    Expect(1, 2943, '\p{Block=oriya}', "");
    Expect(0, 2943, '\p{^Block=oriya}', "");
    Expect(0, 2943, '\P{Block=oriya}', "");
    Expect(1, 2943, '\P{^Block=oriya}', "");
    Expect(0, 2944, '\p{Block=oriya}', "");
    Expect(1, 2944, '\p{^Block=oriya}', "");
    Expect(1, 2944, '\P{Block=oriya}', "");
    Expect(0, 2944, '\P{^Block=oriya}', "");
    Expect(1, 2943, '\p{Block=_	oriya}', "");
    Expect(0, 2943, '\p{^Block=_	oriya}', "");
    Expect(0, 2943, '\P{Block=_	oriya}', "");
    Expect(1, 2943, '\P{^Block=_	oriya}', "");
    Expect(0, 2944, '\p{Block=_	oriya}', "");
    Expect(1, 2944, '\p{^Block=_	oriya}', "");
    Expect(1, 2944, '\P{Block=_	oriya}', "");
    Expect(0, 2944, '\P{^Block=_	oriya}', "");
    Error('\p{Blk=	/a/Oriya}');
    Error('\P{Blk=	/a/Oriya}');
    Expect(1, 2943, '\p{Blk=oriya}', "");
    Expect(0, 2943, '\p{^Blk=oriya}', "");
    Expect(0, 2943, '\P{Blk=oriya}', "");
    Expect(1, 2943, '\P{^Blk=oriya}', "");
    Expect(0, 2944, '\p{Blk=oriya}', "");
    Expect(1, 2944, '\p{^Blk=oriya}', "");
    Expect(1, 2944, '\P{Blk=oriya}', "");
    Expect(0, 2944, '\P{^Blk=oriya}', "");
    Expect(1, 2943, '\p{Blk= -Oriya}', "");
    Expect(0, 2943, '\p{^Blk= -Oriya}', "");
    Expect(0, 2943, '\P{Blk= -Oriya}', "");
    Expect(1, 2943, '\P{^Blk= -Oriya}', "");
    Expect(0, 2944, '\p{Blk= -Oriya}', "");
    Expect(1, 2944, '\p{^Blk= -Oriya}', "");
    Expect(1, 2944, '\P{Blk= -Oriya}', "");
    Expect(0, 2944, '\P{^Blk= -Oriya}', "");
    Error('\p{Is_Block=	:=Oriya}');
    Error('\P{Is_Block=	:=Oriya}');
    Expect(1, 2943, '\p{Is_Block=oriya}', "");
    Expect(0, 2943, '\p{^Is_Block=oriya}', "");
    Expect(0, 2943, '\P{Is_Block=oriya}', "");
    Expect(1, 2943, '\P{^Is_Block=oriya}', "");
    Expect(0, 2944, '\p{Is_Block=oriya}', "");
    Expect(1, 2944, '\p{^Is_Block=oriya}', "");
    Expect(1, 2944, '\P{Is_Block=oriya}', "");
    Expect(0, 2944, '\P{^Is_Block=oriya}', "");
    Expect(1, 2943, '\p{Is_Block= 	oriya}', "");
    Expect(0, 2943, '\p{^Is_Block= 	oriya}', "");
    Expect(0, 2943, '\P{Is_Block= 	oriya}', "");
    Expect(1, 2943, '\P{^Is_Block= 	oriya}', "");
    Expect(0, 2944, '\p{Is_Block= 	oriya}', "");
    Expect(1, 2944, '\p{^Is_Block= 	oriya}', "");
    Expect(1, 2944, '\P{Is_Block= 	oriya}', "");
    Expect(0, 2944, '\P{^Is_Block= 	oriya}', "");
    Error('\p{Is_Blk=-_ORIYA/a/}');
    Error('\P{Is_Blk=-_ORIYA/a/}');
    Expect(1, 2943, '\p{Is_Blk=oriya}', "");
    Expect(0, 2943, '\p{^Is_Blk=oriya}', "");
    Expect(0, 2943, '\P{Is_Blk=oriya}', "");
    Expect(1, 2943, '\P{^Is_Blk=oriya}', "");
    Expect(0, 2944, '\p{Is_Blk=oriya}', "");
    Expect(1, 2944, '\p{^Is_Blk=oriya}', "");
    Expect(1, 2944, '\P{Is_Blk=oriya}', "");
    Expect(0, 2944, '\P{^Is_Blk=oriya}', "");
    Expect(1, 2943, '\p{Is_Blk= 	oriya}', "");
    Expect(0, 2943, '\p{^Is_Blk= 	oriya}', "");
    Expect(0, 2943, '\P{Is_Blk= 	oriya}', "");
    Expect(1, 2943, '\P{^Is_Blk= 	oriya}', "");
    Expect(0, 2944, '\p{Is_Blk= 	oriya}', "");
    Expect(1, 2944, '\p{^Is_Blk= 	oriya}', "");
    Expect(1, 2944, '\P{Is_Blk= 	oriya}', "");
    Expect(0, 2944, '\P{^Is_Blk= 	oriya}', "");
    Error('\p{Block: :=	 Ornamental_dingbats}');
    Error('\P{Block: :=	 Ornamental_dingbats}');
    Expect(1, 128639, '\p{Block=ornamentaldingbats}', "");
    Expect(0, 128639, '\p{^Block=ornamentaldingbats}', "");
    Expect(0, 128639, '\P{Block=ornamentaldingbats}', "");
    Expect(1, 128639, '\P{^Block=ornamentaldingbats}', "");
    Expect(0, 128640, '\p{Block=ornamentaldingbats}', "");
    Expect(1, 128640, '\p{^Block=ornamentaldingbats}', "");
    Expect(1, 128640, '\P{Block=ornamentaldingbats}', "");
    Expect(0, 128640, '\P{^Block=ornamentaldingbats}', "");
    Expect(1, 128639, '\p{Block=	-Ornamental_Dingbats}', "");
    Expect(0, 128639, '\p{^Block=	-Ornamental_Dingbats}', "");
    Expect(0, 128639, '\P{Block=	-Ornamental_Dingbats}', "");
    Expect(1, 128639, '\P{^Block=	-Ornamental_Dingbats}', "");
    Expect(0, 128640, '\p{Block=	-Ornamental_Dingbats}', "");
    Expect(1, 128640, '\p{^Block=	-Ornamental_Dingbats}', "");
    Expect(1, 128640, '\P{Block=	-Ornamental_Dingbats}', "");
    Expect(0, 128640, '\P{^Block=	-Ornamental_Dingbats}', "");
    Error('\p{Blk=-ORNAMENTAL_dingbats/a/}');
    Error('\P{Blk=-ORNAMENTAL_dingbats/a/}');
    Expect(1, 128639, '\p{Blk=ornamentaldingbats}', "");
    Expect(0, 128639, '\p{^Blk=ornamentaldingbats}', "");
    Expect(0, 128639, '\P{Blk=ornamentaldingbats}', "");
    Expect(1, 128639, '\P{^Blk=ornamentaldingbats}', "");
    Expect(0, 128640, '\p{Blk=ornamentaldingbats}', "");
    Expect(1, 128640, '\p{^Blk=ornamentaldingbats}', "");
    Expect(1, 128640, '\P{Blk=ornamentaldingbats}', "");
    Expect(0, 128640, '\P{^Blk=ornamentaldingbats}', "");
    Expect(1, 128639, '\p{Blk=		ornamental_DINGBATS}', "");
    Expect(0, 128639, '\p{^Blk=		ornamental_DINGBATS}', "");
    Expect(0, 128639, '\P{Blk=		ornamental_DINGBATS}', "");
    Expect(1, 128639, '\P{^Blk=		ornamental_DINGBATS}', "");
    Expect(0, 128640, '\p{Blk=		ornamental_DINGBATS}', "");
    Expect(1, 128640, '\p{^Blk=		ornamental_DINGBATS}', "");
    Expect(1, 128640, '\P{Blk=		ornamental_DINGBATS}', "");
    Expect(0, 128640, '\P{^Blk=		ornamental_DINGBATS}', "");
    Error('\p{Is_Block=:=-_Ornamental_Dingbats}');
    Error('\P{Is_Block=:=-_Ornamental_Dingbats}');
    Expect(1, 128639, '\p{Is_Block=ornamentaldingbats}', "");
    Expect(0, 128639, '\p{^Is_Block=ornamentaldingbats}', "");
    Expect(0, 128639, '\P{Is_Block=ornamentaldingbats}', "");
    Expect(1, 128639, '\P{^Is_Block=ornamentaldingbats}', "");
    Expect(0, 128640, '\p{Is_Block=ornamentaldingbats}', "");
    Expect(1, 128640, '\p{^Is_Block=ornamentaldingbats}', "");
    Expect(1, 128640, '\P{Is_Block=ornamentaldingbats}', "");
    Expect(0, 128640, '\P{^Is_Block=ornamentaldingbats}', "");
    Expect(1, 128639, '\p{Is_Block=Ornamental_Dingbats}', "");
    Expect(0, 128639, '\p{^Is_Block=Ornamental_Dingbats}', "");
    Expect(0, 128639, '\P{Is_Block=Ornamental_Dingbats}', "");
    Expect(1, 128639, '\P{^Is_Block=Ornamental_Dingbats}', "");
    Expect(0, 128640, '\p{Is_Block=Ornamental_Dingbats}', "");
    Expect(1, 128640, '\p{^Is_Block=Ornamental_Dingbats}', "");
    Expect(1, 128640, '\P{Is_Block=Ornamental_Dingbats}', "");
    Expect(0, 128640, '\P{^Is_Block=Ornamental_Dingbats}', "");
    Error('\p{Is_Blk=/a/--ORNAMENTAL_Dingbats}');
    Error('\P{Is_Blk=/a/--ORNAMENTAL_Dingbats}');
    Expect(1, 128639, '\p{Is_Blk=ornamentaldingbats}', "");
    Expect(0, 128639, '\p{^Is_Blk=ornamentaldingbats}', "");
    Expect(0, 128639, '\P{Is_Blk=ornamentaldingbats}', "");
    Expect(1, 128639, '\P{^Is_Blk=ornamentaldingbats}', "");
    Expect(0, 128640, '\p{Is_Blk=ornamentaldingbats}', "");
    Expect(1, 128640, '\p{^Is_Blk=ornamentaldingbats}', "");
    Expect(1, 128640, '\P{Is_Blk=ornamentaldingbats}', "");
    Expect(0, 128640, '\P{^Is_Blk=ornamentaldingbats}', "");
    Expect(1, 128639, '\p{Is_Blk=_	Ornamental_Dingbats}', "");
    Expect(0, 128639, '\p{^Is_Blk=_	Ornamental_Dingbats}', "");
    Expect(0, 128639, '\P{Is_Blk=_	Ornamental_Dingbats}', "");
    Expect(1, 128639, '\P{^Is_Blk=_	Ornamental_Dingbats}', "");
    Expect(0, 128640, '\p{Is_Blk=_	Ornamental_Dingbats}', "");
    Expect(1, 128640, '\p{^Is_Blk=_	Ornamental_Dingbats}', "");
    Expect(1, 128640, '\P{Is_Blk=_	Ornamental_Dingbats}', "");
    Expect(0, 128640, '\P{^Is_Blk=_	Ornamental_Dingbats}', "");
    Error('\p{Block=:=Osage}');
    Error('\P{Block=:=Osage}');
    Expect(1, 66815, '\p{Block=osage}', "");
    Expect(0, 66815, '\p{^Block=osage}', "");
    Expect(0, 66815, '\P{Block=osage}', "");
    Expect(1, 66815, '\P{^Block=osage}', "");
    Expect(0, 66816, '\p{Block=osage}', "");
    Expect(1, 66816, '\p{^Block=osage}', "");
    Expect(1, 66816, '\P{Block=osage}', "");
    Expect(0, 66816, '\P{^Block=osage}', "");
    Expect(1, 66815, '\p{Block:	_OSAGE}', "");
    Expect(0, 66815, '\p{^Block:	_OSAGE}', "");
    Expect(0, 66815, '\P{Block:	_OSAGE}', "");
    Expect(1, 66815, '\P{^Block:	_OSAGE}', "");
    Expect(0, 66816, '\p{Block:	_OSAGE}', "");
    Expect(1, 66816, '\p{^Block:	_OSAGE}', "");
    Expect(1, 66816, '\P{Block:	_OSAGE}', "");
    Expect(0, 66816, '\P{^Block:	_OSAGE}', "");
    Error('\p{Blk: :=-	osage}');
    Error('\P{Blk: :=-	osage}');
    Expect(1, 66815, '\p{Blk=osage}', "");
    Expect(0, 66815, '\p{^Blk=osage}', "");
    Expect(0, 66815, '\P{Blk=osage}', "");
    Expect(1, 66815, '\P{^Blk=osage}', "");
    Expect(0, 66816, '\p{Blk=osage}', "");
    Expect(1, 66816, '\p{^Blk=osage}', "");
    Expect(1, 66816, '\P{Blk=osage}', "");
    Expect(0, 66816, '\P{^Blk=osage}', "");
    Expect(1, 66815, '\p{Blk=__OSAGE}', "");
    Expect(0, 66815, '\p{^Blk=__OSAGE}', "");
    Expect(0, 66815, '\P{Blk=__OSAGE}', "");
    Expect(1, 66815, '\P{^Blk=__OSAGE}', "");
    Expect(0, 66816, '\p{Blk=__OSAGE}', "");
    Expect(1, 66816, '\p{^Blk=__OSAGE}', "");
    Expect(1, 66816, '\P{Blk=__OSAGE}', "");
    Expect(0, 66816, '\P{^Blk=__OSAGE}', "");
    Error('\p{Is_Block=:=Osage}');
    Error('\P{Is_Block=:=Osage}');
    Expect(1, 66815, '\p{Is_Block=osage}', "");
    Expect(0, 66815, '\p{^Is_Block=osage}', "");
    Expect(0, 66815, '\P{Is_Block=osage}', "");
    Expect(1, 66815, '\P{^Is_Block=osage}', "");
    Expect(0, 66816, '\p{Is_Block=osage}', "");
    Expect(1, 66816, '\p{^Is_Block=osage}', "");
    Expect(1, 66816, '\P{Is_Block=osage}', "");
    Expect(0, 66816, '\P{^Is_Block=osage}', "");
    Expect(1, 66815, '\p{Is_Block=-OSAGE}', "");
    Expect(0, 66815, '\p{^Is_Block=-OSAGE}', "");
    Expect(0, 66815, '\P{Is_Block=-OSAGE}', "");
    Expect(1, 66815, '\P{^Is_Block=-OSAGE}', "");
    Expect(0, 66816, '\p{Is_Block=-OSAGE}', "");
    Expect(1, 66816, '\p{^Is_Block=-OSAGE}', "");
    Expect(1, 66816, '\P{Is_Block=-OSAGE}', "");
    Expect(0, 66816, '\P{^Is_Block=-OSAGE}', "");
    Error('\p{Is_Blk:    :=OSAGE}');
    Error('\P{Is_Blk:    :=OSAGE}');
    Expect(1, 66815, '\p{Is_Blk=osage}', "");
    Expect(0, 66815, '\p{^Is_Blk=osage}', "");
    Expect(0, 66815, '\P{Is_Blk=osage}', "");
    Expect(1, 66815, '\P{^Is_Blk=osage}', "");
    Expect(0, 66816, '\p{Is_Blk=osage}', "");
    Expect(1, 66816, '\p{^Is_Blk=osage}', "");
    Expect(1, 66816, '\P{Is_Blk=osage}', "");
    Expect(0, 66816, '\P{^Is_Blk=osage}', "");
    Expect(1, 66815, '\p{Is_Blk=- OSAGE}', "");
    Expect(0, 66815, '\p{^Is_Blk=- OSAGE}', "");
    Expect(0, 66815, '\P{Is_Blk=- OSAGE}', "");
    Expect(1, 66815, '\P{^Is_Blk=- OSAGE}', "");
    Expect(0, 66816, '\p{Is_Blk=- OSAGE}', "");
    Expect(1, 66816, '\p{^Is_Blk=- OSAGE}', "");
    Expect(1, 66816, '\P{Is_Blk=- OSAGE}', "");
    Expect(0, 66816, '\P{^Is_Blk=- OSAGE}', "");
    Error('\p{Block=/a/_osmanya}');
    Error('\P{Block=/a/_osmanya}');
    Expect(1, 66735, '\p{Block=osmanya}', "");
    Expect(0, 66735, '\p{^Block=osmanya}', "");
    Expect(0, 66735, '\P{Block=osmanya}', "");
    Expect(1, 66735, '\P{^Block=osmanya}', "");
    Expect(0, 66736, '\p{Block=osmanya}', "");
    Expect(1, 66736, '\p{^Block=osmanya}', "");
    Expect(1, 66736, '\P{Block=osmanya}', "");
    Expect(0, 66736, '\P{^Block=osmanya}', "");
    Expect(1, 66735, '\p{Block=_-Osmanya}', "");
    Expect(0, 66735, '\p{^Block=_-Osmanya}', "");
    Expect(0, 66735, '\P{Block=_-Osmanya}', "");
    Expect(1, 66735, '\P{^Block=_-Osmanya}', "");
    Expect(0, 66736, '\p{Block=_-Osmanya}', "");
    Expect(1, 66736, '\p{^Block=_-Osmanya}', "");
    Expect(1, 66736, '\P{Block=_-Osmanya}', "");
    Expect(0, 66736, '\P{^Block=_-Osmanya}', "");
    Error('\p{Blk:_:=OSMANYA}');
    Error('\P{Blk:_:=OSMANYA}');
    Expect(1, 66735, '\p{Blk=osmanya}', "");
    Expect(0, 66735, '\p{^Blk=osmanya}', "");
    Expect(0, 66735, '\P{Blk=osmanya}', "");
    Expect(1, 66735, '\P{^Blk=osmanya}', "");
    Expect(0, 66736, '\p{Blk=osmanya}', "");
    Expect(1, 66736, '\p{^Blk=osmanya}', "");
    Expect(1, 66736, '\P{Blk=osmanya}', "");
    Expect(0, 66736, '\P{^Blk=osmanya}', "");
    Expect(1, 66735, '\p{Blk=__Osmanya}', "");
    Expect(0, 66735, '\p{^Blk=__Osmanya}', "");
    Expect(0, 66735, '\P{Blk=__Osmanya}', "");
    Expect(1, 66735, '\P{^Blk=__Osmanya}', "");
    Expect(0, 66736, '\p{Blk=__Osmanya}', "");
    Expect(1, 66736, '\p{^Blk=__Osmanya}', "");
    Expect(1, 66736, '\P{Blk=__Osmanya}', "");
    Expect(0, 66736, '\P{^Blk=__Osmanya}', "");
    Error('\p{Is_Block=-osmanya:=}');
    Error('\P{Is_Block=-osmanya:=}');
    Expect(1, 66735, '\p{Is_Block=osmanya}', "");
    Expect(0, 66735, '\p{^Is_Block=osmanya}', "");
    Expect(0, 66735, '\P{Is_Block=osmanya}', "");
    Expect(1, 66735, '\P{^Is_Block=osmanya}', "");
    Expect(0, 66736, '\p{Is_Block=osmanya}', "");
    Expect(1, 66736, '\p{^Is_Block=osmanya}', "");
    Expect(1, 66736, '\P{Is_Block=osmanya}', "");
    Expect(0, 66736, '\P{^Is_Block=osmanya}', "");
    Expect(1, 66735, '\p{Is_Block= 	osmanya}', "");
    Expect(0, 66735, '\p{^Is_Block= 	osmanya}', "");
    Expect(0, 66735, '\P{Is_Block= 	osmanya}', "");
    Expect(1, 66735, '\P{^Is_Block= 	osmanya}', "");
    Expect(0, 66736, '\p{Is_Block= 	osmanya}', "");
    Expect(1, 66736, '\p{^Is_Block= 	osmanya}', "");
    Expect(1, 66736, '\P{Is_Block= 	osmanya}', "");
    Expect(0, 66736, '\P{^Is_Block= 	osmanya}', "");
    Error('\p{Is_Blk=:=- Osmanya}');
    Error('\P{Is_Blk=:=- Osmanya}');
    Expect(1, 66735, '\p{Is_Blk:	osmanya}', "");
    Expect(0, 66735, '\p{^Is_Blk:	osmanya}', "");
    Expect(0, 66735, '\P{Is_Blk:	osmanya}', "");
    Expect(1, 66735, '\P{^Is_Blk:	osmanya}', "");
    Expect(0, 66736, '\p{Is_Blk:	osmanya}', "");
    Expect(1, 66736, '\p{^Is_Blk:	osmanya}', "");
    Expect(1, 66736, '\P{Is_Blk:	osmanya}', "");
    Expect(0, 66736, '\P{^Is_Blk:	osmanya}', "");
    Expect(1, 66735, '\p{Is_Blk=	OSMANYA}', "");
    Expect(0, 66735, '\p{^Is_Blk=	OSMANYA}', "");
    Expect(0, 66735, '\P{Is_Blk=	OSMANYA}', "");
    Expect(1, 66735, '\P{^Is_Blk=	OSMANYA}', "");
    Expect(0, 66736, '\p{Is_Blk=	OSMANYA}', "");
    Expect(1, 66736, '\p{^Is_Blk=	OSMANYA}', "");
    Expect(1, 66736, '\P{Is_Blk=	OSMANYA}', "");
    Expect(0, 66736, '\P{^Is_Blk=	OSMANYA}', "");
    Error('\p{Block:_pahawh_Hmong/a/}');
    Error('\P{Block:_pahawh_Hmong/a/}');
    Expect(1, 93071, '\p{Block=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Block=pahawhhmong}', "");
    Expect(0, 93071, '\P{Block=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Block=pahawhhmong}', "");
    Expect(0, 93072, '\p{Block=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Block=pahawhhmong}', "");
    Expect(1, 93072, '\P{Block=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Block=pahawhhmong}', "");
    Expect(1, 93071, '\p{Block=--pahawh_Hmong}', "");
    Expect(0, 93071, '\p{^Block=--pahawh_Hmong}', "");
    Expect(0, 93071, '\P{Block=--pahawh_Hmong}', "");
    Expect(1, 93071, '\P{^Block=--pahawh_Hmong}', "");
    Expect(0, 93072, '\p{Block=--pahawh_Hmong}', "");
    Expect(1, 93072, '\p{^Block=--pahawh_Hmong}', "");
    Expect(1, 93072, '\P{Block=--pahawh_Hmong}', "");
    Expect(0, 93072, '\P{^Block=--pahawh_Hmong}', "");
    Error('\p{Blk= /a/PAHAWH_HMONG}');
    Error('\P{Blk= /a/PAHAWH_HMONG}');
    Expect(1, 93071, '\p{Blk=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Blk=pahawhhmong}', "");
    Expect(0, 93071, '\P{Blk=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Blk=pahawhhmong}', "");
    Expect(0, 93072, '\p{Blk=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Blk=pahawhhmong}', "");
    Expect(1, 93072, '\P{Blk=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Blk=pahawhhmong}', "");
    Expect(1, 93071, '\p{Blk: - PAHAWH_hmong}', "");
    Expect(0, 93071, '\p{^Blk: - PAHAWH_hmong}', "");
    Expect(0, 93071, '\P{Blk: - PAHAWH_hmong}', "");
    Expect(1, 93071, '\P{^Blk: - PAHAWH_hmong}', "");
    Expect(0, 93072, '\p{Blk: - PAHAWH_hmong}', "");
    Expect(1, 93072, '\p{^Blk: - PAHAWH_hmong}', "");
    Expect(1, 93072, '\P{Blk: - PAHAWH_hmong}', "");
    Expect(0, 93072, '\P{^Blk: - PAHAWH_hmong}', "");
    Error('\p{Is_Block=:=	 Pahawh_Hmong}');
    Error('\P{Is_Block=:=	 Pahawh_Hmong}');
    Expect(1, 93071, '\p{Is_Block=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Is_Block=pahawhhmong}', "");
    Expect(0, 93071, '\P{Is_Block=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Is_Block=pahawhhmong}', "");
    Expect(0, 93072, '\p{Is_Block=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Is_Block=pahawhhmong}', "");
    Expect(1, 93072, '\P{Is_Block=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Is_Block=pahawhhmong}', "");
    Expect(1, 93071, '\p{Is_Block=_Pahawh_hmong}', "");
    Expect(0, 93071, '\p{^Is_Block=_Pahawh_hmong}', "");
    Expect(0, 93071, '\P{Is_Block=_Pahawh_hmong}', "");
    Expect(1, 93071, '\P{^Is_Block=_Pahawh_hmong}', "");
    Expect(0, 93072, '\p{Is_Block=_Pahawh_hmong}', "");
    Expect(1, 93072, '\p{^Is_Block=_Pahawh_hmong}', "");
    Expect(1, 93072, '\P{Is_Block=_Pahawh_hmong}', "");
    Expect(0, 93072, '\P{^Is_Block=_Pahawh_hmong}', "");
    Error('\p{Is_Blk=		PAHAWH_Hmong:=}');
    Error('\P{Is_Blk=		PAHAWH_Hmong:=}');
    Expect(1, 93071, '\p{Is_Blk=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Is_Blk=pahawhhmong}', "");
    Expect(0, 93071, '\P{Is_Blk=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Is_Blk=pahawhhmong}', "");
    Expect(0, 93072, '\p{Is_Blk=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Is_Blk=pahawhhmong}', "");
    Expect(1, 93072, '\P{Is_Blk=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Is_Blk=pahawhhmong}', "");
    Expect(1, 93071, '\p{Is_Blk=		pahawh_HMONG}', "");
    Expect(0, 93071, '\p{^Is_Blk=		pahawh_HMONG}', "");
    Expect(0, 93071, '\P{Is_Blk=		pahawh_HMONG}', "");
    Expect(1, 93071, '\P{^Is_Blk=		pahawh_HMONG}', "");
    Expect(0, 93072, '\p{Is_Blk=		pahawh_HMONG}', "");
    Expect(1, 93072, '\p{^Is_Blk=		pahawh_HMONG}', "");
    Expect(1, 93072, '\P{Is_Blk=		pahawh_HMONG}', "");
    Expect(0, 93072, '\P{^Is_Blk=		pahawh_HMONG}', "");
    Error('\p{Block=	Palmyrene/a/}');
    Error('\P{Block=	Palmyrene/a/}');
    Expect(1, 67711, '\p{Block:   palmyrene}', "");
    Expect(0, 67711, '\p{^Block:   palmyrene}', "");
    Expect(0, 67711, '\P{Block:   palmyrene}', "");
    Expect(1, 67711, '\P{^Block:   palmyrene}', "");
    Expect(0, 67712, '\p{Block:   palmyrene}', "");
    Expect(1, 67712, '\p{^Block:   palmyrene}', "");
    Expect(1, 67712, '\P{Block:   palmyrene}', "");
    Expect(0, 67712, '\P{^Block:   palmyrene}', "");
    Expect(1, 67711, '\p{Block: 	 Palmyrene}', "");
    Expect(0, 67711, '\p{^Block: 	 Palmyrene}', "");
    Expect(0, 67711, '\P{Block: 	 Palmyrene}', "");
    Expect(1, 67711, '\P{^Block: 	 Palmyrene}', "");
    Expect(0, 67712, '\p{Block: 	 Palmyrene}', "");
    Expect(1, 67712, '\p{^Block: 	 Palmyrene}', "");
    Expect(1, 67712, '\P{Block: 	 Palmyrene}', "");
    Expect(0, 67712, '\P{^Block: 	 Palmyrene}', "");
    Error('\p{Blk=-/a/Palmyrene}');
    Error('\P{Blk=-/a/Palmyrene}');
    Expect(1, 67711, '\p{Blk: palmyrene}', "");
    Expect(0, 67711, '\p{^Blk: palmyrene}', "");
    Expect(0, 67711, '\P{Blk: palmyrene}', "");
    Expect(1, 67711, '\P{^Blk: palmyrene}', "");
    Expect(0, 67712, '\p{Blk: palmyrene}', "");
    Expect(1, 67712, '\p{^Blk: palmyrene}', "");
    Expect(1, 67712, '\P{Blk: palmyrene}', "");
    Expect(0, 67712, '\P{^Blk: palmyrene}', "");
    Expect(1, 67711, '\p{Blk=-_Palmyrene}', "");
    Expect(0, 67711, '\p{^Blk=-_Palmyrene}', "");
    Expect(0, 67711, '\P{Blk=-_Palmyrene}', "");
    Expect(1, 67711, '\P{^Blk=-_Palmyrene}', "");
    Expect(0, 67712, '\p{Blk=-_Palmyrene}', "");
    Expect(1, 67712, '\p{^Blk=-_Palmyrene}', "");
    Expect(1, 67712, '\P{Blk=-_Palmyrene}', "");
    Expect(0, 67712, '\P{^Blk=-_Palmyrene}', "");
    Error('\p{Is_Block=__Palmyrene/a/}');
    Error('\P{Is_Block=__Palmyrene/a/}');
    Expect(1, 67711, '\p{Is_Block=palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Block=palmyrene}', "");
    Expect(0, 67711, '\P{Is_Block=palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Block=palmyrene}', "");
    Expect(0, 67712, '\p{Is_Block=palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Block=palmyrene}', "");
    Expect(1, 67712, '\P{Is_Block=palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Block=palmyrene}', "");
    Expect(1, 67711, '\p{Is_Block=_ Palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Block=_ Palmyrene}', "");
    Expect(0, 67711, '\P{Is_Block=_ Palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Block=_ Palmyrene}', "");
    Expect(0, 67712, '\p{Is_Block=_ Palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Block=_ Palmyrene}', "");
    Expect(1, 67712, '\P{Is_Block=_ Palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Block=_ Palmyrene}', "");
    Error('\p{Is_Blk=_:=Palmyrene}');
    Error('\P{Is_Blk=_:=Palmyrene}');
    Expect(1, 67711, '\p{Is_Blk=palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Blk=palmyrene}', "");
    Expect(0, 67711, '\P{Is_Blk=palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Blk=palmyrene}', "");
    Expect(0, 67712, '\p{Is_Blk=palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Blk=palmyrene}', "");
    Expect(1, 67712, '\P{Is_Blk=palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Blk=palmyrene}', "");
    Expect(1, 67711, '\p{Is_Blk: _ Palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Blk: _ Palmyrene}', "");
    Expect(0, 67711, '\P{Is_Blk: _ Palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Blk: _ Palmyrene}', "");
    Expect(0, 67712, '\p{Is_Blk: _ Palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Blk: _ Palmyrene}', "");
    Expect(1, 67712, '\P{Is_Blk: _ Palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Blk: _ Palmyrene}', "");
    Error('\p{Block= -pau_Cin_Hau/a/}');
    Error('\P{Block= -pau_Cin_Hau/a/}');
    Expect(1, 72447, '\p{Block=paucinhau}', "");
    Expect(0, 72447, '\p{^Block=paucinhau}', "");
    Expect(0, 72447, '\P{Block=paucinhau}', "");
    Expect(1, 72447, '\P{^Block=paucinhau}', "");
    Expect(0, 72448, '\p{Block=paucinhau}', "");
    Expect(1, 72448, '\p{^Block=paucinhau}', "");
    Expect(1, 72448, '\P{Block=paucinhau}', "");
    Expect(0, 72448, '\P{^Block=paucinhau}', "");
    Expect(1, 72447, '\p{Block=__pau_CIN_Hau}', "");
    Expect(0, 72447, '\p{^Block=__pau_CIN_Hau}', "");
    Expect(0, 72447, '\P{Block=__pau_CIN_Hau}', "");
    Expect(1, 72447, '\P{^Block=__pau_CIN_Hau}', "");
    Expect(0, 72448, '\p{Block=__pau_CIN_Hau}', "");
    Expect(1, 72448, '\p{^Block=__pau_CIN_Hau}', "");
    Expect(1, 72448, '\P{Block=__pau_CIN_Hau}', "");
    Expect(0, 72448, '\P{^Block=__pau_CIN_Hau}', "");
    Error('\p{Blk=/a/ pau_CIN_Hau}');
    Error('\P{Blk=/a/ pau_CIN_Hau}');
    Expect(1, 72447, '\p{Blk: paucinhau}', "");
    Expect(0, 72447, '\p{^Blk: paucinhau}', "");
    Expect(0, 72447, '\P{Blk: paucinhau}', "");
    Expect(1, 72447, '\P{^Blk: paucinhau}', "");
    Expect(0, 72448, '\p{Blk: paucinhau}', "");
    Expect(1, 72448, '\p{^Blk: paucinhau}', "");
    Expect(1, 72448, '\P{Blk: paucinhau}', "");
    Expect(0, 72448, '\P{^Blk: paucinhau}', "");
    Expect(1, 72447, '\p{Blk=_pau_cin_Hau}', "");
    Expect(0, 72447, '\p{^Blk=_pau_cin_Hau}', "");
    Expect(0, 72447, '\P{Blk=_pau_cin_Hau}', "");
    Expect(1, 72447, '\P{^Blk=_pau_cin_Hau}', "");
    Expect(0, 72448, '\p{Blk=_pau_cin_Hau}', "");
    Expect(1, 72448, '\p{^Blk=_pau_cin_Hau}', "");
    Expect(1, 72448, '\P{Blk=_pau_cin_Hau}', "");
    Expect(0, 72448, '\P{^Blk=_pau_cin_Hau}', "");
    Error('\p{Is_Block=_:=pau_Cin_Hau}');
    Error('\P{Is_Block=_:=pau_Cin_Hau}');
    Expect(1, 72447, '\p{Is_Block=paucinhau}', "");
    Expect(0, 72447, '\p{^Is_Block=paucinhau}', "");
    Expect(0, 72447, '\P{Is_Block=paucinhau}', "");
    Expect(1, 72447, '\P{^Is_Block=paucinhau}', "");
    Expect(0, 72448, '\p{Is_Block=paucinhau}', "");
    Expect(1, 72448, '\p{^Is_Block=paucinhau}', "");
    Expect(1, 72448, '\P{Is_Block=paucinhau}', "");
    Expect(0, 72448, '\P{^Is_Block=paucinhau}', "");
    Expect(1, 72447, '\p{Is_Block:  Pau_cin_hau}', "");
    Expect(0, 72447, '\p{^Is_Block:  Pau_cin_hau}', "");
    Expect(0, 72447, '\P{Is_Block:  Pau_cin_hau}', "");
    Expect(1, 72447, '\P{^Is_Block:  Pau_cin_hau}', "");
    Expect(0, 72448, '\p{Is_Block:  Pau_cin_hau}', "");
    Expect(1, 72448, '\p{^Is_Block:  Pau_cin_hau}', "");
    Expect(1, 72448, '\P{Is_Block:  Pau_cin_hau}', "");
    Expect(0, 72448, '\P{^Is_Block:  Pau_cin_hau}', "");
    Error('\p{Is_Blk=/a/-_pau_CIN_Hau}');
    Error('\P{Is_Blk=/a/-_pau_CIN_Hau}');
    Expect(1, 72447, '\p{Is_Blk=paucinhau}', "");
    Expect(0, 72447, '\p{^Is_Blk=paucinhau}', "");
    Expect(0, 72447, '\P{Is_Blk=paucinhau}', "");
    Expect(1, 72447, '\P{^Is_Blk=paucinhau}', "");
    Expect(0, 72448, '\p{Is_Blk=paucinhau}', "");
    Expect(1, 72448, '\p{^Is_Blk=paucinhau}', "");
    Expect(1, 72448, '\P{Is_Blk=paucinhau}', "");
    Expect(0, 72448, '\P{^Is_Blk=paucinhau}', "");
    Expect(1, 72447, '\p{Is_Blk=_-pau_Cin_hau}', "");
    Expect(0, 72447, '\p{^Is_Blk=_-pau_Cin_hau}', "");
    Expect(0, 72447, '\P{Is_Blk=_-pau_Cin_hau}', "");
    Expect(1, 72447, '\P{^Is_Blk=_-pau_Cin_hau}', "");
    Expect(0, 72448, '\p{Is_Blk=_-pau_Cin_hau}', "");
    Expect(1, 72448, '\p{^Is_Blk=_-pau_Cin_hau}', "");
    Expect(1, 72448, '\P{Is_Blk=_-pau_Cin_hau}', "");
    Expect(0, 72448, '\P{^Is_Blk=_-pau_Cin_hau}', "");
    Error('\p{Block=	/a/Phags_PA}');
    Error('\P{Block=	/a/Phags_PA}');
    Expect(1, 43135, '\p{Block=phagspa}', "");
    Expect(0, 43135, '\p{^Block=phagspa}', "");
    Expect(0, 43135, '\P{Block=phagspa}', "");
    Expect(1, 43135, '\P{^Block=phagspa}', "");
    Expect(0, 43136, '\p{Block=phagspa}', "");
    Expect(1, 43136, '\p{^Block=phagspa}', "");
    Expect(1, 43136, '\P{Block=phagspa}', "");
    Expect(0, 43136, '\P{^Block=phagspa}', "");
    Expect(1, 43135, '\p{Block=	Phags_PA}', "");
    Expect(0, 43135, '\p{^Block=	Phags_PA}', "");
    Expect(0, 43135, '\P{Block=	Phags_PA}', "");
    Expect(1, 43135, '\P{^Block=	Phags_PA}', "");
    Expect(0, 43136, '\p{Block=	Phags_PA}', "");
    Expect(1, 43136, '\p{^Block=	Phags_PA}', "");
    Expect(1, 43136, '\P{Block=	Phags_PA}', "");
    Expect(0, 43136, '\P{^Block=	Phags_PA}', "");
    Error('\p{Blk=/a/--PHAGS_Pa}');
    Error('\P{Blk=/a/--PHAGS_Pa}');
    Expect(1, 43135, '\p{Blk=phagspa}', "");
    Expect(0, 43135, '\p{^Blk=phagspa}', "");
    Expect(0, 43135, '\P{Blk=phagspa}', "");
    Expect(1, 43135, '\P{^Blk=phagspa}', "");
    Expect(0, 43136, '\p{Blk=phagspa}', "");
    Expect(1, 43136, '\p{^Blk=phagspa}', "");
    Expect(1, 43136, '\P{Blk=phagspa}', "");
    Expect(0, 43136, '\P{^Blk=phagspa}', "");
    Expect(1, 43135, '\p{Blk=_Phags_PA}', "");
    Expect(0, 43135, '\p{^Blk=_Phags_PA}', "");
    Expect(0, 43135, '\P{Blk=_Phags_PA}', "");
    Expect(1, 43135, '\P{^Blk=_Phags_PA}', "");
    Expect(0, 43136, '\p{Blk=_Phags_PA}', "");
    Expect(1, 43136, '\p{^Blk=_Phags_PA}', "");
    Expect(1, 43136, '\P{Blk=_Phags_PA}', "");
    Expect(0, 43136, '\P{^Blk=_Phags_PA}', "");
    Error('\p{Is_Block::=	-PHAGS_Pa}');
    Error('\P{Is_Block::=	-PHAGS_Pa}');
    Expect(1, 43135, '\p{Is_Block=phagspa}', "");
    Expect(0, 43135, '\p{^Is_Block=phagspa}', "");
    Expect(0, 43135, '\P{Is_Block=phagspa}', "");
    Expect(1, 43135, '\P{^Is_Block=phagspa}', "");
    Expect(0, 43136, '\p{Is_Block=phagspa}', "");
    Expect(1, 43136, '\p{^Is_Block=phagspa}', "");
    Expect(1, 43136, '\P{Is_Block=phagspa}', "");
    Expect(0, 43136, '\P{^Is_Block=phagspa}', "");
    Expect(1, 43135, '\p{Is_Block= Phags_PA}', "");
    Expect(0, 43135, '\p{^Is_Block= Phags_PA}', "");
    Expect(0, 43135, '\P{Is_Block= Phags_PA}', "");
    Expect(1, 43135, '\P{^Is_Block= Phags_PA}', "");
    Expect(0, 43136, '\p{Is_Block= Phags_PA}', "");
    Expect(1, 43136, '\p{^Is_Block= Phags_PA}', "");
    Expect(1, 43136, '\P{Is_Block= Phags_PA}', "");
    Expect(0, 43136, '\P{^Is_Block= Phags_PA}', "");
    Error('\p{Is_Blk=:=-	Phags_pa}');
    Error('\P{Is_Blk=:=-	Phags_pa}');
    Expect(1, 43135, '\p{Is_Blk=phagspa}', "");
    Expect(0, 43135, '\p{^Is_Blk=phagspa}', "");
    Expect(0, 43135, '\P{Is_Blk=phagspa}', "");
    Expect(1, 43135, '\P{^Is_Blk=phagspa}', "");
    Expect(0, 43136, '\p{Is_Blk=phagspa}', "");
    Expect(1, 43136, '\p{^Is_Blk=phagspa}', "");
    Expect(1, 43136, '\P{Is_Blk=phagspa}', "");
    Expect(0, 43136, '\P{^Is_Blk=phagspa}', "");
    Expect(1, 43135, '\p{Is_Blk=-	phags_Pa}', "");
    Expect(0, 43135, '\p{^Is_Blk=-	phags_Pa}', "");
    Expect(0, 43135, '\P{Is_Blk=-	phags_Pa}', "");
    Expect(1, 43135, '\P{^Is_Blk=-	phags_Pa}', "");
    Expect(0, 43136, '\p{Is_Blk=-	phags_Pa}', "");
    Expect(1, 43136, '\p{^Is_Blk=-	phags_Pa}', "");
    Expect(1, 43136, '\P{Is_Blk=-	phags_Pa}', "");
    Expect(0, 43136, '\P{^Is_Blk=-	phags_Pa}', "");
    Error('\p{Block=:=_ Phaistos_Disc}');
    Error('\P{Block=:=_ Phaistos_Disc}');
    Expect(1, 66047, '\p{Block=phaistosdisc}', "");
    Expect(0, 66047, '\p{^Block=phaistosdisc}', "");
    Expect(0, 66047, '\P{Block=phaistosdisc}', "");
    Expect(1, 66047, '\P{^Block=phaistosdisc}', "");
    Expect(0, 66048, '\p{Block=phaistosdisc}', "");
    Expect(1, 66048, '\p{^Block=phaistosdisc}', "");
    Expect(1, 66048, '\P{Block=phaistosdisc}', "");
    Expect(0, 66048, '\P{^Block=phaistosdisc}', "");
    Expect(1, 66047, '\p{Block=	phaistos_Disc}', "");
    Expect(0, 66047, '\p{^Block=	phaistos_Disc}', "");
    Expect(0, 66047, '\P{Block=	phaistos_Disc}', "");
    Expect(1, 66047, '\P{^Block=	phaistos_Disc}', "");
    Expect(0, 66048, '\p{Block=	phaistos_Disc}', "");
    Expect(1, 66048, '\p{^Block=	phaistos_Disc}', "");
    Expect(1, 66048, '\P{Block=	phaistos_Disc}', "");
    Expect(0, 66048, '\P{^Block=	phaistos_Disc}', "");
    Error('\p{Blk=-	phaistos:=}');
    Error('\P{Blk=-	phaistos:=}');
    Expect(1, 66047, '\p{Blk=phaistos}', "");
    Expect(0, 66047, '\p{^Blk=phaistos}', "");
    Expect(0, 66047, '\P{Blk=phaistos}', "");
    Expect(1, 66047, '\P{^Blk=phaistos}', "");
    Expect(0, 66048, '\p{Blk=phaistos}', "");
    Expect(1, 66048, '\p{^Blk=phaistos}', "");
    Expect(1, 66048, '\P{Blk=phaistos}', "");
    Expect(0, 66048, '\P{^Blk=phaistos}', "");
    Expect(1, 66047, '\p{Blk=	phaistos}', "");
    Expect(0, 66047, '\p{^Blk=	phaistos}', "");
    Expect(0, 66047, '\P{Blk=	phaistos}', "");
    Expect(1, 66047, '\P{^Blk=	phaistos}', "");
    Expect(0, 66048, '\p{Blk=	phaistos}', "");
    Expect(1, 66048, '\p{^Blk=	phaistos}', "");
    Expect(1, 66048, '\P{Blk=	phaistos}', "");
    Expect(0, 66048, '\P{^Blk=	phaistos}', "");
    Error('\p{Is_Block=_:=Phaistos_Disc}');
    Error('\P{Is_Block=_:=Phaistos_Disc}');
    Expect(1, 66047, '\p{Is_Block=phaistosdisc}', "");
    Expect(0, 66047, '\p{^Is_Block=phaistosdisc}', "");
    Expect(0, 66047, '\P{Is_Block=phaistosdisc}', "");
    Expect(1, 66047, '\P{^Is_Block=phaistosdisc}', "");
    Expect(0, 66048, '\p{Is_Block=phaistosdisc}', "");
    Expect(1, 66048, '\p{^Is_Block=phaistosdisc}', "");
    Expect(1, 66048, '\P{Is_Block=phaistosdisc}', "");
    Expect(0, 66048, '\P{^Is_Block=phaistosdisc}', "");
    Expect(1, 66047, '\p{Is_Block=	phaistos_Disc}', "");
    Expect(0, 66047, '\p{^Is_Block=	phaistos_Disc}', "");
    Expect(0, 66047, '\P{Is_Block=	phaistos_Disc}', "");
    Expect(1, 66047, '\P{^Is_Block=	phaistos_Disc}', "");
    Expect(0, 66048, '\p{Is_Block=	phaistos_Disc}', "");
    Expect(1, 66048, '\p{^Is_Block=	phaistos_Disc}', "");
    Expect(1, 66048, '\P{Is_Block=	phaistos_Disc}', "");
    Expect(0, 66048, '\P{^Is_Block=	phaistos_Disc}', "");
    Error('\p{Is_Blk:	:=	 Phaistos}');
    Error('\P{Is_Blk:	:=	 Phaistos}');
    Expect(1, 66047, '\p{Is_Blk: phaistos}', "");
    Expect(0, 66047, '\p{^Is_Blk: phaistos}', "");
    Expect(0, 66047, '\P{Is_Blk: phaistos}', "");
    Expect(1, 66047, '\P{^Is_Blk: phaistos}', "");
    Expect(0, 66048, '\p{Is_Blk: phaistos}', "");
    Expect(1, 66048, '\p{^Is_Blk: phaistos}', "");
    Expect(1, 66048, '\P{Is_Blk: phaistos}', "");
    Expect(0, 66048, '\P{^Is_Blk: phaistos}', "");
    Expect(1, 66047, '\p{Is_Blk= _phaistos}', "");
    Expect(0, 66047, '\p{^Is_Blk= _phaistos}', "");
    Expect(0, 66047, '\P{Is_Blk= _phaistos}', "");
    Expect(1, 66047, '\P{^Is_Blk= _phaistos}', "");
    Expect(0, 66048, '\p{Is_Blk= _phaistos}', "");
    Expect(1, 66048, '\p{^Is_Blk= _phaistos}', "");
    Expect(1, 66048, '\P{Is_Blk= _phaistos}', "");
    Expect(0, 66048, '\P{^Is_Blk= _phaistos}', "");
    Error('\p{Block=_:=Phoenician}');
    Error('\P{Block=_:=Phoenician}');
    Expect(1, 67871, '\p{Block=phoenician}', "");
    Expect(0, 67871, '\p{^Block=phoenician}', "");
    Expect(0, 67871, '\P{Block=phoenician}', "");
    Expect(1, 67871, '\P{^Block=phoenician}', "");
    Expect(0, 67872, '\p{Block=phoenician}', "");
    Expect(1, 67872, '\p{^Block=phoenician}', "");
    Expect(1, 67872, '\P{Block=phoenician}', "");
    Expect(0, 67872, '\P{^Block=phoenician}', "");
    Expect(1, 67871, '\p{Block=		PHOENICIAN}', "");
    Expect(0, 67871, '\p{^Block=		PHOENICIAN}', "");
    Expect(0, 67871, '\P{Block=		PHOENICIAN}', "");
    Expect(1, 67871, '\P{^Block=		PHOENICIAN}', "");
    Expect(0, 67872, '\p{Block=		PHOENICIAN}', "");
    Expect(1, 67872, '\p{^Block=		PHOENICIAN}', "");
    Expect(1, 67872, '\P{Block=		PHOENICIAN}', "");
    Expect(0, 67872, '\P{^Block=		PHOENICIAN}', "");
    Error('\p{Blk=	:=phoenician}');
    Error('\P{Blk=	:=phoenician}');
    Expect(1, 67871, '\p{Blk=phoenician}', "");
    Expect(0, 67871, '\p{^Blk=phoenician}', "");
    Expect(0, 67871, '\P{Blk=phoenician}', "");
    Expect(1, 67871, '\P{^Blk=phoenician}', "");
    Expect(0, 67872, '\p{Blk=phoenician}', "");
    Expect(1, 67872, '\p{^Blk=phoenician}', "");
    Expect(1, 67872, '\P{Blk=phoenician}', "");
    Expect(0, 67872, '\P{^Blk=phoenician}', "");
    Expect(1, 67871, '\p{Blk=_PHOENICIAN}', "");
    Expect(0, 67871, '\p{^Blk=_PHOENICIAN}', "");
    Expect(0, 67871, '\P{Blk=_PHOENICIAN}', "");
    Expect(1, 67871, '\P{^Blk=_PHOENICIAN}', "");
    Expect(0, 67872, '\p{Blk=_PHOENICIAN}', "");
    Expect(1, 67872, '\p{^Blk=_PHOENICIAN}', "");
    Expect(1, 67872, '\P{Blk=_PHOENICIAN}', "");
    Expect(0, 67872, '\P{^Blk=_PHOENICIAN}', "");
    Error('\p{Is_Block=-	phoenician/a/}');
    Error('\P{Is_Block=-	phoenician/a/}');
    Expect(1, 67871, '\p{Is_Block=phoenician}', "");
    Expect(0, 67871, '\p{^Is_Block=phoenician}', "");
    Expect(0, 67871, '\P{Is_Block=phoenician}', "");
    Expect(1, 67871, '\P{^Is_Block=phoenician}', "");
    Expect(0, 67872, '\p{Is_Block=phoenician}', "");
    Expect(1, 67872, '\p{^Is_Block=phoenician}', "");
    Expect(1, 67872, '\P{Is_Block=phoenician}', "");
    Expect(0, 67872, '\P{^Is_Block=phoenician}', "");
    Expect(1, 67871, '\p{Is_Block=	Phoenician}', "");
    Expect(0, 67871, '\p{^Is_Block=	Phoenician}', "");
    Expect(0, 67871, '\P{Is_Block=	Phoenician}', "");
    Expect(1, 67871, '\P{^Is_Block=	Phoenician}', "");
    Expect(0, 67872, '\p{Is_Block=	Phoenician}', "");
    Expect(1, 67872, '\p{^Is_Block=	Phoenician}', "");
    Expect(1, 67872, '\P{Is_Block=	Phoenician}', "");
    Expect(0, 67872, '\P{^Is_Block=	Phoenician}', "");
    Error('\p{Is_Blk=__Phoenician:=}');
    Error('\P{Is_Blk=__Phoenician:=}');
    Expect(1, 67871, '\p{Is_Blk=phoenician}', "");
    Expect(0, 67871, '\p{^Is_Blk=phoenician}', "");
    Expect(0, 67871, '\P{Is_Blk=phoenician}', "");
    Expect(1, 67871, '\P{^Is_Blk=phoenician}', "");
    Expect(0, 67872, '\p{Is_Blk=phoenician}', "");
    Expect(1, 67872, '\p{^Is_Blk=phoenician}', "");
    Expect(1, 67872, '\P{Is_Blk=phoenician}', "");
    Expect(0, 67872, '\P{^Is_Blk=phoenician}', "");
    Expect(1, 67871, '\p{Is_Blk:   	Phoenician}', "");
    Expect(0, 67871, '\p{^Is_Blk:   	Phoenician}', "");
    Expect(0, 67871, '\P{Is_Blk:   	Phoenician}', "");
    Expect(1, 67871, '\P{^Is_Blk:   	Phoenician}', "");
    Expect(0, 67872, '\p{Is_Blk:   	Phoenician}', "");
    Expect(1, 67872, '\p{^Is_Blk:   	Phoenician}', "");
    Expect(1, 67872, '\P{Is_Blk:   	Phoenician}', "");
    Expect(0, 67872, '\P{^Is_Blk:   	Phoenician}', "");
    Error('\p{Block:	:=Phonetic_extensions}');
    Error('\P{Block:	:=Phonetic_extensions}');
    Expect(1, 7551, '\p{Block=phoneticextensions}', "");
    Expect(0, 7551, '\p{^Block=phoneticextensions}', "");
    Expect(0, 7551, '\P{Block=phoneticextensions}', "");
    Expect(1, 7551, '\P{^Block=phoneticextensions}', "");
    Expect(0, 7552, '\p{Block=phoneticextensions}', "");
    Expect(1, 7552, '\p{^Block=phoneticextensions}', "");
    Expect(1, 7552, '\P{Block=phoneticextensions}', "");
    Expect(0, 7552, '\P{^Block=phoneticextensions}', "");
    Expect(1, 7551, '\p{Block: phonetic_EXTENSIONS}', "");
    Expect(0, 7551, '\p{^Block: phonetic_EXTENSIONS}', "");
    Expect(0, 7551, '\P{Block: phonetic_EXTENSIONS}', "");
    Expect(1, 7551, '\P{^Block: phonetic_EXTENSIONS}', "");
    Expect(0, 7552, '\p{Block: phonetic_EXTENSIONS}', "");
    Expect(1, 7552, '\p{^Block: phonetic_EXTENSIONS}', "");
    Expect(1, 7552, '\P{Block: phonetic_EXTENSIONS}', "");
    Expect(0, 7552, '\P{^Block: phonetic_EXTENSIONS}', "");
    Error('\p{Blk=	 phonetic_Ext/a/}');
    Error('\P{Blk=	 phonetic_Ext/a/}');
    Expect(1, 7551, '\p{Blk=phoneticext}', "");
    Expect(0, 7551, '\p{^Blk=phoneticext}', "");
    Expect(0, 7551, '\P{Blk=phoneticext}', "");
    Expect(1, 7551, '\P{^Blk=phoneticext}', "");
    Expect(0, 7552, '\p{Blk=phoneticext}', "");
    Expect(1, 7552, '\p{^Blk=phoneticext}', "");
    Expect(1, 7552, '\P{Blk=phoneticext}', "");
    Expect(0, 7552, '\P{^Blk=phoneticext}', "");
    Expect(1, 7551, '\p{Blk= PHONETIC_ext}', "");
    Expect(0, 7551, '\p{^Blk= PHONETIC_ext}', "");
    Expect(0, 7551, '\P{Blk= PHONETIC_ext}', "");
    Expect(1, 7551, '\P{^Blk= PHONETIC_ext}', "");
    Expect(0, 7552, '\p{Blk= PHONETIC_ext}', "");
    Expect(1, 7552, '\p{^Blk= PHONETIC_ext}', "");
    Expect(1, 7552, '\P{Blk= PHONETIC_ext}', "");
    Expect(0, 7552, '\P{^Blk= PHONETIC_ext}', "");
    Error('\p{Is_Block= /a/phonetic_EXTENSIONS}');
    Error('\P{Is_Block= /a/phonetic_EXTENSIONS}');
    Expect(1, 7551, '\p{Is_Block=phoneticextensions}', "");
    Expect(0, 7551, '\p{^Is_Block=phoneticextensions}', "");
    Expect(0, 7551, '\P{Is_Block=phoneticextensions}', "");
    Expect(1, 7551, '\P{^Is_Block=phoneticextensions}', "");
    Expect(0, 7552, '\p{Is_Block=phoneticextensions}', "");
    Expect(1, 7552, '\p{^Is_Block=phoneticextensions}', "");
    Expect(1, 7552, '\P{Is_Block=phoneticextensions}', "");
    Expect(0, 7552, '\P{^Is_Block=phoneticextensions}', "");
    Expect(1, 7551, '\p{Is_Block=  phonetic_EXTENSIONS}', "");
    Expect(0, 7551, '\p{^Is_Block=  phonetic_EXTENSIONS}', "");
    Expect(0, 7551, '\P{Is_Block=  phonetic_EXTENSIONS}', "");
    Expect(1, 7551, '\P{^Is_Block=  phonetic_EXTENSIONS}', "");
    Expect(0, 7552, '\p{Is_Block=  phonetic_EXTENSIONS}', "");
    Expect(1, 7552, '\p{^Is_Block=  phonetic_EXTENSIONS}', "");
    Expect(1, 7552, '\P{Is_Block=  phonetic_EXTENSIONS}', "");
    Expect(0, 7552, '\P{^Is_Block=  phonetic_EXTENSIONS}', "");
    Error('\p{Is_Blk=/a/ -PHONETIC_Ext}');
    Error('\P{Is_Blk=/a/ -PHONETIC_Ext}');
    Expect(1, 7551, '\p{Is_Blk=phoneticext}', "");
    Expect(0, 7551, '\p{^Is_Blk=phoneticext}', "");
    Expect(0, 7551, '\P{Is_Blk=phoneticext}', "");
    Expect(1, 7551, '\P{^Is_Blk=phoneticext}', "");
    Expect(0, 7552, '\p{Is_Blk=phoneticext}', "");
    Expect(1, 7552, '\p{^Is_Blk=phoneticext}', "");
    Expect(1, 7552, '\P{Is_Blk=phoneticext}', "");
    Expect(0, 7552, '\P{^Is_Blk=phoneticext}', "");
    Expect(1, 7551, '\p{Is_Blk=-Phonetic_Ext}', "");
    Expect(0, 7551, '\p{^Is_Blk=-Phonetic_Ext}', "");
    Expect(0, 7551, '\P{Is_Blk=-Phonetic_Ext}', "");
    Expect(1, 7551, '\P{^Is_Blk=-Phonetic_Ext}', "");
    Expect(0, 7552, '\p{Is_Blk=-Phonetic_Ext}', "");
    Expect(1, 7552, '\p{^Is_Blk=-Phonetic_Ext}', "");
    Expect(1, 7552, '\P{Is_Blk=-Phonetic_Ext}', "");
    Expect(0, 7552, '\P{^Is_Blk=-Phonetic_Ext}', "");
    Error('\p{Block=	 Phonetic_Extensions_Supplement/a/}');
    Error('\P{Block=	 Phonetic_Extensions_Supplement/a/}');
    Expect(1, 7615, '\p{Block=phoneticextensionssupplement}', "");
    Expect(0, 7615, '\p{^Block=phoneticextensionssupplement}', "");
    Expect(0, 7615, '\P{Block=phoneticextensionssupplement}', "");
    Expect(1, 7615, '\P{^Block=phoneticextensionssupplement}', "");
    Expect(0, 7616, '\p{Block=phoneticextensionssupplement}', "");
    Expect(1, 7616, '\p{^Block=phoneticextensionssupplement}', "");
    Expect(1, 7616, '\P{Block=phoneticextensionssupplement}', "");
    Expect(0, 7616, '\P{^Block=phoneticextensionssupplement}', "");
    Expect(1, 7615, '\p{Block=-	PHONETIC_Extensions_supplement}', "");
    Expect(0, 7615, '\p{^Block=-	PHONETIC_Extensions_supplement}', "");
    Expect(0, 7615, '\P{Block=-	PHONETIC_Extensions_supplement}', "");
    Expect(1, 7615, '\P{^Block=-	PHONETIC_Extensions_supplement}', "");
    Expect(0, 7616, '\p{Block=-	PHONETIC_Extensions_supplement}', "");
    Expect(1, 7616, '\p{^Block=-	PHONETIC_Extensions_supplement}', "");
    Expect(1, 7616, '\P{Block=-	PHONETIC_Extensions_supplement}', "");
    Expect(0, 7616, '\P{^Block=-	PHONETIC_Extensions_supplement}', "");
    Error('\p{Blk=/a/-	PHONETIC_ext_Sup}');
    Error('\P{Blk=/a/-	PHONETIC_ext_Sup}');
    Expect(1, 7615, '\p{Blk=phoneticextsup}', "");
    Expect(0, 7615, '\p{^Blk=phoneticextsup}', "");
    Expect(0, 7615, '\P{Blk=phoneticextsup}', "");
    Expect(1, 7615, '\P{^Blk=phoneticextsup}', "");
    Expect(0, 7616, '\p{Blk=phoneticextsup}', "");
    Expect(1, 7616, '\p{^Blk=phoneticextsup}', "");
    Expect(1, 7616, '\P{Blk=phoneticextsup}', "");
    Expect(0, 7616, '\P{^Blk=phoneticextsup}', "");
    Expect(1, 7615, '\p{Blk=	Phonetic_Ext_sup}', "");
    Expect(0, 7615, '\p{^Blk=	Phonetic_Ext_sup}', "");
    Expect(0, 7615, '\P{Blk=	Phonetic_Ext_sup}', "");
    Expect(1, 7615, '\P{^Blk=	Phonetic_Ext_sup}', "");
    Expect(0, 7616, '\p{Blk=	Phonetic_Ext_sup}', "");
    Expect(1, 7616, '\p{^Blk=	Phonetic_Ext_sup}', "");
    Expect(1, 7616, '\P{Blk=	Phonetic_Ext_sup}', "");
    Expect(0, 7616, '\P{^Blk=	Phonetic_Ext_sup}', "");
    Error('\p{Is_Block: 	:=Phonetic_Extensions_Supplement}');
    Error('\P{Is_Block: 	:=Phonetic_Extensions_Supplement}');
    Expect(1, 7615, '\p{Is_Block=phoneticextensionssupplement}', "");
    Expect(0, 7615, '\p{^Is_Block=phoneticextensionssupplement}', "");
    Expect(0, 7615, '\P{Is_Block=phoneticextensionssupplement}', "");
    Expect(1, 7615, '\P{^Is_Block=phoneticextensionssupplement}', "");
    Expect(0, 7616, '\p{Is_Block=phoneticextensionssupplement}', "");
    Expect(1, 7616, '\p{^Is_Block=phoneticextensionssupplement}', "");
    Expect(1, 7616, '\P{Is_Block=phoneticextensionssupplement}', "");
    Expect(0, 7616, '\P{^Is_Block=phoneticextensionssupplement}', "");
    Expect(1, 7615, '\p{Is_Block=__Phonetic_EXTENSIONS_Supplement}', "");
    Expect(0, 7615, '\p{^Is_Block=__Phonetic_EXTENSIONS_Supplement}', "");
    Expect(0, 7615, '\P{Is_Block=__Phonetic_EXTENSIONS_Supplement}', "");
    Expect(1, 7615, '\P{^Is_Block=__Phonetic_EXTENSIONS_Supplement}', "");
    Expect(0, 7616, '\p{Is_Block=__Phonetic_EXTENSIONS_Supplement}', "");
    Expect(1, 7616, '\p{^Is_Block=__Phonetic_EXTENSIONS_Supplement}', "");
    Expect(1, 7616, '\P{Is_Block=__Phonetic_EXTENSIONS_Supplement}', "");
    Expect(0, 7616, '\P{^Is_Block=__Phonetic_EXTENSIONS_Supplement}', "");
    Error('\p{Is_Blk=	:=PHONETIC_Ext_Sup}');
    Error('\P{Is_Blk=	:=PHONETIC_Ext_Sup}');
    Expect(1, 7615, '\p{Is_Blk=phoneticextsup}', "");
    Expect(0, 7615, '\p{^Is_Blk=phoneticextsup}', "");
    Expect(0, 7615, '\P{Is_Blk=phoneticextsup}', "");
    Expect(1, 7615, '\P{^Is_Blk=phoneticextsup}', "");
    Expect(0, 7616, '\p{Is_Blk=phoneticextsup}', "");
    Expect(1, 7616, '\p{^Is_Blk=phoneticextsup}', "");
    Expect(1, 7616, '\P{Is_Blk=phoneticextsup}', "");
    Expect(0, 7616, '\P{^Is_Blk=phoneticextsup}', "");
    Expect(1, 7615, '\p{Is_Blk=- phonetic_Ext_Sup}', "");
    Expect(0, 7615, '\p{^Is_Blk=- phonetic_Ext_Sup}', "");
    Expect(0, 7615, '\P{Is_Blk=- phonetic_Ext_Sup}', "");
    Expect(1, 7615, '\P{^Is_Blk=- phonetic_Ext_Sup}', "");
    Expect(0, 7616, '\p{Is_Blk=- phonetic_Ext_Sup}', "");
    Expect(1, 7616, '\p{^Is_Blk=- phonetic_Ext_Sup}', "");
    Expect(1, 7616, '\P{Is_Blk=- phonetic_Ext_Sup}', "");
    Expect(0, 7616, '\P{^Is_Blk=- phonetic_Ext_Sup}', "");
    Error('\p{Block=	_playing_Cards/a/}');
    Error('\P{Block=	_playing_Cards/a/}');
    Expect(1, 127231, '\p{Block=playingcards}', "");
    Expect(0, 127231, '\p{^Block=playingcards}', "");
    Expect(0, 127231, '\P{Block=playingcards}', "");
    Expect(1, 127231, '\P{^Block=playingcards}', "");
    Expect(0, 127232, '\p{Block=playingcards}', "");
    Expect(1, 127232, '\p{^Block=playingcards}', "");
    Expect(1, 127232, '\P{Block=playingcards}', "");
    Expect(0, 127232, '\P{^Block=playingcards}', "");
    Expect(1, 127231, '\p{Block=		Playing_Cards}', "");
    Expect(0, 127231, '\p{^Block=		Playing_Cards}', "");
    Expect(0, 127231, '\P{Block=		Playing_Cards}', "");
    Expect(1, 127231, '\P{^Block=		Playing_Cards}', "");
    Expect(0, 127232, '\p{Block=		Playing_Cards}', "");
    Expect(1, 127232, '\p{^Block=		Playing_Cards}', "");
    Expect(1, 127232, '\P{Block=		Playing_Cards}', "");
    Expect(0, 127232, '\P{^Block=		Playing_Cards}', "");
    Error('\p{Blk=_:=PLAYING_CARDS}');
    Error('\P{Blk=_:=PLAYING_CARDS}');
    Expect(1, 127231, '\p{Blk=playingcards}', "");
    Expect(0, 127231, '\p{^Blk=playingcards}', "");
    Expect(0, 127231, '\P{Blk=playingcards}', "");
    Expect(1, 127231, '\P{^Blk=playingcards}', "");
    Expect(0, 127232, '\p{Blk=playingcards}', "");
    Expect(1, 127232, '\p{^Blk=playingcards}', "");
    Expect(1, 127232, '\P{Blk=playingcards}', "");
    Expect(0, 127232, '\P{^Blk=playingcards}', "");
    Expect(1, 127231, '\p{Blk=_-PLAYING_Cards}', "");
    Expect(0, 127231, '\p{^Blk=_-PLAYING_Cards}', "");
    Expect(0, 127231, '\P{Blk=_-PLAYING_Cards}', "");
    Expect(1, 127231, '\P{^Blk=_-PLAYING_Cards}', "");
    Expect(0, 127232, '\p{Blk=_-PLAYING_Cards}', "");
    Expect(1, 127232, '\p{^Blk=_-PLAYING_Cards}', "");
    Expect(1, 127232, '\P{Blk=_-PLAYING_Cards}', "");
    Expect(0, 127232, '\P{^Blk=_-PLAYING_Cards}', "");
    Error('\p{Is_Block=	-Playing_cards:=}');
    Error('\P{Is_Block=	-Playing_cards:=}');
    Expect(1, 127231, '\p{Is_Block=playingcards}', "");
    Expect(0, 127231, '\p{^Is_Block=playingcards}', "");
    Expect(0, 127231, '\P{Is_Block=playingcards}', "");
    Expect(1, 127231, '\P{^Is_Block=playingcards}', "");
    Expect(0, 127232, '\p{Is_Block=playingcards}', "");
    Expect(1, 127232, '\p{^Is_Block=playingcards}', "");
    Expect(1, 127232, '\P{Is_Block=playingcards}', "");
    Expect(0, 127232, '\P{^Is_Block=playingcards}', "");
    Expect(1, 127231, '\p{Is_Block=_Playing_cards}', "");
    Expect(0, 127231, '\p{^Is_Block=_Playing_cards}', "");
    Expect(0, 127231, '\P{Is_Block=_Playing_cards}', "");
    Expect(1, 127231, '\P{^Is_Block=_Playing_cards}', "");
    Expect(0, 127232, '\p{Is_Block=_Playing_cards}', "");
    Expect(1, 127232, '\p{^Is_Block=_Playing_cards}', "");
    Expect(1, 127232, '\P{Is_Block=_Playing_cards}', "");
    Expect(0, 127232, '\P{^Is_Block=_Playing_cards}', "");
    Error('\p{Is_Blk=-:=playing_cards}');
    Error('\P{Is_Blk=-:=playing_cards}');
    Expect(1, 127231, '\p{Is_Blk:   playingcards}', "");
    Expect(0, 127231, '\p{^Is_Blk:   playingcards}', "");
    Expect(0, 127231, '\P{Is_Blk:   playingcards}', "");
    Expect(1, 127231, '\P{^Is_Blk:   playingcards}', "");
    Expect(0, 127232, '\p{Is_Blk:   playingcards}', "");
    Expect(1, 127232, '\p{^Is_Blk:   playingcards}', "");
    Expect(1, 127232, '\P{Is_Blk:   playingcards}', "");
    Expect(0, 127232, '\P{^Is_Blk:   playingcards}', "");
    Expect(1, 127231, '\p{Is_Blk= Playing_CARDS}', "");
    Expect(0, 127231, '\p{^Is_Blk= Playing_CARDS}', "");
    Expect(0, 127231, '\P{Is_Blk= Playing_CARDS}', "");
    Expect(1, 127231, '\P{^Is_Blk= Playing_CARDS}', "");
    Expect(0, 127232, '\p{Is_Blk= Playing_CARDS}', "");
    Expect(1, 127232, '\p{^Is_Blk= Playing_CARDS}', "");
    Expect(1, 127232, '\P{Is_Blk= Playing_CARDS}', "");
    Expect(0, 127232, '\P{^Is_Blk= Playing_CARDS}', "");
    Error('\p{Block=/a/	PSALTER_pahlavi}');
    Error('\P{Block=/a/	PSALTER_pahlavi}');
    Expect(1, 68527, '\p{Block=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Block=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Block=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Block=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Block=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Block=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Block=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Block=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Block=- psalter_pahlavi}', "");
    Expect(0, 68527, '\p{^Block=- psalter_pahlavi}', "");
    Expect(0, 68527, '\P{Block=- psalter_pahlavi}', "");
    Expect(1, 68527, '\P{^Block=- psalter_pahlavi}', "");
    Expect(0, 68528, '\p{Block=- psalter_pahlavi}', "");
    Expect(1, 68528, '\p{^Block=- psalter_pahlavi}', "");
    Expect(1, 68528, '\P{Block=- psalter_pahlavi}', "");
    Expect(0, 68528, '\P{^Block=- psalter_pahlavi}', "");
    Error('\p{Blk=/a/Psalter_Pahlavi}');
    Error('\P{Blk=/a/Psalter_Pahlavi}');
    Expect(1, 68527, '\p{Blk=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Blk=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Blk=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Blk=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Blk=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Blk=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Blk=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Blk=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Blk=_Psalter_PAHLAVI}', "");
    Expect(0, 68527, '\p{^Blk=_Psalter_PAHLAVI}', "");
    Expect(0, 68527, '\P{Blk=_Psalter_PAHLAVI}', "");
    Expect(1, 68527, '\P{^Blk=_Psalter_PAHLAVI}', "");
    Expect(0, 68528, '\p{Blk=_Psalter_PAHLAVI}', "");
    Expect(1, 68528, '\p{^Blk=_Psalter_PAHLAVI}', "");
    Expect(1, 68528, '\P{Blk=_Psalter_PAHLAVI}', "");
    Expect(0, 68528, '\P{^Blk=_Psalter_PAHLAVI}', "");
    Error('\p{Is_Block=/a/  PSALTER_PAHLAVI}');
    Error('\P{Is_Block=/a/  PSALTER_PAHLAVI}');
    Expect(1, 68527, '\p{Is_Block=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Is_Block=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Is_Block=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Is_Block=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Is_Block=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Is_Block=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Is_Block=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Is_Block=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Is_Block=_PSALTER_Pahlavi}', "");
    Expect(0, 68527, '\p{^Is_Block=_PSALTER_Pahlavi}', "");
    Expect(0, 68527, '\P{Is_Block=_PSALTER_Pahlavi}', "");
    Expect(1, 68527, '\P{^Is_Block=_PSALTER_Pahlavi}', "");
    Expect(0, 68528, '\p{Is_Block=_PSALTER_Pahlavi}', "");
    Expect(1, 68528, '\p{^Is_Block=_PSALTER_Pahlavi}', "");
    Expect(1, 68528, '\P{Is_Block=_PSALTER_Pahlavi}', "");
    Expect(0, 68528, '\P{^Is_Block=_PSALTER_Pahlavi}', "");
    Error('\p{Is_Blk=_/a/PSALTER_PAHLAVI}');
    Error('\P{Is_Blk=_/a/PSALTER_PAHLAVI}');
    Expect(1, 68527, '\p{Is_Blk=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Is_Blk=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Is_Blk=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Is_Blk=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Is_Blk=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Is_Blk=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Is_Blk=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Is_Blk=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Is_Blk=-Psalter_Pahlavi}', "");
    Expect(0, 68527, '\p{^Is_Blk=-Psalter_Pahlavi}', "");
    Expect(0, 68527, '\P{Is_Blk=-Psalter_Pahlavi}', "");
    Expect(1, 68527, '\P{^Is_Blk=-Psalter_Pahlavi}', "");
    Expect(0, 68528, '\p{Is_Blk=-Psalter_Pahlavi}', "");
    Expect(1, 68528, '\p{^Is_Blk=-Psalter_Pahlavi}', "");
    Expect(1, 68528, '\P{Is_Blk=-Psalter_Pahlavi}', "");
    Expect(0, 68528, '\P{^Is_Blk=-Psalter_Pahlavi}', "");
    Error('\p{Block=/a/--Private_USE_AREA}');
    Error('\P{Block=/a/--Private_USE_AREA}');
    Expect(1, 63743, '\p{Block=privateusearea}', "");
    Expect(0, 63743, '\p{^Block=privateusearea}', "");
    Expect(0, 63743, '\P{Block=privateusearea}', "");
    Expect(1, 63743, '\P{^Block=privateusearea}', "");
    Expect(0, 63744, '\p{Block=privateusearea}', "");
    Expect(1, 63744, '\p{^Block=privateusearea}', "");
    Expect(1, 63744, '\P{Block=privateusearea}', "");
    Expect(0, 63744, '\P{^Block=privateusearea}', "");
    Expect(1, 63743, '\p{Block=  PRIVATE_use_Area}', "");
    Expect(0, 63743, '\p{^Block=  PRIVATE_use_Area}', "");
    Expect(0, 63743, '\P{Block=  PRIVATE_use_Area}', "");
    Expect(1, 63743, '\P{^Block=  PRIVATE_use_Area}', "");
    Expect(0, 63744, '\p{Block=  PRIVATE_use_Area}', "");
    Expect(1, 63744, '\p{^Block=  PRIVATE_use_Area}', "");
    Expect(1, 63744, '\P{Block=  PRIVATE_use_Area}', "");
    Expect(0, 63744, '\P{^Block=  PRIVATE_use_Area}', "");
    Error('\p{Blk:	_	pua:=}');
    Error('\P{Blk:	_	pua:=}');
    Expect(1, 63743, '\p{Blk=pua}', "");
    Expect(0, 63743, '\p{^Blk=pua}', "");
    Expect(0, 63743, '\P{Blk=pua}', "");
    Expect(1, 63743, '\P{^Blk=pua}', "");
    Expect(0, 63744, '\p{Blk=pua}', "");
    Expect(1, 63744, '\p{^Blk=pua}', "");
    Expect(1, 63744, '\P{Blk=pua}', "");
    Expect(0, 63744, '\P{^Blk=pua}', "");
    Expect(1, 63743, '\p{Blk= _pua}', "");
    Expect(0, 63743, '\p{^Blk= _pua}', "");
    Expect(0, 63743, '\P{Blk= _pua}', "");
    Expect(1, 63743, '\P{^Blk= _pua}', "");
    Expect(0, 63744, '\p{Blk= _pua}', "");
    Expect(1, 63744, '\p{^Blk= _pua}', "");
    Expect(1, 63744, '\P{Blk= _pua}', "");
    Expect(0, 63744, '\P{^Blk= _pua}', "");
    Error('\p{Is_Block=:=	 Private_use}');
    Error('\P{Is_Block=:=	 Private_use}');
    Expect(1, 63743, '\p{Is_Block=privateuse}', "");
    Expect(0, 63743, '\p{^Is_Block=privateuse}', "");
    Expect(0, 63743, '\P{Is_Block=privateuse}', "");
    Expect(1, 63743, '\P{^Is_Block=privateuse}', "");
    Expect(0, 63744, '\p{Is_Block=privateuse}', "");
    Expect(1, 63744, '\p{^Is_Block=privateuse}', "");
    Expect(1, 63744, '\P{Is_Block=privateuse}', "");
    Expect(0, 63744, '\P{^Is_Block=privateuse}', "");
    Expect(1, 63743, '\p{Is_Block=	_Private_use}', "");
    Expect(0, 63743, '\p{^Is_Block=	_Private_use}', "");
    Expect(0, 63743, '\P{Is_Block=	_Private_use}', "");
    Expect(1, 63743, '\P{^Is_Block=	_Private_use}', "");
    Expect(0, 63744, '\p{Is_Block=	_Private_use}', "");
    Expect(1, 63744, '\p{^Is_Block=	_Private_use}', "");
    Expect(1, 63744, '\P{Is_Block=	_Private_use}', "");
    Expect(0, 63744, '\P{^Is_Block=	_Private_use}', "");
    Error('\p{Is_Blk= :=Private_Use_Area}');
    Error('\P{Is_Blk= :=Private_Use_Area}');
    Expect(1, 63743, '\p{Is_Blk=privateusearea}', "");
    Expect(0, 63743, '\p{^Is_Blk=privateusearea}', "");
    Expect(0, 63743, '\P{Is_Blk=privateusearea}', "");
    Expect(1, 63743, '\P{^Is_Blk=privateusearea}', "");
    Expect(0, 63744, '\p{Is_Blk=privateusearea}', "");
    Expect(1, 63744, '\p{^Is_Blk=privateusearea}', "");
    Expect(1, 63744, '\P{Is_Blk=privateusearea}', "");
    Expect(0, 63744, '\P{^Is_Blk=privateusearea}', "");
    Expect(1, 63743, '\p{Is_Blk=	 Private_USE_Area}', "");
    Expect(0, 63743, '\p{^Is_Blk=	 Private_USE_Area}', "");
    Expect(0, 63743, '\P{Is_Blk=	 Private_USE_Area}', "");
    Expect(1, 63743, '\P{^Is_Blk=	 Private_USE_Area}', "");
    Expect(0, 63744, '\p{Is_Blk=	 Private_USE_Area}', "");
    Expect(1, 63744, '\p{^Is_Blk=	 Private_USE_Area}', "");
    Expect(1, 63744, '\P{Is_Blk=	 Private_USE_Area}', "");
    Expect(0, 63744, '\P{^Is_Blk=	 Private_USE_Area}', "");
    Error('\p{Block=:=-General_PUNCTUATION}');
    Error('\P{Block=:=-General_PUNCTUATION}');
    Expect(1, 8303, '\p{Block=generalpunctuation}', "");
    Expect(0, 8303, '\p{^Block=generalpunctuation}', "");
    Expect(0, 8303, '\P{Block=generalpunctuation}', "");
    Expect(1, 8303, '\P{^Block=generalpunctuation}', "");
    Expect(0, 8304, '\p{Block=generalpunctuation}', "");
    Expect(1, 8304, '\p{^Block=generalpunctuation}', "");
    Expect(1, 8304, '\P{Block=generalpunctuation}', "");
    Expect(0, 8304, '\P{^Block=generalpunctuation}', "");
    Expect(1, 8303, '\p{Block=	-GENERAL_Punctuation}', "");
    Expect(0, 8303, '\p{^Block=	-GENERAL_Punctuation}', "");
    Expect(0, 8303, '\P{Block=	-GENERAL_Punctuation}', "");
    Expect(1, 8303, '\P{^Block=	-GENERAL_Punctuation}', "");
    Expect(0, 8304, '\p{Block=	-GENERAL_Punctuation}', "");
    Expect(1, 8304, '\p{^Block=	-GENERAL_Punctuation}', "");
    Expect(1, 8304, '\P{Block=	-GENERAL_Punctuation}', "");
    Expect(0, 8304, '\P{^Block=	-GENERAL_Punctuation}', "");
    Error('\p{Blk=/a/	-Punctuation}');
    Error('\P{Blk=/a/	-Punctuation}');
    Expect(1, 8303, '\p{Blk=punctuation}', "");
    Expect(0, 8303, '\p{^Blk=punctuation}', "");
    Expect(0, 8303, '\P{Blk=punctuation}', "");
    Expect(1, 8303, '\P{^Blk=punctuation}', "");
    Expect(0, 8304, '\p{Blk=punctuation}', "");
    Expect(1, 8304, '\p{^Blk=punctuation}', "");
    Expect(1, 8304, '\P{Blk=punctuation}', "");
    Expect(0, 8304, '\P{^Blk=punctuation}', "");
    Expect(1, 8303, '\p{Blk:	PUNCTUATION}', "");
    Expect(0, 8303, '\p{^Blk:	PUNCTUATION}', "");
    Expect(0, 8303, '\P{Blk:	PUNCTUATION}', "");
    Expect(1, 8303, '\P{^Blk:	PUNCTUATION}', "");
    Expect(0, 8304, '\p{Blk:	PUNCTUATION}', "");
    Expect(1, 8304, '\p{^Blk:	PUNCTUATION}', "");
    Expect(1, 8304, '\P{Blk:	PUNCTUATION}', "");
    Expect(0, 8304, '\P{^Blk:	PUNCTUATION}', "");
    Error('\p{Is_Block:   	:=General_Punctuation}');
    Error('\P{Is_Block:   	:=General_Punctuation}');
    Expect(1, 8303, '\p{Is_Block:generalpunctuation}', "");
    Expect(0, 8303, '\p{^Is_Block:generalpunctuation}', "");
    Expect(0, 8303, '\P{Is_Block:generalpunctuation}', "");
    Expect(1, 8303, '\P{^Is_Block:generalpunctuation}', "");
    Expect(0, 8304, '\p{Is_Block:generalpunctuation}', "");
    Expect(1, 8304, '\p{^Is_Block:generalpunctuation}', "");
    Expect(1, 8304, '\P{Is_Block:generalpunctuation}', "");
    Expect(0, 8304, '\P{^Is_Block:generalpunctuation}', "");
    Expect(1, 8303, '\p{Is_Block=_ GENERAL_Punctuation}', "");
    Expect(0, 8303, '\p{^Is_Block=_ GENERAL_Punctuation}', "");
    Expect(0, 8303, '\P{Is_Block=_ GENERAL_Punctuation}', "");
    Expect(1, 8303, '\P{^Is_Block=_ GENERAL_Punctuation}', "");
    Expect(0, 8304, '\p{Is_Block=_ GENERAL_Punctuation}', "");
    Expect(1, 8304, '\p{^Is_Block=_ GENERAL_Punctuation}', "");
    Expect(1, 8304, '\P{Is_Block=_ GENERAL_Punctuation}', "");
    Expect(0, 8304, '\P{^Is_Block=_ GENERAL_Punctuation}', "");
    Error('\p{Is_Blk=_:=PUNCTUATION}');
    Error('\P{Is_Blk=_:=PUNCTUATION}');
    Expect(1, 8303, '\p{Is_Blk=punctuation}', "");
    Expect(0, 8303, '\p{^Is_Blk=punctuation}', "");
    Expect(0, 8303, '\P{Is_Blk=punctuation}', "");
    Expect(1, 8303, '\P{^Is_Blk=punctuation}', "");
    Expect(0, 8304, '\p{Is_Blk=punctuation}', "");
    Expect(1, 8304, '\p{^Is_Blk=punctuation}', "");
    Expect(1, 8304, '\P{Is_Blk=punctuation}', "");
    Expect(0, 8304, '\P{^Is_Blk=punctuation}', "");
    Expect(1, 8303, '\p{Is_Blk=	punctuation}', "");
    Expect(0, 8303, '\p{^Is_Blk=	punctuation}', "");
    Expect(0, 8303, '\P{Is_Blk=	punctuation}', "");
    Expect(1, 8303, '\P{^Is_Blk=	punctuation}', "");
    Expect(0, 8304, '\p{Is_Blk=	punctuation}', "");
    Expect(1, 8304, '\p{^Is_Blk=	punctuation}', "");
    Expect(1, 8304, '\P{Is_Blk=	punctuation}', "");
    Expect(0, 8304, '\P{^Is_Blk=	punctuation}', "");
    Error('\p{Block=	/a/REJANG}');
    Error('\P{Block=	/a/REJANG}');
    Expect(1, 43359, '\p{Block=rejang}', "");
    Expect(0, 43359, '\p{^Block=rejang}', "");
    Expect(0, 43359, '\P{Block=rejang}', "");
    Expect(1, 43359, '\P{^Block=rejang}', "");
    Expect(0, 43360, '\p{Block=rejang}', "");
    Expect(1, 43360, '\p{^Block=rejang}', "");
    Expect(1, 43360, '\P{Block=rejang}', "");
    Expect(0, 43360, '\P{^Block=rejang}', "");
    Expect(1, 43359, '\p{Block=_ REJANG}', "");
    Expect(0, 43359, '\p{^Block=_ REJANG}', "");
    Expect(0, 43359, '\P{Block=_ REJANG}', "");
    Expect(1, 43359, '\P{^Block=_ REJANG}', "");
    Expect(0, 43360, '\p{Block=_ REJANG}', "");
    Expect(1, 43360, '\p{^Block=_ REJANG}', "");
    Expect(1, 43360, '\P{Block=_ REJANG}', "");
    Expect(0, 43360, '\P{^Block=_ REJANG}', "");
    Error('\p{Blk=-/a/Rejang}');
    Error('\P{Blk=-/a/Rejang}');
    Expect(1, 43359, '\p{Blk=rejang}', "");
    Expect(0, 43359, '\p{^Blk=rejang}', "");
    Expect(0, 43359, '\P{Blk=rejang}', "");
    Expect(1, 43359, '\P{^Blk=rejang}', "");
    Expect(0, 43360, '\p{Blk=rejang}', "");
    Expect(1, 43360, '\p{^Blk=rejang}', "");
    Expect(1, 43360, '\P{Blk=rejang}', "");
    Expect(0, 43360, '\P{^Blk=rejang}', "");
    Expect(1, 43359, '\p{Blk:    _rejang}', "");
    Expect(0, 43359, '\p{^Blk:    _rejang}', "");
    Expect(0, 43359, '\P{Blk:    _rejang}', "");
    Expect(1, 43359, '\P{^Blk:    _rejang}', "");
    Expect(0, 43360, '\p{Blk:    _rejang}', "");
    Expect(1, 43360, '\p{^Blk:    _rejang}', "");
    Expect(1, 43360, '\P{Blk:    _rejang}', "");
    Expect(0, 43360, '\P{^Blk:    _rejang}', "");
    Error('\p{Is_Block=:=	_Rejang}');
    Error('\P{Is_Block=:=	_Rejang}');
    Expect(1, 43359, '\p{Is_Block=rejang}', "");
    Expect(0, 43359, '\p{^Is_Block=rejang}', "");
    Expect(0, 43359, '\P{Is_Block=rejang}', "");
    Expect(1, 43359, '\P{^Is_Block=rejang}', "");
    Expect(0, 43360, '\p{Is_Block=rejang}', "");
    Expect(1, 43360, '\p{^Is_Block=rejang}', "");
    Expect(1, 43360, '\P{Is_Block=rejang}', "");
    Expect(0, 43360, '\P{^Is_Block=rejang}', "");
    Expect(1, 43359, '\p{Is_Block:__REJANG}', "");
    Expect(0, 43359, '\p{^Is_Block:__REJANG}', "");
    Expect(0, 43359, '\P{Is_Block:__REJANG}', "");
    Expect(1, 43359, '\P{^Is_Block:__REJANG}', "");
    Expect(0, 43360, '\p{Is_Block:__REJANG}', "");
    Expect(1, 43360, '\p{^Is_Block:__REJANG}', "");
    Expect(1, 43360, '\P{Is_Block:__REJANG}', "");
    Expect(0, 43360, '\P{^Is_Block:__REJANG}', "");
    Error('\p{Is_Blk=/a/ 	REJANG}');
    Error('\P{Is_Blk=/a/ 	REJANG}');
    Expect(1, 43359, '\p{Is_Blk=rejang}', "");
    Expect(0, 43359, '\p{^Is_Blk=rejang}', "");
    Expect(0, 43359, '\P{Is_Blk=rejang}', "");
    Expect(1, 43359, '\P{^Is_Blk=rejang}', "");
    Expect(0, 43360, '\p{Is_Blk=rejang}', "");
    Expect(1, 43360, '\p{^Is_Blk=rejang}', "");
    Expect(1, 43360, '\P{Is_Blk=rejang}', "");
    Expect(0, 43360, '\P{^Is_Blk=rejang}', "");
    Expect(1, 43359, '\p{Is_Blk= REJANG}', "");
    Expect(0, 43359, '\p{^Is_Blk= REJANG}', "");
    Expect(0, 43359, '\P{Is_Blk= REJANG}', "");
    Expect(1, 43359, '\P{^Is_Blk= REJANG}', "");
    Expect(0, 43360, '\p{Is_Blk= REJANG}', "");
    Expect(1, 43360, '\p{^Is_Blk= REJANG}', "");
    Expect(1, 43360, '\P{Is_Blk= REJANG}', "");
    Expect(0, 43360, '\P{^Is_Blk= REJANG}', "");
    Error('\p{Block=	/a/RUMI_Numeral_symbols}');
    Error('\P{Block=	/a/RUMI_Numeral_symbols}');
    Expect(1, 69247, '\p{Block=ruminumeralsymbols}', "");
    Expect(0, 69247, '\p{^Block=ruminumeralsymbols}', "");
    Expect(0, 69247, '\P{Block=ruminumeralsymbols}', "");
    Expect(1, 69247, '\P{^Block=ruminumeralsymbols}', "");
    Expect(0, 69248, '\p{Block=ruminumeralsymbols}', "");
    Expect(1, 69248, '\p{^Block=ruminumeralsymbols}', "");
    Expect(1, 69248, '\P{Block=ruminumeralsymbols}', "");
    Expect(0, 69248, '\P{^Block=ruminumeralsymbols}', "");
    Expect(1, 69247, '\p{Block=-_Rumi_numeral_Symbols}', "");
    Expect(0, 69247, '\p{^Block=-_Rumi_numeral_Symbols}', "");
    Expect(0, 69247, '\P{Block=-_Rumi_numeral_Symbols}', "");
    Expect(1, 69247, '\P{^Block=-_Rumi_numeral_Symbols}', "");
    Expect(0, 69248, '\p{Block=-_Rumi_numeral_Symbols}', "");
    Expect(1, 69248, '\p{^Block=-_Rumi_numeral_Symbols}', "");
    Expect(1, 69248, '\P{Block=-_Rumi_numeral_Symbols}', "");
    Expect(0, 69248, '\P{^Block=-_Rumi_numeral_Symbols}', "");
    Error('\p{Blk=	_Rumi/a/}');
    Error('\P{Blk=	_Rumi/a/}');
    Expect(1, 69247, '\p{Blk=rumi}', "");
    Expect(0, 69247, '\p{^Blk=rumi}', "");
    Expect(0, 69247, '\P{Blk=rumi}', "");
    Expect(1, 69247, '\P{^Blk=rumi}', "");
    Expect(0, 69248, '\p{Blk=rumi}', "");
    Expect(1, 69248, '\p{^Blk=rumi}', "");
    Expect(1, 69248, '\P{Blk=rumi}', "");
    Expect(0, 69248, '\P{^Blk=rumi}', "");
    Expect(1, 69247, '\p{Blk=	RUMI}', "");
    Expect(0, 69247, '\p{^Blk=	RUMI}', "");
    Expect(0, 69247, '\P{Blk=	RUMI}', "");
    Expect(1, 69247, '\P{^Blk=	RUMI}', "");
    Expect(0, 69248, '\p{Blk=	RUMI}', "");
    Expect(1, 69248, '\p{^Blk=	RUMI}', "");
    Expect(1, 69248, '\P{Blk=	RUMI}', "");
    Expect(0, 69248, '\P{^Blk=	RUMI}', "");
    Error('\p{Is_Block=	Rumi_numeral_symbols/a/}');
    Error('\P{Is_Block=	Rumi_numeral_symbols/a/}');
    Expect(1, 69247, '\p{Is_Block=ruminumeralsymbols}', "");
    Expect(0, 69247, '\p{^Is_Block=ruminumeralsymbols}', "");
    Expect(0, 69247, '\P{Is_Block=ruminumeralsymbols}', "");
    Expect(1, 69247, '\P{^Is_Block=ruminumeralsymbols}', "");
    Expect(0, 69248, '\p{Is_Block=ruminumeralsymbols}', "");
    Expect(1, 69248, '\p{^Is_Block=ruminumeralsymbols}', "");
    Expect(1, 69248, '\P{Is_Block=ruminumeralsymbols}', "");
    Expect(0, 69248, '\P{^Is_Block=ruminumeralsymbols}', "");
    Expect(1, 69247, '\p{Is_Block=  Rumi_NUMERAL_Symbols}', "");
    Expect(0, 69247, '\p{^Is_Block=  Rumi_NUMERAL_Symbols}', "");
    Expect(0, 69247, '\P{Is_Block=  Rumi_NUMERAL_Symbols}', "");
    Expect(1, 69247, '\P{^Is_Block=  Rumi_NUMERAL_Symbols}', "");
    Expect(0, 69248, '\p{Is_Block=  Rumi_NUMERAL_Symbols}', "");
    Expect(1, 69248, '\p{^Is_Block=  Rumi_NUMERAL_Symbols}', "");
    Expect(1, 69248, '\P{Is_Block=  Rumi_NUMERAL_Symbols}', "");
    Expect(0, 69248, '\P{^Is_Block=  Rumi_NUMERAL_Symbols}', "");
    Error('\p{Is_Blk= 	Rumi:=}');
    Error('\P{Is_Blk= 	Rumi:=}');
    Expect(1, 69247, '\p{Is_Blk:   rumi}', "");
    Expect(0, 69247, '\p{^Is_Blk:   rumi}', "");
    Expect(0, 69247, '\P{Is_Blk:   rumi}', "");
    Expect(1, 69247, '\P{^Is_Blk:   rumi}', "");
    Expect(0, 69248, '\p{Is_Blk:   rumi}', "");
    Expect(1, 69248, '\p{^Is_Blk:   rumi}', "");
    Expect(1, 69248, '\P{Is_Blk:   rumi}', "");
    Expect(0, 69248, '\P{^Is_Blk:   rumi}', "");
    Expect(1, 69247, '\p{Is_Blk=-_RUMI}', "");
    Expect(0, 69247, '\p{^Is_Blk=-_RUMI}', "");
    Expect(0, 69247, '\P{Is_Blk=-_RUMI}', "");
    Expect(1, 69247, '\P{^Is_Blk=-_RUMI}', "");
    Expect(0, 69248, '\p{Is_Blk=-_RUMI}', "");
    Expect(1, 69248, '\p{^Is_Blk=-_RUMI}', "");
    Expect(1, 69248, '\P{Is_Blk=-_RUMI}', "");
    Expect(0, 69248, '\P{^Is_Blk=-_RUMI}', "");
    Error('\p{Block=:=_Runic}');
    Error('\P{Block=:=_Runic}');
    Expect(1, 5887, '\p{Block=runic}', "");
    Expect(0, 5887, '\p{^Block=runic}', "");
    Expect(0, 5887, '\P{Block=runic}', "");
    Expect(1, 5887, '\P{^Block=runic}', "");
    Expect(0, 5888, '\p{Block=runic}', "");
    Expect(1, 5888, '\p{^Block=runic}', "");
    Expect(1, 5888, '\P{Block=runic}', "");
    Expect(0, 5888, '\P{^Block=runic}', "");
    Expect(1, 5887, '\p{Block=- Runic}', "");
    Expect(0, 5887, '\p{^Block=- Runic}', "");
    Expect(0, 5887, '\P{Block=- Runic}', "");
    Expect(1, 5887, '\P{^Block=- Runic}', "");
    Expect(0, 5888, '\p{Block=- Runic}', "");
    Expect(1, 5888, '\p{^Block=- Runic}', "");
    Expect(1, 5888, '\P{Block=- Runic}', "");
    Expect(0, 5888, '\P{^Block=- Runic}', "");
    Error('\p{Blk:	_/a/Runic}');
    Error('\P{Blk:	_/a/Runic}');
    Expect(1, 5887, '\p{Blk=runic}', "");
    Expect(0, 5887, '\p{^Blk=runic}', "");
    Expect(0, 5887, '\P{Blk=runic}', "");
    Expect(1, 5887, '\P{^Blk=runic}', "");
    Expect(0, 5888, '\p{Blk=runic}', "");
    Expect(1, 5888, '\p{^Blk=runic}', "");
    Expect(1, 5888, '\P{Blk=runic}', "");
    Expect(0, 5888, '\P{^Blk=runic}', "");
    Expect(1, 5887, '\p{Blk=_	RUNIC}', "");
    Expect(0, 5887, '\p{^Blk=_	RUNIC}', "");
    Expect(0, 5887, '\P{Blk=_	RUNIC}', "");
    Expect(1, 5887, '\P{^Blk=_	RUNIC}', "");
    Expect(0, 5888, '\p{Blk=_	RUNIC}', "");
    Expect(1, 5888, '\p{^Blk=_	RUNIC}', "");
    Expect(1, 5888, '\P{Blk=_	RUNIC}', "");
    Expect(0, 5888, '\P{^Blk=_	RUNIC}', "");
    Error('\p{Is_Block=/a/	RUNIC}');
    Error('\P{Is_Block=/a/	RUNIC}');
    Expect(1, 5887, '\p{Is_Block:	runic}', "");
    Expect(0, 5887, '\p{^Is_Block:	runic}', "");
    Expect(0, 5887, '\P{Is_Block:	runic}', "");
    Expect(1, 5887, '\P{^Is_Block:	runic}', "");
    Expect(0, 5888, '\p{Is_Block:	runic}', "");
    Expect(1, 5888, '\p{^Is_Block:	runic}', "");
    Expect(1, 5888, '\P{Is_Block:	runic}', "");
    Expect(0, 5888, '\P{^Is_Block:	runic}', "");
    Expect(1, 5887, '\p{Is_Block=_Runic}', "");
    Expect(0, 5887, '\p{^Is_Block=_Runic}', "");
    Expect(0, 5887, '\P{Is_Block=_Runic}', "");
    Expect(1, 5887, '\P{^Is_Block=_Runic}', "");
    Expect(0, 5888, '\p{Is_Block=_Runic}', "");
    Expect(1, 5888, '\p{^Is_Block=_Runic}', "");
    Expect(1, 5888, '\P{Is_Block=_Runic}', "");
    Expect(0, 5888, '\P{^Is_Block=_Runic}', "");
    Error('\p{Is_Blk: :=Runic}');
    Error('\P{Is_Blk: :=Runic}');
    Expect(1, 5887, '\p{Is_Blk=runic}', "");
    Expect(0, 5887, '\p{^Is_Blk=runic}', "");
    Expect(0, 5887, '\P{Is_Blk=runic}', "");
    Expect(1, 5887, '\P{^Is_Blk=runic}', "");
    Expect(0, 5888, '\p{Is_Blk=runic}', "");
    Expect(1, 5888, '\p{^Is_Blk=runic}', "");
    Expect(1, 5888, '\P{Is_Blk=runic}', "");
    Expect(0, 5888, '\P{^Is_Blk=runic}', "");
    Expect(1, 5887, '\p{Is_Blk=  RUNIC}', "");
    Expect(0, 5887, '\p{^Is_Blk=  RUNIC}', "");
    Expect(0, 5887, '\P{Is_Blk=  RUNIC}', "");
    Expect(1, 5887, '\P{^Is_Blk=  RUNIC}', "");
    Expect(0, 5888, '\p{Is_Blk=  RUNIC}', "");
    Expect(1, 5888, '\p{^Is_Blk=  RUNIC}', "");
    Expect(1, 5888, '\P{Is_Blk=  RUNIC}', "");
    Expect(0, 5888, '\P{^Is_Blk=  RUNIC}', "");
    Error('\p{Block=/a/	_samaritan}');
    Error('\P{Block=/a/	_samaritan}');
    Expect(1, 2111, '\p{Block=samaritan}', "");
    Expect(0, 2111, '\p{^Block=samaritan}', "");
    Expect(0, 2111, '\P{Block=samaritan}', "");
    Expect(1, 2111, '\P{^Block=samaritan}', "");
    Expect(0, 2112, '\p{Block=samaritan}', "");
    Expect(1, 2112, '\p{^Block=samaritan}', "");
    Expect(1, 2112, '\P{Block=samaritan}', "");
    Expect(0, 2112, '\P{^Block=samaritan}', "");
    Expect(1, 2111, '\p{Block=-Samaritan}', "");
    Expect(0, 2111, '\p{^Block=-Samaritan}', "");
    Expect(0, 2111, '\P{Block=-Samaritan}', "");
    Expect(1, 2111, '\P{^Block=-Samaritan}', "");
    Expect(0, 2112, '\p{Block=-Samaritan}', "");
    Expect(1, 2112, '\p{^Block=-Samaritan}', "");
    Expect(1, 2112, '\P{Block=-Samaritan}', "");
    Expect(0, 2112, '\P{^Block=-Samaritan}', "");
    Error('\p{Blk: := _SAMARITAN}');
    Error('\P{Blk: := _SAMARITAN}');
    Expect(1, 2111, '\p{Blk=samaritan}', "");
    Expect(0, 2111, '\p{^Blk=samaritan}', "");
    Expect(0, 2111, '\P{Blk=samaritan}', "");
    Expect(1, 2111, '\P{^Blk=samaritan}', "");
    Expect(0, 2112, '\p{Blk=samaritan}', "");
    Expect(1, 2112, '\p{^Blk=samaritan}', "");
    Expect(1, 2112, '\P{Blk=samaritan}', "");
    Expect(0, 2112, '\P{^Blk=samaritan}', "");
    Expect(1, 2111, '\p{Blk=	Samaritan}', "");
    Expect(0, 2111, '\p{^Blk=	Samaritan}', "");
    Expect(0, 2111, '\P{Blk=	Samaritan}', "");
    Expect(1, 2111, '\P{^Blk=	Samaritan}', "");
    Expect(0, 2112, '\p{Blk=	Samaritan}', "");
    Expect(1, 2112, '\p{^Blk=	Samaritan}', "");
    Expect(1, 2112, '\P{Blk=	Samaritan}', "");
    Expect(0, 2112, '\P{^Blk=	Samaritan}', "");
    Error('\p{Is_Block=_Samaritan/a/}');
    Error('\P{Is_Block=_Samaritan/a/}');
    Expect(1, 2111, '\p{Is_Block=samaritan}', "");
    Expect(0, 2111, '\p{^Is_Block=samaritan}', "");
    Expect(0, 2111, '\P{Is_Block=samaritan}', "");
    Expect(1, 2111, '\P{^Is_Block=samaritan}', "");
    Expect(0, 2112, '\p{Is_Block=samaritan}', "");
    Expect(1, 2112, '\p{^Is_Block=samaritan}', "");
    Expect(1, 2112, '\P{Is_Block=samaritan}', "");
    Expect(0, 2112, '\P{^Is_Block=samaritan}', "");
    Expect(1, 2111, '\p{Is_Block=-	samaritan}', "");
    Expect(0, 2111, '\p{^Is_Block=-	samaritan}', "");
    Expect(0, 2111, '\P{Is_Block=-	samaritan}', "");
    Expect(1, 2111, '\P{^Is_Block=-	samaritan}', "");
    Expect(0, 2112, '\p{Is_Block=-	samaritan}', "");
    Expect(1, 2112, '\p{^Is_Block=-	samaritan}', "");
    Expect(1, 2112, '\P{Is_Block=-	samaritan}', "");
    Expect(0, 2112, '\P{^Is_Block=-	samaritan}', "");
    Error('\p{Is_Blk=-/a/samaritan}');
    Error('\P{Is_Blk=-/a/samaritan}');
    Expect(1, 2111, '\p{Is_Blk=samaritan}', "");
    Expect(0, 2111, '\p{^Is_Blk=samaritan}', "");
    Expect(0, 2111, '\P{Is_Blk=samaritan}', "");
    Expect(1, 2111, '\P{^Is_Blk=samaritan}', "");
    Expect(0, 2112, '\p{Is_Blk=samaritan}', "");
    Expect(1, 2112, '\p{^Is_Blk=samaritan}', "");
    Expect(1, 2112, '\P{Is_Blk=samaritan}', "");
    Expect(0, 2112, '\P{^Is_Blk=samaritan}', "");
    Expect(1, 2111, '\p{Is_Blk=__SAMARITAN}', "");
    Expect(0, 2111, '\p{^Is_Blk=__SAMARITAN}', "");
    Expect(0, 2111, '\P{Is_Blk=__SAMARITAN}', "");
    Expect(1, 2111, '\P{^Is_Blk=__SAMARITAN}', "");
    Expect(0, 2112, '\p{Is_Blk=__SAMARITAN}', "");
    Expect(1, 2112, '\p{^Is_Blk=__SAMARITAN}', "");
    Expect(1, 2112, '\P{Is_Blk=__SAMARITAN}', "");
    Expect(0, 2112, '\P{^Is_Blk=__SAMARITAN}', "");
    Error('\p{Block=_:=Saurashtra}');
    Error('\P{Block=_:=Saurashtra}');
    Expect(1, 43231, '\p{Block=saurashtra}', "");
    Expect(0, 43231, '\p{^Block=saurashtra}', "");
    Expect(0, 43231, '\P{Block=saurashtra}', "");
    Expect(1, 43231, '\P{^Block=saurashtra}', "");
    Expect(0, 43232, '\p{Block=saurashtra}', "");
    Expect(1, 43232, '\p{^Block=saurashtra}', "");
    Expect(1, 43232, '\P{Block=saurashtra}', "");
    Expect(0, 43232, '\P{^Block=saurashtra}', "");
    Expect(1, 43231, '\p{Block=	-SAURASHTRA}', "");
    Expect(0, 43231, '\p{^Block=	-SAURASHTRA}', "");
    Expect(0, 43231, '\P{Block=	-SAURASHTRA}', "");
    Expect(1, 43231, '\P{^Block=	-SAURASHTRA}', "");
    Expect(0, 43232, '\p{Block=	-SAURASHTRA}', "");
    Expect(1, 43232, '\p{^Block=	-SAURASHTRA}', "");
    Expect(1, 43232, '\P{Block=	-SAURASHTRA}', "");
    Expect(0, 43232, '\P{^Block=	-SAURASHTRA}', "");
    Error('\p{Blk: 	Saurashtra/a/}');
    Error('\P{Blk: 	Saurashtra/a/}');
    Expect(1, 43231, '\p{Blk=saurashtra}', "");
    Expect(0, 43231, '\p{^Blk=saurashtra}', "");
    Expect(0, 43231, '\P{Blk=saurashtra}', "");
    Expect(1, 43231, '\P{^Blk=saurashtra}', "");
    Expect(0, 43232, '\p{Blk=saurashtra}', "");
    Expect(1, 43232, '\p{^Blk=saurashtra}', "");
    Expect(1, 43232, '\P{Blk=saurashtra}', "");
    Expect(0, 43232, '\P{^Blk=saurashtra}', "");
    Expect(1, 43231, '\p{Blk=- SAURASHTRA}', "");
    Expect(0, 43231, '\p{^Blk=- SAURASHTRA}', "");
    Expect(0, 43231, '\P{Blk=- SAURASHTRA}', "");
    Expect(1, 43231, '\P{^Blk=- SAURASHTRA}', "");
    Expect(0, 43232, '\p{Blk=- SAURASHTRA}', "");
    Expect(1, 43232, '\p{^Blk=- SAURASHTRA}', "");
    Expect(1, 43232, '\P{Blk=- SAURASHTRA}', "");
    Expect(0, 43232, '\P{^Blk=- SAURASHTRA}', "");
    Error('\p{Is_Block=:=Saurashtra}');
    Error('\P{Is_Block=:=Saurashtra}');
    Expect(1, 43231, '\p{Is_Block=saurashtra}', "");
    Expect(0, 43231, '\p{^Is_Block=saurashtra}', "");
    Expect(0, 43231, '\P{Is_Block=saurashtra}', "");
    Expect(1, 43231, '\P{^Is_Block=saurashtra}', "");
    Expect(0, 43232, '\p{Is_Block=saurashtra}', "");
    Expect(1, 43232, '\p{^Is_Block=saurashtra}', "");
    Expect(1, 43232, '\P{Is_Block=saurashtra}', "");
    Expect(0, 43232, '\P{^Is_Block=saurashtra}', "");
    Expect(1, 43231, '\p{Is_Block= _Saurashtra}', "");
    Expect(0, 43231, '\p{^Is_Block= _Saurashtra}', "");
    Expect(0, 43231, '\P{Is_Block= _Saurashtra}', "");
    Expect(1, 43231, '\P{^Is_Block= _Saurashtra}', "");
    Expect(0, 43232, '\p{Is_Block= _Saurashtra}', "");
    Expect(1, 43232, '\p{^Is_Block= _Saurashtra}', "");
    Expect(1, 43232, '\P{Is_Block= _Saurashtra}', "");
    Expect(0, 43232, '\P{^Is_Block= _Saurashtra}', "");
    Error('\p{Is_Blk=_:=Saurashtra}');
    Error('\P{Is_Blk=_:=Saurashtra}');
    Expect(1, 43231, '\p{Is_Blk=saurashtra}', "");
    Expect(0, 43231, '\p{^Is_Blk=saurashtra}', "");
    Expect(0, 43231, '\P{Is_Blk=saurashtra}', "");
    Expect(1, 43231, '\P{^Is_Blk=saurashtra}', "");
    Expect(0, 43232, '\p{Is_Blk=saurashtra}', "");
    Expect(1, 43232, '\p{^Is_Blk=saurashtra}', "");
    Expect(1, 43232, '\P{Is_Blk=saurashtra}', "");
    Expect(0, 43232, '\P{^Is_Blk=saurashtra}', "");
    Expect(1, 43231, '\p{Is_Blk=	saurashtra}', "");
    Expect(0, 43231, '\p{^Is_Blk=	saurashtra}', "");
    Expect(0, 43231, '\P{Is_Blk=	saurashtra}', "");
    Expect(1, 43231, '\P{^Is_Blk=	saurashtra}', "");
    Expect(0, 43232, '\p{Is_Blk=	saurashtra}', "");
    Expect(1, 43232, '\p{^Is_Blk=	saurashtra}', "");
    Expect(1, 43232, '\P{Is_Blk=	saurashtra}', "");
    Expect(0, 43232, '\P{^Is_Blk=	saurashtra}', "");
    Error('\p{Block= Sharada/a/}');
    Error('\P{Block= Sharada/a/}');
    Expect(1, 70111, '\p{Block=sharada}', "");
    Expect(0, 70111, '\p{^Block=sharada}', "");
    Expect(0, 70111, '\P{Block=sharada}', "");
    Expect(1, 70111, '\P{^Block=sharada}', "");
    Expect(0, 70112, '\p{Block=sharada}', "");
    Expect(1, 70112, '\p{^Block=sharada}', "");
    Expect(1, 70112, '\P{Block=sharada}', "");
    Expect(0, 70112, '\P{^Block=sharada}', "");
    Expect(1, 70111, '\p{Block=-	Sharada}', "");
    Expect(0, 70111, '\p{^Block=-	Sharada}', "");
    Expect(0, 70111, '\P{Block=-	Sharada}', "");
    Expect(1, 70111, '\P{^Block=-	Sharada}', "");
    Expect(0, 70112, '\p{Block=-	Sharada}', "");
    Expect(1, 70112, '\p{^Block=-	Sharada}', "");
    Expect(1, 70112, '\P{Block=-	Sharada}', "");
    Expect(0, 70112, '\P{^Block=-	Sharada}', "");
    Error('\p{Blk=_-SHARADA/a/}');
    Error('\P{Blk=_-SHARADA/a/}');
    Expect(1, 70111, '\p{Blk=sharada}', "");
    Expect(0, 70111, '\p{^Blk=sharada}', "");
    Expect(0, 70111, '\P{Blk=sharada}', "");
    Expect(1, 70111, '\P{^Blk=sharada}', "");
    Expect(0, 70112, '\p{Blk=sharada}', "");
    Expect(1, 70112, '\p{^Blk=sharada}', "");
    Expect(1, 70112, '\P{Blk=sharada}', "");
    Expect(0, 70112, '\P{^Blk=sharada}', "");
    Expect(1, 70111, '\p{Blk=--Sharada}', "");
    Expect(0, 70111, '\p{^Blk=--Sharada}', "");
    Expect(0, 70111, '\P{Blk=--Sharada}', "");
    Expect(1, 70111, '\P{^Blk=--Sharada}', "");
    Expect(0, 70112, '\p{Blk=--Sharada}', "");
    Expect(1, 70112, '\p{^Blk=--Sharada}', "");
    Expect(1, 70112, '\P{Blk=--Sharada}', "");
    Expect(0, 70112, '\P{^Blk=--Sharada}', "");
    Error('\p{Is_Block=-	Sharada/a/}');
    Error('\P{Is_Block=-	Sharada/a/}');
    Expect(1, 70111, '\p{Is_Block:   sharada}', "");
    Expect(0, 70111, '\p{^Is_Block:   sharada}', "");
    Expect(0, 70111, '\P{Is_Block:   sharada}', "");
    Expect(1, 70111, '\P{^Is_Block:   sharada}', "");
    Expect(0, 70112, '\p{Is_Block:   sharada}', "");
    Expect(1, 70112, '\p{^Is_Block:   sharada}', "");
    Expect(1, 70112, '\P{Is_Block:   sharada}', "");
    Expect(0, 70112, '\P{^Is_Block:   sharada}', "");
    Expect(1, 70111, '\p{Is_Block=__SHARADA}', "");
    Expect(0, 70111, '\p{^Is_Block=__SHARADA}', "");
    Expect(0, 70111, '\P{Is_Block=__SHARADA}', "");
    Expect(1, 70111, '\P{^Is_Block=__SHARADA}', "");
    Expect(0, 70112, '\p{Is_Block=__SHARADA}', "");
    Expect(1, 70112, '\p{^Is_Block=__SHARADA}', "");
    Expect(1, 70112, '\P{Is_Block=__SHARADA}', "");
    Expect(0, 70112, '\P{^Is_Block=__SHARADA}', "");
    Error('\p{Is_Blk=:=	-sharada}');
    Error('\P{Is_Blk=:=	-sharada}');
    Expect(1, 70111, '\p{Is_Blk=sharada}', "");
    Expect(0, 70111, '\p{^Is_Blk=sharada}', "");
    Expect(0, 70111, '\P{Is_Blk=sharada}', "");
    Expect(1, 70111, '\P{^Is_Blk=sharada}', "");
    Expect(0, 70112, '\p{Is_Blk=sharada}', "");
    Expect(1, 70112, '\p{^Is_Blk=sharada}', "");
    Expect(1, 70112, '\P{Is_Blk=sharada}', "");
    Expect(0, 70112, '\P{^Is_Blk=sharada}', "");
    Expect(1, 70111, '\p{Is_Blk= _Sharada}', "");
    Expect(0, 70111, '\p{^Is_Blk= _Sharada}', "");
    Expect(0, 70111, '\P{Is_Blk= _Sharada}', "");
    Expect(1, 70111, '\P{^Is_Blk= _Sharada}', "");
    Expect(0, 70112, '\p{Is_Blk= _Sharada}', "");
    Expect(1, 70112, '\p{^Is_Blk= _Sharada}', "");
    Expect(1, 70112, '\P{Is_Blk= _Sharada}', "");
    Expect(0, 70112, '\P{^Is_Blk= _Sharada}', "");
    Error('\p{Block=-/a/Shavian}');
    Error('\P{Block=-/a/Shavian}');
    Expect(1, 66687, '\p{Block=shavian}', "");
    Expect(0, 66687, '\p{^Block=shavian}', "");
    Expect(0, 66687, '\P{Block=shavian}', "");
    Expect(1, 66687, '\P{^Block=shavian}', "");
    Expect(0, 66688, '\p{Block=shavian}', "");
    Expect(1, 66688, '\p{^Block=shavian}', "");
    Expect(1, 66688, '\P{Block=shavian}', "");
    Expect(0, 66688, '\P{^Block=shavian}', "");
    Expect(1, 66687, '\p{Block= SHAVIAN}', "");
    Expect(0, 66687, '\p{^Block= SHAVIAN}', "");
    Expect(0, 66687, '\P{Block= SHAVIAN}', "");
    Expect(1, 66687, '\P{^Block= SHAVIAN}', "");
    Expect(0, 66688, '\p{Block= SHAVIAN}', "");
    Expect(1, 66688, '\p{^Block= SHAVIAN}', "");
    Expect(1, 66688, '\P{Block= SHAVIAN}', "");
    Expect(0, 66688, '\P{^Block= SHAVIAN}', "");
    Error('\p{Blk=/a/-_Shavian}');
    Error('\P{Blk=/a/-_Shavian}');
    Expect(1, 66687, '\p{Blk=shavian}', "");
    Expect(0, 66687, '\p{^Blk=shavian}', "");
    Expect(0, 66687, '\P{Blk=shavian}', "");
    Expect(1, 66687, '\P{^Blk=shavian}', "");
    Expect(0, 66688, '\p{Blk=shavian}', "");
    Expect(1, 66688, '\p{^Blk=shavian}', "");
    Expect(1, 66688, '\P{Blk=shavian}', "");
    Expect(0, 66688, '\P{^Blk=shavian}', "");
    Expect(1, 66687, '\p{Blk=	 Shavian}', "");
    Expect(0, 66687, '\p{^Blk=	 Shavian}', "");
    Expect(0, 66687, '\P{Blk=	 Shavian}', "");
    Expect(1, 66687, '\P{^Blk=	 Shavian}', "");
    Expect(0, 66688, '\p{Blk=	 Shavian}', "");
    Expect(1, 66688, '\p{^Blk=	 Shavian}', "");
    Expect(1, 66688, '\P{Blk=	 Shavian}', "");
    Expect(0, 66688, '\P{^Blk=	 Shavian}', "");
    Error('\p{Is_Block=/a/_	SHAVIAN}');
    Error('\P{Is_Block=/a/_	SHAVIAN}');
    Expect(1, 66687, '\p{Is_Block=shavian}', "");
    Expect(0, 66687, '\p{^Is_Block=shavian}', "");
    Expect(0, 66687, '\P{Is_Block=shavian}', "");
    Expect(1, 66687, '\P{^Is_Block=shavian}', "");
    Expect(0, 66688, '\p{Is_Block=shavian}', "");
    Expect(1, 66688, '\p{^Is_Block=shavian}', "");
    Expect(1, 66688, '\P{Is_Block=shavian}', "");
    Expect(0, 66688, '\P{^Is_Block=shavian}', "");
    Expect(1, 66687, '\p{Is_Block= -shavian}', "");
    Expect(0, 66687, '\p{^Is_Block= -shavian}', "");
    Expect(0, 66687, '\P{Is_Block= -shavian}', "");
    Expect(1, 66687, '\P{^Is_Block= -shavian}', "");
    Expect(0, 66688, '\p{Is_Block= -shavian}', "");
    Expect(1, 66688, '\p{^Is_Block= -shavian}', "");
    Expect(1, 66688, '\P{Is_Block= -shavian}', "");
    Expect(0, 66688, '\P{^Is_Block= -shavian}', "");
    Error('\p{Is_Blk=/a/__Shavian}');
    Error('\P{Is_Blk=/a/__Shavian}');
    Expect(1, 66687, '\p{Is_Blk=shavian}', "");
    Expect(0, 66687, '\p{^Is_Blk=shavian}', "");
    Expect(0, 66687, '\P{Is_Blk=shavian}', "");
    Expect(1, 66687, '\P{^Is_Blk=shavian}', "");
    Expect(0, 66688, '\p{Is_Blk=shavian}', "");
    Expect(1, 66688, '\p{^Is_Blk=shavian}', "");
    Expect(1, 66688, '\P{Is_Blk=shavian}', "");
    Expect(0, 66688, '\P{^Is_Blk=shavian}', "");
    Expect(1, 66687, '\p{Is_Blk= _SHAVIAN}', "");
    Expect(0, 66687, '\p{^Is_Blk= _SHAVIAN}', "");
    Expect(0, 66687, '\P{Is_Blk= _SHAVIAN}', "");
    Expect(1, 66687, '\P{^Is_Blk= _SHAVIAN}', "");
    Expect(0, 66688, '\p{Is_Blk= _SHAVIAN}', "");
    Expect(1, 66688, '\p{^Is_Blk= _SHAVIAN}', "");
    Expect(1, 66688, '\P{Is_Blk= _SHAVIAN}', "");
    Expect(0, 66688, '\P{^Is_Blk= _SHAVIAN}', "");
    Error('\p{Block=	Shorthand_format_Controls/a/}');
    Error('\P{Block=	Shorthand_format_Controls/a/}');
    Expect(1, 113839, '\p{Block=shorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^Block=shorthandformatcontrols}', "");
    Expect(0, 113839, '\P{Block=shorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^Block=shorthandformatcontrols}', "");
    Expect(0, 113840, '\p{Block=shorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^Block=shorthandformatcontrols}', "");
    Expect(1, 113840, '\P{Block=shorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^Block=shorthandformatcontrols}', "");
    Expect(1, 113839, '\p{Block=	SHORTHAND_Format_Controls}', "");
    Expect(0, 113839, '\p{^Block=	SHORTHAND_Format_Controls}', "");
    Expect(0, 113839, '\P{Block=	SHORTHAND_Format_Controls}', "");
    Expect(1, 113839, '\P{^Block=	SHORTHAND_Format_Controls}', "");
    Expect(0, 113840, '\p{Block=	SHORTHAND_Format_Controls}', "");
    Expect(1, 113840, '\p{^Block=	SHORTHAND_Format_Controls}', "");
    Expect(1, 113840, '\P{Block=	SHORTHAND_Format_Controls}', "");
    Expect(0, 113840, '\P{^Block=	SHORTHAND_Format_Controls}', "");
    Error('\p{Blk=_/a/Shorthand_Format_CONTROLS}');
    Error('\P{Blk=_/a/Shorthand_Format_CONTROLS}');
    Expect(1, 113839, '\p{Blk=shorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^Blk=shorthandformatcontrols}', "");
    Expect(0, 113839, '\P{Blk=shorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^Blk=shorthandformatcontrols}', "");
    Expect(0, 113840, '\p{Blk=shorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^Blk=shorthandformatcontrols}', "");
    Expect(1, 113840, '\P{Blk=shorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^Blk=shorthandformatcontrols}', "");
    Expect(1, 113839, '\p{Blk=_shorthand_format_CONTROLS}', "");
    Expect(0, 113839, '\p{^Blk=_shorthand_format_CONTROLS}', "");
    Expect(0, 113839, '\P{Blk=_shorthand_format_CONTROLS}', "");
    Expect(1, 113839, '\P{^Blk=_shorthand_format_CONTROLS}', "");
    Expect(0, 113840, '\p{Blk=_shorthand_format_CONTROLS}', "");
    Expect(1, 113840, '\p{^Blk=_shorthand_format_CONTROLS}', "");
    Expect(1, 113840, '\P{Blk=_shorthand_format_CONTROLS}', "");
    Expect(0, 113840, '\P{^Blk=_shorthand_format_CONTROLS}', "");
    Error('\p{Is_Block=	:=shorthand_FORMAT_CONTROLS}');
    Error('\P{Is_Block=	:=shorthand_FORMAT_CONTROLS}');
    Expect(1, 113839, '\p{Is_Block=shorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^Is_Block=shorthandformatcontrols}', "");
    Expect(0, 113839, '\P{Is_Block=shorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^Is_Block=shorthandformatcontrols}', "");
    Expect(0, 113840, '\p{Is_Block=shorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^Is_Block=shorthandformatcontrols}', "");
    Expect(1, 113840, '\P{Is_Block=shorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^Is_Block=shorthandformatcontrols}', "");
    Expect(1, 113839, '\p{Is_Block=- Shorthand_Format_controls}', "");
    Expect(0, 113839, '\p{^Is_Block=- Shorthand_Format_controls}', "");
    Expect(0, 113839, '\P{Is_Block=- Shorthand_Format_controls}', "");
    Expect(1, 113839, '\P{^Is_Block=- Shorthand_Format_controls}', "");
    Expect(0, 113840, '\p{Is_Block=- Shorthand_Format_controls}', "");
    Expect(1, 113840, '\p{^Is_Block=- Shorthand_Format_controls}', "");
    Expect(1, 113840, '\P{Is_Block=- Shorthand_Format_controls}', "");
    Expect(0, 113840, '\P{^Is_Block=- Shorthand_Format_controls}', "");
    Error('\p{Is_Blk=-shorthand_Format_CONTROLS/a/}');
    Error('\P{Is_Blk=-shorthand_Format_CONTROLS/a/}');
    Expect(1, 113839, '\p{Is_Blk=shorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^Is_Blk=shorthandformatcontrols}', "");
    Expect(0, 113839, '\P{Is_Blk=shorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^Is_Blk=shorthandformatcontrols}', "");
    Expect(0, 113840, '\p{Is_Blk=shorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^Is_Blk=shorthandformatcontrols}', "");
    Expect(1, 113840, '\P{Is_Blk=shorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^Is_Blk=shorthandformatcontrols}', "");
    Expect(1, 113839, '\p{Is_Blk=  Shorthand_Format_controls}', "");
    Expect(0, 113839, '\p{^Is_Blk=  Shorthand_Format_controls}', "");
    Expect(0, 113839, '\P{Is_Blk=  Shorthand_Format_controls}', "");
    Expect(1, 113839, '\P{^Is_Blk=  Shorthand_Format_controls}', "");
    Expect(0, 113840, '\p{Is_Blk=  Shorthand_Format_controls}', "");
    Expect(1, 113840, '\p{^Is_Blk=  Shorthand_Format_controls}', "");
    Expect(1, 113840, '\P{Is_Blk=  Shorthand_Format_controls}', "");
    Expect(0, 113840, '\P{^Is_Blk=  Shorthand_Format_controls}', "");
    Error('\p{Block=_ SIDDHAM:=}');
    Error('\P{Block=_ SIDDHAM:=}');
    Expect(1, 71167, '\p{Block:siddham}', "");
    Expect(0, 71167, '\p{^Block:siddham}', "");
    Expect(0, 71167, '\P{Block:siddham}', "");
    Expect(1, 71167, '\P{^Block:siddham}', "");
    Expect(0, 71168, '\p{Block:siddham}', "");
    Expect(1, 71168, '\p{^Block:siddham}', "");
    Expect(1, 71168, '\P{Block:siddham}', "");
    Expect(0, 71168, '\P{^Block:siddham}', "");
    Expect(1, 71167, '\p{Block=-_siddham}', "");
    Expect(0, 71167, '\p{^Block=-_siddham}', "");
    Expect(0, 71167, '\P{Block=-_siddham}', "");
    Expect(1, 71167, '\P{^Block=-_siddham}', "");
    Expect(0, 71168, '\p{Block=-_siddham}', "");
    Expect(1, 71168, '\p{^Block=-_siddham}', "");
    Expect(1, 71168, '\P{Block=-_siddham}', "");
    Expect(0, 71168, '\P{^Block=-_siddham}', "");
    Error('\p{Blk= /a/siddham}');
    Error('\P{Blk= /a/siddham}');
    Expect(1, 71167, '\p{Blk=siddham}', "");
    Expect(0, 71167, '\p{^Blk=siddham}', "");
    Expect(0, 71167, '\P{Blk=siddham}', "");
    Expect(1, 71167, '\P{^Blk=siddham}', "");
    Expect(0, 71168, '\p{Blk=siddham}', "");
    Expect(1, 71168, '\p{^Blk=siddham}', "");
    Expect(1, 71168, '\P{Blk=siddham}', "");
    Expect(0, 71168, '\P{^Blk=siddham}', "");
    Expect(1, 71167, '\p{Blk=	siddham}', "");
    Expect(0, 71167, '\p{^Blk=	siddham}', "");
    Expect(0, 71167, '\P{Blk=	siddham}', "");
    Expect(1, 71167, '\P{^Blk=	siddham}', "");
    Expect(0, 71168, '\p{Blk=	siddham}', "");
    Expect(1, 71168, '\p{^Blk=	siddham}', "");
    Expect(1, 71168, '\P{Blk=	siddham}', "");
    Expect(0, 71168, '\P{^Blk=	siddham}', "");
    Error('\p{Is_Block=  Siddham:=}');
    Error('\P{Is_Block=  Siddham:=}');
    Expect(1, 71167, '\p{Is_Block:siddham}', "");
    Expect(0, 71167, '\p{^Is_Block:siddham}', "");
    Expect(0, 71167, '\P{Is_Block:siddham}', "");
    Expect(1, 71167, '\P{^Is_Block:siddham}', "");
    Expect(0, 71168, '\p{Is_Block:siddham}', "");
    Expect(1, 71168, '\p{^Is_Block:siddham}', "");
    Expect(1, 71168, '\P{Is_Block:siddham}', "");
    Expect(0, 71168, '\P{^Is_Block:siddham}', "");
    Expect(1, 71167, '\p{Is_Block=_Siddham}', "");
    Expect(0, 71167, '\p{^Is_Block=_Siddham}', "");
    Expect(0, 71167, '\P{Is_Block=_Siddham}', "");
    Expect(1, 71167, '\P{^Is_Block=_Siddham}', "");
    Expect(0, 71168, '\p{Is_Block=_Siddham}', "");
    Expect(1, 71168, '\p{^Is_Block=_Siddham}', "");
    Expect(1, 71168, '\P{Is_Block=_Siddham}', "");
    Expect(0, 71168, '\P{^Is_Block=_Siddham}', "");
    Error('\p{Is_Blk:   :=	-SIDDHAM}');
    Error('\P{Is_Blk:   :=	-SIDDHAM}');
    Expect(1, 71167, '\p{Is_Blk=siddham}', "");
    Expect(0, 71167, '\p{^Is_Blk=siddham}', "");
    Expect(0, 71167, '\P{Is_Blk=siddham}', "");
    Expect(1, 71167, '\P{^Is_Blk=siddham}', "");
    Expect(0, 71168, '\p{Is_Blk=siddham}', "");
    Expect(1, 71168, '\p{^Is_Blk=siddham}', "");
    Expect(1, 71168, '\P{Is_Blk=siddham}', "");
    Expect(0, 71168, '\P{^Is_Blk=siddham}', "");
    Expect(1, 71167, '\p{Is_Blk=--Siddham}', "");
    Expect(0, 71167, '\p{^Is_Blk=--Siddham}', "");
    Expect(0, 71167, '\P{Is_Blk=--Siddham}', "");
    Expect(1, 71167, '\P{^Is_Blk=--Siddham}', "");
    Expect(0, 71168, '\p{Is_Blk=--Siddham}', "");
    Expect(1, 71168, '\p{^Is_Blk=--Siddham}', "");
    Expect(1, 71168, '\P{Is_Blk=--Siddham}', "");
    Expect(0, 71168, '\P{^Is_Blk=--Siddham}', "");
    Error('\p{Block=:=-Sinhala}');
    Error('\P{Block=:=-Sinhala}');
    Expect(1, 3583, '\p{Block=sinhala}', "");
    Expect(0, 3583, '\p{^Block=sinhala}', "");
    Expect(0, 3583, '\P{Block=sinhala}', "");
    Expect(1, 3583, '\P{^Block=sinhala}', "");
    Expect(0, 3584, '\p{Block=sinhala}', "");
    Expect(1, 3584, '\p{^Block=sinhala}', "");
    Expect(1, 3584, '\P{Block=sinhala}', "");
    Expect(0, 3584, '\P{^Block=sinhala}', "");
    Expect(1, 3583, '\p{Block=_	Sinhala}', "");
    Expect(0, 3583, '\p{^Block=_	Sinhala}', "");
    Expect(0, 3583, '\P{Block=_	Sinhala}', "");
    Expect(1, 3583, '\P{^Block=_	Sinhala}', "");
    Expect(0, 3584, '\p{Block=_	Sinhala}', "");
    Expect(1, 3584, '\p{^Block=_	Sinhala}', "");
    Expect(1, 3584, '\P{Block=_	Sinhala}', "");
    Expect(0, 3584, '\P{^Block=_	Sinhala}', "");
    Error('\p{Blk=/a/--Sinhala}');
    Error('\P{Blk=/a/--Sinhala}');
    Expect(1, 3583, '\p{Blk=sinhala}', "");
    Expect(0, 3583, '\p{^Blk=sinhala}', "");
    Expect(0, 3583, '\P{Blk=sinhala}', "");
    Expect(1, 3583, '\P{^Blk=sinhala}', "");
    Expect(0, 3584, '\p{Blk=sinhala}', "");
    Expect(1, 3584, '\p{^Blk=sinhala}', "");
    Expect(1, 3584, '\P{Blk=sinhala}', "");
    Expect(0, 3584, '\P{^Blk=sinhala}', "");
    Expect(1, 3583, '\p{Blk= sinhala}', "");
    Expect(0, 3583, '\p{^Blk= sinhala}', "");
    Expect(0, 3583, '\P{Blk= sinhala}', "");
    Expect(1, 3583, '\P{^Blk= sinhala}', "");
    Expect(0, 3584, '\p{Blk= sinhala}', "");
    Expect(1, 3584, '\p{^Blk= sinhala}', "");
    Expect(1, 3584, '\P{Blk= sinhala}', "");
    Expect(0, 3584, '\P{^Blk= sinhala}', "");
    Error('\p{Is_Block=:=sinhala}');
    Error('\P{Is_Block=:=sinhala}');
    Expect(1, 3583, '\p{Is_Block=sinhala}', "");
    Expect(0, 3583, '\p{^Is_Block=sinhala}', "");
    Expect(0, 3583, '\P{Is_Block=sinhala}', "");
    Expect(1, 3583, '\P{^Is_Block=sinhala}', "");
    Expect(0, 3584, '\p{Is_Block=sinhala}', "");
    Expect(1, 3584, '\p{^Is_Block=sinhala}', "");
    Expect(1, 3584, '\P{Is_Block=sinhala}', "");
    Expect(0, 3584, '\P{^Is_Block=sinhala}', "");
    Expect(1, 3583, '\p{Is_Block=		sinhala}', "");
    Expect(0, 3583, '\p{^Is_Block=		sinhala}', "");
    Expect(0, 3583, '\P{Is_Block=		sinhala}', "");
    Expect(1, 3583, '\P{^Is_Block=		sinhala}', "");
    Expect(0, 3584, '\p{Is_Block=		sinhala}', "");
    Expect(1, 3584, '\p{^Is_Block=		sinhala}', "");
    Expect(1, 3584, '\P{Is_Block=		sinhala}', "");
    Expect(0, 3584, '\P{^Is_Block=		sinhala}', "");
    Error('\p{Is_Blk=/a/_-Sinhala}');
    Error('\P{Is_Blk=/a/_-Sinhala}');
    Expect(1, 3583, '\p{Is_Blk=sinhala}', "");
    Expect(0, 3583, '\p{^Is_Blk=sinhala}', "");
    Expect(0, 3583, '\P{Is_Blk=sinhala}', "");
    Expect(1, 3583, '\P{^Is_Blk=sinhala}', "");
    Expect(0, 3584, '\p{Is_Blk=sinhala}', "");
    Expect(1, 3584, '\p{^Is_Blk=sinhala}', "");
    Expect(1, 3584, '\P{Is_Blk=sinhala}', "");
    Expect(0, 3584, '\P{^Is_Blk=sinhala}', "");
    Expect(1, 3583, '\p{Is_Blk=  Sinhala}', "");
    Expect(0, 3583, '\p{^Is_Blk=  Sinhala}', "");
    Expect(0, 3583, '\P{Is_Blk=  Sinhala}', "");
    Expect(1, 3583, '\P{^Is_Blk=  Sinhala}', "");
    Expect(0, 3584, '\p{Is_Blk=  Sinhala}', "");
    Expect(1, 3584, '\p{^Is_Blk=  Sinhala}', "");
    Expect(1, 3584, '\P{Is_Blk=  Sinhala}', "");
    Expect(0, 3584, '\P{^Is_Blk=  Sinhala}', "");
    Error('\p{Block=/a/_-Sinhala_ARCHAIC_numbers}');
    Error('\P{Block=/a/_-Sinhala_ARCHAIC_numbers}');
    Expect(1, 70143, '\p{Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{Block=-	sinhala_ARCHAIC_Numbers}', "");
    Expect(0, 70143, '\p{^Block=-	sinhala_ARCHAIC_Numbers}', "");
    Expect(0, 70143, '\P{Block=-	sinhala_ARCHAIC_Numbers}', "");
    Expect(1, 70143, '\P{^Block=-	sinhala_ARCHAIC_Numbers}', "");
    Expect(0, 70144, '\p{Block=-	sinhala_ARCHAIC_Numbers}', "");
    Expect(1, 70144, '\p{^Block=-	sinhala_ARCHAIC_Numbers}', "");
    Expect(1, 70144, '\P{Block=-	sinhala_ARCHAIC_Numbers}', "");
    Expect(0, 70144, '\P{^Block=-	sinhala_ARCHAIC_Numbers}', "");
    Error('\p{Blk=/a/  Sinhala_archaic_Numbers}');
    Error('\P{Blk=/a/  Sinhala_archaic_Numbers}');
    Expect(1, 70143, '\p{Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{Blk=sinhala_Archaic_Numbers}', "");
    Expect(0, 70143, '\p{^Blk=sinhala_Archaic_Numbers}', "");
    Expect(0, 70143, '\P{Blk=sinhala_Archaic_Numbers}', "");
    Expect(1, 70143, '\P{^Blk=sinhala_Archaic_Numbers}', "");
    Expect(0, 70144, '\p{Blk=sinhala_Archaic_Numbers}', "");
    Expect(1, 70144, '\p{^Blk=sinhala_Archaic_Numbers}', "");
    Expect(1, 70144, '\P{Blk=sinhala_Archaic_Numbers}', "");
    Expect(0, 70144, '\P{^Blk=sinhala_Archaic_Numbers}', "");
    Error('\p{Is_Block=--sinhala_ARCHAIC_Numbers/a/}');
    Error('\P{Is_Block=--sinhala_ARCHAIC_Numbers/a/}');
    Expect(1, 70143, '\p{Is_Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^Is_Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{Is_Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^Is_Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{Is_Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^Is_Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{Is_Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^Is_Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{Is_Block=_	sinhala_Archaic_numbers}', "");
    Expect(0, 70143, '\p{^Is_Block=_	sinhala_Archaic_numbers}', "");
    Expect(0, 70143, '\P{Is_Block=_	sinhala_Archaic_numbers}', "");
    Expect(1, 70143, '\P{^Is_Block=_	sinhala_Archaic_numbers}', "");
    Expect(0, 70144, '\p{Is_Block=_	sinhala_Archaic_numbers}', "");
    Expect(1, 70144, '\p{^Is_Block=_	sinhala_Archaic_numbers}', "");
    Expect(1, 70144, '\P{Is_Block=_	sinhala_Archaic_numbers}', "");
    Expect(0, 70144, '\P{^Is_Block=_	sinhala_Archaic_numbers}', "");
    Error('\p{Is_Blk=/a/ _Sinhala_Archaic_Numbers}');
    Error('\P{Is_Blk=/a/ _Sinhala_Archaic_Numbers}');
    Expect(1, 70143, '\p{Is_Blk:	sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^Is_Blk:	sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{Is_Blk:	sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^Is_Blk:	sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{Is_Blk:	sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^Is_Blk:	sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{Is_Blk:	sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^Is_Blk:	sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{Is_Blk=__sinhala_ARCHAIC_NUMBERS}', "");
    Expect(0, 70143, '\p{^Is_Blk=__sinhala_ARCHAIC_NUMBERS}', "");
    Expect(0, 70143, '\P{Is_Blk=__sinhala_ARCHAIC_NUMBERS}', "");
    Expect(1, 70143, '\P{^Is_Blk=__sinhala_ARCHAIC_NUMBERS}', "");
    Expect(0, 70144, '\p{Is_Blk=__sinhala_ARCHAIC_NUMBERS}', "");
    Expect(1, 70144, '\p{^Is_Blk=__sinhala_ARCHAIC_NUMBERS}', "");
    Expect(1, 70144, '\P{Is_Blk=__sinhala_ARCHAIC_NUMBERS}', "");
    Expect(0, 70144, '\P{^Is_Blk=__sinhala_ARCHAIC_NUMBERS}', "");
    Error('\p{Block=	/a/small_form_Variants}');
    Error('\P{Block=	/a/small_form_Variants}');
    Expect(1, 65135, '\p{Block:	smallformvariants}', "");
    Expect(0, 65135, '\p{^Block:	smallformvariants}', "");
    Expect(0, 65135, '\P{Block:	smallformvariants}', "");
    Expect(1, 65135, '\P{^Block:	smallformvariants}', "");
    Expect(0, 65136, '\p{Block:	smallformvariants}', "");
    Expect(1, 65136, '\p{^Block:	smallformvariants}', "");
    Expect(1, 65136, '\P{Block:	smallformvariants}', "");
    Expect(0, 65136, '\P{^Block:	smallformvariants}', "");
    Expect(1, 65135, '\p{Block=_	small_Form_Variants}', "");
    Expect(0, 65135, '\p{^Block=_	small_Form_Variants}', "");
    Expect(0, 65135, '\P{Block=_	small_Form_Variants}', "");
    Expect(1, 65135, '\P{^Block=_	small_Form_Variants}', "");
    Expect(0, 65136, '\p{Block=_	small_Form_Variants}', "");
    Expect(1, 65136, '\p{^Block=_	small_Form_Variants}', "");
    Expect(1, 65136, '\P{Block=_	small_Form_Variants}', "");
    Expect(0, 65136, '\P{^Block=_	small_Form_Variants}', "");
    Error('\p{Blk=:= 	SMALL_FORMS}');
    Error('\P{Blk=:= 	SMALL_FORMS}');
    Expect(1, 65135, '\p{Blk=smallforms}', "");
    Expect(0, 65135, '\p{^Blk=smallforms}', "");
    Expect(0, 65135, '\P{Blk=smallforms}', "");
    Expect(1, 65135, '\P{^Blk=smallforms}', "");
    Expect(0, 65136, '\p{Blk=smallforms}', "");
    Expect(1, 65136, '\p{^Blk=smallforms}', "");
    Expect(1, 65136, '\P{Blk=smallforms}', "");
    Expect(0, 65136, '\P{^Blk=smallforms}', "");
    Expect(1, 65135, '\p{Blk=	Small_Forms}', "");
    Expect(0, 65135, '\p{^Blk=	Small_Forms}', "");
    Expect(0, 65135, '\P{Blk=	Small_Forms}', "");
    Expect(1, 65135, '\P{^Blk=	Small_Forms}', "");
    Expect(0, 65136, '\p{Blk=	Small_Forms}', "");
    Expect(1, 65136, '\p{^Blk=	Small_Forms}', "");
    Expect(1, 65136, '\P{Blk=	Small_Forms}', "");
    Expect(0, 65136, '\P{^Blk=	Small_Forms}', "");
    Error('\p{Is_Block=_:=Small_FORM_variants}');
    Error('\P{Is_Block=_:=Small_FORM_variants}');
    Expect(1, 65135, '\p{Is_Block:	smallformvariants}', "");
    Expect(0, 65135, '\p{^Is_Block:	smallformvariants}', "");
    Expect(0, 65135, '\P{Is_Block:	smallformvariants}', "");
    Expect(1, 65135, '\P{^Is_Block:	smallformvariants}', "");
    Expect(0, 65136, '\p{Is_Block:	smallformvariants}', "");
    Expect(1, 65136, '\p{^Is_Block:	smallformvariants}', "");
    Expect(1, 65136, '\P{Is_Block:	smallformvariants}', "");
    Expect(0, 65136, '\P{^Is_Block:	smallformvariants}', "");
    Expect(1, 65135, '\p{Is_Block=_small_Form_variants}', "");
    Expect(0, 65135, '\p{^Is_Block=_small_Form_variants}', "");
    Expect(0, 65135, '\P{Is_Block=_small_Form_variants}', "");
    Expect(1, 65135, '\P{^Is_Block=_small_Form_variants}', "");
    Expect(0, 65136, '\p{Is_Block=_small_Form_variants}', "");
    Expect(1, 65136, '\p{^Is_Block=_small_Form_variants}', "");
    Expect(1, 65136, '\P{Is_Block=_small_Form_variants}', "");
    Expect(0, 65136, '\P{^Is_Block=_small_Form_variants}', "");
    Error('\p{Is_Blk:	/a/ -Small_forms}');
    Error('\P{Is_Blk:	/a/ -Small_forms}');
    Expect(1, 65135, '\p{Is_Blk=smallforms}', "");
    Expect(0, 65135, '\p{^Is_Blk=smallforms}', "");
    Expect(0, 65135, '\P{Is_Blk=smallforms}', "");
    Expect(1, 65135, '\P{^Is_Blk=smallforms}', "");
    Expect(0, 65136, '\p{Is_Blk=smallforms}', "");
    Expect(1, 65136, '\p{^Is_Blk=smallforms}', "");
    Expect(1, 65136, '\P{Is_Blk=smallforms}', "");
    Expect(0, 65136, '\P{^Is_Blk=smallforms}', "");
    Expect(1, 65135, '\p{Is_Blk=	SMALL_Forms}', "");
    Expect(0, 65135, '\p{^Is_Blk=	SMALL_Forms}', "");
    Expect(0, 65135, '\P{Is_Blk=	SMALL_Forms}', "");
    Expect(1, 65135, '\P{^Is_Blk=	SMALL_Forms}', "");
    Expect(0, 65136, '\p{Is_Blk=	SMALL_Forms}', "");
    Expect(1, 65136, '\p{^Is_Blk=	SMALL_Forms}', "");
    Expect(1, 65136, '\P{Is_Blk=	SMALL_Forms}', "");
    Expect(0, 65136, '\P{^Is_Blk=	SMALL_Forms}', "");
    Error('\p{Block=/a/sora_Sompeng}');
    Error('\P{Block=/a/sora_Sompeng}');
    Expect(1, 69887, '\p{Block=sorasompeng}', "");
    Expect(0, 69887, '\p{^Block=sorasompeng}', "");
    Expect(0, 69887, '\P{Block=sorasompeng}', "");
    Expect(1, 69887, '\P{^Block=sorasompeng}', "");
    Expect(0, 69888, '\p{Block=sorasompeng}', "");
    Expect(1, 69888, '\p{^Block=sorasompeng}', "");
    Expect(1, 69888, '\P{Block=sorasompeng}', "");
    Expect(0, 69888, '\P{^Block=sorasompeng}', "");
    Expect(1, 69887, '\p{Block: -_SORA_sompeng}', "");
    Expect(0, 69887, '\p{^Block: -_SORA_sompeng}', "");
    Expect(0, 69887, '\P{Block: -_SORA_sompeng}', "");
    Expect(1, 69887, '\P{^Block: -_SORA_sompeng}', "");
    Expect(0, 69888, '\p{Block: -_SORA_sompeng}', "");
    Expect(1, 69888, '\p{^Block: -_SORA_sompeng}', "");
    Expect(1, 69888, '\P{Block: -_SORA_sompeng}', "");
    Expect(0, 69888, '\P{^Block: -_SORA_sompeng}', "");
    Error('\p{Blk= /a/Sora_SOMPENG}');
    Error('\P{Blk= /a/Sora_SOMPENG}');
    Expect(1, 69887, '\p{Blk=sorasompeng}', "");
    Expect(0, 69887, '\p{^Blk=sorasompeng}', "");
    Expect(0, 69887, '\P{Blk=sorasompeng}', "");
    Expect(1, 69887, '\P{^Blk=sorasompeng}', "");
    Expect(0, 69888, '\p{Blk=sorasompeng}', "");
    Expect(1, 69888, '\p{^Blk=sorasompeng}', "");
    Expect(1, 69888, '\P{Blk=sorasompeng}', "");
    Expect(0, 69888, '\P{^Blk=sorasompeng}', "");
    Expect(1, 69887, '\p{Blk= Sora_SOMPENG}', "");
    Expect(0, 69887, '\p{^Blk= Sora_SOMPENG}', "");
    Expect(0, 69887, '\P{Blk= Sora_SOMPENG}', "");
    Expect(1, 69887, '\P{^Blk= Sora_SOMPENG}', "");
    Expect(0, 69888, '\p{Blk= Sora_SOMPENG}', "");
    Expect(1, 69888, '\p{^Blk= Sora_SOMPENG}', "");
    Expect(1, 69888, '\P{Blk= Sora_SOMPENG}', "");
    Expect(0, 69888, '\P{^Blk= Sora_SOMPENG}', "");
    Error('\p{Is_Block=_:=Sora_SOMPENG}');
    Error('\P{Is_Block=_:=Sora_SOMPENG}');
    Expect(1, 69887, '\p{Is_Block=sorasompeng}', "");
    Expect(0, 69887, '\p{^Is_Block=sorasompeng}', "");
    Expect(0, 69887, '\P{Is_Block=sorasompeng}', "");
    Expect(1, 69887, '\P{^Is_Block=sorasompeng}', "");
    Expect(0, 69888, '\p{Is_Block=sorasompeng}', "");
    Expect(1, 69888, '\p{^Is_Block=sorasompeng}', "");
    Expect(1, 69888, '\P{Is_Block=sorasompeng}', "");
    Expect(0, 69888, '\P{^Is_Block=sorasompeng}', "");
    Expect(1, 69887, '\p{Is_Block=		Sora_Sompeng}', "");
    Expect(0, 69887, '\p{^Is_Block=		Sora_Sompeng}', "");
    Expect(0, 69887, '\P{Is_Block=		Sora_Sompeng}', "");
    Expect(1, 69887, '\P{^Is_Block=		Sora_Sompeng}', "");
    Expect(0, 69888, '\p{Is_Block=		Sora_Sompeng}', "");
    Expect(1, 69888, '\p{^Is_Block=		Sora_Sompeng}', "");
    Expect(1, 69888, '\P{Is_Block=		Sora_Sompeng}', "");
    Expect(0, 69888, '\P{^Is_Block=		Sora_Sompeng}', "");
    Error('\p{Is_Blk=/a/SORA_SOMPENG}');
    Error('\P{Is_Blk=/a/SORA_SOMPENG}');
    Expect(1, 69887, '\p{Is_Blk=sorasompeng}', "");
    Expect(0, 69887, '\p{^Is_Blk=sorasompeng}', "");
    Expect(0, 69887, '\P{Is_Blk=sorasompeng}', "");
    Expect(1, 69887, '\P{^Is_Blk=sorasompeng}', "");
    Expect(0, 69888, '\p{Is_Blk=sorasompeng}', "");
    Expect(1, 69888, '\p{^Is_Blk=sorasompeng}', "");
    Expect(1, 69888, '\P{Is_Blk=sorasompeng}', "");
    Expect(0, 69888, '\P{^Is_Blk=sorasompeng}', "");
    Expect(1, 69887, '\p{Is_Blk=Sora_sompeng}', "");
    Expect(0, 69887, '\p{^Is_Blk=Sora_sompeng}', "");
    Expect(0, 69887, '\P{Is_Blk=Sora_sompeng}', "");
    Expect(1, 69887, '\P{^Is_Blk=Sora_sompeng}', "");
    Expect(0, 69888, '\p{Is_Blk=Sora_sompeng}', "");
    Expect(1, 69888, '\p{^Is_Blk=Sora_sompeng}', "");
    Expect(1, 69888, '\P{Is_Blk=Sora_sompeng}', "");
    Expect(0, 69888, '\P{^Is_Blk=Sora_sompeng}', "");
    Error('\p{Block=/a/Soyombo}');
    Error('\P{Block=/a/Soyombo}');
    Expect(1, 72367, '\p{Block=soyombo}', "");
    Expect(0, 72367, '\p{^Block=soyombo}', "");
    Expect(0, 72367, '\P{Block=soyombo}', "");
    Expect(1, 72367, '\P{^Block=soyombo}', "");
    Expect(0, 72368, '\p{Block=soyombo}', "");
    Expect(1, 72368, '\p{^Block=soyombo}', "");
    Expect(1, 72368, '\P{Block=soyombo}', "");
    Expect(0, 72368, '\P{^Block=soyombo}', "");
    Expect(1, 72367, '\p{Block=_Soyombo}', "");
    Expect(0, 72367, '\p{^Block=_Soyombo}', "");
    Expect(0, 72367, '\P{Block=_Soyombo}', "");
    Expect(1, 72367, '\P{^Block=_Soyombo}', "");
    Expect(0, 72368, '\p{Block=_Soyombo}', "");
    Expect(1, 72368, '\p{^Block=_Soyombo}', "");
    Expect(1, 72368, '\P{Block=_Soyombo}', "");
    Expect(0, 72368, '\P{^Block=_Soyombo}', "");
    Error('\p{Blk=/a/_SOYOMBO}');
    Error('\P{Blk=/a/_SOYOMBO}');
    Expect(1, 72367, '\p{Blk=soyombo}', "");
    Expect(0, 72367, '\p{^Blk=soyombo}', "");
    Expect(0, 72367, '\P{Blk=soyombo}', "");
    Expect(1, 72367, '\P{^Blk=soyombo}', "");
    Expect(0, 72368, '\p{Blk=soyombo}', "");
    Expect(1, 72368, '\p{^Blk=soyombo}', "");
    Expect(1, 72368, '\P{Blk=soyombo}', "");
    Expect(0, 72368, '\P{^Blk=soyombo}', "");
    Expect(1, 72367, '\p{Blk=  soyombo}', "");
    Expect(0, 72367, '\p{^Blk=  soyombo}', "");
    Expect(0, 72367, '\P{Blk=  soyombo}', "");
    Expect(1, 72367, '\P{^Blk=  soyombo}', "");
    Expect(0, 72368, '\p{Blk=  soyombo}', "");
    Expect(1, 72368, '\p{^Blk=  soyombo}', "");
    Expect(1, 72368, '\P{Blk=  soyombo}', "");
    Expect(0, 72368, '\P{^Blk=  soyombo}', "");
    Error('\p{Is_Block=:=_-soyombo}');
    Error('\P{Is_Block=:=_-soyombo}');
    Expect(1, 72367, '\p{Is_Block=soyombo}', "");
    Expect(0, 72367, '\p{^Is_Block=soyombo}', "");
    Expect(0, 72367, '\P{Is_Block=soyombo}', "");
    Expect(1, 72367, '\P{^Is_Block=soyombo}', "");
    Expect(0, 72368, '\p{Is_Block=soyombo}', "");
    Expect(1, 72368, '\p{^Is_Block=soyombo}', "");
    Expect(1, 72368, '\P{Is_Block=soyombo}', "");
    Expect(0, 72368, '\P{^Is_Block=soyombo}', "");
    Expect(1, 72367, '\p{Is_Block=	-soyombo}', "");
    Expect(0, 72367, '\p{^Is_Block=	-soyombo}', "");
    Expect(0, 72367, '\P{Is_Block=	-soyombo}', "");
    Expect(1, 72367, '\P{^Is_Block=	-soyombo}', "");
    Expect(0, 72368, '\p{Is_Block=	-soyombo}', "");
    Expect(1, 72368, '\p{^Is_Block=	-soyombo}', "");
    Expect(1, 72368, '\P{Is_Block=	-soyombo}', "");
    Expect(0, 72368, '\P{^Is_Block=	-soyombo}', "");
    Error('\p{Is_Blk=/a/-_SOYOMBO}');
    Error('\P{Is_Blk=/a/-_SOYOMBO}');
    Expect(1, 72367, '\p{Is_Blk=soyombo}', "");
    Expect(0, 72367, '\p{^Is_Blk=soyombo}', "");
    Expect(0, 72367, '\P{Is_Blk=soyombo}', "");
    Expect(1, 72367, '\P{^Is_Blk=soyombo}', "");
    Expect(0, 72368, '\p{Is_Blk=soyombo}', "");
    Expect(1, 72368, '\p{^Is_Blk=soyombo}', "");
    Expect(1, 72368, '\P{Is_Blk=soyombo}', "");
    Expect(0, 72368, '\P{^Is_Blk=soyombo}', "");
    Expect(1, 72367, '\p{Is_Blk=	_Soyombo}', "");
    Expect(0, 72367, '\p{^Is_Blk=	_Soyombo}', "");
    Expect(0, 72367, '\P{Is_Blk=	_Soyombo}', "");
    Expect(1, 72367, '\P{^Is_Blk=	_Soyombo}', "");
    Expect(0, 72368, '\p{Is_Blk=	_Soyombo}', "");
    Expect(1, 72368, '\p{^Is_Blk=	_Soyombo}', "");
    Expect(1, 72368, '\P{Is_Blk=	_Soyombo}', "");
    Expect(0, 72368, '\P{^Is_Blk=	_Soyombo}', "");
    Error('\p{Block=:=--Specials}');
    Error('\P{Block=:=--Specials}');
    Expect(1, 65520, '\p{Block=specials}', "");
    Expect(0, 65520, '\p{^Block=specials}', "");
    Expect(0, 65520, '\P{Block=specials}', "");
    Expect(1, 65520, '\P{^Block=specials}', "");
    Expect(0, 65536, '\p{Block=specials}', "");
    Expect(1, 65536, '\p{^Block=specials}', "");
    Expect(1, 65536, '\P{Block=specials}', "");
    Expect(0, 65536, '\P{^Block=specials}', "");
    Expect(1, 65520, '\p{Block=-	SPECIALS}', "");
    Expect(0, 65520, '\p{^Block=-	SPECIALS}', "");
    Expect(0, 65520, '\P{Block=-	SPECIALS}', "");
    Expect(1, 65520, '\P{^Block=-	SPECIALS}', "");
    Expect(0, 65536, '\p{Block=-	SPECIALS}', "");
    Expect(1, 65536, '\p{^Block=-	SPECIALS}', "");
    Expect(1, 65536, '\P{Block=-	SPECIALS}', "");
    Expect(0, 65536, '\P{^Block=-	SPECIALS}', "");
    Error('\p{Blk=:=_Specials}');
    Error('\P{Blk=:=_Specials}');
    Expect(1, 65520, '\p{Blk=specials}', "");
    Expect(0, 65520, '\p{^Blk=specials}', "");
    Expect(0, 65520, '\P{Blk=specials}', "");
    Expect(1, 65520, '\P{^Blk=specials}', "");
    Expect(0, 65536, '\p{Blk=specials}', "");
    Expect(1, 65536, '\p{^Blk=specials}', "");
    Expect(1, 65536, '\P{Blk=specials}', "");
    Expect(0, 65536, '\P{^Blk=specials}', "");
    Expect(1, 65520, '\p{Blk=	_Specials}', "");
    Expect(0, 65520, '\p{^Blk=	_Specials}', "");
    Expect(0, 65520, '\P{Blk=	_Specials}', "");
    Expect(1, 65520, '\P{^Blk=	_Specials}', "");
    Expect(0, 65536, '\p{Blk=	_Specials}', "");
    Expect(1, 65536, '\p{^Blk=	_Specials}', "");
    Expect(1, 65536, '\P{Blk=	_Specials}', "");
    Expect(0, 65536, '\P{^Blk=	_Specials}', "");
    Error('\p{Is_Block:   :=_SPECIALS}');
    Error('\P{Is_Block:   :=_SPECIALS}');
    Expect(1, 65520, '\p{Is_Block=specials}', "");
    Expect(0, 65520, '\p{^Is_Block=specials}', "");
    Expect(0, 65520, '\P{Is_Block=specials}', "");
    Expect(1, 65520, '\P{^Is_Block=specials}', "");
    Expect(0, 65536, '\p{Is_Block=specials}', "");
    Expect(1, 65536, '\p{^Is_Block=specials}', "");
    Expect(1, 65536, '\P{Is_Block=specials}', "");
    Expect(0, 65536, '\P{^Is_Block=specials}', "");
    Expect(1, 65520, '\p{Is_Block=-	Specials}', "");
    Expect(0, 65520, '\p{^Is_Block=-	Specials}', "");
    Expect(0, 65520, '\P{Is_Block=-	Specials}', "");
    Expect(1, 65520, '\P{^Is_Block=-	Specials}', "");
    Expect(0, 65536, '\p{Is_Block=-	Specials}', "");
    Expect(1, 65536, '\p{^Is_Block=-	Specials}', "");
    Expect(1, 65536, '\P{Is_Block=-	Specials}', "");
    Expect(0, 65536, '\P{^Is_Block=-	Specials}', "");
    Error('\p{Is_Blk=/a/--specials}');
    Error('\P{Is_Blk=/a/--specials}');
    Expect(1, 65520, '\p{Is_Blk: specials}', "");
    Expect(0, 65520, '\p{^Is_Blk: specials}', "");
    Expect(0, 65520, '\P{Is_Blk: specials}', "");
    Expect(1, 65520, '\P{^Is_Blk: specials}', "");
    Expect(0, 65536, '\p{Is_Blk: specials}', "");
    Expect(1, 65536, '\p{^Is_Blk: specials}', "");
    Expect(1, 65536, '\P{Is_Blk: specials}', "");
    Expect(0, 65536, '\P{^Is_Blk: specials}', "");
    Expect(1, 65520, '\p{Is_Blk: Specials}', "");
    Expect(0, 65520, '\p{^Is_Blk: Specials}', "");
    Expect(0, 65520, '\P{Is_Blk: Specials}', "");
    Expect(1, 65520, '\P{^Is_Blk: Specials}', "");
    Expect(0, 65536, '\p{Is_Blk: Specials}', "");
    Expect(1, 65536, '\p{^Is_Blk: Specials}', "");
    Expect(1, 65536, '\P{Is_Blk: Specials}', "");
    Expect(0, 65536, '\P{^Is_Blk: Specials}', "");
    Error('\p{Block=/a/- sundanese}');
    Error('\P{Block=/a/- sundanese}');
    Expect(1, 7103, '\p{Block=sundanese}', "");
    Expect(0, 7103, '\p{^Block=sundanese}', "");
    Expect(0, 7103, '\P{Block=sundanese}', "");
    Expect(1, 7103, '\P{^Block=sundanese}', "");
    Expect(0, 7104, '\p{Block=sundanese}', "");
    Expect(1, 7104, '\p{^Block=sundanese}', "");
    Expect(1, 7104, '\P{Block=sundanese}', "");
    Expect(0, 7104, '\P{^Block=sundanese}', "");
    Expect(1, 7103, '\p{Block=	Sundanese}', "");
    Expect(0, 7103, '\p{^Block=	Sundanese}', "");
    Expect(0, 7103, '\P{Block=	Sundanese}', "");
    Expect(1, 7103, '\P{^Block=	Sundanese}', "");
    Expect(0, 7104, '\p{Block=	Sundanese}', "");
    Expect(1, 7104, '\p{^Block=	Sundanese}', "");
    Expect(1, 7104, '\P{Block=	Sundanese}', "");
    Expect(0, 7104, '\P{^Block=	Sundanese}', "");
    Error('\p{Blk=:=	_SUNDANESE}');
    Error('\P{Blk=:=	_SUNDANESE}');
    Expect(1, 7103, '\p{Blk=sundanese}', "");
    Expect(0, 7103, '\p{^Blk=sundanese}', "");
    Expect(0, 7103, '\P{Blk=sundanese}', "");
    Expect(1, 7103, '\P{^Blk=sundanese}', "");
    Expect(0, 7104, '\p{Blk=sundanese}', "");
    Expect(1, 7104, '\p{^Blk=sundanese}', "");
    Expect(1, 7104, '\P{Blk=sundanese}', "");
    Expect(0, 7104, '\P{^Blk=sundanese}', "");
    Expect(1, 7103, '\p{Blk=	Sundanese}', "");
    Expect(0, 7103, '\p{^Blk=	Sundanese}', "");
    Expect(0, 7103, '\P{Blk=	Sundanese}', "");
    Expect(1, 7103, '\P{^Blk=	Sundanese}', "");
    Expect(0, 7104, '\p{Blk=	Sundanese}', "");
    Expect(1, 7104, '\p{^Blk=	Sundanese}', "");
    Expect(1, 7104, '\P{Blk=	Sundanese}', "");
    Expect(0, 7104, '\P{^Blk=	Sundanese}', "");
    Error('\p{Is_Block=-	Sundanese:=}');
    Error('\P{Is_Block=-	Sundanese:=}');
    Expect(1, 7103, '\p{Is_Block: sundanese}', "");
    Expect(0, 7103, '\p{^Is_Block: sundanese}', "");
    Expect(0, 7103, '\P{Is_Block: sundanese}', "");
    Expect(1, 7103, '\P{^Is_Block: sundanese}', "");
    Expect(0, 7104, '\p{Is_Block: sundanese}', "");
    Expect(1, 7104, '\p{^Is_Block: sundanese}', "");
    Expect(1, 7104, '\P{Is_Block: sundanese}', "");
    Expect(0, 7104, '\P{^Is_Block: sundanese}', "");
    Expect(1, 7103, '\p{Is_Block= SUNDANESE}', "");
    Expect(0, 7103, '\p{^Is_Block= SUNDANESE}', "");
    Expect(0, 7103, '\P{Is_Block= SUNDANESE}', "");
    Expect(1, 7103, '\P{^Is_Block= SUNDANESE}', "");
    Expect(0, 7104, '\p{Is_Block= SUNDANESE}', "");
    Expect(1, 7104, '\p{^Is_Block= SUNDANESE}', "");
    Expect(1, 7104, '\P{Is_Block= SUNDANESE}', "");
    Expect(0, 7104, '\P{^Is_Block= SUNDANESE}', "");
    Error('\p{Is_Blk=-SUNDANESE/a/}');
    Error('\P{Is_Blk=-SUNDANESE/a/}');
    Expect(1, 7103, '\p{Is_Blk=sundanese}', "");
    Expect(0, 7103, '\p{^Is_Blk=sundanese}', "");
    Expect(0, 7103, '\P{Is_Blk=sundanese}', "");
    Expect(1, 7103, '\P{^Is_Blk=sundanese}', "");
    Expect(0, 7104, '\p{Is_Blk=sundanese}', "");
    Expect(1, 7104, '\p{^Is_Blk=sundanese}', "");
    Expect(1, 7104, '\P{Is_Blk=sundanese}', "");
    Expect(0, 7104, '\P{^Is_Blk=sundanese}', "");
    Expect(1, 7103, '\p{Is_Blk: 		sundanese}', "");
    Expect(0, 7103, '\p{^Is_Blk: 		sundanese}', "");
    Expect(0, 7103, '\P{Is_Blk: 		sundanese}', "");
    Expect(1, 7103, '\P{^Is_Blk: 		sundanese}', "");
    Expect(0, 7104, '\p{Is_Blk: 		sundanese}', "");
    Expect(1, 7104, '\p{^Is_Blk: 		sundanese}', "");
    Expect(1, 7104, '\P{Is_Blk: 		sundanese}', "");
    Expect(0, 7104, '\P{^Is_Blk: 		sundanese}', "");
    Error('\p{Block::=- Sundanese_Supplement}');
    Error('\P{Block::=- Sundanese_Supplement}');
    Expect(1, 7375, '\p{Block=sundanesesupplement}', "");
    Expect(0, 7375, '\p{^Block=sundanesesupplement}', "");
    Expect(0, 7375, '\P{Block=sundanesesupplement}', "");
    Expect(1, 7375, '\P{^Block=sundanesesupplement}', "");
    Expect(0, 7376, '\p{Block=sundanesesupplement}', "");
    Expect(1, 7376, '\p{^Block=sundanesesupplement}', "");
    Expect(1, 7376, '\P{Block=sundanesesupplement}', "");
    Expect(0, 7376, '\P{^Block=sundanesesupplement}', "");
    Expect(1, 7375, '\p{Block=	-Sundanese_SUPPLEMENT}', "");
    Expect(0, 7375, '\p{^Block=	-Sundanese_SUPPLEMENT}', "");
    Expect(0, 7375, '\P{Block=	-Sundanese_SUPPLEMENT}', "");
    Expect(1, 7375, '\P{^Block=	-Sundanese_SUPPLEMENT}', "");
    Expect(0, 7376, '\p{Block=	-Sundanese_SUPPLEMENT}', "");
    Expect(1, 7376, '\p{^Block=	-Sundanese_SUPPLEMENT}', "");
    Expect(1, 7376, '\P{Block=	-Sundanese_SUPPLEMENT}', "");
    Expect(0, 7376, '\P{^Block=	-Sundanese_SUPPLEMENT}', "");
    Error('\p{Blk=/a/	SUNDANESE_Sup}');
    Error('\P{Blk=/a/	SUNDANESE_Sup}');
    Expect(1, 7375, '\p{Blk=sundanesesup}', "");
    Expect(0, 7375, '\p{^Blk=sundanesesup}', "");
    Expect(0, 7375, '\P{Blk=sundanesesup}', "");
    Expect(1, 7375, '\P{^Blk=sundanesesup}', "");
    Expect(0, 7376, '\p{Blk=sundanesesup}', "");
    Expect(1, 7376, '\p{^Blk=sundanesesup}', "");
    Expect(1, 7376, '\P{Blk=sundanesesup}', "");
    Expect(0, 7376, '\P{^Blk=sundanesesup}', "");
    Expect(1, 7375, '\p{Blk=-Sundanese_sup}', "");
    Expect(0, 7375, '\p{^Blk=-Sundanese_sup}', "");
    Expect(0, 7375, '\P{Blk=-Sundanese_sup}', "");
    Expect(1, 7375, '\P{^Blk=-Sundanese_sup}', "");
    Expect(0, 7376, '\p{Blk=-Sundanese_sup}', "");
    Expect(1, 7376, '\p{^Blk=-Sundanese_sup}', "");
    Expect(1, 7376, '\P{Blk=-Sundanese_sup}', "");
    Expect(0, 7376, '\P{^Blk=-Sundanese_sup}', "");
    Error('\p{Is_Block=_:=sundanese_Supplement}');
    Error('\P{Is_Block=_:=sundanese_Supplement}');
    Expect(1, 7375, '\p{Is_Block=sundanesesupplement}', "");
    Expect(0, 7375, '\p{^Is_Block=sundanesesupplement}', "");
    Expect(0, 7375, '\P{Is_Block=sundanesesupplement}', "");
    Expect(1, 7375, '\P{^Is_Block=sundanesesupplement}', "");
    Expect(0, 7376, '\p{Is_Block=sundanesesupplement}', "");
    Expect(1, 7376, '\p{^Is_Block=sundanesesupplement}', "");
    Expect(1, 7376, '\P{Is_Block=sundanesesupplement}', "");
    Expect(0, 7376, '\P{^Is_Block=sundanesesupplement}', "");
    Expect(1, 7375, '\p{Is_Block=__Sundanese_Supplement}', "");
    Expect(0, 7375, '\p{^Is_Block=__Sundanese_Supplement}', "");
    Expect(0, 7375, '\P{Is_Block=__Sundanese_Supplement}', "");
    Expect(1, 7375, '\P{^Is_Block=__Sundanese_Supplement}', "");
    Expect(0, 7376, '\p{Is_Block=__Sundanese_Supplement}', "");
    Expect(1, 7376, '\p{^Is_Block=__Sundanese_Supplement}', "");
    Expect(1, 7376, '\P{Is_Block=__Sundanese_Supplement}', "");
    Expect(0, 7376, '\P{^Is_Block=__Sundanese_Supplement}', "");
    Error('\p{Is_Blk=	Sundanese_Sup:=}');
    Error('\P{Is_Blk=	Sundanese_Sup:=}');
    Expect(1, 7375, '\p{Is_Blk=sundanesesup}', "");
    Expect(0, 7375, '\p{^Is_Blk=sundanesesup}', "");
    Expect(0, 7375, '\P{Is_Blk=sundanesesup}', "");
    Expect(1, 7375, '\P{^Is_Blk=sundanesesup}', "");
    Expect(0, 7376, '\p{Is_Blk=sundanesesup}', "");
    Expect(1, 7376, '\p{^Is_Blk=sundanesesup}', "");
    Expect(1, 7376, '\P{Is_Blk=sundanesesup}', "");
    Expect(0, 7376, '\P{^Is_Blk=sundanesesup}', "");
    Expect(1, 7375, '\p{Is_Blk=	Sundanese_sup}', "");
    Expect(0, 7375, '\p{^Is_Blk=	Sundanese_sup}', "");
    Expect(0, 7375, '\P{Is_Blk=	Sundanese_sup}', "");
    Expect(1, 7375, '\P{^Is_Blk=	Sundanese_sup}', "");
    Expect(0, 7376, '\p{Is_Blk=	Sundanese_sup}', "");
    Expect(1, 7376, '\p{^Is_Blk=	Sundanese_sup}', "");
    Expect(1, 7376, '\P{Is_Blk=	Sundanese_sup}', "");
    Expect(0, 7376, '\P{^Is_Blk=	Sundanese_sup}', "");
    Error('\p{Block:   := 	Supplemental_Arrows_A}');
    Error('\P{Block:   := 	Supplemental_Arrows_A}');
    Expect(1, 10239, '\p{Block=supplementalarrowsa}', "");
    Expect(0, 10239, '\p{^Block=supplementalarrowsa}', "");
    Expect(0, 10239, '\P{Block=supplementalarrowsa}', "");
    Expect(1, 10239, '\P{^Block=supplementalarrowsa}', "");
    Expect(0, 10240, '\p{Block=supplementalarrowsa}', "");
    Expect(1, 10240, '\p{^Block=supplementalarrowsa}', "");
    Expect(1, 10240, '\P{Block=supplementalarrowsa}', "");
    Expect(0, 10240, '\P{^Block=supplementalarrowsa}', "");
    Expect(1, 10239, '\p{Block=-Supplemental_Arrows_a}', "");
    Expect(0, 10239, '\p{^Block=-Supplemental_Arrows_a}', "");
    Expect(0, 10239, '\P{Block=-Supplemental_Arrows_a}', "");
    Expect(1, 10239, '\P{^Block=-Supplemental_Arrows_a}', "");
    Expect(0, 10240, '\p{Block=-Supplemental_Arrows_a}', "");
    Expect(1, 10240, '\p{^Block=-Supplemental_Arrows_a}', "");
    Expect(1, 10240, '\P{Block=-Supplemental_Arrows_a}', "");
    Expect(0, 10240, '\P{^Block=-Supplemental_Arrows_a}', "");
    Error('\p{Blk=-sup_Arrows_A/a/}');
    Error('\P{Blk=-sup_Arrows_A/a/}');
    Expect(1, 10239, '\p{Blk=suparrowsa}', "");
    Expect(0, 10239, '\p{^Blk=suparrowsa}', "");
    Expect(0, 10239, '\P{Blk=suparrowsa}', "");
    Expect(1, 10239, '\P{^Blk=suparrowsa}', "");
    Expect(0, 10240, '\p{Blk=suparrowsa}', "");
    Expect(1, 10240, '\p{^Blk=suparrowsa}', "");
    Expect(1, 10240, '\P{Blk=suparrowsa}', "");
    Expect(0, 10240, '\P{^Blk=suparrowsa}', "");
    Expect(1, 10239, '\p{Blk= _sup_Arrows_a}', "");
    Expect(0, 10239, '\p{^Blk= _sup_Arrows_a}', "");
    Expect(0, 10239, '\P{Blk= _sup_Arrows_a}', "");
    Expect(1, 10239, '\P{^Blk= _sup_Arrows_a}', "");
    Expect(0, 10240, '\p{Blk= _sup_Arrows_a}', "");
    Expect(1, 10240, '\p{^Blk= _sup_Arrows_a}', "");
    Expect(1, 10240, '\P{Blk= _sup_Arrows_a}', "");
    Expect(0, 10240, '\P{^Blk= _sup_Arrows_a}', "");
    Error('\p{Is_Block=_:=Supplemental_arrows_A}');
    Error('\P{Is_Block=_:=Supplemental_arrows_A}');
    Expect(1, 10239, '\p{Is_Block=supplementalarrowsa}', "");
    Expect(0, 10239, '\p{^Is_Block=supplementalarrowsa}', "");
    Expect(0, 10239, '\P{Is_Block=supplementalarrowsa}', "");
    Expect(1, 10239, '\P{^Is_Block=supplementalarrowsa}', "");
    Expect(0, 10240, '\p{Is_Block=supplementalarrowsa}', "");
    Expect(1, 10240, '\p{^Is_Block=supplementalarrowsa}', "");
    Expect(1, 10240, '\P{Is_Block=supplementalarrowsa}', "");
    Expect(0, 10240, '\P{^Is_Block=supplementalarrowsa}', "");
    Expect(1, 10239, '\p{Is_Block=__Supplemental_arrows_A}', "");
    Expect(0, 10239, '\p{^Is_Block=__Supplemental_arrows_A}', "");
    Expect(0, 10239, '\P{Is_Block=__Supplemental_arrows_A}', "");
    Expect(1, 10239, '\P{^Is_Block=__Supplemental_arrows_A}', "");
    Expect(0, 10240, '\p{Is_Block=__Supplemental_arrows_A}', "");
    Expect(1, 10240, '\p{^Is_Block=__Supplemental_arrows_A}', "");
    Expect(1, 10240, '\P{Is_Block=__Supplemental_arrows_A}', "");
    Expect(0, 10240, '\P{^Is_Block=__Supplemental_arrows_A}', "");
    Error('\p{Is_Blk=	Sup_arrows_a:=}');
    Error('\P{Is_Blk=	Sup_arrows_a:=}');
    Expect(1, 10239, '\p{Is_Blk=suparrowsa}', "");
    Expect(0, 10239, '\p{^Is_Blk=suparrowsa}', "");
    Expect(0, 10239, '\P{Is_Blk=suparrowsa}', "");
    Expect(1, 10239, '\P{^Is_Blk=suparrowsa}', "");
    Expect(0, 10240, '\p{Is_Blk=suparrowsa}', "");
    Expect(1, 10240, '\p{^Is_Blk=suparrowsa}', "");
    Expect(1, 10240, '\P{Is_Blk=suparrowsa}', "");
    Expect(0, 10240, '\P{^Is_Blk=suparrowsa}', "");
    Expect(1, 10239, '\p{Is_Blk= 	sup_arrows_a}', "");
    Expect(0, 10239, '\p{^Is_Blk= 	sup_arrows_a}', "");
    Expect(0, 10239, '\P{Is_Blk= 	sup_arrows_a}', "");
    Expect(1, 10239, '\P{^Is_Blk= 	sup_arrows_a}', "");
    Expect(0, 10240, '\p{Is_Blk= 	sup_arrows_a}', "");
    Expect(1, 10240, '\p{^Is_Blk= 	sup_arrows_a}', "");
    Expect(1, 10240, '\P{Is_Blk= 	sup_arrows_a}', "");
    Expect(0, 10240, '\P{^Is_Blk= 	sup_arrows_a}', "");
    Error('\p{Block=:= -Supplemental_ARROWS_b}');
    Error('\P{Block=:= -Supplemental_ARROWS_b}');
    Expect(1, 10623, '\p{Block:supplementalarrowsb}', "");
    Expect(0, 10623, '\p{^Block:supplementalarrowsb}', "");
    Expect(0, 10623, '\P{Block:supplementalarrowsb}', "");
    Expect(1, 10623, '\P{^Block:supplementalarrowsb}', "");
    Expect(0, 10624, '\p{Block:supplementalarrowsb}', "");
    Expect(1, 10624, '\p{^Block:supplementalarrowsb}', "");
    Expect(1, 10624, '\P{Block:supplementalarrowsb}', "");
    Expect(0, 10624, '\P{^Block:supplementalarrowsb}', "");
    Expect(1, 10623, '\p{Block= SUPPLEMENTAL_ARROWS_b}', "");
    Expect(0, 10623, '\p{^Block= SUPPLEMENTAL_ARROWS_b}', "");
    Expect(0, 10623, '\P{Block= SUPPLEMENTAL_ARROWS_b}', "");
    Expect(1, 10623, '\P{^Block= SUPPLEMENTAL_ARROWS_b}', "");
    Expect(0, 10624, '\p{Block= SUPPLEMENTAL_ARROWS_b}', "");
    Expect(1, 10624, '\p{^Block= SUPPLEMENTAL_ARROWS_b}', "");
    Expect(1, 10624, '\P{Block= SUPPLEMENTAL_ARROWS_b}', "");
    Expect(0, 10624, '\P{^Block= SUPPLEMENTAL_ARROWS_b}', "");
    Error('\p{Blk=/a/  Sup_ARROWS_B}');
    Error('\P{Blk=/a/  Sup_ARROWS_B}');
    Expect(1, 10623, '\p{Blk=suparrowsb}', "");
    Expect(0, 10623, '\p{^Blk=suparrowsb}', "");
    Expect(0, 10623, '\P{Blk=suparrowsb}', "");
    Expect(1, 10623, '\P{^Blk=suparrowsb}', "");
    Expect(0, 10624, '\p{Blk=suparrowsb}', "");
    Expect(1, 10624, '\p{^Blk=suparrowsb}', "");
    Expect(1, 10624, '\P{Blk=suparrowsb}', "");
    Expect(0, 10624, '\P{^Blk=suparrowsb}', "");
    Expect(1, 10623, '\p{Blk=--SUP_ARROWS_B}', "");
    Expect(0, 10623, '\p{^Blk=--SUP_ARROWS_B}', "");
    Expect(0, 10623, '\P{Blk=--SUP_ARROWS_B}', "");
    Expect(1, 10623, '\P{^Blk=--SUP_ARROWS_B}', "");
    Expect(0, 10624, '\p{Blk=--SUP_ARROWS_B}', "");
    Expect(1, 10624, '\p{^Blk=--SUP_ARROWS_B}', "");
    Expect(1, 10624, '\P{Blk=--SUP_ARROWS_B}', "");
    Expect(0, 10624, '\P{^Blk=--SUP_ARROWS_B}', "");
    Error('\p{Is_Block=-:=Supplemental_Arrows_B}');
    Error('\P{Is_Block=-:=Supplemental_Arrows_B}');
    Expect(1, 10623, '\p{Is_Block=supplementalarrowsb}', "");
    Expect(0, 10623, '\p{^Is_Block=supplementalarrowsb}', "");
    Expect(0, 10623, '\P{Is_Block=supplementalarrowsb}', "");
    Expect(1, 10623, '\P{^Is_Block=supplementalarrowsb}', "");
    Expect(0, 10624, '\p{Is_Block=supplementalarrowsb}', "");
    Expect(1, 10624, '\p{^Is_Block=supplementalarrowsb}', "");
    Expect(1, 10624, '\P{Is_Block=supplementalarrowsb}', "");
    Expect(0, 10624, '\P{^Is_Block=supplementalarrowsb}', "");
    Expect(1, 10623, '\p{Is_Block=	Supplemental_Arrows_B}', "");
    Expect(0, 10623, '\p{^Is_Block=	Supplemental_Arrows_B}', "");
    Expect(0, 10623, '\P{Is_Block=	Supplemental_Arrows_B}', "");
    Expect(1, 10623, '\P{^Is_Block=	Supplemental_Arrows_B}', "");
    Expect(0, 10624, '\p{Is_Block=	Supplemental_Arrows_B}', "");
    Expect(1, 10624, '\p{^Is_Block=	Supplemental_Arrows_B}', "");
    Expect(1, 10624, '\P{Is_Block=	Supplemental_Arrows_B}', "");
    Expect(0, 10624, '\P{^Is_Block=	Supplemental_Arrows_B}', "");
    Error('\p{Is_Blk=/a/_-Sup_arrows_B}');
    Error('\P{Is_Blk=/a/_-Sup_arrows_B}');
    Expect(1, 10623, '\p{Is_Blk=suparrowsb}', "");
    Expect(0, 10623, '\p{^Is_Blk=suparrowsb}', "");
    Expect(0, 10623, '\P{Is_Blk=suparrowsb}', "");
    Expect(1, 10623, '\P{^Is_Blk=suparrowsb}', "");
    Expect(0, 10624, '\p{Is_Blk=suparrowsb}', "");
    Expect(1, 10624, '\p{^Is_Blk=suparrowsb}', "");
    Expect(1, 10624, '\P{Is_Blk=suparrowsb}', "");
    Expect(0, 10624, '\P{^Is_Blk=suparrowsb}', "");
    Expect(1, 10623, '\p{Is_Blk=	_SUP_arrows_b}', "");
    Expect(0, 10623, '\p{^Is_Blk=	_SUP_arrows_b}', "");
    Expect(0, 10623, '\P{Is_Blk=	_SUP_arrows_b}', "");
    Expect(1, 10623, '\P{^Is_Blk=	_SUP_arrows_b}', "");
    Expect(0, 10624, '\p{Is_Blk=	_SUP_arrows_b}', "");
    Expect(1, 10624, '\p{^Is_Blk=	_SUP_arrows_b}', "");
    Expect(1, 10624, '\P{Is_Blk=	_SUP_arrows_b}', "");
    Expect(0, 10624, '\P{^Is_Blk=	_SUP_arrows_b}', "");
    Error('\p{Block=	_SUPPLEMENTAL_arrows_C:=}');
    Error('\P{Block=	_SUPPLEMENTAL_arrows_C:=}');
    Expect(1, 129279, '\p{Block=supplementalarrowsc}', "");
    Expect(0, 129279, '\p{^Block=supplementalarrowsc}', "");
    Expect(0, 129279, '\P{Block=supplementalarrowsc}', "");
    Expect(1, 129279, '\P{^Block=supplementalarrowsc}', "");
    Expect(0, 129280, '\p{Block=supplementalarrowsc}', "");
    Expect(1, 129280, '\p{^Block=supplementalarrowsc}', "");
    Expect(1, 129280, '\P{Block=supplementalarrowsc}', "");
    Expect(0, 129280, '\P{^Block=supplementalarrowsc}', "");
    Expect(1, 129279, '\p{Block=- Supplemental_Arrows_C}', "");
    Expect(0, 129279, '\p{^Block=- Supplemental_Arrows_C}', "");
    Expect(0, 129279, '\P{Block=- Supplemental_Arrows_C}', "");
    Expect(1, 129279, '\P{^Block=- Supplemental_Arrows_C}', "");
    Expect(0, 129280, '\p{Block=- Supplemental_Arrows_C}', "");
    Expect(1, 129280, '\p{^Block=- Supplemental_Arrows_C}', "");
    Expect(1, 129280, '\P{Block=- Supplemental_Arrows_C}', "");
    Expect(0, 129280, '\P{^Block=- Supplemental_Arrows_C}', "");
    Error('\p{Blk:_SUP_Arrows_C:=}');
    Error('\P{Blk:_SUP_Arrows_C:=}');
    Expect(1, 129279, '\p{Blk:	suparrowsc}', "");
    Expect(0, 129279, '\p{^Blk:	suparrowsc}', "");
    Expect(0, 129279, '\P{Blk:	suparrowsc}', "");
    Expect(1, 129279, '\P{^Blk:	suparrowsc}', "");
    Expect(0, 129280, '\p{Blk:	suparrowsc}', "");
    Expect(1, 129280, '\p{^Blk:	suparrowsc}', "");
    Expect(1, 129280, '\P{Blk:	suparrowsc}', "");
    Expect(0, 129280, '\P{^Blk:	suparrowsc}', "");
    Expect(1, 129279, '\p{Blk=_	Sup_Arrows_c}', "");
    Expect(0, 129279, '\p{^Blk=_	Sup_Arrows_c}', "");
    Expect(0, 129279, '\P{Blk=_	Sup_Arrows_c}', "");
    Expect(1, 129279, '\P{^Blk=_	Sup_Arrows_c}', "");
    Expect(0, 129280, '\p{Blk=_	Sup_Arrows_c}', "");
    Expect(1, 129280, '\p{^Blk=_	Sup_Arrows_c}', "");
    Expect(1, 129280, '\P{Blk=_	Sup_Arrows_c}', "");
    Expect(0, 129280, '\P{^Blk=_	Sup_Arrows_c}', "");
    Error('\p{Is_Block=/a/Supplemental_Arrows_C}');
    Error('\P{Is_Block=/a/Supplemental_Arrows_C}');
    Expect(1, 129279, '\p{Is_Block:   supplementalarrowsc}', "");
    Expect(0, 129279, '\p{^Is_Block:   supplementalarrowsc}', "");
    Expect(0, 129279, '\P{Is_Block:   supplementalarrowsc}', "");
    Expect(1, 129279, '\P{^Is_Block:   supplementalarrowsc}', "");
    Expect(0, 129280, '\p{Is_Block:   supplementalarrowsc}', "");
    Expect(1, 129280, '\p{^Is_Block:   supplementalarrowsc}', "");
    Expect(1, 129280, '\P{Is_Block:   supplementalarrowsc}', "");
    Expect(0, 129280, '\P{^Is_Block:   supplementalarrowsc}', "");
    Expect(1, 129279, '\p{Is_Block=	_Supplemental_Arrows_c}', "");
    Expect(0, 129279, '\p{^Is_Block=	_Supplemental_Arrows_c}', "");
    Expect(0, 129279, '\P{Is_Block=	_Supplemental_Arrows_c}', "");
    Expect(1, 129279, '\P{^Is_Block=	_Supplemental_Arrows_c}', "");
    Expect(0, 129280, '\p{Is_Block=	_Supplemental_Arrows_c}', "");
    Expect(1, 129280, '\p{^Is_Block=	_Supplemental_Arrows_c}', "");
    Expect(1, 129280, '\P{Is_Block=	_Supplemental_Arrows_c}', "");
    Expect(0, 129280, '\P{^Is_Block=	_Supplemental_Arrows_c}', "");
    Error('\p{Is_Blk= SUP_arrows_c:=}');
    Error('\P{Is_Blk= SUP_arrows_c:=}');
    Expect(1, 129279, '\p{Is_Blk:	suparrowsc}', "");
    Expect(0, 129279, '\p{^Is_Blk:	suparrowsc}', "");
    Expect(0, 129279, '\P{Is_Blk:	suparrowsc}', "");
    Expect(1, 129279, '\P{^Is_Blk:	suparrowsc}', "");
    Expect(0, 129280, '\p{Is_Blk:	suparrowsc}', "");
    Expect(1, 129280, '\p{^Is_Blk:	suparrowsc}', "");
    Expect(1, 129280, '\P{Is_Blk:	suparrowsc}', "");
    Expect(0, 129280, '\P{^Is_Blk:	suparrowsc}', "");
    Expect(1, 129279, '\p{Is_Blk= SUP_Arrows_C}', "");
    Expect(0, 129279, '\p{^Is_Blk= SUP_Arrows_C}', "");
    Expect(0, 129279, '\P{Is_Blk= SUP_Arrows_C}', "");
    Expect(1, 129279, '\P{^Is_Blk= SUP_Arrows_C}', "");
    Expect(0, 129280, '\p{Is_Blk= SUP_Arrows_C}', "");
    Expect(1, 129280, '\p{^Is_Blk= SUP_Arrows_C}', "");
    Expect(1, 129280, '\P{Is_Blk= SUP_Arrows_C}', "");
    Expect(0, 129280, '\P{^Is_Blk= SUP_Arrows_C}', "");
    Error('\p{Block=_:=Supplemental_Mathematical_Operators}');
    Error('\P{Block=_:=Supplemental_Mathematical_Operators}');
    Expect(1, 11007, '\p{Block=supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\p{^Block=supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\P{Block=supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\P{^Block=supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\p{Block=supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\p{^Block=supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\P{Block=supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\P{^Block=supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\p{Block=_ Supplemental_Mathematical_operators}', "");
    Expect(0, 11007, '\p{^Block=_ Supplemental_Mathematical_operators}', "");
    Expect(0, 11007, '\P{Block=_ Supplemental_Mathematical_operators}', "");
    Expect(1, 11007, '\P{^Block=_ Supplemental_Mathematical_operators}', "");
    Expect(0, 11008, '\p{Block=_ Supplemental_Mathematical_operators}', "");
    Expect(1, 11008, '\p{^Block=_ Supplemental_Mathematical_operators}', "");
    Expect(1, 11008, '\P{Block=_ Supplemental_Mathematical_operators}', "");
    Expect(0, 11008, '\P{^Block=_ Supplemental_Mathematical_operators}', "");
    Error('\p{Blk=-:=Sup_Math_OPERATORS}');
    Error('\P{Blk=-:=Sup_Math_OPERATORS}');
    Expect(1, 11007, '\p{Blk=supmathoperators}', "");
    Expect(0, 11007, '\p{^Blk=supmathoperators}', "");
    Expect(0, 11007, '\P{Blk=supmathoperators}', "");
    Expect(1, 11007, '\P{^Blk=supmathoperators}', "");
    Expect(0, 11008, '\p{Blk=supmathoperators}', "");
    Expect(1, 11008, '\p{^Blk=supmathoperators}', "");
    Expect(1, 11008, '\P{Blk=supmathoperators}', "");
    Expect(0, 11008, '\P{^Blk=supmathoperators}', "");
    Expect(1, 11007, '\p{Blk=_Sup_math_Operators}', "");
    Expect(0, 11007, '\p{^Blk=_Sup_math_Operators}', "");
    Expect(0, 11007, '\P{Blk=_Sup_math_Operators}', "");
    Expect(1, 11007, '\P{^Blk=_Sup_math_Operators}', "");
    Expect(0, 11008, '\p{Blk=_Sup_math_Operators}', "");
    Expect(1, 11008, '\p{^Blk=_Sup_math_Operators}', "");
    Expect(1, 11008, '\P{Blk=_Sup_math_Operators}', "");
    Expect(0, 11008, '\P{^Blk=_Sup_math_Operators}', "");
    Error('\p{Is_Block=	 Supplemental_MATHEMATICAL_Operators:=}');
    Error('\P{Is_Block=	 Supplemental_MATHEMATICAL_Operators:=}');
    Expect(1, 11007, '\p{Is_Block=supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\p{^Is_Block=supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\P{Is_Block=supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\P{^Is_Block=supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\p{Is_Block=supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\p{^Is_Block=supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\P{Is_Block=supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\P{^Is_Block=supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\p{Is_Block=_Supplemental_Mathematical_OPERATORS}', "");
    Expect(0, 11007, '\p{^Is_Block=_Supplemental_Mathematical_OPERATORS}', "");
    Expect(0, 11007, '\P{Is_Block=_Supplemental_Mathematical_OPERATORS}', "");
    Expect(1, 11007, '\P{^Is_Block=_Supplemental_Mathematical_OPERATORS}', "");
    Expect(0, 11008, '\p{Is_Block=_Supplemental_Mathematical_OPERATORS}', "");
    Expect(1, 11008, '\p{^Is_Block=_Supplemental_Mathematical_OPERATORS}', "");
    Expect(1, 11008, '\P{Is_Block=_Supplemental_Mathematical_OPERATORS}', "");
    Expect(0, 11008, '\P{^Is_Block=_Supplemental_Mathematical_OPERATORS}', "");
    Error('\p{Is_Blk= Sup_MATH_operators:=}');
    Error('\P{Is_Blk= Sup_MATH_operators:=}');
    Expect(1, 11007, '\p{Is_Blk=supmathoperators}', "");
    Expect(0, 11007, '\p{^Is_Blk=supmathoperators}', "");
    Expect(0, 11007, '\P{Is_Blk=supmathoperators}', "");
    Expect(1, 11007, '\P{^Is_Blk=supmathoperators}', "");
    Expect(0, 11008, '\p{Is_Blk=supmathoperators}', "");
    Expect(1, 11008, '\p{^Is_Blk=supmathoperators}', "");
    Expect(1, 11008, '\P{Is_Blk=supmathoperators}', "");
    Expect(0, 11008, '\P{^Is_Blk=supmathoperators}', "");
    Expect(1, 11007, '\p{Is_Blk=_-SUP_math_Operators}', "");
    Expect(0, 11007, '\p{^Is_Blk=_-SUP_math_Operators}', "");
    Expect(0, 11007, '\P{Is_Blk=_-SUP_math_Operators}', "");
    Expect(1, 11007, '\P{^Is_Blk=_-SUP_math_Operators}', "");
    Expect(0, 11008, '\p{Is_Blk=_-SUP_math_Operators}', "");
    Expect(1, 11008, '\p{^Is_Blk=_-SUP_math_Operators}', "");
    Expect(1, 11008, '\P{Is_Blk=_-SUP_math_Operators}', "");
    Expect(0, 11008, '\P{^Is_Blk=_-SUP_math_Operators}', "");
    Error('\p{Block:   _/a/Supplementary_private_Use_Area_a}');
    Error('\P{Block:   _/a/Supplementary_private_Use_Area_a}');
    Expect(1, 983040, '\p{Block=supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\p{^Block=supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\P{Block=supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\P{^Block=supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\p{Block=supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\p{^Block=supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\P{Block=supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\P{^Block=supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\p{Block: - Supplementary_Private_Use_area_a}', "");
    Expect(0, 983040, '\p{^Block: - Supplementary_Private_Use_area_a}', "");
    Expect(0, 983040, '\P{Block: - Supplementary_Private_Use_area_a}', "");
    Expect(1, 983040, '\P{^Block: - Supplementary_Private_Use_area_a}', "");
    Expect(0, 1048576, '\p{Block: - Supplementary_Private_Use_area_a}', "");
    Expect(1, 1048576, '\p{^Block: - Supplementary_Private_Use_area_a}', "");
    Expect(1, 1048576, '\P{Block: - Supplementary_Private_Use_area_a}', "");
    Expect(0, 1048576, '\P{^Block: - Supplementary_Private_Use_area_a}', "");
    Error('\p{Blk=:=--Sup_PUA_a}');
    Error('\P{Blk=:=--Sup_PUA_a}');
    Expect(1, 983040, '\p{Blk=suppuaa}', "");
    Expect(0, 983040, '\p{^Blk=suppuaa}', "");
    Expect(0, 983040, '\P{Blk=suppuaa}', "");
    Expect(1, 983040, '\P{^Blk=suppuaa}', "");
    Expect(0, 1048576, '\p{Blk=suppuaa}', "");
    Expect(1, 1048576, '\p{^Blk=suppuaa}', "");
    Expect(1, 1048576, '\P{Blk=suppuaa}', "");
    Expect(0, 1048576, '\P{^Blk=suppuaa}', "");
    Expect(1, 983040, '\p{Blk=  sup_PUA_A}', "");
    Expect(0, 983040, '\p{^Blk=  sup_PUA_A}', "");
    Expect(0, 983040, '\P{Blk=  sup_PUA_A}', "");
    Expect(1, 983040, '\P{^Blk=  sup_PUA_A}', "");
    Expect(0, 1048576, '\p{Blk=  sup_PUA_A}', "");
    Expect(1, 1048576, '\p{^Blk=  sup_PUA_A}', "");
    Expect(1, 1048576, '\P{Blk=  sup_PUA_A}', "");
    Expect(0, 1048576, '\P{^Blk=  sup_PUA_A}', "");
    Error('\p{Is_Block=		Supplementary_Private_Use_Area_A:=}');
    Error('\P{Is_Block=		Supplementary_Private_Use_Area_A:=}');
    Expect(1, 983040, '\p{Is_Block=supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\p{^Is_Block=supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\P{Is_Block=supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\P{^Is_Block=supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\p{Is_Block=supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\p{^Is_Block=supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\P{Is_Block=supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\P{^Is_Block=supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\p{Is_Block= -supplementary_Private_Use_Area_A}', "");
    Expect(0, 983040, '\p{^Is_Block= -supplementary_Private_Use_Area_A}', "");
    Expect(0, 983040, '\P{Is_Block= -supplementary_Private_Use_Area_A}', "");
    Expect(1, 983040, '\P{^Is_Block= -supplementary_Private_Use_Area_A}', "");
    Expect(0, 1048576, '\p{Is_Block= -supplementary_Private_Use_Area_A}', "");
    Expect(1, 1048576, '\p{^Is_Block= -supplementary_Private_Use_Area_A}', "");
    Expect(1, 1048576, '\P{Is_Block= -supplementary_Private_Use_Area_A}', "");
    Expect(0, 1048576, '\P{^Is_Block= -supplementary_Private_Use_Area_A}', "");
    Error('\p{Is_Blk=:=-SUP_PUA_a}');
    Error('\P{Is_Blk=:=-SUP_PUA_a}');
    Expect(1, 983040, '\p{Is_Blk=suppuaa}', "");
    Expect(0, 983040, '\p{^Is_Blk=suppuaa}', "");
    Expect(0, 983040, '\P{Is_Blk=suppuaa}', "");
    Expect(1, 983040, '\P{^Is_Blk=suppuaa}', "");
    Expect(0, 1048576, '\p{Is_Blk=suppuaa}', "");
    Expect(1, 1048576, '\p{^Is_Blk=suppuaa}', "");
    Expect(1, 1048576, '\P{Is_Blk=suppuaa}', "");
    Expect(0, 1048576, '\P{^Is_Blk=suppuaa}', "");
    Expect(1, 983040, '\p{Is_Blk= SUP_PUA_A}', "");
    Expect(0, 983040, '\p{^Is_Blk= SUP_PUA_A}', "");
    Expect(0, 983040, '\P{Is_Blk= SUP_PUA_A}', "");
    Expect(1, 983040, '\P{^Is_Blk= SUP_PUA_A}', "");
    Expect(0, 1048576, '\p{Is_Blk= SUP_PUA_A}', "");
    Expect(1, 1048576, '\p{^Is_Blk= SUP_PUA_A}', "");
    Expect(1, 1048576, '\P{Is_Blk= SUP_PUA_A}', "");
    Expect(0, 1048576, '\P{^Is_Blk= SUP_PUA_A}', "");
    Error('\p{Block=:=__supplementary_private_USE_Area_B}');
    Error('\P{Block=:=__supplementary_private_USE_Area_B}');
    Expect(1, 1048576, '\p{Block=supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\p{^Block=supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\P{Block=supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\P{^Block=supplementaryprivateuseareab}', "");
    Expect(0, 1, '\p{Block=supplementaryprivateuseareab}', "");
    Expect(1, 1, '\p{^Block=supplementaryprivateuseareab}', "");
    Expect(1, 1, '\P{Block=supplementaryprivateuseareab}', "");
    Expect(0, 1, '\P{^Block=supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\p{Block=_Supplementary_private_use_AREA_B}', "");
    Expect(0, 1048576, '\p{^Block=_Supplementary_private_use_AREA_B}', "");
    Expect(0, 1048576, '\P{Block=_Supplementary_private_use_AREA_B}', "");
    Expect(1, 1048576, '\P{^Block=_Supplementary_private_use_AREA_B}', "");
    Expect(0, 1, '\p{Block=_Supplementary_private_use_AREA_B}', "");
    Expect(1, 1, '\p{^Block=_Supplementary_private_use_AREA_B}', "");
    Expect(1, 1, '\P{Block=_Supplementary_private_use_AREA_B}', "");
    Expect(0, 1, '\P{^Block=_Supplementary_private_use_AREA_B}', "");
    Error('\p{Blk: _:=sup_pua_B}');
    Error('\P{Blk: _:=sup_pua_B}');
    Expect(1, 1048576, '\p{Blk=suppuab}', "");
    Expect(0, 1048576, '\p{^Blk=suppuab}', "");
    Expect(0, 1048576, '\P{Blk=suppuab}', "");
    Expect(1, 1048576, '\P{^Blk=suppuab}', "");
    Expect(0, 1, '\p{Blk=suppuab}', "");
    Expect(1, 1, '\p{^Blk=suppuab}', "");
    Expect(1, 1, '\P{Blk=suppuab}', "");
    Expect(0, 1, '\P{^Blk=suppuab}', "");
    Expect(1, 1048576, '\p{Blk=-Sup_PUA_B}', "");
    Expect(0, 1048576, '\p{^Blk=-Sup_PUA_B}', "");
    Expect(0, 1048576, '\P{Blk=-Sup_PUA_B}', "");
    Expect(1, 1048576, '\P{^Blk=-Sup_PUA_B}', "");
    Expect(0, 1, '\p{Blk=-Sup_PUA_B}', "");
    Expect(1, 1, '\p{^Blk=-Sup_PUA_B}', "");
    Expect(1, 1, '\P{Blk=-Sup_PUA_B}', "");
    Expect(0, 1, '\P{^Blk=-Sup_PUA_B}', "");
    Error('\p{Is_Block=-	Supplementary_Private_use_Area_B:=}');
    Error('\P{Is_Block=-	Supplementary_Private_use_Area_B:=}');
    Expect(1, 1048576, '\p{Is_Block: supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\p{^Is_Block: supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\P{Is_Block: supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\P{^Is_Block: supplementaryprivateuseareab}', "");
    Expect(0, 1, '\p{Is_Block: supplementaryprivateuseareab}', "");
    Expect(1, 1, '\p{^Is_Block: supplementaryprivateuseareab}', "");
    Expect(1, 1, '\P{Is_Block: supplementaryprivateuseareab}', "");
    Expect(0, 1, '\P{^Is_Block: supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\p{Is_Block=	-SUPPLEMENTARY_Private_USE_Area_b}', "");
    Expect(0, 1048576, '\p{^Is_Block=	-SUPPLEMENTARY_Private_USE_Area_b}', "");
    Expect(0, 1048576, '\P{Is_Block=	-SUPPLEMENTARY_Private_USE_Area_b}', "");
    Expect(1, 1048576, '\P{^Is_Block=	-SUPPLEMENTARY_Private_USE_Area_b}', "");
    Expect(0, 1, '\p{Is_Block=	-SUPPLEMENTARY_Private_USE_Area_b}', "");
    Expect(1, 1, '\p{^Is_Block=	-SUPPLEMENTARY_Private_USE_Area_b}', "");
    Expect(1, 1, '\P{Is_Block=	-SUPPLEMENTARY_Private_USE_Area_b}', "");
    Expect(0, 1, '\P{^Is_Block=	-SUPPLEMENTARY_Private_USE_Area_b}', "");
    Error('\p{Is_Blk=/a/	SUP_PUA_b}');
    Error('\P{Is_Blk=/a/	SUP_PUA_b}');
    Expect(1, 1048576, '\p{Is_Blk:   suppuab}', "");
    Expect(0, 1048576, '\p{^Is_Blk:   suppuab}', "");
    Expect(0, 1048576, '\P{Is_Blk:   suppuab}', "");
    Expect(1, 1048576, '\P{^Is_Blk:   suppuab}', "");
    Expect(0, 1, '\p{Is_Blk:   suppuab}', "");
    Expect(1, 1, '\p{^Is_Blk:   suppuab}', "");
    Expect(1, 1, '\P{Is_Blk:   suppuab}', "");
    Expect(0, 1, '\P{^Is_Blk:   suppuab}', "");
    Expect(1, 1048576, '\p{Is_Blk=Sup_pua_B}', "");
    Expect(0, 1048576, '\p{^Is_Blk=Sup_pua_B}', "");
    Expect(0, 1048576, '\P{Is_Blk=Sup_pua_B}', "");
    Expect(1, 1048576, '\P{^Is_Blk=Sup_pua_B}', "");
    Expect(0, 1, '\p{Is_Blk=Sup_pua_B}', "");
    Expect(1, 1, '\p{^Is_Blk=Sup_pua_B}', "");
    Expect(1, 1, '\P{Is_Blk=Sup_pua_B}', "");
    Expect(0, 1, '\P{^Is_Blk=Sup_pua_B}', "");
    Error('\p{Block=:=-supplemental_punctuation}');
    Error('\P{Block=:=-supplemental_punctuation}');
    Expect(1, 11903, '\p{Block=supplementalpunctuation}', "");
    Expect(0, 11903, '\p{^Block=supplementalpunctuation}', "");
    Expect(0, 11903, '\P{Block=supplementalpunctuation}', "");
    Expect(1, 11903, '\P{^Block=supplementalpunctuation}', "");
    Expect(0, 11904, '\p{Block=supplementalpunctuation}', "");
    Expect(1, 11904, '\p{^Block=supplementalpunctuation}', "");
    Expect(1, 11904, '\P{Block=supplementalpunctuation}', "");
    Expect(0, 11904, '\P{^Block=supplementalpunctuation}', "");
    Expect(1, 11903, '\p{Block=	-SUPPLEMENTAL_PUNCTUATION}', "");
    Expect(0, 11903, '\p{^Block=	-SUPPLEMENTAL_PUNCTUATION}', "");
    Expect(0, 11903, '\P{Block=	-SUPPLEMENTAL_PUNCTUATION}', "");
    Expect(1, 11903, '\P{^Block=	-SUPPLEMENTAL_PUNCTUATION}', "");
    Expect(0, 11904, '\p{Block=	-SUPPLEMENTAL_PUNCTUATION}', "");
    Expect(1, 11904, '\p{^Block=	-SUPPLEMENTAL_PUNCTUATION}', "");
    Expect(1, 11904, '\P{Block=	-SUPPLEMENTAL_PUNCTUATION}', "");
    Expect(0, 11904, '\P{^Block=	-SUPPLEMENTAL_PUNCTUATION}', "");
    Error('\p{Blk=-:=sup_Punctuation}');
    Error('\P{Blk=-:=sup_Punctuation}');
    Expect(1, 11903, '\p{Blk=suppunctuation}', "");
    Expect(0, 11903, '\p{^Blk=suppunctuation}', "");
    Expect(0, 11903, '\P{Blk=suppunctuation}', "");
    Expect(1, 11903, '\P{^Blk=suppunctuation}', "");
    Expect(0, 11904, '\p{Blk=suppunctuation}', "");
    Expect(1, 11904, '\p{^Blk=suppunctuation}', "");
    Expect(1, 11904, '\P{Blk=suppunctuation}', "");
    Expect(0, 11904, '\P{^Blk=suppunctuation}', "");
    Expect(1, 11903, '\p{Blk=sup_Punctuation}', "");
    Expect(0, 11903, '\p{^Blk=sup_Punctuation}', "");
    Expect(0, 11903, '\P{Blk=sup_Punctuation}', "");
    Expect(1, 11903, '\P{^Blk=sup_Punctuation}', "");
    Expect(0, 11904, '\p{Blk=sup_Punctuation}', "");
    Expect(1, 11904, '\p{^Blk=sup_Punctuation}', "");
    Expect(1, 11904, '\P{Blk=sup_Punctuation}', "");
    Expect(0, 11904, '\P{^Blk=sup_Punctuation}', "");
    Error('\p{Is_Block=/a/-Supplemental_Punctuation}');
    Error('\P{Is_Block=/a/-Supplemental_Punctuation}');
    Expect(1, 11903, '\p{Is_Block=supplementalpunctuation}', "");
    Expect(0, 11903, '\p{^Is_Block=supplementalpunctuation}', "");
    Expect(0, 11903, '\P{Is_Block=supplementalpunctuation}', "");
    Expect(1, 11903, '\P{^Is_Block=supplementalpunctuation}', "");
    Expect(0, 11904, '\p{Is_Block=supplementalpunctuation}', "");
    Expect(1, 11904, '\p{^Is_Block=supplementalpunctuation}', "");
    Expect(1, 11904, '\P{Is_Block=supplementalpunctuation}', "");
    Expect(0, 11904, '\P{^Is_Block=supplementalpunctuation}', "");
    Expect(1, 11903, '\p{Is_Block=--SUPPLEMENTAL_punctuation}', "");
    Expect(0, 11903, '\p{^Is_Block=--SUPPLEMENTAL_punctuation}', "");
    Expect(0, 11903, '\P{Is_Block=--SUPPLEMENTAL_punctuation}', "");
    Expect(1, 11903, '\P{^Is_Block=--SUPPLEMENTAL_punctuation}', "");
    Expect(0, 11904, '\p{Is_Block=--SUPPLEMENTAL_punctuation}', "");
    Expect(1, 11904, '\p{^Is_Block=--SUPPLEMENTAL_punctuation}', "");
    Expect(1, 11904, '\P{Is_Block=--SUPPLEMENTAL_punctuation}', "");
    Expect(0, 11904, '\P{^Is_Block=--SUPPLEMENTAL_punctuation}', "");
    Error('\p{Is_Blk=/a/ sup_punctuation}');
    Error('\P{Is_Blk=/a/ sup_punctuation}');
    Expect(1, 11903, '\p{Is_Blk=suppunctuation}', "");
    Expect(0, 11903, '\p{^Is_Blk=suppunctuation}', "");
    Expect(0, 11903, '\P{Is_Blk=suppunctuation}', "");
    Expect(1, 11903, '\P{^Is_Blk=suppunctuation}', "");
    Expect(0, 11904, '\p{Is_Blk=suppunctuation}', "");
    Expect(1, 11904, '\p{^Is_Blk=suppunctuation}', "");
    Expect(1, 11904, '\P{Is_Blk=suppunctuation}', "");
    Expect(0, 11904, '\P{^Is_Blk=suppunctuation}', "");
    Expect(1, 11903, '\p{Is_Blk=	-Sup_PUNCTUATION}', "");
    Expect(0, 11903, '\p{^Is_Blk=	-Sup_PUNCTUATION}', "");
    Expect(0, 11903, '\P{Is_Blk=	-Sup_PUNCTUATION}', "");
    Expect(1, 11903, '\P{^Is_Blk=	-Sup_PUNCTUATION}', "");
    Expect(0, 11904, '\p{Is_Blk=	-Sup_PUNCTUATION}', "");
    Expect(1, 11904, '\p{^Is_Blk=	-Sup_PUNCTUATION}', "");
    Expect(1, 11904, '\P{Is_Blk=	-Sup_PUNCTUATION}', "");
    Expect(0, 11904, '\P{^Is_Blk=	-Sup_PUNCTUATION}', "");
    Error('\p{Block=:=_SUPPLEMENTAL_Symbols_And_Pictographs}');
    Error('\P{Block=:=_SUPPLEMENTAL_Symbols_And_Pictographs}');
    Expect(1, 129535, '\p{Block:   supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^Block:   supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{Block:   supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^Block:   supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{Block:   supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^Block:   supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{Block:   supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^Block:   supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{Block= 	Supplemental_symbols_And_Pictographs}', "");
    Expect(0, 129535, '\p{^Block= 	Supplemental_symbols_And_Pictographs}', "");
    Expect(0, 129535, '\P{Block= 	Supplemental_symbols_And_Pictographs}', "");
    Expect(1, 129535, '\P{^Block= 	Supplemental_symbols_And_Pictographs}', "");
    Expect(0, 129536, '\p{Block= 	Supplemental_symbols_And_Pictographs}', "");
    Expect(1, 129536, '\p{^Block= 	Supplemental_symbols_And_Pictographs}', "");
    Expect(1, 129536, '\P{Block= 	Supplemental_symbols_And_Pictographs}', "");
    Expect(0, 129536, '\P{^Block= 	Supplemental_symbols_And_Pictographs}', "");
    Error('\p{Blk=	-SUP_Symbols_And_Pictographs:=}');
    Error('\P{Blk=	-SUP_Symbols_And_Pictographs:=}');
    Expect(1, 129535, '\p{Blk=supsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^Blk=supsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{Blk=supsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^Blk=supsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{Blk=supsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^Blk=supsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{Blk=supsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^Blk=supsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{Blk=- sup_symbols_and_PICTOGRAPHS}', "");
    Expect(0, 129535, '\p{^Blk=- sup_symbols_and_PICTOGRAPHS}', "");
    Expect(0, 129535, '\P{Blk=- sup_symbols_and_PICTOGRAPHS}', "");
    Expect(1, 129535, '\P{^Blk=- sup_symbols_and_PICTOGRAPHS}', "");
    Expect(0, 129536, '\p{Blk=- sup_symbols_and_PICTOGRAPHS}', "");
    Expect(1, 129536, '\p{^Blk=- sup_symbols_and_PICTOGRAPHS}', "");
    Expect(1, 129536, '\P{Blk=- sup_symbols_and_PICTOGRAPHS}', "");
    Expect(0, 129536, '\P{^Blk=- sup_symbols_and_PICTOGRAPHS}', "");
    Error('\p{Is_Block=	/a/Supplemental_SYMBOLS_and_PICTOGRAPHS}');
    Error('\P{Is_Block=	/a/Supplemental_SYMBOLS_and_PICTOGRAPHS}');
    Expect(1, 129535, '\p{Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{Is_Block=-Supplemental_SYMBOLS_And_Pictographs}', "");
    Expect(0, 129535, '\p{^Is_Block=-Supplemental_SYMBOLS_And_Pictographs}', "");
    Expect(0, 129535, '\P{Is_Block=-Supplemental_SYMBOLS_And_Pictographs}', "");
    Expect(1, 129535, '\P{^Is_Block=-Supplemental_SYMBOLS_And_Pictographs}', "");
    Expect(0, 129536, '\p{Is_Block=-Supplemental_SYMBOLS_And_Pictographs}', "");
    Expect(1, 129536, '\p{^Is_Block=-Supplemental_SYMBOLS_And_Pictographs}', "");
    Expect(1, 129536, '\P{Is_Block=-Supplemental_SYMBOLS_And_Pictographs}', "");
    Expect(0, 129536, '\P{^Is_Block=-Supplemental_SYMBOLS_And_Pictographs}', "");
    Error('\p{Is_Blk: -_Sup_Symbols_and_pictographs/a/}');
    Error('\P{Is_Blk: -_Sup_Symbols_and_pictographs/a/}');
    Expect(1, 129535, '\p{Is_Blk=supsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^Is_Blk=supsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{Is_Blk=supsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^Is_Blk=supsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{Is_Blk=supsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^Is_Blk=supsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{Is_Blk=supsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^Is_Blk=supsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{Is_Blk= -Sup_symbols_And_Pictographs}', "");
    Expect(0, 129535, '\p{^Is_Blk= -Sup_symbols_And_Pictographs}', "");
    Expect(0, 129535, '\P{Is_Blk= -Sup_symbols_And_Pictographs}', "");
    Expect(1, 129535, '\P{^Is_Blk= -Sup_symbols_And_Pictographs}', "");
    Expect(0, 129536, '\p{Is_Blk= -Sup_symbols_And_Pictographs}', "");
    Expect(1, 129536, '\p{^Is_Blk= -Sup_symbols_And_Pictographs}', "");
    Expect(1, 129536, '\P{Is_Blk= -Sup_symbols_And_Pictographs}', "");
    Expect(0, 129536, '\P{^Is_Blk= -Sup_symbols_And_Pictographs}', "");
    Error('\p{Block=-superscripts_And_SUBSCRIPTS:=}');
    Error('\P{Block=-superscripts_And_SUBSCRIPTS:=}');
    Expect(1, 8351, '\p{Block=superscriptsandsubscripts}', "");
    Expect(0, 8351, '\p{^Block=superscriptsandsubscripts}', "");
    Expect(0, 8351, '\P{Block=superscriptsandsubscripts}', "");
    Expect(1, 8351, '\P{^Block=superscriptsandsubscripts}', "");
    Expect(0, 8352, '\p{Block=superscriptsandsubscripts}', "");
    Expect(1, 8352, '\p{^Block=superscriptsandsubscripts}', "");
    Expect(1, 8352, '\P{Block=superscriptsandsubscripts}', "");
    Expect(0, 8352, '\P{^Block=superscriptsandsubscripts}', "");
    Expect(1, 8351, '\p{Block= Superscripts_And_subscripts}', "");
    Expect(0, 8351, '\p{^Block= Superscripts_And_subscripts}', "");
    Expect(0, 8351, '\P{Block= Superscripts_And_subscripts}', "");
    Expect(1, 8351, '\P{^Block= Superscripts_And_subscripts}', "");
    Expect(0, 8352, '\p{Block= Superscripts_And_subscripts}', "");
    Expect(1, 8352, '\p{^Block= Superscripts_And_subscripts}', "");
    Expect(1, 8352, '\P{Block= Superscripts_And_subscripts}', "");
    Expect(0, 8352, '\P{^Block= Superscripts_And_subscripts}', "");
    Error('\p{Blk=	/a/Super_And_Sub}');
    Error('\P{Blk=	/a/Super_And_Sub}');
    Expect(1, 8351, '\p{Blk: superandsub}', "");
    Expect(0, 8351, '\p{^Blk: superandsub}', "");
    Expect(0, 8351, '\P{Blk: superandsub}', "");
    Expect(1, 8351, '\P{^Blk: superandsub}', "");
    Expect(0, 8352, '\p{Blk: superandsub}', "");
    Expect(1, 8352, '\p{^Blk: superandsub}', "");
    Expect(1, 8352, '\P{Blk: superandsub}', "");
    Expect(0, 8352, '\P{^Blk: superandsub}', "");
    Expect(1, 8351, '\p{Blk=_SUPER_And_Sub}', "");
    Expect(0, 8351, '\p{^Blk=_SUPER_And_Sub}', "");
    Expect(0, 8351, '\P{Blk=_SUPER_And_Sub}', "");
    Expect(1, 8351, '\P{^Blk=_SUPER_And_Sub}', "");
    Expect(0, 8352, '\p{Blk=_SUPER_And_Sub}', "");
    Expect(1, 8352, '\p{^Blk=_SUPER_And_Sub}', "");
    Expect(1, 8352, '\P{Blk=_SUPER_And_Sub}', "");
    Expect(0, 8352, '\P{^Blk=_SUPER_And_Sub}', "");
    Error('\p{Is_Block=/a/	_Superscripts_And_SUBSCRIPTS}');
    Error('\P{Is_Block=/a/	_Superscripts_And_SUBSCRIPTS}');
    Expect(1, 8351, '\p{Is_Block=superscriptsandsubscripts}', "");
    Expect(0, 8351, '\p{^Is_Block=superscriptsandsubscripts}', "");
    Expect(0, 8351, '\P{Is_Block=superscriptsandsubscripts}', "");
    Expect(1, 8351, '\P{^Is_Block=superscriptsandsubscripts}', "");
    Expect(0, 8352, '\p{Is_Block=superscriptsandsubscripts}', "");
    Expect(1, 8352, '\p{^Is_Block=superscriptsandsubscripts}', "");
    Expect(1, 8352, '\P{Is_Block=superscriptsandsubscripts}', "");
    Expect(0, 8352, '\P{^Is_Block=superscriptsandsubscripts}', "");
    Expect(1, 8351, '\p{Is_Block= Superscripts_And_SUBSCRIPTS}', "");
    Expect(0, 8351, '\p{^Is_Block= Superscripts_And_SUBSCRIPTS}', "");
    Expect(0, 8351, '\P{Is_Block= Superscripts_And_SUBSCRIPTS}', "");
    Expect(1, 8351, '\P{^Is_Block= Superscripts_And_SUBSCRIPTS}', "");
    Expect(0, 8352, '\p{Is_Block= Superscripts_And_SUBSCRIPTS}', "");
    Expect(1, 8352, '\p{^Is_Block= Superscripts_And_SUBSCRIPTS}', "");
    Expect(1, 8352, '\P{Is_Block= Superscripts_And_SUBSCRIPTS}', "");
    Expect(0, 8352, '\P{^Is_Block= Superscripts_And_SUBSCRIPTS}', "");
    Error('\p{Is_Blk=:=-	super_And_Sub}');
    Error('\P{Is_Blk=:=-	super_And_Sub}');
    Expect(1, 8351, '\p{Is_Blk=superandsub}', "");
    Expect(0, 8351, '\p{^Is_Blk=superandsub}', "");
    Expect(0, 8351, '\P{Is_Blk=superandsub}', "");
    Expect(1, 8351, '\P{^Is_Blk=superandsub}', "");
    Expect(0, 8352, '\p{Is_Blk=superandsub}', "");
    Expect(1, 8352, '\p{^Is_Blk=superandsub}', "");
    Expect(1, 8352, '\P{Is_Blk=superandsub}', "");
    Expect(0, 8352, '\P{^Is_Blk=superandsub}', "");
    Expect(1, 8351, '\p{Is_Blk=_ Super_And_Sub}', "");
    Expect(0, 8351, '\p{^Is_Blk=_ Super_And_Sub}', "");
    Expect(0, 8351, '\P{Is_Blk=_ Super_And_Sub}', "");
    Expect(1, 8351, '\P{^Is_Blk=_ Super_And_Sub}', "");
    Expect(0, 8352, '\p{Is_Blk=_ Super_And_Sub}', "");
    Expect(1, 8352, '\p{^Is_Blk=_ Super_And_Sub}', "");
    Expect(1, 8352, '\P{Is_Blk=_ Super_And_Sub}', "");
    Expect(0, 8352, '\P{^Is_Blk=_ Super_And_Sub}', "");
    Error('\p{Block= Sutton_signwriting/a/}');
    Error('\P{Block= Sutton_signwriting/a/}');
    Expect(1, 121519, '\p{Block=suttonsignwriting}', "");
    Expect(0, 121519, '\p{^Block=suttonsignwriting}', "");
    Expect(0, 121519, '\P{Block=suttonsignwriting}', "");
    Expect(1, 121519, '\P{^Block=suttonsignwriting}', "");
    Expect(0, 121520, '\p{Block=suttonsignwriting}', "");
    Expect(1, 121520, '\p{^Block=suttonsignwriting}', "");
    Expect(1, 121520, '\P{Block=suttonsignwriting}', "");
    Expect(0, 121520, '\P{^Block=suttonsignwriting}', "");
    Expect(1, 121519, '\p{Block=-	Sutton_SignWriting}', "");
    Expect(0, 121519, '\p{^Block=-	Sutton_SignWriting}', "");
    Expect(0, 121519, '\P{Block=-	Sutton_SignWriting}', "");
    Expect(1, 121519, '\P{^Block=-	Sutton_SignWriting}', "");
    Expect(0, 121520, '\p{Block=-	Sutton_SignWriting}', "");
    Expect(1, 121520, '\p{^Block=-	Sutton_SignWriting}', "");
    Expect(1, 121520, '\P{Block=-	Sutton_SignWriting}', "");
    Expect(0, 121520, '\P{^Block=-	Sutton_SignWriting}', "");
    Error('\p{Blk=-:=Sutton_SignWriting}');
    Error('\P{Blk=-:=Sutton_SignWriting}');
    Expect(1, 121519, '\p{Blk=suttonsignwriting}', "");
    Expect(0, 121519, '\p{^Blk=suttonsignwriting}', "");
    Expect(0, 121519, '\P{Blk=suttonsignwriting}', "");
    Expect(1, 121519, '\P{^Blk=suttonsignwriting}', "");
    Expect(0, 121520, '\p{Blk=suttonsignwriting}', "");
    Expect(1, 121520, '\p{^Blk=suttonsignwriting}', "");
    Expect(1, 121520, '\P{Blk=suttonsignwriting}', "");
    Expect(0, 121520, '\P{^Blk=suttonsignwriting}', "");
    Expect(1, 121519, '\p{Blk= -SUTTON_signwriting}', "");
    Expect(0, 121519, '\p{^Blk= -SUTTON_signwriting}', "");
    Expect(0, 121519, '\P{Blk= -SUTTON_signwriting}', "");
    Expect(1, 121519, '\P{^Blk= -SUTTON_signwriting}', "");
    Expect(0, 121520, '\p{Blk= -SUTTON_signwriting}', "");
    Expect(1, 121520, '\p{^Blk= -SUTTON_signwriting}', "");
    Expect(1, 121520, '\P{Blk= -SUTTON_signwriting}', "");
    Expect(0, 121520, '\P{^Blk= -SUTTON_signwriting}', "");
    Error('\p{Is_Block=:=SUTTON_SignWriting}');
    Error('\P{Is_Block=:=SUTTON_SignWriting}');
    Expect(1, 121519, '\p{Is_Block=suttonsignwriting}', "");
    Expect(0, 121519, '\p{^Is_Block=suttonsignwriting}', "");
    Expect(0, 121519, '\P{Is_Block=suttonsignwriting}', "");
    Expect(1, 121519, '\P{^Is_Block=suttonsignwriting}', "");
    Expect(0, 121520, '\p{Is_Block=suttonsignwriting}', "");
    Expect(1, 121520, '\p{^Is_Block=suttonsignwriting}', "");
    Expect(1, 121520, '\P{Is_Block=suttonsignwriting}', "");
    Expect(0, 121520, '\P{^Is_Block=suttonsignwriting}', "");
    Expect(1, 121519, '\p{Is_Block=_Sutton_SignWriting}', "");
    Expect(0, 121519, '\p{^Is_Block=_Sutton_SignWriting}', "");
    Expect(0, 121519, '\P{Is_Block=_Sutton_SignWriting}', "");
    Expect(1, 121519, '\P{^Is_Block=_Sutton_SignWriting}', "");
    Expect(0, 121520, '\p{Is_Block=_Sutton_SignWriting}', "");
    Expect(1, 121520, '\p{^Is_Block=_Sutton_SignWriting}', "");
    Expect(1, 121520, '\P{Is_Block=_Sutton_SignWriting}', "");
    Expect(0, 121520, '\P{^Is_Block=_Sutton_SignWriting}', "");
    Error('\p{Is_Blk:   :=  SUTTON_SIGNWRITING}');
    Error('\P{Is_Blk:   :=  SUTTON_SIGNWRITING}');
    Expect(1, 121519, '\p{Is_Blk=suttonsignwriting}', "");
    Expect(0, 121519, '\p{^Is_Blk=suttonsignwriting}', "");
    Expect(0, 121519, '\P{Is_Blk=suttonsignwriting}', "");
    Expect(1, 121519, '\P{^Is_Blk=suttonsignwriting}', "");
    Expect(0, 121520, '\p{Is_Blk=suttonsignwriting}', "");
    Expect(1, 121520, '\p{^Is_Blk=suttonsignwriting}', "");
    Expect(1, 121520, '\P{Is_Blk=suttonsignwriting}', "");
    Expect(0, 121520, '\P{^Is_Blk=suttonsignwriting}', "");
    Expect(1, 121519, '\p{Is_Blk: -sutton_SignWriting}', "");
    Expect(0, 121519, '\p{^Is_Blk: -sutton_SignWriting}', "");
    Expect(0, 121519, '\P{Is_Blk: -sutton_SignWriting}', "");
    Expect(1, 121519, '\P{^Is_Blk: -sutton_SignWriting}', "");
    Expect(0, 121520, '\p{Is_Blk: -sutton_SignWriting}', "");
    Expect(1, 121520, '\p{^Is_Blk: -sutton_SignWriting}', "");
    Expect(1, 121520, '\P{Is_Blk: -sutton_SignWriting}', "");
    Expect(0, 121520, '\P{^Is_Blk: -sutton_SignWriting}', "");
    Error('\p{Block::=	Syloti_NAGRI}');
    Error('\P{Block::=	Syloti_NAGRI}');
    Expect(1, 43055, '\p{Block=sylotinagri}', "");
    Expect(0, 43055, '\p{^Block=sylotinagri}', "");
    Expect(0, 43055, '\P{Block=sylotinagri}', "");
    Expect(1, 43055, '\P{^Block=sylotinagri}', "");
    Expect(0, 43056, '\p{Block=sylotinagri}', "");
    Expect(1, 43056, '\p{^Block=sylotinagri}', "");
    Expect(1, 43056, '\P{Block=sylotinagri}', "");
    Expect(0, 43056, '\P{^Block=sylotinagri}', "");
    Expect(1, 43055, '\p{Block=-_Syloti_Nagri}', "");
    Expect(0, 43055, '\p{^Block=-_Syloti_Nagri}', "");
    Expect(0, 43055, '\P{Block=-_Syloti_Nagri}', "");
    Expect(1, 43055, '\P{^Block=-_Syloti_Nagri}', "");
    Expect(0, 43056, '\p{Block=-_Syloti_Nagri}', "");
    Expect(1, 43056, '\p{^Block=-_Syloti_Nagri}', "");
    Expect(1, 43056, '\P{Block=-_Syloti_Nagri}', "");
    Expect(0, 43056, '\P{^Block=-_Syloti_Nagri}', "");
    Error('\p{Blk=	SYLOTI_Nagri/a/}');
    Error('\P{Blk=	SYLOTI_Nagri/a/}');
    Expect(1, 43055, '\p{Blk:	sylotinagri}', "");
    Expect(0, 43055, '\p{^Blk:	sylotinagri}', "");
    Expect(0, 43055, '\P{Blk:	sylotinagri}', "");
    Expect(1, 43055, '\P{^Blk:	sylotinagri}', "");
    Expect(0, 43056, '\p{Blk:	sylotinagri}', "");
    Expect(1, 43056, '\p{^Blk:	sylotinagri}', "");
    Expect(1, 43056, '\P{Blk:	sylotinagri}', "");
    Expect(0, 43056, '\P{^Blk:	sylotinagri}', "");
    Expect(1, 43055, '\p{Blk= -syloti_nagri}', "");
    Expect(0, 43055, '\p{^Blk= -syloti_nagri}', "");
    Expect(0, 43055, '\P{Blk= -syloti_nagri}', "");
    Expect(1, 43055, '\P{^Blk= -syloti_nagri}', "");
    Expect(0, 43056, '\p{Blk= -syloti_nagri}', "");
    Expect(1, 43056, '\p{^Blk= -syloti_nagri}', "");
    Expect(1, 43056, '\P{Blk= -syloti_nagri}', "");
    Expect(0, 43056, '\P{^Blk= -syloti_nagri}', "");
    Error('\p{Is_Block=	_syloti_nagri/a/}');
    Error('\P{Is_Block=	_syloti_nagri/a/}');
    Expect(1, 43055, '\p{Is_Block=sylotinagri}', "");
    Expect(0, 43055, '\p{^Is_Block=sylotinagri}', "");
    Expect(0, 43055, '\P{Is_Block=sylotinagri}', "");
    Expect(1, 43055, '\P{^Is_Block=sylotinagri}', "");
    Expect(0, 43056, '\p{Is_Block=sylotinagri}', "");
    Expect(1, 43056, '\p{^Is_Block=sylotinagri}', "");
    Expect(1, 43056, '\P{Is_Block=sylotinagri}', "");
    Expect(0, 43056, '\P{^Is_Block=sylotinagri}', "");
    Expect(1, 43055, '\p{Is_Block=-_SYLOTI_nagri}', "");
    Expect(0, 43055, '\p{^Is_Block=-_SYLOTI_nagri}', "");
    Expect(0, 43055, '\P{Is_Block=-_SYLOTI_nagri}', "");
    Expect(1, 43055, '\P{^Is_Block=-_SYLOTI_nagri}', "");
    Expect(0, 43056, '\p{Is_Block=-_SYLOTI_nagri}', "");
    Expect(1, 43056, '\p{^Is_Block=-_SYLOTI_nagri}', "");
    Expect(1, 43056, '\P{Is_Block=-_SYLOTI_nagri}', "");
    Expect(0, 43056, '\P{^Is_Block=-_SYLOTI_nagri}', "");
    Error('\p{Is_Blk: /a/syloti_Nagri}');
    Error('\P{Is_Blk: /a/syloti_Nagri}');
    Expect(1, 43055, '\p{Is_Blk:	sylotinagri}', "");
    Expect(0, 43055, '\p{^Is_Blk:	sylotinagri}', "");
    Expect(0, 43055, '\P{Is_Blk:	sylotinagri}', "");
    Expect(1, 43055, '\P{^Is_Blk:	sylotinagri}', "");
    Expect(0, 43056, '\p{Is_Blk:	sylotinagri}', "");
    Expect(1, 43056, '\p{^Is_Blk:	sylotinagri}', "");
    Expect(1, 43056, '\P{Is_Blk:	sylotinagri}', "");
    Expect(0, 43056, '\P{^Is_Blk:	sylotinagri}', "");
    Expect(1, 43055, '\p{Is_Blk=  syloti_NAGRI}', "");
    Expect(0, 43055, '\p{^Is_Blk=  syloti_NAGRI}', "");
    Expect(0, 43055, '\P{Is_Blk=  syloti_NAGRI}', "");
    Expect(1, 43055, '\P{^Is_Blk=  syloti_NAGRI}', "");
    Expect(0, 43056, '\p{Is_Blk=  syloti_NAGRI}', "");
    Expect(1, 43056, '\p{^Is_Blk=  syloti_NAGRI}', "");
    Expect(1, 43056, '\P{Is_Blk=  syloti_NAGRI}', "");
    Expect(0, 43056, '\P{^Is_Blk=  syloti_NAGRI}', "");
    Error('\p{Block= :=Syriac}');
    Error('\P{Block= :=Syriac}');
    Expect(1, 1871, '\p{Block=syriac}', "");
    Expect(0, 1871, '\p{^Block=syriac}', "");
    Expect(0, 1871, '\P{Block=syriac}', "");
    Expect(1, 1871, '\P{^Block=syriac}', "");
    Expect(0, 1872, '\p{Block=syriac}', "");
    Expect(1, 1872, '\p{^Block=syriac}', "");
    Expect(1, 1872, '\P{Block=syriac}', "");
    Expect(0, 1872, '\P{^Block=syriac}', "");
    Expect(1, 1871, '\p{Block=-	SYRIAC}', "");
    Expect(0, 1871, '\p{^Block=-	SYRIAC}', "");
    Expect(0, 1871, '\P{Block=-	SYRIAC}', "");
    Expect(1, 1871, '\P{^Block=-	SYRIAC}', "");
    Expect(0, 1872, '\p{Block=-	SYRIAC}', "");
    Expect(1, 1872, '\p{^Block=-	SYRIAC}', "");
    Expect(1, 1872, '\P{Block=-	SYRIAC}', "");
    Expect(0, 1872, '\P{^Block=-	SYRIAC}', "");
    Error('\p{Blk= :=Syriac}');
    Error('\P{Blk= :=Syriac}');
    Expect(1, 1871, '\p{Blk=syriac}', "");
    Expect(0, 1871, '\p{^Blk=syriac}', "");
    Expect(0, 1871, '\P{Blk=syriac}', "");
    Expect(1, 1871, '\P{^Blk=syriac}', "");
    Expect(0, 1872, '\p{Blk=syriac}', "");
    Expect(1, 1872, '\p{^Blk=syriac}', "");
    Expect(1, 1872, '\P{Blk=syriac}', "");
    Expect(0, 1872, '\P{^Blk=syriac}', "");
    Expect(1, 1871, '\p{Blk=- Syriac}', "");
    Expect(0, 1871, '\p{^Blk=- Syriac}', "");
    Expect(0, 1871, '\P{Blk=- Syriac}', "");
    Expect(1, 1871, '\P{^Blk=- Syriac}', "");
    Expect(0, 1872, '\p{Blk=- Syriac}', "");
    Expect(1, 1872, '\p{^Blk=- Syriac}', "");
    Expect(1, 1872, '\P{Blk=- Syriac}', "");
    Expect(0, 1872, '\P{^Blk=- Syriac}', "");
    Error('\p{Is_Block=	-Syriac/a/}');
    Error('\P{Is_Block=	-Syriac/a/}');
    Expect(1, 1871, '\p{Is_Block=syriac}', "");
    Expect(0, 1871, '\p{^Is_Block=syriac}', "");
    Expect(0, 1871, '\P{Is_Block=syriac}', "");
    Expect(1, 1871, '\P{^Is_Block=syriac}', "");
    Expect(0, 1872, '\p{Is_Block=syriac}', "");
    Expect(1, 1872, '\p{^Is_Block=syriac}', "");
    Expect(1, 1872, '\P{Is_Block=syriac}', "");
    Expect(0, 1872, '\P{^Is_Block=syriac}', "");
    Expect(1, 1871, '\p{Is_Block=- Syriac}', "");
    Expect(0, 1871, '\p{^Is_Block=- Syriac}', "");
    Expect(0, 1871, '\P{Is_Block=- Syriac}', "");
    Expect(1, 1871, '\P{^Is_Block=- Syriac}', "");
    Expect(0, 1872, '\p{Is_Block=- Syriac}', "");
    Expect(1, 1872, '\p{^Is_Block=- Syriac}', "");
    Expect(1, 1872, '\P{Is_Block=- Syriac}', "");
    Expect(0, 1872, '\P{^Is_Block=- Syriac}', "");
    Error('\p{Is_Blk=-/a/syriac}');
    Error('\P{Is_Blk=-/a/syriac}');
    Expect(1, 1871, '\p{Is_Blk=syriac}', "");
    Expect(0, 1871, '\p{^Is_Blk=syriac}', "");
    Expect(0, 1871, '\P{Is_Blk=syriac}', "");
    Expect(1, 1871, '\P{^Is_Blk=syriac}', "");
    Expect(0, 1872, '\p{Is_Blk=syriac}', "");
    Expect(1, 1872, '\p{^Is_Blk=syriac}', "");
    Expect(1, 1872, '\P{Is_Blk=syriac}', "");
    Expect(0, 1872, '\P{^Is_Blk=syriac}', "");
    Expect(1, 1871, '\p{Is_Blk: -_syriac}', "");
    Expect(0, 1871, '\p{^Is_Blk: -_syriac}', "");
    Expect(0, 1871, '\P{Is_Blk: -_syriac}', "");
    Expect(1, 1871, '\P{^Is_Blk: -_syriac}', "");
    Expect(0, 1872, '\p{Is_Blk: -_syriac}', "");
    Expect(1, 1872, '\p{^Is_Blk: -_syriac}', "");
    Expect(1, 1872, '\P{Is_Blk: -_syriac}', "");
    Expect(0, 1872, '\P{^Is_Blk: -_syriac}', "");
    Error('\p{Block=--Syriac_supplement/a/}');
    Error('\P{Block=--Syriac_supplement/a/}');
    Expect(1, 2159, '\p{Block=syriacsupplement}', "");
    Expect(0, 2159, '\p{^Block=syriacsupplement}', "");
    Expect(0, 2159, '\P{Block=syriacsupplement}', "");
    Expect(1, 2159, '\P{^Block=syriacsupplement}', "");
    Expect(0, 2160, '\p{Block=syriacsupplement}', "");
    Expect(1, 2160, '\p{^Block=syriacsupplement}', "");
    Expect(1, 2160, '\P{Block=syriacsupplement}', "");
    Expect(0, 2160, '\P{^Block=syriacsupplement}', "");
    Expect(1, 2159, '\p{Block=	 syriac_Supplement}', "");
    Expect(0, 2159, '\p{^Block=	 syriac_Supplement}', "");
    Expect(0, 2159, '\P{Block=	 syriac_Supplement}', "");
    Expect(1, 2159, '\P{^Block=	 syriac_Supplement}', "");
    Expect(0, 2160, '\p{Block=	 syriac_Supplement}', "");
    Expect(1, 2160, '\p{^Block=	 syriac_Supplement}', "");
    Expect(1, 2160, '\P{Block=	 syriac_Supplement}', "");
    Expect(0, 2160, '\P{^Block=	 syriac_Supplement}', "");
    Error('\p{Blk: syriac_Sup:=}');
    Error('\P{Blk: syriac_Sup:=}');
    Expect(1, 2159, '\p{Blk=syriacsup}', "");
    Expect(0, 2159, '\p{^Blk=syriacsup}', "");
    Expect(0, 2159, '\P{Blk=syriacsup}', "");
    Expect(1, 2159, '\P{^Blk=syriacsup}', "");
    Expect(0, 2160, '\p{Blk=syriacsup}', "");
    Expect(1, 2160, '\p{^Blk=syriacsup}', "");
    Expect(1, 2160, '\P{Blk=syriacsup}', "");
    Expect(0, 2160, '\P{^Blk=syriacsup}', "");
    Expect(1, 2159, '\p{Blk= -syriac_SUP}', "");
    Expect(0, 2159, '\p{^Blk= -syriac_SUP}', "");
    Expect(0, 2159, '\P{Blk= -syriac_SUP}', "");
    Expect(1, 2159, '\P{^Blk= -syriac_SUP}', "");
    Expect(0, 2160, '\p{Blk= -syriac_SUP}', "");
    Expect(1, 2160, '\p{^Blk= -syriac_SUP}', "");
    Expect(1, 2160, '\P{Blk= -syriac_SUP}', "");
    Expect(0, 2160, '\P{^Blk= -syriac_SUP}', "");
    Error('\p{Is_Block=/a/ Syriac_supplement}');
    Error('\P{Is_Block=/a/ Syriac_supplement}');
    Expect(1, 2159, '\p{Is_Block=syriacsupplement}', "");
    Expect(0, 2159, '\p{^Is_Block=syriacsupplement}', "");
    Expect(0, 2159, '\P{Is_Block=syriacsupplement}', "");
    Expect(1, 2159, '\P{^Is_Block=syriacsupplement}', "");
    Expect(0, 2160, '\p{Is_Block=syriacsupplement}', "");
    Expect(1, 2160, '\p{^Is_Block=syriacsupplement}', "");
    Expect(1, 2160, '\P{Is_Block=syriacsupplement}', "");
    Expect(0, 2160, '\P{^Is_Block=syriacsupplement}', "");
    Expect(1, 2159, '\p{Is_Block=__SYRIAC_Supplement}', "");
    Expect(0, 2159, '\p{^Is_Block=__SYRIAC_Supplement}', "");
    Expect(0, 2159, '\P{Is_Block=__SYRIAC_Supplement}', "");
    Expect(1, 2159, '\P{^Is_Block=__SYRIAC_Supplement}', "");
    Expect(0, 2160, '\p{Is_Block=__SYRIAC_Supplement}', "");
    Expect(1, 2160, '\p{^Is_Block=__SYRIAC_Supplement}', "");
    Expect(1, 2160, '\P{Is_Block=__SYRIAC_Supplement}', "");
    Expect(0, 2160, '\P{^Is_Block=__SYRIAC_Supplement}', "");
    Error('\p{Is_Blk=:=Syriac_SUP}');
    Error('\P{Is_Blk=:=Syriac_SUP}');
    Expect(1, 2159, '\p{Is_Blk=syriacsup}', "");
    Expect(0, 2159, '\p{^Is_Blk=syriacsup}', "");
    Expect(0, 2159, '\P{Is_Blk=syriacsup}', "");
    Expect(1, 2159, '\P{^Is_Blk=syriacsup}', "");
    Expect(0, 2160, '\p{Is_Blk=syriacsup}', "");
    Expect(1, 2160, '\p{^Is_Blk=syriacsup}', "");
    Expect(1, 2160, '\P{Is_Blk=syriacsup}', "");
    Expect(0, 2160, '\P{^Is_Blk=syriacsup}', "");
    Expect(1, 2159, '\p{Is_Blk=-	Syriac_Sup}', "");
    Expect(0, 2159, '\p{^Is_Blk=-	Syriac_Sup}', "");
    Expect(0, 2159, '\P{Is_Blk=-	Syriac_Sup}', "");
    Expect(1, 2159, '\P{^Is_Blk=-	Syriac_Sup}', "");
    Expect(0, 2160, '\p{Is_Blk=-	Syriac_Sup}', "");
    Expect(1, 2160, '\p{^Is_Blk=-	Syriac_Sup}', "");
    Expect(1, 2160, '\P{Is_Blk=-	Syriac_Sup}', "");
    Expect(0, 2160, '\P{^Is_Blk=-	Syriac_Sup}', "");
    Error('\p{Block=/a/	TAGALOG}');
    Error('\P{Block=/a/	TAGALOG}');
    Expect(1, 5919, '\p{Block=tagalog}', "");
    Expect(0, 5919, '\p{^Block=tagalog}', "");
    Expect(0, 5919, '\P{Block=tagalog}', "");
    Expect(1, 5919, '\P{^Block=tagalog}', "");
    Expect(0, 5920, '\p{Block=tagalog}', "");
    Expect(1, 5920, '\p{^Block=tagalog}', "");
    Expect(1, 5920, '\P{Block=tagalog}', "");
    Expect(0, 5920, '\P{^Block=tagalog}', "");
    Expect(1, 5919, '\p{Block=--TAGALOG}', "");
    Expect(0, 5919, '\p{^Block=--TAGALOG}', "");
    Expect(0, 5919, '\P{Block=--TAGALOG}', "");
    Expect(1, 5919, '\P{^Block=--TAGALOG}', "");
    Expect(0, 5920, '\p{Block=--TAGALOG}', "");
    Expect(1, 5920, '\p{^Block=--TAGALOG}', "");
    Expect(1, 5920, '\P{Block=--TAGALOG}', "");
    Expect(0, 5920, '\P{^Block=--TAGALOG}', "");
    Error('\p{Blk=-_Tagalog:=}');
    Error('\P{Blk=-_Tagalog:=}');
    Expect(1, 5919, '\p{Blk=tagalog}', "");
    Expect(0, 5919, '\p{^Blk=tagalog}', "");
    Expect(0, 5919, '\P{Blk=tagalog}', "");
    Expect(1, 5919, '\P{^Blk=tagalog}', "");
    Expect(0, 5920, '\p{Blk=tagalog}', "");
    Expect(1, 5920, '\p{^Blk=tagalog}', "");
    Expect(1, 5920, '\P{Blk=tagalog}', "");
    Expect(0, 5920, '\P{^Blk=tagalog}', "");
    Expect(1, 5919, '\p{Blk:	 tagalog}', "");
    Expect(0, 5919, '\p{^Blk:	 tagalog}', "");
    Expect(0, 5919, '\P{Blk:	 tagalog}', "");
    Expect(1, 5919, '\P{^Blk:	 tagalog}', "");
    Expect(0, 5920, '\p{Blk:	 tagalog}', "");
    Expect(1, 5920, '\p{^Blk:	 tagalog}', "");
    Expect(1, 5920, '\P{Blk:	 tagalog}', "");
    Expect(0, 5920, '\P{^Blk:	 tagalog}', "");
    Error('\p{Is_Block=_:=Tagalog}');
    Error('\P{Is_Block=_:=Tagalog}');
    Expect(1, 5919, '\p{Is_Block=tagalog}', "");
    Expect(0, 5919, '\p{^Is_Block=tagalog}', "");
    Expect(0, 5919, '\P{Is_Block=tagalog}', "");
    Expect(1, 5919, '\P{^Is_Block=tagalog}', "");
    Expect(0, 5920, '\p{Is_Block=tagalog}', "");
    Expect(1, 5920, '\p{^Is_Block=tagalog}', "");
    Expect(1, 5920, '\P{Is_Block=tagalog}', "");
    Expect(0, 5920, '\P{^Is_Block=tagalog}', "");
    Expect(1, 5919, '\p{Is_Block= Tagalog}', "");
    Expect(0, 5919, '\p{^Is_Block= Tagalog}', "");
    Expect(0, 5919, '\P{Is_Block= Tagalog}', "");
    Expect(1, 5919, '\P{^Is_Block= Tagalog}', "");
    Expect(0, 5920, '\p{Is_Block= Tagalog}', "");
    Expect(1, 5920, '\p{^Is_Block= Tagalog}', "");
    Expect(1, 5920, '\P{Is_Block= Tagalog}', "");
    Expect(0, 5920, '\P{^Is_Block= Tagalog}', "");
    Error('\p{Is_Blk=:= _Tagalog}');
    Error('\P{Is_Blk=:= _Tagalog}');
    Expect(1, 5919, '\p{Is_Blk=tagalog}', "");
    Expect(0, 5919, '\p{^Is_Blk=tagalog}', "");
    Expect(0, 5919, '\P{Is_Blk=tagalog}', "");
    Expect(1, 5919, '\P{^Is_Blk=tagalog}', "");
    Expect(0, 5920, '\p{Is_Blk=tagalog}', "");
    Expect(1, 5920, '\p{^Is_Blk=tagalog}', "");
    Expect(1, 5920, '\P{Is_Blk=tagalog}', "");
    Expect(0, 5920, '\P{^Is_Blk=tagalog}', "");
    Expect(1, 5919, '\p{Is_Blk:-	Tagalog}', "");
    Expect(0, 5919, '\p{^Is_Blk:-	Tagalog}', "");
    Expect(0, 5919, '\P{Is_Blk:-	Tagalog}', "");
    Expect(1, 5919, '\P{^Is_Blk:-	Tagalog}', "");
    Expect(0, 5920, '\p{Is_Blk:-	Tagalog}', "");
    Expect(1, 5920, '\p{^Is_Blk:-	Tagalog}', "");
    Expect(1, 5920, '\P{Is_Blk:-	Tagalog}', "");
    Expect(0, 5920, '\P{^Is_Blk:-	Tagalog}', "");
    Error('\p{Block=_ Tagbanwa/a/}');
    Error('\P{Block=_ Tagbanwa/a/}');
    Expect(1, 6015, '\p{Block=tagbanwa}', "");
    Expect(0, 6015, '\p{^Block=tagbanwa}', "");
    Expect(0, 6015, '\P{Block=tagbanwa}', "");
    Expect(1, 6015, '\P{^Block=tagbanwa}', "");
    Expect(0, 6016, '\p{Block=tagbanwa}', "");
    Expect(1, 6016, '\p{^Block=tagbanwa}', "");
    Expect(1, 6016, '\P{Block=tagbanwa}', "");
    Expect(0, 6016, '\P{^Block=tagbanwa}', "");
    Expect(1, 6015, '\p{Block= -Tagbanwa}', "");
    Expect(0, 6015, '\p{^Block= -Tagbanwa}', "");
    Expect(0, 6015, '\P{Block= -Tagbanwa}', "");
    Expect(1, 6015, '\P{^Block= -Tagbanwa}', "");
    Expect(0, 6016, '\p{Block= -Tagbanwa}', "");
    Expect(1, 6016, '\p{^Block= -Tagbanwa}', "");
    Expect(1, 6016, '\P{Block= -Tagbanwa}', "");
    Expect(0, 6016, '\P{^Block= -Tagbanwa}', "");
    Error('\p{Blk=/a/	-tagbanwa}');
    Error('\P{Blk=/a/	-tagbanwa}');
    Expect(1, 6015, '\p{Blk=tagbanwa}', "");
    Expect(0, 6015, '\p{^Blk=tagbanwa}', "");
    Expect(0, 6015, '\P{Blk=tagbanwa}', "");
    Expect(1, 6015, '\P{^Blk=tagbanwa}', "");
    Expect(0, 6016, '\p{Blk=tagbanwa}', "");
    Expect(1, 6016, '\p{^Blk=tagbanwa}', "");
    Expect(1, 6016, '\P{Blk=tagbanwa}', "");
    Expect(0, 6016, '\P{^Blk=tagbanwa}', "");
    Expect(1, 6015, '\p{Blk= TAGBANWA}', "");
    Expect(0, 6015, '\p{^Blk= TAGBANWA}', "");
    Expect(0, 6015, '\P{Blk= TAGBANWA}', "");
    Expect(1, 6015, '\P{^Blk= TAGBANWA}', "");
    Expect(0, 6016, '\p{Blk= TAGBANWA}', "");
    Expect(1, 6016, '\p{^Blk= TAGBANWA}', "");
    Expect(1, 6016, '\P{Blk= TAGBANWA}', "");
    Expect(0, 6016, '\P{^Blk= TAGBANWA}', "");
    Error('\p{Is_Block=	-TAGBANWA/a/}');
    Error('\P{Is_Block=	-TAGBANWA/a/}');
    Expect(1, 6015, '\p{Is_Block=tagbanwa}', "");
    Expect(0, 6015, '\p{^Is_Block=tagbanwa}', "");
    Expect(0, 6015, '\P{Is_Block=tagbanwa}', "");
    Expect(1, 6015, '\P{^Is_Block=tagbanwa}', "");
    Expect(0, 6016, '\p{Is_Block=tagbanwa}', "");
    Expect(1, 6016, '\p{^Is_Block=tagbanwa}', "");
    Expect(1, 6016, '\P{Is_Block=tagbanwa}', "");
    Expect(0, 6016, '\P{^Is_Block=tagbanwa}', "");
    Expect(1, 6015, '\p{Is_Block=_Tagbanwa}', "");
    Expect(0, 6015, '\p{^Is_Block=_Tagbanwa}', "");
    Expect(0, 6015, '\P{Is_Block=_Tagbanwa}', "");
    Expect(1, 6015, '\P{^Is_Block=_Tagbanwa}', "");
    Expect(0, 6016, '\p{Is_Block=_Tagbanwa}', "");
    Expect(1, 6016, '\p{^Is_Block=_Tagbanwa}', "");
    Expect(1, 6016, '\P{Is_Block=_Tagbanwa}', "");
    Expect(0, 6016, '\P{^Is_Block=_Tagbanwa}', "");
    Error('\p{Is_Blk=:=	Tagbanwa}');
    Error('\P{Is_Blk=:=	Tagbanwa}');
    Expect(1, 6015, '\p{Is_Blk=tagbanwa}', "");
    Expect(0, 6015, '\p{^Is_Blk=tagbanwa}', "");
    Expect(0, 6015, '\P{Is_Blk=tagbanwa}', "");
    Expect(1, 6015, '\P{^Is_Blk=tagbanwa}', "");
    Expect(0, 6016, '\p{Is_Blk=tagbanwa}', "");
    Expect(1, 6016, '\p{^Is_Blk=tagbanwa}', "");
    Expect(1, 6016, '\P{Is_Blk=tagbanwa}', "");
    Expect(0, 6016, '\P{^Is_Blk=tagbanwa}', "");
    Expect(1, 6015, '\p{Is_Blk:		_Tagbanwa}', "");
    Expect(0, 6015, '\p{^Is_Blk:		_Tagbanwa}', "");
    Expect(0, 6015, '\P{Is_Blk:		_Tagbanwa}', "");
    Expect(1, 6015, '\P{^Is_Blk:		_Tagbanwa}', "");
    Expect(0, 6016, '\p{Is_Blk:		_Tagbanwa}', "");
    Expect(1, 6016, '\p{^Is_Blk:		_Tagbanwa}', "");
    Expect(1, 6016, '\P{Is_Blk:		_Tagbanwa}', "");
    Expect(0, 6016, '\P{^Is_Blk:		_Tagbanwa}', "");
    Error('\p{Block=/a/_ Tags}');
    Error('\P{Block=/a/_ Tags}');
    Expect(1, 917631, '\p{Block=tags}', "");
    Expect(0, 917631, '\p{^Block=tags}', "");
    Expect(0, 917631, '\P{Block=tags}', "");
    Expect(1, 917631, '\P{^Block=tags}', "");
    Expect(0, 917632, '\p{Block=tags}', "");
    Expect(1, 917632, '\p{^Block=tags}', "");
    Expect(1, 917632, '\P{Block=tags}', "");
    Expect(0, 917632, '\P{^Block=tags}', "");
    Expect(1, 917631, '\p{Block= _Tags}', "");
    Expect(0, 917631, '\p{^Block= _Tags}', "");
    Expect(0, 917631, '\P{Block= _Tags}', "");
    Expect(1, 917631, '\P{^Block= _Tags}', "");
    Expect(0, 917632, '\p{Block= _Tags}', "");
    Expect(1, 917632, '\p{^Block= _Tags}', "");
    Expect(1, 917632, '\P{Block= _Tags}', "");
    Expect(0, 917632, '\P{^Block= _Tags}', "");
    Error('\p{Blk=_Tags:=}');
    Error('\P{Blk=_Tags:=}');
    Expect(1, 917631, '\p{Blk=tags}', "");
    Expect(0, 917631, '\p{^Blk=tags}', "");
    Expect(0, 917631, '\P{Blk=tags}', "");
    Expect(1, 917631, '\P{^Blk=tags}', "");
    Expect(0, 917632, '\p{Blk=tags}', "");
    Expect(1, 917632, '\p{^Blk=tags}', "");
    Expect(1, 917632, '\P{Blk=tags}', "");
    Expect(0, 917632, '\P{^Blk=tags}', "");
    Expect(1, 917631, '\p{Blk=	tags}', "");
    Expect(0, 917631, '\p{^Blk=	tags}', "");
    Expect(0, 917631, '\P{Blk=	tags}', "");
    Expect(1, 917631, '\P{^Blk=	tags}', "");
    Expect(0, 917632, '\p{Blk=	tags}', "");
    Expect(1, 917632, '\p{^Blk=	tags}', "");
    Expect(1, 917632, '\P{Blk=	tags}', "");
    Expect(0, 917632, '\P{^Blk=	tags}', "");
    Error('\p{Is_Block=:=--Tags}');
    Error('\P{Is_Block=:=--Tags}');
    Expect(1, 917631, '\p{Is_Block=tags}', "");
    Expect(0, 917631, '\p{^Is_Block=tags}', "");
    Expect(0, 917631, '\P{Is_Block=tags}', "");
    Expect(1, 917631, '\P{^Is_Block=tags}', "");
    Expect(0, 917632, '\p{Is_Block=tags}', "");
    Expect(1, 917632, '\p{^Is_Block=tags}', "");
    Expect(1, 917632, '\P{Is_Block=tags}', "");
    Expect(0, 917632, '\P{^Is_Block=tags}', "");
    Expect(1, 917631, '\p{Is_Block=	tags}', "");
    Expect(0, 917631, '\p{^Is_Block=	tags}', "");
    Expect(0, 917631, '\P{Is_Block=	tags}', "");
    Expect(1, 917631, '\P{^Is_Block=	tags}', "");
    Expect(0, 917632, '\p{Is_Block=	tags}', "");
    Expect(1, 917632, '\p{^Is_Block=	tags}', "");
    Expect(1, 917632, '\P{Is_Block=	tags}', "");
    Expect(0, 917632, '\P{^Is_Block=	tags}', "");
    Error('\p{Is_Blk=:=  tags}');
    Error('\P{Is_Blk=:=  tags}');
    Expect(1, 917631, '\p{Is_Blk=tags}', "");
    Expect(0, 917631, '\p{^Is_Blk=tags}', "");
    Expect(0, 917631, '\P{Is_Blk=tags}', "");
    Expect(1, 917631, '\P{^Is_Blk=tags}', "");
    Expect(0, 917632, '\p{Is_Blk=tags}', "");
    Expect(1, 917632, '\p{^Is_Blk=tags}', "");
    Expect(1, 917632, '\P{Is_Blk=tags}', "");
    Expect(0, 917632, '\P{^Is_Blk=tags}', "");
    Expect(1, 917631, '\p{Is_Blk=-	tags}', "");
    Expect(0, 917631, '\p{^Is_Blk=-	tags}', "");
    Expect(0, 917631, '\P{Is_Blk=-	tags}', "");
    Expect(1, 917631, '\P{^Is_Blk=-	tags}', "");
    Expect(0, 917632, '\p{Is_Blk=-	tags}', "");
    Expect(1, 917632, '\p{^Is_Blk=-	tags}', "");
    Expect(1, 917632, '\P{Is_Blk=-	tags}', "");
    Expect(0, 917632, '\P{^Is_Blk=-	tags}', "");
    Error('\p{Block=:= _Tai_LE}');
    Error('\P{Block=:= _Tai_LE}');
    Expect(1, 6527, '\p{Block=taile}', "");
    Expect(0, 6527, '\p{^Block=taile}', "");
    Expect(0, 6527, '\P{Block=taile}', "");
    Expect(1, 6527, '\P{^Block=taile}', "");
    Expect(0, 6528, '\p{Block=taile}', "");
    Expect(1, 6528, '\p{^Block=taile}', "");
    Expect(1, 6528, '\P{Block=taile}', "");
    Expect(0, 6528, '\P{^Block=taile}', "");
    Expect(1, 6527, '\p{Block=_	Tai_LE}', "");
    Expect(0, 6527, '\p{^Block=_	Tai_LE}', "");
    Expect(0, 6527, '\P{Block=_	Tai_LE}', "");
    Expect(1, 6527, '\P{^Block=_	Tai_LE}', "");
    Expect(0, 6528, '\p{Block=_	Tai_LE}', "");
    Expect(1, 6528, '\p{^Block=_	Tai_LE}', "");
    Expect(1, 6528, '\P{Block=_	Tai_LE}', "");
    Expect(0, 6528, '\P{^Block=_	Tai_LE}', "");
    Error('\p{Blk=-/a/Tai_LE}');
    Error('\P{Blk=-/a/Tai_LE}');
    Expect(1, 6527, '\p{Blk=taile}', "");
    Expect(0, 6527, '\p{^Blk=taile}', "");
    Expect(0, 6527, '\P{Blk=taile}', "");
    Expect(1, 6527, '\P{^Blk=taile}', "");
    Expect(0, 6528, '\p{Blk=taile}', "");
    Expect(1, 6528, '\p{^Blk=taile}', "");
    Expect(1, 6528, '\P{Blk=taile}', "");
    Expect(0, 6528, '\P{^Blk=taile}', "");
    Expect(1, 6527, '\p{Blk=_	TAI_LE}', "");
    Expect(0, 6527, '\p{^Blk=_	TAI_LE}', "");
    Expect(0, 6527, '\P{Blk=_	TAI_LE}', "");
    Expect(1, 6527, '\P{^Blk=_	TAI_LE}', "");
    Expect(0, 6528, '\p{Blk=_	TAI_LE}', "");
    Expect(1, 6528, '\p{^Blk=_	TAI_LE}', "");
    Expect(1, 6528, '\P{Blk=_	TAI_LE}', "");
    Expect(0, 6528, '\P{^Blk=_	TAI_LE}', "");
    Error('\p{Is_Block: -/a/TAI_LE}');
    Error('\P{Is_Block: -/a/TAI_LE}');
    Expect(1, 6527, '\p{Is_Block: taile}', "");
    Expect(0, 6527, '\p{^Is_Block: taile}', "");
    Expect(0, 6527, '\P{Is_Block: taile}', "");
    Expect(1, 6527, '\P{^Is_Block: taile}', "");
    Expect(0, 6528, '\p{Is_Block: taile}', "");
    Expect(1, 6528, '\p{^Is_Block: taile}', "");
    Expect(1, 6528, '\P{Is_Block: taile}', "");
    Expect(0, 6528, '\P{^Is_Block: taile}', "");
    Expect(1, 6527, '\p{Is_Block=-tai_Le}', "");
    Expect(0, 6527, '\p{^Is_Block=-tai_Le}', "");
    Expect(0, 6527, '\P{Is_Block=-tai_Le}', "");
    Expect(1, 6527, '\P{^Is_Block=-tai_Le}', "");
    Expect(0, 6528, '\p{Is_Block=-tai_Le}', "");
    Expect(1, 6528, '\p{^Is_Block=-tai_Le}', "");
    Expect(1, 6528, '\P{Is_Block=-tai_Le}', "");
    Expect(0, 6528, '\P{^Is_Block=-tai_Le}', "");
    Error('\p{Is_Blk=		TAI_le:=}');
    Error('\P{Is_Blk=		TAI_le:=}');
    Expect(1, 6527, '\p{Is_Blk=taile}', "");
    Expect(0, 6527, '\p{^Is_Blk=taile}', "");
    Expect(0, 6527, '\P{Is_Blk=taile}', "");
    Expect(1, 6527, '\P{^Is_Blk=taile}', "");
    Expect(0, 6528, '\p{Is_Blk=taile}', "");
    Expect(1, 6528, '\p{^Is_Blk=taile}', "");
    Expect(1, 6528, '\P{Is_Blk=taile}', "");
    Expect(0, 6528, '\P{^Is_Blk=taile}', "");
    Expect(1, 6527, '\p{Is_Blk= -TAI_LE}', "");
    Expect(0, 6527, '\p{^Is_Blk= -TAI_LE}', "");
    Expect(0, 6527, '\P{Is_Blk= -TAI_LE}', "");
    Expect(1, 6527, '\P{^Is_Blk= -TAI_LE}', "");
    Expect(0, 6528, '\p{Is_Blk= -TAI_LE}', "");
    Expect(1, 6528, '\p{^Is_Blk= -TAI_LE}', "");
    Expect(1, 6528, '\P{Is_Blk= -TAI_LE}', "");
    Expect(0, 6528, '\P{^Is_Blk= -TAI_LE}', "");
    Error('\p{Block=_/a/Tai_Tham}');
    Error('\P{Block=_/a/Tai_Tham}');
    Expect(1, 6831, '\p{Block=taitham}', "");
    Expect(0, 6831, '\p{^Block=taitham}', "");
    Expect(0, 6831, '\P{Block=taitham}', "");
    Expect(1, 6831, '\P{^Block=taitham}', "");
    Expect(0, 6832, '\p{Block=taitham}', "");
    Expect(1, 6832, '\p{^Block=taitham}', "");
    Expect(1, 6832, '\P{Block=taitham}', "");
    Expect(0, 6832, '\P{^Block=taitham}', "");
    Expect(1, 6831, '\p{Block=	-TAI_Tham}', "");
    Expect(0, 6831, '\p{^Block=	-TAI_Tham}', "");
    Expect(0, 6831, '\P{Block=	-TAI_Tham}', "");
    Expect(1, 6831, '\P{^Block=	-TAI_Tham}', "");
    Expect(0, 6832, '\p{Block=	-TAI_Tham}', "");
    Expect(1, 6832, '\p{^Block=	-TAI_Tham}', "");
    Expect(1, 6832, '\P{Block=	-TAI_Tham}', "");
    Expect(0, 6832, '\P{^Block=	-TAI_Tham}', "");
    Error('\p{Blk= :=Tai_Tham}');
    Error('\P{Blk= :=Tai_Tham}');
    Expect(1, 6831, '\p{Blk=taitham}', "");
    Expect(0, 6831, '\p{^Blk=taitham}', "");
    Expect(0, 6831, '\P{Blk=taitham}', "");
    Expect(1, 6831, '\P{^Blk=taitham}', "");
    Expect(0, 6832, '\p{Blk=taitham}', "");
    Expect(1, 6832, '\p{^Blk=taitham}', "");
    Expect(1, 6832, '\P{Blk=taitham}', "");
    Expect(0, 6832, '\P{^Blk=taitham}', "");
    Expect(1, 6831, '\p{Blk=-TAI_THAM}', "");
    Expect(0, 6831, '\p{^Blk=-TAI_THAM}', "");
    Expect(0, 6831, '\P{Blk=-TAI_THAM}', "");
    Expect(1, 6831, '\P{^Blk=-TAI_THAM}', "");
    Expect(0, 6832, '\p{Blk=-TAI_THAM}', "");
    Expect(1, 6832, '\p{^Blk=-TAI_THAM}', "");
    Expect(1, 6832, '\P{Blk=-TAI_THAM}', "");
    Expect(0, 6832, '\P{^Blk=-TAI_THAM}', "");
    Error('\p{Is_Block=:=-Tai_THAM}');
    Error('\P{Is_Block=:=-Tai_THAM}');
    Expect(1, 6831, '\p{Is_Block=taitham}', "");
    Expect(0, 6831, '\p{^Is_Block=taitham}', "");
    Expect(0, 6831, '\P{Is_Block=taitham}', "");
    Expect(1, 6831, '\P{^Is_Block=taitham}', "");
    Expect(0, 6832, '\p{Is_Block=taitham}', "");
    Expect(1, 6832, '\p{^Is_Block=taitham}', "");
    Expect(1, 6832, '\P{Is_Block=taitham}', "");
    Expect(0, 6832, '\P{^Is_Block=taitham}', "");
    Expect(1, 6831, '\p{Is_Block= tai_tham}', "");
    Expect(0, 6831, '\p{^Is_Block= tai_tham}', "");
    Expect(0, 6831, '\P{Is_Block= tai_tham}', "");
    Expect(1, 6831, '\P{^Is_Block= tai_tham}', "");
    Expect(0, 6832, '\p{Is_Block= tai_tham}', "");
    Expect(1, 6832, '\p{^Is_Block= tai_tham}', "");
    Expect(1, 6832, '\P{Is_Block= tai_tham}', "");
    Expect(0, 6832, '\P{^Is_Block= tai_tham}', "");
    Error('\p{Is_Blk=-/a/TAI_THAM}');
    Error('\P{Is_Blk=-/a/TAI_THAM}');
    Expect(1, 6831, '\p{Is_Blk=taitham}', "");
    Expect(0, 6831, '\p{^Is_Blk=taitham}', "");
    Expect(0, 6831, '\P{Is_Blk=taitham}', "");
    Expect(1, 6831, '\P{^Is_Blk=taitham}', "");
    Expect(0, 6832, '\p{Is_Blk=taitham}', "");
    Expect(1, 6832, '\p{^Is_Blk=taitham}', "");
    Expect(1, 6832, '\P{Is_Blk=taitham}', "");
    Expect(0, 6832, '\P{^Is_Blk=taitham}', "");
    Expect(1, 6831, '\p{Is_Blk=_-Tai_THAM}', "");
    Expect(0, 6831, '\p{^Is_Blk=_-Tai_THAM}', "");
    Expect(0, 6831, '\P{Is_Blk=_-Tai_THAM}', "");
    Expect(1, 6831, '\P{^Is_Blk=_-Tai_THAM}', "");
    Expect(0, 6832, '\p{Is_Blk=_-Tai_THAM}', "");
    Expect(1, 6832, '\p{^Is_Blk=_-Tai_THAM}', "");
    Expect(1, 6832, '\P{Is_Blk=_-Tai_THAM}', "");
    Expect(0, 6832, '\P{^Is_Blk=_-Tai_THAM}', "");
    Error('\p{Block=Tai_Viet:=}');
    Error('\P{Block=Tai_Viet:=}');
    Expect(1, 43743, '\p{Block=taiviet}', "");
    Expect(0, 43743, '\p{^Block=taiviet}', "");
    Expect(0, 43743, '\P{Block=taiviet}', "");
    Expect(1, 43743, '\P{^Block=taiviet}', "");
    Expect(0, 43744, '\p{Block=taiviet}', "");
    Expect(1, 43744, '\p{^Block=taiviet}', "");
    Expect(1, 43744, '\P{Block=taiviet}', "");
    Expect(0, 43744, '\P{^Block=taiviet}', "");
    Expect(1, 43743, '\p{Block=_TAI_VIET}', "");
    Expect(0, 43743, '\p{^Block=_TAI_VIET}', "");
    Expect(0, 43743, '\P{Block=_TAI_VIET}', "");
    Expect(1, 43743, '\P{^Block=_TAI_VIET}', "");
    Expect(0, 43744, '\p{Block=_TAI_VIET}', "");
    Expect(1, 43744, '\p{^Block=_TAI_VIET}', "");
    Expect(1, 43744, '\P{Block=_TAI_VIET}', "");
    Expect(0, 43744, '\P{^Block=_TAI_VIET}', "");
    Error('\p{Blk=:=--tai_viet}');
    Error('\P{Blk=:=--tai_viet}');
    Expect(1, 43743, '\p{Blk: taiviet}', "");
    Expect(0, 43743, '\p{^Blk: taiviet}', "");
    Expect(0, 43743, '\P{Blk: taiviet}', "");
    Expect(1, 43743, '\P{^Blk: taiviet}', "");
    Expect(0, 43744, '\p{Blk: taiviet}', "");
    Expect(1, 43744, '\p{^Blk: taiviet}', "");
    Expect(1, 43744, '\P{Blk: taiviet}', "");
    Expect(0, 43744, '\P{^Blk: taiviet}', "");
    Expect(1, 43743, '\p{Blk= _Tai_viet}', "");
    Expect(0, 43743, '\p{^Blk= _Tai_viet}', "");
    Expect(0, 43743, '\P{Blk= _Tai_viet}', "");
    Expect(1, 43743, '\P{^Blk= _Tai_viet}', "");
    Expect(0, 43744, '\p{Blk= _Tai_viet}', "");
    Expect(1, 43744, '\p{^Blk= _Tai_viet}', "");
    Expect(1, 43744, '\P{Blk= _Tai_viet}', "");
    Expect(0, 43744, '\P{^Blk= _Tai_viet}', "");
    Error('\p{Is_Block:-:=TAI_VIET}');
    Error('\P{Is_Block:-:=TAI_VIET}');
    Expect(1, 43743, '\p{Is_Block: taiviet}', "");
    Expect(0, 43743, '\p{^Is_Block: taiviet}', "");
    Expect(0, 43743, '\P{Is_Block: taiviet}', "");
    Expect(1, 43743, '\P{^Is_Block: taiviet}', "");
    Expect(0, 43744, '\p{Is_Block: taiviet}', "");
    Expect(1, 43744, '\p{^Is_Block: taiviet}', "");
    Expect(1, 43744, '\P{Is_Block: taiviet}', "");
    Expect(0, 43744, '\P{^Is_Block: taiviet}', "");
    Expect(1, 43743, '\p{Is_Block=-Tai_Viet}', "");
    Expect(0, 43743, '\p{^Is_Block=-Tai_Viet}', "");
    Expect(0, 43743, '\P{Is_Block=-Tai_Viet}', "");
    Expect(1, 43743, '\P{^Is_Block=-Tai_Viet}', "");
    Expect(0, 43744, '\p{Is_Block=-Tai_Viet}', "");
    Expect(1, 43744, '\p{^Is_Block=-Tai_Viet}', "");
    Expect(1, 43744, '\P{Is_Block=-Tai_Viet}', "");
    Expect(0, 43744, '\P{^Is_Block=-Tai_Viet}', "");
    Error('\p{Is_Blk= /a/tai_VIET}');
    Error('\P{Is_Blk= /a/tai_VIET}');
    Expect(1, 43743, '\p{Is_Blk=taiviet}', "");
    Expect(0, 43743, '\p{^Is_Blk=taiviet}', "");
    Expect(0, 43743, '\P{Is_Blk=taiviet}', "");
    Expect(1, 43743, '\P{^Is_Blk=taiviet}', "");
    Expect(0, 43744, '\p{Is_Blk=taiviet}', "");
    Expect(1, 43744, '\p{^Is_Blk=taiviet}', "");
    Expect(1, 43744, '\P{Is_Blk=taiviet}', "");
    Expect(0, 43744, '\P{^Is_Blk=taiviet}', "");
    Expect(1, 43743, '\p{Is_Blk=_	TAI_Viet}', "");
    Expect(0, 43743, '\p{^Is_Blk=_	TAI_Viet}', "");
    Expect(0, 43743, '\P{Is_Blk=_	TAI_Viet}', "");
    Expect(1, 43743, '\P{^Is_Blk=_	TAI_Viet}', "");
    Expect(0, 43744, '\p{Is_Blk=_	TAI_Viet}', "");
    Expect(1, 43744, '\p{^Is_Blk=_	TAI_Viet}', "");
    Expect(1, 43744, '\P{Is_Blk=_	TAI_Viet}', "");
    Expect(0, 43744, '\P{^Is_Blk=_	TAI_Viet}', "");
    Error('\p{Block=:=	-Tai_xuan_Jing_SYMBOLS}');
    Error('\P{Block=:=	-Tai_xuan_Jing_SYMBOLS}');
    Expect(1, 119647, '\p{Block:taixuanjingsymbols}', "");
    Expect(0, 119647, '\p{^Block:taixuanjingsymbols}', "");
    Expect(0, 119647, '\P{Block:taixuanjingsymbols}', "");
    Expect(1, 119647, '\P{^Block:taixuanjingsymbols}', "");
    Expect(0, 119648, '\p{Block:taixuanjingsymbols}', "");
    Expect(1, 119648, '\p{^Block:taixuanjingsymbols}', "");
    Expect(1, 119648, '\P{Block:taixuanjingsymbols}', "");
    Expect(0, 119648, '\P{^Block:taixuanjingsymbols}', "");
    Expect(1, 119647, '\p{Block=--tai_XUAN_Jing_Symbols}', "");
    Expect(0, 119647, '\p{^Block=--tai_XUAN_Jing_Symbols}', "");
    Expect(0, 119647, '\P{Block=--tai_XUAN_Jing_Symbols}', "");
    Expect(1, 119647, '\P{^Block=--tai_XUAN_Jing_Symbols}', "");
    Expect(0, 119648, '\p{Block=--tai_XUAN_Jing_Symbols}', "");
    Expect(1, 119648, '\p{^Block=--tai_XUAN_Jing_Symbols}', "");
    Expect(1, 119648, '\P{Block=--tai_XUAN_Jing_Symbols}', "");
    Expect(0, 119648, '\P{^Block=--tai_XUAN_Jing_Symbols}', "");
    Error('\p{Blk=:=	 TAI_xuan_Jing}');
    Error('\P{Blk=:=	 TAI_xuan_Jing}');
    Expect(1, 119647, '\p{Blk=taixuanjing}', "");
    Expect(0, 119647, '\p{^Blk=taixuanjing}', "");
    Expect(0, 119647, '\P{Blk=taixuanjing}', "");
    Expect(1, 119647, '\P{^Blk=taixuanjing}', "");
    Expect(0, 119648, '\p{Blk=taixuanjing}', "");
    Expect(1, 119648, '\p{^Blk=taixuanjing}', "");
    Expect(1, 119648, '\P{Blk=taixuanjing}', "");
    Expect(0, 119648, '\P{^Blk=taixuanjing}', "");
    Expect(1, 119647, '\p{Blk=-Tai_Xuan_JING}', "");
    Expect(0, 119647, '\p{^Blk=-Tai_Xuan_JING}', "");
    Expect(0, 119647, '\P{Blk=-Tai_Xuan_JING}', "");
    Expect(1, 119647, '\P{^Blk=-Tai_Xuan_JING}', "");
    Expect(0, 119648, '\p{Blk=-Tai_Xuan_JING}', "");
    Expect(1, 119648, '\p{^Blk=-Tai_Xuan_JING}', "");
    Expect(1, 119648, '\P{Blk=-Tai_Xuan_JING}', "");
    Expect(0, 119648, '\P{^Blk=-Tai_Xuan_JING}', "");
    Error('\p{Is_Block=-:=Tai_xuan_jing_symbols}');
    Error('\P{Is_Block=-:=Tai_xuan_jing_symbols}');
    Expect(1, 119647, '\p{Is_Block=taixuanjingsymbols}', "");
    Expect(0, 119647, '\p{^Is_Block=taixuanjingsymbols}', "");
    Expect(0, 119647, '\P{Is_Block=taixuanjingsymbols}', "");
    Expect(1, 119647, '\P{^Is_Block=taixuanjingsymbols}', "");
    Expect(0, 119648, '\p{Is_Block=taixuanjingsymbols}', "");
    Expect(1, 119648, '\p{^Is_Block=taixuanjingsymbols}', "");
    Expect(1, 119648, '\P{Is_Block=taixuanjingsymbols}', "");
    Expect(0, 119648, '\P{^Is_Block=taixuanjingsymbols}', "");
    Expect(1, 119647, '\p{Is_Block= -tai_xuan_Jing_Symbols}', "");
    Expect(0, 119647, '\p{^Is_Block= -tai_xuan_Jing_Symbols}', "");
    Expect(0, 119647, '\P{Is_Block= -tai_xuan_Jing_Symbols}', "");
    Expect(1, 119647, '\P{^Is_Block= -tai_xuan_Jing_Symbols}', "");
    Expect(0, 119648, '\p{Is_Block= -tai_xuan_Jing_Symbols}', "");
    Expect(1, 119648, '\p{^Is_Block= -tai_xuan_Jing_Symbols}', "");
    Expect(1, 119648, '\P{Is_Block= -tai_xuan_Jing_Symbols}', "");
    Expect(0, 119648, '\P{^Is_Block= -tai_xuan_Jing_Symbols}', "");
    Error('\p{Is_Blk=-/a/Tai_xuan_Jing}');
    Error('\P{Is_Blk=-/a/Tai_xuan_Jing}');
    Expect(1, 119647, '\p{Is_Blk=taixuanjing}', "");
    Expect(0, 119647, '\p{^Is_Blk=taixuanjing}', "");
    Expect(0, 119647, '\P{Is_Blk=taixuanjing}', "");
    Expect(1, 119647, '\P{^Is_Blk=taixuanjing}', "");
    Expect(0, 119648, '\p{Is_Blk=taixuanjing}', "");
    Expect(1, 119648, '\p{^Is_Blk=taixuanjing}', "");
    Expect(1, 119648, '\P{Is_Blk=taixuanjing}', "");
    Expect(0, 119648, '\P{^Is_Blk=taixuanjing}', "");
    Expect(1, 119647, '\p{Is_Blk= Tai_xuan_Jing}', "");
    Expect(0, 119647, '\p{^Is_Blk= Tai_xuan_Jing}', "");
    Expect(0, 119647, '\P{Is_Blk= Tai_xuan_Jing}', "");
    Expect(1, 119647, '\P{^Is_Blk= Tai_xuan_Jing}', "");
    Expect(0, 119648, '\p{Is_Blk= Tai_xuan_Jing}', "");
    Expect(1, 119648, '\p{^Is_Blk= Tai_xuan_Jing}', "");
    Expect(1, 119648, '\P{Is_Blk= Tai_xuan_Jing}', "");
    Expect(0, 119648, '\P{^Is_Blk= Tai_xuan_Jing}', "");
    Error('\p{Block=		TAKRI:=}');
    Error('\P{Block=		TAKRI:=}');
    Expect(1, 71375, '\p{Block=takri}', "");
    Expect(0, 71375, '\p{^Block=takri}', "");
    Expect(0, 71375, '\P{Block=takri}', "");
    Expect(1, 71375, '\P{^Block=takri}', "");
    Expect(0, 71376, '\p{Block=takri}', "");
    Expect(1, 71376, '\p{^Block=takri}', "");
    Expect(1, 71376, '\P{Block=takri}', "");
    Expect(0, 71376, '\P{^Block=takri}', "");
    Expect(1, 71375, '\p{Block=-Takri}', "");
    Expect(0, 71375, '\p{^Block=-Takri}', "");
    Expect(0, 71375, '\P{Block=-Takri}', "");
    Expect(1, 71375, '\P{^Block=-Takri}', "");
    Expect(0, 71376, '\p{Block=-Takri}', "");
    Expect(1, 71376, '\p{^Block=-Takri}', "");
    Expect(1, 71376, '\P{Block=-Takri}', "");
    Expect(0, 71376, '\P{^Block=-Takri}', "");
    Error('\p{Blk=	/a/Takri}');
    Error('\P{Blk=	/a/Takri}');
    Expect(1, 71375, '\p{Blk=takri}', "");
    Expect(0, 71375, '\p{^Blk=takri}', "");
    Expect(0, 71375, '\P{Blk=takri}', "");
    Expect(1, 71375, '\P{^Blk=takri}', "");
    Expect(0, 71376, '\p{Blk=takri}', "");
    Expect(1, 71376, '\p{^Blk=takri}', "");
    Expect(1, 71376, '\P{Blk=takri}', "");
    Expect(0, 71376, '\P{^Blk=takri}', "");
    Expect(1, 71375, '\p{Blk=--TAKRI}', "");
    Expect(0, 71375, '\p{^Blk=--TAKRI}', "");
    Expect(0, 71375, '\P{Blk=--TAKRI}', "");
    Expect(1, 71375, '\P{^Blk=--TAKRI}', "");
    Expect(0, 71376, '\p{Blk=--TAKRI}', "");
    Expect(1, 71376, '\p{^Blk=--TAKRI}', "");
    Expect(1, 71376, '\P{Blk=--TAKRI}', "");
    Expect(0, 71376, '\P{^Blk=--TAKRI}', "");
    Error('\p{Is_Block=/a/		TAKRI}');
    Error('\P{Is_Block=/a/		TAKRI}');
    Expect(1, 71375, '\p{Is_Block=takri}', "");
    Expect(0, 71375, '\p{^Is_Block=takri}', "");
    Expect(0, 71375, '\P{Is_Block=takri}', "");
    Expect(1, 71375, '\P{^Is_Block=takri}', "");
    Expect(0, 71376, '\p{Is_Block=takri}', "");
    Expect(1, 71376, '\p{^Is_Block=takri}', "");
    Expect(1, 71376, '\P{Is_Block=takri}', "");
    Expect(0, 71376, '\P{^Is_Block=takri}', "");
    Expect(1, 71375, '\p{Is_Block=	 TAKRI}', "");
    Expect(0, 71375, '\p{^Is_Block=	 TAKRI}', "");
    Expect(0, 71375, '\P{Is_Block=	 TAKRI}', "");
    Expect(1, 71375, '\P{^Is_Block=	 TAKRI}', "");
    Expect(0, 71376, '\p{Is_Block=	 TAKRI}', "");
    Expect(1, 71376, '\p{^Is_Block=	 TAKRI}', "");
    Expect(1, 71376, '\P{Is_Block=	 TAKRI}', "");
    Expect(0, 71376, '\P{^Is_Block=	 TAKRI}', "");
    Error('\p{Is_Blk=	/a/Takri}');
    Error('\P{Is_Blk=	/a/Takri}');
    Expect(1, 71375, '\p{Is_Blk=takri}', "");
    Expect(0, 71375, '\p{^Is_Blk=takri}', "");
    Expect(0, 71375, '\P{Is_Blk=takri}', "");
    Expect(1, 71375, '\P{^Is_Blk=takri}', "");
    Expect(0, 71376, '\p{Is_Blk=takri}', "");
    Expect(1, 71376, '\p{^Is_Blk=takri}', "");
    Expect(1, 71376, '\P{Is_Blk=takri}', "");
    Expect(0, 71376, '\P{^Is_Blk=takri}', "");
    Expect(1, 71375, '\p{Is_Blk= Takri}', "");
    Expect(0, 71375, '\p{^Is_Blk= Takri}', "");
    Expect(0, 71375, '\P{Is_Blk= Takri}', "");
    Expect(1, 71375, '\P{^Is_Blk= Takri}', "");
    Expect(0, 71376, '\p{Is_Blk= Takri}', "");
    Expect(1, 71376, '\p{^Is_Blk= Takri}', "");
    Expect(1, 71376, '\P{Is_Blk= Takri}', "");
    Expect(0, 71376, '\P{^Is_Blk= Takri}', "");
    Error('\p{Block=	tamil/a/}');
    Error('\P{Block=	tamil/a/}');
    Expect(1, 3071, '\p{Block=tamil}', "");
    Expect(0, 3071, '\p{^Block=tamil}', "");
    Expect(0, 3071, '\P{Block=tamil}', "");
    Expect(1, 3071, '\P{^Block=tamil}', "");
    Expect(0, 3072, '\p{Block=tamil}', "");
    Expect(1, 3072, '\p{^Block=tamil}', "");
    Expect(1, 3072, '\P{Block=tamil}', "");
    Expect(0, 3072, '\P{^Block=tamil}', "");
    Expect(1, 3071, '\p{Block=		tamil}', "");
    Expect(0, 3071, '\p{^Block=		tamil}', "");
    Expect(0, 3071, '\P{Block=		tamil}', "");
    Expect(1, 3071, '\P{^Block=		tamil}', "");
    Expect(0, 3072, '\p{Block=		tamil}', "");
    Expect(1, 3072, '\p{^Block=		tamil}', "");
    Expect(1, 3072, '\P{Block=		tamil}', "");
    Expect(0, 3072, '\P{^Block=		tamil}', "");
    Error('\p{Blk=_TAMIL:=}');
    Error('\P{Blk=_TAMIL:=}');
    Expect(1, 3071, '\p{Blk=tamil}', "");
    Expect(0, 3071, '\p{^Blk=tamil}', "");
    Expect(0, 3071, '\P{Blk=tamil}', "");
    Expect(1, 3071, '\P{^Blk=tamil}', "");
    Expect(0, 3072, '\p{Blk=tamil}', "");
    Expect(1, 3072, '\p{^Blk=tamil}', "");
    Expect(1, 3072, '\P{Blk=tamil}', "");
    Expect(0, 3072, '\P{^Blk=tamil}', "");
    Expect(1, 3071, '\p{Blk=	 TAMIL}', "");
    Expect(0, 3071, '\p{^Blk=	 TAMIL}', "");
    Expect(0, 3071, '\P{Blk=	 TAMIL}', "");
    Expect(1, 3071, '\P{^Blk=	 TAMIL}', "");
    Expect(0, 3072, '\p{Blk=	 TAMIL}', "");
    Expect(1, 3072, '\p{^Blk=	 TAMIL}', "");
    Expect(1, 3072, '\P{Blk=	 TAMIL}', "");
    Expect(0, 3072, '\P{^Blk=	 TAMIL}', "");
    Error('\p{Is_Block=	tamil/a/}');
    Error('\P{Is_Block=	tamil/a/}');
    Expect(1, 3071, '\p{Is_Block=tamil}', "");
    Expect(0, 3071, '\p{^Is_Block=tamil}', "");
    Expect(0, 3071, '\P{Is_Block=tamil}', "");
    Expect(1, 3071, '\P{^Is_Block=tamil}', "");
    Expect(0, 3072, '\p{Is_Block=tamil}', "");
    Expect(1, 3072, '\p{^Is_Block=tamil}', "");
    Expect(1, 3072, '\P{Is_Block=tamil}', "");
    Expect(0, 3072, '\P{^Is_Block=tamil}', "");
    Expect(1, 3071, '\p{Is_Block=-Tamil}', "");
    Expect(0, 3071, '\p{^Is_Block=-Tamil}', "");
    Expect(0, 3071, '\P{Is_Block=-Tamil}', "");
    Expect(1, 3071, '\P{^Is_Block=-Tamil}', "");
    Expect(0, 3072, '\p{Is_Block=-Tamil}', "");
    Expect(1, 3072, '\p{^Is_Block=-Tamil}', "");
    Expect(1, 3072, '\P{Is_Block=-Tamil}', "");
    Expect(0, 3072, '\P{^Is_Block=-Tamil}', "");
    Error('\p{Is_Blk= _Tamil:=}');
    Error('\P{Is_Blk= _Tamil:=}');
    Expect(1, 3071, '\p{Is_Blk=tamil}', "");
    Expect(0, 3071, '\p{^Is_Blk=tamil}', "");
    Expect(0, 3071, '\P{Is_Blk=tamil}', "");
    Expect(1, 3071, '\P{^Is_Blk=tamil}', "");
    Expect(0, 3072, '\p{Is_Blk=tamil}', "");
    Expect(1, 3072, '\p{^Is_Blk=tamil}', "");
    Expect(1, 3072, '\P{Is_Blk=tamil}', "");
    Expect(0, 3072, '\P{^Is_Blk=tamil}', "");
    Expect(1, 3071, '\p{Is_Blk=_	TAMIL}', "");
    Expect(0, 3071, '\p{^Is_Blk=_	TAMIL}', "");
    Expect(0, 3071, '\P{Is_Blk=_	TAMIL}', "");
    Expect(1, 3071, '\P{^Is_Blk=_	TAMIL}', "");
    Expect(0, 3072, '\p{Is_Blk=_	TAMIL}', "");
    Expect(1, 3072, '\p{^Is_Blk=_	TAMIL}', "");
    Expect(1, 3072, '\P{Is_Blk=_	TAMIL}', "");
    Expect(0, 3072, '\P{^Is_Blk=_	TAMIL}', "");
    Error('\p{Block:		TANGUT/a/}');
    Error('\P{Block:		TANGUT/a/}');
    Expect(1, 100351, '\p{Block=tangut}', "");
    Expect(0, 100351, '\p{^Block=tangut}', "");
    Expect(0, 100351, '\P{Block=tangut}', "");
    Expect(1, 100351, '\P{^Block=tangut}', "");
    Expect(0, 100352, '\p{Block=tangut}', "");
    Expect(1, 100352, '\p{^Block=tangut}', "");
    Expect(1, 100352, '\P{Block=tangut}', "");
    Expect(0, 100352, '\P{^Block=tangut}', "");
    Expect(1, 100351, '\p{Block=- Tangut}', "");
    Expect(0, 100351, '\p{^Block=- Tangut}', "");
    Expect(0, 100351, '\P{Block=- Tangut}', "");
    Expect(1, 100351, '\P{^Block=- Tangut}', "");
    Expect(0, 100352, '\p{Block=- Tangut}', "");
    Expect(1, 100352, '\p{^Block=- Tangut}', "");
    Expect(1, 100352, '\P{Block=- Tangut}', "");
    Expect(0, 100352, '\P{^Block=- Tangut}', "");
    Error('\p{Blk=_-Tangut/a/}');
    Error('\P{Blk=_-Tangut/a/}');
    Expect(1, 100351, '\p{Blk=tangut}', "");
    Expect(0, 100351, '\p{^Blk=tangut}', "");
    Expect(0, 100351, '\P{Blk=tangut}', "");
    Expect(1, 100351, '\P{^Blk=tangut}', "");
    Expect(0, 100352, '\p{Blk=tangut}', "");
    Expect(1, 100352, '\p{^Blk=tangut}', "");
    Expect(1, 100352, '\P{Blk=tangut}', "");
    Expect(0, 100352, '\P{^Blk=tangut}', "");
    Expect(1, 100351, '\p{Blk=--tangut}', "");
    Expect(0, 100351, '\p{^Blk=--tangut}', "");
    Expect(0, 100351, '\P{Blk=--tangut}', "");
    Expect(1, 100351, '\P{^Blk=--tangut}', "");
    Expect(0, 100352, '\p{Blk=--tangut}', "");
    Expect(1, 100352, '\p{^Blk=--tangut}', "");
    Expect(1, 100352, '\P{Blk=--tangut}', "");
    Expect(0, 100352, '\P{^Blk=--tangut}', "");
    Error('\p{Is_Block=  Tangut:=}');
    Error('\P{Is_Block=  Tangut:=}');
    Expect(1, 100351, '\p{Is_Block=tangut}', "");
    Expect(0, 100351, '\p{^Is_Block=tangut}', "");
    Expect(0, 100351, '\P{Is_Block=tangut}', "");
    Expect(1, 100351, '\P{^Is_Block=tangut}', "");
    Expect(0, 100352, '\p{Is_Block=tangut}', "");
    Expect(1, 100352, '\p{^Is_Block=tangut}', "");
    Expect(1, 100352, '\P{Is_Block=tangut}', "");
    Expect(0, 100352, '\P{^Is_Block=tangut}', "");
    Expect(1, 100351, '\p{Is_Block=-tangut}', "");
    Expect(0, 100351, '\p{^Is_Block=-tangut}', "");
    Expect(0, 100351, '\P{Is_Block=-tangut}', "");
    Expect(1, 100351, '\P{^Is_Block=-tangut}', "");
    Expect(0, 100352, '\p{Is_Block=-tangut}', "");
    Expect(1, 100352, '\p{^Is_Block=-tangut}', "");
    Expect(1, 100352, '\P{Is_Block=-tangut}', "");
    Expect(0, 100352, '\P{^Is_Block=-tangut}', "");
    Error('\p{Is_Blk= /a/Tangut}');
    Error('\P{Is_Blk= /a/Tangut}');
    Expect(1, 100351, '\p{Is_Blk=tangut}', "");
    Expect(0, 100351, '\p{^Is_Blk=tangut}', "");
    Expect(0, 100351, '\P{Is_Blk=tangut}', "");
    Expect(1, 100351, '\P{^Is_Blk=tangut}', "");
    Expect(0, 100352, '\p{Is_Blk=tangut}', "");
    Expect(1, 100352, '\p{^Is_Blk=tangut}', "");
    Expect(1, 100352, '\P{Is_Blk=tangut}', "");
    Expect(0, 100352, '\P{^Is_Blk=tangut}', "");
    Expect(1, 100351, '\p{Is_Blk=	Tangut}', "");
    Expect(0, 100351, '\p{^Is_Blk=	Tangut}', "");
    Expect(0, 100351, '\P{Is_Blk=	Tangut}', "");
    Expect(1, 100351, '\P{^Is_Blk=	Tangut}', "");
    Expect(0, 100352, '\p{Is_Blk=	Tangut}', "");
    Expect(1, 100352, '\p{^Is_Blk=	Tangut}', "");
    Expect(1, 100352, '\P{Is_Blk=	Tangut}', "");
    Expect(0, 100352, '\P{^Is_Blk=	Tangut}', "");
    Error('\p{Block=_-Tangut_Components:=}');
    Error('\P{Block=_-Tangut_Components:=}');
    Expect(1, 101119, '\p{Block=tangutcomponents}', "");
    Expect(0, 101119, '\p{^Block=tangutcomponents}', "");
    Expect(0, 101119, '\P{Block=tangutcomponents}', "");
    Expect(1, 101119, '\P{^Block=tangutcomponents}', "");
    Expect(0, 101120, '\p{Block=tangutcomponents}', "");
    Expect(1, 101120, '\p{^Block=tangutcomponents}', "");
    Expect(1, 101120, '\P{Block=tangutcomponents}', "");
    Expect(0, 101120, '\P{^Block=tangutcomponents}', "");
    Expect(1, 101119, '\p{Block=  TANGUT_COMPONENTS}', "");
    Expect(0, 101119, '\p{^Block=  TANGUT_COMPONENTS}', "");
    Expect(0, 101119, '\P{Block=  TANGUT_COMPONENTS}', "");
    Expect(1, 101119, '\P{^Block=  TANGUT_COMPONENTS}', "");
    Expect(0, 101120, '\p{Block=  TANGUT_COMPONENTS}', "");
    Expect(1, 101120, '\p{^Block=  TANGUT_COMPONENTS}', "");
    Expect(1, 101120, '\P{Block=  TANGUT_COMPONENTS}', "");
    Expect(0, 101120, '\P{^Block=  TANGUT_COMPONENTS}', "");
    Error('\p{Blk=_Tangut_components:=}');
    Error('\P{Blk=_Tangut_components:=}');
    Expect(1, 101119, '\p{Blk=tangutcomponents}', "");
    Expect(0, 101119, '\p{^Blk=tangutcomponents}', "");
    Expect(0, 101119, '\P{Blk=tangutcomponents}', "");
    Expect(1, 101119, '\P{^Blk=tangutcomponents}', "");
    Expect(0, 101120, '\p{Blk=tangutcomponents}', "");
    Expect(1, 101120, '\p{^Blk=tangutcomponents}', "");
    Expect(1, 101120, '\P{Blk=tangutcomponents}', "");
    Expect(0, 101120, '\P{^Blk=tangutcomponents}', "");
    Expect(1, 101119, '\p{Blk= 	Tangut_components}', "");
    Expect(0, 101119, '\p{^Blk= 	Tangut_components}', "");
    Expect(0, 101119, '\P{Blk= 	Tangut_components}', "");
    Expect(1, 101119, '\P{^Blk= 	Tangut_components}', "");
    Expect(0, 101120, '\p{Blk= 	Tangut_components}', "");
    Expect(1, 101120, '\p{^Blk= 	Tangut_components}', "");
    Expect(1, 101120, '\P{Blk= 	Tangut_components}', "");
    Expect(0, 101120, '\P{^Blk= 	Tangut_components}', "");
    Error('\p{Is_Block=-/a/Tangut_components}');
    Error('\P{Is_Block=-/a/Tangut_components}');
    Expect(1, 101119, '\p{Is_Block=tangutcomponents}', "");
    Expect(0, 101119, '\p{^Is_Block=tangutcomponents}', "");
    Expect(0, 101119, '\P{Is_Block=tangutcomponents}', "");
    Expect(1, 101119, '\P{^Is_Block=tangutcomponents}', "");
    Expect(0, 101120, '\p{Is_Block=tangutcomponents}', "");
    Expect(1, 101120, '\p{^Is_Block=tangutcomponents}', "");
    Expect(1, 101120, '\P{Is_Block=tangutcomponents}', "");
    Expect(0, 101120, '\P{^Is_Block=tangutcomponents}', "");
    Expect(1, 101119, '\p{Is_Block=	-tangut_components}', "");
    Expect(0, 101119, '\p{^Is_Block=	-tangut_components}', "");
    Expect(0, 101119, '\P{Is_Block=	-tangut_components}', "");
    Expect(1, 101119, '\P{^Is_Block=	-tangut_components}', "");
    Expect(0, 101120, '\p{Is_Block=	-tangut_components}', "");
    Expect(1, 101120, '\p{^Is_Block=	-tangut_components}', "");
    Expect(1, 101120, '\P{Is_Block=	-tangut_components}', "");
    Expect(0, 101120, '\P{^Is_Block=	-tangut_components}', "");
    Error('\p{Is_Blk=:=tangut_components}');
    Error('\P{Is_Blk=:=tangut_components}');
    Expect(1, 101119, '\p{Is_Blk=tangutcomponents}', "");
    Expect(0, 101119, '\p{^Is_Blk=tangutcomponents}', "");
    Expect(0, 101119, '\P{Is_Blk=tangutcomponents}', "");
    Expect(1, 101119, '\P{^Is_Blk=tangutcomponents}', "");
    Expect(0, 101120, '\p{Is_Blk=tangutcomponents}', "");
    Expect(1, 101120, '\p{^Is_Blk=tangutcomponents}', "");
    Expect(1, 101120, '\P{Is_Blk=tangutcomponents}', "");
    Expect(0, 101120, '\P{^Is_Blk=tangutcomponents}', "");
    Expect(1, 101119, '\p{Is_Blk=tangut_Components}', "");
    Expect(0, 101119, '\p{^Is_Blk=tangut_Components}', "");
    Expect(0, 101119, '\P{Is_Blk=tangut_Components}', "");
    Expect(1, 101119, '\P{^Is_Blk=tangut_Components}', "");
    Expect(0, 101120, '\p{Is_Blk=tangut_Components}', "");
    Expect(1, 101120, '\p{^Is_Blk=tangut_Components}', "");
    Expect(1, 101120, '\P{Is_Blk=tangut_Components}', "");
    Expect(0, 101120, '\P{^Is_Blk=tangut_Components}', "");
    Error('\p{Block=_Telugu:=}');
    Error('\P{Block=_Telugu:=}');
    Expect(1, 3199, '\p{Block=telugu}', "");
    Expect(0, 3199, '\p{^Block=telugu}', "");
    Expect(0, 3199, '\P{Block=telugu}', "");
    Expect(1, 3199, '\P{^Block=telugu}', "");
    Expect(0, 3200, '\p{Block=telugu}', "");
    Expect(1, 3200, '\p{^Block=telugu}', "");
    Expect(1, 3200, '\P{Block=telugu}', "");
    Expect(0, 3200, '\P{^Block=telugu}', "");
    Expect(1, 3199, '\p{Block=	_telugu}', "");
    Expect(0, 3199, '\p{^Block=	_telugu}', "");
    Expect(0, 3199, '\P{Block=	_telugu}', "");
    Expect(1, 3199, '\P{^Block=	_telugu}', "");
    Expect(0, 3200, '\p{Block=	_telugu}', "");
    Expect(1, 3200, '\p{^Block=	_telugu}', "");
    Expect(1, 3200, '\P{Block=	_telugu}', "");
    Expect(0, 3200, '\P{^Block=	_telugu}', "");
    Error('\p{Blk=/a/ TELUGU}');
    Error('\P{Blk=/a/ TELUGU}');
    Expect(1, 3199, '\p{Blk=telugu}', "");
    Expect(0, 3199, '\p{^Blk=telugu}', "");
    Expect(0, 3199, '\P{Blk=telugu}', "");
    Expect(1, 3199, '\P{^Blk=telugu}', "");
    Expect(0, 3200, '\p{Blk=telugu}', "");
    Expect(1, 3200, '\p{^Blk=telugu}', "");
    Expect(1, 3200, '\P{Blk=telugu}', "");
    Expect(0, 3200, '\P{^Blk=telugu}', "");
    Expect(1, 3199, '\p{Blk=_-Telugu}', "");
    Expect(0, 3199, '\p{^Blk=_-Telugu}', "");
    Expect(0, 3199, '\P{Blk=_-Telugu}', "");
    Expect(1, 3199, '\P{^Blk=_-Telugu}', "");
    Expect(0, 3200, '\p{Blk=_-Telugu}', "");
    Expect(1, 3200, '\p{^Blk=_-Telugu}', "");
    Expect(1, 3200, '\P{Blk=_-Telugu}', "");
    Expect(0, 3200, '\P{^Blk=_-Telugu}', "");
    Error('\p{Is_Block=_/a/Telugu}');
    Error('\P{Is_Block=_/a/Telugu}');
    Expect(1, 3199, '\p{Is_Block=telugu}', "");
    Expect(0, 3199, '\p{^Is_Block=telugu}', "");
    Expect(0, 3199, '\P{Is_Block=telugu}', "");
    Expect(1, 3199, '\P{^Is_Block=telugu}', "");
    Expect(0, 3200, '\p{Is_Block=telugu}', "");
    Expect(1, 3200, '\p{^Is_Block=telugu}', "");
    Expect(1, 3200, '\P{Is_Block=telugu}', "");
    Expect(0, 3200, '\P{^Is_Block=telugu}', "");
    Expect(1, 3199, '\p{Is_Block: 	 TELUGU}', "");
    Expect(0, 3199, '\p{^Is_Block: 	 TELUGU}', "");
    Expect(0, 3199, '\P{Is_Block: 	 TELUGU}', "");
    Expect(1, 3199, '\P{^Is_Block: 	 TELUGU}', "");
    Expect(0, 3200, '\p{Is_Block: 	 TELUGU}', "");
    Expect(1, 3200, '\p{^Is_Block: 	 TELUGU}', "");
    Expect(1, 3200, '\P{Is_Block: 	 TELUGU}', "");
    Expect(0, 3200, '\P{^Is_Block: 	 TELUGU}', "");
    Error('\p{Is_Blk=telugu:=}');
    Error('\P{Is_Blk=telugu:=}');
    Expect(1, 3199, '\p{Is_Blk=telugu}', "");
    Expect(0, 3199, '\p{^Is_Blk=telugu}', "");
    Expect(0, 3199, '\P{Is_Blk=telugu}', "");
    Expect(1, 3199, '\P{^Is_Blk=telugu}', "");
    Expect(0, 3200, '\p{Is_Blk=telugu}', "");
    Expect(1, 3200, '\p{^Is_Blk=telugu}', "");
    Expect(1, 3200, '\P{Is_Blk=telugu}', "");
    Expect(0, 3200, '\P{^Is_Blk=telugu}', "");
    Expect(1, 3199, '\p{Is_Blk:-TELUGU}', "");
    Expect(0, 3199, '\p{^Is_Blk:-TELUGU}', "");
    Expect(0, 3199, '\P{Is_Blk:-TELUGU}', "");
    Expect(1, 3199, '\P{^Is_Blk:-TELUGU}', "");
    Expect(0, 3200, '\p{Is_Blk:-TELUGU}', "");
    Expect(1, 3200, '\p{^Is_Blk:-TELUGU}', "");
    Expect(1, 3200, '\P{Is_Blk:-TELUGU}', "");
    Expect(0, 3200, '\P{^Is_Blk:-TELUGU}', "");
    Error('\p{Block=:=Thaana}');
    Error('\P{Block=:=Thaana}');
    Expect(1, 1983, '\p{Block=thaana}', "");
    Expect(0, 1983, '\p{^Block=thaana}', "");
    Expect(0, 1983, '\P{Block=thaana}', "");
    Expect(1, 1983, '\P{^Block=thaana}', "");
    Expect(0, 1984, '\p{Block=thaana}', "");
    Expect(1, 1984, '\p{^Block=thaana}', "");
    Expect(1, 1984, '\P{Block=thaana}', "");
    Expect(0, 1984, '\P{^Block=thaana}', "");
    Expect(1, 1983, '\p{Block=	thaana}', "");
    Expect(0, 1983, '\p{^Block=	thaana}', "");
    Expect(0, 1983, '\P{Block=	thaana}', "");
    Expect(1, 1983, '\P{^Block=	thaana}', "");
    Expect(0, 1984, '\p{Block=	thaana}', "");
    Expect(1, 1984, '\p{^Block=	thaana}', "");
    Expect(1, 1984, '\P{Block=	thaana}', "");
    Expect(0, 1984, '\P{^Block=	thaana}', "");
    Error('\p{Blk:  :=Thaana}');
    Error('\P{Blk:  :=Thaana}');
    Expect(1, 1983, '\p{Blk=thaana}', "");
    Expect(0, 1983, '\p{^Blk=thaana}', "");
    Expect(0, 1983, '\P{Blk=thaana}', "");
    Expect(1, 1983, '\P{^Blk=thaana}', "");
    Expect(0, 1984, '\p{Blk=thaana}', "");
    Expect(1, 1984, '\p{^Blk=thaana}', "");
    Expect(1, 1984, '\P{Blk=thaana}', "");
    Expect(0, 1984, '\P{^Blk=thaana}', "");
    Expect(1, 1983, '\p{Blk= -Thaana}', "");
    Expect(0, 1983, '\p{^Blk= -Thaana}', "");
    Expect(0, 1983, '\P{Blk= -Thaana}', "");
    Expect(1, 1983, '\P{^Blk= -Thaana}', "");
    Expect(0, 1984, '\p{Blk= -Thaana}', "");
    Expect(1, 1984, '\p{^Blk= -Thaana}', "");
    Expect(1, 1984, '\P{Blk= -Thaana}', "");
    Expect(0, 1984, '\P{^Blk= -Thaana}', "");
    Error('\p{Is_Block=_ THAANA/a/}');
    Error('\P{Is_Block=_ THAANA/a/}');
    Expect(1, 1983, '\p{Is_Block=thaana}', "");
    Expect(0, 1983, '\p{^Is_Block=thaana}', "");
    Expect(0, 1983, '\P{Is_Block=thaana}', "");
    Expect(1, 1983, '\P{^Is_Block=thaana}', "");
    Expect(0, 1984, '\p{Is_Block=thaana}', "");
    Expect(1, 1984, '\p{^Is_Block=thaana}', "");
    Expect(1, 1984, '\P{Is_Block=thaana}', "");
    Expect(0, 1984, '\P{^Is_Block=thaana}', "");
    Expect(1, 1983, '\p{Is_Block=-Thaana}', "");
    Expect(0, 1983, '\p{^Is_Block=-Thaana}', "");
    Expect(0, 1983, '\P{Is_Block=-Thaana}', "");
    Expect(1, 1983, '\P{^Is_Block=-Thaana}', "");
    Expect(0, 1984, '\p{Is_Block=-Thaana}', "");
    Expect(1, 1984, '\p{^Is_Block=-Thaana}', "");
    Expect(1, 1984, '\P{Is_Block=-Thaana}', "");
    Expect(0, 1984, '\P{^Is_Block=-Thaana}', "");
    Error('\p{Is_Blk:	/a/thaana}');
    Error('\P{Is_Blk:	/a/thaana}');
    Expect(1, 1983, '\p{Is_Blk=thaana}', "");
    Expect(0, 1983, '\p{^Is_Blk=thaana}', "");
    Expect(0, 1983, '\P{Is_Blk=thaana}', "");
    Expect(1, 1983, '\P{^Is_Blk=thaana}', "");
    Expect(0, 1984, '\p{Is_Blk=thaana}', "");
    Expect(1, 1984, '\p{^Is_Blk=thaana}', "");
    Expect(1, 1984, '\P{Is_Blk=thaana}', "");
    Expect(0, 1984, '\P{^Is_Blk=thaana}', "");
    Expect(1, 1983, '\p{Is_Blk=	Thaana}', "");
    Expect(0, 1983, '\p{^Is_Blk=	Thaana}', "");
    Expect(0, 1983, '\P{Is_Blk=	Thaana}', "");
    Expect(1, 1983, '\P{^Is_Blk=	Thaana}', "");
    Expect(0, 1984, '\p{Is_Blk=	Thaana}', "");
    Expect(1, 1984, '\p{^Is_Blk=	Thaana}', "");
    Expect(1, 1984, '\P{Is_Blk=	Thaana}', "");
    Expect(0, 1984, '\P{^Is_Blk=	Thaana}', "");
    Error('\p{Block=:=- THAI}');
    Error('\P{Block=:=- THAI}');
    Expect(1, 3711, '\p{Block: thai}', "");
    Expect(0, 3711, '\p{^Block: thai}', "");
    Expect(0, 3711, '\P{Block: thai}', "");
    Expect(1, 3711, '\P{^Block: thai}', "");
    Expect(0, 3712, '\p{Block: thai}', "");
    Expect(1, 3712, '\p{^Block: thai}', "");
    Expect(1, 3712, '\P{Block: thai}', "");
    Expect(0, 3712, '\P{^Block: thai}', "");
    Expect(1, 3711, '\p{Block:		Thai}', "");
    Expect(0, 3711, '\p{^Block:		Thai}', "");
    Expect(0, 3711, '\P{Block:		Thai}', "");
    Expect(1, 3711, '\P{^Block:		Thai}', "");
    Expect(0, 3712, '\p{Block:		Thai}', "");
    Expect(1, 3712, '\p{^Block:		Thai}', "");
    Expect(1, 3712, '\P{Block:		Thai}', "");
    Expect(0, 3712, '\P{^Block:		Thai}', "");
    Error('\p{Blk: /a/thai}');
    Error('\P{Blk: /a/thai}');
    Expect(1, 3711, '\p{Blk:	thai}', "");
    Expect(0, 3711, '\p{^Blk:	thai}', "");
    Expect(0, 3711, '\P{Blk:	thai}', "");
    Expect(1, 3711, '\P{^Blk:	thai}', "");
    Expect(0, 3712, '\p{Blk:	thai}', "");
    Expect(1, 3712, '\p{^Blk:	thai}', "");
    Expect(1, 3712, '\P{Blk:	thai}', "");
    Expect(0, 3712, '\P{^Blk:	thai}', "");
    Expect(1, 3711, '\p{Blk=	 Thai}', "");
    Expect(0, 3711, '\p{^Blk=	 Thai}', "");
    Expect(0, 3711, '\P{Blk=	 Thai}', "");
    Expect(1, 3711, '\P{^Blk=	 Thai}', "");
    Expect(0, 3712, '\p{Blk=	 Thai}', "");
    Expect(1, 3712, '\p{^Blk=	 Thai}', "");
    Expect(1, 3712, '\P{Blk=	 Thai}', "");
    Expect(0, 3712, '\P{^Blk=	 Thai}', "");
    Error('\p{Is_Block=:=_	Thai}');
    Error('\P{Is_Block=:=_	Thai}');
    Expect(1, 3711, '\p{Is_Block=thai}', "");
    Expect(0, 3711, '\p{^Is_Block=thai}', "");
    Expect(0, 3711, '\P{Is_Block=thai}', "");
    Expect(1, 3711, '\P{^Is_Block=thai}', "");
    Expect(0, 3712, '\p{Is_Block=thai}', "");
    Expect(1, 3712, '\p{^Is_Block=thai}', "");
    Expect(1, 3712, '\P{Is_Block=thai}', "");
    Expect(0, 3712, '\P{^Is_Block=thai}', "");
    Expect(1, 3711, '\p{Is_Block= THAI}', "");
    Expect(0, 3711, '\p{^Is_Block= THAI}', "");
    Expect(0, 3711, '\P{Is_Block= THAI}', "");
    Expect(1, 3711, '\P{^Is_Block= THAI}', "");
    Expect(0, 3712, '\p{Is_Block= THAI}', "");
    Expect(1, 3712, '\p{^Is_Block= THAI}', "");
    Expect(1, 3712, '\P{Is_Block= THAI}', "");
    Expect(0, 3712, '\P{^Is_Block= THAI}', "");
    Error('\p{Is_Blk=/a/THAI}');
    Error('\P{Is_Blk=/a/THAI}');
    Expect(1, 3711, '\p{Is_Blk=thai}', "");
    Expect(0, 3711, '\p{^Is_Blk=thai}', "");
    Expect(0, 3711, '\P{Is_Blk=thai}', "");
    Expect(1, 3711, '\P{^Is_Blk=thai}', "");
    Expect(0, 3712, '\p{Is_Blk=thai}', "");
    Expect(1, 3712, '\p{^Is_Blk=thai}', "");
    Expect(1, 3712, '\P{Is_Blk=thai}', "");
    Expect(0, 3712, '\P{^Is_Blk=thai}', "");
    Expect(1, 3711, '\p{Is_Blk=  thai}', "");
    Expect(0, 3711, '\p{^Is_Blk=  thai}', "");
    Expect(0, 3711, '\P{Is_Blk=  thai}', "");
    Expect(1, 3711, '\P{^Is_Blk=  thai}', "");
    Expect(0, 3712, '\p{Is_Blk=  thai}', "");
    Expect(1, 3712, '\p{^Is_Blk=  thai}', "");
    Expect(1, 3712, '\P{Is_Blk=  thai}', "");
    Expect(0, 3712, '\P{^Is_Blk=  thai}', "");
    Error('\p{Block=_:=Tibetan}');
    Error('\P{Block=_:=Tibetan}');
    Expect(1, 4095, '\p{Block=tibetan}', "");
    Expect(0, 4095, '\p{^Block=tibetan}', "");
    Expect(0, 4095, '\P{Block=tibetan}', "");
    Expect(1, 4095, '\P{^Block=tibetan}', "");
    Expect(0, 4096, '\p{Block=tibetan}', "");
    Expect(1, 4096, '\p{^Block=tibetan}', "");
    Expect(1, 4096, '\P{Block=tibetan}', "");
    Expect(0, 4096, '\P{^Block=tibetan}', "");
    Expect(1, 4095, '\p{Block=		Tibetan}', "");
    Expect(0, 4095, '\p{^Block=		Tibetan}', "");
    Expect(0, 4095, '\P{Block=		Tibetan}', "");
    Expect(1, 4095, '\P{^Block=		Tibetan}', "");
    Expect(0, 4096, '\p{Block=		Tibetan}', "");
    Expect(1, 4096, '\p{^Block=		Tibetan}', "");
    Expect(1, 4096, '\P{Block=		Tibetan}', "");
    Expect(0, 4096, '\P{^Block=		Tibetan}', "");
    Error('\p{Blk=:= -TIBETAN}');
    Error('\P{Blk=:= -TIBETAN}');
    Expect(1, 4095, '\p{Blk=tibetan}', "");
    Expect(0, 4095, '\p{^Blk=tibetan}', "");
    Expect(0, 4095, '\P{Blk=tibetan}', "");
    Expect(1, 4095, '\P{^Blk=tibetan}', "");
    Expect(0, 4096, '\p{Blk=tibetan}', "");
    Expect(1, 4096, '\p{^Blk=tibetan}', "");
    Expect(1, 4096, '\P{Blk=tibetan}', "");
    Expect(0, 4096, '\P{^Blk=tibetan}', "");
    Expect(1, 4095, '\p{Blk= -TIBETAN}', "");
    Expect(0, 4095, '\p{^Blk= -TIBETAN}', "");
    Expect(0, 4095, '\P{Blk= -TIBETAN}', "");
    Expect(1, 4095, '\P{^Blk= -TIBETAN}', "");
    Expect(0, 4096, '\p{Blk= -TIBETAN}', "");
    Expect(1, 4096, '\p{^Blk= -TIBETAN}', "");
    Expect(1, 4096, '\P{Blk= -TIBETAN}', "");
    Expect(0, 4096, '\P{^Blk= -TIBETAN}', "");
    Error('\p{Is_Block=:=_Tibetan}');
    Error('\P{Is_Block=:=_Tibetan}');
    Expect(1, 4095, '\p{Is_Block=tibetan}', "");
    Expect(0, 4095, '\p{^Is_Block=tibetan}', "");
    Expect(0, 4095, '\P{Is_Block=tibetan}', "");
    Expect(1, 4095, '\P{^Is_Block=tibetan}', "");
    Expect(0, 4096, '\p{Is_Block=tibetan}', "");
    Expect(1, 4096, '\p{^Is_Block=tibetan}', "");
    Expect(1, 4096, '\P{Is_Block=tibetan}', "");
    Expect(0, 4096, '\P{^Is_Block=tibetan}', "");
    Expect(1, 4095, '\p{Is_Block=-Tibetan}', "");
    Expect(0, 4095, '\p{^Is_Block=-Tibetan}', "");
    Expect(0, 4095, '\P{Is_Block=-Tibetan}', "");
    Expect(1, 4095, '\P{^Is_Block=-Tibetan}', "");
    Expect(0, 4096, '\p{Is_Block=-Tibetan}', "");
    Expect(1, 4096, '\p{^Is_Block=-Tibetan}', "");
    Expect(1, 4096, '\P{Is_Block=-Tibetan}', "");
    Expect(0, 4096, '\P{^Is_Block=-Tibetan}', "");
    Error('\p{Is_Blk=-:=tibetan}');
    Error('\P{Is_Blk=-:=tibetan}');
    Expect(1, 4095, '\p{Is_Blk=tibetan}', "");
    Expect(0, 4095, '\p{^Is_Blk=tibetan}', "");
    Expect(0, 4095, '\P{Is_Blk=tibetan}', "");
    Expect(1, 4095, '\P{^Is_Blk=tibetan}', "");
    Expect(0, 4096, '\p{Is_Blk=tibetan}', "");
    Expect(1, 4096, '\p{^Is_Blk=tibetan}', "");
    Expect(1, 4096, '\P{Is_Blk=tibetan}', "");
    Expect(0, 4096, '\P{^Is_Blk=tibetan}', "");
    Expect(1, 4095, '\p{Is_Blk= -tibetan}', "");
    Expect(0, 4095, '\p{^Is_Blk= -tibetan}', "");
    Expect(0, 4095, '\P{Is_Blk= -tibetan}', "");
    Expect(1, 4095, '\P{^Is_Blk= -tibetan}', "");
    Expect(0, 4096, '\p{Is_Blk= -tibetan}', "");
    Expect(1, 4096, '\p{^Is_Blk= -tibetan}', "");
    Expect(1, 4096, '\P{Is_Blk= -tibetan}', "");
    Expect(0, 4096, '\P{^Is_Blk= -tibetan}', "");
    Error('\p{Block=_ Tifinagh/a/}');
    Error('\P{Block=_ Tifinagh/a/}');
    Expect(1, 11647, '\p{Block=tifinagh}', "");
    Expect(0, 11647, '\p{^Block=tifinagh}', "");
    Expect(0, 11647, '\P{Block=tifinagh}', "");
    Expect(1, 11647, '\P{^Block=tifinagh}', "");
    Expect(0, 11648, '\p{Block=tifinagh}', "");
    Expect(1, 11648, '\p{^Block=tifinagh}', "");
    Expect(1, 11648, '\P{Block=tifinagh}', "");
    Expect(0, 11648, '\P{^Block=tifinagh}', "");
    Expect(1, 11647, '\p{Block=-tifinagh}', "");
    Expect(0, 11647, '\p{^Block=-tifinagh}', "");
    Expect(0, 11647, '\P{Block=-tifinagh}', "");
    Expect(1, 11647, '\P{^Block=-tifinagh}', "");
    Expect(0, 11648, '\p{Block=-tifinagh}', "");
    Expect(1, 11648, '\p{^Block=-tifinagh}', "");
    Expect(1, 11648, '\P{Block=-tifinagh}', "");
    Expect(0, 11648, '\P{^Block=-tifinagh}', "");
    Error('\p{Blk=_:=tifinagh}');
    Error('\P{Blk=_:=tifinagh}');
    Expect(1, 11647, '\p{Blk=tifinagh}', "");
    Expect(0, 11647, '\p{^Blk=tifinagh}', "");
    Expect(0, 11647, '\P{Blk=tifinagh}', "");
    Expect(1, 11647, '\P{^Blk=tifinagh}', "");
    Expect(0, 11648, '\p{Blk=tifinagh}', "");
    Expect(1, 11648, '\p{^Blk=tifinagh}', "");
    Expect(1, 11648, '\P{Blk=tifinagh}', "");
    Expect(0, 11648, '\P{^Blk=tifinagh}', "");
    Expect(1, 11647, '\p{Blk=		TIFINAGH}', "");
    Expect(0, 11647, '\p{^Blk=		TIFINAGH}', "");
    Expect(0, 11647, '\P{Blk=		TIFINAGH}', "");
    Expect(1, 11647, '\P{^Blk=		TIFINAGH}', "");
    Expect(0, 11648, '\p{Blk=		TIFINAGH}', "");
    Expect(1, 11648, '\p{^Blk=		TIFINAGH}', "");
    Expect(1, 11648, '\P{Blk=		TIFINAGH}', "");
    Expect(0, 11648, '\P{^Blk=		TIFINAGH}', "");
    Error('\p{Is_Block=-:=Tifinagh}');
    Error('\P{Is_Block=-:=Tifinagh}');
    Expect(1, 11647, '\p{Is_Block=tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Block=tifinagh}', "");
    Expect(0, 11647, '\P{Is_Block=tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Block=tifinagh}', "");
    Expect(0, 11648, '\p{Is_Block=tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Block=tifinagh}', "");
    Expect(1, 11648, '\P{Is_Block=tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Block=tifinagh}', "");
    Expect(1, 11647, '\p{Is_Block=		Tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Block=		Tifinagh}', "");
    Expect(0, 11647, '\P{Is_Block=		Tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Block=		Tifinagh}', "");
    Expect(0, 11648, '\p{Is_Block=		Tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Block=		Tifinagh}', "");
    Expect(1, 11648, '\P{Is_Block=		Tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Block=		Tifinagh}', "");
    Error('\p{Is_Blk=:=-	tifinagh}');
    Error('\P{Is_Blk=:=-	tifinagh}');
    Expect(1, 11647, '\p{Is_Blk=tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Blk=tifinagh}', "");
    Expect(0, 11647, '\P{Is_Blk=tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Blk=tifinagh}', "");
    Expect(0, 11648, '\p{Is_Blk=tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Blk=tifinagh}', "");
    Expect(1, 11648, '\P{Is_Blk=tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Blk=tifinagh}', "");
    Expect(1, 11647, '\p{Is_Blk=__Tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Blk=__Tifinagh}', "");
    Expect(0, 11647, '\P{Is_Blk=__Tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Blk=__Tifinagh}', "");
    Expect(0, 11648, '\p{Is_Blk=__Tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Blk=__Tifinagh}', "");
    Expect(1, 11648, '\P{Is_Blk=__Tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Blk=__Tifinagh}', "");
    Error('\p{Block=-TIRHUTA/a/}');
    Error('\P{Block=-TIRHUTA/a/}');
    Expect(1, 70879, '\p{Block=tirhuta}', "");
    Expect(0, 70879, '\p{^Block=tirhuta}', "");
    Expect(0, 70879, '\P{Block=tirhuta}', "");
    Expect(1, 70879, '\P{^Block=tirhuta}', "");
    Expect(0, 70880, '\p{Block=tirhuta}', "");
    Expect(1, 70880, '\p{^Block=tirhuta}', "");
    Expect(1, 70880, '\P{Block=tirhuta}', "");
    Expect(0, 70880, '\P{^Block=tirhuta}', "");
    Expect(1, 70879, '\p{Block=-_TIRHUTA}', "");
    Expect(0, 70879, '\p{^Block=-_TIRHUTA}', "");
    Expect(0, 70879, '\P{Block=-_TIRHUTA}', "");
    Expect(1, 70879, '\P{^Block=-_TIRHUTA}', "");
    Expect(0, 70880, '\p{Block=-_TIRHUTA}', "");
    Expect(1, 70880, '\p{^Block=-_TIRHUTA}', "");
    Expect(1, 70880, '\P{Block=-_TIRHUTA}', "");
    Expect(0, 70880, '\P{^Block=-_TIRHUTA}', "");
    Error('\p{Blk=Tirhuta:=}');
    Error('\P{Blk=Tirhuta:=}');
    Expect(1, 70879, '\p{Blk: tirhuta}', "");
    Expect(0, 70879, '\p{^Blk: tirhuta}', "");
    Expect(0, 70879, '\P{Blk: tirhuta}', "");
    Expect(1, 70879, '\P{^Blk: tirhuta}', "");
    Expect(0, 70880, '\p{Blk: tirhuta}', "");
    Expect(1, 70880, '\p{^Blk: tirhuta}', "");
    Expect(1, 70880, '\P{Blk: tirhuta}', "");
    Expect(0, 70880, '\P{^Blk: tirhuta}', "");
    Expect(1, 70879, '\p{Blk= 	Tirhuta}', "");
    Expect(0, 70879, '\p{^Blk= 	Tirhuta}', "");
    Expect(0, 70879, '\P{Blk= 	Tirhuta}', "");
    Expect(1, 70879, '\P{^Blk= 	Tirhuta}', "");
    Expect(0, 70880, '\p{Blk= 	Tirhuta}', "");
    Expect(1, 70880, '\p{^Blk= 	Tirhuta}', "");
    Expect(1, 70880, '\P{Blk= 	Tirhuta}', "");
    Expect(0, 70880, '\P{^Blk= 	Tirhuta}', "");
    Error('\p{Is_Block=-TIRHUTA:=}');
    Error('\P{Is_Block=-TIRHUTA:=}');
    Expect(1, 70879, '\p{Is_Block=tirhuta}', "");
    Expect(0, 70879, '\p{^Is_Block=tirhuta}', "");
    Expect(0, 70879, '\P{Is_Block=tirhuta}', "");
    Expect(1, 70879, '\P{^Is_Block=tirhuta}', "");
    Expect(0, 70880, '\p{Is_Block=tirhuta}', "");
    Expect(1, 70880, '\p{^Is_Block=tirhuta}', "");
    Expect(1, 70880, '\P{Is_Block=tirhuta}', "");
    Expect(0, 70880, '\P{^Is_Block=tirhuta}', "");
    Expect(1, 70879, '\p{Is_Block=	 Tirhuta}', "");
    Expect(0, 70879, '\p{^Is_Block=	 Tirhuta}', "");
    Expect(0, 70879, '\P{Is_Block=	 Tirhuta}', "");
    Expect(1, 70879, '\P{^Is_Block=	 Tirhuta}', "");
    Expect(0, 70880, '\p{Is_Block=	 Tirhuta}', "");
    Expect(1, 70880, '\p{^Is_Block=	 Tirhuta}', "");
    Expect(1, 70880, '\P{Is_Block=	 Tirhuta}', "");
    Expect(0, 70880, '\P{^Is_Block=	 Tirhuta}', "");
    Error('\p{Is_Blk=/a/		tirhuta}');
    Error('\P{Is_Blk=/a/		tirhuta}');
    Expect(1, 70879, '\p{Is_Blk=tirhuta}', "");
    Expect(0, 70879, '\p{^Is_Blk=tirhuta}', "");
    Expect(0, 70879, '\P{Is_Blk=tirhuta}', "");
    Expect(1, 70879, '\P{^Is_Blk=tirhuta}', "");
    Expect(0, 70880, '\p{Is_Blk=tirhuta}', "");
    Expect(1, 70880, '\p{^Is_Blk=tirhuta}', "");
    Expect(1, 70880, '\P{Is_Blk=tirhuta}', "");
    Expect(0, 70880, '\P{^Is_Blk=tirhuta}', "");
    Expect(1, 70879, '\p{Is_Blk=	-tirhuta}', "");
    Expect(0, 70879, '\p{^Is_Blk=	-tirhuta}', "");
    Expect(0, 70879, '\P{Is_Blk=	-tirhuta}', "");
    Expect(1, 70879, '\P{^Is_Blk=	-tirhuta}', "");
    Expect(0, 70880, '\p{Is_Blk=	-tirhuta}', "");
    Expect(1, 70880, '\p{^Is_Blk=	-tirhuta}', "");
    Expect(1, 70880, '\P{Is_Blk=	-tirhuta}', "");
    Expect(0, 70880, '\P{^Is_Blk=	-tirhuta}', "");
    Error('\p{Block:	/a/- Transport_And_map_Symbols}');
    Error('\P{Block:	/a/- Transport_And_map_Symbols}');
    Expect(1, 128767, '\p{Block=transportandmapsymbols}', "");
    Expect(0, 128767, '\p{^Block=transportandmapsymbols}', "");
    Expect(0, 128767, '\P{Block=transportandmapsymbols}', "");
    Expect(1, 128767, '\P{^Block=transportandmapsymbols}', "");
    Expect(0, 128768, '\p{Block=transportandmapsymbols}', "");
    Expect(1, 128768, '\p{^Block=transportandmapsymbols}', "");
    Expect(1, 128768, '\P{Block=transportandmapsymbols}', "");
    Expect(0, 128768, '\P{^Block=transportandmapsymbols}', "");
    Expect(1, 128767, '\p{Block=-TRANSPORT_and_MAP_Symbols}', "");
    Expect(0, 128767, '\p{^Block=-TRANSPORT_and_MAP_Symbols}', "");
    Expect(0, 128767, '\P{Block=-TRANSPORT_and_MAP_Symbols}', "");
    Expect(1, 128767, '\P{^Block=-TRANSPORT_and_MAP_Symbols}', "");
    Expect(0, 128768, '\p{Block=-TRANSPORT_and_MAP_Symbols}', "");
    Expect(1, 128768, '\p{^Block=-TRANSPORT_and_MAP_Symbols}', "");
    Expect(1, 128768, '\P{Block=-TRANSPORT_and_MAP_Symbols}', "");
    Expect(0, 128768, '\P{^Block=-TRANSPORT_and_MAP_Symbols}', "");
    Error('\p{Blk=/a/_transport_AND_Map}');
    Error('\P{Blk=/a/_transport_AND_Map}');
    Expect(1, 128767, '\p{Blk=transportandmap}', "");
    Expect(0, 128767, '\p{^Blk=transportandmap}', "");
    Expect(0, 128767, '\P{Blk=transportandmap}', "");
    Expect(1, 128767, '\P{^Blk=transportandmap}', "");
    Expect(0, 128768, '\p{Blk=transportandmap}', "");
    Expect(1, 128768, '\p{^Blk=transportandmap}', "");
    Expect(1, 128768, '\P{Blk=transportandmap}', "");
    Expect(0, 128768, '\P{^Blk=transportandmap}', "");
    Expect(1, 128767, '\p{Blk=-	Transport_And_MAP}', "");
    Expect(0, 128767, '\p{^Blk=-	Transport_And_MAP}', "");
    Expect(0, 128767, '\P{Blk=-	Transport_And_MAP}', "");
    Expect(1, 128767, '\P{^Blk=-	Transport_And_MAP}', "");
    Expect(0, 128768, '\p{Blk=-	Transport_And_MAP}', "");
    Expect(1, 128768, '\p{^Blk=-	Transport_And_MAP}', "");
    Expect(1, 128768, '\P{Blk=-	Transport_And_MAP}', "");
    Expect(0, 128768, '\P{^Blk=-	Transport_And_MAP}', "");
    Error('\p{Is_Block=_	TRANSPORT_And_map_Symbols:=}');
    Error('\P{Is_Block=_	TRANSPORT_And_map_Symbols:=}');
    Expect(1, 128767, '\p{Is_Block=transportandmapsymbols}', "");
    Expect(0, 128767, '\p{^Is_Block=transportandmapsymbols}', "");
    Expect(0, 128767, '\P{Is_Block=transportandmapsymbols}', "");
    Expect(1, 128767, '\P{^Is_Block=transportandmapsymbols}', "");
    Expect(0, 128768, '\p{Is_Block=transportandmapsymbols}', "");
    Expect(1, 128768, '\p{^Is_Block=transportandmapsymbols}', "");
    Expect(1, 128768, '\P{Is_Block=transportandmapsymbols}', "");
    Expect(0, 128768, '\P{^Is_Block=transportandmapsymbols}', "");
    Expect(1, 128767, '\p{Is_Block:		transport_And_Map_Symbols}', "");
    Expect(0, 128767, '\p{^Is_Block:		transport_And_Map_Symbols}', "");
    Expect(0, 128767, '\P{Is_Block:		transport_And_Map_Symbols}', "");
    Expect(1, 128767, '\P{^Is_Block:		transport_And_Map_Symbols}', "");
    Expect(0, 128768, '\p{Is_Block:		transport_And_Map_Symbols}', "");
    Expect(1, 128768, '\p{^Is_Block:		transport_And_Map_Symbols}', "");
    Expect(1, 128768, '\P{Is_Block:		transport_And_Map_Symbols}', "");
    Expect(0, 128768, '\P{^Is_Block:		transport_And_Map_Symbols}', "");
    Error('\p{Is_Blk= _Transport_AND_MAP/a/}');
    Error('\P{Is_Blk= _Transport_AND_MAP/a/}');
    Expect(1, 128767, '\p{Is_Blk=transportandmap}', "");
    Expect(0, 128767, '\p{^Is_Blk=transportandmap}', "");
    Expect(0, 128767, '\P{Is_Blk=transportandmap}', "");
    Expect(1, 128767, '\P{^Is_Blk=transportandmap}', "");
    Expect(0, 128768, '\p{Is_Blk=transportandmap}', "");
    Expect(1, 128768, '\p{^Is_Blk=transportandmap}', "");
    Expect(1, 128768, '\P{Is_Blk=transportandmap}', "");
    Expect(0, 128768, '\P{^Is_Blk=transportandmap}', "");
    Expect(1, 128767, '\p{Is_Blk=__transport_and_map}', "");
    Expect(0, 128767, '\p{^Is_Blk=__transport_and_map}', "");
    Expect(0, 128767, '\P{Is_Blk=__transport_and_map}', "");
    Expect(1, 128767, '\P{^Is_Blk=__transport_and_map}', "");
    Expect(0, 128768, '\p{Is_Blk=__transport_and_map}', "");
    Expect(1, 128768, '\p{^Is_Blk=__transport_and_map}', "");
    Expect(1, 128768, '\P{Is_Blk=__transport_and_map}', "");
    Expect(0, 128768, '\P{^Is_Blk=__transport_and_map}', "");
    Error('\p{Block=_ Unified_Canadian_Aboriginal_syllabics:=}');
    Error('\P{Block=_ Unified_Canadian_Aboriginal_syllabics:=}');
    Expect(1, 5759, '\p{Block: unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\p{^Block: unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\P{Block: unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\P{^Block: unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\p{Block: unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\p{^Block: unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\P{Block: unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\P{^Block: unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\p{Block= Unified_canadian_aboriginal_syllabics}', "");
    Expect(0, 5759, '\p{^Block= Unified_canadian_aboriginal_syllabics}', "");
    Expect(0, 5759, '\P{Block= Unified_canadian_aboriginal_syllabics}', "");
    Expect(1, 5759, '\P{^Block= Unified_canadian_aboriginal_syllabics}', "");
    Expect(0, 5760, '\p{Block= Unified_canadian_aboriginal_syllabics}', "");
    Expect(1, 5760, '\p{^Block= Unified_canadian_aboriginal_syllabics}', "");
    Expect(1, 5760, '\P{Block= Unified_canadian_aboriginal_syllabics}', "");
    Expect(0, 5760, '\P{^Block= Unified_canadian_aboriginal_syllabics}', "");
    Error('\p{Blk=_ ucas/a/}');
    Error('\P{Blk=_ ucas/a/}');
    Expect(1, 5759, '\p{Blk=ucas}', "");
    Expect(0, 5759, '\p{^Blk=ucas}', "");
    Expect(0, 5759, '\P{Blk=ucas}', "");
    Expect(1, 5759, '\P{^Blk=ucas}', "");
    Expect(0, 5760, '\p{Blk=ucas}', "");
    Expect(1, 5760, '\p{^Blk=ucas}', "");
    Expect(1, 5760, '\P{Blk=ucas}', "");
    Expect(0, 5760, '\P{^Blk=ucas}', "");
    Expect(1, 5759, '\p{Blk:   	 ucas}', "");
    Expect(0, 5759, '\p{^Blk:   	 ucas}', "");
    Expect(0, 5759, '\P{Blk:   	 ucas}', "");
    Expect(1, 5759, '\P{^Blk:   	 ucas}', "");
    Expect(0, 5760, '\p{Blk:   	 ucas}', "");
    Expect(1, 5760, '\p{^Blk:   	 ucas}', "");
    Expect(1, 5760, '\P{Blk:   	 ucas}', "");
    Expect(0, 5760, '\P{^Blk:   	 ucas}', "");
    Error('\p{Is_Block=--Canadian_syllabics:=}');
    Error('\P{Is_Block=--Canadian_syllabics:=}');
    Expect(1, 5759, '\p{Is_Block:canadiansyllabics}', "");
    Expect(0, 5759, '\p{^Is_Block:canadiansyllabics}', "");
    Expect(0, 5759, '\P{Is_Block:canadiansyllabics}', "");
    Expect(1, 5759, '\P{^Is_Block:canadiansyllabics}', "");
    Expect(0, 5760, '\p{Is_Block:canadiansyllabics}', "");
    Expect(1, 5760, '\p{^Is_Block:canadiansyllabics}', "");
    Expect(1, 5760, '\P{Is_Block:canadiansyllabics}', "");
    Expect(0, 5760, '\P{^Is_Block:canadiansyllabics}', "");
    Expect(1, 5759, '\p{Is_Block=	 Canadian_syllabics}', "");
    Expect(0, 5759, '\p{^Is_Block=	 Canadian_syllabics}', "");
    Expect(0, 5759, '\P{Is_Block=	 Canadian_syllabics}', "");
    Expect(1, 5759, '\P{^Is_Block=	 Canadian_syllabics}', "");
    Expect(0, 5760, '\p{Is_Block=	 Canadian_syllabics}', "");
    Expect(1, 5760, '\p{^Is_Block=	 Canadian_syllabics}', "");
    Expect(1, 5760, '\P{Is_Block=	 Canadian_syllabics}', "");
    Expect(0, 5760, '\P{^Is_Block=	 Canadian_syllabics}', "");
    Error('\p{Is_Blk=	:=UNIFIED_Canadian_Aboriginal_syllabics}');
    Error('\P{Is_Blk=	:=UNIFIED_Canadian_Aboriginal_syllabics}');
    Expect(1, 5759, '\p{Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\p{^Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\P{Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\P{^Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\p{Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\p{^Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\P{Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\P{^Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\p{Is_Blk=_ unified_Canadian_aboriginal_SYLLABICS}', "");
    Expect(0, 5759, '\p{^Is_Blk=_ unified_Canadian_aboriginal_SYLLABICS}', "");
    Expect(0, 5759, '\P{Is_Blk=_ unified_Canadian_aboriginal_SYLLABICS}', "");
    Expect(1, 5759, '\P{^Is_Blk=_ unified_Canadian_aboriginal_SYLLABICS}', "");
    Expect(0, 5760, '\p{Is_Blk=_ unified_Canadian_aboriginal_SYLLABICS}', "");
    Expect(1, 5760, '\p{^Is_Blk=_ unified_Canadian_aboriginal_SYLLABICS}', "");
    Expect(1, 5760, '\P{Is_Blk=_ unified_Canadian_aboriginal_SYLLABICS}', "");
    Expect(0, 5760, '\P{^Is_Blk=_ unified_Canadian_aboriginal_SYLLABICS}', "");
    Error('\p{Block= /a/unified_canadian_Aboriginal_syllabics_Extended}');
    Error('\P{Block= /a/unified_canadian_Aboriginal_syllabics_Extended}');
    Expect(1, 6399, '\p{Block:	unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\p{^Block:	unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\P{Block:	unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\P{^Block:	unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\p{Block:	unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\p{^Block:	unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\P{Block:	unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\P{^Block:	unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\p{Block=__UNIFIED_canadian_aboriginal_SYLLABICS_EXTENDED}', "");
    Expect(0, 6399, '\p{^Block=__UNIFIED_canadian_aboriginal_SYLLABICS_EXTENDED}', "");
    Expect(0, 6399, '\P{Block=__UNIFIED_canadian_aboriginal_SYLLABICS_EXTENDED}', "");
    Expect(1, 6399, '\P{^Block=__UNIFIED_canadian_aboriginal_SYLLABICS_EXTENDED}', "");
    Expect(0, 6400, '\p{Block=__UNIFIED_canadian_aboriginal_SYLLABICS_EXTENDED}', "");
    Expect(1, 6400, '\p{^Block=__UNIFIED_canadian_aboriginal_SYLLABICS_EXTENDED}', "");
    Expect(1, 6400, '\P{Block=__UNIFIED_canadian_aboriginal_SYLLABICS_EXTENDED}', "");
    Expect(0, 6400, '\P{^Block=__UNIFIED_canadian_aboriginal_SYLLABICS_EXTENDED}', "");
    Error('\p{Blk=:=	UCAS_ext}');
    Error('\P{Blk=:=	UCAS_ext}');
    Expect(1, 6399, '\p{Blk=ucasext}', "");
    Expect(0, 6399, '\p{^Blk=ucasext}', "");
    Expect(0, 6399, '\P{Blk=ucasext}', "");
    Expect(1, 6399, '\P{^Blk=ucasext}', "");
    Expect(0, 6400, '\p{Blk=ucasext}', "");
    Expect(1, 6400, '\p{^Blk=ucasext}', "");
    Expect(1, 6400, '\P{Blk=ucasext}', "");
    Expect(0, 6400, '\P{^Blk=ucasext}', "");
    Expect(1, 6399, '\p{Blk=-ucas_Ext}', "");
    Expect(0, 6399, '\p{^Blk=-ucas_Ext}', "");
    Expect(0, 6399, '\P{Blk=-ucas_Ext}', "");
    Expect(1, 6399, '\P{^Blk=-ucas_Ext}', "");
    Expect(0, 6400, '\p{Blk=-ucas_Ext}', "");
    Expect(1, 6400, '\p{^Blk=-ucas_Ext}', "");
    Expect(1, 6400, '\P{Blk=-ucas_Ext}', "");
    Expect(0, 6400, '\P{^Blk=-ucas_Ext}', "");
    Error('\p{Is_Block=- Unified_canadian_aboriginal_syllabics_Extended:=}');
    Error('\P{Is_Block=- Unified_canadian_aboriginal_syllabics_Extended:=}');
    Expect(1, 6399, '\p{Is_Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\p{^Is_Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\P{Is_Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\P{^Is_Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\p{Is_Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\p{^Is_Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\P{Is_Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\P{^Is_Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\p{Is_Block=- Unified_Canadian_Aboriginal_Syllabics_Extended}', "");
    Expect(0, 6399, '\p{^Is_Block=- Unified_Canadian_Aboriginal_Syllabics_Extended}', "");
    Expect(0, 6399, '\P{Is_Block=- Unified_Canadian_Aboriginal_Syllabics_Extended}', "");
    Expect(1, 6399, '\P{^Is_Block=- Unified_Canadian_Aboriginal_Syllabics_Extended}', "");
    Expect(0, 6400, '\p{Is_Block=- Unified_Canadian_Aboriginal_Syllabics_Extended}', "");
    Expect(1, 6400, '\p{^Is_Block=- Unified_Canadian_Aboriginal_Syllabics_Extended}', "");
    Expect(1, 6400, '\P{Is_Block=- Unified_Canadian_Aboriginal_Syllabics_Extended}', "");
    Expect(0, 6400, '\P{^Is_Block=- Unified_Canadian_Aboriginal_Syllabics_Extended}', "");
    Error('\p{Is_Blk=ucas_EXT/a/}');
    Error('\P{Is_Blk=ucas_EXT/a/}');
    Expect(1, 6399, '\p{Is_Blk=ucasext}', "");
    Expect(0, 6399, '\p{^Is_Blk=ucasext}', "");
    Expect(0, 6399, '\P{Is_Blk=ucasext}', "");
    Expect(1, 6399, '\P{^Is_Blk=ucasext}', "");
    Expect(0, 6400, '\p{Is_Blk=ucasext}', "");
    Expect(1, 6400, '\p{^Is_Blk=ucasext}', "");
    Expect(1, 6400, '\P{Is_Blk=ucasext}', "");
    Expect(0, 6400, '\P{^Is_Blk=ucasext}', "");
    Expect(1, 6399, '\p{Is_Blk=	 UCAS_ext}', "");
    Expect(0, 6399, '\p{^Is_Blk=	 UCAS_ext}', "");
    Expect(0, 6399, '\P{Is_Blk=	 UCAS_ext}', "");
    Expect(1, 6399, '\P{^Is_Blk=	 UCAS_ext}', "");
    Expect(0, 6400, '\p{Is_Blk=	 UCAS_ext}', "");
    Expect(1, 6400, '\p{^Is_Blk=	 UCAS_ext}', "");
    Expect(1, 6400, '\P{Is_Blk=	 UCAS_ext}', "");
    Expect(0, 6400, '\P{^Is_Blk=	 UCAS_ext}', "");
    Error('\p{Block=:= -Ugaritic}');
    Error('\P{Block=:= -Ugaritic}');
    Expect(1, 66463, '\p{Block=ugaritic}', "");
    Expect(0, 66463, '\p{^Block=ugaritic}', "");
    Expect(0, 66463, '\P{Block=ugaritic}', "");
    Expect(1, 66463, '\P{^Block=ugaritic}', "");
    Expect(0, 66464, '\p{Block=ugaritic}', "");
    Expect(1, 66464, '\p{^Block=ugaritic}', "");
    Expect(1, 66464, '\P{Block=ugaritic}', "");
    Expect(0, 66464, '\P{^Block=ugaritic}', "");
    Expect(1, 66463, '\p{Block= _UGARITIC}', "");
    Expect(0, 66463, '\p{^Block= _UGARITIC}', "");
    Expect(0, 66463, '\P{Block= _UGARITIC}', "");
    Expect(1, 66463, '\P{^Block= _UGARITIC}', "");
    Expect(0, 66464, '\p{Block= _UGARITIC}', "");
    Expect(1, 66464, '\p{^Block= _UGARITIC}', "");
    Expect(1, 66464, '\P{Block= _UGARITIC}', "");
    Expect(0, 66464, '\P{^Block= _UGARITIC}', "");
    Error('\p{Blk= :=Ugaritic}');
    Error('\P{Blk= :=Ugaritic}');
    Expect(1, 66463, '\p{Blk=ugaritic}', "");
    Expect(0, 66463, '\p{^Blk=ugaritic}', "");
    Expect(0, 66463, '\P{Blk=ugaritic}', "");
    Expect(1, 66463, '\P{^Blk=ugaritic}', "");
    Expect(0, 66464, '\p{Blk=ugaritic}', "");
    Expect(1, 66464, '\p{^Blk=ugaritic}', "");
    Expect(1, 66464, '\P{Blk=ugaritic}', "");
    Expect(0, 66464, '\P{^Blk=ugaritic}', "");
    Expect(1, 66463, '\p{Blk:Ugaritic}', "");
    Expect(0, 66463, '\p{^Blk:Ugaritic}', "");
    Expect(0, 66463, '\P{Blk:Ugaritic}', "");
    Expect(1, 66463, '\P{^Blk:Ugaritic}', "");
    Expect(0, 66464, '\p{Blk:Ugaritic}', "");
    Expect(1, 66464, '\p{^Blk:Ugaritic}', "");
    Expect(1, 66464, '\P{Blk:Ugaritic}', "");
    Expect(0, 66464, '\P{^Blk:Ugaritic}', "");
    Error('\p{Is_Block=:=__Ugaritic}');
    Error('\P{Is_Block=:=__Ugaritic}');
    Expect(1, 66463, '\p{Is_Block=ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Block=ugaritic}', "");
    Expect(0, 66463, '\P{Is_Block=ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Block=ugaritic}', "");
    Expect(0, 66464, '\p{Is_Block=ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Block=ugaritic}', "");
    Expect(1, 66464, '\P{Is_Block=ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Block=ugaritic}', "");
    Expect(1, 66463, '\p{Is_Block= ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Block= ugaritic}', "");
    Expect(0, 66463, '\P{Is_Block= ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Block= ugaritic}', "");
    Expect(0, 66464, '\p{Is_Block= ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Block= ugaritic}', "");
    Expect(1, 66464, '\P{Is_Block= ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Block= ugaritic}', "");
    Error('\p{Is_Blk::=_-UGARITIC}');
    Error('\P{Is_Blk::=_-UGARITIC}');
    Expect(1, 66463, '\p{Is_Blk=ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Blk=ugaritic}', "");
    Expect(0, 66463, '\P{Is_Blk=ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Blk=ugaritic}', "");
    Expect(0, 66464, '\p{Is_Blk=ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Blk=ugaritic}', "");
    Expect(1, 66464, '\P{Is_Blk=ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Blk=ugaritic}', "");
    Expect(1, 66463, '\p{Is_Blk= -Ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Blk= -Ugaritic}', "");
    Expect(0, 66463, '\P{Is_Blk= -Ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Blk= -Ugaritic}', "");
    Expect(0, 66464, '\p{Is_Blk= -Ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Blk= -Ugaritic}', "");
    Expect(1, 66464, '\P{Is_Blk= -Ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Blk= -Ugaritic}', "");
    Error('\p{Block=_-VAI:=}');
    Error('\P{Block=_-VAI:=}');
    Expect(1, 42559, '\p{Block:vai}', "");
    Expect(0, 42559, '\p{^Block:vai}', "");
    Expect(0, 42559, '\P{Block:vai}', "");
    Expect(1, 42559, '\P{^Block:vai}', "");
    Expect(0, 42560, '\p{Block:vai}', "");
    Expect(1, 42560, '\p{^Block:vai}', "");
    Expect(1, 42560, '\P{Block:vai}', "");
    Expect(0, 42560, '\P{^Block:vai}', "");
    Expect(1, 42559, '\p{Block= Vai}', "");
    Expect(0, 42559, '\p{^Block= Vai}', "");
    Expect(0, 42559, '\P{Block= Vai}', "");
    Expect(1, 42559, '\P{^Block= Vai}', "");
    Expect(0, 42560, '\p{Block= Vai}', "");
    Expect(1, 42560, '\p{^Block= Vai}', "");
    Expect(1, 42560, '\P{Block= Vai}', "");
    Expect(0, 42560, '\P{^Block= Vai}', "");
    Error('\p{Blk=/a/-	Vai}');
    Error('\P{Blk=/a/-	Vai}');
    Expect(1, 42559, '\p{Blk=vai}', "");
    Expect(0, 42559, '\p{^Blk=vai}', "");
    Expect(0, 42559, '\P{Blk=vai}', "");
    Expect(1, 42559, '\P{^Blk=vai}', "");
    Expect(0, 42560, '\p{Blk=vai}', "");
    Expect(1, 42560, '\p{^Blk=vai}', "");
    Expect(1, 42560, '\P{Blk=vai}', "");
    Expect(0, 42560, '\P{^Blk=vai}', "");
    Expect(1, 42559, '\p{Blk: 		Vai}', "");
    Expect(0, 42559, '\p{^Blk: 		Vai}', "");
    Expect(0, 42559, '\P{Blk: 		Vai}', "");
    Expect(1, 42559, '\P{^Blk: 		Vai}', "");
    Expect(0, 42560, '\p{Blk: 		Vai}', "");
    Expect(1, 42560, '\p{^Blk: 		Vai}', "");
    Expect(1, 42560, '\P{Blk: 		Vai}', "");
    Expect(0, 42560, '\P{^Blk: 		Vai}', "");
    Error('\p{Is_Block=_:=VAI}');
    Error('\P{Is_Block=_:=VAI}');
    Expect(1, 42559, '\p{Is_Block=vai}', "");
    Expect(0, 42559, '\p{^Is_Block=vai}', "");
    Expect(0, 42559, '\P{Is_Block=vai}', "");
    Expect(1, 42559, '\P{^Is_Block=vai}', "");
    Expect(0, 42560, '\p{Is_Block=vai}', "");
    Expect(1, 42560, '\p{^Is_Block=vai}', "");
    Expect(1, 42560, '\P{Is_Block=vai}', "");
    Expect(0, 42560, '\P{^Is_Block=vai}', "");
    Expect(1, 42559, '\p{Is_Block=-VAI}', "");
    Expect(0, 42559, '\p{^Is_Block=-VAI}', "");
    Expect(0, 42559, '\P{Is_Block=-VAI}', "");
    Expect(1, 42559, '\P{^Is_Block=-VAI}', "");
    Expect(0, 42560, '\p{Is_Block=-VAI}', "");
    Expect(1, 42560, '\p{^Is_Block=-VAI}', "");
    Expect(1, 42560, '\P{Is_Block=-VAI}', "");
    Expect(0, 42560, '\P{^Is_Block=-VAI}', "");
    Error('\p{Is_Blk: :=	 Vai}');
    Error('\P{Is_Blk: :=	 Vai}');
    Expect(1, 42559, '\p{Is_Blk=vai}', "");
    Expect(0, 42559, '\p{^Is_Blk=vai}', "");
    Expect(0, 42559, '\P{Is_Blk=vai}', "");
    Expect(1, 42559, '\P{^Is_Blk=vai}', "");
    Expect(0, 42560, '\p{Is_Blk=vai}', "");
    Expect(1, 42560, '\p{^Is_Blk=vai}', "");
    Expect(1, 42560, '\P{Is_Blk=vai}', "");
    Expect(0, 42560, '\P{^Is_Blk=vai}', "");
    Expect(1, 42559, '\p{Is_Blk=--VAI}', "");
    Expect(0, 42559, '\p{^Is_Blk=--VAI}', "");
    Expect(0, 42559, '\P{Is_Blk=--VAI}', "");
    Expect(1, 42559, '\P{^Is_Blk=--VAI}', "");
    Expect(0, 42560, '\p{Is_Blk=--VAI}', "");
    Expect(1, 42560, '\p{^Is_Blk=--VAI}', "");
    Expect(1, 42560, '\P{Is_Blk=--VAI}', "");
    Expect(0, 42560, '\P{^Is_Blk=--VAI}', "");
    Error('\p{Block=/a/VEDIC_Extensions}');
    Error('\P{Block=/a/VEDIC_Extensions}');
    Expect(1, 7423, '\p{Block=vedicextensions}', "");
    Expect(0, 7423, '\p{^Block=vedicextensions}', "");
    Expect(0, 7423, '\P{Block=vedicextensions}', "");
    Expect(1, 7423, '\P{^Block=vedicextensions}', "");
    Expect(0, 7424, '\p{Block=vedicextensions}', "");
    Expect(1, 7424, '\p{^Block=vedicextensions}', "");
    Expect(1, 7424, '\P{Block=vedicextensions}', "");
    Expect(0, 7424, '\P{^Block=vedicextensions}', "");
    Expect(1, 7423, '\p{Block= 	vedic_extensions}', "");
    Expect(0, 7423, '\p{^Block= 	vedic_extensions}', "");
    Expect(0, 7423, '\P{Block= 	vedic_extensions}', "");
    Expect(1, 7423, '\P{^Block= 	vedic_extensions}', "");
    Expect(0, 7424, '\p{Block= 	vedic_extensions}', "");
    Expect(1, 7424, '\p{^Block= 	vedic_extensions}', "");
    Expect(1, 7424, '\P{Block= 	vedic_extensions}', "");
    Expect(0, 7424, '\P{^Block= 	vedic_extensions}', "");
    Error('\p{Blk=:=  vedic_Ext}');
    Error('\P{Blk=:=  vedic_Ext}');
    Expect(1, 7423, '\p{Blk=vedicext}', "");
    Expect(0, 7423, '\p{^Blk=vedicext}', "");
    Expect(0, 7423, '\P{Blk=vedicext}', "");
    Expect(1, 7423, '\P{^Blk=vedicext}', "");
    Expect(0, 7424, '\p{Blk=vedicext}', "");
    Expect(1, 7424, '\p{^Blk=vedicext}', "");
    Expect(1, 7424, '\P{Blk=vedicext}', "");
    Expect(0, 7424, '\P{^Blk=vedicext}', "");
    Expect(1, 7423, '\p{Blk= Vedic_Ext}', "");
    Expect(0, 7423, '\p{^Blk= Vedic_Ext}', "");
    Expect(0, 7423, '\P{Blk= Vedic_Ext}', "");
    Expect(1, 7423, '\P{^Blk= Vedic_Ext}', "");
    Expect(0, 7424, '\p{Blk= Vedic_Ext}', "");
    Expect(1, 7424, '\p{^Blk= Vedic_Ext}', "");
    Expect(1, 7424, '\P{Blk= Vedic_Ext}', "");
    Expect(0, 7424, '\P{^Blk= Vedic_Ext}', "");
    Error('\p{Is_Block=/a/_	Vedic_Extensions}');
    Error('\P{Is_Block=/a/_	Vedic_Extensions}');
    Expect(1, 7423, '\p{Is_Block=vedicextensions}', "");
    Expect(0, 7423, '\p{^Is_Block=vedicextensions}', "");
    Expect(0, 7423, '\P{Is_Block=vedicextensions}', "");
    Expect(1, 7423, '\P{^Is_Block=vedicextensions}', "");
    Expect(0, 7424, '\p{Is_Block=vedicextensions}', "");
    Expect(1, 7424, '\p{^Is_Block=vedicextensions}', "");
    Expect(1, 7424, '\P{Is_Block=vedicextensions}', "");
    Expect(0, 7424, '\P{^Is_Block=vedicextensions}', "");
    Expect(1, 7423, '\p{Is_Block: _Vedic_Extensions}', "");
    Expect(0, 7423, '\p{^Is_Block: _Vedic_Extensions}', "");
    Expect(0, 7423, '\P{Is_Block: _Vedic_Extensions}', "");
    Expect(1, 7423, '\P{^Is_Block: _Vedic_Extensions}', "");
    Expect(0, 7424, '\p{Is_Block: _Vedic_Extensions}', "");
    Expect(1, 7424, '\p{^Is_Block: _Vedic_Extensions}', "");
    Expect(1, 7424, '\P{Is_Block: _Vedic_Extensions}', "");
    Expect(0, 7424, '\P{^Is_Block: _Vedic_Extensions}', "");
    Error('\p{Is_Blk=_-vedic_ext/a/}');
    Error('\P{Is_Blk=_-vedic_ext/a/}');
    Expect(1, 7423, '\p{Is_Blk=vedicext}', "");
    Expect(0, 7423, '\p{^Is_Blk=vedicext}', "");
    Expect(0, 7423, '\P{Is_Blk=vedicext}', "");
    Expect(1, 7423, '\P{^Is_Blk=vedicext}', "");
    Expect(0, 7424, '\p{Is_Blk=vedicext}', "");
    Expect(1, 7424, '\p{^Is_Blk=vedicext}', "");
    Expect(1, 7424, '\P{Is_Blk=vedicext}', "");
    Expect(0, 7424, '\P{^Is_Blk=vedicext}', "");
    Expect(1, 7423, '\p{Is_Blk=-_VEDIC_EXT}', "");
    Expect(0, 7423, '\p{^Is_Blk=-_VEDIC_EXT}', "");
    Expect(0, 7423, '\P{Is_Blk=-_VEDIC_EXT}', "");
    Expect(1, 7423, '\P{^Is_Blk=-_VEDIC_EXT}', "");
    Expect(0, 7424, '\p{Is_Blk=-_VEDIC_EXT}', "");
    Expect(1, 7424, '\p{^Is_Blk=-_VEDIC_EXT}', "");
    Expect(1, 7424, '\P{Is_Blk=-_VEDIC_EXT}', "");
    Expect(0, 7424, '\P{^Is_Blk=-_VEDIC_EXT}', "");
    Error('\p{Block= 	Vertical_Forms/a/}');
    Error('\P{Block= 	Vertical_Forms/a/}');
    Expect(1, 65055, '\p{Block=verticalforms}', "");
    Expect(0, 65055, '\p{^Block=verticalforms}', "");
    Expect(0, 65055, '\P{Block=verticalforms}', "");
    Expect(1, 65055, '\P{^Block=verticalforms}', "");
    Expect(0, 65056, '\p{Block=verticalforms}', "");
    Expect(1, 65056, '\p{^Block=verticalforms}', "");
    Expect(1, 65056, '\P{Block=verticalforms}', "");
    Expect(0, 65056, '\P{^Block=verticalforms}', "");
    Expect(1, 65055, '\p{Block=_ Vertical_Forms}', "");
    Expect(0, 65055, '\p{^Block=_ Vertical_Forms}', "");
    Expect(0, 65055, '\P{Block=_ Vertical_Forms}', "");
    Expect(1, 65055, '\P{^Block=_ Vertical_Forms}', "");
    Expect(0, 65056, '\p{Block=_ Vertical_Forms}', "");
    Expect(1, 65056, '\p{^Block=_ Vertical_Forms}', "");
    Expect(1, 65056, '\P{Block=_ Vertical_Forms}', "");
    Expect(0, 65056, '\P{^Block=_ Vertical_Forms}', "");
    Error('\p{Blk=__Vertical_FORMS:=}');
    Error('\P{Blk=__Vertical_FORMS:=}');
    Expect(1, 65055, '\p{Blk:   verticalforms}', "");
    Expect(0, 65055, '\p{^Blk:   verticalforms}', "");
    Expect(0, 65055, '\P{Blk:   verticalforms}', "");
    Expect(1, 65055, '\P{^Blk:   verticalforms}', "");
    Expect(0, 65056, '\p{Blk:   verticalforms}', "");
    Expect(1, 65056, '\p{^Blk:   verticalforms}', "");
    Expect(1, 65056, '\P{Blk:   verticalforms}', "");
    Expect(0, 65056, '\P{^Blk:   verticalforms}', "");
    Expect(1, 65055, '\p{Blk=_Vertical_FORMS}', "");
    Expect(0, 65055, '\p{^Blk=_Vertical_FORMS}', "");
    Expect(0, 65055, '\P{Blk=_Vertical_FORMS}', "");
    Expect(1, 65055, '\P{^Blk=_Vertical_FORMS}', "");
    Expect(0, 65056, '\p{Blk=_Vertical_FORMS}', "");
    Expect(1, 65056, '\p{^Blk=_Vertical_FORMS}', "");
    Expect(1, 65056, '\P{Blk=_Vertical_FORMS}', "");
    Expect(0, 65056, '\P{^Blk=_Vertical_FORMS}', "");
    Error('\p{Is_Block=_/a/Vertical_FORMS}');
    Error('\P{Is_Block=_/a/Vertical_FORMS}');
    Expect(1, 65055, '\p{Is_Block=verticalforms}', "");
    Expect(0, 65055, '\p{^Is_Block=verticalforms}', "");
    Expect(0, 65055, '\P{Is_Block=verticalforms}', "");
    Expect(1, 65055, '\P{^Is_Block=verticalforms}', "");
    Expect(0, 65056, '\p{Is_Block=verticalforms}', "");
    Expect(1, 65056, '\p{^Is_Block=verticalforms}', "");
    Expect(1, 65056, '\P{Is_Block=verticalforms}', "");
    Expect(0, 65056, '\P{^Is_Block=verticalforms}', "");
    Expect(1, 65055, '\p{Is_Block=	 Vertical_forms}', "");
    Expect(0, 65055, '\p{^Is_Block=	 Vertical_forms}', "");
    Expect(0, 65055, '\P{Is_Block=	 Vertical_forms}', "");
    Expect(1, 65055, '\P{^Is_Block=	 Vertical_forms}', "");
    Expect(0, 65056, '\p{Is_Block=	 Vertical_forms}', "");
    Expect(1, 65056, '\p{^Is_Block=	 Vertical_forms}', "");
    Expect(1, 65056, '\P{Is_Block=	 Vertical_forms}', "");
    Expect(0, 65056, '\P{^Is_Block=	 Vertical_forms}', "");
    Error('\p{Is_Blk=  VERTICAL_forms/a/}');
    Error('\P{Is_Blk=  VERTICAL_forms/a/}');
    Expect(1, 65055, '\p{Is_Blk: verticalforms}', "");
    Expect(0, 65055, '\p{^Is_Blk: verticalforms}', "");
    Expect(0, 65055, '\P{Is_Blk: verticalforms}', "");
    Expect(1, 65055, '\P{^Is_Blk: verticalforms}', "");
    Expect(0, 65056, '\p{Is_Blk: verticalforms}', "");
    Expect(1, 65056, '\p{^Is_Blk: verticalforms}', "");
    Expect(1, 65056, '\P{Is_Blk: verticalforms}', "");
    Expect(0, 65056, '\P{^Is_Blk: verticalforms}', "");
    Expect(1, 65055, '\p{Is_Blk=_-Vertical_FORMS}', "");
    Expect(0, 65055, '\p{^Is_Blk=_-Vertical_FORMS}', "");
    Expect(0, 65055, '\P{Is_Blk=_-Vertical_FORMS}', "");
    Expect(1, 65055, '\P{^Is_Blk=_-Vertical_FORMS}', "");
    Expect(0, 65056, '\p{Is_Blk=_-Vertical_FORMS}', "");
    Expect(1, 65056, '\p{^Is_Blk=_-Vertical_FORMS}', "");
    Expect(1, 65056, '\P{Is_Blk=_-Vertical_FORMS}', "");
    Expect(0, 65056, '\P{^Is_Blk=_-Vertical_FORMS}', "");
    Error('\p{Block=:=		Variation_SELECTORS}');
    Error('\P{Block=:=		Variation_SELECTORS}');
    Expect(1, 65039, '\p{Block:	variationselectors}', "");
    Expect(0, 65039, '\p{^Block:	variationselectors}', "");
    Expect(0, 65039, '\P{Block:	variationselectors}', "");
    Expect(1, 65039, '\P{^Block:	variationselectors}', "");
    Expect(0, 65040, '\p{Block:	variationselectors}', "");
    Expect(1, 65040, '\p{^Block:	variationselectors}', "");
    Expect(1, 65040, '\P{Block:	variationselectors}', "");
    Expect(0, 65040, '\P{^Block:	variationselectors}', "");
    Expect(1, 65039, '\p{Block=-_variation_Selectors}', "");
    Expect(0, 65039, '\p{^Block=-_variation_Selectors}', "");
    Expect(0, 65039, '\P{Block=-_variation_Selectors}', "");
    Expect(1, 65039, '\P{^Block=-_variation_Selectors}', "");
    Expect(0, 65040, '\p{Block=-_variation_Selectors}', "");
    Expect(1, 65040, '\p{^Block=-_variation_Selectors}', "");
    Expect(1, 65040, '\P{Block=-_variation_Selectors}', "");
    Expect(0, 65040, '\P{^Block=-_variation_Selectors}', "");
    Error('\p{Blk=		vs/a/}');
    Error('\P{Blk=		vs/a/}');
    Expect(1, 65039, '\p{Blk:vs}', "");
    Expect(0, 65039, '\p{^Blk:vs}', "");
    Expect(0, 65039, '\P{Blk:vs}', "");
    Expect(1, 65039, '\P{^Blk:vs}', "");
    Expect(0, 65040, '\p{Blk:vs}', "");
    Expect(1, 65040, '\p{^Blk:vs}', "");
    Expect(1, 65040, '\P{Blk:vs}', "");
    Expect(0, 65040, '\P{^Blk:vs}', "");
    Expect(1, 65039, '\p{Blk=_	vs}', "");
    Expect(0, 65039, '\p{^Blk=_	vs}', "");
    Expect(0, 65039, '\P{Blk=_	vs}', "");
    Expect(1, 65039, '\P{^Blk=_	vs}', "");
    Expect(0, 65040, '\p{Blk=_	vs}', "");
    Expect(1, 65040, '\p{^Blk=_	vs}', "");
    Expect(1, 65040, '\P{Blk=_	vs}', "");
    Expect(0, 65040, '\P{^Blk=_	vs}', "");
    Error('\p{Is_Block=_-variation_selectors:=}');
    Error('\P{Is_Block=_-variation_selectors:=}');
    Expect(1, 65039, '\p{Is_Block=variationselectors}', "");
    Expect(0, 65039, '\p{^Is_Block=variationselectors}', "");
    Expect(0, 65039, '\P{Is_Block=variationselectors}', "");
    Expect(1, 65039, '\P{^Is_Block=variationselectors}', "");
    Expect(0, 65040, '\p{Is_Block=variationselectors}', "");
    Expect(1, 65040, '\p{^Is_Block=variationselectors}', "");
    Expect(1, 65040, '\P{Is_Block=variationselectors}', "");
    Expect(0, 65040, '\P{^Is_Block=variationselectors}', "");
    Expect(1, 65039, '\p{Is_Block=-Variation_SELECTORS}', "");
    Expect(0, 65039, '\p{^Is_Block=-Variation_SELECTORS}', "");
    Expect(0, 65039, '\P{Is_Block=-Variation_SELECTORS}', "");
    Expect(1, 65039, '\P{^Is_Block=-Variation_SELECTORS}', "");
    Expect(0, 65040, '\p{Is_Block=-Variation_SELECTORS}', "");
    Expect(1, 65040, '\p{^Is_Block=-Variation_SELECTORS}', "");
    Expect(1, 65040, '\P{Is_Block=-Variation_SELECTORS}', "");
    Expect(0, 65040, '\P{^Is_Block=-Variation_SELECTORS}', "");
    Error('\p{Is_Blk=/a/-VS}');
    Error('\P{Is_Blk=/a/-VS}');
    Expect(1, 65039, '\p{Is_Blk=vs}', "");
    Expect(0, 65039, '\p{^Is_Blk=vs}', "");
    Expect(0, 65039, '\P{Is_Blk=vs}', "");
    Expect(1, 65039, '\P{^Is_Blk=vs}', "");
    Expect(0, 65040, '\p{Is_Blk=vs}', "");
    Expect(1, 65040, '\p{^Is_Blk=vs}', "");
    Expect(1, 65040, '\P{Is_Blk=vs}', "");
    Expect(0, 65040, '\P{^Is_Blk=vs}', "");
    Expect(1, 65039, '\p{Is_Blk:	-VS}', "");
    Expect(0, 65039, '\p{^Is_Blk:	-VS}', "");
    Expect(0, 65039, '\P{Is_Blk:	-VS}', "");
    Expect(1, 65039, '\P{^Is_Blk:	-VS}', "");
    Expect(0, 65040, '\p{Is_Blk:	-VS}', "");
    Expect(1, 65040, '\p{^Is_Blk:	-VS}', "");
    Expect(1, 65040, '\P{Is_Blk:	-VS}', "");
    Expect(0, 65040, '\P{^Is_Blk:	-VS}', "");
    Error('\p{Block=/a/__Variation_Selectors_Supplement}');
    Error('\P{Block=/a/__Variation_Selectors_Supplement}');
    Expect(1, 917999, '\p{Block=variationselectorssupplement}', "");
    Expect(0, 917999, '\p{^Block=variationselectorssupplement}', "");
    Expect(0, 917999, '\P{Block=variationselectorssupplement}', "");
    Expect(1, 917999, '\P{^Block=variationselectorssupplement}', "");
    Expect(0, 918000, '\p{Block=variationselectorssupplement}', "");
    Expect(1, 918000, '\p{^Block=variationselectorssupplement}', "");
    Expect(1, 918000, '\P{Block=variationselectorssupplement}', "");
    Expect(0, 918000, '\P{^Block=variationselectorssupplement}', "");
    Expect(1, 917999, '\p{Block=-variation_Selectors_SUPPLEMENT}', "");
    Expect(0, 917999, '\p{^Block=-variation_Selectors_SUPPLEMENT}', "");
    Expect(0, 917999, '\P{Block=-variation_Selectors_SUPPLEMENT}', "");
    Expect(1, 917999, '\P{^Block=-variation_Selectors_SUPPLEMENT}', "");
    Expect(0, 918000, '\p{Block=-variation_Selectors_SUPPLEMENT}', "");
    Expect(1, 918000, '\p{^Block=-variation_Selectors_SUPPLEMENT}', "");
    Expect(1, 918000, '\P{Block=-variation_Selectors_SUPPLEMENT}', "");
    Expect(0, 918000, '\P{^Block=-variation_Selectors_SUPPLEMENT}', "");
    Error('\p{Blk=:=	 vs_Sup}');
    Error('\P{Blk=:=	 vs_Sup}');
    Expect(1, 917999, '\p{Blk=vssup}', "");
    Expect(0, 917999, '\p{^Blk=vssup}', "");
    Expect(0, 917999, '\P{Blk=vssup}', "");
    Expect(1, 917999, '\P{^Blk=vssup}', "");
    Expect(0, 918000, '\p{Blk=vssup}', "");
    Expect(1, 918000, '\p{^Blk=vssup}', "");
    Expect(1, 918000, '\P{Blk=vssup}', "");
    Expect(0, 918000, '\P{^Blk=vssup}', "");
    Expect(1, 917999, '\p{Blk=  VS_Sup}', "");
    Expect(0, 917999, '\p{^Blk=  VS_Sup}', "");
    Expect(0, 917999, '\P{Blk=  VS_Sup}', "");
    Expect(1, 917999, '\P{^Blk=  VS_Sup}', "");
    Expect(0, 918000, '\p{Blk=  VS_Sup}', "");
    Expect(1, 918000, '\p{^Blk=  VS_Sup}', "");
    Expect(1, 918000, '\P{Blk=  VS_Sup}', "");
    Expect(0, 918000, '\P{^Blk=  VS_Sup}', "");
    Error('\p{Is_Block=	 variation_Selectors_Supplement/a/}');
    Error('\P{Is_Block=	 variation_Selectors_Supplement/a/}');
    Expect(1, 917999, '\p{Is_Block=variationselectorssupplement}', "");
    Expect(0, 917999, '\p{^Is_Block=variationselectorssupplement}', "");
    Expect(0, 917999, '\P{Is_Block=variationselectorssupplement}', "");
    Expect(1, 917999, '\P{^Is_Block=variationselectorssupplement}', "");
    Expect(0, 918000, '\p{Is_Block=variationselectorssupplement}', "");
    Expect(1, 918000, '\p{^Is_Block=variationselectorssupplement}', "");
    Expect(1, 918000, '\P{Is_Block=variationselectorssupplement}', "");
    Expect(0, 918000, '\P{^Is_Block=variationselectorssupplement}', "");
    Expect(1, 917999, '\p{Is_Block=	_VARIATION_SELECTORS_Supplement}', "");
    Expect(0, 917999, '\p{^Is_Block=	_VARIATION_SELECTORS_Supplement}', "");
    Expect(0, 917999, '\P{Is_Block=	_VARIATION_SELECTORS_Supplement}', "");
    Expect(1, 917999, '\P{^Is_Block=	_VARIATION_SELECTORS_Supplement}', "");
    Expect(0, 918000, '\p{Is_Block=	_VARIATION_SELECTORS_Supplement}', "");
    Expect(1, 918000, '\p{^Is_Block=	_VARIATION_SELECTORS_Supplement}', "");
    Expect(1, 918000, '\P{Is_Block=	_VARIATION_SELECTORS_Supplement}', "");
    Expect(0, 918000, '\P{^Is_Block=	_VARIATION_SELECTORS_Supplement}', "");
    Error('\p{Is_Blk=__vs_Sup:=}');
    Error('\P{Is_Blk=__vs_Sup:=}');
    Expect(1, 917999, '\p{Is_Blk=vssup}', "");
    Expect(0, 917999, '\p{^Is_Blk=vssup}', "");
    Expect(0, 917999, '\P{Is_Blk=vssup}', "");
    Expect(1, 917999, '\P{^Is_Blk=vssup}', "");
    Expect(0, 918000, '\p{Is_Blk=vssup}', "");
    Expect(1, 918000, '\p{^Is_Blk=vssup}', "");
    Expect(1, 918000, '\P{Is_Blk=vssup}', "");
    Expect(0, 918000, '\P{^Is_Blk=vssup}', "");
    Expect(1, 917999, '\p{Is_Blk=_VS_Sup}', "");
    Expect(0, 917999, '\p{^Is_Blk=_VS_Sup}', "");
    Expect(0, 917999, '\P{Is_Blk=_VS_Sup}', "");
    Expect(1, 917999, '\P{^Is_Blk=_VS_Sup}', "");
    Expect(0, 918000, '\p{Is_Blk=_VS_Sup}', "");
    Expect(1, 918000, '\p{^Is_Blk=_VS_Sup}', "");
    Expect(1, 918000, '\P{Is_Blk=_VS_Sup}', "");
    Expect(0, 918000, '\P{^Is_Blk=_VS_Sup}', "");
    Error('\p{Block=	WARANG_citi/a/}');
    Error('\P{Block=	WARANG_citi/a/}');
    Expect(1, 71935, '\p{Block=warangciti}', "");
    Expect(0, 71935, '\p{^Block=warangciti}', "");
    Expect(0, 71935, '\P{Block=warangciti}', "");
    Expect(1, 71935, '\P{^Block=warangciti}', "");
    Expect(0, 71936, '\p{Block=warangciti}', "");
    Expect(1, 71936, '\p{^Block=warangciti}', "");
    Expect(1, 71936, '\P{Block=warangciti}', "");
    Expect(0, 71936, '\P{^Block=warangciti}', "");
    Expect(1, 71935, '\p{Block=--Warang_CITI}', "");
    Expect(0, 71935, '\p{^Block=--Warang_CITI}', "");
    Expect(0, 71935, '\P{Block=--Warang_CITI}', "");
    Expect(1, 71935, '\P{^Block=--Warang_CITI}', "");
    Expect(0, 71936, '\p{Block=--Warang_CITI}', "");
    Expect(1, 71936, '\p{^Block=--Warang_CITI}', "");
    Expect(1, 71936, '\P{Block=--Warang_CITI}', "");
    Expect(0, 71936, '\P{^Block=--Warang_CITI}', "");
    Error('\p{Blk=:=	Warang_citi}');
    Error('\P{Blk=:=	Warang_citi}');
    Expect(1, 71935, '\p{Blk=warangciti}', "");
    Expect(0, 71935, '\p{^Blk=warangciti}', "");
    Expect(0, 71935, '\P{Blk=warangciti}', "");
    Expect(1, 71935, '\P{^Blk=warangciti}', "");
    Expect(0, 71936, '\p{Blk=warangciti}', "");
    Expect(1, 71936, '\p{^Blk=warangciti}', "");
    Expect(1, 71936, '\P{Blk=warangciti}', "");
    Expect(0, 71936, '\P{^Blk=warangciti}', "");
    Expect(1, 71935, '\p{Blk=-	Warang_CITI}', "");
    Expect(0, 71935, '\p{^Blk=-	Warang_CITI}', "");
    Expect(0, 71935, '\P{Blk=-	Warang_CITI}', "");
    Expect(1, 71935, '\P{^Blk=-	Warang_CITI}', "");
    Expect(0, 71936, '\p{Blk=-	Warang_CITI}', "");
    Expect(1, 71936, '\p{^Blk=-	Warang_CITI}', "");
    Expect(1, 71936, '\P{Blk=-	Warang_CITI}', "");
    Expect(0, 71936, '\P{^Blk=-	Warang_CITI}', "");
    Error('\p{Is_Block=/a/	 Warang_CITI}');
    Error('\P{Is_Block=/a/	 Warang_CITI}');
    Expect(1, 71935, '\p{Is_Block=warangciti}', "");
    Expect(0, 71935, '\p{^Is_Block=warangciti}', "");
    Expect(0, 71935, '\P{Is_Block=warangciti}', "");
    Expect(1, 71935, '\P{^Is_Block=warangciti}', "");
    Expect(0, 71936, '\p{Is_Block=warangciti}', "");
    Expect(1, 71936, '\p{^Is_Block=warangciti}', "");
    Expect(1, 71936, '\P{Is_Block=warangciti}', "");
    Expect(0, 71936, '\P{^Is_Block=warangciti}', "");
    Expect(1, 71935, '\p{Is_Block=_WARANG_Citi}', "");
    Expect(0, 71935, '\p{^Is_Block=_WARANG_Citi}', "");
    Expect(0, 71935, '\P{Is_Block=_WARANG_Citi}', "");
    Expect(1, 71935, '\P{^Is_Block=_WARANG_Citi}', "");
    Expect(0, 71936, '\p{Is_Block=_WARANG_Citi}', "");
    Expect(1, 71936, '\p{^Is_Block=_WARANG_Citi}', "");
    Expect(1, 71936, '\P{Is_Block=_WARANG_Citi}', "");
    Expect(0, 71936, '\P{^Is_Block=_WARANG_Citi}', "");
    Error('\p{Is_Blk=	_WARANG_CITI:=}');
    Error('\P{Is_Blk=	_WARANG_CITI:=}');
    Expect(1, 71935, '\p{Is_Blk=warangciti}', "");
    Expect(0, 71935, '\p{^Is_Blk=warangciti}', "");
    Expect(0, 71935, '\P{Is_Blk=warangciti}', "");
    Expect(1, 71935, '\P{^Is_Blk=warangciti}', "");
    Expect(0, 71936, '\p{Is_Blk=warangciti}', "");
    Expect(1, 71936, '\p{^Is_Blk=warangciti}', "");
    Expect(1, 71936, '\P{Is_Blk=warangciti}', "");
    Expect(0, 71936, '\P{^Is_Blk=warangciti}', "");
    Expect(1, 71935, '\p{Is_Blk=		Warang_citi}', "");
    Expect(0, 71935, '\p{^Is_Blk=		Warang_citi}', "");
    Expect(0, 71935, '\P{Is_Blk=		Warang_citi}', "");
    Expect(1, 71935, '\P{^Is_Blk=		Warang_citi}', "");
    Expect(0, 71936, '\p{Is_Blk=		Warang_citi}', "");
    Expect(1, 71936, '\p{^Is_Blk=		Warang_citi}', "");
    Expect(1, 71936, '\P{Is_Blk=		Warang_citi}', "");
    Expect(0, 71936, '\P{^Is_Blk=		Warang_citi}', "");
    Error('\p{Block=	/a/Yi_Radicals}');
    Error('\P{Block=	/a/Yi_Radicals}');
    Expect(1, 42191, '\p{Block=yiradicals}', "");
    Expect(0, 42191, '\p{^Block=yiradicals}', "");
    Expect(0, 42191, '\P{Block=yiradicals}', "");
    Expect(1, 42191, '\P{^Block=yiradicals}', "");
    Expect(0, 42192, '\p{Block=yiradicals}', "");
    Expect(1, 42192, '\p{^Block=yiradicals}', "");
    Expect(1, 42192, '\P{Block=yiradicals}', "");
    Expect(0, 42192, '\P{^Block=yiradicals}', "");
    Expect(1, 42191, '\p{Block=	Yi_Radicals}', "");
    Expect(0, 42191, '\p{^Block=	Yi_Radicals}', "");
    Expect(0, 42191, '\P{Block=	Yi_Radicals}', "");
    Expect(1, 42191, '\P{^Block=	Yi_Radicals}', "");
    Expect(0, 42192, '\p{Block=	Yi_Radicals}', "");
    Expect(1, 42192, '\p{^Block=	Yi_Radicals}', "");
    Expect(1, 42192, '\P{Block=	Yi_Radicals}', "");
    Expect(0, 42192, '\P{^Block=	Yi_Radicals}', "");
    Error('\p{Blk=- Yi_RADICALS:=}');
    Error('\P{Blk=- Yi_RADICALS:=}');
    Expect(1, 42191, '\p{Blk=yiradicals}', "");
    Expect(0, 42191, '\p{^Blk=yiradicals}', "");
    Expect(0, 42191, '\P{Blk=yiradicals}', "");
    Expect(1, 42191, '\P{^Blk=yiradicals}', "");
    Expect(0, 42192, '\p{Blk=yiradicals}', "");
    Expect(1, 42192, '\p{^Blk=yiradicals}', "");
    Expect(1, 42192, '\P{Blk=yiradicals}', "");
    Expect(0, 42192, '\P{^Blk=yiradicals}', "");
    Expect(1, 42191, '\p{Blk= -Yi_Radicals}', "");
    Expect(0, 42191, '\p{^Blk= -Yi_Radicals}', "");
    Expect(0, 42191, '\P{Blk= -Yi_Radicals}', "");
    Expect(1, 42191, '\P{^Blk= -Yi_Radicals}', "");
    Expect(0, 42192, '\p{Blk= -Yi_Radicals}', "");
    Expect(1, 42192, '\p{^Blk= -Yi_Radicals}', "");
    Expect(1, 42192, '\P{Blk= -Yi_Radicals}', "");
    Expect(0, 42192, '\P{^Blk= -Yi_Radicals}', "");
    Error('\p{Is_Block=/a/ -yi_RADICALS}');
    Error('\P{Is_Block=/a/ -yi_RADICALS}');
    Expect(1, 42191, '\p{Is_Block=yiradicals}', "");
    Expect(0, 42191, '\p{^Is_Block=yiradicals}', "");
    Expect(0, 42191, '\P{Is_Block=yiradicals}', "");
    Expect(1, 42191, '\P{^Is_Block=yiradicals}', "");
    Expect(0, 42192, '\p{Is_Block=yiradicals}', "");
    Expect(1, 42192, '\p{^Is_Block=yiradicals}', "");
    Expect(1, 42192, '\P{Is_Block=yiradicals}', "");
    Expect(0, 42192, '\P{^Is_Block=yiradicals}', "");
    Expect(1, 42191, '\p{Is_Block=	_Yi_RADICALS}', "");
    Expect(0, 42191, '\p{^Is_Block=	_Yi_RADICALS}', "");
    Expect(0, 42191, '\P{Is_Block=	_Yi_RADICALS}', "");
    Expect(1, 42191, '\P{^Is_Block=	_Yi_RADICALS}', "");
    Expect(0, 42192, '\p{Is_Block=	_Yi_RADICALS}', "");
    Expect(1, 42192, '\p{^Is_Block=	_Yi_RADICALS}', "");
    Expect(1, 42192, '\P{Is_Block=	_Yi_RADICALS}', "");
    Expect(0, 42192, '\P{^Is_Block=	_Yi_RADICALS}', "");
    Error('\p{Is_Blk=/a/Yi_radicals}');
    Error('\P{Is_Blk=/a/Yi_radicals}');
    Expect(1, 42191, '\p{Is_Blk=yiradicals}', "");
    Expect(0, 42191, '\p{^Is_Blk=yiradicals}', "");
    Expect(0, 42191, '\P{Is_Blk=yiradicals}', "");
    Expect(1, 42191, '\P{^Is_Blk=yiradicals}', "");
    Expect(0, 42192, '\p{Is_Blk=yiradicals}', "");
    Expect(1, 42192, '\p{^Is_Blk=yiradicals}', "");
    Expect(1, 42192, '\P{Is_Blk=yiradicals}', "");
    Expect(0, 42192, '\P{^Is_Blk=yiradicals}', "");
    Expect(1, 42191, '\p{Is_Blk= 	YI_Radicals}', "");
    Expect(0, 42191, '\p{^Is_Blk= 	YI_Radicals}', "");
    Expect(0, 42191, '\P{Is_Blk= 	YI_Radicals}', "");
    Expect(1, 42191, '\P{^Is_Blk= 	YI_Radicals}', "");
    Expect(0, 42192, '\p{Is_Blk= 	YI_Radicals}', "");
    Expect(1, 42192, '\p{^Is_Blk= 	YI_Radicals}', "");
    Expect(1, 42192, '\P{Is_Blk= 	YI_Radicals}', "");
    Expect(0, 42192, '\P{^Is_Blk= 	YI_Radicals}', "");
    Error('\p{Block=-YI_SYLLABLES/a/}');
    Error('\P{Block=-YI_SYLLABLES/a/}');
    Expect(1, 42127, '\p{Block=yisyllables}', "");
    Expect(0, 42127, '\p{^Block=yisyllables}', "");
    Expect(0, 42127, '\P{Block=yisyllables}', "");
    Expect(1, 42127, '\P{^Block=yisyllables}', "");
    Expect(0, 42128, '\p{Block=yisyllables}', "");
    Expect(1, 42128, '\p{^Block=yisyllables}', "");
    Expect(1, 42128, '\P{Block=yisyllables}', "");
    Expect(0, 42128, '\P{^Block=yisyllables}', "");
    Expect(1, 42127, '\p{Block=-	Yi_Syllables}', "");
    Expect(0, 42127, '\p{^Block=-	Yi_Syllables}', "");
    Expect(0, 42127, '\P{Block=-	Yi_Syllables}', "");
    Expect(1, 42127, '\P{^Block=-	Yi_Syllables}', "");
    Expect(0, 42128, '\p{Block=-	Yi_Syllables}', "");
    Expect(1, 42128, '\p{^Block=-	Yi_Syllables}', "");
    Expect(1, 42128, '\P{Block=-	Yi_Syllables}', "");
    Expect(0, 42128, '\P{^Block=-	Yi_Syllables}', "");
    Error('\p{Blk= /a/Yi_syllables}');
    Error('\P{Blk= /a/Yi_syllables}');
    Expect(1, 42127, '\p{Blk:yisyllables}', "");
    Expect(0, 42127, '\p{^Blk:yisyllables}', "");
    Expect(0, 42127, '\P{Blk:yisyllables}', "");
    Expect(1, 42127, '\P{^Blk:yisyllables}', "");
    Expect(0, 42128, '\p{Blk:yisyllables}', "");
    Expect(1, 42128, '\p{^Blk:yisyllables}', "");
    Expect(1, 42128, '\P{Blk:yisyllables}', "");
    Expect(0, 42128, '\P{^Blk:yisyllables}', "");
    Expect(1, 42127, '\p{Blk: 	yi_Syllables}', "");
    Expect(0, 42127, '\p{^Blk: 	yi_Syllables}', "");
    Expect(0, 42127, '\P{Blk: 	yi_Syllables}', "");
    Expect(1, 42127, '\P{^Blk: 	yi_Syllables}', "");
    Expect(0, 42128, '\p{Blk: 	yi_Syllables}', "");
    Expect(1, 42128, '\p{^Blk: 	yi_Syllables}', "");
    Expect(1, 42128, '\P{Blk: 	yi_Syllables}', "");
    Expect(0, 42128, '\P{^Blk: 	yi_Syllables}', "");
    Error('\p{Is_Block= :=Yi_Syllables}');
    Error('\P{Is_Block= :=Yi_Syllables}');
    Expect(1, 42127, '\p{Is_Block=yisyllables}', "");
    Expect(0, 42127, '\p{^Is_Block=yisyllables}', "");
    Expect(0, 42127, '\P{Is_Block=yisyllables}', "");
    Expect(1, 42127, '\P{^Is_Block=yisyllables}', "");
    Expect(0, 42128, '\p{Is_Block=yisyllables}', "");
    Expect(1, 42128, '\p{^Is_Block=yisyllables}', "");
    Expect(1, 42128, '\P{Is_Block=yisyllables}', "");
    Expect(0, 42128, '\P{^Is_Block=yisyllables}', "");
    Expect(1, 42127, '\p{Is_Block=_yi_Syllables}', "");
    Expect(0, 42127, '\p{^Is_Block=_yi_Syllables}', "");
    Expect(0, 42127, '\P{Is_Block=_yi_Syllables}', "");
    Expect(1, 42127, '\P{^Is_Block=_yi_Syllables}', "");
    Expect(0, 42128, '\p{Is_Block=_yi_Syllables}', "");
    Expect(1, 42128, '\p{^Is_Block=_yi_Syllables}', "");
    Expect(1, 42128, '\P{Is_Block=_yi_Syllables}', "");
    Expect(0, 42128, '\P{^Is_Block=_yi_Syllables}', "");
    Error('\p{Is_Blk:  :=Yi_SYLLABLES}');
    Error('\P{Is_Blk:  :=Yi_SYLLABLES}');
    Expect(1, 42127, '\p{Is_Blk=yisyllables}', "");
    Expect(0, 42127, '\p{^Is_Blk=yisyllables}', "");
    Expect(0, 42127, '\P{Is_Blk=yisyllables}', "");
    Expect(1, 42127, '\P{^Is_Blk=yisyllables}', "");
    Expect(0, 42128, '\p{Is_Blk=yisyllables}', "");
    Expect(1, 42128, '\p{^Is_Blk=yisyllables}', "");
    Expect(1, 42128, '\P{Is_Blk=yisyllables}', "");
    Expect(0, 42128, '\P{^Is_Blk=yisyllables}', "");
    Expect(1, 42127, '\p{Is_Blk= Yi_Syllables}', "");
    Expect(0, 42127, '\p{^Is_Blk= Yi_Syllables}', "");
    Expect(0, 42127, '\P{Is_Blk= Yi_Syllables}', "");
    Expect(1, 42127, '\P{^Is_Blk= Yi_Syllables}', "");
    Expect(0, 42128, '\p{Is_Blk= Yi_Syllables}', "");
    Expect(1, 42128, '\p{^Is_Blk= Yi_Syllables}', "");
    Expect(1, 42128, '\P{Is_Blk= Yi_Syllables}', "");
    Expect(0, 42128, '\P{^Is_Blk= Yi_Syllables}', "");
    Error('\p{Block=	-yijing_Hexagram_Symbols:=}');
    Error('\P{Block=	-yijing_Hexagram_Symbols:=}');
    Expect(1, 19967, '\p{Block:   yijinghexagramsymbols}', "");
    Expect(0, 19967, '\p{^Block:   yijinghexagramsymbols}', "");
    Expect(0, 19967, '\P{Block:   yijinghexagramsymbols}', "");
    Expect(1, 19967, '\P{^Block:   yijinghexagramsymbols}', "");
    Expect(0, 19968, '\p{Block:   yijinghexagramsymbols}', "");
    Expect(1, 19968, '\p{^Block:   yijinghexagramsymbols}', "");
    Expect(1, 19968, '\P{Block:   yijinghexagramsymbols}', "");
    Expect(0, 19968, '\P{^Block:   yijinghexagramsymbols}', "");
    Expect(1, 19967, '\p{Block=	Yijing_hexagram_Symbols}', "");
    Expect(0, 19967, '\p{^Block=	Yijing_hexagram_Symbols}', "");
    Expect(0, 19967, '\P{Block=	Yijing_hexagram_Symbols}', "");
    Expect(1, 19967, '\P{^Block=	Yijing_hexagram_Symbols}', "");
    Expect(0, 19968, '\p{Block=	Yijing_hexagram_Symbols}', "");
    Expect(1, 19968, '\p{^Block=	Yijing_hexagram_Symbols}', "");
    Expect(1, 19968, '\P{Block=	Yijing_hexagram_Symbols}', "");
    Expect(0, 19968, '\P{^Block=	Yijing_hexagram_Symbols}', "");
    Error('\p{Blk=-:=yijing}');
    Error('\P{Blk=-:=yijing}');
    Expect(1, 19967, '\p{Blk=yijing}', "");
    Expect(0, 19967, '\p{^Blk=yijing}', "");
    Expect(0, 19967, '\P{Blk=yijing}', "");
    Expect(1, 19967, '\P{^Blk=yijing}', "");
    Expect(0, 19968, '\p{Blk=yijing}', "");
    Expect(1, 19968, '\p{^Blk=yijing}', "");
    Expect(1, 19968, '\P{Blk=yijing}', "");
    Expect(0, 19968, '\P{^Blk=yijing}', "");
    Expect(1, 19967, '\p{Blk=_ yijing}', "");
    Expect(0, 19967, '\p{^Blk=_ yijing}', "");
    Expect(0, 19967, '\P{Blk=_ yijing}', "");
    Expect(1, 19967, '\P{^Blk=_ yijing}', "");
    Expect(0, 19968, '\p{Blk=_ yijing}', "");
    Expect(1, 19968, '\p{^Blk=_ yijing}', "");
    Expect(1, 19968, '\P{Blk=_ yijing}', "");
    Expect(0, 19968, '\P{^Blk=_ yijing}', "");
    Error('\p{Is_Block= Yijing_hexagram_Symbols/a/}');
    Error('\P{Is_Block= Yijing_hexagram_Symbols/a/}');
    Expect(1, 19967, '\p{Is_Block=yijinghexagramsymbols}', "");
    Expect(0, 19967, '\p{^Is_Block=yijinghexagramsymbols}', "");
    Expect(0, 19967, '\P{Is_Block=yijinghexagramsymbols}', "");
    Expect(1, 19967, '\P{^Is_Block=yijinghexagramsymbols}', "");
    Expect(0, 19968, '\p{Is_Block=yijinghexagramsymbols}', "");
    Expect(1, 19968, '\p{^Is_Block=yijinghexagramsymbols}', "");
    Expect(1, 19968, '\P{Is_Block=yijinghexagramsymbols}', "");
    Expect(0, 19968, '\P{^Is_Block=yijinghexagramsymbols}', "");
    Expect(1, 19967, '\p{Is_Block=	_YIJING_hexagram_SYMBOLS}', "");
    Expect(0, 19967, '\p{^Is_Block=	_YIJING_hexagram_SYMBOLS}', "");
    Expect(0, 19967, '\P{Is_Block=	_YIJING_hexagram_SYMBOLS}', "");
    Expect(1, 19967, '\P{^Is_Block=	_YIJING_hexagram_SYMBOLS}', "");
    Expect(0, 19968, '\p{Is_Block=	_YIJING_hexagram_SYMBOLS}', "");
    Expect(1, 19968, '\p{^Is_Block=	_YIJING_hexagram_SYMBOLS}', "");
    Expect(1, 19968, '\P{Is_Block=	_YIJING_hexagram_SYMBOLS}', "");
    Expect(0, 19968, '\P{^Is_Block=	_YIJING_hexagram_SYMBOLS}', "");
    Error('\p{Is_Blk=-Yijing:=}');
    Error('\P{Is_Blk=-Yijing:=}');
    Expect(1, 19967, '\p{Is_Blk=yijing}', "");
    Expect(0, 19967, '\p{^Is_Blk=yijing}', "");
    Expect(0, 19967, '\P{Is_Blk=yijing}', "");
    Expect(1, 19967, '\P{^Is_Blk=yijing}', "");
    Expect(0, 19968, '\p{Is_Blk=yijing}', "");
    Expect(1, 19968, '\p{^Is_Blk=yijing}', "");
    Expect(1, 19968, '\P{Is_Blk=yijing}', "");
    Expect(0, 19968, '\P{^Is_Blk=yijing}', "");
    Expect(1, 19967, '\p{Is_Blk=  YIJING}', "");
    Expect(0, 19967, '\p{^Is_Blk=  YIJING}', "");
    Expect(0, 19967, '\P{Is_Blk=  YIJING}', "");
    Expect(1, 19967, '\P{^Is_Blk=  YIJING}', "");
    Expect(0, 19968, '\p{Is_Blk=  YIJING}', "");
    Expect(1, 19968, '\p{^Is_Blk=  YIJING}', "");
    Expect(1, 19968, '\P{Is_Blk=  YIJING}', "");
    Expect(0, 19968, '\P{^Is_Blk=  YIJING}', "");
    Error('\p{Block=:=- Zanabazar_Square}');
    Error('\P{Block=:=- Zanabazar_Square}');
    Expect(1, 72271, '\p{Block=zanabazarsquare}', "");
    Expect(0, 72271, '\p{^Block=zanabazarsquare}', "");
    Expect(0, 72271, '\P{Block=zanabazarsquare}', "");
    Expect(1, 72271, '\P{^Block=zanabazarsquare}', "");
    Expect(0, 72272, '\p{Block=zanabazarsquare}', "");
    Expect(1, 72272, '\p{^Block=zanabazarsquare}', "");
    Expect(1, 72272, '\P{Block=zanabazarsquare}', "");
    Expect(0, 72272, '\P{^Block=zanabazarsquare}', "");
    Expect(1, 72271, '\p{Block=- zanabazar_square}', "");
    Expect(0, 72271, '\p{^Block=- zanabazar_square}', "");
    Expect(0, 72271, '\P{Block=- zanabazar_square}', "");
    Expect(1, 72271, '\P{^Block=- zanabazar_square}', "");
    Expect(0, 72272, '\p{Block=- zanabazar_square}', "");
    Expect(1, 72272, '\p{^Block=- zanabazar_square}', "");
    Expect(1, 72272, '\P{Block=- zanabazar_square}', "");
    Expect(0, 72272, '\P{^Block=- zanabazar_square}', "");
    Error('\p{Blk=_-zanabazar_square/a/}');
    Error('\P{Blk=_-zanabazar_square/a/}');
    Expect(1, 72271, '\p{Blk=zanabazarsquare}', "");
    Expect(0, 72271, '\p{^Blk=zanabazarsquare}', "");
    Expect(0, 72271, '\P{Blk=zanabazarsquare}', "");
    Expect(1, 72271, '\P{^Blk=zanabazarsquare}', "");
    Expect(0, 72272, '\p{Blk=zanabazarsquare}', "");
    Expect(1, 72272, '\p{^Blk=zanabazarsquare}', "");
    Expect(1, 72272, '\P{Blk=zanabazarsquare}', "");
    Expect(0, 72272, '\P{^Blk=zanabazarsquare}', "");
    Expect(1, 72271, '\p{Blk= -Zanabazar_square}', "");
    Expect(0, 72271, '\p{^Blk= -Zanabazar_square}', "");
    Expect(0, 72271, '\P{Blk= -Zanabazar_square}', "");
    Expect(1, 72271, '\P{^Blk= -Zanabazar_square}', "");
    Expect(0, 72272, '\p{Blk= -Zanabazar_square}', "");
    Expect(1, 72272, '\p{^Blk= -Zanabazar_square}', "");
    Expect(1, 72272, '\P{Blk= -Zanabazar_square}', "");
    Expect(0, 72272, '\P{^Blk= -Zanabazar_square}', "");
    Error('\p{Is_Block=--zanabazar_SQUARE/a/}');
    Error('\P{Is_Block=--zanabazar_SQUARE/a/}');
    Expect(1, 72271, '\p{Is_Block: zanabazarsquare}', "");
    Expect(0, 72271, '\p{^Is_Block: zanabazarsquare}', "");
    Expect(0, 72271, '\P{Is_Block: zanabazarsquare}', "");
    Expect(1, 72271, '\P{^Is_Block: zanabazarsquare}', "");
    Expect(0, 72272, '\p{Is_Block: zanabazarsquare}', "");
    Expect(1, 72272, '\p{^Is_Block: zanabazarsquare}', "");
    Expect(1, 72272, '\P{Is_Block: zanabazarsquare}', "");
    Expect(0, 72272, '\P{^Is_Block: zanabazarsquare}', "");
    Expect(1, 72271, '\p{Is_Block= _Zanabazar_Square}', "");
    Expect(0, 72271, '\p{^Is_Block= _Zanabazar_Square}', "");
    Expect(0, 72271, '\P{Is_Block= _Zanabazar_Square}', "");
    Expect(1, 72271, '\P{^Is_Block= _Zanabazar_Square}', "");
    Expect(0, 72272, '\p{Is_Block= _Zanabazar_Square}', "");
    Expect(1, 72272, '\p{^Is_Block= _Zanabazar_Square}', "");
    Expect(1, 72272, '\P{Is_Block= _Zanabazar_Square}', "");
    Expect(0, 72272, '\P{^Is_Block= _Zanabazar_Square}', "");
    Error('\p{Is_Blk=	/a/ZANABAZAR_SQUARE}');
    Error('\P{Is_Blk=	/a/ZANABAZAR_SQUARE}');
    Expect(1, 72271, '\p{Is_Blk:zanabazarsquare}', "");
    Expect(0, 72271, '\p{^Is_Blk:zanabazarsquare}', "");
    Expect(0, 72271, '\P{Is_Blk:zanabazarsquare}', "");
    Expect(1, 72271, '\P{^Is_Blk:zanabazarsquare}', "");
    Expect(0, 72272, '\p{Is_Blk:zanabazarsquare}', "");
    Expect(1, 72272, '\p{^Is_Blk:zanabazarsquare}', "");
    Expect(1, 72272, '\P{Is_Blk:zanabazarsquare}', "");
    Expect(0, 72272, '\P{^Is_Blk:zanabazarsquare}', "");
    Expect(1, 72271, '\p{Is_Blk=	_Zanabazar_SQUARE}', "");
    Expect(0, 72271, '\p{^Is_Blk=	_Zanabazar_SQUARE}', "");
    Expect(0, 72271, '\P{Is_Blk=	_Zanabazar_SQUARE}', "");
    Expect(1, 72271, '\P{^Is_Blk=	_Zanabazar_SQUARE}', "");
    Expect(0, 72272, '\p{Is_Blk=	_Zanabazar_SQUARE}', "");
    Expect(1, 72272, '\p{^Is_Blk=	_Zanabazar_SQUARE}', "");
    Expect(1, 72272, '\P{Is_Blk=	_Zanabazar_SQUARE}', "");
    Expect(0, 72272, '\P{^Is_Blk=	_Zanabazar_SQUARE}', "");
    Error('\p{bidimirroringglyph}');
    Error('\P{bidimirroringglyph}');
    Error('\p{bmg}');
    Error('\P{bmg}');
    Error('\p{bidipairedbracket}');
    Error('\P{bidipairedbracket}');
    Error('\p{bpb}');
    Error('\P{bpb}');
    Error('\p{bidipairedbrackettype}');
    Error('\P{bidipairedbrackettype}');
    Error('\p{bpt}');
    Error('\P{bpt}');
    Error('\p{Bidi_Paired_Bracket_Type=-Close:=}');
    Error('\P{Bidi_Paired_Bracket_Type=-Close:=}');
    Expect(1, 65379, '\p{Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65379, '\p{^Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65379, '\P{Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65379, '\P{^Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65380, '\p{Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65380, '\p{^Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65380, '\P{Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65380, '\P{^Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65379, '\p{Bidi_Paired_Bracket_Type= CLOSE}', "");
    Expect(0, 65379, '\p{^Bidi_Paired_Bracket_Type= CLOSE}', "");
    Expect(0, 65379, '\P{Bidi_Paired_Bracket_Type= CLOSE}', "");
    Expect(1, 65379, '\P{^Bidi_Paired_Bracket_Type= CLOSE}', "");
    Expect(0, 65380, '\p{Bidi_Paired_Bracket_Type= CLOSE}', "");
    Expect(1, 65380, '\p{^Bidi_Paired_Bracket_Type= CLOSE}', "");
    Expect(1, 65380, '\P{Bidi_Paired_Bracket_Type= CLOSE}', "");
    Expect(0, 65380, '\P{^Bidi_Paired_Bracket_Type= CLOSE}', "");
    Error('\p{Bpt=--C/a/}');
    Error('\P{Bpt=--C/a/}');
    Expect(1, 65379, '\p{Bpt=c}', "");
    Expect(0, 65379, '\p{^Bpt=c}', "");
    Expect(0, 65379, '\P{Bpt=c}', "");
    Expect(1, 65379, '\P{^Bpt=c}', "");
    Expect(0, 65380, '\p{Bpt=c}', "");
    Expect(1, 65380, '\p{^Bpt=c}', "");
    Expect(1, 65380, '\P{Bpt=c}', "");
    Expect(0, 65380, '\P{^Bpt=c}', "");
    Expect(1, 65379, '\p{Bpt= _C}', "");
    Expect(0, 65379, '\p{^Bpt= _C}', "");
    Expect(0, 65379, '\P{Bpt= _C}', "");
    Expect(1, 65379, '\P{^Bpt= _C}', "");
    Expect(0, 65380, '\p{Bpt= _C}', "");
    Expect(1, 65380, '\p{^Bpt= _C}', "");
    Expect(1, 65380, '\P{Bpt= _C}', "");
    Expect(0, 65380, '\P{^Bpt= _C}', "");
    Error('\p{Is_Bidi_Paired_Bracket_Type= :=close}');
    Error('\P{Is_Bidi_Paired_Bracket_Type= :=close}');
    Expect(1, 65379, '\p{Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65379, '\p{^Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65379, '\P{Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65379, '\P{^Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65380, '\p{Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65380, '\p{^Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65380, '\P{Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65380, '\P{^Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65379, '\p{Is_Bidi_Paired_Bracket_Type= Close}', "");
    Expect(0, 65379, '\p{^Is_Bidi_Paired_Bracket_Type= Close}', "");
    Expect(0, 65379, '\P{Is_Bidi_Paired_Bracket_Type= Close}', "");
    Expect(1, 65379, '\P{^Is_Bidi_Paired_Bracket_Type= Close}', "");
    Expect(0, 65380, '\p{Is_Bidi_Paired_Bracket_Type= Close}', "");
    Expect(1, 65380, '\p{^Is_Bidi_Paired_Bracket_Type= Close}', "");
    Expect(1, 65380, '\P{Is_Bidi_Paired_Bracket_Type= Close}', "");
    Expect(0, 65380, '\P{^Is_Bidi_Paired_Bracket_Type= Close}', "");
    Error('\p{Is_Bpt=	:=C}');
    Error('\P{Is_Bpt=	:=C}');
    Expect(1, 65379, '\p{Is_Bpt=c}', "");
    Expect(0, 65379, '\p{^Is_Bpt=c}', "");
    Expect(0, 65379, '\P{Is_Bpt=c}', "");
    Expect(1, 65379, '\P{^Is_Bpt=c}', "");
    Expect(0, 65380, '\p{Is_Bpt=c}', "");
    Expect(1, 65380, '\p{^Is_Bpt=c}', "");
    Expect(1, 65380, '\P{Is_Bpt=c}', "");
    Expect(0, 65380, '\P{^Is_Bpt=c}', "");
    Expect(1, 65379, '\p{Is_Bpt=-C}', "");
    Expect(0, 65379, '\p{^Is_Bpt=-C}', "");
    Expect(0, 65379, '\P{Is_Bpt=-C}', "");
    Expect(1, 65379, '\P{^Is_Bpt=-C}', "");
    Expect(0, 65380, '\p{Is_Bpt=-C}', "");
    Expect(1, 65380, '\p{^Is_Bpt=-C}', "");
    Expect(1, 65380, '\P{Is_Bpt=-C}', "");
    Expect(0, 65380, '\P{^Is_Bpt=-C}', "");
    Error('\p{Bidi_Paired_Bracket_Type=_:=None}');
    Error('\P{Bidi_Paired_Bracket_Type=_:=None}');
    Expect(1, 65380, '\p{Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65380, '\p{^Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65380, '\P{Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65380, '\P{^Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65379, '\p{^Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65379, '\P{Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65379, '\P{^Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65380, '\p{Bidi_Paired_Bracket_Type=-	None}', "");
    Expect(0, 65380, '\p{^Bidi_Paired_Bracket_Type=-	None}', "");
    Expect(0, 65380, '\P{Bidi_Paired_Bracket_Type=-	None}', "");
    Expect(1, 65380, '\P{^Bidi_Paired_Bracket_Type=-	None}', "");
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=-	None}', "");
    Expect(1, 65379, '\p{^Bidi_Paired_Bracket_Type=-	None}', "");
    Expect(1, 65379, '\P{Bidi_Paired_Bracket_Type=-	None}', "");
    Expect(0, 65379, '\P{^Bidi_Paired_Bracket_Type=-	None}', "");
    Error('\p{Bpt= :=N}');
    Error('\P{Bpt= :=N}');
    Expect(1, 65380, '\p{Bpt=n}', "");
    Expect(0, 65380, '\p{^Bpt=n}', "");
    Expect(0, 65380, '\P{Bpt=n}', "");
    Expect(1, 65380, '\P{^Bpt=n}', "");
    Expect(0, 65379, '\p{Bpt=n}', "");
    Expect(1, 65379, '\p{^Bpt=n}', "");
    Expect(1, 65379, '\P{Bpt=n}', "");
    Expect(0, 65379, '\P{^Bpt=n}', "");
    Expect(1, 65380, '\p{Bpt=_N}', "");
    Expect(0, 65380, '\p{^Bpt=_N}', "");
    Expect(0, 65380, '\P{Bpt=_N}', "");
    Expect(1, 65380, '\P{^Bpt=_N}', "");
    Expect(0, 65379, '\p{Bpt=_N}', "");
    Expect(1, 65379, '\p{^Bpt=_N}', "");
    Expect(1, 65379, '\P{Bpt=_N}', "");
    Expect(0, 65379, '\P{^Bpt=_N}', "");
    Error('\p{Is_Bidi_Paired_Bracket_Type:	-None/a/}');
    Error('\P{Is_Bidi_Paired_Bracket_Type:	-None/a/}');
    Expect(1, 65380, '\p{Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65380, '\p{^Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65380, '\P{Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65380, '\P{^Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65379, '\p{Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65379, '\p{^Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65379, '\P{Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65379, '\P{^Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65380, '\p{Is_Bidi_Paired_Bracket_Type=	_None}', "");
    Expect(0, 65380, '\p{^Is_Bidi_Paired_Bracket_Type=	_None}', "");
    Expect(0, 65380, '\P{Is_Bidi_Paired_Bracket_Type=	_None}', "");
    Expect(1, 65380, '\P{^Is_Bidi_Paired_Bracket_Type=	_None}', "");
    Expect(0, 65379, '\p{Is_Bidi_Paired_Bracket_Type=	_None}', "");
    Expect(1, 65379, '\p{^Is_Bidi_Paired_Bracket_Type=	_None}', "");
    Expect(1, 65379, '\P{Is_Bidi_Paired_Bracket_Type=	_None}', "");
    Expect(0, 65379, '\P{^Is_Bidi_Paired_Bracket_Type=	_None}', "");
    Error('\p{Is_Bpt=/a/N}');
    Error('\P{Is_Bpt=/a/N}');
    Expect(1, 65380, '\p{Is_Bpt=n}', "");
    Expect(0, 65380, '\p{^Is_Bpt=n}', "");
    Expect(0, 65380, '\P{Is_Bpt=n}', "");
    Expect(1, 65380, '\P{^Is_Bpt=n}', "");
    Expect(0, 65379, '\p{Is_Bpt=n}', "");
    Expect(1, 65379, '\p{^Is_Bpt=n}', "");
    Expect(1, 65379, '\P{Is_Bpt=n}', "");
    Expect(0, 65379, '\P{^Is_Bpt=n}', "");
    Expect(1, 65380, '\p{Is_Bpt= N}', "");
    Expect(0, 65380, '\p{^Is_Bpt= N}', "");
    Expect(0, 65380, '\P{Is_Bpt= N}', "");
    Expect(1, 65380, '\P{^Is_Bpt= N}', "");
    Expect(0, 65379, '\p{Is_Bpt= N}', "");
    Expect(1, 65379, '\p{^Is_Bpt= N}', "");
    Expect(1, 65379, '\P{Is_Bpt= N}', "");
    Expect(0, 65379, '\P{^Is_Bpt= N}', "");
    Error('\p{Bidi_Paired_Bracket_Type=:=_Open}');
    Error('\P{Bidi_Paired_Bracket_Type=:=_Open}');
    Expect(1, 65378, '\p{Bidi_Paired_Bracket_Type:	open}', "");
    Expect(0, 65378, '\p{^Bidi_Paired_Bracket_Type:	open}', "");
    Expect(0, 65378, '\P{Bidi_Paired_Bracket_Type:	open}', "");
    Expect(1, 65378, '\P{^Bidi_Paired_Bracket_Type:	open}', "");
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type:	open}', "");
    Expect(1, 65379, '\p{^Bidi_Paired_Bracket_Type:	open}', "");
    Expect(1, 65379, '\P{Bidi_Paired_Bracket_Type:	open}', "");
    Expect(0, 65379, '\P{^Bidi_Paired_Bracket_Type:	open}', "");
    Expect(1, 65378, '\p{Bidi_Paired_Bracket_Type:	- Open}', "");
    Expect(0, 65378, '\p{^Bidi_Paired_Bracket_Type:	- Open}', "");
    Expect(0, 65378, '\P{Bidi_Paired_Bracket_Type:	- Open}', "");
    Expect(1, 65378, '\P{^Bidi_Paired_Bracket_Type:	- Open}', "");
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type:	- Open}', "");
    Expect(1, 65379, '\p{^Bidi_Paired_Bracket_Type:	- Open}', "");
    Expect(1, 65379, '\P{Bidi_Paired_Bracket_Type:	- Open}', "");
    Expect(0, 65379, '\P{^Bidi_Paired_Bracket_Type:	- Open}', "");
    Error('\p{Bpt=/a/--o}');
    Error('\P{Bpt=/a/--o}');
    Expect(1, 65378, '\p{Bpt=o}', "");
    Expect(0, 65378, '\p{^Bpt=o}', "");
    Expect(0, 65378, '\P{Bpt=o}', "");
    Expect(1, 65378, '\P{^Bpt=o}', "");
    Expect(0, 65379, '\p{Bpt=o}', "");
    Expect(1, 65379, '\p{^Bpt=o}', "");
    Expect(1, 65379, '\P{Bpt=o}', "");
    Expect(0, 65379, '\P{^Bpt=o}', "");
    Expect(1, 65378, '\p{Bpt= _O}', "");
    Expect(0, 65378, '\p{^Bpt= _O}', "");
    Expect(0, 65378, '\P{Bpt= _O}', "");
    Expect(1, 65378, '\P{^Bpt= _O}', "");
    Expect(0, 65379, '\p{Bpt= _O}', "");
    Expect(1, 65379, '\p{^Bpt= _O}', "");
    Expect(1, 65379, '\P{Bpt= _O}', "");
    Expect(0, 65379, '\P{^Bpt= _O}', "");
    Error('\p{Is_Bidi_Paired_Bracket_Type= /a/open}');
    Error('\P{Is_Bidi_Paired_Bracket_Type= /a/open}');
    Expect(1, 65378, '\p{Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65378, '\p{^Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65378, '\P{Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65378, '\P{^Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65379, '\p{Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65379, '\p{^Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65379, '\P{Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65379, '\P{^Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65378, '\p{Is_Bidi_Paired_Bracket_Type=	open}', "");
    Expect(0, 65378, '\p{^Is_Bidi_Paired_Bracket_Type=	open}', "");
    Expect(0, 65378, '\P{Is_Bidi_Paired_Bracket_Type=	open}', "");
    Expect(1, 65378, '\P{^Is_Bidi_Paired_Bracket_Type=	open}', "");
    Expect(0, 65379, '\p{Is_Bidi_Paired_Bracket_Type=	open}', "");
    Expect(1, 65379, '\p{^Is_Bidi_Paired_Bracket_Type=	open}', "");
    Expect(1, 65379, '\P{Is_Bidi_Paired_Bracket_Type=	open}', "");
    Expect(0, 65379, '\P{^Is_Bidi_Paired_Bracket_Type=	open}', "");
    Error('\p{Is_Bpt=-O:=}');
    Error('\P{Is_Bpt=-O:=}');
    Expect(1, 65378, '\p{Is_Bpt=o}', "");
    Expect(0, 65378, '\p{^Is_Bpt=o}', "");
    Expect(0, 65378, '\P{Is_Bpt=o}', "");
    Expect(1, 65378, '\P{^Is_Bpt=o}', "");
    Expect(0, 65379, '\p{Is_Bpt=o}', "");
    Expect(1, 65379, '\p{^Is_Bpt=o}', "");
    Expect(1, 65379, '\P{Is_Bpt=o}', "");
    Expect(0, 65379, '\P{^Is_Bpt=o}', "");
    Expect(1, 65378, '\p{Is_Bpt=	o}', "");
    Expect(0, 65378, '\p{^Is_Bpt=	o}', "");
    Expect(0, 65378, '\P{Is_Bpt=	o}', "");
    Expect(1, 65378, '\P{^Is_Bpt=	o}', "");
    Expect(0, 65379, '\p{Is_Bpt=	o}', "");
    Expect(1, 65379, '\p{^Is_Bpt=	o}', "");
    Expect(1, 65379, '\P{Is_Bpt=	o}', "");
    Expect(0, 65379, '\P{^Is_Bpt=	o}', "");
    Error('\p{Cased=--No:=}');
    Error('\P{Cased=--No:=}');
    Expect(1, 127370, '\p{Cased=no}', "");
    Expect(0, 127370, '\p{^Cased=no}', "");
    Expect(0, 127370, '\P{Cased=no}', "");
    Expect(1, 127370, '\P{^Cased=no}', "");
    Expect(0, 127369, '\p{Cased=no}', "");
    Expect(1, 127369, '\p{^Cased=no}', "");
    Expect(1, 127369, '\P{Cased=no}', "");
    Expect(0, 127369, '\P{^Cased=no}', "");
    Expect(1, 127370, '\p{Cased=_no}', "");
    Expect(0, 127370, '\p{^Cased=_no}', "");
    Expect(0, 127370, '\P{Cased=_no}', "");
    Expect(1, 127370, '\P{^Cased=_no}', "");
    Expect(0, 127369, '\p{Cased=_no}', "");
    Expect(1, 127369, '\p{^Cased=_no}', "");
    Expect(1, 127369, '\P{Cased=_no}', "");
    Expect(0, 127369, '\P{^Cased=_no}', "");
    Error('\p{Is_Cased=/a/N}');
    Error('\P{Is_Cased=/a/N}');
    Expect(1, 127370, '\p{Is_Cased=n}', "");
    Expect(0, 127370, '\p{^Is_Cased=n}', "");
    Expect(0, 127370, '\P{Is_Cased=n}', "");
    Expect(1, 127370, '\P{^Is_Cased=n}', "");
    Expect(0, 127369, '\p{Is_Cased=n}', "");
    Expect(1, 127369, '\p{^Is_Cased=n}', "");
    Expect(1, 127369, '\P{Is_Cased=n}', "");
    Expect(0, 127369, '\P{^Is_Cased=n}', "");
    Expect(1, 127370, '\p{Is_Cased= -N}', "");
    Expect(0, 127370, '\p{^Is_Cased= -N}', "");
    Expect(0, 127370, '\P{Is_Cased= -N}', "");
    Expect(1, 127370, '\P{^Is_Cased= -N}', "");
    Expect(0, 127369, '\p{Is_Cased= -N}', "");
    Expect(1, 127369, '\p{^Is_Cased= -N}', "");
    Expect(1, 127369, '\P{Is_Cased= -N}', "");
    Expect(0, 127369, '\P{^Is_Cased= -N}', "");
    Error('\p{Cased=:=f}');
    Error('\P{Cased=:=f}');
    Expect(1, 127370, '\p{Cased=f}', "");
    Expect(0, 127370, '\p{^Cased=f}', "");
    Expect(0, 127370, '\P{Cased=f}', "");
    Expect(1, 127370, '\P{^Cased=f}', "");
    Expect(0, 127369, '\p{Cased=f}', "");
    Expect(1, 127369, '\p{^Cased=f}', "");
    Expect(1, 127369, '\P{Cased=f}', "");
    Expect(0, 127369, '\P{^Cased=f}', "");
    Expect(1, 127370, '\p{Cased=_	F}', "");
    Expect(0, 127370, '\p{^Cased=_	F}', "");
    Expect(0, 127370, '\P{Cased=_	F}', "");
    Expect(1, 127370, '\P{^Cased=_	F}', "");
    Expect(0, 127369, '\p{Cased=_	F}', "");
    Expect(1, 127369, '\p{^Cased=_	F}', "");
    Expect(1, 127369, '\P{Cased=_	F}', "");
    Expect(0, 127369, '\P{^Cased=_	F}', "");
    Error('\p{Is_Cased=:=-False}');
    Error('\P{Is_Cased=:=-False}');
    Expect(1, 127370, '\p{Is_Cased=false}', "");
    Expect(0, 127370, '\p{^Is_Cased=false}', "");
    Expect(0, 127370, '\P{Is_Cased=false}', "");
    Expect(1, 127370, '\P{^Is_Cased=false}', "");
    Expect(0, 127369, '\p{Is_Cased=false}', "");
    Expect(1, 127369, '\p{^Is_Cased=false}', "");
    Expect(1, 127369, '\P{Is_Cased=false}', "");
    Expect(0, 127369, '\P{^Is_Cased=false}', "");
    Expect(1, 127370, '\p{Is_Cased=_false}', "");
    Expect(0, 127370, '\p{^Is_Cased=_false}', "");
    Expect(0, 127370, '\P{Is_Cased=_false}', "");
    Expect(1, 127370, '\P{^Is_Cased=_false}', "");
    Expect(0, 127369, '\p{Is_Cased=_false}', "");
    Expect(1, 127369, '\p{^Is_Cased=_false}', "");
    Expect(1, 127369, '\P{Is_Cased=_false}', "");
    Expect(0, 127369, '\P{^Is_Cased=_false}', "");
    Error('\p{Cased=:=__YES}');
    Error('\P{Cased=:=__YES}');
    Expect(1, 127369, '\p{Cased=yes}', "");
    Expect(0, 127369, '\p{^Cased=yes}', "");
    Expect(0, 127369, '\P{Cased=yes}', "");
    Expect(1, 127369, '\P{^Cased=yes}', "");
    Expect(0, 127370, '\p{Cased=yes}', "");
    Expect(1, 127370, '\p{^Cased=yes}', "");
    Expect(1, 127370, '\P{Cased=yes}', "");
    Expect(0, 127370, '\P{^Cased=yes}', "");
    Expect(1, 127369, '\p{Cased:_ Yes}', "");
    Expect(0, 127369, '\p{^Cased:_ Yes}', "");
    Expect(0, 127369, '\P{Cased:_ Yes}', "");
    Expect(1, 127369, '\P{^Cased:_ Yes}', "");
    Expect(0, 127370, '\p{Cased:_ Yes}', "");
    Expect(1, 127370, '\p{^Cased:_ Yes}', "");
    Expect(1, 127370, '\P{Cased:_ Yes}', "");
    Expect(0, 127370, '\P{^Cased:_ Yes}', "");
    Error('\p{Is_Cased=:=y}');
    Error('\P{Is_Cased=:=y}');
    Expect(1, 127369, '\p{Is_Cased:   y}', "");
    Expect(0, 127369, '\p{^Is_Cased:   y}', "");
    Expect(0, 127369, '\P{Is_Cased:   y}', "");
    Expect(1, 127369, '\P{^Is_Cased:   y}', "");
    Expect(0, 127370, '\p{Is_Cased:   y}', "");
    Expect(1, 127370, '\p{^Is_Cased:   y}', "");
    Expect(1, 127370, '\P{Is_Cased:   y}', "");
    Expect(0, 127370, '\P{^Is_Cased:   y}', "");
    Expect(1, 127369, '\p{Is_Cased=		y}', "");
    Expect(0, 127369, '\p{^Is_Cased=		y}', "");
    Expect(0, 127369, '\P{Is_Cased=		y}', "");
    Expect(1, 127369, '\P{^Is_Cased=		y}', "");
    Expect(0, 127370, '\p{Is_Cased=		y}', "");
    Expect(1, 127370, '\p{^Is_Cased=		y}', "");
    Expect(1, 127370, '\P{Is_Cased=		y}', "");
    Expect(0, 127370, '\P{^Is_Cased=		y}', "");
    Error('\p{Cased=/a/	-t}');
    Error('\P{Cased=/a/	-t}');
    Expect(1, 127369, '\p{Cased=t}', "");
    Expect(0, 127369, '\p{^Cased=t}', "");
    Expect(0, 127369, '\P{Cased=t}', "");
    Expect(1, 127369, '\P{^Cased=t}', "");
    Expect(0, 127370, '\p{Cased=t}', "");
    Expect(1, 127370, '\p{^Cased=t}', "");
    Expect(1, 127370, '\P{Cased=t}', "");
    Expect(0, 127370, '\P{^Cased=t}', "");
    Expect(1, 127369, '\p{Cased:			T}', "");
    Expect(0, 127369, '\p{^Cased:			T}', "");
    Expect(0, 127369, '\P{Cased:			T}', "");
    Expect(1, 127369, '\P{^Cased:			T}', "");
    Expect(0, 127370, '\p{Cased:			T}', "");
    Expect(1, 127370, '\p{^Cased:			T}', "");
    Expect(1, 127370, '\P{Cased:			T}', "");
    Expect(0, 127370, '\P{^Cased:			T}', "");
    Error('\p{Is_Cased=-:=True}');
    Error('\P{Is_Cased=-:=True}');
    Expect(1, 127369, '\p{Is_Cased: true}', "");
    Expect(0, 127369, '\p{^Is_Cased: true}', "");
    Expect(0, 127369, '\P{Is_Cased: true}', "");
    Expect(1, 127369, '\P{^Is_Cased: true}', "");
    Expect(0, 127370, '\p{Is_Cased: true}', "");
    Expect(1, 127370, '\p{^Is_Cased: true}', "");
    Expect(1, 127370, '\P{Is_Cased: true}', "");
    Expect(0, 127370, '\P{^Is_Cased: true}', "");
    Expect(1, 127369, '\p{Is_Cased=_ TRUE}', "");
    Expect(0, 127369, '\p{^Is_Cased=_ TRUE}', "");
    Expect(0, 127369, '\P{Is_Cased=_ TRUE}', "");
    Expect(1, 127369, '\P{^Is_Cased=_ TRUE}', "");
    Expect(0, 127370, '\p{Is_Cased=_ TRUE}', "");
    Expect(1, 127370, '\p{^Is_Cased=_ TRUE}', "");
    Expect(1, 127370, '\P{Is_Cased=_ TRUE}', "");
    Expect(0, 127370, '\P{^Is_Cased=_ TRUE}', "");
    Error('\p{canonicalcombiningclass}');
    Error('\P{canonicalcombiningclass}');
    Error('\p{ccc}');
    Error('\P{ccc}');
    Error('\p{Canonical_Combining_Class:	-	Above:=}');
    Error('\P{Canonical_Combining_Class:	-	Above:=}');
    Expect(1, 125257, '\p{Canonical_Combining_Class=above}', "");
    Expect(0, 125257, '\p{^Canonical_Combining_Class=above}', "");
    Expect(0, 125257, '\P{Canonical_Combining_Class=above}', "");
    Expect(1, 125257, '\P{^Canonical_Combining_Class=above}', "");
    Expect(0, 125258, '\p{Canonical_Combining_Class=above}', "");
    Expect(1, 125258, '\p{^Canonical_Combining_Class=above}', "");
    Expect(1, 125258, '\P{Canonical_Combining_Class=above}', "");
    Expect(0, 125258, '\P{^Canonical_Combining_Class=above}', "");
    Expect(1, 125257, '\p{Canonical_Combining_Class=	above}', "");
    Expect(0, 125257, '\p{^Canonical_Combining_Class=	above}', "");
    Expect(0, 125257, '\P{Canonical_Combining_Class=	above}', "");
    Expect(1, 125257, '\P{^Canonical_Combining_Class=	above}', "");
    Expect(0, 125258, '\p{Canonical_Combining_Class=	above}', "");
    Expect(1, 125258, '\p{^Canonical_Combining_Class=	above}', "");
    Expect(1, 125258, '\P{Canonical_Combining_Class=	above}', "");
    Expect(0, 125258, '\P{^Canonical_Combining_Class=	above}', "");
    Error('\p{Ccc:  :=A}');
    Error('\P{Ccc:  :=A}');
    Expect(1, 125257, '\p{Ccc=a}', "");
    Expect(0, 125257, '\p{^Ccc=a}', "");
    Expect(0, 125257, '\P{Ccc=a}', "");
    Expect(1, 125257, '\P{^Ccc=a}', "");
    Expect(0, 125258, '\p{Ccc=a}', "");
    Expect(1, 125258, '\p{^Ccc=a}', "");
    Expect(1, 125258, '\P{Ccc=a}', "");
    Expect(0, 125258, '\P{^Ccc=a}', "");
    Expect(1, 125257, '\p{Ccc=-A}', "");
    Expect(0, 125257, '\p{^Ccc=-A}', "");
    Expect(0, 125257, '\P{Ccc=-A}', "");
    Expect(1, 125257, '\P{^Ccc=-A}', "");
    Expect(0, 125258, '\p{Ccc=-A}', "");
    Expect(1, 125258, '\p{^Ccc=-A}', "");
    Expect(1, 125258, '\P{Ccc=-A}', "");
    Expect(0, 125258, '\P{^Ccc=-A}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/ 230}');
    Error('\P{Is_Canonical_Combining_Class=/a/ 230}');
    Expect(1, 125257, '\p{Is_Canonical_Combining_Class=00230}', "");
    Expect(0, 125257, '\p{^Is_Canonical_Combining_Class=00230}', "");
    Expect(0, 125257, '\P{Is_Canonical_Combining_Class=00230}', "");
    Expect(1, 125257, '\P{^Is_Canonical_Combining_Class=00230}', "");
    Expect(0, 125258, '\p{Is_Canonical_Combining_Class=00230}', "");
    Expect(1, 125258, '\p{^Is_Canonical_Combining_Class=00230}', "");
    Expect(1, 125258, '\P{Is_Canonical_Combining_Class=00230}', "");
    Expect(0, 125258, '\P{^Is_Canonical_Combining_Class=00230}', "");
    Error('\p{Is_Ccc=_ABOVE/a/}');
    Error('\P{Is_Ccc=_ABOVE/a/}');
    Expect(1, 125257, '\p{Is_Ccc=above}', "");
    Expect(0, 125257, '\p{^Is_Ccc=above}', "");
    Expect(0, 125257, '\P{Is_Ccc=above}', "");
    Expect(1, 125257, '\P{^Is_Ccc=above}', "");
    Expect(0, 125258, '\p{Is_Ccc=above}', "");
    Expect(1, 125258, '\p{^Is_Ccc=above}', "");
    Expect(1, 125258, '\P{Is_Ccc=above}', "");
    Expect(0, 125258, '\P{^Is_Ccc=above}', "");
    Expect(1, 125257, '\p{Is_Ccc=	_above}', "");
    Expect(0, 125257, '\p{^Is_Ccc=	_above}', "");
    Expect(0, 125257, '\P{Is_Ccc=	_above}', "");
    Expect(1, 125257, '\P{^Is_Ccc=	_above}', "");
    Expect(0, 125258, '\p{Is_Ccc=	_above}', "");
    Expect(1, 125258, '\p{^Is_Ccc=	_above}', "");
    Expect(1, 125258, '\P{Is_Ccc=	_above}', "");
    Expect(0, 125258, '\P{^Is_Ccc=	_above}', "");
    Error('\p{Canonical_Combining_Class=:=-_above_left}');
    Error('\P{Canonical_Combining_Class=:=-_above_left}');
    Expect(1, 12331, '\p{Canonical_Combining_Class=aboveleft}', "");
    Expect(0, 12331, '\p{^Canonical_Combining_Class=aboveleft}', "");
    Expect(0, 12331, '\P{Canonical_Combining_Class=aboveleft}', "");
    Expect(1, 12331, '\P{^Canonical_Combining_Class=aboveleft}', "");
    Expect(0, 12332, '\p{Canonical_Combining_Class=aboveleft}', "");
    Expect(1, 12332, '\p{^Canonical_Combining_Class=aboveleft}', "");
    Expect(1, 12332, '\P{Canonical_Combining_Class=aboveleft}', "");
    Expect(0, 12332, '\P{^Canonical_Combining_Class=aboveleft}', "");
    Expect(1, 12331, '\p{Canonical_Combining_Class=_-above_Left}', "");
    Expect(0, 12331, '\p{^Canonical_Combining_Class=_-above_Left}', "");
    Expect(0, 12331, '\P{Canonical_Combining_Class=_-above_Left}', "");
    Expect(1, 12331, '\P{^Canonical_Combining_Class=_-above_Left}', "");
    Expect(0, 12332, '\p{Canonical_Combining_Class=_-above_Left}', "");
    Expect(1, 12332, '\p{^Canonical_Combining_Class=_-above_Left}', "");
    Expect(1, 12332, '\P{Canonical_Combining_Class=_-above_Left}', "");
    Expect(0, 12332, '\P{^Canonical_Combining_Class=_-above_Left}', "");
    Error('\p{Ccc=:=		AL}');
    Error('\P{Ccc=:=		AL}');
    Expect(1, 12331, '\p{Ccc=al}', "");
    Expect(0, 12331, '\p{^Ccc=al}', "");
    Expect(0, 12331, '\P{Ccc=al}', "");
    Expect(1, 12331, '\P{^Ccc=al}', "");
    Expect(0, 12332, '\p{Ccc=al}', "");
    Expect(1, 12332, '\p{^Ccc=al}', "");
    Expect(1, 12332, '\P{Ccc=al}', "");
    Expect(0, 12332, '\P{^Ccc=al}', "");
    Expect(1, 12331, '\p{Ccc=		AL}', "");
    Expect(0, 12331, '\p{^Ccc=		AL}', "");
    Expect(0, 12331, '\P{Ccc=		AL}', "");
    Expect(1, 12331, '\P{^Ccc=		AL}', "");
    Expect(0, 12332, '\p{Ccc=		AL}', "");
    Expect(1, 12332, '\p{^Ccc=		AL}', "");
    Expect(1, 12332, '\P{Ccc=		AL}', "");
    Expect(0, 12332, '\P{^Ccc=		AL}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/ 	+00228}');
    Error('\P{Is_Canonical_Combining_Class=/a/ 	+00228}');
    Expect(1, 12331, '\p{Is_Canonical_Combining_Class=+228}', "");
    Expect(0, 12331, '\p{^Is_Canonical_Combining_Class=+228}', "");
    Expect(0, 12331, '\P{Is_Canonical_Combining_Class=+228}', "");
    Expect(1, 12331, '\P{^Is_Canonical_Combining_Class=+228}', "");
    Expect(0, 12332, '\p{Is_Canonical_Combining_Class=+228}', "");
    Expect(1, 12332, '\p{^Is_Canonical_Combining_Class=+228}', "");
    Expect(1, 12332, '\P{Is_Canonical_Combining_Class=+228}', "");
    Expect(0, 12332, '\P{^Is_Canonical_Combining_Class=+228}', "");
    Error('\p{Is_Ccc:   	/a/Above_LEFT}');
    Error('\P{Is_Ccc:   	/a/Above_LEFT}');
    Expect(1, 12331, '\p{Is_Ccc=aboveleft}', "");
    Expect(0, 12331, '\p{^Is_Ccc=aboveleft}', "");
    Expect(0, 12331, '\P{Is_Ccc=aboveleft}', "");
    Expect(1, 12331, '\P{^Is_Ccc=aboveleft}', "");
    Expect(0, 12332, '\p{Is_Ccc=aboveleft}', "");
    Expect(1, 12332, '\p{^Is_Ccc=aboveleft}', "");
    Expect(1, 12332, '\P{Is_Ccc=aboveleft}', "");
    Expect(0, 12332, '\P{^Is_Ccc=aboveleft}', "");
    Expect(1, 12331, '\p{Is_Ccc:	-Above_Left}', "");
    Expect(0, 12331, '\p{^Is_Ccc:	-Above_Left}', "");
    Expect(0, 12331, '\P{Is_Ccc:	-Above_Left}', "");
    Expect(1, 12331, '\P{^Is_Ccc:	-Above_Left}', "");
    Expect(0, 12332, '\p{Is_Ccc:	-Above_Left}', "");
    Expect(1, 12332, '\p{^Is_Ccc:	-Above_Left}', "");
    Expect(1, 12332, '\P{Is_Ccc:	-Above_Left}', "");
    Expect(0, 12332, '\P{^Is_Ccc:	-Above_Left}', "");
    Error('\p{Canonical_Combining_Class=	/a/above_right}');
    Error('\P{Canonical_Combining_Class=	/a/above_right}');
    Expect(1, 12332, '\p{Canonical_Combining_Class=aboveright}', "");
    Expect(0, 12332, '\p{^Canonical_Combining_Class=aboveright}', "");
    Expect(0, 12332, '\P{Canonical_Combining_Class=aboveright}', "");
    Expect(1, 12332, '\P{^Canonical_Combining_Class=aboveright}', "");
    Expect(0, 12333, '\p{Canonical_Combining_Class=aboveright}', "");
    Expect(1, 12333, '\p{^Canonical_Combining_Class=aboveright}', "");
    Expect(1, 12333, '\P{Canonical_Combining_Class=aboveright}', "");
    Expect(0, 12333, '\P{^Canonical_Combining_Class=aboveright}', "");
    Expect(1, 12332, '\p{Canonical_Combining_Class=- above_Right}', "");
    Expect(0, 12332, '\p{^Canonical_Combining_Class=- above_Right}', "");
    Expect(0, 12332, '\P{Canonical_Combining_Class=- above_Right}', "");
    Expect(1, 12332, '\P{^Canonical_Combining_Class=- above_Right}', "");
    Expect(0, 12333, '\p{Canonical_Combining_Class=- above_Right}', "");
    Expect(1, 12333, '\p{^Canonical_Combining_Class=- above_Right}', "");
    Expect(1, 12333, '\P{Canonical_Combining_Class=- above_Right}', "");
    Expect(0, 12333, '\P{^Canonical_Combining_Class=- above_Right}', "");
    Error('\p{Ccc= :=AR}');
    Error('\P{Ccc= :=AR}');
    Expect(1, 12332, '\p{Ccc=ar}', "");
    Expect(0, 12332, '\p{^Ccc=ar}', "");
    Expect(0, 12332, '\P{Ccc=ar}', "");
    Expect(1, 12332, '\P{^Ccc=ar}', "");
    Expect(0, 12333, '\p{Ccc=ar}', "");
    Expect(1, 12333, '\p{^Ccc=ar}', "");
    Expect(1, 12333, '\P{Ccc=ar}', "");
    Expect(0, 12333, '\P{^Ccc=ar}', "");
    Expect(1, 12332, '\p{Ccc=_ AR}', "");
    Expect(0, 12332, '\p{^Ccc=_ AR}', "");
    Expect(0, 12332, '\P{Ccc=_ AR}', "");
    Expect(1, 12332, '\P{^Ccc=_ AR}', "");
    Expect(0, 12333, '\p{Ccc=_ AR}', "");
    Expect(1, 12333, '\p{^Ccc=_ AR}', "");
    Expect(1, 12333, '\P{Ccc=_ AR}', "");
    Expect(0, 12333, '\P{^Ccc=_ AR}', "");
    Error('\p{Is_Canonical_Combining_Class=  0_0_0_0_0_0_0232:=}');
    Error('\P{Is_Canonical_Combining_Class=  0_0_0_0_0_0_0232:=}');
    Expect(1, 12332, '\p{Is_Canonical_Combining_Class: 0000232}', "");
    Expect(0, 12332, '\p{^Is_Canonical_Combining_Class: 0000232}', "");
    Expect(0, 12332, '\P{Is_Canonical_Combining_Class: 0000232}', "");
    Expect(1, 12332, '\P{^Is_Canonical_Combining_Class: 0000232}', "");
    Expect(0, 12333, '\p{Is_Canonical_Combining_Class: 0000232}', "");
    Expect(1, 12333, '\p{^Is_Canonical_Combining_Class: 0000232}', "");
    Expect(1, 12333, '\P{Is_Canonical_Combining_Class: 0000232}', "");
    Expect(0, 12333, '\P{^Is_Canonical_Combining_Class: 0000232}', "");
    Error('\p{Is_Ccc=_:=above_Right}');
    Error('\P{Is_Ccc=_:=above_Right}');
    Expect(1, 12332, '\p{Is_Ccc:   aboveright}', "");
    Expect(0, 12332, '\p{^Is_Ccc:   aboveright}', "");
    Expect(0, 12332, '\P{Is_Ccc:   aboveright}', "");
    Expect(1, 12332, '\P{^Is_Ccc:   aboveright}', "");
    Expect(0, 12333, '\p{Is_Ccc:   aboveright}', "");
    Expect(1, 12333, '\p{^Is_Ccc:   aboveright}', "");
    Expect(1, 12333, '\P{Is_Ccc:   aboveright}', "");
    Expect(0, 12333, '\P{^Is_Ccc:   aboveright}', "");
    Expect(1, 12332, '\p{Is_Ccc= ABOVE_right}', "");
    Expect(0, 12332, '\p{^Is_Ccc= ABOVE_right}', "");
    Expect(0, 12332, '\P{Is_Ccc= ABOVE_right}', "");
    Expect(1, 12332, '\P{^Is_Ccc= ABOVE_right}', "");
    Expect(0, 12333, '\p{Is_Ccc= ABOVE_right}', "");
    Expect(1, 12333, '\p{^Is_Ccc= ABOVE_right}', "");
    Expect(1, 12333, '\P{Is_Ccc= ABOVE_right}', "");
    Expect(0, 12333, '\P{^Is_Ccc= ABOVE_right}', "");
    Error('\p{Canonical_Combining_Class=/a/	_attached_Above}');
    Error('\P{Canonical_Combining_Class=/a/	_attached_Above}');
    Expect(1, 7630, '\p{Canonical_Combining_Class=attachedabove}', "");
    Expect(0, 7630, '\p{^Canonical_Combining_Class=attachedabove}', "");
    Expect(0, 7630, '\P{Canonical_Combining_Class=attachedabove}', "");
    Expect(1, 7630, '\P{^Canonical_Combining_Class=attachedabove}', "");
    Expect(0, 7631, '\p{Canonical_Combining_Class=attachedabove}', "");
    Expect(1, 7631, '\p{^Canonical_Combining_Class=attachedabove}', "");
    Expect(1, 7631, '\P{Canonical_Combining_Class=attachedabove}', "");
    Expect(0, 7631, '\P{^Canonical_Combining_Class=attachedabove}', "");
    Expect(1, 7630, '\p{Canonical_Combining_Class=- Attached_ABOVE}', "");
    Expect(0, 7630, '\p{^Canonical_Combining_Class=- Attached_ABOVE}', "");
    Expect(0, 7630, '\P{Canonical_Combining_Class=- Attached_ABOVE}', "");
    Expect(1, 7630, '\P{^Canonical_Combining_Class=- Attached_ABOVE}', "");
    Expect(0, 7631, '\p{Canonical_Combining_Class=- Attached_ABOVE}', "");
    Expect(1, 7631, '\p{^Canonical_Combining_Class=- Attached_ABOVE}', "");
    Expect(1, 7631, '\P{Canonical_Combining_Class=- Attached_ABOVE}', "");
    Expect(0, 7631, '\P{^Canonical_Combining_Class=- Attached_ABOVE}', "");
    Error('\p{Ccc=-:=ATA}');
    Error('\P{Ccc=-:=ATA}');
    Expect(1, 7630, '\p{Ccc=ata}', "");
    Expect(0, 7630, '\p{^Ccc=ata}', "");
    Expect(0, 7630, '\P{Ccc=ata}', "");
    Expect(1, 7630, '\P{^Ccc=ata}', "");
    Expect(0, 7631, '\p{Ccc=ata}', "");
    Expect(1, 7631, '\p{^Ccc=ata}', "");
    Expect(1, 7631, '\P{Ccc=ata}', "");
    Expect(0, 7631, '\P{^Ccc=ata}', "");
    Expect(1, 7630, '\p{Ccc:	 ATA}', "");
    Expect(0, 7630, '\p{^Ccc:	 ATA}', "");
    Expect(0, 7630, '\P{Ccc:	 ATA}', "");
    Expect(1, 7630, '\P{^Ccc:	 ATA}', "");
    Expect(0, 7631, '\p{Ccc:	 ATA}', "");
    Expect(1, 7631, '\p{^Ccc:	 ATA}', "");
    Expect(1, 7631, '\P{Ccc:	 ATA}', "");
    Expect(0, 7631, '\P{^Ccc:	 ATA}', "");
    Error('\p{Is_Canonical_Combining_Class=	_0_2_14/a/}');
    Error('\P{Is_Canonical_Combining_Class=	_0_2_14/a/}');
    Expect(1, 7630, '\p{Is_Canonical_Combining_Class=0_0_0_0_0_0_0_0_214}', "");
    Expect(0, 7630, '\p{^Is_Canonical_Combining_Class=0_0_0_0_0_0_0_0_214}', "");
    Expect(0, 7630, '\P{Is_Canonical_Combining_Class=0_0_0_0_0_0_0_0_214}', "");
    Expect(1, 7630, '\P{^Is_Canonical_Combining_Class=0_0_0_0_0_0_0_0_214}', "");
    Expect(0, 7631, '\p{Is_Canonical_Combining_Class=0_0_0_0_0_0_0_0_214}', "");
    Expect(1, 7631, '\p{^Is_Canonical_Combining_Class=0_0_0_0_0_0_0_0_214}', "");
    Expect(1, 7631, '\P{Is_Canonical_Combining_Class=0_0_0_0_0_0_0_0_214}', "");
    Expect(0, 7631, '\P{^Is_Canonical_Combining_Class=0_0_0_0_0_0_0_0_214}', "");
    Error('\p{Is_Ccc=/a/  Attached_ABOVE}');
    Error('\P{Is_Ccc=/a/  Attached_ABOVE}');
    Expect(1, 7630, '\p{Is_Ccc=attachedabove}', "");
    Expect(0, 7630, '\p{^Is_Ccc=attachedabove}', "");
    Expect(0, 7630, '\P{Is_Ccc=attachedabove}', "");
    Expect(1, 7630, '\P{^Is_Ccc=attachedabove}', "");
    Expect(0, 7631, '\p{Is_Ccc=attachedabove}', "");
    Expect(1, 7631, '\p{^Is_Ccc=attachedabove}', "");
    Expect(1, 7631, '\P{Is_Ccc=attachedabove}', "");
    Expect(0, 7631, '\P{^Is_Ccc=attachedabove}', "");
    Expect(1, 7630, '\p{Is_Ccc= _Attached_Above}', "");
    Expect(0, 7630, '\p{^Is_Ccc= _Attached_Above}', "");
    Expect(0, 7630, '\P{Is_Ccc= _Attached_Above}', "");
    Expect(1, 7630, '\P{^Is_Ccc= _Attached_Above}', "");
    Expect(0, 7631, '\p{Is_Ccc= _Attached_Above}', "");
    Expect(1, 7631, '\p{^Is_Ccc= _Attached_Above}', "");
    Expect(1, 7631, '\P{Is_Ccc= _Attached_Above}', "");
    Expect(0, 7631, '\P{^Is_Ccc= _Attached_Above}', "");
    Error('\p{Canonical_Combining_Class= -Attached_Above_Right/a/}');
    Error('\P{Canonical_Combining_Class= -Attached_Above_Right/a/}');
    Expect(1, 119154, '\p{Canonical_Combining_Class:attachedaboveright}', "");
    Expect(0, 119154, '\p{^Canonical_Combining_Class:attachedaboveright}', "");
    Expect(0, 119154, '\P{Canonical_Combining_Class:attachedaboveright}', "");
    Expect(1, 119154, '\P{^Canonical_Combining_Class:attachedaboveright}', "");
    Expect(0, 119155, '\p{Canonical_Combining_Class:attachedaboveright}', "");
    Expect(1, 119155, '\p{^Canonical_Combining_Class:attachedaboveright}', "");
    Expect(1, 119155, '\P{Canonical_Combining_Class:attachedaboveright}', "");
    Expect(0, 119155, '\P{^Canonical_Combining_Class:attachedaboveright}', "");
    Expect(1, 119154, '\p{Canonical_Combining_Class=- Attached_above_right}', "");
    Expect(0, 119154, '\p{^Canonical_Combining_Class=- Attached_above_right}', "");
    Expect(0, 119154, '\P{Canonical_Combining_Class=- Attached_above_right}', "");
    Expect(1, 119154, '\P{^Canonical_Combining_Class=- Attached_above_right}', "");
    Expect(0, 119155, '\p{Canonical_Combining_Class=- Attached_above_right}', "");
    Expect(1, 119155, '\p{^Canonical_Combining_Class=- Attached_above_right}', "");
    Expect(1, 119155, '\P{Canonical_Combining_Class=- Attached_above_right}', "");
    Expect(0, 119155, '\P{^Canonical_Combining_Class=- Attached_above_right}', "");
    Error('\p{Ccc=/a/ ATAR}');
    Error('\P{Ccc=/a/ ATAR}');
    Expect(1, 119154, '\p{Ccc=atar}', "");
    Expect(0, 119154, '\p{^Ccc=atar}', "");
    Expect(0, 119154, '\P{Ccc=atar}', "");
    Expect(1, 119154, '\P{^Ccc=atar}', "");
    Expect(0, 119155, '\p{Ccc=atar}', "");
    Expect(1, 119155, '\p{^Ccc=atar}', "");
    Expect(1, 119155, '\P{Ccc=atar}', "");
    Expect(0, 119155, '\P{^Ccc=atar}', "");
    Expect(1, 119154, '\p{Ccc=_ATAR}', "");
    Expect(0, 119154, '\p{^Ccc=_ATAR}', "");
    Expect(0, 119154, '\P{Ccc=_ATAR}', "");
    Expect(1, 119154, '\P{^Ccc=_ATAR}', "");
    Expect(0, 119155, '\p{Ccc=_ATAR}', "");
    Expect(1, 119155, '\p{^Ccc=_ATAR}', "");
    Expect(1, 119155, '\P{Ccc=_ATAR}', "");
    Expect(0, 119155, '\P{^Ccc=_ATAR}', "");
    Error('\p{Is_Canonical_Combining_Class=-/a/000000000216}');
    Error('\P{Is_Canonical_Combining_Class=-/a/000000000216}');
    Expect(1, 119154, '\p{Is_Canonical_Combining_Class=+0216}', "");
    Expect(0, 119154, '\p{^Is_Canonical_Combining_Class=+0216}', "");
    Expect(0, 119154, '\P{Is_Canonical_Combining_Class=+0216}', "");
    Expect(1, 119154, '\P{^Is_Canonical_Combining_Class=+0216}', "");
    Expect(0, 119155, '\p{Is_Canonical_Combining_Class=+0216}', "");
    Expect(1, 119155, '\p{^Is_Canonical_Combining_Class=+0216}', "");
    Expect(1, 119155, '\P{Is_Canonical_Combining_Class=+0216}', "");
    Expect(0, 119155, '\P{^Is_Canonical_Combining_Class=+0216}', "");
    Error('\p{Is_Ccc=_Attached_ABOVE_Right/a/}');
    Error('\P{Is_Ccc=_Attached_ABOVE_Right/a/}');
    Expect(1, 119154, '\p{Is_Ccc=attachedaboveright}', "");
    Expect(0, 119154, '\p{^Is_Ccc=attachedaboveright}', "");
    Expect(0, 119154, '\P{Is_Ccc=attachedaboveright}', "");
    Expect(1, 119154, '\P{^Is_Ccc=attachedaboveright}', "");
    Expect(0, 119155, '\p{Is_Ccc=attachedaboveright}', "");
    Expect(1, 119155, '\p{^Is_Ccc=attachedaboveright}', "");
    Expect(1, 119155, '\P{Is_Ccc=attachedaboveright}', "");
    Expect(0, 119155, '\P{^Is_Ccc=attachedaboveright}', "");
    Expect(1, 119154, '\p{Is_Ccc=-_Attached_Above_right}', "");
    Expect(0, 119154, '\p{^Is_Ccc=-_Attached_Above_right}', "");
    Expect(0, 119154, '\P{Is_Ccc=-_Attached_Above_right}', "");
    Expect(1, 119154, '\P{^Is_Ccc=-_Attached_Above_right}', "");
    Expect(0, 119155, '\p{Is_Ccc=-_Attached_Above_right}', "");
    Expect(1, 119155, '\p{^Is_Ccc=-_Attached_Above_right}', "");
    Expect(1, 119155, '\P{Is_Ccc=-_Attached_Above_right}', "");
    Expect(0, 119155, '\P{^Is_Ccc=-_Attached_Above_right}', "");
    Error('\p{Canonical_Combining_Class: 	ATTACHED_Below:=}');
    Error('\P{Canonical_Combining_Class: 	ATTACHED_Below:=}');
    Expect(1, 7632, '\p{Canonical_Combining_Class=attachedbelow}', "");
    Expect(0, 7632, '\p{^Canonical_Combining_Class=attachedbelow}', "");
    Expect(0, 7632, '\P{Canonical_Combining_Class=attachedbelow}', "");
    Expect(1, 7632, '\P{^Canonical_Combining_Class=attachedbelow}', "");
    Expect(0, 7633, '\p{Canonical_Combining_Class=attachedbelow}', "");
    Expect(1, 7633, '\p{^Canonical_Combining_Class=attachedbelow}', "");
    Expect(1, 7633, '\P{Canonical_Combining_Class=attachedbelow}', "");
    Expect(0, 7633, '\P{^Canonical_Combining_Class=attachedbelow}', "");
    Expect(1, 7632, '\p{Canonical_Combining_Class=-ATTACHED_BELOW}', "");
    Expect(0, 7632, '\p{^Canonical_Combining_Class=-ATTACHED_BELOW}', "");
    Expect(0, 7632, '\P{Canonical_Combining_Class=-ATTACHED_BELOW}', "");
    Expect(1, 7632, '\P{^Canonical_Combining_Class=-ATTACHED_BELOW}', "");
    Expect(0, 7633, '\p{Canonical_Combining_Class=-ATTACHED_BELOW}', "");
    Expect(1, 7633, '\p{^Canonical_Combining_Class=-ATTACHED_BELOW}', "");
    Expect(1, 7633, '\P{Canonical_Combining_Class=-ATTACHED_BELOW}', "");
    Expect(0, 7633, '\P{^Canonical_Combining_Class=-ATTACHED_BELOW}', "");
    Error('\p{Ccc=_-ATB:=}');
    Error('\P{Ccc=_-ATB:=}');
    Expect(1, 7632, '\p{Ccc=atb}', "");
    Expect(0, 7632, '\p{^Ccc=atb}', "");
    Expect(0, 7632, '\P{Ccc=atb}', "");
    Expect(1, 7632, '\P{^Ccc=atb}', "");
    Expect(0, 7633, '\p{Ccc=atb}', "");
    Expect(1, 7633, '\p{^Ccc=atb}', "");
    Expect(1, 7633, '\P{Ccc=atb}', "");
    Expect(0, 7633, '\P{^Ccc=atb}', "");
    Expect(1, 7632, '\p{Ccc=-	ATB}', "");
    Expect(0, 7632, '\p{^Ccc=-	ATB}', "");
    Expect(0, 7632, '\P{Ccc=-	ATB}', "");
    Expect(1, 7632, '\P{^Ccc=-	ATB}', "");
    Expect(0, 7633, '\p{Ccc=-	ATB}', "");
    Expect(1, 7633, '\p{^Ccc=-	ATB}', "");
    Expect(1, 7633, '\P{Ccc=-	ATB}', "");
    Expect(0, 7633, '\P{^Ccc=-	ATB}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/	-00000202}');
    Error('\P{Is_Canonical_Combining_Class=/a/	-00000202}');
    Expect(1, 7632, '\p{Is_Canonical_Combining_Class=0_0_0_0_0_0_2_02}', "");
    Expect(0, 7632, '\p{^Is_Canonical_Combining_Class=0_0_0_0_0_0_2_02}', "");
    Expect(0, 7632, '\P{Is_Canonical_Combining_Class=0_0_0_0_0_0_2_02}', "");
    Expect(1, 7632, '\P{^Is_Canonical_Combining_Class=0_0_0_0_0_0_2_02}', "");
    Expect(0, 7633, '\p{Is_Canonical_Combining_Class=0_0_0_0_0_0_2_02}', "");
    Expect(1, 7633, '\p{^Is_Canonical_Combining_Class=0_0_0_0_0_0_2_02}', "");
    Expect(1, 7633, '\P{Is_Canonical_Combining_Class=0_0_0_0_0_0_2_02}', "");
    Expect(0, 7633, '\P{^Is_Canonical_Combining_Class=0_0_0_0_0_0_2_02}', "");
    Error('\p{Is_Ccc=_/a/Attached_below}');
    Error('\P{Is_Ccc=_/a/Attached_below}');
    Expect(1, 7632, '\p{Is_Ccc=attachedbelow}', "");
    Expect(0, 7632, '\p{^Is_Ccc=attachedbelow}', "");
    Expect(0, 7632, '\P{Is_Ccc=attachedbelow}', "");
    Expect(1, 7632, '\P{^Is_Ccc=attachedbelow}', "");
    Expect(0, 7633, '\p{Is_Ccc=attachedbelow}', "");
    Expect(1, 7633, '\p{^Is_Ccc=attachedbelow}', "");
    Expect(1, 7633, '\P{Is_Ccc=attachedbelow}', "");
    Expect(0, 7633, '\P{^Is_Ccc=attachedbelow}', "");
    Expect(1, 7632, '\p{Is_Ccc= _attached_BELOW}', "");
    Expect(0, 7632, '\p{^Is_Ccc= _attached_BELOW}', "");
    Expect(0, 7632, '\P{Is_Ccc= _attached_BELOW}', "");
    Expect(1, 7632, '\P{^Is_Ccc= _attached_BELOW}', "");
    Expect(0, 7633, '\p{Is_Ccc= _attached_BELOW}', "");
    Expect(1, 7633, '\p{^Is_Ccc= _attached_BELOW}', "");
    Expect(1, 7633, '\P{Is_Ccc= _attached_BELOW}', "");
    Expect(0, 7633, '\P{^Is_Ccc= _attached_BELOW}', "");
    Error('\p{Canonical_Combining_Class=_/a/Attached_Below_Left}');
    Error('\P{Canonical_Combining_Class=_/a/Attached_Below_Left}');
    Expect(0, 1, '\p{Canonical_Combining_Class=attachedbelowleft}', "");
    Expect(1, 1, '\p{^Canonical_Combining_Class=attachedbelowleft}', "");
    Expect(1, 1, '\P{Canonical_Combining_Class=attachedbelowleft}', "");
    Expect(0, 1, '\P{^Canonical_Combining_Class=attachedbelowleft}', "");
    Expect(0, 1, '\p{Canonical_Combining_Class=_	Attached_below_left}', "");
    Expect(1, 1, '\p{^Canonical_Combining_Class=_	Attached_below_left}', "");
    Expect(1, 1, '\P{Canonical_Combining_Class=_	Attached_below_left}', "");
    Expect(0, 1, '\P{^Canonical_Combining_Class=_	Attached_below_left}', "");
    Error('\p{Ccc=_-atbl/a/}');
    Error('\P{Ccc=_-atbl/a/}');
    Expect(0, 1, '\p{Ccc=atbl}', "");
    Expect(1, 1, '\p{^Ccc=atbl}', "");
    Expect(1, 1, '\P{Ccc=atbl}', "");
    Expect(0, 1, '\P{^Ccc=atbl}', "");
    Expect(0, 1, '\p{Ccc= _ATBL}', "");
    Expect(1, 1, '\p{^Ccc= _ATBL}', "");
    Expect(1, 1, '\P{Ccc= _ATBL}', "");
    Expect(0, 1, '\P{^Ccc= _ATBL}', "");
    Error('\p{Is_Canonical_Combining_Class=_:=20_0}');
    Error('\P{Is_Canonical_Combining_Class=_:=20_0}');
    Expect(0, 1, '\p{Is_Canonical_Combining_Class=00000200}', "");
    Expect(1, 1, '\p{^Is_Canonical_Combining_Class=00000200}', "");
    Expect(1, 1, '\P{Is_Canonical_Combining_Class=00000200}', "");
    Expect(0, 1, '\P{^Is_Canonical_Combining_Class=00000200}', "");
    Error('\p{Is_Ccc=-:=Attached_Below_Left}');
    Error('\P{Is_Ccc=-:=Attached_Below_Left}');
    Expect(0, 1, '\p{Is_Ccc:attachedbelowleft}', "");
    Expect(1, 1, '\p{^Is_Ccc:attachedbelowleft}', "");
    Expect(1, 1, '\P{Is_Ccc:attachedbelowleft}', "");
    Expect(0, 1, '\P{^Is_Ccc:attachedbelowleft}', "");
    Expect(0, 1, '\p{Is_Ccc=_ATTACHED_Below_Left}', "");
    Expect(1, 1, '\p{^Is_Ccc=_ATTACHED_Below_Left}', "");
    Expect(1, 1, '\P{Is_Ccc=_ATTACHED_Below_Left}', "");
    Expect(0, 1, '\P{^Is_Ccc=_ATTACHED_Below_Left}', "");
    Error('\p{Canonical_Combining_Class=_Below/a/}');
    Error('\P{Canonical_Combining_Class=_Below/a/}');
    Expect(1, 125142, '\p{Canonical_Combining_Class=below}', "");
    Expect(0, 125142, '\p{^Canonical_Combining_Class=below}', "");
    Expect(0, 125142, '\P{Canonical_Combining_Class=below}', "");
    Expect(1, 125142, '\P{^Canonical_Combining_Class=below}', "");
    Expect(0, 125143, '\p{Canonical_Combining_Class=below}', "");
    Expect(1, 125143, '\p{^Canonical_Combining_Class=below}', "");
    Expect(1, 125143, '\P{Canonical_Combining_Class=below}', "");
    Expect(0, 125143, '\P{^Canonical_Combining_Class=below}', "");
    Expect(1, 125142, '\p{Canonical_Combining_Class= BELOW}', "");
    Expect(0, 125142, '\p{^Canonical_Combining_Class= BELOW}', "");
    Expect(0, 125142, '\P{Canonical_Combining_Class= BELOW}', "");
    Expect(1, 125142, '\P{^Canonical_Combining_Class= BELOW}', "");
    Expect(0, 125143, '\p{Canonical_Combining_Class= BELOW}', "");
    Expect(1, 125143, '\p{^Canonical_Combining_Class= BELOW}', "");
    Expect(1, 125143, '\P{Canonical_Combining_Class= BELOW}', "");
    Expect(0, 125143, '\P{^Canonical_Combining_Class= BELOW}', "");
    Error('\p{Ccc: -/a/B}');
    Error('\P{Ccc: -/a/B}');
    Expect(1, 125142, '\p{Ccc: b}', "");
    Expect(0, 125142, '\p{^Ccc: b}', "");
    Expect(0, 125142, '\P{Ccc: b}', "");
    Expect(1, 125142, '\P{^Ccc: b}', "");
    Expect(0, 125143, '\p{Ccc: b}', "");
    Expect(1, 125143, '\p{^Ccc: b}', "");
    Expect(1, 125143, '\P{Ccc: b}', "");
    Expect(0, 125143, '\P{^Ccc: b}', "");
    Expect(1, 125142, '\p{Ccc=	_B}', "");
    Expect(0, 125142, '\p{^Ccc=	_B}', "");
    Expect(0, 125142, '\P{Ccc=	_B}', "");
    Expect(1, 125142, '\P{^Ccc=	_B}', "");
    Expect(0, 125143, '\p{Ccc=	_B}', "");
    Expect(1, 125143, '\p{^Ccc=	_B}', "");
    Expect(1, 125143, '\P{Ccc=	_B}', "");
    Expect(0, 125143, '\P{^Ccc=	_B}', "");
    Error('\p{Is_Canonical_Combining_Class=:=+000022_0}');
    Error('\P{Is_Canonical_Combining_Class=:=+000022_0}');
    Expect(1, 125142, '\p{Is_Canonical_Combining_Class=0_2_20}', "");
    Expect(0, 125142, '\p{^Is_Canonical_Combining_Class=0_2_20}', "");
    Expect(0, 125142, '\P{Is_Canonical_Combining_Class=0_2_20}', "");
    Expect(1, 125142, '\P{^Is_Canonical_Combining_Class=0_2_20}', "");
    Expect(0, 125143, '\p{Is_Canonical_Combining_Class=0_2_20}', "");
    Expect(1, 125143, '\p{^Is_Canonical_Combining_Class=0_2_20}', "");
    Expect(1, 125143, '\P{Is_Canonical_Combining_Class=0_2_20}', "");
    Expect(0, 125143, '\P{^Is_Canonical_Combining_Class=0_2_20}', "");
    Error('\p{Is_Ccc=:=	BELOW}');
    Error('\P{Is_Ccc=:=	BELOW}');
    Expect(1, 125142, '\p{Is_Ccc=below}', "");
    Expect(0, 125142, '\p{^Is_Ccc=below}', "");
    Expect(0, 125142, '\P{Is_Ccc=below}', "");
    Expect(1, 125142, '\P{^Is_Ccc=below}', "");
    Expect(0, 125143, '\p{Is_Ccc=below}', "");
    Expect(1, 125143, '\p{^Is_Ccc=below}', "");
    Expect(1, 125143, '\P{Is_Ccc=below}', "");
    Expect(0, 125143, '\P{^Is_Ccc=below}', "");
    Expect(1, 125142, '\p{Is_Ccc=	-BELOW}', "");
    Expect(0, 125142, '\p{^Is_Ccc=	-BELOW}', "");
    Expect(0, 125142, '\P{Is_Ccc=	-BELOW}', "");
    Expect(1, 125142, '\P{^Is_Ccc=	-BELOW}', "");
    Expect(0, 125143, '\p{Is_Ccc=	-BELOW}', "");
    Expect(1, 125143, '\p{^Is_Ccc=	-BELOW}', "");
    Expect(1, 125143, '\P{Is_Ccc=	-BELOW}', "");
    Expect(0, 125143, '\P{^Is_Ccc=	-BELOW}', "");
    Error('\p{Canonical_Combining_Class=	/a/below_LEFT}');
    Error('\P{Canonical_Combining_Class=	/a/below_LEFT}');
    Expect(1, 12330, '\p{Canonical_Combining_Class=belowleft}', "");
    Expect(0, 12330, '\p{^Canonical_Combining_Class=belowleft}', "");
    Expect(0, 12330, '\P{Canonical_Combining_Class=belowleft}', "");
    Expect(1, 12330, '\P{^Canonical_Combining_Class=belowleft}', "");
    Expect(0, 12331, '\p{Canonical_Combining_Class=belowleft}', "");
    Expect(1, 12331, '\p{^Canonical_Combining_Class=belowleft}', "");
    Expect(1, 12331, '\P{Canonical_Combining_Class=belowleft}', "");
    Expect(0, 12331, '\P{^Canonical_Combining_Class=belowleft}', "");
    Expect(1, 12330, '\p{Canonical_Combining_Class=- below_left}', "");
    Expect(0, 12330, '\p{^Canonical_Combining_Class=- below_left}', "");
    Expect(0, 12330, '\P{Canonical_Combining_Class=- below_left}', "");
    Expect(1, 12330, '\P{^Canonical_Combining_Class=- below_left}', "");
    Expect(0, 12331, '\p{Canonical_Combining_Class=- below_left}', "");
    Expect(1, 12331, '\p{^Canonical_Combining_Class=- below_left}', "");
    Expect(1, 12331, '\P{Canonical_Combining_Class=- below_left}', "");
    Expect(0, 12331, '\P{^Canonical_Combining_Class=- below_left}', "");
    Error('\p{Ccc=_BL:=}');
    Error('\P{Ccc=_BL:=}');
    Expect(1, 12330, '\p{Ccc:   bl}', "");
    Expect(0, 12330, '\p{^Ccc:   bl}', "");
    Expect(0, 12330, '\P{Ccc:   bl}', "");
    Expect(1, 12330, '\P{^Ccc:   bl}', "");
    Expect(0, 12331, '\p{Ccc:   bl}', "");
    Expect(1, 12331, '\p{^Ccc:   bl}', "");
    Expect(1, 12331, '\P{Ccc:   bl}', "");
    Expect(0, 12331, '\P{^Ccc:   bl}', "");
    Expect(1, 12330, '\p{Ccc=_ BL}', "");
    Expect(0, 12330, '\p{^Ccc=_ BL}', "");
    Expect(0, 12330, '\P{Ccc=_ BL}', "");
    Expect(1, 12330, '\P{^Ccc=_ BL}', "");
    Expect(0, 12331, '\p{Ccc=_ BL}', "");
    Expect(1, 12331, '\p{^Ccc=_ BL}', "");
    Expect(1, 12331, '\P{Ccc=_ BL}', "");
    Expect(0, 12331, '\P{^Ccc=_ BL}', "");
    Error('\p{Is_Canonical_Combining_Class=	/a/+00000218}');
    Error('\P{Is_Canonical_Combining_Class=	/a/+00000218}');
    Expect(1, 12330, '\p{Is_Canonical_Combining_Class=+218}', "");
    Expect(0, 12330, '\p{^Is_Canonical_Combining_Class=+218}', "");
    Expect(0, 12330, '\P{Is_Canonical_Combining_Class=+218}', "");
    Expect(1, 12330, '\P{^Is_Canonical_Combining_Class=+218}', "");
    Expect(0, 12331, '\p{Is_Canonical_Combining_Class=+218}', "");
    Expect(1, 12331, '\p{^Is_Canonical_Combining_Class=+218}', "");
    Expect(1, 12331, '\P{Is_Canonical_Combining_Class=+218}', "");
    Expect(0, 12331, '\P{^Is_Canonical_Combining_Class=+218}', "");
    Error('\p{Is_Ccc:   :=	below_LEFT}');
    Error('\P{Is_Ccc:   :=	below_LEFT}');
    Expect(1, 12330, '\p{Is_Ccc=belowleft}', "");
    Expect(0, 12330, '\p{^Is_Ccc=belowleft}', "");
    Expect(0, 12330, '\P{Is_Ccc=belowleft}', "");
    Expect(1, 12330, '\P{^Is_Ccc=belowleft}', "");
    Expect(0, 12331, '\p{Is_Ccc=belowleft}', "");
    Expect(1, 12331, '\p{^Is_Ccc=belowleft}', "");
    Expect(1, 12331, '\P{Is_Ccc=belowleft}', "");
    Expect(0, 12331, '\P{^Is_Ccc=belowleft}', "");
    Expect(1, 12330, '\p{Is_Ccc=-Below_LEFT}', "");
    Expect(0, 12330, '\p{^Is_Ccc=-Below_LEFT}', "");
    Expect(0, 12330, '\P{Is_Ccc=-Below_LEFT}', "");
    Expect(1, 12330, '\P{^Is_Ccc=-Below_LEFT}', "");
    Expect(0, 12331, '\p{Is_Ccc=-Below_LEFT}', "");
    Expect(1, 12331, '\p{^Is_Ccc=-Below_LEFT}', "");
    Expect(1, 12331, '\P{Is_Ccc=-Below_LEFT}', "");
    Expect(0, 12331, '\P{^Is_Ccc=-Below_LEFT}', "");
    Error('\p{Canonical_Combining_Class=	/a/below_Right}');
    Error('\P{Canonical_Combining_Class=	/a/below_Right}');
    Expect(1, 12333, '\p{Canonical_Combining_Class=belowright}', "");
    Expect(0, 12333, '\p{^Canonical_Combining_Class=belowright}', "");
    Expect(0, 12333, '\P{Canonical_Combining_Class=belowright}', "");
    Expect(1, 12333, '\P{^Canonical_Combining_Class=belowright}', "");
    Expect(0, 12334, '\p{Canonical_Combining_Class=belowright}', "");
    Expect(1, 12334, '\p{^Canonical_Combining_Class=belowright}', "");
    Expect(1, 12334, '\P{Canonical_Combining_Class=belowright}', "");
    Expect(0, 12334, '\P{^Canonical_Combining_Class=belowright}', "");
    Expect(1, 12333, '\p{Canonical_Combining_Class=_Below_Right}', "");
    Expect(0, 12333, '\p{^Canonical_Combining_Class=_Below_Right}', "");
    Expect(0, 12333, '\P{Canonical_Combining_Class=_Below_Right}', "");
    Expect(1, 12333, '\P{^Canonical_Combining_Class=_Below_Right}', "");
    Expect(0, 12334, '\p{Canonical_Combining_Class=_Below_Right}', "");
    Expect(1, 12334, '\p{^Canonical_Combining_Class=_Below_Right}', "");
    Expect(1, 12334, '\P{Canonical_Combining_Class=_Below_Right}', "");
    Expect(0, 12334, '\P{^Canonical_Combining_Class=_Below_Right}', "");
    Error('\p{Ccc=_br:=}');
    Error('\P{Ccc=_br:=}');
    Expect(1, 12333, '\p{Ccc=br}', "");
    Expect(0, 12333, '\p{^Ccc=br}', "");
    Expect(0, 12333, '\P{Ccc=br}', "");
    Expect(1, 12333, '\P{^Ccc=br}', "");
    Expect(0, 12334, '\p{Ccc=br}', "");
    Expect(1, 12334, '\p{^Ccc=br}', "");
    Expect(1, 12334, '\P{Ccc=br}', "");
    Expect(0, 12334, '\P{^Ccc=br}', "");
    Expect(1, 12333, '\p{Ccc:_ br}', "");
    Expect(0, 12333, '\p{^Ccc:_ br}', "");
    Expect(0, 12333, '\P{Ccc:_ br}', "");
    Expect(1, 12333, '\P{^Ccc:_ br}', "");
    Expect(0, 12334, '\p{Ccc:_ br}', "");
    Expect(1, 12334, '\p{^Ccc:_ br}', "");
    Expect(1, 12334, '\P{Ccc:_ br}', "");
    Expect(0, 12334, '\P{^Ccc:_ br}', "");
    Error('\p{Is_Canonical_Combining_Class::=-+0_0_0_0_0_0_0_0_0222}');
    Error('\P{Is_Canonical_Combining_Class::=-+0_0_0_0_0_0_0_0_0222}');
    Expect(1, 12333, '\p{Is_Canonical_Combining_Class=+0_0_0_0_0_0_0_00222}', "");
    Expect(0, 12333, '\p{^Is_Canonical_Combining_Class=+0_0_0_0_0_0_0_00222}', "");
    Expect(0, 12333, '\P{Is_Canonical_Combining_Class=+0_0_0_0_0_0_0_00222}', "");
    Expect(1, 12333, '\P{^Is_Canonical_Combining_Class=+0_0_0_0_0_0_0_00222}', "");
    Expect(0, 12334, '\p{Is_Canonical_Combining_Class=+0_0_0_0_0_0_0_00222}', "");
    Expect(1, 12334, '\p{^Is_Canonical_Combining_Class=+0_0_0_0_0_0_0_00222}', "");
    Expect(1, 12334, '\P{Is_Canonical_Combining_Class=+0_0_0_0_0_0_0_00222}', "");
    Expect(0, 12334, '\P{^Is_Canonical_Combining_Class=+0_0_0_0_0_0_0_00222}', "");
    Error('\p{Is_Ccc=_/a/Below_Right}');
    Error('\P{Is_Ccc=_/a/Below_Right}');
    Expect(1, 12333, '\p{Is_Ccc=belowright}', "");
    Expect(0, 12333, '\p{^Is_Ccc=belowright}', "");
    Expect(0, 12333, '\P{Is_Ccc=belowright}', "");
    Expect(1, 12333, '\P{^Is_Ccc=belowright}', "");
    Expect(0, 12334, '\p{Is_Ccc=belowright}', "");
    Expect(1, 12334, '\p{^Is_Ccc=belowright}', "");
    Expect(1, 12334, '\P{Is_Ccc=belowright}', "");
    Expect(0, 12334, '\P{^Is_Ccc=belowright}', "");
    Expect(1, 12333, '\p{Is_Ccc=	below_right}', "");
    Expect(0, 12333, '\p{^Is_Ccc=	below_right}', "");
    Expect(0, 12333, '\P{Is_Ccc=	below_right}', "");
    Expect(1, 12333, '\P{^Is_Ccc=	below_right}', "");
    Expect(0, 12334, '\p{Is_Ccc=	below_right}', "");
    Expect(1, 12334, '\p{^Is_Ccc=	below_right}', "");
    Expect(1, 12334, '\P{Is_Ccc=	below_right}', "");
    Expect(0, 12334, '\P{^Is_Ccc=	below_right}', "");
    Error('\p{Canonical_Combining_Class=/a/CCC10}');
    Error('\P{Canonical_Combining_Class=/a/CCC10}');
    Expect(1, 1456, '\p{Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1456, '\p{^Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1456, '\P{Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1456, '\P{^Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1457, '\p{Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1457, '\p{^Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1457, '\P{Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1457, '\P{^Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1456, '\p{Canonical_Combining_Class=-	CCC10}', "");
    Expect(0, 1456, '\p{^Canonical_Combining_Class=-	CCC10}', "");
    Expect(0, 1456, '\P{Canonical_Combining_Class=-	CCC10}', "");
    Expect(1, 1456, '\P{^Canonical_Combining_Class=-	CCC10}', "");
    Expect(0, 1457, '\p{Canonical_Combining_Class=-	CCC10}', "");
    Expect(1, 1457, '\p{^Canonical_Combining_Class=-	CCC10}', "");
    Expect(1, 1457, '\P{Canonical_Combining_Class=-	CCC10}', "");
    Expect(0, 1457, '\P{^Canonical_Combining_Class=-	CCC10}', "");
    Error('\p{Ccc=-+000000010:=}');
    Error('\P{Ccc=-+000000010:=}');
    Expect(1, 1456, '\p{Ccc=00_00_00_01_0}', "");
    Expect(0, 1456, '\p{^Ccc=00_00_00_01_0}', "");
    Expect(0, 1456, '\P{Ccc=00_00_00_01_0}', "");
    Expect(1, 1456, '\P{^Ccc=00_00_00_01_0}', "");
    Expect(0, 1457, '\p{Ccc=00_00_00_01_0}', "");
    Expect(1, 1457, '\p{^Ccc=00_00_00_01_0}', "");
    Expect(1, 1457, '\P{Ccc=00_00_00_01_0}', "");
    Expect(0, 1457, '\P{^Ccc=00_00_00_01_0}', "");
    Error('\p{Is_Canonical_Combining_Class=- CCC10:=}');
    Error('\P{Is_Canonical_Combining_Class=- CCC10:=}');
    Expect(1, 1456, '\p{Is_Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1456, '\p{^Is_Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1456, '\P{Is_Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1456, '\P{^Is_Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1457, '\p{Is_Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1457, '\p{^Is_Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1457, '\P{Is_Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1457, '\P{^Is_Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1456, '\p{Is_Canonical_Combining_Class= CCC10}', "");
    Expect(0, 1456, '\p{^Is_Canonical_Combining_Class= CCC10}', "");
    Expect(0, 1456, '\P{Is_Canonical_Combining_Class= CCC10}', "");
    Expect(1, 1456, '\P{^Is_Canonical_Combining_Class= CCC10}', "");
    Expect(0, 1457, '\p{Is_Canonical_Combining_Class= CCC10}', "");
    Expect(1, 1457, '\p{^Is_Canonical_Combining_Class= CCC10}', "");
    Expect(1, 1457, '\P{Is_Canonical_Combining_Class= CCC10}', "");
    Expect(0, 1457, '\P{^Is_Canonical_Combining_Class= CCC10}', "");
    Error('\p{Is_Ccc=_/a/0000010}');
    Error('\P{Is_Ccc=_/a/0000010}');
    Expect(1, 1456, '\p{Is_Ccc=00000000010}', "");
    Expect(0, 1456, '\p{^Is_Ccc=00000000010}', "");
    Expect(0, 1456, '\P{Is_Ccc=00000000010}', "");
    Expect(1, 1456, '\P{^Is_Ccc=00000000010}', "");
    Expect(0, 1457, '\p{Is_Ccc=00000000010}', "");
    Expect(1, 1457, '\p{^Is_Ccc=00000000010}', "");
    Expect(1, 1457, '\P{Is_Ccc=00000000010}', "");
    Expect(0, 1457, '\P{^Is_Ccc=00000000010}', "");
    Error('\p{Canonical_Combining_Class=:=_ CCC103}');
    Error('\P{Canonical_Combining_Class=:=_ CCC103}');
    Expect(1, 3641, '\p{Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3641, '\p{^Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3641, '\P{Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3641, '\P{^Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3642, '\p{Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3642, '\p{^Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3642, '\P{Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3642, '\P{^Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3641, '\p{Canonical_Combining_Class=	_ccc103}', "");
    Expect(0, 3641, '\p{^Canonical_Combining_Class=	_ccc103}', "");
    Expect(0, 3641, '\P{Canonical_Combining_Class=	_ccc103}', "");
    Expect(1, 3641, '\P{^Canonical_Combining_Class=	_ccc103}', "");
    Expect(0, 3642, '\p{Canonical_Combining_Class=	_ccc103}', "");
    Expect(1, 3642, '\p{^Canonical_Combining_Class=	_ccc103}', "");
    Expect(1, 3642, '\P{Canonical_Combining_Class=	_ccc103}', "");
    Expect(0, 3642, '\P{^Canonical_Combining_Class=	_ccc103}', "");
    Error('\p{Ccc=_:=103}');
    Error('\P{Ccc=_:=103}');
    Expect(1, 3641, '\p{Ccc=00000103}', "");
    Expect(0, 3641, '\p{^Ccc=00000103}', "");
    Expect(0, 3641, '\P{Ccc=00000103}', "");
    Expect(1, 3641, '\P{^Ccc=00000103}', "");
    Expect(0, 3642, '\p{Ccc=00000103}', "");
    Expect(1, 3642, '\p{^Ccc=00000103}', "");
    Expect(1, 3642, '\P{Ccc=00000103}', "");
    Expect(0, 3642, '\P{^Ccc=00000103}', "");
    Error('\p{Is_Canonical_Combining_Class=-CCC103:=}');
    Error('\P{Is_Canonical_Combining_Class=-CCC103:=}');
    Expect(1, 3641, '\p{Is_Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3641, '\p{^Is_Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3641, '\P{Is_Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3641, '\P{^Is_Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3642, '\p{Is_Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3642, '\p{^Is_Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3642, '\P{Is_Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3642, '\P{^Is_Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3641, '\p{Is_Canonical_Combining_Class= -CCC103}', "");
    Expect(0, 3641, '\p{^Is_Canonical_Combining_Class= -CCC103}', "");
    Expect(0, 3641, '\P{Is_Canonical_Combining_Class= -CCC103}', "");
    Expect(1, 3641, '\P{^Is_Canonical_Combining_Class= -CCC103}', "");
    Expect(0, 3642, '\p{Is_Canonical_Combining_Class= -CCC103}', "");
    Expect(1, 3642, '\p{^Is_Canonical_Combining_Class= -CCC103}', "");
    Expect(1, 3642, '\P{Is_Canonical_Combining_Class= -CCC103}', "");
    Expect(0, 3642, '\P{^Is_Canonical_Combining_Class= -CCC103}', "");
    Error('\p{Is_Ccc=/a/- 000_001_03}');
    Error('\P{Is_Ccc=/a/- 000_001_03}');
    Expect(1, 3641, '\p{Is_Ccc=0103}', "");
    Expect(0, 3641, '\p{^Is_Ccc=0103}', "");
    Expect(0, 3641, '\P{Is_Ccc=0103}', "");
    Expect(1, 3641, '\P{^Is_Ccc=0103}', "");
    Expect(0, 3642, '\p{Is_Ccc=0103}', "");
    Expect(1, 3642, '\p{^Is_Ccc=0103}', "");
    Expect(1, 3642, '\P{Is_Ccc=0103}', "");
    Expect(0, 3642, '\P{^Is_Ccc=0103}', "");
    Error('\p{Canonical_Combining_Class=:=_	CCC107}');
    Error('\P{Canonical_Combining_Class=:=_	CCC107}');
    Expect(1, 3659, '\p{Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3659, '\p{^Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3659, '\P{Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3659, '\P{^Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3660, '\p{Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3660, '\p{^Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3660, '\P{Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3660, '\P{^Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3659, '\p{Canonical_Combining_Class=__ccc107}', "");
    Expect(0, 3659, '\p{^Canonical_Combining_Class=__ccc107}', "");
    Expect(0, 3659, '\P{Canonical_Combining_Class=__ccc107}', "");
    Expect(1, 3659, '\P{^Canonical_Combining_Class=__ccc107}', "");
    Expect(0, 3660, '\p{Canonical_Combining_Class=__ccc107}', "");
    Expect(1, 3660, '\p{^Canonical_Combining_Class=__ccc107}', "");
    Expect(1, 3660, '\P{Canonical_Combining_Class=__ccc107}', "");
    Expect(0, 3660, '\P{^Canonical_Combining_Class=__ccc107}', "");
    Error('\p{Ccc=:=+0_0_0_0_0_0_0107}');
    Error('\P{Ccc=:=+0_0_0_0_0_0_0107}');
    Expect(1, 3659, '\p{Ccc=+0000107}', "");
    Expect(0, 3659, '\p{^Ccc=+0000107}', "");
    Expect(0, 3659, '\P{Ccc=+0000107}', "");
    Expect(1, 3659, '\P{^Ccc=+0000107}', "");
    Expect(0, 3660, '\p{Ccc=+0000107}', "");
    Expect(1, 3660, '\p{^Ccc=+0000107}', "");
    Expect(1, 3660, '\P{Ccc=+0000107}', "");
    Expect(0, 3660, '\P{^Ccc=+0000107}', "");
    Error('\p{Is_Canonical_Combining_Class=_ CCC107/a/}');
    Error('\P{Is_Canonical_Combining_Class=_ CCC107/a/}');
    Expect(1, 3659, '\p{Is_Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3659, '\p{^Is_Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3659, '\P{Is_Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3659, '\P{^Is_Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3660, '\p{Is_Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3660, '\p{^Is_Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3660, '\P{Is_Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3660, '\P{^Is_Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3659, '\p{Is_Canonical_Combining_Class=	CCC107}', "");
    Expect(0, 3659, '\p{^Is_Canonical_Combining_Class=	CCC107}', "");
    Expect(0, 3659, '\P{Is_Canonical_Combining_Class=	CCC107}', "");
    Expect(1, 3659, '\P{^Is_Canonical_Combining_Class=	CCC107}', "");
    Expect(0, 3660, '\p{Is_Canonical_Combining_Class=	CCC107}', "");
    Expect(1, 3660, '\p{^Is_Canonical_Combining_Class=	CCC107}', "");
    Expect(1, 3660, '\P{Is_Canonical_Combining_Class=	CCC107}', "");
    Expect(0, 3660, '\P{^Is_Canonical_Combining_Class=	CCC107}', "");
    Error('\p{Is_Ccc=-/a/+00_10_7}');
    Error('\P{Is_Ccc=-/a/+00_10_7}');
    Expect(1, 3659, '\p{Is_Ccc=000000107}', "");
    Expect(0, 3659, '\p{^Is_Ccc=000000107}', "");
    Expect(0, 3659, '\P{Is_Ccc=000000107}', "");
    Expect(1, 3659, '\P{^Is_Ccc=000000107}', "");
    Expect(0, 3660, '\p{Is_Ccc=000000107}', "");
    Expect(1, 3660, '\p{^Is_Ccc=000000107}', "");
    Expect(1, 3660, '\P{Is_Ccc=000000107}', "");
    Expect(0, 3660, '\P{^Is_Ccc=000000107}', "");
    Error('\p{Canonical_Combining_Class=-:=CCC11}');
    Error('\P{Canonical_Combining_Class=-:=CCC11}');
    Expect(1, 1457, '\p{Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1457, '\p{^Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1457, '\P{Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1457, '\P{^Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1458, '\p{Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1458, '\p{^Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1458, '\P{Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1458, '\P{^Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1457, '\p{Canonical_Combining_Class=-_CCC11}', "");
    Expect(0, 1457, '\p{^Canonical_Combining_Class=-_CCC11}', "");
    Expect(0, 1457, '\P{Canonical_Combining_Class=-_CCC11}', "");
    Expect(1, 1457, '\P{^Canonical_Combining_Class=-_CCC11}', "");
    Expect(0, 1458, '\p{Canonical_Combining_Class=-_CCC11}', "");
    Expect(1, 1458, '\p{^Canonical_Combining_Class=-_CCC11}', "");
    Expect(1, 1458, '\P{Canonical_Combining_Class=-_CCC11}', "");
    Expect(0, 1458, '\P{^Canonical_Combining_Class=-_CCC11}', "");
    Error('\p{Ccc=/a/		00_01_1}');
    Error('\P{Ccc=/a/		00_01_1}');
    Expect(1, 1457, '\p{Ccc=00000000011}', "");
    Expect(0, 1457, '\p{^Ccc=00000000011}', "");
    Expect(0, 1457, '\P{Ccc=00000000011}', "");
    Expect(1, 1457, '\P{^Ccc=00000000011}', "");
    Expect(0, 1458, '\p{Ccc=00000000011}', "");
    Expect(1, 1458, '\p{^Ccc=00000000011}', "");
    Expect(1, 1458, '\P{Ccc=00000000011}', "");
    Expect(0, 1458, '\P{^Ccc=00000000011}', "");
    Error('\p{Is_Canonical_Combining_Class=_/a/ccc11}');
    Error('\P{Is_Canonical_Combining_Class=_/a/ccc11}');
    Expect(1, 1457, '\p{Is_Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1457, '\p{^Is_Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1457, '\P{Is_Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1457, '\P{^Is_Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1458, '\p{Is_Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1458, '\p{^Is_Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1458, '\P{Is_Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1458, '\P{^Is_Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1457, '\p{Is_Canonical_Combining_Class=	 CCC11}', "");
    Expect(0, 1457, '\p{^Is_Canonical_Combining_Class=	 CCC11}', "");
    Expect(0, 1457, '\P{Is_Canonical_Combining_Class=	 CCC11}', "");
    Expect(1, 1457, '\P{^Is_Canonical_Combining_Class=	 CCC11}', "");
    Expect(0, 1458, '\p{Is_Canonical_Combining_Class=	 CCC11}', "");
    Expect(1, 1458, '\p{^Is_Canonical_Combining_Class=	 CCC11}', "");
    Expect(1, 1458, '\P{Is_Canonical_Combining_Class=	 CCC11}', "");
    Expect(0, 1458, '\P{^Is_Canonical_Combining_Class=	 CCC11}', "");
    Error('\p{Is_Ccc=:=+0_0_0_0_0_0_0_0_011}');
    Error('\P{Is_Ccc=:=+0_0_0_0_0_0_0_0_011}');
    Expect(1, 1457, '\p{Is_Ccc:   0000000011}', "");
    Expect(0, 1457, '\p{^Is_Ccc:   0000000011}', "");
    Expect(0, 1457, '\P{Is_Ccc:   0000000011}', "");
    Expect(1, 1457, '\P{^Is_Ccc:   0000000011}', "");
    Expect(0, 1458, '\p{Is_Ccc:   0000000011}', "");
    Expect(1, 1458, '\p{^Is_Ccc:   0000000011}', "");
    Expect(1, 1458, '\P{Is_Ccc:   0000000011}', "");
    Expect(0, 1458, '\P{^Is_Ccc:   0000000011}', "");
    Error('\p{Canonical_Combining_Class=- ccc118/a/}');
    Error('\P{Canonical_Combining_Class=- ccc118/a/}');
    Expect(1, 3769, '\p{Canonical_Combining_Class: ccc118}', "");
    Expect(0, 3769, '\p{^Canonical_Combining_Class: ccc118}', "");
    Expect(0, 3769, '\P{Canonical_Combining_Class: ccc118}', "");
    Expect(1, 3769, '\P{^Canonical_Combining_Class: ccc118}', "");
    Expect(0, 3770, '\p{Canonical_Combining_Class: ccc118}', "");
    Expect(1, 3770, '\p{^Canonical_Combining_Class: ccc118}', "");
    Expect(1, 3770, '\P{Canonical_Combining_Class: ccc118}', "");
    Expect(0, 3770, '\P{^Canonical_Combining_Class: ccc118}', "");
    Expect(1, 3769, '\p{Canonical_Combining_Class:  ccc118}', "");
    Expect(0, 3769, '\p{^Canonical_Combining_Class:  ccc118}', "");
    Expect(0, 3769, '\P{Canonical_Combining_Class:  ccc118}', "");
    Expect(1, 3769, '\P{^Canonical_Combining_Class:  ccc118}', "");
    Expect(0, 3770, '\p{Canonical_Combining_Class:  ccc118}', "");
    Expect(1, 3770, '\p{^Canonical_Combining_Class:  ccc118}', "");
    Expect(1, 3770, '\P{Canonical_Combining_Class:  ccc118}', "");
    Expect(0, 3770, '\P{^Canonical_Combining_Class:  ccc118}', "");
    Error('\p{Ccc=:=	0118}');
    Error('\P{Ccc=:=	0118}');
    Expect(1, 3769, '\p{Ccc=0000000118}', "");
    Expect(0, 3769, '\p{^Ccc=0000000118}', "");
    Expect(0, 3769, '\P{Ccc=0000000118}', "");
    Expect(1, 3769, '\P{^Ccc=0000000118}', "");
    Expect(0, 3770, '\p{Ccc=0000000118}', "");
    Expect(1, 3770, '\p{^Ccc=0000000118}', "");
    Expect(1, 3770, '\P{Ccc=0000000118}', "");
    Expect(0, 3770, '\P{^Ccc=0000000118}', "");
    Error('\p{Is_Canonical_Combining_Class=-_ccc118:=}');
    Error('\P{Is_Canonical_Combining_Class=-_ccc118:=}');
    Expect(1, 3769, '\p{Is_Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3769, '\p{^Is_Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3769, '\P{Is_Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3769, '\P{^Is_Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3770, '\p{Is_Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3770, '\p{^Is_Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3770, '\P{Is_Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3770, '\P{^Is_Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3769, '\p{Is_Canonical_Combining_Class=	 CCC118}', "");
    Expect(0, 3769, '\p{^Is_Canonical_Combining_Class=	 CCC118}', "");
    Expect(0, 3769, '\P{Is_Canonical_Combining_Class=	 CCC118}', "");
    Expect(1, 3769, '\P{^Is_Canonical_Combining_Class=	 CCC118}', "");
    Expect(0, 3770, '\p{Is_Canonical_Combining_Class=	 CCC118}', "");
    Expect(1, 3770, '\p{^Is_Canonical_Combining_Class=	 CCC118}', "");
    Expect(1, 3770, '\P{Is_Canonical_Combining_Class=	 CCC118}', "");
    Expect(0, 3770, '\P{^Is_Canonical_Combining_Class=	 CCC118}', "");
    Error('\p{Is_Ccc=	+0000118:=}');
    Error('\P{Is_Ccc=	+0000118:=}');
    Expect(1, 3769, '\p{Is_Ccc=+0000000118}', "");
    Expect(0, 3769, '\p{^Is_Ccc=+0000000118}', "");
    Expect(0, 3769, '\P{Is_Ccc=+0000000118}', "");
    Expect(1, 3769, '\P{^Is_Ccc=+0000000118}', "");
    Expect(0, 3770, '\p{Is_Ccc=+0000000118}', "");
    Expect(1, 3770, '\p{^Is_Ccc=+0000000118}', "");
    Expect(1, 3770, '\P{Is_Ccc=+0000000118}', "");
    Expect(0, 3770, '\P{^Is_Ccc=+0000000118}', "");
    Error('\p{Canonical_Combining_Class=:=_	CCC12}');
    Error('\P{Canonical_Combining_Class=:=_	CCC12}');
    Expect(1, 1458, '\p{Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1458, '\p{^Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1458, '\P{Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1458, '\P{^Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1459, '\p{Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1459, '\p{^Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1459, '\P{Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1459, '\P{^Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1458, '\p{Canonical_Combining_Class=	-ccc12}', "");
    Expect(0, 1458, '\p{^Canonical_Combining_Class=	-ccc12}', "");
    Expect(0, 1458, '\P{Canonical_Combining_Class=	-ccc12}', "");
    Expect(1, 1458, '\P{^Canonical_Combining_Class=	-ccc12}', "");
    Expect(0, 1459, '\p{Canonical_Combining_Class=	-ccc12}', "");
    Expect(1, 1459, '\p{^Canonical_Combining_Class=	-ccc12}', "");
    Expect(1, 1459, '\P{Canonical_Combining_Class=	-ccc12}', "");
    Expect(0, 1459, '\P{^Canonical_Combining_Class=	-ccc12}', "");
    Error('\p{Ccc=/a/0_0_0_0_0_012}');
    Error('\P{Ccc=/a/0_0_0_0_0_012}');
    Expect(1, 1458, '\p{Ccc=0_0_0_0_0_12}', "");
    Expect(0, 1458, '\p{^Ccc=0_0_0_0_0_12}', "");
    Expect(0, 1458, '\P{Ccc=0_0_0_0_0_12}', "");
    Expect(1, 1458, '\P{^Ccc=0_0_0_0_0_12}', "");
    Expect(0, 1459, '\p{Ccc=0_0_0_0_0_12}', "");
    Expect(1, 1459, '\p{^Ccc=0_0_0_0_0_12}', "");
    Expect(1, 1459, '\P{Ccc=0_0_0_0_0_12}', "");
    Expect(0, 1459, '\P{^Ccc=0_0_0_0_0_12}', "");
    Error('\p{Is_Canonical_Combining_Class= -CCC12:=}');
    Error('\P{Is_Canonical_Combining_Class= -CCC12:=}');
    Expect(1, 1458, '\p{Is_Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1458, '\p{^Is_Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1458, '\P{Is_Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1458, '\P{^Is_Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1459, '\p{Is_Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1459, '\p{^Is_Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1459, '\P{Is_Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1459, '\P{^Is_Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1458, '\p{Is_Canonical_Combining_Class=-	CCC12}', "");
    Expect(0, 1458, '\p{^Is_Canonical_Combining_Class=-	CCC12}', "");
    Expect(0, 1458, '\P{Is_Canonical_Combining_Class=-	CCC12}', "");
    Expect(1, 1458, '\P{^Is_Canonical_Combining_Class=-	CCC12}', "");
    Expect(0, 1459, '\p{Is_Canonical_Combining_Class=-	CCC12}', "");
    Expect(1, 1459, '\p{^Is_Canonical_Combining_Class=-	CCC12}', "");
    Expect(1, 1459, '\P{Is_Canonical_Combining_Class=-	CCC12}', "");
    Expect(0, 1459, '\P{^Is_Canonical_Combining_Class=-	CCC12}', "");
    Error('\p{Is_Ccc:/a/_+000000012}');
    Error('\P{Is_Ccc:/a/_+000000012}');
    Expect(1, 1458, '\p{Is_Ccc=00_00_00_12}', "");
    Expect(0, 1458, '\p{^Is_Ccc=00_00_00_12}', "");
    Expect(0, 1458, '\P{Is_Ccc=00_00_00_12}', "");
    Expect(1, 1458, '\P{^Is_Ccc=00_00_00_12}', "");
    Expect(0, 1459, '\p{Is_Ccc=00_00_00_12}', "");
    Expect(1, 1459, '\p{^Is_Ccc=00_00_00_12}', "");
    Expect(1, 1459, '\P{Is_Ccc=00_00_00_12}', "");
    Expect(0, 1459, '\P{^Is_Ccc=00_00_00_12}', "");
    Error('\p{Canonical_Combining_Class=-CCC122/a/}');
    Error('\P{Canonical_Combining_Class=-CCC122/a/}');
    Expect(1, 3787, '\p{Canonical_Combining_Class:	ccc122}', "");
    Expect(0, 3787, '\p{^Canonical_Combining_Class:	ccc122}', "");
    Expect(0, 3787, '\P{Canonical_Combining_Class:	ccc122}', "");
    Expect(1, 3787, '\P{^Canonical_Combining_Class:	ccc122}', "");
    Expect(0, 3788, '\p{Canonical_Combining_Class:	ccc122}', "");
    Expect(1, 3788, '\p{^Canonical_Combining_Class:	ccc122}', "");
    Expect(1, 3788, '\P{Canonical_Combining_Class:	ccc122}', "");
    Expect(0, 3788, '\P{^Canonical_Combining_Class:	ccc122}', "");
    Expect(1, 3787, '\p{Canonical_Combining_Class= ccc122}', "");
    Expect(0, 3787, '\p{^Canonical_Combining_Class= ccc122}', "");
    Expect(0, 3787, '\P{Canonical_Combining_Class= ccc122}', "");
    Expect(1, 3787, '\P{^Canonical_Combining_Class= ccc122}', "");
    Expect(0, 3788, '\p{Canonical_Combining_Class= ccc122}', "");
    Expect(1, 3788, '\p{^Canonical_Combining_Class= ccc122}', "");
    Expect(1, 3788, '\P{Canonical_Combining_Class= ccc122}', "");
    Expect(0, 3788, '\P{^Canonical_Combining_Class= ccc122}', "");
    Error('\p{Ccc:	- 0122/a/}');
    Error('\P{Ccc:	- 0122/a/}');
    Expect(1, 3787, '\p{Ccc=00000122}', "");
    Expect(0, 3787, '\p{^Ccc=00000122}', "");
    Expect(0, 3787, '\P{Ccc=00000122}', "");
    Expect(1, 3787, '\P{^Ccc=00000122}', "");
    Expect(0, 3788, '\p{Ccc=00000122}', "");
    Expect(1, 3788, '\p{^Ccc=00000122}', "");
    Expect(1, 3788, '\P{Ccc=00000122}', "");
    Expect(0, 3788, '\P{^Ccc=00000122}', "");
    Error('\p{Is_Canonical_Combining_Class= :=ccc122}');
    Error('\P{Is_Canonical_Combining_Class= :=ccc122}');
    Expect(1, 3787, '\p{Is_Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3787, '\p{^Is_Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3787, '\P{Is_Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3787, '\P{^Is_Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3788, '\p{Is_Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3788, '\p{^Is_Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3788, '\P{Is_Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3788, '\P{^Is_Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3787, '\p{Is_Canonical_Combining_Class=-CCC122}', "");
    Expect(0, 3787, '\p{^Is_Canonical_Combining_Class=-CCC122}', "");
    Expect(0, 3787, '\P{Is_Canonical_Combining_Class=-CCC122}', "");
    Expect(1, 3787, '\P{^Is_Canonical_Combining_Class=-CCC122}', "");
    Expect(0, 3788, '\p{Is_Canonical_Combining_Class=-CCC122}', "");
    Expect(1, 3788, '\p{^Is_Canonical_Combining_Class=-CCC122}', "");
    Expect(1, 3788, '\P{Is_Canonical_Combining_Class=-CCC122}', "");
    Expect(0, 3788, '\P{^Is_Canonical_Combining_Class=-CCC122}', "");
    Error('\p{Is_Ccc=/a/-+00000122}');
    Error('\P{Is_Ccc=/a/-+00000122}');
    Expect(1, 3787, '\p{Is_Ccc=00000000122}', "");
    Expect(0, 3787, '\p{^Is_Ccc=00000000122}', "");
    Expect(0, 3787, '\P{Is_Ccc=00000000122}', "");
    Expect(1, 3787, '\P{^Is_Ccc=00000000122}', "");
    Expect(0, 3788, '\p{Is_Ccc=00000000122}', "");
    Expect(1, 3788, '\p{^Is_Ccc=00000000122}', "");
    Expect(1, 3788, '\P{Is_Ccc=00000000122}', "");
    Expect(0, 3788, '\P{^Is_Ccc=00000000122}', "");
    Error('\p{Canonical_Combining_Class= /a/CCC129}');
    Error('\P{Canonical_Combining_Class= /a/CCC129}');
    Expect(1, 3953, '\p{Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3953, '\p{^Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3953, '\P{Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3953, '\P{^Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3954, '\p{Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3954, '\p{^Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3954, '\P{Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3954, '\P{^Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3953, '\p{Canonical_Combining_Class=--CCC129}', "");
    Expect(0, 3953, '\p{^Canonical_Combining_Class=--CCC129}', "");
    Expect(0, 3953, '\P{Canonical_Combining_Class=--CCC129}', "");
    Expect(1, 3953, '\P{^Canonical_Combining_Class=--CCC129}', "");
    Expect(0, 3954, '\p{Canonical_Combining_Class=--CCC129}', "");
    Expect(1, 3954, '\p{^Canonical_Combining_Class=--CCC129}', "");
    Expect(1, 3954, '\P{Canonical_Combining_Class=--CCC129}', "");
    Expect(0, 3954, '\P{^Canonical_Combining_Class=--CCC129}', "");
    Error('\p{Ccc=/a/ 0000000129}');
    Error('\P{Ccc=/a/ 0000000129}');
    Expect(1, 3953, '\p{Ccc=+000000129}', "");
    Expect(0, 3953, '\p{^Ccc=+000000129}', "");
    Expect(0, 3953, '\P{Ccc=+000000129}', "");
    Expect(1, 3953, '\P{^Ccc=+000000129}', "");
    Expect(0, 3954, '\p{Ccc=+000000129}', "");
    Expect(1, 3954, '\p{^Ccc=+000000129}', "");
    Expect(1, 3954, '\P{Ccc=+000000129}', "");
    Expect(0, 3954, '\P{^Ccc=+000000129}', "");
    Error('\p{Is_Canonical_Combining_Class=	:=CCC129}');
    Error('\P{Is_Canonical_Combining_Class=	:=CCC129}');
    Expect(1, 3953, '\p{Is_Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3953, '\p{^Is_Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3953, '\P{Is_Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3953, '\P{^Is_Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3954, '\p{Is_Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3954, '\p{^Is_Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3954, '\P{Is_Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3954, '\P{^Is_Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3953, '\p{Is_Canonical_Combining_Class=_-CCC129}', "");
    Expect(0, 3953, '\p{^Is_Canonical_Combining_Class=_-CCC129}', "");
    Expect(0, 3953, '\P{Is_Canonical_Combining_Class=_-CCC129}', "");
    Expect(1, 3953, '\P{^Is_Canonical_Combining_Class=_-CCC129}', "");
    Expect(0, 3954, '\p{Is_Canonical_Combining_Class=_-CCC129}', "");
    Expect(1, 3954, '\p{^Is_Canonical_Combining_Class=_-CCC129}', "");
    Expect(1, 3954, '\P{Is_Canonical_Combining_Class=_-CCC129}', "");
    Expect(0, 3954, '\P{^Is_Canonical_Combining_Class=_-CCC129}', "");
    Error('\p{Is_Ccc=:=--0_0_0_1_29}');
    Error('\P{Is_Ccc=:=--0_0_0_1_29}');
    Expect(1, 3953, '\p{Is_Ccc:	00_00_01_29}', "");
    Expect(0, 3953, '\p{^Is_Ccc:	00_00_01_29}', "");
    Expect(0, 3953, '\P{Is_Ccc:	00_00_01_29}', "");
    Expect(1, 3953, '\P{^Is_Ccc:	00_00_01_29}', "");
    Expect(0, 3954, '\p{Is_Ccc:	00_00_01_29}', "");
    Expect(1, 3954, '\p{^Is_Ccc:	00_00_01_29}', "");
    Expect(1, 3954, '\P{Is_Ccc:	00_00_01_29}', "");
    Expect(0, 3954, '\P{^Is_Ccc:	00_00_01_29}', "");
    Error('\p{Canonical_Combining_Class=:= CCC13}');
    Error('\P{Canonical_Combining_Class=:= CCC13}');
    Expect(1, 1459, '\p{Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1459, '\p{^Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1459, '\P{Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1459, '\P{^Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1460, '\p{Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1460, '\p{^Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1460, '\P{Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1460, '\P{^Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1459, '\p{Canonical_Combining_Class= CCC13}', "");
    Expect(0, 1459, '\p{^Canonical_Combining_Class= CCC13}', "");
    Expect(0, 1459, '\P{Canonical_Combining_Class= CCC13}', "");
    Expect(1, 1459, '\P{^Canonical_Combining_Class= CCC13}', "");
    Expect(0, 1460, '\p{Canonical_Combining_Class= CCC13}', "");
    Expect(1, 1460, '\p{^Canonical_Combining_Class= CCC13}', "");
    Expect(1, 1460, '\P{Canonical_Combining_Class= CCC13}', "");
    Expect(0, 1460, '\P{^Canonical_Combining_Class= CCC13}', "");
    Error('\p{Ccc=/a/ -00013}');
    Error('\P{Ccc=/a/ -00013}');
    Expect(1, 1459, '\p{Ccc=00013}', "");
    Expect(0, 1459, '\p{^Ccc=00013}', "");
    Expect(0, 1459, '\P{Ccc=00013}', "");
    Expect(1, 1459, '\P{^Ccc=00013}', "");
    Expect(0, 1460, '\p{Ccc=00013}', "");
    Expect(1, 1460, '\p{^Ccc=00013}', "");
    Expect(1, 1460, '\P{Ccc=00013}', "");
    Expect(0, 1460, '\P{^Ccc=00013}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/ CCC13}');
    Error('\P{Is_Canonical_Combining_Class=/a/ CCC13}');
    Expect(1, 1459, '\p{Is_Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1459, '\p{^Is_Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1459, '\P{Is_Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1459, '\P{^Is_Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1460, '\p{Is_Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1460, '\p{^Is_Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1460, '\P{Is_Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1460, '\P{^Is_Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1459, '\p{Is_Canonical_Combining_Class= ccc13}', "");
    Expect(0, 1459, '\p{^Is_Canonical_Combining_Class= ccc13}', "");
    Expect(0, 1459, '\P{Is_Canonical_Combining_Class= ccc13}', "");
    Expect(1, 1459, '\P{^Is_Canonical_Combining_Class= ccc13}', "");
    Expect(0, 1460, '\p{Is_Canonical_Combining_Class= ccc13}', "");
    Expect(1, 1460, '\p{^Is_Canonical_Combining_Class= ccc13}', "");
    Expect(1, 1460, '\P{Is_Canonical_Combining_Class= ccc13}', "");
    Expect(0, 1460, '\P{^Is_Canonical_Combining_Class= ccc13}', "");
    Error('\p{Is_Ccc=-	0_0_0_0_0_0_13/a/}');
    Error('\P{Is_Ccc=-	0_0_0_0_0_0_13/a/}');
    Expect(1, 1459, '\p{Is_Ccc=013}', "");
    Expect(0, 1459, '\p{^Is_Ccc=013}', "");
    Expect(0, 1459, '\P{Is_Ccc=013}', "");
    Expect(1, 1459, '\P{^Is_Ccc=013}', "");
    Expect(0, 1460, '\p{Is_Ccc=013}', "");
    Expect(1, 1460, '\p{^Is_Ccc=013}', "");
    Expect(1, 1460, '\P{Is_Ccc=013}', "");
    Expect(0, 1460, '\P{^Is_Ccc=013}', "");
    Error('\p{Canonical_Combining_Class=_	CCC130/a/}');
    Error('\P{Canonical_Combining_Class=_	CCC130/a/}');
    Expect(1, 3968, '\p{Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3968, '\p{^Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3968, '\P{Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3968, '\P{^Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3969, '\p{Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3969, '\p{^Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3969, '\P{Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3969, '\P{^Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3968, '\p{Canonical_Combining_Class: CCC130}', "");
    Expect(0, 3968, '\p{^Canonical_Combining_Class: CCC130}', "");
    Expect(0, 3968, '\P{Canonical_Combining_Class: CCC130}', "");
    Expect(1, 3968, '\P{^Canonical_Combining_Class: CCC130}', "");
    Expect(0, 3969, '\p{Canonical_Combining_Class: CCC130}', "");
    Expect(1, 3969, '\p{^Canonical_Combining_Class: CCC130}', "");
    Expect(1, 3969, '\P{Canonical_Combining_Class: CCC130}', "");
    Expect(0, 3969, '\P{^Canonical_Combining_Class: CCC130}', "");
    Error('\p{Ccc=-+00000000130:=}');
    Error('\P{Ccc=-+00000000130:=}');
    Expect(1, 3968, '\p{Ccc=000130}', "");
    Expect(0, 3968, '\p{^Ccc=000130}', "");
    Expect(0, 3968, '\P{Ccc=000130}', "");
    Expect(1, 3968, '\P{^Ccc=000130}', "");
    Expect(0, 3969, '\p{Ccc=000130}', "");
    Expect(1, 3969, '\p{^Ccc=000130}', "");
    Expect(1, 3969, '\P{Ccc=000130}', "");
    Expect(0, 3969, '\P{^Ccc=000130}', "");
    Error('\p{Is_Canonical_Combining_Class=-_CCC130:=}');
    Error('\P{Is_Canonical_Combining_Class=-_CCC130:=}');
    Expect(1, 3968, '\p{Is_Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3968, '\p{^Is_Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3968, '\P{Is_Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3968, '\P{^Is_Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3969, '\p{Is_Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3969, '\p{^Is_Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3969, '\P{Is_Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3969, '\P{^Is_Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3968, '\p{Is_Canonical_Combining_Class=CCC130}', "");
    Expect(0, 3968, '\p{^Is_Canonical_Combining_Class=CCC130}', "");
    Expect(0, 3968, '\P{Is_Canonical_Combining_Class=CCC130}', "");
    Expect(1, 3968, '\P{^Is_Canonical_Combining_Class=CCC130}', "");
    Expect(0, 3969, '\p{Is_Canonical_Combining_Class=CCC130}', "");
    Expect(1, 3969, '\p{^Is_Canonical_Combining_Class=CCC130}', "");
    Expect(1, 3969, '\P{Is_Canonical_Combining_Class=CCC130}', "");
    Expect(0, 3969, '\P{^Is_Canonical_Combining_Class=CCC130}', "");
    Error('\p{Is_Ccc:   /a/+0130}');
    Error('\P{Is_Ccc:   /a/+0130}');
    Expect(1, 3968, '\p{Is_Ccc=13_0}', "");
    Expect(0, 3968, '\p{^Is_Ccc=13_0}', "");
    Expect(0, 3968, '\P{Is_Ccc=13_0}', "");
    Expect(1, 3968, '\P{^Is_Ccc=13_0}', "");
    Expect(0, 3969, '\p{Is_Ccc=13_0}', "");
    Expect(1, 3969, '\p{^Is_Ccc=13_0}', "");
    Expect(1, 3969, '\P{Is_Ccc=13_0}', "");
    Expect(0, 3969, '\P{^Is_Ccc=13_0}', "");
    Error('\p{Canonical_Combining_Class:	/a/  CCC132}');
    Error('\P{Canonical_Combining_Class:	/a/  CCC132}');
    Expect(1, 3956, '\p{Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3956, '\p{^Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3956, '\P{Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3956, '\P{^Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3957, '\p{Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3957, '\p{^Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3957, '\P{Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3957, '\P{^Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3956, '\p{Canonical_Combining_Class=_	CCC132}', "");
    Expect(0, 3956, '\p{^Canonical_Combining_Class=_	CCC132}', "");
    Expect(0, 3956, '\P{Canonical_Combining_Class=_	CCC132}', "");
    Expect(1, 3956, '\P{^Canonical_Combining_Class=_	CCC132}', "");
    Expect(0, 3957, '\p{Canonical_Combining_Class=_	CCC132}', "");
    Expect(1, 3957, '\p{^Canonical_Combining_Class=_	CCC132}', "");
    Expect(1, 3957, '\P{Canonical_Combining_Class=_	CCC132}', "");
    Expect(0, 3957, '\P{^Canonical_Combining_Class=_	CCC132}', "");
    Error('\p{Ccc=_/a/000000132}');
    Error('\P{Ccc=_/a/000000132}');
    Expect(1, 3956, '\p{Ccc:   00132}', "");
    Expect(0, 3956, '\p{^Ccc:   00132}', "");
    Expect(0, 3956, '\P{Ccc:   00132}', "");
    Expect(1, 3956, '\P{^Ccc:   00132}', "");
    Expect(0, 3957, '\p{Ccc:   00132}', "");
    Expect(1, 3957, '\p{^Ccc:   00132}', "");
    Expect(1, 3957, '\P{Ccc:   00132}', "");
    Expect(0, 3957, '\P{^Ccc:   00132}', "");
    Error('\p{Is_Canonical_Combining_Class=:=CCC132}');
    Error('\P{Is_Canonical_Combining_Class=:=CCC132}');
    Expect(1, 3956, '\p{Is_Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3956, '\p{^Is_Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3956, '\P{Is_Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3956, '\P{^Is_Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3957, '\p{Is_Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3957, '\p{^Is_Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3957, '\P{Is_Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3957, '\P{^Is_Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3956, '\p{Is_Canonical_Combining_Class=-	CCC132}', "");
    Expect(0, 3956, '\p{^Is_Canonical_Combining_Class=-	CCC132}', "");
    Expect(0, 3956, '\P{Is_Canonical_Combining_Class=-	CCC132}', "");
    Expect(1, 3956, '\P{^Is_Canonical_Combining_Class=-	CCC132}', "");
    Expect(0, 3957, '\p{Is_Canonical_Combining_Class=-	CCC132}', "");
    Expect(1, 3957, '\p{^Is_Canonical_Combining_Class=-	CCC132}', "");
    Expect(1, 3957, '\P{Is_Canonical_Combining_Class=-	CCC132}', "");
    Expect(0, 3957, '\P{^Is_Canonical_Combining_Class=-	CCC132}', "");
    Error('\p{Is_Ccc=_	+00000_00001_32:=}');
    Error('\P{Is_Ccc=_	+00000_00001_32:=}');
    Expect(1, 3956, '\p{Is_Ccc=000013_2}', "");
    Expect(0, 3956, '\p{^Is_Ccc=000013_2}', "");
    Expect(0, 3956, '\P{Is_Ccc=000013_2}', "");
    Expect(1, 3956, '\P{^Is_Ccc=000013_2}', "");
    Expect(0, 3957, '\p{Is_Ccc=000013_2}', "");
    Expect(1, 3957, '\p{^Is_Ccc=000013_2}', "");
    Expect(1, 3957, '\P{Is_Ccc=000013_2}', "");
    Expect(0, 3957, '\P{^Is_Ccc=000013_2}', "");
    Error('\p{Canonical_Combining_Class=:=-CCC133}');
    Error('\P{Canonical_Combining_Class=:=-CCC133}');
    Expect(0, 1, '\p{Canonical_Combining_Class=ccc133}', "");
    Expect(1, 1, '\p{^Canonical_Combining_Class=ccc133}', "");
    Expect(1, 1, '\P{Canonical_Combining_Class=ccc133}', "");
    Expect(0, 1, '\P{^Canonical_Combining_Class=ccc133}', "");
    Expect(0, 1, '\p{Canonical_Combining_Class=--ccc133}', "");
    Expect(1, 1, '\p{^Canonical_Combining_Class=--ccc133}', "");
    Expect(1, 1, '\P{Canonical_Combining_Class=--ccc133}', "");
    Expect(0, 1, '\P{^Canonical_Combining_Class=--ccc133}', "");
    Error('\p{Ccc=/a/_	0_0_0_0_0_0_0_1_33}');
    Error('\P{Ccc=/a/_	0_0_0_0_0_0_0_1_33}');
    Expect(0, 1, '\p{Ccc=0000000133}', "");
    Expect(1, 1, '\p{^Ccc=0000000133}', "");
    Expect(1, 1, '\P{Ccc=0000000133}', "");
    Expect(0, 1, '\P{^Ccc=0000000133}', "");
    Error('\p{Is_Canonical_Combining_Class= /a/ccc133}');
    Error('\P{Is_Canonical_Combining_Class= /a/ccc133}');
    Expect(0, 1, '\p{Is_Canonical_Combining_Class=ccc133}', "");
    Expect(1, 1, '\p{^Is_Canonical_Combining_Class=ccc133}', "");
    Expect(1, 1, '\P{Is_Canonical_Combining_Class=ccc133}', "");
    Expect(0, 1, '\P{^Is_Canonical_Combining_Class=ccc133}', "");
    Expect(0, 1, '\p{Is_Canonical_Combining_Class= CCC133}', "");
    Expect(1, 1, '\p{^Is_Canonical_Combining_Class= CCC133}', "");
    Expect(1, 1, '\P{Is_Canonical_Combining_Class= CCC133}', "");
    Expect(0, 1, '\P{^Is_Canonical_Combining_Class= CCC133}', "");
    Error('\p{Is_Ccc=-:=00000000133}');
    Error('\P{Is_Ccc=-:=00000000133}');
    Expect(0, 1, '\p{Is_Ccc=00_01_33}', "");
    Expect(1, 1, '\p{^Is_Ccc=00_01_33}', "");
    Expect(1, 1, '\P{Is_Ccc=00_01_33}', "");
    Expect(0, 1, '\P{^Is_Ccc=00_01_33}', "");
    Error('\p{Canonical_Combining_Class=/a/_ CCC14}');
    Error('\P{Canonical_Combining_Class=/a/_ CCC14}');
    Expect(1, 1460, '\p{Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1460, '\p{^Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1460, '\P{Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1460, '\P{^Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1461, '\p{Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1461, '\p{^Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1461, '\P{Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1461, '\P{^Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1460, '\p{Canonical_Combining_Class=-CCC14}', "");
    Expect(0, 1460, '\p{^Canonical_Combining_Class=-CCC14}', "");
    Expect(0, 1460, '\P{Canonical_Combining_Class=-CCC14}', "");
    Expect(1, 1460, '\P{^Canonical_Combining_Class=-CCC14}', "");
    Expect(0, 1461, '\p{Canonical_Combining_Class=-CCC14}', "");
    Expect(1, 1461, '\p{^Canonical_Combining_Class=-CCC14}', "");
    Expect(1, 1461, '\P{Canonical_Combining_Class=-CCC14}', "");
    Expect(0, 1461, '\P{^Canonical_Combining_Class=-CCC14}', "");
    Error('\p{Ccc=	:=+00000_00001_4}');
    Error('\P{Ccc=	:=+00000_00001_4}');
    Expect(1, 1460, '\p{Ccc=0_0_14}', "");
    Expect(0, 1460, '\p{^Ccc=0_0_14}', "");
    Expect(0, 1460, '\P{Ccc=0_0_14}', "");
    Expect(1, 1460, '\P{^Ccc=0_0_14}', "");
    Expect(0, 1461, '\p{Ccc=0_0_14}', "");
    Expect(1, 1461, '\p{^Ccc=0_0_14}', "");
    Expect(1, 1461, '\P{Ccc=0_0_14}', "");
    Expect(0, 1461, '\P{^Ccc=0_0_14}', "");
    Error('\p{Is_Canonical_Combining_Class=	_CCC14:=}');
    Error('\P{Is_Canonical_Combining_Class=	_CCC14:=}');
    Expect(1, 1460, '\p{Is_Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1460, '\p{^Is_Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1460, '\P{Is_Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1460, '\P{^Is_Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1461, '\p{Is_Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1461, '\p{^Is_Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1461, '\P{Is_Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1461, '\P{^Is_Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1460, '\p{Is_Canonical_Combining_Class= 	CCC14}', "");
    Expect(0, 1460, '\p{^Is_Canonical_Combining_Class= 	CCC14}', "");
    Expect(0, 1460, '\P{Is_Canonical_Combining_Class= 	CCC14}', "");
    Expect(1, 1460, '\P{^Is_Canonical_Combining_Class= 	CCC14}', "");
    Expect(0, 1461, '\p{Is_Canonical_Combining_Class= 	CCC14}', "");
    Expect(1, 1461, '\p{^Is_Canonical_Combining_Class= 	CCC14}', "");
    Expect(1, 1461, '\P{Is_Canonical_Combining_Class= 	CCC14}', "");
    Expect(0, 1461, '\P{^Is_Canonical_Combining_Class= 	CCC14}', "");
    Error('\p{Is_Ccc=0_0_0_0_0_0_0_0_014/a/}');
    Error('\P{Is_Ccc=0_0_0_0_0_0_0_0_014/a/}');
    Expect(1, 1460, '\p{Is_Ccc: 01_4}', "");
    Expect(0, 1460, '\p{^Is_Ccc: 01_4}', "");
    Expect(0, 1460, '\P{Is_Ccc: 01_4}', "");
    Expect(1, 1460, '\P{^Is_Ccc: 01_4}', "");
    Expect(0, 1461, '\p{Is_Ccc: 01_4}', "");
    Expect(1, 1461, '\p{^Is_Ccc: 01_4}', "");
    Expect(1, 1461, '\P{Is_Ccc: 01_4}', "");
    Expect(0, 1461, '\P{^Is_Ccc: 01_4}', "");
    Error('\p{Canonical_Combining_Class= _CCC15:=}');
    Error('\P{Canonical_Combining_Class= _CCC15:=}');
    Expect(1, 1461, '\p{Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1461, '\p{^Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1461, '\P{Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1461, '\P{^Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1462, '\p{Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1462, '\p{^Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1462, '\P{Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1462, '\P{^Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1461, '\p{Canonical_Combining_Class=__ccc15}', "");
    Expect(0, 1461, '\p{^Canonical_Combining_Class=__ccc15}', "");
    Expect(0, 1461, '\P{Canonical_Combining_Class=__ccc15}', "");
    Expect(1, 1461, '\P{^Canonical_Combining_Class=__ccc15}', "");
    Expect(0, 1462, '\p{Canonical_Combining_Class=__ccc15}', "");
    Expect(1, 1462, '\p{^Canonical_Combining_Class=__ccc15}', "");
    Expect(1, 1462, '\P{Canonical_Combining_Class=__ccc15}', "");
    Expect(0, 1462, '\P{^Canonical_Combining_Class=__ccc15}', "");
    Error('\p{Ccc=--+0000015:=}');
    Error('\P{Ccc=--+0000015:=}');
    Expect(1, 1461, '\p{Ccc=15}', "");
    Expect(0, 1461, '\p{^Ccc=15}', "");
    Expect(0, 1461, '\P{Ccc=15}', "");
    Expect(1, 1461, '\P{^Ccc=15}', "");
    Expect(0, 1462, '\p{Ccc=15}', "");
    Expect(1, 1462, '\p{^Ccc=15}', "");
    Expect(1, 1462, '\P{Ccc=15}', "");
    Expect(0, 1462, '\P{^Ccc=15}', "");
    Error('\p{Is_Canonical_Combining_Class=-CCC15/a/}');
    Error('\P{Is_Canonical_Combining_Class=-CCC15/a/}');
    Expect(1, 1461, '\p{Is_Canonical_Combining_Class:   ccc15}', "");
    Expect(0, 1461, '\p{^Is_Canonical_Combining_Class:   ccc15}', "");
    Expect(0, 1461, '\P{Is_Canonical_Combining_Class:   ccc15}', "");
    Expect(1, 1461, '\P{^Is_Canonical_Combining_Class:   ccc15}', "");
    Expect(0, 1462, '\p{Is_Canonical_Combining_Class:   ccc15}', "");
    Expect(1, 1462, '\p{^Is_Canonical_Combining_Class:   ccc15}', "");
    Expect(1, 1462, '\P{Is_Canonical_Combining_Class:   ccc15}', "");
    Expect(0, 1462, '\P{^Is_Canonical_Combining_Class:   ccc15}', "");
    Expect(1, 1461, '\p{Is_Canonical_Combining_Class=CCC15}', "");
    Expect(0, 1461, '\p{^Is_Canonical_Combining_Class=CCC15}', "");
    Expect(0, 1461, '\P{Is_Canonical_Combining_Class=CCC15}', "");
    Expect(1, 1461, '\P{^Is_Canonical_Combining_Class=CCC15}', "");
    Expect(0, 1462, '\p{Is_Canonical_Combining_Class=CCC15}', "");
    Expect(1, 1462, '\p{^Is_Canonical_Combining_Class=CCC15}', "");
    Expect(1, 1462, '\P{Is_Canonical_Combining_Class=CCC15}', "");
    Expect(0, 1462, '\P{^Is_Canonical_Combining_Class=CCC15}', "");
    Error('\p{Is_Ccc=/a/ 0000015}');
    Error('\P{Is_Ccc=/a/ 0000015}');
    Expect(1, 1461, '\p{Is_Ccc=000000015}', "");
    Expect(0, 1461, '\p{^Is_Ccc=000000015}', "");
    Expect(0, 1461, '\P{Is_Ccc=000000015}', "");
    Expect(1, 1461, '\P{^Is_Ccc=000000015}', "");
    Expect(0, 1462, '\p{Is_Ccc=000000015}', "");
    Expect(1, 1462, '\p{^Is_Ccc=000000015}', "");
    Expect(1, 1462, '\P{Is_Ccc=000000015}', "");
    Expect(0, 1462, '\P{^Is_Ccc=000000015}', "");
    Error('\p{Canonical_Combining_Class= CCC16/a/}');
    Error('\P{Canonical_Combining_Class= CCC16/a/}');
    Expect(1, 1462, '\p{Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1462, '\p{^Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1462, '\P{Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1462, '\P{^Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1463, '\p{Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1463, '\p{^Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1463, '\P{Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1463, '\P{^Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1462, '\p{Canonical_Combining_Class=-CCC16}', "");
    Expect(0, 1462, '\p{^Canonical_Combining_Class=-CCC16}', "");
    Expect(0, 1462, '\P{Canonical_Combining_Class=-CCC16}', "");
    Expect(1, 1462, '\P{^Canonical_Combining_Class=-CCC16}', "");
    Expect(0, 1463, '\p{Canonical_Combining_Class=-CCC16}', "");
    Expect(1, 1463, '\p{^Canonical_Combining_Class=-CCC16}', "");
    Expect(1, 1463, '\P{Canonical_Combining_Class=-CCC16}', "");
    Expect(0, 1463, '\P{^Canonical_Combining_Class=-CCC16}', "");
    Error('\p{Ccc=/a/_0000016}');
    Error('\P{Ccc=/a/_0000016}');
    Expect(1, 1462, '\p{Ccc=+0000000016}', "");
    Expect(0, 1462, '\p{^Ccc=+0000000016}', "");
    Expect(0, 1462, '\P{Ccc=+0000000016}', "");
    Expect(1, 1462, '\P{^Ccc=+0000000016}', "");
    Expect(0, 1463, '\p{Ccc=+0000000016}', "");
    Expect(1, 1463, '\p{^Ccc=+0000000016}', "");
    Expect(1, 1463, '\P{Ccc=+0000000016}', "");
    Expect(0, 1463, '\P{^Ccc=+0000000016}', "");
    Error('\p{Is_Canonical_Combining_Class:	/a/	ccc16}');
    Error('\P{Is_Canonical_Combining_Class:	/a/	ccc16}');
    Expect(1, 1462, '\p{Is_Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1462, '\p{^Is_Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1462, '\P{Is_Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1462, '\P{^Is_Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1463, '\p{Is_Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1463, '\p{^Is_Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1463, '\P{Is_Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1463, '\P{^Is_Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1462, '\p{Is_Canonical_Combining_Class=__ccc16}', "");
    Expect(0, 1462, '\p{^Is_Canonical_Combining_Class=__ccc16}', "");
    Expect(0, 1462, '\P{Is_Canonical_Combining_Class=__ccc16}', "");
    Expect(1, 1462, '\P{^Is_Canonical_Combining_Class=__ccc16}', "");
    Expect(0, 1463, '\p{Is_Canonical_Combining_Class=__ccc16}', "");
    Expect(1, 1463, '\p{^Is_Canonical_Combining_Class=__ccc16}', "");
    Expect(1, 1463, '\P{Is_Canonical_Combining_Class=__ccc16}', "");
    Expect(0, 1463, '\P{^Is_Canonical_Combining_Class=__ccc16}', "");
    Error('\p{Is_Ccc=/a/__00016}');
    Error('\P{Is_Ccc=/a/__00016}');
    Expect(1, 1462, '\p{Is_Ccc=00001_6}', "");
    Expect(0, 1462, '\p{^Is_Ccc=00001_6}', "");
    Expect(0, 1462, '\P{Is_Ccc=00001_6}', "");
    Expect(1, 1462, '\P{^Is_Ccc=00001_6}', "");
    Expect(0, 1463, '\p{Is_Ccc=00001_6}', "");
    Expect(1, 1463, '\p{^Is_Ccc=00001_6}', "");
    Expect(1, 1463, '\P{Is_Ccc=00001_6}', "");
    Expect(0, 1463, '\P{^Is_Ccc=00001_6}', "");
    Error('\p{Canonical_Combining_Class=	-CCC17:=}');
    Error('\P{Canonical_Combining_Class=	-CCC17:=}');
    Expect(1, 1463, '\p{Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1463, '\p{^Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1463, '\P{Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1463, '\P{^Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1464, '\p{Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1464, '\p{^Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1464, '\P{Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1464, '\P{^Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1463, '\p{Canonical_Combining_Class=-_CCC17}', "");
    Expect(0, 1463, '\p{^Canonical_Combining_Class=-_CCC17}', "");
    Expect(0, 1463, '\P{Canonical_Combining_Class=-_CCC17}', "");
    Expect(1, 1463, '\P{^Canonical_Combining_Class=-_CCC17}', "");
    Expect(0, 1464, '\p{Canonical_Combining_Class=-_CCC17}', "");
    Expect(1, 1464, '\p{^Canonical_Combining_Class=-_CCC17}', "");
    Expect(1, 1464, '\P{Canonical_Combining_Class=-_CCC17}', "");
    Expect(0, 1464, '\P{^Canonical_Combining_Class=-_CCC17}', "");
    Error('\p{Ccc= /a/000017}');
    Error('\P{Ccc= /a/000017}');
    Expect(1, 1463, '\p{Ccc=+0_0_0_0_17}', "");
    Expect(0, 1463, '\p{^Ccc=+0_0_0_0_17}', "");
    Expect(0, 1463, '\P{Ccc=+0_0_0_0_17}', "");
    Expect(1, 1463, '\P{^Ccc=+0_0_0_0_17}', "");
    Expect(0, 1464, '\p{Ccc=+0_0_0_0_17}', "");
    Expect(1, 1464, '\p{^Ccc=+0_0_0_0_17}', "");
    Expect(1, 1464, '\P{Ccc=+0_0_0_0_17}', "");
    Expect(0, 1464, '\P{^Ccc=+0_0_0_0_17}', "");
    Error('\p{Is_Canonical_Combining_Class=:=	 CCC17}');
    Error('\P{Is_Canonical_Combining_Class=:=	 CCC17}');
    Expect(1, 1463, '\p{Is_Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1463, '\p{^Is_Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1463, '\P{Is_Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1463, '\P{^Is_Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1464, '\p{Is_Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1464, '\p{^Is_Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1464, '\P{Is_Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1464, '\P{^Is_Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1463, '\p{Is_Canonical_Combining_Class=--ccc17}', "");
    Expect(0, 1463, '\p{^Is_Canonical_Combining_Class=--ccc17}', "");
    Expect(0, 1463, '\P{Is_Canonical_Combining_Class=--ccc17}', "");
    Expect(1, 1463, '\P{^Is_Canonical_Combining_Class=--ccc17}', "");
    Expect(0, 1464, '\p{Is_Canonical_Combining_Class=--ccc17}', "");
    Expect(1, 1464, '\p{^Is_Canonical_Combining_Class=--ccc17}', "");
    Expect(1, 1464, '\P{Is_Canonical_Combining_Class=--ccc17}', "");
    Expect(0, 1464, '\P{^Is_Canonical_Combining_Class=--ccc17}', "");
    Error('\p{Is_Ccc=/a/+017}');
    Error('\P{Is_Ccc=/a/+017}');
    Expect(1, 1463, '\p{Is_Ccc=000_000_000_17}', "");
    Expect(0, 1463, '\p{^Is_Ccc=000_000_000_17}', "");
    Expect(0, 1463, '\P{Is_Ccc=000_000_000_17}', "");
    Expect(1, 1463, '\P{^Is_Ccc=000_000_000_17}', "");
    Expect(0, 1464, '\p{Is_Ccc=000_000_000_17}', "");
    Expect(1, 1464, '\p{^Is_Ccc=000_000_000_17}', "");
    Expect(1, 1464, '\P{Is_Ccc=000_000_000_17}', "");
    Expect(0, 1464, '\P{^Is_Ccc=000_000_000_17}', "");
    Error('\p{Canonical_Combining_Class=  CCC18:=}');
    Error('\P{Canonical_Combining_Class=  CCC18:=}');
    Expect(1, 1479, '\p{Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1479, '\p{^Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1479, '\P{Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1479, '\P{^Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1480, '\p{Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1480, '\p{^Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1480, '\P{Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1480, '\P{^Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1479, '\p{Canonical_Combining_Class=-CCC18}', "");
    Expect(0, 1479, '\p{^Canonical_Combining_Class=-CCC18}', "");
    Expect(0, 1479, '\P{Canonical_Combining_Class=-CCC18}', "");
    Expect(1, 1479, '\P{^Canonical_Combining_Class=-CCC18}', "");
    Expect(0, 1480, '\p{Canonical_Combining_Class=-CCC18}', "");
    Expect(1, 1480, '\p{^Canonical_Combining_Class=-CCC18}', "");
    Expect(1, 1480, '\P{Canonical_Combining_Class=-CCC18}', "");
    Expect(0, 1480, '\P{^Canonical_Combining_Class=-CCC18}', "");
    Error('\p{Ccc=/a/	 +0000000018}');
    Error('\P{Ccc=/a/	 +0000000018}');
    Expect(1, 1479, '\p{Ccc=+0018}', "");
    Expect(0, 1479, '\p{^Ccc=+0018}', "");
    Expect(0, 1479, '\P{Ccc=+0018}', "");
    Expect(1, 1479, '\P{^Ccc=+0018}', "");
    Expect(0, 1480, '\p{Ccc=+0018}', "");
    Expect(1, 1480, '\p{^Ccc=+0018}', "");
    Expect(1, 1480, '\P{Ccc=+0018}', "");
    Expect(0, 1480, '\P{^Ccc=+0018}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/ ccc18}');
    Error('\P{Is_Canonical_Combining_Class=/a/ ccc18}');
    Expect(1, 1479, '\p{Is_Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1479, '\p{^Is_Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1479, '\P{Is_Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1479, '\P{^Is_Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1480, '\p{Is_Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1480, '\p{^Is_Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1480, '\P{Is_Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1480, '\P{^Is_Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1479, '\p{Is_Canonical_Combining_Class=_CCC18}', "");
    Expect(0, 1479, '\p{^Is_Canonical_Combining_Class=_CCC18}', "");
    Expect(0, 1479, '\P{Is_Canonical_Combining_Class=_CCC18}', "");
    Expect(1, 1479, '\P{^Is_Canonical_Combining_Class=_CCC18}', "");
    Expect(0, 1480, '\p{Is_Canonical_Combining_Class=_CCC18}', "");
    Expect(1, 1480, '\p{^Is_Canonical_Combining_Class=_CCC18}', "");
    Expect(1, 1480, '\P{Is_Canonical_Combining_Class=_CCC18}', "");
    Expect(0, 1480, '\P{^Is_Canonical_Combining_Class=_CCC18}', "");
    Error('\p{Is_Ccc= /a/+00_00_00_00_18}');
    Error('\P{Is_Ccc= /a/+00_00_00_00_18}');
    Expect(1, 1479, '\p{Is_Ccc=00000000018}', "");
    Expect(0, 1479, '\p{^Is_Ccc=00000000018}', "");
    Expect(0, 1479, '\P{Is_Ccc=00000000018}', "");
    Expect(1, 1479, '\P{^Is_Ccc=00000000018}', "");
    Expect(0, 1480, '\p{Is_Ccc=00000000018}', "");
    Expect(1, 1480, '\p{^Is_Ccc=00000000018}', "");
    Expect(1, 1480, '\P{Is_Ccc=00000000018}', "");
    Expect(0, 1480, '\P{^Is_Ccc=00000000018}', "");
    Error('\p{Canonical_Combining_Class=:=-	CCC19}');
    Error('\P{Canonical_Combining_Class=:=-	CCC19}');
    Expect(1, 1466, '\p{Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1466, '\p{^Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1466, '\P{Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1466, '\P{^Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1467, '\p{Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1467, '\p{^Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1467, '\P{Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1467, '\P{^Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1466, '\p{Canonical_Combining_Class:	_-CCC19}', "");
    Expect(0, 1466, '\p{^Canonical_Combining_Class:	_-CCC19}', "");
    Expect(0, 1466, '\P{Canonical_Combining_Class:	_-CCC19}', "");
    Expect(1, 1466, '\P{^Canonical_Combining_Class:	_-CCC19}', "");
    Expect(0, 1467, '\p{Canonical_Combining_Class:	_-CCC19}', "");
    Expect(1, 1467, '\p{^Canonical_Combining_Class:	_-CCC19}', "");
    Expect(1, 1467, '\P{Canonical_Combining_Class:	_-CCC19}', "");
    Expect(0, 1467, '\P{^Canonical_Combining_Class:	_-CCC19}', "");
    Error('\p{Ccc: /a/	 000000019}');
    Error('\P{Ccc: /a/	 000000019}');
    Expect(1, 1466, '\p{Ccc=00_00_00_019}', "");
    Expect(0, 1466, '\p{^Ccc=00_00_00_019}', "");
    Expect(0, 1466, '\P{Ccc=00_00_00_019}', "");
    Expect(1, 1466, '\P{^Ccc=00_00_00_019}', "");
    Expect(0, 1467, '\p{Ccc=00_00_00_019}', "");
    Expect(1, 1467, '\p{^Ccc=00_00_00_019}', "");
    Expect(1, 1467, '\P{Ccc=00_00_00_019}', "");
    Expect(0, 1467, '\P{^Ccc=00_00_00_019}', "");
    Error('\p{Is_Canonical_Combining_Class=:=_-CCC19}');
    Error('\P{Is_Canonical_Combining_Class=:=_-CCC19}');
    Expect(1, 1466, '\p{Is_Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1466, '\p{^Is_Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1466, '\P{Is_Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1466, '\P{^Is_Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1467, '\p{Is_Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1467, '\p{^Is_Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1467, '\P{Is_Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1467, '\P{^Is_Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1466, '\p{Is_Canonical_Combining_Class=-CCC19}', "");
    Expect(0, 1466, '\p{^Is_Canonical_Combining_Class=-CCC19}', "");
    Expect(0, 1466, '\P{Is_Canonical_Combining_Class=-CCC19}', "");
    Expect(1, 1466, '\P{^Is_Canonical_Combining_Class=-CCC19}', "");
    Expect(0, 1467, '\p{Is_Canonical_Combining_Class=-CCC19}', "");
    Expect(1, 1467, '\p{^Is_Canonical_Combining_Class=-CCC19}', "");
    Expect(1, 1467, '\P{Is_Canonical_Combining_Class=-CCC19}', "");
    Expect(0, 1467, '\P{^Is_Canonical_Combining_Class=-CCC19}', "");
    Error('\p{Is_Ccc=-	0_0_19/a/}');
    Error('\P{Is_Ccc=-	0_0_19/a/}');
    Expect(1, 1466, '\p{Is_Ccc=0000019}', "");
    Expect(0, 1466, '\p{^Is_Ccc=0000019}', "");
    Expect(0, 1466, '\P{Is_Ccc=0000019}', "");
    Expect(1, 1466, '\P{^Is_Ccc=0000019}', "");
    Expect(0, 1467, '\p{Is_Ccc=0000019}', "");
    Expect(1, 1467, '\p{^Is_Ccc=0000019}', "");
    Expect(1, 1467, '\P{Is_Ccc=0000019}', "");
    Expect(0, 1467, '\P{^Is_Ccc=0000019}', "");
    Error('\p{Canonical_Combining_Class=_:=CCC20}');
    Error('\P{Canonical_Combining_Class=_:=CCC20}');
    Expect(1, 1467, '\p{Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1467, '\p{^Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1467, '\P{Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1467, '\P{^Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1468, '\p{Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1468, '\p{^Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1468, '\P{Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1468, '\P{^Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1467, '\p{Canonical_Combining_Class= 	CCC20}', "");
    Expect(0, 1467, '\p{^Canonical_Combining_Class= 	CCC20}', "");
    Expect(0, 1467, '\P{Canonical_Combining_Class= 	CCC20}', "");
    Expect(1, 1467, '\P{^Canonical_Combining_Class= 	CCC20}', "");
    Expect(0, 1468, '\p{Canonical_Combining_Class= 	CCC20}', "");
    Expect(1, 1468, '\p{^Canonical_Combining_Class= 	CCC20}', "");
    Expect(1, 1468, '\P{Canonical_Combining_Class= 	CCC20}', "");
    Expect(0, 1468, '\P{^Canonical_Combining_Class= 	CCC20}', "");
    Error('\p{Ccc=:=-	0_0_0_0_0_0_0_0020}');
    Error('\P{Ccc=:=-	0_0_0_0_0_0_0_0020}');
    Expect(1, 1467, '\p{Ccc=0000020}', "");
    Expect(0, 1467, '\p{^Ccc=0000020}', "");
    Expect(0, 1467, '\P{Ccc=0000020}', "");
    Expect(1, 1467, '\P{^Ccc=0000020}', "");
    Expect(0, 1468, '\p{Ccc=0000020}', "");
    Expect(1, 1468, '\p{^Ccc=0000020}', "");
    Expect(1, 1468, '\P{Ccc=0000020}', "");
    Expect(0, 1468, '\P{^Ccc=0000020}', "");
    Error('\p{Is_Canonical_Combining_Class=_ ccc20:=}');
    Error('\P{Is_Canonical_Combining_Class=_ ccc20:=}');
    Expect(1, 1467, '\p{Is_Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1467, '\p{^Is_Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1467, '\P{Is_Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1467, '\P{^Is_Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1468, '\p{Is_Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1468, '\p{^Is_Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1468, '\P{Is_Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1468, '\P{^Is_Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1467, '\p{Is_Canonical_Combining_Class=--CCC20}', "");
    Expect(0, 1467, '\p{^Is_Canonical_Combining_Class=--CCC20}', "");
    Expect(0, 1467, '\P{Is_Canonical_Combining_Class=--CCC20}', "");
    Expect(1, 1467, '\P{^Is_Canonical_Combining_Class=--CCC20}', "");
    Expect(0, 1468, '\p{Is_Canonical_Combining_Class=--CCC20}', "");
    Expect(1, 1468, '\p{^Is_Canonical_Combining_Class=--CCC20}', "");
    Expect(1, 1468, '\P{Is_Canonical_Combining_Class=--CCC20}', "");
    Expect(0, 1468, '\P{^Is_Canonical_Combining_Class=--CCC20}', "");
    Error('\p{Is_Ccc=-	00_00_20/a/}');
    Error('\P{Is_Ccc=-	00_00_20/a/}');
    Expect(1, 1467, '\p{Is_Ccc:	0_0_0_0_0_0_0_0020}', "");
    Expect(0, 1467, '\p{^Is_Ccc:	0_0_0_0_0_0_0_0020}', "");
    Expect(0, 1467, '\P{Is_Ccc:	0_0_0_0_0_0_0_0020}', "");
    Expect(1, 1467, '\P{^Is_Ccc:	0_0_0_0_0_0_0_0020}', "");
    Expect(0, 1468, '\p{Is_Ccc:	0_0_0_0_0_0_0_0020}', "");
    Expect(1, 1468, '\p{^Is_Ccc:	0_0_0_0_0_0_0_0020}', "");
    Expect(1, 1468, '\P{Is_Ccc:	0_0_0_0_0_0_0_0020}', "");
    Expect(0, 1468, '\P{^Is_Ccc:	0_0_0_0_0_0_0_0020}', "");
    Error('\p{Canonical_Combining_Class=	CCC21/a/}');
    Error('\P{Canonical_Combining_Class=	CCC21/a/}');
    Expect(1, 1468, '\p{Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1468, '\p{^Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1468, '\P{Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1468, '\P{^Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1469, '\p{Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1469, '\p{^Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1469, '\P{Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1469, '\P{^Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1468, '\p{Canonical_Combining_Class= ccc21}', "");
    Expect(0, 1468, '\p{^Canonical_Combining_Class= ccc21}', "");
    Expect(0, 1468, '\P{Canonical_Combining_Class= ccc21}', "");
    Expect(1, 1468, '\P{^Canonical_Combining_Class= ccc21}', "");
    Expect(0, 1469, '\p{Canonical_Combining_Class= ccc21}', "");
    Expect(1, 1469, '\p{^Canonical_Combining_Class= ccc21}', "");
    Expect(1, 1469, '\P{Canonical_Combining_Class= ccc21}', "");
    Expect(0, 1469, '\P{^Canonical_Combining_Class= ccc21}', "");
    Error('\p{Ccc=__002_1/a/}');
    Error('\P{Ccc=__002_1/a/}');
    Expect(1, 1468, '\p{Ccc=+21}', "");
    Expect(0, 1468, '\p{^Ccc=+21}', "");
    Expect(0, 1468, '\P{Ccc=+21}', "");
    Expect(1, 1468, '\P{^Ccc=+21}', "");
    Expect(0, 1469, '\p{Ccc=+21}', "");
    Expect(1, 1469, '\p{^Ccc=+21}', "");
    Expect(1, 1469, '\P{Ccc=+21}', "");
    Expect(0, 1469, '\P{^Ccc=+21}', "");
    Error('\p{Is_Canonical_Combining_Class=_:=ccc21}');
    Error('\P{Is_Canonical_Combining_Class=_:=ccc21}');
    Expect(1, 1468, '\p{Is_Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1468, '\p{^Is_Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1468, '\P{Is_Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1468, '\P{^Is_Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1469, '\p{Is_Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1469, '\p{^Is_Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1469, '\P{Is_Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1469, '\P{^Is_Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1468, '\p{Is_Canonical_Combining_Class= _CCC21}', "");
    Expect(0, 1468, '\p{^Is_Canonical_Combining_Class= _CCC21}', "");
    Expect(0, 1468, '\P{Is_Canonical_Combining_Class= _CCC21}', "");
    Expect(1, 1468, '\P{^Is_Canonical_Combining_Class= _CCC21}', "");
    Expect(0, 1469, '\p{Is_Canonical_Combining_Class= _CCC21}', "");
    Expect(1, 1469, '\p{^Is_Canonical_Combining_Class= _CCC21}', "");
    Expect(1, 1469, '\P{Is_Canonical_Combining_Class= _CCC21}', "");
    Expect(0, 1469, '\P{^Is_Canonical_Combining_Class= _CCC21}', "");
    Error('\p{Is_Ccc=-:=02_1}');
    Error('\P{Is_Ccc=-:=02_1}');
    Expect(1, 1468, '\p{Is_Ccc=002_1}', "");
    Expect(0, 1468, '\p{^Is_Ccc=002_1}', "");
    Expect(0, 1468, '\P{Is_Ccc=002_1}', "");
    Expect(1, 1468, '\P{^Is_Ccc=002_1}', "");
    Expect(0, 1469, '\p{Is_Ccc=002_1}', "");
    Expect(1, 1469, '\p{^Is_Ccc=002_1}', "");
    Expect(1, 1469, '\P{Is_Ccc=002_1}', "");
    Expect(0, 1469, '\P{^Is_Ccc=002_1}', "");
    Error('\p{Canonical_Combining_Class=-	CCC22/a/}');
    Error('\P{Canonical_Combining_Class=-	CCC22/a/}');
    Expect(1, 1469, '\p{Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1469, '\p{^Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1469, '\P{Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1469, '\P{^Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1470, '\p{Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1470, '\p{^Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1470, '\P{Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1470, '\P{^Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1469, '\p{Canonical_Combining_Class= CCC22}', "");
    Expect(0, 1469, '\p{^Canonical_Combining_Class= CCC22}', "");
    Expect(0, 1469, '\P{Canonical_Combining_Class= CCC22}', "");
    Expect(1, 1469, '\P{^Canonical_Combining_Class= CCC22}', "");
    Expect(0, 1470, '\p{Canonical_Combining_Class= CCC22}', "");
    Expect(1, 1470, '\p{^Canonical_Combining_Class= CCC22}', "");
    Expect(1, 1470, '\P{Canonical_Combining_Class= CCC22}', "");
    Expect(0, 1470, '\P{^Canonical_Combining_Class= CCC22}', "");
    Error('\p{Ccc=/a/--000000022}');
    Error('\P{Ccc=/a/--000000022}');
    Expect(1, 1469, '\p{Ccc:   0_0_0_22}', "");
    Expect(0, 1469, '\p{^Ccc:   0_0_0_22}', "");
    Expect(0, 1469, '\P{Ccc:   0_0_0_22}', "");
    Expect(1, 1469, '\P{^Ccc:   0_0_0_22}', "");
    Expect(0, 1470, '\p{Ccc:   0_0_0_22}', "");
    Expect(1, 1470, '\p{^Ccc:   0_0_0_22}', "");
    Expect(1, 1470, '\P{Ccc:   0_0_0_22}', "");
    Expect(0, 1470, '\P{^Ccc:   0_0_0_22}', "");
    Error('\p{Is_Canonical_Combining_Class=:=	 ccc22}');
    Error('\P{Is_Canonical_Combining_Class=:=	 ccc22}');
    Expect(1, 1469, '\p{Is_Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1469, '\p{^Is_Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1469, '\P{Is_Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1469, '\P{^Is_Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1470, '\p{Is_Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1470, '\p{^Is_Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1470, '\P{Is_Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1470, '\P{^Is_Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1469, '\p{Is_Canonical_Combining_Class=_CCC22}', "");
    Expect(0, 1469, '\p{^Is_Canonical_Combining_Class=_CCC22}', "");
    Expect(0, 1469, '\P{Is_Canonical_Combining_Class=_CCC22}', "");
    Expect(1, 1469, '\P{^Is_Canonical_Combining_Class=_CCC22}', "");
    Expect(0, 1470, '\p{Is_Canonical_Combining_Class=_CCC22}', "");
    Expect(1, 1470, '\p{^Is_Canonical_Combining_Class=_CCC22}', "");
    Expect(1, 1470, '\P{Is_Canonical_Combining_Class=_CCC22}', "");
    Expect(0, 1470, '\P{^Is_Canonical_Combining_Class=_CCC22}', "");
    Error('\p{Is_Ccc=	-022:=}');
    Error('\P{Is_Ccc=	-022:=}');
    Expect(1, 1469, '\p{Is_Ccc=+00_00_00_22}', "");
    Expect(0, 1469, '\p{^Is_Ccc=+00_00_00_22}', "");
    Expect(0, 1469, '\P{Is_Ccc=+00_00_00_22}', "");
    Expect(1, 1469, '\P{^Is_Ccc=+00_00_00_22}', "");
    Expect(0, 1470, '\p{Is_Ccc=+00_00_00_22}', "");
    Expect(1, 1470, '\p{^Is_Ccc=+00_00_00_22}', "");
    Expect(1, 1470, '\P{Is_Ccc=+00_00_00_22}', "");
    Expect(0, 1470, '\P{^Is_Ccc=+00_00_00_22}', "");
    Error('\p{Canonical_Combining_Class=/a/- CCC23}');
    Error('\P{Canonical_Combining_Class=/a/- CCC23}');
    Expect(1, 1471, '\p{Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1471, '\p{^Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1471, '\P{Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1471, '\P{^Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1472, '\p{Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1472, '\p{^Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1472, '\P{Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1472, '\P{^Canonical_Combining_Class=ccc23}', "");
    Error('\p{Ccc=:=_02_3}');
    Error('\P{Ccc=:=_02_3}');
    Expect(1, 1471, '\p{Ccc=+0_0_0_0_0_0_0023}', "");
    Expect(0, 1471, '\p{^Ccc=+0_0_0_0_0_0_0023}', "");
    Expect(0, 1471, '\P{Ccc=+0_0_0_0_0_0_0023}', "");
    Expect(1, 1471, '\P{^Ccc=+0_0_0_0_0_0_0023}', "");
    Expect(0, 1472, '\p{Ccc=+0_0_0_0_0_0_0023}', "");
    Expect(1, 1472, '\p{^Ccc=+0_0_0_0_0_0_0023}', "");
    Expect(1, 1472, '\P{Ccc=+0_0_0_0_0_0_0023}', "");
    Expect(0, 1472, '\P{^Ccc=+0_0_0_0_0_0_0023}', "");
    Error('\p{Is_Canonical_Combining_Class=-CCC23/a/}');
    Error('\P{Is_Canonical_Combining_Class=-CCC23/a/}');
    Expect(1, 1471, '\p{Is_Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1471, '\p{^Is_Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1471, '\P{Is_Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1471, '\P{^Is_Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1472, '\p{Is_Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1472, '\p{^Is_Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1472, '\P{Is_Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1472, '\P{^Is_Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1471, '\p{Is_Canonical_Combining_Class:_ccc23}', "");
    Expect(0, 1471, '\p{^Is_Canonical_Combining_Class:_ccc23}', "");
    Expect(0, 1471, '\P{Is_Canonical_Combining_Class:_ccc23}', "");
    Expect(1, 1471, '\P{^Is_Canonical_Combining_Class:_ccc23}', "");
    Expect(0, 1472, '\p{Is_Canonical_Combining_Class:_ccc23}', "");
    Expect(1, 1472, '\p{^Is_Canonical_Combining_Class:_ccc23}', "");
    Expect(1, 1472, '\P{Is_Canonical_Combining_Class:_ccc23}', "");
    Expect(0, 1472, '\P{^Is_Canonical_Combining_Class:_ccc23}', "");
    Error('\p{Is_Ccc=  0_0_0_0_0_0_0_023/a/}');
    Error('\P{Is_Ccc=  0_0_0_0_0_0_0_023/a/}');
    Expect(1, 1471, '\p{Is_Ccc:	0000023}', "");
    Expect(0, 1471, '\p{^Is_Ccc:	0000023}', "");
    Expect(0, 1471, '\P{Is_Ccc:	0000023}', "");
    Expect(1, 1471, '\P{^Is_Ccc:	0000023}', "");
    Expect(0, 1472, '\p{Is_Ccc:	0000023}', "");
    Expect(1, 1472, '\p{^Is_Ccc:	0000023}', "");
    Expect(1, 1472, '\P{Is_Ccc:	0000023}', "");
    Expect(0, 1472, '\P{^Is_Ccc:	0000023}', "");
    Error('\p{Canonical_Combining_Class=	CCC24:=}');
    Error('\P{Canonical_Combining_Class=	CCC24:=}');
    Expect(1, 1473, '\p{Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1473, '\p{^Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1473, '\P{Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1473, '\P{^Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1474, '\p{Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1474, '\p{^Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1474, '\P{Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1474, '\P{^Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1473, '\p{Canonical_Combining_Class= CCC24}', "");
    Expect(0, 1473, '\p{^Canonical_Combining_Class= CCC24}', "");
    Expect(0, 1473, '\P{Canonical_Combining_Class= CCC24}', "");
    Expect(1, 1473, '\P{^Canonical_Combining_Class= CCC24}', "");
    Expect(0, 1474, '\p{Canonical_Combining_Class= CCC24}', "");
    Expect(1, 1474, '\p{^Canonical_Combining_Class= CCC24}', "");
    Expect(1, 1474, '\P{Canonical_Combining_Class= CCC24}', "");
    Expect(0, 1474, '\P{^Canonical_Combining_Class= CCC24}', "");
    Error('\p{Ccc:  /a/00_00_02_4}');
    Error('\P{Ccc:  /a/00_00_02_4}');
    Expect(1, 1473, '\p{Ccc=+24}', "");
    Expect(0, 1473, '\p{^Ccc=+24}', "");
    Expect(0, 1473, '\P{Ccc=+24}', "");
    Expect(1, 1473, '\P{^Ccc=+24}', "");
    Expect(0, 1474, '\p{Ccc=+24}', "");
    Expect(1, 1474, '\p{^Ccc=+24}', "");
    Expect(1, 1474, '\P{Ccc=+24}', "");
    Expect(0, 1474, '\P{^Ccc=+24}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/-	CCC24}');
    Error('\P{Is_Canonical_Combining_Class=/a/-	CCC24}');
    Expect(1, 1473, '\p{Is_Canonical_Combining_Class:   ccc24}', "");
    Expect(0, 1473, '\p{^Is_Canonical_Combining_Class:   ccc24}', "");
    Expect(0, 1473, '\P{Is_Canonical_Combining_Class:   ccc24}', "");
    Expect(1, 1473, '\P{^Is_Canonical_Combining_Class:   ccc24}', "");
    Expect(0, 1474, '\p{Is_Canonical_Combining_Class:   ccc24}', "");
    Expect(1, 1474, '\p{^Is_Canonical_Combining_Class:   ccc24}', "");
    Expect(1, 1474, '\P{Is_Canonical_Combining_Class:   ccc24}', "");
    Expect(0, 1474, '\P{^Is_Canonical_Combining_Class:   ccc24}', "");
    Expect(1, 1473, '\p{Is_Canonical_Combining_Class=_ccc24}', "");
    Expect(0, 1473, '\p{^Is_Canonical_Combining_Class=_ccc24}', "");
    Expect(0, 1473, '\P{Is_Canonical_Combining_Class=_ccc24}', "");
    Expect(1, 1473, '\P{^Is_Canonical_Combining_Class=_ccc24}', "");
    Expect(0, 1474, '\p{Is_Canonical_Combining_Class=_ccc24}', "");
    Expect(1, 1474, '\p{^Is_Canonical_Combining_Class=_ccc24}', "");
    Expect(1, 1474, '\P{Is_Canonical_Combining_Class=_ccc24}', "");
    Expect(0, 1474, '\P{^Is_Canonical_Combining_Class=_ccc24}', "");
    Error('\p{Is_Ccc=/a/+00000000024}');
    Error('\P{Is_Ccc=/a/+00000000024}');
    Expect(1, 1473, '\p{Is_Ccc=+024}', "");
    Expect(0, 1473, '\p{^Is_Ccc=+024}', "");
    Expect(0, 1473, '\P{Is_Ccc=+024}', "");
    Expect(1, 1473, '\P{^Is_Ccc=+024}', "");
    Expect(0, 1474, '\p{Is_Ccc=+024}', "");
    Expect(1, 1474, '\p{^Is_Ccc=+024}', "");
    Expect(1, 1474, '\P{Is_Ccc=+024}', "");
    Expect(0, 1474, '\P{^Is_Ccc=+024}', "");
    Error('\p{Canonical_Combining_Class=_CCC25:=}');
    Error('\P{Canonical_Combining_Class=_CCC25:=}');
    Expect(1, 1474, '\p{Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1474, '\p{^Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1474, '\P{Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1474, '\P{^Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1475, '\p{Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1475, '\p{^Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1475, '\P{Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1475, '\P{^Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1474, '\p{Canonical_Combining_Class=-CCC25}', "");
    Expect(0, 1474, '\p{^Canonical_Combining_Class=-CCC25}', "");
    Expect(0, 1474, '\P{Canonical_Combining_Class=-CCC25}', "");
    Expect(1, 1474, '\P{^Canonical_Combining_Class=-CCC25}', "");
    Expect(0, 1475, '\p{Canonical_Combining_Class=-CCC25}', "");
    Expect(1, 1475, '\p{^Canonical_Combining_Class=-CCC25}', "");
    Expect(1, 1475, '\P{Canonical_Combining_Class=-CCC25}', "");
    Expect(0, 1475, '\P{^Canonical_Combining_Class=-CCC25}', "");
    Error('\p{Ccc=:=-_000_000_25}');
    Error('\P{Ccc=:=-_000_000_25}');
    Expect(1, 1474, '\p{Ccc=0000025}', "");
    Expect(0, 1474, '\p{^Ccc=0000025}', "");
    Expect(0, 1474, '\P{Ccc=0000025}', "");
    Expect(1, 1474, '\P{^Ccc=0000025}', "");
    Expect(0, 1475, '\p{Ccc=0000025}', "");
    Expect(1, 1475, '\p{^Ccc=0000025}', "");
    Expect(1, 1475, '\P{Ccc=0000025}', "");
    Expect(0, 1475, '\P{^Ccc=0000025}', "");
    Error('\p{Is_Canonical_Combining_Class=_:=CCC25}');
    Error('\P{Is_Canonical_Combining_Class=_:=CCC25}');
    Expect(1, 1474, '\p{Is_Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1474, '\p{^Is_Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1474, '\P{Is_Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1474, '\P{^Is_Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1475, '\p{Is_Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1475, '\p{^Is_Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1475, '\P{Is_Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1475, '\P{^Is_Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1474, '\p{Is_Canonical_Combining_Class:		-ccc25}', "");
    Expect(0, 1474, '\p{^Is_Canonical_Combining_Class:		-ccc25}', "");
    Expect(0, 1474, '\P{Is_Canonical_Combining_Class:		-ccc25}', "");
    Expect(1, 1474, '\P{^Is_Canonical_Combining_Class:		-ccc25}', "");
    Expect(0, 1475, '\p{Is_Canonical_Combining_Class:		-ccc25}', "");
    Expect(1, 1475, '\p{^Is_Canonical_Combining_Class:		-ccc25}', "");
    Expect(1, 1475, '\P{Is_Canonical_Combining_Class:		-ccc25}', "");
    Expect(0, 1475, '\P{^Is_Canonical_Combining_Class:		-ccc25}', "");
    Error('\p{Is_Ccc=-+00000000025/a/}');
    Error('\P{Is_Ccc=-+00000000025/a/}');
    Expect(1, 1474, '\p{Is_Ccc=+00000025}', "");
    Expect(0, 1474, '\p{^Is_Ccc=+00000025}', "");
    Expect(0, 1474, '\P{Is_Ccc=+00000025}', "");
    Expect(1, 1474, '\P{^Is_Ccc=+00000025}', "");
    Expect(0, 1475, '\p{Is_Ccc=+00000025}', "");
    Expect(1, 1475, '\p{^Is_Ccc=+00000025}', "");
    Expect(1, 1475, '\P{Is_Ccc=+00000025}', "");
    Expect(0, 1475, '\P{^Is_Ccc=+00000025}', "");
    Error('\p{Canonical_Combining_Class:	--CCC26:=}');
    Error('\P{Canonical_Combining_Class:	--CCC26:=}');
    Expect(1, 64286, '\p{Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64286, '\p{^Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64286, '\P{Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64286, '\P{^Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64287, '\p{Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64287, '\p{^Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64287, '\P{Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64287, '\P{^Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64286, '\p{Canonical_Combining_Class=-ccc26}', "");
    Expect(0, 64286, '\p{^Canonical_Combining_Class=-ccc26}', "");
    Expect(0, 64286, '\P{Canonical_Combining_Class=-ccc26}', "");
    Expect(1, 64286, '\P{^Canonical_Combining_Class=-ccc26}', "");
    Expect(0, 64287, '\p{Canonical_Combining_Class=-ccc26}', "");
    Expect(1, 64287, '\p{^Canonical_Combining_Class=-ccc26}', "");
    Expect(1, 64287, '\P{Canonical_Combining_Class=-ccc26}', "");
    Expect(0, 64287, '\P{^Canonical_Combining_Class=-ccc26}', "");
    Error('\p{Ccc=:=	 2_6}');
    Error('\P{Ccc=:=	 2_6}');
    Expect(1, 64286, '\p{Ccc=0000_0002_6}', "");
    Expect(0, 64286, '\p{^Ccc=0000_0002_6}', "");
    Expect(0, 64286, '\P{Ccc=0000_0002_6}', "");
    Expect(1, 64286, '\P{^Ccc=0000_0002_6}', "");
    Expect(0, 64287, '\p{Ccc=0000_0002_6}', "");
    Expect(1, 64287, '\p{^Ccc=0000_0002_6}', "");
    Expect(1, 64287, '\P{Ccc=0000_0002_6}', "");
    Expect(0, 64287, '\P{^Ccc=0000_0002_6}', "");
    Error('\p{Is_Canonical_Combining_Class=__CCC26:=}');
    Error('\P{Is_Canonical_Combining_Class=__CCC26:=}');
    Expect(1, 64286, '\p{Is_Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64286, '\p{^Is_Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64286, '\P{Is_Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64286, '\P{^Is_Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64287, '\p{Is_Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64287, '\p{^Is_Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64287, '\P{Is_Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64287, '\P{^Is_Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64286, '\p{Is_Canonical_Combining_Class= CCC26}', "");
    Expect(0, 64286, '\p{^Is_Canonical_Combining_Class= CCC26}', "");
    Expect(0, 64286, '\P{Is_Canonical_Combining_Class= CCC26}', "");
    Expect(1, 64286, '\P{^Is_Canonical_Combining_Class= CCC26}', "");
    Expect(0, 64287, '\p{Is_Canonical_Combining_Class= CCC26}', "");
    Expect(1, 64287, '\p{^Is_Canonical_Combining_Class= CCC26}', "");
    Expect(1, 64287, '\P{Is_Canonical_Combining_Class= CCC26}', "");
    Expect(0, 64287, '\P{^Is_Canonical_Combining_Class= CCC26}', "");
    Error('\p{Is_Ccc=:=		0_0_0_0_0_0_0_0_0_26}');
    Error('\P{Is_Ccc=:=		0_0_0_0_0_0_0_0_0_26}');
    Expect(1, 64286, '\p{Is_Ccc=00000026}', "");
    Expect(0, 64286, '\p{^Is_Ccc=00000026}', "");
    Expect(0, 64286, '\P{Is_Ccc=00000026}', "");
    Expect(1, 64286, '\P{^Is_Ccc=00000026}', "");
    Expect(0, 64287, '\p{Is_Ccc=00000026}', "");
    Expect(1, 64287, '\p{^Is_Ccc=00000026}', "");
    Expect(1, 64287, '\P{Is_Ccc=00000026}', "");
    Expect(0, 64287, '\P{^Is_Ccc=00000026}', "");
    Error('\p{Canonical_Combining_Class=-/a/CCC27}');
    Error('\P{Canonical_Combining_Class=-/a/CCC27}');
    Expect(1, 2288, '\p{Canonical_Combining_Class:ccc27}', "");
    Expect(0, 2288, '\p{^Canonical_Combining_Class:ccc27}', "");
    Expect(0, 2288, '\P{Canonical_Combining_Class:ccc27}', "");
    Expect(1, 2288, '\P{^Canonical_Combining_Class:ccc27}', "");
    Expect(0, 2289, '\p{Canonical_Combining_Class:ccc27}', "");
    Expect(1, 2289, '\p{^Canonical_Combining_Class:ccc27}', "");
    Expect(1, 2289, '\P{Canonical_Combining_Class:ccc27}', "");
    Expect(0, 2289, '\P{^Canonical_Combining_Class:ccc27}', "");
    Expect(1, 2288, '\p{Canonical_Combining_Class=CCC27}', "");
    Expect(0, 2288, '\p{^Canonical_Combining_Class=CCC27}', "");
    Expect(0, 2288, '\P{Canonical_Combining_Class=CCC27}', "");
    Expect(1, 2288, '\P{^Canonical_Combining_Class=CCC27}', "");
    Expect(0, 2289, '\p{Canonical_Combining_Class=CCC27}', "");
    Expect(1, 2289, '\p{^Canonical_Combining_Class=CCC27}', "");
    Expect(1, 2289, '\P{Canonical_Combining_Class=CCC27}', "");
    Expect(0, 2289, '\P{^Canonical_Combining_Class=CCC27}', "");
    Error('\p{Ccc=:= 0027}');
    Error('\P{Ccc=:= 0027}');
    Expect(1, 2288, '\p{Ccc=0002_7}', "");
    Expect(0, 2288, '\p{^Ccc=0002_7}', "");
    Expect(0, 2288, '\P{Ccc=0002_7}', "");
    Expect(1, 2288, '\P{^Ccc=0002_7}', "");
    Expect(0, 2289, '\p{Ccc=0002_7}', "");
    Expect(1, 2289, '\p{^Ccc=0002_7}', "");
    Expect(1, 2289, '\P{Ccc=0002_7}', "");
    Expect(0, 2289, '\P{^Ccc=0002_7}', "");
    Error('\p{Is_Canonical_Combining_Class=-CCC27/a/}');
    Error('\P{Is_Canonical_Combining_Class=-CCC27/a/}');
    Expect(1, 2288, '\p{Is_Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2288, '\p{^Is_Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2288, '\P{Is_Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2288, '\P{^Is_Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2289, '\p{Is_Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2289, '\p{^Is_Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2289, '\P{Is_Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2289, '\P{^Is_Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2288, '\p{Is_Canonical_Combining_Class=- CCC27}', "");
    Expect(0, 2288, '\p{^Is_Canonical_Combining_Class=- CCC27}', "");
    Expect(0, 2288, '\P{Is_Canonical_Combining_Class=- CCC27}', "");
    Expect(1, 2288, '\P{^Is_Canonical_Combining_Class=- CCC27}', "");
    Expect(0, 2289, '\p{Is_Canonical_Combining_Class=- CCC27}', "");
    Expect(1, 2289, '\p{^Is_Canonical_Combining_Class=- CCC27}', "");
    Expect(1, 2289, '\P{Is_Canonical_Combining_Class=- CCC27}', "");
    Expect(0, 2289, '\P{^Is_Canonical_Combining_Class=- CCC27}', "");
    Error('\p{Is_Ccc=:=27}');
    Error('\P{Is_Ccc=:=27}');
    Expect(1, 2288, '\p{Is_Ccc=+00002_7}', "");
    Expect(0, 2288, '\p{^Is_Ccc=+00002_7}', "");
    Expect(0, 2288, '\P{Is_Ccc=+00002_7}', "");
    Expect(1, 2288, '\P{^Is_Ccc=+00002_7}', "");
    Expect(0, 2289, '\p{Is_Ccc=+00002_7}', "");
    Expect(1, 2289, '\p{^Is_Ccc=+00002_7}', "");
    Expect(1, 2289, '\P{Is_Ccc=+00002_7}', "");
    Expect(0, 2289, '\P{^Is_Ccc=+00002_7}', "");
    Error('\p{Canonical_Combining_Class=		CCC28/a/}');
    Error('\P{Canonical_Combining_Class=		CCC28/a/}');
    Expect(1, 2289, '\p{Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2289, '\p{^Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2289, '\P{Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2289, '\P{^Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2290, '\p{Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2290, '\p{^Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2290, '\P{Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2290, '\P{^Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2289, '\p{Canonical_Combining_Class=_ CCC28}', "");
    Expect(0, 2289, '\p{^Canonical_Combining_Class=_ CCC28}', "");
    Expect(0, 2289, '\P{Canonical_Combining_Class=_ CCC28}', "");
    Expect(1, 2289, '\P{^Canonical_Combining_Class=_ CCC28}', "");
    Expect(0, 2290, '\p{Canonical_Combining_Class=_ CCC28}', "");
    Expect(1, 2290, '\p{^Canonical_Combining_Class=_ CCC28}', "");
    Expect(1, 2290, '\P{Canonical_Combining_Class=_ CCC28}', "");
    Expect(0, 2290, '\P{^Canonical_Combining_Class=_ CCC28}', "");
    Error('\p{Ccc:  :=0000028}');
    Error('\P{Ccc:  :=0000028}');
    Expect(1, 2289, '\p{Ccc:+00002_8}', "");
    Expect(0, 2289, '\p{^Ccc:+00002_8}', "");
    Expect(0, 2289, '\P{Ccc:+00002_8}', "");
    Expect(1, 2289, '\P{^Ccc:+00002_8}', "");
    Expect(0, 2290, '\p{Ccc:+00002_8}', "");
    Expect(1, 2290, '\p{^Ccc:+00002_8}', "");
    Expect(1, 2290, '\P{Ccc:+00002_8}', "");
    Expect(0, 2290, '\P{^Ccc:+00002_8}', "");
    Error('\p{Is_Canonical_Combining_Class=	ccc28/a/}');
    Error('\P{Is_Canonical_Combining_Class=	ccc28/a/}');
    Expect(1, 2289, '\p{Is_Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2289, '\p{^Is_Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2289, '\P{Is_Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2289, '\P{^Is_Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2290, '\p{Is_Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2290, '\p{^Is_Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2290, '\P{Is_Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2290, '\P{^Is_Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2289, '\p{Is_Canonical_Combining_Class=-	CCC28}', "");
    Expect(0, 2289, '\p{^Is_Canonical_Combining_Class=-	CCC28}', "");
    Expect(0, 2289, '\P{Is_Canonical_Combining_Class=-	CCC28}', "");
    Expect(1, 2289, '\P{^Is_Canonical_Combining_Class=-	CCC28}', "");
    Expect(0, 2290, '\p{Is_Canonical_Combining_Class=-	CCC28}', "");
    Expect(1, 2290, '\p{^Is_Canonical_Combining_Class=-	CCC28}', "");
    Expect(1, 2290, '\P{Is_Canonical_Combining_Class=-	CCC28}', "");
    Expect(0, 2290, '\P{^Is_Canonical_Combining_Class=-	CCC28}', "");
    Error('\p{Is_Ccc=/a/ _+28}');
    Error('\P{Is_Ccc=/a/ _+28}');
    Expect(1, 2289, '\p{Is_Ccc=+0_0_0_0_0_28}', "");
    Expect(0, 2289, '\p{^Is_Ccc=+0_0_0_0_0_28}', "");
    Expect(0, 2289, '\P{Is_Ccc=+0_0_0_0_0_28}', "");
    Expect(1, 2289, '\P{^Is_Ccc=+0_0_0_0_0_28}', "");
    Expect(0, 2290, '\p{Is_Ccc=+0_0_0_0_0_28}', "");
    Expect(1, 2290, '\p{^Is_Ccc=+0_0_0_0_0_28}', "");
    Expect(1, 2290, '\P{Is_Ccc=+0_0_0_0_0_28}', "");
    Expect(0, 2290, '\P{^Is_Ccc=+0_0_0_0_0_28}', "");
    Error('\p{Canonical_Combining_Class=/a/  CCC29}');
    Error('\P{Canonical_Combining_Class=/a/  CCC29}');
    Expect(1, 2290, '\p{Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2290, '\p{^Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2290, '\P{Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2290, '\P{^Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2291, '\p{Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2291, '\p{^Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2291, '\P{Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2291, '\P{^Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2290, '\p{Canonical_Combining_Class=  CCC29}', "");
    Expect(0, 2290, '\p{^Canonical_Combining_Class=  CCC29}', "");
    Expect(0, 2290, '\P{Canonical_Combining_Class=  CCC29}', "");
    Expect(1, 2290, '\P{^Canonical_Combining_Class=  CCC29}', "");
    Expect(0, 2291, '\p{Canonical_Combining_Class=  CCC29}', "");
    Expect(1, 2291, '\p{^Canonical_Combining_Class=  CCC29}', "");
    Expect(1, 2291, '\P{Canonical_Combining_Class=  CCC29}', "");
    Expect(0, 2291, '\P{^Canonical_Combining_Class=  CCC29}', "");
    Error('\p{Ccc=_	+000029:=}');
    Error('\P{Ccc=_	+000029:=}');
    Expect(1, 2290, '\p{Ccc:   0000000029}', "");
    Expect(0, 2290, '\p{^Ccc:   0000000029}', "");
    Expect(0, 2290, '\P{Ccc:   0000000029}', "");
    Expect(1, 2290, '\P{^Ccc:   0000000029}', "");
    Expect(0, 2291, '\p{Ccc:   0000000029}', "");
    Expect(1, 2291, '\p{^Ccc:   0000000029}', "");
    Expect(1, 2291, '\P{Ccc:   0000000029}', "");
    Expect(0, 2291, '\P{^Ccc:   0000000029}', "");
    Error('\p{Is_Canonical_Combining_Class=-/a/CCC29}');
    Error('\P{Is_Canonical_Combining_Class=-/a/CCC29}');
    Expect(1, 2290, '\p{Is_Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2290, '\p{^Is_Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2290, '\P{Is_Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2290, '\P{^Is_Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2291, '\p{Is_Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2291, '\p{^Is_Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2291, '\P{Is_Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2291, '\P{^Is_Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2290, '\p{Is_Canonical_Combining_Class=_CCC29}', "");
    Expect(0, 2290, '\p{^Is_Canonical_Combining_Class=_CCC29}', "");
    Expect(0, 2290, '\P{Is_Canonical_Combining_Class=_CCC29}', "");
    Expect(1, 2290, '\P{^Is_Canonical_Combining_Class=_CCC29}', "");
    Expect(0, 2291, '\p{Is_Canonical_Combining_Class=_CCC29}', "");
    Expect(1, 2291, '\p{^Is_Canonical_Combining_Class=_CCC29}', "");
    Expect(1, 2291, '\P{Is_Canonical_Combining_Class=_CCC29}', "");
    Expect(0, 2291, '\P{^Is_Canonical_Combining_Class=_CCC29}', "");
    Error('\p{Is_Ccc= 	2_9:=}');
    Error('\P{Is_Ccc= 	2_9:=}');
    Expect(1, 2290, '\p{Is_Ccc=000000029}', "");
    Expect(0, 2290, '\p{^Is_Ccc=000000029}', "");
    Expect(0, 2290, '\P{Is_Ccc=000000029}', "");
    Expect(1, 2290, '\P{^Is_Ccc=000000029}', "");
    Expect(0, 2291, '\p{Is_Ccc=000000029}', "");
    Expect(1, 2291, '\p{^Is_Ccc=000000029}', "");
    Expect(1, 2291, '\P{Is_Ccc=000000029}', "");
    Expect(0, 2291, '\P{^Is_Ccc=000000029}', "");
    Error('\p{Canonical_Combining_Class= :=CCC30}');
    Error('\P{Canonical_Combining_Class= :=CCC30}');
    Expect(1, 1614, '\p{Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1614, '\p{^Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1614, '\P{Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1614, '\P{^Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1615, '\p{Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1615, '\p{^Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1615, '\P{Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1615, '\P{^Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1614, '\p{Canonical_Combining_Class=	-CCC30}', "");
    Expect(0, 1614, '\p{^Canonical_Combining_Class=	-CCC30}', "");
    Expect(0, 1614, '\P{Canonical_Combining_Class=	-CCC30}', "");
    Expect(1, 1614, '\P{^Canonical_Combining_Class=	-CCC30}', "");
    Expect(0, 1615, '\p{Canonical_Combining_Class=	-CCC30}', "");
    Expect(1, 1615, '\p{^Canonical_Combining_Class=	-CCC30}', "");
    Expect(1, 1615, '\P{Canonical_Combining_Class=	-CCC30}', "");
    Expect(0, 1615, '\P{^Canonical_Combining_Class=	-CCC30}', "");
    Error('\p{Ccc=-	0000000030:=}');
    Error('\P{Ccc=-	0000000030:=}');
    Expect(1, 1614, '\p{Ccc=+0_0_0_0_0_00030}', "");
    Expect(0, 1614, '\p{^Ccc=+0_0_0_0_0_00030}', "");
    Expect(0, 1614, '\P{Ccc=+0_0_0_0_0_00030}', "");
    Expect(1, 1614, '\P{^Ccc=+0_0_0_0_0_00030}', "");
    Expect(0, 1615, '\p{Ccc=+0_0_0_0_0_00030}', "");
    Expect(1, 1615, '\p{^Ccc=+0_0_0_0_0_00030}', "");
    Expect(1, 1615, '\P{Ccc=+0_0_0_0_0_00030}', "");
    Expect(0, 1615, '\P{^Ccc=+0_0_0_0_0_00030}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/ 	CCC30}');
    Error('\P{Is_Canonical_Combining_Class=/a/ 	CCC30}');
    Expect(1, 1614, '\p{Is_Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1614, '\p{^Is_Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1614, '\P{Is_Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1614, '\P{^Is_Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1615, '\p{Is_Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1615, '\p{^Is_Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1615, '\P{Is_Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1615, '\P{^Is_Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1614, '\p{Is_Canonical_Combining_Class=_ CCC30}', "");
    Expect(0, 1614, '\p{^Is_Canonical_Combining_Class=_ CCC30}', "");
    Expect(0, 1614, '\P{Is_Canonical_Combining_Class=_ CCC30}', "");
    Expect(1, 1614, '\P{^Is_Canonical_Combining_Class=_ CCC30}', "");
    Expect(0, 1615, '\p{Is_Canonical_Combining_Class=_ CCC30}', "");
    Expect(1, 1615, '\p{^Is_Canonical_Combining_Class=_ CCC30}', "");
    Expect(1, 1615, '\P{Is_Canonical_Combining_Class=_ CCC30}', "");
    Expect(0, 1615, '\P{^Is_Canonical_Combining_Class=_ CCC30}', "");
    Error('\p{Is_Ccc=:=	_0000000030}');
    Error('\P{Is_Ccc=:=	_0000000030}');
    Expect(1, 1614, '\p{Is_Ccc:+0_0_0_0_0_0_0_30}', "");
    Expect(0, 1614, '\p{^Is_Ccc:+0_0_0_0_0_0_0_30}', "");
    Expect(0, 1614, '\P{Is_Ccc:+0_0_0_0_0_0_0_30}', "");
    Expect(1, 1614, '\P{^Is_Ccc:+0_0_0_0_0_0_0_30}', "");
    Expect(0, 1615, '\p{Is_Ccc:+0_0_0_0_0_0_0_30}', "");
    Expect(1, 1615, '\p{^Is_Ccc:+0_0_0_0_0_0_0_30}', "");
    Expect(1, 1615, '\P{Is_Ccc:+0_0_0_0_0_0_0_30}', "");
    Expect(0, 1615, '\P{^Is_Ccc:+0_0_0_0_0_0_0_30}', "");
    Error('\p{Canonical_Combining_Class=--CCC31/a/}');
    Error('\P{Canonical_Combining_Class=--CCC31/a/}');
    Expect(1, 1615, '\p{Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1615, '\p{^Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1615, '\P{Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1615, '\P{^Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1616, '\p{Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1616, '\p{^Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1616, '\P{Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1616, '\P{^Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1615, '\p{Canonical_Combining_Class=_ccc31}', "");
    Expect(0, 1615, '\p{^Canonical_Combining_Class=_ccc31}', "");
    Expect(0, 1615, '\P{Canonical_Combining_Class=_ccc31}', "");
    Expect(1, 1615, '\P{^Canonical_Combining_Class=_ccc31}', "");
    Expect(0, 1616, '\p{Canonical_Combining_Class=_ccc31}', "");
    Expect(1, 1616, '\p{^Canonical_Combining_Class=_ccc31}', "");
    Expect(1, 1616, '\P{Canonical_Combining_Class=_ccc31}', "");
    Expect(0, 1616, '\P{^Canonical_Combining_Class=_ccc31}', "");
    Error('\p{Ccc=-:=00_00_03_1}');
    Error('\P{Ccc=-:=00_00_03_1}');
    Expect(1, 1615, '\p{Ccc=+0000000031}', "");
    Expect(0, 1615, '\p{^Ccc=+0000000031}', "");
    Expect(0, 1615, '\P{Ccc=+0000000031}', "");
    Expect(1, 1615, '\P{^Ccc=+0000000031}', "");
    Expect(0, 1616, '\p{Ccc=+0000000031}', "");
    Expect(1, 1616, '\p{^Ccc=+0000000031}', "");
    Expect(1, 1616, '\P{Ccc=+0000000031}', "");
    Expect(0, 1616, '\P{^Ccc=+0000000031}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/-_CCC31}');
    Error('\P{Is_Canonical_Combining_Class=/a/-_CCC31}');
    Expect(1, 1615, '\p{Is_Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1615, '\p{^Is_Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1615, '\P{Is_Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1615, '\P{^Is_Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1616, '\p{Is_Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1616, '\p{^Is_Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1616, '\P{Is_Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1616, '\P{^Is_Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1615, '\p{Is_Canonical_Combining_Class= CCC31}', "");
    Expect(0, 1615, '\p{^Is_Canonical_Combining_Class= CCC31}', "");
    Expect(0, 1615, '\P{Is_Canonical_Combining_Class= CCC31}', "");
    Expect(1, 1615, '\P{^Is_Canonical_Combining_Class= CCC31}', "");
    Expect(0, 1616, '\p{Is_Canonical_Combining_Class= CCC31}', "");
    Expect(1, 1616, '\p{^Is_Canonical_Combining_Class= CCC31}', "");
    Expect(1, 1616, '\P{Is_Canonical_Combining_Class= CCC31}', "");
    Expect(0, 1616, '\P{^Is_Canonical_Combining_Class= CCC31}', "");
    Error('\p{Is_Ccc=	:=+3_1}');
    Error('\P{Is_Ccc=	:=+3_1}');
    Expect(1, 1615, '\p{Is_Ccc=0031}', "");
    Expect(0, 1615, '\p{^Is_Ccc=0031}', "");
    Expect(0, 1615, '\P{Is_Ccc=0031}', "");
    Expect(1, 1615, '\P{^Is_Ccc=0031}', "");
    Expect(0, 1616, '\p{Is_Ccc=0031}', "");
    Expect(1, 1616, '\p{^Is_Ccc=0031}', "");
    Expect(1, 1616, '\P{Is_Ccc=0031}', "");
    Expect(0, 1616, '\P{^Is_Ccc=0031}', "");
    Error('\p{Canonical_Combining_Class=	_CCC32:=}');
    Error('\P{Canonical_Combining_Class=	_CCC32:=}');
    Expect(1, 1616, '\p{Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1616, '\p{^Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1616, '\P{Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1616, '\P{^Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1617, '\p{Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1617, '\p{^Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1617, '\P{Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1617, '\P{^Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1616, '\p{Canonical_Combining_Class=--CCC32}', "");
    Expect(0, 1616, '\p{^Canonical_Combining_Class=--CCC32}', "");
    Expect(0, 1616, '\P{Canonical_Combining_Class=--CCC32}', "");
    Expect(1, 1616, '\P{^Canonical_Combining_Class=--CCC32}', "");
    Expect(0, 1617, '\p{Canonical_Combining_Class=--CCC32}', "");
    Expect(1, 1617, '\p{^Canonical_Combining_Class=--CCC32}', "");
    Expect(1, 1617, '\P{Canonical_Combining_Class=--CCC32}', "");
    Expect(0, 1617, '\P{^Canonical_Combining_Class=--CCC32}', "");
    Error('\p{Ccc= /a/032}');
    Error('\P{Ccc= /a/032}');
    Expect(1, 1616, '\p{Ccc=+0_0_32}', "");
    Expect(0, 1616, '\p{^Ccc=+0_0_32}', "");
    Expect(0, 1616, '\P{Ccc=+0_0_32}', "");
    Expect(1, 1616, '\P{^Ccc=+0_0_32}', "");
    Expect(0, 1617, '\p{Ccc=+0_0_32}', "");
    Expect(1, 1617, '\p{^Ccc=+0_0_32}', "");
    Expect(1, 1617, '\P{Ccc=+0_0_32}', "");
    Expect(0, 1617, '\P{^Ccc=+0_0_32}', "");
    Error('\p{Is_Canonical_Combining_Class=-_CCC32:=}');
    Error('\P{Is_Canonical_Combining_Class=-_CCC32:=}');
    Expect(1, 1616, '\p{Is_Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1616, '\p{^Is_Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1616, '\P{Is_Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1616, '\P{^Is_Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1617, '\p{Is_Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1617, '\p{^Is_Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1617, '\P{Is_Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1617, '\P{^Is_Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1616, '\p{Is_Canonical_Combining_Class= -CCC32}', "");
    Expect(0, 1616, '\p{^Is_Canonical_Combining_Class= -CCC32}', "");
    Expect(0, 1616, '\P{Is_Canonical_Combining_Class= -CCC32}', "");
    Expect(1, 1616, '\P{^Is_Canonical_Combining_Class= -CCC32}', "");
    Expect(0, 1617, '\p{Is_Canonical_Combining_Class= -CCC32}', "");
    Expect(1, 1617, '\p{^Is_Canonical_Combining_Class= -CCC32}', "");
    Expect(1, 1617, '\P{Is_Canonical_Combining_Class= -CCC32}', "");
    Expect(0, 1617, '\P{^Is_Canonical_Combining_Class= -CCC32}', "");
    Error('\p{Is_Ccc=/a/_-+000032}');
    Error('\P{Is_Ccc=/a/_-+000032}');
    Expect(1, 1616, '\p{Is_Ccc=00_00_03_2}', "");
    Expect(0, 1616, '\p{^Is_Ccc=00_00_03_2}', "");
    Expect(0, 1616, '\P{Is_Ccc=00_00_03_2}', "");
    Expect(1, 1616, '\P{^Is_Ccc=00_00_03_2}', "");
    Expect(0, 1617, '\p{Is_Ccc=00_00_03_2}', "");
    Expect(1, 1617, '\p{^Is_Ccc=00_00_03_2}', "");
    Expect(1, 1617, '\P{Is_Ccc=00_00_03_2}', "");
    Expect(0, 1617, '\P{^Is_Ccc=00_00_03_2}', "");
    Error('\p{Canonical_Combining_Class=-:=CCC33}');
    Error('\P{Canonical_Combining_Class=-:=CCC33}');
    Expect(1, 1617, '\p{Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1617, '\p{^Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1617, '\P{Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1617, '\P{^Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1618, '\p{Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1618, '\p{^Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1618, '\P{Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1618, '\P{^Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1617, '\p{Canonical_Combining_Class=_-ccc33}', "");
    Expect(0, 1617, '\p{^Canonical_Combining_Class=_-ccc33}', "");
    Expect(0, 1617, '\P{Canonical_Combining_Class=_-ccc33}', "");
    Expect(1, 1617, '\P{^Canonical_Combining_Class=_-ccc33}', "");
    Expect(0, 1618, '\p{Canonical_Combining_Class=_-ccc33}', "");
    Expect(1, 1618, '\p{^Canonical_Combining_Class=_-ccc33}', "");
    Expect(1, 1618, '\P{Canonical_Combining_Class=_-ccc33}', "");
    Expect(0, 1618, '\P{^Canonical_Combining_Class=_-ccc33}', "");
    Error('\p{Ccc=/a/- +00000033}');
    Error('\P{Ccc=/a/- +00000033}');
    Expect(1, 1617, '\p{Ccc=00_03_3}', "");
    Expect(0, 1617, '\p{^Ccc=00_03_3}', "");
    Expect(0, 1617, '\P{Ccc=00_03_3}', "");
    Expect(1, 1617, '\P{^Ccc=00_03_3}', "");
    Expect(0, 1618, '\p{Ccc=00_03_3}', "");
    Expect(1, 1618, '\p{^Ccc=00_03_3}', "");
    Expect(1, 1618, '\P{Ccc=00_03_3}', "");
    Expect(0, 1618, '\P{^Ccc=00_03_3}', "");
    Error('\p{Is_Canonical_Combining_Class=:=_CCC33}');
    Error('\P{Is_Canonical_Combining_Class=:=_CCC33}');
    Expect(1, 1617, '\p{Is_Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1617, '\p{^Is_Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1617, '\P{Is_Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1617, '\P{^Is_Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1618, '\p{Is_Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1618, '\p{^Is_Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1618, '\P{Is_Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1618, '\P{^Is_Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1617, '\p{Is_Canonical_Combining_Class= CCC33}', "");
    Expect(0, 1617, '\p{^Is_Canonical_Combining_Class= CCC33}', "");
    Expect(0, 1617, '\P{Is_Canonical_Combining_Class= CCC33}', "");
    Expect(1, 1617, '\P{^Is_Canonical_Combining_Class= CCC33}', "");
    Expect(0, 1618, '\p{Is_Canonical_Combining_Class= CCC33}', "");
    Expect(1, 1618, '\p{^Is_Canonical_Combining_Class= CCC33}', "");
    Expect(1, 1618, '\P{Is_Canonical_Combining_Class= CCC33}', "");
    Expect(0, 1618, '\P{^Is_Canonical_Combining_Class= CCC33}', "");
    Error('\p{Is_Ccc=0_0_0_0_033:=}');
    Error('\P{Is_Ccc=0_0_0_0_033:=}');
    Expect(1, 1617, '\p{Is_Ccc:+0000000003_3}', "");
    Expect(0, 1617, '\p{^Is_Ccc:+0000000003_3}', "");
    Expect(0, 1617, '\P{Is_Ccc:+0000000003_3}', "");
    Expect(1, 1617, '\P{^Is_Ccc:+0000000003_3}', "");
    Expect(0, 1618, '\p{Is_Ccc:+0000000003_3}', "");
    Expect(1, 1618, '\p{^Is_Ccc:+0000000003_3}', "");
    Expect(1, 1618, '\P{Is_Ccc:+0000000003_3}', "");
    Expect(0, 1618, '\P{^Is_Ccc:+0000000003_3}', "");
    Error('\p{Canonical_Combining_Class: :=ccc34}');
    Error('\P{Canonical_Combining_Class: :=ccc34}');
    Expect(1, 1618, '\p{Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1618, '\p{^Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1618, '\P{Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1618, '\P{^Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1619, '\p{Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1619, '\p{^Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1619, '\P{Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1619, '\P{^Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1618, '\p{Canonical_Combining_Class=CCC34}', "");
    Expect(0, 1618, '\p{^Canonical_Combining_Class=CCC34}', "");
    Expect(0, 1618, '\P{Canonical_Combining_Class=CCC34}', "");
    Expect(1, 1618, '\P{^Canonical_Combining_Class=CCC34}', "");
    Expect(0, 1619, '\p{Canonical_Combining_Class=CCC34}', "");
    Expect(1, 1619, '\p{^Canonical_Combining_Class=CCC34}', "");
    Expect(1, 1619, '\P{Canonical_Combining_Class=CCC34}', "");
    Expect(0, 1619, '\P{^Canonical_Combining_Class=CCC34}', "");
    Error('\p{Ccc=:=-+00003_4}');
    Error('\P{Ccc=:=-+00003_4}');
    Expect(1, 1618, '\p{Ccc=3_4}', "");
    Expect(0, 1618, '\p{^Ccc=3_4}', "");
    Expect(0, 1618, '\P{Ccc=3_4}', "");
    Expect(1, 1618, '\P{^Ccc=3_4}', "");
    Expect(0, 1619, '\p{Ccc=3_4}', "");
    Expect(1, 1619, '\p{^Ccc=3_4}', "");
    Expect(1, 1619, '\P{Ccc=3_4}', "");
    Expect(0, 1619, '\P{^Ccc=3_4}', "");
    Error('\p{Is_Canonical_Combining_Class=:=__CCC34}');
    Error('\P{Is_Canonical_Combining_Class=:=__CCC34}');
    Expect(1, 1618, '\p{Is_Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1618, '\p{^Is_Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1618, '\P{Is_Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1618, '\P{^Is_Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1619, '\p{Is_Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1619, '\p{^Is_Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1619, '\P{Is_Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1619, '\P{^Is_Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1618, '\p{Is_Canonical_Combining_Class=-_CCC34}', "");
    Expect(0, 1618, '\p{^Is_Canonical_Combining_Class=-_CCC34}', "");
    Expect(0, 1618, '\P{Is_Canonical_Combining_Class=-_CCC34}', "");
    Expect(1, 1618, '\P{^Is_Canonical_Combining_Class=-_CCC34}', "");
    Expect(0, 1619, '\p{Is_Canonical_Combining_Class=-_CCC34}', "");
    Expect(1, 1619, '\p{^Is_Canonical_Combining_Class=-_CCC34}', "");
    Expect(1, 1619, '\P{Is_Canonical_Combining_Class=-_CCC34}', "");
    Expect(0, 1619, '\P{^Is_Canonical_Combining_Class=-_CCC34}', "");
    Error('\p{Is_Ccc:	_ 00034:=}');
    Error('\P{Is_Ccc:	_ 00034:=}');
    Expect(1, 1618, '\p{Is_Ccc=0000000034}', "");
    Expect(0, 1618, '\p{^Is_Ccc=0000000034}', "");
    Expect(0, 1618, '\P{Is_Ccc=0000000034}', "");
    Expect(1, 1618, '\P{^Is_Ccc=0000000034}', "");
    Expect(0, 1619, '\p{Is_Ccc=0000000034}', "");
    Expect(1, 1619, '\p{^Is_Ccc=0000000034}', "");
    Expect(1, 1619, '\P{Is_Ccc=0000000034}', "");
    Expect(0, 1619, '\P{^Is_Ccc=0000000034}', "");
    Error('\p{Canonical_Combining_Class=_:=CCC35}');
    Error('\P{Canonical_Combining_Class=_:=CCC35}');
    Expect(1, 1648, '\p{Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1648, '\p{^Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1648, '\P{Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1648, '\P{^Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1649, '\p{Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1649, '\p{^Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1649, '\P{Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1649, '\P{^Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1648, '\p{Canonical_Combining_Class= CCC35}', "");
    Expect(0, 1648, '\p{^Canonical_Combining_Class= CCC35}', "");
    Expect(0, 1648, '\P{Canonical_Combining_Class= CCC35}', "");
    Expect(1, 1648, '\P{^Canonical_Combining_Class= CCC35}', "");
    Expect(0, 1649, '\p{Canonical_Combining_Class= CCC35}', "");
    Expect(1, 1649, '\p{^Canonical_Combining_Class= CCC35}', "");
    Expect(1, 1649, '\P{Canonical_Combining_Class= CCC35}', "");
    Expect(0, 1649, '\P{^Canonical_Combining_Class= CCC35}', "");
    Error('\p{Ccc:   /a/+0_0_0_0_35}');
    Error('\P{Ccc:   /a/+0_0_0_0_35}');
    Expect(1, 1648, '\p{Ccc=0_0_0_0_035}', "");
    Expect(0, 1648, '\p{^Ccc=0_0_0_0_035}', "");
    Expect(0, 1648, '\P{Ccc=0_0_0_0_035}', "");
    Expect(1, 1648, '\P{^Ccc=0_0_0_0_035}', "");
    Expect(0, 1649, '\p{Ccc=0_0_0_0_035}', "");
    Expect(1, 1649, '\p{^Ccc=0_0_0_0_035}', "");
    Expect(1, 1649, '\P{Ccc=0_0_0_0_035}', "");
    Expect(0, 1649, '\P{^Ccc=0_0_0_0_035}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/	ccc35}');
    Error('\P{Is_Canonical_Combining_Class=/a/	ccc35}');
    Expect(1, 1648, '\p{Is_Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1648, '\p{^Is_Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1648, '\P{Is_Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1648, '\P{^Is_Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1649, '\p{Is_Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1649, '\p{^Is_Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1649, '\P{Is_Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1649, '\P{^Is_Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1648, '\p{Is_Canonical_Combining_Class= CCC35}', "");
    Expect(0, 1648, '\p{^Is_Canonical_Combining_Class= CCC35}', "");
    Expect(0, 1648, '\P{Is_Canonical_Combining_Class= CCC35}', "");
    Expect(1, 1648, '\P{^Is_Canonical_Combining_Class= CCC35}', "");
    Expect(0, 1649, '\p{Is_Canonical_Combining_Class= CCC35}', "");
    Expect(1, 1649, '\p{^Is_Canonical_Combining_Class= CCC35}', "");
    Expect(1, 1649, '\P{Is_Canonical_Combining_Class= CCC35}', "");
    Expect(0, 1649, '\P{^Is_Canonical_Combining_Class= CCC35}', "");
    Error('\p{Is_Ccc=/a/000_000_003_5}');
    Error('\P{Is_Ccc=/a/000_000_003_5}');
    Expect(1, 1648, '\p{Is_Ccc=0000000035}', "");
    Expect(0, 1648, '\p{^Is_Ccc=0000000035}', "");
    Expect(0, 1648, '\P{Is_Ccc=0000000035}', "");
    Expect(1, 1648, '\P{^Is_Ccc=0000000035}', "");
    Expect(0, 1649, '\p{Is_Ccc=0000000035}', "");
    Expect(1, 1649, '\p{^Is_Ccc=0000000035}', "");
    Expect(1, 1649, '\P{Is_Ccc=0000000035}', "");
    Expect(0, 1649, '\P{^Is_Ccc=0000000035}', "");
    Error('\p{Canonical_Combining_Class:	:=	_CCC36}');
    Error('\P{Canonical_Combining_Class:	:=	_CCC36}');
    Expect(1, 1809, '\p{Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1809, '\p{^Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1809, '\P{Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1809, '\P{^Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1810, '\p{Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1810, '\p{^Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1810, '\P{Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1810, '\P{^Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1809, '\p{Canonical_Combining_Class= -ccc36}', "");
    Expect(0, 1809, '\p{^Canonical_Combining_Class= -ccc36}', "");
    Expect(0, 1809, '\P{Canonical_Combining_Class= -ccc36}', "");
    Expect(1, 1809, '\P{^Canonical_Combining_Class= -ccc36}', "");
    Expect(0, 1810, '\p{Canonical_Combining_Class= -ccc36}', "");
    Expect(1, 1810, '\p{^Canonical_Combining_Class= -ccc36}', "");
    Expect(1, 1810, '\P{Canonical_Combining_Class= -ccc36}', "");
    Expect(0, 1810, '\P{^Canonical_Combining_Class= -ccc36}', "");
    Error('\p{Ccc=/a/-	0_0_0_0_36}');
    Error('\P{Ccc=/a/-	0_0_0_0_36}');
    Expect(1, 1809, '\p{Ccc=+00_00_36}', "");
    Expect(0, 1809, '\p{^Ccc=+00_00_36}', "");
    Expect(0, 1809, '\P{Ccc=+00_00_36}', "");
    Expect(1, 1809, '\P{^Ccc=+00_00_36}', "");
    Expect(0, 1810, '\p{Ccc=+00_00_36}', "");
    Expect(1, 1810, '\p{^Ccc=+00_00_36}', "");
    Expect(1, 1810, '\P{Ccc=+00_00_36}', "");
    Expect(0, 1810, '\P{^Ccc=+00_00_36}', "");
    Error('\p{Is_Canonical_Combining_Class:     CCC36/a/}');
    Error('\P{Is_Canonical_Combining_Class:     CCC36/a/}');
    Expect(1, 1809, '\p{Is_Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1809, '\p{^Is_Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1809, '\P{Is_Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1809, '\P{^Is_Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1810, '\p{Is_Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1810, '\p{^Is_Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1810, '\P{Is_Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1810, '\P{^Is_Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1809, '\p{Is_Canonical_Combining_Class=	-ccc36}', "");
    Expect(0, 1809, '\p{^Is_Canonical_Combining_Class=	-ccc36}', "");
    Expect(0, 1809, '\P{Is_Canonical_Combining_Class=	-ccc36}', "");
    Expect(1, 1809, '\P{^Is_Canonical_Combining_Class=	-ccc36}', "");
    Expect(0, 1810, '\p{Is_Canonical_Combining_Class=	-ccc36}', "");
    Expect(1, 1810, '\p{^Is_Canonical_Combining_Class=	-ccc36}', "");
    Expect(1, 1810, '\P{Is_Canonical_Combining_Class=	-ccc36}', "");
    Expect(0, 1810, '\P{^Is_Canonical_Combining_Class=	-ccc36}', "");
    Error('\p{Is_Ccc=/a/ 00_00_03_6}');
    Error('\P{Is_Ccc=/a/ 00_00_03_6}');
    Expect(1, 1809, '\p{Is_Ccc=0_0_0_36}', "");
    Expect(0, 1809, '\p{^Is_Ccc=0_0_0_36}', "");
    Expect(0, 1809, '\P{Is_Ccc=0_0_0_36}', "");
    Expect(1, 1809, '\P{^Is_Ccc=0_0_0_36}', "");
    Expect(0, 1810, '\p{Is_Ccc=0_0_0_36}', "");
    Expect(1, 1810, '\p{^Is_Ccc=0_0_0_36}', "");
    Expect(1, 1810, '\P{Is_Ccc=0_0_0_36}', "");
    Expect(0, 1810, '\P{^Is_Ccc=0_0_0_36}', "");
    Error('\p{Canonical_Combining_Class=/a/  CCC84}');
    Error('\P{Canonical_Combining_Class=/a/  CCC84}');
    Expect(1, 3157, '\p{Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3157, '\p{^Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3157, '\P{Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3157, '\P{^Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3158, '\p{Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3158, '\p{^Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3158, '\P{Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3158, '\P{^Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3157, '\p{Canonical_Combining_Class=-ccc84}', "");
    Expect(0, 3157, '\p{^Canonical_Combining_Class=-ccc84}', "");
    Expect(0, 3157, '\P{Canonical_Combining_Class=-ccc84}', "");
    Expect(1, 3157, '\P{^Canonical_Combining_Class=-ccc84}', "");
    Expect(0, 3158, '\p{Canonical_Combining_Class=-ccc84}', "");
    Expect(1, 3158, '\p{^Canonical_Combining_Class=-ccc84}', "");
    Expect(1, 3158, '\P{Canonical_Combining_Class=-ccc84}', "");
    Expect(0, 3158, '\P{^Canonical_Combining_Class=-ccc84}', "");
    Error('\p{Ccc=:= 	8_4}');
    Error('\P{Ccc=:= 	8_4}');
    Expect(1, 3157, '\p{Ccc=084}', "");
    Expect(0, 3157, '\p{^Ccc=084}', "");
    Expect(0, 3157, '\P{Ccc=084}', "");
    Expect(1, 3157, '\P{^Ccc=084}', "");
    Expect(0, 3158, '\p{Ccc=084}', "");
    Expect(1, 3158, '\p{^Ccc=084}', "");
    Expect(1, 3158, '\P{Ccc=084}', "");
    Expect(0, 3158, '\P{^Ccc=084}', "");
    Error('\p{Is_Canonical_Combining_Class=_:=ccc84}');
    Error('\P{Is_Canonical_Combining_Class=_:=ccc84}');
    Expect(1, 3157, '\p{Is_Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3157, '\p{^Is_Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3157, '\P{Is_Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3157, '\P{^Is_Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3158, '\p{Is_Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3158, '\p{^Is_Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3158, '\P{Is_Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3158, '\P{^Is_Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3157, '\p{Is_Canonical_Combining_Class:   -CCC84}', "");
    Expect(0, 3157, '\p{^Is_Canonical_Combining_Class:   -CCC84}', "");
    Expect(0, 3157, '\P{Is_Canonical_Combining_Class:   -CCC84}', "");
    Expect(1, 3157, '\P{^Is_Canonical_Combining_Class:   -CCC84}', "");
    Expect(0, 3158, '\p{Is_Canonical_Combining_Class:   -CCC84}', "");
    Expect(1, 3158, '\p{^Is_Canonical_Combining_Class:   -CCC84}', "");
    Expect(1, 3158, '\P{Is_Canonical_Combining_Class:   -CCC84}', "");
    Expect(0, 3158, '\P{^Is_Canonical_Combining_Class:   -CCC84}', "");
    Error('\p{Is_Ccc=-_84/a/}');
    Error('\P{Is_Ccc=-_84/a/}');
    Expect(1, 3157, '\p{Is_Ccc=00084}', "");
    Expect(0, 3157, '\p{^Is_Ccc=00084}', "");
    Expect(0, 3157, '\P{Is_Ccc=00084}', "");
    Expect(1, 3157, '\P{^Is_Ccc=00084}', "");
    Expect(0, 3158, '\p{Is_Ccc=00084}', "");
    Expect(1, 3158, '\p{^Is_Ccc=00084}', "");
    Expect(1, 3158, '\P{Is_Ccc=00084}', "");
    Expect(0, 3158, '\P{^Is_Ccc=00084}', "");
    Error('\p{Canonical_Combining_Class=-CCC91/a/}');
    Error('\P{Canonical_Combining_Class=-CCC91/a/}');
    Expect(1, 3158, '\p{Canonical_Combining_Class=ccc91}', "");
    Expect(0, 3158, '\p{^Canonical_Combining_Class=ccc91}', "");
    Expect(0, 3158, '\P{Canonical_Combining_Class=ccc91}', "");
    Expect(1, 3158, '\P{^Canonical_Combining_Class=ccc91}', "");
    Expect(0, 3159, '\p{Canonical_Combining_Class=ccc91}', "");
    Expect(1, 3159, '\p{^Canonical_Combining_Class=ccc91}', "");
    Expect(1, 3159, '\P{Canonical_Combining_Class=ccc91}', "");
    Expect(0, 3159, '\P{^Canonical_Combining_Class=ccc91}', "");
    Expect(1, 3158, '\p{Canonical_Combining_Class=	CCC91}', "");
    Expect(0, 3158, '\p{^Canonical_Combining_Class=	CCC91}', "");
    Expect(0, 3158, '\P{Canonical_Combining_Class=	CCC91}', "");
    Expect(1, 3158, '\P{^Canonical_Combining_Class=	CCC91}', "");
    Expect(0, 3159, '\p{Canonical_Combining_Class=	CCC91}', "");
    Expect(1, 3159, '\p{^Canonical_Combining_Class=	CCC91}', "");
    Expect(1, 3159, '\P{Canonical_Combining_Class=	CCC91}', "");
    Expect(0, 3159, '\P{^Canonical_Combining_Class=	CCC91}', "");
    Error('\p{Ccc=:=_+0091}');
    Error('\P{Ccc=:=_+0091}');
    Expect(1, 3158, '\p{Ccc=+00009_1}', "");
    Expect(0, 3158, '\p{^Ccc=+00009_1}', "");
    Expect(0, 3158, '\P{Ccc=+00009_1}', "");
    Expect(1, 3158, '\P{^Ccc=+00009_1}', "");
    Expect(0, 3159, '\p{Ccc=+00009_1}', "");
    Expect(1, 3159, '\p{^Ccc=+00009_1}', "");
    Expect(1, 3159, '\P{Ccc=+00009_1}', "");
    Expect(0, 3159, '\P{^Ccc=+00009_1}', "");
    Error('\p{Is_Canonical_Combining_Class:   :=ccc91}');
    Error('\P{Is_Canonical_Combining_Class:   :=ccc91}');
    Expect(1, 3158, '\p{Is_Canonical_Combining_Class: ccc91}', "");
    Expect(0, 3158, '\p{^Is_Canonical_Combining_Class: ccc91}', "");
    Expect(0, 3158, '\P{Is_Canonical_Combining_Class: ccc91}', "");
    Expect(1, 3158, '\P{^Is_Canonical_Combining_Class: ccc91}', "");
    Expect(0, 3159, '\p{Is_Canonical_Combining_Class: ccc91}', "");
    Expect(1, 3159, '\p{^Is_Canonical_Combining_Class: ccc91}', "");
    Expect(1, 3159, '\P{Is_Canonical_Combining_Class: ccc91}', "");
    Expect(0, 3159, '\P{^Is_Canonical_Combining_Class: ccc91}', "");
    Expect(1, 3158, '\p{Is_Canonical_Combining_Class=_CCC91}', "");
    Expect(0, 3158, '\p{^Is_Canonical_Combining_Class=_CCC91}', "");
    Expect(0, 3158, '\P{Is_Canonical_Combining_Class=_CCC91}', "");
    Expect(1, 3158, '\P{^Is_Canonical_Combining_Class=_CCC91}', "");
    Expect(0, 3159, '\p{Is_Canonical_Combining_Class=_CCC91}', "");
    Expect(1, 3159, '\p{^Is_Canonical_Combining_Class=_CCC91}', "");
    Expect(1, 3159, '\P{Is_Canonical_Combining_Class=_CCC91}', "");
    Expect(0, 3159, '\P{^Is_Canonical_Combining_Class=_CCC91}', "");
    Error('\p{Is_Ccc=_-0000000091/a/}');
    Error('\P{Is_Ccc=_-0000000091/a/}');
    Expect(1, 3158, '\p{Is_Ccc=09_1}', "");
    Expect(0, 3158, '\p{^Is_Ccc=09_1}', "");
    Expect(0, 3158, '\P{Is_Ccc=09_1}', "");
    Expect(1, 3158, '\P{^Is_Ccc=09_1}', "");
    Expect(0, 3159, '\p{Is_Ccc=09_1}', "");
    Expect(1, 3159, '\p{^Is_Ccc=09_1}', "");
    Expect(1, 3159, '\P{Is_Ccc=09_1}', "");
    Expect(0, 3159, '\P{^Is_Ccc=09_1}', "");
    Error('\p{Canonical_Combining_Class=/a/- Double_Above}');
    Error('\P{Canonical_Combining_Class=/a/- Double_Above}');
    Expect(1, 7629, '\p{Canonical_Combining_Class=doubleabove}', "");
    Expect(0, 7629, '\p{^Canonical_Combining_Class=doubleabove}', "");
    Expect(0, 7629, '\P{Canonical_Combining_Class=doubleabove}', "");
    Expect(1, 7629, '\P{^Canonical_Combining_Class=doubleabove}', "");
    Expect(0, 7630, '\p{Canonical_Combining_Class=doubleabove}', "");
    Expect(1, 7630, '\p{^Canonical_Combining_Class=doubleabove}', "");
    Expect(1, 7630, '\P{Canonical_Combining_Class=doubleabove}', "");
    Expect(0, 7630, '\P{^Canonical_Combining_Class=doubleabove}', "");
    Expect(1, 7629, '\p{Canonical_Combining_Class:	_double_ABOVE}', "");
    Expect(0, 7629, '\p{^Canonical_Combining_Class:	_double_ABOVE}', "");
    Expect(0, 7629, '\P{Canonical_Combining_Class:	_double_ABOVE}', "");
    Expect(1, 7629, '\P{^Canonical_Combining_Class:	_double_ABOVE}', "");
    Expect(0, 7630, '\p{Canonical_Combining_Class:	_double_ABOVE}', "");
    Expect(1, 7630, '\p{^Canonical_Combining_Class:	_double_ABOVE}', "");
    Expect(1, 7630, '\P{Canonical_Combining_Class:	_double_ABOVE}', "");
    Expect(0, 7630, '\P{^Canonical_Combining_Class:	_double_ABOVE}', "");
    Error('\p{Ccc=	DA:=}');
    Error('\P{Ccc=	DA:=}');
    Expect(1, 7629, '\p{Ccc=da}', "");
    Expect(0, 7629, '\p{^Ccc=da}', "");
    Expect(0, 7629, '\P{Ccc=da}', "");
    Expect(1, 7629, '\P{^Ccc=da}', "");
    Expect(0, 7630, '\p{Ccc=da}', "");
    Expect(1, 7630, '\p{^Ccc=da}', "");
    Expect(1, 7630, '\P{Ccc=da}', "");
    Expect(0, 7630, '\P{^Ccc=da}', "");
    Expect(1, 7629, '\p{Ccc= 	DA}', "");
    Expect(0, 7629, '\p{^Ccc= 	DA}', "");
    Expect(0, 7629, '\P{Ccc= 	DA}', "");
    Expect(1, 7629, '\P{^Ccc= 	DA}', "");
    Expect(0, 7630, '\p{Ccc= 	DA}', "");
    Expect(1, 7630, '\p{^Ccc= 	DA}', "");
    Expect(1, 7630, '\P{Ccc= 	DA}', "");
    Expect(0, 7630, '\P{^Ccc= 	DA}', "");
    Error('\p{Is_Canonical_Combining_Class=:= _00000000234}');
    Error('\P{Is_Canonical_Combining_Class=:= _00000000234}');
    Expect(1, 7629, '\p{Is_Canonical_Combining_Class=0_0_0_234}', "");
    Expect(0, 7629, '\p{^Is_Canonical_Combining_Class=0_0_0_234}', "");
    Expect(0, 7629, '\P{Is_Canonical_Combining_Class=0_0_0_234}', "");
    Expect(1, 7629, '\P{^Is_Canonical_Combining_Class=0_0_0_234}', "");
    Expect(0, 7630, '\p{Is_Canonical_Combining_Class=0_0_0_234}', "");
    Expect(1, 7630, '\p{^Is_Canonical_Combining_Class=0_0_0_234}', "");
    Expect(1, 7630, '\P{Is_Canonical_Combining_Class=0_0_0_234}', "");
    Expect(0, 7630, '\P{^Is_Canonical_Combining_Class=0_0_0_234}', "");
    Error('\p{Is_Ccc=:=--Double_ABOVE}');
    Error('\P{Is_Ccc=:=--Double_ABOVE}');
    Expect(1, 7629, '\p{Is_Ccc=doubleabove}', "");
    Expect(0, 7629, '\p{^Is_Ccc=doubleabove}', "");
    Expect(0, 7629, '\P{Is_Ccc=doubleabove}', "");
    Expect(1, 7629, '\P{^Is_Ccc=doubleabove}', "");
    Expect(0, 7630, '\p{Is_Ccc=doubleabove}', "");
    Expect(1, 7630, '\p{^Is_Ccc=doubleabove}', "");
    Expect(1, 7630, '\P{Is_Ccc=doubleabove}', "");
    Expect(0, 7630, '\P{^Is_Ccc=doubleabove}', "");
    Expect(1, 7629, '\p{Is_Ccc=	 DOUBLE_Above}', "");
    Expect(0, 7629, '\p{^Is_Ccc=	 DOUBLE_Above}', "");
    Expect(0, 7629, '\P{Is_Ccc=	 DOUBLE_Above}', "");
    Expect(1, 7629, '\P{^Is_Ccc=	 DOUBLE_Above}', "");
    Expect(0, 7630, '\p{Is_Ccc=	 DOUBLE_Above}', "");
    Expect(1, 7630, '\p{^Is_Ccc=	 DOUBLE_Above}', "");
    Expect(1, 7630, '\P{Is_Ccc=	 DOUBLE_Above}', "");
    Expect(0, 7630, '\P{^Is_Ccc=	 DOUBLE_Above}', "");
    Error('\p{Canonical_Combining_Class=-:=DOUBLE_below}');
    Error('\P{Canonical_Combining_Class=-:=DOUBLE_below}');
    Expect(1, 7676, '\p{Canonical_Combining_Class=doublebelow}', "");
    Expect(0, 7676, '\p{^Canonical_Combining_Class=doublebelow}', "");
    Expect(0, 7676, '\P{Canonical_Combining_Class=doublebelow}', "");
    Expect(1, 7676, '\P{^Canonical_Combining_Class=doublebelow}', "");
    Expect(0, 7677, '\p{Canonical_Combining_Class=doublebelow}', "");
    Expect(1, 7677, '\p{^Canonical_Combining_Class=doublebelow}', "");
    Expect(1, 7677, '\P{Canonical_Combining_Class=doublebelow}', "");
    Expect(0, 7677, '\P{^Canonical_Combining_Class=doublebelow}', "");
    Expect(1, 7676, '\p{Canonical_Combining_Class=		Double_BELOW}', "");
    Expect(0, 7676, '\p{^Canonical_Combining_Class=		Double_BELOW}', "");
    Expect(0, 7676, '\P{Canonical_Combining_Class=		Double_BELOW}', "");
    Expect(1, 7676, '\P{^Canonical_Combining_Class=		Double_BELOW}', "");
    Expect(0, 7677, '\p{Canonical_Combining_Class=		Double_BELOW}', "");
    Expect(1, 7677, '\p{^Canonical_Combining_Class=		Double_BELOW}', "");
    Expect(1, 7677, '\P{Canonical_Combining_Class=		Double_BELOW}', "");
    Expect(0, 7677, '\P{^Canonical_Combining_Class=		Double_BELOW}', "");
    Error('\p{Ccc:	-:=db}');
    Error('\P{Ccc:	-:=db}');
    Expect(1, 7676, '\p{Ccc=db}', "");
    Expect(0, 7676, '\p{^Ccc=db}', "");
    Expect(0, 7676, '\P{Ccc=db}', "");
    Expect(1, 7676, '\P{^Ccc=db}', "");
    Expect(0, 7677, '\p{Ccc=db}', "");
    Expect(1, 7677, '\p{^Ccc=db}', "");
    Expect(1, 7677, '\P{Ccc=db}', "");
    Expect(0, 7677, '\P{^Ccc=db}', "");
    Expect(1, 7676, '\p{Ccc=DB}', "");
    Expect(0, 7676, '\p{^Ccc=DB}', "");
    Expect(0, 7676, '\P{Ccc=DB}', "");
    Expect(1, 7676, '\P{^Ccc=DB}', "");
    Expect(0, 7677, '\p{Ccc=DB}', "");
    Expect(1, 7677, '\p{^Ccc=DB}', "");
    Expect(1, 7677, '\P{Ccc=DB}', "");
    Expect(0, 7677, '\P{^Ccc=DB}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/	-+233}');
    Error('\P{Is_Canonical_Combining_Class=/a/	-+233}');
    Expect(1, 7676, '\p{Is_Canonical_Combining_Class=23_3}', "");
    Expect(0, 7676, '\p{^Is_Canonical_Combining_Class=23_3}', "");
    Expect(0, 7676, '\P{Is_Canonical_Combining_Class=23_3}', "");
    Expect(1, 7676, '\P{^Is_Canonical_Combining_Class=23_3}', "");
    Expect(0, 7677, '\p{Is_Canonical_Combining_Class=23_3}', "");
    Expect(1, 7677, '\p{^Is_Canonical_Combining_Class=23_3}', "");
    Expect(1, 7677, '\P{Is_Canonical_Combining_Class=23_3}', "");
    Expect(0, 7677, '\P{^Is_Canonical_Combining_Class=23_3}', "");
    Error('\p{Is_Ccc=-Double_Below:=}');
    Error('\P{Is_Ccc=-Double_Below:=}');
    Expect(1, 7676, '\p{Is_Ccc=doublebelow}', "");
    Expect(0, 7676, '\p{^Is_Ccc=doublebelow}', "");
    Expect(0, 7676, '\P{Is_Ccc=doublebelow}', "");
    Expect(1, 7676, '\P{^Is_Ccc=doublebelow}', "");
    Expect(0, 7677, '\p{Is_Ccc=doublebelow}', "");
    Expect(1, 7677, '\p{^Is_Ccc=doublebelow}', "");
    Expect(1, 7677, '\P{Is_Ccc=doublebelow}', "");
    Expect(0, 7677, '\P{^Is_Ccc=doublebelow}', "");
    Expect(1, 7676, '\p{Is_Ccc= _Double_below}', "");
    Expect(0, 7676, '\p{^Is_Ccc= _Double_below}', "");
    Expect(0, 7676, '\P{Is_Ccc= _Double_below}', "");
    Expect(1, 7676, '\P{^Is_Ccc= _Double_below}', "");
    Expect(0, 7677, '\p{Is_Ccc= _Double_below}', "");
    Expect(1, 7677, '\p{^Is_Ccc= _Double_below}', "");
    Expect(1, 7677, '\P{Is_Ccc= _Double_below}', "");
    Expect(0, 7677, '\P{^Is_Ccc= _Double_below}', "");
    Error('\p{Canonical_Combining_Class:	:=	_Iota_SUBSCRIPT}');
    Error('\P{Canonical_Combining_Class:	:=	_Iota_SUBSCRIPT}');
    Expect(1, 837, '\p{Canonical_Combining_Class=iotasubscript}', "");
    Expect(0, 837, '\p{^Canonical_Combining_Class=iotasubscript}', "");
    Expect(0, 837, '\P{Canonical_Combining_Class=iotasubscript}', "");
    Expect(1, 837, '\P{^Canonical_Combining_Class=iotasubscript}', "");
    Expect(0, 838, '\p{Canonical_Combining_Class=iotasubscript}', "");
    Expect(1, 838, '\p{^Canonical_Combining_Class=iotasubscript}', "");
    Expect(1, 838, '\P{Canonical_Combining_Class=iotasubscript}', "");
    Expect(0, 838, '\P{^Canonical_Combining_Class=iotasubscript}', "");
    Expect(1, 837, '\p{Canonical_Combining_Class: -_IOTA_subscript}', "");
    Expect(0, 837, '\p{^Canonical_Combining_Class: -_IOTA_subscript}', "");
    Expect(0, 837, '\P{Canonical_Combining_Class: -_IOTA_subscript}', "");
    Expect(1, 837, '\P{^Canonical_Combining_Class: -_IOTA_subscript}', "");
    Expect(0, 838, '\p{Canonical_Combining_Class: -_IOTA_subscript}', "");
    Expect(1, 838, '\p{^Canonical_Combining_Class: -_IOTA_subscript}', "");
    Expect(1, 838, '\P{Canonical_Combining_Class: -_IOTA_subscript}', "");
    Expect(0, 838, '\P{^Canonical_Combining_Class: -_IOTA_subscript}', "");
    Error('\p{Ccc: _:=IS}');
    Error('\P{Ccc: _:=IS}');
    Expect(1, 837, '\p{Ccc=is}', "");
    Expect(0, 837, '\p{^Ccc=is}', "");
    Expect(0, 837, '\P{Ccc=is}', "");
    Expect(1, 837, '\P{^Ccc=is}', "");
    Expect(0, 838, '\p{Ccc=is}', "");
    Expect(1, 838, '\p{^Ccc=is}', "");
    Expect(1, 838, '\P{Ccc=is}', "");
    Expect(0, 838, '\P{^Ccc=is}', "");
    Expect(1, 837, '\p{Ccc= IS}', "");
    Expect(0, 837, '\p{^Ccc= IS}', "");
    Expect(0, 837, '\P{Ccc= IS}', "");
    Expect(1, 837, '\P{^Ccc= IS}', "");
    Expect(0, 838, '\p{Ccc= IS}', "");
    Expect(1, 838, '\p{^Ccc= IS}', "");
    Expect(1, 838, '\P{Ccc= IS}', "");
    Expect(0, 838, '\P{^Ccc= IS}', "");
    Error('\p{Is_Canonical_Combining_Class=	_00024_0:=}');
    Error('\P{Is_Canonical_Combining_Class=	_00024_0:=}');
    Expect(1, 837, '\p{Is_Canonical_Combining_Class=00000240}', "");
    Expect(0, 837, '\p{^Is_Canonical_Combining_Class=00000240}', "");
    Expect(0, 837, '\P{Is_Canonical_Combining_Class=00000240}', "");
    Expect(1, 837, '\P{^Is_Canonical_Combining_Class=00000240}', "");
    Expect(0, 838, '\p{Is_Canonical_Combining_Class=00000240}', "");
    Expect(1, 838, '\p{^Is_Canonical_Combining_Class=00000240}', "");
    Expect(1, 838, '\P{Is_Canonical_Combining_Class=00000240}', "");
    Expect(0, 838, '\P{^Is_Canonical_Combining_Class=00000240}', "");
    Error('\p{Is_Ccc=-IOTA_subscript:=}');
    Error('\P{Is_Ccc=-IOTA_subscript:=}');
    Expect(1, 837, '\p{Is_Ccc=iotasubscript}', "");
    Expect(0, 837, '\p{^Is_Ccc=iotasubscript}', "");
    Expect(0, 837, '\P{Is_Ccc=iotasubscript}', "");
    Expect(1, 837, '\P{^Is_Ccc=iotasubscript}', "");
    Expect(0, 838, '\p{Is_Ccc=iotasubscript}', "");
    Expect(1, 838, '\p{^Is_Ccc=iotasubscript}', "");
    Expect(1, 838, '\P{Is_Ccc=iotasubscript}', "");
    Expect(0, 838, '\P{^Is_Ccc=iotasubscript}', "");
    Expect(1, 837, '\p{Is_Ccc= Iota_Subscript}', "");
    Expect(0, 837, '\p{^Is_Ccc= Iota_Subscript}', "");
    Expect(0, 837, '\P{Is_Ccc= Iota_Subscript}', "");
    Expect(1, 837, '\P{^Is_Ccc= Iota_Subscript}', "");
    Expect(0, 838, '\p{Is_Ccc= Iota_Subscript}', "");
    Expect(1, 838, '\p{^Is_Ccc= Iota_Subscript}', "");
    Expect(1, 838, '\P{Is_Ccc= Iota_Subscript}', "");
    Expect(0, 838, '\P{^Is_Ccc= Iota_Subscript}', "");
    Error('\p{Canonical_Combining_Class= /a/KANA_voicing}');
    Error('\P{Canonical_Combining_Class= /a/KANA_voicing}');
    Expect(1, 12442, '\p{Canonical_Combining_Class=kanavoicing}', "");
    Expect(0, 12442, '\p{^Canonical_Combining_Class=kanavoicing}', "");
    Expect(0, 12442, '\P{Canonical_Combining_Class=kanavoicing}', "");
    Expect(1, 12442, '\P{^Canonical_Combining_Class=kanavoicing}', "");
    Expect(0, 12443, '\p{Canonical_Combining_Class=kanavoicing}', "");
    Expect(1, 12443, '\p{^Canonical_Combining_Class=kanavoicing}', "");
    Expect(1, 12443, '\P{Canonical_Combining_Class=kanavoicing}', "");
    Expect(0, 12443, '\P{^Canonical_Combining_Class=kanavoicing}', "");
    Expect(1, 12442, '\p{Canonical_Combining_Class:Kana_VOICING}', "");
    Expect(0, 12442, '\p{^Canonical_Combining_Class:Kana_VOICING}', "");
    Expect(0, 12442, '\P{Canonical_Combining_Class:Kana_VOICING}', "");
    Expect(1, 12442, '\P{^Canonical_Combining_Class:Kana_VOICING}', "");
    Expect(0, 12443, '\p{Canonical_Combining_Class:Kana_VOICING}', "");
    Expect(1, 12443, '\p{^Canonical_Combining_Class:Kana_VOICING}', "");
    Expect(1, 12443, '\P{Canonical_Combining_Class:Kana_VOICING}', "");
    Expect(0, 12443, '\P{^Canonical_Combining_Class:Kana_VOICING}', "");
    Error('\p{Ccc=-:=KV}');
    Error('\P{Ccc=-:=KV}');
    Expect(1, 12442, '\p{Ccc:	kv}', "");
    Expect(0, 12442, '\p{^Ccc:	kv}', "");
    Expect(0, 12442, '\P{Ccc:	kv}', "");
    Expect(1, 12442, '\P{^Ccc:	kv}', "");
    Expect(0, 12443, '\p{Ccc:	kv}', "");
    Expect(1, 12443, '\p{^Ccc:	kv}', "");
    Expect(1, 12443, '\P{Ccc:	kv}', "");
    Expect(0, 12443, '\P{^Ccc:	kv}', "");
    Expect(1, 12442, '\p{Ccc:  	KV}', "");
    Expect(0, 12442, '\p{^Ccc:  	KV}', "");
    Expect(0, 12442, '\P{Ccc:  	KV}', "");
    Expect(1, 12442, '\P{^Ccc:  	KV}', "");
    Expect(0, 12443, '\p{Ccc:  	KV}', "");
    Expect(1, 12443, '\p{^Ccc:  	KV}', "");
    Expect(1, 12443, '\P{Ccc:  	KV}', "");
    Expect(0, 12443, '\P{^Ccc:  	KV}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/	_000000008}');
    Error('\P{Is_Canonical_Combining_Class=/a/	_000000008}');
    Expect(1, 12442, '\p{Is_Canonical_Combining_Class=0000008}', "");
    Expect(0, 12442, '\p{^Is_Canonical_Combining_Class=0000008}', "");
    Expect(0, 12442, '\P{Is_Canonical_Combining_Class=0000008}', "");
    Expect(1, 12442, '\P{^Is_Canonical_Combining_Class=0000008}', "");
    Expect(0, 12443, '\p{Is_Canonical_Combining_Class=0000008}', "");
    Expect(1, 12443, '\p{^Is_Canonical_Combining_Class=0000008}', "");
    Expect(1, 12443, '\P{Is_Canonical_Combining_Class=0000008}', "");
    Expect(0, 12443, '\P{^Is_Canonical_Combining_Class=0000008}', "");
    Error('\p{Is_Ccc= /a/kana_Voicing}');
    Error('\P{Is_Ccc= /a/kana_Voicing}');
    Expect(1, 12442, '\p{Is_Ccc=kanavoicing}', "");
    Expect(0, 12442, '\p{^Is_Ccc=kanavoicing}', "");
    Expect(0, 12442, '\P{Is_Ccc=kanavoicing}', "");
    Expect(1, 12442, '\P{^Is_Ccc=kanavoicing}', "");
    Expect(0, 12443, '\p{Is_Ccc=kanavoicing}', "");
    Expect(1, 12443, '\p{^Is_Ccc=kanavoicing}', "");
    Expect(1, 12443, '\P{Is_Ccc=kanavoicing}', "");
    Expect(0, 12443, '\P{^Is_Ccc=kanavoicing}', "");
    Expect(1, 12442, '\p{Is_Ccc:-_KANA_Voicing}', "");
    Expect(0, 12442, '\p{^Is_Ccc:-_KANA_Voicing}', "");
    Expect(0, 12442, '\P{Is_Ccc:-_KANA_Voicing}', "");
    Expect(1, 12442, '\P{^Is_Ccc:-_KANA_Voicing}', "");
    Expect(0, 12443, '\p{Is_Ccc:-_KANA_Voicing}', "");
    Expect(1, 12443, '\p{^Is_Ccc:-_KANA_Voicing}', "");
    Expect(1, 12443, '\P{Is_Ccc:-_KANA_Voicing}', "");
    Expect(0, 12443, '\P{^Is_Ccc:-_KANA_Voicing}', "");
    Error('\p{Canonical_Combining_Class=_/a/LEFT}');
    Error('\P{Canonical_Combining_Class=_/a/LEFT}');
    Expect(1, 12335, '\p{Canonical_Combining_Class=left}', "");
    Expect(0, 12335, '\p{^Canonical_Combining_Class=left}', "");
    Expect(0, 12335, '\P{Canonical_Combining_Class=left}', "");
    Expect(1, 12335, '\P{^Canonical_Combining_Class=left}', "");
    Expect(0, 12336, '\p{Canonical_Combining_Class=left}', "");
    Expect(1, 12336, '\p{^Canonical_Combining_Class=left}', "");
    Expect(1, 12336, '\P{Canonical_Combining_Class=left}', "");
    Expect(0, 12336, '\P{^Canonical_Combining_Class=left}', "");
    Expect(1, 12335, '\p{Canonical_Combining_Class=_LEFT}', "");
    Expect(0, 12335, '\p{^Canonical_Combining_Class=_LEFT}', "");
    Expect(0, 12335, '\P{Canonical_Combining_Class=_LEFT}', "");
    Expect(1, 12335, '\P{^Canonical_Combining_Class=_LEFT}', "");
    Expect(0, 12336, '\p{Canonical_Combining_Class=_LEFT}', "");
    Expect(1, 12336, '\p{^Canonical_Combining_Class=_LEFT}', "");
    Expect(1, 12336, '\P{Canonical_Combining_Class=_LEFT}', "");
    Expect(0, 12336, '\P{^Canonical_Combining_Class=_LEFT}', "");
    Error('\p{Ccc=-	L/a/}');
    Error('\P{Ccc=-	L/a/}');
    Expect(1, 12335, '\p{Ccc=l}', "");
    Expect(0, 12335, '\p{^Ccc=l}', "");
    Expect(0, 12335, '\P{Ccc=l}', "");
    Expect(1, 12335, '\P{^Ccc=l}', "");
    Expect(0, 12336, '\p{Ccc=l}', "");
    Expect(1, 12336, '\p{^Ccc=l}', "");
    Expect(1, 12336, '\P{Ccc=l}', "");
    Expect(0, 12336, '\P{^Ccc=l}', "");
    Expect(1, 12335, '\p{Ccc=	-L}', "");
    Expect(0, 12335, '\p{^Ccc=	-L}', "");
    Expect(0, 12335, '\P{Ccc=	-L}', "");
    Expect(1, 12335, '\P{^Ccc=	-L}', "");
    Expect(0, 12336, '\p{Ccc=	-L}', "");
    Expect(1, 12336, '\p{^Ccc=	-L}', "");
    Expect(1, 12336, '\P{Ccc=	-L}', "");
    Expect(0, 12336, '\P{^Ccc=	-L}', "");
    Error('\p{Is_Canonical_Combining_Class=:=22_4}');
    Error('\P{Is_Canonical_Combining_Class=:=22_4}');
    Expect(1, 12335, '\p{Is_Canonical_Combining_Class: +000000224}', "");
    Expect(0, 12335, '\p{^Is_Canonical_Combining_Class: +000000224}', "");
    Expect(0, 12335, '\P{Is_Canonical_Combining_Class: +000000224}', "");
    Expect(1, 12335, '\P{^Is_Canonical_Combining_Class: +000000224}', "");
    Expect(0, 12336, '\p{Is_Canonical_Combining_Class: +000000224}', "");
    Expect(1, 12336, '\p{^Is_Canonical_Combining_Class: +000000224}', "");
    Expect(1, 12336, '\P{Is_Canonical_Combining_Class: +000000224}', "");
    Expect(0, 12336, '\P{^Is_Canonical_Combining_Class: +000000224}', "");
    Error('\p{Is_Ccc=/a/_ LEFT}');
    Error('\P{Is_Ccc=/a/_ LEFT}');
    Expect(1, 12335, '\p{Is_Ccc:   left}', "");
    Expect(0, 12335, '\p{^Is_Ccc:   left}', "");
    Expect(0, 12335, '\P{Is_Ccc:   left}', "");
    Expect(1, 12335, '\P{^Is_Ccc:   left}', "");
    Expect(0, 12336, '\p{Is_Ccc:   left}', "");
    Expect(1, 12336, '\p{^Is_Ccc:   left}', "");
    Expect(1, 12336, '\P{Is_Ccc:   left}', "");
    Expect(0, 12336, '\P{^Is_Ccc:   left}', "");
    Expect(1, 12335, '\p{Is_Ccc=		left}', "");
    Expect(0, 12335, '\p{^Is_Ccc=		left}', "");
    Expect(0, 12335, '\P{Is_Ccc=		left}', "");
    Expect(1, 12335, '\P{^Is_Ccc=		left}', "");
    Expect(0, 12336, '\p{Is_Ccc=		left}', "");
    Expect(1, 12336, '\p{^Is_Ccc=		left}', "");
    Expect(1, 12336, '\P{Is_Ccc=		left}', "");
    Expect(0, 12336, '\P{^Is_Ccc=		left}', "");
    Error('\p{Canonical_Combining_Class=-:=nukta}');
    Error('\P{Canonical_Combining_Class=-:=nukta}');
    Expect(1, 125258, '\p{Canonical_Combining_Class=nukta}', "");
    Expect(0, 125258, '\p{^Canonical_Combining_Class=nukta}', "");
    Expect(0, 125258, '\P{Canonical_Combining_Class=nukta}', "");
    Expect(1, 125258, '\P{^Canonical_Combining_Class=nukta}', "");
    Expect(0, 125259, '\p{Canonical_Combining_Class=nukta}', "");
    Expect(1, 125259, '\p{^Canonical_Combining_Class=nukta}', "");
    Expect(1, 125259, '\P{Canonical_Combining_Class=nukta}', "");
    Expect(0, 125259, '\P{^Canonical_Combining_Class=nukta}', "");
    Expect(1, 125258, '\p{Canonical_Combining_Class=-	NUKTA}', "");
    Expect(0, 125258, '\p{^Canonical_Combining_Class=-	NUKTA}', "");
    Expect(0, 125258, '\P{Canonical_Combining_Class=-	NUKTA}', "");
    Expect(1, 125258, '\P{^Canonical_Combining_Class=-	NUKTA}', "");
    Expect(0, 125259, '\p{Canonical_Combining_Class=-	NUKTA}', "");
    Expect(1, 125259, '\p{^Canonical_Combining_Class=-	NUKTA}', "");
    Expect(1, 125259, '\P{Canonical_Combining_Class=-	NUKTA}', "");
    Expect(0, 125259, '\P{^Canonical_Combining_Class=-	NUKTA}', "");
    Error('\p{Ccc= -nk:=}');
    Error('\P{Ccc= -nk:=}');
    Expect(1, 125258, '\p{Ccc=nk}', "");
    Expect(0, 125258, '\p{^Ccc=nk}', "");
    Expect(0, 125258, '\P{Ccc=nk}', "");
    Expect(1, 125258, '\P{^Ccc=nk}', "");
    Expect(0, 125259, '\p{Ccc=nk}', "");
    Expect(1, 125259, '\p{^Ccc=nk}', "");
    Expect(1, 125259, '\P{Ccc=nk}', "");
    Expect(0, 125259, '\P{^Ccc=nk}', "");
    Expect(1, 125258, '\p{Ccc=  NK}', "");
    Expect(0, 125258, '\p{^Ccc=  NK}', "");
    Expect(0, 125258, '\P{Ccc=  NK}', "");
    Expect(1, 125258, '\P{^Ccc=  NK}', "");
    Expect(0, 125259, '\p{Ccc=  NK}', "");
    Expect(1, 125259, '\p{^Ccc=  NK}', "");
    Expect(1, 125259, '\P{Ccc=  NK}', "");
    Expect(0, 125259, '\P{^Ccc=  NK}', "");
    Error('\p{Is_Canonical_Combining_Class=	0007:=}');
    Error('\P{Is_Canonical_Combining_Class=	0007:=}');
    Expect(1, 125258, '\p{Is_Canonical_Combining_Class=+7}', "");
    Expect(0, 125258, '\p{^Is_Canonical_Combining_Class=+7}', "");
    Expect(0, 125258, '\P{Is_Canonical_Combining_Class=+7}', "");
    Expect(1, 125258, '\P{^Is_Canonical_Combining_Class=+7}', "");
    Expect(0, 125259, '\p{Is_Canonical_Combining_Class=+7}', "");
    Expect(1, 125259, '\p{^Is_Canonical_Combining_Class=+7}', "");
    Expect(1, 125259, '\P{Is_Canonical_Combining_Class=+7}', "");
    Expect(0, 125259, '\P{^Is_Canonical_Combining_Class=+7}', "");
    Error('\p{Is_Ccc=_:=nukta}');
    Error('\P{Is_Ccc=_:=nukta}');
    Expect(1, 125258, '\p{Is_Ccc=nukta}', "");
    Expect(0, 125258, '\p{^Is_Ccc=nukta}', "");
    Expect(0, 125258, '\P{Is_Ccc=nukta}', "");
    Expect(1, 125258, '\P{^Is_Ccc=nukta}', "");
    Expect(0, 125259, '\p{Is_Ccc=nukta}', "");
    Expect(1, 125259, '\p{^Is_Ccc=nukta}', "");
    Expect(1, 125259, '\P{Is_Ccc=nukta}', "");
    Expect(0, 125259, '\P{^Is_Ccc=nukta}', "");
    Expect(1, 125258, '\p{Is_Ccc=	_NUKTA}', "");
    Expect(0, 125258, '\p{^Is_Ccc=	_NUKTA}', "");
    Expect(0, 125258, '\P{Is_Ccc=	_NUKTA}', "");
    Expect(1, 125258, '\P{^Is_Ccc=	_NUKTA}', "");
    Expect(0, 125259, '\p{Is_Ccc=	_NUKTA}', "");
    Expect(1, 125259, '\p{^Is_Ccc=	_NUKTA}', "");
    Expect(1, 125259, '\P{Is_Ccc=	_NUKTA}', "");
    Expect(0, 125259, '\P{^Is_Ccc=	_NUKTA}', "");
    Error('\p{Canonical_Combining_Class=/a/Not_reordered}');
    Error('\P{Canonical_Combining_Class=/a/Not_reordered}');
    Expect(1, 125259, '\p{Canonical_Combining_Class=notreordered}', "");
    Expect(0, 125259, '\p{^Canonical_Combining_Class=notreordered}', "");
    Expect(0, 125259, '\P{Canonical_Combining_Class=notreordered}', "");
    Expect(1, 125259, '\P{^Canonical_Combining_Class=notreordered}', "");
    Expect(0, 125258, '\p{Canonical_Combining_Class=notreordered}', "");
    Expect(1, 125258, '\p{^Canonical_Combining_Class=notreordered}', "");
    Expect(1, 125258, '\P{Canonical_Combining_Class=notreordered}', "");
    Expect(0, 125258, '\P{^Canonical_Combining_Class=notreordered}', "");
    Expect(1, 125259, '\p{Canonical_Combining_Class=_-not_Reordered}', "");
    Expect(0, 125259, '\p{^Canonical_Combining_Class=_-not_Reordered}', "");
    Expect(0, 125259, '\P{Canonical_Combining_Class=_-not_Reordered}', "");
    Expect(1, 125259, '\P{^Canonical_Combining_Class=_-not_Reordered}', "");
    Expect(0, 125258, '\p{Canonical_Combining_Class=_-not_Reordered}', "");
    Expect(1, 125258, '\p{^Canonical_Combining_Class=_-not_Reordered}', "");
    Expect(1, 125258, '\P{Canonical_Combining_Class=_-not_Reordered}', "");
    Expect(0, 125258, '\P{^Canonical_Combining_Class=_-not_Reordered}', "");
    Error('\p{Ccc= :=NR}');
    Error('\P{Ccc= :=NR}');
    Expect(1, 125259, '\p{Ccc=nr}', "");
    Expect(0, 125259, '\p{^Ccc=nr}', "");
    Expect(0, 125259, '\P{Ccc=nr}', "");
    Expect(1, 125259, '\P{^Ccc=nr}', "");
    Expect(0, 125258, '\p{Ccc=nr}', "");
    Expect(1, 125258, '\p{^Ccc=nr}', "");
    Expect(1, 125258, '\P{Ccc=nr}', "");
    Expect(0, 125258, '\P{^Ccc=nr}', "");
    Expect(1, 125259, '\p{Ccc= NR}', "");
    Expect(0, 125259, '\p{^Ccc= NR}', "");
    Expect(0, 125259, '\P{Ccc= NR}', "");
    Expect(1, 125259, '\P{^Ccc= NR}', "");
    Expect(0, 125258, '\p{Ccc= NR}', "");
    Expect(1, 125258, '\p{^Ccc= NR}', "");
    Expect(1, 125258, '\P{Ccc= NR}', "");
    Expect(0, 125258, '\P{^Ccc= NR}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/-+0_0}');
    Error('\P{Is_Canonical_Combining_Class=/a/-+0_0}');
    Expect(1, 125259, '\p{Is_Canonical_Combining_Class=0000}', "");
    Expect(0, 125259, '\p{^Is_Canonical_Combining_Class=0000}', "");
    Expect(0, 125259, '\P{Is_Canonical_Combining_Class=0000}', "");
    Expect(1, 125259, '\P{^Is_Canonical_Combining_Class=0000}', "");
    Expect(0, 125258, '\p{Is_Canonical_Combining_Class=0000}', "");
    Expect(1, 125258, '\p{^Is_Canonical_Combining_Class=0000}', "");
    Expect(1, 125258, '\P{Is_Canonical_Combining_Class=0000}', "");
    Expect(0, 125258, '\P{^Is_Canonical_Combining_Class=0000}', "");
    Error('\p{Is_Ccc=:=	not_Reordered}');
    Error('\P{Is_Ccc=:=	not_Reordered}');
    Expect(1, 125259, '\p{Is_Ccc: notreordered}', "");
    Expect(0, 125259, '\p{^Is_Ccc: notreordered}', "");
    Expect(0, 125259, '\P{Is_Ccc: notreordered}', "");
    Expect(1, 125259, '\P{^Is_Ccc: notreordered}', "");
    Expect(0, 125258, '\p{Is_Ccc: notreordered}', "");
    Expect(1, 125258, '\p{^Is_Ccc: notreordered}', "");
    Expect(1, 125258, '\P{Is_Ccc: notreordered}', "");
    Expect(0, 125258, '\P{^Is_Ccc: notreordered}', "");
    Expect(1, 125259, '\p{Is_Ccc= -not_Reordered}', "");
    Expect(0, 125259, '\p{^Is_Ccc= -not_Reordered}', "");
    Expect(0, 125259, '\P{Is_Ccc= -not_Reordered}', "");
    Expect(1, 125259, '\P{^Is_Ccc= -not_Reordered}', "");
    Expect(0, 125258, '\p{Is_Ccc= -not_Reordered}', "");
    Expect(1, 125258, '\p{^Is_Ccc= -not_Reordered}', "");
    Expect(1, 125258, '\P{Is_Ccc= -not_Reordered}', "");
    Expect(0, 125258, '\P{^Is_Ccc= -not_Reordered}', "");
    Error('\p{Canonical_Combining_Class= Overlay/a/}');
    Error('\P{Canonical_Combining_Class= Overlay/a/}');
    Expect(1, 119145, '\p{Canonical_Combining_Class=overlay}', "");
    Expect(0, 119145, '\p{^Canonical_Combining_Class=overlay}', "");
    Expect(0, 119145, '\P{Canonical_Combining_Class=overlay}', "");
    Expect(1, 119145, '\P{^Canonical_Combining_Class=overlay}', "");
    Expect(0, 119146, '\p{Canonical_Combining_Class=overlay}', "");
    Expect(1, 119146, '\p{^Canonical_Combining_Class=overlay}', "");
    Expect(1, 119146, '\P{Canonical_Combining_Class=overlay}', "");
    Expect(0, 119146, '\P{^Canonical_Combining_Class=overlay}', "");
    Expect(1, 119145, '\p{Canonical_Combining_Class= -overlay}', "");
    Expect(0, 119145, '\p{^Canonical_Combining_Class= -overlay}', "");
    Expect(0, 119145, '\P{Canonical_Combining_Class= -overlay}', "");
    Expect(1, 119145, '\P{^Canonical_Combining_Class= -overlay}', "");
    Expect(0, 119146, '\p{Canonical_Combining_Class= -overlay}', "");
    Expect(1, 119146, '\p{^Canonical_Combining_Class= -overlay}', "");
    Expect(1, 119146, '\P{Canonical_Combining_Class= -overlay}', "");
    Expect(0, 119146, '\P{^Canonical_Combining_Class= -overlay}', "");
    Error('\p{Ccc=OV:=}');
    Error('\P{Ccc=OV:=}');
    Expect(1, 119145, '\p{Ccc:ov}', "");
    Expect(0, 119145, '\p{^Ccc:ov}', "");
    Expect(0, 119145, '\P{Ccc:ov}', "");
    Expect(1, 119145, '\P{^Ccc:ov}', "");
    Expect(0, 119146, '\p{Ccc:ov}', "");
    Expect(1, 119146, '\p{^Ccc:ov}', "");
    Expect(1, 119146, '\P{Ccc:ov}', "");
    Expect(0, 119146, '\P{^Ccc:ov}', "");
    Expect(1, 119145, '\p{Ccc=-ov}', "");
    Expect(0, 119145, '\p{^Ccc=-ov}', "");
    Expect(0, 119145, '\P{Ccc=-ov}', "");
    Expect(1, 119145, '\P{^Ccc=-ov}', "");
    Expect(0, 119146, '\p{Ccc=-ov}', "");
    Expect(1, 119146, '\p{^Ccc=-ov}', "");
    Expect(1, 119146, '\P{Ccc=-ov}', "");
    Expect(0, 119146, '\P{^Ccc=-ov}', "");
    Error('\p{Is_Canonical_Combining_Class= /a/00001}');
    Error('\P{Is_Canonical_Combining_Class= /a/00001}');
    Expect(1, 119145, '\p{Is_Canonical_Combining_Class=0001}', "");
    Expect(0, 119145, '\p{^Is_Canonical_Combining_Class=0001}', "");
    Expect(0, 119145, '\P{Is_Canonical_Combining_Class=0001}', "");
    Expect(1, 119145, '\P{^Is_Canonical_Combining_Class=0001}', "");
    Expect(0, 119146, '\p{Is_Canonical_Combining_Class=0001}', "");
    Expect(1, 119146, '\p{^Is_Canonical_Combining_Class=0001}', "");
    Expect(1, 119146, '\P{Is_Canonical_Combining_Class=0001}', "");
    Expect(0, 119146, '\P{^Is_Canonical_Combining_Class=0001}', "");
    Error('\p{Is_Ccc= Overlay/a/}');
    Error('\P{Is_Ccc= Overlay/a/}');
    Expect(1, 119145, '\p{Is_Ccc=overlay}', "");
    Expect(0, 119145, '\p{^Is_Ccc=overlay}', "");
    Expect(0, 119145, '\P{Is_Ccc=overlay}', "");
    Expect(1, 119145, '\P{^Is_Ccc=overlay}', "");
    Expect(0, 119146, '\p{Is_Ccc=overlay}', "");
    Expect(1, 119146, '\p{^Is_Ccc=overlay}', "");
    Expect(1, 119146, '\P{Is_Ccc=overlay}', "");
    Expect(0, 119146, '\P{^Is_Ccc=overlay}', "");
    Expect(1, 119145, '\p{Is_Ccc=	_Overlay}', "");
    Expect(0, 119145, '\p{^Is_Ccc=	_Overlay}', "");
    Expect(0, 119145, '\P{Is_Ccc=	_Overlay}', "");
    Expect(1, 119145, '\P{^Is_Ccc=	_Overlay}', "");
    Expect(0, 119146, '\p{Is_Ccc=	_Overlay}', "");
    Expect(1, 119146, '\p{^Is_Ccc=	_Overlay}', "");
    Expect(1, 119146, '\P{Is_Ccc=	_Overlay}', "");
    Expect(0, 119146, '\P{^Is_Ccc=	_Overlay}', "");
    Error('\p{Canonical_Combining_Class=	RIGHT:=}');
    Error('\P{Canonical_Combining_Class=	RIGHT:=}');
    Expect(1, 119149, '\p{Canonical_Combining_Class=right}', "");
    Expect(0, 119149, '\p{^Canonical_Combining_Class=right}', "");
    Expect(0, 119149, '\P{Canonical_Combining_Class=right}', "");
    Expect(1, 119149, '\P{^Canonical_Combining_Class=right}', "");
    Expect(0, 119150, '\p{Canonical_Combining_Class=right}', "");
    Expect(1, 119150, '\p{^Canonical_Combining_Class=right}', "");
    Expect(1, 119150, '\P{Canonical_Combining_Class=right}', "");
    Expect(0, 119150, '\P{^Canonical_Combining_Class=right}', "");
    Expect(1, 119149, '\p{Canonical_Combining_Class: 	RIGHT}', "");
    Expect(0, 119149, '\p{^Canonical_Combining_Class: 	RIGHT}', "");
    Expect(0, 119149, '\P{Canonical_Combining_Class: 	RIGHT}', "");
    Expect(1, 119149, '\P{^Canonical_Combining_Class: 	RIGHT}', "");
    Expect(0, 119150, '\p{Canonical_Combining_Class: 	RIGHT}', "");
    Expect(1, 119150, '\p{^Canonical_Combining_Class: 	RIGHT}', "");
    Expect(1, 119150, '\P{Canonical_Combining_Class: 	RIGHT}', "");
    Expect(0, 119150, '\P{^Canonical_Combining_Class: 	RIGHT}', "");
    Error('\p{Ccc=_/a/R}');
    Error('\P{Ccc=_/a/R}');
    Expect(1, 119149, '\p{Ccc=r}', "");
    Expect(0, 119149, '\p{^Ccc=r}', "");
    Expect(0, 119149, '\P{Ccc=r}', "");
    Expect(1, 119149, '\P{^Ccc=r}', "");
    Expect(0, 119150, '\p{Ccc=r}', "");
    Expect(1, 119150, '\p{^Ccc=r}', "");
    Expect(1, 119150, '\P{Ccc=r}', "");
    Expect(0, 119150, '\P{^Ccc=r}', "");
    Expect(1, 119149, '\p{Ccc=	R}', "");
    Expect(0, 119149, '\p{^Ccc=	R}', "");
    Expect(0, 119149, '\P{Ccc=	R}', "");
    Expect(1, 119149, '\P{^Ccc=	R}', "");
    Expect(0, 119150, '\p{Ccc=	R}', "");
    Expect(1, 119150, '\p{^Ccc=	R}', "");
    Expect(1, 119150, '\P{Ccc=	R}', "");
    Expect(0, 119150, '\P{^Ccc=	R}', "");
    Error('\p{Is_Canonical_Combining_Class=		00226:=}');
    Error('\P{Is_Canonical_Combining_Class=		00226:=}');
    Expect(1, 119149, '\p{Is_Canonical_Combining_Class=000000226}', "");
    Expect(0, 119149, '\p{^Is_Canonical_Combining_Class=000000226}', "");
    Expect(0, 119149, '\P{Is_Canonical_Combining_Class=000000226}', "");
    Expect(1, 119149, '\P{^Is_Canonical_Combining_Class=000000226}', "");
    Expect(0, 119150, '\p{Is_Canonical_Combining_Class=000000226}', "");
    Expect(1, 119150, '\p{^Is_Canonical_Combining_Class=000000226}', "");
    Expect(1, 119150, '\P{Is_Canonical_Combining_Class=000000226}', "");
    Expect(0, 119150, '\P{^Is_Canonical_Combining_Class=000000226}', "");
    Error('\p{Is_Ccc=_:=Right}');
    Error('\P{Is_Ccc=_:=Right}');
    Expect(1, 119149, '\p{Is_Ccc=right}', "");
    Expect(0, 119149, '\p{^Is_Ccc=right}', "");
    Expect(0, 119149, '\P{Is_Ccc=right}', "");
    Expect(1, 119149, '\P{^Is_Ccc=right}', "");
    Expect(0, 119150, '\p{Is_Ccc=right}', "");
    Expect(1, 119150, '\p{^Is_Ccc=right}', "");
    Expect(1, 119150, '\P{Is_Ccc=right}', "");
    Expect(0, 119150, '\P{^Is_Ccc=right}', "");
    Expect(1, 119149, '\p{Is_Ccc=__right}', "");
    Expect(0, 119149, '\p{^Is_Ccc=__right}', "");
    Expect(0, 119149, '\P{Is_Ccc=__right}', "");
    Expect(1, 119149, '\P{^Is_Ccc=__right}', "");
    Expect(0, 119150, '\p{Is_Ccc=__right}', "");
    Expect(1, 119150, '\p{^Is_Ccc=__right}', "");
    Expect(1, 119150, '\P{Is_Ccc=__right}', "");
    Expect(0, 119150, '\P{^Is_Ccc=__right}', "");
    Error('\p{Canonical_Combining_Class=	:=VIRAMA}');
    Error('\P{Canonical_Combining_Class=	:=VIRAMA}');
    Expect(1, 73029, '\p{Canonical_Combining_Class=virama}', "");
    Expect(0, 73029, '\p{^Canonical_Combining_Class=virama}', "");
    Expect(0, 73029, '\P{Canonical_Combining_Class=virama}', "");
    Expect(1, 73029, '\P{^Canonical_Combining_Class=virama}', "");
    Expect(0, 73030, '\p{Canonical_Combining_Class=virama}', "");
    Expect(1, 73030, '\p{^Canonical_Combining_Class=virama}', "");
    Expect(1, 73030, '\P{Canonical_Combining_Class=virama}', "");
    Expect(0, 73030, '\P{^Canonical_Combining_Class=virama}', "");
    Expect(1, 73029, '\p{Canonical_Combining_Class=-Virama}', "");
    Expect(0, 73029, '\p{^Canonical_Combining_Class=-Virama}', "");
    Expect(0, 73029, '\P{Canonical_Combining_Class=-Virama}', "");
    Expect(1, 73029, '\P{^Canonical_Combining_Class=-Virama}', "");
    Expect(0, 73030, '\p{Canonical_Combining_Class=-Virama}', "");
    Expect(1, 73030, '\p{^Canonical_Combining_Class=-Virama}', "");
    Expect(1, 73030, '\P{Canonical_Combining_Class=-Virama}', "");
    Expect(0, 73030, '\P{^Canonical_Combining_Class=-Virama}', "");
    Error('\p{Ccc=_ VR:=}');
    Error('\P{Ccc=_ VR:=}');
    Expect(1, 73029, '\p{Ccc:   vr}', "");
    Expect(0, 73029, '\p{^Ccc:   vr}', "");
    Expect(0, 73029, '\P{Ccc:   vr}', "");
    Expect(1, 73029, '\P{^Ccc:   vr}', "");
    Expect(0, 73030, '\p{Ccc:   vr}', "");
    Expect(1, 73030, '\p{^Ccc:   vr}', "");
    Expect(1, 73030, '\P{Ccc:   vr}', "");
    Expect(0, 73030, '\P{^Ccc:   vr}', "");
    Expect(1, 73029, '\p{Ccc=	 VR}', "");
    Expect(0, 73029, '\p{^Ccc=	 VR}', "");
    Expect(0, 73029, '\P{Ccc=	 VR}', "");
    Expect(1, 73029, '\P{^Ccc=	 VR}', "");
    Expect(0, 73030, '\p{Ccc=	 VR}', "");
    Expect(1, 73030, '\p{^Ccc=	 VR}', "");
    Expect(1, 73030, '\P{Ccc=	 VR}', "");
    Expect(0, 73030, '\P{^Ccc=	 VR}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/-	+0000000009}');
    Error('\P{Is_Canonical_Combining_Class=/a/-	+0000000009}');
    Expect(1, 73029, '\p{Is_Canonical_Combining_Class=9}', "");
    Expect(0, 73029, '\p{^Is_Canonical_Combining_Class=9}', "");
    Expect(0, 73029, '\P{Is_Canonical_Combining_Class=9}', "");
    Expect(1, 73029, '\P{^Is_Canonical_Combining_Class=9}', "");
    Expect(0, 73030, '\p{Is_Canonical_Combining_Class=9}', "");
    Expect(1, 73030, '\p{^Is_Canonical_Combining_Class=9}', "");
    Expect(1, 73030, '\P{Is_Canonical_Combining_Class=9}', "");
    Expect(0, 73030, '\P{^Is_Canonical_Combining_Class=9}', "");
    Error('\p{Is_Ccc:		 Virama:=}');
    Error('\P{Is_Ccc:		 Virama:=}');
    Expect(1, 73029, '\p{Is_Ccc=virama}', "");
    Expect(0, 73029, '\p{^Is_Ccc=virama}', "");
    Expect(0, 73029, '\P{Is_Ccc=virama}', "");
    Expect(1, 73029, '\P{^Is_Ccc=virama}', "");
    Expect(0, 73030, '\p{Is_Ccc=virama}', "");
    Expect(1, 73030, '\p{^Is_Ccc=virama}', "");
    Expect(1, 73030, '\P{Is_Ccc=virama}', "");
    Expect(0, 73030, '\P{^Is_Ccc=virama}', "");
    Expect(1, 73029, '\p{Is_Ccc= _Virama}', "");
    Expect(0, 73029, '\p{^Is_Ccc= _Virama}', "");
    Expect(0, 73029, '\P{Is_Ccc= _Virama}', "");
    Expect(1, 73029, '\P{^Is_Ccc= _Virama}', "");
    Expect(0, 73030, '\p{Is_Ccc= _Virama}', "");
    Expect(1, 73030, '\p{^Is_Ccc= _Virama}', "");
    Expect(1, 73030, '\P{Is_Ccc= _Virama}', "");
    Expect(0, 73030, '\P{^Is_Ccc= _Virama}', "");
    Error('\p{Composition_Exclusion= 	No:=}');
    Error('\P{Composition_Exclusion= 	No:=}');
    Expect(1, 119233, '\p{Composition_Exclusion=no}', "");
    Expect(0, 119233, '\p{^Composition_Exclusion=no}', "");
    Expect(0, 119233, '\P{Composition_Exclusion=no}', "");
    Expect(1, 119233, '\P{^Composition_Exclusion=no}', "");
    Expect(0, 119232, '\p{Composition_Exclusion=no}', "");
    Expect(1, 119232, '\p{^Composition_Exclusion=no}', "");
    Expect(1, 119232, '\P{Composition_Exclusion=no}', "");
    Expect(0, 119232, '\P{^Composition_Exclusion=no}', "");
    Expect(1, 119233, '\p{Composition_Exclusion= No}', "");
    Expect(0, 119233, '\p{^Composition_Exclusion= No}', "");
    Expect(0, 119233, '\P{Composition_Exclusion= No}', "");
    Expect(1, 119233, '\P{^Composition_Exclusion= No}', "");
    Expect(0, 119232, '\p{Composition_Exclusion= No}', "");
    Expect(1, 119232, '\p{^Composition_Exclusion= No}', "");
    Expect(1, 119232, '\P{Composition_Exclusion= No}', "");
    Expect(0, 119232, '\P{^Composition_Exclusion= No}', "");
    Error('\p{CE=/a/_N}');
    Error('\P{CE=/a/_N}');
    Expect(1, 119233, '\p{CE=n}', "");
    Expect(0, 119233, '\p{^CE=n}', "");
    Expect(0, 119233, '\P{CE=n}', "");
    Expect(1, 119233, '\P{^CE=n}', "");
    Expect(0, 119232, '\p{CE=n}', "");
    Expect(1, 119232, '\p{^CE=n}', "");
    Expect(1, 119232, '\P{CE=n}', "");
    Expect(0, 119232, '\P{^CE=n}', "");
    Expect(1, 119233, '\p{CE= 	n}', "");
    Expect(0, 119233, '\p{^CE= 	n}', "");
    Expect(0, 119233, '\P{CE= 	n}', "");
    Expect(1, 119233, '\P{^CE= 	n}', "");
    Expect(0, 119232, '\p{CE= 	n}', "");
    Expect(1, 119232, '\p{^CE= 	n}', "");
    Expect(1, 119232, '\P{CE= 	n}', "");
    Expect(0, 119232, '\P{^CE= 	n}', "");
    Error('\p{Is_Composition_Exclusion=/a/_F}');
    Error('\P{Is_Composition_Exclusion=/a/_F}');
    Expect(1, 119233, '\p{Is_Composition_Exclusion=f}', "");
    Expect(0, 119233, '\p{^Is_Composition_Exclusion=f}', "");
    Expect(0, 119233, '\P{Is_Composition_Exclusion=f}', "");
    Expect(1, 119233, '\P{^Is_Composition_Exclusion=f}', "");
    Expect(0, 119232, '\p{Is_Composition_Exclusion=f}', "");
    Expect(1, 119232, '\p{^Is_Composition_Exclusion=f}', "");
    Expect(1, 119232, '\P{Is_Composition_Exclusion=f}', "");
    Expect(0, 119232, '\P{^Is_Composition_Exclusion=f}', "");
    Expect(1, 119233, '\p{Is_Composition_Exclusion: _-F}', "");
    Expect(0, 119233, '\p{^Is_Composition_Exclusion: _-F}', "");
    Expect(0, 119233, '\P{Is_Composition_Exclusion: _-F}', "");
    Expect(1, 119233, '\P{^Is_Composition_Exclusion: _-F}', "");
    Expect(0, 119232, '\p{Is_Composition_Exclusion: _-F}', "");
    Expect(1, 119232, '\p{^Is_Composition_Exclusion: _-F}', "");
    Expect(1, 119232, '\P{Is_Composition_Exclusion: _-F}', "");
    Expect(0, 119232, '\P{^Is_Composition_Exclusion: _-F}', "");
    Error('\p{Is_CE=:=--False}');
    Error('\P{Is_CE=:=--False}');
    Expect(1, 119233, '\p{Is_CE=false}', "");
    Expect(0, 119233, '\p{^Is_CE=false}', "");
    Expect(0, 119233, '\P{Is_CE=false}', "");
    Expect(1, 119233, '\P{^Is_CE=false}', "");
    Expect(0, 119232, '\p{Is_CE=false}', "");
    Expect(1, 119232, '\p{^Is_CE=false}', "");
    Expect(1, 119232, '\P{Is_CE=false}', "");
    Expect(0, 119232, '\P{^Is_CE=false}', "");
    Expect(1, 119233, '\p{Is_CE:	--false}', "");
    Expect(0, 119233, '\p{^Is_CE:	--false}', "");
    Expect(0, 119233, '\P{Is_CE:	--false}', "");
    Expect(1, 119233, '\P{^Is_CE:	--false}', "");
    Expect(0, 119232, '\p{Is_CE:	--false}', "");
    Expect(1, 119232, '\p{^Is_CE:	--false}', "");
    Expect(1, 119232, '\P{Is_CE:	--false}', "");
    Expect(0, 119232, '\P{^Is_CE:	--false}', "");
    Error('\p{Composition_Exclusion=:=_ Yes}');
    Error('\P{Composition_Exclusion=:=_ Yes}');
    Expect(1, 119232, '\p{Composition_Exclusion=yes}', "");
    Expect(0, 119232, '\p{^Composition_Exclusion=yes}', "");
    Expect(0, 119232, '\P{Composition_Exclusion=yes}', "");
    Expect(1, 119232, '\P{^Composition_Exclusion=yes}', "");
    Expect(0, 119233, '\p{Composition_Exclusion=yes}', "");
    Expect(1, 119233, '\p{^Composition_Exclusion=yes}', "");
    Expect(1, 119233, '\P{Composition_Exclusion=yes}', "");
    Expect(0, 119233, '\P{^Composition_Exclusion=yes}', "");
    Expect(1, 119232, '\p{Composition_Exclusion= _yes}', "");
    Expect(0, 119232, '\p{^Composition_Exclusion= _yes}', "");
    Expect(0, 119232, '\P{Composition_Exclusion= _yes}', "");
    Expect(1, 119232, '\P{^Composition_Exclusion= _yes}', "");
    Expect(0, 119233, '\p{Composition_Exclusion= _yes}', "");
    Expect(1, 119233, '\p{^Composition_Exclusion= _yes}', "");
    Expect(1, 119233, '\P{Composition_Exclusion= _yes}', "");
    Expect(0, 119233, '\P{^Composition_Exclusion= _yes}', "");
    Error('\p{CE=	Y/a/}');
    Error('\P{CE=	Y/a/}');
    Expect(1, 119232, '\p{CE: y}', "");
    Expect(0, 119232, '\p{^CE: y}', "");
    Expect(0, 119232, '\P{CE: y}', "");
    Expect(1, 119232, '\P{^CE: y}', "");
    Expect(0, 119233, '\p{CE: y}', "");
    Expect(1, 119233, '\p{^CE: y}', "");
    Expect(1, 119233, '\P{CE: y}', "");
    Expect(0, 119233, '\P{^CE: y}', "");
    Expect(1, 119232, '\p{CE=-Y}', "");
    Expect(0, 119232, '\p{^CE=-Y}', "");
    Expect(0, 119232, '\P{CE=-Y}', "");
    Expect(1, 119232, '\P{^CE=-Y}', "");
    Expect(0, 119233, '\p{CE=-Y}', "");
    Expect(1, 119233, '\p{^CE=-Y}', "");
    Expect(1, 119233, '\P{CE=-Y}', "");
    Expect(0, 119233, '\P{^CE=-Y}', "");
    Error('\p{Is_Composition_Exclusion= :=T}');
    Error('\P{Is_Composition_Exclusion= :=T}');
    Expect(1, 119232, '\p{Is_Composition_Exclusion=t}', "");
    Expect(0, 119232, '\p{^Is_Composition_Exclusion=t}', "");
    Expect(0, 119232, '\P{Is_Composition_Exclusion=t}', "");
    Expect(1, 119232, '\P{^Is_Composition_Exclusion=t}', "");
    Expect(0, 119233, '\p{Is_Composition_Exclusion=t}', "");
    Expect(1, 119233, '\p{^Is_Composition_Exclusion=t}', "");
    Expect(1, 119233, '\P{Is_Composition_Exclusion=t}', "");
    Expect(0, 119233, '\P{^Is_Composition_Exclusion=t}', "");
    Expect(1, 119232, '\p{Is_Composition_Exclusion=__T}', "");
    Expect(0, 119232, '\p{^Is_Composition_Exclusion=__T}', "");
    Expect(0, 119232, '\P{Is_Composition_Exclusion=__T}', "");
    Expect(1, 119232, '\P{^Is_Composition_Exclusion=__T}', "");
    Expect(0, 119233, '\p{Is_Composition_Exclusion=__T}', "");
    Expect(1, 119233, '\p{^Is_Composition_Exclusion=__T}', "");
    Expect(1, 119233, '\P{Is_Composition_Exclusion=__T}', "");
    Expect(0, 119233, '\P{^Is_Composition_Exclusion=__T}', "");
    Error('\p{Is_CE=:=True}');
    Error('\P{Is_CE=:=True}');
    Expect(1, 119232, '\p{Is_CE=true}', "");
    Expect(0, 119232, '\p{^Is_CE=true}', "");
    Expect(0, 119232, '\P{Is_CE=true}', "");
    Expect(1, 119232, '\P{^Is_CE=true}', "");
    Expect(0, 119233, '\p{Is_CE=true}', "");
    Expect(1, 119233, '\p{^Is_CE=true}', "");
    Expect(1, 119233, '\P{Is_CE=true}', "");
    Expect(0, 119233, '\P{^Is_CE=true}', "");
    Expect(1, 119232, '\p{Is_CE=-_TRUE}', "");
    Expect(0, 119232, '\p{^Is_CE=-_TRUE}', "");
    Expect(0, 119232, '\P{Is_CE=-_TRUE}', "");
    Expect(1, 119232, '\P{^Is_CE=-_TRUE}', "");
    Expect(0, 119233, '\p{Is_CE=-_TRUE}', "");
    Expect(1, 119233, '\p{^Is_CE=-_TRUE}', "");
    Expect(1, 119233, '\P{Is_CE=-_TRUE}', "");
    Expect(0, 119233, '\P{^Is_CE=-_TRUE}', "");
    Error('\p{casefolding}');
    Error('\P{casefolding}');
    Error('\p{Case_Ignorable=/a/_no}');
    Error('\P{Case_Ignorable=/a/_no}');
    Expect(1, 918000, '\p{Case_Ignorable=no}', "");
    Expect(0, 918000, '\p{^Case_Ignorable=no}', "");
    Expect(0, 918000, '\P{Case_Ignorable=no}', "");
    Expect(1, 918000, '\P{^Case_Ignorable=no}', "");
    Expect(0, 917999, '\p{Case_Ignorable=no}', "");
    Expect(1, 917999, '\p{^Case_Ignorable=no}', "");
    Expect(1, 917999, '\P{Case_Ignorable=no}', "");
    Expect(0, 917999, '\P{^Case_Ignorable=no}', "");
    Expect(1, 918000, '\p{Case_Ignorable=_No}', "");
    Expect(0, 918000, '\p{^Case_Ignorable=_No}', "");
    Expect(0, 918000, '\P{Case_Ignorable=_No}', "");
    Expect(1, 918000, '\P{^Case_Ignorable=_No}', "");
    Expect(0, 917999, '\p{Case_Ignorable=_No}', "");
    Expect(1, 917999, '\p{^Case_Ignorable=_No}', "");
    Expect(1, 917999, '\P{Case_Ignorable=_No}', "");
    Expect(0, 917999, '\P{^Case_Ignorable=_No}', "");
    Error('\p{CI=	_N/a/}');
    Error('\P{CI=	_N/a/}');
    Expect(1, 918000, '\p{CI=n}', "");
    Expect(0, 918000, '\p{^CI=n}', "");
    Expect(0, 918000, '\P{CI=n}', "");
    Expect(1, 918000, '\P{^CI=n}', "");
    Expect(0, 917999, '\p{CI=n}', "");
    Expect(1, 917999, '\p{^CI=n}', "");
    Expect(1, 917999, '\P{CI=n}', "");
    Expect(0, 917999, '\P{^CI=n}', "");
    Expect(1, 918000, '\p{CI=__N}', "");
    Expect(0, 918000, '\p{^CI=__N}', "");
    Expect(0, 918000, '\P{CI=__N}', "");
    Expect(1, 918000, '\P{^CI=__N}', "");
    Expect(0, 917999, '\p{CI=__N}', "");
    Expect(1, 917999, '\p{^CI=__N}', "");
    Expect(1, 917999, '\P{CI=__N}', "");
    Expect(0, 917999, '\P{^CI=__N}', "");
    Error('\p{Is_Case_Ignorable=-/a/F}');
    Error('\P{Is_Case_Ignorable=-/a/F}');
    Expect(1, 918000, '\p{Is_Case_Ignorable=f}', "");
    Expect(0, 918000, '\p{^Is_Case_Ignorable=f}', "");
    Expect(0, 918000, '\P{Is_Case_Ignorable=f}', "");
    Expect(1, 918000, '\P{^Is_Case_Ignorable=f}', "");
    Expect(0, 917999, '\p{Is_Case_Ignorable=f}', "");
    Expect(1, 917999, '\p{^Is_Case_Ignorable=f}', "");
    Expect(1, 917999, '\P{Is_Case_Ignorable=f}', "");
    Expect(0, 917999, '\P{^Is_Case_Ignorable=f}', "");
    Expect(1, 918000, '\p{Is_Case_Ignorable= F}', "");
    Expect(0, 918000, '\p{^Is_Case_Ignorable= F}', "");
    Expect(0, 918000, '\P{Is_Case_Ignorable= F}', "");
    Expect(1, 918000, '\P{^Is_Case_Ignorable= F}', "");
    Expect(0, 917999, '\p{Is_Case_Ignorable= F}', "");
    Expect(1, 917999, '\p{^Is_Case_Ignorable= F}', "");
    Expect(1, 917999, '\P{Is_Case_Ignorable= F}', "");
    Expect(0, 917999, '\P{^Is_Case_Ignorable= F}', "");
    Error('\p{Is_CI=_-False/a/}');
    Error('\P{Is_CI=_-False/a/}');
    Expect(1, 918000, '\p{Is_CI=false}', "");
    Expect(0, 918000, '\p{^Is_CI=false}', "");
    Expect(0, 918000, '\P{Is_CI=false}', "");
    Expect(1, 918000, '\P{^Is_CI=false}', "");
    Expect(0, 917999, '\p{Is_CI=false}', "");
    Expect(1, 917999, '\p{^Is_CI=false}', "");
    Expect(1, 917999, '\P{Is_CI=false}', "");
    Expect(0, 917999, '\P{^Is_CI=false}', "");
    Expect(1, 918000, '\p{Is_CI:	_FALSE}', "");
    Expect(0, 918000, '\p{^Is_CI:	_FALSE}', "");
    Expect(0, 918000, '\P{Is_CI:	_FALSE}', "");
    Expect(1, 918000, '\P{^Is_CI:	_FALSE}', "");
    Expect(0, 917999, '\p{Is_CI:	_FALSE}', "");
    Expect(1, 917999, '\p{^Is_CI:	_FALSE}', "");
    Expect(1, 917999, '\P{Is_CI:	_FALSE}', "");
    Expect(0, 917999, '\P{^Is_CI:	_FALSE}', "");
    Error('\p{Case_Ignorable=:=-YES}');
    Error('\P{Case_Ignorable=:=-YES}');
    Expect(1, 917999, '\p{Case_Ignorable: yes}', "");
    Expect(0, 917999, '\p{^Case_Ignorable: yes}', "");
    Expect(0, 917999, '\P{Case_Ignorable: yes}', "");
    Expect(1, 917999, '\P{^Case_Ignorable: yes}', "");
    Expect(0, 918000, '\p{Case_Ignorable: yes}', "");
    Expect(1, 918000, '\p{^Case_Ignorable: yes}', "");
    Expect(1, 918000, '\P{Case_Ignorable: yes}', "");
    Expect(0, 918000, '\P{^Case_Ignorable: yes}', "");
    Expect(1, 917999, '\p{Case_Ignorable: _Yes}', "");
    Expect(0, 917999, '\p{^Case_Ignorable: _Yes}', "");
    Expect(0, 917999, '\P{Case_Ignorable: _Yes}', "");
    Expect(1, 917999, '\P{^Case_Ignorable: _Yes}', "");
    Expect(0, 918000, '\p{Case_Ignorable: _Yes}', "");
    Expect(1, 918000, '\p{^Case_Ignorable: _Yes}', "");
    Expect(1, 918000, '\P{Case_Ignorable: _Yes}', "");
    Expect(0, 918000, '\P{^Case_Ignorable: _Yes}', "");
    Error('\p{CI=	 y/a/}');
    Error('\P{CI=	 y/a/}');
    Expect(1, 917999, '\p{CI=y}', "");
    Expect(0, 917999, '\p{^CI=y}', "");
    Expect(0, 917999, '\P{CI=y}', "");
    Expect(1, 917999, '\P{^CI=y}', "");
    Expect(0, 918000, '\p{CI=y}', "");
    Expect(1, 918000, '\p{^CI=y}', "");
    Expect(1, 918000, '\P{CI=y}', "");
    Expect(0, 918000, '\P{^CI=y}', "");
    Expect(1, 917999, '\p{CI= Y}', "");
    Expect(0, 917999, '\p{^CI= Y}', "");
    Expect(0, 917999, '\P{CI= Y}', "");
    Expect(1, 917999, '\P{^CI= Y}', "");
    Expect(0, 918000, '\p{CI= Y}', "");
    Expect(1, 918000, '\p{^CI= Y}', "");
    Expect(1, 918000, '\P{CI= Y}', "");
    Expect(0, 918000, '\P{^CI= Y}', "");
    Error('\p{Is_Case_Ignorable=_-T/a/}');
    Error('\P{Is_Case_Ignorable=_-T/a/}');
    Expect(1, 917999, '\p{Is_Case_Ignorable=t}', "");
    Expect(0, 917999, '\p{^Is_Case_Ignorable=t}', "");
    Expect(0, 917999, '\P{Is_Case_Ignorable=t}', "");
    Expect(1, 917999, '\P{^Is_Case_Ignorable=t}', "");
    Expect(0, 918000, '\p{Is_Case_Ignorable=t}', "");
    Expect(1, 918000, '\p{^Is_Case_Ignorable=t}', "");
    Expect(1, 918000, '\P{Is_Case_Ignorable=t}', "");
    Expect(0, 918000, '\P{^Is_Case_Ignorable=t}', "");
    Expect(1, 917999, '\p{Is_Case_Ignorable=--T}', "");
    Expect(0, 917999, '\p{^Is_Case_Ignorable=--T}', "");
    Expect(0, 917999, '\P{Is_Case_Ignorable=--T}', "");
    Expect(1, 917999, '\P{^Is_Case_Ignorable=--T}', "");
    Expect(0, 918000, '\p{Is_Case_Ignorable=--T}', "");
    Expect(1, 918000, '\p{^Is_Case_Ignorable=--T}', "");
    Expect(1, 918000, '\P{Is_Case_Ignorable=--T}', "");
    Expect(0, 918000, '\P{^Is_Case_Ignorable=--T}', "");
    Error('\p{Is_CI=-/a/True}');
    Error('\P{Is_CI=-/a/True}');
    Expect(1, 917999, '\p{Is_CI=true}', "");
    Expect(0, 917999, '\p{^Is_CI=true}', "");
    Expect(0, 917999, '\P{Is_CI=true}', "");
    Expect(1, 917999, '\P{^Is_CI=true}', "");
    Expect(0, 918000, '\p{Is_CI=true}', "");
    Expect(1, 918000, '\p{^Is_CI=true}', "");
    Expect(1, 918000, '\P{Is_CI=true}', "");
    Expect(0, 918000, '\P{^Is_CI=true}', "");
    Expect(1, 917999, '\p{Is_CI=- True}', "");
    Expect(0, 917999, '\p{^Is_CI=- True}', "");
    Expect(0, 917999, '\P{Is_CI=- True}', "");
    Expect(1, 917999, '\P{^Is_CI=- True}', "");
    Expect(0, 918000, '\p{Is_CI=- True}', "");
    Expect(1, 918000, '\p{^Is_CI=- True}', "");
    Expect(1, 918000, '\P{Is_CI=- True}', "");
    Expect(0, 918000, '\P{^Is_CI=- True}', "");
    Error('\p{kaccountingnumeric}');
    Error('\P{kaccountingnumeric}');
    Error('\p{cjkaccountingnumeric}');
    Error('\P{cjkaccountingnumeric}');
    Error('\p{kcompatibilityvariant}');
    Error('\P{kcompatibilityvariant}');
    Error('\p{cjkcompatibilityvariant}');
    Error('\P{cjkcompatibilityvariant}');
    Error('\p{kiicore}');
    Error('\P{kiicore}');
    Error('\p{cjkiicore}');
    Error('\P{cjkiicore}');
    Error('\p{kirggsource}');
    Error('\P{kirggsource}');
    Error('\p{cjkirggsource}');
    Error('\P{cjkirggsource}');
    Error('\p{kirghsource}');
    Error('\P{kirghsource}');
    Error('\p{cjkirghsource}');
    Error('\P{cjkirghsource}');
    Error('\p{kirgjsource}');
    Error('\P{kirgjsource}');
    Error('\p{cjkirgjsource}');
    Error('\P{cjkirgjsource}');
    Error('\p{kirgkpsource}');
    Error('\P{kirgkpsource}');
    Error('\p{cjkirgkpsource}');
    Error('\P{cjkirgkpsource}');
    Error('\p{kirgksource}');
    Error('\P{kirgksource}');
    Error('\p{cjkirgksource}');
    Error('\P{cjkirgksource}');
    Error('\p{kirgmsource}');
    Error('\P{kirgmsource}');
    Error('\p{cjkirgmsource}');
    Error('\P{cjkirgmsource}');
    Error('\p{kirgtsource}');
    Error('\P{kirgtsource}');
    Error('\p{cjkirgtsource}');
    Error('\P{cjkirgtsource}');
    Error('\p{kirgusource}');
    Error('\P{kirgusource}');
    Error('\p{cjkirgusource}');
    Error('\P{cjkirgusource}');
    Error('\p{kirgvsource}');
    Error('\P{kirgvsource}');
    Error('\p{cjkirgvsource}');
    Error('\P{cjkirgvsource}');
    Error('\p{kothernumeric}');
    Error('\P{kothernumeric}');
    Error('\p{cjkothernumeric}');
    Error('\P{cjkothernumeric}');
    Error('\p{kprimarynumeric}');
    Error('\P{kprimarynumeric}');
    Error('\p{cjkprimarynumeric}');
    Error('\P{cjkprimarynumeric}');
    Error('\p{krsunicode}');
    Error('\P{krsunicode}');
    Error('\p{cjkrsunicode}');
    Error('\P{cjkrsunicode}');
    Error('\p{unicoderadicalstroke}');
    Error('\P{unicoderadicalstroke}');
    Error('\p{urs}');
    Error('\P{urs}');
    Error('\p{Full_Composition_Exclusion=:= No}');
    Error('\P{Full_Composition_Exclusion=:= No}');
    Expect(1, 195102, '\p{Full_Composition_Exclusion:no}', "");
    Expect(0, 195102, '\p{^Full_Composition_Exclusion:no}', "");
    Expect(0, 195102, '\P{Full_Composition_Exclusion:no}', "");
    Expect(1, 195102, '\P{^Full_Composition_Exclusion:no}', "");
    Expect(0, 195101, '\p{Full_Composition_Exclusion:no}', "");
    Expect(1, 195101, '\p{^Full_Composition_Exclusion:no}', "");
    Expect(1, 195101, '\P{Full_Composition_Exclusion:no}', "");
    Expect(0, 195101, '\P{^Full_Composition_Exclusion:no}', "");
    Expect(1, 195102, '\p{Full_Composition_Exclusion: No}', "");
    Expect(0, 195102, '\p{^Full_Composition_Exclusion: No}', "");
    Expect(0, 195102, '\P{Full_Composition_Exclusion: No}', "");
    Expect(1, 195102, '\P{^Full_Composition_Exclusion: No}', "");
    Expect(0, 195101, '\p{Full_Composition_Exclusion: No}', "");
    Expect(1, 195101, '\p{^Full_Composition_Exclusion: No}', "");
    Expect(1, 195101, '\P{Full_Composition_Exclusion: No}', "");
    Expect(0, 195101, '\P{^Full_Composition_Exclusion: No}', "");
    Error('\p{Comp_Ex= n:=}');
    Error('\P{Comp_Ex= n:=}');
    Expect(1, 195102, '\p{Comp_Ex=n}', "");
    Expect(0, 195102, '\p{^Comp_Ex=n}', "");
    Expect(0, 195102, '\P{Comp_Ex=n}', "");
    Expect(1, 195102, '\P{^Comp_Ex=n}', "");
    Expect(0, 195101, '\p{Comp_Ex=n}', "");
    Expect(1, 195101, '\p{^Comp_Ex=n}', "");
    Expect(1, 195101, '\P{Comp_Ex=n}', "");
    Expect(0, 195101, '\P{^Comp_Ex=n}', "");
    Expect(1, 195102, '\p{Comp_Ex=	_n}', "");
    Expect(0, 195102, '\p{^Comp_Ex=	_n}', "");
    Expect(0, 195102, '\P{Comp_Ex=	_n}', "");
    Expect(1, 195102, '\P{^Comp_Ex=	_n}', "");
    Expect(0, 195101, '\p{Comp_Ex=	_n}', "");
    Expect(1, 195101, '\p{^Comp_Ex=	_n}', "");
    Expect(1, 195101, '\P{Comp_Ex=	_n}', "");
    Expect(0, 195101, '\P{^Comp_Ex=	_n}', "");
    Error('\p{Is_Full_Composition_Exclusion=/a/  f}');
    Error('\P{Is_Full_Composition_Exclusion=/a/  f}');
    Expect(1, 195102, '\p{Is_Full_Composition_Exclusion=f}', "");
    Expect(0, 195102, '\p{^Is_Full_Composition_Exclusion=f}', "");
    Expect(0, 195102, '\P{Is_Full_Composition_Exclusion=f}', "");
    Expect(1, 195102, '\P{^Is_Full_Composition_Exclusion=f}', "");
    Expect(0, 195101, '\p{Is_Full_Composition_Exclusion=f}', "");
    Expect(1, 195101, '\p{^Is_Full_Composition_Exclusion=f}', "");
    Expect(1, 195101, '\P{Is_Full_Composition_Exclusion=f}', "");
    Expect(0, 195101, '\P{^Is_Full_Composition_Exclusion=f}', "");
    Expect(1, 195102, '\p{Is_Full_Composition_Exclusion=	f}', "");
    Expect(0, 195102, '\p{^Is_Full_Composition_Exclusion=	f}', "");
    Expect(0, 195102, '\P{Is_Full_Composition_Exclusion=	f}', "");
    Expect(1, 195102, '\P{^Is_Full_Composition_Exclusion=	f}', "");
    Expect(0, 195101, '\p{Is_Full_Composition_Exclusion=	f}', "");
    Expect(1, 195101, '\p{^Is_Full_Composition_Exclusion=	f}', "");
    Expect(1, 195101, '\P{Is_Full_Composition_Exclusion=	f}', "");
    Expect(0, 195101, '\P{^Is_Full_Composition_Exclusion=	f}', "");
    Error('\p{Is_Comp_Ex= _False/a/}');
    Error('\P{Is_Comp_Ex= _False/a/}');
    Expect(1, 195102, '\p{Is_Comp_Ex:   false}', "");
    Expect(0, 195102, '\p{^Is_Comp_Ex:   false}', "");
    Expect(0, 195102, '\P{Is_Comp_Ex:   false}', "");
    Expect(1, 195102, '\P{^Is_Comp_Ex:   false}', "");
    Expect(0, 195101, '\p{Is_Comp_Ex:   false}', "");
    Expect(1, 195101, '\p{^Is_Comp_Ex:   false}', "");
    Expect(1, 195101, '\P{Is_Comp_Ex:   false}', "");
    Expect(0, 195101, '\P{^Is_Comp_Ex:   false}', "");
    Expect(1, 195102, '\p{Is_Comp_Ex=	 false}', "");
    Expect(0, 195102, '\p{^Is_Comp_Ex=	 false}', "");
    Expect(0, 195102, '\P{Is_Comp_Ex=	 false}', "");
    Expect(1, 195102, '\P{^Is_Comp_Ex=	 false}', "");
    Expect(0, 195101, '\p{Is_Comp_Ex=	 false}', "");
    Expect(1, 195101, '\p{^Is_Comp_Ex=	 false}', "");
    Expect(1, 195101, '\P{Is_Comp_Ex=	 false}', "");
    Expect(0, 195101, '\P{^Is_Comp_Ex=	 false}', "");
    Error('\p{Full_Composition_Exclusion= Yes/a/}');
    Error('\P{Full_Composition_Exclusion= Yes/a/}');
    Expect(1, 195101, '\p{Full_Composition_Exclusion:	yes}', "");
    Expect(0, 195101, '\p{^Full_Composition_Exclusion:	yes}', "");
    Expect(0, 195101, '\P{Full_Composition_Exclusion:	yes}', "");
    Expect(1, 195101, '\P{^Full_Composition_Exclusion:	yes}', "");
    Expect(0, 195102, '\p{Full_Composition_Exclusion:	yes}', "");
    Expect(1, 195102, '\p{^Full_Composition_Exclusion:	yes}', "");
    Expect(1, 195102, '\P{Full_Composition_Exclusion:	yes}', "");
    Expect(0, 195102, '\P{^Full_Composition_Exclusion:	yes}', "");
    Expect(1, 195101, '\p{Full_Composition_Exclusion: - Yes}', "");
    Expect(0, 195101, '\p{^Full_Composition_Exclusion: - Yes}', "");
    Expect(0, 195101, '\P{Full_Composition_Exclusion: - Yes}', "");
    Expect(1, 195101, '\P{^Full_Composition_Exclusion: - Yes}', "");
    Expect(0, 195102, '\p{Full_Composition_Exclusion: - Yes}', "");
    Expect(1, 195102, '\p{^Full_Composition_Exclusion: - Yes}', "");
    Expect(1, 195102, '\P{Full_Composition_Exclusion: - Yes}', "");
    Expect(0, 195102, '\P{^Full_Composition_Exclusion: - Yes}', "");
    Error('\p{Comp_Ex=/a/	-y}');
    Error('\P{Comp_Ex=/a/	-y}');
    Expect(1, 195101, '\p{Comp_Ex=y}', "");
    Expect(0, 195101, '\p{^Comp_Ex=y}', "");
    Expect(0, 195101, '\P{Comp_Ex=y}', "");
    Expect(1, 195101, '\P{^Comp_Ex=y}', "");
    Expect(0, 195102, '\p{Comp_Ex=y}', "");
    Expect(1, 195102, '\p{^Comp_Ex=y}', "");
    Expect(1, 195102, '\P{Comp_Ex=y}', "");
    Expect(0, 195102, '\P{^Comp_Ex=y}', "");
    Expect(1, 195101, '\p{Comp_Ex:    	y}', "");
    Expect(0, 195101, '\p{^Comp_Ex:    	y}', "");
    Expect(0, 195101, '\P{Comp_Ex:    	y}', "");
    Expect(1, 195101, '\P{^Comp_Ex:    	y}', "");
    Expect(0, 195102, '\p{Comp_Ex:    	y}', "");
    Expect(1, 195102, '\p{^Comp_Ex:    	y}', "");
    Expect(1, 195102, '\P{Comp_Ex:    	y}', "");
    Expect(0, 195102, '\P{^Comp_Ex:    	y}', "");
    Error('\p{Is_Full_Composition_Exclusion=	:=T}');
    Error('\P{Is_Full_Composition_Exclusion=	:=T}');
    Expect(1, 195101, '\p{Is_Full_Composition_Exclusion:	t}', "");
    Expect(0, 195101, '\p{^Is_Full_Composition_Exclusion:	t}', "");
    Expect(0, 195101, '\P{Is_Full_Composition_Exclusion:	t}', "");
    Expect(1, 195101, '\P{^Is_Full_Composition_Exclusion:	t}', "");
    Expect(0, 195102, '\p{Is_Full_Composition_Exclusion:	t}', "");
    Expect(1, 195102, '\p{^Is_Full_Composition_Exclusion:	t}', "");
    Expect(1, 195102, '\P{Is_Full_Composition_Exclusion:	t}', "");
    Expect(0, 195102, '\P{^Is_Full_Composition_Exclusion:	t}', "");
    Expect(1, 195101, '\p{Is_Full_Composition_Exclusion:	_T}', "");
    Expect(0, 195101, '\p{^Is_Full_Composition_Exclusion:	_T}', "");
    Expect(0, 195101, '\P{Is_Full_Composition_Exclusion:	_T}', "");
    Expect(1, 195101, '\P{^Is_Full_Composition_Exclusion:	_T}', "");
    Expect(0, 195102, '\p{Is_Full_Composition_Exclusion:	_T}', "");
    Expect(1, 195102, '\p{^Is_Full_Composition_Exclusion:	_T}', "");
    Expect(1, 195102, '\P{Is_Full_Composition_Exclusion:	_T}', "");
    Expect(0, 195102, '\P{^Is_Full_Composition_Exclusion:	_T}', "");
    Error('\p{Is_Comp_Ex= 	True:=}');
    Error('\P{Is_Comp_Ex= 	True:=}');
    Expect(1, 195101, '\p{Is_Comp_Ex=true}', "");
    Expect(0, 195101, '\p{^Is_Comp_Ex=true}', "");
    Expect(0, 195101, '\P{Is_Comp_Ex=true}', "");
    Expect(1, 195101, '\P{^Is_Comp_Ex=true}', "");
    Expect(0, 195102, '\p{Is_Comp_Ex=true}', "");
    Expect(1, 195102, '\p{^Is_Comp_Ex=true}', "");
    Expect(1, 195102, '\P{Is_Comp_Ex=true}', "");
    Expect(0, 195102, '\P{^Is_Comp_Ex=true}', "");
    Expect(1, 195101, '\p{Is_Comp_Ex=-True}', "");
    Expect(0, 195101, '\p{^Is_Comp_Ex=-True}', "");
    Expect(0, 195101, '\P{Is_Comp_Ex=-True}', "");
    Expect(1, 195101, '\P{^Is_Comp_Ex=-True}', "");
    Expect(0, 195102, '\p{Is_Comp_Ex=-True}', "");
    Expect(1, 195102, '\p{^Is_Comp_Ex=-True}', "");
    Expect(1, 195102, '\P{Is_Comp_Ex=-True}', "");
    Expect(0, 195102, '\P{^Is_Comp_Ex=-True}', "");
    Error('\p{Changes_When_Casefolded= 	NO/a/}');
    Error('\P{Changes_When_Casefolded= 	NO/a/}');
    Expect(1, 125218, '\p{Changes_When_Casefolded=no}', "");
    Expect(0, 125218, '\p{^Changes_When_Casefolded=no}', "");
    Expect(0, 125218, '\P{Changes_When_Casefolded=no}', "");
    Expect(1, 125218, '\P{^Changes_When_Casefolded=no}', "");
    Expect(0, 125217, '\p{Changes_When_Casefolded=no}', "");
    Expect(1, 125217, '\p{^Changes_When_Casefolded=no}', "");
    Expect(1, 125217, '\P{Changes_When_Casefolded=no}', "");
    Expect(0, 125217, '\P{^Changes_When_Casefolded=no}', "");
    Expect(1, 125218, '\p{Changes_When_Casefolded=_NO}', "");
    Expect(0, 125218, '\p{^Changes_When_Casefolded=_NO}', "");
    Expect(0, 125218, '\P{Changes_When_Casefolded=_NO}', "");
    Expect(1, 125218, '\P{^Changes_When_Casefolded=_NO}', "");
    Expect(0, 125217, '\p{Changes_When_Casefolded=_NO}', "");
    Expect(1, 125217, '\p{^Changes_When_Casefolded=_NO}', "");
    Expect(1, 125217, '\P{Changes_When_Casefolded=_NO}', "");
    Expect(0, 125217, '\P{^Changes_When_Casefolded=_NO}', "");
    Error('\p{CWCF:	/a/	 N}');
    Error('\P{CWCF:	/a/	 N}');
    Expect(1, 125218, '\p{CWCF=n}', "");
    Expect(0, 125218, '\p{^CWCF=n}', "");
    Expect(0, 125218, '\P{CWCF=n}', "");
    Expect(1, 125218, '\P{^CWCF=n}', "");
    Expect(0, 125217, '\p{CWCF=n}', "");
    Expect(1, 125217, '\p{^CWCF=n}', "");
    Expect(1, 125217, '\P{CWCF=n}', "");
    Expect(0, 125217, '\P{^CWCF=n}', "");
    Expect(1, 125218, '\p{CWCF:   _N}', "");
    Expect(0, 125218, '\p{^CWCF:   _N}', "");
    Expect(0, 125218, '\P{CWCF:   _N}', "");
    Expect(1, 125218, '\P{^CWCF:   _N}', "");
    Expect(0, 125217, '\p{CWCF:   _N}', "");
    Expect(1, 125217, '\p{^CWCF:   _N}', "");
    Expect(1, 125217, '\P{CWCF:   _N}', "");
    Expect(0, 125217, '\P{^CWCF:   _N}', "");
    Error('\p{Is_Changes_When_Casefolded=__F/a/}');
    Error('\P{Is_Changes_When_Casefolded=__F/a/}');
    Expect(1, 125218, '\p{Is_Changes_When_Casefolded=f}', "");
    Expect(0, 125218, '\p{^Is_Changes_When_Casefolded=f}', "");
    Expect(0, 125218, '\P{Is_Changes_When_Casefolded=f}', "");
    Expect(1, 125218, '\P{^Is_Changes_When_Casefolded=f}', "");
    Expect(0, 125217, '\p{Is_Changes_When_Casefolded=f}', "");
    Expect(1, 125217, '\p{^Is_Changes_When_Casefolded=f}', "");
    Expect(1, 125217, '\P{Is_Changes_When_Casefolded=f}', "");
    Expect(0, 125217, '\P{^Is_Changes_When_Casefolded=f}', "");
    Expect(1, 125218, '\p{Is_Changes_When_Casefolded=-F}', "");
    Expect(0, 125218, '\p{^Is_Changes_When_Casefolded=-F}', "");
    Expect(0, 125218, '\P{Is_Changes_When_Casefolded=-F}', "");
    Expect(1, 125218, '\P{^Is_Changes_When_Casefolded=-F}', "");
    Expect(0, 125217, '\p{Is_Changes_When_Casefolded=-F}', "");
    Expect(1, 125217, '\p{^Is_Changes_When_Casefolded=-F}', "");
    Expect(1, 125217, '\P{Is_Changes_When_Casefolded=-F}', "");
    Expect(0, 125217, '\P{^Is_Changes_When_Casefolded=-F}', "");
    Error('\p{Is_CWCF=:=	False}');
    Error('\P{Is_CWCF=:=	False}');
    Expect(1, 125218, '\p{Is_CWCF=false}', "");
    Expect(0, 125218, '\p{^Is_CWCF=false}', "");
    Expect(0, 125218, '\P{Is_CWCF=false}', "");
    Expect(1, 125218, '\P{^Is_CWCF=false}', "");
    Expect(0, 125217, '\p{Is_CWCF=false}', "");
    Expect(1, 125217, '\p{^Is_CWCF=false}', "");
    Expect(1, 125217, '\P{Is_CWCF=false}', "");
    Expect(0, 125217, '\P{^Is_CWCF=false}', "");
    Expect(1, 125218, '\p{Is_CWCF=-	False}', "");
    Expect(0, 125218, '\p{^Is_CWCF=-	False}', "");
    Expect(0, 125218, '\P{Is_CWCF=-	False}', "");
    Expect(1, 125218, '\P{^Is_CWCF=-	False}', "");
    Expect(0, 125217, '\p{Is_CWCF=-	False}', "");
    Expect(1, 125217, '\p{^Is_CWCF=-	False}', "");
    Expect(1, 125217, '\P{Is_CWCF=-	False}', "");
    Expect(0, 125217, '\P{^Is_CWCF=-	False}', "");
    Error('\p{Changes_When_Casefolded=_Yes/a/}');
    Error('\P{Changes_When_Casefolded=_Yes/a/}');
    Expect(1, 125217, '\p{Changes_When_Casefolded=yes}', "");
    Expect(0, 125217, '\p{^Changes_When_Casefolded=yes}', "");
    Expect(0, 125217, '\P{Changes_When_Casefolded=yes}', "");
    Expect(1, 125217, '\P{^Changes_When_Casefolded=yes}', "");
    Expect(0, 125218, '\p{Changes_When_Casefolded=yes}', "");
    Expect(1, 125218, '\p{^Changes_When_Casefolded=yes}', "");
    Expect(1, 125218, '\P{Changes_When_Casefolded=yes}', "");
    Expect(0, 125218, '\P{^Changes_When_Casefolded=yes}', "");
    Expect(1, 125217, '\p{Changes_When_Casefolded=	Yes}', "");
    Expect(0, 125217, '\p{^Changes_When_Casefolded=	Yes}', "");
    Expect(0, 125217, '\P{Changes_When_Casefolded=	Yes}', "");
    Expect(1, 125217, '\P{^Changes_When_Casefolded=	Yes}', "");
    Expect(0, 125218, '\p{Changes_When_Casefolded=	Yes}', "");
    Expect(1, 125218, '\p{^Changes_When_Casefolded=	Yes}', "");
    Expect(1, 125218, '\P{Changes_When_Casefolded=	Yes}', "");
    Expect(0, 125218, '\P{^Changes_When_Casefolded=	Yes}', "");
    Error('\p{CWCF= :=Y}');
    Error('\P{CWCF= :=Y}');
    Expect(1, 125217, '\p{CWCF=y}', "");
    Expect(0, 125217, '\p{^CWCF=y}', "");
    Expect(0, 125217, '\P{CWCF=y}', "");
    Expect(1, 125217, '\P{^CWCF=y}', "");
    Expect(0, 125218, '\p{CWCF=y}', "");
    Expect(1, 125218, '\p{^CWCF=y}', "");
    Expect(1, 125218, '\P{CWCF=y}', "");
    Expect(0, 125218, '\P{^CWCF=y}', "");
    Expect(1, 125217, '\p{CWCF=-_y}', "");
    Expect(0, 125217, '\p{^CWCF=-_y}', "");
    Expect(0, 125217, '\P{CWCF=-_y}', "");
    Expect(1, 125217, '\P{^CWCF=-_y}', "");
    Expect(0, 125218, '\p{CWCF=-_y}', "");
    Expect(1, 125218, '\p{^CWCF=-_y}', "");
    Expect(1, 125218, '\P{CWCF=-_y}', "");
    Expect(0, 125218, '\P{^CWCF=-_y}', "");
    Error('\p{Is_Changes_When_Casefolded= 	t/a/}');
    Error('\P{Is_Changes_When_Casefolded= 	t/a/}');
    Expect(1, 125217, '\p{Is_Changes_When_Casefolded=t}', "");
    Expect(0, 125217, '\p{^Is_Changes_When_Casefolded=t}', "");
    Expect(0, 125217, '\P{Is_Changes_When_Casefolded=t}', "");
    Expect(1, 125217, '\P{^Is_Changes_When_Casefolded=t}', "");
    Expect(0, 125218, '\p{Is_Changes_When_Casefolded=t}', "");
    Expect(1, 125218, '\p{^Is_Changes_When_Casefolded=t}', "");
    Expect(1, 125218, '\P{Is_Changes_When_Casefolded=t}', "");
    Expect(0, 125218, '\P{^Is_Changes_When_Casefolded=t}', "");
    Expect(1, 125217, '\p{Is_Changes_When_Casefolded=_T}', "");
    Expect(0, 125217, '\p{^Is_Changes_When_Casefolded=_T}', "");
    Expect(0, 125217, '\P{Is_Changes_When_Casefolded=_T}', "");
    Expect(1, 125217, '\P{^Is_Changes_When_Casefolded=_T}', "");
    Expect(0, 125218, '\p{Is_Changes_When_Casefolded=_T}', "");
    Expect(1, 125218, '\p{^Is_Changes_When_Casefolded=_T}', "");
    Expect(1, 125218, '\P{Is_Changes_When_Casefolded=_T}', "");
    Expect(0, 125218, '\P{^Is_Changes_When_Casefolded=_T}', "");
    Error('\p{Is_CWCF=-_True:=}');
    Error('\P{Is_CWCF=-_True:=}');
    Expect(1, 125217, '\p{Is_CWCF=true}', "");
    Expect(0, 125217, '\p{^Is_CWCF=true}', "");
    Expect(0, 125217, '\P{Is_CWCF=true}', "");
    Expect(1, 125217, '\P{^Is_CWCF=true}', "");
    Expect(0, 125218, '\p{Is_CWCF=true}', "");
    Expect(1, 125218, '\p{^Is_CWCF=true}', "");
    Expect(1, 125218, '\P{Is_CWCF=true}', "");
    Expect(0, 125218, '\P{^Is_CWCF=true}', "");
    Expect(1, 125217, '\p{Is_CWCF=_ TRUE}', "");
    Expect(0, 125217, '\p{^Is_CWCF=_ TRUE}', "");
    Expect(0, 125217, '\P{Is_CWCF=_ TRUE}', "");
    Expect(1, 125217, '\P{^Is_CWCF=_ TRUE}', "");
    Expect(0, 125218, '\p{Is_CWCF=_ TRUE}', "");
    Expect(1, 125218, '\p{^Is_CWCF=_ TRUE}', "");
    Expect(1, 125218, '\P{Is_CWCF=_ TRUE}', "");
    Expect(0, 125218, '\P{^Is_CWCF=_ TRUE}', "");
    Error('\p{Changes_When_Casemapped: /a/NO}');
    Error('\P{Changes_When_Casemapped: /a/NO}');
    Expect(1, 125252, '\p{Changes_When_Casemapped=no}', "");
    Expect(0, 125252, '\p{^Changes_When_Casemapped=no}', "");
    Expect(0, 125252, '\P{Changes_When_Casemapped=no}', "");
    Expect(1, 125252, '\P{^Changes_When_Casemapped=no}', "");
    Expect(0, 125251, '\p{Changes_When_Casemapped=no}', "");
    Expect(1, 125251, '\p{^Changes_When_Casemapped=no}', "");
    Expect(1, 125251, '\P{Changes_When_Casemapped=no}', "");
    Expect(0, 125251, '\P{^Changes_When_Casemapped=no}', "");
    Expect(1, 125252, '\p{Changes_When_Casemapped=	NO}', "");
    Expect(0, 125252, '\p{^Changes_When_Casemapped=	NO}', "");
    Expect(0, 125252, '\P{Changes_When_Casemapped=	NO}', "");
    Expect(1, 125252, '\P{^Changes_When_Casemapped=	NO}', "");
    Expect(0, 125251, '\p{Changes_When_Casemapped=	NO}', "");
    Expect(1, 125251, '\p{^Changes_When_Casemapped=	NO}', "");
    Expect(1, 125251, '\P{Changes_When_Casemapped=	NO}', "");
    Expect(0, 125251, '\P{^Changes_When_Casemapped=	NO}', "");
    Error('\p{CWCM=-/a/N}');
    Error('\P{CWCM=-/a/N}');
    Expect(1, 125252, '\p{CWCM=n}', "");
    Expect(0, 125252, '\p{^CWCM=n}', "");
    Expect(0, 125252, '\P{CWCM=n}', "");
    Expect(1, 125252, '\P{^CWCM=n}', "");
    Expect(0, 125251, '\p{CWCM=n}', "");
    Expect(1, 125251, '\p{^CWCM=n}', "");
    Expect(1, 125251, '\P{CWCM=n}', "");
    Expect(0, 125251, '\P{^CWCM=n}', "");
    Expect(1, 125252, '\p{CWCM=-N}', "");
    Expect(0, 125252, '\p{^CWCM=-N}', "");
    Expect(0, 125252, '\P{CWCM=-N}', "");
    Expect(1, 125252, '\P{^CWCM=-N}', "");
    Expect(0, 125251, '\p{CWCM=-N}', "");
    Expect(1, 125251, '\p{^CWCM=-N}', "");
    Expect(1, 125251, '\P{CWCM=-N}', "");
    Expect(0, 125251, '\P{^CWCM=-N}', "");
    Error('\p{Is_Changes_When_Casemapped:  /a/F}');
    Error('\P{Is_Changes_When_Casemapped:  /a/F}');
    Expect(1, 125252, '\p{Is_Changes_When_Casemapped=f}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Casemapped=f}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Casemapped=f}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Casemapped=f}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Casemapped=f}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Casemapped=f}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Casemapped=f}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Casemapped=f}', "");
    Expect(1, 125252, '\p{Is_Changes_When_Casemapped=-f}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Casemapped=-f}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Casemapped=-f}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Casemapped=-f}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Casemapped=-f}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Casemapped=-f}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Casemapped=-f}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Casemapped=-f}', "");
    Error('\p{Is_CWCM=-/a/False}');
    Error('\P{Is_CWCM=-/a/False}');
    Expect(1, 125252, '\p{Is_CWCM=false}', "");
    Expect(0, 125252, '\p{^Is_CWCM=false}', "");
    Expect(0, 125252, '\P{Is_CWCM=false}', "");
    Expect(1, 125252, '\P{^Is_CWCM=false}', "");
    Expect(0, 125251, '\p{Is_CWCM=false}', "");
    Expect(1, 125251, '\p{^Is_CWCM=false}', "");
    Expect(1, 125251, '\P{Is_CWCM=false}', "");
    Expect(0, 125251, '\P{^Is_CWCM=false}', "");
    Expect(1, 125252, '\p{Is_CWCM=		false}', "");
    Expect(0, 125252, '\p{^Is_CWCM=		false}', "");
    Expect(0, 125252, '\P{Is_CWCM=		false}', "");
    Expect(1, 125252, '\P{^Is_CWCM=		false}', "");
    Expect(0, 125251, '\p{Is_CWCM=		false}', "");
    Expect(1, 125251, '\p{^Is_CWCM=		false}', "");
    Expect(1, 125251, '\P{Is_CWCM=		false}', "");
    Expect(0, 125251, '\P{^Is_CWCM=		false}', "");
    Error('\p{Changes_When_Casemapped=:=-YES}');
    Error('\P{Changes_When_Casemapped=:=-YES}');
    Expect(1, 125251, '\p{Changes_When_Casemapped=yes}', "");
    Expect(0, 125251, '\p{^Changes_When_Casemapped=yes}', "");
    Expect(0, 125251, '\P{Changes_When_Casemapped=yes}', "");
    Expect(1, 125251, '\P{^Changes_When_Casemapped=yes}', "");
    Expect(0, 125252, '\p{Changes_When_Casemapped=yes}', "");
    Expect(1, 125252, '\p{^Changes_When_Casemapped=yes}', "");
    Expect(1, 125252, '\P{Changes_When_Casemapped=yes}', "");
    Expect(0, 125252, '\P{^Changes_When_Casemapped=yes}', "");
    Expect(1, 125251, '\p{Changes_When_Casemapped=-Yes}', "");
    Expect(0, 125251, '\p{^Changes_When_Casemapped=-Yes}', "");
    Expect(0, 125251, '\P{Changes_When_Casemapped=-Yes}', "");
    Expect(1, 125251, '\P{^Changes_When_Casemapped=-Yes}', "");
    Expect(0, 125252, '\p{Changes_When_Casemapped=-Yes}', "");
    Expect(1, 125252, '\p{^Changes_When_Casemapped=-Yes}', "");
    Expect(1, 125252, '\P{Changes_When_Casemapped=-Yes}', "");
    Expect(0, 125252, '\P{^Changes_When_Casemapped=-Yes}', "");
    Error('\p{CWCM=:= 	y}');
    Error('\P{CWCM=:= 	y}');
    Expect(1, 125251, '\p{CWCM=y}', "");
    Expect(0, 125251, '\p{^CWCM=y}', "");
    Expect(0, 125251, '\P{CWCM=y}', "");
    Expect(1, 125251, '\P{^CWCM=y}', "");
    Expect(0, 125252, '\p{CWCM=y}', "");
    Expect(1, 125252, '\p{^CWCM=y}', "");
    Expect(1, 125252, '\P{CWCM=y}', "");
    Expect(0, 125252, '\P{^CWCM=y}', "");
    Expect(1, 125251, '\p{CWCM=  Y}', "");
    Expect(0, 125251, '\p{^CWCM=  Y}', "");
    Expect(0, 125251, '\P{CWCM=  Y}', "");
    Expect(1, 125251, '\P{^CWCM=  Y}', "");
    Expect(0, 125252, '\p{CWCM=  Y}', "");
    Expect(1, 125252, '\p{^CWCM=  Y}', "");
    Expect(1, 125252, '\P{CWCM=  Y}', "");
    Expect(0, 125252, '\P{^CWCM=  Y}', "");
    Error('\p{Is_Changes_When_Casemapped=:=_	T}');
    Error('\P{Is_Changes_When_Casemapped=:=_	T}');
    Expect(1, 125251, '\p{Is_Changes_When_Casemapped=t}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Casemapped=t}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Casemapped=t}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Casemapped=t}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Casemapped=t}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Casemapped=t}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Casemapped=t}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Casemapped=t}', "");
    Expect(1, 125251, '\p{Is_Changes_When_Casemapped=-T}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Casemapped=-T}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Casemapped=-T}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Casemapped=-T}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Casemapped=-T}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Casemapped=-T}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Casemapped=-T}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Casemapped=-T}', "");
    Error('\p{Is_CWCM= :=TRUE}');
    Error('\P{Is_CWCM= :=TRUE}');
    Expect(1, 125251, '\p{Is_CWCM=true}', "");
    Expect(0, 125251, '\p{^Is_CWCM=true}', "");
    Expect(0, 125251, '\P{Is_CWCM=true}', "");
    Expect(1, 125251, '\P{^Is_CWCM=true}', "");
    Expect(0, 125252, '\p{Is_CWCM=true}', "");
    Expect(1, 125252, '\p{^Is_CWCM=true}', "");
    Expect(1, 125252, '\P{Is_CWCM=true}', "");
    Expect(0, 125252, '\P{^Is_CWCM=true}', "");
    Expect(1, 125251, '\p{Is_CWCM=-True}', "");
    Expect(0, 125251, '\p{^Is_CWCM=-True}', "");
    Expect(0, 125251, '\P{Is_CWCM=-True}', "");
    Expect(1, 125251, '\P{^Is_CWCM=-True}', "");
    Expect(0, 125252, '\p{Is_CWCM=-True}', "");
    Expect(1, 125252, '\p{^Is_CWCM=-True}', "");
    Expect(1, 125252, '\P{Is_CWCM=-True}', "");
    Expect(0, 125252, '\P{^Is_CWCM=-True}', "");
    Error('\p{Changes_When_NFKC_Casefolded=No:=}');
    Error('\P{Changes_When_NFKC_Casefolded=No:=}');
    Expect(1, 921600, '\p{Changes_When_NFKC_Casefolded=no}', "");
    Expect(0, 921600, '\p{^Changes_When_NFKC_Casefolded=no}', "");
    Expect(0, 921600, '\P{Changes_When_NFKC_Casefolded=no}', "");
    Expect(1, 921600, '\P{^Changes_When_NFKC_Casefolded=no}', "");
    Expect(0, 921599, '\p{Changes_When_NFKC_Casefolded=no}', "");
    Expect(1, 921599, '\p{^Changes_When_NFKC_Casefolded=no}', "");
    Expect(1, 921599, '\P{Changes_When_NFKC_Casefolded=no}', "");
    Expect(0, 921599, '\P{^Changes_When_NFKC_Casefolded=no}', "");
    Expect(1, 921600, '\p{Changes_When_NFKC_Casefolded:	_-NO}', "");
    Expect(0, 921600, '\p{^Changes_When_NFKC_Casefolded:	_-NO}', "");
    Expect(0, 921600, '\P{Changes_When_NFKC_Casefolded:	_-NO}', "");
    Expect(1, 921600, '\P{^Changes_When_NFKC_Casefolded:	_-NO}', "");
    Expect(0, 921599, '\p{Changes_When_NFKC_Casefolded:	_-NO}', "");
    Expect(1, 921599, '\p{^Changes_When_NFKC_Casefolded:	_-NO}', "");
    Expect(1, 921599, '\P{Changes_When_NFKC_Casefolded:	_-NO}', "");
    Expect(0, 921599, '\P{^Changes_When_NFKC_Casefolded:	_-NO}', "");
    Error('\p{CWKCF= /a/N}');
    Error('\P{CWKCF= /a/N}');
    Expect(1, 921600, '\p{CWKCF=n}', "");
    Expect(0, 921600, '\p{^CWKCF=n}', "");
    Expect(0, 921600, '\P{CWKCF=n}', "");
    Expect(1, 921600, '\P{^CWKCF=n}', "");
    Expect(0, 921599, '\p{CWKCF=n}', "");
    Expect(1, 921599, '\p{^CWKCF=n}', "");
    Expect(1, 921599, '\P{CWKCF=n}', "");
    Expect(0, 921599, '\P{^CWKCF=n}', "");
    Expect(1, 921600, '\p{CWKCF=	_N}', "");
    Expect(0, 921600, '\p{^CWKCF=	_N}', "");
    Expect(0, 921600, '\P{CWKCF=	_N}', "");
    Expect(1, 921600, '\P{^CWKCF=	_N}', "");
    Expect(0, 921599, '\p{CWKCF=	_N}', "");
    Expect(1, 921599, '\p{^CWKCF=	_N}', "");
    Expect(1, 921599, '\P{CWKCF=	_N}', "");
    Expect(0, 921599, '\P{^CWKCF=	_N}', "");
    Error('\p{Is_Changes_When_NFKC_Casefolded=:=  F}');
    Error('\P{Is_Changes_When_NFKC_Casefolded=:=  F}');
    Expect(1, 921600, '\p{Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(0, 921600, '\p{^Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(0, 921600, '\P{Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(1, 921600, '\P{^Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(0, 921599, '\p{Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(1, 921599, '\p{^Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(1, 921599, '\P{Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(0, 921599, '\P{^Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(1, 921600, '\p{Is_Changes_When_NFKC_Casefolded= 	f}', "");
    Expect(0, 921600, '\p{^Is_Changes_When_NFKC_Casefolded= 	f}', "");
    Expect(0, 921600, '\P{Is_Changes_When_NFKC_Casefolded= 	f}', "");
    Expect(1, 921600, '\P{^Is_Changes_When_NFKC_Casefolded= 	f}', "");
    Expect(0, 921599, '\p{Is_Changes_When_NFKC_Casefolded= 	f}', "");
    Expect(1, 921599, '\p{^Is_Changes_When_NFKC_Casefolded= 	f}', "");
    Expect(1, 921599, '\P{Is_Changes_When_NFKC_Casefolded= 	f}', "");
    Expect(0, 921599, '\P{^Is_Changes_When_NFKC_Casefolded= 	f}', "");
    Error('\p{Is_CWKCF:   :=__False}');
    Error('\P{Is_CWKCF:   :=__False}');
    Expect(1, 921600, '\p{Is_CWKCF:   false}', "");
    Expect(0, 921600, '\p{^Is_CWKCF:   false}', "");
    Expect(0, 921600, '\P{Is_CWKCF:   false}', "");
    Expect(1, 921600, '\P{^Is_CWKCF:   false}', "");
    Expect(0, 921599, '\p{Is_CWKCF:   false}', "");
    Expect(1, 921599, '\p{^Is_CWKCF:   false}', "");
    Expect(1, 921599, '\P{Is_CWKCF:   false}', "");
    Expect(0, 921599, '\P{^Is_CWKCF:   false}', "");
    Expect(1, 921600, '\p{Is_CWKCF=_ FALSE}', "");
    Expect(0, 921600, '\p{^Is_CWKCF=_ FALSE}', "");
    Expect(0, 921600, '\P{Is_CWKCF=_ FALSE}', "");
    Expect(1, 921600, '\P{^Is_CWKCF=_ FALSE}', "");
    Expect(0, 921599, '\p{Is_CWKCF=_ FALSE}', "");
    Expect(1, 921599, '\p{^Is_CWKCF=_ FALSE}', "");
    Expect(1, 921599, '\P{Is_CWKCF=_ FALSE}', "");
    Expect(0, 921599, '\P{^Is_CWKCF=_ FALSE}', "");
    Error('\p{Changes_When_NFKC_Casefolded=:=Yes}');
    Error('\P{Changes_When_NFKC_Casefolded=:=Yes}');
    Expect(1, 921599, '\p{Changes_When_NFKC_Casefolded=yes}', "");
    Expect(0, 921599, '\p{^Changes_When_NFKC_Casefolded=yes}', "");
    Expect(0, 921599, '\P{Changes_When_NFKC_Casefolded=yes}', "");
    Expect(1, 921599, '\P{^Changes_When_NFKC_Casefolded=yes}', "");
    Expect(0, 921600, '\p{Changes_When_NFKC_Casefolded=yes}', "");
    Expect(1, 921600, '\p{^Changes_When_NFKC_Casefolded=yes}', "");
    Expect(1, 921600, '\P{Changes_When_NFKC_Casefolded=yes}', "");
    Expect(0, 921600, '\P{^Changes_When_NFKC_Casefolded=yes}', "");
    Expect(1, 921599, '\p{Changes_When_NFKC_Casefolded:	_YES}', "");
    Expect(0, 921599, '\p{^Changes_When_NFKC_Casefolded:	_YES}', "");
    Expect(0, 921599, '\P{Changes_When_NFKC_Casefolded:	_YES}', "");
    Expect(1, 921599, '\P{^Changes_When_NFKC_Casefolded:	_YES}', "");
    Expect(0, 921600, '\p{Changes_When_NFKC_Casefolded:	_YES}', "");
    Expect(1, 921600, '\p{^Changes_When_NFKC_Casefolded:	_YES}', "");
    Expect(1, 921600, '\P{Changes_When_NFKC_Casefolded:	_YES}', "");
    Expect(0, 921600, '\P{^Changes_When_NFKC_Casefolded:	_YES}', "");
    Error('\p{CWKCF=/a/ -Y}');
    Error('\P{CWKCF=/a/ -Y}');
    Expect(1, 921599, '\p{CWKCF:	y}', "");
    Expect(0, 921599, '\p{^CWKCF:	y}', "");
    Expect(0, 921599, '\P{CWKCF:	y}', "");
    Expect(1, 921599, '\P{^CWKCF:	y}', "");
    Expect(0, 921600, '\p{CWKCF:	y}', "");
    Expect(1, 921600, '\p{^CWKCF:	y}', "");
    Expect(1, 921600, '\P{CWKCF:	y}', "");
    Expect(0, 921600, '\P{^CWKCF:	y}', "");
    Expect(1, 921599, '\p{CWKCF=	Y}', "");
    Expect(0, 921599, '\p{^CWKCF=	Y}', "");
    Expect(0, 921599, '\P{CWKCF=	Y}', "");
    Expect(1, 921599, '\P{^CWKCF=	Y}', "");
    Expect(0, 921600, '\p{CWKCF=	Y}', "");
    Expect(1, 921600, '\p{^CWKCF=	Y}', "");
    Expect(1, 921600, '\P{CWKCF=	Y}', "");
    Expect(0, 921600, '\P{^CWKCF=	Y}', "");
    Error('\p{Is_Changes_When_NFKC_Casefolded= T/a/}');
    Error('\P{Is_Changes_When_NFKC_Casefolded= T/a/}');
    Expect(1, 921599, '\p{Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(0, 921599, '\p{^Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(0, 921599, '\P{Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(1, 921599, '\P{^Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(0, 921600, '\p{Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(1, 921600, '\p{^Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(1, 921600, '\P{Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(0, 921600, '\P{^Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(1, 921599, '\p{Is_Changes_When_NFKC_Casefolded=_-T}', "");
    Expect(0, 921599, '\p{^Is_Changes_When_NFKC_Casefolded=_-T}', "");
    Expect(0, 921599, '\P{Is_Changes_When_NFKC_Casefolded=_-T}', "");
    Expect(1, 921599, '\P{^Is_Changes_When_NFKC_Casefolded=_-T}', "");
    Expect(0, 921600, '\p{Is_Changes_When_NFKC_Casefolded=_-T}', "");
    Expect(1, 921600, '\p{^Is_Changes_When_NFKC_Casefolded=_-T}', "");
    Expect(1, 921600, '\P{Is_Changes_When_NFKC_Casefolded=_-T}', "");
    Expect(0, 921600, '\P{^Is_Changes_When_NFKC_Casefolded=_-T}', "");
    Error('\p{Is_CWKCF:   :=--True}');
    Error('\P{Is_CWKCF:   :=--True}');
    Expect(1, 921599, '\p{Is_CWKCF:   true}', "");
    Expect(0, 921599, '\p{^Is_CWKCF:   true}', "");
    Expect(0, 921599, '\P{Is_CWKCF:   true}', "");
    Expect(1, 921599, '\P{^Is_CWKCF:   true}', "");
    Expect(0, 921600, '\p{Is_CWKCF:   true}', "");
    Expect(1, 921600, '\p{^Is_CWKCF:   true}', "");
    Expect(1, 921600, '\P{Is_CWKCF:   true}', "");
    Expect(0, 921600, '\P{^Is_CWKCF:   true}', "");
    Expect(1, 921599, '\p{Is_CWKCF=	 True}', "");
    Expect(0, 921599, '\p{^Is_CWKCF=	 True}', "");
    Expect(0, 921599, '\P{Is_CWKCF=	 True}', "");
    Expect(1, 921599, '\P{^Is_CWKCF=	 True}', "");
    Expect(0, 921600, '\p{Is_CWKCF=	 True}', "");
    Expect(1, 921600, '\p{^Is_CWKCF=	 True}', "");
    Expect(1, 921600, '\P{Is_CWKCF=	 True}', "");
    Expect(0, 921600, '\P{^Is_CWKCF=	 True}', "");
    Error('\p{Changes_When_Lowercased=-No:=}');
    Error('\P{Changes_When_Lowercased=-No:=}');
    Expect(1, 125218, '\p{Changes_When_Lowercased=no}', "");
    Expect(0, 125218, '\p{^Changes_When_Lowercased=no}', "");
    Expect(0, 125218, '\P{Changes_When_Lowercased=no}', "");
    Expect(1, 125218, '\P{^Changes_When_Lowercased=no}', "");
    Expect(0, 125217, '\p{Changes_When_Lowercased=no}', "");
    Expect(1, 125217, '\p{^Changes_When_Lowercased=no}', "");
    Expect(1, 125217, '\P{Changes_When_Lowercased=no}', "");
    Expect(0, 125217, '\P{^Changes_When_Lowercased=no}', "");
    Expect(1, 125218, '\p{Changes_When_Lowercased=	NO}', "");
    Expect(0, 125218, '\p{^Changes_When_Lowercased=	NO}', "");
    Expect(0, 125218, '\P{Changes_When_Lowercased=	NO}', "");
    Expect(1, 125218, '\P{^Changes_When_Lowercased=	NO}', "");
    Expect(0, 125217, '\p{Changes_When_Lowercased=	NO}', "");
    Expect(1, 125217, '\p{^Changes_When_Lowercased=	NO}', "");
    Expect(1, 125217, '\P{Changes_When_Lowercased=	NO}', "");
    Expect(0, 125217, '\P{^Changes_When_Lowercased=	NO}', "");
    Error('\p{CWL:   -/a/N}');
    Error('\P{CWL:   -/a/N}');
    Expect(1, 125218, '\p{CWL=n}', "");
    Expect(0, 125218, '\p{^CWL=n}', "");
    Expect(0, 125218, '\P{CWL=n}', "");
    Expect(1, 125218, '\P{^CWL=n}', "");
    Expect(0, 125217, '\p{CWL=n}', "");
    Expect(1, 125217, '\p{^CWL=n}', "");
    Expect(1, 125217, '\P{CWL=n}', "");
    Expect(0, 125217, '\P{^CWL=n}', "");
    Expect(1, 125218, '\p{CWL=_ n}', "");
    Expect(0, 125218, '\p{^CWL=_ n}', "");
    Expect(0, 125218, '\P{CWL=_ n}', "");
    Expect(1, 125218, '\P{^CWL=_ n}', "");
    Expect(0, 125217, '\p{CWL=_ n}', "");
    Expect(1, 125217, '\p{^CWL=_ n}', "");
    Expect(1, 125217, '\P{CWL=_ n}', "");
    Expect(0, 125217, '\P{^CWL=_ n}', "");
    Error('\p{Is_Changes_When_Lowercased=_/a/f}');
    Error('\P{Is_Changes_When_Lowercased=_/a/f}');
    Expect(1, 125218, '\p{Is_Changes_When_Lowercased:	f}', "");
    Expect(0, 125218, '\p{^Is_Changes_When_Lowercased:	f}', "");
    Expect(0, 125218, '\P{Is_Changes_When_Lowercased:	f}', "");
    Expect(1, 125218, '\P{^Is_Changes_When_Lowercased:	f}', "");
    Expect(0, 125217, '\p{Is_Changes_When_Lowercased:	f}', "");
    Expect(1, 125217, '\p{^Is_Changes_When_Lowercased:	f}', "");
    Expect(1, 125217, '\P{Is_Changes_When_Lowercased:	f}', "");
    Expect(0, 125217, '\P{^Is_Changes_When_Lowercased:	f}', "");
    Expect(1, 125218, '\p{Is_Changes_When_Lowercased=-_F}', "");
    Expect(0, 125218, '\p{^Is_Changes_When_Lowercased=-_F}', "");
    Expect(0, 125218, '\P{Is_Changes_When_Lowercased=-_F}', "");
    Expect(1, 125218, '\P{^Is_Changes_When_Lowercased=-_F}', "");
    Expect(0, 125217, '\p{Is_Changes_When_Lowercased=-_F}', "");
    Expect(1, 125217, '\p{^Is_Changes_When_Lowercased=-_F}', "");
    Expect(1, 125217, '\P{Is_Changes_When_Lowercased=-_F}', "");
    Expect(0, 125217, '\P{^Is_Changes_When_Lowercased=-_F}', "");
    Error('\p{Is_CWL:  	false/a/}');
    Error('\P{Is_CWL:  	false/a/}');
    Expect(1, 125218, '\p{Is_CWL=false}', "");
    Expect(0, 125218, '\p{^Is_CWL=false}', "");
    Expect(0, 125218, '\P{Is_CWL=false}', "");
    Expect(1, 125218, '\P{^Is_CWL=false}', "");
    Expect(0, 125217, '\p{Is_CWL=false}', "");
    Expect(1, 125217, '\p{^Is_CWL=false}', "");
    Expect(1, 125217, '\P{Is_CWL=false}', "");
    Expect(0, 125217, '\P{^Is_CWL=false}', "");
    Expect(1, 125218, '\p{Is_CWL=_False}', "");
    Expect(0, 125218, '\p{^Is_CWL=_False}', "");
    Expect(0, 125218, '\P{Is_CWL=_False}', "");
    Expect(1, 125218, '\P{^Is_CWL=_False}', "");
    Expect(0, 125217, '\p{Is_CWL=_False}', "");
    Expect(1, 125217, '\p{^Is_CWL=_False}', "");
    Expect(1, 125217, '\P{Is_CWL=_False}', "");
    Expect(0, 125217, '\P{^Is_CWL=_False}', "");
    Error('\p{Changes_When_Lowercased=:=		yes}');
    Error('\P{Changes_When_Lowercased=:=		yes}');
    Expect(1, 125217, '\p{Changes_When_Lowercased=yes}', "");
    Expect(0, 125217, '\p{^Changes_When_Lowercased=yes}', "");
    Expect(0, 125217, '\P{Changes_When_Lowercased=yes}', "");
    Expect(1, 125217, '\P{^Changes_When_Lowercased=yes}', "");
    Expect(0, 125218, '\p{Changes_When_Lowercased=yes}', "");
    Expect(1, 125218, '\p{^Changes_When_Lowercased=yes}', "");
    Expect(1, 125218, '\P{Changes_When_Lowercased=yes}', "");
    Expect(0, 125218, '\P{^Changes_When_Lowercased=yes}', "");
    Expect(1, 125217, '\p{Changes_When_Lowercased=_	yes}', "");
    Expect(0, 125217, '\p{^Changes_When_Lowercased=_	yes}', "");
    Expect(0, 125217, '\P{Changes_When_Lowercased=_	yes}', "");
    Expect(1, 125217, '\P{^Changes_When_Lowercased=_	yes}', "");
    Expect(0, 125218, '\p{Changes_When_Lowercased=_	yes}', "");
    Expect(1, 125218, '\p{^Changes_When_Lowercased=_	yes}', "");
    Expect(1, 125218, '\P{Changes_When_Lowercased=_	yes}', "");
    Expect(0, 125218, '\P{^Changes_When_Lowercased=_	yes}', "");
    Error('\p{CWL: /a/Y}');
    Error('\P{CWL: /a/Y}');
    Expect(1, 125217, '\p{CWL=y}', "");
    Expect(0, 125217, '\p{^CWL=y}', "");
    Expect(0, 125217, '\P{CWL=y}', "");
    Expect(1, 125217, '\P{^CWL=y}', "");
    Expect(0, 125218, '\p{CWL=y}', "");
    Expect(1, 125218, '\p{^CWL=y}', "");
    Expect(1, 125218, '\P{CWL=y}', "");
    Expect(0, 125218, '\P{^CWL=y}', "");
    Expect(1, 125217, '\p{CWL=-	Y}', "");
    Expect(0, 125217, '\p{^CWL=-	Y}', "");
    Expect(0, 125217, '\P{CWL=-	Y}', "");
    Expect(1, 125217, '\P{^CWL=-	Y}', "");
    Expect(0, 125218, '\p{CWL=-	Y}', "");
    Expect(1, 125218, '\p{^CWL=-	Y}', "");
    Expect(1, 125218, '\P{CWL=-	Y}', "");
    Expect(0, 125218, '\P{^CWL=-	Y}', "");
    Error('\p{Is_Changes_When_Lowercased= T/a/}');
    Error('\P{Is_Changes_When_Lowercased= T/a/}');
    Expect(1, 125217, '\p{Is_Changes_When_Lowercased=t}', "");
    Expect(0, 125217, '\p{^Is_Changes_When_Lowercased=t}', "");
    Expect(0, 125217, '\P{Is_Changes_When_Lowercased=t}', "");
    Expect(1, 125217, '\P{^Is_Changes_When_Lowercased=t}', "");
    Expect(0, 125218, '\p{Is_Changes_When_Lowercased=t}', "");
    Expect(1, 125218, '\p{^Is_Changes_When_Lowercased=t}', "");
    Expect(1, 125218, '\P{Is_Changes_When_Lowercased=t}', "");
    Expect(0, 125218, '\P{^Is_Changes_When_Lowercased=t}', "");
    Expect(1, 125217, '\p{Is_Changes_When_Lowercased:	_T}', "");
    Expect(0, 125217, '\p{^Is_Changes_When_Lowercased:	_T}', "");
    Expect(0, 125217, '\P{Is_Changes_When_Lowercased:	_T}', "");
    Expect(1, 125217, '\P{^Is_Changes_When_Lowercased:	_T}', "");
    Expect(0, 125218, '\p{Is_Changes_When_Lowercased:	_T}', "");
    Expect(1, 125218, '\p{^Is_Changes_When_Lowercased:	_T}', "");
    Expect(1, 125218, '\P{Is_Changes_When_Lowercased:	_T}', "");
    Expect(0, 125218, '\P{^Is_Changes_When_Lowercased:	_T}', "");
    Error('\p{Is_CWL=-:=True}');
    Error('\P{Is_CWL=-:=True}');
    Expect(1, 125217, '\p{Is_CWL:   true}', "");
    Expect(0, 125217, '\p{^Is_CWL:   true}', "");
    Expect(0, 125217, '\P{Is_CWL:   true}', "");
    Expect(1, 125217, '\P{^Is_CWL:   true}', "");
    Expect(0, 125218, '\p{Is_CWL:   true}', "");
    Expect(1, 125218, '\p{^Is_CWL:   true}', "");
    Expect(1, 125218, '\P{Is_CWL:   true}', "");
    Expect(0, 125218, '\P{^Is_CWL:   true}', "");
    Expect(1, 125217, '\p{Is_CWL=  True}', "");
    Expect(0, 125217, '\p{^Is_CWL=  True}', "");
    Expect(0, 125217, '\P{Is_CWL=  True}', "");
    Expect(1, 125217, '\P{^Is_CWL=  True}', "");
    Expect(0, 125218, '\p{Is_CWL=  True}', "");
    Expect(1, 125218, '\p{^Is_CWL=  True}', "");
    Expect(1, 125218, '\P{Is_CWL=  True}', "");
    Expect(0, 125218, '\P{^Is_CWL=  True}', "");
    Error('\p{Changes_When_Titlecased=No:=}');
    Error('\P{Changes_When_Titlecased=No:=}');
    Expect(1, 125252, '\p{Changes_When_Titlecased:	no}', "");
    Expect(0, 125252, '\p{^Changes_When_Titlecased:	no}', "");
    Expect(0, 125252, '\P{Changes_When_Titlecased:	no}', "");
    Expect(1, 125252, '\P{^Changes_When_Titlecased:	no}', "");
    Expect(0, 125251, '\p{Changes_When_Titlecased:	no}', "");
    Expect(1, 125251, '\p{^Changes_When_Titlecased:	no}', "");
    Expect(1, 125251, '\P{Changes_When_Titlecased:	no}', "");
    Expect(0, 125251, '\P{^Changes_When_Titlecased:	no}', "");
    Expect(1, 125252, '\p{Changes_When_Titlecased=- no}', "");
    Expect(0, 125252, '\p{^Changes_When_Titlecased=- no}', "");
    Expect(0, 125252, '\P{Changes_When_Titlecased=- no}', "");
    Expect(1, 125252, '\P{^Changes_When_Titlecased=- no}', "");
    Expect(0, 125251, '\p{Changes_When_Titlecased=- no}', "");
    Expect(1, 125251, '\p{^Changes_When_Titlecased=- no}', "");
    Expect(1, 125251, '\P{Changes_When_Titlecased=- no}', "");
    Expect(0, 125251, '\P{^Changes_When_Titlecased=- no}', "");
    Error('\p{CWT=:= N}');
    Error('\P{CWT=:= N}');
    Expect(1, 125252, '\p{CWT:   n}', "");
    Expect(0, 125252, '\p{^CWT:   n}', "");
    Expect(0, 125252, '\P{CWT:   n}', "");
    Expect(1, 125252, '\P{^CWT:   n}', "");
    Expect(0, 125251, '\p{CWT:   n}', "");
    Expect(1, 125251, '\p{^CWT:   n}', "");
    Expect(1, 125251, '\P{CWT:   n}', "");
    Expect(0, 125251, '\P{^CWT:   n}', "");
    Expect(1, 125252, '\p{CWT: -n}', "");
    Expect(0, 125252, '\p{^CWT: -n}', "");
    Expect(0, 125252, '\P{CWT: -n}', "");
    Expect(1, 125252, '\P{^CWT: -n}', "");
    Expect(0, 125251, '\p{CWT: -n}', "");
    Expect(1, 125251, '\p{^CWT: -n}', "");
    Expect(1, 125251, '\P{CWT: -n}', "");
    Expect(0, 125251, '\P{^CWT: -n}', "");
    Error('\p{Is_Changes_When_Titlecased=-/a/f}');
    Error('\P{Is_Changes_When_Titlecased=-/a/f}');
    Expect(1, 125252, '\p{Is_Changes_When_Titlecased=f}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Titlecased=f}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Titlecased=f}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Titlecased=f}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Titlecased=f}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Titlecased=f}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Titlecased=f}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Titlecased=f}', "");
    Expect(1, 125252, '\p{Is_Changes_When_Titlecased= F}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Titlecased= F}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Titlecased= F}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Titlecased= F}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Titlecased= F}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Titlecased= F}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Titlecased= F}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Titlecased= F}', "");
    Error('\p{Is_CWT=_	False:=}');
    Error('\P{Is_CWT=_	False:=}');
    Expect(1, 125252, '\p{Is_CWT:   false}', "");
    Expect(0, 125252, '\p{^Is_CWT:   false}', "");
    Expect(0, 125252, '\P{Is_CWT:   false}', "");
    Expect(1, 125252, '\P{^Is_CWT:   false}', "");
    Expect(0, 125251, '\p{Is_CWT:   false}', "");
    Expect(1, 125251, '\p{^Is_CWT:   false}', "");
    Expect(1, 125251, '\P{Is_CWT:   false}', "");
    Expect(0, 125251, '\P{^Is_CWT:   false}', "");
    Expect(1, 125252, '\p{Is_CWT=__false}', "");
    Expect(0, 125252, '\p{^Is_CWT=__false}', "");
    Expect(0, 125252, '\P{Is_CWT=__false}', "");
    Expect(1, 125252, '\P{^Is_CWT=__false}', "");
    Expect(0, 125251, '\p{Is_CWT=__false}', "");
    Expect(1, 125251, '\p{^Is_CWT=__false}', "");
    Expect(1, 125251, '\P{Is_CWT=__false}', "");
    Expect(0, 125251, '\P{^Is_CWT=__false}', "");
    Error('\p{Changes_When_Titlecased=:=Yes}');
    Error('\P{Changes_When_Titlecased=:=Yes}');
    Expect(1, 125251, '\p{Changes_When_Titlecased=yes}', "");
    Expect(0, 125251, '\p{^Changes_When_Titlecased=yes}', "");
    Expect(0, 125251, '\P{Changes_When_Titlecased=yes}', "");
    Expect(1, 125251, '\P{^Changes_When_Titlecased=yes}', "");
    Expect(0, 125252, '\p{Changes_When_Titlecased=yes}', "");
    Expect(1, 125252, '\p{^Changes_When_Titlecased=yes}', "");
    Expect(1, 125252, '\P{Changes_When_Titlecased=yes}', "");
    Expect(0, 125252, '\P{^Changes_When_Titlecased=yes}', "");
    Expect(1, 125251, '\p{Changes_When_Titlecased=  Yes}', "");
    Expect(0, 125251, '\p{^Changes_When_Titlecased=  Yes}', "");
    Expect(0, 125251, '\P{Changes_When_Titlecased=  Yes}', "");
    Expect(1, 125251, '\P{^Changes_When_Titlecased=  Yes}', "");
    Expect(0, 125252, '\p{Changes_When_Titlecased=  Yes}', "");
    Expect(1, 125252, '\p{^Changes_When_Titlecased=  Yes}', "");
    Expect(1, 125252, '\P{Changes_When_Titlecased=  Yes}', "");
    Expect(0, 125252, '\P{^Changes_When_Titlecased=  Yes}', "");
    Error('\p{CWT=	y:=}');
    Error('\P{CWT=	y:=}');
    Expect(1, 125251, '\p{CWT=y}', "");
    Expect(0, 125251, '\p{^CWT=y}', "");
    Expect(0, 125251, '\P{CWT=y}', "");
    Expect(1, 125251, '\P{^CWT=y}', "");
    Expect(0, 125252, '\p{CWT=y}', "");
    Expect(1, 125252, '\p{^CWT=y}', "");
    Expect(1, 125252, '\P{CWT=y}', "");
    Expect(0, 125252, '\P{^CWT=y}', "");
    Expect(1, 125251, '\p{CWT=	-y}', "");
    Expect(0, 125251, '\p{^CWT=	-y}', "");
    Expect(0, 125251, '\P{CWT=	-y}', "");
    Expect(1, 125251, '\P{^CWT=	-y}', "");
    Expect(0, 125252, '\p{CWT=	-y}', "");
    Expect(1, 125252, '\p{^CWT=	-y}', "");
    Expect(1, 125252, '\P{CWT=	-y}', "");
    Expect(0, 125252, '\P{^CWT=	-y}', "");
    Error('\p{Is_Changes_When_Titlecased=:=	-T}');
    Error('\P{Is_Changes_When_Titlecased=:=	-T}');
    Expect(1, 125251, '\p{Is_Changes_When_Titlecased=t}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Titlecased=t}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Titlecased=t}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Titlecased=t}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Titlecased=t}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Titlecased=t}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Titlecased=t}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Titlecased=t}', "");
    Expect(1, 125251, '\p{Is_Changes_When_Titlecased=_	t}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Titlecased=_	t}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Titlecased=_	t}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Titlecased=_	t}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Titlecased=_	t}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Titlecased=_	t}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Titlecased=_	t}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Titlecased=_	t}', "");
    Error('\p{Is_CWT=	-TRUE:=}');
    Error('\P{Is_CWT=	-TRUE:=}');
    Expect(1, 125251, '\p{Is_CWT=true}', "");
    Expect(0, 125251, '\p{^Is_CWT=true}', "");
    Expect(0, 125251, '\P{Is_CWT=true}', "");
    Expect(1, 125251, '\P{^Is_CWT=true}', "");
    Expect(0, 125252, '\p{Is_CWT=true}', "");
    Expect(1, 125252, '\p{^Is_CWT=true}', "");
    Expect(1, 125252, '\P{Is_CWT=true}', "");
    Expect(0, 125252, '\P{^Is_CWT=true}', "");
    Expect(1, 125251, '\p{Is_CWT=-TRUE}', "");
    Expect(0, 125251, '\p{^Is_CWT=-TRUE}', "");
    Expect(0, 125251, '\P{Is_CWT=-TRUE}', "");
    Expect(1, 125251, '\P{^Is_CWT=-TRUE}', "");
    Expect(0, 125252, '\p{Is_CWT=-TRUE}', "");
    Expect(1, 125252, '\p{^Is_CWT=-TRUE}', "");
    Expect(1, 125252, '\P{Is_CWT=-TRUE}', "");
    Expect(0, 125252, '\P{^Is_CWT=-TRUE}', "");
    Error('\p{Changes_When_Uppercased=:=_ No}');
    Error('\P{Changes_When_Uppercased=:=_ No}');
    Expect(1, 125252, '\p{Changes_When_Uppercased=no}', "");
    Expect(0, 125252, '\p{^Changes_When_Uppercased=no}', "");
    Expect(0, 125252, '\P{Changes_When_Uppercased=no}', "");
    Expect(1, 125252, '\P{^Changes_When_Uppercased=no}', "");
    Expect(0, 125251, '\p{Changes_When_Uppercased=no}', "");
    Expect(1, 125251, '\p{^Changes_When_Uppercased=no}', "");
    Expect(1, 125251, '\P{Changes_When_Uppercased=no}', "");
    Expect(0, 125251, '\P{^Changes_When_Uppercased=no}', "");
    Expect(1, 125252, '\p{Changes_When_Uppercased=  No}', "");
    Expect(0, 125252, '\p{^Changes_When_Uppercased=  No}', "");
    Expect(0, 125252, '\P{Changes_When_Uppercased=  No}', "");
    Expect(1, 125252, '\P{^Changes_When_Uppercased=  No}', "");
    Expect(0, 125251, '\p{Changes_When_Uppercased=  No}', "");
    Expect(1, 125251, '\p{^Changes_When_Uppercased=  No}', "");
    Expect(1, 125251, '\P{Changes_When_Uppercased=  No}', "");
    Expect(0, 125251, '\P{^Changes_When_Uppercased=  No}', "");
    Error('\p{CWU= 	n/a/}');
    Error('\P{CWU= 	n/a/}');
    Expect(1, 125252, '\p{CWU=n}', "");
    Expect(0, 125252, '\p{^CWU=n}', "");
    Expect(0, 125252, '\P{CWU=n}', "");
    Expect(1, 125252, '\P{^CWU=n}', "");
    Expect(0, 125251, '\p{CWU=n}', "");
    Expect(1, 125251, '\p{^CWU=n}', "");
    Expect(1, 125251, '\P{CWU=n}', "");
    Expect(0, 125251, '\P{^CWU=n}', "");
    Expect(1, 125252, '\p{CWU=-N}', "");
    Expect(0, 125252, '\p{^CWU=-N}', "");
    Expect(0, 125252, '\P{CWU=-N}', "");
    Expect(1, 125252, '\P{^CWU=-N}', "");
    Expect(0, 125251, '\p{CWU=-N}', "");
    Expect(1, 125251, '\p{^CWU=-N}', "");
    Expect(1, 125251, '\P{CWU=-N}', "");
    Expect(0, 125251, '\P{^CWU=-N}', "");
    Error('\p{Is_Changes_When_Uppercased=__F/a/}');
    Error('\P{Is_Changes_When_Uppercased=__F/a/}');
    Expect(1, 125252, '\p{Is_Changes_When_Uppercased=f}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Uppercased=f}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Uppercased=f}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Uppercased=f}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Uppercased=f}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Uppercased=f}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Uppercased=f}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Uppercased=f}', "");
    Expect(1, 125252, '\p{Is_Changes_When_Uppercased=	F}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Uppercased=	F}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Uppercased=	F}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Uppercased=	F}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Uppercased=	F}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Uppercased=	F}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Uppercased=	F}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Uppercased=	F}', "");
    Error('\p{Is_CWU:	 -False:=}');
    Error('\P{Is_CWU:	 -False:=}');
    Expect(1, 125252, '\p{Is_CWU=false}', "");
    Expect(0, 125252, '\p{^Is_CWU=false}', "");
    Expect(0, 125252, '\P{Is_CWU=false}', "");
    Expect(1, 125252, '\P{^Is_CWU=false}', "");
    Expect(0, 125251, '\p{Is_CWU=false}', "");
    Expect(1, 125251, '\p{^Is_CWU=false}', "");
    Expect(1, 125251, '\P{Is_CWU=false}', "");
    Expect(0, 125251, '\P{^Is_CWU=false}', "");
    Expect(1, 125252, '\p{Is_CWU=- False}', "");
    Expect(0, 125252, '\p{^Is_CWU=- False}', "");
    Expect(0, 125252, '\P{Is_CWU=- False}', "");
    Expect(1, 125252, '\P{^Is_CWU=- False}', "");
    Expect(0, 125251, '\p{Is_CWU=- False}', "");
    Expect(1, 125251, '\p{^Is_CWU=- False}', "");
    Expect(1, 125251, '\P{Is_CWU=- False}', "");
    Expect(0, 125251, '\P{^Is_CWU=- False}', "");
    Error('\p{Changes_When_Uppercased: _-yes/a/}');
    Error('\P{Changes_When_Uppercased: _-yes/a/}');
    Expect(1, 125251, '\p{Changes_When_Uppercased=yes}', "");
    Expect(0, 125251, '\p{^Changes_When_Uppercased=yes}', "");
    Expect(0, 125251, '\P{Changes_When_Uppercased=yes}', "");
    Expect(1, 125251, '\P{^Changes_When_Uppercased=yes}', "");
    Expect(0, 125252, '\p{Changes_When_Uppercased=yes}', "");
    Expect(1, 125252, '\p{^Changes_When_Uppercased=yes}', "");
    Expect(1, 125252, '\P{Changes_When_Uppercased=yes}', "");
    Expect(0, 125252, '\P{^Changes_When_Uppercased=yes}', "");
    Expect(1, 125251, '\p{Changes_When_Uppercased=	yes}', "");
    Expect(0, 125251, '\p{^Changes_When_Uppercased=	yes}', "");
    Expect(0, 125251, '\P{Changes_When_Uppercased=	yes}', "");
    Expect(1, 125251, '\P{^Changes_When_Uppercased=	yes}', "");
    Expect(0, 125252, '\p{Changes_When_Uppercased=	yes}', "");
    Expect(1, 125252, '\p{^Changes_When_Uppercased=	yes}', "");
    Expect(1, 125252, '\P{Changes_When_Uppercased=	yes}', "");
    Expect(0, 125252, '\P{^Changes_When_Uppercased=	yes}', "");
    Error('\p{CWU:   :=_Y}');
    Error('\P{CWU:   :=_Y}');
    Expect(1, 125251, '\p{CWU=y}', "");
    Expect(0, 125251, '\p{^CWU=y}', "");
    Expect(0, 125251, '\P{CWU=y}', "");
    Expect(1, 125251, '\P{^CWU=y}', "");
    Expect(0, 125252, '\p{CWU=y}', "");
    Expect(1, 125252, '\p{^CWU=y}', "");
    Expect(1, 125252, '\P{CWU=y}', "");
    Expect(0, 125252, '\P{^CWU=y}', "");
    Expect(1, 125251, '\p{CWU=	 Y}', "");
    Expect(0, 125251, '\p{^CWU=	 Y}', "");
    Expect(0, 125251, '\P{CWU=	 Y}', "");
    Expect(1, 125251, '\P{^CWU=	 Y}', "");
    Expect(0, 125252, '\p{CWU=	 Y}', "");
    Expect(1, 125252, '\p{^CWU=	 Y}', "");
    Expect(1, 125252, '\P{CWU=	 Y}', "");
    Expect(0, 125252, '\P{^CWU=	 Y}', "");
    Error('\p{Is_Changes_When_Uppercased=	t:=}');
    Error('\P{Is_Changes_When_Uppercased=	t:=}');
    Expect(1, 125251, '\p{Is_Changes_When_Uppercased=t}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Uppercased=t}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Uppercased=t}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Uppercased=t}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Uppercased=t}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Uppercased=t}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Uppercased=t}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Uppercased=t}', "");
    Expect(1, 125251, '\p{Is_Changes_When_Uppercased= 	t}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Uppercased= 	t}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Uppercased= 	t}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Uppercased= 	t}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Uppercased= 	t}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Uppercased= 	t}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Uppercased= 	t}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Uppercased= 	t}', "");
    Error('\p{Is_CWU=_:=TRUE}');
    Error('\P{Is_CWU=_:=TRUE}');
    Expect(1, 125251, '\p{Is_CWU=true}', "");
    Expect(0, 125251, '\p{^Is_CWU=true}', "");
    Expect(0, 125251, '\P{Is_CWU=true}', "");
    Expect(1, 125251, '\P{^Is_CWU=true}', "");
    Expect(0, 125252, '\p{Is_CWU=true}', "");
    Expect(1, 125252, '\p{^Is_CWU=true}', "");
    Expect(1, 125252, '\P{Is_CWU=true}', "");
    Expect(0, 125252, '\P{^Is_CWU=true}', "");
    Expect(1, 125251, '\p{Is_CWU=	-TRUE}', "");
    Expect(0, 125251, '\p{^Is_CWU=	-TRUE}', "");
    Expect(0, 125251, '\P{Is_CWU=	-TRUE}', "");
    Expect(1, 125251, '\P{^Is_CWU=	-TRUE}', "");
    Expect(0, 125252, '\p{Is_CWU=	-TRUE}', "");
    Expect(1, 125252, '\p{^Is_CWU=	-TRUE}', "");
    Expect(1, 125252, '\P{Is_CWU=	-TRUE}', "");
    Expect(0, 125252, '\P{^Is_CWU=	-TRUE}', "");
    Error('\p{Dash=/a/ 	No}');
    Error('\P{Dash=/a/ 	No}');
    Expect(1, 65294, '\p{Dash=no}', "");
    Expect(0, 65294, '\p{^Dash=no}', "");
    Expect(0, 65294, '\P{Dash=no}', "");
    Expect(1, 65294, '\P{^Dash=no}', "");
    Expect(0, 65293, '\p{Dash=no}', "");
    Expect(1, 65293, '\p{^Dash=no}', "");
    Expect(1, 65293, '\P{Dash=no}', "");
    Expect(0, 65293, '\P{^Dash=no}', "");
    Expect(1, 65294, '\p{Dash=  No}', "");
    Expect(0, 65294, '\p{^Dash=  No}', "");
    Expect(0, 65294, '\P{Dash=  No}', "");
    Expect(1, 65294, '\P{^Dash=  No}', "");
    Expect(0, 65293, '\p{Dash=  No}', "");
    Expect(1, 65293, '\p{^Dash=  No}', "");
    Expect(1, 65293, '\P{Dash=  No}', "");
    Expect(0, 65293, '\P{^Dash=  No}', "");
    Error('\p{Is_Dash=	_N:=}');
    Error('\P{Is_Dash=	_N:=}');
    Expect(1, 65294, '\p{Is_Dash=n}', "");
    Expect(0, 65294, '\p{^Is_Dash=n}', "");
    Expect(0, 65294, '\P{Is_Dash=n}', "");
    Expect(1, 65294, '\P{^Is_Dash=n}', "");
    Expect(0, 65293, '\p{Is_Dash=n}', "");
    Expect(1, 65293, '\p{^Is_Dash=n}', "");
    Expect(1, 65293, '\P{Is_Dash=n}', "");
    Expect(0, 65293, '\P{^Is_Dash=n}', "");
    Expect(1, 65294, '\p{Is_Dash=-	N}', "");
    Expect(0, 65294, '\p{^Is_Dash=-	N}', "");
    Expect(0, 65294, '\P{Is_Dash=-	N}', "");
    Expect(1, 65294, '\P{^Is_Dash=-	N}', "");
    Expect(0, 65293, '\p{Is_Dash=-	N}', "");
    Expect(1, 65293, '\p{^Is_Dash=-	N}', "");
    Expect(1, 65293, '\P{Is_Dash=-	N}', "");
    Expect(0, 65293, '\P{^Is_Dash=-	N}', "");
    Error('\p{Dash=:= F}');
    Error('\P{Dash=:= F}');
    Expect(1, 65294, '\p{Dash=f}', "");
    Expect(0, 65294, '\p{^Dash=f}', "");
    Expect(0, 65294, '\P{Dash=f}', "");
    Expect(1, 65294, '\P{^Dash=f}', "");
    Expect(0, 65293, '\p{Dash=f}', "");
    Expect(1, 65293, '\p{^Dash=f}', "");
    Expect(1, 65293, '\P{Dash=f}', "");
    Expect(0, 65293, '\P{^Dash=f}', "");
    Expect(1, 65294, '\p{Dash=-f}', "");
    Expect(0, 65294, '\p{^Dash=-f}', "");
    Expect(0, 65294, '\P{Dash=-f}', "");
    Expect(1, 65294, '\P{^Dash=-f}', "");
    Expect(0, 65293, '\p{Dash=-f}', "");
    Expect(1, 65293, '\p{^Dash=-f}', "");
    Expect(1, 65293, '\P{Dash=-f}', "");
    Expect(0, 65293, '\P{^Dash=-f}', "");
    Error('\p{Is_Dash= /a/False}');
    Error('\P{Is_Dash= /a/False}');
    Expect(1, 65294, '\p{Is_Dash=false}', "");
    Expect(0, 65294, '\p{^Is_Dash=false}', "");
    Expect(0, 65294, '\P{Is_Dash=false}', "");
    Expect(1, 65294, '\P{^Is_Dash=false}', "");
    Expect(0, 65293, '\p{Is_Dash=false}', "");
    Expect(1, 65293, '\p{^Is_Dash=false}', "");
    Expect(1, 65293, '\P{Is_Dash=false}', "");
    Expect(0, 65293, '\P{^Is_Dash=false}', "");
    Expect(1, 65294, '\p{Is_Dash=-_false}', "");
    Expect(0, 65294, '\p{^Is_Dash=-_false}', "");
    Expect(0, 65294, '\P{Is_Dash=-_false}', "");
    Expect(1, 65294, '\P{^Is_Dash=-_false}', "");
    Expect(0, 65293, '\p{Is_Dash=-_false}', "");
    Expect(1, 65293, '\p{^Is_Dash=-_false}', "");
    Expect(1, 65293, '\P{Is_Dash=-_false}', "");
    Expect(0, 65293, '\P{^Is_Dash=-_false}', "");
    Error('\p{Dash=_-Yes/a/}');
    Error('\P{Dash=_-Yes/a/}');
    Expect(1, 65293, '\p{Dash=yes}', "");
    Expect(0, 65293, '\p{^Dash=yes}', "");
    Expect(0, 65293, '\P{Dash=yes}', "");
    Expect(1, 65293, '\P{^Dash=yes}', "");
    Expect(0, 65294, '\p{Dash=yes}', "");
    Expect(1, 65294, '\p{^Dash=yes}', "");
    Expect(1, 65294, '\P{Dash=yes}', "");
    Expect(0, 65294, '\P{^Dash=yes}', "");
    Expect(1, 65293, '\p{Dash=-YES}', "");
    Expect(0, 65293, '\p{^Dash=-YES}', "");
    Expect(0, 65293, '\P{Dash=-YES}', "");
    Expect(1, 65293, '\P{^Dash=-YES}', "");
    Expect(0, 65294, '\p{Dash=-YES}', "");
    Expect(1, 65294, '\p{^Dash=-YES}', "");
    Expect(1, 65294, '\P{Dash=-YES}', "");
    Expect(0, 65294, '\P{^Dash=-YES}', "");
    Error('\p{Is_Dash=- Y/a/}');
    Error('\P{Is_Dash=- Y/a/}');
    Expect(1, 65293, '\p{Is_Dash=y}', "");
    Expect(0, 65293, '\p{^Is_Dash=y}', "");
    Expect(0, 65293, '\P{Is_Dash=y}', "");
    Expect(1, 65293, '\P{^Is_Dash=y}', "");
    Expect(0, 65294, '\p{Is_Dash=y}', "");
    Expect(1, 65294, '\p{^Is_Dash=y}', "");
    Expect(1, 65294, '\P{Is_Dash=y}', "");
    Expect(0, 65294, '\P{^Is_Dash=y}', "");
    Expect(1, 65293, '\p{Is_Dash=	Y}', "");
    Expect(0, 65293, '\p{^Is_Dash=	Y}', "");
    Expect(0, 65293, '\P{Is_Dash=	Y}', "");
    Expect(1, 65293, '\P{^Is_Dash=	Y}', "");
    Expect(0, 65294, '\p{Is_Dash=	Y}', "");
    Expect(1, 65294, '\p{^Is_Dash=	Y}', "");
    Expect(1, 65294, '\P{Is_Dash=	Y}', "");
    Expect(0, 65294, '\P{^Is_Dash=	Y}', "");
    Error('\p{Dash:  :=T}');
    Error('\P{Dash:  :=T}');
    Expect(1, 65293, '\p{Dash=t}', "");
    Expect(0, 65293, '\p{^Dash=t}', "");
    Expect(0, 65293, '\P{Dash=t}', "");
    Expect(1, 65293, '\P{^Dash=t}', "");
    Expect(0, 65294, '\p{Dash=t}', "");
    Expect(1, 65294, '\p{^Dash=t}', "");
    Expect(1, 65294, '\P{Dash=t}', "");
    Expect(0, 65294, '\P{^Dash=t}', "");
    Expect(1, 65293, '\p{Dash=__T}', "");
    Expect(0, 65293, '\p{^Dash=__T}', "");
    Expect(0, 65293, '\P{Dash=__T}', "");
    Expect(1, 65293, '\P{^Dash=__T}', "");
    Expect(0, 65294, '\p{Dash=__T}', "");
    Expect(1, 65294, '\p{^Dash=__T}', "");
    Expect(1, 65294, '\P{Dash=__T}', "");
    Expect(0, 65294, '\P{^Dash=__T}', "");
    Error('\p{Is_Dash= :=TRUE}');
    Error('\P{Is_Dash= :=TRUE}');
    Expect(1, 65293, '\p{Is_Dash=true}', "");
    Expect(0, 65293, '\p{^Is_Dash=true}', "");
    Expect(0, 65293, '\P{Is_Dash=true}', "");
    Expect(1, 65293, '\P{^Is_Dash=true}', "");
    Expect(0, 65294, '\p{Is_Dash=true}', "");
    Expect(1, 65294, '\p{^Is_Dash=true}', "");
    Expect(1, 65294, '\P{Is_Dash=true}', "");
    Expect(0, 65294, '\P{^Is_Dash=true}', "");
    Expect(1, 65293, '\p{Is_Dash= -True}', "");
    Expect(0, 65293, '\p{^Is_Dash= -True}', "");
    Expect(0, 65293, '\P{Is_Dash= -True}', "");
    Expect(1, 65293, '\P{^Is_Dash= -True}', "");
    Expect(0, 65294, '\p{Is_Dash= -True}', "");
    Expect(1, 65294, '\p{^Is_Dash= -True}', "");
    Expect(1, 65294, '\P{Is_Dash= -True}', "");
    Expect(0, 65294, '\P{^Is_Dash= -True}', "");
    Error('\p{Deprecated=	No:=}');
    Error('\P{Deprecated=	No:=}');
    Expect(1, 917506, '\p{Deprecated=no}', "");
    Expect(0, 917506, '\p{^Deprecated=no}', "");
    Expect(0, 917506, '\P{Deprecated=no}', "");
    Expect(1, 917506, '\P{^Deprecated=no}', "");
    Expect(0, 917505, '\p{Deprecated=no}', "");
    Expect(1, 917505, '\p{^Deprecated=no}', "");
    Expect(1, 917505, '\P{Deprecated=no}', "");
    Expect(0, 917505, '\P{^Deprecated=no}', "");
    Expect(1, 917506, '\p{Deprecated=-_No}', "");
    Expect(0, 917506, '\p{^Deprecated=-_No}', "");
    Expect(0, 917506, '\P{Deprecated=-_No}', "");
    Expect(1, 917506, '\P{^Deprecated=-_No}', "");
    Expect(0, 917505, '\p{Deprecated=-_No}', "");
    Expect(1, 917505, '\p{^Deprecated=-_No}', "");
    Expect(1, 917505, '\P{Deprecated=-_No}', "");
    Expect(0, 917505, '\P{^Deprecated=-_No}', "");
    Error('\p{Dep:	_/a/n}');
    Error('\P{Dep:	_/a/n}');
    Expect(1, 917506, '\p{Dep=n}', "");
    Expect(0, 917506, '\p{^Dep=n}', "");
    Expect(0, 917506, '\P{Dep=n}', "");
    Expect(1, 917506, '\P{^Dep=n}', "");
    Expect(0, 917505, '\p{Dep=n}', "");
    Expect(1, 917505, '\p{^Dep=n}', "");
    Expect(1, 917505, '\P{Dep=n}', "");
    Expect(0, 917505, '\P{^Dep=n}', "");
    Expect(1, 917506, '\p{Dep= 	n}', "");
    Expect(0, 917506, '\p{^Dep= 	n}', "");
    Expect(0, 917506, '\P{Dep= 	n}', "");
    Expect(1, 917506, '\P{^Dep= 	n}', "");
    Expect(0, 917505, '\p{Dep= 	n}', "");
    Expect(1, 917505, '\p{^Dep= 	n}', "");
    Expect(1, 917505, '\P{Dep= 	n}', "");
    Expect(0, 917505, '\P{^Dep= 	n}', "");
    Error('\p{Is_Deprecated=/a/	 F}');
    Error('\P{Is_Deprecated=/a/	 F}');
    Expect(1, 917506, '\p{Is_Deprecated=f}', "");
    Expect(0, 917506, '\p{^Is_Deprecated=f}', "");
    Expect(0, 917506, '\P{Is_Deprecated=f}', "");
    Expect(1, 917506, '\P{^Is_Deprecated=f}', "");
    Expect(0, 917505, '\p{Is_Deprecated=f}', "");
    Expect(1, 917505, '\p{^Is_Deprecated=f}', "");
    Expect(1, 917505, '\P{Is_Deprecated=f}', "");
    Expect(0, 917505, '\P{^Is_Deprecated=f}', "");
    Expect(1, 917506, '\p{Is_Deprecated:    -F}', "");
    Expect(0, 917506, '\p{^Is_Deprecated:    -F}', "");
    Expect(0, 917506, '\P{Is_Deprecated:    -F}', "");
    Expect(1, 917506, '\P{^Is_Deprecated:    -F}', "");
    Expect(0, 917505, '\p{Is_Deprecated:    -F}', "");
    Expect(1, 917505, '\p{^Is_Deprecated:    -F}', "");
    Expect(1, 917505, '\P{Is_Deprecated:    -F}', "");
    Expect(0, 917505, '\P{^Is_Deprecated:    -F}', "");
    Error('\p{Is_Dep: :=- false}');
    Error('\P{Is_Dep: :=- false}');
    Expect(1, 917506, '\p{Is_Dep=false}', "");
    Expect(0, 917506, '\p{^Is_Dep=false}', "");
    Expect(0, 917506, '\P{Is_Dep=false}', "");
    Expect(1, 917506, '\P{^Is_Dep=false}', "");
    Expect(0, 917505, '\p{Is_Dep=false}', "");
    Expect(1, 917505, '\p{^Is_Dep=false}', "");
    Expect(1, 917505, '\P{Is_Dep=false}', "");
    Expect(0, 917505, '\P{^Is_Dep=false}', "");
    Expect(1, 917506, '\p{Is_Dep=	 False}', "");
    Expect(0, 917506, '\p{^Is_Dep=	 False}', "");
    Expect(0, 917506, '\P{Is_Dep=	 False}', "");
    Expect(1, 917506, '\P{^Is_Dep=	 False}', "");
    Expect(0, 917505, '\p{Is_Dep=	 False}', "");
    Expect(1, 917505, '\p{^Is_Dep=	 False}', "");
    Expect(1, 917505, '\P{Is_Dep=	 False}', "");
    Expect(0, 917505, '\P{^Is_Dep=	 False}', "");
    Error('\p{Deprecated=:=YES}');
    Error('\P{Deprecated=:=YES}');
    Expect(1, 917505, '\p{Deprecated=yes}', "");
    Expect(0, 917505, '\p{^Deprecated=yes}', "");
    Expect(0, 917505, '\P{Deprecated=yes}', "");
    Expect(1, 917505, '\P{^Deprecated=yes}', "");
    Expect(0, 917506, '\p{Deprecated=yes}', "");
    Expect(1, 917506, '\p{^Deprecated=yes}', "");
    Expect(1, 917506, '\P{Deprecated=yes}', "");
    Expect(0, 917506, '\P{^Deprecated=yes}', "");
    Expect(1, 917505, '\p{Deprecated=_	Yes}', "");
    Expect(0, 917505, '\p{^Deprecated=_	Yes}', "");
    Expect(0, 917505, '\P{Deprecated=_	Yes}', "");
    Expect(1, 917505, '\P{^Deprecated=_	Yes}', "");
    Expect(0, 917506, '\p{Deprecated=_	Yes}', "");
    Expect(1, 917506, '\p{^Deprecated=_	Yes}', "");
    Expect(1, 917506, '\P{Deprecated=_	Yes}', "");
    Expect(0, 917506, '\P{^Deprecated=_	Yes}', "");
    Error('\p{Dep= Y/a/}');
    Error('\P{Dep= Y/a/}');
    Expect(1, 917505, '\p{Dep=y}', "");
    Expect(0, 917505, '\p{^Dep=y}', "");
    Expect(0, 917505, '\P{Dep=y}', "");
    Expect(1, 917505, '\P{^Dep=y}', "");
    Expect(0, 917506, '\p{Dep=y}', "");
    Expect(1, 917506, '\p{^Dep=y}', "");
    Expect(1, 917506, '\P{Dep=y}', "");
    Expect(0, 917506, '\P{^Dep=y}', "");
    Expect(1, 917505, '\p{Dep=_Y}', "");
    Expect(0, 917505, '\p{^Dep=_Y}', "");
    Expect(0, 917505, '\P{Dep=_Y}', "");
    Expect(1, 917505, '\P{^Dep=_Y}', "");
    Expect(0, 917506, '\p{Dep=_Y}', "");
    Expect(1, 917506, '\p{^Dep=_Y}', "");
    Expect(1, 917506, '\P{Dep=_Y}', "");
    Expect(0, 917506, '\P{^Dep=_Y}', "");
    Error('\p{Is_Deprecated: _/a/T}');
    Error('\P{Is_Deprecated: _/a/T}');
    Expect(1, 917505, '\p{Is_Deprecated:   t}', "");
    Expect(0, 917505, '\p{^Is_Deprecated:   t}', "");
    Expect(0, 917505, '\P{Is_Deprecated:   t}', "");
    Expect(1, 917505, '\P{^Is_Deprecated:   t}', "");
    Expect(0, 917506, '\p{Is_Deprecated:   t}', "");
    Expect(1, 917506, '\p{^Is_Deprecated:   t}', "");
    Expect(1, 917506, '\P{Is_Deprecated:   t}', "");
    Expect(0, 917506, '\P{^Is_Deprecated:   t}', "");
    Expect(1, 917505, '\p{Is_Deprecated=-_T}', "");
    Expect(0, 917505, '\p{^Is_Deprecated=-_T}', "");
    Expect(0, 917505, '\P{Is_Deprecated=-_T}', "");
    Expect(1, 917505, '\P{^Is_Deprecated=-_T}', "");
    Expect(0, 917506, '\p{Is_Deprecated=-_T}', "");
    Expect(1, 917506, '\p{^Is_Deprecated=-_T}', "");
    Expect(1, 917506, '\P{Is_Deprecated=-_T}', "");
    Expect(0, 917506, '\P{^Is_Deprecated=-_T}', "");
    Error('\p{Is_Dep=	TRUE:=}');
    Error('\P{Is_Dep=	TRUE:=}');
    Expect(1, 917505, '\p{Is_Dep=true}', "");
    Expect(0, 917505, '\p{^Is_Dep=true}', "");
    Expect(0, 917505, '\P{Is_Dep=true}', "");
    Expect(1, 917505, '\P{^Is_Dep=true}', "");
    Expect(0, 917506, '\p{Is_Dep=true}', "");
    Expect(1, 917506, '\p{^Is_Dep=true}', "");
    Expect(1, 917506, '\P{Is_Dep=true}', "");
    Expect(0, 917506, '\P{^Is_Dep=true}', "");
    Expect(1, 917505, '\p{Is_Dep=_	TRUE}', "");
    Expect(0, 917505, '\p{^Is_Dep=_	TRUE}', "");
    Expect(0, 917505, '\P{Is_Dep=_	TRUE}', "");
    Expect(1, 917505, '\P{^Is_Dep=_	TRUE}', "");
    Expect(0, 917506, '\p{Is_Dep=_	TRUE}', "");
    Expect(1, 917506, '\p{^Is_Dep=_	TRUE}', "");
    Expect(1, 917506, '\P{Is_Dep=_	TRUE}', "");
    Expect(0, 917506, '\P{^Is_Dep=_	TRUE}', "");
    Error('\p{Default_Ignorable_Code_Point=/a/-No}');
    Error('\P{Default_Ignorable_Code_Point=/a/-No}');
    Expect(1, 921600, '\p{Default_Ignorable_Code_Point=no}', "");
    Expect(0, 921600, '\p{^Default_Ignorable_Code_Point=no}', "");
    Expect(0, 921600, '\P{Default_Ignorable_Code_Point=no}', "");
    Expect(1, 921600, '\P{^Default_Ignorable_Code_Point=no}', "");
    Expect(0, 921599, '\p{Default_Ignorable_Code_Point=no}', "");
    Expect(1, 921599, '\p{^Default_Ignorable_Code_Point=no}', "");
    Expect(1, 921599, '\P{Default_Ignorable_Code_Point=no}', "");
    Expect(0, 921599, '\P{^Default_Ignorable_Code_Point=no}', "");
    Expect(1, 921600, '\p{Default_Ignorable_Code_Point=_-no}', "");
    Expect(0, 921600, '\p{^Default_Ignorable_Code_Point=_-no}', "");
    Expect(0, 921600, '\P{Default_Ignorable_Code_Point=_-no}', "");
    Expect(1, 921600, '\P{^Default_Ignorable_Code_Point=_-no}', "");
    Expect(0, 921599, '\p{Default_Ignorable_Code_Point=_-no}', "");
    Expect(1, 921599, '\p{^Default_Ignorable_Code_Point=_-no}', "");
    Expect(1, 921599, '\P{Default_Ignorable_Code_Point=_-no}', "");
    Expect(0, 921599, '\P{^Default_Ignorable_Code_Point=_-no}', "");
    Error('\p{DI= -n/a/}');
    Error('\P{DI= -n/a/}');
    Expect(1, 921600, '\p{DI=n}', "");
    Expect(0, 921600, '\p{^DI=n}', "");
    Expect(0, 921600, '\P{DI=n}', "");
    Expect(1, 921600, '\P{^DI=n}', "");
    Expect(0, 921599, '\p{DI=n}', "");
    Expect(1, 921599, '\p{^DI=n}', "");
    Expect(1, 921599, '\P{DI=n}', "");
    Expect(0, 921599, '\P{^DI=n}', "");
    Expect(1, 921600, '\p{DI=_N}', "");
    Expect(0, 921600, '\p{^DI=_N}', "");
    Expect(0, 921600, '\P{DI=_N}', "");
    Expect(1, 921600, '\P{^DI=_N}', "");
    Expect(0, 921599, '\p{DI=_N}', "");
    Expect(1, 921599, '\p{^DI=_N}', "");
    Expect(1, 921599, '\P{DI=_N}', "");
    Expect(0, 921599, '\P{^DI=_N}', "");
    Error('\p{Is_Default_Ignorable_Code_Point= :=f}');
    Error('\P{Is_Default_Ignorable_Code_Point= :=f}');
    Expect(1, 921600, '\p{Is_Default_Ignorable_Code_Point=f}', "");
    Expect(0, 921600, '\p{^Is_Default_Ignorable_Code_Point=f}', "");
    Expect(0, 921600, '\P{Is_Default_Ignorable_Code_Point=f}', "");
    Expect(1, 921600, '\P{^Is_Default_Ignorable_Code_Point=f}', "");
    Expect(0, 921599, '\p{Is_Default_Ignorable_Code_Point=f}', "");
    Expect(1, 921599, '\p{^Is_Default_Ignorable_Code_Point=f}', "");
    Expect(1, 921599, '\P{Is_Default_Ignorable_Code_Point=f}', "");
    Expect(0, 921599, '\P{^Is_Default_Ignorable_Code_Point=f}', "");
    Expect(1, 921600, '\p{Is_Default_Ignorable_Code_Point= _F}', "");
    Expect(0, 921600, '\p{^Is_Default_Ignorable_Code_Point= _F}', "");
    Expect(0, 921600, '\P{Is_Default_Ignorable_Code_Point= _F}', "");
    Expect(1, 921600, '\P{^Is_Default_Ignorable_Code_Point= _F}', "");
    Expect(0, 921599, '\p{Is_Default_Ignorable_Code_Point= _F}', "");
    Expect(1, 921599, '\p{^Is_Default_Ignorable_Code_Point= _F}', "");
    Expect(1, 921599, '\P{Is_Default_Ignorable_Code_Point= _F}', "");
    Expect(0, 921599, '\P{^Is_Default_Ignorable_Code_Point= _F}', "");
    Error('\p{Is_DI=:=	_False}');
    Error('\P{Is_DI=:=	_False}');
    Expect(1, 921600, '\p{Is_DI=false}', "");
    Expect(0, 921600, '\p{^Is_DI=false}', "");
    Expect(0, 921600, '\P{Is_DI=false}', "");
    Expect(1, 921600, '\P{^Is_DI=false}', "");
    Expect(0, 921599, '\p{Is_DI=false}', "");
    Expect(1, 921599, '\p{^Is_DI=false}', "");
    Expect(1, 921599, '\P{Is_DI=false}', "");
    Expect(0, 921599, '\P{^Is_DI=false}', "");
    Expect(1, 921600, '\p{Is_DI=_	false}', "");
    Expect(0, 921600, '\p{^Is_DI=_	false}', "");
    Expect(0, 921600, '\P{Is_DI=_	false}', "");
    Expect(1, 921600, '\P{^Is_DI=_	false}', "");
    Expect(0, 921599, '\p{Is_DI=_	false}', "");
    Expect(1, 921599, '\p{^Is_DI=_	false}', "");
    Expect(1, 921599, '\P{Is_DI=_	false}', "");
    Expect(0, 921599, '\P{^Is_DI=_	false}', "");
    Error('\p{Default_Ignorable_Code_Point= yes:=}');
    Error('\P{Default_Ignorable_Code_Point= yes:=}');
    Expect(1, 921599, '\p{Default_Ignorable_Code_Point=yes}', "");
    Expect(0, 921599, '\p{^Default_Ignorable_Code_Point=yes}', "");
    Expect(0, 921599, '\P{Default_Ignorable_Code_Point=yes}', "");
    Expect(1, 921599, '\P{^Default_Ignorable_Code_Point=yes}', "");
    Expect(0, 921600, '\p{Default_Ignorable_Code_Point=yes}', "");
    Expect(1, 921600, '\p{^Default_Ignorable_Code_Point=yes}', "");
    Expect(1, 921600, '\P{Default_Ignorable_Code_Point=yes}', "");
    Expect(0, 921600, '\P{^Default_Ignorable_Code_Point=yes}', "");
    Expect(1, 921599, '\p{Default_Ignorable_Code_Point:  	Yes}', "");
    Expect(0, 921599, '\p{^Default_Ignorable_Code_Point:  	Yes}', "");
    Expect(0, 921599, '\P{Default_Ignorable_Code_Point:  	Yes}', "");
    Expect(1, 921599, '\P{^Default_Ignorable_Code_Point:  	Yes}', "");
    Expect(0, 921600, '\p{Default_Ignorable_Code_Point:  	Yes}', "");
    Expect(1, 921600, '\p{^Default_Ignorable_Code_Point:  	Yes}', "");
    Expect(1, 921600, '\P{Default_Ignorable_Code_Point:  	Yes}', "");
    Expect(0, 921600, '\P{^Default_Ignorable_Code_Point:  	Yes}', "");
    Error('\p{DI=-_Y/a/}');
    Error('\P{DI=-_Y/a/}');
    Expect(1, 921599, '\p{DI=y}', "");
    Expect(0, 921599, '\p{^DI=y}', "");
    Expect(0, 921599, '\P{DI=y}', "");
    Expect(1, 921599, '\P{^DI=y}', "");
    Expect(0, 921600, '\p{DI=y}', "");
    Expect(1, 921600, '\p{^DI=y}', "");
    Expect(1, 921600, '\P{DI=y}', "");
    Expect(0, 921600, '\P{^DI=y}', "");
    Expect(1, 921599, '\p{DI= 	y}', "");
    Expect(0, 921599, '\p{^DI= 	y}', "");
    Expect(0, 921599, '\P{DI= 	y}', "");
    Expect(1, 921599, '\P{^DI= 	y}', "");
    Expect(0, 921600, '\p{DI= 	y}', "");
    Expect(1, 921600, '\p{^DI= 	y}', "");
    Expect(1, 921600, '\P{DI= 	y}', "");
    Expect(0, 921600, '\P{^DI= 	y}', "");
    Error('\p{Is_Default_Ignorable_Code_Point=_:=T}');
    Error('\P{Is_Default_Ignorable_Code_Point=_:=T}');
    Expect(1, 921599, '\p{Is_Default_Ignorable_Code_Point=t}', "");
    Expect(0, 921599, '\p{^Is_Default_Ignorable_Code_Point=t}', "");
    Expect(0, 921599, '\P{Is_Default_Ignorable_Code_Point=t}', "");
    Expect(1, 921599, '\P{^Is_Default_Ignorable_Code_Point=t}', "");
    Expect(0, 921600, '\p{Is_Default_Ignorable_Code_Point=t}', "");
    Expect(1, 921600, '\p{^Is_Default_Ignorable_Code_Point=t}', "");
    Expect(1, 921600, '\P{Is_Default_Ignorable_Code_Point=t}', "");
    Expect(0, 921600, '\P{^Is_Default_Ignorable_Code_Point=t}', "");
    Expect(1, 921599, '\p{Is_Default_Ignorable_Code_Point:   	t}', "");
    Expect(0, 921599, '\p{^Is_Default_Ignorable_Code_Point:   	t}', "");
    Expect(0, 921599, '\P{Is_Default_Ignorable_Code_Point:   	t}', "");
    Expect(1, 921599, '\P{^Is_Default_Ignorable_Code_Point:   	t}', "");
    Expect(0, 921600, '\p{Is_Default_Ignorable_Code_Point:   	t}', "");
    Expect(1, 921600, '\p{^Is_Default_Ignorable_Code_Point:   	t}', "");
    Expect(1, 921600, '\P{Is_Default_Ignorable_Code_Point:   	t}', "");
    Expect(0, 921600, '\P{^Is_Default_Ignorable_Code_Point:   	t}', "");
    Error('\p{Is_DI=-/a/TRUE}');
    Error('\P{Is_DI=-/a/TRUE}');
    Expect(1, 921599, '\p{Is_DI=true}', "");
    Expect(0, 921599, '\p{^Is_DI=true}', "");
    Expect(0, 921599, '\P{Is_DI=true}', "");
    Expect(1, 921599, '\P{^Is_DI=true}', "");
    Expect(0, 921600, '\p{Is_DI=true}', "");
    Expect(1, 921600, '\p{^Is_DI=true}', "");
    Expect(1, 921600, '\P{Is_DI=true}', "");
    Expect(0, 921600, '\P{^Is_DI=true}', "");
    Expect(1, 921599, '\p{Is_DI=_True}', "");
    Expect(0, 921599, '\p{^Is_DI=_True}', "");
    Expect(0, 921599, '\P{Is_DI=_True}', "");
    Expect(1, 921599, '\P{^Is_DI=_True}', "");
    Expect(0, 921600, '\p{Is_DI=_True}', "");
    Expect(1, 921600, '\p{^Is_DI=_True}', "");
    Expect(1, 921600, '\P{Is_DI=_True}', "");
    Expect(0, 921600, '\P{^Is_DI=_True}', "");
    Error('\p{Diacritic::=__NO}');
    Error('\P{Diacritic::=__NO}');
    Expect(1, 125259, '\p{Diacritic=no}', "");
    Expect(0, 125259, '\p{^Diacritic=no}', "");
    Expect(0, 125259, '\P{Diacritic=no}', "");
    Expect(1, 125259, '\P{^Diacritic=no}', "");
    Expect(0, 125258, '\p{Diacritic=no}', "");
    Expect(1, 125258, '\p{^Diacritic=no}', "");
    Expect(1, 125258, '\P{Diacritic=no}', "");
    Expect(0, 125258, '\P{^Diacritic=no}', "");
    Expect(1, 125259, '\p{Diacritic:     no}', "");
    Expect(0, 125259, '\p{^Diacritic:     no}', "");
    Expect(0, 125259, '\P{Diacritic:     no}', "");
    Expect(1, 125259, '\P{^Diacritic:     no}', "");
    Expect(0, 125258, '\p{Diacritic:     no}', "");
    Expect(1, 125258, '\p{^Diacritic:     no}', "");
    Expect(1, 125258, '\P{Diacritic:     no}', "");
    Expect(0, 125258, '\P{^Diacritic:     no}', "");
    Error('\p{Dia=		N:=}');
    Error('\P{Dia=		N:=}');
    Expect(1, 125259, '\p{Dia=n}', "");
    Expect(0, 125259, '\p{^Dia=n}', "");
    Expect(0, 125259, '\P{Dia=n}', "");
    Expect(1, 125259, '\P{^Dia=n}', "");
    Expect(0, 125258, '\p{Dia=n}', "");
    Expect(1, 125258, '\p{^Dia=n}', "");
    Expect(1, 125258, '\P{Dia=n}', "");
    Expect(0, 125258, '\P{^Dia=n}', "");
    Expect(1, 125259, '\p{Dia: _N}', "");
    Expect(0, 125259, '\p{^Dia: _N}', "");
    Expect(0, 125259, '\P{Dia: _N}', "");
    Expect(1, 125259, '\P{^Dia: _N}', "");
    Expect(0, 125258, '\p{Dia: _N}', "");
    Expect(1, 125258, '\p{^Dia: _N}', "");
    Expect(1, 125258, '\P{Dia: _N}', "");
    Expect(0, 125258, '\P{^Dia: _N}', "");
    Error('\p{Is_Diacritic=F:=}');
    Error('\P{Is_Diacritic=F:=}');
    Expect(1, 125259, '\p{Is_Diacritic=f}', "");
    Expect(0, 125259, '\p{^Is_Diacritic=f}', "");
    Expect(0, 125259, '\P{Is_Diacritic=f}', "");
    Expect(1, 125259, '\P{^Is_Diacritic=f}', "");
    Expect(0, 125258, '\p{Is_Diacritic=f}', "");
    Expect(1, 125258, '\p{^Is_Diacritic=f}', "");
    Expect(1, 125258, '\P{Is_Diacritic=f}', "");
    Expect(0, 125258, '\P{^Is_Diacritic=f}', "");
    Expect(1, 125259, '\p{Is_Diacritic=	 F}', "");
    Expect(0, 125259, '\p{^Is_Diacritic=	 F}', "");
    Expect(0, 125259, '\P{Is_Diacritic=	 F}', "");
    Expect(1, 125259, '\P{^Is_Diacritic=	 F}', "");
    Expect(0, 125258, '\p{Is_Diacritic=	 F}', "");
    Expect(1, 125258, '\p{^Is_Diacritic=	 F}', "");
    Expect(1, 125258, '\P{Is_Diacritic=	 F}', "");
    Expect(0, 125258, '\P{^Is_Diacritic=	 F}', "");
    Error('\p{Is_Dia=	-False:=}');
    Error('\P{Is_Dia=	-False:=}');
    Expect(1, 125259, '\p{Is_Dia=false}', "");
    Expect(0, 125259, '\p{^Is_Dia=false}', "");
    Expect(0, 125259, '\P{Is_Dia=false}', "");
    Expect(1, 125259, '\P{^Is_Dia=false}', "");
    Expect(0, 125258, '\p{Is_Dia=false}', "");
    Expect(1, 125258, '\p{^Is_Dia=false}', "");
    Expect(1, 125258, '\P{Is_Dia=false}', "");
    Expect(0, 125258, '\P{^Is_Dia=false}', "");
    Expect(1, 125259, '\p{Is_Dia=-FALSE}', "");
    Expect(0, 125259, '\p{^Is_Dia=-FALSE}', "");
    Expect(0, 125259, '\P{Is_Dia=-FALSE}', "");
    Expect(1, 125259, '\P{^Is_Dia=-FALSE}', "");
    Expect(0, 125258, '\p{Is_Dia=-FALSE}', "");
    Expect(1, 125258, '\p{^Is_Dia=-FALSE}', "");
    Expect(1, 125258, '\P{Is_Dia=-FALSE}', "");
    Expect(0, 125258, '\P{^Is_Dia=-FALSE}', "");
    Error('\p{Diacritic=_	YES/a/}');
    Error('\P{Diacritic=_	YES/a/}');
    Expect(1, 125258, '\p{Diacritic=yes}', "");
    Expect(0, 125258, '\p{^Diacritic=yes}', "");
    Expect(0, 125258, '\P{Diacritic=yes}', "");
    Expect(1, 125258, '\P{^Diacritic=yes}', "");
    Expect(0, 125259, '\p{Diacritic=yes}', "");
    Expect(1, 125259, '\p{^Diacritic=yes}', "");
    Expect(1, 125259, '\P{Diacritic=yes}', "");
    Expect(0, 125259, '\P{^Diacritic=yes}', "");
    Expect(1, 125258, '\p{Diacritic=-Yes}', "");
    Expect(0, 125258, '\p{^Diacritic=-Yes}', "");
    Expect(0, 125258, '\P{Diacritic=-Yes}', "");
    Expect(1, 125258, '\P{^Diacritic=-Yes}', "");
    Expect(0, 125259, '\p{Diacritic=-Yes}', "");
    Expect(1, 125259, '\p{^Diacritic=-Yes}', "");
    Expect(1, 125259, '\P{Diacritic=-Yes}', "");
    Expect(0, 125259, '\P{^Diacritic=-Yes}', "");
    Error('\p{Dia=/a/-	y}');
    Error('\P{Dia=/a/-	y}');
    Expect(1, 125258, '\p{Dia=y}', "");
    Expect(0, 125258, '\p{^Dia=y}', "");
    Expect(0, 125258, '\P{Dia=y}', "");
    Expect(1, 125258, '\P{^Dia=y}', "");
    Expect(0, 125259, '\p{Dia=y}', "");
    Expect(1, 125259, '\p{^Dia=y}', "");
    Expect(1, 125259, '\P{Dia=y}', "");
    Expect(0, 125259, '\P{^Dia=y}', "");
    Expect(1, 125258, '\p{Dia=	 Y}', "");
    Expect(0, 125258, '\p{^Dia=	 Y}', "");
    Expect(0, 125258, '\P{Dia=	 Y}', "");
    Expect(1, 125258, '\P{^Dia=	 Y}', "");
    Expect(0, 125259, '\p{Dia=	 Y}', "");
    Expect(1, 125259, '\p{^Dia=	 Y}', "");
    Expect(1, 125259, '\P{Dia=	 Y}', "");
    Expect(0, 125259, '\P{^Dia=	 Y}', "");
    Error('\p{Is_Diacritic=/a/	 T}');
    Error('\P{Is_Diacritic=/a/	 T}');
    Expect(1, 125258, '\p{Is_Diacritic=t}', "");
    Expect(0, 125258, '\p{^Is_Diacritic=t}', "");
    Expect(0, 125258, '\P{Is_Diacritic=t}', "");
    Expect(1, 125258, '\P{^Is_Diacritic=t}', "");
    Expect(0, 125259, '\p{Is_Diacritic=t}', "");
    Expect(1, 125259, '\p{^Is_Diacritic=t}', "");
    Expect(1, 125259, '\P{Is_Diacritic=t}', "");
    Expect(0, 125259, '\P{^Is_Diacritic=t}', "");
    Expect(1, 125258, '\p{Is_Diacritic:   _	T}', "");
    Expect(0, 125258, '\p{^Is_Diacritic:   _	T}', "");
    Expect(0, 125258, '\P{Is_Diacritic:   _	T}', "");
    Expect(1, 125258, '\P{^Is_Diacritic:   _	T}', "");
    Expect(0, 125259, '\p{Is_Diacritic:   _	T}', "");
    Expect(1, 125259, '\p{^Is_Diacritic:   _	T}', "");
    Expect(1, 125259, '\P{Is_Diacritic:   _	T}', "");
    Expect(0, 125259, '\P{^Is_Diacritic:   _	T}', "");
    Error('\p{Is_Dia:-	TRUE:=}');
    Error('\P{Is_Dia:-	TRUE:=}');
    Expect(1, 125258, '\p{Is_Dia=true}', "");
    Expect(0, 125258, '\p{^Is_Dia=true}', "");
    Expect(0, 125258, '\P{Is_Dia=true}', "");
    Expect(1, 125258, '\P{^Is_Dia=true}', "");
    Expect(0, 125259, '\p{Is_Dia=true}', "");
    Expect(1, 125259, '\p{^Is_Dia=true}', "");
    Expect(1, 125259, '\P{Is_Dia=true}', "");
    Expect(0, 125259, '\P{^Is_Dia=true}', "");
    Expect(1, 125258, '\p{Is_Dia=_True}', "");
    Expect(0, 125258, '\p{^Is_Dia=_True}', "");
    Expect(0, 125258, '\P{Is_Dia=_True}', "");
    Expect(1, 125258, '\P{^Is_Dia=_True}', "");
    Expect(0, 125259, '\p{Is_Dia=_True}', "");
    Expect(1, 125259, '\p{^Is_Dia=_True}', "");
    Expect(1, 125259, '\P{Is_Dia=_True}', "");
    Expect(0, 125259, '\P{^Is_Dia=_True}', "");
    Error('\p{decompositionmapping}');
    Error('\P{decompositionmapping}');
    Error('\p{dm}');
    Error('\P{dm}');
    Error('\p{decompositiontype}');
    Error('\P{decompositiontype}');
    Error('\p{dt}');
    Error('\P{dt}');
    Error('\p{Decomposition_Type=:=		canonical}');
    Error('\P{Decomposition_Type=:=		canonical}');
    Expect(1, 195101, '\p{Decomposition_Type:canonical}', "");
    Expect(0, 195101, '\p{^Decomposition_Type:canonical}', "");
    Expect(0, 195101, '\P{Decomposition_Type:canonical}', "");
    Expect(1, 195101, '\P{^Decomposition_Type:canonical}', "");
    Expect(0, 195102, '\p{Decomposition_Type:canonical}', "");
    Expect(1, 195102, '\p{^Decomposition_Type:canonical}', "");
    Expect(1, 195102, '\P{Decomposition_Type:canonical}', "");
    Expect(0, 195102, '\P{^Decomposition_Type:canonical}', "");
    Expect(1, 195101, '\p{Decomposition_Type=	 Canonical}', "");
    Expect(0, 195101, '\p{^Decomposition_Type=	 Canonical}', "");
    Expect(0, 195101, '\P{Decomposition_Type=	 Canonical}', "");
    Expect(1, 195101, '\P{^Decomposition_Type=	 Canonical}', "");
    Expect(0, 195102, '\p{Decomposition_Type=	 Canonical}', "");
    Expect(1, 195102, '\p{^Decomposition_Type=	 Canonical}', "");
    Expect(1, 195102, '\P{Decomposition_Type=	 Canonical}', "");
    Expect(0, 195102, '\P{^Decomposition_Type=	 Canonical}', "");
    Error('\p{Dt=_ CAN/a/}');
    Error('\P{Dt=_ CAN/a/}');
    Expect(1, 195101, '\p{Dt: can}', "");
    Expect(0, 195101, '\p{^Dt: can}', "");
    Expect(0, 195101, '\P{Dt: can}', "");
    Expect(1, 195101, '\P{^Dt: can}', "");
    Expect(0, 195102, '\p{Dt: can}', "");
    Expect(1, 195102, '\p{^Dt: can}', "");
    Expect(1, 195102, '\P{Dt: can}', "");
    Expect(0, 195102, '\P{^Dt: can}', "");
    Expect(1, 195101, '\p{Dt=_	Can}', "");
    Expect(0, 195101, '\p{^Dt=_	Can}', "");
    Expect(0, 195101, '\P{Dt=_	Can}', "");
    Expect(1, 195101, '\P{^Dt=_	Can}', "");
    Expect(0, 195102, '\p{Dt=_	Can}', "");
    Expect(1, 195102, '\p{^Dt=_	Can}', "");
    Expect(1, 195102, '\P{Dt=_	Can}', "");
    Expect(0, 195102, '\P{^Dt=_	Can}', "");
    Error('\p{Is_Decomposition_Type:   /a/	-CANONICAL}');
    Error('\P{Is_Decomposition_Type:   /a/	-CANONICAL}');
    Expect(1, 195101, '\p{Is_Decomposition_Type=canonical}', "");
    Expect(0, 195101, '\p{^Is_Decomposition_Type=canonical}', "");
    Expect(0, 195101, '\P{Is_Decomposition_Type=canonical}', "");
    Expect(1, 195101, '\P{^Is_Decomposition_Type=canonical}', "");
    Expect(0, 195102, '\p{Is_Decomposition_Type=canonical}', "");
    Expect(1, 195102, '\p{^Is_Decomposition_Type=canonical}', "");
    Expect(1, 195102, '\P{Is_Decomposition_Type=canonical}', "");
    Expect(0, 195102, '\P{^Is_Decomposition_Type=canonical}', "");
    Expect(1, 195101, '\p{Is_Decomposition_Type=-_Canonical}', "");
    Expect(0, 195101, '\p{^Is_Decomposition_Type=-_Canonical}', "");
    Expect(0, 195101, '\P{Is_Decomposition_Type=-_Canonical}', "");
    Expect(1, 195101, '\P{^Is_Decomposition_Type=-_Canonical}', "");
    Expect(0, 195102, '\p{Is_Decomposition_Type=-_Canonical}', "");
    Expect(1, 195102, '\p{^Is_Decomposition_Type=-_Canonical}', "");
    Expect(1, 195102, '\P{Is_Decomposition_Type=-_Canonical}', "");
    Expect(0, 195102, '\P{^Is_Decomposition_Type=-_Canonical}', "");
    Error('\p{Is_Dt=/a/	-can}');
    Error('\P{Is_Dt=/a/	-can}');
    Expect(1, 195101, '\p{Is_Dt=can}', "");
    Expect(0, 195101, '\p{^Is_Dt=can}', "");
    Expect(0, 195101, '\P{Is_Dt=can}', "");
    Expect(1, 195101, '\P{^Is_Dt=can}', "");
    Expect(0, 195102, '\p{Is_Dt=can}', "");
    Expect(1, 195102, '\p{^Is_Dt=can}', "");
    Expect(1, 195102, '\P{Is_Dt=can}', "");
    Expect(0, 195102, '\P{^Is_Dt=can}', "");
    Expect(1, 195101, '\p{Is_Dt=	 Can}', "");
    Expect(0, 195101, '\p{^Is_Dt=	 Can}', "");
    Expect(0, 195101, '\P{Is_Dt=	 Can}', "");
    Expect(1, 195101, '\P{^Is_Dt=	 Can}', "");
    Expect(0, 195102, '\p{Is_Dt=	 Can}', "");
    Expect(1, 195102, '\p{^Is_Dt=	 Can}', "");
    Expect(1, 195102, '\P{Is_Dt=	 Can}', "");
    Expect(0, 195102, '\P{^Is_Dt=	 Can}', "");
    Error('\p{Decomposition_Type=-:=Compat}');
    Error('\P{Decomposition_Type=-:=Compat}');
    Expect(1, 127560, '\p{Decomposition_Type=compat}', "");
    Expect(0, 127560, '\p{^Decomposition_Type=compat}', "");
    Expect(0, 127560, '\P{Decomposition_Type=compat}', "");
    Expect(1, 127560, '\P{^Decomposition_Type=compat}', "");
    Expect(0, 127561, '\p{Decomposition_Type=compat}', "");
    Expect(1, 127561, '\p{^Decomposition_Type=compat}', "");
    Expect(1, 127561, '\P{Decomposition_Type=compat}', "");
    Expect(0, 127561, '\P{^Decomposition_Type=compat}', "");
    Expect(1, 127560, '\p{Decomposition_Type=_ COMPAT}', "");
    Expect(0, 127560, '\p{^Decomposition_Type=_ COMPAT}', "");
    Expect(0, 127560, '\P{Decomposition_Type=_ COMPAT}', "");
    Expect(1, 127560, '\P{^Decomposition_Type=_ COMPAT}', "");
    Expect(0, 127561, '\p{Decomposition_Type=_ COMPAT}', "");
    Expect(1, 127561, '\p{^Decomposition_Type=_ COMPAT}', "");
    Expect(1, 127561, '\P{Decomposition_Type=_ COMPAT}', "");
    Expect(0, 127561, '\P{^Decomposition_Type=_ COMPAT}', "");
    Error('\p{Dt=-/a/Com}');
    Error('\P{Dt=-/a/Com}');
    Expect(1, 127560, '\p{Dt=com}', "");
    Expect(0, 127560, '\p{^Dt=com}', "");
    Expect(0, 127560, '\P{Dt=com}', "");
    Expect(1, 127560, '\P{^Dt=com}', "");
    Expect(0, 127561, '\p{Dt=com}', "");
    Expect(1, 127561, '\p{^Dt=com}', "");
    Expect(1, 127561, '\P{Dt=com}', "");
    Expect(0, 127561, '\P{^Dt=com}', "");
    Expect(1, 127560, '\p{Dt=	Com}', "");
    Expect(0, 127560, '\p{^Dt=	Com}', "");
    Expect(0, 127560, '\P{Dt=	Com}', "");
    Expect(1, 127560, '\P{^Dt=	Com}', "");
    Expect(0, 127561, '\p{Dt=	Com}', "");
    Expect(1, 127561, '\p{^Dt=	Com}', "");
    Expect(1, 127561, '\P{Dt=	Com}', "");
    Expect(0, 127561, '\P{^Dt=	Com}', "");
    Error('\p{Is_Decomposition_Type=:=-Compat}');
    Error('\P{Is_Decomposition_Type=:=-Compat}');
    Expect(1, 127560, '\p{Is_Decomposition_Type:   compat}', "");
    Expect(0, 127560, '\p{^Is_Decomposition_Type:   compat}', "");
    Expect(0, 127560, '\P{Is_Decomposition_Type:   compat}', "");
    Expect(1, 127560, '\P{^Is_Decomposition_Type:   compat}', "");
    Expect(0, 127561, '\p{Is_Decomposition_Type:   compat}', "");
    Expect(1, 127561, '\p{^Is_Decomposition_Type:   compat}', "");
    Expect(1, 127561, '\P{Is_Decomposition_Type:   compat}', "");
    Expect(0, 127561, '\P{^Is_Decomposition_Type:   compat}', "");
    Expect(1, 127560, '\p{Is_Decomposition_Type=	_COMPAT}', "");
    Expect(0, 127560, '\p{^Is_Decomposition_Type=	_COMPAT}', "");
    Expect(0, 127560, '\P{Is_Decomposition_Type=	_COMPAT}', "");
    Expect(1, 127560, '\P{^Is_Decomposition_Type=	_COMPAT}', "");
    Expect(0, 127561, '\p{Is_Decomposition_Type=	_COMPAT}', "");
    Expect(1, 127561, '\p{^Is_Decomposition_Type=	_COMPAT}', "");
    Expect(1, 127561, '\P{Is_Decomposition_Type=	_COMPAT}', "");
    Expect(0, 127561, '\P{^Is_Decomposition_Type=	_COMPAT}', "");
    Error('\p{Is_Dt=-_Com:=}');
    Error('\P{Is_Dt=-_Com:=}');
    Expect(1, 127560, '\p{Is_Dt: com}', "");
    Expect(0, 127560, '\p{^Is_Dt: com}', "");
    Expect(0, 127560, '\P{Is_Dt: com}', "");
    Expect(1, 127560, '\P{^Is_Dt: com}', "");
    Expect(0, 127561, '\p{Is_Dt: com}', "");
    Expect(1, 127561, '\p{^Is_Dt: com}', "");
    Expect(1, 127561, '\P{Is_Dt: com}', "");
    Expect(0, 127561, '\P{^Is_Dt: com}', "");
    Expect(1, 127560, '\p{Is_Dt=_	com}', "");
    Expect(0, 127560, '\p{^Is_Dt=_	com}', "");
    Expect(0, 127560, '\P{Is_Dt=_	com}', "");
    Expect(1, 127560, '\P{^Is_Dt=_	com}', "");
    Expect(0, 127561, '\p{Is_Dt=_	com}', "");
    Expect(1, 127561, '\p{^Is_Dt=_	com}', "");
    Expect(1, 127561, '\P{Is_Dt=_	com}', "");
    Expect(0, 127561, '\P{^Is_Dt=_	com}', "");
    Error('\p{Decomposition_Type=/a/Circle}');
    Error('\P{Decomposition_Type=/a/Circle}');
    Expect(1, 127569, '\p{Decomposition_Type=circle}', "");
    Expect(0, 127569, '\p{^Decomposition_Type=circle}', "");
    Expect(0, 127569, '\P{Decomposition_Type=circle}', "");
    Expect(1, 127569, '\P{^Decomposition_Type=circle}', "");
    Expect(0, 127570, '\p{Decomposition_Type=circle}', "");
    Expect(1, 127570, '\p{^Decomposition_Type=circle}', "");
    Expect(1, 127570, '\P{Decomposition_Type=circle}', "");
    Expect(0, 127570, '\P{^Decomposition_Type=circle}', "");
    Expect(1, 127569, '\p{Decomposition_Type=	 Circle}', "");
    Expect(0, 127569, '\p{^Decomposition_Type=	 Circle}', "");
    Expect(0, 127569, '\P{Decomposition_Type=	 Circle}', "");
    Expect(1, 127569, '\P{^Decomposition_Type=	 Circle}', "");
    Expect(0, 127570, '\p{Decomposition_Type=	 Circle}', "");
    Expect(1, 127570, '\p{^Decomposition_Type=	 Circle}', "");
    Expect(1, 127570, '\P{Decomposition_Type=	 Circle}', "");
    Expect(0, 127570, '\P{^Decomposition_Type=	 Circle}', "");
    Error('\p{Dt=	_ENC:=}');
    Error('\P{Dt=	_ENC:=}');
    Expect(1, 127569, '\p{Dt=enc}', "");
    Expect(0, 127569, '\p{^Dt=enc}', "");
    Expect(0, 127569, '\P{Dt=enc}', "");
    Expect(1, 127569, '\P{^Dt=enc}', "");
    Expect(0, 127570, '\p{Dt=enc}', "");
    Expect(1, 127570, '\p{^Dt=enc}', "");
    Expect(1, 127570, '\P{Dt=enc}', "");
    Expect(0, 127570, '\P{^Dt=enc}', "");
    Expect(1, 127569, '\p{Dt= -Enc}', "");
    Expect(0, 127569, '\p{^Dt= -Enc}', "");
    Expect(0, 127569, '\P{Dt= -Enc}', "");
    Expect(1, 127569, '\P{^Dt= -Enc}', "");
    Expect(0, 127570, '\p{Dt= -Enc}', "");
    Expect(1, 127570, '\p{^Dt= -Enc}', "");
    Expect(1, 127570, '\P{Dt= -Enc}', "");
    Expect(0, 127570, '\P{^Dt= -Enc}', "");
    Error('\p{Is_Decomposition_Type=:=	CIRCLE}');
    Error('\P{Is_Decomposition_Type=:=	CIRCLE}');
    Expect(1, 127569, '\p{Is_Decomposition_Type=circle}', "");
    Expect(0, 127569, '\p{^Is_Decomposition_Type=circle}', "");
    Expect(0, 127569, '\P{Is_Decomposition_Type=circle}', "");
    Expect(1, 127569, '\P{^Is_Decomposition_Type=circle}', "");
    Expect(0, 127570, '\p{Is_Decomposition_Type=circle}', "");
    Expect(1, 127570, '\p{^Is_Decomposition_Type=circle}', "");
    Expect(1, 127570, '\P{Is_Decomposition_Type=circle}', "");
    Expect(0, 127570, '\P{^Is_Decomposition_Type=circle}', "");
    Expect(1, 127569, '\p{Is_Decomposition_Type=-_CIRCLE}', "");
    Expect(0, 127569, '\p{^Is_Decomposition_Type=-_CIRCLE}', "");
    Expect(0, 127569, '\P{Is_Decomposition_Type=-_CIRCLE}', "");
    Expect(1, 127569, '\P{^Is_Decomposition_Type=-_CIRCLE}', "");
    Expect(0, 127570, '\p{Is_Decomposition_Type=-_CIRCLE}', "");
    Expect(1, 127570, '\p{^Is_Decomposition_Type=-_CIRCLE}', "");
    Expect(1, 127570, '\P{Is_Decomposition_Type=-_CIRCLE}', "");
    Expect(0, 127570, '\P{^Is_Decomposition_Type=-_CIRCLE}', "");
    Error('\p{Is_Dt= -enc/a/}');
    Error('\P{Is_Dt= -enc/a/}');
    Expect(1, 127569, '\p{Is_Dt=enc}', "");
    Expect(0, 127569, '\p{^Is_Dt=enc}', "");
    Expect(0, 127569, '\P{Is_Dt=enc}', "");
    Expect(1, 127569, '\P{^Is_Dt=enc}', "");
    Expect(0, 127570, '\p{Is_Dt=enc}', "");
    Expect(1, 127570, '\p{^Is_Dt=enc}', "");
    Expect(1, 127570, '\P{Is_Dt=enc}', "");
    Expect(0, 127570, '\P{^Is_Dt=enc}', "");
    Expect(1, 127569, '\p{Is_Dt= Enc}', "");
    Expect(0, 127569, '\p{^Is_Dt= Enc}', "");
    Expect(0, 127569, '\P{Is_Dt= Enc}', "");
    Expect(1, 127569, '\P{^Is_Dt= Enc}', "");
    Expect(0, 127570, '\p{Is_Dt= Enc}', "");
    Expect(1, 127570, '\p{^Is_Dt= Enc}', "");
    Expect(1, 127570, '\P{Is_Dt= Enc}', "");
    Expect(0, 127570, '\P{^Is_Dt= Enc}', "");
    Error('\p{Decomposition_Type=_:=final}');
    Error('\P{Decomposition_Type=_:=final}');
    Expect(1, 65276, '\p{Decomposition_Type=final}', "");
    Expect(0, 65276, '\p{^Decomposition_Type=final}', "");
    Expect(0, 65276, '\P{Decomposition_Type=final}', "");
    Expect(1, 65276, '\P{^Decomposition_Type=final}', "");
    Expect(0, 65277, '\p{Decomposition_Type=final}', "");
    Expect(1, 65277, '\p{^Decomposition_Type=final}', "");
    Expect(1, 65277, '\P{Decomposition_Type=final}', "");
    Expect(0, 65277, '\P{^Decomposition_Type=final}', "");
    Expect(1, 65276, '\p{Decomposition_Type=-	Final}', "");
    Expect(0, 65276, '\p{^Decomposition_Type=-	Final}', "");
    Expect(0, 65276, '\P{Decomposition_Type=-	Final}', "");
    Expect(1, 65276, '\P{^Decomposition_Type=-	Final}', "");
    Expect(0, 65277, '\p{Decomposition_Type=-	Final}', "");
    Expect(1, 65277, '\p{^Decomposition_Type=-	Final}', "");
    Expect(1, 65277, '\P{Decomposition_Type=-	Final}', "");
    Expect(0, 65277, '\P{^Decomposition_Type=-	Final}', "");
    Error('\p{Dt=		Fin:=}');
    Error('\P{Dt=		Fin:=}');
    Expect(1, 65276, '\p{Dt=fin}', "");
    Expect(0, 65276, '\p{^Dt=fin}', "");
    Expect(0, 65276, '\P{Dt=fin}', "");
    Expect(1, 65276, '\P{^Dt=fin}', "");
    Expect(0, 65277, '\p{Dt=fin}', "");
    Expect(1, 65277, '\p{^Dt=fin}', "");
    Expect(1, 65277, '\P{Dt=fin}', "");
    Expect(0, 65277, '\P{^Dt=fin}', "");
    Expect(1, 65276, '\p{Dt=-Fin}', "");
    Expect(0, 65276, '\p{^Dt=-Fin}', "");
    Expect(0, 65276, '\P{Dt=-Fin}', "");
    Expect(1, 65276, '\P{^Dt=-Fin}', "");
    Expect(0, 65277, '\p{Dt=-Fin}', "");
    Expect(1, 65277, '\p{^Dt=-Fin}', "");
    Expect(1, 65277, '\P{Dt=-Fin}', "");
    Expect(0, 65277, '\P{^Dt=-Fin}', "");
    Error('\p{Is_Decomposition_Type= FINAL:=}');
    Error('\P{Is_Decomposition_Type= FINAL:=}');
    Expect(1, 65276, '\p{Is_Decomposition_Type=final}', "");
    Expect(0, 65276, '\p{^Is_Decomposition_Type=final}', "");
    Expect(0, 65276, '\P{Is_Decomposition_Type=final}', "");
    Expect(1, 65276, '\P{^Is_Decomposition_Type=final}', "");
    Expect(0, 65277, '\p{Is_Decomposition_Type=final}', "");
    Expect(1, 65277, '\p{^Is_Decomposition_Type=final}', "");
    Expect(1, 65277, '\P{Is_Decomposition_Type=final}', "");
    Expect(0, 65277, '\P{^Is_Decomposition_Type=final}', "");
    Error('\p{Is_Dt=__Fin:=}');
    Error('\P{Is_Dt=__Fin:=}');
    Expect(1, 65276, '\p{Is_Dt=fin}', "");
    Expect(0, 65276, '\p{^Is_Dt=fin}', "");
    Expect(0, 65276, '\P{Is_Dt=fin}', "");
    Expect(1, 65276, '\P{^Is_Dt=fin}', "");
    Expect(0, 65277, '\p{Is_Dt=fin}', "");
    Expect(1, 65277, '\p{^Is_Dt=fin}', "");
    Expect(1, 65277, '\P{Is_Dt=fin}', "");
    Expect(0, 65277, '\P{^Is_Dt=fin}', "");
    Expect(1, 65276, '\p{Is_Dt=	 FIN}', "");
    Expect(0, 65276, '\p{^Is_Dt=	 FIN}', "");
    Expect(0, 65276, '\P{Is_Dt=	 FIN}', "");
    Expect(1, 65276, '\P{^Is_Dt=	 FIN}', "");
    Expect(0, 65277, '\p{Is_Dt=	 FIN}', "");
    Expect(1, 65277, '\p{^Is_Dt=	 FIN}', "");
    Expect(1, 65277, '\P{Is_Dt=	 FIN}', "");
    Expect(0, 65277, '\P{^Is_Dt=	 FIN}', "");
    Error('\p{Decomposition_Type=:=font}');
    Error('\P{Decomposition_Type=:=font}');
    Expect(1, 126651, '\p{Decomposition_Type: font}', "");
    Expect(0, 126651, '\p{^Decomposition_Type: font}', "");
    Expect(0, 126651, '\P{Decomposition_Type: font}', "");
    Expect(1, 126651, '\P{^Decomposition_Type: font}', "");
    Expect(0, 126652, '\p{Decomposition_Type: font}', "");
    Expect(1, 126652, '\p{^Decomposition_Type: font}', "");
    Expect(1, 126652, '\P{Decomposition_Type: font}', "");
    Expect(0, 126652, '\P{^Decomposition_Type: font}', "");
    Expect(1, 126651, '\p{Decomposition_Type=	 Font}', "");
    Expect(0, 126651, '\p{^Decomposition_Type=	 Font}', "");
    Expect(0, 126651, '\P{Decomposition_Type=	 Font}', "");
    Expect(1, 126651, '\P{^Decomposition_Type=	 Font}', "");
    Expect(0, 126652, '\p{Decomposition_Type=	 Font}', "");
    Expect(1, 126652, '\p{^Decomposition_Type=	 Font}', "");
    Expect(1, 126652, '\P{Decomposition_Type=	 Font}', "");
    Expect(0, 126652, '\P{^Decomposition_Type=	 Font}', "");
    Error('\p{Dt=_ Font/a/}');
    Error('\P{Dt=_ Font/a/}');
    Expect(1, 126651, '\p{Dt=font}', "");
    Expect(0, 126651, '\p{^Dt=font}', "");
    Expect(0, 126651, '\P{Dt=font}', "");
    Expect(1, 126651, '\P{^Dt=font}', "");
    Expect(0, 126652, '\p{Dt=font}', "");
    Expect(1, 126652, '\p{^Dt=font}', "");
    Expect(1, 126652, '\P{Dt=font}', "");
    Expect(0, 126652, '\P{^Dt=font}', "");
    Expect(1, 126651, '\p{Dt=	Font}', "");
    Expect(0, 126651, '\p{^Dt=	Font}', "");
    Expect(0, 126651, '\P{Dt=	Font}', "");
    Expect(1, 126651, '\P{^Dt=	Font}', "");
    Expect(0, 126652, '\p{Dt=	Font}', "");
    Expect(1, 126652, '\p{^Dt=	Font}', "");
    Expect(1, 126652, '\P{Dt=	Font}', "");
    Expect(0, 126652, '\P{^Dt=	Font}', "");
    Error('\p{Is_Decomposition_Type=_font:=}');
    Error('\P{Is_Decomposition_Type=_font:=}');
    Expect(1, 126651, '\p{Is_Decomposition_Type=font}', "");
    Expect(0, 126651, '\p{^Is_Decomposition_Type=font}', "");
    Expect(0, 126651, '\P{Is_Decomposition_Type=font}', "");
    Expect(1, 126651, '\P{^Is_Decomposition_Type=font}', "");
    Expect(0, 126652, '\p{Is_Decomposition_Type=font}', "");
    Expect(1, 126652, '\p{^Is_Decomposition_Type=font}', "");
    Expect(1, 126652, '\P{Is_Decomposition_Type=font}', "");
    Expect(0, 126652, '\P{^Is_Decomposition_Type=font}', "");
    Expect(1, 126651, '\p{Is_Decomposition_Type=-_font}', "");
    Expect(0, 126651, '\p{^Is_Decomposition_Type=-_font}', "");
    Expect(0, 126651, '\P{Is_Decomposition_Type=-_font}', "");
    Expect(1, 126651, '\P{^Is_Decomposition_Type=-_font}', "");
    Expect(0, 126652, '\p{Is_Decomposition_Type=-_font}', "");
    Expect(1, 126652, '\p{^Is_Decomposition_Type=-_font}', "");
    Expect(1, 126652, '\P{Is_Decomposition_Type=-_font}', "");
    Expect(0, 126652, '\P{^Is_Decomposition_Type=-_font}', "");
    Error('\p{Is_Dt=  Font:=}');
    Error('\P{Is_Dt=  Font:=}');
    Expect(1, 126651, '\p{Is_Dt=font}', "");
    Expect(0, 126651, '\p{^Is_Dt=font}', "");
    Expect(0, 126651, '\P{Is_Dt=font}', "");
    Expect(1, 126651, '\P{^Is_Dt=font}', "");
    Expect(0, 126652, '\p{Is_Dt=font}', "");
    Expect(1, 126652, '\p{^Is_Dt=font}', "");
    Expect(1, 126652, '\P{Is_Dt=font}', "");
    Expect(0, 126652, '\P{^Is_Dt=font}', "");
    Expect(1, 126651, '\p{Is_Dt=	Font}', "");
    Expect(0, 126651, '\p{^Is_Dt=	Font}', "");
    Expect(0, 126651, '\P{Is_Dt=	Font}', "");
    Expect(1, 126651, '\P{^Is_Dt=	Font}', "");
    Expect(0, 126652, '\p{Is_Dt=	Font}', "");
    Expect(1, 126652, '\p{^Is_Dt=	Font}', "");
    Expect(1, 126652, '\P{Is_Dt=	Font}', "");
    Expect(0, 126652, '\P{^Is_Dt=	Font}', "");
    Error('\p{Decomposition_Type=/a/--Fraction}');
    Error('\P{Decomposition_Type=/a/--Fraction}');
    Expect(1, 8585, '\p{Decomposition_Type=fraction}', "");
    Expect(0, 8585, '\p{^Decomposition_Type=fraction}', "");
    Expect(0, 8585, '\P{Decomposition_Type=fraction}', "");
    Expect(1, 8585, '\P{^Decomposition_Type=fraction}', "");
    Expect(0, 8586, '\p{Decomposition_Type=fraction}', "");
    Expect(1, 8586, '\p{^Decomposition_Type=fraction}', "");
    Expect(1, 8586, '\P{Decomposition_Type=fraction}', "");
    Expect(0, 8586, '\P{^Decomposition_Type=fraction}', "");
    Expect(1, 8585, '\p{Decomposition_Type=_-Fraction}', "");
    Expect(0, 8585, '\p{^Decomposition_Type=_-Fraction}', "");
    Expect(0, 8585, '\P{Decomposition_Type=_-Fraction}', "");
    Expect(1, 8585, '\P{^Decomposition_Type=_-Fraction}', "");
    Expect(0, 8586, '\p{Decomposition_Type=_-Fraction}', "");
    Expect(1, 8586, '\p{^Decomposition_Type=_-Fraction}', "");
    Expect(1, 8586, '\P{Decomposition_Type=_-Fraction}', "");
    Expect(0, 8586, '\P{^Decomposition_Type=_-Fraction}', "");
    Error('\p{Dt=	_Fra/a/}');
    Error('\P{Dt=	_Fra/a/}');
    Expect(1, 8585, '\p{Dt=fra}', "");
    Expect(0, 8585, '\p{^Dt=fra}', "");
    Expect(0, 8585, '\P{Dt=fra}', "");
    Expect(1, 8585, '\P{^Dt=fra}', "");
    Expect(0, 8586, '\p{Dt=fra}', "");
    Expect(1, 8586, '\p{^Dt=fra}', "");
    Expect(1, 8586, '\P{Dt=fra}', "");
    Expect(0, 8586, '\P{^Dt=fra}', "");
    Expect(1, 8585, '\p{Dt=	Fra}', "");
    Expect(0, 8585, '\p{^Dt=	Fra}', "");
    Expect(0, 8585, '\P{Dt=	Fra}', "");
    Expect(1, 8585, '\P{^Dt=	Fra}', "");
    Expect(0, 8586, '\p{Dt=	Fra}', "");
    Expect(1, 8586, '\p{^Dt=	Fra}', "");
    Expect(1, 8586, '\P{Dt=	Fra}', "");
    Expect(0, 8586, '\P{^Dt=	Fra}', "");
    Error('\p{Is_Decomposition_Type=	/a/Fraction}');
    Error('\P{Is_Decomposition_Type=	/a/Fraction}');
    Expect(1, 8585, '\p{Is_Decomposition_Type=fraction}', "");
    Expect(0, 8585, '\p{^Is_Decomposition_Type=fraction}', "");
    Expect(0, 8585, '\P{Is_Decomposition_Type=fraction}', "");
    Expect(1, 8585, '\P{^Is_Decomposition_Type=fraction}', "");
    Expect(0, 8586, '\p{Is_Decomposition_Type=fraction}', "");
    Expect(1, 8586, '\p{^Is_Decomposition_Type=fraction}', "");
    Expect(1, 8586, '\P{Is_Decomposition_Type=fraction}', "");
    Expect(0, 8586, '\P{^Is_Decomposition_Type=fraction}', "");
    Expect(1, 8585, '\p{Is_Decomposition_Type= fraction}', "");
    Expect(0, 8585, '\p{^Is_Decomposition_Type= fraction}', "");
    Expect(0, 8585, '\P{Is_Decomposition_Type= fraction}', "");
    Expect(1, 8585, '\P{^Is_Decomposition_Type= fraction}', "");
    Expect(0, 8586, '\p{Is_Decomposition_Type= fraction}', "");
    Expect(1, 8586, '\p{^Is_Decomposition_Type= fraction}', "");
    Expect(1, 8586, '\P{Is_Decomposition_Type= fraction}', "");
    Expect(0, 8586, '\P{^Is_Decomposition_Type= fraction}', "");
    Error('\p{Is_Dt=:= fra}');
    Error('\P{Is_Dt=:= fra}');
    Expect(1, 8585, '\p{Is_Dt=fra}', "");
    Expect(0, 8585, '\p{^Is_Dt=fra}', "");
    Expect(0, 8585, '\P{Is_Dt=fra}', "");
    Expect(1, 8585, '\P{^Is_Dt=fra}', "");
    Expect(0, 8586, '\p{Is_Dt=fra}', "");
    Expect(1, 8586, '\p{^Is_Dt=fra}', "");
    Expect(1, 8586, '\P{Is_Dt=fra}', "");
    Expect(0, 8586, '\P{^Is_Dt=fra}', "");
    Expect(1, 8585, '\p{Is_Dt=_-FRA}', "");
    Expect(0, 8585, '\p{^Is_Dt=_-FRA}', "");
    Expect(0, 8585, '\P{Is_Dt=_-FRA}', "");
    Expect(1, 8585, '\P{^Is_Dt=_-FRA}', "");
    Expect(0, 8586, '\p{Is_Dt=_-FRA}', "");
    Expect(1, 8586, '\p{^Is_Dt=_-FRA}', "");
    Expect(1, 8586, '\P{Is_Dt=_-FRA}', "");
    Expect(0, 8586, '\P{^Is_Dt=_-FRA}', "");
    Error('\p{Decomposition_Type=  INITIAL/a/}');
    Error('\P{Decomposition_Type=  INITIAL/a/}');
    Expect(1, 65267, '\p{Decomposition_Type=initial}', "");
    Expect(0, 65267, '\p{^Decomposition_Type=initial}', "");
    Expect(0, 65267, '\P{Decomposition_Type=initial}', "");
    Expect(1, 65267, '\P{^Decomposition_Type=initial}', "");
    Expect(0, 65268, '\p{Decomposition_Type=initial}', "");
    Expect(1, 65268, '\p{^Decomposition_Type=initial}', "");
    Expect(1, 65268, '\P{Decomposition_Type=initial}', "");
    Expect(0, 65268, '\P{^Decomposition_Type=initial}', "");
    Expect(1, 65267, '\p{Decomposition_Type=__initial}', "");
    Expect(0, 65267, '\p{^Decomposition_Type=__initial}', "");
    Expect(0, 65267, '\P{Decomposition_Type=__initial}', "");
    Expect(1, 65267, '\P{^Decomposition_Type=__initial}', "");
    Expect(0, 65268, '\p{Decomposition_Type=__initial}', "");
    Expect(1, 65268, '\p{^Decomposition_Type=__initial}', "");
    Expect(1, 65268, '\P{Decomposition_Type=__initial}', "");
    Expect(0, 65268, '\P{^Decomposition_Type=__initial}', "");
    Error('\p{Dt=:=_-Init}');
    Error('\P{Dt=:=_-Init}');
    Expect(1, 65267, '\p{Dt=init}', "");
    Expect(0, 65267, '\p{^Dt=init}', "");
    Expect(0, 65267, '\P{Dt=init}', "");
    Expect(1, 65267, '\P{^Dt=init}', "");
    Expect(0, 65268, '\p{Dt=init}', "");
    Expect(1, 65268, '\p{^Dt=init}', "");
    Expect(1, 65268, '\P{Dt=init}', "");
    Expect(0, 65268, '\P{^Dt=init}', "");
    Expect(1, 65267, '\p{Dt=__Init}', "");
    Expect(0, 65267, '\p{^Dt=__Init}', "");
    Expect(0, 65267, '\P{Dt=__Init}', "");
    Expect(1, 65267, '\P{^Dt=__Init}', "");
    Expect(0, 65268, '\p{Dt=__Init}', "");
    Expect(1, 65268, '\p{^Dt=__Init}', "");
    Expect(1, 65268, '\P{Dt=__Init}', "");
    Expect(0, 65268, '\P{^Dt=__Init}', "");
    Error('\p{Is_Decomposition_Type= :=INITIAL}');
    Error('\P{Is_Decomposition_Type= :=INITIAL}');
    Expect(1, 65267, '\p{Is_Decomposition_Type=initial}', "");
    Expect(0, 65267, '\p{^Is_Decomposition_Type=initial}', "");
    Expect(0, 65267, '\P{Is_Decomposition_Type=initial}', "");
    Expect(1, 65267, '\P{^Is_Decomposition_Type=initial}', "");
    Expect(0, 65268, '\p{Is_Decomposition_Type=initial}', "");
    Expect(1, 65268, '\p{^Is_Decomposition_Type=initial}', "");
    Expect(1, 65268, '\P{Is_Decomposition_Type=initial}', "");
    Expect(0, 65268, '\P{^Is_Decomposition_Type=initial}', "");
    Expect(1, 65267, '\p{Is_Decomposition_Type=	 INITIAL}', "");
    Expect(0, 65267, '\p{^Is_Decomposition_Type=	 INITIAL}', "");
    Expect(0, 65267, '\P{Is_Decomposition_Type=	 INITIAL}', "");
    Expect(1, 65267, '\P{^Is_Decomposition_Type=	 INITIAL}', "");
    Expect(0, 65268, '\p{Is_Decomposition_Type=	 INITIAL}', "");
    Expect(1, 65268, '\p{^Is_Decomposition_Type=	 INITIAL}', "");
    Expect(1, 65268, '\P{Is_Decomposition_Type=	 INITIAL}', "");
    Expect(0, 65268, '\P{^Is_Decomposition_Type=	 INITIAL}', "");
    Error('\p{Is_Dt=-_INIT:=}');
    Error('\P{Is_Dt=-_INIT:=}');
    Expect(1, 65267, '\p{Is_Dt=init}', "");
    Expect(0, 65267, '\p{^Is_Dt=init}', "");
    Expect(0, 65267, '\P{Is_Dt=init}', "");
    Expect(1, 65267, '\P{^Is_Dt=init}', "");
    Expect(0, 65268, '\p{Is_Dt=init}', "");
    Expect(1, 65268, '\p{^Is_Dt=init}', "");
    Expect(1, 65268, '\P{Is_Dt=init}', "");
    Expect(0, 65268, '\P{^Is_Dt=init}', "");
    Expect(1, 65267, '\p{Is_Dt=_ Init}', "");
    Expect(0, 65267, '\p{^Is_Dt=_ Init}', "");
    Expect(0, 65267, '\P{Is_Dt=_ Init}', "");
    Expect(1, 65267, '\P{^Is_Dt=_ Init}', "");
    Expect(0, 65268, '\p{Is_Dt=_ Init}', "");
    Expect(1, 65268, '\p{^Is_Dt=_ Init}', "");
    Expect(1, 65268, '\P{Is_Dt=_ Init}', "");
    Expect(0, 65268, '\P{^Is_Dt=_ Init}', "");
    Error('\p{Decomposition_Type: /a/	_Isolated}');
    Error('\P{Decomposition_Type: /a/	_Isolated}');
    Expect(1, 65275, '\p{Decomposition_Type=isolated}', "");
    Expect(0, 65275, '\p{^Decomposition_Type=isolated}', "");
    Expect(0, 65275, '\P{Decomposition_Type=isolated}', "");
    Expect(1, 65275, '\P{^Decomposition_Type=isolated}', "");
    Expect(0, 65276, '\p{Decomposition_Type=isolated}', "");
    Expect(1, 65276, '\p{^Decomposition_Type=isolated}', "");
    Expect(1, 65276, '\P{Decomposition_Type=isolated}', "");
    Expect(0, 65276, '\P{^Decomposition_Type=isolated}', "");
    Expect(1, 65275, '\p{Decomposition_Type: -Isolated}', "");
    Expect(0, 65275, '\p{^Decomposition_Type: -Isolated}', "");
    Expect(0, 65275, '\P{Decomposition_Type: -Isolated}', "");
    Expect(1, 65275, '\P{^Decomposition_Type: -Isolated}', "");
    Expect(0, 65276, '\p{Decomposition_Type: -Isolated}', "");
    Expect(1, 65276, '\p{^Decomposition_Type: -Isolated}', "");
    Expect(1, 65276, '\P{Decomposition_Type: -Isolated}', "");
    Expect(0, 65276, '\P{^Decomposition_Type: -Isolated}', "");
    Error('\p{Dt:   _Iso:=}');
    Error('\P{Dt:   _Iso:=}');
    Expect(1, 65275, '\p{Dt=iso}', "");
    Expect(0, 65275, '\p{^Dt=iso}', "");
    Expect(0, 65275, '\P{Dt=iso}', "");
    Expect(1, 65275, '\P{^Dt=iso}', "");
    Expect(0, 65276, '\p{Dt=iso}', "");
    Expect(1, 65276, '\p{^Dt=iso}', "");
    Expect(1, 65276, '\P{Dt=iso}', "");
    Expect(0, 65276, '\P{^Dt=iso}', "");
    Expect(1, 65275, '\p{Dt=	_iso}', "");
    Expect(0, 65275, '\p{^Dt=	_iso}', "");
    Expect(0, 65275, '\P{Dt=	_iso}', "");
    Expect(1, 65275, '\P{^Dt=	_iso}', "");
    Expect(0, 65276, '\p{Dt=	_iso}', "");
    Expect(1, 65276, '\p{^Dt=	_iso}', "");
    Expect(1, 65276, '\P{Dt=	_iso}', "");
    Expect(0, 65276, '\P{^Dt=	_iso}', "");
    Error('\p{Is_Decomposition_Type= :=Isolated}');
    Error('\P{Is_Decomposition_Type= :=Isolated}');
    Expect(1, 65275, '\p{Is_Decomposition_Type:isolated}', "");
    Expect(0, 65275, '\p{^Is_Decomposition_Type:isolated}', "");
    Expect(0, 65275, '\P{Is_Decomposition_Type:isolated}', "");
    Expect(1, 65275, '\P{^Is_Decomposition_Type:isolated}', "");
    Expect(0, 65276, '\p{Is_Decomposition_Type:isolated}', "");
    Expect(1, 65276, '\p{^Is_Decomposition_Type:isolated}', "");
    Expect(1, 65276, '\P{Is_Decomposition_Type:isolated}', "");
    Expect(0, 65276, '\P{^Is_Decomposition_Type:isolated}', "");
    Expect(1, 65275, '\p{Is_Decomposition_Type=  Isolated}', "");
    Expect(0, 65275, '\p{^Is_Decomposition_Type=  Isolated}', "");
    Expect(0, 65275, '\P{Is_Decomposition_Type=  Isolated}', "");
    Expect(1, 65275, '\P{^Is_Decomposition_Type=  Isolated}', "");
    Expect(0, 65276, '\p{Is_Decomposition_Type=  Isolated}', "");
    Expect(1, 65276, '\p{^Is_Decomposition_Type=  Isolated}', "");
    Expect(1, 65276, '\P{Is_Decomposition_Type=  Isolated}', "");
    Expect(0, 65276, '\P{^Is_Decomposition_Type=  Isolated}', "");
    Error('\p{Is_Dt=_	iso:=}');
    Error('\P{Is_Dt=_	iso:=}');
    Expect(1, 65275, '\p{Is_Dt=iso}', "");
    Expect(0, 65275, '\p{^Is_Dt=iso}', "");
    Expect(0, 65275, '\P{Is_Dt=iso}', "");
    Expect(1, 65275, '\P{^Is_Dt=iso}', "");
    Expect(0, 65276, '\p{Is_Dt=iso}', "");
    Expect(1, 65276, '\p{^Is_Dt=iso}', "");
    Expect(1, 65276, '\P{Is_Dt=iso}', "");
    Expect(0, 65276, '\P{^Is_Dt=iso}', "");
    Expect(1, 65275, '\p{Is_Dt:-_ISO}', "");
    Expect(0, 65275, '\p{^Is_Dt:-_ISO}', "");
    Expect(0, 65275, '\P{Is_Dt:-_ISO}', "");
    Expect(1, 65275, '\P{^Is_Dt:-_ISO}', "");
    Expect(0, 65276, '\p{Is_Dt:-_ISO}', "");
    Expect(1, 65276, '\p{^Is_Dt:-_ISO}', "");
    Expect(1, 65276, '\P{Is_Dt:-_ISO}', "");
    Expect(0, 65276, '\P{^Is_Dt:-_ISO}', "");
    Error('\p{Decomposition_Type=:=_-Medial}');
    Error('\P{Decomposition_Type=:=_-Medial}');
    Expect(1, 65268, '\p{Decomposition_Type=medial}', "");
    Expect(0, 65268, '\p{^Decomposition_Type=medial}', "");
    Expect(0, 65268, '\P{Decomposition_Type=medial}', "");
    Expect(1, 65268, '\P{^Decomposition_Type=medial}', "");
    Expect(0, 65269, '\p{Decomposition_Type=medial}', "");
    Expect(1, 65269, '\p{^Decomposition_Type=medial}', "");
    Expect(1, 65269, '\P{Decomposition_Type=medial}', "");
    Expect(0, 65269, '\P{^Decomposition_Type=medial}', "");
    Expect(1, 65268, '\p{Decomposition_Type: _medial}', "");
    Expect(0, 65268, '\p{^Decomposition_Type: _medial}', "");
    Expect(0, 65268, '\P{Decomposition_Type: _medial}', "");
    Expect(1, 65268, '\P{^Decomposition_Type: _medial}', "");
    Expect(0, 65269, '\p{Decomposition_Type: _medial}', "");
    Expect(1, 65269, '\p{^Decomposition_Type: _medial}', "");
    Expect(1, 65269, '\P{Decomposition_Type: _medial}', "");
    Expect(0, 65269, '\P{^Decomposition_Type: _medial}', "");
    Error('\p{Dt=/a/Med}');
    Error('\P{Dt=/a/Med}');
    Expect(1, 65268, '\p{Dt=med}', "");
    Expect(0, 65268, '\p{^Dt=med}', "");
    Expect(0, 65268, '\P{Dt=med}', "");
    Expect(1, 65268, '\P{^Dt=med}', "");
    Expect(0, 65269, '\p{Dt=med}', "");
    Expect(1, 65269, '\p{^Dt=med}', "");
    Expect(1, 65269, '\P{Dt=med}', "");
    Expect(0, 65269, '\P{^Dt=med}', "");
    Expect(1, 65268, '\p{Dt=Med}', "");
    Expect(0, 65268, '\p{^Dt=Med}', "");
    Expect(0, 65268, '\P{Dt=Med}', "");
    Expect(1, 65268, '\P{^Dt=Med}', "");
    Expect(0, 65269, '\p{Dt=Med}', "");
    Expect(1, 65269, '\p{^Dt=Med}', "");
    Expect(1, 65269, '\P{Dt=Med}', "");
    Expect(0, 65269, '\P{^Dt=Med}', "");
    Error('\p{Is_Decomposition_Type= /a/MEDIAL}');
    Error('\P{Is_Decomposition_Type= /a/MEDIAL}');
    Expect(1, 65268, '\p{Is_Decomposition_Type=medial}', "");
    Expect(0, 65268, '\p{^Is_Decomposition_Type=medial}', "");
    Expect(0, 65268, '\P{Is_Decomposition_Type=medial}', "");
    Expect(1, 65268, '\P{^Is_Decomposition_Type=medial}', "");
    Expect(0, 65269, '\p{Is_Decomposition_Type=medial}', "");
    Expect(1, 65269, '\p{^Is_Decomposition_Type=medial}', "");
    Expect(1, 65269, '\P{Is_Decomposition_Type=medial}', "");
    Expect(0, 65269, '\P{^Is_Decomposition_Type=medial}', "");
    Expect(1, 65268, '\p{Is_Decomposition_Type=	 MEDIAL}', "");
    Expect(0, 65268, '\p{^Is_Decomposition_Type=	 MEDIAL}', "");
    Expect(0, 65268, '\P{Is_Decomposition_Type=	 MEDIAL}', "");
    Expect(1, 65268, '\P{^Is_Decomposition_Type=	 MEDIAL}', "");
    Expect(0, 65269, '\p{Is_Decomposition_Type=	 MEDIAL}', "");
    Expect(1, 65269, '\p{^Is_Decomposition_Type=	 MEDIAL}', "");
    Expect(1, 65269, '\P{Is_Decomposition_Type=	 MEDIAL}', "");
    Expect(0, 65269, '\P{^Is_Decomposition_Type=	 MEDIAL}', "");
    Error('\p{Is_Dt=:=  Med}');
    Error('\P{Is_Dt=:=  Med}');
    Expect(1, 65268, '\p{Is_Dt=med}', "");
    Expect(0, 65268, '\p{^Is_Dt=med}', "");
    Expect(0, 65268, '\P{Is_Dt=med}', "");
    Expect(1, 65268, '\P{^Is_Dt=med}', "");
    Expect(0, 65269, '\p{Is_Dt=med}', "");
    Expect(1, 65269, '\p{^Is_Dt=med}', "");
    Expect(1, 65269, '\P{Is_Dt=med}', "");
    Expect(0, 65269, '\P{^Is_Dt=med}', "");
    Expect(1, 65268, '\p{Is_Dt=-med}', "");
    Expect(0, 65268, '\p{^Is_Dt=-med}', "");
    Expect(0, 65268, '\P{Is_Dt=-med}', "");
    Expect(1, 65268, '\P{^Is_Dt=-med}', "");
    Expect(0, 65269, '\p{Is_Dt=-med}', "");
    Expect(1, 65269, '\p{^Is_Dt=-med}', "");
    Expect(1, 65269, '\P{Is_Dt=-med}', "");
    Expect(0, 65269, '\P{^Is_Dt=-med}', "");
    Error('\p{Decomposition_Type=:=narrow}');
    Error('\P{Decomposition_Type=:=narrow}');
    Expect(1, 65518, '\p{Decomposition_Type=narrow}', "");
    Expect(0, 65518, '\p{^Decomposition_Type=narrow}', "");
    Expect(0, 65518, '\P{Decomposition_Type=narrow}', "");
    Expect(1, 65518, '\P{^Decomposition_Type=narrow}', "");
    Expect(0, 65519, '\p{Decomposition_Type=narrow}', "");
    Expect(1, 65519, '\p{^Decomposition_Type=narrow}', "");
    Expect(1, 65519, '\P{Decomposition_Type=narrow}', "");
    Expect(0, 65519, '\P{^Decomposition_Type=narrow}', "");
    Expect(1, 65518, '\p{Decomposition_Type:	 	NARROW}', "");
    Expect(0, 65518, '\p{^Decomposition_Type:	 	NARROW}', "");
    Expect(0, 65518, '\P{Decomposition_Type:	 	NARROW}', "");
    Expect(1, 65518, '\P{^Decomposition_Type:	 	NARROW}', "");
    Expect(0, 65519, '\p{Decomposition_Type:	 	NARROW}', "");
    Expect(1, 65519, '\p{^Decomposition_Type:	 	NARROW}', "");
    Expect(1, 65519, '\P{Decomposition_Type:	 	NARROW}', "");
    Expect(0, 65519, '\P{^Decomposition_Type:	 	NARROW}', "");
    Error('\p{Dt=:=_Nar}');
    Error('\P{Dt=:=_Nar}');
    Expect(1, 65518, '\p{Dt=nar}', "");
    Expect(0, 65518, '\p{^Dt=nar}', "");
    Expect(0, 65518, '\P{Dt=nar}', "");
    Expect(1, 65518, '\P{^Dt=nar}', "");
    Expect(0, 65519, '\p{Dt=nar}', "");
    Expect(1, 65519, '\p{^Dt=nar}', "");
    Expect(1, 65519, '\P{Dt=nar}', "");
    Expect(0, 65519, '\P{^Dt=nar}', "");
    Expect(1, 65518, '\p{Dt:_nar}', "");
    Expect(0, 65518, '\p{^Dt:_nar}', "");
    Expect(0, 65518, '\P{Dt:_nar}', "");
    Expect(1, 65518, '\P{^Dt:_nar}', "");
    Expect(0, 65519, '\p{Dt:_nar}', "");
    Expect(1, 65519, '\p{^Dt:_nar}', "");
    Expect(1, 65519, '\P{Dt:_nar}', "");
    Expect(0, 65519, '\P{^Dt:_nar}', "");
    Error('\p{Is_Decomposition_Type= :=Narrow}');
    Error('\P{Is_Decomposition_Type= :=Narrow}');
    Expect(1, 65518, '\p{Is_Decomposition_Type=narrow}', "");
    Expect(0, 65518, '\p{^Is_Decomposition_Type=narrow}', "");
    Expect(0, 65518, '\P{Is_Decomposition_Type=narrow}', "");
    Expect(1, 65518, '\P{^Is_Decomposition_Type=narrow}', "");
    Expect(0, 65519, '\p{Is_Decomposition_Type=narrow}', "");
    Expect(1, 65519, '\p{^Is_Decomposition_Type=narrow}', "");
    Expect(1, 65519, '\P{Is_Decomposition_Type=narrow}', "");
    Expect(0, 65519, '\P{^Is_Decomposition_Type=narrow}', "");
    Expect(1, 65518, '\p{Is_Decomposition_Type=- Narrow}', "");
    Expect(0, 65518, '\p{^Is_Decomposition_Type=- Narrow}', "");
    Expect(0, 65518, '\P{Is_Decomposition_Type=- Narrow}', "");
    Expect(1, 65518, '\P{^Is_Decomposition_Type=- Narrow}', "");
    Expect(0, 65519, '\p{Is_Decomposition_Type=- Narrow}', "");
    Expect(1, 65519, '\p{^Is_Decomposition_Type=- Narrow}', "");
    Expect(1, 65519, '\P{Is_Decomposition_Type=- Narrow}', "");
    Expect(0, 65519, '\P{^Is_Decomposition_Type=- Narrow}', "");
    Error('\p{Is_Dt=_:=Nar}');
    Error('\P{Is_Dt=_:=Nar}');
    Expect(1, 65518, '\p{Is_Dt=nar}', "");
    Expect(0, 65518, '\p{^Is_Dt=nar}', "");
    Expect(0, 65518, '\P{Is_Dt=nar}', "");
    Expect(1, 65518, '\P{^Is_Dt=nar}', "");
    Expect(0, 65519, '\p{Is_Dt=nar}', "");
    Expect(1, 65519, '\p{^Is_Dt=nar}', "");
    Expect(1, 65519, '\P{Is_Dt=nar}', "");
    Expect(0, 65519, '\P{^Is_Dt=nar}', "");
    Expect(1, 65518, '\p{Is_Dt=-	Nar}', "");
    Expect(0, 65518, '\p{^Is_Dt=-	Nar}', "");
    Expect(0, 65518, '\P{Is_Dt=-	Nar}', "");
    Expect(1, 65518, '\P{^Is_Dt=-	Nar}', "");
    Expect(0, 65519, '\p{Is_Dt=-	Nar}', "");
    Expect(1, 65519, '\p{^Is_Dt=-	Nar}', "");
    Expect(1, 65519, '\P{Is_Dt=-	Nar}', "");
    Expect(0, 65519, '\P{^Is_Dt=-	Nar}', "");
    Error('\p{Decomposition_Type=_/a/Nobreak}');
    Error('\P{Decomposition_Type=_/a/Nobreak}');
    Expect(1, 8239, '\p{Decomposition_Type=nobreak}', "");
    Expect(0, 8239, '\p{^Decomposition_Type=nobreak}', "");
    Expect(0, 8239, '\P{Decomposition_Type=nobreak}', "");
    Expect(1, 8239, '\P{^Decomposition_Type=nobreak}', "");
    Expect(0, 8240, '\p{Decomposition_Type=nobreak}', "");
    Expect(1, 8240, '\p{^Decomposition_Type=nobreak}', "");
    Expect(1, 8240, '\P{Decomposition_Type=nobreak}', "");
    Expect(0, 8240, '\P{^Decomposition_Type=nobreak}', "");
    Expect(1, 8239, '\p{Decomposition_Type:   _NOBREAK}', "");
    Expect(0, 8239, '\p{^Decomposition_Type:   _NOBREAK}', "");
    Expect(0, 8239, '\P{Decomposition_Type:   _NOBREAK}', "");
    Expect(1, 8239, '\P{^Decomposition_Type:   _NOBREAK}', "");
    Expect(0, 8240, '\p{Decomposition_Type:   _NOBREAK}', "");
    Expect(1, 8240, '\p{^Decomposition_Type:   _NOBREAK}', "");
    Expect(1, 8240, '\P{Decomposition_Type:   _NOBREAK}', "");
    Expect(0, 8240, '\P{^Decomposition_Type:   _NOBREAK}', "");
    Error('\p{Dt=:=_NB}');
    Error('\P{Dt=:=_NB}');
    Expect(1, 8239, '\p{Dt=nb}', "");
    Expect(0, 8239, '\p{^Dt=nb}', "");
    Expect(0, 8239, '\P{Dt=nb}', "");
    Expect(1, 8239, '\P{^Dt=nb}', "");
    Expect(0, 8240, '\p{Dt=nb}', "");
    Expect(1, 8240, '\p{^Dt=nb}', "");
    Expect(1, 8240, '\P{Dt=nb}', "");
    Expect(0, 8240, '\P{^Dt=nb}', "");
    Expect(1, 8239, '\p{Dt= nb}', "");
    Expect(0, 8239, '\p{^Dt= nb}', "");
    Expect(0, 8239, '\P{Dt= nb}', "");
    Expect(1, 8239, '\P{^Dt= nb}', "");
    Expect(0, 8240, '\p{Dt= nb}', "");
    Expect(1, 8240, '\p{^Dt= nb}', "");
    Expect(1, 8240, '\P{Dt= nb}', "");
    Expect(0, 8240, '\P{^Dt= nb}', "");
    Error('\p{Is_Decomposition_Type=-	Nobreak/a/}');
    Error('\P{Is_Decomposition_Type=-	Nobreak/a/}');
    Expect(1, 8239, '\p{Is_Decomposition_Type=nobreak}', "");
    Expect(0, 8239, '\p{^Is_Decomposition_Type=nobreak}', "");
    Expect(0, 8239, '\P{Is_Decomposition_Type=nobreak}', "");
    Expect(1, 8239, '\P{^Is_Decomposition_Type=nobreak}', "");
    Expect(0, 8240, '\p{Is_Decomposition_Type=nobreak}', "");
    Expect(1, 8240, '\p{^Is_Decomposition_Type=nobreak}', "");
    Expect(1, 8240, '\P{Is_Decomposition_Type=nobreak}', "");
    Expect(0, 8240, '\P{^Is_Decomposition_Type=nobreak}', "");
    Expect(1, 8239, '\p{Is_Decomposition_Type=_ Nobreak}', "");
    Expect(0, 8239, '\p{^Is_Decomposition_Type=_ Nobreak}', "");
    Expect(0, 8239, '\P{Is_Decomposition_Type=_ Nobreak}', "");
    Expect(1, 8239, '\P{^Is_Decomposition_Type=_ Nobreak}', "");
    Expect(0, 8240, '\p{Is_Decomposition_Type=_ Nobreak}', "");
    Expect(1, 8240, '\p{^Is_Decomposition_Type=_ Nobreak}', "");
    Expect(1, 8240, '\P{Is_Decomposition_Type=_ Nobreak}', "");
    Expect(0, 8240, '\P{^Is_Decomposition_Type=_ Nobreak}', "");
    Error('\p{Is_Dt=/a/Nb}');
    Error('\P{Is_Dt=/a/Nb}');
    Expect(1, 8239, '\p{Is_Dt=nb}', "");
    Expect(0, 8239, '\p{^Is_Dt=nb}', "");
    Expect(0, 8239, '\P{Is_Dt=nb}', "");
    Expect(1, 8239, '\P{^Is_Dt=nb}', "");
    Expect(0, 8240, '\p{Is_Dt=nb}', "");
    Expect(1, 8240, '\p{^Is_Dt=nb}', "");
    Expect(1, 8240, '\P{Is_Dt=nb}', "");
    Expect(0, 8240, '\P{^Is_Dt=nb}', "");
    Expect(1, 8239, '\p{Is_Dt:		-Nb}', "");
    Expect(0, 8239, '\p{^Is_Dt:		-Nb}', "");
    Expect(0, 8239, '\P{Is_Dt:		-Nb}', "");
    Expect(1, 8239, '\P{^Is_Dt:		-Nb}', "");
    Expect(0, 8240, '\p{Is_Dt:		-Nb}', "");
    Expect(1, 8240, '\p{^Is_Dt:		-Nb}', "");
    Expect(1, 8240, '\P{Is_Dt:		-Nb}', "");
    Expect(0, 8240, '\P{^Is_Dt:		-Nb}', "");
    Error('\p{Decomposition_Type=Non_canonical:=}');
    Error('\P{Decomposition_Type=Non_canonical:=}');
    Expect(1, 127569, '\p{Decomposition_Type=noncanonical}', "");
    Expect(0, 127569, '\p{^Decomposition_Type=noncanonical}', "");
    Expect(0, 127569, '\P{Decomposition_Type=noncanonical}', "");
    Expect(1, 127569, '\P{^Decomposition_Type=noncanonical}', "");
    Expect(0, 127570, '\p{Decomposition_Type=noncanonical}', "");
    Expect(1, 127570, '\p{^Decomposition_Type=noncanonical}', "");
    Expect(1, 127570, '\P{Decomposition_Type=noncanonical}', "");
    Expect(0, 127570, '\P{^Decomposition_Type=noncanonical}', "");
    Expect(1, 127569, '\p{Decomposition_Type=-	NON_canonical}', "");
    Expect(0, 127569, '\p{^Decomposition_Type=-	NON_canonical}', "");
    Expect(0, 127569, '\P{Decomposition_Type=-	NON_canonical}', "");
    Expect(1, 127569, '\P{^Decomposition_Type=-	NON_canonical}', "");
    Expect(0, 127570, '\p{Decomposition_Type=-	NON_canonical}', "");
    Expect(1, 127570, '\p{^Decomposition_Type=-	NON_canonical}', "");
    Expect(1, 127570, '\P{Decomposition_Type=-	NON_canonical}', "");
    Expect(0, 127570, '\P{^Decomposition_Type=-	NON_canonical}', "");
    Error('\p{Dt=:=_ Non_CANON}');
    Error('\P{Dt=:=_ Non_CANON}');
    Expect(1, 127569, '\p{Dt=noncanon}', "");
    Expect(0, 127569, '\p{^Dt=noncanon}', "");
    Expect(0, 127569, '\P{Dt=noncanon}', "");
    Expect(1, 127569, '\P{^Dt=noncanon}', "");
    Expect(0, 127570, '\p{Dt=noncanon}', "");
    Expect(1, 127570, '\p{^Dt=noncanon}', "");
    Expect(1, 127570, '\P{Dt=noncanon}', "");
    Expect(0, 127570, '\P{^Dt=noncanon}', "");
    Expect(1, 127569, '\p{Dt= NON_CANON}', "");
    Expect(0, 127569, '\p{^Dt= NON_CANON}', "");
    Expect(0, 127569, '\P{Dt= NON_CANON}', "");
    Expect(1, 127569, '\P{^Dt= NON_CANON}', "");
    Expect(0, 127570, '\p{Dt= NON_CANON}', "");
    Expect(1, 127570, '\p{^Dt= NON_CANON}', "");
    Expect(1, 127570, '\P{Dt= NON_CANON}', "");
    Expect(0, 127570, '\P{^Dt= NON_CANON}', "");
    Error('\p{Is_Decomposition_Type=/a/ Non_Canonical}');
    Error('\P{Is_Decomposition_Type=/a/ Non_Canonical}');
    Expect(1, 127569, '\p{Is_Decomposition_Type=noncanonical}', "");
    Expect(0, 127569, '\p{^Is_Decomposition_Type=noncanonical}', "");
    Expect(0, 127569, '\P{Is_Decomposition_Type=noncanonical}', "");
    Expect(1, 127569, '\P{^Is_Decomposition_Type=noncanonical}', "");
    Expect(0, 127570, '\p{Is_Decomposition_Type=noncanonical}', "");
    Expect(1, 127570, '\p{^Is_Decomposition_Type=noncanonical}', "");
    Expect(1, 127570, '\P{Is_Decomposition_Type=noncanonical}', "");
    Expect(0, 127570, '\P{^Is_Decomposition_Type=noncanonical}', "");
    Expect(1, 127569, '\p{Is_Decomposition_Type=--non_CANONICAL}', "");
    Expect(0, 127569, '\p{^Is_Decomposition_Type=--non_CANONICAL}', "");
    Expect(0, 127569, '\P{Is_Decomposition_Type=--non_CANONICAL}', "");
    Expect(1, 127569, '\P{^Is_Decomposition_Type=--non_CANONICAL}', "");
    Expect(0, 127570, '\p{Is_Decomposition_Type=--non_CANONICAL}', "");
    Expect(1, 127570, '\p{^Is_Decomposition_Type=--non_CANONICAL}', "");
    Expect(1, 127570, '\P{Is_Decomposition_Type=--non_CANONICAL}', "");
    Expect(0, 127570, '\P{^Is_Decomposition_Type=--non_CANONICAL}', "");
    Error('\p{Is_Dt:  Non_Canon/a/}');
    Error('\P{Is_Dt:  Non_Canon/a/}');
    Expect(1, 127569, '\p{Is_Dt=noncanon}', "");
    Expect(0, 127569, '\p{^Is_Dt=noncanon}', "");
    Expect(0, 127569, '\P{Is_Dt=noncanon}', "");
    Expect(1, 127569, '\P{^Is_Dt=noncanon}', "");
    Expect(0, 127570, '\p{Is_Dt=noncanon}', "");
    Expect(1, 127570, '\p{^Is_Dt=noncanon}', "");
    Expect(1, 127570, '\P{Is_Dt=noncanon}', "");
    Expect(0, 127570, '\P{^Is_Dt=noncanon}', "");
    Expect(1, 127569, '\p{Is_Dt=	NON_CANON}', "");
    Expect(0, 127569, '\p{^Is_Dt=	NON_CANON}', "");
    Expect(0, 127569, '\P{Is_Dt=	NON_CANON}', "");
    Expect(1, 127569, '\P{^Is_Dt=	NON_CANON}', "");
    Expect(0, 127570, '\p{Is_Dt=	NON_CANON}', "");
    Expect(1, 127570, '\p{^Is_Dt=	NON_CANON}', "");
    Expect(1, 127570, '\P{Is_Dt=	NON_CANON}', "");
    Expect(0, 127570, '\P{^Is_Dt=	NON_CANON}', "");
    Error('\p{Decomposition_Type::=_None}');
    Error('\P{Decomposition_Type::=_None}');
    Expect(1, 195102, '\p{Decomposition_Type=none}', "");
    Expect(0, 195102, '\p{^Decomposition_Type=none}', "");
    Expect(0, 195102, '\P{Decomposition_Type=none}', "");
    Expect(1, 195102, '\P{^Decomposition_Type=none}', "");
    Expect(0, 195101, '\p{Decomposition_Type=none}', "");
    Expect(1, 195101, '\p{^Decomposition_Type=none}', "");
    Expect(1, 195101, '\P{Decomposition_Type=none}', "");
    Expect(0, 195101, '\P{^Decomposition_Type=none}', "");
    Expect(1, 195102, '\p{Decomposition_Type=_-none}', "");
    Expect(0, 195102, '\p{^Decomposition_Type=_-none}', "");
    Expect(0, 195102, '\P{Decomposition_Type=_-none}', "");
    Expect(1, 195102, '\P{^Decomposition_Type=_-none}', "");
    Expect(0, 195101, '\p{Decomposition_Type=_-none}', "");
    Expect(1, 195101, '\p{^Decomposition_Type=_-none}', "");
    Expect(1, 195101, '\P{Decomposition_Type=_-none}', "");
    Expect(0, 195101, '\P{^Decomposition_Type=_-none}', "");
    Error('\p{Dt=	NONE:=}');
    Error('\P{Dt=	NONE:=}');
    Expect(1, 195102, '\p{Dt=none}', "");
    Expect(0, 195102, '\p{^Dt=none}', "");
    Expect(0, 195102, '\P{Dt=none}', "");
    Expect(1, 195102, '\P{^Dt=none}', "");
    Expect(0, 195101, '\p{Dt=none}', "");
    Expect(1, 195101, '\p{^Dt=none}', "");
    Expect(1, 195101, '\P{Dt=none}', "");
    Expect(0, 195101, '\P{^Dt=none}', "");
    Expect(1, 195102, '\p{Dt=__none}', "");
    Expect(0, 195102, '\p{^Dt=__none}', "");
    Expect(0, 195102, '\P{Dt=__none}', "");
    Expect(1, 195102, '\P{^Dt=__none}', "");
    Expect(0, 195101, '\p{Dt=__none}', "");
    Expect(1, 195101, '\p{^Dt=__none}', "");
    Expect(1, 195101, '\P{Dt=__none}', "");
    Expect(0, 195101, '\P{^Dt=__none}', "");
    Error('\p{Is_Decomposition_Type=:= None}');
    Error('\P{Is_Decomposition_Type=:= None}');
    Expect(1, 195102, '\p{Is_Decomposition_Type:   none}', "");
    Expect(0, 195102, '\p{^Is_Decomposition_Type:   none}', "");
    Expect(0, 195102, '\P{Is_Decomposition_Type:   none}', "");
    Expect(1, 195102, '\P{^Is_Decomposition_Type:   none}', "");
    Expect(0, 195101, '\p{Is_Decomposition_Type:   none}', "");
    Expect(1, 195101, '\p{^Is_Decomposition_Type:   none}', "");
    Expect(1, 195101, '\P{Is_Decomposition_Type:   none}', "");
    Expect(0, 195101, '\P{^Is_Decomposition_Type:   none}', "");
    Expect(1, 195102, '\p{Is_Decomposition_Type=_None}', "");
    Expect(0, 195102, '\p{^Is_Decomposition_Type=_None}', "");
    Expect(0, 195102, '\P{Is_Decomposition_Type=_None}', "");
    Expect(1, 195102, '\P{^Is_Decomposition_Type=_None}', "");
    Expect(0, 195101, '\p{Is_Decomposition_Type=_None}', "");
    Expect(1, 195101, '\p{^Is_Decomposition_Type=_None}', "");
    Expect(1, 195101, '\P{Is_Decomposition_Type=_None}', "");
    Expect(0, 195101, '\P{^Is_Decomposition_Type=_None}', "");
    Error('\p{Is_Dt=		none/a/}');
    Error('\P{Is_Dt=		none/a/}');
    Expect(1, 195102, '\p{Is_Dt=none}', "");
    Expect(0, 195102, '\p{^Is_Dt=none}', "");
    Expect(0, 195102, '\P{Is_Dt=none}', "");
    Expect(1, 195102, '\P{^Is_Dt=none}', "");
    Expect(0, 195101, '\p{Is_Dt=none}', "");
    Expect(1, 195101, '\p{^Is_Dt=none}', "");
    Expect(1, 195101, '\P{Is_Dt=none}', "");
    Expect(0, 195101, '\P{^Is_Dt=none}', "");
    Expect(1, 195102, '\p{Is_Dt=	None}', "");
    Expect(0, 195102, '\p{^Is_Dt=	None}', "");
    Expect(0, 195102, '\P{Is_Dt=	None}', "");
    Expect(1, 195102, '\P{^Is_Dt=	None}', "");
    Expect(0, 195101, '\p{Is_Dt=	None}', "");
    Expect(1, 195101, '\p{^Is_Dt=	None}', "");
    Expect(1, 195101, '\P{Is_Dt=	None}', "");
    Expect(0, 195101, '\P{^Is_Dt=	None}', "");
    Error('\p{Decomposition_Type=/a/_small}');
    Error('\P{Decomposition_Type=/a/_small}');
    Expect(1, 65131, '\p{Decomposition_Type=small}', "");
    Expect(0, 65131, '\p{^Decomposition_Type=small}', "");
    Expect(0, 65131, '\P{Decomposition_Type=small}', "");
    Expect(1, 65131, '\P{^Decomposition_Type=small}', "");
    Expect(0, 65132, '\p{Decomposition_Type=small}', "");
    Expect(1, 65132, '\p{^Decomposition_Type=small}', "");
    Expect(1, 65132, '\P{Decomposition_Type=small}', "");
    Expect(0, 65132, '\P{^Decomposition_Type=small}', "");
    Expect(1, 65131, '\p{Decomposition_Type=-SMALL}', "");
    Expect(0, 65131, '\p{^Decomposition_Type=-SMALL}', "");
    Expect(0, 65131, '\P{Decomposition_Type=-SMALL}', "");
    Expect(1, 65131, '\P{^Decomposition_Type=-SMALL}', "");
    Expect(0, 65132, '\p{Decomposition_Type=-SMALL}', "");
    Expect(1, 65132, '\p{^Decomposition_Type=-SMALL}', "");
    Expect(1, 65132, '\P{Decomposition_Type=-SMALL}', "");
    Expect(0, 65132, '\P{^Decomposition_Type=-SMALL}', "");
    Error('\p{Dt=:=_Sml}');
    Error('\P{Dt=:=_Sml}');
    Expect(1, 65131, '\p{Dt=sml}', "");
    Expect(0, 65131, '\p{^Dt=sml}', "");
    Expect(0, 65131, '\P{Dt=sml}', "");
    Expect(1, 65131, '\P{^Dt=sml}', "");
    Expect(0, 65132, '\p{Dt=sml}', "");
    Expect(1, 65132, '\p{^Dt=sml}', "");
    Expect(1, 65132, '\P{Dt=sml}', "");
    Expect(0, 65132, '\P{^Dt=sml}', "");
    Expect(1, 65131, '\p{Dt=  Sml}', "");
    Expect(0, 65131, '\p{^Dt=  Sml}', "");
    Expect(0, 65131, '\P{Dt=  Sml}', "");
    Expect(1, 65131, '\P{^Dt=  Sml}', "");
    Expect(0, 65132, '\p{Dt=  Sml}', "");
    Expect(1, 65132, '\p{^Dt=  Sml}', "");
    Expect(1, 65132, '\P{Dt=  Sml}', "");
    Expect(0, 65132, '\P{^Dt=  Sml}', "");
    Error('\p{Is_Decomposition_Type:  -Small:=}');
    Error('\P{Is_Decomposition_Type:  -Small:=}');
    Expect(1, 65131, '\p{Is_Decomposition_Type=small}', "");
    Expect(0, 65131, '\p{^Is_Decomposition_Type=small}', "");
    Expect(0, 65131, '\P{Is_Decomposition_Type=small}', "");
    Expect(1, 65131, '\P{^Is_Decomposition_Type=small}', "");
    Expect(0, 65132, '\p{Is_Decomposition_Type=small}', "");
    Expect(1, 65132, '\p{^Is_Decomposition_Type=small}', "");
    Expect(1, 65132, '\P{Is_Decomposition_Type=small}', "");
    Expect(0, 65132, '\P{^Is_Decomposition_Type=small}', "");
    Expect(1, 65131, '\p{Is_Decomposition_Type: 	-SMALL}', "");
    Expect(0, 65131, '\p{^Is_Decomposition_Type: 	-SMALL}', "");
    Expect(0, 65131, '\P{Is_Decomposition_Type: 	-SMALL}', "");
    Expect(1, 65131, '\P{^Is_Decomposition_Type: 	-SMALL}', "");
    Expect(0, 65132, '\p{Is_Decomposition_Type: 	-SMALL}', "");
    Expect(1, 65132, '\p{^Is_Decomposition_Type: 	-SMALL}', "");
    Expect(1, 65132, '\P{Is_Decomposition_Type: 	-SMALL}', "");
    Expect(0, 65132, '\P{^Is_Decomposition_Type: 	-SMALL}', "");
    Error('\p{Is_Dt=	sml:=}');
    Error('\P{Is_Dt=	sml:=}');
    Expect(1, 65131, '\p{Is_Dt=sml}', "");
    Expect(0, 65131, '\p{^Is_Dt=sml}', "");
    Expect(0, 65131, '\P{Is_Dt=sml}', "");
    Expect(1, 65131, '\P{^Is_Dt=sml}', "");
    Expect(0, 65132, '\p{Is_Dt=sml}', "");
    Expect(1, 65132, '\p{^Is_Dt=sml}', "");
    Expect(1, 65132, '\P{Is_Dt=sml}', "");
    Expect(0, 65132, '\P{^Is_Dt=sml}', "");
    Expect(1, 65131, '\p{Is_Dt=	_Sml}', "");
    Expect(0, 65131, '\p{^Is_Dt=	_Sml}', "");
    Expect(0, 65131, '\P{Is_Dt=	_Sml}', "");
    Expect(1, 65131, '\P{^Is_Dt=	_Sml}', "");
    Expect(0, 65132, '\p{Is_Dt=	_Sml}', "");
    Expect(1, 65132, '\p{^Is_Dt=	_Sml}', "");
    Expect(1, 65132, '\P{Is_Dt=	_Sml}', "");
    Expect(0, 65132, '\P{^Is_Dt=	_Sml}', "");
    Error('\p{Decomposition_Type=- Square/a/}');
    Error('\P{Decomposition_Type=- Square/a/}');
    Expect(1, 127547, '\p{Decomposition_Type=square}', "");
    Expect(0, 127547, '\p{^Decomposition_Type=square}', "");
    Expect(0, 127547, '\P{Decomposition_Type=square}', "");
    Expect(1, 127547, '\P{^Decomposition_Type=square}', "");
    Expect(0, 127548, '\p{Decomposition_Type=square}', "");
    Expect(1, 127548, '\p{^Decomposition_Type=square}', "");
    Expect(1, 127548, '\P{Decomposition_Type=square}', "");
    Expect(0, 127548, '\P{^Decomposition_Type=square}', "");
    Expect(1, 127547, '\p{Decomposition_Type=	_SQUARE}', "");
    Expect(0, 127547, '\p{^Decomposition_Type=	_SQUARE}', "");
    Expect(0, 127547, '\P{Decomposition_Type=	_SQUARE}', "");
    Expect(1, 127547, '\P{^Decomposition_Type=	_SQUARE}', "");
    Expect(0, 127548, '\p{Decomposition_Type=	_SQUARE}', "");
    Expect(1, 127548, '\p{^Decomposition_Type=	_SQUARE}', "");
    Expect(1, 127548, '\P{Decomposition_Type=	_SQUARE}', "");
    Expect(0, 127548, '\P{^Decomposition_Type=	_SQUARE}', "");
    Error('\p{Dt= /a/Sqr}');
    Error('\P{Dt= /a/Sqr}');
    Expect(1, 127547, '\p{Dt:sqr}', "");
    Expect(0, 127547, '\p{^Dt:sqr}', "");
    Expect(0, 127547, '\P{Dt:sqr}', "");
    Expect(1, 127547, '\P{^Dt:sqr}', "");
    Expect(0, 127548, '\p{Dt:sqr}', "");
    Expect(1, 127548, '\p{^Dt:sqr}', "");
    Expect(1, 127548, '\P{Dt:sqr}', "");
    Expect(0, 127548, '\P{^Dt:sqr}', "");
    Expect(1, 127547, '\p{Dt= Sqr}', "");
    Expect(0, 127547, '\p{^Dt= Sqr}', "");
    Expect(0, 127547, '\P{Dt= Sqr}', "");
    Expect(1, 127547, '\P{^Dt= Sqr}', "");
    Expect(0, 127548, '\p{Dt= Sqr}', "");
    Expect(1, 127548, '\p{^Dt= Sqr}', "");
    Expect(1, 127548, '\P{Dt= Sqr}', "");
    Expect(0, 127548, '\P{^Dt= Sqr}', "");
    Error('\p{Is_Decomposition_Type=_Square/a/}');
    Error('\P{Is_Decomposition_Type=_Square/a/}');
    Expect(1, 127547, '\p{Is_Decomposition_Type=square}', "");
    Expect(0, 127547, '\p{^Is_Decomposition_Type=square}', "");
    Expect(0, 127547, '\P{Is_Decomposition_Type=square}', "");
    Expect(1, 127547, '\P{^Is_Decomposition_Type=square}', "");
    Expect(0, 127548, '\p{Is_Decomposition_Type=square}', "");
    Expect(1, 127548, '\p{^Is_Decomposition_Type=square}', "");
    Expect(1, 127548, '\P{Is_Decomposition_Type=square}', "");
    Expect(0, 127548, '\P{^Is_Decomposition_Type=square}', "");
    Expect(1, 127547, '\p{Is_Decomposition_Type=-_Square}', "");
    Expect(0, 127547, '\p{^Is_Decomposition_Type=-_Square}', "");
    Expect(0, 127547, '\P{Is_Decomposition_Type=-_Square}', "");
    Expect(1, 127547, '\P{^Is_Decomposition_Type=-_Square}', "");
    Expect(0, 127548, '\p{Is_Decomposition_Type=-_Square}', "");
    Expect(1, 127548, '\p{^Is_Decomposition_Type=-_Square}', "");
    Expect(1, 127548, '\P{Is_Decomposition_Type=-_Square}', "");
    Expect(0, 127548, '\P{^Is_Decomposition_Type=-_Square}', "");
    Error('\p{Is_Dt=	Sqr/a/}');
    Error('\P{Is_Dt=	Sqr/a/}');
    Expect(1, 127547, '\p{Is_Dt=sqr}', "");
    Expect(0, 127547, '\p{^Is_Dt=sqr}', "");
    Expect(0, 127547, '\P{Is_Dt=sqr}', "");
    Expect(1, 127547, '\P{^Is_Dt=sqr}', "");
    Expect(0, 127548, '\p{Is_Dt=sqr}', "");
    Expect(1, 127548, '\p{^Is_Dt=sqr}', "");
    Expect(1, 127548, '\P{Is_Dt=sqr}', "");
    Expect(0, 127548, '\P{^Is_Dt=sqr}', "");
    Expect(1, 127547, '\p{Is_Dt=	-sqr}', "");
    Expect(0, 127547, '\p{^Is_Dt=	-sqr}', "");
    Expect(0, 127547, '\P{Is_Dt=	-sqr}', "");
    Expect(1, 127547, '\P{^Is_Dt=	-sqr}', "");
    Expect(0, 127548, '\p{Is_Dt=	-sqr}', "");
    Expect(1, 127548, '\p{^Is_Dt=	-sqr}', "");
    Expect(1, 127548, '\P{Is_Dt=	-sqr}', "");
    Expect(0, 127548, '\P{^Is_Dt=	-sqr}', "");
    Error('\p{Decomposition_Type=_/a/sub}');
    Error('\P{Decomposition_Type=_/a/sub}');
    Expect(1, 11388, '\p{Decomposition_Type=sub}', "");
    Expect(0, 11388, '\p{^Decomposition_Type=sub}', "");
    Expect(0, 11388, '\P{Decomposition_Type=sub}', "");
    Expect(1, 11388, '\P{^Decomposition_Type=sub}', "");
    Expect(0, 11389, '\p{Decomposition_Type=sub}', "");
    Expect(1, 11389, '\p{^Decomposition_Type=sub}', "");
    Expect(1, 11389, '\P{Decomposition_Type=sub}', "");
    Expect(0, 11389, '\P{^Decomposition_Type=sub}', "");
    Expect(1, 11388, '\p{Decomposition_Type= 	Sub}', "");
    Expect(0, 11388, '\p{^Decomposition_Type= 	Sub}', "");
    Expect(0, 11388, '\P{Decomposition_Type= 	Sub}', "");
    Expect(1, 11388, '\P{^Decomposition_Type= 	Sub}', "");
    Expect(0, 11389, '\p{Decomposition_Type= 	Sub}', "");
    Expect(1, 11389, '\p{^Decomposition_Type= 	Sub}', "");
    Expect(1, 11389, '\P{Decomposition_Type= 	Sub}', "");
    Expect(0, 11389, '\P{^Decomposition_Type= 	Sub}', "");
    Error('\p{Dt=_	sub:=}');
    Error('\P{Dt=_	sub:=}');
    Expect(1, 11388, '\p{Dt=sub}', "");
    Expect(0, 11388, '\p{^Dt=sub}', "");
    Expect(0, 11388, '\P{Dt=sub}', "");
    Expect(1, 11388, '\P{^Dt=sub}', "");
    Expect(0, 11389, '\p{Dt=sub}', "");
    Expect(1, 11389, '\p{^Dt=sub}', "");
    Expect(1, 11389, '\P{Dt=sub}', "");
    Expect(0, 11389, '\P{^Dt=sub}', "");
    Expect(1, 11388, '\p{Dt=-SUB}', "");
    Expect(0, 11388, '\p{^Dt=-SUB}', "");
    Expect(0, 11388, '\P{Dt=-SUB}', "");
    Expect(1, 11388, '\P{^Dt=-SUB}', "");
    Expect(0, 11389, '\p{Dt=-SUB}', "");
    Expect(1, 11389, '\p{^Dt=-SUB}', "");
    Expect(1, 11389, '\P{Dt=-SUB}', "");
    Expect(0, 11389, '\P{^Dt=-SUB}', "");
    Error('\p{Is_Decomposition_Type=	 Sub/a/}');
    Error('\P{Is_Decomposition_Type=	 Sub/a/}');
    Expect(1, 11388, '\p{Is_Decomposition_Type=sub}', "");
    Expect(0, 11388, '\p{^Is_Decomposition_Type=sub}', "");
    Expect(0, 11388, '\P{Is_Decomposition_Type=sub}', "");
    Expect(1, 11388, '\P{^Is_Decomposition_Type=sub}', "");
    Expect(0, 11389, '\p{Is_Decomposition_Type=sub}', "");
    Expect(1, 11389, '\p{^Is_Decomposition_Type=sub}', "");
    Expect(1, 11389, '\P{Is_Decomposition_Type=sub}', "");
    Expect(0, 11389, '\P{^Is_Decomposition_Type=sub}', "");
    Expect(1, 11388, '\p{Is_Decomposition_Type= _SUB}', "");
    Expect(0, 11388, '\p{^Is_Decomposition_Type= _SUB}', "");
    Expect(0, 11388, '\P{Is_Decomposition_Type= _SUB}', "");
    Expect(1, 11388, '\P{^Is_Decomposition_Type= _SUB}', "");
    Expect(0, 11389, '\p{Is_Decomposition_Type= _SUB}', "");
    Expect(1, 11389, '\p{^Is_Decomposition_Type= _SUB}', "");
    Expect(1, 11389, '\P{Is_Decomposition_Type= _SUB}', "");
    Expect(0, 11389, '\P{^Is_Decomposition_Type= _SUB}', "");
    Error('\p{Is_Dt= sub:=}');
    Error('\P{Is_Dt= sub:=}');
    Expect(1, 11388, '\p{Is_Dt=sub}', "");
    Expect(0, 11388, '\p{^Is_Dt=sub}', "");
    Expect(0, 11388, '\P{Is_Dt=sub}', "");
    Expect(1, 11388, '\P{^Is_Dt=sub}', "");
    Expect(0, 11389, '\p{Is_Dt=sub}', "");
    Expect(1, 11389, '\p{^Is_Dt=sub}', "");
    Expect(1, 11389, '\P{Is_Dt=sub}', "");
    Expect(0, 11389, '\P{^Is_Dt=sub}', "");
    Expect(1, 11388, '\p{Is_Dt=-_sub}', "");
    Expect(0, 11388, '\p{^Is_Dt=-_sub}', "");
    Expect(0, 11388, '\P{Is_Dt=-_sub}', "");
    Expect(1, 11388, '\P{^Is_Dt=-_sub}', "");
    Expect(0, 11389, '\p{Is_Dt=-_sub}', "");
    Expect(1, 11389, '\p{^Is_Dt=-_sub}', "");
    Expect(1, 11389, '\P{Is_Dt=-_sub}', "");
    Expect(0, 11389, '\P{^Is_Dt=-_sub}', "");
    Error('\p{Decomposition_Type=	 SUPER/a/}');
    Error('\P{Decomposition_Type=	 SUPER/a/}');
    Expect(1, 127339, '\p{Decomposition_Type=super}', "");
    Expect(0, 127339, '\p{^Decomposition_Type=super}', "");
    Expect(0, 127339, '\P{Decomposition_Type=super}', "");
    Expect(1, 127339, '\P{^Decomposition_Type=super}', "");
    Expect(0, 127340, '\p{Decomposition_Type=super}', "");
    Expect(1, 127340, '\p{^Decomposition_Type=super}', "");
    Expect(1, 127340, '\P{Decomposition_Type=super}', "");
    Expect(0, 127340, '\P{^Decomposition_Type=super}', "");
    Expect(1, 127339, '\p{Decomposition_Type= 	super}', "");
    Expect(0, 127339, '\p{^Decomposition_Type= 	super}', "");
    Expect(0, 127339, '\P{Decomposition_Type= 	super}', "");
    Expect(1, 127339, '\P{^Decomposition_Type= 	super}', "");
    Expect(0, 127340, '\p{Decomposition_Type= 	super}', "");
    Expect(1, 127340, '\p{^Decomposition_Type= 	super}', "");
    Expect(1, 127340, '\P{Decomposition_Type= 	super}', "");
    Expect(0, 127340, '\P{^Decomposition_Type= 	super}', "");
    Error('\p{Dt= -Sup:=}');
    Error('\P{Dt= -Sup:=}');
    Expect(1, 127339, '\p{Dt=sup}', "");
    Expect(0, 127339, '\p{^Dt=sup}', "");
    Expect(0, 127339, '\P{Dt=sup}', "");
    Expect(1, 127339, '\P{^Dt=sup}', "");
    Expect(0, 127340, '\p{Dt=sup}', "");
    Expect(1, 127340, '\p{^Dt=sup}', "");
    Expect(1, 127340, '\P{Dt=sup}', "");
    Expect(0, 127340, '\P{^Dt=sup}', "");
    Expect(1, 127339, '\p{Dt=_ Sup}', "");
    Expect(0, 127339, '\p{^Dt=_ Sup}', "");
    Expect(0, 127339, '\P{Dt=_ Sup}', "");
    Expect(1, 127339, '\P{^Dt=_ Sup}', "");
    Expect(0, 127340, '\p{Dt=_ Sup}', "");
    Expect(1, 127340, '\p{^Dt=_ Sup}', "");
    Expect(1, 127340, '\P{Dt=_ Sup}', "");
    Expect(0, 127340, '\P{^Dt=_ Sup}', "");
    Error('\p{Is_Decomposition_Type=_	SUPER/a/}');
    Error('\P{Is_Decomposition_Type=_	SUPER/a/}');
    Expect(1, 127339, '\p{Is_Decomposition_Type=super}', "");
    Expect(0, 127339, '\p{^Is_Decomposition_Type=super}', "");
    Expect(0, 127339, '\P{Is_Decomposition_Type=super}', "");
    Expect(1, 127339, '\P{^Is_Decomposition_Type=super}', "");
    Expect(0, 127340, '\p{Is_Decomposition_Type=super}', "");
    Expect(1, 127340, '\p{^Is_Decomposition_Type=super}', "");
    Expect(1, 127340, '\P{Is_Decomposition_Type=super}', "");
    Expect(0, 127340, '\P{^Is_Decomposition_Type=super}', "");
    Expect(1, 127339, '\p{Is_Decomposition_Type= super}', "");
    Expect(0, 127339, '\p{^Is_Decomposition_Type= super}', "");
    Expect(0, 127339, '\P{Is_Decomposition_Type= super}', "");
    Expect(1, 127339, '\P{^Is_Decomposition_Type= super}', "");
    Expect(0, 127340, '\p{Is_Decomposition_Type= super}', "");
    Expect(1, 127340, '\p{^Is_Decomposition_Type= super}', "");
    Expect(1, 127340, '\P{Is_Decomposition_Type= super}', "");
    Expect(0, 127340, '\P{^Is_Decomposition_Type= super}', "");
    Error('\p{Is_Dt=-Sup:=}');
    Error('\P{Is_Dt=-Sup:=}');
    Expect(1, 127339, '\p{Is_Dt=sup}', "");
    Expect(0, 127339, '\p{^Is_Dt=sup}', "");
    Expect(0, 127339, '\P{Is_Dt=sup}', "");
    Expect(1, 127339, '\P{^Is_Dt=sup}', "");
    Expect(0, 127340, '\p{Is_Dt=sup}', "");
    Expect(1, 127340, '\p{^Is_Dt=sup}', "");
    Expect(1, 127340, '\P{Is_Dt=sup}', "");
    Expect(0, 127340, '\P{^Is_Dt=sup}', "");
    Expect(1, 127339, '\p{Is_Dt=_-SUP}', "");
    Expect(0, 127339, '\p{^Is_Dt=_-SUP}', "");
    Expect(0, 127339, '\P{Is_Dt=_-SUP}', "");
    Expect(1, 127339, '\P{^Is_Dt=_-SUP}', "");
    Expect(0, 127340, '\p{Is_Dt=_-SUP}', "");
    Expect(1, 127340, '\p{^Is_Dt=_-SUP}', "");
    Expect(1, 127340, '\P{Is_Dt=_-SUP}', "");
    Expect(0, 127340, '\P{^Is_Dt=_-SUP}', "");
    Error('\p{Decomposition_Type=:=_Vertical}');
    Error('\P{Decomposition_Type=:=_Vertical}');
    Expect(1, 65096, '\p{Decomposition_Type=vertical}', "");
    Expect(0, 65096, '\p{^Decomposition_Type=vertical}', "");
    Expect(0, 65096, '\P{Decomposition_Type=vertical}', "");
    Expect(1, 65096, '\P{^Decomposition_Type=vertical}', "");
    Expect(0, 65097, '\p{Decomposition_Type=vertical}', "");
    Expect(1, 65097, '\p{^Decomposition_Type=vertical}', "");
    Expect(1, 65097, '\P{Decomposition_Type=vertical}', "");
    Expect(0, 65097, '\P{^Decomposition_Type=vertical}', "");
    Expect(1, 65096, '\p{Decomposition_Type:   _vertical}', "");
    Expect(0, 65096, '\p{^Decomposition_Type:   _vertical}', "");
    Expect(0, 65096, '\P{Decomposition_Type:   _vertical}', "");
    Expect(1, 65096, '\P{^Decomposition_Type:   _vertical}', "");
    Expect(0, 65097, '\p{Decomposition_Type:   _vertical}', "");
    Expect(1, 65097, '\p{^Decomposition_Type:   _vertical}', "");
    Expect(1, 65097, '\P{Decomposition_Type:   _vertical}', "");
    Expect(0, 65097, '\P{^Decomposition_Type:   _vertical}', "");
    Error('\p{Dt= _VERT:=}');
    Error('\P{Dt= _VERT:=}');
    Expect(1, 65096, '\p{Dt=vert}', "");
    Expect(0, 65096, '\p{^Dt=vert}', "");
    Expect(0, 65096, '\P{Dt=vert}', "");
    Expect(1, 65096, '\P{^Dt=vert}', "");
    Expect(0, 65097, '\p{Dt=vert}', "");
    Expect(1, 65097, '\p{^Dt=vert}', "");
    Expect(1, 65097, '\P{Dt=vert}', "");
    Expect(0, 65097, '\P{^Dt=vert}', "");
    Expect(1, 65096, '\p{Dt=-	Vert}', "");
    Expect(0, 65096, '\p{^Dt=-	Vert}', "");
    Expect(0, 65096, '\P{Dt=-	Vert}', "");
    Expect(1, 65096, '\P{^Dt=-	Vert}', "");
    Expect(0, 65097, '\p{Dt=-	Vert}', "");
    Expect(1, 65097, '\p{^Dt=-	Vert}', "");
    Expect(1, 65097, '\P{Dt=-	Vert}', "");
    Expect(0, 65097, '\P{^Dt=-	Vert}', "");
    Error('\p{Is_Decomposition_Type=/a/_ Vertical}');
    Error('\P{Is_Decomposition_Type=/a/_ Vertical}');
    Expect(1, 65096, '\p{Is_Decomposition_Type=vertical}', "");
    Expect(0, 65096, '\p{^Is_Decomposition_Type=vertical}', "");
    Expect(0, 65096, '\P{Is_Decomposition_Type=vertical}', "");
    Expect(1, 65096, '\P{^Is_Decomposition_Type=vertical}', "");
    Expect(0, 65097, '\p{Is_Decomposition_Type=vertical}', "");
    Expect(1, 65097, '\p{^Is_Decomposition_Type=vertical}', "");
    Expect(1, 65097, '\P{Is_Decomposition_Type=vertical}', "");
    Expect(0, 65097, '\P{^Is_Decomposition_Type=vertical}', "");
    Expect(1, 65096, '\p{Is_Decomposition_Type= _Vertical}', "");
    Expect(0, 65096, '\p{^Is_Decomposition_Type= _Vertical}', "");
    Expect(0, 65096, '\P{Is_Decomposition_Type= _Vertical}', "");
    Expect(1, 65096, '\P{^Is_Decomposition_Type= _Vertical}', "");
    Expect(0, 65097, '\p{Is_Decomposition_Type= _Vertical}', "");
    Expect(1, 65097, '\p{^Is_Decomposition_Type= _Vertical}', "");
    Expect(1, 65097, '\P{Is_Decomposition_Type= _Vertical}', "");
    Expect(0, 65097, '\P{^Is_Decomposition_Type= _Vertical}', "");
    Error('\p{Is_Dt=	/a/VERT}');
    Error('\P{Is_Dt=	/a/VERT}');
    Expect(1, 65096, '\p{Is_Dt=vert}', "");
    Expect(0, 65096, '\p{^Is_Dt=vert}', "");
    Expect(0, 65096, '\P{Is_Dt=vert}', "");
    Expect(1, 65096, '\P{^Is_Dt=vert}', "");
    Expect(0, 65097, '\p{Is_Dt=vert}', "");
    Expect(1, 65097, '\p{^Is_Dt=vert}', "");
    Expect(1, 65097, '\P{Is_Dt=vert}', "");
    Expect(0, 65097, '\P{^Is_Dt=vert}', "");
    Expect(1, 65096, '\p{Is_Dt=_-VERT}', "");
    Expect(0, 65096, '\p{^Is_Dt=_-VERT}', "");
    Expect(0, 65096, '\P{Is_Dt=_-VERT}', "");
    Expect(1, 65096, '\P{^Is_Dt=_-VERT}', "");
    Expect(0, 65097, '\p{Is_Dt=_-VERT}', "");
    Expect(1, 65097, '\p{^Is_Dt=_-VERT}', "");
    Expect(1, 65097, '\P{Is_Dt=_-VERT}', "");
    Expect(0, 65097, '\P{^Is_Dt=_-VERT}', "");
    Error('\p{Decomposition_Type=	-Wide/a/}');
    Error('\P{Decomposition_Type=	-Wide/a/}');
    Expect(1, 65510, '\p{Decomposition_Type=wide}', "");
    Expect(0, 65510, '\p{^Decomposition_Type=wide}', "");
    Expect(0, 65510, '\P{Decomposition_Type=wide}', "");
    Expect(1, 65510, '\P{^Decomposition_Type=wide}', "");
    Expect(0, 65511, '\p{Decomposition_Type=wide}', "");
    Expect(1, 65511, '\p{^Decomposition_Type=wide}', "");
    Expect(1, 65511, '\P{Decomposition_Type=wide}', "");
    Expect(0, 65511, '\P{^Decomposition_Type=wide}', "");
    Expect(1, 65510, '\p{Decomposition_Type=	-WIDE}', "");
    Expect(0, 65510, '\p{^Decomposition_Type=	-WIDE}', "");
    Expect(0, 65510, '\P{Decomposition_Type=	-WIDE}', "");
    Expect(1, 65510, '\P{^Decomposition_Type=	-WIDE}', "");
    Expect(0, 65511, '\p{Decomposition_Type=	-WIDE}', "");
    Expect(1, 65511, '\p{^Decomposition_Type=	-WIDE}', "");
    Expect(1, 65511, '\P{Decomposition_Type=	-WIDE}', "");
    Expect(0, 65511, '\P{^Decomposition_Type=	-WIDE}', "");
    Error('\p{Dt=/a/	wide}');
    Error('\P{Dt=/a/	wide}');
    Expect(1, 65510, '\p{Dt: wide}', "");
    Expect(0, 65510, '\p{^Dt: wide}', "");
    Expect(0, 65510, '\P{Dt: wide}', "");
    Expect(1, 65510, '\P{^Dt: wide}', "");
    Expect(0, 65511, '\p{Dt: wide}', "");
    Expect(1, 65511, '\p{^Dt: wide}', "");
    Expect(1, 65511, '\P{Dt: wide}', "");
    Expect(0, 65511, '\P{^Dt: wide}', "");
    Expect(1, 65510, '\p{Dt=_ WIDE}', "");
    Expect(0, 65510, '\p{^Dt=_ WIDE}', "");
    Expect(0, 65510, '\P{Dt=_ WIDE}', "");
    Expect(1, 65510, '\P{^Dt=_ WIDE}', "");
    Expect(0, 65511, '\p{Dt=_ WIDE}', "");
    Expect(1, 65511, '\p{^Dt=_ WIDE}', "");
    Expect(1, 65511, '\P{Dt=_ WIDE}', "");
    Expect(0, 65511, '\P{^Dt=_ WIDE}', "");
    Error('\p{Is_Decomposition_Type=/a/_	Wide}');
    Error('\P{Is_Decomposition_Type=/a/_	Wide}');
    Expect(1, 65510, '\p{Is_Decomposition_Type=wide}', "");
    Expect(0, 65510, '\p{^Is_Decomposition_Type=wide}', "");
    Expect(0, 65510, '\P{Is_Decomposition_Type=wide}', "");
    Expect(1, 65510, '\P{^Is_Decomposition_Type=wide}', "");
    Expect(0, 65511, '\p{Is_Decomposition_Type=wide}', "");
    Expect(1, 65511, '\p{^Is_Decomposition_Type=wide}', "");
    Expect(1, 65511, '\P{Is_Decomposition_Type=wide}', "");
    Expect(0, 65511, '\P{^Is_Decomposition_Type=wide}', "");
    Expect(1, 65510, '\p{Is_Decomposition_Type=_-wide}', "");
    Expect(0, 65510, '\p{^Is_Decomposition_Type=_-wide}', "");
    Expect(0, 65510, '\P{Is_Decomposition_Type=_-wide}', "");
    Expect(1, 65510, '\P{^Is_Decomposition_Type=_-wide}', "");
    Expect(0, 65511, '\p{Is_Decomposition_Type=_-wide}', "");
    Expect(1, 65511, '\p{^Is_Decomposition_Type=_-wide}', "");
    Expect(1, 65511, '\P{Is_Decomposition_Type=_-wide}', "");
    Expect(0, 65511, '\P{^Is_Decomposition_Type=_-wide}', "");
    Error('\p{Is_Dt=- Wide:=}');
    Error('\P{Is_Dt=- Wide:=}');
    Expect(1, 65510, '\p{Is_Dt=wide}', "");
    Expect(0, 65510, '\p{^Is_Dt=wide}', "");
    Expect(0, 65510, '\P{Is_Dt=wide}', "");
    Expect(1, 65510, '\P{^Is_Dt=wide}', "");
    Expect(0, 65511, '\p{Is_Dt=wide}', "");
    Expect(1, 65511, '\p{^Is_Dt=wide}', "");
    Expect(1, 65511, '\P{Is_Dt=wide}', "");
    Expect(0, 65511, '\P{^Is_Dt=wide}', "");
    Expect(1, 65510, '\p{Is_Dt:   _ wide}', "");
    Expect(0, 65510, '\p{^Is_Dt:   _ wide}', "");
    Expect(0, 65510, '\P{Is_Dt:   _ wide}', "");
    Expect(1, 65510, '\P{^Is_Dt:   _ wide}', "");
    Expect(0, 65511, '\p{Is_Dt:   _ wide}', "");
    Expect(1, 65511, '\p{^Is_Dt:   _ wide}', "");
    Expect(1, 65511, '\P{Is_Dt:   _ wide}', "");
    Expect(0, 65511, '\P{^Is_Dt:   _ wide}', "");
    Error('\p{eastasianwidth}');
    Error('\P{eastasianwidth}');
    Error('\p{ea}');
    Error('\P{ea}');
    Error('\p{East_Asian_Width=_ambiguous:=}');
    Error('\P{East_Asian_Width=_ambiguous:=}');
    Expect(1, 1114109, '\p{East_Asian_Width=ambiguous}', "");
    Expect(0, 1114109, '\p{^East_Asian_Width=ambiguous}', "");
    Expect(0, 1114109, '\P{East_Asian_Width=ambiguous}', "");
    Expect(1, 1114109, '\P{^East_Asian_Width=ambiguous}', "");
    Expect(0, 918000, '\p{East_Asian_Width=ambiguous}', "");
    Expect(1, 918000, '\p{^East_Asian_Width=ambiguous}', "");
    Expect(1, 918000, '\P{East_Asian_Width=ambiguous}', "");
    Expect(0, 918000, '\P{^East_Asian_Width=ambiguous}', "");
    Expect(1, 1114109, '\p{East_Asian_Width=_	ambiguous}', "");
    Expect(0, 1114109, '\p{^East_Asian_Width=_	ambiguous}', "");
    Expect(0, 1114109, '\P{East_Asian_Width=_	ambiguous}', "");
    Expect(1, 1114109, '\P{^East_Asian_Width=_	ambiguous}', "");
    Expect(0, 918000, '\p{East_Asian_Width=_	ambiguous}', "");
    Expect(1, 918000, '\p{^East_Asian_Width=_	ambiguous}', "");
    Expect(1, 918000, '\P{East_Asian_Width=_	ambiguous}', "");
    Expect(0, 918000, '\P{^East_Asian_Width=_	ambiguous}', "");
    Error('\p{Ea= /a/a}');
    Error('\P{Ea= /a/a}');
    Expect(1, 1114109, '\p{Ea=a}', "");
    Expect(0, 1114109, '\p{^Ea=a}', "");
    Expect(0, 1114109, '\P{Ea=a}', "");
    Expect(1, 1114109, '\P{^Ea=a}', "");
    Expect(0, 918000, '\p{Ea=a}', "");
    Expect(1, 918000, '\p{^Ea=a}', "");
    Expect(1, 918000, '\P{Ea=a}', "");
    Expect(0, 918000, '\P{^Ea=a}', "");
    Expect(1, 1114109, '\p{Ea=	A}', "");
    Expect(0, 1114109, '\p{^Ea=	A}', "");
    Expect(0, 1114109, '\P{Ea=	A}', "");
    Expect(1, 1114109, '\P{^Ea=	A}', "");
    Expect(0, 918000, '\p{Ea=	A}', "");
    Expect(1, 918000, '\p{^Ea=	A}', "");
    Expect(1, 918000, '\P{Ea=	A}', "");
    Expect(0, 918000, '\P{^Ea=	A}', "");
    Error('\p{Is_East_Asian_Width=  Ambiguous/a/}');
    Error('\P{Is_East_Asian_Width=  Ambiguous/a/}');
    Expect(1, 1114109, '\p{Is_East_Asian_Width=ambiguous}', "");
    Expect(0, 1114109, '\p{^Is_East_Asian_Width=ambiguous}', "");
    Expect(0, 1114109, '\P{Is_East_Asian_Width=ambiguous}', "");
    Expect(1, 1114109, '\P{^Is_East_Asian_Width=ambiguous}', "");
    Expect(0, 918000, '\p{Is_East_Asian_Width=ambiguous}', "");
    Expect(1, 918000, '\p{^Is_East_Asian_Width=ambiguous}', "");
    Expect(1, 918000, '\P{Is_East_Asian_Width=ambiguous}', "");
    Expect(0, 918000, '\P{^Is_East_Asian_Width=ambiguous}', "");
    Expect(1, 1114109, '\p{Is_East_Asian_Width=-_ambiguous}', "");
    Expect(0, 1114109, '\p{^Is_East_Asian_Width=-_ambiguous}', "");
    Expect(0, 1114109, '\P{Is_East_Asian_Width=-_ambiguous}', "");
    Expect(1, 1114109, '\P{^Is_East_Asian_Width=-_ambiguous}', "");
    Expect(0, 918000, '\p{Is_East_Asian_Width=-_ambiguous}', "");
    Expect(1, 918000, '\p{^Is_East_Asian_Width=-_ambiguous}', "");
    Expect(1, 918000, '\P{Is_East_Asian_Width=-_ambiguous}', "");
    Expect(0, 918000, '\P{^Is_East_Asian_Width=-_ambiguous}', "");
    Error('\p{Is_Ea: /a/		A}');
    Error('\P{Is_Ea: /a/		A}');
    Expect(1, 1114109, '\p{Is_Ea=a}', "");
    Expect(0, 1114109, '\p{^Is_Ea=a}', "");
    Expect(0, 1114109, '\P{Is_Ea=a}', "");
    Expect(1, 1114109, '\P{^Is_Ea=a}', "");
    Expect(0, 918000, '\p{Is_Ea=a}', "");
    Expect(1, 918000, '\p{^Is_Ea=a}', "");
    Expect(1, 918000, '\P{Is_Ea=a}', "");
    Expect(0, 918000, '\P{^Is_Ea=a}', "");
    Expect(1, 1114109, '\p{Is_Ea=-_A}', "");
    Expect(0, 1114109, '\p{^Is_Ea=-_A}', "");
    Expect(0, 1114109, '\P{Is_Ea=-_A}', "");
    Expect(1, 1114109, '\P{^Is_Ea=-_A}', "");
    Expect(0, 918000, '\p{Is_Ea=-_A}', "");
    Expect(1, 918000, '\p{^Is_Ea=-_A}', "");
    Expect(1, 918000, '\P{Is_Ea=-_A}', "");
    Expect(0, 918000, '\P{^Is_Ea=-_A}', "");
    Error('\p{East_Asian_Width:    :=FULLWIDTH}');
    Error('\P{East_Asian_Width:    :=FULLWIDTH}');
    Expect(1, 65510, '\p{East_Asian_Width=fullwidth}', "");
    Expect(0, 65510, '\p{^East_Asian_Width=fullwidth}', "");
    Expect(0, 65510, '\P{East_Asian_Width=fullwidth}', "");
    Expect(1, 65510, '\P{^East_Asian_Width=fullwidth}', "");
    Expect(0, 65511, '\p{East_Asian_Width=fullwidth}', "");
    Expect(1, 65511, '\p{^East_Asian_Width=fullwidth}', "");
    Expect(1, 65511, '\P{East_Asian_Width=fullwidth}', "");
    Expect(0, 65511, '\P{^East_Asian_Width=fullwidth}', "");
    Expect(1, 65510, '\p{East_Asian_Width: - Fullwidth}', "");
    Expect(0, 65510, '\p{^East_Asian_Width: - Fullwidth}', "");
    Expect(0, 65510, '\P{East_Asian_Width: - Fullwidth}', "");
    Expect(1, 65510, '\P{^East_Asian_Width: - Fullwidth}', "");
    Expect(0, 65511, '\p{East_Asian_Width: - Fullwidth}', "");
    Expect(1, 65511, '\p{^East_Asian_Width: - Fullwidth}', "");
    Expect(1, 65511, '\P{East_Asian_Width: - Fullwidth}', "");
    Expect(0, 65511, '\P{^East_Asian_Width: - Fullwidth}', "");
    Error('\p{Ea=/a/-	F}');
    Error('\P{Ea=/a/-	F}');
    Expect(1, 65510, '\p{Ea=f}', "");
    Expect(0, 65510, '\p{^Ea=f}', "");
    Expect(0, 65510, '\P{Ea=f}', "");
    Expect(1, 65510, '\P{^Ea=f}', "");
    Expect(0, 65511, '\p{Ea=f}', "");
    Expect(1, 65511, '\p{^Ea=f}', "");
    Expect(1, 65511, '\P{Ea=f}', "");
    Expect(0, 65511, '\P{^Ea=f}', "");
    Expect(1, 65510, '\p{Ea= 	f}', "");
    Expect(0, 65510, '\p{^Ea= 	f}', "");
    Expect(0, 65510, '\P{Ea= 	f}', "");
    Expect(1, 65510, '\P{^Ea= 	f}', "");
    Expect(0, 65511, '\p{Ea= 	f}', "");
    Expect(1, 65511, '\p{^Ea= 	f}', "");
    Expect(1, 65511, '\P{Ea= 	f}', "");
    Expect(0, 65511, '\P{^Ea= 	f}', "");
    Error('\p{Is_East_Asian_Width:	:= _Fullwidth}');
    Error('\P{Is_East_Asian_Width:	:= _Fullwidth}');
    Expect(1, 65510, '\p{Is_East_Asian_Width=fullwidth}', "");
    Expect(0, 65510, '\p{^Is_East_Asian_Width=fullwidth}', "");
    Expect(0, 65510, '\P{Is_East_Asian_Width=fullwidth}', "");
    Expect(1, 65510, '\P{^Is_East_Asian_Width=fullwidth}', "");
    Expect(0, 65511, '\p{Is_East_Asian_Width=fullwidth}', "");
    Expect(1, 65511, '\p{^Is_East_Asian_Width=fullwidth}', "");
    Expect(1, 65511, '\P{Is_East_Asian_Width=fullwidth}', "");
    Expect(0, 65511, '\P{^Is_East_Asian_Width=fullwidth}', "");
    Expect(1, 65510, '\p{Is_East_Asian_Width=-Fullwidth}', "");
    Expect(0, 65510, '\p{^Is_East_Asian_Width=-Fullwidth}', "");
    Expect(0, 65510, '\P{Is_East_Asian_Width=-Fullwidth}', "");
    Expect(1, 65510, '\P{^Is_East_Asian_Width=-Fullwidth}', "");
    Expect(0, 65511, '\p{Is_East_Asian_Width=-Fullwidth}', "");
    Expect(1, 65511, '\p{^Is_East_Asian_Width=-Fullwidth}', "");
    Expect(1, 65511, '\P{Is_East_Asian_Width=-Fullwidth}', "");
    Expect(0, 65511, '\P{^Is_East_Asian_Width=-Fullwidth}', "");
    Error('\p{Is_Ea=_:=F}');
    Error('\P{Is_Ea=_:=F}');
    Expect(1, 65510, '\p{Is_Ea=f}', "");
    Expect(0, 65510, '\p{^Is_Ea=f}', "");
    Expect(0, 65510, '\P{Is_Ea=f}', "");
    Expect(1, 65510, '\P{^Is_Ea=f}', "");
    Expect(0, 65511, '\p{Is_Ea=f}', "");
    Expect(1, 65511, '\p{^Is_Ea=f}', "");
    Expect(1, 65511, '\P{Is_Ea=f}', "");
    Expect(0, 65511, '\P{^Is_Ea=f}', "");
    Expect(1, 65510, '\p{Is_Ea=	f}', "");
    Expect(0, 65510, '\p{^Is_Ea=	f}', "");
    Expect(0, 65510, '\P{Is_Ea=	f}', "");
    Expect(1, 65510, '\P{^Is_Ea=	f}', "");
    Expect(0, 65511, '\p{Is_Ea=	f}', "");
    Expect(1, 65511, '\p{^Is_Ea=	f}', "");
    Expect(1, 65511, '\P{Is_Ea=	f}', "");
    Expect(0, 65511, '\P{^Is_Ea=	f}', "");
    Error('\p{East_Asian_Width=- halfwidth:=}');
    Error('\P{East_Asian_Width=- halfwidth:=}');
    Expect(1, 65518, '\p{East_Asian_Width=halfwidth}', "");
    Expect(0, 65518, '\p{^East_Asian_Width=halfwidth}', "");
    Expect(0, 65518, '\P{East_Asian_Width=halfwidth}', "");
    Expect(1, 65518, '\P{^East_Asian_Width=halfwidth}', "");
    Expect(0, 65519, '\p{East_Asian_Width=halfwidth}', "");
    Expect(1, 65519, '\p{^East_Asian_Width=halfwidth}', "");
    Expect(1, 65519, '\P{East_Asian_Width=halfwidth}', "");
    Expect(0, 65519, '\P{^East_Asian_Width=halfwidth}', "");
    Expect(1, 65518, '\p{East_Asian_Width=  halfwidth}', "");
    Expect(0, 65518, '\p{^East_Asian_Width=  halfwidth}', "");
    Expect(0, 65518, '\P{East_Asian_Width=  halfwidth}', "");
    Expect(1, 65518, '\P{^East_Asian_Width=  halfwidth}', "");
    Expect(0, 65519, '\p{East_Asian_Width=  halfwidth}', "");
    Expect(1, 65519, '\p{^East_Asian_Width=  halfwidth}', "");
    Expect(1, 65519, '\P{East_Asian_Width=  halfwidth}', "");
    Expect(0, 65519, '\P{^East_Asian_Width=  halfwidth}', "");
    Error('\p{Ea=_h:=}');
    Error('\P{Ea=_h:=}');
    Expect(1, 65518, '\p{Ea=h}', "");
    Expect(0, 65518, '\p{^Ea=h}', "");
    Expect(0, 65518, '\P{Ea=h}', "");
    Expect(1, 65518, '\P{^Ea=h}', "");
    Expect(0, 65519, '\p{Ea=h}', "");
    Expect(1, 65519, '\p{^Ea=h}', "");
    Expect(1, 65519, '\P{Ea=h}', "");
    Expect(0, 65519, '\P{^Ea=h}', "");
    Expect(1, 65518, '\p{Ea= 	h}', "");
    Expect(0, 65518, '\p{^Ea= 	h}', "");
    Expect(0, 65518, '\P{Ea= 	h}', "");
    Expect(1, 65518, '\P{^Ea= 	h}', "");
    Expect(0, 65519, '\p{Ea= 	h}', "");
    Expect(1, 65519, '\p{^Ea= 	h}', "");
    Expect(1, 65519, '\P{Ea= 	h}', "");
    Expect(0, 65519, '\P{^Ea= 	h}', "");
    Error('\p{Is_East_Asian_Width:_:=HALFWIDTH}');
    Error('\P{Is_East_Asian_Width:_:=HALFWIDTH}');
    Expect(1, 65518, '\p{Is_East_Asian_Width=halfwidth}', "");
    Expect(0, 65518, '\p{^Is_East_Asian_Width=halfwidth}', "");
    Expect(0, 65518, '\P{Is_East_Asian_Width=halfwidth}', "");
    Expect(1, 65518, '\P{^Is_East_Asian_Width=halfwidth}', "");
    Expect(0, 65519, '\p{Is_East_Asian_Width=halfwidth}', "");
    Expect(1, 65519, '\p{^Is_East_Asian_Width=halfwidth}', "");
    Expect(1, 65519, '\P{Is_East_Asian_Width=halfwidth}', "");
    Expect(0, 65519, '\P{^Is_East_Asian_Width=halfwidth}', "");
    Expect(1, 65518, '\p{Is_East_Asian_Width=--halfwidth}', "");
    Expect(0, 65518, '\p{^Is_East_Asian_Width=--halfwidth}', "");
    Expect(0, 65518, '\P{Is_East_Asian_Width=--halfwidth}', "");
    Expect(1, 65518, '\P{^Is_East_Asian_Width=--halfwidth}', "");
    Expect(0, 65519, '\p{Is_East_Asian_Width=--halfwidth}', "");
    Expect(1, 65519, '\p{^Is_East_Asian_Width=--halfwidth}', "");
    Expect(1, 65519, '\P{Is_East_Asian_Width=--halfwidth}', "");
    Expect(0, 65519, '\P{^Is_East_Asian_Width=--halfwidth}', "");
    Error('\p{Is_Ea:		/a/H}');
    Error('\P{Is_Ea:		/a/H}');
    Expect(1, 65518, '\p{Is_Ea=h}', "");
    Expect(0, 65518, '\p{^Is_Ea=h}', "");
    Expect(0, 65518, '\P{Is_Ea=h}', "");
    Expect(1, 65518, '\P{^Is_Ea=h}', "");
    Expect(0, 65519, '\p{Is_Ea=h}', "");
    Expect(1, 65519, '\p{^Is_Ea=h}', "");
    Expect(1, 65519, '\P{Is_Ea=h}', "");
    Expect(0, 65519, '\P{^Is_Ea=h}', "");
    Expect(1, 65518, '\p{Is_Ea=_-H}', "");
    Expect(0, 65518, '\p{^Is_Ea=_-H}', "");
    Expect(0, 65518, '\P{Is_Ea=_-H}', "");
    Expect(1, 65518, '\P{^Is_Ea=_-H}', "");
    Expect(0, 65519, '\p{Is_Ea=_-H}', "");
    Expect(1, 65519, '\p{^Is_Ea=_-H}', "");
    Expect(1, 65519, '\P{Is_Ea=_-H}', "");
    Expect(0, 65519, '\P{^Is_Ea=_-H}', "");
    Error('\p{East_Asian_Width=/a/-	neutral}');
    Error('\P{East_Asian_Width=/a/-	neutral}');
    Expect(1, 918000, '\p{East_Asian_Width=neutral}', "");
    Expect(0, 918000, '\p{^East_Asian_Width=neutral}', "");
    Expect(0, 918000, '\P{East_Asian_Width=neutral}', "");
    Expect(1, 918000, '\P{^East_Asian_Width=neutral}', "");
    Expect(0, 1114109, '\p{East_Asian_Width=neutral}', "");
    Expect(1, 1114109, '\p{^East_Asian_Width=neutral}', "");
    Expect(1, 1114109, '\P{East_Asian_Width=neutral}', "");
    Expect(0, 1114109, '\P{^East_Asian_Width=neutral}', "");
    Expect(1, 918000, '\p{East_Asian_Width=-NEUTRAL}', "");
    Expect(0, 918000, '\p{^East_Asian_Width=-NEUTRAL}', "");
    Expect(0, 918000, '\P{East_Asian_Width=-NEUTRAL}', "");
    Expect(1, 918000, '\P{^East_Asian_Width=-NEUTRAL}', "");
    Expect(0, 1114109, '\p{East_Asian_Width=-NEUTRAL}', "");
    Expect(1, 1114109, '\p{^East_Asian_Width=-NEUTRAL}', "");
    Expect(1, 1114109, '\P{East_Asian_Width=-NEUTRAL}', "");
    Expect(0, 1114109, '\P{^East_Asian_Width=-NEUTRAL}', "");
    Error('\p{Ea=:= 	N}');
    Error('\P{Ea=:= 	N}');
    Expect(1, 918000, '\p{Ea=n}', "");
    Expect(0, 918000, '\p{^Ea=n}', "");
    Expect(0, 918000, '\P{Ea=n}', "");
    Expect(1, 918000, '\P{^Ea=n}', "");
    Expect(0, 1114109, '\p{Ea=n}', "");
    Expect(1, 1114109, '\p{^Ea=n}', "");
    Expect(1, 1114109, '\P{Ea=n}', "");
    Expect(0, 1114109, '\P{^Ea=n}', "");
    Expect(1, 918000, '\p{Ea:  N}', "");
    Expect(0, 918000, '\p{^Ea:  N}', "");
    Expect(0, 918000, '\P{Ea:  N}', "");
    Expect(1, 918000, '\P{^Ea:  N}', "");
    Expect(0, 1114109, '\p{Ea:  N}', "");
    Expect(1, 1114109, '\p{^Ea:  N}', "");
    Expect(1, 1114109, '\P{Ea:  N}', "");
    Expect(0, 1114109, '\P{^Ea:  N}', "");
    Error('\p{Is_East_Asian_Width=-Neutral:=}');
    Error('\P{Is_East_Asian_Width=-Neutral:=}');
    Expect(1, 918000, '\p{Is_East_Asian_Width=neutral}', "");
    Expect(0, 918000, '\p{^Is_East_Asian_Width=neutral}', "");
    Expect(0, 918000, '\P{Is_East_Asian_Width=neutral}', "");
    Expect(1, 918000, '\P{^Is_East_Asian_Width=neutral}', "");
    Expect(0, 1114109, '\p{Is_East_Asian_Width=neutral}', "");
    Expect(1, 1114109, '\p{^Is_East_Asian_Width=neutral}', "");
    Expect(1, 1114109, '\P{Is_East_Asian_Width=neutral}', "");
    Expect(0, 1114109, '\P{^Is_East_Asian_Width=neutral}', "");
    Expect(1, 918000, '\p{Is_East_Asian_Width=	_Neutral}', "");
    Expect(0, 918000, '\p{^Is_East_Asian_Width=	_Neutral}', "");
    Expect(0, 918000, '\P{Is_East_Asian_Width=	_Neutral}', "");
    Expect(1, 918000, '\P{^Is_East_Asian_Width=	_Neutral}', "");
    Expect(0, 1114109, '\p{Is_East_Asian_Width=	_Neutral}', "");
    Expect(1, 1114109, '\p{^Is_East_Asian_Width=	_Neutral}', "");
    Expect(1, 1114109, '\P{Is_East_Asian_Width=	_Neutral}', "");
    Expect(0, 1114109, '\P{^Is_East_Asian_Width=	_Neutral}', "");
    Error('\p{Is_Ea:	:=N}');
    Error('\P{Is_Ea:	:=N}');
    Expect(1, 918000, '\p{Is_Ea=n}', "");
    Expect(0, 918000, '\p{^Is_Ea=n}', "");
    Expect(0, 918000, '\P{Is_Ea=n}', "");
    Expect(1, 918000, '\P{^Is_Ea=n}', "");
    Expect(0, 1114109, '\p{Is_Ea=n}', "");
    Expect(1, 1114109, '\p{^Is_Ea=n}', "");
    Expect(1, 1114109, '\P{Is_Ea=n}', "");
    Expect(0, 1114109, '\P{^Is_Ea=n}', "");
    Expect(1, 918000, '\p{Is_Ea=-_N}', "");
    Expect(0, 918000, '\p{^Is_Ea=-_N}', "");
    Expect(0, 918000, '\P{Is_Ea=-_N}', "");
    Expect(1, 918000, '\P{^Is_Ea=-_N}', "");
    Expect(0, 1114109, '\p{Is_Ea=-_N}', "");
    Expect(1, 1114109, '\p{^Is_Ea=-_N}', "");
    Expect(1, 1114109, '\P{Is_Ea=-_N}', "");
    Expect(0, 1114109, '\P{^Is_Ea=-_N}', "");
    Error('\p{East_Asian_Width=:=	narrow}');
    Error('\P{East_Asian_Width=:=	narrow}');
    Expect(1, 10630, '\p{East_Asian_Width=narrow}', "");
    Expect(0, 10630, '\p{^East_Asian_Width=narrow}', "");
    Expect(0, 10630, '\P{East_Asian_Width=narrow}', "");
    Expect(1, 10630, '\P{^East_Asian_Width=narrow}', "");
    Expect(0, 10631, '\p{East_Asian_Width=narrow}', "");
    Expect(1, 10631, '\p{^East_Asian_Width=narrow}', "");
    Expect(1, 10631, '\P{East_Asian_Width=narrow}', "");
    Expect(0, 10631, '\P{^East_Asian_Width=narrow}', "");
    Expect(1, 10630, '\p{East_Asian_Width=	 Narrow}', "");
    Expect(0, 10630, '\p{^East_Asian_Width=	 Narrow}', "");
    Expect(0, 10630, '\P{East_Asian_Width=	 Narrow}', "");
    Expect(1, 10630, '\P{^East_Asian_Width=	 Narrow}', "");
    Expect(0, 10631, '\p{East_Asian_Width=	 Narrow}', "");
    Expect(1, 10631, '\p{^East_Asian_Width=	 Narrow}', "");
    Expect(1, 10631, '\P{East_Asian_Width=	 Narrow}', "");
    Expect(0, 10631, '\P{^East_Asian_Width=	 Narrow}', "");
    Error('\p{Ea=/a/ Na}');
    Error('\P{Ea=/a/ Na}');
    Expect(1, 10630, '\p{Ea:	na}', "");
    Expect(0, 10630, '\p{^Ea:	na}', "");
    Expect(0, 10630, '\P{Ea:	na}', "");
    Expect(1, 10630, '\P{^Ea:	na}', "");
    Expect(0, 10631, '\p{Ea:	na}', "");
    Expect(1, 10631, '\p{^Ea:	na}', "");
    Expect(1, 10631, '\P{Ea:	na}', "");
    Expect(0, 10631, '\P{^Ea:	na}', "");
    Expect(1, 10630, '\p{Ea= NA}', "");
    Expect(0, 10630, '\p{^Ea= NA}', "");
    Expect(0, 10630, '\P{Ea= NA}', "");
    Expect(1, 10630, '\P{^Ea= NA}', "");
    Expect(0, 10631, '\p{Ea= NA}', "");
    Expect(1, 10631, '\p{^Ea= NA}', "");
    Expect(1, 10631, '\P{Ea= NA}', "");
    Expect(0, 10631, '\P{^Ea= NA}', "");
    Error('\p{Is_East_Asian_Width=/a/__Narrow}');
    Error('\P{Is_East_Asian_Width=/a/__Narrow}');
    Expect(1, 10630, '\p{Is_East_Asian_Width=narrow}', "");
    Expect(0, 10630, '\p{^Is_East_Asian_Width=narrow}', "");
    Expect(0, 10630, '\P{Is_East_Asian_Width=narrow}', "");
    Expect(1, 10630, '\P{^Is_East_Asian_Width=narrow}', "");
    Expect(0, 10631, '\p{Is_East_Asian_Width=narrow}', "");
    Expect(1, 10631, '\p{^Is_East_Asian_Width=narrow}', "");
    Expect(1, 10631, '\P{Is_East_Asian_Width=narrow}', "");
    Expect(0, 10631, '\P{^Is_East_Asian_Width=narrow}', "");
    Expect(1, 10630, '\p{Is_East_Asian_Width=-Narrow}', "");
    Expect(0, 10630, '\p{^Is_East_Asian_Width=-Narrow}', "");
    Expect(0, 10630, '\P{Is_East_Asian_Width=-Narrow}', "");
    Expect(1, 10630, '\P{^Is_East_Asian_Width=-Narrow}', "");
    Expect(0, 10631, '\p{Is_East_Asian_Width=-Narrow}', "");
    Expect(1, 10631, '\p{^Is_East_Asian_Width=-Narrow}', "");
    Expect(1, 10631, '\P{Is_East_Asian_Width=-Narrow}', "");
    Expect(0, 10631, '\P{^Is_East_Asian_Width=-Narrow}', "");
    Error('\p{Is_Ea:   _/a/Na}');
    Error('\P{Is_Ea:   _/a/Na}');
    Expect(1, 10630, '\p{Is_Ea:   na}', "");
    Expect(0, 10630, '\p{^Is_Ea:   na}', "");
    Expect(0, 10630, '\P{Is_Ea:   na}', "");
    Expect(1, 10630, '\P{^Is_Ea:   na}', "");
    Expect(0, 10631, '\p{Is_Ea:   na}', "");
    Expect(1, 10631, '\p{^Is_Ea:   na}', "");
    Expect(1, 10631, '\P{Is_Ea:   na}', "");
    Expect(0, 10631, '\P{^Is_Ea:   na}', "");
    Expect(1, 10630, '\p{Is_Ea=- Na}', "");
    Expect(0, 10630, '\p{^Is_Ea=- Na}', "");
    Expect(0, 10630, '\P{Is_Ea=- Na}', "");
    Expect(1, 10630, '\P{^Is_Ea=- Na}', "");
    Expect(0, 10631, '\p{Is_Ea=- Na}', "");
    Expect(1, 10631, '\p{^Is_Ea=- Na}', "");
    Expect(1, 10631, '\P{Is_Ea=- Na}', "");
    Expect(0, 10631, '\P{^Is_Ea=- Na}', "");
    Error('\p{East_Asian_Width=_	WIDE/a/}');
    Error('\P{East_Asian_Width=_	WIDE/a/}');
    Expect(1, 262141, '\p{East_Asian_Width=wide}', "");
    Expect(0, 262141, '\p{^East_Asian_Width=wide}', "");
    Expect(0, 262141, '\P{East_Asian_Width=wide}', "");
    Expect(1, 262141, '\P{^East_Asian_Width=wide}', "");
    Expect(0, 262144, '\p{East_Asian_Width=wide}', "");
    Expect(1, 262144, '\p{^East_Asian_Width=wide}', "");
    Expect(1, 262144, '\P{East_Asian_Width=wide}', "");
    Expect(0, 262144, '\P{^East_Asian_Width=wide}', "");
    Expect(1, 262141, '\p{East_Asian_Width: 	_wide}', "");
    Expect(0, 262141, '\p{^East_Asian_Width: 	_wide}', "");
    Expect(0, 262141, '\P{East_Asian_Width: 	_wide}', "");
    Expect(1, 262141, '\P{^East_Asian_Width: 	_wide}', "");
    Expect(0, 262144, '\p{East_Asian_Width: 	_wide}', "");
    Expect(1, 262144, '\p{^East_Asian_Width: 	_wide}', "");
    Expect(1, 262144, '\P{East_Asian_Width: 	_wide}', "");
    Expect(0, 262144, '\P{^East_Asian_Width: 	_wide}', "");
    Error('\p{Ea=:=_	W}');
    Error('\P{Ea=:=_	W}');
    Expect(1, 262141, '\p{Ea=w}', "");
    Expect(0, 262141, '\p{^Ea=w}', "");
    Expect(0, 262141, '\P{Ea=w}', "");
    Expect(1, 262141, '\P{^Ea=w}', "");
    Expect(0, 262144, '\p{Ea=w}', "");
    Expect(1, 262144, '\p{^Ea=w}', "");
    Expect(1, 262144, '\P{Ea=w}', "");
    Expect(0, 262144, '\P{^Ea=w}', "");
    Expect(1, 262141, '\p{Ea=_ W}', "");
    Expect(0, 262141, '\p{^Ea=_ W}', "");
    Expect(0, 262141, '\P{Ea=_ W}', "");
    Expect(1, 262141, '\P{^Ea=_ W}', "");
    Expect(0, 262144, '\p{Ea=_ W}', "");
    Expect(1, 262144, '\p{^Ea=_ W}', "");
    Expect(1, 262144, '\P{Ea=_ W}', "");
    Expect(0, 262144, '\P{^Ea=_ W}', "");
    Error('\p{Is_East_Asian_Width=/a/Wide}');
    Error('\P{Is_East_Asian_Width=/a/Wide}');
    Expect(1, 262141, '\p{Is_East_Asian_Width: wide}', "");
    Expect(0, 262141, '\p{^Is_East_Asian_Width: wide}', "");
    Expect(0, 262141, '\P{Is_East_Asian_Width: wide}', "");
    Expect(1, 262141, '\P{^Is_East_Asian_Width: wide}', "");
    Expect(0, 262144, '\p{Is_East_Asian_Width: wide}', "");
    Expect(1, 262144, '\p{^Is_East_Asian_Width: wide}', "");
    Expect(1, 262144, '\P{Is_East_Asian_Width: wide}', "");
    Expect(0, 262144, '\P{^Is_East_Asian_Width: wide}', "");
    Expect(1, 262141, '\p{Is_East_Asian_Width:   -	Wide}', "");
    Expect(0, 262141, '\p{^Is_East_Asian_Width:   -	Wide}', "");
    Expect(0, 262141, '\P{Is_East_Asian_Width:   -	Wide}', "");
    Expect(1, 262141, '\P{^Is_East_Asian_Width:   -	Wide}', "");
    Expect(0, 262144, '\p{Is_East_Asian_Width:   -	Wide}', "");
    Expect(1, 262144, '\p{^Is_East_Asian_Width:   -	Wide}', "");
    Expect(1, 262144, '\P{Is_East_Asian_Width:   -	Wide}', "");
    Expect(0, 262144, '\P{^Is_East_Asian_Width:   -	Wide}', "");
    Error('\p{Is_Ea=/a/--W}');
    Error('\P{Is_Ea=/a/--W}');
    Expect(1, 262141, '\p{Is_Ea=w}', "");
    Expect(0, 262141, '\p{^Is_Ea=w}', "");
    Expect(0, 262141, '\P{Is_Ea=w}', "");
    Expect(1, 262141, '\P{^Is_Ea=w}', "");
    Expect(0, 262144, '\p{Is_Ea=w}', "");
    Expect(1, 262144, '\p{^Is_Ea=w}', "");
    Expect(1, 262144, '\P{Is_Ea=w}', "");
    Expect(0, 262144, '\P{^Is_Ea=w}', "");
    Expect(1, 262141, '\p{Is_Ea=- W}', "");
    Expect(0, 262141, '\p{^Is_Ea=- W}', "");
    Expect(0, 262141, '\P{Is_Ea=- W}', "");
    Expect(1, 262141, '\P{^Is_Ea=- W}', "");
    Expect(0, 262144, '\p{Is_Ea=- W}', "");
    Expect(1, 262144, '\p{^Is_Ea=- W}', "");
    Expect(1, 262144, '\P{Is_Ea=- W}', "");
    Expect(0, 262144, '\P{^Is_Ea=- W}', "");
    Error('\p{Extender=_No:=}');
    Error('\P{Extender=_No:=}');
    Expect(1, 125255, '\p{Extender=no}', "");
    Expect(0, 125255, '\p{^Extender=no}', "");
    Expect(0, 125255, '\P{Extender=no}', "");
    Expect(1, 125255, '\P{^Extender=no}', "");
    Expect(0, 125254, '\p{Extender=no}', "");
    Expect(1, 125254, '\p{^Extender=no}', "");
    Expect(1, 125254, '\P{Extender=no}', "");
    Expect(0, 125254, '\P{^Extender=no}', "");
    Expect(1, 125255, '\p{Extender= -NO}', "");
    Expect(0, 125255, '\p{^Extender= -NO}', "");
    Expect(0, 125255, '\P{Extender= -NO}', "");
    Expect(1, 125255, '\P{^Extender= -NO}', "");
    Expect(0, 125254, '\p{Extender= -NO}', "");
    Expect(1, 125254, '\p{^Extender= -NO}', "");
    Expect(1, 125254, '\P{Extender= -NO}', "");
    Expect(0, 125254, '\P{^Extender= -NO}', "");
    Error('\p{Ext=- N/a/}');
    Error('\P{Ext=- N/a/}');
    Expect(1, 125255, '\p{Ext=n}', "");
    Expect(0, 125255, '\p{^Ext=n}', "");
    Expect(0, 125255, '\P{Ext=n}', "");
    Expect(1, 125255, '\P{^Ext=n}', "");
    Expect(0, 125254, '\p{Ext=n}', "");
    Expect(1, 125254, '\p{^Ext=n}', "");
    Expect(1, 125254, '\P{Ext=n}', "");
    Expect(0, 125254, '\P{^Ext=n}', "");
    Expect(1, 125255, '\p{Ext=N}', "");
    Expect(0, 125255, '\p{^Ext=N}', "");
    Expect(0, 125255, '\P{Ext=N}', "");
    Expect(1, 125255, '\P{^Ext=N}', "");
    Expect(0, 125254, '\p{Ext=N}', "");
    Expect(1, 125254, '\p{^Ext=N}', "");
    Expect(1, 125254, '\P{Ext=N}', "");
    Expect(0, 125254, '\P{^Ext=N}', "");
    Error('\p{Is_Extender=/a/	 F}');
    Error('\P{Is_Extender=/a/	 F}');
    Expect(1, 125255, '\p{Is_Extender=f}', "");
    Expect(0, 125255, '\p{^Is_Extender=f}', "");
    Expect(0, 125255, '\P{Is_Extender=f}', "");
    Expect(1, 125255, '\P{^Is_Extender=f}', "");
    Expect(0, 125254, '\p{Is_Extender=f}', "");
    Expect(1, 125254, '\p{^Is_Extender=f}', "");
    Expect(1, 125254, '\P{Is_Extender=f}', "");
    Expect(0, 125254, '\P{^Is_Extender=f}', "");
    Expect(1, 125255, '\p{Is_Extender=_	F}', "");
    Expect(0, 125255, '\p{^Is_Extender=_	F}', "");
    Expect(0, 125255, '\P{Is_Extender=_	F}', "");
    Expect(1, 125255, '\P{^Is_Extender=_	F}', "");
    Expect(0, 125254, '\p{Is_Extender=_	F}', "");
    Expect(1, 125254, '\p{^Is_Extender=_	F}', "");
    Expect(1, 125254, '\P{Is_Extender=_	F}', "");
    Expect(0, 125254, '\P{^Is_Extender=_	F}', "");
    Error('\p{Is_Ext= /a/false}');
    Error('\P{Is_Ext= /a/false}');
    Expect(1, 125255, '\p{Is_Ext=false}', "");
    Expect(0, 125255, '\p{^Is_Ext=false}', "");
    Expect(0, 125255, '\P{Is_Ext=false}', "");
    Expect(1, 125255, '\P{^Is_Ext=false}', "");
    Expect(0, 125254, '\p{Is_Ext=false}', "");
    Expect(1, 125254, '\p{^Is_Ext=false}', "");
    Expect(1, 125254, '\P{Is_Ext=false}', "");
    Expect(0, 125254, '\P{^Is_Ext=false}', "");
    Expect(1, 125255, '\p{Is_Ext=__FALSE}', "");
    Expect(0, 125255, '\p{^Is_Ext=__FALSE}', "");
    Expect(0, 125255, '\P{Is_Ext=__FALSE}', "");
    Expect(1, 125255, '\P{^Is_Ext=__FALSE}', "");
    Expect(0, 125254, '\p{Is_Ext=__FALSE}', "");
    Expect(1, 125254, '\p{^Is_Ext=__FALSE}', "");
    Expect(1, 125254, '\P{Is_Ext=__FALSE}', "");
    Expect(0, 125254, '\P{^Is_Ext=__FALSE}', "");
    Error('\p{Extender:	 _Yes/a/}');
    Error('\P{Extender:	 _Yes/a/}');
    Expect(1, 125254, '\p{Extender=yes}', "");
    Expect(0, 125254, '\p{^Extender=yes}', "");
    Expect(0, 125254, '\P{Extender=yes}', "");
    Expect(1, 125254, '\P{^Extender=yes}', "");
    Expect(0, 125255, '\p{Extender=yes}', "");
    Expect(1, 125255, '\p{^Extender=yes}', "");
    Expect(1, 125255, '\P{Extender=yes}', "");
    Expect(0, 125255, '\P{^Extender=yes}', "");
    Expect(1, 125254, '\p{Extender:	 _yes}', "");
    Expect(0, 125254, '\p{^Extender:	 _yes}', "");
    Expect(0, 125254, '\P{Extender:	 _yes}', "");
    Expect(1, 125254, '\P{^Extender:	 _yes}', "");
    Expect(0, 125255, '\p{Extender:	 _yes}', "");
    Expect(1, 125255, '\p{^Extender:	 _yes}', "");
    Expect(1, 125255, '\P{Extender:	 _yes}', "");
    Expect(0, 125255, '\P{^Extender:	 _yes}', "");
    Error('\p{Ext=_	y/a/}');
    Error('\P{Ext=_	y/a/}');
    Expect(1, 125254, '\p{Ext=y}', "");
    Expect(0, 125254, '\p{^Ext=y}', "");
    Expect(0, 125254, '\P{Ext=y}', "");
    Expect(1, 125254, '\P{^Ext=y}', "");
    Expect(0, 125255, '\p{Ext=y}', "");
    Expect(1, 125255, '\p{^Ext=y}', "");
    Expect(1, 125255, '\P{Ext=y}', "");
    Expect(0, 125255, '\P{^Ext=y}', "");
    Expect(1, 125254, '\p{Ext=	Y}', "");
    Expect(0, 125254, '\p{^Ext=	Y}', "");
    Expect(0, 125254, '\P{Ext=	Y}', "");
    Expect(1, 125254, '\P{^Ext=	Y}', "");
    Expect(0, 125255, '\p{Ext=	Y}', "");
    Expect(1, 125255, '\p{^Ext=	Y}', "");
    Expect(1, 125255, '\P{Ext=	Y}', "");
    Expect(0, 125255, '\P{^Ext=	Y}', "");
    Error('\p{Is_Extender=:=-	t}');
    Error('\P{Is_Extender=:=-	t}');
    Expect(1, 125254, '\p{Is_Extender=t}', "");
    Expect(0, 125254, '\p{^Is_Extender=t}', "");
    Expect(0, 125254, '\P{Is_Extender=t}', "");
    Expect(1, 125254, '\P{^Is_Extender=t}', "");
    Expect(0, 125255, '\p{Is_Extender=t}', "");
    Expect(1, 125255, '\p{^Is_Extender=t}', "");
    Expect(1, 125255, '\P{Is_Extender=t}', "");
    Expect(0, 125255, '\P{^Is_Extender=t}', "");
    Expect(1, 125254, '\p{Is_Extender=_-T}', "");
    Expect(0, 125254, '\p{^Is_Extender=_-T}', "");
    Expect(0, 125254, '\P{Is_Extender=_-T}', "");
    Expect(1, 125254, '\P{^Is_Extender=_-T}', "");
    Expect(0, 125255, '\p{Is_Extender=_-T}', "");
    Expect(1, 125255, '\p{^Is_Extender=_-T}', "");
    Expect(1, 125255, '\P{Is_Extender=_-T}', "");
    Expect(0, 125255, '\P{^Is_Extender=_-T}', "");
    Error('\p{Is_Ext= -True/a/}');
    Error('\P{Is_Ext= -True/a/}');
    Expect(1, 125254, '\p{Is_Ext=true}', "");
    Expect(0, 125254, '\p{^Is_Ext=true}', "");
    Expect(0, 125254, '\P{Is_Ext=true}', "");
    Expect(1, 125254, '\P{^Is_Ext=true}', "");
    Expect(0, 125255, '\p{Is_Ext=true}', "");
    Expect(1, 125255, '\p{^Is_Ext=true}', "");
    Expect(1, 125255, '\P{Is_Ext=true}', "");
    Expect(0, 125255, '\P{^Is_Ext=true}', "");
    Expect(1, 125254, '\p{Is_Ext=__true}', "");
    Expect(0, 125254, '\p{^Is_Ext=__true}', "");
    Expect(0, 125254, '\P{Is_Ext=__true}', "");
    Expect(1, 125254, '\P{^Is_Ext=__true}', "");
    Expect(0, 125255, '\p{Is_Ext=__true}', "");
    Expect(1, 125255, '\p{^Is_Ext=__true}', "");
    Expect(1, 125255, '\P{Is_Ext=__true}', "");
    Expect(0, 125255, '\P{^Is_Ext=__true}', "");
    Error('\p{fcnfkcclosure}');
    Error('\P{fcnfkcclosure}');
    Error('\p{fcnfkc}');
    Error('\P{fcnfkc}');
    Error('\p{generalcategory}');
    Error('\P{generalcategory}');
    Error('\p{gc}');
    Error('\P{gc}');
    Error('\p{category}');
    Error('\P{category}');
    Error('\p{General_Category= OTHER:=}');
    Error('\P{General_Category= OTHER:=}');
    Expect(1, 918000, '\p{General_Category=other}', "");
    Expect(0, 918000, '\p{^General_Category=other}', "");
    Expect(0, 918000, '\P{General_Category=other}', "");
    Expect(1, 918000, '\P{^General_Category=other}', "");
    Expect(0, 917999, '\p{General_Category=other}', "");
    Expect(1, 917999, '\p{^General_Category=other}', "");
    Expect(1, 917999, '\P{General_Category=other}', "");
    Expect(0, 917999, '\P{^General_Category=other}', "");
    Expect(1, 918000, '\p{General_Category=	OTHER}', "");
    Expect(0, 918000, '\p{^General_Category=	OTHER}', "");
    Expect(0, 918000, '\P{General_Category=	OTHER}', "");
    Expect(1, 918000, '\P{^General_Category=	OTHER}', "");
    Expect(0, 917999, '\p{General_Category=	OTHER}', "");
    Expect(1, 917999, '\p{^General_Category=	OTHER}', "");
    Expect(1, 917999, '\P{General_Category=	OTHER}', "");
    Expect(0, 917999, '\P{^General_Category=	OTHER}', "");
    Error('\p{Gc=/a/	C}');
    Error('\P{Gc=/a/	C}');
    Expect(1, 918000, '\p{Gc=c}', "");
    Expect(0, 918000, '\p{^Gc=c}', "");
    Expect(0, 918000, '\P{Gc=c}', "");
    Expect(1, 918000, '\P{^Gc=c}', "");
    Expect(0, 917999, '\p{Gc=c}', "");
    Expect(1, 917999, '\p{^Gc=c}', "");
    Expect(1, 917999, '\P{Gc=c}', "");
    Expect(0, 917999, '\P{^Gc=c}', "");
    Expect(1, 918000, '\p{Gc: - C}', "");
    Expect(0, 918000, '\p{^Gc: - C}', "");
    Expect(0, 918000, '\P{Gc: - C}', "");
    Expect(1, 918000, '\P{^Gc: - C}', "");
    Expect(0, 917999, '\p{Gc: - C}', "");
    Expect(1, 917999, '\p{^Gc: - C}', "");
    Expect(1, 917999, '\P{Gc: - C}', "");
    Expect(0, 917999, '\P{^Gc: - C}', "");
    Error('\p{Category=/a/	OTHER}');
    Error('\P{Category=/a/	OTHER}');
    Expect(1, 918000, '\p{Category=other}', "");
    Expect(0, 918000, '\p{^Category=other}', "");
    Expect(0, 918000, '\P{Category=other}', "");
    Expect(1, 918000, '\P{^Category=other}', "");
    Expect(0, 917999, '\p{Category=other}', "");
    Expect(1, 917999, '\p{^Category=other}', "");
    Expect(1, 917999, '\P{Category=other}', "");
    Expect(0, 917999, '\P{^Category=other}', "");
    Expect(1, 918000, '\p{Category=_	other}', "");
    Expect(0, 918000, '\p{^Category=_	other}', "");
    Expect(0, 918000, '\P{Category=_	other}', "");
    Expect(1, 918000, '\P{^Category=_	other}', "");
    Expect(0, 917999, '\p{Category=_	other}', "");
    Expect(1, 917999, '\p{^Category=_	other}', "");
    Expect(1, 917999, '\P{Category=_	other}', "");
    Expect(0, 917999, '\P{^Category=_	other}', "");
    Error('\p{Is_General_Category=:= C}');
    Error('\P{Is_General_Category=:= C}');
    Expect(1, 918000, '\p{Is_General_Category=c}', "");
    Expect(0, 918000, '\p{^Is_General_Category=c}', "");
    Expect(0, 918000, '\P{Is_General_Category=c}', "");
    Expect(1, 918000, '\P{^Is_General_Category=c}', "");
    Expect(0, 917999, '\p{Is_General_Category=c}', "");
    Expect(1, 917999, '\p{^Is_General_Category=c}', "");
    Expect(1, 917999, '\P{Is_General_Category=c}', "");
    Expect(0, 917999, '\P{^Is_General_Category=c}', "");
    Expect(1, 918000, '\p{Is_General_Category=_	C}', "");
    Expect(0, 918000, '\p{^Is_General_Category=_	C}', "");
    Expect(0, 918000, '\P{Is_General_Category=_	C}', "");
    Expect(1, 918000, '\P{^Is_General_Category=_	C}', "");
    Expect(0, 917999, '\p{Is_General_Category=_	C}', "");
    Expect(1, 917999, '\p{^Is_General_Category=_	C}', "");
    Expect(1, 917999, '\P{Is_General_Category=_	C}', "");
    Expect(0, 917999, '\P{^Is_General_Category=_	C}', "");
    Error('\p{Is_Gc:_ Other/a/}');
    Error('\P{Is_Gc:_ Other/a/}');
    Expect(1, 918000, '\p{Is_Gc=other}', "");
    Expect(0, 918000, '\p{^Is_Gc=other}', "");
    Expect(0, 918000, '\P{Is_Gc=other}', "");
    Expect(1, 918000, '\P{^Is_Gc=other}', "");
    Expect(0, 917999, '\p{Is_Gc=other}', "");
    Expect(1, 917999, '\p{^Is_Gc=other}', "");
    Expect(1, 917999, '\P{Is_Gc=other}', "");
    Expect(0, 917999, '\P{^Is_Gc=other}', "");
    Expect(1, 918000, '\p{Is_Gc=	-OTHER}', "");
    Expect(0, 918000, '\p{^Is_Gc=	-OTHER}', "");
    Expect(0, 918000, '\P{Is_Gc=	-OTHER}', "");
    Expect(1, 918000, '\P{^Is_Gc=	-OTHER}', "");
    Expect(0, 917999, '\p{Is_Gc=	-OTHER}', "");
    Expect(1, 917999, '\p{^Is_Gc=	-OTHER}', "");
    Expect(1, 917999, '\P{Is_Gc=	-OTHER}', "");
    Expect(0, 917999, '\P{^Is_Gc=	-OTHER}', "");
    Error('\p{Is_Category= _c:=}');
    Error('\P{Is_Category= _c:=}');
    Expect(1, 918000, '\p{Is_Category=c}', "");
    Expect(0, 918000, '\p{^Is_Category=c}', "");
    Expect(0, 918000, '\P{Is_Category=c}', "");
    Expect(1, 918000, '\P{^Is_Category=c}', "");
    Expect(0, 917999, '\p{Is_Category=c}', "");
    Expect(1, 917999, '\p{^Is_Category=c}', "");
    Expect(1, 917999, '\P{Is_Category=c}', "");
    Expect(0, 917999, '\P{^Is_Category=c}', "");
    Expect(1, 918000, '\p{Is_Category: _C}', "");
    Expect(0, 918000, '\p{^Is_Category: _C}', "");
    Expect(0, 918000, '\P{Is_Category: _C}', "");
    Expect(1, 918000, '\P{^Is_Category: _C}', "");
    Expect(0, 917999, '\p{Is_Category: _C}', "");
    Expect(1, 917999, '\p{^Is_Category: _C}', "");
    Expect(1, 917999, '\P{Is_Category: _C}', "");
    Expect(0, 917999, '\P{^Is_Category: _C}', "");
    Error('\p{General_Category= control:=}');
    Error('\P{General_Category= control:=}');
    Expect(1, 159, '\p{General_Category=control}', "");
    Expect(0, 159, '\p{^General_Category=control}', "");
    Expect(0, 159, '\P{General_Category=control}', "");
    Expect(1, 159, '\P{^General_Category=control}', "");
    Expect(0, 160, '\p{General_Category=control}', "");
    Expect(1, 160, '\p{^General_Category=control}', "");
    Expect(1, 160, '\P{General_Category=control}', "");
    Expect(0, 160, '\P{^General_Category=control}', "");
    Expect(1, 159, '\p{General_Category=_Control}', "");
    Expect(0, 159, '\p{^General_Category=_Control}', "");
    Expect(0, 159, '\P{General_Category=_Control}', "");
    Expect(1, 159, '\P{^General_Category=_Control}', "");
    Expect(0, 160, '\p{General_Category=_Control}', "");
    Expect(1, 160, '\p{^General_Category=_Control}', "");
    Expect(1, 160, '\P{General_Category=_Control}', "");
    Expect(0, 160, '\P{^General_Category=_Control}', "");
    Error('\p{Gc=--cc/a/}');
    Error('\P{Gc=--cc/a/}');
    Expect(1, 159, '\p{Gc: cc}', "");
    Expect(0, 159, '\p{^Gc: cc}', "");
    Expect(0, 159, '\P{Gc: cc}', "");
    Expect(1, 159, '\P{^Gc: cc}', "");
    Expect(0, 160, '\p{Gc: cc}', "");
    Expect(1, 160, '\p{^Gc: cc}', "");
    Expect(1, 160, '\P{Gc: cc}', "");
    Expect(0, 160, '\P{^Gc: cc}', "");
    Expect(1, 159, '\p{Gc=	_cc}', "");
    Expect(0, 159, '\p{^Gc=	_cc}', "");
    Expect(0, 159, '\P{Gc=	_cc}', "");
    Expect(1, 159, '\P{^Gc=	_cc}', "");
    Expect(0, 160, '\p{Gc=	_cc}', "");
    Expect(1, 160, '\p{^Gc=	_cc}', "");
    Expect(1, 160, '\P{Gc=	_cc}', "");
    Expect(0, 160, '\P{^Gc=	_cc}', "");
    Error('\p{Category=_-CNTRL:=}');
    Error('\P{Category=_-CNTRL:=}');
    Expect(1, 159, '\p{Category=cntrl}', "");
    Expect(0, 159, '\p{^Category=cntrl}', "");
    Expect(0, 159, '\P{Category=cntrl}', "");
    Expect(1, 159, '\P{^Category=cntrl}', "");
    Expect(0, 160, '\p{Category=cntrl}', "");
    Expect(1, 160, '\p{^Category=cntrl}', "");
    Expect(1, 160, '\P{Category=cntrl}', "");
    Expect(0, 160, '\P{^Category=cntrl}', "");
    Expect(1, 159, '\p{Category=	Cntrl}', "");
    Expect(0, 159, '\p{^Category=	Cntrl}', "");
    Expect(0, 159, '\P{Category=	Cntrl}', "");
    Expect(1, 159, '\P{^Category=	Cntrl}', "");
    Expect(0, 160, '\p{Category=	Cntrl}', "");
    Expect(1, 160, '\p{^Category=	Cntrl}', "");
    Expect(1, 160, '\P{Category=	Cntrl}', "");
    Expect(0, 160, '\P{^Category=	Cntrl}', "");
    Error('\p{Is_General_Category=/a/ -Control}');
    Error('\P{Is_General_Category=/a/ -Control}');
    Expect(1, 159, '\p{Is_General_Category=control}', "");
    Expect(0, 159, '\p{^Is_General_Category=control}', "");
    Expect(0, 159, '\P{Is_General_Category=control}', "");
    Expect(1, 159, '\P{^Is_General_Category=control}', "");
    Expect(0, 160, '\p{Is_General_Category=control}', "");
    Expect(1, 160, '\p{^Is_General_Category=control}', "");
    Expect(1, 160, '\P{Is_General_Category=control}', "");
    Expect(0, 160, '\P{^Is_General_Category=control}', "");
    Expect(1, 159, '\p{Is_General_Category: -Control}', "");
    Expect(0, 159, '\p{^Is_General_Category: -Control}', "");
    Expect(0, 159, '\P{Is_General_Category: -Control}', "");
    Expect(1, 159, '\P{^Is_General_Category: -Control}', "");
    Expect(0, 160, '\p{Is_General_Category: -Control}', "");
    Expect(1, 160, '\p{^Is_General_Category: -Control}', "");
    Expect(1, 160, '\P{Is_General_Category: -Control}', "");
    Expect(0, 160, '\P{^Is_General_Category: -Control}', "");
    Error('\p{Is_Gc=:=	CC}');
    Error('\P{Is_Gc=:=	CC}');
    Expect(1, 159, '\p{Is_Gc=cc}', "");
    Expect(0, 159, '\p{^Is_Gc=cc}', "");
    Expect(0, 159, '\P{Is_Gc=cc}', "");
    Expect(1, 159, '\P{^Is_Gc=cc}', "");
    Expect(0, 160, '\p{Is_Gc=cc}', "");
    Expect(1, 160, '\p{^Is_Gc=cc}', "");
    Expect(1, 160, '\P{Is_Gc=cc}', "");
    Expect(0, 160, '\P{^Is_Gc=cc}', "");
    Expect(1, 159, '\p{Is_Gc=_cc}', "");
    Expect(0, 159, '\p{^Is_Gc=_cc}', "");
    Expect(0, 159, '\P{Is_Gc=_cc}', "");
    Expect(1, 159, '\P{^Is_Gc=_cc}', "");
    Expect(0, 160, '\p{Is_Gc=_cc}', "");
    Expect(1, 160, '\p{^Is_Gc=_cc}', "");
    Expect(1, 160, '\P{Is_Gc=_cc}', "");
    Expect(0, 160, '\P{^Is_Gc=_cc}', "");
    Error('\p{Is_Category=/a/_cntrl}');
    Error('\P{Is_Category=/a/_cntrl}');
    Expect(1, 159, '\p{Is_Category=cntrl}', "");
    Expect(0, 159, '\p{^Is_Category=cntrl}', "");
    Expect(0, 159, '\P{Is_Category=cntrl}', "");
    Expect(1, 159, '\P{^Is_Category=cntrl}', "");
    Expect(0, 160, '\p{Is_Category=cntrl}', "");
    Expect(1, 160, '\p{^Is_Category=cntrl}', "");
    Expect(1, 160, '\P{Is_Category=cntrl}', "");
    Expect(0, 160, '\P{^Is_Category=cntrl}', "");
    Expect(1, 159, '\p{Is_Category=__CNTRL}', "");
    Expect(0, 159, '\p{^Is_Category=__CNTRL}', "");
    Expect(0, 159, '\P{Is_Category=__CNTRL}', "");
    Expect(1, 159, '\P{^Is_Category=__CNTRL}', "");
    Expect(0, 160, '\p{Is_Category=__CNTRL}', "");
    Expect(1, 160, '\p{^Is_Category=__CNTRL}', "");
    Expect(1, 160, '\P{Is_Category=__CNTRL}', "");
    Expect(0, 160, '\P{^Is_Category=__CNTRL}', "");
    Error('\p{General_Category= /a/FORMAT}');
    Error('\P{General_Category= /a/FORMAT}');
    Expect(1, 917631, '\p{General_Category=format}', "");
    Expect(0, 917631, '\p{^General_Category=format}', "");
    Expect(0, 917631, '\P{General_Category=format}', "");
    Expect(1, 917631, '\P{^General_Category=format}', "");
    Expect(0, 917632, '\p{General_Category=format}', "");
    Expect(1, 917632, '\p{^General_Category=format}', "");
    Expect(1, 917632, '\P{General_Category=format}', "");
    Expect(0, 917632, '\P{^General_Category=format}', "");
    Expect(1, 917631, '\p{General_Category=  Format}', "");
    Expect(0, 917631, '\p{^General_Category=  Format}', "");
    Expect(0, 917631, '\P{General_Category=  Format}', "");
    Expect(1, 917631, '\P{^General_Category=  Format}', "");
    Expect(0, 917632, '\p{General_Category=  Format}', "");
    Expect(1, 917632, '\p{^General_Category=  Format}', "");
    Expect(1, 917632, '\P{General_Category=  Format}', "");
    Expect(0, 917632, '\P{^General_Category=  Format}', "");
    Error('\p{Gc=-	CF/a/}');
    Error('\P{Gc=-	CF/a/}');
    Expect(1, 917631, '\p{Gc=cf}', "");
    Expect(0, 917631, '\p{^Gc=cf}', "");
    Expect(0, 917631, '\P{Gc=cf}', "");
    Expect(1, 917631, '\P{^Gc=cf}', "");
    Expect(0, 917632, '\p{Gc=cf}', "");
    Expect(1, 917632, '\p{^Gc=cf}', "");
    Expect(1, 917632, '\P{Gc=cf}', "");
    Expect(0, 917632, '\P{^Gc=cf}', "");
    Expect(1, 917631, '\p{Gc=--CF}', "");
    Expect(0, 917631, '\p{^Gc=--CF}', "");
    Expect(0, 917631, '\P{Gc=--CF}', "");
    Expect(1, 917631, '\P{^Gc=--CF}', "");
    Expect(0, 917632, '\p{Gc=--CF}', "");
    Expect(1, 917632, '\p{^Gc=--CF}', "");
    Expect(1, 917632, '\P{Gc=--CF}', "");
    Expect(0, 917632, '\P{^Gc=--CF}', "");
    Error('\p{Category=_-FORMAT/a/}');
    Error('\P{Category=_-FORMAT/a/}');
    Expect(1, 917631, '\p{Category=format}', "");
    Expect(0, 917631, '\p{^Category=format}', "");
    Expect(0, 917631, '\P{Category=format}', "");
    Expect(1, 917631, '\P{^Category=format}', "");
    Expect(0, 917632, '\p{Category=format}', "");
    Expect(1, 917632, '\p{^Category=format}', "");
    Expect(1, 917632, '\P{Category=format}', "");
    Expect(0, 917632, '\P{^Category=format}', "");
    Expect(1, 917631, '\p{Category:-	Format}', "");
    Expect(0, 917631, '\p{^Category:-	Format}', "");
    Expect(0, 917631, '\P{Category:-	Format}', "");
    Expect(1, 917631, '\P{^Category:-	Format}', "");
    Expect(0, 917632, '\p{Category:-	Format}', "");
    Expect(1, 917632, '\p{^Category:-	Format}', "");
    Expect(1, 917632, '\P{Category:-	Format}', "");
    Expect(0, 917632, '\P{^Category:-	Format}', "");
    Error('\p{Is_General_Category=_:=cf}');
    Error('\P{Is_General_Category=_:=cf}');
    Expect(1, 917631, '\p{Is_General_Category=cf}', "");
    Expect(0, 917631, '\p{^Is_General_Category=cf}', "");
    Expect(0, 917631, '\P{Is_General_Category=cf}', "");
    Expect(1, 917631, '\P{^Is_General_Category=cf}', "");
    Expect(0, 917632, '\p{Is_General_Category=cf}', "");
    Expect(1, 917632, '\p{^Is_General_Category=cf}', "");
    Expect(1, 917632, '\P{Is_General_Category=cf}', "");
    Expect(0, 917632, '\P{^Is_General_Category=cf}', "");
    Expect(1, 917631, '\p{Is_General_Category= cf}', "");
    Expect(0, 917631, '\p{^Is_General_Category= cf}', "");
    Expect(0, 917631, '\P{Is_General_Category= cf}', "");
    Expect(1, 917631, '\P{^Is_General_Category= cf}', "");
    Expect(0, 917632, '\p{Is_General_Category= cf}', "");
    Expect(1, 917632, '\p{^Is_General_Category= cf}', "");
    Expect(1, 917632, '\P{Is_General_Category= cf}', "");
    Expect(0, 917632, '\P{^Is_General_Category= cf}', "");
    Error('\p{Is_Gc=:=_-Format}');
    Error('\P{Is_Gc=:=_-Format}');
    Expect(1, 917631, '\p{Is_Gc=format}', "");
    Expect(0, 917631, '\p{^Is_Gc=format}', "");
    Expect(0, 917631, '\P{Is_Gc=format}', "");
    Expect(1, 917631, '\P{^Is_Gc=format}', "");
    Expect(0, 917632, '\p{Is_Gc=format}', "");
    Expect(1, 917632, '\p{^Is_Gc=format}', "");
    Expect(1, 917632, '\P{Is_Gc=format}', "");
    Expect(0, 917632, '\P{^Is_Gc=format}', "");
    Expect(1, 917631, '\p{Is_Gc= -format}', "");
    Expect(0, 917631, '\p{^Is_Gc= -format}', "");
    Expect(0, 917631, '\P{Is_Gc= -format}', "");
    Expect(1, 917631, '\P{^Is_Gc= -format}', "");
    Expect(0, 917632, '\p{Is_Gc= -format}', "");
    Expect(1, 917632, '\p{^Is_Gc= -format}', "");
    Expect(1, 917632, '\P{Is_Gc= -format}', "");
    Expect(0, 917632, '\P{^Is_Gc= -format}', "");
    Error('\p{Is_Category=/a/ _Cf}');
    Error('\P{Is_Category=/a/ _Cf}');
    Expect(1, 917631, '\p{Is_Category=cf}', "");
    Expect(0, 917631, '\p{^Is_Category=cf}', "");
    Expect(0, 917631, '\P{Is_Category=cf}', "");
    Expect(1, 917631, '\P{^Is_Category=cf}', "");
    Expect(0, 917632, '\p{Is_Category=cf}', "");
    Expect(1, 917632, '\p{^Is_Category=cf}', "");
    Expect(1, 917632, '\P{Is_Category=cf}', "");
    Expect(0, 917632, '\P{^Is_Category=cf}', "");
    Expect(1, 917631, '\p{Is_Category:   - cf}', "");
    Expect(0, 917631, '\p{^Is_Category:   - cf}', "");
    Expect(0, 917631, '\P{Is_Category:   - cf}', "");
    Expect(1, 917631, '\P{^Is_Category:   - cf}', "");
    Expect(0, 917632, '\p{Is_Category:   - cf}', "");
    Expect(1, 917632, '\p{^Is_Category:   - cf}', "");
    Expect(1, 917632, '\P{Is_Category:   - cf}', "");
    Expect(0, 917632, '\P{^Is_Category:   - cf}', "");
    Error('\p{General_Category=-	Unassigned/a/}');
    Error('\P{General_Category=-	Unassigned/a/}');
    Expect(1, 918000, '\p{General_Category=unassigned}', "");
    Expect(0, 918000, '\p{^General_Category=unassigned}', "");
    Expect(0, 918000, '\P{General_Category=unassigned}', "");
    Expect(1, 918000, '\P{^General_Category=unassigned}', "");
    Expect(0, 1114109, '\p{General_Category=unassigned}', "");
    Expect(1, 1114109, '\p{^General_Category=unassigned}', "");
    Expect(1, 1114109, '\P{General_Category=unassigned}', "");
    Expect(0, 1114109, '\P{^General_Category=unassigned}', "");
    Expect(1, 918000, '\p{General_Category=_	UNASSIGNED}', "");
    Expect(0, 918000, '\p{^General_Category=_	UNASSIGNED}', "");
    Expect(0, 918000, '\P{General_Category=_	UNASSIGNED}', "");
    Expect(1, 918000, '\P{^General_Category=_	UNASSIGNED}', "");
    Expect(0, 1114109, '\p{General_Category=_	UNASSIGNED}', "");
    Expect(1, 1114109, '\p{^General_Category=_	UNASSIGNED}', "");
    Expect(1, 1114109, '\P{General_Category=_	UNASSIGNED}', "");
    Expect(0, 1114109, '\P{^General_Category=_	UNASSIGNED}', "");
    Error('\p{Gc=_:=Cn}');
    Error('\P{Gc=_:=Cn}');
    Expect(1, 918000, '\p{Gc=cn}', "");
    Expect(0, 918000, '\p{^Gc=cn}', "");
    Expect(0, 918000, '\P{Gc=cn}', "");
    Expect(1, 918000, '\P{^Gc=cn}', "");
    Expect(0, 1114109, '\p{Gc=cn}', "");
    Expect(1, 1114109, '\p{^Gc=cn}', "");
    Expect(1, 1114109, '\P{Gc=cn}', "");
    Expect(0, 1114109, '\P{^Gc=cn}', "");
    Expect(1, 918000, '\p{Gc:  	Cn}', "");
    Expect(0, 918000, '\p{^Gc:  	Cn}', "");
    Expect(0, 918000, '\P{Gc:  	Cn}', "");
    Expect(1, 918000, '\P{^Gc:  	Cn}', "");
    Expect(0, 1114109, '\p{Gc:  	Cn}', "");
    Expect(1, 1114109, '\p{^Gc:  	Cn}', "");
    Expect(1, 1114109, '\P{Gc:  	Cn}', "");
    Expect(0, 1114109, '\P{^Gc:  	Cn}', "");
    Error('\p{Category: /a/__Unassigned}');
    Error('\P{Category: /a/__Unassigned}');
    Expect(1, 918000, '\p{Category=unassigned}', "");
    Expect(0, 918000, '\p{^Category=unassigned}', "");
    Expect(0, 918000, '\P{Category=unassigned}', "");
    Expect(1, 918000, '\P{^Category=unassigned}', "");
    Expect(0, 1114109, '\p{Category=unassigned}', "");
    Expect(1, 1114109, '\p{^Category=unassigned}', "");
    Expect(1, 1114109, '\P{Category=unassigned}', "");
    Expect(0, 1114109, '\P{^Category=unassigned}', "");
    Expect(1, 918000, '\p{Category:   -_Unassigned}', "");
    Expect(0, 918000, '\p{^Category:   -_Unassigned}', "");
    Expect(0, 918000, '\P{Category:   -_Unassigned}', "");
    Expect(1, 918000, '\P{^Category:   -_Unassigned}', "");
    Expect(0, 1114109, '\p{Category:   -_Unassigned}', "");
    Expect(1, 1114109, '\p{^Category:   -_Unassigned}', "");
    Expect(1, 1114109, '\P{Category:   -_Unassigned}', "");
    Expect(0, 1114109, '\P{^Category:   -_Unassigned}', "");
    Error('\p{Is_General_Category:   :=-	CN}');
    Error('\P{Is_General_Category:   :=-	CN}');
    Expect(1, 918000, '\p{Is_General_Category=cn}', "");
    Expect(0, 918000, '\p{^Is_General_Category=cn}', "");
    Expect(0, 918000, '\P{Is_General_Category=cn}', "");
    Expect(1, 918000, '\P{^Is_General_Category=cn}', "");
    Expect(0, 1114109, '\p{Is_General_Category=cn}', "");
    Expect(1, 1114109, '\p{^Is_General_Category=cn}', "");
    Expect(1, 1114109, '\P{Is_General_Category=cn}', "");
    Expect(0, 1114109, '\P{^Is_General_Category=cn}', "");
    Expect(1, 918000, '\p{Is_General_Category=- CN}', "");
    Expect(0, 918000, '\p{^Is_General_Category=- CN}', "");
    Expect(0, 918000, '\P{Is_General_Category=- CN}', "");
    Expect(1, 918000, '\P{^Is_General_Category=- CN}', "");
    Expect(0, 1114109, '\p{Is_General_Category=- CN}', "");
    Expect(1, 1114109, '\p{^Is_General_Category=- CN}', "");
    Expect(1, 1114109, '\P{Is_General_Category=- CN}', "");
    Expect(0, 1114109, '\P{^Is_General_Category=- CN}', "");
    Error('\p{Is_Gc=/a/ -Unassigned}');
    Error('\P{Is_Gc=/a/ -Unassigned}');
    Expect(1, 918000, '\p{Is_Gc=unassigned}', "");
    Expect(0, 918000, '\p{^Is_Gc=unassigned}', "");
    Expect(0, 918000, '\P{Is_Gc=unassigned}', "");
    Expect(1, 918000, '\P{^Is_Gc=unassigned}', "");
    Expect(0, 1114109, '\p{Is_Gc=unassigned}', "");
    Expect(1, 1114109, '\p{^Is_Gc=unassigned}', "");
    Expect(1, 1114109, '\P{Is_Gc=unassigned}', "");
    Expect(0, 1114109, '\P{^Is_Gc=unassigned}', "");
    Error('\p{Is_Category=-	Cn:=}');
    Error('\P{Is_Category=-	Cn:=}');
    Expect(1, 918000, '\p{Is_Category=cn}', "");
    Expect(0, 918000, '\p{^Is_Category=cn}', "");
    Expect(0, 918000, '\P{Is_Category=cn}', "");
    Expect(1, 918000, '\P{^Is_Category=cn}', "");
    Expect(0, 1114109, '\p{Is_Category=cn}', "");
    Expect(1, 1114109, '\p{^Is_Category=cn}', "");
    Expect(1, 1114109, '\P{Is_Category=cn}', "");
    Expect(0, 1114109, '\P{^Is_Category=cn}', "");
    Expect(1, 918000, '\p{Is_Category=	Cn}', "");
    Expect(0, 918000, '\p{^Is_Category=	Cn}', "");
    Expect(0, 918000, '\P{Is_Category=	Cn}', "");
    Expect(1, 918000, '\P{^Is_Category=	Cn}', "");
    Expect(0, 1114109, '\p{Is_Category=	Cn}', "");
    Expect(1, 1114109, '\p{^Is_Category=	Cn}', "");
    Expect(1, 1114109, '\P{Is_Category=	Cn}', "");
    Expect(0, 1114109, '\P{^Is_Category=	Cn}', "");
    Error('\p{General_Category=	:=PRIVATE_USE}');
    Error('\P{General_Category=	:=PRIVATE_USE}');
    Expect(1, 1114109, '\p{General_Category=privateuse}', "");
    Expect(0, 1114109, '\p{^General_Category=privateuse}', "");
    Expect(0, 1114109, '\P{General_Category=privateuse}', "");
    Expect(1, 1114109, '\P{^General_Category=privateuse}', "");
    Expect(0, 63744, '\p{General_Category=privateuse}', "");
    Expect(1, 63744, '\p{^General_Category=privateuse}', "");
    Expect(1, 63744, '\P{General_Category=privateuse}', "");
    Expect(0, 63744, '\P{^General_Category=privateuse}', "");
    Expect(1, 1114109, '\p{General_Category=_PRIVATE_USE}', "");
    Expect(0, 1114109, '\p{^General_Category=_PRIVATE_USE}', "");
    Expect(0, 1114109, '\P{General_Category=_PRIVATE_USE}', "");
    Expect(1, 1114109, '\P{^General_Category=_PRIVATE_USE}', "");
    Expect(0, 63744, '\p{General_Category=_PRIVATE_USE}', "");
    Expect(1, 63744, '\p{^General_Category=_PRIVATE_USE}', "");
    Expect(1, 63744, '\P{General_Category=_PRIVATE_USE}', "");
    Expect(0, 63744, '\P{^General_Category=_PRIVATE_USE}', "");
    Error('\p{Gc= -CO/a/}');
    Error('\P{Gc= -CO/a/}');
    Expect(1, 1114109, '\p{Gc=co}', "");
    Expect(0, 1114109, '\p{^Gc=co}', "");
    Expect(0, 1114109, '\P{Gc=co}', "");
    Expect(1, 1114109, '\P{^Gc=co}', "");
    Expect(0, 63744, '\p{Gc=co}', "");
    Expect(1, 63744, '\p{^Gc=co}', "");
    Expect(1, 63744, '\P{Gc=co}', "");
    Expect(0, 63744, '\P{^Gc=co}', "");
    Expect(1, 1114109, '\p{Gc=__Co}', "");
    Expect(0, 1114109, '\p{^Gc=__Co}', "");
    Expect(0, 1114109, '\P{Gc=__Co}', "");
    Expect(1, 1114109, '\P{^Gc=__Co}', "");
    Expect(0, 63744, '\p{Gc=__Co}', "");
    Expect(1, 63744, '\p{^Gc=__Co}', "");
    Expect(1, 63744, '\P{Gc=__Co}', "");
    Expect(0, 63744, '\P{^Gc=__Co}', "");
    Error('\p{Category=--Private_USE:=}');
    Error('\P{Category=--Private_USE:=}');
    Expect(1, 1114109, '\p{Category:privateuse}', "");
    Expect(0, 1114109, '\p{^Category:privateuse}', "");
}
if (!$::TESTCHUNK or $::TESTCHUNK == 2) {
    Expect(0, 1114109, '\P{Category:privateuse}', "");
    Expect(1, 1114109, '\P{^Category:privateuse}', "");
    Expect(0, 63744, '\p{Category:privateuse}', "");
    Expect(1, 63744, '\p{^Category:privateuse}', "");
    Expect(1, 63744, '\P{Category:privateuse}', "");
    Expect(0, 63744, '\P{^Category:privateuse}', "");
    Expect(1, 1114109, '\p{Category:   -	Private_Use}', "");
    Expect(0, 1114109, '\p{^Category:   -	Private_Use}', "");
    Expect(0, 1114109, '\P{Category:   -	Private_Use}', "");
    Expect(1, 1114109, '\P{^Category:   -	Private_Use}', "");
    Expect(0, 63744, '\p{Category:   -	Private_Use}', "");
    Expect(1, 63744, '\p{^Category:   -	Private_Use}', "");
    Expect(1, 63744, '\P{Category:   -	Private_Use}', "");
    Expect(0, 63744, '\P{^Category:   -	Private_Use}', "");
    Error('\p{Is_General_Category=	_CO/a/}');
    Error('\P{Is_General_Category=	_CO/a/}');
    Expect(1, 1114109, '\p{Is_General_Category=co}', "");
    Expect(0, 1114109, '\p{^Is_General_Category=co}', "");
    Expect(0, 1114109, '\P{Is_General_Category=co}', "");
    Expect(1, 1114109, '\P{^Is_General_Category=co}', "");
    Expect(0, 63744, '\p{Is_General_Category=co}', "");
    Expect(1, 63744, '\p{^Is_General_Category=co}', "");
    Expect(1, 63744, '\P{Is_General_Category=co}', "");
    Expect(0, 63744, '\P{^Is_General_Category=co}', "");
    Expect(1, 1114109, '\p{Is_General_Category=_Co}', "");
    Expect(0, 1114109, '\p{^Is_General_Category=_Co}', "");
    Expect(0, 1114109, '\P{Is_General_Category=_Co}', "");
    Expect(1, 1114109, '\P{^Is_General_Category=_Co}', "");
    Expect(0, 63744, '\p{Is_General_Category=_Co}', "");
    Expect(1, 63744, '\p{^Is_General_Category=_Co}', "");
    Expect(1, 63744, '\P{Is_General_Category=_Co}', "");
    Expect(0, 63744, '\P{^Is_General_Category=_Co}', "");
    Error('\p{Is_Gc=/a/ _private_Use}');
    Error('\P{Is_Gc=/a/ _private_Use}');
    Expect(1, 1114109, '\p{Is_Gc=privateuse}', "");
    Expect(0, 1114109, '\p{^Is_Gc=privateuse}', "");
    Expect(0, 1114109, '\P{Is_Gc=privateuse}', "");
    Expect(1, 1114109, '\P{^Is_Gc=privateuse}', "");
    Expect(0, 63744, '\p{Is_Gc=privateuse}', "");
    Expect(1, 63744, '\p{^Is_Gc=privateuse}', "");
    Expect(1, 63744, '\P{Is_Gc=privateuse}', "");
    Expect(0, 63744, '\P{^Is_Gc=privateuse}', "");
    Expect(1, 1114109, '\p{Is_Gc= -private_Use}', "");
    Expect(0, 1114109, '\p{^Is_Gc= -private_Use}', "");
    Expect(0, 1114109, '\P{Is_Gc= -private_Use}', "");
    Expect(1, 1114109, '\P{^Is_Gc= -private_Use}', "");
    Expect(0, 63744, '\p{Is_Gc= -private_Use}', "");
    Expect(1, 63744, '\p{^Is_Gc= -private_Use}', "");
    Expect(1, 63744, '\P{Is_Gc= -private_Use}', "");
    Expect(0, 63744, '\P{^Is_Gc= -private_Use}', "");
    Error('\p{Is_Category=:=Co}');
    Error('\P{Is_Category=:=Co}');
    Expect(1, 1114109, '\p{Is_Category=co}', "");
    Expect(0, 1114109, '\p{^Is_Category=co}', "");
    Expect(0, 1114109, '\P{Is_Category=co}', "");
    Expect(1, 1114109, '\P{^Is_Category=co}', "");
    Expect(0, 63744, '\p{Is_Category=co}', "");
    Expect(1, 63744, '\p{^Is_Category=co}', "");
    Expect(1, 63744, '\P{Is_Category=co}', "");
    Expect(0, 63744, '\P{^Is_Category=co}', "");
    Expect(1, 1114109, '\p{Is_Category=-	Co}', "");
    Expect(0, 1114109, '\p{^Is_Category=-	Co}', "");
    Expect(0, 1114109, '\P{Is_Category=-	Co}', "");
    Expect(1, 1114109, '\P{^Is_Category=-	Co}', "");
    Expect(0, 63744, '\p{Is_Category=-	Co}', "");
    Expect(1, 63744, '\p{^Is_Category=-	Co}', "");
    Expect(1, 63744, '\P{Is_Category=-	Co}', "");
    Expect(0, 63744, '\P{^Is_Category=-	Co}', "");
    Error('\p{General_Category:	:= SURROGATE}');
    Error('\P{General_Category:	:= SURROGATE}');
    Expect(1, 57343, '\p{General_Category=surrogate}', "");
    Expect(0, 57343, '\p{^General_Category=surrogate}', "");
    Expect(0, 57343, '\P{General_Category=surrogate}', "");
    Expect(1, 57343, '\P{^General_Category=surrogate}', "");
    Expect(0, 57344, '\p{General_Category=surrogate}', "");
    Expect(1, 57344, '\p{^General_Category=surrogate}', "");
    Expect(1, 57344, '\P{General_Category=surrogate}', "");
    Expect(0, 57344, '\P{^General_Category=surrogate}', "");
    Expect(1, 57343, '\p{General_Category=__SURROGATE}', "");
    Expect(0, 57343, '\p{^General_Category=__SURROGATE}', "");
    Expect(0, 57343, '\P{General_Category=__SURROGATE}', "");
    Expect(1, 57343, '\P{^General_Category=__SURROGATE}', "");
    Expect(0, 57344, '\p{General_Category=__SURROGATE}', "");
    Expect(1, 57344, '\p{^General_Category=__SURROGATE}', "");
    Expect(1, 57344, '\P{General_Category=__SURROGATE}', "");
    Expect(0, 57344, '\P{^General_Category=__SURROGATE}', "");
    Error('\p{Gc= _Cs/a/}');
    Error('\P{Gc= _Cs/a/}');
    Expect(1, 57343, '\p{Gc=cs}', "");
    Expect(0, 57343, '\p{^Gc=cs}', "");
    Expect(0, 57343, '\P{Gc=cs}', "");
    Expect(1, 57343, '\P{^Gc=cs}', "");
    Expect(0, 57344, '\p{Gc=cs}', "");
    Expect(1, 57344, '\p{^Gc=cs}', "");
    Expect(1, 57344, '\P{Gc=cs}', "");
    Expect(0, 57344, '\P{^Gc=cs}', "");
    Expect(1, 57343, '\p{Gc=_	Cs}', "");
    Expect(0, 57343, '\p{^Gc=_	Cs}', "");
    Expect(0, 57343, '\P{Gc=_	Cs}', "");
    Expect(1, 57343, '\P{^Gc=_	Cs}', "");
    Expect(0, 57344, '\p{Gc=_	Cs}', "");
    Expect(1, 57344, '\p{^Gc=_	Cs}', "");
    Expect(1, 57344, '\P{Gc=_	Cs}', "");
    Expect(0, 57344, '\P{^Gc=_	Cs}', "");
    Error('\p{Category=/a/-SURROGATE}');
    Error('\P{Category=/a/-SURROGATE}');
    Expect(1, 57343, '\p{Category=surrogate}', "");
    Expect(0, 57343, '\p{^Category=surrogate}', "");
    Expect(0, 57343, '\P{Category=surrogate}', "");
    Expect(1, 57343, '\P{^Category=surrogate}', "");
    Expect(0, 57344, '\p{Category=surrogate}', "");
    Expect(1, 57344, '\p{^Category=surrogate}', "");
    Expect(1, 57344, '\P{Category=surrogate}', "");
    Expect(0, 57344, '\P{^Category=surrogate}', "");
    Expect(1, 57343, '\p{Category=	Surrogate}', "");
    Expect(0, 57343, '\p{^Category=	Surrogate}', "");
    Expect(0, 57343, '\P{Category=	Surrogate}', "");
    Expect(1, 57343, '\P{^Category=	Surrogate}', "");
    Expect(0, 57344, '\p{Category=	Surrogate}', "");
    Expect(1, 57344, '\p{^Category=	Surrogate}', "");
    Expect(1, 57344, '\P{Category=	Surrogate}', "");
    Expect(0, 57344, '\P{^Category=	Surrogate}', "");
    Error('\p{Is_General_Category:	/a/Cs}');
    Error('\P{Is_General_Category:	/a/Cs}');
    Expect(1, 57343, '\p{Is_General_Category:   cs}', "");
    Expect(0, 57343, '\p{^Is_General_Category:   cs}', "");
    Expect(0, 57343, '\P{Is_General_Category:   cs}', "");
    Expect(1, 57343, '\P{^Is_General_Category:   cs}', "");
    Expect(0, 57344, '\p{Is_General_Category:   cs}', "");
    Expect(1, 57344, '\p{^Is_General_Category:   cs}', "");
    Expect(1, 57344, '\P{Is_General_Category:   cs}', "");
    Expect(0, 57344, '\P{^Is_General_Category:   cs}', "");
    Expect(1, 57343, '\p{Is_General_Category=	-Cs}', "");
    Expect(0, 57343, '\p{^Is_General_Category=	-Cs}', "");
    Expect(0, 57343, '\P{Is_General_Category=	-Cs}', "");
    Expect(1, 57343, '\P{^Is_General_Category=	-Cs}', "");
    Expect(0, 57344, '\p{Is_General_Category=	-Cs}', "");
    Expect(1, 57344, '\p{^Is_General_Category=	-Cs}', "");
    Expect(1, 57344, '\P{Is_General_Category=	-Cs}', "");
    Expect(0, 57344, '\P{^Is_General_Category=	-Cs}', "");
    Error('\p{Is_Gc:   /a/	surrogate}');
    Error('\P{Is_Gc:   /a/	surrogate}');
    Expect(1, 57343, '\p{Is_Gc=surrogate}', "");
    Expect(0, 57343, '\p{^Is_Gc=surrogate}', "");
    Expect(0, 57343, '\P{Is_Gc=surrogate}', "");
    Expect(1, 57343, '\P{^Is_Gc=surrogate}', "");
    Expect(0, 57344, '\p{Is_Gc=surrogate}', "");
    Expect(1, 57344, '\p{^Is_Gc=surrogate}', "");
    Expect(1, 57344, '\P{Is_Gc=surrogate}', "");
    Expect(0, 57344, '\P{^Is_Gc=surrogate}', "");
    Expect(1, 57343, '\p{Is_Gc=	-surrogate}', "");
    Expect(0, 57343, '\p{^Is_Gc=	-surrogate}', "");
    Expect(0, 57343, '\P{Is_Gc=	-surrogate}', "");
    Expect(1, 57343, '\P{^Is_Gc=	-surrogate}', "");
    Expect(0, 57344, '\p{Is_Gc=	-surrogate}', "");
    Expect(1, 57344, '\p{^Is_Gc=	-surrogate}', "");
    Expect(1, 57344, '\P{Is_Gc=	-surrogate}', "");
    Expect(0, 57344, '\P{^Is_Gc=	-surrogate}', "");
    Error('\p{Is_Category=-	Cs:=}');
    Error('\P{Is_Category=-	Cs:=}');
    Expect(1, 57343, '\p{Is_Category=cs}', "");
    Expect(0, 57343, '\p{^Is_Category=cs}', "");
    Expect(0, 57343, '\P{Is_Category=cs}', "");
    Expect(1, 57343, '\P{^Is_Category=cs}', "");
    Expect(0, 57344, '\p{Is_Category=cs}', "");
    Expect(1, 57344, '\p{^Is_Category=cs}', "");
    Expect(1, 57344, '\P{Is_Category=cs}', "");
    Expect(0, 57344, '\P{^Is_Category=cs}', "");
    Expect(1, 57343, '\p{Is_Category=		Cs}', "");
    Expect(0, 57343, '\p{^Is_Category=		Cs}', "");
    Expect(0, 57343, '\P{Is_Category=		Cs}', "");
    Expect(1, 57343, '\P{^Is_Category=		Cs}', "");
    Expect(0, 57344, '\p{Is_Category=		Cs}', "");
    Expect(1, 57344, '\p{^Is_Category=		Cs}', "");
    Expect(1, 57344, '\P{Is_Category=		Cs}', "");
    Expect(0, 57344, '\P{^Is_Category=		Cs}', "");
    Error('\p{General_Category=:=_	letter}');
    Error('\P{General_Category=:=_	letter}');
    Expect(1, 195101, '\p{General_Category=letter}', "");
    Expect(0, 195101, '\p{^General_Category=letter}', "");
    Expect(0, 195101, '\P{General_Category=letter}', "");
    Expect(1, 195101, '\P{^General_Category=letter}', "");
    Expect(0, 195102, '\p{General_Category=letter}', "");
    Expect(1, 195102, '\p{^General_Category=letter}', "");
    Expect(1, 195102, '\P{General_Category=letter}', "");
    Expect(0, 195102, '\P{^General_Category=letter}', "");
    Expect(1, 195101, '\p{General_Category=_	letter}', "");
    Expect(0, 195101, '\p{^General_Category=_	letter}', "");
    Expect(0, 195101, '\P{General_Category=_	letter}', "");
    Expect(1, 195101, '\P{^General_Category=_	letter}', "");
    Expect(0, 195102, '\p{General_Category=_	letter}', "");
    Expect(1, 195102, '\p{^General_Category=_	letter}', "");
    Expect(1, 195102, '\P{General_Category=_	letter}', "");
    Expect(0, 195102, '\P{^General_Category=_	letter}', "");
    Error('\p{Gc=	/a/L}');
    Error('\P{Gc=	/a/L}');
    Expect(1, 195101, '\p{Gc=l}', "");
    Expect(0, 195101, '\p{^Gc=l}', "");
    Expect(0, 195101, '\P{Gc=l}', "");
    Expect(1, 195101, '\P{^Gc=l}', "");
    Expect(0, 195102, '\p{Gc=l}', "");
    Expect(1, 195102, '\p{^Gc=l}', "");
    Expect(1, 195102, '\P{Gc=l}', "");
    Expect(0, 195102, '\P{^Gc=l}', "");
    Expect(1, 195101, '\p{Gc:   _L}', "");
    Expect(0, 195101, '\p{^Gc:   _L}', "");
    Expect(0, 195101, '\P{Gc:   _L}', "");
    Expect(1, 195101, '\P{^Gc:   _L}', "");
    Expect(0, 195102, '\p{Gc:   _L}', "");
    Expect(1, 195102, '\p{^Gc:   _L}', "");
    Expect(1, 195102, '\P{Gc:   _L}', "");
    Expect(0, 195102, '\P{^Gc:   _L}', "");
    Error('\p{Category=_:=Letter}');
    Error('\P{Category=_:=Letter}');
    Expect(1, 195101, '\p{Category=letter}', "");
    Expect(0, 195101, '\p{^Category=letter}', "");
    Expect(0, 195101, '\P{Category=letter}', "");
    Expect(1, 195101, '\P{^Category=letter}', "");
    Expect(0, 195102, '\p{Category=letter}', "");
    Expect(1, 195102, '\p{^Category=letter}', "");
    Expect(1, 195102, '\P{Category=letter}', "");
    Expect(0, 195102, '\P{^Category=letter}', "");
    Expect(1, 195101, '\p{Category=	 letter}', "");
    Expect(0, 195101, '\p{^Category=	 letter}', "");
    Expect(0, 195101, '\P{Category=	 letter}', "");
    Expect(1, 195101, '\P{^Category=	 letter}', "");
    Expect(0, 195102, '\p{Category=	 letter}', "");
    Expect(1, 195102, '\p{^Category=	 letter}', "");
    Expect(1, 195102, '\P{Category=	 letter}', "");
    Expect(0, 195102, '\P{^Category=	 letter}', "");
    Error('\p{Is_General_Category=-/a/L}');
    Error('\P{Is_General_Category=-/a/L}');
    Expect(1, 195101, '\p{Is_General_Category=l}', "");
    Expect(0, 195101, '\p{^Is_General_Category=l}', "");
    Expect(0, 195101, '\P{Is_General_Category=l}', "");
    Expect(1, 195101, '\P{^Is_General_Category=l}', "");
    Expect(0, 195102, '\p{Is_General_Category=l}', "");
    Expect(1, 195102, '\p{^Is_General_Category=l}', "");
    Expect(1, 195102, '\P{Is_General_Category=l}', "");
    Expect(0, 195102, '\P{^Is_General_Category=l}', "");
    Expect(1, 195101, '\p{Is_General_Category:-_l}', "");
    Expect(0, 195101, '\p{^Is_General_Category:-_l}', "");
    Expect(0, 195101, '\P{Is_General_Category:-_l}', "");
    Expect(1, 195101, '\P{^Is_General_Category:-_l}', "");
    Expect(0, 195102, '\p{Is_General_Category:-_l}', "");
    Expect(1, 195102, '\p{^Is_General_Category:-_l}', "");
    Expect(1, 195102, '\P{Is_General_Category:-_l}', "");
    Expect(0, 195102, '\P{^Is_General_Category:-_l}', "");
    Error('\p{Is_Gc=:=  LETTER}');
    Error('\P{Is_Gc=:=  LETTER}');
    Expect(1, 195101, '\p{Is_Gc=letter}', "");
    Expect(0, 195101, '\p{^Is_Gc=letter}', "");
    Expect(0, 195101, '\P{Is_Gc=letter}', "");
    Expect(1, 195101, '\P{^Is_Gc=letter}', "");
    Expect(0, 195102, '\p{Is_Gc=letter}', "");
    Expect(1, 195102, '\p{^Is_Gc=letter}', "");
    Expect(1, 195102, '\P{Is_Gc=letter}', "");
    Expect(0, 195102, '\P{^Is_Gc=letter}', "");
    Expect(1, 195101, '\p{Is_Gc= Letter}', "");
    Expect(0, 195101, '\p{^Is_Gc= Letter}', "");
    Expect(0, 195101, '\P{Is_Gc= Letter}', "");
    Expect(1, 195101, '\P{^Is_Gc= Letter}', "");
    Expect(0, 195102, '\p{Is_Gc= Letter}', "");
    Expect(1, 195102, '\p{^Is_Gc= Letter}', "");
    Expect(1, 195102, '\P{Is_Gc= Letter}', "");
    Expect(0, 195102, '\P{^Is_Gc= Letter}', "");
    Error('\p{Is_Category=_/a/L}');
    Error('\P{Is_Category=_/a/L}');
    Expect(1, 195101, '\p{Is_Category=l}', "");
    Expect(0, 195101, '\p{^Is_Category=l}', "");
    Expect(0, 195101, '\P{Is_Category=l}', "");
    Expect(1, 195101, '\P{^Is_Category=l}', "");
    Expect(0, 195102, '\p{Is_Category=l}', "");
    Expect(1, 195102, '\p{^Is_Category=l}', "");
    Expect(1, 195102, '\P{Is_Category=l}', "");
    Expect(0, 195102, '\P{^Is_Category=l}', "");
    Expect(1, 195101, '\p{Is_Category=-	L}', "");
    Expect(0, 195101, '\p{^Is_Category=-	L}', "");
    Expect(0, 195101, '\P{Is_Category=-	L}', "");
    Expect(1, 195101, '\P{^Is_Category=-	L}', "");
    Expect(0, 195102, '\p{Is_Category=-	L}', "");
    Expect(1, 195102, '\p{^Is_Category=-	L}', "");
    Expect(1, 195102, '\P{Is_Category=-	L}', "");
    Expect(0, 195102, '\P{^Is_Category=-	L}', "");
    Error('\p{General_Category:	/a/ Cased_letter}');
    Error('\P{General_Category:	/a/ Cased_letter}');
    Expect(1, 125251, '\p{General_Category=casedletter}', "");
    Expect(0, 125251, '\p{^General_Category=casedletter}', "");
    Expect(0, 125251, '\P{General_Category=casedletter}', "");
    Expect(1, 125251, '\P{^General_Category=casedletter}', "");
    Expect(0, 125252, '\p{General_Category=casedletter}', "");
    Expect(1, 125252, '\p{^General_Category=casedletter}', "");
    Expect(1, 125252, '\P{General_Category=casedletter}', "");
    Expect(0, 125252, '\P{^General_Category=casedletter}', "");
    Expect(1, 125251, '\p{General_Category:	-Cased_letter}', "");
    Expect(0, 125251, '\p{^General_Category:	-Cased_letter}', "");
    Expect(0, 125251, '\P{General_Category:	-Cased_letter}', "");
    Expect(1, 125251, '\P{^General_Category:	-Cased_letter}', "");
    Expect(0, 125252, '\p{General_Category:	-Cased_letter}', "");
    Expect(1, 125252, '\p{^General_Category:	-Cased_letter}', "");
    Expect(1, 125252, '\P{General_Category:	-Cased_letter}', "");
    Expect(0, 125252, '\P{^General_Category:	-Cased_letter}', "");
    Error('\p{Gc=_/a/LC}');
    Error('\P{Gc=_/a/LC}');
    Expect(1, 125251, '\p{Gc=lc}', "");
    Expect(0, 125251, '\p{^Gc=lc}', "");
    Expect(0, 125251, '\P{Gc=lc}', "");
    Expect(1, 125251, '\P{^Gc=lc}', "");
    Expect(0, 125252, '\p{Gc=lc}', "");
    Expect(1, 125252, '\p{^Gc=lc}', "");
    Expect(1, 125252, '\P{Gc=lc}', "");
    Expect(0, 125252, '\P{^Gc=lc}', "");
    Expect(1, 125251, '\p{Gc=	LC}', "");
    Expect(0, 125251, '\p{^Gc=	LC}', "");
    Expect(0, 125251, '\P{Gc=	LC}', "");
    Expect(1, 125251, '\P{^Gc=	LC}', "");
    Expect(0, 125252, '\p{Gc=	LC}', "");
    Expect(1, 125252, '\p{^Gc=	LC}', "");
    Expect(1, 125252, '\P{Gc=	LC}', "");
    Expect(0, 125252, '\P{^Gc=	LC}', "");
    Error('\p{Category:   /a/L_}');
    Error('\P{Category:   /a/L_}');
    Expect(1, 125251, '\p{Category=l_}', "");
    Expect(0, 125251, '\p{^Category=l_}', "");
    Expect(0, 125251, '\P{Category=l_}', "");
    Expect(1, 125251, '\P{^Category=l_}', "");
    Expect(0, 125252, '\p{Category=l_}', "");
    Expect(1, 125252, '\p{^Category=l_}', "");
    Expect(1, 125252, '\P{Category=l_}', "");
    Expect(0, 125252, '\P{^Category=l_}', "");
    Expect(1, 125251, '\p{Category=	-L_}', "");
    Expect(0, 125251, '\p{^Category=	-L_}', "");
    Expect(0, 125251, '\P{Category=	-L_}', "");
    Expect(1, 125251, '\P{^Category=	-L_}', "");
    Expect(0, 125252, '\p{Category=	-L_}', "");
    Expect(1, 125252, '\p{^Category=	-L_}', "");
    Expect(1, 125252, '\P{Category=	-L_}', "");
    Expect(0, 125252, '\P{^Category=	-L_}', "");
    Error('\p{Is_General_Category=:=-L&}');
    Error('\P{Is_General_Category=:=-L&}');
    Expect(1, 125251, '\p{Is_General_Category=l&}', "");
    Expect(0, 125251, '\p{^Is_General_Category=l&}', "");
    Expect(0, 125251, '\P{Is_General_Category=l&}', "");
    Expect(1, 125251, '\P{^Is_General_Category=l&}', "");
    Expect(0, 125252, '\p{Is_General_Category=l&}', "");
    Expect(1, 125252, '\p{^Is_General_Category=l&}', "");
    Expect(1, 125252, '\P{Is_General_Category=l&}', "");
    Expect(0, 125252, '\P{^Is_General_Category=l&}', "");
    Expect(1, 125251, '\p{Is_General_Category: 		L&}', "");
    Expect(0, 125251, '\p{^Is_General_Category: 		L&}', "");
    Expect(0, 125251, '\P{Is_General_Category: 		L&}', "");
    Expect(1, 125251, '\P{^Is_General_Category: 		L&}', "");
    Expect(0, 125252, '\p{Is_General_Category: 		L&}', "");
    Expect(1, 125252, '\p{^Is_General_Category: 		L&}', "");
    Expect(1, 125252, '\P{Is_General_Category: 		L&}', "");
    Expect(0, 125252, '\P{^Is_General_Category: 		L&}', "");
    Error('\p{Is_Gc=-_Cased_letter:=}');
    Error('\P{Is_Gc=-_Cased_letter:=}');
    Expect(1, 125251, '\p{Is_Gc:   casedletter}', "");
    Expect(0, 125251, '\p{^Is_Gc:   casedletter}', "");
    Expect(0, 125251, '\P{Is_Gc:   casedletter}', "");
    Expect(1, 125251, '\P{^Is_Gc:   casedletter}', "");
    Expect(0, 125252, '\p{Is_Gc:   casedletter}', "");
    Expect(1, 125252, '\p{^Is_Gc:   casedletter}', "");
    Expect(1, 125252, '\P{Is_Gc:   casedletter}', "");
    Expect(0, 125252, '\P{^Is_Gc:   casedletter}', "");
    Expect(1, 125251, '\p{Is_Gc:_	Cased_Letter}', "");
    Expect(0, 125251, '\p{^Is_Gc:_	Cased_Letter}', "");
    Expect(0, 125251, '\P{Is_Gc:_	Cased_Letter}', "");
    Expect(1, 125251, '\P{^Is_Gc:_	Cased_Letter}', "");
    Expect(0, 125252, '\p{Is_Gc:_	Cased_Letter}', "");
    Expect(1, 125252, '\p{^Is_Gc:_	Cased_Letter}', "");
    Expect(1, 125252, '\P{Is_Gc:_	Cased_Letter}', "");
    Expect(0, 125252, '\P{^Is_Gc:_	Cased_Letter}', "");
    Error('\p{Is_Category=_:=LC}');
    Error('\P{Is_Category=_:=LC}');
    Expect(1, 125251, '\p{Is_Category=lc}', "");
    Expect(0, 125251, '\p{^Is_Category=lc}', "");
    Expect(0, 125251, '\P{Is_Category=lc}', "");
    Expect(1, 125251, '\P{^Is_Category=lc}', "");
    Expect(0, 125252, '\p{Is_Category=lc}', "");
    Expect(1, 125252, '\p{^Is_Category=lc}', "");
    Expect(1, 125252, '\P{Is_Category=lc}', "");
    Expect(0, 125252, '\P{^Is_Category=lc}', "");
    Expect(1, 125251, '\p{Is_Category=_LC}', "");
    Expect(0, 125251, '\p{^Is_Category=_LC}', "");
    Expect(0, 125251, '\P{Is_Category=_LC}', "");
    Expect(1, 125251, '\P{^Is_Category=_LC}', "");
    Expect(0, 125252, '\p{Is_Category=_LC}', "");
    Expect(1, 125252, '\p{^Is_Category=_LC}', "");
    Expect(1, 125252, '\P{Is_Category=_LC}', "");
    Expect(0, 125252, '\P{^Is_Category=_LC}', "");
    Error('\p{General_Category=_LOWERCASE_letter/a/}');
    Error('\P{General_Category=_LOWERCASE_letter/a/}');
    Expect(1, 125251, '\p{General_Category=lowercaseletter}', "");
    Expect(0, 125251, '\p{^General_Category=lowercaseletter}', "");
    Expect(0, 125251, '\P{General_Category=lowercaseletter}', "");
    Expect(1, 125251, '\P{^General_Category=lowercaseletter}', "");
    Expect(0, 125252, '\p{General_Category=lowercaseletter}', "");
    Expect(1, 125252, '\p{^General_Category=lowercaseletter}', "");
    Expect(1, 125252, '\P{General_Category=lowercaseletter}', "");
    Expect(0, 125252, '\P{^General_Category=lowercaseletter}', "");
    Expect(1, 125251, '\p{General_Category=	 Lowercase_letter}', "");
    Expect(0, 125251, '\p{^General_Category=	 Lowercase_letter}', "");
    Expect(0, 125251, '\P{General_Category=	 Lowercase_letter}', "");
    Expect(1, 125251, '\P{^General_Category=	 Lowercase_letter}', "");
    Expect(0, 125252, '\p{General_Category=	 Lowercase_letter}', "");
    Expect(1, 125252, '\p{^General_Category=	 Lowercase_letter}', "");
    Expect(1, 125252, '\P{General_Category=	 Lowercase_letter}', "");
    Expect(0, 125252, '\P{^General_Category=	 Lowercase_letter}', "");
    Error('\p{Gc=/a/ _Ll}');
    Error('\P{Gc=/a/ _Ll}');
    Expect(1, 125251, '\p{Gc=ll}', "");
    Expect(0, 125251, '\p{^Gc=ll}', "");
    Expect(0, 125251, '\P{Gc=ll}', "");
    Expect(1, 125251, '\P{^Gc=ll}', "");
    Expect(0, 125252, '\p{Gc=ll}', "");
    Expect(1, 125252, '\p{^Gc=ll}', "");
    Expect(1, 125252, '\P{Gc=ll}', "");
    Expect(0, 125252, '\P{^Gc=ll}', "");
    Expect(1, 125251, '\p{Gc=-Ll}', "");
    Expect(0, 125251, '\p{^Gc=-Ll}', "");
    Expect(0, 125251, '\P{Gc=-Ll}', "");
    Expect(1, 125251, '\P{^Gc=-Ll}', "");
    Expect(0, 125252, '\p{Gc=-Ll}', "");
    Expect(1, 125252, '\p{^Gc=-Ll}', "");
    Expect(1, 125252, '\P{Gc=-Ll}', "");
    Expect(0, 125252, '\P{^Gc=-Ll}', "");
    Error('\p{Category=	_Lowercase_Letter/a/}');
    Error('\P{Category=	_Lowercase_Letter/a/}');
    Expect(1, 125251, '\p{Category: lowercaseletter}', "");
    Expect(0, 125251, '\p{^Category: lowercaseletter}', "");
    Expect(0, 125251, '\P{Category: lowercaseletter}', "");
    Expect(1, 125251, '\P{^Category: lowercaseletter}', "");
    Expect(0, 125252, '\p{Category: lowercaseletter}', "");
    Expect(1, 125252, '\p{^Category: lowercaseletter}', "");
    Expect(1, 125252, '\P{Category: lowercaseletter}', "");
    Expect(0, 125252, '\P{^Category: lowercaseletter}', "");
    Expect(1, 125251, '\p{Category=__Lowercase_Letter}', "");
    Expect(0, 125251, '\p{^Category=__Lowercase_Letter}', "");
    Expect(0, 125251, '\P{Category=__Lowercase_Letter}', "");
    Expect(1, 125251, '\P{^Category=__Lowercase_Letter}', "");
    Expect(0, 125252, '\p{Category=__Lowercase_Letter}', "");
    Expect(1, 125252, '\p{^Category=__Lowercase_Letter}', "");
    Expect(1, 125252, '\P{Category=__Lowercase_Letter}', "");
    Expect(0, 125252, '\P{^Category=__Lowercase_Letter}', "");
    Error('\p{Is_General_Category=	 Ll:=}');
    Error('\P{Is_General_Category=	 Ll:=}');
    Expect(1, 125251, '\p{Is_General_Category=ll}', "");
    Expect(0, 125251, '\p{^Is_General_Category=ll}', "");
    Expect(0, 125251, '\P{Is_General_Category=ll}', "");
    Expect(1, 125251, '\P{^Is_General_Category=ll}', "");
    Expect(0, 125252, '\p{Is_General_Category=ll}', "");
    Expect(1, 125252, '\p{^Is_General_Category=ll}', "");
    Expect(1, 125252, '\P{Is_General_Category=ll}', "");
    Expect(0, 125252, '\P{^Is_General_Category=ll}', "");
    Expect(1, 125251, '\p{Is_General_Category=-_Ll}', "");
    Expect(0, 125251, '\p{^Is_General_Category=-_Ll}', "");
    Expect(0, 125251, '\P{Is_General_Category=-_Ll}', "");
    Expect(1, 125251, '\P{^Is_General_Category=-_Ll}', "");
    Expect(0, 125252, '\p{Is_General_Category=-_Ll}', "");
    Expect(1, 125252, '\p{^Is_General_Category=-_Ll}', "");
    Expect(1, 125252, '\P{Is_General_Category=-_Ll}', "");
    Expect(0, 125252, '\P{^Is_General_Category=-_Ll}', "");
    Error('\p{Is_Gc=/a/	Lowercase_letter}');
    Error('\P{Is_Gc=/a/	Lowercase_letter}');
    Expect(1, 125251, '\p{Is_Gc=lowercaseletter}', "");
    Expect(0, 125251, '\p{^Is_Gc=lowercaseletter}', "");
    Expect(0, 125251, '\P{Is_Gc=lowercaseletter}', "");
    Expect(1, 125251, '\P{^Is_Gc=lowercaseletter}', "");
    Expect(0, 125252, '\p{Is_Gc=lowercaseletter}', "");
    Expect(1, 125252, '\p{^Is_Gc=lowercaseletter}', "");
    Expect(1, 125252, '\P{Is_Gc=lowercaseletter}', "");
    Expect(0, 125252, '\P{^Is_Gc=lowercaseletter}', "");
    Expect(1, 125251, '\p{Is_Gc=  lowercase_letter}', "");
    Expect(0, 125251, '\p{^Is_Gc=  lowercase_letter}', "");
    Expect(0, 125251, '\P{Is_Gc=  lowercase_letter}', "");
    Expect(1, 125251, '\P{^Is_Gc=  lowercase_letter}', "");
    Expect(0, 125252, '\p{Is_Gc=  lowercase_letter}', "");
    Expect(1, 125252, '\p{^Is_Gc=  lowercase_letter}', "");
    Expect(1, 125252, '\P{Is_Gc=  lowercase_letter}', "");
    Expect(0, 125252, '\P{^Is_Gc=  lowercase_letter}', "");
    Error('\p{Is_Category= Ll/a/}');
    Error('\P{Is_Category= Ll/a/}');
    Expect(1, 125251, '\p{Is_Category=ll}', "");
    Expect(0, 125251, '\p{^Is_Category=ll}', "");
    Expect(0, 125251, '\P{Is_Category=ll}', "");
    Expect(1, 125251, '\P{^Is_Category=ll}', "");
    Expect(0, 125252, '\p{Is_Category=ll}', "");
    Expect(1, 125252, '\p{^Is_Category=ll}', "");
    Expect(1, 125252, '\P{Is_Category=ll}', "");
    Expect(0, 125252, '\P{^Is_Category=ll}', "");
    Expect(1, 125251, '\p{Is_Category=	 ll}', "");
    Expect(0, 125251, '\p{^Is_Category=	 ll}', "");
    Expect(0, 125251, '\P{Is_Category=	 ll}', "");
    Expect(1, 125251, '\P{^Is_Category=	 ll}', "");
    Expect(0, 125252, '\p{Is_Category=	 ll}', "");
    Expect(1, 125252, '\p{^Is_Category=	 ll}', "");
    Expect(1, 125252, '\P{Is_Category=	 ll}', "");
    Expect(0, 125252, '\P{^Is_Category=	 ll}', "");
    Error('\p{General_Category=		modifier_LETTER:=}');
    Error('\P{General_Category=		modifier_LETTER:=}');
    Expect(1, 94177, '\p{General_Category=modifierletter}', "");
    Expect(0, 94177, '\p{^General_Category=modifierletter}', "");
    Expect(0, 94177, '\P{General_Category=modifierletter}', "");
    Expect(1, 94177, '\P{^General_Category=modifierletter}', "");
    Expect(0, 94178, '\p{General_Category=modifierletter}', "");
    Expect(1, 94178, '\p{^General_Category=modifierletter}', "");
    Expect(1, 94178, '\P{General_Category=modifierletter}', "");
    Expect(0, 94178, '\P{^General_Category=modifierletter}', "");
    Expect(1, 94177, '\p{General_Category=- Modifier_letter}', "");
    Expect(0, 94177, '\p{^General_Category=- Modifier_letter}', "");
    Expect(0, 94177, '\P{General_Category=- Modifier_letter}', "");
    Expect(1, 94177, '\P{^General_Category=- Modifier_letter}', "");
    Expect(0, 94178, '\p{General_Category=- Modifier_letter}', "");
    Expect(1, 94178, '\p{^General_Category=- Modifier_letter}', "");
    Expect(1, 94178, '\P{General_Category=- Modifier_letter}', "");
    Expect(0, 94178, '\P{^General_Category=- Modifier_letter}', "");
    Error('\p{Gc=/a/lm}');
    Error('\P{Gc=/a/lm}');
    Expect(1, 94177, '\p{Gc=lm}', "");
    Expect(0, 94177, '\p{^Gc=lm}', "");
    Expect(0, 94177, '\P{Gc=lm}', "");
    Expect(1, 94177, '\P{^Gc=lm}', "");
    Expect(0, 94178, '\p{Gc=lm}', "");
    Expect(1, 94178, '\p{^Gc=lm}', "");
    Expect(1, 94178, '\P{Gc=lm}', "");
    Expect(0, 94178, '\P{^Gc=lm}', "");
    Expect(1, 94177, '\p{Gc=_Lm}', "");
    Expect(0, 94177, '\p{^Gc=_Lm}', "");
    Expect(0, 94177, '\P{Gc=_Lm}', "");
    Expect(1, 94177, '\P{^Gc=_Lm}', "");
    Expect(0, 94178, '\p{Gc=_Lm}', "");
    Expect(1, 94178, '\p{^Gc=_Lm}', "");
    Expect(1, 94178, '\P{Gc=_Lm}', "");
    Expect(0, 94178, '\P{^Gc=_Lm}', "");
    Error('\p{Category= /a/Modifier_Letter}');
    Error('\P{Category= /a/Modifier_Letter}');
    Expect(1, 94177, '\p{Category:	modifierletter}', "");
    Expect(0, 94177, '\p{^Category:	modifierletter}', "");
    Expect(0, 94177, '\P{Category:	modifierletter}', "");
    Expect(1, 94177, '\P{^Category:	modifierletter}', "");
    Expect(0, 94178, '\p{Category:	modifierletter}', "");
    Expect(1, 94178, '\p{^Category:	modifierletter}', "");
    Expect(1, 94178, '\P{Category:	modifierletter}', "");
    Expect(0, 94178, '\P{^Category:	modifierletter}', "");
    Expect(1, 94177, '\p{Category=  modifier_letter}', "");
    Expect(0, 94177, '\p{^Category=  modifier_letter}', "");
    Expect(0, 94177, '\P{Category=  modifier_letter}', "");
    Expect(1, 94177, '\P{^Category=  modifier_letter}', "");
    Expect(0, 94178, '\p{Category=  modifier_letter}', "");
    Expect(1, 94178, '\p{^Category=  modifier_letter}', "");
    Expect(1, 94178, '\P{Category=  modifier_letter}', "");
    Expect(0, 94178, '\P{^Category=  modifier_letter}', "");
    Error('\p{Is_General_Category=:=	Lm}');
    Error('\P{Is_General_Category=:=	Lm}');
    Expect(1, 94177, '\p{Is_General_Category: lm}', "");
    Expect(0, 94177, '\p{^Is_General_Category: lm}', "");
    Expect(0, 94177, '\P{Is_General_Category: lm}', "");
    Expect(1, 94177, '\P{^Is_General_Category: lm}', "");
    Expect(0, 94178, '\p{Is_General_Category: lm}', "");
    Expect(1, 94178, '\p{^Is_General_Category: lm}', "");
    Expect(1, 94178, '\P{Is_General_Category: lm}', "");
    Expect(0, 94178, '\P{^Is_General_Category: lm}', "");
    Expect(1, 94177, '\p{Is_General_Category=	Lm}', "");
    Expect(0, 94177, '\p{^Is_General_Category=	Lm}', "");
    Expect(0, 94177, '\P{Is_General_Category=	Lm}', "");
    Expect(1, 94177, '\P{^Is_General_Category=	Lm}', "");
    Expect(0, 94178, '\p{Is_General_Category=	Lm}', "");
    Expect(1, 94178, '\p{^Is_General_Category=	Lm}', "");
    Expect(1, 94178, '\P{Is_General_Category=	Lm}', "");
    Expect(0, 94178, '\P{^Is_General_Category=	Lm}', "");
    Error('\p{Is_Gc=-Modifier_letter/a/}');
    Error('\P{Is_Gc=-Modifier_letter/a/}');
    Expect(1, 94177, '\p{Is_Gc=modifierletter}', "");
    Expect(0, 94177, '\p{^Is_Gc=modifierletter}', "");
    Expect(0, 94177, '\P{Is_Gc=modifierletter}', "");
    Expect(1, 94177, '\P{^Is_Gc=modifierletter}', "");
    Expect(0, 94178, '\p{Is_Gc=modifierletter}', "");
    Expect(1, 94178, '\p{^Is_Gc=modifierletter}', "");
    Expect(1, 94178, '\P{Is_Gc=modifierletter}', "");
    Expect(0, 94178, '\P{^Is_Gc=modifierletter}', "");
    Expect(1, 94177, '\p{Is_Gc= Modifier_Letter}', "");
    Expect(0, 94177, '\p{^Is_Gc= Modifier_Letter}', "");
    Expect(0, 94177, '\P{Is_Gc= Modifier_Letter}', "");
    Expect(1, 94177, '\P{^Is_Gc= Modifier_Letter}', "");
    Expect(0, 94178, '\p{Is_Gc= Modifier_Letter}', "");
    Expect(1, 94178, '\p{^Is_Gc= Modifier_Letter}', "");
    Expect(1, 94178, '\P{Is_Gc= Modifier_Letter}', "");
    Expect(0, 94178, '\P{^Is_Gc= Modifier_Letter}', "");
    Error('\p{Is_Category=/a/-	LM}');
    Error('\P{Is_Category=/a/-	LM}');
    Expect(1, 94177, '\p{Is_Category=lm}', "");
    Expect(0, 94177, '\p{^Is_Category=lm}', "");
    Expect(0, 94177, '\P{Is_Category=lm}', "");
    Expect(1, 94177, '\P{^Is_Category=lm}', "");
    Expect(0, 94178, '\p{Is_Category=lm}', "");
    Expect(1, 94178, '\p{^Is_Category=lm}', "");
    Expect(1, 94178, '\P{Is_Category=lm}', "");
    Expect(0, 94178, '\P{^Is_Category=lm}', "");
    Expect(1, 94177, '\p{Is_Category= _Lm}', "");
    Expect(0, 94177, '\p{^Is_Category= _Lm}', "");
    Expect(0, 94177, '\P{Is_Category= _Lm}', "");
    Expect(1, 94177, '\P{^Is_Category= _Lm}', "");
    Expect(0, 94178, '\p{Is_Category= _Lm}', "");
    Expect(1, 94178, '\p{^Is_Category= _Lm}', "");
    Expect(1, 94178, '\P{Is_Category= _Lm}', "");
    Expect(0, 94178, '\P{^Is_Category= _Lm}', "");
    Error('\p{General_Category= /a/Other_letter}');
    Error('\P{General_Category= /a/Other_letter}');
    Expect(1, 195101, '\p{General_Category=otherletter}', "");
    Expect(0, 195101, '\p{^General_Category=otherletter}', "");
    Expect(0, 195101, '\P{General_Category=otherletter}', "");
    Expect(1, 195101, '\P{^General_Category=otherletter}', "");
    Expect(0, 195102, '\p{General_Category=otherletter}', "");
    Expect(1, 195102, '\p{^General_Category=otherletter}', "");
    Expect(1, 195102, '\P{General_Category=otherletter}', "");
    Expect(0, 195102, '\P{^General_Category=otherletter}', "");
    Expect(1, 195101, '\p{General_Category=	Other_LETTER}', "");
    Expect(0, 195101, '\p{^General_Category=	Other_LETTER}', "");
    Expect(0, 195101, '\P{General_Category=	Other_LETTER}', "");
    Expect(1, 195101, '\P{^General_Category=	Other_LETTER}', "");
    Expect(0, 195102, '\p{General_Category=	Other_LETTER}', "");
    Expect(1, 195102, '\p{^General_Category=	Other_LETTER}', "");
    Expect(1, 195102, '\P{General_Category=	Other_LETTER}', "");
    Expect(0, 195102, '\P{^General_Category=	Other_LETTER}', "");
    Error('\p{Gc=/a/	LO}');
    Error('\P{Gc=/a/	LO}');
    Expect(1, 195101, '\p{Gc=lo}', "");
    Expect(0, 195101, '\p{^Gc=lo}', "");
    Expect(0, 195101, '\P{Gc=lo}', "");
    Expect(1, 195101, '\P{^Gc=lo}', "");
    Expect(0, 195102, '\p{Gc=lo}', "");
    Expect(1, 195102, '\p{^Gc=lo}', "");
    Expect(1, 195102, '\P{Gc=lo}', "");
    Expect(0, 195102, '\P{^Gc=lo}', "");
    Expect(1, 195101, '\p{Gc= 	LO}', "");
    Expect(0, 195101, '\p{^Gc= 	LO}', "");
    Expect(0, 195101, '\P{Gc= 	LO}', "");
    Expect(1, 195101, '\P{^Gc= 	LO}', "");
    Expect(0, 195102, '\p{Gc= 	LO}', "");
    Expect(1, 195102, '\p{^Gc= 	LO}', "");
    Expect(1, 195102, '\P{Gc= 	LO}', "");
    Expect(0, 195102, '\P{^Gc= 	LO}', "");
    Error('\p{Category=_:=Other_Letter}');
    Error('\P{Category=_:=Other_Letter}');
    Expect(1, 195101, '\p{Category=otherletter}', "");
    Expect(0, 195101, '\p{^Category=otherletter}', "");
    Expect(0, 195101, '\P{Category=otherletter}', "");
    Expect(1, 195101, '\P{^Category=otherletter}', "");
    Expect(0, 195102, '\p{Category=otherletter}', "");
    Expect(1, 195102, '\p{^Category=otherletter}', "");
    Expect(1, 195102, '\P{Category=otherletter}', "");
    Expect(0, 195102, '\P{^Category=otherletter}', "");
    Expect(1, 195101, '\p{Category=__other_letter}', "");
    Expect(0, 195101, '\p{^Category=__other_letter}', "");
    Expect(0, 195101, '\P{Category=__other_letter}', "");
    Expect(1, 195101, '\P{^Category=__other_letter}', "");
    Expect(0, 195102, '\p{Category=__other_letter}', "");
    Expect(1, 195102, '\p{^Category=__other_letter}', "");
    Expect(1, 195102, '\P{Category=__other_letter}', "");
    Expect(0, 195102, '\P{^Category=__other_letter}', "");
    Error('\p{Is_General_Category=	Lo/a/}');
    Error('\P{Is_General_Category=	Lo/a/}');
    Expect(1, 195101, '\p{Is_General_Category=lo}', "");
    Expect(0, 195101, '\p{^Is_General_Category=lo}', "");
    Expect(0, 195101, '\P{Is_General_Category=lo}', "");
    Expect(1, 195101, '\P{^Is_General_Category=lo}', "");
    Expect(0, 195102, '\p{Is_General_Category=lo}', "");
    Expect(1, 195102, '\p{^Is_General_Category=lo}', "");
    Expect(1, 195102, '\P{Is_General_Category=lo}', "");
    Expect(0, 195102, '\P{^Is_General_Category=lo}', "");
    Expect(1, 195101, '\p{Is_General_Category=	LO}', "");
    Expect(0, 195101, '\p{^Is_General_Category=	LO}', "");
    Expect(0, 195101, '\P{Is_General_Category=	LO}', "");
    Expect(1, 195101, '\P{^Is_General_Category=	LO}', "");
    Expect(0, 195102, '\p{Is_General_Category=	LO}', "");
    Expect(1, 195102, '\p{^Is_General_Category=	LO}', "");
    Expect(1, 195102, '\P{Is_General_Category=	LO}', "");
    Expect(0, 195102, '\P{^Is_General_Category=	LO}', "");
    Error('\p{Is_Gc=:=	-Other_LETTER}');
    Error('\P{Is_Gc=:=	-Other_LETTER}');
    Expect(1, 195101, '\p{Is_Gc=otherletter}', "");
    Expect(0, 195101, '\p{^Is_Gc=otherletter}', "");
    Expect(0, 195101, '\P{Is_Gc=otherletter}', "");
    Expect(1, 195101, '\P{^Is_Gc=otherletter}', "");
    Expect(0, 195102, '\p{Is_Gc=otherletter}', "");
    Expect(1, 195102, '\p{^Is_Gc=otherletter}', "");
    Expect(1, 195102, '\P{Is_Gc=otherletter}', "");
    Expect(0, 195102, '\P{^Is_Gc=otherletter}', "");
    Expect(1, 195101, '\p{Is_Gc=- other_Letter}', "");
    Expect(0, 195101, '\p{^Is_Gc=- other_Letter}', "");
    Expect(0, 195101, '\P{Is_Gc=- other_Letter}', "");
    Expect(1, 195101, '\P{^Is_Gc=- other_Letter}', "");
    Expect(0, 195102, '\p{Is_Gc=- other_Letter}', "");
    Expect(1, 195102, '\p{^Is_Gc=- other_Letter}', "");
    Expect(1, 195102, '\P{Is_Gc=- other_Letter}', "");
    Expect(0, 195102, '\P{^Is_Gc=- other_Letter}', "");
    Error('\p{Is_Category=/a/  LO}');
    Error('\P{Is_Category=/a/  LO}');
    Expect(1, 195101, '\p{Is_Category=lo}', "");
    Expect(0, 195101, '\p{^Is_Category=lo}', "");
    Expect(0, 195101, '\P{Is_Category=lo}', "");
    Expect(1, 195101, '\P{^Is_Category=lo}', "");
    Expect(0, 195102, '\p{Is_Category=lo}', "");
    Expect(1, 195102, '\p{^Is_Category=lo}', "");
    Expect(1, 195102, '\P{Is_Category=lo}', "");
    Expect(0, 195102, '\P{^Is_Category=lo}', "");
    Expect(1, 195101, '\p{Is_Category=- Lo}', "");
    Expect(0, 195101, '\p{^Is_Category=- Lo}', "");
    Expect(0, 195101, '\P{Is_Category=- Lo}', "");
    Expect(1, 195101, '\P{^Is_Category=- Lo}', "");
    Expect(0, 195102, '\p{Is_Category=- Lo}', "");
    Expect(1, 195102, '\p{^Is_Category=- Lo}', "");
    Expect(1, 195102, '\P{Is_Category=- Lo}', "");
    Expect(0, 195102, '\P{^Is_Category=- Lo}', "");
    Error('\p{General_Category=/a/ Titlecase_Letter}');
    Error('\P{General_Category=/a/ Titlecase_Letter}');
    Expect(1, 8188, '\p{General_Category=titlecaseletter}', "");
    Expect(0, 8188, '\p{^General_Category=titlecaseletter}', "");
    Expect(0, 8188, '\P{General_Category=titlecaseletter}', "");
    Expect(1, 8188, '\P{^General_Category=titlecaseletter}', "");
    Expect(0, 8189, '\p{General_Category=titlecaseletter}', "");
    Expect(1, 8189, '\p{^General_Category=titlecaseletter}', "");
    Expect(1, 8189, '\P{General_Category=titlecaseletter}', "");
    Expect(0, 8189, '\P{^General_Category=titlecaseletter}', "");
    Expect(1, 8188, '\p{General_Category: 	 Titlecase_Letter}', "");
    Expect(0, 8188, '\p{^General_Category: 	 Titlecase_Letter}', "");
    Expect(0, 8188, '\P{General_Category: 	 Titlecase_Letter}', "");
    Expect(1, 8188, '\P{^General_Category: 	 Titlecase_Letter}', "");
    Expect(0, 8189, '\p{General_Category: 	 Titlecase_Letter}', "");
    Expect(1, 8189, '\p{^General_Category: 	 Titlecase_Letter}', "");
    Expect(1, 8189, '\P{General_Category: 	 Titlecase_Letter}', "");
    Expect(0, 8189, '\P{^General_Category: 	 Titlecase_Letter}', "");
    Error('\p{Gc=:=- Lt}');
    Error('\P{Gc=:=- Lt}');
    Expect(1, 8188, '\p{Gc=lt}', "");
    Expect(0, 8188, '\p{^Gc=lt}', "");
    Expect(0, 8188, '\P{Gc=lt}', "");
    Expect(1, 8188, '\P{^Gc=lt}', "");
    Expect(0, 8189, '\p{Gc=lt}', "");
    Expect(1, 8189, '\p{^Gc=lt}', "");
    Expect(1, 8189, '\P{Gc=lt}', "");
    Expect(0, 8189, '\P{^Gc=lt}', "");
    Expect(1, 8188, '\p{Gc=	 Lt}', "");
    Expect(0, 8188, '\p{^Gc=	 Lt}', "");
    Expect(0, 8188, '\P{Gc=	 Lt}', "");
    Expect(1, 8188, '\P{^Gc=	 Lt}', "");
    Expect(0, 8189, '\p{Gc=	 Lt}', "");
    Expect(1, 8189, '\p{^Gc=	 Lt}', "");
    Expect(1, 8189, '\P{Gc=	 Lt}', "");
    Expect(0, 8189, '\P{^Gc=	 Lt}', "");
    Error('\p{Category=_Titlecase_Letter:=}');
    Error('\P{Category=_Titlecase_Letter:=}');
    Expect(1, 8188, '\p{Category=titlecaseletter}', "");
    Expect(0, 8188, '\p{^Category=titlecaseletter}', "");
    Expect(0, 8188, '\P{Category=titlecaseletter}', "");
    Expect(1, 8188, '\P{^Category=titlecaseletter}', "");
    Expect(0, 8189, '\p{Category=titlecaseletter}', "");
    Expect(1, 8189, '\p{^Category=titlecaseletter}', "");
    Expect(1, 8189, '\P{Category=titlecaseletter}', "");
    Expect(0, 8189, '\P{^Category=titlecaseletter}', "");
    Expect(1, 8188, '\p{Category:__Titlecase_Letter}', "");
    Expect(0, 8188, '\p{^Category:__Titlecase_Letter}', "");
    Expect(0, 8188, '\P{Category:__Titlecase_Letter}', "");
    Expect(1, 8188, '\P{^Category:__Titlecase_Letter}', "");
    Expect(0, 8189, '\p{Category:__Titlecase_Letter}', "");
    Expect(1, 8189, '\p{^Category:__Titlecase_Letter}', "");
    Expect(1, 8189, '\P{Category:__Titlecase_Letter}', "");
    Expect(0, 8189, '\P{^Category:__Titlecase_Letter}', "");
    Error('\p{Is_General_Category= 	lt:=}');
    Error('\P{Is_General_Category= 	lt:=}');
    Expect(1, 8188, '\p{Is_General_Category=lt}', "");
    Expect(0, 8188, '\p{^Is_General_Category=lt}', "");
    Expect(0, 8188, '\P{Is_General_Category=lt}', "");
    Expect(1, 8188, '\P{^Is_General_Category=lt}', "");
    Expect(0, 8189, '\p{Is_General_Category=lt}', "");
    Expect(1, 8189, '\p{^Is_General_Category=lt}', "");
    Expect(1, 8189, '\P{Is_General_Category=lt}', "");
    Expect(0, 8189, '\P{^Is_General_Category=lt}', "");
    Expect(1, 8188, '\p{Is_General_Category=  Lt}', "");
    Expect(0, 8188, '\p{^Is_General_Category=  Lt}', "");
    Expect(0, 8188, '\P{Is_General_Category=  Lt}', "");
    Expect(1, 8188, '\P{^Is_General_Category=  Lt}', "");
    Expect(0, 8189, '\p{Is_General_Category=  Lt}', "");
    Expect(1, 8189, '\p{^Is_General_Category=  Lt}', "");
    Expect(1, 8189, '\P{Is_General_Category=  Lt}', "");
    Expect(0, 8189, '\P{^Is_General_Category=  Lt}', "");
    Error('\p{Is_Gc=-:=Titlecase_Letter}');
    Error('\P{Is_Gc=-:=Titlecase_Letter}');
    Expect(1, 8188, '\p{Is_Gc=titlecaseletter}', "");
    Expect(0, 8188, '\p{^Is_Gc=titlecaseletter}', "");
    Expect(0, 8188, '\P{Is_Gc=titlecaseletter}', "");
    Expect(1, 8188, '\P{^Is_Gc=titlecaseletter}', "");
    Expect(0, 8189, '\p{Is_Gc=titlecaseletter}', "");
    Expect(1, 8189, '\p{^Is_Gc=titlecaseletter}', "");
    Expect(1, 8189, '\P{Is_Gc=titlecaseletter}', "");
    Expect(0, 8189, '\P{^Is_Gc=titlecaseletter}', "");
    Expect(1, 8188, '\p{Is_Gc=  Titlecase_Letter}', "");
    Expect(0, 8188, '\p{^Is_Gc=  Titlecase_Letter}', "");
    Expect(0, 8188, '\P{Is_Gc=  Titlecase_Letter}', "");
    Expect(1, 8188, '\P{^Is_Gc=  Titlecase_Letter}', "");
    Expect(0, 8189, '\p{Is_Gc=  Titlecase_Letter}', "");
    Expect(1, 8189, '\p{^Is_Gc=  Titlecase_Letter}', "");
    Expect(1, 8189, '\P{Is_Gc=  Titlecase_Letter}', "");
    Expect(0, 8189, '\P{^Is_Gc=  Titlecase_Letter}', "");
    Error('\p{Is_Category=:=Lt}');
    Error('\P{Is_Category=:=Lt}');
    Expect(1, 8188, '\p{Is_Category=lt}', "");
    Expect(0, 8188, '\p{^Is_Category=lt}', "");
    Expect(0, 8188, '\P{Is_Category=lt}', "");
    Expect(1, 8188, '\P{^Is_Category=lt}', "");
    Expect(0, 8189, '\p{Is_Category=lt}', "");
    Expect(1, 8189, '\p{^Is_Category=lt}', "");
    Expect(1, 8189, '\P{Is_Category=lt}', "");
    Expect(0, 8189, '\P{^Is_Category=lt}', "");
    Expect(1, 8188, '\p{Is_Category= _lt}', "");
    Expect(0, 8188, '\p{^Is_Category= _lt}', "");
    Expect(0, 8188, '\P{Is_Category= _lt}', "");
    Expect(1, 8188, '\P{^Is_Category= _lt}', "");
    Expect(0, 8189, '\p{Is_Category= _lt}', "");
    Expect(1, 8189, '\p{^Is_Category= _lt}', "");
    Expect(1, 8189, '\P{Is_Category= _lt}', "");
    Expect(0, 8189, '\P{^Is_Category= _lt}', "");
    Error('\p{General_Category=_ UPPERCASE_Letter/a/}');
    Error('\P{General_Category=_ UPPERCASE_Letter/a/}');
    Expect(1, 125217, '\p{General_Category=uppercaseletter}', "");
    Expect(0, 125217, '\p{^General_Category=uppercaseletter}', "");
    Expect(0, 125217, '\P{General_Category=uppercaseletter}', "");
    Expect(1, 125217, '\P{^General_Category=uppercaseletter}', "");
    Expect(0, 125218, '\p{General_Category=uppercaseletter}', "");
    Expect(1, 125218, '\p{^General_Category=uppercaseletter}', "");
    Expect(1, 125218, '\P{General_Category=uppercaseletter}', "");
    Expect(0, 125218, '\P{^General_Category=uppercaseletter}', "");
    Expect(1, 125217, '\p{General_Category=_	UPPERCASE_Letter}', "");
    Expect(0, 125217, '\p{^General_Category=_	UPPERCASE_Letter}', "");
    Expect(0, 125217, '\P{General_Category=_	UPPERCASE_Letter}', "");
    Expect(1, 125217, '\P{^General_Category=_	UPPERCASE_Letter}', "");
    Expect(0, 125218, '\p{General_Category=_	UPPERCASE_Letter}', "");
    Expect(1, 125218, '\p{^General_Category=_	UPPERCASE_Letter}', "");
    Expect(1, 125218, '\P{General_Category=_	UPPERCASE_Letter}', "");
    Expect(0, 125218, '\P{^General_Category=_	UPPERCASE_Letter}', "");
    Error('\p{Gc=		LU/a/}');
    Error('\P{Gc=		LU/a/}');
    Expect(1, 125217, '\p{Gc=lu}', "");
    Expect(0, 125217, '\p{^Gc=lu}', "");
    Expect(0, 125217, '\P{Gc=lu}', "");
    Expect(1, 125217, '\P{^Gc=lu}', "");
    Expect(0, 125218, '\p{Gc=lu}', "");
    Expect(1, 125218, '\p{^Gc=lu}', "");
    Expect(1, 125218, '\P{Gc=lu}', "");
    Expect(0, 125218, '\P{^Gc=lu}', "");
    Expect(1, 125217, '\p{Gc= LU}', "");
    Expect(0, 125217, '\p{^Gc= LU}', "");
    Expect(0, 125217, '\P{Gc= LU}', "");
    Expect(1, 125217, '\P{^Gc= LU}', "");
    Expect(0, 125218, '\p{Gc= LU}', "");
    Expect(1, 125218, '\p{^Gc= LU}', "");
    Expect(1, 125218, '\P{Gc= LU}', "");
    Expect(0, 125218, '\P{^Gc= LU}', "");
    Error('\p{Category=	:=UPPERCASE_LETTER}');
    Error('\P{Category=	:=UPPERCASE_LETTER}');
    Expect(1, 125217, '\p{Category=uppercaseletter}', "");
    Expect(0, 125217, '\p{^Category=uppercaseletter}', "");
    Expect(0, 125217, '\P{Category=uppercaseletter}', "");
    Expect(1, 125217, '\P{^Category=uppercaseletter}', "");
    Expect(0, 125218, '\p{Category=uppercaseletter}', "");
    Expect(1, 125218, '\p{^Category=uppercaseletter}', "");
    Expect(1, 125218, '\P{Category=uppercaseletter}', "");
    Expect(0, 125218, '\P{^Category=uppercaseletter}', "");
    Expect(1, 125217, '\p{Category=_uppercase_Letter}', "");
    Expect(0, 125217, '\p{^Category=_uppercase_Letter}', "");
    Expect(0, 125217, '\P{Category=_uppercase_Letter}', "");
    Expect(1, 125217, '\P{^Category=_uppercase_Letter}', "");
    Expect(0, 125218, '\p{Category=_uppercase_Letter}', "");
    Expect(1, 125218, '\p{^Category=_uppercase_Letter}', "");
    Expect(1, 125218, '\P{Category=_uppercase_Letter}', "");
    Expect(0, 125218, '\P{^Category=_uppercase_Letter}', "");
    Error('\p{Is_General_Category=/a/	 LU}');
    Error('\P{Is_General_Category=/a/	 LU}');
    Expect(1, 125217, '\p{Is_General_Category=lu}', "");
    Expect(0, 125217, '\p{^Is_General_Category=lu}', "");
    Expect(0, 125217, '\P{Is_General_Category=lu}', "");
    Expect(1, 125217, '\P{^Is_General_Category=lu}', "");
    Expect(0, 125218, '\p{Is_General_Category=lu}', "");
    Expect(1, 125218, '\p{^Is_General_Category=lu}', "");
    Expect(1, 125218, '\P{Is_General_Category=lu}', "");
    Expect(0, 125218, '\P{^Is_General_Category=lu}', "");
    Expect(1, 125217, '\p{Is_General_Category=- lu}', "");
    Expect(0, 125217, '\p{^Is_General_Category=- lu}', "");
    Expect(0, 125217, '\P{Is_General_Category=- lu}', "");
    Expect(1, 125217, '\P{^Is_General_Category=- lu}', "");
    Expect(0, 125218, '\p{Is_General_Category=- lu}', "");
    Expect(1, 125218, '\p{^Is_General_Category=- lu}', "");
    Expect(1, 125218, '\P{Is_General_Category=- lu}', "");
    Expect(0, 125218, '\P{^Is_General_Category=- lu}', "");
    Error('\p{Is_Gc=	_uppercase_Letter/a/}');
    Error('\P{Is_Gc=	_uppercase_Letter/a/}');
    Expect(1, 125217, '\p{Is_Gc=uppercaseletter}', "");
    Expect(0, 125217, '\p{^Is_Gc=uppercaseletter}', "");
    Expect(0, 125217, '\P{Is_Gc=uppercaseletter}', "");
    Expect(1, 125217, '\P{^Is_Gc=uppercaseletter}', "");
    Expect(0, 125218, '\p{Is_Gc=uppercaseletter}', "");
    Expect(1, 125218, '\p{^Is_Gc=uppercaseletter}', "");
    Expect(1, 125218, '\P{Is_Gc=uppercaseletter}', "");
    Expect(0, 125218, '\P{^Is_Gc=uppercaseletter}', "");
    Expect(1, 125217, '\p{Is_Gc=-Uppercase_Letter}', "");
    Expect(0, 125217, '\p{^Is_Gc=-Uppercase_Letter}', "");
    Expect(0, 125217, '\P{Is_Gc=-Uppercase_Letter}', "");
    Expect(1, 125217, '\P{^Is_Gc=-Uppercase_Letter}', "");
    Expect(0, 125218, '\p{Is_Gc=-Uppercase_Letter}', "");
    Expect(1, 125218, '\p{^Is_Gc=-Uppercase_Letter}', "");
    Expect(1, 125218, '\P{Is_Gc=-Uppercase_Letter}', "");
    Expect(0, 125218, '\P{^Is_Gc=-Uppercase_Letter}', "");
    Error('\p{Is_Category=- Lu:=}');
    Error('\P{Is_Category=- Lu:=}');
    Expect(1, 125217, '\p{Is_Category:   lu}', "");
    Expect(0, 125217, '\p{^Is_Category:   lu}', "");
    Expect(0, 125217, '\P{Is_Category:   lu}', "");
    Expect(1, 125217, '\P{^Is_Category:   lu}', "");
    Expect(0, 125218, '\p{Is_Category:   lu}', "");
    Expect(1, 125218, '\p{^Is_Category:   lu}', "");
    Expect(1, 125218, '\P{Is_Category:   lu}', "");
    Expect(0, 125218, '\P{^Is_Category:   lu}', "");
    Expect(1, 125217, '\p{Is_Category=	 Lu}', "");
    Expect(0, 125217, '\p{^Is_Category=	 Lu}', "");
    Expect(0, 125217, '\P{Is_Category=	 Lu}', "");
    Expect(1, 125217, '\P{^Is_Category=	 Lu}', "");
    Expect(0, 125218, '\p{Is_Category=	 Lu}', "");
    Expect(1, 125218, '\p{^Is_Category=	 Lu}', "");
    Expect(1, 125218, '\P{Is_Category=	 Lu}', "");
    Expect(0, 125218, '\P{^Is_Category=	 Lu}', "");
    Error('\p{General_Category=/a/-_Mark}');
    Error('\P{General_Category=/a/-_Mark}');
    Expect(1, 917999, '\p{General_Category=mark}', "");
    Expect(0, 917999, '\p{^General_Category=mark}', "");
    Expect(0, 917999, '\P{General_Category=mark}', "");
    Expect(1, 917999, '\P{^General_Category=mark}', "");
    Expect(0, 918000, '\p{General_Category=mark}', "");
    Expect(1, 918000, '\p{^General_Category=mark}', "");
    Expect(1, 918000, '\P{General_Category=mark}', "");
    Expect(0, 918000, '\P{^General_Category=mark}', "");
    Expect(1, 917999, '\p{General_Category=-Mark}', "");
    Expect(0, 917999, '\p{^General_Category=-Mark}', "");
    Expect(0, 917999, '\P{General_Category=-Mark}', "");
    Expect(1, 917999, '\P{^General_Category=-Mark}', "");
    Expect(0, 918000, '\p{General_Category=-Mark}', "");
    Expect(1, 918000, '\p{^General_Category=-Mark}', "");
    Expect(1, 918000, '\P{General_Category=-Mark}', "");
    Expect(0, 918000, '\P{^General_Category=-Mark}', "");
    Error('\p{Gc:    /a/m}');
    Error('\P{Gc:    /a/m}');
    Expect(1, 917999, '\p{Gc=m}', "");
    Expect(0, 917999, '\p{^Gc=m}', "");
    Expect(0, 917999, '\P{Gc=m}', "");
    Expect(1, 917999, '\P{^Gc=m}', "");
    Expect(0, 918000, '\p{Gc=m}', "");
    Expect(1, 918000, '\p{^Gc=m}', "");
    Expect(1, 918000, '\P{Gc=m}', "");
    Expect(0, 918000, '\P{^Gc=m}', "");
    Expect(1, 917999, '\p{Gc=-M}', "");
    Expect(0, 917999, '\p{^Gc=-M}', "");
    Expect(0, 917999, '\P{Gc=-M}', "");
    Expect(1, 917999, '\P{^Gc=-M}', "");
    Expect(0, 918000, '\p{Gc=-M}', "");
    Expect(1, 918000, '\p{^Gc=-M}', "");
    Expect(1, 918000, '\P{Gc=-M}', "");
    Expect(0, 918000, '\P{^Gc=-M}', "");
    Error('\p{Category=	 Combining_Mark:=}');
    Error('\P{Category=	 Combining_Mark:=}');
    Expect(1, 917999, '\p{Category=combiningmark}', "");
    Expect(0, 917999, '\p{^Category=combiningmark}', "");
    Expect(0, 917999, '\P{Category=combiningmark}', "");
    Expect(1, 917999, '\P{^Category=combiningmark}', "");
    Expect(0, 918000, '\p{Category=combiningmark}', "");
    Expect(1, 918000, '\p{^Category=combiningmark}', "");
    Expect(1, 918000, '\P{Category=combiningmark}', "");
    Expect(0, 918000, '\P{^Category=combiningmark}', "");
    Expect(1, 917999, '\p{Category=	-COMBINING_Mark}', "");
    Expect(0, 917999, '\p{^Category=	-COMBINING_Mark}', "");
    Expect(0, 917999, '\P{Category=	-COMBINING_Mark}', "");
    Expect(1, 917999, '\P{^Category=	-COMBINING_Mark}', "");
    Expect(0, 918000, '\p{Category=	-COMBINING_Mark}', "");
    Expect(1, 918000, '\p{^Category=	-COMBINING_Mark}', "");
    Expect(1, 918000, '\P{Category=	-COMBINING_Mark}', "");
    Expect(0, 918000, '\P{^Category=	-COMBINING_Mark}', "");
    Error('\p{Is_General_Category=_	Mark:=}');
    Error('\P{Is_General_Category=_	Mark:=}');
    Expect(1, 917999, '\p{Is_General_Category=mark}', "");
    Expect(0, 917999, '\p{^Is_General_Category=mark}', "");
    Expect(0, 917999, '\P{Is_General_Category=mark}', "");
    Expect(1, 917999, '\P{^Is_General_Category=mark}', "");
    Expect(0, 918000, '\p{Is_General_Category=mark}', "");
    Expect(1, 918000, '\p{^Is_General_Category=mark}', "");
    Expect(1, 918000, '\P{Is_General_Category=mark}', "");
    Expect(0, 918000, '\P{^Is_General_Category=mark}', "");
    Expect(1, 917999, '\p{Is_General_Category=-	Mark}', "");
    Expect(0, 917999, '\p{^Is_General_Category=-	Mark}', "");
    Expect(0, 917999, '\P{Is_General_Category=-	Mark}', "");
    Expect(1, 917999, '\P{^Is_General_Category=-	Mark}', "");
    Expect(0, 918000, '\p{Is_General_Category=-	Mark}', "");
    Expect(1, 918000, '\p{^Is_General_Category=-	Mark}', "");
    Expect(1, 918000, '\P{Is_General_Category=-	Mark}', "");
    Expect(0, 918000, '\P{^Is_General_Category=-	Mark}', "");
    Error('\p{Is_Gc: :=_-M}');
    Error('\P{Is_Gc: :=_-M}');
    Expect(1, 917999, '\p{Is_Gc=m}', "");
    Expect(0, 917999, '\p{^Is_Gc=m}', "");
    Expect(0, 917999, '\P{Is_Gc=m}', "");
    Expect(1, 917999, '\P{^Is_Gc=m}', "");
    Expect(0, 918000, '\p{Is_Gc=m}', "");
    Expect(1, 918000, '\p{^Is_Gc=m}', "");
    Expect(1, 918000, '\P{Is_Gc=m}', "");
    Expect(0, 918000, '\P{^Is_Gc=m}', "");
    Expect(1, 917999, '\p{Is_Gc= M}', "");
    Expect(0, 917999, '\p{^Is_Gc= M}', "");
    Expect(0, 917999, '\P{Is_Gc= M}', "");
    Expect(1, 917999, '\P{^Is_Gc= M}', "");
    Expect(0, 918000, '\p{Is_Gc= M}', "");
    Expect(1, 918000, '\p{^Is_Gc= M}', "");
    Expect(1, 918000, '\P{Is_Gc= M}', "");
    Expect(0, 918000, '\P{^Is_Gc= M}', "");
    Error('\p{Is_Category=:=	-Combining_Mark}');
    Error('\P{Is_Category=:=	-Combining_Mark}');
    Expect(1, 917999, '\p{Is_Category=combiningmark}', "");
    Expect(0, 917999, '\p{^Is_Category=combiningmark}', "");
    Expect(0, 917999, '\P{Is_Category=combiningmark}', "");
    Expect(1, 917999, '\P{^Is_Category=combiningmark}', "");
    Expect(0, 918000, '\p{Is_Category=combiningmark}', "");
    Expect(1, 918000, '\p{^Is_Category=combiningmark}', "");
    Expect(1, 918000, '\P{Is_Category=combiningmark}', "");
    Expect(0, 918000, '\P{^Is_Category=combiningmark}', "");
    Expect(1, 917999, '\p{Is_Category=_ combining_Mark}', "");
    Expect(0, 917999, '\p{^Is_Category=_ combining_Mark}', "");
    Expect(0, 917999, '\P{Is_Category=_ combining_Mark}', "");
    Expect(1, 917999, '\P{^Is_Category=_ combining_Mark}', "");
    Expect(0, 918000, '\p{Is_Category=_ combining_Mark}', "");
    Expect(1, 918000, '\p{^Is_Category=_ combining_Mark}', "");
    Expect(1, 918000, '\P{Is_Category=_ combining_Mark}', "");
    Expect(0, 918000, '\P{^Is_Category=_ combining_Mark}', "");
    Error('\p{General_Category=:=		Spacing_Mark}');
    Error('\P{General_Category=:=		Spacing_Mark}');
    Expect(1, 119154, '\p{General_Category=spacingmark}', "");
    Expect(0, 119154, '\p{^General_Category=spacingmark}', "");
    Expect(0, 119154, '\P{General_Category=spacingmark}', "");
    Expect(1, 119154, '\P{^General_Category=spacingmark}', "");
    Expect(0, 119155, '\p{General_Category=spacingmark}', "");
    Expect(1, 119155, '\p{^General_Category=spacingmark}', "");
    Expect(1, 119155, '\P{General_Category=spacingmark}', "");
    Expect(0, 119155, '\P{^General_Category=spacingmark}', "");
    Expect(1, 119154, '\p{General_Category=- Spacing_Mark}', "");
    Expect(0, 119154, '\p{^General_Category=- Spacing_Mark}', "");
    Expect(0, 119154, '\P{General_Category=- Spacing_Mark}', "");
    Expect(1, 119154, '\P{^General_Category=- Spacing_Mark}', "");
    Expect(0, 119155, '\p{General_Category=- Spacing_Mark}', "");
    Expect(1, 119155, '\p{^General_Category=- Spacing_Mark}', "");
    Expect(1, 119155, '\P{General_Category=- Spacing_Mark}', "");
    Expect(0, 119155, '\P{^General_Category=- Spacing_Mark}', "");
    Error('\p{Gc=:=	mc}');
    Error('\P{Gc=:=	mc}');
    Expect(1, 119154, '\p{Gc=mc}', "");
    Expect(0, 119154, '\p{^Gc=mc}', "");
    Expect(0, 119154, '\P{Gc=mc}', "");
    Expect(1, 119154, '\P{^Gc=mc}', "");
    Expect(0, 119155, '\p{Gc=mc}', "");
    Expect(1, 119155, '\p{^Gc=mc}', "");
    Expect(1, 119155, '\P{Gc=mc}', "");
    Expect(0, 119155, '\P{^Gc=mc}', "");
    Expect(1, 119154, '\p{Gc= -Mc}', "");
    Expect(0, 119154, '\p{^Gc= -Mc}', "");
    Expect(0, 119154, '\P{Gc= -Mc}', "");
    Expect(1, 119154, '\P{^Gc= -Mc}', "");
    Expect(0, 119155, '\p{Gc= -Mc}', "");
    Expect(1, 119155, '\p{^Gc= -Mc}', "");
    Expect(1, 119155, '\P{Gc= -Mc}', "");
    Expect(0, 119155, '\P{^Gc= -Mc}', "");
    Error('\p{Category=:=_	spacing_Mark}');
    Error('\P{Category=:=_	spacing_Mark}');
    Expect(1, 119154, '\p{Category=spacingmark}', "");
    Expect(0, 119154, '\p{^Category=spacingmark}', "");
    Expect(0, 119154, '\P{Category=spacingmark}', "");
    Expect(1, 119154, '\P{^Category=spacingmark}', "");
    Expect(0, 119155, '\p{Category=spacingmark}', "");
    Expect(1, 119155, '\p{^Category=spacingmark}', "");
    Expect(1, 119155, '\P{Category=spacingmark}', "");
    Expect(0, 119155, '\P{^Category=spacingmark}', "");
    Expect(1, 119154, '\p{Category=-Spacing_Mark}', "");
    Expect(0, 119154, '\p{^Category=-Spacing_Mark}', "");
    Expect(0, 119154, '\P{Category=-Spacing_Mark}', "");
    Expect(1, 119154, '\P{^Category=-Spacing_Mark}', "");
    Expect(0, 119155, '\p{Category=-Spacing_Mark}', "");
    Expect(1, 119155, '\p{^Category=-Spacing_Mark}', "");
    Expect(1, 119155, '\P{Category=-Spacing_Mark}', "");
    Expect(0, 119155, '\P{^Category=-Spacing_Mark}', "");
    Error('\p{Is_General_Category=_Mc/a/}');
    Error('\P{Is_General_Category=_Mc/a/}');
    Expect(1, 119154, '\p{Is_General_Category=mc}', "");
    Expect(0, 119154, '\p{^Is_General_Category=mc}', "");
    Expect(0, 119154, '\P{Is_General_Category=mc}', "");
    Expect(1, 119154, '\P{^Is_General_Category=mc}', "");
    Expect(0, 119155, '\p{Is_General_Category=mc}', "");
    Expect(1, 119155, '\p{^Is_General_Category=mc}', "");
    Expect(1, 119155, '\P{Is_General_Category=mc}', "");
    Expect(0, 119155, '\P{^Is_General_Category=mc}', "");
    Expect(1, 119154, '\p{Is_General_Category=_ Mc}', "");
    Expect(0, 119154, '\p{^Is_General_Category=_ Mc}', "");
    Expect(0, 119154, '\P{Is_General_Category=_ Mc}', "");
    Expect(1, 119154, '\P{^Is_General_Category=_ Mc}', "");
    Expect(0, 119155, '\p{Is_General_Category=_ Mc}', "");
    Expect(1, 119155, '\p{^Is_General_Category=_ Mc}', "");
    Expect(1, 119155, '\P{Is_General_Category=_ Mc}', "");
    Expect(0, 119155, '\P{^Is_General_Category=_ Mc}', "");
    Error('\p{Is_Gc=/a/spacing_mark}');
    Error('\P{Is_Gc=/a/spacing_mark}');
    Expect(1, 119154, '\p{Is_Gc=spacingmark}', "");
    Expect(0, 119154, '\p{^Is_Gc=spacingmark}', "");
    Expect(0, 119154, '\P{Is_Gc=spacingmark}', "");
    Expect(1, 119154, '\P{^Is_Gc=spacingmark}', "");
    Expect(0, 119155, '\p{Is_Gc=spacingmark}', "");
    Expect(1, 119155, '\p{^Is_Gc=spacingmark}', "");
    Expect(1, 119155, '\P{Is_Gc=spacingmark}', "");
    Expect(0, 119155, '\P{^Is_Gc=spacingmark}', "");
    Expect(1, 119154, '\p{Is_Gc=	Spacing_Mark}', "");
    Expect(0, 119154, '\p{^Is_Gc=	Spacing_Mark}', "");
    Expect(0, 119154, '\P{Is_Gc=	Spacing_Mark}', "");
    Expect(1, 119154, '\P{^Is_Gc=	Spacing_Mark}', "");
    Expect(0, 119155, '\p{Is_Gc=	Spacing_Mark}', "");
    Expect(1, 119155, '\p{^Is_Gc=	Spacing_Mark}', "");
    Expect(1, 119155, '\P{Is_Gc=	Spacing_Mark}', "");
    Expect(0, 119155, '\P{^Is_Gc=	Spacing_Mark}', "");
    Error('\p{Is_Category::= Mc}');
    Error('\P{Is_Category::= Mc}');
    Expect(1, 119154, '\p{Is_Category:   mc}', "");
    Expect(0, 119154, '\p{^Is_Category:   mc}', "");
    Expect(0, 119154, '\P{Is_Category:   mc}', "");
    Expect(1, 119154, '\P{^Is_Category:   mc}', "");
    Expect(0, 119155, '\p{Is_Category:   mc}', "");
    Expect(1, 119155, '\p{^Is_Category:   mc}', "");
    Expect(1, 119155, '\P{Is_Category:   mc}', "");
    Expect(0, 119155, '\P{^Is_Category:   mc}', "");
    Expect(1, 119154, '\p{Is_Category=_MC}', "");
    Expect(0, 119154, '\p{^Is_Category=_MC}', "");
    Expect(0, 119154, '\P{Is_Category=_MC}', "");
    Expect(1, 119154, '\P{^Is_Category=_MC}', "");
    Expect(0, 119155, '\p{Is_Category=_MC}', "");
    Expect(1, 119155, '\p{^Is_Category=_MC}', "");
    Expect(1, 119155, '\P{Is_Category=_MC}', "");
    Expect(0, 119155, '\P{^Is_Category=_MC}', "");
    Error('\p{General_Category= 	Enclosing_MARK/a/}');
    Error('\P{General_Category= 	Enclosing_MARK/a/}');
    Expect(1, 42610, '\p{General_Category=enclosingmark}', "");
    Expect(0, 42610, '\p{^General_Category=enclosingmark}', "");
    Expect(0, 42610, '\P{General_Category=enclosingmark}', "");
    Expect(1, 42610, '\P{^General_Category=enclosingmark}', "");
    Expect(0, 42611, '\p{General_Category=enclosingmark}', "");
    Expect(1, 42611, '\p{^General_Category=enclosingmark}', "");
    Expect(1, 42611, '\P{General_Category=enclosingmark}', "");
    Expect(0, 42611, '\P{^General_Category=enclosingmark}', "");
    Expect(1, 42610, '\p{General_Category= Enclosing_Mark}', "");
    Expect(0, 42610, '\p{^General_Category= Enclosing_Mark}', "");
    Expect(0, 42610, '\P{General_Category= Enclosing_Mark}', "");
    Expect(1, 42610, '\P{^General_Category= Enclosing_Mark}', "");
    Expect(0, 42611, '\p{General_Category= Enclosing_Mark}', "");
    Expect(1, 42611, '\p{^General_Category= Enclosing_Mark}', "");
    Expect(1, 42611, '\P{General_Category= Enclosing_Mark}', "");
    Expect(0, 42611, '\P{^General_Category= Enclosing_Mark}', "");
    Error('\p{Gc=/a/ -ME}');
    Error('\P{Gc=/a/ -ME}');
    Expect(1, 42610, '\p{Gc=me}', "");
    Expect(0, 42610, '\p{^Gc=me}', "");
    Expect(0, 42610, '\P{Gc=me}', "");
    Expect(1, 42610, '\P{^Gc=me}', "");
    Expect(0, 42611, '\p{Gc=me}', "");
    Expect(1, 42611, '\p{^Gc=me}', "");
    Expect(1, 42611, '\P{Gc=me}', "");
    Expect(0, 42611, '\P{^Gc=me}', "");
    Expect(1, 42610, '\p{Gc:	Me}', "");
    Expect(0, 42610, '\p{^Gc:	Me}', "");
    Expect(0, 42610, '\P{Gc:	Me}', "");
    Expect(1, 42610, '\P{^Gc:	Me}', "");
    Expect(0, 42611, '\p{Gc:	Me}', "");
    Expect(1, 42611, '\p{^Gc:	Me}', "");
    Expect(1, 42611, '\P{Gc:	Me}', "");
    Expect(0, 42611, '\P{^Gc:	Me}', "");
    Error('\p{Category=	:=ENCLOSING_mark}');
    Error('\P{Category=	:=ENCLOSING_mark}');
    Expect(1, 42610, '\p{Category=enclosingmark}', "");
    Expect(0, 42610, '\p{^Category=enclosingmark}', "");
    Expect(0, 42610, '\P{Category=enclosingmark}', "");
    Expect(1, 42610, '\P{^Category=enclosingmark}', "");
    Expect(0, 42611, '\p{Category=enclosingmark}', "");
    Expect(1, 42611, '\p{^Category=enclosingmark}', "");
    Expect(1, 42611, '\P{Category=enclosingmark}', "");
    Expect(0, 42611, '\P{^Category=enclosingmark}', "");
    Expect(1, 42610, '\p{Category=__Enclosing_Mark}', "");
    Expect(0, 42610, '\p{^Category=__Enclosing_Mark}', "");
    Expect(0, 42610, '\P{Category=__Enclosing_Mark}', "");
    Expect(1, 42610, '\P{^Category=__Enclosing_Mark}', "");
    Expect(0, 42611, '\p{Category=__Enclosing_Mark}', "");
    Expect(1, 42611, '\p{^Category=__Enclosing_Mark}', "");
    Expect(1, 42611, '\P{Category=__Enclosing_Mark}', "");
    Expect(0, 42611, '\P{^Category=__Enclosing_Mark}', "");
    Error('\p{Is_General_Category=	 ME:=}');
    Error('\P{Is_General_Category=	 ME:=}');
    Expect(1, 42610, '\p{Is_General_Category=me}', "");
    Expect(0, 42610, '\p{^Is_General_Category=me}', "");
    Expect(0, 42610, '\P{Is_General_Category=me}', "");
    Expect(1, 42610, '\P{^Is_General_Category=me}', "");
    Expect(0, 42611, '\p{Is_General_Category=me}', "");
    Expect(1, 42611, '\p{^Is_General_Category=me}', "");
    Expect(1, 42611, '\P{Is_General_Category=me}', "");
    Expect(0, 42611, '\P{^Is_General_Category=me}', "");
    Expect(1, 42610, '\p{Is_General_Category=-_Me}', "");
    Expect(0, 42610, '\p{^Is_General_Category=-_Me}', "");
    Expect(0, 42610, '\P{Is_General_Category=-_Me}', "");
    Expect(1, 42610, '\P{^Is_General_Category=-_Me}', "");
    Expect(0, 42611, '\p{Is_General_Category=-_Me}', "");
    Expect(1, 42611, '\p{^Is_General_Category=-_Me}', "");
    Expect(1, 42611, '\P{Is_General_Category=-_Me}', "");
    Expect(0, 42611, '\P{^Is_General_Category=-_Me}', "");
    Error('\p{Is_Gc= /a/enclosing_Mark}');
    Error('\P{Is_Gc= /a/enclosing_Mark}');
    Expect(1, 42610, '\p{Is_Gc:   enclosingmark}', "");
    Expect(0, 42610, '\p{^Is_Gc:   enclosingmark}', "");
    Expect(0, 42610, '\P{Is_Gc:   enclosingmark}', "");
    Expect(1, 42610, '\P{^Is_Gc:   enclosingmark}', "");
    Expect(0, 42611, '\p{Is_Gc:   enclosingmark}', "");
    Expect(1, 42611, '\p{^Is_Gc:   enclosingmark}', "");
    Expect(1, 42611, '\P{Is_Gc:   enclosingmark}', "");
    Expect(0, 42611, '\P{^Is_Gc:   enclosingmark}', "");
    Expect(1, 42610, '\p{Is_Gc=-Enclosing_Mark}', "");
    Expect(0, 42610, '\p{^Is_Gc=-Enclosing_Mark}', "");
    Expect(0, 42610, '\P{Is_Gc=-Enclosing_Mark}', "");
    Expect(1, 42610, '\P{^Is_Gc=-Enclosing_Mark}', "");
    Expect(0, 42611, '\p{Is_Gc=-Enclosing_Mark}', "");
    Expect(1, 42611, '\p{^Is_Gc=-Enclosing_Mark}', "");
    Expect(1, 42611, '\P{Is_Gc=-Enclosing_Mark}', "");
    Expect(0, 42611, '\P{^Is_Gc=-Enclosing_Mark}', "");
    Error('\p{Is_Category=:=Me}');
    Error('\P{Is_Category=:=Me}');
    Expect(1, 42610, '\p{Is_Category=me}', "");
    Expect(0, 42610, '\p{^Is_Category=me}', "");
    Expect(0, 42610, '\P{Is_Category=me}', "");
    Expect(1, 42610, '\P{^Is_Category=me}', "");
    Expect(0, 42611, '\p{Is_Category=me}', "");
    Expect(1, 42611, '\p{^Is_Category=me}', "");
    Expect(1, 42611, '\P{Is_Category=me}', "");
    Expect(0, 42611, '\P{^Is_Category=me}', "");
    Expect(1, 42610, '\p{Is_Category:	 ME}', "");
    Expect(0, 42610, '\p{^Is_Category:	 ME}', "");
    Expect(0, 42610, '\P{Is_Category:	 ME}', "");
    Expect(1, 42610, '\P{^Is_Category:	 ME}', "");
    Expect(0, 42611, '\p{Is_Category:	 ME}', "");
    Expect(1, 42611, '\p{^Is_Category:	 ME}', "");
    Expect(1, 42611, '\P{Is_Category:	 ME}', "");
    Expect(0, 42611, '\P{^Is_Category:	 ME}', "");
    Error('\p{General_Category=/a/-_Nonspacing_MARK}');
    Error('\P{General_Category=/a/-_Nonspacing_MARK}');
    Expect(1, 917999, '\p{General_Category=nonspacingmark}', "");
    Expect(0, 917999, '\p{^General_Category=nonspacingmark}', "");
    Expect(0, 917999, '\P{General_Category=nonspacingmark}', "");
    Expect(1, 917999, '\P{^General_Category=nonspacingmark}', "");
    Expect(0, 918000, '\p{General_Category=nonspacingmark}', "");
    Expect(1, 918000, '\p{^General_Category=nonspacingmark}', "");
    Expect(1, 918000, '\P{General_Category=nonspacingmark}', "");
    Expect(0, 918000, '\P{^General_Category=nonspacingmark}', "");
    Expect(1, 917999, '\p{General_Category=	NONSPACING_Mark}', "");
    Expect(0, 917999, '\p{^General_Category=	NONSPACING_Mark}', "");
    Expect(0, 917999, '\P{General_Category=	NONSPACING_Mark}', "");
    Expect(1, 917999, '\P{^General_Category=	NONSPACING_Mark}', "");
    Expect(0, 918000, '\p{General_Category=	NONSPACING_Mark}', "");
    Expect(1, 918000, '\p{^General_Category=	NONSPACING_Mark}', "");
    Expect(1, 918000, '\P{General_Category=	NONSPACING_Mark}', "");
    Expect(0, 918000, '\P{^General_Category=	NONSPACING_Mark}', "");
    Error('\p{Gc= 	MN/a/}');
    Error('\P{Gc= 	MN/a/}');
    Expect(1, 917999, '\p{Gc: mn}', "");
    Expect(0, 917999, '\p{^Gc: mn}', "");
    Expect(0, 917999, '\P{Gc: mn}', "");
    Expect(1, 917999, '\P{^Gc: mn}', "");
    Expect(0, 918000, '\p{Gc: mn}', "");
    Expect(1, 918000, '\p{^Gc: mn}', "");
    Expect(1, 918000, '\P{Gc: mn}', "");
    Expect(0, 918000, '\P{^Gc: mn}', "");
    Expect(1, 917999, '\p{Gc=- Mn}', "");
    Expect(0, 917999, '\p{^Gc=- Mn}', "");
    Expect(0, 917999, '\P{Gc=- Mn}', "");
    Expect(1, 917999, '\P{^Gc=- Mn}', "");
    Expect(0, 918000, '\p{Gc=- Mn}', "");
    Expect(1, 918000, '\p{^Gc=- Mn}', "");
    Expect(1, 918000, '\P{Gc=- Mn}', "");
    Expect(0, 918000, '\P{^Gc=- Mn}', "");
    Error('\p{Category=/a/_-nonspacing_Mark}');
    Error('\P{Category=/a/_-nonspacing_Mark}');
    Expect(1, 917999, '\p{Category:	nonspacingmark}', "");
    Expect(0, 917999, '\p{^Category:	nonspacingmark}', "");
    Expect(0, 917999, '\P{Category:	nonspacingmark}', "");
    Expect(1, 917999, '\P{^Category:	nonspacingmark}', "");
    Expect(0, 918000, '\p{Category:	nonspacingmark}', "");
    Expect(1, 918000, '\p{^Category:	nonspacingmark}', "");
    Expect(1, 918000, '\P{Category:	nonspacingmark}', "");
    Expect(0, 918000, '\P{^Category:	nonspacingmark}', "");
    Expect(1, 917999, '\p{Category=  Nonspacing_Mark}', "");
    Expect(0, 917999, '\p{^Category=  Nonspacing_Mark}', "");
    Expect(0, 917999, '\P{Category=  Nonspacing_Mark}', "");
    Expect(1, 917999, '\P{^Category=  Nonspacing_Mark}', "");
    Expect(0, 918000, '\p{Category=  Nonspacing_Mark}', "");
    Expect(1, 918000, '\p{^Category=  Nonspacing_Mark}', "");
    Expect(1, 918000, '\P{Category=  Nonspacing_Mark}', "");
    Expect(0, 918000, '\P{^Category=  Nonspacing_Mark}', "");
    Error('\p{Is_General_Category=:= 	Mn}');
    Error('\P{Is_General_Category=:= 	Mn}');
    Expect(1, 917999, '\p{Is_General_Category:   mn}', "");
    Expect(0, 917999, '\p{^Is_General_Category:   mn}', "");
    Expect(0, 917999, '\P{Is_General_Category:   mn}', "");
    Expect(1, 917999, '\P{^Is_General_Category:   mn}', "");
    Expect(0, 918000, '\p{Is_General_Category:   mn}', "");
    Expect(1, 918000, '\p{^Is_General_Category:   mn}', "");
    Expect(1, 918000, '\P{Is_General_Category:   mn}', "");
    Expect(0, 918000, '\P{^Is_General_Category:   mn}', "");
    Expect(1, 917999, '\p{Is_General_Category= mn}', "");
    Expect(0, 917999, '\p{^Is_General_Category= mn}', "");
    Expect(0, 917999, '\P{Is_General_Category= mn}', "");
    Expect(1, 917999, '\P{^Is_General_Category= mn}', "");
    Expect(0, 918000, '\p{Is_General_Category= mn}', "");
    Expect(1, 918000, '\p{^Is_General_Category= mn}', "");
    Expect(1, 918000, '\P{Is_General_Category= mn}', "");
    Expect(0, 918000, '\P{^Is_General_Category= mn}', "");
    Error('\p{Is_Gc=:=nonspacing_mark}');
    Error('\P{Is_Gc=:=nonspacing_mark}');
    Expect(1, 917999, '\p{Is_Gc=nonspacingmark}', "");
    Expect(0, 917999, '\p{^Is_Gc=nonspacingmark}', "");
    Expect(0, 917999, '\P{Is_Gc=nonspacingmark}', "");
    Expect(1, 917999, '\P{^Is_Gc=nonspacingmark}', "");
    Expect(0, 918000, '\p{Is_Gc=nonspacingmark}', "");
    Expect(1, 918000, '\p{^Is_Gc=nonspacingmark}', "");
    Expect(1, 918000, '\P{Is_Gc=nonspacingmark}', "");
    Expect(0, 918000, '\P{^Is_Gc=nonspacingmark}', "");
    Expect(1, 917999, '\p{Is_Gc=	-Nonspacing_mark}', "");
    Expect(0, 917999, '\p{^Is_Gc=	-Nonspacing_mark}', "");
    Expect(0, 917999, '\P{Is_Gc=	-Nonspacing_mark}', "");
    Expect(1, 917999, '\P{^Is_Gc=	-Nonspacing_mark}', "");
    Expect(0, 918000, '\p{Is_Gc=	-Nonspacing_mark}', "");
    Expect(1, 918000, '\p{^Is_Gc=	-Nonspacing_mark}', "");
    Expect(1, 918000, '\P{Is_Gc=	-Nonspacing_mark}', "");
    Expect(0, 918000, '\P{^Is_Gc=	-Nonspacing_mark}', "");
    Error('\p{Is_Category=/a/_Mn}');
    Error('\P{Is_Category=/a/_Mn}');
    Expect(1, 917999, '\p{Is_Category=mn}', "");
    Expect(0, 917999, '\p{^Is_Category=mn}', "");
    Expect(0, 917999, '\P{Is_Category=mn}', "");
    Expect(1, 917999, '\P{^Is_Category=mn}', "");
    Expect(0, 918000, '\p{Is_Category=mn}', "");
    Expect(1, 918000, '\p{^Is_Category=mn}', "");
    Expect(1, 918000, '\P{Is_Category=mn}', "");
    Expect(0, 918000, '\P{^Is_Category=mn}', "");
    Expect(1, 917999, '\p{Is_Category=-_Mn}', "");
    Expect(0, 917999, '\p{^Is_Category=-_Mn}', "");
    Expect(0, 917999, '\P{Is_Category=-_Mn}', "");
    Expect(1, 917999, '\P{^Is_Category=-_Mn}', "");
    Expect(0, 918000, '\p{Is_Category=-_Mn}', "");
    Expect(1, 918000, '\p{^Is_Category=-_Mn}', "");
    Expect(1, 918000, '\P{Is_Category=-_Mn}', "");
    Expect(0, 918000, '\P{^Is_Category=-_Mn}', "");
    Error('\p{General_Category=	-NUMBER:=}');
    Error('\P{General_Category=	-NUMBER:=}');
    Expect(1, 127244, '\p{General_Category=number}', "");
    Expect(0, 127244, '\p{^General_Category=number}', "");
    Expect(0, 127244, '\P{General_Category=number}', "");
    Expect(1, 127244, '\P{^General_Category=number}', "");
    Expect(0, 127245, '\p{General_Category=number}', "");
    Expect(1, 127245, '\p{^General_Category=number}', "");
    Expect(1, 127245, '\P{General_Category=number}', "");
    Expect(0, 127245, '\P{^General_Category=number}', "");
    Expect(1, 127244, '\p{General_Category=	NUMBER}', "");
    Expect(0, 127244, '\p{^General_Category=	NUMBER}', "");
    Expect(0, 127244, '\P{General_Category=	NUMBER}', "");
    Expect(1, 127244, '\P{^General_Category=	NUMBER}', "");
    Expect(0, 127245, '\p{General_Category=	NUMBER}', "");
    Expect(1, 127245, '\p{^General_Category=	NUMBER}', "");
    Expect(1, 127245, '\P{General_Category=	NUMBER}', "");
    Expect(0, 127245, '\P{^General_Category=	NUMBER}', "");
    Error('\p{Gc=	_N:=}');
    Error('\P{Gc=	_N:=}');
    Expect(1, 127244, '\p{Gc=n}', "");
    Expect(0, 127244, '\p{^Gc=n}', "");
    Expect(0, 127244, '\P{Gc=n}', "");
    Expect(1, 127244, '\P{^Gc=n}', "");
    Expect(0, 127245, '\p{Gc=n}', "");
    Expect(1, 127245, '\p{^Gc=n}', "");
    Expect(1, 127245, '\P{Gc=n}', "");
    Expect(0, 127245, '\P{^Gc=n}', "");
    Expect(1, 127244, '\p{Gc=		n}', "");
    Expect(0, 127244, '\p{^Gc=		n}', "");
    Expect(0, 127244, '\P{Gc=		n}', "");
    Expect(1, 127244, '\P{^Gc=		n}', "");
    Expect(0, 127245, '\p{Gc=		n}', "");
    Expect(1, 127245, '\p{^Gc=		n}', "");
    Expect(1, 127245, '\P{Gc=		n}', "");
    Expect(0, 127245, '\P{^Gc=		n}', "");
    Error('\p{Category=:=Number}');
    Error('\P{Category=:=Number}');
    Expect(1, 127244, '\p{Category=number}', "");
    Expect(0, 127244, '\p{^Category=number}', "");
    Expect(0, 127244, '\P{Category=number}', "");
    Expect(1, 127244, '\P{^Category=number}', "");
    Expect(0, 127245, '\p{Category=number}', "");
    Expect(1, 127245, '\p{^Category=number}', "");
    Expect(1, 127245, '\P{Category=number}', "");
    Expect(0, 127245, '\P{^Category=number}', "");
    Expect(1, 127244, '\p{Category=_Number}', "");
    Expect(0, 127244, '\p{^Category=_Number}', "");
    Expect(0, 127244, '\P{Category=_Number}', "");
    Expect(1, 127244, '\P{^Category=_Number}', "");
    Expect(0, 127245, '\p{Category=_Number}', "");
    Expect(1, 127245, '\p{^Category=_Number}', "");
    Expect(1, 127245, '\P{Category=_Number}', "");
    Expect(0, 127245, '\P{^Category=_Number}', "");
    Error('\p{Is_General_Category=/a/n}');
    Error('\P{Is_General_Category=/a/n}');
    Expect(1, 127244, '\p{Is_General_Category=n}', "");
    Expect(0, 127244, '\p{^Is_General_Category=n}', "");
    Expect(0, 127244, '\P{Is_General_Category=n}', "");
    Expect(1, 127244, '\P{^Is_General_Category=n}', "");
    Expect(0, 127245, '\p{Is_General_Category=n}', "");
    Expect(1, 127245, '\p{^Is_General_Category=n}', "");
    Expect(1, 127245, '\P{Is_General_Category=n}', "");
    Expect(0, 127245, '\P{^Is_General_Category=n}', "");
    Expect(1, 127244, '\p{Is_General_Category=_n}', "");
    Expect(0, 127244, '\p{^Is_General_Category=_n}', "");
    Expect(0, 127244, '\P{Is_General_Category=_n}', "");
    Expect(1, 127244, '\P{^Is_General_Category=_n}', "");
    Expect(0, 127245, '\p{Is_General_Category=_n}', "");
    Expect(1, 127245, '\p{^Is_General_Category=_n}', "");
    Expect(1, 127245, '\P{Is_General_Category=_n}', "");
    Expect(0, 127245, '\P{^Is_General_Category=_n}', "");
    Error('\p{Is_Gc=/a/_Number}');
    Error('\P{Is_Gc=/a/_Number}');
    Expect(1, 127244, '\p{Is_Gc=number}', "");
    Expect(0, 127244, '\p{^Is_Gc=number}', "");
    Expect(0, 127244, '\P{Is_Gc=number}', "");
    Expect(1, 127244, '\P{^Is_Gc=number}', "");
    Expect(0, 127245, '\p{Is_Gc=number}', "");
    Expect(1, 127245, '\p{^Is_Gc=number}', "");
    Expect(1, 127245, '\P{Is_Gc=number}', "");
    Expect(0, 127245, '\P{^Is_Gc=number}', "");
    Expect(1, 127244, '\p{Is_Gc= Number}', "");
    Expect(0, 127244, '\p{^Is_Gc= Number}', "");
    Expect(0, 127244, '\P{Is_Gc= Number}', "");
    Expect(1, 127244, '\P{^Is_Gc= Number}', "");
    Expect(0, 127245, '\p{Is_Gc= Number}', "");
    Expect(1, 127245, '\p{^Is_Gc= Number}', "");
    Expect(1, 127245, '\P{Is_Gc= Number}', "");
    Expect(0, 127245, '\P{^Is_Gc= Number}', "");
    Error('\p{Is_Category=	n/a/}');
    Error('\P{Is_Category=	n/a/}');
    Expect(1, 127244, '\p{Is_Category=n}', "");
    Expect(0, 127244, '\p{^Is_Category=n}', "");
    Expect(0, 127244, '\P{Is_Category=n}', "");
    Expect(1, 127244, '\P{^Is_Category=n}', "");
    Expect(0, 127245, '\p{Is_Category=n}', "");
    Expect(1, 127245, '\p{^Is_Category=n}', "");
    Expect(1, 127245, '\P{Is_Category=n}', "");
    Expect(0, 127245, '\P{^Is_Category=n}', "");
    Expect(1, 127244, '\p{Is_Category=N}', "");
    Expect(0, 127244, '\p{^Is_Category=N}', "");
    Expect(0, 127244, '\P{Is_Category=N}', "");
    Expect(1, 127244, '\P{^Is_Category=N}', "");
    Expect(0, 127245, '\p{Is_Category=N}', "");
    Expect(1, 127245, '\p{^Is_Category=N}', "");
    Expect(1, 127245, '\P{Is_Category=N}', "");
    Expect(0, 127245, '\P{^Is_Category=N}', "");
    Error('\p{General_Category=-DECIMAL_NUMBER:=}');
    Error('\P{General_Category=-DECIMAL_NUMBER:=}');
    Expect(1, 125273, '\p{General_Category=decimalnumber}', "");
    Expect(0, 125273, '\p{^General_Category=decimalnumber}', "");
    Expect(0, 125273, '\P{General_Category=decimalnumber}', "");
    Expect(1, 125273, '\P{^General_Category=decimalnumber}', "");
    Expect(0, 125274, '\p{General_Category=decimalnumber}', "");
    Expect(1, 125274, '\p{^General_Category=decimalnumber}', "");
    Expect(1, 125274, '\P{General_Category=decimalnumber}', "");
    Expect(0, 125274, '\P{^General_Category=decimalnumber}', "");
    Expect(1, 125273, '\p{General_Category=--Decimal_number}', "");
    Expect(0, 125273, '\p{^General_Category=--Decimal_number}', "");
    Expect(0, 125273, '\P{General_Category=--Decimal_number}', "");
    Expect(1, 125273, '\P{^General_Category=--Decimal_number}', "");
    Expect(0, 125274, '\p{General_Category=--Decimal_number}', "");
    Expect(1, 125274, '\p{^General_Category=--Decimal_number}', "");
    Expect(1, 125274, '\P{General_Category=--Decimal_number}', "");
    Expect(0, 125274, '\P{^General_Category=--Decimal_number}', "");
    Error('\p{Gc=/a/nd}');
    Error('\P{Gc=/a/nd}');
    Expect(1, 125273, '\p{Gc:nd}', "");
    Expect(0, 125273, '\p{^Gc:nd}', "");
    Expect(0, 125273, '\P{Gc:nd}', "");
    Expect(1, 125273, '\P{^Gc:nd}', "");
    Expect(0, 125274, '\p{Gc:nd}', "");
    Expect(1, 125274, '\p{^Gc:nd}', "");
    Expect(1, 125274, '\P{Gc:nd}', "");
    Expect(0, 125274, '\P{^Gc:nd}', "");
    Expect(1, 125273, '\p{Gc=	 Nd}', "");
    Expect(0, 125273, '\p{^Gc=	 Nd}', "");
    Expect(0, 125273, '\P{Gc=	 Nd}', "");
    Expect(1, 125273, '\P{^Gc=	 Nd}', "");
    Expect(0, 125274, '\p{Gc=	 Nd}', "");
    Expect(1, 125274, '\p{^Gc=	 Nd}', "");
    Expect(1, 125274, '\P{Gc=	 Nd}', "");
    Expect(0, 125274, '\P{^Gc=	 Nd}', "");
    Error('\p{Category=	 Digit:=}');
    Error('\P{Category=	 Digit:=}');
    Expect(1, 125273, '\p{Category=digit}', "");
    Expect(0, 125273, '\p{^Category=digit}', "");
    Expect(0, 125273, '\P{Category=digit}', "");
    Expect(1, 125273, '\P{^Category=digit}', "");
    Expect(0, 125274, '\p{Category=digit}', "");
    Expect(1, 125274, '\p{^Category=digit}', "");
    Expect(1, 125274, '\P{Category=digit}', "");
    Expect(0, 125274, '\P{^Category=digit}', "");
    Expect(1, 125273, '\p{Category=-DIGIT}', "");
    Expect(0, 125273, '\p{^Category=-DIGIT}', "");
    Expect(0, 125273, '\P{Category=-DIGIT}', "");
    Expect(1, 125273, '\P{^Category=-DIGIT}', "");
    Expect(0, 125274, '\p{Category=-DIGIT}', "");
    Expect(1, 125274, '\p{^Category=-DIGIT}', "");
    Expect(1, 125274, '\P{Category=-DIGIT}', "");
    Expect(0, 125274, '\P{^Category=-DIGIT}', "");
    Error('\p{Is_General_Category=:= _Decimal_number}');
    Error('\P{Is_General_Category=:= _Decimal_number}');
    Expect(1, 125273, '\p{Is_General_Category=decimalnumber}', "");
    Expect(0, 125273, '\p{^Is_General_Category=decimalnumber}', "");
    Expect(0, 125273, '\P{Is_General_Category=decimalnumber}', "");
    Expect(1, 125273, '\P{^Is_General_Category=decimalnumber}', "");
    Expect(0, 125274, '\p{Is_General_Category=decimalnumber}', "");
    Expect(1, 125274, '\p{^Is_General_Category=decimalnumber}', "");
    Expect(1, 125274, '\P{Is_General_Category=decimalnumber}', "");
    Expect(0, 125274, '\P{^Is_General_Category=decimalnumber}', "");
    Expect(1, 125273, '\p{Is_General_Category= Decimal_Number}', "");
    Expect(0, 125273, '\p{^Is_General_Category= Decimal_Number}', "");
    Expect(0, 125273, '\P{Is_General_Category= Decimal_Number}', "");
    Expect(1, 125273, '\P{^Is_General_Category= Decimal_Number}', "");
    Expect(0, 125274, '\p{Is_General_Category= Decimal_Number}', "");
    Expect(1, 125274, '\p{^Is_General_Category= Decimal_Number}', "");
    Expect(1, 125274, '\P{Is_General_Category= Decimal_Number}', "");
    Expect(0, 125274, '\P{^Is_General_Category= Decimal_Number}', "");
    Error('\p{Is_Gc=:=-_nd}');
    Error('\P{Is_Gc=:=-_nd}');
    Expect(1, 125273, '\p{Is_Gc=nd}', "");
    Expect(0, 125273, '\p{^Is_Gc=nd}', "");
    Expect(0, 125273, '\P{Is_Gc=nd}', "");
    Expect(1, 125273, '\P{^Is_Gc=nd}', "");
    Expect(0, 125274, '\p{Is_Gc=nd}', "");
    Expect(1, 125274, '\p{^Is_Gc=nd}', "");
    Expect(1, 125274, '\P{Is_Gc=nd}', "");
    Expect(0, 125274, '\P{^Is_Gc=nd}', "");
    Expect(1, 125273, '\p{Is_Gc= 	Nd}', "");
    Expect(0, 125273, '\p{^Is_Gc= 	Nd}', "");
    Expect(0, 125273, '\P{Is_Gc= 	Nd}', "");
    Expect(1, 125273, '\P{^Is_Gc= 	Nd}', "");
    Expect(0, 125274, '\p{Is_Gc= 	Nd}', "");
    Expect(1, 125274, '\p{^Is_Gc= 	Nd}', "");
    Expect(1, 125274, '\P{Is_Gc= 	Nd}', "");
    Expect(0, 125274, '\P{^Is_Gc= 	Nd}', "");
    Error('\p{Is_Category=-_Digit:=}');
    Error('\P{Is_Category=-_Digit:=}');
    Expect(1, 125273, '\p{Is_Category=digit}', "");
    Expect(0, 125273, '\p{^Is_Category=digit}', "");
    Expect(0, 125273, '\P{Is_Category=digit}', "");
    Expect(1, 125273, '\P{^Is_Category=digit}', "");
    Expect(0, 125274, '\p{Is_Category=digit}', "");
    Expect(1, 125274, '\p{^Is_Category=digit}', "");
    Expect(1, 125274, '\P{Is_Category=digit}', "");
    Expect(0, 125274, '\P{^Is_Category=digit}', "");
    Expect(1, 125273, '\p{Is_Category=_	Digit}', "");
    Expect(0, 125273, '\p{^Is_Category=_	Digit}', "");
    Expect(0, 125273, '\P{Is_Category=_	Digit}', "");
    Expect(1, 125273, '\P{^Is_Category=_	Digit}', "");
    Expect(0, 125274, '\p{Is_Category=_	Digit}', "");
    Expect(1, 125274, '\p{^Is_Category=_	Digit}', "");
    Expect(1, 125274, '\P{Is_Category=_	Digit}', "");
    Expect(0, 125274, '\P{^Is_Category=_	Digit}', "");
    Error('\p{General_Category= :=Letter_number}');
    Error('\P{General_Category= :=Letter_number}');
    Expect(1, 74862, '\p{General_Category=letternumber}', "");
    Expect(0, 74862, '\p{^General_Category=letternumber}', "");
    Expect(0, 74862, '\P{General_Category=letternumber}', "");
    Expect(1, 74862, '\P{^General_Category=letternumber}', "");
    Expect(0, 74863, '\p{General_Category=letternumber}', "");
    Expect(1, 74863, '\p{^General_Category=letternumber}', "");
    Expect(1, 74863, '\P{General_Category=letternumber}', "");
    Expect(0, 74863, '\P{^General_Category=letternumber}', "");
    Expect(1, 74862, '\p{General_Category=_-LETTER_number}', "");
    Expect(0, 74862, '\p{^General_Category=_-LETTER_number}', "");
    Expect(0, 74862, '\P{General_Category=_-LETTER_number}', "");
    Expect(1, 74862, '\P{^General_Category=_-LETTER_number}', "");
    Expect(0, 74863, '\p{General_Category=_-LETTER_number}', "");
    Expect(1, 74863, '\p{^General_Category=_-LETTER_number}', "");
    Expect(1, 74863, '\P{General_Category=_-LETTER_number}', "");
    Expect(0, 74863, '\P{^General_Category=_-LETTER_number}', "");
    Error('\p{Gc: _:=NL}');
    Error('\P{Gc: _:=NL}');
    Expect(1, 74862, '\p{Gc=nl}', "");
    Expect(0, 74862, '\p{^Gc=nl}', "");
    Expect(0, 74862, '\P{Gc=nl}', "");
    Expect(1, 74862, '\P{^Gc=nl}', "");
    Expect(0, 74863, '\p{Gc=nl}', "");
    Expect(1, 74863, '\p{^Gc=nl}', "");
    Expect(1, 74863, '\P{Gc=nl}', "");
    Expect(0, 74863, '\P{^Gc=nl}', "");
    Expect(1, 74862, '\p{Gc=	_nl}', "");
    Expect(0, 74862, '\p{^Gc=	_nl}', "");
    Expect(0, 74862, '\P{Gc=	_nl}', "");
    Expect(1, 74862, '\P{^Gc=	_nl}', "");
    Expect(0, 74863, '\p{Gc=	_nl}', "");
    Expect(1, 74863, '\p{^Gc=	_nl}', "");
    Expect(1, 74863, '\P{Gc=	_nl}', "");
    Expect(0, 74863, '\P{^Gc=	_nl}', "");
    Error('\p{Category= Letter_Number/a/}');
    Error('\P{Category= Letter_Number/a/}');
    Expect(1, 74862, '\p{Category=letternumber}', "");
    Expect(0, 74862, '\p{^Category=letternumber}', "");
    Expect(0, 74862, '\P{Category=letternumber}', "");
    Expect(1, 74862, '\P{^Category=letternumber}', "");
    Expect(0, 74863, '\p{Category=letternumber}', "");
    Expect(1, 74863, '\p{^Category=letternumber}', "");
    Expect(1, 74863, '\P{Category=letternumber}', "");
    Expect(0, 74863, '\P{^Category=letternumber}', "");
    Expect(1, 74862, '\p{Category=_letter_Number}', "");
    Expect(0, 74862, '\p{^Category=_letter_Number}', "");
    Expect(0, 74862, '\P{Category=_letter_Number}', "");
    Expect(1, 74862, '\P{^Category=_letter_Number}', "");
    Expect(0, 74863, '\p{Category=_letter_Number}', "");
    Expect(1, 74863, '\p{^Category=_letter_Number}', "");
    Expect(1, 74863, '\P{Category=_letter_Number}', "");
    Expect(0, 74863, '\P{^Category=_letter_Number}', "");
    Error('\p{Is_General_Category= -Nl/a/}');
    Error('\P{Is_General_Category= -Nl/a/}');
    Expect(1, 74862, '\p{Is_General_Category=nl}', "");
    Expect(0, 74862, '\p{^Is_General_Category=nl}', "");
    Expect(0, 74862, '\P{Is_General_Category=nl}', "");
    Expect(1, 74862, '\P{^Is_General_Category=nl}', "");
    Expect(0, 74863, '\p{Is_General_Category=nl}', "");
    Expect(1, 74863, '\p{^Is_General_Category=nl}', "");
    Expect(1, 74863, '\P{Is_General_Category=nl}', "");
    Expect(0, 74863, '\P{^Is_General_Category=nl}', "");
    Expect(1, 74862, '\p{Is_General_Category=  Nl}', "");
    Expect(0, 74862, '\p{^Is_General_Category=  Nl}', "");
    Expect(0, 74862, '\P{Is_General_Category=  Nl}', "");
    Expect(1, 74862, '\P{^Is_General_Category=  Nl}', "");
    Expect(0, 74863, '\p{Is_General_Category=  Nl}', "");
    Expect(1, 74863, '\p{^Is_General_Category=  Nl}', "");
    Expect(1, 74863, '\P{Is_General_Category=  Nl}', "");
    Expect(0, 74863, '\P{^Is_General_Category=  Nl}', "");
    Error('\p{Is_Gc:/a/_ Letter_number}');
    Error('\P{Is_Gc:/a/_ Letter_number}');
    Expect(1, 74862, '\p{Is_Gc=letternumber}', "");
    Expect(0, 74862, '\p{^Is_Gc=letternumber}', "");
    Expect(0, 74862, '\P{Is_Gc=letternumber}', "");
    Expect(1, 74862, '\P{^Is_Gc=letternumber}', "");
    Expect(0, 74863, '\p{Is_Gc=letternumber}', "");
    Expect(1, 74863, '\p{^Is_Gc=letternumber}', "");
    Expect(1, 74863, '\P{Is_Gc=letternumber}', "");
    Expect(0, 74863, '\P{^Is_Gc=letternumber}', "");
    Expect(1, 74862, '\p{Is_Gc:	  Letter_Number}', "");
    Expect(0, 74862, '\p{^Is_Gc:	  Letter_Number}', "");
    Expect(0, 74862, '\P{Is_Gc:	  Letter_Number}', "");
    Expect(1, 74862, '\P{^Is_Gc:	  Letter_Number}', "");
    Expect(0, 74863, '\p{Is_Gc:	  Letter_Number}', "");
    Expect(1, 74863, '\p{^Is_Gc:	  Letter_Number}', "");
    Expect(1, 74863, '\P{Is_Gc:	  Letter_Number}', "");
    Expect(0, 74863, '\P{^Is_Gc:	  Letter_Number}', "");
    Error('\p{Is_Category=/a/	-nl}');
    Error('\P{Is_Category=/a/	-nl}');
    Expect(1, 74862, '\p{Is_Category=nl}', "");
    Expect(0, 74862, '\p{^Is_Category=nl}', "");
    Expect(0, 74862, '\P{Is_Category=nl}', "");
    Expect(1, 74862, '\P{^Is_Category=nl}', "");
    Expect(0, 74863, '\p{Is_Category=nl}', "");
    Expect(1, 74863, '\p{^Is_Category=nl}', "");
    Expect(1, 74863, '\P{Is_Category=nl}', "");
    Expect(0, 74863, '\P{^Is_Category=nl}', "");
    Expect(1, 74862, '\p{Is_Category=-_nl}', "");
    Expect(0, 74862, '\p{^Is_Category=-_nl}', "");
    Expect(0, 74862, '\P{Is_Category=-_nl}', "");
    Expect(1, 74862, '\P{^Is_Category=-_nl}', "");
    Expect(0, 74863, '\p{Is_Category=-_nl}', "");
    Expect(1, 74863, '\p{^Is_Category=-_nl}', "");
    Expect(1, 74863, '\P{Is_Category=-_nl}', "");
    Expect(0, 74863, '\P{^Is_Category=-_nl}', "");
    Error('\p{General_Category=/a/	_OTHER_Number}');
    Error('\P{General_Category=/a/	_OTHER_Number}');
    Expect(1, 127244, '\p{General_Category=othernumber}', "");
    Expect(0, 127244, '\p{^General_Category=othernumber}', "");
    Expect(0, 127244, '\P{General_Category=othernumber}', "");
    Expect(1, 127244, '\P{^General_Category=othernumber}', "");
    Expect(0, 127245, '\p{General_Category=othernumber}', "");
    Expect(1, 127245, '\p{^General_Category=othernumber}', "");
    Expect(1, 127245, '\P{General_Category=othernumber}', "");
    Expect(0, 127245, '\P{^General_Category=othernumber}', "");
    Expect(1, 127244, '\p{General_Category:  -Other_Number}', "");
    Expect(0, 127244, '\p{^General_Category:  -Other_Number}', "");
    Expect(0, 127244, '\P{General_Category:  -Other_Number}', "");
    Expect(1, 127244, '\P{^General_Category:  -Other_Number}', "");
    Expect(0, 127245, '\p{General_Category:  -Other_Number}', "");
    Expect(1, 127245, '\p{^General_Category:  -Other_Number}', "");
    Expect(1, 127245, '\P{General_Category:  -Other_Number}', "");
    Expect(0, 127245, '\P{^General_Category:  -Other_Number}', "");
    Error('\p{Gc=-	No:=}');
    Error('\P{Gc=-	No:=}');
    Expect(1, 127244, '\p{Gc=no}', "");
    Expect(0, 127244, '\p{^Gc=no}', "");
    Expect(0, 127244, '\P{Gc=no}', "");
    Expect(1, 127244, '\P{^Gc=no}', "");
    Expect(0, 127245, '\p{Gc=no}', "");
    Expect(1, 127245, '\p{^Gc=no}', "");
    Expect(1, 127245, '\P{Gc=no}', "");
    Expect(0, 127245, '\P{^Gc=no}', "");
    Expect(1, 127244, '\p{Gc=	_No}', "");
    Expect(0, 127244, '\p{^Gc=	_No}', "");
    Expect(0, 127244, '\P{Gc=	_No}', "");
    Expect(1, 127244, '\P{^Gc=	_No}', "");
    Expect(0, 127245, '\p{Gc=	_No}', "");
    Expect(1, 127245, '\p{^Gc=	_No}', "");
    Expect(1, 127245, '\P{Gc=	_No}', "");
    Expect(0, 127245, '\P{^Gc=	_No}', "");
    Error('\p{Category= -Other_Number/a/}');
    Error('\P{Category= -Other_Number/a/}');
    Expect(1, 127244, '\p{Category=othernumber}', "");
    Expect(0, 127244, '\p{^Category=othernumber}', "");
    Expect(0, 127244, '\P{Category=othernumber}', "");
    Expect(1, 127244, '\P{^Category=othernumber}', "");
    Expect(0, 127245, '\p{Category=othernumber}', "");
    Expect(1, 127245, '\p{^Category=othernumber}', "");
    Expect(1, 127245, '\P{Category=othernumber}', "");
    Expect(0, 127245, '\P{^Category=othernumber}', "");
    Expect(1, 127244, '\p{Category=	_other_Number}', "");
    Expect(0, 127244, '\p{^Category=	_other_Number}', "");
    Expect(0, 127244, '\P{Category=	_other_Number}', "");
    Expect(1, 127244, '\P{^Category=	_other_Number}', "");
    Expect(0, 127245, '\p{Category=	_other_Number}', "");
    Expect(1, 127245, '\p{^Category=	_other_Number}', "");
    Expect(1, 127245, '\P{Category=	_other_Number}', "");
    Expect(0, 127245, '\P{^Category=	_other_Number}', "");
    Error('\p{Is_General_Category=/a/ No}');
    Error('\P{Is_General_Category=/a/ No}');
    Expect(1, 127244, '\p{Is_General_Category=no}', "");
    Expect(0, 127244, '\p{^Is_General_Category=no}', "");
    Expect(0, 127244, '\P{Is_General_Category=no}', "");
    Expect(1, 127244, '\P{^Is_General_Category=no}', "");
    Expect(0, 127245, '\p{Is_General_Category=no}', "");
    Expect(1, 127245, '\p{^Is_General_Category=no}', "");
    Expect(1, 127245, '\P{Is_General_Category=no}', "");
    Expect(0, 127245, '\P{^Is_General_Category=no}', "");
    Expect(1, 127244, '\p{Is_General_Category=_ No}', "");
    Expect(0, 127244, '\p{^Is_General_Category=_ No}', "");
    Expect(0, 127244, '\P{Is_General_Category=_ No}', "");
    Expect(1, 127244, '\P{^Is_General_Category=_ No}', "");
    Expect(0, 127245, '\p{Is_General_Category=_ No}', "");
    Expect(1, 127245, '\p{^Is_General_Category=_ No}', "");
    Expect(1, 127245, '\P{Is_General_Category=_ No}', "");
    Expect(0, 127245, '\P{^Is_General_Category=_ No}', "");
    Error('\p{Is_Gc=	-Other_number/a/}');
    Error('\P{Is_Gc=	-Other_number/a/}');
    Expect(1, 127244, '\p{Is_Gc=othernumber}', "");
    Expect(0, 127244, '\p{^Is_Gc=othernumber}', "");
    Expect(0, 127244, '\P{Is_Gc=othernumber}', "");
    Expect(1, 127244, '\P{^Is_Gc=othernumber}', "");
    Expect(0, 127245, '\p{Is_Gc=othernumber}', "");
    Expect(1, 127245, '\p{^Is_Gc=othernumber}', "");
    Expect(1, 127245, '\P{Is_Gc=othernumber}', "");
    Expect(0, 127245, '\P{^Is_Gc=othernumber}', "");
    Expect(1, 127244, '\p{Is_Gc=_other_number}', "");
    Expect(0, 127244, '\p{^Is_Gc=_other_number}', "");
    Expect(0, 127244, '\P{Is_Gc=_other_number}', "");
    Expect(1, 127244, '\P{^Is_Gc=_other_number}', "");
    Expect(0, 127245, '\p{Is_Gc=_other_number}', "");
    Expect(1, 127245, '\p{^Is_Gc=_other_number}', "");
    Expect(1, 127245, '\P{Is_Gc=_other_number}', "");
    Expect(0, 127245, '\P{^Is_Gc=_other_number}', "");
    Error('\p{Is_Category=/a/__No}');
    Error('\P{Is_Category=/a/__No}');
    Expect(1, 127244, '\p{Is_Category:no}', "");
    Expect(0, 127244, '\p{^Is_Category:no}', "");
    Expect(0, 127244, '\P{Is_Category:no}', "");
    Expect(1, 127244, '\P{^Is_Category:no}', "");
    Expect(0, 127245, '\p{Is_Category:no}', "");
    Expect(1, 127245, '\p{^Is_Category:no}', "");
    Expect(1, 127245, '\P{Is_Category:no}', "");
    Expect(0, 127245, '\P{^Is_Category:no}', "");
    Expect(1, 127244, '\p{Is_Category=-No}', "");
    Expect(0, 127244, '\p{^Is_Category=-No}', "");
    Expect(0, 127244, '\P{Is_Category=-No}', "");
    Expect(1, 127244, '\P{^Is_Category=-No}', "");
    Expect(0, 127245, '\p{Is_Category=-No}', "");
    Expect(1, 127245, '\p{^Is_Category=-No}', "");
    Expect(1, 127245, '\P{Is_Category=-No}', "");
    Expect(0, 127245, '\P{^Is_Category=-No}', "");
    Error('\p{General_Category=_-punctuation:=}');
    Error('\P{General_Category=_-punctuation:=}');
    Expect(1, 125279, '\p{General_Category:   punctuation}', "");
    Expect(0, 125279, '\p{^General_Category:   punctuation}', "");
    Expect(0, 125279, '\P{General_Category:   punctuation}', "");
    Expect(1, 125279, '\P{^General_Category:   punctuation}', "");
    Expect(0, 125280, '\p{General_Category:   punctuation}', "");
    Expect(1, 125280, '\p{^General_Category:   punctuation}', "");
    Expect(1, 125280, '\P{General_Category:   punctuation}', "");
    Expect(0, 125280, '\P{^General_Category:   punctuation}', "");
    Expect(1, 125279, '\p{General_Category=-PUNCTUATION}', "");
    Expect(0, 125279, '\p{^General_Category=-PUNCTUATION}', "");
    Expect(0, 125279, '\P{General_Category=-PUNCTUATION}', "");
    Expect(1, 125279, '\P{^General_Category=-PUNCTUATION}', "");
    Expect(0, 125280, '\p{General_Category=-PUNCTUATION}', "");
    Expect(1, 125280, '\p{^General_Category=-PUNCTUATION}', "");
    Expect(1, 125280, '\P{General_Category=-PUNCTUATION}', "");
    Expect(0, 125280, '\P{^General_Category=-PUNCTUATION}', "");
    Error('\p{Gc=_/a/p}');
    Error('\P{Gc=_/a/p}');
    Expect(1, 125279, '\p{Gc=p}', "");
    Expect(0, 125279, '\p{^Gc=p}', "");
    Expect(0, 125279, '\P{Gc=p}', "");
    Expect(1, 125279, '\P{^Gc=p}', "");
    Expect(0, 125280, '\p{Gc=p}', "");
    Expect(1, 125280, '\p{^Gc=p}', "");
    Expect(1, 125280, '\P{Gc=p}', "");
    Expect(0, 125280, '\P{^Gc=p}', "");
    Expect(1, 125279, '\p{Gc=-P}', "");
    Expect(0, 125279, '\p{^Gc=-P}', "");
    Expect(0, 125279, '\P{Gc=-P}', "");
    Expect(1, 125279, '\P{^Gc=-P}', "");
    Expect(0, 125280, '\p{Gc=-P}', "");
    Expect(1, 125280, '\p{^Gc=-P}', "");
    Expect(1, 125280, '\P{Gc=-P}', "");
    Expect(0, 125280, '\P{^Gc=-P}', "");
    Error('\p{Category=/a/--punct}');
    Error('\P{Category=/a/--punct}');
    Expect(1, 125279, '\p{Category:punct}', "");
    Expect(0, 125279, '\p{^Category:punct}', "");
    Expect(0, 125279, '\P{Category:punct}', "");
    Expect(1, 125279, '\P{^Category:punct}', "");
    Expect(0, 125280, '\p{Category:punct}', "");
    Expect(1, 125280, '\p{^Category:punct}', "");
    Expect(1, 125280, '\P{Category:punct}', "");
    Expect(0, 125280, '\P{^Category:punct}', "");
    Expect(1, 125279, '\p{Category=-_Punct}', "");
    Expect(0, 125279, '\p{^Category=-_Punct}', "");
    Expect(0, 125279, '\P{Category=-_Punct}', "");
    Expect(1, 125279, '\P{^Category=-_Punct}', "");
    Expect(0, 125280, '\p{Category=-_Punct}', "");
    Expect(1, 125280, '\p{^Category=-_Punct}', "");
    Expect(1, 125280, '\P{Category=-_Punct}', "");
    Expect(0, 125280, '\P{^Category=-_Punct}', "");
    Error('\p{Is_General_Category=_:=Punctuation}');
    Error('\P{Is_General_Category=_:=Punctuation}');
    Expect(1, 125279, '\p{Is_General_Category=punctuation}', "");
    Expect(0, 125279, '\p{^Is_General_Category=punctuation}', "");
    Expect(0, 125279, '\P{Is_General_Category=punctuation}', "");
    Expect(1, 125279, '\P{^Is_General_Category=punctuation}', "");
    Expect(0, 125280, '\p{Is_General_Category=punctuation}', "");
    Expect(1, 125280, '\p{^Is_General_Category=punctuation}', "");
    Expect(1, 125280, '\P{Is_General_Category=punctuation}', "");
    Expect(0, 125280, '\P{^Is_General_Category=punctuation}', "");
    Expect(1, 125279, '\p{Is_General_Category=-Punctuation}', "");
    Expect(0, 125279, '\p{^Is_General_Category=-Punctuation}', "");
    Expect(0, 125279, '\P{Is_General_Category=-Punctuation}', "");
    Expect(1, 125279, '\P{^Is_General_Category=-Punctuation}', "");
    Expect(0, 125280, '\p{Is_General_Category=-Punctuation}', "");
    Expect(1, 125280, '\p{^Is_General_Category=-Punctuation}', "");
    Expect(1, 125280, '\P{Is_General_Category=-Punctuation}', "");
    Expect(0, 125280, '\P{^Is_General_Category=-Punctuation}', "");
    Error('\p{Is_Gc= 	p:=}');
    Error('\P{Is_Gc= 	p:=}');
    Expect(1, 125279, '\p{Is_Gc=p}', "");
    Expect(0, 125279, '\p{^Is_Gc=p}', "");
    Expect(0, 125279, '\P{Is_Gc=p}', "");
    Expect(1, 125279, '\P{^Is_Gc=p}', "");
    Expect(0, 125280, '\p{Is_Gc=p}', "");
    Expect(1, 125280, '\p{^Is_Gc=p}', "");
    Expect(1, 125280, '\P{Is_Gc=p}', "");
    Expect(0, 125280, '\P{^Is_Gc=p}', "");
    Expect(1, 125279, '\p{Is_Gc=_ p}', "");
    Expect(0, 125279, '\p{^Is_Gc=_ p}', "");
    Expect(0, 125279, '\P{Is_Gc=_ p}', "");
    Expect(1, 125279, '\P{^Is_Gc=_ p}', "");
    Expect(0, 125280, '\p{Is_Gc=_ p}', "");
    Expect(1, 125280, '\p{^Is_Gc=_ p}', "");
    Expect(1, 125280, '\P{Is_Gc=_ p}', "");
    Expect(0, 125280, '\P{^Is_Gc=_ p}', "");
    Error('\p{Is_Category=	:=Punct}');
    Error('\P{Is_Category=	:=Punct}');
    Expect(1, 125279, '\p{Is_Category=punct}', "");
    Expect(0, 125279, '\p{^Is_Category=punct}', "");
    Expect(0, 125279, '\P{Is_Category=punct}', "");
    Expect(1, 125279, '\P{^Is_Category=punct}', "");
    Expect(0, 125280, '\p{Is_Category=punct}', "");
    Expect(1, 125280, '\p{^Is_Category=punct}', "");
    Expect(1, 125280, '\P{Is_Category=punct}', "");
    Expect(0, 125280, '\P{^Is_Category=punct}', "");
    Expect(1, 125279, '\p{Is_Category=-	Punct}', "");
    Expect(0, 125279, '\p{^Is_Category=-	Punct}', "");
    Expect(0, 125279, '\P{Is_Category=-	Punct}', "");
    Expect(1, 125279, '\P{^Is_Category=-	Punct}', "");
    Expect(0, 125280, '\p{Is_Category=-	Punct}', "");
    Expect(1, 125280, '\p{^Is_Category=-	Punct}', "");
    Expect(1, 125280, '\P{Is_Category=-	Punct}', "");
    Expect(0, 125280, '\P{^Is_Category=-	Punct}', "");
    Error('\p{General_Category= Connector_PUNCTUATION/a/}');
    Error('\P{General_Category= Connector_PUNCTUATION/a/}');
    Expect(1, 65343, '\p{General_Category=connectorpunctuation}', "");
    Expect(0, 65343, '\p{^General_Category=connectorpunctuation}', "");
    Expect(0, 65343, '\P{General_Category=connectorpunctuation}', "");
    Expect(1, 65343, '\P{^General_Category=connectorpunctuation}', "");
    Expect(0, 65344, '\p{General_Category=connectorpunctuation}', "");
    Expect(1, 65344, '\p{^General_Category=connectorpunctuation}', "");
    Expect(1, 65344, '\P{General_Category=connectorpunctuation}', "");
    Expect(0, 65344, '\P{^General_Category=connectorpunctuation}', "");
    Expect(1, 65343, '\p{General_Category=	Connector_PUNCTUATION}', "");
    Expect(0, 65343, '\p{^General_Category=	Connector_PUNCTUATION}', "");
    Expect(0, 65343, '\P{General_Category=	Connector_PUNCTUATION}', "");
    Expect(1, 65343, '\P{^General_Category=	Connector_PUNCTUATION}', "");
    Expect(0, 65344, '\p{General_Category=	Connector_PUNCTUATION}', "");
    Expect(1, 65344, '\p{^General_Category=	Connector_PUNCTUATION}', "");
    Expect(1, 65344, '\P{General_Category=	Connector_PUNCTUATION}', "");
    Expect(0, 65344, '\P{^General_Category=	Connector_PUNCTUATION}', "");
    Error('\p{Gc:   _:=Pc}');
    Error('\P{Gc:   _:=Pc}');
    Expect(1, 65343, '\p{Gc=pc}', "");
    Expect(0, 65343, '\p{^Gc=pc}', "");
    Expect(0, 65343, '\P{Gc=pc}', "");
    Expect(1, 65343, '\P{^Gc=pc}', "");
    Expect(0, 65344, '\p{Gc=pc}', "");
    Expect(1, 65344, '\p{^Gc=pc}', "");
    Expect(1, 65344, '\P{Gc=pc}', "");
    Expect(0, 65344, '\P{^Gc=pc}', "");
    Expect(1, 65343, '\p{Gc=_ PC}', "");
    Expect(0, 65343, '\p{^Gc=_ PC}', "");
    Expect(0, 65343, '\P{Gc=_ PC}', "");
    Expect(1, 65343, '\P{^Gc=_ PC}', "");
    Expect(0, 65344, '\p{Gc=_ PC}', "");
    Expect(1, 65344, '\p{^Gc=_ PC}', "");
    Expect(1, 65344, '\P{Gc=_ PC}', "");
    Expect(0, 65344, '\P{^Gc=_ PC}', "");
    Error('\p{Category= 	Connector_PUNCTUATION/a/}');
    Error('\P{Category= 	Connector_PUNCTUATION/a/}');
    Expect(1, 65343, '\p{Category=connectorpunctuation}', "");
    Expect(0, 65343, '\p{^Category=connectorpunctuation}', "");
    Expect(0, 65343, '\P{Category=connectorpunctuation}', "");
    Expect(1, 65343, '\P{^Category=connectorpunctuation}', "");
    Expect(0, 65344, '\p{Category=connectorpunctuation}', "");
    Expect(1, 65344, '\p{^Category=connectorpunctuation}', "");
    Expect(1, 65344, '\P{Category=connectorpunctuation}', "");
    Expect(0, 65344, '\P{^Category=connectorpunctuation}', "");
    Expect(1, 65343, '\p{Category= 	CONNECTOR_Punctuation}', "");
    Expect(0, 65343, '\p{^Category= 	CONNECTOR_Punctuation}', "");
    Expect(0, 65343, '\P{Category= 	CONNECTOR_Punctuation}', "");
    Expect(1, 65343, '\P{^Category= 	CONNECTOR_Punctuation}', "");
    Expect(0, 65344, '\p{Category= 	CONNECTOR_Punctuation}', "");
    Expect(1, 65344, '\p{^Category= 	CONNECTOR_Punctuation}', "");
    Expect(1, 65344, '\P{Category= 	CONNECTOR_Punctuation}', "");
    Expect(0, 65344, '\P{^Category= 	CONNECTOR_Punctuation}', "");
    Error('\p{Is_General_Category=_	Pc/a/}');
    Error('\P{Is_General_Category=_	Pc/a/}');
    Expect(1, 65343, '\p{Is_General_Category=pc}', "");
    Expect(0, 65343, '\p{^Is_General_Category=pc}', "");
    Expect(0, 65343, '\P{Is_General_Category=pc}', "");
    Expect(1, 65343, '\P{^Is_General_Category=pc}', "");
    Expect(0, 65344, '\p{Is_General_Category=pc}', "");
    Expect(1, 65344, '\p{^Is_General_Category=pc}', "");
    Expect(1, 65344, '\P{Is_General_Category=pc}', "");
    Expect(0, 65344, '\P{^Is_General_Category=pc}', "");
    Expect(1, 65343, '\p{Is_General_Category=-Pc}', "");
    Expect(0, 65343, '\p{^Is_General_Category=-Pc}', "");
    Expect(0, 65343, '\P{Is_General_Category=-Pc}', "");
    Expect(1, 65343, '\P{^Is_General_Category=-Pc}', "");
    Expect(0, 65344, '\p{Is_General_Category=-Pc}', "");
    Expect(1, 65344, '\p{^Is_General_Category=-Pc}', "");
    Expect(1, 65344, '\P{Is_General_Category=-Pc}', "");
    Expect(0, 65344, '\P{^Is_General_Category=-Pc}', "");
    Error('\p{Is_Gc= Connector_Punctuation:=}');
    Error('\P{Is_Gc= Connector_Punctuation:=}');
    Expect(1, 65343, '\p{Is_Gc=connectorpunctuation}', "");
    Expect(0, 65343, '\p{^Is_Gc=connectorpunctuation}', "");
    Expect(0, 65343, '\P{Is_Gc=connectorpunctuation}', "");
    Expect(1, 65343, '\P{^Is_Gc=connectorpunctuation}', "");
    Expect(0, 65344, '\p{Is_Gc=connectorpunctuation}', "");
    Expect(1, 65344, '\p{^Is_Gc=connectorpunctuation}', "");
    Expect(1, 65344, '\P{Is_Gc=connectorpunctuation}', "");
    Expect(0, 65344, '\P{^Is_Gc=connectorpunctuation}', "");
    Expect(1, 65343, '\p{Is_Gc=-	connector_Punctuation}', "");
    Expect(0, 65343, '\p{^Is_Gc=-	connector_Punctuation}', "");
    Expect(0, 65343, '\P{Is_Gc=-	connector_Punctuation}', "");
    Expect(1, 65343, '\P{^Is_Gc=-	connector_Punctuation}', "");
    Expect(0, 65344, '\p{Is_Gc=-	connector_Punctuation}', "");
    Expect(1, 65344, '\p{^Is_Gc=-	connector_Punctuation}', "");
    Expect(1, 65344, '\P{Is_Gc=-	connector_Punctuation}', "");
    Expect(0, 65344, '\P{^Is_Gc=-	connector_Punctuation}', "");
    Error('\p{Is_Category: -_pc:=}');
    Error('\P{Is_Category: -_pc:=}');
    Expect(1, 65343, '\p{Is_Category=pc}', "");
    Expect(0, 65343, '\p{^Is_Category=pc}', "");
    Expect(0, 65343, '\P{Is_Category=pc}', "");
    Expect(1, 65343, '\P{^Is_Category=pc}', "");
    Expect(0, 65344, '\p{Is_Category=pc}', "");
    Expect(1, 65344, '\p{^Is_Category=pc}', "");
    Expect(1, 65344, '\P{Is_Category=pc}', "");
    Expect(0, 65344, '\P{^Is_Category=pc}', "");
    Expect(1, 65343, '\p{Is_Category= -PC}', "");
    Expect(0, 65343, '\p{^Is_Category= -PC}', "");
    Expect(0, 65343, '\P{Is_Category= -PC}', "");
    Expect(1, 65343, '\P{^Is_Category= -PC}', "");
    Expect(0, 65344, '\p{Is_Category= -PC}', "");
    Expect(1, 65344, '\p{^Is_Category= -PC}', "");
    Expect(1, 65344, '\P{Is_Category= -PC}', "");
    Expect(0, 65344, '\P{^Is_Category= -PC}', "");
    Error('\p{General_Category=/a/_-DASH_Punctuation}');
    Error('\P{General_Category=/a/_-DASH_Punctuation}');
    Expect(1, 65293, '\p{General_Category:   dashpunctuation}', "");
    Expect(0, 65293, '\p{^General_Category:   dashpunctuation}', "");
    Expect(0, 65293, '\P{General_Category:   dashpunctuation}', "");
    Expect(1, 65293, '\P{^General_Category:   dashpunctuation}', "");
    Expect(0, 65294, '\p{General_Category:   dashpunctuation}', "");
    Expect(1, 65294, '\p{^General_Category:   dashpunctuation}', "");
    Expect(1, 65294, '\P{General_Category:   dashpunctuation}', "");
    Expect(0, 65294, '\P{^General_Category:   dashpunctuation}', "");
    Expect(1, 65293, '\p{General_Category=	DASH_Punctuation}', "");
    Expect(0, 65293, '\p{^General_Category=	DASH_Punctuation}', "");
    Expect(0, 65293, '\P{General_Category=	DASH_Punctuation}', "");
    Expect(1, 65293, '\P{^General_Category=	DASH_Punctuation}', "");
    Expect(0, 65294, '\p{General_Category=	DASH_Punctuation}', "");
    Expect(1, 65294, '\p{^General_Category=	DASH_Punctuation}', "");
    Expect(1, 65294, '\P{General_Category=	DASH_Punctuation}', "");
    Expect(0, 65294, '\P{^General_Category=	DASH_Punctuation}', "");
    Error('\p{Gc=_ pd:=}');
    Error('\P{Gc=_ pd:=}');
    Expect(1, 65293, '\p{Gc=pd}', "");
    Expect(0, 65293, '\p{^Gc=pd}', "");
    Expect(0, 65293, '\P{Gc=pd}', "");
    Expect(1, 65293, '\P{^Gc=pd}', "");
    Expect(0, 65294, '\p{Gc=pd}', "");
    Expect(1, 65294, '\p{^Gc=pd}', "");
    Expect(1, 65294, '\P{Gc=pd}', "");
    Expect(0, 65294, '\P{^Gc=pd}', "");
    Expect(1, 65293, '\p{Gc= pd}', "");
    Expect(0, 65293, '\p{^Gc= pd}', "");
    Expect(0, 65293, '\P{Gc= pd}', "");
    Expect(1, 65293, '\P{^Gc= pd}', "");
    Expect(0, 65294, '\p{Gc= pd}', "");
    Expect(1, 65294, '\p{^Gc= pd}', "");
    Expect(1, 65294, '\P{Gc= pd}', "");
    Expect(0, 65294, '\P{^Gc= pd}', "");
    Error('\p{Category=:=  Dash_punctuation}');
    Error('\P{Category=:=  Dash_punctuation}');
    Expect(1, 65293, '\p{Category=dashpunctuation}', "");
    Expect(0, 65293, '\p{^Category=dashpunctuation}', "");
    Expect(0, 65293, '\P{Category=dashpunctuation}', "");
    Expect(1, 65293, '\P{^Category=dashpunctuation}', "");
    Expect(0, 65294, '\p{Category=dashpunctuation}', "");
    Expect(1, 65294, '\p{^Category=dashpunctuation}', "");
    Expect(1, 65294, '\P{Category=dashpunctuation}', "");
    Expect(0, 65294, '\P{^Category=dashpunctuation}', "");
    Expect(1, 65293, '\p{Category=-_DASH_Punctuation}', "");
    Expect(0, 65293, '\p{^Category=-_DASH_Punctuation}', "");
    Expect(0, 65293, '\P{Category=-_DASH_Punctuation}', "");
    Expect(1, 65293, '\P{^Category=-_DASH_Punctuation}', "");
    Expect(0, 65294, '\p{Category=-_DASH_Punctuation}', "");
    Expect(1, 65294, '\p{^Category=-_DASH_Punctuation}', "");
    Expect(1, 65294, '\P{Category=-_DASH_Punctuation}', "");
    Expect(0, 65294, '\P{^Category=-_DASH_Punctuation}', "");
    Error('\p{Is_General_Category=	/a/Pd}');
    Error('\P{Is_General_Category=	/a/Pd}');
    Expect(1, 65293, '\p{Is_General_Category=pd}', "");
    Expect(0, 65293, '\p{^Is_General_Category=pd}', "");
    Expect(0, 65293, '\P{Is_General_Category=pd}', "");
    Expect(1, 65293, '\P{^Is_General_Category=pd}', "");
    Expect(0, 65294, '\p{Is_General_Category=pd}', "");
    Expect(1, 65294, '\p{^Is_General_Category=pd}', "");
    Expect(1, 65294, '\P{Is_General_Category=pd}', "");
    Expect(0, 65294, '\P{^Is_General_Category=pd}', "");
    Expect(1, 65293, '\p{Is_General_Category:  Pd}', "");
    Expect(0, 65293, '\p{^Is_General_Category:  Pd}', "");
    Expect(0, 65293, '\P{Is_General_Category:  Pd}', "");
    Expect(1, 65293, '\P{^Is_General_Category:  Pd}', "");
    Expect(0, 65294, '\p{Is_General_Category:  Pd}', "");
    Expect(1, 65294, '\p{^Is_General_Category:  Pd}', "");
    Expect(1, 65294, '\P{Is_General_Category:  Pd}', "");
    Expect(0, 65294, '\P{^Is_General_Category:  Pd}', "");
    Error('\p{Is_Gc=:=_	Dash_PUNCTUATION}');
    Error('\P{Is_Gc=:=_	Dash_PUNCTUATION}');
    Expect(1, 65293, '\p{Is_Gc=dashpunctuation}', "");
    Expect(0, 65293, '\p{^Is_Gc=dashpunctuation}', "");
    Expect(0, 65293, '\P{Is_Gc=dashpunctuation}', "");
    Expect(1, 65293, '\P{^Is_Gc=dashpunctuation}', "");
    Expect(0, 65294, '\p{Is_Gc=dashpunctuation}', "");
    Expect(1, 65294, '\p{^Is_Gc=dashpunctuation}', "");
    Expect(1, 65294, '\P{Is_Gc=dashpunctuation}', "");
    Expect(0, 65294, '\P{^Is_Gc=dashpunctuation}', "");
    Expect(1, 65293, '\p{Is_Gc=_DASH_PUNCTUATION}', "");
    Expect(0, 65293, '\p{^Is_Gc=_DASH_PUNCTUATION}', "");
    Expect(0, 65293, '\P{Is_Gc=_DASH_PUNCTUATION}', "");
    Expect(1, 65293, '\P{^Is_Gc=_DASH_PUNCTUATION}', "");
    Expect(0, 65294, '\p{Is_Gc=_DASH_PUNCTUATION}', "");
    Expect(1, 65294, '\p{^Is_Gc=_DASH_PUNCTUATION}', "");
    Expect(1, 65294, '\P{Is_Gc=_DASH_PUNCTUATION}', "");
    Expect(0, 65294, '\P{^Is_Gc=_DASH_PUNCTUATION}', "");
    Error('\p{Is_Category=:=_pd}');
    Error('\P{Is_Category=:=_pd}');
    Expect(1, 65293, '\p{Is_Category=pd}', "");
    Expect(0, 65293, '\p{^Is_Category=pd}', "");
    Expect(0, 65293, '\P{Is_Category=pd}', "");
    Expect(1, 65293, '\P{^Is_Category=pd}', "");
    Expect(0, 65294, '\p{Is_Category=pd}', "");
    Expect(1, 65294, '\p{^Is_Category=pd}', "");
    Expect(1, 65294, '\P{Is_Category=pd}', "");
    Expect(0, 65294, '\P{^Is_Category=pd}', "");
    Expect(1, 65293, '\p{Is_Category=_	PD}', "");
    Expect(0, 65293, '\p{^Is_Category=_	PD}', "");
    Expect(0, 65293, '\P{Is_Category=_	PD}', "");
    Expect(1, 65293, '\P{^Is_Category=_	PD}', "");
    Expect(0, 65294, '\p{Is_Category=_	PD}', "");
    Expect(1, 65294, '\p{^Is_Category=_	PD}', "");
    Expect(1, 65294, '\P{Is_Category=_	PD}', "");
    Expect(0, 65294, '\P{^Is_Category=_	PD}', "");
    Error('\p{General_Category:  :=CLOSE_Punctuation}');
    Error('\P{General_Category:  :=CLOSE_Punctuation}');
    Expect(1, 65379, '\p{General_Category=closepunctuation}', "");
    Expect(0, 65379, '\p{^General_Category=closepunctuation}', "");
    Expect(0, 65379, '\P{General_Category=closepunctuation}', "");
    Expect(1, 65379, '\P{^General_Category=closepunctuation}', "");
    Expect(0, 65380, '\p{General_Category=closepunctuation}', "");
    Expect(1, 65380, '\p{^General_Category=closepunctuation}', "");
    Expect(1, 65380, '\P{General_Category=closepunctuation}', "");
    Expect(0, 65380, '\P{^General_Category=closepunctuation}', "");
    Expect(1, 65379, '\p{General_Category=_	Close_punctuation}', "");
    Expect(0, 65379, '\p{^General_Category=_	Close_punctuation}', "");
    Expect(0, 65379, '\P{General_Category=_	Close_punctuation}', "");
    Expect(1, 65379, '\P{^General_Category=_	Close_punctuation}', "");
    Expect(0, 65380, '\p{General_Category=_	Close_punctuation}', "");
    Expect(1, 65380, '\p{^General_Category=_	Close_punctuation}', "");
    Expect(1, 65380, '\P{General_Category=_	Close_punctuation}', "");
    Expect(0, 65380, '\P{^General_Category=_	Close_punctuation}', "");
    Error('\p{Gc=:=__PE}');
    Error('\P{Gc=:=__PE}');
    Expect(1, 65379, '\p{Gc=pe}', "");
    Expect(0, 65379, '\p{^Gc=pe}', "");
    Expect(0, 65379, '\P{Gc=pe}', "");
    Expect(1, 65379, '\P{^Gc=pe}', "");
    Expect(0, 65380, '\p{Gc=pe}', "");
    Expect(1, 65380, '\p{^Gc=pe}', "");
    Expect(1, 65380, '\P{Gc=pe}', "");
    Expect(0, 65380, '\P{^Gc=pe}', "");
    Expect(1, 65379, '\p{Gc=	_Pe}', "");
    Expect(0, 65379, '\p{^Gc=	_Pe}', "");
    Expect(0, 65379, '\P{Gc=	_Pe}', "");
    Expect(1, 65379, '\P{^Gc=	_Pe}', "");
    Expect(0, 65380, '\p{Gc=	_Pe}', "");
    Expect(1, 65380, '\p{^Gc=	_Pe}', "");
    Expect(1, 65380, '\P{Gc=	_Pe}', "");
    Expect(0, 65380, '\P{^Gc=	_Pe}', "");
    Error('\p{Category=	:=CLOSE_Punctuation}');
    Error('\P{Category=	:=CLOSE_Punctuation}');
    Expect(1, 65379, '\p{Category=closepunctuation}', "");
    Expect(0, 65379, '\p{^Category=closepunctuation}', "");
    Expect(0, 65379, '\P{Category=closepunctuation}', "");
    Expect(1, 65379, '\P{^Category=closepunctuation}', "");
    Expect(0, 65380, '\p{Category=closepunctuation}', "");
    Expect(1, 65380, '\p{^Category=closepunctuation}', "");
    Expect(1, 65380, '\P{Category=closepunctuation}', "");
    Expect(0, 65380, '\P{^Category=closepunctuation}', "");
    Expect(1, 65379, '\p{Category=- CLOSE_punctuation}', "");
    Expect(0, 65379, '\p{^Category=- CLOSE_punctuation}', "");
    Expect(0, 65379, '\P{Category=- CLOSE_punctuation}', "");
    Expect(1, 65379, '\P{^Category=- CLOSE_punctuation}', "");
    Expect(0, 65380, '\p{Category=- CLOSE_punctuation}', "");
    Expect(1, 65380, '\p{^Category=- CLOSE_punctuation}', "");
    Expect(1, 65380, '\P{Category=- CLOSE_punctuation}', "");
    Expect(0, 65380, '\P{^Category=- CLOSE_punctuation}', "");
    Error('\p{Is_General_Category=:=	PE}');
    Error('\P{Is_General_Category=:=	PE}');
    Expect(1, 65379, '\p{Is_General_Category=pe}', "");
    Expect(0, 65379, '\p{^Is_General_Category=pe}', "");
    Expect(0, 65379, '\P{Is_General_Category=pe}', "");
    Expect(1, 65379, '\P{^Is_General_Category=pe}', "");
    Expect(0, 65380, '\p{Is_General_Category=pe}', "");
    Expect(1, 65380, '\p{^Is_General_Category=pe}', "");
    Expect(1, 65380, '\P{Is_General_Category=pe}', "");
    Expect(0, 65380, '\P{^Is_General_Category=pe}', "");
    Expect(1, 65379, '\p{Is_General_Category= -pe}', "");
    Expect(0, 65379, '\p{^Is_General_Category= -pe}', "");
    Expect(0, 65379, '\P{Is_General_Category= -pe}', "");
    Expect(1, 65379, '\P{^Is_General_Category= -pe}', "");
    Expect(0, 65380, '\p{Is_General_Category= -pe}', "");
    Expect(1, 65380, '\p{^Is_General_Category= -pe}', "");
    Expect(1, 65380, '\P{Is_General_Category= -pe}', "");
    Expect(0, 65380, '\P{^Is_General_Category= -pe}', "");
    Error('\p{Is_Gc: _close_Punctuation:=}');
    Error('\P{Is_Gc: _close_Punctuation:=}');
    Expect(1, 65379, '\p{Is_Gc: closepunctuation}', "");
    Expect(0, 65379, '\p{^Is_Gc: closepunctuation}', "");
    Expect(0, 65379, '\P{Is_Gc: closepunctuation}', "");
    Expect(1, 65379, '\P{^Is_Gc: closepunctuation}', "");
    Expect(0, 65380, '\p{Is_Gc: closepunctuation}', "");
    Expect(1, 65380, '\p{^Is_Gc: closepunctuation}', "");
    Expect(1, 65380, '\P{Is_Gc: closepunctuation}', "");
    Expect(0, 65380, '\P{^Is_Gc: closepunctuation}', "");
    Expect(1, 65379, '\p{Is_Gc= -Close_Punctuation}', "");
    Expect(0, 65379, '\p{^Is_Gc= -Close_Punctuation}', "");
    Expect(0, 65379, '\P{Is_Gc= -Close_Punctuation}', "");
    Expect(1, 65379, '\P{^Is_Gc= -Close_Punctuation}', "");
    Expect(0, 65380, '\p{Is_Gc= -Close_Punctuation}', "");
    Expect(1, 65380, '\p{^Is_Gc= -Close_Punctuation}', "");
    Expect(1, 65380, '\P{Is_Gc= -Close_Punctuation}', "");
    Expect(0, 65380, '\P{^Is_Gc= -Close_Punctuation}', "");
    Error('\p{Is_Category=-_Pe:=}');
    Error('\P{Is_Category=-_Pe:=}');
    Expect(1, 65379, '\p{Is_Category=pe}', "");
    Expect(0, 65379, '\p{^Is_Category=pe}', "");
    Expect(0, 65379, '\P{Is_Category=pe}', "");
    Expect(1, 65379, '\P{^Is_Category=pe}', "");
    Expect(0, 65380, '\p{Is_Category=pe}', "");
    Expect(1, 65380, '\p{^Is_Category=pe}', "");
    Expect(1, 65380, '\P{Is_Category=pe}', "");
    Expect(0, 65380, '\P{^Is_Category=pe}', "");
    Expect(1, 65379, '\p{Is_Category= _Pe}', "");
    Expect(0, 65379, '\p{^Is_Category= _Pe}', "");
    Expect(0, 65379, '\P{Is_Category= _Pe}', "");
    Expect(1, 65379, '\P{^Is_Category= _Pe}', "");
    Expect(0, 65380, '\p{Is_Category= _Pe}', "");
    Expect(1, 65380, '\p{^Is_Category= _Pe}', "");
    Expect(1, 65380, '\P{Is_Category= _Pe}', "");
    Expect(0, 65380, '\P{^Is_Category= _Pe}', "");
    Error('\p{General_Category=	FINAL_punctuation/a/}');
    Error('\P{General_Category=	FINAL_punctuation/a/}');
    Expect(1, 11809, '\p{General_Category=finalpunctuation}', "");
    Expect(0, 11809, '\p{^General_Category=finalpunctuation}', "");
    Expect(0, 11809, '\P{General_Category=finalpunctuation}', "");
    Expect(1, 11809, '\P{^General_Category=finalpunctuation}', "");
    Expect(0, 11810, '\p{General_Category=finalpunctuation}', "");
    Expect(1, 11810, '\p{^General_Category=finalpunctuation}', "");
    Expect(1, 11810, '\P{General_Category=finalpunctuation}', "");
    Expect(0, 11810, '\P{^General_Category=finalpunctuation}', "");
    Expect(1, 11809, '\p{General_Category= _FINAL_Punctuation}', "");
    Expect(0, 11809, '\p{^General_Category= _FINAL_Punctuation}', "");
    Expect(0, 11809, '\P{General_Category= _FINAL_Punctuation}', "");
    Expect(1, 11809, '\P{^General_Category= _FINAL_Punctuation}', "");
    Expect(0, 11810, '\p{General_Category= _FINAL_Punctuation}', "");
    Expect(1, 11810, '\p{^General_Category= _FINAL_Punctuation}', "");
    Expect(1, 11810, '\P{General_Category= _FINAL_Punctuation}', "");
    Expect(0, 11810, '\P{^General_Category= _FINAL_Punctuation}', "");
    Error('\p{Gc=  PF/a/}');
    Error('\P{Gc=  PF/a/}');
    Expect(1, 11809, '\p{Gc=pf}', "");
    Expect(0, 11809, '\p{^Gc=pf}', "");
    Expect(0, 11809, '\P{Gc=pf}', "");
    Expect(1, 11809, '\P{^Gc=pf}', "");
    Expect(0, 11810, '\p{Gc=pf}', "");
    Expect(1, 11810, '\p{^Gc=pf}', "");
    Expect(1, 11810, '\P{Gc=pf}', "");
    Expect(0, 11810, '\P{^Gc=pf}', "");
    Expect(1, 11809, '\p{Gc= 	Pf}', "");
    Expect(0, 11809, '\p{^Gc= 	Pf}', "");
    Expect(0, 11809, '\P{Gc= 	Pf}', "");
    Expect(1, 11809, '\P{^Gc= 	Pf}', "");
    Expect(0, 11810, '\p{Gc= 	Pf}', "");
    Expect(1, 11810, '\p{^Gc= 	Pf}', "");
    Expect(1, 11810, '\P{Gc= 	Pf}', "");
    Expect(0, 11810, '\P{^Gc= 	Pf}', "");
    Error('\p{Category= :=FINAL_punctuation}');
    Error('\P{Category= :=FINAL_punctuation}');
    Expect(1, 11809, '\p{Category=finalpunctuation}', "");
    Expect(0, 11809, '\p{^Category=finalpunctuation}', "");
    Expect(0, 11809, '\P{Category=finalpunctuation}', "");
    Expect(1, 11809, '\P{^Category=finalpunctuation}', "");
    Expect(0, 11810, '\p{Category=finalpunctuation}', "");
    Expect(1, 11810, '\p{^Category=finalpunctuation}', "");
    Expect(1, 11810, '\P{Category=finalpunctuation}', "");
    Expect(0, 11810, '\P{^Category=finalpunctuation}', "");
    Expect(1, 11809, '\p{Category=-_Final_punctuation}', "");
    Expect(0, 11809, '\p{^Category=-_Final_punctuation}', "");
    Expect(0, 11809, '\P{Category=-_Final_punctuation}', "");
    Expect(1, 11809, '\P{^Category=-_Final_punctuation}', "");
    Expect(0, 11810, '\p{Category=-_Final_punctuation}', "");
    Expect(1, 11810, '\p{^Category=-_Final_punctuation}', "");
    Expect(1, 11810, '\P{Category=-_Final_punctuation}', "");
    Expect(0, 11810, '\P{^Category=-_Final_punctuation}', "");
    Error('\p{Is_General_Category=--PF:=}');
    Error('\P{Is_General_Category=--PF:=}');
    Expect(1, 11809, '\p{Is_General_Category=pf}', "");
    Expect(0, 11809, '\p{^Is_General_Category=pf}', "");
    Expect(0, 11809, '\P{Is_General_Category=pf}', "");
    Expect(1, 11809, '\P{^Is_General_Category=pf}', "");
    Expect(0, 11810, '\p{Is_General_Category=pf}', "");
    Expect(1, 11810, '\p{^Is_General_Category=pf}', "");
    Expect(1, 11810, '\P{Is_General_Category=pf}', "");
    Expect(0, 11810, '\P{^Is_General_Category=pf}', "");
    Expect(1, 11809, '\p{Is_General_Category= Pf}', "");
    Expect(0, 11809, '\p{^Is_General_Category= Pf}', "");
    Expect(0, 11809, '\P{Is_General_Category= Pf}', "");
    Expect(1, 11809, '\P{^Is_General_Category= Pf}', "");
    Expect(0, 11810, '\p{Is_General_Category= Pf}', "");
    Expect(1, 11810, '\p{^Is_General_Category= Pf}', "");
    Expect(1, 11810, '\P{Is_General_Category= Pf}', "");
    Expect(0, 11810, '\P{^Is_General_Category= Pf}', "");
    Error('\p{Is_Gc=/a/FINAL_PUNCTUATION}');
    Error('\P{Is_Gc=/a/FINAL_PUNCTUATION}');
    Expect(1, 11809, '\p{Is_Gc=finalpunctuation}', "");
    Expect(0, 11809, '\p{^Is_Gc=finalpunctuation}', "");
    Expect(0, 11809, '\P{Is_Gc=finalpunctuation}', "");
    Expect(1, 11809, '\P{^Is_Gc=finalpunctuation}', "");
    Expect(0, 11810, '\p{Is_Gc=finalpunctuation}', "");
    Expect(1, 11810, '\p{^Is_Gc=finalpunctuation}', "");
    Expect(1, 11810, '\P{Is_Gc=finalpunctuation}', "");
    Expect(0, 11810, '\P{^Is_Gc=finalpunctuation}', "");
    Expect(1, 11809, '\p{Is_Gc=-_final_PUNCTUATION}', "");
    Expect(0, 11809, '\p{^Is_Gc=-_final_PUNCTUATION}', "");
    Expect(0, 11809, '\P{Is_Gc=-_final_PUNCTUATION}', "");
    Expect(1, 11809, '\P{^Is_Gc=-_final_PUNCTUATION}', "");
    Expect(0, 11810, '\p{Is_Gc=-_final_PUNCTUATION}', "");
    Expect(1, 11810, '\p{^Is_Gc=-_final_PUNCTUATION}', "");
    Expect(1, 11810, '\P{Is_Gc=-_final_PUNCTUATION}', "");
    Expect(0, 11810, '\P{^Is_Gc=-_final_PUNCTUATION}', "");
    Error('\p{Is_Category=/a/--pf}');
    Error('\P{Is_Category=/a/--pf}');
    Expect(1, 11809, '\p{Is_Category=pf}', "");
    Expect(0, 11809, '\p{^Is_Category=pf}', "");
    Expect(0, 11809, '\P{Is_Category=pf}', "");
    Expect(1, 11809, '\P{^Is_Category=pf}', "");
    Expect(0, 11810, '\p{Is_Category=pf}', "");
    Expect(1, 11810, '\p{^Is_Category=pf}', "");
    Expect(1, 11810, '\P{Is_Category=pf}', "");
    Expect(0, 11810, '\P{^Is_Category=pf}', "");
    Expect(1, 11809, '\p{Is_Category=- Pf}', "");
    Expect(0, 11809, '\p{^Is_Category=- Pf}', "");
    Expect(0, 11809, '\P{Is_Category=- Pf}', "");
    Expect(1, 11809, '\P{^Is_Category=- Pf}', "");
    Expect(0, 11810, '\p{Is_Category=- Pf}', "");
    Expect(1, 11810, '\p{^Is_Category=- Pf}', "");
    Expect(1, 11810, '\P{Is_Category=- Pf}', "");
    Expect(0, 11810, '\P{^Is_Category=- Pf}', "");
    Error('\p{General_Category=/a/_Initial_Punctuation}');
    Error('\P{General_Category=/a/_Initial_Punctuation}');
    Expect(1, 11808, '\p{General_Category=initialpunctuation}', "");
    Expect(0, 11808, '\p{^General_Category=initialpunctuation}', "");
    Expect(0, 11808, '\P{General_Category=initialpunctuation}', "");
    Expect(1, 11808, '\P{^General_Category=initialpunctuation}', "");
    Expect(0, 11809, '\p{General_Category=initialpunctuation}', "");
    Expect(1, 11809, '\p{^General_Category=initialpunctuation}', "");
    Expect(1, 11809, '\P{General_Category=initialpunctuation}', "");
    Expect(0, 11809, '\P{^General_Category=initialpunctuation}', "");
    Expect(1, 11808, '\p{General_Category=		Initial_PUNCTUATION}', "");
    Expect(0, 11808, '\p{^General_Category=		Initial_PUNCTUATION}', "");
    Expect(0, 11808, '\P{General_Category=		Initial_PUNCTUATION}', "");
    Expect(1, 11808, '\P{^General_Category=		Initial_PUNCTUATION}', "");
    Expect(0, 11809, '\p{General_Category=		Initial_PUNCTUATION}', "");
    Expect(1, 11809, '\p{^General_Category=		Initial_PUNCTUATION}', "");
    Expect(1, 11809, '\P{General_Category=		Initial_PUNCTUATION}', "");
    Expect(0, 11809, '\P{^General_Category=		Initial_PUNCTUATION}', "");
    Error('\p{Gc=- Pi:=}');
    Error('\P{Gc=- Pi:=}');
    Expect(1, 11808, '\p{Gc=pi}', "");
    Expect(0, 11808, '\p{^Gc=pi}', "");
    Expect(0, 11808, '\P{Gc=pi}', "");
    Expect(1, 11808, '\P{^Gc=pi}', "");
    Expect(0, 11809, '\p{Gc=pi}', "");
    Expect(1, 11809, '\p{^Gc=pi}', "");
    Expect(1, 11809, '\P{Gc=pi}', "");
    Expect(0, 11809, '\P{^Gc=pi}', "");
    Expect(1, 11808, '\p{Gc=		Pi}', "");
    Expect(0, 11808, '\p{^Gc=		Pi}', "");
    Expect(0, 11808, '\P{Gc=		Pi}', "");
    Expect(1, 11808, '\P{^Gc=		Pi}', "");
    Expect(0, 11809, '\p{Gc=		Pi}', "");
    Expect(1, 11809, '\p{^Gc=		Pi}', "");
    Expect(1, 11809, '\P{Gc=		Pi}', "");
    Expect(0, 11809, '\P{^Gc=		Pi}', "");
    Error('\p{Category=-:=INITIAL_Punctuation}');
    Error('\P{Category=-:=INITIAL_Punctuation}');
    Expect(1, 11808, '\p{Category=initialpunctuation}', "");
    Expect(0, 11808, '\p{^Category=initialpunctuation}', "");
    Expect(0, 11808, '\P{Category=initialpunctuation}', "");
    Expect(1, 11808, '\P{^Category=initialpunctuation}', "");
    Expect(0, 11809, '\p{Category=initialpunctuation}', "");
    Expect(1, 11809, '\p{^Category=initialpunctuation}', "");
    Expect(1, 11809, '\P{Category=initialpunctuation}', "");
    Expect(0, 11809, '\P{^Category=initialpunctuation}', "");
    Expect(1, 11808, '\p{Category=	-Initial_PUNCTUATION}', "");
    Expect(0, 11808, '\p{^Category=	-Initial_PUNCTUATION}', "");
    Expect(0, 11808, '\P{Category=	-Initial_PUNCTUATION}', "");
    Expect(1, 11808, '\P{^Category=	-Initial_PUNCTUATION}', "");
    Expect(0, 11809, '\p{Category=	-Initial_PUNCTUATION}', "");
    Expect(1, 11809, '\p{^Category=	-Initial_PUNCTUATION}', "");
    Expect(1, 11809, '\P{Category=	-Initial_PUNCTUATION}', "");
    Expect(0, 11809, '\P{^Category=	-Initial_PUNCTUATION}', "");
    Error('\p{Is_General_Category=_/a/pi}');
    Error('\P{Is_General_Category=_/a/pi}');
    Expect(1, 11808, '\p{Is_General_Category=pi}', "");
    Expect(0, 11808, '\p{^Is_General_Category=pi}', "");
    Expect(0, 11808, '\P{Is_General_Category=pi}', "");
    Expect(1, 11808, '\P{^Is_General_Category=pi}', "");
    Expect(0, 11809, '\p{Is_General_Category=pi}', "");
    Expect(1, 11809, '\p{^Is_General_Category=pi}', "");
    Expect(1, 11809, '\P{Is_General_Category=pi}', "");
    Expect(0, 11809, '\P{^Is_General_Category=pi}', "");
    Expect(1, 11808, '\p{Is_General_Category= Pi}', "");
    Expect(0, 11808, '\p{^Is_General_Category= Pi}', "");
    Expect(0, 11808, '\P{Is_General_Category= Pi}', "");
    Expect(1, 11808, '\P{^Is_General_Category= Pi}', "");
    Expect(0, 11809, '\p{Is_General_Category= Pi}', "");
    Expect(1, 11809, '\p{^Is_General_Category= Pi}', "");
    Expect(1, 11809, '\P{Is_General_Category= Pi}', "");
    Expect(0, 11809, '\P{^Is_General_Category= Pi}', "");
    Error('\p{Is_Gc=/a/initial_Punctuation}');
    Error('\P{Is_Gc=/a/initial_Punctuation}');
    Expect(1, 11808, '\p{Is_Gc=initialpunctuation}', "");
    Expect(0, 11808, '\p{^Is_Gc=initialpunctuation}', "");
    Expect(0, 11808, '\P{Is_Gc=initialpunctuation}', "");
    Expect(1, 11808, '\P{^Is_Gc=initialpunctuation}', "");
    Expect(0, 11809, '\p{Is_Gc=initialpunctuation}', "");
    Expect(1, 11809, '\p{^Is_Gc=initialpunctuation}', "");
    Expect(1, 11809, '\P{Is_Gc=initialpunctuation}', "");
    Expect(0, 11809, '\P{^Is_Gc=initialpunctuation}', "");
    Expect(1, 11808, '\p{Is_Gc=--Initial_Punctuation}', "");
    Expect(0, 11808, '\p{^Is_Gc=--Initial_Punctuation}', "");
    Expect(0, 11808, '\P{Is_Gc=--Initial_Punctuation}', "");
    Expect(1, 11808, '\P{^Is_Gc=--Initial_Punctuation}', "");
    Expect(0, 11809, '\p{Is_Gc=--Initial_Punctuation}', "");
    Expect(1, 11809, '\p{^Is_Gc=--Initial_Punctuation}', "");
    Expect(1, 11809, '\P{Is_Gc=--Initial_Punctuation}', "");
    Expect(0, 11809, '\P{^Is_Gc=--Initial_Punctuation}', "");
    Error('\p{Is_Category=_:=Pi}');
    Error('\P{Is_Category=_:=Pi}');
    Expect(1, 11808, '\p{Is_Category=pi}', "");
    Expect(0, 11808, '\p{^Is_Category=pi}', "");
    Expect(0, 11808, '\P{Is_Category=pi}', "");
    Expect(1, 11808, '\P{^Is_Category=pi}', "");
    Expect(0, 11809, '\p{Is_Category=pi}', "");
    Expect(1, 11809, '\p{^Is_Category=pi}', "");
    Expect(1, 11809, '\P{Is_Category=pi}', "");
    Expect(0, 11809, '\P{^Is_Category=pi}', "");
    Expect(1, 11808, '\p{Is_Category:		 pi}', "");
    Expect(0, 11808, '\p{^Is_Category:		 pi}', "");
    Expect(0, 11808, '\P{Is_Category:		 pi}', "");
    Expect(1, 11808, '\P{^Is_Category:		 pi}', "");
    Expect(0, 11809, '\p{Is_Category:		 pi}', "");
    Expect(1, 11809, '\p{^Is_Category:		 pi}', "");
    Expect(1, 11809, '\P{Is_Category:		 pi}', "");
    Expect(0, 11809, '\P{^Is_Category:		 pi}', "");
    Error('\p{General_Category=	/a/other_Punctuation}');
    Error('\P{General_Category=	/a/other_Punctuation}');
    Expect(1, 125279, '\p{General_Category=otherpunctuation}', "");
    Expect(0, 125279, '\p{^General_Category=otherpunctuation}', "");
    Expect(0, 125279, '\P{General_Category=otherpunctuation}', "");
    Expect(1, 125279, '\P{^General_Category=otherpunctuation}', "");
    Expect(0, 125280, '\p{General_Category=otherpunctuation}', "");
    Expect(1, 125280, '\p{^General_Category=otherpunctuation}', "");
    Expect(1, 125280, '\P{General_Category=otherpunctuation}', "");
    Expect(0, 125280, '\P{^General_Category=otherpunctuation}', "");
    Expect(1, 125279, '\p{General_Category=__OTHER_Punctuation}', "");
    Expect(0, 125279, '\p{^General_Category=__OTHER_Punctuation}', "");
    Expect(0, 125279, '\P{General_Category=__OTHER_Punctuation}', "");
    Expect(1, 125279, '\P{^General_Category=__OTHER_Punctuation}', "");
    Expect(0, 125280, '\p{General_Category=__OTHER_Punctuation}', "");
    Expect(1, 125280, '\p{^General_Category=__OTHER_Punctuation}', "");
    Expect(1, 125280, '\P{General_Category=__OTHER_Punctuation}', "");
    Expect(0, 125280, '\P{^General_Category=__OTHER_Punctuation}', "");
    Error('\p{Gc=/a/Po}');
    Error('\P{Gc=/a/Po}');
    Expect(1, 125279, '\p{Gc=po}', "");
    Expect(0, 125279, '\p{^Gc=po}', "");
    Expect(0, 125279, '\P{Gc=po}', "");
    Expect(1, 125279, '\P{^Gc=po}', "");
    Expect(0, 125280, '\p{Gc=po}', "");
    Expect(1, 125280, '\p{^Gc=po}', "");
    Expect(1, 125280, '\P{Gc=po}', "");
    Expect(0, 125280, '\P{^Gc=po}', "");
    Expect(1, 125279, '\p{Gc=	-PO}', "");
    Expect(0, 125279, '\p{^Gc=	-PO}', "");
    Expect(0, 125279, '\P{Gc=	-PO}', "");
    Expect(1, 125279, '\P{^Gc=	-PO}', "");
    Expect(0, 125280, '\p{Gc=	-PO}', "");
    Expect(1, 125280, '\p{^Gc=	-PO}', "");
    Expect(1, 125280, '\P{Gc=	-PO}', "");
    Expect(0, 125280, '\P{^Gc=	-PO}', "");
    Error('\p{Category= 	Other_Punctuation/a/}');
    Error('\P{Category= 	Other_Punctuation/a/}');
    Expect(1, 125279, '\p{Category=otherpunctuation}', "");
    Expect(0, 125279, '\p{^Category=otherpunctuation}', "");
    Expect(0, 125279, '\P{Category=otherpunctuation}', "");
    Expect(1, 125279, '\P{^Category=otherpunctuation}', "");
    Expect(0, 125280, '\p{Category=otherpunctuation}', "");
    Expect(1, 125280, '\p{^Category=otherpunctuation}', "");
    Expect(1, 125280, '\P{Category=otherpunctuation}', "");
    Expect(0, 125280, '\P{^Category=otherpunctuation}', "");
    Expect(1, 125279, '\p{Category:   --other_PUNCTUATION}', "");
    Expect(0, 125279, '\p{^Category:   --other_PUNCTUATION}', "");
    Expect(0, 125279, '\P{Category:   --other_PUNCTUATION}', "");
    Expect(1, 125279, '\P{^Category:   --other_PUNCTUATION}', "");
    Expect(0, 125280, '\p{Category:   --other_PUNCTUATION}', "");
    Expect(1, 125280, '\p{^Category:   --other_PUNCTUATION}', "");
    Expect(1, 125280, '\P{Category:   --other_PUNCTUATION}', "");
    Expect(0, 125280, '\P{^Category:   --other_PUNCTUATION}', "");
    Error('\p{Is_General_Category=--po:=}');
    Error('\P{Is_General_Category=--po:=}');
    Expect(1, 125279, '\p{Is_General_Category=po}', "");
    Expect(0, 125279, '\p{^Is_General_Category=po}', "");
    Expect(0, 125279, '\P{Is_General_Category=po}', "");
    Expect(1, 125279, '\P{^Is_General_Category=po}', "");
    Expect(0, 125280, '\p{Is_General_Category=po}', "");
    Expect(1, 125280, '\p{^Is_General_Category=po}', "");
    Expect(1, 125280, '\P{Is_General_Category=po}', "");
    Expect(0, 125280, '\P{^Is_General_Category=po}', "");
    Expect(1, 125279, '\p{Is_General_Category=		Po}', "");
    Expect(0, 125279, '\p{^Is_General_Category=		Po}', "");
    Expect(0, 125279, '\P{Is_General_Category=		Po}', "");
    Expect(1, 125279, '\P{^Is_General_Category=		Po}', "");
    Expect(0, 125280, '\p{Is_General_Category=		Po}', "");
    Expect(1, 125280, '\p{^Is_General_Category=		Po}', "");
    Expect(1, 125280, '\P{Is_General_Category=		Po}', "");
    Expect(0, 125280, '\P{^Is_General_Category=		Po}', "");
    Error('\p{Is_Gc=_-OTHER_punctuation/a/}');
    Error('\P{Is_Gc=_-OTHER_punctuation/a/}');
    Expect(1, 125279, '\p{Is_Gc=otherpunctuation}', "");
    Expect(0, 125279, '\p{^Is_Gc=otherpunctuation}', "");
    Expect(0, 125279, '\P{Is_Gc=otherpunctuation}', "");
    Expect(1, 125279, '\P{^Is_Gc=otherpunctuation}', "");
    Expect(0, 125280, '\p{Is_Gc=otherpunctuation}', "");
    Expect(1, 125280, '\p{^Is_Gc=otherpunctuation}', "");
    Expect(1, 125280, '\P{Is_Gc=otherpunctuation}', "");
    Expect(0, 125280, '\P{^Is_Gc=otherpunctuation}', "");
    Expect(1, 125279, '\p{Is_Gc= other_PUNCTUATION}', "");
    Expect(0, 125279, '\p{^Is_Gc= other_PUNCTUATION}', "");
    Expect(0, 125279, '\P{Is_Gc= other_PUNCTUATION}', "");
    Expect(1, 125279, '\P{^Is_Gc= other_PUNCTUATION}', "");
    Expect(0, 125280, '\p{Is_Gc= other_PUNCTUATION}', "");
    Expect(1, 125280, '\p{^Is_Gc= other_PUNCTUATION}', "");
    Expect(1, 125280, '\P{Is_Gc= other_PUNCTUATION}', "");
    Expect(0, 125280, '\P{^Is_Gc= other_PUNCTUATION}', "");
    Error('\p{Is_Category=/a/Po}');
    Error('\P{Is_Category=/a/Po}');
    Expect(1, 125279, '\p{Is_Category=po}', "");
    Expect(0, 125279, '\p{^Is_Category=po}', "");
    Expect(0, 125279, '\P{Is_Category=po}', "");
    Expect(1, 125279, '\P{^Is_Category=po}', "");
    Expect(0, 125280, '\p{Is_Category=po}', "");
    Expect(1, 125280, '\p{^Is_Category=po}', "");
    Expect(1, 125280, '\P{Is_Category=po}', "");
    Expect(0, 125280, '\P{^Is_Category=po}', "");
    Expect(1, 125279, '\p{Is_Category=	Po}', "");
    Expect(0, 125279, '\p{^Is_Category=	Po}', "");
    Expect(0, 125279, '\P{Is_Category=	Po}', "");
    Expect(1, 125279, '\P{^Is_Category=	Po}', "");
    Expect(0, 125280, '\p{Is_Category=	Po}', "");
    Expect(1, 125280, '\p{^Is_Category=	Po}', "");
    Expect(1, 125280, '\P{Is_Category=	Po}', "");
    Expect(0, 125280, '\P{^Is_Category=	Po}', "");
    Error('\p{General_Category:	/a/-_Open_punctuation}');
    Error('\P{General_Category:	/a/-_Open_punctuation}');
    Expect(1, 65378, '\p{General_Category=openpunctuation}', "");
    Expect(0, 65378, '\p{^General_Category=openpunctuation}', "");
    Expect(0, 65378, '\P{General_Category=openpunctuation}', "");
    Expect(1, 65378, '\P{^General_Category=openpunctuation}', "");
    Expect(0, 65379, '\p{General_Category=openpunctuation}', "");
    Expect(1, 65379, '\p{^General_Category=openpunctuation}', "");
    Expect(1, 65379, '\P{General_Category=openpunctuation}', "");
    Expect(0, 65379, '\P{^General_Category=openpunctuation}', "");
    Expect(1, 65378, '\p{General_Category=_open_punctuation}', "");
    Expect(0, 65378, '\p{^General_Category=_open_punctuation}', "");
    Expect(0, 65378, '\P{General_Category=_open_punctuation}', "");
    Expect(1, 65378, '\P{^General_Category=_open_punctuation}', "");
    Expect(0, 65379, '\p{General_Category=_open_punctuation}', "");
    Expect(1, 65379, '\p{^General_Category=_open_punctuation}', "");
    Expect(1, 65379, '\P{General_Category=_open_punctuation}', "");
    Expect(0, 65379, '\P{^General_Category=_open_punctuation}', "");
    Error('\p{Gc=- ps:=}');
    Error('\P{Gc=- ps:=}');
    Expect(1, 65378, '\p{Gc=ps}', "");
    Expect(0, 65378, '\p{^Gc=ps}', "");
    Expect(0, 65378, '\P{Gc=ps}', "");
    Expect(1, 65378, '\P{^Gc=ps}', "");
    Expect(0, 65379, '\p{Gc=ps}', "");
    Expect(1, 65379, '\p{^Gc=ps}', "");
    Expect(1, 65379, '\P{Gc=ps}', "");
    Expect(0, 65379, '\P{^Gc=ps}', "");
    Expect(1, 65378, '\p{Gc=_	Ps}', "");
    Expect(0, 65378, '\p{^Gc=_	Ps}', "");
    Expect(0, 65378, '\P{Gc=_	Ps}', "");
    Expect(1, 65378, '\P{^Gc=_	Ps}', "");
    Expect(0, 65379, '\p{Gc=_	Ps}', "");
    Expect(1, 65379, '\p{^Gc=_	Ps}', "");
    Expect(1, 65379, '\P{Gc=_	Ps}', "");
    Expect(0, 65379, '\P{^Gc=_	Ps}', "");
    Error('\p{Category=:= Open_PUNCTUATION}');
    Error('\P{Category=:= Open_PUNCTUATION}');
    Expect(1, 65378, '\p{Category=openpunctuation}', "");
    Expect(0, 65378, '\p{^Category=openpunctuation}', "");
    Expect(0, 65378, '\P{Category=openpunctuation}', "");
    Expect(1, 65378, '\P{^Category=openpunctuation}', "");
    Expect(0, 65379, '\p{Category=openpunctuation}', "");
    Expect(1, 65379, '\p{^Category=openpunctuation}', "");
    Expect(1, 65379, '\P{Category=openpunctuation}', "");
    Expect(0, 65379, '\P{^Category=openpunctuation}', "");
    Expect(1, 65378, '\p{Category:   _Open_punctuation}', "");
    Expect(0, 65378, '\p{^Category:   _Open_punctuation}', "");
    Expect(0, 65378, '\P{Category:   _Open_punctuation}', "");
    Expect(1, 65378, '\P{^Category:   _Open_punctuation}', "");
    Expect(0, 65379, '\p{Category:   _Open_punctuation}', "");
    Expect(1, 65379, '\p{^Category:   _Open_punctuation}', "");
    Expect(1, 65379, '\P{Category:   _Open_punctuation}', "");
    Expect(0, 65379, '\P{^Category:   _Open_punctuation}', "");
    Error('\p{Is_General_Category= /a/Ps}');
    Error('\P{Is_General_Category= /a/Ps}');
    Expect(1, 65378, '\p{Is_General_Category=ps}', "");
    Expect(0, 65378, '\p{^Is_General_Category=ps}', "");
    Expect(0, 65378, '\P{Is_General_Category=ps}', "");
    Expect(1, 65378, '\P{^Is_General_Category=ps}', "");
    Expect(0, 65379, '\p{Is_General_Category=ps}', "");
    Expect(1, 65379, '\p{^Is_General_Category=ps}', "");
    Expect(1, 65379, '\P{Is_General_Category=ps}', "");
    Expect(0, 65379, '\P{^Is_General_Category=ps}', "");
    Expect(1, 65378, '\p{Is_General_Category=_Ps}', "");
    Expect(0, 65378, '\p{^Is_General_Category=_Ps}', "");
    Expect(0, 65378, '\P{Is_General_Category=_Ps}', "");
    Expect(1, 65378, '\P{^Is_General_Category=_Ps}', "");
    Expect(0, 65379, '\p{Is_General_Category=_Ps}', "");
    Expect(1, 65379, '\p{^Is_General_Category=_Ps}', "");
    Expect(1, 65379, '\P{Is_General_Category=_Ps}', "");
    Expect(0, 65379, '\P{^Is_General_Category=_Ps}', "");
    Error('\p{Is_Gc= -open_PUNCTUATION:=}');
    Error('\P{Is_Gc= -open_PUNCTUATION:=}');
    Expect(1, 65378, '\p{Is_Gc=openpunctuation}', "");
    Expect(0, 65378, '\p{^Is_Gc=openpunctuation}', "");
    Expect(0, 65378, '\P{Is_Gc=openpunctuation}', "");
    Expect(1, 65378, '\P{^Is_Gc=openpunctuation}', "");
    Expect(0, 65379, '\p{Is_Gc=openpunctuation}', "");
    Expect(1, 65379, '\p{^Is_Gc=openpunctuation}', "");
    Expect(1, 65379, '\P{Is_Gc=openpunctuation}', "");
    Expect(0, 65379, '\P{^Is_Gc=openpunctuation}', "");
    Expect(1, 65378, '\p{Is_Gc=  Open_Punctuation}', "");
    Expect(0, 65378, '\p{^Is_Gc=  Open_Punctuation}', "");
    Expect(0, 65378, '\P{Is_Gc=  Open_Punctuation}', "");
    Expect(1, 65378, '\P{^Is_Gc=  Open_Punctuation}', "");
    Expect(0, 65379, '\p{Is_Gc=  Open_Punctuation}', "");
    Expect(1, 65379, '\p{^Is_Gc=  Open_Punctuation}', "");
    Expect(1, 65379, '\P{Is_Gc=  Open_Punctuation}', "");
    Expect(0, 65379, '\P{^Is_Gc=  Open_Punctuation}', "");
    Error('\p{Is_Category=__Ps/a/}');
    Error('\P{Is_Category=__Ps/a/}');
    Expect(1, 65378, '\p{Is_Category:	ps}', "");
    Expect(0, 65378, '\p{^Is_Category:	ps}', "");
    Expect(0, 65378, '\P{Is_Category:	ps}', "");
    Expect(1, 65378, '\P{^Is_Category:	ps}', "");
    Expect(0, 65379, '\p{Is_Category:	ps}', "");
    Expect(1, 65379, '\p{^Is_Category:	ps}', "");
    Expect(1, 65379, '\P{Is_Category:	ps}', "");
    Expect(0, 65379, '\P{^Is_Category:	ps}', "");
    Expect(1, 65378, '\p{Is_Category=- Ps}', "");
    Expect(0, 65378, '\p{^Is_Category=- Ps}', "");
    Expect(0, 65378, '\P{Is_Category=- Ps}', "");
    Expect(1, 65378, '\P{^Is_Category=- Ps}', "");
    Expect(0, 65379, '\p{Is_Category=- Ps}', "");
    Expect(1, 65379, '\p{^Is_Category=- Ps}', "");
    Expect(1, 65379, '\P{Is_Category=- Ps}', "");
    Expect(0, 65379, '\P{^Is_Category=- Ps}', "");
    Error('\p{General_Category=-/a/Symbol}');
    Error('\P{General_Category=-/a/Symbol}');
    Expect(1, 129510, '\p{General_Category=symbol}', "");
    Expect(0, 129510, '\p{^General_Category=symbol}', "");
    Expect(0, 129510, '\P{General_Category=symbol}', "");
    Expect(1, 129510, '\P{^General_Category=symbol}', "");
    Expect(0, 129511, '\p{General_Category=symbol}', "");
    Expect(1, 129511, '\p{^General_Category=symbol}', "");
    Expect(1, 129511, '\P{General_Category=symbol}', "");
    Expect(0, 129511, '\P{^General_Category=symbol}', "");
    Expect(1, 129510, '\p{General_Category=_ symbol}', "");
    Expect(0, 129510, '\p{^General_Category=_ symbol}', "");
    Expect(0, 129510, '\P{General_Category=_ symbol}', "");
    Expect(1, 129510, '\P{^General_Category=_ symbol}', "");
    Expect(0, 129511, '\p{General_Category=_ symbol}', "");
    Expect(1, 129511, '\p{^General_Category=_ symbol}', "");
    Expect(1, 129511, '\P{General_Category=_ symbol}', "");
    Expect(0, 129511, '\P{^General_Category=_ symbol}', "");
    Error('\p{Gc=-	S/a/}');
    Error('\P{Gc=-	S/a/}');
    Expect(1, 129510, '\p{Gc=s}', "");
    Expect(0, 129510, '\p{^Gc=s}', "");
    Expect(0, 129510, '\P{Gc=s}', "");
    Expect(1, 129510, '\P{^Gc=s}', "");
    Expect(0, 129511, '\p{Gc=s}', "");
    Expect(1, 129511, '\p{^Gc=s}', "");
    Expect(1, 129511, '\P{Gc=s}', "");
    Expect(0, 129511, '\P{^Gc=s}', "");
    Expect(1, 129510, '\p{Gc=	_S}', "");
    Expect(0, 129510, '\p{^Gc=	_S}', "");
    Expect(0, 129510, '\P{Gc=	_S}', "");
    Expect(1, 129510, '\P{^Gc=	_S}', "");
    Expect(0, 129511, '\p{Gc=	_S}', "");
    Expect(1, 129511, '\p{^Gc=	_S}', "");
    Expect(1, 129511, '\P{Gc=	_S}', "");
    Expect(0, 129511, '\P{^Gc=	_S}', "");
    Error('\p{Category=	-SYMBOL:=}');
    Error('\P{Category=	-SYMBOL:=}');
    Expect(1, 129510, '\p{Category:	symbol}', "");
    Expect(0, 129510, '\p{^Category:	symbol}', "");
    Expect(0, 129510, '\P{Category:	symbol}', "");
    Expect(1, 129510, '\P{^Category:	symbol}', "");
    Expect(0, 129511, '\p{Category:	symbol}', "");
    Expect(1, 129511, '\p{^Category:	symbol}', "");
    Expect(1, 129511, '\P{Category:	symbol}', "");
    Expect(0, 129511, '\P{^Category:	symbol}', "");
    Expect(1, 129510, '\p{Category=	_Symbol}', "");
    Expect(0, 129510, '\p{^Category=	_Symbol}', "");
    Expect(0, 129510, '\P{Category=	_Symbol}', "");
    Expect(1, 129510, '\P{^Category=	_Symbol}', "");
    Expect(0, 129511, '\p{Category=	_Symbol}', "");
    Expect(1, 129511, '\p{^Category=	_Symbol}', "");
    Expect(1, 129511, '\P{Category=	_Symbol}', "");
    Expect(0, 129511, '\P{^Category=	_Symbol}', "");
    Error('\p{Is_General_Category=/a/S}');
    Error('\P{Is_General_Category=/a/S}');
    Expect(1, 129510, '\p{Is_General_Category=s}', "");
    Expect(0, 129510, '\p{^Is_General_Category=s}', "");
    Expect(0, 129510, '\P{Is_General_Category=s}', "");
    Expect(1, 129510, '\P{^Is_General_Category=s}', "");
    Expect(0, 129511, '\p{Is_General_Category=s}', "");
    Expect(1, 129511, '\p{^Is_General_Category=s}', "");
    Expect(1, 129511, '\P{Is_General_Category=s}', "");
    Expect(0, 129511, '\P{^Is_General_Category=s}', "");
    Expect(1, 129510, '\p{Is_General_Category=	_S}', "");
    Expect(0, 129510, '\p{^Is_General_Category=	_S}', "");
    Expect(0, 129510, '\P{Is_General_Category=	_S}', "");
    Expect(1, 129510, '\P{^Is_General_Category=	_S}', "");
    Expect(0, 129511, '\p{Is_General_Category=	_S}', "");
    Expect(1, 129511, '\p{^Is_General_Category=	_S}', "");
    Expect(1, 129511, '\P{Is_General_Category=	_S}', "");
    Expect(0, 129511, '\P{^Is_General_Category=	_S}', "");
    Error('\p{Is_Gc:  Symbol/a/}');
    Error('\P{Is_Gc:  Symbol/a/}');
    Expect(1, 129510, '\p{Is_Gc=symbol}', "");
    Expect(0, 129510, '\p{^Is_Gc=symbol}', "");
    Expect(0, 129510, '\P{Is_Gc=symbol}', "");
    Expect(1, 129510, '\P{^Is_Gc=symbol}', "");
    Expect(0, 129511, '\p{Is_Gc=symbol}', "");
    Expect(1, 129511, '\p{^Is_Gc=symbol}', "");
    Expect(1, 129511, '\P{Is_Gc=symbol}', "");
    Expect(0, 129511, '\P{^Is_Gc=symbol}', "");
    Expect(1, 129510, '\p{Is_Gc=_Symbol}', "");
    Expect(0, 129510, '\p{^Is_Gc=_Symbol}', "");
    Expect(0, 129510, '\P{Is_Gc=_Symbol}', "");
    Expect(1, 129510, '\P{^Is_Gc=_Symbol}', "");
    Expect(0, 129511, '\p{Is_Gc=_Symbol}', "");
    Expect(1, 129511, '\p{^Is_Gc=_Symbol}', "");
    Expect(1, 129511, '\P{Is_Gc=_Symbol}', "");
    Expect(0, 129511, '\P{^Is_Gc=_Symbol}', "");
    Error('\p{Is_Category= S:=}');
    Error('\P{Is_Category= S:=}');
    Expect(1, 129510, '\p{Is_Category=s}', "");
    Expect(0, 129510, '\p{^Is_Category=s}', "");
    Expect(0, 129510, '\P{Is_Category=s}', "");
    Expect(1, 129510, '\P{^Is_Category=s}', "");
    Expect(0, 129511, '\p{Is_Category=s}', "");
    Expect(1, 129511, '\p{^Is_Category=s}', "");
    Expect(1, 129511, '\P{Is_Category=s}', "");
    Expect(0, 129511, '\P{^Is_Category=s}', "");
    Expect(1, 129510, '\p{Is_Category=_S}', "");
    Expect(0, 129510, '\p{^Is_Category=_S}', "");
    Expect(0, 129510, '\P{Is_Category=_S}', "");
    Expect(1, 129510, '\P{^Is_Category=_S}', "");
    Expect(0, 129511, '\p{Is_Category=_S}', "");
    Expect(1, 129511, '\p{^Is_Category=_S}', "");
    Expect(1, 129511, '\P{Is_Category=_S}', "");
    Expect(0, 129511, '\P{^Is_Category=_S}', "");
    Error('\p{General_Category=/a/ currency_Symbol}');
    Error('\P{General_Category=/a/ currency_Symbol}');
    Expect(1, 65510, '\p{General_Category=currencysymbol}', "");
    Expect(0, 65510, '\p{^General_Category=currencysymbol}', "");
    Expect(0, 65510, '\P{General_Category=currencysymbol}', "");
    Expect(1, 65510, '\P{^General_Category=currencysymbol}', "");
    Expect(0, 65511, '\p{General_Category=currencysymbol}', "");
    Expect(1, 65511, '\p{^General_Category=currencysymbol}', "");
    Expect(1, 65511, '\P{General_Category=currencysymbol}', "");
    Expect(0, 65511, '\P{^General_Category=currencysymbol}', "");
    Expect(1, 65510, '\p{General_Category= -Currency_Symbol}', "");
    Expect(0, 65510, '\p{^General_Category= -Currency_Symbol}', "");
    Expect(0, 65510, '\P{General_Category= -Currency_Symbol}', "");
    Expect(1, 65510, '\P{^General_Category= -Currency_Symbol}', "");
    Expect(0, 65511, '\p{General_Category= -Currency_Symbol}', "");
    Expect(1, 65511, '\p{^General_Category= -Currency_Symbol}', "");
    Expect(1, 65511, '\P{General_Category= -Currency_Symbol}', "");
    Expect(0, 65511, '\P{^General_Category= -Currency_Symbol}', "");
    Error('\p{Gc=SC:=}');
    Error('\P{Gc=SC:=}');
    Expect(1, 65510, '\p{Gc=sc}', "");
    Expect(0, 65510, '\p{^Gc=sc}', "");
    Expect(0, 65510, '\P{Gc=sc}', "");
    Expect(1, 65510, '\P{^Gc=sc}', "");
    Expect(0, 65511, '\p{Gc=sc}', "");
    Expect(1, 65511, '\p{^Gc=sc}', "");
    Expect(1, 65511, '\P{Gc=sc}', "");
    Expect(0, 65511, '\P{^Gc=sc}', "");
    Expect(1, 65510, '\p{Gc=_ sc}', "");
    Expect(0, 65510, '\p{^Gc=_ sc}', "");
    Expect(0, 65510, '\P{Gc=_ sc}', "");
    Expect(1, 65510, '\P{^Gc=_ sc}', "");
    Expect(0, 65511, '\p{Gc=_ sc}', "");
    Expect(1, 65511, '\p{^Gc=_ sc}', "");
    Expect(1, 65511, '\P{Gc=_ sc}', "");
    Expect(0, 65511, '\P{^Gc=_ sc}', "");
    Error('\p{Category:	/a/-_currency_Symbol}');
    Error('\P{Category:	/a/-_currency_Symbol}');
    Expect(1, 65510, '\p{Category=currencysymbol}', "");
    Expect(0, 65510, '\p{^Category=currencysymbol}', "");
    Expect(0, 65510, '\P{Category=currencysymbol}', "");
    Expect(1, 65510, '\P{^Category=currencysymbol}', "");
    Expect(0, 65511, '\p{Category=currencysymbol}', "");
    Expect(1, 65511, '\p{^Category=currencysymbol}', "");
    Expect(1, 65511, '\P{Category=currencysymbol}', "");
    Expect(0, 65511, '\P{^Category=currencysymbol}', "");
    Expect(1, 65510, '\p{Category=	currency_Symbol}', "");
    Expect(0, 65510, '\p{^Category=	currency_Symbol}', "");
    Expect(0, 65510, '\P{Category=	currency_Symbol}', "");
    Expect(1, 65510, '\P{^Category=	currency_Symbol}', "");
    Expect(0, 65511, '\p{Category=	currency_Symbol}', "");
    Expect(1, 65511, '\p{^Category=	currency_Symbol}', "");
    Expect(1, 65511, '\P{Category=	currency_Symbol}', "");
    Expect(0, 65511, '\P{^Category=	currency_Symbol}', "");
    Error('\p{Is_General_Category=/a/-SC}');
    Error('\P{Is_General_Category=/a/-SC}');
    Expect(1, 65510, '\p{Is_General_Category=sc}', "");
    Expect(0, 65510, '\p{^Is_General_Category=sc}', "");
    Expect(0, 65510, '\P{Is_General_Category=sc}', "");
    Expect(1, 65510, '\P{^Is_General_Category=sc}', "");
    Expect(0, 65511, '\p{Is_General_Category=sc}', "");
    Expect(1, 65511, '\p{^Is_General_Category=sc}', "");
    Expect(1, 65511, '\P{Is_General_Category=sc}', "");
    Expect(0, 65511, '\P{^Is_General_Category=sc}', "");
    Expect(1, 65510, '\p{Is_General_Category= _Sc}', "");
    Expect(0, 65510, '\p{^Is_General_Category= _Sc}', "");
    Expect(0, 65510, '\P{Is_General_Category= _Sc}', "");
    Expect(1, 65510, '\P{^Is_General_Category= _Sc}', "");
    Expect(0, 65511, '\p{Is_General_Category= _Sc}', "");
    Expect(1, 65511, '\p{^Is_General_Category= _Sc}', "");
    Expect(1, 65511, '\P{Is_General_Category= _Sc}', "");
    Expect(0, 65511, '\P{^Is_General_Category= _Sc}', "");
    Error('\p{Is_Gc=-Currency_symbol:=}');
    Error('\P{Is_Gc=-Currency_symbol:=}');
    Expect(1, 65510, '\p{Is_Gc=currencysymbol}', "");
    Expect(0, 65510, '\p{^Is_Gc=currencysymbol}', "");
    Expect(0, 65510, '\P{Is_Gc=currencysymbol}', "");
    Expect(1, 65510, '\P{^Is_Gc=currencysymbol}', "");
    Expect(0, 65511, '\p{Is_Gc=currencysymbol}', "");
    Expect(1, 65511, '\p{^Is_Gc=currencysymbol}', "");
    Expect(1, 65511, '\P{Is_Gc=currencysymbol}', "");
    Expect(0, 65511, '\P{^Is_Gc=currencysymbol}', "");
    Expect(1, 65510, '\p{Is_Gc=_Currency_Symbol}', "");
    Expect(0, 65510, '\p{^Is_Gc=_Currency_Symbol}', "");
    Expect(0, 65510, '\P{Is_Gc=_Currency_Symbol}', "");
    Expect(1, 65510, '\P{^Is_Gc=_Currency_Symbol}', "");
    Expect(0, 65511, '\p{Is_Gc=_Currency_Symbol}', "");
    Expect(1, 65511, '\p{^Is_Gc=_Currency_Symbol}', "");
    Expect(1, 65511, '\P{Is_Gc=_Currency_Symbol}', "");
    Expect(0, 65511, '\P{^Is_Gc=_Currency_Symbol}', "");
    Error('\p{Is_Category=/a/ _SC}');
    Error('\P{Is_Category=/a/ _SC}');
    Expect(1, 65510, '\p{Is_Category=sc}', "");
    Expect(0, 65510, '\p{^Is_Category=sc}', "");
    Expect(0, 65510, '\P{Is_Category=sc}', "");
    Expect(1, 65510, '\P{^Is_Category=sc}', "");
    Expect(0, 65511, '\p{Is_Category=sc}', "");
    Expect(1, 65511, '\p{^Is_Category=sc}', "");
    Expect(1, 65511, '\P{Is_Category=sc}', "");
    Expect(0, 65511, '\P{^Is_Category=sc}', "");
    Expect(1, 65510, '\p{Is_Category=- SC}', "");
    Expect(0, 65510, '\p{^Is_Category=- SC}', "");
    Expect(0, 65510, '\P{Is_Category=- SC}', "");
    Expect(1, 65510, '\P{^Is_Category=- SC}', "");
    Expect(0, 65511, '\p{Is_Category=- SC}', "");
    Expect(1, 65511, '\p{^Is_Category=- SC}', "");
    Expect(1, 65511, '\P{Is_Category=- SC}', "");
    Expect(0, 65511, '\P{^Is_Category=- SC}', "");
    Error('\p{General_Category=/a/-MODIFIER_Symbol}');
    Error('\P{General_Category=/a/-MODIFIER_Symbol}');
    Expect(1, 127999, '\p{General_Category=modifiersymbol}', "");
    Expect(0, 127999, '\p{^General_Category=modifiersymbol}', "");
    Expect(0, 127999, '\P{General_Category=modifiersymbol}', "");
    Expect(1, 127999, '\P{^General_Category=modifiersymbol}', "");
    Expect(0, 128000, '\p{General_Category=modifiersymbol}', "");
    Expect(1, 128000, '\p{^General_Category=modifiersymbol}', "");
    Expect(1, 128000, '\P{General_Category=modifiersymbol}', "");
    Expect(0, 128000, '\P{^General_Category=modifiersymbol}', "");
    Expect(1, 127999, '\p{General_Category= modifier_Symbol}', "");
    Expect(0, 127999, '\p{^General_Category= modifier_Symbol}', "");
    Expect(0, 127999, '\P{General_Category= modifier_Symbol}', "");
    Expect(1, 127999, '\P{^General_Category= modifier_Symbol}', "");
    Expect(0, 128000, '\p{General_Category= modifier_Symbol}', "");
    Expect(1, 128000, '\p{^General_Category= modifier_Symbol}', "");
    Expect(1, 128000, '\P{General_Category= modifier_Symbol}', "");
    Expect(0, 128000, '\P{^General_Category= modifier_Symbol}', "");
    Error('\p{Gc:   	:=sk}');
    Error('\P{Gc:   	:=sk}');
    Expect(1, 127999, '\p{Gc=sk}', "");
    Expect(0, 127999, '\p{^Gc=sk}', "");
    Expect(0, 127999, '\P{Gc=sk}', "");
    Expect(1, 127999, '\P{^Gc=sk}', "");
    Expect(0, 128000, '\p{Gc=sk}', "");
    Expect(1, 128000, '\p{^Gc=sk}', "");
    Expect(1, 128000, '\P{Gc=sk}', "");
    Expect(0, 128000, '\P{^Gc=sk}', "");
    Expect(1, 127999, '\p{Gc=-_Sk}', "");
    Expect(0, 127999, '\p{^Gc=-_Sk}', "");
    Expect(0, 127999, '\P{Gc=-_Sk}', "");
    Expect(1, 127999, '\P{^Gc=-_Sk}', "");
    Expect(0, 128000, '\p{Gc=-_Sk}', "");
    Expect(1, 128000, '\p{^Gc=-_Sk}', "");
    Expect(1, 128000, '\P{Gc=-_Sk}', "");
    Expect(0, 128000, '\P{^Gc=-_Sk}', "");
    Error('\p{Category=_modifier_SYMBOL:=}');
    Error('\P{Category=_modifier_SYMBOL:=}');
    Expect(1, 127999, '\p{Category=modifiersymbol}', "");
    Expect(0, 127999, '\p{^Category=modifiersymbol}', "");
    Expect(0, 127999, '\P{Category=modifiersymbol}', "");
    Expect(1, 127999, '\P{^Category=modifiersymbol}', "");
    Expect(0, 128000, '\p{Category=modifiersymbol}', "");
    Expect(1, 128000, '\p{^Category=modifiersymbol}', "");
    Expect(1, 128000, '\P{Category=modifiersymbol}', "");
    Expect(0, 128000, '\P{^Category=modifiersymbol}', "");
    Expect(1, 127999, '\p{Category=-modifier_symbol}', "");
    Expect(0, 127999, '\p{^Category=-modifier_symbol}', "");
    Expect(0, 127999, '\P{Category=-modifier_symbol}', "");
    Expect(1, 127999, '\P{^Category=-modifier_symbol}', "");
    Expect(0, 128000, '\p{Category=-modifier_symbol}', "");
    Expect(1, 128000, '\p{^Category=-modifier_symbol}', "");
    Expect(1, 128000, '\P{Category=-modifier_symbol}', "");
    Expect(0, 128000, '\P{^Category=-modifier_symbol}', "");
    Error('\p{Is_General_Category=/a/Sk}');
    Error('\P{Is_General_Category=/a/Sk}');
    Expect(1, 127999, '\p{Is_General_Category=sk}', "");
    Expect(0, 127999, '\p{^Is_General_Category=sk}', "");
    Expect(0, 127999, '\P{Is_General_Category=sk}', "");
    Expect(1, 127999, '\P{^Is_General_Category=sk}', "");
    Expect(0, 128000, '\p{Is_General_Category=sk}', "");
    Expect(1, 128000, '\p{^Is_General_Category=sk}', "");
    Expect(1, 128000, '\P{Is_General_Category=sk}', "");
    Expect(0, 128000, '\P{^Is_General_Category=sk}', "");
    Expect(1, 127999, '\p{Is_General_Category=	-sk}', "");
    Expect(0, 127999, '\p{^Is_General_Category=	-sk}', "");
    Expect(0, 127999, '\P{Is_General_Category=	-sk}', "");
    Expect(1, 127999, '\P{^Is_General_Category=	-sk}', "");
    Expect(0, 128000, '\p{Is_General_Category=	-sk}', "");
    Expect(1, 128000, '\p{^Is_General_Category=	-sk}', "");
    Expect(1, 128000, '\P{Is_General_Category=	-sk}', "");
    Expect(0, 128000, '\P{^Is_General_Category=	-sk}', "");
    Error('\p{Is_Gc=/a/_modifier_SYMBOL}');
    Error('\P{Is_Gc=/a/_modifier_SYMBOL}');
    Expect(1, 127999, '\p{Is_Gc=modifiersymbol}', "");
    Expect(0, 127999, '\p{^Is_Gc=modifiersymbol}', "");
    Expect(0, 127999, '\P{Is_Gc=modifiersymbol}', "");
    Expect(1, 127999, '\P{^Is_Gc=modifiersymbol}', "");
    Expect(0, 128000, '\p{Is_Gc=modifiersymbol}', "");
    Expect(1, 128000, '\p{^Is_Gc=modifiersymbol}', "");
    Expect(1, 128000, '\P{Is_Gc=modifiersymbol}', "");
    Expect(0, 128000, '\P{^Is_Gc=modifiersymbol}', "");
    Expect(1, 127999, '\p{Is_Gc=Modifier_symbol}', "");
    Expect(0, 127999, '\p{^Is_Gc=Modifier_symbol}', "");
    Expect(0, 127999, '\P{Is_Gc=Modifier_symbol}', "");
    Expect(1, 127999, '\P{^Is_Gc=Modifier_symbol}', "");
    Expect(0, 128000, '\p{Is_Gc=Modifier_symbol}', "");
    Expect(1, 128000, '\p{^Is_Gc=Modifier_symbol}', "");
    Expect(1, 128000, '\P{Is_Gc=Modifier_symbol}', "");
    Expect(0, 128000, '\P{^Is_Gc=Modifier_symbol}', "");
    Error('\p{Is_Category:		_Sk:=}');
    Error('\P{Is_Category:		_Sk:=}');
    Expect(1, 127999, '\p{Is_Category=sk}', "");
    Expect(0, 127999, '\p{^Is_Category=sk}', "");
    Expect(0, 127999, '\P{Is_Category=sk}', "");
    Expect(1, 127999, '\P{^Is_Category=sk}', "");
    Expect(0, 128000, '\p{Is_Category=sk}', "");
    Expect(1, 128000, '\p{^Is_Category=sk}', "");
    Expect(1, 128000, '\P{Is_Category=sk}', "");
    Expect(0, 128000, '\P{^Is_Category=sk}', "");
    Expect(1, 127999, '\p{Is_Category=	 Sk}', "");
    Expect(0, 127999, '\p{^Is_Category=	 Sk}', "");
    Expect(0, 127999, '\P{Is_Category=	 Sk}', "");
    Expect(1, 127999, '\P{^Is_Category=	 Sk}', "");
    Expect(0, 128000, '\p{Is_Category=	 Sk}', "");
    Expect(1, 128000, '\p{^Is_Category=	 Sk}', "");
    Expect(1, 128000, '\P{Is_Category=	 Sk}', "");
    Expect(0, 128000, '\P{^Is_Category=	 Sk}', "");
    Error('\p{General_Category= :=math_SYMBOL}');
    Error('\P{General_Category= :=math_SYMBOL}');
    Expect(1, 126705, '\p{General_Category=mathsymbol}', "");
    Expect(0, 126705, '\p{^General_Category=mathsymbol}', "");
    Expect(0, 126705, '\P{General_Category=mathsymbol}', "");
    Expect(1, 126705, '\P{^General_Category=mathsymbol}', "");
    Expect(0, 126706, '\p{General_Category=mathsymbol}', "");
    Expect(1, 126706, '\p{^General_Category=mathsymbol}', "");
    Expect(1, 126706, '\P{General_Category=mathsymbol}', "");
    Expect(0, 126706, '\P{^General_Category=mathsymbol}', "");
    Expect(1, 126705, '\p{General_Category=	math_SYMBOL}', "");
    Expect(0, 126705, '\p{^General_Category=	math_SYMBOL}', "");
    Expect(0, 126705, '\P{General_Category=	math_SYMBOL}', "");
    Expect(1, 126705, '\P{^General_Category=	math_SYMBOL}', "");
    Expect(0, 126706, '\p{General_Category=	math_SYMBOL}', "");
    Expect(1, 126706, '\p{^General_Category=	math_SYMBOL}', "");
    Expect(1, 126706, '\P{General_Category=	math_SYMBOL}', "");
    Expect(0, 126706, '\P{^General_Category=	math_SYMBOL}', "");
    Error('\p{Gc=	/a/SM}');
    Error('\P{Gc=	/a/SM}');
    Expect(1, 126705, '\p{Gc=sm}', "");
    Expect(0, 126705, '\p{^Gc=sm}', "");
    Expect(0, 126705, '\P{Gc=sm}', "");
    Expect(1, 126705, '\P{^Gc=sm}', "");
    Expect(0, 126706, '\p{Gc=sm}', "");
    Expect(1, 126706, '\p{^Gc=sm}', "");
    Expect(1, 126706, '\P{Gc=sm}', "");
    Expect(0, 126706, '\P{^Gc=sm}', "");
    Expect(1, 126705, '\p{Gc=_-Sm}', "");
    Expect(0, 126705, '\p{^Gc=_-Sm}', "");
    Expect(0, 126705, '\P{Gc=_-Sm}', "");
    Expect(1, 126705, '\P{^Gc=_-Sm}', "");
    Expect(0, 126706, '\p{Gc=_-Sm}', "");
    Expect(1, 126706, '\p{^Gc=_-Sm}', "");
    Expect(1, 126706, '\P{Gc=_-Sm}', "");
    Expect(0, 126706, '\P{^Gc=_-Sm}', "");
    Error('\p{Category=_:=Math_symbol}');
    Error('\P{Category=_:=Math_symbol}');
    Expect(1, 126705, '\p{Category=mathsymbol}', "");
    Expect(0, 126705, '\p{^Category=mathsymbol}', "");
    Expect(0, 126705, '\P{Category=mathsymbol}', "");
    Expect(1, 126705, '\P{^Category=mathsymbol}', "");
    Expect(0, 126706, '\p{Category=mathsymbol}', "");
    Expect(1, 126706, '\p{^Category=mathsymbol}', "");
    Expect(1, 126706, '\P{Category=mathsymbol}', "");
    Expect(0, 126706, '\P{^Category=mathsymbol}', "");
    Expect(1, 126705, '\p{Category= _Math_Symbol}', "");
    Expect(0, 126705, '\p{^Category= _Math_Symbol}', "");
    Expect(0, 126705, '\P{Category= _Math_Symbol}', "");
    Expect(1, 126705, '\P{^Category= _Math_Symbol}', "");
    Expect(0, 126706, '\p{Category= _Math_Symbol}', "");
    Expect(1, 126706, '\p{^Category= _Math_Symbol}', "");
    Expect(1, 126706, '\P{Category= _Math_Symbol}', "");
    Expect(0, 126706, '\P{^Category= _Math_Symbol}', "");
    Error('\p{Is_General_Category=:=  sm}');
    Error('\P{Is_General_Category=:=  sm}');
    Expect(1, 126705, '\p{Is_General_Category=sm}', "");
    Expect(0, 126705, '\p{^Is_General_Category=sm}', "");
    Expect(0, 126705, '\P{Is_General_Category=sm}', "");
    Expect(1, 126705, '\P{^Is_General_Category=sm}', "");
    Expect(0, 126706, '\p{Is_General_Category=sm}', "");
    Expect(1, 126706, '\p{^Is_General_Category=sm}', "");
    Expect(1, 126706, '\P{Is_General_Category=sm}', "");
    Expect(0, 126706, '\P{^Is_General_Category=sm}', "");
    Expect(1, 126705, '\p{Is_General_Category: SM}', "");
    Expect(0, 126705, '\p{^Is_General_Category: SM}', "");
    Expect(0, 126705, '\P{Is_General_Category: SM}', "");
    Expect(1, 126705, '\P{^Is_General_Category: SM}', "");
    Expect(0, 126706, '\p{Is_General_Category: SM}', "");
    Expect(1, 126706, '\p{^Is_General_Category: SM}', "");
    Expect(1, 126706, '\P{Is_General_Category: SM}', "");
    Expect(0, 126706, '\P{^Is_General_Category: SM}', "");
    Error('\p{Is_Gc= :=Math_symbol}');
    Error('\P{Is_Gc= :=Math_symbol}');
    Expect(1, 126705, '\p{Is_Gc=mathsymbol}', "");
    Expect(0, 126705, '\p{^Is_Gc=mathsymbol}', "");
    Expect(0, 126705, '\P{Is_Gc=mathsymbol}', "");
    Expect(1, 126705, '\P{^Is_Gc=mathsymbol}', "");
    Expect(0, 126706, '\p{Is_Gc=mathsymbol}', "");
    Expect(1, 126706, '\p{^Is_Gc=mathsymbol}', "");
    Expect(1, 126706, '\P{Is_Gc=mathsymbol}', "");
    Expect(0, 126706, '\P{^Is_Gc=mathsymbol}', "");
    Expect(1, 126705, '\p{Is_Gc=_ Math_SYMBOL}', "");
    Expect(0, 126705, '\p{^Is_Gc=_ Math_SYMBOL}', "");
    Expect(0, 126705, '\P{Is_Gc=_ Math_SYMBOL}', "");
    Expect(1, 126705, '\P{^Is_Gc=_ Math_SYMBOL}', "");
    Expect(0, 126706, '\p{Is_Gc=_ Math_SYMBOL}', "");
    Expect(1, 126706, '\p{^Is_Gc=_ Math_SYMBOL}', "");
    Expect(1, 126706, '\P{Is_Gc=_ Math_SYMBOL}', "");
    Expect(0, 126706, '\P{^Is_Gc=_ Math_SYMBOL}', "");
    Error('\p{Is_Category:--SM/a/}');
    Error('\P{Is_Category:--SM/a/}');
    Expect(1, 126705, '\p{Is_Category=sm}', "");
    Expect(0, 126705, '\p{^Is_Category=sm}', "");
    Expect(0, 126705, '\P{Is_Category=sm}', "");
    Expect(1, 126705, '\P{^Is_Category=sm}', "");
    Expect(0, 126706, '\p{Is_Category=sm}', "");
    Expect(1, 126706, '\p{^Is_Category=sm}', "");
    Expect(1, 126706, '\P{Is_Category=sm}', "");
    Expect(0, 126706, '\P{^Is_Category=sm}', "");
    Expect(1, 126705, '\p{Is_Category=_sm}', "");
    Expect(0, 126705, '\p{^Is_Category=_sm}', "");
    Expect(0, 126705, '\P{Is_Category=_sm}', "");
    Expect(1, 126705, '\P{^Is_Category=_sm}', "");
    Expect(0, 126706, '\p{Is_Category=_sm}', "");
    Expect(1, 126706, '\p{^Is_Category=_sm}', "");
    Expect(1, 126706, '\P{Is_Category=_sm}', "");
    Expect(0, 126706, '\P{^Is_Category=_sm}', "");
    Error('\p{General_Category=:=	 other_symbol}');
    Error('\P{General_Category=:=	 other_symbol}');
    Expect(1, 129510, '\p{General_Category=othersymbol}', "");
    Expect(0, 129510, '\p{^General_Category=othersymbol}', "");
    Expect(0, 129510, '\P{General_Category=othersymbol}', "");
    Expect(1, 129510, '\P{^General_Category=othersymbol}', "");
    Expect(0, 129511, '\p{General_Category=othersymbol}', "");
    Expect(1, 129511, '\p{^General_Category=othersymbol}', "");
    Expect(1, 129511, '\P{General_Category=othersymbol}', "");
    Expect(0, 129511, '\P{^General_Category=othersymbol}', "");
    Expect(1, 129510, '\p{General_Category= -OTHER_SYMBOL}', "");
    Expect(0, 129510, '\p{^General_Category= -OTHER_SYMBOL}', "");
    Expect(0, 129510, '\P{General_Category= -OTHER_SYMBOL}', "");
    Expect(1, 129510, '\P{^General_Category= -OTHER_SYMBOL}', "");
    Expect(0, 129511, '\p{General_Category= -OTHER_SYMBOL}', "");
    Expect(1, 129511, '\p{^General_Category= -OTHER_SYMBOL}', "");
    Expect(1, 129511, '\P{General_Category= -OTHER_SYMBOL}', "");
    Expect(0, 129511, '\P{^General_Category= -OTHER_SYMBOL}', "");
    Error('\p{Gc=:=-So}');
    Error('\P{Gc=:=-So}');
    Expect(1, 129510, '\p{Gc=so}', "");
    Expect(0, 129510, '\p{^Gc=so}', "");
    Expect(0, 129510, '\P{Gc=so}', "");
    Expect(1, 129510, '\P{^Gc=so}', "");
    Expect(0, 129511, '\p{Gc=so}', "");
    Expect(1, 129511, '\p{^Gc=so}', "");
    Expect(1, 129511, '\P{Gc=so}', "");
    Expect(0, 129511, '\P{^Gc=so}', "");
    Expect(1, 129510, '\p{Gc=-	SO}', "");
    Expect(0, 129510, '\p{^Gc=-	SO}', "");
    Expect(0, 129510, '\P{Gc=-	SO}', "");
    Expect(1, 129510, '\P{^Gc=-	SO}', "");
    Expect(0, 129511, '\p{Gc=-	SO}', "");
    Expect(1, 129511, '\p{^Gc=-	SO}', "");
    Expect(1, 129511, '\P{Gc=-	SO}', "");
    Expect(0, 129511, '\P{^Gc=-	SO}', "");
    Error('\p{Category=:=	-Other_Symbol}');
    Error('\P{Category=:=	-Other_Symbol}');
    Expect(1, 129510, '\p{Category=othersymbol}', "");
    Expect(0, 129510, '\p{^Category=othersymbol}', "");
    Expect(0, 129510, '\P{Category=othersymbol}', "");
    Expect(1, 129510, '\P{^Category=othersymbol}', "");
    Expect(0, 129511, '\p{Category=othersymbol}', "");
    Expect(1, 129511, '\p{^Category=othersymbol}', "");
    Expect(1, 129511, '\P{Category=othersymbol}', "");
    Expect(0, 129511, '\P{^Category=othersymbol}', "");
    Expect(1, 129510, '\p{Category= _OTHER_symbol}', "");
    Expect(0, 129510, '\p{^Category= _OTHER_symbol}', "");
    Expect(0, 129510, '\P{Category= _OTHER_symbol}', "");
    Expect(1, 129510, '\P{^Category= _OTHER_symbol}', "");
    Expect(0, 129511, '\p{Category= _OTHER_symbol}', "");
    Expect(1, 129511, '\p{^Category= _OTHER_symbol}', "");
    Expect(1, 129511, '\P{Category= _OTHER_symbol}', "");
    Expect(0, 129511, '\P{^Category= _OTHER_symbol}', "");
    Error('\p{Is_General_Category=--So:=}');
    Error('\P{Is_General_Category=--So:=}');
    Expect(1, 129510, '\p{Is_General_Category=so}', "");
    Expect(0, 129510, '\p{^Is_General_Category=so}', "");
    Expect(0, 129510, '\P{Is_General_Category=so}', "");
    Expect(1, 129510, '\P{^Is_General_Category=so}', "");
    Expect(0, 129511, '\p{Is_General_Category=so}', "");
    Expect(1, 129511, '\p{^Is_General_Category=so}', "");
    Expect(1, 129511, '\P{Is_General_Category=so}', "");
    Expect(0, 129511, '\P{^Is_General_Category=so}', "");
    Expect(1, 129510, '\p{Is_General_Category= 	So}', "");
    Expect(0, 129510, '\p{^Is_General_Category= 	So}', "");
    Expect(0, 129510, '\P{Is_General_Category= 	So}', "");
    Expect(1, 129510, '\P{^Is_General_Category= 	So}', "");
    Expect(0, 129511, '\p{Is_General_Category= 	So}', "");
    Expect(1, 129511, '\p{^Is_General_Category= 	So}', "");
    Expect(1, 129511, '\P{Is_General_Category= 	So}', "");
    Expect(0, 129511, '\P{^Is_General_Category= 	So}', "");
    Error('\p{Is_Gc=:=	-Other_Symbol}');
    Error('\P{Is_Gc=:=	-Other_Symbol}');
    Expect(1, 129510, '\p{Is_Gc=othersymbol}', "");
    Expect(0, 129510, '\p{^Is_Gc=othersymbol}', "");
    Expect(0, 129510, '\P{Is_Gc=othersymbol}', "");
    Expect(1, 129510, '\P{^Is_Gc=othersymbol}', "");
    Expect(0, 129511, '\p{Is_Gc=othersymbol}', "");
    Expect(1, 129511, '\p{^Is_Gc=othersymbol}', "");
    Expect(1, 129511, '\P{Is_Gc=othersymbol}', "");
    Expect(0, 129511, '\P{^Is_Gc=othersymbol}', "");
    Expect(1, 129510, '\p{Is_Gc=__Other_symbol}', "");
    Expect(0, 129510, '\p{^Is_Gc=__Other_symbol}', "");
    Expect(0, 129510, '\P{Is_Gc=__Other_symbol}', "");
    Expect(1, 129510, '\P{^Is_Gc=__Other_symbol}', "");
    Expect(0, 129511, '\p{Is_Gc=__Other_symbol}', "");
    Expect(1, 129511, '\p{^Is_Gc=__Other_symbol}', "");
    Expect(1, 129511, '\P{Is_Gc=__Other_symbol}', "");
    Expect(0, 129511, '\P{^Is_Gc=__Other_symbol}', "");
    Error('\p{Is_Category=/a/-So}');
    Error('\P{Is_Category=/a/-So}');
    Expect(1, 129510, '\p{Is_Category=so}', "");
    Expect(0, 129510, '\p{^Is_Category=so}', "");
    Expect(0, 129510, '\P{Is_Category=so}', "");
    Expect(1, 129510, '\P{^Is_Category=so}', "");
    Expect(0, 129511, '\p{Is_Category=so}', "");
    Expect(1, 129511, '\p{^Is_Category=so}', "");
    Expect(1, 129511, '\P{Is_Category=so}', "");
    Expect(0, 129511, '\P{^Is_Category=so}', "");
    Expect(1, 129510, '\p{Is_Category=-	SO}', "");
    Expect(0, 129510, '\p{^Is_Category=-	SO}', "");
    Expect(0, 129510, '\P{Is_Category=-	SO}', "");
    Expect(1, 129510, '\P{^Is_Category=-	SO}', "");
    Expect(0, 129511, '\p{Is_Category=-	SO}', "");
    Expect(1, 129511, '\p{^Is_Category=-	SO}', "");
    Expect(1, 129511, '\P{Is_Category=-	SO}', "");
    Expect(0, 129511, '\P{^Is_Category=-	SO}', "");
    Error('\p{General_Category=/a/Separator}');
    Error('\P{General_Category=/a/Separator}');
    Expect(1, 12288, '\p{General_Category=separator}', "");
    Expect(0, 12288, '\p{^General_Category=separator}', "");
    Expect(0, 12288, '\P{General_Category=separator}', "");
    Expect(1, 12288, '\P{^General_Category=separator}', "");
    Expect(0, 12289, '\p{General_Category=separator}', "");
    Expect(1, 12289, '\p{^General_Category=separator}', "");
    Expect(1, 12289, '\P{General_Category=separator}', "");
    Expect(0, 12289, '\P{^General_Category=separator}', "");
    Expect(1, 12288, '\p{General_Category=  separator}', "");
    Expect(0, 12288, '\p{^General_Category=  separator}', "");
    Expect(0, 12288, '\P{General_Category=  separator}', "");
    Expect(1, 12288, '\P{^General_Category=  separator}', "");
    Expect(0, 12289, '\p{General_Category=  separator}', "");
    Expect(1, 12289, '\p{^General_Category=  separator}', "");
    Expect(1, 12289, '\P{General_Category=  separator}', "");
    Expect(0, 12289, '\P{^General_Category=  separator}', "");
    Error('\p{Gc=:=z}');
    Error('\P{Gc=:=z}');
    Expect(1, 12288, '\p{Gc=z}', "");
    Expect(0, 12288, '\p{^Gc=z}', "");
    Expect(0, 12288, '\P{Gc=z}', "");
    Expect(1, 12288, '\P{^Gc=z}', "");
    Expect(0, 12289, '\p{Gc=z}', "");
    Expect(1, 12289, '\p{^Gc=z}', "");
    Expect(1, 12289, '\P{Gc=z}', "");
    Expect(0, 12289, '\P{^Gc=z}', "");
    Expect(1, 12288, '\p{Gc=_-Z}', "");
    Expect(0, 12288, '\p{^Gc=_-Z}', "");
    Expect(0, 12288, '\P{Gc=_-Z}', "");
    Expect(1, 12288, '\P{^Gc=_-Z}', "");
    Expect(0, 12289, '\p{Gc=_-Z}', "");
    Expect(1, 12289, '\p{^Gc=_-Z}', "");
    Expect(1, 12289, '\P{Gc=_-Z}', "");
    Expect(0, 12289, '\P{^Gc=_-Z}', "");
    Error('\p{Category=/a/ 	SEPARATOR}');
    Error('\P{Category=/a/ 	SEPARATOR}');
    Expect(1, 12288, '\p{Category=separator}', "");
    Expect(0, 12288, '\p{^Category=separator}', "");
    Expect(0, 12288, '\P{Category=separator}', "");
    Expect(1, 12288, '\P{^Category=separator}', "");
    Expect(0, 12289, '\p{Category=separator}', "");
    Expect(1, 12289, '\p{^Category=separator}', "");
    Expect(1, 12289, '\P{Category=separator}', "");
    Expect(0, 12289, '\P{^Category=separator}', "");
    Expect(1, 12288, '\p{Category=_-SEPARATOR}', "");
    Expect(0, 12288, '\p{^Category=_-SEPARATOR}', "");
    Expect(0, 12288, '\P{Category=_-SEPARATOR}', "");
    Expect(1, 12288, '\P{^Category=_-SEPARATOR}', "");
    Expect(0, 12289, '\p{Category=_-SEPARATOR}', "");
    Expect(1, 12289, '\p{^Category=_-SEPARATOR}', "");
    Expect(1, 12289, '\P{Category=_-SEPARATOR}', "");
    Expect(0, 12289, '\P{^Category=_-SEPARATOR}', "");
    Error('\p{Is_General_Category=_	Z:=}');
    Error('\P{Is_General_Category=_	Z:=}');
    Expect(1, 12288, '\p{Is_General_Category=z}', "");
    Expect(0, 12288, '\p{^Is_General_Category=z}', "");
    Expect(0, 12288, '\P{Is_General_Category=z}', "");
    Expect(1, 12288, '\P{^Is_General_Category=z}', "");
    Expect(0, 12289, '\p{Is_General_Category=z}', "");
    Expect(1, 12289, '\p{^Is_General_Category=z}', "");
    Expect(1, 12289, '\P{Is_General_Category=z}', "");
    Expect(0, 12289, '\P{^Is_General_Category=z}', "");
    Expect(1, 12288, '\p{Is_General_Category=__Z}', "");
    Expect(0, 12288, '\p{^Is_General_Category=__Z}', "");
    Expect(0, 12288, '\P{Is_General_Category=__Z}', "");
    Expect(1, 12288, '\P{^Is_General_Category=__Z}', "");
    Expect(0, 12289, '\p{Is_General_Category=__Z}', "");
    Expect(1, 12289, '\p{^Is_General_Category=__Z}', "");
    Expect(1, 12289, '\P{Is_General_Category=__Z}', "");
    Expect(0, 12289, '\P{^Is_General_Category=__Z}', "");
    Error('\p{Is_Gc=/a/		Separator}');
    Error('\P{Is_Gc=/a/		Separator}');
    Expect(1, 12288, '\p{Is_Gc=separator}', "");
    Expect(0, 12288, '\p{^Is_Gc=separator}', "");
    Expect(0, 12288, '\P{Is_Gc=separator}', "");
    Expect(1, 12288, '\P{^Is_Gc=separator}', "");
    Expect(0, 12289, '\p{Is_Gc=separator}', "");
    Expect(1, 12289, '\p{^Is_Gc=separator}', "");
    Expect(1, 12289, '\P{Is_Gc=separator}', "");
    Expect(0, 12289, '\P{^Is_Gc=separator}', "");
    Expect(1, 12288, '\p{Is_Gc=	SEPARATOR}', "");
    Expect(0, 12288, '\p{^Is_Gc=	SEPARATOR}', "");
    Expect(0, 12288, '\P{Is_Gc=	SEPARATOR}', "");
    Expect(1, 12288, '\P{^Is_Gc=	SEPARATOR}', "");
    Expect(0, 12289, '\p{Is_Gc=	SEPARATOR}', "");
    Expect(1, 12289, '\p{^Is_Gc=	SEPARATOR}', "");
    Expect(1, 12289, '\P{Is_Gc=	SEPARATOR}', "");
    Expect(0, 12289, '\P{^Is_Gc=	SEPARATOR}', "");
    Error('\p{Is_Category=:=- Z}');
    Error('\P{Is_Category=:=- Z}');
    Expect(1, 12288, '\p{Is_Category=z}', "");
    Expect(0, 12288, '\p{^Is_Category=z}', "");
    Expect(0, 12288, '\P{Is_Category=z}', "");
    Expect(1, 12288, '\P{^Is_Category=z}', "");
    Expect(0, 12289, '\p{Is_Category=z}', "");
    Expect(1, 12289, '\p{^Is_Category=z}', "");
    Expect(1, 12289, '\P{Is_Category=z}', "");
    Expect(0, 12289, '\P{^Is_Category=z}', "");
    Expect(1, 12288, '\p{Is_Category=__z}', "");
    Expect(0, 12288, '\p{^Is_Category=__z}', "");
    Expect(0, 12288, '\P{Is_Category=__z}', "");
    Expect(1, 12288, '\P{^Is_Category=__z}', "");
    Expect(0, 12289, '\p{Is_Category=__z}', "");
    Expect(1, 12289, '\p{^Is_Category=__z}', "");
    Expect(1, 12289, '\P{Is_Category=__z}', "");
    Expect(0, 12289, '\P{^Is_Category=__z}', "");
    Error('\p{General_Category=_/a/line_SEPARATOR}');
    Error('\P{General_Category=_/a/line_SEPARATOR}');
    Expect(1, 8232, '\p{General_Category=lineseparator}', "");
    Expect(0, 8232, '\p{^General_Category=lineseparator}', "");
    Expect(0, 8232, '\P{General_Category=lineseparator}', "");
    Expect(1, 8232, '\P{^General_Category=lineseparator}', "");
    Expect(0, 8233, '\p{General_Category=lineseparator}', "");
    Expect(1, 8233, '\p{^General_Category=lineseparator}', "");
    Expect(1, 8233, '\P{General_Category=lineseparator}', "");
    Expect(0, 8233, '\P{^General_Category=lineseparator}', "");
    Expect(1, 8232, '\p{General_Category=		Line_Separator}', "");
    Expect(0, 8232, '\p{^General_Category=		Line_Separator}', "");
    Expect(0, 8232, '\P{General_Category=		Line_Separator}', "");
    Expect(1, 8232, '\P{^General_Category=		Line_Separator}', "");
    Expect(0, 8233, '\p{General_Category=		Line_Separator}', "");
    Expect(1, 8233, '\p{^General_Category=		Line_Separator}', "");
    Expect(1, 8233, '\P{General_Category=		Line_Separator}', "");
    Expect(0, 8233, '\P{^General_Category=		Line_Separator}', "");
    Error('\p{Gc=/a/__zl}');
    Error('\P{Gc=/a/__zl}');
    Expect(1, 8232, '\p{Gc=zl}', "");
    Expect(0, 8232, '\p{^Gc=zl}', "");
    Expect(0, 8232, '\P{Gc=zl}', "");
    Expect(1, 8232, '\P{^Gc=zl}', "");
    Expect(0, 8233, '\p{Gc=zl}', "");
    Expect(1, 8233, '\p{^Gc=zl}', "");
    Expect(1, 8233, '\P{Gc=zl}', "");
    Expect(0, 8233, '\P{^Gc=zl}', "");
    Expect(1, 8232, '\p{Gc=		Zl}', "");
    Expect(0, 8232, '\p{^Gc=		Zl}', "");
    Expect(0, 8232, '\P{Gc=		Zl}', "");
    Expect(1, 8232, '\P{^Gc=		Zl}', "");
    Expect(0, 8233, '\p{Gc=		Zl}', "");
    Expect(1, 8233, '\p{^Gc=		Zl}', "");
    Expect(1, 8233, '\P{Gc=		Zl}', "");
    Expect(0, 8233, '\P{^Gc=		Zl}', "");
    Error('\p{Category=_ line_SEPARATOR:=}');
    Error('\P{Category=_ line_SEPARATOR:=}');
    Expect(1, 8232, '\p{Category=lineseparator}', "");
    Expect(0, 8232, '\p{^Category=lineseparator}', "");
    Expect(0, 8232, '\P{Category=lineseparator}', "");
    Expect(1, 8232, '\P{^Category=lineseparator}', "");
    Expect(0, 8233, '\p{Category=lineseparator}', "");
    Expect(1, 8233, '\p{^Category=lineseparator}', "");
    Expect(1, 8233, '\P{Category=lineseparator}', "");
    Expect(0, 8233, '\P{^Category=lineseparator}', "");
    Expect(1, 8232, '\p{Category=-	LINE_SEPARATOR}', "");
    Expect(0, 8232, '\p{^Category=-	LINE_SEPARATOR}', "");
    Expect(0, 8232, '\P{Category=-	LINE_SEPARATOR}', "");
    Expect(1, 8232, '\P{^Category=-	LINE_SEPARATOR}', "");
    Expect(0, 8233, '\p{Category=-	LINE_SEPARATOR}', "");
    Expect(1, 8233, '\p{^Category=-	LINE_SEPARATOR}', "");
    Expect(1, 8233, '\P{Category=-	LINE_SEPARATOR}', "");
    Expect(0, 8233, '\P{^Category=-	LINE_SEPARATOR}', "");
    Error('\p{Is_General_Category=	ZL:=}');
    Error('\P{Is_General_Category=	ZL:=}');
    Expect(1, 8232, '\p{Is_General_Category=zl}', "");
    Expect(0, 8232, '\p{^Is_General_Category=zl}', "");
    Expect(0, 8232, '\P{Is_General_Category=zl}', "");
    Expect(1, 8232, '\P{^Is_General_Category=zl}', "");
    Expect(0, 8233, '\p{Is_General_Category=zl}', "");
    Expect(1, 8233, '\p{^Is_General_Category=zl}', "");
    Expect(1, 8233, '\P{Is_General_Category=zl}', "");
    Expect(0, 8233, '\P{^Is_General_Category=zl}', "");
    Expect(1, 8232, '\p{Is_General_Category= _ZL}', "");
    Expect(0, 8232, '\p{^Is_General_Category= _ZL}', "");
    Expect(0, 8232, '\P{Is_General_Category= _ZL}', "");
    Expect(1, 8232, '\P{^Is_General_Category= _ZL}', "");
    Expect(0, 8233, '\p{Is_General_Category= _ZL}', "");
    Expect(1, 8233, '\p{^Is_General_Category= _ZL}', "");
    Expect(1, 8233, '\P{Is_General_Category= _ZL}', "");
    Expect(0, 8233, '\P{^Is_General_Category= _ZL}', "");
    Error('\p{Is_Gc=:=-_Line_separator}');
    Error('\P{Is_Gc=:=-_Line_separator}');
    Expect(1, 8232, '\p{Is_Gc=lineseparator}', "");
    Expect(0, 8232, '\p{^Is_Gc=lineseparator}', "");
    Expect(0, 8232, '\P{Is_Gc=lineseparator}', "");
    Expect(1, 8232, '\P{^Is_Gc=lineseparator}', "");
    Expect(0, 8233, '\p{Is_Gc=lineseparator}', "");
    Expect(1, 8233, '\p{^Is_Gc=lineseparator}', "");
    Expect(1, 8233, '\P{Is_Gc=lineseparator}', "");
    Expect(0, 8233, '\P{^Is_Gc=lineseparator}', "");
    Expect(1, 8232, '\p{Is_Gc=	_Line_SEPARATOR}', "");
    Expect(0, 8232, '\p{^Is_Gc=	_Line_SEPARATOR}', "");
    Expect(0, 8232, '\P{Is_Gc=	_Line_SEPARATOR}', "");
    Expect(1, 8232, '\P{^Is_Gc=	_Line_SEPARATOR}', "");
    Expect(0, 8233, '\p{Is_Gc=	_Line_SEPARATOR}', "");
    Expect(1, 8233, '\p{^Is_Gc=	_Line_SEPARATOR}', "");
    Expect(1, 8233, '\P{Is_Gc=	_Line_SEPARATOR}', "");
    Expect(0, 8233, '\P{^Is_Gc=	_Line_SEPARATOR}', "");
    Error('\p{Is_Category=/a/ZL}');
    Error('\P{Is_Category=/a/ZL}');
    Expect(1, 8232, '\p{Is_Category=zl}', "");
    Expect(0, 8232, '\p{^Is_Category=zl}', "");
    Expect(0, 8232, '\P{Is_Category=zl}', "");
    Expect(1, 8232, '\P{^Is_Category=zl}', "");
    Expect(0, 8233, '\p{Is_Category=zl}', "");
    Expect(1, 8233, '\p{^Is_Category=zl}', "");
    Expect(1, 8233, '\P{Is_Category=zl}', "");
    Expect(0, 8233, '\P{^Is_Category=zl}', "");
    Expect(1, 8232, '\p{Is_Category= zl}', "");
    Expect(0, 8232, '\p{^Is_Category= zl}', "");
    Expect(0, 8232, '\P{Is_Category= zl}', "");
    Expect(1, 8232, '\P{^Is_Category= zl}', "");
    Expect(0, 8233, '\p{Is_Category= zl}', "");
    Expect(1, 8233, '\p{^Is_Category= zl}', "");
    Expect(1, 8233, '\P{Is_Category= zl}', "");
    Expect(0, 8233, '\P{^Is_Category= zl}', "");
    Error('\p{General_Category=/a/_	Paragraph_Separator}');
    Error('\P{General_Category=/a/_	Paragraph_Separator}');
    Expect(1, 8233, '\p{General_Category=paragraphseparator}', "");
    Expect(0, 8233, '\p{^General_Category=paragraphseparator}', "");
    Expect(0, 8233, '\P{General_Category=paragraphseparator}', "");
    Expect(1, 8233, '\P{^General_Category=paragraphseparator}', "");
    Expect(0, 8234, '\p{General_Category=paragraphseparator}', "");
    Expect(1, 8234, '\p{^General_Category=paragraphseparator}', "");
    Expect(1, 8234, '\P{General_Category=paragraphseparator}', "");
    Expect(0, 8234, '\P{^General_Category=paragraphseparator}', "");
    Expect(1, 8233, '\p{General_Category= -Paragraph_separator}', "");
    Expect(0, 8233, '\p{^General_Category= -Paragraph_separator}', "");
    Expect(0, 8233, '\P{General_Category= -Paragraph_separator}', "");
    Expect(1, 8233, '\P{^General_Category= -Paragraph_separator}', "");
    Expect(0, 8234, '\p{General_Category= -Paragraph_separator}', "");
    Expect(1, 8234, '\p{^General_Category= -Paragraph_separator}', "");
    Expect(1, 8234, '\P{General_Category= -Paragraph_separator}', "");
    Expect(0, 8234, '\P{^General_Category= -Paragraph_separator}', "");
    Error('\p{Gc=	:=Zp}');
    Error('\P{Gc=	:=Zp}');
    Expect(1, 8233, '\p{Gc=zp}', "");
    Expect(0, 8233, '\p{^Gc=zp}', "");
    Expect(0, 8233, '\P{Gc=zp}', "");
    Expect(1, 8233, '\P{^Gc=zp}', "");
    Expect(0, 8234, '\p{Gc=zp}', "");
    Expect(1, 8234, '\p{^Gc=zp}', "");
    Expect(1, 8234, '\P{Gc=zp}', "");
    Expect(0, 8234, '\P{^Gc=zp}', "");
    Expect(1, 8233, '\p{Gc=	ZP}', "");
    Expect(0, 8233, '\p{^Gc=	ZP}', "");
    Expect(0, 8233, '\P{Gc=	ZP}', "");
    Expect(1, 8233, '\P{^Gc=	ZP}', "");
    Expect(0, 8234, '\p{Gc=	ZP}', "");
    Expect(1, 8234, '\p{^Gc=	ZP}', "");
    Expect(1, 8234, '\P{Gc=	ZP}', "");
    Expect(0, 8234, '\P{^Gc=	ZP}', "");
    Error('\p{Category=-:=Paragraph_Separator}');
    Error('\P{Category=-:=Paragraph_Separator}');
    Expect(1, 8233, '\p{Category=paragraphseparator}', "");
    Expect(0, 8233, '\p{^Category=paragraphseparator}', "");
    Expect(0, 8233, '\P{Category=paragraphseparator}', "");
    Expect(1, 8233, '\P{^Category=paragraphseparator}', "");
    Expect(0, 8234, '\p{Category=paragraphseparator}', "");
    Expect(1, 8234, '\p{^Category=paragraphseparator}', "");
    Expect(1, 8234, '\P{Category=paragraphseparator}', "");
    Expect(0, 8234, '\P{^Category=paragraphseparator}', "");
    Expect(1, 8233, '\p{Category=_Paragraph_separator}', "");
    Expect(0, 8233, '\p{^Category=_Paragraph_separator}', "");
    Expect(0, 8233, '\P{Category=_Paragraph_separator}', "");
    Expect(1, 8233, '\P{^Category=_Paragraph_separator}', "");
    Expect(0, 8234, '\p{Category=_Paragraph_separator}', "");
    Expect(1, 8234, '\p{^Category=_Paragraph_separator}', "");
    Expect(1, 8234, '\P{Category=_Paragraph_separator}', "");
    Expect(0, 8234, '\P{^Category=_Paragraph_separator}', "");
    Error('\p{Is_General_Category:_	ZP:=}');
    Error('\P{Is_General_Category:_	ZP:=}');
    Expect(1, 8233, '\p{Is_General_Category:zp}', "");
    Expect(0, 8233, '\p{^Is_General_Category:zp}', "");
    Expect(0, 8233, '\P{Is_General_Category:zp}', "");
    Expect(1, 8233, '\P{^Is_General_Category:zp}', "");
    Expect(0, 8234, '\p{Is_General_Category:zp}', "");
    Expect(1, 8234, '\p{^Is_General_Category:zp}', "");
    Expect(1, 8234, '\P{Is_General_Category:zp}', "");
    Expect(0, 8234, '\P{^Is_General_Category:zp}', "");
    Expect(1, 8233, '\p{Is_General_Category:   -zp}', "");
    Expect(0, 8233, '\p{^Is_General_Category:   -zp}', "");
    Expect(0, 8233, '\P{Is_General_Category:   -zp}', "");
    Expect(1, 8233, '\P{^Is_General_Category:   -zp}', "");
    Expect(0, 8234, '\p{Is_General_Category:   -zp}', "");
    Expect(1, 8234, '\p{^Is_General_Category:   -zp}', "");
    Expect(1, 8234, '\P{Is_General_Category:   -zp}', "");
    Expect(0, 8234, '\P{^Is_General_Category:   -zp}', "");
    Error('\p{Is_Gc=-:=PARAGRAPH_SEPARATOR}');
    Error('\P{Is_Gc=-:=PARAGRAPH_SEPARATOR}');
    Expect(1, 8233, '\p{Is_Gc=paragraphseparator}', "");
    Expect(0, 8233, '\p{^Is_Gc=paragraphseparator}', "");
    Expect(0, 8233, '\P{Is_Gc=paragraphseparator}', "");
    Expect(1, 8233, '\P{^Is_Gc=paragraphseparator}', "");
    Expect(0, 8234, '\p{Is_Gc=paragraphseparator}', "");
    Expect(1, 8234, '\p{^Is_Gc=paragraphseparator}', "");
    Expect(1, 8234, '\P{Is_Gc=paragraphseparator}', "");
    Expect(0, 8234, '\P{^Is_Gc=paragraphseparator}', "");
    Expect(1, 8233, '\p{Is_Gc=- Paragraph_Separator}', "");
    Expect(0, 8233, '\p{^Is_Gc=- Paragraph_Separator}', "");
    Expect(0, 8233, '\P{Is_Gc=- Paragraph_Separator}', "");
    Expect(1, 8233, '\P{^Is_Gc=- Paragraph_Separator}', "");
    Expect(0, 8234, '\p{Is_Gc=- Paragraph_Separator}', "");
    Expect(1, 8234, '\p{^Is_Gc=- Paragraph_Separator}', "");
    Expect(1, 8234, '\P{Is_Gc=- Paragraph_Separator}', "");
    Expect(0, 8234, '\P{^Is_Gc=- Paragraph_Separator}', "");
    Error('\p{Is_Category=:=		Zp}');
    Error('\P{Is_Category=:=		Zp}');
    Expect(1, 8233, '\p{Is_Category: zp}', "");
    Expect(0, 8233, '\p{^Is_Category: zp}', "");
    Expect(0, 8233, '\P{Is_Category: zp}', "");
    Expect(1, 8233, '\P{^Is_Category: zp}', "");
    Expect(0, 8234, '\p{Is_Category: zp}', "");
    Expect(1, 8234, '\p{^Is_Category: zp}', "");
    Expect(1, 8234, '\P{Is_Category: zp}', "");
    Expect(0, 8234, '\P{^Is_Category: zp}', "");
    Expect(1, 8233, '\p{Is_Category=_	zp}', "");
    Expect(0, 8233, '\p{^Is_Category=_	zp}', "");
    Expect(0, 8233, '\P{Is_Category=_	zp}', "");
    Expect(1, 8233, '\P{^Is_Category=_	zp}', "");
    Expect(0, 8234, '\p{Is_Category=_	zp}', "");
    Expect(1, 8234, '\p{^Is_Category=_	zp}', "");
    Expect(1, 8234, '\P{Is_Category=_	zp}', "");
    Expect(0, 8234, '\P{^Is_Category=_	zp}', "");
    Error('\p{General_Category=__space_SEPARATOR:=}');
    Error('\P{General_Category=__space_SEPARATOR:=}');
    Expect(1, 12288, '\p{General_Category=spaceseparator}', "");
    Expect(0, 12288, '\p{^General_Category=spaceseparator}', "");
    Expect(0, 12288, '\P{General_Category=spaceseparator}', "");
    Expect(1, 12288, '\P{^General_Category=spaceseparator}', "");
    Expect(0, 12289, '\p{General_Category=spaceseparator}', "");
    Expect(1, 12289, '\p{^General_Category=spaceseparator}', "");
    Expect(1, 12289, '\P{General_Category=spaceseparator}', "");
    Expect(0, 12289, '\P{^General_Category=spaceseparator}', "");
    Expect(1, 12288, '\p{General_Category=-_Space_separator}', "");
    Expect(0, 12288, '\p{^General_Category=-_Space_separator}', "");
    Expect(0, 12288, '\P{General_Category=-_Space_separator}', "");
    Expect(1, 12288, '\P{^General_Category=-_Space_separator}', "");
    Expect(0, 12289, '\p{General_Category=-_Space_separator}', "");
    Expect(1, 12289, '\p{^General_Category=-_Space_separator}', "");
    Expect(1, 12289, '\P{General_Category=-_Space_separator}', "");
    Expect(0, 12289, '\P{^General_Category=-_Space_separator}', "");
    Error('\p{Gc=	:=Zs}');
    Error('\P{Gc=	:=Zs}');
    Expect(1, 12288, '\p{Gc=zs}', "");
    Expect(0, 12288, '\p{^Gc=zs}', "");
    Expect(0, 12288, '\P{Gc=zs}', "");
    Expect(1, 12288, '\P{^Gc=zs}', "");
    Expect(0, 12289, '\p{Gc=zs}', "");
    Expect(1, 12289, '\p{^Gc=zs}', "");
    Expect(1, 12289, '\P{Gc=zs}', "");
    Expect(0, 12289, '\P{^Gc=zs}', "");
    Expect(1, 12288, '\p{Gc=	Zs}', "");
    Expect(0, 12288, '\p{^Gc=	Zs}', "");
    Expect(0, 12288, '\P{Gc=	Zs}', "");
    Expect(1, 12288, '\P{^Gc=	Zs}', "");
    Expect(0, 12289, '\p{Gc=	Zs}', "");
    Expect(1, 12289, '\p{^Gc=	Zs}', "");
    Expect(1, 12289, '\P{Gc=	Zs}', "");
    Expect(0, 12289, '\P{^Gc=	Zs}', "");
    Error('\p{Category=/a/	 Space_separator}');
    Error('\P{Category=/a/	 Space_separator}');
    Expect(1, 12288, '\p{Category=spaceseparator}', "");
    Expect(0, 12288, '\p{^Category=spaceseparator}', "");
    Expect(0, 12288, '\P{Category=spaceseparator}', "");
    Expect(1, 12288, '\P{^Category=spaceseparator}', "");
    Expect(0, 12289, '\p{Category=spaceseparator}', "");
    Expect(1, 12289, '\p{^Category=spaceseparator}', "");
    Expect(1, 12289, '\P{Category=spaceseparator}', "");
    Expect(0, 12289, '\P{^Category=spaceseparator}', "");
    Expect(1, 12288, '\p{Category=- SPACE_Separator}', "");
    Expect(0, 12288, '\p{^Category=- SPACE_Separator}', "");
    Expect(0, 12288, '\P{Category=- SPACE_Separator}', "");
    Expect(1, 12288, '\P{^Category=- SPACE_Separator}', "");
    Expect(0, 12289, '\p{Category=- SPACE_Separator}', "");
    Expect(1, 12289, '\p{^Category=- SPACE_Separator}', "");
    Expect(1, 12289, '\P{Category=- SPACE_Separator}', "");
    Expect(0, 12289, '\P{^Category=- SPACE_Separator}', "");
    Error('\p{Is_General_Category= -ZS:=}');
    Error('\P{Is_General_Category= -ZS:=}');
    Expect(1, 12288, '\p{Is_General_Category=zs}', "");
    Expect(0, 12288, '\p{^Is_General_Category=zs}', "");
    Expect(0, 12288, '\P{Is_General_Category=zs}', "");
    Expect(1, 12288, '\P{^Is_General_Category=zs}', "");
    Expect(0, 12289, '\p{Is_General_Category=zs}', "");
    Expect(1, 12289, '\p{^Is_General_Category=zs}', "");
    Expect(1, 12289, '\P{Is_General_Category=zs}', "");
    Expect(0, 12289, '\P{^Is_General_Category=zs}', "");
    Expect(1, 12288, '\p{Is_General_Category=--Zs}', "");
    Expect(0, 12288, '\p{^Is_General_Category=--Zs}', "");
    Expect(0, 12288, '\P{Is_General_Category=--Zs}', "");
    Expect(1, 12288, '\P{^Is_General_Category=--Zs}', "");
    Expect(0, 12289, '\p{Is_General_Category=--Zs}', "");
    Expect(1, 12289, '\p{^Is_General_Category=--Zs}', "");
    Expect(1, 12289, '\P{Is_General_Category=--Zs}', "");
    Expect(0, 12289, '\P{^Is_General_Category=--Zs}', "");
    Error('\p{Is_Gc=- Space_SEPARATOR/a/}');
    Error('\P{Is_Gc=- Space_SEPARATOR/a/}');
    Expect(1, 12288, '\p{Is_Gc=spaceseparator}', "");
    Expect(0, 12288, '\p{^Is_Gc=spaceseparator}', "");
    Expect(0, 12288, '\P{Is_Gc=spaceseparator}', "");
    Expect(1, 12288, '\P{^Is_Gc=spaceseparator}', "");
    Expect(0, 12289, '\p{Is_Gc=spaceseparator}', "");
    Expect(1, 12289, '\p{^Is_Gc=spaceseparator}', "");
    Expect(1, 12289, '\P{Is_Gc=spaceseparator}', "");
    Expect(0, 12289, '\P{^Is_Gc=spaceseparator}', "");
    Expect(1, 12288, '\p{Is_Gc=--Space_Separator}', "");
    Expect(0, 12288, '\p{^Is_Gc=--Space_Separator}', "");
    Expect(0, 12288, '\P{Is_Gc=--Space_Separator}', "");
    Expect(1, 12288, '\P{^Is_Gc=--Space_Separator}', "");
    Expect(0, 12289, '\p{Is_Gc=--Space_Separator}', "");
    Expect(1, 12289, '\p{^Is_Gc=--Space_Separator}', "");
    Expect(1, 12289, '\P{Is_Gc=--Space_Separator}', "");
    Expect(0, 12289, '\P{^Is_Gc=--Space_Separator}', "");
    Error('\p{Is_Category=:=Zs}');
    Error('\P{Is_Category=:=Zs}');
    Expect(1, 12288, '\p{Is_Category:zs}', "");
    Expect(0, 12288, '\p{^Is_Category:zs}', "");
    Expect(0, 12288, '\P{Is_Category:zs}', "");
    Expect(1, 12288, '\P{^Is_Category:zs}', "");
    Expect(0, 12289, '\p{Is_Category:zs}', "");
    Expect(1, 12289, '\p{^Is_Category:zs}', "");
    Expect(1, 12289, '\P{Is_Category:zs}', "");
    Expect(0, 12289, '\P{^Is_Category:zs}', "");
    Expect(1, 12288, '\p{Is_Category=	-ZS}', "");
    Expect(0, 12288, '\p{^Is_Category=	-ZS}', "");
    Expect(0, 12288, '\P{Is_Category=	-ZS}', "");
    Expect(1, 12288, '\P{^Is_Category=	-ZS}', "");
    Expect(0, 12289, '\p{Is_Category=	-ZS}', "");
    Expect(1, 12289, '\p{^Is_Category=	-ZS}', "");
    Expect(1, 12289, '\P{Is_Category=	-ZS}', "");
    Expect(0, 12289, '\P{^Is_Category=	-ZS}', "");
    Error('\p{graphemeclusterbreak}');
    Error('\P{graphemeclusterbreak}');
    Error('\p{gcb}');
    Error('\P{gcb}');
    Error('\p{_perlgcb}');
    Error('\P{_perlgcb}');
    Error('\p{Grapheme_Cluster_Break=--control:=}');
    Error('\P{Grapheme_Cluster_Break=--control:=}');
    Expect(1, 921599, '\p{Grapheme_Cluster_Break=control}', "");
    Expect(0, 921599, '\p{^Grapheme_Cluster_Break=control}', "");
    Expect(0, 921599, '\P{Grapheme_Cluster_Break=control}', "");
    Expect(1, 921599, '\P{^Grapheme_Cluster_Break=control}', "");
    Expect(0, 921600, '\p{Grapheme_Cluster_Break=control}', "");
    Expect(1, 921600, '\p{^Grapheme_Cluster_Break=control}', "");
    Expect(1, 921600, '\P{Grapheme_Cluster_Break=control}', "");
    Expect(0, 921600, '\P{^Grapheme_Cluster_Break=control}', "");
    Expect(1, 921599, '\p{Grapheme_Cluster_Break=	-Control}', "");
    Expect(0, 921599, '\p{^Grapheme_Cluster_Break=	-Control}', "");
    Expect(0, 921599, '\P{Grapheme_Cluster_Break=	-Control}', "");
    Expect(1, 921599, '\P{^Grapheme_Cluster_Break=	-Control}', "");
    Expect(0, 921600, '\p{Grapheme_Cluster_Break=	-Control}', "");
    Expect(1, 921600, '\p{^Grapheme_Cluster_Break=	-Control}', "");
    Expect(1, 921600, '\P{Grapheme_Cluster_Break=	-Control}', "");
    Expect(0, 921600, '\P{^Grapheme_Cluster_Break=	-Control}', "");
    Error('\p{GCB=/a/_	CN}');
    Error('\P{GCB=/a/_	CN}');
    Expect(1, 921599, '\p{GCB=cn}', "");
    Expect(0, 921599, '\p{^GCB=cn}', "");
    Expect(0, 921599, '\P{GCB=cn}', "");
    Expect(1, 921599, '\P{^GCB=cn}', "");
    Expect(0, 921600, '\p{GCB=cn}', "");
    Expect(1, 921600, '\p{^GCB=cn}', "");
    Expect(1, 921600, '\P{GCB=cn}', "");
    Expect(0, 921600, '\P{^GCB=cn}', "");
    Expect(1, 921599, '\p{GCB= _CN}', "");
    Expect(0, 921599, '\p{^GCB= _CN}', "");
    Expect(0, 921599, '\P{GCB= _CN}', "");
    Expect(1, 921599, '\P{^GCB= _CN}', "");
    Expect(0, 921600, '\p{GCB= _CN}', "");
    Expect(1, 921600, '\p{^GCB= _CN}', "");
    Expect(1, 921600, '\P{GCB= _CN}', "");
    Expect(0, 921600, '\P{^GCB= _CN}', "");
    Error('\p{Is_Grapheme_Cluster_Break=-	Control/a/}');
    Error('\P{Is_Grapheme_Cluster_Break=-	Control/a/}');
    Expect(1, 921599, '\p{Is_Grapheme_Cluster_Break=control}', "");
    Expect(0, 921599, '\p{^Is_Grapheme_Cluster_Break=control}', "");
    Expect(0, 921599, '\P{Is_Grapheme_Cluster_Break=control}', "");
    Expect(1, 921599, '\P{^Is_Grapheme_Cluster_Break=control}', "");
    Expect(0, 921600, '\p{Is_Grapheme_Cluster_Break=control}', "");
    Expect(1, 921600, '\p{^Is_Grapheme_Cluster_Break=control}', "");
    Expect(1, 921600, '\P{Is_Grapheme_Cluster_Break=control}', "");
    Expect(0, 921600, '\P{^Is_Grapheme_Cluster_Break=control}', "");
    Expect(1, 921599, '\p{Is_Grapheme_Cluster_Break=Control}', "");
    Expect(0, 921599, '\p{^Is_Grapheme_Cluster_Break=Control}', "");
    Expect(0, 921599, '\P{Is_Grapheme_Cluster_Break=Control}', "");
    Expect(1, 921599, '\P{^Is_Grapheme_Cluster_Break=Control}', "");
    Expect(0, 921600, '\p{Is_Grapheme_Cluster_Break=Control}', "");
    Expect(1, 921600, '\p{^Is_Grapheme_Cluster_Break=Control}', "");
    Expect(1, 921600, '\P{Is_Grapheme_Cluster_Break=Control}', "");
    Expect(0, 921600, '\P{^Is_Grapheme_Cluster_Break=Control}', "");
    Error('\p{Is_GCB=:=-_CN}');
    Error('\P{Is_GCB=:=-_CN}');
    Expect(1, 921599, '\p{Is_GCB:	cn}', "");
    Expect(0, 921599, '\p{^Is_GCB:	cn}', "");
    Expect(0, 921599, '\P{Is_GCB:	cn}', "");
    Expect(1, 921599, '\P{^Is_GCB:	cn}', "");
    Expect(0, 921600, '\p{Is_GCB:	cn}', "");
    Expect(1, 921600, '\p{^Is_GCB:	cn}', "");
    Expect(1, 921600, '\P{Is_GCB:	cn}', "");
    Expect(0, 921600, '\P{^Is_GCB:	cn}', "");
    Expect(1, 921599, '\p{Is_GCB=		CN}', "");
    Expect(0, 921599, '\p{^Is_GCB=		CN}', "");
    Expect(0, 921599, '\P{Is_GCB=		CN}', "");
    Expect(1, 921599, '\P{^Is_GCB=		CN}', "");
    Expect(0, 921600, '\p{Is_GCB=		CN}', "");
    Expect(1, 921600, '\p{^Is_GCB=		CN}', "");
    Expect(1, 921600, '\P{Is_GCB=		CN}', "");
    Expect(0, 921600, '\P{^Is_GCB=		CN}', "");
    Error('\p{Grapheme_Cluster_Break=/a/CR}');
    Error('\P{Grapheme_Cluster_Break=/a/CR}');
    Expect(1, 13, '\p{Grapheme_Cluster_Break=cr}', "");
    Expect(0, 13, '\p{^Grapheme_Cluster_Break=cr}', "");
    Expect(0, 13, '\P{Grapheme_Cluster_Break=cr}', "");
    Expect(1, 13, '\P{^Grapheme_Cluster_Break=cr}', "");
    Expect(0, 14, '\p{Grapheme_Cluster_Break=cr}', "");
    Expect(1, 14, '\p{^Grapheme_Cluster_Break=cr}', "");
    Expect(1, 14, '\P{Grapheme_Cluster_Break=cr}', "");
    Expect(0, 14, '\P{^Grapheme_Cluster_Break=cr}', "");
    Expect(1, 13, '\p{Grapheme_Cluster_Break=_CR}', "");
    Expect(0, 13, '\p{^Grapheme_Cluster_Break=_CR}', "");
    Expect(0, 13, '\P{Grapheme_Cluster_Break=_CR}', "");
    Expect(1, 13, '\P{^Grapheme_Cluster_Break=_CR}', "");
    Expect(0, 14, '\p{Grapheme_Cluster_Break=_CR}', "");
    Expect(1, 14, '\p{^Grapheme_Cluster_Break=_CR}', "");
    Expect(1, 14, '\P{Grapheme_Cluster_Break=_CR}', "");
    Expect(0, 14, '\P{^Grapheme_Cluster_Break=_CR}', "");
    Error('\p{GCB=_CR/a/}');
    Error('\P{GCB=_CR/a/}');
    Expect(1, 13, '\p{GCB:   cr}', "");
    Expect(0, 13, '\p{^GCB:   cr}', "");
    Expect(0, 13, '\P{GCB:   cr}', "");
    Expect(1, 13, '\P{^GCB:   cr}', "");
    Expect(0, 14, '\p{GCB:   cr}', "");
    Expect(1, 14, '\p{^GCB:   cr}', "");
    Expect(1, 14, '\P{GCB:   cr}', "");
    Expect(0, 14, '\P{^GCB:   cr}', "");
    Expect(1, 13, '\p{GCB=- CR}', "");
    Expect(0, 13, '\p{^GCB=- CR}', "");
    Expect(0, 13, '\P{GCB=- CR}', "");
    Expect(1, 13, '\P{^GCB=- CR}', "");
    Expect(0, 14, '\p{GCB=- CR}', "");
    Expect(1, 14, '\p{^GCB=- CR}', "");
    Expect(1, 14, '\P{GCB=- CR}', "");
    Expect(0, 14, '\P{^GCB=- CR}', "");
    Error('\p{Is_Grapheme_Cluster_Break:   /a/_CR}');
    Error('\P{Is_Grapheme_Cluster_Break:   /a/_CR}');
    Expect(1, 13, '\p{Is_Grapheme_Cluster_Break=cr}', "");
    Expect(0, 13, '\p{^Is_Grapheme_Cluster_Break=cr}', "");
    Expect(0, 13, '\P{Is_Grapheme_Cluster_Break=cr}', "");
    Expect(1, 13, '\P{^Is_Grapheme_Cluster_Break=cr}', "");
    Expect(0, 14, '\p{Is_Grapheme_Cluster_Break=cr}', "");
    Expect(1, 14, '\p{^Is_Grapheme_Cluster_Break=cr}', "");
    Expect(1, 14, '\P{Is_Grapheme_Cluster_Break=cr}', "");
    Expect(0, 14, '\P{^Is_Grapheme_Cluster_Break=cr}', "");
    Expect(1, 13, '\p{Is_Grapheme_Cluster_Break:	--CR}', "");
    Expect(0, 13, '\p{^Is_Grapheme_Cluster_Break:	--CR}', "");
    Expect(0, 13, '\P{Is_Grapheme_Cluster_Break:	--CR}', "");
    Expect(1, 13, '\P{^Is_Grapheme_Cluster_Break:	--CR}', "");
    Expect(0, 14, '\p{Is_Grapheme_Cluster_Break:	--CR}', "");
    Expect(1, 14, '\p{^Is_Grapheme_Cluster_Break:	--CR}', "");
    Expect(1, 14, '\P{Is_Grapheme_Cluster_Break:	--CR}', "");
    Expect(0, 14, '\P{^Is_Grapheme_Cluster_Break:	--CR}', "");
    Error('\p{Is_GCB=_/a/CR}');
    Error('\P{Is_GCB=_/a/CR}');
    Expect(1, 13, '\p{Is_GCB=cr}', "");
    Expect(0, 13, '\p{^Is_GCB=cr}', "");
    Expect(0, 13, '\P{Is_GCB=cr}', "");
    Expect(1, 13, '\P{^Is_GCB=cr}', "");
    Expect(0, 14, '\p{Is_GCB=cr}', "");
    Expect(1, 14, '\p{^Is_GCB=cr}', "");
    Expect(1, 14, '\P{Is_GCB=cr}', "");
    Expect(0, 14, '\P{^Is_GCB=cr}', "");
    Expect(1, 13, '\p{Is_GCB=-_CR}', "");
    Expect(0, 13, '\p{^Is_GCB=-_CR}', "");
    Expect(0, 13, '\P{Is_GCB=-_CR}', "");
    Expect(1, 13, '\P{^Is_GCB=-_CR}', "");
    Expect(0, 14, '\p{Is_GCB=-_CR}', "");
    Expect(1, 14, '\p{^Is_GCB=-_CR}', "");
    Expect(1, 14, '\P{Is_GCB=-_CR}', "");
    Expect(0, 14, '\P{^Is_GCB=-_CR}', "");
    Error('\p{Grapheme_Cluster_Break: :=- e_BASE}');
    Error('\P{Grapheme_Cluster_Break: :=- e_BASE}');
    Expect(1, 129501, '\p{Grapheme_Cluster_Break=ebase}', "");
    Expect(0, 129501, '\p{^Grapheme_Cluster_Break=ebase}', "");
    Expect(0, 129501, '\P{Grapheme_Cluster_Break=ebase}', "");
    Expect(1, 129501, '\P{^Grapheme_Cluster_Break=ebase}', "");
    Expect(0, 129502, '\p{Grapheme_Cluster_Break=ebase}', "");
    Expect(1, 129502, '\p{^Grapheme_Cluster_Break=ebase}', "");
    Expect(1, 129502, '\P{Grapheme_Cluster_Break=ebase}', "");
    Expect(0, 129502, '\P{^Grapheme_Cluster_Break=ebase}', "");
    Expect(1, 129501, '\p{Grapheme_Cluster_Break=	_E_BASE}', "");
    Expect(0, 129501, '\p{^Grapheme_Cluster_Break=	_E_BASE}', "");
    Expect(0, 129501, '\P{Grapheme_Cluster_Break=	_E_BASE}', "");
    Expect(1, 129501, '\P{^Grapheme_Cluster_Break=	_E_BASE}', "");
    Expect(0, 129502, '\p{Grapheme_Cluster_Break=	_E_BASE}', "");
    Expect(1, 129502, '\p{^Grapheme_Cluster_Break=	_E_BASE}', "");
    Expect(1, 129502, '\P{Grapheme_Cluster_Break=	_E_BASE}', "");
    Expect(0, 129502, '\P{^Grapheme_Cluster_Break=	_E_BASE}', "");
    Error('\p{GCB=/a/ EB}');
    Error('\P{GCB=/a/ EB}');
    Expect(1, 129501, '\p{GCB=eb}', "");
    Expect(0, 129501, '\p{^GCB=eb}', "");
    Expect(0, 129501, '\P{GCB=eb}', "");
    Expect(1, 129501, '\P{^GCB=eb}', "");
    Expect(0, 129502, '\p{GCB=eb}', "");
    Expect(1, 129502, '\p{^GCB=eb}', "");
    Expect(1, 129502, '\P{GCB=eb}', "");
    Expect(0, 129502, '\P{^GCB=eb}', "");
    Expect(1, 129501, '\p{GCB=__EB}', "");
    Expect(0, 129501, '\p{^GCB=__EB}', "");
    Expect(0, 129501, '\P{GCB=__EB}', "");
    Expect(1, 129501, '\P{^GCB=__EB}', "");
    Expect(0, 129502, '\p{GCB=__EB}', "");
    Expect(1, 129502, '\p{^GCB=__EB}', "");
    Expect(1, 129502, '\P{GCB=__EB}', "");
    Expect(0, 129502, '\P{^GCB=__EB}', "");
    Error('\p{Is_Grapheme_Cluster_Break=:=	_E_Base}');
    Error('\P{Is_Grapheme_Cluster_Break=:=	_E_Base}');
    Expect(1, 129501, '\p{Is_Grapheme_Cluster_Break=ebase}', "");
    Expect(0, 129501, '\p{^Is_Grapheme_Cluster_Break=ebase}', "");
    Expect(0, 129501, '\P{Is_Grapheme_Cluster_Break=ebase}', "");
    Expect(1, 129501, '\P{^Is_Grapheme_Cluster_Break=ebase}', "");
    Expect(0, 129502, '\p{Is_Grapheme_Cluster_Break=ebase}', "");
    Expect(1, 129502, '\p{^Is_Grapheme_Cluster_Break=ebase}', "");
    Expect(1, 129502, '\P{Is_Grapheme_Cluster_Break=ebase}', "");
    Expect(0, 129502, '\P{^Is_Grapheme_Cluster_Break=ebase}', "");
    Expect(1, 129501, '\p{Is_Grapheme_Cluster_Break:		E_Base}', "");
    Expect(0, 129501, '\p{^Is_Grapheme_Cluster_Break:		E_Base}', "");
    Expect(0, 129501, '\P{Is_Grapheme_Cluster_Break:		E_Base}', "");
    Expect(1, 129501, '\P{^Is_Grapheme_Cluster_Break:		E_Base}', "");
    Expect(0, 129502, '\p{Is_Grapheme_Cluster_Break:		E_Base}', "");
    Expect(1, 129502, '\p{^Is_Grapheme_Cluster_Break:		E_Base}', "");
    Expect(1, 129502, '\P{Is_Grapheme_Cluster_Break:		E_Base}', "");
    Expect(0, 129502, '\P{^Is_Grapheme_Cluster_Break:		E_Base}', "");
    Error('\p{Is_GCB=/a/-	EB}');
    Error('\P{Is_GCB=/a/-	EB}');
    Expect(1, 129501, '\p{Is_GCB=eb}', "");
    Expect(0, 129501, '\p{^Is_GCB=eb}', "");
    Expect(0, 129501, '\P{Is_GCB=eb}', "");
    Expect(1, 129501, '\P{^Is_GCB=eb}', "");
    Expect(0, 129502, '\p{Is_GCB=eb}', "");
    Expect(1, 129502, '\p{^Is_GCB=eb}', "");
    Expect(1, 129502, '\P{Is_GCB=eb}', "");
    Expect(0, 129502, '\P{^Is_GCB=eb}', "");
    Expect(1, 129501, '\p{Is_GCB=		EB}', "");
    Expect(0, 129501, '\p{^Is_GCB=		EB}', "");
    Expect(0, 129501, '\P{Is_GCB=		EB}', "");
    Expect(1, 129501, '\P{^Is_GCB=		EB}', "");
    Expect(0, 129502, '\p{Is_GCB=		EB}', "");
    Expect(1, 129502, '\p{^Is_GCB=		EB}', "");
    Expect(1, 129502, '\P{Is_GCB=		EB}', "");
    Expect(0, 129502, '\P{^Is_GCB=		EB}', "");
    Error('\p{Grapheme_Cluster_Break= _E_Base_GAZ:=}');
    Error('\P{Grapheme_Cluster_Break= _E_Base_GAZ:=}');
    Expect(1, 128105, '\p{Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(0, 128105, '\p{^Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(0, 128105, '\P{Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(1, 128105, '\P{^Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(0, 128106, '\p{Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(1, 128106, '\p{^Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(1, 128106, '\P{Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(0, 128106, '\P{^Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(1, 128105, '\p{Grapheme_Cluster_Break:	 _E_BASE_GAZ}', "");
    Expect(0, 128105, '\p{^Grapheme_Cluster_Break:	 _E_BASE_GAZ}', "");
    Expect(0, 128105, '\P{Grapheme_Cluster_Break:	 _E_BASE_GAZ}', "");
    Expect(1, 128105, '\P{^Grapheme_Cluster_Break:	 _E_BASE_GAZ}', "");
    Expect(0, 128106, '\p{Grapheme_Cluster_Break:	 _E_BASE_GAZ}', "");
    Expect(1, 128106, '\p{^Grapheme_Cluster_Break:	 _E_BASE_GAZ}', "");
    Expect(1, 128106, '\P{Grapheme_Cluster_Break:	 _E_BASE_GAZ}', "");
    Expect(0, 128106, '\P{^Grapheme_Cluster_Break:	 _E_BASE_GAZ}', "");
    Error('\p{GCB=/a/EBG}');
    Error('\P{GCB=/a/EBG}');
    Expect(1, 128105, '\p{GCB=ebg}', "");
    Expect(0, 128105, '\p{^GCB=ebg}', "");
    Expect(0, 128105, '\P{GCB=ebg}', "");
    Expect(1, 128105, '\P{^GCB=ebg}', "");
    Expect(0, 128106, '\p{GCB=ebg}', "");
    Expect(1, 128106, '\p{^GCB=ebg}', "");
    Expect(1, 128106, '\P{GCB=ebg}', "");
    Expect(0, 128106, '\P{^GCB=ebg}', "");
    Expect(1, 128105, '\p{GCB=  EBG}', "");
    Expect(0, 128105, '\p{^GCB=  EBG}', "");
    Expect(0, 128105, '\P{GCB=  EBG}', "");
    Expect(1, 128105, '\P{^GCB=  EBG}', "");
    Expect(0, 128106, '\p{GCB=  EBG}', "");
    Expect(1, 128106, '\p{^GCB=  EBG}', "");
    Expect(1, 128106, '\P{GCB=  EBG}', "");
    Expect(0, 128106, '\P{^GCB=  EBG}', "");
    Error('\p{Is_Grapheme_Cluster_Break:   -	e_Base_gaz:=}');
    Error('\P{Is_Grapheme_Cluster_Break:   -	e_Base_gaz:=}');
    Expect(1, 128105, '\p{Is_Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(0, 128105, '\p{^Is_Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(0, 128105, '\P{Is_Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(1, 128105, '\P{^Is_Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(0, 128106, '\p{Is_Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(1, 128106, '\p{^Is_Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(1, 128106, '\P{Is_Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(0, 128106, '\P{^Is_Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(1, 128105, '\p{Is_Grapheme_Cluster_Break=-_E_Base_GAZ}', "");
    Expect(0, 128105, '\p{^Is_Grapheme_Cluster_Break=-_E_Base_GAZ}', "");
    Expect(0, 128105, '\P{Is_Grapheme_Cluster_Break=-_E_Base_GAZ}', "");
    Expect(1, 128105, '\P{^Is_Grapheme_Cluster_Break=-_E_Base_GAZ}', "");
    Expect(0, 128106, '\p{Is_Grapheme_Cluster_Break=-_E_Base_GAZ}', "");
    Expect(1, 128106, '\p{^Is_Grapheme_Cluster_Break=-_E_Base_GAZ}', "");
    Expect(1, 128106, '\P{Is_Grapheme_Cluster_Break=-_E_Base_GAZ}', "");
    Expect(0, 128106, '\P{^Is_Grapheme_Cluster_Break=-_E_Base_GAZ}', "");
    Error('\p{Is_GCB=	/a/EBG}');
    Error('\P{Is_GCB=	/a/EBG}');
    Expect(1, 128105, '\p{Is_GCB=ebg}', "");
    Expect(0, 128105, '\p{^Is_GCB=ebg}', "");
    Expect(0, 128105, '\P{Is_GCB=ebg}', "");
    Expect(1, 128105, '\P{^Is_GCB=ebg}', "");
    Expect(0, 128106, '\p{Is_GCB=ebg}', "");
    Expect(1, 128106, '\p{^Is_GCB=ebg}', "");
    Expect(1, 128106, '\P{Is_GCB=ebg}', "");
    Expect(0, 128106, '\P{^Is_GCB=ebg}', "");
    Expect(1, 128105, '\p{Is_GCB=	-EBG}', "");
    Expect(0, 128105, '\p{^Is_GCB=	-EBG}', "");
    Expect(0, 128105, '\P{Is_GCB=	-EBG}', "");
    Expect(1, 128105, '\P{^Is_GCB=	-EBG}', "");
    Expect(0, 128106, '\p{Is_GCB=	-EBG}', "");
    Expect(1, 128106, '\p{^Is_GCB=	-EBG}', "");
    Expect(1, 128106, '\P{Is_GCB=	-EBG}', "");
    Expect(0, 128106, '\P{^Is_GCB=	-EBG}', "");
    Error('\p{Grapheme_Cluster_Break: 	E_Modifier/a/}');
    Error('\P{Grapheme_Cluster_Break: 	E_Modifier/a/}');
    Expect(1, 127999, '\p{Grapheme_Cluster_Break=emodifier}', "");
    Expect(0, 127999, '\p{^Grapheme_Cluster_Break=emodifier}', "");
    Expect(0, 127999, '\P{Grapheme_Cluster_Break=emodifier}', "");
    Expect(1, 127999, '\P{^Grapheme_Cluster_Break=emodifier}', "");
    Expect(0, 128000, '\p{Grapheme_Cluster_Break=emodifier}', "");
    Expect(1, 128000, '\p{^Grapheme_Cluster_Break=emodifier}', "");
    Expect(1, 128000, '\P{Grapheme_Cluster_Break=emodifier}', "");
    Expect(0, 128000, '\P{^Grapheme_Cluster_Break=emodifier}', "");
    Expect(1, 127999, '\p{Grapheme_Cluster_Break=__e_Modifier}', "");
    Expect(0, 127999, '\p{^Grapheme_Cluster_Break=__e_Modifier}', "");
    Expect(0, 127999, '\P{Grapheme_Cluster_Break=__e_Modifier}', "");
    Expect(1, 127999, '\P{^Grapheme_Cluster_Break=__e_Modifier}', "");
    Expect(0, 128000, '\p{Grapheme_Cluster_Break=__e_Modifier}', "");
    Expect(1, 128000, '\p{^Grapheme_Cluster_Break=__e_Modifier}', "");
    Expect(1, 128000, '\P{Grapheme_Cluster_Break=__e_Modifier}', "");
    Expect(0, 128000, '\P{^Grapheme_Cluster_Break=__e_Modifier}', "");
    Error('\p{GCB:_-EM:=}');
    Error('\P{GCB:_-EM:=}');
    Expect(1, 127999, '\p{GCB=em}', "");
    Expect(0, 127999, '\p{^GCB=em}', "");
    Expect(0, 127999, '\P{GCB=em}', "");
    Expect(1, 127999, '\P{^GCB=em}', "");
    Expect(0, 128000, '\p{GCB=em}', "");
    Expect(1, 128000, '\p{^GCB=em}', "");
    Expect(1, 128000, '\P{GCB=em}', "");
    Expect(0, 128000, '\P{^GCB=em}', "");
    Expect(1, 127999, '\p{GCB=  EM}', "");
    Expect(0, 127999, '\p{^GCB=  EM}', "");
    Expect(0, 127999, '\P{GCB=  EM}', "");
    Expect(1, 127999, '\P{^GCB=  EM}', "");
    Expect(0, 128000, '\p{GCB=  EM}', "");
    Expect(1, 128000, '\p{^GCB=  EM}', "");
    Expect(1, 128000, '\P{GCB=  EM}', "");
    Expect(0, 128000, '\P{^GCB=  EM}', "");
    Error('\p{Is_Grapheme_Cluster_Break=-:=E_modifier}');
    Error('\P{Is_Grapheme_Cluster_Break=-:=E_modifier}');
    Expect(1, 127999, '\p{Is_Grapheme_Cluster_Break=emodifier}', "");
    Expect(0, 127999, '\p{^Is_Grapheme_Cluster_Break=emodifier}', "");
    Expect(0, 127999, '\P{Is_Grapheme_Cluster_Break=emodifier}', "");
    Expect(1, 127999, '\P{^Is_Grapheme_Cluster_Break=emodifier}', "");
    Expect(0, 128000, '\p{Is_Grapheme_Cluster_Break=emodifier}', "");
    Expect(1, 128000, '\p{^Is_Grapheme_Cluster_Break=emodifier}', "");
    Expect(1, 128000, '\P{Is_Grapheme_Cluster_Break=emodifier}', "");
    Expect(0, 128000, '\P{^Is_Grapheme_Cluster_Break=emodifier}', "");
    Expect(1, 127999, '\p{Is_Grapheme_Cluster_Break:    e_modifier}', "");
    Expect(0, 127999, '\p{^Is_Grapheme_Cluster_Break:    e_modifier}', "");
    Expect(0, 127999, '\P{Is_Grapheme_Cluster_Break:    e_modifier}', "");
    Expect(1, 127999, '\P{^Is_Grapheme_Cluster_Break:    e_modifier}', "");
    Expect(0, 128000, '\p{Is_Grapheme_Cluster_Break:    e_modifier}', "");
    Expect(1, 128000, '\p{^Is_Grapheme_Cluster_Break:    e_modifier}', "");
    Expect(1, 128000, '\P{Is_Grapheme_Cluster_Break:    e_modifier}', "");
    Expect(0, 128000, '\P{^Is_Grapheme_Cluster_Break:    e_modifier}', "");
    Error('\p{Is_GCB=--em:=}');
    Error('\P{Is_GCB=--em:=}');
    Expect(1, 127999, '\p{Is_GCB=em}', "");
    Expect(0, 127999, '\p{^Is_GCB=em}', "");
    Expect(0, 127999, '\P{Is_GCB=em}', "");
    Expect(1, 127999, '\P{^Is_GCB=em}', "");
    Expect(0, 128000, '\p{Is_GCB=em}', "");
    Expect(1, 128000, '\p{^Is_GCB=em}', "");
    Expect(1, 128000, '\P{Is_GCB=em}', "");
    Expect(0, 128000, '\P{^Is_GCB=em}', "");
    Expect(1, 127999, '\p{Is_GCB=_EM}', "");
    Expect(0, 127999, '\p{^Is_GCB=_EM}', "");
    Expect(0, 127999, '\P{Is_GCB=_EM}', "");
    Expect(1, 127999, '\P{^Is_GCB=_EM}', "");
    Expect(0, 128000, '\p{Is_GCB=_EM}', "");
    Expect(1, 128000, '\p{^Is_GCB=_EM}', "");
    Expect(1, 128000, '\P{Is_GCB=_EM}', "");
    Expect(0, 128000, '\P{^Is_GCB=_EM}', "");
    Error('\p{Grapheme_Cluster_Break=_/a/Extend}');
    Error('\P{Grapheme_Cluster_Break=_/a/Extend}');
    Expect(1, 917999, '\p{Grapheme_Cluster_Break=extend}', "");
    Expect(0, 917999, '\p{^Grapheme_Cluster_Break=extend}', "");
    Expect(0, 917999, '\P{Grapheme_Cluster_Break=extend}', "");
    Expect(1, 917999, '\P{^Grapheme_Cluster_Break=extend}', "");
    Expect(0, 918000, '\p{Grapheme_Cluster_Break=extend}', "");
    Expect(1, 918000, '\p{^Grapheme_Cluster_Break=extend}', "");
    Expect(1, 918000, '\P{Grapheme_Cluster_Break=extend}', "");
    Expect(0, 918000, '\P{^Grapheme_Cluster_Break=extend}', "");
    Expect(1, 917999, '\p{Grapheme_Cluster_Break: -extend}', "");
    Expect(0, 917999, '\p{^Grapheme_Cluster_Break: -extend}', "");
    Expect(0, 917999, '\P{Grapheme_Cluster_Break: -extend}', "");
    Expect(1, 917999, '\P{^Grapheme_Cluster_Break: -extend}', "");
    Expect(0, 918000, '\p{Grapheme_Cluster_Break: -extend}', "");
    Expect(1, 918000, '\p{^Grapheme_Cluster_Break: -extend}', "");
    Expect(1, 918000, '\P{Grapheme_Cluster_Break: -extend}', "");
    Expect(0, 918000, '\P{^Grapheme_Cluster_Break: -extend}', "");
    Error('\p{GCB=	EX/a/}');
    Error('\P{GCB=	EX/a/}');
    Expect(1, 917999, '\p{GCB=ex}', "");
    Expect(0, 917999, '\p{^GCB=ex}', "");
    Expect(0, 917999, '\P{GCB=ex}', "");
    Expect(1, 917999, '\P{^GCB=ex}', "");
    Expect(0, 918000, '\p{GCB=ex}', "");
    Expect(1, 918000, '\p{^GCB=ex}', "");
    Expect(1, 918000, '\P{GCB=ex}', "");
    Expect(0, 918000, '\P{^GCB=ex}', "");
    Expect(1, 917999, '\p{GCB=	 EX}', "");
    Expect(0, 917999, '\p{^GCB=	 EX}', "");
    Expect(0, 917999, '\P{GCB=	 EX}', "");
    Expect(1, 917999, '\P{^GCB=	 EX}', "");
    Expect(0, 918000, '\p{GCB=	 EX}', "");
    Expect(1, 918000, '\p{^GCB=	 EX}', "");
    Expect(1, 918000, '\P{GCB=	 EX}', "");
    Expect(0, 918000, '\P{^GCB=	 EX}', "");
    Error('\p{Is_Grapheme_Cluster_Break=_	Extend/a/}');
    Error('\P{Is_Grapheme_Cluster_Break=_	Extend/a/}');
    Expect(1, 917999, '\p{Is_Grapheme_Cluster_Break=extend}', "");
    Expect(0, 917999, '\p{^Is_Grapheme_Cluster_Break=extend}', "");
    Expect(0, 917999, '\P{Is_Grapheme_Cluster_Break=extend}', "");
    Expect(1, 917999, '\P{^Is_Grapheme_Cluster_Break=extend}', "");
    Expect(0, 918000, '\p{Is_Grapheme_Cluster_Break=extend}', "");
    Expect(1, 918000, '\p{^Is_Grapheme_Cluster_Break=extend}', "");
    Expect(1, 918000, '\P{Is_Grapheme_Cluster_Break=extend}', "");
    Expect(0, 918000, '\P{^Is_Grapheme_Cluster_Break=extend}', "");
    Expect(1, 917999, '\p{Is_Grapheme_Cluster_Break=_Extend}', "");
    Expect(0, 917999, '\p{^Is_Grapheme_Cluster_Break=_Extend}', "");
    Expect(0, 917999, '\P{Is_Grapheme_Cluster_Break=_Extend}', "");
    Expect(1, 917999, '\P{^Is_Grapheme_Cluster_Break=_Extend}', "");
    Expect(0, 918000, '\p{Is_Grapheme_Cluster_Break=_Extend}', "");
    Expect(1, 918000, '\p{^Is_Grapheme_Cluster_Break=_Extend}', "");
    Expect(1, 918000, '\P{Is_Grapheme_Cluster_Break=_Extend}', "");
    Expect(0, 918000, '\P{^Is_Grapheme_Cluster_Break=_Extend}', "");
    Error('\p{Is_GCB=/a/ -EX}');
    Error('\P{Is_GCB=/a/ -EX}');
    Expect(1, 917999, '\p{Is_GCB=ex}', "");
    Expect(0, 917999, '\p{^Is_GCB=ex}', "");
    Expect(0, 917999, '\P{Is_GCB=ex}', "");
    Expect(1, 917999, '\P{^Is_GCB=ex}', "");
    Expect(0, 918000, '\p{Is_GCB=ex}', "");
    Expect(1, 918000, '\p{^Is_GCB=ex}', "");
    Expect(1, 918000, '\P{Is_GCB=ex}', "");
    Expect(0, 918000, '\P{^Is_GCB=ex}', "");
    Expect(1, 917999, '\p{Is_GCB=--ex}', "");
    Expect(0, 917999, '\p{^Is_GCB=--ex}', "");
    Expect(0, 917999, '\P{Is_GCB=--ex}', "");
    Expect(1, 917999, '\P{^Is_GCB=--ex}', "");
    Expect(0, 918000, '\p{Is_GCB=--ex}', "");
    Expect(1, 918000, '\p{^Is_GCB=--ex}', "");
    Expect(1, 918000, '\P{Is_GCB=--ex}', "");
    Expect(0, 918000, '\P{^Is_GCB=--ex}', "");
    Error('\p{Grapheme_Cluster_Break=:=  Glue_after_Zwj}');
    Error('\P{Grapheme_Cluster_Break=:=  Glue_after_Zwj}');
    Expect(1, 128658, '\p{Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(0, 128658, '\p{^Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(0, 128658, '\P{Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(1, 128658, '\P{^Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(0, 128659, '\p{Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(1, 128659, '\p{^Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(1, 128659, '\P{Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(0, 128659, '\P{^Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(1, 128658, '\p{Grapheme_Cluster_Break= _Glue_After_zwj}', "");
    Expect(0, 128658, '\p{^Grapheme_Cluster_Break= _Glue_After_zwj}', "");
    Expect(0, 128658, '\P{Grapheme_Cluster_Break= _Glue_After_zwj}', "");
    Expect(1, 128658, '\P{^Grapheme_Cluster_Break= _Glue_After_zwj}', "");
    Expect(0, 128659, '\p{Grapheme_Cluster_Break= _Glue_After_zwj}', "");
    Expect(1, 128659, '\p{^Grapheme_Cluster_Break= _Glue_After_zwj}', "");
    Expect(1, 128659, '\P{Grapheme_Cluster_Break= _Glue_After_zwj}', "");
    Expect(0, 128659, '\P{^Grapheme_Cluster_Break= _Glue_After_zwj}', "");
    Error('\p{GCB=-_GAZ:=}');
    Error('\P{GCB=-_GAZ:=}');
    Expect(1, 128658, '\p{GCB=gaz}', "");
    Expect(0, 128658, '\p{^GCB=gaz}', "");
    Expect(0, 128658, '\P{GCB=gaz}', "");
    Expect(1, 128658, '\P{^GCB=gaz}', "");
    Expect(0, 128659, '\p{GCB=gaz}', "");
    Expect(1, 128659, '\p{^GCB=gaz}', "");
    Expect(1, 128659, '\P{GCB=gaz}', "");
    Expect(0, 128659, '\P{^GCB=gaz}', "");
    Expect(1, 128658, '\p{GCB=-	GAZ}', "");
    Expect(0, 128658, '\p{^GCB=-	GAZ}', "");
    Expect(0, 128658, '\P{GCB=-	GAZ}', "");
    Expect(1, 128658, '\P{^GCB=-	GAZ}', "");
    Expect(0, 128659, '\p{GCB=-	GAZ}', "");
    Expect(1, 128659, '\p{^GCB=-	GAZ}', "");
    Expect(1, 128659, '\P{GCB=-	GAZ}', "");
    Expect(0, 128659, '\P{^GCB=-	GAZ}', "");
    Error('\p{Is_Grapheme_Cluster_Break=--glue_AFTER_zwj:=}');
    Error('\P{Is_Grapheme_Cluster_Break=--glue_AFTER_zwj:=}');
    Expect(1, 128658, '\p{Is_Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(0, 128658, '\p{^Is_Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(0, 128658, '\P{Is_Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(1, 128658, '\P{^Is_Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(0, 128659, '\p{Is_Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(1, 128659, '\p{^Is_Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(1, 128659, '\P{Is_Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(0, 128659, '\P{^Is_Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(1, 128658, '\p{Is_Grapheme_Cluster_Break=  Glue_AFTER_Zwj}', "");
    Expect(0, 128658, '\p{^Is_Grapheme_Cluster_Break=  Glue_AFTER_Zwj}', "");
    Expect(0, 128658, '\P{Is_Grapheme_Cluster_Break=  Glue_AFTER_Zwj}', "");
    Expect(1, 128658, '\P{^Is_Grapheme_Cluster_Break=  Glue_AFTER_Zwj}', "");
    Expect(0, 128659, '\p{Is_Grapheme_Cluster_Break=  Glue_AFTER_Zwj}', "");
    Expect(1, 128659, '\p{^Is_Grapheme_Cluster_Break=  Glue_AFTER_Zwj}', "");
    Expect(1, 128659, '\P{Is_Grapheme_Cluster_Break=  Glue_AFTER_Zwj}', "");
    Expect(0, 128659, '\P{^Is_Grapheme_Cluster_Break=  Glue_AFTER_Zwj}', "");
    Error('\p{Is_GCB:	/a/-	GAZ}');
    Error('\P{Is_GCB:	/a/-	GAZ}');
    Expect(1, 128658, '\p{Is_GCB:gaz}', "");
    Expect(0, 128658, '\p{^Is_GCB:gaz}', "");
    Expect(0, 128658, '\P{Is_GCB:gaz}', "");
    Expect(1, 128658, '\P{^Is_GCB:gaz}', "");
    Expect(0, 128659, '\p{Is_GCB:gaz}', "");
    Expect(1, 128659, '\p{^Is_GCB:gaz}', "");
    Expect(1, 128659, '\P{Is_GCB:gaz}', "");
    Expect(0, 128659, '\P{^Is_GCB:gaz}', "");
    Expect(1, 128658, '\p{Is_GCB=	_GAZ}', "");
    Expect(0, 128658, '\p{^Is_GCB=	_GAZ}', "");
    Expect(0, 128658, '\P{Is_GCB=	_GAZ}', "");
    Expect(1, 128658, '\P{^Is_GCB=	_GAZ}', "");
    Expect(0, 128659, '\p{Is_GCB=	_GAZ}', "");
    Expect(1, 128659, '\p{^Is_GCB=	_GAZ}', "");
    Expect(1, 128659, '\P{Is_GCB=	_GAZ}', "");
    Expect(0, 128659, '\P{^Is_GCB=	_GAZ}', "");
    Error('\p{Grapheme_Cluster_Break=_/a/L}');
    Error('\P{Grapheme_Cluster_Break=_/a/L}');
    Expect(1, 43388, '\p{Grapheme_Cluster_Break=l}', "");
    Expect(0, 43388, '\p{^Grapheme_Cluster_Break=l}', "");
    Expect(0, 43388, '\P{Grapheme_Cluster_Break=l}', "");
    Expect(1, 43388, '\P{^Grapheme_Cluster_Break=l}', "");
    Expect(0, 43389, '\p{Grapheme_Cluster_Break=l}', "");
    Expect(1, 43389, '\p{^Grapheme_Cluster_Break=l}', "");
    Expect(1, 43389, '\P{Grapheme_Cluster_Break=l}', "");
    Expect(0, 43389, '\P{^Grapheme_Cluster_Break=l}', "");
    Expect(1, 43388, '\p{Grapheme_Cluster_Break=_-L}', "");
    Expect(0, 43388, '\p{^Grapheme_Cluster_Break=_-L}', "");
    Expect(0, 43388, '\P{Grapheme_Cluster_Break=_-L}', "");
    Expect(1, 43388, '\P{^Grapheme_Cluster_Break=_-L}', "");
    Expect(0, 43389, '\p{Grapheme_Cluster_Break=_-L}', "");
    Expect(1, 43389, '\p{^Grapheme_Cluster_Break=_-L}', "");
    Expect(1, 43389, '\P{Grapheme_Cluster_Break=_-L}', "");
    Expect(0, 43389, '\P{^Grapheme_Cluster_Break=_-L}', "");
    Error('\p{GCB= L:=}');
    Error('\P{GCB= L:=}');
    Expect(1, 43388, '\p{GCB: l}', "");
    Expect(0, 43388, '\p{^GCB: l}', "");
    Expect(0, 43388, '\P{GCB: l}', "");
    Expect(1, 43388, '\P{^GCB: l}', "");
    Expect(0, 43389, '\p{GCB: l}', "");
    Expect(1, 43389, '\p{^GCB: l}', "");
    Expect(1, 43389, '\P{GCB: l}', "");
    Expect(0, 43389, '\P{^GCB: l}', "");
    Expect(1, 43388, '\p{GCB=- L}', "");
    Expect(0, 43388, '\p{^GCB=- L}', "");
    Expect(0, 43388, '\P{GCB=- L}', "");
    Expect(1, 43388, '\P{^GCB=- L}', "");
    Expect(0, 43389, '\p{GCB=- L}', "");
    Expect(1, 43389, '\p{^GCB=- L}', "");
    Expect(1, 43389, '\P{GCB=- L}', "");
    Expect(0, 43389, '\P{^GCB=- L}', "");
    Error('\p{Is_Grapheme_Cluster_Break=-L:=}');
    Error('\P{Is_Grapheme_Cluster_Break=-L:=}');
    Expect(1, 43388, '\p{Is_Grapheme_Cluster_Break: l}', "");
    Expect(0, 43388, '\p{^Is_Grapheme_Cluster_Break: l}', "");
    Expect(0, 43388, '\P{Is_Grapheme_Cluster_Break: l}', "");
    Expect(1, 43388, '\P{^Is_Grapheme_Cluster_Break: l}', "");
    Expect(0, 43389, '\p{Is_Grapheme_Cluster_Break: l}', "");
    Expect(1, 43389, '\p{^Is_Grapheme_Cluster_Break: l}', "");
    Expect(1, 43389, '\P{Is_Grapheme_Cluster_Break: l}', "");
    Expect(0, 43389, '\P{^Is_Grapheme_Cluster_Break: l}', "");
    Expect(1, 43388, '\p{Is_Grapheme_Cluster_Break: --L}', "");
    Expect(0, 43388, '\p{^Is_Grapheme_Cluster_Break: --L}', "");
    Expect(0, 43388, '\P{Is_Grapheme_Cluster_Break: --L}', "");
    Expect(1, 43388, '\P{^Is_Grapheme_Cluster_Break: --L}', "");
    Expect(0, 43389, '\p{Is_Grapheme_Cluster_Break: --L}', "");
    Expect(1, 43389, '\p{^Is_Grapheme_Cluster_Break: --L}', "");
    Expect(1, 43389, '\P{Is_Grapheme_Cluster_Break: --L}', "");
    Expect(0, 43389, '\P{^Is_Grapheme_Cluster_Break: --L}', "");
    Error('\p{Is_GCB=-/a/L}');
    Error('\P{Is_GCB=-/a/L}');
    Expect(1, 43388, '\p{Is_GCB=l}', "");
    Expect(0, 43388, '\p{^Is_GCB=l}', "");
    Expect(0, 43388, '\P{Is_GCB=l}', "");
    Expect(1, 43388, '\P{^Is_GCB=l}', "");
    Expect(0, 43389, '\p{Is_GCB=l}', "");
    Expect(1, 43389, '\p{^Is_GCB=l}', "");
    Expect(1, 43389, '\P{Is_GCB=l}', "");
    Expect(0, 43389, '\P{^Is_GCB=l}', "");
    Expect(1, 43388, '\p{Is_GCB: -	L}', "");
    Expect(0, 43388, '\p{^Is_GCB: -	L}', "");
    Expect(0, 43388, '\P{Is_GCB: -	L}', "");
    Expect(1, 43388, '\P{^Is_GCB: -	L}', "");
    Expect(0, 43389, '\p{Is_GCB: -	L}', "");
    Expect(1, 43389, '\p{^Is_GCB: -	L}', "");
    Expect(1, 43389, '\P{Is_GCB: -	L}', "");
    Expect(0, 43389, '\P{^Is_GCB: -	L}', "");
    Error('\p{Grapheme_Cluster_Break=	LF/a/}');
    Error('\P{Grapheme_Cluster_Break=	LF/a/}');
    Expect(1, 10, '\p{Grapheme_Cluster_Break=lf}', "");
    Expect(0, 10, '\p{^Grapheme_Cluster_Break=lf}', "");
    Expect(0, 10, '\P{Grapheme_Cluster_Break=lf}', "");
    Expect(1, 10, '\P{^Grapheme_Cluster_Break=lf}', "");
    Expect(0, 11, '\p{Grapheme_Cluster_Break=lf}', "");
    Expect(1, 11, '\p{^Grapheme_Cluster_Break=lf}', "");
    Expect(1, 11, '\P{Grapheme_Cluster_Break=lf}', "");
    Expect(0, 11, '\P{^Grapheme_Cluster_Break=lf}', "");
    Expect(1, 10, '\p{Grapheme_Cluster_Break=	_LF}', "");
    Expect(0, 10, '\p{^Grapheme_Cluster_Break=	_LF}', "");
    Expect(0, 10, '\P{Grapheme_Cluster_Break=	_LF}', "");
    Expect(1, 10, '\P{^Grapheme_Cluster_Break=	_LF}', "");
    Expect(0, 11, '\p{Grapheme_Cluster_Break=	_LF}', "");
    Expect(1, 11, '\p{^Grapheme_Cluster_Break=	_LF}', "");
    Expect(1, 11, '\P{Grapheme_Cluster_Break=	_LF}', "");
    Expect(0, 11, '\P{^Grapheme_Cluster_Break=	_LF}', "");
    Error('\p{GCB=:=	lf}');
    Error('\P{GCB=:=	lf}');
    Expect(1, 10, '\p{GCB=lf}', "");
    Expect(0, 10, '\p{^GCB=lf}', "");
    Expect(0, 10, '\P{GCB=lf}', "");
    Expect(1, 10, '\P{^GCB=lf}', "");
    Expect(0, 11, '\p{GCB=lf}', "");
    Expect(1, 11, '\p{^GCB=lf}', "");
    Expect(1, 11, '\P{GCB=lf}', "");
    Expect(0, 11, '\P{^GCB=lf}', "");
    Expect(1, 10, '\p{GCB= LF}', "");
    Expect(0, 10, '\p{^GCB= LF}', "");
    Expect(0, 10, '\P{GCB= LF}', "");
    Expect(1, 10, '\P{^GCB= LF}', "");
    Expect(0, 11, '\p{GCB= LF}', "");
    Expect(1, 11, '\p{^GCB= LF}', "");
    Expect(1, 11, '\P{GCB= LF}', "");
    Expect(0, 11, '\P{^GCB= LF}', "");
    Error('\p{Is_Grapheme_Cluster_Break:	_ LF:=}');
    Error('\P{Is_Grapheme_Cluster_Break:	_ LF:=}');
    Expect(1, 10, '\p{Is_Grapheme_Cluster_Break=lf}', "");
    Expect(0, 10, '\p{^Is_Grapheme_Cluster_Break=lf}', "");
    Expect(0, 10, '\P{Is_Grapheme_Cluster_Break=lf}', "");
    Expect(1, 10, '\P{^Is_Grapheme_Cluster_Break=lf}', "");
    Expect(0, 11, '\p{Is_Grapheme_Cluster_Break=lf}', "");
    Expect(1, 11, '\p{^Is_Grapheme_Cluster_Break=lf}', "");
    Expect(1, 11, '\P{Is_Grapheme_Cluster_Break=lf}', "");
    Expect(0, 11, '\P{^Is_Grapheme_Cluster_Break=lf}', "");
    Expect(1, 10, '\p{Is_Grapheme_Cluster_Break=--LF}', "");
    Expect(0, 10, '\p{^Is_Grapheme_Cluster_Break=--LF}', "");
    Expect(0, 10, '\P{Is_Grapheme_Cluster_Break=--LF}', "");
    Expect(1, 10, '\P{^Is_Grapheme_Cluster_Break=--LF}', "");
    Expect(0, 11, '\p{Is_Grapheme_Cluster_Break=--LF}', "");
    Expect(1, 11, '\p{^Is_Grapheme_Cluster_Break=--LF}', "");
    Expect(1, 11, '\P{Is_Grapheme_Cluster_Break=--LF}', "");
    Expect(0, 11, '\P{^Is_Grapheme_Cluster_Break=--LF}', "");
    Error('\p{Is_GCB= :=lf}');
    Error('\P{Is_GCB= :=lf}');
    Expect(1, 10, '\p{Is_GCB:lf}', "");
    Expect(0, 10, '\p{^Is_GCB:lf}', "");
    Expect(0, 10, '\P{Is_GCB:lf}', "");
    Expect(1, 10, '\P{^Is_GCB:lf}', "");
    Expect(0, 11, '\p{Is_GCB:lf}', "");
    Expect(1, 11, '\p{^Is_GCB:lf}', "");
    Expect(1, 11, '\P{Is_GCB:lf}', "");
    Expect(0, 11, '\P{^Is_GCB:lf}', "");
    Expect(1, 10, '\p{Is_GCB=_LF}', "");
    Expect(0, 10, '\p{^Is_GCB=_LF}', "");
    Expect(0, 10, '\P{Is_GCB=_LF}', "");
    Expect(1, 10, '\P{^Is_GCB=_LF}', "");
    Expect(0, 11, '\p{Is_GCB=_LF}', "");
    Expect(1, 11, '\p{^Is_GCB=_LF}', "");
    Expect(1, 11, '\P{Is_GCB=_LF}', "");
    Expect(0, 11, '\P{^Is_GCB=_LF}', "");
    Error('\p{Grapheme_Cluster_Break=	 LV/a/}');
    Error('\P{Grapheme_Cluster_Break=	 LV/a/}');
    Expect(1, 55176, '\p{Grapheme_Cluster_Break:lv}', "");
    Expect(0, 55176, '\p{^Grapheme_Cluster_Break:lv}', "");
    Expect(0, 55176, '\P{Grapheme_Cluster_Break:lv}', "");
    Expect(1, 55176, '\P{^Grapheme_Cluster_Break:lv}', "");
    Expect(0, 55177, '\p{Grapheme_Cluster_Break:lv}', "");
    Expect(1, 55177, '\p{^Grapheme_Cluster_Break:lv}', "");
    Expect(1, 55177, '\P{Grapheme_Cluster_Break:lv}', "");
    Expect(0, 55177, '\P{^Grapheme_Cluster_Break:lv}', "");
    Expect(1, 55176, '\p{Grapheme_Cluster_Break=--LV}', "");
    Expect(0, 55176, '\p{^Grapheme_Cluster_Break=--LV}', "");
    Expect(0, 55176, '\P{Grapheme_Cluster_Break=--LV}', "");
    Expect(1, 55176, '\P{^Grapheme_Cluster_Break=--LV}', "");
    Expect(0, 55177, '\p{Grapheme_Cluster_Break=--LV}', "");
    Expect(1, 55177, '\p{^Grapheme_Cluster_Break=--LV}', "");
    Expect(1, 55177, '\P{Grapheme_Cluster_Break=--LV}', "");
    Expect(0, 55177, '\P{^Grapheme_Cluster_Break=--LV}', "");
    Error('\p{GCB=:=	-LV}');
    Error('\P{GCB=:=	-LV}');
    Expect(1, 55176, '\p{GCB=lv}', "");
    Expect(0, 55176, '\p{^GCB=lv}', "");
    Expect(0, 55176, '\P{GCB=lv}', "");
    Expect(1, 55176, '\P{^GCB=lv}', "");
    Expect(0, 55177, '\p{GCB=lv}', "");
    Expect(1, 55177, '\p{^GCB=lv}', "");
    Expect(1, 55177, '\P{GCB=lv}', "");
    Expect(0, 55177, '\P{^GCB=lv}', "");
    Expect(1, 55176, '\p{GCB=	lv}', "");
    Expect(0, 55176, '\p{^GCB=	lv}', "");
    Expect(0, 55176, '\P{GCB=	lv}', "");
    Expect(1, 55176, '\P{^GCB=	lv}', "");
    Expect(0, 55177, '\p{GCB=	lv}', "");
    Expect(1, 55177, '\p{^GCB=	lv}', "");
    Expect(1, 55177, '\P{GCB=	lv}', "");
    Expect(0, 55177, '\P{^GCB=	lv}', "");
    Error('\p{Is_Grapheme_Cluster_Break:   _-lv:=}');
    Error('\P{Is_Grapheme_Cluster_Break:   _-lv:=}');
    Expect(1, 55176, '\p{Is_Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55176, '\p{^Is_Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55176, '\P{Is_Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55176, '\P{^Is_Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55177, '\p{Is_Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55177, '\p{^Is_Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55177, '\P{Is_Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55177, '\P{^Is_Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55176, '\p{Is_Grapheme_Cluster_Break= LV}', "");
    Expect(0, 55176, '\p{^Is_Grapheme_Cluster_Break= LV}', "");
    Expect(0, 55176, '\P{Is_Grapheme_Cluster_Break= LV}', "");
    Expect(1, 55176, '\P{^Is_Grapheme_Cluster_Break= LV}', "");
    Expect(0, 55177, '\p{Is_Grapheme_Cluster_Break= LV}', "");
    Expect(1, 55177, '\p{^Is_Grapheme_Cluster_Break= LV}', "");
    Expect(1, 55177, '\P{Is_Grapheme_Cluster_Break= LV}', "");
    Expect(0, 55177, '\P{^Is_Grapheme_Cluster_Break= LV}', "");
    Error('\p{Is_GCB=--LV/a/}');
    Error('\P{Is_GCB=--LV/a/}');
    Expect(1, 55176, '\p{Is_GCB=lv}', "");
    Expect(0, 55176, '\p{^Is_GCB=lv}', "");
    Expect(0, 55176, '\P{Is_GCB=lv}', "");
    Expect(1, 55176, '\P{^Is_GCB=lv}', "");
    Expect(0, 55177, '\p{Is_GCB=lv}', "");
    Expect(1, 55177, '\p{^Is_GCB=lv}', "");
    Expect(1, 55177, '\P{Is_GCB=lv}', "");
    Expect(0, 55177, '\P{^Is_GCB=lv}', "");
    Expect(1, 55176, '\p{Is_GCB=_-lv}', "");
    Expect(0, 55176, '\p{^Is_GCB=_-lv}', "");
    Expect(0, 55176, '\P{Is_GCB=_-lv}', "");
    Expect(1, 55176, '\P{^Is_GCB=_-lv}', "");
    Expect(0, 55177, '\p{Is_GCB=_-lv}', "");
    Expect(1, 55177, '\p{^Is_GCB=_-lv}', "");
    Expect(1, 55177, '\P{Is_GCB=_-lv}', "");
    Expect(0, 55177, '\P{^Is_GCB=_-lv}', "");
    Error('\p{Grapheme_Cluster_Break= /a/LVT}');
    Error('\P{Grapheme_Cluster_Break= /a/LVT}');
    Expect(1, 55203, '\p{Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55203, '\p{^Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55203, '\P{Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55203, '\P{^Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55204, '\p{Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55204, '\p{^Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55204, '\P{Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55204, '\P{^Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55203, '\p{Grapheme_Cluster_Break=_	lvt}', "");
    Expect(0, 55203, '\p{^Grapheme_Cluster_Break=_	lvt}', "");
    Expect(0, 55203, '\P{Grapheme_Cluster_Break=_	lvt}', "");
    Expect(1, 55203, '\P{^Grapheme_Cluster_Break=_	lvt}', "");
    Expect(0, 55204, '\p{Grapheme_Cluster_Break=_	lvt}', "");
    Expect(1, 55204, '\p{^Grapheme_Cluster_Break=_	lvt}', "");
    Expect(1, 55204, '\P{Grapheme_Cluster_Break=_	lvt}', "");
    Expect(0, 55204, '\P{^Grapheme_Cluster_Break=_	lvt}', "");
    Error('\p{GCB=-LVT/a/}');
    Error('\P{GCB=-LVT/a/}');
    Expect(1, 55203, '\p{GCB=lvt}', "");
    Expect(0, 55203, '\p{^GCB=lvt}', "");
    Expect(0, 55203, '\P{GCB=lvt}', "");
    Expect(1, 55203, '\P{^GCB=lvt}', "");
    Expect(0, 55204, '\p{GCB=lvt}', "");
    Expect(1, 55204, '\p{^GCB=lvt}', "");
    Expect(1, 55204, '\P{GCB=lvt}', "");
    Expect(0, 55204, '\P{^GCB=lvt}', "");
    Expect(1, 55203, '\p{GCB=  LVT}', "");
    Expect(0, 55203, '\p{^GCB=  LVT}', "");
    Expect(0, 55203, '\P{GCB=  LVT}', "");
    Expect(1, 55203, '\P{^GCB=  LVT}', "");
    Expect(0, 55204, '\p{GCB=  LVT}', "");
    Expect(1, 55204, '\p{^GCB=  LVT}', "");
    Expect(1, 55204, '\P{GCB=  LVT}', "");
    Expect(0, 55204, '\P{^GCB=  LVT}', "");
    Error('\p{Is_Grapheme_Cluster_Break=/a/__LVT}');
    Error('\P{Is_Grapheme_Cluster_Break=/a/__LVT}');
    Expect(1, 55203, '\p{Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55203, '\p{^Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55203, '\P{Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55203, '\P{^Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55204, '\p{Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55204, '\p{^Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55204, '\P{Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55204, '\P{^Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55203, '\p{Is_Grapheme_Cluster_Break=	 lvt}', "");
    Expect(0, 55203, '\p{^Is_Grapheme_Cluster_Break=	 lvt}', "");
    Expect(0, 55203, '\P{Is_Grapheme_Cluster_Break=	 lvt}', "");
    Expect(1, 55203, '\P{^Is_Grapheme_Cluster_Break=	 lvt}', "");
    Expect(0, 55204, '\p{Is_Grapheme_Cluster_Break=	 lvt}', "");
    Expect(1, 55204, '\p{^Is_Grapheme_Cluster_Break=	 lvt}', "");
    Expect(1, 55204, '\P{Is_Grapheme_Cluster_Break=	 lvt}', "");
    Expect(0, 55204, '\P{^Is_Grapheme_Cluster_Break=	 lvt}', "");
    Error('\p{Is_GCB=_-LVT/a/}');
    Error('\P{Is_GCB=_-LVT/a/}');
    Expect(1, 55203, '\p{Is_GCB=lvt}', "");
    Expect(0, 55203, '\p{^Is_GCB=lvt}', "");
    Expect(0, 55203, '\P{Is_GCB=lvt}', "");
    Expect(1, 55203, '\P{^Is_GCB=lvt}', "");
    Expect(0, 55204, '\p{Is_GCB=lvt}', "");
    Expect(1, 55204, '\p{^Is_GCB=lvt}', "");
    Expect(1, 55204, '\P{Is_GCB=lvt}', "");
    Expect(0, 55204, '\P{^Is_GCB=lvt}', "");
    Expect(1, 55203, '\p{Is_GCB=-LVT}', "");
    Expect(0, 55203, '\p{^Is_GCB=-LVT}', "");
    Expect(0, 55203, '\P{Is_GCB=-LVT}', "");
    Expect(1, 55203, '\P{^Is_GCB=-LVT}', "");
    Expect(0, 55204, '\p{Is_GCB=-LVT}', "");
    Expect(1, 55204, '\p{^Is_GCB=-LVT}', "");
    Expect(1, 55204, '\P{Is_GCB=-LVT}', "");
    Expect(0, 55204, '\P{^Is_GCB=-LVT}', "");
    Error('\p{Grapheme_Cluster_Break=-PREPEND:=}');
    Error('\P{Grapheme_Cluster_Break=-PREPEND:=}');
    Expect(1, 73030, '\p{Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73030, '\p{^Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73030, '\P{Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73030, '\P{^Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73031, '\p{Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73031, '\p{^Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73031, '\P{Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73031, '\P{^Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73030, '\p{Grapheme_Cluster_Break=-Prepend}', "");
    Expect(0, 73030, '\p{^Grapheme_Cluster_Break=-Prepend}', "");
    Expect(0, 73030, '\P{Grapheme_Cluster_Break=-Prepend}', "");
    Expect(1, 73030, '\P{^Grapheme_Cluster_Break=-Prepend}', "");
    Expect(0, 73031, '\p{Grapheme_Cluster_Break=-Prepend}', "");
    Expect(1, 73031, '\p{^Grapheme_Cluster_Break=-Prepend}', "");
    Expect(1, 73031, '\P{Grapheme_Cluster_Break=-Prepend}', "");
    Expect(0, 73031, '\P{^Grapheme_Cluster_Break=-Prepend}', "");
    Error('\p{GCB= :=pp}');
    Error('\P{GCB= :=pp}');
    Expect(1, 73030, '\p{GCB=pp}', "");
    Expect(0, 73030, '\p{^GCB=pp}', "");
    Expect(0, 73030, '\P{GCB=pp}', "");
    Expect(1, 73030, '\P{^GCB=pp}', "");
    Expect(0, 73031, '\p{GCB=pp}', "");
    Expect(1, 73031, '\p{^GCB=pp}', "");
    Expect(1, 73031, '\P{GCB=pp}', "");
    Expect(0, 73031, '\P{^GCB=pp}', "");
    Expect(1, 73030, '\p{GCB=_-PP}', "");
    Expect(0, 73030, '\p{^GCB=_-PP}', "");
    Expect(0, 73030, '\P{GCB=_-PP}', "");
    Expect(1, 73030, '\P{^GCB=_-PP}', "");
    Expect(0, 73031, '\p{GCB=_-PP}', "");
    Expect(1, 73031, '\p{^GCB=_-PP}', "");
    Expect(1, 73031, '\P{GCB=_-PP}', "");
    Expect(0, 73031, '\P{^GCB=_-PP}', "");
    Error('\p{Is_Grapheme_Cluster_Break=  Prepend:=}');
    Error('\P{Is_Grapheme_Cluster_Break=  Prepend:=}');
    Expect(1, 73030, '\p{Is_Grapheme_Cluster_Break:prepend}', "");
    Expect(0, 73030, '\p{^Is_Grapheme_Cluster_Break:prepend}', "");
    Expect(0, 73030, '\P{Is_Grapheme_Cluster_Break:prepend}', "");
    Expect(1, 73030, '\P{^Is_Grapheme_Cluster_Break:prepend}', "");
    Expect(0, 73031, '\p{Is_Grapheme_Cluster_Break:prepend}', "");
    Expect(1, 73031, '\p{^Is_Grapheme_Cluster_Break:prepend}', "");
    Expect(1, 73031, '\P{Is_Grapheme_Cluster_Break:prepend}', "");
    Expect(0, 73031, '\P{^Is_Grapheme_Cluster_Break:prepend}', "");
    Expect(1, 73030, '\p{Is_Grapheme_Cluster_Break=	_Prepend}', "");
    Expect(0, 73030, '\p{^Is_Grapheme_Cluster_Break=	_Prepend}', "");
    Expect(0, 73030, '\P{Is_Grapheme_Cluster_Break=	_Prepend}', "");
    Expect(1, 73030, '\P{^Is_Grapheme_Cluster_Break=	_Prepend}', "");
    Expect(0, 73031, '\p{Is_Grapheme_Cluster_Break=	_Prepend}', "");
    Expect(1, 73031, '\p{^Is_Grapheme_Cluster_Break=	_Prepend}', "");
    Expect(1, 73031, '\P{Is_Grapheme_Cluster_Break=	_Prepend}', "");
    Expect(0, 73031, '\P{^Is_Grapheme_Cluster_Break=	_Prepend}', "");
    Error('\p{Is_GCB= _pp:=}');
    Error('\P{Is_GCB= _pp:=}');
    Expect(1, 73030, '\p{Is_GCB:	pp}', "");
    Expect(0, 73030, '\p{^Is_GCB:	pp}', "");
    Expect(0, 73030, '\P{Is_GCB:	pp}', "");
    Expect(1, 73030, '\P{^Is_GCB:	pp}', "");
    Expect(0, 73031, '\p{Is_GCB:	pp}', "");
    Expect(1, 73031, '\p{^Is_GCB:	pp}', "");
    Expect(1, 73031, '\P{Is_GCB:	pp}', "");
    Expect(0, 73031, '\P{^Is_GCB:	pp}', "");
    Expect(1, 73030, '\p{Is_GCB:	_PP}', "");
    Expect(0, 73030, '\p{^Is_GCB:	_PP}', "");
    Expect(0, 73030, '\P{Is_GCB:	_PP}', "");
    Expect(1, 73030, '\P{^Is_GCB:	_PP}', "");
    Expect(0, 73031, '\p{Is_GCB:	_PP}', "");
    Expect(1, 73031, '\p{^Is_GCB:	_PP}', "");
    Expect(1, 73031, '\P{Is_GCB:	_PP}', "");
    Expect(0, 73031, '\P{^Is_GCB:	_PP}', "");
    Error('\p{Grapheme_Cluster_Break= /a/Regional_Indicator}');
    Error('\P{Grapheme_Cluster_Break= /a/Regional_Indicator}');
    Expect(1, 127487, '\p{Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Grapheme_Cluster_Break=- regional_Indicator}', "");
    Expect(0, 127487, '\p{^Grapheme_Cluster_Break=- regional_Indicator}', "");
    Expect(0, 127487, '\P{Grapheme_Cluster_Break=- regional_Indicator}', "");
    Expect(1, 127487, '\P{^Grapheme_Cluster_Break=- regional_Indicator}', "");
    Expect(0, 127488, '\p{Grapheme_Cluster_Break=- regional_Indicator}', "");
    Expect(1, 127488, '\p{^Grapheme_Cluster_Break=- regional_Indicator}', "");
    Expect(1, 127488, '\P{Grapheme_Cluster_Break=- regional_Indicator}', "");
    Expect(0, 127488, '\P{^Grapheme_Cluster_Break=- regional_Indicator}', "");
    Error('\p{GCB=:=  RI}');
    Error('\P{GCB=:=  RI}');
    Expect(1, 127487, '\p{GCB=ri}', "");
    Expect(0, 127487, '\p{^GCB=ri}', "");
    Expect(0, 127487, '\P{GCB=ri}', "");
    Expect(1, 127487, '\P{^GCB=ri}', "");
    Expect(0, 127488, '\p{GCB=ri}', "");
    Expect(1, 127488, '\p{^GCB=ri}', "");
    Expect(1, 127488, '\P{GCB=ri}', "");
    Expect(0, 127488, '\P{^GCB=ri}', "");
    Expect(1, 127487, '\p{GCB=_	RI}', "");
    Expect(0, 127487, '\p{^GCB=_	RI}', "");
    Expect(0, 127487, '\P{GCB=_	RI}', "");
    Expect(1, 127487, '\P{^GCB=_	RI}', "");
    Expect(0, 127488, '\p{GCB=_	RI}', "");
    Expect(1, 127488, '\p{^GCB=_	RI}', "");
    Expect(1, 127488, '\P{GCB=_	RI}', "");
    Expect(0, 127488, '\P{^GCB=_	RI}', "");
    Error('\p{Is_Grapheme_Cluster_Break=- Regional_Indicator:=}');
    Error('\P{Is_Grapheme_Cluster_Break=- Regional_Indicator:=}');
    Expect(1, 127487, '\p{Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Is_Grapheme_Cluster_Break= _Regional_Indicator}', "");
    Expect(0, 127487, '\p{^Is_Grapheme_Cluster_Break= _Regional_Indicator}', "");
    Expect(0, 127487, '\P{Is_Grapheme_Cluster_Break= _Regional_Indicator}', "");
    Expect(1, 127487, '\P{^Is_Grapheme_Cluster_Break= _Regional_Indicator}', "");
    Expect(0, 127488, '\p{Is_Grapheme_Cluster_Break= _Regional_Indicator}', "");
    Expect(1, 127488, '\p{^Is_Grapheme_Cluster_Break= _Regional_Indicator}', "");
    Expect(1, 127488, '\P{Is_Grapheme_Cluster_Break= _Regional_Indicator}', "");
    Expect(0, 127488, '\P{^Is_Grapheme_Cluster_Break= _Regional_Indicator}', "");
    Error('\p{Is_GCB=	ri/a/}');
    Error('\P{Is_GCB=	ri/a/}');
    Expect(1, 127487, '\p{Is_GCB:   ri}', "");
    Expect(0, 127487, '\p{^Is_GCB:   ri}', "");
    Expect(0, 127487, '\P{Is_GCB:   ri}', "");
    Expect(1, 127487, '\P{^Is_GCB:   ri}', "");
    Expect(0, 127488, '\p{Is_GCB:   ri}', "");
    Expect(1, 127488, '\p{^Is_GCB:   ri}', "");
    Expect(1, 127488, '\P{Is_GCB:   ri}', "");
    Expect(0, 127488, '\P{^Is_GCB:   ri}', "");
    Expect(1, 127487, '\p{Is_GCB=__RI}', "");
    Expect(0, 127487, '\p{^Is_GCB=__RI}', "");
    Expect(0, 127487, '\P{Is_GCB=__RI}', "");
    Expect(1, 127487, '\P{^Is_GCB=__RI}', "");
    Expect(0, 127488, '\p{Is_GCB=__RI}', "");
    Expect(1, 127488, '\p{^Is_GCB=__RI}', "");
    Expect(1, 127488, '\P{Is_GCB=__RI}', "");
    Expect(0, 127488, '\P{^Is_GCB=__RI}', "");
    Error('\p{Grapheme_Cluster_Break=	_SpacingMark:=}');
    Error('\P{Grapheme_Cluster_Break=	_SpacingMark:=}');
    Expect(1, 119149, '\p{Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119149, '\p{^Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119149, '\P{Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119149, '\P{^Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119150, '\p{Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119150, '\p{^Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119150, '\P{Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119150, '\P{^Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119149, '\p{Grapheme_Cluster_Break= SPACINGMARK}', "");
    Expect(0, 119149, '\p{^Grapheme_Cluster_Break= SPACINGMARK}', "");
    Expect(0, 119149, '\P{Grapheme_Cluster_Break= SPACINGMARK}', "");
    Expect(1, 119149, '\P{^Grapheme_Cluster_Break= SPACINGMARK}', "");
    Expect(0, 119150, '\p{Grapheme_Cluster_Break= SPACINGMARK}', "");
    Expect(1, 119150, '\p{^Grapheme_Cluster_Break= SPACINGMARK}', "");
    Expect(1, 119150, '\P{Grapheme_Cluster_Break= SPACINGMARK}', "");
    Expect(0, 119150, '\P{^Grapheme_Cluster_Break= SPACINGMARK}', "");
    Error('\p{GCB=/a/sm}');
    Error('\P{GCB=/a/sm}');
    Expect(1, 119149, '\p{GCB:	sm}', "");
    Expect(0, 119149, '\p{^GCB:	sm}', "");
    Expect(0, 119149, '\P{GCB:	sm}', "");
    Expect(1, 119149, '\P{^GCB:	sm}', "");
    Expect(0, 119150, '\p{GCB:	sm}', "");
    Expect(1, 119150, '\p{^GCB:	sm}', "");
    Expect(1, 119150, '\P{GCB:	sm}', "");
    Expect(0, 119150, '\P{^GCB:	sm}', "");
    Expect(1, 119149, '\p{GCB=_SM}', "");
    Expect(0, 119149, '\p{^GCB=_SM}', "");
    Expect(0, 119149, '\P{GCB=_SM}', "");
    Expect(1, 119149, '\P{^GCB=_SM}', "");
    Expect(0, 119150, '\p{GCB=_SM}', "");
    Expect(1, 119150, '\p{^GCB=_SM}', "");
    Expect(1, 119150, '\P{GCB=_SM}', "");
    Expect(0, 119150, '\P{^GCB=_SM}', "");
    Error('\p{Is_Grapheme_Cluster_Break=-:=SpacingMark}');
    Error('\P{Is_Grapheme_Cluster_Break=-:=SpacingMark}');
    Expect(1, 119149, '\p{Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119149, '\p{^Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119149, '\P{Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119149, '\P{^Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119150, '\p{Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119150, '\p{^Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119150, '\P{Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119150, '\P{^Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119149, '\p{Is_Grapheme_Cluster_Break=-	SPACINGMARK}', "");
    Expect(0, 119149, '\p{^Is_Grapheme_Cluster_Break=-	SPACINGMARK}', "");
    Expect(0, 119149, '\P{Is_Grapheme_Cluster_Break=-	SPACINGMARK}', "");
    Expect(1, 119149, '\P{^Is_Grapheme_Cluster_Break=-	SPACINGMARK}', "");
    Expect(0, 119150, '\p{Is_Grapheme_Cluster_Break=-	SPACINGMARK}', "");
    Expect(1, 119150, '\p{^Is_Grapheme_Cluster_Break=-	SPACINGMARK}', "");
    Expect(1, 119150, '\P{Is_Grapheme_Cluster_Break=-	SPACINGMARK}', "");
    Expect(0, 119150, '\P{^Is_Grapheme_Cluster_Break=-	SPACINGMARK}', "");
    Error('\p{Is_GCB=- SM/a/}');
    Error('\P{Is_GCB=- SM/a/}');
    Expect(1, 119149, '\p{Is_GCB:sm}', "");
    Expect(0, 119149, '\p{^Is_GCB:sm}', "");
    Expect(0, 119149, '\P{Is_GCB:sm}', "");
    Expect(1, 119149, '\P{^Is_GCB:sm}', "");
    Expect(0, 119150, '\p{Is_GCB:sm}', "");
    Expect(1, 119150, '\p{^Is_GCB:sm}', "");
    Expect(1, 119150, '\P{Is_GCB:sm}', "");
    Expect(0, 119150, '\P{^Is_GCB:sm}', "");
    Expect(1, 119149, '\p{Is_GCB= _SM}', "");
    Expect(0, 119149, '\p{^Is_GCB= _SM}', "");
    Expect(0, 119149, '\P{Is_GCB= _SM}', "");
    Expect(1, 119149, '\P{^Is_GCB= _SM}', "");
    Expect(0, 119150, '\p{Is_GCB= _SM}', "");
    Expect(1, 119150, '\p{^Is_GCB= _SM}', "");
    Expect(1, 119150, '\P{Is_GCB= _SM}', "");
    Expect(0, 119150, '\P{^Is_GCB= _SM}', "");
    Error('\p{Grapheme_Cluster_Break=	T/a/}');
    Error('\P{Grapheme_Cluster_Break=	T/a/}');
    Expect(1, 55291, '\p{Grapheme_Cluster_Break=t}', "");
    Expect(0, 55291, '\p{^Grapheme_Cluster_Break=t}', "");
    Expect(0, 55291, '\P{Grapheme_Cluster_Break=t}', "");
    Expect(1, 55291, '\P{^Grapheme_Cluster_Break=t}', "");
    Expect(0, 55292, '\p{Grapheme_Cluster_Break=t}', "");
    Expect(1, 55292, '\p{^Grapheme_Cluster_Break=t}', "");
    Expect(1, 55292, '\P{Grapheme_Cluster_Break=t}', "");
    Expect(0, 55292, '\P{^Grapheme_Cluster_Break=t}', "");
    Expect(1, 55291, '\p{Grapheme_Cluster_Break=  t}', "");
    Expect(0, 55291, '\p{^Grapheme_Cluster_Break=  t}', "");
    Expect(0, 55291, '\P{Grapheme_Cluster_Break=  t}', "");
    Expect(1, 55291, '\P{^Grapheme_Cluster_Break=  t}', "");
    Expect(0, 55292, '\p{Grapheme_Cluster_Break=  t}', "");
    Expect(1, 55292, '\p{^Grapheme_Cluster_Break=  t}', "");
    Expect(1, 55292, '\P{Grapheme_Cluster_Break=  t}', "");
    Expect(0, 55292, '\P{^Grapheme_Cluster_Break=  t}', "");
    Error('\p{GCB: _ T/a/}');
    Error('\P{GCB: _ T/a/}');
    Expect(1, 55291, '\p{GCB=t}', "");
    Expect(0, 55291, '\p{^GCB=t}', "");
    Expect(0, 55291, '\P{GCB=t}', "");
    Expect(1, 55291, '\P{^GCB=t}', "");
    Expect(0, 55292, '\p{GCB=t}', "");
    Expect(1, 55292, '\p{^GCB=t}', "");
    Expect(1, 55292, '\P{GCB=t}', "");
    Expect(0, 55292, '\P{^GCB=t}', "");
    Expect(1, 55291, '\p{GCB=	 T}', "");
    Expect(0, 55291, '\p{^GCB=	 T}', "");
    Expect(0, 55291, '\P{GCB=	 T}', "");
    Expect(1, 55291, '\P{^GCB=	 T}', "");
    Expect(0, 55292, '\p{GCB=	 T}', "");
    Expect(1, 55292, '\p{^GCB=	 T}', "");
    Expect(1, 55292, '\P{GCB=	 T}', "");
    Expect(0, 55292, '\P{^GCB=	 T}', "");
    Error('\p{Is_Grapheme_Cluster_Break=	-T:=}');
    Error('\P{Is_Grapheme_Cluster_Break=	-T:=}');
    Expect(1, 55291, '\p{Is_Grapheme_Cluster_Break:t}', "");
    Expect(0, 55291, '\p{^Is_Grapheme_Cluster_Break:t}', "");
    Expect(0, 55291, '\P{Is_Grapheme_Cluster_Break:t}', "");
    Expect(1, 55291, '\P{^Is_Grapheme_Cluster_Break:t}', "");
    Expect(0, 55292, '\p{Is_Grapheme_Cluster_Break:t}', "");
    Expect(1, 55292, '\p{^Is_Grapheme_Cluster_Break:t}', "");
    Expect(1, 55292, '\P{Is_Grapheme_Cluster_Break:t}', "");
    Expect(0, 55292, '\P{^Is_Grapheme_Cluster_Break:t}', "");
    Expect(1, 55291, '\p{Is_Grapheme_Cluster_Break=	 T}', "");
    Expect(0, 55291, '\p{^Is_Grapheme_Cluster_Break=	 T}', "");
    Expect(0, 55291, '\P{Is_Grapheme_Cluster_Break=	 T}', "");
    Expect(1, 55291, '\P{^Is_Grapheme_Cluster_Break=	 T}', "");
    Expect(0, 55292, '\p{Is_Grapheme_Cluster_Break=	 T}', "");
    Expect(1, 55292, '\p{^Is_Grapheme_Cluster_Break=	 T}', "");
    Expect(1, 55292, '\P{Is_Grapheme_Cluster_Break=	 T}', "");
    Expect(0, 55292, '\P{^Is_Grapheme_Cluster_Break=	 T}', "");
    Error('\p{Is_GCB=-/a/T}');
    Error('\P{Is_GCB=-/a/T}');
    Expect(1, 55291, '\p{Is_GCB=t}', "");
    Expect(0, 55291, '\p{^Is_GCB=t}', "");
    Expect(0, 55291, '\P{Is_GCB=t}', "");
    Expect(1, 55291, '\P{^Is_GCB=t}', "");
    Expect(0, 55292, '\p{Is_GCB=t}', "");
    Expect(1, 55292, '\p{^Is_GCB=t}', "");
    Expect(1, 55292, '\P{Is_GCB=t}', "");
    Expect(0, 55292, '\P{^Is_GCB=t}', "");
    Expect(1, 55291, '\p{Is_GCB=-	t}', "");
    Expect(0, 55291, '\p{^Is_GCB=-	t}', "");
    Expect(0, 55291, '\P{Is_GCB=-	t}', "");
    Expect(1, 55291, '\P{^Is_GCB=-	t}', "");
    Expect(0, 55292, '\p{Is_GCB=-	t}', "");
    Expect(1, 55292, '\p{^Is_GCB=-	t}', "");
    Expect(1, 55292, '\P{Is_GCB=-	t}', "");
    Expect(0, 55292, '\P{^Is_GCB=-	t}', "");
    Error('\p{Grapheme_Cluster_Break=:= 	V}');
    Error('\P{Grapheme_Cluster_Break=:= 	V}');
    Expect(1, 55238, '\p{Grapheme_Cluster_Break=v}', "");
    Expect(0, 55238, '\p{^Grapheme_Cluster_Break=v}', "");
    Expect(0, 55238, '\P{Grapheme_Cluster_Break=v}', "");
    Expect(1, 55238, '\P{^Grapheme_Cluster_Break=v}', "");
    Expect(0, 55239, '\p{Grapheme_Cluster_Break=v}', "");
    Expect(1, 55239, '\p{^Grapheme_Cluster_Break=v}', "");
    Expect(1, 55239, '\P{Grapheme_Cluster_Break=v}', "");
    Expect(0, 55239, '\P{^Grapheme_Cluster_Break=v}', "");
    Expect(1, 55238, '\p{Grapheme_Cluster_Break=	 v}', "");
    Expect(0, 55238, '\p{^Grapheme_Cluster_Break=	 v}', "");
    Expect(0, 55238, '\P{Grapheme_Cluster_Break=	 v}', "");
    Expect(1, 55238, '\P{^Grapheme_Cluster_Break=	 v}', "");
    Expect(0, 55239, '\p{Grapheme_Cluster_Break=	 v}', "");
    Expect(1, 55239, '\p{^Grapheme_Cluster_Break=	 v}', "");
    Expect(1, 55239, '\P{Grapheme_Cluster_Break=	 v}', "");
    Expect(0, 55239, '\P{^Grapheme_Cluster_Break=	 v}', "");
    Error('\p{GCB=:=--V}');
    Error('\P{GCB=:=--V}');
    Expect(1, 55238, '\p{GCB=v}', "");
    Expect(0, 55238, '\p{^GCB=v}', "");
    Expect(0, 55238, '\P{GCB=v}', "");
    Expect(1, 55238, '\P{^GCB=v}', "");
    Expect(0, 55239, '\p{GCB=v}', "");
    Expect(1, 55239, '\p{^GCB=v}', "");
    Expect(1, 55239, '\P{GCB=v}', "");
    Expect(0, 55239, '\P{^GCB=v}', "");
    Expect(1, 55238, '\p{GCB:	-_v}', "");
    Expect(0, 55238, '\p{^GCB:	-_v}', "");
    Expect(0, 55238, '\P{GCB:	-_v}', "");
    Expect(1, 55238, '\P{^GCB:	-_v}', "");
    Expect(0, 55239, '\p{GCB:	-_v}', "");
    Expect(1, 55239, '\p{^GCB:	-_v}', "");
    Expect(1, 55239, '\P{GCB:	-_v}', "");
    Expect(0, 55239, '\P{^GCB:	-_v}', "");
    Error('\p{Is_Grapheme_Cluster_Break=:=V}');
    Error('\P{Is_Grapheme_Cluster_Break=:=V}');
    Expect(1, 55238, '\p{Is_Grapheme_Cluster_Break=v}', "");
    Expect(0, 55238, '\p{^Is_Grapheme_Cluster_Break=v}', "");
    Expect(0, 55238, '\P{Is_Grapheme_Cluster_Break=v}', "");
    Expect(1, 55238, '\P{^Is_Grapheme_Cluster_Break=v}', "");
    Expect(0, 55239, '\p{Is_Grapheme_Cluster_Break=v}', "");
    Expect(1, 55239, '\p{^Is_Grapheme_Cluster_Break=v}', "");
    Expect(1, 55239, '\P{Is_Grapheme_Cluster_Break=v}', "");
    Expect(0, 55239, '\P{^Is_Grapheme_Cluster_Break=v}', "");
    Expect(1, 55238, '\p{Is_Grapheme_Cluster_Break= v}', "");
    Expect(0, 55238, '\p{^Is_Grapheme_Cluster_Break= v}', "");
    Expect(0, 55238, '\P{Is_Grapheme_Cluster_Break= v}', "");
    Expect(1, 55238, '\P{^Is_Grapheme_Cluster_Break= v}', "");
    Expect(0, 55239, '\p{Is_Grapheme_Cluster_Break= v}', "");
    Expect(1, 55239, '\p{^Is_Grapheme_Cluster_Break= v}', "");
    Expect(1, 55239, '\P{Is_Grapheme_Cluster_Break= v}', "");
    Expect(0, 55239, '\P{^Is_Grapheme_Cluster_Break= v}', "");
    Error('\p{Is_GCB=_:=V}');
    Error('\P{Is_GCB=_:=V}');
    Expect(1, 55238, '\p{Is_GCB=v}', "");
    Expect(0, 55238, '\p{^Is_GCB=v}', "");
    Expect(0, 55238, '\P{Is_GCB=v}', "");
    Expect(1, 55238, '\P{^Is_GCB=v}', "");
    Expect(0, 55239, '\p{Is_GCB=v}', "");
    Expect(1, 55239, '\p{^Is_GCB=v}', "");
    Expect(1, 55239, '\P{Is_GCB=v}', "");
    Expect(0, 55239, '\P{^Is_GCB=v}', "");
    Expect(1, 55238, '\p{Is_GCB=	V}', "");
    Expect(0, 55238, '\p{^Is_GCB=	V}', "");
    Expect(0, 55238, '\P{Is_GCB=	V}', "");
    Expect(1, 55238, '\P{^Is_GCB=	V}', "");
    Expect(0, 55239, '\p{Is_GCB=	V}', "");
    Expect(1, 55239, '\p{^Is_GCB=	V}', "");
    Expect(1, 55239, '\P{Is_GCB=	V}', "");
    Expect(0, 55239, '\P{^Is_GCB=	V}', "");
    Error('\p{Grapheme_Cluster_Break=	/a/Other}');
    Error('\P{Grapheme_Cluster_Break=	/a/Other}');
    Expect(1, 921600, '\p{Grapheme_Cluster_Break=other}', "");
    Expect(0, 921600, '\p{^Grapheme_Cluster_Break=other}', "");
    Expect(0, 921600, '\P{Grapheme_Cluster_Break=other}', "");
    Expect(1, 921600, '\P{^Grapheme_Cluster_Break=other}', "");
    Expect(0, 921599, '\p{Grapheme_Cluster_Break=other}', "");
    Expect(1, 921599, '\p{^Grapheme_Cluster_Break=other}', "");
    Expect(1, 921599, '\P{Grapheme_Cluster_Break=other}', "");
    Expect(0, 921599, '\P{^Grapheme_Cluster_Break=other}', "");
    Expect(1, 921600, '\p{Grapheme_Cluster_Break=-	Other}', "");
    Expect(0, 921600, '\p{^Grapheme_Cluster_Break=-	Other}', "");
    Expect(0, 921600, '\P{Grapheme_Cluster_Break=-	Other}', "");
    Expect(1, 921600, '\P{^Grapheme_Cluster_Break=-	Other}', "");
    Expect(0, 921599, '\p{Grapheme_Cluster_Break=-	Other}', "");
    Expect(1, 921599, '\p{^Grapheme_Cluster_Break=-	Other}', "");
    Expect(1, 921599, '\P{Grapheme_Cluster_Break=-	Other}', "");
    Expect(0, 921599, '\P{^Grapheme_Cluster_Break=-	Other}', "");
    Error('\p{GCB= 	xx/a/}');
    Error('\P{GCB= 	xx/a/}');
    Expect(1, 921600, '\p{GCB=xx}', "");
    Expect(0, 921600, '\p{^GCB=xx}', "");
    Expect(0, 921600, '\P{GCB=xx}', "");
    Expect(1, 921600, '\P{^GCB=xx}', "");
    Expect(0, 921599, '\p{GCB=xx}', "");
    Expect(1, 921599, '\p{^GCB=xx}', "");
    Expect(1, 921599, '\P{GCB=xx}', "");
    Expect(0, 921599, '\P{^GCB=xx}', "");
    Expect(1, 921600, '\p{GCB: 	xx}', "");
    Expect(0, 921600, '\p{^GCB: 	xx}', "");
    Expect(0, 921600, '\P{GCB: 	xx}', "");
    Expect(1, 921600, '\P{^GCB: 	xx}', "");
    Expect(0, 921599, '\p{GCB: 	xx}', "");
    Expect(1, 921599, '\p{^GCB: 	xx}', "");
    Expect(1, 921599, '\P{GCB: 	xx}', "");
    Expect(0, 921599, '\P{^GCB: 	xx}', "");
    Error('\p{Is_Grapheme_Cluster_Break=:=-Other}');
    Error('\P{Is_Grapheme_Cluster_Break=:=-Other}');
    Expect(1, 921600, '\p{Is_Grapheme_Cluster_Break=other}', "");
    Expect(0, 921600, '\p{^Is_Grapheme_Cluster_Break=other}', "");
    Expect(0, 921600, '\P{Is_Grapheme_Cluster_Break=other}', "");
    Expect(1, 921600, '\P{^Is_Grapheme_Cluster_Break=other}', "");
    Expect(0, 921599, '\p{Is_Grapheme_Cluster_Break=other}', "");
    Expect(1, 921599, '\p{^Is_Grapheme_Cluster_Break=other}', "");
    Expect(1, 921599, '\P{Is_Grapheme_Cluster_Break=other}', "");
    Expect(0, 921599, '\P{^Is_Grapheme_Cluster_Break=other}', "");
    Expect(1, 921600, '\p{Is_Grapheme_Cluster_Break=		other}', "");
    Expect(0, 921600, '\p{^Is_Grapheme_Cluster_Break=		other}', "");
    Expect(0, 921600, '\P{Is_Grapheme_Cluster_Break=		other}', "");
    Expect(1, 921600, '\P{^Is_Grapheme_Cluster_Break=		other}', "");
    Expect(0, 921599, '\p{Is_Grapheme_Cluster_Break=		other}', "");
    Expect(1, 921599, '\p{^Is_Grapheme_Cluster_Break=		other}', "");
    Expect(1, 921599, '\P{Is_Grapheme_Cluster_Break=		other}', "");
    Expect(0, 921599, '\P{^Is_Grapheme_Cluster_Break=		other}', "");
    Error('\p{Is_GCB=/a/	 XX}');
    Error('\P{Is_GCB=/a/	 XX}');
    Expect(1, 921600, '\p{Is_GCB=xx}', "");
    Expect(0, 921600, '\p{^Is_GCB=xx}', "");
    Expect(0, 921600, '\P{Is_GCB=xx}', "");
    Expect(1, 921600, '\P{^Is_GCB=xx}', "");
    Expect(0, 921599, '\p{Is_GCB=xx}', "");
    Expect(1, 921599, '\p{^Is_GCB=xx}', "");
    Expect(1, 921599, '\P{Is_GCB=xx}', "");
    Expect(0, 921599, '\P{^Is_GCB=xx}', "");
    Expect(1, 921600, '\p{Is_GCB:   --XX}', "");
    Expect(0, 921600, '\p{^Is_GCB:   --XX}', "");
    Expect(0, 921600, '\P{Is_GCB:   --XX}', "");
    Expect(1, 921600, '\P{^Is_GCB:   --XX}', "");
    Expect(0, 921599, '\p{Is_GCB:   --XX}', "");
    Expect(1, 921599, '\p{^Is_GCB:   --XX}', "");
    Expect(1, 921599, '\P{Is_GCB:   --XX}', "");
    Expect(0, 921599, '\P{^Is_GCB:   --XX}', "");
    Error('\p{Grapheme_Cluster_Break= ZWJ:=}');
    Error('\P{Grapheme_Cluster_Break= ZWJ:=}');
    Expect(1, 8205, '\p{Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8205, '\p{^Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8205, '\P{Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8205, '\P{^Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8206, '\p{Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8206, '\p{^Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8206, '\P{Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8206, '\P{^Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8205, '\p{Grapheme_Cluster_Break= 	ZWJ}', "");
    Expect(0, 8205, '\p{^Grapheme_Cluster_Break= 	ZWJ}', "");
    Expect(0, 8205, '\P{Grapheme_Cluster_Break= 	ZWJ}', "");
    Expect(1, 8205, '\P{^Grapheme_Cluster_Break= 	ZWJ}', "");
    Expect(0, 8206, '\p{Grapheme_Cluster_Break= 	ZWJ}', "");
    Expect(1, 8206, '\p{^Grapheme_Cluster_Break= 	ZWJ}', "");
    Expect(1, 8206, '\P{Grapheme_Cluster_Break= 	ZWJ}', "");
    Expect(0, 8206, '\P{^Grapheme_Cluster_Break= 	ZWJ}', "");
    Error('\p{GCB= /a/ZWJ}');
    Error('\P{GCB= /a/ZWJ}');
    Expect(1, 8205, '\p{GCB=zwj}', "");
    Expect(0, 8205, '\p{^GCB=zwj}', "");
    Expect(0, 8205, '\P{GCB=zwj}', "");
    Expect(1, 8205, '\P{^GCB=zwj}', "");
    Expect(0, 8206, '\p{GCB=zwj}', "");
    Expect(1, 8206, '\p{^GCB=zwj}', "");
    Expect(1, 8206, '\P{GCB=zwj}', "");
    Expect(0, 8206, '\P{^GCB=zwj}', "");
    Expect(1, 8205, '\p{GCB:	__zwj}', "");
    Expect(0, 8205, '\p{^GCB:	__zwj}', "");
    Expect(0, 8205, '\P{GCB:	__zwj}', "");
    Expect(1, 8205, '\P{^GCB:	__zwj}', "");
    Expect(0, 8206, '\p{GCB:	__zwj}', "");
    Expect(1, 8206, '\p{^GCB:	__zwj}', "");
    Expect(1, 8206, '\P{GCB:	__zwj}', "");
    Expect(0, 8206, '\P{^GCB:	__zwj}', "");
    Error('\p{Is_Grapheme_Cluster_Break=--ZWJ:=}');
    Error('\P{Is_Grapheme_Cluster_Break=--ZWJ:=}');
    Expect(1, 8205, '\p{Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8205, '\p{^Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8205, '\P{Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8205, '\P{^Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8206, '\p{Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8206, '\p{^Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8206, '\P{Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8206, '\P{^Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8205, '\p{Is_Grapheme_Cluster_Break=		zwj}', "");
    Expect(0, 8205, '\p{^Is_Grapheme_Cluster_Break=		zwj}', "");
    Expect(0, 8205, '\P{Is_Grapheme_Cluster_Break=		zwj}', "");
    Expect(1, 8205, '\P{^Is_Grapheme_Cluster_Break=		zwj}', "");
    Expect(0, 8206, '\p{Is_Grapheme_Cluster_Break=		zwj}', "");
    Expect(1, 8206, '\p{^Is_Grapheme_Cluster_Break=		zwj}', "");
    Expect(1, 8206, '\P{Is_Grapheme_Cluster_Break=		zwj}', "");
    Expect(0, 8206, '\P{^Is_Grapheme_Cluster_Break=		zwj}', "");
    Error('\p{Is_GCB=_:=ZWJ}');
    Error('\P{Is_GCB=_:=ZWJ}');
    Expect(1, 8205, '\p{Is_GCB=zwj}', "");
    Expect(0, 8205, '\p{^Is_GCB=zwj}', "");
    Expect(0, 8205, '\P{Is_GCB=zwj}', "");
    Expect(1, 8205, '\P{^Is_GCB=zwj}', "");
    Expect(0, 8206, '\p{Is_GCB=zwj}', "");
    Expect(1, 8206, '\p{^Is_GCB=zwj}', "");
    Expect(1, 8206, '\P{Is_GCB=zwj}', "");
    Expect(0, 8206, '\P{^Is_GCB=zwj}', "");
    Expect(1, 8205, '\p{Is_GCB=	ZWJ}', "");
    Expect(0, 8205, '\p{^Is_GCB=	ZWJ}', "");
    Expect(0, 8205, '\P{Is_GCB=	ZWJ}', "");
    Expect(1, 8205, '\P{^Is_GCB=	ZWJ}', "");
    Expect(0, 8206, '\p{Is_GCB=	ZWJ}', "");
    Expect(1, 8206, '\p{^Is_GCB=	ZWJ}', "");
    Expect(1, 8206, '\P{Is_GCB=	ZWJ}', "");
    Expect(0, 8206, '\P{^Is_GCB=	ZWJ}', "");
    Error('\p{Grapheme_Base=	/a/no}');
    Error('\P{Grapheme_Base=	/a/no}');
    Expect(1, 195102, '\p{Grapheme_Base:no}', "");
    Expect(0, 195102, '\p{^Grapheme_Base:no}', "");
    Expect(0, 195102, '\P{Grapheme_Base:no}', "");
    Expect(1, 195102, '\P{^Grapheme_Base:no}', "");
    Expect(0, 195101, '\p{Grapheme_Base:no}', "");
    Expect(1, 195101, '\p{^Grapheme_Base:no}', "");
    Expect(1, 195101, '\P{Grapheme_Base:no}', "");
    Expect(0, 195101, '\P{^Grapheme_Base:no}', "");
    Expect(1, 195102, '\p{Grapheme_Base=_No}', "");
    Expect(0, 195102, '\p{^Grapheme_Base=_No}', "");
    Expect(0, 195102, '\P{Grapheme_Base=_No}', "");
    Expect(1, 195102, '\P{^Grapheme_Base=_No}', "");
    Expect(0, 195101, '\p{Grapheme_Base=_No}', "");
    Expect(1, 195101, '\p{^Grapheme_Base=_No}', "");
    Expect(1, 195101, '\P{Grapheme_Base=_No}', "");
    Expect(0, 195101, '\P{^Grapheme_Base=_No}', "");
    Error('\p{Gr_Base= _N/a/}');
    Error('\P{Gr_Base= _N/a/}');
    Expect(1, 195102, '\p{Gr_Base=n}', "");
    Expect(0, 195102, '\p{^Gr_Base=n}', "");
    Expect(0, 195102, '\P{Gr_Base=n}', "");
    Expect(1, 195102, '\P{^Gr_Base=n}', "");
    Expect(0, 195101, '\p{Gr_Base=n}', "");
    Expect(1, 195101, '\p{^Gr_Base=n}', "");
    Expect(1, 195101, '\P{Gr_Base=n}', "");
    Expect(0, 195101, '\P{^Gr_Base=n}', "");
    Expect(1, 195102, '\p{Gr_Base=-	N}', "");
    Expect(0, 195102, '\p{^Gr_Base=-	N}', "");
    Expect(0, 195102, '\P{Gr_Base=-	N}', "");
    Expect(1, 195102, '\P{^Gr_Base=-	N}', "");
    Expect(0, 195101, '\p{Gr_Base=-	N}', "");
    Expect(1, 195101, '\p{^Gr_Base=-	N}', "");
    Expect(1, 195101, '\P{Gr_Base=-	N}', "");
    Expect(0, 195101, '\P{^Gr_Base=-	N}', "");
    Error('\p{Is_Grapheme_Base=:=F}');
    Error('\P{Is_Grapheme_Base=:=F}');
    Expect(1, 195102, '\p{Is_Grapheme_Base=f}', "");
    Expect(0, 195102, '\p{^Is_Grapheme_Base=f}', "");
    Expect(0, 195102, '\P{Is_Grapheme_Base=f}', "");
    Expect(1, 195102, '\P{^Is_Grapheme_Base=f}', "");
    Expect(0, 195101, '\p{Is_Grapheme_Base=f}', "");
    Expect(1, 195101, '\p{^Is_Grapheme_Base=f}', "");
    Expect(1, 195101, '\P{Is_Grapheme_Base=f}', "");
    Expect(0, 195101, '\P{^Is_Grapheme_Base=f}', "");
    Expect(1, 195102, '\p{Is_Grapheme_Base= F}', "");
    Expect(0, 195102, '\p{^Is_Grapheme_Base= F}', "");
    Expect(0, 195102, '\P{Is_Grapheme_Base= F}', "");
    Expect(1, 195102, '\P{^Is_Grapheme_Base= F}', "");
    Expect(0, 195101, '\p{Is_Grapheme_Base= F}', "");
    Expect(1, 195101, '\p{^Is_Grapheme_Base= F}', "");
    Expect(1, 195101, '\P{Is_Grapheme_Base= F}', "");
    Expect(0, 195101, '\P{^Is_Grapheme_Base= F}', "");
    Error('\p{Is_Gr_Base=:=- False}');
    Error('\P{Is_Gr_Base=:=- False}');
    Expect(1, 195102, '\p{Is_Gr_Base=false}', "");
    Expect(0, 195102, '\p{^Is_Gr_Base=false}', "");
    Expect(0, 195102, '\P{Is_Gr_Base=false}', "");
    Expect(1, 195102, '\P{^Is_Gr_Base=false}', "");
    Expect(0, 195101, '\p{Is_Gr_Base=false}', "");
    Expect(1, 195101, '\p{^Is_Gr_Base=false}', "");
    Expect(1, 195101, '\P{Is_Gr_Base=false}', "");
    Expect(0, 195101, '\P{^Is_Gr_Base=false}', "");
    Expect(1, 195102, '\p{Is_Gr_Base=	 False}', "");
    Expect(0, 195102, '\p{^Is_Gr_Base=	 False}', "");
    Expect(0, 195102, '\P{Is_Gr_Base=	 False}', "");
    Expect(1, 195102, '\P{^Is_Gr_Base=	 False}', "");
    Expect(0, 195101, '\p{Is_Gr_Base=	 False}', "");
    Expect(1, 195101, '\p{^Is_Gr_Base=	 False}', "");
    Expect(1, 195101, '\P{Is_Gr_Base=	 False}', "");
    Expect(0, 195101, '\P{^Is_Gr_Base=	 False}', "");
    Error('\p{Grapheme_Base=	:=Yes}');
    Error('\P{Grapheme_Base=	:=Yes}');
    Expect(1, 195101, '\p{Grapheme_Base=yes}', "");
    Expect(0, 195101, '\p{^Grapheme_Base=yes}', "");
    Expect(0, 195101, '\P{Grapheme_Base=yes}', "");
    Expect(1, 195101, '\P{^Grapheme_Base=yes}', "");
    Expect(0, 195102, '\p{Grapheme_Base=yes}', "");
    Expect(1, 195102, '\p{^Grapheme_Base=yes}', "");
    Expect(1, 195102, '\P{Grapheme_Base=yes}', "");
    Expect(0, 195102, '\P{^Grapheme_Base=yes}', "");
    Expect(1, 195101, '\p{Grapheme_Base: Yes}', "");
    Expect(0, 195101, '\p{^Grapheme_Base: Yes}', "");
    Expect(0, 195101, '\P{Grapheme_Base: Yes}', "");
    Expect(1, 195101, '\P{^Grapheme_Base: Yes}', "");
    Expect(0, 195102, '\p{Grapheme_Base: Yes}', "");
    Expect(1, 195102, '\p{^Grapheme_Base: Yes}', "");
    Expect(1, 195102, '\P{Grapheme_Base: Yes}', "");
    Expect(0, 195102, '\P{^Grapheme_Base: Yes}', "");
    Error('\p{Gr_Base=:=_	Y}');
    Error('\P{Gr_Base=:=_	Y}');
    Expect(1, 195101, '\p{Gr_Base=y}', "");
    Expect(0, 195101, '\p{^Gr_Base=y}', "");
    Expect(0, 195101, '\P{Gr_Base=y}', "");
    Expect(1, 195101, '\P{^Gr_Base=y}', "");
    Expect(0, 195102, '\p{Gr_Base=y}', "");
    Expect(1, 195102, '\p{^Gr_Base=y}', "");
    Expect(1, 195102, '\P{Gr_Base=y}', "");
    Expect(0, 195102, '\P{^Gr_Base=y}', "");
    Expect(1, 195101, '\p{Gr_Base=	 Y}', "");
    Expect(0, 195101, '\p{^Gr_Base=	 Y}', "");
    Expect(0, 195101, '\P{Gr_Base=	 Y}', "");
    Expect(1, 195101, '\P{^Gr_Base=	 Y}', "");
    Expect(0, 195102, '\p{Gr_Base=	 Y}', "");
    Expect(1, 195102, '\p{^Gr_Base=	 Y}', "");
    Expect(1, 195102, '\P{Gr_Base=	 Y}', "");
    Expect(0, 195102, '\P{^Gr_Base=	 Y}', "");
    Error('\p{Is_Grapheme_Base=_t/a/}');
    Error('\P{Is_Grapheme_Base=_t/a/}');
    Expect(1, 195101, '\p{Is_Grapheme_Base=t}', "");
    Expect(0, 195101, '\p{^Is_Grapheme_Base=t}', "");
    Expect(0, 195101, '\P{Is_Grapheme_Base=t}', "");
    Expect(1, 195101, '\P{^Is_Grapheme_Base=t}', "");
    Expect(0, 195102, '\p{Is_Grapheme_Base=t}', "");
    Expect(1, 195102, '\p{^Is_Grapheme_Base=t}', "");
    Expect(1, 195102, '\P{Is_Grapheme_Base=t}', "");
    Expect(0, 195102, '\P{^Is_Grapheme_Base=t}', "");
    Expect(1, 195101, '\p{Is_Grapheme_Base:   -T}', "");
    Expect(0, 195101, '\p{^Is_Grapheme_Base:   -T}', "");
    Expect(0, 195101, '\P{Is_Grapheme_Base:   -T}', "");
    Expect(1, 195101, '\P{^Is_Grapheme_Base:   -T}', "");
    Expect(0, 195102, '\p{Is_Grapheme_Base:   -T}', "");
    Expect(1, 195102, '\p{^Is_Grapheme_Base:   -T}', "");
    Expect(1, 195102, '\P{Is_Grapheme_Base:   -T}', "");
    Expect(0, 195102, '\P{^Is_Grapheme_Base:   -T}', "");
    Error('\p{Is_Gr_Base:/a/--True}');
    Error('\P{Is_Gr_Base:/a/--True}');
    Expect(1, 195101, '\p{Is_Gr_Base=true}', "");
    Expect(0, 195101, '\p{^Is_Gr_Base=true}', "");
    Expect(0, 195101, '\P{Is_Gr_Base=true}', "");
    Expect(1, 195101, '\P{^Is_Gr_Base=true}', "");
    Expect(0, 195102, '\p{Is_Gr_Base=true}', "");
    Expect(1, 195102, '\p{^Is_Gr_Base=true}', "");
    Expect(1, 195102, '\P{Is_Gr_Base=true}', "");
    Expect(0, 195102, '\P{^Is_Gr_Base=true}', "");
    Expect(1, 195101, '\p{Is_Gr_Base=_	True}', "");
    Expect(0, 195101, '\p{^Is_Gr_Base=_	True}', "");
    Expect(0, 195101, '\P{Is_Gr_Base=_	True}', "");
    Expect(1, 195101, '\P{^Is_Gr_Base=_	True}', "");
    Expect(0, 195102, '\p{Is_Gr_Base=_	True}', "");
    Expect(1, 195102, '\p{^Is_Gr_Base=_	True}', "");
    Expect(1, 195102, '\P{Is_Gr_Base=_	True}', "");
    Expect(0, 195102, '\P{^Is_Gr_Base=_	True}', "");
    Error('\p{Grapheme_Extend=_:=No}');
    Error('\P{Grapheme_Extend=_:=No}');
    Expect(1, 918000, '\p{Grapheme_Extend=no}', "");
    Expect(0, 918000, '\p{^Grapheme_Extend=no}', "");
    Expect(0, 918000, '\P{Grapheme_Extend=no}', "");
    Expect(1, 918000, '\P{^Grapheme_Extend=no}', "");
    Expect(0, 917999, '\p{Grapheme_Extend=no}', "");
    Expect(1, 917999, '\p{^Grapheme_Extend=no}', "");
    Expect(1, 917999, '\P{Grapheme_Extend=no}', "");
    Expect(0, 917999, '\P{^Grapheme_Extend=no}', "");
    Expect(1, 918000, '\p{Grapheme_Extend=No}', "");
    Expect(0, 918000, '\p{^Grapheme_Extend=No}', "");
    Expect(0, 918000, '\P{Grapheme_Extend=No}', "");
    Expect(1, 918000, '\P{^Grapheme_Extend=No}', "");
    Expect(0, 917999, '\p{Grapheme_Extend=No}', "");
    Expect(1, 917999, '\p{^Grapheme_Extend=No}', "");
    Expect(1, 917999, '\P{Grapheme_Extend=No}', "");
    Expect(0, 917999, '\P{^Grapheme_Extend=No}', "");
    Error('\p{Gr_Ext= N/a/}');
    Error('\P{Gr_Ext= N/a/}');
    Expect(1, 918000, '\p{Gr_Ext=n}', "");
    Expect(0, 918000, '\p{^Gr_Ext=n}', "");
    Expect(0, 918000, '\P{Gr_Ext=n}', "");
    Expect(1, 918000, '\P{^Gr_Ext=n}', "");
    Expect(0, 917999, '\p{Gr_Ext=n}', "");
    Expect(1, 917999, '\p{^Gr_Ext=n}', "");
    Expect(1, 917999, '\P{Gr_Ext=n}', "");
    Expect(0, 917999, '\P{^Gr_Ext=n}', "");
    Expect(1, 918000, '\p{Gr_Ext=	_N}', "");
    Expect(0, 918000, '\p{^Gr_Ext=	_N}', "");
    Expect(0, 918000, '\P{Gr_Ext=	_N}', "");
    Expect(1, 918000, '\P{^Gr_Ext=	_N}', "");
    Expect(0, 917999, '\p{Gr_Ext=	_N}', "");
    Expect(1, 917999, '\p{^Gr_Ext=	_N}', "");
    Expect(1, 917999, '\P{Gr_Ext=	_N}', "");
    Expect(0, 917999, '\P{^Gr_Ext=	_N}', "");
    Error('\p{Is_Grapheme_Extend=:=F}');
    Error('\P{Is_Grapheme_Extend=:=F}');
    Expect(1, 918000, '\p{Is_Grapheme_Extend: f}', "");
    Expect(0, 918000, '\p{^Is_Grapheme_Extend: f}', "");
    Expect(0, 918000, '\P{Is_Grapheme_Extend: f}', "");
    Expect(1, 918000, '\P{^Is_Grapheme_Extend: f}', "");
    Expect(0, 917999, '\p{Is_Grapheme_Extend: f}', "");
    Expect(1, 917999, '\p{^Is_Grapheme_Extend: f}', "");
    Expect(1, 917999, '\P{Is_Grapheme_Extend: f}', "");
    Expect(0, 917999, '\P{^Is_Grapheme_Extend: f}', "");
    Expect(1, 918000, '\p{Is_Grapheme_Extend=	f}', "");
    Expect(0, 918000, '\p{^Is_Grapheme_Extend=	f}', "");
    Expect(0, 918000, '\P{Is_Grapheme_Extend=	f}', "");
    Expect(1, 918000, '\P{^Is_Grapheme_Extend=	f}', "");
    Expect(0, 917999, '\p{Is_Grapheme_Extend=	f}', "");
    Expect(1, 917999, '\p{^Is_Grapheme_Extend=	f}', "");
    Expect(1, 917999, '\P{Is_Grapheme_Extend=	f}', "");
    Expect(0, 917999, '\P{^Is_Grapheme_Extend=	f}', "");
    Error('\p{Is_Gr_Ext=	false/a/}');
    Error('\P{Is_Gr_Ext=	false/a/}');
    Expect(1, 918000, '\p{Is_Gr_Ext=false}', "");
    Expect(0, 918000, '\p{^Is_Gr_Ext=false}', "");
    Expect(0, 918000, '\P{Is_Gr_Ext=false}', "");
    Expect(1, 918000, '\P{^Is_Gr_Ext=false}', "");
    Expect(0, 917999, '\p{Is_Gr_Ext=false}', "");
    Expect(1, 917999, '\p{^Is_Gr_Ext=false}', "");
    Expect(1, 917999, '\P{Is_Gr_Ext=false}', "");
    Expect(0, 917999, '\P{^Is_Gr_Ext=false}', "");
    Expect(1, 918000, '\p{Is_Gr_Ext=_-False}', "");
    Expect(0, 918000, '\p{^Is_Gr_Ext=_-False}', "");
    Expect(0, 918000, '\P{Is_Gr_Ext=_-False}', "");
    Expect(1, 918000, '\P{^Is_Gr_Ext=_-False}', "");
    Expect(0, 917999, '\p{Is_Gr_Ext=_-False}', "");
    Expect(1, 917999, '\p{^Is_Gr_Ext=_-False}', "");
    Expect(1, 917999, '\P{Is_Gr_Ext=_-False}', "");
    Expect(0, 917999, '\P{^Is_Gr_Ext=_-False}', "");
    Error('\p{Grapheme_Extend=	:=YES}');
    Error('\P{Grapheme_Extend=	:=YES}');
    Expect(1, 917999, '\p{Grapheme_Extend=yes}', "");
    Expect(0, 917999, '\p{^Grapheme_Extend=yes}', "");
    Expect(0, 917999, '\P{Grapheme_Extend=yes}', "");
    Expect(1, 917999, '\P{^Grapheme_Extend=yes}', "");
    Expect(0, 918000, '\p{Grapheme_Extend=yes}', "");
    Expect(1, 918000, '\p{^Grapheme_Extend=yes}', "");
    Expect(1, 918000, '\P{Grapheme_Extend=yes}', "");
    Expect(0, 918000, '\P{^Grapheme_Extend=yes}', "");
    Expect(1, 917999, '\p{Grapheme_Extend= 	yes}', "");
    Expect(0, 917999, '\p{^Grapheme_Extend= 	yes}', "");
    Expect(0, 917999, '\P{Grapheme_Extend= 	yes}', "");
    Expect(1, 917999, '\P{^Grapheme_Extend= 	yes}', "");
    Expect(0, 918000, '\p{Grapheme_Extend= 	yes}', "");
    Expect(1, 918000, '\p{^Grapheme_Extend= 	yes}', "");
    Expect(1, 918000, '\P{Grapheme_Extend= 	yes}', "");
    Expect(0, 918000, '\P{^Grapheme_Extend= 	yes}', "");
    Error('\p{Gr_Ext=/a/	_Y}');
    Error('\P{Gr_Ext=/a/	_Y}');
    Expect(1, 917999, '\p{Gr_Ext=y}', "");
    Expect(0, 917999, '\p{^Gr_Ext=y}', "");
    Expect(0, 917999, '\P{Gr_Ext=y}', "");
    Expect(1, 917999, '\P{^Gr_Ext=y}', "");
    Expect(0, 918000, '\p{Gr_Ext=y}', "");
    Expect(1, 918000, '\p{^Gr_Ext=y}', "");
    Expect(1, 918000, '\P{Gr_Ext=y}', "");
    Expect(0, 918000, '\P{^Gr_Ext=y}', "");
    Expect(1, 917999, '\p{Gr_Ext:Y}', "");
    Expect(0, 917999, '\p{^Gr_Ext:Y}', "");
    Expect(0, 917999, '\P{Gr_Ext:Y}', "");
    Expect(1, 917999, '\P{^Gr_Ext:Y}', "");
    Expect(0, 918000, '\p{Gr_Ext:Y}', "");
    Expect(1, 918000, '\p{^Gr_Ext:Y}', "");
    Expect(1, 918000, '\P{Gr_Ext:Y}', "");
    Expect(0, 918000, '\P{^Gr_Ext:Y}', "");
    Error('\p{Is_Grapheme_Extend=:= T}');
    Error('\P{Is_Grapheme_Extend=:= T}');
    Expect(1, 917999, '\p{Is_Grapheme_Extend=t}', "");
    Expect(0, 917999, '\p{^Is_Grapheme_Extend=t}', "");
    Expect(0, 917999, '\P{Is_Grapheme_Extend=t}', "");
    Expect(1, 917999, '\P{^Is_Grapheme_Extend=t}', "");
    Expect(0, 918000, '\p{Is_Grapheme_Extend=t}', "");
    Expect(1, 918000, '\p{^Is_Grapheme_Extend=t}', "");
    Expect(1, 918000, '\P{Is_Grapheme_Extend=t}', "");
    Expect(0, 918000, '\P{^Is_Grapheme_Extend=t}', "");
    Expect(1, 917999, '\p{Is_Grapheme_Extend=_	T}', "");
    Expect(0, 917999, '\p{^Is_Grapheme_Extend=_	T}', "");
    Expect(0, 917999, '\P{Is_Grapheme_Extend=_	T}', "");
    Expect(1, 917999, '\P{^Is_Grapheme_Extend=_	T}', "");
    Expect(0, 918000, '\p{Is_Grapheme_Extend=_	T}', "");
    Expect(1, 918000, '\p{^Is_Grapheme_Extend=_	T}', "");
    Expect(1, 918000, '\P{Is_Grapheme_Extend=_	T}', "");
    Expect(0, 918000, '\P{^Is_Grapheme_Extend=_	T}', "");
    Error('\p{Is_Gr_Ext=_:=true}');
    Error('\P{Is_Gr_Ext=_:=true}');
    Expect(1, 917999, '\p{Is_Gr_Ext=true}', "");
    Expect(0, 917999, '\p{^Is_Gr_Ext=true}', "");
    Expect(0, 917999, '\P{Is_Gr_Ext=true}', "");
    Expect(1, 917999, '\P{^Is_Gr_Ext=true}', "");
    Expect(0, 918000, '\p{Is_Gr_Ext=true}', "");
    Expect(1, 918000, '\p{^Is_Gr_Ext=true}', "");
    Expect(1, 918000, '\P{Is_Gr_Ext=true}', "");
    Expect(0, 918000, '\P{^Is_Gr_Ext=true}', "");
    Expect(1, 917999, '\p{Is_Gr_Ext=		TRUE}', "");
    Expect(0, 917999, '\p{^Is_Gr_Ext=		TRUE}', "");
    Expect(0, 917999, '\P{Is_Gr_Ext=		TRUE}', "");
    Expect(1, 917999, '\P{^Is_Gr_Ext=		TRUE}', "");
    Expect(0, 918000, '\p{Is_Gr_Ext=		TRUE}', "");
    Expect(1, 918000, '\p{^Is_Gr_Ext=		TRUE}', "");
    Expect(1, 918000, '\P{Is_Gr_Ext=		TRUE}', "");
    Expect(0, 918000, '\P{^Is_Gr_Ext=		TRUE}', "");
    Error('\p{Grapheme_Link=No}');
    Error('\P{Grapheme_Link=No}');
    Error('\p{Gr_Link=N}');
    Error('\P{Gr_Link=N}');
    Error('\p{Is_Grapheme_Link=F}');
    Error('\P{Is_Grapheme_Link=F}');
    Error('\p{Is_Gr_Link=False}');
    Error('\P{Is_Gr_Link=False}');
    Error('\p{Grapheme_Link=Yes}');
    Error('\P{Grapheme_Link=Yes}');
    Error('\p{Gr_Link:	Y}');
    Error('\P{Gr_Link:	Y}');
    Error('\p{Is_Grapheme_Link=T}');
    Error('\P{Is_Grapheme_Link=T}');
    Error('\p{Is_Gr_Link=True}');
    Error('\P{Is_Gr_Link=True}');
    Error('\p{Hex_Digit=-no:=}');
    Error('\P{Hex_Digit=-no:=}');
    Expect(1, 65351, '\p{Hex_Digit=no}', "");
    Expect(0, 65351, '\p{^Hex_Digit=no}', "");
    Expect(0, 65351, '\P{Hex_Digit=no}', "");
    Expect(1, 65351, '\P{^Hex_Digit=no}', "");
    Expect(0, 65350, '\p{Hex_Digit=no}', "");
    Expect(1, 65350, '\p{^Hex_Digit=no}', "");
    Expect(1, 65350, '\P{Hex_Digit=no}', "");
    Expect(0, 65350, '\P{^Hex_Digit=no}', "");
    Expect(1, 65351, '\p{Hex_Digit=_	No}', "");
    Expect(0, 65351, '\p{^Hex_Digit=_	No}', "");
    Expect(0, 65351, '\P{Hex_Digit=_	No}', "");
    Expect(1, 65351, '\P{^Hex_Digit=_	No}', "");
    Expect(0, 65350, '\p{Hex_Digit=_	No}', "");
    Expect(1, 65350, '\p{^Hex_Digit=_	No}', "");
    Expect(1, 65350, '\P{Hex_Digit=_	No}', "");
    Expect(0, 65350, '\P{^Hex_Digit=_	No}', "");
    Error('\p{Hex=__n:=}');
    Error('\P{Hex=__n:=}');
    Expect(1, 65351, '\p{Hex=n}', "");
    Expect(0, 65351, '\p{^Hex=n}', "");
    Expect(0, 65351, '\P{Hex=n}', "");
    Expect(1, 65351, '\P{^Hex=n}', "");
    Expect(0, 65350, '\p{Hex=n}', "");
    Expect(1, 65350, '\p{^Hex=n}', "");
    Expect(1, 65350, '\P{Hex=n}', "");
    Expect(0, 65350, '\P{^Hex=n}', "");
    Expect(1, 65351, '\p{Hex=-	N}', "");
    Expect(0, 65351, '\p{^Hex=-	N}', "");
    Expect(0, 65351, '\P{Hex=-	N}', "");
    Expect(1, 65351, '\P{^Hex=-	N}', "");
    Expect(0, 65350, '\p{Hex=-	N}', "");
    Expect(1, 65350, '\p{^Hex=-	N}', "");
    Expect(1, 65350, '\P{Hex=-	N}', "");
    Expect(0, 65350, '\P{^Hex=-	N}', "");
    Error('\p{Is_Hex_Digit=	:=F}');
    Error('\P{Is_Hex_Digit=	:=F}');
    Expect(1, 65351, '\p{Is_Hex_Digit=f}', "");
    Expect(0, 65351, '\p{^Is_Hex_Digit=f}', "");
    Expect(0, 65351, '\P{Is_Hex_Digit=f}', "");
    Expect(1, 65351, '\P{^Is_Hex_Digit=f}', "");
    Expect(0, 65350, '\p{Is_Hex_Digit=f}', "");
    Expect(1, 65350, '\p{^Is_Hex_Digit=f}', "");
    Expect(1, 65350, '\P{Is_Hex_Digit=f}', "");
    Expect(0, 65350, '\P{^Is_Hex_Digit=f}', "");
    Expect(1, 65351, '\p{Is_Hex_Digit=_ F}', "");
    Expect(0, 65351, '\p{^Is_Hex_Digit=_ F}', "");
    Expect(0, 65351, '\P{Is_Hex_Digit=_ F}', "");
    Expect(1, 65351, '\P{^Is_Hex_Digit=_ F}', "");
    Expect(0, 65350, '\p{Is_Hex_Digit=_ F}', "");
    Expect(1, 65350, '\p{^Is_Hex_Digit=_ F}', "");
    Expect(1, 65350, '\P{Is_Hex_Digit=_ F}', "");
    Expect(0, 65350, '\P{^Is_Hex_Digit=_ F}', "");
    Error('\p{Is_Hex=__false/a/}');
    Error('\P{Is_Hex=__false/a/}');
    Expect(1, 65351, '\p{Is_Hex=false}', "");
    Expect(0, 65351, '\p{^Is_Hex=false}', "");
    Expect(0, 65351, '\P{Is_Hex=false}', "");
    Expect(1, 65351, '\P{^Is_Hex=false}', "");
    Expect(0, 65350, '\p{Is_Hex=false}', "");
    Expect(1, 65350, '\p{^Is_Hex=false}', "");
    Expect(1, 65350, '\P{Is_Hex=false}', "");
    Expect(0, 65350, '\P{^Is_Hex=false}', "");
    Expect(1, 65351, '\p{Is_Hex= _False}', "");
    Expect(0, 65351, '\p{^Is_Hex= _False}', "");
    Expect(0, 65351, '\P{Is_Hex= _False}', "");
    Expect(1, 65351, '\P{^Is_Hex= _False}', "");
    Expect(0, 65350, '\p{Is_Hex= _False}', "");
    Expect(1, 65350, '\p{^Is_Hex= _False}', "");
    Expect(1, 65350, '\P{Is_Hex= _False}', "");
    Expect(0, 65350, '\P{^Is_Hex= _False}', "");
    Error('\p{Hex_Digit=_-Yes/a/}');
    Error('\P{Hex_Digit=_-Yes/a/}');
    Expect(1, 65350, '\p{Hex_Digit=yes}', "");
    Expect(0, 65350, '\p{^Hex_Digit=yes}', "");
    Expect(0, 65350, '\P{Hex_Digit=yes}', "");
    Expect(1, 65350, '\P{^Hex_Digit=yes}', "");
    Expect(0, 65351, '\p{Hex_Digit=yes}', "");
    Expect(1, 65351, '\p{^Hex_Digit=yes}', "");
    Expect(1, 65351, '\P{Hex_Digit=yes}', "");
    Expect(0, 65351, '\P{^Hex_Digit=yes}', "");
    Expect(1, 65350, '\p{Hex_Digit=-yes}', "");
    Expect(0, 65350, '\p{^Hex_Digit=-yes}', "");
    Expect(0, 65350, '\P{Hex_Digit=-yes}', "");
    Expect(1, 65350, '\P{^Hex_Digit=-yes}', "");
    Expect(0, 65351, '\p{Hex_Digit=-yes}', "");
    Expect(1, 65351, '\p{^Hex_Digit=-yes}', "");
    Expect(1, 65351, '\P{Hex_Digit=-yes}', "");
    Expect(0, 65351, '\P{^Hex_Digit=-yes}', "");
    Error('\p{Hex:   :=		y}');
    Error('\P{Hex:   :=		y}');
    Expect(1, 65350, '\p{Hex=y}', "");
    Expect(0, 65350, '\p{^Hex=y}', "");
    Expect(0, 65350, '\P{Hex=y}', "");
    Expect(1, 65350, '\P{^Hex=y}', "");
    Expect(0, 65351, '\p{Hex=y}', "");
    Expect(1, 65351, '\p{^Hex=y}', "");
    Expect(1, 65351, '\P{Hex=y}', "");
    Expect(0, 65351, '\P{^Hex=y}', "");
    Expect(1, 65350, '\p{Hex=-	Y}', "");
    Expect(0, 65350, '\p{^Hex=-	Y}', "");
    Expect(0, 65350, '\P{Hex=-	Y}', "");
    Expect(1, 65350, '\P{^Hex=-	Y}', "");
    Expect(0, 65351, '\p{Hex=-	Y}', "");
    Expect(1, 65351, '\p{^Hex=-	Y}', "");
    Expect(1, 65351, '\P{Hex=-	Y}', "");
    Expect(0, 65351, '\P{^Hex=-	Y}', "");
    Error('\p{Is_Hex_Digit=  T:=}');
    Error('\P{Is_Hex_Digit=  T:=}');
    Expect(1, 65350, '\p{Is_Hex_Digit=t}', "");
    Expect(0, 65350, '\p{^Is_Hex_Digit=t}', "");
    Expect(0, 65350, '\P{Is_Hex_Digit=t}', "");
    Expect(1, 65350, '\P{^Is_Hex_Digit=t}', "");
    Expect(0, 65351, '\p{Is_Hex_Digit=t}', "");
    Expect(1, 65351, '\p{^Is_Hex_Digit=t}', "");
    Expect(1, 65351, '\P{Is_Hex_Digit=t}', "");
    Expect(0, 65351, '\P{^Is_Hex_Digit=t}', "");
    Expect(1, 65350, '\p{Is_Hex_Digit= T}', "");
    Expect(0, 65350, '\p{^Is_Hex_Digit= T}', "");
    Expect(0, 65350, '\P{Is_Hex_Digit= T}', "");
    Expect(1, 65350, '\P{^Is_Hex_Digit= T}', "");
    Expect(0, 65351, '\p{Is_Hex_Digit= T}', "");
    Expect(1, 65351, '\p{^Is_Hex_Digit= T}', "");
    Expect(1, 65351, '\P{Is_Hex_Digit= T}', "");
    Expect(0, 65351, '\P{^Is_Hex_Digit= T}', "");
    Error('\p{Is_Hex=:=  True}');
    Error('\P{Is_Hex=:=  True}');
    Expect(1, 65350, '\p{Is_Hex=true}', "");
    Expect(0, 65350, '\p{^Is_Hex=true}', "");
    Expect(0, 65350, '\P{Is_Hex=true}', "");
    Expect(1, 65350, '\P{^Is_Hex=true}', "");
    Expect(0, 65351, '\p{Is_Hex=true}', "");
    Expect(1, 65351, '\p{^Is_Hex=true}', "");
    Expect(1, 65351, '\P{Is_Hex=true}', "");
    Expect(0, 65351, '\P{^Is_Hex=true}', "");
    Expect(1, 65350, '\p{Is_Hex:	_true}', "");
    Expect(0, 65350, '\p{^Is_Hex:	_true}', "");
    Expect(0, 65350, '\P{Is_Hex:	_true}', "");
    Expect(1, 65350, '\P{^Is_Hex:	_true}', "");
    Expect(0, 65351, '\p{Is_Hex:	_true}', "");
    Expect(1, 65351, '\p{^Is_Hex:	_true}', "");
    Expect(1, 65351, '\P{Is_Hex:	_true}', "");
    Expect(0, 65351, '\P{^Is_Hex:	_true}', "");
    Error('\p{hangulsyllabletype}');
    Error('\P{hangulsyllabletype}');
    Error('\p{hst}');
    Error('\P{hst}');
    Error('\p{Hangul_Syllable_Type= _leading_Jamo/a/}');
    Error('\P{Hangul_Syllable_Type= _leading_Jamo/a/}');
    Expect(1, 43388, '\p{Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43388, '\p{^Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43388, '\P{Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43388, '\P{^Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43389, '\p{Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43389, '\p{^Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43389, '\P{Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43389, '\P{^Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43388, '\p{Hangul_Syllable_Type=_-Leading_JAMO}', "");
    Expect(0, 43388, '\p{^Hangul_Syllable_Type=_-Leading_JAMO}', "");
    Expect(0, 43388, '\P{Hangul_Syllable_Type=_-Leading_JAMO}', "");
    Expect(1, 43388, '\P{^Hangul_Syllable_Type=_-Leading_JAMO}', "");
    Expect(0, 43389, '\p{Hangul_Syllable_Type=_-Leading_JAMO}', "");
    Expect(1, 43389, '\p{^Hangul_Syllable_Type=_-Leading_JAMO}', "");
    Expect(1, 43389, '\P{Hangul_Syllable_Type=_-Leading_JAMO}', "");
    Expect(0, 43389, '\P{^Hangul_Syllable_Type=_-Leading_JAMO}', "");
    Error('\p{Hst: := _L}');
    Error('\P{Hst: := _L}');
    Expect(1, 43388, '\p{Hst=l}', "");
    Expect(0, 43388, '\p{^Hst=l}', "");
    Expect(0, 43388, '\P{Hst=l}', "");
    Expect(1, 43388, '\P{^Hst=l}', "");
    Expect(0, 43389, '\p{Hst=l}', "");
    Expect(1, 43389, '\p{^Hst=l}', "");
    Expect(1, 43389, '\P{Hst=l}', "");
    Expect(0, 43389, '\P{^Hst=l}', "");
    Expect(1, 43388, '\p{Hst=	_L}', "");
    Expect(0, 43388, '\p{^Hst=	_L}', "");
    Expect(0, 43388, '\P{Hst=	_L}', "");
    Expect(1, 43388, '\P{^Hst=	_L}', "");
    Expect(0, 43389, '\p{Hst=	_L}', "");
    Expect(1, 43389, '\p{^Hst=	_L}', "");
    Expect(1, 43389, '\P{Hst=	_L}', "");
    Expect(0, 43389, '\P{^Hst=	_L}', "");
    Error('\p{Is_Hangul_Syllable_Type=/a/Leading_Jamo}');
    Error('\P{Is_Hangul_Syllable_Type=/a/Leading_Jamo}');
    Expect(1, 43388, '\p{Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43388, '\p{^Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43388, '\P{Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43388, '\P{^Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43389, '\p{Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43389, '\p{^Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43389, '\P{Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43389, '\P{^Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43388, '\p{Is_Hangul_Syllable_Type= 	Leading_jamo}', "");
    Expect(0, 43388, '\p{^Is_Hangul_Syllable_Type= 	Leading_jamo}', "");
    Expect(0, 43388, '\P{Is_Hangul_Syllable_Type= 	Leading_jamo}', "");
    Expect(1, 43388, '\P{^Is_Hangul_Syllable_Type= 	Leading_jamo}', "");
    Expect(0, 43389, '\p{Is_Hangul_Syllable_Type= 	Leading_jamo}', "");
    Expect(1, 43389, '\p{^Is_Hangul_Syllable_Type= 	Leading_jamo}', "");
    Expect(1, 43389, '\P{Is_Hangul_Syllable_Type= 	Leading_jamo}', "");
    Expect(0, 43389, '\P{^Is_Hangul_Syllable_Type= 	Leading_jamo}', "");
    Error('\p{Is_Hst:	-:=L}');
    Error('\P{Is_Hst:	-:=L}');
    Expect(1, 43388, '\p{Is_Hst=l}', "");
    Expect(0, 43388, '\p{^Is_Hst=l}', "");
    Expect(0, 43388, '\P{Is_Hst=l}', "");
    Expect(1, 43388, '\P{^Is_Hst=l}', "");
    Expect(0, 43389, '\p{Is_Hst=l}', "");
    Expect(1, 43389, '\p{^Is_Hst=l}', "");
    Expect(1, 43389, '\P{Is_Hst=l}', "");
    Expect(0, 43389, '\P{^Is_Hst=l}', "");
    Expect(1, 43388, '\p{Is_Hst= _L}', "");
    Expect(0, 43388, '\p{^Is_Hst= _L}', "");
    Expect(0, 43388, '\P{Is_Hst= _L}', "");
    Expect(1, 43388, '\P{^Is_Hst= _L}', "");
    Expect(0, 43389, '\p{Is_Hst= _L}', "");
    Expect(1, 43389, '\p{^Is_Hst= _L}', "");
    Expect(1, 43389, '\P{Is_Hst= _L}', "");
    Expect(0, 43389, '\P{^Is_Hst= _L}', "");
    Error('\p{Hangul_Syllable_Type=_LV_Syllable:=}');
    Error('\P{Hangul_Syllable_Type=_LV_Syllable:=}');
    Expect(1, 55176, '\p{Hangul_Syllable_Type:	lvsyllable}', "");
    Expect(0, 55176, '\p{^Hangul_Syllable_Type:	lvsyllable}', "");
    Expect(0, 55176, '\P{Hangul_Syllable_Type:	lvsyllable}', "");
    Expect(1, 55176, '\P{^Hangul_Syllable_Type:	lvsyllable}', "");
    Expect(0, 55177, '\p{Hangul_Syllable_Type:	lvsyllable}', "");
    Expect(1, 55177, '\p{^Hangul_Syllable_Type:	lvsyllable}', "");
    Expect(1, 55177, '\P{Hangul_Syllable_Type:	lvsyllable}', "");
    Expect(0, 55177, '\P{^Hangul_Syllable_Type:	lvsyllable}', "");
    Expect(1, 55176, '\p{Hangul_Syllable_Type=-LV_syllable}', "");
    Expect(0, 55176, '\p{^Hangul_Syllable_Type=-LV_syllable}', "");
    Expect(0, 55176, '\P{Hangul_Syllable_Type=-LV_syllable}', "");
    Expect(1, 55176, '\P{^Hangul_Syllable_Type=-LV_syllable}', "");
    Expect(0, 55177, '\p{Hangul_Syllable_Type=-LV_syllable}', "");
    Expect(1, 55177, '\p{^Hangul_Syllable_Type=-LV_syllable}', "");
    Expect(1, 55177, '\P{Hangul_Syllable_Type=-LV_syllable}', "");
    Expect(0, 55177, '\P{^Hangul_Syllable_Type=-LV_syllable}', "");
    Error('\p{Hst: lv:=}');
    Error('\P{Hst: lv:=}');
    Expect(1, 55176, '\p{Hst=lv}', "");
    Expect(0, 55176, '\p{^Hst=lv}', "");
    Expect(0, 55176, '\P{Hst=lv}', "");
    Expect(1, 55176, '\P{^Hst=lv}', "");
    Expect(0, 55177, '\p{Hst=lv}', "");
    Expect(1, 55177, '\p{^Hst=lv}', "");
    Expect(1, 55177, '\P{Hst=lv}', "");
    Expect(0, 55177, '\P{^Hst=lv}', "");
    Expect(1, 55176, '\p{Hst= LV}', "");
    Expect(0, 55176, '\p{^Hst= LV}', "");
    Expect(0, 55176, '\P{Hst= LV}', "");
    Expect(1, 55176, '\P{^Hst= LV}', "");
    Expect(0, 55177, '\p{Hst= LV}', "");
    Expect(1, 55177, '\p{^Hst= LV}', "");
    Expect(1, 55177, '\P{Hst= LV}', "");
    Expect(0, 55177, '\P{^Hst= LV}', "");
    Error('\p{Is_Hangul_Syllable_Type=:=-LV_syllable}');
    Error('\P{Is_Hangul_Syllable_Type=:=-LV_syllable}');
    Expect(1, 55176, '\p{Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55176, '\p{^Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55176, '\P{Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55176, '\P{^Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55177, '\p{Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55177, '\p{^Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55177, '\P{Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55177, '\P{^Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55176, '\p{Is_Hangul_Syllable_Type= 	LV_SYLLABLE}', "");
    Expect(0, 55176, '\p{^Is_Hangul_Syllable_Type= 	LV_SYLLABLE}', "");
    Expect(0, 55176, '\P{Is_Hangul_Syllable_Type= 	LV_SYLLABLE}', "");
    Expect(1, 55176, '\P{^Is_Hangul_Syllable_Type= 	LV_SYLLABLE}', "");
    Expect(0, 55177, '\p{Is_Hangul_Syllable_Type= 	LV_SYLLABLE}', "");
    Expect(1, 55177, '\p{^Is_Hangul_Syllable_Type= 	LV_SYLLABLE}', "");
    Expect(1, 55177, '\P{Is_Hangul_Syllable_Type= 	LV_SYLLABLE}', "");
    Expect(0, 55177, '\P{^Is_Hangul_Syllable_Type= 	LV_SYLLABLE}', "");
    Error('\p{Is_Hst= _lv/a/}');
    Error('\P{Is_Hst= _lv/a/}');
    Expect(1, 55176, '\p{Is_Hst:	lv}', "");
    Expect(0, 55176, '\p{^Is_Hst:	lv}', "");
    Expect(0, 55176, '\P{Is_Hst:	lv}', "");
    Expect(1, 55176, '\P{^Is_Hst:	lv}', "");
    Expect(0, 55177, '\p{Is_Hst:	lv}', "");
    Expect(1, 55177, '\p{^Is_Hst:	lv}', "");
    Expect(1, 55177, '\P{Is_Hst:	lv}', "");
    Expect(0, 55177, '\P{^Is_Hst:	lv}', "");
    Expect(1, 55176, '\p{Is_Hst:- LV}', "");
    Expect(0, 55176, '\p{^Is_Hst:- LV}', "");
    Expect(0, 55176, '\P{Is_Hst:- LV}', "");
    Expect(1, 55176, '\P{^Is_Hst:- LV}', "");
    Expect(0, 55177, '\p{Is_Hst:- LV}', "");
    Expect(1, 55177, '\p{^Is_Hst:- LV}', "");
    Expect(1, 55177, '\P{Is_Hst:- LV}', "");
    Expect(0, 55177, '\P{^Is_Hst:- LV}', "");
    Error('\p{Hangul_Syllable_Type=--LVT_syllable/a/}');
    Error('\P{Hangul_Syllable_Type=--LVT_syllable/a/}');
    Expect(1, 55203, '\p{Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55203, '\p{^Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55203, '\P{Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55203, '\P{^Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55204, '\p{Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55204, '\p{^Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55204, '\P{Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55204, '\P{^Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55203, '\p{Hangul_Syllable_Type=_	lvt_syllable}', "");
    Expect(0, 55203, '\p{^Hangul_Syllable_Type=_	lvt_syllable}', "");
    Expect(0, 55203, '\P{Hangul_Syllable_Type=_	lvt_syllable}', "");
    Expect(1, 55203, '\P{^Hangul_Syllable_Type=_	lvt_syllable}', "");
    Expect(0, 55204, '\p{Hangul_Syllable_Type=_	lvt_syllable}', "");
    Expect(1, 55204, '\p{^Hangul_Syllable_Type=_	lvt_syllable}', "");
    Expect(1, 55204, '\P{Hangul_Syllable_Type=_	lvt_syllable}', "");
    Expect(0, 55204, '\P{^Hangul_Syllable_Type=_	lvt_syllable}', "");
    Error('\p{Hst=/a/		lvt}');
    Error('\P{Hst=/a/		lvt}');
    Expect(1, 55203, '\p{Hst=lvt}', "");
    Expect(0, 55203, '\p{^Hst=lvt}', "");
    Expect(0, 55203, '\P{Hst=lvt}', "");
    Expect(1, 55203, '\P{^Hst=lvt}', "");
    Expect(0, 55204, '\p{Hst=lvt}', "");
    Expect(1, 55204, '\p{^Hst=lvt}', "");
    Expect(1, 55204, '\P{Hst=lvt}', "");
    Expect(0, 55204, '\P{^Hst=lvt}', "");
    Expect(1, 55203, '\p{Hst=--lvt}', "");
    Expect(0, 55203, '\p{^Hst=--lvt}', "");
    Expect(0, 55203, '\P{Hst=--lvt}', "");
    Expect(1, 55203, '\P{^Hst=--lvt}', "");
    Expect(0, 55204, '\p{Hst=--lvt}', "");
    Expect(1, 55204, '\p{^Hst=--lvt}', "");
    Expect(1, 55204, '\P{Hst=--lvt}', "");
    Expect(0, 55204, '\P{^Hst=--lvt}', "");
    Error('\p{Is_Hangul_Syllable_Type=lvt_Syllable/a/}');
    Error('\P{Is_Hangul_Syllable_Type=lvt_Syllable/a/}');
    Expect(1, 55203, '\p{Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55203, '\p{^Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55203, '\P{Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55203, '\P{^Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55204, '\p{Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55204, '\p{^Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55204, '\P{Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55204, '\P{^Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55203, '\p{Is_Hangul_Syllable_Type:     LVT_Syllable}', "");
    Expect(0, 55203, '\p{^Is_Hangul_Syllable_Type:     LVT_Syllable}', "");
    Expect(0, 55203, '\P{Is_Hangul_Syllable_Type:     LVT_Syllable}', "");
    Expect(1, 55203, '\P{^Is_Hangul_Syllable_Type:     LVT_Syllable}', "");
    Expect(0, 55204, '\p{Is_Hangul_Syllable_Type:     LVT_Syllable}', "");
    Expect(1, 55204, '\p{^Is_Hangul_Syllable_Type:     LVT_Syllable}', "");
    Expect(1, 55204, '\P{Is_Hangul_Syllable_Type:     LVT_Syllable}', "");
    Expect(0, 55204, '\P{^Is_Hangul_Syllable_Type:     LVT_Syllable}', "");
    Error('\p{Is_Hst=/a/LVT}');
    Error('\P{Is_Hst=/a/LVT}');
    Expect(1, 55203, '\p{Is_Hst:	lvt}', "");
    Expect(0, 55203, '\p{^Is_Hst:	lvt}', "");
    Expect(0, 55203, '\P{Is_Hst:	lvt}', "");
    Expect(1, 55203, '\P{^Is_Hst:	lvt}', "");
    Expect(0, 55204, '\p{Is_Hst:	lvt}', "");
    Expect(1, 55204, '\p{^Is_Hst:	lvt}', "");
    Expect(1, 55204, '\P{Is_Hst:	lvt}', "");
    Expect(0, 55204, '\P{^Is_Hst:	lvt}', "");
    Expect(1, 55203, '\p{Is_Hst=__LVT}', "");
    Expect(0, 55203, '\p{^Is_Hst=__LVT}', "");
    Expect(0, 55203, '\P{Is_Hst=__LVT}', "");
    Expect(1, 55203, '\P{^Is_Hst=__LVT}', "");
    Expect(0, 55204, '\p{Is_Hst=__LVT}', "");
    Expect(1, 55204, '\p{^Is_Hst=__LVT}', "");
    Expect(1, 55204, '\P{Is_Hst=__LVT}', "");
    Expect(0, 55204, '\P{^Is_Hst=__LVT}', "");
    Error('\p{Hangul_Syllable_Type=:=-Not_applicable}');
    Error('\P{Hangul_Syllable_Type=:=-Not_applicable}');
    Expect(1, 55292, '\p{Hangul_Syllable_Type=notapplicable}', "");
    Expect(0, 55292, '\p{^Hangul_Syllable_Type=notapplicable}', "");
    Expect(0, 55292, '\P{Hangul_Syllable_Type=notapplicable}', "");
    Expect(1, 55292, '\P{^Hangul_Syllable_Type=notapplicable}', "");
    Expect(0, 55291, '\p{Hangul_Syllable_Type=notapplicable}', "");
    Expect(1, 55291, '\p{^Hangul_Syllable_Type=notapplicable}', "");
    Expect(1, 55291, '\P{Hangul_Syllable_Type=notapplicable}', "");
    Expect(0, 55291, '\P{^Hangul_Syllable_Type=notapplicable}', "");
    Expect(1, 55292, '\p{Hangul_Syllable_Type=	-NOT_applicable}', "");
    Expect(0, 55292, '\p{^Hangul_Syllable_Type=	-NOT_applicable}', "");
    Expect(0, 55292, '\P{Hangul_Syllable_Type=	-NOT_applicable}', "");
    Expect(1, 55292, '\P{^Hangul_Syllable_Type=	-NOT_applicable}', "");
    Expect(0, 55291, '\p{Hangul_Syllable_Type=	-NOT_applicable}', "");
    Expect(1, 55291, '\p{^Hangul_Syllable_Type=	-NOT_applicable}', "");
    Expect(1, 55291, '\P{Hangul_Syllable_Type=	-NOT_applicable}', "");
    Expect(0, 55291, '\P{^Hangul_Syllable_Type=	-NOT_applicable}', "");
    Error('\p{Hst=-NA/a/}');
    Error('\P{Hst=-NA/a/}');
    Expect(1, 55292, '\p{Hst=na}', "");
    Expect(0, 55292, '\p{^Hst=na}', "");
    Expect(0, 55292, '\P{Hst=na}', "");
    Expect(1, 55292, '\P{^Hst=na}', "");
    Expect(0, 55291, '\p{Hst=na}', "");
    Expect(1, 55291, '\p{^Hst=na}', "");
    Expect(1, 55291, '\P{Hst=na}', "");
    Expect(0, 55291, '\P{^Hst=na}', "");
    Expect(1, 55292, '\p{Hst=-	NA}', "");
    Expect(0, 55292, '\p{^Hst=-	NA}', "");
    Expect(0, 55292, '\P{Hst=-	NA}', "");
    Expect(1, 55292, '\P{^Hst=-	NA}', "");
    Expect(0, 55291, '\p{Hst=-	NA}', "");
    Expect(1, 55291, '\p{^Hst=-	NA}', "");
    Expect(1, 55291, '\P{Hst=-	NA}', "");
    Expect(0, 55291, '\P{^Hst=-	NA}', "");
    Error('\p{Is_Hangul_Syllable_Type=-Not_Applicable:=}');
    Error('\P{Is_Hangul_Syllable_Type=-Not_Applicable:=}');
    Expect(1, 55292, '\p{Is_Hangul_Syllable_Type: notapplicable}', "");
    Expect(0, 55292, '\p{^Is_Hangul_Syllable_Type: notapplicable}', "");
    Expect(0, 55292, '\P{Is_Hangul_Syllable_Type: notapplicable}', "");
    Expect(1, 55292, '\P{^Is_Hangul_Syllable_Type: notapplicable}', "");
    Expect(0, 55291, '\p{Is_Hangul_Syllable_Type: notapplicable}', "");
    Expect(1, 55291, '\p{^Is_Hangul_Syllable_Type: notapplicable}', "");
    Expect(1, 55291, '\P{Is_Hangul_Syllable_Type: notapplicable}', "");
    Expect(0, 55291, '\P{^Is_Hangul_Syllable_Type: notapplicable}', "");
    Expect(1, 55292, '\p{Is_Hangul_Syllable_Type=	_not_applicable}', "");
    Expect(0, 55292, '\p{^Is_Hangul_Syllable_Type=	_not_applicable}', "");
    Expect(0, 55292, '\P{Is_Hangul_Syllable_Type=	_not_applicable}', "");
    Expect(1, 55292, '\P{^Is_Hangul_Syllable_Type=	_not_applicable}', "");
    Expect(0, 55291, '\p{Is_Hangul_Syllable_Type=	_not_applicable}', "");
    Expect(1, 55291, '\p{^Is_Hangul_Syllable_Type=	_not_applicable}', "");
    Expect(1, 55291, '\P{Is_Hangul_Syllable_Type=	_not_applicable}', "");
    Expect(0, 55291, '\P{^Is_Hangul_Syllable_Type=	_not_applicable}', "");
    Error('\p{Is_Hst=:=NA}');
    Error('\P{Is_Hst=:=NA}');
    Expect(1, 55292, '\p{Is_Hst=na}', "");
    Expect(0, 55292, '\p{^Is_Hst=na}', "");
    Expect(0, 55292, '\P{Is_Hst=na}', "");
    Expect(1, 55292, '\P{^Is_Hst=na}', "");
    Expect(0, 55291, '\p{Is_Hst=na}', "");
    Expect(1, 55291, '\p{^Is_Hst=na}', "");
    Expect(1, 55291, '\P{Is_Hst=na}', "");
    Expect(0, 55291, '\P{^Is_Hst=na}', "");
    Expect(1, 55292, '\p{Is_Hst= _NA}', "");
    Expect(0, 55292, '\p{^Is_Hst= _NA}', "");
    Expect(0, 55292, '\P{Is_Hst= _NA}', "");
    Expect(1, 55292, '\P{^Is_Hst= _NA}', "");
    Expect(0, 55291, '\p{Is_Hst= _NA}', "");
    Expect(1, 55291, '\p{^Is_Hst= _NA}', "");
    Expect(1, 55291, '\P{Is_Hst= _NA}', "");
    Expect(0, 55291, '\P{^Is_Hst= _NA}', "");
    Error('\p{Hangul_Syllable_Type=/a/_ trailing_JAMO}');
    Error('\P{Hangul_Syllable_Type=/a/_ trailing_JAMO}');
    Expect(1, 55291, '\p{Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55291, '\p{^Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55291, '\P{Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55291, '\P{^Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55292, '\p{Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55292, '\p{^Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55292, '\P{Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55292, '\P{^Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55291, '\p{Hangul_Syllable_Type=- Trailing_JAMO}', "");
    Expect(0, 55291, '\p{^Hangul_Syllable_Type=- Trailing_JAMO}', "");
    Expect(0, 55291, '\P{Hangul_Syllable_Type=- Trailing_JAMO}', "");
    Expect(1, 55291, '\P{^Hangul_Syllable_Type=- Trailing_JAMO}', "");
    Expect(0, 55292, '\p{Hangul_Syllable_Type=- Trailing_JAMO}', "");
    Expect(1, 55292, '\p{^Hangul_Syllable_Type=- Trailing_JAMO}', "");
    Expect(1, 55292, '\P{Hangul_Syllable_Type=- Trailing_JAMO}', "");
    Expect(0, 55292, '\P{^Hangul_Syllable_Type=- Trailing_JAMO}', "");
    Error('\p{Hst:	- T/a/}');
    Error('\P{Hst:	- T/a/}');
    Expect(1, 55291, '\p{Hst=t}', "");
    Expect(0, 55291, '\p{^Hst=t}', "");
    Expect(0, 55291, '\P{Hst=t}', "");
    Expect(1, 55291, '\P{^Hst=t}', "");
    Expect(0, 55292, '\p{Hst=t}', "");
    Expect(1, 55292, '\p{^Hst=t}', "");
    Expect(1, 55292, '\P{Hst=t}', "");
    Expect(0, 55292, '\P{^Hst=t}', "");
    Expect(1, 55291, '\p{Hst=-T}', "");
    Expect(0, 55291, '\p{^Hst=-T}', "");
    Expect(0, 55291, '\P{Hst=-T}', "");
    Expect(1, 55291, '\P{^Hst=-T}', "");
    Expect(0, 55292, '\p{Hst=-T}', "");
    Expect(1, 55292, '\p{^Hst=-T}', "");
    Expect(1, 55292, '\P{Hst=-T}', "");
    Expect(0, 55292, '\P{^Hst=-T}', "");
    Error('\p{Is_Hangul_Syllable_Type:   -:=trailing_JAMO}');
    Error('\P{Is_Hangul_Syllable_Type:   -:=trailing_JAMO}');
    Expect(1, 55291, '\p{Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55291, '\p{^Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55291, '\P{Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55291, '\P{^Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55292, '\p{Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55292, '\p{^Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55292, '\P{Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55292, '\P{^Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55291, '\p{Is_Hangul_Syllable_Type=_TRAILING_jamo}', "");
    Expect(0, 55291, '\p{^Is_Hangul_Syllable_Type=_TRAILING_jamo}', "");
    Expect(0, 55291, '\P{Is_Hangul_Syllable_Type=_TRAILING_jamo}', "");
    Expect(1, 55291, '\P{^Is_Hangul_Syllable_Type=_TRAILING_jamo}', "");
    Expect(0, 55292, '\p{Is_Hangul_Syllable_Type=_TRAILING_jamo}', "");
    Expect(1, 55292, '\p{^Is_Hangul_Syllable_Type=_TRAILING_jamo}', "");
    Expect(1, 55292, '\P{Is_Hangul_Syllable_Type=_TRAILING_jamo}', "");
    Expect(0, 55292, '\P{^Is_Hangul_Syllable_Type=_TRAILING_jamo}', "");
    Error('\p{Is_Hst=/a/T}');
    Error('\P{Is_Hst=/a/T}');
    Expect(1, 55291, '\p{Is_Hst=t}', "");
    Expect(0, 55291, '\p{^Is_Hst=t}', "");
    Expect(0, 55291, '\P{Is_Hst=t}', "");
    Expect(1, 55291, '\P{^Is_Hst=t}', "");
    Expect(0, 55292, '\p{Is_Hst=t}', "");
    Expect(1, 55292, '\p{^Is_Hst=t}', "");
    Expect(1, 55292, '\P{Is_Hst=t}', "");
    Expect(0, 55292, '\P{^Is_Hst=t}', "");
    Expect(1, 55291, '\p{Is_Hst:    _T}', "");
    Expect(0, 55291, '\p{^Is_Hst:    _T}', "");
    Expect(0, 55291, '\P{Is_Hst:    _T}', "");
    Expect(1, 55291, '\P{^Is_Hst:    _T}', "");
    Expect(0, 55292, '\p{Is_Hst:    _T}', "");
    Expect(1, 55292, '\p{^Is_Hst:    _T}', "");
    Expect(1, 55292, '\P{Is_Hst:    _T}', "");
    Expect(0, 55292, '\P{^Is_Hst:    _T}', "");
    Error('\p{Hangul_Syllable_Type=/a/  Vowel_Jamo}');
    Error('\P{Hangul_Syllable_Type=/a/  Vowel_Jamo}');
    Expect(1, 55238, '\p{Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55238, '\p{^Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55238, '\P{Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55238, '\P{^Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55239, '\p{Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55239, '\p{^Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55239, '\P{Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55239, '\P{^Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55238, '\p{Hangul_Syllable_Type=__Vowel_Jamo}', "");
    Expect(0, 55238, '\p{^Hangul_Syllable_Type=__Vowel_Jamo}', "");
    Expect(0, 55238, '\P{Hangul_Syllable_Type=__Vowel_Jamo}', "");
    Expect(1, 55238, '\P{^Hangul_Syllable_Type=__Vowel_Jamo}', "");
    Expect(0, 55239, '\p{Hangul_Syllable_Type=__Vowel_Jamo}', "");
    Expect(1, 55239, '\p{^Hangul_Syllable_Type=__Vowel_Jamo}', "");
    Expect(1, 55239, '\P{Hangul_Syllable_Type=__Vowel_Jamo}', "");
    Expect(0, 55239, '\P{^Hangul_Syllable_Type=__Vowel_Jamo}', "");
    Error('\p{Hst=-V:=}');
    Error('\P{Hst=-V:=}');
    Expect(1, 55238, '\p{Hst=v}', "");
    Expect(0, 55238, '\p{^Hst=v}', "");
    Expect(0, 55238, '\P{Hst=v}', "");
    Expect(1, 55238, '\P{^Hst=v}', "");
    Expect(0, 55239, '\p{Hst=v}', "");
    Expect(1, 55239, '\p{^Hst=v}', "");
    Expect(1, 55239, '\P{Hst=v}', "");
    Expect(0, 55239, '\P{^Hst=v}', "");
    Expect(1, 55238, '\p{Hst= V}', "");
    Expect(0, 55238, '\p{^Hst= V}', "");
    Expect(0, 55238, '\P{Hst= V}', "");
    Expect(1, 55238, '\P{^Hst= V}', "");
    Expect(0, 55239, '\p{Hst= V}', "");
    Expect(1, 55239, '\p{^Hst= V}', "");
    Expect(1, 55239, '\P{Hst= V}', "");
    Expect(0, 55239, '\P{^Hst= V}', "");
    Error('\p{Is_Hangul_Syllable_Type=:=		vowel_Jamo}');
    Error('\P{Is_Hangul_Syllable_Type=:=		vowel_Jamo}');
    Expect(1, 55238, '\p{Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55238, '\p{^Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55238, '\P{Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55238, '\P{^Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55239, '\p{Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55239, '\p{^Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55239, '\P{Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55239, '\P{^Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55238, '\p{Is_Hangul_Syllable_Type=_VOWEL_jamo}', "");
    Expect(0, 55238, '\p{^Is_Hangul_Syllable_Type=_VOWEL_jamo}', "");
    Expect(0, 55238, '\P{Is_Hangul_Syllable_Type=_VOWEL_jamo}', "");
    Expect(1, 55238, '\P{^Is_Hangul_Syllable_Type=_VOWEL_jamo}', "");
    Expect(0, 55239, '\p{Is_Hangul_Syllable_Type=_VOWEL_jamo}', "");
    Expect(1, 55239, '\p{^Is_Hangul_Syllable_Type=_VOWEL_jamo}', "");
    Expect(1, 55239, '\P{Is_Hangul_Syllable_Type=_VOWEL_jamo}', "");
    Expect(0, 55239, '\P{^Is_Hangul_Syllable_Type=_VOWEL_jamo}', "");
    Error('\p{Is_Hst=-:=V}');
    Error('\P{Is_Hst=-:=V}');
    Expect(1, 55238, '\p{Is_Hst=v}', "");
    Expect(0, 55238, '\p{^Is_Hst=v}', "");
    Expect(0, 55238, '\P{Is_Hst=v}', "");
    Expect(1, 55238, '\P{^Is_Hst=v}', "");
    Expect(0, 55239, '\p{Is_Hst=v}', "");
    Expect(1, 55239, '\p{^Is_Hst=v}', "");
    Expect(1, 55239, '\P{Is_Hst=v}', "");
    Expect(0, 55239, '\P{^Is_Hst=v}', "");
    Expect(1, 55238, '\p{Is_Hst=-v}', "");
    Expect(0, 55238, '\p{^Is_Hst=-v}', "");
    Expect(0, 55238, '\P{Is_Hst=-v}', "");
    Expect(1, 55238, '\P{^Is_Hst=-v}', "");
    Expect(0, 55239, '\p{Is_Hst=-v}', "");
    Expect(1, 55239, '\p{^Is_Hst=-v}', "");
    Expect(1, 55239, '\P{Is_Hst=-v}', "");
    Expect(0, 55239, '\P{^Is_Hst=-v}', "");
    Error('\p{Hyphen=	 No/a/}');
    Error('\P{Hyphen=	 No/a/}');
    Expect(1, 65382, '\p{Hyphen:no}', 'deprecated');
    Expect(0, 65382, '\p{^Hyphen:no}', 'deprecated');
    Expect(0, 65382, '\P{Hyphen:no}', 'deprecated');
    Expect(1, 65382, '\P{^Hyphen:no}', 'deprecated');
    Expect(0, 65381, '\p{Hyphen:no}', 'deprecated');
    Expect(1, 65381, '\p{^Hyphen:no}', 'deprecated');
    Expect(1, 65381, '\P{Hyphen:no}', 'deprecated');
    Expect(0, 65381, '\P{^Hyphen:no}', 'deprecated');
    Expect(1, 65382, '\p{Hyphen=-NO}', 'deprecated');
    Expect(0, 65382, '\p{^Hyphen=-NO}', 'deprecated');
    Expect(0, 65382, '\P{Hyphen=-NO}', 'deprecated');
    Expect(1, 65382, '\P{^Hyphen=-NO}', 'deprecated');
    Expect(0, 65381, '\p{Hyphen=-NO}', 'deprecated');
    Expect(1, 65381, '\p{^Hyphen=-NO}', 'deprecated');
    Expect(1, 65381, '\P{Hyphen=-NO}', 'deprecated');
    Expect(0, 65381, '\P{^Hyphen=-NO}', 'deprecated');
    Error('\p{Is_Hyphen=_n:=}');
    Error('\P{Is_Hyphen=_n:=}');
    Expect(1, 65382, '\p{Is_Hyphen=n}', 'deprecated');
    Expect(0, 65382, '\p{^Is_Hyphen=n}', 'deprecated');
    Expect(0, 65382, '\P{Is_Hyphen=n}', 'deprecated');
    Expect(1, 65382, '\P{^Is_Hyphen=n}', 'deprecated');
    Expect(0, 65381, '\p{Is_Hyphen=n}', 'deprecated');
    Expect(1, 65381, '\p{^Is_Hyphen=n}', 'deprecated');
    Expect(1, 65381, '\P{Is_Hyphen=n}', 'deprecated');
    Expect(0, 65381, '\P{^Is_Hyphen=n}', 'deprecated');
    Expect(1, 65382, '\p{Is_Hyphen= 	N}', 'deprecated');
    Expect(0, 65382, '\p{^Is_Hyphen= 	N}', 'deprecated');
    Expect(0, 65382, '\P{Is_Hyphen= 	N}', 'deprecated');
    Expect(1, 65382, '\P{^Is_Hyphen= 	N}', 'deprecated');
    Expect(0, 65381, '\p{Is_Hyphen= 	N}', 'deprecated');
    Expect(1, 65381, '\p{^Is_Hyphen= 	N}', 'deprecated');
    Expect(1, 65381, '\P{Is_Hyphen= 	N}', 'deprecated');
    Expect(0, 65381, '\P{^Is_Hyphen= 	N}', 'deprecated');
    Error('\p{Hyphen=_:=F}');
    Error('\P{Hyphen=_:=F}');
    Expect(1, 65382, '\p{Hyphen=f}', 'deprecated');
    Expect(0, 65382, '\p{^Hyphen=f}', 'deprecated');
    Expect(0, 65382, '\P{Hyphen=f}', 'deprecated');
    Expect(1, 65382, '\P{^Hyphen=f}', 'deprecated');
    Expect(0, 65381, '\p{Hyphen=f}', 'deprecated');
    Expect(1, 65381, '\p{^Hyphen=f}', 'deprecated');
    Expect(1, 65381, '\P{Hyphen=f}', 'deprecated');
    Expect(0, 65381, '\P{^Hyphen=f}', 'deprecated');
    Expect(1, 65382, '\p{Hyphen=_	f}', 'deprecated');
    Expect(0, 65382, '\p{^Hyphen=_	f}', 'deprecated');
    Expect(0, 65382, '\P{Hyphen=_	f}', 'deprecated');
    Expect(1, 65382, '\P{^Hyphen=_	f}', 'deprecated');
    Expect(0, 65381, '\p{Hyphen=_	f}', 'deprecated');
    Expect(1, 65381, '\p{^Hyphen=_	f}', 'deprecated');
    Expect(1, 65381, '\P{Hyphen=_	f}', 'deprecated');
    Expect(0, 65381, '\P{^Hyphen=_	f}', 'deprecated');
    Error('\p{Is_Hyphen= FALSE:=}');
    Error('\P{Is_Hyphen= FALSE:=}');
    Expect(1, 65382, '\p{Is_Hyphen=false}', 'deprecated');
    Expect(0, 65382, '\p{^Is_Hyphen=false}', 'deprecated');
    Expect(0, 65382, '\P{Is_Hyphen=false}', 'deprecated');
    Expect(1, 65382, '\P{^Is_Hyphen=false}', 'deprecated');
    Expect(0, 65381, '\p{Is_Hyphen=false}', 'deprecated');
    Expect(1, 65381, '\p{^Is_Hyphen=false}', 'deprecated');
    Expect(1, 65381, '\P{Is_Hyphen=false}', 'deprecated');
    Expect(0, 65381, '\P{^Is_Hyphen=false}', 'deprecated');
    Expect(1, 65382, '\p{Is_Hyphen= -false}', 'deprecated');
    Expect(0, 65382, '\p{^Is_Hyphen= -false}', 'deprecated');
    Expect(0, 65382, '\P{Is_Hyphen= -false}', 'deprecated');
    Expect(1, 65382, '\P{^Is_Hyphen= -false}', 'deprecated');
    Expect(0, 65381, '\p{Is_Hyphen= -false}', 'deprecated');
    Expect(1, 65381, '\p{^Is_Hyphen= -false}', 'deprecated');
    Expect(1, 65381, '\P{Is_Hyphen= -false}', 'deprecated');
    Expect(0, 65381, '\P{^Is_Hyphen= -false}', 'deprecated');
    Error('\p{Hyphen=	YES:=}');
    Error('\P{Hyphen=	YES:=}');
    Expect(1, 65381, '\p{Hyphen: yes}', 'deprecated');
    Expect(0, 65381, '\p{^Hyphen: yes}', 'deprecated');
    Expect(0, 65381, '\P{Hyphen: yes}', 'deprecated');
    Expect(1, 65381, '\P{^Hyphen: yes}', 'deprecated');
    Expect(0, 65382, '\p{Hyphen: yes}', 'deprecated');
    Expect(1, 65382, '\p{^Hyphen: yes}', 'deprecated');
    Expect(1, 65382, '\P{Hyphen: yes}', 'deprecated');
    Expect(0, 65382, '\P{^Hyphen: yes}', 'deprecated');
    Expect(1, 65381, '\p{Hyphen= Yes}', 'deprecated');
    Expect(0, 65381, '\p{^Hyphen= Yes}', 'deprecated');
    Expect(0, 65381, '\P{Hyphen= Yes}', 'deprecated');
    Expect(1, 65381, '\P{^Hyphen= Yes}', 'deprecated');
    Expect(0, 65382, '\p{Hyphen= Yes}', 'deprecated');
    Expect(1, 65382, '\p{^Hyphen= Yes}', 'deprecated');
    Expect(1, 65382, '\P{Hyphen= Yes}', 'deprecated');
    Expect(0, 65382, '\P{^Hyphen= Yes}', 'deprecated');
    Error('\p{Is_Hyphen::=	-Y}');
    Error('\P{Is_Hyphen::=	-Y}');
    Expect(1, 65381, '\p{Is_Hyphen=y}', 'deprecated');
    Expect(0, 65381, '\p{^Is_Hyphen=y}', 'deprecated');
    Expect(0, 65381, '\P{Is_Hyphen=y}', 'deprecated');
    Expect(1, 65381, '\P{^Is_Hyphen=y}', 'deprecated');
    Expect(0, 65382, '\p{Is_Hyphen=y}', 'deprecated');
    Expect(1, 65382, '\p{^Is_Hyphen=y}', 'deprecated');
    Expect(1, 65382, '\P{Is_Hyphen=y}', 'deprecated');
    Expect(0, 65382, '\P{^Is_Hyphen=y}', 'deprecated');
    Expect(1, 65381, '\p{Is_Hyphen=	Y}', 'deprecated');
    Expect(0, 65381, '\p{^Is_Hyphen=	Y}', 'deprecated');
    Expect(0, 65381, '\P{Is_Hyphen=	Y}', 'deprecated');
    Expect(1, 65381, '\P{^Is_Hyphen=	Y}', 'deprecated');
    Expect(0, 65382, '\p{Is_Hyphen=	Y}', 'deprecated');
    Expect(1, 65382, '\p{^Is_Hyphen=	Y}', 'deprecated');
    Expect(1, 65382, '\P{Is_Hyphen=	Y}', 'deprecated');
    Expect(0, 65382, '\P{^Is_Hyphen=	Y}', 'deprecated');
    Error('\p{Hyphen:    T:=}');
    Error('\P{Hyphen:    T:=}');
    Expect(1, 65381, '\p{Hyphen=t}', 'deprecated');
    Expect(0, 65381, '\p{^Hyphen=t}', 'deprecated');
    Expect(0, 65381, '\P{Hyphen=t}', 'deprecated');
    Expect(1, 65381, '\P{^Hyphen=t}', 'deprecated');
    Expect(0, 65382, '\p{Hyphen=t}', 'deprecated');
    Expect(1, 65382, '\p{^Hyphen=t}', 'deprecated');
    Expect(1, 65382, '\P{Hyphen=t}', 'deprecated');
    Expect(0, 65382, '\P{^Hyphen=t}', 'deprecated');
    Expect(1, 65381, '\p{Hyphen=	-t}', 'deprecated');
    Expect(0, 65381, '\p{^Hyphen=	-t}', 'deprecated');
    Expect(0, 65381, '\P{Hyphen=	-t}', 'deprecated');
    Expect(1, 65381, '\P{^Hyphen=	-t}', 'deprecated');
    Expect(0, 65382, '\p{Hyphen=	-t}', 'deprecated');
    Expect(1, 65382, '\p{^Hyphen=	-t}', 'deprecated');
    Expect(1, 65382, '\P{Hyphen=	-t}', 'deprecated');
    Expect(0, 65382, '\P{^Hyphen=	-t}', 'deprecated');
    Error('\p{Is_Hyphen= True/a/}');
    Error('\P{Is_Hyphen= True/a/}');
    Expect(1, 65381, '\p{Is_Hyphen=true}', 'deprecated');
    Expect(0, 65381, '\p{^Is_Hyphen=true}', 'deprecated');
    Expect(0, 65381, '\P{Is_Hyphen=true}', 'deprecated');
    Expect(1, 65381, '\P{^Is_Hyphen=true}', 'deprecated');
    Expect(0, 65382, '\p{Is_Hyphen=true}', 'deprecated');
    Expect(1, 65382, '\p{^Is_Hyphen=true}', 'deprecated');
    Expect(1, 65382, '\P{Is_Hyphen=true}', 'deprecated');
    Expect(0, 65382, '\P{^Is_Hyphen=true}', 'deprecated');
    Expect(1, 65381, '\p{Is_Hyphen:	-true}', 'deprecated');
    Expect(0, 65381, '\p{^Is_Hyphen:	-true}', 'deprecated');
    Expect(0, 65381, '\P{Is_Hyphen:	-true}', 'deprecated');
    Expect(1, 65381, '\P{^Is_Hyphen:	-true}', 'deprecated');
    Expect(0, 65382, '\p{Is_Hyphen:	-true}', 'deprecated');
    Expect(1, 65382, '\p{^Is_Hyphen:	-true}', 'deprecated');
    Expect(1, 65382, '\P{Is_Hyphen:	-true}', 'deprecated');
    Expect(0, 65382, '\P{^Is_Hyphen:	-true}', 'deprecated');
    Error('\p{ID_Continue=/a/  No}');
    Error('\P{ID_Continue=/a/  No}');
    Expect(1, 918000, '\p{ID_Continue:no}', "");
    Expect(0, 918000, '\p{^ID_Continue:no}', "");
    Expect(0, 918000, '\P{ID_Continue:no}', "");
    Expect(1, 918000, '\P{^ID_Continue:no}', "");
    Expect(0, 917999, '\p{ID_Continue:no}', "");
    Expect(1, 917999, '\p{^ID_Continue:no}', "");
    Expect(1, 917999, '\P{ID_Continue:no}', "");
    Expect(0, 917999, '\P{^ID_Continue:no}', "");
    Expect(1, 918000, '\p{ID_Continue=-	NO}', "");
    Expect(0, 918000, '\p{^ID_Continue=-	NO}', "");
    Expect(0, 918000, '\P{ID_Continue=-	NO}', "");
    Expect(1, 918000, '\P{^ID_Continue=-	NO}', "");
    Expect(0, 917999, '\p{ID_Continue=-	NO}', "");
    Expect(1, 917999, '\p{^ID_Continue=-	NO}', "");
    Expect(1, 917999, '\P{ID_Continue=-	NO}', "");
    Expect(0, 917999, '\P{^ID_Continue=-	NO}', "");
    Error('\p{IDC=:=N}');
    Error('\P{IDC=:=N}');
    Expect(1, 918000, '\p{IDC=n}', "");
    Expect(0, 918000, '\p{^IDC=n}', "");
    Expect(0, 918000, '\P{IDC=n}', "");
    Expect(1, 918000, '\P{^IDC=n}', "");
    Expect(0, 917999, '\p{IDC=n}', "");
    Expect(1, 917999, '\p{^IDC=n}', "");
    Expect(1, 917999, '\P{IDC=n}', "");
    Expect(0, 917999, '\P{^IDC=n}', "");
    Expect(1, 918000, '\p{IDC=	 n}', "");
    Expect(0, 918000, '\p{^IDC=	 n}', "");
    Expect(0, 918000, '\P{IDC=	 n}', "");
    Expect(1, 918000, '\P{^IDC=	 n}', "");
    Expect(0, 917999, '\p{IDC=	 n}', "");
    Expect(1, 917999, '\p{^IDC=	 n}', "");
    Expect(1, 917999, '\P{IDC=	 n}', "");
    Expect(0, 917999, '\P{^IDC=	 n}', "");
    Error('\p{Is_ID_Continue=  F:=}');
    Error('\P{Is_ID_Continue=  F:=}');
    Expect(1, 918000, '\p{Is_ID_Continue=f}', "");
    Expect(0, 918000, '\p{^Is_ID_Continue=f}', "");
    Expect(0, 918000, '\P{Is_ID_Continue=f}', "");
    Expect(1, 918000, '\P{^Is_ID_Continue=f}', "");
    Expect(0, 917999, '\p{Is_ID_Continue=f}', "");
    Expect(1, 917999, '\p{^Is_ID_Continue=f}', "");
    Expect(1, 917999, '\P{Is_ID_Continue=f}', "");
    Expect(0, 917999, '\P{^Is_ID_Continue=f}', "");
    Expect(1, 918000, '\p{Is_ID_Continue=	_F}', "");
    Expect(0, 918000, '\p{^Is_ID_Continue=	_F}', "");
    Expect(0, 918000, '\P{Is_ID_Continue=	_F}', "");
    Expect(1, 918000, '\P{^Is_ID_Continue=	_F}', "");
    Expect(0, 917999, '\p{Is_ID_Continue=	_F}', "");
    Expect(1, 917999, '\p{^Is_ID_Continue=	_F}', "");
    Expect(1, 917999, '\P{Is_ID_Continue=	_F}', "");
    Expect(0, 917999, '\P{^Is_ID_Continue=	_F}', "");
    Error('\p{Is_IDC:	:=-	false}');
    Error('\P{Is_IDC:	:=-	false}');
    Expect(1, 918000, '\p{Is_IDC=false}', "");
    Expect(0, 918000, '\p{^Is_IDC=false}', "");
    Expect(0, 918000, '\P{Is_IDC=false}', "");
    Expect(1, 918000, '\P{^Is_IDC=false}', "");
    Expect(0, 917999, '\p{Is_IDC=false}', "");
    Expect(1, 917999, '\p{^Is_IDC=false}', "");
    Expect(1, 917999, '\P{Is_IDC=false}', "");
    Expect(0, 917999, '\P{^Is_IDC=false}', "");
    Expect(1, 918000, '\p{Is_IDC= FALSE}', "");
    Expect(0, 918000, '\p{^Is_IDC= FALSE}', "");
    Expect(0, 918000, '\P{Is_IDC= FALSE}', "");
    Expect(1, 918000, '\P{^Is_IDC= FALSE}', "");
    Expect(0, 917999, '\p{Is_IDC= FALSE}', "");
    Expect(1, 917999, '\p{^Is_IDC= FALSE}', "");
    Expect(1, 917999, '\P{Is_IDC= FALSE}', "");
    Expect(0, 917999, '\P{^Is_IDC= FALSE}', "");
    Error('\p{ID_Continue::= -Yes}');
    Error('\P{ID_Continue::= -Yes}');
    Expect(1, 917999, '\p{ID_Continue: yes}', "");
    Expect(0, 917999, '\p{^ID_Continue: yes}', "");
    Expect(0, 917999, '\P{ID_Continue: yes}', "");
    Expect(1, 917999, '\P{^ID_Continue: yes}', "");
    Expect(0, 918000, '\p{ID_Continue: yes}', "");
    Expect(1, 918000, '\p{^ID_Continue: yes}', "");
    Expect(1, 918000, '\P{ID_Continue: yes}', "");
    Expect(0, 918000, '\P{^ID_Continue: yes}', "");
    Expect(1, 917999, '\p{ID_Continue=_ Yes}', "");
    Expect(0, 917999, '\p{^ID_Continue=_ Yes}', "");
    Expect(0, 917999, '\P{ID_Continue=_ Yes}', "");
    Expect(1, 917999, '\P{^ID_Continue=_ Yes}', "");
    Expect(0, 918000, '\p{ID_Continue=_ Yes}', "");
    Expect(1, 918000, '\p{^ID_Continue=_ Yes}', "");
    Expect(1, 918000, '\P{ID_Continue=_ Yes}', "");
    Expect(0, 918000, '\P{^ID_Continue=_ Yes}', "");
    Error('\p{IDC= /a/y}');
    Error('\P{IDC= /a/y}');
    Expect(1, 917999, '\p{IDC=y}', "");
    Expect(0, 917999, '\p{^IDC=y}', "");
    Expect(0, 917999, '\P{IDC=y}', "");
    Expect(1, 917999, '\P{^IDC=y}', "");
    Expect(0, 918000, '\p{IDC=y}', "");
    Expect(1, 918000, '\p{^IDC=y}', "");
    Expect(1, 918000, '\P{IDC=y}', "");
    Expect(0, 918000, '\P{^IDC=y}', "");
    Expect(1, 917999, '\p{IDC=	-Y}', "");
    Expect(0, 917999, '\p{^IDC=	-Y}', "");
    Expect(0, 917999, '\P{IDC=	-Y}', "");
    Expect(1, 917999, '\P{^IDC=	-Y}', "");
    Expect(0, 918000, '\p{IDC=	-Y}', "");
    Expect(1, 918000, '\p{^IDC=	-Y}', "");
    Expect(1, 918000, '\P{IDC=	-Y}', "");
    Expect(0, 918000, '\P{^IDC=	-Y}', "");
    Error('\p{Is_ID_Continue= :=T}');
    Error('\P{Is_ID_Continue= :=T}');
    Expect(1, 917999, '\p{Is_ID_Continue=t}', "");
    Expect(0, 917999, '\p{^Is_ID_Continue=t}', "");
    Expect(0, 917999, '\P{Is_ID_Continue=t}', "");
    Expect(1, 917999, '\P{^Is_ID_Continue=t}', "");
    Expect(0, 918000, '\p{Is_ID_Continue=t}', "");
    Expect(1, 918000, '\p{^Is_ID_Continue=t}', "");
    Expect(1, 918000, '\P{Is_ID_Continue=t}', "");
    Expect(0, 918000, '\P{^Is_ID_Continue=t}', "");
    Expect(1, 917999, '\p{Is_ID_Continue=-_T}', "");
    Expect(0, 917999, '\p{^Is_ID_Continue=-_T}', "");
    Expect(0, 917999, '\P{Is_ID_Continue=-_T}', "");
    Expect(1, 917999, '\P{^Is_ID_Continue=-_T}', "");
    Expect(0, 918000, '\p{Is_ID_Continue=-_T}', "");
    Expect(1, 918000, '\p{^Is_ID_Continue=-_T}', "");
    Expect(1, 918000, '\P{Is_ID_Continue=-_T}', "");
    Expect(0, 918000, '\P{^Is_ID_Continue=-_T}', "");
    Error('\p{Is_IDC=:=__true}');
    Error('\P{Is_IDC=:=__true}');
    Expect(1, 917999, '\p{Is_IDC=true}', "");
    Expect(0, 917999, '\p{^Is_IDC=true}', "");
    Expect(0, 917999, '\P{Is_IDC=true}', "");
    Expect(1, 917999, '\P{^Is_IDC=true}', "");
    Expect(0, 918000, '\p{Is_IDC=true}', "");
    Expect(1, 918000, '\p{^Is_IDC=true}', "");
    Expect(1, 918000, '\P{Is_IDC=true}', "");
    Expect(0, 918000, '\P{^Is_IDC=true}', "");
    Expect(1, 917999, '\p{Is_IDC= True}', "");
    Expect(0, 917999, '\p{^Is_IDC= True}', "");
    Expect(0, 917999, '\P{Is_IDC= True}', "");
    Expect(1, 917999, '\P{^Is_IDC= True}', "");
    Expect(0, 918000, '\p{Is_IDC= True}', "");
    Expect(1, 918000, '\p{^Is_IDC= True}', "");
    Expect(1, 918000, '\P{Is_IDC= True}', "");
    Expect(0, 918000, '\P{^Is_IDC= True}', "");
    Error('\p{Ideographic=	 No:=}');
    Error('\P{Ideographic=	 No:=}');
    Expect(1, 195102, '\p{Ideographic=no}', "");
    Expect(0, 195102, '\p{^Ideographic=no}', "");
    Expect(0, 195102, '\P{Ideographic=no}', "");
    Expect(1, 195102, '\P{^Ideographic=no}', "");
    Expect(0, 195101, '\p{Ideographic=no}', "");
    Expect(1, 195101, '\p{^Ideographic=no}', "");
    Expect(1, 195101, '\P{Ideographic=no}', "");
    Expect(0, 195101, '\P{^Ideographic=no}', "");
    Expect(1, 195102, '\p{Ideographic= _no}', "");
    Expect(0, 195102, '\p{^Ideographic= _no}', "");
    Expect(0, 195102, '\P{Ideographic= _no}', "");
    Expect(1, 195102, '\P{^Ideographic= _no}', "");
    Expect(0, 195101, '\p{Ideographic= _no}', "");
    Expect(1, 195101, '\p{^Ideographic= _no}', "");
    Expect(1, 195101, '\P{Ideographic= _no}', "");
    Expect(0, 195101, '\P{^Ideographic= _no}', "");
    Error('\p{Ideo=	/a/n}');
    Error('\P{Ideo=	/a/n}');
    Expect(1, 195102, '\p{Ideo=n}', "");
    Expect(0, 195102, '\p{^Ideo=n}', "");
    Expect(0, 195102, '\P{Ideo=n}', "");
    Expect(1, 195102, '\P{^Ideo=n}', "");
    Expect(0, 195101, '\p{Ideo=n}', "");
    Expect(1, 195101, '\p{^Ideo=n}', "");
    Expect(1, 195101, '\P{Ideo=n}', "");
    Expect(0, 195101, '\P{^Ideo=n}', "");
    Expect(1, 195102, '\p{Ideo=_	N}', "");
    Expect(0, 195102, '\p{^Ideo=_	N}', "");
    Expect(0, 195102, '\P{Ideo=_	N}', "");
    Expect(1, 195102, '\P{^Ideo=_	N}', "");
    Expect(0, 195101, '\p{Ideo=_	N}', "");
    Expect(1, 195101, '\p{^Ideo=_	N}', "");
    Expect(1, 195101, '\P{Ideo=_	N}', "");
    Expect(0, 195101, '\P{^Ideo=_	N}', "");
    Error('\p{Is_Ideographic:	-f/a/}');
    Error('\P{Is_Ideographic:	-f/a/}');
    Expect(1, 195102, '\p{Is_Ideographic=f}', "");
    Expect(0, 195102, '\p{^Is_Ideographic=f}', "");
    Expect(0, 195102, '\P{Is_Ideographic=f}', "");
    Expect(1, 195102, '\P{^Is_Ideographic=f}', "");
    Expect(0, 195101, '\p{Is_Ideographic=f}', "");
    Expect(1, 195101, '\p{^Is_Ideographic=f}', "");
    Expect(1, 195101, '\P{Is_Ideographic=f}', "");
    Expect(0, 195101, '\P{^Is_Ideographic=f}', "");
    Expect(1, 195102, '\p{Is_Ideographic=-F}', "");
    Expect(0, 195102, '\p{^Is_Ideographic=-F}', "");
    Expect(0, 195102, '\P{Is_Ideographic=-F}', "");
    Expect(1, 195102, '\P{^Is_Ideographic=-F}', "");
    Expect(0, 195101, '\p{Is_Ideographic=-F}', "");
    Expect(1, 195101, '\p{^Is_Ideographic=-F}', "");
    Expect(1, 195101, '\P{Is_Ideographic=-F}', "");
    Expect(0, 195101, '\P{^Is_Ideographic=-F}', "");
    Error('\p{Is_Ideo=:=  False}');
    Error('\P{Is_Ideo=:=  False}');
    Expect(1, 195102, '\p{Is_Ideo=false}', "");
    Expect(0, 195102, '\p{^Is_Ideo=false}', "");
    Expect(0, 195102, '\P{Is_Ideo=false}', "");
    Expect(1, 195102, '\P{^Is_Ideo=false}', "");
    Expect(0, 195101, '\p{Is_Ideo=false}', "");
    Expect(1, 195101, '\p{^Is_Ideo=false}', "");
    Expect(1, 195101, '\P{Is_Ideo=false}', "");
    Expect(0, 195101, '\P{^Is_Ideo=false}', "");
    Expect(1, 195102, '\p{Is_Ideo=__False}', "");
    Expect(0, 195102, '\p{^Is_Ideo=__False}', "");
    Expect(0, 195102, '\P{Is_Ideo=__False}', "");
    Expect(1, 195102, '\P{^Is_Ideo=__False}', "");
    Expect(0, 195101, '\p{Is_Ideo=__False}', "");
    Expect(1, 195101, '\p{^Is_Ideo=__False}', "");
    Expect(1, 195101, '\P{Is_Ideo=__False}', "");
    Expect(0, 195101, '\P{^Is_Ideo=__False}', "");
    Error('\p{Ideographic=- Yes/a/}');
    Error('\P{Ideographic=- Yes/a/}');
    Expect(1, 195101, '\p{Ideographic=yes}', "");
    Expect(0, 195101, '\p{^Ideographic=yes}', "");
    Expect(0, 195101, '\P{Ideographic=yes}', "");
    Expect(1, 195101, '\P{^Ideographic=yes}', "");
    Expect(0, 195102, '\p{Ideographic=yes}', "");
    Expect(1, 195102, '\p{^Ideographic=yes}', "");
    Expect(1, 195102, '\P{Ideographic=yes}', "");
    Expect(0, 195102, '\P{^Ideographic=yes}', "");
    Expect(1, 195101, '\p{Ideographic: 	yes}', "");
    Expect(0, 195101, '\p{^Ideographic: 	yes}', "");
    Expect(0, 195101, '\P{Ideographic: 	yes}', "");
    Expect(1, 195101, '\P{^Ideographic: 	yes}', "");
    Expect(0, 195102, '\p{Ideographic: 	yes}', "");
    Expect(1, 195102, '\p{^Ideographic: 	yes}', "");
    Expect(1, 195102, '\P{Ideographic: 	yes}', "");
    Expect(0, 195102, '\P{^Ideographic: 	yes}', "");
    Error('\p{Ideo= Y:=}');
    Error('\P{Ideo= Y:=}');
    Expect(1, 195101, '\p{Ideo=y}', "");
    Expect(0, 195101, '\p{^Ideo=y}', "");
    Expect(0, 195101, '\P{Ideo=y}', "");
    Expect(1, 195101, '\P{^Ideo=y}', "");
    Expect(0, 195102, '\p{Ideo=y}', "");
    Expect(1, 195102, '\p{^Ideo=y}', "");
    Expect(1, 195102, '\P{Ideo=y}', "");
    Expect(0, 195102, '\P{^Ideo=y}', "");
    Expect(1, 195101, '\p{Ideo:     Y}', "");
    Expect(0, 195101, '\p{^Ideo:     Y}', "");
    Expect(0, 195101, '\P{Ideo:     Y}', "");
    Expect(1, 195101, '\P{^Ideo:     Y}', "");
    Expect(0, 195102, '\p{Ideo:     Y}', "");
    Expect(1, 195102, '\p{^Ideo:     Y}', "");
    Expect(1, 195102, '\P{Ideo:     Y}', "");
    Expect(0, 195102, '\P{^Ideo:     Y}', "");
    Error('\p{Is_Ideographic=_:=T}');
    Error('\P{Is_Ideographic=_:=T}');
    Expect(1, 195101, '\p{Is_Ideographic=t}', "");
    Expect(0, 195101, '\p{^Is_Ideographic=t}', "");
    Expect(0, 195101, '\P{Is_Ideographic=t}', "");
    Expect(1, 195101, '\P{^Is_Ideographic=t}', "");
    Expect(0, 195102, '\p{Is_Ideographic=t}', "");
    Expect(1, 195102, '\p{^Is_Ideographic=t}', "");
    Expect(1, 195102, '\P{Is_Ideographic=t}', "");
    Expect(0, 195102, '\P{^Is_Ideographic=t}', "");
    Expect(1, 195101, '\p{Is_Ideographic=_-T}', "");
    Expect(0, 195101, '\p{^Is_Ideographic=_-T}', "");
    Expect(0, 195101, '\P{Is_Ideographic=_-T}', "");
    Expect(1, 195101, '\P{^Is_Ideographic=_-T}', "");
    Expect(0, 195102, '\p{Is_Ideographic=_-T}', "");
    Expect(1, 195102, '\p{^Is_Ideographic=_-T}', "");
    Expect(1, 195102, '\P{Is_Ideographic=_-T}', "");
    Expect(0, 195102, '\P{^Is_Ideographic=_-T}', "");
    Error('\p{Is_Ideo=	_True:=}');
    Error('\P{Is_Ideo=	_True:=}');
    Expect(1, 195101, '\p{Is_Ideo=true}', "");
    Expect(0, 195101, '\p{^Is_Ideo=true}', "");
    Expect(0, 195101, '\P{Is_Ideo=true}', "");
    Expect(1, 195101, '\P{^Is_Ideo=true}', "");
    Expect(0, 195102, '\p{Is_Ideo=true}', "");
    Expect(1, 195102, '\p{^Is_Ideo=true}', "");
    Expect(1, 195102, '\P{Is_Ideo=true}', "");
    Expect(0, 195102, '\P{^Is_Ideo=true}', "");
    Expect(1, 195101, '\p{Is_Ideo=_TRUE}', "");
    Expect(0, 195101, '\p{^Is_Ideo=_TRUE}', "");
    Expect(0, 195101, '\P{Is_Ideo=_TRUE}', "");
    Expect(1, 195101, '\P{^Is_Ideo=_TRUE}', "");
    Expect(0, 195102, '\p{Is_Ideo=_TRUE}', "");
    Expect(1, 195102, '\p{^Is_Ideo=_TRUE}', "");
    Expect(1, 195102, '\P{Is_Ideo=_TRUE}', "");
    Expect(0, 195102, '\P{^Is_Ideo=_TRUE}', "");
    Error('\p{ID_Start=/a/	 No}');
    Error('\P{ID_Start=/a/	 No}');
    Expect(1, 195102, '\p{ID_Start=no}', "");
    Expect(0, 195102, '\p{^ID_Start=no}', "");
    Expect(0, 195102, '\P{ID_Start=no}', "");
    Expect(1, 195102, '\P{^ID_Start=no}', "");
    Expect(0, 195101, '\p{ID_Start=no}', "");
    Expect(1, 195101, '\p{^ID_Start=no}', "");
    Expect(1, 195101, '\P{ID_Start=no}', "");
    Expect(0, 195101, '\P{^ID_Start=no}', "");
    Expect(1, 195102, '\p{ID_Start=_-No}', "");
    Expect(0, 195102, '\p{^ID_Start=_-No}', "");
    Expect(0, 195102, '\P{ID_Start=_-No}', "");
    Expect(1, 195102, '\P{^ID_Start=_-No}', "");
    Expect(0, 195101, '\p{ID_Start=_-No}', "");
    Expect(1, 195101, '\p{^ID_Start=_-No}', "");
    Expect(1, 195101, '\P{ID_Start=_-No}', "");
    Expect(0, 195101, '\P{^ID_Start=_-No}', "");
    Error('\p{IDS=-:=N}');
    Error('\P{IDS=-:=N}');
    Expect(1, 195102, '\p{IDS=n}', "");
    Expect(0, 195102, '\p{^IDS=n}', "");
    Expect(0, 195102, '\P{IDS=n}', "");
    Expect(1, 195102, '\P{^IDS=n}', "");
    Expect(0, 195101, '\p{IDS=n}', "");
    Expect(1, 195101, '\p{^IDS=n}', "");
    Expect(1, 195101, '\P{IDS=n}', "");
    Expect(0, 195101, '\P{^IDS=n}', "");
    Expect(1, 195102, '\p{IDS:	-n}', "");
    Expect(0, 195102, '\p{^IDS:	-n}', "");
    Expect(0, 195102, '\P{IDS:	-n}', "");
    Expect(1, 195102, '\P{^IDS:	-n}', "");
    Expect(0, 195101, '\p{IDS:	-n}', "");
    Expect(1, 195101, '\p{^IDS:	-n}', "");
    Expect(1, 195101, '\P{IDS:	-n}', "");
    Expect(0, 195101, '\P{^IDS:	-n}', "");
    Error('\p{Is_ID_Start=:=F}');
    Error('\P{Is_ID_Start=:=F}');
    Expect(1, 195102, '\p{Is_ID_Start=f}', "");
    Expect(0, 195102, '\p{^Is_ID_Start=f}', "");
    Expect(0, 195102, '\P{Is_ID_Start=f}', "");
    Expect(1, 195102, '\P{^Is_ID_Start=f}', "");
    Expect(0, 195101, '\p{Is_ID_Start=f}', "");
    Expect(1, 195101, '\p{^Is_ID_Start=f}', "");
    Expect(1, 195101, '\P{Is_ID_Start=f}', "");
    Expect(0, 195101, '\P{^Is_ID_Start=f}', "");
    Expect(1, 195102, '\p{Is_ID_Start=__F}', "");
    Expect(0, 195102, '\p{^Is_ID_Start=__F}', "");
    Expect(0, 195102, '\P{Is_ID_Start=__F}', "");
    Expect(1, 195102, '\P{^Is_ID_Start=__F}', "");
    Expect(0, 195101, '\p{Is_ID_Start=__F}', "");
    Expect(1, 195101, '\p{^Is_ID_Start=__F}', "");
    Expect(1, 195101, '\P{Is_ID_Start=__F}', "");
    Expect(0, 195101, '\P{^Is_ID_Start=__F}', "");
    Error('\p{Is_IDS=/a/ -False}');
    Error('\P{Is_IDS=/a/ -False}');
    Expect(1, 195102, '\p{Is_IDS=false}', "");
    Expect(0, 195102, '\p{^Is_IDS=false}', "");
    Expect(0, 195102, '\P{Is_IDS=false}', "");
    Expect(1, 195102, '\P{^Is_IDS=false}', "");
    Expect(0, 195101, '\p{Is_IDS=false}', "");
    Expect(1, 195101, '\p{^Is_IDS=false}', "");
    Expect(1, 195101, '\P{Is_IDS=false}', "");
    Expect(0, 195101, '\P{^Is_IDS=false}', "");
    Expect(1, 195102, '\p{Is_IDS=  false}', "");
    Expect(0, 195102, '\p{^Is_IDS=  false}', "");
    Expect(0, 195102, '\P{Is_IDS=  false}', "");
    Expect(1, 195102, '\P{^Is_IDS=  false}', "");
    Expect(0, 195101, '\p{Is_IDS=  false}', "");
    Expect(1, 195101, '\p{^Is_IDS=  false}', "");
    Expect(1, 195101, '\P{Is_IDS=  false}', "");
    Expect(0, 195101, '\P{^Is_IDS=  false}', "");
    Error('\p{ID_Start=_/a/yes}');
    Error('\P{ID_Start=_/a/yes}');
    Expect(1, 195101, '\p{ID_Start:   yes}', "");
    Expect(0, 195101, '\p{^ID_Start:   yes}', "");
    Expect(0, 195101, '\P{ID_Start:   yes}', "");
    Expect(1, 195101, '\P{^ID_Start:   yes}', "");
    Expect(0, 195102, '\p{ID_Start:   yes}', "");
    Expect(1, 195102, '\p{^ID_Start:   yes}', "");
    Expect(1, 195102, '\P{ID_Start:   yes}', "");
    Expect(0, 195102, '\P{^ID_Start:   yes}', "");
    Expect(1, 195101, '\p{ID_Start= -yes}', "");
    Expect(0, 195101, '\p{^ID_Start= -yes}', "");
    Expect(0, 195101, '\P{ID_Start= -yes}', "");
    Expect(1, 195101, '\P{^ID_Start= -yes}', "");
    Expect(0, 195102, '\p{ID_Start= -yes}', "");
    Expect(1, 195102, '\p{^ID_Start= -yes}', "");
    Expect(1, 195102, '\P{ID_Start= -yes}', "");
    Expect(0, 195102, '\P{^ID_Start= -yes}', "");
    Error('\p{IDS:	-y:=}');
    Error('\P{IDS:	-y:=}');
    Expect(1, 195101, '\p{IDS=y}', "");
    Expect(0, 195101, '\p{^IDS=y}', "");
    Expect(0, 195101, '\P{IDS=y}', "");
    Expect(1, 195101, '\P{^IDS=y}', "");
    Expect(0, 195102, '\p{IDS=y}', "");
    Expect(1, 195102, '\p{^IDS=y}', "");
    Expect(1, 195102, '\P{IDS=y}', "");
    Expect(0, 195102, '\P{^IDS=y}', "");
    Expect(1, 195101, '\p{IDS= 	y}', "");
    Expect(0, 195101, '\p{^IDS= 	y}', "");
    Expect(0, 195101, '\P{IDS= 	y}', "");
    Expect(1, 195101, '\P{^IDS= 	y}', "");
    Expect(0, 195102, '\p{IDS= 	y}', "");
    Expect(1, 195102, '\p{^IDS= 	y}', "");
    Expect(1, 195102, '\P{IDS= 	y}', "");
    Expect(0, 195102, '\P{^IDS= 	y}', "");
    Error('\p{Is_ID_Start=/a/T}');
    Error('\P{Is_ID_Start=/a/T}');
    Expect(1, 195101, '\p{Is_ID_Start=t}', "");
    Expect(0, 195101, '\p{^Is_ID_Start=t}', "");
    Expect(0, 195101, '\P{Is_ID_Start=t}', "");
    Expect(1, 195101, '\P{^Is_ID_Start=t}', "");
    Expect(0, 195102, '\p{Is_ID_Start=t}', "");
    Expect(1, 195102, '\p{^Is_ID_Start=t}', "");
    Expect(1, 195102, '\P{Is_ID_Start=t}', "");
    Expect(0, 195102, '\P{^Is_ID_Start=t}', "");
    Expect(1, 195101, '\p{Is_ID_Start=T}', "");
    Expect(0, 195101, '\p{^Is_ID_Start=T}', "");
    Expect(0, 195101, '\P{Is_ID_Start=T}', "");
    Expect(1, 195101, '\P{^Is_ID_Start=T}', "");
    Expect(0, 195102, '\p{Is_ID_Start=T}', "");
    Expect(1, 195102, '\p{^Is_ID_Start=T}', "");
    Expect(1, 195102, '\P{Is_ID_Start=T}', "");
    Expect(0, 195102, '\P{^Is_ID_Start=T}', "");
    Error('\p{Is_IDS=_:=TRUE}');
    Error('\P{Is_IDS=_:=TRUE}');
    Expect(1, 195101, '\p{Is_IDS=true}', "");
    Expect(0, 195101, '\p{^Is_IDS=true}', "");
    Expect(0, 195101, '\P{Is_IDS=true}', "");
    Expect(1, 195101, '\P{^Is_IDS=true}', "");
    Expect(0, 195102, '\p{Is_IDS=true}', "");
    Expect(1, 195102, '\p{^Is_IDS=true}', "");
    Expect(1, 195102, '\P{Is_IDS=true}', "");
    Expect(0, 195102, '\P{^Is_IDS=true}', "");
    Expect(1, 195101, '\p{Is_IDS=_ True}', "");
    Expect(0, 195101, '\p{^Is_IDS=_ True}', "");
    Expect(0, 195101, '\P{Is_IDS=_ True}', "");
    Expect(1, 195101, '\P{^Is_IDS=_ True}', "");
    Expect(0, 195102, '\p{Is_IDS=_ True}', "");
    Expect(1, 195102, '\p{^Is_IDS=_ True}', "");
    Expect(1, 195102, '\P{Is_IDS=_ True}', "");
    Expect(0, 195102, '\P{^Is_IDS=_ True}', "");
    Error('\p{IDS_Binary_Operator= 	no/a/}');
    Error('\P{IDS_Binary_Operator= 	no/a/}');
    Expect(1, 12284, '\p{IDS_Binary_Operator=no}', "");
    Expect(0, 12284, '\p{^IDS_Binary_Operator=no}', "");
    Expect(0, 12284, '\P{IDS_Binary_Operator=no}', "");
    Expect(1, 12284, '\P{^IDS_Binary_Operator=no}', "");
    Expect(0, 12283, '\p{IDS_Binary_Operator=no}', "");
    Expect(1, 12283, '\p{^IDS_Binary_Operator=no}', "");
    Expect(1, 12283, '\P{IDS_Binary_Operator=no}', "");
    Expect(0, 12283, '\P{^IDS_Binary_Operator=no}', "");
    Expect(1, 12284, '\p{IDS_Binary_Operator=No}', "");
    Expect(0, 12284, '\p{^IDS_Binary_Operator=No}', "");
    Expect(0, 12284, '\P{IDS_Binary_Operator=No}', "");
    Expect(1, 12284, '\P{^IDS_Binary_Operator=No}', "");
    Expect(0, 12283, '\p{IDS_Binary_Operator=No}', "");
    Expect(1, 12283, '\p{^IDS_Binary_Operator=No}', "");
    Expect(1, 12283, '\P{IDS_Binary_Operator=No}', "");
    Expect(0, 12283, '\P{^IDS_Binary_Operator=No}', "");
    Error('\p{IDSB:	/a/ -N}');
    Error('\P{IDSB:	/a/ -N}');
    Expect(1, 12284, '\p{IDSB=n}', "");
    Expect(0, 12284, '\p{^IDSB=n}', "");
    Expect(0, 12284, '\P{IDSB=n}', "");
    Expect(1, 12284, '\P{^IDSB=n}', "");
    Expect(0, 12283, '\p{IDSB=n}', "");
    Expect(1, 12283, '\p{^IDSB=n}', "");
    Expect(1, 12283, '\P{IDSB=n}', "");
    Expect(0, 12283, '\P{^IDSB=n}', "");
    Expect(1, 12284, '\p{IDSB=-N}', "");
    Expect(0, 12284, '\p{^IDSB=-N}', "");
    Expect(0, 12284, '\P{IDSB=-N}', "");
    Expect(1, 12284, '\P{^IDSB=-N}', "");
    Expect(0, 12283, '\p{IDSB=-N}', "");
    Expect(1, 12283, '\p{^IDSB=-N}', "");
    Expect(1, 12283, '\P{IDSB=-N}', "");
    Expect(0, 12283, '\P{^IDSB=-N}', "");
    Error('\p{Is_IDS_Binary_Operator=/a/F}');
    Error('\P{Is_IDS_Binary_Operator=/a/F}');
    Expect(1, 12284, '\p{Is_IDS_Binary_Operator=f}', "");
    Expect(0, 12284, '\p{^Is_IDS_Binary_Operator=f}', "");
    Expect(0, 12284, '\P{Is_IDS_Binary_Operator=f}', "");
    Expect(1, 12284, '\P{^Is_IDS_Binary_Operator=f}', "");
    Expect(0, 12283, '\p{Is_IDS_Binary_Operator=f}', "");
    Expect(1, 12283, '\p{^Is_IDS_Binary_Operator=f}', "");
    Expect(1, 12283, '\P{Is_IDS_Binary_Operator=f}', "");
    Expect(0, 12283, '\P{^Is_IDS_Binary_Operator=f}', "");
    Expect(1, 12284, '\p{Is_IDS_Binary_Operator=  F}', "");
    Expect(0, 12284, '\p{^Is_IDS_Binary_Operator=  F}', "");
    Expect(0, 12284, '\P{Is_IDS_Binary_Operator=  F}', "");
    Expect(1, 12284, '\P{^Is_IDS_Binary_Operator=  F}', "");
    Expect(0, 12283, '\p{Is_IDS_Binary_Operator=  F}', "");
    Expect(1, 12283, '\p{^Is_IDS_Binary_Operator=  F}', "");
    Expect(1, 12283, '\P{Is_IDS_Binary_Operator=  F}', "");
    Expect(0, 12283, '\P{^Is_IDS_Binary_Operator=  F}', "");
    Error('\p{Is_IDSB=_	False:=}');
    Error('\P{Is_IDSB=_	False:=}');
    Expect(1, 12284, '\p{Is_IDSB=false}', "");
    Expect(0, 12284, '\p{^Is_IDSB=false}', "");
    Expect(0, 12284, '\P{Is_IDSB=false}', "");
    Expect(1, 12284, '\P{^Is_IDSB=false}', "");
    Expect(0, 12283, '\p{Is_IDSB=false}', "");
    Expect(1, 12283, '\p{^Is_IDSB=false}', "");
    Expect(1, 12283, '\P{Is_IDSB=false}', "");
    Expect(0, 12283, '\P{^Is_IDSB=false}', "");
    Expect(1, 12284, '\p{Is_IDSB=--False}', "");
    Expect(0, 12284, '\p{^Is_IDSB=--False}', "");
    Expect(0, 12284, '\P{Is_IDSB=--False}', "");
    Expect(1, 12284, '\P{^Is_IDSB=--False}', "");
    Expect(0, 12283, '\p{Is_IDSB=--False}', "");
    Expect(1, 12283, '\p{^Is_IDSB=--False}', "");
    Expect(1, 12283, '\P{Is_IDSB=--False}', "");
    Expect(0, 12283, '\P{^Is_IDSB=--False}', "");
    Error('\p{IDS_Binary_Operator=	_yes/a/}');
    Error('\P{IDS_Binary_Operator=	_yes/a/}');
    Expect(1, 12283, '\p{IDS_Binary_Operator=yes}', "");
    Expect(0, 12283, '\p{^IDS_Binary_Operator=yes}', "");
    Expect(0, 12283, '\P{IDS_Binary_Operator=yes}', "");
    Expect(1, 12283, '\P{^IDS_Binary_Operator=yes}', "");
    Expect(0, 12284, '\p{IDS_Binary_Operator=yes}', "");
    Expect(1, 12284, '\p{^IDS_Binary_Operator=yes}', "");
    Expect(1, 12284, '\P{IDS_Binary_Operator=yes}', "");
    Expect(0, 12284, '\P{^IDS_Binary_Operator=yes}', "");
    Expect(1, 12283, '\p{IDS_Binary_Operator:   _ Yes}', "");
    Expect(0, 12283, '\p{^IDS_Binary_Operator:   _ Yes}', "");
    Expect(0, 12283, '\P{IDS_Binary_Operator:   _ Yes}', "");
    Expect(1, 12283, '\P{^IDS_Binary_Operator:   _ Yes}', "");
    Expect(0, 12284, '\p{IDS_Binary_Operator:   _ Yes}', "");
    Expect(1, 12284, '\p{^IDS_Binary_Operator:   _ Yes}', "");
    Expect(1, 12284, '\P{IDS_Binary_Operator:   _ Yes}', "");
    Expect(0, 12284, '\P{^IDS_Binary_Operator:   _ Yes}', "");
    Error('\p{IDSB=-Y:=}');
    Error('\P{IDSB=-Y:=}');
    Expect(1, 12283, '\p{IDSB=y}', "");
    Expect(0, 12283, '\p{^IDSB=y}', "");
    Expect(0, 12283, '\P{IDSB=y}', "");
    Expect(1, 12283, '\P{^IDSB=y}', "");
    Expect(0, 12284, '\p{IDSB=y}', "");
    Expect(1, 12284, '\p{^IDSB=y}', "");
    Expect(1, 12284, '\P{IDSB=y}', "");
    Expect(0, 12284, '\P{^IDSB=y}', "");
    Expect(1, 12283, '\p{IDSB=	-Y}', "");
    Expect(0, 12283, '\p{^IDSB=	-Y}', "");
    Expect(0, 12283, '\P{IDSB=	-Y}', "");
    Expect(1, 12283, '\P{^IDSB=	-Y}', "");
    Expect(0, 12284, '\p{IDSB=	-Y}', "");
    Expect(1, 12284, '\p{^IDSB=	-Y}', "");
    Expect(1, 12284, '\P{IDSB=	-Y}', "");
    Expect(0, 12284, '\P{^IDSB=	-Y}', "");
    Error('\p{Is_IDS_Binary_Operator=	_T:=}');
    Error('\P{Is_IDS_Binary_Operator=	_T:=}');
    Expect(1, 12283, '\p{Is_IDS_Binary_Operator=t}', "");
    Expect(0, 12283, '\p{^Is_IDS_Binary_Operator=t}', "");
    Expect(0, 12283, '\P{Is_IDS_Binary_Operator=t}', "");
    Expect(1, 12283, '\P{^Is_IDS_Binary_Operator=t}', "");
    Expect(0, 12284, '\p{Is_IDS_Binary_Operator=t}', "");
    Expect(1, 12284, '\p{^Is_IDS_Binary_Operator=t}', "");
    Expect(1, 12284, '\P{Is_IDS_Binary_Operator=t}', "");
    Expect(0, 12284, '\P{^Is_IDS_Binary_Operator=t}', "");
    Expect(1, 12283, '\p{Is_IDS_Binary_Operator=_-t}', "");
    Expect(0, 12283, '\p{^Is_IDS_Binary_Operator=_-t}', "");
    Expect(0, 12283, '\P{Is_IDS_Binary_Operator=_-t}', "");
    Expect(1, 12283, '\P{^Is_IDS_Binary_Operator=_-t}', "");
    Expect(0, 12284, '\p{Is_IDS_Binary_Operator=_-t}', "");
    Expect(1, 12284, '\p{^Is_IDS_Binary_Operator=_-t}', "");
    Expect(1, 12284, '\P{Is_IDS_Binary_Operator=_-t}', "");
    Expect(0, 12284, '\P{^Is_IDS_Binary_Operator=_-t}', "");
    Error('\p{Is_IDSB=/a/_TRUE}');
    Error('\P{Is_IDSB=/a/_TRUE}');
    Expect(1, 12283, '\p{Is_IDSB=true}', "");
    Expect(0, 12283, '\p{^Is_IDSB=true}', "");
    Expect(0, 12283, '\P{Is_IDSB=true}', "");
    Expect(1, 12283, '\P{^Is_IDSB=true}', "");
    Expect(0, 12284, '\p{Is_IDSB=true}', "");
    Expect(1, 12284, '\p{^Is_IDSB=true}', "");
    Expect(1, 12284, '\P{Is_IDSB=true}', "");
    Expect(0, 12284, '\P{^Is_IDSB=true}', "");
    Expect(1, 12283, '\p{Is_IDSB:  True}', "");
    Expect(0, 12283, '\p{^Is_IDSB:  True}', "");
    Expect(0, 12283, '\P{Is_IDSB:  True}', "");
    Expect(1, 12283, '\P{^Is_IDSB:  True}', "");
    Expect(0, 12284, '\p{Is_IDSB:  True}', "");
    Expect(1, 12284, '\p{^Is_IDSB:  True}', "");
    Expect(1, 12284, '\P{Is_IDSB:  True}', "");
    Expect(0, 12284, '\P{^Is_IDSB:  True}', "");
    Error('\p{IDS_Trinary_Operator=	:=NO}');
    Error('\P{IDS_Trinary_Operator=	:=NO}');
    Expect(1, 12276, '\p{IDS_Trinary_Operator=no}', "");
    Expect(0, 12276, '\p{^IDS_Trinary_Operator=no}', "");
    Expect(0, 12276, '\P{IDS_Trinary_Operator=no}', "");
    Expect(1, 12276, '\P{^IDS_Trinary_Operator=no}', "");
    Expect(0, 12275, '\p{IDS_Trinary_Operator=no}', "");
    Expect(1, 12275, '\p{^IDS_Trinary_Operator=no}', "");
    Expect(1, 12275, '\P{IDS_Trinary_Operator=no}', "");
    Expect(0, 12275, '\P{^IDS_Trinary_Operator=no}', "");
    Expect(1, 12276, '\p{IDS_Trinary_Operator=	 No}', "");
    Expect(0, 12276, '\p{^IDS_Trinary_Operator=	 No}', "");
    Expect(0, 12276, '\P{IDS_Trinary_Operator=	 No}', "");
    Expect(1, 12276, '\P{^IDS_Trinary_Operator=	 No}', "");
    Expect(0, 12275, '\p{IDS_Trinary_Operator=	 No}', "");
    Expect(1, 12275, '\p{^IDS_Trinary_Operator=	 No}', "");
    Expect(1, 12275, '\P{IDS_Trinary_Operator=	 No}', "");
    Expect(0, 12275, '\P{^IDS_Trinary_Operator=	 No}', "");
    Error('\p{IDST=_N:=}');
    Error('\P{IDST=_N:=}');
    Expect(1, 12276, '\p{IDST=n}', "");
    Expect(0, 12276, '\p{^IDST=n}', "");
    Expect(0, 12276, '\P{IDST=n}', "");
    Expect(1, 12276, '\P{^IDST=n}', "");
    Expect(0, 12275, '\p{IDST=n}', "");
    Expect(1, 12275, '\p{^IDST=n}', "");
    Expect(1, 12275, '\P{IDST=n}', "");
    Expect(0, 12275, '\P{^IDST=n}', "");
    Expect(1, 12276, '\p{IDST=_N}', "");
    Expect(0, 12276, '\p{^IDST=_N}', "");
    Expect(0, 12276, '\P{IDST=_N}', "");
    Expect(1, 12276, '\P{^IDST=_N}', "");
    Expect(0, 12275, '\p{IDST=_N}', "");
    Expect(1, 12275, '\p{^IDST=_N}', "");
    Expect(1, 12275, '\P{IDST=_N}', "");
    Expect(0, 12275, '\P{^IDST=_N}', "");
    Error('\p{Is_IDS_Trinary_Operator=/a/ F}');
    Error('\P{Is_IDS_Trinary_Operator=/a/ F}');
    Expect(1, 12276, '\p{Is_IDS_Trinary_Operator=f}', "");
    Expect(0, 12276, '\p{^Is_IDS_Trinary_Operator=f}', "");
    Expect(0, 12276, '\P{Is_IDS_Trinary_Operator=f}', "");
    Expect(1, 12276, '\P{^Is_IDS_Trinary_Operator=f}', "");
    Expect(0, 12275, '\p{Is_IDS_Trinary_Operator=f}', "");
    Expect(1, 12275, '\p{^Is_IDS_Trinary_Operator=f}', "");
    Expect(1, 12275, '\P{Is_IDS_Trinary_Operator=f}', "");
    Expect(0, 12275, '\P{^Is_IDS_Trinary_Operator=f}', "");
    Expect(1, 12276, '\p{Is_IDS_Trinary_Operator=_F}', "");
    Expect(0, 12276, '\p{^Is_IDS_Trinary_Operator=_F}', "");
    Expect(0, 12276, '\P{Is_IDS_Trinary_Operator=_F}', "");
    Expect(1, 12276, '\P{^Is_IDS_Trinary_Operator=_F}', "");
    Expect(0, 12275, '\p{Is_IDS_Trinary_Operator=_F}', "");
    Expect(1, 12275, '\p{^Is_IDS_Trinary_Operator=_F}', "");
    Expect(1, 12275, '\P{Is_IDS_Trinary_Operator=_F}', "");
    Expect(0, 12275, '\P{^Is_IDS_Trinary_Operator=_F}', "");
    Error('\p{Is_IDST=	 FALSE/a/}');
    Error('\P{Is_IDST=	 FALSE/a/}');
    Expect(1, 12276, '\p{Is_IDST=false}', "");
    Expect(0, 12276, '\p{^Is_IDST=false}', "");
    Expect(0, 12276, '\P{Is_IDST=false}', "");
    Expect(1, 12276, '\P{^Is_IDST=false}', "");
    Expect(0, 12275, '\p{Is_IDST=false}', "");
    Expect(1, 12275, '\p{^Is_IDST=false}', "");
    Expect(1, 12275, '\P{Is_IDST=false}', "");
    Expect(0, 12275, '\P{^Is_IDST=false}', "");
    Expect(1, 12276, '\p{Is_IDST=	 False}', "");
    Expect(0, 12276, '\p{^Is_IDST=	 False}', "");
    Expect(0, 12276, '\P{Is_IDST=	 False}', "");
    Expect(1, 12276, '\P{^Is_IDST=	 False}', "");
    Expect(0, 12275, '\p{Is_IDST=	 False}', "");
    Expect(1, 12275, '\p{^Is_IDST=	 False}', "");
    Expect(1, 12275, '\P{Is_IDST=	 False}', "");
    Expect(0, 12275, '\P{^Is_IDST=	 False}', "");
    Error('\p{IDS_Trinary_Operator=	/a/Yes}');
    Error('\P{IDS_Trinary_Operator=	/a/Yes}');
    Expect(1, 12275, '\p{IDS_Trinary_Operator=yes}', "");
    Expect(0, 12275, '\p{^IDS_Trinary_Operator=yes}', "");
    Expect(0, 12275, '\P{IDS_Trinary_Operator=yes}', "");
    Expect(1, 12275, '\P{^IDS_Trinary_Operator=yes}', "");
    Expect(0, 12276, '\p{IDS_Trinary_Operator=yes}', "");
    Expect(1, 12276, '\p{^IDS_Trinary_Operator=yes}', "");
    Expect(1, 12276, '\P{IDS_Trinary_Operator=yes}', "");
    Expect(0, 12276, '\P{^IDS_Trinary_Operator=yes}', "");
    Expect(1, 12275, '\p{IDS_Trinary_Operator=_ yes}', "");
    Expect(0, 12275, '\p{^IDS_Trinary_Operator=_ yes}', "");
    Expect(0, 12275, '\P{IDS_Trinary_Operator=_ yes}', "");
    Expect(1, 12275, '\P{^IDS_Trinary_Operator=_ yes}', "");
    Expect(0, 12276, '\p{IDS_Trinary_Operator=_ yes}', "");
    Expect(1, 12276, '\p{^IDS_Trinary_Operator=_ yes}', "");
    Expect(1, 12276, '\P{IDS_Trinary_Operator=_ yes}', "");
    Expect(0, 12276, '\P{^IDS_Trinary_Operator=_ yes}', "");
    Error('\p{IDST=:=	_y}');
    Error('\P{IDST=:=	_y}');
    Expect(1, 12275, '\p{IDST=y}', "");
    Expect(0, 12275, '\p{^IDST=y}', "");
    Expect(0, 12275, '\P{IDST=y}', "");
    Expect(1, 12275, '\P{^IDST=y}', "");
    Expect(0, 12276, '\p{IDST=y}', "");
    Expect(1, 12276, '\p{^IDST=y}', "");
    Expect(1, 12276, '\P{IDST=y}', "");
    Expect(0, 12276, '\P{^IDST=y}', "");
    Expect(1, 12275, '\p{IDST:Y}', "");
    Expect(0, 12275, '\p{^IDST:Y}', "");
    Expect(0, 12275, '\P{IDST:Y}', "");
    Expect(1, 12275, '\P{^IDST:Y}', "");
    Expect(0, 12276, '\p{IDST:Y}', "");
    Expect(1, 12276, '\p{^IDST:Y}', "");
    Expect(1, 12276, '\P{IDST:Y}', "");
    Expect(0, 12276, '\P{^IDST:Y}', "");
    Error('\p{Is_IDS_Trinary_Operator=/a/--T}');
    Error('\P{Is_IDS_Trinary_Operator=/a/--T}');
    Expect(1, 12275, '\p{Is_IDS_Trinary_Operator:t}', "");
    Expect(0, 12275, '\p{^Is_IDS_Trinary_Operator:t}', "");
    Expect(0, 12275, '\P{Is_IDS_Trinary_Operator:t}', "");
    Expect(1, 12275, '\P{^Is_IDS_Trinary_Operator:t}', "");
    Expect(0, 12276, '\p{Is_IDS_Trinary_Operator:t}', "");
    Expect(1, 12276, '\p{^Is_IDS_Trinary_Operator:t}', "");
    Expect(1, 12276, '\P{Is_IDS_Trinary_Operator:t}', "");
    Expect(0, 12276, '\P{^Is_IDS_Trinary_Operator:t}', "");
    Expect(1, 12275, '\p{Is_IDS_Trinary_Operator=	t}', "");
    Expect(0, 12275, '\p{^Is_IDS_Trinary_Operator=	t}', "");
    Expect(0, 12275, '\P{Is_IDS_Trinary_Operator=	t}', "");
    Expect(1, 12275, '\P{^Is_IDS_Trinary_Operator=	t}', "");
    Expect(0, 12276, '\p{Is_IDS_Trinary_Operator=	t}', "");
    Expect(1, 12276, '\p{^Is_IDS_Trinary_Operator=	t}', "");
    Expect(1, 12276, '\P{Is_IDS_Trinary_Operator=	t}', "");
    Expect(0, 12276, '\P{^Is_IDS_Trinary_Operator=	t}', "");
    Error('\p{Is_IDST:  	true/a/}');
    Error('\P{Is_IDST:  	true/a/}');
    Expect(1, 12275, '\p{Is_IDST=true}', "");
    Expect(0, 12275, '\p{^Is_IDST=true}', "");
    Expect(0, 12275, '\P{Is_IDST=true}', "");
    Expect(1, 12275, '\P{^Is_IDST=true}', "");
    Expect(0, 12276, '\p{Is_IDST=true}', "");
    Expect(1, 12276, '\p{^Is_IDST=true}', "");
    Expect(1, 12276, '\P{Is_IDST=true}', "");
    Expect(0, 12276, '\P{^Is_IDST=true}', "");
    Expect(1, 12275, '\p{Is_IDST:	 	True}', "");
    Expect(0, 12275, '\p{^Is_IDST:	 	True}', "");
    Expect(0, 12275, '\P{Is_IDST:	 	True}', "");
    Expect(1, 12275, '\P{^Is_IDST:	 	True}', "");
    Expect(0, 12276, '\p{Is_IDST:	 	True}', "");
    Expect(1, 12276, '\p{^Is_IDST:	 	True}', "");
    Expect(1, 12276, '\P{Is_IDST:	 	True}', "");
    Expect(0, 12276, '\P{^Is_IDST:	 	True}', "");
    Error('\p{presentin}');
    Error('\P{presentin}');
    Error('\p{in}');
    Error('\P{in}');
    Error('\p{Present_In=-:=00001.1}');
    Error('\P{Present_In=-:=00001.1}');
    Expect(1, 65533, '\p{Present_In=0000000001.1}', "");
    Expect(0, 65533, '\p{^Present_In=0000000001.1}', "");
    Expect(0, 65533, '\P{Present_In=0000000001.1}', "");
    Expect(1, 65533, '\P{^Present_In=0000000001.1}', "");
    Expect(0, 65536, '\p{Present_In=0000000001.1}', "");
    Expect(1, 65536, '\p{^Present_In=0000000001.1}', "");
    Expect(1, 65536, '\P{Present_In=0000000001.1}', "");
    Expect(0, 65536, '\P{^Present_In=0000000001.1}', "");
    Error('\p{In=:=--+00001.1}');
    Error('\P{In=:=--+00001.1}');
    Expect(1, 65533, '\p{In=+01.1}', "");
    Expect(0, 65533, '\p{^In=+01.1}', "");
    Expect(0, 65533, '\P{In=+01.1}', "");
    Expect(1, 65533, '\P{^In=+01.1}', "");
    Expect(0, 65536, '\p{In=+01.1}', "");
    Expect(1, 65536, '\p{^In=+01.1}', "");
    Expect(1, 65536, '\P{In=+01.1}', "");
    Expect(0, 65536, '\P{^In=+01.1}', "");
    Error('\p{Is_Present_In:	 _+01.1/a/}');
    Error('\P{Is_Present_In:	 _+01.1/a/}');
    Expect(1, 65533, '\p{Is_Present_In=1.1}', "");
    Expect(0, 65533, '\p{^Is_Present_In=1.1}', "");
    Expect(0, 65533, '\P{Is_Present_In=1.1}', "");
    Expect(1, 65533, '\P{^Is_Present_In=1.1}', "");
    Expect(0, 65536, '\p{Is_Present_In=1.1}', "");
    Expect(1, 65536, '\p{^Is_Present_In=1.1}', "");
    Expect(1, 65536, '\P{Is_Present_In=1.1}', "");
    Expect(0, 65536, '\P{^Is_Present_In=1.1}', "");
    Error('\p{Is_In=_:=+000001.1}');
    Error('\P{Is_In=_:=+000001.1}');
    Expect(1, 65533, '\p{Is_In:	0001.1}', "");
    Expect(0, 65533, '\p{^Is_In:	0001.1}', "");
    Expect(0, 65533, '\P{Is_In:	0001.1}', "");
    Expect(1, 65533, '\P{^Is_In:	0001.1}', "");
    Expect(0, 65536, '\p{Is_In:	0001.1}', "");
    Expect(1, 65536, '\p{^Is_In:	0001.1}', "");
    Expect(1, 65536, '\P{Is_In:	0001.1}', "");
    Expect(0, 65536, '\P{^Is_In:	0001.1}', "");
    Error('\p{Present_In=	 00010.0:=}');
    Error('\P{Present_In=	 00010.0:=}');
    Expect(1, 983040, '\p{Present_In=0_0_0_0_0_0_10.0}', "");
    Expect(0, 983040, '\p{^Present_In=0_0_0_0_0_0_10.0}', "");
    Expect(0, 983040, '\P{Present_In=0_0_0_0_0_0_10.0}', "");
    Expect(1, 983040, '\P{^Present_In=0_0_0_0_0_0_10.0}', "");
    Expect(0, 983037, '\p{Present_In=0_0_0_0_0_0_10.0}', "");
    Expect(1, 983037, '\p{^Present_In=0_0_0_0_0_0_10.0}', "");
    Expect(1, 983037, '\P{Present_In=0_0_0_0_0_0_10.0}', "");
    Expect(0, 983037, '\P{^Present_In=0_0_0_0_0_0_10.0}', "");
    Error('\p{In= -V10_0/a/}');
    Error('\P{In= -V10_0/a/}');
    Expect(1, 983040, '\p{In=v100}', "");
    Expect(0, 983040, '\p{^In=v100}', "");
    Expect(0, 983040, '\P{In=v100}', "");
    Expect(1, 983040, '\P{^In=v100}', "");
    Expect(0, 983037, '\p{In=v100}', "");
    Expect(1, 983037, '\p{^In=v100}', "");
    Expect(1, 983037, '\P{In=v100}', "");
    Expect(0, 983037, '\P{^In=v100}', "");
    Expect(1, 983040, '\p{In=-V10_0}', "");
    Expect(0, 983040, '\p{^In=-V10_0}', "");
    Expect(0, 983040, '\P{In=-V10_0}', "");
    Expect(1, 983040, '\P{^In=-V10_0}', "");
    Expect(0, 983037, '\p{In=-V10_0}', "");
    Expect(1, 983037, '\p{^In=-V10_0}', "");
    Expect(1, 983037, '\P{In=-V10_0}', "");
    Expect(0, 983037, '\P{^In=-V10_0}', "");
    Error('\p{Is_Present_In=:=000010.0}');
    Error('\P{Is_Present_In=:=000010.0}');
    Expect(1, 983040, '\p{Is_Present_In=+000001_0.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+000001_0.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=+000001_0.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+000001_0.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=+000001_0.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+000001_0.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=+000001_0.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+000001_0.0}', "");
    Error('\p{Is_In:		/a/V10_0}');
    Error('\P{Is_In:		/a/V10_0}');
    Expect(1, 983040, '\p{Is_In:   v100}', "");
    Expect(0, 983040, '\p{^Is_In:   v100}', "");
    Expect(0, 983040, '\P{Is_In:   v100}', "");
    Expect(1, 983040, '\P{^Is_In:   v100}', "");
    Expect(0, 983037, '\p{Is_In:   v100}', "");
    Expect(1, 983037, '\p{^Is_In:   v100}', "");
    Expect(1, 983037, '\P{Is_In:   v100}', "");
    Expect(0, 983037, '\P{^Is_In:   v100}', "");
    Expect(1, 983040, '\p{Is_In=		V10_0}', "");
    Expect(0, 983040, '\p{^Is_In=		V10_0}', "");
    Expect(0, 983040, '\P{Is_In=		V10_0}', "");
    Expect(1, 983040, '\P{^Is_In=		V10_0}', "");
    Expect(0, 983037, '\p{Is_In=		V10_0}', "");
    Expect(1, 983037, '\p{^Is_In=		V10_0}', "");
    Expect(1, 983037, '\P{Is_In=		V10_0}', "");
    Expect(0, 983037, '\P{^Is_In=		V10_0}', "");
    Error('\p{Present_In=_-000000002.0:=}');
    Error('\P{Present_In=_-000000002.0:=}');
    Expect(1, 983040, '\p{Present_In=000000002.0}', "");
    Expect(0, 983040, '\p{^Present_In=000000002.0}', "");
    Expect(0, 983040, '\P{Present_In=000000002.0}', "");
    Expect(1, 983040, '\P{^Present_In=000000002.0}', "");
    Expect(0, 983037, '\p{Present_In=000000002.0}', "");
    Expect(1, 983037, '\p{^Present_In=000000002.0}', "");
    Expect(1, 983037, '\P{Present_In=000000002.0}', "");
    Expect(0, 983037, '\P{^Present_In=000000002.0}', "");
    Error('\p{In=:= V2_0}');
    Error('\P{In=:= V2_0}');
    Expect(1, 983040, '\p{In=v20}', "");
    Expect(0, 983040, '\p{^In=v20}', "");
    Expect(0, 983040, '\P{In=v20}', "");
    Expect(1, 983040, '\P{^In=v20}', "");
    Expect(0, 983037, '\p{In=v20}', "");
    Expect(1, 983037, '\p{^In=v20}', "");
    Expect(1, 983037, '\P{In=v20}', "");
    Expect(0, 983037, '\P{^In=v20}', "");
    Expect(1, 983040, '\p{In=--v2_0}', "");
    Expect(0, 983040, '\p{^In=--v2_0}', "");
    Expect(0, 983040, '\P{In=--v2_0}', "");
    Expect(1, 983040, '\P{^In=--v2_0}', "");
    Expect(0, 983037, '\p{In=--v2_0}', "");
    Expect(1, 983037, '\p{^In=--v2_0}', "");
    Expect(1, 983037, '\P{In=--v2_0}', "");
    Expect(0, 983037, '\P{^In=--v2_0}', "");
    Error('\p{Is_Present_In=-	00_2.0/a/}');
    Error('\P{Is_Present_In=-	00_2.0/a/}');
    Expect(1, 983040, '\p{Is_Present_In=0002.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=0002.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=0002.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=0002.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=0002.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=0002.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=0002.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=0002.0}', "");
    Error('\p{Is_In=:=v2_0}');
    Error('\P{Is_In=:=v2_0}');
    Expect(1, 983040, '\p{Is_In=v20}', "");
    Expect(0, 983040, '\p{^Is_In=v20}', "");
    Expect(0, 983040, '\P{Is_In=v20}', "");
    Expect(1, 983040, '\P{^Is_In=v20}', "");
    Expect(0, 983037, '\p{Is_In=v20}', "");
    Expect(1, 983037, '\p{^Is_In=v20}', "");
    Expect(1, 983037, '\P{Is_In=v20}', "");
    Expect(0, 983037, '\P{^Is_In=v20}', "");
    Expect(1, 983040, '\p{Is_In=_V2_0}', "");
    Expect(0, 983040, '\p{^Is_In=_V2_0}', "");
    Expect(0, 983040, '\P{Is_In=_V2_0}', "");
    Expect(1, 983040, '\P{^Is_In=_V2_0}', "");
    Expect(0, 983037, '\p{Is_In=_V2_0}', "");
    Expect(1, 983037, '\p{^Is_In=_V2_0}', "");
    Expect(1, 983037, '\P{Is_In=_V2_0}', "");
    Expect(0, 983037, '\P{^Is_In=_V2_0}', "");
    Error('\p{Present_In=:= -00_00_00_00_02.1}');
    Error('\P{Present_In=:= -00_00_00_00_02.1}');
    Expect(1, 983040, '\p{Present_In=+000_000_2.1}', "");
    Expect(0, 983040, '\p{^Present_In=+000_000_2.1}', "");
    Expect(0, 983040, '\P{Present_In=+000_000_2.1}', "");
    Expect(1, 983040, '\P{^Present_In=+000_000_2.1}', "");
    Expect(0, 983037, '\p{Present_In=+000_000_2.1}', "");
    Expect(1, 983037, '\p{^Present_In=+000_000_2.1}', "");
    Expect(1, 983037, '\P{Present_In=+000_000_2.1}', "");
    Expect(0, 983037, '\P{^Present_In=+000_000_2.1}', "");
    Error('\p{In=/a/ V2_1}');
    Error('\P{In=/a/ V2_1}');
    Expect(1, 983040, '\p{In=v21}', "");
    Expect(0, 983040, '\p{^In=v21}', "");
    Expect(0, 983040, '\P{In=v21}', "");
    Expect(1, 983040, '\P{^In=v21}', "");
    Expect(0, 983037, '\p{In=v21}', "");
    Expect(1, 983037, '\p{^In=v21}', "");
    Expect(1, 983037, '\P{In=v21}', "");
    Expect(0, 983037, '\P{^In=v21}', "");
    Expect(1, 983040, '\p{In=	V2_1}', "");
    Expect(0, 983040, '\p{^In=	V2_1}', "");
    Expect(0, 983040, '\P{In=	V2_1}', "");
    Expect(1, 983040, '\P{^In=	V2_1}', "");
    Expect(0, 983037, '\p{In=	V2_1}', "");
    Expect(1, 983037, '\p{^In=	V2_1}', "");
    Expect(1, 983037, '\P{In=	V2_1}', "");
    Expect(0, 983037, '\P{^In=	V2_1}', "");
    Error('\p{Is_Present_In=:=		0000000002.1}');
    Error('\P{Is_Present_In=:=		0000000002.1}');
    Expect(1, 983040, '\p{Is_Present_In=2.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=2.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=2.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=2.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=2.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=2.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=2.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=2.1}', "");
    Error('\p{Is_In= :=V2_1}');
    Error('\P{Is_In= :=V2_1}');
    Expect(1, 983040, '\p{Is_In=v21}', "");
    Expect(0, 983040, '\p{^Is_In=v21}', "");
    Expect(0, 983040, '\P{Is_In=v21}', "");
    Expect(1, 983040, '\P{^Is_In=v21}', "");
    Expect(0, 983037, '\p{Is_In=v21}', "");
    Expect(1, 983037, '\p{^Is_In=v21}', "");
    Expect(1, 983037, '\P{Is_In=v21}', "");
    Expect(0, 983037, '\P{^Is_In=v21}', "");
    Expect(1, 983040, '\p{Is_In=V2_1}', "");
    Expect(0, 983040, '\p{^Is_In=V2_1}', "");
    Expect(0, 983040, '\P{Is_In=V2_1}', "");
    Expect(1, 983040, '\P{^Is_In=V2_1}', "");
    Expect(0, 983037, '\p{Is_In=V2_1}', "");
    Expect(1, 983037, '\p{^Is_In=V2_1}', "");
    Expect(1, 983037, '\P{Is_In=V2_1}', "");
    Expect(0, 983037, '\P{^Is_In=V2_1}', "");
    Error('\p{Present_In:	/a/	-+000000003.0}');
    Error('\P{Present_In:	/a/	-+000000003.0}');
    Expect(1, 983040, '\p{Present_In=+0_3.0}', "");
    Expect(0, 983040, '\p{^Present_In=+0_3.0}', "");
    Expect(0, 983040, '\P{Present_In=+0_3.0}', "");
    Expect(1, 983040, '\P{^Present_In=+0_3.0}', "");
    Expect(0, 983037, '\p{Present_In=+0_3.0}', "");
    Expect(1, 983037, '\p{^Present_In=+0_3.0}', "");
    Expect(1, 983037, '\P{Present_In=+0_3.0}', "");
    Expect(0, 983037, '\P{^Present_In=+0_3.0}', "");
    Error('\p{In=-/a/v3_0}');
    Error('\P{In=-/a/v3_0}');
    Expect(1, 983040, '\p{In=v30}', "");
    Expect(0, 983040, '\p{^In=v30}', "");
    Expect(0, 983040, '\P{In=v30}', "");
    Expect(1, 983040, '\P{^In=v30}', "");
    Expect(0, 983037, '\p{In=v30}', "");
    Expect(1, 983037, '\p{^In=v30}', "");
    Expect(1, 983037, '\P{In=v30}', "");
    Expect(0, 983037, '\P{^In=v30}', "");
    Expect(1, 983040, '\p{In:--V3_0}', "");
    Expect(0, 983040, '\p{^In:--V3_0}', "");
    Expect(0, 983040, '\P{In:--V3_0}', "");
    Expect(1, 983040, '\P{^In:--V3_0}', "");
    Expect(0, 983037, '\p{In:--V3_0}', "");
    Expect(1, 983037, '\p{^In:--V3_0}', "");
    Expect(1, 983037, '\P{In:--V3_0}', "");
    Expect(0, 983037, '\P{^In:--V3_0}', "");
    Error('\p{Is_Present_In::=_	0000_3.0}');
    Error('\P{Is_Present_In::=_	0000_3.0}');
    Expect(1, 983040, '\p{Is_Present_In=000000003.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=000000003.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=000000003.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=000000003.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=000000003.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=000000003.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=000000003.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=000000003.0}', "");
    Error('\p{Is_In=-/a/V3_0}');
    Error('\P{Is_In=-/a/V3_0}');
    Expect(1, 983040, '\p{Is_In=v30}', "");
    Expect(0, 983040, '\p{^Is_In=v30}', "");
    Expect(0, 983040, '\P{Is_In=v30}', "");
    Expect(1, 983040, '\P{^Is_In=v30}', "");
    Expect(0, 983037, '\p{Is_In=v30}', "");
    Expect(1, 983037, '\p{^Is_In=v30}', "");
    Expect(1, 983037, '\P{Is_In=v30}', "");
    Expect(0, 983037, '\P{^Is_In=v30}', "");
    Expect(1, 983040, '\p{Is_In:   _ v3_0}', "");
    Expect(0, 983040, '\p{^Is_In:   _ v3_0}', "");
    Expect(0, 983040, '\P{Is_In:   _ v3_0}', "");
    Expect(1, 983040, '\P{^Is_In:   _ v3_0}', "");
    Expect(0, 983037, '\p{Is_In:   _ v3_0}', "");
    Expect(1, 983037, '\p{^Is_In:   _ v3_0}', "");
    Expect(1, 983037, '\P{Is_In:   _ v3_0}', "");
    Expect(0, 983037, '\P{^Is_In:   _ v3_0}', "");
    Error('\p{Present_In=:=-_+000000003.1}');
    Error('\P{Present_In=:=-_+000000003.1}');
    Expect(1, 983040, '\p{Present_In=+003.1}', "");
    Expect(0, 983040, '\p{^Present_In=+003.1}', "");
    Expect(0, 983040, '\P{Present_In=+003.1}', "");
    Expect(1, 983040, '\P{^Present_In=+003.1}', "");
    Expect(0, 983037, '\p{Present_In=+003.1}', "");
    Expect(1, 983037, '\p{^Present_In=+003.1}', "");
    Expect(1, 983037, '\P{Present_In=+003.1}', "");
    Expect(0, 983037, '\P{^Present_In=+003.1}', "");
    Error('\p{In:    :=V3_1}');
    Error('\P{In:    :=V3_1}');
    Expect(1, 983040, '\p{In=v31}', "");
    Expect(0, 983040, '\p{^In=v31}', "");
    Expect(0, 983040, '\P{In=v31}', "");
    Expect(1, 983040, '\P{^In=v31}', "");
    Expect(0, 983037, '\p{In=v31}', "");
    Expect(1, 983037, '\p{^In=v31}', "");
    Expect(1, 983037, '\P{In=v31}', "");
    Expect(0, 983037, '\P{^In=v31}', "");
    Expect(1, 983040, '\p{In=_-V3_1}', "");
    Expect(0, 983040, '\p{^In=_-V3_1}', "");
    Expect(0, 983040, '\P{In=_-V3_1}', "");
    Expect(1, 983040, '\P{^In=_-V3_1}', "");
    Expect(0, 983037, '\p{In=_-V3_1}', "");
    Expect(1, 983037, '\p{^In=_-V3_1}', "");
    Expect(1, 983037, '\P{In=_-V3_1}', "");
    Expect(0, 983037, '\P{^In=_-V3_1}', "");
    Error('\p{Is_Present_In=:=-0_0_0_0_0_0_0_03.1}');
    Error('\P{Is_Present_In=:=-0_0_0_0_0_0_0_03.1}');
    Expect(1, 983040, '\p{Is_Present_In:	00_3.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In:	00_3.1}', "");
    Expect(0, 983040, '\P{Is_Present_In:	00_3.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In:	00_3.1}', "");
    Expect(0, 983037, '\p{Is_Present_In:	00_3.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In:	00_3.1}', "");
    Expect(1, 983037, '\P{Is_Present_In:	00_3.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In:	00_3.1}', "");
    Error('\p{Is_In:		/a/v3_1}');
    Error('\P{Is_In:		/a/v3_1}');
    Expect(1, 983040, '\p{Is_In=v31}', "");
    Expect(0, 983040, '\p{^Is_In=v31}', "");
    Expect(0, 983040, '\P{Is_In=v31}', "");
    Expect(1, 983040, '\P{^Is_In=v31}', "");
    Expect(0, 983037, '\p{Is_In=v31}', "");
    Expect(1, 983037, '\p{^Is_In=v31}', "");
    Expect(1, 983037, '\P{Is_In=v31}', "");
    Expect(0, 983037, '\P{^Is_In=v31}', "");
    Expect(1, 983040, '\p{Is_In=- V3_1}', "");
    Expect(0, 983040, '\p{^Is_In=- V3_1}', "");
    Expect(0, 983040, '\P{Is_In=- V3_1}', "");
    Expect(1, 983040, '\P{^Is_In=- V3_1}', "");
    Expect(0, 983037, '\p{Is_In=- V3_1}', "");
    Expect(1, 983037, '\p{^Is_In=- V3_1}', "");
    Expect(1, 983037, '\P{Is_In=- V3_1}', "");
    Expect(0, 983037, '\P{^Is_In=- V3_1}', "");
    Error('\p{Present_In=_+0003.2:=}');
    Error('\P{Present_In=_+0003.2:=}');
    Expect(1, 983040, '\p{Present_In=3.2}', "");
    Expect(0, 983040, '\p{^Present_In=3.2}', "");
    Expect(0, 983040, '\P{Present_In=3.2}', "");
    Expect(1, 983040, '\P{^Present_In=3.2}', "");
    Expect(0, 983037, '\p{Present_In=3.2}', "");
    Expect(1, 983037, '\p{^Present_In=3.2}', "");
    Expect(1, 983037, '\P{Present_In=3.2}', "");
    Expect(0, 983037, '\P{^Present_In=3.2}', "");
    Error('\p{In=- v3_2:=}');
    Error('\P{In=- v3_2:=}');
    Expect(1, 983040, '\p{In=v32}', "");
    Expect(0, 983040, '\p{^In=v32}', "");
    Expect(0, 983040, '\P{In=v32}', "");
    Expect(1, 983040, '\P{^In=v32}', "");
    Expect(0, 983037, '\p{In=v32}', "");
    Expect(1, 983037, '\p{^In=v32}', "");
    Expect(1, 983037, '\P{In=v32}', "");
    Expect(0, 983037, '\P{^In=v32}', "");
    Expect(1, 983040, '\p{In=-V3_2}', "");
    Expect(0, 983040, '\p{^In=-V3_2}', "");
    Expect(0, 983040, '\P{In=-V3_2}', "");
    Expect(1, 983040, '\P{^In=-V3_2}', "");
    Expect(0, 983037, '\p{In=-V3_2}', "");
    Expect(1, 983037, '\p{^In=-V3_2}', "");
    Expect(1, 983037, '\P{In=-V3_2}', "");
    Expect(0, 983037, '\P{^In=-V3_2}', "");
    Error('\p{Is_Present_In=/a/  +0_0_0_0_03.2}');
    Error('\P{Is_Present_In=/a/  +0_0_0_0_03.2}');
    Expect(1, 983040, '\p{Is_Present_In=000003.2}', "");
    Expect(0, 983040, '\p{^Is_Present_In=000003.2}', "");
    Expect(0, 983040, '\P{Is_Present_In=000003.2}', "");
    Expect(1, 983040, '\P{^Is_Present_In=000003.2}', "");
    Expect(0, 983037, '\p{Is_Present_In=000003.2}', "");
    Expect(1, 983037, '\p{^Is_Present_In=000003.2}', "");
    Expect(1, 983037, '\P{Is_Present_In=000003.2}', "");
    Expect(0, 983037, '\P{^Is_Present_In=000003.2}', "");
    Error('\p{Is_In=-:=V3_2}');
    Error('\P{Is_In=-:=V3_2}');
    Expect(1, 983040, '\p{Is_In=v32}', "");
    Expect(0, 983040, '\p{^Is_In=v32}', "");
    Expect(0, 983040, '\P{Is_In=v32}', "");
    Expect(1, 983040, '\P{^Is_In=v32}', "");
    Expect(0, 983037, '\p{Is_In=v32}', "");
    Expect(1, 983037, '\p{^Is_In=v32}', "");
    Expect(1, 983037, '\P{Is_In=v32}', "");
    Expect(0, 983037, '\P{^Is_In=v32}', "");
    Expect(1, 983040, '\p{Is_In= v3_2}', "");
    Expect(0, 983040, '\p{^Is_In= v3_2}', "");
    Expect(0, 983040, '\P{Is_In= v3_2}', "");
    Expect(1, 983040, '\P{^Is_In= v3_2}', "");
    Expect(0, 983037, '\p{Is_In= v3_2}', "");
    Expect(1, 983037, '\p{^Is_In= v3_2}', "");
    Expect(1, 983037, '\P{Is_In= v3_2}', "");
    Expect(0, 983037, '\P{^Is_In= v3_2}', "");
    Error('\p{Present_In=/a/-	00000004.0}');
    Error('\P{Present_In=/a/-	00000004.0}');
    Expect(1, 983040, '\p{Present_In=+000000004.0}', "");
    Expect(0, 983040, '\p{^Present_In=+000000004.0}', "");
    Expect(0, 983040, '\P{Present_In=+000000004.0}', "");
    Expect(1, 983040, '\P{^Present_In=+000000004.0}', "");
    Expect(0, 983037, '\p{Present_In=+000000004.0}', "");
    Expect(1, 983037, '\p{^Present_In=+000000004.0}', "");
    Expect(1, 983037, '\P{Present_In=+000000004.0}', "");
    Expect(0, 983037, '\P{^Present_In=+000000004.0}', "");
    Error('\p{In=/a/- v4_0}');
    Error('\P{In=/a/- v4_0}');
    Expect(1, 983040, '\p{In=v40}', "");
    Expect(0, 983040, '\p{^In=v40}', "");
    Expect(0, 983040, '\P{In=v40}', "");
    Expect(1, 983040, '\P{^In=v40}', "");
    Expect(0, 983037, '\p{In=v40}', "");
    Expect(1, 983037, '\p{^In=v40}', "");
    Expect(1, 983037, '\P{In=v40}', "");
    Expect(0, 983037, '\P{^In=v40}', "");
    Expect(1, 983040, '\p{In=_-V4_0}', "");
    Expect(0, 983040, '\p{^In=_-V4_0}', "");
    Expect(0, 983040, '\P{In=_-V4_0}', "");
    Expect(1, 983040, '\P{^In=_-V4_0}', "");
    Expect(0, 983037, '\p{In=_-V4_0}', "");
    Expect(1, 983037, '\p{^In=_-V4_0}', "");
    Expect(1, 983037, '\P{In=_-V4_0}', "");
    Expect(0, 983037, '\P{^In=_-V4_0}', "");
    Error('\p{Is_Present_In= -00004.0/a/}');
    Error('\P{Is_Present_In= -00004.0/a/}');
    Expect(1, 983040, '\p{Is_Present_In=+00_00_00_04.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+00_00_00_04.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=+00_00_00_04.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+00_00_00_04.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=+00_00_00_04.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+00_00_00_04.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=+00_00_00_04.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+00_00_00_04.0}', "");
    Error('\p{Is_In=-:=V4_0}');
    Error('\P{Is_In=-:=V4_0}');
    Expect(1, 983040, '\p{Is_In=v40}', "");
    Expect(0, 983040, '\p{^Is_In=v40}', "");
    Expect(0, 983040, '\P{Is_In=v40}', "");
    Expect(1, 983040, '\P{^Is_In=v40}', "");
    Expect(0, 983037, '\p{Is_In=v40}', "");
    Expect(1, 983037, '\p{^Is_In=v40}', "");
    Expect(1, 983037, '\P{Is_In=v40}', "");
    Expect(0, 983037, '\P{^Is_In=v40}', "");
    Expect(1, 983040, '\p{Is_In= V4_0}', "");
    Expect(0, 983040, '\p{^Is_In= V4_0}', "");
    Expect(0, 983040, '\P{Is_In= V4_0}', "");
    Expect(1, 983040, '\P{^Is_In= V4_0}', "");
    Expect(0, 983037, '\p{Is_In= V4_0}', "");
    Expect(1, 983037, '\p{^Is_In= V4_0}', "");
    Expect(1, 983037, '\P{Is_In= V4_0}', "");
    Expect(0, 983037, '\P{^Is_In= V4_0}', "");
    Error('\p{Present_In=__00004.1:=}');
    Error('\P{Present_In=__00004.1:=}');
    Expect(1, 983040, '\p{Present_In:   000000000_4.1}', "");
    Expect(0, 983040, '\p{^Present_In:   000000000_4.1}', "");
    Expect(0, 983040, '\P{Present_In:   000000000_4.1}', "");
    Expect(1, 983040, '\P{^Present_In:   000000000_4.1}', "");
    Expect(0, 983037, '\p{Present_In:   000000000_4.1}', "");
    Expect(1, 983037, '\p{^Present_In:   000000000_4.1}', "");
    Expect(1, 983037, '\P{Present_In:   000000000_4.1}', "");
    Expect(0, 983037, '\P{^Present_In:   000000000_4.1}', "");
    Error('\p{In=/a/-_V4_1}');
    Error('\P{In=/a/-_V4_1}');
    Expect(1, 983040, '\p{In=v41}', "");
    Expect(0, 983040, '\p{^In=v41}', "");
    Expect(0, 983040, '\P{In=v41}', "");
    Expect(1, 983040, '\P{^In=v41}', "");
    Expect(0, 983037, '\p{In=v41}', "");
    Expect(1, 983037, '\p{^In=v41}', "");
    Expect(1, 983037, '\P{In=v41}', "");
    Expect(0, 983037, '\P{^In=v41}', "");
    Expect(1, 983040, '\p{In=_-v4_1}', "");
    Expect(0, 983040, '\p{^In=_-v4_1}', "");
    Expect(0, 983040, '\P{In=_-v4_1}', "");
    Expect(1, 983040, '\P{^In=_-v4_1}', "");
    Expect(0, 983037, '\p{In=_-v4_1}', "");
    Expect(1, 983037, '\p{^In=_-v4_1}', "");
    Expect(1, 983037, '\P{In=_-v4_1}', "");
    Expect(0, 983037, '\P{^In=_-v4_1}', "");
    Error('\p{Is_Present_In=-/a/000004.1}');
    Error('\P{Is_Present_In=-/a/000004.1}');
    Expect(1, 983040, '\p{Is_Present_In=+0_0_0_0_0004.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+0_0_0_0_0004.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=+0_0_0_0_0004.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+0_0_0_0_0004.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=+0_0_0_0_0004.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+0_0_0_0_0004.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=+0_0_0_0_0004.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+0_0_0_0_0004.1}', "");
    Error('\p{Is_In=v4_1:=}');
    Error('\P{Is_In=v4_1:=}');
    Expect(1, 983040, '\p{Is_In=v41}', "");
    Expect(0, 983040, '\p{^Is_In=v41}', "");
    Expect(0, 983040, '\P{Is_In=v41}', "");
    Expect(1, 983040, '\P{^Is_In=v41}', "");
    Expect(0, 983037, '\p{Is_In=v41}', "");
    Expect(1, 983037, '\p{^Is_In=v41}', "");
    Expect(1, 983037, '\P{Is_In=v41}', "");
    Expect(0, 983037, '\P{^Is_In=v41}', "");
    Expect(1, 983040, '\p{Is_In=	V4_1}', "");
    Expect(0, 983040, '\p{^Is_In=	V4_1}', "");
    Expect(0, 983040, '\P{Is_In=	V4_1}', "");
    Expect(1, 983040, '\P{^Is_In=	V4_1}', "");
    Expect(0, 983037, '\p{Is_In=	V4_1}', "");
    Expect(1, 983037, '\p{^Is_In=	V4_1}', "");
    Expect(1, 983037, '\P{Is_In=	V4_1}', "");
    Expect(0, 983037, '\P{^Is_In=	V4_1}', "");
    Error('\p{Present_In= _0000_0000_05.0/a/}');
    Error('\P{Present_In= _0000_0000_05.0/a/}');
    Expect(1, 983040, '\p{Present_In=00000_5.0}', "");
    Expect(0, 983040, '\p{^Present_In=00000_5.0}', "");
    Expect(0, 983040, '\P{Present_In=00000_5.0}', "");
    Expect(1, 983040, '\P{^Present_In=00000_5.0}', "");
    Expect(0, 983037, '\p{Present_In=00000_5.0}', "");
    Expect(1, 983037, '\p{^Present_In=00000_5.0}', "");
    Expect(1, 983037, '\P{Present_In=00000_5.0}', "");
    Expect(0, 983037, '\P{^Present_In=00000_5.0}', "");
    Error('\p{In= V5_0/a/}');
    Error('\P{In= V5_0/a/}');
    Expect(1, 983040, '\p{In:v50}', "");
    Expect(0, 983040, '\p{^In:v50}', "");
    Expect(0, 983040, '\P{In:v50}', "");
    Expect(1, 983040, '\P{^In:v50}', "");
    Expect(0, 983037, '\p{In:v50}', "");
    Expect(1, 983037, '\p{^In:v50}', "");
    Expect(1, 983037, '\P{In:v50}', "");
    Expect(0, 983037, '\P{^In:v50}', "");
    Expect(1, 983040, '\p{In=_-v5_0}', "");
    Expect(0, 983040, '\p{^In=_-v5_0}', "");
    Expect(0, 983040, '\P{In=_-v5_0}', "");
    Expect(1, 983040, '\P{^In=_-v5_0}', "");
    Expect(0, 983037, '\p{In=_-v5_0}', "");
    Expect(1, 983037, '\p{^In=_-v5_0}', "");
    Expect(1, 983037, '\P{In=_-v5_0}', "");
    Expect(0, 983037, '\P{^In=_-v5_0}', "");
    Error('\p{Is_Present_In=_/a/00_5.0}');
    Error('\P{Is_Present_In=_/a/00_5.0}');
    Expect(1, 983040, '\p{Is_Present_In=+0_0_0_0_0_005.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+0_0_0_0_0_005.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=+0_0_0_0_0_005.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+0_0_0_0_0_005.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=+0_0_0_0_0_005.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+0_0_0_0_0_005.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=+0_0_0_0_0_005.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+0_0_0_0_0_005.0}', "");
    Error('\p{Is_In=:= _v5_0}');
    Error('\P{Is_In=:= _v5_0}');
    Expect(1, 983040, '\p{Is_In=v50}', "");
    Expect(0, 983040, '\p{^Is_In=v50}', "");
    Expect(0, 983040, '\P{Is_In=v50}', "");
    Expect(1, 983040, '\P{^Is_In=v50}', "");
    Expect(0, 983037, '\p{Is_In=v50}', "");
    Expect(1, 983037, '\p{^Is_In=v50}', "");
    Expect(1, 983037, '\P{Is_In=v50}', "");
    Expect(0, 983037, '\P{^Is_In=v50}', "");
    Expect(1, 983040, '\p{Is_In=_V5_0}', "");
    Expect(0, 983040, '\p{^Is_In=_V5_0}', "");
    Expect(0, 983040, '\P{Is_In=_V5_0}', "");
    Expect(1, 983040, '\P{^Is_In=_V5_0}', "");
    Expect(0, 983037, '\p{Is_In=_V5_0}', "");
    Expect(1, 983037, '\p{^Is_In=_V5_0}', "");
    Expect(1, 983037, '\P{Is_In=_V5_0}', "");
    Expect(0, 983037, '\P{^Is_In=_V5_0}', "");
    Error('\p{Present_In= :=000_000_5.1}');
    Error('\P{Present_In= :=000_000_5.1}');
    Expect(1, 983040, '\p{Present_In=+00000_5.1}', "");
    Expect(0, 983040, '\p{^Present_In=+00000_5.1}', "");
    Expect(0, 983040, '\P{Present_In=+00000_5.1}', "");
    Expect(1, 983040, '\P{^Present_In=+00000_5.1}', "");
    Expect(0, 983037, '\p{Present_In=+00000_5.1}', "");
    Expect(1, 983037, '\p{^Present_In=+00000_5.1}', "");
    Expect(1, 983037, '\P{Present_In=+00000_5.1}', "");
    Expect(0, 983037, '\P{^Present_In=+00000_5.1}', "");
    Error('\p{In:   := -V5_1}');
    Error('\P{In:   := -V5_1}');
    Expect(1, 983040, '\p{In=v51}', "");
    Expect(0, 983040, '\p{^In=v51}', "");
    Expect(0, 983040, '\P{In=v51}', "");
    Expect(1, 983040, '\P{^In=v51}', "");
    Expect(0, 983037, '\p{In=v51}', "");
    Expect(1, 983037, '\p{^In=v51}', "");
    Expect(1, 983037, '\P{In=v51}', "");
    Expect(0, 983037, '\P{^In=v51}', "");
    Expect(1, 983040, '\p{In:   V5_1}', "");
    Expect(0, 983040, '\p{^In:   V5_1}', "");
    Expect(0, 983040, '\P{In:   V5_1}', "");
    Expect(1, 983040, '\P{^In:   V5_1}', "");
    Expect(0, 983037, '\p{In:   V5_1}', "");
    Expect(1, 983037, '\p{^In:   V5_1}', "");
    Expect(1, 983037, '\P{In:   V5_1}', "");
    Expect(0, 983037, '\P{^In:   V5_1}', "");
    Error('\p{Is_Present_In=  0000000005.1/a/}');
    Error('\P{Is_Present_In=  0000000005.1/a/}');
    Expect(1, 983040, '\p{Is_Present_In=0005.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=0005.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=0005.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=0005.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=0005.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=0005.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=0005.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=0005.1}', "");
    Error('\p{Is_In=_/a/V5_1}');
    Error('\P{Is_In=_/a/V5_1}');
    Expect(1, 983040, '\p{Is_In=v51}', "");
    Expect(0, 983040, '\p{^Is_In=v51}', "");
    Expect(0, 983040, '\P{Is_In=v51}', "");
    Expect(1, 983040, '\P{^Is_In=v51}', "");
    Expect(0, 983037, '\p{Is_In=v51}', "");
    Expect(1, 983037, '\p{^Is_In=v51}', "");
    Expect(1, 983037, '\P{Is_In=v51}', "");
    Expect(0, 983037, '\P{^Is_In=v51}', "");
    Expect(1, 983040, '\p{Is_In=__V5_1}', "");
    Expect(0, 983040, '\p{^Is_In=__V5_1}', "");
    Expect(0, 983040, '\P{Is_In=__V5_1}', "");
    Expect(1, 983040, '\P{^Is_In=__V5_1}', "");
    Expect(0, 983037, '\p{Is_In=__V5_1}', "");
    Expect(1, 983037, '\p{^Is_In=__V5_1}', "");
    Expect(1, 983037, '\P{Is_In=__V5_1}', "");
    Expect(0, 983037, '\P{^Is_In=__V5_1}', "");
    Error('\p{Present_In=/a/	+000000000_5.2}');
    Error('\P{Present_In=/a/	+000000000_5.2}');
    Expect(1, 983040, '\p{Present_In:   005.2}', "");
    Expect(0, 983040, '\p{^Present_In:   005.2}', "");
    Expect(0, 983040, '\P{Present_In:   005.2}', "");
    Expect(1, 983040, '\P{^Present_In:   005.2}', "");
    Expect(0, 983037, '\p{Present_In:   005.2}', "");
    Expect(1, 983037, '\p{^Present_In:   005.2}', "");
    Expect(1, 983037, '\P{Present_In:   005.2}', "");
    Expect(0, 983037, '\P{^Present_In:   005.2}', "");
    Error('\p{In:		v5_2:=}');
    Error('\P{In:		v5_2:=}');
    Expect(1, 983040, '\p{In=v52}', "");
    Expect(0, 983040, '\p{^In=v52}', "");
    Expect(0, 983040, '\P{In=v52}', "");
    Expect(1, 983040, '\P{^In=v52}', "");
    Expect(0, 983037, '\p{In=v52}', "");
    Expect(1, 983037, '\p{^In=v52}', "");
    Expect(1, 983037, '\P{In=v52}', "");
    Expect(0, 983037, '\P{^In=v52}', "");
    Expect(1, 983040, '\p{In=-V5_2}', "");
    Expect(0, 983040, '\p{^In=-V5_2}', "");
    Expect(0, 983040, '\P{In=-V5_2}', "");
    Expect(1, 983040, '\P{^In=-V5_2}', "");
    Expect(0, 983037, '\p{In=-V5_2}', "");
    Expect(1, 983037, '\p{^In=-V5_2}', "");
    Expect(1, 983037, '\P{In=-V5_2}', "");
    Expect(0, 983037, '\P{^In=-V5_2}', "");
    Error('\p{Is_Present_In=- 0000_5.2/a/}');
    Error('\P{Is_Present_In=- 0000_5.2/a/}');
    Expect(1, 983040, '\p{Is_Present_In:   0_5.2}', "");
    Expect(0, 983040, '\p{^Is_Present_In:   0_5.2}', "");
    Expect(0, 983040, '\P{Is_Present_In:   0_5.2}', "");
    Expect(1, 983040, '\P{^Is_Present_In:   0_5.2}', "");
    Expect(0, 983037, '\p{Is_Present_In:   0_5.2}', "");
    Expect(1, 983037, '\p{^Is_Present_In:   0_5.2}', "");
    Expect(1, 983037, '\P{Is_Present_In:   0_5.2}', "");
    Expect(0, 983037, '\P{^Is_Present_In:   0_5.2}', "");
    Error('\p{Is_In=/a/	 v5_2}');
    Error('\P{Is_In=/a/	 v5_2}');
    Expect(1, 983040, '\p{Is_In: v52}', "");
    Expect(0, 983040, '\p{^Is_In: v52}', "");
    Expect(0, 983040, '\P{Is_In: v52}', "");
    Expect(1, 983040, '\P{^Is_In: v52}', "");
    Expect(0, 983037, '\p{Is_In: v52}', "");
    Expect(1, 983037, '\p{^Is_In: v52}', "");
    Expect(1, 983037, '\P{Is_In: v52}', "");
    Expect(0, 983037, '\P{^Is_In: v52}', "");
    Expect(1, 983040, '\p{Is_In= -V5_2}', "");
    Expect(0, 983040, '\p{^Is_In= -V5_2}', "");
    Expect(0, 983040, '\P{Is_In= -V5_2}', "");
    Expect(1, 983040, '\P{^Is_In= -V5_2}', "");
    Expect(0, 983037, '\p{Is_In= -V5_2}', "");
    Expect(1, 983037, '\p{^Is_In= -V5_2}', "");
    Expect(1, 983037, '\P{Is_In= -V5_2}', "");
    Expect(0, 983037, '\P{^Is_In= -V5_2}', "");
    Error('\p{Present_In=:=	-+0_6.0}');
    Error('\P{Present_In=:=	-+0_6.0}');
    Expect(1, 983040, '\p{Present_In=000006.0}', "");
    Expect(0, 983040, '\p{^Present_In=000006.0}', "");
    Expect(0, 983040, '\P{Present_In=000006.0}', "");
    Expect(1, 983040, '\P{^Present_In=000006.0}', "");
    Expect(0, 983037, '\p{Present_In=000006.0}', "");
    Expect(1, 983037, '\p{^Present_In=000006.0}', "");
    Expect(1, 983037, '\P{Present_In=000006.0}', "");
    Expect(0, 983037, '\P{^Present_In=000006.0}', "");
    Error('\p{In=:=-v6_0}');
    Error('\P{In=:=-v6_0}');
    Expect(1, 983040, '\p{In=v60}', "");
    Expect(0, 983040, '\p{^In=v60}', "");
    Expect(0, 983040, '\P{In=v60}', "");
    Expect(1, 983040, '\P{^In=v60}', "");
    Expect(0, 983037, '\p{In=v60}', "");
    Expect(1, 983037, '\p{^In=v60}', "");
    Expect(1, 983037, '\P{In=v60}', "");
    Expect(0, 983037, '\P{^In=v60}', "");
    Expect(1, 983040, '\p{In=-_V6_0}', "");
    Expect(0, 983040, '\p{^In=-_V6_0}', "");
    Expect(0, 983040, '\P{In=-_V6_0}', "");
    Expect(1, 983040, '\P{^In=-_V6_0}', "");
    Expect(0, 983037, '\p{In=-_V6_0}', "");
    Expect(1, 983037, '\p{^In=-_V6_0}', "");
    Expect(1, 983037, '\P{In=-_V6_0}', "");
    Expect(0, 983037, '\P{^In=-_V6_0}', "");
    Error('\p{Is_Present_In:   	/a/000006.0}');
    Error('\P{Is_Present_In:   	/a/000006.0}');
    Expect(1, 983040, '\p{Is_Present_In=00000006.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=00000006.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=00000006.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=00000006.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=00000006.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=00000006.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=00000006.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=00000006.0}', "");
    Error('\p{Is_In=_V6_0/a/}');
    Error('\P{Is_In=_V6_0/a/}');
    Expect(1, 983040, '\p{Is_In=v60}', "");
    Expect(0, 983040, '\p{^Is_In=v60}', "");
    Expect(0, 983040, '\P{Is_In=v60}', "");
    Expect(1, 983040, '\P{^Is_In=v60}', "");
    Expect(0, 983037, '\p{Is_In=v60}', "");
    Expect(1, 983037, '\p{^Is_In=v60}', "");
    Expect(1, 983037, '\P{Is_In=v60}', "");
    Expect(0, 983037, '\P{^Is_In=v60}', "");
    Expect(1, 983040, '\p{Is_In=- V6_0}', "");
    Expect(0, 983040, '\p{^Is_In=- V6_0}', "");
    Expect(0, 983040, '\P{Is_In=- V6_0}', "");
    Expect(1, 983040, '\P{^Is_In=- V6_0}', "");
    Expect(0, 983037, '\p{Is_In=- V6_0}', "");
    Expect(1, 983037, '\p{^Is_In=- V6_0}', "");
    Expect(1, 983037, '\P{Is_In=- V6_0}', "");
    Expect(0, 983037, '\P{^Is_In=- V6_0}', "");
    Error('\p{Present_In=/a/00_6.1}');
    Error('\P{Present_In=/a/00_6.1}');
    Expect(1, 983040, '\p{Present_In=6.1}', "");
    Expect(0, 983040, '\p{^Present_In=6.1}', "");
    Expect(0, 983040, '\P{Present_In=6.1}', "");
    Expect(1, 983040, '\P{^Present_In=6.1}', "");
    Expect(0, 983037, '\p{Present_In=6.1}', "");
    Expect(1, 983037, '\p{^Present_In=6.1}', "");
    Expect(1, 983037, '\P{Present_In=6.1}', "");
    Expect(0, 983037, '\P{^Present_In=6.1}', "");
    Error('\p{In=:=-_V6_1}');
    Error('\P{In=:=-_V6_1}');
    Expect(1, 983040, '\p{In=v61}', "");
    Expect(0, 983040, '\p{^In=v61}', "");
    Expect(0, 983040, '\P{In=v61}', "");
    Expect(1, 983040, '\P{^In=v61}', "");
    Expect(0, 983037, '\p{In=v61}', "");
    Expect(1, 983037, '\p{^In=v61}', "");
    Expect(1, 983037, '\P{In=v61}', "");
    Expect(0, 983037, '\P{^In=v61}', "");
    Expect(1, 983040, '\p{In= V6_1}', "");
    Expect(0, 983040, '\p{^In= V6_1}', "");
    Expect(0, 983040, '\P{In= V6_1}', "");
    Expect(1, 983040, '\P{^In= V6_1}', "");
    Expect(0, 983037, '\p{In= V6_1}', "");
    Expect(1, 983037, '\p{^In= V6_1}', "");
    Expect(1, 983037, '\P{In= V6_1}', "");
    Expect(0, 983037, '\P{^In= V6_1}', "");
    Error('\p{Is_Present_In::=_-6.1}');
    Error('\P{Is_Present_In::=_-6.1}');
    Expect(1, 983040, '\p{Is_Present_In=+0_0_0_006.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+0_0_0_006.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=+0_0_0_006.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+0_0_0_006.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=+0_0_0_006.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+0_0_0_006.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=+0_0_0_006.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+0_0_0_006.1}', "");
    Error('\p{Is_In=	/a/V6_1}');
    Error('\P{Is_In=	/a/V6_1}');
    Expect(1, 983040, '\p{Is_In=v61}', "");
    Expect(0, 983040, '\p{^Is_In=v61}', "");
    Expect(0, 983040, '\P{Is_In=v61}', "");
    Expect(1, 983040, '\P{^Is_In=v61}', "");
    Expect(0, 983037, '\p{Is_In=v61}', "");
    Expect(1, 983037, '\p{^Is_In=v61}', "");
    Expect(1, 983037, '\P{Is_In=v61}', "");
    Expect(0, 983037, '\P{^Is_In=v61}', "");
    Expect(1, 983040, '\p{Is_In= V6_1}', "");
    Expect(0, 983040, '\p{^Is_In= V6_1}', "");
    Expect(0, 983040, '\P{Is_In= V6_1}', "");
    Expect(1, 983040, '\P{^Is_In= V6_1}', "");
    Expect(0, 983037, '\p{Is_In= V6_1}', "");
    Expect(1, 983037, '\p{^Is_In= V6_1}', "");
    Expect(1, 983037, '\P{Is_In= V6_1}', "");
    Expect(0, 983037, '\P{^Is_In= V6_1}', "");
    Error('\p{Present_In=-:=+006.2}');
    Error('\P{Present_In=-:=+006.2}');
    Expect(1, 983040, '\p{Present_In=0000000006.2}', "");
    Expect(0, 983040, '\p{^Present_In=0000000006.2}', "");
    Expect(0, 983040, '\P{Present_In=0000000006.2}', "");
    Expect(1, 983040, '\P{^Present_In=0000000006.2}', "");
    Expect(0, 983037, '\p{Present_In=0000000006.2}', "");
    Expect(1, 983037, '\p{^Present_In=0000000006.2}', "");
    Expect(1, 983037, '\P{Present_In=0000000006.2}', "");
    Expect(0, 983037, '\P{^Present_In=0000000006.2}', "");
    Error('\p{In=:= _V6_2}');
    Error('\P{In=:= _V6_2}');
    Expect(1, 983040, '\p{In=v62}', "");
    Expect(0, 983040, '\p{^In=v62}', "");
    Expect(0, 983040, '\P{In=v62}', "");
    Expect(1, 983040, '\P{^In=v62}', "");
    Expect(0, 983037, '\p{In=v62}', "");
    Expect(1, 983037, '\p{^In=v62}', "");
    Expect(1, 983037, '\P{In=v62}', "");
    Expect(0, 983037, '\P{^In=v62}', "");
    Expect(1, 983040, '\p{In=_-V6_2}', "");
    Expect(0, 983040, '\p{^In=_-V6_2}', "");
    Expect(0, 983040, '\P{In=_-V6_2}', "");
    Expect(1, 983040, '\P{^In=_-V6_2}', "");
    Expect(0, 983037, '\p{In=_-V6_2}', "");
    Expect(1, 983037, '\p{^In=_-V6_2}', "");
    Expect(1, 983037, '\P{In=_-V6_2}', "");
    Expect(0, 983037, '\P{^In=_-V6_2}', "");
    Error('\p{Is_Present_In=/a/- +0006.2}');
    Error('\P{Is_Present_In=/a/- +0006.2}');
    Expect(1, 983040, '\p{Is_Present_In=0_0_0_06.2}', "");
    Expect(0, 983040, '\p{^Is_Present_In=0_0_0_06.2}', "");
    Expect(0, 983040, '\P{Is_Present_In=0_0_0_06.2}', "");
    Expect(1, 983040, '\P{^Is_Present_In=0_0_0_06.2}', "");
    Expect(0, 983037, '\p{Is_Present_In=0_0_0_06.2}', "");
    Expect(1, 983037, '\p{^Is_Present_In=0_0_0_06.2}', "");
    Expect(1, 983037, '\P{Is_Present_In=0_0_0_06.2}', "");
    Expect(0, 983037, '\P{^Is_Present_In=0_0_0_06.2}', "");
    Error('\p{Is_In=:=	-V6_2}');
    Error('\P{Is_In=:=	-V6_2}');
    Expect(1, 983040, '\p{Is_In=v62}', "");
    Expect(0, 983040, '\p{^Is_In=v62}', "");
    Expect(0, 983040, '\P{Is_In=v62}', "");
    Expect(1, 983040, '\P{^Is_In=v62}', "");
    Expect(0, 983037, '\p{Is_In=v62}', "");
    Expect(1, 983037, '\p{^Is_In=v62}', "");
    Expect(1, 983037, '\P{Is_In=v62}', "");
    Expect(0, 983037, '\P{^Is_In=v62}', "");
    Expect(1, 983040, '\p{Is_In: 	V6_2}', "");
    Expect(0, 983040, '\p{^Is_In: 	V6_2}', "");
    Expect(0, 983040, '\P{Is_In: 	V6_2}', "");
    Expect(1, 983040, '\P{^Is_In: 	V6_2}', "");
    Expect(0, 983037, '\p{Is_In: 	V6_2}', "");
    Expect(1, 983037, '\p{^Is_In: 	V6_2}', "");
    Expect(1, 983037, '\P{Is_In: 	V6_2}', "");
    Expect(0, 983037, '\P{^Is_In: 	V6_2}', "");
    Error('\p{Present_In= -00_00_00_006.3/a/}');
    Error('\P{Present_In= -00_00_00_006.3/a/}');
    Expect(1, 983040, '\p{Present_In=0_6.3}', "");
    Expect(0, 983040, '\p{^Present_In=0_6.3}', "");
    Expect(0, 983040, '\P{Present_In=0_6.3}', "");
    Expect(1, 983040, '\P{^Present_In=0_6.3}', "");
    Expect(0, 983037, '\p{Present_In=0_6.3}', "");
    Expect(1, 983037, '\p{^Present_In=0_6.3}', "");
    Expect(1, 983037, '\P{Present_In=0_6.3}', "");
    Expect(0, 983037, '\P{^Present_In=0_6.3}', "");
    Error('\p{In=/a/V6_3}');
    Error('\P{In=/a/V6_3}');
    Expect(1, 983040, '\p{In=v63}', "");
    Expect(0, 983040, '\p{^In=v63}', "");
    Expect(0, 983040, '\P{In=v63}', "");
    Expect(1, 983040, '\P{^In=v63}', "");
    Expect(0, 983037, '\p{In=v63}', "");
    Expect(1, 983037, '\p{^In=v63}', "");
    Expect(1, 983037, '\P{In=v63}', "");
    Expect(0, 983037, '\P{^In=v63}', "");
    Expect(1, 983040, '\p{In=-v6_3}', "");
    Expect(0, 983040, '\p{^In=-v6_3}', "");
    Expect(0, 983040, '\P{In=-v6_3}', "");
    Expect(1, 983040, '\P{^In=-v6_3}', "");
    Expect(0, 983037, '\p{In=-v6_3}', "");
    Expect(1, 983037, '\p{^In=-v6_3}', "");
    Expect(1, 983037, '\P{In=-v6_3}', "");
    Expect(0, 983037, '\P{^In=-v6_3}', "");
    Error('\p{Is_Present_In=	+000000006.3/a/}');
    Error('\P{Is_Present_In=	+000000006.3/a/}');
    Expect(1, 983040, '\p{Is_Present_In=0_0_0_06.3}', "");
    Expect(0, 983040, '\p{^Is_Present_In=0_0_0_06.3}', "");
    Expect(0, 983040, '\P{Is_Present_In=0_0_0_06.3}', "");
    Expect(1, 983040, '\P{^Is_Present_In=0_0_0_06.3}', "");
    Expect(0, 983037, '\p{Is_Present_In=0_0_0_06.3}', "");
    Expect(1, 983037, '\p{^Is_Present_In=0_0_0_06.3}', "");
    Expect(1, 983037, '\P{Is_Present_In=0_0_0_06.3}', "");
    Expect(0, 983037, '\P{^Is_Present_In=0_0_0_06.3}', "");
    Error('\p{Is_In= _v6_3/a/}');
    Error('\P{Is_In= _v6_3/a/}');
    Expect(1, 983040, '\p{Is_In=v63}', "");
    Expect(0, 983040, '\p{^Is_In=v63}', "");
    Expect(0, 983040, '\P{Is_In=v63}', "");
    Expect(1, 983040, '\P{^Is_In=v63}', "");
    Expect(0, 983037, '\p{Is_In=v63}', "");
    Expect(1, 983037, '\p{^Is_In=v63}', "");
    Expect(1, 983037, '\P{Is_In=v63}', "");
    Expect(0, 983037, '\P{^Is_In=v63}', "");
    Expect(1, 983040, '\p{Is_In=_V6_3}', "");
    Expect(0, 983040, '\p{^Is_In=_V6_3}', "");
    Expect(0, 983040, '\P{Is_In=_V6_3}', "");
    Expect(1, 983040, '\P{^Is_In=_V6_3}', "");
    Expect(0, 983037, '\p{Is_In=_V6_3}', "");
    Expect(1, 983037, '\p{^Is_In=_V6_3}', "");
    Expect(1, 983037, '\P{Is_In=_V6_3}', "");
    Expect(0, 983037, '\P{^Is_In=_V6_3}', "");
    Error('\p{Present_In=/a/ 00_7.0}');
    Error('\P{Present_In=/a/ 00_7.0}');
    Expect(1, 983040, '\p{Present_In=0_7.0}', "");
    Expect(0, 983040, '\p{^Present_In=0_7.0}', "");
    Expect(0, 983040, '\P{Present_In=0_7.0}', "");
    Expect(1, 983040, '\P{^Present_In=0_7.0}', "");
    Expect(0, 983037, '\p{Present_In=0_7.0}', "");
    Expect(1, 983037, '\p{^Present_In=0_7.0}', "");
    Expect(1, 983037, '\P{Present_In=0_7.0}', "");
    Expect(0, 983037, '\P{^Present_In=0_7.0}', "");
    Error('\p{In= 	V7_0:=}');
    Error('\P{In= 	V7_0:=}');
    Expect(1, 983040, '\p{In=v70}', "");
    Expect(0, 983040, '\p{^In=v70}', "");
    Expect(0, 983040, '\P{In=v70}', "");
    Expect(1, 983040, '\P{^In=v70}', "");
    Expect(0, 983037, '\p{In=v70}', "");
    Expect(1, 983037, '\p{^In=v70}', "");
    Expect(1, 983037, '\P{In=v70}', "");
    Expect(0, 983037, '\P{^In=v70}', "");
    Expect(1, 983040, '\p{In= _V7_0}', "");
    Expect(0, 983040, '\p{^In= _V7_0}', "");
    Expect(0, 983040, '\P{In= _V7_0}', "");
    Expect(1, 983040, '\P{^In= _V7_0}', "");
    Expect(0, 983037, '\p{In= _V7_0}', "");
    Expect(1, 983037, '\p{^In= _V7_0}', "");
    Expect(1, 983037, '\P{In= _V7_0}', "");
    Expect(0, 983037, '\P{^In= _V7_0}', "");
    Error('\p{Is_Present_In=	/a/00_7.0}');
    Error('\P{Is_Present_In=	/a/00_7.0}');
    Expect(1, 983040, '\p{Is_Present_In=7.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=7.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=7.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=7.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=7.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=7.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=7.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=7.0}', "");
    Error('\p{Is_In=:=V7_0}');
    Error('\P{Is_In=:=V7_0}');
    Expect(1, 983040, '\p{Is_In=v70}', "");
    Expect(0, 983040, '\p{^Is_In=v70}', "");
    Expect(0, 983040, '\P{Is_In=v70}', "");
    Expect(1, 983040, '\P{^Is_In=v70}', "");
    Expect(0, 983037, '\p{Is_In=v70}', "");
    Expect(1, 983037, '\p{^Is_In=v70}', "");
    Expect(1, 983037, '\P{Is_In=v70}', "");
    Expect(0, 983037, '\P{^Is_In=v70}', "");
    Expect(1, 983040, '\p{Is_In=- V7_0}', "");
    Expect(0, 983040, '\p{^Is_In=- V7_0}', "");
    Expect(0, 983040, '\P{Is_In=- V7_0}', "");
    Expect(1, 983040, '\P{^Is_In=- V7_0}', "");
    Expect(0, 983037, '\p{Is_In=- V7_0}', "");
    Expect(1, 983037, '\p{^Is_In=- V7_0}', "");
    Expect(1, 983037, '\P{Is_In=- V7_0}', "");
    Expect(0, 983037, '\P{^Is_In=- V7_0}', "");
    Error('\p{Present_In= 	8.0:=}');
    Error('\P{Present_In= 	8.0:=}');
    Expect(1, 983040, '\p{Present_In=08.0}', "");
    Expect(0, 983040, '\p{^Present_In=08.0}', "");
    Expect(0, 983040, '\P{Present_In=08.0}', "");
    Expect(1, 983040, '\P{^Present_In=08.0}', "");
    Expect(0, 983037, '\p{Present_In=08.0}', "");
    Expect(1, 983037, '\p{^Present_In=08.0}', "");
    Expect(1, 983037, '\P{Present_In=08.0}', "");
    Expect(0, 983037, '\P{^Present_In=08.0}', "");
    Error('\p{In: /a/V8_0}');
    Error('\P{In: /a/V8_0}');
    Expect(1, 983040, '\p{In=v80}', "");
    Expect(0, 983040, '\p{^In=v80}', "");
    Expect(0, 983040, '\P{In=v80}', "");
    Expect(1, 983040, '\P{^In=v80}', "");
    Expect(0, 983037, '\p{In=v80}', "");
    Expect(1, 983037, '\p{^In=v80}', "");
    Expect(1, 983037, '\P{In=v80}', "");
    Expect(0, 983037, '\P{^In=v80}', "");
    Expect(1, 983040, '\p{In: -_V8_0}', "");
    Expect(0, 983040, '\p{^In: -_V8_0}', "");
    Expect(0, 983040, '\P{In: -_V8_0}', "");
    Expect(1, 983040, '\P{^In: -_V8_0}', "");
    Expect(0, 983037, '\p{In: -_V8_0}', "");
    Expect(1, 983037, '\p{^In: -_V8_0}', "");
    Expect(1, 983037, '\P{In: -_V8_0}', "");
    Expect(0, 983037, '\P{^In: -_V8_0}', "");
    Error('\p{Is_Present_In=/a/		0000008.0}');
    Error('\P{Is_Present_In=/a/		0000008.0}');
    Expect(1, 983040, '\p{Is_Present_In=+0_0_0_0_0_08.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+0_0_0_0_0_08.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=+0_0_0_0_0_08.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+0_0_0_0_0_08.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=+0_0_0_0_0_08.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+0_0_0_0_0_08.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=+0_0_0_0_0_08.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+0_0_0_0_0_08.0}', "");
    Error('\p{Is_In= _v8_0:=}');
    Error('\P{Is_In= _v8_0:=}');
    Expect(1, 983040, '\p{Is_In=v80}', "");
    Expect(0, 983040, '\p{^Is_In=v80}', "");
    Expect(0, 983040, '\P{Is_In=v80}', "");
    Expect(1, 983040, '\P{^Is_In=v80}', "");
    Expect(0, 983037, '\p{Is_In=v80}', "");
    Expect(1, 983037, '\p{^Is_In=v80}', "");
    Expect(1, 983037, '\P{Is_In=v80}', "");
    Expect(0, 983037, '\P{^Is_In=v80}', "");
    Expect(1, 983040, '\p{Is_In=_V8_0}', "");
    Expect(0, 983040, '\p{^Is_In=_V8_0}', "");
    Expect(0, 983040, '\P{Is_In=_V8_0}', "");
    Expect(1, 983040, '\P{^Is_In=_V8_0}', "");
    Expect(0, 983037, '\p{Is_In=_V8_0}', "");
    Expect(1, 983037, '\p{^Is_In=_V8_0}', "");
    Expect(1, 983037, '\P{Is_In=_V8_0}', "");
    Expect(0, 983037, '\P{^Is_In=_V8_0}', "");
    Error('\p{Present_In=/a/- 09.0}');
    Error('\P{Present_In=/a/- 09.0}');
    Expect(1, 983040, '\p{Present_In=0000000009.0}', "");
    Expect(0, 983040, '\p{^Present_In=0000000009.0}', "");
    Expect(0, 983040, '\P{Present_In=0000000009.0}', "");
    Expect(1, 983040, '\P{^Present_In=0000000009.0}', "");
    Expect(0, 983037, '\p{Present_In=0000000009.0}', "");
    Expect(1, 983037, '\p{^Present_In=0000000009.0}', "");
    Expect(1, 983037, '\P{Present_In=0000000009.0}', "");
    Expect(0, 983037, '\P{^Present_In=0000000009.0}', "");
    Error('\p{In=:= -V9_0}');
    Error('\P{In=:= -V9_0}');
    Expect(1, 983040, '\p{In=v90}', "");
    Expect(0, 983040, '\p{^In=v90}', "");
    Expect(0, 983040, '\P{In=v90}', "");
    Expect(1, 983040, '\P{^In=v90}', "");
    Expect(0, 983037, '\p{In=v90}', "");
    Expect(1, 983037, '\p{^In=v90}', "");
    Expect(1, 983037, '\P{In=v90}', "");
    Expect(0, 983037, '\P{^In=v90}', "");
    Expect(1, 983040, '\p{In=__V9_0}', "");
    Expect(0, 983040, '\p{^In=__V9_0}', "");
    Expect(0, 983040, '\P{In=__V9_0}', "");
    Expect(1, 983040, '\P{^In=__V9_0}', "");
    Expect(0, 983037, '\p{In=__V9_0}', "");
    Expect(1, 983037, '\p{^In=__V9_0}', "");
    Expect(1, 983037, '\P{In=__V9_0}', "");
    Expect(0, 983037, '\P{^In=__V9_0}', "");
    Error('\p{Is_Present_In=	/a/00009.0}');
    Error('\P{Is_Present_In=	/a/00009.0}');
    Expect(1, 983040, '\p{Is_Present_In=+00_00_00_9.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+00_00_00_9.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=+00_00_00_9.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+00_00_00_9.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=+00_00_00_9.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+00_00_00_9.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=+00_00_00_9.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+00_00_00_9.0}', "");
    Error('\p{Is_In=/a/ V9_0}');
    Error('\P{Is_In=/a/ V9_0}');
    Expect(1, 983040, '\p{Is_In=v90}', "");
    Expect(0, 983040, '\p{^Is_In=v90}', "");
    Expect(0, 983040, '\P{Is_In=v90}', "");
    Expect(1, 983040, '\P{^Is_In=v90}', "");
    Expect(0, 983037, '\p{Is_In=v90}', "");
    Expect(1, 983037, '\p{^Is_In=v90}', "");
    Expect(1, 983037, '\P{Is_In=v90}', "");
    Expect(0, 983037, '\P{^Is_In=v90}', "");
    Expect(1, 983040, '\p{Is_In=-	V9_0}', "");
    Expect(0, 983040, '\p{^Is_In=-	V9_0}', "");
    Expect(0, 983040, '\P{Is_In=-	V9_0}', "");
    Expect(1, 983040, '\P{^Is_In=-	V9_0}', "");
    Expect(0, 983037, '\p{Is_In=-	V9_0}', "");
    Expect(1, 983037, '\p{^Is_In=-	V9_0}', "");
    Expect(1, 983037, '\P{Is_In=-	V9_0}', "");
    Expect(0, 983037, '\P{^Is_In=-	V9_0}', "");
    Error('\p{Present_In= /a/Unassigned}');
    Error('\P{Present_In= /a/Unassigned}');
    Expect(1, 983037, '\p{Present_In=unassigned}', "");
    Expect(0, 983037, '\p{^Present_In=unassigned}', "");
    Expect(0, 983037, '\P{Present_In=unassigned}', "");
    Expect(1, 983037, '\P{^Present_In=unassigned}', "");
    Expect(0, 983040, '\p{Present_In=unassigned}', "");
    Expect(1, 983040, '\p{^Present_In=unassigned}', "");
    Expect(1, 983040, '\P{Present_In=unassigned}', "");
    Expect(0, 983040, '\P{^Present_In=unassigned}', "");
    Expect(1, 983037, '\p{Present_In= _unassigned}', "");
    Expect(0, 983037, '\p{^Present_In= _unassigned}', "");
    Expect(0, 983037, '\P{Present_In= _unassigned}', "");
    Expect(1, 983037, '\P{^Present_In= _unassigned}', "");
    Expect(0, 983040, '\p{Present_In= _unassigned}', "");
    Expect(1, 983040, '\p{^Present_In= _unassigned}', "");
    Expect(1, 983040, '\P{Present_In= _unassigned}', "");
    Expect(0, 983040, '\P{^Present_In= _unassigned}', "");
    Error('\p{In=:= -unassigned}');
    Error('\P{In=:= -unassigned}');
    Expect(1, 983037, '\p{In:   unassigned}', "");
    Expect(0, 983037, '\p{^In:   unassigned}', "");
    Expect(0, 983037, '\P{In:   unassigned}', "");
    Expect(1, 983037, '\P{^In:   unassigned}', "");
    Expect(0, 983040, '\p{In:   unassigned}', "");
    Expect(1, 983040, '\p{^In:   unassigned}', "");
    Expect(1, 983040, '\P{In:   unassigned}', "");
    Expect(0, 983040, '\P{^In:   unassigned}', "");
    Expect(1, 983037, '\p{In=_	unassigned}', "");
    Expect(0, 983037, '\p{^In=_	unassigned}', "");
    Expect(0, 983037, '\P{In=_	unassigned}', "");
    Expect(1, 983037, '\P{^In=_	unassigned}', "");
    Expect(0, 983040, '\p{In=_	unassigned}', "");
    Expect(1, 983040, '\p{^In=_	unassigned}', "");
    Expect(1, 983040, '\P{In=_	unassigned}', "");
    Expect(0, 983040, '\P{^In=_	unassigned}', "");
    Error('\p{Is_Present_In=- Unassigned:=}');
    Error('\P{Is_Present_In=- Unassigned:=}');
    Expect(1, 983037, '\p{Is_Present_In=unassigned}', "");
    Expect(0, 983037, '\p{^Is_Present_In=unassigned}', "");
    Expect(0, 983037, '\P{Is_Present_In=unassigned}', "");
    Expect(1, 983037, '\P{^Is_Present_In=unassigned}', "");
    Expect(0, 983040, '\p{Is_Present_In=unassigned}', "");
    Expect(1, 983040, '\p{^Is_Present_In=unassigned}', "");
    Expect(1, 983040, '\P{Is_Present_In=unassigned}', "");
    Expect(0, 983040, '\P{^Is_Present_In=unassigned}', "");
    Error('\p{Is_In:   	:=unassigned}');
    Error('\P{Is_In:   	:=unassigned}');
    Expect(1, 983037, '\p{Is_In=unassigned}', "");
    Expect(0, 983037, '\p{^Is_In=unassigned}', "");
    Expect(0, 983037, '\P{Is_In=unassigned}', "");
    Expect(1, 983037, '\P{^Is_In=unassigned}', "");
    Expect(0, 983040, '\p{Is_In=unassigned}', "");
    Expect(1, 983040, '\p{^Is_In=unassigned}', "");
    Expect(1, 983040, '\P{Is_In=unassigned}', "");
    Expect(0, 983040, '\P{^Is_In=unassigned}', "");
    Expect(1, 983037, '\p{Is_In=	 unassigned}', "");
    Expect(0, 983037, '\p{^Is_In=	 unassigned}', "");
    Expect(0, 983037, '\P{Is_In=	 unassigned}', "");
    Expect(1, 983037, '\P{^Is_In=	 unassigned}', "");
    Expect(0, 983040, '\p{Is_In=	 unassigned}', "");
    Expect(1, 983040, '\p{^Is_In=	 unassigned}', "");
    Expect(1, 983040, '\P{Is_In=	 unassigned}', "");
    Expect(0, 983040, '\P{^Is_In=	 unassigned}', "");
    Error('\p{indicpositionalcategory}');
    Error('\P{indicpositionalcategory}');
    Error('\p{inpc}');
    Error('\P{inpc}');
    Error('\p{Indic_Positional_Category=:=	Bottom}');
    Error('\P{Indic_Positional_Category=:=	Bottom}');
    Expect(1, 73031, '\p{Indic_Positional_Category:   bottom}', "");
    Expect(0, 73031, '\p{^Indic_Positional_Category:   bottom}', "");
    Expect(0, 73031, '\P{Indic_Positional_Category:   bottom}', "");
    Expect(1, 73031, '\P{^Indic_Positional_Category:   bottom}', "");
    Expect(0, 73032, '\p{Indic_Positional_Category:   bottom}', "");
    Expect(1, 73032, '\p{^Indic_Positional_Category:   bottom}', "");
    Expect(1, 73032, '\P{Indic_Positional_Category:   bottom}', "");
    Expect(0, 73032, '\P{^Indic_Positional_Category:   bottom}', "");
    Expect(1, 73031, '\p{Indic_Positional_Category=-_Bottom}', "");
    Expect(0, 73031, '\p{^Indic_Positional_Category=-_Bottom}', "");
    Expect(0, 73031, '\P{Indic_Positional_Category=-_Bottom}', "");
    Expect(1, 73031, '\P{^Indic_Positional_Category=-_Bottom}', "");
    Expect(0, 73032, '\p{Indic_Positional_Category=-_Bottom}', "");
    Expect(1, 73032, '\p{^Indic_Positional_Category=-_Bottom}', "");
    Expect(1, 73032, '\P{Indic_Positional_Category=-_Bottom}', "");
    Expect(0, 73032, '\P{^Indic_Positional_Category=-_Bottom}', "");
    Error('\p{InPC=:=-_Bottom}');
    Error('\P{InPC=:=-_Bottom}');
    Expect(1, 73031, '\p{InPC=bottom}', "");
    Expect(0, 73031, '\p{^InPC=bottom}', "");
    Expect(0, 73031, '\P{InPC=bottom}', "");
    Expect(1, 73031, '\P{^InPC=bottom}', "");
    Expect(0, 73032, '\p{InPC=bottom}', "");
    Expect(1, 73032, '\p{^InPC=bottom}', "");
    Expect(1, 73032, '\P{InPC=bottom}', "");
    Expect(0, 73032, '\P{^InPC=bottom}', "");
    Expect(1, 73031, '\p{InPC:	-Bottom}', "");
    Expect(0, 73031, '\p{^InPC:	-Bottom}', "");
    Expect(0, 73031, '\P{InPC:	-Bottom}', "");
    Expect(1, 73031, '\P{^InPC:	-Bottom}', "");
    Expect(0, 73032, '\p{InPC:	-Bottom}', "");
    Expect(1, 73032, '\p{^InPC:	-Bottom}', "");
    Expect(1, 73032, '\P{InPC:	-Bottom}', "");
    Expect(0, 73032, '\P{^InPC:	-Bottom}', "");
    Error('\p{Is_Indic_Positional_Category=	-Bottom/a/}');
    Error('\P{Is_Indic_Positional_Category=	-Bottom/a/}');
    Expect(1, 73031, '\p{Is_Indic_Positional_Category=bottom}', "");
    Expect(0, 73031, '\p{^Is_Indic_Positional_Category=bottom}', "");
    Expect(0, 73031, '\P{Is_Indic_Positional_Category=bottom}', "");
    Expect(1, 73031, '\P{^Is_Indic_Positional_Category=bottom}', "");
    Expect(0, 73032, '\p{Is_Indic_Positional_Category=bottom}', "");
    Expect(1, 73032, '\p{^Is_Indic_Positional_Category=bottom}', "");
    Expect(1, 73032, '\P{Is_Indic_Positional_Category=bottom}', "");
    Expect(0, 73032, '\P{^Is_Indic_Positional_Category=bottom}', "");
    Expect(1, 73031, '\p{Is_Indic_Positional_Category=__Bottom}', "");
    Expect(0, 73031, '\p{^Is_Indic_Positional_Category=__Bottom}', "");
    Expect(0, 73031, '\P{Is_Indic_Positional_Category=__Bottom}', "");
    Expect(1, 73031, '\P{^Is_Indic_Positional_Category=__Bottom}', "");
    Expect(0, 73032, '\p{Is_Indic_Positional_Category=__Bottom}', "");
    Expect(1, 73032, '\p{^Is_Indic_Positional_Category=__Bottom}', "");
    Expect(1, 73032, '\P{Is_Indic_Positional_Category=__Bottom}', "");
    Expect(0, 73032, '\P{^Is_Indic_Positional_Category=__Bottom}', "");
    Error('\p{Is_InPC=/a/ 	bottom}');
    Error('\P{Is_InPC=/a/ 	bottom}');
    Expect(1, 73031, '\p{Is_InPC=bottom}', "");
    Expect(0, 73031, '\p{^Is_InPC=bottom}', "");
    Expect(0, 73031, '\P{Is_InPC=bottom}', "");
    Expect(1, 73031, '\P{^Is_InPC=bottom}', "");
    Expect(0, 73032, '\p{Is_InPC=bottom}', "");
    Expect(1, 73032, '\p{^Is_InPC=bottom}', "");
    Expect(1, 73032, '\P{Is_InPC=bottom}', "");
    Expect(0, 73032, '\P{^Is_InPC=bottom}', "");
    Expect(1, 73031, '\p{Is_InPC=-Bottom}', "");
    Expect(0, 73031, '\p{^Is_InPC=-Bottom}', "");
    Expect(0, 73031, '\P{Is_InPC=-Bottom}', "");
    Expect(1, 73031, '\P{^Is_InPC=-Bottom}', "");
    Expect(0, 73032, '\p{Is_InPC=-Bottom}', "");
    Expect(1, 73032, '\p{^Is_InPC=-Bottom}', "");
    Expect(1, 73032, '\P{Is_InPC=-Bottom}', "");
    Expect(0, 73032, '\P{^Is_InPC=-Bottom}', "");
    Error('\p{Indic_Positional_Category=:=_-Bottom_AND_Left}');
    Error('\P{Indic_Positional_Category=:=_-Bottom_AND_Left}');
    Expect(1, 43455, '\p{Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43455, '\p{^Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43455, '\P{Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43455, '\P{^Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43456, '\p{Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43456, '\p{^Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43456, '\P{Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43456, '\P{^Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43455, '\p{Indic_Positional_Category:		bottom_AND_LEFT}', "");
    Expect(0, 43455, '\p{^Indic_Positional_Category:		bottom_AND_LEFT}', "");
    Expect(0, 43455, '\P{Indic_Positional_Category:		bottom_AND_LEFT}', "");
    Expect(1, 43455, '\P{^Indic_Positional_Category:		bottom_AND_LEFT}', "");
    Expect(0, 43456, '\p{Indic_Positional_Category:		bottom_AND_LEFT}', "");
    Expect(1, 43456, '\p{^Indic_Positional_Category:		bottom_AND_LEFT}', "");
    Expect(1, 43456, '\P{Indic_Positional_Category:		bottom_AND_LEFT}', "");
    Expect(0, 43456, '\P{^Indic_Positional_Category:		bottom_AND_LEFT}', "");
    Error('\p{InPC=_:=bottom_and_LEFT}');
    Error('\P{InPC=_:=bottom_and_LEFT}');
    Expect(1, 43455, '\p{InPC=bottomandleft}', "");
    Expect(0, 43455, '\p{^InPC=bottomandleft}', "");
    Expect(0, 43455, '\P{InPC=bottomandleft}', "");
    Expect(1, 43455, '\P{^InPC=bottomandleft}', "");
    Expect(0, 43456, '\p{InPC=bottomandleft}', "");
    Expect(1, 43456, '\p{^InPC=bottomandleft}', "");
    Expect(1, 43456, '\P{InPC=bottomandleft}', "");
    Expect(0, 43456, '\P{^InPC=bottomandleft}', "");
    Expect(1, 43455, '\p{InPC:		_bottom_And_Left}', "");
    Expect(0, 43455, '\p{^InPC:		_bottom_And_Left}', "");
    Expect(0, 43455, '\P{InPC:		_bottom_And_Left}', "");
    Expect(1, 43455, '\P{^InPC:		_bottom_And_Left}', "");
    Expect(0, 43456, '\p{InPC:		_bottom_And_Left}', "");
    Expect(1, 43456, '\p{^InPC:		_bottom_And_Left}', "");
    Expect(1, 43456, '\P{InPC:		_bottom_And_Left}', "");
    Expect(0, 43456, '\P{^InPC:		_bottom_And_Left}', "");
    Error('\p{Is_Indic_Positional_Category=-_bottom_and_left/a/}');
    Error('\P{Is_Indic_Positional_Category=-_bottom_and_left/a/}');
    Expect(1, 43455, '\p{Is_Indic_Positional_Category:	bottomandleft}', "");
    Expect(0, 43455, '\p{^Is_Indic_Positional_Category:	bottomandleft}', "");
    Expect(0, 43455, '\P{Is_Indic_Positional_Category:	bottomandleft}', "");
    Expect(1, 43455, '\P{^Is_Indic_Positional_Category:	bottomandleft}', "");
    Expect(0, 43456, '\p{Is_Indic_Positional_Category:	bottomandleft}', "");
    Expect(1, 43456, '\p{^Is_Indic_Positional_Category:	bottomandleft}', "");
    Expect(1, 43456, '\P{Is_Indic_Positional_Category:	bottomandleft}', "");
    Expect(0, 43456, '\P{^Is_Indic_Positional_Category:	bottomandleft}', "");
    Expect(1, 43455, '\p{Is_Indic_Positional_Category=	 bottom_AND_Left}', "");
    Expect(0, 43455, '\p{^Is_Indic_Positional_Category=	 bottom_AND_Left}', "");
    Expect(0, 43455, '\P{Is_Indic_Positional_Category=	 bottom_AND_Left}', "");
    Expect(1, 43455, '\P{^Is_Indic_Positional_Category=	 bottom_AND_Left}', "");
    Expect(0, 43456, '\p{Is_Indic_Positional_Category=	 bottom_AND_Left}', "");
    Expect(1, 43456, '\p{^Is_Indic_Positional_Category=	 bottom_AND_Left}', "");
    Expect(1, 43456, '\P{Is_Indic_Positional_Category=	 bottom_AND_Left}', "");
    Expect(0, 43456, '\P{^Is_Indic_Positional_Category=	 bottom_AND_Left}', "");
    Error('\p{Is_InPC=-BOTTOM_And_Left/a/}');
    Error('\P{Is_InPC=-BOTTOM_And_Left/a/}');
    Expect(1, 43455, '\p{Is_InPC=bottomandleft}', "");
    Expect(0, 43455, '\p{^Is_InPC=bottomandleft}', "");
    Expect(0, 43455, '\P{Is_InPC=bottomandleft}', "");
    Expect(1, 43455, '\P{^Is_InPC=bottomandleft}', "");
    Expect(0, 43456, '\p{Is_InPC=bottomandleft}', "");
    Expect(1, 43456, '\p{^Is_InPC=bottomandleft}', "");
    Expect(1, 43456, '\P{Is_InPC=bottomandleft}', "");
    Expect(0, 43456, '\P{^Is_InPC=bottomandleft}', "");
    Expect(1, 43455, '\p{Is_InPC=	Bottom_and_Left}', "");
    Expect(0, 43455, '\p{^Is_InPC=	Bottom_and_Left}', "");
    Expect(0, 43455, '\P{Is_InPC=	Bottom_and_Left}', "");
    Expect(1, 43455, '\P{^Is_InPC=	Bottom_and_Left}', "");
    Expect(0, 43456, '\p{Is_InPC=	Bottom_and_Left}', "");
    Expect(1, 43456, '\p{^Is_InPC=	Bottom_and_Left}', "");
    Expect(1, 43456, '\P{Is_InPC=	Bottom_and_Left}', "");
    Expect(0, 43456, '\P{^Is_InPC=	Bottom_and_Left}', "");
    Error('\p{Indic_Positional_Category=:=_ BOTTOM_and_right}');
    Error('\P{Indic_Positional_Category=:=_ BOTTOM_and_right}');
    Expect(1, 43456, '\p{Indic_Positional_Category=bottomandright}', "");
    Expect(0, 43456, '\p{^Indic_Positional_Category=bottomandright}', "");
    Expect(0, 43456, '\P{Indic_Positional_Category=bottomandright}', "");
    Expect(1, 43456, '\P{^Indic_Positional_Category=bottomandright}', "");
    Expect(0, 43457, '\p{Indic_Positional_Category=bottomandright}', "");
    Expect(1, 43457, '\p{^Indic_Positional_Category=bottomandright}', "");
    Expect(1, 43457, '\P{Indic_Positional_Category=bottomandright}', "");
    Expect(0, 43457, '\P{^Indic_Positional_Category=bottomandright}', "");
    Expect(1, 43456, '\p{Indic_Positional_Category=_	BOTTOM_and_RIGHT}', "");
    Expect(0, 43456, '\p{^Indic_Positional_Category=_	BOTTOM_and_RIGHT}', "");
    Expect(0, 43456, '\P{Indic_Positional_Category=_	BOTTOM_and_RIGHT}', "");
    Expect(1, 43456, '\P{^Indic_Positional_Category=_	BOTTOM_and_RIGHT}', "");
    Expect(0, 43457, '\p{Indic_Positional_Category=_	BOTTOM_and_RIGHT}', "");
    Expect(1, 43457, '\p{^Indic_Positional_Category=_	BOTTOM_and_RIGHT}', "");
    Expect(1, 43457, '\P{Indic_Positional_Category=_	BOTTOM_and_RIGHT}', "");
    Expect(0, 43457, '\P{^Indic_Positional_Category=_	BOTTOM_and_RIGHT}', "");
    Error('\p{InPC:  Bottom_And_right:=}');
    Error('\P{InPC:  Bottom_And_right:=}');
    Expect(1, 43456, '\p{InPC=bottomandright}', "");
    Expect(0, 43456, '\p{^InPC=bottomandright}', "");
    Expect(0, 43456, '\P{InPC=bottomandright}', "");
    Expect(1, 43456, '\P{^InPC=bottomandright}', "");
    Expect(0, 43457, '\p{InPC=bottomandright}', "");
    Expect(1, 43457, '\p{^InPC=bottomandright}', "");
    Expect(1, 43457, '\P{InPC=bottomandright}', "");
    Expect(0, 43457, '\P{^InPC=bottomandright}', "");
    Expect(1, 43456, '\p{InPC=-_Bottom_And_Right}', "");
    Expect(0, 43456, '\p{^InPC=-_Bottom_And_Right}', "");
    Expect(0, 43456, '\P{InPC=-_Bottom_And_Right}', "");
    Expect(1, 43456, '\P{^InPC=-_Bottom_And_Right}', "");
    Expect(0, 43457, '\p{InPC=-_Bottom_And_Right}', "");
    Expect(1, 43457, '\p{^InPC=-_Bottom_And_Right}', "");
    Expect(1, 43457, '\P{InPC=-_Bottom_And_Right}', "");
    Expect(0, 43457, '\P{^InPC=-_Bottom_And_Right}', "");
    Error('\p{Is_Indic_Positional_Category=/a/	BOTTOM_and_Right}');
    Error('\P{Is_Indic_Positional_Category=/a/	BOTTOM_and_Right}');
    Expect(1, 43456, '\p{Is_Indic_Positional_Category=bottomandright}', "");
    Expect(0, 43456, '\p{^Is_Indic_Positional_Category=bottomandright}', "");
    Expect(0, 43456, '\P{Is_Indic_Positional_Category=bottomandright}', "");
    Expect(1, 43456, '\P{^Is_Indic_Positional_Category=bottomandright}', "");
    Expect(0, 43457, '\p{Is_Indic_Positional_Category=bottomandright}', "");
    Expect(1, 43457, '\p{^Is_Indic_Positional_Category=bottomandright}', "");
    Expect(1, 43457, '\P{Is_Indic_Positional_Category=bottomandright}', "");
    Expect(0, 43457, '\P{^Is_Indic_Positional_Category=bottomandright}', "");
    Expect(1, 43456, '\p{Is_Indic_Positional_Category= _Bottom_And_Right}', "");
    Expect(0, 43456, '\p{^Is_Indic_Positional_Category= _Bottom_And_Right}', "");
    Expect(0, 43456, '\P{Is_Indic_Positional_Category= _Bottom_And_Right}', "");
    Expect(1, 43456, '\P{^Is_Indic_Positional_Category= _Bottom_And_Right}', "");
    Expect(0, 43457, '\p{Is_Indic_Positional_Category= _Bottom_And_Right}', "");
    Expect(1, 43457, '\p{^Is_Indic_Positional_Category= _Bottom_And_Right}', "");
    Expect(1, 43457, '\P{Is_Indic_Positional_Category= _Bottom_And_Right}', "");
    Expect(0, 43457, '\P{^Is_Indic_Positional_Category= _Bottom_And_Right}', "");
    Error('\p{Is_InPC=_Bottom_and_Right/a/}');
    Error('\P{Is_InPC=_Bottom_and_Right/a/}');
    Expect(1, 43456, '\p{Is_InPC=bottomandright}', "");
    Expect(0, 43456, '\p{^Is_InPC=bottomandright}', "");
    Expect(0, 43456, '\P{Is_InPC=bottomandright}', "");
    Expect(1, 43456, '\P{^Is_InPC=bottomandright}', "");
    Expect(0, 43457, '\p{Is_InPC=bottomandright}', "");
    Expect(1, 43457, '\p{^Is_InPC=bottomandright}', "");
    Expect(1, 43457, '\P{Is_InPC=bottomandright}', "");
    Expect(0, 43457, '\P{^Is_InPC=bottomandright}', "");
    Expect(1, 43456, '\p{Is_InPC= -Bottom_And_Right}', "");
    Expect(0, 43456, '\p{^Is_InPC= -Bottom_And_Right}', "");
    Expect(0, 43456, '\P{Is_InPC= -Bottom_And_Right}', "");
    Expect(1, 43456, '\P{^Is_InPC= -Bottom_And_Right}', "");
    Expect(0, 43457, '\p{Is_InPC= -Bottom_And_Right}', "");
    Expect(1, 43457, '\p{^Is_InPC= -Bottom_And_Right}', "");
    Expect(1, 43457, '\P{Is_InPC= -Bottom_And_Right}', "");
    Expect(0, 43457, '\P{^Is_InPC= -Bottom_And_Right}', "");
    Error('\p{Indic_Positional_Category= /a/Left}');
    Error('\P{Indic_Positional_Category= /a/Left}');
    Expect(1, 72881, '\p{Indic_Positional_Category=left}', "");
    Expect(0, 72881, '\p{^Indic_Positional_Category=left}', "");
    Expect(0, 72881, '\P{Indic_Positional_Category=left}', "");
    Expect(1, 72881, '\P{^Indic_Positional_Category=left}', "");
    Expect(0, 72882, '\p{Indic_Positional_Category=left}', "");
    Expect(1, 72882, '\p{^Indic_Positional_Category=left}', "");
    Expect(1, 72882, '\P{Indic_Positional_Category=left}', "");
    Expect(0, 72882, '\P{^Indic_Positional_Category=left}', "");
    Expect(1, 72881, '\p{Indic_Positional_Category=_left}', "");
    Expect(0, 72881, '\p{^Indic_Positional_Category=_left}', "");
    Expect(0, 72881, '\P{Indic_Positional_Category=_left}', "");
    Expect(1, 72881, '\P{^Indic_Positional_Category=_left}', "");
    Expect(0, 72882, '\p{Indic_Positional_Category=_left}', "");
    Expect(1, 72882, '\p{^Indic_Positional_Category=_left}', "");
    Expect(1, 72882, '\P{Indic_Positional_Category=_left}', "");
    Expect(0, 72882, '\P{^Indic_Positional_Category=_left}', "");
    Error('\p{InPC=- LEFT:=}');
    Error('\P{InPC=- LEFT:=}');
    Expect(1, 72881, '\p{InPC=left}', "");
    Expect(0, 72881, '\p{^InPC=left}', "");
    Expect(0, 72881, '\P{InPC=left}', "");
    Expect(1, 72881, '\P{^InPC=left}', "");
    Expect(0, 72882, '\p{InPC=left}', "");
    Expect(1, 72882, '\p{^InPC=left}', "");
    Expect(1, 72882, '\P{InPC=left}', "");
    Expect(0, 72882, '\P{^InPC=left}', "");
    Expect(1, 72881, '\p{InPC=	-left}', "");
    Expect(0, 72881, '\p{^InPC=	-left}', "");
    Expect(0, 72881, '\P{InPC=	-left}', "");
    Expect(1, 72881, '\P{^InPC=	-left}', "");
    Expect(0, 72882, '\p{InPC=	-left}', "");
    Expect(1, 72882, '\p{^InPC=	-left}', "");
    Expect(1, 72882, '\P{InPC=	-left}', "");
    Expect(0, 72882, '\P{^InPC=	-left}', "");
    Error('\p{Is_Indic_Positional_Category=	 left:=}');
    Error('\P{Is_Indic_Positional_Category=	 left:=}');
    Expect(1, 72881, '\p{Is_Indic_Positional_Category=left}', "");
    Expect(0, 72881, '\p{^Is_Indic_Positional_Category=left}', "");
    Expect(0, 72881, '\P{Is_Indic_Positional_Category=left}', "");
    Expect(1, 72881, '\P{^Is_Indic_Positional_Category=left}', "");
    Expect(0, 72882, '\p{Is_Indic_Positional_Category=left}', "");
    Expect(1, 72882, '\p{^Is_Indic_Positional_Category=left}', "");
    Expect(1, 72882, '\P{Is_Indic_Positional_Category=left}', "");
    Expect(0, 72882, '\P{^Is_Indic_Positional_Category=left}', "");
    Expect(1, 72881, '\p{Is_Indic_Positional_Category= Left}', "");
    Expect(0, 72881, '\p{^Is_Indic_Positional_Category= Left}', "");
    Expect(0, 72881, '\P{Is_Indic_Positional_Category= Left}', "");
    Expect(1, 72881, '\P{^Is_Indic_Positional_Category= Left}', "");
    Expect(0, 72882, '\p{Is_Indic_Positional_Category= Left}', "");
    Expect(1, 72882, '\p{^Is_Indic_Positional_Category= Left}', "");
    Expect(1, 72882, '\P{Is_Indic_Positional_Category= Left}', "");
    Expect(0, 72882, '\P{^Is_Indic_Positional_Category= Left}', "");
    Error('\p{Is_InPC= /a/LEFT}');
    Error('\P{Is_InPC= /a/LEFT}');
    Expect(1, 72881, '\p{Is_InPC=left}', "");
    Expect(0, 72881, '\p{^Is_InPC=left}', "");
    Expect(0, 72881, '\P{Is_InPC=left}', "");
    Expect(1, 72881, '\P{^Is_InPC=left}', "");
    Expect(0, 72882, '\p{Is_InPC=left}', "");
    Expect(1, 72882, '\p{^Is_InPC=left}', "");
    Expect(1, 72882, '\P{Is_InPC=left}', "");
    Expect(0, 72882, '\P{^Is_InPC=left}', "");
    Expect(1, 72881, '\p{Is_InPC:_-left}', "");
    Expect(0, 72881, '\p{^Is_InPC:_-left}', "");
    Expect(0, 72881, '\P{Is_InPC:_-left}', "");
    Expect(1, 72881, '\P{^Is_InPC:_-left}', "");
    Expect(0, 72882, '\p{Is_InPC:_-left}', "");
    Expect(1, 72882, '\p{^Is_InPC:_-left}', "");
    Expect(1, 72882, '\P{Is_InPC:_-left}', "");
    Expect(0, 72882, '\P{^Is_InPC:_-left}', "");
    Error('\p{Indic_Positional_Category=_/a/Left_and_right}');
    Error('\P{Indic_Positional_Category=_/a/Left_and_right}');
    Expect(1, 71098, '\p{Indic_Positional_Category=leftandright}', "");
    Expect(0, 71098, '\p{^Indic_Positional_Category=leftandright}', "");
    Expect(0, 71098, '\P{Indic_Positional_Category=leftandright}', "");
    Expect(1, 71098, '\P{^Indic_Positional_Category=leftandright}', "");
    Expect(0, 71099, '\p{Indic_Positional_Category=leftandright}', "");
    Expect(1, 71099, '\p{^Indic_Positional_Category=leftandright}', "");
    Expect(1, 71099, '\P{Indic_Positional_Category=leftandright}', "");
    Expect(0, 71099, '\P{^Indic_Positional_Category=leftandright}', "");
    Expect(1, 71098, '\p{Indic_Positional_Category=__left_and_Right}', "");
    Expect(0, 71098, '\p{^Indic_Positional_Category=__left_and_Right}', "");
    Expect(0, 71098, '\P{Indic_Positional_Category=__left_and_Right}', "");
    Expect(1, 71098, '\P{^Indic_Positional_Category=__left_and_Right}', "");
    Expect(0, 71099, '\p{Indic_Positional_Category=__left_and_Right}', "");
    Expect(1, 71099, '\p{^Indic_Positional_Category=__left_and_Right}', "");
    Expect(1, 71099, '\P{Indic_Positional_Category=__left_and_Right}', "");
    Expect(0, 71099, '\P{^Indic_Positional_Category=__left_and_Right}', "");
    Error('\p{InPC=:=-LEFT_AND_RIGHT}');
    Error('\P{InPC=:=-LEFT_AND_RIGHT}');
    Expect(1, 71098, '\p{InPC=leftandright}', "");
    Expect(0, 71098, '\p{^InPC=leftandright}', "");
    Expect(0, 71098, '\P{InPC=leftandright}', "");
    Expect(1, 71098, '\P{^InPC=leftandright}', "");
    Expect(0, 71099, '\p{InPC=leftandright}', "");
    Expect(1, 71099, '\p{^InPC=leftandright}', "");
    Expect(1, 71099, '\P{InPC=leftandright}', "");
    Expect(0, 71099, '\P{^InPC=leftandright}', "");
    Expect(1, 71098, '\p{InPC: LEFT_and_RIGHT}', "");
    Expect(0, 71098, '\p{^InPC: LEFT_and_RIGHT}', "");
    Expect(0, 71098, '\P{InPC: LEFT_and_RIGHT}', "");
    Expect(1, 71098, '\P{^InPC: LEFT_and_RIGHT}', "");
    Expect(0, 71099, '\p{InPC: LEFT_and_RIGHT}', "");
    Expect(1, 71099, '\p{^InPC: LEFT_and_RIGHT}', "");
    Expect(1, 71099, '\P{InPC: LEFT_and_RIGHT}', "");
    Expect(0, 71099, '\P{^InPC: LEFT_and_RIGHT}', "");
    Error('\p{Is_Indic_Positional_Category=- LEFT_And_Right:=}');
    Error('\P{Is_Indic_Positional_Category=- LEFT_And_Right:=}');
    Expect(1, 71098, '\p{Is_Indic_Positional_Category=leftandright}', "");
    Expect(0, 71098, '\p{^Is_Indic_Positional_Category=leftandright}', "");
    Expect(0, 71098, '\P{Is_Indic_Positional_Category=leftandright}', "");
    Expect(1, 71098, '\P{^Is_Indic_Positional_Category=leftandright}', "");
    Expect(0, 71099, '\p{Is_Indic_Positional_Category=leftandright}', "");
    Expect(1, 71099, '\p{^Is_Indic_Positional_Category=leftandright}', "");
    Expect(1, 71099, '\P{Is_Indic_Positional_Category=leftandright}', "");
    Expect(0, 71099, '\P{^Is_Indic_Positional_Category=leftandright}', "");
    Expect(1, 71098, '\p{Is_Indic_Positional_Category=  Left_And_RIGHT}', "");
    Expect(0, 71098, '\p{^Is_Indic_Positional_Category=  Left_And_RIGHT}', "");
    Expect(0, 71098, '\P{Is_Indic_Positional_Category=  Left_And_RIGHT}', "");
    Expect(1, 71098, '\P{^Is_Indic_Positional_Category=  Left_And_RIGHT}', "");
    Expect(0, 71099, '\p{Is_Indic_Positional_Category=  Left_And_RIGHT}', "");
    Expect(1, 71099, '\p{^Is_Indic_Positional_Category=  Left_And_RIGHT}', "");
    Expect(1, 71099, '\P{Is_Indic_Positional_Category=  Left_And_RIGHT}', "");
    Expect(0, 71099, '\P{^Is_Indic_Positional_Category=  Left_And_RIGHT}', "");
    Error('\p{Is_InPC=/a/-_LEFT_AND_Right}');
    Error('\P{Is_InPC=/a/-_LEFT_AND_Right}');
    Expect(1, 71098, '\p{Is_InPC=leftandright}', "");
    Expect(0, 71098, '\p{^Is_InPC=leftandright}', "");
    Expect(0, 71098, '\P{Is_InPC=leftandright}', "");
    Expect(1, 71098, '\P{^Is_InPC=leftandright}', "");
    Expect(0, 71099, '\p{Is_InPC=leftandright}', "");
    Expect(1, 71099, '\p{^Is_InPC=leftandright}', "");
    Expect(1, 71099, '\P{Is_InPC=leftandright}', "");
    Expect(0, 71099, '\P{^Is_InPC=leftandright}', "");
    Expect(1, 71098, '\p{Is_InPC=__Left_And_Right}', "");
    Expect(0, 71098, '\p{^Is_InPC=__Left_And_Right}', "");
    Expect(0, 71098, '\P{Is_InPC=__Left_And_Right}', "");
    Expect(1, 71098, '\P{^Is_InPC=__Left_And_Right}', "");
    Expect(0, 71099, '\p{Is_InPC=__Left_And_Right}', "");
    Expect(1, 71099, '\p{^Is_InPC=__Left_And_Right}', "");
    Expect(1, 71099, '\P{Is_InPC=__Left_And_Right}', "");
    Expect(0, 71099, '\P{^Is_InPC=__Left_And_Right}', "");
    Error('\p{Indic_Positional_Category=_ na/a/}');
    Error('\P{Indic_Positional_Category=_ na/a/}');
    Expect(1, 73032, '\p{Indic_Positional_Category=na}', "");
    Expect(0, 73032, '\p{^Indic_Positional_Category=na}', "");
    Expect(0, 73032, '\P{Indic_Positional_Category=na}', "");
    Expect(1, 73032, '\P{^Indic_Positional_Category=na}', "");
    Expect(0, 73031, '\p{Indic_Positional_Category=na}', "");
    Expect(1, 73031, '\p{^Indic_Positional_Category=na}', "");
    Expect(1, 73031, '\P{Indic_Positional_Category=na}', "");
    Expect(0, 73031, '\P{^Indic_Positional_Category=na}', "");
    Expect(1, 73032, '\p{Indic_Positional_Category= -NA}', "");
    Expect(0, 73032, '\p{^Indic_Positional_Category= -NA}', "");
    Expect(0, 73032, '\P{Indic_Positional_Category= -NA}', "");
    Expect(1, 73032, '\P{^Indic_Positional_Category= -NA}', "");
    Expect(0, 73031, '\p{Indic_Positional_Category= -NA}', "");
    Expect(1, 73031, '\p{^Indic_Positional_Category= -NA}', "");
    Expect(1, 73031, '\P{Indic_Positional_Category= -NA}', "");
    Expect(0, 73031, '\P{^Indic_Positional_Category= -NA}', "");
    Error('\p{InPC:/a/_NA}');
    Error('\P{InPC:/a/_NA}');
    Expect(1, 73032, '\p{InPC=na}', "");
    Expect(0, 73032, '\p{^InPC=na}', "");
    Expect(0, 73032, '\P{InPC=na}', "");
    Expect(1, 73032, '\P{^InPC=na}', "");
    Expect(0, 73031, '\p{InPC=na}', "");
    Expect(1, 73031, '\p{^InPC=na}', "");
    Expect(1, 73031, '\P{InPC=na}', "");
    Expect(0, 73031, '\P{^InPC=na}', "");
    Expect(1, 73032, '\p{InPC=	NA}', "");
    Expect(0, 73032, '\p{^InPC=	NA}', "");
    Expect(0, 73032, '\P{InPC=	NA}', "");
    Expect(1, 73032, '\P{^InPC=	NA}', "");
    Expect(0, 73031, '\p{InPC=	NA}', "");
    Expect(1, 73031, '\p{^InPC=	NA}', "");
    Expect(1, 73031, '\P{InPC=	NA}', "");
    Expect(0, 73031, '\P{^InPC=	NA}', "");
    Error('\p{Is_Indic_Positional_Category=/a/		na}');
    Error('\P{Is_Indic_Positional_Category=/a/		na}');
    Expect(1, 73032, '\p{Is_Indic_Positional_Category=na}', "");
    Expect(0, 73032, '\p{^Is_Indic_Positional_Category=na}', "");
    Expect(0, 73032, '\P{Is_Indic_Positional_Category=na}', "");
    Expect(1, 73032, '\P{^Is_Indic_Positional_Category=na}', "");
    Expect(0, 73031, '\p{Is_Indic_Positional_Category=na}', "");
    Expect(1, 73031, '\p{^Is_Indic_Positional_Category=na}', "");
    Expect(1, 73031, '\P{Is_Indic_Positional_Category=na}', "");
    Expect(0, 73031, '\P{^Is_Indic_Positional_Category=na}', "");
    Expect(1, 73032, '\p{Is_Indic_Positional_Category=__NA}', "");
    Expect(0, 73032, '\p{^Is_Indic_Positional_Category=__NA}', "");
    Expect(0, 73032, '\P{Is_Indic_Positional_Category=__NA}', "");
    Expect(1, 73032, '\P{^Is_Indic_Positional_Category=__NA}', "");
    Expect(0, 73031, '\p{Is_Indic_Positional_Category=__NA}', "");
    Expect(1, 73031, '\p{^Is_Indic_Positional_Category=__NA}', "");
    Expect(1, 73031, '\P{Is_Indic_Positional_Category=__NA}', "");
    Expect(0, 73031, '\P{^Is_Indic_Positional_Category=__NA}', "");
    Error('\p{Is_InPC=- na:=}');
    Error('\P{Is_InPC=- na:=}');
    Expect(1, 73032, '\p{Is_InPC=na}', "");
    Expect(0, 73032, '\p{^Is_InPC=na}', "");
    Expect(0, 73032, '\P{Is_InPC=na}', "");
    Expect(1, 73032, '\P{^Is_InPC=na}', "");
    Expect(0, 73031, '\p{Is_InPC=na}', "");
    Expect(1, 73031, '\p{^Is_InPC=na}', "");
    Expect(1, 73031, '\P{Is_InPC=na}', "");
    Expect(0, 73031, '\P{^Is_InPC=na}', "");
    Expect(1, 73032, '\p{Is_InPC= 	na}', "");
    Expect(0, 73032, '\p{^Is_InPC= 	na}', "");
    Expect(0, 73032, '\P{Is_InPC= 	na}', "");
    Expect(1, 73032, '\P{^Is_InPC= 	na}', "");
    Expect(0, 73031, '\p{Is_InPC= 	na}', "");
    Expect(1, 73031, '\p{^Is_InPC= 	na}', "");
    Expect(1, 73031, '\P{Is_InPC= 	na}', "");
    Expect(0, 73031, '\P{^Is_InPC= 	na}', "");
    Error('\p{Indic_Positional_Category=:=-Overstruck}');
    Error('\P{Indic_Positional_Category=:=-Overstruck}');
    Expect(1, 68102, '\p{Indic_Positional_Category:	overstruck}', "");
    Expect(0, 68102, '\p{^Indic_Positional_Category:	overstruck}', "");
    Expect(0, 68102, '\P{Indic_Positional_Category:	overstruck}', "");
    Expect(1, 68102, '\P{^Indic_Positional_Category:	overstruck}', "");
    Expect(0, 68103, '\p{Indic_Positional_Category:	overstruck}', "");
    Expect(1, 68103, '\p{^Indic_Positional_Category:	overstruck}', "");
    Expect(1, 68103, '\P{Indic_Positional_Category:	overstruck}', "");
    Expect(0, 68103, '\P{^Indic_Positional_Category:	overstruck}', "");
    Expect(1, 68102, '\p{Indic_Positional_Category=- Overstruck}', "");
    Expect(0, 68102, '\p{^Indic_Positional_Category=- Overstruck}', "");
    Expect(0, 68102, '\P{Indic_Positional_Category=- Overstruck}', "");
    Expect(1, 68102, '\P{^Indic_Positional_Category=- Overstruck}', "");
    Expect(0, 68103, '\p{Indic_Positional_Category=- Overstruck}', "");
    Expect(1, 68103, '\p{^Indic_Positional_Category=- Overstruck}', "");
    Expect(1, 68103, '\P{Indic_Positional_Category=- Overstruck}', "");
    Expect(0, 68103, '\P{^Indic_Positional_Category=- Overstruck}', "");
    Error('\p{InPC=	-overstruck:=}');
    Error('\P{InPC=	-overstruck:=}');
    Expect(1, 68102, '\p{InPC=overstruck}', "");
    Expect(0, 68102, '\p{^InPC=overstruck}', "");
    Expect(0, 68102, '\P{InPC=overstruck}', "");
    Expect(1, 68102, '\P{^InPC=overstruck}', "");
    Expect(0, 68103, '\p{InPC=overstruck}', "");
    Expect(1, 68103, '\p{^InPC=overstruck}', "");
    Expect(1, 68103, '\P{InPC=overstruck}', "");
    Expect(0, 68103, '\P{^InPC=overstruck}', "");
    Expect(1, 68102, '\p{InPC= 	overstruck}', "");
    Expect(0, 68102, '\p{^InPC= 	overstruck}', "");
    Expect(0, 68102, '\P{InPC= 	overstruck}', "");
    Expect(1, 68102, '\P{^InPC= 	overstruck}', "");
    Expect(0, 68103, '\p{InPC= 	overstruck}', "");
    Expect(1, 68103, '\p{^InPC= 	overstruck}', "");
    Expect(1, 68103, '\P{InPC= 	overstruck}', "");
    Expect(0, 68103, '\P{^InPC= 	overstruck}', "");
    Error('\p{Is_Indic_Positional_Category=	-OVERSTRUCK:=}');
    Error('\P{Is_Indic_Positional_Category=	-OVERSTRUCK:=}');
    Expect(1, 68102, '\p{Is_Indic_Positional_Category: overstruck}', "");
    Expect(0, 68102, '\p{^Is_Indic_Positional_Category: overstruck}', "");
    Expect(0, 68102, '\P{Is_Indic_Positional_Category: overstruck}', "");
    Expect(1, 68102, '\P{^Is_Indic_Positional_Category: overstruck}', "");
    Expect(0, 68103, '\p{Is_Indic_Positional_Category: overstruck}', "");
    Expect(1, 68103, '\p{^Is_Indic_Positional_Category: overstruck}', "");
    Expect(1, 68103, '\P{Is_Indic_Positional_Category: overstruck}', "");
    Expect(0, 68103, '\P{^Is_Indic_Positional_Category: overstruck}', "");
    Expect(1, 68102, '\p{Is_Indic_Positional_Category= overstruck}', "");
    Expect(0, 68102, '\p{^Is_Indic_Positional_Category= overstruck}', "");
    Expect(0, 68102, '\P{Is_Indic_Positional_Category= overstruck}', "");
    Expect(1, 68102, '\P{^Is_Indic_Positional_Category= overstruck}', "");
    Expect(0, 68103, '\p{Is_Indic_Positional_Category= overstruck}', "");
    Expect(1, 68103, '\p{^Is_Indic_Positional_Category= overstruck}', "");
    Expect(1, 68103, '\P{Is_Indic_Positional_Category= overstruck}', "");
    Expect(0, 68103, '\P{^Is_Indic_Positional_Category= overstruck}', "");
    Error('\p{Is_InPC=:= _OVERSTRUCK}');
    Error('\P{Is_InPC=:= _OVERSTRUCK}');
    Expect(1, 68102, '\p{Is_InPC=overstruck}', "");
    Expect(0, 68102, '\p{^Is_InPC=overstruck}', "");
    Expect(0, 68102, '\P{Is_InPC=overstruck}', "");
    Expect(1, 68102, '\P{^Is_InPC=overstruck}', "");
    Expect(0, 68103, '\p{Is_InPC=overstruck}', "");
    Expect(1, 68103, '\p{^Is_InPC=overstruck}', "");
    Expect(1, 68103, '\P{Is_InPC=overstruck}', "");
    Expect(0, 68103, '\P{^Is_InPC=overstruck}', "");
    Expect(1, 68102, '\p{Is_InPC=_overstruck}', "");
    Expect(0, 68102, '\p{^Is_InPC=_overstruck}', "");
    Expect(0, 68102, '\P{Is_InPC=_overstruck}', "");
    Expect(1, 68102, '\P{^Is_InPC=_overstruck}', "");
    Expect(0, 68103, '\p{Is_InPC=_overstruck}', "");
    Expect(1, 68103, '\p{^Is_InPC=_overstruck}', "");
    Expect(1, 68103, '\P{Is_InPC=_overstruck}', "");
    Expect(0, 68103, '\P{^Is_InPC=_overstruck}', "");
    Error('\p{Indic_Positional_Category=:=Right}');
    Error('\P{Indic_Positional_Category=:=Right}');
    Expect(1, 72884, '\p{Indic_Positional_Category=right}', "");
    Expect(0, 72884, '\p{^Indic_Positional_Category=right}', "");
    Expect(0, 72884, '\P{Indic_Positional_Category=right}', "");
    Expect(1, 72884, '\P{^Indic_Positional_Category=right}', "");
    Expect(0, 72885, '\p{Indic_Positional_Category=right}', "");
    Expect(1, 72885, '\p{^Indic_Positional_Category=right}', "");
    Expect(1, 72885, '\P{Indic_Positional_Category=right}', "");
    Expect(0, 72885, '\P{^Indic_Positional_Category=right}', "");
    Expect(1, 72884, '\p{Indic_Positional_Category=RIGHT}', "");
    Expect(0, 72884, '\p{^Indic_Positional_Category=RIGHT}', "");
    Expect(0, 72884, '\P{Indic_Positional_Category=RIGHT}', "");
    Expect(1, 72884, '\P{^Indic_Positional_Category=RIGHT}', "");
    Expect(0, 72885, '\p{Indic_Positional_Category=RIGHT}', "");
    Expect(1, 72885, '\p{^Indic_Positional_Category=RIGHT}', "");
    Expect(1, 72885, '\P{Indic_Positional_Category=RIGHT}', "");
    Expect(0, 72885, '\P{^Indic_Positional_Category=RIGHT}', "");
    Error('\p{InPC=/a/Right}');
    Error('\P{InPC=/a/Right}');
    Expect(1, 72884, '\p{InPC=right}', "");
    Expect(0, 72884, '\p{^InPC=right}', "");
    Expect(0, 72884, '\P{InPC=right}', "");
    Expect(1, 72884, '\P{^InPC=right}', "");
    Expect(0, 72885, '\p{InPC=right}', "");
    Expect(1, 72885, '\p{^InPC=right}', "");
    Expect(1, 72885, '\P{InPC=right}', "");
    Expect(0, 72885, '\P{^InPC=right}', "");
    Expect(1, 72884, '\p{InPC= RIGHT}', "");
    Expect(0, 72884, '\p{^InPC= RIGHT}', "");
    Expect(0, 72884, '\P{InPC= RIGHT}', "");
    Expect(1, 72884, '\P{^InPC= RIGHT}', "");
    Expect(0, 72885, '\p{InPC= RIGHT}', "");
    Expect(1, 72885, '\p{^InPC= RIGHT}', "");
    Expect(1, 72885, '\P{InPC= RIGHT}', "");
    Expect(0, 72885, '\P{^InPC= RIGHT}', "");
    Error('\p{Is_Indic_Positional_Category=	/a/RIGHT}');
    Error('\P{Is_Indic_Positional_Category=	/a/RIGHT}');
    Expect(1, 72884, '\p{Is_Indic_Positional_Category:   right}', "");
    Expect(0, 72884, '\p{^Is_Indic_Positional_Category:   right}', "");
    Expect(0, 72884, '\P{Is_Indic_Positional_Category:   right}', "");
    Expect(1, 72884, '\P{^Is_Indic_Positional_Category:   right}', "");
    Expect(0, 72885, '\p{Is_Indic_Positional_Category:   right}', "");
    Expect(1, 72885, '\p{^Is_Indic_Positional_Category:   right}', "");
    Expect(1, 72885, '\P{Is_Indic_Positional_Category:   right}', "");
    Expect(0, 72885, '\P{^Is_Indic_Positional_Category:   right}', "");
    Expect(1, 72884, '\p{Is_Indic_Positional_Category= -Right}', "");
    Expect(0, 72884, '\p{^Is_Indic_Positional_Category= -Right}', "");
    Expect(0, 72884, '\P{Is_Indic_Positional_Category= -Right}', "");
    Expect(1, 72884, '\P{^Is_Indic_Positional_Category= -Right}', "");
    Expect(0, 72885, '\p{Is_Indic_Positional_Category= -Right}', "");
    Expect(1, 72885, '\p{^Is_Indic_Positional_Category= -Right}', "");
    Expect(1, 72885, '\P{Is_Indic_Positional_Category= -Right}', "");
    Expect(0, 72885, '\P{^Is_Indic_Positional_Category= -Right}', "");
    Error('\p{Is_InPC=-/a/Right}');
    Error('\P{Is_InPC=-/a/Right}');
    Expect(1, 72884, '\p{Is_InPC=right}', "");
    Expect(0, 72884, '\p{^Is_InPC=right}', "");
    Expect(0, 72884, '\P{Is_InPC=right}', "");
    Expect(1, 72884, '\P{^Is_InPC=right}', "");
    Expect(0, 72885, '\p{Is_InPC=right}', "");
    Expect(1, 72885, '\p{^Is_InPC=right}', "");
    Expect(1, 72885, '\P{Is_InPC=right}', "");
    Expect(0, 72885, '\P{^Is_InPC=right}', "");
    Expect(1, 72884, '\p{Is_InPC= RIGHT}', "");
    Expect(0, 72884, '\p{^Is_InPC= RIGHT}', "");
    Expect(0, 72884, '\P{Is_InPC= RIGHT}', "");
    Expect(1, 72884, '\P{^Is_InPC= RIGHT}', "");
    Expect(0, 72885, '\p{Is_InPC= RIGHT}', "");
    Expect(1, 72885, '\p{^Is_InPC= RIGHT}', "");
    Expect(1, 72885, '\P{Is_InPC= RIGHT}', "");
    Expect(0, 72885, '\P{^Is_InPC= RIGHT}', "");
    Error('\p{Indic_Positional_Category=:=_TOP}');
    Error('\P{Indic_Positional_Category=:=_TOP}');
    Expect(1, 73027, '\p{Indic_Positional_Category:   top}', "");
    Expect(0, 73027, '\p{^Indic_Positional_Category:   top}', "");
    Expect(0, 73027, '\P{Indic_Positional_Category:   top}', "");
    Expect(1, 73027, '\P{^Indic_Positional_Category:   top}', "");
    Expect(0, 73028, '\p{Indic_Positional_Category:   top}', "");
    Expect(1, 73028, '\p{^Indic_Positional_Category:   top}', "");
    Expect(1, 73028, '\P{Indic_Positional_Category:   top}', "");
    Expect(0, 73028, '\P{^Indic_Positional_Category:   top}', "");
    Expect(1, 73027, '\p{Indic_Positional_Category= -TOP}', "");
    Expect(0, 73027, '\p{^Indic_Positional_Category= -TOP}', "");
    Expect(0, 73027, '\P{Indic_Positional_Category= -TOP}', "");
    Expect(1, 73027, '\P{^Indic_Positional_Category= -TOP}', "");
    Expect(0, 73028, '\p{Indic_Positional_Category= -TOP}', "");
    Expect(1, 73028, '\p{^Indic_Positional_Category= -TOP}', "");
    Expect(1, 73028, '\P{Indic_Positional_Category= -TOP}', "");
    Expect(0, 73028, '\P{^Indic_Positional_Category= -TOP}', "");
    Error('\p{InPC= /a/Top}');
    Error('\P{InPC= /a/Top}');
    Expect(1, 73027, '\p{InPC=top}', "");
    Expect(0, 73027, '\p{^InPC=top}', "");
    Expect(0, 73027, '\P{InPC=top}', "");
    Expect(1, 73027, '\P{^InPC=top}', "");
    Expect(0, 73028, '\p{InPC=top}', "");
    Expect(1, 73028, '\p{^InPC=top}', "");
    Expect(1, 73028, '\P{InPC=top}', "");
    Expect(0, 73028, '\P{^InPC=top}', "");
    Expect(1, 73027, '\p{InPC=	top}', "");
    Expect(0, 73027, '\p{^InPC=	top}', "");
    Expect(0, 73027, '\P{InPC=	top}', "");
    Expect(1, 73027, '\P{^InPC=	top}', "");
    Expect(0, 73028, '\p{InPC=	top}', "");
    Expect(1, 73028, '\p{^InPC=	top}', "");
    Expect(1, 73028, '\P{InPC=	top}', "");
    Expect(0, 73028, '\P{^InPC=	top}', "");
    Error('\p{Is_Indic_Positional_Category=/a/-TOP}');
    Error('\P{Is_Indic_Positional_Category=/a/-TOP}');
    Expect(1, 73027, '\p{Is_Indic_Positional_Category=top}', "");
    Expect(0, 73027, '\p{^Is_Indic_Positional_Category=top}', "");
    Expect(0, 73027, '\P{Is_Indic_Positional_Category=top}', "");
    Expect(1, 73027, '\P{^Is_Indic_Positional_Category=top}', "");
    Expect(0, 73028, '\p{Is_Indic_Positional_Category=top}', "");
    Expect(1, 73028, '\p{^Is_Indic_Positional_Category=top}', "");
    Expect(1, 73028, '\P{Is_Indic_Positional_Category=top}', "");
    Expect(0, 73028, '\P{^Is_Indic_Positional_Category=top}', "");
    Expect(1, 73027, '\p{Is_Indic_Positional_Category=- Top}', "");
    Expect(0, 73027, '\p{^Is_Indic_Positional_Category=- Top}', "");
    Expect(0, 73027, '\P{Is_Indic_Positional_Category=- Top}', "");
    Expect(1, 73027, '\P{^Is_Indic_Positional_Category=- Top}', "");
    Expect(0, 73028, '\p{Is_Indic_Positional_Category=- Top}', "");
    Expect(1, 73028, '\p{^Is_Indic_Positional_Category=- Top}', "");
    Expect(1, 73028, '\P{Is_Indic_Positional_Category=- Top}', "");
    Expect(0, 73028, '\P{^Is_Indic_Positional_Category=- Top}', "");
    Error('\p{Is_InPC=	Top:=}');
    Error('\P{Is_InPC=	Top:=}');
    Expect(1, 73027, '\p{Is_InPC=top}', "");
    Expect(0, 73027, '\p{^Is_InPC=top}', "");
    Expect(0, 73027, '\P{Is_InPC=top}', "");
    Expect(1, 73027, '\P{^Is_InPC=top}', "");
    Expect(0, 73028, '\p{Is_InPC=top}', "");
    Expect(1, 73028, '\p{^Is_InPC=top}', "");
    Expect(1, 73028, '\P{Is_InPC=top}', "");
    Expect(0, 73028, '\P{^Is_InPC=top}', "");
    Expect(1, 73027, '\p{Is_InPC=-_Top}', "");
    Expect(0, 73027, '\p{^Is_InPC=-_Top}', "");
    Expect(0, 73027, '\P{Is_InPC=-_Top}', "");
    Expect(1, 73027, '\P{^Is_InPC=-_Top}', "");
    Expect(0, 73028, '\p{Is_InPC=-_Top}', "");
    Expect(1, 73028, '\p{^Is_InPC=-_Top}', "");
    Expect(1, 73028, '\P{Is_InPC=-_Top}', "");
    Expect(0, 73028, '\P{^Is_InPC=-_Top}', "");
    Error('\p{Indic_Positional_Category=:=	Top_And_Bottom}');
    Error('\P{Indic_Positional_Category=:=	Top_And_Bottom}');
    Expect(1, 69935, '\p{Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69935, '\p{^Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69935, '\P{Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69935, '\P{^Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69936, '\p{Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69936, '\p{^Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69936, '\P{Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69936, '\P{^Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69935, '\p{Indic_Positional_Category=- Top_And_Bottom}', "");
    Expect(0, 69935, '\p{^Indic_Positional_Category=- Top_And_Bottom}', "");
    Expect(0, 69935, '\P{Indic_Positional_Category=- Top_And_Bottom}', "");
    Expect(1, 69935, '\P{^Indic_Positional_Category=- Top_And_Bottom}', "");
    Expect(0, 69936, '\p{Indic_Positional_Category=- Top_And_Bottom}', "");
    Expect(1, 69936, '\p{^Indic_Positional_Category=- Top_And_Bottom}', "");
    Expect(1, 69936, '\P{Indic_Positional_Category=- Top_And_Bottom}', "");
    Expect(0, 69936, '\P{^Indic_Positional_Category=- Top_And_Bottom}', "");
    Error('\p{InPC=/a/	-TOP_And_Bottom}');
    Error('\P{InPC=/a/	-TOP_And_Bottom}');
    Expect(1, 69935, '\p{InPC=topandbottom}', "");
    Expect(0, 69935, '\p{^InPC=topandbottom}', "");
    Expect(0, 69935, '\P{InPC=topandbottom}', "");
    Expect(1, 69935, '\P{^InPC=topandbottom}', "");
    Expect(0, 69936, '\p{InPC=topandbottom}', "");
    Expect(1, 69936, '\p{^InPC=topandbottom}', "");
    Expect(1, 69936, '\P{InPC=topandbottom}', "");
    Expect(0, 69936, '\P{^InPC=topandbottom}', "");
    Expect(1, 69935, '\p{InPC=-Top_AND_Bottom}', "");
    Expect(0, 69935, '\p{^InPC=-Top_AND_Bottom}', "");
    Expect(0, 69935, '\P{InPC=-Top_AND_Bottom}', "");
    Expect(1, 69935, '\P{^InPC=-Top_AND_Bottom}', "");
    Expect(0, 69936, '\p{InPC=-Top_AND_Bottom}', "");
    Expect(1, 69936, '\p{^InPC=-Top_AND_Bottom}', "");
    Expect(1, 69936, '\P{InPC=-Top_AND_Bottom}', "");
    Expect(0, 69936, '\P{^InPC=-Top_AND_Bottom}', "");
    Error('\p{Is_Indic_Positional_Category= -Top_AND_bottom/a/}');
    Error('\P{Is_Indic_Positional_Category= -Top_AND_bottom/a/}');
    Expect(1, 69935, '\p{Is_Indic_Positional_Category:topandbottom}', "");
    Expect(0, 69935, '\p{^Is_Indic_Positional_Category:topandbottom}', "");
    Expect(0, 69935, '\P{Is_Indic_Positional_Category:topandbottom}', "");
    Expect(1, 69935, '\P{^Is_Indic_Positional_Category:topandbottom}', "");
    Expect(0, 69936, '\p{Is_Indic_Positional_Category:topandbottom}', "");
    Expect(1, 69936, '\p{^Is_Indic_Positional_Category:topandbottom}', "");
    Expect(1, 69936, '\P{Is_Indic_Positional_Category:topandbottom}', "");
    Expect(0, 69936, '\P{^Is_Indic_Positional_Category:topandbottom}', "");
    Expect(1, 69935, '\p{Is_Indic_Positional_Category=_Top_and_Bottom}', "");
    Expect(0, 69935, '\p{^Is_Indic_Positional_Category=_Top_and_Bottom}', "");
    Expect(0, 69935, '\P{Is_Indic_Positional_Category=_Top_and_Bottom}', "");
    Expect(1, 69935, '\P{^Is_Indic_Positional_Category=_Top_and_Bottom}', "");
    Expect(0, 69936, '\p{Is_Indic_Positional_Category=_Top_and_Bottom}', "");
    Expect(1, 69936, '\p{^Is_Indic_Positional_Category=_Top_and_Bottom}', "");
    Expect(1, 69936, '\P{Is_Indic_Positional_Category=_Top_and_Bottom}', "");
    Expect(0, 69936, '\P{^Is_Indic_Positional_Category=_Top_and_Bottom}', "");
    Error('\p{Is_InPC=-/a/Top_And_Bottom}');
    Error('\P{Is_InPC=-/a/Top_And_Bottom}');
    Expect(1, 69935, '\p{Is_InPC=topandbottom}', "");
    Expect(0, 69935, '\p{^Is_InPC=topandbottom}', "");
    Expect(0, 69935, '\P{Is_InPC=topandbottom}', "");
    Expect(1, 69935, '\P{^Is_InPC=topandbottom}', "");
    Expect(0, 69936, '\p{Is_InPC=topandbottom}', "");
    Expect(1, 69936, '\p{^Is_InPC=topandbottom}', "");
    Expect(1, 69936, '\P{Is_InPC=topandbottom}', "");
    Expect(0, 69936, '\P{^Is_InPC=topandbottom}', "");
    Expect(1, 69935, '\p{Is_InPC=	-TOP_and_bottom}', "");
    Expect(0, 69935, '\p{^Is_InPC=	-TOP_and_bottom}', "");
    Expect(0, 69935, '\P{Is_InPC=	-TOP_and_bottom}', "");
    Expect(1, 69935, '\P{^Is_InPC=	-TOP_and_bottom}', "");
    Expect(0, 69936, '\p{Is_InPC=	-TOP_and_bottom}', "");
    Expect(1, 69936, '\p{^Is_InPC=	-TOP_and_bottom}', "");
    Expect(1, 69936, '\P{Is_InPC=	-TOP_and_bottom}', "");
    Expect(0, 69936, '\P{^Is_InPC=	-TOP_and_bottom}', "");
    Error('\p{Indic_Positional_Category=:= 	Top_And_BOTTOM_and_Right}');
    Error('\P{Indic_Positional_Category=:= 	Top_And_BOTTOM_and_Right}');
    Expect(1, 6973, '\p{Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6973, '\p{^Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6973, '\P{Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6973, '\P{^Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6974, '\p{Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6974, '\p{^Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6974, '\P{Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6974, '\P{^Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6973, '\p{Indic_Positional_Category=-top_and_Bottom_And_right}', "");
    Expect(0, 6973, '\p{^Indic_Positional_Category=-top_and_Bottom_And_right}', "");
    Expect(0, 6973, '\P{Indic_Positional_Category=-top_and_Bottom_And_right}', "");
    Expect(1, 6973, '\P{^Indic_Positional_Category=-top_and_Bottom_And_right}', "");
    Expect(0, 6974, '\p{Indic_Positional_Category=-top_and_Bottom_And_right}', "");
    Expect(1, 6974, '\p{^Indic_Positional_Category=-top_and_Bottom_And_right}', "");
    Expect(1, 6974, '\P{Indic_Positional_Category=-top_and_Bottom_And_right}', "");
    Expect(0, 6974, '\P{^Indic_Positional_Category=-top_and_Bottom_And_right}', "");
    Error('\p{InPC:  :=top_And_Bottom_and_Right}');
    Error('\P{InPC:  :=top_And_Bottom_and_Right}');
    Expect(1, 6973, '\p{InPC=topandbottomandright}', "");
    Expect(0, 6973, '\p{^InPC=topandbottomandright}', "");
    Expect(0, 6973, '\P{InPC=topandbottomandright}', "");
    Expect(1, 6973, '\P{^InPC=topandbottomandright}', "");
    Expect(0, 6974, '\p{InPC=topandbottomandright}', "");
    Expect(1, 6974, '\p{^InPC=topandbottomandright}', "");
    Expect(1, 6974, '\P{InPC=topandbottomandright}', "");
    Expect(0, 6974, '\P{^InPC=topandbottomandright}', "");
    Expect(1, 6973, '\p{InPC=	_Top_And_bottom_And_Right}', "");
    Expect(0, 6973, '\p{^InPC=	_Top_And_bottom_And_Right}', "");
    Expect(0, 6973, '\P{InPC=	_Top_And_bottom_And_Right}', "");
    Expect(1, 6973, '\P{^InPC=	_Top_And_bottom_And_Right}', "");
    Expect(0, 6974, '\p{InPC=	_Top_And_bottom_And_Right}', "");
    Expect(1, 6974, '\p{^InPC=	_Top_And_bottom_And_Right}', "");
    Expect(1, 6974, '\P{InPC=	_Top_And_bottom_And_Right}', "");
    Expect(0, 6974, '\P{^InPC=	_Top_And_bottom_And_Right}', "");
    Error('\p{Is_Indic_Positional_Category=		TOP_and_BOTTOM_And_right/a/}');
    Error('\P{Is_Indic_Positional_Category=		TOP_and_BOTTOM_And_right/a/}');
    Expect(1, 6973, '\p{Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6973, '\p{^Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6973, '\P{Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6973, '\P{^Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6974, '\p{Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6974, '\p{^Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6974, '\P{Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6974, '\P{^Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6973, '\p{Is_Indic_Positional_Category=--top_AND_bottom_AND_right}', "");
    Expect(0, 6973, '\p{^Is_Indic_Positional_Category=--top_AND_bottom_AND_right}', "");
    Expect(0, 6973, '\P{Is_Indic_Positional_Category=--top_AND_bottom_AND_right}', "");
    Expect(1, 6973, '\P{^Is_Indic_Positional_Category=--top_AND_bottom_AND_right}', "");
    Expect(0, 6974, '\p{Is_Indic_Positional_Category=--top_AND_bottom_AND_right}', "");
    Expect(1, 6974, '\p{^Is_Indic_Positional_Category=--top_AND_bottom_AND_right}', "");
    Expect(1, 6974, '\P{Is_Indic_Positional_Category=--top_AND_bottom_AND_right}', "");
    Expect(0, 6974, '\P{^Is_Indic_Positional_Category=--top_AND_bottom_AND_right}', "");
    Error('\p{Is_InPC=/a/_ TOP_And_bottom_and_RIGHT}');
    Error('\P{Is_InPC=/a/_ TOP_And_bottom_and_RIGHT}');
    Expect(1, 6973, '\p{Is_InPC=topandbottomandright}', "");
    Expect(0, 6973, '\p{^Is_InPC=topandbottomandright}', "");
    Expect(0, 6973, '\P{Is_InPC=topandbottomandright}', "");
    Expect(1, 6973, '\P{^Is_InPC=topandbottomandright}', "");
    Expect(0, 6974, '\p{Is_InPC=topandbottomandright}', "");
    Expect(1, 6974, '\p{^Is_InPC=topandbottomandright}', "");
    Expect(1, 6974, '\P{Is_InPC=topandbottomandright}', "");
    Expect(0, 6974, '\P{^Is_InPC=topandbottomandright}', "");
    Expect(1, 6973, '\p{Is_InPC= 	TOP_And_Bottom_And_RIGHT}', "");
    Expect(0, 6973, '\p{^Is_InPC= 	TOP_And_Bottom_And_RIGHT}', "");
    Expect(0, 6973, '\P{Is_InPC= 	TOP_And_Bottom_And_RIGHT}', "");
    Expect(1, 6973, '\P{^Is_InPC= 	TOP_And_Bottom_And_RIGHT}', "");
    Expect(0, 6974, '\p{Is_InPC= 	TOP_And_Bottom_And_RIGHT}', "");
    Expect(1, 6974, '\p{^Is_InPC= 	TOP_And_Bottom_And_RIGHT}', "");
    Expect(1, 6974, '\P{Is_InPC= 	TOP_And_Bottom_And_RIGHT}', "");
    Expect(0, 6974, '\P{^Is_InPC= 	TOP_And_Bottom_And_RIGHT}', "");
    Error('\p{Indic_Positional_Category= 	Top_And_Left:=}');
    Error('\P{Indic_Positional_Category= 	Top_And_Left:=}');
    Expect(1, 71097, '\p{Indic_Positional_Category=topandleft}', "");
    Expect(0, 71097, '\p{^Indic_Positional_Category=topandleft}', "");
    Expect(0, 71097, '\P{Indic_Positional_Category=topandleft}', "");
    Expect(1, 71097, '\P{^Indic_Positional_Category=topandleft}', "");
    Expect(0, 71098, '\p{Indic_Positional_Category=topandleft}', "");
    Expect(1, 71098, '\p{^Indic_Positional_Category=topandleft}', "");
    Expect(1, 71098, '\P{Indic_Positional_Category=topandleft}', "");
    Expect(0, 71098, '\P{^Indic_Positional_Category=topandleft}', "");
    Expect(1, 71097, '\p{Indic_Positional_Category: Top_And_Left}', "");
    Expect(0, 71097, '\p{^Indic_Positional_Category: Top_And_Left}', "");
    Expect(0, 71097, '\P{Indic_Positional_Category: Top_And_Left}', "");
    Expect(1, 71097, '\P{^Indic_Positional_Category: Top_And_Left}', "");
    Expect(0, 71098, '\p{Indic_Positional_Category: Top_And_Left}', "");
    Expect(1, 71098, '\p{^Indic_Positional_Category: Top_And_Left}', "");
    Expect(1, 71098, '\P{Indic_Positional_Category: Top_And_Left}', "");
    Expect(0, 71098, '\P{^Indic_Positional_Category: Top_And_Left}', "");
    Error('\p{InPC=-_Top_and_Left:=}');
    Error('\P{InPC=-_Top_and_Left:=}');
    Expect(1, 71097, '\p{InPC=topandleft}', "");
    Expect(0, 71097, '\p{^InPC=topandleft}', "");
    Expect(0, 71097, '\P{InPC=topandleft}', "");
    Expect(1, 71097, '\P{^InPC=topandleft}', "");
    Expect(0, 71098, '\p{InPC=topandleft}', "");
    Expect(1, 71098, '\p{^InPC=topandleft}', "");
    Expect(1, 71098, '\P{InPC=topandleft}', "");
    Expect(0, 71098, '\P{^InPC=topandleft}', "");
    Expect(1, 71097, '\p{InPC=	-TOP_And_left}', "");
    Expect(0, 71097, '\p{^InPC=	-TOP_And_left}', "");
    Expect(0, 71097, '\P{InPC=	-TOP_And_left}', "");
    Expect(1, 71097, '\P{^InPC=	-TOP_And_left}', "");
    Expect(0, 71098, '\p{InPC=	-TOP_And_left}', "");
    Expect(1, 71098, '\p{^InPC=	-TOP_And_left}', "");
    Expect(1, 71098, '\P{InPC=	-TOP_And_left}', "");
    Expect(0, 71098, '\P{^InPC=	-TOP_And_left}', "");
    Error('\p{Is_Indic_Positional_Category=-_Top_AND_left/a/}');
    Error('\P{Is_Indic_Positional_Category=-_Top_AND_left/a/}');
    Expect(1, 71097, '\p{Is_Indic_Positional_Category=topandleft}', "");
    Expect(0, 71097, '\p{^Is_Indic_Positional_Category=topandleft}', "");
    Expect(0, 71097, '\P{Is_Indic_Positional_Category=topandleft}', "");
    Expect(1, 71097, '\P{^Is_Indic_Positional_Category=topandleft}', "");
    Expect(0, 71098, '\p{Is_Indic_Positional_Category=topandleft}', "");
    Expect(1, 71098, '\p{^Is_Indic_Positional_Category=topandleft}', "");
    Expect(1, 71098, '\P{Is_Indic_Positional_Category=topandleft}', "");
    Expect(0, 71098, '\P{^Is_Indic_Positional_Category=topandleft}', "");
    Expect(1, 71097, '\p{Is_Indic_Positional_Category=-Top_AND_Left}', "");
    Expect(0, 71097, '\p{^Is_Indic_Positional_Category=-Top_AND_Left}', "");
    Expect(0, 71097, '\P{Is_Indic_Positional_Category=-Top_AND_Left}', "");
    Expect(1, 71097, '\P{^Is_Indic_Positional_Category=-Top_AND_Left}', "");
    Expect(0, 71098, '\p{Is_Indic_Positional_Category=-Top_AND_Left}', "");
    Expect(1, 71098, '\p{^Is_Indic_Positional_Category=-Top_AND_Left}', "");
    Expect(1, 71098, '\P{Is_Indic_Positional_Category=-Top_AND_Left}', "");
    Expect(0, 71098, '\P{^Is_Indic_Positional_Category=-Top_AND_Left}', "");
    Error('\p{Is_InPC=__Top_AND_Left/a/}');
    Error('\P{Is_InPC=__Top_AND_Left/a/}');
    Expect(1, 71097, '\p{Is_InPC=topandleft}', "");
    Expect(0, 71097, '\p{^Is_InPC=topandleft}', "");
    Expect(0, 71097, '\P{Is_InPC=topandleft}', "");
    Expect(1, 71097, '\P{^Is_InPC=topandleft}', "");
    Expect(0, 71098, '\p{Is_InPC=topandleft}', "");
    Expect(1, 71098, '\p{^Is_InPC=topandleft}', "");
    Expect(1, 71098, '\P{Is_InPC=topandleft}', "");
    Expect(0, 71098, '\P{^Is_InPC=topandleft}', "");
    Expect(1, 71097, '\p{Is_InPC=_	Top_and_LEFT}', "");
    Expect(0, 71097, '\p{^Is_InPC=_	Top_and_LEFT}', "");
    Expect(0, 71097, '\P{Is_InPC=_	Top_and_LEFT}', "");
    Expect(1, 71097, '\P{^Is_InPC=_	Top_and_LEFT}', "");
    Expect(0, 71098, '\p{Is_InPC=_	Top_and_LEFT}', "");
    Expect(1, 71098, '\p{^Is_InPC=_	Top_and_LEFT}', "");
    Expect(1, 71098, '\P{Is_InPC=_	Top_and_LEFT}', "");
    Expect(0, 71098, '\P{^Is_InPC=_	Top_and_LEFT}', "");
    Error('\p{Indic_Positional_Category=- top_AND_Left_And_Right:=}');
    Error('\P{Indic_Positional_Category=- top_AND_Left_And_Right:=}');
    Expect(1, 71099, '\p{Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71099, '\p{^Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71099, '\P{Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71099, '\P{^Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71100, '\p{Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71100, '\p{^Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71100, '\P{Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71100, '\P{^Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71099, '\p{Indic_Positional_Category=_-TOP_AND_Left_and_Right}', "");
    Expect(0, 71099, '\p{^Indic_Positional_Category=_-TOP_AND_Left_and_Right}', "");
    Expect(0, 71099, '\P{Indic_Positional_Category=_-TOP_AND_Left_and_Right}', "");
    Expect(1, 71099, '\P{^Indic_Positional_Category=_-TOP_AND_Left_and_Right}', "");
    Expect(0, 71100, '\p{Indic_Positional_Category=_-TOP_AND_Left_and_Right}', "");
    Expect(1, 71100, '\p{^Indic_Positional_Category=_-TOP_AND_Left_and_Right}', "");
    Expect(1, 71100, '\P{Indic_Positional_Category=_-TOP_AND_Left_and_Right}', "");
    Expect(0, 71100, '\P{^Indic_Positional_Category=_-TOP_AND_Left_and_Right}', "");
    Error('\p{InPC=/a/top_and_Left_and_RIGHT}');
    Error('\P{InPC=/a/top_and_Left_and_RIGHT}');
    Expect(1, 71099, '\p{InPC=topandleftandright}', "");
    Expect(0, 71099, '\p{^InPC=topandleftandright}', "");
    Expect(0, 71099, '\P{InPC=topandleftandright}', "");
    Expect(1, 71099, '\P{^InPC=topandleftandright}', "");
    Expect(0, 71100, '\p{InPC=topandleftandright}', "");
    Expect(1, 71100, '\p{^InPC=topandleftandright}', "");
    Expect(1, 71100, '\P{InPC=topandleftandright}', "");
    Expect(0, 71100, '\P{^InPC=topandleftandright}', "");
    Expect(1, 71099, '\p{InPC=--Top_and_left_And_right}', "");
    Expect(0, 71099, '\p{^InPC=--Top_and_left_And_right}', "");
    Expect(0, 71099, '\P{InPC=--Top_and_left_And_right}', "");
    Expect(1, 71099, '\P{^InPC=--Top_and_left_And_right}', "");
    Expect(0, 71100, '\p{InPC=--Top_and_left_And_right}', "");
    Expect(1, 71100, '\p{^InPC=--Top_and_left_And_right}', "");
    Expect(1, 71100, '\P{InPC=--Top_and_left_And_right}', "");
    Expect(0, 71100, '\P{^InPC=--Top_and_left_And_right}', "");
    Error('\p{Is_Indic_Positional_Category=/a/	Top_And_left_AND_Right}');
    Error('\P{Is_Indic_Positional_Category=/a/	Top_And_left_AND_Right}');
    Expect(1, 71099, '\p{Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71099, '\p{^Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71099, '\P{Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71099, '\P{^Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71100, '\p{Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71100, '\p{^Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71100, '\P{Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71100, '\P{^Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71099, '\p{Is_Indic_Positional_Category= _Top_And_Left_and_Right}', "");
    Expect(0, 71099, '\p{^Is_Indic_Positional_Category= _Top_And_Left_and_Right}', "");
    Expect(0, 71099, '\P{Is_Indic_Positional_Category= _Top_And_Left_and_Right}', "");
    Expect(1, 71099, '\P{^Is_Indic_Positional_Category= _Top_And_Left_and_Right}', "");
    Expect(0, 71100, '\p{Is_Indic_Positional_Category= _Top_And_Left_and_Right}', "");
    Expect(1, 71100, '\p{^Is_Indic_Positional_Category= _Top_And_Left_and_Right}', "");
    Expect(1, 71100, '\P{Is_Indic_Positional_Category= _Top_And_Left_and_Right}', "");
    Expect(0, 71100, '\P{^Is_Indic_Positional_Category= _Top_And_Left_and_Right}', "");
    Error('\p{Is_InPC::= TOP_And_Left_And_right}');
    Error('\P{Is_InPC::= TOP_And_Left_And_right}');
    Expect(1, 71099, '\p{Is_InPC=topandleftandright}', "");
    Expect(0, 71099, '\p{^Is_InPC=topandleftandright}', "");
    Expect(0, 71099, '\P{Is_InPC=topandleftandright}', "");
    Expect(1, 71099, '\P{^Is_InPC=topandleftandright}', "");
    Expect(0, 71100, '\p{Is_InPC=topandleftandright}', "");
    Expect(1, 71100, '\p{^Is_InPC=topandleftandright}', "");
    Expect(1, 71100, '\P{Is_InPC=topandleftandright}', "");
    Expect(0, 71100, '\P{^Is_InPC=topandleftandright}', "");
    Expect(1, 71099, '\p{Is_InPC=_-TOP_AND_Left_And_Right}', "");
    Expect(0, 71099, '\p{^Is_InPC=_-TOP_AND_Left_And_Right}', "");
    Expect(0, 71099, '\P{Is_InPC=_-TOP_AND_Left_And_Right}', "");
    Expect(1, 71099, '\P{^Is_InPC=_-TOP_AND_Left_And_Right}', "");
    Expect(0, 71100, '\p{Is_InPC=_-TOP_AND_Left_And_Right}', "");
    Expect(1, 71100, '\p{^Is_InPC=_-TOP_AND_Left_And_Right}', "");
    Expect(1, 71100, '\P{Is_InPC=_-TOP_AND_Left_And_Right}', "");
    Expect(0, 71100, '\P{^Is_InPC=_-TOP_AND_Left_And_Right}', "");
    Error('\p{Indic_Positional_Category=/a/TOP_AND_right}');
    Error('\P{Indic_Positional_Category=/a/TOP_AND_right}');
    Expect(1, 70195, '\p{Indic_Positional_Category=topandright}', "");
    Expect(0, 70195, '\p{^Indic_Positional_Category=topandright}', "");
    Expect(0, 70195, '\P{Indic_Positional_Category=topandright}', "");
    Expect(1, 70195, '\P{^Indic_Positional_Category=topandright}', "");
    Expect(0, 70196, '\p{Indic_Positional_Category=topandright}', "");
    Expect(1, 70196, '\p{^Indic_Positional_Category=topandright}', "");
    Expect(1, 70196, '\P{Indic_Positional_Category=topandright}', "");
    Expect(0, 70196, '\P{^Indic_Positional_Category=topandright}', "");
    Expect(1, 70195, '\p{Indic_Positional_Category=Top_And_Right}', "");
    Expect(0, 70195, '\p{^Indic_Positional_Category=Top_And_Right}', "");
    Expect(0, 70195, '\P{Indic_Positional_Category=Top_And_Right}', "");
    Expect(1, 70195, '\P{^Indic_Positional_Category=Top_And_Right}', "");
    Expect(0, 70196, '\p{Indic_Positional_Category=Top_And_Right}', "");
    Expect(1, 70196, '\p{^Indic_Positional_Category=Top_And_Right}', "");
    Expect(1, 70196, '\P{Indic_Positional_Category=Top_And_Right}', "");
    Expect(0, 70196, '\P{^Indic_Positional_Category=Top_And_Right}', "");
    Error('\p{InPC=-top_And_RIGHT:=}');
    Error('\P{InPC=-top_And_RIGHT:=}');
    Expect(1, 70195, '\p{InPC=topandright}', "");
    Expect(0, 70195, '\p{^InPC=topandright}', "");
    Expect(0, 70195, '\P{InPC=topandright}', "");
    Expect(1, 70195, '\P{^InPC=topandright}', "");
    Expect(0, 70196, '\p{InPC=topandright}', "");
    Expect(1, 70196, '\p{^InPC=topandright}', "");
    Expect(1, 70196, '\P{InPC=topandright}', "");
    Expect(0, 70196, '\P{^InPC=topandright}', "");
    Expect(1, 70195, '\p{InPC=	TOP_And_Right}', "");
    Expect(0, 70195, '\p{^InPC=	TOP_And_Right}', "");
    Expect(0, 70195, '\P{InPC=	TOP_And_Right}', "");
    Expect(1, 70195, '\P{^InPC=	TOP_And_Right}', "");
    Expect(0, 70196, '\p{InPC=	TOP_And_Right}', "");
    Expect(1, 70196, '\p{^InPC=	TOP_And_Right}', "");
    Expect(1, 70196, '\P{InPC=	TOP_And_Right}', "");
    Expect(0, 70196, '\P{^InPC=	TOP_And_Right}', "");
    Error('\p{Is_Indic_Positional_Category=		top_and_right/a/}');
    Error('\P{Is_Indic_Positional_Category=		top_and_right/a/}');
    Expect(1, 70195, '\p{Is_Indic_Positional_Category=topandright}', "");
    Expect(0, 70195, '\p{^Is_Indic_Positional_Category=topandright}', "");
    Expect(0, 70195, '\P{Is_Indic_Positional_Category=topandright}', "");
    Expect(1, 70195, '\P{^Is_Indic_Positional_Category=topandright}', "");
    Expect(0, 70196, '\p{Is_Indic_Positional_Category=topandright}', "");
    Expect(1, 70196, '\p{^Is_Indic_Positional_Category=topandright}', "");
    Expect(1, 70196, '\P{Is_Indic_Positional_Category=topandright}', "");
    Expect(0, 70196, '\P{^Is_Indic_Positional_Category=topandright}', "");
    Expect(1, 70195, '\p{Is_Indic_Positional_Category= 	Top_AND_Right}', "");
    Expect(0, 70195, '\p{^Is_Indic_Positional_Category= 	Top_AND_Right}', "");
    Expect(0, 70195, '\P{Is_Indic_Positional_Category= 	Top_AND_Right}', "");
    Expect(1, 70195, '\P{^Is_Indic_Positional_Category= 	Top_AND_Right}', "");
    Expect(0, 70196, '\p{Is_Indic_Positional_Category= 	Top_AND_Right}', "");
    Expect(1, 70196, '\p{^Is_Indic_Positional_Category= 	Top_AND_Right}', "");
    Expect(1, 70196, '\P{Is_Indic_Positional_Category= 	Top_AND_Right}', "");
    Expect(0, 70196, '\P{^Is_Indic_Positional_Category= 	Top_AND_Right}', "");
    Error('\p{Is_InPC:-	top_AND_right:=}');
    Error('\P{Is_InPC:-	top_AND_right:=}');
    Expect(1, 70195, '\p{Is_InPC=topandright}', "");
    Expect(0, 70195, '\p{^Is_InPC=topandright}', "");
    Expect(0, 70195, '\P{Is_InPC=topandright}', "");
    Expect(1, 70195, '\P{^Is_InPC=topandright}', "");
    Expect(0, 70196, '\p{Is_InPC=topandright}', "");
    Expect(1, 70196, '\p{^Is_InPC=topandright}', "");
    Expect(1, 70196, '\P{Is_InPC=topandright}', "");
    Expect(0, 70196, '\P{^Is_InPC=topandright}', "");
    Expect(1, 70195, '\p{Is_InPC=-_Top_AND_RIGHT}', "");
    Expect(0, 70195, '\p{^Is_InPC=-_Top_AND_RIGHT}', "");
    Expect(0, 70195, '\P{Is_InPC=-_Top_AND_RIGHT}', "");
    Expect(1, 70195, '\P{^Is_InPC=-_Top_AND_RIGHT}', "");
    Expect(0, 70196, '\p{Is_InPC=-_Top_AND_RIGHT}', "");
    Expect(1, 70196, '\p{^Is_InPC=-_Top_AND_RIGHT}', "");
    Expect(1, 70196, '\P{Is_InPC=-_Top_AND_RIGHT}', "");
    Expect(0, 70196, '\P{^Is_InPC=-_Top_AND_RIGHT}', "");
    Error('\p{Indic_Positional_Category:-	Visual_Order_LEFT:=}');
    Error('\P{Indic_Positional_Category:-	Visual_Order_LEFT:=}');
    Expect(1, 43708, '\p{Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43708, '\p{^Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43708, '\P{Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43708, '\P{^Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43709, '\p{Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43709, '\p{^Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43709, '\P{Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43709, '\P{^Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43708, '\p{Indic_Positional_Category=-	Visual_Order_left}', "");
    Expect(0, 43708, '\p{^Indic_Positional_Category=-	Visual_Order_left}', "");
    Expect(0, 43708, '\P{Indic_Positional_Category=-	Visual_Order_left}', "");
    Expect(1, 43708, '\P{^Indic_Positional_Category=-	Visual_Order_left}', "");
    Expect(0, 43709, '\p{Indic_Positional_Category=-	Visual_Order_left}', "");
    Expect(1, 43709, '\p{^Indic_Positional_Category=-	Visual_Order_left}', "");
    Expect(1, 43709, '\P{Indic_Positional_Category=-	Visual_Order_left}', "");
    Expect(0, 43709, '\P{^Indic_Positional_Category=-	Visual_Order_left}', "");
    Error('\p{InPC=/a/_-Visual_ORDER_LEFT}');
    Error('\P{InPC=/a/_-Visual_ORDER_LEFT}');
    Expect(1, 43708, '\p{InPC=visualorderleft}', "");
    Expect(0, 43708, '\p{^InPC=visualorderleft}', "");
    Expect(0, 43708, '\P{InPC=visualorderleft}', "");
    Expect(1, 43708, '\P{^InPC=visualorderleft}', "");
    Expect(0, 43709, '\p{InPC=visualorderleft}', "");
    Expect(1, 43709, '\p{^InPC=visualorderleft}', "");
    Expect(1, 43709, '\P{InPC=visualorderleft}', "");
    Expect(0, 43709, '\P{^InPC=visualorderleft}', "");
    Expect(1, 43708, '\p{InPC=	-Visual_Order_left}', "");
    Expect(0, 43708, '\p{^InPC=	-Visual_Order_left}', "");
    Expect(0, 43708, '\P{InPC=	-Visual_Order_left}', "");
    Expect(1, 43708, '\P{^InPC=	-Visual_Order_left}', "");
    Expect(0, 43709, '\p{InPC=	-Visual_Order_left}', "");
    Expect(1, 43709, '\p{^InPC=	-Visual_Order_left}', "");
    Expect(1, 43709, '\P{InPC=	-Visual_Order_left}', "");
    Expect(0, 43709, '\P{^InPC=	-Visual_Order_left}', "");
    Error('\p{Is_Indic_Positional_Category=-/a/Visual_order_Left}');
    Error('\P{Is_Indic_Positional_Category=-/a/Visual_order_Left}');
    Expect(1, 43708, '\p{Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43708, '\p{^Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43708, '\P{Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43708, '\P{^Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43709, '\p{Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43709, '\p{^Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43709, '\P{Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43709, '\P{^Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43708, '\p{Is_Indic_Positional_Category= -Visual_Order_Left}', "");
    Expect(0, 43708, '\p{^Is_Indic_Positional_Category= -Visual_Order_Left}', "");
    Expect(0, 43708, '\P{Is_Indic_Positional_Category= -Visual_Order_Left}', "");
    Expect(1, 43708, '\P{^Is_Indic_Positional_Category= -Visual_Order_Left}', "");
    Expect(0, 43709, '\p{Is_Indic_Positional_Category= -Visual_Order_Left}', "");
    Expect(1, 43709, '\p{^Is_Indic_Positional_Category= -Visual_Order_Left}', "");
    Expect(1, 43709, '\P{Is_Indic_Positional_Category= -Visual_Order_Left}', "");
    Expect(0, 43709, '\P{^Is_Indic_Positional_Category= -Visual_Order_Left}', "");
    Error('\p{Is_InPC=/a/  VISUAL_order_left}');
    Error('\P{Is_InPC=/a/  VISUAL_order_left}');
    Expect(1, 43708, '\p{Is_InPC:visualorderleft}', "");
    Expect(0, 43708, '\p{^Is_InPC:visualorderleft}', "");
    Expect(0, 43708, '\P{Is_InPC:visualorderleft}', "");
    Expect(1, 43708, '\P{^Is_InPC:visualorderleft}', "");
    Expect(0, 43709, '\p{Is_InPC:visualorderleft}', "");
    Expect(1, 43709, '\p{^Is_InPC:visualorderleft}', "");
    Expect(1, 43709, '\P{Is_InPC:visualorderleft}', "");
    Expect(0, 43709, '\P{^Is_InPC:visualorderleft}', "");
    Expect(1, 43708, '\p{Is_InPC=  VISUAL_Order_Left}', "");
    Expect(0, 43708, '\p{^Is_InPC=  VISUAL_Order_Left}', "");
    Expect(0, 43708, '\P{Is_InPC=  VISUAL_Order_Left}', "");
    Expect(1, 43708, '\P{^Is_InPC=  VISUAL_Order_Left}', "");
    Expect(0, 43709, '\p{Is_InPC=  VISUAL_Order_Left}', "");
    Expect(1, 43709, '\p{^Is_InPC=  VISUAL_Order_Left}', "");
    Expect(1, 43709, '\P{Is_InPC=  VISUAL_Order_Left}', "");
    Expect(0, 43709, '\P{^Is_InPC=  VISUAL_Order_Left}', "");
    Error('\p{indicsyllabiccategory}');
    Error('\P{indicsyllabiccategory}');
    Error('\p{insc}');
    Error('\P{insc}');
    Error('\p{Indic_Syllabic_Category=-avagraha:=}');
    Error('\P{Indic_Syllabic_Category=-avagraha:=}');
    Expect(1, 72768, '\p{Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72768, '\p{^Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72768, '\P{Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72768, '\P{^Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72769, '\p{Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72769, '\p{^Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72769, '\P{Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72769, '\P{^Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72768, '\p{Indic_Syllabic_Category=--AVAGRAHA}', "");
    Expect(0, 72768, '\p{^Indic_Syllabic_Category=--AVAGRAHA}', "");
    Expect(0, 72768, '\P{Indic_Syllabic_Category=--AVAGRAHA}', "");
    Expect(1, 72768, '\P{^Indic_Syllabic_Category=--AVAGRAHA}', "");
    Expect(0, 72769, '\p{Indic_Syllabic_Category=--AVAGRAHA}', "");
    Expect(1, 72769, '\p{^Indic_Syllabic_Category=--AVAGRAHA}', "");
    Expect(1, 72769, '\P{Indic_Syllabic_Category=--AVAGRAHA}', "");
    Expect(0, 72769, '\P{^Indic_Syllabic_Category=--AVAGRAHA}', "");
    Error('\p{InSC= _avagraha:=}');
    Error('\P{InSC= _avagraha:=}');
    Expect(1, 72768, '\p{InSC=avagraha}', "");
    Expect(0, 72768, '\p{^InSC=avagraha}', "");
    Expect(0, 72768, '\P{InSC=avagraha}', "");
    Expect(1, 72768, '\P{^InSC=avagraha}', "");
    Expect(0, 72769, '\p{InSC=avagraha}', "");
    Expect(1, 72769, '\p{^InSC=avagraha}', "");
    Expect(1, 72769, '\P{InSC=avagraha}', "");
    Expect(0, 72769, '\P{^InSC=avagraha}', "");
    Expect(1, 72768, '\p{InSC= -Avagraha}', "");
    Expect(0, 72768, '\p{^InSC= -Avagraha}', "");
    Expect(0, 72768, '\P{InSC= -Avagraha}', "");
    Expect(1, 72768, '\P{^InSC= -Avagraha}', "");
    Expect(0, 72769, '\p{InSC= -Avagraha}', "");
    Expect(1, 72769, '\p{^InSC= -Avagraha}', "");
    Expect(1, 72769, '\P{InSC= -Avagraha}', "");
    Expect(0, 72769, '\P{^InSC= -Avagraha}', "");
    Error('\p{Is_Indic_Syllabic_Category=	 Avagraha/a/}');
    Error('\P{Is_Indic_Syllabic_Category=	 Avagraha/a/}');
    Expect(1, 72768, '\p{Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72768, '\p{^Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72768, '\P{Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72768, '\P{^Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72769, '\p{Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72769, '\p{^Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72769, '\P{Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72769, '\P{^Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72768, '\p{Is_Indic_Syllabic_Category=	-AVAGRAHA}', "");
    Expect(0, 72768, '\p{^Is_Indic_Syllabic_Category=	-AVAGRAHA}', "");
    Expect(0, 72768, '\P{Is_Indic_Syllabic_Category=	-AVAGRAHA}', "");
    Expect(1, 72768, '\P{^Is_Indic_Syllabic_Category=	-AVAGRAHA}', "");
    Expect(0, 72769, '\p{Is_Indic_Syllabic_Category=	-AVAGRAHA}', "");
    Expect(1, 72769, '\p{^Is_Indic_Syllabic_Category=	-AVAGRAHA}', "");
    Expect(1, 72769, '\P{Is_Indic_Syllabic_Category=	-AVAGRAHA}', "");
    Expect(0, 72769, '\P{^Is_Indic_Syllabic_Category=	-AVAGRAHA}', "");
    Error('\p{Is_InSC=/a/ AVAGRAHA}');
    Error('\P{Is_InSC=/a/ AVAGRAHA}');
    Expect(1, 72768, '\p{Is_InSC=avagraha}', "");
    Expect(0, 72768, '\p{^Is_InSC=avagraha}', "");
    Expect(0, 72768, '\P{Is_InSC=avagraha}', "");
    Expect(1, 72768, '\P{^Is_InSC=avagraha}', "");
    Expect(0, 72769, '\p{Is_InSC=avagraha}', "");
    Expect(1, 72769, '\p{^Is_InSC=avagraha}', "");
    Expect(1, 72769, '\P{Is_InSC=avagraha}', "");
    Expect(0, 72769, '\P{^Is_InSC=avagraha}', "");
    Expect(1, 72768, '\p{Is_InSC=-Avagraha}', "");
    Expect(0, 72768, '\p{^Is_InSC=-Avagraha}', "");
    Expect(0, 72768, '\P{Is_InSC=-Avagraha}', "");
    Expect(1, 72768, '\P{^Is_InSC=-Avagraha}', "");
    Expect(0, 72769, '\p{Is_InSC=-Avagraha}', "");
    Expect(1, 72769, '\p{^Is_InSC=-Avagraha}', "");
    Expect(1, 72769, '\P{Is_InSC=-Avagraha}', "");
    Expect(0, 72769, '\P{^Is_InSC=-Avagraha}', "");
    Error('\p{Indic_Syllabic_Category=/a/	 BINDU}');
    Error('\P{Indic_Syllabic_Category=/a/	 BINDU}');
    Expect(1, 73024, '\p{Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73024, '\p{^Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73024, '\P{Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73024, '\P{^Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73025, '\p{Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73025, '\p{^Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73025, '\P{Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73025, '\P{^Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73024, '\p{Indic_Syllabic_Category:   -	Bindu}', "");
    Expect(0, 73024, '\p{^Indic_Syllabic_Category:   -	Bindu}', "");
    Expect(0, 73024, '\P{Indic_Syllabic_Category:   -	Bindu}', "");
    Expect(1, 73024, '\P{^Indic_Syllabic_Category:   -	Bindu}', "");
    Expect(0, 73025, '\p{Indic_Syllabic_Category:   -	Bindu}', "");
    Expect(1, 73025, '\p{^Indic_Syllabic_Category:   -	Bindu}', "");
    Expect(1, 73025, '\P{Indic_Syllabic_Category:   -	Bindu}', "");
    Expect(0, 73025, '\P{^Indic_Syllabic_Category:   -	Bindu}', "");
    Error('\p{InSC=/a/ _Bindu}');
    Error('\P{InSC=/a/ _Bindu}');
    Expect(1, 73024, '\p{InSC=bindu}', "");
    Expect(0, 73024, '\p{^InSC=bindu}', "");
    Expect(0, 73024, '\P{InSC=bindu}', "");
    Expect(1, 73024, '\P{^InSC=bindu}', "");
    Expect(0, 73025, '\p{InSC=bindu}', "");
    Expect(1, 73025, '\p{^InSC=bindu}', "");
    Expect(1, 73025, '\P{InSC=bindu}', "");
    Expect(0, 73025, '\P{^InSC=bindu}', "");
    Expect(1, 73024, '\p{InSC=	-Bindu}', "");
    Expect(0, 73024, '\p{^InSC=	-Bindu}', "");
    Expect(0, 73024, '\P{InSC=	-Bindu}', "");
    Expect(1, 73024, '\P{^InSC=	-Bindu}', "");
    Expect(0, 73025, '\p{InSC=	-Bindu}', "");
    Expect(1, 73025, '\p{^InSC=	-Bindu}', "");
    Expect(1, 73025, '\P{InSC=	-Bindu}', "");
    Expect(0, 73025, '\P{^InSC=	-Bindu}', "");
    Error('\p{Is_Indic_Syllabic_Category=_/a/Bindu}');
    Error('\P{Is_Indic_Syllabic_Category=_/a/Bindu}');
    Expect(1, 73024, '\p{Is_Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73024, '\p{^Is_Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73024, '\P{Is_Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73024, '\P{^Is_Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73025, '\p{Is_Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73025, '\p{^Is_Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73025, '\P{Is_Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73025, '\P{^Is_Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73024, '\p{Is_Indic_Syllabic_Category=--Bindu}', "");
    Expect(0, 73024, '\p{^Is_Indic_Syllabic_Category=--Bindu}', "");
    Expect(0, 73024, '\P{Is_Indic_Syllabic_Category=--Bindu}', "");
    Expect(1, 73024, '\P{^Is_Indic_Syllabic_Category=--Bindu}', "");
    Expect(0, 73025, '\p{Is_Indic_Syllabic_Category=--Bindu}', "");
    Expect(1, 73025, '\p{^Is_Indic_Syllabic_Category=--Bindu}', "");
    Expect(1, 73025, '\P{Is_Indic_Syllabic_Category=--Bindu}', "");
    Expect(0, 73025, '\P{^Is_Indic_Syllabic_Category=--Bindu}', "");
    Error('\p{Is_InSC=	 Bindu:=}');
    Error('\P{Is_InSC=	 Bindu:=}');
    Expect(1, 73024, '\p{Is_InSC=bindu}', "");
    Expect(0, 73024, '\p{^Is_InSC=bindu}', "");
    Expect(0, 73024, '\P{Is_InSC=bindu}', "");
    Expect(1, 73024, '\P{^Is_InSC=bindu}', "");
    Expect(0, 73025, '\p{Is_InSC=bindu}', "");
    Expect(1, 73025, '\p{^Is_InSC=bindu}', "");
    Expect(1, 73025, '\P{Is_InSC=bindu}', "");
    Expect(0, 73025, '\P{^Is_InSC=bindu}', "");
    Expect(1, 73024, '\p{Is_InSC=- Bindu}', "");
    Expect(0, 73024, '\p{^Is_InSC=- Bindu}', "");
    Expect(0, 73024, '\P{Is_InSC=- Bindu}', "");
    Expect(1, 73024, '\P{^Is_InSC=- Bindu}', "");
    Expect(0, 73025, '\p{Is_InSC=- Bindu}', "");
    Expect(1, 73025, '\p{^Is_InSC=- Bindu}', "");
    Expect(1, 73025, '\P{Is_InSC=- Bindu}', "");
    Expect(0, 73025, '\P{^Is_InSC=- Bindu}', "");
    Error('\p{Indic_Syllabic_Category:	_brahmi_joining_NUMBER/a/}');
    Error('\P{Indic_Syllabic_Category:	_brahmi_joining_NUMBER/a/}');
    Expect(1, 69733, '\p{Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69733, '\p{^Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69733, '\P{Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69733, '\P{^Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69734, '\p{Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69734, '\p{^Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69734, '\P{Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69734, '\P{^Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69733, '\p{Indic_Syllabic_Category=		Brahmi_Joining_NUMBER}', "");
    Expect(0, 69733, '\p{^Indic_Syllabic_Category=		Brahmi_Joining_NUMBER}', "");
    Expect(0, 69733, '\P{Indic_Syllabic_Category=		Brahmi_Joining_NUMBER}', "");
    Expect(1, 69733, '\P{^Indic_Syllabic_Category=		Brahmi_Joining_NUMBER}', "");
    Expect(0, 69734, '\p{Indic_Syllabic_Category=		Brahmi_Joining_NUMBER}', "");
    Expect(1, 69734, '\p{^Indic_Syllabic_Category=		Brahmi_Joining_NUMBER}', "");
    Expect(1, 69734, '\P{Indic_Syllabic_Category=		Brahmi_Joining_NUMBER}', "");
    Expect(0, 69734, '\P{^Indic_Syllabic_Category=		Brahmi_Joining_NUMBER}', "");
    Error('\p{InSC=_:=brahmi_JOINING_Number}');
    Error('\P{InSC=_:=brahmi_JOINING_Number}');
    Expect(1, 69733, '\p{InSC=brahmijoiningnumber}', "");
    Expect(0, 69733, '\p{^InSC=brahmijoiningnumber}', "");
    Expect(0, 69733, '\P{InSC=brahmijoiningnumber}', "");
    Expect(1, 69733, '\P{^InSC=brahmijoiningnumber}', "");
    Expect(0, 69734, '\p{InSC=brahmijoiningnumber}', "");
    Expect(1, 69734, '\p{^InSC=brahmijoiningnumber}', "");
    Expect(1, 69734, '\P{InSC=brahmijoiningnumber}', "");
    Expect(0, 69734, '\P{^InSC=brahmijoiningnumber}', "");
    Expect(1, 69733, '\p{InSC=-BRAHMI_Joining_Number}', "");
    Expect(0, 69733, '\p{^InSC=-BRAHMI_Joining_Number}', "");
    Expect(0, 69733, '\P{InSC=-BRAHMI_Joining_Number}', "");
    Expect(1, 69733, '\P{^InSC=-BRAHMI_Joining_Number}', "");
    Expect(0, 69734, '\p{InSC=-BRAHMI_Joining_Number}', "");
    Expect(1, 69734, '\p{^InSC=-BRAHMI_Joining_Number}', "");
    Expect(1, 69734, '\P{InSC=-BRAHMI_Joining_Number}', "");
    Expect(0, 69734, '\P{^InSC=-BRAHMI_Joining_Number}', "");
    Error('\p{Is_Indic_Syllabic_Category=/a/-	Brahmi_JOINING_number}');
    Error('\P{Is_Indic_Syllabic_Category=/a/-	Brahmi_JOINING_number}');
    Expect(1, 69733, '\p{Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69733, '\p{^Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69733, '\P{Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69733, '\P{^Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69734, '\p{Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69734, '\p{^Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69734, '\P{Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69734, '\P{^Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69733, '\p{Is_Indic_Syllabic_Category:   BRAHMI_joining_number}', "");
    Expect(0, 69733, '\p{^Is_Indic_Syllabic_Category:   BRAHMI_joining_number}', "");
    Expect(0, 69733, '\P{Is_Indic_Syllabic_Category:   BRAHMI_joining_number}', "");
    Expect(1, 69733, '\P{^Is_Indic_Syllabic_Category:   BRAHMI_joining_number}', "");
    Expect(0, 69734, '\p{Is_Indic_Syllabic_Category:   BRAHMI_joining_number}', "");
    Expect(1, 69734, '\p{^Is_Indic_Syllabic_Category:   BRAHMI_joining_number}', "");
    Expect(1, 69734, '\P{Is_Indic_Syllabic_Category:   BRAHMI_joining_number}', "");
    Expect(0, 69734, '\P{^Is_Indic_Syllabic_Category:   BRAHMI_joining_number}', "");
    Error('\p{Is_InSC=  brahmi_JOINING_number:=}');
    Error('\P{Is_InSC=  brahmi_JOINING_number:=}');
    Expect(1, 69733, '\p{Is_InSC=brahmijoiningnumber}', "");
    Expect(0, 69733, '\p{^Is_InSC=brahmijoiningnumber}', "");
    Expect(0, 69733, '\P{Is_InSC=brahmijoiningnumber}', "");
    Expect(1, 69733, '\P{^Is_InSC=brahmijoiningnumber}', "");
    Expect(0, 69734, '\p{Is_InSC=brahmijoiningnumber}', "");
    Expect(1, 69734, '\p{^Is_InSC=brahmijoiningnumber}', "");
    Expect(1, 69734, '\P{Is_InSC=brahmijoiningnumber}', "");
    Expect(0, 69734, '\P{^Is_InSC=brahmijoiningnumber}', "");
    Expect(1, 69733, '\p{Is_InSC=  Brahmi_JOINING_Number}', "");
    Expect(0, 69733, '\p{^Is_InSC=  Brahmi_JOINING_Number}', "");
    Expect(0, 69733, '\P{Is_InSC=  Brahmi_JOINING_Number}', "");
    Expect(1, 69733, '\P{^Is_InSC=  Brahmi_JOINING_Number}', "");
    Expect(0, 69734, '\p{Is_InSC=  Brahmi_JOINING_Number}', "");
    Expect(1, 69734, '\p{^Is_InSC=  Brahmi_JOINING_Number}', "");
    Expect(1, 69734, '\P{Is_InSC=  Brahmi_JOINING_Number}', "");
    Expect(0, 69734, '\P{^Is_InSC=  Brahmi_JOINING_Number}', "");
    Error('\p{Indic_Syllabic_Category= Cantillation_mark/a/}');
    Error('\P{Indic_Syllabic_Category= Cantillation_mark/a/}');
    Expect(1, 70516, '\p{Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70516, '\p{^Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70516, '\P{Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70516, '\P{^Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70517, '\p{Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70517, '\p{^Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70517, '\P{Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70517, '\P{^Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70516, '\p{Indic_Syllabic_Category= 	Cantillation_mark}', "");
    Expect(0, 70516, '\p{^Indic_Syllabic_Category= 	Cantillation_mark}', "");
    Expect(0, 70516, '\P{Indic_Syllabic_Category= 	Cantillation_mark}', "");
    Expect(1, 70516, '\P{^Indic_Syllabic_Category= 	Cantillation_mark}', "");
    Expect(0, 70517, '\p{Indic_Syllabic_Category= 	Cantillation_mark}', "");
    Expect(1, 70517, '\p{^Indic_Syllabic_Category= 	Cantillation_mark}', "");
    Expect(1, 70517, '\P{Indic_Syllabic_Category= 	Cantillation_mark}', "");
    Expect(0, 70517, '\P{^Indic_Syllabic_Category= 	Cantillation_mark}', "");
    Error('\p{InSC:	/a/cantillation_Mark}');
    Error('\P{InSC:	/a/cantillation_Mark}');
    Expect(1, 70516, '\p{InSC=cantillationmark}', "");
    Expect(0, 70516, '\p{^InSC=cantillationmark}', "");
    Expect(0, 70516, '\P{InSC=cantillationmark}', "");
    Expect(1, 70516, '\P{^InSC=cantillationmark}', "");
    Expect(0, 70517, '\p{InSC=cantillationmark}', "");
    Expect(1, 70517, '\p{^InSC=cantillationmark}', "");
    Expect(1, 70517, '\P{InSC=cantillationmark}', "");
    Expect(0, 70517, '\P{^InSC=cantillationmark}', "");
    Expect(1, 70516, '\p{InSC=-	Cantillation_mark}', "");
    Expect(0, 70516, '\p{^InSC=-	Cantillation_mark}', "");
    Expect(0, 70516, '\P{InSC=-	Cantillation_mark}', "");
    Expect(1, 70516, '\P{^InSC=-	Cantillation_mark}', "");
    Expect(0, 70517, '\p{InSC=-	Cantillation_mark}', "");
    Expect(1, 70517, '\p{^InSC=-	Cantillation_mark}', "");
    Expect(1, 70517, '\P{InSC=-	Cantillation_mark}', "");
    Expect(0, 70517, '\P{^InSC=-	Cantillation_mark}', "");
    Error('\p{Is_Indic_Syllabic_Category=/a/-Cantillation_mark}');
    Error('\P{Is_Indic_Syllabic_Category=/a/-Cantillation_mark}');
    Expect(1, 70516, '\p{Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70516, '\p{^Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70516, '\P{Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70516, '\P{^Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70517, '\p{Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70517, '\p{^Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70517, '\P{Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70517, '\P{^Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70516, '\p{Is_Indic_Syllabic_Category=		cantillation_Mark}', "");
    Expect(0, 70516, '\p{^Is_Indic_Syllabic_Category=		cantillation_Mark}', "");
    Expect(0, 70516, '\P{Is_Indic_Syllabic_Category=		cantillation_Mark}', "");
    Expect(1, 70516, '\P{^Is_Indic_Syllabic_Category=		cantillation_Mark}', "");
    Expect(0, 70517, '\p{Is_Indic_Syllabic_Category=		cantillation_Mark}', "");
    Expect(1, 70517, '\p{^Is_Indic_Syllabic_Category=		cantillation_Mark}', "");
    Expect(1, 70517, '\P{Is_Indic_Syllabic_Category=		cantillation_Mark}', "");
    Expect(0, 70517, '\P{^Is_Indic_Syllabic_Category=		cantillation_Mark}', "");
    Error('\p{Is_InSC=__Cantillation_MARK/a/}');
    Error('\P{Is_InSC=__Cantillation_MARK/a/}');
    Expect(1, 70516, '\p{Is_InSC=cantillationmark}', "");
    Expect(0, 70516, '\p{^Is_InSC=cantillationmark}', "");
    Expect(0, 70516, '\P{Is_InSC=cantillationmark}', "");
    Expect(1, 70516, '\P{^Is_InSC=cantillationmark}', "");
    Expect(0, 70517, '\p{Is_InSC=cantillationmark}', "");
    Expect(1, 70517, '\p{^Is_InSC=cantillationmark}', "");
    Expect(1, 70517, '\P{Is_InSC=cantillationmark}', "");
    Expect(0, 70517, '\P{^Is_InSC=cantillationmark}', "");
    Expect(1, 70516, '\p{Is_InSC=  CANTILLATION_MARK}', "");
    Expect(0, 70516, '\p{^Is_InSC=  CANTILLATION_MARK}', "");
    Expect(0, 70516, '\P{Is_InSC=  CANTILLATION_MARK}', "");
    Expect(1, 70516, '\P{^Is_InSC=  CANTILLATION_MARK}', "");
    Expect(0, 70517, '\p{Is_InSC=  CANTILLATION_MARK}', "");
    Expect(1, 70517, '\p{^Is_InSC=  CANTILLATION_MARK}', "");
    Expect(1, 70517, '\P{Is_InSC=  CANTILLATION_MARK}', "");
    Expect(0, 70517, '\P{^Is_InSC=  CANTILLATION_MARK}', "");
    Error('\p{Indic_Syllabic_Category=	Consonant/a/}');
    Error('\P{Indic_Syllabic_Category=	Consonant/a/}');
    Expect(1, 73008, '\p{Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73008, '\p{^Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73008, '\P{Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73008, '\P{^Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73009, '\p{Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73009, '\p{^Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73009, '\P{Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73009, '\P{^Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73008, '\p{Indic_Syllabic_Category=_	Consonant}', "");
    Expect(0, 73008, '\p{^Indic_Syllabic_Category=_	Consonant}', "");
    Expect(0, 73008, '\P{Indic_Syllabic_Category=_	Consonant}', "");
    Expect(1, 73008, '\P{^Indic_Syllabic_Category=_	Consonant}', "");
    Expect(0, 73009, '\p{Indic_Syllabic_Category=_	Consonant}', "");
    Expect(1, 73009, '\p{^Indic_Syllabic_Category=_	Consonant}', "");
    Expect(1, 73009, '\P{Indic_Syllabic_Category=_	Consonant}', "");
    Expect(0, 73009, '\P{^Indic_Syllabic_Category=_	Consonant}', "");
    Error('\p{InSC=-	consonant:=}');
    Error('\P{InSC=-	consonant:=}');
    Expect(1, 73008, '\p{InSC=consonant}', "");
    Expect(0, 73008, '\p{^InSC=consonant}', "");
    Expect(0, 73008, '\P{InSC=consonant}', "");
    Expect(1, 73008, '\P{^InSC=consonant}', "");
    Expect(0, 73009, '\p{InSC=consonant}', "");
    Expect(1, 73009, '\p{^InSC=consonant}', "");
    Expect(1, 73009, '\P{InSC=consonant}', "");
    Expect(0, 73009, '\P{^InSC=consonant}', "");
    Expect(1, 73008, '\p{InSC=--Consonant}', "");
    Expect(0, 73008, '\p{^InSC=--Consonant}', "");
    Expect(0, 73008, '\P{InSC=--Consonant}', "");
    Expect(1, 73008, '\P{^InSC=--Consonant}', "");
    Expect(0, 73009, '\p{InSC=--Consonant}', "");
    Expect(1, 73009, '\p{^InSC=--Consonant}', "");
    Expect(1, 73009, '\P{InSC=--Consonant}', "");
    Expect(0, 73009, '\P{^InSC=--Consonant}', "");
    Error('\p{Is_Indic_Syllabic_Category= -consonant/a/}');
    Error('\P{Is_Indic_Syllabic_Category= -consonant/a/}');
    Expect(1, 73008, '\p{Is_Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73008, '\p{^Is_Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73008, '\P{Is_Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73008, '\P{^Is_Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73009, '\p{Is_Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73009, '\p{^Is_Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73009, '\P{Is_Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73009, '\P{^Is_Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73008, '\p{Is_Indic_Syllabic_Category= _CONSONANT}', "");
    Expect(0, 73008, '\p{^Is_Indic_Syllabic_Category= _CONSONANT}', "");
    Expect(0, 73008, '\P{Is_Indic_Syllabic_Category= _CONSONANT}', "");
    Expect(1, 73008, '\P{^Is_Indic_Syllabic_Category= _CONSONANT}', "");
    Expect(0, 73009, '\p{Is_Indic_Syllabic_Category= _CONSONANT}', "");
    Expect(1, 73009, '\p{^Is_Indic_Syllabic_Category= _CONSONANT}', "");
    Expect(1, 73009, '\P{Is_Indic_Syllabic_Category= _CONSONANT}', "");
    Expect(0, 73009, '\P{^Is_Indic_Syllabic_Category= _CONSONANT}', "");
    Error('\p{Is_InSC=	-Consonant/a/}');
    Error('\P{Is_InSC=	-Consonant/a/}');
    Expect(1, 73008, '\p{Is_InSC=consonant}', "");
    Expect(0, 73008, '\p{^Is_InSC=consonant}', "");
    Expect(0, 73008, '\P{Is_InSC=consonant}', "");
    Expect(1, 73008, '\P{^Is_InSC=consonant}', "");
    Expect(0, 73009, '\p{Is_InSC=consonant}', "");
    Expect(1, 73009, '\p{^Is_InSC=consonant}', "");
    Expect(1, 73009, '\P{Is_InSC=consonant}', "");
    Expect(0, 73009, '\P{^Is_InSC=consonant}', "");
    Expect(1, 73008, '\p{Is_InSC=_ Consonant}', "");
    Expect(0, 73008, '\p{^Is_InSC=_ Consonant}', "");
    Expect(0, 73008, '\P{Is_InSC=_ Consonant}', "");
    Expect(1, 73008, '\P{^Is_InSC=_ Consonant}', "");
    Expect(0, 73009, '\p{Is_InSC=_ Consonant}', "");
    Expect(1, 73009, '\p{^Is_InSC=_ Consonant}', "");
    Expect(1, 73009, '\P{Is_InSC=_ Consonant}', "");
    Expect(0, 73009, '\P{^Is_InSC=_ Consonant}', "");
    Error('\p{Indic_Syllabic_Category=/a/	-CONSONANT_Dead}');
    Error('\P{Indic_Syllabic_Category=/a/	-CONSONANT_Dead}');
    Expect(1, 3455, '\p{Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 3455, '\p{^Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 3455, '\P{Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 3455, '\P{^Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 3456, '\p{Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 3456, '\p{^Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 3456, '\P{Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 3456, '\P{^Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 3455, '\p{Indic_Syllabic_Category:   _	CONSONANT_DEAD}', "");
    Expect(0, 3455, '\p{^Indic_Syllabic_Category:   _	CONSONANT_DEAD}', "");
    Expect(0, 3455, '\P{Indic_Syllabic_Category:   _	CONSONANT_DEAD}', "");
    Expect(1, 3455, '\P{^Indic_Syllabic_Category:   _	CONSONANT_DEAD}', "");
    Expect(0, 3456, '\p{Indic_Syllabic_Category:   _	CONSONANT_DEAD}', "");
    Expect(1, 3456, '\p{^Indic_Syllabic_Category:   _	CONSONANT_DEAD}', "");
    Expect(1, 3456, '\P{Indic_Syllabic_Category:   _	CONSONANT_DEAD}', "");
    Expect(0, 3456, '\P{^Indic_Syllabic_Category:   _	CONSONANT_DEAD}', "");
    Error('\p{InSC=/a/Consonant_dead}');
    Error('\P{InSC=/a/Consonant_dead}');
    Expect(1, 3455, '\p{InSC=consonantdead}', "");
    Expect(0, 3455, '\p{^InSC=consonantdead}', "");
    Expect(0, 3455, '\P{InSC=consonantdead}', "");
    Expect(1, 3455, '\P{^InSC=consonantdead}', "");
    Expect(0, 3456, '\p{InSC=consonantdead}', "");
    Expect(1, 3456, '\p{^InSC=consonantdead}', "");
    Expect(1, 3456, '\P{InSC=consonantdead}', "");
    Expect(0, 3456, '\P{^InSC=consonantdead}', "");
    Expect(1, 3455, '\p{InSC=_ Consonant_dead}', "");
    Expect(0, 3455, '\p{^InSC=_ Consonant_dead}', "");
    Expect(0, 3455, '\P{InSC=_ Consonant_dead}', "");
    Expect(1, 3455, '\P{^InSC=_ Consonant_dead}', "");
    Expect(0, 3456, '\p{InSC=_ Consonant_dead}', "");
    Expect(1, 3456, '\p{^InSC=_ Consonant_dead}', "");
    Expect(1, 3456, '\P{InSC=_ Consonant_dead}', "");
    Expect(0, 3456, '\P{^InSC=_ Consonant_dead}', "");
    Error('\p{Is_Indic_Syllabic_Category=:=--Consonant_DEAD}');
    Error('\P{Is_Indic_Syllabic_Category=:=--Consonant_DEAD}');
    Expect(1, 3455, '\p{Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 3455, '\p{^Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 3455, '\P{Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 3455, '\P{^Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 3456, '\p{Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 3456, '\p{^Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 3456, '\P{Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 3456, '\P{^Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 3455, '\p{Is_Indic_Syllabic_Category:-	consonant_DEAD}', "");
    Expect(0, 3455, '\p{^Is_Indic_Syllabic_Category:-	consonant_DEAD}', "");
    Expect(0, 3455, '\P{Is_Indic_Syllabic_Category:-	consonant_DEAD}', "");
    Expect(1, 3455, '\P{^Is_Indic_Syllabic_Category:-	consonant_DEAD}', "");
    Expect(0, 3456, '\p{Is_Indic_Syllabic_Category:-	consonant_DEAD}', "");
    Expect(1, 3456, '\p{^Is_Indic_Syllabic_Category:-	consonant_DEAD}', "");
    Expect(1, 3456, '\P{Is_Indic_Syllabic_Category:-	consonant_DEAD}', "");
    Expect(0, 3456, '\P{^Is_Indic_Syllabic_Category:-	consonant_DEAD}', "");
    Error('\p{Is_InSC:   _CONSONANT_Dead/a/}');
    Error('\P{Is_InSC:   _CONSONANT_Dead/a/}');
    Expect(1, 3455, '\p{Is_InSC=consonantdead}', "");
    Expect(0, 3455, '\p{^Is_InSC=consonantdead}', "");
    Expect(0, 3455, '\P{Is_InSC=consonantdead}', "");
    Expect(1, 3455, '\P{^Is_InSC=consonantdead}', "");
    Expect(0, 3456, '\p{Is_InSC=consonantdead}', "");
    Expect(1, 3456, '\p{^Is_InSC=consonantdead}', "");
    Expect(1, 3456, '\P{Is_InSC=consonantdead}', "");
    Expect(0, 3456, '\P{^Is_InSC=consonantdead}', "");
    Expect(1, 3455, '\p{Is_InSC:   Consonant_DEAD}', "");
    Expect(0, 3455, '\p{^Is_InSC:   Consonant_DEAD}', "");
    Expect(0, 3455, '\P{Is_InSC:   Consonant_DEAD}', "");
    Expect(1, 3455, '\P{^Is_InSC:   Consonant_DEAD}', "");
    Expect(0, 3456, '\p{Is_InSC:   Consonant_DEAD}', "");
    Expect(1, 3456, '\p{^Is_InSC:   Consonant_DEAD}', "");
    Expect(1, 3456, '\P{Is_InSC:   Consonant_DEAD}', "");
    Expect(0, 3456, '\P{^Is_InSC:   Consonant_DEAD}', "");
    Error('\p{Indic_Syllabic_Category= /a/Consonant_final}');
    Error('\P{Indic_Syllabic_Category= /a/Consonant_final}');
    Expect(1, 72341, '\p{Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72341, '\p{^Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72341, '\P{Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72341, '\P{^Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72342, '\p{Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72342, '\p{^Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72342, '\P{Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72342, '\P{^Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72341, '\p{Indic_Syllabic_Category=-_consonant_Final}', "");
    Expect(0, 72341, '\p{^Indic_Syllabic_Category=-_consonant_Final}', "");
    Expect(0, 72341, '\P{Indic_Syllabic_Category=-_consonant_Final}', "");
    Expect(1, 72341, '\P{^Indic_Syllabic_Category=-_consonant_Final}', "");
    Expect(0, 72342, '\p{Indic_Syllabic_Category=-_consonant_Final}', "");
    Expect(1, 72342, '\p{^Indic_Syllabic_Category=-_consonant_Final}', "");
    Expect(1, 72342, '\P{Indic_Syllabic_Category=-_consonant_Final}', "");
    Expect(0, 72342, '\P{^Indic_Syllabic_Category=-_consonant_Final}', "");
    Error('\p{InSC:/a/_consonant_FINAL}');
    Error('\P{InSC:/a/_consonant_FINAL}');
    Expect(1, 72341, '\p{InSC=consonantfinal}', "");
    Expect(0, 72341, '\p{^InSC=consonantfinal}', "");
    Expect(0, 72341, '\P{InSC=consonantfinal}', "");
    Expect(1, 72341, '\P{^InSC=consonantfinal}', "");
    Expect(0, 72342, '\p{InSC=consonantfinal}', "");
    Expect(1, 72342, '\p{^InSC=consonantfinal}', "");
    Expect(1, 72342, '\P{InSC=consonantfinal}', "");
    Expect(0, 72342, '\P{^InSC=consonantfinal}', "");
    Expect(1, 72341, '\p{InSC=Consonant_Final}', "");
    Expect(0, 72341, '\p{^InSC=Consonant_Final}', "");
    Expect(0, 72341, '\P{InSC=Consonant_Final}', "");
    Expect(1, 72341, '\P{^InSC=Consonant_Final}', "");
    Expect(0, 72342, '\p{InSC=Consonant_Final}', "");
    Expect(1, 72342, '\p{^InSC=Consonant_Final}', "");
    Expect(1, 72342, '\P{InSC=Consonant_Final}', "");
    Expect(0, 72342, '\P{^InSC=Consonant_Final}', "");
    Error('\p{Is_Indic_Syllabic_Category=/a/__Consonant_Final}');
    Error('\P{Is_Indic_Syllabic_Category=/a/__Consonant_Final}');
    Expect(1, 72341, '\p{Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72341, '\p{^Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72341, '\P{Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72341, '\P{^Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72342, '\p{Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72342, '\p{^Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72342, '\P{Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72342, '\P{^Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72341, '\p{Is_Indic_Syllabic_Category=		consonant_Final}', "");
    Expect(0, 72341, '\p{^Is_Indic_Syllabic_Category=		consonant_Final}', "");
    Expect(0, 72341, '\P{Is_Indic_Syllabic_Category=		consonant_Final}', "");
    Expect(1, 72341, '\P{^Is_Indic_Syllabic_Category=		consonant_Final}', "");
    Expect(0, 72342, '\p{Is_Indic_Syllabic_Category=		consonant_Final}', "");
    Expect(1, 72342, '\p{^Is_Indic_Syllabic_Category=		consonant_Final}', "");
    Expect(1, 72342, '\P{Is_Indic_Syllabic_Category=		consonant_Final}', "");
    Expect(0, 72342, '\P{^Is_Indic_Syllabic_Category=		consonant_Final}', "");
    Error('\p{Is_InSC=_Consonant_FINAL:=}');
    Error('\P{Is_InSC=_Consonant_FINAL:=}');
    Expect(1, 72341, '\p{Is_InSC=consonantfinal}', "");
    Expect(0, 72341, '\p{^Is_InSC=consonantfinal}', "");
    Expect(0, 72341, '\P{Is_InSC=consonantfinal}', "");
    Expect(1, 72341, '\P{^Is_InSC=consonantfinal}', "");
    Expect(0, 72342, '\p{Is_InSC=consonantfinal}', "");
    Expect(1, 72342, '\p{^Is_InSC=consonantfinal}', "");
    Expect(1, 72342, '\P{Is_InSC=consonantfinal}', "");
    Expect(0, 72342, '\P{^Is_InSC=consonantfinal}', "");
    Expect(1, 72341, '\p{Is_InSC=-_Consonant_FINAL}', "");
    Expect(0, 72341, '\p{^Is_InSC=-_Consonant_FINAL}', "");
    Expect(0, 72341, '\P{Is_InSC=-_Consonant_FINAL}', "");
    Expect(1, 72341, '\P{^Is_InSC=-_Consonant_FINAL}', "");
    Expect(0, 72342, '\p{Is_InSC=-_Consonant_FINAL}', "");
    Expect(1, 72342, '\p{^Is_InSC=-_Consonant_FINAL}', "");
    Expect(1, 72342, '\P{Is_InSC=-_Consonant_FINAL}', "");
    Expect(0, 72342, '\P{^Is_InSC=-_Consonant_FINAL}', "");
    Error('\p{Indic_Syllabic_Category=	:=consonant_head_LETTER}');
    Error('\P{Indic_Syllabic_Category=	:=consonant_head_LETTER}');
    Expect(1, 3980, '\p{Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3980, '\p{^Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3980, '\P{Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3980, '\P{^Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3981, '\p{Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3981, '\p{^Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3981, '\P{Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3981, '\P{^Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3980, '\p{Indic_Syllabic_Category=	-Consonant_HEAD_Letter}', "");
    Expect(0, 3980, '\p{^Indic_Syllabic_Category=	-Consonant_HEAD_Letter}', "");
    Expect(0, 3980, '\P{Indic_Syllabic_Category=	-Consonant_HEAD_Letter}', "");
    Expect(1, 3980, '\P{^Indic_Syllabic_Category=	-Consonant_HEAD_Letter}', "");
    Expect(0, 3981, '\p{Indic_Syllabic_Category=	-Consonant_HEAD_Letter}', "");
    Expect(1, 3981, '\p{^Indic_Syllabic_Category=	-Consonant_HEAD_Letter}', "");
    Expect(1, 3981, '\P{Indic_Syllabic_Category=	-Consonant_HEAD_Letter}', "");
    Expect(0, 3981, '\P{^Indic_Syllabic_Category=	-Consonant_HEAD_Letter}', "");
    Error('\p{InSC=:= _consonant_Head_LETTER}');
    Error('\P{InSC=:= _consonant_Head_LETTER}');
    Expect(1, 3980, '\p{InSC=consonantheadletter}', "");
    Expect(0, 3980, '\p{^InSC=consonantheadletter}', "");
    Expect(0, 3980, '\P{InSC=consonantheadletter}', "");
    Expect(1, 3980, '\P{^InSC=consonantheadletter}', "");
    Expect(0, 3981, '\p{InSC=consonantheadletter}', "");
    Expect(1, 3981, '\p{^InSC=consonantheadletter}', "");
    Expect(1, 3981, '\P{InSC=consonantheadletter}', "");
    Expect(0, 3981, '\P{^InSC=consonantheadletter}', "");
    Expect(1, 3980, '\p{InSC=-_Consonant_HEAD_Letter}', "");
    Expect(0, 3980, '\p{^InSC=-_Consonant_HEAD_Letter}', "");
    Expect(0, 3980, '\P{InSC=-_Consonant_HEAD_Letter}', "");
    Expect(1, 3980, '\P{^InSC=-_Consonant_HEAD_Letter}', "");
    Expect(0, 3981, '\p{InSC=-_Consonant_HEAD_Letter}', "");
    Expect(1, 3981, '\p{^InSC=-_Consonant_HEAD_Letter}', "");
    Expect(1, 3981, '\P{InSC=-_Consonant_HEAD_Letter}', "");
    Expect(0, 3981, '\P{^InSC=-_Consonant_HEAD_Letter}', "");
    Error('\p{Is_Indic_Syllabic_Category=	-CONSONANT_head_Letter/a/}');
    Error('\P{Is_Indic_Syllabic_Category=	-CONSONANT_head_Letter/a/}');
    Expect(1, 3980, '\p{Is_Indic_Syllabic_Category:   consonantheadletter}', "");
    Expect(0, 3980, '\p{^Is_Indic_Syllabic_Category:   consonantheadletter}', "");
    Expect(0, 3980, '\P{Is_Indic_Syllabic_Category:   consonantheadletter}', "");
    Expect(1, 3980, '\P{^Is_Indic_Syllabic_Category:   consonantheadletter}', "");
    Expect(0, 3981, '\p{Is_Indic_Syllabic_Category:   consonantheadletter}', "");
    Expect(1, 3981, '\p{^Is_Indic_Syllabic_Category:   consonantheadletter}', "");
    Expect(1, 3981, '\P{Is_Indic_Syllabic_Category:   consonantheadletter}', "");
    Expect(0, 3981, '\P{^Is_Indic_Syllabic_Category:   consonantheadletter}', "");
    Expect(1, 3980, '\p{Is_Indic_Syllabic_Category= 	Consonant_Head_LETTER}', "");
    Expect(0, 3980, '\p{^Is_Indic_Syllabic_Category= 	Consonant_Head_LETTER}', "");
    Expect(0, 3980, '\P{Is_Indic_Syllabic_Category= 	Consonant_Head_LETTER}', "");
    Expect(1, 3980, '\P{^Is_Indic_Syllabic_Category= 	Consonant_Head_LETTER}', "");
    Expect(0, 3981, '\p{Is_Indic_Syllabic_Category= 	Consonant_Head_LETTER}', "");
    Expect(1, 3981, '\p{^Is_Indic_Syllabic_Category= 	Consonant_Head_LETTER}', "");
    Expect(1, 3981, '\P{Is_Indic_Syllabic_Category= 	Consonant_Head_LETTER}', "");
    Expect(0, 3981, '\P{^Is_Indic_Syllabic_Category= 	Consonant_Head_LETTER}', "");
    Error('\p{Is_InSC:   :=-consonant_Head_Letter}');
    Error('\P{Is_InSC:   :=-consonant_Head_Letter}');
    Expect(1, 3980, '\p{Is_InSC=consonantheadletter}', "");
    Expect(0, 3980, '\p{^Is_InSC=consonantheadletter}', "");
    Expect(0, 3980, '\P{Is_InSC=consonantheadletter}', "");
    Expect(1, 3980, '\P{^Is_InSC=consonantheadletter}', "");
    Expect(0, 3981, '\p{Is_InSC=consonantheadletter}', "");
    Expect(1, 3981, '\p{^Is_InSC=consonantheadletter}', "");
    Expect(1, 3981, '\P{Is_InSC=consonantheadletter}', "");
    Expect(0, 3981, '\P{^Is_InSC=consonantheadletter}', "");
    Expect(1, 3980, '\p{Is_InSC= 	consonant_HEAD_LETTER}', "");
    Expect(0, 3980, '\p{^Is_InSC= 	consonant_HEAD_LETTER}', "");
    Expect(0, 3980, '\P{Is_InSC= 	consonant_HEAD_LETTER}', "");
    Expect(1, 3980, '\P{^Is_InSC= 	consonant_HEAD_LETTER}', "");
    Expect(0, 3981, '\p{Is_InSC= 	consonant_HEAD_LETTER}', "");
    Expect(1, 3981, '\p{^Is_InSC= 	consonant_HEAD_LETTER}', "");
    Expect(1, 3981, '\P{Is_InSC= 	consonant_HEAD_LETTER}', "");
    Expect(0, 3981, '\P{^Is_InSC= 	consonant_HEAD_LETTER}', "");
    Error('\p{Indic_Syllabic_Category=/a/	 Consonant_Killer}');
    Error('\P{Indic_Syllabic_Category=/a/	 Consonant_Killer}');
    Expect(1, 6093, '\p{Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6093, '\p{^Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6093, '\P{Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6093, '\P{^Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6094, '\p{Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6094, '\p{^Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6094, '\P{Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6094, '\P{^Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6093, '\p{Indic_Syllabic_Category=_	consonant_KILLER}', "");
    Expect(0, 6093, '\p{^Indic_Syllabic_Category=_	consonant_KILLER}', "");
    Expect(0, 6093, '\P{Indic_Syllabic_Category=_	consonant_KILLER}', "");
    Expect(1, 6093, '\P{^Indic_Syllabic_Category=_	consonant_KILLER}', "");
    Expect(0, 6094, '\p{Indic_Syllabic_Category=_	consonant_KILLER}', "");
    Expect(1, 6094, '\p{^Indic_Syllabic_Category=_	consonant_KILLER}', "");
    Expect(1, 6094, '\P{Indic_Syllabic_Category=_	consonant_KILLER}', "");
    Expect(0, 6094, '\P{^Indic_Syllabic_Category=_	consonant_KILLER}', "");
    Error('\p{InSC:    :=consonant_Killer}');
    Error('\P{InSC:    :=consonant_Killer}');
    Expect(1, 6093, '\p{InSC=consonantkiller}', "");
    Expect(0, 6093, '\p{^InSC=consonantkiller}', "");
    Expect(0, 6093, '\P{InSC=consonantkiller}', "");
    Expect(1, 6093, '\P{^InSC=consonantkiller}', "");
    Expect(0, 6094, '\p{InSC=consonantkiller}', "");
    Expect(1, 6094, '\p{^InSC=consonantkiller}', "");
    Expect(1, 6094, '\P{InSC=consonantkiller}', "");
    Expect(0, 6094, '\P{^InSC=consonantkiller}', "");
    Expect(1, 6093, '\p{InSC=		Consonant_Killer}', "");
    Expect(0, 6093, '\p{^InSC=		Consonant_Killer}', "");
    Expect(0, 6093, '\P{InSC=		Consonant_Killer}', "");
    Expect(1, 6093, '\P{^InSC=		Consonant_Killer}', "");
    Expect(0, 6094, '\p{InSC=		Consonant_Killer}', "");
    Expect(1, 6094, '\p{^InSC=		Consonant_Killer}', "");
    Expect(1, 6094, '\P{InSC=		Consonant_Killer}', "");
    Expect(0, 6094, '\P{^InSC=		Consonant_Killer}', "");
    Error('\p{Is_Indic_Syllabic_Category=:=	 consonant_Killer}');
    Error('\P{Is_Indic_Syllabic_Category=:=	 consonant_Killer}');
    Expect(1, 6093, '\p{Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6093, '\p{^Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6093, '\P{Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6093, '\P{^Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6094, '\p{Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6094, '\p{^Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6094, '\P{Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6094, '\P{^Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6093, '\p{Is_Indic_Syllabic_Category:  CONSONANT_Killer}', "");
    Expect(0, 6093, '\p{^Is_Indic_Syllabic_Category:  CONSONANT_Killer}', "");
    Expect(0, 6093, '\P{Is_Indic_Syllabic_Category:  CONSONANT_Killer}', "");
    Expect(1, 6093, '\P{^Is_Indic_Syllabic_Category:  CONSONANT_Killer}', "");
    Expect(0, 6094, '\p{Is_Indic_Syllabic_Category:  CONSONANT_Killer}', "");
    Expect(1, 6094, '\p{^Is_Indic_Syllabic_Category:  CONSONANT_Killer}', "");
    Expect(1, 6094, '\P{Is_Indic_Syllabic_Category:  CONSONANT_Killer}', "");
    Expect(0, 6094, '\P{^Is_Indic_Syllabic_Category:  CONSONANT_Killer}', "");
    Error('\p{Is_InSC=	/a/consonant_killer}');
    Error('\P{Is_InSC=	/a/consonant_killer}');
    Expect(1, 6093, '\p{Is_InSC=consonantkiller}', "");
    Expect(0, 6093, '\p{^Is_InSC=consonantkiller}', "");
    Expect(0, 6093, '\P{Is_InSC=consonantkiller}', "");
    Expect(1, 6093, '\P{^Is_InSC=consonantkiller}', "");
    Expect(0, 6094, '\p{Is_InSC=consonantkiller}', "");
    Expect(1, 6094, '\p{^Is_InSC=consonantkiller}', "");
    Expect(1, 6094, '\P{Is_InSC=consonantkiller}', "");
    Expect(0, 6094, '\P{^Is_InSC=consonantkiller}', "");
    Expect(1, 6093, '\p{Is_InSC=-CONSONANT_Killer}', "");
    Expect(0, 6093, '\p{^Is_InSC=-CONSONANT_Killer}', "");
    Expect(0, 6093, '\P{Is_InSC=-CONSONANT_Killer}', "");
    Expect(1, 6093, '\P{^Is_InSC=-CONSONANT_Killer}', "");
    Expect(0, 6094, '\p{Is_InSC=-CONSONANT_Killer}', "");
    Expect(1, 6094, '\p{^Is_InSC=-CONSONANT_Killer}', "");
    Expect(1, 6094, '\P{Is_InSC=-CONSONANT_Killer}', "");
    Expect(0, 6094, '\P{^Is_InSC=-CONSONANT_Killer}', "");
    Error('\p{Indic_Syllabic_Category=	:=consonant_medial}');
    Error('\P{Indic_Syllabic_Category=	:=consonant_medial}');
    Expect(1, 73031, '\p{Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73031, '\p{^Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73031, '\P{Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73031, '\P{^Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73032, '\p{Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73032, '\p{^Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73032, '\P{Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73032, '\P{^Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73031, '\p{Indic_Syllabic_Category=-CONSONANT_medial}', "");
    Expect(0, 73031, '\p{^Indic_Syllabic_Category=-CONSONANT_medial}', "");
    Expect(0, 73031, '\P{Indic_Syllabic_Category=-CONSONANT_medial}', "");
    Expect(1, 73031, '\P{^Indic_Syllabic_Category=-CONSONANT_medial}', "");
    Expect(0, 73032, '\p{Indic_Syllabic_Category=-CONSONANT_medial}', "");
    Expect(1, 73032, '\p{^Indic_Syllabic_Category=-CONSONANT_medial}', "");
    Expect(1, 73032, '\P{Indic_Syllabic_Category=-CONSONANT_medial}', "");
    Expect(0, 73032, '\P{^Indic_Syllabic_Category=-CONSONANT_medial}', "");
    Error('\p{InSC=/a/-CONSONANT_Medial}');
    Error('\P{InSC=/a/-CONSONANT_Medial}');
    Expect(1, 73031, '\p{InSC=consonantmedial}', "");
    Expect(0, 73031, '\p{^InSC=consonantmedial}', "");
    Expect(0, 73031, '\P{InSC=consonantmedial}', "");
    Expect(1, 73031, '\P{^InSC=consonantmedial}', "");
    Expect(0, 73032, '\p{InSC=consonantmedial}', "");
    Expect(1, 73032, '\p{^InSC=consonantmedial}', "");
    Expect(1, 73032, '\P{InSC=consonantmedial}', "");
    Expect(0, 73032, '\P{^InSC=consonantmedial}', "");
    Expect(1, 73031, '\p{InSC=	-Consonant_MEDIAL}', "");
    Expect(0, 73031, '\p{^InSC=	-Consonant_MEDIAL}', "");
    Expect(0, 73031, '\P{InSC=	-Consonant_MEDIAL}', "");
    Expect(1, 73031, '\P{^InSC=	-Consonant_MEDIAL}', "");
    Expect(0, 73032, '\p{InSC=	-Consonant_MEDIAL}', "");
    Expect(1, 73032, '\p{^InSC=	-Consonant_MEDIAL}', "");
    Expect(1, 73032, '\P{InSC=	-Consonant_MEDIAL}', "");
    Expect(0, 73032, '\P{^InSC=	-Consonant_MEDIAL}', "");
    Error('\p{Is_Indic_Syllabic_Category=/a/	Consonant_Medial}');
    Error('\P{Is_Indic_Syllabic_Category=/a/	Consonant_Medial}');
    Expect(1, 73031, '\p{Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73031, '\p{^Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73031, '\P{Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73031, '\P{^Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73032, '\p{Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73032, '\p{^Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73032, '\P{Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73032, '\P{^Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73031, '\p{Is_Indic_Syllabic_Category= _consonant_medial}', "");
    Expect(0, 73031, '\p{^Is_Indic_Syllabic_Category= _consonant_medial}', "");
    Expect(0, 73031, '\P{Is_Indic_Syllabic_Category= _consonant_medial}', "");
    Expect(1, 73031, '\P{^Is_Indic_Syllabic_Category= _consonant_medial}', "");
    Expect(0, 73032, '\p{Is_Indic_Syllabic_Category= _consonant_medial}', "");
    Expect(1, 73032, '\p{^Is_Indic_Syllabic_Category= _consonant_medial}', "");
    Expect(1, 73032, '\P{Is_Indic_Syllabic_Category= _consonant_medial}', "");
    Expect(0, 73032, '\P{^Is_Indic_Syllabic_Category= _consonant_medial}', "");
    Error('\p{Is_InSC=  Consonant_Medial/a/}');
    Error('\P{Is_InSC=  Consonant_Medial/a/}');
    Expect(1, 73031, '\p{Is_InSC=consonantmedial}', "");
    Expect(0, 73031, '\p{^Is_InSC=consonantmedial}', "");
    Expect(0, 73031, '\P{Is_InSC=consonantmedial}', "");
    Expect(1, 73031, '\P{^Is_InSC=consonantmedial}', "");
    Expect(0, 73032, '\p{Is_InSC=consonantmedial}', "");
    Expect(1, 73032, '\p{^Is_InSC=consonantmedial}', "");
    Expect(1, 73032, '\P{Is_InSC=consonantmedial}', "");
    Expect(0, 73032, '\P{^Is_InSC=consonantmedial}', "");
    Expect(1, 73031, '\p{Is_InSC=--Consonant_medial}', "");
    Expect(0, 73031, '\p{^Is_InSC=--Consonant_medial}', "");
    Expect(0, 73031, '\P{Is_InSC=--Consonant_medial}', "");
    Expect(1, 73031, '\P{^Is_InSC=--Consonant_medial}', "");
    Expect(0, 73032, '\p{Is_InSC=--Consonant_medial}', "");
    Expect(1, 73032, '\p{^Is_InSC=--Consonant_medial}', "");
    Expect(1, 73032, '\P{Is_InSC=--Consonant_medial}', "");
    Expect(0, 73032, '\P{^Is_InSC=--Consonant_medial}', "");
    Error('\p{Indic_Syllabic_Category=:=- CONSONANT_Placeholder}');
    Error('\P{Indic_Syllabic_Category=:=- CONSONANT_Placeholder}');
    Expect(1, 72261, '\p{Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 72261, '\p{^Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 72261, '\P{Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 72261, '\P{^Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 72262, '\p{Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 72262, '\p{^Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 72262, '\P{Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 72262, '\P{^Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 72261, '\p{Indic_Syllabic_Category=	 consonant_Placeholder}', "");
    Expect(0, 72261, '\p{^Indic_Syllabic_Category=	 consonant_Placeholder}', "");
    Expect(0, 72261, '\P{Indic_Syllabic_Category=	 consonant_Placeholder}', "");
    Expect(1, 72261, '\P{^Indic_Syllabic_Category=	 consonant_Placeholder}', "");
    Expect(0, 72262, '\p{Indic_Syllabic_Category=	 consonant_Placeholder}', "");
    Expect(1, 72262, '\p{^Indic_Syllabic_Category=	 consonant_Placeholder}', "");
    Expect(1, 72262, '\P{Indic_Syllabic_Category=	 consonant_Placeholder}', "");
    Expect(0, 72262, '\P{^Indic_Syllabic_Category=	 consonant_Placeholder}', "");
    Error('\p{InSC= :=CONSONANT_Placeholder}');
    Error('\P{InSC= :=CONSONANT_Placeholder}');
    Expect(1, 72261, '\p{InSC=consonantplaceholder}', "");
    Expect(0, 72261, '\p{^InSC=consonantplaceholder}', "");
    Expect(0, 72261, '\P{InSC=consonantplaceholder}', "");
    Expect(1, 72261, '\P{^InSC=consonantplaceholder}', "");
    Expect(0, 72262, '\p{InSC=consonantplaceholder}', "");
    Expect(1, 72262, '\p{^InSC=consonantplaceholder}', "");
    Expect(1, 72262, '\P{InSC=consonantplaceholder}', "");
    Expect(0, 72262, '\P{^InSC=consonantplaceholder}', "");
    Expect(1, 72261, '\p{InSC= -Consonant_Placeholder}', "");
    Expect(0, 72261, '\p{^InSC= -Consonant_Placeholder}', "");
    Expect(0, 72261, '\P{InSC= -Consonant_Placeholder}', "");
    Expect(1, 72261, '\P{^InSC= -Consonant_Placeholder}', "");
    Expect(0, 72262, '\p{InSC= -Consonant_Placeholder}', "");
    Expect(1, 72262, '\p{^InSC= -Consonant_Placeholder}', "");
    Expect(1, 72262, '\P{InSC= -Consonant_Placeholder}', "");
    Expect(0, 72262, '\P{^InSC= -Consonant_Placeholder}', "");
    Error('\p{Is_Indic_Syllabic_Category=:=Consonant_Placeholder}');
    Error('\P{Is_Indic_Syllabic_Category=:=Consonant_Placeholder}');
    Expect(1, 72261, '\p{Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 72261, '\p{^Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 72261, '\P{Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 72261, '\P{^Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 72262, '\p{Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 72262, '\p{^Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 72262, '\P{Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 72262, '\P{^Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 72261, '\p{Is_Indic_Syllabic_Category:   	_CONSONANT_placeholder}', "");
    Expect(0, 72261, '\p{^Is_Indic_Syllabic_Category:   	_CONSONANT_placeholder}', "");
    Expect(0, 72261, '\P{Is_Indic_Syllabic_Category:   	_CONSONANT_placeholder}', "");
    Expect(1, 72261, '\P{^Is_Indic_Syllabic_Category:   	_CONSONANT_placeholder}', "");
    Expect(0, 72262, '\p{Is_Indic_Syllabic_Category:   	_CONSONANT_placeholder}', "");
    Expect(1, 72262, '\p{^Is_Indic_Syllabic_Category:   	_CONSONANT_placeholder}', "");
    Expect(1, 72262, '\P{Is_Indic_Syllabic_Category:   	_CONSONANT_placeholder}', "");
    Expect(0, 72262, '\P{^Is_Indic_Syllabic_Category:   	_CONSONANT_placeholder}', "");
    Error('\p{Is_InSC=_/a/Consonant_placeholder}');
    Error('\P{Is_InSC=_/a/Consonant_placeholder}');
    Expect(1, 72261, '\p{Is_InSC=consonantplaceholder}', "");
    Expect(0, 72261, '\p{^Is_InSC=consonantplaceholder}', "");
    Expect(0, 72261, '\P{Is_InSC=consonantplaceholder}', "");
    Expect(1, 72261, '\P{^Is_InSC=consonantplaceholder}', "");
    Expect(0, 72262, '\p{Is_InSC=consonantplaceholder}', "");
    Expect(1, 72262, '\p{^Is_InSC=consonantplaceholder}', "");
    Expect(1, 72262, '\P{Is_InSC=consonantplaceholder}', "");
    Expect(0, 72262, '\P{^Is_InSC=consonantplaceholder}', "");
    Expect(1, 72261, '\p{Is_InSC= -consonant_placeholder}', "");
    Expect(0, 72261, '\p{^Is_InSC= -consonant_placeholder}', "");
    Expect(0, 72261, '\P{Is_InSC= -consonant_placeholder}', "");
    Expect(1, 72261, '\P{^Is_InSC= -consonant_placeholder}', "");
    Expect(0, 72262, '\p{Is_InSC= -consonant_placeholder}', "");
    Expect(1, 72262, '\p{^Is_InSC= -consonant_placeholder}', "");
    Expect(1, 72262, '\P{Is_InSC= -consonant_placeholder}', "");
    Expect(0, 72262, '\P{^Is_InSC= -consonant_placeholder}', "");
    Error('\p{Indic_Syllabic_Category=--Consonant_Preceding_REPHA/a/}');
    Error('\P{Indic_Syllabic_Category=--Consonant_Preceding_REPHA/a/}');
    Expect(1, 73030, '\p{Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73030, '\p{^Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73030, '\P{Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73030, '\P{^Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73031, '\p{Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73031, '\p{^Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73031, '\P{Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73031, '\P{^Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73030, '\p{Indic_Syllabic_Category= 	Consonant_Preceding_Repha}', "");
    Expect(0, 73030, '\p{^Indic_Syllabic_Category= 	Consonant_Preceding_Repha}', "");
    Expect(0, 73030, '\P{Indic_Syllabic_Category= 	Consonant_Preceding_Repha}', "");
    Expect(1, 73030, '\P{^Indic_Syllabic_Category= 	Consonant_Preceding_Repha}', "");
    Expect(0, 73031, '\p{Indic_Syllabic_Category= 	Consonant_Preceding_Repha}', "");
    Expect(1, 73031, '\p{^Indic_Syllabic_Category= 	Consonant_Preceding_Repha}', "");
    Expect(1, 73031, '\P{Indic_Syllabic_Category= 	Consonant_Preceding_Repha}', "");
    Expect(0, 73031, '\P{^Indic_Syllabic_Category= 	Consonant_Preceding_Repha}', "");
    Error('\p{InSC:_	Consonant_Preceding_repha:=}');
    Error('\P{InSC:_	Consonant_Preceding_repha:=}');
    Expect(1, 73030, '\p{InSC=consonantprecedingrepha}', "");
    Expect(0, 73030, '\p{^InSC=consonantprecedingrepha}', "");
    Expect(0, 73030, '\P{InSC=consonantprecedingrepha}', "");
    Expect(1, 73030, '\P{^InSC=consonantprecedingrepha}', "");
    Expect(0, 73031, '\p{InSC=consonantprecedingrepha}', "");
    Expect(1, 73031, '\p{^InSC=consonantprecedingrepha}', "");
    Expect(1, 73031, '\P{InSC=consonantprecedingrepha}', "");
    Expect(0, 73031, '\P{^InSC=consonantprecedingrepha}', "");
    Expect(1, 73030, '\p{InSC:		Consonant_Preceding_REPHA}', "");
    Expect(0, 73030, '\p{^InSC:		Consonant_Preceding_REPHA}', "");
    Expect(0, 73030, '\P{InSC:		Consonant_Preceding_REPHA}', "");
    Expect(1, 73030, '\P{^InSC:		Consonant_Preceding_REPHA}', "");
    Expect(0, 73031, '\p{InSC:		Consonant_Preceding_REPHA}', "");
    Expect(1, 73031, '\p{^InSC:		Consonant_Preceding_REPHA}', "");
    Expect(1, 73031, '\P{InSC:		Consonant_Preceding_REPHA}', "");
    Expect(0, 73031, '\P{^InSC:		Consonant_Preceding_REPHA}', "");
    Error('\p{Is_Indic_Syllabic_Category=_/a/CONSONANT_PRECEDING_repha}');
    Error('\P{Is_Indic_Syllabic_Category=_/a/CONSONANT_PRECEDING_repha}');
    Expect(1, 73030, '\p{Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73030, '\p{^Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73030, '\P{Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73030, '\P{^Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73031, '\p{Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73031, '\p{^Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73031, '\P{Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73031, '\P{^Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73030, '\p{Is_Indic_Syllabic_Category= _consonant_preceding_repha}', "");
    Expect(0, 73030, '\p{^Is_Indic_Syllabic_Category= _consonant_preceding_repha}', "");
    Expect(0, 73030, '\P{Is_Indic_Syllabic_Category= _consonant_preceding_repha}', "");
    Expect(1, 73030, '\P{^Is_Indic_Syllabic_Category= _consonant_preceding_repha}', "");
    Expect(0, 73031, '\p{Is_Indic_Syllabic_Category= _consonant_preceding_repha}', "");
    Expect(1, 73031, '\p{^Is_Indic_Syllabic_Category= _consonant_preceding_repha}', "");
    Expect(1, 73031, '\P{Is_Indic_Syllabic_Category= _consonant_preceding_repha}', "");
    Expect(0, 73031, '\P{^Is_Indic_Syllabic_Category= _consonant_preceding_repha}', "");
    Error('\p{Is_InSC= -consonant_Preceding_Repha/a/}');
    Error('\P{Is_InSC= -consonant_Preceding_Repha/a/}');
    Expect(1, 73030, '\p{Is_InSC=consonantprecedingrepha}', "");
    Expect(0, 73030, '\p{^Is_InSC=consonantprecedingrepha}', "");
    Expect(0, 73030, '\P{Is_InSC=consonantprecedingrepha}', "");
    Expect(1, 73030, '\P{^Is_InSC=consonantprecedingrepha}', "");
    Expect(0, 73031, '\p{Is_InSC=consonantprecedingrepha}', "");
    Expect(1, 73031, '\p{^Is_InSC=consonantprecedingrepha}', "");
    Expect(1, 73031, '\P{Is_InSC=consonantprecedingrepha}', "");
    Expect(0, 73031, '\P{^Is_InSC=consonantprecedingrepha}', "");
    Expect(1, 73030, '\p{Is_InSC= -CONSONANT_preceding_Repha}', "");
    Expect(0, 73030, '\p{^Is_InSC= -CONSONANT_preceding_Repha}', "");
    Expect(0, 73030, '\P{Is_InSC= -CONSONANT_preceding_Repha}', "");
    Expect(1, 73030, '\P{^Is_InSC= -CONSONANT_preceding_Repha}', "");
    Expect(0, 73031, '\p{Is_InSC= -CONSONANT_preceding_Repha}', "");
    Expect(1, 73031, '\p{^Is_InSC= -CONSONANT_preceding_Repha}', "");
    Expect(1, 73031, '\P{Is_InSC= -CONSONANT_preceding_Repha}', "");
    Expect(0, 73031, '\P{^Is_InSC= -CONSONANT_preceding_Repha}', "");
    Error('\p{Indic_Syllabic_Category=:= 	CONSONANT_prefixed}');
    Error('\P{Indic_Syllabic_Category=:= 	CONSONANT_prefixed}');
    Expect(1, 72329, '\p{Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72329, '\p{^Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72329, '\P{Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72329, '\P{^Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72330, '\p{Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72330, '\p{^Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72330, '\P{Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72330, '\P{^Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72329, '\p{Indic_Syllabic_Category=_	consonant_Prefixed}', "");
    Expect(0, 72329, '\p{^Indic_Syllabic_Category=_	consonant_Prefixed}', "");
    Expect(0, 72329, '\P{Indic_Syllabic_Category=_	consonant_Prefixed}', "");
    Expect(1, 72329, '\P{^Indic_Syllabic_Category=_	consonant_Prefixed}', "");
    Expect(0, 72330, '\p{Indic_Syllabic_Category=_	consonant_Prefixed}', "");
    Expect(1, 72330, '\p{^Indic_Syllabic_Category=_	consonant_Prefixed}', "");
    Expect(1, 72330, '\P{Indic_Syllabic_Category=_	consonant_Prefixed}', "");
    Expect(0, 72330, '\P{^Indic_Syllabic_Category=_	consonant_Prefixed}', "");
    Error('\p{InSC: 	/a/Consonant_Prefixed}');
    Error('\P{InSC: 	/a/Consonant_Prefixed}');
    Expect(1, 72329, '\p{InSC=consonantprefixed}', "");
    Expect(0, 72329, '\p{^InSC=consonantprefixed}', "");
    Expect(0, 72329, '\P{InSC=consonantprefixed}', "");
    Expect(1, 72329, '\P{^InSC=consonantprefixed}', "");
    Expect(0, 72330, '\p{InSC=consonantprefixed}', "");
    Expect(1, 72330, '\p{^InSC=consonantprefixed}', "");
    Expect(1, 72330, '\P{InSC=consonantprefixed}', "");
    Expect(0, 72330, '\P{^InSC=consonantprefixed}', "");
    Expect(1, 72329, '\p{InSC=		Consonant_Prefixed}', "");
    Expect(0, 72329, '\p{^InSC=		Consonant_Prefixed}', "");
    Expect(0, 72329, '\P{InSC=		Consonant_Prefixed}', "");
    Expect(1, 72329, '\P{^InSC=		Consonant_Prefixed}', "");
    Expect(0, 72330, '\p{InSC=		Consonant_Prefixed}', "");
    Expect(1, 72330, '\p{^InSC=		Consonant_Prefixed}', "");
    Expect(1, 72330, '\P{InSC=		Consonant_Prefixed}', "");
    Expect(0, 72330, '\P{^InSC=		Consonant_Prefixed}', "");
    Error('\p{Is_Indic_Syllabic_Category=/a/ -Consonant_prefixed}');
    Error('\P{Is_Indic_Syllabic_Category=/a/ -Consonant_prefixed}');
    Expect(1, 72329, '\p{Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72329, '\p{^Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72329, '\P{Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72329, '\P{^Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72330, '\p{Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72330, '\p{^Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72330, '\P{Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72330, '\P{^Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72329, '\p{Is_Indic_Syllabic_Category= Consonant_Prefixed}', "");
    Expect(0, 72329, '\p{^Is_Indic_Syllabic_Category= Consonant_Prefixed}', "");
    Expect(0, 72329, '\P{Is_Indic_Syllabic_Category= Consonant_Prefixed}', "");
    Expect(1, 72329, '\P{^Is_Indic_Syllabic_Category= Consonant_Prefixed}', "");
    Expect(0, 72330, '\p{Is_Indic_Syllabic_Category= Consonant_Prefixed}', "");
    Expect(1, 72330, '\p{^Is_Indic_Syllabic_Category= Consonant_Prefixed}', "");
    Expect(1, 72330, '\P{Is_Indic_Syllabic_Category= Consonant_Prefixed}', "");
    Expect(0, 72330, '\P{^Is_Indic_Syllabic_Category= Consonant_Prefixed}', "");
    Error('\p{Is_InSC= 	Consonant_Prefixed:=}');
    Error('\P{Is_InSC= 	Consonant_Prefixed:=}');
    Expect(1, 72329, '\p{Is_InSC=consonantprefixed}', "");
    Expect(0, 72329, '\p{^Is_InSC=consonantprefixed}', "");
    Expect(0, 72329, '\P{Is_InSC=consonantprefixed}', "");
    Expect(1, 72329, '\P{^Is_InSC=consonantprefixed}', "");
    Expect(0, 72330, '\p{Is_InSC=consonantprefixed}', "");
    Expect(1, 72330, '\p{^Is_InSC=consonantprefixed}', "");
    Expect(1, 72330, '\P{Is_InSC=consonantprefixed}', "");
    Expect(0, 72330, '\P{^Is_InSC=consonantprefixed}', "");
    Expect(1, 72329, '\p{Is_InSC=- Consonant_PREFIXED}', "");
    Expect(0, 72329, '\p{^Is_InSC=- Consonant_PREFIXED}', "");
    Expect(0, 72329, '\P{Is_InSC=- Consonant_PREFIXED}', "");
    Expect(1, 72329, '\P{^Is_InSC=- Consonant_PREFIXED}', "");
    Expect(0, 72330, '\p{Is_InSC=- Consonant_PREFIXED}', "");
    Expect(1, 72330, '\p{^Is_InSC=- Consonant_PREFIXED}', "");
    Expect(1, 72330, '\P{Is_InSC=- Consonant_PREFIXED}', "");
    Expect(0, 72330, '\P{^Is_InSC=- Consonant_PREFIXED}', "");
    Error('\p{Indic_Syllabic_Category=CONSONANT_subjoined:=}');
    Error('\P{Indic_Syllabic_Category=CONSONANT_subjoined:=}');
    Expect(1, 72879, '\p{Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72879, '\p{^Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72879, '\P{Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72879, '\P{^Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72880, '\p{Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72880, '\p{^Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72880, '\P{Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72880, '\P{^Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72879, '\p{Indic_Syllabic_Category=_CONSONANT_subjoined}', "");
    Expect(0, 72879, '\p{^Indic_Syllabic_Category=_CONSONANT_subjoined}', "");
    Expect(0, 72879, '\P{Indic_Syllabic_Category=_CONSONANT_subjoined}', "");
    Expect(1, 72879, '\P{^Indic_Syllabic_Category=_CONSONANT_subjoined}', "");
    Expect(0, 72880, '\p{Indic_Syllabic_Category=_CONSONANT_subjoined}', "");
    Expect(1, 72880, '\p{^Indic_Syllabic_Category=_CONSONANT_subjoined}', "");
    Expect(1, 72880, '\P{Indic_Syllabic_Category=_CONSONANT_subjoined}', "");
    Expect(0, 72880, '\P{^Indic_Syllabic_Category=_CONSONANT_subjoined}', "");
    Error('\p{InSC=/a/__CONSONANT_Subjoined}');
    Error('\P{InSC=/a/__CONSONANT_Subjoined}');
    Expect(1, 72879, '\p{InSC=consonantsubjoined}', "");
    Expect(0, 72879, '\p{^InSC=consonantsubjoined}', "");
    Expect(0, 72879, '\P{InSC=consonantsubjoined}', "");
    Expect(1, 72879, '\P{^InSC=consonantsubjoined}', "");
    Expect(0, 72880, '\p{InSC=consonantsubjoined}', "");
    Expect(1, 72880, '\p{^InSC=consonantsubjoined}', "");
    Expect(1, 72880, '\P{InSC=consonantsubjoined}', "");
    Expect(0, 72880, '\P{^InSC=consonantsubjoined}', "");
    Expect(1, 72879, '\p{InSC=-_consonant_Subjoined}', "");
    Expect(0, 72879, '\p{^InSC=-_consonant_Subjoined}', "");
    Expect(0, 72879, '\P{InSC=-_consonant_Subjoined}', "");
    Expect(1, 72879, '\P{^InSC=-_consonant_Subjoined}', "");
    Expect(0, 72880, '\p{InSC=-_consonant_Subjoined}', "");
    Expect(1, 72880, '\p{^InSC=-_consonant_Subjoined}', "");
    Expect(1, 72880, '\P{InSC=-_consonant_Subjoined}', "");
    Expect(0, 72880, '\P{^InSC=-_consonant_Subjoined}', "");
    Error('\p{Is_Indic_Syllabic_Category=	:=CONSONANT_subjoined}');
    Error('\P{Is_Indic_Syllabic_Category=	:=CONSONANT_subjoined}');
    Expect(1, 72879, '\p{Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72879, '\p{^Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72879, '\P{Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72879, '\P{^Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72880, '\p{Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72880, '\p{^Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72880, '\P{Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72880, '\P{^Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72879, '\p{Is_Indic_Syllabic_Category=	consonant_SUBJOINED}', "");
    Expect(0, 72879, '\p{^Is_Indic_Syllabic_Category=	consonant_SUBJOINED}', "");
    Expect(0, 72879, '\P{Is_Indic_Syllabic_Category=	consonant_SUBJOINED}', "");
    Expect(1, 72879, '\P{^Is_Indic_Syllabic_Category=	consonant_SUBJOINED}', "");
    Expect(0, 72880, '\p{Is_Indic_Syllabic_Category=	consonant_SUBJOINED}', "");
    Expect(1, 72880, '\p{^Is_Indic_Syllabic_Category=	consonant_SUBJOINED}', "");
    Expect(1, 72880, '\P{Is_Indic_Syllabic_Category=	consonant_SUBJOINED}', "");
    Expect(0, 72880, '\P{^Is_Indic_Syllabic_Category=	consonant_SUBJOINED}', "");
    Error('\p{Is_InSC=_:=Consonant_Subjoined}');
    Error('\P{Is_InSC=_:=Consonant_Subjoined}');
    Expect(1, 72879, '\p{Is_InSC=consonantsubjoined}', "");
    Expect(0, 72879, '\p{^Is_InSC=consonantsubjoined}', "");
    Expect(0, 72879, '\P{Is_InSC=consonantsubjoined}', "");
    Expect(1, 72879, '\P{^Is_InSC=consonantsubjoined}', "");
    Expect(0, 72880, '\p{Is_InSC=consonantsubjoined}', "");
    Expect(1, 72880, '\p{^Is_InSC=consonantsubjoined}', "");
    Expect(1, 72880, '\P{Is_InSC=consonantsubjoined}', "");
    Expect(0, 72880, '\P{^Is_InSC=consonantsubjoined}', "");
    Expect(1, 72879, '\p{Is_InSC=- CONSONANT_subjoined}', "");
    Expect(0, 72879, '\p{^Is_InSC=- CONSONANT_subjoined}', "");
    Expect(0, 72879, '\P{Is_InSC=- CONSONANT_subjoined}', "");
    Expect(1, 72879, '\P{^Is_InSC=- CONSONANT_subjoined}', "");
    Expect(0, 72880, '\p{Is_InSC=- CONSONANT_subjoined}', "");
    Expect(1, 72880, '\p{^Is_InSC=- CONSONANT_subjoined}', "");
    Expect(1, 72880, '\P{Is_InSC=- CONSONANT_subjoined}', "");
    Expect(0, 72880, '\P{^Is_InSC=- CONSONANT_subjoined}', "");
    Error('\p{Indic_Syllabic_Category=-	Consonant_succeeding_Repha:=}');
    Error('\P{Indic_Syllabic_Category=-	Consonant_succeeding_Repha:=}');
    Expect(1, 43394, '\p{Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\p{^Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\P{Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\P{^Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\p{Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\p{^Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\P{Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\P{^Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\p{Indic_Syllabic_Category= consonant_Succeeding_Repha}', "");
    Expect(0, 43394, '\p{^Indic_Syllabic_Category= consonant_Succeeding_Repha}', "");
    Expect(0, 43394, '\P{Indic_Syllabic_Category= consonant_Succeeding_Repha}', "");
    Expect(1, 43394, '\P{^Indic_Syllabic_Category= consonant_Succeeding_Repha}', "");
    Expect(0, 43395, '\p{Indic_Syllabic_Category= consonant_Succeeding_Repha}', "");
    Expect(1, 43395, '\p{^Indic_Syllabic_Category= consonant_Succeeding_Repha}', "");
    Expect(1, 43395, '\P{Indic_Syllabic_Category= consonant_Succeeding_Repha}', "");
    Expect(0, 43395, '\P{^Indic_Syllabic_Category= consonant_Succeeding_Repha}', "");
    Error('\p{InSC=-:=consonant_Succeeding_Repha}');
    Error('\P{InSC=-:=consonant_Succeeding_Repha}');
    Expect(1, 43394, '\p{InSC=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\p{^InSC=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\P{InSC=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\P{^InSC=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\p{InSC=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\p{^InSC=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\P{InSC=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\P{^InSC=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\p{InSC=-Consonant_Succeeding_REPHA}', "");
    Expect(0, 43394, '\p{^InSC=-Consonant_Succeeding_REPHA}', "");
    Expect(0, 43394, '\P{InSC=-Consonant_Succeeding_REPHA}', "");
    Expect(1, 43394, '\P{^InSC=-Consonant_Succeeding_REPHA}', "");
    Expect(0, 43395, '\p{InSC=-Consonant_Succeeding_REPHA}', "");
    Expect(1, 43395, '\p{^InSC=-Consonant_Succeeding_REPHA}', "");
    Expect(1, 43395, '\P{InSC=-Consonant_Succeeding_REPHA}', "");
    Expect(0, 43395, '\P{^InSC=-Consonant_Succeeding_REPHA}', "");
    Error('\p{Is_Indic_Syllabic_Category=_/a/CONSONANT_Succeeding_REPHA}');
    Error('\P{Is_Indic_Syllabic_Category=_/a/CONSONANT_Succeeding_REPHA}');
    Expect(1, 43394, '\p{Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\p{^Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\P{Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\P{^Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\p{Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\p{^Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\P{Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\P{^Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\p{Is_Indic_Syllabic_Category=-Consonant_Succeeding_Repha}', "");
    Expect(0, 43394, '\p{^Is_Indic_Syllabic_Category=-Consonant_Succeeding_Repha}', "");
    Expect(0, 43394, '\P{Is_Indic_Syllabic_Category=-Consonant_Succeeding_Repha}', "");
    Expect(1, 43394, '\P{^Is_Indic_Syllabic_Category=-Consonant_Succeeding_Repha}', "");
    Expect(0, 43395, '\p{Is_Indic_Syllabic_Category=-Consonant_Succeeding_Repha}', "");
    Expect(1, 43395, '\p{^Is_Indic_Syllabic_Category=-Consonant_Succeeding_Repha}', "");
    Expect(1, 43395, '\P{Is_Indic_Syllabic_Category=-Consonant_Succeeding_Repha}', "");
    Expect(0, 43395, '\P{^Is_Indic_Syllabic_Category=-Consonant_Succeeding_Repha}', "");
    Error('\p{Is_InSC= /a/Consonant_Succeeding_Repha}');
    Error('\P{Is_InSC= /a/Consonant_Succeeding_Repha}');
    Expect(1, 43394, '\p{Is_InSC=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\p{^Is_InSC=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\P{Is_InSC=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\P{^Is_InSC=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\p{Is_InSC=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\p{^Is_InSC=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\P{Is_InSC=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\P{^Is_InSC=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\p{Is_InSC=--Consonant_SUCCEEDING_Repha}', "");
    Expect(0, 43394, '\p{^Is_InSC=--Consonant_SUCCEEDING_Repha}', "");
    Expect(0, 43394, '\P{Is_InSC=--Consonant_SUCCEEDING_Repha}', "");
    Expect(1, 43394, '\P{^Is_InSC=--Consonant_SUCCEEDING_Repha}', "");
    Expect(0, 43395, '\p{Is_InSC=--Consonant_SUCCEEDING_Repha}', "");
    Expect(1, 43395, '\p{^Is_InSC=--Consonant_SUCCEEDING_Repha}', "");
    Expect(1, 43395, '\P{Is_InSC=--Consonant_SUCCEEDING_Repha}', "");
    Expect(0, 43395, '\P{^Is_InSC=--Consonant_SUCCEEDING_Repha}', "");
    Error('\p{Indic_Syllabic_Category=/a/_ CONSONANT_With_Stacker}');
    Error('\P{Indic_Syllabic_Category=/a/_ CONSONANT_With_Stacker}');
    Expect(1, 69636, '\p{Indic_Syllabic_Category:consonantwithstacker}', "");
    Expect(0, 69636, '\p{^Indic_Syllabic_Category:consonantwithstacker}', "");
    Expect(0, 69636, '\P{Indic_Syllabic_Category:consonantwithstacker}', "");
    Expect(1, 69636, '\P{^Indic_Syllabic_Category:consonantwithstacker}', "");
    Expect(0, 69637, '\p{Indic_Syllabic_Category:consonantwithstacker}', "");
    Expect(1, 69637, '\p{^Indic_Syllabic_Category:consonantwithstacker}', "");
    Expect(1, 69637, '\P{Indic_Syllabic_Category:consonantwithstacker}', "");
    Expect(0, 69637, '\P{^Indic_Syllabic_Category:consonantwithstacker}', "");
    Expect(1, 69636, '\p{Indic_Syllabic_Category=		Consonant_With_Stacker}', "");
    Expect(0, 69636, '\p{^Indic_Syllabic_Category=		Consonant_With_Stacker}', "");
    Expect(0, 69636, '\P{Indic_Syllabic_Category=		Consonant_With_Stacker}', "");
    Expect(1, 69636, '\P{^Indic_Syllabic_Category=		Consonant_With_Stacker}', "");
    Expect(0, 69637, '\p{Indic_Syllabic_Category=		Consonant_With_Stacker}', "");
    Expect(1, 69637, '\p{^Indic_Syllabic_Category=		Consonant_With_Stacker}', "");
    Expect(1, 69637, '\P{Indic_Syllabic_Category=		Consonant_With_Stacker}', "");
    Expect(0, 69637, '\P{^Indic_Syllabic_Category=		Consonant_With_Stacker}', "");
    Error('\p{InSC=/a/-consonant_With_stacker}');
    Error('\P{InSC=/a/-consonant_With_stacker}');
    Expect(1, 69636, '\p{InSC=consonantwithstacker}', "");
    Expect(0, 69636, '\p{^InSC=consonantwithstacker}', "");
    Expect(0, 69636, '\P{InSC=consonantwithstacker}', "");
    Expect(1, 69636, '\P{^InSC=consonantwithstacker}', "");
    Expect(0, 69637, '\p{InSC=consonantwithstacker}', "");
    Expect(1, 69637, '\p{^InSC=consonantwithstacker}', "");
    Expect(1, 69637, '\P{InSC=consonantwithstacker}', "");
    Expect(0, 69637, '\P{^InSC=consonantwithstacker}', "");
    Expect(1, 69636, '\p{InSC=_Consonant_With_Stacker}', "");
    Expect(0, 69636, '\p{^InSC=_Consonant_With_Stacker}', "");
    Expect(0, 69636, '\P{InSC=_Consonant_With_Stacker}', "");
    Expect(1, 69636, '\P{^InSC=_Consonant_With_Stacker}', "");
    Expect(0, 69637, '\p{InSC=_Consonant_With_Stacker}', "");
    Expect(1, 69637, '\p{^InSC=_Consonant_With_Stacker}', "");
    Expect(1, 69637, '\P{InSC=_Consonant_With_Stacker}', "");
    Expect(0, 69637, '\P{^InSC=_Consonant_With_Stacker}', "");
    Error('\p{Is_Indic_Syllabic_Category=-Consonant_With_STACKER/a/}');
    Error('\P{Is_Indic_Syllabic_Category=-Consonant_With_STACKER/a/}');
    Expect(1, 69636, '\p{Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(0, 69636, '\p{^Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(0, 69636, '\P{Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(1, 69636, '\P{^Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(0, 69637, '\p{Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(1, 69637, '\p{^Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(1, 69637, '\P{Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(0, 69637, '\P{^Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(1, 69636, '\p{Is_Indic_Syllabic_Category= _Consonant_With_Stacker}', "");
    Expect(0, 69636, '\p{^Is_Indic_Syllabic_Category= _Consonant_With_Stacker}', "");
    Expect(0, 69636, '\P{Is_Indic_Syllabic_Category= _Consonant_With_Stacker}', "");
    Expect(1, 69636, '\P{^Is_Indic_Syllabic_Category= _Consonant_With_Stacker}', "");
    Expect(0, 69637, '\p{Is_Indic_Syllabic_Category= _Consonant_With_Stacker}', "");
    Expect(1, 69637, '\p{^Is_Indic_Syllabic_Category= _Consonant_With_Stacker}', "");
    Expect(1, 69637, '\P{Is_Indic_Syllabic_Category= _Consonant_With_Stacker}', "");
    Expect(0, 69637, '\P{^Is_Indic_Syllabic_Category= _Consonant_With_Stacker}', "");
    Error('\p{Is_InSC=:=_Consonant_With_STACKER}');
    Error('\P{Is_InSC=:=_Consonant_With_STACKER}');
    Expect(1, 69636, '\p{Is_InSC=consonantwithstacker}', "");
    Expect(0, 69636, '\p{^Is_InSC=consonantwithstacker}', "");
    Expect(0, 69636, '\P{Is_InSC=consonantwithstacker}', "");
    Expect(1, 69636, '\P{^Is_InSC=consonantwithstacker}', "");
    Expect(0, 69637, '\p{Is_InSC=consonantwithstacker}', "");
    Expect(1, 69637, '\p{^Is_InSC=consonantwithstacker}', "");
    Expect(1, 69637, '\P{Is_InSC=consonantwithstacker}', "");
    Expect(0, 69637, '\P{^Is_InSC=consonantwithstacker}', "");
    Expect(1, 69636, '\p{Is_InSC=	consonant_With_Stacker}', "");
    Expect(0, 69636, '\p{^Is_InSC=	consonant_With_Stacker}', "");
    Expect(0, 69636, '\P{Is_InSC=	consonant_With_Stacker}', "");
    Expect(1, 69636, '\P{^Is_InSC=	consonant_With_Stacker}', "");
    Expect(0, 69637, '\p{Is_InSC=	consonant_With_Stacker}', "");
    Expect(1, 69637, '\p{^Is_InSC=	consonant_With_Stacker}', "");
    Expect(1, 69637, '\P{Is_InSC=	consonant_With_Stacker}', "");
    Expect(0, 69637, '\P{^Is_InSC=	consonant_With_Stacker}', "");
    Error('\p{Indic_Syllabic_Category=_-Gemination_MARK:=}');
    Error('\P{Indic_Syllabic_Category=_-Gemination_MARK:=}');
    Expect(1, 72344, '\p{Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72344, '\p{^Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72344, '\P{Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72344, '\P{^Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72345, '\p{Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72345, '\p{^Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72345, '\P{Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72345, '\P{^Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72344, '\p{Indic_Syllabic_Category=--Gemination_mark}', "");
    Expect(0, 72344, '\p{^Indic_Syllabic_Category=--Gemination_mark}', "");
    Expect(0, 72344, '\P{Indic_Syllabic_Category=--Gemination_mark}', "");
    Expect(1, 72344, '\P{^Indic_Syllabic_Category=--Gemination_mark}', "");
    Expect(0, 72345, '\p{Indic_Syllabic_Category=--Gemination_mark}', "");
    Expect(1, 72345, '\p{^Indic_Syllabic_Category=--Gemination_mark}', "");
    Expect(1, 72345, '\P{Indic_Syllabic_Category=--Gemination_mark}', "");
    Expect(0, 72345, '\P{^Indic_Syllabic_Category=--Gemination_mark}', "");
    Error('\p{InSC=-:=Gemination_mark}');
    Error('\P{InSC=-:=Gemination_mark}');
    Expect(1, 72344, '\p{InSC: geminationmark}', "");
    Expect(0, 72344, '\p{^InSC: geminationmark}', "");
    Expect(0, 72344, '\P{InSC: geminationmark}', "");
    Expect(1, 72344, '\P{^InSC: geminationmark}', "");
    Expect(0, 72345, '\p{InSC: geminationmark}', "");
    Expect(1, 72345, '\p{^InSC: geminationmark}', "");
    Expect(1, 72345, '\P{InSC: geminationmark}', "");
    Expect(0, 72345, '\P{^InSC: geminationmark}', "");
    Expect(1, 72344, '\p{InSC=--Gemination_MARK}', "");
    Expect(0, 72344, '\p{^InSC=--Gemination_MARK}', "");
    Expect(0, 72344, '\P{InSC=--Gemination_MARK}', "");
    Expect(1, 72344, '\P{^InSC=--Gemination_MARK}', "");
    Expect(0, 72345, '\p{InSC=--Gemination_MARK}', "");
    Expect(1, 72345, '\p{^InSC=--Gemination_MARK}', "");
    Expect(1, 72345, '\P{InSC=--Gemination_MARK}', "");
    Expect(0, 72345, '\P{^InSC=--Gemination_MARK}', "");
    Error('\p{Is_Indic_Syllabic_Category=_:=Gemination_MARK}');
    Error('\P{Is_Indic_Syllabic_Category=_:=Gemination_MARK}');
    Expect(1, 72344, '\p{Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72344, '\p{^Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72344, '\P{Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72344, '\P{^Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72345, '\p{Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72345, '\p{^Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72345, '\P{Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72345, '\P{^Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72344, '\p{Is_Indic_Syllabic_Category=GEMINATION_Mark}', "");
    Expect(0, 72344, '\p{^Is_Indic_Syllabic_Category=GEMINATION_Mark}', "");
    Expect(0, 72344, '\P{Is_Indic_Syllabic_Category=GEMINATION_Mark}', "");
    Expect(1, 72344, '\P{^Is_Indic_Syllabic_Category=GEMINATION_Mark}', "");
    Expect(0, 72345, '\p{Is_Indic_Syllabic_Category=GEMINATION_Mark}', "");
    Expect(1, 72345, '\p{^Is_Indic_Syllabic_Category=GEMINATION_Mark}', "");
    Expect(1, 72345, '\P{Is_Indic_Syllabic_Category=GEMINATION_Mark}', "");
    Expect(0, 72345, '\P{^Is_Indic_Syllabic_Category=GEMINATION_Mark}', "");
    Error('\p{Is_InSC=/a/ Gemination_Mark}');
    Error('\P{Is_InSC=/a/ Gemination_Mark}');
    Expect(1, 72344, '\p{Is_InSC=geminationmark}', "");
    Expect(0, 72344, '\p{^Is_InSC=geminationmark}', "");
    Expect(0, 72344, '\P{Is_InSC=geminationmark}', "");
    Expect(1, 72344, '\P{^Is_InSC=geminationmark}', "");
    Expect(0, 72345, '\p{Is_InSC=geminationmark}', "");
    Expect(1, 72345, '\p{^Is_InSC=geminationmark}', "");
    Expect(1, 72345, '\P{Is_InSC=geminationmark}', "");
    Expect(0, 72345, '\P{^Is_InSC=geminationmark}', "");
    Expect(1, 72344, '\p{Is_InSC=	 gemination_Mark}', "");
    Expect(0, 72344, '\p{^Is_InSC=	 gemination_Mark}', "");
    Expect(0, 72344, '\P{Is_InSC=	 gemination_Mark}', "");
    Expect(1, 72344, '\P{^Is_InSC=	 gemination_Mark}', "");
    Expect(0, 72345, '\p{Is_InSC=	 gemination_Mark}', "");
    Expect(1, 72345, '\p{^Is_InSC=	 gemination_Mark}', "");
    Expect(1, 72345, '\P{Is_InSC=	 gemination_Mark}', "");
    Expect(0, 72345, '\P{^Is_InSC=	 gemination_Mark}', "");
    Error('\p{Indic_Syllabic_Category=/a/		Invisible_Stacker}');
    Error('\P{Indic_Syllabic_Category=/a/		Invisible_Stacker}');
    Expect(1, 73029, '\p{Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73029, '\p{^Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73029, '\P{Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73029, '\P{^Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73030, '\p{Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73030, '\p{^Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73030, '\P{Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73030, '\P{^Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73029, '\p{Indic_Syllabic_Category=	 invisible_Stacker}', "");
    Expect(0, 73029, '\p{^Indic_Syllabic_Category=	 invisible_Stacker}', "");
    Expect(0, 73029, '\P{Indic_Syllabic_Category=	 invisible_Stacker}', "");
    Expect(1, 73029, '\P{^Indic_Syllabic_Category=	 invisible_Stacker}', "");
    Expect(0, 73030, '\p{Indic_Syllabic_Category=	 invisible_Stacker}', "");
    Expect(1, 73030, '\p{^Indic_Syllabic_Category=	 invisible_Stacker}', "");
    Expect(1, 73030, '\P{Indic_Syllabic_Category=	 invisible_Stacker}', "");
    Expect(0, 73030, '\P{^Indic_Syllabic_Category=	 invisible_Stacker}', "");
    Error('\p{InSC=-/a/Invisible_STACKER}');
    Error('\P{InSC=-/a/Invisible_STACKER}');
    Expect(1, 73029, '\p{InSC=invisiblestacker}', "");
    Expect(0, 73029, '\p{^InSC=invisiblestacker}', "");
    Expect(0, 73029, '\P{InSC=invisiblestacker}', "");
    Expect(1, 73029, '\P{^InSC=invisiblestacker}', "");
    Expect(0, 73030, '\p{InSC=invisiblestacker}', "");
    Expect(1, 73030, '\p{^InSC=invisiblestacker}', "");
    Expect(1, 73030, '\P{InSC=invisiblestacker}', "");
    Expect(0, 73030, '\P{^InSC=invisiblestacker}', "");
    Expect(1, 73029, '\p{InSC=	-Invisible_STACKER}', "");
    Expect(0, 73029, '\p{^InSC=	-Invisible_STACKER}', "");
    Expect(0, 73029, '\P{InSC=	-Invisible_STACKER}', "");
    Expect(1, 73029, '\P{^InSC=	-Invisible_STACKER}', "");
    Expect(0, 73030, '\p{InSC=	-Invisible_STACKER}', "");
    Expect(1, 73030, '\p{^InSC=	-Invisible_STACKER}', "");
    Expect(1, 73030, '\P{InSC=	-Invisible_STACKER}', "");
    Expect(0, 73030, '\P{^InSC=	-Invisible_STACKER}', "");
    Error('\p{Is_Indic_Syllabic_Category=_Invisible_STACKER/a/}');
    Error('\P{Is_Indic_Syllabic_Category=_Invisible_STACKER/a/}');
    Expect(1, 73029, '\p{Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73029, '\p{^Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73029, '\P{Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73029, '\P{^Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73030, '\p{Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73030, '\p{^Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73030, '\P{Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73030, '\P{^Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73029, '\p{Is_Indic_Syllabic_Category=- Invisible_STACKER}', "");
    Expect(0, 73029, '\p{^Is_Indic_Syllabic_Category=- Invisible_STACKER}', "");
    Expect(0, 73029, '\P{Is_Indic_Syllabic_Category=- Invisible_STACKER}', "");
    Expect(1, 73029, '\P{^Is_Indic_Syllabic_Category=- Invisible_STACKER}', "");
    Expect(0, 73030, '\p{Is_Indic_Syllabic_Category=- Invisible_STACKER}', "");
    Expect(1, 73030, '\p{^Is_Indic_Syllabic_Category=- Invisible_STACKER}', "");
    Expect(1, 73030, '\P{Is_Indic_Syllabic_Category=- Invisible_STACKER}', "");
    Expect(0, 73030, '\P{^Is_Indic_Syllabic_Category=- Invisible_STACKER}', "");
    Error('\p{Is_InSC=/a/-Invisible_Stacker}');
    Error('\P{Is_InSC=/a/-Invisible_Stacker}');
    Expect(1, 73029, '\p{Is_InSC=invisiblestacker}', "");
    Expect(0, 73029, '\p{^Is_InSC=invisiblestacker}', "");
    Expect(0, 73029, '\P{Is_InSC=invisiblestacker}', "");
    Expect(1, 73029, '\P{^Is_InSC=invisiblestacker}', "");
    Expect(0, 73030, '\p{Is_InSC=invisiblestacker}', "");
    Expect(1, 73030, '\p{^Is_InSC=invisiblestacker}', "");
    Expect(1, 73030, '\P{Is_InSC=invisiblestacker}', "");
    Expect(0, 73030, '\P{^Is_InSC=invisiblestacker}', "");
    Expect(1, 73029, '\p{Is_InSC=-INVISIBLE_Stacker}', "");
    Expect(0, 73029, '\p{^Is_InSC=-INVISIBLE_Stacker}', "");
    Expect(0, 73029, '\P{Is_InSC=-INVISIBLE_Stacker}', "");
    Expect(1, 73029, '\P{^Is_InSC=-INVISIBLE_Stacker}', "");
    Expect(0, 73030, '\p{Is_InSC=-INVISIBLE_Stacker}', "");
    Expect(1, 73030, '\p{^Is_InSC=-INVISIBLE_Stacker}', "");
    Expect(1, 73030, '\P{Is_InSC=-INVISIBLE_Stacker}', "");
    Expect(0, 73030, '\P{^Is_InSC=-INVISIBLE_Stacker}', "");
    Error('\p{Indic_Syllabic_Category= /a/Joiner}');
    Error('\P{Indic_Syllabic_Category= /a/Joiner}');
    Expect(1, 8205, '\p{Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8205, '\p{^Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8205, '\P{Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8205, '\P{^Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8206, '\p{Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8206, '\p{^Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8206, '\P{Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8206, '\P{^Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8205, '\p{Indic_Syllabic_Category: _-Joiner}', "");
    Expect(0, 8205, '\p{^Indic_Syllabic_Category: _-Joiner}', "");
    Expect(0, 8205, '\P{Indic_Syllabic_Category: _-Joiner}', "");
    Expect(1, 8205, '\P{^Indic_Syllabic_Category: _-Joiner}', "");
    Expect(0, 8206, '\p{Indic_Syllabic_Category: _-Joiner}', "");
    Expect(1, 8206, '\p{^Indic_Syllabic_Category: _-Joiner}', "");
    Expect(1, 8206, '\P{Indic_Syllabic_Category: _-Joiner}', "");
    Expect(0, 8206, '\P{^Indic_Syllabic_Category: _-Joiner}', "");
    Error('\p{InSC: 	/a/joiner}');
    Error('\P{InSC: 	/a/joiner}');
    Expect(1, 8205, '\p{InSC:	joiner}', "");
    Expect(0, 8205, '\p{^InSC:	joiner}', "");
    Expect(0, 8205, '\P{InSC:	joiner}', "");
    Expect(1, 8205, '\P{^InSC:	joiner}', "");
    Expect(0, 8206, '\p{InSC:	joiner}', "");
    Expect(1, 8206, '\p{^InSC:	joiner}', "");
    Expect(1, 8206, '\P{InSC:	joiner}', "");
    Expect(0, 8206, '\P{^InSC:	joiner}', "");
    Expect(1, 8205, '\p{InSC=_Joiner}', "");
    Expect(0, 8205, '\p{^InSC=_Joiner}', "");
    Expect(0, 8205, '\P{InSC=_Joiner}', "");
    Expect(1, 8205, '\P{^InSC=_Joiner}', "");
    Expect(0, 8206, '\p{InSC=_Joiner}', "");
    Expect(1, 8206, '\p{^InSC=_Joiner}', "");
    Expect(1, 8206, '\P{InSC=_Joiner}', "");
    Expect(0, 8206, '\P{^InSC=_Joiner}', "");
    Error('\p{Is_Indic_Syllabic_Category= /a/Joiner}');
    Error('\P{Is_Indic_Syllabic_Category= /a/Joiner}');
    Expect(1, 8205, '\p{Is_Indic_Syllabic_Category:   joiner}', "");
    Expect(0, 8205, '\p{^Is_Indic_Syllabic_Category:   joiner}', "");
    Expect(0, 8205, '\P{Is_Indic_Syllabic_Category:   joiner}', "");
    Expect(1, 8205, '\P{^Is_Indic_Syllabic_Category:   joiner}', "");
    Expect(0, 8206, '\p{Is_Indic_Syllabic_Category:   joiner}', "");
    Expect(1, 8206, '\p{^Is_Indic_Syllabic_Category:   joiner}', "");
    Expect(1, 8206, '\P{Is_Indic_Syllabic_Category:   joiner}', "");
    Expect(0, 8206, '\P{^Is_Indic_Syllabic_Category:   joiner}', "");
    Expect(1, 8205, '\p{Is_Indic_Syllabic_Category=	 Joiner}', "");
    Expect(0, 8205, '\p{^Is_Indic_Syllabic_Category=	 Joiner}', "");
    Expect(0, 8205, '\P{Is_Indic_Syllabic_Category=	 Joiner}', "");
    Expect(1, 8205, '\P{^Is_Indic_Syllabic_Category=	 Joiner}', "");
    Expect(0, 8206, '\p{Is_Indic_Syllabic_Category=	 Joiner}', "");
    Expect(1, 8206, '\p{^Is_Indic_Syllabic_Category=	 Joiner}', "");
    Expect(1, 8206, '\P{Is_Indic_Syllabic_Category=	 Joiner}', "");
    Expect(0, 8206, '\P{^Is_Indic_Syllabic_Category=	 Joiner}', "");
    Error('\p{Is_InSC=_:=Joiner}');
    Error('\P{Is_InSC=_:=Joiner}');
    Expect(1, 8205, '\p{Is_InSC=joiner}', "");
    Expect(0, 8205, '\p{^Is_InSC=joiner}', "");
    Expect(0, 8205, '\P{Is_InSC=joiner}', "");
    Expect(1, 8205, '\P{^Is_InSC=joiner}', "");
    Expect(0, 8206, '\p{Is_InSC=joiner}', "");
    Expect(1, 8206, '\p{^Is_InSC=joiner}', "");
    Expect(1, 8206, '\P{Is_InSC=joiner}', "");
    Expect(0, 8206, '\P{^Is_InSC=joiner}', "");
    Expect(1, 8205, '\p{Is_InSC=-Joiner}', "");
    Expect(0, 8205, '\p{^Is_InSC=-Joiner}', "");
    Expect(0, 8205, '\P{Is_InSC=-Joiner}', "");
    Expect(1, 8205, '\P{^Is_InSC=-Joiner}', "");
    Expect(0, 8206, '\p{Is_InSC=-Joiner}', "");
    Expect(1, 8206, '\p{^Is_InSC=-Joiner}', "");
    Expect(1, 8206, '\P{Is_InSC=-Joiner}', "");
    Expect(0, 8206, '\P{^Is_InSC=-Joiner}', "");
    Error('\p{Indic_Syllabic_Category=- Modifying_LETTER:=}');
    Error('\P{Indic_Syllabic_Category=- Modifying_LETTER:=}');
    Expect(1, 2947, '\p{Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2947, '\p{^Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2947, '\P{Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2947, '\P{^Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2948, '\p{Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2948, '\p{^Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2948, '\P{Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2948, '\P{^Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2947, '\p{Indic_Syllabic_Category= 	MODIFYING_Letter}', "");
    Expect(0, 2947, '\p{^Indic_Syllabic_Category= 	MODIFYING_Letter}', "");
    Expect(0, 2947, '\P{Indic_Syllabic_Category= 	MODIFYING_Letter}', "");
    Expect(1, 2947, '\P{^Indic_Syllabic_Category= 	MODIFYING_Letter}', "");
    Expect(0, 2948, '\p{Indic_Syllabic_Category= 	MODIFYING_Letter}', "");
    Expect(1, 2948, '\p{^Indic_Syllabic_Category= 	MODIFYING_Letter}', "");
    Expect(1, 2948, '\P{Indic_Syllabic_Category= 	MODIFYING_Letter}', "");
    Expect(0, 2948, '\P{^Indic_Syllabic_Category= 	MODIFYING_Letter}', "");
    Error('\p{InSC=_:=modifying_Letter}');
    Error('\P{InSC=_:=modifying_Letter}');
    Expect(1, 2947, '\p{InSC=modifyingletter}', "");
    Expect(0, 2947, '\p{^InSC=modifyingletter}', "");
    Expect(0, 2947, '\P{InSC=modifyingletter}', "");
    Expect(1, 2947, '\P{^InSC=modifyingletter}', "");
    Expect(0, 2948, '\p{InSC=modifyingletter}', "");
    Expect(1, 2948, '\p{^InSC=modifyingletter}', "");
    Expect(1, 2948, '\P{InSC=modifyingletter}', "");
    Expect(0, 2948, '\P{^InSC=modifyingletter}', "");
    Expect(1, 2947, '\p{InSC=-	modifying_LETTER}', "");
    Expect(0, 2947, '\p{^InSC=-	modifying_LETTER}', "");
    Expect(0, 2947, '\P{InSC=-	modifying_LETTER}', "");
    Expect(1, 2947, '\P{^InSC=-	modifying_LETTER}', "");
    Expect(0, 2948, '\p{InSC=-	modifying_LETTER}', "");
    Expect(1, 2948, '\p{^InSC=-	modifying_LETTER}', "");
    Expect(1, 2948, '\P{InSC=-	modifying_LETTER}', "");
    Expect(0, 2948, '\P{^InSC=-	modifying_LETTER}', "");
    Error('\p{Is_Indic_Syllabic_Category=-:=Modifying_letter}');
    Error('\P{Is_Indic_Syllabic_Category=-:=Modifying_letter}');
    Expect(1, 2947, '\p{Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2947, '\p{^Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2947, '\P{Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2947, '\P{^Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2948, '\p{Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2948, '\p{^Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2948, '\P{Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2948, '\P{^Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2947, '\p{Is_Indic_Syllabic_Category=--Modifying_letter}', "");
    Expect(0, 2947, '\p{^Is_Indic_Syllabic_Category=--Modifying_letter}', "");
    Expect(0, 2947, '\P{Is_Indic_Syllabic_Category=--Modifying_letter}', "");
    Expect(1, 2947, '\P{^Is_Indic_Syllabic_Category=--Modifying_letter}', "");
    Expect(0, 2948, '\p{Is_Indic_Syllabic_Category=--Modifying_letter}', "");
    Expect(1, 2948, '\p{^Is_Indic_Syllabic_Category=--Modifying_letter}', "");
    Expect(1, 2948, '\P{Is_Indic_Syllabic_Category=--Modifying_letter}', "");
    Expect(0, 2948, '\P{^Is_Indic_Syllabic_Category=--Modifying_letter}', "");
    Error('\p{Is_InSC=_/a/Modifying_Letter}');
    Error('\P{Is_InSC=_/a/Modifying_Letter}');
    Expect(1, 2947, '\p{Is_InSC=modifyingletter}', "");
    Expect(0, 2947, '\p{^Is_InSC=modifyingletter}', "");
    Expect(0, 2947, '\P{Is_InSC=modifyingletter}', "");
    Expect(1, 2947, '\P{^Is_InSC=modifyingletter}', "");
    Expect(0, 2948, '\p{Is_InSC=modifyingletter}', "");
    Expect(1, 2948, '\p{^Is_InSC=modifyingletter}', "");
    Expect(1, 2948, '\P{Is_InSC=modifyingletter}', "");
    Expect(0, 2948, '\P{^Is_InSC=modifyingletter}', "");
    Expect(1, 2947, '\p{Is_InSC=-modifying_LETTER}', "");
    Expect(0, 2947, '\p{^Is_InSC=-modifying_LETTER}', "");
    Expect(0, 2947, '\P{Is_InSC=-modifying_LETTER}', "");
    Expect(1, 2947, '\P{^Is_InSC=-modifying_LETTER}', "");
    Expect(0, 2948, '\p{Is_InSC=-modifying_LETTER}', "");
    Expect(1, 2948, '\p{^Is_InSC=-modifying_LETTER}', "");
    Expect(1, 2948, '\P{Is_InSC=-modifying_LETTER}', "");
    Expect(0, 2948, '\P{^Is_InSC=-modifying_LETTER}', "");
    Error('\p{Indic_Syllabic_Category=/a/	Non_JOINER}');
    Error('\P{Indic_Syllabic_Category=/a/	Non_JOINER}');
    Expect(1, 8204, '\p{Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8204, '\p{^Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8204, '\P{Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8204, '\P{^Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8205, '\p{Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8205, '\p{^Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8205, '\P{Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8205, '\P{^Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8204, '\p{Indic_Syllabic_Category=  Non_Joiner}', "");
    Expect(0, 8204, '\p{^Indic_Syllabic_Category=  Non_Joiner}', "");
    Expect(0, 8204, '\P{Indic_Syllabic_Category=  Non_Joiner}', "");
    Expect(1, 8204, '\P{^Indic_Syllabic_Category=  Non_Joiner}', "");
    Expect(0, 8205, '\p{Indic_Syllabic_Category=  Non_Joiner}', "");
    Expect(1, 8205, '\p{^Indic_Syllabic_Category=  Non_Joiner}', "");
    Expect(1, 8205, '\P{Indic_Syllabic_Category=  Non_Joiner}', "");
    Expect(0, 8205, '\P{^Indic_Syllabic_Category=  Non_Joiner}', "");
    Error('\p{InSC= /a/non_Joiner}');
    Error('\P{InSC= /a/non_Joiner}');
    Expect(1, 8204, '\p{InSC=nonjoiner}', "");
    Expect(0, 8204, '\p{^InSC=nonjoiner}', "");
    Expect(0, 8204, '\P{InSC=nonjoiner}', "");
    Expect(1, 8204, '\P{^InSC=nonjoiner}', "");
    Expect(0, 8205, '\p{InSC=nonjoiner}', "");
    Expect(1, 8205, '\p{^InSC=nonjoiner}', "");
    Expect(1, 8205, '\P{InSC=nonjoiner}', "");
    Expect(0, 8205, '\P{^InSC=nonjoiner}', "");
    Expect(1, 8204, '\p{InSC= non_JOINER}', "");
    Expect(0, 8204, '\p{^InSC= non_JOINER}', "");
    Expect(0, 8204, '\P{InSC= non_JOINER}', "");
    Expect(1, 8204, '\P{^InSC= non_JOINER}', "");
    Expect(0, 8205, '\p{InSC= non_JOINER}', "");
    Expect(1, 8205, '\p{^InSC= non_JOINER}', "");
    Expect(1, 8205, '\P{InSC= non_JOINER}', "");
    Expect(0, 8205, '\P{^InSC= non_JOINER}', "");
    Error('\p{Is_Indic_Syllabic_Category=:=	_Non_Joiner}');
    Error('\P{Is_Indic_Syllabic_Category=:=	_Non_Joiner}');
    Expect(1, 8204, '\p{Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8204, '\p{^Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8204, '\P{Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8204, '\P{^Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8205, '\p{Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8205, '\p{^Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8205, '\P{Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8205, '\P{^Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8204, '\p{Is_Indic_Syllabic_Category= NON_joiner}', "");
    Expect(0, 8204, '\p{^Is_Indic_Syllabic_Category= NON_joiner}', "");
    Expect(0, 8204, '\P{Is_Indic_Syllabic_Category= NON_joiner}', "");
    Expect(1, 8204, '\P{^Is_Indic_Syllabic_Category= NON_joiner}', "");
    Expect(0, 8205, '\p{Is_Indic_Syllabic_Category= NON_joiner}', "");
    Expect(1, 8205, '\p{^Is_Indic_Syllabic_Category= NON_joiner}', "");
    Expect(1, 8205, '\P{Is_Indic_Syllabic_Category= NON_joiner}', "");
    Expect(0, 8205, '\P{^Is_Indic_Syllabic_Category= NON_joiner}', "");
    Error('\p{Is_InSC=-NON_Joiner/a/}');
    Error('\P{Is_InSC=-NON_Joiner/a/}');
    Expect(1, 8204, '\p{Is_InSC=nonjoiner}', "");
    Expect(0, 8204, '\p{^Is_InSC=nonjoiner}', "");
    Expect(0, 8204, '\P{Is_InSC=nonjoiner}', "");
    Expect(1, 8204, '\P{^Is_InSC=nonjoiner}', "");
    Expect(0, 8205, '\p{Is_InSC=nonjoiner}', "");
    Expect(1, 8205, '\p{^Is_InSC=nonjoiner}', "");
    Expect(1, 8205, '\P{Is_InSC=nonjoiner}', "");
    Expect(0, 8205, '\P{^Is_InSC=nonjoiner}', "");
    Expect(1, 8204, '\p{Is_InSC=  Non_Joiner}', "");
    Expect(0, 8204, '\p{^Is_InSC=  Non_Joiner}', "");
    Expect(0, 8204, '\P{Is_InSC=  Non_Joiner}', "");
    Expect(1, 8204, '\P{^Is_InSC=  Non_Joiner}', "");
    Expect(0, 8205, '\p{Is_InSC=  Non_Joiner}', "");
    Expect(1, 8205, '\p{^Is_InSC=  Non_Joiner}', "");
    Expect(1, 8205, '\P{Is_InSC=  Non_Joiner}', "");
    Expect(0, 8205, '\P{^Is_InSC=  Non_Joiner}', "");
    Error('\p{Indic_Syllabic_Category=/a/	-NUKTA}');
    Error('\P{Indic_Syllabic_Category=/a/	-NUKTA}');
    Expect(1, 73026, '\p{Indic_Syllabic_Category=nukta}', "");
    Expect(0, 73026, '\p{^Indic_Syllabic_Category=nukta}', "");
    Expect(0, 73026, '\P{Indic_Syllabic_Category=nukta}', "");
    Expect(1, 73026, '\P{^Indic_Syllabic_Category=nukta}', "");
    Expect(0, 73027, '\p{Indic_Syllabic_Category=nukta}', "");
    Expect(1, 73027, '\p{^Indic_Syllabic_Category=nukta}', "");
    Expect(1, 73027, '\P{Indic_Syllabic_Category=nukta}', "");
    Expect(0, 73027, '\P{^Indic_Syllabic_Category=nukta}', "");
    Expect(1, 73026, '\p{Indic_Syllabic_Category=NUKTA}', "");
    Expect(0, 73026, '\p{^Indic_Syllabic_Category=NUKTA}', "");
    Expect(0, 73026, '\P{Indic_Syllabic_Category=NUKTA}', "");
    Expect(1, 73026, '\P{^Indic_Syllabic_Category=NUKTA}', "");
    Expect(0, 73027, '\p{Indic_Syllabic_Category=NUKTA}', "");
    Expect(1, 73027, '\p{^Indic_Syllabic_Category=NUKTA}', "");
    Expect(1, 73027, '\P{Indic_Syllabic_Category=NUKTA}', "");
    Expect(0, 73027, '\P{^Indic_Syllabic_Category=NUKTA}', "");
    Error('\p{InSC=	Nukta/a/}');
    Error('\P{InSC=	Nukta/a/}');
    Expect(1, 73026, '\p{InSC=nukta}', "");
    Expect(0, 73026, '\p{^InSC=nukta}', "");
    Expect(0, 73026, '\P{InSC=nukta}', "");
    Expect(1, 73026, '\P{^InSC=nukta}', "");
    Expect(0, 73027, '\p{InSC=nukta}', "");
    Expect(1, 73027, '\p{^InSC=nukta}', "");
    Expect(1, 73027, '\P{InSC=nukta}', "");
    Expect(0, 73027, '\P{^InSC=nukta}', "");
    Expect(1, 73026, '\p{InSC=_nukta}', "");
    Expect(0, 73026, '\p{^InSC=_nukta}', "");
    Expect(0, 73026, '\P{InSC=_nukta}', "");
    Expect(1, 73026, '\P{^InSC=_nukta}', "");
    Expect(0, 73027, '\p{InSC=_nukta}', "");
    Expect(1, 73027, '\p{^InSC=_nukta}', "");
    Expect(1, 73027, '\P{InSC=_nukta}', "");
    Expect(0, 73027, '\P{^InSC=_nukta}', "");
    Error('\p{Is_Indic_Syllabic_Category=:=_NUKTA}');
    Error('\P{Is_Indic_Syllabic_Category=:=_NUKTA}');
    Expect(1, 73026, '\p{Is_Indic_Syllabic_Category=nukta}', "");
    Expect(0, 73026, '\p{^Is_Indic_Syllabic_Category=nukta}', "");
    Expect(0, 73026, '\P{Is_Indic_Syllabic_Category=nukta}', "");
    Expect(1, 73026, '\P{^Is_Indic_Syllabic_Category=nukta}', "");
    Expect(0, 73027, '\p{Is_Indic_Syllabic_Category=nukta}', "");
    Expect(1, 73027, '\p{^Is_Indic_Syllabic_Category=nukta}', "");
    Expect(1, 73027, '\P{Is_Indic_Syllabic_Category=nukta}', "");
    Expect(0, 73027, '\P{^Is_Indic_Syllabic_Category=nukta}', "");
    Expect(1, 73026, '\p{Is_Indic_Syllabic_Category=	-Nukta}', "");
    Expect(0, 73026, '\p{^Is_Indic_Syllabic_Category=	-Nukta}', "");
    Expect(0, 73026, '\P{Is_Indic_Syllabic_Category=	-Nukta}', "");
    Expect(1, 73026, '\P{^Is_Indic_Syllabic_Category=	-Nukta}', "");
    Expect(0, 73027, '\p{Is_Indic_Syllabic_Category=	-Nukta}', "");
    Expect(1, 73027, '\p{^Is_Indic_Syllabic_Category=	-Nukta}', "");
    Expect(1, 73027, '\P{Is_Indic_Syllabic_Category=	-Nukta}', "");
    Expect(0, 73027, '\P{^Is_Indic_Syllabic_Category=	-Nukta}', "");
    Error('\p{Is_InSC=-nukta/a/}');
    Error('\P{Is_InSC=-nukta/a/}');
    Expect(1, 73026, '\p{Is_InSC=nukta}', "");
    Expect(0, 73026, '\p{^Is_InSC=nukta}', "");
    Expect(0, 73026, '\P{Is_InSC=nukta}', "");
    Expect(1, 73026, '\P{^Is_InSC=nukta}', "");
    Expect(0, 73027, '\p{Is_InSC=nukta}', "");
    Expect(1, 73027, '\p{^Is_InSC=nukta}', "");
    Expect(1, 73027, '\P{Is_InSC=nukta}', "");
    Expect(0, 73027, '\P{^Is_InSC=nukta}', "");
    Error('\p{Indic_Syllabic_Category=_/a/Number}');
    Error('\P{Indic_Syllabic_Category=_/a/Number}');
    Expect(1, 73049, '\p{Indic_Syllabic_Category=number}', "");
    Expect(0, 73049, '\p{^Indic_Syllabic_Category=number}', "");
    Expect(0, 73049, '\P{Indic_Syllabic_Category=number}', "");
    Expect(1, 73049, '\P{^Indic_Syllabic_Category=number}', "");
    Expect(0, 73050, '\p{Indic_Syllabic_Category=number}', "");
    Expect(1, 73050, '\p{^Indic_Syllabic_Category=number}', "");
    Expect(1, 73050, '\P{Indic_Syllabic_Category=number}', "");
    Expect(0, 73050, '\P{^Indic_Syllabic_Category=number}', "");
    Expect(1, 73049, '\p{Indic_Syllabic_Category=_Number}', "");
    Expect(0, 73049, '\p{^Indic_Syllabic_Category=_Number}', "");
    Expect(0, 73049, '\P{Indic_Syllabic_Category=_Number}', "");
    Expect(1, 73049, '\P{^Indic_Syllabic_Category=_Number}', "");
    Expect(0, 73050, '\p{Indic_Syllabic_Category=_Number}', "");
    Expect(1, 73050, '\p{^Indic_Syllabic_Category=_Number}', "");
    Expect(1, 73050, '\P{Indic_Syllabic_Category=_Number}', "");
    Expect(0, 73050, '\P{^Indic_Syllabic_Category=_Number}', "");
    Error('\p{InSC=	/a/NUMBER}');
    Error('\P{InSC=	/a/NUMBER}');
    Expect(1, 73049, '\p{InSC=number}', "");
    Expect(0, 73049, '\p{^InSC=number}', "");
    Expect(0, 73049, '\P{InSC=number}', "");
    Expect(1, 73049, '\P{^InSC=number}', "");
    Expect(0, 73050, '\p{InSC=number}', "");
    Expect(1, 73050, '\p{^InSC=number}', "");
    Expect(1, 73050, '\P{InSC=number}', "");
    Expect(0, 73050, '\P{^InSC=number}', "");
    Expect(1, 73049, '\p{InSC= -Number}', "");
    Expect(0, 73049, '\p{^InSC= -Number}', "");
    Expect(0, 73049, '\P{InSC= -Number}', "");
    Expect(1, 73049, '\P{^InSC= -Number}', "");
    Expect(0, 73050, '\p{InSC= -Number}', "");
    Expect(1, 73050, '\p{^InSC= -Number}', "");
    Expect(1, 73050, '\P{InSC= -Number}', "");
    Expect(0, 73050, '\P{^InSC= -Number}', "");
    Error('\p{Is_Indic_Syllabic_Category=/a/	number}');
    Error('\P{Is_Indic_Syllabic_Category=/a/	number}');
    Expect(1, 73049, '\p{Is_Indic_Syllabic_Category=number}', "");
    Expect(0, 73049, '\p{^Is_Indic_Syllabic_Category=number}', "");
    Expect(0, 73049, '\P{Is_Indic_Syllabic_Category=number}', "");
    Expect(1, 73049, '\P{^Is_Indic_Syllabic_Category=number}', "");
    Expect(0, 73050, '\p{Is_Indic_Syllabic_Category=number}', "");
    Expect(1, 73050, '\p{^Is_Indic_Syllabic_Category=number}', "");
    Expect(1, 73050, '\P{Is_Indic_Syllabic_Category=number}', "");
    Expect(0, 73050, '\P{^Is_Indic_Syllabic_Category=number}', "");
    Expect(1, 73049, '\p{Is_Indic_Syllabic_Category=- number}', "");
    Expect(0, 73049, '\p{^Is_Indic_Syllabic_Category=- number}', "");
    Expect(0, 73049, '\P{Is_Indic_Syllabic_Category=- number}', "");
    Expect(1, 73049, '\P{^Is_Indic_Syllabic_Category=- number}', "");
    Expect(0, 73050, '\p{Is_Indic_Syllabic_Category=- number}', "");
    Expect(1, 73050, '\p{^Is_Indic_Syllabic_Category=- number}', "");
    Expect(1, 73050, '\P{Is_Indic_Syllabic_Category=- number}', "");
    Expect(0, 73050, '\P{^Is_Indic_Syllabic_Category=- number}', "");
    Error('\p{Is_InSC=:=	Number}');
    Error('\P{Is_InSC=:=	Number}');
    Expect(1, 73049, '\p{Is_InSC=number}', "");
    Expect(0, 73049, '\p{^Is_InSC=number}', "");
    Expect(0, 73049, '\P{Is_InSC=number}', "");
    Expect(1, 73049, '\P{^Is_InSC=number}', "");
    Expect(0, 73050, '\p{Is_InSC=number}', "");
    Expect(1, 73050, '\p{^Is_InSC=number}', "");
    Expect(1, 73050, '\P{Is_InSC=number}', "");
    Expect(0, 73050, '\P{^Is_InSC=number}', "");
    Expect(1, 73049, '\p{Is_InSC=- number}', "");
    Expect(0, 73049, '\p{^Is_InSC=- number}', "");
    Expect(0, 73049, '\P{Is_InSC=- number}', "");
    Expect(1, 73049, '\P{^Is_InSC=- number}', "");
    Expect(0, 73050, '\p{Is_InSC=- number}', "");
    Expect(1, 73050, '\p{^Is_InSC=- number}', "");
    Expect(1, 73050, '\P{Is_InSC=- number}', "");
    Expect(0, 73050, '\P{^Is_InSC=- number}', "");
    Error('\p{Indic_Syllabic_Category: _/a/Number_Joiner}');
    Error('\P{Indic_Syllabic_Category: _/a/Number_Joiner}');
    Expect(1, 69759, '\p{Indic_Syllabic_Category:   numberjoiner}', "");
    Expect(0, 69759, '\p{^Indic_Syllabic_Category:   numberjoiner}', "");
    Expect(0, 69759, '\P{Indic_Syllabic_Category:   numberjoiner}', "");
    Expect(1, 69759, '\P{^Indic_Syllabic_Category:   numberjoiner}', "");
    Expect(0, 69760, '\p{Indic_Syllabic_Category:   numberjoiner}', "");
    Expect(1, 69760, '\p{^Indic_Syllabic_Category:   numberjoiner}', "");
    Expect(1, 69760, '\P{Indic_Syllabic_Category:   numberjoiner}', "");
    Expect(0, 69760, '\P{^Indic_Syllabic_Category:   numberjoiner}', "");
    Expect(1, 69759, '\p{Indic_Syllabic_Category=	_NUMBER_Joiner}', "");
    Expect(0, 69759, '\p{^Indic_Syllabic_Category=	_NUMBER_Joiner}', "");
    Expect(0, 69759, '\P{Indic_Syllabic_Category=	_NUMBER_Joiner}', "");
    Expect(1, 69759, '\P{^Indic_Syllabic_Category=	_NUMBER_Joiner}', "");
    Expect(0, 69760, '\p{Indic_Syllabic_Category=	_NUMBER_Joiner}', "");
    Expect(1, 69760, '\p{^Indic_Syllabic_Category=	_NUMBER_Joiner}', "");
    Expect(1, 69760, '\P{Indic_Syllabic_Category=	_NUMBER_Joiner}', "");
    Expect(0, 69760, '\P{^Indic_Syllabic_Category=	_NUMBER_Joiner}', "");
    Error('\p{InSC= -Number_Joiner:=}');
    Error('\P{InSC= -Number_Joiner:=}');
    Expect(1, 69759, '\p{InSC=numberjoiner}', "");
    Expect(0, 69759, '\p{^InSC=numberjoiner}', "");
    Expect(0, 69759, '\P{InSC=numberjoiner}', "");
    Expect(1, 69759, '\P{^InSC=numberjoiner}', "");
    Expect(0, 69760, '\p{InSC=numberjoiner}', "");
    Expect(1, 69760, '\p{^InSC=numberjoiner}', "");
    Expect(1, 69760, '\P{InSC=numberjoiner}', "");
    Expect(0, 69760, '\P{^InSC=numberjoiner}', "");
    Expect(1, 69759, '\p{InSC= _number_joiner}', "");
    Expect(0, 69759, '\p{^InSC= _number_joiner}', "");
    Expect(0, 69759, '\P{InSC= _number_joiner}', "");
    Expect(1, 69759, '\P{^InSC= _number_joiner}', "");
    Expect(0, 69760, '\p{InSC= _number_joiner}', "");
    Expect(1, 69760, '\p{^InSC= _number_joiner}', "");
    Expect(1, 69760, '\P{InSC= _number_joiner}', "");
    Expect(0, 69760, '\P{^InSC= _number_joiner}', "");
    Error('\p{Is_Indic_Syllabic_Category=	_NUMBER_Joiner/a/}');
    Error('\P{Is_Indic_Syllabic_Category=	_NUMBER_Joiner/a/}');
    Expect(1, 69759, '\p{Is_Indic_Syllabic_Category: numberjoiner}', "");
    Expect(0, 69759, '\p{^Is_Indic_Syllabic_Category: numberjoiner}', "");
    Expect(0, 69759, '\P{Is_Indic_Syllabic_Category: numberjoiner}', "");
    Expect(1, 69759, '\P{^Is_Indic_Syllabic_Category: numberjoiner}', "");
    Expect(0, 69760, '\p{Is_Indic_Syllabic_Category: numberjoiner}', "");
    Expect(1, 69760, '\p{^Is_Indic_Syllabic_Category: numberjoiner}', "");
    Expect(1, 69760, '\P{Is_Indic_Syllabic_Category: numberjoiner}', "");
    Expect(0, 69760, '\P{^Is_Indic_Syllabic_Category: numberjoiner}', "");
    Expect(1, 69759, '\p{Is_Indic_Syllabic_Category=	-NUMBER_JOINER}', "");
    Expect(0, 69759, '\p{^Is_Indic_Syllabic_Category=	-NUMBER_JOINER}', "");
    Expect(0, 69759, '\P{Is_Indic_Syllabic_Category=	-NUMBER_JOINER}', "");
    Expect(1, 69759, '\P{^Is_Indic_Syllabic_Category=	-NUMBER_JOINER}', "");
    Expect(0, 69760, '\p{Is_Indic_Syllabic_Category=	-NUMBER_JOINER}', "");
    Expect(1, 69760, '\p{^Is_Indic_Syllabic_Category=	-NUMBER_JOINER}', "");
    Expect(1, 69760, '\P{Is_Indic_Syllabic_Category=	-NUMBER_JOINER}', "");
    Expect(0, 69760, '\P{^Is_Indic_Syllabic_Category=	-NUMBER_JOINER}', "");
    Error('\p{Is_InSC=_:=number_Joiner}');
    Error('\P{Is_InSC=_:=number_Joiner}');
    Expect(1, 69759, '\p{Is_InSC=numberjoiner}', "");
    Expect(0, 69759, '\p{^Is_InSC=numberjoiner}', "");
    Expect(0, 69759, '\P{Is_InSC=numberjoiner}', "");
    Expect(1, 69759, '\P{^Is_InSC=numberjoiner}', "");
    Expect(0, 69760, '\p{Is_InSC=numberjoiner}', "");
    Expect(1, 69760, '\p{^Is_InSC=numberjoiner}', "");
    Expect(1, 69760, '\P{Is_InSC=numberjoiner}', "");
    Expect(0, 69760, '\P{^Is_InSC=numberjoiner}', "");
    Expect(1, 69759, '\p{Is_InSC=- NUMBER_Joiner}', "");
    Expect(0, 69759, '\p{^Is_InSC=- NUMBER_Joiner}', "");
    Expect(0, 69759, '\P{Is_InSC=- NUMBER_Joiner}', "");
    Expect(1, 69759, '\P{^Is_InSC=- NUMBER_Joiner}', "");
    Expect(0, 69760, '\p{Is_InSC=- NUMBER_Joiner}', "");
    Expect(1, 69760, '\p{^Is_InSC=- NUMBER_Joiner}', "");
    Expect(1, 69760, '\P{Is_InSC=- NUMBER_Joiner}', "");
    Expect(0, 69760, '\P{^Is_InSC=- NUMBER_Joiner}', "");
    Error('\p{Indic_Syllabic_Category=	 other/a/}');
    Error('\P{Indic_Syllabic_Category=	 other/a/}');
    Expect(1, 73050, '\p{Indic_Syllabic_Category=other}', "");
    Expect(0, 73050, '\p{^Indic_Syllabic_Category=other}', "");
    Expect(0, 73050, '\P{Indic_Syllabic_Category=other}', "");
    Expect(1, 73050, '\P{^Indic_Syllabic_Category=other}', "");
    Expect(0, 73049, '\p{Indic_Syllabic_Category=other}', "");
    Expect(1, 73049, '\p{^Indic_Syllabic_Category=other}', "");
    Expect(1, 73049, '\P{Indic_Syllabic_Category=other}', "");
    Expect(0, 73049, '\P{^Indic_Syllabic_Category=other}', "");
    Expect(1, 73050, '\p{Indic_Syllabic_Category=-other}', "");
    Expect(0, 73050, '\p{^Indic_Syllabic_Category=-other}', "");
    Expect(0, 73050, '\P{Indic_Syllabic_Category=-other}', "");
    Expect(1, 73050, '\P{^Indic_Syllabic_Category=-other}', "");
    Expect(0, 73049, '\p{Indic_Syllabic_Category=-other}', "");
    Expect(1, 73049, '\p{^Indic_Syllabic_Category=-other}', "");
    Expect(1, 73049, '\P{Indic_Syllabic_Category=-other}', "");
    Expect(0, 73049, '\P{^Indic_Syllabic_Category=-other}', "");
    Error('\p{InSC=_Other/a/}');
    Error('\P{InSC=_Other/a/}');
    Expect(1, 73050, '\p{InSC=other}', "");
    Expect(0, 73050, '\p{^InSC=other}', "");
    Expect(0, 73050, '\P{InSC=other}', "");
    Expect(1, 73050, '\P{^InSC=other}', "");
    Expect(0, 73049, '\p{InSC=other}', "");
    Expect(1, 73049, '\p{^InSC=other}', "");
    Expect(1, 73049, '\P{InSC=other}', "");
    Expect(0, 73049, '\P{^InSC=other}', "");
    Expect(1, 73050, '\p{InSC=_OTHER}', "");
    Expect(0, 73050, '\p{^InSC=_OTHER}', "");
    Expect(0, 73050, '\P{InSC=_OTHER}', "");
    Expect(1, 73050, '\P{^InSC=_OTHER}', "");
    Expect(0, 73049, '\p{InSC=_OTHER}', "");
    Expect(1, 73049, '\p{^InSC=_OTHER}', "");
    Expect(1, 73049, '\P{InSC=_OTHER}', "");
    Expect(0, 73049, '\P{^InSC=_OTHER}', "");
    Error('\p{Is_Indic_Syllabic_Category=:=_-Other}');
    Error('\P{Is_Indic_Syllabic_Category=:=_-Other}');
    Expect(1, 73050, '\p{Is_Indic_Syllabic_Category=other}', "");
    Expect(0, 73050, '\p{^Is_Indic_Syllabic_Category=other}', "");
    Expect(0, 73050, '\P{Is_Indic_Syllabic_Category=other}', "");
    Expect(1, 73050, '\P{^Is_Indic_Syllabic_Category=other}', "");
    Expect(0, 73049, '\p{Is_Indic_Syllabic_Category=other}', "");
    Expect(1, 73049, '\p{^Is_Indic_Syllabic_Category=other}', "");
    Expect(1, 73049, '\P{Is_Indic_Syllabic_Category=other}', "");
    Expect(0, 73049, '\P{^Is_Indic_Syllabic_Category=other}', "");
    Expect(1, 73050, '\p{Is_Indic_Syllabic_Category=- Other}', "");
    Expect(0, 73050, '\p{^Is_Indic_Syllabic_Category=- Other}', "");
    Expect(0, 73050, '\P{Is_Indic_Syllabic_Category=- Other}', "");
    Expect(1, 73050, '\P{^Is_Indic_Syllabic_Category=- Other}', "");
    Expect(0, 73049, '\p{Is_Indic_Syllabic_Category=- Other}', "");
    Expect(1, 73049, '\p{^Is_Indic_Syllabic_Category=- Other}', "");
    Expect(1, 73049, '\P{Is_Indic_Syllabic_Category=- Other}', "");
    Expect(0, 73049, '\P{^Is_Indic_Syllabic_Category=- Other}', "");
    Error('\p{Is_InSC=-/a/other}');
    Error('\P{Is_InSC=-/a/other}');
    Expect(1, 73050, '\p{Is_InSC=other}', "");
    Expect(0, 73050, '\p{^Is_InSC=other}', "");
    Expect(0, 73050, '\P{Is_InSC=other}', "");
    Expect(1, 73050, '\P{^Is_InSC=other}', "");
    Expect(0, 73049, '\p{Is_InSC=other}', "");
    Expect(1, 73049, '\p{^Is_InSC=other}', "");
    Expect(1, 73049, '\P{Is_InSC=other}', "");
    Expect(0, 73049, '\P{^Is_InSC=other}', "");
    Expect(1, 73050, '\p{Is_InSC=-Other}', "");
    Expect(0, 73050, '\p{^Is_InSC=-Other}', "");
    Expect(0, 73050, '\P{Is_InSC=-Other}', "");
    Expect(1, 73050, '\P{^Is_InSC=-Other}', "");
    Expect(0, 73049, '\p{Is_InSC=-Other}', "");
    Expect(1, 73049, '\p{^Is_InSC=-Other}', "");
    Expect(1, 73049, '\P{Is_InSC=-Other}', "");
    Expect(0, 73049, '\P{^Is_InSC=-Other}', "");
    Error('\p{Indic_Syllabic_Category=_/a/Pure_killer}');
    Error('\P{Indic_Syllabic_Category=_/a/Pure_killer}');
    Expect(1, 73028, '\p{Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73028, '\p{^Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73028, '\P{Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73028, '\P{^Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73029, '\p{Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73029, '\p{^Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73029, '\P{Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73029, '\P{^Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73028, '\p{Indic_Syllabic_Category=  pure_Killer}', "");
    Expect(0, 73028, '\p{^Indic_Syllabic_Category=  pure_Killer}', "");
    Expect(0, 73028, '\P{Indic_Syllabic_Category=  pure_Killer}', "");
    Expect(1, 73028, '\P{^Indic_Syllabic_Category=  pure_Killer}', "");
    Expect(0, 73029, '\p{Indic_Syllabic_Category=  pure_Killer}', "");
    Expect(1, 73029, '\p{^Indic_Syllabic_Category=  pure_Killer}', "");
    Expect(1, 73029, '\P{Indic_Syllabic_Category=  pure_Killer}', "");
    Expect(0, 73029, '\P{^Indic_Syllabic_Category=  pure_Killer}', "");
    Error('\p{InSC=_:=pure_KILLER}');
    Error('\P{InSC=_:=pure_KILLER}');
    Expect(1, 73028, '\p{InSC=purekiller}', "");
    Expect(0, 73028, '\p{^InSC=purekiller}', "");
    Expect(0, 73028, '\P{InSC=purekiller}', "");
    Expect(1, 73028, '\P{^InSC=purekiller}', "");
    Expect(0, 73029, '\p{InSC=purekiller}', "");
    Expect(1, 73029, '\p{^InSC=purekiller}', "");
    Expect(1, 73029, '\P{InSC=purekiller}', "");
    Expect(0, 73029, '\P{^InSC=purekiller}', "");
    Expect(1, 73028, '\p{InSC=-	Pure_killer}', "");
    Expect(0, 73028, '\p{^InSC=-	Pure_killer}', "");
    Expect(0, 73028, '\P{InSC=-	Pure_killer}', "");
    Expect(1, 73028, '\P{^InSC=-	Pure_killer}', "");
    Expect(0, 73029, '\p{InSC=-	Pure_killer}', "");
    Expect(1, 73029, '\p{^InSC=-	Pure_killer}', "");
    Expect(1, 73029, '\P{InSC=-	Pure_killer}', "");
    Expect(0, 73029, '\P{^InSC=-	Pure_killer}', "");
    Error('\p{Is_Indic_Syllabic_Category=:=	-Pure_Killer}');
    Error('\P{Is_Indic_Syllabic_Category=:=	-Pure_Killer}');
    Expect(1, 73028, '\p{Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73028, '\p{^Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73028, '\P{Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73028, '\P{^Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73029, '\p{Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73029, '\p{^Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73029, '\P{Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73029, '\P{^Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73028, '\p{Is_Indic_Syllabic_Category=_Pure_killer}', "");
    Expect(0, 73028, '\p{^Is_Indic_Syllabic_Category=_Pure_killer}', "");
    Expect(0, 73028, '\P{Is_Indic_Syllabic_Category=_Pure_killer}', "");
    Expect(1, 73028, '\P{^Is_Indic_Syllabic_Category=_Pure_killer}', "");
    Expect(0, 73029, '\p{Is_Indic_Syllabic_Category=_Pure_killer}', "");
    Expect(1, 73029, '\p{^Is_Indic_Syllabic_Category=_Pure_killer}', "");
    Expect(1, 73029, '\P{Is_Indic_Syllabic_Category=_Pure_killer}', "");
    Expect(0, 73029, '\P{^Is_Indic_Syllabic_Category=_Pure_killer}', "");
    Error('\p{Is_InSC=:= pure_Killer}');
    Error('\P{Is_InSC=:= pure_Killer}');
    Expect(1, 73028, '\p{Is_InSC=purekiller}', "");
    Expect(0, 73028, '\p{^Is_InSC=purekiller}', "");
    Expect(0, 73028, '\P{Is_InSC=purekiller}', "");
    Expect(1, 73028, '\P{^Is_InSC=purekiller}', "");
    Expect(0, 73029, '\p{Is_InSC=purekiller}', "");
    Expect(1, 73029, '\p{^Is_InSC=purekiller}', "");
    Expect(1, 73029, '\P{Is_InSC=purekiller}', "");
    Expect(0, 73029, '\P{^Is_InSC=purekiller}', "");
    Expect(1, 73028, '\p{Is_InSC= 	PURE_Killer}', "");
    Expect(0, 73028, '\p{^Is_InSC= 	PURE_Killer}', "");
    Expect(0, 73028, '\P{Is_InSC= 	PURE_Killer}', "");
    Expect(1, 73028, '\P{^Is_InSC= 	PURE_Killer}', "");
    Expect(0, 73029, '\p{Is_InSC= 	PURE_Killer}', "");
    Expect(1, 73029, '\p{^Is_InSC= 	PURE_Killer}', "");
    Expect(1, 73029, '\P{Is_InSC= 	PURE_Killer}', "");
    Expect(0, 73029, '\P{^Is_InSC= 	PURE_Killer}', "");
    Error('\p{Indic_Syllabic_Category= _Register_shifter/a/}');
    Error('\P{Indic_Syllabic_Category= _Register_shifter/a/}');
    Expect(1, 6090, '\p{Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6090, '\p{^Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6090, '\P{Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6090, '\P{^Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6091, '\p{Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6091, '\p{^Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6091, '\P{Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6091, '\P{^Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6090, '\p{Indic_Syllabic_Category:	-Register_SHIFTER}', "");
    Expect(0, 6090, '\p{^Indic_Syllabic_Category:	-Register_SHIFTER}', "");
    Expect(0, 6090, '\P{Indic_Syllabic_Category:	-Register_SHIFTER}', "");
    Expect(1, 6090, '\P{^Indic_Syllabic_Category:	-Register_SHIFTER}', "");
    Expect(0, 6091, '\p{Indic_Syllabic_Category:	-Register_SHIFTER}', "");
    Expect(1, 6091, '\p{^Indic_Syllabic_Category:	-Register_SHIFTER}', "");
    Expect(1, 6091, '\P{Indic_Syllabic_Category:	-Register_SHIFTER}', "");
    Expect(0, 6091, '\P{^Indic_Syllabic_Category:	-Register_SHIFTER}', "");
    Error('\p{InSC=/a/  Register_Shifter}');
    Error('\P{InSC=/a/  Register_Shifter}');
    Expect(1, 6090, '\p{InSC=registershifter}', "");
    Expect(0, 6090, '\p{^InSC=registershifter}', "");
    Expect(0, 6090, '\P{InSC=registershifter}', "");
    Expect(1, 6090, '\P{^InSC=registershifter}', "");
    Expect(0, 6091, '\p{InSC=registershifter}', "");
    Expect(1, 6091, '\p{^InSC=registershifter}', "");
    Expect(1, 6091, '\P{InSC=registershifter}', "");
    Expect(0, 6091, '\P{^InSC=registershifter}', "");
    Expect(1, 6090, '\p{InSC=	-Register_Shifter}', "");
    Expect(0, 6090, '\p{^InSC=	-Register_Shifter}', "");
    Expect(0, 6090, '\P{InSC=	-Register_Shifter}', "");
    Expect(1, 6090, '\P{^InSC=	-Register_Shifter}', "");
    Expect(0, 6091, '\p{InSC=	-Register_Shifter}', "");
    Expect(1, 6091, '\p{^InSC=	-Register_Shifter}', "");
    Expect(1, 6091, '\P{InSC=	-Register_Shifter}', "");
    Expect(0, 6091, '\P{^InSC=	-Register_Shifter}', "");
    Error('\p{Is_Indic_Syllabic_Category=_register_Shifter:=}');
    Error('\P{Is_Indic_Syllabic_Category=_register_Shifter:=}');
    Expect(1, 6090, '\p{Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6090, '\p{^Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6090, '\P{Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6090, '\P{^Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6091, '\p{Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6091, '\p{^Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6091, '\P{Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6091, '\P{^Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6090, '\p{Is_Indic_Syllabic_Category=		register_Shifter}', "");
    Expect(0, 6090, '\p{^Is_Indic_Syllabic_Category=		register_Shifter}', "");
    Expect(0, 6090, '\P{Is_Indic_Syllabic_Category=		register_Shifter}', "");
    Expect(1, 6090, '\P{^Is_Indic_Syllabic_Category=		register_Shifter}', "");
    Expect(0, 6091, '\p{Is_Indic_Syllabic_Category=		register_Shifter}', "");
    Expect(1, 6091, '\p{^Is_Indic_Syllabic_Category=		register_Shifter}', "");
    Expect(1, 6091, '\P{Is_Indic_Syllabic_Category=		register_Shifter}', "");
    Expect(0, 6091, '\P{^Is_Indic_Syllabic_Category=		register_Shifter}', "");
    Error('\p{Is_InSC:	-/a/Register_Shifter}');
    Error('\P{Is_InSC:	-/a/Register_Shifter}');
    Expect(1, 6090, '\p{Is_InSC:	registershifter}', "");
    Expect(0, 6090, '\p{^Is_InSC:	registershifter}', "");
    Expect(0, 6090, '\P{Is_InSC:	registershifter}', "");
    Expect(1, 6090, '\P{^Is_InSC:	registershifter}', "");
    Expect(0, 6091, '\p{Is_InSC:	registershifter}', "");
    Expect(1, 6091, '\p{^Is_InSC:	registershifter}', "");
    Expect(1, 6091, '\P{Is_InSC:	registershifter}', "");
    Expect(0, 6091, '\P{^Is_InSC:	registershifter}', "");
    Expect(1, 6090, '\p{Is_InSC=_ register_Shifter}', "");
    Expect(0, 6090, '\p{^Is_InSC=_ register_Shifter}', "");
    Expect(0, 6090, '\P{Is_InSC=_ register_Shifter}', "");
    Expect(1, 6090, '\P{^Is_InSC=_ register_Shifter}', "");
    Expect(0, 6091, '\p{Is_InSC=_ register_Shifter}', "");
    Expect(1, 6091, '\p{^Is_InSC=_ register_Shifter}', "");
    Expect(1, 6091, '\P{Is_InSC=_ register_Shifter}', "");
    Expect(0, 6091, '\P{^Is_InSC=_ register_Shifter}', "");
    Error('\p{Indic_Syllabic_Category:  syllable_Modifier/a/}');
    Error('\P{Indic_Syllabic_Category:  syllable_Modifier/a/}');
    Expect(1, 72243, '\p{Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72243, '\p{^Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72243, '\P{Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72243, '\P{^Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72244, '\p{Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72244, '\p{^Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72244, '\P{Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72244, '\P{^Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72243, '\p{Indic_Syllabic_Category=	 Syllable_Modifier}', "");
    Expect(0, 72243, '\p{^Indic_Syllabic_Category=	 Syllable_Modifier}', "");
    Expect(0, 72243, '\P{Indic_Syllabic_Category=	 Syllable_Modifier}', "");
    Expect(1, 72243, '\P{^Indic_Syllabic_Category=	 Syllable_Modifier}', "");
    Expect(0, 72244, '\p{Indic_Syllabic_Category=	 Syllable_Modifier}', "");
    Expect(1, 72244, '\p{^Indic_Syllabic_Category=	 Syllable_Modifier}', "");
    Expect(1, 72244, '\P{Indic_Syllabic_Category=	 Syllable_Modifier}', "");
    Expect(0, 72244, '\P{^Indic_Syllabic_Category=	 Syllable_Modifier}', "");
    Error('\p{InSC=/a/	 SYLLABLE_modifier}');
    Error('\P{InSC=/a/	 SYLLABLE_modifier}');
    Expect(1, 72243, '\p{InSC=syllablemodifier}', "");
    Expect(0, 72243, '\p{^InSC=syllablemodifier}', "");
    Expect(0, 72243, '\P{InSC=syllablemodifier}', "");
    Expect(1, 72243, '\P{^InSC=syllablemodifier}', "");
    Expect(0, 72244, '\p{InSC=syllablemodifier}', "");
    Expect(1, 72244, '\p{^InSC=syllablemodifier}', "");
    Expect(1, 72244, '\P{InSC=syllablemodifier}', "");
    Expect(0, 72244, '\P{^InSC=syllablemodifier}', "");
    Expect(1, 72243, '\p{InSC=_-Syllable_Modifier}', "");
    Expect(0, 72243, '\p{^InSC=_-Syllable_Modifier}', "");
    Expect(0, 72243, '\P{InSC=_-Syllable_Modifier}', "");
    Expect(1, 72243, '\P{^InSC=_-Syllable_Modifier}', "");
    Expect(0, 72244, '\p{InSC=_-Syllable_Modifier}', "");
    Expect(1, 72244, '\p{^InSC=_-Syllable_Modifier}', "");
    Expect(1, 72244, '\P{InSC=_-Syllable_Modifier}', "");
    Expect(0, 72244, '\P{^InSC=_-Syllable_Modifier}', "");
    Error('\p{Is_Indic_Syllabic_Category=__Syllable_modifier:=}');
    Error('\P{Is_Indic_Syllabic_Category=__Syllable_modifier:=}');
    Expect(1, 72243, '\p{Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72243, '\p{^Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72243, '\P{Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72243, '\P{^Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72244, '\p{Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72244, '\p{^Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72244, '\P{Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72244, '\P{^Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72243, '\p{Is_Indic_Syllabic_Category:	-	syllable_modifier}', "");
    Expect(0, 72243, '\p{^Is_Indic_Syllabic_Category:	-	syllable_modifier}', "");
    Expect(0, 72243, '\P{Is_Indic_Syllabic_Category:	-	syllable_modifier}', "");
    Expect(1, 72243, '\P{^Is_Indic_Syllabic_Category:	-	syllable_modifier}', "");
    Expect(0, 72244, '\p{Is_Indic_Syllabic_Category:	-	syllable_modifier}', "");
    Expect(1, 72244, '\p{^Is_Indic_Syllabic_Category:	-	syllable_modifier}', "");
    Expect(1, 72244, '\P{Is_Indic_Syllabic_Category:	-	syllable_modifier}', "");
    Expect(0, 72244, '\P{^Is_Indic_Syllabic_Category:	-	syllable_modifier}', "");
    Error('\p{Is_InSC=/a/syllable_Modifier}');
    Error('\P{Is_InSC=/a/syllable_Modifier}');
    Expect(1, 72243, '\p{Is_InSC:	syllablemodifier}', "");
    Expect(0, 72243, '\p{^Is_InSC:	syllablemodifier}', "");
    Expect(0, 72243, '\P{Is_InSC:	syllablemodifier}', "");
    Expect(1, 72243, '\P{^Is_InSC:	syllablemodifier}', "");
    Expect(0, 72244, '\p{Is_InSC:	syllablemodifier}', "");
    Expect(1, 72244, '\p{^Is_InSC:	syllablemodifier}', "");
    Expect(1, 72244, '\P{Is_InSC:	syllablemodifier}', "");
    Expect(0, 72244, '\P{^Is_InSC:	syllablemodifier}', "");
    Expect(1, 72243, '\p{Is_InSC: _	syllable_modifier}', "");
    Expect(0, 72243, '\p{^Is_InSC: _	syllable_modifier}', "");
    Expect(0, 72243, '\P{Is_InSC: _	syllable_modifier}', "");
    Expect(1, 72243, '\P{^Is_InSC: _	syllable_modifier}', "");
    Expect(0, 72244, '\p{Is_InSC: _	syllable_modifier}', "");
    Expect(1, 72244, '\p{^Is_InSC: _	syllable_modifier}', "");
    Expect(1, 72244, '\P{Is_InSC: _	syllable_modifier}', "");
    Expect(0, 72244, '\P{^Is_InSC: _	syllable_modifier}', "");
    Error('\p{Indic_Syllabic_Category=_/a/TONE_Letter}');
    Error('\P{Indic_Syllabic_Category=_/a/TONE_Letter}');
    Expect(1, 43714, '\p{Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43714, '\p{^Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43714, '\P{Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43714, '\P{^Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43715, '\p{Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43715, '\p{^Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43715, '\P{Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43715, '\P{^Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43714, '\p{Indic_Syllabic_Category=--TONE_Letter}', "");
    Expect(0, 43714, '\p{^Indic_Syllabic_Category=--TONE_Letter}', "");
    Expect(0, 43714, '\P{Indic_Syllabic_Category=--TONE_Letter}', "");
    Expect(1, 43714, '\P{^Indic_Syllabic_Category=--TONE_Letter}', "");
    Expect(0, 43715, '\p{Indic_Syllabic_Category=--TONE_Letter}', "");
    Expect(1, 43715, '\p{^Indic_Syllabic_Category=--TONE_Letter}', "");
    Expect(1, 43715, '\P{Indic_Syllabic_Category=--TONE_Letter}', "");
    Expect(0, 43715, '\P{^Indic_Syllabic_Category=--TONE_Letter}', "");
    Error('\p{InSC=/a/Tone_letter}');
    Error('\P{InSC=/a/Tone_letter}');
    Expect(1, 43714, '\p{InSC=toneletter}', "");
    Expect(0, 43714, '\p{^InSC=toneletter}', "");
    Expect(0, 43714, '\P{InSC=toneletter}', "");
    Expect(1, 43714, '\P{^InSC=toneletter}', "");
    Expect(0, 43715, '\p{InSC=toneletter}', "");
    Expect(1, 43715, '\p{^InSC=toneletter}', "");
    Expect(1, 43715, '\P{InSC=toneletter}', "");
    Expect(0, 43715, '\P{^InSC=toneletter}', "");
    Expect(1, 43714, '\p{InSC=_	tone_Letter}', "");
    Expect(0, 43714, '\p{^InSC=_	tone_Letter}', "");
    Expect(0, 43714, '\P{InSC=_	tone_Letter}', "");
    Expect(1, 43714, '\P{^InSC=_	tone_Letter}', "");
    Expect(0, 43715, '\p{InSC=_	tone_Letter}', "");
    Expect(1, 43715, '\p{^InSC=_	tone_Letter}', "");
    Expect(1, 43715, '\P{InSC=_	tone_Letter}', "");
    Expect(0, 43715, '\P{^InSC=_	tone_Letter}', "");
    Error('\p{Is_Indic_Syllabic_Category=:=_	tone_Letter}');
    Error('\P{Is_Indic_Syllabic_Category=:=_	tone_Letter}');
    Expect(1, 43714, '\p{Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43714, '\p{^Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43714, '\P{Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43714, '\P{^Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43715, '\p{Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43715, '\p{^Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43715, '\P{Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43715, '\P{^Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43714, '\p{Is_Indic_Syllabic_Category=--TONE_Letter}', "");
    Expect(0, 43714, '\p{^Is_Indic_Syllabic_Category=--TONE_Letter}', "");
    Expect(0, 43714, '\P{Is_Indic_Syllabic_Category=--TONE_Letter}', "");
    Expect(1, 43714, '\P{^Is_Indic_Syllabic_Category=--TONE_Letter}', "");
    Expect(0, 43715, '\p{Is_Indic_Syllabic_Category=--TONE_Letter}', "");
    Expect(1, 43715, '\p{^Is_Indic_Syllabic_Category=--TONE_Letter}', "");
    Expect(1, 43715, '\P{Is_Indic_Syllabic_Category=--TONE_Letter}', "");
    Expect(0, 43715, '\P{^Is_Indic_Syllabic_Category=--TONE_Letter}', "");
    Error('\p{Is_InSC: -	tone_LETTER/a/}');
    Error('\P{Is_InSC: -	tone_LETTER/a/}');
    Expect(1, 43714, '\p{Is_InSC=toneletter}', "");
    Expect(0, 43714, '\p{^Is_InSC=toneletter}', "");
    Expect(0, 43714, '\P{Is_InSC=toneletter}', "");
    Expect(1, 43714, '\P{^Is_InSC=toneletter}', "");
    Expect(0, 43715, '\p{Is_InSC=toneletter}', "");
    Expect(1, 43715, '\p{^Is_InSC=toneletter}', "");
    Expect(1, 43715, '\P{Is_InSC=toneletter}', "");
    Expect(0, 43715, '\P{^Is_InSC=toneletter}', "");
    Expect(1, 43714, '\p{Is_InSC= TONE_LETTER}', "");
    Expect(0, 43714, '\p{^Is_InSC= TONE_LETTER}', "");
    Expect(0, 43714, '\P{Is_InSC= TONE_LETTER}', "");
    Expect(1, 43714, '\P{^Is_InSC= TONE_LETTER}', "");
    Expect(0, 43715, '\p{Is_InSC= TONE_LETTER}', "");
    Expect(1, 43715, '\p{^Is_InSC= TONE_LETTER}', "");
    Expect(1, 43715, '\P{Is_InSC= TONE_LETTER}', "");
    Expect(0, 43715, '\P{^Is_InSC= TONE_LETTER}', "");
    Error('\p{Indic_Syllabic_Category= 	Tone_Mark:=}');
    Error('\P{Indic_Syllabic_Category= 	Tone_Mark:=}');
    Expect(1, 44012, '\p{Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44012, '\p{^Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44012, '\P{Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44012, '\P{^Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44013, '\p{Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44013, '\p{^Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44013, '\P{Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44013, '\P{^Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44012, '\p{Indic_Syllabic_Category=	TONE_mark}', "");
    Expect(0, 44012, '\p{^Indic_Syllabic_Category=	TONE_mark}', "");
    Expect(0, 44012, '\P{Indic_Syllabic_Category=	TONE_mark}', "");
    Expect(1, 44012, '\P{^Indic_Syllabic_Category=	TONE_mark}', "");
    Expect(0, 44013, '\p{Indic_Syllabic_Category=	TONE_mark}', "");
    Expect(1, 44013, '\p{^Indic_Syllabic_Category=	TONE_mark}', "");
    Expect(1, 44013, '\P{Indic_Syllabic_Category=	TONE_mark}', "");
    Expect(0, 44013, '\P{^Indic_Syllabic_Category=	TONE_mark}', "");
    Error('\p{InSC=/a/--Tone_mark}');
    Error('\P{InSC=/a/--Tone_mark}');
    Expect(1, 44012, '\p{InSC=tonemark}', "");
    Expect(0, 44012, '\p{^InSC=tonemark}', "");
    Expect(0, 44012, '\P{InSC=tonemark}', "");
    Expect(1, 44012, '\P{^InSC=tonemark}', "");
    Expect(0, 44013, '\p{InSC=tonemark}', "");
    Expect(1, 44013, '\p{^InSC=tonemark}', "");
    Expect(1, 44013, '\P{InSC=tonemark}', "");
    Expect(0, 44013, '\P{^InSC=tonemark}', "");
    Expect(1, 44012, '\p{InSC=tone_MARK}', "");
    Expect(0, 44012, '\p{^InSC=tone_MARK}', "");
    Expect(0, 44012, '\P{InSC=tone_MARK}', "");
    Expect(1, 44012, '\P{^InSC=tone_MARK}', "");
    Expect(0, 44013, '\p{InSC=tone_MARK}', "");
    Expect(1, 44013, '\p{^InSC=tone_MARK}', "");
    Expect(1, 44013, '\P{InSC=tone_MARK}', "");
    Expect(0, 44013, '\P{^InSC=tone_MARK}', "");
    Error('\p{Is_Indic_Syllabic_Category:   _ tone_Mark/a/}');
    Error('\P{Is_Indic_Syllabic_Category:   _ tone_Mark/a/}');
    Expect(1, 44012, '\p{Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44012, '\p{^Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44012, '\P{Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44012, '\P{^Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44013, '\p{Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44013, '\p{^Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44013, '\P{Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44013, '\P{^Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44012, '\p{Is_Indic_Syllabic_Category=-_Tone_Mark}', "");
    Expect(0, 44012, '\p{^Is_Indic_Syllabic_Category=-_Tone_Mark}', "");
    Expect(0, 44012, '\P{Is_Indic_Syllabic_Category=-_Tone_Mark}', "");
    Expect(1, 44012, '\P{^Is_Indic_Syllabic_Category=-_Tone_Mark}', "");
    Expect(0, 44013, '\p{Is_Indic_Syllabic_Category=-_Tone_Mark}', "");
    Expect(1, 44013, '\p{^Is_Indic_Syllabic_Category=-_Tone_Mark}', "");
    Expect(1, 44013, '\P{Is_Indic_Syllabic_Category=-_Tone_Mark}', "");
    Expect(0, 44013, '\P{^Is_Indic_Syllabic_Category=-_Tone_Mark}', "");
    Error('\p{Is_InSC=TONE_Mark/a/}');
    Error('\P{Is_InSC=TONE_Mark/a/}');
    Expect(1, 44012, '\p{Is_InSC=tonemark}', "");
    Expect(0, 44012, '\p{^Is_InSC=tonemark}', "");
    Expect(0, 44012, '\P{Is_InSC=tonemark}', "");
    Expect(1, 44012, '\P{^Is_InSC=tonemark}', "");
    Expect(0, 44013, '\p{Is_InSC=tonemark}', "");
    Expect(1, 44013, '\p{^Is_InSC=tonemark}', "");
    Expect(1, 44013, '\P{Is_InSC=tonemark}', "");
    Expect(0, 44013, '\P{^Is_InSC=tonemark}', "");
    Expect(1, 44012, '\p{Is_InSC=__Tone_Mark}', "");
    Expect(0, 44012, '\p{^Is_InSC=__Tone_Mark}', "");
    Expect(0, 44012, '\P{Is_InSC=__Tone_Mark}', "");
    Expect(1, 44012, '\P{^Is_InSC=__Tone_Mark}', "");
    Expect(0, 44013, '\p{Is_InSC=__Tone_Mark}', "");
    Expect(1, 44013, '\p{^Is_InSC=__Tone_Mark}', "");
    Expect(1, 44013, '\P{Is_InSC=__Tone_Mark}', "");
    Expect(0, 44013, '\P{^Is_InSC=__Tone_Mark}', "");
    Error('\p{Indic_Syllabic_Category=:=Virama}');
    Error('\P{Indic_Syllabic_Category=:=Virama}');
    Expect(1, 72767, '\p{Indic_Syllabic_Category=virama}', "");
    Expect(0, 72767, '\p{^Indic_Syllabic_Category=virama}', "");
    Expect(0, 72767, '\P{Indic_Syllabic_Category=virama}', "");
    Expect(1, 72767, '\P{^Indic_Syllabic_Category=virama}', "");
    Expect(0, 72768, '\p{Indic_Syllabic_Category=virama}', "");
    Expect(1, 72768, '\p{^Indic_Syllabic_Category=virama}', "");
    Expect(1, 72768, '\P{Indic_Syllabic_Category=virama}', "");
    Expect(0, 72768, '\P{^Indic_Syllabic_Category=virama}', "");
    Expect(1, 72767, '\p{Indic_Syllabic_Category=_VIRAMA}', "");
    Expect(0, 72767, '\p{^Indic_Syllabic_Category=_VIRAMA}', "");
    Expect(0, 72767, '\P{Indic_Syllabic_Category=_VIRAMA}', "");
    Expect(1, 72767, '\P{^Indic_Syllabic_Category=_VIRAMA}', "");
    Expect(0, 72768, '\p{Indic_Syllabic_Category=_VIRAMA}', "");
    Expect(1, 72768, '\p{^Indic_Syllabic_Category=_VIRAMA}', "");
    Expect(1, 72768, '\P{Indic_Syllabic_Category=_VIRAMA}', "");
    Expect(0, 72768, '\P{^Indic_Syllabic_Category=_VIRAMA}', "");
    Error('\p{InSC= 	virama/a/}');
    Error('\P{InSC= 	virama/a/}');
    Expect(1, 72767, '\p{InSC=virama}', "");
    Expect(0, 72767, '\p{^InSC=virama}', "");
    Expect(0, 72767, '\P{InSC=virama}', "");
    Expect(1, 72767, '\P{^InSC=virama}', "");
    Expect(0, 72768, '\p{InSC=virama}', "");
    Expect(1, 72768, '\p{^InSC=virama}', "");
    Expect(1, 72768, '\P{InSC=virama}', "");
    Expect(0, 72768, '\P{^InSC=virama}', "");
    Expect(1, 72767, '\p{InSC=- VIRAMA}', "");
    Expect(0, 72767, '\p{^InSC=- VIRAMA}', "");
    Expect(0, 72767, '\P{InSC=- VIRAMA}', "");
    Expect(1, 72767, '\P{^InSC=- VIRAMA}', "");
    Expect(0, 72768, '\p{InSC=- VIRAMA}', "");
    Expect(1, 72768, '\p{^InSC=- VIRAMA}', "");
    Expect(1, 72768, '\P{InSC=- VIRAMA}', "");
    Expect(0, 72768, '\P{^InSC=- VIRAMA}', "");
    Error('\p{Is_Indic_Syllabic_Category=-	Virama:=}');
    Error('\P{Is_Indic_Syllabic_Category=-	Virama:=}');
    Expect(1, 72767, '\p{Is_Indic_Syllabic_Category=virama}', "");
    Expect(0, 72767, '\p{^Is_Indic_Syllabic_Category=virama}', "");
    Expect(0, 72767, '\P{Is_Indic_Syllabic_Category=virama}', "");
    Expect(1, 72767, '\P{^Is_Indic_Syllabic_Category=virama}', "");
    Expect(0, 72768, '\p{Is_Indic_Syllabic_Category=virama}', "");
    Expect(1, 72768, '\p{^Is_Indic_Syllabic_Category=virama}', "");
    Expect(1, 72768, '\P{Is_Indic_Syllabic_Category=virama}', "");
    Expect(0, 72768, '\P{^Is_Indic_Syllabic_Category=virama}', "");
    Expect(1, 72767, '\p{Is_Indic_Syllabic_Category=	-VIRAMA}', "");
    Expect(0, 72767, '\p{^Is_Indic_Syllabic_Category=	-VIRAMA}', "");
    Expect(0, 72767, '\P{Is_Indic_Syllabic_Category=	-VIRAMA}', "");
    Expect(1, 72767, '\P{^Is_Indic_Syllabic_Category=	-VIRAMA}', "");
    Expect(0, 72768, '\p{Is_Indic_Syllabic_Category=	-VIRAMA}', "");
    Expect(1, 72768, '\p{^Is_Indic_Syllabic_Category=	-VIRAMA}', "");
    Expect(1, 72768, '\P{Is_Indic_Syllabic_Category=	-VIRAMA}', "");
    Expect(0, 72768, '\P{^Is_Indic_Syllabic_Category=	-VIRAMA}', "");
    Error('\p{Is_InSC=:=_Virama}');
    Error('\P{Is_InSC=:=_Virama}');
    Expect(1, 72767, '\p{Is_InSC=virama}', "");
    Expect(0, 72767, '\p{^Is_InSC=virama}', "");
    Expect(0, 72767, '\P{Is_InSC=virama}', "");
    Expect(1, 72767, '\P{^Is_InSC=virama}', "");
    Expect(0, 72768, '\p{Is_InSC=virama}', "");
    Expect(1, 72768, '\p{^Is_InSC=virama}', "");
    Expect(1, 72768, '\P{Is_InSC=virama}', "");
    Expect(0, 72768, '\P{^Is_InSC=virama}', "");
    Expect(1, 72767, '\p{Is_InSC=	VIRAMA}', "");
    Expect(0, 72767, '\p{^Is_InSC=	VIRAMA}', "");
    Expect(0, 72767, '\P{Is_InSC=	VIRAMA}', "");
    Expect(1, 72767, '\P{^Is_InSC=	VIRAMA}', "");
    Expect(0, 72768, '\p{Is_InSC=	VIRAMA}', "");
    Expect(1, 72768, '\p{^Is_InSC=	VIRAMA}', "");
    Expect(1, 72768, '\P{Is_InSC=	VIRAMA}', "");
    Expect(0, 72768, '\P{^Is_InSC=	VIRAMA}', "");
    Error('\p{Indic_Syllabic_Category=-_VISARGA:=}');
    Error('\P{Indic_Syllabic_Category=-_VISARGA:=}');
    Expect(1, 73025, '\p{Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73025, '\p{^Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73025, '\P{Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73025, '\P{^Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73026, '\p{Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73026, '\p{^Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73026, '\P{Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73026, '\P{^Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73025, '\p{Indic_Syllabic_Category=- VISARGA}', "");
    Expect(0, 73025, '\p{^Indic_Syllabic_Category=- VISARGA}', "");
    Expect(0, 73025, '\P{Indic_Syllabic_Category=- VISARGA}', "");
    Expect(1, 73025, '\P{^Indic_Syllabic_Category=- VISARGA}', "");
    Expect(0, 73026, '\p{Indic_Syllabic_Category=- VISARGA}', "");
    Expect(1, 73026, '\p{^Indic_Syllabic_Category=- VISARGA}', "");
    Expect(1, 73026, '\P{Indic_Syllabic_Category=- VISARGA}', "");
    Expect(0, 73026, '\P{^Indic_Syllabic_Category=- VISARGA}', "");
    Error('\p{InSC=	/a/visarga}');
    Error('\P{InSC=	/a/visarga}');
    Expect(1, 73025, '\p{InSC=visarga}', "");
    Expect(0, 73025, '\p{^InSC=visarga}', "");
    Expect(0, 73025, '\P{InSC=visarga}', "");
    Expect(1, 73025, '\P{^InSC=visarga}', "");
    Expect(0, 73026, '\p{InSC=visarga}', "");
    Expect(1, 73026, '\p{^InSC=visarga}', "");
    Expect(1, 73026, '\P{InSC=visarga}', "");
    Expect(0, 73026, '\P{^InSC=visarga}', "");
    Expect(1, 73025, '\p{InSC=-visarga}', "");
    Expect(0, 73025, '\p{^InSC=-visarga}', "");
    Expect(0, 73025, '\P{InSC=-visarga}', "");
    Expect(1, 73025, '\P{^InSC=-visarga}', "");
    Expect(0, 73026, '\p{InSC=-visarga}', "");
    Expect(1, 73026, '\p{^InSC=-visarga}', "");
    Expect(1, 73026, '\P{InSC=-visarga}', "");
    Expect(0, 73026, '\P{^InSC=-visarga}', "");
    Error('\p{Is_Indic_Syllabic_Category=--visarga:=}');
    Error('\P{Is_Indic_Syllabic_Category=--visarga:=}');
    Expect(1, 73025, '\p{Is_Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73025, '\p{^Is_Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73025, '\P{Is_Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73025, '\P{^Is_Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73026, '\p{Is_Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73026, '\p{^Is_Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73026, '\P{Is_Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73026, '\P{^Is_Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73025, '\p{Is_Indic_Syllabic_Category:   _-Visarga}', "");
    Expect(0, 73025, '\p{^Is_Indic_Syllabic_Category:   _-Visarga}', "");
    Expect(0, 73025, '\P{Is_Indic_Syllabic_Category:   _-Visarga}', "");
    Expect(1, 73025, '\P{^Is_Indic_Syllabic_Category:   _-Visarga}', "");
    Expect(0, 73026, '\p{Is_Indic_Syllabic_Category:   _-Visarga}', "");
    Expect(1, 73026, '\p{^Is_Indic_Syllabic_Category:   _-Visarga}', "");
    Expect(1, 73026, '\P{Is_Indic_Syllabic_Category:   _-Visarga}', "");
    Expect(0, 73026, '\P{^Is_Indic_Syllabic_Category:   _-Visarga}', "");
    Error('\p{Is_InSC=	Visarga:=}');
    Error('\P{Is_InSC=	Visarga:=}');
    Expect(1, 73025, '\p{Is_InSC=visarga}', "");
    Expect(0, 73025, '\p{^Is_InSC=visarga}', "");
    Expect(0, 73025, '\P{Is_InSC=visarga}', "");
    Expect(1, 73025, '\P{^Is_InSC=visarga}', "");
    Expect(0, 73026, '\p{Is_InSC=visarga}', "");
    Expect(1, 73026, '\p{^Is_InSC=visarga}', "");
    Expect(1, 73026, '\P{Is_InSC=visarga}', "");
    Expect(0, 73026, '\P{^Is_InSC=visarga}', "");
    Expect(1, 73025, '\p{Is_InSC=		Visarga}', "");
    Expect(0, 73025, '\p{^Is_InSC=		Visarga}', "");
    Expect(0, 73025, '\P{Is_InSC=		Visarga}', "");
    Expect(1, 73025, '\P{^Is_InSC=		Visarga}', "");
    Expect(0, 73026, '\p{Is_InSC=		Visarga}', "");
    Expect(1, 73026, '\p{^Is_InSC=		Visarga}', "");
    Expect(1, 73026, '\P{Is_InSC=		Visarga}', "");
    Expect(0, 73026, '\P{^Is_InSC=		Visarga}', "");
    Error('\p{Indic_Syllabic_Category=:=	 vowel}');
    Error('\P{Indic_Syllabic_Category=:=	 vowel}');
    Expect(1, 69972, '\p{Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69972, '\p{^Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69972, '\P{Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69972, '\P{^Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69973, '\p{Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69973, '\p{^Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69973, '\P{Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69973, '\P{^Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69972, '\p{Indic_Syllabic_Category:_Vowel}', "");
    Expect(0, 69972, '\p{^Indic_Syllabic_Category:_Vowel}', "");
    Expect(0, 69972, '\P{Indic_Syllabic_Category:_Vowel}', "");
    Expect(1, 69972, '\P{^Indic_Syllabic_Category:_Vowel}', "");
    Expect(0, 69973, '\p{Indic_Syllabic_Category:_Vowel}', "");
    Expect(1, 69973, '\p{^Indic_Syllabic_Category:_Vowel}', "");
    Expect(1, 69973, '\P{Indic_Syllabic_Category:_Vowel}', "");
    Expect(0, 69973, '\P{^Indic_Syllabic_Category:_Vowel}', "");
    Error('\p{InSC=/a/-VOWEL}');
    Error('\P{InSC=/a/-VOWEL}');
    Expect(1, 69972, '\p{InSC=vowel}', "");
    Expect(0, 69972, '\p{^InSC=vowel}', "");
    Expect(0, 69972, '\P{InSC=vowel}', "");
    Expect(1, 69972, '\P{^InSC=vowel}', "");
    Expect(0, 69973, '\p{InSC=vowel}', "");
    Expect(1, 69973, '\p{^InSC=vowel}', "");
    Expect(1, 69973, '\P{InSC=vowel}', "");
    Expect(0, 69973, '\P{^InSC=vowel}', "");
    Expect(1, 69972, '\p{InSC=_-vowel}', "");
    Expect(0, 69972, '\p{^InSC=_-vowel}', "");
    Expect(0, 69972, '\P{InSC=_-vowel}', "");
    Expect(1, 69972, '\P{^InSC=_-vowel}', "");
    Expect(0, 69973, '\p{InSC=_-vowel}', "");
    Expect(1, 69973, '\p{^InSC=_-vowel}', "");
    Expect(1, 69973, '\P{InSC=_-vowel}', "");
    Expect(0, 69973, '\P{^InSC=_-vowel}', "");
    Error('\p{Is_Indic_Syllabic_Category=-:=VOWEL}');
    Error('\P{Is_Indic_Syllabic_Category=-:=VOWEL}');
    Expect(1, 69972, '\p{Is_Indic_Syllabic_Category:vowel}', "");
    Expect(0, 69972, '\p{^Is_Indic_Syllabic_Category:vowel}', "");
    Expect(0, 69972, '\P{Is_Indic_Syllabic_Category:vowel}', "");
    Expect(1, 69972, '\P{^Is_Indic_Syllabic_Category:vowel}', "");
    Expect(0, 69973, '\p{Is_Indic_Syllabic_Category:vowel}', "");
    Expect(1, 69973, '\p{^Is_Indic_Syllabic_Category:vowel}', "");
    Expect(1, 69973, '\P{Is_Indic_Syllabic_Category:vowel}', "");
    Expect(0, 69973, '\P{^Is_Indic_Syllabic_Category:vowel}', "");
    Expect(1, 69972, '\p{Is_Indic_Syllabic_Category:   -Vowel}', "");
    Expect(0, 69972, '\p{^Is_Indic_Syllabic_Category:   -Vowel}', "");
    Expect(0, 69972, '\P{Is_Indic_Syllabic_Category:   -Vowel}', "");
    Expect(1, 69972, '\P{^Is_Indic_Syllabic_Category:   -Vowel}', "");
    Expect(0, 69973, '\p{Is_Indic_Syllabic_Category:   -Vowel}', "");
    Expect(1, 69973, '\p{^Is_Indic_Syllabic_Category:   -Vowel}', "");
    Expect(1, 69973, '\P{Is_Indic_Syllabic_Category:   -Vowel}', "");
    Expect(0, 69973, '\P{^Is_Indic_Syllabic_Category:   -Vowel}', "");
    Error('\p{Is_InSC=-Vowel/a/}');
    Error('\P{Is_InSC=-Vowel/a/}');
    Expect(1, 69972, '\p{Is_InSC=vowel}', "");
    Expect(0, 69972, '\p{^Is_InSC=vowel}', "");
    Expect(0, 69972, '\P{Is_InSC=vowel}', "");
    Expect(1, 69972, '\P{^Is_InSC=vowel}', "");
    Expect(0, 69973, '\p{Is_InSC=vowel}', "");
    Expect(1, 69973, '\p{^Is_InSC=vowel}', "");
    Expect(1, 69973, '\P{Is_InSC=vowel}', "");
    Expect(0, 69973, '\P{^Is_InSC=vowel}', "");
    Expect(1, 69972, '\p{Is_InSC=	Vowel}', "");
    Expect(0, 69972, '\p{^Is_InSC=	Vowel}', "");
    Expect(0, 69972, '\P{Is_InSC=	Vowel}', "");
    Expect(1, 69972, '\P{^Is_InSC=	Vowel}', "");
    Expect(0, 69973, '\p{Is_InSC=	Vowel}', "");
    Expect(1, 69973, '\p{^Is_InSC=	Vowel}', "");
    Expect(1, 69973, '\P{Is_InSC=	Vowel}', "");
    Expect(0, 69973, '\P{^Is_InSC=	Vowel}', "");
    Error('\p{Indic_Syllabic_Category=_/a/VOWEL_Dependent}');
    Error('\P{Indic_Syllabic_Category=_/a/VOWEL_Dependent}');
    Expect(1, 73027, '\p{Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73027, '\p{^Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73027, '\P{Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73027, '\P{^Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73028, '\p{Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73028, '\p{^Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73028, '\P{Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73028, '\P{^Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73027, '\p{Indic_Syllabic_Category=--VOWEL_DEPENDENT}', "");
    Expect(0, 73027, '\p{^Indic_Syllabic_Category=--VOWEL_DEPENDENT}', "");
    Expect(0, 73027, '\P{Indic_Syllabic_Category=--VOWEL_DEPENDENT}', "");
    Expect(1, 73027, '\P{^Indic_Syllabic_Category=--VOWEL_DEPENDENT}', "");
    Expect(0, 73028, '\p{Indic_Syllabic_Category=--VOWEL_DEPENDENT}', "");
    Expect(1, 73028, '\p{^Indic_Syllabic_Category=--VOWEL_DEPENDENT}', "");
    Expect(1, 73028, '\P{Indic_Syllabic_Category=--VOWEL_DEPENDENT}', "");
    Expect(0, 73028, '\P{^Indic_Syllabic_Category=--VOWEL_DEPENDENT}', "");
    Error('\p{InSC=:=--vowel_Dependent}');
    Error('\P{InSC=:=--vowel_Dependent}');
    Expect(1, 73027, '\p{InSC=voweldependent}', "");
    Expect(0, 73027, '\p{^InSC=voweldependent}', "");
    Expect(0, 73027, '\P{InSC=voweldependent}', "");
    Expect(1, 73027, '\P{^InSC=voweldependent}', "");
    Expect(0, 73028, '\p{InSC=voweldependent}', "");
    Expect(1, 73028, '\p{^InSC=voweldependent}', "");
    Expect(1, 73028, '\P{InSC=voweldependent}', "");
    Expect(0, 73028, '\P{^InSC=voweldependent}', "");
    Expect(1, 73027, '\p{InSC=-Vowel_DEPENDENT}', "");
    Expect(0, 73027, '\p{^InSC=-Vowel_DEPENDENT}', "");
    Expect(0, 73027, '\P{InSC=-Vowel_DEPENDENT}', "");
    Expect(1, 73027, '\P{^InSC=-Vowel_DEPENDENT}', "");
    Expect(0, 73028, '\p{InSC=-Vowel_DEPENDENT}', "");
    Expect(1, 73028, '\p{^InSC=-Vowel_DEPENDENT}', "");
    Expect(1, 73028, '\P{InSC=-Vowel_DEPENDENT}', "");
    Expect(0, 73028, '\P{^InSC=-Vowel_DEPENDENT}', "");
    Error('\p{Is_Indic_Syllabic_Category=-Vowel_Dependent:=}');
    Error('\P{Is_Indic_Syllabic_Category=-Vowel_Dependent:=}');
    Expect(1, 73027, '\p{Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73027, '\p{^Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73027, '\P{Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73027, '\P{^Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73028, '\p{Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73028, '\p{^Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73028, '\P{Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73028, '\P{^Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73027, '\p{Is_Indic_Syllabic_Category=--VOWEL_dependent}', "");
    Expect(0, 73027, '\p{^Is_Indic_Syllabic_Category=--VOWEL_dependent}', "");
    Expect(0, 73027, '\P{Is_Indic_Syllabic_Category=--VOWEL_dependent}', "");
    Expect(1, 73027, '\P{^Is_Indic_Syllabic_Category=--VOWEL_dependent}', "");
    Expect(0, 73028, '\p{Is_Indic_Syllabic_Category=--VOWEL_dependent}', "");
    Expect(1, 73028, '\p{^Is_Indic_Syllabic_Category=--VOWEL_dependent}', "");
    Expect(1, 73028, '\P{Is_Indic_Syllabic_Category=--VOWEL_dependent}', "");
    Expect(0, 73028, '\P{^Is_Indic_Syllabic_Category=--VOWEL_dependent}', "");
    Error('\p{Is_InSC=/a/_	VOWEL_Dependent}');
    Error('\P{Is_InSC=/a/_	VOWEL_Dependent}');
    Expect(1, 73027, '\p{Is_InSC=voweldependent}', "");
    Expect(0, 73027, '\p{^Is_InSC=voweldependent}', "");
    Expect(0, 73027, '\P{Is_InSC=voweldependent}', "");
    Expect(1, 73027, '\P{^Is_InSC=voweldependent}', "");
    Expect(0, 73028, '\p{Is_InSC=voweldependent}', "");
    Expect(1, 73028, '\p{^Is_InSC=voweldependent}', "");
    Expect(1, 73028, '\P{Is_InSC=voweldependent}', "");
    Expect(0, 73028, '\P{^Is_InSC=voweldependent}', "");
    Expect(1, 73027, '\p{Is_InSC= VOWEL_Dependent}', "");
    Expect(0, 73027, '\p{^Is_InSC= VOWEL_Dependent}', "");
    Expect(0, 73027, '\P{Is_InSC= VOWEL_Dependent}', "");
    Expect(1, 73027, '\P{^Is_InSC= VOWEL_Dependent}', "");
    Expect(0, 73028, '\p{Is_InSC= VOWEL_Dependent}', "");
    Expect(1, 73028, '\p{^Is_InSC= VOWEL_Dependent}', "");
    Expect(1, 73028, '\P{Is_InSC= VOWEL_Dependent}', "");
    Expect(0, 73028, '\P{^Is_InSC= VOWEL_Dependent}', "");
    Error('\p{Indic_Syllabic_Category= /a/vowel_Independent}');
    Error('\P{Indic_Syllabic_Category= /a/vowel_Independent}');
    Expect(1, 72971, '\p{Indic_Syllabic_Category:vowelindependent}', "");
    Expect(0, 72971, '\p{^Indic_Syllabic_Category:vowelindependent}', "");
    Expect(0, 72971, '\P{Indic_Syllabic_Category:vowelindependent}', "");
    Expect(1, 72971, '\P{^Indic_Syllabic_Category:vowelindependent}', "");
    Expect(0, 72972, '\p{Indic_Syllabic_Category:vowelindependent}', "");
    Expect(1, 72972, '\p{^Indic_Syllabic_Category:vowelindependent}', "");
    Expect(1, 72972, '\P{Indic_Syllabic_Category:vowelindependent}', "");
    Expect(0, 72972, '\P{^Indic_Syllabic_Category:vowelindependent}', "");
    Expect(1, 72971, '\p{Indic_Syllabic_Category=-Vowel_Independent}', "");
    Expect(0, 72971, '\p{^Indic_Syllabic_Category=-Vowel_Independent}', "");
    Expect(0, 72971, '\P{Indic_Syllabic_Category=-Vowel_Independent}', "");
    Expect(1, 72971, '\P{^Indic_Syllabic_Category=-Vowel_Independent}', "");
    Expect(0, 72972, '\p{Indic_Syllabic_Category=-Vowel_Independent}', "");
    Expect(1, 72972, '\p{^Indic_Syllabic_Category=-Vowel_Independent}', "");
    Expect(1, 72972, '\P{Indic_Syllabic_Category=-Vowel_Independent}', "");
    Expect(0, 72972, '\P{^Indic_Syllabic_Category=-Vowel_Independent}', "");
    Error('\p{InSC= /a/VOWEL_Independent}');
    Error('\P{InSC= /a/VOWEL_Independent}');
    Expect(1, 72971, '\p{InSC=vowelindependent}', "");
    Expect(0, 72971, '\p{^InSC=vowelindependent}', "");
    Expect(0, 72971, '\P{InSC=vowelindependent}', "");
    Expect(1, 72971, '\P{^InSC=vowelindependent}', "");
    Expect(0, 72972, '\p{InSC=vowelindependent}', "");
    Expect(1, 72972, '\p{^InSC=vowelindependent}', "");
    Expect(1, 72972, '\P{InSC=vowelindependent}', "");
    Expect(0, 72972, '\P{^InSC=vowelindependent}', "");
    Expect(1, 72971, '\p{InSC=  Vowel_independent}', "");
    Expect(0, 72971, '\p{^InSC=  Vowel_independent}', "");
    Expect(0, 72971, '\P{InSC=  Vowel_independent}', "");
    Expect(1, 72971, '\P{^InSC=  Vowel_independent}', "");
    Expect(0, 72972, '\p{InSC=  Vowel_independent}', "");
    Expect(1, 72972, '\p{^InSC=  Vowel_independent}', "");
    Expect(1, 72972, '\P{InSC=  Vowel_independent}', "");
    Expect(0, 72972, '\P{^InSC=  Vowel_independent}', "");
    Error('\p{Is_Indic_Syllabic_Category=-VOWEL_Independent:=}');
    Error('\P{Is_Indic_Syllabic_Category=-VOWEL_Independent:=}');
    Expect(1, 72971, '\p{Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 72971, '\p{^Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 72971, '\P{Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 72971, '\P{^Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 72972, '\p{Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 72972, '\p{^Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 72972, '\P{Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 72972, '\P{^Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 72971, '\p{Is_Indic_Syllabic_Category=	_vowel_INDEPENDENT}', "");
    Expect(0, 72971, '\p{^Is_Indic_Syllabic_Category=	_vowel_INDEPENDENT}', "");
    Expect(0, 72971, '\P{Is_Indic_Syllabic_Category=	_vowel_INDEPENDENT}', "");
    Expect(1, 72971, '\P{^Is_Indic_Syllabic_Category=	_vowel_INDEPENDENT}', "");
    Expect(0, 72972, '\p{Is_Indic_Syllabic_Category=	_vowel_INDEPENDENT}', "");
    Expect(1, 72972, '\p{^Is_Indic_Syllabic_Category=	_vowel_INDEPENDENT}', "");
    Expect(1, 72972, '\P{Is_Indic_Syllabic_Category=	_vowel_INDEPENDENT}', "");
    Expect(0, 72972, '\P{^Is_Indic_Syllabic_Category=	_vowel_INDEPENDENT}', "");
    Error('\p{Is_InSC=	_Vowel_INDEPENDENT:=}');
    Error('\P{Is_InSC=	_Vowel_INDEPENDENT:=}');
    Expect(1, 72971, '\p{Is_InSC=vowelindependent}', "");
    Expect(0, 72971, '\p{^Is_InSC=vowelindependent}', "");
    Expect(0, 72971, '\P{Is_InSC=vowelindependent}', "");
    Expect(1, 72971, '\P{^Is_InSC=vowelindependent}', "");
    Expect(0, 72972, '\p{Is_InSC=vowelindependent}', "");
    Expect(1, 72972, '\p{^Is_InSC=vowelindependent}', "");
    Expect(1, 72972, '\P{Is_InSC=vowelindependent}', "");
    Expect(0, 72972, '\P{^Is_InSC=vowelindependent}', "");
    Expect(1, 72971, '\p{Is_InSC=	 VOWEL_INDEPENDENT}', "");
    Expect(0, 72971, '\p{^Is_InSC=	 VOWEL_INDEPENDENT}', "");
    Expect(0, 72971, '\P{Is_InSC=	 VOWEL_INDEPENDENT}', "");
    Expect(1, 72971, '\P{^Is_InSC=	 VOWEL_INDEPENDENT}', "");
    Expect(0, 72972, '\p{Is_InSC=	 VOWEL_INDEPENDENT}', "");
    Expect(1, 72972, '\p{^Is_InSC=	 VOWEL_INDEPENDENT}', "");
    Expect(1, 72972, '\P{Is_InSC=	 VOWEL_INDEPENDENT}', "");
    Expect(0, 72972, '\P{^Is_InSC=	 VOWEL_INDEPENDENT}', "");
    Error('\p{isocomment}');
    Error('\P{isocomment}');
    Error('\p{joininggroup}');
    Error('\P{joininggroup}');
    Error('\p{jg}');
    Error('\P{jg}');
    Error('\p{Joining_Group=:= African_feh}');
    Error('\P{Joining_Group=:= African_feh}');
    Expect(1, 2235, '\p{Joining_Group=africanfeh}', "");
    Expect(0, 2235, '\p{^Joining_Group=africanfeh}', "");
    Expect(0, 2235, '\P{Joining_Group=africanfeh}', "");
    Expect(1, 2235, '\P{^Joining_Group=africanfeh}', "");
    Expect(0, 2236, '\p{Joining_Group=africanfeh}', "");
    Expect(1, 2236, '\p{^Joining_Group=africanfeh}', "");
    Expect(1, 2236, '\P{Joining_Group=africanfeh}', "");
    Expect(0, 2236, '\P{^Joining_Group=africanfeh}', "");
    Expect(1, 2235, '\p{Joining_Group=	 African_FEH}', "");
    Expect(0, 2235, '\p{^Joining_Group=	 African_FEH}', "");
    Expect(0, 2235, '\P{Joining_Group=	 African_FEH}', "");
    Expect(1, 2235, '\P{^Joining_Group=	 African_FEH}', "");
    Expect(0, 2236, '\p{Joining_Group=	 African_FEH}', "");
    Expect(1, 2236, '\p{^Joining_Group=	 African_FEH}', "");
    Expect(1, 2236, '\P{Joining_Group=	 African_FEH}', "");
    Expect(0, 2236, '\P{^Joining_Group=	 African_FEH}', "");
    Error('\p{Jg=:= -African_FEH}');
    Error('\P{Jg=:= -African_FEH}');
    Expect(1, 2235, '\p{Jg=africanfeh}', "");
    Expect(0, 2235, '\p{^Jg=africanfeh}', "");
    Expect(0, 2235, '\P{Jg=africanfeh}', "");
    Expect(1, 2235, '\P{^Jg=africanfeh}', "");
    Expect(0, 2236, '\p{Jg=africanfeh}', "");
    Expect(1, 2236, '\p{^Jg=africanfeh}', "");
    Expect(1, 2236, '\P{Jg=africanfeh}', "");
    Expect(0, 2236, '\P{^Jg=africanfeh}', "");
    Expect(1, 2235, '\p{Jg=-african_Feh}', "");
    Expect(0, 2235, '\p{^Jg=-african_Feh}', "");
    Expect(0, 2235, '\P{Jg=-african_Feh}', "");
    Expect(1, 2235, '\P{^Jg=-african_Feh}', "");
    Expect(0, 2236, '\p{Jg=-african_Feh}', "");
    Expect(1, 2236, '\p{^Jg=-african_Feh}', "");
    Expect(1, 2236, '\P{Jg=-african_Feh}', "");
    Expect(0, 2236, '\P{^Jg=-african_Feh}', "");
    Error('\p{Is_Joining_Group=_African_Feh/a/}');
    Error('\P{Is_Joining_Group=_African_Feh/a/}');
    Expect(1, 2235, '\p{Is_Joining_Group:   africanfeh}', "");
    Expect(0, 2235, '\p{^Is_Joining_Group:   africanfeh}', "");
    Expect(0, 2235, '\P{Is_Joining_Group:   africanfeh}', "");
    Expect(1, 2235, '\P{^Is_Joining_Group:   africanfeh}', "");
    Expect(0, 2236, '\p{Is_Joining_Group:   africanfeh}', "");
    Expect(1, 2236, '\p{^Is_Joining_Group:   africanfeh}', "");
    Expect(1, 2236, '\P{Is_Joining_Group:   africanfeh}', "");
    Expect(0, 2236, '\P{^Is_Joining_Group:   africanfeh}', "");
    Expect(1, 2235, '\p{Is_Joining_Group=	African_Feh}', "");
    Expect(0, 2235, '\p{^Is_Joining_Group=	African_Feh}', "");
    Expect(0, 2235, '\P{Is_Joining_Group=	African_Feh}', "");
    Expect(1, 2235, '\P{^Is_Joining_Group=	African_Feh}', "");
    Expect(0, 2236, '\p{Is_Joining_Group=	African_Feh}', "");
    Expect(1, 2236, '\p{^Is_Joining_Group=	African_Feh}', "");
    Expect(1, 2236, '\P{Is_Joining_Group=	African_Feh}', "");
    Expect(0, 2236, '\P{^Is_Joining_Group=	African_Feh}', "");
    Error('\p{Is_Jg=/a/African_feh}');
    Error('\P{Is_Jg=/a/African_feh}');
    Expect(1, 2235, '\p{Is_Jg=africanfeh}', "");
    Expect(0, 2235, '\p{^Is_Jg=africanfeh}', "");
    Expect(0, 2235, '\P{Is_Jg=africanfeh}', "");
    Expect(1, 2235, '\P{^Is_Jg=africanfeh}', "");
    Expect(0, 2236, '\p{Is_Jg=africanfeh}', "");
    Expect(1, 2236, '\p{^Is_Jg=africanfeh}', "");
    Expect(1, 2236, '\P{Is_Jg=africanfeh}', "");
    Expect(0, 2236, '\P{^Is_Jg=africanfeh}', "");
    Expect(1, 2235, '\p{Is_Jg=_ African_Feh}', "");
    Expect(0, 2235, '\p{^Is_Jg=_ African_Feh}', "");
    Expect(0, 2235, '\P{Is_Jg=_ African_Feh}', "");
    Expect(1, 2235, '\P{^Is_Jg=_ African_Feh}', "");
    Expect(0, 2236, '\p{Is_Jg=_ African_Feh}', "");
    Expect(1, 2236, '\p{^Is_Jg=_ African_Feh}', "");
    Expect(1, 2236, '\P{Is_Jg=_ African_Feh}', "");
    Expect(0, 2236, '\P{^Is_Jg=_ African_Feh}', "");
    Error('\p{Joining_Group=	/a/african_noon}');
    Error('\P{Joining_Group=	/a/african_noon}');
    Expect(1, 2237, '\p{Joining_Group=africannoon}', "");
    Expect(0, 2237, '\p{^Joining_Group=africannoon}', "");
    Expect(0, 2237, '\P{Joining_Group=africannoon}', "");
    Expect(1, 2237, '\P{^Joining_Group=africannoon}', "");
    Expect(0, 2238, '\p{Joining_Group=africannoon}', "");
    Expect(1, 2238, '\p{^Joining_Group=africannoon}', "");
    Expect(1, 2238, '\P{Joining_Group=africannoon}', "");
    Expect(0, 2238, '\P{^Joining_Group=africannoon}', "");
    Expect(1, 2237, '\p{Joining_Group:_-AFRICAN_Noon}', "");
    Expect(0, 2237, '\p{^Joining_Group:_-AFRICAN_Noon}', "");
    Expect(0, 2237, '\P{Joining_Group:_-AFRICAN_Noon}', "");
    Expect(1, 2237, '\P{^Joining_Group:_-AFRICAN_Noon}', "");
    Expect(0, 2238, '\p{Joining_Group:_-AFRICAN_Noon}', "");
    Expect(1, 2238, '\p{^Joining_Group:_-AFRICAN_Noon}', "");
    Expect(1, 2238, '\P{Joining_Group:_-AFRICAN_Noon}', "");
    Expect(0, 2238, '\P{^Joining_Group:_-AFRICAN_Noon}', "");
    Error('\p{Jg= -african_Noon/a/}');
    Error('\P{Jg= -african_Noon/a/}');
    Expect(1, 2237, '\p{Jg=africannoon}', "");
    Expect(0, 2237, '\p{^Jg=africannoon}', "");
    Expect(0, 2237, '\P{Jg=africannoon}', "");
    Expect(1, 2237, '\P{^Jg=africannoon}', "");
    Expect(0, 2238, '\p{Jg=africannoon}', "");
    Expect(1, 2238, '\p{^Jg=africannoon}', "");
    Expect(1, 2238, '\P{Jg=africannoon}', "");
    Expect(0, 2238, '\P{^Jg=africannoon}', "");
    Expect(1, 2237, '\p{Jg=	african_noon}', "");
    Expect(0, 2237, '\p{^Jg=	african_noon}', "");
    Expect(0, 2237, '\P{Jg=	african_noon}', "");
    Expect(1, 2237, '\P{^Jg=	african_noon}', "");
    Expect(0, 2238, '\p{Jg=	african_noon}', "");
    Expect(1, 2238, '\p{^Jg=	african_noon}', "");
    Expect(1, 2238, '\P{Jg=	african_noon}', "");
    Expect(0, 2238, '\P{^Jg=	african_noon}', "");
    Error('\p{Is_Joining_Group=/a/_	African_Noon}');
    Error('\P{Is_Joining_Group=/a/_	African_Noon}');
    Expect(1, 2237, '\p{Is_Joining_Group:	africannoon}', "");
    Expect(0, 2237, '\p{^Is_Joining_Group:	africannoon}', "");
    Expect(0, 2237, '\P{Is_Joining_Group:	africannoon}', "");
    Expect(1, 2237, '\P{^Is_Joining_Group:	africannoon}', "");
    Expect(0, 2238, '\p{Is_Joining_Group:	africannoon}', "");
    Expect(1, 2238, '\p{^Is_Joining_Group:	africannoon}', "");
    Expect(1, 2238, '\P{Is_Joining_Group:	africannoon}', "");
    Expect(0, 2238, '\P{^Is_Joining_Group:	africannoon}', "");
    Expect(1, 2237, '\p{Is_Joining_Group= -AFRICAN_noon}', "");
    Expect(0, 2237, '\p{^Is_Joining_Group= -AFRICAN_noon}', "");
    Expect(0, 2237, '\P{Is_Joining_Group= -AFRICAN_noon}', "");
    Expect(1, 2237, '\P{^Is_Joining_Group= -AFRICAN_noon}', "");
    Expect(0, 2238, '\p{Is_Joining_Group= -AFRICAN_noon}', "");
    Expect(1, 2238, '\p{^Is_Joining_Group= -AFRICAN_noon}', "");
    Expect(1, 2238, '\P{Is_Joining_Group= -AFRICAN_noon}', "");
    Expect(0, 2238, '\P{^Is_Joining_Group= -AFRICAN_noon}', "");
    Error('\p{Is_Jg=:=		African_Noon}');
    Error('\P{Is_Jg=:=		African_Noon}');
    Expect(1, 2237, '\p{Is_Jg=africannoon}', "");
    Expect(0, 2237, '\p{^Is_Jg=africannoon}', "");
    Expect(0, 2237, '\P{Is_Jg=africannoon}', "");
    Expect(1, 2237, '\P{^Is_Jg=africannoon}', "");
    Expect(0, 2238, '\p{Is_Jg=africannoon}', "");
    Expect(1, 2238, '\p{^Is_Jg=africannoon}', "");
    Expect(1, 2238, '\P{Is_Jg=africannoon}', "");
    Expect(0, 2238, '\P{^Is_Jg=africannoon}', "");
    Expect(1, 2237, '\p{Is_Jg=African_Noon}', "");
    Expect(0, 2237, '\p{^Is_Jg=African_Noon}', "");
    Expect(0, 2237, '\P{Is_Jg=African_Noon}', "");
    Expect(1, 2237, '\P{^Is_Jg=African_Noon}', "");
    Expect(0, 2238, '\p{Is_Jg=African_Noon}', "");
    Expect(1, 2238, '\p{^Is_Jg=African_Noon}', "");
    Expect(1, 2238, '\P{Is_Jg=African_Noon}', "");
    Expect(0, 2238, '\P{^Is_Jg=African_Noon}', "");
    Error('\p{Joining_Group:	/a/ _african_Qaf}');
    Error('\P{Joining_Group:	/a/ _african_Qaf}');
    Expect(1, 2236, '\p{Joining_Group=africanqaf}', "");
    Expect(0, 2236, '\p{^Joining_Group=africanqaf}', "");
    Expect(0, 2236, '\P{Joining_Group=africanqaf}', "");
    Expect(1, 2236, '\P{^Joining_Group=africanqaf}', "");
    Expect(0, 2237, '\p{Joining_Group=africanqaf}', "");
    Expect(1, 2237, '\p{^Joining_Group=africanqaf}', "");
    Expect(1, 2237, '\P{Joining_Group=africanqaf}', "");
    Expect(0, 2237, '\P{^Joining_Group=africanqaf}', "");
    Expect(1, 2236, '\p{Joining_Group=AFRICAN_Qaf}', "");
    Expect(0, 2236, '\p{^Joining_Group=AFRICAN_Qaf}', "");
    Expect(0, 2236, '\P{Joining_Group=AFRICAN_Qaf}', "");
    Expect(1, 2236, '\P{^Joining_Group=AFRICAN_Qaf}', "");
    Expect(0, 2237, '\p{Joining_Group=AFRICAN_Qaf}', "");
    Expect(1, 2237, '\p{^Joining_Group=AFRICAN_Qaf}', "");
    Expect(1, 2237, '\P{Joining_Group=AFRICAN_Qaf}', "");
    Expect(0, 2237, '\P{^Joining_Group=AFRICAN_Qaf}', "");
    Error('\p{Jg=/a/African_Qaf}');
    Error('\P{Jg=/a/African_Qaf}');
    Expect(1, 2236, '\p{Jg=africanqaf}', "");
    Expect(0, 2236, '\p{^Jg=africanqaf}', "");
    Expect(0, 2236, '\P{Jg=africanqaf}', "");
    Expect(1, 2236, '\P{^Jg=africanqaf}', "");
    Expect(0, 2237, '\p{Jg=africanqaf}', "");
    Expect(1, 2237, '\p{^Jg=africanqaf}', "");
    Expect(1, 2237, '\P{Jg=africanqaf}', "");
    Expect(0, 2237, '\P{^Jg=africanqaf}', "");
    Expect(1, 2236, '\p{Jg=__AFRICAN_Qaf}', "");
    Expect(0, 2236, '\p{^Jg=__AFRICAN_Qaf}', "");
    Expect(0, 2236, '\P{Jg=__AFRICAN_Qaf}', "");
    Expect(1, 2236, '\P{^Jg=__AFRICAN_Qaf}', "");
    Expect(0, 2237, '\p{Jg=__AFRICAN_Qaf}', "");
    Expect(1, 2237, '\p{^Jg=__AFRICAN_Qaf}', "");
    Expect(1, 2237, '\P{Jg=__AFRICAN_Qaf}', "");
    Expect(0, 2237, '\P{^Jg=__AFRICAN_Qaf}', "");
    Error('\p{Is_Joining_Group=-_AFRICAN_Qaf/a/}');
    Error('\P{Is_Joining_Group=-_AFRICAN_Qaf/a/}');
    Expect(1, 2236, '\p{Is_Joining_Group=africanqaf}', "");
    Expect(0, 2236, '\p{^Is_Joining_Group=africanqaf}', "");
    Expect(0, 2236, '\P{Is_Joining_Group=africanqaf}', "");
    Expect(1, 2236, '\P{^Is_Joining_Group=africanqaf}', "");
    Expect(0, 2237, '\p{Is_Joining_Group=africanqaf}', "");
    Expect(1, 2237, '\p{^Is_Joining_Group=africanqaf}', "");
    Expect(1, 2237, '\P{Is_Joining_Group=africanqaf}', "");
    Expect(0, 2237, '\P{^Is_Joining_Group=africanqaf}', "");
    Expect(1, 2236, '\p{Is_Joining_Group=	 AFRICAN_QAF}', "");
    Expect(0, 2236, '\p{^Is_Joining_Group=	 AFRICAN_QAF}', "");
    Expect(0, 2236, '\P{Is_Joining_Group=	 AFRICAN_QAF}', "");
    Expect(1, 2236, '\P{^Is_Joining_Group=	 AFRICAN_QAF}', "");
    Expect(0, 2237, '\p{Is_Joining_Group=	 AFRICAN_QAF}', "");
    Expect(1, 2237, '\p{^Is_Joining_Group=	 AFRICAN_QAF}', "");
    Expect(1, 2237, '\P{Is_Joining_Group=	 AFRICAN_QAF}', "");
    Expect(0, 2237, '\P{^Is_Joining_Group=	 AFRICAN_QAF}', "");
    Error('\p{Is_Jg=- African_Qaf:=}');
    Error('\P{Is_Jg=- African_Qaf:=}');
    Expect(1, 2236, '\p{Is_Jg=africanqaf}', "");
    Expect(0, 2236, '\p{^Is_Jg=africanqaf}', "");
    Expect(0, 2236, '\P{Is_Jg=africanqaf}', "");
    Expect(1, 2236, '\P{^Is_Jg=africanqaf}', "");
    Expect(0, 2237, '\p{Is_Jg=africanqaf}', "");
    Expect(1, 2237, '\p{^Is_Jg=africanqaf}', "");
    Expect(1, 2237, '\P{Is_Jg=africanqaf}', "");
    Expect(0, 2237, '\P{^Is_Jg=africanqaf}', "");
    Expect(1, 2236, '\p{Is_Jg=	_african_QAF}', "");
    Expect(0, 2236, '\p{^Is_Jg=	_african_QAF}', "");
    Expect(0, 2236, '\P{Is_Jg=	_african_QAF}', "");
    Expect(1, 2236, '\P{^Is_Jg=	_african_QAF}', "");
    Expect(0, 2237, '\p{Is_Jg=	_african_QAF}', "");
    Expect(1, 2237, '\p{^Is_Jg=	_african_QAF}', "");
    Expect(1, 2237, '\P{Is_Jg=	_african_QAF}', "");
    Expect(0, 2237, '\P{^Is_Jg=	_african_QAF}', "");
    Error('\p{Joining_Group:   /a/__Ain}');
    Error('\P{Joining_Group:   /a/__Ain}');
    Expect(1, 2227, '\p{Joining_Group:ain}', "");
    Expect(0, 2227, '\p{^Joining_Group:ain}', "");
    Expect(0, 2227, '\P{Joining_Group:ain}', "");
    Expect(1, 2227, '\P{^Joining_Group:ain}', "");
    Expect(0, 2228, '\p{Joining_Group:ain}', "");
    Expect(1, 2228, '\p{^Joining_Group:ain}', "");
    Expect(1, 2228, '\P{Joining_Group:ain}', "");
    Expect(0, 2228, '\P{^Joining_Group:ain}', "");
    Expect(1, 2227, '\p{Joining_Group=	Ain}', "");
    Expect(0, 2227, '\p{^Joining_Group=	Ain}', "");
    Expect(0, 2227, '\P{Joining_Group=	Ain}', "");
    Expect(1, 2227, '\P{^Joining_Group=	Ain}', "");
    Expect(0, 2228, '\p{Joining_Group=	Ain}', "");
    Expect(1, 2228, '\p{^Joining_Group=	Ain}', "");
    Expect(1, 2228, '\P{Joining_Group=	Ain}', "");
    Expect(0, 2228, '\P{^Joining_Group=	Ain}', "");
    Error('\p{Jg=- Ain:=}');
    Error('\P{Jg=- Ain:=}');
    Expect(1, 2227, '\p{Jg=ain}', "");
    Expect(0, 2227, '\p{^Jg=ain}', "");
    Expect(0, 2227, '\P{Jg=ain}', "");
    Expect(1, 2227, '\P{^Jg=ain}', "");
    Expect(0, 2228, '\p{Jg=ain}', "");
    Expect(1, 2228, '\p{^Jg=ain}', "");
    Expect(1, 2228, '\P{Jg=ain}', "");
    Expect(0, 2228, '\P{^Jg=ain}', "");
    Expect(1, 2227, '\p{Jg:Ain}', "");
    Expect(0, 2227, '\p{^Jg:Ain}', "");
    Expect(0, 2227, '\P{Jg:Ain}', "");
    Expect(1, 2227, '\P{^Jg:Ain}', "");
    Expect(0, 2228, '\p{Jg:Ain}', "");
    Expect(1, 2228, '\p{^Jg:Ain}', "");
    Expect(1, 2228, '\P{Jg:Ain}', "");
    Expect(0, 2228, '\P{^Jg:Ain}', "");
    Error('\p{Is_Joining_Group=-_ain/a/}');
    Error('\P{Is_Joining_Group=-_ain/a/}');
    Expect(1, 2227, '\p{Is_Joining_Group=ain}', "");
    Expect(0, 2227, '\p{^Is_Joining_Group=ain}', "");
    Expect(0, 2227, '\P{Is_Joining_Group=ain}', "");
    Expect(1, 2227, '\P{^Is_Joining_Group=ain}', "");
    Expect(0, 2228, '\p{Is_Joining_Group=ain}', "");
    Expect(1, 2228, '\p{^Is_Joining_Group=ain}', "");
    Expect(1, 2228, '\P{Is_Joining_Group=ain}', "");
    Expect(0, 2228, '\P{^Is_Joining_Group=ain}', "");
    Expect(1, 2227, '\p{Is_Joining_Group=--Ain}', "");
    Expect(0, 2227, '\p{^Is_Joining_Group=--Ain}', "");
    Expect(0, 2227, '\P{Is_Joining_Group=--Ain}', "");
    Expect(1, 2227, '\P{^Is_Joining_Group=--Ain}', "");
    Expect(0, 2228, '\p{Is_Joining_Group=--Ain}', "");
    Expect(1, 2228, '\p{^Is_Joining_Group=--Ain}', "");
    Expect(1, 2228, '\P{Is_Joining_Group=--Ain}', "");
    Expect(0, 2228, '\P{^Is_Joining_Group=--Ain}', "");
    Error('\p{Is_Jg=:=	-ain}');
    Error('\P{Is_Jg=:=	-ain}');
    Expect(1, 2227, '\p{Is_Jg=ain}', "");
    Expect(0, 2227, '\p{^Is_Jg=ain}', "");
    Expect(0, 2227, '\P{Is_Jg=ain}', "");
    Expect(1, 2227, '\P{^Is_Jg=ain}', "");
    Expect(0, 2228, '\p{Is_Jg=ain}', "");
    Expect(1, 2228, '\p{^Is_Jg=ain}', "");
    Expect(1, 2228, '\P{Is_Jg=ain}', "");
    Expect(0, 2228, '\P{^Is_Jg=ain}', "");
    Expect(1, 2227, '\p{Is_Jg= AIN}', "");
    Expect(0, 2227, '\p{^Is_Jg= AIN}', "");
    Expect(0, 2227, '\P{Is_Jg= AIN}', "");
    Expect(1, 2227, '\P{^Is_Jg= AIN}', "");
    Expect(0, 2228, '\p{Is_Jg= AIN}', "");
    Expect(1, 2228, '\p{^Is_Jg= AIN}', "");
    Expect(1, 2228, '\P{Is_Jg= AIN}', "");
    Expect(0, 2228, '\P{^Is_Jg= AIN}', "");
    Error('\p{Joining_Group:   /a/ 	Alaph}');
    Error('\P{Joining_Group:   /a/ 	Alaph}');
    Expect(1, 1808, '\p{Joining_Group:   alaph}', "");
    Expect(0, 1808, '\p{^Joining_Group:   alaph}', "");
    Expect(0, 1808, '\P{Joining_Group:   alaph}', "");
    Expect(1, 1808, '\P{^Joining_Group:   alaph}', "");
    Expect(0, 1809, '\p{Joining_Group:   alaph}', "");
    Expect(1, 1809, '\p{^Joining_Group:   alaph}', "");
    Expect(1, 1809, '\P{Joining_Group:   alaph}', "");
    Expect(0, 1809, '\P{^Joining_Group:   alaph}', "");
    Expect(1, 1808, '\p{Joining_Group= -Alaph}', "");
    Expect(0, 1808, '\p{^Joining_Group= -Alaph}', "");
    Expect(0, 1808, '\P{Joining_Group= -Alaph}', "");
    Expect(1, 1808, '\P{^Joining_Group= -Alaph}', "");
    Expect(0, 1809, '\p{Joining_Group= -Alaph}', "");
    Expect(1, 1809, '\p{^Joining_Group= -Alaph}', "");
    Expect(1, 1809, '\P{Joining_Group= -Alaph}', "");
    Expect(0, 1809, '\P{^Joining_Group= -Alaph}', "");
    Error('\p{Jg=	/a/Alaph}');
    Error('\P{Jg=	/a/Alaph}');
    Expect(1, 1808, '\p{Jg=alaph}', "");
    Expect(0, 1808, '\p{^Jg=alaph}', "");
    Expect(0, 1808, '\P{Jg=alaph}', "");
    Expect(1, 1808, '\P{^Jg=alaph}', "");
    Expect(0, 1809, '\p{Jg=alaph}', "");
    Expect(1, 1809, '\p{^Jg=alaph}', "");
    Expect(1, 1809, '\P{Jg=alaph}', "");
    Expect(0, 1809, '\P{^Jg=alaph}', "");
    Expect(1, 1808, '\p{Jg= 	Alaph}', "");
    Expect(0, 1808, '\p{^Jg= 	Alaph}', "");
    Expect(0, 1808, '\P{Jg= 	Alaph}', "");
    Expect(1, 1808, '\P{^Jg= 	Alaph}', "");
    Expect(0, 1809, '\p{Jg= 	Alaph}', "");
    Expect(1, 1809, '\p{^Jg= 	Alaph}', "");
    Expect(1, 1809, '\P{Jg= 	Alaph}', "");
    Expect(0, 1809, '\P{^Jg= 	Alaph}', "");
    Error('\p{Is_Joining_Group=:=_ALAPH}');
    Error('\P{Is_Joining_Group=:=_ALAPH}');
    Expect(1, 1808, '\p{Is_Joining_Group: alaph}', "");
    Expect(0, 1808, '\p{^Is_Joining_Group: alaph}', "");
    Expect(0, 1808, '\P{Is_Joining_Group: alaph}', "");
    Expect(1, 1808, '\P{^Is_Joining_Group: alaph}', "");
    Expect(0, 1809, '\p{Is_Joining_Group: alaph}', "");
    Expect(1, 1809, '\p{^Is_Joining_Group: alaph}', "");
    Expect(1, 1809, '\P{Is_Joining_Group: alaph}', "");
    Expect(0, 1809, '\P{^Is_Joining_Group: alaph}', "");
    Expect(1, 1808, '\p{Is_Joining_Group=- alaph}', "");
    Expect(0, 1808, '\p{^Is_Joining_Group=- alaph}', "");
    Expect(0, 1808, '\P{Is_Joining_Group=- alaph}', "");
    Expect(1, 1808, '\P{^Is_Joining_Group=- alaph}', "");
    Expect(0, 1809, '\p{Is_Joining_Group=- alaph}', "");
    Expect(1, 1809, '\p{^Is_Joining_Group=- alaph}', "");
    Expect(1, 1809, '\P{Is_Joining_Group=- alaph}', "");
    Expect(0, 1809, '\P{^Is_Joining_Group=- alaph}', "");
    Error('\p{Is_Jg=/a/_Alaph}');
    Error('\P{Is_Jg=/a/_Alaph}');
    Expect(1, 1808, '\p{Is_Jg=alaph}', "");
    Expect(0, 1808, '\p{^Is_Jg=alaph}', "");
    Expect(0, 1808, '\P{Is_Jg=alaph}', "");
    Expect(1, 1808, '\P{^Is_Jg=alaph}', "");
    Expect(0, 1809, '\p{Is_Jg=alaph}', "");
    Expect(1, 1809, '\p{^Is_Jg=alaph}', "");
    Expect(1, 1809, '\P{Is_Jg=alaph}', "");
    Expect(0, 1809, '\P{^Is_Jg=alaph}', "");
    Expect(1, 1808, '\p{Is_Jg:	 Alaph}', "");
    Expect(0, 1808, '\p{^Is_Jg:	 Alaph}', "");
    Expect(0, 1808, '\P{Is_Jg:	 Alaph}', "");
    Expect(1, 1808, '\P{^Is_Jg:	 Alaph}', "");
    Expect(0, 1809, '\p{Is_Jg:	 Alaph}', "");
    Expect(1, 1809, '\p{^Is_Jg:	 Alaph}', "");
    Expect(1, 1809, '\P{Is_Jg:	 Alaph}', "");
    Expect(0, 1809, '\P{^Is_Jg:	 Alaph}', "");
    Error('\p{Joining_Group=/a/	Alef}');
    Error('\P{Joining_Group=/a/	Alef}');
    Expect(1, 1908, '\p{Joining_Group=alef}', "");
    Expect(0, 1908, '\p{^Joining_Group=alef}', "");
    Expect(0, 1908, '\P{Joining_Group=alef}', "");
    Expect(1, 1908, '\P{^Joining_Group=alef}', "");
    Expect(0, 1909, '\p{Joining_Group=alef}', "");
    Expect(1, 1909, '\p{^Joining_Group=alef}', "");
    Expect(1, 1909, '\P{Joining_Group=alef}', "");
    Expect(0, 1909, '\P{^Joining_Group=alef}', "");
    Expect(1, 1908, '\p{Joining_Group=	_Alef}', "");
    Expect(0, 1908, '\p{^Joining_Group=	_Alef}', "");
    Expect(0, 1908, '\P{Joining_Group=	_Alef}', "");
    Expect(1, 1908, '\P{^Joining_Group=	_Alef}', "");
    Expect(0, 1909, '\p{Joining_Group=	_Alef}', "");
    Expect(1, 1909, '\p{^Joining_Group=	_Alef}', "");
    Expect(1, 1909, '\P{Joining_Group=	_Alef}', "");
    Expect(0, 1909, '\P{^Joining_Group=	_Alef}', "");
    Error('\p{Jg=- ALEF/a/}');
    Error('\P{Jg=- ALEF/a/}');
    Expect(1, 1908, '\p{Jg:alef}', "");
    Expect(0, 1908, '\p{^Jg:alef}', "");
    Expect(0, 1908, '\P{Jg:alef}', "");
    Expect(1, 1908, '\P{^Jg:alef}', "");
    Expect(0, 1909, '\p{Jg:alef}', "");
    Expect(1, 1909, '\p{^Jg:alef}', "");
    Expect(1, 1909, '\P{Jg:alef}', "");
    Expect(0, 1909, '\P{^Jg:alef}', "");
    Expect(1, 1908, '\p{Jg= _ALEF}', "");
    Expect(0, 1908, '\p{^Jg= _ALEF}', "");
    Expect(0, 1908, '\P{Jg= _ALEF}', "");
    Expect(1, 1908, '\P{^Jg= _ALEF}', "");
    Expect(0, 1909, '\p{Jg= _ALEF}', "");
    Expect(1, 1909, '\p{^Jg= _ALEF}', "");
    Expect(1, 1909, '\P{Jg= _ALEF}', "");
    Expect(0, 1909, '\P{^Jg= _ALEF}', "");
    Error('\p{Is_Joining_Group:   -_Alef/a/}');
    Error('\P{Is_Joining_Group:   -_Alef/a/}');
    Expect(1, 1908, '\p{Is_Joining_Group=alef}', "");
    Expect(0, 1908, '\p{^Is_Joining_Group=alef}', "");
    Expect(0, 1908, '\P{Is_Joining_Group=alef}', "");
    Expect(1, 1908, '\P{^Is_Joining_Group=alef}', "");
    Expect(0, 1909, '\p{Is_Joining_Group=alef}', "");
    Expect(1, 1909, '\p{^Is_Joining_Group=alef}', "");
    Expect(1, 1909, '\P{Is_Joining_Group=alef}', "");
    Expect(0, 1909, '\P{^Is_Joining_Group=alef}', "");
    Expect(1, 1908, '\p{Is_Joining_Group=_-Alef}', "");
    Expect(0, 1908, '\p{^Is_Joining_Group=_-Alef}', "");
    Expect(0, 1908, '\P{Is_Joining_Group=_-Alef}', "");
    Expect(1, 1908, '\P{^Is_Joining_Group=_-Alef}', "");
    Expect(0, 1909, '\p{Is_Joining_Group=_-Alef}', "");
    Expect(1, 1909, '\p{^Is_Joining_Group=_-Alef}', "");
    Expect(1, 1909, '\P{Is_Joining_Group=_-Alef}', "");
    Expect(0, 1909, '\P{^Is_Joining_Group=_-Alef}', "");
    Error('\p{Is_Jg=-Alef/a/}');
    Error('\P{Is_Jg=-Alef/a/}');
    Expect(1, 1908, '\p{Is_Jg=alef}', "");
    Expect(0, 1908, '\p{^Is_Jg=alef}', "");
    Expect(0, 1908, '\P{Is_Jg=alef}', "");
    Expect(1, 1908, '\P{^Is_Jg=alef}', "");
    Expect(0, 1909, '\p{Is_Jg=alef}', "");
    Expect(1, 1909, '\p{^Is_Jg=alef}', "");
    Expect(1, 1909, '\P{Is_Jg=alef}', "");
    Expect(0, 1909, '\P{^Is_Jg=alef}', "");
    Expect(1, 1908, '\p{Is_Jg=-alef}', "");
    Expect(0, 1908, '\p{^Is_Jg=-alef}', "");
    Expect(0, 1908, '\P{Is_Jg=-alef}', "");
    Expect(1, 1908, '\P{^Is_Jg=-alef}', "");
    Expect(0, 1909, '\p{Is_Jg=-alef}', "");
    Expect(1, 1909, '\p{^Is_Jg=-alef}', "");
    Expect(1, 1909, '\P{Is_Jg=-alef}', "");
    Expect(0, 1909, '\P{^Is_Jg=-alef}', "");
    Error('\p{Joining_Group=	/a/BEH}');
    Error('\P{Joining_Group=	/a/BEH}');
    Expect(1, 2232, '\p{Joining_Group=beh}', "");
    Expect(0, 2232, '\p{^Joining_Group=beh}', "");
    Expect(0, 2232, '\P{Joining_Group=beh}', "");
    Expect(1, 2232, '\P{^Joining_Group=beh}', "");
    Expect(0, 2233, '\p{Joining_Group=beh}', "");
    Expect(1, 2233, '\p{^Joining_Group=beh}', "");
    Expect(1, 2233, '\P{Joining_Group=beh}', "");
    Expect(0, 2233, '\P{^Joining_Group=beh}', "");
    Expect(1, 2232, '\p{Joining_Group=  BEH}', "");
    Expect(0, 2232, '\p{^Joining_Group=  BEH}', "");
    Expect(0, 2232, '\P{Joining_Group=  BEH}', "");
    Expect(1, 2232, '\P{^Joining_Group=  BEH}', "");
    Expect(0, 2233, '\p{Joining_Group=  BEH}', "");
    Expect(1, 2233, '\p{^Joining_Group=  BEH}', "");
    Expect(1, 2233, '\P{Joining_Group=  BEH}', "");
    Expect(0, 2233, '\P{^Joining_Group=  BEH}', "");
    Error('\p{Jg=	 Beh:=}');
    Error('\P{Jg=	 Beh:=}');
    Expect(1, 2232, '\p{Jg=beh}', "");
    Expect(0, 2232, '\p{^Jg=beh}', "");
    Expect(0, 2232, '\P{Jg=beh}', "");
    Expect(1, 2232, '\P{^Jg=beh}', "");
    Expect(0, 2233, '\p{Jg=beh}', "");
    Expect(1, 2233, '\p{^Jg=beh}', "");
    Expect(1, 2233, '\P{Jg=beh}', "");
    Expect(0, 2233, '\P{^Jg=beh}', "");
    Expect(1, 2232, '\p{Jg:     Beh}', "");
    Expect(0, 2232, '\p{^Jg:     Beh}', "");
    Expect(0, 2232, '\P{Jg:     Beh}', "");
    Expect(1, 2232, '\P{^Jg:     Beh}', "");
    Expect(0, 2233, '\p{Jg:     Beh}', "");
    Expect(1, 2233, '\p{^Jg:     Beh}', "");
    Expect(1, 2233, '\P{Jg:     Beh}', "");
    Expect(0, 2233, '\P{^Jg:     Beh}', "");
    Error('\p{Is_Joining_Group=:= _Beh}');
    Error('\P{Is_Joining_Group=:= _Beh}');
    Expect(1, 2232, '\p{Is_Joining_Group:	beh}', "");
    Expect(0, 2232, '\p{^Is_Joining_Group:	beh}', "");
    Expect(0, 2232, '\P{Is_Joining_Group:	beh}', "");
    Expect(1, 2232, '\P{^Is_Joining_Group:	beh}', "");
    Expect(0, 2233, '\p{Is_Joining_Group:	beh}', "");
    Expect(1, 2233, '\p{^Is_Joining_Group:	beh}', "");
    Expect(1, 2233, '\P{Is_Joining_Group:	beh}', "");
    Expect(0, 2233, '\P{^Is_Joining_Group:	beh}', "");
    Expect(1, 2232, '\p{Is_Joining_Group=	BEH}', "");
    Expect(0, 2232, '\p{^Is_Joining_Group=	BEH}', "");
    Expect(0, 2232, '\P{Is_Joining_Group=	BEH}', "");
    Expect(1, 2232, '\P{^Is_Joining_Group=	BEH}', "");
    Expect(0, 2233, '\p{Is_Joining_Group=	BEH}', "");
    Expect(1, 2233, '\p{^Is_Joining_Group=	BEH}', "");
    Expect(1, 2233, '\P{Is_Joining_Group=	BEH}', "");
    Expect(0, 2233, '\P{^Is_Joining_Group=	BEH}', "");
    Error('\p{Is_Jg: 	:=BEH}');
    Error('\P{Is_Jg: 	:=BEH}');
    Expect(1, 2232, '\p{Is_Jg=beh}', "");
    Expect(0, 2232, '\p{^Is_Jg=beh}', "");
    Expect(0, 2232, '\P{Is_Jg=beh}', "");
    Expect(1, 2232, '\P{^Is_Jg=beh}', "");
    Expect(0, 2233, '\p{Is_Jg=beh}', "");
    Expect(1, 2233, '\p{^Is_Jg=beh}', "");
    Expect(1, 2233, '\P{Is_Jg=beh}', "");
    Expect(0, 2233, '\P{^Is_Jg=beh}', "");
    Expect(1, 2232, '\p{Is_Jg= -beh}', "");
    Expect(0, 2232, '\p{^Is_Jg= -beh}', "");
    Expect(0, 2232, '\P{Is_Jg= -beh}', "");
    Expect(1, 2232, '\P{^Is_Jg= -beh}', "");
    Expect(0, 2233, '\p{Is_Jg= -beh}', "");
    Expect(1, 2233, '\p{^Is_Jg= -beh}', "");
    Expect(1, 2233, '\P{Is_Jg= -beh}', "");
    Expect(0, 2233, '\P{^Is_Jg= -beh}', "");
    Error('\p{Joining_Group=_Beth:=}');
    Error('\P{Joining_Group=_Beth:=}');
    Expect(1, 1837, '\p{Joining_Group=beth}', "");
    Expect(0, 1837, '\p{^Joining_Group=beth}', "");
    Expect(0, 1837, '\P{Joining_Group=beth}', "");
    Expect(1, 1837, '\P{^Joining_Group=beth}', "");
    Expect(0, 1838, '\p{Joining_Group=beth}', "");
    Expect(1, 1838, '\p{^Joining_Group=beth}', "");
    Expect(1, 1838, '\P{Joining_Group=beth}', "");
    Expect(0, 1838, '\P{^Joining_Group=beth}', "");
    Expect(1, 1837, '\p{Joining_Group= 	beth}', "");
    Expect(0, 1837, '\p{^Joining_Group= 	beth}', "");
    Expect(0, 1837, '\P{Joining_Group= 	beth}', "");
    Expect(1, 1837, '\P{^Joining_Group= 	beth}', "");
    Expect(0, 1838, '\p{Joining_Group= 	beth}', "");
    Expect(1, 1838, '\p{^Joining_Group= 	beth}', "");
    Expect(1, 1838, '\P{Joining_Group= 	beth}', "");
    Expect(0, 1838, '\P{^Joining_Group= 	beth}', "");
    Error('\p{Jg=:=_BETH}');
    Error('\P{Jg=:=_BETH}');
    Expect(1, 1837, '\p{Jg=beth}', "");
    Expect(0, 1837, '\p{^Jg=beth}', "");
    Expect(0, 1837, '\P{Jg=beth}', "");
    Expect(1, 1837, '\P{^Jg=beth}', "");
    Expect(0, 1838, '\p{Jg=beth}', "");
    Expect(1, 1838, '\p{^Jg=beth}', "");
    Expect(1, 1838, '\P{Jg=beth}', "");
    Expect(0, 1838, '\P{^Jg=beth}', "");
    Expect(1, 1837, '\p{Jg=_-beth}', "");
    Expect(0, 1837, '\p{^Jg=_-beth}', "");
    Expect(0, 1837, '\P{Jg=_-beth}', "");
    Expect(1, 1837, '\P{^Jg=_-beth}', "");
    Expect(0, 1838, '\p{Jg=_-beth}', "");
    Expect(1, 1838, '\p{^Jg=_-beth}', "");
    Expect(1, 1838, '\P{Jg=_-beth}', "");
    Expect(0, 1838, '\P{^Jg=_-beth}', "");
    Error('\p{Is_Joining_Group=_-Beth:=}');
    Error('\P{Is_Joining_Group=_-Beth:=}');
    Expect(1, 1837, '\p{Is_Joining_Group=beth}', "");
    Expect(0, 1837, '\p{^Is_Joining_Group=beth}', "");
    Expect(0, 1837, '\P{Is_Joining_Group=beth}', "");
    Expect(1, 1837, '\P{^Is_Joining_Group=beth}', "");
    Expect(0, 1838, '\p{Is_Joining_Group=beth}', "");
    Expect(1, 1838, '\p{^Is_Joining_Group=beth}', "");
    Expect(1, 1838, '\P{Is_Joining_Group=beth}', "");
    Expect(0, 1838, '\P{^Is_Joining_Group=beth}', "");
    Expect(1, 1837, '\p{Is_Joining_Group=- Beth}', "");
    Expect(0, 1837, '\p{^Is_Joining_Group=- Beth}', "");
    Expect(0, 1837, '\P{Is_Joining_Group=- Beth}', "");
    Expect(1, 1837, '\P{^Is_Joining_Group=- Beth}', "");
    Expect(0, 1838, '\p{Is_Joining_Group=- Beth}', "");
    Expect(1, 1838, '\p{^Is_Joining_Group=- Beth}', "");
    Expect(1, 1838, '\P{Is_Joining_Group=- Beth}', "");
    Expect(0, 1838, '\P{^Is_Joining_Group=- Beth}', "");
    Error('\p{Is_Jg=/a/	 beth}');
    Error('\P{Is_Jg=/a/	 beth}');
    Expect(1, 1837, '\p{Is_Jg=beth}', "");
    Expect(0, 1837, '\p{^Is_Jg=beth}', "");
    Expect(0, 1837, '\P{Is_Jg=beth}', "");
    Expect(1, 1837, '\P{^Is_Jg=beth}', "");
    Expect(0, 1838, '\p{Is_Jg=beth}', "");
    Expect(1, 1838, '\p{^Is_Jg=beth}', "");
    Expect(1, 1838, '\P{Is_Jg=beth}', "");
    Expect(0, 1838, '\P{^Is_Jg=beth}', "");
    Expect(1, 1837, '\p{Is_Jg=-beth}', "");
    Expect(0, 1837, '\p{^Is_Jg=-beth}', "");
    Expect(0, 1837, '\P{Is_Jg=-beth}', "");
    Expect(1, 1837, '\P{^Is_Jg=-beth}', "");
    Expect(0, 1838, '\p{Is_Jg=-beth}', "");
    Expect(1, 1838, '\p{^Is_Jg=-beth}', "");
    Expect(1, 1838, '\P{Is_Jg=-beth}', "");
    Expect(0, 1838, '\P{^Is_Jg=-beth}', "");
    Error('\p{Joining_Group= 	Burushaski_YEH_barree/a/}');
    Error('\P{Joining_Group= 	Burushaski_YEH_barree/a/}');
    Expect(1, 1915, '\p{Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1915, '\p{^Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1915, '\P{Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1915, '\P{^Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1916, '\p{Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1916, '\p{^Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1916, '\P{Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1916, '\P{^Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1915, '\p{Joining_Group= _Burushaski_Yeh_BARREE}', "");
    Expect(0, 1915, '\p{^Joining_Group= _Burushaski_Yeh_BARREE}', "");
    Expect(0, 1915, '\P{Joining_Group= _Burushaski_Yeh_BARREE}', "");
    Expect(1, 1915, '\P{^Joining_Group= _Burushaski_Yeh_BARREE}', "");
    Expect(0, 1916, '\p{Joining_Group= _Burushaski_Yeh_BARREE}', "");
    Expect(1, 1916, '\p{^Joining_Group= _Burushaski_Yeh_BARREE}', "");
    Expect(1, 1916, '\P{Joining_Group= _Burushaski_Yeh_BARREE}', "");
    Expect(0, 1916, '\P{^Joining_Group= _Burushaski_Yeh_BARREE}', "");
    Error('\p{Jg: -Burushaski_Yeh_barree:=}');
    Error('\P{Jg: -Burushaski_Yeh_barree:=}');
    Expect(1, 1915, '\p{Jg=burushaskiyehbarree}', "");
    Expect(0, 1915, '\p{^Jg=burushaskiyehbarree}', "");
    Expect(0, 1915, '\P{Jg=burushaskiyehbarree}', "");
    Expect(1, 1915, '\P{^Jg=burushaskiyehbarree}', "");
    Expect(0, 1916, '\p{Jg=burushaskiyehbarree}', "");
    Expect(1, 1916, '\p{^Jg=burushaskiyehbarree}', "");
    Expect(1, 1916, '\P{Jg=burushaskiyehbarree}', "");
    Expect(0, 1916, '\P{^Jg=burushaskiyehbarree}', "");
    Expect(1, 1915, '\p{Jg=	BURUSHASKI_yeh_barree}', "");
    Expect(0, 1915, '\p{^Jg=	BURUSHASKI_yeh_barree}', "");
    Expect(0, 1915, '\P{Jg=	BURUSHASKI_yeh_barree}', "");
    Expect(1, 1915, '\P{^Jg=	BURUSHASKI_yeh_barree}', "");
    Expect(0, 1916, '\p{Jg=	BURUSHASKI_yeh_barree}', "");
    Expect(1, 1916, '\p{^Jg=	BURUSHASKI_yeh_barree}', "");
    Expect(1, 1916, '\P{Jg=	BURUSHASKI_yeh_barree}', "");
    Expect(0, 1916, '\P{^Jg=	BURUSHASKI_yeh_barree}', "");
    Error('\p{Is_Joining_Group= :=Burushaski_Yeh_Barree}');
    Error('\P{Is_Joining_Group= :=Burushaski_Yeh_Barree}');
    Expect(1, 1915, '\p{Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1915, '\p{^Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1915, '\P{Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1915, '\P{^Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1916, '\p{Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1916, '\p{^Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1916, '\P{Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1916, '\P{^Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1915, '\p{Is_Joining_Group:	_	Burushaski_YEH_barree}', "");
    Expect(0, 1915, '\p{^Is_Joining_Group:	_	Burushaski_YEH_barree}', "");
    Expect(0, 1915, '\P{Is_Joining_Group:	_	Burushaski_YEH_barree}', "");
    Expect(1, 1915, '\P{^Is_Joining_Group:	_	Burushaski_YEH_barree}', "");
    Expect(0, 1916, '\p{Is_Joining_Group:	_	Burushaski_YEH_barree}', "");
    Expect(1, 1916, '\p{^Is_Joining_Group:	_	Burushaski_YEH_barree}', "");
    Expect(1, 1916, '\P{Is_Joining_Group:	_	Burushaski_YEH_barree}', "");
    Expect(0, 1916, '\P{^Is_Joining_Group:	_	Burushaski_YEH_barree}', "");
    Error('\p{Is_Jg=:=	Burushaski_YEH_barree}');
    Error('\P{Is_Jg=:=	Burushaski_YEH_barree}');
    Expect(1, 1915, '\p{Is_Jg=burushaskiyehbarree}', "");
    Expect(0, 1915, '\p{^Is_Jg=burushaskiyehbarree}', "");
    Expect(0, 1915, '\P{Is_Jg=burushaskiyehbarree}', "");
    Expect(1, 1915, '\P{^Is_Jg=burushaskiyehbarree}', "");
    Expect(0, 1916, '\p{Is_Jg=burushaskiyehbarree}', "");
    Expect(1, 1916, '\p{^Is_Jg=burushaskiyehbarree}', "");
    Expect(1, 1916, '\P{Is_Jg=burushaskiyehbarree}', "");
    Expect(0, 1916, '\P{^Is_Jg=burushaskiyehbarree}', "");
    Expect(1, 1915, '\p{Is_Jg= Burushaski_Yeh_Barree}', "");
    Expect(0, 1915, '\p{^Is_Jg= Burushaski_Yeh_Barree}', "");
    Expect(0, 1915, '\P{Is_Jg= Burushaski_Yeh_Barree}', "");
    Expect(1, 1915, '\P{^Is_Jg= Burushaski_Yeh_Barree}', "");
    Expect(0, 1916, '\p{Is_Jg= Burushaski_Yeh_Barree}', "");
    Expect(1, 1916, '\p{^Is_Jg= Burushaski_Yeh_Barree}', "");
    Expect(1, 1916, '\P{Is_Jg= Burushaski_Yeh_Barree}', "");
    Expect(0, 1916, '\P{^Is_Jg= Burushaski_Yeh_Barree}', "");
    Error('\p{Joining_Group:	_	Dal:=}');
    Error('\P{Joining_Group:	_	Dal:=}');
    Expect(1, 2222, '\p{Joining_Group=dal}', "");
    Expect(0, 2222, '\p{^Joining_Group=dal}', "");
    Expect(0, 2222, '\P{Joining_Group=dal}', "");
    Expect(1, 2222, '\P{^Joining_Group=dal}', "");
    Expect(0, 2223, '\p{Joining_Group=dal}', "");
    Expect(1, 2223, '\p{^Joining_Group=dal}', "");
    Expect(1, 2223, '\P{Joining_Group=dal}', "");
    Expect(0, 2223, '\P{^Joining_Group=dal}', "");
    Expect(1, 2222, '\p{Joining_Group=_dal}', "");
    Expect(0, 2222, '\p{^Joining_Group=_dal}', "");
    Expect(0, 2222, '\P{Joining_Group=_dal}', "");
    Expect(1, 2222, '\P{^Joining_Group=_dal}', "");
    Expect(0, 2223, '\p{Joining_Group=_dal}', "");
    Expect(1, 2223, '\p{^Joining_Group=_dal}', "");
    Expect(1, 2223, '\P{Joining_Group=_dal}', "");
    Expect(0, 2223, '\P{^Joining_Group=_dal}', "");
    Error('\p{Jg= /a/Dal}');
    Error('\P{Jg= /a/Dal}');
    Expect(1, 2222, '\p{Jg=dal}', "");
    Expect(0, 2222, '\p{^Jg=dal}', "");
    Expect(0, 2222, '\P{Jg=dal}', "");
    Expect(1, 2222, '\P{^Jg=dal}', "");
    Expect(0, 2223, '\p{Jg=dal}', "");
    Expect(1, 2223, '\p{^Jg=dal}', "");
    Expect(1, 2223, '\P{Jg=dal}', "");
    Expect(0, 2223, '\P{^Jg=dal}', "");
    Expect(1, 2222, '\p{Jg=	dal}', "");
    Expect(0, 2222, '\p{^Jg=	dal}', "");
    Expect(0, 2222, '\P{Jg=	dal}', "");
    Expect(1, 2222, '\P{^Jg=	dal}', "");
    Expect(0, 2223, '\p{Jg=	dal}', "");
    Expect(1, 2223, '\p{^Jg=	dal}', "");
    Expect(1, 2223, '\P{Jg=	dal}', "");
    Expect(0, 2223, '\P{^Jg=	dal}', "");
    Error('\p{Is_Joining_Group=	/a/dal}');
    Error('\P{Is_Joining_Group=	/a/dal}');
    Expect(1, 2222, '\p{Is_Joining_Group=dal}', "");
    Expect(0, 2222, '\p{^Is_Joining_Group=dal}', "");
    Expect(0, 2222, '\P{Is_Joining_Group=dal}', "");
    Expect(1, 2222, '\P{^Is_Joining_Group=dal}', "");
    Expect(0, 2223, '\p{Is_Joining_Group=dal}', "");
    Expect(1, 2223, '\p{^Is_Joining_Group=dal}', "");
    Expect(1, 2223, '\P{Is_Joining_Group=dal}', "");
    Expect(0, 2223, '\P{^Is_Joining_Group=dal}', "");
    Expect(1, 2222, '\p{Is_Joining_Group=	Dal}', "");
    Expect(0, 2222, '\p{^Is_Joining_Group=	Dal}', "");
    Expect(0, 2222, '\P{Is_Joining_Group=	Dal}', "");
    Expect(1, 2222, '\P{^Is_Joining_Group=	Dal}', "");
    Expect(0, 2223, '\p{Is_Joining_Group=	Dal}', "");
    Expect(1, 2223, '\p{^Is_Joining_Group=	Dal}', "");
    Expect(1, 2223, '\P{Is_Joining_Group=	Dal}', "");
    Expect(0, 2223, '\P{^Is_Joining_Group=	Dal}', "");
    Error('\p{Is_Jg=	/a/Dal}');
    Error('\P{Is_Jg=	/a/Dal}');
    Expect(1, 2222, '\p{Is_Jg=dal}', "");
    Expect(0, 2222, '\p{^Is_Jg=dal}', "");
    Expect(0, 2222, '\P{Is_Jg=dal}', "");
    Expect(1, 2222, '\P{^Is_Jg=dal}', "");
    Expect(0, 2223, '\p{Is_Jg=dal}', "");
    Expect(1, 2223, '\p{^Is_Jg=dal}', "");
    Expect(1, 2223, '\P{Is_Jg=dal}', "");
    Expect(0, 2223, '\P{^Is_Jg=dal}', "");
    Expect(1, 2222, '\p{Is_Jg=	Dal}', "");
    Expect(0, 2222, '\p{^Is_Jg=	Dal}', "");
    Expect(0, 2222, '\P{Is_Jg=	Dal}', "");
    Expect(1, 2222, '\P{^Is_Jg=	Dal}', "");
    Expect(0, 2223, '\p{Is_Jg=	Dal}', "");
    Expect(1, 2223, '\p{^Is_Jg=	Dal}', "");
    Expect(1, 2223, '\P{Is_Jg=	Dal}', "");
    Expect(0, 2223, '\P{^Is_Jg=	Dal}', "");
    Error('\p{Joining_Group= /a/DALATH_rish}');
    Error('\P{Joining_Group= /a/DALATH_rish}');
    Expect(1, 1839, '\p{Joining_Group=dalathrish}', "");
    Expect(0, 1839, '\p{^Joining_Group=dalathrish}', "");
    Expect(0, 1839, '\P{Joining_Group=dalathrish}', "");
    Expect(1, 1839, '\P{^Joining_Group=dalathrish}', "");
    Expect(0, 1840, '\p{Joining_Group=dalathrish}', "");
    Expect(1, 1840, '\p{^Joining_Group=dalathrish}', "");
    Expect(1, 1840, '\P{Joining_Group=dalathrish}', "");
    Expect(0, 1840, '\P{^Joining_Group=dalathrish}', "");
    Expect(1, 1839, '\p{Joining_Group=		Dalath_RISH}', "");
    Expect(0, 1839, '\p{^Joining_Group=		Dalath_RISH}', "");
    Expect(0, 1839, '\P{Joining_Group=		Dalath_RISH}', "");
    Expect(1, 1839, '\P{^Joining_Group=		Dalath_RISH}', "");
    Expect(0, 1840, '\p{Joining_Group=		Dalath_RISH}', "");
    Expect(1, 1840, '\p{^Joining_Group=		Dalath_RISH}', "");
    Expect(1, 1840, '\P{Joining_Group=		Dalath_RISH}', "");
    Expect(0, 1840, '\P{^Joining_Group=		Dalath_RISH}', "");
    Error('\p{Jg=:=--Dalath_Rish}');
    Error('\P{Jg=:=--Dalath_Rish}');
    Expect(1, 1839, '\p{Jg=dalathrish}', "");
    Expect(0, 1839, '\p{^Jg=dalathrish}', "");
    Expect(0, 1839, '\P{Jg=dalathrish}', "");
    Expect(1, 1839, '\P{^Jg=dalathrish}', "");
    Expect(0, 1840, '\p{Jg=dalathrish}', "");
    Expect(1, 1840, '\p{^Jg=dalathrish}', "");
    Expect(1, 1840, '\P{Jg=dalathrish}', "");
    Expect(0, 1840, '\P{^Jg=dalathrish}', "");
    Expect(1, 1839, '\p{Jg= _Dalath_rish}', "");
    Expect(0, 1839, '\p{^Jg= _Dalath_rish}', "");
    Expect(0, 1839, '\P{Jg= _Dalath_rish}', "");
    Expect(1, 1839, '\P{^Jg= _Dalath_rish}', "");
    Expect(0, 1840, '\p{Jg= _Dalath_rish}', "");
    Expect(1, 1840, '\p{^Jg= _Dalath_rish}', "");
    Expect(1, 1840, '\P{Jg= _Dalath_rish}', "");
    Expect(0, 1840, '\P{^Jg= _Dalath_rish}', "");
    Error('\p{Is_Joining_Group=_:=DALATH_rish}');
    Error('\P{Is_Joining_Group=_:=DALATH_rish}');
    Expect(1, 1839, '\p{Is_Joining_Group:dalathrish}', "");
    Expect(0, 1839, '\p{^Is_Joining_Group:dalathrish}', "");
    Expect(0, 1839, '\P{Is_Joining_Group:dalathrish}', "");
    Expect(1, 1839, '\P{^Is_Joining_Group:dalathrish}', "");
    Expect(0, 1840, '\p{Is_Joining_Group:dalathrish}', "");
    Expect(1, 1840, '\p{^Is_Joining_Group:dalathrish}', "");
    Expect(1, 1840, '\P{Is_Joining_Group:dalathrish}', "");
    Expect(0, 1840, '\P{^Is_Joining_Group:dalathrish}', "");
    Expect(1, 1839, '\p{Is_Joining_Group=	Dalath_Rish}', "");
    Expect(0, 1839, '\p{^Is_Joining_Group=	Dalath_Rish}', "");
    Expect(0, 1839, '\P{Is_Joining_Group=	Dalath_Rish}', "");
    Expect(1, 1839, '\P{^Is_Joining_Group=	Dalath_Rish}', "");
    Expect(0, 1840, '\p{Is_Joining_Group=	Dalath_Rish}', "");
    Expect(1, 1840, '\p{^Is_Joining_Group=	Dalath_Rish}', "");
    Expect(1, 1840, '\P{Is_Joining_Group=	Dalath_Rish}', "");
    Expect(0, 1840, '\P{^Is_Joining_Group=	Dalath_Rish}', "");
    Error('\p{Is_Jg=- Dalath_RISH:=}');
    Error('\P{Is_Jg=- Dalath_RISH:=}');
    Expect(1, 1839, '\p{Is_Jg=dalathrish}', "");
    Expect(0, 1839, '\p{^Is_Jg=dalathrish}', "");
    Expect(0, 1839, '\P{Is_Jg=dalathrish}', "");
    Expect(1, 1839, '\P{^Is_Jg=dalathrish}', "");
    Expect(0, 1840, '\p{Is_Jg=dalathrish}', "");
    Expect(1, 1840, '\p{^Is_Jg=dalathrish}', "");
    Expect(1, 1840, '\P{Is_Jg=dalathrish}', "");
    Expect(0, 1840, '\P{^Is_Jg=dalathrish}', "");
    Expect(1, 1839, '\p{Is_Jg:   __Dalath_Rish}', "");
    Expect(0, 1839, '\p{^Is_Jg:   __Dalath_Rish}', "");
    Expect(0, 1839, '\P{Is_Jg:   __Dalath_Rish}', "");
    Expect(1, 1839, '\P{^Is_Jg:   __Dalath_Rish}', "");
    Expect(0, 1840, '\p{Is_Jg:   __Dalath_Rish}', "");
    Expect(1, 1840, '\p{^Is_Jg:   __Dalath_Rish}', "");
    Expect(1, 1840, '\P{Is_Jg:   __Dalath_Rish}', "");
    Expect(0, 1840, '\P{^Is_Jg:   __Dalath_Rish}', "");
    Error('\p{Joining_Group=	:=E}');
    Error('\P{Joining_Group=	:=E}');
    Expect(1, 1829, '\p{Joining_Group=e}', "");
    Expect(0, 1829, '\p{^Joining_Group=e}', "");
    Expect(0, 1829, '\P{Joining_Group=e}', "");
    Expect(1, 1829, '\P{^Joining_Group=e}', "");
    Expect(0, 1830, '\p{Joining_Group=e}', "");
    Expect(1, 1830, '\p{^Joining_Group=e}', "");
    Expect(1, 1830, '\P{Joining_Group=e}', "");
    Expect(0, 1830, '\P{^Joining_Group=e}', "");
    Expect(1, 1829, '\p{Joining_Group=_E}', "");
    Expect(0, 1829, '\p{^Joining_Group=_E}', "");
    Expect(0, 1829, '\P{Joining_Group=_E}', "");
    Expect(1, 1829, '\P{^Joining_Group=_E}', "");
    Expect(0, 1830, '\p{Joining_Group=_E}', "");
    Expect(1, 1830, '\p{^Joining_Group=_E}', "");
    Expect(1, 1830, '\P{Joining_Group=_E}', "");
    Expect(0, 1830, '\P{^Joining_Group=_E}', "");
    Error('\p{Jg=:=-e}');
    Error('\P{Jg=:=-e}');
    Expect(1, 1829, '\p{Jg=e}', "");
    Expect(0, 1829, '\p{^Jg=e}', "");
    Expect(0, 1829, '\P{Jg=e}', "");
    Expect(1, 1829, '\P{^Jg=e}', "");
    Expect(0, 1830, '\p{Jg=e}', "");
    Expect(1, 1830, '\p{^Jg=e}', "");
    Expect(1, 1830, '\P{Jg=e}', "");
    Expect(0, 1830, '\P{^Jg=e}', "");
    Expect(1, 1829, '\p{Jg=--e}', "");
    Expect(0, 1829, '\p{^Jg=--e}', "");
    Expect(0, 1829, '\P{Jg=--e}', "");
    Expect(1, 1829, '\P{^Jg=--e}', "");
    Expect(0, 1830, '\p{Jg=--e}', "");
    Expect(1, 1830, '\p{^Jg=--e}', "");
    Expect(1, 1830, '\P{Jg=--e}', "");
    Expect(0, 1830, '\P{^Jg=--e}', "");
    Error('\p{Is_Joining_Group=/a/E}');
    Error('\P{Is_Joining_Group=/a/E}');
    Expect(1, 1829, '\p{Is_Joining_Group=e}', "");
    Expect(0, 1829, '\p{^Is_Joining_Group=e}', "");
    Expect(0, 1829, '\P{Is_Joining_Group=e}', "");
    Expect(1, 1829, '\P{^Is_Joining_Group=e}', "");
    Expect(0, 1830, '\p{Is_Joining_Group=e}', "");
    Expect(1, 1830, '\p{^Is_Joining_Group=e}', "");
    Expect(1, 1830, '\P{Is_Joining_Group=e}', "");
    Expect(0, 1830, '\P{^Is_Joining_Group=e}', "");
    Expect(1, 1829, '\p{Is_Joining_Group= 	E}', "");
    Expect(0, 1829, '\p{^Is_Joining_Group= 	E}', "");
    Expect(0, 1829, '\P{Is_Joining_Group= 	E}', "");
    Expect(1, 1829, '\P{^Is_Joining_Group= 	E}', "");
    Expect(0, 1830, '\p{Is_Joining_Group= 	E}', "");
    Expect(1, 1830, '\p{^Is_Joining_Group= 	E}', "");
    Expect(1, 1830, '\P{Is_Joining_Group= 	E}', "");
    Expect(0, 1830, '\P{^Is_Joining_Group= 	E}', "");
    Error('\p{Is_Jg=:= -e}');
    Error('\P{Is_Jg=:= -e}');
    Expect(1, 1829, '\p{Is_Jg=e}', "");
    Expect(0, 1829, '\p{^Is_Jg=e}', "");
    Expect(0, 1829, '\P{Is_Jg=e}', "");
    Expect(1, 1829, '\P{^Is_Jg=e}', "");
    Expect(0, 1830, '\p{Is_Jg=e}', "");
    Expect(1, 1830, '\p{^Is_Jg=e}', "");
    Expect(1, 1830, '\P{Is_Jg=e}', "");
    Expect(0, 1830, '\P{^Is_Jg=e}', "");
    Expect(1, 1829, '\p{Is_Jg=	_E}', "");
    Expect(0, 1829, '\p{^Is_Jg=	_E}', "");
    Expect(0, 1829, '\P{Is_Jg=	_E}', "");
    Expect(1, 1829, '\P{^Is_Jg=	_E}', "");
    Expect(0, 1830, '\p{Is_Jg=	_E}', "");
    Expect(1, 1830, '\p{^Is_Jg=	_E}', "");
    Expect(1, 1830, '\P{Is_Jg=	_E}', "");
    Expect(0, 1830, '\P{^Is_Jg=	_E}', "");
    Error('\p{Joining_Group= :=Farsi_Yeh}');
    Error('\P{Joining_Group= :=Farsi_Yeh}');
    Expect(1, 1910, '\p{Joining_Group=farsiyeh}', "");
    Expect(0, 1910, '\p{^Joining_Group=farsiyeh}', "");
    Expect(0, 1910, '\P{Joining_Group=farsiyeh}', "");
    Expect(1, 1910, '\P{^Joining_Group=farsiyeh}', "");
    Expect(0, 1911, '\p{Joining_Group=farsiyeh}', "");
    Expect(1, 1911, '\p{^Joining_Group=farsiyeh}', "");
    Expect(1, 1911, '\P{Joining_Group=farsiyeh}', "");
    Expect(0, 1911, '\P{^Joining_Group=farsiyeh}', "");
    Expect(1, 1910, '\p{Joining_Group=_Farsi_yeh}', "");
    Expect(0, 1910, '\p{^Joining_Group=_Farsi_yeh}', "");
    Expect(0, 1910, '\P{Joining_Group=_Farsi_yeh}', "");
    Expect(1, 1910, '\P{^Joining_Group=_Farsi_yeh}', "");
    Expect(0, 1911, '\p{Joining_Group=_Farsi_yeh}', "");
    Expect(1, 1911, '\p{^Joining_Group=_Farsi_yeh}', "");
    Expect(1, 1911, '\P{Joining_Group=_Farsi_yeh}', "");
    Expect(0, 1911, '\P{^Joining_Group=_Farsi_yeh}', "");
    Error('\p{Jg=	:=farsi_yeh}');
    Error('\P{Jg=	:=farsi_yeh}');
    Expect(1, 1910, '\p{Jg=farsiyeh}', "");
    Expect(0, 1910, '\p{^Jg=farsiyeh}', "");
    Expect(0, 1910, '\P{Jg=farsiyeh}', "");
    Expect(1, 1910, '\P{^Jg=farsiyeh}', "");
    Expect(0, 1911, '\p{Jg=farsiyeh}', "");
    Expect(1, 1911, '\p{^Jg=farsiyeh}', "");
    Expect(1, 1911, '\P{Jg=farsiyeh}', "");
    Expect(0, 1911, '\P{^Jg=farsiyeh}', "");
    Expect(1, 1910, '\p{Jg= 	Farsi_yeh}', "");
    Expect(0, 1910, '\p{^Jg= 	Farsi_yeh}', "");
    Expect(0, 1910, '\P{Jg= 	Farsi_yeh}', "");
    Expect(1, 1910, '\P{^Jg= 	Farsi_yeh}', "");
    Expect(0, 1911, '\p{Jg= 	Farsi_yeh}', "");
    Expect(1, 1911, '\p{^Jg= 	Farsi_yeh}', "");
    Expect(1, 1911, '\P{Jg= 	Farsi_yeh}', "");
    Expect(0, 1911, '\P{^Jg= 	Farsi_yeh}', "");
    Error('\p{Is_Joining_Group=_-farsi_Yeh/a/}');
    Error('\P{Is_Joining_Group=_-farsi_Yeh/a/}');
    Expect(1, 1910, '\p{Is_Joining_Group=farsiyeh}', "");
    Expect(0, 1910, '\p{^Is_Joining_Group=farsiyeh}', "");
    Expect(0, 1910, '\P{Is_Joining_Group=farsiyeh}', "");
    Expect(1, 1910, '\P{^Is_Joining_Group=farsiyeh}', "");
    Expect(0, 1911, '\p{Is_Joining_Group=farsiyeh}', "");
    Expect(1, 1911, '\p{^Is_Joining_Group=farsiyeh}', "");
    Expect(1, 1911, '\P{Is_Joining_Group=farsiyeh}', "");
    Expect(0, 1911, '\P{^Is_Joining_Group=farsiyeh}', "");
    Expect(1, 1910, '\p{Is_Joining_Group:  Farsi_YEH}', "");
    Expect(0, 1910, '\p{^Is_Joining_Group:  Farsi_YEH}', "");
    Expect(0, 1910, '\P{Is_Joining_Group:  Farsi_YEH}', "");
    Expect(1, 1910, '\P{^Is_Joining_Group:  Farsi_YEH}', "");
    Expect(0, 1911, '\p{Is_Joining_Group:  Farsi_YEH}', "");
    Expect(1, 1911, '\p{^Is_Joining_Group:  Farsi_YEH}', "");
    Expect(1, 1911, '\P{Is_Joining_Group:  Farsi_YEH}', "");
    Expect(0, 1911, '\P{^Is_Joining_Group:  Farsi_YEH}', "");
    Error('\p{Is_Jg=	/a/Farsi_Yeh}');
    Error('\P{Is_Jg=	/a/Farsi_Yeh}');
    Expect(1, 1910, '\p{Is_Jg=farsiyeh}', "");
    Expect(0, 1910, '\p{^Is_Jg=farsiyeh}', "");
    Expect(0, 1910, '\P{Is_Jg=farsiyeh}', "");
    Expect(1, 1910, '\P{^Is_Jg=farsiyeh}', "");
    Expect(0, 1911, '\p{Is_Jg=farsiyeh}', "");
    Expect(1, 1911, '\p{^Is_Jg=farsiyeh}', "");
    Expect(1, 1911, '\P{Is_Jg=farsiyeh}', "");
    Expect(0, 1911, '\P{^Is_Jg=farsiyeh}', "");
    Expect(1, 1910, '\p{Is_Jg=-_Farsi_Yeh}', "");
    Expect(0, 1910, '\p{^Is_Jg=-_Farsi_Yeh}', "");
    Expect(0, 1910, '\P{Is_Jg=-_Farsi_Yeh}', "");
    Expect(1, 1910, '\P{^Is_Jg=-_Farsi_Yeh}', "");
    Expect(0, 1911, '\p{Is_Jg=-_Farsi_Yeh}', "");
    Expect(1, 1911, '\p{^Is_Jg=-_Farsi_Yeh}', "");
    Expect(1, 1911, '\P{Is_Jg=-_Farsi_Yeh}', "");
    Expect(0, 1911, '\P{^Is_Jg=-_Farsi_Yeh}', "");
    Error('\p{Joining_Group=_:=Fe}');
    Error('\P{Joining_Group=_:=Fe}');
    Expect(1, 1871, '\p{Joining_Group=fe}', "");
    Expect(0, 1871, '\p{^Joining_Group=fe}', "");
    Expect(0, 1871, '\P{Joining_Group=fe}', "");
    Expect(1, 1871, '\P{^Joining_Group=fe}', "");
    Expect(0, 1872, '\p{Joining_Group=fe}', "");
    Expect(1, 1872, '\p{^Joining_Group=fe}', "");
    Expect(1, 1872, '\P{Joining_Group=fe}', "");
    Expect(0, 1872, '\P{^Joining_Group=fe}', "");
    Expect(1, 1871, '\p{Joining_Group=  Fe}', "");
    Expect(0, 1871, '\p{^Joining_Group=  Fe}', "");
    Expect(0, 1871, '\P{Joining_Group=  Fe}', "");
    Expect(1, 1871, '\P{^Joining_Group=  Fe}', "");
    Expect(0, 1872, '\p{Joining_Group=  Fe}', "");
    Expect(1, 1872, '\p{^Joining_Group=  Fe}', "");
    Expect(1, 1872, '\P{Joining_Group=  Fe}', "");
    Expect(0, 1872, '\P{^Joining_Group=  Fe}', "");
    Error('\p{Jg=	:=FE}');
    Error('\P{Jg=	:=FE}');
    Expect(1, 1871, '\p{Jg=fe}', "");
    Expect(0, 1871, '\p{^Jg=fe}', "");
    Expect(0, 1871, '\P{Jg=fe}', "");
    Expect(1, 1871, '\P{^Jg=fe}', "");
    Expect(0, 1872, '\p{Jg=fe}', "");
    Expect(1, 1872, '\p{^Jg=fe}', "");
    Expect(1, 1872, '\P{Jg=fe}', "");
    Expect(0, 1872, '\P{^Jg=fe}', "");
    Expect(1, 1871, '\p{Jg:	-FE}', "");
    Expect(0, 1871, '\p{^Jg:	-FE}', "");
    Expect(0, 1871, '\P{Jg:	-FE}', "");
    Expect(1, 1871, '\P{^Jg:	-FE}', "");
    Expect(0, 1872, '\p{Jg:	-FE}', "");
    Expect(1, 1872, '\p{^Jg:	-FE}', "");
    Expect(1, 1872, '\P{Jg:	-FE}', "");
    Expect(0, 1872, '\P{^Jg:	-FE}', "");
    Error('\p{Is_Joining_Group=/a/--fe}');
    Error('\P{Is_Joining_Group=/a/--fe}');
    Expect(1, 1871, '\p{Is_Joining_Group=fe}', "");
    Expect(0, 1871, '\p{^Is_Joining_Group=fe}', "");
    Expect(0, 1871, '\P{Is_Joining_Group=fe}', "");
    Expect(1, 1871, '\P{^Is_Joining_Group=fe}', "");
    Expect(0, 1872, '\p{Is_Joining_Group=fe}', "");
    Expect(1, 1872, '\p{^Is_Joining_Group=fe}', "");
    Expect(1, 1872, '\P{Is_Joining_Group=fe}', "");
    Expect(0, 1872, '\P{^Is_Joining_Group=fe}', "");
    Expect(1, 1871, '\p{Is_Joining_Group=	Fe}', "");
    Expect(0, 1871, '\p{^Is_Joining_Group=	Fe}', "");
    Expect(0, 1871, '\P{Is_Joining_Group=	Fe}', "");
    Expect(1, 1871, '\P{^Is_Joining_Group=	Fe}', "");
    Expect(0, 1872, '\p{Is_Joining_Group=	Fe}', "");
    Expect(1, 1872, '\p{^Is_Joining_Group=	Fe}', "");
    Expect(1, 1872, '\P{Is_Joining_Group=	Fe}', "");
    Expect(0, 1872, '\P{^Is_Joining_Group=	Fe}', "");
    Error('\p{Is_Jg=_Fe/a/}');
    Error('\P{Is_Jg=_Fe/a/}');
    Expect(1, 1871, '\p{Is_Jg=fe}', "");
    Expect(0, 1871, '\p{^Is_Jg=fe}', "");
    Expect(0, 1871, '\P{Is_Jg=fe}', "");
    Expect(1, 1871, '\P{^Is_Jg=fe}', "");
    Expect(0, 1872, '\p{Is_Jg=fe}', "");
    Expect(1, 1872, '\p{^Is_Jg=fe}', "");
    Expect(1, 1872, '\P{Is_Jg=fe}', "");
    Expect(0, 1872, '\P{^Is_Jg=fe}', "");
    Expect(1, 1871, '\p{Is_Jg=_fe}', "");
    Expect(0, 1871, '\p{^Is_Jg=_fe}', "");
    Expect(0, 1871, '\P{Is_Jg=_fe}', "");
    Expect(1, 1871, '\P{^Is_Jg=_fe}', "");
    Expect(0, 1872, '\p{Is_Jg=_fe}', "");
    Expect(1, 1872, '\p{^Is_Jg=_fe}', "");
    Expect(1, 1872, '\P{Is_Jg=_fe}', "");
    Expect(0, 1872, '\P{^Is_Jg=_fe}', "");
    Error('\p{Joining_Group:	:= FEH}');
    Error('\P{Joining_Group:	:= FEH}');
    Expect(1, 2212, '\p{Joining_Group=feh}', "");
    Expect(0, 2212, '\p{^Joining_Group=feh}', "");
    Expect(0, 2212, '\P{Joining_Group=feh}', "");
    Expect(1, 2212, '\P{^Joining_Group=feh}', "");
    Expect(0, 2213, '\p{Joining_Group=feh}', "");
    Expect(1, 2213, '\p{^Joining_Group=feh}', "");
    Expect(1, 2213, '\P{Joining_Group=feh}', "");
    Expect(0, 2213, '\P{^Joining_Group=feh}', "");
    Expect(1, 2212, '\p{Joining_Group=		feh}', "");
    Expect(0, 2212, '\p{^Joining_Group=		feh}', "");
    Expect(0, 2212, '\P{Joining_Group=		feh}', "");
    Expect(1, 2212, '\P{^Joining_Group=		feh}', "");
    Expect(0, 2213, '\p{Joining_Group=		feh}', "");
    Expect(1, 2213, '\p{^Joining_Group=		feh}', "");
    Expect(1, 2213, '\P{Joining_Group=		feh}', "");
    Expect(0, 2213, '\P{^Joining_Group=		feh}', "");
    Error('\p{Jg=/a/ 	FEH}');
    Error('\P{Jg=/a/ 	FEH}');
    Expect(1, 2212, '\p{Jg=feh}', "");
    Expect(0, 2212, '\p{^Jg=feh}', "");
    Expect(0, 2212, '\P{Jg=feh}', "");
    Expect(1, 2212, '\P{^Jg=feh}', "");
    Expect(0, 2213, '\p{Jg=feh}', "");
    Expect(1, 2213, '\p{^Jg=feh}', "");
    Expect(1, 2213, '\P{Jg=feh}', "");
    Expect(0, 2213, '\P{^Jg=feh}', "");
    Expect(1, 2212, '\p{Jg=	-feh}', "");
    Expect(0, 2212, '\p{^Jg=	-feh}', "");
    Expect(0, 2212, '\P{Jg=	-feh}', "");
    Expect(1, 2212, '\P{^Jg=	-feh}', "");
    Expect(0, 2213, '\p{Jg=	-feh}', "");
    Expect(1, 2213, '\p{^Jg=	-feh}', "");
    Expect(1, 2213, '\P{Jg=	-feh}', "");
    Expect(0, 2213, '\P{^Jg=	-feh}', "");
    Error('\p{Is_Joining_Group=_	Feh:=}');
    Error('\P{Is_Joining_Group=_	Feh:=}');
    Expect(1, 2212, '\p{Is_Joining_Group:   feh}', "");
    Expect(0, 2212, '\p{^Is_Joining_Group:   feh}', "");
    Expect(0, 2212, '\P{Is_Joining_Group:   feh}', "");
    Expect(1, 2212, '\P{^Is_Joining_Group:   feh}', "");
    Expect(0, 2213, '\p{Is_Joining_Group:   feh}', "");
    Expect(1, 2213, '\p{^Is_Joining_Group:   feh}', "");
    Expect(1, 2213, '\P{Is_Joining_Group:   feh}', "");
    Expect(0, 2213, '\P{^Is_Joining_Group:   feh}', "");
    Expect(1, 2212, '\p{Is_Joining_Group=	 Feh}', "");
    Expect(0, 2212, '\p{^Is_Joining_Group=	 Feh}', "");
    Expect(0, 2212, '\P{Is_Joining_Group=	 Feh}', "");
    Expect(1, 2212, '\P{^Is_Joining_Group=	 Feh}', "");
    Expect(0, 2213, '\p{Is_Joining_Group=	 Feh}', "");
    Expect(1, 2213, '\p{^Is_Joining_Group=	 Feh}', "");
    Expect(1, 2213, '\P{Is_Joining_Group=	 Feh}', "");
    Expect(0, 2213, '\P{^Is_Joining_Group=	 Feh}', "");
    Error('\p{Is_Jg=/a/__Feh}');
    Error('\P{Is_Jg=/a/__Feh}');
    Expect(1, 2212, '\p{Is_Jg:feh}', "");
    Expect(0, 2212, '\p{^Is_Jg:feh}', "");
    Expect(0, 2212, '\P{Is_Jg:feh}', "");
    Expect(1, 2212, '\P{^Is_Jg:feh}', "");
    Expect(0, 2213, '\p{Is_Jg:feh}', "");
    Expect(1, 2213, '\p{^Is_Jg:feh}', "");
    Expect(1, 2213, '\P{Is_Jg:feh}', "");
    Expect(0, 2213, '\P{^Is_Jg:feh}', "");
    Expect(1, 2212, '\p{Is_Jg:	-FEH}', "");
    Expect(0, 2212, '\p{^Is_Jg:	-FEH}', "");
    Expect(0, 2212, '\P{Is_Jg:	-FEH}', "");
    Expect(1, 2212, '\P{^Is_Jg:	-FEH}', "");
    Expect(0, 2213, '\p{Is_Jg:	-FEH}', "");
    Expect(1, 2213, '\p{^Is_Jg:	-FEH}', "");
    Expect(1, 2213, '\P{Is_Jg:	-FEH}', "");
    Expect(0, 2213, '\P{^Is_Jg:	-FEH}', "");
    Error('\p{Joining_Group=/a/ -FINAL_SEMKATH}');
    Error('\P{Joining_Group=/a/ -FINAL_SEMKATH}');
    Expect(1, 1828, '\p{Joining_Group=finalsemkath}', "");
    Expect(0, 1828, '\p{^Joining_Group=finalsemkath}', "");
    Expect(0, 1828, '\P{Joining_Group=finalsemkath}', "");
    Expect(1, 1828, '\P{^Joining_Group=finalsemkath}', "");
    Expect(0, 1829, '\p{Joining_Group=finalsemkath}', "");
    Expect(1, 1829, '\p{^Joining_Group=finalsemkath}', "");
    Expect(1, 1829, '\P{Joining_Group=finalsemkath}', "");
    Expect(0, 1829, '\P{^Joining_Group=finalsemkath}', "");
    Expect(1, 1828, '\p{Joining_Group=final_Semkath}', "");
    Expect(0, 1828, '\p{^Joining_Group=final_Semkath}', "");
    Expect(0, 1828, '\P{Joining_Group=final_Semkath}', "");
    Expect(1, 1828, '\P{^Joining_Group=final_Semkath}', "");
    Expect(0, 1829, '\p{Joining_Group=final_Semkath}', "");
    Expect(1, 1829, '\p{^Joining_Group=final_Semkath}', "");
    Expect(1, 1829, '\P{Joining_Group=final_Semkath}', "");
    Expect(0, 1829, '\P{^Joining_Group=final_Semkath}', "");
    Error('\p{Jg=_FINAL_Semkath/a/}');
    Error('\P{Jg=_FINAL_Semkath/a/}');
    Expect(1, 1828, '\p{Jg=finalsemkath}', "");
    Expect(0, 1828, '\p{^Jg=finalsemkath}', "");
    Expect(0, 1828, '\P{Jg=finalsemkath}', "");
    Expect(1, 1828, '\P{^Jg=finalsemkath}', "");
    Expect(0, 1829, '\p{Jg=finalsemkath}', "");
    Expect(1, 1829, '\p{^Jg=finalsemkath}', "");
    Expect(1, 1829, '\P{Jg=finalsemkath}', "");
    Expect(0, 1829, '\P{^Jg=finalsemkath}', "");
    Expect(1, 1828, '\p{Jg=	Final_SEMKATH}', "");
    Expect(0, 1828, '\p{^Jg=	Final_SEMKATH}', "");
    Expect(0, 1828, '\P{Jg=	Final_SEMKATH}', "");
    Expect(1, 1828, '\P{^Jg=	Final_SEMKATH}', "");
    Expect(0, 1829, '\p{Jg=	Final_SEMKATH}', "");
    Expect(1, 1829, '\p{^Jg=	Final_SEMKATH}', "");
    Expect(1, 1829, '\P{Jg=	Final_SEMKATH}', "");
    Expect(0, 1829, '\P{^Jg=	Final_SEMKATH}', "");
    Error('\p{Is_Joining_Group= 	Final_Semkath:=}');
    Error('\P{Is_Joining_Group= 	Final_Semkath:=}');
    Expect(1, 1828, '\p{Is_Joining_Group=finalsemkath}', "");
    Expect(0, 1828, '\p{^Is_Joining_Group=finalsemkath}', "");
    Expect(0, 1828, '\P{Is_Joining_Group=finalsemkath}', "");
    Expect(1, 1828, '\P{^Is_Joining_Group=finalsemkath}', "");
    Expect(0, 1829, '\p{Is_Joining_Group=finalsemkath}', "");
    Expect(1, 1829, '\p{^Is_Joining_Group=finalsemkath}', "");
    Expect(1, 1829, '\P{Is_Joining_Group=finalsemkath}', "");
    Expect(0, 1829, '\P{^Is_Joining_Group=finalsemkath}', "");
    Expect(1, 1828, '\p{Is_Joining_Group=	final_SEMKATH}', "");
    Expect(0, 1828, '\p{^Is_Joining_Group=	final_SEMKATH}', "");
    Expect(0, 1828, '\P{Is_Joining_Group=	final_SEMKATH}', "");
    Expect(1, 1828, '\P{^Is_Joining_Group=	final_SEMKATH}', "");
    Expect(0, 1829, '\p{Is_Joining_Group=	final_SEMKATH}', "");
    Expect(1, 1829, '\p{^Is_Joining_Group=	final_SEMKATH}', "");
    Expect(1, 1829, '\P{Is_Joining_Group=	final_SEMKATH}', "");
    Expect(0, 1829, '\P{^Is_Joining_Group=	final_SEMKATH}', "");
    Error('\p{Is_Jg=/a/-Final_semkath}');
    Error('\P{Is_Jg=/a/-Final_semkath}');
    Expect(1, 1828, '\p{Is_Jg=finalsemkath}', "");
    Expect(0, 1828, '\p{^Is_Jg=finalsemkath}', "");
    Expect(0, 1828, '\P{Is_Jg=finalsemkath}', "");
    Expect(1, 1828, '\P{^Is_Jg=finalsemkath}', "");
    Expect(0, 1829, '\p{Is_Jg=finalsemkath}', "");
    Expect(1, 1829, '\p{^Is_Jg=finalsemkath}', "");
    Expect(1, 1829, '\P{Is_Jg=finalsemkath}', "");
    Expect(0, 1829, '\P{^Is_Jg=finalsemkath}', "");
    Expect(1, 1828, '\p{Is_Jg=__Final_SEMKATH}', "");
    Expect(0, 1828, '\p{^Is_Jg=__Final_SEMKATH}', "");
    Expect(0, 1828, '\P{Is_Jg=__Final_SEMKATH}', "");
    Expect(1, 1828, '\P{^Is_Jg=__Final_SEMKATH}', "");
    Expect(0, 1829, '\p{Is_Jg=__Final_SEMKATH}', "");
    Expect(1, 1829, '\p{^Is_Jg=__Final_SEMKATH}', "");
    Expect(1, 1829, '\P{Is_Jg=__Final_SEMKATH}', "");
    Expect(0, 1829, '\P{^Is_Jg=__Final_SEMKATH}', "");
    Error('\p{Joining_Group= 	GAF/a/}');
    Error('\P{Joining_Group= 	GAF/a/}');
    Expect(1, 2224, '\p{Joining_Group=gaf}', "");
    Expect(0, 2224, '\p{^Joining_Group=gaf}', "");
    Expect(0, 2224, '\P{Joining_Group=gaf}', "");
    Expect(1, 2224, '\P{^Joining_Group=gaf}', "");
    Expect(0, 2225, '\p{Joining_Group=gaf}', "");
    Expect(1, 2225, '\p{^Joining_Group=gaf}', "");
    Expect(1, 2225, '\P{Joining_Group=gaf}', "");
    Expect(0, 2225, '\P{^Joining_Group=gaf}', "");
    Expect(1, 2224, '\p{Joining_Group=-	GAF}', "");
    Expect(0, 2224, '\p{^Joining_Group=-	GAF}', "");
    Expect(0, 2224, '\P{Joining_Group=-	GAF}', "");
    Expect(1, 2224, '\P{^Joining_Group=-	GAF}', "");
    Expect(0, 2225, '\p{Joining_Group=-	GAF}', "");
    Expect(1, 2225, '\p{^Joining_Group=-	GAF}', "");
    Expect(1, 2225, '\P{Joining_Group=-	GAF}', "");
    Expect(0, 2225, '\P{^Joining_Group=-	GAF}', "");
    Error('\p{Jg=:=_ Gaf}');
    Error('\P{Jg=:=_ Gaf}');
    Expect(1, 2224, '\p{Jg=gaf}', "");
    Expect(0, 2224, '\p{^Jg=gaf}', "");
    Expect(0, 2224, '\P{Jg=gaf}', "");
    Expect(1, 2224, '\P{^Jg=gaf}', "");
    Expect(0, 2225, '\p{Jg=gaf}', "");
    Expect(1, 2225, '\p{^Jg=gaf}', "");
    Expect(1, 2225, '\P{Jg=gaf}', "");
    Expect(0, 2225, '\P{^Jg=gaf}', "");
    Expect(1, 2224, '\p{Jg=_-Gaf}', "");
    Expect(0, 2224, '\p{^Jg=_-Gaf}', "");
    Expect(0, 2224, '\P{Jg=_-Gaf}', "");
    Expect(1, 2224, '\P{^Jg=_-Gaf}', "");
    Expect(0, 2225, '\p{Jg=_-Gaf}', "");
    Expect(1, 2225, '\p{^Jg=_-Gaf}', "");
    Expect(1, 2225, '\P{Jg=_-Gaf}', "");
    Expect(0, 2225, '\P{^Jg=_-Gaf}', "");
    Error('\p{Is_Joining_Group=:=GAF}');
    Error('\P{Is_Joining_Group=:=GAF}');
    Expect(1, 2224, '\p{Is_Joining_Group=gaf}', "");
    Expect(0, 2224, '\p{^Is_Joining_Group=gaf}', "");
    Expect(0, 2224, '\P{Is_Joining_Group=gaf}', "");
    Expect(1, 2224, '\P{^Is_Joining_Group=gaf}', "");
    Expect(0, 2225, '\p{Is_Joining_Group=gaf}', "");
    Expect(1, 2225, '\p{^Is_Joining_Group=gaf}', "");
    Expect(1, 2225, '\P{Is_Joining_Group=gaf}', "");
    Expect(0, 2225, '\P{^Is_Joining_Group=gaf}', "");
    Expect(1, 2224, '\p{Is_Joining_Group=-Gaf}', "");
    Expect(0, 2224, '\p{^Is_Joining_Group=-Gaf}', "");
    Expect(0, 2224, '\P{Is_Joining_Group=-Gaf}', "");
    Expect(1, 2224, '\P{^Is_Joining_Group=-Gaf}', "");
    Expect(0, 2225, '\p{Is_Joining_Group=-Gaf}', "");
    Expect(1, 2225, '\p{^Is_Joining_Group=-Gaf}', "");
    Expect(1, 2225, '\P{Is_Joining_Group=-Gaf}', "");
    Expect(0, 2225, '\P{^Is_Joining_Group=-Gaf}', "");
    Error('\p{Is_Jg=:=_ GAF}');
    Error('\P{Is_Jg=:=_ GAF}');
    Expect(1, 2224, '\p{Is_Jg=gaf}', "");
    Expect(0, 2224, '\p{^Is_Jg=gaf}', "");
    Expect(0, 2224, '\P{Is_Jg=gaf}', "");
    Expect(1, 2224, '\P{^Is_Jg=gaf}', "");
    Expect(0, 2225, '\p{Is_Jg=gaf}', "");
    Expect(1, 2225, '\p{^Is_Jg=gaf}', "");
    Expect(1, 2225, '\P{Is_Jg=gaf}', "");
    Expect(0, 2225, '\P{^Is_Jg=gaf}', "");
    Expect(1, 2224, '\p{Is_Jg:    	Gaf}', "");
    Expect(0, 2224, '\p{^Is_Jg:    	Gaf}', "");
    Expect(0, 2224, '\P{Is_Jg:    	Gaf}', "");
    Expect(1, 2224, '\P{^Is_Jg:    	Gaf}', "");
    Expect(0, 2225, '\p{Is_Jg:    	Gaf}', "");
    Expect(1, 2225, '\p{^Is_Jg:    	Gaf}', "");
    Expect(1, 2225, '\P{Is_Jg:    	Gaf}', "");
    Expect(0, 2225, '\P{^Is_Jg:    	Gaf}', "");
    Error('\p{Joining_Group= gamal/a/}');
    Error('\P{Joining_Group= gamal/a/}');
    Expect(1, 1838, '\p{Joining_Group=gamal}', "");
    Expect(0, 1838, '\p{^Joining_Group=gamal}', "");
    Expect(0, 1838, '\P{Joining_Group=gamal}', "");
    Expect(1, 1838, '\P{^Joining_Group=gamal}', "");
    Expect(0, 1839, '\p{Joining_Group=gamal}', "");
    Expect(1, 1839, '\p{^Joining_Group=gamal}', "");
    Expect(1, 1839, '\P{Joining_Group=gamal}', "");
    Expect(0, 1839, '\P{^Joining_Group=gamal}', "");
    Expect(1, 1838, '\p{Joining_Group=GAMAL}', "");
    Expect(0, 1838, '\p{^Joining_Group=GAMAL}', "");
    Expect(0, 1838, '\P{Joining_Group=GAMAL}', "");
    Expect(1, 1838, '\P{^Joining_Group=GAMAL}', "");
    Expect(0, 1839, '\p{Joining_Group=GAMAL}', "");
    Expect(1, 1839, '\p{^Joining_Group=GAMAL}', "");
    Expect(1, 1839, '\P{Joining_Group=GAMAL}', "");
    Expect(0, 1839, '\P{^Joining_Group=GAMAL}', "");
    Error('\p{Jg=-/a/Gamal}');
    Error('\P{Jg=-/a/Gamal}');
    Expect(1, 1838, '\p{Jg=gamal}', "");
    Expect(0, 1838, '\p{^Jg=gamal}', "");
    Expect(0, 1838, '\P{Jg=gamal}', "");
    Expect(1, 1838, '\P{^Jg=gamal}', "");
    Expect(0, 1839, '\p{Jg=gamal}', "");
    Expect(1, 1839, '\p{^Jg=gamal}', "");
    Expect(1, 1839, '\P{Jg=gamal}', "");
    Expect(0, 1839, '\P{^Jg=gamal}', "");
    Expect(1, 1838, '\p{Jg=-Gamal}', "");
    Expect(0, 1838, '\p{^Jg=-Gamal}', "");
    Expect(0, 1838, '\P{Jg=-Gamal}', "");
    Expect(1, 1838, '\P{^Jg=-Gamal}', "");
    Expect(0, 1839, '\p{Jg=-Gamal}', "");
    Expect(1, 1839, '\p{^Jg=-Gamal}', "");
    Expect(1, 1839, '\P{Jg=-Gamal}', "");
    Expect(0, 1839, '\P{^Jg=-Gamal}', "");
    Error('\p{Is_Joining_Group=:=--Gamal}');
    Error('\P{Is_Joining_Group=:=--Gamal}');
    Expect(1, 1838, '\p{Is_Joining_Group=gamal}', "");
    Expect(0, 1838, '\p{^Is_Joining_Group=gamal}', "");
    Expect(0, 1838, '\P{Is_Joining_Group=gamal}', "");
    Expect(1, 1838, '\P{^Is_Joining_Group=gamal}', "");
    Expect(0, 1839, '\p{Is_Joining_Group=gamal}', "");
    Expect(1, 1839, '\p{^Is_Joining_Group=gamal}', "");
    Expect(1, 1839, '\P{Is_Joining_Group=gamal}', "");
    Expect(0, 1839, '\P{^Is_Joining_Group=gamal}', "");
    Expect(1, 1838, '\p{Is_Joining_Group=	gamal}', "");
    Expect(0, 1838, '\p{^Is_Joining_Group=	gamal}', "");
    Expect(0, 1838, '\P{Is_Joining_Group=	gamal}', "");
    Expect(1, 1838, '\P{^Is_Joining_Group=	gamal}', "");
    Expect(0, 1839, '\p{Is_Joining_Group=	gamal}', "");
    Expect(1, 1839, '\p{^Is_Joining_Group=	gamal}', "");
    Expect(1, 1839, '\P{Is_Joining_Group=	gamal}', "");
    Expect(0, 1839, '\P{^Is_Joining_Group=	gamal}', "");
    Error('\p{Is_Jg=--GAMAL/a/}');
    Error('\P{Is_Jg=--GAMAL/a/}');
    Expect(1, 1838, '\p{Is_Jg=gamal}', "");
    Expect(0, 1838, '\p{^Is_Jg=gamal}', "");
    Expect(0, 1838, '\P{Is_Jg=gamal}', "");
    Expect(1, 1838, '\P{^Is_Jg=gamal}', "");
    Expect(0, 1839, '\p{Is_Jg=gamal}', "");
    Expect(1, 1839, '\p{^Is_Jg=gamal}', "");
    Expect(1, 1839, '\P{Is_Jg=gamal}', "");
    Expect(0, 1839, '\P{^Is_Jg=gamal}', "");
    Expect(1, 1838, '\p{Is_Jg=	-Gamal}', "");
    Expect(0, 1838, '\p{^Is_Jg=	-Gamal}', "");
    Expect(0, 1838, '\P{Is_Jg=	-Gamal}', "");
    Expect(1, 1838, '\P{^Is_Jg=	-Gamal}', "");
    Expect(0, 1839, '\p{Is_Jg=	-Gamal}', "");
    Expect(1, 1839, '\p{^Is_Jg=	-Gamal}', "");
    Expect(1, 1839, '\P{Is_Jg=	-Gamal}', "");
    Expect(0, 1839, '\P{^Is_Jg=	-Gamal}', "");
    Error('\p{Joining_Group=	/a/Hah}');
    Error('\P{Joining_Group=	/a/Hah}');
    Expect(1, 2210, '\p{Joining_Group=hah}', "");
    Expect(0, 2210, '\p{^Joining_Group=hah}', "");
    Expect(0, 2210, '\P{Joining_Group=hah}', "");
    Expect(1, 2210, '\P{^Joining_Group=hah}', "");
    Expect(0, 2211, '\p{Joining_Group=hah}', "");
    Expect(1, 2211, '\p{^Joining_Group=hah}', "");
    Expect(1, 2211, '\P{Joining_Group=hah}', "");
    Expect(0, 2211, '\P{^Joining_Group=hah}', "");
    Expect(1, 2210, '\p{Joining_Group=- HAH}', "");
    Expect(0, 2210, '\p{^Joining_Group=- HAH}', "");
    Expect(0, 2210, '\P{Joining_Group=- HAH}', "");
    Expect(1, 2210, '\P{^Joining_Group=- HAH}', "");
    Expect(0, 2211, '\p{Joining_Group=- HAH}', "");
    Expect(1, 2211, '\p{^Joining_Group=- HAH}', "");
    Expect(1, 2211, '\P{Joining_Group=- HAH}', "");
    Expect(0, 2211, '\P{^Joining_Group=- HAH}', "");
    Error('\p{Jg= -Hah/a/}');
    Error('\P{Jg= -Hah/a/}');
    Expect(1, 2210, '\p{Jg=hah}', "");
    Expect(0, 2210, '\p{^Jg=hah}', "");
    Expect(0, 2210, '\P{Jg=hah}', "");
    Expect(1, 2210, '\P{^Jg=hah}', "");
    Expect(0, 2211, '\p{Jg=hah}', "");
    Expect(1, 2211, '\p{^Jg=hah}', "");
    Expect(1, 2211, '\P{Jg=hah}', "");
    Expect(0, 2211, '\P{^Jg=hah}', "");
    Expect(1, 2210, '\p{Jg=- HAH}', "");
    Expect(0, 2210, '\p{^Jg=- HAH}', "");
    Expect(0, 2210, '\P{Jg=- HAH}', "");
    Expect(1, 2210, '\P{^Jg=- HAH}', "");
    Expect(0, 2211, '\p{Jg=- HAH}', "");
    Expect(1, 2211, '\p{^Jg=- HAH}', "");
    Expect(1, 2211, '\P{Jg=- HAH}', "");
    Expect(0, 2211, '\P{^Jg=- HAH}', "");
    Error('\p{Is_Joining_Group=_:=hah}');
    Error('\P{Is_Joining_Group=_:=hah}');
    Expect(1, 2210, '\p{Is_Joining_Group=hah}', "");
    Expect(0, 2210, '\p{^Is_Joining_Group=hah}', "");
    Expect(0, 2210, '\P{Is_Joining_Group=hah}', "");
    Expect(1, 2210, '\P{^Is_Joining_Group=hah}', "");
    Expect(0, 2211, '\p{Is_Joining_Group=hah}', "");
    Expect(1, 2211, '\p{^Is_Joining_Group=hah}', "");
    Expect(1, 2211, '\P{Is_Joining_Group=hah}', "");
    Expect(0, 2211, '\P{^Is_Joining_Group=hah}', "");
    Expect(1, 2210, '\p{Is_Joining_Group=  Hah}', "");
    Expect(0, 2210, '\p{^Is_Joining_Group=  Hah}', "");
    Expect(0, 2210, '\P{Is_Joining_Group=  Hah}', "");
    Expect(1, 2210, '\P{^Is_Joining_Group=  Hah}', "");
    Expect(0, 2211, '\p{Is_Joining_Group=  Hah}', "");
    Expect(1, 2211, '\p{^Is_Joining_Group=  Hah}', "");
    Expect(1, 2211, '\P{Is_Joining_Group=  Hah}', "");
    Expect(0, 2211, '\P{^Is_Joining_Group=  Hah}', "");
    Error('\p{Is_Jg:    :=Hah}');
    Error('\P{Is_Jg:    :=Hah}');
    Expect(1, 2210, '\p{Is_Jg=hah}', "");
    Expect(0, 2210, '\p{^Is_Jg=hah}', "");
    Expect(0, 2210, '\P{Is_Jg=hah}', "");
    Expect(1, 2210, '\P{^Is_Jg=hah}', "");
    Expect(0, 2211, '\p{Is_Jg=hah}', "");
    Expect(1, 2211, '\p{^Is_Jg=hah}', "");
    Expect(1, 2211, '\P{Is_Jg=hah}', "");
    Expect(0, 2211, '\P{^Is_Jg=hah}', "");
    Expect(1, 2210, '\p{Is_Jg=- Hah}', "");
    Expect(0, 2210, '\p{^Is_Jg=- Hah}', "");
    Expect(0, 2210, '\P{Is_Jg=- Hah}', "");
    Expect(1, 2210, '\P{^Is_Jg=- Hah}', "");
    Expect(0, 2211, '\p{Is_Jg=- Hah}', "");
    Expect(1, 2211, '\p{^Is_Jg=- Hah}', "");
    Expect(1, 2211, '\P{Is_Jg=- Hah}', "");
    Expect(0, 2211, '\P{^Is_Jg=- Hah}', "");
    Error('\p{Joining_Group=:= _He}');
    Error('\P{Joining_Group=:= _He}');
    Expect(1, 1815, '\p{Joining_Group=he}', "");
    Expect(0, 1815, '\p{^Joining_Group=he}', "");
    Expect(0, 1815, '\P{Joining_Group=he}', "");
    Expect(1, 1815, '\P{^Joining_Group=he}', "");
    Expect(0, 1816, '\p{Joining_Group=he}', "");
    Expect(1, 1816, '\p{^Joining_Group=he}', "");
    Expect(1, 1816, '\P{Joining_Group=he}', "");
    Expect(0, 1816, '\P{^Joining_Group=he}', "");
    Expect(1, 1815, '\p{Joining_Group=_-HE}', "");
    Expect(0, 1815, '\p{^Joining_Group=_-HE}', "");
    Expect(0, 1815, '\P{Joining_Group=_-HE}', "");
    Expect(1, 1815, '\P{^Joining_Group=_-HE}', "");
    Expect(0, 1816, '\p{Joining_Group=_-HE}', "");
    Expect(1, 1816, '\p{^Joining_Group=_-HE}', "");
    Expect(1, 1816, '\P{Joining_Group=_-HE}', "");
    Expect(0, 1816, '\P{^Joining_Group=_-HE}', "");
    Error('\p{Jg=:=_He}');
    Error('\P{Jg=:=_He}');
    Expect(1, 1815, '\p{Jg=he}', "");
    Expect(0, 1815, '\p{^Jg=he}', "");
    Expect(0, 1815, '\P{Jg=he}', "");
    Expect(1, 1815, '\P{^Jg=he}', "");
    Expect(0, 1816, '\p{Jg=he}', "");
    Expect(1, 1816, '\p{^Jg=he}', "");
    Expect(1, 1816, '\P{Jg=he}', "");
    Expect(0, 1816, '\P{^Jg=he}', "");
    Expect(1, 1815, '\p{Jg=-_HE}', "");
    Expect(0, 1815, '\p{^Jg=-_HE}', "");
    Expect(0, 1815, '\P{Jg=-_HE}', "");
    Expect(1, 1815, '\P{^Jg=-_HE}', "");
    Expect(0, 1816, '\p{Jg=-_HE}', "");
    Expect(1, 1816, '\p{^Jg=-_HE}', "");
    Expect(1, 1816, '\P{Jg=-_HE}', "");
    Expect(0, 1816, '\P{^Jg=-_HE}', "");
    Error('\p{Is_Joining_Group::=		he}');
    Error('\P{Is_Joining_Group::=		he}');
    Expect(1, 1815, '\p{Is_Joining_Group=he}', "");
    Expect(0, 1815, '\p{^Is_Joining_Group=he}', "");
    Expect(0, 1815, '\P{Is_Joining_Group=he}', "");
    Expect(1, 1815, '\P{^Is_Joining_Group=he}', "");
    Expect(0, 1816, '\p{Is_Joining_Group=he}', "");
    Expect(1, 1816, '\p{^Is_Joining_Group=he}', "");
    Expect(1, 1816, '\P{Is_Joining_Group=he}', "");
    Expect(0, 1816, '\P{^Is_Joining_Group=he}', "");
    Expect(1, 1815, '\p{Is_Joining_Group= he}', "");
    Expect(0, 1815, '\p{^Is_Joining_Group= he}', "");
    Expect(0, 1815, '\P{Is_Joining_Group= he}', "");
    Expect(1, 1815, '\P{^Is_Joining_Group= he}', "");
    Expect(0, 1816, '\p{Is_Joining_Group= he}', "");
    Expect(1, 1816, '\p{^Is_Joining_Group= he}', "");
    Expect(1, 1816, '\P{Is_Joining_Group= he}', "");
    Expect(0, 1816, '\P{^Is_Joining_Group= he}', "");
    Error('\p{Is_Jg: _ HE/a/}');
    Error('\P{Is_Jg: _ HE/a/}');
    Expect(1, 1815, '\p{Is_Jg=he}', "");
    Expect(0, 1815, '\p{^Is_Jg=he}', "");
    Expect(0, 1815, '\P{Is_Jg=he}', "");
    Expect(1, 1815, '\P{^Is_Jg=he}', "");
    Expect(0, 1816, '\p{Is_Jg=he}', "");
    Expect(1, 1816, '\p{^Is_Jg=he}', "");
    Expect(1, 1816, '\P{Is_Jg=he}', "");
    Expect(0, 1816, '\P{^Is_Jg=he}', "");
    Expect(1, 1815, '\p{Is_Jg=	he}', "");
    Expect(0, 1815, '\p{^Is_Jg=	he}', "");
    Expect(0, 1815, '\P{Is_Jg=	he}', "");
    Expect(1, 1815, '\P{^Is_Jg=	he}', "");
    Expect(0, 1816, '\p{Is_Jg=	he}', "");
    Expect(1, 1816, '\p{^Is_Jg=	he}', "");
    Expect(1, 1816, '\P{Is_Jg=	he}', "");
    Expect(0, 1816, '\P{^Is_Jg=	he}', "");
    Error('\p{Joining_Group:   /a/heh}');
    Error('\P{Joining_Group:   /a/heh}');
    Expect(1, 1607, '\p{Joining_Group=heh}', "");
    Expect(0, 1607, '\p{^Joining_Group=heh}', "");
    Expect(0, 1607, '\P{Joining_Group=heh}', "");
    Expect(1, 1607, '\P{^Joining_Group=heh}', "");
    Expect(0, 1608, '\p{Joining_Group=heh}', "");
    Expect(1, 1608, '\p{^Joining_Group=heh}', "");
    Expect(1, 1608, '\P{Joining_Group=heh}', "");
    Expect(0, 1608, '\P{^Joining_Group=heh}', "");
    Expect(1, 1607, '\p{Joining_Group=Heh}', "");
    Expect(0, 1607, '\p{^Joining_Group=Heh}', "");
    Expect(0, 1607, '\P{Joining_Group=Heh}', "");
    Expect(1, 1607, '\P{^Joining_Group=Heh}', "");
    Expect(0, 1608, '\p{Joining_Group=Heh}', "");
    Expect(1, 1608, '\p{^Joining_Group=Heh}', "");
    Expect(1, 1608, '\P{Joining_Group=Heh}', "");
    Expect(0, 1608, '\P{^Joining_Group=Heh}', "");
    Error('\p{Jg=	HEH:=}');
    Error('\P{Jg=	HEH:=}');
    Expect(1, 1607, '\p{Jg=heh}', "");
    Expect(0, 1607, '\p{^Jg=heh}', "");
    Expect(0, 1607, '\P{Jg=heh}', "");
    Expect(1, 1607, '\P{^Jg=heh}', "");
    Expect(0, 1608, '\p{Jg=heh}', "");
    Expect(1, 1608, '\p{^Jg=heh}', "");
    Expect(1, 1608, '\P{Jg=heh}', "");
    Expect(0, 1608, '\P{^Jg=heh}', "");
    Expect(1, 1607, '\p{Jg= Heh}', "");
    Expect(0, 1607, '\p{^Jg= Heh}', "");
    Expect(0, 1607, '\P{Jg= Heh}', "");
    Expect(1, 1607, '\P{^Jg= Heh}', "");
    Expect(0, 1608, '\p{Jg= Heh}', "");
    Expect(1, 1608, '\p{^Jg= Heh}', "");
    Expect(1, 1608, '\P{Jg= Heh}', "");
    Expect(0, 1608, '\P{^Jg= Heh}', "");
    Error('\p{Is_Joining_Group=-Heh/a/}');
    Error('\P{Is_Joining_Group=-Heh/a/}');
    Expect(1, 1607, '\p{Is_Joining_Group=heh}', "");
    Expect(0, 1607, '\p{^Is_Joining_Group=heh}', "");
    Expect(0, 1607, '\P{Is_Joining_Group=heh}', "");
    Expect(1, 1607, '\P{^Is_Joining_Group=heh}', "");
    Expect(0, 1608, '\p{Is_Joining_Group=heh}', "");
    Expect(1, 1608, '\p{^Is_Joining_Group=heh}', "");
    Expect(1, 1608, '\P{Is_Joining_Group=heh}', "");
    Expect(0, 1608, '\P{^Is_Joining_Group=heh}', "");
    Expect(1, 1607, '\p{Is_Joining_Group:   HEH}', "");
    Expect(0, 1607, '\p{^Is_Joining_Group:   HEH}', "");
    Expect(0, 1607, '\P{Is_Joining_Group:   HEH}', "");
    Expect(1, 1607, '\P{^Is_Joining_Group:   HEH}', "");
    Expect(0, 1608, '\p{Is_Joining_Group:   HEH}', "");
    Expect(1, 1608, '\p{^Is_Joining_Group:   HEH}', "");
    Expect(1, 1608, '\P{Is_Joining_Group:   HEH}', "");
    Expect(0, 1608, '\P{^Is_Joining_Group:   HEH}', "");
    Error('\p{Is_Jg=- heh/a/}');
    Error('\P{Is_Jg=- heh/a/}');
    Expect(1, 1607, '\p{Is_Jg=heh}', "");
    Expect(0, 1607, '\p{^Is_Jg=heh}', "");
    Expect(0, 1607, '\P{Is_Jg=heh}', "");
    Expect(1, 1607, '\P{^Is_Jg=heh}', "");
    Expect(0, 1608, '\p{Is_Jg=heh}', "");
    Expect(1, 1608, '\p{^Is_Jg=heh}', "");
    Expect(1, 1608, '\P{Is_Jg=heh}', "");
    Expect(0, 1608, '\P{^Is_Jg=heh}', "");
    Expect(1, 1607, '\p{Is_Jg=-HEH}', "");
    Expect(0, 1607, '\p{^Is_Jg=-HEH}', "");
    Expect(0, 1607, '\P{Is_Jg=-HEH}', "");
    Expect(1, 1607, '\P{^Is_Jg=-HEH}', "");
    Expect(0, 1608, '\p{Is_Jg=-HEH}', "");
    Expect(1, 1608, '\p{^Is_Jg=-HEH}', "");
    Expect(1, 1608, '\P{Is_Jg=-HEH}', "");
    Expect(0, 1608, '\P{^Is_Jg=-HEH}', "");
    Error('\p{Joining_Group=	/a/Heh_Goal}');
    Error('\P{Joining_Group=	/a/Heh_Goal}');
    Expect(1, 1730, '\p{Joining_Group=hehgoal}', "");
    Expect(0, 1730, '\p{^Joining_Group=hehgoal}', "");
    Expect(0, 1730, '\P{Joining_Group=hehgoal}', "");
    Expect(1, 1730, '\P{^Joining_Group=hehgoal}', "");
    Expect(0, 1731, '\p{Joining_Group=hehgoal}', "");
    Expect(1, 1731, '\p{^Joining_Group=hehgoal}', "");
    Expect(1, 1731, '\P{Joining_Group=hehgoal}', "");
    Expect(0, 1731, '\P{^Joining_Group=hehgoal}', "");
    Expect(1, 1730, '\p{Joining_Group=	_Heh_goal}', "");
    Expect(0, 1730, '\p{^Joining_Group=	_Heh_goal}', "");
    Expect(0, 1730, '\P{Joining_Group=	_Heh_goal}', "");
    Expect(1, 1730, '\P{^Joining_Group=	_Heh_goal}', "");
    Expect(0, 1731, '\p{Joining_Group=	_Heh_goal}', "");
    Expect(1, 1731, '\p{^Joining_Group=	_Heh_goal}', "");
    Expect(1, 1731, '\P{Joining_Group=	_Heh_goal}', "");
    Expect(0, 1731, '\P{^Joining_Group=	_Heh_goal}', "");
    Error('\p{Jg::=	_Heh_Goal}');
    Error('\P{Jg::=	_Heh_Goal}');
    Expect(1, 1730, '\p{Jg=hehgoal}', "");
    Expect(0, 1730, '\p{^Jg=hehgoal}', "");
    Expect(0, 1730, '\P{Jg=hehgoal}', "");
    Expect(1, 1730, '\P{^Jg=hehgoal}', "");
    Expect(0, 1731, '\p{Jg=hehgoal}', "");
    Expect(1, 1731, '\p{^Jg=hehgoal}', "");
    Expect(1, 1731, '\P{Jg=hehgoal}', "");
    Expect(0, 1731, '\P{^Jg=hehgoal}', "");
    Expect(1, 1730, '\p{Jg=_	HEH_GOAL}', "");
    Expect(0, 1730, '\p{^Jg=_	HEH_GOAL}', "");
    Expect(0, 1730, '\P{Jg=_	HEH_GOAL}', "");
    Expect(1, 1730, '\P{^Jg=_	HEH_GOAL}', "");
    Expect(0, 1731, '\p{Jg=_	HEH_GOAL}', "");
    Expect(1, 1731, '\p{^Jg=_	HEH_GOAL}', "");
    Expect(1, 1731, '\P{Jg=_	HEH_GOAL}', "");
    Expect(0, 1731, '\P{^Jg=_	HEH_GOAL}', "");
    Error('\p{Is_Joining_Group=:=	-HEH_GOAL}');
    Error('\P{Is_Joining_Group=:=	-HEH_GOAL}');
    Expect(1, 1730, '\p{Is_Joining_Group=hehgoal}', "");
    Expect(0, 1730, '\p{^Is_Joining_Group=hehgoal}', "");
    Expect(0, 1730, '\P{Is_Joining_Group=hehgoal}', "");
    Expect(1, 1730, '\P{^Is_Joining_Group=hehgoal}', "");
    Expect(0, 1731, '\p{Is_Joining_Group=hehgoal}', "");
    Expect(1, 1731, '\p{^Is_Joining_Group=hehgoal}', "");
    Expect(1, 1731, '\P{Is_Joining_Group=hehgoal}', "");
    Expect(0, 1731, '\P{^Is_Joining_Group=hehgoal}', "");
    Expect(1, 1730, '\p{Is_Joining_Group: 		heh_goal}', "");
    Expect(0, 1730, '\p{^Is_Joining_Group: 		heh_goal}', "");
    Expect(0, 1730, '\P{Is_Joining_Group: 		heh_goal}', "");
    Expect(1, 1730, '\P{^Is_Joining_Group: 		heh_goal}', "");
    Expect(0, 1731, '\p{Is_Joining_Group: 		heh_goal}', "");
    Expect(1, 1731, '\p{^Is_Joining_Group: 		heh_goal}', "");
    Expect(1, 1731, '\P{Is_Joining_Group: 		heh_goal}', "");
    Expect(0, 1731, '\P{^Is_Joining_Group: 		heh_goal}', "");
    Error('\p{Is_Jg=:=		HEH_Goal}');
    Error('\P{Is_Jg=:=		HEH_Goal}');
    Expect(1, 1730, '\p{Is_Jg=hehgoal}', "");
    Expect(0, 1730, '\p{^Is_Jg=hehgoal}', "");
    Expect(0, 1730, '\P{Is_Jg=hehgoal}', "");
    Expect(1, 1730, '\P{^Is_Jg=hehgoal}', "");
    Expect(0, 1731, '\p{Is_Jg=hehgoal}', "");
    Expect(1, 1731, '\p{^Is_Jg=hehgoal}', "");
    Expect(1, 1731, '\P{Is_Jg=hehgoal}', "");
    Expect(0, 1731, '\P{^Is_Jg=hehgoal}', "");
    Expect(1, 1730, '\p{Is_Jg=_ Heh_Goal}', "");
    Expect(0, 1730, '\p{^Is_Jg=_ Heh_Goal}', "");
    Expect(0, 1730, '\P{Is_Jg=_ Heh_Goal}', "");
    Expect(1, 1730, '\P{^Is_Jg=_ Heh_Goal}', "");
    Expect(0, 1731, '\p{Is_Jg=_ Heh_Goal}', "");
    Expect(1, 1731, '\p{^Is_Jg=_ Heh_Goal}', "");
    Expect(1, 1731, '\P{Is_Jg=_ Heh_Goal}', "");
    Expect(0, 1731, '\P{^Is_Jg=_ Heh_Goal}', "");
    Error('\p{Joining_Group= -Heth/a/}');
    Error('\P{Joining_Group= -Heth/a/}');
    Expect(1, 1818, '\p{Joining_Group=heth}', "");
    Expect(0, 1818, '\p{^Joining_Group=heth}', "");
    Expect(0, 1818, '\P{Joining_Group=heth}', "");
    Expect(1, 1818, '\P{^Joining_Group=heth}', "");
    Expect(0, 1819, '\p{Joining_Group=heth}', "");
    Expect(1, 1819, '\p{^Joining_Group=heth}', "");
    Expect(1, 1819, '\P{Joining_Group=heth}', "");
    Expect(0, 1819, '\P{^Joining_Group=heth}', "");
    Expect(1, 1818, '\p{Joining_Group=  Heth}', "");
    Expect(0, 1818, '\p{^Joining_Group=  Heth}', "");
    Expect(0, 1818, '\P{Joining_Group=  Heth}', "");
    Expect(1, 1818, '\P{^Joining_Group=  Heth}', "");
    Expect(0, 1819, '\p{Joining_Group=  Heth}', "");
    Expect(1, 1819, '\p{^Joining_Group=  Heth}', "");
    Expect(1, 1819, '\P{Joining_Group=  Heth}', "");
    Expect(0, 1819, '\P{^Joining_Group=  Heth}', "");
    Error('\p{Jg=_ HETH/a/}');
    Error('\P{Jg=_ HETH/a/}');
    Expect(1, 1818, '\p{Jg=heth}', "");
    Expect(0, 1818, '\p{^Jg=heth}', "");
    Expect(0, 1818, '\P{Jg=heth}', "");
    Expect(1, 1818, '\P{^Jg=heth}', "");
    Expect(0, 1819, '\p{Jg=heth}', "");
    Expect(1, 1819, '\p{^Jg=heth}', "");
    Expect(1, 1819, '\P{Jg=heth}', "");
    Expect(0, 1819, '\P{^Jg=heth}', "");
    Expect(1, 1818, '\p{Jg= Heth}', "");
    Expect(0, 1818, '\p{^Jg= Heth}', "");
    Expect(0, 1818, '\P{Jg= Heth}', "");
    Expect(1, 1818, '\P{^Jg= Heth}', "");
    Expect(0, 1819, '\p{Jg= Heth}', "");
    Expect(1, 1819, '\p{^Jg= Heth}', "");
    Expect(1, 1819, '\P{Jg= Heth}', "");
    Expect(0, 1819, '\P{^Jg= Heth}', "");
    Error('\p{Is_Joining_Group= /a/Heth}');
    Error('\P{Is_Joining_Group= /a/Heth}');
    Expect(1, 1818, '\p{Is_Joining_Group=heth}', "");
    Expect(0, 1818, '\p{^Is_Joining_Group=heth}', "");
    Expect(0, 1818, '\P{Is_Joining_Group=heth}', "");
    Expect(1, 1818, '\P{^Is_Joining_Group=heth}', "");
    Expect(0, 1819, '\p{Is_Joining_Group=heth}', "");
    Expect(1, 1819, '\p{^Is_Joining_Group=heth}', "");
    Expect(1, 1819, '\P{Is_Joining_Group=heth}', "");
    Expect(0, 1819, '\P{^Is_Joining_Group=heth}', "");
    Expect(1, 1818, '\p{Is_Joining_Group=_	heth}', "");
    Expect(0, 1818, '\p{^Is_Joining_Group=_	heth}', "");
    Expect(0, 1818, '\P{Is_Joining_Group=_	heth}', "");
    Expect(1, 1818, '\P{^Is_Joining_Group=_	heth}', "");
    Expect(0, 1819, '\p{Is_Joining_Group=_	heth}', "");
    Expect(1, 1819, '\p{^Is_Joining_Group=_	heth}', "");
    Expect(1, 1819, '\P{Is_Joining_Group=_	heth}', "");
    Expect(0, 1819, '\P{^Is_Joining_Group=_	heth}', "");
    Error('\p{Is_Jg=/a/ -heth}');
    Error('\P{Is_Jg=/a/ -heth}');
    Expect(1, 1818, '\p{Is_Jg=heth}', "");
    Expect(0, 1818, '\p{^Is_Jg=heth}', "");
    Expect(0, 1818, '\P{Is_Jg=heth}', "");
    Expect(1, 1818, '\P{^Is_Jg=heth}', "");
    Expect(0, 1819, '\p{Is_Jg=heth}', "");
    Expect(1, 1819, '\p{^Is_Jg=heth}', "");
    Expect(1, 1819, '\P{Is_Jg=heth}', "");
    Expect(0, 1819, '\P{^Is_Jg=heth}', "");
    Expect(1, 1818, '\p{Is_Jg=_ Heth}', "");
    Expect(0, 1818, '\p{^Is_Jg=_ Heth}', "");
    Expect(0, 1818, '\P{Is_Jg=_ Heth}', "");
    Expect(1, 1818, '\P{^Is_Jg=_ Heth}', "");
    Expect(0, 1819, '\p{Is_Jg=_ Heth}', "");
    Expect(1, 1819, '\p{^Is_Jg=_ Heth}', "");
    Expect(1, 1819, '\P{Is_Jg=_ Heth}', "");
    Expect(0, 1819, '\P{^Is_Jg=_ Heth}', "");
    Error('\p{Joining_Group=_/a/kaf}');
    Error('\P{Joining_Group=_/a/kaf}');
    Expect(1, 2228, '\p{Joining_Group=kaf}', "");
    Expect(0, 2228, '\p{^Joining_Group=kaf}', "");
    Expect(0, 2228, '\P{Joining_Group=kaf}', "");
    Expect(1, 2228, '\P{^Joining_Group=kaf}', "");
    Expect(0, 2229, '\p{Joining_Group=kaf}', "");
    Expect(1, 2229, '\p{^Joining_Group=kaf}', "");
    Expect(1, 2229, '\P{Joining_Group=kaf}', "");
    Expect(0, 2229, '\P{^Joining_Group=kaf}', "");
    Expect(1, 2228, '\p{Joining_Group=	 Kaf}', "");
    Expect(0, 2228, '\p{^Joining_Group=	 Kaf}', "");
    Expect(0, 2228, '\P{Joining_Group=	 Kaf}', "");
    Expect(1, 2228, '\P{^Joining_Group=	 Kaf}', "");
    Expect(0, 2229, '\p{Joining_Group=	 Kaf}', "");
    Expect(1, 2229, '\p{^Joining_Group=	 Kaf}', "");
    Expect(1, 2229, '\P{Joining_Group=	 Kaf}', "");
    Expect(0, 2229, '\P{^Joining_Group=	 Kaf}', "");
    Error('\p{Jg=	kaf:=}');
    Error('\P{Jg=	kaf:=}');
    Expect(1, 2228, '\p{Jg=kaf}', "");
    Expect(0, 2228, '\p{^Jg=kaf}', "");
    Expect(0, 2228, '\P{Jg=kaf}', "");
    Expect(1, 2228, '\P{^Jg=kaf}', "");
    Expect(0, 2229, '\p{Jg=kaf}', "");
    Expect(1, 2229, '\p{^Jg=kaf}', "");
    Expect(1, 2229, '\P{Jg=kaf}', "");
    Expect(0, 2229, '\P{^Jg=kaf}', "");
    Expect(1, 2228, '\p{Jg=_KAF}', "");
    Expect(0, 2228, '\p{^Jg=_KAF}', "");
    Expect(0, 2228, '\P{Jg=_KAF}', "");
    Expect(1, 2228, '\P{^Jg=_KAF}', "");
    Expect(0, 2229, '\p{Jg=_KAF}', "");
    Expect(1, 2229, '\p{^Jg=_KAF}', "");
    Expect(1, 2229, '\P{Jg=_KAF}', "");
    Expect(0, 2229, '\P{^Jg=_KAF}', "");
    Error('\p{Is_Joining_Group= _Kaf/a/}');
    Error('\P{Is_Joining_Group= _Kaf/a/}');
    Expect(1, 2228, '\p{Is_Joining_Group=kaf}', "");
    Expect(0, 2228, '\p{^Is_Joining_Group=kaf}', "");
    Expect(0, 2228, '\P{Is_Joining_Group=kaf}', "");
    Expect(1, 2228, '\P{^Is_Joining_Group=kaf}', "");
    Expect(0, 2229, '\p{Is_Joining_Group=kaf}', "");
    Expect(1, 2229, '\p{^Is_Joining_Group=kaf}', "");
    Expect(1, 2229, '\P{Is_Joining_Group=kaf}', "");
    Expect(0, 2229, '\P{^Is_Joining_Group=kaf}', "");
    Expect(1, 2228, '\p{Is_Joining_Group=--KAF}', "");
    Expect(0, 2228, '\p{^Is_Joining_Group=--KAF}', "");
    Expect(0, 2228, '\P{Is_Joining_Group=--KAF}', "");
    Expect(1, 2228, '\P{^Is_Joining_Group=--KAF}', "");
    Expect(0, 2229, '\p{Is_Joining_Group=--KAF}', "");
    Expect(1, 2229, '\p{^Is_Joining_Group=--KAF}', "");
    Expect(1, 2229, '\P{Is_Joining_Group=--KAF}', "");
    Expect(0, 2229, '\P{^Is_Joining_Group=--KAF}', "");
    Error('\p{Is_Jg=	/a/Kaf}');
    Error('\P{Is_Jg=	/a/Kaf}');
    Expect(1, 2228, '\p{Is_Jg=kaf}', "");
    Expect(0, 2228, '\p{^Is_Jg=kaf}', "");
    Expect(0, 2228, '\P{Is_Jg=kaf}', "");
    Expect(1, 2228, '\P{^Is_Jg=kaf}', "");
    Expect(0, 2229, '\p{Is_Jg=kaf}', "");
    Expect(1, 2229, '\p{^Is_Jg=kaf}', "");
    Expect(1, 2229, '\P{Is_Jg=kaf}', "");
    Expect(0, 2229, '\P{^Is_Jg=kaf}', "");
    Expect(1, 2228, '\p{Is_Jg=	-KAF}', "");
    Expect(0, 2228, '\p{^Is_Jg=	-KAF}', "");
    Expect(0, 2228, '\P{Is_Jg=	-KAF}', "");
    Expect(1, 2228, '\P{^Is_Jg=	-KAF}', "");
    Expect(0, 2229, '\p{Is_Jg=	-KAF}', "");
    Expect(1, 2229, '\p{^Is_Jg=	-KAF}', "");
    Expect(1, 2229, '\P{Is_Jg=	-KAF}', "");
    Expect(0, 2229, '\P{^Is_Jg=	-KAF}', "");
    Error('\p{Joining_Group=-/a/Kaph}');
    Error('\P{Joining_Group=-/a/Kaph}');
    Expect(1, 1823, '\p{Joining_Group=kaph}', "");
    Expect(0, 1823, '\p{^Joining_Group=kaph}', "");
    Expect(0, 1823, '\P{Joining_Group=kaph}', "");
    Expect(1, 1823, '\P{^Joining_Group=kaph}', "");
    Expect(0, 1824, '\p{Joining_Group=kaph}', "");
    Expect(1, 1824, '\p{^Joining_Group=kaph}', "");
    Expect(1, 1824, '\P{Joining_Group=kaph}', "");
    Expect(0, 1824, '\P{^Joining_Group=kaph}', "");
    Expect(1, 1823, '\p{Joining_Group=Kaph}', "");
    Expect(0, 1823, '\p{^Joining_Group=Kaph}', "");
    Expect(0, 1823, '\P{Joining_Group=Kaph}', "");
    Expect(1, 1823, '\P{^Joining_Group=Kaph}', "");
    Expect(0, 1824, '\p{Joining_Group=Kaph}', "");
    Expect(1, 1824, '\p{^Joining_Group=Kaph}', "");
    Expect(1, 1824, '\P{Joining_Group=Kaph}', "");
    Expect(0, 1824, '\P{^Joining_Group=Kaph}', "");
    Error('\p{Jg=/a/KAPH}');
    Error('\P{Jg=/a/KAPH}');
    Expect(1, 1823, '\p{Jg=kaph}', "");
    Expect(0, 1823, '\p{^Jg=kaph}', "");
    Expect(0, 1823, '\P{Jg=kaph}', "");
    Expect(1, 1823, '\P{^Jg=kaph}', "");
    Expect(0, 1824, '\p{Jg=kaph}', "");
    Expect(1, 1824, '\p{^Jg=kaph}', "");
    Expect(1, 1824, '\P{Jg=kaph}', "");
    Expect(0, 1824, '\P{^Jg=kaph}', "");
    Expect(1, 1823, '\p{Jg=-	Kaph}', "");
    Expect(0, 1823, '\p{^Jg=-	Kaph}', "");
    Expect(0, 1823, '\P{Jg=-	Kaph}', "");
    Expect(1, 1823, '\P{^Jg=-	Kaph}', "");
    Expect(0, 1824, '\p{Jg=-	Kaph}', "");
    Expect(1, 1824, '\p{^Jg=-	Kaph}', "");
    Expect(1, 1824, '\P{Jg=-	Kaph}', "");
    Expect(0, 1824, '\P{^Jg=-	Kaph}', "");
    Error('\p{Is_Joining_Group=	kaph:=}');
    Error('\P{Is_Joining_Group=	kaph:=}');
    Expect(1, 1823, '\p{Is_Joining_Group=kaph}', "");
    Expect(0, 1823, '\p{^Is_Joining_Group=kaph}', "");
    Expect(0, 1823, '\P{Is_Joining_Group=kaph}', "");
    Expect(1, 1823, '\P{^Is_Joining_Group=kaph}', "");
    Expect(0, 1824, '\p{Is_Joining_Group=kaph}', "");
    Expect(1, 1824, '\p{^Is_Joining_Group=kaph}', "");
    Expect(1, 1824, '\P{Is_Joining_Group=kaph}', "");
    Expect(0, 1824, '\P{^Is_Joining_Group=kaph}', "");
    Expect(1, 1823, '\p{Is_Joining_Group:	 _Kaph}', "");
    Expect(0, 1823, '\p{^Is_Joining_Group:	 _Kaph}', "");
    Expect(0, 1823, '\P{Is_Joining_Group:	 _Kaph}', "");
    Expect(1, 1823, '\P{^Is_Joining_Group:	 _Kaph}', "");
    Expect(0, 1824, '\p{Is_Joining_Group:	 _Kaph}', "");
    Expect(1, 1824, '\p{^Is_Joining_Group:	 _Kaph}', "");
    Expect(1, 1824, '\P{Is_Joining_Group:	 _Kaph}', "");
    Expect(0, 1824, '\P{^Is_Joining_Group:	 _Kaph}', "");
    Error('\p{Is_Jg=:= -KAPH}');
    Error('\P{Is_Jg=:= -KAPH}');
    Expect(1, 1823, '\p{Is_Jg=kaph}', "");
    Expect(0, 1823, '\p{^Is_Jg=kaph}', "");
    Expect(0, 1823, '\P{Is_Jg=kaph}', "");
    Expect(1, 1823, '\P{^Is_Jg=kaph}', "");
    Expect(0, 1824, '\p{Is_Jg=kaph}', "");
    Expect(1, 1824, '\p{^Is_Jg=kaph}', "");
    Expect(1, 1824, '\P{Is_Jg=kaph}', "");
    Expect(0, 1824, '\P{^Is_Jg=kaph}', "");
    Expect(1, 1823, '\p{Is_Jg=_KAPH}', "");
    Expect(0, 1823, '\p{^Is_Jg=_KAPH}', "");
    Expect(0, 1823, '\P{Is_Jg=_KAPH}', "");
    Expect(1, 1823, '\P{^Is_Jg=_KAPH}', "");
    Expect(0, 1824, '\p{Is_Jg=_KAPH}', "");
    Expect(1, 1824, '\p{^Is_Jg=_KAPH}', "");
    Expect(1, 1824, '\P{Is_Jg=_KAPH}', "");
    Expect(0, 1824, '\P{^Is_Jg=_KAPH}', "");
    Error('\p{Joining_Group=_-khaph/a/}');
    Error('\P{Joining_Group=_-khaph/a/}');
    Expect(1, 1870, '\p{Joining_Group=khaph}', "");
    Expect(0, 1870, '\p{^Joining_Group=khaph}', "");
    Expect(0, 1870, '\P{Joining_Group=khaph}', "");
    Expect(1, 1870, '\P{^Joining_Group=khaph}', "");
    Expect(0, 1871, '\p{Joining_Group=khaph}', "");
    Expect(1, 1871, '\p{^Joining_Group=khaph}', "");
    Expect(1, 1871, '\P{Joining_Group=khaph}', "");
    Expect(0, 1871, '\P{^Joining_Group=khaph}', "");
    Expect(1, 1870, '\p{Joining_Group=__Khaph}', "");
    Expect(0, 1870, '\p{^Joining_Group=__Khaph}', "");
    Expect(0, 1870, '\P{Joining_Group=__Khaph}', "");
    Expect(1, 1870, '\P{^Joining_Group=__Khaph}', "");
    Expect(0, 1871, '\p{Joining_Group=__Khaph}', "");
    Expect(1, 1871, '\p{^Joining_Group=__Khaph}', "");
    Expect(1, 1871, '\P{Joining_Group=__Khaph}', "");
    Expect(0, 1871, '\P{^Joining_Group=__Khaph}', "");
    Error('\p{Jg=-KHAPH:=}');
    Error('\P{Jg=-KHAPH:=}');
    Expect(1, 1870, '\p{Jg=khaph}', "");
    Expect(0, 1870, '\p{^Jg=khaph}', "");
    Expect(0, 1870, '\P{Jg=khaph}', "");
    Expect(1, 1870, '\P{^Jg=khaph}', "");
    Expect(0, 1871, '\p{Jg=khaph}', "");
    Expect(1, 1871, '\p{^Jg=khaph}', "");
    Expect(1, 1871, '\P{Jg=khaph}', "");
    Expect(0, 1871, '\P{^Jg=khaph}', "");
    Expect(1, 1870, '\p{Jg= KHAPH}', "");
    Expect(0, 1870, '\p{^Jg= KHAPH}', "");
    Expect(0, 1870, '\P{Jg= KHAPH}', "");
    Expect(1, 1870, '\P{^Jg= KHAPH}', "");
    Expect(0, 1871, '\p{Jg= KHAPH}', "");
    Expect(1, 1871, '\p{^Jg= KHAPH}', "");
    Expect(1, 1871, '\P{Jg= KHAPH}', "");
    Expect(0, 1871, '\P{^Jg= KHAPH}', "");
    Error('\p{Is_Joining_Group=  KHAPH:=}');
    Error('\P{Is_Joining_Group=  KHAPH:=}');
    Expect(1, 1870, '\p{Is_Joining_Group: khaph}', "");
    Expect(0, 1870, '\p{^Is_Joining_Group: khaph}', "");
    Expect(0, 1870, '\P{Is_Joining_Group: khaph}', "");
    Expect(1, 1870, '\P{^Is_Joining_Group: khaph}', "");
    Expect(0, 1871, '\p{Is_Joining_Group: khaph}', "");
    Expect(1, 1871, '\p{^Is_Joining_Group: khaph}', "");
    Expect(1, 1871, '\P{Is_Joining_Group: khaph}', "");
    Expect(0, 1871, '\P{^Is_Joining_Group: khaph}', "");
    Expect(1, 1870, '\p{Is_Joining_Group: _KHAPH}', "");
    Expect(0, 1870, '\p{^Is_Joining_Group: _KHAPH}', "");
    Expect(0, 1870, '\P{Is_Joining_Group: _KHAPH}', "");
    Expect(1, 1870, '\P{^Is_Joining_Group: _KHAPH}', "");
    Expect(0, 1871, '\p{Is_Joining_Group: _KHAPH}', "");
    Expect(1, 1871, '\p{^Is_Joining_Group: _KHAPH}', "");
    Expect(1, 1871, '\P{Is_Joining_Group: _KHAPH}', "");
    Expect(0, 1871, '\P{^Is_Joining_Group: _KHAPH}', "");
    Error('\p{Is_Jg=-:=Khaph}');
    Error('\P{Is_Jg=-:=Khaph}');
    Expect(1, 1870, '\p{Is_Jg=khaph}', "");
    Expect(0, 1870, '\p{^Is_Jg=khaph}', "");
    Expect(0, 1870, '\P{Is_Jg=khaph}', "");
    Expect(1, 1870, '\P{^Is_Jg=khaph}', "");
    Expect(0, 1871, '\p{Is_Jg=khaph}', "");
    Expect(1, 1871, '\p{^Is_Jg=khaph}', "");
    Expect(1, 1871, '\P{Is_Jg=khaph}', "");
    Expect(0, 1871, '\P{^Is_Jg=khaph}', "");
    Expect(1, 1870, '\p{Is_Jg=	-Khaph}', "");
    Expect(0, 1870, '\p{^Is_Jg=	-Khaph}', "");
    Expect(0, 1870, '\P{Is_Jg=	-Khaph}', "");
    Expect(1, 1870, '\P{^Is_Jg=	-Khaph}', "");
    Expect(0, 1871, '\p{Is_Jg=	-Khaph}', "");
    Expect(1, 1871, '\p{^Is_Jg=	-Khaph}', "");
    Expect(1, 1871, '\P{Is_Jg=	-Khaph}', "");
    Expect(0, 1871, '\P{^Is_Jg=	-Khaph}', "");
    Error('\p{Joining_Group=-	KNOTTED_HEH/a/}');
    Error('\P{Joining_Group=-	KNOTTED_HEH/a/}');
    Expect(1, 1791, '\p{Joining_Group=knottedheh}', "");
    Expect(0, 1791, '\p{^Joining_Group=knottedheh}', "");
    Expect(0, 1791, '\P{Joining_Group=knottedheh}', "");
    Expect(1, 1791, '\P{^Joining_Group=knottedheh}', "");
    Expect(0, 1792, '\p{Joining_Group=knottedheh}', "");
    Expect(1, 1792, '\p{^Joining_Group=knottedheh}', "");
    Expect(1, 1792, '\P{Joining_Group=knottedheh}', "");
    Expect(0, 1792, '\P{^Joining_Group=knottedheh}', "");
    Expect(1, 1791, '\p{Joining_Group=Knotted_HEH}', "");
    Expect(0, 1791, '\p{^Joining_Group=Knotted_HEH}', "");
    Expect(0, 1791, '\P{Joining_Group=Knotted_HEH}', "");
    Expect(1, 1791, '\P{^Joining_Group=Knotted_HEH}', "");
    Expect(0, 1792, '\p{Joining_Group=Knotted_HEH}', "");
    Expect(1, 1792, '\p{^Joining_Group=Knotted_HEH}', "");
    Expect(1, 1792, '\P{Joining_Group=Knotted_HEH}', "");
    Expect(0, 1792, '\P{^Joining_Group=Knotted_HEH}', "");
    Error('\p{Jg=-:=Knotted_Heh}');
    Error('\P{Jg=-:=Knotted_Heh}');
    Expect(1, 1791, '\p{Jg=knottedheh}', "");
    Expect(0, 1791, '\p{^Jg=knottedheh}', "");
    Expect(0, 1791, '\P{Jg=knottedheh}', "");
    Expect(1, 1791, '\P{^Jg=knottedheh}', "");
    Expect(0, 1792, '\p{Jg=knottedheh}', "");
    Expect(1, 1792, '\p{^Jg=knottedheh}', "");
    Expect(1, 1792, '\P{Jg=knottedheh}', "");
    Expect(0, 1792, '\P{^Jg=knottedheh}', "");
    Expect(1, 1791, '\p{Jg= 	knotted_Heh}', "");
    Expect(0, 1791, '\p{^Jg= 	knotted_Heh}', "");
    Expect(0, 1791, '\P{Jg= 	knotted_Heh}', "");
    Expect(1, 1791, '\P{^Jg= 	knotted_Heh}', "");
    Expect(0, 1792, '\p{Jg= 	knotted_Heh}', "");
    Expect(1, 1792, '\p{^Jg= 	knotted_Heh}', "");
    Expect(1, 1792, '\P{Jg= 	knotted_Heh}', "");
    Expect(0, 1792, '\P{^Jg= 	knotted_Heh}', "");
    Error('\p{Is_Joining_Group=:=_-Knotted_Heh}');
    Error('\P{Is_Joining_Group=:=_-Knotted_Heh}');
    Expect(1, 1791, '\p{Is_Joining_Group=knottedheh}', "");
    Expect(0, 1791, '\p{^Is_Joining_Group=knottedheh}', "");
    Expect(0, 1791, '\P{Is_Joining_Group=knottedheh}', "");
    Expect(1, 1791, '\P{^Is_Joining_Group=knottedheh}', "");
    Expect(0, 1792, '\p{Is_Joining_Group=knottedheh}', "");
    Expect(1, 1792, '\p{^Is_Joining_Group=knottedheh}', "");
    Expect(1, 1792, '\P{Is_Joining_Group=knottedheh}', "");
    Expect(0, 1792, '\P{^Is_Joining_Group=knottedheh}', "");
    Expect(1, 1791, '\p{Is_Joining_Group:	Knotted_HEH}', "");
    Expect(0, 1791, '\p{^Is_Joining_Group:	Knotted_HEH}', "");
    Expect(0, 1791, '\P{Is_Joining_Group:	Knotted_HEH}', "");
    Expect(1, 1791, '\P{^Is_Joining_Group:	Knotted_HEH}', "");
    Expect(0, 1792, '\p{Is_Joining_Group:	Knotted_HEH}', "");
    Expect(1, 1792, '\p{^Is_Joining_Group:	Knotted_HEH}', "");
    Expect(1, 1792, '\P{Is_Joining_Group:	Knotted_HEH}', "");
    Expect(0, 1792, '\P{^Is_Joining_Group:	Knotted_HEH}', "");
    Error('\p{Is_Jg=/a/KNOTTED_HEH}');
    Error('\P{Is_Jg=/a/KNOTTED_HEH}');
    Expect(1, 1791, '\p{Is_Jg:   knottedheh}', "");
    Expect(0, 1791, '\p{^Is_Jg:   knottedheh}', "");
    Expect(0, 1791, '\P{Is_Jg:   knottedheh}', "");
    Expect(1, 1791, '\P{^Is_Jg:   knottedheh}', "");
    Expect(0, 1792, '\p{Is_Jg:   knottedheh}', "");
    Expect(1, 1792, '\p{^Is_Jg:   knottedheh}', "");
    Expect(1, 1792, '\P{Is_Jg:   knottedheh}', "");
    Expect(0, 1792, '\P{^Is_Jg:   knottedheh}', "");
    Expect(1, 1791, '\p{Is_Jg=_KNOTTED_heh}', "");
    Expect(0, 1791, '\p{^Is_Jg=_KNOTTED_heh}', "");
    Expect(0, 1791, '\P{Is_Jg=_KNOTTED_heh}', "");
    Expect(1, 1791, '\P{^Is_Jg=_KNOTTED_heh}', "");
    Expect(0, 1792, '\p{Is_Jg=_KNOTTED_heh}', "");
    Expect(1, 1792, '\p{^Is_Jg=_KNOTTED_heh}', "");
    Expect(1, 1792, '\P{Is_Jg=_KNOTTED_heh}', "");
    Expect(0, 1792, '\P{^Is_Jg=_KNOTTED_heh}', "");
    Error('\p{Joining_Group=/a/_-LAM}');
    Error('\P{Joining_Group=/a/_-LAM}');
    Expect(1, 2214, '\p{Joining_Group=lam}', "");
    Expect(0, 2214, '\p{^Joining_Group=lam}', "");
    Expect(0, 2214, '\P{Joining_Group=lam}', "");
    Expect(1, 2214, '\P{^Joining_Group=lam}', "");
    Expect(0, 2215, '\p{Joining_Group=lam}', "");
    Expect(1, 2215, '\p{^Joining_Group=lam}', "");
    Expect(1, 2215, '\P{Joining_Group=lam}', "");
    Expect(0, 2215, '\P{^Joining_Group=lam}', "");
    Expect(1, 2214, '\p{Joining_Group=-LAM}', "");
    Expect(0, 2214, '\p{^Joining_Group=-LAM}', "");
    Expect(0, 2214, '\P{Joining_Group=-LAM}', "");
    Expect(1, 2214, '\P{^Joining_Group=-LAM}', "");
    Expect(0, 2215, '\p{Joining_Group=-LAM}', "");
    Expect(1, 2215, '\p{^Joining_Group=-LAM}', "");
    Expect(1, 2215, '\P{Joining_Group=-LAM}', "");
    Expect(0, 2215, '\P{^Joining_Group=-LAM}', "");
    Error('\p{Jg=	LAM:=}');
    Error('\P{Jg=	LAM:=}');
    Expect(1, 2214, '\p{Jg=lam}', "");
    Expect(0, 2214, '\p{^Jg=lam}', "");
    Expect(0, 2214, '\P{Jg=lam}', "");
    Expect(1, 2214, '\P{^Jg=lam}', "");
    Expect(0, 2215, '\p{Jg=lam}', "");
    Expect(1, 2215, '\p{^Jg=lam}', "");
    Expect(1, 2215, '\P{Jg=lam}', "");
    Expect(0, 2215, '\P{^Jg=lam}', "");
    Expect(1, 2214, '\p{Jg=	 LAM}', "");
    Expect(0, 2214, '\p{^Jg=	 LAM}', "");
    Expect(0, 2214, '\P{Jg=	 LAM}', "");
    Expect(1, 2214, '\P{^Jg=	 LAM}', "");
    Expect(0, 2215, '\p{Jg=	 LAM}', "");
    Expect(1, 2215, '\p{^Jg=	 LAM}', "");
    Expect(1, 2215, '\P{Jg=	 LAM}', "");
    Expect(0, 2215, '\P{^Jg=	 LAM}', "");
    Error('\p{Is_Joining_Group=/a/-lam}');
    Error('\P{Is_Joining_Group=/a/-lam}');
    Expect(1, 2214, '\p{Is_Joining_Group=lam}', "");
    Expect(0, 2214, '\p{^Is_Joining_Group=lam}', "");
    Expect(0, 2214, '\P{Is_Joining_Group=lam}', "");
    Expect(1, 2214, '\P{^Is_Joining_Group=lam}', "");
    Expect(0, 2215, '\p{Is_Joining_Group=lam}', "");
    Expect(1, 2215, '\p{^Is_Joining_Group=lam}', "");
    Expect(1, 2215, '\P{Is_Joining_Group=lam}', "");
    Expect(0, 2215, '\P{^Is_Joining_Group=lam}', "");
    Expect(1, 2214, '\p{Is_Joining_Group: -LAM}', "");
    Expect(0, 2214, '\p{^Is_Joining_Group: -LAM}', "");
    Expect(0, 2214, '\P{Is_Joining_Group: -LAM}', "");
    Expect(1, 2214, '\P{^Is_Joining_Group: -LAM}', "");
    Expect(0, 2215, '\p{Is_Joining_Group: -LAM}', "");
    Expect(1, 2215, '\p{^Is_Joining_Group: -LAM}', "");
    Expect(1, 2215, '\P{Is_Joining_Group: -LAM}', "");
    Expect(0, 2215, '\P{^Is_Joining_Group: -LAM}', "");
    Error('\p{Is_Jg:    _Lam:=}');
    Error('\P{Is_Jg:    _Lam:=}');
    Expect(1, 2214, '\p{Is_Jg=lam}', "");
    Expect(0, 2214, '\p{^Is_Jg=lam}', "");
    Expect(0, 2214, '\P{Is_Jg=lam}', "");
    Expect(1, 2214, '\P{^Is_Jg=lam}', "");
    Expect(0, 2215, '\p{Is_Jg=lam}', "");
    Expect(1, 2215, '\p{^Is_Jg=lam}', "");
    Expect(1, 2215, '\P{Is_Jg=lam}', "");
    Expect(0, 2215, '\P{^Is_Jg=lam}', "");
    Expect(1, 2214, '\p{Is_Jg=	Lam}', "");
    Expect(0, 2214, '\p{^Is_Jg=	Lam}', "");
    Expect(0, 2214, '\P{Is_Jg=	Lam}', "");
    Expect(1, 2214, '\P{^Is_Jg=	Lam}', "");
    Expect(0, 2215, '\p{Is_Jg=	Lam}', "");
    Expect(1, 2215, '\p{^Is_Jg=	Lam}', "");
    Expect(1, 2215, '\P{Is_Jg=	Lam}', "");
    Expect(0, 2215, '\P{^Is_Jg=	Lam}', "");
    Error('\p{Joining_Group:   -/a/LAMADH}');
    Error('\P{Joining_Group:   -/a/LAMADH}');
    Expect(1, 1824, '\p{Joining_Group=lamadh}', "");
    Expect(0, 1824, '\p{^Joining_Group=lamadh}', "");
    Expect(0, 1824, '\P{Joining_Group=lamadh}', "");
    Expect(1, 1824, '\P{^Joining_Group=lamadh}', "");
    Expect(0, 1825, '\p{Joining_Group=lamadh}', "");
    Expect(1, 1825, '\p{^Joining_Group=lamadh}', "");
    Expect(1, 1825, '\P{Joining_Group=lamadh}', "");
    Expect(0, 1825, '\P{^Joining_Group=lamadh}', "");
    Expect(1, 1824, '\p{Joining_Group=__Lamadh}', "");
    Expect(0, 1824, '\p{^Joining_Group=__Lamadh}', "");
    Expect(0, 1824, '\P{Joining_Group=__Lamadh}', "");
    Expect(1, 1824, '\P{^Joining_Group=__Lamadh}', "");
    Expect(0, 1825, '\p{Joining_Group=__Lamadh}', "");
    Expect(1, 1825, '\p{^Joining_Group=__Lamadh}', "");
    Expect(1, 1825, '\P{Joining_Group=__Lamadh}', "");
    Expect(0, 1825, '\P{^Joining_Group=__Lamadh}', "");
    Error('\p{Jg= -lamadh/a/}');
    Error('\P{Jg= -lamadh/a/}');
    Expect(1, 1824, '\p{Jg=lamadh}', "");
    Expect(0, 1824, '\p{^Jg=lamadh}', "");
    Expect(0, 1824, '\P{Jg=lamadh}', "");
    Expect(1, 1824, '\P{^Jg=lamadh}', "");
    Expect(0, 1825, '\p{Jg=lamadh}', "");
    Expect(1, 1825, '\p{^Jg=lamadh}', "");
    Expect(1, 1825, '\P{Jg=lamadh}', "");
    Expect(0, 1825, '\P{^Jg=lamadh}', "");
    Expect(1, 1824, '\p{Jg= lamadh}', "");
    Expect(0, 1824, '\p{^Jg= lamadh}', "");
    Expect(0, 1824, '\P{Jg= lamadh}', "");
    Expect(1, 1824, '\P{^Jg= lamadh}', "");
    Expect(0, 1825, '\p{Jg= lamadh}', "");
    Expect(1, 1825, '\p{^Jg= lamadh}', "");
    Expect(1, 1825, '\P{Jg= lamadh}', "");
    Expect(0, 1825, '\P{^Jg= lamadh}', "");
    Error('\p{Is_Joining_Group=_-Lamadh/a/}');
    Error('\P{Is_Joining_Group=_-Lamadh/a/}');
    Expect(1, 1824, '\p{Is_Joining_Group=lamadh}', "");
    Expect(0, 1824, '\p{^Is_Joining_Group=lamadh}', "");
    Expect(0, 1824, '\P{Is_Joining_Group=lamadh}', "");
    Expect(1, 1824, '\P{^Is_Joining_Group=lamadh}', "");
    Expect(0, 1825, '\p{Is_Joining_Group=lamadh}', "");
    Expect(1, 1825, '\p{^Is_Joining_Group=lamadh}', "");
    Expect(1, 1825, '\P{Is_Joining_Group=lamadh}', "");
    Expect(0, 1825, '\P{^Is_Joining_Group=lamadh}', "");
    Expect(1, 1824, '\p{Is_Joining_Group=-_Lamadh}', "");
    Expect(0, 1824, '\p{^Is_Joining_Group=-_Lamadh}', "");
    Expect(0, 1824, '\P{Is_Joining_Group=-_Lamadh}', "");
    Expect(1, 1824, '\P{^Is_Joining_Group=-_Lamadh}', "");
    Expect(0, 1825, '\p{Is_Joining_Group=-_Lamadh}', "");
    Expect(1, 1825, '\p{^Is_Joining_Group=-_Lamadh}', "");
    Expect(1, 1825, '\P{Is_Joining_Group=-_Lamadh}', "");
    Expect(0, 1825, '\P{^Is_Joining_Group=-_Lamadh}', "");
    Error('\p{Is_Jg=-_Lamadh:=}');
    Error('\P{Is_Jg=-_Lamadh:=}');
    Expect(1, 1824, '\p{Is_Jg=lamadh}', "");
    Expect(0, 1824, '\p{^Is_Jg=lamadh}', "");
    Expect(0, 1824, '\P{Is_Jg=lamadh}', "");
    Expect(1, 1824, '\P{^Is_Jg=lamadh}', "");
    Expect(0, 1825, '\p{Is_Jg=lamadh}', "");
    Expect(1, 1825, '\p{^Is_Jg=lamadh}', "");
    Expect(1, 1825, '\P{Is_Jg=lamadh}', "");
    Expect(0, 1825, '\P{^Is_Jg=lamadh}', "");
    Expect(1, 1824, '\p{Is_Jg:	__lamadh}', "");
    Expect(0, 1824, '\p{^Is_Jg:	__lamadh}', "");
    Expect(0, 1824, '\P{Is_Jg:	__lamadh}', "");
    Expect(1, 1824, '\P{^Is_Jg:	__lamadh}', "");
    Expect(0, 1825, '\p{Is_Jg:	__lamadh}', "");
    Expect(1, 1825, '\p{^Is_Jg:	__lamadh}', "");
    Expect(1, 1825, '\P{Is_Jg:	__lamadh}', "");
    Expect(0, 1825, '\P{^Is_Jg:	__lamadh}', "");
    Error('\p{Joining_Group=--MALAYALAM_Bha/a/}');
    Error('\P{Joining_Group=--MALAYALAM_Bha/a/}');
    Expect(1, 2150, '\p{Joining_Group=malayalambha}', "");
    Expect(0, 2150, '\p{^Joining_Group=malayalambha}', "");
    Expect(0, 2150, '\P{Joining_Group=malayalambha}', "");
    Expect(1, 2150, '\P{^Joining_Group=malayalambha}', "");
    Expect(0, 2151, '\p{Joining_Group=malayalambha}', "");
    Expect(1, 2151, '\p{^Joining_Group=malayalambha}', "");
    Expect(1, 2151, '\P{Joining_Group=malayalambha}', "");
    Expect(0, 2151, '\P{^Joining_Group=malayalambha}', "");
    Expect(1, 2150, '\p{Joining_Group=__Malayalam_Bha}', "");
    Expect(0, 2150, '\p{^Joining_Group=__Malayalam_Bha}', "");
    Expect(0, 2150, '\P{Joining_Group=__Malayalam_Bha}', "");
    Expect(1, 2150, '\P{^Joining_Group=__Malayalam_Bha}', "");
    Expect(0, 2151, '\p{Joining_Group=__Malayalam_Bha}', "");
    Expect(1, 2151, '\p{^Joining_Group=__Malayalam_Bha}', "");
    Expect(1, 2151, '\P{Joining_Group=__Malayalam_Bha}', "");
    Expect(0, 2151, '\P{^Joining_Group=__Malayalam_Bha}', "");
    Error('\p{Jg=	_Malayalam_Bha/a/}');
    Error('\P{Jg=	_Malayalam_Bha/a/}');
    Expect(1, 2150, '\p{Jg:   malayalambha}', "");
    Expect(0, 2150, '\p{^Jg:   malayalambha}', "");
    Expect(0, 2150, '\P{Jg:   malayalambha}', "");
    Expect(1, 2150, '\P{^Jg:   malayalambha}', "");
    Expect(0, 2151, '\p{Jg:   malayalambha}', "");
    Expect(1, 2151, '\p{^Jg:   malayalambha}', "");
    Expect(1, 2151, '\P{Jg:   malayalambha}', "");
    Expect(0, 2151, '\P{^Jg:   malayalambha}', "");
    Expect(1, 2150, '\p{Jg=Malayalam_BHA}', "");
    Expect(0, 2150, '\p{^Jg=Malayalam_BHA}', "");
    Expect(0, 2150, '\P{Jg=Malayalam_BHA}', "");
    Expect(1, 2150, '\P{^Jg=Malayalam_BHA}', "");
    Expect(0, 2151, '\p{Jg=Malayalam_BHA}', "");
    Expect(1, 2151, '\p{^Jg=Malayalam_BHA}', "");
    Expect(1, 2151, '\P{Jg=Malayalam_BHA}', "");
    Expect(0, 2151, '\P{^Jg=Malayalam_BHA}', "");
    Error('\p{Is_Joining_Group=:=Malayalam_bha}');
    Error('\P{Is_Joining_Group=:=Malayalam_bha}');
    Expect(1, 2150, '\p{Is_Joining_Group=malayalambha}', "");
    Expect(0, 2150, '\p{^Is_Joining_Group=malayalambha}', "");
    Expect(0, 2150, '\P{Is_Joining_Group=malayalambha}', "");
    Expect(1, 2150, '\P{^Is_Joining_Group=malayalambha}', "");
    Expect(0, 2151, '\p{Is_Joining_Group=malayalambha}', "");
    Expect(1, 2151, '\p{^Is_Joining_Group=malayalambha}', "");
    Expect(1, 2151, '\P{Is_Joining_Group=malayalambha}', "");
    Expect(0, 2151, '\P{^Is_Joining_Group=malayalambha}', "");
    Expect(1, 2150, '\p{Is_Joining_Group=_ MALAYALAM_BHA}', "");
    Expect(0, 2150, '\p{^Is_Joining_Group=_ MALAYALAM_BHA}', "");
    Expect(0, 2150, '\P{Is_Joining_Group=_ MALAYALAM_BHA}', "");
    Expect(1, 2150, '\P{^Is_Joining_Group=_ MALAYALAM_BHA}', "");
    Expect(0, 2151, '\p{Is_Joining_Group=_ MALAYALAM_BHA}', "");
    Expect(1, 2151, '\p{^Is_Joining_Group=_ MALAYALAM_BHA}', "");
    Expect(1, 2151, '\P{Is_Joining_Group=_ MALAYALAM_BHA}', "");
    Expect(0, 2151, '\P{^Is_Joining_Group=_ MALAYALAM_BHA}', "");
    Error('\p{Is_Jg=/a/MALAYALAM_Bha}');
    Error('\P{Is_Jg=/a/MALAYALAM_Bha}');
    Expect(1, 2150, '\p{Is_Jg=malayalambha}', "");
    Expect(0, 2150, '\p{^Is_Jg=malayalambha}', "");
    Expect(0, 2150, '\P{Is_Jg=malayalambha}', "");
    Expect(1, 2150, '\P{^Is_Jg=malayalambha}', "");
    Expect(0, 2151, '\p{Is_Jg=malayalambha}', "");
    Expect(1, 2151, '\p{^Is_Jg=malayalambha}', "");
    Expect(1, 2151, '\P{Is_Jg=malayalambha}', "");
    Expect(0, 2151, '\P{^Is_Jg=malayalambha}', "");
    Expect(1, 2150, '\p{Is_Jg=-MALAYALAM_Bha}', "");
    Expect(0, 2150, '\p{^Is_Jg=-MALAYALAM_Bha}', "");
    Expect(0, 2150, '\P{Is_Jg=-MALAYALAM_Bha}', "");
    Expect(1, 2150, '\P{^Is_Jg=-MALAYALAM_Bha}', "");
    Expect(0, 2151, '\p{Is_Jg=-MALAYALAM_Bha}', "");
    Expect(1, 2151, '\p{^Is_Jg=-MALAYALAM_Bha}', "");
    Expect(1, 2151, '\P{Is_Jg=-MALAYALAM_Bha}', "");
    Expect(0, 2151, '\P{^Is_Jg=-MALAYALAM_Bha}', "");
    Error('\p{Joining_Group=-Malayalam_Ja/a/}');
    Error('\P{Joining_Group=-Malayalam_Ja/a/}');
    Expect(1, 2145, '\p{Joining_Group=malayalamja}', "");
    Expect(0, 2145, '\p{^Joining_Group=malayalamja}', "");
    Expect(0, 2145, '\P{Joining_Group=malayalamja}', "");
    Expect(1, 2145, '\P{^Joining_Group=malayalamja}', "");
    Expect(0, 2146, '\p{Joining_Group=malayalamja}', "");
    Expect(1, 2146, '\p{^Joining_Group=malayalamja}', "");
    Expect(1, 2146, '\P{Joining_Group=malayalamja}', "");
    Expect(0, 2146, '\P{^Joining_Group=malayalamja}', "");
    Expect(1, 2145, '\p{Joining_Group=_	Malayalam_ja}', "");
    Expect(0, 2145, '\p{^Joining_Group=_	Malayalam_ja}', "");
    Expect(0, 2145, '\P{Joining_Group=_	Malayalam_ja}', "");
    Expect(1, 2145, '\P{^Joining_Group=_	Malayalam_ja}', "");
    Expect(0, 2146, '\p{Joining_Group=_	Malayalam_ja}', "");
    Expect(1, 2146, '\p{^Joining_Group=_	Malayalam_ja}', "");
    Expect(1, 2146, '\P{Joining_Group=_	Malayalam_ja}', "");
    Expect(0, 2146, '\P{^Joining_Group=_	Malayalam_ja}', "");
    Error('\p{Jg=/a/_	malayalam_Ja}');
    Error('\P{Jg=/a/_	malayalam_Ja}');
    Expect(1, 2145, '\p{Jg=malayalamja}', "");
    Expect(0, 2145, '\p{^Jg=malayalamja}', "");
    Expect(0, 2145, '\P{Jg=malayalamja}', "");
    Expect(1, 2145, '\P{^Jg=malayalamja}', "");
    Expect(0, 2146, '\p{Jg=malayalamja}', "");
    Expect(1, 2146, '\p{^Jg=malayalamja}', "");
    Expect(1, 2146, '\P{Jg=malayalamja}', "");
    Expect(0, 2146, '\P{^Jg=malayalamja}', "");
    Expect(1, 2145, '\p{Jg=_	Malayalam_ja}', "");
    Expect(0, 2145, '\p{^Jg=_	Malayalam_ja}', "");
    Expect(0, 2145, '\P{Jg=_	Malayalam_ja}', "");
    Expect(1, 2145, '\P{^Jg=_	Malayalam_ja}', "");
    Expect(0, 2146, '\p{Jg=_	Malayalam_ja}', "");
    Expect(1, 2146, '\p{^Jg=_	Malayalam_ja}', "");
    Expect(1, 2146, '\P{Jg=_	Malayalam_ja}', "");
    Expect(0, 2146, '\P{^Jg=_	Malayalam_ja}', "");
    Error('\p{Is_Joining_Group= /a/Malayalam_Ja}');
    Error('\P{Is_Joining_Group= /a/Malayalam_Ja}');
    Expect(1, 2145, '\p{Is_Joining_Group=malayalamja}', "");
    Expect(0, 2145, '\p{^Is_Joining_Group=malayalamja}', "");
    Expect(0, 2145, '\P{Is_Joining_Group=malayalamja}', "");
    Expect(1, 2145, '\P{^Is_Joining_Group=malayalamja}', "");
    Expect(0, 2146, '\p{Is_Joining_Group=malayalamja}', "");
    Expect(1, 2146, '\p{^Is_Joining_Group=malayalamja}', "");
    Expect(1, 2146, '\P{Is_Joining_Group=malayalamja}', "");
    Expect(0, 2146, '\P{^Is_Joining_Group=malayalamja}', "");
    Expect(1, 2145, '\p{Is_Joining_Group=_malayalam_Ja}', "");
    Expect(0, 2145, '\p{^Is_Joining_Group=_malayalam_Ja}', "");
    Expect(0, 2145, '\P{Is_Joining_Group=_malayalam_Ja}', "");
    Expect(1, 2145, '\P{^Is_Joining_Group=_malayalam_Ja}', "");
    Expect(0, 2146, '\p{Is_Joining_Group=_malayalam_Ja}', "");
    Expect(1, 2146, '\p{^Is_Joining_Group=_malayalam_Ja}', "");
    Expect(1, 2146, '\P{Is_Joining_Group=_malayalam_Ja}', "");
    Expect(0, 2146, '\P{^Is_Joining_Group=_malayalam_Ja}', "");
    Error('\p{Is_Jg= -Malayalam_JA/a/}');
    Error('\P{Is_Jg= -Malayalam_JA/a/}');
    Expect(1, 2145, '\p{Is_Jg=malayalamja}', "");
    Expect(0, 2145, '\p{^Is_Jg=malayalamja}', "");
    Expect(0, 2145, '\P{Is_Jg=malayalamja}', "");
    Expect(1, 2145, '\P{^Is_Jg=malayalamja}', "");
    Expect(0, 2146, '\p{Is_Jg=malayalamja}', "");
    Expect(1, 2146, '\p{^Is_Jg=malayalamja}', "");
    Expect(1, 2146, '\P{Is_Jg=malayalamja}', "");
    Expect(0, 2146, '\P{^Is_Jg=malayalamja}', "");
    Expect(1, 2145, '\p{Is_Jg= MALAYALAM_ja}', "");
    Expect(0, 2145, '\p{^Is_Jg= MALAYALAM_ja}', "");
    Expect(0, 2145, '\P{Is_Jg= MALAYALAM_ja}', "");
    Expect(1, 2145, '\P{^Is_Jg= MALAYALAM_ja}', "");
    Expect(0, 2146, '\p{Is_Jg= MALAYALAM_ja}', "");
    Expect(1, 2146, '\p{^Is_Jg= MALAYALAM_ja}', "");
    Expect(1, 2146, '\P{Is_Jg= MALAYALAM_ja}', "");
    Expect(0, 2146, '\P{^Is_Jg= MALAYALAM_ja}', "");
    Error('\p{Joining_Group=- Malayalam_LLA/a/}');
    Error('\P{Joining_Group=- Malayalam_LLA/a/}');
    Expect(1, 2152, '\p{Joining_Group=malayalamlla}', "");
    Expect(0, 2152, '\p{^Joining_Group=malayalamlla}', "");
    Expect(0, 2152, '\P{Joining_Group=malayalamlla}', "");
    Expect(1, 2152, '\P{^Joining_Group=malayalamlla}', "");
    Expect(0, 2153, '\p{Joining_Group=malayalamlla}', "");
    Expect(1, 2153, '\p{^Joining_Group=malayalamlla}', "");
    Expect(1, 2153, '\P{Joining_Group=malayalamlla}', "");
    Expect(0, 2153, '\P{^Joining_Group=malayalamlla}', "");
    Expect(1, 2152, '\p{Joining_Group=_MALAYALAM_Lla}', "");
    Expect(0, 2152, '\p{^Joining_Group=_MALAYALAM_Lla}', "");
    Expect(0, 2152, '\P{Joining_Group=_MALAYALAM_Lla}', "");
    Expect(1, 2152, '\P{^Joining_Group=_MALAYALAM_Lla}', "");
    Expect(0, 2153, '\p{Joining_Group=_MALAYALAM_Lla}', "");
    Expect(1, 2153, '\p{^Joining_Group=_MALAYALAM_Lla}', "");
    Expect(1, 2153, '\P{Joining_Group=_MALAYALAM_Lla}', "");
    Expect(0, 2153, '\P{^Joining_Group=_MALAYALAM_Lla}', "");
    Error('\p{Jg=:= Malayalam_Lla}');
    Error('\P{Jg=:= Malayalam_Lla}');
    Expect(1, 2152, '\p{Jg=malayalamlla}', "");
    Expect(0, 2152, '\p{^Jg=malayalamlla}', "");
    Expect(0, 2152, '\P{Jg=malayalamlla}', "");
    Expect(1, 2152, '\P{^Jg=malayalamlla}', "");
    Expect(0, 2153, '\p{Jg=malayalamlla}', "");
    Expect(1, 2153, '\p{^Jg=malayalamlla}', "");
    Expect(1, 2153, '\P{Jg=malayalamlla}', "");
    Expect(0, 2153, '\P{^Jg=malayalamlla}', "");
    Expect(1, 2152, '\p{Jg=_-MALAYALAM_Lla}', "");
    Expect(0, 2152, '\p{^Jg=_-MALAYALAM_Lla}', "");
    Expect(0, 2152, '\P{Jg=_-MALAYALAM_Lla}', "");
    Expect(1, 2152, '\P{^Jg=_-MALAYALAM_Lla}', "");
    Expect(0, 2153, '\p{Jg=_-MALAYALAM_Lla}', "");
    Expect(1, 2153, '\p{^Jg=_-MALAYALAM_Lla}', "");
    Expect(1, 2153, '\P{Jg=_-MALAYALAM_Lla}', "");
    Expect(0, 2153, '\P{^Jg=_-MALAYALAM_Lla}', "");
    Error('\p{Is_Joining_Group=/a/	 malayalam_Lla}');
    Error('\P{Is_Joining_Group=/a/	 malayalam_Lla}');
    Expect(1, 2152, '\p{Is_Joining_Group=malayalamlla}', "");
    Expect(0, 2152, '\p{^Is_Joining_Group=malayalamlla}', "");
    Expect(0, 2152, '\P{Is_Joining_Group=malayalamlla}', "");
    Expect(1, 2152, '\P{^Is_Joining_Group=malayalamlla}', "");
    Expect(0, 2153, '\p{Is_Joining_Group=malayalamlla}', "");
    Expect(1, 2153, '\p{^Is_Joining_Group=malayalamlla}', "");
    Expect(1, 2153, '\P{Is_Joining_Group=malayalamlla}', "");
    Expect(0, 2153, '\P{^Is_Joining_Group=malayalamlla}', "");
    Expect(1, 2152, '\p{Is_Joining_Group=	MALAYALAM_Lla}', "");
    Expect(0, 2152, '\p{^Is_Joining_Group=	MALAYALAM_Lla}', "");
    Expect(0, 2152, '\P{Is_Joining_Group=	MALAYALAM_Lla}', "");
    Expect(1, 2152, '\P{^Is_Joining_Group=	MALAYALAM_Lla}', "");
    Expect(0, 2153, '\p{Is_Joining_Group=	MALAYALAM_Lla}', "");
    Expect(1, 2153, '\p{^Is_Joining_Group=	MALAYALAM_Lla}', "");
    Expect(1, 2153, '\P{Is_Joining_Group=	MALAYALAM_Lla}', "");
    Expect(0, 2153, '\P{^Is_Joining_Group=	MALAYALAM_Lla}', "");
    Error('\p{Is_Jg=/a/--MALAYALAM_lla}');
    Error('\P{Is_Jg=/a/--MALAYALAM_lla}');
    Expect(1, 2152, '\p{Is_Jg=malayalamlla}', "");
    Expect(0, 2152, '\p{^Is_Jg=malayalamlla}', "");
    Expect(0, 2152, '\P{Is_Jg=malayalamlla}', "");
    Expect(1, 2152, '\P{^Is_Jg=malayalamlla}', "");
    Expect(0, 2153, '\p{Is_Jg=malayalamlla}', "");
    Expect(1, 2153, '\p{^Is_Jg=malayalamlla}', "");
    Expect(1, 2153, '\P{Is_Jg=malayalamlla}', "");
    Expect(0, 2153, '\P{^Is_Jg=malayalamlla}', "");
    Expect(1, 2152, '\p{Is_Jg= -Malayalam_LLA}', "");
    Expect(0, 2152, '\p{^Is_Jg= -Malayalam_LLA}', "");
    Expect(0, 2152, '\P{Is_Jg= -Malayalam_LLA}', "");
    Expect(1, 2152, '\P{^Is_Jg= -Malayalam_LLA}', "");
    Expect(0, 2153, '\p{Is_Jg= -Malayalam_LLA}', "");
    Expect(1, 2153, '\p{^Is_Jg= -Malayalam_LLA}', "");
    Expect(1, 2153, '\P{Is_Jg= -Malayalam_LLA}', "");
    Expect(0, 2153, '\P{^Is_Jg= -Malayalam_LLA}', "");
    Error('\p{Joining_Group= :=MALAYALAM_Llla}');
    Error('\P{Joining_Group= :=MALAYALAM_Llla}');
    Expect(1, 2153, '\p{Joining_Group=malayalamllla}', "");
    Expect(0, 2153, '\p{^Joining_Group=malayalamllla}', "");
    Expect(0, 2153, '\P{Joining_Group=malayalamllla}', "");
    Expect(1, 2153, '\P{^Joining_Group=malayalamllla}', "");
    Expect(0, 2154, '\p{Joining_Group=malayalamllla}', "");
    Expect(1, 2154, '\p{^Joining_Group=malayalamllla}', "");
    Expect(1, 2154, '\P{Joining_Group=malayalamllla}', "");
    Expect(0, 2154, '\P{^Joining_Group=malayalamllla}', "");
    Expect(1, 2153, '\p{Joining_Group=__MALAYALAM_Llla}', "");
    Expect(0, 2153, '\p{^Joining_Group=__MALAYALAM_Llla}', "");
    Expect(0, 2153, '\P{Joining_Group=__MALAYALAM_Llla}', "");
    Expect(1, 2153, '\P{^Joining_Group=__MALAYALAM_Llla}', "");
    Expect(0, 2154, '\p{Joining_Group=__MALAYALAM_Llla}', "");
    Expect(1, 2154, '\p{^Joining_Group=__MALAYALAM_Llla}', "");
    Expect(1, 2154, '\P{Joining_Group=__MALAYALAM_Llla}', "");
    Expect(0, 2154, '\P{^Joining_Group=__MALAYALAM_Llla}', "");
    Error('\p{Jg=/a/ Malayalam_Llla}');
    Error('\P{Jg=/a/ Malayalam_Llla}');
    Expect(1, 2153, '\p{Jg=malayalamllla}', "");
    Expect(0, 2153, '\p{^Jg=malayalamllla}', "");
    Expect(0, 2153, '\P{Jg=malayalamllla}', "");
    Expect(1, 2153, '\P{^Jg=malayalamllla}', "");
    Expect(0, 2154, '\p{Jg=malayalamllla}', "");
    Expect(1, 2154, '\p{^Jg=malayalamllla}', "");
    Expect(1, 2154, '\P{Jg=malayalamllla}', "");
    Expect(0, 2154, '\P{^Jg=malayalamllla}', "");
    Expect(1, 2153, '\p{Jg= _MALAYALAM_Llla}', "");
    Expect(0, 2153, '\p{^Jg= _MALAYALAM_Llla}', "");
    Expect(0, 2153, '\P{Jg= _MALAYALAM_Llla}', "");
    Expect(1, 2153, '\P{^Jg= _MALAYALAM_Llla}', "");
    Expect(0, 2154, '\p{Jg= _MALAYALAM_Llla}', "");
    Expect(1, 2154, '\p{^Jg= _MALAYALAM_Llla}', "");
    Expect(1, 2154, '\P{Jg= _MALAYALAM_Llla}', "");
    Expect(0, 2154, '\P{^Jg= _MALAYALAM_Llla}', "");
    Error('\p{Is_Joining_Group=/a/Malayalam_Llla}');
    Error('\P{Is_Joining_Group=/a/Malayalam_Llla}');
    Expect(1, 2153, '\p{Is_Joining_Group=malayalamllla}', "");
    Expect(0, 2153, '\p{^Is_Joining_Group=malayalamllla}', "");
    Expect(0, 2153, '\P{Is_Joining_Group=malayalamllla}', "");
    Expect(1, 2153, '\P{^Is_Joining_Group=malayalamllla}', "");
    Expect(0, 2154, '\p{Is_Joining_Group=malayalamllla}', "");
    Expect(1, 2154, '\p{^Is_Joining_Group=malayalamllla}', "");
    Expect(1, 2154, '\P{Is_Joining_Group=malayalamllla}', "");
    Expect(0, 2154, '\P{^Is_Joining_Group=malayalamllla}', "");
    Expect(1, 2153, '\p{Is_Joining_Group=-Malayalam_LLLA}', "");
    Expect(0, 2153, '\p{^Is_Joining_Group=-Malayalam_LLLA}', "");
    Expect(0, 2153, '\P{Is_Joining_Group=-Malayalam_LLLA}', "");
    Expect(1, 2153, '\P{^Is_Joining_Group=-Malayalam_LLLA}', "");
    Expect(0, 2154, '\p{Is_Joining_Group=-Malayalam_LLLA}', "");
    Expect(1, 2154, '\p{^Is_Joining_Group=-Malayalam_LLLA}', "");
    Expect(1, 2154, '\P{Is_Joining_Group=-Malayalam_LLLA}', "");
    Expect(0, 2154, '\P{^Is_Joining_Group=-Malayalam_LLLA}', "");
    Error('\p{Is_Jg=:=	 MALAYALAM_Llla}');
    Error('\P{Is_Jg=:=	 MALAYALAM_Llla}');
    Expect(1, 2153, '\p{Is_Jg=malayalamllla}', "");
    Expect(0, 2153, '\p{^Is_Jg=malayalamllla}', "");
    Expect(0, 2153, '\P{Is_Jg=malayalamllla}', "");
    Expect(1, 2153, '\P{^Is_Jg=malayalamllla}', "");
    Expect(0, 2154, '\p{Is_Jg=malayalamllla}', "");
    Expect(1, 2154, '\p{^Is_Jg=malayalamllla}', "");
    Expect(1, 2154, '\P{Is_Jg=malayalamllla}', "");
    Expect(0, 2154, '\P{^Is_Jg=malayalamllla}', "");
    Expect(1, 2153, '\p{Is_Jg=		malayalam_LLLA}', "");
    Expect(0, 2153, '\p{^Is_Jg=		malayalam_LLLA}', "");
    Expect(0, 2153, '\P{Is_Jg=		malayalam_LLLA}', "");
    Expect(1, 2153, '\P{^Is_Jg=		malayalam_LLLA}', "");
    Expect(0, 2154, '\p{Is_Jg=		malayalam_LLLA}', "");
    Expect(1, 2154, '\p{^Is_Jg=		malayalam_LLLA}', "");
    Expect(1, 2154, '\P{Is_Jg=		malayalam_LLLA}', "");
    Expect(0, 2154, '\P{^Is_Jg=		malayalam_LLLA}', "");
    Error('\p{Joining_Group=/a/MALAYALAM_NGA}');
    Error('\P{Joining_Group=/a/MALAYALAM_NGA}');
    Expect(1, 2144, '\p{Joining_Group=malayalamnga}', "");
    Expect(0, 2144, '\p{^Joining_Group=malayalamnga}', "");
    Expect(0, 2144, '\P{Joining_Group=malayalamnga}', "");
    Expect(1, 2144, '\P{^Joining_Group=malayalamnga}', "");
    Expect(0, 2145, '\p{Joining_Group=malayalamnga}', "");
    Expect(1, 2145, '\p{^Joining_Group=malayalamnga}', "");
    Expect(1, 2145, '\P{Joining_Group=malayalamnga}', "");
    Expect(0, 2145, '\P{^Joining_Group=malayalamnga}', "");
    Expect(1, 2144, '\p{Joining_Group=	malayalam_Nga}', "");
    Expect(0, 2144, '\p{^Joining_Group=	malayalam_Nga}', "");
    Expect(0, 2144, '\P{Joining_Group=	malayalam_Nga}', "");
    Expect(1, 2144, '\P{^Joining_Group=	malayalam_Nga}', "");
    Expect(0, 2145, '\p{Joining_Group=	malayalam_Nga}', "");
    Expect(1, 2145, '\p{^Joining_Group=	malayalam_Nga}', "");
    Expect(1, 2145, '\P{Joining_Group=	malayalam_Nga}', "");
    Expect(0, 2145, '\P{^Joining_Group=	malayalam_Nga}', "");
    Error('\p{Jg=/a/	-Malayalam_Nga}');
    Error('\P{Jg=/a/	-Malayalam_Nga}');
    Expect(1, 2144, '\p{Jg=malayalamnga}', "");
    Expect(0, 2144, '\p{^Jg=malayalamnga}', "");
    Expect(0, 2144, '\P{Jg=malayalamnga}', "");
    Expect(1, 2144, '\P{^Jg=malayalamnga}', "");
    Expect(0, 2145, '\p{Jg=malayalamnga}', "");
    Expect(1, 2145, '\p{^Jg=malayalamnga}', "");
    Expect(1, 2145, '\P{Jg=malayalamnga}', "");
    Expect(0, 2145, '\P{^Jg=malayalamnga}', "");
    Expect(1, 2144, '\p{Jg=-	Malayalam_Nga}', "");
    Expect(0, 2144, '\p{^Jg=-	Malayalam_Nga}', "");
    Expect(0, 2144, '\P{Jg=-	Malayalam_Nga}', "");
    Expect(1, 2144, '\P{^Jg=-	Malayalam_Nga}', "");
    Expect(0, 2145, '\p{Jg=-	Malayalam_Nga}', "");
    Expect(1, 2145, '\p{^Jg=-	Malayalam_Nga}', "");
    Expect(1, 2145, '\P{Jg=-	Malayalam_Nga}', "");
    Expect(0, 2145, '\P{^Jg=-	Malayalam_Nga}', "");
    Error('\p{Is_Joining_Group=	:=Malayalam_Nga}');
    Error('\P{Is_Joining_Group=	:=Malayalam_Nga}');
    Expect(1, 2144, '\p{Is_Joining_Group: malayalamnga}', "");
    Expect(0, 2144, '\p{^Is_Joining_Group: malayalamnga}', "");
    Expect(0, 2144, '\P{Is_Joining_Group: malayalamnga}', "");
    Expect(1, 2144, '\P{^Is_Joining_Group: malayalamnga}', "");
    Expect(0, 2145, '\p{Is_Joining_Group: malayalamnga}', "");
    Expect(1, 2145, '\p{^Is_Joining_Group: malayalamnga}', "");
    Expect(1, 2145, '\P{Is_Joining_Group: malayalamnga}', "");
    Expect(0, 2145, '\P{^Is_Joining_Group: malayalamnga}', "");
    Expect(1, 2144, '\p{Is_Joining_Group=Malayalam_Nga}', "");
    Expect(0, 2144, '\p{^Is_Joining_Group=Malayalam_Nga}', "");
    Expect(0, 2144, '\P{Is_Joining_Group=Malayalam_Nga}', "");
    Expect(1, 2144, '\P{^Is_Joining_Group=Malayalam_Nga}', "");
    Expect(0, 2145, '\p{Is_Joining_Group=Malayalam_Nga}', "");
    Expect(1, 2145, '\p{^Is_Joining_Group=Malayalam_Nga}', "");
    Expect(1, 2145, '\P{Is_Joining_Group=Malayalam_Nga}', "");
    Expect(0, 2145, '\P{^Is_Joining_Group=Malayalam_Nga}', "");
    Error('\p{Is_Jg=/a/malayalam_NGA}');
    Error('\P{Is_Jg=/a/malayalam_NGA}');
    Expect(1, 2144, '\p{Is_Jg=malayalamnga}', "");
    Expect(0, 2144, '\p{^Is_Jg=malayalamnga}', "");
    Expect(0, 2144, '\P{Is_Jg=malayalamnga}', "");
    Expect(1, 2144, '\P{^Is_Jg=malayalamnga}', "");
    Expect(0, 2145, '\p{Is_Jg=malayalamnga}', "");
    Expect(1, 2145, '\p{^Is_Jg=malayalamnga}', "");
    Expect(1, 2145, '\P{Is_Jg=malayalamnga}', "");
    Expect(0, 2145, '\P{^Is_Jg=malayalamnga}', "");
    Expect(1, 2144, '\p{Is_Jg=	 malayalam_Nga}', "");
    Expect(0, 2144, '\p{^Is_Jg=	 malayalam_Nga}', "");
    Expect(0, 2144, '\P{Is_Jg=	 malayalam_Nga}', "");
    Expect(1, 2144, '\P{^Is_Jg=	 malayalam_Nga}', "");
    Expect(0, 2145, '\p{Is_Jg=	 malayalam_Nga}', "");
    Expect(1, 2145, '\p{^Is_Jg=	 malayalam_Nga}', "");
    Expect(1, 2145, '\P{Is_Jg=	 malayalam_Nga}', "");
    Expect(0, 2145, '\P{^Is_Jg=	 malayalam_Nga}', "");
    Error('\p{Joining_Group=-:=MALAYALAM_NNA}');
    Error('\P{Joining_Group=-:=MALAYALAM_NNA}');
    Expect(1, 2148, '\p{Joining_Group=malayalamnna}', "");
    Expect(0, 2148, '\p{^Joining_Group=malayalamnna}', "");
    Expect(0, 2148, '\P{Joining_Group=malayalamnna}', "");
    Expect(1, 2148, '\P{^Joining_Group=malayalamnna}', "");
    Expect(0, 2149, '\p{Joining_Group=malayalamnna}', "");
    Expect(1, 2149, '\p{^Joining_Group=malayalamnna}', "");
    Expect(1, 2149, '\P{Joining_Group=malayalamnna}', "");
    Expect(0, 2149, '\P{^Joining_Group=malayalamnna}', "");
    Expect(1, 2148, '\p{Joining_Group= MALAYALAM_Nna}', "");
    Expect(0, 2148, '\p{^Joining_Group= MALAYALAM_Nna}', "");
    Expect(0, 2148, '\P{Joining_Group= MALAYALAM_Nna}', "");
    Expect(1, 2148, '\P{^Joining_Group= MALAYALAM_Nna}', "");
    Expect(0, 2149, '\p{Joining_Group= MALAYALAM_Nna}', "");
    Expect(1, 2149, '\p{^Joining_Group= MALAYALAM_Nna}', "");
    Expect(1, 2149, '\P{Joining_Group= MALAYALAM_Nna}', "");
    Expect(0, 2149, '\P{^Joining_Group= MALAYALAM_Nna}', "");
    Error('\p{Jg=/a/ MALAYALAM_Nna}');
    Error('\P{Jg=/a/ MALAYALAM_Nna}');
    Expect(1, 2148, '\p{Jg=malayalamnna}', "");
    Expect(0, 2148, '\p{^Jg=malayalamnna}', "");
    Expect(0, 2148, '\P{Jg=malayalamnna}', "");
    Expect(1, 2148, '\P{^Jg=malayalamnna}', "");
    Expect(0, 2149, '\p{Jg=malayalamnna}', "");
    Expect(1, 2149, '\p{^Jg=malayalamnna}', "");
    Expect(1, 2149, '\P{Jg=malayalamnna}', "");
    Expect(0, 2149, '\P{^Jg=malayalamnna}', "");
    Expect(1, 2148, '\p{Jg:   		Malayalam_NNA}', "");
    Expect(0, 2148, '\p{^Jg:   		Malayalam_NNA}', "");
    Expect(0, 2148, '\P{Jg:   		Malayalam_NNA}', "");
    Expect(1, 2148, '\P{^Jg:   		Malayalam_NNA}', "");
    Expect(0, 2149, '\p{Jg:   		Malayalam_NNA}', "");
    Expect(1, 2149, '\p{^Jg:   		Malayalam_NNA}', "");
    Expect(1, 2149, '\P{Jg:   		Malayalam_NNA}', "");
    Expect(0, 2149, '\P{^Jg:   		Malayalam_NNA}', "");
    Error('\p{Is_Joining_Group:    malayalam_NNA:=}');
    Error('\P{Is_Joining_Group:    malayalam_NNA:=}');
    Expect(1, 2148, '\p{Is_Joining_Group=malayalamnna}', "");
    Expect(0, 2148, '\p{^Is_Joining_Group=malayalamnna}', "");
    Expect(0, 2148, '\P{Is_Joining_Group=malayalamnna}', "");
    Expect(1, 2148, '\P{^Is_Joining_Group=malayalamnna}', "");
    Expect(0, 2149, '\p{Is_Joining_Group=malayalamnna}', "");
    Expect(1, 2149, '\p{^Is_Joining_Group=malayalamnna}', "");
    Expect(1, 2149, '\P{Is_Joining_Group=malayalamnna}', "");
    Expect(0, 2149, '\P{^Is_Joining_Group=malayalamnna}', "");
    Expect(1, 2148, '\p{Is_Joining_Group=_-Malayalam_Nna}', "");
    Expect(0, 2148, '\p{^Is_Joining_Group=_-Malayalam_Nna}', "");
    Expect(0, 2148, '\P{Is_Joining_Group=_-Malayalam_Nna}', "");
    Expect(1, 2148, '\P{^Is_Joining_Group=_-Malayalam_Nna}', "");
    Expect(0, 2149, '\p{Is_Joining_Group=_-Malayalam_Nna}', "");
    Expect(1, 2149, '\p{^Is_Joining_Group=_-Malayalam_Nna}', "");
    Expect(1, 2149, '\P{Is_Joining_Group=_-Malayalam_Nna}', "");
    Expect(0, 2149, '\P{^Is_Joining_Group=_-Malayalam_Nna}', "");
    Error('\p{Is_Jg=/a/	MALAYALAM_NNA}');
    Error('\P{Is_Jg=/a/	MALAYALAM_NNA}');
    Expect(1, 2148, '\p{Is_Jg=malayalamnna}', "");
    Expect(0, 2148, '\p{^Is_Jg=malayalamnna}', "");
    Expect(0, 2148, '\P{Is_Jg=malayalamnna}', "");
    Expect(1, 2148, '\P{^Is_Jg=malayalamnna}', "");
    Expect(0, 2149, '\p{Is_Jg=malayalamnna}', "");
    Expect(1, 2149, '\p{^Is_Jg=malayalamnna}', "");
    Expect(1, 2149, '\P{Is_Jg=malayalamnna}', "");
    Expect(0, 2149, '\P{^Is_Jg=malayalamnna}', "");
    Expect(1, 2148, '\p{Is_Jg=-_Malayalam_Nna}', "");
    Expect(0, 2148, '\p{^Is_Jg=-_Malayalam_Nna}', "");
    Expect(0, 2148, '\P{Is_Jg=-_Malayalam_Nna}', "");
    Expect(1, 2148, '\P{^Is_Jg=-_Malayalam_Nna}', "");
    Expect(0, 2149, '\p{Is_Jg=-_Malayalam_Nna}', "");
    Expect(1, 2149, '\p{^Is_Jg=-_Malayalam_Nna}', "");
    Expect(1, 2149, '\P{Is_Jg=-_Malayalam_Nna}', "");
    Expect(0, 2149, '\P{^Is_Jg=-_Malayalam_Nna}', "");
    Error('\p{Joining_Group:   	/a/Malayalam_NNNA}');
    Error('\P{Joining_Group:   	/a/Malayalam_NNNA}');
    Expect(1, 2149, '\p{Joining_Group=malayalamnnna}', "");
    Expect(0, 2149, '\p{^Joining_Group=malayalamnnna}', "");
    Expect(0, 2149, '\P{Joining_Group=malayalamnnna}', "");
    Expect(1, 2149, '\P{^Joining_Group=malayalamnnna}', "");
    Expect(0, 2150, '\p{Joining_Group=malayalamnnna}', "");
    Expect(1, 2150, '\p{^Joining_Group=malayalamnnna}', "");
    Expect(1, 2150, '\P{Joining_Group=malayalamnnna}', "");
    Expect(0, 2150, '\P{^Joining_Group=malayalamnnna}', "");
    Expect(1, 2149, '\p{Joining_Group=		Malayalam_NNNA}', "");
    Expect(0, 2149, '\p{^Joining_Group=		Malayalam_NNNA}', "");
    Expect(0, 2149, '\P{Joining_Group=		Malayalam_NNNA}', "");
    Expect(1, 2149, '\P{^Joining_Group=		Malayalam_NNNA}', "");
    Expect(0, 2150, '\p{Joining_Group=		Malayalam_NNNA}', "");
    Expect(1, 2150, '\p{^Joining_Group=		Malayalam_NNNA}', "");
    Expect(1, 2150, '\P{Joining_Group=		Malayalam_NNNA}', "");
    Expect(0, 2150, '\P{^Joining_Group=		Malayalam_NNNA}', "");
    Error('\p{Jg=/a/_-malayalam_Nnna}');
    Error('\P{Jg=/a/_-malayalam_Nnna}');
    Expect(1, 2149, '\p{Jg=malayalamnnna}', "");
    Expect(0, 2149, '\p{^Jg=malayalamnnna}', "");
    Expect(0, 2149, '\P{Jg=malayalamnnna}', "");
    Expect(1, 2149, '\P{^Jg=malayalamnnna}', "");
    Expect(0, 2150, '\p{Jg=malayalamnnna}', "");
    Expect(1, 2150, '\p{^Jg=malayalamnnna}', "");
    Expect(1, 2150, '\P{Jg=malayalamnnna}', "");
    Expect(0, 2150, '\P{^Jg=malayalamnnna}', "");
    Expect(1, 2149, '\p{Jg=_Malayalam_Nnna}', "");
    Expect(0, 2149, '\p{^Jg=_Malayalam_Nnna}', "");
    Expect(0, 2149, '\P{Jg=_Malayalam_Nnna}', "");
    Expect(1, 2149, '\P{^Jg=_Malayalam_Nnna}', "");
    Expect(0, 2150, '\p{Jg=_Malayalam_Nnna}', "");
    Expect(1, 2150, '\p{^Jg=_Malayalam_Nnna}', "");
    Expect(1, 2150, '\P{Jg=_Malayalam_Nnna}', "");
    Expect(0, 2150, '\P{^Jg=_Malayalam_Nnna}', "");
    Error('\p{Is_Joining_Group=/a/	 MALAYALAM_nnna}');
    Error('\P{Is_Joining_Group=/a/	 MALAYALAM_nnna}');
    Expect(1, 2149, '\p{Is_Joining_Group=malayalamnnna}', "");
    Expect(0, 2149, '\p{^Is_Joining_Group=malayalamnnna}', "");
    Expect(0, 2149, '\P{Is_Joining_Group=malayalamnnna}', "");
    Expect(1, 2149, '\P{^Is_Joining_Group=malayalamnnna}', "");
    Expect(0, 2150, '\p{Is_Joining_Group=malayalamnnna}', "");
    Expect(1, 2150, '\p{^Is_Joining_Group=malayalamnnna}', "");
    Expect(1, 2150, '\P{Is_Joining_Group=malayalamnnna}', "");
    Expect(0, 2150, '\P{^Is_Joining_Group=malayalamnnna}', "");
    Expect(1, 2149, '\p{Is_Joining_Group=__Malayalam_Nnna}', "");
    Expect(0, 2149, '\p{^Is_Joining_Group=__Malayalam_Nnna}', "");
    Expect(0, 2149, '\P{Is_Joining_Group=__Malayalam_Nnna}', "");
    Expect(1, 2149, '\P{^Is_Joining_Group=__Malayalam_Nnna}', "");
    Expect(0, 2150, '\p{Is_Joining_Group=__Malayalam_Nnna}', "");
    Expect(1, 2150, '\p{^Is_Joining_Group=__Malayalam_Nnna}', "");
    Expect(1, 2150, '\P{Is_Joining_Group=__Malayalam_Nnna}', "");
    Expect(0, 2150, '\P{^Is_Joining_Group=__Malayalam_Nnna}', "");
    Error('\p{Is_Jg=_ Malayalam_NNNA/a/}');
    Error('\P{Is_Jg=_ Malayalam_NNNA/a/}');
    Expect(1, 2149, '\p{Is_Jg=malayalamnnna}', "");
    Expect(0, 2149, '\p{^Is_Jg=malayalamnnna}', "");
    Expect(0, 2149, '\P{Is_Jg=malayalamnnna}', "");
    Expect(1, 2149, '\P{^Is_Jg=malayalamnnna}', "");
    Expect(0, 2150, '\p{Is_Jg=malayalamnnna}', "");
    Expect(1, 2150, '\p{^Is_Jg=malayalamnnna}', "");
    Expect(1, 2150, '\P{Is_Jg=malayalamnnna}', "");
    Expect(0, 2150, '\P{^Is_Jg=malayalamnnna}', "");
    Expect(1, 2149, '\p{Is_Jg=_-malayalam_nnna}', "");
    Expect(0, 2149, '\p{^Is_Jg=_-malayalam_nnna}', "");
    Expect(0, 2149, '\P{Is_Jg=_-malayalam_nnna}', "");
    Expect(1, 2149, '\P{^Is_Jg=_-malayalam_nnna}', "");
    Expect(0, 2150, '\p{Is_Jg=_-malayalam_nnna}', "");
    Expect(1, 2150, '\p{^Is_Jg=_-malayalam_nnna}', "");
    Expect(1, 2150, '\P{Is_Jg=_-malayalam_nnna}', "");
    Expect(0, 2150, '\P{^Is_Jg=_-malayalam_nnna}', "");
    Error('\p{Joining_Group=-Malayalam_Nya:=}');
    Error('\P{Joining_Group=-Malayalam_Nya:=}');
    Expect(1, 2146, '\p{Joining_Group=malayalamnya}', "");
    Expect(0, 2146, '\p{^Joining_Group=malayalamnya}', "");
    Expect(0, 2146, '\P{Joining_Group=malayalamnya}', "");
    Expect(1, 2146, '\P{^Joining_Group=malayalamnya}', "");
    Expect(0, 2147, '\p{Joining_Group=malayalamnya}', "");
    Expect(1, 2147, '\p{^Joining_Group=malayalamnya}', "");
    Expect(1, 2147, '\P{Joining_Group=malayalamnya}', "");
    Expect(0, 2147, '\P{^Joining_Group=malayalamnya}', "");
    Expect(1, 2146, '\p{Joining_Group: _Malayalam_Nya}', "");
    Expect(0, 2146, '\p{^Joining_Group: _Malayalam_Nya}', "");
    Expect(0, 2146, '\P{Joining_Group: _Malayalam_Nya}', "");
    Expect(1, 2146, '\P{^Joining_Group: _Malayalam_Nya}', "");
    Expect(0, 2147, '\p{Joining_Group: _Malayalam_Nya}', "");
    Expect(1, 2147, '\p{^Joining_Group: _Malayalam_Nya}', "");
    Expect(1, 2147, '\P{Joining_Group: _Malayalam_Nya}', "");
    Expect(0, 2147, '\P{^Joining_Group: _Malayalam_Nya}', "");
    Error('\p{Jg=-	Malayalam_NYA/a/}');
    Error('\P{Jg=-	Malayalam_NYA/a/}');
    Expect(1, 2146, '\p{Jg=malayalamnya}', "");
    Expect(0, 2146, '\p{^Jg=malayalamnya}', "");
    Expect(0, 2146, '\P{Jg=malayalamnya}', "");
    Expect(1, 2146, '\P{^Jg=malayalamnya}', "");
    Expect(0, 2147, '\p{Jg=malayalamnya}', "");
    Expect(1, 2147, '\p{^Jg=malayalamnya}', "");
    Expect(1, 2147, '\P{Jg=malayalamnya}', "");
    Expect(0, 2147, '\P{^Jg=malayalamnya}', "");
    Expect(1, 2146, '\p{Jg=-_MALAYALAM_Nya}', "");
    Expect(0, 2146, '\p{^Jg=-_MALAYALAM_Nya}', "");
    Expect(0, 2146, '\P{Jg=-_MALAYALAM_Nya}', "");
    Expect(1, 2146, '\P{^Jg=-_MALAYALAM_Nya}', "");
    Expect(0, 2147, '\p{Jg=-_MALAYALAM_Nya}', "");
    Expect(1, 2147, '\p{^Jg=-_MALAYALAM_Nya}', "");
    Expect(1, 2147, '\P{Jg=-_MALAYALAM_Nya}', "");
    Expect(0, 2147, '\P{^Jg=-_MALAYALAM_Nya}', "");
    Error('\p{Is_Joining_Group=:=--MALAYALAM_nya}');
    Error('\P{Is_Joining_Group=:=--MALAYALAM_nya}');
    Expect(1, 2146, '\p{Is_Joining_Group=malayalamnya}', "");
    Expect(0, 2146, '\p{^Is_Joining_Group=malayalamnya}', "");
    Expect(0, 2146, '\P{Is_Joining_Group=malayalamnya}', "");
    Expect(1, 2146, '\P{^Is_Joining_Group=malayalamnya}', "");
    Expect(0, 2147, '\p{Is_Joining_Group=malayalamnya}', "");
    Expect(1, 2147, '\p{^Is_Joining_Group=malayalamnya}', "");
    Expect(1, 2147, '\P{Is_Joining_Group=malayalamnya}', "");
    Expect(0, 2147, '\P{^Is_Joining_Group=malayalamnya}', "");
    Expect(1, 2146, '\p{Is_Joining_Group=_Malayalam_Nya}', "");
    Expect(0, 2146, '\p{^Is_Joining_Group=_Malayalam_Nya}', "");
    Expect(0, 2146, '\P{Is_Joining_Group=_Malayalam_Nya}', "");
    Expect(1, 2146, '\P{^Is_Joining_Group=_Malayalam_Nya}', "");
    Expect(0, 2147, '\p{Is_Joining_Group=_Malayalam_Nya}', "");
    Expect(1, 2147, '\p{^Is_Joining_Group=_Malayalam_Nya}', "");
    Expect(1, 2147, '\P{Is_Joining_Group=_Malayalam_Nya}', "");
    Expect(0, 2147, '\P{^Is_Joining_Group=_Malayalam_Nya}', "");
    Error('\p{Is_Jg=-malayalam_Nya:=}');
    Error('\P{Is_Jg=-malayalam_Nya:=}');
    Expect(1, 2146, '\p{Is_Jg=malayalamnya}', "");
    Expect(0, 2146, '\p{^Is_Jg=malayalamnya}', "");
    Expect(0, 2146, '\P{Is_Jg=malayalamnya}', "");
    Expect(1, 2146, '\P{^Is_Jg=malayalamnya}', "");
    Expect(0, 2147, '\p{Is_Jg=malayalamnya}', "");
    Expect(1, 2147, '\p{^Is_Jg=malayalamnya}', "");
    Expect(1, 2147, '\P{Is_Jg=malayalamnya}', "");
    Expect(0, 2147, '\P{^Is_Jg=malayalamnya}', "");
    Expect(1, 2146, '\p{Is_Jg= malayalam_NYA}', "");
    Expect(0, 2146, '\p{^Is_Jg= malayalam_NYA}', "");
    Expect(0, 2146, '\P{Is_Jg= malayalam_NYA}', "");
    Expect(1, 2146, '\P{^Is_Jg= malayalam_NYA}', "");
    Expect(0, 2147, '\p{Is_Jg= malayalam_NYA}', "");
    Expect(1, 2147, '\p{^Is_Jg= malayalam_NYA}', "");
    Expect(1, 2147, '\P{Is_Jg= malayalam_NYA}', "");
    Expect(0, 2147, '\P{^Is_Jg= malayalam_NYA}', "");
    Error('\p{Joining_Group=:=- malayalam_ra}');
    Error('\P{Joining_Group=:=- malayalam_ra}');
    Expect(1, 2151, '\p{Joining_Group:malayalamra}', "");
    Expect(0, 2151, '\p{^Joining_Group:malayalamra}', "");
    Expect(0, 2151, '\P{Joining_Group:malayalamra}', "");
    Expect(1, 2151, '\P{^Joining_Group:malayalamra}', "");
    Expect(0, 2152, '\p{Joining_Group:malayalamra}', "");
    Expect(1, 2152, '\p{^Joining_Group:malayalamra}', "");
    Expect(1, 2152, '\P{Joining_Group:malayalamra}', "");
    Expect(0, 2152, '\P{^Joining_Group:malayalamra}', "");
    Expect(1, 2151, '\p{Joining_Group= -Malayalam_Ra}', "");
    Expect(0, 2151, '\p{^Joining_Group= -Malayalam_Ra}', "");
    Expect(0, 2151, '\P{Joining_Group= -Malayalam_Ra}', "");
    Expect(1, 2151, '\P{^Joining_Group= -Malayalam_Ra}', "");
    Expect(0, 2152, '\p{Joining_Group= -Malayalam_Ra}', "");
    Expect(1, 2152, '\p{^Joining_Group= -Malayalam_Ra}', "");
    Expect(1, 2152, '\P{Joining_Group= -Malayalam_Ra}', "");
    Expect(0, 2152, '\P{^Joining_Group= -Malayalam_Ra}', "");
    Error('\p{Jg=--Malayalam_Ra/a/}');
    Error('\P{Jg=--Malayalam_Ra/a/}');
    Expect(1, 2151, '\p{Jg=malayalamra}', "");
    Expect(0, 2151, '\p{^Jg=malayalamra}', "");
    Expect(0, 2151, '\P{Jg=malayalamra}', "");
    Expect(1, 2151, '\P{^Jg=malayalamra}', "");
    Expect(0, 2152, '\p{Jg=malayalamra}', "");
    Expect(1, 2152, '\p{^Jg=malayalamra}', "");
    Expect(1, 2152, '\P{Jg=malayalamra}', "");
    Expect(0, 2152, '\P{^Jg=malayalamra}', "");
    Expect(1, 2151, '\p{Jg=_Malayalam_Ra}', "");
    Expect(0, 2151, '\p{^Jg=_Malayalam_Ra}', "");
    Expect(0, 2151, '\P{Jg=_Malayalam_Ra}', "");
    Expect(1, 2151, '\P{^Jg=_Malayalam_Ra}', "");
    Expect(0, 2152, '\p{Jg=_Malayalam_Ra}', "");
    Expect(1, 2152, '\p{^Jg=_Malayalam_Ra}', "");
    Expect(1, 2152, '\P{Jg=_Malayalam_Ra}', "");
    Expect(0, 2152, '\P{^Jg=_Malayalam_Ra}', "");
    Error('\p{Is_Joining_Group=_ malayalam_RA/a/}');
    Error('\P{Is_Joining_Group=_ malayalam_RA/a/}');
    Expect(1, 2151, '\p{Is_Joining_Group=malayalamra}', "");
    Expect(0, 2151, '\p{^Is_Joining_Group=malayalamra}', "");
    Expect(0, 2151, '\P{Is_Joining_Group=malayalamra}', "");
    Expect(1, 2151, '\P{^Is_Joining_Group=malayalamra}', "");
    Expect(0, 2152, '\p{Is_Joining_Group=malayalamra}', "");
    Expect(1, 2152, '\p{^Is_Joining_Group=malayalamra}', "");
    Expect(1, 2152, '\P{Is_Joining_Group=malayalamra}', "");
    Expect(0, 2152, '\P{^Is_Joining_Group=malayalamra}', "");
    Expect(1, 2151, '\p{Is_Joining_Group=	_Malayalam_ra}', "");
    Expect(0, 2151, '\p{^Is_Joining_Group=	_Malayalam_ra}', "");
    Expect(0, 2151, '\P{Is_Joining_Group=	_Malayalam_ra}', "");
    Expect(1, 2151, '\P{^Is_Joining_Group=	_Malayalam_ra}', "");
    Expect(0, 2152, '\p{Is_Joining_Group=	_Malayalam_ra}', "");
    Expect(1, 2152, '\p{^Is_Joining_Group=	_Malayalam_ra}', "");
    Expect(1, 2152, '\P{Is_Joining_Group=	_Malayalam_ra}', "");
    Expect(0, 2152, '\P{^Is_Joining_Group=	_Malayalam_ra}', "");
    Error('\p{Is_Jg=/a/  Malayalam_ra}');
    Error('\P{Is_Jg=/a/  Malayalam_ra}');
    Expect(1, 2151, '\p{Is_Jg=malayalamra}', "");
    Expect(0, 2151, '\p{^Is_Jg=malayalamra}', "");
    Expect(0, 2151, '\P{Is_Jg=malayalamra}', "");
    Expect(1, 2151, '\P{^Is_Jg=malayalamra}', "");
    Expect(0, 2152, '\p{Is_Jg=malayalamra}', "");
    Expect(1, 2152, '\p{^Is_Jg=malayalamra}', "");
    Expect(1, 2152, '\P{Is_Jg=malayalamra}', "");
    Expect(0, 2152, '\P{^Is_Jg=malayalamra}', "");
    Expect(1, 2151, '\p{Is_Jg=		Malayalam_RA}', "");
    Expect(0, 2151, '\p{^Is_Jg=		Malayalam_RA}', "");
    Expect(0, 2151, '\P{Is_Jg=		Malayalam_RA}', "");
    Expect(1, 2151, '\P{^Is_Jg=		Malayalam_RA}', "");
    Expect(0, 2152, '\p{Is_Jg=		Malayalam_RA}', "");
    Expect(1, 2152, '\p{^Is_Jg=		Malayalam_RA}', "");
    Expect(1, 2152, '\P{Is_Jg=		Malayalam_RA}', "");
    Expect(0, 2152, '\P{^Is_Jg=		Malayalam_RA}', "");
    Error('\p{Joining_Group=/a/ -MALAYALAM_Ssa}');
    Error('\P{Joining_Group=/a/ -MALAYALAM_Ssa}');
    Expect(1, 2154, '\p{Joining_Group=malayalamssa}', "");
    Expect(0, 2154, '\p{^Joining_Group=malayalamssa}', "");
    Expect(0, 2154, '\P{Joining_Group=malayalamssa}', "");
    Expect(1, 2154, '\P{^Joining_Group=malayalamssa}', "");
    Expect(0, 2155, '\p{Joining_Group=malayalamssa}', "");
    Expect(1, 2155, '\p{^Joining_Group=malayalamssa}', "");
    Expect(1, 2155, '\P{Joining_Group=malayalamssa}', "");
    Expect(0, 2155, '\P{^Joining_Group=malayalamssa}', "");
    Expect(1, 2154, '\p{Joining_Group= -Malayalam_Ssa}', "");
    Expect(0, 2154, '\p{^Joining_Group= -Malayalam_Ssa}', "");
    Expect(0, 2154, '\P{Joining_Group= -Malayalam_Ssa}', "");
    Expect(1, 2154, '\P{^Joining_Group= -Malayalam_Ssa}', "");
    Expect(0, 2155, '\p{Joining_Group= -Malayalam_Ssa}', "");
    Expect(1, 2155, '\p{^Joining_Group= -Malayalam_Ssa}', "");
    Expect(1, 2155, '\P{Joining_Group= -Malayalam_Ssa}', "");
    Expect(0, 2155, '\P{^Joining_Group= -Malayalam_Ssa}', "");
    Error('\p{Jg=/a/- malayalam_Ssa}');
    Error('\P{Jg=/a/- malayalam_Ssa}');
    Expect(1, 2154, '\p{Jg=malayalamssa}', "");
    Expect(0, 2154, '\p{^Jg=malayalamssa}', "");
    Expect(0, 2154, '\P{Jg=malayalamssa}', "");
    Expect(1, 2154, '\P{^Jg=malayalamssa}', "");
    Expect(0, 2155, '\p{Jg=malayalamssa}', "");
    Expect(1, 2155, '\p{^Jg=malayalamssa}', "");
    Expect(1, 2155, '\P{Jg=malayalamssa}', "");
    Expect(0, 2155, '\P{^Jg=malayalamssa}', "");
    Expect(1, 2154, '\p{Jg=-	MALAYALAM_ssa}', "");
    Expect(0, 2154, '\p{^Jg=-	MALAYALAM_ssa}', "");
    Expect(0, 2154, '\P{Jg=-	MALAYALAM_ssa}', "");
    Expect(1, 2154, '\P{^Jg=-	MALAYALAM_ssa}', "");
    Expect(0, 2155, '\p{Jg=-	MALAYALAM_ssa}', "");
    Expect(1, 2155, '\p{^Jg=-	MALAYALAM_ssa}', "");
    Expect(1, 2155, '\P{Jg=-	MALAYALAM_ssa}', "");
    Expect(0, 2155, '\P{^Jg=-	MALAYALAM_ssa}', "");
    Error('\p{Is_Joining_Group=/a/--Malayalam_SSA}');
    Error('\P{Is_Joining_Group=/a/--Malayalam_SSA}');
    Expect(1, 2154, '\p{Is_Joining_Group=malayalamssa}', "");
    Expect(0, 2154, '\p{^Is_Joining_Group=malayalamssa}', "");
    Expect(0, 2154, '\P{Is_Joining_Group=malayalamssa}', "");
    Expect(1, 2154, '\P{^Is_Joining_Group=malayalamssa}', "");
    Expect(0, 2155, '\p{Is_Joining_Group=malayalamssa}', "");
    Expect(1, 2155, '\p{^Is_Joining_Group=malayalamssa}', "");
    Expect(1, 2155, '\P{Is_Joining_Group=malayalamssa}', "");
    Expect(0, 2155, '\P{^Is_Joining_Group=malayalamssa}', "");
    Expect(1, 2154, '\p{Is_Joining_Group=_	MALAYALAM_Ssa}', "");
    Expect(0, 2154, '\p{^Is_Joining_Group=_	MALAYALAM_Ssa}', "");
    Expect(0, 2154, '\P{Is_Joining_Group=_	MALAYALAM_Ssa}', "");
    Expect(1, 2154, '\P{^Is_Joining_Group=_	MALAYALAM_Ssa}', "");
    Expect(0, 2155, '\p{Is_Joining_Group=_	MALAYALAM_Ssa}', "");
    Expect(1, 2155, '\p{^Is_Joining_Group=_	MALAYALAM_Ssa}', "");
    Expect(1, 2155, '\P{Is_Joining_Group=_	MALAYALAM_Ssa}', "");
    Expect(0, 2155, '\P{^Is_Joining_Group=_	MALAYALAM_Ssa}', "");
    Error('\p{Is_Jg=--Malayalam_Ssa:=}');
    Error('\P{Is_Jg=--Malayalam_Ssa:=}');
    Expect(1, 2154, '\p{Is_Jg=malayalamssa}', "");
    Expect(0, 2154, '\p{^Is_Jg=malayalamssa}', "");
    Expect(0, 2154, '\P{Is_Jg=malayalamssa}', "");
    Expect(1, 2154, '\P{^Is_Jg=malayalamssa}', "");
    Expect(0, 2155, '\p{Is_Jg=malayalamssa}', "");
    Expect(1, 2155, '\p{^Is_Jg=malayalamssa}', "");
    Expect(1, 2155, '\P{Is_Jg=malayalamssa}', "");
    Expect(0, 2155, '\P{^Is_Jg=malayalamssa}', "");
    Expect(1, 2154, '\p{Is_Jg:    malayalam_Ssa}', "");
    Expect(0, 2154, '\p{^Is_Jg:    malayalam_Ssa}', "");
    Expect(0, 2154, '\P{Is_Jg:    malayalam_Ssa}', "");
    Expect(1, 2154, '\P{^Is_Jg:    malayalam_Ssa}', "");
    Expect(0, 2155, '\p{Is_Jg:    malayalam_Ssa}', "");
    Expect(1, 2155, '\p{^Is_Jg:    malayalam_Ssa}', "");
    Expect(1, 2155, '\P{Is_Jg:    malayalam_Ssa}', "");
    Expect(0, 2155, '\P{^Is_Jg:    malayalam_Ssa}', "");
    Error('\p{Joining_Group=	:=MALAYALAM_TTA}');
    Error('\P{Joining_Group=	:=MALAYALAM_TTA}');
    Expect(1, 2147, '\p{Joining_Group=malayalamtta}', "");
    Expect(0, 2147, '\p{^Joining_Group=malayalamtta}', "");
    Expect(0, 2147, '\P{Joining_Group=malayalamtta}', "");
    Expect(1, 2147, '\P{^Joining_Group=malayalamtta}', "");
    Expect(0, 2148, '\p{Joining_Group=malayalamtta}', "");
    Expect(1, 2148, '\p{^Joining_Group=malayalamtta}', "");
    Expect(1, 2148, '\P{Joining_Group=malayalamtta}', "");
    Expect(0, 2148, '\P{^Joining_Group=malayalamtta}', "");
    Expect(1, 2147, '\p{Joining_Group= -Malayalam_Tta}', "");
    Expect(0, 2147, '\p{^Joining_Group= -Malayalam_Tta}', "");
    Expect(0, 2147, '\P{Joining_Group= -Malayalam_Tta}', "");
    Expect(1, 2147, '\P{^Joining_Group= -Malayalam_Tta}', "");
    Expect(0, 2148, '\p{Joining_Group= -Malayalam_Tta}', "");
    Expect(1, 2148, '\p{^Joining_Group= -Malayalam_Tta}', "");
    Expect(1, 2148, '\P{Joining_Group= -Malayalam_Tta}', "");
    Expect(0, 2148, '\P{^Joining_Group= -Malayalam_Tta}', "");
    Error('\p{Jg=-:=malayalam_Tta}');
    Error('\P{Jg=-:=malayalam_Tta}');
    Expect(1, 2147, '\p{Jg=malayalamtta}', "");
    Expect(0, 2147, '\p{^Jg=malayalamtta}', "");
    Expect(0, 2147, '\P{Jg=malayalamtta}', "");
    Expect(1, 2147, '\P{^Jg=malayalamtta}', "");
    Expect(0, 2148, '\p{Jg=malayalamtta}', "");
    Expect(1, 2148, '\p{^Jg=malayalamtta}', "");
    Expect(1, 2148, '\P{Jg=malayalamtta}', "");
    Expect(0, 2148, '\P{^Jg=malayalamtta}', "");
    Expect(1, 2147, '\p{Jg=-MALAYALAM_TTA}', "");
    Expect(0, 2147, '\p{^Jg=-MALAYALAM_TTA}', "");
    Expect(0, 2147, '\P{Jg=-MALAYALAM_TTA}', "");
    Expect(1, 2147, '\P{^Jg=-MALAYALAM_TTA}', "");
    Expect(0, 2148, '\p{Jg=-MALAYALAM_TTA}', "");
    Expect(1, 2148, '\p{^Jg=-MALAYALAM_TTA}', "");
    Expect(1, 2148, '\P{Jg=-MALAYALAM_TTA}', "");
    Expect(0, 2148, '\P{^Jg=-MALAYALAM_TTA}', "");
    Error('\p{Is_Joining_Group=	 Malayalam_Tta:=}');
    Error('\P{Is_Joining_Group=	 Malayalam_Tta:=}');
    Expect(1, 2147, '\p{Is_Joining_Group=malayalamtta}', "");
    Expect(0, 2147, '\p{^Is_Joining_Group=malayalamtta}', "");
    Expect(0, 2147, '\P{Is_Joining_Group=malayalamtta}', "");
    Expect(1, 2147, '\P{^Is_Joining_Group=malayalamtta}', "");
    Expect(0, 2148, '\p{Is_Joining_Group=malayalamtta}', "");
    Expect(1, 2148, '\p{^Is_Joining_Group=malayalamtta}', "");
    Expect(1, 2148, '\P{Is_Joining_Group=malayalamtta}', "");
    Expect(0, 2148, '\P{^Is_Joining_Group=malayalamtta}', "");
    Expect(1, 2147, '\p{Is_Joining_Group=	_Malayalam_TTA}', "");
    Expect(0, 2147, '\p{^Is_Joining_Group=	_Malayalam_TTA}', "");
    Expect(0, 2147, '\P{Is_Joining_Group=	_Malayalam_TTA}', "");
    Expect(1, 2147, '\P{^Is_Joining_Group=	_Malayalam_TTA}', "");
    Expect(0, 2148, '\p{Is_Joining_Group=	_Malayalam_TTA}', "");
    Expect(1, 2148, '\p{^Is_Joining_Group=	_Malayalam_TTA}', "");
    Expect(1, 2148, '\P{Is_Joining_Group=	_Malayalam_TTA}', "");
    Expect(0, 2148, '\P{^Is_Joining_Group=	_Malayalam_TTA}', "");
    Error('\p{Is_Jg:-:=Malayalam_Tta}');
    Error('\P{Is_Jg:-:=Malayalam_Tta}');
    Expect(1, 2147, '\p{Is_Jg: malayalamtta}', "");
    Expect(0, 2147, '\p{^Is_Jg: malayalamtta}', "");
    Expect(0, 2147, '\P{Is_Jg: malayalamtta}', "");
    Expect(1, 2147, '\P{^Is_Jg: malayalamtta}', "");
    Expect(0, 2148, '\p{Is_Jg: malayalamtta}', "");
    Expect(1, 2148, '\p{^Is_Jg: malayalamtta}', "");
    Expect(1, 2148, '\P{Is_Jg: malayalamtta}', "");
    Expect(0, 2148, '\P{^Is_Jg: malayalamtta}', "");
    Expect(1, 2147, '\p{Is_Jg=-Malayalam_Tta}', "");
    Expect(0, 2147, '\p{^Is_Jg=-Malayalam_Tta}', "");
    Expect(0, 2147, '\P{Is_Jg=-Malayalam_Tta}', "");
    Expect(1, 2147, '\P{^Is_Jg=-Malayalam_Tta}', "");
    Expect(0, 2148, '\p{Is_Jg=-Malayalam_Tta}', "");
    Expect(1, 2148, '\p{^Is_Jg=-Malayalam_Tta}', "");
    Expect(1, 2148, '\P{Is_Jg=-Malayalam_Tta}', "");
    Expect(0, 2148, '\P{^Is_Jg=-Malayalam_Tta}', "");
    Error('\p{Joining_Group=/a/ -MANICHAEAN_aleph}');
    Error('\P{Joining_Group=/a/ -MANICHAEAN_aleph}');
    Expect(1, 68288, '\p{Joining_Group=manichaeanaleph}', "");
    Expect(0, 68288, '\p{^Joining_Group=manichaeanaleph}', "");
    Expect(0, 68288, '\P{Joining_Group=manichaeanaleph}', "");
    Expect(1, 68288, '\P{^Joining_Group=manichaeanaleph}', "");
    Expect(0, 68289, '\p{Joining_Group=manichaeanaleph}', "");
    Expect(1, 68289, '\p{^Joining_Group=manichaeanaleph}', "");
    Expect(1, 68289, '\P{Joining_Group=manichaeanaleph}', "");
    Expect(0, 68289, '\P{^Joining_Group=manichaeanaleph}', "");
    Expect(1, 68288, '\p{Joining_Group= MANICHAEAN_ALEPH}', "");
    Expect(0, 68288, '\p{^Joining_Group= MANICHAEAN_ALEPH}', "");
    Expect(0, 68288, '\P{Joining_Group= MANICHAEAN_ALEPH}', "");
    Expect(1, 68288, '\P{^Joining_Group= MANICHAEAN_ALEPH}', "");
    Expect(0, 68289, '\p{Joining_Group= MANICHAEAN_ALEPH}', "");
    Expect(1, 68289, '\p{^Joining_Group= MANICHAEAN_ALEPH}', "");
    Expect(1, 68289, '\P{Joining_Group= MANICHAEAN_ALEPH}', "");
    Expect(0, 68289, '\P{^Joining_Group= MANICHAEAN_ALEPH}', "");
    Error('\p{Jg::=  manichaean_aleph}');
    Error('\P{Jg::=  manichaean_aleph}');
    Expect(1, 68288, '\p{Jg=manichaeanaleph}', "");
    Expect(0, 68288, '\p{^Jg=manichaeanaleph}', "");
    Expect(0, 68288, '\P{Jg=manichaeanaleph}', "");
    Expect(1, 68288, '\P{^Jg=manichaeanaleph}', "");
    Expect(0, 68289, '\p{Jg=manichaeanaleph}', "");
    Expect(1, 68289, '\p{^Jg=manichaeanaleph}', "");
    Expect(1, 68289, '\P{Jg=manichaeanaleph}', "");
    Expect(0, 68289, '\P{^Jg=manichaeanaleph}', "");
    Expect(1, 68288, '\p{Jg:     manichaean_Aleph}', "");
    Expect(0, 68288, '\p{^Jg:     manichaean_Aleph}', "");
    Expect(0, 68288, '\P{Jg:     manichaean_Aleph}', "");
    Expect(1, 68288, '\P{^Jg:     manichaean_Aleph}', "");
    Expect(0, 68289, '\p{Jg:     manichaean_Aleph}', "");
    Expect(1, 68289, '\p{^Jg:     manichaean_Aleph}', "");
    Expect(1, 68289, '\P{Jg:     manichaean_Aleph}', "");
    Expect(0, 68289, '\P{^Jg:     manichaean_Aleph}', "");
    Error('\p{Is_Joining_Group= Manichaean_aleph/a/}');
    Error('\P{Is_Joining_Group= Manichaean_aleph/a/}');
    Expect(1, 68288, '\p{Is_Joining_Group=manichaeanaleph}', "");
    Expect(0, 68288, '\p{^Is_Joining_Group=manichaeanaleph}', "");
    Expect(0, 68288, '\P{Is_Joining_Group=manichaeanaleph}', "");
    Expect(1, 68288, '\P{^Is_Joining_Group=manichaeanaleph}', "");
    Expect(0, 68289, '\p{Is_Joining_Group=manichaeanaleph}', "");
    Expect(1, 68289, '\p{^Is_Joining_Group=manichaeanaleph}', "");
    Expect(1, 68289, '\P{Is_Joining_Group=manichaeanaleph}', "");
    Expect(0, 68289, '\P{^Is_Joining_Group=manichaeanaleph}', "");
    Expect(1, 68288, '\p{Is_Joining_Group=_Manichaean_ALEPH}', "");
    Expect(0, 68288, '\p{^Is_Joining_Group=_Manichaean_ALEPH}', "");
    Expect(0, 68288, '\P{Is_Joining_Group=_Manichaean_ALEPH}', "");
    Expect(1, 68288, '\P{^Is_Joining_Group=_Manichaean_ALEPH}', "");
    Expect(0, 68289, '\p{Is_Joining_Group=_Manichaean_ALEPH}', "");
    Expect(1, 68289, '\p{^Is_Joining_Group=_Manichaean_ALEPH}', "");
    Expect(1, 68289, '\P{Is_Joining_Group=_Manichaean_ALEPH}', "");
    Expect(0, 68289, '\P{^Is_Joining_Group=_Manichaean_ALEPH}', "");
    Error('\p{Is_Jg=/a/  MANICHAEAN_aleph}');
    Error('\P{Is_Jg=/a/  MANICHAEAN_aleph}');
    Expect(1, 68288, '\p{Is_Jg:   manichaeanaleph}', "");
    Expect(0, 68288, '\p{^Is_Jg:   manichaeanaleph}', "");
    Expect(0, 68288, '\P{Is_Jg:   manichaeanaleph}', "");
    Expect(1, 68288, '\P{^Is_Jg:   manichaeanaleph}', "");
    Expect(0, 68289, '\p{Is_Jg:   manichaeanaleph}', "");
    Expect(1, 68289, '\p{^Is_Jg:   manichaeanaleph}', "");
    Expect(1, 68289, '\P{Is_Jg:   manichaeanaleph}', "");
    Expect(0, 68289, '\P{^Is_Jg:   manichaeanaleph}', "");
    Expect(1, 68288, '\p{Is_Jg=manichaean_aleph}', "");
    Expect(0, 68288, '\p{^Is_Jg=manichaean_aleph}', "");
    Expect(0, 68288, '\P{Is_Jg=manichaean_aleph}', "");
    Expect(1, 68288, '\P{^Is_Jg=manichaean_aleph}', "");
    Expect(0, 68289, '\p{Is_Jg=manichaean_aleph}', "");
    Expect(1, 68289, '\p{^Is_Jg=manichaean_aleph}', "");
    Expect(1, 68289, '\P{Is_Jg=manichaean_aleph}', "");
    Expect(0, 68289, '\P{^Is_Jg=manichaean_aleph}', "");
    Error('\p{Joining_Group=/a/	_MANICHAEAN_Ayin}');
    Error('\P{Joining_Group=/a/	_MANICHAEAN_Ayin}');
    Expect(1, 68314, '\p{Joining_Group=manichaeanayin}', "");
    Expect(0, 68314, '\p{^Joining_Group=manichaeanayin}', "");
    Expect(0, 68314, '\P{Joining_Group=manichaeanayin}', "");
    Expect(1, 68314, '\P{^Joining_Group=manichaeanayin}', "");
    Expect(0, 68315, '\p{Joining_Group=manichaeanayin}', "");
    Expect(1, 68315, '\p{^Joining_Group=manichaeanayin}', "");
    Expect(1, 68315, '\P{Joining_Group=manichaeanayin}', "");
    Expect(0, 68315, '\P{^Joining_Group=manichaeanayin}', "");
    Expect(1, 68314, '\p{Joining_Group=	_Manichaean_ayin}', "");
    Expect(0, 68314, '\p{^Joining_Group=	_Manichaean_ayin}', "");
    Expect(0, 68314, '\P{Joining_Group=	_Manichaean_ayin}', "");
    Expect(1, 68314, '\P{^Joining_Group=	_Manichaean_ayin}', "");
    Expect(0, 68315, '\p{Joining_Group=	_Manichaean_ayin}', "");
    Expect(1, 68315, '\p{^Joining_Group=	_Manichaean_ayin}', "");
    Expect(1, 68315, '\P{Joining_Group=	_Manichaean_ayin}', "");
    Expect(0, 68315, '\P{^Joining_Group=	_Manichaean_ayin}', "");
    Error('\p{Jg=:=_Manichaean_AYIN}');
    Error('\P{Jg=:=_Manichaean_AYIN}');
    Expect(1, 68314, '\p{Jg=manichaeanayin}', "");
    Expect(0, 68314, '\p{^Jg=manichaeanayin}', "");
    Expect(0, 68314, '\P{Jg=manichaeanayin}', "");
    Expect(1, 68314, '\P{^Jg=manichaeanayin}', "");
    Expect(0, 68315, '\p{Jg=manichaeanayin}', "");
    Expect(1, 68315, '\p{^Jg=manichaeanayin}', "");
    Expect(1, 68315, '\P{Jg=manichaeanayin}', "");
    Expect(0, 68315, '\P{^Jg=manichaeanayin}', "");
    Expect(1, 68314, '\p{Jg= -MANICHAEAN_Ayin}', "");
    Expect(0, 68314, '\p{^Jg= -MANICHAEAN_Ayin}', "");
    Expect(0, 68314, '\P{Jg= -MANICHAEAN_Ayin}', "");
    Expect(1, 68314, '\P{^Jg= -MANICHAEAN_Ayin}', "");
    Expect(0, 68315, '\p{Jg= -MANICHAEAN_Ayin}', "");
    Expect(1, 68315, '\p{^Jg= -MANICHAEAN_Ayin}', "");
    Expect(1, 68315, '\P{Jg= -MANICHAEAN_Ayin}', "");
    Expect(0, 68315, '\P{^Jg= -MANICHAEAN_Ayin}', "");
    Error('\p{Is_Joining_Group: -MANICHAEAN_Ayin/a/}');
    Error('\P{Is_Joining_Group: -MANICHAEAN_Ayin/a/}');
    Expect(1, 68314, '\p{Is_Joining_Group=manichaeanayin}', "");
    Expect(0, 68314, '\p{^Is_Joining_Group=manichaeanayin}', "");
    Expect(0, 68314, '\P{Is_Joining_Group=manichaeanayin}', "");
    Expect(1, 68314, '\P{^Is_Joining_Group=manichaeanayin}', "");
    Expect(0, 68315, '\p{Is_Joining_Group=manichaeanayin}', "");
    Expect(1, 68315, '\p{^Is_Joining_Group=manichaeanayin}', "");
    Expect(1, 68315, '\P{Is_Joining_Group=manichaeanayin}', "");
    Expect(0, 68315, '\P{^Is_Joining_Group=manichaeanayin}', "");
    Expect(1, 68314, '\p{Is_Joining_Group=	 manichaean_AYIN}', "");
    Expect(0, 68314, '\p{^Is_Joining_Group=	 manichaean_AYIN}', "");
    Expect(0, 68314, '\P{Is_Joining_Group=	 manichaean_AYIN}', "");
    Expect(1, 68314, '\P{^Is_Joining_Group=	 manichaean_AYIN}', "");
    Expect(0, 68315, '\p{Is_Joining_Group=	 manichaean_AYIN}', "");
    Expect(1, 68315, '\p{^Is_Joining_Group=	 manichaean_AYIN}', "");
    Expect(1, 68315, '\P{Is_Joining_Group=	 manichaean_AYIN}', "");
    Expect(0, 68315, '\P{^Is_Joining_Group=	 manichaean_AYIN}', "");
    Error('\p{Is_Jg: /a/_ Manichaean_ayin}');
    Error('\P{Is_Jg: /a/_ Manichaean_ayin}');
    Expect(1, 68314, '\p{Is_Jg=manichaeanayin}', "");
    Expect(0, 68314, '\p{^Is_Jg=manichaeanayin}', "");
    Expect(0, 68314, '\P{Is_Jg=manichaeanayin}', "");
    Expect(1, 68314, '\P{^Is_Jg=manichaeanayin}', "");
    Expect(0, 68315, '\p{Is_Jg=manichaeanayin}', "");
    Expect(1, 68315, '\p{^Is_Jg=manichaeanayin}', "");
    Expect(1, 68315, '\P{Is_Jg=manichaeanayin}', "");
    Expect(0, 68315, '\P{^Is_Jg=manichaeanayin}', "");
    Expect(1, 68314, '\p{Is_Jg=Manichaean_Ayin}', "");
    Expect(0, 68314, '\p{^Is_Jg=Manichaean_Ayin}', "");
    Expect(0, 68314, '\P{Is_Jg=Manichaean_Ayin}', "");
    Expect(1, 68314, '\P{^Is_Jg=Manichaean_Ayin}', "");
    Expect(0, 68315, '\p{Is_Jg=Manichaean_Ayin}', "");
    Expect(1, 68315, '\p{^Is_Jg=Manichaean_Ayin}', "");
    Expect(1, 68315, '\P{Is_Jg=Manichaean_Ayin}', "");
    Expect(0, 68315, '\P{^Is_Jg=Manichaean_Ayin}', "");
    Error('\p{Joining_Group:    /a/Manichaean_Beth}');
    Error('\P{Joining_Group:    /a/Manichaean_Beth}');
    Expect(1, 68290, '\p{Joining_Group=manichaeanbeth}', "");
    Expect(0, 68290, '\p{^Joining_Group=manichaeanbeth}', "");
    Expect(0, 68290, '\P{Joining_Group=manichaeanbeth}', "");
    Expect(1, 68290, '\P{^Joining_Group=manichaeanbeth}', "");
    Expect(0, 68291, '\p{Joining_Group=manichaeanbeth}', "");
    Expect(1, 68291, '\p{^Joining_Group=manichaeanbeth}', "");
    Expect(1, 68291, '\P{Joining_Group=manichaeanbeth}', "");
    Expect(0, 68291, '\P{^Joining_Group=manichaeanbeth}', "");
    Expect(1, 68290, '\p{Joining_Group=_Manichaean_BETH}', "");
    Expect(0, 68290, '\p{^Joining_Group=_Manichaean_BETH}', "");
    Expect(0, 68290, '\P{Joining_Group=_Manichaean_BETH}', "");
    Expect(1, 68290, '\P{^Joining_Group=_Manichaean_BETH}', "");
    Expect(0, 68291, '\p{Joining_Group=_Manichaean_BETH}', "");
    Expect(1, 68291, '\p{^Joining_Group=_Manichaean_BETH}', "");
    Expect(1, 68291, '\P{Joining_Group=_Manichaean_BETH}', "");
    Expect(0, 68291, '\P{^Joining_Group=_Manichaean_BETH}', "");
    Error('\p{Jg=/a/ _Manichaean_Beth}');
    Error('\P{Jg=/a/ _Manichaean_Beth}');
    Expect(1, 68290, '\p{Jg:	manichaeanbeth}', "");
    Expect(0, 68290, '\p{^Jg:	manichaeanbeth}', "");
    Expect(0, 68290, '\P{Jg:	manichaeanbeth}', "");
    Expect(1, 68290, '\P{^Jg:	manichaeanbeth}', "");
    Expect(0, 68291, '\p{Jg:	manichaeanbeth}', "");
    Expect(1, 68291, '\p{^Jg:	manichaeanbeth}', "");
    Expect(1, 68291, '\P{Jg:	manichaeanbeth}', "");
    Expect(0, 68291, '\P{^Jg:	manichaeanbeth}', "");
    Expect(1, 68290, '\p{Jg= _manichaean_beth}', "");
    Expect(0, 68290, '\p{^Jg= _manichaean_beth}', "");
    Expect(0, 68290, '\P{Jg= _manichaean_beth}', "");
    Expect(1, 68290, '\P{^Jg= _manichaean_beth}', "");
    Expect(0, 68291, '\p{Jg= _manichaean_beth}', "");
    Expect(1, 68291, '\p{^Jg= _manichaean_beth}', "");
    Expect(1, 68291, '\P{Jg= _manichaean_beth}', "");
    Expect(0, 68291, '\P{^Jg= _manichaean_beth}', "");
    Error('\p{Is_Joining_Group=Manichaean_Beth:=}');
    Error('\P{Is_Joining_Group=Manichaean_Beth:=}');
    Expect(1, 68290, '\p{Is_Joining_Group=manichaeanbeth}', "");
    Expect(0, 68290, '\p{^Is_Joining_Group=manichaeanbeth}', "");
    Expect(0, 68290, '\P{Is_Joining_Group=manichaeanbeth}', "");
    Expect(1, 68290, '\P{^Is_Joining_Group=manichaeanbeth}', "");
    Expect(0, 68291, '\p{Is_Joining_Group=manichaeanbeth}', "");
    Expect(1, 68291, '\p{^Is_Joining_Group=manichaeanbeth}', "");
    Expect(1, 68291, '\P{Is_Joining_Group=manichaeanbeth}', "");
    Expect(0, 68291, '\P{^Is_Joining_Group=manichaeanbeth}', "");
    Expect(1, 68290, '\p{Is_Joining_Group=_manichaean_Beth}', "");
    Expect(0, 68290, '\p{^Is_Joining_Group=_manichaean_Beth}', "");
    Expect(0, 68290, '\P{Is_Joining_Group=_manichaean_Beth}', "");
    Expect(1, 68290, '\P{^Is_Joining_Group=_manichaean_Beth}', "");
    Expect(0, 68291, '\p{Is_Joining_Group=_manichaean_Beth}', "");
    Expect(1, 68291, '\p{^Is_Joining_Group=_manichaean_Beth}', "");
    Expect(1, 68291, '\P{Is_Joining_Group=_manichaean_Beth}', "");
    Expect(0, 68291, '\P{^Is_Joining_Group=_manichaean_Beth}', "");
    Error('\p{Is_Jg=/a/__Manichaean_beth}');
    Error('\P{Is_Jg=/a/__Manichaean_beth}');
    Expect(1, 68290, '\p{Is_Jg=manichaeanbeth}', "");
    Expect(0, 68290, '\p{^Is_Jg=manichaeanbeth}', "");
    Expect(0, 68290, '\P{Is_Jg=manichaeanbeth}', "");
    Expect(1, 68290, '\P{^Is_Jg=manichaeanbeth}', "");
    Expect(0, 68291, '\p{Is_Jg=manichaeanbeth}', "");
    Expect(1, 68291, '\p{^Is_Jg=manichaeanbeth}', "");
    Expect(1, 68291, '\P{Is_Jg=manichaeanbeth}', "");
    Expect(0, 68291, '\P{^Is_Jg=manichaeanbeth}', "");
    Expect(1, 68290, '\p{Is_Jg= -MANICHAEAN_Beth}', "");
    Expect(0, 68290, '\p{^Is_Jg= -MANICHAEAN_Beth}', "");
    Expect(0, 68290, '\P{Is_Jg= -MANICHAEAN_Beth}', "");
    Expect(1, 68290, '\P{^Is_Jg= -MANICHAEAN_Beth}', "");
    Expect(0, 68291, '\p{Is_Jg= -MANICHAEAN_Beth}', "");
    Expect(1, 68291, '\p{^Is_Jg= -MANICHAEAN_Beth}', "");
    Expect(1, 68291, '\P{Is_Jg= -MANICHAEAN_Beth}', "");
    Expect(0, 68291, '\P{^Is_Jg= -MANICHAEAN_Beth}', "");
    Error('\p{Joining_Group=	-Manichaean_Daleth/a/}');
    Error('\P{Joining_Group=	-Manichaean_Daleth/a/}');
    Expect(1, 68293, '\p{Joining_Group:	manichaeandaleth}', "");
    Expect(0, 68293, '\p{^Joining_Group:	manichaeandaleth}', "");
    Expect(0, 68293, '\P{Joining_Group:	manichaeandaleth}', "");
    Expect(1, 68293, '\P{^Joining_Group:	manichaeandaleth}', "");
    Expect(0, 68294, '\p{Joining_Group:	manichaeandaleth}', "");
    Expect(1, 68294, '\p{^Joining_Group:	manichaeandaleth}', "");
    Expect(1, 68294, '\P{Joining_Group:	manichaeandaleth}', "");
    Expect(0, 68294, '\P{^Joining_Group:	manichaeandaleth}', "");
    Expect(1, 68293, '\p{Joining_Group=	Manichaean_Daleth}', "");
    Expect(0, 68293, '\p{^Joining_Group=	Manichaean_Daleth}', "");
    Expect(0, 68293, '\P{Joining_Group=	Manichaean_Daleth}', "");
    Expect(1, 68293, '\P{^Joining_Group=	Manichaean_Daleth}', "");
    Expect(0, 68294, '\p{Joining_Group=	Manichaean_Daleth}', "");
    Expect(1, 68294, '\p{^Joining_Group=	Manichaean_Daleth}', "");
    Expect(1, 68294, '\P{Joining_Group=	Manichaean_Daleth}', "");
    Expect(0, 68294, '\P{^Joining_Group=	Manichaean_Daleth}', "");
    Error('\p{Jg=:=	-MANICHAEAN_Daleth}');
    Error('\P{Jg=:=	-MANICHAEAN_Daleth}');
    Expect(1, 68293, '\p{Jg=manichaeandaleth}', "");
    Expect(0, 68293, '\p{^Jg=manichaeandaleth}', "");
    Expect(0, 68293, '\P{Jg=manichaeandaleth}', "");
    Expect(1, 68293, '\P{^Jg=manichaeandaleth}', "");
    Expect(0, 68294, '\p{Jg=manichaeandaleth}', "");
    Expect(1, 68294, '\p{^Jg=manichaeandaleth}', "");
    Expect(1, 68294, '\P{Jg=manichaeandaleth}', "");
    Expect(0, 68294, '\P{^Jg=manichaeandaleth}', "");
    Expect(1, 68293, '\p{Jg=	-Manichaean_daleth}', "");
    Expect(0, 68293, '\p{^Jg=	-Manichaean_daleth}', "");
    Expect(0, 68293, '\P{Jg=	-Manichaean_daleth}', "");
    Expect(1, 68293, '\P{^Jg=	-Manichaean_daleth}', "");
    Expect(0, 68294, '\p{Jg=	-Manichaean_daleth}', "");
    Expect(1, 68294, '\p{^Jg=	-Manichaean_daleth}', "");
    Expect(1, 68294, '\P{Jg=	-Manichaean_daleth}', "");
    Expect(0, 68294, '\P{^Jg=	-Manichaean_daleth}', "");
    Error('\p{Is_Joining_Group:/a/-manichaean_Daleth}');
    Error('\P{Is_Joining_Group:/a/-manichaean_Daleth}');
    Expect(1, 68293, '\p{Is_Joining_Group=manichaeandaleth}', "");
    Expect(0, 68293, '\p{^Is_Joining_Group=manichaeandaleth}', "");
    Expect(0, 68293, '\P{Is_Joining_Group=manichaeandaleth}', "");
    Expect(1, 68293, '\P{^Is_Joining_Group=manichaeandaleth}', "");
    Expect(0, 68294, '\p{Is_Joining_Group=manichaeandaleth}', "");
    Expect(1, 68294, '\p{^Is_Joining_Group=manichaeandaleth}', "");
    Expect(1, 68294, '\P{Is_Joining_Group=manichaeandaleth}', "");
    Expect(0, 68294, '\P{^Is_Joining_Group=manichaeandaleth}', "");
    Expect(1, 68293, '\p{Is_Joining_Group= -Manichaean_Daleth}', "");
    Expect(0, 68293, '\p{^Is_Joining_Group= -Manichaean_Daleth}', "");
    Expect(0, 68293, '\P{Is_Joining_Group= -Manichaean_Daleth}', "");
    Expect(1, 68293, '\P{^Is_Joining_Group= -Manichaean_Daleth}', "");
    Expect(0, 68294, '\p{Is_Joining_Group= -Manichaean_Daleth}', "");
    Expect(1, 68294, '\p{^Is_Joining_Group= -Manichaean_Daleth}', "");
    Expect(1, 68294, '\P{Is_Joining_Group= -Manichaean_Daleth}', "");
    Expect(0, 68294, '\P{^Is_Joining_Group= -Manichaean_Daleth}', "");
    Error('\p{Is_Jg=:=-Manichaean_DALETH}');
    Error('\P{Is_Jg=:=-Manichaean_DALETH}');
    Expect(1, 68293, '\p{Is_Jg=manichaeandaleth}', "");
    Expect(0, 68293, '\p{^Is_Jg=manichaeandaleth}', "");
    Expect(0, 68293, '\P{Is_Jg=manichaeandaleth}', "");
    Expect(1, 68293, '\P{^Is_Jg=manichaeandaleth}', "");
    Expect(0, 68294, '\p{Is_Jg=manichaeandaleth}', "");
    Expect(1, 68294, '\p{^Is_Jg=manichaeandaleth}', "");
    Expect(1, 68294, '\P{Is_Jg=manichaeandaleth}', "");
    Expect(0, 68294, '\P{^Is_Jg=manichaeandaleth}', "");
    Expect(1, 68293, '\p{Is_Jg:Manichaean_DALETH}', "");
    Expect(0, 68293, '\p{^Is_Jg:Manichaean_DALETH}', "");
    Expect(0, 68293, '\P{Is_Jg:Manichaean_DALETH}', "");
    Expect(1, 68293, '\P{^Is_Jg:Manichaean_DALETH}', "");
    Expect(0, 68294, '\p{Is_Jg:Manichaean_DALETH}', "");
    Expect(1, 68294, '\p{^Is_Jg:Manichaean_DALETH}', "");
    Expect(1, 68294, '\P{Is_Jg:Manichaean_DALETH}', "");
    Expect(0, 68294, '\P{^Is_Jg:Manichaean_DALETH}', "");
    Error('\p{Joining_Group=:=- MANICHAEAN_DHAMEDH}');
    Error('\P{Joining_Group=:=- MANICHAEAN_DHAMEDH}');
    Expect(1, 68308, '\p{Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68308, '\p{^Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68308, '\P{Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68308, '\P{^Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68309, '\p{Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68309, '\p{^Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68309, '\P{Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68309, '\P{^Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68308, '\p{Joining_Group=	 MANICHAEAN_Dhamedh}', "");
    Expect(0, 68308, '\p{^Joining_Group=	 MANICHAEAN_Dhamedh}', "");
    Expect(0, 68308, '\P{Joining_Group=	 MANICHAEAN_Dhamedh}', "");
    Expect(1, 68308, '\P{^Joining_Group=	 MANICHAEAN_Dhamedh}', "");
    Expect(0, 68309, '\p{Joining_Group=	 MANICHAEAN_Dhamedh}', "");
    Expect(1, 68309, '\p{^Joining_Group=	 MANICHAEAN_Dhamedh}', "");
    Expect(1, 68309, '\P{Joining_Group=	 MANICHAEAN_Dhamedh}', "");
    Expect(0, 68309, '\P{^Joining_Group=	 MANICHAEAN_Dhamedh}', "");
    Error('\p{Jg:  	manichaean_DHAMEDH/a/}');
    Error('\P{Jg:  	manichaean_DHAMEDH/a/}');
    Expect(1, 68308, '\p{Jg=manichaeandhamedh}', "");
    Expect(0, 68308, '\p{^Jg=manichaeandhamedh}', "");
    Expect(0, 68308, '\P{Jg=manichaeandhamedh}', "");
    Expect(1, 68308, '\P{^Jg=manichaeandhamedh}', "");
    Expect(0, 68309, '\p{Jg=manichaeandhamedh}', "");
    Expect(1, 68309, '\p{^Jg=manichaeandhamedh}', "");
    Expect(1, 68309, '\P{Jg=manichaeandhamedh}', "");
    Expect(0, 68309, '\P{^Jg=manichaeandhamedh}', "");
    Expect(1, 68308, '\p{Jg:  	MANICHAEAN_dhamedh}', "");
    Expect(0, 68308, '\p{^Jg:  	MANICHAEAN_dhamedh}', "");
    Expect(0, 68308, '\P{Jg:  	MANICHAEAN_dhamedh}', "");
    Expect(1, 68308, '\P{^Jg:  	MANICHAEAN_dhamedh}', "");
    Expect(0, 68309, '\p{Jg:  	MANICHAEAN_dhamedh}', "");
    Expect(1, 68309, '\p{^Jg:  	MANICHAEAN_dhamedh}', "");
    Expect(1, 68309, '\P{Jg:  	MANICHAEAN_dhamedh}', "");
    Expect(0, 68309, '\P{^Jg:  	MANICHAEAN_dhamedh}', "");
    Error('\p{Is_Joining_Group=-:=MANICHAEAN_DHAMEDH}');
    Error('\P{Is_Joining_Group=-:=MANICHAEAN_DHAMEDH}');
    Expect(1, 68308, '\p{Is_Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68308, '\p{^Is_Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68308, '\P{Is_Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68308, '\P{^Is_Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68309, '\p{Is_Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68309, '\p{^Is_Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68309, '\P{Is_Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68309, '\P{^Is_Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68308, '\p{Is_Joining_Group=-_MANICHAEAN_Dhamedh}', "");
    Expect(0, 68308, '\p{^Is_Joining_Group=-_MANICHAEAN_Dhamedh}', "");
    Expect(0, 68308, '\P{Is_Joining_Group=-_MANICHAEAN_Dhamedh}', "");
    Expect(1, 68308, '\P{^Is_Joining_Group=-_MANICHAEAN_Dhamedh}', "");
    Expect(0, 68309, '\p{Is_Joining_Group=-_MANICHAEAN_Dhamedh}', "");
    Expect(1, 68309, '\p{^Is_Joining_Group=-_MANICHAEAN_Dhamedh}', "");
    Expect(1, 68309, '\P{Is_Joining_Group=-_MANICHAEAN_Dhamedh}', "");
    Expect(0, 68309, '\P{^Is_Joining_Group=-_MANICHAEAN_Dhamedh}', "");
    Error('\p{Is_Jg:	-_Manichaean_dhamedh/a/}');
    Error('\P{Is_Jg:	-_Manichaean_dhamedh/a/}');
    Expect(1, 68308, '\p{Is_Jg=manichaeandhamedh}', "");
    Expect(0, 68308, '\p{^Is_Jg=manichaeandhamedh}', "");
    Expect(0, 68308, '\P{Is_Jg=manichaeandhamedh}', "");
    Expect(1, 68308, '\P{^Is_Jg=manichaeandhamedh}', "");
    Expect(0, 68309, '\p{Is_Jg=manichaeandhamedh}', "");
    Expect(1, 68309, '\p{^Is_Jg=manichaeandhamedh}', "");
    Expect(1, 68309, '\P{Is_Jg=manichaeandhamedh}', "");
    Expect(0, 68309, '\P{^Is_Jg=manichaeandhamedh}', "");
    Expect(1, 68308, '\p{Is_Jg=		MANICHAEAN_Dhamedh}', "");
    Expect(0, 68308, '\p{^Is_Jg=		MANICHAEAN_Dhamedh}', "");
    Expect(0, 68308, '\P{Is_Jg=		MANICHAEAN_Dhamedh}', "");
    Expect(1, 68308, '\P{^Is_Jg=		MANICHAEAN_Dhamedh}', "");
    Expect(0, 68309, '\p{Is_Jg=		MANICHAEAN_Dhamedh}', "");
    Expect(1, 68309, '\p{^Is_Jg=		MANICHAEAN_Dhamedh}', "");
    Expect(1, 68309, '\P{Is_Jg=		MANICHAEAN_Dhamedh}', "");
    Expect(0, 68309, '\P{^Is_Jg=		MANICHAEAN_Dhamedh}', "");
    Error('\p{Joining_Group= MANICHAEAN_Five:=}');
    Error('\P{Joining_Group= MANICHAEAN_Five:=}');
    Expect(1, 68332, '\p{Joining_Group: manichaeanfive}', "");
    Expect(0, 68332, '\p{^Joining_Group: manichaeanfive}', "");
    Expect(0, 68332, '\P{Joining_Group: manichaeanfive}', "");
    Expect(1, 68332, '\P{^Joining_Group: manichaeanfive}', "");
    Expect(0, 68333, '\p{Joining_Group: manichaeanfive}', "");
    Expect(1, 68333, '\p{^Joining_Group: manichaeanfive}', "");
    Expect(1, 68333, '\P{Joining_Group: manichaeanfive}', "");
    Expect(0, 68333, '\P{^Joining_Group: manichaeanfive}', "");
    Expect(1, 68332, '\p{Joining_Group=	manichaean_Five}', "");
    Expect(0, 68332, '\p{^Joining_Group=	manichaean_Five}', "");
    Expect(0, 68332, '\P{Joining_Group=	manichaean_Five}', "");
    Expect(1, 68332, '\P{^Joining_Group=	manichaean_Five}', "");
    Expect(0, 68333, '\p{Joining_Group=	manichaean_Five}', "");
    Expect(1, 68333, '\p{^Joining_Group=	manichaean_Five}', "");
    Expect(1, 68333, '\P{Joining_Group=	manichaean_Five}', "");
    Expect(0, 68333, '\P{^Joining_Group=	manichaean_Five}', "");
    Error('\p{Jg= /a/manichaean_five}');
    Error('\P{Jg= /a/manichaean_five}');
    Expect(1, 68332, '\p{Jg=manichaeanfive}', "");
    Expect(0, 68332, '\p{^Jg=manichaeanfive}', "");
    Expect(0, 68332, '\P{Jg=manichaeanfive}', "");
    Expect(1, 68332, '\P{^Jg=manichaeanfive}', "");
    Expect(0, 68333, '\p{Jg=manichaeanfive}', "");
    Expect(1, 68333, '\p{^Jg=manichaeanfive}', "");
    Expect(1, 68333, '\P{Jg=manichaeanfive}', "");
    Expect(0, 68333, '\P{^Jg=manichaeanfive}', "");
    Expect(1, 68332, '\p{Jg:	__Manichaean_FIVE}', "");
    Expect(0, 68332, '\p{^Jg:	__Manichaean_FIVE}', "");
    Expect(0, 68332, '\P{Jg:	__Manichaean_FIVE}', "");
    Expect(1, 68332, '\P{^Jg:	__Manichaean_FIVE}', "");
    Expect(0, 68333, '\p{Jg:	__Manichaean_FIVE}', "");
    Expect(1, 68333, '\p{^Jg:	__Manichaean_FIVE}', "");
    Expect(1, 68333, '\P{Jg:	__Manichaean_FIVE}', "");
    Expect(0, 68333, '\P{^Jg:	__Manichaean_FIVE}', "");
    Error('\p{Is_Joining_Group=_Manichaean_FIVE/a/}');
    Error('\P{Is_Joining_Group=_Manichaean_FIVE/a/}');
    Expect(1, 68332, '\p{Is_Joining_Group=manichaeanfive}', "");
    Expect(0, 68332, '\p{^Is_Joining_Group=manichaeanfive}', "");
    Expect(0, 68332, '\P{Is_Joining_Group=manichaeanfive}', "");
    Expect(1, 68332, '\P{^Is_Joining_Group=manichaeanfive}', "");
    Expect(0, 68333, '\p{Is_Joining_Group=manichaeanfive}', "");
    Expect(1, 68333, '\p{^Is_Joining_Group=manichaeanfive}', "");
    Expect(1, 68333, '\P{Is_Joining_Group=manichaeanfive}', "");
    Expect(0, 68333, '\P{^Is_Joining_Group=manichaeanfive}', "");
    Expect(1, 68332, '\p{Is_Joining_Group=	-Manichaean_FIVE}', "");
    Expect(0, 68332, '\p{^Is_Joining_Group=	-Manichaean_FIVE}', "");
    Expect(0, 68332, '\P{Is_Joining_Group=	-Manichaean_FIVE}', "");
    Expect(1, 68332, '\P{^Is_Joining_Group=	-Manichaean_FIVE}', "");
    Expect(0, 68333, '\p{Is_Joining_Group=	-Manichaean_FIVE}', "");
    Expect(1, 68333, '\p{^Is_Joining_Group=	-Manichaean_FIVE}', "");
    Expect(1, 68333, '\P{Is_Joining_Group=	-Manichaean_FIVE}', "");
    Expect(0, 68333, '\P{^Is_Joining_Group=	-Manichaean_FIVE}', "");
    Error('\p{Is_Jg=manichaean_FIVE/a/}');
    Error('\P{Is_Jg=manichaean_FIVE/a/}');
    Expect(1, 68332, '\p{Is_Jg:manichaeanfive}', "");
    Expect(0, 68332, '\p{^Is_Jg:manichaeanfive}', "");
    Expect(0, 68332, '\P{Is_Jg:manichaeanfive}', "");
    Expect(1, 68332, '\P{^Is_Jg:manichaeanfive}', "");
    Expect(0, 68333, '\p{Is_Jg:manichaeanfive}', "");
    Expect(1, 68333, '\p{^Is_Jg:manichaeanfive}', "");
    Expect(1, 68333, '\P{Is_Jg:manichaeanfive}', "");
    Expect(0, 68333, '\P{^Is_Jg:manichaeanfive}', "");
    Expect(1, 68332, '\p{Is_Jg= _Manichaean_five}', "");
    Expect(0, 68332, '\p{^Is_Jg= _Manichaean_five}', "");
    Expect(0, 68332, '\P{Is_Jg= _Manichaean_five}', "");
    Expect(1, 68332, '\P{^Is_Jg= _Manichaean_five}', "");
    Expect(0, 68333, '\p{Is_Jg= _Manichaean_five}', "");
    Expect(1, 68333, '\p{^Is_Jg= _Manichaean_five}', "");
    Expect(1, 68333, '\P{Is_Jg= _Manichaean_five}', "");
    Expect(0, 68333, '\P{^Is_Jg= _Manichaean_five}', "");
    Error('\p{Joining_Group=	manichaean_Gimel/a/}');
    Error('\P{Joining_Group=	manichaean_Gimel/a/}');
    Expect(1, 68292, '\p{Joining_Group=manichaeangimel}', "");
    Expect(0, 68292, '\p{^Joining_Group=manichaeangimel}', "");
    Expect(0, 68292, '\P{Joining_Group=manichaeangimel}', "");
    Expect(1, 68292, '\P{^Joining_Group=manichaeangimel}', "");
    Expect(0, 68293, '\p{Joining_Group=manichaeangimel}', "");
    Expect(1, 68293, '\p{^Joining_Group=manichaeangimel}', "");
    Expect(1, 68293, '\P{Joining_Group=manichaeangimel}', "");
    Expect(0, 68293, '\P{^Joining_Group=manichaeangimel}', "");
    Expect(1, 68292, '\p{Joining_Group=-	manichaean_gimel}', "");
    Expect(0, 68292, '\p{^Joining_Group=-	manichaean_gimel}', "");
    Expect(0, 68292, '\P{Joining_Group=-	manichaean_gimel}', "");
    Expect(1, 68292, '\P{^Joining_Group=-	manichaean_gimel}', "");
    Expect(0, 68293, '\p{Joining_Group=-	manichaean_gimel}', "");
    Expect(1, 68293, '\p{^Joining_Group=-	manichaean_gimel}', "");
    Expect(1, 68293, '\P{Joining_Group=-	manichaean_gimel}', "");
    Expect(0, 68293, '\P{^Joining_Group=-	manichaean_gimel}', "");
    Error('\p{Jg= :=Manichaean_GIMEL}');
    Error('\P{Jg= :=Manichaean_GIMEL}');
    Expect(1, 68292, '\p{Jg:   manichaeangimel}', "");
    Expect(0, 68292, '\p{^Jg:   manichaeangimel}', "");
    Expect(0, 68292, '\P{Jg:   manichaeangimel}', "");
    Expect(1, 68292, '\P{^Jg:   manichaeangimel}', "");
    Expect(0, 68293, '\p{Jg:   manichaeangimel}', "");
    Expect(1, 68293, '\p{^Jg:   manichaeangimel}', "");
    Expect(1, 68293, '\P{Jg:   manichaeangimel}', "");
    Expect(0, 68293, '\P{^Jg:   manichaeangimel}', "");
    Expect(1, 68292, '\p{Jg:  manichaean_Gimel}', "");
    Expect(0, 68292, '\p{^Jg:  manichaean_Gimel}', "");
    Expect(0, 68292, '\P{Jg:  manichaean_Gimel}', "");
    Expect(1, 68292, '\P{^Jg:  manichaean_Gimel}', "");
    Expect(0, 68293, '\p{Jg:  manichaean_Gimel}', "");
    Expect(1, 68293, '\p{^Jg:  manichaean_Gimel}', "");
    Expect(1, 68293, '\P{Jg:  manichaean_Gimel}', "");
    Expect(0, 68293, '\P{^Jg:  manichaean_Gimel}', "");
    Error('\p{Is_Joining_Group=_:=manichaean_gimel}');
    Error('\P{Is_Joining_Group=_:=manichaean_gimel}');
    Expect(1, 68292, '\p{Is_Joining_Group:	manichaeangimel}', "");
    Expect(0, 68292, '\p{^Is_Joining_Group:	manichaeangimel}', "");
    Expect(0, 68292, '\P{Is_Joining_Group:	manichaeangimel}', "");
    Expect(1, 68292, '\P{^Is_Joining_Group:	manichaeangimel}', "");
    Expect(0, 68293, '\p{Is_Joining_Group:	manichaeangimel}', "");
    Expect(1, 68293, '\p{^Is_Joining_Group:	manichaeangimel}', "");
    Expect(1, 68293, '\P{Is_Joining_Group:	manichaeangimel}', "");
    Expect(0, 68293, '\P{^Is_Joining_Group:	manichaeangimel}', "");
    Expect(1, 68292, '\p{Is_Joining_Group= -manichaean_Gimel}', "");
    Expect(0, 68292, '\p{^Is_Joining_Group= -manichaean_Gimel}', "");
    Expect(0, 68292, '\P{Is_Joining_Group= -manichaean_Gimel}', "");
    Expect(1, 68292, '\P{^Is_Joining_Group= -manichaean_Gimel}', "");
    Expect(0, 68293, '\p{Is_Joining_Group= -manichaean_Gimel}', "");
    Expect(1, 68293, '\p{^Is_Joining_Group= -manichaean_Gimel}', "");
    Expect(1, 68293, '\P{Is_Joining_Group= -manichaean_Gimel}', "");
    Expect(0, 68293, '\P{^Is_Joining_Group= -manichaean_Gimel}', "");
    Error('\p{Is_Jg=	MANICHAEAN_Gimel/a/}');
    Error('\P{Is_Jg=	MANICHAEAN_Gimel/a/}');
    Expect(1, 68292, '\p{Is_Jg=manichaeangimel}', "");
    Expect(0, 68292, '\p{^Is_Jg=manichaeangimel}', "");
    Expect(0, 68292, '\P{Is_Jg=manichaeangimel}', "");
    Expect(1, 68292, '\P{^Is_Jg=manichaeangimel}', "");
    Expect(0, 68293, '\p{Is_Jg=manichaeangimel}', "");
    Expect(1, 68293, '\p{^Is_Jg=manichaeangimel}', "");
    Expect(1, 68293, '\P{Is_Jg=manichaeangimel}', "");
    Expect(0, 68293, '\P{^Is_Jg=manichaeangimel}', "");
    Expect(1, 68292, '\p{Is_Jg=		Manichaean_GIMEL}', "");
    Expect(0, 68292, '\p{^Is_Jg=		Manichaean_GIMEL}', "");
    Expect(0, 68292, '\P{Is_Jg=		Manichaean_GIMEL}', "");
    Expect(1, 68292, '\P{^Is_Jg=		Manichaean_GIMEL}', "");
    Expect(0, 68293, '\p{Is_Jg=		Manichaean_GIMEL}', "");
    Expect(1, 68293, '\p{^Is_Jg=		Manichaean_GIMEL}', "");
    Expect(1, 68293, '\P{Is_Jg=		Manichaean_GIMEL}', "");
    Expect(0, 68293, '\P{^Is_Jg=		Manichaean_GIMEL}', "");
    Error('\p{Joining_Group=		Manichaean_heth:=}');
    Error('\P{Joining_Group=		Manichaean_heth:=}');
    Expect(1, 68301, '\p{Joining_Group=manichaeanheth}', "");
    Expect(0, 68301, '\p{^Joining_Group=manichaeanheth}', "");
    Expect(0, 68301, '\P{Joining_Group=manichaeanheth}', "");
    Expect(1, 68301, '\P{^Joining_Group=manichaeanheth}', "");
    Expect(0, 68302, '\p{Joining_Group=manichaeanheth}', "");
    Expect(1, 68302, '\p{^Joining_Group=manichaeanheth}', "");
    Expect(1, 68302, '\P{Joining_Group=manichaeanheth}', "");
    Expect(0, 68302, '\P{^Joining_Group=manichaeanheth}', "");
    Expect(1, 68301, '\p{Joining_Group=-	Manichaean_heth}', "");
    Expect(0, 68301, '\p{^Joining_Group=-	Manichaean_heth}', "");
    Expect(0, 68301, '\P{Joining_Group=-	Manichaean_heth}', "");
    Expect(1, 68301, '\P{^Joining_Group=-	Manichaean_heth}', "");
    Expect(0, 68302, '\p{Joining_Group=-	Manichaean_heth}', "");
    Expect(1, 68302, '\p{^Joining_Group=-	Manichaean_heth}', "");
    Expect(1, 68302, '\P{Joining_Group=-	Manichaean_heth}', "");
    Expect(0, 68302, '\P{^Joining_Group=-	Manichaean_heth}', "");
    Error('\p{Jg=/a/manichaean_Heth}');
    Error('\P{Jg=/a/manichaean_Heth}');
    Expect(1, 68301, '\p{Jg=manichaeanheth}', "");
    Expect(0, 68301, '\p{^Jg=manichaeanheth}', "");
    Expect(0, 68301, '\P{Jg=manichaeanheth}', "");
    Expect(1, 68301, '\P{^Jg=manichaeanheth}', "");
    Expect(0, 68302, '\p{Jg=manichaeanheth}', "");
    Expect(1, 68302, '\p{^Jg=manichaeanheth}', "");
    Expect(1, 68302, '\P{Jg=manichaeanheth}', "");
    Expect(0, 68302, '\P{^Jg=manichaeanheth}', "");
    Expect(1, 68301, '\p{Jg=-Manichaean_HETH}', "");
    Expect(0, 68301, '\p{^Jg=-Manichaean_HETH}', "");
    Expect(0, 68301, '\P{Jg=-Manichaean_HETH}', "");
    Expect(1, 68301, '\P{^Jg=-Manichaean_HETH}', "");
    Expect(0, 68302, '\p{Jg=-Manichaean_HETH}', "");
    Expect(1, 68302, '\p{^Jg=-Manichaean_HETH}', "");
    Expect(1, 68302, '\P{Jg=-Manichaean_HETH}', "");
    Expect(0, 68302, '\P{^Jg=-Manichaean_HETH}', "");
    Error('\p{Is_Joining_Group= _manichaean_Heth:=}');
    Error('\P{Is_Joining_Group= _manichaean_Heth:=}');
    Expect(1, 68301, '\p{Is_Joining_Group=manichaeanheth}', "");
    Expect(0, 68301, '\p{^Is_Joining_Group=manichaeanheth}', "");
    Expect(0, 68301, '\P{Is_Joining_Group=manichaeanheth}', "");
    Expect(1, 68301, '\P{^Is_Joining_Group=manichaeanheth}', "");
    Expect(0, 68302, '\p{Is_Joining_Group=manichaeanheth}', "");
    Expect(1, 68302, '\p{^Is_Joining_Group=manichaeanheth}', "");
    Expect(1, 68302, '\P{Is_Joining_Group=manichaeanheth}', "");
    Expect(0, 68302, '\P{^Is_Joining_Group=manichaeanheth}', "");
    Expect(1, 68301, '\p{Is_Joining_Group=-manichaean_Heth}', "");
    Expect(0, 68301, '\p{^Is_Joining_Group=-manichaean_Heth}', "");
    Expect(0, 68301, '\P{Is_Joining_Group=-manichaean_Heth}', "");
    Expect(1, 68301, '\P{^Is_Joining_Group=-manichaean_Heth}', "");
    Expect(0, 68302, '\p{Is_Joining_Group=-manichaean_Heth}', "");
    Expect(1, 68302, '\p{^Is_Joining_Group=-manichaean_Heth}', "");
    Expect(1, 68302, '\P{Is_Joining_Group=-manichaean_Heth}', "");
    Expect(0, 68302, '\P{^Is_Joining_Group=-manichaean_Heth}', "");
    Error('\p{Is_Jg=_	manichaean_heth:=}');
    Error('\P{Is_Jg=_	manichaean_heth:=}');
    Expect(1, 68301, '\p{Is_Jg=manichaeanheth}', "");
    Expect(0, 68301, '\p{^Is_Jg=manichaeanheth}', "");
    Expect(0, 68301, '\P{Is_Jg=manichaeanheth}', "");
    Expect(1, 68301, '\P{^Is_Jg=manichaeanheth}', "");
    Expect(0, 68302, '\p{Is_Jg=manichaeanheth}', "");
    Expect(1, 68302, '\p{^Is_Jg=manichaeanheth}', "");
    Expect(1, 68302, '\P{Is_Jg=manichaeanheth}', "");
    Expect(0, 68302, '\P{^Is_Jg=manichaeanheth}', "");
    Expect(1, 68301, '\p{Is_Jg:     Manichaean_Heth}', "");
    Expect(0, 68301, '\p{^Is_Jg:     Manichaean_Heth}', "");
    Expect(0, 68301, '\P{Is_Jg:     Manichaean_Heth}', "");
    Expect(1, 68301, '\P{^Is_Jg:     Manichaean_Heth}', "");
    Expect(0, 68302, '\p{Is_Jg:     Manichaean_Heth}', "");
    Expect(1, 68302, '\p{^Is_Jg:     Manichaean_Heth}', "");
    Expect(1, 68302, '\P{Is_Jg:     Manichaean_Heth}', "");
    Expect(0, 68302, '\P{^Is_Jg:     Manichaean_Heth}', "");
    Error('\p{Joining_Group=/a/	 Manichaean_hundred}');
    Error('\P{Joining_Group=/a/	 Manichaean_hundred}');
    Expect(1, 68335, '\p{Joining_Group=manichaeanhundred}', "");
    Expect(0, 68335, '\p{^Joining_Group=manichaeanhundred}', "");
    Expect(0, 68335, '\P{Joining_Group=manichaeanhundred}', "");
    Expect(1, 68335, '\P{^Joining_Group=manichaeanhundred}', "");
    Expect(0, 68336, '\p{Joining_Group=manichaeanhundred}', "");
    Expect(1, 68336, '\p{^Joining_Group=manichaeanhundred}', "");
    Expect(1, 68336, '\P{Joining_Group=manichaeanhundred}', "");
    Expect(0, 68336, '\P{^Joining_Group=manichaeanhundred}', "");
    Expect(1, 68335, '\p{Joining_Group=_	Manichaean_HUNDRED}', "");
    Expect(0, 68335, '\p{^Joining_Group=_	Manichaean_HUNDRED}', "");
    Expect(0, 68335, '\P{Joining_Group=_	Manichaean_HUNDRED}', "");
    Expect(1, 68335, '\P{^Joining_Group=_	Manichaean_HUNDRED}', "");
    Expect(0, 68336, '\p{Joining_Group=_	Manichaean_HUNDRED}', "");
    Expect(1, 68336, '\p{^Joining_Group=_	Manichaean_HUNDRED}', "");
    Expect(1, 68336, '\P{Joining_Group=_	Manichaean_HUNDRED}', "");
    Expect(0, 68336, '\P{^Joining_Group=_	Manichaean_HUNDRED}', "");
    Error('\p{Jg=	_manichaean_hundred/a/}');
    Error('\P{Jg=	_manichaean_hundred/a/}');
    Expect(1, 68335, '\p{Jg=manichaeanhundred}', "");
    Expect(0, 68335, '\p{^Jg=manichaeanhundred}', "");
    Expect(0, 68335, '\P{Jg=manichaeanhundred}', "");
    Expect(1, 68335, '\P{^Jg=manichaeanhundred}', "");
    Expect(0, 68336, '\p{Jg=manichaeanhundred}', "");
    Expect(1, 68336, '\p{^Jg=manichaeanhundred}', "");
    Expect(1, 68336, '\P{Jg=manichaeanhundred}', "");
    Expect(0, 68336, '\P{^Jg=manichaeanhundred}', "");
    Expect(1, 68335, '\p{Jg= _manichaean_HUNDRED}', "");
    Expect(0, 68335, '\p{^Jg= _manichaean_HUNDRED}', "");
    Expect(0, 68335, '\P{Jg= _manichaean_HUNDRED}', "");
    Expect(1, 68335, '\P{^Jg= _manichaean_HUNDRED}', "");
    Expect(0, 68336, '\p{Jg= _manichaean_HUNDRED}', "");
    Expect(1, 68336, '\p{^Jg= _manichaean_HUNDRED}', "");
    Expect(1, 68336, '\P{Jg= _manichaean_HUNDRED}', "");
    Expect(0, 68336, '\P{^Jg= _manichaean_HUNDRED}', "");
    Error('\p{Is_Joining_Group=:=- Manichaean_hundred}');
    Error('\P{Is_Joining_Group=:=- Manichaean_hundred}');
    Expect(1, 68335, '\p{Is_Joining_Group=manichaeanhundred}', "");
    Expect(0, 68335, '\p{^Is_Joining_Group=manichaeanhundred}', "");
    Expect(0, 68335, '\P{Is_Joining_Group=manichaeanhundred}', "");
    Expect(1, 68335, '\P{^Is_Joining_Group=manichaeanhundred}', "");
    Expect(0, 68336, '\p{Is_Joining_Group=manichaeanhundred}', "");
    Expect(1, 68336, '\p{^Is_Joining_Group=manichaeanhundred}', "");
    Expect(1, 68336, '\P{Is_Joining_Group=manichaeanhundred}', "");
    Expect(0, 68336, '\P{^Is_Joining_Group=manichaeanhundred}', "");
    Expect(1, 68335, '\p{Is_Joining_Group=	 manichaean_hundred}', "");
    Expect(0, 68335, '\p{^Is_Joining_Group=	 manichaean_hundred}', "");
    Expect(0, 68335, '\P{Is_Joining_Group=	 manichaean_hundred}', "");
    Expect(1, 68335, '\P{^Is_Joining_Group=	 manichaean_hundred}', "");
    Expect(0, 68336, '\p{Is_Joining_Group=	 manichaean_hundred}', "");
    Expect(1, 68336, '\p{^Is_Joining_Group=	 manichaean_hundred}', "");
    Expect(1, 68336, '\P{Is_Joining_Group=	 manichaean_hundred}', "");
    Expect(0, 68336, '\P{^Is_Joining_Group=	 manichaean_hundred}', "");
    Error('\p{Is_Jg=	_MANICHAEAN_Hundred/a/}');
    Error('\P{Is_Jg=	_MANICHAEAN_Hundred/a/}');
    Expect(1, 68335, '\p{Is_Jg=manichaeanhundred}', "");
    Expect(0, 68335, '\p{^Is_Jg=manichaeanhundred}', "");
    Expect(0, 68335, '\P{Is_Jg=manichaeanhundred}', "");
    Expect(1, 68335, '\P{^Is_Jg=manichaeanhundred}', "");
    Expect(0, 68336, '\p{Is_Jg=manichaeanhundred}', "");
    Expect(1, 68336, '\p{^Is_Jg=manichaeanhundred}', "");
    Expect(1, 68336, '\P{Is_Jg=manichaeanhundred}', "");
    Expect(0, 68336, '\P{^Is_Jg=manichaeanhundred}', "");
    Expect(1, 68335, '\p{Is_Jg=-MANICHAEAN_Hundred}', "");
    Expect(0, 68335, '\p{^Is_Jg=-MANICHAEAN_Hundred}', "");
    Expect(0, 68335, '\P{Is_Jg=-MANICHAEAN_Hundred}', "");
    Expect(1, 68335, '\P{^Is_Jg=-MANICHAEAN_Hundred}', "");
    Expect(0, 68336, '\p{Is_Jg=-MANICHAEAN_Hundred}', "");
    Expect(1, 68336, '\p{^Is_Jg=-MANICHAEAN_Hundred}', "");
    Expect(1, 68336, '\P{Is_Jg=-MANICHAEAN_Hundred}', "");
    Expect(0, 68336, '\P{^Is_Jg=-MANICHAEAN_Hundred}', "");
    Error('\p{Joining_Group=__Manichaean_KAPH/a/}');
    Error('\P{Joining_Group=__Manichaean_KAPH/a/}');
    Expect(1, 68306, '\p{Joining_Group=manichaeankaph}', "");
    Expect(0, 68306, '\p{^Joining_Group=manichaeankaph}', "");
    Expect(0, 68306, '\P{Joining_Group=manichaeankaph}', "");
    Expect(1, 68306, '\P{^Joining_Group=manichaeankaph}', "");
    Expect(0, 68307, '\p{Joining_Group=manichaeankaph}', "");
    Expect(1, 68307, '\p{^Joining_Group=manichaeankaph}', "");
    Expect(1, 68307, '\P{Joining_Group=manichaeankaph}', "");
    Expect(0, 68307, '\P{^Joining_Group=manichaeankaph}', "");
    Expect(1, 68306, '\p{Joining_Group=_manichaean_KAPH}', "");
    Expect(0, 68306, '\p{^Joining_Group=_manichaean_KAPH}', "");
    Expect(0, 68306, '\P{Joining_Group=_manichaean_KAPH}', "");
    Expect(1, 68306, '\P{^Joining_Group=_manichaean_KAPH}', "");
    Expect(0, 68307, '\p{Joining_Group=_manichaean_KAPH}', "");
    Expect(1, 68307, '\p{^Joining_Group=_manichaean_KAPH}', "");
    Expect(1, 68307, '\P{Joining_Group=_manichaean_KAPH}', "");
    Expect(0, 68307, '\P{^Joining_Group=_manichaean_KAPH}', "");
    Error('\p{Jg=/a/ -Manichaean_Kaph}');
    Error('\P{Jg=/a/ -Manichaean_Kaph}');
    Expect(1, 68306, '\p{Jg=manichaeankaph}', "");
    Expect(0, 68306, '\p{^Jg=manichaeankaph}', "");
    Expect(0, 68306, '\P{Jg=manichaeankaph}', "");
    Expect(1, 68306, '\P{^Jg=manichaeankaph}', "");
    Expect(0, 68307, '\p{Jg=manichaeankaph}', "");
    Expect(1, 68307, '\p{^Jg=manichaeankaph}', "");
    Expect(1, 68307, '\P{Jg=manichaeankaph}', "");
    Expect(0, 68307, '\P{^Jg=manichaeankaph}', "");
    Expect(1, 68306, '\p{Jg= manichaean_kaph}', "");
    Expect(0, 68306, '\p{^Jg= manichaean_kaph}', "");
    Expect(0, 68306, '\P{Jg= manichaean_kaph}', "");
    Expect(1, 68306, '\P{^Jg= manichaean_kaph}', "");
    Expect(0, 68307, '\p{Jg= manichaean_kaph}', "");
    Expect(1, 68307, '\p{^Jg= manichaean_kaph}', "");
    Expect(1, 68307, '\P{Jg= manichaean_kaph}', "");
    Expect(0, 68307, '\P{^Jg= manichaean_kaph}', "");
    Error('\p{Is_Joining_Group=_-Manichaean_kaph/a/}');
    Error('\P{Is_Joining_Group=_-Manichaean_kaph/a/}');
    Expect(1, 68306, '\p{Is_Joining_Group=manichaeankaph}', "");
    Expect(0, 68306, '\p{^Is_Joining_Group=manichaeankaph}', "");
    Expect(0, 68306, '\P{Is_Joining_Group=manichaeankaph}', "");
    Expect(1, 68306, '\P{^Is_Joining_Group=manichaeankaph}', "");
    Expect(0, 68307, '\p{Is_Joining_Group=manichaeankaph}', "");
    Expect(1, 68307, '\p{^Is_Joining_Group=manichaeankaph}', "");
    Expect(1, 68307, '\P{Is_Joining_Group=manichaeankaph}', "");
    Expect(0, 68307, '\P{^Is_Joining_Group=manichaeankaph}', "");
    Expect(1, 68306, '\p{Is_Joining_Group=	 Manichaean_kaph}', "");
    Expect(0, 68306, '\p{^Is_Joining_Group=	 Manichaean_kaph}', "");
    Expect(0, 68306, '\P{Is_Joining_Group=	 Manichaean_kaph}', "");
    Expect(1, 68306, '\P{^Is_Joining_Group=	 Manichaean_kaph}', "");
    Expect(0, 68307, '\p{Is_Joining_Group=	 Manichaean_kaph}', "");
    Expect(1, 68307, '\p{^Is_Joining_Group=	 Manichaean_kaph}', "");
    Expect(1, 68307, '\P{Is_Joining_Group=	 Manichaean_kaph}', "");
    Expect(0, 68307, '\P{^Is_Joining_Group=	 Manichaean_kaph}', "");
    Error('\p{Is_Jg=	Manichaean_kaph/a/}');
    Error('\P{Is_Jg=	Manichaean_kaph/a/}');
    Expect(1, 68306, '\p{Is_Jg=manichaeankaph}', "");
    Expect(0, 68306, '\p{^Is_Jg=manichaeankaph}', "");
    Expect(0, 68306, '\P{Is_Jg=manichaeankaph}', "");
    Expect(1, 68306, '\P{^Is_Jg=manichaeankaph}', "");
    Expect(0, 68307, '\p{Is_Jg=manichaeankaph}', "");
    Expect(1, 68307, '\p{^Is_Jg=manichaeankaph}', "");
    Expect(1, 68307, '\P{Is_Jg=manichaeankaph}', "");
    Expect(0, 68307, '\P{^Is_Jg=manichaeankaph}', "");
    Expect(1, 68306, '\p{Is_Jg=	 MANICHAEAN_Kaph}', "");
    Expect(0, 68306, '\p{^Is_Jg=	 MANICHAEAN_Kaph}', "");
    Expect(0, 68306, '\P{Is_Jg=	 MANICHAEAN_Kaph}', "");
    Expect(1, 68306, '\P{^Is_Jg=	 MANICHAEAN_Kaph}', "");
    Expect(0, 68307, '\p{Is_Jg=	 MANICHAEAN_Kaph}', "");
    Expect(1, 68307, '\p{^Is_Jg=	 MANICHAEAN_Kaph}', "");
    Expect(1, 68307, '\P{Is_Jg=	 MANICHAEAN_Kaph}', "");
    Expect(0, 68307, '\P{^Is_Jg=	 MANICHAEAN_Kaph}', "");
    Error('\p{Joining_Group=	-MANICHAEAN_lamedh/a/}');
    Error('\P{Joining_Group=	-MANICHAEAN_lamedh/a/}');
    Expect(1, 68307, '\p{Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68307, '\p{^Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68307, '\P{Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68307, '\P{^Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68308, '\p{Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68308, '\p{^Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68308, '\P{Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68308, '\P{^Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68307, '\p{Joining_Group=-_Manichaean_Lamedh}', "");
    Expect(0, 68307, '\p{^Joining_Group=-_Manichaean_Lamedh}', "");
    Expect(0, 68307, '\P{Joining_Group=-_Manichaean_Lamedh}', "");
    Expect(1, 68307, '\P{^Joining_Group=-_Manichaean_Lamedh}', "");
    Expect(0, 68308, '\p{Joining_Group=-_Manichaean_Lamedh}', "");
    Expect(1, 68308, '\p{^Joining_Group=-_Manichaean_Lamedh}', "");
    Expect(1, 68308, '\P{Joining_Group=-_Manichaean_Lamedh}', "");
    Expect(0, 68308, '\P{^Joining_Group=-_Manichaean_Lamedh}', "");
    Error('\p{Jg=/a/Manichaean_Lamedh}');
    Error('\P{Jg=/a/Manichaean_Lamedh}');
    Expect(1, 68307, '\p{Jg=manichaeanlamedh}', "");
    Expect(0, 68307, '\p{^Jg=manichaeanlamedh}', "");
    Expect(0, 68307, '\P{Jg=manichaeanlamedh}', "");
    Expect(1, 68307, '\P{^Jg=manichaeanlamedh}', "");
    Expect(0, 68308, '\p{Jg=manichaeanlamedh}', "");
    Expect(1, 68308, '\p{^Jg=manichaeanlamedh}', "");
    Expect(1, 68308, '\P{Jg=manichaeanlamedh}', "");
    Expect(0, 68308, '\P{^Jg=manichaeanlamedh}', "");
    Expect(1, 68307, '\p{Jg=	 Manichaean_LAMEDH}', "");
    Expect(0, 68307, '\p{^Jg=	 Manichaean_LAMEDH}', "");
    Expect(0, 68307, '\P{Jg=	 Manichaean_LAMEDH}', "");
    Expect(1, 68307, '\P{^Jg=	 Manichaean_LAMEDH}', "");
    Expect(0, 68308, '\p{Jg=	 Manichaean_LAMEDH}', "");
    Expect(1, 68308, '\p{^Jg=	 Manichaean_LAMEDH}', "");
    Expect(1, 68308, '\P{Jg=	 Manichaean_LAMEDH}', "");
    Expect(0, 68308, '\P{^Jg=	 Manichaean_LAMEDH}', "");
    Error('\p{Is_Joining_Group=MANICHAEAN_Lamedh:=}');
    Error('\P{Is_Joining_Group=MANICHAEAN_Lamedh:=}');
    Expect(1, 68307, '\p{Is_Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68307, '\p{^Is_Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68307, '\P{Is_Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68307, '\P{^Is_Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68308, '\p{Is_Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68308, '\p{^Is_Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68308, '\P{Is_Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68308, '\P{^Is_Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68307, '\p{Is_Joining_Group=_Manichaean_Lamedh}', "");
    Expect(0, 68307, '\p{^Is_Joining_Group=_Manichaean_Lamedh}', "");
    Expect(0, 68307, '\P{Is_Joining_Group=_Manichaean_Lamedh}', "");
    Expect(1, 68307, '\P{^Is_Joining_Group=_Manichaean_Lamedh}', "");
    Expect(0, 68308, '\p{Is_Joining_Group=_Manichaean_Lamedh}', "");
    Expect(1, 68308, '\p{^Is_Joining_Group=_Manichaean_Lamedh}', "");
    Expect(1, 68308, '\P{Is_Joining_Group=_Manichaean_Lamedh}', "");
    Expect(0, 68308, '\P{^Is_Joining_Group=_Manichaean_Lamedh}', "");
    Error('\p{Is_Jg=-:=MANICHAEAN_LAMEDH}');
    Error('\P{Is_Jg=-:=MANICHAEAN_LAMEDH}');
    Expect(1, 68307, '\p{Is_Jg=manichaeanlamedh}', "");
    Expect(0, 68307, '\p{^Is_Jg=manichaeanlamedh}', "");
    Expect(0, 68307, '\P{Is_Jg=manichaeanlamedh}', "");
    Expect(1, 68307, '\P{^Is_Jg=manichaeanlamedh}', "");
    Expect(0, 68308, '\p{Is_Jg=manichaeanlamedh}', "");
    Expect(1, 68308, '\p{^Is_Jg=manichaeanlamedh}', "");
    Expect(1, 68308, '\P{Is_Jg=manichaeanlamedh}', "");
    Expect(0, 68308, '\P{^Is_Jg=manichaeanlamedh}', "");
    Expect(1, 68307, '\p{Is_Jg=	Manichaean_Lamedh}', "");
    Expect(0, 68307, '\p{^Is_Jg=	Manichaean_Lamedh}', "");
    Expect(0, 68307, '\P{Is_Jg=	Manichaean_Lamedh}', "");
    Expect(1, 68307, '\P{^Is_Jg=	Manichaean_Lamedh}', "");
    Expect(0, 68308, '\p{Is_Jg=	Manichaean_Lamedh}', "");
    Expect(1, 68308, '\p{^Is_Jg=	Manichaean_Lamedh}', "");
    Expect(1, 68308, '\P{Is_Jg=	Manichaean_Lamedh}', "");
    Expect(0, 68308, '\P{^Is_Jg=	Manichaean_Lamedh}', "");
    Error('\p{Joining_Group= Manichaean_mem:=}');
    Error('\P{Joining_Group= Manichaean_mem:=}');
    Expect(1, 68310, '\p{Joining_Group=manichaeanmem}', "");
    Expect(0, 68310, '\p{^Joining_Group=manichaeanmem}', "");
    Expect(0, 68310, '\P{Joining_Group=manichaeanmem}', "");
    Expect(1, 68310, '\P{^Joining_Group=manichaeanmem}', "");
    Expect(0, 68311, '\p{Joining_Group=manichaeanmem}', "");
    Expect(1, 68311, '\p{^Joining_Group=manichaeanmem}', "");
    Expect(1, 68311, '\P{Joining_Group=manichaeanmem}', "");
    Expect(0, 68311, '\P{^Joining_Group=manichaeanmem}', "");
    Expect(1, 68310, '\p{Joining_Group=__manichaean_mem}', "");
    Expect(0, 68310, '\p{^Joining_Group=__manichaean_mem}', "");
    Expect(0, 68310, '\P{Joining_Group=__manichaean_mem}', "");
    Expect(1, 68310, '\P{^Joining_Group=__manichaean_mem}', "");
    Expect(0, 68311, '\p{Joining_Group=__manichaean_mem}', "");
    Expect(1, 68311, '\p{^Joining_Group=__manichaean_mem}', "");
    Expect(1, 68311, '\P{Joining_Group=__manichaean_mem}', "");
    Expect(0, 68311, '\P{^Joining_Group=__manichaean_mem}', "");
    Error('\p{Jg:	/a/_ manichaean_Mem}');
    Error('\P{Jg:	/a/_ manichaean_Mem}');
    Expect(1, 68310, '\p{Jg=manichaeanmem}', "");
    Expect(0, 68310, '\p{^Jg=manichaeanmem}', "");
    Expect(0, 68310, '\P{Jg=manichaeanmem}', "");
    Expect(1, 68310, '\P{^Jg=manichaeanmem}', "");
    Expect(0, 68311, '\p{Jg=manichaeanmem}', "");
    Expect(1, 68311, '\p{^Jg=manichaeanmem}', "");
    Expect(1, 68311, '\P{Jg=manichaeanmem}', "");
    Expect(0, 68311, '\P{^Jg=manichaeanmem}', "");
    Expect(1, 68310, '\p{Jg=	 Manichaean_Mem}', "");
    Expect(0, 68310, '\p{^Jg=	 Manichaean_Mem}', "");
    Expect(0, 68310, '\P{Jg=	 Manichaean_Mem}', "");
    Expect(1, 68310, '\P{^Jg=	 Manichaean_Mem}', "");
    Expect(0, 68311, '\p{Jg=	 Manichaean_Mem}', "");
    Expect(1, 68311, '\p{^Jg=	 Manichaean_Mem}', "");
    Expect(1, 68311, '\P{Jg=	 Manichaean_Mem}', "");
    Expect(0, 68311, '\P{^Jg=	 Manichaean_Mem}', "");
    Error('\p{Is_Joining_Group:   /a/MANICHAEAN_Mem}');
    Error('\P{Is_Joining_Group:   /a/MANICHAEAN_Mem}');
    Expect(1, 68310, '\p{Is_Joining_Group=manichaeanmem}', "");
    Expect(0, 68310, '\p{^Is_Joining_Group=manichaeanmem}', "");
    Expect(0, 68310, '\P{Is_Joining_Group=manichaeanmem}', "");
    Expect(1, 68310, '\P{^Is_Joining_Group=manichaeanmem}', "");
    Expect(0, 68311, '\p{Is_Joining_Group=manichaeanmem}', "");
    Expect(1, 68311, '\p{^Is_Joining_Group=manichaeanmem}', "");
    Expect(1, 68311, '\P{Is_Joining_Group=manichaeanmem}', "");
    Expect(0, 68311, '\P{^Is_Joining_Group=manichaeanmem}', "");
    Expect(1, 68310, '\p{Is_Joining_Group=-Manichaean_Mem}', "");
    Expect(0, 68310, '\p{^Is_Joining_Group=-Manichaean_Mem}', "");
    Expect(0, 68310, '\P{Is_Joining_Group=-Manichaean_Mem}', "");
    Expect(1, 68310, '\P{^Is_Joining_Group=-Manichaean_Mem}', "");
    Expect(0, 68311, '\p{Is_Joining_Group=-Manichaean_Mem}', "");
    Expect(1, 68311, '\p{^Is_Joining_Group=-Manichaean_Mem}', "");
    Expect(1, 68311, '\P{Is_Joining_Group=-Manichaean_Mem}', "");
    Expect(0, 68311, '\P{^Is_Joining_Group=-Manichaean_Mem}', "");
    Error('\p{Is_Jg=/a/-_Manichaean_mem}');
    Error('\P{Is_Jg=/a/-_Manichaean_mem}');
    Expect(1, 68310, '\p{Is_Jg=manichaeanmem}', "");
    Expect(0, 68310, '\p{^Is_Jg=manichaeanmem}', "");
    Expect(0, 68310, '\P{Is_Jg=manichaeanmem}', "");
    Expect(1, 68310, '\P{^Is_Jg=manichaeanmem}', "");
    Expect(0, 68311, '\p{Is_Jg=manichaeanmem}', "");
    Expect(1, 68311, '\p{^Is_Jg=manichaeanmem}', "");
    Expect(1, 68311, '\P{Is_Jg=manichaeanmem}', "");
    Expect(0, 68311, '\P{^Is_Jg=manichaeanmem}', "");
    Expect(1, 68310, '\p{Is_Jg:--manichaean_Mem}', "");
    Expect(0, 68310, '\p{^Is_Jg:--manichaean_Mem}', "");
    Expect(0, 68310, '\P{Is_Jg:--manichaean_Mem}', "");
    Expect(1, 68310, '\P{^Is_Jg:--manichaean_Mem}', "");
    Expect(0, 68311, '\p{Is_Jg:--manichaean_Mem}', "");
    Expect(1, 68311, '\p{^Is_Jg:--manichaean_Mem}', "");
    Expect(1, 68311, '\P{Is_Jg:--manichaean_Mem}', "");
    Expect(0, 68311, '\P{^Is_Jg:--manichaean_Mem}', "");
    Error('\p{Joining_Group=/a/manichaean_NUN}');
    Error('\P{Joining_Group=/a/manichaean_NUN}');
    Expect(1, 68311, '\p{Joining_Group=manichaeannun}', "");
    Expect(0, 68311, '\p{^Joining_Group=manichaeannun}', "");
    Expect(0, 68311, '\P{Joining_Group=manichaeannun}', "");
    Expect(1, 68311, '\P{^Joining_Group=manichaeannun}', "");
    Expect(0, 68312, '\p{Joining_Group=manichaeannun}', "");
    Expect(1, 68312, '\p{^Joining_Group=manichaeannun}', "");
    Expect(1, 68312, '\P{Joining_Group=manichaeannun}', "");
    Expect(0, 68312, '\P{^Joining_Group=manichaeannun}', "");
    Expect(1, 68311, '\p{Joining_Group=- Manichaean_nun}', "");
    Expect(0, 68311, '\p{^Joining_Group=- Manichaean_nun}', "");
    Expect(0, 68311, '\P{Joining_Group=- Manichaean_nun}', "");
    Expect(1, 68311, '\P{^Joining_Group=- Manichaean_nun}', "");
    Expect(0, 68312, '\p{Joining_Group=- Manichaean_nun}', "");
    Expect(1, 68312, '\p{^Joining_Group=- Manichaean_nun}', "");
    Expect(1, 68312, '\P{Joining_Group=- Manichaean_nun}', "");
    Expect(0, 68312, '\P{^Joining_Group=- Manichaean_nun}', "");
    Error('\p{Jg=:=Manichaean_Nun}');
    Error('\P{Jg=:=Manichaean_Nun}');
    Expect(1, 68311, '\p{Jg=manichaeannun}', "");
    Expect(0, 68311, '\p{^Jg=manichaeannun}', "");
    Expect(0, 68311, '\P{Jg=manichaeannun}', "");
    Expect(1, 68311, '\P{^Jg=manichaeannun}', "");
    Expect(0, 68312, '\p{Jg=manichaeannun}', "");
    Expect(1, 68312, '\p{^Jg=manichaeannun}', "");
    Expect(1, 68312, '\P{Jg=manichaeannun}', "");
    Expect(0, 68312, '\P{^Jg=manichaeannun}', "");
    Expect(1, 68311, '\p{Jg:	__MANICHAEAN_Nun}', "");
    Expect(0, 68311, '\p{^Jg:	__MANICHAEAN_Nun}', "");
    Expect(0, 68311, '\P{Jg:	__MANICHAEAN_Nun}', "");
    Expect(1, 68311, '\P{^Jg:	__MANICHAEAN_Nun}', "");
    Expect(0, 68312, '\p{Jg:	__MANICHAEAN_Nun}', "");
    Expect(1, 68312, '\p{^Jg:	__MANICHAEAN_Nun}', "");
    Expect(1, 68312, '\P{Jg:	__MANICHAEAN_Nun}', "");
    Expect(0, 68312, '\P{^Jg:	__MANICHAEAN_Nun}', "");
    Error('\p{Is_Joining_Group=_	Manichaean_Nun/a/}');
    Error('\P{Is_Joining_Group=_	Manichaean_Nun/a/}');
    Expect(1, 68311, '\p{Is_Joining_Group=manichaeannun}', "");
    Expect(0, 68311, '\p{^Is_Joining_Group=manichaeannun}', "");
    Expect(0, 68311, '\P{Is_Joining_Group=manichaeannun}', "");
    Expect(1, 68311, '\P{^Is_Joining_Group=manichaeannun}', "");
    Expect(0, 68312, '\p{Is_Joining_Group=manichaeannun}', "");
    Expect(1, 68312, '\p{^Is_Joining_Group=manichaeannun}', "");
    Expect(1, 68312, '\P{Is_Joining_Group=manichaeannun}', "");
    Expect(0, 68312, '\P{^Is_Joining_Group=manichaeannun}', "");
    Expect(1, 68311, '\p{Is_Joining_Group=_-Manichaean_Nun}', "");
    Expect(0, 68311, '\p{^Is_Joining_Group=_-Manichaean_Nun}', "");
    Expect(0, 68311, '\P{Is_Joining_Group=_-Manichaean_Nun}', "");
    Expect(1, 68311, '\P{^Is_Joining_Group=_-Manichaean_Nun}', "");
    Expect(0, 68312, '\p{Is_Joining_Group=_-Manichaean_Nun}', "");
    Expect(1, 68312, '\p{^Is_Joining_Group=_-Manichaean_Nun}', "");
    Expect(1, 68312, '\P{Is_Joining_Group=_-Manichaean_Nun}', "");
    Expect(0, 68312, '\P{^Is_Joining_Group=_-Manichaean_Nun}', "");
    Error('\p{Is_Jg=:= _MANICHAEAN_nun}');
    Error('\P{Is_Jg=:= _MANICHAEAN_nun}');
    Expect(1, 68311, '\p{Is_Jg=manichaeannun}', "");
    Expect(0, 68311, '\p{^Is_Jg=manichaeannun}', "");
    Expect(0, 68311, '\P{Is_Jg=manichaeannun}', "");
    Expect(1, 68311, '\P{^Is_Jg=manichaeannun}', "");
    Expect(0, 68312, '\p{Is_Jg=manichaeannun}', "");
    Expect(1, 68312, '\p{^Is_Jg=manichaeannun}', "");
    Expect(1, 68312, '\P{Is_Jg=manichaeannun}', "");
    Expect(0, 68312, '\P{^Is_Jg=manichaeannun}', "");
    Expect(1, 68311, '\p{Is_Jg= manichaean_nun}', "");
    Expect(0, 68311, '\p{^Is_Jg= manichaean_nun}', "");
    Expect(0, 68311, '\P{Is_Jg= manichaean_nun}', "");
    Expect(1, 68311, '\P{^Is_Jg= manichaean_nun}', "");
    Expect(0, 68312, '\p{Is_Jg= manichaean_nun}', "");
    Expect(1, 68312, '\p{^Is_Jg= manichaean_nun}', "");
    Expect(1, 68312, '\P{Is_Jg= manichaean_nun}', "");
    Expect(0, 68312, '\P{^Is_Jg= manichaean_nun}', "");
    Error('\p{Joining_Group=_/a/Manichaean_One}');
    Error('\P{Joining_Group=_/a/Manichaean_One}');
    Expect(1, 68331, '\p{Joining_Group: manichaeanone}', "");
    Expect(0, 68331, '\p{^Joining_Group: manichaeanone}', "");
    Expect(0, 68331, '\P{Joining_Group: manichaeanone}', "");
    Expect(1, 68331, '\P{^Joining_Group: manichaeanone}', "");
    Expect(0, 68332, '\p{Joining_Group: manichaeanone}', "");
    Expect(1, 68332, '\p{^Joining_Group: manichaeanone}', "");
    Expect(1, 68332, '\P{Joining_Group: manichaeanone}', "");
    Expect(0, 68332, '\P{^Joining_Group: manichaeanone}', "");
    Expect(1, 68331, '\p{Joining_Group=	_Manichaean_One}', "");
    Expect(0, 68331, '\p{^Joining_Group=	_Manichaean_One}', "");
    Expect(0, 68331, '\P{Joining_Group=	_Manichaean_One}', "");
    Expect(1, 68331, '\P{^Joining_Group=	_Manichaean_One}', "");
    Expect(0, 68332, '\p{Joining_Group=	_Manichaean_One}', "");
    Expect(1, 68332, '\p{^Joining_Group=	_Manichaean_One}', "");
    Expect(1, 68332, '\P{Joining_Group=	_Manichaean_One}', "");
    Expect(0, 68332, '\P{^Joining_Group=	_Manichaean_One}', "");
    Error('\p{Jg=-:=Manichaean_One}');
    Error('\P{Jg=-:=Manichaean_One}');
    Expect(1, 68331, '\p{Jg=manichaeanone}', "");
    Expect(0, 68331, '\p{^Jg=manichaeanone}', "");
    Expect(0, 68331, '\P{Jg=manichaeanone}', "");
    Expect(1, 68331, '\P{^Jg=manichaeanone}', "");
    Expect(0, 68332, '\p{Jg=manichaeanone}', "");
    Expect(1, 68332, '\p{^Jg=manichaeanone}', "");
    Expect(1, 68332, '\P{Jg=manichaeanone}', "");
    Expect(0, 68332, '\P{^Jg=manichaeanone}', "");
    Expect(1, 68331, '\p{Jg=	MANICHAEAN_one}', "");
    Expect(0, 68331, '\p{^Jg=	MANICHAEAN_one}', "");
    Expect(0, 68331, '\P{Jg=	MANICHAEAN_one}', "");
    Expect(1, 68331, '\P{^Jg=	MANICHAEAN_one}', "");
    Expect(0, 68332, '\p{Jg=	MANICHAEAN_one}', "");
    Expect(1, 68332, '\p{^Jg=	MANICHAEAN_one}', "");
    Expect(1, 68332, '\P{Jg=	MANICHAEAN_one}', "");
    Expect(0, 68332, '\P{^Jg=	MANICHAEAN_one}', "");
    Error('\p{Is_Joining_Group: 	_MANICHAEAN_ONE:=}');
    Error('\P{Is_Joining_Group: 	_MANICHAEAN_ONE:=}');
    Expect(1, 68331, '\p{Is_Joining_Group=manichaeanone}', "");
    Expect(0, 68331, '\p{^Is_Joining_Group=manichaeanone}', "");
    Expect(0, 68331, '\P{Is_Joining_Group=manichaeanone}', "");
    Expect(1, 68331, '\P{^Is_Joining_Group=manichaeanone}', "");
    Expect(0, 68332, '\p{Is_Joining_Group=manichaeanone}', "");
    Expect(1, 68332, '\p{^Is_Joining_Group=manichaeanone}', "");
    Expect(1, 68332, '\P{Is_Joining_Group=manichaeanone}', "");
    Expect(0, 68332, '\P{^Is_Joining_Group=manichaeanone}', "");
    Expect(1, 68331, '\p{Is_Joining_Group=- manichaean_One}', "");
    Expect(0, 68331, '\p{^Is_Joining_Group=- manichaean_One}', "");
    Expect(0, 68331, '\P{Is_Joining_Group=- manichaean_One}', "");
    Expect(1, 68331, '\P{^Is_Joining_Group=- manichaean_One}', "");
    Expect(0, 68332, '\p{Is_Joining_Group=- manichaean_One}', "");
    Expect(1, 68332, '\p{^Is_Joining_Group=- manichaean_One}', "");
    Expect(1, 68332, '\P{Is_Joining_Group=- manichaean_One}', "");
    Expect(0, 68332, '\P{^Is_Joining_Group=- manichaean_One}', "");
    Error('\p{Is_Jg=	Manichaean_One:=}');
    Error('\P{Is_Jg=	Manichaean_One:=}');
    Expect(1, 68331, '\p{Is_Jg=manichaeanone}', "");
    Expect(0, 68331, '\p{^Is_Jg=manichaeanone}', "");
    Expect(0, 68331, '\P{Is_Jg=manichaeanone}', "");
    Expect(1, 68331, '\P{^Is_Jg=manichaeanone}', "");
    Expect(0, 68332, '\p{Is_Jg=manichaeanone}', "");
    Expect(1, 68332, '\p{^Is_Jg=manichaeanone}', "");
    Expect(1, 68332, '\P{Is_Jg=manichaeanone}', "");
    Expect(0, 68332, '\P{^Is_Jg=manichaeanone}', "");
    Expect(1, 68331, '\p{Is_Jg=_	Manichaean_One}', "");
    Expect(0, 68331, '\p{^Is_Jg=_	Manichaean_One}', "");
    Expect(0, 68331, '\P{Is_Jg=_	Manichaean_One}', "");
    Expect(1, 68331, '\P{^Is_Jg=_	Manichaean_One}', "");
    Expect(0, 68332, '\p{Is_Jg=_	Manichaean_One}', "");
    Expect(1, 68332, '\p{^Is_Jg=_	Manichaean_One}', "");
    Expect(1, 68332, '\P{Is_Jg=_	Manichaean_One}', "");
    Expect(0, 68332, '\P{^Is_Jg=_	Manichaean_One}', "");
    Error('\p{Joining_Group=/a/Manichaean_PE}');
    Error('\P{Joining_Group=/a/Manichaean_PE}');
    Expect(1, 68316, '\p{Joining_Group=manichaeanpe}', "");
    Expect(0, 68316, '\p{^Joining_Group=manichaeanpe}', "");
    Expect(0, 68316, '\P{Joining_Group=manichaeanpe}', "");
    Expect(1, 68316, '\P{^Joining_Group=manichaeanpe}', "");
    Expect(0, 68317, '\p{Joining_Group=manichaeanpe}', "");
    Expect(1, 68317, '\p{^Joining_Group=manichaeanpe}', "");
    Expect(1, 68317, '\P{Joining_Group=manichaeanpe}', "");
    Expect(0, 68317, '\P{^Joining_Group=manichaeanpe}', "");
    Expect(1, 68316, '\p{Joining_Group=_Manichaean_Pe}', "");
    Expect(0, 68316, '\p{^Joining_Group=_Manichaean_Pe}', "");
    Expect(0, 68316, '\P{Joining_Group=_Manichaean_Pe}', "");
    Expect(1, 68316, '\P{^Joining_Group=_Manichaean_Pe}', "");
    Expect(0, 68317, '\p{Joining_Group=_Manichaean_Pe}', "");
    Expect(1, 68317, '\p{^Joining_Group=_Manichaean_Pe}', "");
    Expect(1, 68317, '\P{Joining_Group=_Manichaean_Pe}', "");
    Expect(0, 68317, '\P{^Joining_Group=_Manichaean_Pe}', "");
    Error('\p{Jg:	:=--manichaean_Pe}');
    Error('\P{Jg:	:=--manichaean_Pe}');
    Expect(1, 68316, '\p{Jg:	manichaeanpe}', "");
    Expect(0, 68316, '\p{^Jg:	manichaeanpe}', "");
    Expect(0, 68316, '\P{Jg:	manichaeanpe}', "");
    Expect(1, 68316, '\P{^Jg:	manichaeanpe}', "");
    Expect(0, 68317, '\p{Jg:	manichaeanpe}', "");
    Expect(1, 68317, '\p{^Jg:	manichaeanpe}', "");
    Expect(1, 68317, '\P{Jg:	manichaeanpe}', "");
    Expect(0, 68317, '\P{^Jg:	manichaeanpe}', "");
    Expect(1, 68316, '\p{Jg=	Manichaean_Pe}', "");
    Expect(0, 68316, '\p{^Jg=	Manichaean_Pe}', "");
    Expect(0, 68316, '\P{Jg=	Manichaean_Pe}', "");
    Expect(1, 68316, '\P{^Jg=	Manichaean_Pe}', "");
    Expect(0, 68317, '\p{Jg=	Manichaean_Pe}', "");
    Expect(1, 68317, '\p{^Jg=	Manichaean_Pe}', "");
    Expect(1, 68317, '\P{Jg=	Manichaean_Pe}', "");
    Expect(0, 68317, '\P{^Jg=	Manichaean_Pe}', "");
    Error('\p{Is_Joining_Group=-/a/Manichaean_pe}');
    Error('\P{Is_Joining_Group=-/a/Manichaean_pe}');
    Expect(1, 68316, '\p{Is_Joining_Group=manichaeanpe}', "");
    Expect(0, 68316, '\p{^Is_Joining_Group=manichaeanpe}', "");
    Expect(0, 68316, '\P{Is_Joining_Group=manichaeanpe}', "");
    Expect(1, 68316, '\P{^Is_Joining_Group=manichaeanpe}', "");
    Expect(0, 68317, '\p{Is_Joining_Group=manichaeanpe}', "");
    Expect(1, 68317, '\p{^Is_Joining_Group=manichaeanpe}', "");
    Expect(1, 68317, '\P{Is_Joining_Group=manichaeanpe}', "");
    Expect(0, 68317, '\P{^Is_Joining_Group=manichaeanpe}', "");
    Expect(1, 68316, '\p{Is_Joining_Group=-Manichaean_Pe}', "");
    Expect(0, 68316, '\p{^Is_Joining_Group=-Manichaean_Pe}', "");
    Expect(0, 68316, '\P{Is_Joining_Group=-Manichaean_Pe}', "");
    Expect(1, 68316, '\P{^Is_Joining_Group=-Manichaean_Pe}', "");
    Expect(0, 68317, '\p{Is_Joining_Group=-Manichaean_Pe}', "");
    Expect(1, 68317, '\p{^Is_Joining_Group=-Manichaean_Pe}', "");
    Expect(1, 68317, '\P{Is_Joining_Group=-Manichaean_Pe}', "");
    Expect(0, 68317, '\P{^Is_Joining_Group=-Manichaean_Pe}', "");
    Error('\p{Is_Jg= /a/Manichaean_Pe}');
    Error('\P{Is_Jg= /a/Manichaean_Pe}');
    Expect(1, 68316, '\p{Is_Jg=manichaeanpe}', "");
    Expect(0, 68316, '\p{^Is_Jg=manichaeanpe}', "");
    Expect(0, 68316, '\P{Is_Jg=manichaeanpe}', "");
    Expect(1, 68316, '\P{^Is_Jg=manichaeanpe}', "");
    Expect(0, 68317, '\p{Is_Jg=manichaeanpe}', "");
    Expect(1, 68317, '\p{^Is_Jg=manichaeanpe}', "");
    Expect(1, 68317, '\P{Is_Jg=manichaeanpe}', "");
    Expect(0, 68317, '\P{^Is_Jg=manichaeanpe}', "");
    Expect(1, 68316, '\p{Is_Jg=  Manichaean_Pe}', "");
    Expect(0, 68316, '\p{^Is_Jg=  Manichaean_Pe}', "");
    Expect(0, 68316, '\P{Is_Jg=  Manichaean_Pe}', "");
    Expect(1, 68316, '\P{^Is_Jg=  Manichaean_Pe}', "");
    Expect(0, 68317, '\p{Is_Jg=  Manichaean_Pe}', "");
    Expect(1, 68317, '\p{^Is_Jg=  Manichaean_Pe}', "");
    Expect(1, 68317, '\P{Is_Jg=  Manichaean_Pe}', "");
    Expect(0, 68317, '\P{^Is_Jg=  Manichaean_Pe}', "");
    Error('\p{Joining_Group=:=		MANICHAEAN_Qoph}');
    Error('\P{Joining_Group=:=		MANICHAEAN_Qoph}');
    Expect(1, 68320, '\p{Joining_Group=manichaeanqoph}', "");
    Expect(0, 68320, '\p{^Joining_Group=manichaeanqoph}', "");
    Expect(0, 68320, '\P{Joining_Group=manichaeanqoph}', "");
    Expect(1, 68320, '\P{^Joining_Group=manichaeanqoph}', "");
    Expect(0, 68321, '\p{Joining_Group=manichaeanqoph}', "");
    Expect(1, 68321, '\p{^Joining_Group=manichaeanqoph}', "");
    Expect(1, 68321, '\P{Joining_Group=manichaeanqoph}', "");
    Expect(0, 68321, '\P{^Joining_Group=manichaeanqoph}', "");
    Expect(1, 68320, '\p{Joining_Group=-_Manichaean_QOPH}', "");
    Expect(0, 68320, '\p{^Joining_Group=-_Manichaean_QOPH}', "");
    Expect(0, 68320, '\P{Joining_Group=-_Manichaean_QOPH}', "");
    Expect(1, 68320, '\P{^Joining_Group=-_Manichaean_QOPH}', "");
    Expect(0, 68321, '\p{Joining_Group=-_Manichaean_QOPH}', "");
    Expect(1, 68321, '\p{^Joining_Group=-_Manichaean_QOPH}', "");
    Expect(1, 68321, '\P{Joining_Group=-_Manichaean_QOPH}', "");
    Expect(0, 68321, '\P{^Joining_Group=-_Manichaean_QOPH}', "");
    Error('\p{Jg= 	Manichaean_QOPH:=}');
    Error('\P{Jg= 	Manichaean_QOPH:=}');
    Expect(1, 68320, '\p{Jg=manichaeanqoph}', "");
    Expect(0, 68320, '\p{^Jg=manichaeanqoph}', "");
    Expect(0, 68320, '\P{Jg=manichaeanqoph}', "");
    Expect(1, 68320, '\P{^Jg=manichaeanqoph}', "");
    Expect(0, 68321, '\p{Jg=manichaeanqoph}', "");
    Expect(1, 68321, '\p{^Jg=manichaeanqoph}', "");
    Expect(1, 68321, '\P{Jg=manichaeanqoph}', "");
    Expect(0, 68321, '\P{^Jg=manichaeanqoph}', "");
    Expect(1, 68320, '\p{Jg=- manichaean_Qoph}', "");
    Expect(0, 68320, '\p{^Jg=- manichaean_Qoph}', "");
    Expect(0, 68320, '\P{Jg=- manichaean_Qoph}', "");
    Expect(1, 68320, '\P{^Jg=- manichaean_Qoph}', "");
    Expect(0, 68321, '\p{Jg=- manichaean_Qoph}', "");
    Expect(1, 68321, '\p{^Jg=- manichaean_Qoph}', "");
    Expect(1, 68321, '\P{Jg=- manichaean_Qoph}', "");
    Expect(0, 68321, '\P{^Jg=- manichaean_Qoph}', "");
    Error('\p{Is_Joining_Group= /a/manichaean_Qoph}');
    Error('\P{Is_Joining_Group= /a/manichaean_Qoph}');
    Expect(1, 68320, '\p{Is_Joining_Group=manichaeanqoph}', "");
    Expect(0, 68320, '\p{^Is_Joining_Group=manichaeanqoph}', "");
    Expect(0, 68320, '\P{Is_Joining_Group=manichaeanqoph}', "");
    Expect(1, 68320, '\P{^Is_Joining_Group=manichaeanqoph}', "");
    Expect(0, 68321, '\p{Is_Joining_Group=manichaeanqoph}', "");
    Expect(1, 68321, '\p{^Is_Joining_Group=manichaeanqoph}', "");
    Expect(1, 68321, '\P{Is_Joining_Group=manichaeanqoph}', "");
    Expect(0, 68321, '\P{^Is_Joining_Group=manichaeanqoph}', "");
    Expect(1, 68320, '\p{Is_Joining_Group=	Manichaean_qoph}', "");
    Expect(0, 68320, '\p{^Is_Joining_Group=	Manichaean_qoph}', "");
    Expect(0, 68320, '\P{Is_Joining_Group=	Manichaean_qoph}', "");
    Expect(1, 68320, '\P{^Is_Joining_Group=	Manichaean_qoph}', "");
    Expect(0, 68321, '\p{Is_Joining_Group=	Manichaean_qoph}', "");
    Expect(1, 68321, '\p{^Is_Joining_Group=	Manichaean_qoph}', "");
    Expect(1, 68321, '\P{Is_Joining_Group=	Manichaean_qoph}', "");
    Expect(0, 68321, '\P{^Is_Joining_Group=	Manichaean_qoph}', "");
    Error('\p{Is_Jg=:= -Manichaean_Qoph}');
    Error('\P{Is_Jg=:= -Manichaean_Qoph}');
    Expect(1, 68320, '\p{Is_Jg=manichaeanqoph}', "");
    Expect(0, 68320, '\p{^Is_Jg=manichaeanqoph}', "");
    Expect(0, 68320, '\P{Is_Jg=manichaeanqoph}', "");
    Expect(1, 68320, '\P{^Is_Jg=manichaeanqoph}', "");
    Expect(0, 68321, '\p{Is_Jg=manichaeanqoph}', "");
    Expect(1, 68321, '\p{^Is_Jg=manichaeanqoph}', "");
    Expect(1, 68321, '\P{Is_Jg=manichaeanqoph}', "");
    Expect(0, 68321, '\P{^Is_Jg=manichaeanqoph}', "");
    Expect(1, 68320, '\p{Is_Jg=	 Manichaean_qoph}', "");
    Expect(0, 68320, '\p{^Is_Jg=	 Manichaean_qoph}', "");
    Expect(0, 68320, '\P{Is_Jg=	 Manichaean_qoph}', "");
    Expect(1, 68320, '\P{^Is_Jg=	 Manichaean_qoph}', "");
    Expect(0, 68321, '\p{Is_Jg=	 Manichaean_qoph}', "");
    Expect(1, 68321, '\p{^Is_Jg=	 Manichaean_qoph}', "");
    Expect(1, 68321, '\P{Is_Jg=	 Manichaean_qoph}', "");
    Expect(0, 68321, '\P{^Is_Jg=	 Manichaean_qoph}', "");
    Error('\p{Joining_Group::= 	Manichaean_resh}');
    Error('\P{Joining_Group::= 	Manichaean_resh}');
    Expect(1, 68321, '\p{Joining_Group:   manichaeanresh}', "");
    Expect(0, 68321, '\p{^Joining_Group:   manichaeanresh}', "");
    Expect(0, 68321, '\P{Joining_Group:   manichaeanresh}', "");
    Expect(1, 68321, '\P{^Joining_Group:   manichaeanresh}', "");
    Expect(0, 68322, '\p{Joining_Group:   manichaeanresh}', "");
    Expect(1, 68322, '\p{^Joining_Group:   manichaeanresh}', "");
    Expect(1, 68322, '\P{Joining_Group:   manichaeanresh}', "");
    Expect(0, 68322, '\P{^Joining_Group:   manichaeanresh}', "");
    Expect(1, 68321, '\p{Joining_Group=--Manichaean_Resh}', "");
    Expect(0, 68321, '\p{^Joining_Group=--Manichaean_Resh}', "");
    Expect(0, 68321, '\P{Joining_Group=--Manichaean_Resh}', "");
    Expect(1, 68321, '\P{^Joining_Group=--Manichaean_Resh}', "");
    Expect(0, 68322, '\p{Joining_Group=--Manichaean_Resh}', "");
    Expect(1, 68322, '\p{^Joining_Group=--Manichaean_Resh}', "");
    Expect(1, 68322, '\P{Joining_Group=--Manichaean_Resh}', "");
    Expect(0, 68322, '\P{^Joining_Group=--Manichaean_Resh}', "");
    Error('\p{Jg=-:=manichaean_Resh}');
    Error('\P{Jg=-:=manichaean_Resh}');
    Expect(1, 68321, '\p{Jg=manichaeanresh}', "");
    Expect(0, 68321, '\p{^Jg=manichaeanresh}', "");
    Expect(0, 68321, '\P{Jg=manichaeanresh}', "");
    Expect(1, 68321, '\P{^Jg=manichaeanresh}', "");
    Expect(0, 68322, '\p{Jg=manichaeanresh}', "");
    Expect(1, 68322, '\p{^Jg=manichaeanresh}', "");
    Expect(1, 68322, '\P{Jg=manichaeanresh}', "");
    Expect(0, 68322, '\P{^Jg=manichaeanresh}', "");
    Expect(1, 68321, '\p{Jg=		manichaean_Resh}', "");
    Expect(0, 68321, '\p{^Jg=		manichaean_Resh}', "");
    Expect(0, 68321, '\P{Jg=		manichaean_Resh}', "");
    Expect(1, 68321, '\P{^Jg=		manichaean_Resh}', "");
    Expect(0, 68322, '\p{Jg=		manichaean_Resh}', "");
    Expect(1, 68322, '\p{^Jg=		manichaean_Resh}', "");
    Expect(1, 68322, '\P{Jg=		manichaean_Resh}', "");
    Expect(0, 68322, '\P{^Jg=		manichaean_Resh}', "");
    Error('\p{Is_Joining_Group:	/a/-Manichaean_RESH}');
    Error('\P{Is_Joining_Group:	/a/-Manichaean_RESH}');
    Expect(1, 68321, '\p{Is_Joining_Group=manichaeanresh}', "");
    Expect(0, 68321, '\p{^Is_Joining_Group=manichaeanresh}', "");
    Expect(0, 68321, '\P{Is_Joining_Group=manichaeanresh}', "");
    Expect(1, 68321, '\P{^Is_Joining_Group=manichaeanresh}', "");
    Expect(0, 68322, '\p{Is_Joining_Group=manichaeanresh}', "");
    Expect(1, 68322, '\p{^Is_Joining_Group=manichaeanresh}', "");
    Expect(1, 68322, '\P{Is_Joining_Group=manichaeanresh}', "");
    Expect(0, 68322, '\P{^Is_Joining_Group=manichaeanresh}', "");
    Expect(1, 68321, '\p{Is_Joining_Group=Manichaean_Resh}', "");
    Expect(0, 68321, '\p{^Is_Joining_Group=Manichaean_Resh}', "");
    Expect(0, 68321, '\P{Is_Joining_Group=Manichaean_Resh}', "");
    Expect(1, 68321, '\P{^Is_Joining_Group=Manichaean_Resh}', "");
    Expect(0, 68322, '\p{Is_Joining_Group=Manichaean_Resh}', "");
    Expect(1, 68322, '\p{^Is_Joining_Group=Manichaean_Resh}', "");
    Expect(1, 68322, '\P{Is_Joining_Group=Manichaean_Resh}', "");
    Expect(0, 68322, '\P{^Is_Joining_Group=Manichaean_Resh}', "");
    Error('\p{Is_Jg: /a/__Manichaean_Resh}');
    Error('\P{Is_Jg: /a/__Manichaean_Resh}');
    Expect(1, 68321, '\p{Is_Jg=manichaeanresh}', "");
    Expect(0, 68321, '\p{^Is_Jg=manichaeanresh}', "");
    Expect(0, 68321, '\P{Is_Jg=manichaeanresh}', "");
    Expect(1, 68321, '\P{^Is_Jg=manichaeanresh}', "");
    Expect(0, 68322, '\p{Is_Jg=manichaeanresh}', "");
    Expect(1, 68322, '\p{^Is_Jg=manichaeanresh}', "");
    Expect(1, 68322, '\P{Is_Jg=manichaeanresh}', "");
    Expect(0, 68322, '\P{^Is_Jg=manichaeanresh}', "");
    Expect(1, 68321, '\p{Is_Jg:		manichaean_RESH}', "");
    Expect(0, 68321, '\p{^Is_Jg:		manichaean_RESH}', "");
    Expect(0, 68321, '\P{Is_Jg:		manichaean_RESH}', "");
    Expect(1, 68321, '\P{^Is_Jg:		manichaean_RESH}', "");
    Expect(0, 68322, '\p{Is_Jg:		manichaean_RESH}', "");
    Expect(1, 68322, '\p{^Is_Jg:		manichaean_RESH}', "");
    Expect(1, 68322, '\P{Is_Jg:		manichaean_RESH}', "");
    Expect(0, 68322, '\P{^Is_Jg:		manichaean_RESH}', "");
    Error('\p{Joining_Group=:=	-manichaean_sadhe}');
    Error('\P{Joining_Group=:=	-manichaean_sadhe}');
    Expect(1, 68317, '\p{Joining_Group=manichaeansadhe}', "");
    Expect(0, 68317, '\p{^Joining_Group=manichaeansadhe}', "");
    Expect(0, 68317, '\P{Joining_Group=manichaeansadhe}', "");
    Expect(1, 68317, '\P{^Joining_Group=manichaeansadhe}', "");
    Expect(0, 68318, '\p{Joining_Group=manichaeansadhe}', "");
    Expect(1, 68318, '\p{^Joining_Group=manichaeansadhe}', "");
    Expect(1, 68318, '\P{Joining_Group=manichaeansadhe}', "");
    Expect(0, 68318, '\P{^Joining_Group=manichaeansadhe}', "");
    Expect(1, 68317, '\p{Joining_Group= manichaean_SADHE}', "");
    Expect(0, 68317, '\p{^Joining_Group= manichaean_SADHE}', "");
    Expect(0, 68317, '\P{Joining_Group= manichaean_SADHE}', "");
    Expect(1, 68317, '\P{^Joining_Group= manichaean_SADHE}', "");
    Expect(0, 68318, '\p{Joining_Group= manichaean_SADHE}', "");
    Expect(1, 68318, '\p{^Joining_Group= manichaean_SADHE}', "");
    Expect(1, 68318, '\P{Joining_Group= manichaean_SADHE}', "");
    Expect(0, 68318, '\P{^Joining_Group= manichaean_SADHE}', "");
    Error('\p{Jg=:= 	MANICHAEAN_sadhe}');
    Error('\P{Jg=:= 	MANICHAEAN_sadhe}');
    Expect(1, 68317, '\p{Jg:manichaeansadhe}', "");
    Expect(0, 68317, '\p{^Jg:manichaeansadhe}', "");
    Expect(0, 68317, '\P{Jg:manichaeansadhe}', "");
    Expect(1, 68317, '\P{^Jg:manichaeansadhe}', "");
    Expect(0, 68318, '\p{Jg:manichaeansadhe}', "");
    Expect(1, 68318, '\p{^Jg:manichaeansadhe}', "");
    Expect(1, 68318, '\P{Jg:manichaeansadhe}', "");
    Expect(0, 68318, '\P{^Jg:manichaeansadhe}', "");
    Expect(1, 68317, '\p{Jg=_-Manichaean_Sadhe}', "");
    Expect(0, 68317, '\p{^Jg=_-Manichaean_Sadhe}', "");
    Expect(0, 68317, '\P{Jg=_-Manichaean_Sadhe}', "");
    Expect(1, 68317, '\P{^Jg=_-Manichaean_Sadhe}', "");
    Expect(0, 68318, '\p{Jg=_-Manichaean_Sadhe}', "");
    Expect(1, 68318, '\p{^Jg=_-Manichaean_Sadhe}', "");
    Expect(1, 68318, '\P{Jg=_-Manichaean_Sadhe}', "");
    Expect(0, 68318, '\P{^Jg=_-Manichaean_Sadhe}', "");
    Error('\p{Is_Joining_Group:	:=- manichaean_Sadhe}');
    Error('\P{Is_Joining_Group:	:=- manichaean_Sadhe}');
    Expect(1, 68317, '\p{Is_Joining_Group=manichaeansadhe}', "");
    Expect(0, 68317, '\p{^Is_Joining_Group=manichaeansadhe}', "");
    Expect(0, 68317, '\P{Is_Joining_Group=manichaeansadhe}', "");
    Expect(1, 68317, '\P{^Is_Joining_Group=manichaeansadhe}', "");
    Expect(0, 68318, '\p{Is_Joining_Group=manichaeansadhe}', "");
    Expect(1, 68318, '\p{^Is_Joining_Group=manichaeansadhe}', "");
    Expect(1, 68318, '\P{Is_Joining_Group=manichaeansadhe}', "");
    Expect(0, 68318, '\P{^Is_Joining_Group=manichaeansadhe}', "");
    Expect(1, 68317, '\p{Is_Joining_Group=_	Manichaean_Sadhe}', "");
    Expect(0, 68317, '\p{^Is_Joining_Group=_	Manichaean_Sadhe}', "");
    Expect(0, 68317, '\P{Is_Joining_Group=_	Manichaean_Sadhe}', "");
    Expect(1, 68317, '\P{^Is_Joining_Group=_	Manichaean_Sadhe}', "");
    Expect(0, 68318, '\p{Is_Joining_Group=_	Manichaean_Sadhe}', "");
    Expect(1, 68318, '\p{^Is_Joining_Group=_	Manichaean_Sadhe}', "");
    Expect(1, 68318, '\P{Is_Joining_Group=_	Manichaean_Sadhe}', "");
    Expect(0, 68318, '\P{^Is_Joining_Group=_	Manichaean_Sadhe}', "");
    Error('\p{Is_Jg=/a/ 	Manichaean_SADHE}');
    Error('\P{Is_Jg=/a/ 	Manichaean_SADHE}');
    Expect(1, 68317, '\p{Is_Jg:   manichaeansadhe}', "");
    Expect(0, 68317, '\p{^Is_Jg:   manichaeansadhe}', "");
    Expect(0, 68317, '\P{Is_Jg:   manichaeansadhe}', "");
    Expect(1, 68317, '\P{^Is_Jg:   manichaeansadhe}', "");
    Expect(0, 68318, '\p{Is_Jg:   manichaeansadhe}', "");
    Expect(1, 68318, '\p{^Is_Jg:   manichaeansadhe}', "");
    Expect(1, 68318, '\P{Is_Jg:   manichaeansadhe}', "");
    Expect(0, 68318, '\P{^Is_Jg:   manichaeansadhe}', "");
    Expect(1, 68317, '\p{Is_Jg= manichaean_SADHE}', "");
    Expect(0, 68317, '\p{^Is_Jg= manichaean_SADHE}', "");
    Expect(0, 68317, '\P{Is_Jg= manichaean_SADHE}', "");
    Expect(1, 68317, '\P{^Is_Jg= manichaean_SADHE}', "");
    Expect(0, 68318, '\p{Is_Jg= manichaean_SADHE}', "");
    Expect(1, 68318, '\p{^Is_Jg= manichaean_SADHE}', "");
    Expect(1, 68318, '\P{Is_Jg= manichaean_SADHE}', "");
    Expect(0, 68318, '\P{^Is_Jg= manichaean_SADHE}', "");
    Error('\p{Joining_Group=	 MANICHAEAN_Samekh:=}');
    Error('\P{Joining_Group=	 MANICHAEAN_Samekh:=}');
    Expect(1, 68312, '\p{Joining_Group=manichaeansamekh}', "");
    Expect(0, 68312, '\p{^Joining_Group=manichaeansamekh}', "");
    Expect(0, 68312, '\P{Joining_Group=manichaeansamekh}', "");
    Expect(1, 68312, '\P{^Joining_Group=manichaeansamekh}', "");
    Expect(0, 68313, '\p{Joining_Group=manichaeansamekh}', "");
    Expect(1, 68313, '\p{^Joining_Group=manichaeansamekh}', "");
    Expect(1, 68313, '\P{Joining_Group=manichaeansamekh}', "");
    Expect(0, 68313, '\P{^Joining_Group=manichaeansamekh}', "");
    Expect(1, 68312, '\p{Joining_Group=_Manichaean_Samekh}', "");
    Expect(0, 68312, '\p{^Joining_Group=_Manichaean_Samekh}', "");
    Expect(0, 68312, '\P{Joining_Group=_Manichaean_Samekh}', "");
    Expect(1, 68312, '\P{^Joining_Group=_Manichaean_Samekh}', "");
    Expect(0, 68313, '\p{Joining_Group=_Manichaean_Samekh}', "");
    Expect(1, 68313, '\p{^Joining_Group=_Manichaean_Samekh}', "");
    Expect(1, 68313, '\P{Joining_Group=_Manichaean_Samekh}', "");
    Expect(0, 68313, '\P{^Joining_Group=_Manichaean_Samekh}', "");
    Error('\p{Jg=	:=manichaean_Samekh}');
    Error('\P{Jg=	:=manichaean_Samekh}');
    Expect(1, 68312, '\p{Jg=manichaeansamekh}', "");
    Expect(0, 68312, '\p{^Jg=manichaeansamekh}', "");
    Expect(0, 68312, '\P{Jg=manichaeansamekh}', "");
    Expect(1, 68312, '\P{^Jg=manichaeansamekh}', "");
    Expect(0, 68313, '\p{Jg=manichaeansamekh}', "");
    Expect(1, 68313, '\p{^Jg=manichaeansamekh}', "");
    Expect(1, 68313, '\P{Jg=manichaeansamekh}', "");
    Expect(0, 68313, '\P{^Jg=manichaeansamekh}', "");
    Expect(1, 68312, '\p{Jg=_ manichaean_samekh}', "");
    Expect(0, 68312, '\p{^Jg=_ manichaean_samekh}', "");
    Expect(0, 68312, '\P{Jg=_ manichaean_samekh}', "");
    Expect(1, 68312, '\P{^Jg=_ manichaean_samekh}', "");
    Expect(0, 68313, '\p{Jg=_ manichaean_samekh}', "");
    Expect(1, 68313, '\p{^Jg=_ manichaean_samekh}', "");
    Expect(1, 68313, '\P{Jg=_ manichaean_samekh}', "");
    Expect(0, 68313, '\P{^Jg=_ manichaean_samekh}', "");
    Error('\p{Is_Joining_Group=	 Manichaean_samekh:=}');
    Error('\P{Is_Joining_Group=	 Manichaean_samekh:=}');
    Expect(1, 68312, '\p{Is_Joining_Group=manichaeansamekh}', "");
    Expect(0, 68312, '\p{^Is_Joining_Group=manichaeansamekh}', "");
    Expect(0, 68312, '\P{Is_Joining_Group=manichaeansamekh}', "");
    Expect(1, 68312, '\P{^Is_Joining_Group=manichaeansamekh}', "");
    Expect(0, 68313, '\p{Is_Joining_Group=manichaeansamekh}', "");
    Expect(1, 68313, '\p{^Is_Joining_Group=manichaeansamekh}', "");
    Expect(1, 68313, '\P{Is_Joining_Group=manichaeansamekh}', "");
    Expect(0, 68313, '\P{^Is_Joining_Group=manichaeansamekh}', "");
    Expect(1, 68312, '\p{Is_Joining_Group= 	Manichaean_Samekh}', "");
    Expect(0, 68312, '\p{^Is_Joining_Group= 	Manichaean_Samekh}', "");
    Expect(0, 68312, '\P{Is_Joining_Group= 	Manichaean_Samekh}', "");
    Expect(1, 68312, '\P{^Is_Joining_Group= 	Manichaean_Samekh}', "");
    Expect(0, 68313, '\p{Is_Joining_Group= 	Manichaean_Samekh}', "");
    Expect(1, 68313, '\p{^Is_Joining_Group= 	Manichaean_Samekh}', "");
    Expect(1, 68313, '\P{Is_Joining_Group= 	Manichaean_Samekh}', "");
    Expect(0, 68313, '\P{^Is_Joining_Group= 	Manichaean_Samekh}', "");
    Error('\p{Is_Jg: 	MANICHAEAN_SAMEKH:=}');
    Error('\P{Is_Jg: 	MANICHAEAN_SAMEKH:=}');
    Expect(1, 68312, '\p{Is_Jg=manichaeansamekh}', "");
    Expect(0, 68312, '\p{^Is_Jg=manichaeansamekh}', "");
    Expect(0, 68312, '\P{Is_Jg=manichaeansamekh}', "");
    Expect(1, 68312, '\P{^Is_Jg=manichaeansamekh}', "");
    Expect(0, 68313, '\p{Is_Jg=manichaeansamekh}', "");
    Expect(1, 68313, '\p{^Is_Jg=manichaeansamekh}', "");
    Expect(1, 68313, '\P{Is_Jg=manichaeansamekh}', "");
    Expect(0, 68313, '\P{^Is_Jg=manichaeansamekh}', "");
    Expect(1, 68312, '\p{Is_Jg=	 Manichaean_Samekh}', "");
    Expect(0, 68312, '\p{^Is_Jg=	 Manichaean_Samekh}', "");
    Expect(0, 68312, '\P{Is_Jg=	 Manichaean_Samekh}', "");
    Expect(1, 68312, '\P{^Is_Jg=	 Manichaean_Samekh}', "");
    Expect(0, 68313, '\p{Is_Jg=	 Manichaean_Samekh}', "");
    Expect(1, 68313, '\p{^Is_Jg=	 Manichaean_Samekh}', "");
    Expect(1, 68313, '\P{Is_Jg=	 Manichaean_Samekh}', "");
    Expect(0, 68313, '\P{^Is_Jg=	 Manichaean_Samekh}', "");
    Error('\p{Joining_Group=:=_ MANICHAEAN_Taw}');
    Error('\P{Joining_Group=:=_ MANICHAEAN_Taw}');
    Expect(1, 68324, '\p{Joining_Group=manichaeantaw}', "");
    Expect(0, 68324, '\p{^Joining_Group=manichaeantaw}', "");
    Expect(0, 68324, '\P{Joining_Group=manichaeantaw}', "");
    Expect(1, 68324, '\P{^Joining_Group=manichaeantaw}', "");
    Expect(0, 68325, '\p{Joining_Group=manichaeantaw}', "");
    Expect(1, 68325, '\p{^Joining_Group=manichaeantaw}', "");
    Expect(1, 68325, '\P{Joining_Group=manichaeantaw}', "");
    Expect(0, 68325, '\P{^Joining_Group=manichaeantaw}', "");
    Expect(1, 68324, '\p{Joining_Group= -Manichaean_taw}', "");
    Expect(0, 68324, '\p{^Joining_Group= -Manichaean_taw}', "");
    Expect(0, 68324, '\P{Joining_Group= -Manichaean_taw}', "");
    Expect(1, 68324, '\P{^Joining_Group= -Manichaean_taw}', "");
    Expect(0, 68325, '\p{Joining_Group= -Manichaean_taw}', "");
    Expect(1, 68325, '\p{^Joining_Group= -Manichaean_taw}', "");
    Expect(1, 68325, '\P{Joining_Group= -Manichaean_taw}', "");
    Expect(0, 68325, '\P{^Joining_Group= -Manichaean_taw}', "");
    Error('\p{Jg= /a/Manichaean_taw}');
    Error('\P{Jg= /a/Manichaean_taw}');
    Expect(1, 68324, '\p{Jg=manichaeantaw}', "");
    Expect(0, 68324, '\p{^Jg=manichaeantaw}', "");
    Expect(0, 68324, '\P{Jg=manichaeantaw}', "");
    Expect(1, 68324, '\P{^Jg=manichaeantaw}', "");
    Expect(0, 68325, '\p{Jg=manichaeantaw}', "");
    Expect(1, 68325, '\p{^Jg=manichaeantaw}', "");
    Expect(1, 68325, '\P{Jg=manichaeantaw}', "");
    Expect(0, 68325, '\P{^Jg=manichaeantaw}', "");
    Expect(1, 68324, '\p{Jg:  _MANICHAEAN_taw}', "");
    Expect(0, 68324, '\p{^Jg:  _MANICHAEAN_taw}', "");
    Expect(0, 68324, '\P{Jg:  _MANICHAEAN_taw}', "");
    Expect(1, 68324, '\P{^Jg:  _MANICHAEAN_taw}', "");
    Expect(0, 68325, '\p{Jg:  _MANICHAEAN_taw}', "");
    Expect(1, 68325, '\p{^Jg:  _MANICHAEAN_taw}', "");
    Expect(1, 68325, '\P{Jg:  _MANICHAEAN_taw}', "");
    Expect(0, 68325, '\P{^Jg:  _MANICHAEAN_taw}', "");
    Error('\p{Is_Joining_Group=/a/--manichaean_Taw}');
    Error('\P{Is_Joining_Group=/a/--manichaean_Taw}');
    Expect(1, 68324, '\p{Is_Joining_Group=manichaeantaw}', "");
    Expect(0, 68324, '\p{^Is_Joining_Group=manichaeantaw}', "");
    Expect(0, 68324, '\P{Is_Joining_Group=manichaeantaw}', "");
    Expect(1, 68324, '\P{^Is_Joining_Group=manichaeantaw}', "");
    Expect(0, 68325, '\p{Is_Joining_Group=manichaeantaw}', "");
    Expect(1, 68325, '\p{^Is_Joining_Group=manichaeantaw}', "");
    Expect(1, 68325, '\P{Is_Joining_Group=manichaeantaw}', "");
    Expect(0, 68325, '\P{^Is_Joining_Group=manichaeantaw}', "");
    Expect(1, 68324, '\p{Is_Joining_Group=-_Manichaean_TAW}', "");
    Expect(0, 68324, '\p{^Is_Joining_Group=-_Manichaean_TAW}', "");
    Expect(0, 68324, '\P{Is_Joining_Group=-_Manichaean_TAW}', "");
    Expect(1, 68324, '\P{^Is_Joining_Group=-_Manichaean_TAW}', "");
    Expect(0, 68325, '\p{Is_Joining_Group=-_Manichaean_TAW}', "");
    Expect(1, 68325, '\p{^Is_Joining_Group=-_Manichaean_TAW}', "");
    Expect(1, 68325, '\P{Is_Joining_Group=-_Manichaean_TAW}', "");
    Expect(0, 68325, '\P{^Is_Joining_Group=-_Manichaean_TAW}', "");
    Error('\p{Is_Jg=/a/_	MANICHAEAN_Taw}');
    Error('\P{Is_Jg=/a/_	MANICHAEAN_Taw}');
    Expect(1, 68324, '\p{Is_Jg=manichaeantaw}', "");
    Expect(0, 68324, '\p{^Is_Jg=manichaeantaw}', "");
    Expect(0, 68324, '\P{Is_Jg=manichaeantaw}', "");
    Expect(1, 68324, '\P{^Is_Jg=manichaeantaw}', "");
    Expect(0, 68325, '\p{Is_Jg=manichaeantaw}', "");
    Expect(1, 68325, '\p{^Is_Jg=manichaeantaw}', "");
    Expect(1, 68325, '\P{Is_Jg=manichaeantaw}', "");
    Expect(0, 68325, '\P{^Is_Jg=manichaeantaw}', "");
    Expect(1, 68324, '\p{Is_Jg= Manichaean_Taw}', "");
    Expect(0, 68324, '\p{^Is_Jg= Manichaean_Taw}', "");
    Expect(0, 68324, '\P{Is_Jg= Manichaean_Taw}', "");
    Expect(1, 68324, '\P{^Is_Jg= Manichaean_Taw}', "");
    Expect(0, 68325, '\p{Is_Jg= Manichaean_Taw}', "");
    Expect(1, 68325, '\p{^Is_Jg= Manichaean_Taw}', "");
    Expect(1, 68325, '\P{Is_Jg= Manichaean_Taw}', "");
    Expect(0, 68325, '\P{^Is_Jg= Manichaean_Taw}', "");
    Error('\p{Joining_Group=__Manichaean_ten:=}');
    Error('\P{Joining_Group=__Manichaean_ten:=}');
    Expect(1, 68333, '\p{Joining_Group=manichaeanten}', "");
    Expect(0, 68333, '\p{^Joining_Group=manichaeanten}', "");
    Expect(0, 68333, '\P{Joining_Group=manichaeanten}', "");
    Expect(1, 68333, '\P{^Joining_Group=manichaeanten}', "");
    Expect(0, 68334, '\p{Joining_Group=manichaeanten}', "");
    Expect(1, 68334, '\p{^Joining_Group=manichaeanten}', "");
    Expect(1, 68334, '\P{Joining_Group=manichaeanten}', "");
    Expect(0, 68334, '\P{^Joining_Group=manichaeanten}', "");
    Expect(1, 68333, '\p{Joining_Group=	_Manichaean_TEN}', "");
    Expect(0, 68333, '\p{^Joining_Group=	_Manichaean_TEN}', "");
    Expect(0, 68333, '\P{Joining_Group=	_Manichaean_TEN}', "");
    Expect(1, 68333, '\P{^Joining_Group=	_Manichaean_TEN}', "");
    Expect(0, 68334, '\p{Joining_Group=	_Manichaean_TEN}', "");
    Expect(1, 68334, '\p{^Joining_Group=	_Manichaean_TEN}', "");
    Expect(1, 68334, '\P{Joining_Group=	_Manichaean_TEN}', "");
    Expect(0, 68334, '\P{^Joining_Group=	_Manichaean_TEN}', "");
    Error('\p{Jg=_:=Manichaean_Ten}');
    Error('\P{Jg=_:=Manichaean_Ten}');
    Expect(1, 68333, '\p{Jg: manichaeanten}', "");
    Expect(0, 68333, '\p{^Jg: manichaeanten}', "");
    Expect(0, 68333, '\P{Jg: manichaeanten}', "");
    Expect(1, 68333, '\P{^Jg: manichaeanten}', "");
    Expect(0, 68334, '\p{Jg: manichaeanten}', "");
    Expect(1, 68334, '\p{^Jg: manichaeanten}', "");
    Expect(1, 68334, '\P{Jg: manichaeanten}', "");
    Expect(0, 68334, '\P{^Jg: manichaeanten}', "");
    Expect(1, 68333, '\p{Jg=-MANICHAEAN_Ten}', "");
    Expect(0, 68333, '\p{^Jg=-MANICHAEAN_Ten}', "");
    Expect(0, 68333, '\P{Jg=-MANICHAEAN_Ten}', "");
    Expect(1, 68333, '\P{^Jg=-MANICHAEAN_Ten}', "");
    Expect(0, 68334, '\p{Jg=-MANICHAEAN_Ten}', "");
    Expect(1, 68334, '\p{^Jg=-MANICHAEAN_Ten}', "");
    Expect(1, 68334, '\P{Jg=-MANICHAEAN_Ten}', "");
    Expect(0, 68334, '\P{^Jg=-MANICHAEAN_Ten}', "");
    Error('\p{Is_Joining_Group: :=-Manichaean_Ten}');
    Error('\P{Is_Joining_Group: :=-Manichaean_Ten}');
    Expect(1, 68333, '\p{Is_Joining_Group=manichaeanten}', "");
    Expect(0, 68333, '\p{^Is_Joining_Group=manichaeanten}', "");
    Expect(0, 68333, '\P{Is_Joining_Group=manichaeanten}', "");
    Expect(1, 68333, '\P{^Is_Joining_Group=manichaeanten}', "");
    Expect(0, 68334, '\p{Is_Joining_Group=manichaeanten}', "");
    Expect(1, 68334, '\p{^Is_Joining_Group=manichaeanten}', "");
    Expect(1, 68334, '\P{Is_Joining_Group=manichaeanten}', "");
    Expect(0, 68334, '\P{^Is_Joining_Group=manichaeanten}', "");
    Expect(1, 68333, '\p{Is_Joining_Group= _Manichaean_ten}', "");
    Expect(0, 68333, '\p{^Is_Joining_Group= _Manichaean_ten}', "");
    Expect(0, 68333, '\P{Is_Joining_Group= _Manichaean_ten}', "");
    Expect(1, 68333, '\P{^Is_Joining_Group= _Manichaean_ten}', "");
    Expect(0, 68334, '\p{Is_Joining_Group= _Manichaean_ten}', "");
    Expect(1, 68334, '\p{^Is_Joining_Group= _Manichaean_ten}', "");
    Expect(1, 68334, '\P{Is_Joining_Group= _Manichaean_ten}', "");
    Expect(0, 68334, '\P{^Is_Joining_Group= _Manichaean_ten}', "");
    Error('\p{Is_Jg=/a/ Manichaean_Ten}');
    Error('\P{Is_Jg=/a/ Manichaean_Ten}');
    Expect(1, 68333, '\p{Is_Jg=manichaeanten}', "");
    Expect(0, 68333, '\p{^Is_Jg=manichaeanten}', "");
    Expect(0, 68333, '\P{Is_Jg=manichaeanten}', "");
    Expect(1, 68333, '\P{^Is_Jg=manichaeanten}', "");
    Expect(0, 68334, '\p{Is_Jg=manichaeanten}', "");
    Expect(1, 68334, '\p{^Is_Jg=manichaeanten}', "");
    Expect(1, 68334, '\P{Is_Jg=manichaeanten}', "");
    Expect(0, 68334, '\P{^Is_Jg=manichaeanten}', "");
    Expect(1, 68333, '\p{Is_Jg=-Manichaean_ten}', "");
    Expect(0, 68333, '\p{^Is_Jg=-Manichaean_ten}', "");
    Expect(0, 68333, '\P{Is_Jg=-Manichaean_ten}', "");
    Expect(1, 68333, '\P{^Is_Jg=-Manichaean_ten}', "");
    Expect(0, 68334, '\p{Is_Jg=-Manichaean_ten}', "");
    Expect(1, 68334, '\p{^Is_Jg=-Manichaean_ten}', "");
    Expect(1, 68334, '\P{Is_Jg=-Manichaean_ten}', "");
    Expect(0, 68334, '\P{^Is_Jg=-Manichaean_ten}', "");
    Error('\p{Joining_Group=/a/	Manichaean_TETH}');
    Error('\P{Joining_Group=/a/	Manichaean_TETH}');
    Expect(1, 68302, '\p{Joining_Group=manichaeanteth}', "");
    Expect(0, 68302, '\p{^Joining_Group=manichaeanteth}', "");
    Expect(0, 68302, '\P{Joining_Group=manichaeanteth}', "");
    Expect(1, 68302, '\P{^Joining_Group=manichaeanteth}', "");
    Expect(0, 68303, '\p{Joining_Group=manichaeanteth}', "");
    Expect(1, 68303, '\p{^Joining_Group=manichaeanteth}', "");
    Expect(1, 68303, '\P{Joining_Group=manichaeanteth}', "");
    Expect(0, 68303, '\P{^Joining_Group=manichaeanteth}', "");
    Expect(1, 68302, '\p{Joining_Group=	 MANICHAEAN_TETH}', "");
    Expect(0, 68302, '\p{^Joining_Group=	 MANICHAEAN_TETH}', "");
    Expect(0, 68302, '\P{Joining_Group=	 MANICHAEAN_TETH}', "");
    Expect(1, 68302, '\P{^Joining_Group=	 MANICHAEAN_TETH}', "");
    Expect(0, 68303, '\p{Joining_Group=	 MANICHAEAN_TETH}', "");
    Expect(1, 68303, '\p{^Joining_Group=	 MANICHAEAN_TETH}', "");
    Expect(1, 68303, '\P{Joining_Group=	 MANICHAEAN_TETH}', "");
    Expect(0, 68303, '\P{^Joining_Group=	 MANICHAEAN_TETH}', "");
    Error('\p{Jg=_	Manichaean_Teth/a/}');
    Error('\P{Jg=_	Manichaean_Teth/a/}');
    Expect(1, 68302, '\p{Jg=manichaeanteth}', "");
    Expect(0, 68302, '\p{^Jg=manichaeanteth}', "");
    Expect(0, 68302, '\P{Jg=manichaeanteth}', "");
    Expect(1, 68302, '\P{^Jg=manichaeanteth}', "");
    Expect(0, 68303, '\p{Jg=manichaeanteth}', "");
    Expect(1, 68303, '\p{^Jg=manichaeanteth}', "");
    Expect(1, 68303, '\P{Jg=manichaeanteth}', "");
    Expect(0, 68303, '\P{^Jg=manichaeanteth}', "");
    Expect(1, 68302, '\p{Jg:	Manichaean_Teth}', "");
    Expect(0, 68302, '\p{^Jg:	Manichaean_Teth}', "");
    Expect(0, 68302, '\P{Jg:	Manichaean_Teth}', "");
    Expect(1, 68302, '\P{^Jg:	Manichaean_Teth}', "");
    Expect(0, 68303, '\p{Jg:	Manichaean_Teth}', "");
    Expect(1, 68303, '\p{^Jg:	Manichaean_Teth}', "");
    Expect(1, 68303, '\P{Jg:	Manichaean_Teth}', "");
    Expect(0, 68303, '\P{^Jg:	Manichaean_Teth}', "");
    Error('\p{Is_Joining_Group=_/a/manichaean_Teth}');
    Error('\P{Is_Joining_Group=_/a/manichaean_Teth}');
    Expect(1, 68302, '\p{Is_Joining_Group=manichaeanteth}', "");
    Expect(0, 68302, '\p{^Is_Joining_Group=manichaeanteth}', "");
    Expect(0, 68302, '\P{Is_Joining_Group=manichaeanteth}', "");
    Expect(1, 68302, '\P{^Is_Joining_Group=manichaeanteth}', "");
    Expect(0, 68303, '\p{Is_Joining_Group=manichaeanteth}', "");
    Expect(1, 68303, '\p{^Is_Joining_Group=manichaeanteth}', "");
    Expect(1, 68303, '\P{Is_Joining_Group=manichaeanteth}', "");
    Expect(0, 68303, '\P{^Is_Joining_Group=manichaeanteth}', "");
    Expect(1, 68302, '\p{Is_Joining_Group=_Manichaean_teth}', "");
    Expect(0, 68302, '\p{^Is_Joining_Group=_Manichaean_teth}', "");
    Expect(0, 68302, '\P{Is_Joining_Group=_Manichaean_teth}', "");
    Expect(1, 68302, '\P{^Is_Joining_Group=_Manichaean_teth}', "");
    Expect(0, 68303, '\p{Is_Joining_Group=_Manichaean_teth}', "");
    Expect(1, 68303, '\p{^Is_Joining_Group=_Manichaean_teth}', "");
    Expect(1, 68303, '\P{Is_Joining_Group=_Manichaean_teth}', "");
    Expect(0, 68303, '\P{^Is_Joining_Group=_Manichaean_teth}', "");
    Error('\p{Is_Jg:_:=manichaean_teth}');
    Error('\P{Is_Jg:_:=manichaean_teth}');
    Expect(1, 68302, '\p{Is_Jg: manichaeanteth}', "");
    Expect(0, 68302, '\p{^Is_Jg: manichaeanteth}', "");
    Expect(0, 68302, '\P{Is_Jg: manichaeanteth}', "");
    Expect(1, 68302, '\P{^Is_Jg: manichaeanteth}', "");
    Expect(0, 68303, '\p{Is_Jg: manichaeanteth}', "");
    Expect(1, 68303, '\p{^Is_Jg: manichaeanteth}', "");
    Expect(1, 68303, '\P{Is_Jg: manichaeanteth}', "");
    Expect(0, 68303, '\P{^Is_Jg: manichaeanteth}', "");
    Expect(1, 68302, '\p{Is_Jg= -Manichaean_TETH}', "");
    Expect(0, 68302, '\p{^Is_Jg= -Manichaean_TETH}', "");
    Expect(0, 68302, '\P{Is_Jg= -Manichaean_TETH}', "");
    Expect(1, 68302, '\P{^Is_Jg= -Manichaean_TETH}', "");
    Expect(0, 68303, '\p{Is_Jg= -Manichaean_TETH}', "");
    Expect(1, 68303, '\p{^Is_Jg= -Manichaean_TETH}', "");
    Expect(1, 68303, '\P{Is_Jg= -Manichaean_TETH}', "");
    Expect(0, 68303, '\P{^Is_Jg= -Manichaean_TETH}', "");
    Error('\p{Joining_Group=/a/ manichaean_Thamedh}');
    Error('\P{Joining_Group=/a/ manichaean_Thamedh}');
    Expect(1, 68309, '\p{Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68309, '\p{^Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68309, '\P{Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68309, '\P{^Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68310, '\p{Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68310, '\p{^Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68310, '\P{Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68310, '\P{^Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68309, '\p{Joining_Group=-_Manichaean_thamedh}', "");
    Expect(0, 68309, '\p{^Joining_Group=-_Manichaean_thamedh}', "");
    Expect(0, 68309, '\P{Joining_Group=-_Manichaean_thamedh}', "");
    Expect(1, 68309, '\P{^Joining_Group=-_Manichaean_thamedh}', "");
    Expect(0, 68310, '\p{Joining_Group=-_Manichaean_thamedh}', "");
    Expect(1, 68310, '\p{^Joining_Group=-_Manichaean_thamedh}', "");
    Expect(1, 68310, '\P{Joining_Group=-_Manichaean_thamedh}', "");
    Expect(0, 68310, '\P{^Joining_Group=-_Manichaean_thamedh}', "");
    Error('\p{Jg=	Manichaean_Thamedh/a/}');
    Error('\P{Jg=	Manichaean_Thamedh/a/}');
    Expect(1, 68309, '\p{Jg=manichaeanthamedh}', "");
    Expect(0, 68309, '\p{^Jg=manichaeanthamedh}', "");
    Expect(0, 68309, '\P{Jg=manichaeanthamedh}', "");
    Expect(1, 68309, '\P{^Jg=manichaeanthamedh}', "");
    Expect(0, 68310, '\p{Jg=manichaeanthamedh}', "");
    Expect(1, 68310, '\p{^Jg=manichaeanthamedh}', "");
    Expect(1, 68310, '\P{Jg=manichaeanthamedh}', "");
    Expect(0, 68310, '\P{^Jg=manichaeanthamedh}', "");
    Expect(1, 68309, '\p{Jg= -Manichaean_Thamedh}', "");
    Expect(0, 68309, '\p{^Jg= -Manichaean_Thamedh}', "");
    Expect(0, 68309, '\P{Jg= -Manichaean_Thamedh}', "");
    Expect(1, 68309, '\P{^Jg= -Manichaean_Thamedh}', "");
    Expect(0, 68310, '\p{Jg= -Manichaean_Thamedh}', "");
    Expect(1, 68310, '\p{^Jg= -Manichaean_Thamedh}', "");
    Expect(1, 68310, '\P{Jg= -Manichaean_Thamedh}', "");
    Expect(0, 68310, '\P{^Jg= -Manichaean_Thamedh}', "");
    Error('\p{Is_Joining_Group=- MANICHAEAN_Thamedh:=}');
    Error('\P{Is_Joining_Group=- MANICHAEAN_Thamedh:=}');
    Expect(1, 68309, '\p{Is_Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68309, '\p{^Is_Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68309, '\P{Is_Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68309, '\P{^Is_Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68310, '\p{Is_Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68310, '\p{^Is_Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68310, '\P{Is_Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68310, '\P{^Is_Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68309, '\p{Is_Joining_Group=_	manichaean_thamedh}', "");
    Expect(0, 68309, '\p{^Is_Joining_Group=_	manichaean_thamedh}', "");
    Expect(0, 68309, '\P{Is_Joining_Group=_	manichaean_thamedh}', "");
    Expect(1, 68309, '\P{^Is_Joining_Group=_	manichaean_thamedh}', "");
    Expect(0, 68310, '\p{Is_Joining_Group=_	manichaean_thamedh}', "");
    Expect(1, 68310, '\p{^Is_Joining_Group=_	manichaean_thamedh}', "");
    Expect(1, 68310, '\P{Is_Joining_Group=_	manichaean_thamedh}', "");
    Expect(0, 68310, '\P{^Is_Joining_Group=_	manichaean_thamedh}', "");
    Error('\p{Is_Jg=:=--manichaean_Thamedh}');
    Error('\P{Is_Jg=:=--manichaean_Thamedh}');
    Expect(1, 68309, '\p{Is_Jg=manichaeanthamedh}', "");
    Expect(0, 68309, '\p{^Is_Jg=manichaeanthamedh}', "");
    Expect(0, 68309, '\P{Is_Jg=manichaeanthamedh}', "");
    Expect(1, 68309, '\P{^Is_Jg=manichaeanthamedh}', "");
    Expect(0, 68310, '\p{Is_Jg=manichaeanthamedh}', "");
    Expect(1, 68310, '\p{^Is_Jg=manichaeanthamedh}', "");
    Expect(1, 68310, '\P{Is_Jg=manichaeanthamedh}', "");
    Expect(0, 68310, '\P{^Is_Jg=manichaeanthamedh}', "");
    Expect(1, 68309, '\p{Is_Jg= -MANICHAEAN_THAMEDH}', "");
    Expect(0, 68309, '\p{^Is_Jg= -MANICHAEAN_THAMEDH}', "");
    Expect(0, 68309, '\P{Is_Jg= -MANICHAEAN_THAMEDH}', "");
    Expect(1, 68309, '\P{^Is_Jg= -MANICHAEAN_THAMEDH}', "");
    Expect(0, 68310, '\p{Is_Jg= -MANICHAEAN_THAMEDH}', "");
    Expect(1, 68310, '\p{^Is_Jg= -MANICHAEAN_THAMEDH}', "");
    Expect(1, 68310, '\P{Is_Jg= -MANICHAEAN_THAMEDH}', "");
    Expect(0, 68310, '\P{^Is_Jg= -MANICHAEAN_THAMEDH}', "");
    Error('\p{Joining_Group=_Manichaean_twenty/a/}');
    Error('\P{Joining_Group=_Manichaean_twenty/a/}');
    Expect(1, 68334, '\p{Joining_Group=manichaeantwenty}', "");
    Expect(0, 68334, '\p{^Joining_Group=manichaeantwenty}', "");
    Expect(0, 68334, '\P{Joining_Group=manichaeantwenty}', "");
    Expect(1, 68334, '\P{^Joining_Group=manichaeantwenty}', "");
    Expect(0, 68335, '\p{Joining_Group=manichaeantwenty}', "");
    Expect(1, 68335, '\p{^Joining_Group=manichaeantwenty}', "");
    Expect(1, 68335, '\P{Joining_Group=manichaeantwenty}', "");
    Expect(0, 68335, '\P{^Joining_Group=manichaeantwenty}', "");
    Expect(1, 68334, '\p{Joining_Group= -manichaean_Twenty}', "");
    Expect(0, 68334, '\p{^Joining_Group= -manichaean_Twenty}', "");
    Expect(0, 68334, '\P{Joining_Group= -manichaean_Twenty}', "");
    Expect(1, 68334, '\P{^Joining_Group= -manichaean_Twenty}', "");
    Expect(0, 68335, '\p{Joining_Group= -manichaean_Twenty}', "");
    Expect(1, 68335, '\p{^Joining_Group= -manichaean_Twenty}', "");
    Expect(1, 68335, '\P{Joining_Group= -manichaean_Twenty}', "");
    Expect(0, 68335, '\P{^Joining_Group= -manichaean_Twenty}', "");
    Error('\p{Jg=/a/ MANICHAEAN_Twenty}');
    Error('\P{Jg=/a/ MANICHAEAN_Twenty}');
    Expect(1, 68334, '\p{Jg=manichaeantwenty}', "");
    Expect(0, 68334, '\p{^Jg=manichaeantwenty}', "");
    Expect(0, 68334, '\P{Jg=manichaeantwenty}', "");
    Expect(1, 68334, '\P{^Jg=manichaeantwenty}', "");
    Expect(0, 68335, '\p{Jg=manichaeantwenty}', "");
    Expect(1, 68335, '\p{^Jg=manichaeantwenty}', "");
    Expect(1, 68335, '\P{Jg=manichaeantwenty}', "");
    Expect(0, 68335, '\P{^Jg=manichaeantwenty}', "");
    Expect(1, 68334, '\p{Jg= _manichaean_Twenty}', "");
    Expect(0, 68334, '\p{^Jg= _manichaean_Twenty}', "");
    Expect(0, 68334, '\P{Jg= _manichaean_Twenty}', "");
    Expect(1, 68334, '\P{^Jg= _manichaean_Twenty}', "");
    Expect(0, 68335, '\p{Jg= _manichaean_Twenty}', "");
    Expect(1, 68335, '\p{^Jg= _manichaean_Twenty}', "");
    Expect(1, 68335, '\P{Jg= _manichaean_Twenty}', "");
    Expect(0, 68335, '\P{^Jg= _manichaean_Twenty}', "");
    Error('\p{Is_Joining_Group=/a/--MANICHAEAN_TWENTY}');
    Error('\P{Is_Joining_Group=/a/--MANICHAEAN_TWENTY}');
    Expect(1, 68334, '\p{Is_Joining_Group=manichaeantwenty}', "");
    Expect(0, 68334, '\p{^Is_Joining_Group=manichaeantwenty}', "");
    Expect(0, 68334, '\P{Is_Joining_Group=manichaeantwenty}', "");
    Expect(1, 68334, '\P{^Is_Joining_Group=manichaeantwenty}', "");
    Expect(0, 68335, '\p{Is_Joining_Group=manichaeantwenty}', "");
    Expect(1, 68335, '\p{^Is_Joining_Group=manichaeantwenty}', "");
    Expect(1, 68335, '\P{Is_Joining_Group=manichaeantwenty}', "");
    Expect(0, 68335, '\P{^Is_Joining_Group=manichaeantwenty}', "");
    Expect(1, 68334, '\p{Is_Joining_Group=_-manichaean_Twenty}', "");
    Expect(0, 68334, '\p{^Is_Joining_Group=_-manichaean_Twenty}', "");
    Expect(0, 68334, '\P{Is_Joining_Group=_-manichaean_Twenty}', "");
    Expect(1, 68334, '\P{^Is_Joining_Group=_-manichaean_Twenty}', "");
    Expect(0, 68335, '\p{Is_Joining_Group=_-manichaean_Twenty}', "");
    Expect(1, 68335, '\p{^Is_Joining_Group=_-manichaean_Twenty}', "");
    Expect(1, 68335, '\P{Is_Joining_Group=_-manichaean_Twenty}', "");
    Expect(0, 68335, '\P{^Is_Joining_Group=_-manichaean_Twenty}', "");
    Error('\p{Is_Jg=/a/_manichaean_Twenty}');
    Error('\P{Is_Jg=/a/_manichaean_Twenty}');
    Expect(1, 68334, '\p{Is_Jg=manichaeantwenty}', "");
    Expect(0, 68334, '\p{^Is_Jg=manichaeantwenty}', "");
    Expect(0, 68334, '\P{Is_Jg=manichaeantwenty}', "");
    Expect(1, 68334, '\P{^Is_Jg=manichaeantwenty}', "");
    Expect(0, 68335, '\p{Is_Jg=manichaeantwenty}', "");
    Expect(1, 68335, '\p{^Is_Jg=manichaeantwenty}', "");
    Expect(1, 68335, '\P{Is_Jg=manichaeantwenty}', "");
    Expect(0, 68335, '\P{^Is_Jg=manichaeantwenty}', "");
    Expect(1, 68334, '\p{Is_Jg=	_MANICHAEAN_twenty}', "");
    Expect(0, 68334, '\p{^Is_Jg=	_MANICHAEAN_twenty}', "");
    Expect(0, 68334, '\P{Is_Jg=	_MANICHAEAN_twenty}', "");
    Expect(1, 68334, '\P{^Is_Jg=	_MANICHAEAN_twenty}', "");
    Expect(0, 68335, '\p{Is_Jg=	_MANICHAEAN_twenty}', "");
    Expect(1, 68335, '\p{^Is_Jg=	_MANICHAEAN_twenty}', "");
    Expect(1, 68335, '\P{Is_Jg=	_MANICHAEAN_twenty}', "");
    Expect(0, 68335, '\P{^Is_Jg=	_MANICHAEAN_twenty}', "");
    Error('\p{Joining_Group=-/a/manichaean_Waw}');
    Error('\P{Joining_Group=-/a/manichaean_Waw}');
    Expect(1, 68295, '\p{Joining_Group=manichaeanwaw}', "");
    Expect(0, 68295, '\p{^Joining_Group=manichaeanwaw}', "");
    Expect(0, 68295, '\P{Joining_Group=manichaeanwaw}', "");
    Expect(1, 68295, '\P{^Joining_Group=manichaeanwaw}', "");
    Expect(0, 68296, '\p{Joining_Group=manichaeanwaw}', "");
    Expect(1, 68296, '\p{^Joining_Group=manichaeanwaw}', "");
    Expect(1, 68296, '\P{Joining_Group=manichaeanwaw}', "");
    Expect(0, 68296, '\P{^Joining_Group=manichaeanwaw}', "");
    Expect(1, 68295, '\p{Joining_Group= _Manichaean_Waw}', "");
    Expect(0, 68295, '\p{^Joining_Group= _Manichaean_Waw}', "");
    Expect(0, 68295, '\P{Joining_Group= _Manichaean_Waw}', "");
    Expect(1, 68295, '\P{^Joining_Group= _Manichaean_Waw}', "");
    Expect(0, 68296, '\p{Joining_Group= _Manichaean_Waw}', "");
    Expect(1, 68296, '\p{^Joining_Group= _Manichaean_Waw}', "");
    Expect(1, 68296, '\P{Joining_Group= _Manichaean_Waw}', "");
    Expect(0, 68296, '\P{^Joining_Group= _Manichaean_Waw}', "");
    Error('\p{Jg=:= -Manichaean_Waw}');
    Error('\P{Jg=:= -Manichaean_Waw}');
    Expect(1, 68295, '\p{Jg=manichaeanwaw}', "");
    Expect(0, 68295, '\p{^Jg=manichaeanwaw}', "");
    Expect(0, 68295, '\P{Jg=manichaeanwaw}', "");
    Expect(1, 68295, '\P{^Jg=manichaeanwaw}', "");
    Expect(0, 68296, '\p{Jg=manichaeanwaw}', "");
    Expect(1, 68296, '\p{^Jg=manichaeanwaw}', "");
    Expect(1, 68296, '\P{Jg=manichaeanwaw}', "");
    Expect(0, 68296, '\P{^Jg=manichaeanwaw}', "");
    Expect(1, 68295, '\p{Jg= Manichaean_WAW}', "");
    Expect(0, 68295, '\p{^Jg= Manichaean_WAW}', "");
    Expect(0, 68295, '\P{Jg= Manichaean_WAW}', "");
    Expect(1, 68295, '\P{^Jg= Manichaean_WAW}', "");
    Expect(0, 68296, '\p{Jg= Manichaean_WAW}', "");
    Expect(1, 68296, '\p{^Jg= Manichaean_WAW}', "");
    Expect(1, 68296, '\P{Jg= Manichaean_WAW}', "");
    Expect(0, 68296, '\P{^Jg= Manichaean_WAW}', "");
    Error('\p{Is_Joining_Group= /a/manichaean_WAW}');
    Error('\P{Is_Joining_Group= /a/manichaean_WAW}');
    Expect(1, 68295, '\p{Is_Joining_Group=manichaeanwaw}', "");
    Expect(0, 68295, '\p{^Is_Joining_Group=manichaeanwaw}', "");
    Expect(0, 68295, '\P{Is_Joining_Group=manichaeanwaw}', "");
    Expect(1, 68295, '\P{^Is_Joining_Group=manichaeanwaw}', "");
    Expect(0, 68296, '\p{Is_Joining_Group=manichaeanwaw}', "");
    Expect(1, 68296, '\p{^Is_Joining_Group=manichaeanwaw}', "");
    Expect(1, 68296, '\P{Is_Joining_Group=manichaeanwaw}', "");
    Expect(0, 68296, '\P{^Is_Joining_Group=manichaeanwaw}', "");
    Expect(1, 68295, '\p{Is_Joining_Group=	-MANICHAEAN_Waw}', "");
    Expect(0, 68295, '\p{^Is_Joining_Group=	-MANICHAEAN_Waw}', "");
    Expect(0, 68295, '\P{Is_Joining_Group=	-MANICHAEAN_Waw}', "");
    Expect(1, 68295, '\P{^Is_Joining_Group=	-MANICHAEAN_Waw}', "");
    Expect(0, 68296, '\p{Is_Joining_Group=	-MANICHAEAN_Waw}', "");
    Expect(1, 68296, '\p{^Is_Joining_Group=	-MANICHAEAN_Waw}', "");
    Expect(1, 68296, '\P{Is_Joining_Group=	-MANICHAEAN_Waw}', "");
    Expect(0, 68296, '\P{^Is_Joining_Group=	-MANICHAEAN_Waw}', "");
    Error('\p{Is_Jg= /a/MANICHAEAN_WAW}');
    Error('\P{Is_Jg= /a/MANICHAEAN_WAW}');
    Expect(1, 68295, '\p{Is_Jg=manichaeanwaw}', "");
    Expect(0, 68295, '\p{^Is_Jg=manichaeanwaw}', "");
    Expect(0, 68295, '\P{Is_Jg=manichaeanwaw}', "");
    Expect(1, 68295, '\P{^Is_Jg=manichaeanwaw}', "");
    Expect(0, 68296, '\p{Is_Jg=manichaeanwaw}', "");
    Expect(1, 68296, '\p{^Is_Jg=manichaeanwaw}', "");
    Expect(1, 68296, '\P{Is_Jg=manichaeanwaw}', "");
    Expect(0, 68296, '\P{^Is_Jg=manichaeanwaw}', "");
    Expect(1, 68295, '\p{Is_Jg=-	manichaean_WAW}', "");
    Expect(0, 68295, '\p{^Is_Jg=-	manichaean_WAW}', "");
    Expect(0, 68295, '\P{Is_Jg=-	manichaean_WAW}', "");
    Expect(1, 68295, '\P{^Is_Jg=-	manichaean_WAW}', "");
    Expect(0, 68296, '\p{Is_Jg=-	manichaean_WAW}', "");
    Expect(1, 68296, '\p{^Is_Jg=-	manichaean_WAW}', "");
    Expect(1, 68296, '\P{Is_Jg=-	manichaean_WAW}', "");
    Expect(0, 68296, '\P{^Is_Jg=-	manichaean_WAW}', "");
    Error('\p{Joining_Group=	Manichaean_YODH:=}');
    Error('\P{Joining_Group=	Manichaean_YODH:=}');
    Expect(1, 68303, '\p{Joining_Group=manichaeanyodh}', "");
    Expect(0, 68303, '\p{^Joining_Group=manichaeanyodh}', "");
    Expect(0, 68303, '\P{Joining_Group=manichaeanyodh}', "");
    Expect(1, 68303, '\P{^Joining_Group=manichaeanyodh}', "");
    Expect(0, 68304, '\p{Joining_Group=manichaeanyodh}', "");
    Expect(1, 68304, '\p{^Joining_Group=manichaeanyodh}', "");
    Expect(1, 68304, '\P{Joining_Group=manichaeanyodh}', "");
    Expect(0, 68304, '\P{^Joining_Group=manichaeanyodh}', "");
    Expect(1, 68303, '\p{Joining_Group=-Manichaean_Yodh}', "");
    Expect(0, 68303, '\p{^Joining_Group=-Manichaean_Yodh}', "");
    Expect(0, 68303, '\P{Joining_Group=-Manichaean_Yodh}', "");
    Expect(1, 68303, '\P{^Joining_Group=-Manichaean_Yodh}', "");
    Expect(0, 68304, '\p{Joining_Group=-Manichaean_Yodh}', "");
    Expect(1, 68304, '\p{^Joining_Group=-Manichaean_Yodh}', "");
    Expect(1, 68304, '\P{Joining_Group=-Manichaean_Yodh}', "");
    Expect(0, 68304, '\P{^Joining_Group=-Manichaean_Yodh}', "");
    Error('\p{Jg:	:=Manichaean_YODH}');
    Error('\P{Jg:	:=Manichaean_YODH}');
    Expect(1, 68303, '\p{Jg=manichaeanyodh}', "");
    Expect(0, 68303, '\p{^Jg=manichaeanyodh}', "");
    Expect(0, 68303, '\P{Jg=manichaeanyodh}', "");
    Expect(1, 68303, '\P{^Jg=manichaeanyodh}', "");
    Expect(0, 68304, '\p{Jg=manichaeanyodh}', "");
    Expect(1, 68304, '\p{^Jg=manichaeanyodh}', "");
    Expect(1, 68304, '\P{Jg=manichaeanyodh}', "");
    Expect(0, 68304, '\P{^Jg=manichaeanyodh}', "");
    Expect(1, 68303, '\p{Jg=_ Manichaean_Yodh}', "");
    Expect(0, 68303, '\p{^Jg=_ Manichaean_Yodh}', "");
    Expect(0, 68303, '\P{Jg=_ Manichaean_Yodh}', "");
    Expect(1, 68303, '\P{^Jg=_ Manichaean_Yodh}', "");
    Expect(0, 68304, '\p{Jg=_ Manichaean_Yodh}', "");
    Expect(1, 68304, '\p{^Jg=_ Manichaean_Yodh}', "");
    Expect(1, 68304, '\P{Jg=_ Manichaean_Yodh}', "");
    Expect(0, 68304, '\P{^Jg=_ Manichaean_Yodh}', "");
    Error('\p{Is_Joining_Group: 	:=Manichaean_Yodh}');
    Error('\P{Is_Joining_Group: 	:=Manichaean_Yodh}');
    Expect(1, 68303, '\p{Is_Joining_Group=manichaeanyodh}', "");
    Expect(0, 68303, '\p{^Is_Joining_Group=manichaeanyodh}', "");
    Expect(0, 68303, '\P{Is_Joining_Group=manichaeanyodh}', "");
    Expect(1, 68303, '\P{^Is_Joining_Group=manichaeanyodh}', "");
    Expect(0, 68304, '\p{Is_Joining_Group=manichaeanyodh}', "");
    Expect(1, 68304, '\p{^Is_Joining_Group=manichaeanyodh}', "");
    Expect(1, 68304, '\P{Is_Joining_Group=manichaeanyodh}', "");
    Expect(0, 68304, '\P{^Is_Joining_Group=manichaeanyodh}', "");
    Expect(1, 68303, '\p{Is_Joining_Group= -manichaean_YODH}', "");
    Expect(0, 68303, '\p{^Is_Joining_Group= -manichaean_YODH}', "");
    Expect(0, 68303, '\P{Is_Joining_Group= -manichaean_YODH}', "");
    Expect(1, 68303, '\P{^Is_Joining_Group= -manichaean_YODH}', "");
    Expect(0, 68304, '\p{Is_Joining_Group= -manichaean_YODH}', "");
    Expect(1, 68304, '\p{^Is_Joining_Group= -manichaean_YODH}', "");
    Expect(1, 68304, '\P{Is_Joining_Group= -manichaean_YODH}', "");
    Expect(0, 68304, '\P{^Is_Joining_Group= -manichaean_YODH}', "");
    Error('\p{Is_Jg=_-Manichaean_Yodh/a/}');
    Error('\P{Is_Jg=_-Manichaean_Yodh/a/}');
    Expect(1, 68303, '\p{Is_Jg=manichaeanyodh}', "");
    Expect(0, 68303, '\p{^Is_Jg=manichaeanyodh}', "");
    Expect(0, 68303, '\P{Is_Jg=manichaeanyodh}', "");
    Expect(1, 68303, '\P{^Is_Jg=manichaeanyodh}', "");
    Expect(0, 68304, '\p{Is_Jg=manichaeanyodh}', "");
    Expect(1, 68304, '\p{^Is_Jg=manichaeanyodh}', "");
    Expect(1, 68304, '\P{Is_Jg=manichaeanyodh}', "");
    Expect(0, 68304, '\P{^Is_Jg=manichaeanyodh}', "");
    Expect(1, 68303, '\p{Is_Jg=-_manichaean_yodh}', "");
    Expect(0, 68303, '\p{^Is_Jg=-_manichaean_yodh}', "");
    Expect(0, 68303, '\P{Is_Jg=-_manichaean_yodh}', "");
    Expect(1, 68303, '\P{^Is_Jg=-_manichaean_yodh}', "");
    Expect(0, 68304, '\p{Is_Jg=-_manichaean_yodh}', "");
    Expect(1, 68304, '\p{^Is_Jg=-_manichaean_yodh}', "");
    Expect(1, 68304, '\P{Is_Jg=-_manichaean_yodh}', "");
    Expect(0, 68304, '\P{^Is_Jg=-_manichaean_yodh}', "");
    Error('\p{Joining_Group= _MANICHAEAN_Zayin:=}');
    Error('\P{Joining_Group= _MANICHAEAN_Zayin:=}');
    Expect(1, 68298, '\p{Joining_Group=manichaeanzayin}', "");
    Expect(0, 68298, '\p{^Joining_Group=manichaeanzayin}', "");
    Expect(0, 68298, '\P{Joining_Group=manichaeanzayin}', "");
    Expect(1, 68298, '\P{^Joining_Group=manichaeanzayin}', "");
    Expect(0, 68299, '\p{Joining_Group=manichaeanzayin}', "");
    Expect(1, 68299, '\p{^Joining_Group=manichaeanzayin}', "");
    Expect(1, 68299, '\P{Joining_Group=manichaeanzayin}', "");
    Expect(0, 68299, '\P{^Joining_Group=manichaeanzayin}', "");
    Expect(1, 68298, '\p{Joining_Group=_ manichaean_Zayin}', "");
    Expect(0, 68298, '\p{^Joining_Group=_ manichaean_Zayin}', "");
    Expect(0, 68298, '\P{Joining_Group=_ manichaean_Zayin}', "");
    Expect(1, 68298, '\P{^Joining_Group=_ manichaean_Zayin}', "");
    Expect(0, 68299, '\p{Joining_Group=_ manichaean_Zayin}', "");
    Expect(1, 68299, '\p{^Joining_Group=_ manichaean_Zayin}', "");
    Expect(1, 68299, '\P{Joining_Group=_ manichaean_Zayin}', "");
    Expect(0, 68299, '\P{^Joining_Group=_ manichaean_Zayin}', "");
    Error('\p{Jg=Manichaean_zayin/a/}');
    Error('\P{Jg=Manichaean_zayin/a/}');
    Expect(1, 68298, '\p{Jg=manichaeanzayin}', "");
    Expect(0, 68298, '\p{^Jg=manichaeanzayin}', "");
    Expect(0, 68298, '\P{Jg=manichaeanzayin}', "");
    Expect(1, 68298, '\P{^Jg=manichaeanzayin}', "");
    Expect(0, 68299, '\p{Jg=manichaeanzayin}', "");
    Expect(1, 68299, '\p{^Jg=manichaeanzayin}', "");
    Expect(1, 68299, '\P{Jg=manichaeanzayin}', "");
    Expect(0, 68299, '\P{^Jg=manichaeanzayin}', "");
    Expect(1, 68298, '\p{Jg=_	Manichaean_ZAYIN}', "");
    Expect(0, 68298, '\p{^Jg=_	Manichaean_ZAYIN}', "");
    Expect(0, 68298, '\P{Jg=_	Manichaean_ZAYIN}', "");
    Expect(1, 68298, '\P{^Jg=_	Manichaean_ZAYIN}', "");
    Expect(0, 68299, '\p{Jg=_	Manichaean_ZAYIN}', "");
    Expect(1, 68299, '\p{^Jg=_	Manichaean_ZAYIN}', "");
    Expect(1, 68299, '\P{Jg=_	Manichaean_ZAYIN}', "");
    Expect(0, 68299, '\P{^Jg=_	Manichaean_ZAYIN}', "");
    Error('\p{Is_Joining_Group=MANICHAEAN_ZAYIN/a/}');
    Error('\P{Is_Joining_Group=MANICHAEAN_ZAYIN/a/}');
    Expect(1, 68298, '\p{Is_Joining_Group=manichaeanzayin}', "");
    Expect(0, 68298, '\p{^Is_Joining_Group=manichaeanzayin}', "");
    Expect(0, 68298, '\P{Is_Joining_Group=manichaeanzayin}', "");
    Expect(1, 68298, '\P{^Is_Joining_Group=manichaeanzayin}', "");
    Expect(0, 68299, '\p{Is_Joining_Group=manichaeanzayin}', "");
    Expect(1, 68299, '\p{^Is_Joining_Group=manichaeanzayin}', "");
    Expect(1, 68299, '\P{Is_Joining_Group=manichaeanzayin}', "");
    Expect(0, 68299, '\P{^Is_Joining_Group=manichaeanzayin}', "");
    Expect(1, 68298, '\p{Is_Joining_Group= 	Manichaean_Zayin}', "");
    Expect(0, 68298, '\p{^Is_Joining_Group= 	Manichaean_Zayin}', "");
    Expect(0, 68298, '\P{Is_Joining_Group= 	Manichaean_Zayin}', "");
    Expect(1, 68298, '\P{^Is_Joining_Group= 	Manichaean_Zayin}', "");
    Expect(0, 68299, '\p{Is_Joining_Group= 	Manichaean_Zayin}', "");
    Expect(1, 68299, '\p{^Is_Joining_Group= 	Manichaean_Zayin}', "");
    Expect(1, 68299, '\P{Is_Joining_Group= 	Manichaean_Zayin}', "");
    Expect(0, 68299, '\P{^Is_Joining_Group= 	Manichaean_Zayin}', "");
    Error('\p{Is_Jg=:=MANICHAEAN_Zayin}');
    Error('\P{Is_Jg=:=MANICHAEAN_Zayin}');
    Expect(1, 68298, '\p{Is_Jg:	manichaeanzayin}', "");
    Expect(0, 68298, '\p{^Is_Jg:	manichaeanzayin}', "");
    Expect(0, 68298, '\P{Is_Jg:	manichaeanzayin}', "");
    Expect(1, 68298, '\P{^Is_Jg:	manichaeanzayin}', "");
    Expect(0, 68299, '\p{Is_Jg:	manichaeanzayin}', "");
    Expect(1, 68299, '\p{^Is_Jg:	manichaeanzayin}', "");
    Expect(1, 68299, '\P{Is_Jg:	manichaeanzayin}', "");
    Expect(0, 68299, '\P{^Is_Jg:	manichaeanzayin}', "");
    Expect(1, 68298, '\p{Is_Jg=	_Manichaean_Zayin}', "");
    Expect(0, 68298, '\p{^Is_Jg=	_Manichaean_Zayin}', "");
    Expect(0, 68298, '\P{Is_Jg=	_Manichaean_Zayin}', "");
    Expect(1, 68298, '\P{^Is_Jg=	_Manichaean_Zayin}', "");
    Expect(0, 68299, '\p{Is_Jg=	_Manichaean_Zayin}', "");
    Expect(1, 68299, '\p{^Is_Jg=	_Manichaean_Zayin}', "");
    Expect(1, 68299, '\P{Is_Jg=	_Manichaean_Zayin}', "");
    Expect(0, 68299, '\P{^Is_Jg=	_Manichaean_Zayin}', "");
    Error('\p{Joining_Group= :=Meem}');
    Error('\P{Joining_Group= :=Meem}');
    Expect(1, 2215, '\p{Joining_Group=meem}', "");
    Expect(0, 2215, '\p{^Joining_Group=meem}', "");
    Expect(0, 2215, '\P{Joining_Group=meem}', "");
    Expect(1, 2215, '\P{^Joining_Group=meem}', "");
    Expect(0, 2216, '\p{Joining_Group=meem}', "");
    Expect(1, 2216, '\p{^Joining_Group=meem}', "");
    Expect(1, 2216, '\P{Joining_Group=meem}', "");
    Expect(0, 2216, '\P{^Joining_Group=meem}', "");
    Expect(1, 2215, '\p{Joining_Group=Meem}', "");
    Expect(0, 2215, '\p{^Joining_Group=Meem}', "");
    Expect(0, 2215, '\P{Joining_Group=Meem}', "");
    Expect(1, 2215, '\P{^Joining_Group=Meem}', "");
    Expect(0, 2216, '\p{Joining_Group=Meem}', "");
    Expect(1, 2216, '\p{^Joining_Group=Meem}', "");
    Expect(1, 2216, '\P{Joining_Group=Meem}', "");
    Expect(0, 2216, '\P{^Joining_Group=Meem}', "");
    Error('\p{Jg=-MEEM/a/}');
    Error('\P{Jg=-MEEM/a/}');
    Expect(1, 2215, '\p{Jg=meem}', "");
    Expect(0, 2215, '\p{^Jg=meem}', "");
    Expect(0, 2215, '\P{Jg=meem}', "");
    Expect(1, 2215, '\P{^Jg=meem}', "");
    Expect(0, 2216, '\p{Jg=meem}', "");
    Expect(1, 2216, '\p{^Jg=meem}', "");
    Expect(1, 2216, '\P{Jg=meem}', "");
    Expect(0, 2216, '\P{^Jg=meem}', "");
    Expect(1, 2215, '\p{Jg= meem}', "");
    Expect(0, 2215, '\p{^Jg= meem}', "");
    Expect(0, 2215, '\P{Jg= meem}', "");
    Expect(1, 2215, '\P{^Jg= meem}', "");
    Expect(0, 2216, '\p{Jg= meem}', "");
    Expect(1, 2216, '\p{^Jg= meem}', "");
    Expect(1, 2216, '\P{Jg= meem}', "");
    Expect(0, 2216, '\P{^Jg= meem}', "");
    Error('\p{Is_Joining_Group=_/a/Meem}');
    Error('\P{Is_Joining_Group=_/a/Meem}');
    Expect(1, 2215, '\p{Is_Joining_Group=meem}', "");
    Expect(0, 2215, '\p{^Is_Joining_Group=meem}', "");
    Expect(0, 2215, '\P{Is_Joining_Group=meem}', "");
    Expect(1, 2215, '\P{^Is_Joining_Group=meem}', "");
    Expect(0, 2216, '\p{Is_Joining_Group=meem}', "");
    Expect(1, 2216, '\p{^Is_Joining_Group=meem}', "");
    Expect(1, 2216, '\P{Is_Joining_Group=meem}', "");
    Expect(0, 2216, '\P{^Is_Joining_Group=meem}', "");
    Expect(1, 2215, '\p{Is_Joining_Group=_Meem}', "");
    Expect(0, 2215, '\p{^Is_Joining_Group=_Meem}', "");
    Expect(0, 2215, '\P{Is_Joining_Group=_Meem}', "");
    Expect(1, 2215, '\P{^Is_Joining_Group=_Meem}', "");
    Expect(0, 2216, '\p{Is_Joining_Group=_Meem}', "");
    Expect(1, 2216, '\p{^Is_Joining_Group=_Meem}', "");
    Expect(1, 2216, '\P{Is_Joining_Group=_Meem}', "");
    Expect(0, 2216, '\P{^Is_Joining_Group=_Meem}', "");
    Error('\p{Is_Jg=/a/ Meem}');
    Error('\P{Is_Jg=/a/ Meem}');
    Expect(1, 2215, '\p{Is_Jg=meem}', "");
    Expect(0, 2215, '\p{^Is_Jg=meem}', "");
    Expect(0, 2215, '\P{Is_Jg=meem}', "");
    Expect(1, 2215, '\P{^Is_Jg=meem}', "");
    Expect(0, 2216, '\p{Is_Jg=meem}', "");
    Expect(1, 2216, '\p{^Is_Jg=meem}', "");
    Expect(1, 2216, '\P{Is_Jg=meem}', "");
    Expect(0, 2216, '\P{^Is_Jg=meem}', "");
    Expect(1, 2215, '\p{Is_Jg=--Meem}', "");
    Expect(0, 2215, '\p{^Is_Jg=--Meem}', "");
    Expect(0, 2215, '\P{Is_Jg=--Meem}', "");
    Expect(1, 2215, '\P{^Is_Jg=--Meem}', "");
    Expect(0, 2216, '\p{Is_Jg=--Meem}', "");
    Expect(1, 2216, '\p{^Is_Jg=--Meem}', "");
    Expect(1, 2216, '\P{Is_Jg=--Meem}', "");
    Expect(0, 2216, '\P{^Is_Jg=--Meem}', "");
    Error('\p{Joining_Group=	MIM/a/}');
    Error('\P{Joining_Group=	MIM/a/}');
    Expect(1, 1825, '\p{Joining_Group:	mim}', "");
    Expect(0, 1825, '\p{^Joining_Group:	mim}', "");
    Expect(0, 1825, '\P{Joining_Group:	mim}', "");
    Expect(1, 1825, '\P{^Joining_Group:	mim}', "");
    Expect(0, 1826, '\p{Joining_Group:	mim}', "");
    Expect(1, 1826, '\p{^Joining_Group:	mim}', "");
    Expect(1, 1826, '\P{Joining_Group:	mim}', "");
    Expect(0, 1826, '\P{^Joining_Group:	mim}', "");
    Expect(1, 1825, '\p{Joining_Group=Mim}', "");
    Expect(0, 1825, '\p{^Joining_Group=Mim}', "");
    Expect(0, 1825, '\P{Joining_Group=Mim}', "");
    Expect(1, 1825, '\P{^Joining_Group=Mim}', "");
    Expect(0, 1826, '\p{Joining_Group=Mim}', "");
    Expect(1, 1826, '\p{^Joining_Group=Mim}', "");
    Expect(1, 1826, '\P{Joining_Group=Mim}', "");
    Expect(0, 1826, '\P{^Joining_Group=Mim}', "");
    Error('\p{Jg= :=mim}');
    Error('\P{Jg= :=mim}');
    Expect(1, 1825, '\p{Jg=mim}', "");
    Expect(0, 1825, '\p{^Jg=mim}', "");
    Expect(0, 1825, '\P{Jg=mim}', "");
    Expect(1, 1825, '\P{^Jg=mim}', "");
    Expect(0, 1826, '\p{Jg=mim}', "");
    Expect(1, 1826, '\p{^Jg=mim}', "");
    Expect(1, 1826, '\P{Jg=mim}', "");
    Expect(0, 1826, '\P{^Jg=mim}', "");
    Expect(1, 1825, '\p{Jg=	_mim}', "");
    Expect(0, 1825, '\p{^Jg=	_mim}', "");
    Expect(0, 1825, '\P{Jg=	_mim}', "");
    Expect(1, 1825, '\P{^Jg=	_mim}', "");
    Expect(0, 1826, '\p{Jg=	_mim}', "");
    Expect(1, 1826, '\p{^Jg=	_mim}', "");
    Expect(1, 1826, '\P{Jg=	_mim}', "");
    Expect(0, 1826, '\P{^Jg=	_mim}', "");
    Error('\p{Is_Joining_Group= /a/Mim}');
    Error('\P{Is_Joining_Group= /a/Mim}');
    Expect(1, 1825, '\p{Is_Joining_Group=mim}', "");
    Expect(0, 1825, '\p{^Is_Joining_Group=mim}', "");
    Expect(0, 1825, '\P{Is_Joining_Group=mim}', "");
    Expect(1, 1825, '\P{^Is_Joining_Group=mim}', "");
    Expect(0, 1826, '\p{Is_Joining_Group=mim}', "");
    Expect(1, 1826, '\p{^Is_Joining_Group=mim}', "");
    Expect(1, 1826, '\P{Is_Joining_Group=mim}', "");
    Expect(0, 1826, '\P{^Is_Joining_Group=mim}', "");
    Expect(1, 1825, '\p{Is_Joining_Group:_ Mim}', "");
    Expect(0, 1825, '\p{^Is_Joining_Group:_ Mim}', "");
    Expect(0, 1825, '\P{Is_Joining_Group:_ Mim}', "");
    Expect(1, 1825, '\P{^Is_Joining_Group:_ Mim}', "");
    Expect(0, 1826, '\p{Is_Joining_Group:_ Mim}', "");
    Expect(1, 1826, '\p{^Is_Joining_Group:_ Mim}', "");
    Expect(1, 1826, '\P{Is_Joining_Group:_ Mim}', "");
    Expect(0, 1826, '\P{^Is_Joining_Group:_ Mim}', "");
    Error('\p{Is_Jg=-MIM:=}');
    Error('\P{Is_Jg=-MIM:=}');
    Expect(1, 1825, '\p{Is_Jg=mim}', "");
    Expect(0, 1825, '\p{^Is_Jg=mim}', "");
    Expect(0, 1825, '\P{Is_Jg=mim}', "");
    Expect(1, 1825, '\P{^Is_Jg=mim}', "");
    Expect(0, 1826, '\p{Is_Jg=mim}', "");
    Expect(1, 1826, '\p{^Is_Jg=mim}', "");
    Expect(1, 1826, '\P{Is_Jg=mim}', "");
    Expect(0, 1826, '\P{^Is_Jg=mim}', "");
    Expect(1, 1825, '\p{Is_Jg=-mim}', "");
    Expect(0, 1825, '\p{^Is_Jg=-mim}', "");
    Expect(0, 1825, '\P{Is_Jg=-mim}', "");
    Expect(1, 1825, '\P{^Is_Jg=-mim}', "");
    Expect(0, 1826, '\p{Is_Jg=-mim}', "");
    Expect(1, 1826, '\p{^Is_Jg=-mim}', "");
    Expect(1, 1826, '\P{Is_Jg=-mim}', "");
    Expect(0, 1826, '\P{^Is_Jg=-mim}', "");
    Error('\p{Joining_Group= :=No_JOINING_Group}');
    Error('\P{Joining_Group= :=No_JOINING_Group}');
    Expect(1, 68336, '\p{Joining_Group=nojoininggroup}', "");
    Expect(0, 68336, '\p{^Joining_Group=nojoininggroup}', "");
    Expect(0, 68336, '\P{Joining_Group=nojoininggroup}', "");
    Expect(1, 68336, '\P{^Joining_Group=nojoininggroup}', "");
    Expect(0, 68335, '\p{Joining_Group=nojoininggroup}', "");
    Expect(1, 68335, '\p{^Joining_Group=nojoininggroup}', "");
    Expect(1, 68335, '\P{Joining_Group=nojoininggroup}', "");
    Expect(0, 68335, '\P{^Joining_Group=nojoininggroup}', "");
    Expect(1, 68336, '\p{Joining_Group=	 No_JOINING_GROUP}', "");
    Expect(0, 68336, '\p{^Joining_Group=	 No_JOINING_GROUP}', "");
    Expect(0, 68336, '\P{Joining_Group=	 No_JOINING_GROUP}', "");
    Expect(1, 68336, '\P{^Joining_Group=	 No_JOINING_GROUP}', "");
    Expect(0, 68335, '\p{Joining_Group=	 No_JOINING_GROUP}', "");
    Expect(1, 68335, '\p{^Joining_Group=	 No_JOINING_GROUP}', "");
    Expect(1, 68335, '\P{Joining_Group=	 No_JOINING_GROUP}', "");
    Expect(0, 68335, '\P{^Joining_Group=	 No_JOINING_GROUP}', "");
    Error('\p{Jg=-:=No_joining_GROUP}');
    Error('\P{Jg=-:=No_joining_GROUP}');
    Expect(1, 68336, '\p{Jg: nojoininggroup}', "");
    Expect(0, 68336, '\p{^Jg: nojoininggroup}', "");
    Expect(0, 68336, '\P{Jg: nojoininggroup}', "");
    Expect(1, 68336, '\P{^Jg: nojoininggroup}', "");
    Expect(0, 68335, '\p{Jg: nojoininggroup}', "");
    Expect(1, 68335, '\p{^Jg: nojoininggroup}', "");
    Expect(1, 68335, '\P{Jg: nojoininggroup}', "");
    Expect(0, 68335, '\P{^Jg: nojoininggroup}', "");
    Expect(1, 68336, '\p{Jg:	 No_joining_GROUP}', "");
    Expect(0, 68336, '\p{^Jg:	 No_joining_GROUP}', "");
    Expect(0, 68336, '\P{Jg:	 No_joining_GROUP}', "");
    Expect(1, 68336, '\P{^Jg:	 No_joining_GROUP}', "");
    Expect(0, 68335, '\p{Jg:	 No_joining_GROUP}', "");
    Expect(1, 68335, '\p{^Jg:	 No_joining_GROUP}', "");
    Expect(1, 68335, '\P{Jg:	 No_joining_GROUP}', "");
    Expect(0, 68335, '\P{^Jg:	 No_joining_GROUP}', "");
    Error('\p{Is_Joining_Group=_	no_joining_Group/a/}');
    Error('\P{Is_Joining_Group=_	no_joining_Group/a/}');
    Expect(1, 68336, '\p{Is_Joining_Group=nojoininggroup}', "");
    Expect(0, 68336, '\p{^Is_Joining_Group=nojoininggroup}', "");
    Expect(0, 68336, '\P{Is_Joining_Group=nojoininggroup}', "");
    Expect(1, 68336, '\P{^Is_Joining_Group=nojoininggroup}', "");
    Expect(0, 68335, '\p{Is_Joining_Group=nojoininggroup}', "");
    Expect(1, 68335, '\p{^Is_Joining_Group=nojoininggroup}', "");
    Expect(1, 68335, '\P{Is_Joining_Group=nojoininggroup}', "");
    Expect(0, 68335, '\P{^Is_Joining_Group=nojoininggroup}', "");
    Expect(1, 68336, '\p{Is_Joining_Group=_-NO_Joining_Group}', "");
    Expect(0, 68336, '\p{^Is_Joining_Group=_-NO_Joining_Group}', "");
    Expect(0, 68336, '\P{Is_Joining_Group=_-NO_Joining_Group}', "");
    Expect(1, 68336, '\P{^Is_Joining_Group=_-NO_Joining_Group}', "");
    Expect(0, 68335, '\p{Is_Joining_Group=_-NO_Joining_Group}', "");
    Expect(1, 68335, '\p{^Is_Joining_Group=_-NO_Joining_Group}', "");
    Expect(1, 68335, '\P{Is_Joining_Group=_-NO_Joining_Group}', "");
    Expect(0, 68335, '\P{^Is_Joining_Group=_-NO_Joining_Group}', "");
    Error('\p{Is_Jg=	/a/No_JOINING_GROUP}');
    Error('\P{Is_Jg=	/a/No_JOINING_GROUP}');
    Expect(1, 68336, '\p{Is_Jg=nojoininggroup}', "");
    Expect(0, 68336, '\p{^Is_Jg=nojoininggroup}', "");
    Expect(0, 68336, '\P{Is_Jg=nojoininggroup}', "");
    Expect(1, 68336, '\P{^Is_Jg=nojoininggroup}', "");
    Expect(0, 68335, '\p{Is_Jg=nojoininggroup}', "");
    Expect(1, 68335, '\p{^Is_Jg=nojoininggroup}', "");
    Expect(1, 68335, '\P{Is_Jg=nojoininggroup}', "");
    Expect(0, 68335, '\P{^Is_Jg=nojoininggroup}', "");
    Expect(1, 68336, '\p{Is_Jg=	no_Joining_Group}', "");
    Expect(0, 68336, '\p{^Is_Jg=	no_Joining_Group}', "");
    Expect(0, 68336, '\P{Is_Jg=	no_Joining_Group}', "");
    Expect(1, 68336, '\P{^Is_Jg=	no_Joining_Group}', "");
    Expect(0, 68335, '\p{Is_Jg=	no_Joining_Group}', "");
    Expect(1, 68335, '\p{^Is_Jg=	no_Joining_Group}', "");
    Expect(1, 68335, '\P{Is_Jg=	no_Joining_Group}', "");
    Expect(0, 68335, '\P{^Is_Jg=	no_Joining_Group}', "");
    Error('\p{Joining_Group:   _-noon:=}');
    Error('\P{Joining_Group:   _-noon:=}');
    Expect(1, 1897, '\p{Joining_Group=noon}', "");
    Expect(0, 1897, '\p{^Joining_Group=noon}', "");
    Expect(0, 1897, '\P{Joining_Group=noon}', "");
    Expect(1, 1897, '\P{^Joining_Group=noon}', "");
    Expect(0, 1898, '\p{Joining_Group=noon}', "");
    Expect(1, 1898, '\p{^Joining_Group=noon}', "");
    Expect(1, 1898, '\P{Joining_Group=noon}', "");
    Expect(0, 1898, '\P{^Joining_Group=noon}', "");
    Expect(1, 1897, '\p{Joining_Group= NOON}', "");
    Expect(0, 1897, '\p{^Joining_Group= NOON}', "");
    Expect(0, 1897, '\P{Joining_Group= NOON}', "");
    Expect(1, 1897, '\P{^Joining_Group= NOON}', "");
    Expect(0, 1898, '\p{Joining_Group= NOON}', "");
    Expect(1, 1898, '\p{^Joining_Group= NOON}', "");
    Expect(1, 1898, '\P{Joining_Group= NOON}', "");
    Expect(0, 1898, '\P{^Joining_Group= NOON}', "");
    Error('\p{Jg=:=	Noon}');
    Error('\P{Jg=:=	Noon}');
    Expect(1, 1897, '\p{Jg=noon}', "");
    Expect(0, 1897, '\p{^Jg=noon}', "");
    Expect(0, 1897, '\P{Jg=noon}', "");
    Expect(1, 1897, '\P{^Jg=noon}', "");
    Expect(0, 1898, '\p{Jg=noon}', "");
    Expect(1, 1898, '\p{^Jg=noon}', "");
    Expect(1, 1898, '\P{Jg=noon}', "");
    Expect(0, 1898, '\P{^Jg=noon}', "");
    Expect(1, 1897, '\p{Jg=__NOON}', "");
    Expect(0, 1897, '\p{^Jg=__NOON}', "");
    Expect(0, 1897, '\P{Jg=__NOON}', "");
    Expect(1, 1897, '\P{^Jg=__NOON}', "");
    Expect(0, 1898, '\p{Jg=__NOON}', "");
    Expect(1, 1898, '\p{^Jg=__NOON}', "");
    Expect(1, 1898, '\P{Jg=__NOON}', "");
    Expect(0, 1898, '\P{^Jg=__NOON}', "");
    Error('\p{Is_Joining_Group=/a/noon}');
    Error('\P{Is_Joining_Group=/a/noon}');
    Expect(1, 1897, '\p{Is_Joining_Group=noon}', "");
    Expect(0, 1897, '\p{^Is_Joining_Group=noon}', "");
    Expect(0, 1897, '\P{Is_Joining_Group=noon}', "");
    Expect(1, 1897, '\P{^Is_Joining_Group=noon}', "");
    Expect(0, 1898, '\p{Is_Joining_Group=noon}', "");
    Expect(1, 1898, '\p{^Is_Joining_Group=noon}', "");
    Expect(1, 1898, '\P{Is_Joining_Group=noon}', "");
    Expect(0, 1898, '\P{^Is_Joining_Group=noon}', "");
    Expect(1, 1897, '\p{Is_Joining_Group=	_Noon}', "");
    Expect(0, 1897, '\p{^Is_Joining_Group=	_Noon}', "");
    Expect(0, 1897, '\P{Is_Joining_Group=	_Noon}', "");
    Expect(1, 1897, '\P{^Is_Joining_Group=	_Noon}', "");
    Expect(0, 1898, '\p{Is_Joining_Group=	_Noon}', "");
    Expect(1, 1898, '\p{^Is_Joining_Group=	_Noon}', "");
    Expect(1, 1898, '\P{Is_Joining_Group=	_Noon}', "");
    Expect(0, 1898, '\P{^Is_Joining_Group=	_Noon}', "");
    Error('\p{Is_Jg:	 Noon/a/}');
    Error('\P{Is_Jg:	 Noon/a/}');
    Expect(1, 1897, '\p{Is_Jg=noon}', "");
    Expect(0, 1897, '\p{^Is_Jg=noon}', "");
    Expect(0, 1897, '\P{Is_Jg=noon}', "");
    Expect(1, 1897, '\P{^Is_Jg=noon}', "");
    Expect(0, 1898, '\p{Is_Jg=noon}', "");
    Expect(1, 1898, '\p{^Is_Jg=noon}', "");
    Expect(1, 1898, '\P{Is_Jg=noon}', "");
    Expect(0, 1898, '\P{^Is_Jg=noon}', "");
    Expect(1, 1897, '\p{Is_Jg=	_NOON}', "");
    Expect(0, 1897, '\p{^Is_Jg=	_NOON}', "");
    Expect(0, 1897, '\P{Is_Jg=	_NOON}', "");
    Expect(1, 1897, '\P{^Is_Jg=	_NOON}', "");
    Expect(0, 1898, '\p{Is_Jg=	_NOON}', "");
    Expect(1, 1898, '\p{^Is_Jg=	_NOON}', "");
    Expect(1, 1898, '\P{Is_Jg=	_NOON}', "");
    Expect(0, 1898, '\P{^Is_Jg=	_NOON}', "");
    Error('\p{Joining_Group=/a/-_NUN}');
    Error('\P{Joining_Group=/a/-_NUN}');
    Expect(1, 1826, '\p{Joining_Group:nun}', "");
    Expect(0, 1826, '\p{^Joining_Group:nun}', "");
    Expect(0, 1826, '\P{Joining_Group:nun}', "");
    Expect(1, 1826, '\P{^Joining_Group:nun}', "");
    Expect(0, 1827, '\p{Joining_Group:nun}', "");
    Expect(1, 1827, '\p{^Joining_Group:nun}', "");
    Expect(1, 1827, '\P{Joining_Group:nun}', "");
    Expect(0, 1827, '\P{^Joining_Group:nun}', "");
    Expect(1, 1826, '\p{Joining_Group=	-Nun}', "");
    Expect(0, 1826, '\p{^Joining_Group=	-Nun}', "");
    Expect(0, 1826, '\P{Joining_Group=	-Nun}', "");
    Expect(1, 1826, '\P{^Joining_Group=	-Nun}', "");
    Expect(0, 1827, '\p{Joining_Group=	-Nun}', "");
    Expect(1, 1827, '\p{^Joining_Group=	-Nun}', "");
    Expect(1, 1827, '\P{Joining_Group=	-Nun}', "");
    Expect(0, 1827, '\P{^Joining_Group=	-Nun}', "");
    Error('\p{Jg= 	NUN:=}');
    Error('\P{Jg= 	NUN:=}');
    Expect(1, 1826, '\p{Jg:   nun}', "");
    Expect(0, 1826, '\p{^Jg:   nun}', "");
    Expect(0, 1826, '\P{Jg:   nun}', "");
    Expect(1, 1826, '\P{^Jg:   nun}', "");
    Expect(0, 1827, '\p{Jg:   nun}', "");
    Expect(1, 1827, '\p{^Jg:   nun}', "");
    Expect(1, 1827, '\P{Jg:   nun}', "");
    Expect(0, 1827, '\P{^Jg:   nun}', "");
    Expect(1, 1826, '\p{Jg:    	nun}', "");
    Expect(0, 1826, '\p{^Jg:    	nun}', "");
    Expect(0, 1826, '\P{Jg:    	nun}', "");
    Expect(1, 1826, '\P{^Jg:    	nun}', "");
    Expect(0, 1827, '\p{Jg:    	nun}', "");
    Expect(1, 1827, '\p{^Jg:    	nun}', "");
    Expect(1, 1827, '\P{Jg:    	nun}', "");
    Expect(0, 1827, '\P{^Jg:    	nun}', "");
    Error('\p{Is_Joining_Group=/a/	Nun}');
    Error('\P{Is_Joining_Group=/a/	Nun}');
    Expect(1, 1826, '\p{Is_Joining_Group=nun}', "");
    Expect(0, 1826, '\p{^Is_Joining_Group=nun}', "");
    Expect(0, 1826, '\P{Is_Joining_Group=nun}', "");
    Expect(1, 1826, '\P{^Is_Joining_Group=nun}', "");
    Expect(0, 1827, '\p{Is_Joining_Group=nun}', "");
    Expect(1, 1827, '\p{^Is_Joining_Group=nun}', "");
    Expect(1, 1827, '\P{Is_Joining_Group=nun}', "");
    Expect(0, 1827, '\P{^Is_Joining_Group=nun}', "");
    Expect(1, 1826, '\p{Is_Joining_Group= _Nun}', "");
    Expect(0, 1826, '\p{^Is_Joining_Group= _Nun}', "");
    Expect(0, 1826, '\P{Is_Joining_Group= _Nun}', "");
    Expect(1, 1826, '\P{^Is_Joining_Group= _Nun}', "");
    Expect(0, 1827, '\p{Is_Joining_Group= _Nun}', "");
    Expect(1, 1827, '\p{^Is_Joining_Group= _Nun}', "");
    Expect(1, 1827, '\P{Is_Joining_Group= _Nun}', "");
    Expect(0, 1827, '\P{^Is_Joining_Group= _Nun}', "");
    Error('\p{Is_Jg=/a/- nun}');
    Error('\P{Is_Jg=/a/- nun}');
    Expect(1, 1826, '\p{Is_Jg=nun}', "");
    Expect(0, 1826, '\p{^Is_Jg=nun}', "");
    Expect(0, 1826, '\P{Is_Jg=nun}', "");
    Expect(1, 1826, '\P{^Is_Jg=nun}', "");
    Expect(0, 1827, '\p{Is_Jg=nun}', "");
    Expect(1, 1827, '\p{^Is_Jg=nun}', "");
    Expect(1, 1827, '\P{Is_Jg=nun}', "");
    Expect(0, 1827, '\P{^Is_Jg=nun}', "");
    Expect(1, 1826, '\p{Is_Jg=	-nun}', "");
    Expect(0, 1826, '\p{^Is_Jg=	-nun}', "");
    Expect(0, 1826, '\P{Is_Jg=	-nun}', "");
    Expect(1, 1826, '\P{^Is_Jg=	-nun}', "");
    Expect(0, 1827, '\p{Is_Jg=	-nun}', "");
    Expect(1, 1827, '\p{^Is_Jg=	-nun}', "");
    Expect(1, 1827, '\P{Is_Jg=	-nun}', "");
    Expect(0, 1827, '\P{^Is_Jg=	-nun}', "");
    Error('\p{Joining_Group=/a/_ nya}');
    Error('\P{Joining_Group=/a/_ nya}');
    Expect(1, 1725, '\p{Joining_Group=nya}', "");
    Expect(0, 1725, '\p{^Joining_Group=nya}', "");
    Expect(0, 1725, '\P{Joining_Group=nya}', "");
    Expect(1, 1725, '\P{^Joining_Group=nya}', "");
    Expect(0, 1726, '\p{Joining_Group=nya}', "");
    Expect(1, 1726, '\p{^Joining_Group=nya}', "");
    Expect(1, 1726, '\P{Joining_Group=nya}', "");
    Expect(0, 1726, '\P{^Joining_Group=nya}', "");
    Expect(1, 1725, '\p{Joining_Group: _	Nya}', "");
    Expect(0, 1725, '\p{^Joining_Group: _	Nya}', "");
    Expect(0, 1725, '\P{Joining_Group: _	Nya}', "");
    Expect(1, 1725, '\P{^Joining_Group: _	Nya}', "");
    Expect(0, 1726, '\p{Joining_Group: _	Nya}', "");
    Expect(1, 1726, '\p{^Joining_Group: _	Nya}', "");
    Expect(1, 1726, '\P{Joining_Group: _	Nya}', "");
    Expect(0, 1726, '\P{^Joining_Group: _	Nya}', "");
    Error('\p{Jg= nya/a/}');
    Error('\P{Jg= nya/a/}');
    Expect(1, 1725, '\p{Jg=nya}', "");
    Expect(0, 1725, '\p{^Jg=nya}', "");
    Expect(0, 1725, '\P{Jg=nya}', "");
    Expect(1, 1725, '\P{^Jg=nya}', "");
    Expect(0, 1726, '\p{Jg=nya}', "");
    Expect(1, 1726, '\p{^Jg=nya}', "");
    Expect(1, 1726, '\P{Jg=nya}', "");
    Expect(0, 1726, '\P{^Jg=nya}', "");
    Expect(1, 1725, '\p{Jg=_nya}', "");
    Expect(0, 1725, '\p{^Jg=_nya}', "");
    Expect(0, 1725, '\P{Jg=_nya}', "");
    Expect(1, 1725, '\P{^Jg=_nya}', "");
    Expect(0, 1726, '\p{Jg=_nya}', "");
    Expect(1, 1726, '\p{^Jg=_nya}', "");
    Expect(1, 1726, '\P{Jg=_nya}', "");
    Expect(0, 1726, '\P{^Jg=_nya}', "");
    Error('\p{Is_Joining_Group= :=nya}');
    Error('\P{Is_Joining_Group= :=nya}');
    Expect(1, 1725, '\p{Is_Joining_Group=nya}', "");
    Expect(0, 1725, '\p{^Is_Joining_Group=nya}', "");
    Expect(0, 1725, '\P{Is_Joining_Group=nya}', "");
    Expect(1, 1725, '\P{^Is_Joining_Group=nya}', "");
    Expect(0, 1726, '\p{Is_Joining_Group=nya}', "");
    Expect(1, 1726, '\p{^Is_Joining_Group=nya}', "");
    Expect(1, 1726, '\P{Is_Joining_Group=nya}', "");
    Expect(0, 1726, '\P{^Is_Joining_Group=nya}', "");
    Expect(1, 1725, '\p{Is_Joining_Group=	-Nya}', "");
    Expect(0, 1725, '\p{^Is_Joining_Group=	-Nya}', "");
    Expect(0, 1725, '\P{Is_Joining_Group=	-Nya}', "");
    Expect(1, 1725, '\P{^Is_Joining_Group=	-Nya}', "");
    Expect(0, 1726, '\p{Is_Joining_Group=	-Nya}', "");
    Expect(1, 1726, '\p{^Is_Joining_Group=	-Nya}', "");
    Expect(1, 1726, '\P{Is_Joining_Group=	-Nya}', "");
    Expect(0, 1726, '\P{^Is_Joining_Group=	-Nya}', "");
    Error('\p{Is_Jg=/a/-	Nya}');
    Error('\P{Is_Jg=/a/-	Nya}');
    Expect(1, 1725, '\p{Is_Jg:   nya}', "");
    Expect(0, 1725, '\p{^Is_Jg:   nya}', "");
    Expect(0, 1725, '\P{Is_Jg:   nya}', "");
    Expect(1, 1725, '\P{^Is_Jg:   nya}', "");
    Expect(0, 1726, '\p{Is_Jg:   nya}', "");
    Expect(1, 1726, '\p{^Is_Jg:   nya}', "");
    Expect(1, 1726, '\P{Is_Jg:   nya}', "");
    Expect(0, 1726, '\P{^Is_Jg:   nya}', "");
    Expect(1, 1725, '\p{Is_Jg=	 Nya}', "");
    Expect(0, 1725, '\p{^Is_Jg=	 Nya}', "");
    Expect(0, 1725, '\P{Is_Jg=	 Nya}', "");
    Expect(1, 1725, '\P{^Is_Jg=	 Nya}', "");
    Expect(0, 1726, '\p{Is_Jg=	 Nya}', "");
    Expect(1, 1726, '\p{^Is_Jg=	 Nya}', "");
    Expect(1, 1726, '\P{Is_Jg=	 Nya}', "");
    Expect(0, 1726, '\P{^Is_Jg=	 Nya}', "");
    Error('\p{Joining_Group:-	Pe/a/}');
    Error('\P{Joining_Group:-	Pe/a/}');
    Expect(1, 1830, '\p{Joining_Group=pe}', "");
    Expect(0, 1830, '\p{^Joining_Group=pe}', "");
    Expect(0, 1830, '\P{Joining_Group=pe}', "");
    Expect(1, 1830, '\P{^Joining_Group=pe}', "");
    Expect(0, 1831, '\p{Joining_Group=pe}', "");
    Expect(1, 1831, '\p{^Joining_Group=pe}', "");
    Expect(1, 1831, '\P{Joining_Group=pe}', "");
    Expect(0, 1831, '\P{^Joining_Group=pe}', "");
    Expect(1, 1830, '\p{Joining_Group=_ pe}', "");
    Expect(0, 1830, '\p{^Joining_Group=_ pe}', "");
    Expect(0, 1830, '\P{Joining_Group=_ pe}', "");
    Expect(1, 1830, '\P{^Joining_Group=_ pe}', "");
    Expect(0, 1831, '\p{Joining_Group=_ pe}', "");
    Expect(1, 1831, '\p{^Joining_Group=_ pe}', "");
    Expect(1, 1831, '\P{Joining_Group=_ pe}', "");
    Expect(0, 1831, '\P{^Joining_Group=_ pe}', "");
    Error('\p{Jg=/a/Pe}');
    Error('\P{Jg=/a/Pe}');
    Expect(1, 1830, '\p{Jg:	pe}', "");
    Expect(0, 1830, '\p{^Jg:	pe}', "");
    Expect(0, 1830, '\P{Jg:	pe}', "");
    Expect(1, 1830, '\P{^Jg:	pe}', "");
    Expect(0, 1831, '\p{Jg:	pe}', "");
    Expect(1, 1831, '\p{^Jg:	pe}', "");
    Expect(1, 1831, '\P{Jg:	pe}', "");
    Expect(0, 1831, '\P{^Jg:	pe}', "");
    Expect(1, 1830, '\p{Jg=	pe}', "");
    Expect(0, 1830, '\p{^Jg=	pe}', "");
    Expect(0, 1830, '\P{Jg=	pe}', "");
    Expect(1, 1830, '\P{^Jg=	pe}', "");
    Expect(0, 1831, '\p{Jg=	pe}', "");
    Expect(1, 1831, '\p{^Jg=	pe}', "");
    Expect(1, 1831, '\P{Jg=	pe}', "");
    Expect(0, 1831, '\P{^Jg=	pe}', "");
    Error('\p{Is_Joining_Group=/a/--pe}');
    Error('\P{Is_Joining_Group=/a/--pe}');
    Expect(1, 1830, '\p{Is_Joining_Group=pe}', "");
    Expect(0, 1830, '\p{^Is_Joining_Group=pe}', "");
    Expect(0, 1830, '\P{Is_Joining_Group=pe}', "");
    Expect(1, 1830, '\P{^Is_Joining_Group=pe}', "");
    Expect(0, 1831, '\p{Is_Joining_Group=pe}', "");
    Expect(1, 1831, '\p{^Is_Joining_Group=pe}', "");
    Expect(1, 1831, '\P{Is_Joining_Group=pe}', "");
    Expect(0, 1831, '\P{^Is_Joining_Group=pe}', "");
    Expect(1, 1830, '\p{Is_Joining_Group=	_Pe}', "");
    Expect(0, 1830, '\p{^Is_Joining_Group=	_Pe}', "");
    Expect(0, 1830, '\P{Is_Joining_Group=	_Pe}', "");
    Expect(1, 1830, '\P{^Is_Joining_Group=	_Pe}', "");
    Expect(0, 1831, '\p{Is_Joining_Group=	_Pe}', "");
    Expect(1, 1831, '\p{^Is_Joining_Group=	_Pe}', "");
    Expect(1, 1831, '\P{Is_Joining_Group=	_Pe}', "");
    Expect(0, 1831, '\P{^Is_Joining_Group=	_Pe}', "");
    Error('\p{Is_Jg=		Pe:=}');
    Error('\P{Is_Jg=		Pe:=}');
    Expect(1, 1830, '\p{Is_Jg=pe}', "");
    Expect(0, 1830, '\p{^Is_Jg=pe}', "");
    Expect(0, 1830, '\P{Is_Jg=pe}', "");
    Expect(1, 1830, '\P{^Is_Jg=pe}', "");
    Expect(0, 1831, '\p{Is_Jg=pe}', "");
    Expect(1, 1831, '\p{^Is_Jg=pe}', "");
    Expect(1, 1831, '\P{Is_Jg=pe}', "");
    Expect(0, 1831, '\P{^Is_Jg=pe}', "");
    Expect(1, 1830, '\p{Is_Jg=--PE}', "");
    Expect(0, 1830, '\p{^Is_Jg=--PE}', "");
    Expect(0, 1830, '\P{Is_Jg=--PE}', "");
    Expect(1, 1830, '\P{^Is_Jg=--PE}', "");
    Expect(0, 1831, '\p{Is_Jg=--PE}', "");
    Expect(1, 1831, '\p{^Is_Jg=--PE}', "");
    Expect(1, 1831, '\P{Is_Jg=--PE}', "");
    Expect(0, 1831, '\P{^Is_Jg=--PE}', "");
    Error('\p{Joining_Group=/a/ -Qaf}');
    Error('\P{Joining_Group=/a/ -Qaf}');
    Expect(1, 2213, '\p{Joining_Group:   qaf}', "");
    Expect(0, 2213, '\p{^Joining_Group:   qaf}', "");
    Expect(0, 2213, '\P{Joining_Group:   qaf}', "");
    Expect(1, 2213, '\P{^Joining_Group:   qaf}', "");
    Expect(0, 2214, '\p{Joining_Group:   qaf}', "");
    Expect(1, 2214, '\p{^Joining_Group:   qaf}', "");
    Expect(1, 2214, '\P{Joining_Group:   qaf}', "");
    Expect(0, 2214, '\P{^Joining_Group:   qaf}', "");
    Expect(1, 2213, '\p{Joining_Group=QAF}', "");
    Expect(0, 2213, '\p{^Joining_Group=QAF}', "");
    Expect(0, 2213, '\P{Joining_Group=QAF}', "");
    Expect(1, 2213, '\P{^Joining_Group=QAF}', "");
    Expect(0, 2214, '\p{Joining_Group=QAF}', "");
    Expect(1, 2214, '\p{^Joining_Group=QAF}', "");
    Expect(1, 2214, '\P{Joining_Group=QAF}', "");
    Expect(0, 2214, '\P{^Joining_Group=QAF}', "");
    Error('\p{Jg:   -Qaf:=}');
    Error('\P{Jg:   -Qaf:=}');
    Expect(1, 2213, '\p{Jg=qaf}', "");
    Expect(0, 2213, '\p{^Jg=qaf}', "");
    Expect(0, 2213, '\P{Jg=qaf}', "");
    Expect(1, 2213, '\P{^Jg=qaf}', "");
    Expect(0, 2214, '\p{Jg=qaf}', "");
    Expect(1, 2214, '\p{^Jg=qaf}', "");
    Expect(1, 2214, '\P{Jg=qaf}', "");
    Expect(0, 2214, '\P{^Jg=qaf}', "");
    Expect(1, 2213, '\p{Jg= 	Qaf}', "");
    Expect(0, 2213, '\p{^Jg= 	Qaf}', "");
    Expect(0, 2213, '\P{Jg= 	Qaf}', "");
    Expect(1, 2213, '\P{^Jg= 	Qaf}', "");
    Expect(0, 2214, '\p{Jg= 	Qaf}', "");
    Expect(1, 2214, '\p{^Jg= 	Qaf}', "");
    Expect(1, 2214, '\P{Jg= 	Qaf}', "");
    Expect(0, 2214, '\P{^Jg= 	Qaf}', "");
    Error('\p{Is_Joining_Group=/a/- Qaf}');
    Error('\P{Is_Joining_Group=/a/- Qaf}');
    Expect(1, 2213, '\p{Is_Joining_Group=qaf}', "");
    Expect(0, 2213, '\p{^Is_Joining_Group=qaf}', "");
    Expect(0, 2213, '\P{Is_Joining_Group=qaf}', "");
    Expect(1, 2213, '\P{^Is_Joining_Group=qaf}', "");
    Expect(0, 2214, '\p{Is_Joining_Group=qaf}', "");
    Expect(1, 2214, '\p{^Is_Joining_Group=qaf}', "");
    Expect(1, 2214, '\P{Is_Joining_Group=qaf}', "");
    Expect(0, 2214, '\P{^Is_Joining_Group=qaf}', "");
    Expect(1, 2213, '\p{Is_Joining_Group= Qaf}', "");
    Expect(0, 2213, '\p{^Is_Joining_Group= Qaf}', "");
    Expect(0, 2213, '\P{Is_Joining_Group= Qaf}', "");
    Expect(1, 2213, '\P{^Is_Joining_Group= Qaf}', "");
    Expect(0, 2214, '\p{Is_Joining_Group= Qaf}', "");
    Expect(1, 2214, '\p{^Is_Joining_Group= Qaf}', "");
    Expect(1, 2214, '\P{Is_Joining_Group= Qaf}', "");
    Expect(0, 2214, '\P{^Is_Joining_Group= Qaf}', "");
    Error('\p{Is_Jg=:=		QAF}');
    Error('\P{Is_Jg=:=		QAF}');
    Expect(1, 2213, '\p{Is_Jg=qaf}', "");
    Expect(0, 2213, '\p{^Is_Jg=qaf}', "");
    Expect(0, 2213, '\P{Is_Jg=qaf}', "");
    Expect(1, 2213, '\P{^Is_Jg=qaf}', "");
    Expect(0, 2214, '\p{Is_Jg=qaf}', "");
    Expect(1, 2214, '\p{^Is_Jg=qaf}', "");
    Expect(1, 2214, '\P{Is_Jg=qaf}', "");
    Expect(0, 2214, '\P{^Is_Jg=qaf}', "");
    Expect(1, 2213, '\p{Is_Jg=-	Qaf}', "");
    Expect(0, 2213, '\p{^Is_Jg=-	Qaf}', "");
    Expect(0, 2213, '\P{Is_Jg=-	Qaf}', "");
    Expect(1, 2213, '\P{^Is_Jg=-	Qaf}', "");
    Expect(0, 2214, '\p{Is_Jg=-	Qaf}', "");
    Expect(1, 2214, '\p{^Is_Jg=-	Qaf}', "");
    Expect(1, 2214, '\P{Is_Jg=-	Qaf}', "");
    Expect(0, 2214, '\P{^Is_Jg=-	Qaf}', "");
    Error('\p{Joining_Group=	 qaph/a/}');
    Error('\P{Joining_Group=	 qaph/a/}');
    Expect(1, 1833, '\p{Joining_Group=qaph}', "");
    Expect(0, 1833, '\p{^Joining_Group=qaph}', "");
    Expect(0, 1833, '\P{Joining_Group=qaph}', "");
    Expect(1, 1833, '\P{^Joining_Group=qaph}', "");
    Expect(0, 1834, '\p{Joining_Group=qaph}', "");
    Expect(1, 1834, '\p{^Joining_Group=qaph}', "");
    Expect(1, 1834, '\P{Joining_Group=qaph}', "");
    Expect(0, 1834, '\P{^Joining_Group=qaph}', "");
    Expect(1, 1833, '\p{Joining_Group=	-Qaph}', "");
    Expect(0, 1833, '\p{^Joining_Group=	-Qaph}', "");
    Expect(0, 1833, '\P{Joining_Group=	-Qaph}', "");
    Expect(1, 1833, '\P{^Joining_Group=	-Qaph}', "");
    Expect(0, 1834, '\p{Joining_Group=	-Qaph}', "");
    Expect(1, 1834, '\p{^Joining_Group=	-Qaph}', "");
    Expect(1, 1834, '\P{Joining_Group=	-Qaph}', "");
    Expect(0, 1834, '\P{^Joining_Group=	-Qaph}', "");
    Error('\p{Jg:  :=qaph}');
    Error('\P{Jg:  :=qaph}');
    Expect(1, 1833, '\p{Jg=qaph}', "");
    Expect(0, 1833, '\p{^Jg=qaph}', "");
    Expect(0, 1833, '\P{Jg=qaph}', "");
    Expect(1, 1833, '\P{^Jg=qaph}', "");
    Expect(0, 1834, '\p{Jg=qaph}', "");
    Expect(1, 1834, '\p{^Jg=qaph}', "");
    Expect(1, 1834, '\P{Jg=qaph}', "");
    Expect(0, 1834, '\P{^Jg=qaph}', "");
    Expect(1, 1833, '\p{Jg=		Qaph}', "");
    Expect(0, 1833, '\p{^Jg=		Qaph}', "");
    Expect(0, 1833, '\P{Jg=		Qaph}', "");
    Expect(1, 1833, '\P{^Jg=		Qaph}', "");
    Expect(0, 1834, '\p{Jg=		Qaph}', "");
    Expect(1, 1834, '\p{^Jg=		Qaph}', "");
    Expect(1, 1834, '\P{Jg=		Qaph}', "");
    Expect(0, 1834, '\P{^Jg=		Qaph}', "");
    Error('\p{Is_Joining_Group=_ Qaph:=}');
    Error('\P{Is_Joining_Group=_ Qaph:=}');
    Expect(1, 1833, '\p{Is_Joining_Group=qaph}', "");
    Expect(0, 1833, '\p{^Is_Joining_Group=qaph}', "");
    Expect(0, 1833, '\P{Is_Joining_Group=qaph}', "");
    Expect(1, 1833, '\P{^Is_Joining_Group=qaph}', "");
    Expect(0, 1834, '\p{Is_Joining_Group=qaph}', "");
    Expect(1, 1834, '\p{^Is_Joining_Group=qaph}', "");
    Expect(1, 1834, '\P{Is_Joining_Group=qaph}', "");
    Expect(0, 1834, '\P{^Is_Joining_Group=qaph}', "");
    Error('\p{Is_Jg= QAPH/a/}');
    Error('\P{Is_Jg= QAPH/a/}');
    Expect(1, 1833, '\p{Is_Jg=qaph}', "");
    Expect(0, 1833, '\p{^Is_Jg=qaph}', "");
    Expect(0, 1833, '\P{Is_Jg=qaph}', "");
    Expect(1, 1833, '\P{^Is_Jg=qaph}', "");
    Expect(0, 1834, '\p{Is_Jg=qaph}', "");
    Expect(1, 1834, '\p{^Is_Jg=qaph}', "");
    Expect(1, 1834, '\P{Is_Jg=qaph}', "");
    Expect(0, 1834, '\P{^Is_Jg=qaph}', "");
    Expect(1, 1833, '\p{Is_Jg:		_QAPH}', "");
    Expect(0, 1833, '\p{^Is_Jg:		_QAPH}', "");
    Expect(0, 1833, '\P{Is_Jg:		_QAPH}', "");
    Expect(1, 1833, '\P{^Is_Jg:		_QAPH}', "");
    Expect(0, 1834, '\p{Is_Jg:		_QAPH}', "");
    Expect(1, 1834, '\p{^Is_Jg:		_QAPH}', "");
    Expect(1, 1834, '\P{Is_Jg:		_QAPH}', "");
    Expect(0, 1834, '\P{^Is_Jg:		_QAPH}', "");
    Error('\p{Joining_Group=- Reh/a/}');
    Error('\P{Joining_Group=- Reh/a/}');
    Expect(1, 2233, '\p{Joining_Group=reh}', "");
    Expect(0, 2233, '\p{^Joining_Group=reh}', "");
    Expect(0, 2233, '\P{Joining_Group=reh}', "");
    Expect(1, 2233, '\P{^Joining_Group=reh}', "");
    Expect(0, 2234, '\p{Joining_Group=reh}', "");
    Expect(1, 2234, '\p{^Joining_Group=reh}', "");
    Expect(1, 2234, '\P{Joining_Group=reh}', "");
    Expect(0, 2234, '\P{^Joining_Group=reh}', "");
    Expect(1, 2233, '\p{Joining_Group=	_Reh}', "");
    Expect(0, 2233, '\p{^Joining_Group=	_Reh}', "");
    Expect(0, 2233, '\P{Joining_Group=	_Reh}', "");
    Expect(1, 2233, '\P{^Joining_Group=	_Reh}', "");
    Expect(0, 2234, '\p{Joining_Group=	_Reh}', "");
    Expect(1, 2234, '\p{^Joining_Group=	_Reh}', "");
    Expect(1, 2234, '\P{Joining_Group=	_Reh}', "");
    Expect(0, 2234, '\P{^Joining_Group=	_Reh}', "");
    Error('\p{Jg=:=- Reh}');
    Error('\P{Jg=:=- Reh}');
    Expect(1, 2233, '\p{Jg=reh}', "");
    Expect(0, 2233, '\p{^Jg=reh}', "");
    Expect(0, 2233, '\P{Jg=reh}', "");
    Expect(1, 2233, '\P{^Jg=reh}', "");
    Expect(0, 2234, '\p{Jg=reh}', "");
    Expect(1, 2234, '\p{^Jg=reh}', "");
    Expect(1, 2234, '\P{Jg=reh}', "");
    Expect(0, 2234, '\P{^Jg=reh}', "");
    Expect(1, 2233, '\p{Jg=--REH}', "");
    Expect(0, 2233, '\p{^Jg=--REH}', "");
    Expect(0, 2233, '\P{Jg=--REH}', "");
    Expect(1, 2233, '\P{^Jg=--REH}', "");
    Expect(0, 2234, '\p{Jg=--REH}', "");
    Expect(1, 2234, '\p{^Jg=--REH}', "");
    Expect(1, 2234, '\P{Jg=--REH}', "");
    Expect(0, 2234, '\P{^Jg=--REH}', "");
    Error('\p{Is_Joining_Group=-Reh:=}');
    Error('\P{Is_Joining_Group=-Reh:=}');
    Expect(1, 2233, '\p{Is_Joining_Group=reh}', "");
    Expect(0, 2233, '\p{^Is_Joining_Group=reh}', "");
    Expect(0, 2233, '\P{Is_Joining_Group=reh}', "");
    Expect(1, 2233, '\P{^Is_Joining_Group=reh}', "");
    Expect(0, 2234, '\p{Is_Joining_Group=reh}', "");
    Expect(1, 2234, '\p{^Is_Joining_Group=reh}', "");
    Expect(1, 2234, '\P{Is_Joining_Group=reh}', "");
    Expect(0, 2234, '\P{^Is_Joining_Group=reh}', "");
    Expect(1, 2233, '\p{Is_Joining_Group=- REH}', "");
    Expect(0, 2233, '\p{^Is_Joining_Group=- REH}', "");
    Expect(0, 2233, '\P{Is_Joining_Group=- REH}', "");
    Expect(1, 2233, '\P{^Is_Joining_Group=- REH}', "");
    Expect(0, 2234, '\p{Is_Joining_Group=- REH}', "");
    Expect(1, 2234, '\p{^Is_Joining_Group=- REH}', "");
    Expect(1, 2234, '\P{Is_Joining_Group=- REH}', "");
    Expect(0, 2234, '\P{^Is_Joining_Group=- REH}', "");
    Error('\p{Is_Jg:/a/reh}');
    Error('\P{Is_Jg:/a/reh}');
    Expect(1, 2233, '\p{Is_Jg=reh}', "");
    Expect(0, 2233, '\p{^Is_Jg=reh}', "");
    Expect(0, 2233, '\P{Is_Jg=reh}', "");
    Expect(1, 2233, '\P{^Is_Jg=reh}', "");
    Expect(0, 2234, '\p{Is_Jg=reh}', "");
    Expect(1, 2234, '\p{^Is_Jg=reh}', "");
    Expect(1, 2234, '\P{Is_Jg=reh}', "");
    Expect(0, 2234, '\P{^Is_Jg=reh}', "");
    Expect(1, 2233, '\p{Is_Jg=	-REH}', "");
    Expect(0, 2233, '\p{^Is_Jg=	-REH}', "");
    Expect(0, 2233, '\P{Is_Jg=	-REH}', "");
    Expect(1, 2233, '\P{^Is_Jg=	-REH}', "");
    Expect(0, 2234, '\p{Is_Jg=	-REH}', "");
    Expect(1, 2234, '\p{^Is_Jg=	-REH}', "");
    Expect(1, 2234, '\P{Is_Jg=	-REH}', "");
    Expect(0, 2234, '\P{^Is_Jg=	-REH}', "");
    Error('\p{Joining_Group=/a/REVERSED_PE}');
    Error('\P{Joining_Group=/a/REVERSED_PE}');
    Expect(1, 1831, '\p{Joining_Group=reversedpe}', "");
    Expect(0, 1831, '\p{^Joining_Group=reversedpe}', "");
    Expect(0, 1831, '\P{Joining_Group=reversedpe}', "");
    Expect(1, 1831, '\P{^Joining_Group=reversedpe}', "");
    Expect(0, 1832, '\p{Joining_Group=reversedpe}', "");
    Expect(1, 1832, '\p{^Joining_Group=reversedpe}', "");
    Expect(1, 1832, '\P{Joining_Group=reversedpe}', "");
    Expect(0, 1832, '\P{^Joining_Group=reversedpe}', "");
    Expect(1, 1831, '\p{Joining_Group=--Reversed_PE}', "");
    Expect(0, 1831, '\p{^Joining_Group=--Reversed_PE}', "");
    Expect(0, 1831, '\P{Joining_Group=--Reversed_PE}', "");
    Expect(1, 1831, '\P{^Joining_Group=--Reversed_PE}', "");
    Expect(0, 1832, '\p{Joining_Group=--Reversed_PE}', "");
    Expect(1, 1832, '\p{^Joining_Group=--Reversed_PE}', "");
    Expect(1, 1832, '\P{Joining_Group=--Reversed_PE}', "");
    Expect(0, 1832, '\P{^Joining_Group=--Reversed_PE}', "");
    Error('\p{Jg=	_Reversed_PE:=}');
    Error('\P{Jg=	_Reversed_PE:=}');
    Expect(1, 1831, '\p{Jg=reversedpe}', "");
    Expect(0, 1831, '\p{^Jg=reversedpe}', "");
    Expect(0, 1831, '\P{Jg=reversedpe}', "");
    Expect(1, 1831, '\P{^Jg=reversedpe}', "");
    Expect(0, 1832, '\p{Jg=reversedpe}', "");
    Expect(1, 1832, '\p{^Jg=reversedpe}', "");
    Expect(1, 1832, '\P{Jg=reversedpe}', "");
    Expect(0, 1832, '\P{^Jg=reversedpe}', "");
    Expect(1, 1831, '\p{Jg= Reversed_Pe}', "");
    Expect(0, 1831, '\p{^Jg= Reversed_Pe}', "");
    Expect(0, 1831, '\P{Jg= Reversed_Pe}', "");
    Expect(1, 1831, '\P{^Jg= Reversed_Pe}', "");
    Expect(0, 1832, '\p{Jg= Reversed_Pe}', "");
    Expect(1, 1832, '\p{^Jg= Reversed_Pe}', "");
    Expect(1, 1832, '\P{Jg= Reversed_Pe}', "");
    Expect(0, 1832, '\P{^Jg= Reversed_Pe}', "");
    Error('\p{Is_Joining_Group=/a/-REVERSED_pe}');
    Error('\P{Is_Joining_Group=/a/-REVERSED_pe}');
    Expect(1, 1831, '\p{Is_Joining_Group=reversedpe}', "");
    Expect(0, 1831, '\p{^Is_Joining_Group=reversedpe}', "");
    Expect(0, 1831, '\P{Is_Joining_Group=reversedpe}', "");
    Expect(1, 1831, '\P{^Is_Joining_Group=reversedpe}', "");
    Expect(0, 1832, '\p{Is_Joining_Group=reversedpe}', "");
    Expect(1, 1832, '\p{^Is_Joining_Group=reversedpe}', "");
    Expect(1, 1832, '\P{Is_Joining_Group=reversedpe}', "");
    Expect(0, 1832, '\P{^Is_Joining_Group=reversedpe}', "");
    Expect(1, 1831, '\p{Is_Joining_Group=_-Reversed_Pe}', "");
    Expect(0, 1831, '\p{^Is_Joining_Group=_-Reversed_Pe}', "");
    Expect(0, 1831, '\P{Is_Joining_Group=_-Reversed_Pe}', "");
    Expect(1, 1831, '\P{^Is_Joining_Group=_-Reversed_Pe}', "");
    Expect(0, 1832, '\p{Is_Joining_Group=_-Reversed_Pe}', "");
    Expect(1, 1832, '\p{^Is_Joining_Group=_-Reversed_Pe}', "");
    Expect(1, 1832, '\P{Is_Joining_Group=_-Reversed_Pe}', "");
    Expect(0, 1832, '\P{^Is_Joining_Group=_-Reversed_Pe}', "");
    Error('\p{Is_Jg:   _	Reversed_pe/a/}');
    Error('\P{Is_Jg:   _	Reversed_pe/a/}');
    Expect(1, 1831, '\p{Is_Jg=reversedpe}', "");
    Expect(0, 1831, '\p{^Is_Jg=reversedpe}', "");
    Expect(0, 1831, '\P{Is_Jg=reversedpe}', "");
    Expect(1, 1831, '\P{^Is_Jg=reversedpe}', "");
    Expect(0, 1832, '\p{Is_Jg=reversedpe}', "");
    Expect(1, 1832, '\p{^Is_Jg=reversedpe}', "");
    Expect(1, 1832, '\P{Is_Jg=reversedpe}', "");
    Expect(0, 1832, '\P{^Is_Jg=reversedpe}', "");
    Expect(1, 1831, '\p{Is_Jg=  Reversed_PE}', "");
    Expect(0, 1831, '\p{^Is_Jg=  Reversed_PE}', "");
    Expect(0, 1831, '\P{Is_Jg=  Reversed_PE}', "");
    Expect(1, 1831, '\P{^Is_Jg=  Reversed_PE}', "");
    Expect(0, 1832, '\p{Is_Jg=  Reversed_PE}', "");
    Expect(1, 1832, '\p{^Is_Jg=  Reversed_PE}', "");
    Expect(1, 1832, '\P{Is_Jg=  Reversed_PE}', "");
    Expect(0, 1832, '\P{^Is_Jg=  Reversed_PE}', "");
    Error('\p{Joining_Group=_:=Rohingya_Yeh}');
    Error('\P{Joining_Group=_:=Rohingya_Yeh}');
    Expect(1, 2220, '\p{Joining_Group:   rohingyayeh}', "");
    Expect(0, 2220, '\p{^Joining_Group:   rohingyayeh}', "");
    Expect(0, 2220, '\P{Joining_Group:   rohingyayeh}', "");
    Expect(1, 2220, '\P{^Joining_Group:   rohingyayeh}', "");
    Expect(0, 2221, '\p{Joining_Group:   rohingyayeh}', "");
    Expect(1, 2221, '\p{^Joining_Group:   rohingyayeh}', "");
    Expect(1, 2221, '\P{Joining_Group:   rohingyayeh}', "");
    Expect(0, 2221, '\P{^Joining_Group:   rohingyayeh}', "");
    Expect(1, 2220, '\p{Joining_Group=_-ROHINGYA_Yeh}', "");
    Expect(0, 2220, '\p{^Joining_Group=_-ROHINGYA_Yeh}', "");
    Expect(0, 2220, '\P{Joining_Group=_-ROHINGYA_Yeh}', "");
    Expect(1, 2220, '\P{^Joining_Group=_-ROHINGYA_Yeh}', "");
    Expect(0, 2221, '\p{Joining_Group=_-ROHINGYA_Yeh}', "");
    Expect(1, 2221, '\p{^Joining_Group=_-ROHINGYA_Yeh}', "");
    Expect(1, 2221, '\P{Joining_Group=_-ROHINGYA_Yeh}', "");
    Expect(0, 2221, '\P{^Joining_Group=_-ROHINGYA_Yeh}', "");
    Error('\p{Jg= _rohingya_yeh/a/}');
    Error('\P{Jg= _rohingya_yeh/a/}');
    Expect(1, 2220, '\p{Jg=rohingyayeh}', "");
    Expect(0, 2220, '\p{^Jg=rohingyayeh}', "");
    Expect(0, 2220, '\P{Jg=rohingyayeh}', "");
    Expect(1, 2220, '\P{^Jg=rohingyayeh}', "");
    Expect(0, 2221, '\p{Jg=rohingyayeh}', "");
    Expect(1, 2221, '\p{^Jg=rohingyayeh}', "");
    Expect(1, 2221, '\P{Jg=rohingyayeh}', "");
    Expect(0, 2221, '\P{^Jg=rohingyayeh}', "");
    Expect(1, 2220, '\p{Jg=_ROHINGYA_YEH}', "");
    Expect(0, 2220, '\p{^Jg=_ROHINGYA_YEH}', "");
    Expect(0, 2220, '\P{Jg=_ROHINGYA_YEH}', "");
    Expect(1, 2220, '\P{^Jg=_ROHINGYA_YEH}', "");
    Expect(0, 2221, '\p{Jg=_ROHINGYA_YEH}', "");
    Expect(1, 2221, '\p{^Jg=_ROHINGYA_YEH}', "");
    Expect(1, 2221, '\P{Jg=_ROHINGYA_YEH}', "");
    Expect(0, 2221, '\P{^Jg=_ROHINGYA_YEH}', "");
    Error('\p{Is_Joining_Group=:=ROHINGYA_Yeh}');
    Error('\P{Is_Joining_Group=:=ROHINGYA_Yeh}');
    Expect(1, 2220, '\p{Is_Joining_Group=rohingyayeh}', "");
    Expect(0, 2220, '\p{^Is_Joining_Group=rohingyayeh}', "");
    Expect(0, 2220, '\P{Is_Joining_Group=rohingyayeh}', "");
    Expect(1, 2220, '\P{^Is_Joining_Group=rohingyayeh}', "");
    Expect(0, 2221, '\p{Is_Joining_Group=rohingyayeh}', "");
    Expect(1, 2221, '\p{^Is_Joining_Group=rohingyayeh}', "");
    Expect(1, 2221, '\P{Is_Joining_Group=rohingyayeh}', "");
    Expect(0, 2221, '\P{^Is_Joining_Group=rohingyayeh}', "");
    Expect(1, 2220, '\p{Is_Joining_Group=- rohingya_YEH}', "");
    Expect(0, 2220, '\p{^Is_Joining_Group=- rohingya_YEH}', "");
    Expect(0, 2220, '\P{Is_Joining_Group=- rohingya_YEH}', "");
    Expect(1, 2220, '\P{^Is_Joining_Group=- rohingya_YEH}', "");
    Expect(0, 2221, '\p{Is_Joining_Group=- rohingya_YEH}', "");
    Expect(1, 2221, '\p{^Is_Joining_Group=- rohingya_YEH}', "");
    Expect(1, 2221, '\P{Is_Joining_Group=- rohingya_YEH}', "");
    Expect(0, 2221, '\P{^Is_Joining_Group=- rohingya_YEH}', "");
    Error('\p{Is_Jg=:=_ROHINGYA_YEH}');
    Error('\P{Is_Jg=:=_ROHINGYA_YEH}');
    Expect(1, 2220, '\p{Is_Jg:   rohingyayeh}', "");
    Expect(0, 2220, '\p{^Is_Jg:   rohingyayeh}', "");
    Expect(0, 2220, '\P{Is_Jg:   rohingyayeh}', "");
    Expect(1, 2220, '\P{^Is_Jg:   rohingyayeh}', "");
    Expect(0, 2221, '\p{Is_Jg:   rohingyayeh}', "");
    Expect(1, 2221, '\p{^Is_Jg:   rohingyayeh}', "");
    Expect(1, 2221, '\P{Is_Jg:   rohingyayeh}', "");
    Expect(0, 2221, '\P{^Is_Jg:   rohingyayeh}', "");
    Expect(1, 2220, '\p{Is_Jg:	-rohingya_yeh}', "");
    Expect(0, 2220, '\p{^Is_Jg:	-rohingya_yeh}', "");
    Expect(0, 2220, '\P{Is_Jg:	-rohingya_yeh}', "");
    Expect(1, 2220, '\P{^Is_Jg:	-rohingya_yeh}', "");
    Expect(0, 2221, '\p{Is_Jg:	-rohingya_yeh}', "");
    Expect(1, 2221, '\p{^Is_Jg:	-rohingya_yeh}', "");
    Expect(1, 2221, '\P{Is_Jg:	-rohingya_yeh}', "");
    Expect(0, 2221, '\P{^Is_Jg:	-rohingya_yeh}', "");
    Error('\p{Joining_Group=	:=Sad}');
    Error('\P{Joining_Group=	:=Sad}');
    Expect(1, 2223, '\p{Joining_Group=sad}', "");
    Expect(0, 2223, '\p{^Joining_Group=sad}', "");
    Expect(0, 2223, '\P{Joining_Group=sad}', "");
    Expect(1, 2223, '\P{^Joining_Group=sad}', "");
    Expect(0, 2224, '\p{Joining_Group=sad}', "");
    Expect(1, 2224, '\p{^Joining_Group=sad}', "");
    Expect(1, 2224, '\P{Joining_Group=sad}', "");
    Expect(0, 2224, '\P{^Joining_Group=sad}', "");
    Expect(1, 2223, '\p{Joining_Group=_-SAD}', "");
    Expect(0, 2223, '\p{^Joining_Group=_-SAD}', "");
    Expect(0, 2223, '\P{Joining_Group=_-SAD}', "");
    Expect(1, 2223, '\P{^Joining_Group=_-SAD}', "");
    Expect(0, 2224, '\p{Joining_Group=_-SAD}', "");
    Expect(1, 2224, '\p{^Joining_Group=_-SAD}', "");
    Expect(1, 2224, '\P{Joining_Group=_-SAD}', "");
    Expect(0, 2224, '\P{^Joining_Group=_-SAD}', "");
    Error('\p{Jg=-Sad:=}');
    Error('\P{Jg=-Sad:=}');
    Expect(1, 2223, '\p{Jg=sad}', "");
    Expect(0, 2223, '\p{^Jg=sad}', "");
    Expect(0, 2223, '\P{Jg=sad}', "");
    Expect(1, 2223, '\P{^Jg=sad}', "");
    Expect(0, 2224, '\p{Jg=sad}', "");
    Expect(1, 2224, '\p{^Jg=sad}', "");
    Expect(1, 2224, '\P{Jg=sad}', "");
    Expect(0, 2224, '\P{^Jg=sad}', "");
    Expect(1, 2223, '\p{Jg=Sad}', "");
    Expect(0, 2223, '\p{^Jg=Sad}', "");
    Expect(0, 2223, '\P{Jg=Sad}', "");
    Expect(1, 2223, '\P{^Jg=Sad}', "");
    Expect(0, 2224, '\p{Jg=Sad}', "");
    Expect(1, 2224, '\p{^Jg=Sad}', "");
    Expect(1, 2224, '\P{Jg=Sad}', "");
    Expect(0, 2224, '\P{^Jg=Sad}', "");
    Error('\p{Is_Joining_Group:   _-SAD/a/}');
    Error('\P{Is_Joining_Group:   _-SAD/a/}');
    Expect(1, 2223, '\p{Is_Joining_Group=sad}', "");
    Expect(0, 2223, '\p{^Is_Joining_Group=sad}', "");
    Expect(0, 2223, '\P{Is_Joining_Group=sad}', "");
    Expect(1, 2223, '\P{^Is_Joining_Group=sad}', "");
    Expect(0, 2224, '\p{Is_Joining_Group=sad}', "");
    Expect(1, 2224, '\p{^Is_Joining_Group=sad}', "");
    Expect(1, 2224, '\P{Is_Joining_Group=sad}', "");
    Expect(0, 2224, '\P{^Is_Joining_Group=sad}', "");
    Expect(1, 2223, '\p{Is_Joining_Group=	Sad}', "");
    Expect(0, 2223, '\p{^Is_Joining_Group=	Sad}', "");
    Expect(0, 2223, '\P{Is_Joining_Group=	Sad}', "");
    Expect(1, 2223, '\P{^Is_Joining_Group=	Sad}', "");
    Expect(0, 2224, '\p{Is_Joining_Group=	Sad}', "");
    Expect(1, 2224, '\p{^Is_Joining_Group=	Sad}', "");
    Expect(1, 2224, '\P{Is_Joining_Group=	Sad}', "");
    Expect(0, 2224, '\P{^Is_Joining_Group=	Sad}', "");
    Error('\p{Is_Jg=_:=sad}');
    Error('\P{Is_Jg=_:=sad}');
    Expect(1, 2223, '\p{Is_Jg:sad}', "");
    Expect(0, 2223, '\p{^Is_Jg:sad}', "");
    Expect(0, 2223, '\P{Is_Jg:sad}', "");
    Expect(1, 2223, '\P{^Is_Jg:sad}', "");
    Expect(0, 2224, '\p{Is_Jg:sad}', "");
    Expect(1, 2224, '\p{^Is_Jg:sad}', "");
    Expect(1, 2224, '\P{Is_Jg:sad}', "");
    Expect(0, 2224, '\P{^Is_Jg:sad}', "");
    Expect(1, 2223, '\p{Is_Jg=_SAD}', "");
    Expect(0, 2223, '\p{^Is_Jg=_SAD}', "");
    Expect(0, 2223, '\P{Is_Jg=_SAD}', "");
    Expect(1, 2223, '\P{^Is_Jg=_SAD}', "");
    Expect(0, 2224, '\p{Is_Jg=_SAD}', "");
    Expect(1, 2224, '\p{^Is_Jg=_SAD}', "");
    Expect(1, 2224, '\P{Is_Jg=_SAD}', "");
    Expect(0, 2224, '\P{^Is_Jg=_SAD}', "");
    Error('\p{Joining_Group=	_SADHE/a/}');
    Error('\P{Joining_Group=	_SADHE/a/}');
    Expect(1, 1832, '\p{Joining_Group=sadhe}', "");
    Expect(0, 1832, '\p{^Joining_Group=sadhe}', "");
    Expect(0, 1832, '\P{Joining_Group=sadhe}', "");
    Expect(1, 1832, '\P{^Joining_Group=sadhe}', "");
    Expect(0, 1833, '\p{Joining_Group=sadhe}', "");
    Expect(1, 1833, '\p{^Joining_Group=sadhe}', "");
    Expect(1, 1833, '\P{Joining_Group=sadhe}', "");
    Expect(0, 1833, '\P{^Joining_Group=sadhe}', "");
    Expect(1, 1832, '\p{Joining_Group: -SADHE}', "");
    Expect(0, 1832, '\p{^Joining_Group: -SADHE}', "");
    Expect(0, 1832, '\P{Joining_Group: -SADHE}', "");
    Expect(1, 1832, '\P{^Joining_Group: -SADHE}', "");
    Expect(0, 1833, '\p{Joining_Group: -SADHE}', "");
    Expect(1, 1833, '\p{^Joining_Group: -SADHE}', "");
    Expect(1, 1833, '\P{Joining_Group: -SADHE}', "");
    Expect(0, 1833, '\P{^Joining_Group: -SADHE}', "");
    Error('\p{Jg:	:=_SADHE}');
    Error('\P{Jg:	:=_SADHE}');
    Expect(1, 1832, '\p{Jg: sadhe}', "");
    Expect(0, 1832, '\p{^Jg: sadhe}', "");
    Expect(0, 1832, '\P{Jg: sadhe}', "");
    Expect(1, 1832, '\P{^Jg: sadhe}', "");
    Expect(0, 1833, '\p{Jg: sadhe}', "");
    Expect(1, 1833, '\p{^Jg: sadhe}', "");
    Expect(1, 1833, '\P{Jg: sadhe}', "");
    Expect(0, 1833, '\P{^Jg: sadhe}', "");
    Expect(1, 1832, '\p{Jg=	sadhe}', "");
    Expect(0, 1832, '\p{^Jg=	sadhe}', "");
    Expect(0, 1832, '\P{Jg=	sadhe}', "");
    Expect(1, 1832, '\P{^Jg=	sadhe}', "");
    Expect(0, 1833, '\p{Jg=	sadhe}', "");
    Expect(1, 1833, '\p{^Jg=	sadhe}', "");
    Expect(1, 1833, '\P{Jg=	sadhe}', "");
    Expect(0, 1833, '\P{^Jg=	sadhe}', "");
    Error('\p{Is_Joining_Group:   _	Sadhe/a/}');
    Error('\P{Is_Joining_Group:   _	Sadhe/a/}');
    Expect(1, 1832, '\p{Is_Joining_Group=sadhe}', "");
    Expect(0, 1832, '\p{^Is_Joining_Group=sadhe}', "");
    Expect(0, 1832, '\P{Is_Joining_Group=sadhe}', "");
    Expect(1, 1832, '\P{^Is_Joining_Group=sadhe}', "");
    Expect(0, 1833, '\p{Is_Joining_Group=sadhe}', "");
    Expect(1, 1833, '\p{^Is_Joining_Group=sadhe}', "");
    Expect(1, 1833, '\P{Is_Joining_Group=sadhe}', "");
    Expect(0, 1833, '\P{^Is_Joining_Group=sadhe}', "");
    Expect(1, 1832, '\p{Is_Joining_Group=_-Sadhe}', "");
    Expect(0, 1832, '\p{^Is_Joining_Group=_-Sadhe}', "");
    Expect(0, 1832, '\P{Is_Joining_Group=_-Sadhe}', "");
    Expect(1, 1832, '\P{^Is_Joining_Group=_-Sadhe}', "");
    Expect(0, 1833, '\p{Is_Joining_Group=_-Sadhe}', "");
    Expect(1, 1833, '\p{^Is_Joining_Group=_-Sadhe}', "");
    Expect(1, 1833, '\P{Is_Joining_Group=_-Sadhe}', "");
    Expect(0, 1833, '\P{^Is_Joining_Group=_-Sadhe}', "");
    Error('\p{Is_Jg=-:=Sadhe}');
    Error('\P{Is_Jg=-:=Sadhe}');
    Expect(1, 1832, '\p{Is_Jg=sadhe}', "");
    Expect(0, 1832, '\p{^Is_Jg=sadhe}', "");
    Expect(0, 1832, '\P{Is_Jg=sadhe}', "");
    Expect(1, 1832, '\P{^Is_Jg=sadhe}', "");
    Expect(0, 1833, '\p{Is_Jg=sadhe}', "");
    Expect(1, 1833, '\p{^Is_Jg=sadhe}', "");
    Expect(1, 1833, '\P{Is_Jg=sadhe}', "");
    Expect(0, 1833, '\P{^Is_Jg=sadhe}', "");
    Expect(1, 1832, '\p{Is_Jg=-Sadhe}', "");
    Expect(0, 1832, '\p{^Is_Jg=-Sadhe}', "");
    Expect(0, 1832, '\P{Is_Jg=-Sadhe}', "");
    Expect(1, 1832, '\P{^Is_Jg=-Sadhe}', "");
    Expect(0, 1833, '\p{Is_Jg=-Sadhe}', "");
    Expect(1, 1833, '\p{^Is_Jg=-Sadhe}', "");
    Expect(1, 1833, '\P{Is_Jg=-Sadhe}', "");
    Expect(0, 1833, '\P{^Is_Jg=-Sadhe}', "");
    Error('\p{Joining_Group= SEEN:=}');
    Error('\P{Joining_Group= SEEN:=}');
    Expect(1, 1918, '\p{Joining_Group=seen}', "");
    Expect(0, 1918, '\p{^Joining_Group=seen}', "");
    Expect(0, 1918, '\P{Joining_Group=seen}', "");
    Expect(1, 1918, '\P{^Joining_Group=seen}', "");
    Expect(0, 1919, '\p{Joining_Group=seen}', "");
    Expect(1, 1919, '\p{^Joining_Group=seen}', "");
    Expect(1, 1919, '\P{Joining_Group=seen}', "");
    Expect(0, 1919, '\P{^Joining_Group=seen}', "");
    Expect(1, 1918, '\p{Joining_Group=_ Seen}', "");
    Expect(0, 1918, '\p{^Joining_Group=_ Seen}', "");
    Expect(0, 1918, '\P{Joining_Group=_ Seen}', "");
    Expect(1, 1918, '\P{^Joining_Group=_ Seen}', "");
    Expect(0, 1919, '\p{Joining_Group=_ Seen}', "");
    Expect(1, 1919, '\p{^Joining_Group=_ Seen}', "");
    Expect(1, 1919, '\P{Joining_Group=_ Seen}', "");
    Expect(0, 1919, '\P{^Joining_Group=_ Seen}', "");
    Error('\p{Jg=	seen:=}');
    Error('\P{Jg=	seen:=}');
    Expect(1, 1918, '\p{Jg:seen}', "");
    Expect(0, 1918, '\p{^Jg:seen}', "");
    Expect(0, 1918, '\P{Jg:seen}', "");
    Expect(1, 1918, '\P{^Jg:seen}', "");
    Expect(0, 1919, '\p{Jg:seen}', "");
    Expect(1, 1919, '\p{^Jg:seen}', "");
    Expect(1, 1919, '\P{Jg:seen}', "");
    Expect(0, 1919, '\P{^Jg:seen}', "");
    Expect(1, 1918, '\p{Jg=_ SEEN}', "");
    Expect(0, 1918, '\p{^Jg=_ SEEN}', "");
    Expect(0, 1918, '\P{Jg=_ SEEN}', "");
    Expect(1, 1918, '\P{^Jg=_ SEEN}', "");
    Expect(0, 1919, '\p{Jg=_ SEEN}', "");
    Expect(1, 1919, '\p{^Jg=_ SEEN}', "");
    Expect(1, 1919, '\P{Jg=_ SEEN}', "");
    Expect(0, 1919, '\P{^Jg=_ SEEN}', "");
    Error('\p{Is_Joining_Group= Seen/a/}');
    Error('\P{Is_Joining_Group= Seen/a/}');
    Expect(1, 1918, '\p{Is_Joining_Group=seen}', "");
    Expect(0, 1918, '\p{^Is_Joining_Group=seen}', "");
    Expect(0, 1918, '\P{Is_Joining_Group=seen}', "");
    Expect(1, 1918, '\P{^Is_Joining_Group=seen}', "");
    Expect(0, 1919, '\p{Is_Joining_Group=seen}', "");
    Expect(1, 1919, '\p{^Is_Joining_Group=seen}', "");
    Expect(1, 1919, '\P{Is_Joining_Group=seen}', "");
    Expect(0, 1919, '\P{^Is_Joining_Group=seen}', "");
    Expect(1, 1918, '\p{Is_Joining_Group=-Seen}', "");
    Expect(0, 1918, '\p{^Is_Joining_Group=-Seen}', "");
    Expect(0, 1918, '\P{Is_Joining_Group=-Seen}', "");
    Expect(1, 1918, '\P{^Is_Joining_Group=-Seen}', "");
    Expect(0, 1919, '\p{Is_Joining_Group=-Seen}', "");
    Expect(1, 1919, '\p{^Is_Joining_Group=-Seen}', "");
    Expect(1, 1919, '\P{Is_Joining_Group=-Seen}', "");
    Expect(0, 1919, '\P{^Is_Joining_Group=-Seen}', "");
    Error('\p{Is_Jg=_/a/SEEN}');
    Error('\P{Is_Jg=_/a/SEEN}');
    Expect(1, 1918, '\p{Is_Jg=seen}', "");
    Expect(0, 1918, '\p{^Is_Jg=seen}', "");
    Expect(0, 1918, '\P{Is_Jg=seen}', "");
    Expect(1, 1918, '\P{^Is_Jg=seen}', "");
    Expect(0, 1919, '\p{Is_Jg=seen}', "");
    Expect(1, 1919, '\p{^Is_Jg=seen}', "");
    Expect(1, 1919, '\P{Is_Jg=seen}', "");
    Expect(0, 1919, '\P{^Is_Jg=seen}', "");
    Expect(1, 1918, '\p{Is_Jg= Seen}', "");
    Expect(0, 1918, '\p{^Is_Jg= Seen}', "");
    Expect(0, 1918, '\P{Is_Jg= Seen}', "");
    Expect(1, 1918, '\P{^Is_Jg= Seen}', "");
    Expect(0, 1919, '\p{Is_Jg= Seen}', "");
    Expect(1, 1919, '\p{^Is_Jg= Seen}', "");
    Expect(1, 1919, '\P{Is_Jg= Seen}', "");
    Expect(0, 1919, '\P{^Is_Jg= Seen}', "");
    Error('\p{Joining_Group=_/a/Semkath}');
    Error('\P{Joining_Group=_/a/Semkath}');
    Expect(1, 1827, '\p{Joining_Group:	semkath}', "");
    Expect(0, 1827, '\p{^Joining_Group:	semkath}', "");
    Expect(0, 1827, '\P{Joining_Group:	semkath}', "");
    Expect(1, 1827, '\P{^Joining_Group:	semkath}', "");
    Expect(0, 1828, '\p{Joining_Group:	semkath}', "");
    Expect(1, 1828, '\p{^Joining_Group:	semkath}', "");
    Expect(1, 1828, '\P{Joining_Group:	semkath}', "");
    Expect(0, 1828, '\P{^Joining_Group:	semkath}', "");
    Expect(1, 1827, '\p{Joining_Group:		Semkath}', "");
    Expect(0, 1827, '\p{^Joining_Group:		Semkath}', "");
    Expect(0, 1827, '\P{Joining_Group:		Semkath}', "");
    Expect(1, 1827, '\P{^Joining_Group:		Semkath}', "");
    Expect(0, 1828, '\p{Joining_Group:		Semkath}', "");
    Expect(1, 1828, '\p{^Joining_Group:		Semkath}', "");
    Expect(1, 1828, '\P{Joining_Group:		Semkath}', "");
    Expect(0, 1828, '\P{^Joining_Group:		Semkath}', "");
    Error('\p{Jg:/a/	semkath}');
    Error('\P{Jg:/a/	semkath}');
    Expect(1, 1827, '\p{Jg=semkath}', "");
    Expect(0, 1827, '\p{^Jg=semkath}', "");
    Expect(0, 1827, '\P{Jg=semkath}', "");
    Expect(1, 1827, '\P{^Jg=semkath}', "");
    Expect(0, 1828, '\p{Jg=semkath}', "");
    Expect(1, 1828, '\p{^Jg=semkath}', "");
    Expect(1, 1828, '\P{Jg=semkath}', "");
    Expect(0, 1828, '\P{^Jg=semkath}', "");
    Expect(1, 1827, '\p{Jg= -semkath}', "");
    Expect(0, 1827, '\p{^Jg= -semkath}', "");
    Expect(0, 1827, '\P{Jg= -semkath}', "");
    Expect(1, 1827, '\P{^Jg= -semkath}', "");
    Expect(0, 1828, '\p{Jg= -semkath}', "");
    Expect(1, 1828, '\p{^Jg= -semkath}', "");
    Expect(1, 1828, '\P{Jg= -semkath}', "");
    Expect(0, 1828, '\P{^Jg= -semkath}', "");
    Error('\p{Is_Joining_Group=- Semkath:=}');
    Error('\P{Is_Joining_Group=- Semkath:=}');
    Expect(1, 1827, '\p{Is_Joining_Group=semkath}', "");
    Expect(0, 1827, '\p{^Is_Joining_Group=semkath}', "");
    Expect(0, 1827, '\P{Is_Joining_Group=semkath}', "");
    Expect(1, 1827, '\P{^Is_Joining_Group=semkath}', "");
    Expect(0, 1828, '\p{Is_Joining_Group=semkath}', "");
    Expect(1, 1828, '\p{^Is_Joining_Group=semkath}', "");
    Expect(1, 1828, '\P{Is_Joining_Group=semkath}', "");
    Expect(0, 1828, '\P{^Is_Joining_Group=semkath}', "");
    Expect(1, 1827, '\p{Is_Joining_Group=_	Semkath}', "");
    Expect(0, 1827, '\p{^Is_Joining_Group=_	Semkath}', "");
    Expect(0, 1827, '\P{Is_Joining_Group=_	Semkath}', "");
    Expect(1, 1827, '\P{^Is_Joining_Group=_	Semkath}', "");
    Expect(0, 1828, '\p{Is_Joining_Group=_	Semkath}', "");
    Expect(1, 1828, '\p{^Is_Joining_Group=_	Semkath}', "");
    Expect(1, 1828, '\P{Is_Joining_Group=_	Semkath}', "");
    Expect(0, 1828, '\P{^Is_Joining_Group=_	Semkath}', "");
    Error('\p{Is_Jg:   /a/Semkath}');
    Error('\P{Is_Jg:   /a/Semkath}');
    Expect(1, 1827, '\p{Is_Jg:semkath}', "");
    Expect(0, 1827, '\p{^Is_Jg:semkath}', "");
    Expect(0, 1827, '\P{Is_Jg:semkath}', "");
    Expect(1, 1827, '\P{^Is_Jg:semkath}', "");
    Expect(0, 1828, '\p{Is_Jg:semkath}', "");
    Expect(1, 1828, '\p{^Is_Jg:semkath}', "");
    Expect(1, 1828, '\P{Is_Jg:semkath}', "");
    Expect(0, 1828, '\P{^Is_Jg:semkath}', "");
    Expect(1, 1827, '\p{Is_Jg= -SEMKATH}', "");
    Expect(0, 1827, '\p{^Is_Jg= -SEMKATH}', "");
    Expect(0, 1827, '\P{Is_Jg= -SEMKATH}', "");
    Expect(1, 1827, '\P{^Is_Jg= -SEMKATH}', "");
    Expect(0, 1828, '\p{Is_Jg= -SEMKATH}', "");
    Expect(1, 1828, '\p{^Is_Jg= -SEMKATH}', "");
    Expect(1, 1828, '\P{Is_Jg= -SEMKATH}', "");
    Expect(0, 1828, '\P{^Is_Jg= -SEMKATH}', "");
    Error('\p{Joining_Group= Shin:=}');
    Error('\P{Joining_Group= Shin:=}');
    Expect(1, 1835, '\p{Joining_Group=shin}', "");
    Expect(0, 1835, '\p{^Joining_Group=shin}', "");
    Expect(0, 1835, '\P{Joining_Group=shin}', "");
    Expect(1, 1835, '\P{^Joining_Group=shin}', "");
    Expect(0, 1836, '\p{Joining_Group=shin}', "");
    Expect(1, 1836, '\p{^Joining_Group=shin}', "");
    Expect(1, 1836, '\P{Joining_Group=shin}', "");
    Expect(0, 1836, '\P{^Joining_Group=shin}', "");
    Expect(1, 1835, '\p{Joining_Group=	Shin}', "");
    Expect(0, 1835, '\p{^Joining_Group=	Shin}', "");
    Expect(0, 1835, '\P{Joining_Group=	Shin}', "");
    Expect(1, 1835, '\P{^Joining_Group=	Shin}', "");
    Expect(0, 1836, '\p{Joining_Group=	Shin}', "");
    Expect(1, 1836, '\p{^Joining_Group=	Shin}', "");
    Expect(1, 1836, '\P{Joining_Group=	Shin}', "");
    Expect(0, 1836, '\P{^Joining_Group=	Shin}', "");
    Error('\p{Jg=	:=SHIN}');
    Error('\P{Jg=	:=SHIN}');
    Expect(1, 1835, '\p{Jg=shin}', "");
    Expect(0, 1835, '\p{^Jg=shin}', "");
    Expect(0, 1835, '\P{Jg=shin}', "");
    Expect(1, 1835, '\P{^Jg=shin}', "");
    Expect(0, 1836, '\p{Jg=shin}', "");
    Expect(1, 1836, '\p{^Jg=shin}', "");
    Expect(1, 1836, '\P{Jg=shin}', "");
    Expect(0, 1836, '\P{^Jg=shin}', "");
    Expect(1, 1835, '\p{Jg:  shin}', "");
    Expect(0, 1835, '\p{^Jg:  shin}', "");
    Expect(0, 1835, '\P{Jg:  shin}', "");
    Expect(1, 1835, '\P{^Jg:  shin}', "");
    Expect(0, 1836, '\p{Jg:  shin}', "");
    Expect(1, 1836, '\p{^Jg:  shin}', "");
    Expect(1, 1836, '\P{Jg:  shin}', "");
    Expect(0, 1836, '\P{^Jg:  shin}', "");
    Error('\p{Is_Joining_Group=		SHIN:=}');
    Error('\P{Is_Joining_Group=		SHIN:=}');
    Expect(1, 1835, '\p{Is_Joining_Group=shin}', "");
    Expect(0, 1835, '\p{^Is_Joining_Group=shin}', "");
    Expect(0, 1835, '\P{Is_Joining_Group=shin}', "");
    Expect(1, 1835, '\P{^Is_Joining_Group=shin}', "");
    Expect(0, 1836, '\p{Is_Joining_Group=shin}', "");
    Expect(1, 1836, '\p{^Is_Joining_Group=shin}', "");
    Expect(1, 1836, '\P{Is_Joining_Group=shin}', "");
    Expect(0, 1836, '\P{^Is_Joining_Group=shin}', "");
    Expect(1, 1835, '\p{Is_Joining_Group=-Shin}', "");
    Expect(0, 1835, '\p{^Is_Joining_Group=-Shin}', "");
    Expect(0, 1835, '\P{Is_Joining_Group=-Shin}', "");
    Expect(1, 1835, '\P{^Is_Joining_Group=-Shin}', "");
    Expect(0, 1836, '\p{Is_Joining_Group=-Shin}', "");
    Expect(1, 1836, '\p{^Is_Joining_Group=-Shin}', "");
    Expect(1, 1836, '\P{Is_Joining_Group=-Shin}', "");
    Expect(0, 1836, '\P{^Is_Joining_Group=-Shin}', "");
    Error('\p{Is_Jg= /a/shin}');
    Error('\P{Is_Jg= /a/shin}');
    Expect(1, 1835, '\p{Is_Jg=shin}', "");
    Expect(0, 1835, '\p{^Is_Jg=shin}', "");
    Expect(0, 1835, '\P{Is_Jg=shin}', "");
    Expect(1, 1835, '\P{^Is_Jg=shin}', "");
    Expect(0, 1836, '\p{Is_Jg=shin}', "");
    Expect(1, 1836, '\p{^Is_Jg=shin}', "");
    Expect(1, 1836, '\P{Is_Jg=shin}', "");
    Expect(0, 1836, '\P{^Is_Jg=shin}', "");
    Expect(1, 1835, '\p{Is_Jg=	_shin}', "");
    Expect(0, 1835, '\p{^Is_Jg=	_shin}', "");
    Expect(0, 1835, '\P{Is_Jg=	_shin}', "");
    Expect(1, 1835, '\P{^Is_Jg=	_shin}', "");
    Expect(0, 1836, '\p{Is_Jg=	_shin}', "");
    Expect(1, 1836, '\p{^Is_Jg=	_shin}', "");
    Expect(1, 1836, '\P{Is_Jg=	_shin}', "");
    Expect(0, 1836, '\P{^Is_Jg=	_shin}', "");
    Error('\p{Joining_Group=/a/ STRAIGHT_WAW}');
    Error('\P{Joining_Group=/a/ STRAIGHT_WAW}');
    Expect(1, 2225, '\p{Joining_Group=straightwaw}', "");
    Expect(0, 2225, '\p{^Joining_Group=straightwaw}', "");
    Expect(0, 2225, '\P{Joining_Group=straightwaw}', "");
    Expect(1, 2225, '\P{^Joining_Group=straightwaw}', "");
    Expect(0, 2226, '\p{Joining_Group=straightwaw}', "");
    Expect(1, 2226, '\p{^Joining_Group=straightwaw}', "");
    Expect(1, 2226, '\P{Joining_Group=straightwaw}', "");
    Expect(0, 2226, '\P{^Joining_Group=straightwaw}', "");
    Expect(1, 2225, '\p{Joining_Group=_Straight_WAW}', "");
    Expect(0, 2225, '\p{^Joining_Group=_Straight_WAW}', "");
    Expect(0, 2225, '\P{Joining_Group=_Straight_WAW}', "");
    Expect(1, 2225, '\P{^Joining_Group=_Straight_WAW}', "");
    Expect(0, 2226, '\p{Joining_Group=_Straight_WAW}', "");
    Expect(1, 2226, '\p{^Joining_Group=_Straight_WAW}', "");
    Expect(1, 2226, '\P{Joining_Group=_Straight_WAW}', "");
    Expect(0, 2226, '\P{^Joining_Group=_Straight_WAW}', "");
    Error('\p{Jg=/a/_STRAIGHT_WAW}');
    Error('\P{Jg=/a/_STRAIGHT_WAW}');
    Expect(1, 2225, '\p{Jg=straightwaw}', "");
    Expect(0, 2225, '\p{^Jg=straightwaw}', "");
    Expect(0, 2225, '\P{Jg=straightwaw}', "");
    Expect(1, 2225, '\P{^Jg=straightwaw}', "");
    Expect(0, 2226, '\p{Jg=straightwaw}', "");
    Expect(1, 2226, '\p{^Jg=straightwaw}', "");
    Expect(1, 2226, '\P{Jg=straightwaw}', "");
    Expect(0, 2226, '\P{^Jg=straightwaw}', "");
    Expect(1, 2225, '\p{Jg=-Straight_Waw}', "");
    Expect(0, 2225, '\p{^Jg=-Straight_Waw}', "");
    Expect(0, 2225, '\P{Jg=-Straight_Waw}', "");
    Expect(1, 2225, '\P{^Jg=-Straight_Waw}', "");
    Expect(0, 2226, '\p{Jg=-Straight_Waw}', "");
    Expect(1, 2226, '\p{^Jg=-Straight_Waw}', "");
    Expect(1, 2226, '\P{Jg=-Straight_Waw}', "");
    Expect(0, 2226, '\P{^Jg=-Straight_Waw}', "");
    Error('\p{Is_Joining_Group=:=_-Straight_Waw}');
    Error('\P{Is_Joining_Group=:=_-Straight_Waw}');
    Expect(1, 2225, '\p{Is_Joining_Group=straightwaw}', "");
    Expect(0, 2225, '\p{^Is_Joining_Group=straightwaw}', "");
    Expect(0, 2225, '\P{Is_Joining_Group=straightwaw}', "");
    Expect(1, 2225, '\P{^Is_Joining_Group=straightwaw}', "");
    Expect(0, 2226, '\p{Is_Joining_Group=straightwaw}', "");
    Expect(1, 2226, '\p{^Is_Joining_Group=straightwaw}', "");
    Expect(1, 2226, '\P{Is_Joining_Group=straightwaw}', "");
    Expect(0, 2226, '\P{^Is_Joining_Group=straightwaw}', "");
    Expect(1, 2225, '\p{Is_Joining_Group=  Straight_Waw}', "");
    Expect(0, 2225, '\p{^Is_Joining_Group=  Straight_Waw}', "");
    Expect(0, 2225, '\P{Is_Joining_Group=  Straight_Waw}', "");
    Expect(1, 2225, '\P{^Is_Joining_Group=  Straight_Waw}', "");
    Expect(0, 2226, '\p{Is_Joining_Group=  Straight_Waw}', "");
    Expect(1, 2226, '\p{^Is_Joining_Group=  Straight_Waw}', "");
    Expect(1, 2226, '\P{Is_Joining_Group=  Straight_Waw}', "");
    Expect(0, 2226, '\P{^Is_Joining_Group=  Straight_Waw}', "");
    Error('\p{Is_Jg=/a/	 Straight_Waw}');
    Error('\P{Is_Jg=/a/	 Straight_Waw}');
    Expect(1, 2225, '\p{Is_Jg=straightwaw}', "");
    Expect(0, 2225, '\p{^Is_Jg=straightwaw}', "");
    Expect(0, 2225, '\P{Is_Jg=straightwaw}', "");
    Expect(1, 2225, '\P{^Is_Jg=straightwaw}', "");
    Expect(0, 2226, '\p{Is_Jg=straightwaw}', "");
    Expect(1, 2226, '\p{^Is_Jg=straightwaw}', "");
    Expect(1, 2226, '\P{Is_Jg=straightwaw}', "");
    Expect(0, 2226, '\P{^Is_Jg=straightwaw}', "");
    Expect(1, 2225, '\p{Is_Jg=	-Straight_WAW}', "");
    Expect(0, 2225, '\p{^Is_Jg=	-Straight_WAW}', "");
    Expect(0, 2225, '\P{Is_Jg=	-Straight_WAW}', "");
    Expect(1, 2225, '\P{^Is_Jg=	-Straight_WAW}', "");
    Expect(0, 2226, '\p{Is_Jg=	-Straight_WAW}', "");
    Expect(1, 2226, '\p{^Is_Jg=	-Straight_WAW}', "");
    Expect(1, 2226, '\P{Is_Jg=	-Straight_WAW}', "");
    Expect(0, 2226, '\P{^Is_Jg=	-Straight_WAW}', "");
    Error('\p{Joining_Group=/a/SWASH_Kaf}');
    Error('\P{Joining_Group=/a/SWASH_Kaf}');
    Expect(1, 1706, '\p{Joining_Group=swashkaf}', "");
    Expect(0, 1706, '\p{^Joining_Group=swashkaf}', "");
    Expect(0, 1706, '\P{Joining_Group=swashkaf}', "");
    Expect(1, 1706, '\P{^Joining_Group=swashkaf}', "");
    Expect(0, 1707, '\p{Joining_Group=swashkaf}', "");
    Expect(1, 1707, '\p{^Joining_Group=swashkaf}', "");
    Expect(1, 1707, '\P{Joining_Group=swashkaf}', "");
    Expect(0, 1707, '\P{^Joining_Group=swashkaf}', "");
    Expect(1, 1706, '\p{Joining_Group=_	SWASH_KAF}', "");
    Expect(0, 1706, '\p{^Joining_Group=_	SWASH_KAF}', "");
    Expect(0, 1706, '\P{Joining_Group=_	SWASH_KAF}', "");
    Expect(1, 1706, '\P{^Joining_Group=_	SWASH_KAF}', "");
    Expect(0, 1707, '\p{Joining_Group=_	SWASH_KAF}', "");
    Expect(1, 1707, '\p{^Joining_Group=_	SWASH_KAF}', "");
    Expect(1, 1707, '\P{Joining_Group=_	SWASH_KAF}', "");
    Expect(0, 1707, '\P{^Joining_Group=_	SWASH_KAF}', "");
    Error('\p{Jg= /a/SWASH_Kaf}');
    Error('\P{Jg= /a/SWASH_Kaf}');
    Expect(1, 1706, '\p{Jg=swashkaf}', "");
    Expect(0, 1706, '\p{^Jg=swashkaf}', "");
    Expect(0, 1706, '\P{Jg=swashkaf}', "");
    Expect(1, 1706, '\P{^Jg=swashkaf}', "");
    Expect(0, 1707, '\p{Jg=swashkaf}', "");
    Expect(1, 1707, '\p{^Jg=swashkaf}', "");
    Expect(1, 1707, '\P{Jg=swashkaf}', "");
    Expect(0, 1707, '\P{^Jg=swashkaf}', "");
    Expect(1, 1706, '\p{Jg= Swash_KAF}', "");
    Expect(0, 1706, '\p{^Jg= Swash_KAF}', "");
    Expect(0, 1706, '\P{Jg= Swash_KAF}', "");
    Expect(1, 1706, '\P{^Jg= Swash_KAF}', "");
    Expect(0, 1707, '\p{Jg= Swash_KAF}', "");
    Expect(1, 1707, '\p{^Jg= Swash_KAF}', "");
    Expect(1, 1707, '\P{Jg= Swash_KAF}', "");
    Expect(0, 1707, '\P{^Jg= Swash_KAF}', "");
    Error('\p{Is_Joining_Group=_ Swash_Kaf:=}');
    Error('\P{Is_Joining_Group=_ Swash_Kaf:=}');
    Expect(1, 1706, '\p{Is_Joining_Group=swashkaf}', "");
    Expect(0, 1706, '\p{^Is_Joining_Group=swashkaf}', "");
    Expect(0, 1706, '\P{Is_Joining_Group=swashkaf}', "");
    Expect(1, 1706, '\P{^Is_Joining_Group=swashkaf}', "");
    Expect(0, 1707, '\p{Is_Joining_Group=swashkaf}', "");
    Expect(1, 1707, '\p{^Is_Joining_Group=swashkaf}', "");
    Expect(1, 1707, '\P{Is_Joining_Group=swashkaf}', "");
    Expect(0, 1707, '\P{^Is_Joining_Group=swashkaf}', "");
    Expect(1, 1706, '\p{Is_Joining_Group=	_SWASH_kaf}', "");
    Expect(0, 1706, '\p{^Is_Joining_Group=	_SWASH_kaf}', "");
    Expect(0, 1706, '\P{Is_Joining_Group=	_SWASH_kaf}', "");
    Expect(1, 1706, '\P{^Is_Joining_Group=	_SWASH_kaf}', "");
    Expect(0, 1707, '\p{Is_Joining_Group=	_SWASH_kaf}', "");
    Expect(1, 1707, '\p{^Is_Joining_Group=	_SWASH_kaf}', "");
    Expect(1, 1707, '\P{Is_Joining_Group=	_SWASH_kaf}', "");
    Expect(0, 1707, '\P{^Is_Joining_Group=	_SWASH_kaf}', "");
    Error('\p{Is_Jg=:=_Swash_kaf}');
    Error('\P{Is_Jg=:=_Swash_kaf}');
    Expect(1, 1706, '\p{Is_Jg: swashkaf}', "");
    Expect(0, 1706, '\p{^Is_Jg: swashkaf}', "");
    Expect(0, 1706, '\P{Is_Jg: swashkaf}', "");
    Expect(1, 1706, '\P{^Is_Jg: swashkaf}', "");
    Expect(0, 1707, '\p{Is_Jg: swashkaf}', "");
    Expect(1, 1707, '\p{^Is_Jg: swashkaf}', "");
    Expect(1, 1707, '\P{Is_Jg: swashkaf}', "");
    Expect(0, 1707, '\P{^Is_Jg: swashkaf}', "");
    Expect(1, 1706, '\p{Is_Jg=	Swash_kaf}', "");
    Expect(0, 1706, '\p{^Is_Jg=	Swash_kaf}', "");
    Expect(0, 1706, '\P{Is_Jg=	Swash_kaf}', "");
    Expect(1, 1706, '\P{^Is_Jg=	Swash_kaf}', "");
    Expect(0, 1707, '\p{Is_Jg=	Swash_kaf}', "");
    Expect(1, 1707, '\p{^Is_Jg=	Swash_kaf}', "");
    Expect(1, 1707, '\P{Is_Jg=	Swash_kaf}', "");
    Expect(0, 1707, '\P{^Is_Jg=	Swash_kaf}', "");
    Error('\p{Joining_Group= /a/syriac_WAW}');
    Error('\P{Joining_Group= /a/syriac_WAW}');
    Expect(1, 1816, '\p{Joining_Group=syriacwaw}', "");
    Expect(0, 1816, '\p{^Joining_Group=syriacwaw}', "");
    Expect(0, 1816, '\P{Joining_Group=syriacwaw}', "");
    Expect(1, 1816, '\P{^Joining_Group=syriacwaw}', "");
    Expect(0, 1817, '\p{Joining_Group=syriacwaw}', "");
    Expect(1, 1817, '\p{^Joining_Group=syriacwaw}', "");
    Expect(1, 1817, '\P{Joining_Group=syriacwaw}', "");
    Expect(0, 1817, '\P{^Joining_Group=syriacwaw}', "");
    Expect(1, 1816, '\p{Joining_Group:	 SYRIAC_waw}', "");
    Expect(0, 1816, '\p{^Joining_Group:	 SYRIAC_waw}', "");
    Expect(0, 1816, '\P{Joining_Group:	 SYRIAC_waw}', "");
    Expect(1, 1816, '\P{^Joining_Group:	 SYRIAC_waw}', "");
    Expect(0, 1817, '\p{Joining_Group:	 SYRIAC_waw}', "");
    Expect(1, 1817, '\p{^Joining_Group:	 SYRIAC_waw}', "");
    Expect(1, 1817, '\P{Joining_Group:	 SYRIAC_waw}', "");
    Expect(0, 1817, '\P{^Joining_Group:	 SYRIAC_waw}', "");
    Error('\p{Jg=-Syriac_waw:=}');
    Error('\P{Jg=-Syriac_waw:=}');
    Expect(1, 1816, '\p{Jg=syriacwaw}', "");
    Expect(0, 1816, '\p{^Jg=syriacwaw}', "");
    Expect(0, 1816, '\P{Jg=syriacwaw}', "");
    Expect(1, 1816, '\P{^Jg=syriacwaw}', "");
    Expect(0, 1817, '\p{Jg=syriacwaw}', "");
    Expect(1, 1817, '\p{^Jg=syriacwaw}', "");
    Expect(1, 1817, '\P{Jg=syriacwaw}', "");
    Expect(0, 1817, '\P{^Jg=syriacwaw}', "");
    Expect(1, 1816, '\p{Jg=	 Syriac_WAW}', "");
    Expect(0, 1816, '\p{^Jg=	 Syriac_WAW}', "");
    Expect(0, 1816, '\P{Jg=	 Syriac_WAW}', "");
    Expect(1, 1816, '\P{^Jg=	 Syriac_WAW}', "");
    Expect(0, 1817, '\p{Jg=	 Syriac_WAW}', "");
    Expect(1, 1817, '\p{^Jg=	 Syriac_WAW}', "");
    Expect(1, 1817, '\P{Jg=	 Syriac_WAW}', "");
    Expect(0, 1817, '\P{^Jg=	 Syriac_WAW}', "");
    Error('\p{Is_Joining_Group=	syriac_Waw:=}');
    Error('\P{Is_Joining_Group=	syriac_Waw:=}');
    Expect(1, 1816, '\p{Is_Joining_Group=syriacwaw}', "");
    Expect(0, 1816, '\p{^Is_Joining_Group=syriacwaw}', "");
    Expect(0, 1816, '\P{Is_Joining_Group=syriacwaw}', "");
    Expect(1, 1816, '\P{^Is_Joining_Group=syriacwaw}', "");
    Expect(0, 1817, '\p{Is_Joining_Group=syriacwaw}', "");
    Expect(1, 1817, '\p{^Is_Joining_Group=syriacwaw}', "");
    Expect(1, 1817, '\P{Is_Joining_Group=syriacwaw}', "");
    Expect(0, 1817, '\P{^Is_Joining_Group=syriacwaw}', "");
    Expect(1, 1816, '\p{Is_Joining_Group=	 Syriac_Waw}', "");
    Expect(0, 1816, '\p{^Is_Joining_Group=	 Syriac_Waw}', "");
    Expect(0, 1816, '\P{Is_Joining_Group=	 Syriac_Waw}', "");
    Expect(1, 1816, '\P{^Is_Joining_Group=	 Syriac_Waw}', "");
    Expect(0, 1817, '\p{Is_Joining_Group=	 Syriac_Waw}', "");
    Expect(1, 1817, '\p{^Is_Joining_Group=	 Syriac_Waw}', "");
    Expect(1, 1817, '\P{Is_Joining_Group=	 Syriac_Waw}', "");
    Expect(0, 1817, '\P{^Is_Joining_Group=	 Syriac_Waw}', "");
    Error('\p{Is_Jg=	_SYRIAC_WAW:=}');
    Error('\P{Is_Jg=	_SYRIAC_WAW:=}');
    Expect(1, 1816, '\p{Is_Jg=syriacwaw}', "");
    Expect(0, 1816, '\p{^Is_Jg=syriacwaw}', "");
    Expect(0, 1816, '\P{Is_Jg=syriacwaw}', "");
    Expect(1, 1816, '\P{^Is_Jg=syriacwaw}', "");
    Expect(0, 1817, '\p{Is_Jg=syriacwaw}', "");
    Expect(1, 1817, '\p{^Is_Jg=syriacwaw}', "");
    Expect(1, 1817, '\P{Is_Jg=syriacwaw}', "");
    Expect(0, 1817, '\P{^Is_Jg=syriacwaw}', "");
    Expect(1, 1816, '\p{Is_Jg=_	Syriac_WAW}', "");
    Expect(0, 1816, '\p{^Is_Jg=_	Syriac_WAW}', "");
    Expect(0, 1816, '\P{Is_Jg=_	Syriac_WAW}', "");
    Expect(1, 1816, '\P{^Is_Jg=_	Syriac_WAW}', "");
    Expect(0, 1817, '\p{Is_Jg=_	Syriac_WAW}', "");
    Expect(1, 1817, '\p{^Is_Jg=_	Syriac_WAW}', "");
    Expect(1, 1817, '\P{Is_Jg=_	Syriac_WAW}', "");
    Expect(0, 1817, '\P{^Is_Jg=_	Syriac_WAW}', "");
    Error('\p{Joining_Group= 	TAH/a/}');
    Error('\P{Joining_Group= 	TAH/a/}');
    Expect(1, 2211, '\p{Joining_Group=tah}', "");
    Expect(0, 2211, '\p{^Joining_Group=tah}', "");
    Expect(0, 2211, '\P{Joining_Group=tah}', "");
    Expect(1, 2211, '\P{^Joining_Group=tah}', "");
    Expect(0, 2212, '\p{Joining_Group=tah}', "");
    Expect(1, 2212, '\p{^Joining_Group=tah}', "");
    Expect(1, 2212, '\P{Joining_Group=tah}', "");
    Expect(0, 2212, '\P{^Joining_Group=tah}', "");
    Expect(1, 2211, '\p{Joining_Group=  Tah}', "");
    Expect(0, 2211, '\p{^Joining_Group=  Tah}', "");
    Expect(0, 2211, '\P{Joining_Group=  Tah}', "");
    Expect(1, 2211, '\P{^Joining_Group=  Tah}', "");
    Expect(0, 2212, '\p{Joining_Group=  Tah}', "");
    Expect(1, 2212, '\p{^Joining_Group=  Tah}', "");
    Expect(1, 2212, '\P{Joining_Group=  Tah}', "");
    Expect(0, 2212, '\P{^Joining_Group=  Tah}', "");
    Error('\p{Jg=:=_	tah}');
    Error('\P{Jg=:=_	tah}');
    Expect(1, 2211, '\p{Jg=tah}', "");
    Expect(0, 2211, '\p{^Jg=tah}', "");
    Expect(0, 2211, '\P{Jg=tah}', "");
    Expect(1, 2211, '\P{^Jg=tah}', "");
    Expect(0, 2212, '\p{Jg=tah}', "");
    Expect(1, 2212, '\p{^Jg=tah}', "");
    Expect(1, 2212, '\P{Jg=tah}', "");
    Expect(0, 2212, '\P{^Jg=tah}', "");
    Expect(1, 2211, '\p{Jg=  tah}', "");
    Expect(0, 2211, '\p{^Jg=  tah}', "");
    Expect(0, 2211, '\P{Jg=  tah}', "");
    Expect(1, 2211, '\P{^Jg=  tah}', "");
    Expect(0, 2212, '\p{Jg=  tah}', "");
    Expect(1, 2212, '\p{^Jg=  tah}', "");
    Expect(1, 2212, '\P{Jg=  tah}', "");
    Expect(0, 2212, '\P{^Jg=  tah}', "");
    Error('\p{Is_Joining_Group=	_tah/a/}');
    Error('\P{Is_Joining_Group=	_tah/a/}');
    Expect(1, 2211, '\p{Is_Joining_Group=tah}', "");
    Expect(0, 2211, '\p{^Is_Joining_Group=tah}', "");
    Expect(0, 2211, '\P{Is_Joining_Group=tah}', "");
    Expect(1, 2211, '\P{^Is_Joining_Group=tah}', "");
    Expect(0, 2212, '\p{Is_Joining_Group=tah}', "");
    Expect(1, 2212, '\p{^Is_Joining_Group=tah}', "");
    Expect(1, 2212, '\P{Is_Joining_Group=tah}', "");
    Expect(0, 2212, '\P{^Is_Joining_Group=tah}', "");
    Expect(1, 2211, '\p{Is_Joining_Group: -_TAH}', "");
    Expect(0, 2211, '\p{^Is_Joining_Group: -_TAH}', "");
    Expect(0, 2211, '\P{Is_Joining_Group: -_TAH}', "");
    Expect(1, 2211, '\P{^Is_Joining_Group: -_TAH}', "");
    Expect(0, 2212, '\p{Is_Joining_Group: -_TAH}', "");
    Expect(1, 2212, '\p{^Is_Joining_Group: -_TAH}', "");
    Expect(1, 2212, '\P{Is_Joining_Group: -_TAH}', "");
    Expect(0, 2212, '\P{^Is_Joining_Group: -_TAH}', "");
    Error('\p{Is_Jg= /a/TAH}');
    Error('\P{Is_Jg= /a/TAH}');
    Expect(1, 2211, '\p{Is_Jg=tah}', "");
    Expect(0, 2211, '\p{^Is_Jg=tah}', "");
    Expect(0, 2211, '\P{Is_Jg=tah}', "");
    Expect(1, 2211, '\P{^Is_Jg=tah}', "");
    Expect(0, 2212, '\p{Is_Jg=tah}', "");
    Expect(1, 2212, '\p{^Is_Jg=tah}', "");
    Expect(1, 2212, '\P{Is_Jg=tah}', "");
    Expect(0, 2212, '\P{^Is_Jg=tah}', "");
    Expect(1, 2211, '\p{Is_Jg= Tah}', "");
    Expect(0, 2211, '\p{^Is_Jg= Tah}', "");
    Expect(0, 2211, '\P{Is_Jg= Tah}', "");
    Expect(1, 2211, '\P{^Is_Jg= Tah}', "");
    Expect(0, 2212, '\p{Is_Jg= Tah}', "");
    Expect(1, 2212, '\p{^Is_Jg= Tah}', "");
    Expect(1, 2212, '\P{Is_Jg= Tah}', "");
    Expect(0, 2212, '\P{^Is_Jg= Tah}', "");
    Error('\p{Joining_Group=/a/	_taw}');
    Error('\P{Joining_Group=/a/	_taw}');
    Expect(1, 1836, '\p{Joining_Group=taw}', "");
    Expect(0, 1836, '\p{^Joining_Group=taw}', "");
    Expect(0, 1836, '\P{Joining_Group=taw}', "");
    Expect(1, 1836, '\P{^Joining_Group=taw}', "");
    Expect(0, 1837, '\p{Joining_Group=taw}', "");
    Expect(1, 1837, '\p{^Joining_Group=taw}', "");
    Expect(1, 1837, '\P{Joining_Group=taw}', "");
    Expect(0, 1837, '\P{^Joining_Group=taw}', "");
    Expect(1, 1836, '\p{Joining_Group= 	TAW}', "");
    Expect(0, 1836, '\p{^Joining_Group= 	TAW}', "");
    Expect(0, 1836, '\P{Joining_Group= 	TAW}', "");
    Expect(1, 1836, '\P{^Joining_Group= 	TAW}', "");
    Expect(0, 1837, '\p{Joining_Group= 	TAW}', "");
    Expect(1, 1837, '\p{^Joining_Group= 	TAW}', "");
    Expect(1, 1837, '\P{Joining_Group= 	TAW}', "");
    Expect(0, 1837, '\P{^Joining_Group= 	TAW}', "");
    Error('\p{Jg=_/a/Taw}');
    Error('\P{Jg=_/a/Taw}');
    Expect(1, 1836, '\p{Jg=taw}', "");
    Expect(0, 1836, '\p{^Jg=taw}', "");
    Expect(0, 1836, '\P{Jg=taw}', "");
    Expect(1, 1836, '\P{^Jg=taw}', "");
    Expect(0, 1837, '\p{Jg=taw}', "");
    Expect(1, 1837, '\p{^Jg=taw}', "");
    Expect(1, 1837, '\P{Jg=taw}', "");
    Expect(0, 1837, '\P{^Jg=taw}', "");
    Expect(1, 1836, '\p{Jg=__Taw}', "");
    Expect(0, 1836, '\p{^Jg=__Taw}', "");
    Expect(0, 1836, '\P{Jg=__Taw}', "");
    Expect(1, 1836, '\P{^Jg=__Taw}', "");
    Expect(0, 1837, '\p{Jg=__Taw}', "");
    Expect(1, 1837, '\p{^Jg=__Taw}', "");
    Expect(1, 1837, '\P{Jg=__Taw}', "");
    Expect(0, 1837, '\P{^Jg=__Taw}', "");
    Error('\p{Is_Joining_Group=  taw/a/}');
    Error('\P{Is_Joining_Group=  taw/a/}');
    Expect(1, 1836, '\p{Is_Joining_Group:	taw}', "");
    Expect(0, 1836, '\p{^Is_Joining_Group:	taw}', "");
    Expect(0, 1836, '\P{Is_Joining_Group:	taw}', "");
    Expect(1, 1836, '\P{^Is_Joining_Group:	taw}', "");
    Expect(0, 1837, '\p{Is_Joining_Group:	taw}', "");
    Expect(1, 1837, '\p{^Is_Joining_Group:	taw}', "");
    Expect(1, 1837, '\P{Is_Joining_Group:	taw}', "");
    Expect(0, 1837, '\P{^Is_Joining_Group:	taw}', "");
    Expect(1, 1836, '\p{Is_Joining_Group= -Taw}', "");
    Expect(0, 1836, '\p{^Is_Joining_Group= -Taw}', "");
    Expect(0, 1836, '\P{Is_Joining_Group= -Taw}', "");
    Expect(1, 1836, '\P{^Is_Joining_Group= -Taw}', "");
    Expect(0, 1837, '\p{Is_Joining_Group= -Taw}', "");
    Expect(1, 1837, '\p{^Is_Joining_Group= -Taw}', "");
    Expect(1, 1837, '\P{Is_Joining_Group= -Taw}', "");
    Expect(0, 1837, '\P{^Is_Joining_Group= -Taw}', "");
    Error('\p{Is_Jg:    /a/TAW}');
    Error('\P{Is_Jg:    /a/TAW}');
    Expect(1, 1836, '\p{Is_Jg=taw}', "");
    Expect(0, 1836, '\p{^Is_Jg=taw}', "");
    Expect(0, 1836, '\P{Is_Jg=taw}', "");
    Expect(1, 1836, '\P{^Is_Jg=taw}', "");
    Expect(0, 1837, '\p{Is_Jg=taw}', "");
    Expect(1, 1837, '\p{^Is_Jg=taw}', "");
    Expect(1, 1837, '\P{Is_Jg=taw}', "");
    Expect(0, 1837, '\P{^Is_Jg=taw}', "");
    Expect(1, 1836, '\p{Is_Jg= _Taw}', "");
    Expect(0, 1836, '\p{^Is_Jg= _Taw}', "");
    Expect(0, 1836, '\P{Is_Jg= _Taw}', "");
    Expect(1, 1836, '\P{^Is_Jg= _Taw}', "");
    Expect(0, 1837, '\p{Is_Jg= _Taw}', "");
    Expect(1, 1837, '\p{^Is_Jg= _Taw}', "");
    Expect(1, 1837, '\P{Is_Jg= _Taw}', "");
    Expect(0, 1837, '\P{^Is_Jg= _Taw}', "");
    Error('\p{Joining_Group= 	Teh_Marbuta/a/}');
    Error('\P{Joining_Group= 	Teh_Marbuta/a/}');
    Expect(1, 1749, '\p{Joining_Group=tehmarbuta}', "");
    Expect(0, 1749, '\p{^Joining_Group=tehmarbuta}', "");
    Expect(0, 1749, '\P{Joining_Group=tehmarbuta}', "");
    Expect(1, 1749, '\P{^Joining_Group=tehmarbuta}', "");
    Expect(0, 1750, '\p{Joining_Group=tehmarbuta}', "");
    Expect(1, 1750, '\p{^Joining_Group=tehmarbuta}', "");
    Expect(1, 1750, '\P{Joining_Group=tehmarbuta}', "");
    Expect(0, 1750, '\P{^Joining_Group=tehmarbuta}', "");
    Expect(1, 1749, '\p{Joining_Group=	 Teh_MARBUTA}', "");
    Expect(0, 1749, '\p{^Joining_Group=	 Teh_MARBUTA}', "");
    Expect(0, 1749, '\P{Joining_Group=	 Teh_MARBUTA}', "");
    Expect(1, 1749, '\P{^Joining_Group=	 Teh_MARBUTA}', "");
    Expect(0, 1750, '\p{Joining_Group=	 Teh_MARBUTA}', "");
    Expect(1, 1750, '\p{^Joining_Group=	 Teh_MARBUTA}', "");
    Expect(1, 1750, '\P{Joining_Group=	 Teh_MARBUTA}', "");
    Expect(0, 1750, '\P{^Joining_Group=	 Teh_MARBUTA}', "");
    Error('\p{Jg:	Teh_marbuta/a/}');
    Error('\P{Jg:	Teh_marbuta/a/}');
    Expect(1, 1749, '\p{Jg=tehmarbuta}', "");
    Expect(0, 1749, '\p{^Jg=tehmarbuta}', "");
    Expect(0, 1749, '\P{Jg=tehmarbuta}', "");
    Expect(1, 1749, '\P{^Jg=tehmarbuta}', "");
    Expect(0, 1750, '\p{Jg=tehmarbuta}', "");
    Expect(1, 1750, '\p{^Jg=tehmarbuta}', "");
    Expect(1, 1750, '\P{Jg=tehmarbuta}', "");
    Expect(0, 1750, '\P{^Jg=tehmarbuta}', "");
    Expect(1, 1749, '\p{Jg=-teh_Marbuta}', "");
    Expect(0, 1749, '\p{^Jg=-teh_Marbuta}', "");
    Expect(0, 1749, '\P{Jg=-teh_Marbuta}', "");
    Expect(1, 1749, '\P{^Jg=-teh_Marbuta}', "");
    Expect(0, 1750, '\p{Jg=-teh_Marbuta}', "");
    Expect(1, 1750, '\p{^Jg=-teh_Marbuta}', "");
    Expect(1, 1750, '\P{Jg=-teh_Marbuta}', "");
    Expect(0, 1750, '\P{^Jg=-teh_Marbuta}', "");
    Error('\p{Is_Joining_Group= teh_Marbuta:=}');
    Error('\P{Is_Joining_Group= teh_Marbuta:=}');
    Expect(1, 1749, '\p{Is_Joining_Group=tehmarbuta}', "");
    Expect(0, 1749, '\p{^Is_Joining_Group=tehmarbuta}', "");
    Expect(0, 1749, '\P{Is_Joining_Group=tehmarbuta}', "");
    Expect(1, 1749, '\P{^Is_Joining_Group=tehmarbuta}', "");
    Expect(0, 1750, '\p{Is_Joining_Group=tehmarbuta}', "");
    Expect(1, 1750, '\p{^Is_Joining_Group=tehmarbuta}', "");
    Expect(1, 1750, '\P{Is_Joining_Group=tehmarbuta}', "");
    Expect(0, 1750, '\P{^Is_Joining_Group=tehmarbuta}', "");
    Expect(1, 1749, '\p{Is_Joining_Group:	_teh_marbuta}', "");
    Expect(0, 1749, '\p{^Is_Joining_Group:	_teh_marbuta}', "");
    Expect(0, 1749, '\P{Is_Joining_Group:	_teh_marbuta}', "");
    Expect(1, 1749, '\P{^Is_Joining_Group:	_teh_marbuta}', "");
    Expect(0, 1750, '\p{Is_Joining_Group:	_teh_marbuta}', "");
    Expect(1, 1750, '\p{^Is_Joining_Group:	_teh_marbuta}', "");
    Expect(1, 1750, '\P{Is_Joining_Group:	_teh_marbuta}', "");
    Expect(0, 1750, '\P{^Is_Joining_Group:	_teh_marbuta}', "");
    Error('\p{Is_Jg=/a/ -Teh_MARBUTA}');
    Error('\P{Is_Jg=/a/ -Teh_MARBUTA}');
    Expect(1, 1749, '\p{Is_Jg=tehmarbuta}', "");
    Expect(0, 1749, '\p{^Is_Jg=tehmarbuta}', "");
    Expect(0, 1749, '\P{Is_Jg=tehmarbuta}', "");
    Expect(1, 1749, '\P{^Is_Jg=tehmarbuta}', "");
    Expect(0, 1750, '\p{Is_Jg=tehmarbuta}', "");
    Expect(1, 1750, '\p{^Is_Jg=tehmarbuta}', "");
    Expect(1, 1750, '\P{Is_Jg=tehmarbuta}', "");
    Expect(0, 1750, '\P{^Is_Jg=tehmarbuta}', "");
    Expect(1, 1749, '\p{Is_Jg= teh_MARBUTA}', "");
    Expect(0, 1749, '\p{^Is_Jg= teh_MARBUTA}', "");
    Expect(0, 1749, '\P{Is_Jg= teh_MARBUTA}', "");
    Expect(1, 1749, '\P{^Is_Jg= teh_MARBUTA}', "");
    Expect(0, 1750, '\p{Is_Jg= teh_MARBUTA}', "");
    Expect(1, 1750, '\p{^Is_Jg= teh_MARBUTA}', "");
    Expect(1, 1750, '\P{Is_Jg= teh_MARBUTA}', "");
    Expect(0, 1750, '\P{^Is_Jg= teh_MARBUTA}', "");
    Error('\p{Joining_Group:   /a/-Hamza_on_Heh_GOAL}');
    Error('\P{Joining_Group:   /a/-Hamza_on_Heh_GOAL}');
    Expect(1, 1731, '\p{Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1731, '\p{^Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1731, '\P{Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1731, '\P{^Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1732, '\p{Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1732, '\p{^Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1732, '\P{Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1732, '\P{^Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1731, '\p{Joining_Group=	Hamza_On_Heh_goal}', "");
    Expect(0, 1731, '\p{^Joining_Group=	Hamza_On_Heh_goal}', "");
    Expect(0, 1731, '\P{Joining_Group=	Hamza_On_Heh_goal}', "");
    Expect(1, 1731, '\P{^Joining_Group=	Hamza_On_Heh_goal}', "");
    Expect(0, 1732, '\p{Joining_Group=	Hamza_On_Heh_goal}', "");
    Expect(1, 1732, '\p{^Joining_Group=	Hamza_On_Heh_goal}', "");
    Expect(1, 1732, '\P{Joining_Group=	Hamza_On_Heh_goal}', "");
    Expect(0, 1732, '\P{^Joining_Group=	Hamza_On_Heh_goal}', "");
    Error('\p{Jg:/a/Teh_marbuta_Goal}');
    Error('\P{Jg:/a/Teh_marbuta_Goal}');
    Expect(1, 1731, '\p{Jg=tehmarbutagoal}', "");
    Expect(0, 1731, '\p{^Jg=tehmarbutagoal}', "");
    Expect(0, 1731, '\P{Jg=tehmarbutagoal}', "");
    Expect(1, 1731, '\P{^Jg=tehmarbutagoal}', "");
    Expect(0, 1732, '\p{Jg=tehmarbutagoal}', "");
    Expect(1, 1732, '\p{^Jg=tehmarbutagoal}', "");
    Expect(1, 1732, '\P{Jg=tehmarbutagoal}', "");
    Expect(0, 1732, '\P{^Jg=tehmarbutagoal}', "");
    Expect(1, 1731, '\p{Jg=	-Teh_MARBUTA_Goal}', "");
    Expect(0, 1731, '\p{^Jg=	-Teh_MARBUTA_Goal}', "");
    Expect(0, 1731, '\P{Jg=	-Teh_MARBUTA_Goal}', "");
    Expect(1, 1731, '\P{^Jg=	-Teh_MARBUTA_Goal}', "");
    Expect(0, 1732, '\p{Jg=	-Teh_MARBUTA_Goal}', "");
    Expect(1, 1732, '\p{^Jg=	-Teh_MARBUTA_Goal}', "");
    Expect(1, 1732, '\P{Jg=	-Teh_MARBUTA_Goal}', "");
    Expect(0, 1732, '\P{^Jg=	-Teh_MARBUTA_Goal}', "");
    Error('\p{Is_Joining_Group=-hamza_On_Heh_Goal/a/}');
    Error('\P{Is_Joining_Group=-hamza_On_Heh_Goal/a/}');
    Expect(1, 1731, '\p{Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1731, '\p{^Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1731, '\P{Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1731, '\P{^Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1732, '\p{Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1732, '\p{^Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1732, '\P{Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1732, '\P{^Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1731, '\p{Is_Joining_Group= Hamza_On_Heh_Goal}', "");
    Expect(0, 1731, '\p{^Is_Joining_Group= Hamza_On_Heh_Goal}', "");
    Expect(0, 1731, '\P{Is_Joining_Group= Hamza_On_Heh_Goal}', "");
    Expect(1, 1731, '\P{^Is_Joining_Group= Hamza_On_Heh_Goal}', "");
    Expect(0, 1732, '\p{Is_Joining_Group= Hamza_On_Heh_Goal}', "");
    Expect(1, 1732, '\p{^Is_Joining_Group= Hamza_On_Heh_Goal}', "");
    Expect(1, 1732, '\P{Is_Joining_Group= Hamza_On_Heh_Goal}', "");
    Expect(0, 1732, '\P{^Is_Joining_Group= Hamza_On_Heh_Goal}', "");
    Error('\p{Is_Jg=	Teh_marbuta_Goal/a/}');
    Error('\P{Is_Jg=	Teh_marbuta_Goal/a/}');
    Expect(1, 1731, '\p{Is_Jg=tehmarbutagoal}', "");
    Expect(0, 1731, '\p{^Is_Jg=tehmarbutagoal}', "");
    Expect(0, 1731, '\P{Is_Jg=tehmarbutagoal}', "");
    Expect(1, 1731, '\P{^Is_Jg=tehmarbutagoal}', "");
    Expect(0, 1732, '\p{Is_Jg=tehmarbutagoal}', "");
    Expect(1, 1732, '\p{^Is_Jg=tehmarbutagoal}', "");
    Expect(1, 1732, '\P{Is_Jg=tehmarbutagoal}', "");
    Expect(0, 1732, '\P{^Is_Jg=tehmarbutagoal}', "");
    Expect(1, 1731, '\p{Is_Jg=-_Teh_marbuta_Goal}', "");
    Expect(0, 1731, '\p{^Is_Jg=-_Teh_marbuta_Goal}', "");
    Expect(0, 1731, '\P{Is_Jg=-_Teh_marbuta_Goal}', "");
    Expect(1, 1731, '\P{^Is_Jg=-_Teh_marbuta_Goal}', "");
    Expect(0, 1732, '\p{Is_Jg=-_Teh_marbuta_Goal}', "");
    Expect(1, 1732, '\p{^Is_Jg=-_Teh_marbuta_Goal}', "");
    Expect(1, 1732, '\P{Is_Jg=-_Teh_marbuta_Goal}', "");
    Expect(0, 1732, '\P{^Is_Jg=-_Teh_marbuta_Goal}', "");
    Error('\p{Joining_Group= teth/a/}');
    Error('\P{Joining_Group= teth/a/}');
    Expect(1, 1820, '\p{Joining_Group:   teth}', "");
    Expect(0, 1820, '\p{^Joining_Group:   teth}', "");
    Expect(0, 1820, '\P{Joining_Group:   teth}', "");
    Expect(1, 1820, '\P{^Joining_Group:   teth}', "");
    Expect(0, 1821, '\p{Joining_Group:   teth}', "");
    Expect(1, 1821, '\p{^Joining_Group:   teth}', "");
    Expect(1, 1821, '\P{Joining_Group:   teth}', "");
    Expect(0, 1821, '\P{^Joining_Group:   teth}', "");
    Expect(1, 1820, '\p{Joining_Group=- teth}', "");
    Expect(0, 1820, '\p{^Joining_Group=- teth}', "");
    Expect(0, 1820, '\P{Joining_Group=- teth}', "");
    Expect(1, 1820, '\P{^Joining_Group=- teth}', "");
    Expect(0, 1821, '\p{Joining_Group=- teth}', "");
    Expect(1, 1821, '\p{^Joining_Group=- teth}', "");
    Expect(1, 1821, '\P{Joining_Group=- teth}', "");
    Expect(0, 1821, '\P{^Joining_Group=- teth}', "");
    Error('\p{Jg=/a/__teth}');
    Error('\P{Jg=/a/__teth}');
    Expect(1, 1820, '\p{Jg=teth}', "");
    Expect(0, 1820, '\p{^Jg=teth}', "");
    Expect(0, 1820, '\P{Jg=teth}', "");
    Expect(1, 1820, '\P{^Jg=teth}', "");
    Expect(0, 1821, '\p{Jg=teth}', "");
    Expect(1, 1821, '\p{^Jg=teth}', "");
    Expect(1, 1821, '\P{Jg=teth}', "");
    Expect(0, 1821, '\P{^Jg=teth}', "");
    Expect(1, 1820, '\p{Jg=_-Teth}', "");
    Expect(0, 1820, '\p{^Jg=_-Teth}', "");
    Expect(0, 1820, '\P{Jg=_-Teth}', "");
    Expect(1, 1820, '\P{^Jg=_-Teth}', "");
    Expect(0, 1821, '\p{Jg=_-Teth}', "");
    Expect(1, 1821, '\p{^Jg=_-Teth}', "");
    Expect(1, 1821, '\P{Jg=_-Teth}', "");
    Expect(0, 1821, '\P{^Jg=_-Teth}', "");
    Error('\p{Is_Joining_Group:-_teth:=}');
    Error('\P{Is_Joining_Group:-_teth:=}');
    Expect(1, 1820, '\p{Is_Joining_Group:	teth}', "");
    Expect(0, 1820, '\p{^Is_Joining_Group:	teth}', "");
    Expect(0, 1820, '\P{Is_Joining_Group:	teth}', "");
    Expect(1, 1820, '\P{^Is_Joining_Group:	teth}', "");
    Expect(0, 1821, '\p{Is_Joining_Group:	teth}', "");
    Expect(1, 1821, '\p{^Is_Joining_Group:	teth}', "");
    Expect(1, 1821, '\P{Is_Joining_Group:	teth}', "");
    Expect(0, 1821, '\P{^Is_Joining_Group:	teth}', "");
    Expect(1, 1820, '\p{Is_Joining_Group=-Teth}', "");
    Expect(0, 1820, '\p{^Is_Joining_Group=-Teth}', "");
    Expect(0, 1820, '\P{Is_Joining_Group=-Teth}', "");
    Expect(1, 1820, '\P{^Is_Joining_Group=-Teth}', "");
    Expect(0, 1821, '\p{Is_Joining_Group=-Teth}', "");
    Expect(1, 1821, '\p{^Is_Joining_Group=-Teth}', "");
    Expect(1, 1821, '\P{Is_Joining_Group=-Teth}', "");
    Expect(0, 1821, '\P{^Is_Joining_Group=-Teth}', "");
    Error('\p{Is_Jg=_ Teth/a/}');
    Error('\P{Is_Jg=_ Teth/a/}');
    Expect(1, 1820, '\p{Is_Jg=teth}', "");
    Expect(0, 1820, '\p{^Is_Jg=teth}', "");
    Expect(0, 1820, '\P{Is_Jg=teth}', "");
    Expect(1, 1820, '\P{^Is_Jg=teth}', "");
    Expect(0, 1821, '\p{Is_Jg=teth}', "");
    Expect(1, 1821, '\p{^Is_Jg=teth}', "");
    Expect(1, 1821, '\P{Is_Jg=teth}', "");
    Expect(0, 1821, '\P{^Is_Jg=teth}', "");
    Expect(1, 1820, '\p{Is_Jg= -Teth}', "");
    Expect(0, 1820, '\p{^Is_Jg= -Teth}', "");
    Expect(0, 1820, '\P{Is_Jg= -Teth}', "");
    Expect(1, 1820, '\P{^Is_Jg= -Teth}', "");
    Expect(0, 1821, '\p{Is_Jg= -Teth}', "");
    Expect(1, 1821, '\p{^Is_Jg= -Teth}', "");
    Expect(1, 1821, '\P{Is_Jg= -Teth}', "");
    Expect(0, 1821, '\P{^Is_Jg= -Teth}', "");
    Error('\p{Joining_Group= :=WAW}');
    Error('\P{Joining_Group= :=WAW}');
    Expect(1, 2219, '\p{Joining_Group:	waw}', "");
    Expect(0, 2219, '\p{^Joining_Group:	waw}', "");
    Expect(0, 2219, '\P{Joining_Group:	waw}', "");
    Expect(1, 2219, '\P{^Joining_Group:	waw}', "");
    Expect(0, 2220, '\p{Joining_Group:	waw}', "");
    Expect(1, 2220, '\p{^Joining_Group:	waw}', "");
    Expect(1, 2220, '\P{Joining_Group:	waw}', "");
    Expect(0, 2220, '\P{^Joining_Group:	waw}', "");
    Expect(1, 2219, '\p{Joining_Group=_Waw}', "");
    Expect(0, 2219, '\p{^Joining_Group=_Waw}', "");
    Expect(0, 2219, '\P{Joining_Group=_Waw}', "");
    Expect(1, 2219, '\P{^Joining_Group=_Waw}', "");
    Expect(0, 2220, '\p{Joining_Group=_Waw}', "");
    Expect(1, 2220, '\p{^Joining_Group=_Waw}', "");
    Expect(1, 2220, '\P{Joining_Group=_Waw}', "");
    Expect(0, 2220, '\P{^Joining_Group=_Waw}', "");
    Error('\p{Jg=:=		Waw}');
    Error('\P{Jg=:=		Waw}');
    Expect(1, 2219, '\p{Jg=waw}', "");
    Expect(0, 2219, '\p{^Jg=waw}', "");
    Expect(0, 2219, '\P{Jg=waw}', "");
    Expect(1, 2219, '\P{^Jg=waw}', "");
    Expect(0, 2220, '\p{Jg=waw}', "");
    Expect(1, 2220, '\p{^Jg=waw}', "");
    Expect(1, 2220, '\P{Jg=waw}', "");
    Expect(0, 2220, '\P{^Jg=waw}', "");
    Expect(1, 2219, '\p{Jg=-_waw}', "");
    Expect(0, 2219, '\p{^Jg=-_waw}', "");
    Expect(0, 2219, '\P{Jg=-_waw}', "");
    Expect(1, 2219, '\P{^Jg=-_waw}', "");
    Expect(0, 2220, '\p{Jg=-_waw}', "");
    Expect(1, 2220, '\p{^Jg=-_waw}', "");
    Expect(1, 2220, '\P{Jg=-_waw}', "");
    Expect(0, 2220, '\P{^Jg=-_waw}', "");
    Error('\p{Is_Joining_Group=:=	-waw}');
    Error('\P{Is_Joining_Group=:=	-waw}');
    Expect(1, 2219, '\p{Is_Joining_Group=waw}', "");
    Expect(0, 2219, '\p{^Is_Joining_Group=waw}', "");
    Expect(0, 2219, '\P{Is_Joining_Group=waw}', "");
    Expect(1, 2219, '\P{^Is_Joining_Group=waw}', "");
    Expect(0, 2220, '\p{Is_Joining_Group=waw}', "");
    Expect(1, 2220, '\p{^Is_Joining_Group=waw}', "");
    Expect(1, 2220, '\P{Is_Joining_Group=waw}', "");
    Expect(0, 2220, '\P{^Is_Joining_Group=waw}', "");
    Expect(1, 2219, '\p{Is_Joining_Group= _Waw}', "");
    Expect(0, 2219, '\p{^Is_Joining_Group= _Waw}', "");
    Expect(0, 2219, '\P{Is_Joining_Group= _Waw}', "");
    Expect(1, 2219, '\P{^Is_Joining_Group= _Waw}', "");
    Expect(0, 2220, '\p{Is_Joining_Group= _Waw}', "");
    Expect(1, 2220, '\p{^Is_Joining_Group= _Waw}', "");
    Expect(1, 2220, '\P{Is_Joining_Group= _Waw}', "");
    Expect(0, 2220, '\P{^Is_Joining_Group= _Waw}', "");
    Error('\p{Is_Jg=:= 	WAW}');
    Error('\P{Is_Jg=:= 	WAW}');
    Expect(1, 2219, '\p{Is_Jg=waw}', "");
    Expect(0, 2219, '\p{^Is_Jg=waw}', "");
    Expect(0, 2219, '\P{Is_Jg=waw}', "");
    Expect(1, 2219, '\P{^Is_Jg=waw}', "");
    Expect(0, 2220, '\p{Is_Jg=waw}', "");
    Expect(1, 2220, '\p{^Is_Jg=waw}', "");
    Expect(1, 2220, '\P{Is_Jg=waw}', "");
    Expect(0, 2220, '\P{^Is_Jg=waw}', "");
    Expect(1, 2219, '\p{Is_Jg=		Waw}', "");
    Expect(0, 2219, '\p{^Is_Jg=		Waw}', "");
    Expect(0, 2219, '\P{Is_Jg=		Waw}', "");
    Expect(1, 2219, '\P{^Is_Jg=		Waw}', "");
    Expect(0, 2220, '\p{Is_Jg=		Waw}', "");
    Expect(1, 2220, '\p{^Is_Jg=		Waw}', "");
    Expect(1, 2220, '\P{Is_Jg=		Waw}', "");
    Expect(0, 2220, '\P{^Is_Jg=		Waw}', "");
    Error('\p{Joining_Group=:=_yeh}');
    Error('\P{Joining_Group=:=_yeh}');
    Expect(1, 2234, '\p{Joining_Group:yeh}', "");
    Expect(0, 2234, '\p{^Joining_Group:yeh}', "");
    Expect(0, 2234, '\P{Joining_Group:yeh}', "");
    Expect(1, 2234, '\P{^Joining_Group:yeh}', "");
    Expect(0, 2235, '\p{Joining_Group:yeh}', "");
    Expect(1, 2235, '\p{^Joining_Group:yeh}', "");
    Expect(1, 2235, '\P{Joining_Group:yeh}', "");
    Expect(0, 2235, '\P{^Joining_Group:yeh}', "");
    Expect(1, 2234, '\p{Joining_Group=_YEH}', "");
    Expect(0, 2234, '\p{^Joining_Group=_YEH}', "");
    Expect(0, 2234, '\P{Joining_Group=_YEH}', "");
    Expect(1, 2234, '\P{^Joining_Group=_YEH}', "");
    Expect(0, 2235, '\p{Joining_Group=_YEH}', "");
    Expect(1, 2235, '\p{^Joining_Group=_YEH}', "");
    Expect(1, 2235, '\P{Joining_Group=_YEH}', "");
    Expect(0, 2235, '\P{^Joining_Group=_YEH}', "");
    Error('\p{Jg=-/a/yeh}');
    Error('\P{Jg=-/a/yeh}');
    Expect(1, 2234, '\p{Jg=yeh}', "");
    Expect(0, 2234, '\p{^Jg=yeh}', "");
    Expect(0, 2234, '\P{Jg=yeh}', "");
    Expect(1, 2234, '\P{^Jg=yeh}', "");
    Expect(0, 2235, '\p{Jg=yeh}', "");
    Expect(1, 2235, '\p{^Jg=yeh}', "");
    Expect(1, 2235, '\P{Jg=yeh}', "");
    Expect(0, 2235, '\P{^Jg=yeh}', "");
    Expect(1, 2234, '\p{Jg:   _ yeh}', "");
    Expect(0, 2234, '\p{^Jg:   _ yeh}', "");
    Expect(0, 2234, '\P{Jg:   _ yeh}', "");
    Expect(1, 2234, '\P{^Jg:   _ yeh}', "");
    Expect(0, 2235, '\p{Jg:   _ yeh}', "");
    Expect(1, 2235, '\p{^Jg:   _ yeh}', "");
    Expect(1, 2235, '\P{Jg:   _ yeh}', "");
    Expect(0, 2235, '\P{^Jg:   _ yeh}', "");
    Error('\p{Is_Joining_Group=	_YEH/a/}');
    Error('\P{Is_Joining_Group=	_YEH/a/}');
    Expect(1, 2234, '\p{Is_Joining_Group=yeh}', "");
    Expect(0, 2234, '\p{^Is_Joining_Group=yeh}', "");
    Expect(0, 2234, '\P{Is_Joining_Group=yeh}', "");
    Expect(1, 2234, '\P{^Is_Joining_Group=yeh}', "");
    Expect(0, 2235, '\p{Is_Joining_Group=yeh}', "");
    Expect(1, 2235, '\p{^Is_Joining_Group=yeh}', "");
    Expect(1, 2235, '\P{Is_Joining_Group=yeh}', "");
    Expect(0, 2235, '\P{^Is_Joining_Group=yeh}', "");
    Expect(1, 2234, '\p{Is_Joining_Group=_ yeh}', "");
    Expect(0, 2234, '\p{^Is_Joining_Group=_ yeh}', "");
    Expect(0, 2234, '\P{Is_Joining_Group=_ yeh}', "");
    Expect(1, 2234, '\P{^Is_Joining_Group=_ yeh}', "");
    Expect(0, 2235, '\p{Is_Joining_Group=_ yeh}', "");
    Expect(1, 2235, '\p{^Is_Joining_Group=_ yeh}', "");
    Expect(1, 2235, '\P{Is_Joining_Group=_ yeh}', "");
    Expect(0, 2235, '\P{^Is_Joining_Group=_ yeh}', "");
    Error('\p{Is_Jg=/a/ _Yeh}');
    Error('\P{Is_Jg=/a/ _Yeh}');
    Expect(1, 2234, '\p{Is_Jg=yeh}', "");
    Expect(0, 2234, '\p{^Is_Jg=yeh}', "");
    Expect(0, 2234, '\P{Is_Jg=yeh}', "");
    Expect(1, 2234, '\P{^Is_Jg=yeh}', "");
    Expect(0, 2235, '\p{Is_Jg=yeh}', "");
    Expect(1, 2235, '\p{^Is_Jg=yeh}', "");
    Expect(1, 2235, '\P{Is_Jg=yeh}', "");
    Expect(0, 2235, '\P{^Is_Jg=yeh}', "");
    Expect(1, 2234, '\p{Is_Jg=- Yeh}', "");
    Expect(0, 2234, '\p{^Is_Jg=- Yeh}', "");
    Expect(0, 2234, '\P{Is_Jg=- Yeh}', "");
    Expect(1, 2234, '\P{^Is_Jg=- Yeh}', "");
    Expect(0, 2235, '\p{Is_Jg=- Yeh}', "");
    Expect(1, 2235, '\p{^Is_Jg=- Yeh}', "");
    Expect(1, 2235, '\P{Is_Jg=- Yeh}', "");
    Expect(0, 2235, '\P{^Is_Jg=- Yeh}', "");
    Error('\p{Joining_Group=/a/-_Yeh_BARREE}');
    Error('\P{Joining_Group=/a/-_Yeh_BARREE}');
    Expect(1, 1747, '\p{Joining_Group:	yehbarree}', "");
    Expect(0, 1747, '\p{^Joining_Group:	yehbarree}', "");
    Expect(0, 1747, '\P{Joining_Group:	yehbarree}', "");
    Expect(1, 1747, '\P{^Joining_Group:	yehbarree}', "");
    Expect(0, 1748, '\p{Joining_Group:	yehbarree}', "");
    Expect(1, 1748, '\p{^Joining_Group:	yehbarree}', "");
    Expect(1, 1748, '\P{Joining_Group:	yehbarree}', "");
    Expect(0, 1748, '\P{^Joining_Group:	yehbarree}', "");
    Expect(1, 1747, '\p{Joining_Group:		YEH_BARREE}', "");
    Expect(0, 1747, '\p{^Joining_Group:		YEH_BARREE}', "");
    Expect(0, 1747, '\P{Joining_Group:		YEH_BARREE}', "");
    Expect(1, 1747, '\P{^Joining_Group:		YEH_BARREE}', "");
    Expect(0, 1748, '\p{Joining_Group:		YEH_BARREE}', "");
    Expect(1, 1748, '\p{^Joining_Group:		YEH_BARREE}', "");
    Expect(1, 1748, '\P{Joining_Group:		YEH_BARREE}', "");
    Expect(0, 1748, '\P{^Joining_Group:		YEH_BARREE}', "");
    Error('\p{Jg=-:=YEH_barree}');
    Error('\P{Jg=-:=YEH_barree}');
    Expect(1, 1747, '\p{Jg=yehbarree}', "");
    Expect(0, 1747, '\p{^Jg=yehbarree}', "");
    Expect(0, 1747, '\P{Jg=yehbarree}', "");
    Expect(1, 1747, '\P{^Jg=yehbarree}', "");
    Expect(0, 1748, '\p{Jg=yehbarree}', "");
    Expect(1, 1748, '\p{^Jg=yehbarree}', "");
    Expect(1, 1748, '\P{Jg=yehbarree}', "");
    Expect(0, 1748, '\P{^Jg=yehbarree}', "");
    Expect(1, 1747, '\p{Jg= 	yeh_Barree}', "");
    Expect(0, 1747, '\p{^Jg= 	yeh_Barree}', "");
    Expect(0, 1747, '\P{Jg= 	yeh_Barree}', "");
    Expect(1, 1747, '\P{^Jg= 	yeh_Barree}', "");
    Expect(0, 1748, '\p{Jg= 	yeh_Barree}', "");
    Expect(1, 1748, '\p{^Jg= 	yeh_Barree}', "");
    Expect(1, 1748, '\P{Jg= 	yeh_Barree}', "");
    Expect(0, 1748, '\P{^Jg= 	yeh_Barree}', "");
    Error('\p{Is_Joining_Group:	_:=YEH_barree}');
    Error('\P{Is_Joining_Group:	_:=YEH_barree}');
    Expect(1, 1747, '\p{Is_Joining_Group=yehbarree}', "");
    Expect(0, 1747, '\p{^Is_Joining_Group=yehbarree}', "");
    Expect(0, 1747, '\P{Is_Joining_Group=yehbarree}', "");
    Expect(1, 1747, '\P{^Is_Joining_Group=yehbarree}', "");
    Expect(0, 1748, '\p{Is_Joining_Group=yehbarree}', "");
    Expect(1, 1748, '\p{^Is_Joining_Group=yehbarree}', "");
    Expect(1, 1748, '\P{Is_Joining_Group=yehbarree}', "");
    Expect(0, 1748, '\P{^Is_Joining_Group=yehbarree}', "");
    Expect(1, 1747, '\p{Is_Joining_Group=	_Yeh_Barree}', "");
    Expect(0, 1747, '\p{^Is_Joining_Group=	_Yeh_Barree}', "");
    Expect(0, 1747, '\P{Is_Joining_Group=	_Yeh_Barree}', "");
    Expect(1, 1747, '\P{^Is_Joining_Group=	_Yeh_Barree}', "");
    Expect(0, 1748, '\p{Is_Joining_Group=	_Yeh_Barree}', "");
    Expect(1, 1748, '\p{^Is_Joining_Group=	_Yeh_Barree}', "");
    Expect(1, 1748, '\P{Is_Joining_Group=	_Yeh_Barree}', "");
    Expect(0, 1748, '\P{^Is_Joining_Group=	_Yeh_Barree}', "");
    Error('\p{Is_Jg= Yeh_barree:=}');
    Error('\P{Is_Jg= Yeh_barree:=}');
    Expect(1, 1747, '\p{Is_Jg=yehbarree}', "");
    Expect(0, 1747, '\p{^Is_Jg=yehbarree}', "");
    Expect(0, 1747, '\P{Is_Jg=yehbarree}', "");
    Expect(1, 1747, '\P{^Is_Jg=yehbarree}', "");
    Expect(0, 1748, '\p{Is_Jg=yehbarree}', "");
    Expect(1, 1748, '\p{^Is_Jg=yehbarree}', "");
    Expect(1, 1748, '\P{Is_Jg=yehbarree}', "");
    Expect(0, 1748, '\P{^Is_Jg=yehbarree}', "");
    Expect(1, 1747, '\p{Is_Jg= Yeh_Barree}', "");
    Expect(0, 1747, '\p{^Is_Jg= Yeh_Barree}', "");
    Expect(0, 1747, '\P{Is_Jg= Yeh_Barree}', "");
    Expect(1, 1747, '\P{^Is_Jg= Yeh_Barree}', "");
    Expect(0, 1748, '\p{Is_Jg= Yeh_Barree}', "");
    Expect(1, 1748, '\p{^Is_Jg= Yeh_Barree}', "");
    Expect(1, 1748, '\P{Is_Jg= Yeh_Barree}', "");
    Expect(0, 1748, '\P{^Is_Jg= Yeh_Barree}', "");
    Error('\p{Joining_Group=:=-Yeh_with_tail}');
    Error('\P{Joining_Group=:=-Yeh_with_tail}');
    Expect(1, 1741, '\p{Joining_Group=yehwithtail}', "");
    Expect(0, 1741, '\p{^Joining_Group=yehwithtail}', "");
    Expect(0, 1741, '\P{Joining_Group=yehwithtail}', "");
    Expect(1, 1741, '\P{^Joining_Group=yehwithtail}', "");
    Expect(0, 1742, '\p{Joining_Group=yehwithtail}', "");
    Expect(1, 1742, '\p{^Joining_Group=yehwithtail}', "");
    Expect(1, 1742, '\P{Joining_Group=yehwithtail}', "");
    Expect(0, 1742, '\P{^Joining_Group=yehwithtail}', "");
    Expect(1, 1741, '\p{Joining_Group=	-YEH_With_tail}', "");
    Expect(0, 1741, '\p{^Joining_Group=	-YEH_With_tail}', "");
    Expect(0, 1741, '\P{Joining_Group=	-YEH_With_tail}', "");
    Expect(1, 1741, '\P{^Joining_Group=	-YEH_With_tail}', "");
    Expect(0, 1742, '\p{Joining_Group=	-YEH_With_tail}', "");
    Expect(1, 1742, '\p{^Joining_Group=	-YEH_With_tail}', "");
    Expect(1, 1742, '\P{Joining_Group=	-YEH_With_tail}', "");
    Expect(0, 1742, '\P{^Joining_Group=	-YEH_With_tail}', "");
    Error('\p{Jg=	_YEH_With_Tail/a/}');
    Error('\P{Jg=	_YEH_With_Tail/a/}');
    Expect(1, 1741, '\p{Jg=yehwithtail}', "");
    Expect(0, 1741, '\p{^Jg=yehwithtail}', "");
    Expect(0, 1741, '\P{Jg=yehwithtail}', "");
    Expect(1, 1741, '\P{^Jg=yehwithtail}', "");
    Expect(0, 1742, '\p{Jg=yehwithtail}', "");
    Expect(1, 1742, '\p{^Jg=yehwithtail}', "");
    Expect(1, 1742, '\P{Jg=yehwithtail}', "");
    Expect(0, 1742, '\P{^Jg=yehwithtail}', "");
    Expect(1, 1741, '\p{Jg=Yeh_WITH_Tail}', "");
    Expect(0, 1741, '\p{^Jg=Yeh_WITH_Tail}', "");
    Expect(0, 1741, '\P{Jg=Yeh_WITH_Tail}', "");
    Expect(1, 1741, '\P{^Jg=Yeh_WITH_Tail}', "");
    Expect(0, 1742, '\p{Jg=Yeh_WITH_Tail}', "");
    Expect(1, 1742, '\p{^Jg=Yeh_WITH_Tail}', "");
    Expect(1, 1742, '\P{Jg=Yeh_WITH_Tail}', "");
    Expect(0, 1742, '\P{^Jg=Yeh_WITH_Tail}', "");
    Error('\p{Is_Joining_Group= -Yeh_With_Tail:=}');
    Error('\P{Is_Joining_Group= -Yeh_With_Tail:=}');
    Expect(1, 1741, '\p{Is_Joining_Group=yehwithtail}', "");
    Expect(0, 1741, '\p{^Is_Joining_Group=yehwithtail}', "");
    Expect(0, 1741, '\P{Is_Joining_Group=yehwithtail}', "");
    Expect(1, 1741, '\P{^Is_Joining_Group=yehwithtail}', "");
    Expect(0, 1742, '\p{Is_Joining_Group=yehwithtail}', "");
    Expect(1, 1742, '\p{^Is_Joining_Group=yehwithtail}', "");
    Expect(1, 1742, '\P{Is_Joining_Group=yehwithtail}', "");
    Expect(0, 1742, '\P{^Is_Joining_Group=yehwithtail}', "");
    Expect(1, 1741, '\p{Is_Joining_Group=_yeh_WITH_TAIL}', "");
    Expect(0, 1741, '\p{^Is_Joining_Group=_yeh_WITH_TAIL}', "");
    Expect(0, 1741, '\P{Is_Joining_Group=_yeh_WITH_TAIL}', "");
    Expect(1, 1741, '\P{^Is_Joining_Group=_yeh_WITH_TAIL}', "");
    Expect(0, 1742, '\p{Is_Joining_Group=_yeh_WITH_TAIL}', "");
    Expect(1, 1742, '\p{^Is_Joining_Group=_yeh_WITH_TAIL}', "");
    Expect(1, 1742, '\P{Is_Joining_Group=_yeh_WITH_TAIL}', "");
    Expect(0, 1742, '\P{^Is_Joining_Group=_yeh_WITH_TAIL}', "");
    Error('\p{Is_Jg=:= 	YEH_With_Tail}');
    Error('\P{Is_Jg=:= 	YEH_With_Tail}');
    Expect(1, 1741, '\p{Is_Jg=yehwithtail}', "");
    Expect(0, 1741, '\p{^Is_Jg=yehwithtail}', "");
    Expect(0, 1741, '\P{Is_Jg=yehwithtail}', "");
    Expect(1, 1741, '\P{^Is_Jg=yehwithtail}', "");
    Expect(0, 1742, '\p{Is_Jg=yehwithtail}', "");
    Expect(1, 1742, '\p{^Is_Jg=yehwithtail}', "");
    Expect(1, 1742, '\P{Is_Jg=yehwithtail}', "");
    Expect(0, 1742, '\P{^Is_Jg=yehwithtail}', "");
    Expect(1, 1741, '\p{Is_Jg=	 YEH_with_TAIL}', "");
    Expect(0, 1741, '\p{^Is_Jg=	 YEH_with_TAIL}', "");
    Expect(0, 1741, '\P{Is_Jg=	 YEH_with_TAIL}', "");
    Expect(1, 1741, '\P{^Is_Jg=	 YEH_with_TAIL}', "");
    Expect(0, 1742, '\p{Is_Jg=	 YEH_with_TAIL}', "");
    Expect(1, 1742, '\p{^Is_Jg=	 YEH_with_TAIL}', "");
    Expect(1, 1742, '\P{Is_Jg=	 YEH_with_TAIL}', "");
    Expect(0, 1742, '\P{^Is_Jg=	 YEH_with_TAIL}', "");
    Error('\p{Joining_Group=/a/ Yudh}');
    Error('\P{Joining_Group=/a/ Yudh}');
    Expect(1, 1821, '\p{Joining_Group=yudh}', "");
    Expect(0, 1821, '\p{^Joining_Group=yudh}', "");
    Expect(0, 1821, '\P{Joining_Group=yudh}', "");
    Expect(1, 1821, '\P{^Joining_Group=yudh}', "");
    Expect(0, 1822, '\p{Joining_Group=yudh}', "");
    Expect(1, 1822, '\p{^Joining_Group=yudh}', "");
    Expect(1, 1822, '\P{Joining_Group=yudh}', "");
    Expect(0, 1822, '\P{^Joining_Group=yudh}', "");
    Expect(1, 1821, '\p{Joining_Group=-Yudh}', "");
    Expect(0, 1821, '\p{^Joining_Group=-Yudh}', "");
    Expect(0, 1821, '\P{Joining_Group=-Yudh}', "");
    Expect(1, 1821, '\P{^Joining_Group=-Yudh}', "");
    Expect(0, 1822, '\p{Joining_Group=-Yudh}', "");
    Expect(1, 1822, '\p{^Joining_Group=-Yudh}', "");
    Expect(1, 1822, '\P{Joining_Group=-Yudh}', "");
    Expect(0, 1822, '\P{^Joining_Group=-Yudh}', "");
    Error('\p{Jg:		yudh:=}');
    Error('\P{Jg:		yudh:=}');
    Expect(1, 1821, '\p{Jg=yudh}', "");
    Expect(0, 1821, '\p{^Jg=yudh}', "");
    Expect(0, 1821, '\P{Jg=yudh}', "");
    Expect(1, 1821, '\P{^Jg=yudh}', "");
    Expect(0, 1822, '\p{Jg=yudh}', "");
    Expect(1, 1822, '\p{^Jg=yudh}', "");
    Expect(1, 1822, '\P{Jg=yudh}', "");
    Expect(0, 1822, '\P{^Jg=yudh}', "");
    Expect(1, 1821, '\p{Jg=		Yudh}', "");
    Expect(0, 1821, '\p{^Jg=		Yudh}', "");
    Expect(0, 1821, '\P{Jg=		Yudh}', "");
    Expect(1, 1821, '\P{^Jg=		Yudh}', "");
    Expect(0, 1822, '\p{Jg=		Yudh}', "");
    Expect(1, 1822, '\p{^Jg=		Yudh}', "");
    Expect(1, 1822, '\P{Jg=		Yudh}', "");
    Expect(0, 1822, '\P{^Jg=		Yudh}', "");
    Error('\p{Is_Joining_Group= _Yudh/a/}');
    Error('\P{Is_Joining_Group= _Yudh/a/}');
    Expect(1, 1821, '\p{Is_Joining_Group:yudh}', "");
    Expect(0, 1821, '\p{^Is_Joining_Group:yudh}', "");
    Expect(0, 1821, '\P{Is_Joining_Group:yudh}', "");
    Expect(1, 1821, '\P{^Is_Joining_Group:yudh}', "");
    Expect(0, 1822, '\p{Is_Joining_Group:yudh}', "");
    Expect(1, 1822, '\p{^Is_Joining_Group:yudh}', "");
    Expect(1, 1822, '\P{Is_Joining_Group:yudh}', "");
    Expect(0, 1822, '\P{^Is_Joining_Group:yudh}', "");
    Expect(1, 1821, '\p{Is_Joining_Group=	 Yudh}', "");
    Expect(0, 1821, '\p{^Is_Joining_Group=	 Yudh}', "");
    Expect(0, 1821, '\P{Is_Joining_Group=	 Yudh}', "");
    Expect(1, 1821, '\P{^Is_Joining_Group=	 Yudh}', "");
    Expect(0, 1822, '\p{Is_Joining_Group=	 Yudh}', "");
    Expect(1, 1822, '\p{^Is_Joining_Group=	 Yudh}', "");
    Expect(1, 1822, '\P{Is_Joining_Group=	 Yudh}', "");
    Expect(0, 1822, '\P{^Is_Joining_Group=	 Yudh}', "");
    Error('\p{Is_Jg=:=	yudh}');
    Error('\P{Is_Jg=:=	yudh}');
    Expect(1, 1821, '\p{Is_Jg=yudh}', "");
    Expect(0, 1821, '\p{^Is_Jg=yudh}', "");
    Expect(0, 1821, '\P{Is_Jg=yudh}', "");
    Expect(1, 1821, '\P{^Is_Jg=yudh}', "");
    Expect(0, 1822, '\p{Is_Jg=yudh}', "");
    Expect(1, 1822, '\p{^Is_Jg=yudh}', "");
    Expect(1, 1822, '\P{Is_Jg=yudh}', "");
    Expect(0, 1822, '\P{^Is_Jg=yudh}', "");
    Expect(1, 1821, '\p{Is_Jg=--Yudh}', "");
    Expect(0, 1821, '\p{^Is_Jg=--Yudh}', "");
    Expect(0, 1821, '\P{Is_Jg=--Yudh}', "");
    Expect(1, 1821, '\P{^Is_Jg=--Yudh}', "");
    Expect(0, 1822, '\p{Is_Jg=--Yudh}', "");
    Expect(1, 1822, '\p{^Is_Jg=--Yudh}', "");
    Expect(1, 1822, '\P{Is_Jg=--Yudh}', "");
    Expect(0, 1822, '\P{^Is_Jg=--Yudh}', "");
    Error('\p{Joining_Group=:= 	Yudh_he}');
    Error('\P{Joining_Group=:= 	Yudh_he}');
    Expect(1, 1822, '\p{Joining_Group=yudhhe}', "");
    Expect(0, 1822, '\p{^Joining_Group=yudhhe}', "");
    Expect(0, 1822, '\P{Joining_Group=yudhhe}', "");
    Expect(1, 1822, '\P{^Joining_Group=yudhhe}', "");
    Expect(0, 1823, '\p{Joining_Group=yudhhe}', "");
    Expect(1, 1823, '\p{^Joining_Group=yudhhe}', "");
    Expect(1, 1823, '\P{Joining_Group=yudhhe}', "");
    Expect(0, 1823, '\P{^Joining_Group=yudhhe}', "");
    Expect(1, 1822, '\p{Joining_Group=--YUDH_he}', "");
    Expect(0, 1822, '\p{^Joining_Group=--YUDH_he}', "");
    Expect(0, 1822, '\P{Joining_Group=--YUDH_he}', "");
    Expect(1, 1822, '\P{^Joining_Group=--YUDH_he}', "");
    Expect(0, 1823, '\p{Joining_Group=--YUDH_he}', "");
    Expect(1, 1823, '\p{^Joining_Group=--YUDH_he}', "");
    Expect(1, 1823, '\P{Joining_Group=--YUDH_he}', "");
    Expect(0, 1823, '\P{^Joining_Group=--YUDH_he}', "");
    Error('\p{Jg=:= Yudh_He}');
    Error('\P{Jg=:= Yudh_He}');
    Expect(1, 1822, '\p{Jg=yudhhe}', "");
    Expect(0, 1822, '\p{^Jg=yudhhe}', "");
    Expect(0, 1822, '\P{Jg=yudhhe}', "");
    Expect(1, 1822, '\P{^Jg=yudhhe}', "");
    Expect(0, 1823, '\p{Jg=yudhhe}', "");
    Expect(1, 1823, '\p{^Jg=yudhhe}', "");
    Expect(1, 1823, '\P{Jg=yudhhe}', "");
    Expect(0, 1823, '\P{^Jg=yudhhe}', "");
    Expect(1, 1822, '\p{Jg= -Yudh_HE}', "");
    Expect(0, 1822, '\p{^Jg= -Yudh_HE}', "");
    Expect(0, 1822, '\P{Jg= -Yudh_HE}', "");
    Expect(1, 1822, '\P{^Jg= -Yudh_HE}', "");
    Expect(0, 1823, '\p{Jg= -Yudh_HE}', "");
    Expect(1, 1823, '\p{^Jg= -Yudh_HE}', "");
    Expect(1, 1823, '\P{Jg= -Yudh_HE}', "");
    Expect(0, 1823, '\P{^Jg= -Yudh_HE}', "");
    Error('\p{Is_Joining_Group=_Yudh_HE:=}');
    Error('\P{Is_Joining_Group=_Yudh_HE:=}');
    Expect(1, 1822, '\p{Is_Joining_Group=yudhhe}', "");
    Expect(0, 1822, '\p{^Is_Joining_Group=yudhhe}', "");
    Expect(0, 1822, '\P{Is_Joining_Group=yudhhe}', "");
    Expect(1, 1822, '\P{^Is_Joining_Group=yudhhe}', "");
    Expect(0, 1823, '\p{Is_Joining_Group=yudhhe}', "");
    Expect(1, 1823, '\p{^Is_Joining_Group=yudhhe}', "");
    Expect(1, 1823, '\P{Is_Joining_Group=yudhhe}', "");
    Expect(0, 1823, '\P{^Is_Joining_Group=yudhhe}', "");
    Expect(1, 1822, '\p{Is_Joining_Group=  yudh_he}', "");
    Expect(0, 1822, '\p{^Is_Joining_Group=  yudh_he}', "");
    Expect(0, 1822, '\P{Is_Joining_Group=  yudh_he}', "");
    Expect(1, 1822, '\P{^Is_Joining_Group=  yudh_he}', "");
    Expect(0, 1823, '\p{Is_Joining_Group=  yudh_he}', "");
    Expect(1, 1823, '\p{^Is_Joining_Group=  yudh_he}', "");
    Expect(1, 1823, '\P{Is_Joining_Group=  yudh_he}', "");
    Expect(0, 1823, '\P{^Is_Joining_Group=  yudh_he}', "");
    Error('\p{Is_Jg=__yudh_He:=}');
    Error('\P{Is_Jg=__yudh_He:=}');
    Expect(1, 1822, '\p{Is_Jg=yudhhe}', "");
    Expect(0, 1822, '\p{^Is_Jg=yudhhe}', "");
    Expect(0, 1822, '\P{Is_Jg=yudhhe}', "");
    Expect(1, 1822, '\P{^Is_Jg=yudhhe}', "");
    Expect(0, 1823, '\p{Is_Jg=yudhhe}', "");
    Expect(1, 1823, '\p{^Is_Jg=yudhhe}', "");
    Expect(1, 1823, '\P{Is_Jg=yudhhe}', "");
    Expect(0, 1823, '\P{^Is_Jg=yudhhe}', "");
    Expect(1, 1822, '\p{Is_Jg=_-Yudh_he}', "");
    Expect(0, 1822, '\p{^Is_Jg=_-Yudh_he}', "");
    Expect(0, 1822, '\P{Is_Jg=_-Yudh_he}', "");
    Expect(1, 1822, '\P{^Is_Jg=_-Yudh_he}', "");
    Expect(0, 1823, '\p{Is_Jg=_-Yudh_he}', "");
    Expect(1, 1823, '\p{^Is_Jg=_-Yudh_he}', "");
    Expect(1, 1823, '\P{Is_Jg=_-Yudh_he}', "");
    Expect(0, 1823, '\P{^Is_Jg=_-Yudh_he}', "");
    Error('\p{Joining_Group:   	ZAIN:=}');
    Error('\P{Joining_Group:   	ZAIN:=}');
    Expect(1, 1817, '\p{Joining_Group=zain}', "");
    Expect(0, 1817, '\p{^Joining_Group=zain}', "");
    Expect(0, 1817, '\P{Joining_Group=zain}', "");
    Expect(1, 1817, '\P{^Joining_Group=zain}', "");
    Expect(0, 1818, '\p{Joining_Group=zain}', "");
    Expect(1, 1818, '\p{^Joining_Group=zain}', "");
    Expect(1, 1818, '\P{Joining_Group=zain}', "");
    Expect(0, 1818, '\P{^Joining_Group=zain}', "");
    Expect(1, 1817, '\p{Joining_Group=_ ZAIN}', "");
    Expect(0, 1817, '\p{^Joining_Group=_ ZAIN}', "");
    Expect(0, 1817, '\P{Joining_Group=_ ZAIN}', "");
    Expect(1, 1817, '\P{^Joining_Group=_ ZAIN}', "");
    Expect(0, 1818, '\p{Joining_Group=_ ZAIN}', "");
    Expect(1, 1818, '\p{^Joining_Group=_ ZAIN}', "");
    Expect(1, 1818, '\P{Joining_Group=_ ZAIN}', "");
    Expect(0, 1818, '\P{^Joining_Group=_ ZAIN}', "");
    Error('\p{Jg=_	ZAIN:=}');
    Error('\P{Jg=_	ZAIN:=}');
    Expect(1, 1817, '\p{Jg=zain}', "");
    Expect(0, 1817, '\p{^Jg=zain}', "");
    Expect(0, 1817, '\P{Jg=zain}', "");
    Expect(1, 1817, '\P{^Jg=zain}', "");
    Expect(0, 1818, '\p{Jg=zain}', "");
    Expect(1, 1818, '\p{^Jg=zain}', "");
    Expect(1, 1818, '\P{Jg=zain}', "");
    Expect(0, 1818, '\P{^Jg=zain}', "");
    Expect(1, 1817, '\p{Jg=ZAIN}', "");
    Expect(0, 1817, '\p{^Jg=ZAIN}', "");
    Expect(0, 1817, '\P{Jg=ZAIN}', "");
    Expect(1, 1817, '\P{^Jg=ZAIN}', "");
    Expect(0, 1818, '\p{Jg=ZAIN}', "");
    Expect(1, 1818, '\p{^Jg=ZAIN}', "");
    Expect(1, 1818, '\P{Jg=ZAIN}', "");
    Expect(0, 1818, '\P{^Jg=ZAIN}', "");
    Error('\p{Is_Joining_Group=_Zain/a/}');
    Error('\P{Is_Joining_Group=_Zain/a/}');
    Expect(1, 1817, '\p{Is_Joining_Group=zain}', "");
    Expect(0, 1817, '\p{^Is_Joining_Group=zain}', "");
    Expect(0, 1817, '\P{Is_Joining_Group=zain}', "");
    Expect(1, 1817, '\P{^Is_Joining_Group=zain}', "");
    Expect(0, 1818, '\p{Is_Joining_Group=zain}', "");
    Expect(1, 1818, '\p{^Is_Joining_Group=zain}', "");
    Expect(1, 1818, '\P{Is_Joining_Group=zain}', "");
    Expect(0, 1818, '\P{^Is_Joining_Group=zain}', "");
    Expect(1, 1817, '\p{Is_Joining_Group=	 zain}', "");
    Expect(0, 1817, '\p{^Is_Joining_Group=	 zain}', "");
    Expect(0, 1817, '\P{Is_Joining_Group=	 zain}', "");
    Expect(1, 1817, '\P{^Is_Joining_Group=	 zain}', "");
    Expect(0, 1818, '\p{Is_Joining_Group=	 zain}', "");
    Expect(1, 1818, '\p{^Is_Joining_Group=	 zain}', "");
    Expect(1, 1818, '\P{Is_Joining_Group=	 zain}', "");
    Expect(0, 1818, '\P{^Is_Joining_Group=	 zain}', "");
    Error('\p{Is_Jg=__zain:=}');
    Error('\P{Is_Jg=__zain:=}');
    Expect(1, 1817, '\p{Is_Jg: zain}', "");
    Expect(0, 1817, '\p{^Is_Jg: zain}', "");
    Expect(0, 1817, '\P{Is_Jg: zain}', "");
    Expect(1, 1817, '\P{^Is_Jg: zain}', "");
    Expect(0, 1818, '\p{Is_Jg: zain}', "");
    Expect(1, 1818, '\p{^Is_Jg: zain}', "");
    Expect(1, 1818, '\P{Is_Jg: zain}', "");
    Expect(0, 1818, '\P{^Is_Jg: zain}', "");
    Expect(1, 1817, '\p{Is_Jg: _-ZAIN}', "");
    Expect(0, 1817, '\p{^Is_Jg: _-ZAIN}', "");
    Expect(0, 1817, '\P{Is_Jg: _-ZAIN}', "");
    Expect(1, 1817, '\P{^Is_Jg: _-ZAIN}', "");
    Expect(0, 1818, '\p{Is_Jg: _-ZAIN}', "");
    Expect(1, 1818, '\p{^Is_Jg: _-ZAIN}', "");
    Expect(1, 1818, '\P{Is_Jg: _-ZAIN}', "");
    Expect(0, 1818, '\P{^Is_Jg: _-ZAIN}', "");
    Error('\p{Joining_Group=/a/ Zhain}');
    Error('\P{Joining_Group=/a/ Zhain}');
    Expect(1, 1869, '\p{Joining_Group=zhain}', "");
    Expect(0, 1869, '\p{^Joining_Group=zhain}', "");
    Expect(0, 1869, '\P{Joining_Group=zhain}', "");
    Expect(1, 1869, '\P{^Joining_Group=zhain}', "");
    Expect(0, 1870, '\p{Joining_Group=zhain}', "");
    Expect(1, 1870, '\p{^Joining_Group=zhain}', "");
    Expect(1, 1870, '\P{Joining_Group=zhain}', "");
    Expect(0, 1870, '\P{^Joining_Group=zhain}', "");
    Expect(1, 1869, '\p{Joining_Group= Zhain}', "");
    Expect(0, 1869, '\p{^Joining_Group= Zhain}', "");
    Expect(0, 1869, '\P{Joining_Group= Zhain}', "");
    Expect(1, 1869, '\P{^Joining_Group= Zhain}', "");
    Expect(0, 1870, '\p{Joining_Group= Zhain}', "");
    Expect(1, 1870, '\p{^Joining_Group= Zhain}', "");
    Expect(1, 1870, '\P{Joining_Group= Zhain}', "");
    Expect(0, 1870, '\P{^Joining_Group= Zhain}', "");
    Error('\p{Jg=_ zhain/a/}');
    Error('\P{Jg=_ zhain/a/}');
    Expect(1, 1869, '\p{Jg=zhain}', "");
    Expect(0, 1869, '\p{^Jg=zhain}', "");
    Expect(0, 1869, '\P{Jg=zhain}', "");
    Expect(1, 1869, '\P{^Jg=zhain}', "");
    Expect(0, 1870, '\p{Jg=zhain}', "");
    Expect(1, 1870, '\p{^Jg=zhain}', "");
    Expect(1, 1870, '\P{Jg=zhain}', "");
    Expect(0, 1870, '\P{^Jg=zhain}', "");
    Expect(1, 1869, '\p{Jg=_ Zhain}', "");
    Expect(0, 1869, '\p{^Jg=_ Zhain}', "");
    Expect(0, 1869, '\P{Jg=_ Zhain}', "");
    Expect(1, 1869, '\P{^Jg=_ Zhain}', "");
    Expect(0, 1870, '\p{Jg=_ Zhain}', "");
    Expect(1, 1870, '\p{^Jg=_ Zhain}', "");
    Expect(1, 1870, '\P{Jg=_ Zhain}', "");
    Expect(0, 1870, '\P{^Jg=_ Zhain}', "");
    Error('\p{Is_Joining_Group=/a/	 ZHAIN}');
    Error('\P{Is_Joining_Group=/a/	 ZHAIN}');
    Expect(1, 1869, '\p{Is_Joining_Group=zhain}', "");
    Expect(0, 1869, '\p{^Is_Joining_Group=zhain}', "");
    Expect(0, 1869, '\P{Is_Joining_Group=zhain}', "");
    Expect(1, 1869, '\P{^Is_Joining_Group=zhain}', "");
    Expect(0, 1870, '\p{Is_Joining_Group=zhain}', "");
    Expect(1, 1870, '\p{^Is_Joining_Group=zhain}', "");
    Expect(1, 1870, '\P{Is_Joining_Group=zhain}', "");
    Expect(0, 1870, '\P{^Is_Joining_Group=zhain}', "");
    Expect(1, 1869, '\p{Is_Joining_Group= 	zhain}', "");
    Expect(0, 1869, '\p{^Is_Joining_Group= 	zhain}', "");
    Expect(0, 1869, '\P{Is_Joining_Group= 	zhain}', "");
    Expect(1, 1869, '\P{^Is_Joining_Group= 	zhain}', "");
    Expect(0, 1870, '\p{Is_Joining_Group= 	zhain}', "");
    Expect(1, 1870, '\p{^Is_Joining_Group= 	zhain}', "");
    Expect(1, 1870, '\P{Is_Joining_Group= 	zhain}', "");
    Expect(0, 1870, '\P{^Is_Joining_Group= 	zhain}', "");
    Error('\p{Is_Jg= Zhain:=}');
    Error('\P{Is_Jg= Zhain:=}');
    Expect(1, 1869, '\p{Is_Jg=zhain}', "");
    Expect(0, 1869, '\p{^Is_Jg=zhain}', "");
    Expect(0, 1869, '\P{Is_Jg=zhain}', "");
    Expect(1, 1869, '\P{^Is_Jg=zhain}', "");
    Expect(0, 1870, '\p{Is_Jg=zhain}', "");
    Expect(1, 1870, '\p{^Is_Jg=zhain}', "");
    Expect(1, 1870, '\P{Is_Jg=zhain}', "");
    Expect(0, 1870, '\P{^Is_Jg=zhain}', "");
    Expect(1, 1869, '\p{Is_Jg=	Zhain}', "");
    Expect(0, 1869, '\p{^Is_Jg=	Zhain}', "");
    Expect(0, 1869, '\P{Is_Jg=	Zhain}', "");
    Expect(1, 1869, '\P{^Is_Jg=	Zhain}', "");
    Expect(0, 1870, '\p{Is_Jg=	Zhain}', "");
    Expect(1, 1870, '\p{^Is_Jg=	Zhain}', "");
    Expect(1, 1870, '\P{Is_Jg=	Zhain}', "");
    Expect(0, 1870, '\P{^Is_Jg=	Zhain}', "");
    Error('\p{Join_Control=-:=no}');
    Error('\P{Join_Control=-:=no}');
    Expect(1, 8206, '\p{Join_Control: no}', "");
    Expect(0, 8206, '\p{^Join_Control: no}', "");
    Expect(0, 8206, '\P{Join_Control: no}', "");
    Expect(1, 8206, '\P{^Join_Control: no}', "");
    Expect(0, 8205, '\p{Join_Control: no}', "");
    Expect(1, 8205, '\p{^Join_Control: no}', "");
    Expect(1, 8205, '\P{Join_Control: no}', "");
    Expect(0, 8205, '\P{^Join_Control: no}', "");
    Expect(1, 8206, '\p{Join_Control= No}', "");
    Expect(0, 8206, '\p{^Join_Control= No}', "");
    Expect(0, 8206, '\P{Join_Control= No}', "");
    Expect(1, 8206, '\P{^Join_Control= No}', "");
    Expect(0, 8205, '\p{Join_Control= No}', "");
    Expect(1, 8205, '\p{^Join_Control= No}', "");
    Expect(1, 8205, '\P{Join_Control= No}', "");
    Expect(0, 8205, '\P{^Join_Control= No}', "");
    Error('\p{Join_C=/a/_N}');
    Error('\P{Join_C=/a/_N}');
    Expect(1, 8206, '\p{Join_C=n}', "");
    Expect(0, 8206, '\p{^Join_C=n}', "");
    Expect(0, 8206, '\P{Join_C=n}', "");
    Expect(1, 8206, '\P{^Join_C=n}', "");
    Expect(0, 8205, '\p{Join_C=n}', "");
    Expect(1, 8205, '\p{^Join_C=n}', "");
    Expect(1, 8205, '\P{Join_C=n}', "");
    Expect(0, 8205, '\P{^Join_C=n}', "");
    Expect(1, 8206, '\p{Join_C=-N}', "");
    Expect(0, 8206, '\p{^Join_C=-N}', "");
    Expect(0, 8206, '\P{Join_C=-N}', "");
    Expect(1, 8206, '\P{^Join_C=-N}', "");
    Expect(0, 8205, '\p{Join_C=-N}', "");
    Expect(1, 8205, '\p{^Join_C=-N}', "");
    Expect(1, 8205, '\P{Join_C=-N}', "");
    Expect(0, 8205, '\P{^Join_C=-N}', "");
    Error('\p{Is_Join_Control= -F/a/}');
    Error('\P{Is_Join_Control= -F/a/}');
    Expect(1, 8206, '\p{Is_Join_Control=f}', "");
    Expect(0, 8206, '\p{^Is_Join_Control=f}', "");
    Expect(0, 8206, '\P{Is_Join_Control=f}', "");
    Expect(1, 8206, '\P{^Is_Join_Control=f}', "");
    Expect(0, 8205, '\p{Is_Join_Control=f}', "");
    Expect(1, 8205, '\p{^Is_Join_Control=f}', "");
    Expect(1, 8205, '\P{Is_Join_Control=f}', "");
    Expect(0, 8205, '\P{^Is_Join_Control=f}', "");
    Expect(1, 8206, '\p{Is_Join_Control=--F}', "");
    Expect(0, 8206, '\p{^Is_Join_Control=--F}', "");
    Expect(0, 8206, '\P{Is_Join_Control=--F}', "");
    Expect(1, 8206, '\P{^Is_Join_Control=--F}', "");
    Expect(0, 8205, '\p{Is_Join_Control=--F}', "");
    Expect(1, 8205, '\p{^Is_Join_Control=--F}', "");
    Expect(1, 8205, '\P{Is_Join_Control=--F}', "");
    Expect(0, 8205, '\P{^Is_Join_Control=--F}', "");
    Error('\p{Is_Join_C=- False/a/}');
    Error('\P{Is_Join_C=- False/a/}');
    Expect(1, 8206, '\p{Is_Join_C=false}', "");
    Expect(0, 8206, '\p{^Is_Join_C=false}', "");
    Expect(0, 8206, '\P{Is_Join_C=false}', "");
    Expect(1, 8206, '\P{^Is_Join_C=false}', "");
    Expect(0, 8205, '\p{Is_Join_C=false}', "");
    Expect(1, 8205, '\p{^Is_Join_C=false}', "");
    Expect(1, 8205, '\P{Is_Join_C=false}', "");
    Expect(0, 8205, '\P{^Is_Join_C=false}', "");
    Expect(1, 8206, '\p{Is_Join_C= 	FALSE}', "");
    Expect(0, 8206, '\p{^Is_Join_C= 	FALSE}', "");
    Expect(0, 8206, '\P{Is_Join_C= 	FALSE}', "");
    Expect(1, 8206, '\P{^Is_Join_C= 	FALSE}', "");
    Expect(0, 8205, '\p{Is_Join_C= 	FALSE}', "");
    Expect(1, 8205, '\p{^Is_Join_C= 	FALSE}', "");
    Expect(1, 8205, '\P{Is_Join_C= 	FALSE}', "");
    Expect(0, 8205, '\P{^Is_Join_C= 	FALSE}', "");
    Error('\p{Join_Control=	_yes/a/}');
    Error('\P{Join_Control=	_yes/a/}');
    Expect(1, 8205, '\p{Join_Control=yes}', "");
    Expect(0, 8205, '\p{^Join_Control=yes}', "");
    Expect(0, 8205, '\P{Join_Control=yes}', "");
    Expect(1, 8205, '\P{^Join_Control=yes}', "");
    Expect(0, 8206, '\p{Join_Control=yes}', "");
    Expect(1, 8206, '\p{^Join_Control=yes}', "");
    Expect(1, 8206, '\P{Join_Control=yes}', "");
    Expect(0, 8206, '\P{^Join_Control=yes}', "");
    Expect(1, 8205, '\p{Join_Control=	_yes}', "");
    Expect(0, 8205, '\p{^Join_Control=	_yes}', "");
    Expect(0, 8205, '\P{Join_Control=	_yes}', "");
    Expect(1, 8205, '\P{^Join_Control=	_yes}', "");
    Expect(0, 8206, '\p{Join_Control=	_yes}', "");
    Expect(1, 8206, '\p{^Join_Control=	_yes}', "");
    Expect(1, 8206, '\P{Join_Control=	_yes}', "");
    Expect(0, 8206, '\P{^Join_Control=	_yes}', "");
    Error('\p{Join_C= y:=}');
    Error('\P{Join_C= y:=}');
    Expect(1, 8205, '\p{Join_C:y}', "");
    Expect(0, 8205, '\p{^Join_C:y}', "");
    Expect(0, 8205, '\P{Join_C:y}', "");
    Expect(1, 8205, '\P{^Join_C:y}', "");
    Expect(0, 8206, '\p{Join_C:y}', "");
    Expect(1, 8206, '\p{^Join_C:y}', "");
    Expect(1, 8206, '\P{Join_C:y}', "");
    Expect(0, 8206, '\P{^Join_C:y}', "");
    Expect(1, 8205, '\p{Join_C=	_Y}', "");
    Expect(0, 8205, '\p{^Join_C=	_Y}', "");
    Expect(0, 8205, '\P{Join_C=	_Y}', "");
    Expect(1, 8205, '\P{^Join_C=	_Y}', "");
    Expect(0, 8206, '\p{Join_C=	_Y}', "");
    Expect(1, 8206, '\p{^Join_C=	_Y}', "");
    Expect(1, 8206, '\P{Join_C=	_Y}', "");
    Expect(0, 8206, '\P{^Join_C=	_Y}', "");
    Error('\p{Is_Join_Control=/a/T}');
    Error('\P{Is_Join_Control=/a/T}');
    Expect(1, 8205, '\p{Is_Join_Control:	t}', "");
    Expect(0, 8205, '\p{^Is_Join_Control:	t}', "");
    Expect(0, 8205, '\P{Is_Join_Control:	t}', "");
    Expect(1, 8205, '\P{^Is_Join_Control:	t}', "");
    Expect(0, 8206, '\p{Is_Join_Control:	t}', "");
    Expect(1, 8206, '\p{^Is_Join_Control:	t}', "");
    Expect(1, 8206, '\P{Is_Join_Control:	t}', "");
    Expect(0, 8206, '\P{^Is_Join_Control:	t}', "");
    Expect(1, 8205, '\p{Is_Join_Control=_ T}', "");
    Expect(0, 8205, '\p{^Is_Join_Control=_ T}', "");
    Expect(0, 8205, '\P{Is_Join_Control=_ T}', "");
    Expect(1, 8205, '\P{^Is_Join_Control=_ T}', "");
    Expect(0, 8206, '\p{Is_Join_Control=_ T}', "");
    Expect(1, 8206, '\p{^Is_Join_Control=_ T}', "");
    Expect(1, 8206, '\P{Is_Join_Control=_ T}', "");
    Expect(0, 8206, '\P{^Is_Join_Control=_ T}', "");
    Error('\p{Is_Join_C=/a/--True}');
    Error('\P{Is_Join_C=/a/--True}');
    Expect(1, 8205, '\p{Is_Join_C=true}', "");
    Expect(0, 8205, '\p{^Is_Join_C=true}', "");
    Expect(0, 8205, '\P{Is_Join_C=true}', "");
    Expect(1, 8205, '\P{^Is_Join_C=true}', "");
    Expect(0, 8206, '\p{Is_Join_C=true}', "");
    Expect(1, 8206, '\p{^Is_Join_C=true}', "");
    Expect(1, 8206, '\P{Is_Join_C=true}', "");
    Expect(0, 8206, '\P{^Is_Join_C=true}', "");
    Expect(1, 8205, '\p{Is_Join_C= TRUE}', "");
    Expect(0, 8205, '\p{^Is_Join_C= TRUE}', "");
    Expect(0, 8205, '\P{Is_Join_C= TRUE}', "");
    Expect(1, 8205, '\P{^Is_Join_C= TRUE}', "");
    Expect(0, 8206, '\p{Is_Join_C= TRUE}', "");
    Expect(1, 8206, '\p{^Is_Join_C= TRUE}', "");
    Expect(1, 8206, '\P{Is_Join_C= TRUE}', "");
    Expect(0, 8206, '\P{^Is_Join_C= TRUE}', "");
    Error('\p{jamoshortname}');
    Error('\P{jamoshortname}');
    Error('\p{jsn}');
    Error('\P{jsn}');
    Error('\p{Jamo_Short_Name:   A}');
    Error('\P{Jamo_Short_Name:   A}');
    Error('\p{JSN=A}');
    Error('\P{JSN=A}');
    Error('\p{Is_Jamo_Short_Name=A}');
    Error('\P{Is_Jamo_Short_Name=A}');
    Error('\p{Is_JSN=A}');
    Error('\P{Is_JSN=A}');
    Error('\p{Jamo_Short_Name=AE}');
    Error('\P{Jamo_Short_Name=AE}');
    Error('\p{JSN:   AE}');
    Error('\P{JSN:   AE}');
    Error('\p{Is_Jamo_Short_Name=AE}');
    Error('\P{Is_Jamo_Short_Name=AE}');
    Error('\p{Is_JSN:AE}');
    Error('\P{Is_JSN:AE}');
    Error('\p{Jamo_Short_Name=B}');
    Error('\P{Jamo_Short_Name=B}');
    Error('\p{JSN=B}');
    Error('\P{JSN=B}');
    Error('\p{Is_Jamo_Short_Name=B}');
    Error('\P{Is_Jamo_Short_Name=B}');
    Error('\p{Is_JSN=B}');
    Error('\P{Is_JSN=B}');
    Error('\p{Jamo_Short_Name=BB}');
    Error('\P{Jamo_Short_Name=BB}');
    Error('\p{JSN=BB}');
    Error('\P{JSN=BB}');
    Error('\p{Is_Jamo_Short_Name=BB}');
    Error('\P{Is_Jamo_Short_Name=BB}');
    Error('\p{Is_JSN=BB}');
    Error('\P{Is_JSN=BB}');
    Error('\p{Jamo_Short_Name:	BS}');
    Error('\P{Jamo_Short_Name:	BS}');
    Error('\p{JSN=BS}');
    Error('\P{JSN=BS}');
    Error('\p{Is_Jamo_Short_Name=BS}');
    Error('\P{Is_Jamo_Short_Name=BS}');
    Error('\p{Is_JSN=BS}');
    Error('\P{Is_JSN=BS}');
    Error('\p{Jamo_Short_Name: C}');
    Error('\P{Jamo_Short_Name: C}');
    Error('\p{JSN=C}');
    Error('\P{JSN=C}');
    Error('\p{Is_Jamo_Short_Name=C}');
    Error('\P{Is_Jamo_Short_Name=C}');
    Error('\p{Is_JSN=C}');
    Error('\P{Is_JSN=C}');
    Error('\p{Jamo_Short_Name=D}');
    Error('\P{Jamo_Short_Name=D}');
    Error('\p{JSN=D}');
    Error('\P{JSN=D}');
    Error('\p{Is_Jamo_Short_Name:   D}');
    Error('\P{Is_Jamo_Short_Name:   D}');
    Error('\p{Is_JSN=D}');
    Error('\P{Is_JSN=D}');
    Error('\p{Jamo_Short_Name=DD}');
    Error('\P{Jamo_Short_Name=DD}');
    Error('\p{JSN=DD}');
    Error('\P{JSN=DD}');
    Error('\p{Is_Jamo_Short_Name=DD}');
    Error('\P{Is_Jamo_Short_Name=DD}');
    Error('\p{Is_JSN=DD}');
    Error('\P{Is_JSN=DD}');
    Error('\p{Jamo_Short_Name:   E}');
    Error('\P{Jamo_Short_Name:   E}');
    Error('\p{JSN=E}');
    Error('\P{JSN=E}');
    Error('\p{Is_Jamo_Short_Name:	E}');
    Error('\P{Is_Jamo_Short_Name:	E}');
    Error('\p{Is_JSN=E}');
    Error('\P{Is_JSN=E}');
    Error('\p{Jamo_Short_Name=EO}');
    Error('\P{Jamo_Short_Name=EO}');
    Error('\p{JSN=EO}');
    Error('\P{JSN=EO}');
    Error('\p{Is_Jamo_Short_Name=EO}');
    Error('\P{Is_Jamo_Short_Name=EO}');
    Error('\p{Is_JSN=EO}');
    Error('\P{Is_JSN=EO}');
    Error('\p{Jamo_Short_Name=EU}');
    Error('\P{Jamo_Short_Name=EU}');
    Error('\p{JSN=EU}');
    Error('\P{JSN=EU}');
    Error('\p{Is_Jamo_Short_Name=EU}');
    Error('\P{Is_Jamo_Short_Name=EU}');
    Error('\p{Is_JSN:	EU}');
    Error('\P{Is_JSN:	EU}');
    Error('\p{Jamo_Short_Name:G}');
    Error('\P{Jamo_Short_Name:G}');
    Error('\p{JSN:G}');
    Error('\P{JSN:G}');
    Error('\p{Is_Jamo_Short_Name=G}');
    Error('\P{Is_Jamo_Short_Name=G}');
    Error('\p{Is_JSN=G}');
    Error('\P{Is_JSN=G}');
    Error('\p{Jamo_Short_Name=GG}');
    Error('\P{Jamo_Short_Name=GG}');
    Error('\p{JSN: GG}');
    Error('\P{JSN: GG}');
    Error('\p{Is_Jamo_Short_Name=GG}');
    Error('\P{Is_Jamo_Short_Name=GG}');
    Error('\p{Is_JSN=GG}');
    Error('\P{Is_JSN=GG}');
    Error('\p{Jamo_Short_Name=GS}');
    Error('\P{Jamo_Short_Name=GS}');
    Error('\p{JSN:GS}');
    Error('\P{JSN:GS}');
    Error('\p{Is_Jamo_Short_Name=GS}');
    Error('\P{Is_Jamo_Short_Name=GS}');
    Error('\p{Is_JSN=GS}');
    Error('\P{Is_JSN=GS}');
    Error('\p{Jamo_Short_Name=H}');
    Error('\P{Jamo_Short_Name=H}');
    Error('\p{JSN=H}');
    Error('\P{JSN=H}');
    Error('\p{Is_Jamo_Short_Name=H}');
    Error('\P{Is_Jamo_Short_Name=H}');
    Error('\p{Is_JSN=H}');
    Error('\P{Is_JSN=H}');
    Error('\p{Jamo_Short_Name=I}');
    Error('\P{Jamo_Short_Name=I}');
    Error('\p{JSN:I}');
    Error('\P{JSN:I}');
    Error('\p{Is_Jamo_Short_Name=I}');
    Error('\P{Is_Jamo_Short_Name=I}');
    Error('\p{Is_JSN=I}');
    Error('\P{Is_JSN=I}');
    Error('\p{Jamo_Short_Name=J}');
    Error('\P{Jamo_Short_Name=J}');
    Error('\p{JSN=J}');
    Error('\P{JSN=J}');
    Error('\p{Is_Jamo_Short_Name=J}');
    Error('\P{Is_Jamo_Short_Name=J}');
    Error('\p{Is_JSN=J}');
    Error('\P{Is_JSN=J}');
    Error('\p{Jamo_Short_Name=JJ}');
    Error('\P{Jamo_Short_Name=JJ}');
    Error('\p{JSN=JJ}');
    Error('\P{JSN=JJ}');
    Error('\p{Is_Jamo_Short_Name=JJ}');
    Error('\P{Is_Jamo_Short_Name=JJ}');
    Error('\p{Is_JSN=JJ}');
    Error('\P{Is_JSN=JJ}');
    Error('\p{Jamo_Short_Name=K}');
    Error('\P{Jamo_Short_Name=K}');
    Error('\p{JSN=K}');
    Error('\P{JSN=K}');
    Error('\p{Is_Jamo_Short_Name=K}');
    Error('\P{Is_Jamo_Short_Name=K}');
    Error('\p{Is_JSN=K}');
    Error('\P{Is_JSN=K}');
    Error('\p{Jamo_Short_Name: L}');
    Error('\P{Jamo_Short_Name: L}');
    Error('\p{JSN=L}');
    Error('\P{JSN=L}');
    Error('\p{Is_Jamo_Short_Name=L}');
    Error('\P{Is_Jamo_Short_Name=L}');
    Error('\p{Is_JSN=L}');
    Error('\P{Is_JSN=L}');
    Error('\p{Jamo_Short_Name=LB}');
    Error('\P{Jamo_Short_Name=LB}');
    Error('\p{JSN=LB}');
    Error('\P{JSN=LB}');
    Error('\p{Is_Jamo_Short_Name=LB}');
    Error('\P{Is_Jamo_Short_Name=LB}');
    Error('\p{Is_JSN=LB}');
    Error('\P{Is_JSN=LB}');
    Error('\p{Jamo_Short_Name=LG}');
    Error('\P{Jamo_Short_Name=LG}');
    Error('\p{JSN=LG}');
    Error('\P{JSN=LG}');
    Error('\p{Is_Jamo_Short_Name=LG}');
    Error('\P{Is_Jamo_Short_Name=LG}');
    Error('\p{Is_JSN=LG}');
    Error('\P{Is_JSN=LG}');
    Error('\p{Jamo_Short_Name=LH}');
    Error('\P{Jamo_Short_Name=LH}');
    Error('\p{JSN=LH}');
    Error('\P{JSN=LH}');
    Error('\p{Is_Jamo_Short_Name=LH}');
    Error('\P{Is_Jamo_Short_Name=LH}');
    Error('\p{Is_JSN=LH}');
    Error('\P{Is_JSN=LH}');
    Error('\p{Jamo_Short_Name=LM}');
    Error('\P{Jamo_Short_Name=LM}');
    Error('\p{JSN=LM}');
    Error('\P{JSN=LM}');
    Error('\p{Is_Jamo_Short_Name=LM}');
    Error('\P{Is_Jamo_Short_Name=LM}');
    Error('\p{Is_JSN=LM}');
    Error('\P{Is_JSN=LM}');
    Error('\p{Jamo_Short_Name=LP}');
    Error('\P{Jamo_Short_Name=LP}');
    Error('\p{JSN=LP}');
    Error('\P{JSN=LP}');
    Error('\p{Is_Jamo_Short_Name=LP}');
    Error('\P{Is_Jamo_Short_Name=LP}');
    Error('\p{Is_JSN=LP}');
    Error('\P{Is_JSN=LP}');
    Error('\p{Jamo_Short_Name=LS}');
    Error('\P{Jamo_Short_Name=LS}');
    Error('\p{JSN=LS}');
    Error('\P{JSN=LS}');
    Error('\p{Is_Jamo_Short_Name:   LS}');
    Error('\P{Is_Jamo_Short_Name:   LS}');
    Error('\p{Is_JSN=LS}');
    Error('\P{Is_JSN=LS}');
    Error('\p{Jamo_Short_Name=LT}');
    Error('\P{Jamo_Short_Name=LT}');
    Error('\p{JSN=LT}');
    Error('\P{JSN=LT}');
    Error('\p{Is_Jamo_Short_Name=LT}');
    Error('\P{Is_Jamo_Short_Name=LT}');
    Error('\p{Is_JSN:   LT}');
    Error('\P{Is_JSN:   LT}');
    Error('\p{Jamo_Short_Name=M}');
    Error('\P{Jamo_Short_Name=M}');
    Error('\p{JSN=M}');
    Error('\P{JSN=M}');
    Error('\p{Is_Jamo_Short_Name=M}');
    Error('\P{Is_Jamo_Short_Name=M}');
    Error('\p{Is_JSN=M}');
    Error('\P{Is_JSN=M}');
    Error('\p{Jamo_Short_Name=N}');
    Error('\P{Jamo_Short_Name=N}');
    Error('\p{JSN=N}');
    Error('\P{JSN=N}');
    Error('\p{Is_Jamo_Short_Name=N}');
    Error('\P{Is_Jamo_Short_Name=N}');
    Error('\p{Is_JSN=N}');
    Error('\P{Is_JSN=N}');
    Error('\p{Jamo_Short_Name:NG}');
    Error('\P{Jamo_Short_Name:NG}');
    Error('\p{JSN=NG}');
    Error('\P{JSN=NG}');
    Error('\p{Is_Jamo_Short_Name=NG}');
    Error('\P{Is_Jamo_Short_Name=NG}');
    Error('\p{Is_JSN=NG}');
    Error('\P{Is_JSN=NG}');
    Error('\p{Jamo_Short_Name=NH}');
    Error('\P{Jamo_Short_Name=NH}');
    Error('\p{JSN=NH}');
    Error('\P{JSN=NH}');
    Error('\p{Is_Jamo_Short_Name: NH}');
    Error('\P{Is_Jamo_Short_Name: NH}');
    Error('\p{Is_JSN=NH}');
    Error('\P{Is_JSN=NH}');
    Error('\p{Jamo_Short_Name=NJ}');
    Error('\P{Jamo_Short_Name=NJ}');
    Error('\p{JSN=NJ}');
    Error('\P{JSN=NJ}');
    Error('\p{Is_Jamo_Short_Name=NJ}');
    Error('\P{Is_Jamo_Short_Name=NJ}');
    Error('\p{Is_JSN=NJ}');
    Error('\P{Is_JSN=NJ}');
    Error('\p{Jamo_Short_Name=O}');
    Error('\P{Jamo_Short_Name=O}');
    Error('\p{JSN=O}');
    Error('\P{JSN=O}');
    Error('\p{Is_Jamo_Short_Name=O}');
    Error('\P{Is_Jamo_Short_Name=O}');
    Error('\p{Is_JSN=O}');
    Error('\P{Is_JSN=O}');
    Error('\p{Jamo_Short_Name=OE}');
    Error('\P{Jamo_Short_Name=OE}');
    Error('\p{JSN=OE}');
    Error('\P{JSN=OE}');
    Error('\p{Is_Jamo_Short_Name=OE}');
    Error('\P{Is_Jamo_Short_Name=OE}');
    Error('\p{Is_JSN=OE}');
    Error('\P{Is_JSN=OE}');
    Error('\p{Jamo_Short_Name=P}');
    Error('\P{Jamo_Short_Name=P}');
    Error('\p{JSN=P}');
    Error('\P{JSN=P}');
    Error('\p{Is_Jamo_Short_Name:	P}');
    Error('\P{Is_Jamo_Short_Name:	P}');
    Error('\p{Is_JSN=P}');
    Error('\P{Is_JSN=P}');
    Error('\p{Jamo_Short_Name=R}');
    Error('\P{Jamo_Short_Name=R}');
    Error('\p{JSN=R}');
    Error('\P{JSN=R}');
    Error('\p{Is_Jamo_Short_Name=R}');
    Error('\P{Is_Jamo_Short_Name=R}');
    Error('\p{Is_JSN=R}');
    Error('\P{Is_JSN=R}');
    Error('\p{Jamo_Short_Name=S}');
    Error('\P{Jamo_Short_Name=S}');
    Error('\p{JSN=S}');
    Error('\P{JSN=S}');
    Error('\p{Is_Jamo_Short_Name=S}');
    Error('\P{Is_Jamo_Short_Name=S}');
    Error('\p{Is_JSN=S}');
    Error('\P{Is_JSN=S}');
    Error('\p{Jamo_Short_Name=SS}');
    Error('\P{Jamo_Short_Name=SS}');
    Error('\p{JSN: SS}');
    Error('\P{JSN: SS}');
    Error('\p{Is_Jamo_Short_Name=SS}');
    Error('\P{Is_Jamo_Short_Name=SS}');
    Error('\p{Is_JSN=SS}');
    Error('\P{Is_JSN=SS}');
    Error('\p{Jamo_Short_Name=T}');
    Error('\P{Jamo_Short_Name=T}');
    Error('\p{JSN=T}');
    Error('\P{JSN=T}');
    Error('\p{Is_Jamo_Short_Name=T}');
    Error('\P{Is_Jamo_Short_Name=T}');
    Error('\p{Is_JSN=T}');
    Error('\P{Is_JSN=T}');
    Error('\p{Jamo_Short_Name=U}');
    Error('\P{Jamo_Short_Name=U}');
    Error('\p{JSN=U}');
    Error('\P{JSN=U}');
    Error('\p{Is_Jamo_Short_Name=U}');
    Error('\P{Is_Jamo_Short_Name=U}');
    Error('\p{Is_JSN=U}');
    Error('\P{Is_JSN=U}');
    Error('\p{Jamo_Short_Name=WA}');
    Error('\P{Jamo_Short_Name=WA}');
    Error('\p{JSN=WA}');
    Error('\P{JSN=WA}');
    Error('\p{Is_Jamo_Short_Name:	WA}');
    Error('\P{Is_Jamo_Short_Name:	WA}');
    Error('\p{Is_JSN=WA}');
    Error('\P{Is_JSN=WA}');
    Error('\p{Jamo_Short_Name=WAE}');
    Error('\P{Jamo_Short_Name=WAE}');
    Error('\p{JSN:WAE}');
    Error('\P{JSN:WAE}');
    Error('\p{Is_Jamo_Short_Name=WAE}');
    Error('\P{Is_Jamo_Short_Name=WAE}');
    Error('\p{Is_JSN=WAE}');
    Error('\P{Is_JSN=WAE}');
    Error('\p{Jamo_Short_Name=WE}');
    Error('\P{Jamo_Short_Name=WE}');
    Error('\p{JSN=WE}');
    Error('\P{JSN=WE}');
    Error('\p{Is_Jamo_Short_Name=WE}');
    Error('\P{Is_Jamo_Short_Name=WE}');
    Error('\p{Is_JSN=WE}');
    Error('\P{Is_JSN=WE}');
    Error('\p{Jamo_Short_Name=WEO}');
    Error('\P{Jamo_Short_Name=WEO}');
    Error('\p{JSN=WEO}');
    Error('\P{JSN=WEO}');
    Error('\p{Is_Jamo_Short_Name=WEO}');
    Error('\P{Is_Jamo_Short_Name=WEO}');
    Error('\p{Is_JSN=WEO}');
    Error('\P{Is_JSN=WEO}');
    Error('\p{Jamo_Short_Name=WI}');
    Error('\P{Jamo_Short_Name=WI}');
    Error('\p{JSN=WI}');
    Error('\P{JSN=WI}');
    Error('\p{Is_Jamo_Short_Name=WI}');
    Error('\P{Is_Jamo_Short_Name=WI}');
    Error('\p{Is_JSN:WI}');
    Error('\P{Is_JSN:WI}');
    Error('\p{Jamo_Short_Name=YA}');
    Error('\P{Jamo_Short_Name=YA}');
    Error('\p{JSN=YA}');
    Error('\P{JSN=YA}');
    Error('\p{Is_Jamo_Short_Name=YA}');
    Error('\P{Is_Jamo_Short_Name=YA}');
    Error('\p{Is_JSN=YA}');
    Error('\P{Is_JSN=YA}');
    Error('\p{Jamo_Short_Name=YAE}');
    Error('\P{Jamo_Short_Name=YAE}');
    Error('\p{JSN=YAE}');
    Error('\P{JSN=YAE}');
    Error('\p{Is_Jamo_Short_Name=YAE}');
    Error('\P{Is_Jamo_Short_Name=YAE}');
    Error('\p{Is_JSN=YAE}');
    Error('\P{Is_JSN=YAE}');
    Error('\p{Jamo_Short_Name=YE}');
    Error('\P{Jamo_Short_Name=YE}');
    Error('\p{JSN=YE}');
    Error('\P{JSN=YE}');
    Error('\p{Is_Jamo_Short_Name=YE}');
    Error('\P{Is_Jamo_Short_Name=YE}');
    Error('\p{Is_JSN=YE}');
    Error('\P{Is_JSN=YE}');
    Error('\p{Jamo_Short_Name=YEO}');
    Error('\P{Jamo_Short_Name=YEO}');
    Error('\p{JSN=YEO}');
    Error('\P{JSN=YEO}');
    Error('\p{Is_Jamo_Short_Name=YEO}');
    Error('\P{Is_Jamo_Short_Name=YEO}');
    Error('\p{Is_JSN:	YEO}');
    Error('\P{Is_JSN:	YEO}');
    Error('\p{Jamo_Short_Name=YI}');
    Error('\P{Jamo_Short_Name=YI}');
    Error('\p{JSN=YI}');
    Error('\P{JSN=YI}');
    Error('\p{Is_Jamo_Short_Name=YI}');
    Error('\P{Is_Jamo_Short_Name=YI}');
    Error('\p{Is_JSN:YI}');
    Error('\P{Is_JSN:YI}');
    Error('\p{Jamo_Short_Name:	YO}');
    Error('\P{Jamo_Short_Name:	YO}');
    Error('\p{JSN: YO}');
    Error('\P{JSN: YO}');
    Error('\p{Is_Jamo_Short_Name=YO}');
    Error('\P{Is_Jamo_Short_Name=YO}');
    Error('\p{Is_JSN=YO}');
    Error('\P{Is_JSN=YO}');
    Error('\p{Jamo_Short_Name=YU}');
    Error('\P{Jamo_Short_Name=YU}');
    Error('\p{JSN=YU}');
    Error('\P{JSN=YU}');
    Error('\p{Is_Jamo_Short_Name=YU}');
    Error('\P{Is_Jamo_Short_Name=YU}');
    Error('\p{Is_JSN=YU}');
    Error('\P{Is_JSN=YU}');
    Error('\p{joiningtype}');
    Error('\P{joiningtype}');
    Error('\p{jt}');
    Error('\P{jt}');
    Error('\p{Joining_Type=/a/_join_CAUSING}');
    Error('\P{Joining_Type=/a/_join_CAUSING}');
    Expect(1, 8205, '\p{Joining_Type=joincausing}', "");
    Expect(0, 8205, '\p{^Joining_Type=joincausing}', "");
    Expect(0, 8205, '\P{Joining_Type=joincausing}', "");
    Expect(1, 8205, '\P{^Joining_Type=joincausing}', "");
    Expect(0, 8206, '\p{Joining_Type=joincausing}', "");
    Expect(1, 8206, '\p{^Joining_Type=joincausing}', "");
    Expect(1, 8206, '\P{Joining_Type=joincausing}', "");
    Expect(0, 8206, '\P{^Joining_Type=joincausing}', "");
    Expect(1, 8205, '\p{Joining_Type= join_CAUSING}', "");
    Expect(0, 8205, '\p{^Joining_Type= join_CAUSING}', "");
    Expect(0, 8205, '\P{Joining_Type= join_CAUSING}', "");
    Expect(1, 8205, '\P{^Joining_Type= join_CAUSING}', "");
    Expect(0, 8206, '\p{Joining_Type= join_CAUSING}', "");
    Expect(1, 8206, '\p{^Joining_Type= join_CAUSING}', "");
    Expect(1, 8206, '\P{Joining_Type= join_CAUSING}', "");
    Expect(0, 8206, '\P{^Joining_Type= join_CAUSING}', "");
    Error('\p{Jt=:=	c}');
    Error('\P{Jt=:=	c}');
    Expect(1, 8205, '\p{Jt=c}', "");
    Expect(0, 8205, '\p{^Jt=c}', "");
    Expect(0, 8205, '\P{Jt=c}', "");
    Expect(1, 8205, '\P{^Jt=c}', "");
    Expect(0, 8206, '\p{Jt=c}', "");
    Expect(1, 8206, '\p{^Jt=c}', "");
    Expect(1, 8206, '\P{Jt=c}', "");
    Expect(0, 8206, '\P{^Jt=c}', "");
    Expect(1, 8205, '\p{Jt=		c}', "");
    Expect(0, 8205, '\p{^Jt=		c}', "");
    Expect(0, 8205, '\P{Jt=		c}', "");
    Expect(1, 8205, '\P{^Jt=		c}', "");
    Expect(0, 8206, '\p{Jt=		c}', "");
    Expect(1, 8206, '\p{^Jt=		c}', "");
    Expect(1, 8206, '\P{Jt=		c}', "");
    Expect(0, 8206, '\P{^Jt=		c}', "");
    Error('\p{Is_Joining_Type:__join_causing/a/}');
    Error('\P{Is_Joining_Type:__join_causing/a/}');
    Expect(1, 8205, '\p{Is_Joining_Type=joincausing}', "");
    Expect(0, 8205, '\p{^Is_Joining_Type=joincausing}', "");
    Expect(0, 8205, '\P{Is_Joining_Type=joincausing}', "");
    Expect(1, 8205, '\P{^Is_Joining_Type=joincausing}', "");
    Expect(0, 8206, '\p{Is_Joining_Type=joincausing}', "");
    Expect(1, 8206, '\p{^Is_Joining_Type=joincausing}', "");
    Expect(1, 8206, '\P{Is_Joining_Type=joincausing}', "");
    Expect(0, 8206, '\P{^Is_Joining_Type=joincausing}', "");
    Expect(1, 8205, '\p{Is_Joining_Type: Join_Causing}', "");
    Expect(0, 8205, '\p{^Is_Joining_Type: Join_Causing}', "");
    Expect(0, 8205, '\P{Is_Joining_Type: Join_Causing}', "");
    Expect(1, 8205, '\P{^Is_Joining_Type: Join_Causing}', "");
    Expect(0, 8206, '\p{Is_Joining_Type: Join_Causing}', "");
    Expect(1, 8206, '\p{^Is_Joining_Type: Join_Causing}', "");
    Expect(1, 8206, '\P{Is_Joining_Type: Join_Causing}', "");
    Expect(0, 8206, '\P{^Is_Joining_Type: Join_Causing}', "");
    Error('\p{Is_Jt=_:=C}');
    Error('\P{Is_Jt=_:=C}');
    Expect(1, 8205, '\p{Is_Jt=c}', "");
    Expect(0, 8205, '\p{^Is_Jt=c}', "");
    Expect(0, 8205, '\P{Is_Jt=c}', "");
    Expect(1, 8205, '\P{^Is_Jt=c}', "");
    Expect(0, 8206, '\p{Is_Jt=c}', "");
    Expect(1, 8206, '\p{^Is_Jt=c}', "");
    Expect(1, 8206, '\P{Is_Jt=c}', "");
    Expect(0, 8206, '\P{^Is_Jt=c}', "");
    Expect(1, 8205, '\p{Is_Jt=_c}', "");
    Expect(0, 8205, '\p{^Is_Jt=_c}', "");
    Expect(0, 8205, '\P{Is_Jt=_c}', "");
    Expect(1, 8205, '\P{^Is_Jt=_c}', "");
    Expect(0, 8206, '\p{Is_Jt=_c}', "");
    Expect(1, 8206, '\p{^Is_Jt=_c}', "");
    Expect(1, 8206, '\P{Is_Jt=_c}', "");
    Expect(0, 8206, '\P{^Is_Jt=_c}', "");
    Error('\p{Joining_Type=:=	DUAL_joining}');
    Error('\P{Joining_Type=:=	DUAL_joining}');
    Expect(1, 125251, '\p{Joining_Type=dualjoining}', "");
    Expect(0, 125251, '\p{^Joining_Type=dualjoining}', "");
    Expect(0, 125251, '\P{Joining_Type=dualjoining}', "");
    Expect(1, 125251, '\P{^Joining_Type=dualjoining}', "");
    Expect(0, 125252, '\p{Joining_Type=dualjoining}', "");
    Expect(1, 125252, '\p{^Joining_Type=dualjoining}', "");
    Expect(1, 125252, '\P{Joining_Type=dualjoining}', "");
    Expect(0, 125252, '\P{^Joining_Type=dualjoining}', "");
    Expect(1, 125251, '\p{Joining_Type=	DUAL_Joining}', "");
    Expect(0, 125251, '\p{^Joining_Type=	DUAL_Joining}', "");
    Expect(0, 125251, '\P{Joining_Type=	DUAL_Joining}', "");
    Expect(1, 125251, '\P{^Joining_Type=	DUAL_Joining}', "");
    Expect(0, 125252, '\p{Joining_Type=	DUAL_Joining}', "");
    Expect(1, 125252, '\p{^Joining_Type=	DUAL_Joining}', "");
    Expect(1, 125252, '\P{Joining_Type=	DUAL_Joining}', "");
    Expect(0, 125252, '\P{^Joining_Type=	DUAL_Joining}', "");
    Error('\p{Jt:	 /a/D}');
    Error('\P{Jt:	 /a/D}');
    Expect(1, 125251, '\p{Jt=d}', "");
    Expect(0, 125251, '\p{^Jt=d}', "");
    Expect(0, 125251, '\P{Jt=d}', "");
    Expect(1, 125251, '\P{^Jt=d}', "");
    Expect(0, 125252, '\p{Jt=d}', "");
    Expect(1, 125252, '\p{^Jt=d}', "");
    Expect(1, 125252, '\P{Jt=d}', "");
    Expect(0, 125252, '\P{^Jt=d}', "");
    Expect(1, 125251, '\p{Jt=	-d}', "");
    Expect(0, 125251, '\p{^Jt=	-d}', "");
    Expect(0, 125251, '\P{Jt=	-d}', "");
    Expect(1, 125251, '\P{^Jt=	-d}', "");
    Expect(0, 125252, '\p{Jt=	-d}', "");
    Expect(1, 125252, '\p{^Jt=	-d}', "");
    Expect(1, 125252, '\P{Jt=	-d}', "");
    Expect(0, 125252, '\P{^Jt=	-d}', "");
    Error('\p{Is_Joining_Type:-Dual_JOINING:=}');
    Error('\P{Is_Joining_Type:-Dual_JOINING:=}');
    Expect(1, 125251, '\p{Is_Joining_Type=dualjoining}', "");
    Expect(0, 125251, '\p{^Is_Joining_Type=dualjoining}', "");
    Expect(0, 125251, '\P{Is_Joining_Type=dualjoining}', "");
    Expect(1, 125251, '\P{^Is_Joining_Type=dualjoining}', "");
    Expect(0, 125252, '\p{Is_Joining_Type=dualjoining}', "");
    Expect(1, 125252, '\p{^Is_Joining_Type=dualjoining}', "");
    Expect(1, 125252, '\P{Is_Joining_Type=dualjoining}', "");
    Expect(0, 125252, '\P{^Is_Joining_Type=dualjoining}', "");
    Expect(1, 125251, '\p{Is_Joining_Type=-_DUAL_Joining}', "");
    Expect(0, 125251, '\p{^Is_Joining_Type=-_DUAL_Joining}', "");
    Expect(0, 125251, '\P{Is_Joining_Type=-_DUAL_Joining}', "");
    Expect(1, 125251, '\P{^Is_Joining_Type=-_DUAL_Joining}', "");
    Expect(0, 125252, '\p{Is_Joining_Type=-_DUAL_Joining}', "");
    Expect(1, 125252, '\p{^Is_Joining_Type=-_DUAL_Joining}', "");
    Expect(1, 125252, '\P{Is_Joining_Type=-_DUAL_Joining}', "");
    Expect(0, 125252, '\P{^Is_Joining_Type=-_DUAL_Joining}', "");
    Error('\p{Is_Jt=/a/--D}');
    Error('\P{Is_Jt=/a/--D}');
    Expect(1, 125251, '\p{Is_Jt=d}', "");
    Expect(0, 125251, '\p{^Is_Jt=d}', "");
    Expect(0, 125251, '\P{Is_Jt=d}', "");
    Expect(1, 125251, '\P{^Is_Jt=d}', "");
    Expect(0, 125252, '\p{Is_Jt=d}', "");
    Expect(1, 125252, '\p{^Is_Jt=d}', "");
    Expect(1, 125252, '\P{Is_Jt=d}', "");
    Expect(0, 125252, '\P{^Is_Jt=d}', "");
    Expect(1, 125251, '\p{Is_Jt=_D}', "");
    Expect(0, 125251, '\p{^Is_Jt=_D}', "");
    Expect(0, 125251, '\P{Is_Jt=_D}', "");
    Expect(1, 125251, '\P{^Is_Jt=_D}', "");
    Expect(0, 125252, '\p{Is_Jt=_D}', "");
    Expect(1, 125252, '\p{^Is_Jt=_D}', "");
    Expect(1, 125252, '\P{Is_Jt=_D}', "");
    Expect(0, 125252, '\P{^Is_Jt=_D}', "");
    Error('\p{Joining_Type:	:=-Left_Joining}');
    Error('\P{Joining_Type:	:=-Left_Joining}');
    Expect(1, 68311, '\p{Joining_Type=leftjoining}', "");
    Expect(0, 68311, '\p{^Joining_Type=leftjoining}', "");
    Expect(0, 68311, '\P{Joining_Type=leftjoining}', "");
    Expect(1, 68311, '\P{^Joining_Type=leftjoining}', "");
    Expect(0, 68312, '\p{Joining_Type=leftjoining}', "");
    Expect(1, 68312, '\p{^Joining_Type=leftjoining}', "");
    Expect(1, 68312, '\P{Joining_Type=leftjoining}', "");
    Expect(0, 68312, '\P{^Joining_Type=leftjoining}', "");
    Expect(1, 68311, '\p{Joining_Type=left_Joining}', "");
    Expect(0, 68311, '\p{^Joining_Type=left_Joining}', "");
    Expect(0, 68311, '\P{Joining_Type=left_Joining}', "");
    Expect(1, 68311, '\P{^Joining_Type=left_Joining}', "");
    Expect(0, 68312, '\p{Joining_Type=left_Joining}', "");
    Expect(1, 68312, '\p{^Joining_Type=left_Joining}', "");
    Expect(1, 68312, '\P{Joining_Type=left_Joining}', "");
    Expect(0, 68312, '\P{^Joining_Type=left_Joining}', "");
    Error('\p{Jt=/a/L}');
    Error('\P{Jt=/a/L}');
    Expect(1, 68311, '\p{Jt=l}', "");
    Expect(0, 68311, '\p{^Jt=l}', "");
    Expect(0, 68311, '\P{Jt=l}', "");
    Expect(1, 68311, '\P{^Jt=l}', "");
    Expect(0, 68312, '\p{Jt=l}', "");
    Expect(1, 68312, '\p{^Jt=l}', "");
    Expect(1, 68312, '\P{Jt=l}', "");
    Expect(0, 68312, '\P{^Jt=l}', "");
    Expect(1, 68311, '\p{Jt=L}', "");
    Expect(0, 68311, '\p{^Jt=L}', "");
    Expect(0, 68311, '\P{Jt=L}', "");
    Expect(1, 68311, '\P{^Jt=L}', "");
    Expect(0, 68312, '\p{Jt=L}', "");
    Expect(1, 68312, '\p{^Jt=L}', "");
    Expect(1, 68312, '\P{Jt=L}', "");
    Expect(0, 68312, '\P{^Jt=L}', "");
    Error('\p{Is_Joining_Type=_	Left_JOINING:=}');
    Error('\P{Is_Joining_Type=_	Left_JOINING:=}');
    Expect(1, 68311, '\p{Is_Joining_Type=leftjoining}', "");
    Expect(0, 68311, '\p{^Is_Joining_Type=leftjoining}', "");
    Expect(0, 68311, '\P{Is_Joining_Type=leftjoining}', "");
    Expect(1, 68311, '\P{^Is_Joining_Type=leftjoining}', "");
    Expect(0, 68312, '\p{Is_Joining_Type=leftjoining}', "");
    Expect(1, 68312, '\p{^Is_Joining_Type=leftjoining}', "");
    Expect(1, 68312, '\P{Is_Joining_Type=leftjoining}', "");
    Expect(0, 68312, '\P{^Is_Joining_Type=leftjoining}', "");
    Expect(1, 68311, '\p{Is_Joining_Type=_	Left_JOINING}', "");
    Expect(0, 68311, '\p{^Is_Joining_Type=_	Left_JOINING}', "");
    Expect(0, 68311, '\P{Is_Joining_Type=_	Left_JOINING}', "");
    Expect(1, 68311, '\P{^Is_Joining_Type=_	Left_JOINING}', "");
    Expect(0, 68312, '\p{Is_Joining_Type=_	Left_JOINING}', "");
    Expect(1, 68312, '\p{^Is_Joining_Type=_	Left_JOINING}', "");
    Expect(1, 68312, '\P{Is_Joining_Type=_	Left_JOINING}', "");
    Expect(0, 68312, '\P{^Is_Joining_Type=_	Left_JOINING}', "");
    Error('\p{Is_Jt=_ l:=}');
    Error('\P{Is_Jt=_ l:=}');
    Expect(1, 68311, '\p{Is_Jt=l}', "");
    Expect(0, 68311, '\p{^Is_Jt=l}', "");
    Expect(0, 68311, '\P{Is_Jt=l}', "");
    Expect(1, 68311, '\P{^Is_Jt=l}', "");
    Expect(0, 68312, '\p{Is_Jt=l}', "");
    Expect(1, 68312, '\p{^Is_Jt=l}', "");
    Expect(1, 68312, '\P{Is_Jt=l}', "");
    Expect(0, 68312, '\P{^Is_Jt=l}', "");
    Expect(1, 68311, '\p{Is_Jt=-L}', "");
    Expect(0, 68311, '\p{^Is_Jt=-L}', "");
    Expect(0, 68311, '\P{Is_Jt=-L}', "");
    Expect(1, 68311, '\P{^Is_Jt=-L}', "");
    Expect(0, 68312, '\p{Is_Jt=-L}', "");
    Expect(1, 68312, '\p{^Is_Jt=-L}', "");
    Expect(1, 68312, '\P{Is_Jt=-L}', "");
    Expect(0, 68312, '\P{^Is_Jt=-L}', "");
    Error('\p{Joining_Type=_Right_joining:=}');
    Error('\P{Joining_Type=_Right_joining:=}');
    Expect(1, 68524, '\p{Joining_Type=rightjoining}', "");
    Expect(0, 68524, '\p{^Joining_Type=rightjoining}', "");
    Expect(0, 68524, '\P{Joining_Type=rightjoining}', "");
    Expect(1, 68524, '\P{^Joining_Type=rightjoining}', "");
    Expect(0, 68525, '\p{Joining_Type=rightjoining}', "");
    Expect(1, 68525, '\p{^Joining_Type=rightjoining}', "");
    Expect(1, 68525, '\P{Joining_Type=rightjoining}', "");
    Expect(0, 68525, '\P{^Joining_Type=rightjoining}', "");
    Expect(1, 68524, '\p{Joining_Type=_-Right_Joining}', "");
    Expect(0, 68524, '\p{^Joining_Type=_-Right_Joining}', "");
    Expect(0, 68524, '\P{Joining_Type=_-Right_Joining}', "");
    Expect(1, 68524, '\P{^Joining_Type=_-Right_Joining}', "");
    Expect(0, 68525, '\p{Joining_Type=_-Right_Joining}', "");
    Expect(1, 68525, '\p{^Joining_Type=_-Right_Joining}', "");
    Expect(1, 68525, '\P{Joining_Type=_-Right_Joining}', "");
    Expect(0, 68525, '\P{^Joining_Type=_-Right_Joining}', "");
    Error('\p{Jt=/a/	R}');
    Error('\P{Jt=/a/	R}');
    Expect(1, 68524, '\p{Jt=r}', "");
    Expect(0, 68524, '\p{^Jt=r}', "");
    Expect(0, 68524, '\P{Jt=r}', "");
    Expect(1, 68524, '\P{^Jt=r}', "");
    Expect(0, 68525, '\p{Jt=r}', "");
    Expect(1, 68525, '\p{^Jt=r}', "");
    Expect(1, 68525, '\P{Jt=r}', "");
    Expect(0, 68525, '\P{^Jt=r}', "");
    Expect(1, 68524, '\p{Jt=_R}', "");
    Expect(0, 68524, '\p{^Jt=_R}', "");
    Expect(0, 68524, '\P{Jt=_R}', "");
    Expect(1, 68524, '\P{^Jt=_R}', "");
    Expect(0, 68525, '\p{Jt=_R}', "");
    Expect(1, 68525, '\p{^Jt=_R}', "");
    Expect(1, 68525, '\P{Jt=_R}', "");
    Expect(0, 68525, '\P{^Jt=_R}', "");
    Error('\p{Is_Joining_Type=:= -right_Joining}');
    Error('\P{Is_Joining_Type=:= -right_Joining}');
    Expect(1, 68524, '\p{Is_Joining_Type=rightjoining}', "");
    Expect(0, 68524, '\p{^Is_Joining_Type=rightjoining}', "");
    Expect(0, 68524, '\P{Is_Joining_Type=rightjoining}', "");
    Expect(1, 68524, '\P{^Is_Joining_Type=rightjoining}', "");
    Expect(0, 68525, '\p{Is_Joining_Type=rightjoining}', "");
    Expect(1, 68525, '\p{^Is_Joining_Type=rightjoining}', "");
    Expect(1, 68525, '\P{Is_Joining_Type=rightjoining}', "");
    Expect(0, 68525, '\P{^Is_Joining_Type=rightjoining}', "");
    Expect(1, 68524, '\p{Is_Joining_Type=-Right_Joining}', "");
    Expect(0, 68524, '\p{^Is_Joining_Type=-Right_Joining}', "");
    Expect(0, 68524, '\P{Is_Joining_Type=-Right_Joining}', "");
    Expect(1, 68524, '\P{^Is_Joining_Type=-Right_Joining}', "");
    Expect(0, 68525, '\p{Is_Joining_Type=-Right_Joining}', "");
    Expect(1, 68525, '\p{^Is_Joining_Type=-Right_Joining}', "");
    Expect(1, 68525, '\P{Is_Joining_Type=-Right_Joining}', "");
    Expect(0, 68525, '\P{^Is_Joining_Type=-Right_Joining}', "");
    Error('\p{Is_Jt=	 R:=}');
    Error('\P{Is_Jt=	 R:=}');
    Expect(1, 68524, '\p{Is_Jt=r}', "");
    Expect(0, 68524, '\p{^Is_Jt=r}', "");
    Expect(0, 68524, '\P{Is_Jt=r}', "");
    Expect(1, 68524, '\P{^Is_Jt=r}', "");
    Expect(0, 68525, '\p{Is_Jt=r}', "");
    Expect(1, 68525, '\p{^Is_Jt=r}', "");
    Expect(1, 68525, '\P{Is_Jt=r}', "");
    Expect(0, 68525, '\P{^Is_Jt=r}', "");
    Expect(1, 68524, '\p{Is_Jt=_	R}', "");
    Expect(0, 68524, '\p{^Is_Jt=_	R}', "");
    Expect(0, 68524, '\P{Is_Jt=_	R}', "");
    Expect(1, 68524, '\P{^Is_Jt=_	R}', "");
    Expect(0, 68525, '\p{Is_Jt=_	R}', "");
    Expect(1, 68525, '\p{^Is_Jt=_	R}', "");
    Expect(1, 68525, '\P{Is_Jt=_	R}', "");
    Expect(0, 68525, '\P{^Is_Jt=_	R}', "");
    Error('\p{Joining_Type=	 TRANSPARENT:=}');
    Error('\P{Joining_Type=	 TRANSPARENT:=}');
    Expect(1, 917999, '\p{Joining_Type=transparent}', "");
    Expect(0, 917999, '\p{^Joining_Type=transparent}', "");
    Expect(0, 917999, '\P{Joining_Type=transparent}', "");
    Expect(1, 917999, '\P{^Joining_Type=transparent}', "");
    Expect(0, 918000, '\p{Joining_Type=transparent}', "");
    Expect(1, 918000, '\p{^Joining_Type=transparent}', "");
    Expect(1, 918000, '\P{Joining_Type=transparent}', "");
    Expect(0, 918000, '\P{^Joining_Type=transparent}', "");
    Expect(1, 917999, '\p{Joining_Type=	-transparent}', "");
    Expect(0, 917999, '\p{^Joining_Type=	-transparent}', "");
    Expect(0, 917999, '\P{Joining_Type=	-transparent}', "");
    Expect(1, 917999, '\P{^Joining_Type=	-transparent}', "");
    Expect(0, 918000, '\p{Joining_Type=	-transparent}', "");
    Expect(1, 918000, '\p{^Joining_Type=	-transparent}', "");
    Expect(1, 918000, '\P{Joining_Type=	-transparent}', "");
    Expect(0, 918000, '\P{^Joining_Type=	-transparent}', "");
    Error('\p{Jt: 	-t/a/}');
    Error('\P{Jt: 	-t/a/}');
    Expect(1, 917999, '\p{Jt=t}', "");
    Expect(0, 917999, '\p{^Jt=t}', "");
    Expect(0, 917999, '\P{Jt=t}', "");
    Expect(1, 917999, '\P{^Jt=t}', "");
    Expect(0, 918000, '\p{Jt=t}', "");
    Expect(1, 918000, '\p{^Jt=t}', "");
    Expect(1, 918000, '\P{Jt=t}', "");
    Expect(0, 918000, '\P{^Jt=t}', "");
    Expect(1, 917999, '\p{Jt=_	t}', "");
    Expect(0, 917999, '\p{^Jt=_	t}', "");
    Expect(0, 917999, '\P{Jt=_	t}', "");
    Expect(1, 917999, '\P{^Jt=_	t}', "");
    Expect(0, 918000, '\p{Jt=_	t}', "");
    Expect(1, 918000, '\p{^Jt=_	t}', "");
    Expect(1, 918000, '\P{Jt=_	t}', "");
    Expect(0, 918000, '\P{^Jt=_	t}', "");
    Error('\p{Is_Joining_Type=-/a/TRANSPARENT}');
    Error('\P{Is_Joining_Type=-/a/TRANSPARENT}');
    Expect(1, 917999, '\p{Is_Joining_Type: transparent}', "");
    Expect(0, 917999, '\p{^Is_Joining_Type: transparent}', "");
    Expect(0, 917999, '\P{Is_Joining_Type: transparent}', "");
    Expect(1, 917999, '\P{^Is_Joining_Type: transparent}', "");
    Expect(0, 918000, '\p{Is_Joining_Type: transparent}', "");
    Expect(1, 918000, '\p{^Is_Joining_Type: transparent}', "");
    Expect(1, 918000, '\P{Is_Joining_Type: transparent}', "");
    Expect(0, 918000, '\P{^Is_Joining_Type: transparent}', "");
    Expect(1, 917999, '\p{Is_Joining_Type=_Transparent}', "");
    Expect(0, 917999, '\p{^Is_Joining_Type=_Transparent}', "");
    Expect(0, 917999, '\P{Is_Joining_Type=_Transparent}', "");
    Expect(1, 917999, '\P{^Is_Joining_Type=_Transparent}', "");
    Expect(0, 918000, '\p{Is_Joining_Type=_Transparent}', "");
    Expect(1, 918000, '\p{^Is_Joining_Type=_Transparent}', "");
    Expect(1, 918000, '\P{Is_Joining_Type=_Transparent}', "");
    Expect(0, 918000, '\P{^Is_Joining_Type=_Transparent}', "");
    Error('\p{Is_Jt=-:=T}');
    Error('\P{Is_Jt=-:=T}');
    Expect(1, 917999, '\p{Is_Jt=t}', "");
    Expect(0, 917999, '\p{^Is_Jt=t}', "");
    Expect(0, 917999, '\P{Is_Jt=t}', "");
    Expect(1, 917999, '\P{^Is_Jt=t}', "");
    Expect(0, 918000, '\p{Is_Jt=t}', "");
    Expect(1, 918000, '\p{^Is_Jt=t}', "");
    Expect(1, 918000, '\P{Is_Jt=t}', "");
    Expect(0, 918000, '\P{^Is_Jt=t}', "");
    Expect(1, 917999, '\p{Is_Jt:   _-T}', "");
    Expect(0, 917999, '\p{^Is_Jt:   _-T}', "");
    Expect(0, 917999, '\P{Is_Jt:   _-T}', "");
    Expect(1, 917999, '\P{^Is_Jt:   _-T}', "");
    Expect(0, 918000, '\p{Is_Jt:   _-T}', "");
    Expect(1, 918000, '\p{^Is_Jt:   _-T}', "");
    Expect(1, 918000, '\P{Is_Jt:   _-T}', "");
    Expect(0, 918000, '\P{^Is_Jt:   _-T}', "");
    Error('\p{Joining_Type=-Non_Joining/a/}');
    Error('\P{Joining_Type=-Non_Joining/a/}');
    Expect(1, 918000, '\p{Joining_Type=nonjoining}', "");
    Expect(0, 918000, '\p{^Joining_Type=nonjoining}', "");
    Expect(0, 918000, '\P{Joining_Type=nonjoining}', "");
    Expect(1, 918000, '\P{^Joining_Type=nonjoining}', "");
    Expect(0, 917999, '\p{Joining_Type=nonjoining}', "");
    Expect(1, 917999, '\p{^Joining_Type=nonjoining}', "");
    Expect(1, 917999, '\P{Joining_Type=nonjoining}', "");
    Expect(0, 917999, '\P{^Joining_Type=nonjoining}', "");
    Expect(1, 918000, '\p{Joining_Type=_NON_joining}', "");
    Expect(0, 918000, '\p{^Joining_Type=_NON_joining}', "");
    Expect(0, 918000, '\P{Joining_Type=_NON_joining}', "");
    Expect(1, 918000, '\P{^Joining_Type=_NON_joining}', "");
    Expect(0, 917999, '\p{Joining_Type=_NON_joining}', "");
    Expect(1, 917999, '\p{^Joining_Type=_NON_joining}', "");
    Expect(1, 917999, '\P{Joining_Type=_NON_joining}', "");
    Expect(0, 917999, '\P{^Joining_Type=_NON_joining}', "");
    Error('\p{Jt=:= u}');
    Error('\P{Jt=:= u}');
    Expect(1, 918000, '\p{Jt=u}', "");
    Expect(0, 918000, '\p{^Jt=u}', "");
    Expect(0, 918000, '\P{Jt=u}', "");
    Expect(1, 918000, '\P{^Jt=u}', "");
    Expect(0, 917999, '\p{Jt=u}', "");
    Expect(1, 917999, '\p{^Jt=u}', "");
    Expect(1, 917999, '\P{Jt=u}', "");
    Expect(0, 917999, '\P{^Jt=u}', "");
    Expect(1, 918000, '\p{Jt= 	u}', "");
    Expect(0, 918000, '\p{^Jt= 	u}', "");
    Expect(0, 918000, '\P{Jt= 	u}', "");
    Expect(1, 918000, '\P{^Jt= 	u}', "");
    Expect(0, 917999, '\p{Jt= 	u}', "");
    Expect(1, 917999, '\p{^Jt= 	u}', "");
    Expect(1, 917999, '\P{Jt= 	u}', "");
    Expect(0, 917999, '\P{^Jt= 	u}', "");
    Error('\p{Is_Joining_Type:/a/ 	non_JOINING}');
    Error('\P{Is_Joining_Type:/a/ 	non_JOINING}');
    Expect(1, 918000, '\p{Is_Joining_Type=nonjoining}', "");
    Expect(0, 918000, '\p{^Is_Joining_Type=nonjoining}', "");
    Expect(0, 918000, '\P{Is_Joining_Type=nonjoining}', "");
    Expect(1, 918000, '\P{^Is_Joining_Type=nonjoining}', "");
    Expect(0, 917999, '\p{Is_Joining_Type=nonjoining}', "");
    Expect(1, 917999, '\p{^Is_Joining_Type=nonjoining}', "");
    Expect(1, 917999, '\P{Is_Joining_Type=nonjoining}', "");
    Expect(0, 917999, '\P{^Is_Joining_Type=nonjoining}', "");
    Expect(1, 918000, '\p{Is_Joining_Type=-	Non_Joining}', "");
    Expect(0, 918000, '\p{^Is_Joining_Type=-	Non_Joining}', "");
    Expect(0, 918000, '\P{Is_Joining_Type=-	Non_Joining}', "");
    Expect(1, 918000, '\P{^Is_Joining_Type=-	Non_Joining}', "");
    Expect(0, 917999, '\p{Is_Joining_Type=-	Non_Joining}', "");
    Expect(1, 917999, '\p{^Is_Joining_Type=-	Non_Joining}', "");
    Expect(1, 917999, '\P{Is_Joining_Type=-	Non_Joining}', "");
    Expect(0, 917999, '\P{^Is_Joining_Type=-	Non_Joining}', "");
    Error('\p{Is_Jt=__u:=}');
    Error('\P{Is_Jt=__u:=}');
    Expect(1, 918000, '\p{Is_Jt=u}', "");
    Expect(0, 918000, '\p{^Is_Jt=u}', "");
    Expect(0, 918000, '\P{Is_Jt=u}', "");
    Expect(1, 918000, '\P{^Is_Jt=u}', "");
    Expect(0, 917999, '\p{Is_Jt=u}', "");
    Expect(1, 917999, '\p{^Is_Jt=u}', "");
    Expect(1, 917999, '\P{Is_Jt=u}', "");
    Expect(0, 917999, '\P{^Is_Jt=u}', "");
    Error('\p{linebreak}');
    Error('\P{linebreak}');
    Error('\p{lb}');
    Error('\P{lb}');
    Error('\p{Line_Break=_/a/Ambiguous}');
    Error('\P{Line_Break=_/a/Ambiguous}');
    Expect(1, 127404, '\p{Line_Break=ambiguous}', "");
    Expect(0, 127404, '\p{^Line_Break=ambiguous}', "");
    Expect(0, 127404, '\P{Line_Break=ambiguous}', "");
    Expect(1, 127404, '\P{^Line_Break=ambiguous}', "");
    Expect(0, 127405, '\p{Line_Break=ambiguous}', "");
    Expect(1, 127405, '\p{^Line_Break=ambiguous}', "");
    Expect(1, 127405, '\P{Line_Break=ambiguous}', "");
    Expect(0, 127405, '\P{^Line_Break=ambiguous}', "");
    Expect(1, 127404, '\p{Line_Break=- ambiguous}', "");
    Expect(0, 127404, '\p{^Line_Break=- ambiguous}', "");
    Expect(0, 127404, '\P{Line_Break=- ambiguous}', "");
    Expect(1, 127404, '\P{^Line_Break=- ambiguous}', "");
    Expect(0, 127405, '\p{Line_Break=- ambiguous}', "");
    Expect(1, 127405, '\p{^Line_Break=- ambiguous}', "");
    Expect(1, 127405, '\P{Line_Break=- ambiguous}', "");
    Expect(0, 127405, '\P{^Line_Break=- ambiguous}', "");
    Error('\p{Lb:   AI/a/}');
    Error('\P{Lb:   AI/a/}');
    Expect(1, 127404, '\p{Lb=ai}', "");
    Expect(0, 127404, '\p{^Lb=ai}', "");
    Expect(0, 127404, '\P{Lb=ai}', "");
    Expect(1, 127404, '\P{^Lb=ai}', "");
    Expect(0, 127405, '\p{Lb=ai}', "");
    Expect(1, 127405, '\p{^Lb=ai}', "");
    Expect(1, 127405, '\P{Lb=ai}', "");
    Expect(0, 127405, '\P{^Lb=ai}', "");
    Expect(1, 127404, '\p{Lb=-_AI}', "");
    Expect(0, 127404, '\p{^Lb=-_AI}', "");
    Expect(0, 127404, '\P{Lb=-_AI}', "");
    Expect(1, 127404, '\P{^Lb=-_AI}', "");
    Expect(0, 127405, '\p{Lb=-_AI}', "");
    Expect(1, 127405, '\p{^Lb=-_AI}', "");
    Expect(1, 127405, '\P{Lb=-_AI}', "");
    Expect(0, 127405, '\P{^Lb=-_AI}', "");
    Error('\p{Is_Line_Break=_/a/ambiguous}');
    Error('\P{Is_Line_Break=_/a/ambiguous}');
    Expect(1, 127404, '\p{Is_Line_Break=ambiguous}', "");
    Expect(0, 127404, '\p{^Is_Line_Break=ambiguous}', "");
    Expect(0, 127404, '\P{Is_Line_Break=ambiguous}', "");
    Expect(1, 127404, '\P{^Is_Line_Break=ambiguous}', "");
    Expect(0, 127405, '\p{Is_Line_Break=ambiguous}', "");
    Expect(1, 127405, '\p{^Is_Line_Break=ambiguous}', "");
    Expect(1, 127405, '\P{Is_Line_Break=ambiguous}', "");
    Expect(0, 127405, '\P{^Is_Line_Break=ambiguous}', "");
    Expect(1, 127404, '\p{Is_Line_Break=--Ambiguous}', "");
    Expect(0, 127404, '\p{^Is_Line_Break=--Ambiguous}', "");
    Expect(0, 127404, '\P{Is_Line_Break=--Ambiguous}', "");
    Expect(1, 127404, '\P{^Is_Line_Break=--Ambiguous}', "");
    Expect(0, 127405, '\p{Is_Line_Break=--Ambiguous}', "");
    Expect(1, 127405, '\p{^Is_Line_Break=--Ambiguous}', "");
    Expect(1, 127405, '\P{Is_Line_Break=--Ambiguous}', "");
    Expect(0, 127405, '\P{^Is_Line_Break=--Ambiguous}', "");
    Error('\p{Is_Lb=/a/ _AI}');
    Error('\P{Is_Lb=/a/ _AI}');
    Expect(1, 127404, '\p{Is_Lb=ai}', "");
    Expect(0, 127404, '\p{^Is_Lb=ai}', "");
    Expect(0, 127404, '\P{Is_Lb=ai}', "");
    Expect(1, 127404, '\P{^Is_Lb=ai}', "");
    Expect(0, 127405, '\p{Is_Lb=ai}', "");
    Expect(1, 127405, '\p{^Is_Lb=ai}', "");
    Expect(1, 127405, '\P{Is_Lb=ai}', "");
    Expect(0, 127405, '\P{^Is_Lb=ai}', "");
    Expect(1, 127404, '\p{Is_Lb=  AI}', "");
    Expect(0, 127404, '\p{^Is_Lb=  AI}', "");
    Expect(0, 127404, '\P{Is_Lb=  AI}', "");
    Expect(1, 127404, '\P{^Is_Lb=  AI}', "");
    Expect(0, 127405, '\p{Is_Lb=  AI}', "");
    Expect(1, 127405, '\p{^Is_Lb=  AI}', "");
    Expect(1, 127405, '\P{Is_Lb=  AI}', "");
    Expect(0, 127405, '\P{^Is_Lb=  AI}', "");
    Error('\p{Line_Break=-	alphabetic/a/}');
    Error('\P{Line_Break=-	alphabetic/a/}');
    Expect(1, 129291, '\p{Line_Break=alphabetic}', "");
    Expect(0, 129291, '\p{^Line_Break=alphabetic}', "");
    Expect(0, 129291, '\P{Line_Break=alphabetic}', "");
    Expect(1, 129291, '\P{^Line_Break=alphabetic}', "");
    Expect(0, 129292, '\p{Line_Break=alphabetic}', "");
    Expect(1, 129292, '\p{^Line_Break=alphabetic}', "");
    Expect(1, 129292, '\P{Line_Break=alphabetic}', "");
    Expect(0, 129292, '\P{^Line_Break=alphabetic}', "");
    Expect(1, 129291, '\p{Line_Break=-Alphabetic}', "");
    Expect(0, 129291, '\p{^Line_Break=-Alphabetic}', "");
    Expect(0, 129291, '\P{Line_Break=-Alphabetic}', "");
    Expect(1, 129291, '\P{^Line_Break=-Alphabetic}', "");
    Expect(0, 129292, '\p{Line_Break=-Alphabetic}', "");
    Expect(1, 129292, '\p{^Line_Break=-Alphabetic}', "");
    Expect(1, 129292, '\P{Line_Break=-Alphabetic}', "");
    Expect(0, 129292, '\P{^Line_Break=-Alphabetic}', "");
    Error('\p{Lb=	 AL/a/}');
    Error('\P{Lb=	 AL/a/}');
    Expect(1, 129291, '\p{Lb:al}', "");
    Expect(0, 129291, '\p{^Lb:al}', "");
    Expect(0, 129291, '\P{Lb:al}', "");
    Expect(1, 129291, '\P{^Lb:al}', "");
    Expect(0, 129292, '\p{Lb:al}', "");
    Expect(1, 129292, '\p{^Lb:al}', "");
    Expect(1, 129292, '\P{Lb:al}', "");
    Expect(0, 129292, '\P{^Lb:al}', "");
    Expect(1, 129291, '\p{Lb=--al}', "");
    Expect(0, 129291, '\p{^Lb=--al}', "");
    Expect(0, 129291, '\P{Lb=--al}', "");
    Expect(1, 129291, '\P{^Lb=--al}', "");
    Expect(0, 129292, '\p{Lb=--al}', "");
    Expect(1, 129292, '\p{^Lb=--al}', "");
    Expect(1, 129292, '\P{Lb=--al}', "");
    Expect(0, 129292, '\P{^Lb=--al}', "");
    Error('\p{Is_Line_Break=		ALPHABETIC:=}');
    Error('\P{Is_Line_Break=		ALPHABETIC:=}');
    Expect(1, 129291, '\p{Is_Line_Break=alphabetic}', "");
    Expect(0, 129291, '\p{^Is_Line_Break=alphabetic}', "");
    Expect(0, 129291, '\P{Is_Line_Break=alphabetic}', "");
    Expect(1, 129291, '\P{^Is_Line_Break=alphabetic}', "");
    Expect(0, 129292, '\p{Is_Line_Break=alphabetic}', "");
    Expect(1, 129292, '\p{^Is_Line_Break=alphabetic}', "");
    Expect(1, 129292, '\P{Is_Line_Break=alphabetic}', "");
    Expect(0, 129292, '\P{^Is_Line_Break=alphabetic}', "");
    Expect(1, 129291, '\p{Is_Line_Break=	alphabetic}', "");
    Expect(0, 129291, '\p{^Is_Line_Break=	alphabetic}', "");
    Expect(0, 129291, '\P{Is_Line_Break=	alphabetic}', "");
    Expect(1, 129291, '\P{^Is_Line_Break=	alphabetic}', "");
    Expect(0, 129292, '\p{Is_Line_Break=	alphabetic}', "");
    Expect(1, 129292, '\p{^Is_Line_Break=	alphabetic}', "");
    Expect(1, 129292, '\P{Is_Line_Break=	alphabetic}', "");
    Expect(0, 129292, '\P{^Is_Line_Break=	alphabetic}', "");
    Error('\p{Is_Lb= al/a/}');
    Error('\P{Is_Lb= al/a/}');
    Expect(1, 129291, '\p{Is_Lb=al}', "");
    Expect(0, 129291, '\p{^Is_Lb=al}', "");
    Expect(0, 129291, '\P{Is_Lb=al}', "");
    Expect(1, 129291, '\P{^Is_Lb=al}', "");
    Expect(0, 129292, '\p{Is_Lb=al}', "");
    Expect(1, 129292, '\p{^Is_Lb=al}', "");
    Expect(1, 129292, '\P{Is_Lb=al}', "");
    Expect(0, 129292, '\P{^Is_Lb=al}', "");
    Expect(1, 129291, '\p{Is_Lb=-_AL}', "");
    Expect(0, 129291, '\p{^Is_Lb=-_AL}', "");
    Expect(0, 129291, '\P{Is_Lb=-_AL}', "");
    Expect(1, 129291, '\P{^Is_Lb=-_AL}', "");
    Expect(0, 129292, '\p{Is_Lb=-_AL}', "");
    Expect(1, 129292, '\p{^Is_Lb=-_AL}', "");
    Expect(1, 129292, '\P{Is_Lb=-_AL}', "");
    Expect(0, 129292, '\P{^Is_Lb=-_AL}', "");
    Error('\p{Line_Break=/a/	Break_Both}');
    Error('\P{Line_Break=/a/	Break_Both}');
    Expect(1, 11835, '\p{Line_Break=breakboth}', "");
    Expect(0, 11835, '\p{^Line_Break=breakboth}', "");
    Expect(0, 11835, '\P{Line_Break=breakboth}', "");
    Expect(1, 11835, '\P{^Line_Break=breakboth}', "");
    Expect(0, 11836, '\p{Line_Break=breakboth}', "");
    Expect(1, 11836, '\p{^Line_Break=breakboth}', "");
    Expect(1, 11836, '\P{Line_Break=breakboth}', "");
    Expect(0, 11836, '\P{^Line_Break=breakboth}', "");
    Expect(1, 11835, '\p{Line_Break= _break_Both}', "");
    Expect(0, 11835, '\p{^Line_Break= _break_Both}', "");
    Expect(0, 11835, '\P{Line_Break= _break_Both}', "");
    Expect(1, 11835, '\P{^Line_Break= _break_Both}', "");
    Expect(0, 11836, '\p{Line_Break= _break_Both}', "");
    Expect(1, 11836, '\p{^Line_Break= _break_Both}', "");
    Expect(1, 11836, '\P{Line_Break= _break_Both}', "");
    Expect(0, 11836, '\P{^Line_Break= _break_Both}', "");
    Error('\p{Lb=_/a/B2}');
    Error('\P{Lb=_/a/B2}');
    Expect(1, 11835, '\p{Lb=b2}', "");
    Expect(0, 11835, '\p{^Lb=b2}', "");
    Expect(0, 11835, '\P{Lb=b2}', "");
    Expect(1, 11835, '\P{^Lb=b2}', "");
    Expect(0, 11836, '\p{Lb=b2}', "");
    Expect(1, 11836, '\p{^Lb=b2}', "");
    Expect(1, 11836, '\P{Lb=b2}', "");
    Expect(0, 11836, '\P{^Lb=b2}', "");
    Expect(1, 11835, '\p{Lb=- B2}', "");
    Expect(0, 11835, '\p{^Lb=- B2}', "");
    Expect(0, 11835, '\P{Lb=- B2}', "");
    Expect(1, 11835, '\P{^Lb=- B2}', "");
    Expect(0, 11836, '\p{Lb=- B2}', "");
    Expect(1, 11836, '\p{^Lb=- B2}', "");
    Expect(1, 11836, '\P{Lb=- B2}', "");
    Expect(0, 11836, '\P{^Lb=- B2}', "");
    Error('\p{Is_Line_Break=-/a/Break_Both}');
    Error('\P{Is_Line_Break=-/a/Break_Both}');
    Expect(1, 11835, '\p{Is_Line_Break=breakboth}', "");
    Expect(0, 11835, '\p{^Is_Line_Break=breakboth}', "");
    Expect(0, 11835, '\P{Is_Line_Break=breakboth}', "");
    Expect(1, 11835, '\P{^Is_Line_Break=breakboth}', "");
    Expect(0, 11836, '\p{Is_Line_Break=breakboth}', "");
    Expect(1, 11836, '\p{^Is_Line_Break=breakboth}', "");
    Expect(1, 11836, '\P{Is_Line_Break=breakboth}', "");
    Expect(0, 11836, '\P{^Is_Line_Break=breakboth}', "");
    Expect(1, 11835, '\p{Is_Line_Break= -break_both}', "");
    Expect(0, 11835, '\p{^Is_Line_Break= -break_both}', "");
    Expect(0, 11835, '\P{Is_Line_Break= -break_both}', "");
    Expect(1, 11835, '\P{^Is_Line_Break= -break_both}', "");
    Expect(0, 11836, '\p{Is_Line_Break= -break_both}', "");
    Expect(1, 11836, '\p{^Is_Line_Break= -break_both}', "");
    Expect(1, 11836, '\P{Is_Line_Break= -break_both}', "");
    Expect(0, 11836, '\P{^Is_Line_Break= -break_both}', "");
    Error('\p{Is_Lb:/a/  B2}');
    Error('\P{Is_Lb:/a/  B2}');
    Expect(1, 11835, '\p{Is_Lb=b2}', "");
    Expect(0, 11835, '\p{^Is_Lb=b2}', "");
    Expect(0, 11835, '\P{Is_Lb=b2}', "");
    Expect(1, 11835, '\P{^Is_Lb=b2}', "");
    Expect(0, 11836, '\p{Is_Lb=b2}', "");
    Expect(1, 11836, '\p{^Is_Lb=b2}', "");
    Expect(1, 11836, '\P{Is_Lb=b2}', "");
    Expect(0, 11836, '\P{^Is_Lb=b2}', "");
    Expect(1, 11835, '\p{Is_Lb= B2}', "");
    Expect(0, 11835, '\p{^Is_Lb= B2}', "");
    Expect(0, 11835, '\P{Is_Lb= B2}', "");
    Expect(1, 11835, '\P{^Is_Lb= B2}', "");
    Expect(0, 11836, '\p{Is_Lb= B2}', "");
    Expect(1, 11836, '\p{^Is_Lb= B2}', "");
    Expect(1, 11836, '\P{Is_Lb= B2}', "");
    Expect(0, 11836, '\P{^Is_Lb= B2}', "");
    Error('\p{Line_Break=_BREAK_After:=}');
    Error('\P{Line_Break=_BREAK_After:=}');
    Expect(1, 121482, '\p{Line_Break:	breakafter}', "");
    Expect(0, 121482, '\p{^Line_Break:	breakafter}', "");
    Expect(0, 121482, '\P{Line_Break:	breakafter}', "");
    Expect(1, 121482, '\P{^Line_Break:	breakafter}', "");
    Expect(0, 121483, '\p{Line_Break:	breakafter}', "");
    Expect(1, 121483, '\p{^Line_Break:	breakafter}', "");
    Expect(1, 121483, '\P{Line_Break:	breakafter}', "");
    Expect(0, 121483, '\P{^Line_Break:	breakafter}', "");
    Expect(1, 121482, '\p{Line_Break= break_after}', "");
    Expect(0, 121482, '\p{^Line_Break= break_after}', "");
    Expect(0, 121482, '\P{Line_Break= break_after}', "");
    Expect(1, 121482, '\P{^Line_Break= break_after}', "");
    Expect(0, 121483, '\p{Line_Break= break_after}', "");
    Expect(1, 121483, '\p{^Line_Break= break_after}', "");
    Expect(1, 121483, '\P{Line_Break= break_after}', "");
    Expect(0, 121483, '\P{^Line_Break= break_after}', "");
    Error('\p{Lb=_/a/BA}');
    Error('\P{Lb=_/a/BA}');
    Expect(1, 121482, '\p{Lb=ba}', "");
    Expect(0, 121482, '\p{^Lb=ba}', "");
    Expect(0, 121482, '\P{Lb=ba}', "");
    Expect(1, 121482, '\P{^Lb=ba}', "");
    Expect(0, 121483, '\p{Lb=ba}', "");
    Expect(1, 121483, '\p{^Lb=ba}', "");
    Expect(1, 121483, '\P{Lb=ba}', "");
    Expect(0, 121483, '\P{^Lb=ba}', "");
    Expect(1, 121482, '\p{Lb=	_BA}', "");
    Expect(0, 121482, '\p{^Lb=	_BA}', "");
    Expect(0, 121482, '\P{Lb=	_BA}', "");
    Expect(1, 121482, '\P{^Lb=	_BA}', "");
    Expect(0, 121483, '\p{Lb=	_BA}', "");
    Expect(1, 121483, '\p{^Lb=	_BA}', "");
    Expect(1, 121483, '\P{Lb=	_BA}', "");
    Expect(0, 121483, '\P{^Lb=	_BA}', "");
    Error('\p{Is_Line_Break= /a/BREAK_after}');
    Error('\P{Is_Line_Break= /a/BREAK_after}');
    Expect(1, 121482, '\p{Is_Line_Break=breakafter}', "");
    Expect(0, 121482, '\p{^Is_Line_Break=breakafter}', "");
    Expect(0, 121482, '\P{Is_Line_Break=breakafter}', "");
    Expect(1, 121482, '\P{^Is_Line_Break=breakafter}', "");
    Expect(0, 121483, '\p{Is_Line_Break=breakafter}', "");
    Expect(1, 121483, '\p{^Is_Line_Break=breakafter}', "");
    Expect(1, 121483, '\P{Is_Line_Break=breakafter}', "");
    Expect(0, 121483, '\P{^Is_Line_Break=breakafter}', "");
    Expect(1, 121482, '\p{Is_Line_Break=_ BREAK_after}', "");
    Expect(0, 121482, '\p{^Is_Line_Break=_ BREAK_after}', "");
    Expect(0, 121482, '\P{Is_Line_Break=_ BREAK_after}', "");
    Expect(1, 121482, '\P{^Is_Line_Break=_ BREAK_after}', "");
    Expect(0, 121483, '\p{Is_Line_Break=_ BREAK_after}', "");
    Expect(1, 121483, '\p{^Is_Line_Break=_ BREAK_after}', "");
    Expect(1, 121483, '\P{Is_Line_Break=_ BREAK_after}', "");
    Expect(0, 121483, '\P{^Is_Line_Break=_ BREAK_after}', "");
    Error('\p{Is_Lb: _ba/a/}');
    Error('\P{Is_Lb: _ba/a/}');
    Expect(1, 121482, '\p{Is_Lb=ba}', "");
    Expect(0, 121482, '\p{^Is_Lb=ba}', "");
    Expect(0, 121482, '\P{Is_Lb=ba}', "");
    Expect(1, 121482, '\P{^Is_Lb=ba}', "");
    Expect(0, 121483, '\p{Is_Lb=ba}', "");
    Expect(1, 121483, '\p{^Is_Lb=ba}', "");
    Expect(1, 121483, '\P{Is_Lb=ba}', "");
    Expect(0, 121483, '\P{^Is_Lb=ba}', "");
    Expect(1, 121482, '\p{Is_Lb=_BA}', "");
    Expect(0, 121482, '\p{^Is_Lb=_BA}', "");
    Expect(0, 121482, '\P{Is_Lb=_BA}', "");
    Expect(1, 121482, '\P{^Is_Lb=_BA}', "");
    Expect(0, 121483, '\p{Is_Lb=_BA}', "");
    Expect(1, 121483, '\p{^Is_Lb=_BA}', "");
    Expect(1, 121483, '\P{Is_Lb=_BA}', "");
    Expect(0, 121483, '\P{^Is_Lb=_BA}', "");
    Error('\p{Line_Break=-:=break_before}');
    Error('\P{Line_Break=-:=break_before}');
    Expect(1, 72816, '\p{Line_Break=breakbefore}', "");
    Expect(0, 72816, '\p{^Line_Break=breakbefore}', "");
    Expect(0, 72816, '\P{Line_Break=breakbefore}', "");
    Expect(1, 72816, '\P{^Line_Break=breakbefore}', "");
    Expect(0, 72817, '\p{Line_Break=breakbefore}', "");
    Expect(1, 72817, '\p{^Line_Break=breakbefore}', "");
    Expect(1, 72817, '\P{Line_Break=breakbefore}', "");
    Expect(0, 72817, '\P{^Line_Break=breakbefore}', "");
    Expect(1, 72816, '\p{Line_Break=	 break_BEFORE}', "");
    Expect(0, 72816, '\p{^Line_Break=	 break_BEFORE}', "");
    Expect(0, 72816, '\P{Line_Break=	 break_BEFORE}', "");
    Expect(1, 72816, '\P{^Line_Break=	 break_BEFORE}', "");
    Expect(0, 72817, '\p{Line_Break=	 break_BEFORE}', "");
    Expect(1, 72817, '\p{^Line_Break=	 break_BEFORE}', "");
    Expect(1, 72817, '\P{Line_Break=	 break_BEFORE}', "");
    Expect(0, 72817, '\P{^Line_Break=	 break_BEFORE}', "");
    Error('\p{Lb=_:=BB}');
    Error('\P{Lb=_:=BB}');
    Expect(1, 72816, '\p{Lb=bb}', "");
    Expect(0, 72816, '\p{^Lb=bb}', "");
    Expect(0, 72816, '\P{Lb=bb}', "");
    Expect(1, 72816, '\P{^Lb=bb}', "");
    Expect(0, 72817, '\p{Lb=bb}', "");
    Expect(1, 72817, '\p{^Lb=bb}', "");
    Expect(1, 72817, '\P{Lb=bb}', "");
    Expect(0, 72817, '\P{^Lb=bb}', "");
    Expect(1, 72816, '\p{Lb=-_BB}', "");
    Expect(0, 72816, '\p{^Lb=-_BB}', "");
    Expect(0, 72816, '\P{Lb=-_BB}', "");
    Expect(1, 72816, '\P{^Lb=-_BB}', "");
    Expect(0, 72817, '\p{Lb=-_BB}', "");
    Expect(1, 72817, '\p{^Lb=-_BB}', "");
    Expect(1, 72817, '\P{Lb=-_BB}', "");
    Expect(0, 72817, '\P{^Lb=-_BB}', "");
    Error('\p{Is_Line_Break=__break_Before:=}');
    Error('\P{Is_Line_Break=__break_Before:=}');
    Expect(1, 72816, '\p{Is_Line_Break=breakbefore}', "");
    Expect(0, 72816, '\p{^Is_Line_Break=breakbefore}', "");
    Expect(0, 72816, '\P{Is_Line_Break=breakbefore}', "");
    Expect(1, 72816, '\P{^Is_Line_Break=breakbefore}', "");
    Expect(0, 72817, '\p{Is_Line_Break=breakbefore}', "");
    Expect(1, 72817, '\p{^Is_Line_Break=breakbefore}', "");
    Expect(1, 72817, '\P{Is_Line_Break=breakbefore}', "");
    Expect(0, 72817, '\P{^Is_Line_Break=breakbefore}', "");
    Expect(1, 72816, '\p{Is_Line_Break=_	Break_BEFORE}', "");
    Expect(0, 72816, '\p{^Is_Line_Break=_	Break_BEFORE}', "");
    Expect(0, 72816, '\P{Is_Line_Break=_	Break_BEFORE}', "");
    Expect(1, 72816, '\P{^Is_Line_Break=_	Break_BEFORE}', "");
    Expect(0, 72817, '\p{Is_Line_Break=_	Break_BEFORE}', "");
    Expect(1, 72817, '\p{^Is_Line_Break=_	Break_BEFORE}', "");
    Expect(1, 72817, '\P{Is_Line_Break=_	Break_BEFORE}', "");
    Expect(0, 72817, '\P{^Is_Line_Break=_	Break_BEFORE}', "");
    Error('\p{Is_Lb=__BB:=}');
    Error('\P{Is_Lb=__BB:=}');
    Expect(1, 72816, '\p{Is_Lb=bb}', "");
    Expect(0, 72816, '\p{^Is_Lb=bb}', "");
    Expect(0, 72816, '\P{Is_Lb=bb}', "");
    Expect(1, 72816, '\P{^Is_Lb=bb}', "");
    Expect(0, 72817, '\p{Is_Lb=bb}', "");
    Expect(1, 72817, '\p{^Is_Lb=bb}', "");
    Expect(1, 72817, '\P{Is_Lb=bb}', "");
    Expect(0, 72817, '\P{^Is_Lb=bb}', "");
    Expect(1, 72816, '\p{Is_Lb=--BB}', "");
    Expect(0, 72816, '\p{^Is_Lb=--BB}', "");
    Expect(0, 72816, '\P{Is_Lb=--BB}', "");
    Expect(1, 72816, '\P{^Is_Lb=--BB}', "");
    Expect(0, 72817, '\p{Is_Lb=--BB}', "");
    Expect(1, 72817, '\p{^Is_Lb=--BB}', "");
    Expect(1, 72817, '\P{Is_Lb=--BB}', "");
    Expect(0, 72817, '\P{^Is_Lb=--BB}', "");
    Error('\p{Line_Break=	-MANDATORY_break/a/}');
    Error('\P{Line_Break=	-MANDATORY_break/a/}');
    Expect(1, 8233, '\p{Line_Break=mandatorybreak}', "");
    Expect(0, 8233, '\p{^Line_Break=mandatorybreak}', "");
    Expect(0, 8233, '\P{Line_Break=mandatorybreak}', "");
    Expect(1, 8233, '\P{^Line_Break=mandatorybreak}', "");
    Expect(0, 8234, '\p{Line_Break=mandatorybreak}', "");
    Expect(1, 8234, '\p{^Line_Break=mandatorybreak}', "");
    Expect(1, 8234, '\P{Line_Break=mandatorybreak}', "");
    Expect(0, 8234, '\P{^Line_Break=mandatorybreak}', "");
    Expect(1, 8233, '\p{Line_Break=  MANDATORY_Break}', "");
    Expect(0, 8233, '\p{^Line_Break=  MANDATORY_Break}', "");
    Expect(0, 8233, '\P{Line_Break=  MANDATORY_Break}', "");
    Expect(1, 8233, '\P{^Line_Break=  MANDATORY_Break}', "");
    Expect(0, 8234, '\p{Line_Break=  MANDATORY_Break}', "");
    Expect(1, 8234, '\p{^Line_Break=  MANDATORY_Break}', "");
    Expect(1, 8234, '\P{Line_Break=  MANDATORY_Break}', "");
    Expect(0, 8234, '\P{^Line_Break=  MANDATORY_Break}', "");
    Error('\p{Lb=:=	BK}');
    Error('\P{Lb=:=	BK}');
    Expect(1, 8233, '\p{Lb=bk}', "");
    Expect(0, 8233, '\p{^Lb=bk}', "");
    Expect(0, 8233, '\P{Lb=bk}', "");
    Expect(1, 8233, '\P{^Lb=bk}', "");
    Expect(0, 8234, '\p{Lb=bk}', "");
    Expect(1, 8234, '\p{^Lb=bk}', "");
    Expect(1, 8234, '\P{Lb=bk}', "");
    Expect(0, 8234, '\P{^Lb=bk}', "");
    Expect(1, 8233, '\p{Lb=_ BK}', "");
    Expect(0, 8233, '\p{^Lb=_ BK}', "");
    Expect(0, 8233, '\P{Lb=_ BK}', "");
    Expect(1, 8233, '\P{^Lb=_ BK}', "");
    Expect(0, 8234, '\p{Lb=_ BK}', "");
    Expect(1, 8234, '\p{^Lb=_ BK}', "");
    Expect(1, 8234, '\P{Lb=_ BK}', "");
    Expect(0, 8234, '\P{^Lb=_ BK}', "");
    Error('\p{Is_Line_Break=:=Mandatory_break}');
    Error('\P{Is_Line_Break=:=Mandatory_break}');
    Expect(1, 8233, '\p{Is_Line_Break:   mandatorybreak}', "");
    Expect(0, 8233, '\p{^Is_Line_Break:   mandatorybreak}', "");
    Expect(0, 8233, '\P{Is_Line_Break:   mandatorybreak}', "");
    Expect(1, 8233, '\P{^Is_Line_Break:   mandatorybreak}', "");
    Expect(0, 8234, '\p{Is_Line_Break:   mandatorybreak}', "");
    Expect(1, 8234, '\p{^Is_Line_Break:   mandatorybreak}', "");
    Expect(1, 8234, '\P{Is_Line_Break:   mandatorybreak}', "");
    Expect(0, 8234, '\P{^Is_Line_Break:   mandatorybreak}', "");
    Expect(1, 8233, '\p{Is_Line_Break= Mandatory_Break}', "");
    Expect(0, 8233, '\p{^Is_Line_Break= Mandatory_Break}', "");
    Expect(0, 8233, '\P{Is_Line_Break= Mandatory_Break}', "");
    Expect(1, 8233, '\P{^Is_Line_Break= Mandatory_Break}', "");
    Expect(0, 8234, '\p{Is_Line_Break= Mandatory_Break}', "");
    Expect(1, 8234, '\p{^Is_Line_Break= Mandatory_Break}', "");
    Expect(1, 8234, '\P{Is_Line_Break= Mandatory_Break}', "");
    Expect(0, 8234, '\P{^Is_Line_Break= Mandatory_Break}', "");
    Error('\p{Is_Lb=-	bk/a/}');
    Error('\P{Is_Lb=-	bk/a/}');
    Expect(1, 8233, '\p{Is_Lb=bk}', "");
    Expect(0, 8233, '\p{^Is_Lb=bk}', "");
    Expect(0, 8233, '\P{Is_Lb=bk}', "");
    Expect(1, 8233, '\P{^Is_Lb=bk}', "");
    Expect(0, 8234, '\p{Is_Lb=bk}', "");
    Expect(1, 8234, '\p{^Is_Lb=bk}', "");
    Expect(1, 8234, '\P{Is_Lb=bk}', "");
    Expect(0, 8234, '\P{^Is_Lb=bk}', "");
    Expect(1, 8233, '\p{Is_Lb=-	BK}', "");
    Expect(0, 8233, '\p{^Is_Lb=-	BK}', "");
    Expect(0, 8233, '\P{Is_Lb=-	BK}', "");
    Expect(1, 8233, '\P{^Is_Lb=-	BK}', "");
    Expect(0, 8234, '\p{Is_Lb=-	BK}', "");
    Expect(1, 8234, '\p{^Is_Lb=-	BK}', "");
    Expect(1, 8234, '\P{Is_Lb=-	BK}', "");
    Expect(0, 8234, '\P{^Is_Lb=-	BK}', "");
    Error('\p{Line_Break=_:=CONTINGENT_Break}');
    Error('\P{Line_Break=_:=CONTINGENT_Break}');
    Expect(1, 65532, '\p{Line_Break=contingentbreak}', "");
    Expect(0, 65532, '\p{^Line_Break=contingentbreak}', "");
    Expect(0, 65532, '\P{Line_Break=contingentbreak}', "");
    Expect(1, 65532, '\P{^Line_Break=contingentbreak}', "");
    Expect(0, 65533, '\p{Line_Break=contingentbreak}', "");
    Expect(1, 65533, '\p{^Line_Break=contingentbreak}', "");
    Expect(1, 65533, '\P{Line_Break=contingentbreak}', "");
    Expect(0, 65533, '\P{^Line_Break=contingentbreak}', "");
    Expect(1, 65532, '\p{Line_Break=	-contingent_break}', "");
    Expect(0, 65532, '\p{^Line_Break=	-contingent_break}', "");
    Expect(0, 65532, '\P{Line_Break=	-contingent_break}', "");
    Expect(1, 65532, '\P{^Line_Break=	-contingent_break}', "");
    Expect(0, 65533, '\p{Line_Break=	-contingent_break}', "");
    Expect(1, 65533, '\p{^Line_Break=	-contingent_break}', "");
    Expect(1, 65533, '\P{Line_Break=	-contingent_break}', "");
    Expect(0, 65533, '\P{^Line_Break=	-contingent_break}', "");
    Error('\p{Lb=	/a/cb}');
    Error('\P{Lb=	/a/cb}');
    Expect(1, 65532, '\p{Lb=cb}', "");
    Expect(0, 65532, '\p{^Lb=cb}', "");
    Expect(0, 65532, '\P{Lb=cb}', "");
    Expect(1, 65532, '\P{^Lb=cb}', "");
    Expect(0, 65533, '\p{Lb=cb}', "");
    Expect(1, 65533, '\p{^Lb=cb}', "");
    Expect(1, 65533, '\P{Lb=cb}', "");
    Expect(0, 65533, '\P{^Lb=cb}', "");
    Expect(1, 65532, '\p{Lb:   _CB}', "");
    Expect(0, 65532, '\p{^Lb:   _CB}', "");
    Expect(0, 65532, '\P{Lb:   _CB}', "");
    Expect(1, 65532, '\P{^Lb:   _CB}', "");
    Expect(0, 65533, '\p{Lb:   _CB}', "");
    Expect(1, 65533, '\p{^Lb:   _CB}', "");
    Expect(1, 65533, '\P{Lb:   _CB}', "");
    Expect(0, 65533, '\P{^Lb:   _CB}', "");
    Error('\p{Is_Line_Break=:= Contingent_Break}');
    Error('\P{Is_Line_Break=:= Contingent_Break}');
    Expect(1, 65532, '\p{Is_Line_Break=contingentbreak}', "");
    Expect(0, 65532, '\p{^Is_Line_Break=contingentbreak}', "");
    Expect(0, 65532, '\P{Is_Line_Break=contingentbreak}', "");
    Expect(1, 65532, '\P{^Is_Line_Break=contingentbreak}', "");
    Expect(0, 65533, '\p{Is_Line_Break=contingentbreak}', "");
    Expect(1, 65533, '\p{^Is_Line_Break=contingentbreak}', "");
    Expect(1, 65533, '\P{Is_Line_Break=contingentbreak}', "");
    Expect(0, 65533, '\P{^Is_Line_Break=contingentbreak}', "");
    Expect(1, 65532, '\p{Is_Line_Break=	Contingent_break}', "");
    Expect(0, 65532, '\p{^Is_Line_Break=	Contingent_break}', "");
    Expect(0, 65532, '\P{Is_Line_Break=	Contingent_break}', "");
    Expect(1, 65532, '\P{^Is_Line_Break=	Contingent_break}', "");
    Expect(0, 65533, '\p{Is_Line_Break=	Contingent_break}', "");
    Expect(1, 65533, '\p{^Is_Line_Break=	Contingent_break}', "");
    Expect(1, 65533, '\P{Is_Line_Break=	Contingent_break}', "");
    Expect(0, 65533, '\P{^Is_Line_Break=	Contingent_break}', "");
    Error('\p{Is_Lb=/a/_-CB}');
    Error('\P{Is_Lb=/a/_-CB}');
    Expect(1, 65532, '\p{Is_Lb=cb}', "");
    Expect(0, 65532, '\p{^Is_Lb=cb}', "");
    Expect(0, 65532, '\P{Is_Lb=cb}', "");
    Expect(1, 65532, '\P{^Is_Lb=cb}', "");
    Expect(0, 65533, '\p{Is_Lb=cb}', "");
    Expect(1, 65533, '\p{^Is_Lb=cb}', "");
    Expect(1, 65533, '\P{Is_Lb=cb}', "");
    Expect(0, 65533, '\P{^Is_Lb=cb}', "");
    Expect(1, 65532, '\p{Is_Lb=	 CB}', "");
    Expect(0, 65532, '\p{^Is_Lb=	 CB}', "");
    Expect(0, 65532, '\P{Is_Lb=	 CB}', "");
    Expect(1, 65532, '\P{^Is_Lb=	 CB}', "");
    Expect(0, 65533, '\p{Is_Lb=	 CB}', "");
    Expect(1, 65533, '\p{^Is_Lb=	 CB}', "");
    Expect(1, 65533, '\P{Is_Lb=	 CB}', "");
    Expect(0, 65533, '\P{^Is_Lb=	 CB}', "");
    Error('\p{Line_Break=	_Conditional_Japanese_starter/a/}');
    Error('\P{Line_Break=	_Conditional_Japanese_starter/a/}');
    Expect(1, 65392, '\p{Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 65392, '\p{^Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 65392, '\P{Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 65392, '\P{^Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 65393, '\p{Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 65393, '\p{^Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 65393, '\P{Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 65393, '\P{^Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 65392, '\p{Line_Break=--Conditional_JAPANESE_Starter}', "");
    Expect(0, 65392, '\p{^Line_Break=--Conditional_JAPANESE_Starter}', "");
    Expect(0, 65392, '\P{Line_Break=--Conditional_JAPANESE_Starter}', "");
    Expect(1, 65392, '\P{^Line_Break=--Conditional_JAPANESE_Starter}', "");
    Expect(0, 65393, '\p{Line_Break=--Conditional_JAPANESE_Starter}', "");
    Expect(1, 65393, '\p{^Line_Break=--Conditional_JAPANESE_Starter}', "");
    Expect(1, 65393, '\P{Line_Break=--Conditional_JAPANESE_Starter}', "");
    Expect(0, 65393, '\P{^Line_Break=--Conditional_JAPANESE_Starter}', "");
    Error('\p{Lb:	_/a/cj}');
    Error('\P{Lb:	_/a/cj}');
    Expect(1, 65392, '\p{Lb=cj}', "");
    Expect(0, 65392, '\p{^Lb=cj}', "");
    Expect(0, 65392, '\P{Lb=cj}', "");
    Expect(1, 65392, '\P{^Lb=cj}', "");
    Expect(0, 65393, '\p{Lb=cj}', "");
    Expect(1, 65393, '\p{^Lb=cj}', "");
    Expect(1, 65393, '\P{Lb=cj}', "");
    Expect(0, 65393, '\P{^Lb=cj}', "");
    Expect(1, 65392, '\p{Lb= -cj}', "");
    Expect(0, 65392, '\p{^Lb= -cj}', "");
    Expect(0, 65392, '\P{Lb= -cj}', "");
    Expect(1, 65392, '\P{^Lb= -cj}', "");
    Expect(0, 65393, '\p{Lb= -cj}', "");
    Expect(1, 65393, '\p{^Lb= -cj}', "");
    Expect(1, 65393, '\P{Lb= -cj}', "");
    Expect(0, 65393, '\P{^Lb= -cj}', "");
    Error('\p{Is_Line_Break=/a/Conditional_Japanese_Starter}');
    Error('\P{Is_Line_Break=/a/Conditional_Japanese_Starter}');
    Expect(1, 65392, '\p{Is_Line_Break:   conditionaljapanesestarter}', "");
    Expect(0, 65392, '\p{^Is_Line_Break:   conditionaljapanesestarter}', "");
    Expect(0, 65392, '\P{Is_Line_Break:   conditionaljapanesestarter}', "");
    Expect(1, 65392, '\P{^Is_Line_Break:   conditionaljapanesestarter}', "");
    Expect(0, 65393, '\p{Is_Line_Break:   conditionaljapanesestarter}', "");
    Expect(1, 65393, '\p{^Is_Line_Break:   conditionaljapanesestarter}', "");
    Expect(1, 65393, '\P{Is_Line_Break:   conditionaljapanesestarter}', "");
    Expect(0, 65393, '\P{^Is_Line_Break:   conditionaljapanesestarter}', "");
    Expect(1, 65392, '\p{Is_Line_Break=	conditional_JAPANESE_starter}', "");
    Expect(0, 65392, '\p{^Is_Line_Break=	conditional_JAPANESE_starter}', "");
    Expect(0, 65392, '\P{Is_Line_Break=	conditional_JAPANESE_starter}', "");
    Expect(1, 65392, '\P{^Is_Line_Break=	conditional_JAPANESE_starter}', "");
    Expect(0, 65393, '\p{Is_Line_Break=	conditional_JAPANESE_starter}', "");
    Expect(1, 65393, '\p{^Is_Line_Break=	conditional_JAPANESE_starter}', "");
    Expect(1, 65393, '\P{Is_Line_Break=	conditional_JAPANESE_starter}', "");
    Expect(0, 65393, '\P{^Is_Line_Break=	conditional_JAPANESE_starter}', "");
    Error('\p{Is_Lb=	:=CJ}');
    Error('\P{Is_Lb=	:=CJ}');
    Expect(1, 65392, '\p{Is_Lb=cj}', "");
    Expect(0, 65392, '\p{^Is_Lb=cj}', "");
    Expect(0, 65392, '\P{Is_Lb=cj}', "");
    Expect(1, 65392, '\P{^Is_Lb=cj}', "");
    Expect(0, 65393, '\p{Is_Lb=cj}', "");
    Expect(1, 65393, '\p{^Is_Lb=cj}', "");
    Expect(1, 65393, '\P{Is_Lb=cj}', "");
    Expect(0, 65393, '\P{^Is_Lb=cj}', "");
    Expect(1, 65392, '\p{Is_Lb=-	CJ}', "");
    Expect(0, 65392, '\p{^Is_Lb=-	CJ}', "");
    Expect(0, 65392, '\P{Is_Lb=-	CJ}', "");
    Expect(1, 65392, '\P{^Is_Lb=-	CJ}', "");
    Expect(0, 65393, '\p{Is_Lb=-	CJ}', "");
    Expect(1, 65393, '\p{^Is_Lb=-	CJ}', "");
    Expect(1, 65393, '\P{Is_Lb=-	CJ}', "");
    Expect(0, 65393, '\P{^Is_Lb=-	CJ}', "");
    Error('\p{Line_Break=-:=close_punctuation}');
    Error('\P{Line_Break=-:=close_punctuation}');
    Expect(1, 83407, '\p{Line_Break=closepunctuation}', "");
    Expect(0, 83407, '\p{^Line_Break=closepunctuation}', "");
    Expect(0, 83407, '\P{Line_Break=closepunctuation}', "");
    Expect(1, 83407, '\P{^Line_Break=closepunctuation}', "");
    Expect(0, 83408, '\p{Line_Break=closepunctuation}', "");
    Expect(1, 83408, '\p{^Line_Break=closepunctuation}', "");
    Expect(1, 83408, '\P{Line_Break=closepunctuation}', "");
    Expect(0, 83408, '\P{^Line_Break=closepunctuation}', "");
    Expect(1, 83407, '\p{Line_Break= Close_PUNCTUATION}', "");
    Expect(0, 83407, '\p{^Line_Break= Close_PUNCTUATION}', "");
    Expect(0, 83407, '\P{Line_Break= Close_PUNCTUATION}', "");
    Expect(1, 83407, '\P{^Line_Break= Close_PUNCTUATION}', "");
    Expect(0, 83408, '\p{Line_Break= Close_PUNCTUATION}', "");
    Expect(1, 83408, '\p{^Line_Break= Close_PUNCTUATION}', "");
    Expect(1, 83408, '\P{Line_Break= Close_PUNCTUATION}', "");
    Expect(0, 83408, '\P{^Line_Break= Close_PUNCTUATION}', "");
    Error('\p{Lb:	:=  CL}');
    Error('\P{Lb:	:=  CL}');
    Expect(1, 83407, '\p{Lb:   cl}', "");
    Expect(0, 83407, '\p{^Lb:   cl}', "");
    Expect(0, 83407, '\P{Lb:   cl}', "");
    Expect(1, 83407, '\P{^Lb:   cl}', "");
    Expect(0, 83408, '\p{Lb:   cl}', "");
    Expect(1, 83408, '\p{^Lb:   cl}', "");
    Expect(1, 83408, '\P{Lb:   cl}', "");
    Expect(0, 83408, '\P{^Lb:   cl}', "");
    Expect(1, 83407, '\p{Lb=_-cl}', "");
    Expect(0, 83407, '\p{^Lb=_-cl}', "");
    Expect(0, 83407, '\P{Lb=_-cl}', "");
    Expect(1, 83407, '\P{^Lb=_-cl}', "");
    Expect(0, 83408, '\p{Lb=_-cl}', "");
    Expect(1, 83408, '\p{^Lb=_-cl}', "");
    Expect(1, 83408, '\P{Lb=_-cl}', "");
    Expect(0, 83408, '\P{^Lb=_-cl}', "");
    Error('\p{Is_Line_Break:   :=Close_Punctuation}');
    Error('\P{Is_Line_Break:   :=Close_Punctuation}');
    Expect(1, 83407, '\p{Is_Line_Break=closepunctuation}', "");
    Expect(0, 83407, '\p{^Is_Line_Break=closepunctuation}', "");
    Expect(0, 83407, '\P{Is_Line_Break=closepunctuation}', "");
    Expect(1, 83407, '\P{^Is_Line_Break=closepunctuation}', "");
    Expect(0, 83408, '\p{Is_Line_Break=closepunctuation}', "");
    Expect(1, 83408, '\p{^Is_Line_Break=closepunctuation}', "");
    Expect(1, 83408, '\P{Is_Line_Break=closepunctuation}', "");
    Expect(0, 83408, '\P{^Is_Line_Break=closepunctuation}', "");
    Expect(1, 83407, '\p{Is_Line_Break=_Close_punctuation}', "");
    Expect(0, 83407, '\p{^Is_Line_Break=_Close_punctuation}', "");
    Expect(0, 83407, '\P{Is_Line_Break=_Close_punctuation}', "");
    Expect(1, 83407, '\P{^Is_Line_Break=_Close_punctuation}', "");
    Expect(0, 83408, '\p{Is_Line_Break=_Close_punctuation}', "");
    Expect(1, 83408, '\p{^Is_Line_Break=_Close_punctuation}', "");
    Expect(1, 83408, '\P{Is_Line_Break=_Close_punctuation}', "");
    Expect(0, 83408, '\P{^Is_Line_Break=_Close_punctuation}', "");
    Error('\p{Is_Lb=/a/--CL}');
    Error('\P{Is_Lb=/a/--CL}');
    Expect(1, 83407, '\p{Is_Lb=cl}', "");
    Expect(0, 83407, '\p{^Is_Lb=cl}', "");
    Expect(0, 83407, '\P{Is_Lb=cl}', "");
    Expect(1, 83407, '\P{^Is_Lb=cl}', "");
    Expect(0, 83408, '\p{Is_Lb=cl}', "");
    Expect(1, 83408, '\p{^Is_Lb=cl}', "");
    Expect(1, 83408, '\P{Is_Lb=cl}', "");
    Expect(0, 83408, '\P{^Is_Lb=cl}', "");
    Expect(1, 83407, '\p{Is_Lb=-cl}', "");
    Expect(0, 83407, '\p{^Is_Lb=-cl}', "");
    Expect(0, 83407, '\P{Is_Lb=-cl}', "");
    Expect(1, 83407, '\P{^Is_Lb=-cl}', "");
    Expect(0, 83408, '\p{Is_Lb=-cl}', "");
    Expect(1, 83408, '\p{^Is_Lb=-cl}', "");
    Expect(1, 83408, '\P{Is_Lb=-cl}', "");
    Expect(0, 83408, '\P{^Is_Lb=-cl}', "");
    Error('\p{Line_Break=	/a/Combining_Mark}');
    Error('\P{Line_Break=	/a/Combining_Mark}');
    Expect(1, 917999, '\p{Line_Break=combiningmark}', "");
    Expect(0, 917999, '\p{^Line_Break=combiningmark}', "");
    Expect(0, 917999, '\P{Line_Break=combiningmark}', "");
    Expect(1, 917999, '\P{^Line_Break=combiningmark}', "");
    Expect(0, 918000, '\p{Line_Break=combiningmark}', "");
    Expect(1, 918000, '\p{^Line_Break=combiningmark}', "");
    Expect(1, 918000, '\P{Line_Break=combiningmark}', "");
    Expect(0, 918000, '\P{^Line_Break=combiningmark}', "");
    Expect(1, 917999, '\p{Line_Break=-_combining_MARK}', "");
    Expect(0, 917999, '\p{^Line_Break=-_combining_MARK}', "");
    Expect(0, 917999, '\P{Line_Break=-_combining_MARK}', "");
    Expect(1, 917999, '\P{^Line_Break=-_combining_MARK}', "");
    Expect(0, 918000, '\p{Line_Break=-_combining_MARK}', "");
    Expect(1, 918000, '\p{^Line_Break=-_combining_MARK}', "");
    Expect(1, 918000, '\P{Line_Break=-_combining_MARK}', "");
    Expect(0, 918000, '\P{^Line_Break=-_combining_MARK}', "");
    Error('\p{Lb=/a/_cm}');
    Error('\P{Lb=/a/_cm}');
    Expect(1, 917999, '\p{Lb=cm}', "");
    Expect(0, 917999, '\p{^Lb=cm}', "");
    Expect(0, 917999, '\P{Lb=cm}', "");
    Expect(1, 917999, '\P{^Lb=cm}', "");
    Expect(0, 918000, '\p{Lb=cm}', "");
    Expect(1, 918000, '\p{^Lb=cm}', "");
    Expect(1, 918000, '\P{Lb=cm}', "");
    Expect(0, 918000, '\P{^Lb=cm}', "");
    Expect(1, 917999, '\p{Lb=__CM}', "");
    Expect(0, 917999, '\p{^Lb=__CM}', "");
    Expect(0, 917999, '\P{Lb=__CM}', "");
    Expect(1, 917999, '\P{^Lb=__CM}', "");
    Expect(0, 918000, '\p{Lb=__CM}', "");
    Expect(1, 918000, '\p{^Lb=__CM}', "");
    Expect(1, 918000, '\P{Lb=__CM}', "");
    Expect(0, 918000, '\P{^Lb=__CM}', "");
    Error('\p{Is_Line_Break=:=_-Combining_MARK}');
    Error('\P{Is_Line_Break=:=_-Combining_MARK}');
    Expect(1, 917999, '\p{Is_Line_Break=combiningmark}', "");
    Expect(0, 917999, '\p{^Is_Line_Break=combiningmark}', "");
    Expect(0, 917999, '\P{Is_Line_Break=combiningmark}', "");
    Expect(1, 917999, '\P{^Is_Line_Break=combiningmark}', "");
    Expect(0, 918000, '\p{Is_Line_Break=combiningmark}', "");
    Expect(1, 918000, '\p{^Is_Line_Break=combiningmark}', "");
    Expect(1, 918000, '\P{Is_Line_Break=combiningmark}', "");
    Expect(0, 918000, '\P{^Is_Line_Break=combiningmark}', "");
    Expect(1, 917999, '\p{Is_Line_Break=	 combining_MARK}', "");
    Expect(0, 917999, '\p{^Is_Line_Break=	 combining_MARK}', "");
    Expect(0, 917999, '\P{Is_Line_Break=	 combining_MARK}', "");
    Expect(1, 917999, '\P{^Is_Line_Break=	 combining_MARK}', "");
    Expect(0, 918000, '\p{Is_Line_Break=	 combining_MARK}', "");
    Expect(1, 918000, '\p{^Is_Line_Break=	 combining_MARK}', "");
    Expect(1, 918000, '\P{Is_Line_Break=	 combining_MARK}', "");
    Expect(0, 918000, '\P{^Is_Line_Break=	 combining_MARK}', "");
    Error('\p{Is_Lb:   := cm}');
    Error('\P{Is_Lb:   := cm}');
    Expect(1, 917999, '\p{Is_Lb=cm}', "");
    Expect(0, 917999, '\p{^Is_Lb=cm}', "");
    Expect(0, 917999, '\P{Is_Lb=cm}', "");
    Expect(1, 917999, '\P{^Is_Lb=cm}', "");
    Expect(0, 918000, '\p{Is_Lb=cm}', "");
    Expect(1, 918000, '\p{^Is_Lb=cm}', "");
    Expect(1, 918000, '\P{Is_Lb=cm}', "");
    Expect(0, 918000, '\P{^Is_Lb=cm}', "");
    Expect(1, 917999, '\p{Is_Lb=__cm}', "");
    Expect(0, 917999, '\p{^Is_Lb=__cm}', "");
    Expect(0, 917999, '\P{Is_Lb=__cm}', "");
    Expect(1, 917999, '\P{^Is_Lb=__cm}', "");
    Expect(0, 918000, '\p{Is_Lb=__cm}', "");
    Expect(1, 918000, '\p{^Is_Lb=__cm}', "");
    Expect(1, 918000, '\P{Is_Lb=__cm}', "");
    Expect(0, 918000, '\P{^Is_Lb=__cm}', "");
    Error('\p{Line_Break=_ Close_Parenthesis:=}');
    Error('\P{Line_Break=_ Close_Parenthesis:=}');
    Expect(1, 93, '\p{Line_Break=closeparenthesis}', "");
    Expect(0, 93, '\p{^Line_Break=closeparenthesis}', "");
    Expect(0, 93, '\P{Line_Break=closeparenthesis}', "");
    Expect(1, 93, '\P{^Line_Break=closeparenthesis}', "");
    Expect(0, 94, '\p{Line_Break=closeparenthesis}', "");
    Expect(1, 94, '\p{^Line_Break=closeparenthesis}', "");
    Expect(1, 94, '\P{Line_Break=closeparenthesis}', "");
    Expect(0, 94, '\P{^Line_Break=closeparenthesis}', "");
    Expect(1, 93, '\p{Line_Break=-_close_Parenthesis}', "");
    Expect(0, 93, '\p{^Line_Break=-_close_Parenthesis}', "");
    Expect(0, 93, '\P{Line_Break=-_close_Parenthesis}', "");
    Expect(1, 93, '\P{^Line_Break=-_close_Parenthesis}', "");
    Expect(0, 94, '\p{Line_Break=-_close_Parenthesis}', "");
    Expect(1, 94, '\p{^Line_Break=-_close_Parenthesis}', "");
    Expect(1, 94, '\P{Line_Break=-_close_Parenthesis}', "");
    Expect(0, 94, '\P{^Line_Break=-_close_Parenthesis}', "");
    Error('\p{Lb=_	CP:=}');
    Error('\P{Lb=_	CP:=}');
    Expect(1, 93, '\p{Lb=cp}', "");
    Expect(0, 93, '\p{^Lb=cp}', "");
    Expect(0, 93, '\P{Lb=cp}', "");
    Expect(1, 93, '\P{^Lb=cp}', "");
    Expect(0, 94, '\p{Lb=cp}', "");
    Expect(1, 94, '\p{^Lb=cp}', "");
    Expect(1, 94, '\P{Lb=cp}', "");
    Expect(0, 94, '\P{^Lb=cp}', "");
    Expect(1, 93, '\p{Lb=_CP}', "");
    Expect(0, 93, '\p{^Lb=_CP}', "");
    Expect(0, 93, '\P{Lb=_CP}', "");
    Expect(1, 93, '\P{^Lb=_CP}', "");
    Expect(0, 94, '\p{Lb=_CP}', "");
    Expect(1, 94, '\p{^Lb=_CP}', "");
    Expect(1, 94, '\P{Lb=_CP}', "");
    Expect(0, 94, '\P{^Lb=_CP}', "");
    Error('\p{Is_Line_Break=:= _Close_Parenthesis}');
    Error('\P{Is_Line_Break=:= _Close_Parenthesis}');
    Expect(1, 93, '\p{Is_Line_Break=closeparenthesis}', "");
    Expect(0, 93, '\p{^Is_Line_Break=closeparenthesis}', "");
    Expect(0, 93, '\P{Is_Line_Break=closeparenthesis}', "");
    Expect(1, 93, '\P{^Is_Line_Break=closeparenthesis}', "");
    Expect(0, 94, '\p{Is_Line_Break=closeparenthesis}', "");
    Expect(1, 94, '\p{^Is_Line_Break=closeparenthesis}', "");
    Expect(1, 94, '\P{Is_Line_Break=closeparenthesis}', "");
    Expect(0, 94, '\P{^Is_Line_Break=closeparenthesis}', "");
    Expect(1, 93, '\p{Is_Line_Break=-Close_PARENTHESIS}', "");
    Expect(0, 93, '\p{^Is_Line_Break=-Close_PARENTHESIS}', "");
    Expect(0, 93, '\P{Is_Line_Break=-Close_PARENTHESIS}', "");
    Expect(1, 93, '\P{^Is_Line_Break=-Close_PARENTHESIS}', "");
    Expect(0, 94, '\p{Is_Line_Break=-Close_PARENTHESIS}', "");
    Expect(1, 94, '\p{^Is_Line_Break=-Close_PARENTHESIS}', "");
    Expect(1, 94, '\P{Is_Line_Break=-Close_PARENTHESIS}', "");
    Expect(0, 94, '\P{^Is_Line_Break=-Close_PARENTHESIS}', "");
    Error('\p{Is_Lb=/a/ 	cp}');
    Error('\P{Is_Lb=/a/ 	cp}');
    Expect(1, 93, '\p{Is_Lb=cp}', "");
    Expect(0, 93, '\p{^Is_Lb=cp}', "");
    Expect(0, 93, '\P{Is_Lb=cp}', "");
    Expect(1, 93, '\P{^Is_Lb=cp}', "");
    Expect(0, 94, '\p{Is_Lb=cp}', "");
    Expect(1, 94, '\p{^Is_Lb=cp}', "");
    Expect(1, 94, '\P{Is_Lb=cp}', "");
    Expect(0, 94, '\P{^Is_Lb=cp}', "");
    Expect(1, 93, '\p{Is_Lb= 	CP}', "");
    Expect(0, 93, '\p{^Is_Lb= 	CP}', "");
    Expect(0, 93, '\P{Is_Lb= 	CP}', "");
    Expect(1, 93, '\P{^Is_Lb= 	CP}', "");
    Expect(0, 94, '\p{Is_Lb= 	CP}', "");
    Expect(1, 94, '\p{^Is_Lb= 	CP}', "");
    Expect(1, 94, '\P{Is_Lb= 	CP}', "");
    Expect(0, 94, '\P{^Is_Lb= 	CP}', "");
    Error('\p{Line_Break=	/a/Carriage_RETURN}');
    Error('\P{Line_Break=	/a/Carriage_RETURN}');
    Expect(1, 13, '\p{Line_Break:   carriagereturn}', "");
    Expect(0, 13, '\p{^Line_Break:   carriagereturn}', "");
    Expect(0, 13, '\P{Line_Break:   carriagereturn}', "");
    Expect(1, 13, '\P{^Line_Break:   carriagereturn}', "");
    Expect(0, 14, '\p{Line_Break:   carriagereturn}', "");
    Expect(1, 14, '\p{^Line_Break:   carriagereturn}', "");
    Expect(1, 14, '\P{Line_Break:   carriagereturn}', "");
    Expect(0, 14, '\P{^Line_Break:   carriagereturn}', "");
    Expect(1, 13, '\p{Line_Break=-carriage_RETURN}', "");
    Expect(0, 13, '\p{^Line_Break=-carriage_RETURN}', "");
    Expect(0, 13, '\P{Line_Break=-carriage_RETURN}', "");
    Expect(1, 13, '\P{^Line_Break=-carriage_RETURN}', "");
    Expect(0, 14, '\p{Line_Break=-carriage_RETURN}', "");
    Expect(1, 14, '\p{^Line_Break=-carriage_RETURN}', "");
    Expect(1, 14, '\P{Line_Break=-carriage_RETURN}', "");
    Expect(0, 14, '\P{^Line_Break=-carriage_RETURN}', "");
    Error('\p{Lb=:=_	CR}');
    Error('\P{Lb=:=_	CR}');
    Expect(1, 13, '\p{Lb=cr}', "");
    Expect(0, 13, '\p{^Lb=cr}', "");
    Expect(0, 13, '\P{Lb=cr}', "");
    Expect(1, 13, '\P{^Lb=cr}', "");
    Expect(0, 14, '\p{Lb=cr}', "");
    Expect(1, 14, '\p{^Lb=cr}', "");
    Expect(1, 14, '\P{Lb=cr}', "");
    Expect(0, 14, '\P{^Lb=cr}', "");
    Expect(1, 13, '\p{Lb=	_CR}', "");
    Expect(0, 13, '\p{^Lb=	_CR}', "");
    Expect(0, 13, '\P{Lb=	_CR}', "");
    Expect(1, 13, '\P{^Lb=	_CR}', "");
    Expect(0, 14, '\p{Lb=	_CR}', "");
    Expect(1, 14, '\p{^Lb=	_CR}', "");
    Expect(1, 14, '\P{Lb=	_CR}', "");
    Expect(0, 14, '\P{^Lb=	_CR}', "");
    Error('\p{Is_Line_Break:   :=CARRIAGE_Return}');
    Error('\P{Is_Line_Break:   :=CARRIAGE_Return}');
    Expect(1, 13, '\p{Is_Line_Break=carriagereturn}', "");
    Expect(0, 13, '\p{^Is_Line_Break=carriagereturn}', "");
    Expect(0, 13, '\P{Is_Line_Break=carriagereturn}', "");
    Expect(1, 13, '\P{^Is_Line_Break=carriagereturn}', "");
    Expect(0, 14, '\p{Is_Line_Break=carriagereturn}', "");
    Expect(1, 14, '\p{^Is_Line_Break=carriagereturn}', "");
    Expect(1, 14, '\P{Is_Line_Break=carriagereturn}', "");
    Expect(0, 14, '\P{^Is_Line_Break=carriagereturn}', "");
    Expect(1, 13, '\p{Is_Line_Break= -Carriage_Return}', "");
    Expect(0, 13, '\p{^Is_Line_Break= -Carriage_Return}', "");
    Expect(0, 13, '\P{Is_Line_Break= -Carriage_Return}', "");
    Expect(1, 13, '\P{^Is_Line_Break= -Carriage_Return}', "");
    Expect(0, 14, '\p{Is_Line_Break= -Carriage_Return}', "");
    Expect(1, 14, '\p{^Is_Line_Break= -Carriage_Return}', "");
    Expect(1, 14, '\P{Is_Line_Break= -Carriage_Return}', "");
    Expect(0, 14, '\P{^Is_Line_Break= -Carriage_Return}', "");
    Error('\p{Is_Lb:     CR/a/}');
    Error('\P{Is_Lb:     CR/a/}');
    Expect(1, 13, '\p{Is_Lb=cr}', "");
    Expect(0, 13, '\p{^Is_Lb=cr}', "");
    Expect(0, 13, '\P{Is_Lb=cr}', "");
    Expect(1, 13, '\P{^Is_Lb=cr}', "");
    Expect(0, 14, '\p{Is_Lb=cr}', "");
    Expect(1, 14, '\p{^Is_Lb=cr}', "");
    Expect(1, 14, '\P{Is_Lb=cr}', "");
    Expect(0, 14, '\P{^Is_Lb=cr}', "");
    Expect(1, 13, '\p{Is_Lb=CR}', "");
    Expect(0, 13, '\p{^Is_Lb=CR}', "");
    Expect(0, 13, '\P{Is_Lb=CR}', "");
    Expect(1, 13, '\P{^Is_Lb=CR}', "");
    Expect(0, 14, '\p{Is_Lb=CR}', "");
    Expect(1, 14, '\p{^Is_Lb=CR}', "");
    Expect(1, 14, '\P{Is_Lb=CR}', "");
    Expect(0, 14, '\P{^Is_Lb=CR}', "");
    Error('\p{Line_Break=-/a/E_base}');
    Error('\P{Line_Break=-/a/E_base}');
    Expect(1, 129501, '\p{Line_Break:	ebase}', "");
    Expect(0, 129501, '\p{^Line_Break:	ebase}', "");
    Expect(0, 129501, '\P{Line_Break:	ebase}', "");
    Expect(1, 129501, '\P{^Line_Break:	ebase}', "");
    Expect(0, 129502, '\p{Line_Break:	ebase}', "");
    Expect(1, 129502, '\p{^Line_Break:	ebase}', "");
    Expect(1, 129502, '\P{Line_Break:	ebase}', "");
    Expect(0, 129502, '\P{^Line_Break:	ebase}', "");
    Expect(1, 129501, '\p{Line_Break= 	E_BASE}', "");
    Expect(0, 129501, '\p{^Line_Break= 	E_BASE}', "");
    Expect(0, 129501, '\P{Line_Break= 	E_BASE}', "");
    Expect(1, 129501, '\P{^Line_Break= 	E_BASE}', "");
    Expect(0, 129502, '\p{Line_Break= 	E_BASE}', "");
    Expect(1, 129502, '\p{^Line_Break= 	E_BASE}', "");
    Expect(1, 129502, '\P{Line_Break= 	E_BASE}', "");
    Expect(0, 129502, '\P{^Line_Break= 	E_BASE}', "");
    Error('\p{Lb:	/a/EB}');
    Error('\P{Lb:	/a/EB}');
    Expect(1, 129501, '\p{Lb=eb}', "");
    Expect(0, 129501, '\p{^Lb=eb}', "");
    Expect(0, 129501, '\P{Lb=eb}', "");
    Expect(1, 129501, '\P{^Lb=eb}', "");
    Expect(0, 129502, '\p{Lb=eb}', "");
    Expect(1, 129502, '\p{^Lb=eb}', "");
    Expect(1, 129502, '\P{Lb=eb}', "");
    Expect(0, 129502, '\P{^Lb=eb}', "");
    Expect(1, 129501, '\p{Lb=_EB}', "");
    Expect(0, 129501, '\p{^Lb=_EB}', "");
    Expect(0, 129501, '\P{Lb=_EB}', "");
    Expect(1, 129501, '\P{^Lb=_EB}', "");
    Expect(0, 129502, '\p{Lb=_EB}', "");
    Expect(1, 129502, '\p{^Lb=_EB}', "");
    Expect(1, 129502, '\P{Lb=_EB}', "");
    Expect(0, 129502, '\P{^Lb=_EB}', "");
    Error('\p{Is_Line_Break=_e_BASE/a/}');
    Error('\P{Is_Line_Break=_e_BASE/a/}');
    Expect(1, 129501, '\p{Is_Line_Break=ebase}', "");
    Expect(0, 129501, '\p{^Is_Line_Break=ebase}', "");
    Expect(0, 129501, '\P{Is_Line_Break=ebase}', "");
    Expect(1, 129501, '\P{^Is_Line_Break=ebase}', "");
    Expect(0, 129502, '\p{Is_Line_Break=ebase}', "");
    Expect(1, 129502, '\p{^Is_Line_Break=ebase}', "");
    Expect(1, 129502, '\P{Is_Line_Break=ebase}', "");
    Expect(0, 129502, '\P{^Is_Line_Break=ebase}', "");
    Expect(1, 129501, '\p{Is_Line_Break=	e_Base}', "");
    Expect(0, 129501, '\p{^Is_Line_Break=	e_Base}', "");
    Expect(0, 129501, '\P{Is_Line_Break=	e_Base}', "");
    Expect(1, 129501, '\P{^Is_Line_Break=	e_Base}', "");
    Expect(0, 129502, '\p{Is_Line_Break=	e_Base}', "");
    Expect(1, 129502, '\p{^Is_Line_Break=	e_Base}', "");
    Expect(1, 129502, '\P{Is_Line_Break=	e_Base}', "");
    Expect(0, 129502, '\P{^Is_Line_Break=	e_Base}', "");
    Error('\p{Is_Lb=_eb:=}');
    Error('\P{Is_Lb=_eb:=}');
    Expect(1, 129501, '\p{Is_Lb=eb}', "");
    Expect(0, 129501, '\p{^Is_Lb=eb}', "");
    Expect(0, 129501, '\P{Is_Lb=eb}', "");
    Expect(1, 129501, '\P{^Is_Lb=eb}', "");
    Expect(0, 129502, '\p{Is_Lb=eb}', "");
    Expect(1, 129502, '\p{^Is_Lb=eb}', "");
    Expect(1, 129502, '\P{Is_Lb=eb}', "");
    Expect(0, 129502, '\P{^Is_Lb=eb}', "");
    Expect(1, 129501, '\p{Is_Lb=-_EB}', "");
    Expect(0, 129501, '\p{^Is_Lb=-_EB}', "");
    Expect(0, 129501, '\P{Is_Lb=-_EB}', "");
    Expect(1, 129501, '\P{^Is_Lb=-_EB}', "");
    Expect(0, 129502, '\p{Is_Lb=-_EB}', "");
    Expect(1, 129502, '\p{^Is_Lb=-_EB}', "");
    Expect(1, 129502, '\P{Is_Lb=-_EB}', "");
    Expect(0, 129502, '\P{^Is_Lb=-_EB}', "");
    Error('\p{Line_Break=/a/ e_modifier}');
    Error('\P{Line_Break=/a/ e_modifier}');
    Expect(1, 127999, '\p{Line_Break=emodifier}', "");
    Expect(0, 127999, '\p{^Line_Break=emodifier}', "");
    Expect(0, 127999, '\P{Line_Break=emodifier}', "");
    Expect(1, 127999, '\P{^Line_Break=emodifier}', "");
    Expect(0, 128000, '\p{Line_Break=emodifier}', "");
    Expect(1, 128000, '\p{^Line_Break=emodifier}', "");
    Expect(1, 128000, '\P{Line_Break=emodifier}', "");
    Expect(0, 128000, '\P{^Line_Break=emodifier}', "");
    Expect(1, 127999, '\p{Line_Break=	 E_MODIFIER}', "");
    Expect(0, 127999, '\p{^Line_Break=	 E_MODIFIER}', "");
    Expect(0, 127999, '\P{Line_Break=	 E_MODIFIER}', "");
    Expect(1, 127999, '\P{^Line_Break=	 E_MODIFIER}', "");
    Expect(0, 128000, '\p{Line_Break=	 E_MODIFIER}', "");
    Expect(1, 128000, '\p{^Line_Break=	 E_MODIFIER}', "");
    Expect(1, 128000, '\P{Line_Break=	 E_MODIFIER}', "");
    Expect(0, 128000, '\P{^Line_Break=	 E_MODIFIER}', "");
    Error('\p{Lb=_/a/EM}');
    Error('\P{Lb=_/a/EM}');
    Expect(1, 127999, '\p{Lb=em}', "");
    Expect(0, 127999, '\p{^Lb=em}', "");
    Expect(0, 127999, '\P{Lb=em}', "");
    Expect(1, 127999, '\P{^Lb=em}', "");
    Expect(0, 128000, '\p{Lb=em}', "");
    Expect(1, 128000, '\p{^Lb=em}', "");
    Expect(1, 128000, '\P{Lb=em}', "");
    Expect(0, 128000, '\P{^Lb=em}', "");
    Expect(1, 127999, '\p{Lb=_ EM}', "");
    Expect(0, 127999, '\p{^Lb=_ EM}', "");
    Expect(0, 127999, '\P{Lb=_ EM}', "");
    Expect(1, 127999, '\P{^Lb=_ EM}', "");
    Expect(0, 128000, '\p{Lb=_ EM}', "");
    Expect(1, 128000, '\p{^Lb=_ EM}', "");
    Expect(1, 128000, '\P{Lb=_ EM}', "");
    Expect(0, 128000, '\P{^Lb=_ EM}', "");
    Error('\p{Is_Line_Break=:= -E_Modifier}');
    Error('\P{Is_Line_Break=:= -E_Modifier}');
    Expect(1, 127999, '\p{Is_Line_Break=emodifier}', "");
    Expect(0, 127999, '\p{^Is_Line_Break=emodifier}', "");
    Expect(0, 127999, '\P{Is_Line_Break=emodifier}', "");
    Expect(1, 127999, '\P{^Is_Line_Break=emodifier}', "");
    Expect(0, 128000, '\p{Is_Line_Break=emodifier}', "");
    Expect(1, 128000, '\p{^Is_Line_Break=emodifier}', "");
    Expect(1, 128000, '\P{Is_Line_Break=emodifier}', "");
    Expect(0, 128000, '\P{^Is_Line_Break=emodifier}', "");
    Expect(1, 127999, '\p{Is_Line_Break=- E_Modifier}', "");
    Expect(0, 127999, '\p{^Is_Line_Break=- E_Modifier}', "");
    Expect(0, 127999, '\P{Is_Line_Break=- E_Modifier}', "");
    Expect(1, 127999, '\P{^Is_Line_Break=- E_Modifier}', "");
    Expect(0, 128000, '\p{Is_Line_Break=- E_Modifier}', "");
    Expect(1, 128000, '\p{^Is_Line_Break=- E_Modifier}', "");
    Expect(1, 128000, '\P{Is_Line_Break=- E_Modifier}', "");
    Expect(0, 128000, '\P{^Is_Line_Break=- E_Modifier}', "");
    Error('\p{Is_Lb=:=	_EM}');
    Error('\P{Is_Lb=:=	_EM}');
    Expect(1, 127999, '\p{Is_Lb=em}', "");
    Expect(0, 127999, '\p{^Is_Lb=em}', "");
    Expect(0, 127999, '\P{Is_Lb=em}', "");
    Expect(1, 127999, '\P{^Is_Lb=em}', "");
    Expect(0, 128000, '\p{Is_Lb=em}', "");
    Expect(1, 128000, '\p{^Is_Lb=em}', "");
    Expect(1, 128000, '\P{Is_Lb=em}', "");
    Expect(0, 128000, '\P{^Is_Lb=em}', "");
    Expect(1, 127999, '\p{Is_Lb=- EM}', "");
    Expect(0, 127999, '\p{^Is_Lb=- EM}', "");
    Expect(0, 127999, '\P{Is_Lb=- EM}', "");
    Expect(1, 127999, '\P{^Is_Lb=- EM}', "");
    Expect(0, 128000, '\p{Is_Lb=- EM}', "");
    Expect(1, 128000, '\p{^Is_Lb=- EM}', "");
    Expect(1, 128000, '\P{Is_Lb=- EM}', "");
    Expect(0, 128000, '\P{^Is_Lb=- EM}', "");
    Error('\p{Line_Break=_:=Exclamation}');
    Error('\P{Line_Break=_:=Exclamation}');
    Expect(1, 72817, '\p{Line_Break=exclamation}', "");
    Expect(0, 72817, '\p{^Line_Break=exclamation}', "");
    Expect(0, 72817, '\P{Line_Break=exclamation}', "");
    Expect(1, 72817, '\P{^Line_Break=exclamation}', "");
    Expect(0, 72818, '\p{Line_Break=exclamation}', "");
    Expect(1, 72818, '\p{^Line_Break=exclamation}', "");
    Expect(1, 72818, '\P{Line_Break=exclamation}', "");
    Expect(0, 72818, '\P{^Line_Break=exclamation}', "");
    Expect(1, 72817, '\p{Line_Break=	EXCLAMATION}', "");
    Expect(0, 72817, '\p{^Line_Break=	EXCLAMATION}', "");
    Expect(0, 72817, '\P{Line_Break=	EXCLAMATION}', "");
    Expect(1, 72817, '\P{^Line_Break=	EXCLAMATION}', "");
    Expect(0, 72818, '\p{Line_Break=	EXCLAMATION}', "");
    Expect(1, 72818, '\p{^Line_Break=	EXCLAMATION}', "");
    Expect(1, 72818, '\P{Line_Break=	EXCLAMATION}', "");
    Expect(0, 72818, '\P{^Line_Break=	EXCLAMATION}', "");
    Error('\p{Lb=/a/-EX}');
    Error('\P{Lb=/a/-EX}');
    Expect(1, 72817, '\p{Lb=ex}', "");
    Expect(0, 72817, '\p{^Lb=ex}', "");
    Expect(0, 72817, '\P{Lb=ex}', "");
    Expect(1, 72817, '\P{^Lb=ex}', "");
    Expect(0, 72818, '\p{Lb=ex}', "");
    Expect(1, 72818, '\p{^Lb=ex}', "");
    Expect(1, 72818, '\P{Lb=ex}', "");
    Expect(0, 72818, '\P{^Lb=ex}', "");
    Expect(1, 72817, '\p{Lb=	EX}', "");
    Expect(0, 72817, '\p{^Lb=	EX}', "");
    Expect(0, 72817, '\P{Lb=	EX}', "");
    Expect(1, 72817, '\P{^Lb=	EX}', "");
    Expect(0, 72818, '\p{Lb=	EX}', "");
    Expect(1, 72818, '\p{^Lb=	EX}', "");
    Expect(1, 72818, '\P{Lb=	EX}', "");
    Expect(0, 72818, '\P{^Lb=	EX}', "");
    Error('\p{Is_Line_Break= Exclamation:=}');
    Error('\P{Is_Line_Break= Exclamation:=}');
    Expect(1, 72817, '\p{Is_Line_Break=exclamation}', "");
    Expect(0, 72817, '\p{^Is_Line_Break=exclamation}', "");
    Expect(0, 72817, '\P{Is_Line_Break=exclamation}', "");
    Expect(1, 72817, '\P{^Is_Line_Break=exclamation}', "");
    Expect(0, 72818, '\p{Is_Line_Break=exclamation}', "");
    Expect(1, 72818, '\p{^Is_Line_Break=exclamation}', "");
    Expect(1, 72818, '\P{Is_Line_Break=exclamation}', "");
    Expect(0, 72818, '\P{^Is_Line_Break=exclamation}', "");
    Expect(1, 72817, '\p{Is_Line_Break=__exclamation}', "");
    Expect(0, 72817, '\p{^Is_Line_Break=__exclamation}', "");
    Expect(0, 72817, '\P{Is_Line_Break=__exclamation}', "");
    Expect(1, 72817, '\P{^Is_Line_Break=__exclamation}', "");
    Expect(0, 72818, '\p{Is_Line_Break=__exclamation}', "");
    Expect(1, 72818, '\p{^Is_Line_Break=__exclamation}', "");
    Expect(1, 72818, '\P{Is_Line_Break=__exclamation}', "");
    Expect(0, 72818, '\P{^Is_Line_Break=__exclamation}', "");
    Error('\p{Is_Lb=__EX:=}');
    Error('\P{Is_Lb=__EX:=}');
    Expect(1, 72817, '\p{Is_Lb=ex}', "");
    Expect(0, 72817, '\p{^Is_Lb=ex}', "");
    Expect(0, 72817, '\P{Is_Lb=ex}', "");
    Expect(1, 72817, '\P{^Is_Lb=ex}', "");
    Expect(0, 72818, '\p{Is_Lb=ex}', "");
    Expect(1, 72818, '\p{^Is_Lb=ex}', "");
    Expect(1, 72818, '\P{Is_Lb=ex}', "");
    Expect(0, 72818, '\P{^Is_Lb=ex}', "");
    Expect(1, 72817, '\p{Is_Lb=_	EX}', "");
    Expect(0, 72817, '\p{^Is_Lb=_	EX}', "");
    Expect(0, 72817, '\P{Is_Lb=_	EX}', "");
    Expect(1, 72817, '\P{^Is_Lb=_	EX}', "");
    Expect(0, 72818, '\p{Is_Lb=_	EX}', "");
    Expect(1, 72818, '\p{^Is_Lb=_	EX}', "");
    Expect(1, 72818, '\P{Is_Lb=_	EX}', "");
    Expect(0, 72818, '\P{^Is_Lb=_	EX}', "");
    Error('\p{Line_Break= glue:=}');
    Error('\P{Line_Break= glue:=}');
    Expect(1, 8239, '\p{Line_Break=glue}', "");
    Expect(0, 8239, '\p{^Line_Break=glue}', "");
    Expect(0, 8239, '\P{Line_Break=glue}', "");
    Expect(1, 8239, '\P{^Line_Break=glue}', "");
    Expect(0, 8240, '\p{Line_Break=glue}', "");
    Expect(1, 8240, '\p{^Line_Break=glue}', "");
    Expect(1, 8240, '\P{Line_Break=glue}', "");
    Expect(0, 8240, '\P{^Line_Break=glue}', "");
    Expect(1, 8239, '\p{Line_Break:   	 glue}', "");
    Expect(0, 8239, '\p{^Line_Break:   	 glue}', "");
    Expect(0, 8239, '\P{Line_Break:   	 glue}', "");
    Expect(1, 8239, '\P{^Line_Break:   	 glue}', "");
    Expect(0, 8240, '\p{Line_Break:   	 glue}', "");
    Expect(1, 8240, '\p{^Line_Break:   	 glue}', "");
    Expect(1, 8240, '\P{Line_Break:   	 glue}', "");
    Expect(0, 8240, '\P{^Line_Break:   	 glue}', "");
    Error('\p{Lb=/a/_ GL}');
    Error('\P{Lb=/a/_ GL}');
    Expect(1, 8239, '\p{Lb=gl}', "");
    Expect(0, 8239, '\p{^Lb=gl}', "");
    Expect(0, 8239, '\P{Lb=gl}', "");
    Expect(1, 8239, '\P{^Lb=gl}', "");
    Expect(0, 8240, '\p{Lb=gl}', "");
    Expect(1, 8240, '\p{^Lb=gl}', "");
    Expect(1, 8240, '\P{Lb=gl}', "");
    Expect(0, 8240, '\P{^Lb=gl}', "");
    Expect(1, 8239, '\p{Lb=_GL}', "");
    Expect(0, 8239, '\p{^Lb=_GL}', "");
    Expect(0, 8239, '\P{Lb=_GL}', "");
    Expect(1, 8239, '\P{^Lb=_GL}', "");
    Expect(0, 8240, '\p{Lb=_GL}', "");
    Expect(1, 8240, '\p{^Lb=_GL}', "");
    Expect(1, 8240, '\P{Lb=_GL}', "");
    Expect(0, 8240, '\P{^Lb=_GL}', "");
    Error('\p{Is_Line_Break=_:=glue}');
    Error('\P{Is_Line_Break=_:=glue}');
    Expect(1, 8239, '\p{Is_Line_Break=glue}', "");
    Expect(0, 8239, '\p{^Is_Line_Break=glue}', "");
    Expect(0, 8239, '\P{Is_Line_Break=glue}', "");
    Expect(1, 8239, '\P{^Is_Line_Break=glue}', "");
    Expect(0, 8240, '\p{Is_Line_Break=glue}', "");
    Expect(1, 8240, '\p{^Is_Line_Break=glue}', "");
    Expect(1, 8240, '\P{Is_Line_Break=glue}', "");
    Expect(0, 8240, '\P{^Is_Line_Break=glue}', "");
    Expect(1, 8239, '\p{Is_Line_Break=-	glue}', "");
    Expect(0, 8239, '\p{^Is_Line_Break=-	glue}', "");
    Expect(0, 8239, '\P{Is_Line_Break=-	glue}', "");
    Expect(1, 8239, '\P{^Is_Line_Break=-	glue}', "");
    Expect(0, 8240, '\p{Is_Line_Break=-	glue}', "");
    Expect(1, 8240, '\p{^Is_Line_Break=-	glue}', "");
    Expect(1, 8240, '\P{Is_Line_Break=-	glue}', "");
    Expect(0, 8240, '\P{^Is_Line_Break=-	glue}', "");
    Error('\p{Is_Lb=	_GL:=}');
    Error('\P{Is_Lb=	_GL:=}');
    Expect(1, 8239, '\p{Is_Lb=gl}', "");
    Expect(0, 8239, '\p{^Is_Lb=gl}', "");
    Expect(0, 8239, '\P{Is_Lb=gl}', "");
    Expect(1, 8239, '\P{^Is_Lb=gl}', "");
    Expect(0, 8240, '\p{Is_Lb=gl}', "");
    Expect(1, 8240, '\p{^Is_Lb=gl}', "");
    Expect(1, 8240, '\P{Is_Lb=gl}', "");
    Expect(0, 8240, '\P{^Is_Lb=gl}', "");
    Expect(1, 8239, '\p{Is_Lb= 	GL}', "");
    Expect(0, 8239, '\p{^Is_Lb= 	GL}', "");
    Expect(0, 8239, '\P{Is_Lb= 	GL}', "");
    Expect(1, 8239, '\P{^Is_Lb= 	GL}', "");
    Expect(0, 8240, '\p{Is_Lb= 	GL}', "");
    Expect(1, 8240, '\p{^Is_Lb= 	GL}', "");
    Expect(1, 8240, '\P{Is_Lb= 	GL}', "");
    Expect(0, 8240, '\P{^Is_Lb= 	GL}', "");
    Error('\p{Line_Break=:=	 h2}');
    Error('\P{Line_Break=:=	 h2}');
    Expect(1, 55176, '\p{Line_Break=h2}', "");
    Expect(0, 55176, '\p{^Line_Break=h2}', "");
    Expect(0, 55176, '\P{Line_Break=h2}', "");
    Expect(1, 55176, '\P{^Line_Break=h2}', "");
    Expect(0, 55177, '\p{Line_Break=h2}', "");
    Expect(1, 55177, '\p{^Line_Break=h2}', "");
    Expect(1, 55177, '\P{Line_Break=h2}', "");
    Expect(0, 55177, '\P{^Line_Break=h2}', "");
    Expect(1, 55176, '\p{Line_Break=_	H2}', "");
    Expect(0, 55176, '\p{^Line_Break=_	H2}', "");
    Expect(0, 55176, '\P{Line_Break=_	H2}', "");
    Expect(1, 55176, '\P{^Line_Break=_	H2}', "");
    Expect(0, 55177, '\p{Line_Break=_	H2}', "");
    Expect(1, 55177, '\p{^Line_Break=_	H2}', "");
    Expect(1, 55177, '\P{Line_Break=_	H2}', "");
    Expect(0, 55177, '\P{^Line_Break=_	H2}', "");
    Error('\p{Lb=	 H2:=}');
    Error('\P{Lb=	 H2:=}');
    Expect(1, 55176, '\p{Lb=h2}', "");
    Expect(0, 55176, '\p{^Lb=h2}', "");
    Expect(0, 55176, '\P{Lb=h2}', "");
    Expect(1, 55176, '\P{^Lb=h2}', "");
    Expect(0, 55177, '\p{Lb=h2}', "");
    Expect(1, 55177, '\p{^Lb=h2}', "");
    Expect(1, 55177, '\P{Lb=h2}', "");
    Expect(0, 55177, '\P{^Lb=h2}', "");
    Expect(1, 55176, '\p{Lb=-H2}', "");
    Expect(0, 55176, '\p{^Lb=-H2}', "");
    Expect(0, 55176, '\P{Lb=-H2}', "");
    Expect(1, 55176, '\P{^Lb=-H2}', "");
    Expect(0, 55177, '\p{Lb=-H2}', "");
    Expect(1, 55177, '\p{^Lb=-H2}', "");
    Expect(1, 55177, '\P{Lb=-H2}', "");
    Expect(0, 55177, '\P{^Lb=-H2}', "");
    Error('\p{Is_Line_Break=-:=H2}');
    Error('\P{Is_Line_Break=-:=H2}');
    Expect(1, 55176, '\p{Is_Line_Break=h2}', "");
    Expect(0, 55176, '\p{^Is_Line_Break=h2}', "");
    Expect(0, 55176, '\P{Is_Line_Break=h2}', "");
    Expect(1, 55176, '\P{^Is_Line_Break=h2}', "");
    Expect(0, 55177, '\p{Is_Line_Break=h2}', "");
    Expect(1, 55177, '\p{^Is_Line_Break=h2}', "");
    Expect(1, 55177, '\P{Is_Line_Break=h2}', "");
    Expect(0, 55177, '\P{^Is_Line_Break=h2}', "");
    Expect(1, 55176, '\p{Is_Line_Break= 	h2}', "");
    Expect(0, 55176, '\p{^Is_Line_Break= 	h2}', "");
    Expect(0, 55176, '\P{Is_Line_Break= 	h2}', "");
    Expect(1, 55176, '\P{^Is_Line_Break= 	h2}', "");
    Expect(0, 55177, '\p{Is_Line_Break= 	h2}', "");
    Expect(1, 55177, '\p{^Is_Line_Break= 	h2}', "");
    Expect(1, 55177, '\P{Is_Line_Break= 	h2}', "");
    Expect(0, 55177, '\P{^Is_Line_Break= 	h2}', "");
    Error('\p{Is_Lb=/a/  H2}');
    Error('\P{Is_Lb=/a/  H2}');
    Expect(1, 55176, '\p{Is_Lb=h2}', "");
    Expect(0, 55176, '\p{^Is_Lb=h2}', "");
    Expect(0, 55176, '\P{Is_Lb=h2}', "");
    Expect(1, 55176, '\P{^Is_Lb=h2}', "");
    Expect(0, 55177, '\p{Is_Lb=h2}', "");
    Expect(1, 55177, '\p{^Is_Lb=h2}', "");
    Expect(1, 55177, '\P{Is_Lb=h2}', "");
    Expect(0, 55177, '\P{^Is_Lb=h2}', "");
    Expect(1, 55176, '\p{Is_Lb=__H2}', "");
    Expect(0, 55176, '\p{^Is_Lb=__H2}', "");
    Expect(0, 55176, '\P{Is_Lb=__H2}', "");
    Expect(1, 55176, '\P{^Is_Lb=__H2}', "");
    Expect(0, 55177, '\p{Is_Lb=__H2}', "");
    Expect(1, 55177, '\p{^Is_Lb=__H2}', "");
    Expect(1, 55177, '\P{Is_Lb=__H2}', "");
    Expect(0, 55177, '\P{^Is_Lb=__H2}', "");
    Error('\p{Line_Break=	/a/H3}');
    Error('\P{Line_Break=	/a/H3}');
    Expect(1, 55203, '\p{Line_Break=h3}', "");
    Expect(0, 55203, '\p{^Line_Break=h3}', "");
    Expect(0, 55203, '\P{Line_Break=h3}', "");
    Expect(1, 55203, '\P{^Line_Break=h3}', "");
    Expect(0, 55204, '\p{Line_Break=h3}', "");
    Expect(1, 55204, '\p{^Line_Break=h3}', "");
    Expect(1, 55204, '\P{Line_Break=h3}', "");
    Expect(0, 55204, '\P{^Line_Break=h3}', "");
    Expect(1, 55203, '\p{Line_Break=-h3}', "");
    Expect(0, 55203, '\p{^Line_Break=-h3}', "");
    Expect(0, 55203, '\P{Line_Break=-h3}', "");
    Expect(1, 55203, '\P{^Line_Break=-h3}', "");
    Expect(0, 55204, '\p{Line_Break=-h3}', "");
    Expect(1, 55204, '\p{^Line_Break=-h3}', "");
    Expect(1, 55204, '\P{Line_Break=-h3}', "");
    Expect(0, 55204, '\P{^Line_Break=-h3}', "");
    Error('\p{Lb= H3:=}');
    Error('\P{Lb= H3:=}');
    Expect(1, 55203, '\p{Lb=h3}', "");
    Expect(0, 55203, '\p{^Lb=h3}', "");
    Expect(0, 55203, '\P{Lb=h3}', "");
    Expect(1, 55203, '\P{^Lb=h3}', "");
    Expect(0, 55204, '\p{Lb=h3}', "");
    Expect(1, 55204, '\p{^Lb=h3}', "");
    Expect(1, 55204, '\P{Lb=h3}', "");
    Expect(0, 55204, '\P{^Lb=h3}', "");
    Expect(1, 55203, '\p{Lb=	_H3}', "");
    Expect(0, 55203, '\p{^Lb=	_H3}', "");
    Expect(0, 55203, '\P{Lb=	_H3}', "");
    Expect(1, 55203, '\P{^Lb=	_H3}', "");
    Expect(0, 55204, '\p{Lb=	_H3}', "");
    Expect(1, 55204, '\p{^Lb=	_H3}', "");
    Expect(1, 55204, '\P{Lb=	_H3}', "");
    Expect(0, 55204, '\P{^Lb=	_H3}', "");
    Error('\p{Is_Line_Break:	 /a/H3}');
    Error('\P{Is_Line_Break:	 /a/H3}');
    Expect(1, 55203, '\p{Is_Line_Break=h3}', "");
    Expect(0, 55203, '\p{^Is_Line_Break=h3}', "");
    Expect(0, 55203, '\P{Is_Line_Break=h3}', "");
    Expect(1, 55203, '\P{^Is_Line_Break=h3}', "");
    Expect(0, 55204, '\p{Is_Line_Break=h3}', "");
    Expect(1, 55204, '\p{^Is_Line_Break=h3}', "");
    Expect(1, 55204, '\P{Is_Line_Break=h3}', "");
    Expect(0, 55204, '\P{^Is_Line_Break=h3}', "");
    Expect(1, 55203, '\p{Is_Line_Break= _H3}', "");
    Expect(0, 55203, '\p{^Is_Line_Break= _H3}', "");
    Expect(0, 55203, '\P{Is_Line_Break= _H3}', "");
    Expect(1, 55203, '\P{^Is_Line_Break= _H3}', "");
    Expect(0, 55204, '\p{Is_Line_Break= _H3}', "");
    Expect(1, 55204, '\p{^Is_Line_Break= _H3}', "");
    Expect(1, 55204, '\P{Is_Line_Break= _H3}', "");
    Expect(0, 55204, '\P{^Is_Line_Break= _H3}', "");
    Error('\p{Is_Lb= h3:=}');
    Error('\P{Is_Lb= h3:=}');
    Expect(1, 55203, '\p{Is_Lb=h3}', "");
    Expect(0, 55203, '\p{^Is_Lb=h3}', "");
    Expect(0, 55203, '\P{Is_Lb=h3}', "");
    Expect(1, 55203, '\P{^Is_Lb=h3}', "");
    Expect(0, 55204, '\p{Is_Lb=h3}', "");
    Expect(1, 55204, '\p{^Is_Lb=h3}', "");
    Expect(1, 55204, '\P{Is_Lb=h3}', "");
    Expect(0, 55204, '\P{^Is_Lb=h3}', "");
    Expect(1, 55203, '\p{Is_Lb=	_h3}', "");
    Expect(0, 55203, '\p{^Is_Lb=	_h3}', "");
    Expect(0, 55203, '\P{Is_Lb=	_h3}', "");
    Expect(1, 55203, '\P{^Is_Lb=	_h3}', "");
    Expect(0, 55204, '\p{Is_Lb=	_h3}', "");
    Expect(1, 55204, '\p{^Is_Lb=	_h3}', "");
    Expect(1, 55204, '\P{Is_Lb=	_h3}', "");
    Expect(0, 55204, '\P{^Is_Lb=	_h3}', "");
    Error('\p{Line_Break=	 Hebrew_Letter/a/}');
    Error('\P{Line_Break=	 Hebrew_Letter/a/}');
    Expect(1, 64335, '\p{Line_Break=hebrewletter}', "");
    Expect(0, 64335, '\p{^Line_Break=hebrewletter}', "");
    Expect(0, 64335, '\P{Line_Break=hebrewletter}', "");
    Expect(1, 64335, '\P{^Line_Break=hebrewletter}', "");
    Expect(0, 64336, '\p{Line_Break=hebrewletter}', "");
    Expect(1, 64336, '\p{^Line_Break=hebrewletter}', "");
    Expect(1, 64336, '\P{Line_Break=hebrewletter}', "");
    Expect(0, 64336, '\P{^Line_Break=hebrewletter}', "");
    Expect(1, 64335, '\p{Line_Break= _Hebrew_Letter}', "");
    Expect(0, 64335, '\p{^Line_Break= _Hebrew_Letter}', "");
    Expect(0, 64335, '\P{Line_Break= _Hebrew_Letter}', "");
    Expect(1, 64335, '\P{^Line_Break= _Hebrew_Letter}', "");
    Expect(0, 64336, '\p{Line_Break= _Hebrew_Letter}', "");
    Expect(1, 64336, '\p{^Line_Break= _Hebrew_Letter}', "");
    Expect(1, 64336, '\P{Line_Break= _Hebrew_Letter}', "");
    Expect(0, 64336, '\P{^Line_Break= _Hebrew_Letter}', "");
    Error('\p{Lb=/a/	HL}');
    Error('\P{Lb=/a/	HL}');
    Expect(1, 64335, '\p{Lb=hl}', "");
    Expect(0, 64335, '\p{^Lb=hl}', "");
    Expect(0, 64335, '\P{Lb=hl}', "");
    Expect(1, 64335, '\P{^Lb=hl}', "");
    Expect(0, 64336, '\p{Lb=hl}', "");
    Expect(1, 64336, '\p{^Lb=hl}', "");
    Expect(1, 64336, '\P{Lb=hl}', "");
    Expect(0, 64336, '\P{^Lb=hl}', "");
    Expect(1, 64335, '\p{Lb:-HL}', "");
    Expect(0, 64335, '\p{^Lb:-HL}', "");
    Expect(0, 64335, '\P{Lb:-HL}', "");
    Expect(1, 64335, '\P{^Lb:-HL}', "");
    Expect(0, 64336, '\p{Lb:-HL}', "");
    Expect(1, 64336, '\p{^Lb:-HL}', "");
    Expect(1, 64336, '\P{Lb:-HL}', "");
    Expect(0, 64336, '\P{^Lb:-HL}', "");
    Error('\p{Is_Line_Break=	HEBREW_letter/a/}');
    Error('\P{Is_Line_Break=	HEBREW_letter/a/}');
    Expect(1, 64335, '\p{Is_Line_Break:hebrewletter}', "");
    Expect(0, 64335, '\p{^Is_Line_Break:hebrewletter}', "");
    Expect(0, 64335, '\P{Is_Line_Break:hebrewletter}', "");
    Expect(1, 64335, '\P{^Is_Line_Break:hebrewletter}', "");
    Expect(0, 64336, '\p{Is_Line_Break:hebrewletter}', "");
    Expect(1, 64336, '\p{^Is_Line_Break:hebrewletter}', "");
    Expect(1, 64336, '\P{Is_Line_Break:hebrewletter}', "");
    Expect(0, 64336, '\P{^Is_Line_Break:hebrewletter}', "");
    Expect(1, 64335, '\p{Is_Line_Break=--Hebrew_LETTER}', "");
    Expect(0, 64335, '\p{^Is_Line_Break=--Hebrew_LETTER}', "");
    Expect(0, 64335, '\P{Is_Line_Break=--Hebrew_LETTER}', "");
    Expect(1, 64335, '\P{^Is_Line_Break=--Hebrew_LETTER}', "");
    Expect(0, 64336, '\p{Is_Line_Break=--Hebrew_LETTER}', "");
    Expect(1, 64336, '\p{^Is_Line_Break=--Hebrew_LETTER}', "");
    Expect(1, 64336, '\P{Is_Line_Break=--Hebrew_LETTER}', "");
    Expect(0, 64336, '\P{^Is_Line_Break=--Hebrew_LETTER}', "");
    Error('\p{Is_Lb=:=hl}');
    Error('\P{Is_Lb=:=hl}');
    Expect(1, 64335, '\p{Is_Lb=hl}', "");
    Expect(0, 64335, '\p{^Is_Lb=hl}', "");
    Expect(0, 64335, '\P{Is_Lb=hl}', "");
    Expect(1, 64335, '\P{^Is_Lb=hl}', "");
    Expect(0, 64336, '\p{Is_Lb=hl}', "");
    Expect(1, 64336, '\p{^Is_Lb=hl}', "");
    Expect(1, 64336, '\P{Is_Lb=hl}', "");
    Expect(0, 64336, '\P{^Is_Lb=hl}', "");
    Expect(1, 64335, '\p{Is_Lb= HL}', "");
    Expect(0, 64335, '\p{^Is_Lb= HL}', "");
    Expect(0, 64335, '\P{Is_Lb= HL}', "");
    Expect(1, 64335, '\P{^Is_Lb= HL}', "");
    Expect(0, 64336, '\p{Is_Lb= HL}', "");
    Expect(1, 64336, '\p{^Is_Lb= HL}', "");
    Expect(1, 64336, '\P{Is_Lb= HL}', "");
    Expect(0, 64336, '\P{^Is_Lb= HL}', "");
    Error('\p{Line_Break=__Hyphen:=}');
    Error('\P{Line_Break=__Hyphen:=}');
    Expect(1, 45, '\p{Line_Break:   hyphen}', "");
    Expect(0, 45, '\p{^Line_Break:   hyphen}', "");
    Expect(0, 45, '\P{Line_Break:   hyphen}', "");
    Expect(1, 45, '\P{^Line_Break:   hyphen}', "");
    Expect(0, 46, '\p{Line_Break:   hyphen}', "");
    Expect(1, 46, '\p{^Line_Break:   hyphen}', "");
    Expect(1, 46, '\P{Line_Break:   hyphen}', "");
    Expect(0, 46, '\P{^Line_Break:   hyphen}', "");
    Expect(1, 45, '\p{Line_Break=	_Hyphen}', "");
    Expect(0, 45, '\p{^Line_Break=	_Hyphen}', "");
    Expect(0, 45, '\P{Line_Break=	_Hyphen}', "");
    Expect(1, 45, '\P{^Line_Break=	_Hyphen}', "");
    Expect(0, 46, '\p{Line_Break=	_Hyphen}', "");
    Expect(1, 46, '\p{^Line_Break=	_Hyphen}', "");
    Expect(1, 46, '\P{Line_Break=	_Hyphen}', "");
    Expect(0, 46, '\P{^Line_Break=	_Hyphen}', "");
    Error('\p{Lb=	/a/HY}');
    Error('\P{Lb=	/a/HY}');
    Expect(1, 45, '\p{Lb=hy}', "");
    Expect(0, 45, '\p{^Lb=hy}', "");
    Expect(0, 45, '\P{Lb=hy}', "");
    Expect(1, 45, '\P{^Lb=hy}', "");
    Expect(0, 46, '\p{Lb=hy}', "");
    Expect(1, 46, '\p{^Lb=hy}', "");
    Expect(1, 46, '\P{Lb=hy}', "");
    Expect(0, 46, '\P{^Lb=hy}', "");
    Expect(1, 45, '\p{Lb=	-HY}', "");
    Expect(0, 45, '\p{^Lb=	-HY}', "");
    Expect(0, 45, '\P{Lb=	-HY}', "");
    Expect(1, 45, '\P{^Lb=	-HY}', "");
    Expect(0, 46, '\p{Lb=	-HY}', "");
    Expect(1, 46, '\p{^Lb=	-HY}', "");
    Expect(1, 46, '\P{Lb=	-HY}', "");
    Expect(0, 46, '\P{^Lb=	-HY}', "");
    Error('\p{Is_Line_Break=-	HYPHEN/a/}');
    Error('\P{Is_Line_Break=-	HYPHEN/a/}');
    Expect(1, 45, '\p{Is_Line_Break=hyphen}', "");
    Expect(0, 45, '\p{^Is_Line_Break=hyphen}', "");
    Expect(0, 45, '\P{Is_Line_Break=hyphen}', "");
    Expect(1, 45, '\P{^Is_Line_Break=hyphen}', "");
    Expect(0, 46, '\p{Is_Line_Break=hyphen}', "");
    Expect(1, 46, '\p{^Is_Line_Break=hyphen}', "");
    Expect(1, 46, '\P{Is_Line_Break=hyphen}', "");
    Expect(0, 46, '\P{^Is_Line_Break=hyphen}', "");
    Expect(1, 45, '\p{Is_Line_Break= Hyphen}', "");
    Expect(0, 45, '\p{^Is_Line_Break= Hyphen}', "");
    Expect(0, 45, '\P{Is_Line_Break= Hyphen}', "");
    Expect(1, 45, '\P{^Is_Line_Break= Hyphen}', "");
    Expect(0, 46, '\p{Is_Line_Break= Hyphen}', "");
    Expect(1, 46, '\p{^Is_Line_Break= Hyphen}', "");
    Expect(1, 46, '\P{Is_Line_Break= Hyphen}', "");
    Expect(0, 46, '\P{^Is_Line_Break= Hyphen}', "");
    Error('\p{Is_Lb=	HY:=}');
    Error('\P{Is_Lb=	HY:=}');
    Expect(1, 45, '\p{Is_Lb=hy}', "");
    Expect(0, 45, '\p{^Is_Lb=hy}', "");
    Expect(0, 45, '\P{Is_Lb=hy}', "");
    Expect(1, 45, '\P{^Is_Lb=hy}', "");
    Expect(0, 46, '\p{Is_Lb=hy}', "");
    Expect(1, 46, '\p{^Is_Lb=hy}', "");
    Expect(1, 46, '\P{Is_Lb=hy}', "");
    Expect(0, 46, '\P{^Is_Lb=hy}', "");
    Expect(1, 45, '\p{Is_Lb=	HY}', "");
    Expect(0, 45, '\p{^Is_Lb=	HY}', "");
    Expect(0, 45, '\P{Is_Lb=	HY}', "");
    Expect(1, 45, '\P{^Is_Lb=	HY}', "");
    Expect(0, 46, '\p{Is_Lb=	HY}', "");
    Expect(1, 46, '\p{^Is_Lb=	HY}', "");
    Expect(1, 46, '\P{Is_Lb=	HY}', "");
    Expect(0, 46, '\P{^Is_Lb=	HY}', "");
    Error('\p{Line_Break:	:= 	ideographic}');
    Error('\P{Line_Break:	:= 	ideographic}');
    Expect(1, 262141, '\p{Line_Break=ideographic}', "");
    Expect(0, 262141, '\p{^Line_Break=ideographic}', "");
    Expect(0, 262141, '\P{Line_Break=ideographic}', "");
    Expect(1, 262141, '\P{^Line_Break=ideographic}', "");
    Expect(0, 262144, '\p{Line_Break=ideographic}', "");
    Expect(1, 262144, '\p{^Line_Break=ideographic}', "");
    Expect(1, 262144, '\P{Line_Break=ideographic}', "");
    Expect(0, 262144, '\P{^Line_Break=ideographic}', "");
    Expect(1, 262141, '\p{Line_Break:-IDEOGRAPHIC}', "");
    Expect(0, 262141, '\p{^Line_Break:-IDEOGRAPHIC}', "");
    Expect(0, 262141, '\P{Line_Break:-IDEOGRAPHIC}', "");
    Expect(1, 262141, '\P{^Line_Break:-IDEOGRAPHIC}', "");
    Expect(0, 262144, '\p{Line_Break:-IDEOGRAPHIC}', "");
    Expect(1, 262144, '\p{^Line_Break:-IDEOGRAPHIC}', "");
    Expect(1, 262144, '\P{Line_Break:-IDEOGRAPHIC}', "");
    Expect(0, 262144, '\P{^Line_Break:-IDEOGRAPHIC}', "");
    Error('\p{Lb=:=_ id}');
    Error('\P{Lb=:=_ id}');
    Expect(1, 262141, '\p{Lb:id}', "");
    Expect(0, 262141, '\p{^Lb:id}', "");
    Expect(0, 262141, '\P{Lb:id}', "");
    Expect(1, 262141, '\P{^Lb:id}', "");
    Expect(0, 262144, '\p{Lb:id}', "");
    Expect(1, 262144, '\p{^Lb:id}', "");
    Expect(1, 262144, '\P{Lb:id}', "");
    Expect(0, 262144, '\P{^Lb:id}', "");
    Expect(1, 262141, '\p{Lb=-_id}', "");
    Expect(0, 262141, '\p{^Lb=-_id}', "");
    Expect(0, 262141, '\P{Lb=-_id}', "");
    Expect(1, 262141, '\P{^Lb=-_id}', "");
    Expect(0, 262144, '\p{Lb=-_id}', "");
    Expect(1, 262144, '\p{^Lb=-_id}', "");
    Expect(1, 262144, '\P{Lb=-_id}', "");
    Expect(0, 262144, '\P{^Lb=-_id}', "");
    Error('\p{Is_Line_Break=-/a/ideographic}');
    Error('\P{Is_Line_Break=-/a/ideographic}');
    Expect(1, 262141, '\p{Is_Line_Break=ideographic}', "");
    Expect(0, 262141, '\p{^Is_Line_Break=ideographic}', "");
    Expect(0, 262141, '\P{Is_Line_Break=ideographic}', "");
    Expect(1, 262141, '\P{^Is_Line_Break=ideographic}', "");
    Expect(0, 262144, '\p{Is_Line_Break=ideographic}', "");
    Expect(1, 262144, '\p{^Is_Line_Break=ideographic}', "");
    Expect(1, 262144, '\P{Is_Line_Break=ideographic}', "");
    Expect(0, 262144, '\P{^Is_Line_Break=ideographic}', "");
    Expect(1, 262141, '\p{Is_Line_Break=	ideographic}', "");
    Expect(0, 262141, '\p{^Is_Line_Break=	ideographic}', "");
    Expect(0, 262141, '\P{Is_Line_Break=	ideographic}', "");
    Expect(1, 262141, '\P{^Is_Line_Break=	ideographic}', "");
    Expect(0, 262144, '\p{Is_Line_Break=	ideographic}', "");
    Expect(1, 262144, '\p{^Is_Line_Break=	ideographic}', "");
    Expect(1, 262144, '\P{Is_Line_Break=	ideographic}', "");
    Expect(0, 262144, '\P{^Is_Line_Break=	ideographic}', "");
    Error('\p{Is_Lb=/a/_id}');
    Error('\P{Is_Lb=/a/_id}');
    Expect(1, 262141, '\p{Is_Lb=id}', "");
    Expect(0, 262141, '\p{^Is_Lb=id}', "");
    Expect(0, 262141, '\P{Is_Lb=id}', "");
    Expect(1, 262141, '\P{^Is_Lb=id}', "");
    Expect(0, 262144, '\p{Is_Lb=id}', "");
    Expect(1, 262144, '\p{^Is_Lb=id}', "");
    Expect(1, 262144, '\P{Is_Lb=id}', "");
    Expect(0, 262144, '\P{^Is_Lb=id}', "");
    Expect(1, 262141, '\p{Is_Lb=__ID}', "");
    Expect(0, 262141, '\p{^Is_Lb=__ID}', "");
    Expect(0, 262141, '\P{Is_Lb=__ID}', "");
    Expect(1, 262141, '\P{^Is_Lb=__ID}', "");
    Expect(0, 262144, '\p{Is_Lb=__ID}', "");
    Expect(1, 262144, '\p{^Is_Lb=__ID}', "");
    Expect(1, 262144, '\P{Is_Lb=__ID}', "");
    Expect(0, 262144, '\P{^Is_Lb=__ID}', "");
    Error('\p{Line_Break= INSEPARABLE:=}');
    Error('\P{Line_Break= INSEPARABLE:=}');
    Expect(1, 68342, '\p{Line_Break=inseparable}', "");
    Expect(0, 68342, '\p{^Line_Break=inseparable}', "");
    Expect(0, 68342, '\P{Line_Break=inseparable}', "");
    Expect(1, 68342, '\P{^Line_Break=inseparable}', "");
    Expect(0, 68343, '\p{Line_Break=inseparable}', "");
    Expect(1, 68343, '\p{^Line_Break=inseparable}', "");
    Expect(1, 68343, '\P{Line_Break=inseparable}', "");
    Expect(0, 68343, '\P{^Line_Break=inseparable}', "");
    Expect(1, 68342, '\p{Line_Break=	Inseparable}', "");
    Expect(0, 68342, '\p{^Line_Break=	Inseparable}', "");
    Expect(0, 68342, '\P{Line_Break=	Inseparable}', "");
    Expect(1, 68342, '\P{^Line_Break=	Inseparable}', "");
    Expect(0, 68343, '\p{Line_Break=	Inseparable}', "");
    Expect(1, 68343, '\p{^Line_Break=	Inseparable}', "");
    Expect(1, 68343, '\P{Line_Break=	Inseparable}', "");
    Expect(0, 68343, '\P{^Line_Break=	Inseparable}', "");
    Error('\p{Lb=/a/	_IN}');
    Error('\P{Lb=/a/	_IN}');
    Expect(1, 68342, '\p{Lb=in}', "");
    Expect(0, 68342, '\p{^Lb=in}', "");
    Expect(0, 68342, '\P{Lb=in}', "");
    Expect(1, 68342, '\P{^Lb=in}', "");
    Expect(0, 68343, '\p{Lb=in}', "");
    Expect(1, 68343, '\p{^Lb=in}', "");
    Expect(1, 68343, '\P{Lb=in}', "");
    Expect(0, 68343, '\P{^Lb=in}', "");
    Expect(1, 68342, '\p{Lb:-	IN}', "");
    Expect(0, 68342, '\p{^Lb:-	IN}', "");
    Expect(0, 68342, '\P{Lb:-	IN}', "");
    Expect(1, 68342, '\P{^Lb:-	IN}', "");
    Expect(0, 68343, '\p{Lb:-	IN}', "");
    Expect(1, 68343, '\p{^Lb:-	IN}', "");
    Expect(1, 68343, '\P{Lb:-	IN}', "");
    Expect(0, 68343, '\P{^Lb:-	IN}', "");
    Error('\p{Is_Line_Break=	:=Inseperable}');
    Error('\P{Is_Line_Break=	:=Inseperable}');
    Expect(1, 68342, '\p{Is_Line_Break=inseperable}', "");
    Expect(0, 68342, '\p{^Is_Line_Break=inseperable}', "");
    Expect(0, 68342, '\P{Is_Line_Break=inseperable}', "");
    Expect(1, 68342, '\P{^Is_Line_Break=inseperable}', "");
    Expect(0, 68343, '\p{Is_Line_Break=inseperable}', "");
    Expect(1, 68343, '\p{^Is_Line_Break=inseperable}', "");
    Expect(1, 68343, '\P{Is_Line_Break=inseperable}', "");
    Expect(0, 68343, '\P{^Is_Line_Break=inseperable}', "");
    Expect(1, 68342, '\p{Is_Line_Break= Inseperable}', "");
    Expect(0, 68342, '\p{^Is_Line_Break= Inseperable}', "");
    Expect(0, 68342, '\P{Is_Line_Break= Inseperable}', "");
    Expect(1, 68342, '\P{^Is_Line_Break= Inseperable}', "");
    Expect(0, 68343, '\p{Is_Line_Break= Inseperable}', "");
    Expect(1, 68343, '\p{^Is_Line_Break= Inseperable}', "");
    Expect(1, 68343, '\P{Is_Line_Break= Inseperable}', "");
    Expect(0, 68343, '\P{^Is_Line_Break= Inseperable}', "");
    Error('\p{Is_Lb=-INSEPARABLE/a/}');
    Error('\P{Is_Lb=-INSEPARABLE/a/}');
    Expect(1, 68342, '\p{Is_Lb=inseparable}', "");
    Expect(0, 68342, '\p{^Is_Lb=inseparable}', "");
    Expect(0, 68342, '\P{Is_Lb=inseparable}', "");
    Expect(1, 68342, '\P{^Is_Lb=inseparable}', "");
    Expect(0, 68343, '\p{Is_Lb=inseparable}', "");
    Expect(1, 68343, '\p{^Is_Lb=inseparable}', "");
    Expect(1, 68343, '\P{Is_Lb=inseparable}', "");
    Expect(0, 68343, '\P{^Is_Lb=inseparable}', "");
    Expect(1, 68342, '\p{Is_Lb=	Inseparable}', "");
    Expect(0, 68342, '\p{^Is_Lb=	Inseparable}', "");
    Expect(0, 68342, '\P{Is_Lb=	Inseparable}', "");
    Expect(1, 68342, '\P{^Is_Lb=	Inseparable}', "");
    Expect(0, 68343, '\p{Is_Lb=	Inseparable}', "");
    Expect(1, 68343, '\p{^Is_Lb=	Inseparable}', "");
    Expect(1, 68343, '\P{Is_Lb=	Inseparable}', "");
    Expect(0, 68343, '\P{^Is_Lb=	Inseparable}', "");
    Error('\p{Line_Break=-_infix_Numeric:=}');
    Error('\P{Line_Break=-_infix_Numeric:=}');
    Expect(1, 65044, '\p{Line_Break=infixnumeric}', "");
    Expect(0, 65044, '\p{^Line_Break=infixnumeric}', "");
    Expect(0, 65044, '\P{Line_Break=infixnumeric}', "");
    Expect(1, 65044, '\P{^Line_Break=infixnumeric}', "");
    Expect(0, 65045, '\p{Line_Break=infixnumeric}', "");
    Expect(1, 65045, '\p{^Line_Break=infixnumeric}', "");
    Expect(1, 65045, '\P{Line_Break=infixnumeric}', "");
    Expect(0, 65045, '\P{^Line_Break=infixnumeric}', "");
    Expect(1, 65044, '\p{Line_Break=--infix_Numeric}', "");
    Expect(0, 65044, '\p{^Line_Break=--infix_Numeric}', "");
    Expect(0, 65044, '\P{Line_Break=--infix_Numeric}', "");
    Expect(1, 65044, '\P{^Line_Break=--infix_Numeric}', "");
    Expect(0, 65045, '\p{Line_Break=--infix_Numeric}', "");
    Expect(1, 65045, '\p{^Line_Break=--infix_Numeric}', "");
    Expect(1, 65045, '\P{Line_Break=--infix_Numeric}', "");
    Expect(0, 65045, '\P{^Line_Break=--infix_Numeric}', "");
    Error('\p{Lb=-:=is}');
    Error('\P{Lb=-:=is}');
    Expect(1, 65044, '\p{Lb=is}', "");
    Expect(0, 65044, '\p{^Lb=is}', "");
    Expect(0, 65044, '\P{Lb=is}', "");
    Expect(1, 65044, '\P{^Lb=is}', "");
    Expect(0, 65045, '\p{Lb=is}', "");
    Expect(1, 65045, '\p{^Lb=is}', "");
    Expect(1, 65045, '\P{Lb=is}', "");
    Expect(0, 65045, '\P{^Lb=is}', "");
    Expect(1, 65044, '\p{Lb=	 IS}', "");
    Expect(0, 65044, '\p{^Lb=	 IS}', "");
    Expect(0, 65044, '\P{Lb=	 IS}', "");
    Expect(1, 65044, '\P{^Lb=	 IS}', "");
    Expect(0, 65045, '\p{Lb=	 IS}', "");
    Expect(1, 65045, '\p{^Lb=	 IS}', "");
    Expect(1, 65045, '\P{Lb=	 IS}', "");
    Expect(0, 65045, '\P{^Lb=	 IS}', "");
    Error('\p{Is_Line_Break=-infix_NUMERIC/a/}');
    Error('\P{Is_Line_Break=-infix_NUMERIC/a/}');
    Expect(1, 65044, '\p{Is_Line_Break=infixnumeric}', "");
    Expect(0, 65044, '\p{^Is_Line_Break=infixnumeric}', "");
    Expect(0, 65044, '\P{Is_Line_Break=infixnumeric}', "");
    Expect(1, 65044, '\P{^Is_Line_Break=infixnumeric}', "");
    Expect(0, 65045, '\p{Is_Line_Break=infixnumeric}', "");
    Expect(1, 65045, '\p{^Is_Line_Break=infixnumeric}', "");
    Expect(1, 65045, '\P{Is_Line_Break=infixnumeric}', "");
    Expect(0, 65045, '\P{^Is_Line_Break=infixnumeric}', "");
    Expect(1, 65044, '\p{Is_Line_Break=		Infix_NUMERIC}', "");
    Expect(0, 65044, '\p{^Is_Line_Break=		Infix_NUMERIC}', "");
    Expect(0, 65044, '\P{Is_Line_Break=		Infix_NUMERIC}', "");
    Expect(1, 65044, '\P{^Is_Line_Break=		Infix_NUMERIC}', "");
    Expect(0, 65045, '\p{Is_Line_Break=		Infix_NUMERIC}', "");
    Expect(1, 65045, '\p{^Is_Line_Break=		Infix_NUMERIC}', "");
    Expect(1, 65045, '\P{Is_Line_Break=		Infix_NUMERIC}', "");
    Expect(0, 65045, '\P{^Is_Line_Break=		Infix_NUMERIC}', "");
    Error('\p{Is_Lb=_IS:=}');
    Error('\P{Is_Lb=_IS:=}');
    Expect(1, 65044, '\p{Is_Lb=is}', "");
    Expect(0, 65044, '\p{^Is_Lb=is}', "");
    Expect(0, 65044, '\P{Is_Lb=is}', "");
    Expect(1, 65044, '\P{^Is_Lb=is}', "");
    Expect(0, 65045, '\p{Is_Lb=is}', "");
    Expect(1, 65045, '\p{^Is_Lb=is}', "");
    Expect(1, 65045, '\P{Is_Lb=is}', "");
    Expect(0, 65045, '\P{^Is_Lb=is}', "");
    Expect(1, 65044, '\p{Is_Lb:		IS}', "");
    Expect(0, 65044, '\p{^Is_Lb:		IS}', "");
    Expect(0, 65044, '\P{Is_Lb:		IS}', "");
    Expect(1, 65044, '\P{^Is_Lb:		IS}', "");
    Expect(0, 65045, '\p{Is_Lb:		IS}', "");
    Expect(1, 65045, '\p{^Is_Lb:		IS}', "");
    Expect(1, 65045, '\P{Is_Lb:		IS}', "");
    Expect(0, 65045, '\P{^Is_Lb:		IS}', "");
    Error('\p{Line_Break=/a/__JL}');
    Error('\P{Line_Break=/a/__JL}');
    Expect(1, 43388, '\p{Line_Break=jl}', "");
    Expect(0, 43388, '\p{^Line_Break=jl}', "");
    Expect(0, 43388, '\P{Line_Break=jl}', "");
    Expect(1, 43388, '\P{^Line_Break=jl}', "");
    Expect(0, 43389, '\p{Line_Break=jl}', "");
    Expect(1, 43389, '\p{^Line_Break=jl}', "");
    Expect(1, 43389, '\P{Line_Break=jl}', "");
    Expect(0, 43389, '\P{^Line_Break=jl}', "");
    Expect(1, 43388, '\p{Line_Break= -JL}', "");
    Expect(0, 43388, '\p{^Line_Break= -JL}', "");
    Expect(0, 43388, '\P{Line_Break= -JL}', "");
    Expect(1, 43388, '\P{^Line_Break= -JL}', "");
    Expect(0, 43389, '\p{Line_Break= -JL}', "");
    Expect(1, 43389, '\p{^Line_Break= -JL}', "");
    Expect(1, 43389, '\P{Line_Break= -JL}', "");
    Expect(0, 43389, '\P{^Line_Break= -JL}', "");
    Error('\p{Lb= -JL:=}');
    Error('\P{Lb= -JL:=}');
    Expect(1, 43388, '\p{Lb=jl}', "");
    Expect(0, 43388, '\p{^Lb=jl}', "");
    Expect(0, 43388, '\P{Lb=jl}', "");
    Expect(1, 43388, '\P{^Lb=jl}', "");
    Expect(0, 43389, '\p{Lb=jl}', "");
    Expect(1, 43389, '\p{^Lb=jl}', "");
    Expect(1, 43389, '\P{Lb=jl}', "");
    Expect(0, 43389, '\P{^Lb=jl}', "");
    Expect(1, 43388, '\p{Lb=-	jl}', "");
    Expect(0, 43388, '\p{^Lb=-	jl}', "");
    Expect(0, 43388, '\P{Lb=-	jl}', "");
    Expect(1, 43388, '\P{^Lb=-	jl}', "");
    Expect(0, 43389, '\p{Lb=-	jl}', "");
    Expect(1, 43389, '\p{^Lb=-	jl}', "");
    Expect(1, 43389, '\P{Lb=-	jl}', "");
    Expect(0, 43389, '\P{^Lb=-	jl}', "");
    Error('\p{Is_Line_Break=--JL/a/}');
    Error('\P{Is_Line_Break=--JL/a/}');
    Expect(1, 43388, '\p{Is_Line_Break=jl}', "");
    Expect(0, 43388, '\p{^Is_Line_Break=jl}', "");
    Expect(0, 43388, '\P{Is_Line_Break=jl}', "");
    Expect(1, 43388, '\P{^Is_Line_Break=jl}', "");
    Expect(0, 43389, '\p{Is_Line_Break=jl}', "");
    Expect(1, 43389, '\p{^Is_Line_Break=jl}', "");
    Expect(1, 43389, '\P{Is_Line_Break=jl}', "");
    Expect(0, 43389, '\P{^Is_Line_Break=jl}', "");
    Expect(1, 43388, '\p{Is_Line_Break= JL}', "");
    Expect(0, 43388, '\p{^Is_Line_Break= JL}', "");
    Expect(0, 43388, '\P{Is_Line_Break= JL}', "");
    Expect(1, 43388, '\P{^Is_Line_Break= JL}', "");
    Expect(0, 43389, '\p{Is_Line_Break= JL}', "");
    Expect(1, 43389, '\p{^Is_Line_Break= JL}', "");
    Expect(1, 43389, '\P{Is_Line_Break= JL}', "");
    Expect(0, 43389, '\P{^Is_Line_Break= JL}', "");
    Error('\p{Is_Lb=:=-_jl}');
    Error('\P{Is_Lb=:=-_jl}');
    Expect(1, 43388, '\p{Is_Lb=jl}', "");
    Expect(0, 43388, '\p{^Is_Lb=jl}', "");
    Expect(0, 43388, '\P{Is_Lb=jl}', "");
    Expect(1, 43388, '\P{^Is_Lb=jl}', "");
    Expect(0, 43389, '\p{Is_Lb=jl}', "");
    Expect(1, 43389, '\p{^Is_Lb=jl}', "");
    Expect(1, 43389, '\P{Is_Lb=jl}', "");
    Expect(0, 43389, '\P{^Is_Lb=jl}', "");
    Expect(1, 43388, '\p{Is_Lb= jl}', "");
    Expect(0, 43388, '\p{^Is_Lb= jl}', "");
    Expect(0, 43388, '\P{Is_Lb= jl}', "");
    Expect(1, 43388, '\P{^Is_Lb= jl}', "");
    Expect(0, 43389, '\p{Is_Lb= jl}', "");
    Expect(1, 43389, '\p{^Is_Lb= jl}', "");
    Expect(1, 43389, '\P{Is_Lb= jl}', "");
    Expect(0, 43389, '\P{^Is_Lb= jl}', "");
    Error('\p{Line_Break=	jt/a/}');
    Error('\P{Line_Break=	jt/a/}');
    Expect(1, 55291, '\p{Line_Break=jt}', "");
    Expect(0, 55291, '\p{^Line_Break=jt}', "");
    Expect(0, 55291, '\P{Line_Break=jt}', "");
    Expect(1, 55291, '\P{^Line_Break=jt}', "");
    Expect(0, 55292, '\p{Line_Break=jt}', "");
    Expect(1, 55292, '\p{^Line_Break=jt}', "");
    Expect(1, 55292, '\P{Line_Break=jt}', "");
    Expect(0, 55292, '\P{^Line_Break=jt}', "");
    Expect(1, 55291, '\p{Line_Break=-JT}', "");
    Expect(0, 55291, '\p{^Line_Break=-JT}', "");
    Expect(0, 55291, '\P{Line_Break=-JT}', "");
    Expect(1, 55291, '\P{^Line_Break=-JT}', "");
    Expect(0, 55292, '\p{Line_Break=-JT}', "");
    Expect(1, 55292, '\p{^Line_Break=-JT}', "");
    Expect(1, 55292, '\P{Line_Break=-JT}', "");
    Expect(0, 55292, '\P{^Line_Break=-JT}', "");
    Error('\p{Lb=_	JT:=}');
    Error('\P{Lb=_	JT:=}');
    Expect(1, 55291, '\p{Lb=jt}', "");
    Expect(0, 55291, '\p{^Lb=jt}', "");
    Expect(0, 55291, '\P{Lb=jt}', "");
    Expect(1, 55291, '\P{^Lb=jt}', "");
    Expect(0, 55292, '\p{Lb=jt}', "");
    Expect(1, 55292, '\p{^Lb=jt}', "");
    Expect(1, 55292, '\P{Lb=jt}', "");
    Expect(0, 55292, '\P{^Lb=jt}', "");
    Expect(1, 55291, '\p{Lb=-	JT}', "");
    Expect(0, 55291, '\p{^Lb=-	JT}', "");
    Expect(0, 55291, '\P{Lb=-	JT}', "");
    Expect(1, 55291, '\P{^Lb=-	JT}', "");
    Expect(0, 55292, '\p{Lb=-	JT}', "");
    Expect(1, 55292, '\p{^Lb=-	JT}', "");
    Expect(1, 55292, '\P{Lb=-	JT}', "");
    Expect(0, 55292, '\P{^Lb=-	JT}', "");
    Error('\p{Is_Line_Break=	_jt/a/}');
    Error('\P{Is_Line_Break=	_jt/a/}');
    Expect(1, 55291, '\p{Is_Line_Break=jt}', "");
    Expect(0, 55291, '\p{^Is_Line_Break=jt}', "");
    Expect(0, 55291, '\P{Is_Line_Break=jt}', "");
    Expect(1, 55291, '\P{^Is_Line_Break=jt}', "");
    Expect(0, 55292, '\p{Is_Line_Break=jt}', "");
    Expect(1, 55292, '\p{^Is_Line_Break=jt}', "");
    Expect(1, 55292, '\P{Is_Line_Break=jt}', "");
    Expect(0, 55292, '\P{^Is_Line_Break=jt}', "");
    Expect(1, 55291, '\p{Is_Line_Break= 	JT}', "");
    Expect(0, 55291, '\p{^Is_Line_Break= 	JT}', "");
    Expect(0, 55291, '\P{Is_Line_Break= 	JT}', "");
    Expect(1, 55291, '\P{^Is_Line_Break= 	JT}', "");
    Expect(0, 55292, '\p{Is_Line_Break= 	JT}', "");
    Expect(1, 55292, '\p{^Is_Line_Break= 	JT}', "");
    Expect(1, 55292, '\P{Is_Line_Break= 	JT}', "");
    Expect(0, 55292, '\P{^Is_Line_Break= 	JT}', "");
    Error('\p{Is_Lb=:=JT}');
    Error('\P{Is_Lb=:=JT}');
    Expect(1, 55291, '\p{Is_Lb=jt}', "");
    Expect(0, 55291, '\p{^Is_Lb=jt}', "");
    Expect(0, 55291, '\P{Is_Lb=jt}', "");
    Expect(1, 55291, '\P{^Is_Lb=jt}', "");
    Expect(0, 55292, '\p{Is_Lb=jt}', "");
    Expect(1, 55292, '\p{^Is_Lb=jt}', "");
    Expect(1, 55292, '\P{Is_Lb=jt}', "");
    Expect(0, 55292, '\P{^Is_Lb=jt}', "");
    Expect(1, 55291, '\p{Is_Lb= -JT}', "");
    Expect(0, 55291, '\p{^Is_Lb= -JT}', "");
    Expect(0, 55291, '\P{Is_Lb= -JT}', "");
    Expect(1, 55291, '\P{^Is_Lb= -JT}', "");
    Expect(0, 55292, '\p{Is_Lb= -JT}', "");
    Expect(1, 55292, '\p{^Is_Lb= -JT}', "");
    Expect(1, 55292, '\P{Is_Lb= -JT}', "");
    Expect(0, 55292, '\P{^Is_Lb= -JT}', "");
    Error('\p{Line_Break=:=_JV}');
    Error('\P{Line_Break=:=_JV}');
    Expect(1, 55238, '\p{Line_Break=jv}', "");
    Expect(0, 55238, '\p{^Line_Break=jv}', "");
    Expect(0, 55238, '\P{Line_Break=jv}', "");
    Expect(1, 55238, '\P{^Line_Break=jv}', "");
    Expect(0, 55239, '\p{Line_Break=jv}', "");
    Expect(1, 55239, '\p{^Line_Break=jv}', "");
    Expect(1, 55239, '\P{Line_Break=jv}', "");
    Expect(0, 55239, '\P{^Line_Break=jv}', "");
    Expect(1, 55238, '\p{Line_Break=--JV}', "");
    Expect(0, 55238, '\p{^Line_Break=--JV}', "");
    Expect(0, 55238, '\P{Line_Break=--JV}', "");
    Expect(1, 55238, '\P{^Line_Break=--JV}', "");
    Expect(0, 55239, '\p{Line_Break=--JV}', "");
    Expect(1, 55239, '\p{^Line_Break=--JV}', "");
    Expect(1, 55239, '\P{Line_Break=--JV}', "");
    Expect(0, 55239, '\P{^Line_Break=--JV}', "");
    Error('\p{Lb=/a/	JV}');
    Error('\P{Lb=/a/	JV}');
    Expect(1, 55238, '\p{Lb=jv}', "");
    Expect(0, 55238, '\p{^Lb=jv}', "");
    Expect(0, 55238, '\P{Lb=jv}', "");
    Expect(1, 55238, '\P{^Lb=jv}', "");
    Expect(0, 55239, '\p{Lb=jv}', "");
    Expect(1, 55239, '\p{^Lb=jv}', "");
    Expect(1, 55239, '\P{Lb=jv}', "");
    Expect(0, 55239, '\P{^Lb=jv}', "");
    Expect(1, 55238, '\p{Lb=_-JV}', "");
    Expect(0, 55238, '\p{^Lb=_-JV}', "");
    Expect(0, 55238, '\P{Lb=_-JV}', "");
    Expect(1, 55238, '\P{^Lb=_-JV}', "");
    Expect(0, 55239, '\p{Lb=_-JV}', "");
    Expect(1, 55239, '\p{^Lb=_-JV}', "");
    Expect(1, 55239, '\P{Lb=_-JV}', "");
    Expect(0, 55239, '\P{^Lb=_-JV}', "");
    Error('\p{Is_Line_Break=_-jv/a/}');
    Error('\P{Is_Line_Break=_-jv/a/}');
    Expect(1, 55238, '\p{Is_Line_Break=jv}', "");
    Expect(0, 55238, '\p{^Is_Line_Break=jv}', "");
    Expect(0, 55238, '\P{Is_Line_Break=jv}', "");
    Expect(1, 55238, '\P{^Is_Line_Break=jv}', "");
    Expect(0, 55239, '\p{Is_Line_Break=jv}', "");
    Expect(1, 55239, '\p{^Is_Line_Break=jv}', "");
    Expect(1, 55239, '\P{Is_Line_Break=jv}', "");
    Expect(0, 55239, '\P{^Is_Line_Break=jv}', "");
    Expect(1, 55238, '\p{Is_Line_Break=-	JV}', "");
    Expect(0, 55238, '\p{^Is_Line_Break=-	JV}', "");
    Expect(0, 55238, '\P{Is_Line_Break=-	JV}', "");
    Expect(1, 55238, '\P{^Is_Line_Break=-	JV}', "");
    Expect(0, 55239, '\p{Is_Line_Break=-	JV}', "");
    Expect(1, 55239, '\p{^Is_Line_Break=-	JV}', "");
    Expect(1, 55239, '\P{Is_Line_Break=-	JV}', "");
    Expect(0, 55239, '\P{^Is_Line_Break=-	JV}', "");
    Error('\p{Is_Lb=_:=JV}');
    Error('\P{Is_Lb=_:=JV}');
    Expect(1, 55238, '\p{Is_Lb=jv}', "");
    Expect(0, 55238, '\p{^Is_Lb=jv}', "");
    Expect(0, 55238, '\P{Is_Lb=jv}', "");
    Expect(1, 55238, '\P{^Is_Lb=jv}', "");
    Expect(0, 55239, '\p{Is_Lb=jv}', "");
    Expect(1, 55239, '\p{^Is_Lb=jv}', "");
    Expect(1, 55239, '\P{Is_Lb=jv}', "");
    Expect(0, 55239, '\P{^Is_Lb=jv}', "");
    Expect(1, 55238, '\p{Is_Lb=_-jv}', "");
    Expect(0, 55238, '\p{^Is_Lb=_-jv}', "");
    Expect(0, 55238, '\P{Is_Lb=_-jv}', "");
    Expect(1, 55238, '\P{^Is_Lb=_-jv}', "");
    Expect(0, 55239, '\p{Is_Lb=_-jv}', "");
    Expect(1, 55239, '\p{^Is_Lb=_-jv}', "");
    Expect(1, 55239, '\P{Is_Lb=_-jv}', "");
    Expect(0, 55239, '\P{^Is_Lb=_-jv}', "");
    Error('\p{Line_Break=/a/  LINE_FEED}');
    Error('\P{Line_Break=/a/  LINE_FEED}');
    Expect(1, 10, '\p{Line_Break=linefeed}', "");
    Expect(0, 10, '\p{^Line_Break=linefeed}', "");
    Expect(0, 10, '\P{Line_Break=linefeed}', "");
    Expect(1, 10, '\P{^Line_Break=linefeed}', "");
    Expect(0, 11, '\p{Line_Break=linefeed}', "");
    Expect(1, 11, '\p{^Line_Break=linefeed}', "");
    Expect(1, 11, '\P{Line_Break=linefeed}', "");
    Expect(0, 11, '\P{^Line_Break=linefeed}', "");
    Expect(1, 10, '\p{Line_Break=_-Line_Feed}', "");
    Expect(0, 10, '\p{^Line_Break=_-Line_Feed}', "");
    Expect(0, 10, '\P{Line_Break=_-Line_Feed}', "");
    Expect(1, 10, '\P{^Line_Break=_-Line_Feed}', "");
    Expect(0, 11, '\p{Line_Break=_-Line_Feed}', "");
    Expect(1, 11, '\p{^Line_Break=_-Line_Feed}', "");
    Expect(1, 11, '\P{Line_Break=_-Line_Feed}', "");
    Expect(0, 11, '\P{^Line_Break=_-Line_Feed}', "");
    Error('\p{Lb:  /a/LF}');
    Error('\P{Lb:  /a/LF}');
    Expect(1, 10, '\p{Lb=lf}', "");
    Expect(0, 10, '\p{^Lb=lf}', "");
    Expect(0, 10, '\P{Lb=lf}', "");
    Expect(1, 10, '\P{^Lb=lf}', "");
    Expect(0, 11, '\p{Lb=lf}', "");
    Expect(1, 11, '\p{^Lb=lf}', "");
    Expect(1, 11, '\P{Lb=lf}', "");
    Expect(0, 11, '\P{^Lb=lf}', "");
    Expect(1, 10, '\p{Lb=-LF}', "");
    Expect(0, 10, '\p{^Lb=-LF}', "");
    Expect(0, 10, '\P{Lb=-LF}', "");
    Expect(1, 10, '\P{^Lb=-LF}', "");
    Expect(0, 11, '\p{Lb=-LF}', "");
    Expect(1, 11, '\p{^Lb=-LF}', "");
    Expect(1, 11, '\P{Lb=-LF}', "");
    Expect(0, 11, '\P{^Lb=-LF}', "");
    Error('\p{Is_Line_Break=-Line_Feed:=}');
    Error('\P{Is_Line_Break=-Line_Feed:=}');
    Expect(1, 10, '\p{Is_Line_Break=linefeed}', "");
    Expect(0, 10, '\p{^Is_Line_Break=linefeed}', "");
    Expect(0, 10, '\P{Is_Line_Break=linefeed}', "");
    Expect(1, 10, '\P{^Is_Line_Break=linefeed}', "");
    Expect(0, 11, '\p{Is_Line_Break=linefeed}', "");
    Expect(1, 11, '\p{^Is_Line_Break=linefeed}', "");
    Expect(1, 11, '\P{Is_Line_Break=linefeed}', "");
    Expect(0, 11, '\P{^Is_Line_Break=linefeed}', "");
    Expect(1, 10, '\p{Is_Line_Break=- LINE_Feed}', "");
    Expect(0, 10, '\p{^Is_Line_Break=- LINE_Feed}', "");
    Expect(0, 10, '\P{Is_Line_Break=- LINE_Feed}', "");
    Expect(1, 10, '\P{^Is_Line_Break=- LINE_Feed}', "");
    Expect(0, 11, '\p{Is_Line_Break=- LINE_Feed}', "");
    Expect(1, 11, '\p{^Is_Line_Break=- LINE_Feed}', "");
    Expect(1, 11, '\P{Is_Line_Break=- LINE_Feed}', "");
    Expect(0, 11, '\P{^Is_Line_Break=- LINE_Feed}', "");
    Error('\p{Is_Lb=-_lf:=}');
    Error('\P{Is_Lb=-_lf:=}');
    Expect(1, 10, '\p{Is_Lb=lf}', "");
    Expect(0, 10, '\p{^Is_Lb=lf}', "");
    Expect(0, 10, '\P{Is_Lb=lf}', "");
    Expect(1, 10, '\P{^Is_Lb=lf}', "");
    Expect(0, 11, '\p{Is_Lb=lf}', "");
    Expect(1, 11, '\p{^Is_Lb=lf}', "");
    Expect(1, 11, '\P{Is_Lb=lf}', "");
    Expect(0, 11, '\P{^Is_Lb=lf}', "");
    Expect(1, 10, '\p{Is_Lb:-	LF}', "");
    Expect(0, 10, '\p{^Is_Lb:-	LF}', "");
    Expect(0, 10, '\P{Is_Lb:-	LF}', "");
    Expect(1, 10, '\P{^Is_Lb:-	LF}', "");
    Expect(0, 11, '\p{Is_Lb:-	LF}', "");
    Expect(1, 11, '\p{^Is_Lb:-	LF}', "");
    Expect(1, 11, '\P{Is_Lb:-	LF}', "");
    Expect(0, 11, '\P{^Is_Lb:-	LF}', "");
    Error('\p{Line_Break= Next_line/a/}');
    Error('\P{Line_Break= Next_line/a/}');
    Expect(1, 133, '\p{Line_Break=nextline}', "");
    Expect(0, 133, '\p{^Line_Break=nextline}', "");
    Expect(0, 133, '\P{Line_Break=nextline}', "");
    Expect(1, 133, '\P{^Line_Break=nextline}', "");
    Expect(0, 134, '\p{Line_Break=nextline}', "");
    Expect(1, 134, '\p{^Line_Break=nextline}', "");
    Expect(1, 134, '\P{Line_Break=nextline}', "");
    Expect(0, 134, '\P{^Line_Break=nextline}', "");
    Expect(1, 133, '\p{Line_Break=_	Next_line}', "");
    Expect(0, 133, '\p{^Line_Break=_	Next_line}', "");
    Expect(0, 133, '\P{Line_Break=_	Next_line}', "");
    Expect(1, 133, '\P{^Line_Break=_	Next_line}', "");
    Expect(0, 134, '\p{Line_Break=_	Next_line}', "");
    Expect(1, 134, '\p{^Line_Break=_	Next_line}', "");
    Expect(1, 134, '\P{Line_Break=_	Next_line}', "");
    Expect(0, 134, '\P{^Line_Break=_	Next_line}', "");
    Error('\p{Lb=:=NL}');
    Error('\P{Lb=:=NL}');
    Expect(1, 133, '\p{Lb=nl}', "");
    Expect(0, 133, '\p{^Lb=nl}', "");
    Expect(0, 133, '\P{Lb=nl}', "");
    Expect(1, 133, '\P{^Lb=nl}', "");
    Expect(0, 134, '\p{Lb=nl}', "");
    Expect(1, 134, '\p{^Lb=nl}', "");
    Expect(1, 134, '\P{Lb=nl}', "");
    Expect(0, 134, '\P{^Lb=nl}', "");
    Expect(1, 133, '\p{Lb=	NL}', "");
    Expect(0, 133, '\p{^Lb=	NL}', "");
    Expect(0, 133, '\P{Lb=	NL}', "");
    Expect(1, 133, '\P{^Lb=	NL}', "");
    Expect(0, 134, '\p{Lb=	NL}', "");
    Expect(1, 134, '\p{^Lb=	NL}', "");
    Expect(1, 134, '\P{Lb=	NL}', "");
    Expect(0, 134, '\P{^Lb=	NL}', "");
    Error('\p{Is_Line_Break: /a/_ NEXT_LINE}');
    Error('\P{Is_Line_Break: /a/_ NEXT_LINE}');
    Expect(1, 133, '\p{Is_Line_Break=nextline}', "");
    Expect(0, 133, '\p{^Is_Line_Break=nextline}', "");
    Expect(0, 133, '\P{Is_Line_Break=nextline}', "");
    Expect(1, 133, '\P{^Is_Line_Break=nextline}', "");
    Expect(0, 134, '\p{Is_Line_Break=nextline}', "");
    Expect(1, 134, '\p{^Is_Line_Break=nextline}', "");
    Expect(1, 134, '\P{Is_Line_Break=nextline}', "");
    Expect(0, 134, '\P{^Is_Line_Break=nextline}', "");
    Expect(1, 133, '\p{Is_Line_Break=	Next_LINE}', "");
    Expect(0, 133, '\p{^Is_Line_Break=	Next_LINE}', "");
    Expect(0, 133, '\P{Is_Line_Break=	Next_LINE}', "");
    Expect(1, 133, '\P{^Is_Line_Break=	Next_LINE}', "");
    Expect(0, 134, '\p{Is_Line_Break=	Next_LINE}', "");
    Expect(1, 134, '\p{^Is_Line_Break=	Next_LINE}', "");
    Expect(1, 134, '\P{Is_Line_Break=	Next_LINE}', "");
    Expect(0, 134, '\P{^Is_Line_Break=	Next_LINE}', "");
    Error('\p{Is_Lb= _nl/a/}');
    Error('\P{Is_Lb= _nl/a/}');
    Expect(1, 133, '\p{Is_Lb=nl}', "");
    Expect(0, 133, '\p{^Is_Lb=nl}', "");
    Expect(0, 133, '\P{Is_Lb=nl}', "");
    Expect(1, 133, '\P{^Is_Lb=nl}', "");
    Expect(0, 134, '\p{Is_Lb=nl}', "");
    Expect(1, 134, '\p{^Is_Lb=nl}', "");
    Expect(1, 134, '\P{Is_Lb=nl}', "");
    Expect(0, 134, '\P{^Is_Lb=nl}', "");
    Expect(1, 133, '\p{Is_Lb=_	nl}', "");
    Expect(0, 133, '\p{^Is_Lb=_	nl}', "");
    Expect(0, 133, '\P{Is_Lb=_	nl}', "");
    Expect(1, 133, '\P{^Is_Lb=_	nl}', "");
    Expect(0, 134, '\p{Is_Lb=_	nl}', "");
    Expect(1, 134, '\p{^Is_Lb=_	nl}', "");
    Expect(1, 134, '\P{Is_Lb=_	nl}', "");
    Expect(0, 134, '\P{^Is_Lb=_	nl}', "");
    Error('\p{Line_Break= -Nonstarter/a/}');
    Error('\P{Line_Break= -Nonstarter/a/}');
    Expect(1, 128635, '\p{Line_Break=nonstarter}', "");
    Expect(0, 128635, '\p{^Line_Break=nonstarter}', "");
    Expect(0, 128635, '\P{Line_Break=nonstarter}', "");
    Expect(1, 128635, '\P{^Line_Break=nonstarter}', "");
    Expect(0, 128636, '\p{Line_Break=nonstarter}', "");
    Expect(1, 128636, '\p{^Line_Break=nonstarter}', "");
    Expect(1, 128636, '\P{Line_Break=nonstarter}', "");
    Expect(0, 128636, '\P{^Line_Break=nonstarter}', "");
    Expect(1, 128635, '\p{Line_Break=	Nonstarter}', "");
    Expect(0, 128635, '\p{^Line_Break=	Nonstarter}', "");
    Expect(0, 128635, '\P{Line_Break=	Nonstarter}', "");
    Expect(1, 128635, '\P{^Line_Break=	Nonstarter}', "");
    Expect(0, 128636, '\p{Line_Break=	Nonstarter}', "");
    Expect(1, 128636, '\p{^Line_Break=	Nonstarter}', "");
    Expect(1, 128636, '\P{Line_Break=	Nonstarter}', "");
    Expect(0, 128636, '\P{^Line_Break=	Nonstarter}', "");
    Error('\p{Lb=:=	 NS}');
    Error('\P{Lb=:=	 NS}');
    Expect(1, 128635, '\p{Lb=ns}', "");
    Expect(0, 128635, '\p{^Lb=ns}', "");
    Expect(0, 128635, '\P{Lb=ns}', "");
    Expect(1, 128635, '\P{^Lb=ns}', "");
    Expect(0, 128636, '\p{Lb=ns}', "");
    Expect(1, 128636, '\p{^Lb=ns}', "");
    Expect(1, 128636, '\P{Lb=ns}', "");
    Expect(0, 128636, '\P{^Lb=ns}', "");
    Expect(1, 128635, '\p{Lb=  NS}', "");
    Expect(0, 128635, '\p{^Lb=  NS}', "");
    Expect(0, 128635, '\P{Lb=  NS}', "");
    Expect(1, 128635, '\P{^Lb=  NS}', "");
    Expect(0, 128636, '\p{Lb=  NS}', "");
    Expect(1, 128636, '\p{^Lb=  NS}', "");
    Expect(1, 128636, '\P{Lb=  NS}', "");
    Expect(0, 128636, '\P{^Lb=  NS}', "");
    Error('\p{Is_Line_Break=_	nonstarter/a/}');
    Error('\P{Is_Line_Break=_	nonstarter/a/}');
    Expect(1, 128635, '\p{Is_Line_Break: nonstarter}', "");
    Expect(0, 128635, '\p{^Is_Line_Break: nonstarter}', "");
    Expect(0, 128635, '\P{Is_Line_Break: nonstarter}', "");
    Expect(1, 128635, '\P{^Is_Line_Break: nonstarter}', "");
    Expect(0, 128636, '\p{Is_Line_Break: nonstarter}', "");
    Expect(1, 128636, '\p{^Is_Line_Break: nonstarter}', "");
    Expect(1, 128636, '\P{Is_Line_Break: nonstarter}', "");
    Expect(0, 128636, '\P{^Is_Line_Break: nonstarter}', "");
    Expect(1, 128635, '\p{Is_Line_Break:	-	Nonstarter}', "");
    Expect(0, 128635, '\p{^Is_Line_Break:	-	Nonstarter}', "");
    Expect(0, 128635, '\P{Is_Line_Break:	-	Nonstarter}', "");
    Expect(1, 128635, '\P{^Is_Line_Break:	-	Nonstarter}', "");
    Expect(0, 128636, '\p{Is_Line_Break:	-	Nonstarter}', "");
    Expect(1, 128636, '\p{^Is_Line_Break:	-	Nonstarter}', "");
    Expect(1, 128636, '\P{Is_Line_Break:	-	Nonstarter}', "");
    Expect(0, 128636, '\P{^Is_Line_Break:	-	Nonstarter}', "");
    Error('\p{Is_Lb=/a/_NS}');
    Error('\P{Is_Lb=/a/_NS}');
    Expect(1, 128635, '\p{Is_Lb:	ns}', "");
    Expect(0, 128635, '\p{^Is_Lb:	ns}', "");
    Expect(0, 128635, '\P{Is_Lb:	ns}', "");
    Expect(1, 128635, '\P{^Is_Lb:	ns}', "");
    Expect(0, 128636, '\p{Is_Lb:	ns}', "");
    Expect(1, 128636, '\p{^Is_Lb:	ns}', "");
    Expect(1, 128636, '\P{Is_Lb:	ns}', "");
    Expect(0, 128636, '\P{^Is_Lb:	ns}', "");
    Expect(1, 128635, '\p{Is_Lb:	NS}', "");
    Expect(0, 128635, '\p{^Is_Lb:	NS}', "");
    Expect(0, 128635, '\P{Is_Lb:	NS}', "");
    Expect(1, 128635, '\P{^Is_Lb:	NS}', "");
    Expect(0, 128636, '\p{Is_Lb:	NS}', "");
    Expect(1, 128636, '\p{^Is_Lb:	NS}', "");
    Expect(1, 128636, '\P{Is_Lb:	NS}', "");
    Expect(0, 128636, '\P{^Is_Lb:	NS}', "");
    Error('\p{Line_Break=-:=numeric}');
    Error('\P{Line_Break=-:=numeric}');
    Expect(1, 125273, '\p{Line_Break=numeric}', "");
    Expect(0, 125273, '\p{^Line_Break=numeric}', "");
    Expect(0, 125273, '\P{Line_Break=numeric}', "");
    Expect(1, 125273, '\P{^Line_Break=numeric}', "");
    Expect(0, 125274, '\p{Line_Break=numeric}', "");
    Expect(1, 125274, '\p{^Line_Break=numeric}', "");
    Expect(1, 125274, '\P{Line_Break=numeric}', "");
    Expect(0, 125274, '\P{^Line_Break=numeric}', "");
    Expect(1, 125273, '\p{Line_Break=-	NUMERIC}', "");
    Expect(0, 125273, '\p{^Line_Break=-	NUMERIC}', "");
    Expect(0, 125273, '\P{Line_Break=-	NUMERIC}', "");
    Expect(1, 125273, '\P{^Line_Break=-	NUMERIC}', "");
    Expect(0, 125274, '\p{Line_Break=-	NUMERIC}', "");
    Expect(1, 125274, '\p{^Line_Break=-	NUMERIC}', "");
    Expect(1, 125274, '\P{Line_Break=-	NUMERIC}', "");
    Expect(0, 125274, '\P{^Line_Break=-	NUMERIC}', "");
    Error('\p{Lb= /a/NU}');
    Error('\P{Lb= /a/NU}');
    Expect(1, 125273, '\p{Lb=nu}', "");
    Expect(0, 125273, '\p{^Lb=nu}', "");
    Expect(0, 125273, '\P{Lb=nu}', "");
    Expect(1, 125273, '\P{^Lb=nu}', "");
    Expect(0, 125274, '\p{Lb=nu}', "");
    Expect(1, 125274, '\p{^Lb=nu}', "");
    Expect(1, 125274, '\P{Lb=nu}', "");
    Expect(0, 125274, '\P{^Lb=nu}', "");
    Expect(1, 125273, '\p{Lb=	NU}', "");
    Expect(0, 125273, '\p{^Lb=	NU}', "");
    Expect(0, 125273, '\P{Lb=	NU}', "");
    Expect(1, 125273, '\P{^Lb=	NU}', "");
    Expect(0, 125274, '\p{Lb=	NU}', "");
    Expect(1, 125274, '\p{^Lb=	NU}', "");
    Expect(1, 125274, '\P{Lb=	NU}', "");
    Expect(0, 125274, '\P{^Lb=	NU}', "");
    Error('\p{Is_Line_Break= 	NUMERIC:=}');
    Error('\P{Is_Line_Break= 	NUMERIC:=}');
    Expect(1, 125273, '\p{Is_Line_Break:numeric}', "");
    Expect(0, 125273, '\p{^Is_Line_Break:numeric}', "");
    Expect(0, 125273, '\P{Is_Line_Break:numeric}', "");
    Expect(1, 125273, '\P{^Is_Line_Break:numeric}', "");
    Expect(0, 125274, '\p{Is_Line_Break:numeric}', "");
    Expect(1, 125274, '\p{^Is_Line_Break:numeric}', "");
    Expect(1, 125274, '\P{Is_Line_Break:numeric}', "");
    Expect(0, 125274, '\P{^Is_Line_Break:numeric}', "");
    Expect(1, 125273, '\p{Is_Line_Break:	-	numeric}', "");
    Expect(0, 125273, '\p{^Is_Line_Break:	-	numeric}', "");
    Expect(0, 125273, '\P{Is_Line_Break:	-	numeric}', "");
    Expect(1, 125273, '\P{^Is_Line_Break:	-	numeric}', "");
    Expect(0, 125274, '\p{Is_Line_Break:	-	numeric}', "");
    Expect(1, 125274, '\p{^Is_Line_Break:	-	numeric}', "");
    Expect(1, 125274, '\P{Is_Line_Break:	-	numeric}', "");
    Expect(0, 125274, '\P{^Is_Line_Break:	-	numeric}', "");
    Error('\p{Is_Lb: :=		NU}');
    Error('\P{Is_Lb: :=		NU}');
    Expect(1, 125273, '\p{Is_Lb=nu}', "");
    Expect(0, 125273, '\p{^Is_Lb=nu}', "");
    Expect(0, 125273, '\P{Is_Lb=nu}', "");
    Expect(1, 125273, '\P{^Is_Lb=nu}', "");
    Expect(0, 125274, '\p{Is_Lb=nu}', "");
    Expect(1, 125274, '\p{^Is_Lb=nu}', "");
    Expect(1, 125274, '\P{Is_Lb=nu}', "");
    Expect(0, 125274, '\P{^Is_Lb=nu}', "");
    Expect(1, 125273, '\p{Is_Lb=_ NU}', "");
    Expect(0, 125273, '\p{^Is_Lb=_ NU}', "");
    Expect(0, 125273, '\P{Is_Lb=_ NU}', "");
    Expect(1, 125273, '\P{^Is_Lb=_ NU}', "");
    Expect(0, 125274, '\p{Is_Lb=_ NU}', "");
    Expect(1, 125274, '\p{^Is_Lb=_ NU}', "");
    Expect(1, 125274, '\P{Is_Lb=_ NU}', "");
    Expect(0, 125274, '\P{^Is_Lb=_ NU}', "");
    Error('\p{Line_Break=/a/-	OPEN_PUNCTUATION}');
    Error('\P{Line_Break=/a/-	OPEN_PUNCTUATION}');
    Expect(1, 125279, '\p{Line_Break=openpunctuation}', "");
    Expect(0, 125279, '\p{^Line_Break=openpunctuation}', "");
    Expect(0, 125279, '\P{Line_Break=openpunctuation}', "");
    Expect(1, 125279, '\P{^Line_Break=openpunctuation}', "");
    Expect(0, 125280, '\p{Line_Break=openpunctuation}', "");
    Expect(1, 125280, '\p{^Line_Break=openpunctuation}', "");
    Expect(1, 125280, '\P{Line_Break=openpunctuation}', "");
    Expect(0, 125280, '\P{^Line_Break=openpunctuation}', "");
    Expect(1, 125279, '\p{Line_Break:	_	Open_punctuation}', "");
    Expect(0, 125279, '\p{^Line_Break:	_	Open_punctuation}', "");
    Expect(0, 125279, '\P{Line_Break:	_	Open_punctuation}', "");
    Expect(1, 125279, '\P{^Line_Break:	_	Open_punctuation}', "");
    Expect(0, 125280, '\p{Line_Break:	_	Open_punctuation}', "");
    Expect(1, 125280, '\p{^Line_Break:	_	Open_punctuation}', "");
    Expect(1, 125280, '\P{Line_Break:	_	Open_punctuation}', "");
    Expect(0, 125280, '\P{^Line_Break:	_	Open_punctuation}', "");
    Error('\p{Lb=-/a/op}');
    Error('\P{Lb=-/a/op}');
    Expect(1, 125279, '\p{Lb:	op}', "");
    Expect(0, 125279, '\p{^Lb:	op}', "");
    Expect(0, 125279, '\P{Lb:	op}', "");
    Expect(1, 125279, '\P{^Lb:	op}', "");
    Expect(0, 125280, '\p{Lb:	op}', "");
    Expect(1, 125280, '\p{^Lb:	op}', "");
    Expect(1, 125280, '\P{Lb:	op}', "");
    Expect(0, 125280, '\P{^Lb:	op}', "");
    Expect(1, 125279, '\p{Lb=	OP}', "");
    Expect(0, 125279, '\p{^Lb=	OP}', "");
    Expect(0, 125279, '\P{Lb=	OP}', "");
    Expect(1, 125279, '\P{^Lb=	OP}', "");
    Expect(0, 125280, '\p{Lb=	OP}', "");
    Expect(1, 125280, '\p{^Lb=	OP}', "");
    Expect(1, 125280, '\P{Lb=	OP}', "");
    Expect(0, 125280, '\P{^Lb=	OP}', "");
    Error('\p{Is_Line_Break=	 Open_punctuation:=}');
    Error('\P{Is_Line_Break=	 Open_punctuation:=}');
    Expect(1, 125279, '\p{Is_Line_Break=openpunctuation}', "");
    Expect(0, 125279, '\p{^Is_Line_Break=openpunctuation}', "");
    Expect(0, 125279, '\P{Is_Line_Break=openpunctuation}', "");
    Expect(1, 125279, '\P{^Is_Line_Break=openpunctuation}', "");
    Expect(0, 125280, '\p{Is_Line_Break=openpunctuation}', "");
    Expect(1, 125280, '\p{^Is_Line_Break=openpunctuation}', "");
    Expect(1, 125280, '\P{Is_Line_Break=openpunctuation}', "");
    Expect(0, 125280, '\P{^Is_Line_Break=openpunctuation}', "");
    Expect(1, 125279, '\p{Is_Line_Break=	-open_Punctuation}', "");
    Expect(0, 125279, '\p{^Is_Line_Break=	-open_Punctuation}', "");
    Expect(0, 125279, '\P{Is_Line_Break=	-open_Punctuation}', "");
    Expect(1, 125279, '\P{^Is_Line_Break=	-open_Punctuation}', "");
    Expect(0, 125280, '\p{Is_Line_Break=	-open_Punctuation}', "");
    Expect(1, 125280, '\p{^Is_Line_Break=	-open_Punctuation}', "");
    Expect(1, 125280, '\P{Is_Line_Break=	-open_Punctuation}', "");
    Expect(0, 125280, '\P{^Is_Line_Break=	-open_Punctuation}', "");
    Error('\p{Is_Lb=-	OP:=}');
    Error('\P{Is_Lb=-	OP:=}');
    Expect(1, 125279, '\p{Is_Lb=op}', "");
    Expect(0, 125279, '\p{^Is_Lb=op}', "");
    Expect(0, 125279, '\P{Is_Lb=op}', "");
    Expect(1, 125279, '\P{^Is_Lb=op}', "");
    Expect(0, 125280, '\p{Is_Lb=op}', "");
    Expect(1, 125280, '\p{^Is_Lb=op}', "");
    Expect(1, 125280, '\P{Is_Lb=op}', "");
    Expect(0, 125280, '\P{^Is_Lb=op}', "");
    Expect(1, 125279, '\p{Is_Lb=	 op}', "");
    Expect(0, 125279, '\p{^Is_Lb=	 op}', "");
    Expect(0, 125279, '\P{Is_Lb=	 op}', "");
    Expect(1, 125279, '\P{^Is_Lb=	 op}', "");
    Expect(0, 125280, '\p{Is_Lb=	 op}', "");
    Expect(1, 125280, '\p{^Is_Lb=	 op}', "");
    Expect(1, 125280, '\P{Is_Lb=	 op}', "");
    Expect(0, 125280, '\P{^Is_Lb=	 op}', "");
    Error('\p{Line_Break:  POSTFIX_numeric/a/}');
    Error('\P{Line_Break:  POSTFIX_numeric/a/}');
    Expect(1, 65504, '\p{Line_Break=postfixnumeric}', "");
    Expect(0, 65504, '\p{^Line_Break=postfixnumeric}', "");
    Expect(0, 65504, '\P{Line_Break=postfixnumeric}', "");
    Expect(1, 65504, '\P{^Line_Break=postfixnumeric}', "");
    Expect(0, 65505, '\p{Line_Break=postfixnumeric}', "");
    Expect(1, 65505, '\p{^Line_Break=postfixnumeric}', "");
    Expect(1, 65505, '\P{Line_Break=postfixnumeric}', "");
    Expect(0, 65505, '\P{^Line_Break=postfixnumeric}', "");
    Expect(1, 65504, '\p{Line_Break= postfix_numeric}', "");
    Expect(0, 65504, '\p{^Line_Break= postfix_numeric}', "");
    Expect(0, 65504, '\P{Line_Break= postfix_numeric}', "");
    Expect(1, 65504, '\P{^Line_Break= postfix_numeric}', "");
    Expect(0, 65505, '\p{Line_Break= postfix_numeric}', "");
    Expect(1, 65505, '\p{^Line_Break= postfix_numeric}', "");
    Expect(1, 65505, '\P{Line_Break= postfix_numeric}', "");
    Expect(0, 65505, '\P{^Line_Break= postfix_numeric}', "");
    Error('\p{Lb:    	PO:=}');
    Error('\P{Lb:    	PO:=}');
    Expect(1, 65504, '\p{Lb=po}', "");
    Expect(0, 65504, '\p{^Lb=po}', "");
    Expect(0, 65504, '\P{Lb=po}', "");
    Expect(1, 65504, '\P{^Lb=po}', "");
    Expect(0, 65505, '\p{Lb=po}', "");
    Expect(1, 65505, '\p{^Lb=po}', "");
    Expect(1, 65505, '\P{Lb=po}', "");
    Expect(0, 65505, '\P{^Lb=po}', "");
    Expect(1, 65504, '\p{Lb=__PO}', "");
    Expect(0, 65504, '\p{^Lb=__PO}', "");
    Expect(0, 65504, '\P{Lb=__PO}', "");
    Expect(1, 65504, '\P{^Lb=__PO}', "");
    Expect(0, 65505, '\p{Lb=__PO}', "");
    Expect(1, 65505, '\p{^Lb=__PO}', "");
    Expect(1, 65505, '\P{Lb=__PO}', "");
    Expect(0, 65505, '\P{^Lb=__PO}', "");
    Error('\p{Is_Line_Break= POSTFIX_NUMERIC/a/}');
    Error('\P{Is_Line_Break= POSTFIX_NUMERIC/a/}');
    Expect(1, 65504, '\p{Is_Line_Break=postfixnumeric}', "");
    Expect(0, 65504, '\p{^Is_Line_Break=postfixnumeric}', "");
    Expect(0, 65504, '\P{Is_Line_Break=postfixnumeric}', "");
    Expect(1, 65504, '\P{^Is_Line_Break=postfixnumeric}', "");
    Expect(0, 65505, '\p{Is_Line_Break=postfixnumeric}', "");
    Expect(1, 65505, '\p{^Is_Line_Break=postfixnumeric}', "");
    Expect(1, 65505, '\P{Is_Line_Break=postfixnumeric}', "");
    Expect(0, 65505, '\P{^Is_Line_Break=postfixnumeric}', "");
    Expect(1, 65504, '\p{Is_Line_Break=-_postfix_NUMERIC}', "");
    Expect(0, 65504, '\p{^Is_Line_Break=-_postfix_NUMERIC}', "");
    Expect(0, 65504, '\P{Is_Line_Break=-_postfix_NUMERIC}', "");
    Expect(1, 65504, '\P{^Is_Line_Break=-_postfix_NUMERIC}', "");
    Expect(0, 65505, '\p{Is_Line_Break=-_postfix_NUMERIC}', "");
    Expect(1, 65505, '\p{^Is_Line_Break=-_postfix_NUMERIC}', "");
    Expect(1, 65505, '\P{Is_Line_Break=-_postfix_NUMERIC}', "");
    Expect(0, 65505, '\P{^Is_Line_Break=-_postfix_NUMERIC}', "");
    Error('\p{Is_Lb:   /a/  po}');
    Error('\P{Is_Lb:   /a/  po}');
    Expect(1, 65504, '\p{Is_Lb=po}', "");
    Expect(0, 65504, '\p{^Is_Lb=po}', "");
    Expect(0, 65504, '\P{Is_Lb=po}', "");
    Expect(1, 65504, '\P{^Is_Lb=po}', "");
    Expect(0, 65505, '\p{Is_Lb=po}', "");
    Expect(1, 65505, '\p{^Is_Lb=po}', "");
    Expect(1, 65505, '\P{Is_Lb=po}', "");
    Expect(0, 65505, '\P{^Is_Lb=po}', "");
    Expect(1, 65504, '\p{Is_Lb=-_PO}', "");
    Expect(0, 65504, '\p{^Is_Lb=-_PO}', "");
    Expect(0, 65504, '\P{Is_Lb=-_PO}', "");
    Expect(1, 65504, '\P{^Is_Lb=-_PO}', "");
    Expect(0, 65505, '\p{Is_Lb=-_PO}', "");
    Expect(1, 65505, '\p{^Is_Lb=-_PO}', "");
    Expect(1, 65505, '\P{Is_Lb=-_PO}', "");
    Expect(0, 65505, '\P{^Is_Lb=-_PO}', "");
    Error('\p{Line_Break=_prefix_Numeric:=}');
    Error('\P{Line_Break=_prefix_Numeric:=}');
    Expect(1, 65510, '\p{Line_Break=prefixnumeric}', "");
    Expect(0, 65510, '\p{^Line_Break=prefixnumeric}', "");
    Expect(0, 65510, '\P{Line_Break=prefixnumeric}', "");
    Expect(1, 65510, '\P{^Line_Break=prefixnumeric}', "");
    Expect(0, 65511, '\p{Line_Break=prefixnumeric}', "");
    Expect(1, 65511, '\p{^Line_Break=prefixnumeric}', "");
    Expect(1, 65511, '\P{Line_Break=prefixnumeric}', "");
    Expect(0, 65511, '\P{^Line_Break=prefixnumeric}', "");
    Expect(1, 65510, '\p{Line_Break=-Prefix_Numeric}', "");
    Expect(0, 65510, '\p{^Line_Break=-Prefix_Numeric}', "");
    Expect(0, 65510, '\P{Line_Break=-Prefix_Numeric}', "");
    Expect(1, 65510, '\P{^Line_Break=-Prefix_Numeric}', "");
    Expect(0, 65511, '\p{Line_Break=-Prefix_Numeric}', "");
    Expect(1, 65511, '\p{^Line_Break=-Prefix_Numeric}', "");
    Expect(1, 65511, '\P{Line_Break=-Prefix_Numeric}', "");
    Expect(0, 65511, '\P{^Line_Break=-Prefix_Numeric}', "");
    Error('\p{Lb=/a/--PR}');
    Error('\P{Lb=/a/--PR}');
    Expect(1, 65510, '\p{Lb=pr}', "");
    Expect(0, 65510, '\p{^Lb=pr}', "");
    Expect(0, 65510, '\P{Lb=pr}', "");
    Expect(1, 65510, '\P{^Lb=pr}', "");
    Expect(0, 65511, '\p{Lb=pr}', "");
    Expect(1, 65511, '\p{^Lb=pr}', "");
    Expect(1, 65511, '\P{Lb=pr}', "");
    Expect(0, 65511, '\P{^Lb=pr}', "");
    Expect(1, 65510, '\p{Lb=_PR}', "");
    Expect(0, 65510, '\p{^Lb=_PR}', "");
    Expect(0, 65510, '\P{Lb=_PR}', "");
    Expect(1, 65510, '\P{^Lb=_PR}', "");
    Expect(0, 65511, '\p{Lb=_PR}', "");
    Expect(1, 65511, '\p{^Lb=_PR}', "");
    Expect(1, 65511, '\P{Lb=_PR}', "");
    Expect(0, 65511, '\P{^Lb=_PR}', "");
    Error('\p{Is_Line_Break=	 Prefix_numeric:=}');
    Error('\P{Is_Line_Break=	 Prefix_numeric:=}');
    Expect(1, 65510, '\p{Is_Line_Break=prefixnumeric}', "");
    Expect(0, 65510, '\p{^Is_Line_Break=prefixnumeric}', "");
    Expect(0, 65510, '\P{Is_Line_Break=prefixnumeric}', "");
    Expect(1, 65510, '\P{^Is_Line_Break=prefixnumeric}', "");
    Expect(0, 65511, '\p{Is_Line_Break=prefixnumeric}', "");
    Expect(1, 65511, '\p{^Is_Line_Break=prefixnumeric}', "");
    Expect(1, 65511, '\P{Is_Line_Break=prefixnumeric}', "");
    Expect(0, 65511, '\P{^Is_Line_Break=prefixnumeric}', "");
    Expect(1, 65510, '\p{Is_Line_Break=_-Prefix_Numeric}', "");
    Expect(0, 65510, '\p{^Is_Line_Break=_-Prefix_Numeric}', "");
    Expect(0, 65510, '\P{Is_Line_Break=_-Prefix_Numeric}', "");
    Expect(1, 65510, '\P{^Is_Line_Break=_-Prefix_Numeric}', "");
    Expect(0, 65511, '\p{Is_Line_Break=_-Prefix_Numeric}', "");
    Expect(1, 65511, '\p{^Is_Line_Break=_-Prefix_Numeric}', "");
    Expect(1, 65511, '\P{Is_Line_Break=_-Prefix_Numeric}', "");
    Expect(0, 65511, '\P{^Is_Line_Break=_-Prefix_Numeric}', "");
    Error('\p{Is_Lb=_/a/PR}');
    Error('\P{Is_Lb=_/a/PR}');
    Expect(1, 65510, '\p{Is_Lb: pr}', "");
    Expect(0, 65510, '\p{^Is_Lb: pr}', "");
    Expect(0, 65510, '\P{Is_Lb: pr}', "");
    Expect(1, 65510, '\P{^Is_Lb: pr}', "");
    Expect(0, 65511, '\p{Is_Lb: pr}', "");
    Expect(1, 65511, '\p{^Is_Lb: pr}', "");
    Expect(1, 65511, '\P{Is_Lb: pr}', "");
    Expect(0, 65511, '\P{^Is_Lb: pr}', "");
    Expect(1, 65510, '\p{Is_Lb= _PR}', "");
    Expect(0, 65510, '\p{^Is_Lb= _PR}', "");
    Expect(0, 65510, '\P{Is_Lb= _PR}', "");
    Expect(1, 65510, '\P{^Is_Lb= _PR}', "");
    Expect(0, 65511, '\p{Is_Lb= _PR}', "");
    Expect(1, 65511, '\p{^Is_Lb= _PR}', "");
    Expect(1, 65511, '\P{Is_Lb= _PR}', "");
    Expect(0, 65511, '\P{^Is_Lb= _PR}', "");
    Error('\p{Line_Break=		QUOTATION/a/}');
    Error('\P{Line_Break=		QUOTATION/a/}');
    Expect(1, 128632, '\p{Line_Break:quotation}', "");
    Expect(0, 128632, '\p{^Line_Break:quotation}', "");
    Expect(0, 128632, '\P{Line_Break:quotation}', "");
    Expect(1, 128632, '\P{^Line_Break:quotation}', "");
    Expect(0, 128633, '\p{Line_Break:quotation}', "");
    Expect(1, 128633, '\p{^Line_Break:quotation}', "");
    Expect(1, 128633, '\P{Line_Break:quotation}', "");
    Expect(0, 128633, '\P{^Line_Break:quotation}', "");
    Expect(1, 128632, '\p{Line_Break= 	Quotation}', "");
    Expect(0, 128632, '\p{^Line_Break= 	Quotation}', "");
    Expect(0, 128632, '\P{Line_Break= 	Quotation}', "");
    Expect(1, 128632, '\P{^Line_Break= 	Quotation}', "");
    Expect(0, 128633, '\p{Line_Break= 	Quotation}', "");
    Expect(1, 128633, '\p{^Line_Break= 	Quotation}', "");
    Expect(1, 128633, '\P{Line_Break= 	Quotation}', "");
    Expect(0, 128633, '\P{^Line_Break= 	Quotation}', "");
    Error('\p{Lb= :=QU}');
    Error('\P{Lb= :=QU}');
    Expect(1, 128632, '\p{Lb=qu}', "");
    Expect(0, 128632, '\p{^Lb=qu}', "");
    Expect(0, 128632, '\P{Lb=qu}', "");
    Expect(1, 128632, '\P{^Lb=qu}', "");
    Expect(0, 128633, '\p{Lb=qu}', "");
    Expect(1, 128633, '\p{^Lb=qu}', "");
    Expect(1, 128633, '\P{Lb=qu}', "");
    Expect(0, 128633, '\P{^Lb=qu}', "");
    Expect(1, 128632, '\p{Lb=	qu}', "");
    Expect(0, 128632, '\p{^Lb=	qu}', "");
    Expect(0, 128632, '\P{Lb=	qu}', "");
    Expect(1, 128632, '\P{^Lb=	qu}', "");
    Expect(0, 128633, '\p{Lb=	qu}', "");
    Expect(1, 128633, '\p{^Lb=	qu}', "");
    Expect(1, 128633, '\P{Lb=	qu}', "");
    Expect(0, 128633, '\P{^Lb=	qu}', "");
    Error('\p{Is_Line_Break=-QUOTATION/a/}');
    Error('\P{Is_Line_Break=-QUOTATION/a/}');
    Expect(1, 128632, '\p{Is_Line_Break=quotation}', "");
    Expect(0, 128632, '\p{^Is_Line_Break=quotation}', "");
    Expect(0, 128632, '\P{Is_Line_Break=quotation}', "");
    Expect(1, 128632, '\P{^Is_Line_Break=quotation}', "");
    Expect(0, 128633, '\p{Is_Line_Break=quotation}', "");
    Expect(1, 128633, '\p{^Is_Line_Break=quotation}', "");
    Expect(1, 128633, '\P{Is_Line_Break=quotation}', "");
    Expect(0, 128633, '\P{^Is_Line_Break=quotation}', "");
    Expect(1, 128632, '\p{Is_Line_Break=-	QUOTATION}', "");
    Expect(0, 128632, '\p{^Is_Line_Break=-	QUOTATION}', "");
    Expect(0, 128632, '\P{Is_Line_Break=-	QUOTATION}', "");
    Expect(1, 128632, '\P{^Is_Line_Break=-	QUOTATION}', "");
    Expect(0, 128633, '\p{Is_Line_Break=-	QUOTATION}', "");
    Expect(1, 128633, '\p{^Is_Line_Break=-	QUOTATION}', "");
    Expect(1, 128633, '\P{Is_Line_Break=-	QUOTATION}', "");
    Expect(0, 128633, '\P{^Is_Line_Break=-	QUOTATION}', "");
    Error('\p{Is_Lb=	-QU/a/}');
    Error('\P{Is_Lb=	-QU/a/}');
    Expect(1, 128632, '\p{Is_Lb=qu}', "");
    Expect(0, 128632, '\p{^Is_Lb=qu}', "");
    Expect(0, 128632, '\P{Is_Lb=qu}', "");
    Expect(1, 128632, '\P{^Is_Lb=qu}', "");
    Expect(0, 128633, '\p{Is_Lb=qu}', "");
    Expect(1, 128633, '\p{^Is_Lb=qu}', "");
    Expect(1, 128633, '\P{Is_Lb=qu}', "");
    Expect(0, 128633, '\P{^Is_Lb=qu}', "");
    Expect(1, 128632, '\p{Is_Lb=	_QU}', "");
    Expect(0, 128632, '\p{^Is_Lb=	_QU}', "");
    Expect(0, 128632, '\P{Is_Lb=	_QU}', "");
    Expect(1, 128632, '\P{^Is_Lb=	_QU}', "");
    Expect(0, 128633, '\p{Is_Lb=	_QU}', "");
    Expect(1, 128633, '\p{^Is_Lb=	_QU}', "");
    Expect(1, 128633, '\P{Is_Lb=	_QU}', "");
    Expect(0, 128633, '\P{^Is_Lb=	_QU}', "");
    Error('\p{Line_Break=	/a/regional_Indicator}');
    Error('\P{Line_Break=	/a/regional_Indicator}');
    Expect(1, 127487, '\p{Line_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Line_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Line_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Line_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Line_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Line_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Line_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Line_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Line_Break=-_regional_Indicator}', "");
    Expect(0, 127487, '\p{^Line_Break=-_regional_Indicator}', "");
    Expect(0, 127487, '\P{Line_Break=-_regional_Indicator}', "");
    Expect(1, 127487, '\P{^Line_Break=-_regional_Indicator}', "");
    Expect(0, 127488, '\p{Line_Break=-_regional_Indicator}', "");
    Expect(1, 127488, '\p{^Line_Break=-_regional_Indicator}', "");
    Expect(1, 127488, '\P{Line_Break=-_regional_Indicator}', "");
    Expect(0, 127488, '\P{^Line_Break=-_regional_Indicator}', "");
    Error('\p{Lb=/a/ RI}');
    Error('\P{Lb=/a/ RI}');
    Expect(1, 127487, '\p{Lb=ri}', "");
    Expect(0, 127487, '\p{^Lb=ri}', "");
    Expect(0, 127487, '\P{Lb=ri}', "");
    Expect(1, 127487, '\P{^Lb=ri}', "");
    Expect(0, 127488, '\p{Lb=ri}', "");
    Expect(1, 127488, '\p{^Lb=ri}', "");
    Expect(1, 127488, '\P{Lb=ri}', "");
    Expect(0, 127488, '\P{^Lb=ri}', "");
    Expect(1, 127487, '\p{Lb=		RI}', "");
    Expect(0, 127487, '\p{^Lb=		RI}', "");
    Expect(0, 127487, '\P{Lb=		RI}', "");
    Expect(1, 127487, '\P{^Lb=		RI}', "");
    Expect(0, 127488, '\p{Lb=		RI}', "");
    Expect(1, 127488, '\p{^Lb=		RI}', "");
    Expect(1, 127488, '\P{Lb=		RI}', "");
    Expect(0, 127488, '\P{^Lb=		RI}', "");
    Error('\p{Is_Line_Break=--regional_Indicator/a/}');
    Error('\P{Is_Line_Break=--regional_Indicator/a/}');
    Expect(1, 127487, '\p{Is_Line_Break:   regionalindicator}', "");
    Expect(0, 127487, '\p{^Is_Line_Break:   regionalindicator}', "");
    Expect(0, 127487, '\P{Is_Line_Break:   regionalindicator}', "");
    Expect(1, 127487, '\P{^Is_Line_Break:   regionalindicator}', "");
    Expect(0, 127488, '\p{Is_Line_Break:   regionalindicator}', "");
    Expect(1, 127488, '\p{^Is_Line_Break:   regionalindicator}', "");
    Expect(1, 127488, '\P{Is_Line_Break:   regionalindicator}', "");
    Expect(0, 127488, '\P{^Is_Line_Break:   regionalindicator}', "");
    Expect(1, 127487, '\p{Is_Line_Break=		REGIONAL_Indicator}', "");
    Expect(0, 127487, '\p{^Is_Line_Break=		REGIONAL_Indicator}', "");
    Expect(0, 127487, '\P{Is_Line_Break=		REGIONAL_Indicator}', "");
    Expect(1, 127487, '\P{^Is_Line_Break=		REGIONAL_Indicator}', "");
    Expect(0, 127488, '\p{Is_Line_Break=		REGIONAL_Indicator}', "");
    Expect(1, 127488, '\p{^Is_Line_Break=		REGIONAL_Indicator}', "");
    Expect(1, 127488, '\P{Is_Line_Break=		REGIONAL_Indicator}', "");
    Expect(0, 127488, '\P{^Is_Line_Break=		REGIONAL_Indicator}', "");
    Error('\p{Is_Lb:    :=RI}');
    Error('\P{Is_Lb:    :=RI}');
    Expect(1, 127487, '\p{Is_Lb=ri}', "");
    Expect(0, 127487, '\p{^Is_Lb=ri}', "");
    Expect(0, 127487, '\P{Is_Lb=ri}', "");
    Expect(1, 127487, '\P{^Is_Lb=ri}', "");
    Expect(0, 127488, '\p{Is_Lb=ri}', "");
    Expect(1, 127488, '\p{^Is_Lb=ri}', "");
    Expect(1, 127488, '\P{Is_Lb=ri}', "");
    Expect(0, 127488, '\P{^Is_Lb=ri}', "");
    Expect(1, 127487, '\p{Is_Lb=--RI}', "");
    Expect(0, 127487, '\p{^Is_Lb=--RI}', "");
    Expect(0, 127487, '\P{Is_Lb=--RI}', "");
    Expect(1, 127487, '\P{^Is_Lb=--RI}', "");
    Expect(0, 127488, '\p{Is_Lb=--RI}', "");
    Expect(1, 127488, '\p{^Is_Lb=--RI}', "");
    Expect(1, 127488, '\P{Is_Lb=--RI}', "");
    Expect(0, 127488, '\P{^Is_Lb=--RI}', "");
    Error('\p{Line_Break=	/a/COMPLEX_CONTEXT}');
    Error('\P{Line_Break=	/a/COMPLEX_CONTEXT}');
    Expect(1, 71487, '\p{Line_Break=complexcontext}', "");
    Expect(0, 71487, '\p{^Line_Break=complexcontext}', "");
    Expect(0, 71487, '\P{Line_Break=complexcontext}', "");
    Expect(1, 71487, '\P{^Line_Break=complexcontext}', "");
    Expect(0, 71488, '\p{Line_Break=complexcontext}', "");
    Expect(1, 71488, '\p{^Line_Break=complexcontext}', "");
    Expect(1, 71488, '\P{Line_Break=complexcontext}', "");
    Expect(0, 71488, '\P{^Line_Break=complexcontext}', "");
    Expect(1, 71487, '\p{Line_Break=	Complex_context}', "");
    Expect(0, 71487, '\p{^Line_Break=	Complex_context}', "");
    Expect(0, 71487, '\P{Line_Break=	Complex_context}', "");
    Expect(1, 71487, '\P{^Line_Break=	Complex_context}', "");
    Expect(0, 71488, '\p{Line_Break=	Complex_context}', "");
    Expect(1, 71488, '\p{^Line_Break=	Complex_context}', "");
    Expect(1, 71488, '\P{Line_Break=	Complex_context}', "");
    Expect(0, 71488, '\P{^Line_Break=	Complex_context}', "");
    Error('\p{Lb=- SA:=}');
    Error('\P{Lb=- SA:=}');
    Expect(1, 71487, '\p{Lb=sa}', "");
    Expect(0, 71487, '\p{^Lb=sa}', "");
    Expect(0, 71487, '\P{Lb=sa}', "");
    Expect(1, 71487, '\P{^Lb=sa}', "");
    Expect(0, 71488, '\p{Lb=sa}', "");
    Expect(1, 71488, '\p{^Lb=sa}', "");
    Expect(1, 71488, '\P{Lb=sa}', "");
    Expect(0, 71488, '\P{^Lb=sa}', "");
    Expect(1, 71487, '\p{Lb=	SA}', "");
    Expect(0, 71487, '\p{^Lb=	SA}', "");
    Expect(0, 71487, '\P{Lb=	SA}', "");
    Expect(1, 71487, '\P{^Lb=	SA}', "");
    Expect(0, 71488, '\p{Lb=	SA}', "");
    Expect(1, 71488, '\p{^Lb=	SA}', "");
    Expect(1, 71488, '\P{Lb=	SA}', "");
    Expect(0, 71488, '\P{^Lb=	SA}', "");
    Error('\p{Is_Line_Break=-:=Complex_Context}');
    Error('\P{Is_Line_Break=-:=Complex_Context}');
    Expect(1, 71487, '\p{Is_Line_Break=complexcontext}', "");
    Expect(0, 71487, '\p{^Is_Line_Break=complexcontext}', "");
    Expect(0, 71487, '\P{Is_Line_Break=complexcontext}', "");
    Expect(1, 71487, '\P{^Is_Line_Break=complexcontext}', "");
    Expect(0, 71488, '\p{Is_Line_Break=complexcontext}', "");
    Expect(1, 71488, '\p{^Is_Line_Break=complexcontext}', "");
    Expect(1, 71488, '\P{Is_Line_Break=complexcontext}', "");
    Expect(0, 71488, '\P{^Is_Line_Break=complexcontext}', "");
    Expect(1, 71487, '\p{Is_Line_Break:   -complex_Context}', "");
    Expect(0, 71487, '\p{^Is_Line_Break:   -complex_Context}', "");
    Expect(0, 71487, '\P{Is_Line_Break:   -complex_Context}', "");
    Expect(1, 71487, '\P{^Is_Line_Break:   -complex_Context}', "");
    Expect(0, 71488, '\p{Is_Line_Break:   -complex_Context}', "");
    Expect(1, 71488, '\p{^Is_Line_Break:   -complex_Context}', "");
    Expect(1, 71488, '\P{Is_Line_Break:   -complex_Context}', "");
    Expect(0, 71488, '\P{^Is_Line_Break:   -complex_Context}', "");
    Error('\p{Is_Lb= :=sa}');
    Error('\P{Is_Lb= :=sa}');
    Expect(1, 71487, '\p{Is_Lb=sa}', "");
    Expect(0, 71487, '\p{^Is_Lb=sa}', "");
    Expect(0, 71487, '\P{Is_Lb=sa}', "");
    Expect(1, 71487, '\P{^Is_Lb=sa}', "");
    Expect(0, 71488, '\p{Is_Lb=sa}', "");
    Expect(1, 71488, '\p{^Is_Lb=sa}', "");
    Expect(1, 71488, '\P{Is_Lb=sa}', "");
    Expect(0, 71488, '\P{^Is_Lb=sa}', "");
    Expect(1, 71487, '\p{Is_Lb= SA}', "");
    Expect(0, 71487, '\p{^Is_Lb= SA}', "");
    Expect(0, 71487, '\P{Is_Lb= SA}', "");
    Expect(1, 71487, '\P{^Is_Lb= SA}', "");
    Expect(0, 71488, '\p{Is_Lb= SA}', "");
    Expect(1, 71488, '\p{^Is_Lb= SA}', "");
    Expect(1, 71488, '\P{Is_Lb= SA}', "");
    Expect(0, 71488, '\P{^Is_Lb= SA}', "");
    Error('\p{Line_Break=	Surrogate:=}');
    Error('\P{Line_Break=	Surrogate:=}');
    Expect(1, 57343, '\p{Line_Break=surrogate}', 'deprecated');
    Expect(0, 57343, '\p{^Line_Break=surrogate}', 'deprecated');
    Expect(0, 57343, '\P{Line_Break=surrogate}', 'deprecated');
    Expect(1, 57343, '\P{^Line_Break=surrogate}', 'deprecated');
    Expect(0, 57344, '\p{Line_Break=surrogate}', 'deprecated');
    Expect(1, 57344, '\p{^Line_Break=surrogate}', 'deprecated');
    Expect(1, 57344, '\P{Line_Break=surrogate}', 'deprecated');
    Expect(0, 57344, '\P{^Line_Break=surrogate}', 'deprecated');
    Expect(1, 57343, '\p{Line_Break=__surrogate}', 'deprecated');
    Expect(0, 57343, '\p{^Line_Break=__surrogate}', 'deprecated');
    Expect(0, 57343, '\P{Line_Break=__surrogate}', 'deprecated');
    Expect(1, 57343, '\P{^Line_Break=__surrogate}', 'deprecated');
    Expect(0, 57344, '\p{Line_Break=__surrogate}', 'deprecated');
    Expect(1, 57344, '\p{^Line_Break=__surrogate}', 'deprecated');
    Expect(1, 57344, '\P{Line_Break=__surrogate}', 'deprecated');
    Expect(0, 57344, '\P{^Line_Break=__surrogate}', 'deprecated');
    Error('\p{Lb=	_SG/a/}');
    Error('\P{Lb=	_SG/a/}');
    Expect(1, 57343, '\p{Lb=sg}', 'deprecated');
    Expect(0, 57343, '\p{^Lb=sg}', 'deprecated');
    Expect(0, 57343, '\P{Lb=sg}', 'deprecated');
    Expect(1, 57343, '\P{^Lb=sg}', 'deprecated');
    Expect(0, 57344, '\p{Lb=sg}', 'deprecated');
    Expect(1, 57344, '\p{^Lb=sg}', 'deprecated');
    Expect(1, 57344, '\P{Lb=sg}', 'deprecated');
    Expect(0, 57344, '\P{^Lb=sg}', 'deprecated');
    Expect(1, 57343, '\p{Lb:	 SG}', 'deprecated');
    Expect(0, 57343, '\p{^Lb:	 SG}', 'deprecated');
    Expect(0, 57343, '\P{Lb:	 SG}', 'deprecated');
    Expect(1, 57343, '\P{^Lb:	 SG}', 'deprecated');
    Expect(0, 57344, '\p{Lb:	 SG}', 'deprecated');
    Expect(1, 57344, '\p{^Lb:	 SG}', 'deprecated');
    Expect(1, 57344, '\P{Lb:	 SG}', 'deprecated');
    Expect(0, 57344, '\P{^Lb:	 SG}', 'deprecated');
    Error('\p{Is_Line_Break=/a/ -Surrogate}');
    Error('\P{Is_Line_Break=/a/ -Surrogate}');
    Expect(1, 57343, '\p{Is_Line_Break=surrogate}', 'deprecated');
    Expect(0, 57343, '\p{^Is_Line_Break=surrogate}', 'deprecated');
    Expect(0, 57343, '\P{Is_Line_Break=surrogate}', 'deprecated');
    Expect(1, 57343, '\P{^Is_Line_Break=surrogate}', 'deprecated');
    Expect(0, 57344, '\p{Is_Line_Break=surrogate}', 'deprecated');
    Expect(1, 57344, '\p{^Is_Line_Break=surrogate}', 'deprecated');
    Expect(1, 57344, '\P{Is_Line_Break=surrogate}', 'deprecated');
    Expect(0, 57344, '\P{^Is_Line_Break=surrogate}', 'deprecated');
    Expect(1, 57343, '\p{Is_Line_Break:_SURROGATE}', 'deprecated');
    Expect(0, 57343, '\p{^Is_Line_Break:_SURROGATE}', 'deprecated');
    Expect(0, 57343, '\P{Is_Line_Break:_SURROGATE}', 'deprecated');
    Expect(1, 57343, '\P{^Is_Line_Break:_SURROGATE}', 'deprecated');
    Expect(0, 57344, '\p{Is_Line_Break:_SURROGATE}', 'deprecated');
    Expect(1, 57344, '\p{^Is_Line_Break:_SURROGATE}', 'deprecated');
    Expect(1, 57344, '\P{Is_Line_Break:_SURROGATE}', 'deprecated');
    Expect(0, 57344, '\P{^Is_Line_Break:_SURROGATE}', 'deprecated');
    Error('\p{Is_Lb=:=SG}');
    Error('\P{Is_Lb=:=SG}');
    Expect(1, 57343, '\p{Is_Lb=sg}', 'deprecated');
    Expect(0, 57343, '\p{^Is_Lb=sg}', 'deprecated');
    Expect(0, 57343, '\P{Is_Lb=sg}', 'deprecated');
    Expect(1, 57343, '\P{^Is_Lb=sg}', 'deprecated');
    Expect(0, 57344, '\p{Is_Lb=sg}', 'deprecated');
    Expect(1, 57344, '\p{^Is_Lb=sg}', 'deprecated');
    Expect(1, 57344, '\P{Is_Lb=sg}', 'deprecated');
    Expect(0, 57344, '\P{^Is_Lb=sg}', 'deprecated');
    Expect(1, 57343, '\p{Is_Lb:    sg}', 'deprecated');
    Expect(0, 57343, '\p{^Is_Lb:    sg}', 'deprecated');
    Expect(0, 57343, '\P{Is_Lb:    sg}', 'deprecated');
    Expect(1, 57343, '\P{^Is_Lb:    sg}', 'deprecated');
    Expect(0, 57344, '\p{Is_Lb:    sg}', 'deprecated');
    Expect(1, 57344, '\p{^Is_Lb:    sg}', 'deprecated');
    Expect(1, 57344, '\P{Is_Lb:    sg}', 'deprecated');
    Expect(0, 57344, '\P{^Is_Lb:    sg}', 'deprecated');
    Error('\p{Line_Break=		space/a/}');
    Error('\P{Line_Break=		space/a/}');
    Expect(1, 32, '\p{Line_Break=space}', "");
    Expect(0, 32, '\p{^Line_Break=space}', "");
    Expect(0, 32, '\P{Line_Break=space}', "");
    Expect(1, 32, '\P{^Line_Break=space}', "");
    Expect(0, 33, '\p{Line_Break=space}', "");
    Expect(1, 33, '\p{^Line_Break=space}', "");
    Expect(1, 33, '\P{Line_Break=space}', "");
    Expect(0, 33, '\P{^Line_Break=space}', "");
    Expect(1, 32, '\p{Line_Break=	 SPACE}', "");
    Expect(0, 32, '\p{^Line_Break=	 SPACE}', "");
    Expect(0, 32, '\P{Line_Break=	 SPACE}', "");
    Expect(1, 32, '\P{^Line_Break=	 SPACE}', "");
    Expect(0, 33, '\p{Line_Break=	 SPACE}', "");
    Expect(1, 33, '\p{^Line_Break=	 SPACE}', "");
    Expect(1, 33, '\P{Line_Break=	 SPACE}', "");
    Expect(0, 33, '\P{^Line_Break=	 SPACE}', "");
    Error('\p{Lb=	/a/sp}');
    Error('\P{Lb=	/a/sp}');
    Expect(1, 32, '\p{Lb=sp}', "");
    Expect(0, 32, '\p{^Lb=sp}', "");
    Expect(0, 32, '\P{Lb=sp}', "");
    Expect(1, 32, '\P{^Lb=sp}', "");
    Expect(0, 33, '\p{Lb=sp}', "");
    Expect(1, 33, '\p{^Lb=sp}', "");
    Expect(1, 33, '\P{Lb=sp}', "");
    Expect(0, 33, '\P{^Lb=sp}', "");
    Expect(1, 32, '\p{Lb=	sp}', "");
    Expect(0, 32, '\p{^Lb=	sp}', "");
    Expect(0, 32, '\P{Lb=	sp}', "");
    Expect(1, 32, '\P{^Lb=	sp}', "");
    Expect(0, 33, '\p{Lb=	sp}', "");
    Expect(1, 33, '\p{^Lb=	sp}', "");
    Expect(1, 33, '\P{Lb=	sp}', "");
    Expect(0, 33, '\P{^Lb=	sp}', "");
    Error('\p{Is_Line_Break::= 	Space}');
    Error('\P{Is_Line_Break::= 	Space}');
    Expect(1, 32, '\p{Is_Line_Break=space}', "");
    Expect(0, 32, '\p{^Is_Line_Break=space}', "");
    Expect(0, 32, '\P{Is_Line_Break=space}', "");
    Expect(1, 32, '\P{^Is_Line_Break=space}', "");
    Expect(0, 33, '\p{Is_Line_Break=space}', "");
    Expect(1, 33, '\p{^Is_Line_Break=space}', "");
    Expect(1, 33, '\P{Is_Line_Break=space}', "");
    Expect(0, 33, '\P{^Is_Line_Break=space}', "");
    Expect(1, 32, '\p{Is_Line_Break=	SPACE}', "");
    Expect(0, 32, '\p{^Is_Line_Break=	SPACE}', "");
    Expect(0, 32, '\P{Is_Line_Break=	SPACE}', "");
    Expect(1, 32, '\P{^Is_Line_Break=	SPACE}', "");
    Expect(0, 33, '\p{Is_Line_Break=	SPACE}', "");
    Expect(1, 33, '\p{^Is_Line_Break=	SPACE}', "");
    Expect(1, 33, '\P{Is_Line_Break=	SPACE}', "");
    Expect(0, 33, '\P{^Is_Line_Break=	SPACE}', "");
    Error('\p{Is_Lb=-_SP:=}');
    Error('\P{Is_Lb=-_SP:=}');
    Expect(1, 32, '\p{Is_Lb=sp}', "");
    Expect(0, 32, '\p{^Is_Lb=sp}', "");
    Expect(0, 32, '\P{Is_Lb=sp}', "");
    Expect(1, 32, '\P{^Is_Lb=sp}', "");
    Expect(0, 33, '\p{Is_Lb=sp}', "");
    Expect(1, 33, '\p{^Is_Lb=sp}', "");
    Expect(1, 33, '\P{Is_Lb=sp}', "");
    Expect(0, 33, '\P{^Is_Lb=sp}', "");
    Expect(1, 32, '\p{Is_Lb=SP}', "");
    Expect(0, 32, '\p{^Is_Lb=SP}', "");
    Expect(0, 32, '\P{Is_Lb=SP}', "");
    Expect(1, 32, '\P{^Is_Lb=SP}', "");
    Expect(0, 33, '\p{Is_Lb=SP}', "");
    Expect(1, 33, '\p{^Is_Lb=SP}', "");
    Expect(1, 33, '\P{Is_Lb=SP}', "");
    Expect(0, 33, '\P{^Is_Lb=SP}', "");
    Error('\p{Line_Break:_break_SYMBOLS/a/}');
    Error('\P{Line_Break:_break_SYMBOLS/a/}');
    Expect(1, 47, '\p{Line_Break=breaksymbols}', "");
    Expect(0, 47, '\p{^Line_Break=breaksymbols}', "");
    Expect(0, 47, '\P{Line_Break=breaksymbols}', "");
    Expect(1, 47, '\P{^Line_Break=breaksymbols}', "");
    Expect(0, 48, '\p{Line_Break=breaksymbols}', "");
    Expect(1, 48, '\p{^Line_Break=breaksymbols}', "");
    Expect(1, 48, '\P{Line_Break=breaksymbols}', "");
    Expect(0, 48, '\P{^Line_Break=breaksymbols}', "");
    Expect(1, 47, '\p{Line_Break:   -	BREAK_Symbols}', "");
    Expect(0, 47, '\p{^Line_Break:   -	BREAK_Symbols}', "");
    Expect(0, 47, '\P{Line_Break:   -	BREAK_Symbols}', "");
    Expect(1, 47, '\P{^Line_Break:   -	BREAK_Symbols}', "");
    Expect(0, 48, '\p{Line_Break:   -	BREAK_Symbols}', "");
    Expect(1, 48, '\p{^Line_Break:   -	BREAK_Symbols}', "");
    Expect(1, 48, '\P{Line_Break:   -	BREAK_Symbols}', "");
    Expect(0, 48, '\P{^Line_Break:   -	BREAK_Symbols}', "");
    Error('\p{Lb=:=SY}');
    Error('\P{Lb=:=SY}');
    Expect(1, 47, '\p{Lb=sy}', "");
    Expect(0, 47, '\p{^Lb=sy}', "");
    Expect(0, 47, '\P{Lb=sy}', "");
    Expect(1, 47, '\P{^Lb=sy}', "");
    Expect(0, 48, '\p{Lb=sy}', "");
    Expect(1, 48, '\p{^Lb=sy}', "");
    Expect(1, 48, '\P{Lb=sy}', "");
    Expect(0, 48, '\P{^Lb=sy}', "");
    Expect(1, 47, '\p{Lb:		_sy}', "");
    Expect(0, 47, '\p{^Lb:		_sy}', "");
    Expect(0, 47, '\P{Lb:		_sy}', "");
    Expect(1, 47, '\P{^Lb:		_sy}', "");
    Expect(0, 48, '\p{Lb:		_sy}', "");
    Expect(1, 48, '\p{^Lb:		_sy}', "");
    Expect(1, 48, '\P{Lb:		_sy}', "");
    Expect(0, 48, '\P{^Lb:		_sy}', "");
    Error('\p{Is_Line_Break= /a/Break_Symbols}');
    Error('\P{Is_Line_Break= /a/Break_Symbols}');
    Expect(1, 47, '\p{Is_Line_Break=breaksymbols}', "");
    Expect(0, 47, '\p{^Is_Line_Break=breaksymbols}', "");
    Expect(0, 47, '\P{Is_Line_Break=breaksymbols}', "");
    Expect(1, 47, '\P{^Is_Line_Break=breaksymbols}', "");
    Expect(0, 48, '\p{Is_Line_Break=breaksymbols}', "");
    Expect(1, 48, '\p{^Is_Line_Break=breaksymbols}', "");
    Expect(1, 48, '\P{Is_Line_Break=breaksymbols}', "");
    Expect(0, 48, '\P{^Is_Line_Break=breaksymbols}', "");
    Expect(1, 47, '\p{Is_Line_Break= -break_Symbols}', "");
    Expect(0, 47, '\p{^Is_Line_Break= -break_Symbols}', "");
    Expect(0, 47, '\P{Is_Line_Break= -break_Symbols}', "");
    Expect(1, 47, '\P{^Is_Line_Break= -break_Symbols}', "");
    Expect(0, 48, '\p{Is_Line_Break= -break_Symbols}', "");
    Expect(1, 48, '\p{^Is_Line_Break= -break_Symbols}', "");
    Expect(1, 48, '\P{Is_Line_Break= -break_Symbols}', "");
    Expect(0, 48, '\P{^Is_Line_Break= -break_Symbols}', "");
    Error('\p{Is_Lb=:=-_SY}');
    Error('\P{Is_Lb=:=-_SY}');
    Expect(1, 47, '\p{Is_Lb=sy}', "");
    Expect(0, 47, '\p{^Is_Lb=sy}', "");
    Expect(0, 47, '\P{Is_Lb=sy}', "");
    Expect(1, 47, '\P{^Is_Lb=sy}', "");
    Expect(0, 48, '\p{Is_Lb=sy}', "");
    Expect(1, 48, '\p{^Is_Lb=sy}', "");
    Expect(1, 48, '\P{Is_Lb=sy}', "");
    Expect(0, 48, '\P{^Is_Lb=sy}', "");
    Expect(1, 47, '\p{Is_Lb:-sy}', "");
    Expect(0, 47, '\p{^Is_Lb:-sy}', "");
    Expect(0, 47, '\P{Is_Lb:-sy}', "");
    Expect(1, 47, '\P{^Is_Lb:-sy}', "");
    Expect(0, 48, '\p{Is_Lb:-sy}', "");
    Expect(1, 48, '\p{^Is_Lb:-sy}', "");
    Expect(1, 48, '\P{Is_Lb:-sy}', "");
    Expect(0, 48, '\P{^Is_Lb:-sy}', "");
    Error('\p{Line_Break=-_Word_JOINER:=}');
    Error('\P{Line_Break=-_Word_JOINER:=}');
    Expect(1, 65279, '\p{Line_Break=wordjoiner}', "");
    Expect(0, 65279, '\p{^Line_Break=wordjoiner}', "");
    Expect(0, 65279, '\P{Line_Break=wordjoiner}', "");
    Expect(1, 65279, '\P{^Line_Break=wordjoiner}', "");
    Expect(0, 65280, '\p{Line_Break=wordjoiner}', "");
    Expect(1, 65280, '\p{^Line_Break=wordjoiner}', "");
    Expect(1, 65280, '\P{Line_Break=wordjoiner}', "");
    Expect(0, 65280, '\P{^Line_Break=wordjoiner}', "");
    Expect(1, 65279, '\p{Line_Break=	 WORD_joiner}', "");
    Expect(0, 65279, '\p{^Line_Break=	 WORD_joiner}', "");
    Expect(0, 65279, '\P{Line_Break=	 WORD_joiner}', "");
    Expect(1, 65279, '\P{^Line_Break=	 WORD_joiner}', "");
    Expect(0, 65280, '\p{Line_Break=	 WORD_joiner}', "");
    Expect(1, 65280, '\p{^Line_Break=	 WORD_joiner}', "");
    Expect(1, 65280, '\P{Line_Break=	 WORD_joiner}', "");
    Expect(0, 65280, '\P{^Line_Break=	 WORD_joiner}', "");
    Error('\p{Lb:  -WJ/a/}');
    Error('\P{Lb:  -WJ/a/}');
    Expect(1, 65279, '\p{Lb=wj}', "");
    Expect(0, 65279, '\p{^Lb=wj}', "");
    Expect(0, 65279, '\P{Lb=wj}', "");
    Expect(1, 65279, '\P{^Lb=wj}', "");
    Expect(0, 65280, '\p{Lb=wj}', "");
    Expect(1, 65280, '\p{^Lb=wj}', "");
    Expect(1, 65280, '\P{Lb=wj}', "");
    Expect(0, 65280, '\P{^Lb=wj}', "");
    Expect(1, 65279, '\p{Lb=	 wj}', "");
    Expect(0, 65279, '\p{^Lb=	 wj}', "");
    Expect(0, 65279, '\P{Lb=	 wj}', "");
    Expect(1, 65279, '\P{^Lb=	 wj}', "");
    Expect(0, 65280, '\p{Lb=	 wj}', "");
    Expect(1, 65280, '\p{^Lb=	 wj}', "");
    Expect(1, 65280, '\P{Lb=	 wj}', "");
    Expect(0, 65280, '\P{^Lb=	 wj}', "");
    Error('\p{Is_Line_Break=/a/-_WORD_Joiner}');
    Error('\P{Is_Line_Break=/a/-_WORD_Joiner}');
    Expect(1, 65279, '\p{Is_Line_Break=wordjoiner}', "");
    Expect(0, 65279, '\p{^Is_Line_Break=wordjoiner}', "");
    Expect(0, 65279, '\P{Is_Line_Break=wordjoiner}', "");
    Expect(1, 65279, '\P{^Is_Line_Break=wordjoiner}', "");
    Expect(0, 65280, '\p{Is_Line_Break=wordjoiner}', "");
    Expect(1, 65280, '\p{^Is_Line_Break=wordjoiner}', "");
    Expect(1, 65280, '\P{Is_Line_Break=wordjoiner}', "");
    Expect(0, 65280, '\P{^Is_Line_Break=wordjoiner}', "");
    Expect(1, 65279, '\p{Is_Line_Break=--Word_joiner}', "");
    Expect(0, 65279, '\p{^Is_Line_Break=--Word_joiner}', "");
    Expect(0, 65279, '\P{Is_Line_Break=--Word_joiner}', "");
    Expect(1, 65279, '\P{^Is_Line_Break=--Word_joiner}', "");
    Expect(0, 65280, '\p{Is_Line_Break=--Word_joiner}', "");
    Expect(1, 65280, '\p{^Is_Line_Break=--Word_joiner}', "");
    Expect(1, 65280, '\P{Is_Line_Break=--Word_joiner}', "");
    Expect(0, 65280, '\P{^Is_Line_Break=--Word_joiner}', "");
    Error('\p{Is_Lb= -WJ:=}');
    Error('\P{Is_Lb= -WJ:=}');
    Expect(1, 65279, '\p{Is_Lb=wj}', "");
    Expect(0, 65279, '\p{^Is_Lb=wj}', "");
    Expect(0, 65279, '\P{Is_Lb=wj}', "");
    Expect(1, 65279, '\P{^Is_Lb=wj}', "");
    Expect(0, 65280, '\p{Is_Lb=wj}', "");
    Expect(1, 65280, '\p{^Is_Lb=wj}', "");
    Expect(1, 65280, '\P{Is_Lb=wj}', "");
    Expect(0, 65280, '\P{^Is_Lb=wj}', "");
    Expect(1, 65279, '\p{Is_Lb:-_wj}', "");
    Expect(0, 65279, '\p{^Is_Lb:-_wj}', "");
    Expect(0, 65279, '\P{Is_Lb:-_wj}', "");
    Expect(1, 65279, '\P{^Is_Lb:-_wj}', "");
    Expect(0, 65280, '\p{Is_Lb:-_wj}', "");
    Expect(1, 65280, '\p{^Is_Lb:-_wj}', "");
    Expect(1, 65280, '\P{Is_Lb:-_wj}', "");
    Expect(0, 65280, '\P{^Is_Lb:-_wj}', "");
    Error('\p{Line_Break=/a/-UNKNOWN}');
    Error('\P{Line_Break=/a/-UNKNOWN}');
    Expect(1, 918000, '\p{Line_Break=unknown}', "");
    Expect(0, 918000, '\p{^Line_Break=unknown}', "");
    Expect(0, 918000, '\P{Line_Break=unknown}', "");
    Expect(1, 918000, '\P{^Line_Break=unknown}', "");
    Expect(0, 917999, '\p{Line_Break=unknown}', "");
    Expect(1, 917999, '\p{^Line_Break=unknown}', "");
    Expect(1, 917999, '\P{Line_Break=unknown}', "");
    Expect(0, 917999, '\P{^Line_Break=unknown}', "");
    Expect(1, 918000, '\p{Line_Break=	 Unknown}', "");
    Expect(0, 918000, '\p{^Line_Break=	 Unknown}', "");
    Expect(0, 918000, '\P{Line_Break=	 Unknown}', "");
    Expect(1, 918000, '\P{^Line_Break=	 Unknown}', "");
    Expect(0, 917999, '\p{Line_Break=	 Unknown}', "");
    Expect(1, 917999, '\p{^Line_Break=	 Unknown}', "");
    Expect(1, 917999, '\P{Line_Break=	 Unknown}', "");
    Expect(0, 917999, '\P{^Line_Break=	 Unknown}', "");
    Error('\p{Lb=	XX/a/}');
    Error('\P{Lb=	XX/a/}');
    Expect(1, 918000, '\p{Lb=xx}', "");
    Expect(0, 918000, '\p{^Lb=xx}', "");
    Expect(0, 918000, '\P{Lb=xx}', "");
    Expect(1, 918000, '\P{^Lb=xx}', "");
    Expect(0, 917999, '\p{Lb=xx}', "");
    Expect(1, 917999, '\p{^Lb=xx}', "");
    Expect(1, 917999, '\P{Lb=xx}', "");
    Expect(0, 917999, '\P{^Lb=xx}', "");
    Expect(1, 918000, '\p{Lb:  XX}', "");
    Expect(0, 918000, '\p{^Lb:  XX}', "");
    Expect(0, 918000, '\P{Lb:  XX}', "");
    Expect(1, 918000, '\P{^Lb:  XX}', "");
    Expect(0, 917999, '\p{Lb:  XX}', "");
    Expect(1, 917999, '\p{^Lb:  XX}', "");
    Expect(1, 917999, '\P{Lb:  XX}', "");
    Expect(0, 917999, '\P{^Lb:  XX}', "");
    Error('\p{Is_Line_Break=/a/- unknown}');
    Error('\P{Is_Line_Break=/a/- unknown}');
    Expect(1, 918000, '\p{Is_Line_Break=unknown}', "");
    Expect(0, 918000, '\p{^Is_Line_Break=unknown}', "");
    Expect(0, 918000, '\P{Is_Line_Break=unknown}', "");
    Expect(1, 918000, '\P{^Is_Line_Break=unknown}', "");
    Expect(0, 917999, '\p{Is_Line_Break=unknown}', "");
    Expect(1, 917999, '\p{^Is_Line_Break=unknown}', "");
    Expect(1, 917999, '\P{Is_Line_Break=unknown}', "");
    Expect(0, 917999, '\P{^Is_Line_Break=unknown}', "");
    Expect(1, 918000, '\p{Is_Line_Break=	_UNKNOWN}', "");
    Expect(0, 918000, '\p{^Is_Line_Break=	_UNKNOWN}', "");
    Expect(0, 918000, '\P{Is_Line_Break=	_UNKNOWN}', "");
    Expect(1, 918000, '\P{^Is_Line_Break=	_UNKNOWN}', "");
    Expect(0, 917999, '\p{Is_Line_Break=	_UNKNOWN}', "");
    Expect(1, 917999, '\p{^Is_Line_Break=	_UNKNOWN}', "");
    Expect(1, 917999, '\P{Is_Line_Break=	_UNKNOWN}', "");
    Expect(0, 917999, '\P{^Is_Line_Break=	_UNKNOWN}', "");
    Error('\p{Is_Lb=/a/  XX}');
    Error('\P{Is_Lb=/a/  XX}');
    Expect(1, 918000, '\p{Is_Lb=xx}', "");
    Expect(0, 918000, '\p{^Is_Lb=xx}', "");
    Expect(0, 918000, '\P{Is_Lb=xx}', "");
    Expect(1, 918000, '\P{^Is_Lb=xx}', "");
    Expect(0, 917999, '\p{Is_Lb=xx}', "");
    Expect(1, 917999, '\p{^Is_Lb=xx}', "");
    Expect(1, 917999, '\P{Is_Lb=xx}', "");
    Expect(0, 917999, '\P{^Is_Lb=xx}', "");
    Expect(1, 918000, '\p{Is_Lb=	-XX}', "");
    Expect(0, 918000, '\p{^Is_Lb=	-XX}', "");
    Expect(0, 918000, '\P{Is_Lb=	-XX}', "");
    Expect(1, 918000, '\P{^Is_Lb=	-XX}', "");
    Expect(0, 917999, '\p{Is_Lb=	-XX}', "");
    Expect(1, 917999, '\p{^Is_Lb=	-XX}', "");
    Expect(1, 917999, '\P{Is_Lb=	-XX}', "");
    Expect(0, 917999, '\P{^Is_Lb=	-XX}', "");
    Error('\p{Line_Break=/a/_-ZWSPACE}');
    Error('\P{Line_Break=/a/_-ZWSPACE}');
    Expect(1, 8203, '\p{Line_Break=zwspace}', "");
    Expect(0, 8203, '\p{^Line_Break=zwspace}', "");
    Expect(0, 8203, '\P{Line_Break=zwspace}', "");
    Expect(1, 8203, '\P{^Line_Break=zwspace}', "");
    Expect(0, 8204, '\p{Line_Break=zwspace}', "");
    Expect(1, 8204, '\p{^Line_Break=zwspace}', "");
    Expect(1, 8204, '\P{Line_Break=zwspace}', "");
    Expect(0, 8204, '\P{^Line_Break=zwspace}', "");
    Expect(1, 8203, '\p{Line_Break=_zwspace}', "");
    Expect(0, 8203, '\p{^Line_Break=_zwspace}', "");
    Expect(0, 8203, '\P{Line_Break=_zwspace}', "");
    Expect(1, 8203, '\P{^Line_Break=_zwspace}', "");
    Expect(0, 8204, '\p{Line_Break=_zwspace}', "");
    Expect(1, 8204, '\p{^Line_Break=_zwspace}', "");
    Expect(1, 8204, '\P{Line_Break=_zwspace}', "");
    Expect(0, 8204, '\P{^Line_Break=_zwspace}', "");
    Error('\p{Lb=:= 	zw}');
    Error('\P{Lb=:= 	zw}');
    Expect(1, 8203, '\p{Lb=zw}', "");
    Expect(0, 8203, '\p{^Lb=zw}', "");
    Expect(0, 8203, '\P{Lb=zw}', "");
    Expect(1, 8203, '\P{^Lb=zw}', "");
    Expect(0, 8204, '\p{Lb=zw}', "");
    Expect(1, 8204, '\p{^Lb=zw}', "");
    Expect(1, 8204, '\P{Lb=zw}', "");
    Expect(0, 8204, '\P{^Lb=zw}', "");
    Expect(1, 8203, '\p{Lb=_ZW}', "");
    Expect(0, 8203, '\p{^Lb=_ZW}', "");
    Expect(0, 8203, '\P{Lb=_ZW}', "");
    Expect(1, 8203, '\P{^Lb=_ZW}', "");
    Expect(0, 8204, '\p{Lb=_ZW}', "");
    Expect(1, 8204, '\p{^Lb=_ZW}', "");
    Expect(1, 8204, '\P{Lb=_ZW}', "");
    Expect(0, 8204, '\P{^Lb=_ZW}', "");
    Error('\p{Is_Line_Break=	:=ZWSPACE}');
    Error('\P{Is_Line_Break=	:=ZWSPACE}');
    Expect(1, 8203, '\p{Is_Line_Break=zwspace}', "");
    Expect(0, 8203, '\p{^Is_Line_Break=zwspace}', "");
    Expect(0, 8203, '\P{Is_Line_Break=zwspace}', "");
    Expect(1, 8203, '\P{^Is_Line_Break=zwspace}', "");
    Expect(0, 8204, '\p{Is_Line_Break=zwspace}', "");
    Expect(1, 8204, '\p{^Is_Line_Break=zwspace}', "");
    Expect(1, 8204, '\P{Is_Line_Break=zwspace}', "");
    Expect(0, 8204, '\P{^Is_Line_Break=zwspace}', "");
    Expect(1, 8203, '\p{Is_Line_Break=- ZWSpace}', "");
    Expect(0, 8203, '\p{^Is_Line_Break=- ZWSpace}', "");
    Expect(0, 8203, '\P{Is_Line_Break=- ZWSpace}', "");
    Expect(1, 8203, '\P{^Is_Line_Break=- ZWSpace}', "");
    Expect(0, 8204, '\p{Is_Line_Break=- ZWSpace}', "");
    Expect(1, 8204, '\p{^Is_Line_Break=- ZWSpace}', "");
    Expect(1, 8204, '\P{Is_Line_Break=- ZWSpace}', "");
    Expect(0, 8204, '\P{^Is_Line_Break=- ZWSpace}', "");
    Error('\p{Is_Lb=/a/-_ZW}');
    Error('\P{Is_Lb=/a/-_ZW}');
    Expect(1, 8203, '\p{Is_Lb=zw}', "");
    Expect(0, 8203, '\p{^Is_Lb=zw}', "");
    Expect(0, 8203, '\P{Is_Lb=zw}', "");
    Expect(1, 8203, '\P{^Is_Lb=zw}', "");
    Expect(0, 8204, '\p{Is_Lb=zw}', "");
    Expect(1, 8204, '\p{^Is_Lb=zw}', "");
    Expect(1, 8204, '\P{Is_Lb=zw}', "");
    Expect(0, 8204, '\P{^Is_Lb=zw}', "");
    Expect(1, 8203, '\p{Is_Lb=_ZW}', "");
    Expect(0, 8203, '\p{^Is_Lb=_ZW}', "");
    Expect(0, 8203, '\P{Is_Lb=_ZW}', "");
    Expect(1, 8203, '\P{^Is_Lb=_ZW}', "");
    Expect(0, 8204, '\p{Is_Lb=_ZW}', "");
    Expect(1, 8204, '\p{^Is_Lb=_ZW}', "");
    Expect(1, 8204, '\P{Is_Lb=_ZW}', "");
    Expect(0, 8204, '\P{^Is_Lb=_ZW}', "");
    Error('\p{Line_Break=/a/ -zwj}');
    Error('\P{Line_Break=/a/ -zwj}');
    Expect(1, 8205, '\p{Line_Break=zwj}', "");
    Expect(0, 8205, '\p{^Line_Break=zwj}', "");
    Expect(0, 8205, '\P{Line_Break=zwj}', "");
    Expect(1, 8205, '\P{^Line_Break=zwj}', "");
    Expect(0, 8206, '\p{Line_Break=zwj}', "");
    Expect(1, 8206, '\p{^Line_Break=zwj}', "");
    Expect(1, 8206, '\P{Line_Break=zwj}', "");
    Expect(0, 8206, '\P{^Line_Break=zwj}', "");
    Expect(1, 8205, '\p{Line_Break=	-zwj}', "");
    Expect(0, 8205, '\p{^Line_Break=	-zwj}', "");
    Expect(0, 8205, '\P{Line_Break=	-zwj}', "");
    Expect(1, 8205, '\P{^Line_Break=	-zwj}', "");
    Expect(0, 8206, '\p{Line_Break=	-zwj}', "");
    Expect(1, 8206, '\p{^Line_Break=	-zwj}', "");
    Expect(1, 8206, '\P{Line_Break=	-zwj}', "");
    Expect(0, 8206, '\P{^Line_Break=	-zwj}', "");
    Error('\p{Lb= 	ZWJ:=}');
    Error('\P{Lb= 	ZWJ:=}');
    Expect(1, 8205, '\p{Lb=zwj}', "");
    Expect(0, 8205, '\p{^Lb=zwj}', "");
    Expect(0, 8205, '\P{Lb=zwj}', "");
    Expect(1, 8205, '\P{^Lb=zwj}', "");
    Expect(0, 8206, '\p{Lb=zwj}', "");
    Expect(1, 8206, '\p{^Lb=zwj}', "");
    Expect(1, 8206, '\P{Lb=zwj}', "");
    Expect(0, 8206, '\P{^Lb=zwj}', "");
    Expect(1, 8205, '\p{Lb= 	ZWJ}', "");
    Expect(0, 8205, '\p{^Lb= 	ZWJ}', "");
    Expect(0, 8205, '\P{Lb= 	ZWJ}', "");
    Expect(1, 8205, '\P{^Lb= 	ZWJ}', "");
    Expect(0, 8206, '\p{Lb= 	ZWJ}', "");
    Expect(1, 8206, '\p{^Lb= 	ZWJ}', "");
    Expect(1, 8206, '\P{Lb= 	ZWJ}', "");
    Expect(0, 8206, '\P{^Lb= 	ZWJ}', "");
    Error('\p{Is_Line_Break=/a/ ZWJ}');
    Error('\P{Is_Line_Break=/a/ ZWJ}');
    Expect(1, 8205, '\p{Is_Line_Break=zwj}', "");
    Expect(0, 8205, '\p{^Is_Line_Break=zwj}', "");
    Expect(0, 8205, '\P{Is_Line_Break=zwj}', "");
    Expect(1, 8205, '\P{^Is_Line_Break=zwj}', "");
    Expect(0, 8206, '\p{Is_Line_Break=zwj}', "");
    Expect(1, 8206, '\p{^Is_Line_Break=zwj}', "");
    Expect(1, 8206, '\P{Is_Line_Break=zwj}', "");
    Expect(0, 8206, '\P{^Is_Line_Break=zwj}', "");
    Expect(1, 8205, '\p{Is_Line_Break=_ZWJ}', "");
    Expect(0, 8205, '\p{^Is_Line_Break=_ZWJ}', "");
    Expect(0, 8205, '\P{Is_Line_Break=_ZWJ}', "");
    Expect(1, 8205, '\P{^Is_Line_Break=_ZWJ}', "");
    Expect(0, 8206, '\p{Is_Line_Break=_ZWJ}', "");
    Expect(1, 8206, '\p{^Is_Line_Break=_ZWJ}', "");
    Expect(1, 8206, '\P{Is_Line_Break=_ZWJ}', "");
    Expect(0, 8206, '\P{^Is_Line_Break=_ZWJ}', "");
    Error('\p{Is_Lb=	:=ZWJ}');
    Error('\P{Is_Lb=	:=ZWJ}');
    Expect(1, 8205, '\p{Is_Lb=zwj}', "");
    Expect(0, 8205, '\p{^Is_Lb=zwj}', "");
    Expect(0, 8205, '\P{Is_Lb=zwj}', "");
    Expect(1, 8205, '\P{^Is_Lb=zwj}', "");
    Expect(0, 8206, '\p{Is_Lb=zwj}', "");
    Expect(1, 8206, '\p{^Is_Lb=zwj}', "");
    Expect(1, 8206, '\P{Is_Lb=zwj}', "");
    Expect(0, 8206, '\P{^Is_Lb=zwj}', "");
    Expect(1, 8205, '\p{Is_Lb:  ZWJ}', "");
    Expect(0, 8205, '\p{^Is_Lb:  ZWJ}', "");
    Expect(0, 8205, '\P{Is_Lb:  ZWJ}', "");
    Expect(1, 8205, '\P{^Is_Lb:  ZWJ}', "");
    Expect(0, 8206, '\p{Is_Lb:  ZWJ}', "");
    Expect(1, 8206, '\p{^Is_Lb:  ZWJ}', "");
    Expect(1, 8206, '\P{Is_Lb:  ZWJ}', "");
    Expect(0, 8206, '\P{^Is_Lb:  ZWJ}', "");
    Error('\p{lowercasemapping}');
    Error('\P{lowercasemapping}');
    Error('\p{legacycasefolding}');
    Error('\P{legacycasefolding}');
    Error('\p{legacylowercasemapping}');
    Error('\P{legacylowercasemapping}');
    Error('\p{legacyperldecimaldigit}');
    Error('\P{legacyperldecimaldigit}');
    Error('\p{legacytitlecasemapping}');
    Error('\P{legacytitlecasemapping}');
    Error('\p{legacyuppercasemapping}');
    Error('\P{legacyuppercasemapping}');
    Error('\p{Logical_Order_Exception:	 no/a/}');
    Error('\P{Logical_Order_Exception:	 no/a/}');
    Expect(1, 43709, '\p{Logical_Order_Exception=no}', "");
    Expect(0, 43709, '\p{^Logical_Order_Exception=no}', "");
    Expect(0, 43709, '\P{Logical_Order_Exception=no}', "");
    Expect(1, 43709, '\P{^Logical_Order_Exception=no}', "");
    Expect(0, 43708, '\p{Logical_Order_Exception=no}', "");
    Expect(1, 43708, '\p{^Logical_Order_Exception=no}', "");
    Expect(1, 43708, '\P{Logical_Order_Exception=no}', "");
    Expect(0, 43708, '\P{^Logical_Order_Exception=no}', "");
    Expect(1, 43709, '\p{Logical_Order_Exception:	_no}', "");
    Expect(0, 43709, '\p{^Logical_Order_Exception:	_no}', "");
    Expect(0, 43709, '\P{Logical_Order_Exception:	_no}', "");
    Expect(1, 43709, '\P{^Logical_Order_Exception:	_no}', "");
    Expect(0, 43708, '\p{Logical_Order_Exception:	_no}', "");
    Expect(1, 43708, '\p{^Logical_Order_Exception:	_no}', "");
    Expect(1, 43708, '\P{Logical_Order_Exception:	_no}', "");
    Expect(0, 43708, '\P{^Logical_Order_Exception:	_no}', "");
    Error('\p{LOE: 	N:=}');
    Error('\P{LOE: 	N:=}');
    Expect(1, 43709, '\p{LOE=n}', "");
    Expect(0, 43709, '\p{^LOE=n}', "");
    Expect(0, 43709, '\P{LOE=n}', "");
    Expect(1, 43709, '\P{^LOE=n}', "");
    Expect(0, 43708, '\p{LOE=n}', "");
    Expect(1, 43708, '\p{^LOE=n}', "");
    Expect(1, 43708, '\P{LOE=n}', "");
    Expect(0, 43708, '\P{^LOE=n}', "");
    Expect(1, 43709, '\p{LOE= N}', "");
    Expect(0, 43709, '\p{^LOE= N}', "");
    Expect(0, 43709, '\P{LOE= N}', "");
    Expect(1, 43709, '\P{^LOE= N}', "");
    Expect(0, 43708, '\p{LOE= N}', "");
    Expect(1, 43708, '\p{^LOE= N}', "");
    Expect(1, 43708, '\P{LOE= N}', "");
    Expect(0, 43708, '\P{^LOE= N}', "");
    Error('\p{Is_Logical_Order_Exception= _F/a/}');
    Error('\P{Is_Logical_Order_Exception= _F/a/}');
    Expect(1, 43709, '\p{Is_Logical_Order_Exception=f}', "");
    Expect(0, 43709, '\p{^Is_Logical_Order_Exception=f}', "");
    Expect(0, 43709, '\P{Is_Logical_Order_Exception=f}', "");
    Expect(1, 43709, '\P{^Is_Logical_Order_Exception=f}', "");
    Expect(0, 43708, '\p{Is_Logical_Order_Exception=f}', "");
    Expect(1, 43708, '\p{^Is_Logical_Order_Exception=f}', "");
    Expect(1, 43708, '\P{Is_Logical_Order_Exception=f}', "");
    Expect(0, 43708, '\P{^Is_Logical_Order_Exception=f}', "");
    Expect(1, 43709, '\p{Is_Logical_Order_Exception=  F}', "");
    Expect(0, 43709, '\p{^Is_Logical_Order_Exception=  F}', "");
    Expect(0, 43709, '\P{Is_Logical_Order_Exception=  F}', "");
    Expect(1, 43709, '\P{^Is_Logical_Order_Exception=  F}', "");
    Expect(0, 43708, '\p{Is_Logical_Order_Exception=  F}', "");
    Expect(1, 43708, '\p{^Is_Logical_Order_Exception=  F}', "");
    Expect(1, 43708, '\P{Is_Logical_Order_Exception=  F}', "");
    Expect(0, 43708, '\P{^Is_Logical_Order_Exception=  F}', "");
    Error('\p{Is_LOE=	false/a/}');
    Error('\P{Is_LOE=	false/a/}');
    Expect(1, 43709, '\p{Is_LOE=false}', "");
    Expect(0, 43709, '\p{^Is_LOE=false}', "");
    Expect(0, 43709, '\P{Is_LOE=false}', "");
    Expect(1, 43709, '\P{^Is_LOE=false}', "");
    Expect(0, 43708, '\p{Is_LOE=false}', "");
    Expect(1, 43708, '\p{^Is_LOE=false}', "");
    Expect(1, 43708, '\P{Is_LOE=false}', "");
    Expect(0, 43708, '\P{^Is_LOE=false}', "");
    Expect(1, 43709, '\p{Is_LOE=	FALSE}', "");
    Expect(0, 43709, '\p{^Is_LOE=	FALSE}', "");
    Expect(0, 43709, '\P{Is_LOE=	FALSE}', "");
    Expect(1, 43709, '\P{^Is_LOE=	FALSE}', "");
    Expect(0, 43708, '\p{Is_LOE=	FALSE}', "");
    Expect(1, 43708, '\p{^Is_LOE=	FALSE}', "");
    Expect(1, 43708, '\P{Is_LOE=	FALSE}', "");
    Expect(0, 43708, '\P{^Is_LOE=	FALSE}', "");
    Error('\p{Logical_Order_Exception=	 Yes:=}');
    Error('\P{Logical_Order_Exception=	 Yes:=}');
    Expect(1, 43708, '\p{Logical_Order_Exception: yes}', "");
    Expect(0, 43708, '\p{^Logical_Order_Exception: yes}', "");
    Expect(0, 43708, '\P{Logical_Order_Exception: yes}', "");
    Expect(1, 43708, '\P{^Logical_Order_Exception: yes}', "");
    Expect(0, 43709, '\p{Logical_Order_Exception: yes}', "");
    Expect(1, 43709, '\p{^Logical_Order_Exception: yes}', "");
    Expect(1, 43709, '\P{Logical_Order_Exception: yes}', "");
    Expect(0, 43709, '\P{^Logical_Order_Exception: yes}', "");
    Expect(1, 43708, '\p{Logical_Order_Exception=	YES}', "");
    Expect(0, 43708, '\p{^Logical_Order_Exception=	YES}', "");
    Expect(0, 43708, '\P{Logical_Order_Exception=	YES}', "");
    Expect(1, 43708, '\P{^Logical_Order_Exception=	YES}', "");
    Expect(0, 43709, '\p{Logical_Order_Exception=	YES}', "");
    Expect(1, 43709, '\p{^Logical_Order_Exception=	YES}', "");
    Expect(1, 43709, '\P{Logical_Order_Exception=	YES}', "");
    Expect(0, 43709, '\P{^Logical_Order_Exception=	YES}', "");
    Error('\p{LOE=:=-	Y}');
    Error('\P{LOE=:=-	Y}');
    Expect(1, 43708, '\p{LOE=y}', "");
    Expect(0, 43708, '\p{^LOE=y}', "");
    Expect(0, 43708, '\P{LOE=y}', "");
    Expect(1, 43708, '\P{^LOE=y}', "");
    Expect(0, 43709, '\p{LOE=y}', "");
    Expect(1, 43709, '\p{^LOE=y}', "");
    Expect(1, 43709, '\P{LOE=y}', "");
    Expect(0, 43709, '\P{^LOE=y}', "");
    Expect(1, 43708, '\p{LOE=	 Y}', "");
    Expect(0, 43708, '\p{^LOE=	 Y}', "");
    Expect(0, 43708, '\P{LOE=	 Y}', "");
    Expect(1, 43708, '\P{^LOE=	 Y}', "");
    Expect(0, 43709, '\p{LOE=	 Y}', "");
    Expect(1, 43709, '\p{^LOE=	 Y}', "");
    Expect(1, 43709, '\P{LOE=	 Y}', "");
    Expect(0, 43709, '\P{^LOE=	 Y}', "");
    Error('\p{Is_Logical_Order_Exception=:= T}');
    Error('\P{Is_Logical_Order_Exception=:= T}');
    Expect(1, 43708, '\p{Is_Logical_Order_Exception=t}', "");
    Expect(0, 43708, '\p{^Is_Logical_Order_Exception=t}', "");
    Expect(0, 43708, '\P{Is_Logical_Order_Exception=t}', "");
    Expect(1, 43708, '\P{^Is_Logical_Order_Exception=t}', "");
    Expect(0, 43709, '\p{Is_Logical_Order_Exception=t}', "");
    Expect(1, 43709, '\p{^Is_Logical_Order_Exception=t}', "");
    Expect(1, 43709, '\P{Is_Logical_Order_Exception=t}', "");
    Expect(0, 43709, '\P{^Is_Logical_Order_Exception=t}', "");
    Expect(1, 43708, '\p{Is_Logical_Order_Exception=__T}', "");
    Expect(0, 43708, '\p{^Is_Logical_Order_Exception=__T}', "");
    Expect(0, 43708, '\P{Is_Logical_Order_Exception=__T}', "");
    Expect(1, 43708, '\P{^Is_Logical_Order_Exception=__T}', "");
    Expect(0, 43709, '\p{Is_Logical_Order_Exception=__T}', "");
    Expect(1, 43709, '\p{^Is_Logical_Order_Exception=__T}', "");
    Expect(1, 43709, '\P{Is_Logical_Order_Exception=__T}', "");
    Expect(0, 43709, '\P{^Is_Logical_Order_Exception=__T}', "");
    Error('\p{Is_LOE=:=-	TRUE}');
    Error('\P{Is_LOE=:=-	TRUE}');
    Expect(1, 43708, '\p{Is_LOE=true}', "");
    Expect(0, 43708, '\p{^Is_LOE=true}', "");
    Expect(0, 43708, '\P{Is_LOE=true}', "");
    Expect(1, 43708, '\P{^Is_LOE=true}', "");
    Expect(0, 43709, '\p{Is_LOE=true}', "");
    Expect(1, 43709, '\p{^Is_LOE=true}', "");
    Expect(1, 43709, '\P{Is_LOE=true}', "");
    Expect(0, 43709, '\P{^Is_LOE=true}', "");
    Expect(1, 43708, '\p{Is_LOE=_ True}', "");
    Expect(0, 43708, '\p{^Is_LOE=_ True}', "");
    Expect(0, 43708, '\P{Is_LOE=_ True}', "");
    Expect(1, 43708, '\P{^Is_LOE=_ True}', "");
    Expect(0, 43709, '\p{Is_LOE=_ True}', "");
    Expect(1, 43709, '\p{^Is_LOE=_ True}', "");
    Expect(1, 43709, '\P{Is_LOE=_ True}', "");
    Expect(0, 43709, '\P{^Is_LOE=_ True}', "");
    Error('\p{Lowercase= :=No}');
    Error('\P{Lowercase= :=No}');
    Expect(1, 125252, '\p{Lowercase=no}', "");
    Expect(0, 125252, '\p{^Lowercase=no}', "");
    Expect(0, 125252, '\P{Lowercase=no}', "");
    Expect(1, 125252, '\P{^Lowercase=no}', "");
    Expect(0, 125251, '\p{Lowercase=no}', "");
    Expect(1, 125251, '\p{^Lowercase=no}', "");
    Expect(1, 125251, '\P{Lowercase=no}', "");
    Expect(0, 125251, '\P{^Lowercase=no}', "");
    Expect(1, 125252, '\p{Lowercase= -No}', "");
    Expect(0, 125252, '\p{^Lowercase= -No}', "");
    Expect(0, 125252, '\P{Lowercase= -No}', "");
    Expect(1, 125252, '\P{^Lowercase= -No}', "");
    Expect(0, 125251, '\p{Lowercase= -No}', "");
    Expect(1, 125251, '\p{^Lowercase= -No}', "");
    Expect(1, 125251, '\P{Lowercase= -No}', "");
    Expect(0, 125251, '\P{^Lowercase= -No}', "");
    Error('\p{Lower:  _N/a/}');
    Error('\P{Lower:  _N/a/}');
    Expect(1, 125252, '\p{Lower=n}', "");
    Expect(0, 125252, '\p{^Lower=n}', "");
    Expect(0, 125252, '\P{Lower=n}', "");
    Expect(1, 125252, '\P{^Lower=n}', "");
    Expect(0, 125251, '\p{Lower=n}', "");
    Expect(1, 125251, '\p{^Lower=n}', "");
    Expect(1, 125251, '\P{Lower=n}', "");
    Expect(0, 125251, '\P{^Lower=n}', "");
    Expect(1, 125252, '\p{Lower:    N}', "");
    Expect(0, 125252, '\p{^Lower:    N}', "");
    Expect(0, 125252, '\P{Lower:    N}', "");
    Expect(1, 125252, '\P{^Lower:    N}', "");
    Expect(0, 125251, '\p{Lower:    N}', "");
    Expect(1, 125251, '\p{^Lower:    N}', "");
    Expect(1, 125251, '\P{Lower:    N}', "");
    Expect(0, 125251, '\P{^Lower:    N}', "");
    Error('\p{Is_Lowercase=	 F:=}');
    Error('\P{Is_Lowercase=	 F:=}');
    Expect(1, 125252, '\p{Is_Lowercase=f}', "");
    Expect(0, 125252, '\p{^Is_Lowercase=f}', "");
    Expect(0, 125252, '\P{Is_Lowercase=f}', "");
    Expect(1, 125252, '\P{^Is_Lowercase=f}', "");
    Expect(0, 125251, '\p{Is_Lowercase=f}', "");
    Expect(1, 125251, '\p{^Is_Lowercase=f}', "");
    Expect(1, 125251, '\P{Is_Lowercase=f}', "");
    Expect(0, 125251, '\P{^Is_Lowercase=f}', "");
    Expect(1, 125252, '\p{Is_Lowercase=	F}', "");
    Expect(0, 125252, '\p{^Is_Lowercase=	F}', "");
    Expect(0, 125252, '\P{Is_Lowercase=	F}', "");
    Expect(1, 125252, '\P{^Is_Lowercase=	F}', "");
    Expect(0, 125251, '\p{Is_Lowercase=	F}', "");
    Expect(1, 125251, '\p{^Is_Lowercase=	F}', "");
    Expect(1, 125251, '\P{Is_Lowercase=	F}', "");
    Expect(0, 125251, '\P{^Is_Lowercase=	F}', "");
    Error('\p{Is_Lower=_False:=}');
    Error('\P{Is_Lower=_False:=}');
    Expect(1, 125252, '\p{Is_Lower=false}', "");
    Expect(0, 125252, '\p{^Is_Lower=false}', "");
    Expect(0, 125252, '\P{Is_Lower=false}', "");
    Expect(1, 125252, '\P{^Is_Lower=false}', "");
    Expect(0, 125251, '\p{Is_Lower=false}', "");
    Expect(1, 125251, '\p{^Is_Lower=false}', "");
    Expect(1, 125251, '\P{Is_Lower=false}', "");
    Expect(0, 125251, '\P{^Is_Lower=false}', "");
    Expect(1, 125252, '\p{Is_Lower=__false}', "");
    Expect(0, 125252, '\p{^Is_Lower=__false}', "");
    Expect(0, 125252, '\P{Is_Lower=__false}', "");
    Expect(1, 125252, '\P{^Is_Lower=__false}', "");
    Expect(0, 125251, '\p{Is_Lower=__false}', "");
    Expect(1, 125251, '\p{^Is_Lower=__false}', "");
    Expect(1, 125251, '\P{Is_Lower=__false}', "");
    Expect(0, 125251, '\P{^Is_Lower=__false}', "");
    Error('\p{Lowercase=--YES:=}');
    Error('\P{Lowercase=--YES:=}');
    Expect(1, 125251, '\p{Lowercase=yes}', "");
    Expect(0, 125251, '\p{^Lowercase=yes}', "");
    Expect(0, 125251, '\P{Lowercase=yes}', "");
    Expect(1, 125251, '\P{^Lowercase=yes}', "");
    Expect(0, 125252, '\p{Lowercase=yes}', "");
    Expect(1, 125252, '\p{^Lowercase=yes}', "");
    Expect(1, 125252, '\P{Lowercase=yes}', "");
    Expect(0, 125252, '\P{^Lowercase=yes}', "");
    Expect(1, 125251, '\p{Lowercase=	Yes}', "");
    Expect(0, 125251, '\p{^Lowercase=	Yes}', "");
    Expect(0, 125251, '\P{Lowercase=	Yes}', "");
    Expect(1, 125251, '\P{^Lowercase=	Yes}', "");
    Expect(0, 125252, '\p{Lowercase=	Yes}', "");
    Expect(1, 125252, '\p{^Lowercase=	Yes}', "");
    Expect(1, 125252, '\P{Lowercase=	Yes}', "");
    Expect(0, 125252, '\P{^Lowercase=	Yes}', "");
    Error('\p{Lower=/a/  Y}');
    Error('\P{Lower=/a/  Y}');
    Expect(1, 125251, '\p{Lower=y}', "");
    Expect(0, 125251, '\p{^Lower=y}', "");
    Expect(0, 125251, '\P{Lower=y}', "");
    Expect(1, 125251, '\P{^Lower=y}', "");
    Expect(0, 125252, '\p{Lower=y}', "");
    Expect(1, 125252, '\p{^Lower=y}', "");
    Expect(1, 125252, '\P{Lower=y}', "");
    Expect(0, 125252, '\P{^Lower=y}', "");
    Expect(1, 125251, '\p{Lower=__Y}', "");
    Expect(0, 125251, '\p{^Lower=__Y}', "");
    Expect(0, 125251, '\P{Lower=__Y}', "");
    Expect(1, 125251, '\P{^Lower=__Y}', "");
    Expect(0, 125252, '\p{Lower=__Y}', "");
    Expect(1, 125252, '\p{^Lower=__Y}', "");
    Expect(1, 125252, '\P{Lower=__Y}', "");
    Expect(0, 125252, '\P{^Lower=__Y}', "");
    Error('\p{Is_Lowercase=:=_ T}');
    Error('\P{Is_Lowercase=:=_ T}');
    Expect(1, 125251, '\p{Is_Lowercase=t}', "");
    Expect(0, 125251, '\p{^Is_Lowercase=t}', "");
    Expect(0, 125251, '\P{Is_Lowercase=t}', "");
    Expect(1, 125251, '\P{^Is_Lowercase=t}', "");
    Expect(0, 125252, '\p{Is_Lowercase=t}', "");
    Expect(1, 125252, '\p{^Is_Lowercase=t}', "");
    Expect(1, 125252, '\P{Is_Lowercase=t}', "");
    Expect(0, 125252, '\P{^Is_Lowercase=t}', "");
    Expect(1, 125251, '\p{Is_Lowercase=	-T}', "");
    Expect(0, 125251, '\p{^Is_Lowercase=	-T}', "");
    Expect(0, 125251, '\P{Is_Lowercase=	-T}', "");
    Expect(1, 125251, '\P{^Is_Lowercase=	-T}', "");
    Expect(0, 125252, '\p{Is_Lowercase=	-T}', "");
    Expect(1, 125252, '\p{^Is_Lowercase=	-T}', "");
    Expect(1, 125252, '\P{Is_Lowercase=	-T}', "");
    Expect(0, 125252, '\P{^Is_Lowercase=	-T}', "");
    Error('\p{Is_Lower=/a/	True}');
    Error('\P{Is_Lower=/a/	True}');
    Expect(1, 125251, '\p{Is_Lower=true}', "");
    Expect(0, 125251, '\p{^Is_Lower=true}', "");
    Expect(0, 125251, '\P{Is_Lower=true}', "");
    Expect(1, 125251, '\P{^Is_Lower=true}', "");
    Expect(0, 125252, '\p{Is_Lower=true}', "");
    Expect(1, 125252, '\p{^Is_Lower=true}', "");
    Expect(1, 125252, '\P{Is_Lower=true}', "");
    Expect(0, 125252, '\P{^Is_Lower=true}', "");
    Expect(1, 125251, '\p{Is_Lower=- true}', "");
    Expect(0, 125251, '\p{^Is_Lower=- true}', "");
    Expect(0, 125251, '\P{Is_Lower=- true}', "");
    Expect(1, 125251, '\P{^Is_Lower=- true}', "");
    Expect(0, 125252, '\p{Is_Lower=- true}', "");
    Expect(1, 125252, '\p{^Is_Lower=- true}', "");
    Expect(1, 125252, '\P{Is_Lower=- true}', "");
    Expect(0, 125252, '\P{^Is_Lower=- true}', "");
    Error('\p{Math=--No:=}');
    Error('\P{Math=--No:=}');
    Expect(1, 126706, '\p{Math=no}', "");
    Expect(0, 126706, '\p{^Math=no}', "");
    Expect(0, 126706, '\P{Math=no}', "");
    Expect(1, 126706, '\P{^Math=no}', "");
    Expect(0, 126705, '\p{Math=no}', "");
    Expect(1, 126705, '\p{^Math=no}', "");
    Expect(1, 126705, '\P{Math=no}', "");
    Expect(0, 126705, '\P{^Math=no}', "");
    Expect(1, 126706, '\p{Math=	 NO}', "");
    Expect(0, 126706, '\p{^Math=	 NO}', "");
    Expect(0, 126706, '\P{Math=	 NO}', "");
    Expect(1, 126706, '\P{^Math=	 NO}', "");
    Expect(0, 126705, '\p{Math=	 NO}', "");
    Expect(1, 126705, '\p{^Math=	 NO}', "");
    Expect(1, 126705, '\P{Math=	 NO}', "");
    Expect(0, 126705, '\P{^Math=	 NO}', "");
    Error('\p{Is_Math=/a/_	N}');
    Error('\P{Is_Math=/a/_	N}');
    Expect(1, 126706, '\p{Is_Math=n}', "");
    Expect(0, 126706, '\p{^Is_Math=n}', "");
    Expect(0, 126706, '\P{Is_Math=n}', "");
    Expect(1, 126706, '\P{^Is_Math=n}', "");
    Expect(0, 126705, '\p{Is_Math=n}', "");
    Expect(1, 126705, '\p{^Is_Math=n}', "");
    Expect(1, 126705, '\P{Is_Math=n}', "");
    Expect(0, 126705, '\P{^Is_Math=n}', "");
    Expect(1, 126706, '\p{Is_Math=_N}', "");
    Expect(0, 126706, '\p{^Is_Math=_N}', "");
    Expect(0, 126706, '\P{Is_Math=_N}', "");
    Expect(1, 126706, '\P{^Is_Math=_N}', "");
    Expect(0, 126705, '\p{Is_Math=_N}', "");
    Expect(1, 126705, '\p{^Is_Math=_N}', "");
    Expect(1, 126705, '\P{Is_Math=_N}', "");
    Expect(0, 126705, '\P{^Is_Math=_N}', "");
    Error('\p{Math=__F/a/}');
    Error('\P{Math=__F/a/}');
    Expect(1, 126706, '\p{Math=f}', "");
    Expect(0, 126706, '\p{^Math=f}', "");
    Expect(0, 126706, '\P{Math=f}', "");
    Expect(1, 126706, '\P{^Math=f}', "");
    Expect(0, 126705, '\p{Math=f}', "");
    Expect(1, 126705, '\p{^Math=f}', "");
    Expect(1, 126705, '\P{Math=f}', "");
    Expect(0, 126705, '\P{^Math=f}', "");
    Expect(1, 126706, '\p{Math=	F}', "");
    Expect(0, 126706, '\p{^Math=	F}', "");
    Expect(0, 126706, '\P{Math=	F}', "");
    Expect(1, 126706, '\P{^Math=	F}', "");
    Expect(0, 126705, '\p{Math=	F}', "");
    Expect(1, 126705, '\p{^Math=	F}', "");
    Expect(1, 126705, '\P{Math=	F}', "");
    Expect(0, 126705, '\P{^Math=	F}', "");
    Error('\p{Is_Math=	/a/FALSE}');
    Error('\P{Is_Math=	/a/FALSE}');
    Expect(1, 126706, '\p{Is_Math=false}', "");
    Expect(0, 126706, '\p{^Is_Math=false}', "");
    Expect(0, 126706, '\P{Is_Math=false}', "");
    Expect(1, 126706, '\P{^Is_Math=false}', "");
    Expect(0, 126705, '\p{Is_Math=false}', "");
    Expect(1, 126705, '\p{^Is_Math=false}', "");
    Expect(1, 126705, '\P{Is_Math=false}', "");
    Expect(0, 126705, '\P{^Is_Math=false}', "");
    Expect(1, 126706, '\p{Is_Math= False}', "");
    Expect(0, 126706, '\p{^Is_Math= False}', "");
    Expect(0, 126706, '\P{Is_Math= False}', "");
    Expect(1, 126706, '\P{^Is_Math= False}', "");
    Expect(0, 126705, '\p{Is_Math= False}', "");
    Expect(1, 126705, '\p{^Is_Math= False}', "");
    Expect(1, 126705, '\P{Is_Math= False}', "");
    Expect(0, 126705, '\P{^Is_Math= False}', "");
    Error('\p{Math: --yes/a/}');
    Error('\P{Math: --yes/a/}');
    Expect(1, 126705, '\p{Math=yes}', "");
    Expect(0, 126705, '\p{^Math=yes}', "");
    Expect(0, 126705, '\P{Math=yes}', "");
    Expect(1, 126705, '\P{^Math=yes}', "");
    Expect(0, 126706, '\p{Math=yes}', "");
    Expect(1, 126706, '\p{^Math=yes}', "");
    Expect(1, 126706, '\P{Math=yes}', "");
    Expect(0, 126706, '\P{^Math=yes}', "");
    Expect(1, 126705, '\p{Math=- YES}', "");
    Expect(0, 126705, '\p{^Math=- YES}', "");
    Expect(0, 126705, '\P{Math=- YES}', "");
    Expect(1, 126705, '\P{^Math=- YES}', "");
    Expect(0, 126706, '\p{Math=- YES}', "");
    Expect(1, 126706, '\p{^Math=- YES}', "");
    Expect(1, 126706, '\P{Math=- YES}', "");
    Expect(0, 126706, '\P{^Math=- YES}', "");
    Error('\p{Is_Math=/a/	_y}');
    Error('\P{Is_Math=/a/	_y}');
    Expect(1, 126705, '\p{Is_Math=y}', "");
    Expect(0, 126705, '\p{^Is_Math=y}', "");
    Expect(0, 126705, '\P{Is_Math=y}', "");
    Expect(1, 126705, '\P{^Is_Math=y}', "");
    Expect(0, 126706, '\p{Is_Math=y}', "");
    Expect(1, 126706, '\p{^Is_Math=y}', "");
    Expect(1, 126706, '\P{Is_Math=y}', "");
    Expect(0, 126706, '\P{^Is_Math=y}', "");
    Expect(1, 126705, '\p{Is_Math=	Y}', "");
    Expect(0, 126705, '\p{^Is_Math=	Y}', "");
    Expect(0, 126705, '\P{Is_Math=	Y}', "");
    Expect(1, 126705, '\P{^Is_Math=	Y}', "");
    Expect(0, 126706, '\p{Is_Math=	Y}', "");
    Expect(1, 126706, '\p{^Is_Math=	Y}', "");
    Expect(1, 126706, '\P{Is_Math=	Y}', "");
    Expect(0, 126706, '\P{^Is_Math=	Y}', "");
    Error('\p{Math=/a/-t}');
    Error('\P{Math=/a/-t}');
    Expect(1, 126705, '\p{Math=t}', "");
    Expect(0, 126705, '\p{^Math=t}', "");
    Expect(0, 126705, '\P{Math=t}', "");
    Expect(1, 126705, '\P{^Math=t}', "");
    Expect(0, 126706, '\p{Math=t}', "");
    Expect(1, 126706, '\p{^Math=t}', "");
    Expect(1, 126706, '\P{Math=t}', "");
    Expect(0, 126706, '\P{^Math=t}', "");
    Expect(1, 126705, '\p{Math=	T}', "");
    Expect(0, 126705, '\p{^Math=	T}', "");
    Expect(0, 126705, '\P{Math=	T}', "");
    Expect(1, 126705, '\P{^Math=	T}', "");
    Expect(0, 126706, '\p{Math=	T}', "");
    Expect(1, 126706, '\p{^Math=	T}', "");
    Expect(1, 126706, '\P{Math=	T}', "");
    Expect(0, 126706, '\P{^Math=	T}', "");
    Error('\p{Is_Math=/a/ TRUE}');
    Error('\P{Is_Math=/a/ TRUE}');
    Expect(1, 126705, '\p{Is_Math:true}', "");
    Expect(0, 126705, '\p{^Is_Math:true}', "");
    Expect(0, 126705, '\P{Is_Math:true}', "");
    Expect(1, 126705, '\P{^Is_Math:true}', "");
    Expect(0, 126706, '\p{Is_Math:true}', "");
    Expect(1, 126706, '\p{^Is_Math:true}', "");
    Expect(1, 126706, '\P{Is_Math:true}', "");
    Expect(0, 126706, '\P{^Is_Math:true}', "");
    Expect(1, 126705, '\p{Is_Math=	True}', "");
    Expect(0, 126705, '\p{^Is_Math=	True}', "");
    Expect(0, 126705, '\P{Is_Math=	True}', "");
    Expect(1, 126705, '\P{^Is_Math=	True}', "");
    Expect(0, 126706, '\p{Is_Math=	True}', "");
    Expect(1, 126706, '\p{^Is_Math=	True}', "");
    Expect(1, 126706, '\P{Is_Math=	True}', "");
    Expect(0, 126706, '\P{^Is_Math=	True}', "");
    Error('\p{name}');
    Error('\P{name}');
    Error('\p{na}');
    Error('\P{na}');
    Error('\p{unicode1name}');
    Error('\P{unicode1name}');
    Error('\p{na1}');
    Error('\P{na1}');
    Error('\p{namealias}');
    Error('\P{namealias}');
    Error('\p{_perlnamealias}');
    Error('\P{_perlnamealias}');
    Error('\p{Noncharacter_Code_Point=_:=NO}');
    Error('\P{Noncharacter_Code_Point=_:=NO}');
    Expect(1, 1114109, '\p{Noncharacter_Code_Point:   no}', "");
    Expect(0, 1114109, '\p{^Noncharacter_Code_Point:   no}', "");
    Expect(0, 1114109, '\P{Noncharacter_Code_Point:   no}', "");
    Expect(1, 1114109, '\P{^Noncharacter_Code_Point:   no}', "");
    Expect(0, 1114111, '\p{Noncharacter_Code_Point:   no}', "");
    Expect(1, 1114111, '\p{^Noncharacter_Code_Point:   no}', "");
    Expect(1, 1114111, '\P{Noncharacter_Code_Point:   no}', "");
    Expect(0, 1114111, '\P{^Noncharacter_Code_Point:   no}', "");
    Expect(1, 1114109, '\p{Noncharacter_Code_Point=_No}', "");
    Expect(0, 1114109, '\p{^Noncharacter_Code_Point=_No}', "");
    Expect(0, 1114109, '\P{Noncharacter_Code_Point=_No}', "");
    Expect(1, 1114109, '\P{^Noncharacter_Code_Point=_No}', "");
    Expect(0, 1114111, '\p{Noncharacter_Code_Point=_No}', "");
    Expect(1, 1114111, '\p{^Noncharacter_Code_Point=_No}', "");
    Expect(1, 1114111, '\P{Noncharacter_Code_Point=_No}', "");
    Expect(0, 1114111, '\P{^Noncharacter_Code_Point=_No}', "");
    Error('\p{NChar=/a/ N}');
    Error('\P{NChar=/a/ N}');
    Expect(1, 1114109, '\p{NChar=n}', "");
    Expect(0, 1114109, '\p{^NChar=n}', "");
    Expect(0, 1114109, '\P{NChar=n}', "");
    Expect(1, 1114109, '\P{^NChar=n}', "");
    Expect(0, 1114111, '\p{NChar=n}', "");
    Expect(1, 1114111, '\p{^NChar=n}', "");
    Expect(1, 1114111, '\P{NChar=n}', "");
    Expect(0, 1114111, '\P{^NChar=n}', "");
    Expect(1, 1114109, '\p{NChar=--N}', "");
    Expect(0, 1114109, '\p{^NChar=--N}', "");
    Expect(0, 1114109, '\P{NChar=--N}', "");
    Expect(1, 1114109, '\P{^NChar=--N}', "");
    Expect(0, 1114111, '\p{NChar=--N}', "");
    Expect(1, 1114111, '\p{^NChar=--N}', "");
    Expect(1, 1114111, '\P{NChar=--N}', "");
    Expect(0, 1114111, '\P{^NChar=--N}', "");
    Error('\p{Is_Noncharacter_Code_Point=:=_F}');
    Error('\P{Is_Noncharacter_Code_Point=:=_F}');
    Expect(1, 1114109, '\p{Is_Noncharacter_Code_Point=f}', "");
    Expect(0, 1114109, '\p{^Is_Noncharacter_Code_Point=f}', "");
    Expect(0, 1114109, '\P{Is_Noncharacter_Code_Point=f}', "");
    Expect(1, 1114109, '\P{^Is_Noncharacter_Code_Point=f}', "");
    Expect(0, 1114111, '\p{Is_Noncharacter_Code_Point=f}', "");
    Expect(1, 1114111, '\p{^Is_Noncharacter_Code_Point=f}', "");
    Expect(1, 1114111, '\P{Is_Noncharacter_Code_Point=f}', "");
    Expect(0, 1114111, '\P{^Is_Noncharacter_Code_Point=f}', "");
    Expect(1, 1114109, '\p{Is_Noncharacter_Code_Point=_F}', "");
    Expect(0, 1114109, '\p{^Is_Noncharacter_Code_Point=_F}', "");
    Expect(0, 1114109, '\P{Is_Noncharacter_Code_Point=_F}', "");
    Expect(1, 1114109, '\P{^Is_Noncharacter_Code_Point=_F}', "");
    Expect(0, 1114111, '\p{Is_Noncharacter_Code_Point=_F}', "");
    Expect(1, 1114111, '\p{^Is_Noncharacter_Code_Point=_F}', "");
    Expect(1, 1114111, '\P{Is_Noncharacter_Code_Point=_F}', "");
    Expect(0, 1114111, '\P{^Is_Noncharacter_Code_Point=_F}', "");
    Error('\p{Is_NChar=	 FALSE:=}');
    Error('\P{Is_NChar=	 FALSE:=}');
    Expect(1, 1114109, '\p{Is_NChar=false}', "");
    Expect(0, 1114109, '\p{^Is_NChar=false}', "");
    Expect(0, 1114109, '\P{Is_NChar=false}', "");
    Expect(1, 1114109, '\P{^Is_NChar=false}', "");
    Expect(0, 1114111, '\p{Is_NChar=false}', "");
    Expect(1, 1114111, '\p{^Is_NChar=false}', "");
    Expect(1, 1114111, '\P{Is_NChar=false}', "");
    Expect(0, 1114111, '\P{^Is_NChar=false}', "");
    Expect(1, 1114109, '\p{Is_NChar=_ FALSE}', "");
    Expect(0, 1114109, '\p{^Is_NChar=_ FALSE}', "");
    Expect(0, 1114109, '\P{Is_NChar=_ FALSE}', "");
    Expect(1, 1114109, '\P{^Is_NChar=_ FALSE}', "");
    Expect(0, 1114111, '\p{Is_NChar=_ FALSE}', "");
    Expect(1, 1114111, '\p{^Is_NChar=_ FALSE}', "");
    Expect(1, 1114111, '\P{Is_NChar=_ FALSE}', "");
    Expect(0, 1114111, '\P{^Is_NChar=_ FALSE}', "");
    Error('\p{Noncharacter_Code_Point=:=Yes}');
    Error('\P{Noncharacter_Code_Point=:=Yes}');
    Expect(1, 1114111, '\p{Noncharacter_Code_Point=yes}', "");
    Expect(0, 1114111, '\p{^Noncharacter_Code_Point=yes}', "");
    Expect(0, 1114111, '\P{Noncharacter_Code_Point=yes}', "");
    Expect(1, 1114111, '\P{^Noncharacter_Code_Point=yes}', "");
    Expect(0, 1114109, '\p{Noncharacter_Code_Point=yes}', "");
    Expect(1, 1114109, '\p{^Noncharacter_Code_Point=yes}', "");
    Expect(1, 1114109, '\P{Noncharacter_Code_Point=yes}', "");
    Expect(0, 1114109, '\P{^Noncharacter_Code_Point=yes}', "");
    Error('\p{NChar=/a/-Y}');
    Error('\P{NChar=/a/-Y}');
    Expect(1, 1114111, '\p{NChar=y}', "");
    Expect(0, 1114111, '\p{^NChar=y}', "");
    Expect(0, 1114111, '\P{NChar=y}', "");
    Expect(1, 1114111, '\P{^NChar=y}', "");
    Expect(0, 1114109, '\p{NChar=y}', "");
    Expect(1, 1114109, '\p{^NChar=y}', "");
    Expect(1, 1114109, '\P{NChar=y}', "");
    Expect(0, 1114109, '\P{^NChar=y}', "");
    Expect(1, 1114111, '\p{NChar= 	Y}', "");
    Expect(0, 1114111, '\p{^NChar= 	Y}', "");
    Expect(0, 1114111, '\P{NChar= 	Y}', "");
    Expect(1, 1114111, '\P{^NChar= 	Y}', "");
    Expect(0, 1114109, '\p{NChar= 	Y}', "");
    Expect(1, 1114109, '\p{^NChar= 	Y}', "");
    Expect(1, 1114109, '\P{NChar= 	Y}', "");
    Expect(0, 1114109, '\P{^NChar= 	Y}', "");
    Error('\p{Is_Noncharacter_Code_Point= /a/t}');
    Error('\P{Is_Noncharacter_Code_Point= /a/t}');
    Expect(1, 1114111, '\p{Is_Noncharacter_Code_Point=t}', "");
    Expect(0, 1114111, '\p{^Is_Noncharacter_Code_Point=t}', "");
    Expect(0, 1114111, '\P{Is_Noncharacter_Code_Point=t}', "");
    Expect(1, 1114111, '\P{^Is_Noncharacter_Code_Point=t}', "");
    Expect(0, 1114109, '\p{Is_Noncharacter_Code_Point=t}', "");
    Expect(1, 1114109, '\p{^Is_Noncharacter_Code_Point=t}', "");
    Expect(1, 1114109, '\P{Is_Noncharacter_Code_Point=t}', "");
    Expect(0, 1114109, '\P{^Is_Noncharacter_Code_Point=t}', "");
    Expect(1, 1114111, '\p{Is_Noncharacter_Code_Point=	T}', "");
    Expect(0, 1114111, '\p{^Is_Noncharacter_Code_Point=	T}', "");
    Expect(0, 1114111, '\P{Is_Noncharacter_Code_Point=	T}', "");
    Expect(1, 1114111, '\P{^Is_Noncharacter_Code_Point=	T}', "");
    Expect(0, 1114109, '\p{Is_Noncharacter_Code_Point=	T}', "");
    Expect(1, 1114109, '\p{^Is_Noncharacter_Code_Point=	T}', "");
    Expect(1, 1114109, '\P{Is_Noncharacter_Code_Point=	T}', "");
    Expect(0, 1114109, '\P{^Is_Noncharacter_Code_Point=	T}', "");
    Error('\p{Is_NChar=_:=True}');
    Error('\P{Is_NChar=_:=True}');
    Expect(1, 1114111, '\p{Is_NChar=true}', "");
    Expect(0, 1114111, '\p{^Is_NChar=true}', "");
    Expect(0, 1114111, '\P{Is_NChar=true}', "");
    Expect(1, 1114111, '\P{^Is_NChar=true}', "");
    Expect(0, 1114109, '\p{Is_NChar=true}', "");
    Expect(1, 1114109, '\p{^Is_NChar=true}', "");
    Expect(1, 1114109, '\P{Is_NChar=true}', "");
    Expect(0, 1114109, '\P{^Is_NChar=true}', "");
    Expect(1, 1114111, '\p{Is_NChar=_True}', "");
    Expect(0, 1114111, '\p{^Is_NChar=_True}', "");
    Expect(0, 1114111, '\P{Is_NChar=_True}', "");
    Expect(1, 1114111, '\P{^Is_NChar=_True}', "");
    Expect(0, 1114109, '\p{Is_NChar=_True}', "");
    Expect(1, 1114109, '\p{^Is_NChar=_True}', "");
    Expect(1, 1114109, '\P{Is_NChar=_True}', "");
    Expect(0, 1114109, '\P{^Is_NChar=_True}', "");
    Error('\p{nfcquickcheck}');
    Error('\P{nfcquickcheck}');
    Error('\p{nfcqc}');
    Error('\P{nfcqc}');
    Error('\p{NFC_Quick_Check=_:=Maybe}');
    Error('\P{NFC_Quick_Check=_:=Maybe}');
    Expect(1, 71087, '\p{NFC_Quick_Check=maybe}', "");
    Expect(0, 71087, '\p{^NFC_Quick_Check=maybe}', "");
    Expect(0, 71087, '\P{NFC_Quick_Check=maybe}', "");
    Expect(1, 71087, '\P{^NFC_Quick_Check=maybe}', "");
    Expect(0, 71088, '\p{NFC_Quick_Check=maybe}', "");
    Expect(1, 71088, '\p{^NFC_Quick_Check=maybe}', "");
    Expect(1, 71088, '\P{NFC_Quick_Check=maybe}', "");
    Expect(0, 71088, '\P{^NFC_Quick_Check=maybe}', "");
    Expect(1, 71087, '\p{NFC_Quick_Check=	MAYBE}', "");
    Expect(0, 71087, '\p{^NFC_Quick_Check=	MAYBE}', "");
    Expect(0, 71087, '\P{NFC_Quick_Check=	MAYBE}', "");
    Expect(1, 71087, '\P{^NFC_Quick_Check=	MAYBE}', "");
    Expect(0, 71088, '\p{NFC_Quick_Check=	MAYBE}', "");
    Expect(1, 71088, '\p{^NFC_Quick_Check=	MAYBE}', "");
    Expect(1, 71088, '\P{NFC_Quick_Check=	MAYBE}', "");
    Expect(0, 71088, '\P{^NFC_Quick_Check=	MAYBE}', "");
    Error('\p{NFC_QC=M:=}');
    Error('\P{NFC_QC=M:=}');
    Expect(1, 71087, '\p{NFC_QC=m}', "");
    Expect(0, 71087, '\p{^NFC_QC=m}', "");
    Expect(0, 71087, '\P{NFC_QC=m}', "");
    Expect(1, 71087, '\P{^NFC_QC=m}', "");
    Expect(0, 71088, '\p{NFC_QC=m}', "");
    Expect(1, 71088, '\p{^NFC_QC=m}', "");
    Expect(1, 71088, '\P{NFC_QC=m}', "");
    Expect(0, 71088, '\P{^NFC_QC=m}', "");
    Expect(1, 71087, '\p{NFC_QC=-M}', "");
    Expect(0, 71087, '\p{^NFC_QC=-M}', "");
    Expect(0, 71087, '\P{NFC_QC=-M}', "");
    Expect(1, 71087, '\P{^NFC_QC=-M}', "");
    Expect(0, 71088, '\p{NFC_QC=-M}', "");
    Expect(1, 71088, '\p{^NFC_QC=-M}', "");
    Expect(1, 71088, '\P{NFC_QC=-M}', "");
    Expect(0, 71088, '\P{^NFC_QC=-M}', "");
    Error('\p{Is_NFC_Quick_Check=__maybe/a/}');
    Error('\P{Is_NFC_Quick_Check=__maybe/a/}');
    Expect(1, 71087, '\p{Is_NFC_Quick_Check:   maybe}', "");
    Expect(0, 71087, '\p{^Is_NFC_Quick_Check:   maybe}', "");
    Expect(0, 71087, '\P{Is_NFC_Quick_Check:   maybe}', "");
    Expect(1, 71087, '\P{^Is_NFC_Quick_Check:   maybe}', "");
    Expect(0, 71088, '\p{Is_NFC_Quick_Check:   maybe}', "");
    Expect(1, 71088, '\p{^Is_NFC_Quick_Check:   maybe}', "");
    Expect(1, 71088, '\P{Is_NFC_Quick_Check:   maybe}', "");
    Expect(0, 71088, '\P{^Is_NFC_Quick_Check:   maybe}', "");
    Expect(1, 71087, '\p{Is_NFC_Quick_Check=__maybe}', "");
    Expect(0, 71087, '\p{^Is_NFC_Quick_Check=__maybe}', "");
    Expect(0, 71087, '\P{Is_NFC_Quick_Check=__maybe}', "");
    Expect(1, 71087, '\P{^Is_NFC_Quick_Check=__maybe}', "");
    Expect(0, 71088, '\p{Is_NFC_Quick_Check=__maybe}', "");
    Expect(1, 71088, '\p{^Is_NFC_Quick_Check=__maybe}', "");
    Expect(1, 71088, '\P{Is_NFC_Quick_Check=__maybe}', "");
    Expect(0, 71088, '\P{^Is_NFC_Quick_Check=__maybe}', "");
    Error('\p{Is_NFC_QC=-:=m}');
    Error('\P{Is_NFC_QC=-:=m}');
    Expect(1, 71087, '\p{Is_NFC_QC=m}', "");
    Expect(0, 71087, '\p{^Is_NFC_QC=m}', "");
    Expect(0, 71087, '\P{Is_NFC_QC=m}', "");
    Expect(1, 71087, '\P{^Is_NFC_QC=m}', "");
    Expect(0, 71088, '\p{Is_NFC_QC=m}', "");
    Expect(1, 71088, '\p{^Is_NFC_QC=m}', "");
    Expect(1, 71088, '\P{Is_NFC_QC=m}', "");
    Expect(0, 71088, '\P{^Is_NFC_QC=m}', "");
    Expect(1, 71087, '\p{Is_NFC_QC= 	M}', "");
    Expect(0, 71087, '\p{^Is_NFC_QC= 	M}', "");
    Expect(0, 71087, '\P{Is_NFC_QC= 	M}', "");
    Expect(1, 71087, '\P{^Is_NFC_QC= 	M}', "");
    Expect(0, 71088, '\p{Is_NFC_QC= 	M}', "");
    Expect(1, 71088, '\p{^Is_NFC_QC= 	M}', "");
    Expect(1, 71088, '\P{Is_NFC_QC= 	M}', "");
    Expect(0, 71088, '\P{^Is_NFC_QC= 	M}', "");
    Error('\p{NFC_Quick_Check=	No/a/}');
    Error('\P{NFC_Quick_Check=	No/a/}');
    Expect(1, 195101, '\p{NFC_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^NFC_Quick_Check=no}', "");
    Expect(0, 195101, '\P{NFC_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^NFC_Quick_Check=no}', "");
    Expect(0, 195102, '\p{NFC_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^NFC_Quick_Check=no}', "");
    Expect(1, 195102, '\P{NFC_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^NFC_Quick_Check=no}', "");
    Expect(1, 195101, '\p{NFC_Quick_Check= No}', "");
    Expect(0, 195101, '\p{^NFC_Quick_Check= No}', "");
    Expect(0, 195101, '\P{NFC_Quick_Check= No}', "");
    Expect(1, 195101, '\P{^NFC_Quick_Check= No}', "");
    Expect(0, 195102, '\p{NFC_Quick_Check= No}', "");
    Expect(1, 195102, '\p{^NFC_Quick_Check= No}', "");
    Expect(1, 195102, '\P{NFC_Quick_Check= No}', "");
    Expect(0, 195102, '\P{^NFC_Quick_Check= No}', "");
    Error('\p{NFC_QC=		N:=}');
    Error('\P{NFC_QC=		N:=}');
    Expect(1, 195101, '\p{NFC_QC=n}', "");
    Expect(0, 195101, '\p{^NFC_QC=n}', "");
    Expect(0, 195101, '\P{NFC_QC=n}', "");
    Expect(1, 195101, '\P{^NFC_QC=n}', "");
    Expect(0, 195102, '\p{NFC_QC=n}', "");
    Expect(1, 195102, '\p{^NFC_QC=n}', "");
    Expect(1, 195102, '\P{NFC_QC=n}', "");
    Expect(0, 195102, '\P{^NFC_QC=n}', "");
    Expect(1, 195101, '\p{NFC_QC=-N}', "");
    Expect(0, 195101, '\p{^NFC_QC=-N}', "");
    Expect(0, 195101, '\P{NFC_QC=-N}', "");
    Expect(1, 195101, '\P{^NFC_QC=-N}', "");
    Expect(0, 195102, '\p{NFC_QC=-N}', "");
    Expect(1, 195102, '\p{^NFC_QC=-N}', "");
    Expect(1, 195102, '\P{NFC_QC=-N}', "");
    Expect(0, 195102, '\P{^NFC_QC=-N}', "");
    Error('\p{Is_NFC_Quick_Check=:=-NO}');
    Error('\P{Is_NFC_Quick_Check=:=-NO}');
    Expect(1, 195101, '\p{Is_NFC_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^Is_NFC_Quick_Check=no}', "");
    Expect(0, 195101, '\P{Is_NFC_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^Is_NFC_Quick_Check=no}', "");
    Expect(0, 195102, '\p{Is_NFC_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^Is_NFC_Quick_Check=no}', "");
    Expect(1, 195102, '\P{Is_NFC_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^Is_NFC_Quick_Check=no}', "");
    Expect(1, 195101, '\p{Is_NFC_Quick_Check= -NO}', "");
    Expect(0, 195101, '\p{^Is_NFC_Quick_Check= -NO}', "");
    Expect(0, 195101, '\P{Is_NFC_Quick_Check= -NO}', "");
    Expect(1, 195101, '\P{^Is_NFC_Quick_Check= -NO}', "");
    Expect(0, 195102, '\p{Is_NFC_Quick_Check= -NO}', "");
    Expect(1, 195102, '\p{^Is_NFC_Quick_Check= -NO}', "");
    Expect(1, 195102, '\P{Is_NFC_Quick_Check= -NO}', "");
    Expect(0, 195102, '\P{^Is_NFC_Quick_Check= -NO}', "");
    Error('\p{Is_NFC_QC= /a/N}');
    Error('\P{Is_NFC_QC= /a/N}');
    Expect(1, 195101, '\p{Is_NFC_QC=n}', "");
    Expect(0, 195101, '\p{^Is_NFC_QC=n}', "");
    Expect(0, 195101, '\P{Is_NFC_QC=n}', "");
    Expect(1, 195101, '\P{^Is_NFC_QC=n}', "");
    Expect(0, 195102, '\p{Is_NFC_QC=n}', "");
    Expect(1, 195102, '\p{^Is_NFC_QC=n}', "");
    Expect(1, 195102, '\P{Is_NFC_QC=n}', "");
    Expect(0, 195102, '\P{^Is_NFC_QC=n}', "");
    Expect(1, 195101, '\p{Is_NFC_QC= N}', "");
    Expect(0, 195101, '\p{^Is_NFC_QC= N}', "");
    Expect(0, 195101, '\P{Is_NFC_QC= N}', "");
    Expect(1, 195101, '\P{^Is_NFC_QC= N}', "");
    Expect(0, 195102, '\p{Is_NFC_QC= N}', "");
    Expect(1, 195102, '\p{^Is_NFC_QC= N}', "");
    Expect(1, 195102, '\P{Is_NFC_QC= N}', "");
    Expect(0, 195102, '\P{^Is_NFC_QC= N}', "");
    Error('\p{NFC_Quick_Check=_	YES:=}');
    Error('\P{NFC_Quick_Check=_	YES:=}');
    Expect(1, 195102, '\p{NFC_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^NFC_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{NFC_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^NFC_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{NFC_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^NFC_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{NFC_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^NFC_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{NFC_Quick_Check=-Yes}', "");
    Expect(0, 195102, '\p{^NFC_Quick_Check=-Yes}', "");
    Expect(0, 195102, '\P{NFC_Quick_Check=-Yes}', "");
    Expect(1, 195102, '\P{^NFC_Quick_Check=-Yes}', "");
    Expect(0, 195101, '\p{NFC_Quick_Check=-Yes}', "");
    Expect(1, 195101, '\p{^NFC_Quick_Check=-Yes}', "");
    Expect(1, 195101, '\P{NFC_Quick_Check=-Yes}', "");
    Expect(0, 195101, '\P{^NFC_Quick_Check=-Yes}', "");
    Error('\p{NFC_QC= 	Y/a/}');
    Error('\P{NFC_QC= 	Y/a/}');
    Expect(1, 195102, '\p{NFC_QC=y}', "");
    Expect(0, 195102, '\p{^NFC_QC=y}', "");
    Expect(0, 195102, '\P{NFC_QC=y}', "");
    Expect(1, 195102, '\P{^NFC_QC=y}', "");
    Expect(0, 195101, '\p{NFC_QC=y}', "");
    Expect(1, 195101, '\p{^NFC_QC=y}', "");
    Expect(1, 195101, '\P{NFC_QC=y}', "");
    Expect(0, 195101, '\P{^NFC_QC=y}', "");
    Expect(1, 195102, '\p{NFC_QC=_	Y}', "");
    Expect(0, 195102, '\p{^NFC_QC=_	Y}', "");
    Expect(0, 195102, '\P{NFC_QC=_	Y}', "");
    Expect(1, 195102, '\P{^NFC_QC=_	Y}', "");
    Expect(0, 195101, '\p{NFC_QC=_	Y}', "");
    Expect(1, 195101, '\p{^NFC_QC=_	Y}', "");
    Expect(1, 195101, '\P{NFC_QC=_	Y}', "");
    Expect(0, 195101, '\P{^NFC_QC=_	Y}', "");
    Error('\p{Is_NFC_Quick_Check=		Yes:=}');
    Error('\P{Is_NFC_Quick_Check=		Yes:=}');
    Expect(1, 195102, '\p{Is_NFC_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^Is_NFC_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{Is_NFC_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^Is_NFC_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{Is_NFC_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^Is_NFC_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{Is_NFC_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^Is_NFC_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{Is_NFC_Quick_Check= 	yes}', "");
    Expect(0, 195102, '\p{^Is_NFC_Quick_Check= 	yes}', "");
    Expect(0, 195102, '\P{Is_NFC_Quick_Check= 	yes}', "");
    Expect(1, 195102, '\P{^Is_NFC_Quick_Check= 	yes}', "");
    Expect(0, 195101, '\p{Is_NFC_Quick_Check= 	yes}', "");
    Expect(1, 195101, '\p{^Is_NFC_Quick_Check= 	yes}', "");
    Expect(1, 195101, '\P{Is_NFC_Quick_Check= 	yes}', "");
    Expect(0, 195101, '\P{^Is_NFC_Quick_Check= 	yes}', "");
    Error('\p{Is_NFC_QC=_	Y:=}');
    Error('\P{Is_NFC_QC=_	Y:=}');
    Expect(1, 195102, '\p{Is_NFC_QC=y}', "");
    Expect(0, 195102, '\p{^Is_NFC_QC=y}', "");
    Expect(0, 195102, '\P{Is_NFC_QC=y}', "");
    Expect(1, 195102, '\P{^Is_NFC_QC=y}', "");
    Expect(0, 195101, '\p{Is_NFC_QC=y}', "");
    Expect(1, 195101, '\p{^Is_NFC_QC=y}', "");
    Expect(1, 195101, '\P{Is_NFC_QC=y}', "");
    Expect(0, 195101, '\P{^Is_NFC_QC=y}', "");
    Expect(1, 195102, '\p{Is_NFC_QC=--Y}', "");
    Expect(0, 195102, '\p{^Is_NFC_QC=--Y}', "");
    Expect(0, 195102, '\P{Is_NFC_QC=--Y}', "");
    Expect(1, 195102, '\P{^Is_NFC_QC=--Y}', "");
    Expect(0, 195101, '\p{Is_NFC_QC=--Y}', "");
    Expect(1, 195101, '\p{^Is_NFC_QC=--Y}', "");
    Expect(1, 195101, '\P{Is_NFC_QC=--Y}', "");
    Expect(0, 195101, '\P{^Is_NFC_QC=--Y}', "");
    Error('\p{nfdquickcheck}');
    Error('\P{nfdquickcheck}');
    Error('\p{nfdqc}');
    Error('\P{nfdqc}');
    Error('\p{NFD_Quick_Check=:= No}');
    Error('\P{NFD_Quick_Check=:= No}');
    Expect(1, 195101, '\p{NFD_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^NFD_Quick_Check=no}', "");
    Expect(0, 195101, '\P{NFD_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^NFD_Quick_Check=no}', "");
    Expect(0, 195102, '\p{NFD_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^NFD_Quick_Check=no}', "");
    Expect(1, 195102, '\P{NFD_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^NFD_Quick_Check=no}', "");
    Expect(1, 195101, '\p{NFD_Quick_Check=-	No}', "");
    Expect(0, 195101, '\p{^NFD_Quick_Check=-	No}', "");
    Expect(0, 195101, '\P{NFD_Quick_Check=-	No}', "");
    Expect(1, 195101, '\P{^NFD_Quick_Check=-	No}', "");
    Expect(0, 195102, '\p{NFD_Quick_Check=-	No}', "");
    Expect(1, 195102, '\p{^NFD_Quick_Check=-	No}', "");
    Expect(1, 195102, '\P{NFD_Quick_Check=-	No}', "");
    Expect(0, 195102, '\P{^NFD_Quick_Check=-	No}', "");
    Error('\p{NFD_QC:   /a/ -N}');
    Error('\P{NFD_QC:   /a/ -N}');
    Expect(1, 195101, '\p{NFD_QC=n}', "");
    Expect(0, 195101, '\p{^NFD_QC=n}', "");
    Expect(0, 195101, '\P{NFD_QC=n}', "");
    Expect(1, 195101, '\P{^NFD_QC=n}', "");
    Expect(0, 195102, '\p{NFD_QC=n}', "");
    Expect(1, 195102, '\p{^NFD_QC=n}', "");
    Expect(1, 195102, '\P{NFD_QC=n}', "");
    Expect(0, 195102, '\P{^NFD_QC=n}', "");
    Expect(1, 195101, '\p{NFD_QC: --N}', "");
    Expect(0, 195101, '\p{^NFD_QC: --N}', "");
    Expect(0, 195101, '\P{NFD_QC: --N}', "");
    Expect(1, 195101, '\P{^NFD_QC: --N}', "");
    Expect(0, 195102, '\p{NFD_QC: --N}', "");
    Expect(1, 195102, '\p{^NFD_QC: --N}', "");
    Expect(1, 195102, '\P{NFD_QC: --N}', "");
    Expect(0, 195102, '\P{^NFD_QC: --N}', "");
    Error('\p{Is_NFD_Quick_Check=--No:=}');
    Error('\P{Is_NFD_Quick_Check=--No:=}');
    Expect(1, 195101, '\p{Is_NFD_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^Is_NFD_Quick_Check=no}', "");
    Expect(0, 195101, '\P{Is_NFD_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^Is_NFD_Quick_Check=no}', "");
    Expect(0, 195102, '\p{Is_NFD_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^Is_NFD_Quick_Check=no}', "");
    Expect(1, 195102, '\P{Is_NFD_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^Is_NFD_Quick_Check=no}', "");
    Expect(1, 195101, '\p{Is_NFD_Quick_Check=-No}', "");
    Expect(0, 195101, '\p{^Is_NFD_Quick_Check=-No}', "");
    Expect(0, 195101, '\P{Is_NFD_Quick_Check=-No}', "");
    Expect(1, 195101, '\P{^Is_NFD_Quick_Check=-No}', "");
    Expect(0, 195102, '\p{Is_NFD_Quick_Check=-No}', "");
    Expect(1, 195102, '\p{^Is_NFD_Quick_Check=-No}', "");
    Expect(1, 195102, '\P{Is_NFD_Quick_Check=-No}', "");
    Expect(0, 195102, '\P{^Is_NFD_Quick_Check=-No}', "");
    Error('\p{Is_NFD_QC=	/a/n}');
    Error('\P{Is_NFD_QC=	/a/n}');
    Expect(1, 195101, '\p{Is_NFD_QC=n}', "");
    Expect(0, 195101, '\p{^Is_NFD_QC=n}', "");
    Expect(0, 195101, '\P{Is_NFD_QC=n}', "");
    Expect(1, 195101, '\P{^Is_NFD_QC=n}', "");
    Expect(0, 195102, '\p{Is_NFD_QC=n}', "");
    Expect(1, 195102, '\p{^Is_NFD_QC=n}', "");
    Expect(1, 195102, '\P{Is_NFD_QC=n}', "");
    Expect(0, 195102, '\P{^Is_NFD_QC=n}', "");
    Expect(1, 195101, '\p{Is_NFD_QC= 	N}', "");
    Expect(0, 195101, '\p{^Is_NFD_QC= 	N}', "");
    Expect(0, 195101, '\P{Is_NFD_QC= 	N}', "");
    Expect(1, 195101, '\P{^Is_NFD_QC= 	N}', "");
    Expect(0, 195102, '\p{Is_NFD_QC= 	N}', "");
    Expect(1, 195102, '\p{^Is_NFD_QC= 	N}', "");
    Expect(1, 195102, '\P{Is_NFD_QC= 	N}', "");
    Expect(0, 195102, '\P{^Is_NFD_QC= 	N}', "");
    Error('\p{NFD_Quick_Check:	_/a/yes}');
    Error('\P{NFD_Quick_Check:	_/a/yes}');
    Expect(1, 195102, '\p{NFD_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^NFD_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{NFD_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^NFD_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{NFD_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^NFD_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{NFD_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^NFD_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{NFD_Quick_Check=	Yes}', "");
    Expect(0, 195102, '\p{^NFD_Quick_Check=	Yes}', "");
    Expect(0, 195102, '\P{NFD_Quick_Check=	Yes}', "");
    Expect(1, 195102, '\P{^NFD_Quick_Check=	Yes}', "");
    Expect(0, 195101, '\p{NFD_Quick_Check=	Yes}', "");
    Expect(1, 195101, '\p{^NFD_Quick_Check=	Yes}', "");
    Expect(1, 195101, '\P{NFD_Quick_Check=	Yes}', "");
    Expect(0, 195101, '\P{^NFD_Quick_Check=	Yes}', "");
    Error('\p{NFD_QC=:=_-Y}');
    Error('\P{NFD_QC=:=_-Y}');
    Expect(1, 195102, '\p{NFD_QC=y}', "");
    Expect(0, 195102, '\p{^NFD_QC=y}', "");
    Expect(0, 195102, '\P{NFD_QC=y}', "");
    Expect(1, 195102, '\P{^NFD_QC=y}', "");
    Expect(0, 195101, '\p{NFD_QC=y}', "");
    Expect(1, 195101, '\p{^NFD_QC=y}', "");
    Expect(1, 195101, '\P{NFD_QC=y}', "");
    Expect(0, 195101, '\P{^NFD_QC=y}', "");
    Expect(1, 195102, '\p{NFD_QC=_-Y}', "");
    Expect(0, 195102, '\p{^NFD_QC=_-Y}', "");
    Expect(0, 195102, '\P{NFD_QC=_-Y}', "");
    Expect(1, 195102, '\P{^NFD_QC=_-Y}', "");
    Expect(0, 195101, '\p{NFD_QC=_-Y}', "");
    Expect(1, 195101, '\p{^NFD_QC=_-Y}', "");
    Expect(1, 195101, '\P{NFD_QC=_-Y}', "");
    Expect(0, 195101, '\P{^NFD_QC=_-Y}', "");
    Error('\p{Is_NFD_Quick_Check=-_yes:=}');
    Error('\P{Is_NFD_Quick_Check=-_yes:=}');
    Expect(1, 195102, '\p{Is_NFD_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^Is_NFD_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{Is_NFD_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^Is_NFD_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{Is_NFD_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^Is_NFD_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{Is_NFD_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^Is_NFD_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{Is_NFD_Quick_Check:--Yes}', "");
    Expect(0, 195102, '\p{^Is_NFD_Quick_Check:--Yes}', "");
    Expect(0, 195102, '\P{Is_NFD_Quick_Check:--Yes}', "");
    Expect(1, 195102, '\P{^Is_NFD_Quick_Check:--Yes}', "");
    Expect(0, 195101, '\p{Is_NFD_Quick_Check:--Yes}', "");
    Expect(1, 195101, '\p{^Is_NFD_Quick_Check:--Yes}', "");
    Expect(1, 195101, '\P{Is_NFD_Quick_Check:--Yes}', "");
    Expect(0, 195101, '\P{^Is_NFD_Quick_Check:--Yes}', "");
    Error('\p{Is_NFD_QC= 	Y:=}');
    Error('\P{Is_NFD_QC= 	Y:=}');
    Expect(1, 195102, '\p{Is_NFD_QC=y}', "");
    Expect(0, 195102, '\p{^Is_NFD_QC=y}', "");
    Expect(0, 195102, '\P{Is_NFD_QC=y}', "");
    Expect(1, 195102, '\P{^Is_NFD_QC=y}', "");
    Expect(0, 195101, '\p{Is_NFD_QC=y}', "");
    Expect(1, 195101, '\p{^Is_NFD_QC=y}', "");
    Expect(1, 195101, '\P{Is_NFD_QC=y}', "");
    Expect(0, 195101, '\P{^Is_NFD_QC=y}', "");
    Expect(1, 195102, '\p{Is_NFD_QC= _y}', "");
    Expect(0, 195102, '\p{^Is_NFD_QC= _y}', "");
    Expect(0, 195102, '\P{Is_NFD_QC= _y}', "");
    Expect(1, 195102, '\P{^Is_NFD_QC= _y}', "");
    Expect(0, 195101, '\p{Is_NFD_QC= _y}', "");
    Expect(1, 195101, '\p{^Is_NFD_QC= _y}', "");
    Expect(1, 195101, '\P{Is_NFD_QC= _y}', "");
    Expect(0, 195101, '\P{^Is_NFD_QC= _y}', "");
    Error('\p{nfkccasefold}');
    Error('\P{nfkccasefold}');
    Error('\p{nfkccf}');
    Error('\P{nfkccf}');
    Error('\p{nfkcquickcheck}');
    Error('\P{nfkcquickcheck}');
    Error('\p{nfkcqc}');
    Error('\P{nfkcqc}');
    Error('\p{NFKC_Quick_Check:	 :=Maybe}');
    Error('\P{NFKC_Quick_Check:	 :=Maybe}');
    Expect(1, 71087, '\p{NFKC_Quick_Check=maybe}', "");
    Expect(0, 71087, '\p{^NFKC_Quick_Check=maybe}', "");
    Expect(0, 71087, '\P{NFKC_Quick_Check=maybe}', "");
    Expect(1, 71087, '\P{^NFKC_Quick_Check=maybe}', "");
    Expect(0, 71088, '\p{NFKC_Quick_Check=maybe}', "");
    Expect(1, 71088, '\p{^NFKC_Quick_Check=maybe}', "");
    Expect(1, 71088, '\P{NFKC_Quick_Check=maybe}', "");
    Expect(0, 71088, '\P{^NFKC_Quick_Check=maybe}', "");
    Expect(1, 71087, '\p{NFKC_Quick_Check:_Maybe}', "");
    Expect(0, 71087, '\p{^NFKC_Quick_Check:_Maybe}', "");
    Expect(0, 71087, '\P{NFKC_Quick_Check:_Maybe}', "");
    Expect(1, 71087, '\P{^NFKC_Quick_Check:_Maybe}', "");
    Expect(0, 71088, '\p{NFKC_Quick_Check:_Maybe}', "");
    Expect(1, 71088, '\p{^NFKC_Quick_Check:_Maybe}', "");
    Expect(1, 71088, '\P{NFKC_Quick_Check:_Maybe}', "");
    Expect(0, 71088, '\P{^NFKC_Quick_Check:_Maybe}', "");
    Error('\p{NFKC_QC=_:=M}');
    Error('\P{NFKC_QC=_:=M}');
    Expect(1, 71087, '\p{NFKC_QC=m}', "");
    Expect(0, 71087, '\p{^NFKC_QC=m}', "");
    Expect(0, 71087, '\P{NFKC_QC=m}', "");
    Expect(1, 71087, '\P{^NFKC_QC=m}', "");
    Expect(0, 71088, '\p{NFKC_QC=m}', "");
    Expect(1, 71088, '\p{^NFKC_QC=m}', "");
    Expect(1, 71088, '\P{NFKC_QC=m}', "");
    Expect(0, 71088, '\P{^NFKC_QC=m}', "");
    Expect(1, 71087, '\p{NFKC_QC=	 M}', "");
    Expect(0, 71087, '\p{^NFKC_QC=	 M}', "");
    Expect(0, 71087, '\P{NFKC_QC=	 M}', "");
    Expect(1, 71087, '\P{^NFKC_QC=	 M}', "");
    Expect(0, 71088, '\p{NFKC_QC=	 M}', "");
    Expect(1, 71088, '\p{^NFKC_QC=	 M}', "");
    Expect(1, 71088, '\P{NFKC_QC=	 M}', "");
    Expect(0, 71088, '\P{^NFKC_QC=	 M}', "");
    Error('\p{Is_NFKC_Quick_Check=/a/Maybe}');
    Error('\P{Is_NFKC_Quick_Check=/a/Maybe}');
    Expect(1, 71087, '\p{Is_NFKC_Quick_Check=maybe}', "");
    Expect(0, 71087, '\p{^Is_NFKC_Quick_Check=maybe}', "");
    Expect(0, 71087, '\P{Is_NFKC_Quick_Check=maybe}', "");
    Expect(1, 71087, '\P{^Is_NFKC_Quick_Check=maybe}', "");
    Expect(0, 71088, '\p{Is_NFKC_Quick_Check=maybe}', "");
    Expect(1, 71088, '\p{^Is_NFKC_Quick_Check=maybe}', "");
    Expect(1, 71088, '\P{Is_NFKC_Quick_Check=maybe}', "");
    Expect(0, 71088, '\P{^Is_NFKC_Quick_Check=maybe}', "");
    Expect(1, 71087, '\p{Is_NFKC_Quick_Check=		maybe}', "");
    Expect(0, 71087, '\p{^Is_NFKC_Quick_Check=		maybe}', "");
    Expect(0, 71087, '\P{Is_NFKC_Quick_Check=		maybe}', "");
    Expect(1, 71087, '\P{^Is_NFKC_Quick_Check=		maybe}', "");
    Expect(0, 71088, '\p{Is_NFKC_Quick_Check=		maybe}', "");
    Expect(1, 71088, '\p{^Is_NFKC_Quick_Check=		maybe}', "");
    Expect(1, 71088, '\P{Is_NFKC_Quick_Check=		maybe}', "");
    Expect(0, 71088, '\P{^Is_NFKC_Quick_Check=		maybe}', "");
    Error('\p{Is_NFKC_QC=	-m:=}');
    Error('\P{Is_NFKC_QC=	-m:=}');
    Expect(1, 71087, '\p{Is_NFKC_QC=m}', "");
    Expect(0, 71087, '\p{^Is_NFKC_QC=m}', "");
    Expect(0, 71087, '\P{Is_NFKC_QC=m}', "");
    Expect(1, 71087, '\P{^Is_NFKC_QC=m}', "");
    Expect(0, 71088, '\p{Is_NFKC_QC=m}', "");
    Expect(1, 71088, '\p{^Is_NFKC_QC=m}', "");
    Expect(1, 71088, '\P{Is_NFKC_QC=m}', "");
    Expect(0, 71088, '\P{^Is_NFKC_QC=m}', "");
    Expect(1, 71087, '\p{Is_NFKC_QC=-M}', "");
    Expect(0, 71087, '\p{^Is_NFKC_QC=-M}', "");
    Expect(0, 71087, '\P{Is_NFKC_QC=-M}', "");
    Expect(1, 71087, '\P{^Is_NFKC_QC=-M}', "");
    Expect(0, 71088, '\p{Is_NFKC_QC=-M}', "");
    Expect(1, 71088, '\p{^Is_NFKC_QC=-M}', "");
    Expect(1, 71088, '\P{Is_NFKC_QC=-M}', "");
    Expect(0, 71088, '\P{^Is_NFKC_QC=-M}', "");
    Error('\p{NFKC_Quick_Check=	/a/NO}');
    Error('\P{NFKC_Quick_Check=	/a/NO}');
    Expect(1, 195101, '\p{NFKC_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^NFKC_Quick_Check=no}', "");
    Expect(0, 195101, '\P{NFKC_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^NFKC_Quick_Check=no}', "");
    Expect(0, 195102, '\p{NFKC_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^NFKC_Quick_Check=no}', "");
    Expect(1, 195102, '\P{NFKC_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^NFKC_Quick_Check=no}', "");
    Expect(1, 195101, '\p{NFKC_Quick_Check:    No}', "");
    Expect(0, 195101, '\p{^NFKC_Quick_Check:    No}', "");
    Expect(0, 195101, '\P{NFKC_Quick_Check:    No}', "");
    Expect(1, 195101, '\P{^NFKC_Quick_Check:    No}', "");
    Expect(0, 195102, '\p{NFKC_Quick_Check:    No}', "");
    Expect(1, 195102, '\p{^NFKC_Quick_Check:    No}', "");
    Expect(1, 195102, '\P{NFKC_Quick_Check:    No}', "");
    Expect(0, 195102, '\P{^NFKC_Quick_Check:    No}', "");
    Error('\p{NFKC_QC=/a/N}');
    Error('\P{NFKC_QC=/a/N}');
    Expect(1, 195101, '\p{NFKC_QC=n}', "");
    Expect(0, 195101, '\p{^NFKC_QC=n}', "");
    Expect(0, 195101, '\P{NFKC_QC=n}', "");
    Expect(1, 195101, '\P{^NFKC_QC=n}', "");
    Expect(0, 195102, '\p{NFKC_QC=n}', "");
    Expect(1, 195102, '\p{^NFKC_QC=n}', "");
    Expect(1, 195102, '\P{NFKC_QC=n}', "");
    Expect(0, 195102, '\P{^NFKC_QC=n}', "");
    Expect(1, 195101, '\p{NFKC_QC=  N}', "");
    Expect(0, 195101, '\p{^NFKC_QC=  N}', "");
    Expect(0, 195101, '\P{NFKC_QC=  N}', "");
    Expect(1, 195101, '\P{^NFKC_QC=  N}', "");
    Expect(0, 195102, '\p{NFKC_QC=  N}', "");
    Expect(1, 195102, '\p{^NFKC_QC=  N}', "");
    Expect(1, 195102, '\P{NFKC_QC=  N}', "");
    Expect(0, 195102, '\P{^NFKC_QC=  N}', "");
    Error('\p{Is_NFKC_Quick_Check=:=	 no}');
    Error('\P{Is_NFKC_Quick_Check=:=	 no}');
    Expect(1, 195101, '\p{Is_NFKC_Quick_Check:   no}', "");
    Expect(0, 195101, '\p{^Is_NFKC_Quick_Check:   no}', "");
    Expect(0, 195101, '\P{Is_NFKC_Quick_Check:   no}', "");
    Expect(1, 195101, '\P{^Is_NFKC_Quick_Check:   no}', "");
    Expect(0, 195102, '\p{Is_NFKC_Quick_Check:   no}', "");
    Expect(1, 195102, '\p{^Is_NFKC_Quick_Check:   no}', "");
    Expect(1, 195102, '\P{Is_NFKC_Quick_Check:   no}', "");
    Expect(0, 195102, '\P{^Is_NFKC_Quick_Check:   no}', "");
    Expect(1, 195101, '\p{Is_NFKC_Quick_Check=-No}', "");
    Expect(0, 195101, '\p{^Is_NFKC_Quick_Check=-No}', "");
    Expect(0, 195101, '\P{Is_NFKC_Quick_Check=-No}', "");
    Expect(1, 195101, '\P{^Is_NFKC_Quick_Check=-No}', "");
    Expect(0, 195102, '\p{Is_NFKC_Quick_Check=-No}', "");
    Expect(1, 195102, '\p{^Is_NFKC_Quick_Check=-No}', "");
    Expect(1, 195102, '\P{Is_NFKC_Quick_Check=-No}', "");
    Expect(0, 195102, '\P{^Is_NFKC_Quick_Check=-No}', "");
    Error('\p{Is_NFKC_QC=_/a/N}');
    Error('\P{Is_NFKC_QC=_/a/N}');
    Expect(1, 195101, '\p{Is_NFKC_QC=n}', "");
    Expect(0, 195101, '\p{^Is_NFKC_QC=n}', "");
    Expect(0, 195101, '\P{Is_NFKC_QC=n}', "");
    Expect(1, 195101, '\P{^Is_NFKC_QC=n}', "");
    Expect(0, 195102, '\p{Is_NFKC_QC=n}', "");
    Expect(1, 195102, '\p{^Is_NFKC_QC=n}', "");
    Expect(1, 195102, '\P{Is_NFKC_QC=n}', "");
    Expect(0, 195102, '\P{^Is_NFKC_QC=n}', "");
    Expect(1, 195101, '\p{Is_NFKC_QC= _n}', "");
    Expect(0, 195101, '\p{^Is_NFKC_QC= _n}', "");
    Expect(0, 195101, '\P{Is_NFKC_QC= _n}', "");
    Expect(1, 195101, '\P{^Is_NFKC_QC= _n}', "");
    Expect(0, 195102, '\p{Is_NFKC_QC= _n}', "");
    Expect(1, 195102, '\p{^Is_NFKC_QC= _n}', "");
    Expect(1, 195102, '\P{Is_NFKC_QC= _n}', "");
    Expect(0, 195102, '\P{^Is_NFKC_QC= _n}', "");
    Error('\p{NFKC_Quick_Check=:=_ Yes}');
    Error('\P{NFKC_Quick_Check=:=_ Yes}');
    Expect(1, 195102, '\p{NFKC_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^NFKC_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{NFKC_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^NFKC_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{NFKC_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^NFKC_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{NFKC_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^NFKC_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{NFKC_Quick_Check= -Yes}', "");
    Expect(0, 195102, '\p{^NFKC_Quick_Check= -Yes}', "");
    Expect(0, 195102, '\P{NFKC_Quick_Check= -Yes}', "");
    Expect(1, 195102, '\P{^NFKC_Quick_Check= -Yes}', "");
    Expect(0, 195101, '\p{NFKC_Quick_Check= -Yes}', "");
    Expect(1, 195101, '\p{^NFKC_Quick_Check= -Yes}', "");
    Expect(1, 195101, '\P{NFKC_Quick_Check= -Yes}', "");
    Expect(0, 195101, '\P{^NFKC_Quick_Check= -Yes}', "");
    Error('\p{NFKC_QC=-:=Y}');
    Error('\P{NFKC_QC=-:=Y}');
    Expect(1, 195102, '\p{NFKC_QC=y}', "");
    Expect(0, 195102, '\p{^NFKC_QC=y}', "");
    Expect(0, 195102, '\P{NFKC_QC=y}', "");
    Expect(1, 195102, '\P{^NFKC_QC=y}', "");
    Expect(0, 195101, '\p{NFKC_QC=y}', "");
    Expect(1, 195101, '\p{^NFKC_QC=y}', "");
    Expect(1, 195101, '\P{NFKC_QC=y}', "");
    Expect(0, 195101, '\P{^NFKC_QC=y}', "");
    Expect(1, 195102, '\p{NFKC_QC=-	Y}', "");
    Expect(0, 195102, '\p{^NFKC_QC=-	Y}', "");
    Expect(0, 195102, '\P{NFKC_QC=-	Y}', "");
    Expect(1, 195102, '\P{^NFKC_QC=-	Y}', "");
    Expect(0, 195101, '\p{NFKC_QC=-	Y}', "");
    Expect(1, 195101, '\p{^NFKC_QC=-	Y}', "");
    Expect(1, 195101, '\P{NFKC_QC=-	Y}', "");
    Expect(0, 195101, '\P{^NFKC_QC=-	Y}', "");
    Error('\p{Is_NFKC_Quick_Check=		yes/a/}');
    Error('\P{Is_NFKC_Quick_Check=		yes/a/}');
    Expect(1, 195102, '\p{Is_NFKC_Quick_Check: yes}', "");
    Expect(0, 195102, '\p{^Is_NFKC_Quick_Check: yes}', "");
    Expect(0, 195102, '\P{Is_NFKC_Quick_Check: yes}', "");
    Expect(1, 195102, '\P{^Is_NFKC_Quick_Check: yes}', "");
    Expect(0, 195101, '\p{Is_NFKC_Quick_Check: yes}', "");
    Expect(1, 195101, '\p{^Is_NFKC_Quick_Check: yes}', "");
    Expect(1, 195101, '\P{Is_NFKC_Quick_Check: yes}', "");
    Expect(0, 195101, '\P{^Is_NFKC_Quick_Check: yes}', "");
    Error('\p{Is_NFKC_QC=/a/ Y}');
    Error('\P{Is_NFKC_QC=/a/ Y}');
    Expect(1, 195102, '\p{Is_NFKC_QC=y}', "");
    Expect(0, 195102, '\p{^Is_NFKC_QC=y}', "");
    Expect(0, 195102, '\P{Is_NFKC_QC=y}', "");
    Expect(1, 195102, '\P{^Is_NFKC_QC=y}', "");
    Expect(0, 195101, '\p{Is_NFKC_QC=y}', "");
    Expect(1, 195101, '\p{^Is_NFKC_QC=y}', "");
    Expect(1, 195101, '\P{Is_NFKC_QC=y}', "");
    Expect(0, 195101, '\P{^Is_NFKC_QC=y}', "");
    Expect(1, 195102, '\p{Is_NFKC_QC=_-y}', "");
    Expect(0, 195102, '\p{^Is_NFKC_QC=_-y}', "");
    Expect(0, 195102, '\P{Is_NFKC_QC=_-y}', "");
    Expect(1, 195102, '\P{^Is_NFKC_QC=_-y}', "");
    Expect(0, 195101, '\p{Is_NFKC_QC=_-y}', "");
    Expect(1, 195101, '\p{^Is_NFKC_QC=_-y}', "");
    Expect(1, 195101, '\P{Is_NFKC_QC=_-y}', "");
    Expect(0, 195101, '\P{^Is_NFKC_QC=_-y}', "");
    Error('\p{nfkdquickcheck}');
    Error('\P{nfkdquickcheck}');
    Error('\p{nfkdqc}');
    Error('\P{nfkdqc}');
    Error('\p{NFKD_Quick_Check=-:=NO}');
    Error('\P{NFKD_Quick_Check=-:=NO}');
    Expect(1, 195101, '\p{NFKD_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^NFKD_Quick_Check=no}', "");
    Expect(0, 195101, '\P{NFKD_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^NFKD_Quick_Check=no}', "");
    Expect(0, 195102, '\p{NFKD_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^NFKD_Quick_Check=no}', "");
    Expect(1, 195102, '\P{NFKD_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^NFKD_Quick_Check=no}', "");
    Expect(1, 195101, '\p{NFKD_Quick_Check=_No}', "");
    Expect(0, 195101, '\p{^NFKD_Quick_Check=_No}', "");
    Expect(0, 195101, '\P{NFKD_Quick_Check=_No}', "");
    Expect(1, 195101, '\P{^NFKD_Quick_Check=_No}', "");
    Expect(0, 195102, '\p{NFKD_Quick_Check=_No}', "");
    Expect(1, 195102, '\p{^NFKD_Quick_Check=_No}', "");
    Expect(1, 195102, '\P{NFKD_Quick_Check=_No}', "");
    Expect(0, 195102, '\P{^NFKD_Quick_Check=_No}', "");
    Error('\p{NFKD_QC=-N/a/}');
    Error('\P{NFKD_QC=-N/a/}');
    Expect(1, 195101, '\p{NFKD_QC=n}', "");
    Expect(0, 195101, '\p{^NFKD_QC=n}', "");
    Expect(0, 195101, '\P{NFKD_QC=n}', "");
    Expect(1, 195101, '\P{^NFKD_QC=n}', "");
    Expect(0, 195102, '\p{NFKD_QC=n}', "");
    Expect(1, 195102, '\p{^NFKD_QC=n}', "");
    Expect(1, 195102, '\P{NFKD_QC=n}', "");
    Expect(0, 195102, '\P{^NFKD_QC=n}', "");
    Expect(1, 195101, '\p{NFKD_QC=-n}', "");
    Expect(0, 195101, '\p{^NFKD_QC=-n}', "");
    Expect(0, 195101, '\P{NFKD_QC=-n}', "");
    Expect(1, 195101, '\P{^NFKD_QC=-n}', "");
    Expect(0, 195102, '\p{NFKD_QC=-n}', "");
    Expect(1, 195102, '\p{^NFKD_QC=-n}', "");
    Expect(1, 195102, '\P{NFKD_QC=-n}', "");
    Expect(0, 195102, '\P{^NFKD_QC=-n}', "");
    Error('\p{Is_NFKD_Quick_Check:   :=No}');
    Error('\P{Is_NFKD_Quick_Check:   :=No}');
    Expect(1, 195101, '\p{Is_NFKD_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^Is_NFKD_Quick_Check=no}', "");
    Expect(0, 195101, '\P{Is_NFKD_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^Is_NFKD_Quick_Check=no}', "");
    Expect(0, 195102, '\p{Is_NFKD_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^Is_NFKD_Quick_Check=no}', "");
    Expect(1, 195102, '\P{Is_NFKD_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^Is_NFKD_Quick_Check=no}', "");
    Expect(1, 195101, '\p{Is_NFKD_Quick_Check= No}', "");
    Expect(0, 195101, '\p{^Is_NFKD_Quick_Check= No}', "");
    Expect(0, 195101, '\P{Is_NFKD_Quick_Check= No}', "");
    Expect(1, 195101, '\P{^Is_NFKD_Quick_Check= No}', "");
    Expect(0, 195102, '\p{Is_NFKD_Quick_Check= No}', "");
    Expect(1, 195102, '\p{^Is_NFKD_Quick_Check= No}', "");
    Expect(1, 195102, '\P{Is_NFKD_Quick_Check= No}', "");
    Expect(0, 195102, '\P{^Is_NFKD_Quick_Check= No}', "");
    Error('\p{Is_NFKD_QC: :=N}');
    Error('\P{Is_NFKD_QC: :=N}');
    Expect(1, 195101, '\p{Is_NFKD_QC=n}', "");
    Expect(0, 195101, '\p{^Is_NFKD_QC=n}', "");
    Expect(0, 195101, '\P{Is_NFKD_QC=n}', "");
    Expect(1, 195101, '\P{^Is_NFKD_QC=n}', "");
    Expect(0, 195102, '\p{Is_NFKD_QC=n}', "");
    Expect(1, 195102, '\p{^Is_NFKD_QC=n}', "");
    Expect(1, 195102, '\P{Is_NFKD_QC=n}', "");
    Expect(0, 195102, '\P{^Is_NFKD_QC=n}', "");
    Expect(1, 195101, '\p{Is_NFKD_QC=__n}', "");
    Expect(0, 195101, '\p{^Is_NFKD_QC=__n}', "");
    Expect(0, 195101, '\P{Is_NFKD_QC=__n}', "");
    Expect(1, 195101, '\P{^Is_NFKD_QC=__n}', "");
    Expect(0, 195102, '\p{Is_NFKD_QC=__n}', "");
    Expect(1, 195102, '\p{^Is_NFKD_QC=__n}', "");
    Expect(1, 195102, '\P{Is_NFKD_QC=__n}', "");
    Expect(0, 195102, '\P{^Is_NFKD_QC=__n}', "");
    Error('\p{NFKD_Quick_Check=		Yes/a/}');
    Error('\P{NFKD_Quick_Check=		Yes/a/}');
    Expect(1, 195102, '\p{NFKD_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^NFKD_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{NFKD_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^NFKD_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{NFKD_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^NFKD_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{NFKD_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^NFKD_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{NFKD_Quick_Check:_-Yes}', "");
    Expect(0, 195102, '\p{^NFKD_Quick_Check:_-Yes}', "");
    Expect(0, 195102, '\P{NFKD_Quick_Check:_-Yes}', "");
    Expect(1, 195102, '\P{^NFKD_Quick_Check:_-Yes}', "");
    Expect(0, 195101, '\p{NFKD_Quick_Check:_-Yes}', "");
    Expect(1, 195101, '\p{^NFKD_Quick_Check:_-Yes}', "");
    Expect(1, 195101, '\P{NFKD_Quick_Check:_-Yes}', "");
    Expect(0, 195101, '\P{^NFKD_Quick_Check:_-Yes}', "");
    Error('\p{NFKD_QC=:=	 Y}');
    Error('\P{NFKD_QC=:=	 Y}');
    Expect(1, 195102, '\p{NFKD_QC=y}', "");
    Expect(0, 195102, '\p{^NFKD_QC=y}', "");
    Expect(0, 195102, '\P{NFKD_QC=y}', "");
    Expect(1, 195102, '\P{^NFKD_QC=y}', "");
    Expect(0, 195101, '\p{NFKD_QC=y}', "");
    Expect(1, 195101, '\p{^NFKD_QC=y}', "");
    Expect(1, 195101, '\P{NFKD_QC=y}', "");
    Expect(0, 195101, '\P{^NFKD_QC=y}', "");
    Expect(1, 195102, '\p{NFKD_QC=_ Y}', "");
    Expect(0, 195102, '\p{^NFKD_QC=_ Y}', "");
    Expect(0, 195102, '\P{NFKD_QC=_ Y}', "");
    Expect(1, 195102, '\P{^NFKD_QC=_ Y}', "");
    Expect(0, 195101, '\p{NFKD_QC=_ Y}', "");
    Expect(1, 195101, '\p{^NFKD_QC=_ Y}', "");
    Expect(1, 195101, '\P{NFKD_QC=_ Y}', "");
    Expect(0, 195101, '\P{^NFKD_QC=_ Y}', "");
    Error('\p{Is_NFKD_Quick_Check=	yes/a/}');
    Error('\P{Is_NFKD_Quick_Check=	yes/a/}');
    Expect(1, 195102, '\p{Is_NFKD_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^Is_NFKD_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{Is_NFKD_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^Is_NFKD_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{Is_NFKD_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^Is_NFKD_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{Is_NFKD_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^Is_NFKD_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{Is_NFKD_Quick_Check=-yes}', "");
    Expect(0, 195102, '\p{^Is_NFKD_Quick_Check=-yes}', "");
    Expect(0, 195102, '\P{Is_NFKD_Quick_Check=-yes}', "");
    Expect(1, 195102, '\P{^Is_NFKD_Quick_Check=-yes}', "");
    Expect(0, 195101, '\p{Is_NFKD_Quick_Check=-yes}', "");
    Expect(1, 195101, '\p{^Is_NFKD_Quick_Check=-yes}', "");
    Expect(1, 195101, '\P{Is_NFKD_Quick_Check=-yes}', "");
    Expect(0, 195101, '\P{^Is_NFKD_Quick_Check=-yes}', "");
    Error('\p{Is_NFKD_QC=/a/-	Y}');
    Error('\P{Is_NFKD_QC=/a/-	Y}');
    Expect(1, 195102, '\p{Is_NFKD_QC=y}', "");
    Expect(0, 195102, '\p{^Is_NFKD_QC=y}', "");
    Expect(0, 195102, '\P{Is_NFKD_QC=y}', "");
    Expect(1, 195102, '\P{^Is_NFKD_QC=y}', "");
    Expect(0, 195101, '\p{Is_NFKD_QC=y}', "");
    Expect(1, 195101, '\p{^Is_NFKD_QC=y}', "");
    Expect(1, 195101, '\P{Is_NFKD_QC=y}', "");
    Expect(0, 195101, '\P{^Is_NFKD_QC=y}', "");
    Expect(1, 195102, '\p{Is_NFKD_QC=	Y}', "");
    Expect(0, 195102, '\p{^Is_NFKD_QC=	Y}', "");
    Expect(0, 195102, '\P{Is_NFKD_QC=	Y}', "");
    Expect(1, 195102, '\P{^Is_NFKD_QC=	Y}', "");
    Expect(0, 195101, '\p{Is_NFKD_QC=	Y}', "");
    Expect(1, 195101, '\p{^Is_NFKD_QC=	Y}', "");
    Expect(1, 195101, '\P{Is_NFKD_QC=	Y}', "");
    Expect(0, 195101, '\P{^Is_NFKD_QC=	Y}', "");
    Error('\p{numerictype}');
    Error('\P{numerictype}');
    Error('\p{nt}');
    Error('\P{nt}');
    Error('\p{Numeric_Type=/a/decimal}');
    Error('\P{Numeric_Type=/a/decimal}');
    Expect(1, 125273, '\p{Numeric_Type=decimal}', "");
    Expect(0, 125273, '\p{^Numeric_Type=decimal}', "");
    Expect(0, 125273, '\P{Numeric_Type=decimal}', "");
    Expect(1, 125273, '\P{^Numeric_Type=decimal}', "");
    Expect(0, 125274, '\p{Numeric_Type=decimal}', "");
    Expect(1, 125274, '\p{^Numeric_Type=decimal}', "");
    Expect(1, 125274, '\P{Numeric_Type=decimal}', "");
    Expect(0, 125274, '\P{^Numeric_Type=decimal}', "");
    Expect(1, 125273, '\p{Numeric_Type= _DECIMAL}', "");
    Expect(0, 125273, '\p{^Numeric_Type= _DECIMAL}', "");
    Expect(0, 125273, '\P{Numeric_Type= _DECIMAL}', "");
    Expect(1, 125273, '\P{^Numeric_Type= _DECIMAL}', "");
    Expect(0, 125274, '\p{Numeric_Type= _DECIMAL}', "");
    Expect(1, 125274, '\p{^Numeric_Type= _DECIMAL}', "");
    Expect(1, 125274, '\P{Numeric_Type= _DECIMAL}', "");
    Expect(0, 125274, '\P{^Numeric_Type= _DECIMAL}', "");
    Error('\p{Nt=:=_DE}');
    Error('\P{Nt=:=_DE}');
    Expect(1, 125273, '\p{Nt=de}', "");
    Expect(0, 125273, '\p{^Nt=de}', "");
    Expect(0, 125273, '\P{Nt=de}', "");
    Expect(1, 125273, '\P{^Nt=de}', "");
    Expect(0, 125274, '\p{Nt=de}', "");
    Expect(1, 125274, '\p{^Nt=de}', "");
    Expect(1, 125274, '\P{Nt=de}', "");
    Expect(0, 125274, '\P{^Nt=de}', "");
    Expect(1, 125273, '\p{Nt= DE}', "");
    Expect(0, 125273, '\p{^Nt= DE}', "");
    Expect(0, 125273, '\P{Nt= DE}', "");
    Expect(1, 125273, '\P{^Nt= DE}', "");
    Expect(0, 125274, '\p{Nt= DE}', "");
    Expect(1, 125274, '\p{^Nt= DE}', "");
    Expect(1, 125274, '\P{Nt= DE}', "");
    Expect(0, 125274, '\P{^Nt= DE}', "");
    Error('\p{Is_Numeric_Type=:=	Decimal}');
    Error('\P{Is_Numeric_Type=:=	Decimal}');
    Expect(1, 125273, '\p{Is_Numeric_Type=decimal}', "");
    Expect(0, 125273, '\p{^Is_Numeric_Type=decimal}', "");
    Expect(0, 125273, '\P{Is_Numeric_Type=decimal}', "");
    Expect(1, 125273, '\P{^Is_Numeric_Type=decimal}', "");
    Expect(0, 125274, '\p{Is_Numeric_Type=decimal}', "");
    Expect(1, 125274, '\p{^Is_Numeric_Type=decimal}', "");
    Expect(1, 125274, '\P{Is_Numeric_Type=decimal}', "");
    Expect(0, 125274, '\P{^Is_Numeric_Type=decimal}', "");
    Expect(1, 125273, '\p{Is_Numeric_Type=	decimal}', "");
    Expect(0, 125273, '\p{^Is_Numeric_Type=	decimal}', "");
    Expect(0, 125273, '\P{Is_Numeric_Type=	decimal}', "");
    Expect(1, 125273, '\P{^Is_Numeric_Type=	decimal}', "");
    Expect(0, 125274, '\p{Is_Numeric_Type=	decimal}', "");
    Expect(1, 125274, '\p{^Is_Numeric_Type=	decimal}', "");
    Expect(1, 125274, '\P{Is_Numeric_Type=	decimal}', "");
    Expect(0, 125274, '\P{^Is_Numeric_Type=	decimal}', "");
    Error('\p{Is_Nt=	 De/a/}');
    Error('\P{Is_Nt=	 De/a/}');
    Expect(1, 125273, '\p{Is_Nt:	de}', "");
    Expect(0, 125273, '\p{^Is_Nt:	de}', "");
    Expect(0, 125273, '\P{Is_Nt:	de}', "");
    Expect(1, 125273, '\P{^Is_Nt:	de}', "");
    Expect(0, 125274, '\p{Is_Nt:	de}', "");
    Expect(1, 125274, '\p{^Is_Nt:	de}', "");
    Expect(1, 125274, '\P{Is_Nt:	de}', "");
    Expect(0, 125274, '\P{^Is_Nt:	de}', "");
    Expect(1, 125273, '\p{Is_Nt=	De}', "");
    Expect(0, 125273, '\p{^Is_Nt=	De}', "");
    Expect(0, 125273, '\P{Is_Nt=	De}', "");
    Expect(1, 125273, '\P{^Is_Nt=	De}', "");
    Expect(0, 125274, '\p{Is_Nt=	De}', "");
    Expect(1, 125274, '\p{^Is_Nt=	De}', "");
    Expect(1, 125274, '\P{Is_Nt=	De}', "");
    Expect(0, 125274, '\P{^Is_Nt=	De}', "");
    Error('\p{Numeric_Type=/a/DIGIT}');
    Error('\P{Numeric_Type=/a/DIGIT}');
    Expect(1, 127242, '\p{Numeric_Type=digit}', "");
    Expect(0, 127242, '\p{^Numeric_Type=digit}', "");
    Expect(0, 127242, '\P{Numeric_Type=digit}', "");
    Expect(1, 127242, '\P{^Numeric_Type=digit}', "");
    Expect(0, 127243, '\p{Numeric_Type=digit}', "");
    Expect(1, 127243, '\p{^Numeric_Type=digit}', "");
    Expect(1, 127243, '\P{Numeric_Type=digit}', "");
    Expect(0, 127243, '\P{^Numeric_Type=digit}', "");
    Expect(1, 127242, '\p{Numeric_Type=__Digit}', "");
    Expect(0, 127242, '\p{^Numeric_Type=__Digit}', "");
    Expect(0, 127242, '\P{Numeric_Type=__Digit}', "");
    Expect(1, 127242, '\P{^Numeric_Type=__Digit}', "");
    Expect(0, 127243, '\p{Numeric_Type=__Digit}', "");
    Expect(1, 127243, '\p{^Numeric_Type=__Digit}', "");
    Expect(1, 127243, '\P{Numeric_Type=__Digit}', "");
    Expect(0, 127243, '\P{^Numeric_Type=__Digit}', "");
    Error('\p{Nt=_:=Di}');
    Error('\P{Nt=_:=Di}');
    Expect(1, 127242, '\p{Nt=di}', "");
    Expect(0, 127242, '\p{^Nt=di}', "");
    Expect(0, 127242, '\P{Nt=di}', "");
    Expect(1, 127242, '\P{^Nt=di}', "");
    Expect(0, 127243, '\p{Nt=di}', "");
    Expect(1, 127243, '\p{^Nt=di}', "");
    Expect(1, 127243, '\P{Nt=di}', "");
    Expect(0, 127243, '\P{^Nt=di}', "");
    Expect(1, 127242, '\p{Nt=  DI}', "");
    Expect(0, 127242, '\p{^Nt=  DI}', "");
    Expect(0, 127242, '\P{Nt=  DI}', "");
    Expect(1, 127242, '\P{^Nt=  DI}', "");
    Expect(0, 127243, '\p{Nt=  DI}', "");
    Expect(1, 127243, '\p{^Nt=  DI}', "");
    Expect(1, 127243, '\P{Nt=  DI}', "");
    Expect(0, 127243, '\P{^Nt=  DI}', "");
    Error('\p{Is_Numeric_Type:   /a/-	DIGIT}');
    Error('\P{Is_Numeric_Type:   /a/-	DIGIT}');
    Expect(1, 127242, '\p{Is_Numeric_Type=digit}', "");
    Expect(0, 127242, '\p{^Is_Numeric_Type=digit}', "");
    Expect(0, 127242, '\P{Is_Numeric_Type=digit}', "");
    Expect(1, 127242, '\P{^Is_Numeric_Type=digit}', "");
    Expect(0, 127243, '\p{Is_Numeric_Type=digit}', "");
    Expect(1, 127243, '\p{^Is_Numeric_Type=digit}', "");
    Expect(1, 127243, '\P{Is_Numeric_Type=digit}', "");
    Expect(0, 127243, '\P{^Is_Numeric_Type=digit}', "");
    Expect(1, 127242, '\p{Is_Numeric_Type=_	DIGIT}', "");
    Expect(0, 127242, '\p{^Is_Numeric_Type=_	DIGIT}', "");
    Expect(0, 127242, '\P{Is_Numeric_Type=_	DIGIT}', "");
    Expect(1, 127242, '\P{^Is_Numeric_Type=_	DIGIT}', "");
    Expect(0, 127243, '\p{Is_Numeric_Type=_	DIGIT}', "");
    Expect(1, 127243, '\p{^Is_Numeric_Type=_	DIGIT}', "");
    Expect(1, 127243, '\P{Is_Numeric_Type=_	DIGIT}', "");
    Expect(0, 127243, '\P{^Is_Numeric_Type=_	DIGIT}', "");
    Error('\p{Is_Nt=:=	_di}');
    Error('\P{Is_Nt=:=	_di}');
    Expect(1, 127242, '\p{Is_Nt=di}', "");
    Expect(0, 127242, '\p{^Is_Nt=di}', "");
    Expect(0, 127242, '\P{Is_Nt=di}', "");
    Expect(1, 127242, '\P{^Is_Nt=di}', "");
    Expect(0, 127243, '\p{Is_Nt=di}', "");
    Expect(1, 127243, '\p{^Is_Nt=di}', "");
    Expect(1, 127243, '\P{Is_Nt=di}', "");
    Expect(0, 127243, '\P{^Is_Nt=di}', "");
    Expect(1, 127242, '\p{Is_Nt=	-Di}', "");
    Expect(0, 127242, '\p{^Is_Nt=	-Di}', "");
    Expect(0, 127242, '\P{Is_Nt=	-Di}', "");
    Expect(1, 127242, '\P{^Is_Nt=	-Di}', "");
    Expect(0, 127243, '\p{Is_Nt=	-Di}', "");
    Expect(1, 127243, '\p{^Is_Nt=	-Di}', "");
    Expect(1, 127243, '\P{Is_Nt=	-Di}', "");
    Expect(0, 127243, '\P{^Is_Nt=	-Di}', "");
    Error('\p{Numeric_Type:	 /a/NONE}');
    Error('\P{Numeric_Type:	 /a/NONE}');
    Expect(1, 194705, '\p{Numeric_Type=none}', "");
    Expect(0, 194705, '\p{^Numeric_Type=none}', "");
    Expect(0, 194705, '\P{Numeric_Type=none}', "");
    Expect(1, 194705, '\P{^Numeric_Type=none}', "");
    Expect(0, 194704, '\p{Numeric_Type=none}', "");
    Expect(1, 194704, '\p{^Numeric_Type=none}', "");
    Expect(1, 194704, '\P{Numeric_Type=none}', "");
    Expect(0, 194704, '\P{^Numeric_Type=none}', "");
    Expect(1, 194705, '\p{Numeric_Type=  none}', "");
    Expect(0, 194705, '\p{^Numeric_Type=  none}', "");
    Expect(0, 194705, '\P{Numeric_Type=  none}', "");
    Expect(1, 194705, '\P{^Numeric_Type=  none}', "");
    Expect(0, 194704, '\p{Numeric_Type=  none}', "");
    Expect(1, 194704, '\p{^Numeric_Type=  none}', "");
    Expect(1, 194704, '\P{Numeric_Type=  none}', "");
    Expect(0, 194704, '\P{^Numeric_Type=  none}', "");
    Error('\p{Nt=	 none:=}');
    Error('\P{Nt=	 none:=}');
    Expect(1, 194705, '\p{Nt=none}', "");
    Expect(0, 194705, '\p{^Nt=none}', "");
    Expect(0, 194705, '\P{Nt=none}', "");
    Expect(1, 194705, '\P{^Nt=none}', "");
    Expect(0, 194704, '\p{Nt=none}', "");
    Expect(1, 194704, '\p{^Nt=none}', "");
    Expect(1, 194704, '\P{Nt=none}', "");
    Expect(0, 194704, '\P{^Nt=none}', "");
    Expect(1, 194705, '\p{Nt=		NONE}', "");
    Expect(0, 194705, '\p{^Nt=		NONE}', "");
    Expect(0, 194705, '\P{Nt=		NONE}', "");
    Expect(1, 194705, '\P{^Nt=		NONE}', "");
    Expect(0, 194704, '\p{Nt=		NONE}', "");
    Expect(1, 194704, '\p{^Nt=		NONE}', "");
    Expect(1, 194704, '\P{Nt=		NONE}', "");
    Expect(0, 194704, '\P{^Nt=		NONE}', "");
    Error('\p{Is_Numeric_Type=/a/ none}');
    Error('\P{Is_Numeric_Type=/a/ none}');
    Expect(1, 194705, '\p{Is_Numeric_Type=none}', "");
    Expect(0, 194705, '\p{^Is_Numeric_Type=none}', "");
    Expect(0, 194705, '\P{Is_Numeric_Type=none}', "");
    Expect(1, 194705, '\P{^Is_Numeric_Type=none}', "");
    Expect(0, 194704, '\p{Is_Numeric_Type=none}', "");
    Expect(1, 194704, '\p{^Is_Numeric_Type=none}', "");
    Expect(1, 194704, '\P{Is_Numeric_Type=none}', "");
    Expect(0, 194704, '\P{^Is_Numeric_Type=none}', "");
    Expect(1, 194705, '\p{Is_Numeric_Type= none}', "");
    Expect(0, 194705, '\p{^Is_Numeric_Type= none}', "");
    Expect(0, 194705, '\P{Is_Numeric_Type= none}', "");
    Expect(1, 194705, '\P{^Is_Numeric_Type= none}', "");
    Expect(0, 194704, '\p{Is_Numeric_Type= none}', "");
    Expect(1, 194704, '\p{^Is_Numeric_Type= none}', "");
    Expect(1, 194704, '\P{Is_Numeric_Type= none}', "");
    Expect(0, 194704, '\P{^Is_Numeric_Type= none}', "");
    Error('\p{Is_Nt=-/a/None}');
    Error('\P{Is_Nt=-/a/None}');
    Expect(1, 194705, '\p{Is_Nt=none}', "");
    Expect(0, 194705, '\p{^Is_Nt=none}', "");
    Expect(0, 194705, '\P{Is_Nt=none}', "");
    Expect(1, 194705, '\P{^Is_Nt=none}', "");
    Expect(0, 194704, '\p{Is_Nt=none}', "");
    Expect(1, 194704, '\p{^Is_Nt=none}', "");
    Expect(1, 194704, '\P{Is_Nt=none}', "");
    Expect(0, 194704, '\P{^Is_Nt=none}', "");
    Expect(1, 194705, '\p{Is_Nt= -none}', "");
    Expect(0, 194705, '\p{^Is_Nt= -none}', "");
    Expect(0, 194705, '\P{Is_Nt= -none}', "");
    Expect(1, 194705, '\P{^Is_Nt= -none}', "");
    Expect(0, 194704, '\p{Is_Nt= -none}', "");
    Expect(1, 194704, '\p{^Is_Nt= -none}', "");
    Expect(1, 194704, '\P{Is_Nt= -none}', "");
    Expect(0, 194704, '\P{^Is_Nt= -none}', "");
    Error('\p{Numeric_Type: 	:=Numeric}');
    Error('\P{Numeric_Type: 	:=Numeric}');
    Expect(1, 194704, '\p{Numeric_Type:   numeric}', "");
    Expect(0, 194704, '\p{^Numeric_Type:   numeric}', "");
    Expect(0, 194704, '\P{Numeric_Type:   numeric}', "");
    Expect(1, 194704, '\P{^Numeric_Type:   numeric}', "");
    Expect(0, 194705, '\p{Numeric_Type:   numeric}', "");
    Expect(1, 194705, '\p{^Numeric_Type:   numeric}', "");
    Expect(1, 194705, '\P{Numeric_Type:   numeric}', "");
    Expect(0, 194705, '\P{^Numeric_Type:   numeric}', "");
    Expect(1, 194704, '\p{Numeric_Type=_NUMERIC}', "");
    Expect(0, 194704, '\p{^Numeric_Type=_NUMERIC}', "");
    Expect(0, 194704, '\P{Numeric_Type=_NUMERIC}', "");
    Expect(1, 194704, '\P{^Numeric_Type=_NUMERIC}', "");
    Expect(0, 194705, '\p{Numeric_Type=_NUMERIC}', "");
    Expect(1, 194705, '\p{^Numeric_Type=_NUMERIC}', "");
    Expect(1, 194705, '\P{Numeric_Type=_NUMERIC}', "");
    Expect(0, 194705, '\P{^Numeric_Type=_NUMERIC}', "");
    Error('\p{Nt=/a/Nu}');
    Error('\P{Nt=/a/Nu}');
    Expect(1, 194704, '\p{Nt=nu}', "");
    Expect(0, 194704, '\p{^Nt=nu}', "");
    Expect(0, 194704, '\P{Nt=nu}', "");
    Expect(1, 194704, '\P{^Nt=nu}', "");
    Expect(0, 194705, '\p{Nt=nu}', "");
    Expect(1, 194705, '\p{^Nt=nu}', "");
    Expect(1, 194705, '\P{Nt=nu}', "");
    Expect(0, 194705, '\P{^Nt=nu}', "");
    Expect(1, 194704, '\p{Nt=--NU}', "");
    Expect(0, 194704, '\p{^Nt=--NU}', "");
    Expect(0, 194704, '\P{Nt=--NU}', "");
    Expect(1, 194704, '\P{^Nt=--NU}', "");
    Expect(0, 194705, '\p{Nt=--NU}', "");
    Expect(1, 194705, '\p{^Nt=--NU}', "");
    Expect(1, 194705, '\P{Nt=--NU}', "");
    Expect(0, 194705, '\P{^Nt=--NU}', "");
    Error('\p{Is_Numeric_Type=:=		Numeric}');
    Error('\P{Is_Numeric_Type=:=		Numeric}');
    Expect(1, 194704, '\p{Is_Numeric_Type=numeric}', "");
    Expect(0, 194704, '\p{^Is_Numeric_Type=numeric}', "");
    Expect(0, 194704, '\P{Is_Numeric_Type=numeric}', "");
    Expect(1, 194704, '\P{^Is_Numeric_Type=numeric}', "");
    Expect(0, 194705, '\p{Is_Numeric_Type=numeric}', "");
    Expect(1, 194705, '\p{^Is_Numeric_Type=numeric}', "");
    Expect(1, 194705, '\P{Is_Numeric_Type=numeric}', "");
    Expect(0, 194705, '\P{^Is_Numeric_Type=numeric}', "");
    Expect(1, 194704, '\p{Is_Numeric_Type=-Numeric}', "");
    Expect(0, 194704, '\p{^Is_Numeric_Type=-Numeric}', "");
    Expect(0, 194704, '\P{Is_Numeric_Type=-Numeric}', "");
    Expect(1, 194704, '\P{^Is_Numeric_Type=-Numeric}', "");
    Expect(0, 194705, '\p{Is_Numeric_Type=-Numeric}', "");
    Expect(1, 194705, '\p{^Is_Numeric_Type=-Numeric}', "");
    Expect(1, 194705, '\P{Is_Numeric_Type=-Numeric}', "");
    Expect(0, 194705, '\P{^Is_Numeric_Type=-Numeric}', "");
    Error('\p{Is_Nt=-	NU:=}');
    Error('\P{Is_Nt=-	NU:=}');
    Expect(1, 194704, '\p{Is_Nt=nu}', "");
    Expect(0, 194704, '\p{^Is_Nt=nu}', "");
    Expect(0, 194704, '\P{Is_Nt=nu}', "");
    Expect(1, 194704, '\P{^Is_Nt=nu}', "");
    Expect(0, 194705, '\p{Is_Nt=nu}', "");
    Expect(1, 194705, '\p{^Is_Nt=nu}', "");
    Expect(1, 194705, '\P{Is_Nt=nu}', "");
    Expect(0, 194705, '\P{^Is_Nt=nu}', "");
    Expect(1, 194704, '\p{Is_Nt: __Nu}', "");
    Expect(0, 194704, '\p{^Is_Nt: __Nu}', "");
    Expect(0, 194704, '\P{Is_Nt: __Nu}', "");
    Expect(1, 194704, '\P{^Is_Nt: __Nu}', "");
    Expect(0, 194705, '\p{Is_Nt: __Nu}', "");
    Expect(1, 194705, '\p{^Is_Nt: __Nu}', "");
    Expect(1, 194705, '\P{Is_Nt: __Nu}', "");
    Expect(0, 194705, '\P{^Is_Nt: __Nu}', "");
    Error('\p{numericvalue}');
    Error('\P{numericvalue}');
    Error('\p{nv}');
    Error('\P{nv}');
    Error('\p{Numeric_Value=  -0000001/002/a/}');
    Error('\P{Numeric_Value=  -0000001/002/a/}');
    Expect(1, 3891, '\p{Numeric_Value=-001/002}', "");
    Expect(0, 3891, '\p{^Numeric_Value=-001/002}', "");
    Expect(0, 3891, '\P{Numeric_Value=-001/002}', "");
    Expect(1, 3891, '\P{^Numeric_Value=-001/002}', "");
    Expect(0, 3892, '\p{Numeric_Value=-001/002}', "");
    Expect(1, 3892, '\p{^Numeric_Value=-001/002}', "");
    Expect(1, 3892, '\P{Numeric_Value=-001/002}', "");
    Expect(0, 3892, '\P{^Numeric_Value=-001/002}', "");
    Expect(1, 3891, '\p{Numeric_Value=-0.500}', "");
    Expect(0, 3891, '\p{^Numeric_Value=-0.500}', "");
    Expect(0, 3891, '\P{Numeric_Value=-0.500}', "");
    Expect(1, 3891, '\P{^Numeric_Value=-0.500}', "");
    Expect(0, 3892, '\p{Numeric_Value=-0.500}', "");
    Expect(1, 3892, '\p{^Numeric_Value=-0.500}', "");
    Expect(1, 3892, '\P{Numeric_Value=-0.500}', "");
    Expect(0, 3892, '\P{^Numeric_Value=-0.500}', "");
    Error('\p{Nv=:=-0000000001/000000002}');
    Error('\P{Nv=:=-0000000001/000000002}');
    Expect(1, 3891, '\p{Nv=-000001/2}', "");
    Expect(0, 3891, '\p{^Nv=-000001/2}', "");
    Expect(0, 3891, '\P{Nv=-000001/2}', "");
    Expect(1, 3891, '\P{^Nv=-000001/2}', "");
    Expect(0, 3892, '\p{Nv=-000001/2}', "");
    Expect(1, 3892, '\p{^Nv=-000001/2}', "");
    Expect(1, 3892, '\P{Nv=-000001/2}', "");
    Expect(0, 3892, '\P{^Nv=-000001/2}', "");
    Expect(1, 3891, '\p{Nv=-0.500}', "");
    Expect(0, 3891, '\p{^Nv=-0.500}', "");
    Expect(0, 3891, '\P{Nv=-0.500}', "");
    Expect(1, 3891, '\P{^Nv=-0.500}', "");
    Expect(0, 3892, '\p{Nv=-0.500}', "");
    Expect(1, 3892, '\p{^Nv=-0.500}', "");
    Expect(1, 3892, '\P{Nv=-0.500}', "");
    Expect(0, 3892, '\P{^Nv=-0.500}', "");
    Error('\p{Is_Numeric_Value=:=---01/2}');
    Error('\P{Is_Numeric_Value=:=---01/2}');
    Expect(1, 3891, '\p{Is_Numeric_Value=-00000001/0000000002}', "");
    Expect(0, 3891, '\p{^Is_Numeric_Value=-00000001/0000000002}', "");
    Expect(0, 3891, '\P{Is_Numeric_Value=-00000001/0000000002}', "");
    Expect(1, 3891, '\P{^Is_Numeric_Value=-00000001/0000000002}', "");
    Expect(0, 3892, '\p{Is_Numeric_Value=-00000001/0000000002}', "");
    Expect(1, 3892, '\p{^Is_Numeric_Value=-00000001/0000000002}', "");
    Expect(1, 3892, '\P{Is_Numeric_Value=-00000001/0000000002}', "");
    Expect(0, 3892, '\P{^Is_Numeric_Value=-00000001/0000000002}', "");
    Expect(1, 3891, '\p{Is_Numeric_Value=-0.500}', "");
    Expect(0, 3891, '\p{^Is_Numeric_Value=-0.500}', "");
    Expect(0, 3891, '\P{Is_Numeric_Value=-0.500}', "");
    Expect(1, 3891, '\P{^Is_Numeric_Value=-0.500}', "");
    Expect(0, 3892, '\p{Is_Numeric_Value=-0.500}', "");
    Expect(1, 3892, '\p{^Is_Numeric_Value=-0.500}', "");
    Expect(1, 3892, '\P{Is_Numeric_Value=-0.500}', "");
    Expect(0, 3892, '\P{^Is_Numeric_Value=-0.500}', "");
    Error('\p{Is_Nv=:= -1/0002}');
    Error('\P{Is_Nv=:= -1/0002}');
    Expect(1, 3891, '\p{Is_Nv=-00000001/00002}', "");
    Expect(0, 3891, '\p{^Is_Nv=-00000001/00002}', "");
    Expect(0, 3891, '\P{Is_Nv=-00000001/00002}', "");
    Expect(1, 3891, '\P{^Is_Nv=-00000001/00002}', "");
    Expect(0, 3892, '\p{Is_Nv=-00000001/00002}', "");
    Expect(1, 3892, '\p{^Is_Nv=-00000001/00002}', "");
    Expect(1, 3892, '\P{Is_Nv=-00000001/00002}', "");
    Expect(0, 3892, '\P{^Is_Nv=-00000001/00002}', "");
    Expect(1, 3891, '\p{Is_Nv=-0.500}', "");
    Expect(0, 3891, '\p{^Is_Nv=-0.500}', "");
    Expect(0, 3891, '\P{Is_Nv=-0.500}', "");
    Expect(1, 3891, '\P{^Is_Nv=-0.500}', "");
    Expect(0, 3892, '\p{Is_Nv=-0.500}', "");
    Expect(1, 3892, '\p{^Is_Nv=-0.500}', "");
    Expect(1, 3892, '\P{Is_Nv=-0.500}', "");
    Expect(0, 3892, '\P{^Is_Nv=-0.500}', "");
    Error('\p{Numeric_Value=	-000000000:=}');
    Error('\P{Numeric_Value=	-000000000:=}');
    Expect(1, 127244, '\p{Numeric_Value=00000000}', "");
    Expect(0, 127244, '\p{^Numeric_Value=00000000}', "");
    Expect(0, 127244, '\P{Numeric_Value=00000000}', "");
    Expect(1, 127244, '\P{^Numeric_Value=00000000}', "");
    Expect(0, 127245, '\p{Numeric_Value=00000000}', "");
    Expect(1, 127245, '\p{^Numeric_Value=00000000}', "");
    Expect(1, 127245, '\P{Numeric_Value=00000000}', "");
    Expect(0, 127245, '\P{^Numeric_Value=00000000}', "");
    Error('\p{Nv=	/a/+000_0}');
    Error('\P{Nv=	/a/+000_0}');
    Expect(1, 127244, '\p{Nv=000000}', "");
    Expect(0, 127244, '\p{^Nv=000000}', "");
    Expect(0, 127244, '\P{Nv=000000}', "");
    Expect(1, 127244, '\P{^Nv=000000}', "");
    Expect(0, 127245, '\p{Nv=000000}', "");
    Expect(1, 127245, '\p{^Nv=000000}', "");
    Expect(1, 127245, '\P{Nv=000000}', "");
    Expect(0, 127245, '\P{^Nv=000000}', "");
    Error('\p{Is_Numeric_Value=0/a/}');
    Error('\P{Is_Numeric_Value=0/a/}');
    Expect(1, 127244, '\p{Is_Numeric_Value:00_0}', "");
    Expect(0, 127244, '\p{^Is_Numeric_Value:00_0}', "");
    Expect(0, 127244, '\P{Is_Numeric_Value:00_0}', "");
    Expect(1, 127244, '\P{^Is_Numeric_Value:00_0}', "");
    Expect(0, 127245, '\p{Is_Numeric_Value:00_0}', "");
    Expect(1, 127245, '\p{^Is_Numeric_Value:00_0}', "");
    Expect(1, 127245, '\P{Is_Numeric_Value:00_0}', "");
    Expect(0, 127245, '\P{^Is_Numeric_Value:00_0}', "");
    Error('\p{Is_Nv=	:=0_0}');
    Error('\P{Is_Nv=	:=0_0}');
    Expect(1, 127244, '\p{Is_Nv=0_0_0_0_0_0000}', "");
    Expect(0, 127244, '\p{^Is_Nv=0_0_0_0_0_0000}', "");
    Expect(0, 127244, '\P{Is_Nv=0_0_0_0_0_0000}', "");
    Expect(1, 127244, '\P{^Is_Nv=0_0_0_0_0_0000}', "");
    Expect(0, 127245, '\p{Is_Nv=0_0_0_0_0_0000}', "");
    Expect(1, 127245, '\p{^Is_Nv=0_0_0_0_0_0000}', "");
    Expect(1, 127245, '\P{Is_Nv=0_0_0_0_0_0000}', "");
    Expect(0, 127245, '\P{^Is_Nv=0_0_0_0_0_0000}', "");
    Error('\p{Numeric_Value=:=	0_1}');
    Error('\P{Numeric_Value=:=	0_1}');
    Expect(1, 133418, '\p{Numeric_Value=1}', "");
    Expect(0, 133418, '\p{^Numeric_Value=1}', "");
    Expect(0, 133418, '\P{Numeric_Value=1}', "");
    Expect(1, 133418, '\P{^Numeric_Value=1}', "");
    Expect(0, 133419, '\p{Numeric_Value=1}', "");
    Expect(1, 133419, '\p{^Numeric_Value=1}', "");
    Expect(1, 133419, '\P{Numeric_Value=1}', "");
    Expect(0, 133419, '\P{^Numeric_Value=1}', "");
    Error('\p{Nv=	/a/00_00_00_01}');
    Error('\P{Nv=	/a/00_00_00_01}');
    Expect(1, 133418, '\p{Nv=00_00_00_1}', "");
    Expect(0, 133418, '\p{^Nv=00_00_00_1}', "");
    Expect(0, 133418, '\P{Nv=00_00_00_1}', "");
    Expect(1, 133418, '\P{^Nv=00_00_00_1}', "");
    Expect(0, 133419, '\p{Nv=00_00_00_1}', "");
    Expect(1, 133419, '\p{^Nv=00_00_00_1}', "");
    Expect(1, 133419, '\P{Nv=00_00_00_1}', "");
    Expect(0, 133419, '\P{^Nv=00_00_00_1}', "");
    Error('\p{Is_Numeric_Value=	 000_1/a/}');
    Error('\P{Is_Numeric_Value=	 000_1/a/}');
    Expect(1, 133418, '\p{Is_Numeric_Value=00_1}', "");
    Expect(0, 133418, '\p{^Is_Numeric_Value=00_1}', "");
    Expect(0, 133418, '\P{Is_Numeric_Value=00_1}', "");
    Expect(1, 133418, '\P{^Is_Numeric_Value=00_1}', "");
    Expect(0, 133419, '\p{Is_Numeric_Value=00_1}', "");
    Expect(1, 133419, '\p{^Is_Numeric_Value=00_1}', "");
    Expect(1, 133419, '\P{Is_Numeric_Value=00_1}', "");
    Expect(0, 133419, '\P{^Is_Numeric_Value=00_1}', "");
    Error('\p{Is_Nv=	:=+00_1}');
    Error('\P{Is_Nv=	:=+00_1}');
    Expect(1, 133418, '\p{Is_Nv=+000000001}', "");
    Expect(0, 133418, '\p{^Is_Nv=+000000001}', "");
    Expect(0, 133418, '\P{Is_Nv=+000000001}', "");
    Expect(1, 133418, '\P{^Is_Nv=+000000001}', "");
    Expect(0, 133419, '\p{Is_Nv=+000000001}', "");
    Expect(1, 133419, '\p{^Is_Nv=+000000001}', "");
    Expect(1, 133419, '\P{Is_Nv=+000000001}', "");
    Expect(0, 133419, '\P{^Is_Nv=+000000001}', "");
    Error('\p{Numeric_Value=:=00001/010}');
    Error('\P{Numeric_Value=:=00001/010}');
    Expect(1, 8530, '\p{Numeric_Value=001/00000000010}', "");
    Expect(0, 8530, '\p{^Numeric_Value=001/00000000010}', "");
    Expect(0, 8530, '\P{Numeric_Value=001/00000000010}', "");
    Expect(1, 8530, '\P{^Numeric_Value=001/00000000010}', "");
    Expect(0, 8531, '\p{Numeric_Value=001/00000000010}', "");
    Expect(1, 8531, '\p{^Numeric_Value=001/00000000010}', "");
    Expect(1, 8531, '\P{Numeric_Value=001/00000000010}', "");
    Expect(0, 8531, '\P{^Numeric_Value=001/00000000010}', "");
    Expect(1, 8530, '\p{Numeric_Value=0.100}', "");
    Expect(0, 8530, '\p{^Numeric_Value=0.100}', "");
    Expect(0, 8530, '\P{Numeric_Value=0.100}', "");
    Expect(1, 8530, '\P{^Numeric_Value=0.100}', "");
    Expect(0, 8531, '\p{Numeric_Value=0.100}', "");
    Expect(1, 8531, '\p{^Numeric_Value=0.100}', "");
    Expect(1, 8531, '\P{Numeric_Value=0.100}', "");
    Expect(0, 8531, '\P{^Numeric_Value=0.100}', "");
    Error('\p{Nv=:=_+1/0000000010}');
    Error('\P{Nv=:=_+1/0000000010}');
    Expect(1, 8530, '\p{Nv=01/000010}', "");
    Expect(0, 8530, '\p{^Nv=01/000010}', "");
    Expect(0, 8530, '\P{Nv=01/000010}', "");
    Expect(1, 8530, '\P{^Nv=01/000010}', "");
    Expect(0, 8531, '\p{Nv=01/000010}', "");
    Expect(1, 8531, '\p{^Nv=01/000010}', "");
    Expect(1, 8531, '\P{Nv=01/000010}', "");
    Expect(0, 8531, '\P{^Nv=01/000010}', "");
    Expect(1, 8530, '\p{Nv=0.100}', "");
    Expect(0, 8530, '\p{^Nv=0.100}', "");
    Expect(0, 8530, '\P{Nv=0.100}', "");
    Expect(1, 8530, '\P{^Nv=0.100}', "");
    Expect(0, 8531, '\p{Nv=0.100}', "");
    Expect(1, 8531, '\p{^Nv=0.100}', "");
    Expect(1, 8531, '\P{Nv=0.100}', "");
    Expect(0, 8531, '\P{^Nv=0.100}', "");
    Error('\p{Is_Numeric_Value=:=_+000000001/000000010}');
    Error('\P{Is_Numeric_Value=:=_+000000001/000000010}');
    Expect(1, 8530, '\p{Is_Numeric_Value=+000000001/00010}', "");
    Expect(0, 8530, '\p{^Is_Numeric_Value=+000000001/00010}', "");
    Expect(0, 8530, '\P{Is_Numeric_Value=+000000001/00010}', "");
    Expect(1, 8530, '\P{^Is_Numeric_Value=+000000001/00010}', "");
    Expect(0, 8531, '\p{Is_Numeric_Value=+000000001/00010}', "");
    Expect(1, 8531, '\p{^Is_Numeric_Value=+000000001/00010}', "");
    Expect(1, 8531, '\P{Is_Numeric_Value=+000000001/00010}', "");
    Expect(0, 8531, '\P{^Is_Numeric_Value=+000000001/00010}', "");
    Expect(1, 8530, '\p{Is_Numeric_Value=0.100}', "");
    Expect(0, 8530, '\p{^Is_Numeric_Value=0.100}', "");
    Expect(0, 8530, '\P{Is_Numeric_Value=0.100}', "");
    Expect(1, 8530, '\P{^Is_Numeric_Value=0.100}', "");
    Expect(0, 8531, '\p{Is_Numeric_Value=0.100}', "");
    Expect(1, 8531, '\p{^Is_Numeric_Value=0.100}', "");
    Expect(1, 8531, '\P{Is_Numeric_Value=0.100}', "");
    Expect(0, 8531, '\P{^Is_Numeric_Value=0.100}', "");
    Error('\p{Is_Nv=--000001/0000010:=}');
    Error('\P{Is_Nv=--000001/0000010:=}');
    Expect(1, 8530, '\p{Is_Nv=0000000001/10}', "");
    Expect(0, 8530, '\p{^Is_Nv=0000000001/10}', "");
    Expect(0, 8530, '\P{Is_Nv=0000000001/10}', "");
    Expect(1, 8530, '\P{^Is_Nv=0000000001/10}', "");
    Expect(0, 8531, '\p{Is_Nv=0000000001/10}', "");
    Expect(1, 8531, '\p{^Is_Nv=0000000001/10}', "");
    Expect(1, 8531, '\P{Is_Nv=0000000001/10}', "");
    Expect(0, 8531, '\P{^Is_Nv=0000000001/10}', "");
    Expect(1, 8530, '\p{Is_Nv=0.100}', "");
    Expect(0, 8530, '\p{^Is_Nv=0.100}', "");
    Expect(0, 8530, '\P{Is_Nv=0.100}', "");
    Expect(1, 8530, '\P{^Is_Nv=0.100}', "");
    Expect(0, 8531, '\p{Is_Nv=0.100}', "");
    Expect(1, 8531, '\p{^Is_Nv=0.100}', "");
    Expect(1, 8531, '\P{Is_Nv=0.100}', "");
    Expect(0, 8531, '\P{^Is_Nv=0.100}', "");
    Error('\p{Numeric_Value=:=-	+00000001/000012}');
    Error('\P{Numeric_Value=:=-	+00000001/000012}');
    Expect(1, 68086, '\p{Numeric_Value=000001/00000012}', "");
    Expect(0, 68086, '\p{^Numeric_Value=000001/00000012}', "");
    Expect(0, 68086, '\P{Numeric_Value=000001/00000012}', "");
    Expect(1, 68086, '\P{^Numeric_Value=000001/00000012}', "");
    Expect(0, 68087, '\p{Numeric_Value=000001/00000012}', "");
    Expect(1, 68087, '\p{^Numeric_Value=000001/00000012}', "");
    Expect(1, 68087, '\P{Numeric_Value=000001/00000012}', "");
    Expect(0, 68087, '\P{^Numeric_Value=000001/00000012}', "");
    Error('\p{Numeric_Value=0.08}');
    Error('\P{Numeric_Value=0.08}');
    Expect(1, 68086, '\p{Numeric_Value=0.083}', "");
    Expect(0, 68086, '\p{^Numeric_Value=0.083}', "");
    Expect(0, 68086, '\P{Numeric_Value=0.083}', "");
    Expect(1, 68086, '\P{^Numeric_Value=0.083}', "");
    Expect(0, 68087, '\p{Numeric_Value=0.083}', "");
    Expect(1, 68087, '\p{^Numeric_Value=0.083}', "");
    Expect(1, 68087, '\P{Numeric_Value=0.083}', "");
    Expect(0, 68087, '\P{^Numeric_Value=0.083}', "");
    Error('\p{Nv=/a/	 01/00012}');
    Error('\P{Nv=/a/	 01/00012}');
    Expect(1, 68086, '\p{Nv=0000001/000012}', "");
    Expect(0, 68086, '\p{^Nv=0000001/000012}', "");
    Expect(0, 68086, '\P{Nv=0000001/000012}', "");
    Expect(1, 68086, '\P{^Nv=0000001/000012}', "");
    Expect(0, 68087, '\p{Nv=0000001/000012}', "");
    Expect(1, 68087, '\p{^Nv=0000001/000012}', "");
    Expect(1, 68087, '\P{Nv=0000001/000012}', "");
    Expect(0, 68087, '\P{^Nv=0000001/000012}', "");
    Error('\p{Nv=0.08}');
    Error('\P{Nv=0.08}');
    Expect(1, 68086, '\p{Nv=0.083}', "");
    Expect(0, 68086, '\p{^Nv=0.083}', "");
    Expect(0, 68086, '\P{Nv=0.083}', "");
    Expect(1, 68086, '\P{^Nv=0.083}', "");
    Expect(0, 68087, '\p{Nv=0.083}', "");
    Expect(1, 68087, '\p{^Nv=0.083}', "");
    Expect(1, 68087, '\P{Nv=0.083}', "");
    Expect(0, 68087, '\P{^Nv=0.083}', "");
    Error('\p{Is_Numeric_Value= /a/0000001/00000012}');
    Error('\P{Is_Numeric_Value= /a/0000001/00000012}');
    Expect(1, 68086, '\p{Is_Numeric_Value:0001/0000012}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value:0001/0000012}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value:0001/0000012}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value:0001/0000012}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value:0001/0000012}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value:0001/0000012}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value:0001/0000012}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value:0001/0000012}', "");
    Error('\p{Is_Numeric_Value=0.08}');
    Error('\P{Is_Numeric_Value=0.08}');
    Expect(1, 68086, '\p{Is_Numeric_Value=0.083}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=0.083}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=0.083}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=0.083}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=0.083}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=0.083}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=0.083}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=0.083}', "");
    Error('\p{Is_Nv=:=0001/012}');
    Error('\P{Is_Nv=:=0001/012}');
    Expect(1, 68086, '\p{Is_Nv=000001/00000000012}', "");
    Expect(0, 68086, '\p{^Is_Nv=000001/00000000012}', "");
    Expect(0, 68086, '\P{Is_Nv=000001/00000000012}', "");
    Expect(1, 68086, '\P{^Is_Nv=000001/00000000012}', "");
    Expect(0, 68087, '\p{Is_Nv=000001/00000000012}', "");
    Expect(1, 68087, '\p{^Is_Nv=000001/00000000012}', "");
    Expect(1, 68087, '\P{Is_Nv=000001/00000000012}', "");
    Expect(0, 68087, '\P{^Is_Nv=000001/00000000012}', "");
    Error('\p{Is_Nv=0.08}');
    Error('\P{Is_Nv=0.08}');
    Expect(1, 68086, '\p{Is_Nv:	0.083}', "");
    Expect(0, 68086, '\p{^Is_Nv:	0.083}', "");
    Expect(0, 68086, '\P{Is_Nv:	0.083}', "");
    Expect(1, 68086, '\P{^Is_Nv:	0.083}', "");
    Expect(0, 68087, '\p{Is_Nv:	0.083}', "");
    Expect(1, 68087, '\p{^Is_Nv:	0.083}', "");
    Expect(1, 68087, '\P{Is_Nv:	0.083}', "");
    Expect(0, 68087, '\P{^Is_Nv:	0.083}', "");
    Error('\p{Numeric_Value=:= 	+000000001/16}');
    Error('\P{Numeric_Value=:= 	+000000001/16}');
    Expect(1, 43059, '\p{Numeric_Value=+000000001/000000016}', "");
    Expect(0, 43059, '\p{^Numeric_Value=+000000001/000000016}', "");
    Expect(0, 43059, '\P{Numeric_Value=+000000001/000000016}', "");
    Expect(1, 43059, '\P{^Numeric_Value=+000000001/000000016}', "");
    Expect(0, 43060, '\p{Numeric_Value=+000000001/000000016}', "");
    Expect(1, 43060, '\p{^Numeric_Value=+000000001/000000016}', "");
    Expect(1, 43060, '\P{Numeric_Value=+000000001/000000016}', "");
    Expect(0, 43060, '\P{^Numeric_Value=+000000001/000000016}', "");
    Error('\p{Numeric_Value=0.06}');
    Error('\P{Numeric_Value=0.06}');
    Expect(1, 43059, '\p{Numeric_Value=0.062}', "");
    Expect(0, 43059, '\p{^Numeric_Value=0.062}', "");
    Expect(0, 43059, '\P{Numeric_Value=0.062}', "");
    Expect(1, 43059, '\P{^Numeric_Value=0.062}', "");
    Expect(0, 43060, '\p{Numeric_Value=0.062}', "");
    Expect(1, 43060, '\p{^Numeric_Value=0.062}', "");
    Expect(1, 43060, '\P{Numeric_Value=0.062}', "");
    Expect(0, 43060, '\P{^Numeric_Value=0.062}', "");
    Error('\p{Nv=/a/	0001/00016}');
    Error('\P{Nv=/a/	0001/00016}');
    Expect(1, 43059, '\p{Nv=000000001/016}', "");
    Expect(0, 43059, '\p{^Nv=000000001/016}', "");
    Expect(0, 43059, '\P{Nv=000000001/016}', "");
    Expect(1, 43059, '\P{^Nv=000000001/016}', "");
    Expect(0, 43060, '\p{Nv=000000001/016}', "");
    Expect(1, 43060, '\p{^Nv=000000001/016}', "");
    Expect(1, 43060, '\P{Nv=000000001/016}', "");
    Expect(0, 43060, '\P{^Nv=000000001/016}', "");
    Error('\p{Nv=0.06}');
    Error('\P{Nv=0.06}');
    Expect(1, 43059, '\p{Nv=0.062}', "");
    Expect(0, 43059, '\p{^Nv=0.062}', "");
    Expect(0, 43059, '\P{Nv=0.062}', "");
    Expect(1, 43059, '\P{^Nv=0.062}', "");
    Expect(0, 43060, '\p{Nv=0.062}', "");
    Expect(1, 43060, '\p{^Nv=0.062}', "");
    Expect(1, 43060, '\P{Nv=0.062}', "");
    Expect(0, 43060, '\P{^Nv=0.062}', "");
    Error('\p{Is_Numeric_Value:	/a/	_000000001/00000016}');
    Error('\P{Is_Numeric_Value:	/a/	_000000001/00000016}');
    Expect(1, 43059, '\p{Is_Numeric_Value=000000001/00016}', "");
    Expect(0, 43059, '\p{^Is_Numeric_Value=000000001/00016}', "");
    Expect(0, 43059, '\P{Is_Numeric_Value=000000001/00016}', "");
    Expect(1, 43059, '\P{^Is_Numeric_Value=000000001/00016}', "");
    Expect(0, 43060, '\p{Is_Numeric_Value=000000001/00016}', "");
    Expect(1, 43060, '\p{^Is_Numeric_Value=000000001/00016}', "");
    Expect(1, 43060, '\P{Is_Numeric_Value=000000001/00016}', "");
    Expect(0, 43060, '\P{^Is_Numeric_Value=000000001/00016}', "");
    Error('\p{Is_Numeric_Value=0.06}');
    Error('\P{Is_Numeric_Value=0.06}');
    Expect(1, 43059, '\p{Is_Numeric_Value=0.062}', "");
    Expect(0, 43059, '\p{^Is_Numeric_Value=0.062}', "");
    Expect(0, 43059, '\P{Is_Numeric_Value=0.062}', "");
    Expect(1, 43059, '\P{^Is_Numeric_Value=0.062}', "");
    Expect(0, 43060, '\p{Is_Numeric_Value=0.062}', "");
    Expect(1, 43060, '\p{^Is_Numeric_Value=0.062}', "");
    Expect(1, 43060, '\P{Is_Numeric_Value=0.062}', "");
    Expect(0, 43060, '\P{^Is_Numeric_Value=0.062}', "");
    Error('\p{Is_Nv= -0001/00000000016/a/}');
    Error('\P{Is_Nv= -0001/00000000016/a/}');
    Expect(1, 43059, '\p{Is_Nv=1/016}', "");
    Expect(0, 43059, '\p{^Is_Nv=1/016}', "");
    Expect(0, 43059, '\P{Is_Nv=1/016}', "");
    Expect(1, 43059, '\P{^Is_Nv=1/016}', "");
    Expect(0, 43060, '\p{Is_Nv=1/016}', "");
    Expect(1, 43060, '\p{^Is_Nv=1/016}', "");
    Expect(1, 43060, '\P{Is_Nv=1/016}', "");
    Expect(0, 43060, '\P{^Is_Nv=1/016}', "");
    Error('\p{Is_Nv=0.06}');
    Error('\P{Is_Nv=0.06}');
    Expect(1, 43059, '\p{Is_Nv=0.062}', "");
    Expect(0, 43059, '\p{^Is_Nv=0.062}', "");
    Expect(0, 43059, '\P{Is_Nv=0.062}', "");
    Expect(1, 43059, '\P{^Is_Nv=0.062}', "");
    Expect(0, 43060, '\p{Is_Nv=0.062}', "");
    Expect(1, 43060, '\p{^Is_Nv=0.062}', "");
    Expect(1, 43060, '\P{Is_Nv=0.062}', "");
    Expect(0, 43060, '\P{^Is_Nv=0.062}', "");
    Error('\p{Numeric_Value=	:=+0000001/0160}');
    Error('\P{Numeric_Value=	:=+0000001/0160}');
    Expect(1, 3416, '\p{Numeric_Value=+00001/160}', "");
    Expect(0, 3416, '\p{^Numeric_Value=+00001/160}', "");
    Expect(0, 3416, '\P{Numeric_Value=+00001/160}', "");
    Expect(1, 3416, '\P{^Numeric_Value=+00001/160}', "");
    Expect(0, 3417, '\p{Numeric_Value=+00001/160}', "");
    Expect(1, 3417, '\p{^Numeric_Value=+00001/160}', "");
    Expect(1, 3417, '\P{Numeric_Value=+00001/160}', "");
    Expect(0, 3417, '\P{^Numeric_Value=+00001/160}', "");
    Error('\p{Numeric_Value=0.01}');
    Error('\P{Numeric_Value=0.01}');
    Expect(1, 3416, '\p{Numeric_Value=0.006}', "");
    Expect(0, 3416, '\p{^Numeric_Value=0.006}', "");
    Expect(0, 3416, '\P{Numeric_Value=0.006}', "");
    Expect(1, 3416, '\P{^Numeric_Value=0.006}', "");
    Expect(0, 3417, '\p{Numeric_Value=0.006}', "");
    Expect(1, 3417, '\p{^Numeric_Value=0.006}', "");
    Expect(1, 3417, '\P{Numeric_Value=0.006}', "");
    Expect(0, 3417, '\P{^Numeric_Value=0.006}', "");
    Error('\p{Nv=	1/000000000160:=}');
    Error('\P{Nv=	1/000000000160:=}');
    Expect(1, 3416, '\p{Nv:+001/0000000160}', "");
    Expect(0, 3416, '\p{^Nv:+001/0000000160}', "");
    Expect(0, 3416, '\P{Nv:+001/0000000160}', "");
    Expect(1, 3416, '\P{^Nv:+001/0000000160}', "");
    Expect(0, 3417, '\p{Nv:+001/0000000160}', "");
    Expect(1, 3417, '\p{^Nv:+001/0000000160}', "");
    Expect(1, 3417, '\P{Nv:+001/0000000160}', "");
    Expect(0, 3417, '\P{^Nv:+001/0000000160}', "");
    Error('\p{Nv=0.01}');
    Error('\P{Nv=0.01}');
    Expect(1, 3416, '\p{Nv=0.006}', "");
    Expect(0, 3416, '\p{^Nv=0.006}', "");
    Expect(0, 3416, '\P{Nv=0.006}', "");
    Expect(1, 3416, '\P{^Nv=0.006}', "");
    Expect(0, 3417, '\p{Nv=0.006}', "");
    Expect(1, 3417, '\p{^Nv=0.006}', "");
    Expect(1, 3417, '\P{Nv=0.006}', "");
    Expect(0, 3417, '\P{^Nv=0.006}', "");
    Error('\p{Is_Numeric_Value=:= _+00000001/000000000160}');
    Error('\P{Is_Numeric_Value=:= _+00000001/000000000160}');
    Expect(1, 3416, '\p{Is_Numeric_Value:   001/00160}', "");
    Expect(0, 3416, '\p{^Is_Numeric_Value:   001/00160}', "");
    Expect(0, 3416, '\P{Is_Numeric_Value:   001/00160}', "");
    Expect(1, 3416, '\P{^Is_Numeric_Value:   001/00160}', "");
    Expect(0, 3417, '\p{Is_Numeric_Value:   001/00160}', "");
    Expect(1, 3417, '\p{^Is_Numeric_Value:   001/00160}', "");
    Expect(1, 3417, '\P{Is_Numeric_Value:   001/00160}', "");
    Expect(0, 3417, '\P{^Is_Numeric_Value:   001/00160}', "");
    Error('\p{Is_Numeric_Value=0.01}');
    Error('\P{Is_Numeric_Value=0.01}');
    Expect(1, 3416, '\p{Is_Numeric_Value=0.006}', "");
    Expect(0, 3416, '\p{^Is_Numeric_Value=0.006}', "");
    Expect(0, 3416, '\P{Is_Numeric_Value=0.006}', "");
    Expect(1, 3416, '\P{^Is_Numeric_Value=0.006}', "");
    Expect(0, 3417, '\p{Is_Numeric_Value=0.006}', "");
    Expect(1, 3417, '\p{^Is_Numeric_Value=0.006}', "");
    Expect(1, 3417, '\P{Is_Numeric_Value=0.006}', "");
    Expect(0, 3417, '\P{^Is_Numeric_Value=0.006}', "");
    Error('\p{Is_Nv=/a/001/00160}');
    Error('\P{Is_Nv=/a/001/00160}');
    Expect(1, 3416, '\p{Is_Nv=00001/000160}', "");
    Expect(0, 3416, '\p{^Is_Nv=00001/000160}', "");
    Expect(0, 3416, '\P{Is_Nv=00001/000160}', "");
    Expect(1, 3416, '\P{^Is_Nv=00001/000160}', "");
    Expect(0, 3417, '\p{Is_Nv=00001/000160}', "");
    Expect(1, 3417, '\p{^Is_Nv=00001/000160}', "");
    Expect(1, 3417, '\P{Is_Nv=00001/000160}', "");
    Expect(0, 3417, '\P{^Is_Nv=00001/000160}', "");
    Error('\p{Is_Nv=0.01}');
    Error('\P{Is_Nv=0.01}');
    Expect(1, 3416, '\p{Is_Nv: 0.006}', "");
    Expect(0, 3416, '\p{^Is_Nv: 0.006}', "");
    Expect(0, 3416, '\P{Is_Nv: 0.006}', "");
    Expect(1, 3416, '\P{^Is_Nv: 0.006}', "");
    Expect(0, 3417, '\p{Is_Nv: 0.006}', "");
    Expect(1, 3417, '\p{^Is_Nv: 0.006}', "");
    Expect(1, 3417, '\P{Is_Nv: 0.006}', "");
    Expect(0, 3417, '\P{^Is_Nv: 0.006}', "");
    Error('\p{Numeric_Value=:=_	0000001/0000002}');
    Error('\P{Numeric_Value=:=_	0000001/0000002}');
    Expect(1, 74852, '\p{Numeric_Value=0000001/02}', "");
    Expect(0, 74852, '\p{^Numeric_Value=0000001/02}', "");
    Expect(0, 74852, '\P{Numeric_Value=0000001/02}', "");
    Expect(1, 74852, '\P{^Numeric_Value=0000001/02}', "");
    Expect(0, 74853, '\p{Numeric_Value=0000001/02}', "");
    Expect(1, 74853, '\p{^Numeric_Value=0000001/02}', "");
    Expect(1, 74853, '\P{Numeric_Value=0000001/02}', "");
    Expect(0, 74853, '\P{^Numeric_Value=0000001/02}', "");
    Expect(1, 74852, '\p{Numeric_Value=0.500}', "");
    Expect(0, 74852, '\p{^Numeric_Value=0.500}', "");
    Expect(0, 74852, '\P{Numeric_Value=0.500}', "");
    Expect(1, 74852, '\P{^Numeric_Value=0.500}', "");
    Expect(0, 74853, '\p{Numeric_Value=0.500}', "");
    Expect(1, 74853, '\p{^Numeric_Value=0.500}', "");
    Expect(1, 74853, '\P{Numeric_Value=0.500}', "");
    Expect(0, 74853, '\P{^Numeric_Value=0.500}', "");
    Error('\p{Nv=_-+000001/2:=}');
    Error('\P{Nv=_-+000001/2:=}');
    Expect(1, 74852, '\p{Nv=1/02}', "");
    Expect(0, 74852, '\p{^Nv=1/02}', "");
    Expect(0, 74852, '\P{Nv=1/02}', "");
    Expect(1, 74852, '\P{^Nv=1/02}', "");
    Expect(0, 74853, '\p{Nv=1/02}', "");
    Expect(1, 74853, '\p{^Nv=1/02}', "");
    Expect(1, 74853, '\P{Nv=1/02}', "");
    Expect(0, 74853, '\P{^Nv=1/02}', "");
    Expect(1, 74852, '\p{Nv=0.500}', "");
    Expect(0, 74852, '\p{^Nv=0.500}', "");
    Expect(0, 74852, '\P{Nv=0.500}', "");
    Expect(1, 74852, '\P{^Nv=0.500}', "");
    Expect(0, 74853, '\p{Nv=0.500}', "");
    Expect(1, 74853, '\p{^Nv=0.500}', "");
    Expect(1, 74853, '\P{Nv=0.500}', "");
    Expect(0, 74853, '\P{^Nv=0.500}', "");
    Error('\p{Is_Numeric_Value=_/a/+1/0000000002}');
    Error('\P{Is_Numeric_Value=_/a/+1/0000000002}');
    Expect(1, 74852, '\p{Is_Numeric_Value:000001/00000002}', "");
    Expect(0, 74852, '\p{^Is_Numeric_Value:000001/00000002}', "");
    Expect(0, 74852, '\P{Is_Numeric_Value:000001/00000002}', "");
    Expect(1, 74852, '\P{^Is_Numeric_Value:000001/00000002}', "");
    Expect(0, 74853, '\p{Is_Numeric_Value:000001/00000002}', "");
    Expect(1, 74853, '\p{^Is_Numeric_Value:000001/00000002}', "");
    Expect(1, 74853, '\P{Is_Numeric_Value:000001/00000002}', "");
    Expect(0, 74853, '\P{^Is_Numeric_Value:000001/00000002}', "");
    Expect(1, 74852, '\p{Is_Numeric_Value=0.500}', "");
    Expect(0, 74852, '\p{^Is_Numeric_Value=0.500}', "");
    Expect(0, 74852, '\P{Is_Numeric_Value=0.500}', "");
    Expect(1, 74852, '\P{^Is_Numeric_Value=0.500}', "");
    Expect(0, 74853, '\p{Is_Numeric_Value=0.500}', "");
    Expect(1, 74853, '\p{^Is_Numeric_Value=0.500}', "");
    Expect(1, 74853, '\P{Is_Numeric_Value=0.500}', "");
    Expect(0, 74853, '\P{^Is_Numeric_Value=0.500}', "");
    Error('\p{Is_Nv=_	+00001/000002:=}');
    Error('\P{Is_Nv=_	+00001/000002:=}');
    Expect(1, 74852, '\p{Is_Nv=0001/00000002}', "");
    Expect(0, 74852, '\p{^Is_Nv=0001/00000002}', "");
    Expect(0, 74852, '\P{Is_Nv=0001/00000002}', "");
    Expect(1, 74852, '\P{^Is_Nv=0001/00000002}', "");
    Expect(0, 74853, '\p{Is_Nv=0001/00000002}', "");
    Expect(1, 74853, '\p{^Is_Nv=0001/00000002}', "");
    Expect(1, 74853, '\P{Is_Nv=0001/00000002}', "");
    Expect(0, 74853, '\P{^Is_Nv=0001/00000002}', "");
    Expect(1, 74852, '\p{Is_Nv:	0.500}', "");
    Expect(0, 74852, '\p{^Is_Nv:	0.500}', "");
    Expect(0, 74852, '\P{Is_Nv:	0.500}', "");
    Expect(1, 74852, '\P{^Is_Nv:	0.500}', "");
    Expect(0, 74853, '\p{Is_Nv:	0.500}', "");
    Expect(1, 74853, '\p{^Is_Nv:	0.500}', "");
    Expect(1, 74853, '\P{Is_Nv:	0.500}', "");
    Expect(0, 74853, '\P{^Is_Nv:	0.500}', "");
    Error('\p{Numeric_Value=/a/+00001/00000020}');
    Error('\P{Numeric_Value=/a/+00001/00000020}');
    Expect(1, 3419, '\p{Numeric_Value=1/00000000020}', "");
    Expect(0, 3419, '\p{^Numeric_Value=1/00000000020}', "");
    Expect(0, 3419, '\P{Numeric_Value=1/00000000020}', "");
    Expect(1, 3419, '\P{^Numeric_Value=1/00000000020}', "");
    Expect(0, 3420, '\p{Numeric_Value=1/00000000020}', "");
    Expect(1, 3420, '\p{^Numeric_Value=1/00000000020}', "");
    Expect(1, 3420, '\P{Numeric_Value=1/00000000020}', "");
    Expect(0, 3420, '\P{^Numeric_Value=1/00000000020}', "");
    Expect(1, 3419, '\p{Numeric_Value=0.050}', "");
    Expect(0, 3419, '\p{^Numeric_Value=0.050}', "");
    Expect(0, 3419, '\P{Numeric_Value=0.050}', "");
    Expect(1, 3419, '\P{^Numeric_Value=0.050}', "");
    Expect(0, 3420, '\p{Numeric_Value=0.050}', "");
    Expect(1, 3420, '\p{^Numeric_Value=0.050}', "");
    Expect(1, 3420, '\P{Numeric_Value=0.050}', "");
    Expect(0, 3420, '\P{^Numeric_Value=0.050}', "");
    Error('\p{Nv=:=-	+01/000020}');
    Error('\P{Nv=:=-	+01/000020}');
    Expect(1, 3419, '\p{Nv:   000001/0000020}', "");
    Expect(0, 3419, '\p{^Nv:   000001/0000020}', "");
    Expect(0, 3419, '\P{Nv:   000001/0000020}', "");
    Expect(1, 3419, '\P{^Nv:   000001/0000020}', "");
    Expect(0, 3420, '\p{Nv:   000001/0000020}', "");
    Expect(1, 3420, '\p{^Nv:   000001/0000020}', "");
    Expect(1, 3420, '\P{Nv:   000001/0000020}', "");
    Expect(0, 3420, '\P{^Nv:   000001/0000020}', "");
    Expect(1, 3419, '\p{Nv=0.050}', "");
    Expect(0, 3419, '\p{^Nv=0.050}', "");
    Expect(0, 3419, '\P{Nv=0.050}', "");
    Expect(1, 3419, '\P{^Nv=0.050}', "");
    Expect(0, 3420, '\p{Nv=0.050}', "");
    Expect(1, 3420, '\p{^Nv=0.050}', "");
    Expect(1, 3420, '\P{Nv=0.050}', "");
    Expect(0, 3420, '\P{^Nv=0.050}', "");
    Error('\p{Is_Numeric_Value=:= 0000000001/020}');
    Error('\P{Is_Numeric_Value=:= 0000000001/020}');
    Expect(1, 3419, '\p{Is_Numeric_Value=00000001/20}', "");
    Expect(0, 3419, '\p{^Is_Numeric_Value=00000001/20}', "");
    Expect(0, 3419, '\P{Is_Numeric_Value=00000001/20}', "");
    Expect(1, 3419, '\P{^Is_Numeric_Value=00000001/20}', "");
    Expect(0, 3420, '\p{Is_Numeric_Value=00000001/20}', "");
    Expect(1, 3420, '\p{^Is_Numeric_Value=00000001/20}', "");
    Expect(1, 3420, '\P{Is_Numeric_Value=00000001/20}', "");
    Expect(0, 3420, '\P{^Is_Numeric_Value=00000001/20}', "");
    Expect(1, 3419, '\p{Is_Numeric_Value=0.050}', "");
    Expect(0, 3419, '\p{^Is_Numeric_Value=0.050}', "");
    Expect(0, 3419, '\P{Is_Numeric_Value=0.050}', "");
    Expect(1, 3419, '\P{^Is_Numeric_Value=0.050}', "");
    Expect(0, 3420, '\p{Is_Numeric_Value=0.050}', "");
    Expect(1, 3420, '\p{^Is_Numeric_Value=0.050}', "");
    Expect(1, 3420, '\P{Is_Numeric_Value=0.050}', "");
    Expect(0, 3420, '\P{^Is_Numeric_Value=0.050}', "");
    Error('\p{Is_Nv= _000001/00020/a/}');
    Error('\P{Is_Nv= _000001/00020/a/}');
    Expect(1, 3419, '\p{Is_Nv=0001/00000020}', "");
    Expect(0, 3419, '\p{^Is_Nv=0001/00000020}', "");
    Expect(0, 3419, '\P{Is_Nv=0001/00000020}', "");
    Expect(1, 3419, '\P{^Is_Nv=0001/00000020}', "");
    Expect(0, 3420, '\p{Is_Nv=0001/00000020}', "");
    Expect(1, 3420, '\p{^Is_Nv=0001/00000020}', "");
    Expect(1, 3420, '\P{Is_Nv=0001/00000020}', "");
    Expect(0, 3420, '\P{^Is_Nv=0001/00000020}', "");
    Expect(1, 3419, '\p{Is_Nv=0.050}', "");
    Expect(0, 3419, '\p{^Is_Nv=0.050}', "");
    Expect(0, 3419, '\P{Is_Nv=0.050}', "");
    Expect(1, 3419, '\P{^Is_Nv=0.050}', "");
    Expect(0, 3420, '\p{Is_Nv=0.050}', "");
    Expect(1, 3420, '\p{^Is_Nv=0.050}', "");
    Expect(1, 3420, '\P{Is_Nv=0.050}', "");
    Expect(0, 3420, '\P{^Is_Nv=0.050}', "");
    Error('\p{Numeric_Value=--+00001/00000003:=}');
    Error('\P{Numeric_Value=--+00001/00000003:=}');
    Expect(1, 74853, '\p{Numeric_Value=01/003}', "");
    Expect(0, 74853, '\p{^Numeric_Value=01/003}', "");
    Expect(0, 74853, '\P{Numeric_Value=01/003}', "");
    Expect(1, 74853, '\P{^Numeric_Value=01/003}', "");
    Expect(0, 74854, '\p{Numeric_Value=01/003}', "");
    Expect(1, 74854, '\p{^Numeric_Value=01/003}', "");
    Expect(1, 74854, '\P{Numeric_Value=01/003}', "");
    Expect(0, 74854, '\P{^Numeric_Value=01/003}', "");
    Error('\p{Numeric_Value=0.3}');
    Error('\P{Numeric_Value=0.3}');
    Error('\p{Numeric_Value=0.33}');
    Error('\P{Numeric_Value=0.33}');
    Expect(1, 74853, '\p{Numeric_Value=0.333}', "");
    Expect(0, 74853, '\p{^Numeric_Value=0.333}', "");
    Expect(0, 74853, '\P{Numeric_Value=0.333}', "");
    Expect(1, 74853, '\P{^Numeric_Value=0.333}', "");
    Expect(0, 74854, '\p{Numeric_Value=0.333}', "");
    Expect(1, 74854, '\p{^Numeric_Value=0.333}', "");
    Expect(1, 74854, '\P{Numeric_Value=0.333}', "");
    Expect(0, 74854, '\P{^Numeric_Value=0.333}', "");
    Error('\p{Nv=/a/-	+01/000003}');
    Error('\P{Nv=/a/-	+01/000003}');
    Expect(1, 74853, '\p{Nv=00001/03}', "");
    Expect(0, 74853, '\p{^Nv=00001/03}', "");
    Expect(0, 74853, '\P{Nv=00001/03}', "");
    Expect(1, 74853, '\P{^Nv=00001/03}', "");
    Expect(0, 74854, '\p{Nv=00001/03}', "");
    Expect(1, 74854, '\p{^Nv=00001/03}', "");
    Expect(1, 74854, '\P{Nv=00001/03}', "");
    Expect(0, 74854, '\P{^Nv=00001/03}', "");
    Error('\p{Nv=0.3}');
    Error('\P{Nv=0.3}');
    Error('\p{Nv=0.33}');
    Error('\P{Nv=0.33}');
    Expect(1, 74853, '\p{Nv=0.333}', "");
    Expect(0, 74853, '\p{^Nv=0.333}', "");
    Expect(0, 74853, '\P{Nv=0.333}', "");
    Expect(1, 74853, '\P{^Nv=0.333}', "");
    Expect(0, 74854, '\p{Nv=0.333}', "");
    Expect(1, 74854, '\p{^Nv=0.333}', "");
    Expect(1, 74854, '\P{Nv=0.333}', "");
    Expect(0, 74854, '\P{^Nv=0.333}', "");
    Error('\p{Is_Numeric_Value=:=- 001/0000000003}');
    Error('\P{Is_Numeric_Value=:=- 001/0000000003}');
    Expect(1, 74853, '\p{Is_Numeric_Value=+000001/3}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value=+000001/3}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value=+000001/3}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value=+000001/3}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value=+000001/3}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value=+000001/3}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value=+000001/3}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value=+000001/3}', "");
    Error('\p{Is_Numeric_Value=0.3}');
    Error('\P{Is_Numeric_Value=0.3}');
    Error('\p{Is_Numeric_Value=0.33}');
    Error('\P{Is_Numeric_Value=0.33}');
    Expect(1, 74853, '\p{Is_Numeric_Value:   0.333}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value:   0.333}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value:   0.333}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value:   0.333}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value:   0.333}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value:   0.333}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value:   0.333}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value:   0.333}', "");
    Error('\p{Is_Nv=0000001/00003/a/}');
    Error('\P{Is_Nv=0000001/00003/a/}');
    Expect(1, 74853, '\p{Is_Nv=+000000001/3}', "");
    Expect(0, 74853, '\p{^Is_Nv=+000000001/3}', "");
    Expect(0, 74853, '\P{Is_Nv=+000000001/3}', "");
    Expect(1, 74853, '\P{^Is_Nv=+000000001/3}', "");
    Expect(0, 74854, '\p{Is_Nv=+000000001/3}', "");
    Expect(1, 74854, '\p{^Is_Nv=+000000001/3}', "");
    Expect(1, 74854, '\P{Is_Nv=+000000001/3}', "");
    Expect(0, 74854, '\P{^Is_Nv=+000000001/3}', "");
    Error('\p{Is_Nv=0.3}');
    Error('\P{Is_Nv=0.3}');
    Error('\p{Is_Nv=0.33}');
    Error('\P{Is_Nv=0.33}');
    Expect(1, 74853, '\p{Is_Nv=0.333}', "");
    Expect(0, 74853, '\p{^Is_Nv=0.333}', "");
    Expect(0, 74853, '\P{Is_Nv=0.333}', "");
    Expect(1, 74853, '\P{^Is_Nv=0.333}', "");
    Expect(0, 74854, '\p{Is_Nv=0.333}', "");
    Expect(1, 74854, '\p{^Is_Nv=0.333}', "");
    Expect(1, 74854, '\P{Is_Nv=0.333}', "");
    Expect(0, 74854, '\P{^Is_Nv=0.333}', "");
    Error('\p{Numeric_Value=:=	-0000001/004}');
    Error('\P{Numeric_Value=:=	-0000001/004}');
    Expect(1, 74851, '\p{Numeric_Value=00000001/0000004}', "");
    Expect(0, 74851, '\p{^Numeric_Value=00000001/0000004}', "");
    Expect(0, 74851, '\P{Numeric_Value=00000001/0000004}', "");
    Expect(1, 74851, '\P{^Numeric_Value=00000001/0000004}', "");
    Expect(0, 74852, '\p{Numeric_Value=00000001/0000004}', "");
    Expect(1, 74852, '\p{^Numeric_Value=00000001/0000004}', "");
    Expect(1, 74852, '\P{Numeric_Value=00000001/0000004}', "");
    Expect(0, 74852, '\P{^Numeric_Value=00000001/0000004}', "");
    Expect(1, 74851, '\p{Numeric_Value=0.250}', "");
    Expect(0, 74851, '\p{^Numeric_Value=0.250}', "");
    Expect(0, 74851, '\P{Numeric_Value=0.250}', "");
    Expect(1, 74851, '\P{^Numeric_Value=0.250}', "");
    Expect(0, 74852, '\p{Numeric_Value=0.250}', "");
    Expect(1, 74852, '\p{^Numeric_Value=0.250}', "");
    Expect(1, 74852, '\P{Numeric_Value=0.250}', "");
    Expect(0, 74852, '\P{^Numeric_Value=0.250}', "");
    Error('\p{Nv=_ 00001/00000004:=}');
    Error('\P{Nv=_ 00001/00000004:=}');
    Expect(1, 74851, '\p{Nv=000001/04}', "");
    Expect(0, 74851, '\p{^Nv=000001/04}', "");
    Expect(0, 74851, '\P{Nv=000001/04}', "");
    Expect(1, 74851, '\P{^Nv=000001/04}', "");
    Expect(0, 74852, '\p{Nv=000001/04}', "");
    Expect(1, 74852, '\p{^Nv=000001/04}', "");
    Expect(1, 74852, '\P{Nv=000001/04}', "");
    Expect(0, 74852, '\P{^Nv=000001/04}', "");
    Expect(1, 74851, '\p{Nv=0.250}', "");
    Expect(0, 74851, '\p{^Nv=0.250}', "");
    Expect(0, 74851, '\P{Nv=0.250}', "");
    Expect(1, 74851, '\P{^Nv=0.250}', "");
    Expect(0, 74852, '\p{Nv=0.250}', "");
    Expect(1, 74852, '\p{^Nv=0.250}', "");
    Expect(1, 74852, '\P{Nv=0.250}', "");
    Expect(0, 74852, '\P{^Nv=0.250}', "");
    Error('\p{Is_Numeric_Value=-	001/000004/a/}');
    Error('\P{Is_Numeric_Value=-	001/000004/a/}');
    Expect(1, 74851, '\p{Is_Numeric_Value=00001/0004}', "");
    Expect(0, 74851, '\p{^Is_Numeric_Value=00001/0004}', "");
    Expect(0, 74851, '\P{Is_Numeric_Value=00001/0004}', "");
    Expect(1, 74851, '\P{^Is_Numeric_Value=00001/0004}', "");
    Expect(0, 74852, '\p{Is_Numeric_Value=00001/0004}', "");
    Expect(1, 74852, '\p{^Is_Numeric_Value=00001/0004}', "");
    Expect(1, 74852, '\P{Is_Numeric_Value=00001/0004}', "");
    Expect(0, 74852, '\P{^Is_Numeric_Value=00001/0004}', "");
    Expect(1, 74851, '\p{Is_Numeric_Value=0.250}', "");
    Expect(0, 74851, '\p{^Is_Numeric_Value=0.250}', "");
    Expect(0, 74851, '\P{Is_Numeric_Value=0.250}', "");
    Expect(1, 74851, '\P{^Is_Numeric_Value=0.250}', "");
    Expect(0, 74852, '\p{Is_Numeric_Value=0.250}', "");
    Expect(1, 74852, '\p{^Is_Numeric_Value=0.250}', "");
    Expect(1, 74852, '\P{Is_Numeric_Value=0.250}', "");
    Expect(0, 74852, '\P{^Is_Numeric_Value=0.250}', "");
    Error('\p{Is_Nv=_-00000001/04:=}');
    Error('\P{Is_Nv=_-00000001/04:=}');
    Expect(1, 74851, '\p{Is_Nv=1/00004}', "");
    Expect(0, 74851, '\p{^Is_Nv=1/00004}', "");
    Expect(0, 74851, '\P{Is_Nv=1/00004}', "");
    Expect(1, 74851, '\P{^Is_Nv=1/00004}', "");
    Expect(0, 74852, '\p{Is_Nv=1/00004}', "");
    Expect(1, 74852, '\p{^Is_Nv=1/00004}', "");
    Expect(1, 74852, '\P{Is_Nv=1/00004}', "");
    Expect(0, 74852, '\P{^Is_Nv=1/00004}', "");
    Expect(1, 74851, '\p{Is_Nv=0.250}', "");
    Expect(0, 74851, '\p{^Is_Nv=0.250}', "");
    Expect(0, 74851, '\P{Is_Nv=0.250}', "");
    Expect(1, 74851, '\P{^Is_Nv=0.250}', "");
    Expect(0, 74852, '\p{Is_Nv=0.250}', "");
    Expect(1, 74852, '\p{^Is_Nv=0.250}', "");
    Expect(1, 74852, '\P{Is_Nv=0.250}', "");
    Expect(0, 74852, '\P{^Is_Nv=0.250}', "");
    Error('\p{Numeric_Value=:=-_00001/0040}');
    Error('\P{Numeric_Value=:=-_00001/0040}');
    Expect(1, 3417, '\p{Numeric_Value=00000001/00040}', "");
    Expect(0, 3417, '\p{^Numeric_Value=00000001/00040}', "");
    Expect(0, 3417, '\P{Numeric_Value=00000001/00040}', "");
    Expect(1, 3417, '\P{^Numeric_Value=00000001/00040}', "");
    Expect(0, 3418, '\p{Numeric_Value=00000001/00040}', "");
    Expect(1, 3418, '\p{^Numeric_Value=00000001/00040}', "");
    Expect(1, 3418, '\P{Numeric_Value=00000001/00040}', "");
    Expect(0, 3418, '\P{^Numeric_Value=00000001/00040}', "");
    Error('\p{Numeric_Value=0.03}');
    Error('\P{Numeric_Value=0.03}');
    Expect(1, 3417, '\p{Numeric_Value=0.025}', "");
    Expect(0, 3417, '\p{^Numeric_Value=0.025}', "");
    Expect(0, 3417, '\P{Numeric_Value=0.025}', "");
    Expect(1, 3417, '\P{^Numeric_Value=0.025}', "");
    Expect(0, 3418, '\p{Numeric_Value=0.025}', "");
    Expect(1, 3418, '\p{^Numeric_Value=0.025}', "");
    Expect(1, 3418, '\P{Numeric_Value=0.025}', "");
    Expect(0, 3418, '\P{^Numeric_Value=0.025}', "");
    Error('\p{Nv=-+0001/0000000040:=}');
    Error('\P{Nv=-+0001/0000000040:=}');
    Expect(1, 3417, '\p{Nv=000001/000040}', "");
    Expect(0, 3417, '\p{^Nv=000001/000040}', "");
    Expect(0, 3417, '\P{Nv=000001/000040}', "");
    Expect(1, 3417, '\P{^Nv=000001/000040}', "");
    Expect(0, 3418, '\p{Nv=000001/000040}', "");
    Expect(1, 3418, '\p{^Nv=000001/000040}', "");
    Expect(1, 3418, '\P{Nv=000001/000040}', "");
    Expect(0, 3418, '\P{^Nv=000001/000040}', "");
    Error('\p{Nv=0.03}');
    Error('\P{Nv=0.03}');
    Expect(1, 3417, '\p{Nv=0.025}', "");
    Expect(0, 3417, '\p{^Nv=0.025}', "");
    Expect(0, 3417, '\P{Nv=0.025}', "");
    Expect(1, 3417, '\P{^Nv=0.025}', "");
    Expect(0, 3418, '\p{Nv=0.025}', "");
    Expect(1, 3418, '\p{^Nv=0.025}', "");
    Expect(1, 3418, '\P{Nv=0.025}', "");
    Expect(0, 3418, '\P{^Nv=0.025}', "");
    Error('\p{Is_Numeric_Value= :=01/00000000040}');
    Error('\P{Is_Numeric_Value= :=01/00000000040}');
    Expect(1, 3417, '\p{Is_Numeric_Value=00000001/0000000040}', "");
    Expect(0, 3417, '\p{^Is_Numeric_Value=00000001/0000000040}', "");
    Expect(0, 3417, '\P{Is_Numeric_Value=00000001/0000000040}', "");
    Expect(1, 3417, '\P{^Is_Numeric_Value=00000001/0000000040}', "");
    Expect(0, 3418, '\p{Is_Numeric_Value=00000001/0000000040}', "");
    Expect(1, 3418, '\p{^Is_Numeric_Value=00000001/0000000040}', "");
    Expect(1, 3418, '\P{Is_Numeric_Value=00000001/0000000040}', "");
    Expect(0, 3418, '\P{^Is_Numeric_Value=00000001/0000000040}', "");
    Error('\p{Is_Numeric_Value=0.03}');
    Error('\P{Is_Numeric_Value=0.03}');
    Expect(1, 3417, '\p{Is_Numeric_Value=0.025}', "");
    Expect(0, 3417, '\p{^Is_Numeric_Value=0.025}', "");
    Expect(0, 3417, '\P{Is_Numeric_Value=0.025}', "");
    Expect(1, 3417, '\P{^Is_Numeric_Value=0.025}', "");
    Expect(0, 3418, '\p{Is_Numeric_Value=0.025}', "");
    Expect(1, 3418, '\p{^Is_Numeric_Value=0.025}', "");
    Expect(1, 3418, '\P{Is_Numeric_Value=0.025}', "");
    Expect(0, 3418, '\P{^Is_Numeric_Value=0.025}', "");
    Error('\p{Is_Nv:	 _+0000001/00000000040/a/}');
    Error('\P{Is_Nv:	 _+0000001/00000000040/a/}');
    Expect(1, 3417, '\p{Is_Nv=+00000001/040}', "");
    Expect(0, 3417, '\p{^Is_Nv=+00000001/040}', "");
    Expect(0, 3417, '\P{Is_Nv=+00000001/040}', "");
    Expect(1, 3417, '\P{^Is_Nv=+00000001/040}', "");
    Expect(0, 3418, '\p{Is_Nv=+00000001/040}', "");
    Expect(1, 3418, '\p{^Is_Nv=+00000001/040}', "");
    Expect(1, 3418, '\P{Is_Nv=+00000001/040}', "");
    Expect(0, 3418, '\P{^Is_Nv=+00000001/040}', "");
    Error('\p{Is_Nv=0.03}');
    Error('\P{Is_Nv=0.03}');
    Expect(1, 3417, '\p{Is_Nv=0.025}', "");
    Expect(0, 3417, '\p{^Is_Nv=0.025}', "");
    Expect(0, 3417, '\P{Is_Nv=0.025}', "");
    Expect(1, 3417, '\P{^Is_Nv=0.025}', "");
    Expect(0, 3418, '\p{Is_Nv=0.025}', "");
    Expect(1, 3418, '\p{^Is_Nv=0.025}', "");
    Expect(1, 3418, '\P{Is_Nv=0.025}', "");
    Expect(0, 3418, '\P{^Is_Nv=0.025}', "");
    Error('\p{Numeric_Value=-/a/000001/000005}');
    Error('\P{Numeric_Value=-/a/000001/000005}');
    Expect(1, 8533, '\p{Numeric_Value=+001/005}', "");
    Expect(0, 8533, '\p{^Numeric_Value=+001/005}', "");
    Expect(0, 8533, '\P{Numeric_Value=+001/005}', "");
    Expect(1, 8533, '\P{^Numeric_Value=+001/005}', "");
    Expect(0, 8534, '\p{Numeric_Value=+001/005}', "");
    Expect(1, 8534, '\p{^Numeric_Value=+001/005}', "");
    Expect(1, 8534, '\P{Numeric_Value=+001/005}', "");
    Expect(0, 8534, '\P{^Numeric_Value=+001/005}', "");
    Expect(1, 8533, '\p{Numeric_Value=0.200}', "");
    Expect(0, 8533, '\p{^Numeric_Value=0.200}', "");
    Expect(0, 8533, '\P{Numeric_Value=0.200}', "");
    Expect(1, 8533, '\P{^Numeric_Value=0.200}', "");
    Expect(0, 8534, '\p{Numeric_Value=0.200}', "");
    Expect(1, 8534, '\p{^Numeric_Value=0.200}', "");
    Expect(1, 8534, '\P{Numeric_Value=0.200}', "");
    Expect(0, 8534, '\P{^Numeric_Value=0.200}', "");
    Error('\p{Nv=--+1/00005:=}');
    Error('\P{Nv=--+1/00005:=}');
    Expect(1, 8533, '\p{Nv=00000001/0005}', "");
    Expect(0, 8533, '\p{^Nv=00000001/0005}', "");
    Expect(0, 8533, '\P{Nv=00000001/0005}', "");
    Expect(1, 8533, '\P{^Nv=00000001/0005}', "");
    Expect(0, 8534, '\p{Nv=00000001/0005}', "");
    Expect(1, 8534, '\p{^Nv=00000001/0005}', "");
    Expect(1, 8534, '\P{Nv=00000001/0005}', "");
    Expect(0, 8534, '\P{^Nv=00000001/0005}', "");
    Expect(1, 8533, '\p{Nv=0.200}', "");
    Expect(0, 8533, '\p{^Nv=0.200}', "");
    Expect(0, 8533, '\P{Nv=0.200}', "");
    Expect(1, 8533, '\P{^Nv=0.200}', "");
    Expect(0, 8534, '\p{Nv=0.200}', "");
    Expect(1, 8534, '\p{^Nv=0.200}', "");
    Expect(1, 8534, '\P{Nv=0.200}', "");
    Expect(0, 8534, '\P{^Nv=0.200}', "");
    Error('\p{Is_Numeric_Value=/a/1/0005}');
    Error('\P{Is_Numeric_Value=/a/1/0005}');
    Expect(1, 8533, '\p{Is_Numeric_Value=00000001/0000005}', "");
    Expect(0, 8533, '\p{^Is_Numeric_Value=00000001/0000005}', "");
    Expect(0, 8533, '\P{Is_Numeric_Value=00000001/0000005}', "");
    Expect(1, 8533, '\P{^Is_Numeric_Value=00000001/0000005}', "");
    Expect(0, 8534, '\p{Is_Numeric_Value=00000001/0000005}', "");
    Expect(1, 8534, '\p{^Is_Numeric_Value=00000001/0000005}', "");
    Expect(1, 8534, '\P{Is_Numeric_Value=00000001/0000005}', "");
    Expect(0, 8534, '\P{^Is_Numeric_Value=00000001/0000005}', "");
    Expect(1, 8533, '\p{Is_Numeric_Value=0.200}', "");
    Expect(0, 8533, '\p{^Is_Numeric_Value=0.200}', "");
    Expect(0, 8533, '\P{Is_Numeric_Value=0.200}', "");
    Expect(1, 8533, '\P{^Is_Numeric_Value=0.200}', "");
    Expect(0, 8534, '\p{Is_Numeric_Value=0.200}', "");
    Expect(1, 8534, '\p{^Is_Numeric_Value=0.200}', "");
    Expect(1, 8534, '\P{Is_Numeric_Value=0.200}', "");
    Expect(0, 8534, '\P{^Is_Numeric_Value=0.200}', "");
    Error('\p{Is_Nv:		/a/000001/005}');
    Error('\P{Is_Nv:		/a/000001/005}');
    Expect(1, 8533, '\p{Is_Nv=0001/05}', "");
    Expect(0, 8533, '\p{^Is_Nv=0001/05}', "");
    Expect(0, 8533, '\P{Is_Nv=0001/05}', "");
    Expect(1, 8533, '\P{^Is_Nv=0001/05}', "");
    Expect(0, 8534, '\p{Is_Nv=0001/05}', "");
    Expect(1, 8534, '\p{^Is_Nv=0001/05}', "");
    Expect(1, 8534, '\P{Is_Nv=0001/05}', "");
    Expect(0, 8534, '\P{^Is_Nv=0001/05}', "");
    Expect(1, 8533, '\p{Is_Nv=0.200}', "");
    Expect(0, 8533, '\p{^Is_Nv=0.200}', "");
    Expect(0, 8533, '\P{Is_Nv=0.200}', "");
    Expect(1, 8533, '\P{^Is_Nv=0.200}', "");
    Expect(0, 8534, '\p{Is_Nv=0.200}', "");
    Expect(1, 8534, '\p{^Is_Nv=0.200}', "");
    Expect(1, 8534, '\P{Is_Nv=0.200}', "");
    Expect(0, 8534, '\P{^Is_Nv=0.200}', "");
    Error('\p{Numeric_Value=-_00001/00000006/a/}');
    Error('\P{Numeric_Value=-_00001/00000006/a/}');
    Expect(1, 74849, '\p{Numeric_Value=0000000001/000000006}', "");
    Expect(0, 74849, '\p{^Numeric_Value=0000000001/000000006}', "");
    Expect(0, 74849, '\P{Numeric_Value=0000000001/000000006}', "");
    Expect(1, 74849, '\P{^Numeric_Value=0000000001/000000006}', "");
    Expect(0, 74850, '\p{Numeric_Value=0000000001/000000006}', "");
    Expect(1, 74850, '\p{^Numeric_Value=0000000001/000000006}', "");
    Expect(1, 74850, '\P{Numeric_Value=0000000001/000000006}', "");
    Expect(0, 74850, '\P{^Numeric_Value=0000000001/000000006}', "");
    Error('\p{Numeric_Value: 0.17}');
    Error('\P{Numeric_Value: 0.17}');
    Expect(1, 74849, '\p{Numeric_Value: 0.167}', "");
    Expect(0, 74849, '\p{^Numeric_Value: 0.167}', "");
    Expect(0, 74849, '\P{Numeric_Value: 0.167}', "");
    Expect(1, 74849, '\P{^Numeric_Value: 0.167}', "");
    Expect(0, 74850, '\p{Numeric_Value: 0.167}', "");
    Expect(1, 74850, '\p{^Numeric_Value: 0.167}', "");
    Expect(1, 74850, '\P{Numeric_Value: 0.167}', "");
    Expect(0, 74850, '\P{^Numeric_Value: 0.167}', "");
    Error('\p{Nv=:=	+00001/06}');
    Error('\P{Nv=:=	+00001/06}');
    Expect(1, 74849, '\p{Nv: +000000001/000006}', "");
    Expect(0, 74849, '\p{^Nv: +000000001/000006}', "");
    Expect(0, 74849, '\P{Nv: +000000001/000006}', "");
    Expect(1, 74849, '\P{^Nv: +000000001/000006}', "");
    Expect(0, 74850, '\p{Nv: +000000001/000006}', "");
    Expect(1, 74850, '\p{^Nv: +000000001/000006}', "");
    Expect(1, 74850, '\P{Nv: +000000001/000006}', "");
    Expect(0, 74850, '\P{^Nv: +000000001/000006}', "");
    Error('\p{Nv=0.17}');
    Error('\P{Nv=0.17}');
    Expect(1, 74849, '\p{Nv=0.167}', "");
    Expect(0, 74849, '\p{^Nv=0.167}', "");
    Expect(0, 74849, '\P{Nv=0.167}', "");
    Expect(1, 74849, '\P{^Nv=0.167}', "");
    Expect(0, 74850, '\p{Nv=0.167}', "");
    Expect(1, 74850, '\p{^Nv=0.167}', "");
    Expect(1, 74850, '\P{Nv=0.167}', "");
    Expect(0, 74850, '\P{^Nv=0.167}', "");
    Error('\p{Is_Numeric_Value=-:=000000001/06}');
    Error('\P{Is_Numeric_Value=-:=000000001/06}');
    Expect(1, 74849, '\p{Is_Numeric_Value=+01/00000006}', "");
    Expect(0, 74849, '\p{^Is_Numeric_Value=+01/00000006}', "");
    Expect(0, 74849, '\P{Is_Numeric_Value=+01/00000006}', "");
    Expect(1, 74849, '\P{^Is_Numeric_Value=+01/00000006}', "");
    Expect(0, 74850, '\p{Is_Numeric_Value=+01/00000006}', "");
    Expect(1, 74850, '\p{^Is_Numeric_Value=+01/00000006}', "");
    Expect(1, 74850, '\P{Is_Numeric_Value=+01/00000006}', "");
    Expect(0, 74850, '\P{^Is_Numeric_Value=+01/00000006}', "");
    Error('\p{Is_Numeric_Value=0.17}');
    Error('\P{Is_Numeric_Value=0.17}');
    Expect(1, 74849, '\p{Is_Numeric_Value:	0.167}', "");
    Expect(0, 74849, '\p{^Is_Numeric_Value:	0.167}', "");
    Expect(0, 74849, '\P{Is_Numeric_Value:	0.167}', "");
    Expect(1, 74849, '\P{^Is_Numeric_Value:	0.167}', "");
    Expect(0, 74850, '\p{Is_Numeric_Value:	0.167}', "");
    Expect(1, 74850, '\p{^Is_Numeric_Value:	0.167}', "");
    Expect(1, 74850, '\P{Is_Numeric_Value:	0.167}', "");
    Expect(0, 74850, '\P{^Is_Numeric_Value:	0.167}', "");
    Error('\p{Is_Nv=:= 01/006}');
    Error('\P{Is_Nv=:= 01/006}');
    Expect(1, 74849, '\p{Is_Nv=1/000006}', "");
    Expect(0, 74849, '\p{^Is_Nv=1/000006}', "");
    Expect(0, 74849, '\P{Is_Nv=1/000006}', "");
    Expect(1, 74849, '\P{^Is_Nv=1/000006}', "");
    Expect(0, 74850, '\p{Is_Nv=1/000006}', "");
    Expect(1, 74850, '\p{^Is_Nv=1/000006}', "");
    Expect(1, 74850, '\P{Is_Nv=1/000006}', "");
    Expect(0, 74850, '\P{^Is_Nv=1/000006}', "");
    Error('\p{Is_Nv=0.17}');
    Error('\P{Is_Nv=0.17}');
    Expect(1, 74849, '\p{Is_Nv: 0.167}', "");
    Expect(0, 74849, '\p{^Is_Nv: 0.167}', "");
    Expect(0, 74849, '\P{Is_Nv: 0.167}', "");
    Expect(1, 74849, '\P{^Is_Nv: 0.167}', "");
    Expect(0, 74850, '\p{Is_Nv: 0.167}', "");
    Expect(1, 74850, '\p{^Is_Nv: 0.167}', "");
    Expect(1, 74850, '\P{Is_Nv: 0.167}', "");
    Expect(0, 74850, '\P{^Is_Nv: 0.167}', "");
    Error('\p{Numeric_Value= :=01/07}');
    Error('\P{Numeric_Value= :=01/07}');
    Expect(1, 8528, '\p{Numeric_Value=001/00007}', "");
    Expect(0, 8528, '\p{^Numeric_Value=001/00007}', "");
    Expect(0, 8528, '\P{Numeric_Value=001/00007}', "");
    Expect(1, 8528, '\P{^Numeric_Value=001/00007}', "");
    Expect(0, 8529, '\p{Numeric_Value=001/00007}', "");
    Expect(1, 8529, '\p{^Numeric_Value=001/00007}', "");
    Expect(1, 8529, '\P{Numeric_Value=001/00007}', "");
    Expect(0, 8529, '\P{^Numeric_Value=001/00007}', "");
    Error('\p{Numeric_Value=0.14}');
    Error('\P{Numeric_Value=0.14}');
    Expect(1, 8528, '\p{Numeric_Value=0.143}', "");
    Expect(0, 8528, '\p{^Numeric_Value=0.143}', "");
    Expect(0, 8528, '\P{Numeric_Value=0.143}', "");
    Expect(1, 8528, '\P{^Numeric_Value=0.143}', "");
    Expect(0, 8529, '\p{Numeric_Value=0.143}', "");
    Expect(1, 8529, '\p{^Numeric_Value=0.143}', "");
    Expect(1, 8529, '\P{Numeric_Value=0.143}', "");
    Expect(0, 8529, '\P{^Numeric_Value=0.143}', "");
    Error('\p{Nv:	/a/-01/00000007}');
    Error('\P{Nv:	/a/-01/00000007}');
    Expect(1, 8528, '\p{Nv=00001/007}', "");
    Expect(0, 8528, '\p{^Nv=00001/007}', "");
    Expect(0, 8528, '\P{Nv=00001/007}', "");
    Expect(1, 8528, '\P{^Nv=00001/007}', "");
    Expect(0, 8529, '\p{Nv=00001/007}', "");
    Expect(1, 8529, '\p{^Nv=00001/007}', "");
    Expect(1, 8529, '\P{Nv=00001/007}', "");
    Expect(0, 8529, '\P{^Nv=00001/007}', "");
    Error('\p{Nv=0.14}');
    Error('\P{Nv=0.14}');
    Expect(1, 8528, '\p{Nv=0.143}', "");
    Expect(0, 8528, '\p{^Nv=0.143}', "");
    Expect(0, 8528, '\P{Nv=0.143}', "");
    Expect(1, 8528, '\P{^Nv=0.143}', "");
    Expect(0, 8529, '\p{Nv=0.143}', "");
    Expect(1, 8529, '\p{^Nv=0.143}', "");
    Expect(1, 8529, '\P{Nv=0.143}', "");
    Expect(0, 8529, '\P{^Nv=0.143}', "");
    Error('\p{Is_Numeric_Value=_+0000001/00007:=}');
    Error('\P{Is_Numeric_Value=_+0000001/00007:=}');
    Expect(1, 8528, '\p{Is_Numeric_Value:000000001/00007}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value:000000001/00007}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value:000000001/00007}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value:000000001/00007}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value:000000001/00007}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value:000000001/00007}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value:000000001/00007}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value:000000001/00007}', "");
    Error('\p{Is_Numeric_Value=0.14}');
    Error('\P{Is_Numeric_Value=0.14}');
    Expect(1, 8528, '\p{Is_Numeric_Value:   0.143}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value:   0.143}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value:   0.143}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value:   0.143}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value:   0.143}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value:   0.143}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value:   0.143}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value:   0.143}', "");
    Error('\p{Is_Nv=:=	_+00001/0000007}');
    Error('\P{Is_Nv=:=	_+00001/0000007}');
    Expect(1, 8528, '\p{Is_Nv=000001/0000007}', "");
    Expect(0, 8528, '\p{^Is_Nv=000001/0000007}', "");
    Expect(0, 8528, '\P{Is_Nv=000001/0000007}', "");
    Expect(1, 8528, '\P{^Is_Nv=000001/0000007}', "");
    Expect(0, 8529, '\p{Is_Nv=000001/0000007}', "");
    Expect(1, 8529, '\p{^Is_Nv=000001/0000007}', "");
    Expect(1, 8529, '\P{Is_Nv=000001/0000007}', "");
    Expect(0, 8529, '\P{^Is_Nv=000001/0000007}', "");
    Error('\p{Is_Nv=0.14}');
    Error('\P{Is_Nv=0.14}');
    Expect(1, 8528, '\p{Is_Nv=0.143}', "");
    Expect(0, 8528, '\p{^Is_Nv=0.143}', "");
    Expect(0, 8528, '\P{Is_Nv=0.143}', "");
    Expect(1, 8528, '\P{^Is_Nv=0.143}', "");
    Expect(0, 8529, '\p{Is_Nv=0.143}', "");
    Expect(1, 8529, '\p{^Is_Nv=0.143}', "");
    Expect(1, 8529, '\P{Is_Nv=0.143}', "");
    Expect(0, 8529, '\P{^Is_Nv=0.143}', "");
    Error('\p{Numeric_Value:   	+1/000000008:=}');
    Error('\P{Numeric_Value:   	+1/000000008:=}');
    Expect(1, 74847, '\p{Numeric_Value=000001/008}', "");
    Expect(0, 74847, '\p{^Numeric_Value=000001/008}', "");
    Expect(0, 74847, '\P{Numeric_Value=000001/008}', "");
    Expect(1, 74847, '\P{^Numeric_Value=000001/008}', "");
    Expect(0, 74848, '\p{Numeric_Value=000001/008}', "");
    Expect(1, 74848, '\p{^Numeric_Value=000001/008}', "");
    Expect(1, 74848, '\P{Numeric_Value=000001/008}', "");
    Expect(0, 74848, '\P{^Numeric_Value=000001/008}', "");
    Error('\p{Numeric_Value=0.12}');
    Error('\P{Numeric_Value=0.12}');
    Expect(1, 74847, '\p{Numeric_Value:	0.125}', "");
    Expect(0, 74847, '\p{^Numeric_Value:	0.125}', "");
    Expect(0, 74847, '\P{Numeric_Value:	0.125}', "");
    Expect(1, 74847, '\P{^Numeric_Value:	0.125}', "");
    Expect(0, 74848, '\p{Numeric_Value:	0.125}', "");
    Expect(1, 74848, '\p{^Numeric_Value:	0.125}', "");
    Expect(1, 74848, '\P{Numeric_Value:	0.125}', "");
    Expect(0, 74848, '\P{^Numeric_Value:	0.125}', "");
    Error('\p{Nv:    _+00001/8:=}');
    Error('\P{Nv:    _+00001/8:=}');
    Expect(1, 74847, '\p{Nv=+00001/00008}', "");
    Expect(0, 74847, '\p{^Nv=+00001/00008}', "");
    Expect(0, 74847, '\P{Nv=+00001/00008}', "");
    Expect(1, 74847, '\P{^Nv=+00001/00008}', "");
    Expect(0, 74848, '\p{Nv=+00001/00008}', "");
    Expect(1, 74848, '\p{^Nv=+00001/00008}', "");
    Expect(1, 74848, '\P{Nv=+00001/00008}', "");
    Expect(0, 74848, '\P{^Nv=+00001/00008}', "");
    Error('\p{Nv=0.12}');
    Error('\P{Nv=0.12}');
    Expect(1, 74847, '\p{Nv=0.125}', "");
    Expect(0, 74847, '\p{^Nv=0.125}', "");
    Expect(0, 74847, '\P{Nv=0.125}', "");
    Expect(1, 74847, '\P{^Nv=0.125}', "");
    Expect(0, 74848, '\p{Nv=0.125}', "");
    Expect(1, 74848, '\p{^Nv=0.125}', "");
    Expect(1, 74848, '\P{Nv=0.125}', "");
    Expect(0, 74848, '\P{^Nv=0.125}', "");
    Error('\p{Is_Numeric_Value=:=00000001/00000008}');
    Error('\P{Is_Numeric_Value=:=00000001/00000008}');
    Expect(1, 74847, '\p{Is_Numeric_Value=+00000001/0000008}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value=+00000001/0000008}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value=+00000001/0000008}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value=+00000001/0000008}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value=+00000001/0000008}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value=+00000001/0000008}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value=+00000001/0000008}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value=+00000001/0000008}', "");
    Error('\p{Is_Numeric_Value=0.12}');
    Error('\P{Is_Numeric_Value=0.12}');
    Expect(1, 74847, '\p{Is_Numeric_Value:0.125}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value:0.125}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value:0.125}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value:0.125}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value:0.125}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value:0.125}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value:0.125}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value:0.125}', "");
    Error('\p{Is_Nv=-:=000000001/008}');
    Error('\P{Is_Nv=-:=000000001/008}');
    Expect(1, 74847, '\p{Is_Nv=1/00000008}', "");
    Expect(0, 74847, '\p{^Is_Nv=1/00000008}', "");
    Expect(0, 74847, '\P{Is_Nv=1/00000008}', "");
    Expect(1, 74847, '\P{^Is_Nv=1/00000008}', "");
    Expect(0, 74848, '\p{Is_Nv=1/00000008}', "");
    Expect(1, 74848, '\p{^Is_Nv=1/00000008}', "");
    Expect(1, 74848, '\P{Is_Nv=1/00000008}', "");
    Expect(0, 74848, '\P{^Is_Nv=1/00000008}', "");
    Error('\p{Is_Nv=0.12}');
    Error('\P{Is_Nv=0.12}');
    Expect(1, 74847, '\p{Is_Nv=0.125}', "");
    Expect(0, 74847, '\p{^Is_Nv=0.125}', "");
    Expect(0, 74847, '\P{Is_Nv=0.125}', "");
    Expect(1, 74847, '\P{^Is_Nv=0.125}', "");
    Expect(0, 74848, '\p{Is_Nv=0.125}', "");
    Expect(1, 74848, '\p{^Is_Nv=0.125}', "");
    Expect(1, 74848, '\P{Is_Nv=0.125}', "");
    Expect(0, 74848, '\P{^Is_Nv=0.125}', "");
    Error('\p{Numeric_Value=_01/0000000009:=}');
    Error('\P{Numeric_Value=_01/0000000009:=}');
    Expect(1, 8529, '\p{Numeric_Value=0001/0000009}', "");
    Expect(0, 8529, '\p{^Numeric_Value=0001/0000009}', "");
    Expect(0, 8529, '\P{Numeric_Value=0001/0000009}', "");
    Expect(1, 8529, '\P{^Numeric_Value=0001/0000009}', "");
    Expect(0, 8530, '\p{Numeric_Value=0001/0000009}', "");
    Expect(1, 8530, '\p{^Numeric_Value=0001/0000009}', "");
    Expect(1, 8530, '\P{Numeric_Value=0001/0000009}', "");
    Expect(0, 8530, '\P{^Numeric_Value=0001/0000009}', "");
    Error('\p{Numeric_Value=0.11}');
    Error('\P{Numeric_Value=0.11}');
    Expect(1, 8529, '\p{Numeric_Value=0.111}', "");
    Expect(0, 8529, '\p{^Numeric_Value=0.111}', "");
    Expect(0, 8529, '\P{Numeric_Value=0.111}', "");
    Expect(1, 8529, '\P{^Numeric_Value=0.111}', "");
    Expect(0, 8530, '\p{Numeric_Value=0.111}', "");
    Expect(1, 8530, '\p{^Numeric_Value=0.111}', "");
    Expect(1, 8530, '\P{Numeric_Value=0.111}', "");
    Expect(0, 8530, '\P{^Numeric_Value=0.111}', "");
    Error('\p{Nv=/a/	-+000001/000009}');
    Error('\P{Nv=/a/	-+000001/000009}');
    Expect(1, 8529, '\p{Nv=000001/0009}', "");
    Expect(0, 8529, '\p{^Nv=000001/0009}', "");
    Expect(0, 8529, '\P{Nv=000001/0009}', "");
    Expect(1, 8529, '\P{^Nv=000001/0009}', "");
    Expect(0, 8530, '\p{Nv=000001/0009}', "");
    Expect(1, 8530, '\p{^Nv=000001/0009}', "");
    Expect(1, 8530, '\P{Nv=000001/0009}', "");
    Expect(0, 8530, '\P{^Nv=000001/0009}', "");
    Error('\p{Nv=0.11}');
    Error('\P{Nv=0.11}');
    Expect(1, 8529, '\p{Nv=0.111}', "");
    Expect(0, 8529, '\p{^Nv=0.111}', "");
    Expect(0, 8529, '\P{Nv=0.111}', "");
    Expect(1, 8529, '\P{^Nv=0.111}', "");
    Expect(0, 8530, '\p{Nv=0.111}', "");
    Expect(1, 8530, '\p{^Nv=0.111}', "");
    Expect(1, 8530, '\P{Nv=0.111}', "");
    Expect(0, 8530, '\P{^Nv=0.111}', "");
    Error('\p{Is_Numeric_Value= :=1/009}');
    Error('\P{Is_Numeric_Value= :=1/009}');
    Expect(1, 8529, '\p{Is_Numeric_Value=1/09}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value=1/09}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value=1/09}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value=1/09}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value=1/09}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value=1/09}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value=1/09}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value=1/09}', "");
    Error('\p{Is_Numeric_Value=0.11}');
    Error('\P{Is_Numeric_Value=0.11}');
    Expect(1, 8529, '\p{Is_Numeric_Value=0.111}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value=0.111}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value=0.111}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value=0.111}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value=0.111}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value=0.111}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value=0.111}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value=0.111}', "");
    Error('\p{Is_Nv=--001/000000009:=}');
    Error('\P{Is_Nv=--001/000000009:=}');
    Expect(1, 8529, '\p{Is_Nv=000000001/00009}', "");
    Expect(0, 8529, '\p{^Is_Nv=000000001/00009}', "");
    Expect(0, 8529, '\P{Is_Nv=000000001/00009}', "");
    Expect(1, 8529, '\P{^Is_Nv=000000001/00009}', "");
    Expect(0, 8530, '\p{Is_Nv=000000001/00009}', "");
    Expect(1, 8530, '\p{^Is_Nv=000000001/00009}', "");
    Expect(1, 8530, '\P{Is_Nv=000000001/00009}', "");
    Expect(0, 8530, '\P{^Is_Nv=000000001/00009}', "");
    Error('\p{Is_Nv=0.11}');
    Error('\P{Is_Nv=0.11}');
    Expect(1, 8529, '\p{Is_Nv:0.111}', "");
    Expect(0, 8529, '\p{^Is_Nv:0.111}', "");
    Expect(0, 8529, '\P{Is_Nv:0.111}', "");
    Expect(1, 8529, '\P{^Is_Nv:0.111}', "");
    Expect(0, 8530, '\p{Is_Nv:0.111}', "");
    Expect(1, 8530, '\p{^Is_Nv:0.111}', "");
    Expect(1, 8530, '\P{Is_Nv:0.111}', "");
    Expect(0, 8530, '\P{^Is_Nv:0.111}', "");
    Error('\p{Numeric_Value=:=- 000010}');
    Error('\P{Numeric_Value=:=- 000010}');
    Expect(1, 119657, '\p{Numeric_Value=000000001_0}', "");
    Expect(0, 119657, '\p{^Numeric_Value=000000001_0}', "");
    Expect(0, 119657, '\P{Numeric_Value=000000001_0}', "");
    Expect(1, 119657, '\P{^Numeric_Value=000000001_0}', "");
    Expect(0, 119658, '\p{Numeric_Value=000000001_0}', "");
    Expect(1, 119658, '\p{^Numeric_Value=000000001_0}', "");
    Expect(1, 119658, '\P{Numeric_Value=000000001_0}', "");
    Expect(0, 119658, '\P{^Numeric_Value=000000001_0}', "");
    Error('\p{Nv=	:=0_0_0_0_0_0_0_0_0_10}');
    Error('\P{Nv=	:=0_0_0_0_0_0_0_0_0_10}');
    Expect(1, 119657, '\p{Nv=0_0_0_0_010}', "");
    Expect(0, 119657, '\p{^Nv=0_0_0_0_010}', "");
    Expect(0, 119657, '\P{Nv=0_0_0_0_010}', "");
    Expect(1, 119657, '\P{^Nv=0_0_0_0_010}', "");
    Expect(0, 119658, '\p{Nv=0_0_0_0_010}', "");
    Expect(1, 119658, '\p{^Nv=0_0_0_0_010}', "");
    Expect(1, 119658, '\P{Nv=0_0_0_0_010}', "");
    Expect(0, 119658, '\P{^Nv=0_0_0_0_010}', "");
    Error('\p{Is_Numeric_Value=/a/000010}');
    Error('\P{Is_Numeric_Value=/a/000010}');
    Expect(1, 119657, '\p{Is_Numeric_Value: +000000010}', "");
    Expect(0, 119657, '\p{^Is_Numeric_Value: +000000010}', "");
    Expect(0, 119657, '\P{Is_Numeric_Value: +000000010}', "");
    Expect(1, 119657, '\P{^Is_Numeric_Value: +000000010}', "");
    Expect(0, 119658, '\p{Is_Numeric_Value: +000000010}', "");
    Expect(1, 119658, '\p{^Is_Numeric_Value: +000000010}', "");
    Expect(1, 119658, '\P{Is_Numeric_Value: +000000010}', "");
    Expect(0, 119658, '\P{^Is_Numeric_Value: +000000010}', "");
    Error('\p{Is_Nv=-/a/0000010}');
    Error('\P{Is_Nv=-/a/0000010}');
    Expect(1, 119657, '\p{Is_Nv=00001_0}', "");
    Expect(0, 119657, '\p{^Is_Nv=00001_0}', "");
    Expect(0, 119657, '\P{Is_Nv=00001_0}', "");
    Expect(1, 119657, '\P{^Is_Nv=00001_0}', "");
    Expect(0, 119658, '\p{Is_Nv=00001_0}', "");
    Expect(1, 119658, '\p{^Is_Nv=00001_0}', "");
    Expect(1, 119658, '\P{Is_Nv=00001_0}', "");
    Expect(0, 119658, '\P{^Is_Nv=00001_0}', "");
    Error('\p{Numeric_Value=/a/000_001_00}');
    Error('\P{Numeric_Value=/a/000_001_00}');
    Expect(1, 93020, '\p{Numeric_Value=+0_0_0_0_0100}', "");
    Expect(0, 93020, '\p{^Numeric_Value=+0_0_0_0_0100}', "");
    Expect(0, 93020, '\P{Numeric_Value=+0_0_0_0_0100}', "");
    Expect(1, 93020, '\P{^Numeric_Value=+0_0_0_0_0100}', "");
    Expect(0, 93021, '\p{Numeric_Value=+0_0_0_0_0100}', "");
    Expect(1, 93021, '\p{^Numeric_Value=+0_0_0_0_0100}', "");
    Expect(1, 93021, '\P{Numeric_Value=+0_0_0_0_0100}', "");
    Expect(0, 93021, '\P{^Numeric_Value=+0_0_0_0_0100}', "");
    Error('\p{Nv= -10_0/a/}');
    Error('\P{Nv= -10_0/a/}');
    Expect(1, 93020, '\p{Nv=00_10_0}', "");
    Expect(0, 93020, '\p{^Nv=00_10_0}', "");
    Expect(0, 93020, '\P{Nv=00_10_0}', "");
    Expect(1, 93020, '\P{^Nv=00_10_0}', "");
    Expect(0, 93021, '\p{Nv=00_10_0}', "");
    Expect(1, 93021, '\p{^Nv=00_10_0}', "");
    Expect(1, 93021, '\P{Nv=00_10_0}', "");
    Expect(0, 93021, '\P{^Nv=00_10_0}', "");
    Error('\p{Is_Numeric_Value= 000000100/a/}');
    Error('\P{Is_Numeric_Value= 000000100/a/}');
    Expect(1, 93020, '\p{Is_Numeric_Value=00000100}', "");
    Expect(0, 93020, '\p{^Is_Numeric_Value=00000100}', "");
    Expect(0, 93020, '\P{Is_Numeric_Value=00000100}', "");
    Expect(1, 93020, '\P{^Is_Numeric_Value=00000100}', "");
    Expect(0, 93021, '\p{Is_Numeric_Value=00000100}', "");
    Expect(1, 93021, '\p{^Is_Numeric_Value=00000100}', "");
    Expect(1, 93021, '\P{Is_Numeric_Value=00000100}', "");
    Expect(0, 93021, '\P{^Is_Numeric_Value=00000100}', "");
    Error('\p{Is_Nv=:=_+000_000_010_0}');
    Error('\P{Is_Nv=:=_+000_000_010_0}');
    Expect(1, 93020, '\p{Is_Nv=0_0_0_0_0_0_0_0_1_00}', "");
    Expect(0, 93020, '\p{^Is_Nv=0_0_0_0_0_0_0_0_1_00}', "");
    Expect(0, 93020, '\P{Is_Nv=0_0_0_0_0_0_0_0_1_00}', "");
    Expect(1, 93020, '\P{^Is_Nv=0_0_0_0_0_0_0_0_1_00}', "");
    Expect(0, 93021, '\p{Is_Nv=0_0_0_0_0_0_0_0_1_00}', "");
    Expect(1, 93021, '\p{^Is_Nv=0_0_0_0_0_0_0_0_1_00}', "");
    Expect(1, 93021, '\P{Is_Nv=0_0_0_0_0_0_0_0_1_00}', "");
    Expect(0, 93021, '\P{^Is_Nv=0_0_0_0_0_0_0_0_1_00}', "");
    Error('\p{Numeric_Value=/a/_	0_0_1_0_00}');
    Error('\P{Numeric_Value=/a/_	0_0_1_0_00}');
    Expect(1, 70132, '\p{Numeric_Value=0000001000}', "");
    Expect(0, 70132, '\p{^Numeric_Value=0000001000}', "");
    Expect(0, 70132, '\P{Numeric_Value=0000001000}', "");
    Expect(1, 70132, '\P{^Numeric_Value=0000001000}', "");
    Expect(0, 70133, '\p{Numeric_Value=0000001000}', "");
    Expect(1, 70133, '\p{^Numeric_Value=0000001000}', "");
    Expect(1, 70133, '\P{Numeric_Value=0000001000}', "");
    Expect(0, 70133, '\P{^Numeric_Value=0000001000}', "");
    Error('\p{Nv=	 001000/a/}');
    Error('\P{Nv=	 001000/a/}');
    Expect(1, 70132, '\p{Nv=00001000}', "");
    Expect(0, 70132, '\p{^Nv=00001000}', "");
    Expect(0, 70132, '\P{Nv=00001000}', "");
    Expect(1, 70132, '\P{^Nv=00001000}', "");
    Expect(0, 70133, '\p{Nv=00001000}', "");
    Expect(1, 70133, '\p{^Nv=00001000}', "");
    Expect(1, 70133, '\P{Nv=00001000}', "");
    Expect(0, 70133, '\P{^Nv=00001000}', "");
    Error('\p{Is_Numeric_Value=/a/_00001000}');
    Error('\P{Is_Numeric_Value=/a/_00001000}');
    Expect(1, 70132, '\p{Is_Numeric_Value: +00001000}', "");
    Expect(0, 70132, '\p{^Is_Numeric_Value: +00001000}', "");
    Expect(0, 70132, '\P{Is_Numeric_Value: +00001000}', "");
    Expect(1, 70132, '\P{^Is_Numeric_Value: +00001000}', "");
    Expect(0, 70133, '\p{Is_Numeric_Value: +00001000}', "");
    Expect(1, 70133, '\p{^Is_Numeric_Value: +00001000}', "");
    Expect(1, 70133, '\P{Is_Numeric_Value: +00001000}', "");
    Expect(0, 70133, '\P{^Is_Numeric_Value: +00001000}', "");
    Error('\p{Is_Nv=/a/000_100_0}');
    Error('\P{Is_Nv=/a/000_100_0}');
    Expect(1, 70132, '\p{Is_Nv=01000}', "");
    Expect(0, 70132, '\p{^Is_Nv=01000}', "");
    Expect(0, 70132, '\P{Is_Nv=01000}', "");
    Expect(1, 70132, '\P{^Is_Nv=01000}', "");
    Expect(0, 70133, '\p{Is_Nv=01000}', "");
    Expect(1, 70133, '\p{^Is_Nv=01000}', "");
    Expect(1, 70133, '\P{Is_Nv=01000}', "");
    Expect(0, 70133, '\P{^Is_Nv=01000}', "");
    Error('\p{Numeric_Value=:=	_+01_00_00}');
    Error('\P{Numeric_Value=:=	_+01_00_00}');
    Expect(1, 93021, '\p{Numeric_Value=00_10_00_0}', "");
    Expect(0, 93021, '\p{^Numeric_Value=00_10_00_0}', "");
    Expect(0, 93021, '\P{Numeric_Value=00_10_00_0}', "");
    Expect(1, 93021, '\P{^Numeric_Value=00_10_00_0}', "");
    Expect(0, 93022, '\p{Numeric_Value=00_10_00_0}', "");
    Expect(1, 93022, '\p{^Numeric_Value=00_10_00_0}', "");
    Expect(1, 93022, '\P{Numeric_Value=00_10_00_0}', "");
    Expect(0, 93022, '\P{^Numeric_Value=00_10_00_0}', "");
    Error('\p{Nv=/a/	+0_0_0_0_0_1_0000}');
    Error('\P{Nv=/a/	+0_0_0_0_0_1_0000}');
    Expect(1, 93021, '\p{Nv=000010000}', "");
    Expect(0, 93021, '\p{^Nv=000010000}', "");
    Expect(0, 93021, '\P{Nv=000010000}', "");
    Expect(1, 93021, '\P{^Nv=000010000}', "");
    Expect(0, 93022, '\p{Nv=000010000}', "");
    Expect(1, 93022, '\p{^Nv=000010000}', "");
    Expect(1, 93022, '\P{Nv=000010000}', "");
    Expect(0, 93022, '\P{^Nv=000010000}', "");
    Error('\p{Is_Numeric_Value=:= 	000001000_0}');
    Error('\P{Is_Numeric_Value=:= 	000001000_0}');
    Expect(1, 93021, '\p{Is_Numeric_Value=000000010000}', "");
    Expect(0, 93021, '\p{^Is_Numeric_Value=000000010000}', "");
    Expect(0, 93021, '\P{Is_Numeric_Value=000000010000}', "");
    Expect(1, 93021, '\P{^Is_Numeric_Value=000000010000}', "");
    Expect(0, 93022, '\p{Is_Numeric_Value=000000010000}', "");
    Expect(1, 93022, '\p{^Is_Numeric_Value=000000010000}', "");
    Expect(1, 93022, '\P{Is_Numeric_Value=000000010000}', "");
    Expect(0, 93022, '\P{^Is_Numeric_Value=000000010000}', "");
    Error('\p{Is_Nv=:=+00000010000}');
    Error('\P{Is_Nv=:=+00000010000}');
    Expect(1, 93021, '\p{Is_Nv=000010000}', "");
    Expect(0, 93021, '\p{^Is_Nv=000010000}', "");
    Expect(0, 93021, '\P{Is_Nv=000010000}', "");
    Expect(1, 93021, '\P{^Is_Nv=000010000}', "");
    Expect(0, 93022, '\p{Is_Nv=000010000}', "");
    Expect(1, 93022, '\p{^Is_Nv=000010000}', "");
    Expect(1, 93022, '\P{Is_Nv=000010000}', "");
    Expect(0, 93022, '\P{^Is_Nv=000010000}', "");
    Error('\p{Numeric_Value=:=	+000000000100000}');
    Error('\P{Numeric_Value=:=	+000000000100000}');
    Expect(1, 68077, '\p{Numeric_Value=0100000}', "");
    Expect(0, 68077, '\p{^Numeric_Value=0100000}', "");
    Expect(0, 68077, '\P{Numeric_Value=0100000}', "");
    Expect(1, 68077, '\P{^Numeric_Value=0100000}', "");
    Expect(0, 68078, '\p{Numeric_Value=0100000}', "");
    Expect(1, 68078, '\p{^Numeric_Value=0100000}', "");
    Expect(1, 68078, '\P{Numeric_Value=0100000}', "");
    Expect(0, 68078, '\P{^Numeric_Value=0100000}', "");
    Error('\p{Nv= /a/0_0_0_0_0_0_1_0_0_0_00}');
    Error('\P{Nv= /a/0_0_0_0_0_0_1_0_0_0_00}');
    Expect(1, 68077, '\p{Nv=100000}', "");
    Expect(0, 68077, '\p{^Nv=100000}', "");
    Expect(0, 68077, '\P{Nv=100000}', "");
    Expect(1, 68077, '\P{^Nv=100000}', "");
    Expect(0, 68078, '\p{Nv=100000}', "");
    Expect(1, 68078, '\p{^Nv=100000}', "");
    Expect(1, 68078, '\P{Nv=100000}', "");
    Expect(0, 68078, '\P{^Nv=100000}', "");
    Error('\p{Is_Numeric_Value=:=		+0100000}');
    Error('\P{Is_Numeric_Value=:=		+0100000}');
    Expect(1, 68077, '\p{Is_Numeric_Value=10000_0}', "");
    Expect(0, 68077, '\p{^Is_Numeric_Value=10000_0}', "");
    Expect(0, 68077, '\P{Is_Numeric_Value=10000_0}', "");
    Expect(1, 68077, '\P{^Is_Numeric_Value=10000_0}', "");
    Expect(0, 68078, '\p{Is_Numeric_Value=10000_0}', "");
    Expect(1, 68078, '\p{^Is_Numeric_Value=10000_0}', "");
    Expect(1, 68078, '\P{Is_Numeric_Value=10000_0}', "");
    Expect(0, 68078, '\P{^Is_Numeric_Value=10000_0}', "");
    Error('\p{Is_Nv=-/a/00000_10000_0}');
    Error('\P{Is_Nv=-/a/00000_10000_0}');
    Expect(1, 68077, '\p{Is_Nv=+000100000}', "");
    Expect(0, 68077, '\p{^Is_Nv=+000100000}', "");
    Expect(0, 68077, '\P{Is_Nv=+000100000}', "");
    Expect(1, 68077, '\P{^Is_Nv=+000100000}', "");
    Expect(0, 68078, '\p{Is_Nv=+000100000}', "");
    Expect(1, 68078, '\p{^Is_Nv=+000100000}', "");
    Expect(1, 68078, '\P{Is_Nv=+000100000}', "");
    Expect(0, 68078, '\P{^Is_Nv=+000100000}', "");
    Error('\p{Numeric_Value=:=+0_0_1_0_0_0000}');
    Error('\P{Numeric_Value=:=+0_0_1_0_0_0000}');
    Expect(1, 93022, '\p{Numeric_Value=00_00_00_10_00_000}', "");
    Expect(0, 93022, '\p{^Numeric_Value=00_00_00_10_00_000}', "");
    Expect(0, 93022, '\P{Numeric_Value=00_00_00_10_00_000}', "");
    Expect(1, 93022, '\P{^Numeric_Value=00_00_00_10_00_000}', "");
    Expect(0, 93023, '\p{Numeric_Value=00_00_00_10_00_000}', "");
    Expect(1, 93023, '\p{^Numeric_Value=00_00_00_10_00_000}', "");
    Expect(1, 93023, '\P{Numeric_Value=00_00_00_10_00_000}', "");
    Expect(0, 93023, '\P{^Numeric_Value=00_00_00_10_00_000}', "");
    Error('\p{Nv=:=		000001000000}');
    Error('\P{Nv=:=		000001000000}');
    Expect(1, 93022, '\p{Nv=00_10_00_00_0}', "");
    Expect(0, 93022, '\p{^Nv=00_10_00_00_0}', "");
    Expect(0, 93022, '\P{Nv=00_10_00_00_0}', "");
    Expect(1, 93022, '\P{^Nv=00_10_00_00_0}', "");
    Expect(0, 93023, '\p{Nv=00_10_00_00_0}', "");
    Expect(1, 93023, '\p{^Nv=00_10_00_00_0}', "");
    Expect(1, 93023, '\P{Nv=00_10_00_00_0}', "");
    Expect(0, 93023, '\P{^Nv=00_10_00_00_0}', "");
    Error('\p{Is_Numeric_Value=:=-+0001000000}');
    Error('\P{Is_Numeric_Value=:=-+0001000000}');
    Expect(1, 93022, '\p{Is_Numeric_Value=+0_0_0_1_0_0_0000}', "");
    Expect(0, 93022, '\p{^Is_Numeric_Value=+0_0_0_1_0_0_0000}', "");
    Expect(0, 93022, '\P{Is_Numeric_Value=+0_0_0_1_0_0_0000}', "");
    Expect(1, 93022, '\P{^Is_Numeric_Value=+0_0_0_1_0_0_0000}', "");
    Expect(0, 93023, '\p{Is_Numeric_Value=+0_0_0_1_0_0_0000}', "");
    Expect(1, 93023, '\p{^Is_Numeric_Value=+0_0_0_1_0_0_0000}', "");
    Expect(1, 93023, '\P{Is_Numeric_Value=+0_0_0_1_0_0_0000}', "");
    Expect(0, 93023, '\P{^Is_Numeric_Value=+0_0_0_1_0_0_0000}', "");
    Error('\p{Is_Nv=:=+00_00_01_00_00_00}');
    Error('\P{Is_Nv=:=+00_00_01_00_00_00}');
    Expect(1, 93022, '\p{Is_Nv=0_1_0_0_0_000}', "");
    Expect(0, 93022, '\p{^Is_Nv=0_1_0_0_0_000}', "");
    Expect(0, 93022, '\P{Is_Nv=0_1_0_0_0_000}', "");
    Expect(1, 93022, '\P{^Is_Nv=0_1_0_0_0_000}', "");
    Expect(0, 93023, '\p{Is_Nv=0_1_0_0_0_000}', "");
    Expect(1, 93023, '\p{^Is_Nv=0_1_0_0_0_000}', "");
    Expect(1, 93023, '\P{Is_Nv=0_1_0_0_0_000}', "");
    Expect(0, 93023, '\P{^Is_Nv=0_1_0_0_0_000}', "");
    Error('\p{Numeric_Value= -0000100000000:=}');
    Error('\P{Numeric_Value= -0000100000000:=}');
    Expect(1, 93023, '\p{Numeric_Value=0000100000000}', "");
    Expect(0, 93023, '\p{^Numeric_Value=0000100000000}', "");
    Expect(0, 93023, '\P{Numeric_Value=0000100000000}', "");
    Expect(1, 93023, '\P{^Numeric_Value=0000100000000}', "");
    Expect(0, 93024, '\p{Numeric_Value=0000100000000}', "");
    Expect(1, 93024, '\p{^Numeric_Value=0000100000000}', "");
    Expect(1, 93024, '\P{Numeric_Value=0000100000000}', "");
    Expect(0, 93024, '\P{^Numeric_Value=0000100000000}', "");
    Error('\p{Nv=	/a/100000000}');
    Error('\P{Nv=	/a/100000000}');
    Expect(1, 93023, '\p{Nv=100000000}', "");
    Expect(0, 93023, '\p{^Nv=100000000}', "");
    Expect(0, 93023, '\P{Nv=100000000}', "");
    Expect(1, 93023, '\P{^Nv=100000000}', "");
    Expect(0, 93024, '\p{Nv=100000000}', "");
    Expect(1, 93024, '\p{^Nv=100000000}', "");
    Expect(1, 93024, '\P{Nv=100000000}', "");
    Expect(0, 93024, '\P{^Nv=100000000}', "");
    Error('\p{Is_Numeric_Value= _0_1_0_0_0_0_0_0_00/a/}');
    Error('\P{Is_Numeric_Value= _0_1_0_0_0_0_0_0_00/a/}');
    Expect(1, 93023, '\p{Is_Numeric_Value=+000_001_000_000_00}', "");
    Expect(0, 93023, '\p{^Is_Numeric_Value=+000_001_000_000_00}', "");
    Expect(0, 93023, '\P{Is_Numeric_Value=+000_001_000_000_00}', "");
    Expect(1, 93023, '\P{^Is_Numeric_Value=+000_001_000_000_00}', "");
    Expect(0, 93024, '\p{Is_Numeric_Value=+000_001_000_000_00}', "");
    Expect(1, 93024, '\p{^Is_Numeric_Value=+000_001_000_000_00}', "");
    Expect(1, 93024, '\P{Is_Numeric_Value=+000_001_000_000_00}', "");
    Expect(0, 93024, '\P{^Is_Numeric_Value=+000_001_000_000_00}', "");
    Error('\p{Is_Nv=/a/	-00100000000}');
    Error('\P{Is_Nv=/a/	-00100000000}');
    Expect(1, 93023, '\p{Is_Nv=0100000000}', "");
    Expect(0, 93023, '\p{^Is_Nv=0100000000}', "");
    Expect(0, 93023, '\P{Is_Nv=0100000000}', "");
    Expect(1, 93023, '\P{^Is_Nv=0100000000}', "");
    Expect(0, 93024, '\p{Is_Nv=0100000000}', "");
    Expect(1, 93024, '\p{^Is_Nv=0100000000}', "");
    Expect(1, 93024, '\P{Is_Nv=0100000000}', "");
    Expect(0, 93024, '\P{^Is_Nv=0100000000}', "");
    Error('\p{Numeric_Value=_:=+0000000010000000000}');
    Error('\P{Numeric_Value=_:=+0000000010000000000}');
    Expect(1, 93024, '\p{Numeric_Value:   00000000010000000000}', "");
    Expect(0, 93024, '\p{^Numeric_Value:   00000000010000000000}', "");
    Expect(0, 93024, '\P{Numeric_Value:   00000000010000000000}', "");
    Expect(1, 93024, '\P{^Numeric_Value:   00000000010000000000}', "");
    Expect(0, 93025, '\p{Numeric_Value:   00000000010000000000}', "");
    Expect(1, 93025, '\p{^Numeric_Value:   00000000010000000000}', "");
    Expect(1, 93025, '\P{Numeric_Value:   00000000010000000000}', "");
    Expect(0, 93025, '\P{^Numeric_Value:   00000000010000000000}', "");
    Error('\p{Nv=	:=0_0_0_0_0_0_0_1_0_0_0_0_000000}');
    Error('\P{Nv=	:=0_0_0_0_0_0_0_1_0_0_0_0_000000}');
    Expect(1, 93024, '\p{Nv=01000_00000_00}', "");
    Expect(0, 93024, '\p{^Nv=01000_00000_00}', "");
    Expect(0, 93024, '\P{Nv=01000_00000_00}', "");
    Expect(1, 93024, '\P{^Nv=01000_00000_00}', "");
    Expect(0, 93025, '\p{Nv=01000_00000_00}', "");
    Expect(1, 93025, '\p{^Nv=01000_00000_00}', "");
    Expect(1, 93025, '\P{Nv=01000_00000_00}', "");
    Expect(0, 93025, '\P{^Nv=01000_00000_00}', "");
    Error('\p{Is_Numeric_Value=_/a/0000000010000000000}');
    Error('\P{Is_Numeric_Value=_/a/0000000010000000000}');
    Expect(1, 93024, '\p{Is_Numeric_Value: +0_0_0_0_1_0_0_0_0_000000}', "");
    Expect(0, 93024, '\p{^Is_Numeric_Value: +0_0_0_0_1_0_0_0_0_000000}', "");
    Expect(0, 93024, '\P{Is_Numeric_Value: +0_0_0_0_1_0_0_0_0_000000}', "");
    Expect(1, 93024, '\P{^Is_Numeric_Value: +0_0_0_0_1_0_0_0_0_000000}', "");
    Expect(0, 93025, '\p{Is_Numeric_Value: +0_0_0_0_1_0_0_0_0_000000}', "");
    Expect(1, 93025, '\p{^Is_Numeric_Value: +0_0_0_0_1_0_0_0_0_000000}', "");
    Expect(1, 93025, '\P{Is_Numeric_Value: +0_0_0_0_1_0_0_0_0_000000}', "");
    Expect(0, 93025, '\P{^Is_Numeric_Value: +0_0_0_0_1_0_0_0_0_000000}', "");
    Error('\p{Is_Nv=	:=000000001_000000000_0}');
    Error('\P{Is_Nv=	:=000000001_000000000_0}');
    Expect(1, 93024, '\p{Is_Nv:	+00_00_00_00_10_00_00_00_00_0}', "");
    Expect(0, 93024, '\p{^Is_Nv:	+00_00_00_00_10_00_00_00_00_0}', "");
    Expect(0, 93024, '\P{Is_Nv:	+00_00_00_00_10_00_00_00_00_0}', "");
    Expect(1, 93024, '\P{^Is_Nv:	+00_00_00_00_10_00_00_00_00_0}', "");
    Expect(0, 93025, '\p{Is_Nv:	+00_00_00_00_10_00_00_00_00_0}', "");
    Expect(1, 93025, '\p{^Is_Nv:	+00_00_00_00_10_00_00_00_00_0}', "");
    Expect(1, 93025, '\P{Is_Nv:	+00_00_00_00_10_00_00_00_00_0}', "");
    Expect(0, 93025, '\P{^Is_Nv:	+00_00_00_00_10_00_00_00_00_0}', "");
    Error('\p{Numeric_Value=:=-	0_0_1_0_0_0_0_0_0_0_0_0000}');
    Error('\P{Numeric_Value=:=-	0_0_1_0_0_0_0_0_0_0_0_0000}');
    Expect(1, 93025, '\p{Numeric_Value=010000_000000_00}', "");
    Expect(0, 93025, '\p{^Numeric_Value=010000_000000_00}', "");
    Expect(0, 93025, '\P{Numeric_Value=010000_000000_00}', "");
    Expect(1, 93025, '\P{^Numeric_Value=010000_000000_00}', "");
    Expect(0, 93026, '\p{Numeric_Value=010000_000000_00}', "");
    Expect(1, 93026, '\p{^Numeric_Value=010000_000000_00}', "");
    Expect(1, 93026, '\P{Numeric_Value=010000_000000_00}', "");
    Expect(0, 93026, '\P{^Numeric_Value=010000_000000_00}', "");
    Error('\p{Nv=/a/_-000000001000000000000}');
    Error('\P{Nv=/a/_-000000001000000000000}');
    Expect(1, 93025, '\p{Nv: 00001000000000000}', "");
    Expect(0, 93025, '\p{^Nv: 00001000000000000}', "");
    Expect(0, 93025, '\P{Nv: 00001000000000000}', "");
    Expect(1, 93025, '\P{^Nv: 00001000000000000}', "");
    Expect(0, 93026, '\p{Nv: 00001000000000000}', "");
    Expect(1, 93026, '\p{^Nv: 00001000000000000}', "");
    Expect(1, 93026, '\P{Nv: 00001000000000000}', "");
    Expect(0, 93026, '\P{^Nv: 00001000000000000}', "");
    Error('\p{Is_Numeric_Value=	+100000000000_0:=}');
    Error('\P{Is_Numeric_Value=	+100000000000_0:=}');
    Expect(1, 93025, '\p{Is_Numeric_Value=01000000000000}', "");
    Expect(0, 93025, '\p{^Is_Numeric_Value=01000000000000}', "");
    Expect(0, 93025, '\P{Is_Numeric_Value=01000000000000}', "");
    Expect(1, 93025, '\P{^Is_Numeric_Value=01000000000000}', "");
    Expect(0, 93026, '\p{Is_Numeric_Value=01000000000000}', "");
    Expect(1, 93026, '\p{^Is_Numeric_Value=01000000000000}', "");
    Expect(1, 93026, '\P{Is_Numeric_Value=01000000000000}', "");
    Expect(0, 93026, '\P{^Is_Numeric_Value=01000000000000}', "");
    Error('\p{Is_Nv=-	+0_0_0_1_0_0_0_0_0_0_0_0_0_0_00/a/}');
    Error('\P{Is_Nv=-	+0_0_0_1_0_0_0_0_0_0_0_0_0_0_00/a/}');
    Expect(1, 93025, '\p{Is_Nv:	0001000000000000}', "");
    Expect(0, 93025, '\p{^Is_Nv:	0001000000000000}', "");
    Expect(0, 93025, '\P{Is_Nv:	0001000000000000}', "");
    Expect(1, 93025, '\P{^Is_Nv:	0001000000000000}', "");
    Expect(0, 93026, '\p{Is_Nv:	0001000000000000}', "");
    Expect(1, 93026, '\p{^Is_Nv:	0001000000000000}', "");
    Expect(1, 93026, '\P{Is_Nv:	0001000000000000}', "");
    Expect(0, 93026, '\P{^Is_Nv:	0001000000000000}', "");
    Error('\p{Numeric_Value=_/a/0_0_11}');
    Error('\P{Numeric_Value=_/a/0_0_11}');
    Expect(1, 9451, '\p{Numeric_Value=000000011}', "");
    Expect(0, 9451, '\p{^Numeric_Value=000000011}', "");
    Expect(0, 9451, '\P{Numeric_Value=000000011}', "");
    Expect(1, 9451, '\P{^Numeric_Value=000000011}', "");
    Expect(0, 9452, '\p{Numeric_Value=000000011}', "");
    Expect(1, 9452, '\p{^Numeric_Value=000000011}', "");
    Expect(1, 9452, '\P{Numeric_Value=000000011}', "");
    Expect(0, 9452, '\P{^Numeric_Value=000000011}', "");
    Error('\p{Nv=	0_0_0_0_11/a/}');
    Error('\P{Nv=	0_0_0_0_11/a/}');
    Expect(1, 9451, '\p{Nv=00001_1}', "");
    Expect(0, 9451, '\p{^Nv=00001_1}', "");
    Expect(0, 9451, '\P{Nv=00001_1}', "");
    Expect(1, 9451, '\P{^Nv=00001_1}', "");
    Expect(0, 9452, '\p{Nv=00001_1}', "");
    Expect(1, 9452, '\p{^Nv=00001_1}', "");
    Expect(1, 9452, '\P{Nv=00001_1}', "");
    Expect(0, 9452, '\P{^Nv=00001_1}', "");
    Error('\p{Is_Numeric_Value=:=	 00000011}');
    Error('\P{Is_Numeric_Value=:=	 00000011}');
    Expect(1, 9451, '\p{Is_Numeric_Value:0_0_0_0_0_0_0_011}', "");
    Expect(0, 9451, '\p{^Is_Numeric_Value:0_0_0_0_0_0_0_011}', "");
    Expect(0, 9451, '\P{Is_Numeric_Value:0_0_0_0_0_0_0_011}', "");
    Expect(1, 9451, '\P{^Is_Numeric_Value:0_0_0_0_0_0_0_011}', "");
    Expect(0, 9452, '\p{Is_Numeric_Value:0_0_0_0_0_0_0_011}', "");
    Expect(1, 9452, '\p{^Is_Numeric_Value:0_0_0_0_0_0_0_011}', "");
    Expect(1, 9452, '\P{Is_Numeric_Value:0_0_0_0_0_0_0_011}', "");
    Expect(0, 9452, '\P{^Is_Numeric_Value:0_0_0_0_0_0_0_011}', "");
    Error('\p{Is_Nv:		00000011:=}');
    Error('\P{Is_Nv:		00000011:=}');
    Expect(1, 9451, '\p{Is_Nv=0_0_0_011}', "");
    Expect(0, 9451, '\p{^Is_Nv=0_0_0_011}', "");
    Expect(0, 9451, '\P{Is_Nv=0_0_0_011}', "");
    Expect(1, 9451, '\P{^Is_Nv=0_0_0_011}', "");
    Expect(0, 9452, '\p{Is_Nv=0_0_0_011}', "");
    Expect(1, 9452, '\p{^Is_Nv=0_0_0_011}', "");
    Expect(1, 9452, '\P{Is_Nv=0_0_0_011}', "");
    Expect(0, 9452, '\P{^Is_Nv=0_0_0_011}', "");
    Error('\p{Numeric_Value=_/a/000000011/0012}');
    Error('\P{Numeric_Value=_/a/000000011/0012}');
    Expect(1, 68028, '\p{Numeric_Value=0000000011/0000000012}', "");
    Expect(0, 68028, '\p{^Numeric_Value=0000000011/0000000012}', "");
    Expect(0, 68028, '\P{Numeric_Value=0000000011/0000000012}', "");
    Expect(1, 68028, '\P{^Numeric_Value=0000000011/0000000012}', "");
    Expect(0, 68029, '\p{Numeric_Value=0000000011/0000000012}', "");
    Expect(1, 68029, '\p{^Numeric_Value=0000000011/0000000012}', "");
    Expect(1, 68029, '\P{Numeric_Value=0000000011/0000000012}', "");
    Expect(0, 68029, '\P{^Numeric_Value=0000000011/0000000012}', "");
    Error('\p{Numeric_Value=0.9}');
    Error('\P{Numeric_Value=0.9}');
    Error('\p{Numeric_Value=0.92}');
    Error('\P{Numeric_Value=0.92}');
    Expect(1, 68028, '\p{Numeric_Value=0.917}', "");
    Expect(0, 68028, '\p{^Numeric_Value=0.917}', "");
    Expect(0, 68028, '\P{Numeric_Value=0.917}', "");
    Expect(1, 68028, '\P{^Numeric_Value=0.917}', "");
    Expect(0, 68029, '\p{Numeric_Value=0.917}', "");
    Expect(1, 68029, '\p{^Numeric_Value=0.917}', "");
    Expect(1, 68029, '\P{Numeric_Value=0.917}', "");
    Expect(0, 68029, '\P{^Numeric_Value=0.917}', "");
    Error('\p{Nv=:=  11/0000012}');
    Error('\P{Nv=:=  11/0000012}');
    Expect(1, 68028, '\p{Nv=11/0000012}', "");
    Expect(0, 68028, '\p{^Nv=11/0000012}', "");
    Expect(0, 68028, '\P{Nv=11/0000012}', "");
    Expect(1, 68028, '\P{^Nv=11/0000012}', "");
    Expect(0, 68029, '\p{Nv=11/0000012}', "");
    Expect(1, 68029, '\p{^Nv=11/0000012}', "");
    Expect(1, 68029, '\P{Nv=11/0000012}', "");
    Expect(0, 68029, '\P{^Nv=11/0000012}', "");
    Error('\p{Nv=0.9}');
    Error('\P{Nv=0.9}');
    Error('\p{Nv=0.92}');
    Error('\P{Nv=0.92}');
    Expect(1, 68028, '\p{Nv=0.917}', "");
    Expect(0, 68028, '\p{^Nv=0.917}', "");
    Expect(0, 68028, '\P{Nv=0.917}', "");
    Expect(1, 68028, '\P{^Nv=0.917}', "");
    Expect(0, 68029, '\p{Nv=0.917}', "");
    Expect(1, 68029, '\p{^Nv=0.917}', "");
    Expect(1, 68029, '\P{Nv=0.917}', "");
    Expect(0, 68029, '\P{^Nv=0.917}', "");
    Error('\p{Is_Numeric_Value=/a/ 	00000000011/012}');
    Error('\P{Is_Numeric_Value=/a/ 	00000000011/012}');
    Expect(1, 68028, '\p{Is_Numeric_Value=000011/12}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value=000011/12}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value=000011/12}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value=000011/12}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value=000011/12}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value=000011/12}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value=000011/12}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value=000011/12}', "");
    Error('\p{Is_Numeric_Value=0.9}');
    Error('\P{Is_Numeric_Value=0.9}');
    Error('\p{Is_Numeric_Value=0.92}');
    Error('\P{Is_Numeric_Value=0.92}');
    Expect(1, 68028, '\p{Is_Numeric_Value=0.917}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value=0.917}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value=0.917}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value=0.917}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value=0.917}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value=0.917}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value=0.917}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value=0.917}', "");
    Error('\p{Is_Nv=_-00000011/00000000012/a/}');
    Error('\P{Is_Nv=_-00000011/00000000012/a/}');
    Expect(1, 68028, '\p{Is_Nv=000000011/000000012}', "");
    Expect(0, 68028, '\p{^Is_Nv=000000011/000000012}', "");
    Expect(0, 68028, '\P{Is_Nv=000000011/000000012}', "");
    Expect(1, 68028, '\P{^Is_Nv=000000011/000000012}', "");
    Expect(0, 68029, '\p{Is_Nv=000000011/000000012}', "");
    Expect(1, 68029, '\p{^Is_Nv=000000011/000000012}', "");
    Expect(1, 68029, '\P{Is_Nv=000000011/000000012}', "");
    Expect(0, 68029, '\P{^Is_Nv=000000011/000000012}', "");
    Error('\p{Is_Nv=0.9}');
    Error('\P{Is_Nv=0.9}');
    Error('\p{Is_Nv:   0.92}');
    Error('\P{Is_Nv:   0.92}');
    Expect(1, 68028, '\p{Is_Nv=0.917}', "");
    Expect(0, 68028, '\p{^Is_Nv=0.917}', "");
    Expect(0, 68028, '\P{Is_Nv=0.917}', "");
    Expect(1, 68028, '\P{^Is_Nv=0.917}', "");
    Expect(0, 68029, '\p{Is_Nv=0.917}', "");
    Expect(1, 68029, '\p{^Is_Nv=0.917}', "");
    Expect(1, 68029, '\P{Is_Nv=0.917}', "");
    Expect(0, 68029, '\P{^Is_Nv=0.917}', "");
    Error('\p{Numeric_Value=:= -11/0002}');
    Error('\P{Numeric_Value=:= -11/0002}');
    Expect(1, 3887, '\p{Numeric_Value=+0000011/02}', "");
    Expect(0, 3887, '\p{^Numeric_Value=+0000011/02}', "");
    Expect(0, 3887, '\P{Numeric_Value=+0000011/02}', "");
    Expect(1, 3887, '\P{^Numeric_Value=+0000011/02}', "");
    Expect(0, 3888, '\p{Numeric_Value=+0000011/02}', "");
    Expect(1, 3888, '\p{^Numeric_Value=+0000011/02}', "");
    Expect(1, 3888, '\P{Numeric_Value=+0000011/02}', "");
    Expect(0, 3888, '\P{^Numeric_Value=+0000011/02}', "");
    Expect(1, 3887, '\p{Numeric_Value=5.500}', "");
    Expect(0, 3887, '\p{^Numeric_Value=5.500}', "");
    Expect(0, 3887, '\P{Numeric_Value=5.500}', "");
    Expect(1, 3887, '\P{^Numeric_Value=5.500}', "");
    Expect(0, 3888, '\p{Numeric_Value=5.500}', "");
    Expect(1, 3888, '\p{^Numeric_Value=5.500}', "");
    Expect(1, 3888, '\P{Numeric_Value=5.500}', "");
    Expect(0, 3888, '\P{^Numeric_Value=5.500}', "");
    Error('\p{Nv=:=- 00000011/00000002}');
    Error('\P{Nv=:=- 00000011/00000002}');
    Expect(1, 3887, '\p{Nv=011/000000002}', "");
    Expect(0, 3887, '\p{^Nv=011/000000002}', "");
    Expect(0, 3887, '\P{Nv=011/000000002}', "");
    Expect(1, 3887, '\P{^Nv=011/000000002}', "");
    Expect(0, 3888, '\p{Nv=011/000000002}', "");
    Expect(1, 3888, '\p{^Nv=011/000000002}', "");
    Expect(1, 3888, '\P{Nv=011/000000002}', "");
    Expect(0, 3888, '\P{^Nv=011/000000002}', "");
    Expect(1, 3887, '\p{Nv=5.500}', "");
    Expect(0, 3887, '\p{^Nv=5.500}', "");
    Expect(0, 3887, '\P{Nv=5.500}', "");
    Expect(1, 3887, '\P{^Nv=5.500}', "");
    Expect(0, 3888, '\p{Nv=5.500}', "");
    Expect(1, 3888, '\p{^Nv=5.500}', "");
    Expect(1, 3888, '\P{Nv=5.500}', "");
    Expect(0, 3888, '\P{^Nv=5.500}', "");
    Error('\p{Is_Numeric_Value=__+00000000011/02:=}');
    Error('\P{Is_Numeric_Value=__+00000000011/02:=}');
    Expect(1, 3887, '\p{Is_Numeric_Value=0000011/02}', "");
    Expect(0, 3887, '\p{^Is_Numeric_Value=0000011/02}', "");
    Expect(0, 3887, '\P{Is_Numeric_Value=0000011/02}', "");
    Expect(1, 3887, '\P{^Is_Numeric_Value=0000011/02}', "");
    Expect(0, 3888, '\p{Is_Numeric_Value=0000011/02}', "");
    Expect(1, 3888, '\p{^Is_Numeric_Value=0000011/02}', "");
    Expect(1, 3888, '\P{Is_Numeric_Value=0000011/02}', "");
    Expect(0, 3888, '\P{^Is_Numeric_Value=0000011/02}', "");
    Expect(1, 3887, '\p{Is_Numeric_Value=5.500}', "");
    Expect(0, 3887, '\p{^Is_Numeric_Value=5.500}', "");
    Expect(0, 3887, '\P{Is_Numeric_Value=5.500}', "");
    Expect(1, 3887, '\P{^Is_Numeric_Value=5.500}', "");
    Expect(0, 3888, '\p{Is_Numeric_Value=5.500}', "");
    Expect(1, 3888, '\p{^Is_Numeric_Value=5.500}', "");
    Expect(1, 3888, '\P{Is_Numeric_Value=5.500}', "");
    Expect(0, 3888, '\P{^Is_Numeric_Value=5.500}', "");
    Error('\p{Is_Nv:		+00011/0000000002/a/}');
    Error('\P{Is_Nv:		+00011/0000000002/a/}');
    Expect(1, 3887, '\p{Is_Nv=000011/2}', "");
    Expect(0, 3887, '\p{^Is_Nv=000011/2}', "");
    Expect(0, 3887, '\P{Is_Nv=000011/2}', "");
    Expect(1, 3887, '\P{^Is_Nv=000011/2}', "");
    Expect(0, 3888, '\p{Is_Nv=000011/2}', "");
    Expect(1, 3888, '\p{^Is_Nv=000011/2}', "");
    Expect(1, 3888, '\P{Is_Nv=000011/2}', "");
    Expect(0, 3888, '\P{^Is_Nv=000011/2}', "");
    Expect(1, 3887, '\p{Is_Nv=5.500}', "");
    Expect(0, 3887, '\p{^Is_Nv=5.500}', "");
    Expect(0, 3887, '\P{Is_Nv=5.500}', "");
    Expect(1, 3887, '\P{^Is_Nv=5.500}', "");
    Expect(0, 3888, '\p{Is_Nv=5.500}', "");
    Expect(1, 3888, '\p{^Is_Nv=5.500}', "");
    Expect(1, 3888, '\P{Is_Nv=5.500}', "");
    Expect(0, 3888, '\P{^Is_Nv=5.500}', "");
    Error('\p{Numeric_Value=	/a/+0_0_0_12}');
    Error('\P{Numeric_Value=	/a/+0_0_0_12}');
    Expect(1, 9452, '\p{Numeric_Value=00012}', "");
    Expect(0, 9452, '\p{^Numeric_Value=00012}', "");
    Expect(0, 9452, '\P{Numeric_Value=00012}', "");
    Expect(1, 9452, '\P{^Numeric_Value=00012}', "");
    Expect(0, 9453, '\p{Numeric_Value=00012}', "");
    Expect(1, 9453, '\p{^Numeric_Value=00012}', "");
    Expect(1, 9453, '\P{Numeric_Value=00012}', "");
    Expect(0, 9453, '\P{^Numeric_Value=00012}', "");
    Error('\p{Nv=_+0_0_0_0_0_0_0_0012:=}');
    Error('\P{Nv=_+0_0_0_0_0_0_0_0012:=}');
    Expect(1, 9452, '\p{Nv:	+0000000012}', "");
    Expect(0, 9452, '\p{^Nv:	+0000000012}', "");
    Expect(0, 9452, '\P{Nv:	+0000000012}', "");
    Expect(1, 9452, '\P{^Nv:	+0000000012}', "");
    Expect(0, 9453, '\p{Nv:	+0000000012}', "");
    Expect(1, 9453, '\p{^Nv:	+0000000012}', "");
    Expect(1, 9453, '\P{Nv:	+0000000012}', "");
    Expect(0, 9453, '\P{^Nv:	+0000000012}', "");
    Error('\p{Is_Numeric_Value=-	0_0_12/a/}');
    Error('\P{Is_Numeric_Value=-	0_0_12/a/}');
    Expect(1, 9452, '\p{Is_Numeric_Value=+0_0_0_0_0012}', "");
    Expect(0, 9452, '\p{^Is_Numeric_Value=+0_0_0_0_0012}', "");
    Expect(0, 9452, '\P{Is_Numeric_Value=+0_0_0_0_0012}', "");
    Expect(1, 9452, '\P{^Is_Numeric_Value=+0_0_0_0_0012}', "");
    Expect(0, 9453, '\p{Is_Numeric_Value=+0_0_0_0_0012}', "");
    Expect(1, 9453, '\p{^Is_Numeric_Value=+0_0_0_0_0012}', "");
    Expect(1, 9453, '\P{Is_Numeric_Value=+0_0_0_0_0012}', "");
    Expect(0, 9453, '\P{^Is_Numeric_Value=+0_0_0_0_0012}', "");
    Error('\p{Is_Nv=	-+0_0_0_0_0_0_0_0012:=}');
    Error('\P{Is_Nv=	-+0_0_0_0_0_0_0_0012:=}');
    Expect(1, 9452, '\p{Is_Nv=000012}', "");
    Expect(0, 9452, '\p{^Is_Nv=000012}', "");
    Expect(0, 9452, '\P{Is_Nv=000012}', "");
    Expect(1, 9452, '\P{^Is_Nv=000012}', "");
    Expect(0, 9453, '\p{Is_Nv=000012}', "");
    Expect(1, 9453, '\p{^Is_Nv=000012}', "");
    Expect(1, 9453, '\P{Is_Nv=000012}', "");
    Expect(0, 9453, '\P{^Is_Nv=000012}', "");
    Error('\p{Numeric_Value=:=_+00013}');
    Error('\P{Numeric_Value=:=_+00013}');
    Expect(1, 9453, '\p{Numeric_Value=0_0_0_0_0_0_0_0_0_13}', "");
    Expect(0, 9453, '\p{^Numeric_Value=0_0_0_0_0_0_0_0_0_13}', "");
    Expect(0, 9453, '\P{Numeric_Value=0_0_0_0_0_0_0_0_0_13}', "");
    Expect(1, 9453, '\P{^Numeric_Value=0_0_0_0_0_0_0_0_0_13}', "");
    Expect(0, 9454, '\p{Numeric_Value=0_0_0_0_0_0_0_0_0_13}', "");
    Expect(1, 9454, '\p{^Numeric_Value=0_0_0_0_0_0_0_0_0_13}', "");
    Expect(1, 9454, '\P{Numeric_Value=0_0_0_0_0_0_0_0_0_13}', "");
    Expect(0, 9454, '\P{^Numeric_Value=0_0_0_0_0_0_0_0_0_13}', "");
    Error('\p{Nv=_/a/000000013}');
    Error('\P{Nv=_/a/000000013}');
    Expect(1, 9453, '\p{Nv=01_3}', "");
    Expect(0, 9453, '\p{^Nv=01_3}', "");
    Expect(0, 9453, '\P{Nv=01_3}', "");
    Expect(1, 9453, '\P{^Nv=01_3}', "");
    Expect(0, 9454, '\p{Nv=01_3}', "");
    Expect(1, 9454, '\p{^Nv=01_3}', "");
    Expect(1, 9454, '\P{Nv=01_3}', "");
    Expect(0, 9454, '\P{^Nv=01_3}', "");
    Error('\p{Is_Numeric_Value:	_/a/0013}');
    Error('\P{Is_Numeric_Value:	_/a/0013}');
    Expect(1, 9453, '\p{Is_Numeric_Value=0000000013}', "");
    Expect(0, 9453, '\p{^Is_Numeric_Value=0000000013}', "");
    Expect(0, 9453, '\P{Is_Numeric_Value=0000000013}', "");
    Expect(1, 9453, '\P{^Is_Numeric_Value=0000000013}', "");
    Expect(0, 9454, '\p{Is_Numeric_Value=0000000013}', "");
    Expect(1, 9454, '\p{^Is_Numeric_Value=0000000013}', "");
    Expect(1, 9454, '\P{Is_Numeric_Value=0000000013}', "");
    Expect(0, 9454, '\P{^Is_Numeric_Value=0000000013}', "");
    Error('\p{Is_Nv=/a/+013}');
    Error('\P{Is_Nv=/a/+013}');
    Expect(1, 9453, '\p{Is_Nv=013}', "");
    Expect(0, 9453, '\p{^Is_Nv=013}', "");
    Expect(0, 9453, '\P{Is_Nv=013}', "");
    Expect(1, 9453, '\P{^Is_Nv=013}', "");
    Expect(0, 9454, '\p{Is_Nv=013}', "");
    Expect(1, 9454, '\p{^Is_Nv=013}', "");
    Expect(1, 9454, '\P{Is_Nv=013}', "");
    Expect(0, 9454, '\P{^Is_Nv=013}', "");
    Error('\p{Numeric_Value=_:=00013/0000000002}');
    Error('\P{Numeric_Value=_:=00013/0000000002}');
    Expect(1, 3888, '\p{Numeric_Value=0000000013/000002}', "");
    Expect(0, 3888, '\p{^Numeric_Value=0000000013/000002}', "");
    Expect(0, 3888, '\P{Numeric_Value=0000000013/000002}', "");
    Expect(1, 3888, '\P{^Numeric_Value=0000000013/000002}', "");
    Expect(0, 3889, '\p{Numeric_Value=0000000013/000002}', "");
    Expect(1, 3889, '\p{^Numeric_Value=0000000013/000002}', "");
    Expect(1, 3889, '\P{Numeric_Value=0000000013/000002}', "");
    Expect(0, 3889, '\P{^Numeric_Value=0000000013/000002}', "");
    Expect(1, 3888, '\p{Numeric_Value: 6.500}', "");
    Expect(0, 3888, '\p{^Numeric_Value: 6.500}', "");
    Expect(0, 3888, '\P{Numeric_Value: 6.500}', "");
    Expect(1, 3888, '\P{^Numeric_Value: 6.500}', "");
    Expect(0, 3889, '\p{Numeric_Value: 6.500}', "");
    Expect(1, 3889, '\p{^Numeric_Value: 6.500}', "");
    Expect(1, 3889, '\P{Numeric_Value: 6.500}', "");
    Expect(0, 3889, '\P{^Numeric_Value: 6.500}', "");
    Error('\p{Nv=/a/00000000013/02}');
    Error('\P{Nv=/a/00000000013/02}');
    Expect(1, 3888, '\p{Nv=000013/00002}', "");
    Expect(0, 3888, '\p{^Nv=000013/00002}', "");
    Expect(0, 3888, '\P{Nv=000013/00002}', "");
    Expect(1, 3888, '\P{^Nv=000013/00002}', "");
    Expect(0, 3889, '\p{Nv=000013/00002}', "");
    Expect(1, 3889, '\p{^Nv=000013/00002}', "");
    Expect(1, 3889, '\P{Nv=000013/00002}', "");
    Expect(0, 3889, '\P{^Nv=000013/00002}', "");
    Expect(1, 3888, '\p{Nv=6.500}', "");
    Expect(0, 3888, '\p{^Nv=6.500}', "");
    Expect(0, 3888, '\P{Nv=6.500}', "");
    Expect(1, 3888, '\P{^Nv=6.500}', "");
    Expect(0, 3889, '\p{Nv=6.500}', "");
    Expect(1, 3889, '\p{^Nv=6.500}', "");
    Expect(1, 3889, '\P{Nv=6.500}', "");
    Expect(0, 3889, '\P{^Nv=6.500}', "");
    Error('\p{Is_Numeric_Value=/a/_ 013/000000002}');
    Error('\P{Is_Numeric_Value=/a/_ 013/000000002}');
    Expect(1, 3888, '\p{Is_Numeric_Value=+013/00002}', "");
    Expect(0, 3888, '\p{^Is_Numeric_Value=+013/00002}', "");
    Expect(0, 3888, '\P{Is_Numeric_Value=+013/00002}', "");
    Expect(1, 3888, '\P{^Is_Numeric_Value=+013/00002}', "");
    Expect(0, 3889, '\p{Is_Numeric_Value=+013/00002}', "");
    Expect(1, 3889, '\p{^Is_Numeric_Value=+013/00002}', "");
    Expect(1, 3889, '\P{Is_Numeric_Value=+013/00002}', "");
    Expect(0, 3889, '\P{^Is_Numeric_Value=+013/00002}', "");
    Expect(1, 3888, '\p{Is_Numeric_Value=6.500}', "");
    Expect(0, 3888, '\p{^Is_Numeric_Value=6.500}', "");
    Expect(0, 3888, '\P{Is_Numeric_Value=6.500}', "");
    Expect(1, 3888, '\P{^Is_Numeric_Value=6.500}', "");
    Expect(0, 3889, '\p{Is_Numeric_Value=6.500}', "");
    Expect(1, 3889, '\p{^Is_Numeric_Value=6.500}', "");
    Expect(1, 3889, '\P{Is_Numeric_Value=6.500}', "");
    Expect(0, 3889, '\P{^Is_Numeric_Value=6.500}', "");
    Error('\p{Is_Nv=	:=13/0000002}');
    Error('\P{Is_Nv=	:=13/0000002}');
    Expect(1, 3888, '\p{Is_Nv=00000000013/0002}', "");
    Expect(0, 3888, '\p{^Is_Nv=00000000013/0002}', "");
    Expect(0, 3888, '\P{Is_Nv=00000000013/0002}', "");
    Expect(1, 3888, '\P{^Is_Nv=00000000013/0002}', "");
    Expect(0, 3889, '\p{Is_Nv=00000000013/0002}', "");
    Expect(1, 3889, '\p{^Is_Nv=00000000013/0002}', "");
    Expect(1, 3889, '\P{Is_Nv=00000000013/0002}', "");
    Expect(0, 3889, '\P{^Is_Nv=00000000013/0002}', "");
    Expect(1, 3888, '\p{Is_Nv=6.500}', "");
    Expect(0, 3888, '\p{^Is_Nv=6.500}', "");
    Expect(0, 3888, '\P{Is_Nv=6.500}', "");
    Expect(1, 3888, '\P{^Is_Nv=6.500}', "");
    Expect(0, 3889, '\p{Is_Nv=6.500}', "");
    Expect(1, 3889, '\p{^Is_Nv=6.500}', "");
    Expect(1, 3889, '\P{Is_Nv=6.500}', "");
    Expect(0, 3889, '\P{^Is_Nv=6.500}', "");
    Error('\p{Numeric_Value=:=	 00000000014}');
    Error('\P{Numeric_Value=:=	 00000000014}');
    Expect(1, 9454, '\p{Numeric_Value=000000014}', "");
    Expect(0, 9454, '\p{^Numeric_Value=000000014}', "");
    Expect(0, 9454, '\P{Numeric_Value=000000014}', "");
    Expect(1, 9454, '\P{^Numeric_Value=000000014}', "");
    Expect(0, 9455, '\p{Numeric_Value=000000014}', "");
    Expect(1, 9455, '\p{^Numeric_Value=000000014}', "");
    Expect(1, 9455, '\P{Numeric_Value=000000014}', "");
    Expect(0, 9455, '\P{^Numeric_Value=000000014}', "");
    Error('\p{Nv:	:=_	014}');
    Error('\P{Nv:	:=_	014}');
    Expect(1, 9454, '\p{Nv=+00000000014}', "");
    Expect(0, 9454, '\p{^Nv=+00000000014}', "");
    Expect(0, 9454, '\P{Nv=+00000000014}', "");
    Expect(1, 9454, '\P{^Nv=+00000000014}', "");
    Expect(0, 9455, '\p{Nv=+00000000014}', "");
    Expect(1, 9455, '\p{^Nv=+00000000014}', "");
    Expect(1, 9455, '\P{Nv=+00000000014}', "");
    Expect(0, 9455, '\P{^Nv=+00000000014}', "");
    Error('\p{Is_Numeric_Value=	+014:=}');
    Error('\P{Is_Numeric_Value=	+014:=}');
    Expect(1, 9454, '\p{Is_Numeric_Value:   0_0_0_0_0_0_0_14}', "");
    Expect(0, 9454, '\p{^Is_Numeric_Value:   0_0_0_0_0_0_0_14}', "");
    Expect(0, 9454, '\P{Is_Numeric_Value:   0_0_0_0_0_0_0_14}', "");
    Expect(1, 9454, '\P{^Is_Numeric_Value:   0_0_0_0_0_0_0_14}', "");
    Expect(0, 9455, '\p{Is_Numeric_Value:   0_0_0_0_0_0_0_14}', "");
    Expect(1, 9455, '\p{^Is_Numeric_Value:   0_0_0_0_0_0_0_14}', "");
    Expect(1, 9455, '\P{Is_Numeric_Value:   0_0_0_0_0_0_0_14}', "");
    Expect(0, 9455, '\P{^Is_Numeric_Value:   0_0_0_0_0_0_0_14}', "");
    Error('\p{Is_Nv: := _0000000014}');
    Error('\P{Is_Nv: := _0000000014}');
    Expect(1, 9454, '\p{Is_Nv=1_4}', "");
    Expect(0, 9454, '\p{^Is_Nv=1_4}', "");
    Expect(0, 9454, '\P{Is_Nv=1_4}', "");
    Expect(1, 9454, '\P{^Is_Nv=1_4}', "");
    Expect(0, 9455, '\p{Is_Nv=1_4}', "");
    Expect(1, 9455, '\p{^Is_Nv=1_4}', "");
    Expect(1, 9455, '\P{Is_Nv=1_4}', "");
    Expect(0, 9455, '\P{^Is_Nv=1_4}', "");
    Error('\p{Numeric_Value=/a/ -+01_5}');
    Error('\P{Numeric_Value=/a/ -+01_5}');
    Expect(1, 9455, '\p{Numeric_Value=00015}', "");
    Expect(0, 9455, '\p{^Numeric_Value=00015}', "");
    Expect(0, 9455, '\P{Numeric_Value=00015}', "");
    Expect(1, 9455, '\P{^Numeric_Value=00015}', "");
    Expect(0, 9456, '\p{Numeric_Value=00015}', "");
    Expect(1, 9456, '\p{^Numeric_Value=00015}', "");
    Expect(1, 9456, '\P{Numeric_Value=00015}', "");
    Expect(0, 9456, '\P{^Numeric_Value=00015}', "");
    Error('\p{Nv=_:=0000015}');
    Error('\P{Nv=_:=0000015}');
    Expect(1, 9455, '\p{Nv=0000000015}', "");
    Expect(0, 9455, '\p{^Nv=0000000015}', "");
    Expect(0, 9455, '\P{Nv=0000000015}', "");
    Expect(1, 9455, '\P{^Nv=0000000015}', "");
    Expect(0, 9456, '\p{Nv=0000000015}', "");
    Expect(1, 9456, '\p{^Nv=0000000015}', "");
    Expect(1, 9456, '\P{Nv=0000000015}', "");
    Expect(0, 9456, '\P{^Nv=0000000015}', "");
    Error('\p{Is_Numeric_Value=:= +000000015}');
    Error('\P{Is_Numeric_Value=:= +000000015}');
    Expect(1, 9455, '\p{Is_Numeric_Value=0000000015}', "");
    Expect(0, 9455, '\p{^Is_Numeric_Value=0000000015}', "");
    Expect(0, 9455, '\P{Is_Numeric_Value=0000000015}', "");
    Expect(1, 9455, '\P{^Is_Numeric_Value=0000000015}', "");
    Expect(0, 9456, '\p{Is_Numeric_Value=0000000015}', "");
    Expect(1, 9456, '\p{^Is_Numeric_Value=0000000015}', "");
    Expect(1, 9456, '\P{Is_Numeric_Value=0000000015}', "");
    Expect(0, 9456, '\P{^Is_Numeric_Value=0000000015}', "");
    Error('\p{Is_Nv=:=_-00000015}');
    Error('\P{Is_Nv=:=_-00000015}');
    Expect(1, 9455, '\p{Is_Nv=01_5}', "");
    Expect(0, 9455, '\p{^Is_Nv=01_5}', "");
    Expect(0, 9455, '\P{Is_Nv=01_5}', "");
    Expect(1, 9455, '\P{^Is_Nv=01_5}', "");
    Expect(0, 9456, '\p{Is_Nv=01_5}', "");
    Expect(1, 9456, '\p{^Is_Nv=01_5}', "");
    Expect(1, 9456, '\P{Is_Nv=01_5}', "");
    Expect(0, 9456, '\P{^Is_Nv=01_5}', "");
    Error('\p{Numeric_Value=/a/ -0000000015/02}');
    Error('\P{Numeric_Value=/a/ -0000000015/02}');
    Expect(1, 3889, '\p{Numeric_Value=+15/00000002}', "");
    Expect(0, 3889, '\p{^Numeric_Value=+15/00000002}', "");
    Expect(0, 3889, '\P{Numeric_Value=+15/00000002}', "");
    Expect(1, 3889, '\P{^Numeric_Value=+15/00000002}', "");
    Expect(0, 3890, '\p{Numeric_Value=+15/00000002}', "");
    Expect(1, 3890, '\p{^Numeric_Value=+15/00000002}', "");
    Expect(1, 3890, '\P{Numeric_Value=+15/00000002}', "");
    Expect(0, 3890, '\P{^Numeric_Value=+15/00000002}', "");
    Expect(1, 3889, '\p{Numeric_Value:	7.500}', "");
    Expect(0, 3889, '\p{^Numeric_Value:	7.500}', "");
    Expect(0, 3889, '\P{Numeric_Value:	7.500}', "");
    Expect(1, 3889, '\P{^Numeric_Value:	7.500}', "");
    Expect(0, 3890, '\p{Numeric_Value:	7.500}', "");
    Expect(1, 3890, '\p{^Numeric_Value:	7.500}', "");
    Expect(1, 3890, '\P{Numeric_Value:	7.500}', "");
    Expect(0, 3890, '\P{^Numeric_Value:	7.500}', "");
    Error('\p{Nv=:=+0015/00000002}');
    Error('\P{Nv=:=+0015/00000002}');
    Expect(1, 3889, '\p{Nv=+000000015/000002}', "");
    Expect(0, 3889, '\p{^Nv=+000000015/000002}', "");
    Expect(0, 3889, '\P{Nv=+000000015/000002}', "");
    Expect(1, 3889, '\P{^Nv=+000000015/000002}', "");
    Expect(0, 3890, '\p{Nv=+000000015/000002}', "");
    Expect(1, 3890, '\p{^Nv=+000000015/000002}', "");
    Expect(1, 3890, '\P{Nv=+000000015/000002}', "");
    Expect(0, 3890, '\P{^Nv=+000000015/000002}', "");
    Expect(1, 3889, '\p{Nv=7.500}', "");
    Expect(0, 3889, '\p{^Nv=7.500}', "");
    Expect(0, 3889, '\P{Nv=7.500}', "");
    Expect(1, 3889, '\P{^Nv=7.500}', "");
    Expect(0, 3890, '\p{Nv=7.500}', "");
    Expect(1, 3890, '\p{^Nv=7.500}', "");
    Expect(1, 3890, '\P{Nv=7.500}', "");
    Expect(0, 3890, '\P{^Nv=7.500}', "");
    Error('\p{Is_Numeric_Value=015/002:=}');
    Error('\P{Is_Numeric_Value=015/002:=}');
    Expect(1, 3889, '\p{Is_Numeric_Value:	+000015/2}', "");
    Expect(0, 3889, '\p{^Is_Numeric_Value:	+000015/2}', "");
    Expect(0, 3889, '\P{Is_Numeric_Value:	+000015/2}', "");
    Expect(1, 3889, '\P{^Is_Numeric_Value:	+000015/2}', "");
    Expect(0, 3890, '\p{Is_Numeric_Value:	+000015/2}', "");
    Expect(1, 3890, '\p{^Is_Numeric_Value:	+000015/2}', "");
    Expect(1, 3890, '\P{Is_Numeric_Value:	+000015/2}', "");
    Expect(0, 3890, '\P{^Is_Numeric_Value:	+000015/2}', "");
    Expect(1, 3889, '\p{Is_Numeric_Value=7.500}', "");
    Expect(0, 3889, '\p{^Is_Numeric_Value=7.500}', "");
    Expect(0, 3889, '\P{Is_Numeric_Value=7.500}', "");
    Expect(1, 3889, '\P{^Is_Numeric_Value=7.500}', "");
    Expect(0, 3890, '\p{Is_Numeric_Value=7.500}', "");
    Expect(1, 3890, '\p{^Is_Numeric_Value=7.500}', "");
    Expect(1, 3890, '\P{Is_Numeric_Value=7.500}', "");
    Expect(0, 3890, '\P{^Is_Numeric_Value=7.500}', "");
    Error('\p{Is_Nv: 	:=015/00002}');
    Error('\P{Is_Nv: 	:=015/00002}');
    Expect(1, 3889, '\p{Is_Nv=+0000015/00002}', "");
    Expect(0, 3889, '\p{^Is_Nv=+0000015/00002}', "");
    Expect(0, 3889, '\P{Is_Nv=+0000015/00002}', "");
    Expect(1, 3889, '\P{^Is_Nv=+0000015/00002}', "");
    Expect(0, 3890, '\p{Is_Nv=+0000015/00002}', "");
    Expect(1, 3890, '\p{^Is_Nv=+0000015/00002}', "");
    Expect(1, 3890, '\P{Is_Nv=+0000015/00002}', "");
    Expect(0, 3890, '\P{^Is_Nv=+0000015/00002}', "");
    Expect(1, 3889, '\p{Is_Nv:	7.500}', "");
    Expect(0, 3889, '\p{^Is_Nv:	7.500}', "");
    Expect(0, 3889, '\P{Is_Nv:	7.500}', "");
    Expect(1, 3889, '\P{^Is_Nv:	7.500}', "");
    Expect(0, 3890, '\p{Is_Nv:	7.500}', "");
    Expect(1, 3890, '\p{^Is_Nv:	7.500}', "");
    Expect(1, 3890, '\P{Is_Nv:	7.500}', "");
    Expect(0, 3890, '\P{^Is_Nv:	7.500}', "");
    Error('\p{Numeric_Value=:=-	00000000016}');
    Error('\P{Numeric_Value=:=-	00000000016}');
    Expect(1, 9456, '\p{Numeric_Value=000000016}', "");
    Expect(0, 9456, '\p{^Numeric_Value=000000016}', "");
    Expect(0, 9456, '\P{Numeric_Value=000000016}', "");
    Expect(1, 9456, '\P{^Numeric_Value=000000016}', "");
    Expect(0, 9457, '\p{Numeric_Value=000000016}', "");
    Expect(1, 9457, '\p{^Numeric_Value=000000016}', "");
    Expect(1, 9457, '\P{Numeric_Value=000000016}', "");
    Expect(0, 9457, '\P{^Numeric_Value=000000016}', "");
    Error('\p{Nv=/a/__1_6}');
    Error('\P{Nv=/a/__1_6}');
    Expect(1, 9456, '\p{Nv=0_0_0_0_16}', "");
    Expect(0, 9456, '\p{^Nv=0_0_0_0_16}', "");
    Expect(0, 9456, '\P{Nv=0_0_0_0_16}', "");
    Expect(1, 9456, '\P{^Nv=0_0_0_0_16}', "");
    Expect(0, 9457, '\p{Nv=0_0_0_0_16}', "");
    Expect(1, 9457, '\p{^Nv=0_0_0_0_16}', "");
    Expect(1, 9457, '\P{Nv=0_0_0_0_16}', "");
    Expect(0, 9457, '\P{^Nv=0_0_0_0_16}', "");
    Error('\p{Is_Numeric_Value=-_0_0_0_0_0_0_0_0_16:=}');
    Error('\P{Is_Numeric_Value=-_0_0_0_0_0_0_0_0_16:=}');
    Expect(1, 9456, '\p{Is_Numeric_Value=00000016}', "");
    Expect(0, 9456, '\p{^Is_Numeric_Value=00000016}', "");
    Expect(0, 9456, '\P{Is_Numeric_Value=00000016}', "");
    Expect(1, 9456, '\P{^Is_Numeric_Value=00000016}', "");
    Expect(0, 9457, '\p{Is_Numeric_Value=00000016}', "");
    Expect(1, 9457, '\p{^Is_Numeric_Value=00000016}', "");
    Expect(1, 9457, '\P{Is_Numeric_Value=00000016}', "");
    Expect(0, 9457, '\P{^Is_Numeric_Value=00000016}', "");
    Error('\p{Is_Nv=:=		+000001_6}');
    Error('\P{Is_Nv=:=		+000001_6}');
    Expect(1, 9456, '\p{Is_Nv=00000000016}', "");
    Expect(0, 9456, '\p{^Is_Nv=00000000016}', "");
    Expect(0, 9456, '\P{Is_Nv=00000000016}', "");
    Expect(1, 9456, '\P{^Is_Nv=00000000016}', "");
    Expect(0, 9457, '\p{Is_Nv=00000000016}', "");
    Expect(1, 9457, '\p{^Is_Nv=00000000016}', "");
    Expect(1, 9457, '\P{Is_Nv=00000000016}', "");
    Expect(0, 9457, '\P{^Is_Nv=00000000016}', "");
    Error('\p{Numeric_Value=:= _017}');
    Error('\P{Numeric_Value=:= _017}');
    Expect(1, 9457, '\p{Numeric_Value=1_7}', "");
    Expect(0, 9457, '\p{^Numeric_Value=1_7}', "");
    Expect(0, 9457, '\P{Numeric_Value=1_7}', "");
    Expect(1, 9457, '\P{^Numeric_Value=1_7}', "");
    Expect(0, 9458, '\p{Numeric_Value=1_7}', "");
    Expect(1, 9458, '\p{^Numeric_Value=1_7}', "");
    Expect(1, 9458, '\P{Numeric_Value=1_7}', "");
    Expect(0, 9458, '\P{^Numeric_Value=1_7}', "");
    Error('\p{Nv:	-:=01_7}');
    Error('\P{Nv:	-:=01_7}');
    Expect(1, 9457, '\p{Nv=+000000017}', "");
    Expect(0, 9457, '\p{^Nv=+000000017}', "");
    Expect(0, 9457, '\P{Nv=+000000017}', "");
    Expect(1, 9457, '\P{^Nv=+000000017}', "");
    Expect(0, 9458, '\p{Nv=+000000017}', "");
    Expect(1, 9458, '\p{^Nv=+000000017}', "");
    Expect(1, 9458, '\P{Nv=+000000017}', "");
    Expect(0, 9458, '\P{^Nv=+000000017}', "");
    Error('\p{Is_Numeric_Value=:=-	000017}');
    Error('\P{Is_Numeric_Value=:=-	000017}');
    Expect(1, 9457, '\p{Is_Numeric_Value=01_7}', "");
    Expect(0, 9457, '\p{^Is_Numeric_Value=01_7}', "");
    Expect(0, 9457, '\P{Is_Numeric_Value=01_7}', "");
    Expect(1, 9457, '\P{^Is_Numeric_Value=01_7}', "");
    Expect(0, 9458, '\p{Is_Numeric_Value=01_7}', "");
    Expect(1, 9458, '\p{^Is_Numeric_Value=01_7}', "");
    Expect(1, 9458, '\P{Is_Numeric_Value=01_7}', "");
    Expect(0, 9458, '\P{^Is_Numeric_Value=01_7}', "");
    Error('\p{Is_Nv=/a/	-0000017}');
    Error('\P{Is_Nv=/a/	-0000017}');
    Expect(1, 9457, '\p{Is_Nv=000000017}', "");
    Expect(0, 9457, '\p{^Is_Nv=000000017}', "");
    Expect(0, 9457, '\P{Is_Nv=000000017}', "");
    Expect(1, 9457, '\P{^Is_Nv=000000017}', "");
    Expect(0, 9458, '\p{Is_Nv=000000017}', "");
    Expect(1, 9458, '\p{^Is_Nv=000000017}', "");
    Expect(1, 9458, '\P{Is_Nv=000000017}', "");
    Expect(0, 9458, '\P{^Is_Nv=000000017}', "");
    Error('\p{Numeric_Value=/a/00017/00000002}');
    Error('\P{Numeric_Value=/a/00017/00000002}');
    Expect(1, 3890, '\p{Numeric_Value=+17/002}', "");
    Expect(0, 3890, '\p{^Numeric_Value=+17/002}', "");
    Expect(0, 3890, '\P{Numeric_Value=+17/002}', "");
    Expect(1, 3890, '\P{^Numeric_Value=+17/002}', "");
    Expect(0, 3891, '\p{Numeric_Value=+17/002}', "");
    Expect(1, 3891, '\p{^Numeric_Value=+17/002}', "");
    Expect(1, 3891, '\P{Numeric_Value=+17/002}', "");
    Expect(0, 3891, '\P{^Numeric_Value=+17/002}', "");
    Expect(1, 3890, '\p{Numeric_Value=8.500}', "");
    Expect(0, 3890, '\p{^Numeric_Value=8.500}', "");
    Expect(0, 3890, '\P{Numeric_Value=8.500}', "");
    Expect(1, 3890, '\P{^Numeric_Value=8.500}', "");
    Expect(0, 3891, '\p{Numeric_Value=8.500}', "");
    Expect(1, 3891, '\p{^Numeric_Value=8.500}', "");
    Expect(1, 3891, '\P{Numeric_Value=8.500}', "");
    Expect(0, 3891, '\P{^Numeric_Value=8.500}', "");
    Error('\p{Nv: -:=000000017/000000002}');
    Error('\P{Nv: -:=000000017/000000002}');
    Expect(1, 3890, '\p{Nv:   0000000017/00002}', "");
    Expect(0, 3890, '\p{^Nv:   0000000017/00002}', "");
    Expect(0, 3890, '\P{Nv:   0000000017/00002}', "");
    Expect(1, 3890, '\P{^Nv:   0000000017/00002}', "");
    Expect(0, 3891, '\p{Nv:   0000000017/00002}', "");
    Expect(1, 3891, '\p{^Nv:   0000000017/00002}', "");
    Expect(1, 3891, '\P{Nv:   0000000017/00002}', "");
    Expect(0, 3891, '\P{^Nv:   0000000017/00002}', "");
    Expect(1, 3890, '\p{Nv=8.500}', "");
    Expect(0, 3890, '\p{^Nv=8.500}', "");
    Expect(0, 3890, '\P{Nv=8.500}', "");
    Expect(1, 3890, '\P{^Nv=8.500}', "");
    Expect(0, 3891, '\p{Nv=8.500}', "");
    Expect(1, 3891, '\p{^Nv=8.500}', "");
    Expect(1, 3891, '\P{Nv=8.500}', "");
    Expect(0, 3891, '\P{^Nv=8.500}', "");
    Error('\p{Is_Numeric_Value=/a/ 0000000017/2}');
    Error('\P{Is_Numeric_Value=/a/ 0000000017/2}');
    Expect(1, 3890, '\p{Is_Numeric_Value=0000017/00002}', "");
    Expect(0, 3890, '\p{^Is_Numeric_Value=0000017/00002}', "");
    Expect(0, 3890, '\P{Is_Numeric_Value=0000017/00002}', "");
    Expect(1, 3890, '\P{^Is_Numeric_Value=0000017/00002}', "");
    Expect(0, 3891, '\p{Is_Numeric_Value=0000017/00002}', "");
    Expect(1, 3891, '\p{^Is_Numeric_Value=0000017/00002}', "");
    Expect(1, 3891, '\P{Is_Numeric_Value=0000017/00002}', "");
    Expect(0, 3891, '\P{^Is_Numeric_Value=0000017/00002}', "");
    Expect(1, 3890, '\p{Is_Numeric_Value=8.500}', "");
    Expect(0, 3890, '\p{^Is_Numeric_Value=8.500}', "");
    Expect(0, 3890, '\P{Is_Numeric_Value=8.500}', "");
    Expect(1, 3890, '\P{^Is_Numeric_Value=8.500}', "");
    Expect(0, 3891, '\p{Is_Numeric_Value=8.500}', "");
    Expect(1, 3891, '\p{^Is_Numeric_Value=8.500}', "");
    Expect(1, 3891, '\P{Is_Numeric_Value=8.500}', "");
    Expect(0, 3891, '\P{^Is_Numeric_Value=8.500}', "");
    Error('\p{Is_Nv=/a/  +00000000017/000000002}');
    Error('\P{Is_Nv=/a/  +00000000017/000000002}');
    Expect(1, 3890, '\p{Is_Nv=17/00002}', "");
    Expect(0, 3890, '\p{^Is_Nv=17/00002}', "");
    Expect(0, 3890, '\P{Is_Nv=17/00002}', "");
    Expect(1, 3890, '\P{^Is_Nv=17/00002}', "");
    Expect(0, 3891, '\p{Is_Nv=17/00002}', "");
    Expect(1, 3891, '\p{^Is_Nv=17/00002}', "");
    Expect(1, 3891, '\P{Is_Nv=17/00002}', "");
    Expect(0, 3891, '\P{^Is_Nv=17/00002}', "");
    Expect(1, 3890, '\p{Is_Nv=8.500}', "");
    Expect(0, 3890, '\p{^Is_Nv=8.500}', "");
    Expect(0, 3890, '\P{Is_Nv=8.500}', "");
    Expect(1, 3890, '\P{^Is_Nv=8.500}', "");
    Expect(0, 3891, '\p{Is_Nv=8.500}', "");
    Expect(1, 3891, '\p{^Is_Nv=8.500}', "");
    Expect(1, 3891, '\P{Is_Nv=8.500}', "");
    Expect(0, 3891, '\P{^Is_Nv=8.500}', "");
    Error('\p{Numeric_Value=/a/_	+0_0_0_0_0_0_00018}');
    Error('\P{Numeric_Value=/a/_	+0_0_0_0_0_0_00018}');
    Expect(1, 9458, '\p{Numeric_Value=000_000_001_8}', "");
    Expect(0, 9458, '\p{^Numeric_Value=000_000_001_8}', "");
    Expect(0, 9458, '\P{Numeric_Value=000_000_001_8}', "");
    Expect(1, 9458, '\P{^Numeric_Value=000_000_001_8}', "");
    Expect(0, 9459, '\p{Numeric_Value=000_000_001_8}', "");
    Expect(1, 9459, '\p{^Numeric_Value=000_000_001_8}', "");
    Expect(1, 9459, '\P{Numeric_Value=000_000_001_8}', "");
    Expect(0, 9459, '\P{^Numeric_Value=000_000_001_8}', "");
    Error('\p{Nv=/a/- 018}');
    Error('\P{Nv=/a/- 018}');
    Expect(1, 9458, '\p{Nv=000_000_000_18}', "");
    Expect(0, 9458, '\p{^Nv=000_000_000_18}', "");
    Expect(0, 9458, '\P{Nv=000_000_000_18}', "");
    Expect(1, 9458, '\P{^Nv=000_000_000_18}', "");
    Expect(0, 9459, '\p{Nv=000_000_000_18}', "");
    Expect(1, 9459, '\p{^Nv=000_000_000_18}', "");
    Expect(1, 9459, '\P{Nv=000_000_000_18}', "");
    Expect(0, 9459, '\P{^Nv=000_000_000_18}', "");
    Error('\p{Is_Numeric_Value=:=_	00018}');
    Error('\P{Is_Numeric_Value=:=_	00018}');
    Expect(1, 9458, '\p{Is_Numeric_Value=+00000000018}', "");
    Expect(0, 9458, '\p{^Is_Numeric_Value=+00000000018}', "");
    Expect(0, 9458, '\P{Is_Numeric_Value=+00000000018}', "");
    Expect(1, 9458, '\P{^Is_Numeric_Value=+00000000018}', "");
    Expect(0, 9459, '\p{Is_Numeric_Value=+00000000018}', "");
    Expect(1, 9459, '\p{^Is_Numeric_Value=+00000000018}', "");
    Expect(1, 9459, '\P{Is_Numeric_Value=+00000000018}', "");
    Expect(0, 9459, '\P{^Is_Numeric_Value=+00000000018}', "");
    Error('\p{Is_Nv=_:=+00001_8}');
    Error('\P{Is_Nv=_:=+00001_8}');
    Expect(1, 9458, '\p{Is_Nv=000_001_8}', "");
    Expect(0, 9458, '\p{^Is_Nv=000_001_8}', "");
    Expect(0, 9458, '\P{Is_Nv=000_001_8}', "");
    Expect(1, 9458, '\P{^Is_Nv=000_001_8}', "");
    Expect(0, 9459, '\p{Is_Nv=000_001_8}', "");
    Expect(1, 9459, '\p{^Is_Nv=000_001_8}', "");
    Expect(1, 9459, '\P{Is_Nv=000_001_8}', "");
    Expect(0, 9459, '\P{^Is_Nv=000_001_8}', "");
    Error('\p{Numeric_Value=:= 00_00_01_9}');
    Error('\P{Numeric_Value=:= 00_00_01_9}');
    Expect(1, 9459, '\p{Numeric_Value=001_9}', "");
    Expect(0, 9459, '\p{^Numeric_Value=001_9}', "");
    Expect(0, 9459, '\P{Numeric_Value=001_9}', "");
    Expect(1, 9459, '\P{^Numeric_Value=001_9}', "");
    Expect(0, 9460, '\p{Numeric_Value=001_9}', "");
    Expect(1, 9460, '\p{^Numeric_Value=001_9}', "");
    Expect(1, 9460, '\P{Numeric_Value=001_9}', "");
    Expect(0, 9460, '\P{^Numeric_Value=001_9}', "");
    Error('\p{Nv=_-0_0_0_019/a/}');
    Error('\P{Nv=_-0_0_0_019/a/}');
    Expect(1, 9459, '\p{Nv=0_0_0_0_0_0_0_019}', "");
    Expect(0, 9459, '\p{^Nv=0_0_0_0_0_0_0_019}', "");
    Expect(0, 9459, '\P{Nv=0_0_0_0_0_0_0_019}', "");
    Expect(1, 9459, '\P{^Nv=0_0_0_0_0_0_0_019}', "");
    Expect(0, 9460, '\p{Nv=0_0_0_0_0_0_0_019}', "");
    Expect(1, 9460, '\p{^Nv=0_0_0_0_0_0_0_019}', "");
    Expect(1, 9460, '\P{Nv=0_0_0_0_0_0_0_019}', "");
    Expect(0, 9460, '\P{^Nv=0_0_0_0_0_0_0_019}', "");
    Error('\p{Is_Numeric_Value= 	+0_0_0_0_19/a/}');
    Error('\P{Is_Numeric_Value= 	+0_0_0_0_19/a/}');
    Expect(1, 9459, '\p{Is_Numeric_Value=+00_00_00_19}', "");
    Expect(0, 9459, '\p{^Is_Numeric_Value=+00_00_00_19}', "");
    Expect(0, 9459, '\P{Is_Numeric_Value=+00_00_00_19}', "");
    Expect(1, 9459, '\P{^Is_Numeric_Value=+00_00_00_19}', "");
    Expect(0, 9460, '\p{Is_Numeric_Value=+00_00_00_19}', "");
    Expect(1, 9460, '\p{^Is_Numeric_Value=+00_00_00_19}', "");
    Expect(1, 9460, '\P{Is_Numeric_Value=+00_00_00_19}', "");
    Expect(0, 9460, '\P{^Is_Numeric_Value=+00_00_00_19}', "");
    Error('\p{Is_Nv=/a/+0_0_19}');
    Error('\P{Is_Nv=/a/+0_0_19}');
    Expect(1, 9459, '\p{Is_Nv=00000000019}', "");
    Expect(0, 9459, '\p{^Is_Nv=00000000019}', "");
    Expect(0, 9459, '\P{Is_Nv=00000000019}', "");
    Expect(1, 9459, '\P{^Is_Nv=00000000019}', "");
    Expect(0, 9460, '\p{Is_Nv=00000000019}', "");
    Expect(1, 9460, '\p{^Is_Nv=00000000019}', "");
    Expect(1, 9460, '\P{Is_Nv=00000000019}', "");
    Expect(0, 9460, '\P{^Is_Nv=00000000019}', "");
    Error('\p{Numeric_Value:	_:=+2}');
    Error('\P{Numeric_Value:	_:=+2}');
    Expect(1, 140176, '\p{Numeric_Value=+2}', "");
    Expect(0, 140176, '\p{^Numeric_Value=+2}', "");
    Expect(0, 140176, '\P{Numeric_Value=+2}', "");
    Expect(1, 140176, '\P{^Numeric_Value=+2}', "");
    Expect(0, 140177, '\p{Numeric_Value=+2}', "");
    Expect(1, 140177, '\p{^Numeric_Value=+2}', "");
    Expect(1, 140177, '\P{Numeric_Value=+2}', "");
    Expect(0, 140177, '\P{^Numeric_Value=+2}', "");
    Error('\p{Nv=/a/_-0002}');
    Error('\P{Nv=/a/_-0002}');
    Expect(1, 140176, '\p{Nv=0000002}', "");
    Expect(0, 140176, '\p{^Nv=0000002}', "");
    Expect(0, 140176, '\P{Nv=0000002}', "");
    Expect(1, 140176, '\P{^Nv=0000002}', "");
    Expect(0, 140177, '\p{Nv=0000002}', "");
    Expect(1, 140177, '\p{^Nv=0000002}', "");
    Expect(1, 140177, '\P{Nv=0000002}', "");
    Expect(0, 140177, '\P{^Nv=0000002}', "");
    Error('\p{Is_Numeric_Value=-:=+0_0_0_0_0002}');
    Error('\P{Is_Numeric_Value=-:=+0_0_0_0_0002}');
    Expect(1, 140176, '\p{Is_Numeric_Value=00_2}', "");
    Expect(0, 140176, '\p{^Is_Numeric_Value=00_2}', "");
    Expect(0, 140176, '\P{Is_Numeric_Value=00_2}', "");
    Expect(1, 140176, '\P{^Is_Numeric_Value=00_2}', "");
    Expect(0, 140177, '\p{Is_Numeric_Value=00_2}', "");
    Expect(1, 140177, '\p{^Is_Numeric_Value=00_2}', "");
    Expect(1, 140177, '\P{Is_Numeric_Value=00_2}', "");
    Expect(0, 140177, '\P{^Is_Numeric_Value=00_2}', "");
    Error('\p{Is_Nv=:=_+02}');
    Error('\P{Is_Nv=:=_+02}');
    Expect(1, 140176, '\p{Is_Nv=+2}', "");
    Expect(0, 140176, '\p{^Is_Nv=+2}', "");
    Expect(0, 140176, '\P{Is_Nv=+2}', "");
    Expect(1, 140176, '\P{^Is_Nv=+2}', "");
    Expect(0, 140177, '\p{Is_Nv=+2}', "");
    Expect(1, 140177, '\p{^Is_Nv=+2}', "");
    Expect(1, 140177, '\P{Is_Nv=+2}', "");
    Expect(0, 140177, '\P{^Is_Nv=+2}', "");
    Error('\p{Numeric_Value=-:=00000002/00003}');
    Error('\P{Numeric_Value=-:=00000002/00003}');
    Expect(1, 74854, '\p{Numeric_Value:+00000002/000000003}', "");
    Expect(0, 74854, '\p{^Numeric_Value:+00000002/000000003}', "");
    Expect(0, 74854, '\P{Numeric_Value:+00000002/000000003}', "");
    Expect(1, 74854, '\P{^Numeric_Value:+00000002/000000003}', "");
    Expect(0, 74855, '\p{Numeric_Value:+00000002/000000003}', "");
    Expect(1, 74855, '\p{^Numeric_Value:+00000002/000000003}', "");
    Expect(1, 74855, '\P{Numeric_Value:+00000002/000000003}', "");
    Expect(0, 74855, '\P{^Numeric_Value:+00000002/000000003}', "");
    Error('\p{Numeric_Value=0.7}');
    Error('\P{Numeric_Value=0.7}');
    Error('\p{Numeric_Value=0.67}');
    Error('\P{Numeric_Value=0.67}');
    Expect(1, 74854, '\p{Numeric_Value:	0.667}', "");
    Expect(0, 74854, '\p{^Numeric_Value:	0.667}', "");
    Expect(0, 74854, '\P{Numeric_Value:	0.667}', "");
    Expect(1, 74854, '\P{^Numeric_Value:	0.667}', "");
    Expect(0, 74855, '\p{Numeric_Value:	0.667}', "");
    Expect(1, 74855, '\p{^Numeric_Value:	0.667}', "");
    Expect(1, 74855, '\P{Numeric_Value:	0.667}', "");
    Expect(0, 74855, '\P{^Numeric_Value:	0.667}', "");
    Error('\p{Nv=:=02/0000003}');
    Error('\P{Nv=:=02/0000003}');
    Expect(1, 74854, '\p{Nv=+0000000002/3}', "");
    Expect(0, 74854, '\p{^Nv=+0000000002/3}', "");
    Expect(0, 74854, '\P{Nv=+0000000002/3}', "");
    Expect(1, 74854, '\P{^Nv=+0000000002/3}', "");
    Expect(0, 74855, '\p{Nv=+0000000002/3}', "");
    Expect(1, 74855, '\p{^Nv=+0000000002/3}', "");
    Expect(1, 74855, '\P{Nv=+0000000002/3}', "");
    Expect(0, 74855, '\P{^Nv=+0000000002/3}', "");
    Error('\p{Nv=0.7}');
    Error('\P{Nv=0.7}');
    Error('\p{Nv=0.67}');
    Error('\P{Nv=0.67}');
    Expect(1, 74854, '\p{Nv=0.667}', "");
    Expect(0, 74854, '\p{^Nv=0.667}', "");
    Expect(0, 74854, '\P{Nv=0.667}', "");
    Expect(1, 74854, '\P{^Nv=0.667}', "");
    Expect(0, 74855, '\p{Nv=0.667}', "");
    Expect(1, 74855, '\p{^Nv=0.667}', "");
    Expect(1, 74855, '\P{Nv=0.667}', "");
    Expect(0, 74855, '\P{^Nv=0.667}', "");
    Error('\p{Is_Numeric_Value=/a/+000002/03}');
    Error('\P{Is_Numeric_Value=/a/+000002/03}');
    Expect(1, 74854, '\p{Is_Numeric_Value=000002/0000003}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value=000002/0000003}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value=000002/0000003}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value=000002/0000003}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value=000002/0000003}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value=000002/0000003}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value=000002/0000003}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value=000002/0000003}', "");
    Error('\p{Is_Numeric_Value=0.7}');
    Error('\P{Is_Numeric_Value=0.7}');
    Error('\p{Is_Numeric_Value=0.67}');
    Error('\P{Is_Numeric_Value=0.67}');
    Expect(1, 74854, '\p{Is_Numeric_Value=0.667}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value=0.667}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value=0.667}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value=0.667}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value=0.667}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value=0.667}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value=0.667}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value=0.667}', "");
    Error('\p{Is_Nv=+000000002/0003:=}');
    Error('\P{Is_Nv=+000000002/0003:=}');
    Expect(1, 74854, '\p{Is_Nv=+000000002/0000003}', "");
    Expect(0, 74854, '\p{^Is_Nv=+000000002/0000003}', "");
    Expect(0, 74854, '\P{Is_Nv=+000000002/0000003}', "");
    Expect(1, 74854, '\P{^Is_Nv=+000000002/0000003}', "");
    Expect(0, 74855, '\p{Is_Nv=+000000002/0000003}', "");
    Expect(1, 74855, '\p{^Is_Nv=+000000002/0000003}', "");
    Expect(1, 74855, '\P{Is_Nv=+000000002/0000003}', "");
    Expect(0, 74855, '\P{^Is_Nv=+000000002/0000003}', "");
    Error('\p{Is_Nv=0.7}');
    Error('\P{Is_Nv=0.7}');
    Error('\p{Is_Nv=0.67}');
    Error('\P{Is_Nv=0.67}');
    Expect(1, 74854, '\p{Is_Nv=0.667}', "");
    Expect(0, 74854, '\p{^Is_Nv=0.667}', "");
    Expect(0, 74854, '\P{Is_Nv=0.667}', "");
    Expect(1, 74854, '\P{^Is_Nv=0.667}', "");
    Expect(0, 74855, '\p{Is_Nv=0.667}', "");
    Expect(1, 74855, '\p{^Is_Nv=0.667}', "");
    Expect(1, 74855, '\P{Is_Nv=0.667}', "");
    Expect(0, 74855, '\P{^Is_Nv=0.667}', "");
    Error('\p{Numeric_Value=+002/0000005:=}');
    Error('\P{Numeric_Value=+002/0000005:=}');
    Expect(1, 8534, '\p{Numeric_Value=02/0000005}', "");
    Expect(0, 8534, '\p{^Numeric_Value=02/0000005}', "");
    Expect(0, 8534, '\P{Numeric_Value=02/0000005}', "");
    Expect(1, 8534, '\P{^Numeric_Value=02/0000005}', "");
    Expect(0, 8535, '\p{Numeric_Value=02/0000005}', "");
    Expect(1, 8535, '\p{^Numeric_Value=02/0000005}', "");
    Expect(1, 8535, '\P{Numeric_Value=02/0000005}', "");
    Expect(0, 8535, '\P{^Numeric_Value=02/0000005}', "");
    Expect(1, 8534, '\p{Numeric_Value=0.400}', "");
    Expect(0, 8534, '\p{^Numeric_Value=0.400}', "");
    Expect(0, 8534, '\P{Numeric_Value=0.400}', "");
    Expect(1, 8534, '\P{^Numeric_Value=0.400}', "");
    Expect(0, 8535, '\p{Numeric_Value=0.400}', "");
    Expect(1, 8535, '\p{^Numeric_Value=0.400}', "");
    Expect(1, 8535, '\P{Numeric_Value=0.400}', "");
    Expect(0, 8535, '\P{^Numeric_Value=0.400}', "");
    Error('\p{Nv=:=  +2/00000005}');
    Error('\P{Nv=:=  +2/00000005}');
    Expect(1, 8534, '\p{Nv=000002/5}', "");
    Expect(0, 8534, '\p{^Nv=000002/5}', "");
    Expect(0, 8534, '\P{Nv=000002/5}', "");
    Expect(1, 8534, '\P{^Nv=000002/5}', "");
    Expect(0, 8535, '\p{Nv=000002/5}', "");
    Expect(1, 8535, '\p{^Nv=000002/5}', "");
    Expect(1, 8535, '\P{Nv=000002/5}', "");
    Expect(0, 8535, '\P{^Nv=000002/5}', "");
    Expect(1, 8534, '\p{Nv=0.400}', "");
    Expect(0, 8534, '\p{^Nv=0.400}', "");
    Expect(0, 8534, '\P{Nv=0.400}', "");
    Expect(1, 8534, '\P{^Nv=0.400}', "");
    Expect(0, 8535, '\p{Nv=0.400}', "");
    Expect(1, 8535, '\p{^Nv=0.400}', "");
    Expect(1, 8535, '\P{Nv=0.400}', "");
    Expect(0, 8535, '\P{^Nv=0.400}', "");
    Error('\p{Is_Numeric_Value=-+00002/05/a/}');
    Error('\P{Is_Numeric_Value=-+00002/05/a/}');
    Expect(1, 8534, '\p{Is_Numeric_Value=02/0005}', "");
    Expect(0, 8534, '\p{^Is_Numeric_Value=02/0005}', "");
    Expect(0, 8534, '\P{Is_Numeric_Value=02/0005}', "");
    Expect(1, 8534, '\P{^Is_Numeric_Value=02/0005}', "");
    Expect(0, 8535, '\p{Is_Numeric_Value=02/0005}', "");
    Expect(1, 8535, '\p{^Is_Numeric_Value=02/0005}', "");
    Expect(1, 8535, '\P{Is_Numeric_Value=02/0005}', "");
    Expect(0, 8535, '\P{^Is_Numeric_Value=02/0005}', "");
    Expect(1, 8534, '\p{Is_Numeric_Value=0.400}', "");
    Expect(0, 8534, '\p{^Is_Numeric_Value=0.400}', "");
    Expect(0, 8534, '\P{Is_Numeric_Value=0.400}', "");
    Expect(1, 8534, '\P{^Is_Numeric_Value=0.400}', "");
    Expect(0, 8535, '\p{Is_Numeric_Value=0.400}', "");
    Expect(1, 8535, '\p{^Is_Numeric_Value=0.400}', "");
    Expect(1, 8535, '\P{Is_Numeric_Value=0.400}', "");
    Expect(0, 8535, '\P{^Is_Numeric_Value=0.400}', "");
    Error('\p{Is_Nv=	0000002/000000005:=}');
    Error('\P{Is_Nv=	0000002/000000005:=}');
    Expect(1, 8534, '\p{Is_Nv=+000000002/000000005}', "");
    Expect(0, 8534, '\p{^Is_Nv=+000000002/000000005}', "");
    Expect(0, 8534, '\P{Is_Nv=+000000002/000000005}', "");
    Expect(1, 8534, '\P{^Is_Nv=+000000002/000000005}', "");
    Expect(0, 8535, '\p{Is_Nv=+000000002/000000005}', "");
    Expect(1, 8535, '\p{^Is_Nv=+000000002/000000005}', "");
    Expect(1, 8535, '\P{Is_Nv=+000000002/000000005}', "");
    Expect(0, 8535, '\P{^Is_Nv=+000000002/000000005}', "");
    Expect(1, 8534, '\p{Is_Nv=0.400}', "");
    Expect(0, 8534, '\p{^Is_Nv=0.400}', "");
    Expect(0, 8534, '\P{Is_Nv=0.400}', "");
    Expect(1, 8534, '\P{^Is_Nv=0.400}', "");
    Expect(0, 8535, '\p{Is_Nv=0.400}', "");
    Expect(1, 8535, '\p{^Is_Nv=0.400}', "");
    Expect(1, 8535, '\P{Is_Nv=0.400}', "");
    Expect(0, 8535, '\P{^Is_Nv=0.400}', "");
    Error('\p{Numeric_Value=- 0_0_0_020/a/}');
    Error('\P{Numeric_Value=- 0_0_0_020/a/}');
    Expect(1, 119658, '\p{Numeric_Value: +20}', "");
    Expect(0, 119658, '\p{^Numeric_Value: +20}', "");
    Expect(0, 119658, '\P{Numeric_Value: +20}', "");
    Expect(1, 119658, '\P{^Numeric_Value: +20}', "");
    Expect(0, 119659, '\p{Numeric_Value: +20}', "");
    Expect(1, 119659, '\p{^Numeric_Value: +20}', "");
    Expect(1, 119659, '\P{Numeric_Value: +20}', "");
    Expect(0, 119659, '\P{^Numeric_Value: +20}', "");
    Error('\p{Nv=:=	_+02_0}');
    Error('\P{Nv=:=	_+02_0}');
    Expect(1, 119658, '\p{Nv=020}', "");
    Expect(0, 119658, '\p{^Nv=020}', "");
    Expect(0, 119658, '\P{Nv=020}', "");
    Expect(1, 119658, '\P{^Nv=020}', "");
    Expect(0, 119659, '\p{Nv=020}', "");
    Expect(1, 119659, '\p{^Nv=020}', "");
    Expect(1, 119659, '\P{Nv=020}', "");
    Expect(0, 119659, '\P{^Nv=020}', "");
    Error('\p{Is_Numeric_Value=	+0000020/a/}');
    Error('\P{Is_Numeric_Value=	+0000020/a/}');
    Expect(1, 119658, '\p{Is_Numeric_Value=20}', "");
    Expect(0, 119658, '\p{^Is_Numeric_Value=20}', "");
    Expect(0, 119658, '\P{Is_Numeric_Value=20}', "");
    Expect(1, 119658, '\P{^Is_Numeric_Value=20}', "");
    Expect(0, 119659, '\p{Is_Numeric_Value=20}', "");
    Expect(1, 119659, '\p{^Is_Numeric_Value=20}', "");
    Expect(1, 119659, '\P{Is_Numeric_Value=20}', "");
    Expect(0, 119659, '\P{^Is_Numeric_Value=20}', "");
    Error('\p{Is_Nv=/a/-_+20}');
    Error('\P{Is_Nv=/a/-_+20}');
    Expect(1, 119658, '\p{Is_Nv=00000000020}', "");
    Expect(0, 119658, '\p{^Is_Nv=00000000020}', "");
    Expect(0, 119658, '\P{Is_Nv=00000000020}', "");
    Expect(1, 119658, '\P{^Is_Nv=00000000020}', "");
    Expect(0, 119659, '\p{Is_Nv=00000000020}', "");
    Expect(1, 119659, '\p{^Is_Nv=00000000020}', "");
    Expect(1, 119659, '\P{Is_Nv=00000000020}', "");
    Expect(0, 119659, '\P{^Is_Nv=00000000020}', "");
    Error('\p{Numeric_Value=	/a/00200}');
    Error('\P{Numeric_Value=	/a/00200}');
    Expect(1, 69235, '\p{Numeric_Value=000200}', "");
    Expect(0, 69235, '\p{^Numeric_Value=000200}', "");
    Expect(0, 69235, '\P{Numeric_Value=000200}', "");
    Expect(1, 69235, '\P{^Numeric_Value=000200}', "");
    Expect(0, 69236, '\p{Numeric_Value=000200}', "");
    Expect(1, 69236, '\p{^Numeric_Value=000200}', "");
    Expect(1, 69236, '\P{Numeric_Value=000200}', "");
    Expect(0, 69236, '\P{^Numeric_Value=000200}', "");
    Error('\p{Nv= /a/+0020_0}');
    Error('\P{Nv= /a/+0020_0}');
    Expect(1, 69235, '\p{Nv=+000_000_002_00}', "");
    Expect(0, 69235, '\p{^Nv=+000_000_002_00}', "");
    Expect(0, 69235, '\P{Nv=+000_000_002_00}', "");
    Expect(1, 69235, '\P{^Nv=+000_000_002_00}', "");
    Expect(0, 69236, '\p{Nv=+000_000_002_00}', "");
    Expect(1, 69236, '\p{^Nv=+000_000_002_00}', "");
    Expect(1, 69236, '\P{Nv=+000_000_002_00}', "");
    Expect(0, 69236, '\P{^Nv=+000_000_002_00}', "");
    Error('\p{Is_Numeric_Value= 00200/a/}');
    Error('\P{Is_Numeric_Value= 00200/a/}');
    Expect(1, 69235, '\p{Is_Numeric_Value=+0000200}', "");
    Expect(0, 69235, '\p{^Is_Numeric_Value=+0000200}', "");
    Expect(0, 69235, '\P{Is_Numeric_Value=+0000200}', "");
    Expect(1, 69235, '\P{^Is_Numeric_Value=+0000200}', "");
    Expect(0, 69236, '\p{Is_Numeric_Value=+0000200}', "");
    Expect(1, 69236, '\p{^Is_Numeric_Value=+0000200}', "");
    Expect(1, 69236, '\P{Is_Numeric_Value=+0000200}', "");
    Expect(0, 69236, '\P{^Is_Numeric_Value=+0000200}', "");
    Error('\p{Is_Nv=	/a/+00000000200}');
    Error('\P{Is_Nv=	/a/+00000000200}');
    Expect(1, 69235, '\p{Is_Nv=0_0_0_0_0_0200}', "");
    Expect(0, 69235, '\p{^Is_Nv=0_0_0_0_0_0200}', "");
    Expect(0, 69235, '\P{Is_Nv=0_0_0_0_0_0200}', "");
    Expect(1, 69235, '\P{^Is_Nv=0_0_0_0_0_0200}', "");
    Expect(0, 69236, '\p{Is_Nv=0_0_0_0_0_0200}', "");
    Expect(1, 69236, '\p{^Is_Nv=0_0_0_0_0_0200}', "");
    Expect(1, 69236, '\P{Is_Nv=0_0_0_0_0_0200}', "");
    Expect(0, 69236, '\P{^Is_Nv=0_0_0_0_0_0200}', "");
    Error('\p{Numeric_Value=-:=0000002000}');
    Error('\P{Numeric_Value=-:=0000002000}');
    Expect(1, 68060, '\p{Numeric_Value=002000}', "");
    Expect(0, 68060, '\p{^Numeric_Value=002000}', "");
    Expect(0, 68060, '\P{Numeric_Value=002000}', "");
    Expect(1, 68060, '\P{^Numeric_Value=002000}', "");
    Expect(0, 68061, '\p{Numeric_Value=002000}', "");
    Expect(1, 68061, '\p{^Numeric_Value=002000}', "");
    Expect(1, 68061, '\P{Numeric_Value=002000}', "");
    Expect(0, 68061, '\P{^Numeric_Value=002000}', "");
    Error('\p{Nv=:=	 0_0_0_0_0_0_0_0_2_0_00}');
    Error('\P{Nv=:=	 0_0_0_0_0_0_0_0_2_0_00}');
    Expect(1, 68060, '\p{Nv=0000000002000}', "");
    Expect(0, 68060, '\p{^Nv=0000000002000}', "");
    Expect(0, 68060, '\P{Nv=0000000002000}', "");
    Expect(1, 68060, '\P{^Nv=0000000002000}', "");
    Expect(0, 68061, '\p{Nv=0000000002000}', "");
    Expect(1, 68061, '\p{^Nv=0000000002000}', "");
    Expect(1, 68061, '\P{Nv=0000000002000}', "");
    Expect(0, 68061, '\P{^Nv=0000000002000}', "");
    Error('\p{Is_Numeric_Value=	00000002000/a/}');
    Error('\P{Is_Numeric_Value=	00000002000/a/}');
    Expect(1, 68060, '\p{Is_Numeric_Value=00000_00200_0}', "");
    Expect(0, 68060, '\p{^Is_Numeric_Value=00000_00200_0}', "");
    Expect(0, 68060, '\P{Is_Numeric_Value=00000_00200_0}', "");
    Expect(1, 68060, '\P{^Is_Numeric_Value=00000_00200_0}', "");
    Expect(0, 68061, '\p{Is_Numeric_Value=00000_00200_0}', "");
    Expect(1, 68061, '\p{^Is_Numeric_Value=00000_00200_0}', "");
    Expect(1, 68061, '\P{Is_Numeric_Value=00000_00200_0}', "");
    Expect(0, 68061, '\P{^Is_Numeric_Value=00000_00200_0}', "");
    Error('\p{Is_Nv:	/a/-_+00000_00020_00}');
    Error('\P{Is_Nv:	/a/-_+00000_00020_00}');
    Expect(1, 68060, '\p{Is_Nv=00000002000}', "");
    Expect(0, 68060, '\p{^Is_Nv=00000002000}', "");
    Expect(0, 68060, '\P{Is_Nv=00000002000}', "");
    Expect(1, 68060, '\P{^Is_Nv=00000002000}', "");
    Expect(0, 68061, '\p{Is_Nv=00000002000}', "");
    Expect(1, 68061, '\p{^Is_Nv=00000002000}', "");
    Expect(1, 68061, '\P{Is_Nv=00000002000}', "");
    Expect(0, 68061, '\P{^Is_Nv=00000002000}', "");
    Error('\p{Numeric_Value=_/a/+02_00_00}');
    Error('\P{Numeric_Value=_/a/+02_00_00}');
    Expect(1, 68069, '\p{Numeric_Value=+0020000}', "");
    Expect(0, 68069, '\p{^Numeric_Value=+0020000}', "");
    Expect(0, 68069, '\P{Numeric_Value=+0020000}', "");
    Expect(1, 68069, '\P{^Numeric_Value=+0020000}', "");
    Expect(0, 68070, '\p{Numeric_Value=+0020000}', "");
    Expect(1, 68070, '\p{^Numeric_Value=+0020000}', "");
    Expect(1, 68070, '\P{Numeric_Value=+0020000}', "");
    Expect(0, 68070, '\P{^Numeric_Value=+0020000}', "");
    Error('\p{Nv=-:=000_002_000_0}');
    Error('\P{Nv=-:=000_002_000_0}');
    Expect(1, 68069, '\p{Nv=+00000000020000}', "");
    Expect(0, 68069, '\p{^Nv=+00000000020000}', "");
    Expect(0, 68069, '\P{Nv=+00000000020000}', "");
    Expect(1, 68069, '\P{^Nv=+00000000020000}', "");
    Expect(0, 68070, '\p{Nv=+00000000020000}', "");
    Expect(1, 68070, '\p{^Nv=+00000000020000}', "");
    Expect(1, 68070, '\P{Nv=+00000000020000}', "");
    Expect(0, 68070, '\P{^Nv=+00000000020000}', "");
    Error('\p{Is_Numeric_Value=	 002_000_0/a/}');
    Error('\P{Is_Numeric_Value=	 002_000_0/a/}');
    Expect(1, 68069, '\p{Is_Numeric_Value=0_0_0_0_0_0_0_20000}', "");
    Expect(0, 68069, '\p{^Is_Numeric_Value=0_0_0_0_0_0_0_20000}', "");
    Expect(0, 68069, '\P{Is_Numeric_Value=0_0_0_0_0_0_0_20000}', "");
    Expect(1, 68069, '\P{^Is_Numeric_Value=0_0_0_0_0_0_0_20000}', "");
    Expect(0, 68070, '\p{Is_Numeric_Value=0_0_0_0_0_0_0_20000}', "");
    Expect(1, 68070, '\p{^Is_Numeric_Value=0_0_0_0_0_0_0_20000}', "");
    Expect(1, 68070, '\P{Is_Numeric_Value=0_0_0_0_0_0_0_20000}', "");
    Expect(0, 68070, '\P{^Is_Numeric_Value=0_0_0_0_0_0_0_20000}', "");
    Error('\p{Is_Nv=-:=+00000020000}');
    Error('\P{Is_Nv=-:=+00000020000}');
    Expect(1, 68069, '\p{Is_Nv=0000_0000_0200_00}', "");
    Expect(0, 68069, '\p{^Is_Nv=0000_0000_0200_00}', "");
    Expect(0, 68069, '\P{Is_Nv=0000_0000_0200_00}', "");
    Expect(1, 68069, '\P{^Is_Nv=0000_0000_0200_00}', "");
    Expect(0, 68070, '\p{Is_Nv=0000_0000_0200_00}', "");
    Expect(1, 68070, '\p{^Is_Nv=0000_0000_0200_00}', "");
    Expect(1, 68070, '\P{Is_Nv=0000_0000_0200_00}', "");
    Expect(0, 68070, '\P{^Is_Nv=0000_0000_0200_00}', "");
    Error('\p{Numeric_Value=	:=20000_0}');
    Error('\P{Numeric_Value=	:=20000_0}');
    Expect(1, 68078, '\p{Numeric_Value=20_00_00}', "");
    Expect(0, 68078, '\p{^Numeric_Value=20_00_00}', "");
    Expect(0, 68078, '\P{Numeric_Value=20_00_00}', "");
    Expect(1, 68078, '\P{^Numeric_Value=20_00_00}', "");
    Expect(0, 68079, '\p{Numeric_Value=20_00_00}', "");
    Expect(1, 68079, '\p{^Numeric_Value=20_00_00}', "");
    Expect(1, 68079, '\P{Numeric_Value=20_00_00}', "");
    Expect(0, 68079, '\P{^Numeric_Value=20_00_00}', "");
    Error('\p{Nv:   /a/		0_0_0_0_0_0_0_0_0200000}');
    Error('\P{Nv:   /a/		0_0_0_0_0_0_0_0_0200000}');
    Expect(1, 68078, '\p{Nv:	000000_020000_0}', "");
    Expect(0, 68078, '\p{^Nv:	000000_020000_0}', "");
    Expect(0, 68078, '\P{Nv:	000000_020000_0}', "");
    Expect(1, 68078, '\P{^Nv:	000000_020000_0}', "");
    Expect(0, 68079, '\p{Nv:	000000_020000_0}', "");
    Expect(1, 68079, '\p{^Nv:	000000_020000_0}', "");
    Expect(1, 68079, '\P{Nv:	000000_020000_0}', "");
    Expect(0, 68079, '\P{^Nv:	000000_020000_0}', "");
    Error('\p{Is_Numeric_Value=/a/-+0000200000}');
    Error('\P{Is_Numeric_Value=/a/-+0000200000}');
    Expect(1, 68078, '\p{Is_Numeric_Value=0000_0000_0200_000}', "");
    Expect(0, 68078, '\p{^Is_Numeric_Value=0000_0000_0200_000}', "");
    Expect(0, 68078, '\P{Is_Numeric_Value=0000_0000_0200_000}', "");
    Expect(1, 68078, '\P{^Is_Numeric_Value=0000_0000_0200_000}', "");
    Expect(0, 68079, '\p{Is_Numeric_Value=0000_0000_0200_000}', "");
    Expect(1, 68079, '\p{^Is_Numeric_Value=0000_0000_0200_000}', "");
    Expect(1, 68079, '\P{Is_Numeric_Value=0000_0000_0200_000}', "");
    Expect(0, 68079, '\P{^Is_Numeric_Value=0000_0000_0200_000}', "");
    Error('\p{Is_Nv=:=-_+200000}');
    Error('\P{Is_Nv=:=-_+200000}');
    Expect(1, 68078, '\p{Is_Nv=000000000200000}', "");
    Expect(0, 68078, '\p{^Is_Nv=000000000200000}', "");
    Expect(0, 68078, '\P{Is_Nv=000000000200000}', "");
    Expect(1, 68078, '\P{^Is_Nv=000000000200000}', "");
    Expect(0, 68079, '\p{Is_Nv=000000000200000}', "");
    Expect(1, 68079, '\p{^Is_Nv=000000000200000}', "");
    Expect(1, 68079, '\P{Is_Nv=000000000200000}', "");
    Expect(0, 68079, '\P{^Is_Nv=000000000200000}', "");
    Error('\p{Numeric_Value= _00_00_21/a/}');
    Error('\P{Numeric_Value= _00_00_21/a/}');
    Expect(1, 12881, '\p{Numeric_Value=+00000021}', "");
    Expect(0, 12881, '\p{^Numeric_Value=+00000021}', "");
    Expect(0, 12881, '\P{Numeric_Value=+00000021}', "");
    Expect(1, 12881, '\P{^Numeric_Value=+00000021}', "");
    Expect(0, 12882, '\p{Numeric_Value=+00000021}', "");
    Expect(1, 12882, '\p{^Numeric_Value=+00000021}', "");
    Expect(1, 12882, '\P{Numeric_Value=+00000021}', "");
    Expect(0, 12882, '\P{^Numeric_Value=+00000021}', "");
    Error('\p{Nv=/a/ -0000000021}');
    Error('\P{Nv=/a/ -0000000021}');
    Expect(1, 12881, '\p{Nv=02_1}', "");
    Expect(0, 12881, '\p{^Nv=02_1}', "");
    Expect(0, 12881, '\P{Nv=02_1}', "");
    Expect(1, 12881, '\P{^Nv=02_1}', "");
    Expect(0, 12882, '\p{Nv=02_1}', "");
    Expect(1, 12882, '\p{^Nv=02_1}', "");
    Expect(1, 12882, '\P{Nv=02_1}', "");
    Expect(0, 12882, '\P{^Nv=02_1}', "");
    Error('\p{Is_Numeric_Value=_	2_1/a/}');
    Error('\P{Is_Numeric_Value=_	2_1/a/}');
    Expect(1, 12881, '\p{Is_Numeric_Value=2_1}', "");
    Expect(0, 12881, '\p{^Is_Numeric_Value=2_1}', "");
    Expect(0, 12881, '\P{Is_Numeric_Value=2_1}', "");
    Expect(1, 12881, '\P{^Is_Numeric_Value=2_1}', "");
    Expect(0, 12882, '\p{Is_Numeric_Value=2_1}', "");
    Expect(1, 12882, '\p{^Is_Numeric_Value=2_1}', "");
    Expect(1, 12882, '\P{Is_Numeric_Value=2_1}', "");
    Expect(0, 12882, '\P{^Is_Numeric_Value=2_1}', "");
    Error('\p{Is_Nv=/a/--0_0_0_0_0_0_0_21}');
    Error('\P{Is_Nv=/a/--0_0_0_0_0_0_0_21}');
    Expect(1, 12881, '\p{Is_Nv=000_000_002_1}', "");
    Expect(0, 12881, '\p{^Is_Nv=000_000_002_1}', "");
    Expect(0, 12881, '\P{Is_Nv=000_000_002_1}', "");
    Expect(1, 12881, '\P{^Is_Nv=000_000_002_1}', "");
    Expect(0, 12882, '\p{Is_Nv=000_000_002_1}', "");
    Expect(1, 12882, '\p{^Is_Nv=000_000_002_1}', "");
    Expect(1, 12882, '\P{Is_Nv=000_000_002_1}', "");
    Expect(0, 12882, '\P{^Is_Nv=000_000_002_1}', "");
    Error('\p{Numeric_Value=:=	-000216000}');
    Error('\P{Numeric_Value=:=	-000216000}');
    Expect(1, 74802, '\p{Numeric_Value=0000216000}', "");
    Expect(0, 74802, '\p{^Numeric_Value=0000216000}', "");
    Expect(0, 74802, '\P{Numeric_Value=0000216000}', "");
    Expect(1, 74802, '\P{^Numeric_Value=0000216000}', "");
    Expect(0, 74803, '\p{Numeric_Value=0000216000}', "");
    Expect(1, 74803, '\p{^Numeric_Value=0000216000}', "");
    Expect(1, 74803, '\P{Numeric_Value=0000216000}', "");
    Expect(0, 74803, '\P{^Numeric_Value=0000216000}', "");
    Error('\p{Nv=/a/ -+0_0_0_0_0_2_1_6_000}');
    Error('\P{Nv=/a/ -+0_0_0_0_0_2_1_6_000}');
    Expect(1, 74802, '\p{Nv=0_0_0_0_0_0_0_0_216000}', "");
    Expect(0, 74802, '\p{^Nv=0_0_0_0_0_0_0_0_216000}', "");
    Expect(0, 74802, '\P{Nv=0_0_0_0_0_0_0_0_216000}', "");
    Expect(1, 74802, '\P{^Nv=0_0_0_0_0_0_0_0_216000}', "");
    Expect(0, 74803, '\p{Nv=0_0_0_0_0_0_0_0_216000}', "");
    Expect(1, 74803, '\p{^Nv=0_0_0_0_0_0_0_0_216000}', "");
    Expect(1, 74803, '\P{Nv=0_0_0_0_0_0_0_0_216000}', "");
    Expect(0, 74803, '\P{^Nv=0_0_0_0_0_0_0_0_216000}', "");
    Error('\p{Is_Numeric_Value=_00000_02160_00/a/}');
    Error('\P{Is_Numeric_Value=_00000_02160_00/a/}');
    Expect(1, 74802, '\p{Is_Numeric_Value=00000000216000}', "");
    Expect(0, 74802, '\p{^Is_Numeric_Value=00000000216000}', "");
    Expect(0, 74802, '\P{Is_Numeric_Value=00000000216000}', "");
    Expect(1, 74802, '\P{^Is_Numeric_Value=00000000216000}', "");
    Expect(0, 74803, '\p{Is_Numeric_Value=00000000216000}', "");
    Expect(1, 74803, '\p{^Is_Numeric_Value=00000000216000}', "");
    Expect(1, 74803, '\P{Is_Numeric_Value=00000000216000}', "");
    Expect(0, 74803, '\P{^Is_Numeric_Value=00000000216000}', "");
    Error('\p{Is_Nv=_:=0000000216000}');
    Error('\P{Is_Nv=_:=0000000216000}');
    Expect(1, 74802, '\p{Is_Nv=+2_1_6_000}', "");
    Expect(0, 74802, '\p{^Is_Nv=+2_1_6_000}', "");
    Expect(0, 74802, '\P{Is_Nv=+2_1_6_000}', "");
    Expect(1, 74802, '\P{^Is_Nv=+2_1_6_000}', "");
    Expect(0, 74803, '\p{Is_Nv=+2_1_6_000}', "");
    Expect(1, 74803, '\p{^Is_Nv=+2_1_6_000}', "");
    Expect(1, 74803, '\P{Is_Nv=+2_1_6_000}', "");
    Expect(0, 74803, '\P{^Is_Nv=+2_1_6_000}', "");
    Error('\p{Numeric_Value=:=--+000022}');
    Error('\P{Numeric_Value=:=--+000022}');
    Expect(1, 12882, '\p{Numeric_Value=+00002_2}', "");
    Expect(0, 12882, '\p{^Numeric_Value=+00002_2}', "");
    Expect(0, 12882, '\P{Numeric_Value=+00002_2}', "");
    Expect(1, 12882, '\P{^Numeric_Value=+00002_2}', "");
    Expect(0, 12883, '\p{Numeric_Value=+00002_2}', "");
    Expect(1, 12883, '\p{^Numeric_Value=+00002_2}', "");
    Expect(1, 12883, '\P{Numeric_Value=+00002_2}', "");
    Expect(0, 12883, '\P{^Numeric_Value=+00002_2}', "");
    Error('\p{Nv= /a/0_0_0_0_0_0022}');
    Error('\P{Nv= /a/0_0_0_0_0_0022}');
    Expect(1, 12882, '\p{Nv=0_0_22}', "");
    Expect(0, 12882, '\p{^Nv=0_0_22}', "");
    Expect(0, 12882, '\P{Nv=0_0_22}', "");
    Expect(1, 12882, '\P{^Nv=0_0_22}', "");
    Expect(0, 12883, '\p{Nv=0_0_22}', "");
    Expect(1, 12883, '\p{^Nv=0_0_22}', "");
    Expect(1, 12883, '\P{Nv=0_0_22}', "");
    Expect(0, 12883, '\P{^Nv=0_0_22}', "");
    Error('\p{Is_Numeric_Value=/a/_	0_0_0_0_22}');
    Error('\P{Is_Numeric_Value=/a/_	0_0_0_0_22}');
    Expect(1, 12882, '\p{Is_Numeric_Value=+0000_0000_22}', "");
    Expect(0, 12882, '\p{^Is_Numeric_Value=+0000_0000_22}', "");
    Expect(0, 12882, '\P{Is_Numeric_Value=+0000_0000_22}', "");
    Expect(1, 12882, '\P{^Is_Numeric_Value=+0000_0000_22}', "");
    Expect(0, 12883, '\p{Is_Numeric_Value=+0000_0000_22}', "");
    Expect(1, 12883, '\p{^Is_Numeric_Value=+0000_0000_22}', "");
    Expect(1, 12883, '\P{Is_Numeric_Value=+0000_0000_22}', "");
    Expect(0, 12883, '\P{^Is_Numeric_Value=+0000_0000_22}', "");
    Error('\p{Is_Nv=	:=02_2}');
    Error('\P{Is_Nv=	:=02_2}');
    Expect(1, 12882, '\p{Is_Nv=+000000022}', "");
    Expect(0, 12882, '\p{^Is_Nv=+000000022}', "");
    Expect(0, 12882, '\P{Is_Nv=+000000022}', "");
    Expect(1, 12882, '\P{^Is_Nv=+000000022}', "");
    Expect(0, 12883, '\p{Is_Nv=+000000022}', "");
    Expect(1, 12883, '\p{^Is_Nv=+000000022}', "");
    Expect(1, 12883, '\P{Is_Nv=+000000022}', "");
    Expect(0, 12883, '\P{^Is_Nv=+000000022}', "");
    Error('\p{Numeric_Value= _+000023/a/}');
    Error('\P{Numeric_Value= _+000023/a/}');
    Expect(1, 12883, '\p{Numeric_Value=+000000023}', "");
    Expect(0, 12883, '\p{^Numeric_Value=+000000023}', "");
    Expect(0, 12883, '\P{Numeric_Value=+000000023}', "");
    Expect(1, 12883, '\P{^Numeric_Value=+000000023}', "");
    Expect(0, 12884, '\p{Numeric_Value=+000000023}', "");
    Expect(1, 12884, '\p{^Numeric_Value=+000000023}', "");
    Expect(1, 12884, '\P{Numeric_Value=+000000023}', "");
    Expect(0, 12884, '\P{^Numeric_Value=+000000023}', "");
    Error('\p{Nv=:=+00000023}');
    Error('\P{Nv=:=+00000023}');
    Expect(1, 12883, '\p{Nv=+0002_3}', "");
    Expect(0, 12883, '\p{^Nv=+0002_3}', "");
    Expect(0, 12883, '\P{Nv=+0002_3}', "");
    Expect(1, 12883, '\P{^Nv=+0002_3}', "");
    Expect(0, 12884, '\p{Nv=+0002_3}', "");
    Expect(1, 12884, '\p{^Nv=+0002_3}', "");
    Expect(1, 12884, '\P{Nv=+0002_3}', "");
    Expect(0, 12884, '\P{^Nv=+0002_3}', "");
    Error('\p{Is_Numeric_Value::=	-000000023}');
    Error('\P{Is_Numeric_Value::=	-000000023}');
    Expect(1, 12883, '\p{Is_Numeric_Value=0_0_0_023}', "");
    Expect(0, 12883, '\p{^Is_Numeric_Value=0_0_0_023}', "");
    Expect(0, 12883, '\P{Is_Numeric_Value=0_0_0_023}', "");
    Expect(1, 12883, '\P{^Is_Numeric_Value=0_0_0_023}', "");
    Expect(0, 12884, '\p{Is_Numeric_Value=0_0_0_023}', "");
    Expect(1, 12884, '\p{^Is_Numeric_Value=0_0_0_023}', "");
    Expect(1, 12884, '\P{Is_Numeric_Value=0_0_0_023}', "");
    Expect(0, 12884, '\P{^Is_Numeric_Value=0_0_0_023}', "");
    Error('\p{Is_Nv:   	-00000000023/a/}');
    Error('\P{Is_Nv:   	-00000000023/a/}');
    Expect(1, 12883, '\p{Is_Nv=+2_3}', "");
    Expect(0, 12883, '\p{^Is_Nv=+2_3}', "");
    Expect(0, 12883, '\P{Is_Nv=+2_3}', "");
    Expect(1, 12883, '\P{^Is_Nv=+2_3}', "");
    Expect(0, 12884, '\p{Is_Nv=+2_3}', "");
    Expect(1, 12884, '\p{^Is_Nv=+2_3}', "");
    Expect(1, 12884, '\P{Is_Nv=+2_3}', "");
    Expect(0, 12884, '\P{^Is_Nv=+2_3}', "");
    Error('\p{Numeric_Value=_000024/a/}');
    Error('\P{Numeric_Value=_000024/a/}');
    Expect(1, 12884, '\p{Numeric_Value=00000024}', "");
    Expect(0, 12884, '\p{^Numeric_Value=00000024}', "");
    Expect(0, 12884, '\P{Numeric_Value=00000024}', "");
    Expect(1, 12884, '\P{^Numeric_Value=00000024}', "");
    Expect(0, 12885, '\p{Numeric_Value=00000024}', "");
    Expect(1, 12885, '\p{^Numeric_Value=00000024}', "");
    Expect(1, 12885, '\P{Numeric_Value=00000024}', "");
    Expect(0, 12885, '\P{^Numeric_Value=00000024}', "");
    Error('\p{Nv=_:=0000024}');
    Error('\P{Nv=_:=0000024}');
    Expect(1, 12884, '\p{Nv=00002_4}', "");
    Expect(0, 12884, '\p{^Nv=00002_4}', "");
    Expect(0, 12884, '\P{Nv=00002_4}', "");
    Expect(1, 12884, '\P{^Nv=00002_4}', "");
    Expect(0, 12885, '\p{Nv=00002_4}', "");
    Expect(1, 12885, '\p{^Nv=00002_4}', "");
    Expect(1, 12885, '\P{Nv=00002_4}', "");
    Expect(0, 12885, '\P{^Nv=00002_4}', "");
    Error('\p{Is_Numeric_Value=/a/ 0_0_24}');
    Error('\P{Is_Numeric_Value=/a/ 0_0_24}');
    Expect(1, 12884, '\p{Is_Numeric_Value:	+024}', "");
    Expect(0, 12884, '\p{^Is_Numeric_Value:	+024}', "");
    Expect(0, 12884, '\P{Is_Numeric_Value:	+024}', "");
    Expect(1, 12884, '\P{^Is_Numeric_Value:	+024}', "");
    Expect(0, 12885, '\p{Is_Numeric_Value:	+024}', "");
    Expect(1, 12885, '\p{^Is_Numeric_Value:	+024}', "");
    Expect(1, 12885, '\P{Is_Numeric_Value:	+024}', "");
    Expect(0, 12885, '\P{^Is_Numeric_Value:	+024}', "");
    Error('\p{Is_Nv=- 00_02_4:=}');
    Error('\P{Is_Nv=- 00_02_4:=}');
    Expect(1, 12884, '\p{Is_Nv=00_00_00_02_4}', "");
    Expect(0, 12884, '\p{^Is_Nv=00_00_00_02_4}', "");
    Expect(0, 12884, '\P{Is_Nv=00_00_00_02_4}', "");
    Expect(1, 12884, '\P{^Is_Nv=00_00_00_02_4}', "");
    Expect(0, 12885, '\p{Is_Nv=00_00_00_02_4}', "");
    Expect(1, 12885, '\p{^Is_Nv=00_00_00_02_4}', "");
    Expect(1, 12885, '\P{Is_Nv=00_00_00_02_4}', "");
    Expect(0, 12885, '\P{^Is_Nv=00_00_00_02_4}', "");
    Error('\p{Numeric_Value=/a/_00000000025}');
    Error('\P{Numeric_Value=/a/_00000000025}');
    Expect(1, 12885, '\p{Numeric_Value=+00000000025}', "");
    Expect(0, 12885, '\p{^Numeric_Value=+00000000025}', "");
    Expect(0, 12885, '\P{Numeric_Value=+00000000025}', "");
    Expect(1, 12885, '\P{^Numeric_Value=+00000000025}', "");
    Expect(0, 12886, '\p{Numeric_Value=+00000000025}', "");
    Expect(1, 12886, '\p{^Numeric_Value=+00000000025}', "");
    Expect(1, 12886, '\P{Numeric_Value=+00000000025}', "");
    Expect(0, 12886, '\P{^Numeric_Value=+00000000025}', "");
    Error('\p{Nv: - +00_00_25:=}');
    Error('\P{Nv: - +00_00_25:=}');
    Expect(1, 12885, '\p{Nv=+0025}', "");
    Expect(0, 12885, '\p{^Nv=+0025}', "");
    Expect(0, 12885, '\P{Nv=+0025}', "");
    Expect(1, 12885, '\P{^Nv=+0025}', "");
    Expect(0, 12886, '\p{Nv=+0025}', "");
    Expect(1, 12886, '\p{^Nv=+0025}', "");
    Expect(1, 12886, '\P{Nv=+0025}', "");
    Expect(0, 12886, '\P{^Nv=+0025}', "");
    Error('\p{Is_Numeric_Value=	0_0_0_025/a/}');
    Error('\P{Is_Numeric_Value=	0_0_0_025/a/}');
    Expect(1, 12885, '\p{Is_Numeric_Value=+00000000025}', "");
    Expect(0, 12885, '\p{^Is_Numeric_Value=+00000000025}', "");
    Expect(0, 12885, '\P{Is_Numeric_Value=+00000000025}', "");
    Expect(1, 12885, '\P{^Is_Numeric_Value=+00000000025}', "");
    Expect(0, 12886, '\p{Is_Numeric_Value=+00000000025}', "");
    Expect(1, 12886, '\p{^Is_Numeric_Value=+00000000025}', "");
    Expect(1, 12886, '\P{Is_Numeric_Value=+00000000025}', "");
    Expect(0, 12886, '\P{^Is_Numeric_Value=+00000000025}', "");
    Error('\p{Is_Nv=:=_00_00_00_25}');
    Error('\P{Is_Nv=:=_00_00_00_25}');
    Expect(1, 12885, '\p{Is_Nv:   02_5}', "");
    Expect(0, 12885, '\p{^Is_Nv:   02_5}', "");
    Expect(0, 12885, '\P{Is_Nv:   02_5}', "");
    Expect(1, 12885, '\P{^Is_Nv:   02_5}', "");
    Expect(0, 12886, '\p{Is_Nv:   02_5}', "");
    Expect(1, 12886, '\p{^Is_Nv:   02_5}', "");
    Expect(1, 12886, '\P{Is_Nv:   02_5}', "");
    Expect(0, 12886, '\P{^Is_Nv:   02_5}', "");
    Error('\p{Numeric_Value= /a/26}');
    Error('\P{Numeric_Value= /a/26}');
    Expect(1, 12886, '\p{Numeric_Value=00000000026}', "");
    Expect(0, 12886, '\p{^Numeric_Value=00000000026}', "");
    Expect(0, 12886, '\P{Numeric_Value=00000000026}', "");
    Expect(1, 12886, '\P{^Numeric_Value=00000000026}', "");
    Expect(0, 12887, '\p{Numeric_Value=00000000026}', "");
    Expect(1, 12887, '\p{^Numeric_Value=00000000026}', "");
    Expect(1, 12887, '\P{Numeric_Value=00000000026}', "");
    Expect(0, 12887, '\P{^Numeric_Value=00000000026}', "");
    Error('\p{Nv=-00026:=}');
    Error('\P{Nv=-00026:=}');
    Expect(1, 12886, '\p{Nv=026}', "");
    Expect(0, 12886, '\p{^Nv=026}', "");
    Expect(0, 12886, '\P{Nv=026}', "");
    Expect(1, 12886, '\P{^Nv=026}', "");
    Expect(0, 12887, '\p{Nv=026}', "");
    Expect(1, 12887, '\p{^Nv=026}', "");
    Expect(1, 12887, '\P{Nv=026}', "");
    Expect(0, 12887, '\P{^Nv=026}', "");
    Error('\p{Is_Numeric_Value:   --00000000026:=}');
    Error('\P{Is_Numeric_Value:   --00000000026:=}');
    Expect(1, 12886, '\p{Is_Numeric_Value=00000026}', "");
    Expect(0, 12886, '\p{^Is_Numeric_Value=00000026}', "");
    Expect(0, 12886, '\P{Is_Numeric_Value=00000026}', "");
    Expect(1, 12886, '\P{^Is_Numeric_Value=00000026}', "");
    Expect(0, 12887, '\p{Is_Numeric_Value=00000026}', "");
    Expect(1, 12887, '\p{^Is_Numeric_Value=00000026}', "");
    Expect(1, 12887, '\P{Is_Numeric_Value=00000026}', "");
    Expect(0, 12887, '\P{^Is_Numeric_Value=00000026}', "");
    Error('\p{Is_Nv= 000000026/a/}');
    Error('\P{Is_Nv= 000000026/a/}');
    Expect(1, 12886, '\p{Is_Nv=0000026}', "");
    Expect(0, 12886, '\p{^Is_Nv=0000026}', "");
    Expect(0, 12886, '\P{Is_Nv=0000026}', "");
    Expect(1, 12886, '\P{^Is_Nv=0000026}', "");
    Expect(0, 12887, '\p{Is_Nv=0000026}', "");
    Expect(1, 12887, '\p{^Is_Nv=0000026}', "");
    Expect(1, 12887, '\P{Is_Nv=0000026}', "");
    Expect(0, 12887, '\P{^Is_Nv=0000026}', "");
    Error('\p{Numeric_Value:	:=-00_00_00_27}');
    Error('\P{Numeric_Value:	:=-00_00_00_27}');
    Expect(1, 12887, '\p{Numeric_Value=+0_0_0_0_0_27}', "");
    Expect(0, 12887, '\p{^Numeric_Value=+0_0_0_0_0_27}', "");
    Expect(0, 12887, '\P{Numeric_Value=+0_0_0_0_0_27}', "");
    Expect(1, 12887, '\P{^Numeric_Value=+0_0_0_0_0_27}', "");
    Expect(0, 12888, '\p{Numeric_Value=+0_0_0_0_0_27}', "");
    Expect(1, 12888, '\p{^Numeric_Value=+0_0_0_0_0_27}', "");
    Expect(1, 12888, '\P{Numeric_Value=+0_0_0_0_0_27}', "");
    Expect(0, 12888, '\P{^Numeric_Value=+0_0_0_0_0_27}', "");
    Error('\p{Nv=-:=+00_00_00_027}');
    Error('\P{Nv=-:=+00_00_00_027}');
    Expect(1, 12887, '\p{Nv=+00027}', "");
    Expect(0, 12887, '\p{^Nv=+00027}', "");
    Expect(0, 12887, '\P{Nv=+00027}', "");
    Expect(1, 12887, '\P{^Nv=+00027}', "");
    Expect(0, 12888, '\p{Nv=+00027}', "");
    Expect(1, 12888, '\p{^Nv=+00027}', "");
    Expect(1, 12888, '\P{Nv=+00027}', "");
    Expect(0, 12888, '\P{^Nv=+00027}', "");
    Error('\p{Is_Numeric_Value=  +0_0_0_0_27:=}');
    Error('\P{Is_Numeric_Value=  +0_0_0_0_27:=}');
    Expect(1, 12887, '\p{Is_Numeric_Value=00027}', "");
    Expect(0, 12887, '\p{^Is_Numeric_Value=00027}', "");
    Expect(0, 12887, '\P{Is_Numeric_Value=00027}', "");
    Expect(1, 12887, '\P{^Is_Numeric_Value=00027}', "");
    Expect(0, 12888, '\p{Is_Numeric_Value=00027}', "");
    Expect(1, 12888, '\p{^Is_Numeric_Value=00027}', "");
    Expect(1, 12888, '\P{Is_Numeric_Value=00027}', "");
    Expect(0, 12888, '\P{^Is_Numeric_Value=00027}', "");
    Error('\p{Is_Nv=:= +02_7}');
    Error('\P{Is_Nv=:= +02_7}');
    Expect(1, 12887, '\p{Is_Nv=00000002_7}', "");
    Expect(0, 12887, '\p{^Is_Nv=00000002_7}', "");
    Expect(0, 12887, '\P{Is_Nv=00000002_7}', "");
    Expect(1, 12887, '\P{^Is_Nv=00000002_7}', "");
    Expect(0, 12888, '\p{Is_Nv=00000002_7}', "");
    Expect(1, 12888, '\p{^Is_Nv=00000002_7}', "");
    Expect(1, 12888, '\P{Is_Nv=00000002_7}', "");
    Expect(0, 12888, '\P{^Is_Nv=00000002_7}', "");
    Error('\p{Numeric_Value=_-0000028/a/}');
    Error('\P{Numeric_Value=_-0000028/a/}');
    Expect(1, 12888, '\p{Numeric_Value=28}', "");
    Expect(0, 12888, '\p{^Numeric_Value=28}', "");
    Expect(0, 12888, '\P{Numeric_Value=28}', "");
    Expect(1, 12888, '\P{^Numeric_Value=28}', "");
    Expect(0, 12889, '\p{Numeric_Value=28}', "");
    Expect(1, 12889, '\p{^Numeric_Value=28}', "");
    Expect(1, 12889, '\P{Numeric_Value=28}', "");
    Expect(0, 12889, '\P{^Numeric_Value=28}', "");
    Error('\p{Nv=_/a/00028}');
    Error('\P{Nv=_/a/00028}');
    Expect(1, 12888, '\p{Nv=+000000028}', "");
    Expect(0, 12888, '\p{^Nv=+000000028}', "");
    Expect(0, 12888, '\P{Nv=+000000028}', "");
    Expect(1, 12888, '\P{^Nv=+000000028}', "");
    Expect(0, 12889, '\p{Nv=+000000028}', "");
    Expect(1, 12889, '\p{^Nv=+000000028}', "");
    Expect(1, 12889, '\P{Nv=+000000028}', "");
    Expect(0, 12889, '\P{^Nv=+000000028}', "");
    Error('\p{Is_Numeric_Value=	:=02_8}');
    Error('\P{Is_Numeric_Value=	:=02_8}');
    Expect(1, 12888, '\p{Is_Numeric_Value=+02_8}', "");
    Expect(0, 12888, '\p{^Is_Numeric_Value=+02_8}', "");
    Expect(0, 12888, '\P{Is_Numeric_Value=+02_8}', "");
    Expect(1, 12888, '\P{^Is_Numeric_Value=+02_8}', "");
    Expect(0, 12889, '\p{Is_Numeric_Value=+02_8}', "");
    Expect(1, 12889, '\p{^Is_Numeric_Value=+02_8}', "");
    Expect(1, 12889, '\P{Is_Numeric_Value=+02_8}', "");
    Expect(0, 12889, '\P{^Is_Numeric_Value=+02_8}', "");
    Error('\p{Is_Nv:   /a/_-0_0_0_0_0_0_0_0_0_28}');
    Error('\P{Is_Nv:   /a/_-0_0_0_0_0_0_0_0_0_28}');
    Expect(1, 12888, '\p{Is_Nv=028}', "");
    Expect(0, 12888, '\p{^Is_Nv=028}', "");
    Expect(0, 12888, '\P{Is_Nv=028}', "");
    Expect(1, 12888, '\P{^Is_Nv=028}', "");
    Expect(0, 12889, '\p{Is_Nv=028}', "");
    Expect(1, 12889, '\p{^Is_Nv=028}', "");
    Expect(1, 12889, '\P{Is_Nv=028}', "");
    Expect(0, 12889, '\P{^Is_Nv=028}', "");
    Error('\p{Numeric_Value=  2_9/a/}');
    Error('\P{Numeric_Value=  2_9/a/}');
    Expect(1, 12889, '\p{Numeric_Value=+2_9}', "");
    Expect(0, 12889, '\p{^Numeric_Value=+2_9}', "");
    Expect(0, 12889, '\P{Numeric_Value=+2_9}', "");
    Expect(1, 12889, '\P{^Numeric_Value=+2_9}', "");
    Expect(0, 12890, '\p{Numeric_Value=+2_9}', "");
    Expect(1, 12890, '\p{^Numeric_Value=+2_9}', "");
    Expect(1, 12890, '\P{Numeric_Value=+2_9}', "");
    Expect(0, 12890, '\P{^Numeric_Value=+2_9}', "");
    Error('\p{Nv=_/a/000000029}');
    Error('\P{Nv=_/a/000000029}');
    Expect(1, 12889, '\p{Nv=+00000000029}', "");
    Expect(0, 12889, '\p{^Nv=+00000000029}', "");
    Expect(0, 12889, '\P{Nv=+00000000029}', "");
    Expect(1, 12889, '\P{^Nv=+00000000029}', "");
    Expect(0, 12890, '\p{Nv=+00000000029}', "");
    Expect(1, 12890, '\p{^Nv=+00000000029}', "");
    Expect(1, 12890, '\P{Nv=+00000000029}', "");
    Expect(0, 12890, '\P{^Nv=+00000000029}', "");
    Error('\p{Is_Numeric_Value=:=_-002_9}');
    Error('\P{Is_Numeric_Value=:=_-002_9}');
    Expect(1, 12889, '\p{Is_Numeric_Value=0_0_0_0_0_0_0_0_29}', "");
    Expect(0, 12889, '\p{^Is_Numeric_Value=0_0_0_0_0_0_0_0_29}', "");
    Expect(0, 12889, '\P{Is_Numeric_Value=0_0_0_0_0_0_0_0_29}', "");
    Expect(1, 12889, '\P{^Is_Numeric_Value=0_0_0_0_0_0_0_0_29}', "");
    Expect(0, 12890, '\p{Is_Numeric_Value=0_0_0_0_0_0_0_0_29}', "");
    Expect(1, 12890, '\p{^Is_Numeric_Value=0_0_0_0_0_0_0_0_29}', "");
    Expect(1, 12890, '\P{Is_Numeric_Value=0_0_0_0_0_0_0_0_29}', "");
    Expect(0, 12890, '\P{^Is_Numeric_Value=0_0_0_0_0_0_0_0_29}', "");
    Error('\p{Is_Nv=:=_ 029}');
    Error('\P{Is_Nv=:=_ 029}');
    Expect(1, 12889, '\p{Is_Nv=0_0_0_0_0029}', "");
    Expect(0, 12889, '\p{^Is_Nv=0_0_0_0_0029}', "");
    Expect(0, 12889, '\P{Is_Nv=0_0_0_0_0029}', "");
    Expect(1, 12889, '\P{^Is_Nv=0_0_0_0_0029}', "");
    Expect(0, 12890, '\p{Is_Nv=0_0_0_0_0029}', "");
    Expect(1, 12890, '\p{^Is_Nv=0_0_0_0_0029}', "");
    Expect(1, 12890, '\P{Is_Nv=0_0_0_0_0029}', "");
    Expect(0, 12890, '\P{^Is_Nv=0_0_0_0_0029}', "");
    Error('\p{Numeric_Value: 	+0000000003:=}');
    Error('\P{Numeric_Value: 	+0000000003:=}');
    Expect(1, 146203, '\p{Numeric_Value=+3}', "");
    Expect(0, 146203, '\p{^Numeric_Value=+3}', "");
    Expect(0, 146203, '\P{Numeric_Value=+3}', "");
    Expect(1, 146203, '\P{^Numeric_Value=+3}', "");
    Expect(0, 146204, '\p{Numeric_Value=+3}', "");
    Expect(1, 146204, '\p{^Numeric_Value=+3}', "");
    Expect(1, 146204, '\P{Numeric_Value=+3}', "");
    Expect(0, 146204, '\P{^Numeric_Value=+3}', "");
    Error('\p{Nv:	0000000003:=}');
    Error('\P{Nv:	0000000003:=}');
    Expect(1, 146203, '\p{Nv=0003}', "");
    Expect(0, 146203, '\p{^Nv=0003}', "");
    Expect(0, 146203, '\P{Nv=0003}', "");
    Expect(1, 146203, '\P{^Nv=0003}', "");
    Expect(0, 146204, '\p{Nv=0003}', "");
    Expect(1, 146204, '\p{^Nv=0003}', "");
    Expect(1, 146204, '\P{Nv=0003}', "");
    Expect(0, 146204, '\P{^Nv=0003}', "");
    Error('\p{Is_Numeric_Value=0_0_03:=}');
    Error('\P{Is_Numeric_Value=0_0_03:=}');
    Expect(1, 146203, '\p{Is_Numeric_Value=+0003}', "");
    Expect(0, 146203, '\p{^Is_Numeric_Value=+0003}', "");
    Expect(0, 146203, '\P{Is_Numeric_Value=+0003}', "");
    Expect(1, 146203, '\P{^Is_Numeric_Value=+0003}', "");
    Expect(0, 146204, '\p{Is_Numeric_Value=+0003}', "");
    Expect(1, 146204, '\p{^Is_Numeric_Value=+0003}', "");
    Expect(1, 146204, '\P{Is_Numeric_Value=+0003}', "");
    Expect(0, 146204, '\P{^Is_Numeric_Value=+0003}', "");
    Error('\p{Is_Nv=_/a/000003}');
    Error('\P{Is_Nv=_/a/000003}');
    Expect(1, 146203, '\p{Is_Nv=0_0_0_0_0_00003}', "");
    Expect(0, 146203, '\p{^Is_Nv=0_0_0_0_0_00003}', "");
    Expect(0, 146203, '\P{Is_Nv=0_0_0_0_0_00003}', "");
    Expect(1, 146203, '\P{^Is_Nv=0_0_0_0_0_00003}', "");
    Expect(0, 146204, '\p{Is_Nv=0_0_0_0_0_00003}', "");
    Expect(1, 146204, '\p{^Is_Nv=0_0_0_0_0_00003}', "");
    Expect(1, 146204, '\P{Is_Nv=0_0_0_0_0_00003}', "");
    Expect(0, 146204, '\P{^Is_Nv=0_0_0_0_0_00003}', "");
    Error('\p{Numeric_Value=/a/	-00003/00016}');
    Error('\P{Numeric_Value=/a/	-00003/00016}');
    Expect(1, 43061, '\p{Numeric_Value=00003/00000016}', "");
    Expect(0, 43061, '\p{^Numeric_Value=00003/00000016}', "");
    Expect(0, 43061, '\P{Numeric_Value=00003/00000016}', "");
    Expect(1, 43061, '\P{^Numeric_Value=00003/00000016}', "");
    Expect(0, 43062, '\p{Numeric_Value=00003/00000016}', "");
    Expect(1, 43062, '\p{^Numeric_Value=00003/00000016}', "");
    Expect(1, 43062, '\P{Numeric_Value=00003/00000016}', "");
    Expect(0, 43062, '\P{^Numeric_Value=00003/00000016}', "");
    Error('\p{Numeric_Value=0.19}');
    Error('\P{Numeric_Value=0.19}');
    Expect(1, 43061, '\p{Numeric_Value=0.188}', "");
    Expect(0, 43061, '\p{^Numeric_Value=0.188}', "");
    Expect(0, 43061, '\P{Numeric_Value=0.188}', "");
    Expect(1, 43061, '\P{^Numeric_Value=0.188}', "");
    Expect(0, 43062, '\p{Numeric_Value=0.188}', "");
    Expect(1, 43062, '\p{^Numeric_Value=0.188}', "");
    Expect(1, 43062, '\P{Numeric_Value=0.188}', "");
    Expect(0, 43062, '\P{^Numeric_Value=0.188}', "");
    Error('\p{Nv=/a/+0003/0016}');
    Error('\P{Nv=/a/+0003/0016}');
    Expect(1, 43061, '\p{Nv=003/00000000016}', "");
    Expect(0, 43061, '\p{^Nv=003/00000000016}', "");
    Expect(0, 43061, '\P{Nv=003/00000000016}', "");
    Expect(1, 43061, '\P{^Nv=003/00000000016}', "");
    Expect(0, 43062, '\p{Nv=003/00000000016}', "");
    Expect(1, 43062, '\p{^Nv=003/00000000016}', "");
    Expect(1, 43062, '\P{Nv=003/00000000016}', "");
    Expect(0, 43062, '\P{^Nv=003/00000000016}', "");
    Error('\p{Nv=0.19}');
    Error('\P{Nv=0.19}');
    Expect(1, 43061, '\p{Nv=0.188}', "");
    Expect(0, 43061, '\p{^Nv=0.188}', "");
    Expect(0, 43061, '\P{Nv=0.188}', "");
    Expect(1, 43061, '\P{^Nv=0.188}', "");
    Expect(0, 43062, '\p{Nv=0.188}', "");
    Expect(1, 43062, '\p{^Nv=0.188}', "");
    Expect(1, 43062, '\P{Nv=0.188}', "");
    Expect(0, 43062, '\P{^Nv=0.188}', "");
    Error('\p{Is_Numeric_Value=	00003/016:=}');
    Error('\P{Is_Numeric_Value=	00003/016:=}');
    Expect(1, 43061, '\p{Is_Numeric_Value=3/0016}', "");
    Expect(0, 43061, '\p{^Is_Numeric_Value=3/0016}', "");
    Expect(0, 43061, '\P{Is_Numeric_Value=3/0016}', "");
    Expect(1, 43061, '\P{^Is_Numeric_Value=3/0016}', "");
    Expect(0, 43062, '\p{Is_Numeric_Value=3/0016}', "");
    Expect(1, 43062, '\p{^Is_Numeric_Value=3/0016}', "");
    Expect(1, 43062, '\P{Is_Numeric_Value=3/0016}', "");
    Expect(0, 43062, '\P{^Is_Numeric_Value=3/0016}', "");
    Error('\p{Is_Numeric_Value=0.19}');
    Error('\P{Is_Numeric_Value=0.19}');
    Expect(1, 43061, '\p{Is_Numeric_Value:0.188}', "");
    Expect(0, 43061, '\p{^Is_Numeric_Value:0.188}', "");
    Expect(0, 43061, '\P{Is_Numeric_Value:0.188}', "");
    Expect(1, 43061, '\P{^Is_Numeric_Value:0.188}', "");
    Expect(0, 43062, '\p{Is_Numeric_Value:0.188}', "");
    Expect(1, 43062, '\p{^Is_Numeric_Value:0.188}', "");
    Expect(1, 43062, '\P{Is_Numeric_Value:0.188}', "");
    Expect(0, 43062, '\P{^Is_Numeric_Value:0.188}', "");
    Error('\p{Is_Nv=:= 	+0000000003/00016}');
    Error('\P{Is_Nv=:= 	+0000000003/00016}');
    Expect(1, 43061, '\p{Is_Nv=00000003/0016}', "");
    Expect(0, 43061, '\p{^Is_Nv=00000003/0016}', "");
    Expect(0, 43061, '\P{Is_Nv=00000003/0016}', "");
    Expect(1, 43061, '\P{^Is_Nv=00000003/0016}', "");
    Expect(0, 43062, '\p{Is_Nv=00000003/0016}', "");
    Expect(1, 43062, '\p{^Is_Nv=00000003/0016}', "");
    Expect(1, 43062, '\P{Is_Nv=00000003/0016}', "");
    Expect(0, 43062, '\P{^Is_Nv=00000003/0016}', "");
    Error('\p{Is_Nv=0.19}');
    Error('\P{Is_Nv=0.19}');
    Expect(1, 43061, '\p{Is_Nv:	0.188}', "");
    Expect(0, 43061, '\p{^Is_Nv:	0.188}', "");
    Expect(0, 43061, '\P{Is_Nv:	0.188}', "");
    Expect(1, 43061, '\P{^Is_Nv:	0.188}', "");
    Expect(0, 43062, '\p{Is_Nv:	0.188}', "");
    Expect(1, 43062, '\p{^Is_Nv:	0.188}', "");
    Expect(1, 43062, '\P{Is_Nv:	0.188}', "");
    Expect(0, 43062, '\P{^Is_Nv:	0.188}', "");
    Error('\p{Numeric_Value=	_0000003/00002/a/}');
    Error('\P{Numeric_Value=	_0000003/00002/a/}');
    Expect(1, 3883, '\p{Numeric_Value=03/2}', "");
    Expect(0, 3883, '\p{^Numeric_Value=03/2}', "");
    Expect(0, 3883, '\P{Numeric_Value=03/2}', "");
    Expect(1, 3883, '\P{^Numeric_Value=03/2}', "");
    Expect(0, 3884, '\p{Numeric_Value=03/2}', "");
    Expect(1, 3884, '\p{^Numeric_Value=03/2}', "");
    Expect(1, 3884, '\P{Numeric_Value=03/2}', "");
    Expect(0, 3884, '\P{^Numeric_Value=03/2}', "");
    Expect(1, 3883, '\p{Numeric_Value=1.500}', "");
    Expect(0, 3883, '\p{^Numeric_Value=1.500}', "");
    Expect(0, 3883, '\P{Numeric_Value=1.500}', "");
    Expect(1, 3883, '\P{^Numeric_Value=1.500}', "");
    Expect(0, 3884, '\p{Numeric_Value=1.500}', "");
    Expect(1, 3884, '\p{^Numeric_Value=1.500}', "");
    Expect(1, 3884, '\P{Numeric_Value=1.500}', "");
    Expect(0, 3884, '\P{^Numeric_Value=1.500}', "");
    Error('\p{Nv=_ 0003/000002:=}');
    Error('\P{Nv=_ 0003/000002:=}');
    Expect(1, 3883, '\p{Nv=0000000003/00000002}', "");
    Expect(0, 3883, '\p{^Nv=0000000003/00000002}', "");
    Expect(0, 3883, '\P{Nv=0000000003/00000002}', "");
    Expect(1, 3883, '\P{^Nv=0000000003/00000002}', "");
    Expect(0, 3884, '\p{Nv=0000000003/00000002}', "");
    Expect(1, 3884, '\p{^Nv=0000000003/00000002}', "");
    Expect(1, 3884, '\P{Nv=0000000003/00000002}', "");
    Expect(0, 3884, '\P{^Nv=0000000003/00000002}', "");
    Expect(1, 3883, '\p{Nv=1.500}', "");
    Expect(0, 3883, '\p{^Nv=1.500}', "");
    Expect(0, 3883, '\P{Nv=1.500}', "");
    Expect(1, 3883, '\P{^Nv=1.500}', "");
    Expect(0, 3884, '\p{Nv=1.500}', "");
    Expect(1, 3884, '\p{^Nv=1.500}', "");
    Expect(1, 3884, '\P{Nv=1.500}', "");
    Expect(0, 3884, '\P{^Nv=1.500}', "");
    Error('\p{Is_Numeric_Value=/a/_0000000003/002}');
    Error('\P{Is_Numeric_Value=/a/_0000000003/002}');
    Expect(1, 3883, '\p{Is_Numeric_Value=0000000003/000000002}', "");
    Expect(0, 3883, '\p{^Is_Numeric_Value=0000000003/000000002}', "");
    Expect(0, 3883, '\P{Is_Numeric_Value=0000000003/000000002}', "");
    Expect(1, 3883, '\P{^Is_Numeric_Value=0000000003/000000002}', "");
    Expect(0, 3884, '\p{Is_Numeric_Value=0000000003/000000002}', "");
    Expect(1, 3884, '\p{^Is_Numeric_Value=0000000003/000000002}', "");
    Expect(1, 3884, '\P{Is_Numeric_Value=0000000003/000000002}', "");
    Expect(0, 3884, '\P{^Is_Numeric_Value=0000000003/000000002}', "");
    Expect(1, 3883, '\p{Is_Numeric_Value=1.500}', "");
    Expect(0, 3883, '\p{^Is_Numeric_Value=1.500}', "");
    Expect(0, 3883, '\P{Is_Numeric_Value=1.500}', "");
    Expect(1, 3883, '\P{^Is_Numeric_Value=1.500}', "");
    Expect(0, 3884, '\p{Is_Numeric_Value=1.500}', "");
    Expect(1, 3884, '\p{^Is_Numeric_Value=1.500}', "");
    Expect(1, 3884, '\P{Is_Numeric_Value=1.500}', "");
    Expect(0, 3884, '\P{^Is_Numeric_Value=1.500}', "");
    Error('\p{Is_Nv=/a/00003/02}');
    Error('\P{Is_Nv=/a/00003/02}');
    Expect(1, 3883, '\p{Is_Nv=0003/02}', "");
    Expect(0, 3883, '\p{^Is_Nv=0003/02}', "");
    Expect(0, 3883, '\P{Is_Nv=0003/02}', "");
    Expect(1, 3883, '\P{^Is_Nv=0003/02}', "");
    Expect(0, 3884, '\p{Is_Nv=0003/02}', "");
    Expect(1, 3884, '\p{^Is_Nv=0003/02}', "");
    Expect(1, 3884, '\P{Is_Nv=0003/02}', "");
    Expect(0, 3884, '\P{^Is_Nv=0003/02}', "");
    Expect(1, 3883, '\p{Is_Nv=1.500}', "");
    Expect(0, 3883, '\p{^Is_Nv=1.500}', "");
    Expect(0, 3883, '\P{Is_Nv=1.500}', "");
    Expect(1, 3883, '\P{^Is_Nv=1.500}', "");
    Expect(0, 3884, '\p{Is_Nv=1.500}', "");
    Expect(1, 3884, '\p{^Is_Nv=1.500}', "");
    Expect(1, 3884, '\P{Is_Nv=1.500}', "");
    Expect(0, 3884, '\P{^Is_Nv=1.500}', "");
    Error('\p{Numeric_Value= _0000003/000000020:=}');
    Error('\P{Numeric_Value= _0000003/000000020:=}');
    Expect(1, 3421, '\p{Numeric_Value=0000003/0020}', "");
    Expect(0, 3421, '\p{^Numeric_Value=0000003/0020}', "");
    Expect(0, 3421, '\P{Numeric_Value=0000003/0020}', "");
    Expect(1, 3421, '\P{^Numeric_Value=0000003/0020}', "");
    Expect(0, 3422, '\p{Numeric_Value=0000003/0020}', "");
    Expect(1, 3422, '\p{^Numeric_Value=0000003/0020}', "");
    Expect(1, 3422, '\P{Numeric_Value=0000003/0020}', "");
    Expect(0, 3422, '\P{^Numeric_Value=0000003/0020}', "");
    Expect(1, 3421, '\p{Numeric_Value=0.150}', "");
    Expect(0, 3421, '\p{^Numeric_Value=0.150}', "");
    Expect(0, 3421, '\P{Numeric_Value=0.150}', "");
    Expect(1, 3421, '\P{^Numeric_Value=0.150}', "");
    Expect(0, 3422, '\p{Numeric_Value=0.150}', "");
    Expect(1, 3422, '\p{^Numeric_Value=0.150}', "");
    Expect(1, 3422, '\P{Numeric_Value=0.150}', "");
    Expect(0, 3422, '\P{^Numeric_Value=0.150}', "");
    Error('\p{Nv=		+00000003/020/a/}');
    Error('\P{Nv=		+00000003/020/a/}');
    Expect(1, 3421, '\p{Nv: 3/020}', "");
    Expect(0, 3421, '\p{^Nv: 3/020}', "");
    Expect(0, 3421, '\P{Nv: 3/020}', "");
    Expect(1, 3421, '\P{^Nv: 3/020}', "");
    Expect(0, 3422, '\p{Nv: 3/020}', "");
    Expect(1, 3422, '\p{^Nv: 3/020}', "");
    Expect(1, 3422, '\P{Nv: 3/020}', "");
    Expect(0, 3422, '\P{^Nv: 3/020}', "");
    Expect(1, 3421, '\p{Nv=0.150}', "");
    Expect(0, 3421, '\p{^Nv=0.150}', "");
    Expect(0, 3421, '\P{Nv=0.150}', "");
    Expect(1, 3421, '\P{^Nv=0.150}', "");
    Expect(0, 3422, '\p{Nv=0.150}', "");
    Expect(1, 3422, '\p{^Nv=0.150}', "");
    Expect(1, 3422, '\P{Nv=0.150}', "");
    Expect(0, 3422, '\P{^Nv=0.150}', "");
    Error('\p{Is_Numeric_Value=_	00003/0000000020/a/}');
    Error('\P{Is_Numeric_Value=_	00003/0000000020/a/}');
    Expect(1, 3421, '\p{Is_Numeric_Value=00000003/00020}', "");
    Expect(0, 3421, '\p{^Is_Numeric_Value=00000003/00020}', "");
    Expect(0, 3421, '\P{Is_Numeric_Value=00000003/00020}', "");
    Expect(1, 3421, '\P{^Is_Numeric_Value=00000003/00020}', "");
    Expect(0, 3422, '\p{Is_Numeric_Value=00000003/00020}', "");
    Expect(1, 3422, '\p{^Is_Numeric_Value=00000003/00020}', "");
    Expect(1, 3422, '\P{Is_Numeric_Value=00000003/00020}', "");
    Expect(0, 3422, '\P{^Is_Numeric_Value=00000003/00020}', "");
    Expect(1, 3421, '\p{Is_Numeric_Value=0.150}', "");
    Expect(0, 3421, '\p{^Is_Numeric_Value=0.150}', "");
    Expect(0, 3421, '\P{Is_Numeric_Value=0.150}', "");
    Expect(1, 3421, '\P{^Is_Numeric_Value=0.150}', "");
    Expect(0, 3422, '\p{Is_Numeric_Value=0.150}', "");
    Expect(1, 3422, '\p{^Is_Numeric_Value=0.150}', "");
    Expect(1, 3422, '\P{Is_Numeric_Value=0.150}', "");
    Expect(0, 3422, '\P{^Is_Numeric_Value=0.150}', "");
    Error('\p{Is_Nv=/a/+0003/00000000020}');
    Error('\P{Is_Nv=/a/+0003/00000000020}');
    Expect(1, 3421, '\p{Is_Nv:	000003/0020}', "");
    Expect(0, 3421, '\p{^Is_Nv:	000003/0020}', "");
    Expect(0, 3421, '\P{Is_Nv:	000003/0020}', "");
    Expect(1, 3421, '\P{^Is_Nv:	000003/0020}', "");
    Expect(0, 3422, '\p{Is_Nv:	000003/0020}', "");
    Expect(1, 3422, '\p{^Is_Nv:	000003/0020}', "");
    Expect(1, 3422, '\P{Is_Nv:	000003/0020}', "");
    Expect(0, 3422, '\P{^Is_Nv:	000003/0020}', "");
    Expect(1, 3421, '\p{Is_Nv=0.150}', "");
    Expect(0, 3421, '\p{^Is_Nv=0.150}', "");
    Expect(0, 3421, '\P{Is_Nv=0.150}', "");
    Expect(1, 3421, '\P{^Is_Nv=0.150}', "");
    Expect(0, 3422, '\p{Is_Nv=0.150}', "");
    Expect(1, 3422, '\p{^Is_Nv=0.150}', "");
    Expect(1, 3422, '\P{Is_Nv=0.150}', "");
    Expect(0, 3422, '\P{^Is_Nv=0.150}', "");
    Error('\p{Numeric_Value= :=03/04}');
    Error('\P{Numeric_Value= :=03/04}');
    Expect(1, 68094, '\p{Numeric_Value=+00003/00004}', "");
    Expect(0, 68094, '\p{^Numeric_Value=+00003/00004}', "");
    Expect(0, 68094, '\P{Numeric_Value=+00003/00004}', "");
    Expect(1, 68094, '\P{^Numeric_Value=+00003/00004}', "");
    Expect(0, 68095, '\p{Numeric_Value=+00003/00004}', "");
    Expect(1, 68095, '\p{^Numeric_Value=+00003/00004}', "");
    Expect(1, 68095, '\P{Numeric_Value=+00003/00004}', "");
    Expect(0, 68095, '\P{^Numeric_Value=+00003/00004}', "");
    Expect(1, 68094, '\p{Numeric_Value=0.750}', "");
    Expect(0, 68094, '\p{^Numeric_Value=0.750}', "");
    Expect(0, 68094, '\P{Numeric_Value=0.750}', "");
    Expect(1, 68094, '\P{^Numeric_Value=0.750}', "");
    Expect(0, 68095, '\p{Numeric_Value=0.750}', "");
    Expect(1, 68095, '\p{^Numeric_Value=0.750}', "");
    Expect(1, 68095, '\P{Numeric_Value=0.750}', "");
    Expect(0, 68095, '\P{^Numeric_Value=0.750}', "");
    Error('\p{Nv:   :=+00003/0000004}');
    Error('\P{Nv:   :=+00003/0000004}');
    Expect(1, 68094, '\p{Nv=+00000003/000000004}', "");
    Expect(0, 68094, '\p{^Nv=+00000003/000000004}', "");
    Expect(0, 68094, '\P{Nv=+00000003/000000004}', "");
    Expect(1, 68094, '\P{^Nv=+00000003/000000004}', "");
    Expect(0, 68095, '\p{Nv=+00000003/000000004}', "");
    Expect(1, 68095, '\p{^Nv=+00000003/000000004}', "");
    Expect(1, 68095, '\P{Nv=+00000003/000000004}', "");
    Expect(0, 68095, '\P{^Nv=+00000003/000000004}', "");
    Expect(1, 68094, '\p{Nv=0.750}', "");
    Expect(0, 68094, '\p{^Nv=0.750}', "");
    Expect(0, 68094, '\P{Nv=0.750}', "");
    Expect(1, 68094, '\P{^Nv=0.750}', "");
    Expect(0, 68095, '\p{Nv=0.750}', "");
    Expect(1, 68095, '\p{^Nv=0.750}', "");
    Expect(1, 68095, '\P{Nv=0.750}', "");
    Expect(0, 68095, '\P{^Nv=0.750}', "");
    Error('\p{Is_Numeric_Value=__003/4/a/}');
    Error('\P{Is_Numeric_Value=__003/4/a/}');
    Expect(1, 68094, '\p{Is_Numeric_Value=000003/4}', "");
    Expect(0, 68094, '\p{^Is_Numeric_Value=000003/4}', "");
    Expect(0, 68094, '\P{Is_Numeric_Value=000003/4}', "");
    Expect(1, 68094, '\P{^Is_Numeric_Value=000003/4}', "");
    Expect(0, 68095, '\p{Is_Numeric_Value=000003/4}', "");
    Expect(1, 68095, '\p{^Is_Numeric_Value=000003/4}', "");
    Expect(1, 68095, '\P{Is_Numeric_Value=000003/4}', "");
    Expect(0, 68095, '\P{^Is_Numeric_Value=000003/4}', "");
    Expect(1, 68094, '\p{Is_Numeric_Value=0.750}', "");
    Expect(0, 68094, '\p{^Is_Numeric_Value=0.750}', "");
    Expect(0, 68094, '\P{Is_Numeric_Value=0.750}', "");
    Expect(1, 68094, '\P{^Is_Numeric_Value=0.750}', "");
    Expect(0, 68095, '\p{Is_Numeric_Value=0.750}', "");
    Expect(1, 68095, '\p{^Is_Numeric_Value=0.750}', "");
    Expect(1, 68095, '\P{Is_Numeric_Value=0.750}', "");
    Expect(0, 68095, '\P{^Is_Numeric_Value=0.750}', "");
    Error('\p{Is_Nv=-_00003/00004/a/}');
    Error('\P{Is_Nv=-_00003/00004/a/}');
    Expect(1, 68094, '\p{Is_Nv=003/0000004}', "");
    Expect(0, 68094, '\p{^Is_Nv=003/0000004}', "");
    Expect(0, 68094, '\P{Is_Nv=003/0000004}', "");
    Expect(1, 68094, '\P{^Is_Nv=003/0000004}', "");
    Expect(0, 68095, '\p{Is_Nv=003/0000004}', "");
    Expect(1, 68095, '\p{^Is_Nv=003/0000004}', "");
    Expect(1, 68095, '\P{Is_Nv=003/0000004}', "");
    Expect(0, 68095, '\P{^Is_Nv=003/0000004}', "");
    Expect(1, 68094, '\p{Is_Nv=0.750}', "");
    Expect(0, 68094, '\p{^Is_Nv=0.750}', "");
    Expect(0, 68094, '\P{Is_Nv=0.750}', "");
    Expect(1, 68094, '\P{^Is_Nv=0.750}', "");
    Expect(0, 68095, '\p{Is_Nv=0.750}', "");
    Expect(1, 68095, '\p{^Is_Nv=0.750}', "");
    Expect(1, 68095, '\P{Is_Nv=0.750}', "");
    Expect(0, 68095, '\P{^Is_Nv=0.750}', "");
    Error('\p{Numeric_Value=	:=00003/00005}');
    Error('\P{Numeric_Value=	:=00003/00005}');
    Expect(1, 8535, '\p{Numeric_Value=+0000003/00005}', "");
    Expect(0, 8535, '\p{^Numeric_Value=+0000003/00005}', "");
    Expect(0, 8535, '\P{Numeric_Value=+0000003/00005}', "");
    Expect(1, 8535, '\P{^Numeric_Value=+0000003/00005}', "");
    Expect(0, 8536, '\p{Numeric_Value=+0000003/00005}', "");
    Expect(1, 8536, '\p{^Numeric_Value=+0000003/00005}', "");
    Expect(1, 8536, '\P{Numeric_Value=+0000003/00005}', "");
    Expect(0, 8536, '\P{^Numeric_Value=+0000003/00005}', "");
    Expect(1, 8535, '\p{Numeric_Value=0.600}', "");
    Expect(0, 8535, '\p{^Numeric_Value=0.600}', "");
    Expect(0, 8535, '\P{Numeric_Value=0.600}', "");
    Expect(1, 8535, '\P{^Numeric_Value=0.600}', "");
    Expect(0, 8536, '\p{Numeric_Value=0.600}', "");
    Expect(1, 8536, '\p{^Numeric_Value=0.600}', "");
    Expect(1, 8536, '\P{Numeric_Value=0.600}', "");
    Expect(0, 8536, '\P{^Numeric_Value=0.600}', "");
    Error('\p{Nv=	:=0000000003/0000000005}');
    Error('\P{Nv=	:=0000000003/0000000005}');
    Expect(1, 8535, '\p{Nv: +0000003/005}', "");
    Expect(0, 8535, '\p{^Nv: +0000003/005}', "");
    Expect(0, 8535, '\P{Nv: +0000003/005}', "");
    Expect(1, 8535, '\P{^Nv: +0000003/005}', "");
    Expect(0, 8536, '\p{Nv: +0000003/005}', "");
    Expect(1, 8536, '\p{^Nv: +0000003/005}', "");
    Expect(1, 8536, '\P{Nv: +0000003/005}', "");
    Expect(0, 8536, '\P{^Nv: +0000003/005}', "");
    Expect(1, 8535, '\p{Nv=0.600}', "");
    Expect(0, 8535, '\p{^Nv=0.600}', "");
    Expect(0, 8535, '\P{Nv=0.600}', "");
    Expect(1, 8535, '\P{^Nv=0.600}', "");
    Expect(0, 8536, '\p{Nv=0.600}', "");
    Expect(1, 8536, '\p{^Nv=0.600}', "");
    Expect(1, 8536, '\P{Nv=0.600}', "");
    Expect(0, 8536, '\P{^Nv=0.600}', "");
    Error('\p{Is_Numeric_Value=	03/5:=}');
    Error('\P{Is_Numeric_Value=	03/5:=}');
    Expect(1, 8535, '\p{Is_Numeric_Value=+000003/0000005}', "");
    Expect(0, 8535, '\p{^Is_Numeric_Value=+000003/0000005}', "");
    Expect(0, 8535, '\P{Is_Numeric_Value=+000003/0000005}', "");
    Expect(1, 8535, '\P{^Is_Numeric_Value=+000003/0000005}', "");
    Expect(0, 8536, '\p{Is_Numeric_Value=+000003/0000005}', "");
    Expect(1, 8536, '\p{^Is_Numeric_Value=+000003/0000005}', "");
    Expect(1, 8536, '\P{Is_Numeric_Value=+000003/0000005}', "");
    Expect(0, 8536, '\P{^Is_Numeric_Value=+000003/0000005}', "");
    Expect(1, 8535, '\p{Is_Numeric_Value=0.600}', "");
    Expect(0, 8535, '\p{^Is_Numeric_Value=0.600}', "");
    Expect(0, 8535, '\P{Is_Numeric_Value=0.600}', "");
    Expect(1, 8535, '\P{^Is_Numeric_Value=0.600}', "");
    Expect(0, 8536, '\p{Is_Numeric_Value=0.600}', "");
    Expect(1, 8536, '\p{^Is_Numeric_Value=0.600}', "");
    Expect(1, 8536, '\P{Is_Numeric_Value=0.600}', "");
    Expect(0, 8536, '\P{^Is_Numeric_Value=0.600}', "");
    Error('\p{Is_Nv:/a/-03/000000005}');
    Error('\P{Is_Nv:/a/-03/000000005}');
    Expect(1, 8535, '\p{Is_Nv=000003/05}', "");
    Expect(0, 8535, '\p{^Is_Nv=000003/05}', "");
    Expect(0, 8535, '\P{Is_Nv=000003/05}', "");
    Expect(1, 8535, '\P{^Is_Nv=000003/05}', "");
    Expect(0, 8536, '\p{Is_Nv=000003/05}', "");
    Expect(1, 8536, '\p{^Is_Nv=000003/05}', "");
    Expect(1, 8536, '\P{Is_Nv=000003/05}', "");
    Expect(0, 8536, '\P{^Is_Nv=000003/05}', "");
    Expect(1, 8535, '\p{Is_Nv=0.600}', "");
    Expect(0, 8535, '\p{^Is_Nv=0.600}', "");
    Expect(0, 8535, '\P{Is_Nv=0.600}', "");
    Expect(1, 8535, '\P{^Is_Nv=0.600}', "");
    Expect(0, 8536, '\p{Is_Nv=0.600}', "");
    Expect(1, 8536, '\p{^Is_Nv=0.600}', "");
    Expect(1, 8536, '\P{Is_Nv=0.600}', "");
    Expect(0, 8536, '\P{^Is_Nv=0.600}', "");
    Error('\p{Numeric_Value= +00003/000000008:=}');
    Error('\P{Numeric_Value= +00003/000000008:=}');
    Expect(1, 8540, '\p{Numeric_Value=0000003/08}', "");
    Expect(0, 8540, '\p{^Numeric_Value=0000003/08}', "");
    Expect(0, 8540, '\P{Numeric_Value=0000003/08}', "");
    Expect(1, 8540, '\P{^Numeric_Value=0000003/08}', "");
    Expect(0, 8541, '\p{Numeric_Value=0000003/08}', "");
    Expect(1, 8541, '\p{^Numeric_Value=0000003/08}', "");
    Expect(1, 8541, '\P{Numeric_Value=0000003/08}', "");
    Expect(0, 8541, '\P{^Numeric_Value=0000003/08}', "");
    Error('\p{Numeric_Value=0.38}');
    Error('\P{Numeric_Value=0.38}');
    Expect(1, 8540, '\p{Numeric_Value=0.375}', "");
    Expect(0, 8540, '\p{^Numeric_Value=0.375}', "");
    Expect(0, 8540, '\P{Numeric_Value=0.375}', "");
    Expect(1, 8540, '\P{^Numeric_Value=0.375}', "");
    Expect(0, 8541, '\p{Numeric_Value=0.375}', "");
    Expect(1, 8541, '\p{^Numeric_Value=0.375}', "");
    Expect(1, 8541, '\P{Numeric_Value=0.375}', "");
    Expect(0, 8541, '\P{^Numeric_Value=0.375}', "");
    Error('\p{Nv=_/a/+0000000003/000008}');
    Error('\P{Nv=_/a/+0000000003/000008}');
    Expect(1, 8540, '\p{Nv=3/8}', "");
    Expect(0, 8540, '\p{^Nv=3/8}', "");
    Expect(0, 8540, '\P{Nv=3/8}', "");
    Expect(1, 8540, '\P{^Nv=3/8}', "");
    Expect(0, 8541, '\p{Nv=3/8}', "");
    Expect(1, 8541, '\p{^Nv=3/8}', "");
    Expect(1, 8541, '\P{Nv=3/8}', "");
    Expect(0, 8541, '\P{^Nv=3/8}', "");
    Error('\p{Nv=0.38}');
    Error('\P{Nv=0.38}');
    Expect(1, 8540, '\p{Nv=0.375}', "");
    Expect(0, 8540, '\p{^Nv=0.375}', "");
    Expect(0, 8540, '\P{Nv=0.375}', "");
    Expect(1, 8540, '\P{^Nv=0.375}', "");
    Expect(0, 8541, '\p{Nv=0.375}', "");
    Expect(1, 8541, '\p{^Nv=0.375}', "");
    Expect(1, 8541, '\P{Nv=0.375}', "");
    Expect(0, 8541, '\P{^Nv=0.375}', "");
    Error('\p{Is_Numeric_Value=:=		0000000003/0000008}');
    Error('\P{Is_Numeric_Value=:=		0000000003/0000008}');
    Expect(1, 8540, '\p{Is_Numeric_Value=0000000003/08}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value=0000000003/08}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value=0000000003/08}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value=0000000003/08}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value=0000000003/08}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value=0000000003/08}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value=0000000003/08}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value=0000000003/08}', "");
    Error('\p{Is_Numeric_Value=0.38}');
    Error('\P{Is_Numeric_Value=0.38}');
    Expect(1, 8540, '\p{Is_Numeric_Value=0.375}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value=0.375}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value=0.375}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value=0.375}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value=0.375}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value=0.375}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value=0.375}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value=0.375}', "");
    Error('\p{Is_Nv=:=+3/00000008}');
    Error('\P{Is_Nv=:=+3/00000008}');
    Expect(1, 8540, '\p{Is_Nv=+003/08}', "");
    Expect(0, 8540, '\p{^Is_Nv=+003/08}', "");
    Expect(0, 8540, '\P{Is_Nv=+003/08}', "");
    Expect(1, 8540, '\P{^Is_Nv=+003/08}', "");
    Expect(0, 8541, '\p{Is_Nv=+003/08}', "");
    Expect(1, 8541, '\p{^Is_Nv=+003/08}', "");
    Expect(1, 8541, '\P{Is_Nv=+003/08}', "");
    Expect(0, 8541, '\P{^Is_Nv=+003/08}', "");
    Error('\p{Is_Nv=0.38}');
    Error('\P{Is_Nv=0.38}');
    Expect(1, 8540, '\p{Is_Nv=0.375}', "");
    Expect(0, 8540, '\p{^Is_Nv=0.375}', "");
    Expect(0, 8540, '\P{Is_Nv=0.375}', "");
    Expect(1, 8540, '\P{^Is_Nv=0.375}', "");
    Expect(0, 8541, '\p{Is_Nv=0.375}', "");
    Expect(1, 8541, '\p{^Is_Nv=0.375}', "");
    Expect(1, 8541, '\P{Is_Nv=0.375}', "");
    Expect(0, 8541, '\P{^Is_Nv=0.375}', "");
    Error('\p{Numeric_Value=/a/-	+000003/00000000080}');
    Error('\P{Numeric_Value=/a/-	+000003/00000000080}');
    Expect(1, 3418, '\p{Numeric_Value=0000003/00080}', "");
    Expect(0, 3418, '\p{^Numeric_Value=0000003/00080}', "");
    Expect(0, 3418, '\P{Numeric_Value=0000003/00080}', "");
    Expect(1, 3418, '\P{^Numeric_Value=0000003/00080}', "");
    Expect(0, 3419, '\p{Numeric_Value=0000003/00080}', "");
    Expect(1, 3419, '\p{^Numeric_Value=0000003/00080}', "");
    Expect(1, 3419, '\P{Numeric_Value=0000003/00080}', "");
    Expect(0, 3419, '\P{^Numeric_Value=0000003/00080}', "");
    Error('\p{Numeric_Value=0.04}');
    Error('\P{Numeric_Value=0.04}');
    Expect(1, 3418, '\p{Numeric_Value=0.037}', "");
    Expect(0, 3418, '\p{^Numeric_Value=0.037}', "");
    Expect(0, 3418, '\P{Numeric_Value=0.037}', "");
    Expect(1, 3418, '\P{^Numeric_Value=0.037}', "");
    Expect(0, 3419, '\p{Numeric_Value=0.037}', "");
    Expect(1, 3419, '\p{^Numeric_Value=0.037}', "");
    Expect(1, 3419, '\P{Numeric_Value=0.037}', "");
    Expect(0, 3419, '\P{^Numeric_Value=0.037}', "");
    Error('\p{Nv=-/a/000003/00000000080}');
    Error('\P{Nv=-/a/000003/00000000080}');
    Expect(1, 3418, '\p{Nv=+0000000003/0000000080}', "");
    Expect(0, 3418, '\p{^Nv=+0000000003/0000000080}', "");
    Expect(0, 3418, '\P{Nv=+0000000003/0000000080}', "");
    Expect(1, 3418, '\P{^Nv=+0000000003/0000000080}', "");
    Expect(0, 3419, '\p{Nv=+0000000003/0000000080}', "");
    Expect(1, 3419, '\p{^Nv=+0000000003/0000000080}', "");
    Expect(1, 3419, '\P{Nv=+0000000003/0000000080}', "");
    Expect(0, 3419, '\P{^Nv=+0000000003/0000000080}', "");
    Error('\p{Nv=0.04}');
    Error('\P{Nv=0.04}');
    Expect(1, 3418, '\p{Nv=0.037}', "");
    Expect(0, 3418, '\p{^Nv=0.037}', "");
    Expect(0, 3418, '\P{Nv=0.037}', "");
    Expect(1, 3418, '\P{^Nv=0.037}', "");
    Expect(0, 3419, '\p{Nv=0.037}', "");
    Expect(1, 3419, '\p{^Nv=0.037}', "");
    Expect(1, 3419, '\P{Nv=0.037}', "");
    Expect(0, 3419, '\P{^Nv=0.037}', "");
    Error('\p{Is_Numeric_Value= :=+00000003/00000000080}');
    Error('\P{Is_Numeric_Value= :=+00000003/00000000080}');
    Expect(1, 3418, '\p{Is_Numeric_Value=0000003/0080}', "");
    Expect(0, 3418, '\p{^Is_Numeric_Value=0000003/0080}', "");
    Expect(0, 3418, '\P{Is_Numeric_Value=0000003/0080}', "");
    Expect(1, 3418, '\P{^Is_Numeric_Value=0000003/0080}', "");
    Expect(0, 3419, '\p{Is_Numeric_Value=0000003/0080}', "");
    Expect(1, 3419, '\p{^Is_Numeric_Value=0000003/0080}', "");
    Expect(1, 3419, '\P{Is_Numeric_Value=0000003/0080}', "");
    Expect(0, 3419, '\P{^Is_Numeric_Value=0000003/0080}', "");
    Error('\p{Is_Numeric_Value:	0.04}');
    Error('\P{Is_Numeric_Value:	0.04}');
    Expect(1, 3418, '\p{Is_Numeric_Value=0.037}', "");
    Expect(0, 3418, '\p{^Is_Numeric_Value=0.037}', "");
    Expect(0, 3418, '\P{Is_Numeric_Value=0.037}', "");
    Expect(1, 3418, '\P{^Is_Numeric_Value=0.037}', "");
    Expect(0, 3419, '\p{Is_Numeric_Value=0.037}', "");
    Expect(1, 3419, '\p{^Is_Numeric_Value=0.037}', "");
    Expect(1, 3419, '\P{Is_Numeric_Value=0.037}', "");
    Expect(0, 3419, '\P{^Is_Numeric_Value=0.037}', "");
    Error('\p{Is_Nv=/a/		+0003/000080}');
    Error('\P{Is_Nv=/a/		+0003/000080}');
    Expect(1, 3418, '\p{Is_Nv=+000000003/0000000080}', "");
    Expect(0, 3418, '\p{^Is_Nv=+000000003/0000000080}', "");
    Expect(0, 3418, '\P{Is_Nv=+000000003/0000000080}', "");
    Expect(1, 3418, '\P{^Is_Nv=+000000003/0000000080}', "");
    Expect(0, 3419, '\p{Is_Nv=+000000003/0000000080}', "");
    Expect(1, 3419, '\p{^Is_Nv=+000000003/0000000080}', "");
    Expect(1, 3419, '\P{Is_Nv=+000000003/0000000080}', "");
    Expect(0, 3419, '\P{^Is_Nv=+000000003/0000000080}', "");
    Error('\p{Is_Nv=0.04}');
    Error('\P{Is_Nv=0.04}');
    Expect(1, 3418, '\p{Is_Nv:	0.037}', "");
    Expect(0, 3418, '\p{^Is_Nv:	0.037}', "");
    Expect(0, 3418, '\P{Is_Nv:	0.037}', "");
    Expect(1, 3418, '\P{^Is_Nv:	0.037}', "");
    Expect(0, 3419, '\p{Is_Nv:	0.037}', "");
    Expect(1, 3419, '\p{^Is_Nv:	0.037}', "");
    Expect(1, 3419, '\P{Is_Nv:	0.037}', "");
    Expect(0, 3419, '\P{^Is_Nv:	0.037}', "");
    Error('\p{Numeric_Value: :=__0030}');
    Error('\P{Numeric_Value: :=__0030}');
    Expect(1, 133507, '\p{Numeric_Value=00000030}', "");
    Expect(0, 133507, '\p{^Numeric_Value=00000030}', "");
    Expect(0, 133507, '\P{Numeric_Value=00000030}', "");
    Expect(1, 133507, '\P{^Numeric_Value=00000030}', "");
    Expect(0, 133508, '\p{Numeric_Value=00000030}', "");
    Expect(1, 133508, '\p{^Numeric_Value=00000030}', "");
    Expect(1, 133508, '\P{Numeric_Value=00000030}', "");
    Expect(0, 133508, '\P{^Numeric_Value=00000030}', "");
    Error('\p{Nv:  0003_0:=}');
    Error('\P{Nv:  0003_0:=}');
    Expect(1, 133507, '\p{Nv=+0000000030}', "");
    Expect(0, 133507, '\p{^Nv=+0000000030}', "");
    Expect(0, 133507, '\P{Nv=+0000000030}', "");
    Expect(1, 133507, '\P{^Nv=+0000000030}', "");
    Expect(0, 133508, '\p{Nv=+0000000030}', "");
    Expect(1, 133508, '\p{^Nv=+0000000030}', "");
    Expect(1, 133508, '\P{Nv=+0000000030}', "");
    Expect(0, 133508, '\P{^Nv=+0000000030}', "");
    Error('\p{Is_Numeric_Value=-	000030:=}');
    Error('\P{Is_Numeric_Value=-	000030:=}');
    Expect(1, 133507, '\p{Is_Numeric_Value=+0000000030}', "");
    Expect(0, 133507, '\p{^Is_Numeric_Value=+0000000030}', "");
    Expect(0, 133507, '\P{Is_Numeric_Value=+0000000030}', "");
    Expect(1, 133507, '\P{^Is_Numeric_Value=+0000000030}', "");
    Expect(0, 133508, '\p{Is_Numeric_Value=+0000000030}', "");
    Expect(1, 133508, '\p{^Is_Numeric_Value=+0000000030}', "");
    Expect(1, 133508, '\P{Is_Numeric_Value=+0000000030}', "");
    Expect(0, 133508, '\P{^Is_Numeric_Value=+0000000030}', "");
    Error('\p{Is_Nv:    /a/000030}');
    Error('\P{Is_Nv:    /a/000030}');
    Expect(1, 133507, '\p{Is_Nv=+03_0}', "");
    Expect(0, 133507, '\p{^Is_Nv=+03_0}', "");
    Expect(0, 133507, '\P{Is_Nv=+03_0}', "");
    Expect(1, 133507, '\P{^Is_Nv=+03_0}', "");
    Expect(0, 133508, '\p{Is_Nv=+03_0}', "");
    Expect(1, 133508, '\p{^Is_Nv=+03_0}', "");
    Expect(1, 133508, '\P{Is_Nv=+03_0}', "");
    Expect(0, 133508, '\P{^Is_Nv=+03_0}', "");
    Error('\p{Numeric_Value=/a/-300}');
    Error('\P{Numeric_Value=/a/-300}');
    Expect(1, 69236, '\p{Numeric_Value=+000000300}', "");
    Expect(0, 69236, '\p{^Numeric_Value=+000000300}', "");
    Expect(0, 69236, '\P{Numeric_Value=+000000300}', "");
    Expect(1, 69236, '\P{^Numeric_Value=+000000300}', "");
    Expect(0, 69237, '\p{Numeric_Value=+000000300}', "");
    Expect(1, 69237, '\p{^Numeric_Value=+000000300}', "");
    Expect(1, 69237, '\P{Numeric_Value=+000000300}', "");
    Expect(0, 69237, '\P{^Numeric_Value=+000000300}', "");
    Error('\p{Nv= _000_003_00:=}');
    Error('\P{Nv= _000_003_00:=}');
    Expect(1, 69236, '\p{Nv: 000_030_0}', "");
    Expect(0, 69236, '\p{^Nv: 000_030_0}', "");
    Expect(0, 69236, '\P{Nv: 000_030_0}', "");
    Expect(1, 69236, '\P{^Nv: 000_030_0}', "");
    Expect(0, 69237, '\p{Nv: 000_030_0}', "");
    Expect(1, 69237, '\p{^Nv: 000_030_0}', "");
    Expect(1, 69237, '\P{Nv: 000_030_0}', "");
    Expect(0, 69237, '\P{^Nv: 000_030_0}', "");
    Error('\p{Is_Numeric_Value=/a/+0_0_0_0_0300}');
    Error('\P{Is_Numeric_Value=/a/+0_0_0_0_0300}');
    Expect(1, 69236, '\p{Is_Numeric_Value=+00000030_0}', "");
    Expect(0, 69236, '\p{^Is_Numeric_Value=+00000030_0}', "");
    Expect(0, 69236, '\P{Is_Numeric_Value=+00000030_0}', "");
    Expect(1, 69236, '\P{^Is_Numeric_Value=+00000030_0}', "");
    Expect(0, 69237, '\p{Is_Numeric_Value=+00000030_0}', "");
    Expect(1, 69237, '\p{^Is_Numeric_Value=+00000030_0}', "");
    Expect(1, 69237, '\P{Is_Numeric_Value=+00000030_0}', "");
    Expect(0, 69237, '\P{^Is_Numeric_Value=+00000030_0}', "");
    Error('\p{Is_Nv=-0_0_0_0_0_00300/a/}');
    Error('\P{Is_Nv=-0_0_0_0_0_00300/a/}');
    Expect(1, 69236, '\p{Is_Nv=+0_0_0_0_0_0_0_0_300}', "");
    Expect(0, 69236, '\p{^Is_Nv=+0_0_0_0_0_0_0_0_300}', "");
    Expect(0, 69236, '\P{Is_Nv=+0_0_0_0_0_0_0_0_300}', "");
    Expect(1, 69236, '\P{^Is_Nv=+0_0_0_0_0_0_0_0_300}', "");
    Expect(0, 69237, '\p{Is_Nv=+0_0_0_0_0_0_0_0_300}', "");
    Expect(1, 69237, '\p{^Is_Nv=+0_0_0_0_0_0_0_0_300}', "");
    Expect(1, 69237, '\P{Is_Nv=+0_0_0_0_0_0_0_0_300}', "");
    Expect(0, 69237, '\P{^Is_Nv=+0_0_0_0_0_0_0_0_300}', "");
    Error('\p{Numeric_Value=:=  0000_0000_0300_0}');
    Error('\P{Numeric_Value=:=  0000_0000_0300_0}');
    Expect(1, 68061, '\p{Numeric_Value=0_0_0_0_0_0_0_0_0_3_0_00}', "");
    Expect(0, 68061, '\p{^Numeric_Value=0_0_0_0_0_0_0_0_0_3_0_00}', "");
    Expect(0, 68061, '\P{Numeric_Value=0_0_0_0_0_0_0_0_0_3_0_00}', "");
    Expect(1, 68061, '\P{^Numeric_Value=0_0_0_0_0_0_0_0_0_3_0_00}', "");
    Expect(0, 68062, '\p{Numeric_Value=0_0_0_0_0_0_0_0_0_3_0_00}', "");
    Expect(1, 68062, '\p{^Numeric_Value=0_0_0_0_0_0_0_0_0_3_0_00}', "");
    Expect(1, 68062, '\P{Numeric_Value=0_0_0_0_0_0_0_0_0_3_0_00}', "");
    Expect(0, 68062, '\P{^Numeric_Value=0_0_0_0_0_0_0_0_0_3_0_00}', "");
    Error('\p{Nv=_/a/003000}');
    Error('\P{Nv=_/a/003000}');
    Expect(1, 68061, '\p{Nv:	000003000}', "");
    Expect(0, 68061, '\p{^Nv:	000003000}', "");
    Expect(0, 68061, '\P{Nv:	000003000}', "");
    Expect(1, 68061, '\P{^Nv:	000003000}', "");
    Expect(0, 68062, '\p{Nv:	000003000}', "");
    Expect(1, 68062, '\p{^Nv:	000003000}', "");
    Expect(1, 68062, '\P{Nv:	000003000}', "");
    Expect(0, 68062, '\P{^Nv:	000003000}', "");
    Error('\p{Is_Numeric_Value=:=0000003000}');
    Error('\P{Is_Numeric_Value=:=0000003000}');
    Expect(1, 68061, '\p{Is_Numeric_Value: +03000}', "");
    Expect(0, 68061, '\p{^Is_Numeric_Value: +03000}', "");
    Expect(0, 68061, '\P{Is_Numeric_Value: +03000}', "");
    Expect(1, 68061, '\P{^Is_Numeric_Value: +03000}', "");
    Expect(0, 68062, '\p{Is_Numeric_Value: +03000}', "");
    Expect(1, 68062, '\p{^Is_Numeric_Value: +03000}', "");
    Expect(1, 68062, '\P{Is_Numeric_Value: +03000}', "");
    Expect(0, 68062, '\P{^Is_Numeric_Value: +03000}', "");
    Error('\p{Is_Nv=:=_+0_0_0_3_000}');
    Error('\P{Is_Nv=:=_+0_0_0_3_000}');
    Expect(1, 68061, '\p{Is_Nv=+00003000}', "");
    Expect(0, 68061, '\p{^Is_Nv=+00003000}', "");
    Expect(0, 68061, '\P{Is_Nv=+00003000}', "");
    Expect(1, 68061, '\P{^Is_Nv=+00003000}', "");
    Expect(0, 68062, '\p{Is_Nv=+00003000}', "");
    Expect(1, 68062, '\p{^Is_Nv=+00003000}', "");
    Expect(1, 68062, '\P{Is_Nv=+00003000}', "");
    Expect(0, 68062, '\P{^Is_Nv=+00003000}', "");
    Error('\p{Numeric_Value=	:=+000000030000}');
    Error('\P{Numeric_Value=	:=+000000030000}');
    Expect(1, 68070, '\p{Numeric_Value=000030000}', "");
    Expect(0, 68070, '\p{^Numeric_Value=000030000}', "");
    Expect(0, 68070, '\P{Numeric_Value=000030000}', "");
    Expect(1, 68070, '\P{^Numeric_Value=000030000}', "");
    Expect(0, 68071, '\p{Numeric_Value=000030000}', "");
    Expect(1, 68071, '\p{^Numeric_Value=000030000}', "");
    Expect(1, 68071, '\P{Numeric_Value=000030000}', "");
    Expect(0, 68071, '\P{^Numeric_Value=000030000}', "");
    Error('\p{Nv= +0030000:=}');
    Error('\P{Nv= +0030000:=}');
    Expect(1, 68070, '\p{Nv=00_00_03_00_00}', "");
    Expect(0, 68070, '\p{^Nv=00_00_03_00_00}', "");
    Expect(0, 68070, '\P{Nv=00_00_03_00_00}', "");
    Expect(1, 68070, '\P{^Nv=00_00_03_00_00}', "");
    Expect(0, 68071, '\p{Nv=00_00_03_00_00}', "");
    Expect(1, 68071, '\p{^Nv=00_00_03_00_00}', "");
    Expect(1, 68071, '\P{Nv=00_00_03_00_00}', "");
    Expect(0, 68071, '\P{^Nv=00_00_03_00_00}', "");
    Error('\p{Is_Numeric_Value=_:=+00000030000}');
    Error('\P{Is_Numeric_Value=_:=+00000030000}');
    Expect(1, 68070, '\p{Is_Numeric_Value:	30000}', "");
    Expect(0, 68070, '\p{^Is_Numeric_Value:	30000}', "");
    Expect(0, 68070, '\P{Is_Numeric_Value:	30000}', "");
    Expect(1, 68070, '\P{^Is_Numeric_Value:	30000}', "");
    Expect(0, 68071, '\p{Is_Numeric_Value:	30000}', "");
    Expect(1, 68071, '\p{^Is_Numeric_Value:	30000}', "");
    Expect(1, 68071, '\P{Is_Numeric_Value:	30000}', "");
    Expect(0, 68071, '\P{^Is_Numeric_Value:	30000}', "");
    Error('\p{Is_Nv=:=	003000_0}');
    Error('\P{Is_Nv=:=	003000_0}');
    Expect(1, 68070, '\p{Is_Nv=030000}', "");
    Expect(0, 68070, '\p{^Is_Nv=030000}', "");
    Expect(0, 68070, '\P{Is_Nv=030000}', "");
    Expect(1, 68070, '\P{^Is_Nv=030000}', "");
    Expect(0, 68071, '\p{Is_Nv=030000}', "");
    Expect(1, 68071, '\p{^Is_Nv=030000}', "");
    Expect(1, 68071, '\P{Is_Nv=030000}', "");
    Expect(0, 68071, '\P{^Is_Nv=030000}', "");
    Error('\p{Numeric_Value=	00_00_03_00_000/a/}');
    Error('\P{Numeric_Value=	00_00_03_00_000/a/}');
    Expect(1, 68079, '\p{Numeric_Value=30000_0}', "");
    Expect(0, 68079, '\p{^Numeric_Value=30000_0}', "");
    Expect(0, 68079, '\P{Numeric_Value=30000_0}', "");
    Expect(1, 68079, '\P{^Numeric_Value=30000_0}', "");
    Expect(0, 68080, '\p{Numeric_Value=30000_0}', "");
    Expect(1, 68080, '\p{^Numeric_Value=30000_0}', "");
    Expect(1, 68080, '\P{Numeric_Value=30000_0}', "");
    Expect(0, 68080, '\P{^Numeric_Value=30000_0}', "");
    Error('\p{Nv=/a/--00_00_00_30_00_00}');
    Error('\P{Nv=/a/--00_00_00_30_00_00}');
    Expect(1, 68079, '\p{Nv=000000300000}', "");
    Expect(0, 68079, '\p{^Nv=000000300000}', "");
    Expect(0, 68079, '\P{Nv=000000300000}', "");
    Expect(1, 68079, '\P{^Nv=000000300000}', "");
    Expect(0, 68080, '\p{Nv=000000300000}', "");
    Expect(1, 68080, '\p{^Nv=000000300000}', "");
    Expect(1, 68080, '\P{Nv=000000300000}', "");
    Expect(0, 68080, '\P{^Nv=000000300000}', "");
    Error('\p{Is_Numeric_Value:   /a/	0300000}');
    Error('\P{Is_Numeric_Value:   /a/	0300000}');
    Expect(1, 68079, '\p{Is_Numeric_Value: +00300000}', "");
    Expect(0, 68079, '\p{^Is_Numeric_Value: +00300000}', "");
    Expect(0, 68079, '\P{Is_Numeric_Value: +00300000}', "");
    Expect(1, 68079, '\P{^Is_Numeric_Value: +00300000}', "");
    Expect(0, 68080, '\p{Is_Numeric_Value: +00300000}', "");
    Expect(1, 68080, '\p{^Is_Numeric_Value: +00300000}', "");
    Expect(1, 68080, '\P{Is_Numeric_Value: +00300000}', "");
    Expect(0, 68080, '\P{^Is_Numeric_Value: +00300000}', "");
    Error('\p{Is_Nv=	_+0_0_0_0_0_0_3_00000:=}');
    Error('\P{Is_Nv=	_+0_0_0_0_0_0_3_00000:=}');
    Expect(1, 68079, '\p{Is_Nv=300000}', "");
    Expect(0, 68079, '\p{^Is_Nv=300000}', "");
    Expect(0, 68079, '\P{Is_Nv=300000}', "");
    Expect(1, 68079, '\P{^Is_Nv=300000}', "");
    Expect(0, 68080, '\p{Is_Nv=300000}', "");
    Expect(1, 68080, '\p{^Is_Nv=300000}', "");
    Expect(1, 68080, '\P{Is_Nv=300000}', "");
    Expect(0, 68080, '\P{^Is_Nv=300000}', "");
    Error('\p{Numeric_Value=/a/--00031}');
    Error('\P{Numeric_Value=/a/--00031}');
    Expect(1, 12891, '\p{Numeric_Value=0000000031}', "");
    Expect(0, 12891, '\p{^Numeric_Value=0000000031}', "");
    Expect(0, 12891, '\P{Numeric_Value=0000000031}', "");
    Expect(1, 12891, '\P{^Numeric_Value=0000000031}', "");
    Expect(0, 12892, '\p{Numeric_Value=0000000031}', "");
    Expect(1, 12892, '\p{^Numeric_Value=0000000031}', "");
    Expect(1, 12892, '\P{Numeric_Value=0000000031}', "");
    Expect(0, 12892, '\P{^Numeric_Value=0000000031}', "");
    Error('\p{Nv= _0031/a/}');
    Error('\P{Nv= _0031/a/}');
    Expect(1, 12891, '\p{Nv=00000000031}', "");
    Expect(0, 12891, '\p{^Nv=00000000031}', "");
    Expect(0, 12891, '\P{Nv=00000000031}', "");
    Expect(1, 12891, '\P{^Nv=00000000031}', "");
    Expect(0, 12892, '\p{Nv=00000000031}', "");
    Expect(1, 12892, '\p{^Nv=00000000031}', "");
    Expect(1, 12892, '\P{Nv=00000000031}', "");
    Expect(0, 12892, '\P{^Nv=00000000031}', "");
    Error('\p{Is_Numeric_Value= :=+00_00_03_1}');
    Error('\P{Is_Numeric_Value= :=+00_00_03_1}');
    Expect(1, 12891, '\p{Is_Numeric_Value=31}', "");
    Expect(0, 12891, '\p{^Is_Numeric_Value=31}', "");
    Expect(0, 12891, '\P{Is_Numeric_Value=31}', "");
    Expect(1, 12891, '\P{^Is_Numeric_Value=31}', "");
    Expect(0, 12892, '\p{Is_Numeric_Value=31}', "");
    Expect(1, 12892, '\p{^Is_Numeric_Value=31}', "");
    Expect(1, 12892, '\P{Is_Numeric_Value=31}', "");
    Expect(0, 12892, '\P{^Is_Numeric_Value=31}', "");
    Error('\p{Is_Nv= /a/000_000_31}');
    Error('\P{Is_Nv= /a/000_000_31}');
    Expect(1, 12891, '\p{Is_Nv=031}', "");
    Expect(0, 12891, '\p{^Is_Nv=031}', "");
    Expect(0, 12891, '\P{Is_Nv=031}', "");
    Expect(1, 12891, '\P{^Is_Nv=031}', "");
    Expect(0, 12892, '\p{Is_Nv=031}', "");
    Expect(1, 12892, '\p{^Is_Nv=031}', "");
    Expect(1, 12892, '\P{Is_Nv=031}', "");
    Expect(0, 12892, '\P{^Is_Nv=031}', "");
    Error('\p{Numeric_Value:-:=000003_2}');
    Error('\P{Numeric_Value:-:=000003_2}');
    Expect(1, 12892, '\p{Numeric_Value=+0_0_0_0_0_0_00032}', "");
    Expect(0, 12892, '\p{^Numeric_Value=+0_0_0_0_0_0_00032}', "");
    Expect(0, 12892, '\P{Numeric_Value=+0_0_0_0_0_0_00032}', "");
    Expect(1, 12892, '\P{^Numeric_Value=+0_0_0_0_0_0_00032}', "");
    Expect(0, 12893, '\p{Numeric_Value=+0_0_0_0_0_0_00032}', "");
    Expect(1, 12893, '\p{^Numeric_Value=+0_0_0_0_0_0_00032}', "");
    Expect(1, 12893, '\P{Numeric_Value=+0_0_0_0_0_0_00032}', "");
    Expect(0, 12893, '\P{^Numeric_Value=+0_0_0_0_0_0_00032}', "");
    Error('\p{Nv=/a/-_00_00_00_032}');
    Error('\P{Nv=/a/-_00_00_00_032}');
    Expect(1, 12892, '\p{Nv=+03_2}', "");
    Expect(0, 12892, '\p{^Nv=+03_2}', "");
    Expect(0, 12892, '\P{Nv=+03_2}', "");
    Expect(1, 12892, '\P{^Nv=+03_2}', "");
    Expect(0, 12893, '\p{Nv=+03_2}', "");
    Expect(1, 12893, '\p{^Nv=+03_2}', "");
    Expect(1, 12893, '\P{Nv=+03_2}', "");
    Expect(0, 12893, '\P{^Nv=+03_2}', "");
    Error('\p{Is_Numeric_Value= 	000032:=}');
    Error('\P{Is_Numeric_Value= 	000032:=}');
    Expect(1, 12892, '\p{Is_Numeric_Value=+00000000032}', "");
    Expect(0, 12892, '\p{^Is_Numeric_Value=+00000000032}', "");
    Expect(0, 12892, '\P{Is_Numeric_Value=+00000000032}', "");
    Expect(1, 12892, '\P{^Is_Numeric_Value=+00000000032}', "");
    Expect(0, 12893, '\p{Is_Numeric_Value=+00000000032}', "");
    Expect(1, 12893, '\p{^Is_Numeric_Value=+00000000032}', "");
    Expect(1, 12893, '\P{Is_Numeric_Value=+00000000032}', "");
    Expect(0, 12893, '\P{^Is_Numeric_Value=+00000000032}', "");
    Error('\p{Is_Nv=_/a/0_0_0_0_0_0_0_0032}');
    Error('\P{Is_Nv=_/a/0_0_0_0_0_0_0_0032}');
    Expect(1, 12892, '\p{Is_Nv=+0000000003_2}', "");
    Expect(0, 12892, '\p{^Is_Nv=+0000000003_2}', "");
    Expect(0, 12892, '\P{Is_Nv=+0000000003_2}', "");
    Expect(1, 12892, '\P{^Is_Nv=+0000000003_2}', "");
    Expect(0, 12893, '\p{Is_Nv=+0000000003_2}', "");
    Expect(1, 12893, '\p{^Is_Nv=+0000000003_2}', "");
    Expect(1, 12893, '\P{Is_Nv=+0000000003_2}', "");
    Expect(0, 12893, '\P{^Is_Nv=+0000000003_2}', "");
    Error('\p{Numeric_Value=	/a/+00_00_00_33}');
    Error('\P{Numeric_Value=	/a/+00_00_00_33}');
    Expect(1, 12893, '\p{Numeric_Value=0_0_0_0_0033}', "");
    Expect(0, 12893, '\p{^Numeric_Value=0_0_0_0_0033}', "");
    Expect(0, 12893, '\P{Numeric_Value=0_0_0_0_0033}', "");
    Expect(1, 12893, '\P{^Numeric_Value=0_0_0_0_0033}', "");
    Expect(0, 12894, '\p{Numeric_Value=0_0_0_0_0033}', "");
    Expect(1, 12894, '\p{^Numeric_Value=0_0_0_0_0033}', "");
    Expect(1, 12894, '\P{Numeric_Value=0_0_0_0_0033}', "");
    Expect(0, 12894, '\P{^Numeric_Value=0_0_0_0_0033}', "");
    Error('\p{Nv=--+00000033/a/}');
    Error('\P{Nv=--+00000033/a/}');
    Expect(1, 12893, '\p{Nv=00000033}', "");
    Expect(0, 12893, '\p{^Nv=00000033}', "");
    Expect(0, 12893, '\P{Nv=00000033}', "");
    Expect(1, 12893, '\P{^Nv=00000033}', "");
    Expect(0, 12894, '\p{Nv=00000033}', "");
    Expect(1, 12894, '\p{^Nv=00000033}', "");
    Expect(1, 12894, '\P{Nv=00000033}', "");
    Expect(0, 12894, '\P{^Nv=00000033}', "");
    Error('\p{Is_Numeric_Value=:=033}');
    Error('\P{Is_Numeric_Value=:=033}');
    Expect(1, 12893, '\p{Is_Numeric_Value=3_3}', "");
    Expect(0, 12893, '\p{^Is_Numeric_Value=3_3}', "");
    Expect(0, 12893, '\P{Is_Numeric_Value=3_3}', "");
    Expect(1, 12893, '\P{^Is_Numeric_Value=3_3}', "");
    Expect(0, 12894, '\p{Is_Numeric_Value=3_3}', "");
    Expect(1, 12894, '\p{^Is_Numeric_Value=3_3}', "");
    Expect(1, 12894, '\P{Is_Numeric_Value=3_3}', "");
    Expect(0, 12894, '\P{^Is_Numeric_Value=3_3}', "");
    Error('\p{Is_Nv=/a/-+000000033}');
    Error('\P{Is_Nv=/a/-+000000033}');
    Expect(1, 12893, '\p{Is_Nv=03_3}', "");
    Expect(0, 12893, '\p{^Is_Nv=03_3}', "");
    Expect(0, 12893, '\P{Is_Nv=03_3}', "");
    Expect(1, 12893, '\P{^Is_Nv=03_3}', "");
    Expect(0, 12894, '\p{Is_Nv=03_3}', "");
    Expect(1, 12894, '\p{^Is_Nv=03_3}', "");
    Expect(1, 12894, '\P{Is_Nv=03_3}', "");
    Expect(0, 12894, '\P{^Is_Nv=03_3}', "");
    Error('\p{Numeric_Value=/a/_ 0_0_0_0_0_0_0_0034}');
    Error('\P{Numeric_Value=/a/_ 0_0_0_0_0_0_0_0034}');
    Expect(1, 12894, '\p{Numeric_Value:	000_003_4}', "");
    Expect(0, 12894, '\p{^Numeric_Value:	000_003_4}', "");
    Expect(0, 12894, '\P{Numeric_Value:	000_003_4}', "");
    Expect(1, 12894, '\P{^Numeric_Value:	000_003_4}', "");
    Expect(0, 12895, '\p{Numeric_Value:	000_003_4}', "");
    Expect(1, 12895, '\p{^Numeric_Value:	000_003_4}', "");
    Expect(1, 12895, '\P{Numeric_Value:	000_003_4}', "");
    Expect(0, 12895, '\P{^Numeric_Value:	000_003_4}', "");
    Error('\p{Nv=_ 0000_0000_34/a/}');
    Error('\P{Nv=_ 0000_0000_34/a/}');
    Expect(1, 12894, '\p{Nv=0000000003_4}', "");
    Expect(0, 12894, '\p{^Nv=0000000003_4}', "");
    Expect(0, 12894, '\P{Nv=0000000003_4}', "");
    Expect(1, 12894, '\P{^Nv=0000000003_4}', "");
    Expect(0, 12895, '\p{Nv=0000000003_4}', "");
    Expect(1, 12895, '\p{^Nv=0000000003_4}', "");
    Expect(1, 12895, '\P{Nv=0000000003_4}', "");
    Expect(0, 12895, '\P{^Nv=0000000003_4}', "");
    Error('\p{Is_Numeric_Value=:=-00000034}');
    Error('\P{Is_Numeric_Value=:=-00000034}');
    Expect(1, 12894, '\p{Is_Numeric_Value=0_0_34}', "");
    Expect(0, 12894, '\p{^Is_Numeric_Value=0_0_34}', "");
    Expect(0, 12894, '\P{Is_Numeric_Value=0_0_34}', "");
    Expect(1, 12894, '\P{^Is_Numeric_Value=0_0_34}', "");
    Expect(0, 12895, '\p{Is_Numeric_Value=0_0_34}', "");
    Expect(1, 12895, '\p{^Is_Numeric_Value=0_0_34}', "");
    Expect(1, 12895, '\P{Is_Numeric_Value=0_0_34}', "");
    Expect(0, 12895, '\P{^Is_Numeric_Value=0_0_34}', "");
    Error('\p{Is_Nv:	/a/_-+000034}');
    Error('\P{Is_Nv:	/a/_-+000034}');
    Expect(1, 12894, '\p{Is_Nv=000000034}', "");
    Expect(0, 12894, '\p{^Is_Nv=000000034}', "");
    Expect(0, 12894, '\P{Is_Nv=000000034}', "");
    Expect(1, 12894, '\P{^Is_Nv=000000034}', "");
    Expect(0, 12895, '\p{Is_Nv=000000034}', "");
    Expect(1, 12895, '\p{^Is_Nv=000000034}', "");
    Expect(1, 12895, '\P{Is_Nv=000000034}', "");
    Expect(0, 12895, '\P{^Is_Nv=000000034}', "");
    Error('\p{Numeric_Value=/a/	_035}');
    Error('\P{Numeric_Value=/a/	_035}');
    Expect(1, 12895, '\p{Numeric_Value=+0035}', "");
    Expect(0, 12895, '\p{^Numeric_Value=+0035}', "");
    Expect(0, 12895, '\P{Numeric_Value=+0035}', "");
    Expect(1, 12895, '\P{^Numeric_Value=+0035}', "");
    Expect(0, 12896, '\p{Numeric_Value=+0035}', "");
    Expect(1, 12896, '\p{^Numeric_Value=+0035}', "");
    Expect(1, 12896, '\P{Numeric_Value=+0035}', "");
    Expect(0, 12896, '\P{^Numeric_Value=+0035}', "");
    Error('\p{Nv=__0_0_0_035:=}');
    Error('\P{Nv=__0_0_0_035:=}');
    Expect(1, 12895, '\p{Nv=0000003_5}', "");
    Expect(0, 12895, '\p{^Nv=0000003_5}', "");
    Expect(0, 12895, '\P{Nv=0000003_5}', "");
    Expect(1, 12895, '\P{^Nv=0000003_5}', "");
    Expect(0, 12896, '\p{Nv=0000003_5}', "");
    Expect(1, 12896, '\p{^Nv=0000003_5}', "");
    Expect(1, 12896, '\P{Nv=0000003_5}', "");
    Expect(0, 12896, '\P{^Nv=0000003_5}', "");
    Error('\p{Is_Numeric_Value=-/a/+0_0_0_0_0_35}');
    Error('\P{Is_Numeric_Value=-/a/+0_0_0_0_0_35}');
    Expect(1, 12895, '\p{Is_Numeric_Value:00_00_00_00_035}', "");
    Expect(0, 12895, '\p{^Is_Numeric_Value:00_00_00_00_035}', "");
    Expect(0, 12895, '\P{Is_Numeric_Value:00_00_00_00_035}', "");
    Expect(1, 12895, '\P{^Is_Numeric_Value:00_00_00_00_035}', "");
    Expect(0, 12896, '\p{Is_Numeric_Value:00_00_00_00_035}', "");
    Expect(1, 12896, '\p{^Is_Numeric_Value:00_00_00_00_035}', "");
    Expect(1, 12896, '\P{Is_Numeric_Value:00_00_00_00_035}', "");
    Expect(0, 12896, '\P{^Is_Numeric_Value:00_00_00_00_035}', "");
    Error('\p{Is_Nv=/a/		+000035}');
    Error('\P{Is_Nv=/a/		+000035}');
    Expect(1, 12895, '\p{Is_Nv=0_0_0_035}', "");
    Expect(0, 12895, '\p{^Is_Nv=0_0_0_035}', "");
    Expect(0, 12895, '\P{Is_Nv=0_0_0_035}', "");
    Expect(1, 12895, '\P{^Is_Nv=0_0_0_035}', "");
    Expect(0, 12896, '\p{Is_Nv=0_0_0_035}', "");
    Expect(1, 12896, '\p{^Is_Nv=0_0_0_035}', "");
    Expect(1, 12896, '\P{Is_Nv=0_0_0_035}', "");
    Expect(0, 12896, '\P{^Is_Nv=0_0_0_035}', "");
    Error('\p{Numeric_Value= 	+0_0_36:=}');
    Error('\P{Numeric_Value= 	+0_0_36:=}');
    Expect(1, 12977, '\p{Numeric_Value=0_0_0_36}', "");
    Expect(0, 12977, '\p{^Numeric_Value=0_0_0_36}', "");
    Expect(0, 12977, '\P{Numeric_Value=0_0_0_36}', "");
    Expect(1, 12977, '\P{^Numeric_Value=0_0_0_36}', "");
    Expect(0, 12978, '\p{Numeric_Value=0_0_0_36}', "");
    Expect(1, 12978, '\p{^Numeric_Value=0_0_0_36}', "");
    Expect(1, 12978, '\P{Numeric_Value=0_0_0_36}', "");
    Expect(0, 12978, '\P{^Numeric_Value=0_0_0_36}', "");
    Error('\p{Nv=_0_0_0_0_0036/a/}');
    Error('\P{Nv=_0_0_0_0_0036/a/}');
    Expect(1, 12977, '\p{Nv=00_00_00_036}', "");
    Expect(0, 12977, '\p{^Nv=00_00_00_036}', "");
    Expect(0, 12977, '\P{Nv=00_00_00_036}', "");
    Expect(1, 12977, '\P{^Nv=00_00_00_036}', "");
    Expect(0, 12978, '\p{Nv=00_00_00_036}', "");
    Expect(1, 12978, '\p{^Nv=00_00_00_036}', "");
    Expect(1, 12978, '\P{Nv=00_00_00_036}', "");
    Expect(0, 12978, '\P{^Nv=00_00_00_036}', "");
    Error('\p{Is_Numeric_Value=/a/		36}');
    Error('\P{Is_Numeric_Value=/a/		36}');
    Expect(1, 12977, '\p{Is_Numeric_Value=00000003_6}', "");
    Expect(0, 12977, '\p{^Is_Numeric_Value=00000003_6}', "");
    Expect(0, 12977, '\P{Is_Numeric_Value=00000003_6}', "");
    Expect(1, 12977, '\P{^Is_Numeric_Value=00000003_6}', "");
    Expect(0, 12978, '\p{Is_Numeric_Value=00000003_6}', "");
    Expect(1, 12978, '\p{^Is_Numeric_Value=00000003_6}', "");
    Expect(1, 12978, '\P{Is_Numeric_Value=00000003_6}', "");
    Expect(0, 12978, '\P{^Is_Numeric_Value=00000003_6}', "");
    Error('\p{Is_Nv=_:=36}');
    Error('\P{Is_Nv=_:=36}');
    Expect(1, 12977, '\p{Is_Nv=00003_6}', "");
    Expect(0, 12977, '\p{^Is_Nv=00003_6}', "");
    Expect(0, 12977, '\P{Is_Nv=00003_6}', "");
    Expect(1, 12977, '\P{^Is_Nv=00003_6}', "");
    Expect(0, 12978, '\p{Is_Nv=00003_6}', "");
    Expect(1, 12978, '\p{^Is_Nv=00003_6}', "");
    Expect(1, 12978, '\P{Is_Nv=00003_6}', "");
    Expect(0, 12978, '\P{^Is_Nv=00003_6}', "");
    Error('\p{Numeric_Value=		00000037:=}');
    Error('\P{Numeric_Value=		00000037:=}');
    Expect(1, 12978, '\p{Numeric_Value=00_03_7}', "");
    Expect(0, 12978, '\p{^Numeric_Value=00_03_7}', "");
    Expect(0, 12978, '\P{Numeric_Value=00_03_7}', "");
    Expect(1, 12978, '\P{^Numeric_Value=00_03_7}', "");
    Expect(0, 12979, '\p{Numeric_Value=00_03_7}', "");
    Expect(1, 12979, '\p{^Numeric_Value=00_03_7}', "");
    Expect(1, 12979, '\P{Numeric_Value=00_03_7}', "");
    Expect(0, 12979, '\P{^Numeric_Value=00_03_7}', "");
    Error('\p{Nv=:=-000000037}');
    Error('\P{Nv=:=-000000037}');
    Expect(1, 12978, '\p{Nv=00_03_7}', "");
    Expect(0, 12978, '\p{^Nv=00_03_7}', "");
    Expect(0, 12978, '\P{Nv=00_03_7}', "");
    Expect(1, 12978, '\P{^Nv=00_03_7}', "");
    Expect(0, 12979, '\p{Nv=00_03_7}', "");
    Expect(1, 12979, '\p{^Nv=00_03_7}', "");
    Expect(1, 12979, '\P{Nv=00_03_7}', "");
    Expect(0, 12979, '\P{^Nv=00_03_7}', "");
    Error('\p{Is_Numeric_Value= :=3_7}');
    Error('\P{Is_Numeric_Value= :=3_7}');
    Expect(1, 12978, '\p{Is_Numeric_Value=000037}', "");
    Expect(0, 12978, '\p{^Is_Numeric_Value=000037}', "");
    Expect(0, 12978, '\P{Is_Numeric_Value=000037}', "");
    Expect(1, 12978, '\P{^Is_Numeric_Value=000037}', "");
    Expect(0, 12979, '\p{Is_Numeric_Value=000037}', "");
    Expect(1, 12979, '\p{^Is_Numeric_Value=000037}', "");
    Expect(1, 12979, '\P{Is_Numeric_Value=000037}', "");
    Expect(0, 12979, '\P{^Is_Numeric_Value=000037}', "");
    Error('\p{Is_Nv=__037:=}');
    Error('\P{Is_Nv=__037:=}');
    Expect(1, 12978, '\p{Is_Nv=0000037}', "");
    Expect(0, 12978, '\p{^Is_Nv=0000037}', "");
    Expect(0, 12978, '\P{Is_Nv=0000037}', "");
    Expect(1, 12978, '\P{^Is_Nv=0000037}', "");
    Expect(0, 12979, '\p{Is_Nv=0000037}', "");
    Expect(1, 12979, '\p{^Is_Nv=0000037}', "");
    Expect(1, 12979, '\P{Is_Nv=0000037}', "");
    Expect(0, 12979, '\P{^Is_Nv=0000037}', "");
    Error('\p{Numeric_Value=-00000000038:=}');
    Error('\P{Numeric_Value=-00000000038:=}');
    Expect(1, 12979, '\p{Numeric_Value=0038}', "");
    Expect(0, 12979, '\p{^Numeric_Value=0038}', "");
    Expect(0, 12979, '\P{Numeric_Value=0038}', "");
    Expect(1, 12979, '\P{^Numeric_Value=0038}', "");
    Expect(0, 12980, '\p{Numeric_Value=0038}', "");
    Expect(1, 12980, '\p{^Numeric_Value=0038}', "");
    Expect(1, 12980, '\P{Numeric_Value=0038}', "");
    Expect(0, 12980, '\P{^Numeric_Value=0038}', "");
    Error('\p{Nv=:=-00038}');
    Error('\P{Nv=:=-00038}');
    Expect(1, 12979, '\p{Nv: +038}', "");
    Expect(0, 12979, '\p{^Nv: +038}', "");
    Expect(0, 12979, '\P{Nv: +038}', "");
    Expect(1, 12979, '\P{^Nv: +038}', "");
    Expect(0, 12980, '\p{Nv: +038}', "");
    Expect(1, 12980, '\p{^Nv: +038}', "");
    Expect(1, 12980, '\P{Nv: +038}', "");
    Expect(0, 12980, '\P{^Nv: +038}', "");
    Error('\p{Is_Numeric_Value= 0_0_0_38/a/}');
    Error('\P{Is_Numeric_Value= 0_0_0_38/a/}');
    Expect(1, 12979, '\p{Is_Numeric_Value: 000038}', "");
    Expect(0, 12979, '\p{^Is_Numeric_Value: 000038}', "");
    Expect(0, 12979, '\P{Is_Numeric_Value: 000038}', "");
    Expect(1, 12979, '\P{^Is_Numeric_Value: 000038}', "");
    Expect(0, 12980, '\p{Is_Numeric_Value: 000038}', "");
    Expect(1, 12980, '\p{^Is_Numeric_Value: 000038}', "");
    Expect(1, 12980, '\P{Is_Numeric_Value: 000038}', "");
    Expect(0, 12980, '\P{^Is_Numeric_Value: 000038}', "");
    Error('\p{Is_Nv=:=+00038}');
    Error('\P{Is_Nv=:=+00038}');
    Expect(1, 12979, '\p{Is_Nv:038}', "");
    Expect(0, 12979, '\p{^Is_Nv:038}', "");
    Expect(0, 12979, '\P{Is_Nv:038}', "");
    Expect(1, 12979, '\P{^Is_Nv:038}', "");
    Expect(0, 12980, '\p{Is_Nv:038}', "");
    Expect(1, 12980, '\p{^Is_Nv:038}', "");
    Expect(1, 12980, '\P{Is_Nv:038}', "");
    Expect(0, 12980, '\P{^Is_Nv:038}', "");
    Error('\p{Numeric_Value: _:=003_9}');
    Error('\P{Numeric_Value: _:=003_9}');
    Expect(1, 12980, '\p{Numeric_Value=00_00_39}', "");
    Expect(0, 12980, '\p{^Numeric_Value=00_00_39}', "");
    Expect(0, 12980, '\P{Numeric_Value=00_00_39}', "");
    Expect(1, 12980, '\P{^Numeric_Value=00_00_39}', "");
    Expect(0, 12981, '\p{Numeric_Value=00_00_39}', "");
    Expect(1, 12981, '\p{^Numeric_Value=00_00_39}', "");
    Expect(1, 12981, '\P{Numeric_Value=00_00_39}', "");
    Expect(0, 12981, '\P{^Numeric_Value=00_00_39}', "");
    Error('\p{Nv=/a/- 00000039}');
    Error('\P{Nv=/a/- 00000039}');
    Expect(1, 12980, '\p{Nv=39}', "");
    Expect(0, 12980, '\p{^Nv=39}', "");
    Expect(0, 12980, '\P{Nv=39}', "");
    Expect(1, 12980, '\P{^Nv=39}', "");
    Expect(0, 12981, '\p{Nv=39}', "");
    Expect(1, 12981, '\p{^Nv=39}', "");
    Expect(1, 12981, '\P{Nv=39}', "");
    Expect(0, 12981, '\P{^Nv=39}', "");
    Error('\p{Is_Numeric_Value=_-+00_00_00_39:=}');
    Error('\P{Is_Numeric_Value=_-+00_00_00_39:=}');
    Expect(1, 12980, '\p{Is_Numeric_Value=39}', "");
    Expect(0, 12980, '\p{^Is_Numeric_Value=39}', "");
    Expect(0, 12980, '\P{Is_Numeric_Value=39}', "");
    Expect(1, 12980, '\P{^Is_Numeric_Value=39}', "");
    Expect(0, 12981, '\p{Is_Numeric_Value=39}', "");
    Expect(1, 12981, '\p{^Is_Numeric_Value=39}', "");
    Expect(1, 12981, '\P{Is_Numeric_Value=39}', "");
    Expect(0, 12981, '\P{^Is_Numeric_Value=39}', "");
    Error('\p{Is_Nv=_/a/3_9}');
    Error('\P{Is_Nv=_/a/3_9}');
    Expect(1, 12980, '\p{Is_Nv:+00_00_03_9}', "");
    Expect(0, 12980, '\p{^Is_Nv:+00_00_03_9}', "");
    Expect(0, 12980, '\P{Is_Nv:+00_00_03_9}', "");
    Expect(1, 12980, '\P{^Is_Nv:+00_00_03_9}', "");
    Expect(0, 12981, '\p{Is_Nv:+00_00_03_9}', "");
    Expect(1, 12981, '\p{^Is_Nv:+00_00_03_9}', "");
    Expect(1, 12981, '\P{Is_Nv:+00_00_03_9}', "");
    Expect(0, 12981, '\P{^Is_Nv:+00_00_03_9}', "");
    Error('\p{Numeric_Value=:=	004}');
    Error('\P{Numeric_Value=:=	004}');
    Expect(1, 156269, '\p{Numeric_Value=00000004}', "");
    Expect(0, 156269, '\p{^Numeric_Value=00000004}', "");
    Expect(0, 156269, '\P{Numeric_Value=00000004}', "");
    Expect(1, 156269, '\P{^Numeric_Value=00000004}', "");
    Expect(0, 156270, '\p{Numeric_Value=00000004}', "");
    Expect(1, 156270, '\p{^Numeric_Value=00000004}', "");
    Expect(1, 156270, '\P{Numeric_Value=00000004}', "");
    Expect(0, 156270, '\P{^Numeric_Value=00000004}', "");
    Error('\p{Nv: /a/	+00000004}');
    Error('\P{Nv: /a/	+00000004}');
    Expect(1, 156269, '\p{Nv=+0000004}', "");
    Expect(0, 156269, '\p{^Nv=+0000004}', "");
    Expect(0, 156269, '\P{Nv=+0000004}', "");
    Expect(1, 156269, '\P{^Nv=+0000004}', "");
    Expect(0, 156270, '\p{Nv=+0000004}', "");
    Expect(1, 156270, '\p{^Nv=+0000004}', "");
    Expect(1, 156270, '\P{Nv=+0000004}', "");
    Expect(0, 156270, '\P{^Nv=+0000004}', "");
    Error('\p{Is_Numeric_Value=:=		04}');
    Error('\P{Is_Numeric_Value=:=		04}');
    Expect(1, 156269, '\p{Is_Numeric_Value=00004}', "");
    Expect(0, 156269, '\p{^Is_Numeric_Value=00004}', "");
    Expect(0, 156269, '\P{Is_Numeric_Value=00004}', "");
    Expect(1, 156269, '\P{^Is_Numeric_Value=00004}', "");
    Expect(0, 156270, '\p{Is_Numeric_Value=00004}', "");
    Expect(1, 156270, '\p{^Is_Numeric_Value=00004}', "");
    Expect(1, 156270, '\P{Is_Numeric_Value=00004}', "");
    Expect(0, 156270, '\P{^Is_Numeric_Value=00004}', "");
    Error('\p{Is_Nv=		+00000004/a/}');
    Error('\P{Is_Nv=		+00000004/a/}');
    Expect(1, 156269, '\p{Is_Nv=000_000_000_4}', "");
    Expect(0, 156269, '\p{^Is_Nv=000_000_000_4}', "");
    Expect(0, 156269, '\P{Is_Nv=000_000_000_4}', "");
    Expect(1, 156269, '\P{^Is_Nv=000_000_000_4}', "");
    Expect(0, 156270, '\p{Is_Nv=000_000_000_4}', "");
    Expect(1, 156270, '\p{^Is_Nv=000_000_000_4}', "");
    Expect(1, 156270, '\P{Is_Nv=000_000_000_4}', "");
    Expect(0, 156270, '\P{^Is_Nv=000_000_000_4}', "");
    Error('\p{Numeric_Value=/a/_+000000004/00005}');
    Error('\P{Numeric_Value=/a/_+000000004/00005}');
    Expect(1, 8536, '\p{Numeric_Value=00000004/000000005}', "");
    Expect(0, 8536, '\p{^Numeric_Value=00000004/000000005}', "");
    Expect(0, 8536, '\P{Numeric_Value=00000004/000000005}', "");
    Expect(1, 8536, '\P{^Numeric_Value=00000004/000000005}', "");
    Expect(0, 8537, '\p{Numeric_Value=00000004/000000005}', "");
    Expect(1, 8537, '\p{^Numeric_Value=00000004/000000005}', "");
    Expect(1, 8537, '\P{Numeric_Value=00000004/000000005}', "");
    Expect(0, 8537, '\P{^Numeric_Value=00000004/000000005}', "");
    Expect(1, 8536, '\p{Numeric_Value=0.800}', "");
    Expect(0, 8536, '\p{^Numeric_Value=0.800}', "");
    Expect(0, 8536, '\P{Numeric_Value=0.800}', "");
    Expect(1, 8536, '\P{^Numeric_Value=0.800}', "");
    Expect(0, 8537, '\p{Numeric_Value=0.800}', "");
    Expect(1, 8537, '\p{^Numeric_Value=0.800}', "");
    Expect(1, 8537, '\P{Numeric_Value=0.800}', "");
    Expect(0, 8537, '\P{^Numeric_Value=0.800}', "");
    Error('\p{Nv:   --0000000004/000000005/a/}');
    Error('\P{Nv:   --0000000004/000000005/a/}');
    Expect(1, 8536, '\p{Nv=+000000004/00005}', "");
    Expect(0, 8536, '\p{^Nv=+000000004/00005}', "");
    Expect(0, 8536, '\P{Nv=+000000004/00005}', "");
    Expect(1, 8536, '\P{^Nv=+000000004/00005}', "");
    Expect(0, 8537, '\p{Nv=+000000004/00005}', "");
    Expect(1, 8537, '\p{^Nv=+000000004/00005}', "");
    Expect(1, 8537, '\P{Nv=+000000004/00005}', "");
    Expect(0, 8537, '\P{^Nv=+000000004/00005}', "");
    Expect(1, 8536, '\p{Nv=0.800}', "");
    Expect(0, 8536, '\p{^Nv=0.800}', "");
    Expect(0, 8536, '\P{Nv=0.800}', "");
    Expect(1, 8536, '\P{^Nv=0.800}', "");
    Expect(0, 8537, '\p{Nv=0.800}', "");
    Expect(1, 8537, '\p{^Nv=0.800}', "");
    Expect(1, 8537, '\P{Nv=0.800}', "");
    Expect(0, 8537, '\P{^Nv=0.800}', "");
    Error('\p{Is_Numeric_Value=-_00000004/0005:=}');
    Error('\P{Is_Numeric_Value=-_00000004/0005:=}');
    Expect(1, 8536, '\p{Is_Numeric_Value=0000000004/0000005}', "");
    Expect(0, 8536, '\p{^Is_Numeric_Value=0000000004/0000005}', "");
    Expect(0, 8536, '\P{Is_Numeric_Value=0000000004/0000005}', "");
    Expect(1, 8536, '\P{^Is_Numeric_Value=0000000004/0000005}', "");
    Expect(0, 8537, '\p{Is_Numeric_Value=0000000004/0000005}', "");
    Expect(1, 8537, '\p{^Is_Numeric_Value=0000000004/0000005}', "");
    Expect(1, 8537, '\P{Is_Numeric_Value=0000000004/0000005}', "");
    Expect(0, 8537, '\P{^Is_Numeric_Value=0000000004/0000005}', "");
    Expect(1, 8536, '\p{Is_Numeric_Value=0.800}', "");
    Expect(0, 8536, '\p{^Is_Numeric_Value=0.800}', "");
    Expect(0, 8536, '\P{Is_Numeric_Value=0.800}', "");
    Expect(1, 8536, '\P{^Is_Numeric_Value=0.800}', "");
    Expect(0, 8537, '\p{Is_Numeric_Value=0.800}', "");
    Expect(1, 8537, '\p{^Is_Numeric_Value=0.800}', "");
    Expect(1, 8537, '\P{Is_Numeric_Value=0.800}', "");
    Expect(0, 8537, '\P{^Is_Numeric_Value=0.800}', "");
    Error('\p{Is_Nv=:= 	+04/0000000005}');
    Error('\P{Is_Nv=:= 	+04/0000000005}');
    Expect(1, 8536, '\p{Is_Nv:   004/00005}', "");
    Expect(0, 8536, '\p{^Is_Nv:   004/00005}', "");
    Expect(0, 8536, '\P{Is_Nv:   004/00005}', "");
    Expect(1, 8536, '\P{^Is_Nv:   004/00005}', "");
    Expect(0, 8537, '\p{Is_Nv:   004/00005}', "");
    Expect(1, 8537, '\p{^Is_Nv:   004/00005}', "");
    Expect(1, 8537, '\P{Is_Nv:   004/00005}', "");
    Expect(0, 8537, '\P{^Is_Nv:   004/00005}', "");
    Expect(1, 8536, '\p{Is_Nv=0.800}', "");
    Expect(0, 8536, '\p{^Is_Nv=0.800}', "");
    Expect(0, 8536, '\P{Is_Nv=0.800}', "");
    Expect(1, 8536, '\P{^Is_Nv=0.800}', "");
    Expect(0, 8537, '\p{Is_Nv=0.800}', "");
    Expect(1, 8537, '\p{^Is_Nv=0.800}', "");
    Expect(1, 8537, '\P{Is_Nv=0.800}', "");
    Expect(0, 8537, '\P{^Is_Nv=0.800}', "");
    Error('\p{Numeric_Value=_+0_0_0_40/a/}');
    Error('\P{Numeric_Value=_+0_0_0_40/a/}');
    Expect(1, 133532, '\p{Numeric_Value=000040}', "");
    Expect(0, 133532, '\p{^Numeric_Value=000040}', "");
    Expect(0, 133532, '\P{Numeric_Value=000040}', "");
    Expect(1, 133532, '\P{^Numeric_Value=000040}', "");
    Expect(0, 133533, '\p{Numeric_Value=000040}', "");
    Expect(1, 133533, '\p{^Numeric_Value=000040}', "");
    Expect(1, 133533, '\P{Numeric_Value=000040}', "");
    Expect(0, 133533, '\P{^Numeric_Value=000040}', "");
    Error('\p{Nv: :=	_000040}');
    Error('\P{Nv: :=	_000040}');
    Expect(1, 133532, '\p{Nv=0_0_0_0_0_40}', "");
    Expect(0, 133532, '\p{^Nv=0_0_0_0_0_40}', "");
    Expect(0, 133532, '\P{Nv=0_0_0_0_0_40}', "");
    Expect(1, 133532, '\P{^Nv=0_0_0_0_0_40}', "");
    Expect(0, 133533, '\p{Nv=0_0_0_0_0_40}', "");
    Expect(1, 133533, '\p{^Nv=0_0_0_0_0_40}', "");
    Expect(1, 133533, '\P{Nv=0_0_0_0_0_40}', "");
    Expect(0, 133533, '\P{^Nv=0_0_0_0_0_40}', "");
    Error('\p{Is_Numeric_Value=	:=0000040}');
    Error('\P{Is_Numeric_Value=	:=0000040}');
    Expect(1, 133532, '\p{Is_Numeric_Value=040}', "");
    Expect(0, 133532, '\p{^Is_Numeric_Value=040}', "");
    Expect(0, 133532, '\P{Is_Numeric_Value=040}', "");
    Expect(1, 133532, '\P{^Is_Numeric_Value=040}', "");
    Expect(0, 133533, '\p{Is_Numeric_Value=040}', "");
    Expect(1, 133533, '\p{^Is_Numeric_Value=040}', "");
    Expect(1, 133533, '\P{Is_Numeric_Value=040}', "");
    Expect(0, 133533, '\P{^Is_Numeric_Value=040}', "");
    Error('\p{Is_Nv=-00040/a/}');
    Error('\P{Is_Nv=-00040/a/}');
    Expect(1, 133532, '\p{Is_Nv=0_0_0_0_040}', "");
    Expect(0, 133532, '\p{^Is_Nv=0_0_0_0_040}', "");
    Expect(0, 133532, '\P{Is_Nv=0_0_0_0_040}', "");
    Expect(1, 133532, '\P{^Is_Nv=0_0_0_0_040}', "");
    Expect(0, 133533, '\p{Is_Nv=0_0_0_0_040}', "");
    Expect(1, 133533, '\p{^Is_Nv=0_0_0_0_040}', "");
    Expect(1, 133533, '\P{Is_Nv=0_0_0_0_040}', "");
    Expect(0, 133533, '\P{^Is_Nv=0_0_0_0_040}', "");
    Error('\p{Numeric_Value=	400/a/}');
    Error('\P{Numeric_Value=	400/a/}');
    Expect(1, 69237, '\p{Numeric_Value=0400}', "");
    Expect(0, 69237, '\p{^Numeric_Value=0400}', "");
    Expect(0, 69237, '\P{Numeric_Value=0400}', "");
    Expect(1, 69237, '\P{^Numeric_Value=0400}', "");
    Expect(0, 69238, '\p{Numeric_Value=0400}', "");
    Expect(1, 69238, '\p{^Numeric_Value=0400}', "");
    Expect(1, 69238, '\P{Numeric_Value=0400}', "");
    Expect(0, 69238, '\P{^Numeric_Value=0400}', "");
    Error('\p{Nv=:=	_0_0_0_0_0_0_0_0400}');
    Error('\P{Nv=:=	_0_0_0_0_0_0_0_0400}');
    Expect(1, 69237, '\p{Nv=+00_04_00}', "");
    Expect(0, 69237, '\p{^Nv=+00_04_00}', "");
    Expect(0, 69237, '\P{Nv=+00_04_00}', "");
    Expect(1, 69237, '\P{^Nv=+00_04_00}', "");
    Expect(0, 69238, '\p{Nv=+00_04_00}', "");
    Expect(1, 69238, '\p{^Nv=+00_04_00}', "");
    Expect(1, 69238, '\P{Nv=+00_04_00}', "");
    Expect(0, 69238, '\P{^Nv=+00_04_00}', "");
    Error('\p{Is_Numeric_Value=_:=+0_0_4_00}');
    Error('\P{Is_Numeric_Value=_:=+0_0_4_00}');
    Expect(1, 69237, '\p{Is_Numeric_Value=00_00_00_00_04_00}', "");
    Expect(0, 69237, '\p{^Is_Numeric_Value=00_00_00_00_04_00}', "");
    Expect(0, 69237, '\P{Is_Numeric_Value=00_00_00_00_04_00}', "");
    Expect(1, 69237, '\P{^Is_Numeric_Value=00_00_00_00_04_00}', "");
    Expect(0, 69238, '\p{Is_Numeric_Value=00_00_00_00_04_00}', "");
    Expect(1, 69238, '\p{^Is_Numeric_Value=00_00_00_00_04_00}', "");
    Expect(1, 69238, '\P{Is_Numeric_Value=00_00_00_00_04_00}', "");
    Expect(0, 69238, '\P{^Is_Numeric_Value=00_00_00_00_04_00}', "");
    Error('\p{Is_Nv::=		0000000400}');
    Error('\P{Is_Nv::=		0000000400}');
    Expect(1, 69237, '\p{Is_Nv=000_000_040_0}', "");
    Expect(0, 69237, '\p{^Is_Nv=000_000_040_0}', "");
    Expect(0, 69237, '\P{Is_Nv=000_000_040_0}', "");
    Expect(1, 69237, '\P{^Is_Nv=000_000_040_0}', "");
    Expect(0, 69238, '\p{Is_Nv=000_000_040_0}', "");
    Expect(1, 69238, '\p{^Is_Nv=000_000_040_0}', "");
    Expect(1, 69238, '\P{Is_Nv=000_000_040_0}', "");
    Expect(0, 69238, '\P{^Is_Nv=000_000_040_0}', "");
    Error('\p{Numeric_Value= 	004000/a/}');
    Error('\P{Numeric_Value= 	004000/a/}');
    Expect(1, 68062, '\p{Numeric_Value=00004000}', "");
    Expect(0, 68062, '\p{^Numeric_Value=00004000}', "");
    Expect(0, 68062, '\P{Numeric_Value=00004000}', "");
    Expect(1, 68062, '\P{^Numeric_Value=00004000}', "");
    Expect(0, 68063, '\p{Numeric_Value=00004000}', "");
    Expect(1, 68063, '\p{^Numeric_Value=00004000}', "");
    Expect(1, 68063, '\P{Numeric_Value=00004000}', "");
    Expect(0, 68063, '\P{^Numeric_Value=00004000}', "");
    Error('\p{Nv=:=	-000_000_000_400_0}');
    Error('\P{Nv=:=	-000_000_000_400_0}');
    Expect(1, 68062, '\p{Nv=0_0_0_0_0_0_0_4_000}', "");
    Expect(0, 68062, '\p{^Nv=0_0_0_0_0_0_0_4_000}', "");
    Expect(0, 68062, '\P{Nv=0_0_0_0_0_0_0_4_000}', "");
    Expect(1, 68062, '\P{^Nv=0_0_0_0_0_0_0_4_000}', "");
    Expect(0, 68063, '\p{Nv=0_0_0_0_0_0_0_4_000}', "");
    Expect(1, 68063, '\p{^Nv=0_0_0_0_0_0_0_4_000}', "");
    Expect(1, 68063, '\P{Nv=0_0_0_0_0_0_0_4_000}', "");
    Expect(0, 68063, '\P{^Nv=0_0_0_0_0_0_0_4_000}', "");
    Error('\p{Is_Numeric_Value=	-000004000/a/}');
    Error('\P{Is_Numeric_Value=	-000004000/a/}');
    Expect(1, 68062, '\p{Is_Numeric_Value=+0_0_0_0_0_4000}', "");
    Expect(0, 68062, '\p{^Is_Numeric_Value=+0_0_0_0_0_4000}', "");
    Expect(0, 68062, '\P{Is_Numeric_Value=+0_0_0_0_0_4000}', "");
    Expect(1, 68062, '\P{^Is_Numeric_Value=+0_0_0_0_0_4000}', "");
    Expect(0, 68063, '\p{Is_Numeric_Value=+0_0_0_0_0_4000}', "");
    Expect(1, 68063, '\p{^Is_Numeric_Value=+0_0_0_0_0_4000}', "");
    Expect(1, 68063, '\P{Is_Numeric_Value=+0_0_0_0_0_4000}', "");
    Expect(0, 68063, '\P{^Is_Numeric_Value=+0_0_0_0_0_4000}', "");
    Error('\p{Is_Nv=:=000000004000}');
    Error('\P{Is_Nv=:=000000004000}');
    Expect(1, 68062, '\p{Is_Nv=+000004000}', "");
    Expect(0, 68062, '\p{^Is_Nv=+000004000}', "");
    Expect(0, 68062, '\P{Is_Nv=+000004000}', "");
    Expect(1, 68062, '\P{^Is_Nv=+000004000}', "");
    Expect(0, 68063, '\p{Is_Nv=+000004000}', "");
    Expect(1, 68063, '\p{^Is_Nv=+000004000}', "");
    Expect(1, 68063, '\P{Is_Nv=+000004000}', "");
    Expect(0, 68063, '\P{^Is_Nv=+000004000}', "");
    Error('\p{Numeric_Value= 0000_4000_0/a/}');
    Error('\P{Numeric_Value= 0000_4000_0/a/}');
    Expect(1, 68071, '\p{Numeric_Value: 000040000}', "");
    Expect(0, 68071, '\p{^Numeric_Value: 000040000}', "");
    Expect(0, 68071, '\P{Numeric_Value: 000040000}', "");
    Expect(1, 68071, '\P{^Numeric_Value: 000040000}', "");
    Expect(0, 68072, '\p{Numeric_Value: 000040000}', "");
    Expect(1, 68072, '\p{^Numeric_Value: 000040000}', "");
    Expect(1, 68072, '\P{Numeric_Value: 000040000}', "");
    Expect(0, 68072, '\P{^Numeric_Value: 000040000}', "");
    Error('\p{Nv: /a/ +4_0_0_00}');
    Error('\P{Nv: /a/ +4_0_0_00}');
    Expect(1, 68071, '\p{Nv=000000040000}', "");
    Expect(0, 68071, '\p{^Nv=000000040000}', "");
    Expect(0, 68071, '\P{Nv=000000040000}', "");
    Expect(1, 68071, '\P{^Nv=000000040000}', "");
    Expect(0, 68072, '\p{Nv=000000040000}', "");
    Expect(1, 68072, '\p{^Nv=000000040000}', "");
    Expect(1, 68072, '\P{Nv=000000040000}', "");
    Expect(0, 68072, '\P{^Nv=000000040000}', "");
    Error('\p{Is_Numeric_Value=_-0_0_0_0_0_0_4_0000:=}');
    Error('\P{Is_Numeric_Value=_-0_0_0_0_0_0_4_0000:=}');
    Expect(1, 68071, '\p{Is_Numeric_Value=+0_0_0_0_4_0_000}', "");
    Expect(0, 68071, '\p{^Is_Numeric_Value=+0_0_0_0_4_0_000}', "");
    Expect(0, 68071, '\P{Is_Numeric_Value=+0_0_0_0_4_0_000}', "");
    Expect(1, 68071, '\P{^Is_Numeric_Value=+0_0_0_0_4_0_000}', "");
    Expect(0, 68072, '\p{Is_Numeric_Value=+0_0_0_0_4_0_000}', "");
    Expect(1, 68072, '\p{^Is_Numeric_Value=+0_0_0_0_4_0_000}', "");
    Expect(1, 68072, '\P{Is_Numeric_Value=+0_0_0_0_4_0_000}', "");
    Expect(0, 68072, '\P{^Is_Numeric_Value=+0_0_0_0_4_0_000}', "");
    Error('\p{Is_Nv=	:=+000000040000}');
    Error('\P{Is_Nv=	:=+000000040000}');
    Expect(1, 68071, '\p{Is_Nv=0000040000}', "");
    Expect(0, 68071, '\p{^Is_Nv=0000040000}', "");
    Expect(0, 68071, '\P{Is_Nv=0000040000}', "");
    Expect(1, 68071, '\P{^Is_Nv=0000040000}', "");
    Expect(0, 68072, '\p{Is_Nv=0000040000}', "");
    Expect(1, 68072, '\p{^Is_Nv=0000040000}', "");
    Expect(1, 68072, '\P{Is_Nv=0000040000}', "");
    Expect(0, 68072, '\P{^Is_Nv=0000040000}', "");
    Error('\p{Numeric_Value=/a/	+000400000}');
    Error('\P{Numeric_Value=/a/	+000400000}');
    Expect(1, 68080, '\p{Numeric_Value=400000}', "");
    Expect(0, 68080, '\p{^Numeric_Value=400000}', "");
    Expect(0, 68080, '\P{Numeric_Value=400000}', "");
    Expect(1, 68080, '\P{^Numeric_Value=400000}', "");
    Expect(0, 68081, '\p{Numeric_Value=400000}', "");
    Expect(1, 68081, '\p{^Numeric_Value=400000}', "");
    Expect(1, 68081, '\P{Numeric_Value=400000}', "");
    Expect(0, 68081, '\P{^Numeric_Value=400000}', "");
    Error('\p{Nv=:=	+00_00_00_00_04_00_00_0}');
    Error('\P{Nv=:=	+00_00_00_00_04_00_00_0}');
    Expect(1, 68080, '\p{Nv=0_4_0_0_000}', "");
    Expect(0, 68080, '\p{^Nv=0_4_0_0_000}', "");
    Expect(0, 68080, '\P{Nv=0_4_0_0_000}', "");
    Expect(1, 68080, '\P{^Nv=0_4_0_0_000}', "");
    Expect(0, 68081, '\p{Nv=0_4_0_0_000}', "");
    Expect(1, 68081, '\p{^Nv=0_4_0_0_000}', "");
    Expect(1, 68081, '\P{Nv=0_4_0_0_000}', "");
    Expect(0, 68081, '\P{^Nv=0_4_0_0_000}', "");
    Error('\p{Is_Numeric_Value=_-0000000400000/a/}');
    Error('\P{Is_Numeric_Value=_-0000000400000/a/}');
    Expect(1, 68080, '\p{Is_Numeric_Value=+0000000400000}', "");
    Expect(0, 68080, '\p{^Is_Numeric_Value=+0000000400000}', "");
    Expect(0, 68080, '\P{Is_Numeric_Value=+0000000400000}', "");
    Expect(1, 68080, '\P{^Is_Numeric_Value=+0000000400000}', "");
    Expect(0, 68081, '\p{Is_Numeric_Value=+0000000400000}', "");
    Expect(1, 68081, '\p{^Is_Numeric_Value=+0000000400000}', "");
    Expect(1, 68081, '\P{Is_Numeric_Value=+0000000400000}', "");
    Expect(0, 68081, '\P{^Is_Numeric_Value=+0000000400000}', "");
    Error('\p{Is_Nv= -00_00_40_00_00:=}');
    Error('\P{Is_Nv= -00_00_40_00_00:=}');
    Expect(1, 68080, '\p{Is_Nv=+0_0_4_0_0_0_00}', "");
    Expect(0, 68080, '\p{^Is_Nv=+0_0_4_0_0_0_00}', "");
    Expect(0, 68080, '\P{Is_Nv=+0_0_4_0_0_0_00}', "");
    Expect(1, 68080, '\P{^Is_Nv=+0_0_4_0_0_0_00}', "");
    Expect(0, 68081, '\p{Is_Nv=+0_0_4_0_0_0_00}', "");
    Expect(1, 68081, '\p{^Is_Nv=+0_0_4_0_0_0_00}', "");
    Expect(1, 68081, '\P{Is_Nv=+0_0_4_0_0_0_00}', "");
    Expect(0, 68081, '\P{^Is_Nv=+0_0_4_0_0_0_00}', "");
    Error('\p{Numeric_Value=--0004_1/a/}');
    Error('\P{Numeric_Value=--0004_1/a/}');
    Expect(1, 12982, '\p{Numeric_Value=0000041}', "");
    Expect(0, 12982, '\p{^Numeric_Value=0000041}', "");
    Expect(0, 12982, '\P{Numeric_Value=0000041}', "");
    Expect(1, 12982, '\P{^Numeric_Value=0000041}', "");
    Expect(0, 12983, '\p{Numeric_Value=0000041}', "");
    Expect(1, 12983, '\p{^Numeric_Value=0000041}', "");
    Expect(1, 12983, '\P{Numeric_Value=0000041}', "");
    Expect(0, 12983, '\P{^Numeric_Value=0000041}', "");
    Error('\p{Nv= 	+04_1/a/}');
    Error('\P{Nv= 	+04_1/a/}');
    Expect(1, 12982, '\p{Nv=+0_0_0_041}', "");
    Expect(0, 12982, '\p{^Nv=+0_0_0_041}', "");
    Expect(0, 12982, '\P{Nv=+0_0_0_041}', "");
    Expect(1, 12982, '\P{^Nv=+0_0_0_041}', "");
    Expect(0, 12983, '\p{Nv=+0_0_0_041}', "");
    Expect(1, 12983, '\p{^Nv=+0_0_0_041}', "");
    Expect(1, 12983, '\P{Nv=+0_0_0_041}', "");
    Expect(0, 12983, '\P{^Nv=+0_0_0_041}', "");
    Error('\p{Is_Numeric_Value=:=-004_1}');
    Error('\P{Is_Numeric_Value=:=-004_1}');
    Expect(1, 12982, '\p{Is_Numeric_Value: +00_00_04_1}', "");
    Expect(0, 12982, '\p{^Is_Numeric_Value: +00_00_04_1}', "");
    Expect(0, 12982, '\P{Is_Numeric_Value: +00_00_04_1}', "");
    Expect(1, 12982, '\P{^Is_Numeric_Value: +00_00_04_1}', "");
    Expect(0, 12983, '\p{Is_Numeric_Value: +00_00_04_1}', "");
    Expect(1, 12983, '\p{^Is_Numeric_Value: +00_00_04_1}', "");
    Expect(1, 12983, '\P{Is_Numeric_Value: +00_00_04_1}', "");
    Expect(0, 12983, '\P{^Is_Numeric_Value: +00_00_04_1}', "");
    Error('\p{Is_Nv=:=--00000041}');
    Error('\P{Is_Nv=:=--00000041}');
    Expect(1, 12982, '\p{Is_Nv=+0_0_0_0_0_0_00041}', "");
    Expect(0, 12982, '\p{^Is_Nv=+0_0_0_0_0_0_00041}', "");
    Expect(0, 12982, '\P{Is_Nv=+0_0_0_0_0_0_00041}', "");
    Expect(1, 12982, '\P{^Is_Nv=+0_0_0_0_0_0_00041}', "");
    Expect(0, 12983, '\p{Is_Nv=+0_0_0_0_0_0_00041}', "");
    Expect(1, 12983, '\p{^Is_Nv=+0_0_0_0_0_0_00041}', "");
    Expect(1, 12983, '\P{Is_Nv=+0_0_0_0_0_0_00041}', "");
    Expect(0, 12983, '\P{^Is_Nv=+0_0_0_0_0_0_00041}', "");
    Error('\p{Numeric_Value=:=--+000_004_2}');
    Error('\P{Numeric_Value=:=--+000_004_2}');
    Expect(1, 12983, '\p{Numeric_Value=00_00_00_042}', "");
    Expect(0, 12983, '\p{^Numeric_Value=00_00_00_042}', "");
    Expect(0, 12983, '\P{Numeric_Value=00_00_00_042}', "");
    Expect(1, 12983, '\P{^Numeric_Value=00_00_00_042}', "");
    Expect(0, 12984, '\p{Numeric_Value=00_00_00_042}', "");
    Expect(1, 12984, '\p{^Numeric_Value=00_00_00_042}', "");
    Expect(1, 12984, '\P{Numeric_Value=00_00_00_042}', "");
    Expect(0, 12984, '\P{^Numeric_Value=00_00_00_042}', "");
    Error('\p{Nv:  /a/00000042}');
    Error('\P{Nv:  /a/00000042}');
    Expect(1, 12983, '\p{Nv=00_04_2}', "");
    Expect(0, 12983, '\p{^Nv=00_04_2}', "");
    Expect(0, 12983, '\P{Nv=00_04_2}', "");
    Expect(1, 12983, '\P{^Nv=00_04_2}', "");
    Expect(0, 12984, '\p{Nv=00_04_2}', "");
    Expect(1, 12984, '\p{^Nv=00_04_2}', "");
    Expect(1, 12984, '\P{Nv=00_04_2}', "");
    Expect(0, 12984, '\P{^Nv=00_04_2}', "");
    Error('\p{Is_Numeric_Value=_/a/+00000000042}');
    Error('\P{Is_Numeric_Value=_/a/+00000000042}');
    Expect(1, 12983, '\p{Is_Numeric_Value=0000000042}', "");
    Expect(0, 12983, '\p{^Is_Numeric_Value=0000000042}', "");
    Expect(0, 12983, '\P{Is_Numeric_Value=0000000042}', "");
    Expect(1, 12983, '\P{^Is_Numeric_Value=0000000042}', "");
    Expect(0, 12984, '\p{Is_Numeric_Value=0000000042}', "");
    Expect(1, 12984, '\p{^Is_Numeric_Value=0000000042}', "");
    Expect(1, 12984, '\P{Is_Numeric_Value=0000000042}', "");
    Expect(0, 12984, '\P{^Is_Numeric_Value=0000000042}', "");
    Error('\p{Is_Nv=/a/+000000042}');
    Error('\P{Is_Nv=/a/+000000042}');
    Expect(1, 12983, '\p{Is_Nv=+0000000042}', "");
    Expect(0, 12983, '\p{^Is_Nv=+0000000042}', "");
    Expect(0, 12983, '\P{Is_Nv=+0000000042}', "");
    Expect(1, 12983, '\P{^Is_Nv=+0000000042}', "");
    Expect(0, 12984, '\p{Is_Nv=+0000000042}', "");
    Expect(1, 12984, '\p{^Is_Nv=+0000000042}', "");
    Expect(1, 12984, '\P{Is_Nv=+0000000042}', "");
    Expect(0, 12984, '\P{^Is_Nv=+0000000042}', "");
    Error('\p{Numeric_Value=:=_00000000043}');
    Error('\P{Numeric_Value=:=_00000000043}');
    Expect(1, 12984, '\p{Numeric_Value=000004_3}', "");
    Expect(0, 12984, '\p{^Numeric_Value=000004_3}', "");
    Expect(0, 12984, '\P{Numeric_Value=000004_3}', "");
    Expect(1, 12984, '\P{^Numeric_Value=000004_3}', "");
    Expect(0, 12985, '\p{Numeric_Value=000004_3}', "");
    Expect(1, 12985, '\p{^Numeric_Value=000004_3}', "");
    Expect(1, 12985, '\P{Numeric_Value=000004_3}', "");
    Expect(0, 12985, '\P{^Numeric_Value=000004_3}', "");
    Error('\p{Nv=	+0000043:=}');
    Error('\P{Nv=	+0000043:=}');
    Expect(1, 12984, '\p{Nv=043}', "");
    Expect(0, 12984, '\p{^Nv=043}', "");
    Expect(0, 12984, '\P{Nv=043}', "");
    Expect(1, 12984, '\P{^Nv=043}', "");
    Expect(0, 12985, '\p{Nv=043}', "");
    Expect(1, 12985, '\p{^Nv=043}', "");
    Expect(1, 12985, '\P{Nv=043}', "");
    Expect(0, 12985, '\P{^Nv=043}', "");
    Error('\p{Is_Numeric_Value=0043/a/}');
    Error('\P{Is_Numeric_Value=0043/a/}');
    Expect(1, 12984, '\p{Is_Numeric_Value=0000000043}', "");
    Expect(0, 12984, '\p{^Is_Numeric_Value=0000000043}', "");
    Expect(0, 12984, '\P{Is_Numeric_Value=0000000043}', "");
    Expect(1, 12984, '\P{^Is_Numeric_Value=0000000043}', "");
    Expect(0, 12985, '\p{Is_Numeric_Value=0000000043}', "");
    Expect(1, 12985, '\p{^Is_Numeric_Value=0000000043}', "");
    Expect(1, 12985, '\P{Is_Numeric_Value=0000000043}', "");
    Expect(0, 12985, '\P{^Is_Numeric_Value=0000000043}', "");
    Error('\p{Is_Nv=-:=0000004_3}');
    Error('\P{Is_Nv=-:=0000004_3}');
    Expect(1, 12984, '\p{Is_Nv=+00000000043}', "");
    Expect(0, 12984, '\p{^Is_Nv=+00000000043}', "");
    Expect(0, 12984, '\P{Is_Nv=+00000000043}', "");
    Expect(1, 12984, '\P{^Is_Nv=+00000000043}', "");
    Expect(0, 12985, '\p{Is_Nv=+00000000043}', "");
    Expect(1, 12985, '\p{^Is_Nv=+00000000043}', "");
    Expect(1, 12985, '\P{Is_Nv=+00000000043}', "");
    Expect(0, 12985, '\P{^Is_Nv=+00000000043}', "");
    Error('\p{Numeric_Value=:=0_0_0_0_0_0_0_4_3_2_000}');
    Error('\P{Numeric_Value=:=0_0_0_0_0_0_0_4_3_2_000}');
    Expect(1, 74803, '\p{Numeric_Value=+000000043200_0}', "");
    Expect(0, 74803, '\p{^Numeric_Value=+000000043200_0}', "");
    Expect(0, 74803, '\P{Numeric_Value=+000000043200_0}', "");
    Expect(1, 74803, '\P{^Numeric_Value=+000000043200_0}', "");
    Expect(0, 74804, '\p{Numeric_Value=+000000043200_0}', "");
    Expect(1, 74804, '\p{^Numeric_Value=+000000043200_0}', "");
    Expect(1, 74804, '\P{Numeric_Value=+000000043200_0}', "");
    Expect(0, 74804, '\P{^Numeric_Value=+000000043200_0}', "");
    Error('\p{Nv:   -/a/0000_4320_00}');
    Error('\P{Nv:   -/a/0000_4320_00}');
    Expect(1, 74803, '\p{Nv=000000043200_0}', "");
    Expect(0, 74803, '\p{^Nv=000000043200_0}', "");
    Expect(0, 74803, '\P{Nv=000000043200_0}', "");
    Expect(1, 74803, '\P{^Nv=000000043200_0}', "");
    Expect(0, 74804, '\p{Nv=000000043200_0}', "");
    Expect(1, 74804, '\p{^Nv=000000043200_0}', "");
    Expect(1, 74804, '\P{Nv=000000043200_0}', "");
    Expect(0, 74804, '\P{^Nv=000000043200_0}', "");
    Error('\p{Is_Numeric_Value= -+0432000/a/}');
    Error('\P{Is_Numeric_Value= -+0432000/a/}');
    Expect(1, 74803, '\p{Is_Numeric_Value=00_00_00_04_32_000}', "");
    Expect(0, 74803, '\p{^Is_Numeric_Value=00_00_00_04_32_000}', "");
    Expect(0, 74803, '\P{Is_Numeric_Value=00_00_00_04_32_000}', "");
    Expect(1, 74803, '\P{^Is_Numeric_Value=00_00_00_04_32_000}', "");
    Expect(0, 74804, '\p{Is_Numeric_Value=00_00_00_04_32_000}', "");
    Expect(1, 74804, '\p{^Is_Numeric_Value=00_00_00_04_32_000}', "");
    Expect(1, 74804, '\P{Is_Numeric_Value=00_00_00_04_32_000}', "");
    Expect(0, 74804, '\P{^Is_Numeric_Value=00_00_00_04_32_000}', "");
    Error('\p{Is_Nv=-_+0000_4320_00/a/}');
    Error('\P{Is_Nv=-_+0000_4320_00/a/}');
    Expect(1, 74803, '\p{Is_Nv=+000000432000}', "");
    Expect(0, 74803, '\p{^Is_Nv=+000000432000}', "");
    Expect(0, 74803, '\P{Is_Nv=+000000432000}', "");
    Expect(1, 74803, '\P{^Is_Nv=+000000432000}', "");
    Expect(0, 74804, '\p{Is_Nv=+000000432000}', "");
    Expect(1, 74804, '\p{^Is_Nv=+000000432000}', "");
    Expect(1, 74804, '\P{Is_Nv=+000000432000}', "");
    Expect(0, 74804, '\P{^Is_Nv=+000000432000}', "");
    Error('\p{Numeric_Value=0_0_0_44:=}');
    Error('\P{Numeric_Value=0_0_0_44:=}');
    Expect(1, 12985, '\p{Numeric_Value=+04_4}', "");
    Expect(0, 12985, '\p{^Numeric_Value=+04_4}', "");
    Expect(0, 12985, '\P{Numeric_Value=+04_4}', "");
    Expect(1, 12985, '\P{^Numeric_Value=+04_4}', "");
    Expect(0, 12986, '\p{Numeric_Value=+04_4}', "");
    Expect(1, 12986, '\p{^Numeric_Value=+04_4}', "");
    Expect(1, 12986, '\P{Numeric_Value=+04_4}', "");
    Expect(0, 12986, '\P{^Numeric_Value=+04_4}', "");
    Error('\p{Nv=:=_00000044}');
    Error('\P{Nv=:=_00000044}');
    Expect(1, 12985, '\p{Nv=0_0_0_44}', "");
    Expect(0, 12985, '\p{^Nv=0_0_0_44}', "");
    Expect(0, 12985, '\P{Nv=0_0_0_44}', "");
    Expect(1, 12985, '\P{^Nv=0_0_0_44}', "");
    Expect(0, 12986, '\p{Nv=0_0_0_44}', "");
    Expect(1, 12986, '\p{^Nv=0_0_0_44}', "");
    Expect(1, 12986, '\P{Nv=0_0_0_44}', "");
    Expect(0, 12986, '\P{^Nv=0_0_0_44}', "");
    Error('\p{Is_Numeric_Value=:=	_000_000_000_44}');
    Error('\P{Is_Numeric_Value=:=	_000_000_000_44}');
    Expect(1, 12985, '\p{Is_Numeric_Value=+00000044}', "");
    Expect(0, 12985, '\p{^Is_Numeric_Value=+00000044}', "");
    Expect(0, 12985, '\P{Is_Numeric_Value=+00000044}', "");
    Expect(1, 12985, '\P{^Is_Numeric_Value=+00000044}', "");
    Expect(0, 12986, '\p{Is_Numeric_Value=+00000044}', "");
    Expect(1, 12986, '\p{^Is_Numeric_Value=+00000044}', "");
    Expect(1, 12986, '\P{Is_Numeric_Value=+00000044}', "");
    Expect(0, 12986, '\P{^Is_Numeric_Value=+00000044}', "");
    Error('\p{Is_Nv:		_000044:=}');
    Error('\P{Is_Nv:		_000044:=}');
    Expect(1, 12985, '\p{Is_Nv=000044}', "");
    Expect(0, 12985, '\p{^Is_Nv=000044}', "");
    Expect(0, 12985, '\P{Is_Nv=000044}', "");
    Expect(1, 12985, '\P{^Is_Nv=000044}', "");
    Expect(0, 12986, '\p{Is_Nv=000044}', "");
    Expect(1, 12986, '\p{^Is_Nv=000044}', "");
    Expect(1, 12986, '\P{Is_Nv=000044}', "");
    Expect(0, 12986, '\P{^Is_Nv=000044}', "");
    Error('\p{Numeric_Value=	+00045:=}');
    Error('\P{Numeric_Value=	+00045:=}');
    Expect(1, 12986, '\p{Numeric_Value=0000045}', "");
    Expect(0, 12986, '\p{^Numeric_Value=0000045}', "");
    Expect(0, 12986, '\P{Numeric_Value=0000045}', "");
    Expect(1, 12986, '\P{^Numeric_Value=0000045}', "");
    Expect(0, 12987, '\p{Numeric_Value=0000045}', "");
    Expect(1, 12987, '\p{^Numeric_Value=0000045}', "");
    Expect(1, 12987, '\P{Numeric_Value=0000045}', "");
    Expect(0, 12987, '\P{^Numeric_Value=0000045}', "");
    Error('\p{Nv: /a/000000045}');
    Error('\P{Nv: /a/000000045}');
    Expect(1, 12986, '\p{Nv=000_000_45}', "");
    Expect(0, 12986, '\p{^Nv=000_000_45}', "");
    Expect(0, 12986, '\P{Nv=000_000_45}', "");
    Expect(1, 12986, '\P{^Nv=000_000_45}', "");
    Expect(0, 12987, '\p{Nv=000_000_45}', "");
    Expect(1, 12987, '\p{^Nv=000_000_45}', "");
    Expect(1, 12987, '\P{Nv=000_000_45}', "");
    Expect(0, 12987, '\P{^Nv=000_000_45}', "");
    Error('\p{Is_Numeric_Value=/a/-_+045}');
    Error('\P{Is_Numeric_Value=/a/-_+045}');
    Expect(1, 12986, '\p{Is_Numeric_Value=0_0_0_0_0_045}', "");
    Expect(0, 12986, '\p{^Is_Numeric_Value=0_0_0_0_0_045}', "");
    Expect(0, 12986, '\P{Is_Numeric_Value=0_0_0_0_0_045}', "");
    Expect(1, 12986, '\P{^Is_Numeric_Value=0_0_0_0_0_045}', "");
    Expect(0, 12987, '\p{Is_Numeric_Value=0_0_0_0_0_045}', "");
    Expect(1, 12987, '\p{^Is_Numeric_Value=0_0_0_0_0_045}', "");
    Expect(1, 12987, '\P{Is_Numeric_Value=0_0_0_0_0_045}', "");
    Expect(0, 12987, '\P{^Is_Numeric_Value=0_0_0_0_0_045}', "");
    Error('\p{Is_Nv=-:=45}');
    Error('\P{Is_Nv=-:=45}');
    Expect(1, 12986, '\p{Is_Nv=+0_0_0_0_0_0045}', "");
    Expect(0, 12986, '\p{^Is_Nv=+0_0_0_0_0_0045}', "");
    Expect(0, 12986, '\P{Is_Nv=+0_0_0_0_0_0045}', "");
    Expect(1, 12986, '\P{^Is_Nv=+0_0_0_0_0_0045}', "");
    Expect(0, 12987, '\p{Is_Nv=+0_0_0_0_0_0045}', "");
    Expect(1, 12987, '\p{^Is_Nv=+0_0_0_0_0_0045}', "");
    Expect(1, 12987, '\P{Is_Nv=+0_0_0_0_0_0045}', "");
    Expect(0, 12987, '\P{^Is_Nv=+0_0_0_0_0_0045}', "");
    Error('\p{Numeric_Value=:=  0_0_0_0_46}');
    Error('\P{Numeric_Value=:=  0_0_0_0_46}');
    Expect(1, 12987, '\p{Numeric_Value=+0_0_0_46}', "");
    Expect(0, 12987, '\p{^Numeric_Value=+0_0_0_46}', "");
    Expect(0, 12987, '\P{Numeric_Value=+0_0_0_46}', "");
    Expect(1, 12987, '\P{^Numeric_Value=+0_0_0_46}', "");
    Expect(0, 12988, '\p{Numeric_Value=+0_0_0_46}', "");
    Expect(1, 12988, '\p{^Numeric_Value=+0_0_0_46}', "");
    Expect(1, 12988, '\P{Numeric_Value=+0_0_0_46}', "");
    Expect(0, 12988, '\P{^Numeric_Value=+0_0_0_46}', "");
    Error('\p{Nv=- +000046:=}');
    Error('\P{Nv=- +000046:=}');
    Expect(1, 12987, '\p{Nv=+0_0_0_046}', "");
    Expect(0, 12987, '\p{^Nv=+0_0_0_046}', "");
    Expect(0, 12987, '\P{Nv=+0_0_0_046}', "");
    Expect(1, 12987, '\P{^Nv=+0_0_0_046}', "");
    Expect(0, 12988, '\p{Nv=+0_0_0_046}', "");
    Expect(1, 12988, '\p{^Nv=+0_0_0_046}', "");
    Expect(1, 12988, '\P{Nv=+0_0_0_046}', "");
    Expect(0, 12988, '\P{^Nv=+0_0_0_046}', "");
    Error('\p{Is_Numeric_Value=-:=+4_6}');
    Error('\P{Is_Numeric_Value=-:=+4_6}');
    Expect(1, 12987, '\p{Is_Numeric_Value: +0000046}', "");
    Expect(0, 12987, '\p{^Is_Numeric_Value: +0000046}', "");
    Expect(0, 12987, '\P{Is_Numeric_Value: +0000046}', "");
    Expect(1, 12987, '\P{^Is_Numeric_Value: +0000046}', "");
    Expect(0, 12988, '\p{Is_Numeric_Value: +0000046}', "");
    Expect(1, 12988, '\p{^Is_Numeric_Value: +0000046}', "");
    Expect(1, 12988, '\P{Is_Numeric_Value: +0000046}', "");
    Expect(0, 12988, '\P{^Is_Numeric_Value: +0000046}', "");
    Error('\p{Is_Nv=:=-_000_004_6}');
    Error('\P{Is_Nv=:=-_000_004_6}');
    Expect(1, 12987, '\p{Is_Nv=0000000004_6}', "");
    Expect(0, 12987, '\p{^Is_Nv=0000000004_6}', "");
    Expect(0, 12987, '\P{Is_Nv=0000000004_6}', "");
    Expect(1, 12987, '\P{^Is_Nv=0000000004_6}', "");
    Expect(0, 12988, '\p{Is_Nv=0000000004_6}', "");
    Expect(1, 12988, '\p{^Is_Nv=0000000004_6}', "");
    Expect(1, 12988, '\P{Is_Nv=0000000004_6}', "");
    Expect(0, 12988, '\P{^Is_Nv=0000000004_6}', "");
    Error('\p{Numeric_Value=:=-0_0_0_0_047}');
    Error('\P{Numeric_Value=:=-0_0_0_0_047}');
    Expect(1, 12988, '\p{Numeric_Value=00_04_7}', "");
    Expect(0, 12988, '\p{^Numeric_Value=00_04_7}', "");
    Expect(0, 12988, '\P{Numeric_Value=00_04_7}', "");
    Expect(1, 12988, '\P{^Numeric_Value=00_04_7}', "");
    Expect(0, 12989, '\p{Numeric_Value=00_04_7}', "");
    Expect(1, 12989, '\p{^Numeric_Value=00_04_7}', "");
    Expect(1, 12989, '\P{Numeric_Value=00_04_7}', "");
    Expect(0, 12989, '\P{^Numeric_Value=00_04_7}', "");
    Error('\p{Nv=/a/	 0047}');
    Error('\P{Nv=/a/	 0047}');
    Expect(1, 12988, '\p{Nv=4_7}', "");
    Expect(0, 12988, '\p{^Nv=4_7}', "");
    Expect(0, 12988, '\P{Nv=4_7}', "");
    Expect(1, 12988, '\P{^Nv=4_7}', "");
    Expect(0, 12989, '\p{Nv=4_7}', "");
    Expect(1, 12989, '\p{^Nv=4_7}', "");
    Expect(1, 12989, '\P{Nv=4_7}', "");
    Expect(0, 12989, '\P{^Nv=4_7}', "");
    Error('\p{Is_Numeric_Value: -_+0000047:=}');
    Error('\P{Is_Numeric_Value: -_+0000047:=}');
    Expect(1, 12988, '\p{Is_Numeric_Value=0_0_0_47}', "");
    Expect(0, 12988, '\p{^Is_Numeric_Value=0_0_0_47}', "");
    Expect(0, 12988, '\P{Is_Numeric_Value=0_0_0_47}', "");
    Expect(1, 12988, '\P{^Is_Numeric_Value=0_0_0_47}', "");
    Expect(0, 12989, '\p{Is_Numeric_Value=0_0_0_47}', "");
    Expect(1, 12989, '\p{^Is_Numeric_Value=0_0_0_47}', "");
    Expect(1, 12989, '\P{Is_Numeric_Value=0_0_0_47}', "");
    Expect(0, 12989, '\P{^Is_Numeric_Value=0_0_0_47}', "");
    Error('\p{Is_Nv=-47:=}');
    Error('\P{Is_Nv=-47:=}');
    Expect(1, 12988, '\p{Is_Nv=0_0_47}', "");
    Expect(0, 12988, '\p{^Is_Nv=0_0_47}', "");
    Expect(0, 12988, '\P{Is_Nv=0_0_47}', "");
    Expect(1, 12988, '\P{^Is_Nv=0_0_47}', "");
    Expect(0, 12989, '\p{Is_Nv=0_0_47}', "");
    Expect(1, 12989, '\p{^Is_Nv=0_0_47}', "");
    Expect(1, 12989, '\P{Is_Nv=0_0_47}', "");
    Expect(0, 12989, '\P{^Is_Nv=0_0_47}', "");
    Error('\p{Numeric_Value=	-000000048:=}');
    Error('\P{Numeric_Value=	-000000048:=}');
    Expect(1, 12989, '\p{Numeric_Value=+48}', "");
    Expect(0, 12989, '\p{^Numeric_Value=+48}', "");
    Expect(0, 12989, '\P{Numeric_Value=+48}', "");
    Expect(1, 12989, '\P{^Numeric_Value=+48}', "");
    Expect(0, 12990, '\p{Numeric_Value=+48}', "");
    Expect(1, 12990, '\p{^Numeric_Value=+48}', "");
    Expect(1, 12990, '\P{Numeric_Value=+48}', "");
    Expect(0, 12990, '\P{^Numeric_Value=+48}', "");
    Error('\p{Nv=_-000000048:=}');
    Error('\P{Nv=_-000000048:=}');
    Expect(1, 12989, '\p{Nv=0_0_48}', "");
    Expect(0, 12989, '\p{^Nv=0_0_48}', "");
    Expect(0, 12989, '\P{Nv=0_0_48}', "");
    Expect(1, 12989, '\P{^Nv=0_0_48}', "");
    Expect(0, 12990, '\p{Nv=0_0_48}', "");
    Expect(1, 12990, '\p{^Nv=0_0_48}', "");
    Expect(1, 12990, '\P{Nv=0_0_48}', "");
    Expect(0, 12990, '\P{^Nv=0_0_48}', "");
    Error('\p{Is_Numeric_Value=/a/ 0_0_0_048}');
    Error('\P{Is_Numeric_Value=/a/ 0_0_0_048}');
    Expect(1, 12989, '\p{Is_Numeric_Value=+0_0_48}', "");
    Expect(0, 12989, '\p{^Is_Numeric_Value=+0_0_48}', "");
    Expect(0, 12989, '\P{Is_Numeric_Value=+0_0_48}', "");
    Expect(1, 12989, '\P{^Is_Numeric_Value=+0_0_48}', "");
    Expect(0, 12990, '\p{Is_Numeric_Value=+0_0_48}', "");
    Expect(1, 12990, '\p{^Is_Numeric_Value=+0_0_48}', "");
    Expect(1, 12990, '\P{Is_Numeric_Value=+0_0_48}', "");
    Expect(0, 12990, '\P{^Is_Numeric_Value=+0_0_48}', "");
    Error('\p{Is_Nv=_	0_0_0_0_0048:=}');
    Error('\P{Is_Nv=_	0_0_0_0_0048:=}');
    Expect(1, 12989, '\p{Is_Nv=000000048}', "");
    Expect(0, 12989, '\p{^Is_Nv=000000048}', "");
    Expect(0, 12989, '\P{Is_Nv=000000048}', "");
    Expect(1, 12989, '\P{^Is_Nv=000000048}', "");
    Expect(0, 12990, '\p{Is_Nv=000000048}', "");
    Expect(1, 12990, '\p{^Is_Nv=000000048}', "");
    Expect(1, 12990, '\P{Is_Nv=000000048}', "");
    Expect(0, 12990, '\P{^Is_Nv=000000048}', "");
    Error('\p{Numeric_Value:-00_04_9/a/}');
    Error('\P{Numeric_Value:-00_04_9/a/}');
    Expect(1, 12990, '\p{Numeric_Value=0_0_0_049}', "");
    Expect(0, 12990, '\p{^Numeric_Value=0_0_0_049}', "");
    Expect(0, 12990, '\P{Numeric_Value=0_0_0_049}', "");
    Expect(1, 12990, '\P{^Numeric_Value=0_0_0_049}', "");
    Expect(0, 12991, '\p{Numeric_Value=0_0_0_049}', "");
    Expect(1, 12991, '\p{^Numeric_Value=0_0_0_049}', "");
    Expect(1, 12991, '\P{Numeric_Value=0_0_0_049}', "");
    Expect(0, 12991, '\P{^Numeric_Value=0_0_0_049}', "");
    Error('\p{Nv=:=_ 00049}');
    Error('\P{Nv=:=_ 00049}');
    Expect(1, 12990, '\p{Nv:	+00000000049}', "");
    Expect(0, 12990, '\p{^Nv:	+00000000049}', "");
    Expect(0, 12990, '\P{Nv:	+00000000049}', "");
    Expect(1, 12990, '\P{^Nv:	+00000000049}', "");
    Expect(0, 12991, '\p{Nv:	+00000000049}', "");
    Expect(1, 12991, '\p{^Nv:	+00000000049}', "");
    Expect(1, 12991, '\P{Nv:	+00000000049}', "");
    Expect(0, 12991, '\P{^Nv:	+00000000049}', "");
    Error('\p{Is_Numeric_Value=/a/ 	+004_9}');
    Error('\P{Is_Numeric_Value=/a/ 	+004_9}');
    Expect(1, 12990, '\p{Is_Numeric_Value=+049}', "");
    Expect(0, 12990, '\p{^Is_Numeric_Value=+049}', "");
    Expect(0, 12990, '\P{Is_Numeric_Value=+049}', "");
    Expect(1, 12990, '\P{^Is_Numeric_Value=+049}', "");
    Expect(0, 12991, '\p{Is_Numeric_Value=+049}', "");
    Expect(1, 12991, '\p{^Is_Numeric_Value=+049}', "");
    Expect(1, 12991, '\P{Is_Numeric_Value=+049}', "");
    Expect(0, 12991, '\P{^Is_Numeric_Value=+049}', "");
    Error('\p{Is_Nv=/a/0000049}');
    Error('\P{Is_Nv=/a/0000049}');
    Expect(1, 12990, '\p{Is_Nv=+4_9}', "");
    Expect(0, 12990, '\p{^Is_Nv=+4_9}', "");
    Expect(0, 12990, '\P{Is_Nv=+4_9}', "");
    Expect(1, 12990, '\P{^Is_Nv=+4_9}', "");
    Expect(0, 12991, '\p{Is_Nv=+4_9}', "");
    Expect(1, 12991, '\p{^Is_Nv=+4_9}', "");
    Expect(1, 12991, '\P{Is_Nv=+4_9}', "");
    Expect(0, 12991, '\P{^Is_Nv=+4_9}', "");
    Error('\p{Numeric_Value= :=00_5}');
    Error('\P{Numeric_Value= :=00_5}');
    Expect(1, 131361, '\p{Numeric_Value=0000000005}', "");
    Expect(0, 131361, '\p{^Numeric_Value=0000000005}', "");
    Expect(0, 131361, '\P{Numeric_Value=0000000005}', "");
    Expect(1, 131361, '\P{^Numeric_Value=0000000005}', "");
    Expect(0, 131362, '\p{Numeric_Value=0000000005}', "");
    Expect(1, 131362, '\p{^Numeric_Value=0000000005}', "");
    Expect(1, 131362, '\P{Numeric_Value=0000000005}', "");
    Expect(0, 131362, '\P{^Numeric_Value=0000000005}', "");
    Error('\p{Nv=/a/5}');
    Error('\P{Nv=/a/5}');
    Expect(1, 131361, '\p{Nv=0000000005}', "");
    Expect(0, 131361, '\p{^Nv=0000000005}', "");
    Expect(0, 131361, '\P{Nv=0000000005}', "");
    Expect(1, 131361, '\P{^Nv=0000000005}', "");
    Expect(0, 131362, '\p{Nv=0000000005}', "");
    Expect(1, 131362, '\p{^Nv=0000000005}', "");
    Expect(1, 131362, '\P{Nv=0000000005}', "");
    Expect(0, 131362, '\P{^Nv=0000000005}', "");
    Error('\p{Is_Numeric_Value=/a/5}');
    Error('\P{Is_Numeric_Value=/a/5}');
    Expect(1, 131361, '\p{Is_Numeric_Value: +0_5}', "");
    Expect(0, 131361, '\p{^Is_Numeric_Value: +0_5}', "");
    Expect(0, 131361, '\P{Is_Numeric_Value: +0_5}', "");
    Expect(1, 131361, '\P{^Is_Numeric_Value: +0_5}', "");
    Expect(0, 131362, '\p{Is_Numeric_Value: +0_5}', "");
    Expect(1, 131362, '\p{^Is_Numeric_Value: +0_5}', "");
    Expect(1, 131362, '\P{Is_Numeric_Value: +0_5}', "");
    Expect(0, 131362, '\P{^Is_Numeric_Value: +0_5}', "");
    Error('\p{Is_Nv=-5/a/}');
    Error('\P{Is_Nv=-5/a/}');
    Expect(1, 131361, '\p{Is_Nv=00000000_5}', "");
    Expect(0, 131361, '\p{^Is_Nv=00000000_5}', "");
    Expect(0, 131361, '\P{Is_Nv=00000000_5}', "");
    Expect(1, 131361, '\P{^Is_Nv=00000000_5}', "");
    Expect(0, 131362, '\p{Is_Nv=00000000_5}', "");
    Expect(1, 131362, '\p{^Is_Nv=00000000_5}', "");
    Expect(1, 131362, '\P{Is_Nv=00000000_5}', "");
    Expect(0, 131362, '\P{^Is_Nv=00000000_5}', "");
    Error('\p{Numeric_Value=+0005/000000012/a/}');
    Error('\P{Numeric_Value=+0005/000000012/a/}');
    Expect(1, 68090, '\p{Numeric_Value=+0000005/00012}', "");
    Expect(0, 68090, '\p{^Numeric_Value=+0000005/00012}', "");
    Expect(0, 68090, '\P{Numeric_Value=+0000005/00012}', "");
    Expect(1, 68090, '\P{^Numeric_Value=+0000005/00012}', "");
    Expect(0, 68091, '\p{Numeric_Value=+0000005/00012}', "");
    Expect(1, 68091, '\p{^Numeric_Value=+0000005/00012}', "");
    Expect(1, 68091, '\P{Numeric_Value=+0000005/00012}', "");
    Expect(0, 68091, '\P{^Numeric_Value=+0000005/00012}', "");
    Error('\p{Numeric_Value=0.42}');
    Error('\P{Numeric_Value=0.42}');
    Expect(1, 68090, '\p{Numeric_Value=0.417}', "");
    Expect(0, 68090, '\p{^Numeric_Value=0.417}', "");
    Expect(0, 68090, '\P{Numeric_Value=0.417}', "");
    Expect(1, 68090, '\P{^Numeric_Value=0.417}', "");
    Expect(0, 68091, '\p{Numeric_Value=0.417}', "");
    Expect(1, 68091, '\p{^Numeric_Value=0.417}', "");
    Expect(1, 68091, '\P{Numeric_Value=0.417}', "");
    Expect(0, 68091, '\P{^Numeric_Value=0.417}', "");
    Error('\p{Nv=-/a/05/00000000012}');
    Error('\P{Nv=-/a/05/00000000012}');
    Expect(1, 68090, '\p{Nv=0000005/0000012}', "");
    Expect(0, 68090, '\p{^Nv=0000005/0000012}', "");
    Expect(0, 68090, '\P{Nv=0000005/0000012}', "");
    Expect(1, 68090, '\P{^Nv=0000005/0000012}', "");
    Expect(0, 68091, '\p{Nv=0000005/0000012}', "");
    Expect(1, 68091, '\p{^Nv=0000005/0000012}', "");
    Expect(1, 68091, '\P{Nv=0000005/0000012}', "");
    Expect(0, 68091, '\P{^Nv=0000005/0000012}', "");
    Error('\p{Nv=0.42}');
    Error('\P{Nv=0.42}');
    Expect(1, 68090, '\p{Nv=0.417}', "");
    Expect(0, 68090, '\p{^Nv=0.417}', "");
    Expect(0, 68090, '\P{Nv=0.417}', "");
    Expect(1, 68090, '\P{^Nv=0.417}', "");
    Expect(0, 68091, '\p{Nv=0.417}', "");
    Expect(1, 68091, '\p{^Nv=0.417}', "");
    Expect(1, 68091, '\P{Nv=0.417}', "");
    Expect(0, 68091, '\P{^Nv=0.417}', "");
    Error('\p{Is_Numeric_Value= -+005/00000000012:=}');
    Error('\P{Is_Numeric_Value= -+005/00000000012:=}');
    Expect(1, 68090, '\p{Is_Numeric_Value=005/00000012}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value=005/00000012}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value=005/00000012}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value=005/00000012}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value=005/00000012}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value=005/00000012}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value=005/00000012}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value=005/00000012}', "");
    Error('\p{Is_Numeric_Value=0.42}');
    Error('\P{Is_Numeric_Value=0.42}');
    Expect(1, 68090, '\p{Is_Numeric_Value=0.417}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value=0.417}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value=0.417}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value=0.417}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value=0.417}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value=0.417}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value=0.417}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value=0.417}', "");
    Error('\p{Is_Nv=/a/--005/00000012}');
    Error('\P{Is_Nv=/a/--005/00000012}');
    Expect(1, 68090, '\p{Is_Nv=+000005/0000000012}', "");
    Expect(0, 68090, '\p{^Is_Nv=+000005/0000000012}', "");
    Expect(0, 68090, '\P{Is_Nv=+000005/0000000012}', "");
    Expect(1, 68090, '\P{^Is_Nv=+000005/0000000012}', "");
    Expect(0, 68091, '\p{Is_Nv=+000005/0000000012}', "");
    Expect(1, 68091, '\p{^Is_Nv=+000005/0000000012}', "");
    Expect(1, 68091, '\P{Is_Nv=+000005/0000000012}', "");
    Expect(0, 68091, '\P{^Is_Nv=+000005/0000000012}', "");
    Error('\p{Is_Nv=0.42}');
    Error('\P{Is_Nv=0.42}');
    Expect(1, 68090, '\p{Is_Nv=0.417}', "");
    Expect(0, 68090, '\p{^Is_Nv=0.417}', "");
    Expect(0, 68090, '\P{Is_Nv=0.417}', "");
    Expect(1, 68090, '\P{^Is_Nv=0.417}', "");
    Expect(0, 68091, '\p{Is_Nv=0.417}', "");
    Expect(1, 68091, '\p{^Is_Nv=0.417}', "");
    Expect(1, 68091, '\P{Is_Nv=0.417}', "");
    Expect(0, 68091, '\P{^Is_Nv=0.417}', "");
    Error('\p{Numeric_Value=/a/	05/00002}');
    Error('\P{Numeric_Value=/a/	05/00002}');
    Expect(1, 3884, '\p{Numeric_Value=005/00000002}', "");
    Expect(0, 3884, '\p{^Numeric_Value=005/00000002}', "");
    Expect(0, 3884, '\P{Numeric_Value=005/00000002}', "");
    Expect(1, 3884, '\P{^Numeric_Value=005/00000002}', "");
    Expect(0, 3885, '\p{Numeric_Value=005/00000002}', "");
    Expect(1, 3885, '\p{^Numeric_Value=005/00000002}', "");
    Expect(1, 3885, '\P{Numeric_Value=005/00000002}', "");
    Expect(0, 3885, '\P{^Numeric_Value=005/00000002}', "");
    Expect(1, 3884, '\p{Numeric_Value=2.500}', "");
    Expect(0, 3884, '\p{^Numeric_Value=2.500}', "");
    Expect(0, 3884, '\P{Numeric_Value=2.500}', "");
    Expect(1, 3884, '\P{^Numeric_Value=2.500}', "");
    Expect(0, 3885, '\p{Numeric_Value=2.500}', "");
    Expect(1, 3885, '\p{^Numeric_Value=2.500}', "");
    Expect(1, 3885, '\P{Numeric_Value=2.500}', "");
    Expect(0, 3885, '\P{^Numeric_Value=2.500}', "");
    Error('\p{Nv= _05/0000000002:=}');
    Error('\P{Nv= _05/0000000002:=}');
    Expect(1, 3884, '\p{Nv:0005/0000002}', "");
    Expect(0, 3884, '\p{^Nv:0005/0000002}', "");
    Expect(0, 3884, '\P{Nv:0005/0000002}', "");
    Expect(1, 3884, '\P{^Nv:0005/0000002}', "");
    Expect(0, 3885, '\p{Nv:0005/0000002}', "");
    Expect(1, 3885, '\p{^Nv:0005/0000002}', "");
    Expect(1, 3885, '\P{Nv:0005/0000002}', "");
    Expect(0, 3885, '\P{^Nv:0005/0000002}', "");
    Expect(1, 3884, '\p{Nv=2.500}', "");
    Expect(0, 3884, '\p{^Nv=2.500}', "");
    Expect(0, 3884, '\P{Nv=2.500}', "");
    Expect(1, 3884, '\P{^Nv=2.500}', "");
    Expect(0, 3885, '\p{Nv=2.500}', "");
    Expect(1, 3885, '\p{^Nv=2.500}', "");
    Expect(1, 3885, '\P{Nv=2.500}', "");
    Expect(0, 3885, '\P{^Nv=2.500}', "");
    Error('\p{Is_Numeric_Value=-05/2:=}');
    Error('\P{Is_Numeric_Value=-05/2:=}');
    Expect(1, 3884, '\p{Is_Numeric_Value=0000005/0000002}', "");
    Expect(0, 3884, '\p{^Is_Numeric_Value=0000005/0000002}', "");
    Expect(0, 3884, '\P{Is_Numeric_Value=0000005/0000002}', "");
    Expect(1, 3884, '\P{^Is_Numeric_Value=0000005/0000002}', "");
    Expect(0, 3885, '\p{Is_Numeric_Value=0000005/0000002}', "");
    Expect(1, 3885, '\p{^Is_Numeric_Value=0000005/0000002}', "");
    Expect(1, 3885, '\P{Is_Numeric_Value=0000005/0000002}', "");
    Expect(0, 3885, '\P{^Is_Numeric_Value=0000005/0000002}', "");
    Expect(1, 3884, '\p{Is_Numeric_Value=2.500}', "");
    Expect(0, 3884, '\p{^Is_Numeric_Value=2.500}', "");
    Expect(0, 3884, '\P{Is_Numeric_Value=2.500}', "");
    Expect(1, 3884, '\P{^Is_Numeric_Value=2.500}', "");
    Expect(0, 3885, '\p{Is_Numeric_Value=2.500}', "");
    Expect(1, 3885, '\p{^Is_Numeric_Value=2.500}', "");
    Expect(1, 3885, '\P{Is_Numeric_Value=2.500}', "");
    Expect(0, 3885, '\P{^Is_Numeric_Value=2.500}', "");
    Error('\p{Is_Nv=:=+0005/02}');
    Error('\P{Is_Nv=:=+0005/02}');
    Expect(1, 3884, '\p{Is_Nv=000005/2}', "");
    Expect(0, 3884, '\p{^Is_Nv=000005/2}', "");
    Expect(0, 3884, '\P{Is_Nv=000005/2}', "");
    Expect(1, 3884, '\P{^Is_Nv=000005/2}', "");
    Expect(0, 3885, '\p{Is_Nv=000005/2}', "");
    Expect(1, 3885, '\p{^Is_Nv=000005/2}', "");
    Expect(1, 3885, '\P{Is_Nv=000005/2}', "");
    Expect(0, 3885, '\P{^Is_Nv=000005/2}', "");
    Expect(1, 3884, '\p{Is_Nv=2.500}', "");
    Expect(0, 3884, '\p{^Is_Nv=2.500}', "");
    Expect(0, 3884, '\P{Is_Nv=2.500}', "");
    Expect(1, 3884, '\P{^Is_Nv=2.500}', "");
    Expect(0, 3885, '\p{Is_Nv=2.500}', "");
    Expect(1, 3885, '\p{^Is_Nv=2.500}', "");
    Expect(1, 3885, '\P{Is_Nv=2.500}', "");
    Expect(0, 3885, '\P{^Is_Nv=2.500}', "");
    Error('\p{Numeric_Value=--+0005/0000000006/a/}');
    Error('\P{Numeric_Value=--+0005/0000000006/a/}');
    Expect(1, 74844, '\p{Numeric_Value=00000005/000006}', "");
    Expect(0, 74844, '\p{^Numeric_Value=00000005/000006}', "");
    Expect(0, 74844, '\P{Numeric_Value=00000005/000006}', "");
    Expect(1, 74844, '\P{^Numeric_Value=00000005/000006}', "");
    Expect(0, 74845, '\p{Numeric_Value=00000005/000006}', "");
    Expect(1, 74845, '\p{^Numeric_Value=00000005/000006}', "");
    Expect(1, 74845, '\P{Numeric_Value=00000005/000006}', "");
    Expect(0, 74845, '\P{^Numeric_Value=00000005/000006}', "");
    Error('\p{Numeric_Value=0.83}');
    Error('\P{Numeric_Value=0.83}');
    Expect(1, 74844, '\p{Numeric_Value=0.833}', "");
    Expect(0, 74844, '\p{^Numeric_Value=0.833}', "");
    Expect(0, 74844, '\P{Numeric_Value=0.833}', "");
    Expect(1, 74844, '\P{^Numeric_Value=0.833}', "");
    Expect(0, 74845, '\p{Numeric_Value=0.833}', "");
    Expect(1, 74845, '\p{^Numeric_Value=0.833}', "");
    Expect(1, 74845, '\P{Numeric_Value=0.833}', "");
    Expect(0, 74845, '\P{^Numeric_Value=0.833}', "");
    Error('\p{Nv=/a/	+000005/006}');
    Error('\P{Nv=/a/	+000005/006}');
    Expect(1, 74844, '\p{Nv=+0000005/0000006}', "");
    Expect(0, 74844, '\p{^Nv=+0000005/0000006}', "");
    Expect(0, 74844, '\P{Nv=+0000005/0000006}', "");
    Expect(1, 74844, '\P{^Nv=+0000005/0000006}', "");
    Expect(0, 74845, '\p{Nv=+0000005/0000006}', "");
    Expect(1, 74845, '\p{^Nv=+0000005/0000006}', "");
    Expect(1, 74845, '\P{Nv=+0000005/0000006}', "");
    Expect(0, 74845, '\P{^Nv=+0000005/0000006}', "");
    Error('\p{Nv=0.83}');
    Error('\P{Nv=0.83}');
    Expect(1, 74844, '\p{Nv=0.833}', "");
    Expect(0, 74844, '\p{^Nv=0.833}', "");
    Expect(0, 74844, '\P{Nv=0.833}', "");
    Expect(1, 74844, '\P{^Nv=0.833}', "");
    Expect(0, 74845, '\p{Nv=0.833}', "");
    Expect(1, 74845, '\p{^Nv=0.833}', "");
    Expect(1, 74845, '\P{Nv=0.833}', "");
    Expect(0, 74845, '\P{^Nv=0.833}', "");
    Error('\p{Is_Numeric_Value:   	/a/05/00000006}');
    Error('\P{Is_Numeric_Value:   	/a/05/00000006}');
    Expect(1, 74844, '\p{Is_Numeric_Value=0000000005/06}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value=0000000005/06}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value=0000000005/06}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value=0000000005/06}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value=0000000005/06}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value=0000000005/06}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value=0000000005/06}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value=0000000005/06}', "");
    Error('\p{Is_Numeric_Value:   0.83}');
    Error('\P{Is_Numeric_Value:   0.83}');
    Expect(1, 74844, '\p{Is_Numeric_Value: 0.833}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value: 0.833}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value: 0.833}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value: 0.833}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value: 0.833}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value: 0.833}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value: 0.833}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value: 0.833}', "");
    Error('\p{Is_Nv=:=__00000005/6}');
    Error('\P{Is_Nv=:=__00000005/6}');
    Expect(1, 74844, '\p{Is_Nv:   5/0000000006}', "");
    Expect(0, 74844, '\p{^Is_Nv:   5/0000000006}', "");
    Expect(0, 74844, '\P{Is_Nv:   5/0000000006}', "");
    Expect(1, 74844, '\P{^Is_Nv:   5/0000000006}', "");
    Expect(0, 74845, '\p{Is_Nv:   5/0000000006}', "");
    Expect(1, 74845, '\p{^Is_Nv:   5/0000000006}', "");
    Expect(1, 74845, '\P{Is_Nv:   5/0000000006}', "");
    Expect(0, 74845, '\P{^Is_Nv:   5/0000000006}', "");
    Error('\p{Is_Nv=0.83}');
    Error('\P{Is_Nv=0.83}');
    Expect(1, 74844, '\p{Is_Nv=0.833}', "");
    Expect(0, 74844, '\p{^Is_Nv=0.833}', "");
    Expect(0, 74844, '\P{Is_Nv=0.833}', "");
    Expect(1, 74844, '\P{^Is_Nv=0.833}', "");
    Expect(0, 74845, '\p{Is_Nv=0.833}', "");
    Expect(1, 74845, '\p{^Is_Nv=0.833}', "");
    Expect(1, 74845, '\P{Is_Nv=0.833}', "");
    Expect(0, 74845, '\P{^Is_Nv=0.833}', "");
    Error('\p{Numeric_Value=_:=+0000005/008}');
    Error('\P{Numeric_Value=_:=+0000005/008}');
    Expect(1, 8541, '\p{Numeric_Value=0000005/00000008}', "");
    Expect(0, 8541, '\p{^Numeric_Value=0000005/00000008}', "");
    Expect(0, 8541, '\P{Numeric_Value=0000005/00000008}', "");
    Expect(1, 8541, '\P{^Numeric_Value=0000005/00000008}', "");
    Expect(0, 8542, '\p{Numeric_Value=0000005/00000008}', "");
    Expect(1, 8542, '\p{^Numeric_Value=0000005/00000008}', "");
    Expect(1, 8542, '\P{Numeric_Value=0000005/00000008}', "");
    Expect(0, 8542, '\P{^Numeric_Value=0000005/00000008}', "");
    Error('\p{Numeric_Value=0.62}');
    Error('\P{Numeric_Value=0.62}');
    Expect(1, 8541, '\p{Numeric_Value=0.625}', "");
    Expect(0, 8541, '\p{^Numeric_Value=0.625}', "");
    Expect(0, 8541, '\P{Numeric_Value=0.625}', "");
    Expect(1, 8541, '\P{^Numeric_Value=0.625}', "");
    Expect(0, 8542, '\p{Numeric_Value=0.625}', "");
    Expect(1, 8542, '\p{^Numeric_Value=0.625}', "");
    Expect(1, 8542, '\P{Numeric_Value=0.625}', "");
    Expect(0, 8542, '\P{^Numeric_Value=0.625}', "");
    Error('\p{Nv=/a/00005/0000008}');
    Error('\P{Nv=/a/00005/0000008}');
    Expect(1, 8541, '\p{Nv=+0000005/00008}', "");
    Expect(0, 8541, '\p{^Nv=+0000005/00008}', "");
    Expect(0, 8541, '\P{Nv=+0000005/00008}', "");
    Expect(1, 8541, '\P{^Nv=+0000005/00008}', "");
    Expect(0, 8542, '\p{Nv=+0000005/00008}', "");
    Expect(1, 8542, '\p{^Nv=+0000005/00008}', "");
    Expect(1, 8542, '\P{Nv=+0000005/00008}', "");
    Expect(0, 8542, '\P{^Nv=+0000005/00008}', "");
    Error('\p{Nv=0.62}');
    Error('\P{Nv=0.62}');
    Expect(1, 8541, '\p{Nv=0.625}', "");
    Expect(0, 8541, '\p{^Nv=0.625}', "");
    Expect(0, 8541, '\P{Nv=0.625}', "");
    Expect(1, 8541, '\P{^Nv=0.625}', "");
    Expect(0, 8542, '\p{Nv=0.625}', "");
    Expect(1, 8542, '\p{^Nv=0.625}', "");
    Expect(1, 8542, '\P{Nv=0.625}', "");
    Expect(0, 8542, '\P{^Nv=0.625}', "");
    Error('\p{Is_Numeric_Value=/a/__+00005/08}');
    Error('\P{Is_Numeric_Value=/a/__+00005/08}');
    Expect(1, 8541, '\p{Is_Numeric_Value:	0000005/00008}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value:	0000005/00008}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value:	0000005/00008}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value:	0000005/00008}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value:	0000005/00008}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value:	0000005/00008}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value:	0000005/00008}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value:	0000005/00008}', "");
    Error('\p{Is_Numeric_Value=0.62}');
    Error('\P{Is_Numeric_Value=0.62}');
    Expect(1, 8541, '\p{Is_Numeric_Value=0.625}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value=0.625}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value=0.625}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value=0.625}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value=0.625}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value=0.625}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value=0.625}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value=0.625}', "");
    Error('\p{Is_Nv=_-000005/0008:=}');
    Error('\P{Is_Nv=_-000005/0008:=}');
    Expect(1, 8541, '\p{Is_Nv=00000005/0000008}', "");
    Expect(0, 8541, '\p{^Is_Nv=00000005/0000008}', "");
    Expect(0, 8541, '\P{Is_Nv=00000005/0000008}', "");
    Expect(1, 8541, '\P{^Is_Nv=00000005/0000008}', "");
    Expect(0, 8542, '\p{Is_Nv=00000005/0000008}', "");
    Expect(1, 8542, '\p{^Is_Nv=00000005/0000008}', "");
    Expect(1, 8542, '\P{Is_Nv=00000005/0000008}', "");
    Expect(0, 8542, '\P{^Is_Nv=00000005/0000008}', "");
    Error('\p{Is_Nv=0.62}');
    Error('\P{Is_Nv=0.62}');
    Expect(1, 8541, '\p{Is_Nv=0.625}', "");
    Expect(0, 8541, '\p{^Is_Nv=0.625}', "");
    Expect(0, 8541, '\P{Is_Nv=0.625}', "");
    Expect(1, 8541, '\P{^Is_Nv=0.625}', "");
    Expect(0, 8542, '\p{Is_Nv=0.625}', "");
    Expect(1, 8542, '\p{^Is_Nv=0.625}', "");
    Expect(1, 8542, '\P{Is_Nv=0.625}', "");
    Expect(0, 8542, '\P{^Is_Nv=0.625}', "");
    Error('\p{Numeric_Value=/a/	 +00_00_05_0}');
    Error('\P{Numeric_Value=/a/	 +00_00_05_0}');
    Expect(1, 119661, '\p{Numeric_Value=000050}', "");
    Expect(0, 119661, '\p{^Numeric_Value=000050}', "");
    Expect(0, 119661, '\P{Numeric_Value=000050}', "");
    Expect(1, 119661, '\P{^Numeric_Value=000050}', "");
    Expect(0, 119662, '\p{Numeric_Value=000050}', "");
    Expect(1, 119662, '\p{^Numeric_Value=000050}', "");
    Expect(1, 119662, '\P{Numeric_Value=000050}', "");
    Expect(0, 119662, '\P{^Numeric_Value=000050}', "");
    Error('\p{Nv=		0050/a/}');
    Error('\P{Nv=		0050/a/}');
    Expect(1, 119661, '\p{Nv:50}', "");
    Expect(0, 119661, '\p{^Nv:50}', "");
    Expect(0, 119661, '\P{Nv:50}', "");
    Expect(1, 119661, '\P{^Nv:50}', "");
    Expect(0, 119662, '\p{Nv:50}', "");
    Expect(1, 119662, '\p{^Nv:50}', "");
    Expect(1, 119662, '\P{Nv:50}', "");
    Expect(0, 119662, '\P{^Nv:50}', "");
    Error('\p{Is_Numeric_Value= /a/+00_00_05_0}');
    Error('\P{Is_Numeric_Value= /a/+00_00_05_0}');
    Expect(1, 119661, '\p{Is_Numeric_Value=000000050}', "");
    Expect(0, 119661, '\p{^Is_Numeric_Value=000000050}', "");
    Expect(0, 119661, '\P{Is_Numeric_Value=000000050}', "");
    Expect(1, 119661, '\P{^Is_Numeric_Value=000000050}', "");
    Expect(0, 119662, '\p{Is_Numeric_Value=000000050}', "");
    Expect(1, 119662, '\p{^Is_Numeric_Value=000000050}', "");
    Expect(1, 119662, '\P{Is_Numeric_Value=000000050}', "");
    Expect(0, 119662, '\P{^Is_Numeric_Value=000000050}', "");
    Error('\p{Is_Nv=__50:=}');
    Error('\P{Is_Nv=__50:=}');
    Expect(1, 119661, '\p{Is_Nv=00_05_0}', "");
    Expect(0, 119661, '\p{^Is_Nv=00_05_0}', "");
    Expect(0, 119661, '\P{Is_Nv=00_05_0}', "");
    Expect(1, 119661, '\P{^Is_Nv=00_05_0}', "");
    Expect(0, 119662, '\p{Is_Nv=00_05_0}', "");
    Expect(1, 119662, '\p{^Is_Nv=00_05_0}', "");
    Expect(1, 119662, '\P{Is_Nv=00_05_0}', "");
    Expect(0, 119662, '\P{^Is_Nv=00_05_0}', "");
    Error('\p{Numeric_Value=/a/__00000000500}');
    Error('\P{Numeric_Value=/a/__00000000500}');
    Expect(1, 69238, '\p{Numeric_Value=000000000500}', "");
    Expect(0, 69238, '\p{^Numeric_Value=000000000500}', "");
    Expect(0, 69238, '\P{Numeric_Value=000000000500}', "");
    Expect(1, 69238, '\P{^Numeric_Value=000000000500}', "");
    Expect(0, 69239, '\p{Numeric_Value=000000000500}', "");
    Expect(1, 69239, '\p{^Numeric_Value=000000000500}', "");
    Expect(1, 69239, '\P{Numeric_Value=000000000500}', "");
    Expect(0, 69239, '\P{^Numeric_Value=000000000500}', "");
    Error('\p{Nv=-+00000500/a/}');
    Error('\P{Nv=-+00000500/a/}');
    Expect(1, 69238, '\p{Nv:0000000050_0}', "");
    Expect(0, 69238, '\p{^Nv:0000000050_0}', "");
    Expect(0, 69238, '\P{Nv:0000000050_0}', "");
    Expect(1, 69238, '\P{^Nv:0000000050_0}', "");
    Expect(0, 69239, '\p{Nv:0000000050_0}', "");
    Expect(1, 69239, '\p{^Nv:0000000050_0}', "");
    Expect(1, 69239, '\P{Nv:0000000050_0}', "");
    Expect(0, 69239, '\P{^Nv:0000000050_0}', "");
    Error('\p{Is_Numeric_Value=-000500/a/}');
    Error('\P{Is_Numeric_Value=-000500/a/}');
    Expect(1, 69238, '\p{Is_Numeric_Value=000000500}', "");
    Expect(0, 69238, '\p{^Is_Numeric_Value=000000500}', "");
    Expect(0, 69238, '\P{Is_Numeric_Value=000000500}', "");
    Expect(1, 69238, '\P{^Is_Numeric_Value=000000500}', "");
    Expect(0, 69239, '\p{Is_Numeric_Value=000000500}', "");
    Expect(1, 69239, '\p{^Is_Numeric_Value=000000500}', "");
    Expect(1, 69239, '\P{Is_Numeric_Value=000000500}', "");
    Expect(0, 69239, '\P{^Is_Numeric_Value=000000500}', "");
    Error('\p{Is_Nv=:=50_0}');
    Error('\P{Is_Nv=:=50_0}');
    Expect(1, 69238, '\p{Is_Nv=0500}', "");
    Expect(0, 69238, '\p{^Is_Nv=0500}', "");
    Expect(0, 69238, '\P{Is_Nv=0500}', "");
    Expect(1, 69238, '\P{^Is_Nv=0500}', "");
    Expect(0, 69239, '\p{Is_Nv=0500}', "");
    Expect(1, 69239, '\p{^Is_Nv=0500}', "");
    Expect(1, 69239, '\P{Is_Nv=0500}', "");
    Expect(0, 69239, '\P{^Is_Nv=0500}', "");
    Error('\p{Numeric_Value=/a/	 000_500_0}');
    Error('\P{Numeric_Value=/a/	 000_500_0}');
    Expect(1, 68063, '\p{Numeric_Value=0_0_0_0_0_0_0_0_0_5_0_00}', "");
    Expect(0, 68063, '\p{^Numeric_Value=0_0_0_0_0_0_0_0_0_5_0_00}', "");
    Expect(0, 68063, '\P{Numeric_Value=0_0_0_0_0_0_0_0_0_5_0_00}', "");
    Expect(1, 68063, '\P{^Numeric_Value=0_0_0_0_0_0_0_0_0_5_0_00}', "");
    Expect(0, 68064, '\p{Numeric_Value=0_0_0_0_0_0_0_0_0_5_0_00}', "");
    Expect(1, 68064, '\p{^Numeric_Value=0_0_0_0_0_0_0_0_0_5_0_00}', "");
    Expect(1, 68064, '\P{Numeric_Value=0_0_0_0_0_0_0_0_0_5_0_00}', "");
    Expect(0, 68064, '\P{^Numeric_Value=0_0_0_0_0_0_0_0_0_5_0_00}', "");
    Error('\p{Nv=_:=000005000}');
    Error('\P{Nv=_:=000005000}');
    Expect(1, 68063, '\p{Nv=+0_0_0_0_0_0_0_005000}', "");
    Expect(0, 68063, '\p{^Nv=+0_0_0_0_0_0_0_005000}', "");
    Expect(0, 68063, '\P{Nv=+0_0_0_0_0_0_0_005000}', "");
    Expect(1, 68063, '\P{^Nv=+0_0_0_0_0_0_0_005000}', "");
    Expect(0, 68064, '\p{Nv=+0_0_0_0_0_0_0_005000}', "");
    Expect(1, 68064, '\p{^Nv=+0_0_0_0_0_0_0_005000}', "");
    Expect(1, 68064, '\P{Nv=+0_0_0_0_0_0_0_005000}', "");
    Expect(0, 68064, '\P{^Nv=+0_0_0_0_0_0_0_005000}', "");
    Error('\p{Is_Numeric_Value=/a/		0_0_0_0_0_0_5000}');
    Error('\P{Is_Numeric_Value=/a/		0_0_0_0_0_0_5000}');
    Expect(1, 68063, '\p{Is_Numeric_Value=0_0_0_0_0_0_0_5000}', "");
    Expect(0, 68063, '\p{^Is_Numeric_Value=0_0_0_0_0_0_0_5000}', "");
    Expect(0, 68063, '\P{Is_Numeric_Value=0_0_0_0_0_0_0_5000}', "");
    Expect(1, 68063, '\P{^Is_Numeric_Value=0_0_0_0_0_0_0_5000}', "");
    Expect(0, 68064, '\p{Is_Numeric_Value=0_0_0_0_0_0_0_5000}', "");
    Expect(1, 68064, '\p{^Is_Numeric_Value=0_0_0_0_0_0_0_5000}', "");
    Expect(1, 68064, '\P{Is_Numeric_Value=0_0_0_0_0_0_0_5000}', "");
    Expect(0, 68064, '\P{^Is_Numeric_Value=0_0_0_0_0_0_0_5000}', "");
    Error('\p{Is_Nv=	+0_0_0_0_0_0_0_0_0_5_0_00:=}');
    Error('\P{Is_Nv=	+0_0_0_0_0_0_0_0_0_5_0_00:=}');
    Expect(1, 68063, '\p{Is_Nv=05000}', "");
    Expect(0, 68063, '\p{^Is_Nv=05000}', "");
    Expect(0, 68063, '\P{Is_Nv=05000}', "");
    Expect(1, 68063, '\P{^Is_Nv=05000}', "");
    Expect(0, 68064, '\p{Is_Nv=05000}', "");
    Expect(1, 68064, '\p{^Is_Nv=05000}', "");
    Expect(1, 68064, '\P{Is_Nv=05000}', "");
    Expect(0, 68064, '\P{^Is_Nv=05000}', "");
    Error('\p{Numeric_Value=_:=0_0_0_0_0_0_0_5_0_000}');
    Error('\P{Numeric_Value=_:=0_0_0_0_0_0_0_5_0_000}');
    Expect(1, 68072, '\p{Numeric_Value=+000050000}', "");
    Expect(0, 68072, '\p{^Numeric_Value=+000050000}', "");
    Expect(0, 68072, '\P{Numeric_Value=+000050000}', "");
    Expect(1, 68072, '\P{^Numeric_Value=+000050000}', "");
    Expect(0, 68073, '\p{Numeric_Value=+000050000}', "");
    Expect(1, 68073, '\p{^Numeric_Value=+000050000}', "");
    Expect(1, 68073, '\P{Numeric_Value=+000050000}', "");
    Expect(0, 68073, '\P{^Numeric_Value=+000050000}', "");
    Error('\p{Nv=/a/+00_00_00_50_00_0}');
    Error('\P{Nv=/a/+00_00_00_50_00_0}');
    Expect(1, 68072, '\p{Nv=50000}', "");
    Expect(0, 68072, '\p{^Nv=50000}', "");
    Expect(0, 68072, '\P{Nv=50000}', "");
    Expect(1, 68072, '\P{^Nv=50000}', "");
    Expect(0, 68073, '\p{Nv=50000}', "");
    Expect(1, 68073, '\p{^Nv=50000}', "");
    Expect(1, 68073, '\P{Nv=50000}', "");
    Expect(0, 68073, '\P{^Nv=50000}', "");
    Error('\p{Is_Numeric_Value=-/a/0_0_0_0_0_5_0_0_00}');
    Error('\P{Is_Numeric_Value=-/a/0_0_0_0_0_5_0_0_00}');
    Expect(1, 68072, '\p{Is_Numeric_Value=00000050000}', "");
    Expect(0, 68072, '\p{^Is_Numeric_Value=00000050000}', "");
    Expect(0, 68072, '\P{Is_Numeric_Value=00000050000}', "");
    Expect(1, 68072, '\P{^Is_Numeric_Value=00000050000}', "");
    Expect(0, 68073, '\p{Is_Numeric_Value=00000050000}', "");
    Expect(1, 68073, '\p{^Is_Numeric_Value=00000050000}', "");
    Expect(1, 68073, '\P{Is_Numeric_Value=00000050000}', "");
    Expect(0, 68073, '\P{^Is_Numeric_Value=00000050000}', "");
    Error('\p{Is_Nv: --0_0_0_0_0_0_0_0_0_5_0_0_00/a/}');
    Error('\P{Is_Nv: --0_0_0_0_0_0_0_0_0_5_0_0_00/a/}');
    Expect(1, 68072, '\p{Is_Nv=00050000}', "");
    Expect(0, 68072, '\p{^Is_Nv=00050000}', "");
    Expect(0, 68072, '\P{Is_Nv=00050000}', "");
    Expect(1, 68072, '\P{^Is_Nv=00050000}', "");
    Expect(0, 68073, '\p{Is_Nv=00050000}', "");
    Expect(1, 68073, '\p{^Is_Nv=00050000}', "");
    Expect(1, 68073, '\P{Is_Nv=00050000}', "");
    Expect(0, 68073, '\P{^Is_Nv=00050000}', "");
    Error('\p{Numeric_Value=__00000500000/a/}');
    Error('\P{Numeric_Value=__00000500000/a/}');
    Expect(1, 68081, '\p{Numeric_Value=+500000}', "");
    Expect(0, 68081, '\p{^Numeric_Value=+500000}', "");
    Expect(0, 68081, '\P{Numeric_Value=+500000}', "");
    Expect(1, 68081, '\P{^Numeric_Value=+500000}', "");
    Expect(0, 68082, '\p{Numeric_Value=+500000}', "");
    Expect(1, 68082, '\p{^Numeric_Value=+500000}', "");
    Expect(1, 68082, '\P{Numeric_Value=+500000}', "");
    Expect(0, 68082, '\P{^Numeric_Value=+500000}', "");
    Error('\p{Nv=/a/	 00000500000}');
    Error('\P{Nv=/a/	 00000500000}');
    Expect(1, 68081, '\p{Nv=+5_0_0_0_00}', "");
    Expect(0, 68081, '\p{^Nv=+5_0_0_0_00}', "");
    Expect(0, 68081, '\P{Nv=+5_0_0_0_00}', "");
    Expect(1, 68081, '\P{^Nv=+5_0_0_0_00}', "");
    Expect(0, 68082, '\p{Nv=+5_0_0_0_00}', "");
    Expect(1, 68082, '\p{^Nv=+5_0_0_0_00}', "");
    Expect(1, 68082, '\P{Nv=+5_0_0_0_00}', "");
    Expect(0, 68082, '\P{^Nv=+5_0_0_0_00}', "");
    Error('\p{Is_Numeric_Value=:=-_00050000_0}');
    Error('\P{Is_Numeric_Value=:=-_00050000_0}');
    Expect(1, 68081, '\p{Is_Numeric_Value=000000050000_0}', "");
    Expect(0, 68081, '\p{^Is_Numeric_Value=000000050000_0}', "");
    Expect(0, 68081, '\P{Is_Numeric_Value=000000050000_0}', "");
    Expect(1, 68081, '\P{^Is_Numeric_Value=000000050000_0}', "");
    Expect(0, 68082, '\p{Is_Numeric_Value=000000050000_0}', "");
    Expect(1, 68082, '\p{^Is_Numeric_Value=000000050000_0}', "");
    Expect(1, 68082, '\P{Is_Numeric_Value=000000050000_0}', "");
    Expect(0, 68082, '\P{^Is_Numeric_Value=000000050000_0}', "");
    Error('\p{Is_Nv=--0_0_0_0_5_0_0_0_00:=}');
    Error('\P{Is_Nv=--0_0_0_0_5_0_0_0_00:=}');
    Expect(1, 68081, '\p{Is_Nv=0_0_5_0_0_0_00}', "");
    Expect(0, 68081, '\p{^Is_Nv=0_0_5_0_0_0_00}', "");
    Expect(0, 68081, '\P{Is_Nv=0_0_5_0_0_0_00}', "");
    Expect(1, 68081, '\P{^Is_Nv=0_0_5_0_0_0_00}', "");
    Expect(0, 68082, '\p{Is_Nv=0_0_5_0_0_0_00}', "");
    Expect(1, 68082, '\p{^Is_Nv=0_0_5_0_0_0_00}', "");
    Expect(1, 68082, '\P{Is_Nv=0_0_5_0_0_0_00}', "");
    Expect(0, 68082, '\P{^Is_Nv=0_0_5_0_0_0_00}', "");
    Error('\p{Numeric_Value= +6:=}');
    Error('\P{Numeric_Value= +6:=}');
    Expect(1, 133866, '\p{Numeric_Value=000000000_6}', "");
    Expect(0, 133866, '\p{^Numeric_Value=000000000_6}', "");
    Expect(0, 133866, '\P{Numeric_Value=000000000_6}', "");
    Expect(1, 133866, '\P{^Numeric_Value=000000000_6}', "");
    Expect(0, 133867, '\p{Numeric_Value=000000000_6}', "");
    Expect(1, 133867, '\p{^Numeric_Value=000000000_6}', "");
    Expect(1, 133867, '\P{Numeric_Value=000000000_6}', "");
    Expect(0, 133867, '\P{^Numeric_Value=000000000_6}', "");
    Error('\p{Nv:+0006:=}');
    Error('\P{Nv:+0006:=}');
    Expect(1, 133866, '\p{Nv=00000_6}', "");
    Expect(0, 133866, '\p{^Nv=00000_6}', "");
    Expect(0, 133866, '\P{Nv=00000_6}', "");
    Expect(1, 133866, '\P{^Nv=00000_6}', "");
    Expect(0, 133867, '\p{Nv=00000_6}', "");
    Expect(1, 133867, '\p{^Nv=00000_6}', "");
    Expect(1, 133867, '\P{Nv=00000_6}', "");
    Expect(0, 133867, '\P{^Nv=00000_6}', "");
    Error('\p{Is_Numeric_Value=/a/006}');
    Error('\P{Is_Numeric_Value=/a/006}');
    Expect(1, 133866, '\p{Is_Numeric_Value=+00000006}', "");
    Expect(0, 133866, '\p{^Is_Numeric_Value=+00000006}', "");
    Expect(0, 133866, '\P{Is_Numeric_Value=+00000006}', "");
    Expect(1, 133866, '\P{^Is_Numeric_Value=+00000006}', "");
    Expect(0, 133867, '\p{Is_Numeric_Value=+00000006}', "");
    Expect(1, 133867, '\p{^Is_Numeric_Value=+00000006}', "");
    Expect(1, 133867, '\P{Is_Numeric_Value=+00000006}', "");
    Expect(0, 133867, '\P{^Is_Numeric_Value=+00000006}', "");
    Error('\p{Is_Nv= :=6}');
    Error('\P{Is_Nv= :=6}');
    Expect(1, 133866, '\p{Is_Nv=+0_6}', "");
    Expect(0, 133866, '\p{^Is_Nv=+0_6}', "");
    Expect(0, 133866, '\P{Is_Nv=+0_6}', "");
    Expect(1, 133866, '\P{^Is_Nv=+0_6}', "");
    Expect(0, 133867, '\p{Is_Nv=+0_6}', "");
    Expect(1, 133867, '\p{^Is_Nv=+0_6}', "");
    Expect(1, 133867, '\P{Is_Nv=+0_6}', "");
    Expect(0, 133867, '\P{^Is_Nv=+0_6}', "");
    Error('\p{Numeric_Value=/a/ _06_0}');
    Error('\P{Numeric_Value=/a/ _06_0}');
    Expect(1, 119662, '\p{Numeric_Value=006_0}', "");
    Expect(0, 119662, '\p{^Numeric_Value=006_0}', "");
    Expect(0, 119662, '\P{Numeric_Value=006_0}', "");
    Expect(1, 119662, '\P{^Numeric_Value=006_0}', "");
    Expect(0, 119663, '\p{Numeric_Value=006_0}', "");
    Expect(1, 119663, '\p{^Numeric_Value=006_0}', "");
    Expect(1, 119663, '\P{Numeric_Value=006_0}', "");
    Expect(0, 119663, '\P{^Numeric_Value=006_0}', "");
    Error('\p{Nv= /a/0000000060}');
    Error('\P{Nv= /a/0000000060}');
    Expect(1, 119662, '\p{Nv=+06_0}', "");
    Expect(0, 119662, '\p{^Nv=+06_0}', "");
    Expect(0, 119662, '\P{Nv=+06_0}', "");
    Expect(1, 119662, '\P{^Nv=+06_0}', "");
    Expect(0, 119663, '\p{Nv=+06_0}', "");
    Expect(1, 119663, '\p{^Nv=+06_0}', "");
    Expect(1, 119663, '\P{Nv=+06_0}', "");
    Expect(0, 119663, '\P{^Nv=+06_0}', "");
    Error('\p{Is_Numeric_Value=	/a/0000000006_0}');
    Error('\P{Is_Numeric_Value=	/a/0000000006_0}');
    Expect(1, 119662, '\p{Is_Numeric_Value=006_0}', "");
    Expect(0, 119662, '\p{^Is_Numeric_Value=006_0}', "");
    Expect(0, 119662, '\P{Is_Numeric_Value=006_0}', "");
    Expect(1, 119662, '\P{^Is_Numeric_Value=006_0}', "");
    Expect(0, 119663, '\p{Is_Numeric_Value=006_0}', "");
    Expect(1, 119663, '\p{^Is_Numeric_Value=006_0}', "");
    Expect(1, 119663, '\P{Is_Numeric_Value=006_0}', "");
    Expect(0, 119663, '\P{^Is_Numeric_Value=006_0}', "");
    Error('\p{Is_Nv=_:=+000060}');
    Error('\P{Is_Nv=_:=+000060}');
    Expect(1, 119662, '\p{Is_Nv=060}', "");
    Expect(0, 119662, '\p{^Is_Nv=060}', "");
    Expect(0, 119662, '\P{Is_Nv=060}', "");
    Expect(1, 119662, '\P{^Is_Nv=060}', "");
    Expect(0, 119663, '\p{Is_Nv=060}', "");
    Expect(1, 119663, '\p{^Is_Nv=060}', "");
    Expect(1, 119663, '\P{Is_Nv=060}', "");
    Expect(0, 119663, '\P{^Is_Nv=060}', "");
    Error('\p{Numeric_Value=	/a/+0000000600}');
    Error('\P{Numeric_Value=	/a/+0000000600}');
    Expect(1, 69239, '\p{Numeric_Value=600}', "");
    Expect(0, 69239, '\p{^Numeric_Value=600}', "");
    Expect(0, 69239, '\P{Numeric_Value=600}', "");
    Expect(1, 69239, '\P{^Numeric_Value=600}', "");
    Expect(0, 69240, '\p{Numeric_Value=600}', "");
    Expect(1, 69240, '\p{^Numeric_Value=600}', "");
    Expect(1, 69240, '\P{Numeric_Value=600}', "");
    Expect(0, 69240, '\P{^Numeric_Value=600}', "");
    Error('\p{Nv= :=+0000000600}');
    Error('\P{Nv= :=+0000000600}');
    Expect(1, 69239, '\p{Nv=+00600}', "");
    Expect(0, 69239, '\p{^Nv=+00600}', "");
    Expect(0, 69239, '\P{Nv=+00600}', "");
    Expect(1, 69239, '\P{^Nv=+00600}', "");
    Expect(0, 69240, '\p{Nv=+00600}', "");
    Expect(1, 69240, '\p{^Nv=+00600}', "");
    Expect(1, 69240, '\P{Nv=+00600}', "");
    Expect(0, 69240, '\P{^Nv=+00600}', "");
    Error('\p{Is_Numeric_Value=/a/_ +0600}');
    Error('\P{Is_Numeric_Value=/a/_ +0600}');
    Expect(1, 69239, '\p{Is_Numeric_Value=000000000600}', "");
    Expect(0, 69239, '\p{^Is_Numeric_Value=000000000600}', "");
    Expect(0, 69239, '\P{Is_Numeric_Value=000000000600}', "");
    Expect(1, 69239, '\P{^Is_Numeric_Value=000000000600}', "");
    Expect(0, 69240, '\p{Is_Numeric_Value=000000000600}', "");
    Expect(1, 69240, '\p{^Is_Numeric_Value=000000000600}', "");
    Expect(1, 69240, '\P{Is_Numeric_Value=000000000600}', "");
    Expect(0, 69240, '\P{^Is_Numeric_Value=000000000600}', "");
    Error('\p{Is_Nv:   --00000600/a/}');
    Error('\P{Is_Nv:   --00000600/a/}');
    Expect(1, 69239, '\p{Is_Nv=0_0_0_0_600}', "");
    Expect(0, 69239, '\p{^Is_Nv=0_0_0_0_600}', "");
    Expect(0, 69239, '\P{Is_Nv=0_0_0_0_600}', "");
    Expect(1, 69239, '\P{^Is_Nv=0_0_0_0_600}', "");
    Expect(0, 69240, '\p{Is_Nv=0_0_0_0_600}', "");
    Expect(1, 69240, '\p{^Is_Nv=0_0_0_0_600}', "");
    Expect(1, 69240, '\P{Is_Nv=0_0_0_0_600}', "");
    Expect(0, 69240, '\P{^Is_Nv=0_0_0_0_600}', "");
    Error('\p{Numeric_Value=:=0_0_0_0_0_0_6000}');
    Error('\P{Numeric_Value=:=0_0_0_0_0_0_6000}');
    Expect(1, 68064, '\p{Numeric_Value=+00_60_00}', "");
    Expect(0, 68064, '\p{^Numeric_Value=+00_60_00}', "");
    Expect(0, 68064, '\P{Numeric_Value=+00_60_00}', "");
    Expect(1, 68064, '\P{^Numeric_Value=+00_60_00}', "");
    Expect(0, 68065, '\p{Numeric_Value=+00_60_00}', "");
    Expect(1, 68065, '\p{^Numeric_Value=+00_60_00}', "");
    Expect(1, 68065, '\P{Numeric_Value=+00_60_00}', "");
    Expect(0, 68065, '\P{^Numeric_Value=+00_60_00}', "");
    Error('\p{Nv= 	006000:=}');
    Error('\P{Nv= 	006000:=}');
    Expect(1, 68064, '\p{Nv:   600_0}', "");
    Expect(0, 68064, '\p{^Nv:   600_0}', "");
    Expect(0, 68064, '\P{Nv:   600_0}', "");
    Expect(1, 68064, '\P{^Nv:   600_0}', "");
    Expect(0, 68065, '\p{Nv:   600_0}', "");
    Expect(1, 68065, '\p{^Nv:   600_0}', "");
    Expect(1, 68065, '\P{Nv:   600_0}', "");
    Expect(0, 68065, '\P{^Nv:   600_0}', "");
    Error('\p{Is_Numeric_Value=-/a/00_60_00}');
    Error('\P{Is_Numeric_Value=-/a/00_60_00}');
    Expect(1, 68064, '\p{Is_Numeric_Value=000006000}', "");
    Expect(0, 68064, '\p{^Is_Numeric_Value=000006000}', "");
    Expect(0, 68064, '\P{Is_Numeric_Value=000006000}', "");
    Expect(1, 68064, '\P{^Is_Numeric_Value=000006000}', "");
    Expect(0, 68065, '\p{Is_Numeric_Value=000006000}', "");
    Expect(1, 68065, '\p{^Is_Numeric_Value=000006000}', "");
    Expect(1, 68065, '\P{Is_Numeric_Value=000006000}', "");
    Expect(0, 68065, '\P{^Is_Numeric_Value=000006000}', "");
    Error('\p{Is_Nv= /a/0_0_0_0_0_0_0_6000}');
    Error('\P{Is_Nv= /a/0_0_0_0_0_0_0_6000}');
    Expect(1, 68064, '\p{Is_Nv=000_600_0}', "");
    Expect(0, 68064, '\p{^Is_Nv=000_600_0}', "");
    Expect(0, 68064, '\P{Is_Nv=000_600_0}', "");
    Expect(1, 68064, '\P{^Is_Nv=000_600_0}', "");
    Expect(0, 68065, '\p{Is_Nv=000_600_0}', "");
    Expect(1, 68065, '\p{^Is_Nv=000_600_0}', "");
    Expect(1, 68065, '\P{Is_Nv=000_600_0}', "");
    Expect(0, 68065, '\P{^Is_Nv=000_600_0}', "");
    Error('\p{Numeric_Value=_6000_0/a/}');
    Error('\P{Numeric_Value=_6000_0/a/}');
    Expect(1, 68073, '\p{Numeric_Value=00060000}', "");
    Expect(0, 68073, '\p{^Numeric_Value=00060000}', "");
    Expect(0, 68073, '\P{Numeric_Value=00060000}', "");
    Expect(1, 68073, '\P{^Numeric_Value=00060000}', "");
    Expect(0, 68074, '\p{Numeric_Value=00060000}', "");
    Expect(1, 68074, '\p{^Numeric_Value=00060000}', "");
    Expect(1, 68074, '\P{Numeric_Value=00060000}', "");
    Expect(0, 68074, '\P{^Numeric_Value=00060000}', "");
    Error('\p{Nv=:=0000000060000}');
    Error('\P{Nv=:=0000000060000}');
    Expect(1, 68073, '\p{Nv:	00060000}', "");
    Expect(0, 68073, '\p{^Nv:	00060000}', "");
    Expect(0, 68073, '\P{Nv:	00060000}', "");
    Expect(1, 68073, '\P{^Nv:	00060000}', "");
    Expect(0, 68074, '\p{Nv:	00060000}', "");
    Expect(1, 68074, '\p{^Nv:	00060000}', "");
    Expect(1, 68074, '\P{Nv:	00060000}', "");
    Expect(0, 68074, '\P{^Nv:	00060000}', "");
    Error('\p{Is_Numeric_Value=-	006000_0/a/}');
    Error('\P{Is_Numeric_Value=-	006000_0/a/}');
    Expect(1, 68073, '\p{Is_Numeric_Value=000_600_00}', "");
    Expect(0, 68073, '\p{^Is_Numeric_Value=000_600_00}', "");
    Expect(0, 68073, '\P{Is_Numeric_Value=000_600_00}', "");
    Expect(1, 68073, '\P{^Is_Numeric_Value=000_600_00}', "");
    Expect(0, 68074, '\p{Is_Numeric_Value=000_600_00}', "");
    Expect(1, 68074, '\p{^Is_Numeric_Value=000_600_00}', "");
    Expect(1, 68074, '\P{Is_Numeric_Value=000_600_00}', "");
    Expect(0, 68074, '\P{^Is_Numeric_Value=000_600_00}', "");
    Error('\p{Is_Nv=-/a/0_6_0_000}');
    Error('\P{Is_Nv=-/a/0_6_0_000}');
    Expect(1, 68073, '\p{Is_Nv=+0_0_0_0_0_0_0_0_0_60000}', "");
    Expect(0, 68073, '\p{^Is_Nv=+0_0_0_0_0_0_0_0_0_60000}', "");
    Expect(0, 68073, '\P{Is_Nv=+0_0_0_0_0_0_0_0_0_60000}', "");
    Expect(1, 68073, '\P{^Is_Nv=+0_0_0_0_0_0_0_0_0_60000}', "");
    Expect(0, 68074, '\p{Is_Nv=+0_0_0_0_0_0_0_0_0_60000}', "");
    Expect(1, 68074, '\p{^Is_Nv=+0_0_0_0_0_0_0_0_0_60000}', "");
    Expect(1, 68074, '\P{Is_Nv=+0_0_0_0_0_0_0_0_0_60000}', "");
    Expect(0, 68074, '\P{^Is_Nv=+0_0_0_0_0_0_0_0_0_60000}', "");
    Error('\p{Numeric_Value=-	+0000000600000/a/}');
    Error('\P{Numeric_Value=-	+0000000600000/a/}');
    Expect(1, 68082, '\p{Numeric_Value=000_000_006_000_00}', "");
    Expect(0, 68082, '\p{^Numeric_Value=000_000_006_000_00}', "");
    Expect(0, 68082, '\P{Numeric_Value=000_000_006_000_00}', "");
    Expect(1, 68082, '\P{^Numeric_Value=000_000_006_000_00}', "");
    Expect(0, 68083, '\p{Numeric_Value=000_000_006_000_00}', "");
    Expect(1, 68083, '\p{^Numeric_Value=000_000_006_000_00}', "");
    Expect(1, 68083, '\P{Numeric_Value=000_000_006_000_00}', "");
    Expect(0, 68083, '\P{^Numeric_Value=000_000_006_000_00}', "");
    Error('\p{Nv=:=_+0_0_0_6_0_0_000}');
    Error('\P{Nv=:=_+0_0_0_6_0_0_000}');
    Expect(1, 68082, '\p{Nv: 000600000}', "");
    Expect(0, 68082, '\p{^Nv: 000600000}', "");
    Expect(0, 68082, '\P{Nv: 000600000}', "");
    Expect(1, 68082, '\P{^Nv: 000600000}', "");
    Expect(0, 68083, '\p{Nv: 000600000}', "");
    Expect(1, 68083, '\p{^Nv: 000600000}', "");
    Expect(1, 68083, '\P{Nv: 000600000}', "");
    Expect(0, 68083, '\P{^Nv: 000600000}', "");
    Error('\p{Is_Numeric_Value=:=		600000}');
    Error('\P{Is_Numeric_Value=:=		600000}');
    Expect(1, 68082, '\p{Is_Numeric_Value=00000000600000}', "");
    Expect(0, 68082, '\p{^Is_Numeric_Value=00000000600000}', "");
    Expect(0, 68082, '\P{Is_Numeric_Value=00000000600000}', "");
    Expect(1, 68082, '\P{^Is_Numeric_Value=00000000600000}', "");
    Expect(0, 68083, '\p{Is_Numeric_Value=00000000600000}', "");
    Expect(1, 68083, '\p{^Is_Numeric_Value=00000000600000}', "");
    Expect(1, 68083, '\P{Is_Numeric_Value=00000000600000}', "");
    Expect(0, 68083, '\P{^Is_Numeric_Value=00000000600000}', "");
    Error('\p{Is_Nv=/a/--060_000_0}');
    Error('\P{Is_Nv=/a/--060_000_0}');
    Expect(1, 68082, '\p{Is_Nv=+00600000}', "");
    Expect(0, 68082, '\p{^Is_Nv=+00600000}', "");
    Expect(0, 68082, '\P{Is_Nv=+00600000}', "");
    Expect(1, 68082, '\P{^Is_Nv=+00600000}', "");
    Expect(0, 68083, '\p{Is_Nv=+00600000}', "");
    Expect(1, 68083, '\p{^Is_Nv=+00600000}', "");
    Expect(1, 68083, '\P{Is_Nv=+00600000}', "");
    Expect(0, 68083, '\P{^Is_Nv=+00600000}', "");
    Error('\p{Numeric_Value=_:=000007}');
    Error('\P{Numeric_Value=_:=000007}');
    Expect(1, 131073, '\p{Numeric_Value=+07}', "");
    Expect(0, 131073, '\p{^Numeric_Value=+07}', "");
    Expect(0, 131073, '\P{Numeric_Value=+07}', "");
    Expect(1, 131073, '\P{^Numeric_Value=+07}', "");
    Expect(0, 131074, '\p{Numeric_Value=+07}', "");
    Expect(1, 131074, '\p{^Numeric_Value=+07}', "");
    Expect(1, 131074, '\P{Numeric_Value=+07}', "");
    Expect(0, 131074, '\P{^Numeric_Value=+07}', "");
    Error('\p{Nv= /a/+000_7}');
    Error('\P{Nv= /a/+000_7}');
    Expect(1, 131073, '\p{Nv=0_0_0_0_0_0_07}', "");
    Expect(0, 131073, '\p{^Nv=0_0_0_0_0_0_07}', "");
    Expect(0, 131073, '\P{Nv=0_0_0_0_0_0_07}', "");
    Expect(1, 131073, '\P{^Nv=0_0_0_0_0_0_07}', "");
    Expect(0, 131074, '\p{Nv=0_0_0_0_0_0_07}', "");
    Expect(1, 131074, '\p{^Nv=0_0_0_0_0_0_07}', "");
    Expect(1, 131074, '\P{Nv=0_0_0_0_0_0_07}', "");
    Expect(0, 131074, '\P{^Nv=0_0_0_0_0_0_07}', "");
    Error('\p{Is_Numeric_Value=-/a/000_000_07}');
    Error('\P{Is_Numeric_Value=-/a/000_000_07}');
    Expect(1, 131073, '\p{Is_Numeric_Value=000_000_7}', "");
    Expect(0, 131073, '\p{^Is_Numeric_Value=000_000_7}', "");
    Expect(0, 131073, '\P{Is_Numeric_Value=000_000_7}', "");
    Expect(1, 131073, '\P{^Is_Numeric_Value=000_000_7}', "");
    Expect(0, 131074, '\p{Is_Numeric_Value=000_000_7}', "");
    Expect(1, 131074, '\p{^Is_Numeric_Value=000_000_7}', "");
    Expect(1, 131074, '\P{Is_Numeric_Value=000_000_7}', "");
    Expect(0, 131074, '\P{^Is_Numeric_Value=000_000_7}', "");
    Error('\p{Is_Nv=:=		7}');
    Error('\P{Is_Nv=:=		7}');
    Expect(1, 131073, '\p{Is_Nv=0000007}', "");
    Expect(0, 131073, '\p{^Is_Nv=0000007}', "");
    Expect(0, 131073, '\P{Is_Nv=0000007}', "");
    Expect(1, 131073, '\P{^Is_Nv=0000007}', "");
    Expect(0, 131074, '\p{Is_Nv=0000007}', "");
    Expect(1, 131074, '\p{^Is_Nv=0000007}', "");
    Expect(1, 131074, '\P{Is_Nv=0000007}', "");
    Expect(0, 131074, '\P{^Is_Nv=0000007}', "");
    Error('\p{Numeric_Value=:= _+0000007/0000012}');
    Error('\P{Numeric_Value=:= _+0000007/0000012}');
    Expect(1, 68092, '\p{Numeric_Value:0007/0012}', "");
    Expect(0, 68092, '\p{^Numeric_Value:0007/0012}', "");
    Expect(0, 68092, '\P{Numeric_Value:0007/0012}', "");
    Expect(1, 68092, '\P{^Numeric_Value:0007/0012}', "");
    Expect(0, 68093, '\p{Numeric_Value:0007/0012}', "");
    Expect(1, 68093, '\p{^Numeric_Value:0007/0012}', "");
    Expect(1, 68093, '\P{Numeric_Value:0007/0012}', "");
    Expect(0, 68093, '\P{^Numeric_Value:0007/0012}', "");
    Error('\p{Numeric_Value=0.58}');
    Error('\P{Numeric_Value=0.58}');
    Expect(1, 68092, '\p{Numeric_Value=0.583}', "");
    Expect(0, 68092, '\p{^Numeric_Value=0.583}', "");
    Expect(0, 68092, '\P{Numeric_Value=0.583}', "");
    Expect(1, 68092, '\P{^Numeric_Value=0.583}', "");
    Expect(0, 68093, '\p{Numeric_Value=0.583}', "");
    Expect(1, 68093, '\p{^Numeric_Value=0.583}', "");
    Expect(1, 68093, '\P{Numeric_Value=0.583}', "");
    Expect(0, 68093, '\P{^Numeric_Value=0.583}', "");
    Error('\p{Nv=/a/__000007/0000000012}');
    Error('\P{Nv=/a/__000007/0000000012}');
    Expect(1, 68092, '\p{Nv=+07/000012}', "");
    Expect(0, 68092, '\p{^Nv=+07/000012}', "");
    Expect(0, 68092, '\P{Nv=+07/000012}', "");
    Expect(1, 68092, '\P{^Nv=+07/000012}', "");
    Expect(0, 68093, '\p{Nv=+07/000012}', "");
    Expect(1, 68093, '\p{^Nv=+07/000012}', "");
    Expect(1, 68093, '\P{Nv=+07/000012}', "");
    Expect(0, 68093, '\P{^Nv=+07/000012}', "");
    Error('\p{Nv=0.58}');
    Error('\P{Nv=0.58}');
    Expect(1, 68092, '\p{Nv=0.583}', "");
    Expect(0, 68092, '\p{^Nv=0.583}', "");
    Expect(0, 68092, '\P{Nv=0.583}', "");
    Expect(1, 68092, '\P{^Nv=0.583}', "");
    Expect(0, 68093, '\p{Nv=0.583}', "");
    Expect(1, 68093, '\p{^Nv=0.583}', "");
    Expect(1, 68093, '\P{Nv=0.583}', "");
    Expect(0, 68093, '\P{^Nv=0.583}', "");
    Error('\p{Is_Numeric_Value=:=	000000007/012}');
    Error('\P{Is_Numeric_Value=:=	000000007/012}');
    Expect(1, 68092, '\p{Is_Numeric_Value=0000000007/000000012}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value=0000000007/000000012}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value=0000000007/000000012}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value=0000000007/000000012}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value=0000000007/000000012}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value=0000000007/000000012}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value=0000000007/000000012}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value=0000000007/000000012}', "");
    Error('\p{Is_Numeric_Value=0.58}');
    Error('\P{Is_Numeric_Value=0.58}');
    Expect(1, 68092, '\p{Is_Numeric_Value=0.583}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value=0.583}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value=0.583}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value=0.583}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value=0.583}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value=0.583}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value=0.583}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value=0.583}', "");
    Error('\p{Is_Nv=:=	+00000007/0000000012}');
    Error('\P{Is_Nv=:=	+00000007/0000000012}');
    Expect(1, 68092, '\p{Is_Nv=0000007/0012}', "");
    Expect(0, 68092, '\p{^Is_Nv=0000007/0012}', "");
    Expect(0, 68092, '\P{Is_Nv=0000007/0012}', "");
    Expect(1, 68092, '\P{^Is_Nv=0000007/0012}', "");
    Expect(0, 68093, '\p{Is_Nv=0000007/0012}', "");
    Expect(1, 68093, '\p{^Is_Nv=0000007/0012}', "");
    Expect(1, 68093, '\P{Is_Nv=0000007/0012}', "");
    Expect(0, 68093, '\P{^Is_Nv=0000007/0012}', "");
    Error('\p{Is_Nv=0.58}');
    Error('\P{Is_Nv=0.58}');
    Expect(1, 68092, '\p{Is_Nv=0.583}', "");
    Expect(0, 68092, '\p{^Is_Nv=0.583}', "");
    Expect(0, 68092, '\P{Is_Nv=0.583}', "");
    Expect(1, 68092, '\P{^Is_Nv=0.583}', "");
    Expect(0, 68093, '\p{Is_Nv=0.583}', "");
    Expect(1, 68093, '\p{^Is_Nv=0.583}', "");
    Expect(1, 68093, '\P{Is_Nv=0.583}', "");
    Expect(0, 68093, '\P{^Is_Nv=0.583}', "");
    Error('\p{Numeric_Value=/a/_ 00000007/000000002}');
    Error('\P{Numeric_Value=/a/_ 00000007/000000002}');
    Expect(1, 3885, '\p{Numeric_Value=+007/0002}', "");
    Expect(0, 3885, '\p{^Numeric_Value=+007/0002}', "");
    Expect(0, 3885, '\P{Numeric_Value=+007/0002}', "");
    Expect(1, 3885, '\P{^Numeric_Value=+007/0002}', "");
    Expect(0, 3886, '\p{Numeric_Value=+007/0002}', "");
    Expect(1, 3886, '\p{^Numeric_Value=+007/0002}', "");
    Expect(1, 3886, '\P{Numeric_Value=+007/0002}', "");
    Expect(0, 3886, '\P{^Numeric_Value=+007/0002}', "");
    Expect(1, 3885, '\p{Numeric_Value=3.500}', "");
    Expect(0, 3885, '\p{^Numeric_Value=3.500}', "");
    Expect(0, 3885, '\P{Numeric_Value=3.500}', "");
    Expect(1, 3885, '\P{^Numeric_Value=3.500}', "");
    Expect(0, 3886, '\p{Numeric_Value=3.500}', "");
    Expect(1, 3886, '\p{^Numeric_Value=3.500}', "");
    Expect(1, 3886, '\P{Numeric_Value=3.500}', "");
    Expect(0, 3886, '\P{^Numeric_Value=3.500}', "");
    Error('\p{Nv=/a/ -007/00002}');
    Error('\P{Nv=/a/ -007/00002}');
    Expect(1, 3885, '\p{Nv=000000007/000002}', "");
    Expect(0, 3885, '\p{^Nv=000000007/000002}', "");
    Expect(0, 3885, '\P{Nv=000000007/000002}', "");
    Expect(1, 3885, '\P{^Nv=000000007/000002}', "");
    Expect(0, 3886, '\p{Nv=000000007/000002}', "");
    Expect(1, 3886, '\p{^Nv=000000007/000002}', "");
    Expect(1, 3886, '\P{Nv=000000007/000002}', "");
    Expect(0, 3886, '\P{^Nv=000000007/000002}', "");
    Expect(1, 3885, '\p{Nv=3.500}', "");
    Expect(0, 3885, '\p{^Nv=3.500}', "");
    Expect(0, 3885, '\P{Nv=3.500}', "");
    Expect(1, 3885, '\P{^Nv=3.500}', "");
    Expect(0, 3886, '\p{Nv=3.500}', "");
    Expect(1, 3886, '\p{^Nv=3.500}', "");
    Expect(1, 3886, '\P{Nv=3.500}', "");
    Expect(0, 3886, '\P{^Nv=3.500}', "");
    Error('\p{Is_Numeric_Value=	/a/000007/00002}');
    Error('\P{Is_Numeric_Value=	/a/000007/00002}');
    Expect(1, 3885, '\p{Is_Numeric_Value=07/02}', "");
    Expect(0, 3885, '\p{^Is_Numeric_Value=07/02}', "");
    Expect(0, 3885, '\P{Is_Numeric_Value=07/02}', "");
    Expect(1, 3885, '\P{^Is_Numeric_Value=07/02}', "");
    Expect(0, 3886, '\p{Is_Numeric_Value=07/02}', "");
    Expect(1, 3886, '\p{^Is_Numeric_Value=07/02}', "");
    Expect(1, 3886, '\P{Is_Numeric_Value=07/02}', "");
    Expect(0, 3886, '\P{^Is_Numeric_Value=07/02}', "");
    Expect(1, 3885, '\p{Is_Numeric_Value=3.500}', "");
    Expect(0, 3885, '\p{^Is_Numeric_Value=3.500}', "");
    Expect(0, 3885, '\P{Is_Numeric_Value=3.500}', "");
    Expect(1, 3885, '\P{^Is_Numeric_Value=3.500}', "");
    Expect(0, 3886, '\p{Is_Numeric_Value=3.500}', "");
    Expect(1, 3886, '\p{^Is_Numeric_Value=3.500}', "");
    Expect(1, 3886, '\P{Is_Numeric_Value=3.500}', "");
    Expect(0, 3886, '\P{^Is_Numeric_Value=3.500}', "");
    Error('\p{Is_Nv=	/a/+007/0002}');
    Error('\P{Is_Nv=	/a/+007/0002}');
    Expect(1, 3885, '\p{Is_Nv=00000007/2}', "");
    Expect(0, 3885, '\p{^Is_Nv=00000007/2}', "");
    Expect(0, 3885, '\P{Is_Nv=00000007/2}', "");
    Expect(1, 3885, '\P{^Is_Nv=00000007/2}', "");
    Expect(0, 3886, '\p{Is_Nv=00000007/2}', "");
    Expect(1, 3886, '\p{^Is_Nv=00000007/2}', "");
    Expect(1, 3886, '\P{Is_Nv=00000007/2}', "");
    Expect(0, 3886, '\P{^Is_Nv=00000007/2}', "");
    Expect(1, 3885, '\p{Is_Nv=3.500}', "");
    Expect(0, 3885, '\p{^Is_Nv=3.500}', "");
    Expect(0, 3885, '\P{Is_Nv=3.500}', "");
    Expect(1, 3885, '\P{^Is_Nv=3.500}', "");
    Expect(0, 3886, '\p{Is_Nv=3.500}', "");
    Expect(1, 3886, '\p{^Is_Nv=3.500}', "");
    Expect(1, 3886, '\P{Is_Nv=3.500}', "");
    Expect(0, 3886, '\P{^Is_Nv=3.500}', "");
    Error('\p{Numeric_Value=:=_ 7/8}');
    Error('\P{Numeric_Value=:=_ 7/8}');
    Expect(1, 8542, '\p{Numeric_Value=+07/000000008}', "");
    Expect(0, 8542, '\p{^Numeric_Value=+07/000000008}', "");
    Expect(0, 8542, '\P{Numeric_Value=+07/000000008}', "");
    Expect(1, 8542, '\P{^Numeric_Value=+07/000000008}', "");
    Expect(0, 8543, '\p{Numeric_Value=+07/000000008}', "");
    Expect(1, 8543, '\p{^Numeric_Value=+07/000000008}', "");
    Expect(1, 8543, '\P{Numeric_Value=+07/000000008}', "");
    Expect(0, 8543, '\P{^Numeric_Value=+07/000000008}', "");
    Error('\p{Numeric_Value=0.9}');
    Error('\P{Numeric_Value=0.9}');
    Error('\p{Numeric_Value=0.88}');
    Error('\P{Numeric_Value=0.88}');
    Expect(1, 8542, '\p{Numeric_Value:	0.875}', "");
    Expect(0, 8542, '\p{^Numeric_Value:	0.875}', "");
    Expect(0, 8542, '\P{Numeric_Value:	0.875}', "");
    Expect(1, 8542, '\P{^Numeric_Value:	0.875}', "");
    Expect(0, 8543, '\p{Numeric_Value:	0.875}', "");
    Expect(1, 8543, '\p{^Numeric_Value:	0.875}', "");
    Expect(1, 8543, '\P{Numeric_Value:	0.875}', "");
    Expect(0, 8543, '\P{^Numeric_Value:	0.875}', "");
    Error('\p{Nv= /a/+07/000000008}');
    Error('\P{Nv= /a/+07/000000008}');
    Expect(1, 8542, '\p{Nv=0000000007/08}', "");
    Expect(0, 8542, '\p{^Nv=0000000007/08}', "");
    Expect(0, 8542, '\P{Nv=0000000007/08}', "");
    Expect(1, 8542, '\P{^Nv=0000000007/08}', "");
    Expect(0, 8543, '\p{Nv=0000000007/08}', "");
    Expect(1, 8543, '\p{^Nv=0000000007/08}', "");
    Expect(1, 8543, '\P{Nv=0000000007/08}', "");
    Expect(0, 8543, '\P{^Nv=0000000007/08}', "");
    Error('\p{Nv=0.9}');
    Error('\P{Nv=0.9}');
    Error('\p{Nv=0.88}');
    Error('\P{Nv=0.88}');
    Expect(1, 8542, '\p{Nv=0.875}', "");
    Expect(0, 8542, '\p{^Nv=0.875}', "");
    Expect(0, 8542, '\P{Nv=0.875}', "");
    Expect(1, 8542, '\P{^Nv=0.875}', "");
    Expect(0, 8543, '\p{Nv=0.875}', "");
    Expect(1, 8543, '\p{^Nv=0.875}', "");
    Expect(1, 8543, '\P{Nv=0.875}', "");
    Expect(0, 8543, '\P{^Nv=0.875}', "");
    Error('\p{Is_Numeric_Value=/a/__000000007/0008}');
    Error('\P{Is_Numeric_Value=/a/__000000007/0008}');
    Expect(1, 8542, '\p{Is_Numeric_Value:   000007/8}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value:   000007/8}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value:   000007/8}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value:   000007/8}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value:   000007/8}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value:   000007/8}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value:   000007/8}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value:   000007/8}', "");
    Error('\p{Is_Numeric_Value:   0.9}');
    Error('\P{Is_Numeric_Value:   0.9}');
    Error('\p{Is_Numeric_Value=0.88}');
    Error('\P{Is_Numeric_Value=0.88}');
    Expect(1, 8542, '\p{Is_Numeric_Value=0.875}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value=0.875}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value=0.875}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value=0.875}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value=0.875}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value=0.875}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value=0.875}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value=0.875}', "");
    Error('\p{Is_Nv=/a/007/0000000008}');
    Error('\P{Is_Nv=/a/007/0000000008}');
    Expect(1, 8542, '\p{Is_Nv=+00007/00000008}', "");
    Expect(0, 8542, '\p{^Is_Nv=+00007/00000008}', "");
    Expect(0, 8542, '\P{Is_Nv=+00007/00000008}', "");
    Expect(1, 8542, '\P{^Is_Nv=+00007/00000008}', "");
    Expect(0, 8543, '\p{Is_Nv=+00007/00000008}', "");
    Expect(1, 8543, '\p{^Is_Nv=+00007/00000008}', "");
    Expect(1, 8543, '\P{Is_Nv=+00007/00000008}', "");
    Expect(0, 8543, '\P{^Is_Nv=+00007/00000008}', "");
    Error('\p{Is_Nv=0.9}');
    Error('\P{Is_Nv=0.9}');
    Error('\p{Is_Nv=0.88}');
    Error('\P{Is_Nv=0.88}');
    Expect(1, 8542, '\p{Is_Nv=0.875}', "");
    Expect(0, 8542, '\p{^Is_Nv=0.875}', "");
    Expect(0, 8542, '\P{Is_Nv=0.875}', "");
    Expect(1, 8542, '\P{^Is_Nv=0.875}', "");
    Expect(0, 8543, '\p{Is_Nv=0.875}', "");
    Expect(1, 8543, '\p{^Is_Nv=0.875}', "");
    Expect(1, 8543, '\P{Is_Nv=0.875}', "");
    Expect(0, 8543, '\P{^Is_Nv=0.875}', "");
    Error('\p{Numeric_Value=:=_	+00000070}');
    Error('\P{Numeric_Value=:=_	+00000070}');
    Expect(1, 119663, '\p{Numeric_Value=+0070}', "");
    Expect(0, 119663, '\p{^Numeric_Value=+0070}', "");
    Expect(0, 119663, '\P{Numeric_Value=+0070}', "");
    Expect(1, 119663, '\P{^Numeric_Value=+0070}', "");
    Expect(0, 119664, '\p{Numeric_Value=+0070}', "");
    Expect(1, 119664, '\p{^Numeric_Value=+0070}', "");
    Expect(1, 119664, '\P{Numeric_Value=+0070}', "");
    Expect(0, 119664, '\P{^Numeric_Value=+0070}', "");
    Error('\p{Nv=0_0_70/a/}');
    Error('\P{Nv=0_0_70/a/}');
    Expect(1, 119663, '\p{Nv=+000_000_007_0}', "");
    Expect(0, 119663, '\p{^Nv=+000_000_007_0}', "");
    Expect(0, 119663, '\P{Nv=+000_000_007_0}', "");
    Expect(1, 119663, '\P{^Nv=+000_000_007_0}', "");
    Expect(0, 119664, '\p{Nv=+000_000_007_0}', "");
    Expect(1, 119664, '\p{^Nv=+000_000_007_0}', "");
    Expect(1, 119664, '\P{Nv=+000_000_007_0}', "");
    Expect(0, 119664, '\P{^Nv=+000_000_007_0}', "");
    Error('\p{Is_Numeric_Value=	-000_000_007_0/a/}');
    Error('\P{Is_Numeric_Value=	-000_000_007_0/a/}');
    Expect(1, 119663, '\p{Is_Numeric_Value=00_00_00_00_07_0}', "");
    Expect(0, 119663, '\p{^Is_Numeric_Value=00_00_00_00_07_0}', "");
    Expect(0, 119663, '\P{Is_Numeric_Value=00_00_00_00_07_0}', "");
    Expect(1, 119663, '\P{^Is_Numeric_Value=00_00_00_00_07_0}', "");
    Expect(0, 119664, '\p{Is_Numeric_Value=00_00_00_00_07_0}', "");
    Expect(1, 119664, '\p{^Is_Numeric_Value=00_00_00_00_07_0}', "");
    Expect(1, 119664, '\P{Is_Numeric_Value=00_00_00_00_07_0}', "");
    Expect(0, 119664, '\P{^Is_Numeric_Value=00_00_00_00_07_0}', "");
    Error('\p{Is_Nv=:=00_00_00_070}');
    Error('\P{Is_Nv=:=00_00_00_070}');
    Expect(1, 119663, '\p{Is_Nv: 0_0_0_0_0070}', "");
    Expect(0, 119663, '\p{^Is_Nv: 0_0_0_0_0070}', "");
    Expect(0, 119663, '\P{Is_Nv: 0_0_0_0_0070}', "");
    Expect(1, 119663, '\P{^Is_Nv: 0_0_0_0_0070}', "");
    Expect(0, 119664, '\p{Is_Nv: 0_0_0_0_0070}', "");
    Expect(1, 119664, '\p{^Is_Nv: 0_0_0_0_0070}', "");
    Expect(1, 119664, '\P{Is_Nv: 0_0_0_0_0070}', "");
    Expect(0, 119664, '\P{^Is_Nv: 0_0_0_0_0070}', "");
    Error('\p{Numeric_Value=--070_0/a/}');
    Error('\P{Numeric_Value=--070_0/a/}');
    Expect(1, 69240, '\p{Numeric_Value=00_00_00_00_0700}', "");
    Expect(0, 69240, '\p{^Numeric_Value=00_00_00_00_0700}', "");
    Expect(0, 69240, '\P{Numeric_Value=00_00_00_00_0700}', "");
    Expect(1, 69240, '\P{^Numeric_Value=00_00_00_00_0700}', "");
    Expect(0, 69241, '\p{Numeric_Value=00_00_00_00_0700}', "");
    Expect(1, 69241, '\p{^Numeric_Value=00_00_00_00_0700}', "");
    Expect(1, 69241, '\P{Numeric_Value=00_00_00_00_0700}', "");
    Expect(0, 69241, '\P{^Numeric_Value=00_00_00_00_0700}', "");
    Error('\p{Nv=_/a/000000700}');
    Error('\P{Nv=_/a/000000700}');
    Expect(1, 69240, '\p{Nv=+000000000700}', "");
    Expect(0, 69240, '\p{^Nv=+000000000700}', "");
    Expect(0, 69240, '\P{Nv=+000000000700}', "");
    Expect(1, 69240, '\P{^Nv=+000000000700}', "");
    Expect(0, 69241, '\p{Nv=+000000000700}', "");
    Expect(1, 69241, '\p{^Nv=+000000000700}', "");
    Expect(1, 69241, '\P{Nv=+000000000700}', "");
    Expect(0, 69241, '\P{^Nv=+000000000700}', "");
    Error('\p{Is_Numeric_Value=_:=+00000000700}');
    Error('\P{Is_Numeric_Value=_:=+00000000700}');
    Expect(1, 69240, '\p{Is_Numeric_Value=0000000700}', "");
    Expect(0, 69240, '\p{^Is_Numeric_Value=0000000700}', "");
    Expect(0, 69240, '\P{Is_Numeric_Value=0000000700}', "");
    Expect(1, 69240, '\P{^Is_Numeric_Value=0000000700}', "");
    Expect(0, 69241, '\p{Is_Numeric_Value=0000000700}', "");
    Expect(1, 69241, '\p{^Is_Numeric_Value=0000000700}', "");
    Expect(1, 69241, '\P{Is_Numeric_Value=0000000700}', "");
    Expect(0, 69241, '\P{^Is_Numeric_Value=0000000700}', "");
    Error('\p{Is_Nv=/a/- 0000000700}');
    Error('\P{Is_Nv=/a/- 0000000700}');
    Expect(1, 69240, '\p{Is_Nv=0_0_0_0_0_0_0_700}', "");
    Expect(0, 69240, '\p{^Is_Nv=0_0_0_0_0_0_0_700}', "");
    Expect(0, 69240, '\P{Is_Nv=0_0_0_0_0_0_0_700}', "");
    Expect(1, 69240, '\P{^Is_Nv=0_0_0_0_0_0_0_700}', "");
    Expect(0, 69241, '\p{Is_Nv=0_0_0_0_0_0_0_700}', "");
    Expect(1, 69241, '\p{^Is_Nv=0_0_0_0_0_0_0_700}', "");
    Expect(1, 69241, '\P{Is_Nv=0_0_0_0_0_0_0_700}', "");
    Expect(0, 69241, '\P{^Is_Nv=0_0_0_0_0_0_0_700}', "");
    Error('\p{Numeric_Value=:=--00_00_07_000}');
    Error('\P{Numeric_Value=:=--00_00_07_000}');
    Expect(1, 68065, '\p{Numeric_Value=00_70_00}', "");
    Expect(0, 68065, '\p{^Numeric_Value=00_70_00}', "");
    Expect(0, 68065, '\P{Numeric_Value=00_70_00}', "");
    Expect(1, 68065, '\P{^Numeric_Value=00_70_00}', "");
    Expect(0, 68066, '\p{Numeric_Value=00_70_00}', "");
    Expect(1, 68066, '\p{^Numeric_Value=00_70_00}', "");
    Expect(1, 68066, '\P{Numeric_Value=00_70_00}', "");
    Expect(0, 68066, '\P{^Numeric_Value=00_70_00}', "");
    Error('\p{Nv=:=0000000007000}');
    Error('\P{Nv=:=0000000007000}');
    Expect(1, 68065, '\p{Nv=+0_0_0_7_0_00}', "");
    Expect(0, 68065, '\p{^Nv=+0_0_0_7_0_00}', "");
    Expect(0, 68065, '\P{Nv=+0_0_0_7_0_00}', "");
    Expect(1, 68065, '\P{^Nv=+0_0_0_7_0_00}', "");
    Expect(0, 68066, '\p{Nv=+0_0_0_7_0_00}', "");
    Expect(1, 68066, '\p{^Nv=+0_0_0_7_0_00}', "");
    Expect(1, 68066, '\P{Nv=+0_0_0_7_0_00}', "");
    Expect(0, 68066, '\P{^Nv=+0_0_0_7_0_00}', "");
    Error('\p{Is_Numeric_Value=:=_-07000}');
    Error('\P{Is_Numeric_Value=:=_-07000}');
    Expect(1, 68065, '\p{Is_Numeric_Value=000000007000}', "");
    Expect(0, 68065, '\p{^Is_Numeric_Value=000000007000}', "");
    Expect(0, 68065, '\P{Is_Numeric_Value=000000007000}', "");
    Expect(1, 68065, '\P{^Is_Numeric_Value=000000007000}', "");
    Expect(0, 68066, '\p{Is_Numeric_Value=000000007000}', "");
    Expect(1, 68066, '\p{^Is_Numeric_Value=000000007000}', "");
    Expect(1, 68066, '\P{Is_Numeric_Value=000000007000}', "");
    Expect(0, 68066, '\P{^Is_Numeric_Value=000000007000}', "");
    Error('\p{Is_Nv=--+700_0:=}');
    Error('\P{Is_Nv=--+700_0:=}');
    Expect(1, 68065, '\p{Is_Nv=7000}', "");
    Expect(0, 68065, '\p{^Is_Nv=7000}', "");
    Expect(0, 68065, '\P{Is_Nv=7000}', "");
    Expect(1, 68065, '\P{^Is_Nv=7000}', "");
    Expect(0, 68066, '\p{Is_Nv=7000}', "");
    Expect(1, 68066, '\p{^Is_Nv=7000}', "");
    Expect(1, 68066, '\P{Is_Nv=7000}', "");
    Expect(0, 68066, '\P{^Is_Nv=7000}', "");
    Error('\p{Numeric_Value= /a/+007000_0}');
    Error('\P{Numeric_Value= /a/+007000_0}');
    Expect(1, 68074, '\p{Numeric_Value=000_007_000_0}', "");
    Expect(0, 68074, '\p{^Numeric_Value=000_007_000_0}', "");
    Expect(0, 68074, '\P{Numeric_Value=000_007_000_0}', "");
    Expect(1, 68074, '\P{^Numeric_Value=000_007_000_0}', "");
    Expect(0, 68075, '\p{Numeric_Value=000_007_000_0}', "");
    Expect(1, 68075, '\p{^Numeric_Value=000_007_000_0}', "");
    Expect(1, 68075, '\P{Numeric_Value=000_007_000_0}', "");
    Expect(0, 68075, '\P{^Numeric_Value=000_007_000_0}', "");
    Error('\p{Nv=:=00_70_00_0}');
    Error('\P{Nv=:=00_70_00_0}');
    Expect(1, 68074, '\p{Nv=+0_0_0_0_0_0_70000}', "");
    Expect(0, 68074, '\p{^Nv=+0_0_0_0_0_0_70000}', "");
    Expect(0, 68074, '\P{Nv=+0_0_0_0_0_0_70000}', "");
    Expect(1, 68074, '\P{^Nv=+0_0_0_0_0_0_70000}', "");
    Expect(0, 68075, '\p{Nv=+0_0_0_0_0_0_70000}', "");
    Expect(1, 68075, '\p{^Nv=+0_0_0_0_0_0_70000}', "");
    Expect(1, 68075, '\P{Nv=+0_0_0_0_0_0_70000}', "");
    Expect(0, 68075, '\P{^Nv=+0_0_0_0_0_0_70000}', "");
    Error('\p{Is_Numeric_Value=		+7_0_0_00:=}');
    Error('\P{Is_Numeric_Value=		+7_0_0_00:=}');
    Expect(1, 68074, '\p{Is_Numeric_Value=00_70_00_0}', "");
    Expect(0, 68074, '\p{^Is_Numeric_Value=00_70_00_0}', "");
    Expect(0, 68074, '\P{Is_Numeric_Value=00_70_00_0}', "");
    Expect(1, 68074, '\P{^Is_Numeric_Value=00_70_00_0}', "");
    Expect(0, 68075, '\p{Is_Numeric_Value=00_70_00_0}', "");
    Expect(1, 68075, '\p{^Is_Numeric_Value=00_70_00_0}', "");
    Expect(1, 68075, '\P{Is_Numeric_Value=00_70_00_0}', "");
    Expect(0, 68075, '\P{^Is_Numeric_Value=00_70_00_0}', "");
    Error('\p{Is_Nv=/a/		000000070000}');
    Error('\P{Is_Nv=/a/		000000070000}');
    Expect(1, 68074, '\p{Is_Nv:   0_0_0_0_7_0_0_00}', "");
    Expect(0, 68074, '\p{^Is_Nv:   0_0_0_0_7_0_0_00}', "");
    Expect(0, 68074, '\P{Is_Nv:   0_0_0_0_7_0_0_00}', "");
    Expect(1, 68074, '\P{^Is_Nv:   0_0_0_0_7_0_0_00}', "");
    Expect(0, 68075, '\p{Is_Nv:   0_0_0_0_7_0_0_00}', "");
    Expect(1, 68075, '\p{^Is_Nv:   0_0_0_0_7_0_0_00}', "");
    Expect(1, 68075, '\P{Is_Nv:   0_0_0_0_7_0_0_00}', "");
    Expect(0, 68075, '\P{^Is_Nv:   0_0_0_0_7_0_0_00}', "");
    Error('\p{Numeric_Value=_-0_0_0_0_0_7_0_0000:=}');
    Error('\P{Numeric_Value=_-0_0_0_0_0_7_0_0000:=}');
    Expect(1, 68083, '\p{Numeric_Value=+00700000}', "");
    Expect(0, 68083, '\p{^Numeric_Value=+00700000}', "");
    Expect(0, 68083, '\P{Numeric_Value=+00700000}', "");
    Expect(1, 68083, '\P{^Numeric_Value=+00700000}', "");
    Expect(0, 68084, '\p{Numeric_Value=+00700000}', "");
    Expect(1, 68084, '\p{^Numeric_Value=+00700000}', "");
    Expect(1, 68084, '\P{Numeric_Value=+00700000}', "");
    Expect(0, 68084, '\P{^Numeric_Value=+00700000}', "");
    Error('\p{Nv=/a/_ 00000000700000}');
    Error('\P{Nv=/a/_ 00000000700000}');
    Expect(1, 68083, '\p{Nv=00_00_00_00_07_00_000}', "");
    Expect(0, 68083, '\p{^Nv=00_00_00_00_07_00_000}', "");
    Expect(0, 68083, '\P{Nv=00_00_00_00_07_00_000}', "");
    Expect(1, 68083, '\P{^Nv=00_00_00_00_07_00_000}', "");
    Expect(0, 68084, '\p{Nv=00_00_00_00_07_00_000}', "");
    Expect(1, 68084, '\p{^Nv=00_00_00_00_07_00_000}', "");
    Expect(1, 68084, '\P{Nv=00_00_00_00_07_00_000}', "");
    Expect(0, 68084, '\P{^Nv=00_00_00_00_07_00_000}', "");
    Error('\p{Is_Numeric_Value=--0_0_0_7_0_0000:=}');
    Error('\P{Is_Numeric_Value=--0_0_0_7_0_0000:=}');
    Expect(1, 68083, '\p{Is_Numeric_Value=700000}', "");
    Expect(0, 68083, '\p{^Is_Numeric_Value=700000}', "");
    Expect(0, 68083, '\P{Is_Numeric_Value=700000}', "");
    Expect(1, 68083, '\P{^Is_Numeric_Value=700000}', "");
    Expect(0, 68084, '\p{Is_Numeric_Value=700000}', "");
    Expect(1, 68084, '\p{^Is_Numeric_Value=700000}', "");
    Expect(1, 68084, '\P{Is_Numeric_Value=700000}', "");
    Expect(0, 68084, '\P{^Is_Numeric_Value=700000}', "");
    Error('\p{Is_Nv=/a/  0070000_0}');
    Error('\P{Is_Nv=/a/  0070000_0}');
    Expect(1, 68083, '\p{Is_Nv=70_00_00}', "");
    Expect(0, 68083, '\p{^Is_Nv=70_00_00}', "");
    Expect(0, 68083, '\P{Is_Nv=70_00_00}', "");
    Expect(1, 68083, '\P{^Is_Nv=70_00_00}', "");
    Expect(0, 68084, '\p{Is_Nv=70_00_00}', "");
    Expect(1, 68084, '\p{^Is_Nv=70_00_00}', "");
    Expect(1, 68084, '\P{Is_Nv=70_00_00}', "");
    Expect(0, 68084, '\P{^Is_Nv=70_00_00}', "");
    Error('\p{Numeric_Value=/a/+0000000008}');
    Error('\P{Numeric_Value=/a/+0000000008}');
    Expect(1, 127241, '\p{Numeric_Value=0000000008}', "");
    Expect(0, 127241, '\p{^Numeric_Value=0000000008}', "");
    Expect(0, 127241, '\P{Numeric_Value=0000000008}', "");
    Expect(1, 127241, '\P{^Numeric_Value=0000000008}', "");
    Expect(0, 127242, '\p{Numeric_Value=0000000008}', "");
    Expect(1, 127242, '\p{^Numeric_Value=0000000008}', "");
    Expect(1, 127242, '\P{Numeric_Value=0000000008}', "");
    Expect(0, 127242, '\P{^Numeric_Value=0000000008}', "");
    Error('\p{Nv=	:=00_00_00_00_08}');
    Error('\P{Nv=	:=00_00_00_00_08}');
    Expect(1, 127241, '\p{Nv:	00_00_00_8}', "");
    Expect(0, 127241, '\p{^Nv:	00_00_00_8}', "");
    Expect(0, 127241, '\P{Nv:	00_00_00_8}', "");
    Expect(1, 127241, '\P{^Nv:	00_00_00_8}', "");
    Expect(0, 127242, '\p{Nv:	00_00_00_8}', "");
    Expect(1, 127242, '\p{^Nv:	00_00_00_8}', "");
    Expect(1, 127242, '\P{Nv:	00_00_00_8}', "");
    Expect(0, 127242, '\P{^Nv:	00_00_00_8}', "");
    Error('\p{Is_Numeric_Value=_008/a/}');
    Error('\P{Is_Numeric_Value=_008/a/}');
    Expect(1, 127241, '\p{Is_Numeric_Value:+0000008}', "");
    Expect(0, 127241, '\p{^Is_Numeric_Value:+0000008}', "");
    Expect(0, 127241, '\P{Is_Numeric_Value:+0000008}', "");
    Expect(1, 127241, '\P{^Is_Numeric_Value:+0000008}', "");
    Expect(0, 127242, '\p{Is_Numeric_Value:+0000008}', "");
    Expect(1, 127242, '\p{^Is_Numeric_Value:+0000008}', "");
    Expect(1, 127242, '\P{Is_Numeric_Value:+0000008}', "");
    Expect(0, 127242, '\P{^Is_Numeric_Value:+0000008}', "");
    Error('\p{Is_Nv=-_00000_8/a/}');
    Error('\P{Is_Nv=-_00000_8/a/}');
    Expect(1, 127241, '\p{Is_Nv=0_0_0_0_0_0_0008}', "");
    Expect(0, 127241, '\p{^Is_Nv=0_0_0_0_0_0_0008}', "");
    Expect(0, 127241, '\P{Is_Nv=0_0_0_0_0_0_0008}', "");
    Expect(1, 127241, '\P{^Is_Nv=0_0_0_0_0_0_0008}', "");
    Expect(0, 127242, '\p{Is_Nv=0_0_0_0_0_0_0008}', "");
    Expect(1, 127242, '\p{^Is_Nv=0_0_0_0_0_0_0008}', "");
    Expect(1, 127242, '\P{Is_Nv=0_0_0_0_0_0_0008}', "");
    Expect(0, 127242, '\P{^Is_Nv=0_0_0_0_0_0_0008}', "");
    Error('\p{Numeric_Value=0080/a/}');
    Error('\P{Numeric_Value=0080/a/}');
    Expect(1, 119664, '\p{Numeric_Value=+0008_0}', "");
    Expect(0, 119664, '\p{^Numeric_Value=+0008_0}', "");
    Expect(0, 119664, '\P{Numeric_Value=+0008_0}', "");
    Expect(1, 119664, '\P{^Numeric_Value=+0008_0}', "");
    Expect(0, 119665, '\p{Numeric_Value=+0008_0}', "");
    Expect(1, 119665, '\p{^Numeric_Value=+0008_0}', "");
    Expect(1, 119665, '\P{Numeric_Value=+0008_0}', "");
    Expect(0, 119665, '\P{^Numeric_Value=+0008_0}', "");
    Error('\p{Nv:	_-0000080/a/}');
    Error('\P{Nv:	_-0000080/a/}');
    Expect(1, 119664, '\p{Nv=000080}', "");
    Expect(0, 119664, '\p{^Nv=000080}', "");
    Expect(0, 119664, '\P{Nv=000080}', "");
    Expect(1, 119664, '\P{^Nv=000080}', "");
    Expect(0, 119665, '\p{Nv=000080}', "");
    Expect(1, 119665, '\p{^Nv=000080}', "");
    Expect(1, 119665, '\P{Nv=000080}', "");
    Expect(0, 119665, '\P{^Nv=000080}', "");
    Error('\p{Is_Numeric_Value=	:=000080}');
    Error('\P{Is_Numeric_Value=	:=000080}');
    Expect(1, 119664, '\p{Is_Numeric_Value=0000080}', "");
    Expect(0, 119664, '\p{^Is_Numeric_Value=0000080}', "");
    Expect(0, 119664, '\P{Is_Numeric_Value=0000080}', "");
    Expect(1, 119664, '\P{^Is_Numeric_Value=0000080}', "");
    Expect(0, 119665, '\p{Is_Numeric_Value=0000080}', "");
    Expect(1, 119665, '\p{^Is_Numeric_Value=0000080}', "");
    Expect(1, 119665, '\P{Is_Numeric_Value=0000080}', "");
    Expect(0, 119665, '\P{^Is_Numeric_Value=0000080}', "");
    Error('\p{Is_Nv=/a/ 00000000080}');
    Error('\P{Is_Nv=/a/ 00000000080}');
    Expect(1, 119664, '\p{Is_Nv:   +0_0_0_0_0_80}', "");
    Expect(0, 119664, '\p{^Is_Nv:   +0_0_0_0_0_80}', "");
    Expect(0, 119664, '\P{Is_Nv:   +0_0_0_0_0_80}', "");
    Expect(1, 119664, '\P{^Is_Nv:   +0_0_0_0_0_80}', "");
    Expect(0, 119665, '\p{Is_Nv:   +0_0_0_0_0_80}', "");
    Expect(1, 119665, '\p{^Is_Nv:   +0_0_0_0_0_80}', "");
    Expect(1, 119665, '\P{Is_Nv:   +0_0_0_0_0_80}', "");
    Expect(0, 119665, '\P{^Is_Nv:   +0_0_0_0_0_80}', "");
    Error('\p{Numeric_Value:	:=_+00_00_00_00_08_00}');
    Error('\P{Numeric_Value:	:=_+00_00_00_00_08_00}');
    Expect(1, 69241, '\p{Numeric_Value=000800}', "");
    Expect(0, 69241, '\p{^Numeric_Value=000800}', "");
    Expect(0, 69241, '\P{Numeric_Value=000800}', "");
    Expect(1, 69241, '\P{^Numeric_Value=000800}', "");
    Expect(0, 69242, '\p{Numeric_Value=000800}', "");
    Expect(1, 69242, '\p{^Numeric_Value=000800}', "");
    Expect(1, 69242, '\P{Numeric_Value=000800}', "");
    Expect(0, 69242, '\P{^Numeric_Value=000800}', "");
    Error('\p{Nv= :=00_00_00_00_0800}');
    Error('\P{Nv= :=00_00_00_00_0800}');
    Expect(1, 69241, '\p{Nv=0000800}', "");
    Expect(0, 69241, '\p{^Nv=0000800}', "");
    Expect(0, 69241, '\P{Nv=0000800}', "");
    Expect(1, 69241, '\P{^Nv=0000800}', "");
    Expect(0, 69242, '\p{Nv=0000800}', "");
    Expect(1, 69242, '\p{^Nv=0000800}', "");
    Expect(1, 69242, '\P{Nv=0000800}', "");
    Expect(0, 69242, '\P{^Nv=0000800}', "");
    Error('\p{Is_Numeric_Value=:=000000800}');
    Error('\P{Is_Numeric_Value=:=000000800}');
    Expect(1, 69241, '\p{Is_Numeric_Value:	0800}', "");
    Expect(0, 69241, '\p{^Is_Numeric_Value:	0800}', "");
    Expect(0, 69241, '\P{Is_Numeric_Value:	0800}', "");
    Expect(1, 69241, '\P{^Is_Numeric_Value:	0800}', "");
    Expect(0, 69242, '\p{Is_Numeric_Value:	0800}', "");
    Expect(1, 69242, '\p{^Is_Numeric_Value:	0800}', "");
    Expect(1, 69242, '\P{Is_Numeric_Value:	0800}', "");
    Expect(0, 69242, '\P{^Is_Numeric_Value:	0800}', "");
    Error('\p{Is_Nv=_+0_0_8_00:=}');
    Error('\P{Is_Nv=_+0_0_8_00:=}');
    Expect(1, 69241, '\p{Is_Nv:   00_00_00_00_800}', "");
    Expect(0, 69241, '\p{^Is_Nv:   00_00_00_00_800}', "");
    Expect(0, 69241, '\P{Is_Nv:   00_00_00_00_800}', "");
    Expect(1, 69241, '\P{^Is_Nv:   00_00_00_00_800}', "");
    Expect(0, 69242, '\p{Is_Nv:   00_00_00_00_800}', "");
    Expect(1, 69242, '\p{^Is_Nv:   00_00_00_00_800}', "");
    Expect(1, 69242, '\P{Is_Nv:   00_00_00_00_800}', "");
    Expect(0, 69242, '\P{^Is_Nv:   00_00_00_00_800}', "");
    Error('\p{Numeric_Value=		0_0_0_8_0_00/a/}');
    Error('\P{Numeric_Value=		0_0_0_8_0_00/a/}');
    Expect(1, 68066, '\p{Numeric_Value=000000008000}', "");
    Expect(0, 68066, '\p{^Numeric_Value=000000008000}', "");
    Expect(0, 68066, '\P{Numeric_Value=000000008000}', "");
    Expect(1, 68066, '\P{^Numeric_Value=000000008000}', "");
    Expect(0, 68067, '\p{Numeric_Value=000000008000}', "");
    Expect(1, 68067, '\p{^Numeric_Value=000000008000}', "");
    Expect(1, 68067, '\P{Numeric_Value=000000008000}', "");
    Expect(0, 68067, '\P{^Numeric_Value=000000008000}', "");
    Error('\p{Nv=/a/-+0_0_0_0_0_0_0_0_0_8000}');
    Error('\P{Nv=/a/-+0_0_0_0_0_0_0_0_0_8000}');
    Expect(1, 68066, '\p{Nv=+08_00_0}', "");
    Expect(0, 68066, '\p{^Nv=+08_00_0}', "");
    Expect(0, 68066, '\P{Nv=+08_00_0}', "");
    Expect(1, 68066, '\P{^Nv=+08_00_0}', "");
    Expect(0, 68067, '\p{Nv=+08_00_0}', "");
    Expect(1, 68067, '\p{^Nv=+08_00_0}', "");
    Expect(1, 68067, '\P{Nv=+08_00_0}', "");
    Expect(0, 68067, '\P{^Nv=+08_00_0}', "");
    Error('\p{Is_Numeric_Value=/a/_+08000}');
    Error('\P{Is_Numeric_Value=/a/_+08000}');
    Expect(1, 68066, '\p{Is_Numeric_Value=00008000}', "");
    Expect(0, 68066, '\p{^Is_Numeric_Value=00008000}', "");
    Expect(0, 68066, '\P{Is_Numeric_Value=00008000}', "");
    Expect(1, 68066, '\P{^Is_Numeric_Value=00008000}', "");
    Expect(0, 68067, '\p{Is_Numeric_Value=00008000}', "");
    Expect(1, 68067, '\p{^Is_Numeric_Value=00008000}', "");
    Expect(1, 68067, '\P{Is_Numeric_Value=00008000}', "");
    Expect(0, 68067, '\P{^Is_Numeric_Value=00008000}', "");
    Error('\p{Is_Nv=:=-00_00_80_00}');
    Error('\P{Is_Nv=:=-00_00_80_00}');
    Expect(1, 68066, '\p{Is_Nv=000008000}', "");
    Expect(0, 68066, '\p{^Is_Nv=000008000}', "");
    Expect(0, 68066, '\P{Is_Nv=000008000}', "");
    Expect(1, 68066, '\P{^Is_Nv=000008000}', "");
    Expect(0, 68067, '\p{Is_Nv=000008000}', "");
    Expect(1, 68067, '\p{^Is_Nv=000008000}', "");
    Expect(1, 68067, '\P{Is_Nv=000008000}', "");
    Expect(0, 68067, '\P{^Is_Nv=000008000}', "");
    Error('\p{Numeric_Value= :=0000080000}');
    Error('\P{Numeric_Value= :=0000080000}');
    Expect(1, 68075, '\p{Numeric_Value=0080000}', "");
    Expect(0, 68075, '\p{^Numeric_Value=0080000}', "");
    Expect(0, 68075, '\P{Numeric_Value=0080000}', "");
    Expect(1, 68075, '\P{^Numeric_Value=0080000}', "");
    Expect(0, 68076, '\p{Numeric_Value=0080000}', "");
    Expect(1, 68076, '\p{^Numeric_Value=0080000}', "");
    Expect(1, 68076, '\P{Numeric_Value=0080000}', "");
    Expect(0, 68076, '\P{^Numeric_Value=0080000}', "");
    Error('\p{Nv:   /a/	-00000080000}');
    Error('\P{Nv:   /a/	-00000080000}');
    Expect(1, 68075, '\p{Nv=+80000}', "");
    Expect(0, 68075, '\p{^Nv=+80000}', "");
    Expect(0, 68075, '\P{Nv=+80000}', "");
    Expect(1, 68075, '\P{^Nv=+80000}', "");
    Expect(0, 68076, '\p{Nv=+80000}', "");
    Expect(1, 68076, '\p{^Nv=+80000}', "");
    Expect(1, 68076, '\P{Nv=+80000}', "");
    Expect(0, 68076, '\P{^Nv=+80000}', "");
    Error('\p{Is_Numeric_Value=/a/	+000080000}');
    Error('\P{Is_Numeric_Value=/a/	+000080000}');
    Expect(1, 68075, '\p{Is_Numeric_Value=000008000_0}', "");
    Expect(0, 68075, '\p{^Is_Numeric_Value=000008000_0}', "");
    Expect(0, 68075, '\P{Is_Numeric_Value=000008000_0}', "");
    Expect(1, 68075, '\P{^Is_Numeric_Value=000008000_0}', "");
    Expect(0, 68076, '\p{Is_Numeric_Value=000008000_0}', "");
    Expect(1, 68076, '\p{^Is_Numeric_Value=000008000_0}', "");
    Expect(1, 68076, '\P{Is_Numeric_Value=000008000_0}', "");
    Expect(0, 68076, '\P{^Is_Numeric_Value=000008000_0}', "");
    Error('\p{Is_Nv=_/a/0080000}');
    Error('\P{Is_Nv=_/a/0080000}');
    Expect(1, 68075, '\p{Is_Nv=0000_0000_8000_0}', "");
    Expect(0, 68075, '\p{^Is_Nv=0000_0000_8000_0}', "");
    Expect(0, 68075, '\P{Is_Nv=0000_0000_8000_0}', "");
    Expect(1, 68075, '\P{^Is_Nv=0000_0000_8000_0}', "");
    Expect(0, 68076, '\p{Is_Nv=0000_0000_8000_0}', "");
    Expect(1, 68076, '\p{^Is_Nv=0000_0000_8000_0}', "");
    Expect(1, 68076, '\P{Is_Nv=0000_0000_8000_0}', "");
    Expect(0, 68076, '\P{^Is_Nv=0000_0000_8000_0}', "");
    Error('\p{Numeric_Value=/a/__00800000}');
    Error('\P{Numeric_Value=/a/__00800000}');
    Expect(1, 68084, '\p{Numeric_Value=+000000800000}', "");
    Expect(0, 68084, '\p{^Numeric_Value=+000000800000}', "");
    Expect(0, 68084, '\P{Numeric_Value=+000000800000}', "");
    Expect(1, 68084, '\P{^Numeric_Value=+000000800000}', "");
    Expect(0, 68085, '\p{Numeric_Value=+000000800000}', "");
    Expect(1, 68085, '\p{^Numeric_Value=+000000800000}', "");
    Expect(1, 68085, '\P{Numeric_Value=+000000800000}', "");
    Expect(0, 68085, '\P{^Numeric_Value=+000000800000}', "");
    Error('\p{Nv=/a/__0000000800000}');
    Error('\P{Nv=/a/__0000000800000}');
    Expect(1, 68084, '\p{Nv=+00_00_08_00_000}', "");
    Expect(0, 68084, '\p{^Nv=+00_00_08_00_000}', "");
    Expect(0, 68084, '\P{Nv=+00_00_08_00_000}', "");
    Expect(1, 68084, '\P{^Nv=+00_00_08_00_000}', "");
    Expect(0, 68085, '\p{Nv=+00_00_08_00_000}', "");
    Expect(1, 68085, '\p{^Nv=+00_00_08_00_000}', "");
    Expect(1, 68085, '\P{Nv=+00_00_08_00_000}', "");
    Expect(0, 68085, '\P{^Nv=+00_00_08_00_000}', "");
    Error('\p{Is_Numeric_Value=/a/+0000000800000}');
    Error('\P{Is_Numeric_Value=/a/+0000000800000}');
    Expect(1, 68084, '\p{Is_Numeric_Value=000000000800000}', "");
    Expect(0, 68084, '\p{^Is_Numeric_Value=000000000800000}', "");
    Expect(0, 68084, '\P{Is_Numeric_Value=000000000800000}', "");
    Expect(1, 68084, '\P{^Is_Numeric_Value=000000000800000}', "");
    Expect(0, 68085, '\p{Is_Numeric_Value=000000000800000}', "");
    Expect(1, 68085, '\p{^Is_Numeric_Value=000000000800000}', "");
    Expect(1, 68085, '\P{Is_Numeric_Value=000000000800000}', "");
    Expect(0, 68085, '\P{^Is_Numeric_Value=000000000800000}', "");
    Error('\p{Is_Nv=:= 0000000800000}');
    Error('\P{Is_Nv=:= 0000000800000}');
    Expect(1, 68084, '\p{Is_Nv:   +000000000800000}', "");
    Expect(0, 68084, '\p{^Is_Nv:   +000000000800000}', "");
    Expect(0, 68084, '\P{Is_Nv:   +000000000800000}', "");
    Expect(1, 68084, '\P{^Is_Nv:   +000000000800000}', "");
    Expect(0, 68085, '\p{Is_Nv:   +000000000800000}', "");
    Expect(1, 68085, '\p{^Is_Nv:   +000000000800000}', "");
    Expect(1, 68085, '\P{Is_Nv:   +000000000800000}', "");
    Expect(0, 68085, '\P{^Is_Nv:   +000000000800000}', "");
    Error('\p{Numeric_Value=_0_9/a/}');
    Error('\P{Numeric_Value=_0_9/a/}');
    Expect(1, 194704, '\p{Numeric_Value=+000000009}', "");
    Expect(0, 194704, '\p{^Numeric_Value=+000000009}', "");
    Expect(0, 194704, '\P{Numeric_Value=+000000009}', "");
    Expect(1, 194704, '\P{^Numeric_Value=+000000009}', "");
    Expect(0, 194705, '\p{Numeric_Value=+000000009}', "");
    Expect(1, 194705, '\p{^Numeric_Value=+000000009}', "");
    Expect(1, 194705, '\P{Numeric_Value=+000000009}', "");
    Expect(0, 194705, '\P{^Numeric_Value=+000000009}', "");
    Error('\p{Nv=:=000009}');
    Error('\P{Nv=:=000009}');
    Expect(1, 194704, '\p{Nv=009}', "");
    Expect(0, 194704, '\p{^Nv=009}', "");
    Expect(0, 194704, '\P{Nv=009}', "");
    Expect(1, 194704, '\P{^Nv=009}', "");
    Expect(0, 194705, '\p{Nv=009}', "");
    Expect(1, 194705, '\p{^Nv=009}', "");
    Expect(1, 194705, '\P{Nv=009}', "");
    Expect(0, 194705, '\P{^Nv=009}', "");
    Error('\p{Is_Numeric_Value=	:=+0000_0000_9}');
    Error('\P{Is_Numeric_Value=	:=+0000_0000_9}');
    Expect(1, 194704, '\p{Is_Numeric_Value=0000009}', "");
    Expect(0, 194704, '\p{^Is_Numeric_Value=0000009}', "");
    Expect(0, 194704, '\P{Is_Numeric_Value=0000009}', "");
    Expect(1, 194704, '\P{^Is_Numeric_Value=0000009}', "");
    Expect(0, 194705, '\p{Is_Numeric_Value=0000009}', "");
    Expect(1, 194705, '\p{^Is_Numeric_Value=0000009}', "");
    Expect(1, 194705, '\P{Is_Numeric_Value=0000009}', "");
    Expect(0, 194705, '\P{^Is_Numeric_Value=0000009}', "");
    Error('\p{Is_Nv=/a/_-09}');
    Error('\P{Is_Nv=/a/_-09}');
    Expect(1, 194704, '\p{Is_Nv=0_0_0_0_0_0_09}', "");
    Expect(0, 194704, '\p{^Is_Nv=0_0_0_0_0_0_09}', "");
    Expect(0, 194704, '\P{Is_Nv=0_0_0_0_0_0_09}', "");
    Expect(1, 194704, '\P{^Is_Nv=0_0_0_0_0_0_09}', "");
    Expect(0, 194705, '\p{Is_Nv=0_0_0_0_0_0_09}', "");
    Expect(1, 194705, '\p{^Is_Nv=0_0_0_0_0_0_09}', "");
    Expect(1, 194705, '\P{Is_Nv=0_0_0_0_0_0_09}', "");
    Expect(0, 194705, '\P{^Is_Nv=0_0_0_0_0_0_09}', "");
    Error('\p{Numeric_Value= /a/0000009/000000002}');
    Error('\P{Numeric_Value= /a/0000009/000000002}');
    Expect(1, 3886, '\p{Numeric_Value=+000009/2}', "");
    Expect(0, 3886, '\p{^Numeric_Value=+000009/2}', "");
    Expect(0, 3886, '\P{Numeric_Value=+000009/2}', "");
    Expect(1, 3886, '\P{^Numeric_Value=+000009/2}', "");
    Expect(0, 3887, '\p{Numeric_Value=+000009/2}', "");
    Expect(1, 3887, '\p{^Numeric_Value=+000009/2}', "");
    Expect(1, 3887, '\P{Numeric_Value=+000009/2}', "");
    Expect(0, 3887, '\P{^Numeric_Value=+000009/2}', "");
    Expect(1, 3886, '\p{Numeric_Value: 4.500}', "");
    Expect(0, 3886, '\p{^Numeric_Value: 4.500}', "");
    Expect(0, 3886, '\P{Numeric_Value: 4.500}', "");
    Expect(1, 3886, '\P{^Numeric_Value: 4.500}', "");
    Expect(0, 3887, '\p{Numeric_Value: 4.500}', "");
    Expect(1, 3887, '\p{^Numeric_Value: 4.500}', "");
    Expect(1, 3887, '\P{Numeric_Value: 4.500}', "");
    Expect(0, 3887, '\P{^Numeric_Value: 4.500}', "");
    Error('\p{Nv=:= 	+0009/0002}');
    Error('\P{Nv=:= 	+0009/0002}');
    Expect(1, 3886, '\p{Nv=000009/0002}', "");
    Expect(0, 3886, '\p{^Nv=000009/0002}', "");
    Expect(0, 3886, '\P{Nv=000009/0002}', "");
    Expect(1, 3886, '\P{^Nv=000009/0002}', "");
    Expect(0, 3887, '\p{Nv=000009/0002}', "");
    Expect(1, 3887, '\p{^Nv=000009/0002}', "");
    Expect(1, 3887, '\P{Nv=000009/0002}', "");
    Expect(0, 3887, '\P{^Nv=000009/0002}', "");
    Expect(1, 3886, '\p{Nv=4.500}', "");
    Expect(0, 3886, '\p{^Nv=4.500}', "");
    Expect(0, 3886, '\P{Nv=4.500}', "");
    Expect(1, 3886, '\P{^Nv=4.500}', "");
    Expect(0, 3887, '\p{Nv=4.500}', "");
    Expect(1, 3887, '\p{^Nv=4.500}', "");
    Expect(1, 3887, '\P{Nv=4.500}', "");
    Expect(0, 3887, '\P{^Nv=4.500}', "");
    Error('\p{Is_Numeric_Value=:=	+0000000009/0002}');
    Error('\P{Is_Numeric_Value=:=	+0000000009/0002}');
    Expect(1, 3886, '\p{Is_Numeric_Value=0000000009/0002}', "");
    Expect(0, 3886, '\p{^Is_Numeric_Value=0000000009/0002}', "");
    Expect(0, 3886, '\P{Is_Numeric_Value=0000000009/0002}', "");
    Expect(1, 3886, '\P{^Is_Numeric_Value=0000000009/0002}', "");
    Expect(0, 3887, '\p{Is_Numeric_Value=0000000009/0002}', "");
    Expect(1, 3887, '\p{^Is_Numeric_Value=0000000009/0002}', "");
    Expect(1, 3887, '\P{Is_Numeric_Value=0000000009/0002}', "");
    Expect(0, 3887, '\P{^Is_Numeric_Value=0000000009/0002}', "");
    Expect(1, 3886, '\p{Is_Numeric_Value=4.500}', "");
    Expect(0, 3886, '\p{^Is_Numeric_Value=4.500}', "");
    Expect(0, 3886, '\P{Is_Numeric_Value=4.500}', "");
    Expect(1, 3886, '\P{^Is_Numeric_Value=4.500}', "");
    Expect(0, 3887, '\p{Is_Numeric_Value=4.500}', "");
    Expect(1, 3887, '\p{^Is_Numeric_Value=4.500}', "");
    Expect(1, 3887, '\P{Is_Numeric_Value=4.500}', "");
    Expect(0, 3887, '\P{^Is_Numeric_Value=4.500}', "");
    Error('\p{Is_Nv=:= +000009/0000000002}');
    Error('\P{Is_Nv=:= +000009/0000000002}');
    Expect(1, 3886, '\p{Is_Nv=009/0000002}', "");
    Expect(0, 3886, '\p{^Is_Nv=009/0000002}', "");
    Expect(0, 3886, '\P{Is_Nv=009/0000002}', "");
    Expect(1, 3886, '\P{^Is_Nv=009/0000002}', "");
    Expect(0, 3887, '\p{Is_Nv=009/0000002}', "");
    Expect(1, 3887, '\p{^Is_Nv=009/0000002}', "");
    Expect(1, 3887, '\P{Is_Nv=009/0000002}', "");
    Expect(0, 3887, '\P{^Is_Nv=009/0000002}', "");
    Expect(1, 3886, '\p{Is_Nv=4.500}', "");
    Expect(0, 3886, '\p{^Is_Nv=4.500}', "");
    Expect(0, 3886, '\P{Is_Nv=4.500}', "");
    Expect(1, 3886, '\P{^Is_Nv=4.500}', "");
    Expect(0, 3887, '\p{Is_Nv=4.500}', "");
    Expect(1, 3887, '\p{^Is_Nv=4.500}', "");
    Expect(1, 3887, '\P{Is_Nv=4.500}', "");
    Expect(0, 3887, '\P{^Is_Nv=4.500}', "");
    Error('\p{Numeric_Value=:=--+00000090}');
    Error('\P{Numeric_Value=:=--+00000090}');
    Expect(1, 119665, '\p{Numeric_Value=90}', "");
    Expect(0, 119665, '\p{^Numeric_Value=90}', "");
    Expect(0, 119665, '\P{Numeric_Value=90}', "");
    Expect(1, 119665, '\P{^Numeric_Value=90}', "");
    Expect(0, 119666, '\p{Numeric_Value=90}', "");
    Expect(1, 119666, '\p{^Numeric_Value=90}', "");
    Expect(1, 119666, '\P{Numeric_Value=90}', "");
    Expect(0, 119666, '\P{^Numeric_Value=90}', "");
    Error('\p{Nv=	:=+0000090}');
    Error('\P{Nv=	:=+0000090}');
    Expect(1, 119665, '\p{Nv=+000090}', "");
    Expect(0, 119665, '\p{^Nv=+000090}', "");
    Expect(0, 119665, '\P{Nv=+000090}', "");
    Expect(1, 119665, '\P{^Nv=+000090}', "");
    Expect(0, 119666, '\p{Nv=+000090}', "");
    Expect(1, 119666, '\p{^Nv=+000090}', "");
    Expect(1, 119666, '\P{Nv=+000090}', "");
    Expect(0, 119666, '\P{^Nv=+000090}', "");
    Error('\p{Is_Numeric_Value=/a/-	0_0_0_90}');
    Error('\P{Is_Numeric_Value=/a/-	0_0_0_90}');
    Expect(1, 119665, '\p{Is_Numeric_Value=00000000090}', "");
    Expect(0, 119665, '\p{^Is_Numeric_Value=00000000090}', "");
    Expect(0, 119665, '\P{Is_Numeric_Value=00000000090}', "");
    Expect(1, 119665, '\P{^Is_Numeric_Value=00000000090}', "");
    Expect(0, 119666, '\p{Is_Numeric_Value=00000000090}', "");
    Expect(1, 119666, '\p{^Is_Numeric_Value=00000000090}', "");
    Expect(1, 119666, '\P{Is_Numeric_Value=00000000090}', "");
    Expect(0, 119666, '\P{^Is_Numeric_Value=00000000090}', "");
    Error('\p{Is_Nv=/a/ -0_0_0_90}');
    Error('\P{Is_Nv=/a/ -0_0_0_90}');
    Expect(1, 119665, '\p{Is_Nv=00000000090}', "");
    Expect(0, 119665, '\p{^Is_Nv=00000000090}', "");
    Expect(0, 119665, '\P{Is_Nv=00000000090}', "");
    Expect(1, 119665, '\P{^Is_Nv=00000000090}', "");
    Expect(0, 119666, '\p{Is_Nv=00000000090}', "");
    Expect(1, 119666, '\p{^Is_Nv=00000000090}', "");
    Expect(1, 119666, '\P{Is_Nv=00000000090}', "");
    Expect(0, 119666, '\P{^Is_Nv=00000000090}', "");
    Error('\p{Numeric_Value=	:=00000000900}');
    Error('\P{Numeric_Value=	:=00000000900}');
    Expect(1, 69242, '\p{Numeric_Value=00000000900}', "");
    Expect(0, 69242, '\p{^Numeric_Value=00000000900}', "");
    Expect(0, 69242, '\P{Numeric_Value=00000000900}', "");
    Expect(1, 69242, '\P{^Numeric_Value=00000000900}', "");
    Expect(0, 69243, '\p{Numeric_Value=00000000900}', "");
    Expect(1, 69243, '\p{^Numeric_Value=00000000900}', "");
    Expect(1, 69243, '\P{Numeric_Value=00000000900}', "");
    Expect(0, 69243, '\P{^Numeric_Value=00000000900}', "");
    Error('\p{Nv=:=-0000090_0}');
    Error('\P{Nv=:=-0000090_0}');
    Expect(1, 69242, '\p{Nv=000900}', "");
    Expect(0, 69242, '\p{^Nv=000900}', "");
    Expect(0, 69242, '\P{Nv=000900}', "");
    Expect(1, 69242, '\P{^Nv=000900}', "");
    Expect(0, 69243, '\p{Nv=000900}', "");
    Expect(1, 69243, '\p{^Nv=000900}', "");
    Expect(1, 69243, '\P{Nv=000900}', "");
    Expect(0, 69243, '\P{^Nv=000900}', "");
    Error('\p{Is_Numeric_Value= +00900:=}');
    Error('\P{Is_Numeric_Value= +00900:=}');
    Expect(1, 69242, '\p{Is_Numeric_Value=000900}', "");
    Expect(0, 69242, '\p{^Is_Numeric_Value=000900}', "");
    Expect(0, 69242, '\P{Is_Numeric_Value=000900}', "");
    Expect(1, 69242, '\P{^Is_Numeric_Value=000900}', "");
    Expect(0, 69243, '\p{Is_Numeric_Value=000900}', "");
    Expect(1, 69243, '\p{^Is_Numeric_Value=000900}', "");
    Expect(1, 69243, '\P{Is_Numeric_Value=000900}', "");
    Expect(0, 69243, '\P{^Is_Numeric_Value=000900}', "");
    Error('\p{Is_Nv=		0000900:=}');
    Error('\P{Is_Nv=		0000900:=}');
    Expect(1, 69242, '\p{Is_Nv=0900}', "");
    Expect(0, 69242, '\p{^Is_Nv=0900}', "");
    Expect(0, 69242, '\P{Is_Nv=0900}', "");
    Expect(1, 69242, '\P{^Is_Nv=0900}', "");
    Expect(0, 69243, '\p{Is_Nv=0900}', "");
    Expect(1, 69243, '\p{^Is_Nv=0900}', "");
    Expect(1, 69243, '\P{Is_Nv=0900}', "");
    Expect(0, 69243, '\P{^Is_Nv=0900}', "");
    Error('\p{Numeric_Value=_	00009000/a/}');
    Error('\P{Numeric_Value=_	00009000/a/}');
    Expect(1, 68067, '\p{Numeric_Value=09000}', "");
    Expect(0, 68067, '\p{^Numeric_Value=09000}', "");
    Expect(0, 68067, '\P{Numeric_Value=09000}', "");
    Expect(1, 68067, '\P{^Numeric_Value=09000}', "");
    Expect(0, 68068, '\p{Numeric_Value=09000}', "");
    Expect(1, 68068, '\p{^Numeric_Value=09000}', "");
    Expect(1, 68068, '\P{Numeric_Value=09000}', "");
    Expect(0, 68068, '\P{^Numeric_Value=09000}', "");
    Error('\p{Nv=:=_ 0000900_0}');
    Error('\P{Nv=:=_ 0000900_0}');
    Expect(1, 68067, '\p{Nv=+00000009000}', "");
    Expect(0, 68067, '\p{^Nv=+00000009000}', "");
    Expect(0, 68067, '\P{Nv=+00000009000}', "");
    Expect(1, 68067, '\P{^Nv=+00000009000}', "");
    Expect(0, 68068, '\p{Nv=+00000009000}', "");
    Expect(1, 68068, '\p{^Nv=+00000009000}', "");
    Expect(1, 68068, '\P{Nv=+00000009000}', "");
    Expect(0, 68068, '\P{^Nv=+00000009000}', "");
    Error('\p{Is_Numeric_Value=:=+009000}');
    Error('\P{Is_Numeric_Value=:=+009000}');
    Expect(1, 68067, '\p{Is_Numeric_Value=00009000}', "");
    Expect(0, 68067, '\p{^Is_Numeric_Value=00009000}', "");
    Expect(0, 68067, '\P{Is_Numeric_Value=00009000}', "");
    Expect(1, 68067, '\P{^Is_Numeric_Value=00009000}', "");
    Expect(0, 68068, '\p{Is_Numeric_Value=00009000}', "");
    Expect(1, 68068, '\p{^Is_Numeric_Value=00009000}', "");
    Expect(1, 68068, '\P{Is_Numeric_Value=00009000}', "");
    Expect(0, 68068, '\P{^Is_Numeric_Value=00009000}', "");
    Error('\p{Is_Nv=_-000_900_0:=}');
    Error('\P{Is_Nv=_-000_900_0:=}');
    Expect(1, 68067, '\p{Is_Nv=0009000}', "");
    Expect(0, 68067, '\p{^Is_Nv=0009000}', "");
    Expect(0, 68067, '\P{Is_Nv=0009000}', "");
    Expect(1, 68067, '\P{^Is_Nv=0009000}', "");
    Expect(0, 68068, '\p{Is_Nv=0009000}', "");
    Expect(1, 68068, '\p{^Is_Nv=0009000}', "");
    Expect(1, 68068, '\P{Is_Nv=0009000}', "");
    Expect(0, 68068, '\P{^Is_Nv=0009000}', "");
    Error('\p{Numeric_Value= +00000090000/a/}');
    Error('\P{Numeric_Value= +00000090000/a/}');
    Expect(1, 68076, '\p{Numeric_Value=0_0_9_0_000}', "");
    Expect(0, 68076, '\p{^Numeric_Value=0_0_9_0_000}', "");
    Expect(0, 68076, '\P{Numeric_Value=0_0_9_0_000}', "");
    Expect(1, 68076, '\P{^Numeric_Value=0_0_9_0_000}', "");
    Expect(0, 68077, '\p{Numeric_Value=0_0_9_0_000}', "");
    Expect(1, 68077, '\p{^Numeric_Value=0_0_9_0_000}', "");
    Expect(1, 68077, '\P{Numeric_Value=0_0_9_0_000}', "");
    Expect(0, 68077, '\P{^Numeric_Value=0_0_9_0_000}', "");
    Error('\p{Nv=:=  0000090000}');
    Error('\P{Nv=:=  0000090000}');
    Expect(1, 68076, '\p{Nv: 9000_0}', "");
    Expect(0, 68076, '\p{^Nv: 9000_0}', "");
    Expect(0, 68076, '\P{Nv: 9000_0}', "");
    Expect(1, 68076, '\P{^Nv: 9000_0}', "");
    Expect(0, 68077, '\p{Nv: 9000_0}', "");
    Expect(1, 68077, '\p{^Nv: 9000_0}', "");
}
if (!$::TESTCHUNK or $::TESTCHUNK == 3) {
    Expect(1, 68077, '\P{Nv: 9000_0}', "");
    Expect(0, 68077, '\P{^Nv: 9000_0}', "");
    Error('\p{Is_Numeric_Value=/a/+0_0_0_0_0_0_0_0_090000}');
    Error('\P{Is_Numeric_Value=/a/+0_0_0_0_0_0_0_0_090000}');
    Expect(1, 68076, '\p{Is_Numeric_Value=09000_0}', "");
    Expect(0, 68076, '\p{^Is_Numeric_Value=09000_0}', "");
    Expect(0, 68076, '\P{Is_Numeric_Value=09000_0}', "");
    Expect(1, 68076, '\P{^Is_Numeric_Value=09000_0}', "");
    Expect(0, 68077, '\p{Is_Numeric_Value=09000_0}', "");
    Expect(1, 68077, '\p{^Is_Numeric_Value=09000_0}', "");
    Expect(1, 68077, '\P{Is_Numeric_Value=09000_0}', "");
    Expect(0, 68077, '\P{^Is_Numeric_Value=09000_0}', "");
    Error('\p{Is_Nv=-0_0_0_0_0_0_9_0_000/a/}');
    Error('\P{Is_Nv=-0_0_0_0_0_0_9_0_000/a/}');
    Expect(1, 68076, '\p{Is_Nv=0000000090000}', "");
    Expect(0, 68076, '\p{^Is_Nv=0000000090000}', "");
    Expect(0, 68076, '\P{Is_Nv=0000000090000}', "");
    Expect(1, 68076, '\P{^Is_Nv=0000000090000}', "");
    Expect(0, 68077, '\p{Is_Nv=0000000090000}', "");
    Expect(1, 68077, '\p{^Is_Nv=0000000090000}', "");
    Expect(1, 68077, '\P{Is_Nv=0000000090000}', "");
    Expect(0, 68077, '\P{^Is_Nv=0000000090000}', "");
    Error('\p{Numeric_Value=_/a/0_0_0_0_0_0_0_0_0900000}');
    Error('\P{Numeric_Value=_/a/0_0_0_0_0_0_0_0_0900000}');
    Expect(1, 68085, '\p{Numeric_Value=00_00_00_90_00_00}', "");
    Expect(0, 68085, '\p{^Numeric_Value=00_00_00_90_00_00}', "");
    Expect(0, 68085, '\P{Numeric_Value=00_00_00_90_00_00}', "");
    Expect(1, 68085, '\P{^Numeric_Value=00_00_00_90_00_00}', "");
    Expect(0, 68086, '\p{Numeric_Value=00_00_00_90_00_00}', "");
    Expect(1, 68086, '\p{^Numeric_Value=00_00_00_90_00_00}', "");
    Expect(1, 68086, '\P{Numeric_Value=00_00_00_90_00_00}', "");
    Expect(0, 68086, '\P{^Numeric_Value=00_00_00_90_00_00}', "");
    Error('\p{Nv=:=_0000_0000_9000_00}');
    Error('\P{Nv=:=_0000_0000_9000_00}');
    Expect(1, 68085, '\p{Nv=00_00_09_00_000}', "");
    Expect(0, 68085, '\p{^Nv=00_00_09_00_000}', "");
    Expect(0, 68085, '\P{Nv=00_00_09_00_000}', "");
    Expect(1, 68085, '\P{^Nv=00_00_09_00_000}', "");
    Expect(0, 68086, '\p{Nv=00_00_09_00_000}', "");
    Expect(1, 68086, '\p{^Nv=00_00_09_00_000}', "");
    Expect(1, 68086, '\P{Nv=00_00_09_00_000}', "");
    Expect(0, 68086, '\P{^Nv=00_00_09_00_000}', "");
    Error('\p{Is_Numeric_Value=__00000000900000/a/}');
    Error('\P{Is_Numeric_Value=__00000000900000/a/}');
    Expect(1, 68085, '\p{Is_Numeric_Value=+00000900000}', "");
    Expect(0, 68085, '\p{^Is_Numeric_Value=+00000900000}', "");
    Expect(0, 68085, '\P{Is_Numeric_Value=+00000900000}', "");
    Expect(1, 68085, '\P{^Is_Numeric_Value=+00000900000}', "");
    Expect(0, 68086, '\p{Is_Numeric_Value=+00000900000}', "");
    Expect(1, 68086, '\p{^Is_Numeric_Value=+00000900000}', "");
    Expect(1, 68086, '\P{Is_Numeric_Value=+00000900000}', "");
    Expect(0, 68086, '\P{^Is_Numeric_Value=+00000900000}', "");
    Error('\p{Is_Nv=:=-_+00_00_00_09_00_000}');
    Error('\P{Is_Nv=:=-_+00_00_00_09_00_000}');
    Expect(1, 68085, '\p{Is_Nv=900000}', "");
    Expect(0, 68085, '\p{^Is_Nv=900000}', "");
    Expect(0, 68085, '\P{Is_Nv=900000}', "");
    Expect(1, 68085, '\P{^Is_Nv=900000}', "");
    Expect(0, 68086, '\p{Is_Nv=900000}', "");
    Expect(1, 68086, '\p{^Is_Nv=900000}', "");
    Expect(1, 68086, '\P{Is_Nv=900000}', "");
    Expect(0, 68086, '\P{^Is_Nv=900000}', "");
    Error('\p{Numeric_Value=:=__NaN}');
    Error('\P{Numeric_Value=:=__NaN}');
    Expect(1, 194705, '\p{Numeric_Value=nan}', "");
    Expect(0, 194705, '\p{^Numeric_Value=nan}', "");
    Expect(0, 194705, '\P{Numeric_Value=nan}', "");
    Expect(1, 194705, '\P{^Numeric_Value=nan}', "");
    Expect(0, 194704, '\p{Numeric_Value=nan}', "");
    Expect(1, 194704, '\p{^Numeric_Value=nan}', "");
    Expect(1, 194704, '\P{Numeric_Value=nan}', "");
    Expect(0, 194704, '\P{^Numeric_Value=nan}', "");
    Expect(1, 194705, '\p{Numeric_Value= NaN}', "");
    Expect(0, 194705, '\p{^Numeric_Value= NaN}', "");
    Expect(0, 194705, '\P{Numeric_Value= NaN}', "");
    Expect(1, 194705, '\P{^Numeric_Value= NaN}', "");
    Expect(0, 194704, '\p{Numeric_Value= NaN}', "");
    Expect(1, 194704, '\p{^Numeric_Value= NaN}', "");
    Expect(1, 194704, '\P{Numeric_Value= NaN}', "");
    Expect(0, 194704, '\P{^Numeric_Value= NaN}', "");
    Error('\p{Nv= /a/nan}');
    Error('\P{Nv= /a/nan}');
    Expect(1, 194705, '\p{Nv=nan}', "");
    Expect(0, 194705, '\p{^Nv=nan}', "");
    Expect(0, 194705, '\P{Nv=nan}', "");
    Expect(1, 194705, '\P{^Nv=nan}', "");
    Expect(0, 194704, '\p{Nv=nan}', "");
    Expect(1, 194704, '\p{^Nv=nan}', "");
    Expect(1, 194704, '\P{Nv=nan}', "");
    Expect(0, 194704, '\P{^Nv=nan}', "");
    Expect(1, 194705, '\p{Nv=_nan}', "");
    Expect(0, 194705, '\p{^Nv=_nan}', "");
    Expect(0, 194705, '\P{Nv=_nan}', "");
    Expect(1, 194705, '\P{^Nv=_nan}', "");
    Expect(0, 194704, '\p{Nv=_nan}', "");
    Expect(1, 194704, '\p{^Nv=_nan}', "");
    Expect(1, 194704, '\P{Nv=_nan}', "");
    Expect(0, 194704, '\P{^Nv=_nan}', "");
    Error('\p{Is_Numeric_Value=	/a/NAN}');
    Error('\P{Is_Numeric_Value=	/a/NAN}');
    Expect(1, 194705, '\p{Is_Numeric_Value=nan}', "");
    Expect(0, 194705, '\p{^Is_Numeric_Value=nan}', "");
    Expect(0, 194705, '\P{Is_Numeric_Value=nan}', "");
    Expect(1, 194705, '\P{^Is_Numeric_Value=nan}', "");
    Expect(0, 194704, '\p{Is_Numeric_Value=nan}', "");
    Expect(1, 194704, '\p{^Is_Numeric_Value=nan}', "");
    Expect(1, 194704, '\P{Is_Numeric_Value=nan}', "");
    Expect(0, 194704, '\P{^Is_Numeric_Value=nan}', "");
    Expect(1, 194705, '\p{Is_Numeric_Value= nan}', "");
    Expect(0, 194705, '\p{^Is_Numeric_Value= nan}', "");
    Expect(0, 194705, '\P{Is_Numeric_Value= nan}', "");
    Expect(1, 194705, '\P{^Is_Numeric_Value= nan}', "");
    Expect(0, 194704, '\p{Is_Numeric_Value= nan}', "");
    Expect(1, 194704, '\p{^Is_Numeric_Value= nan}', "");
    Expect(1, 194704, '\P{Is_Numeric_Value= nan}', "");
    Expect(0, 194704, '\P{^Is_Numeric_Value= nan}', "");
    Error('\p{Is_Nv=/a/		NAN}');
    Error('\P{Is_Nv=/a/		NAN}');
    Expect(1, 194705, '\p{Is_Nv=nan}', "");
    Expect(0, 194705, '\p{^Is_Nv=nan}', "");
    Expect(0, 194705, '\P{Is_Nv=nan}', "");
    Expect(1, 194705, '\P{^Is_Nv=nan}', "");
    Expect(0, 194704, '\p{Is_Nv=nan}', "");
    Expect(1, 194704, '\p{^Is_Nv=nan}', "");
    Expect(1, 194704, '\P{Is_Nv=nan}', "");
    Expect(0, 194704, '\P{^Is_Nv=nan}', "");
    Expect(1, 194705, '\p{Is_Nv=_-nan}', "");
    Expect(0, 194705, '\p{^Is_Nv=_-nan}', "");
    Expect(0, 194705, '\P{Is_Nv=_-nan}', "");
    Expect(1, 194705, '\P{^Is_Nv=_-nan}', "");
    Expect(0, 194704, '\p{Is_Nv=_-nan}', "");
    Expect(1, 194704, '\p{^Is_Nv=_-nan}', "");
    Expect(1, 194704, '\P{Is_Nv=_-nan}', "");
    Expect(0, 194704, '\P{^Is_Nv=_-nan}', "");
    Error('\p{Other_Alphabetic=No}');
    Error('\P{Other_Alphabetic=No}');
    Error('\p{OAlpha=N}');
    Error('\P{OAlpha=N}');
    Error('\p{Is_Other_Alphabetic=F}');
    Error('\P{Is_Other_Alphabetic=F}');
    Error('\p{Is_OAlpha=False}');
    Error('\P{Is_OAlpha=False}');
    Error('\p{Other_Alphabetic=Yes}');
    Error('\P{Other_Alphabetic=Yes}');
    Error('\p{OAlpha=Y}');
    Error('\P{OAlpha=Y}');
    Error('\p{Is_Other_Alphabetic=T}');
    Error('\P{Is_Other_Alphabetic=T}');
    Error('\p{Is_OAlpha=True}');
    Error('\P{Is_OAlpha=True}');
    Error('\p{Other_Default_Ignorable_Code_Point=No}');
    Error('\P{Other_Default_Ignorable_Code_Point=No}');
    Error('\p{ODI=N}');
    Error('\P{ODI=N}');
    Error('\p{Is_Other_Default_Ignorable_Code_Point=F}');
    Error('\P{Is_Other_Default_Ignorable_Code_Point=F}');
    Error('\p{Is_ODI=False}');
    Error('\P{Is_ODI=False}');
    Error('\p{Other_Default_Ignorable_Code_Point=Yes}');
    Error('\P{Other_Default_Ignorable_Code_Point=Yes}');
    Error('\p{ODI=Y}');
    Error('\P{ODI=Y}');
    Error('\p{Is_Other_Default_Ignorable_Code_Point:T}');
    Error('\P{Is_Other_Default_Ignorable_Code_Point:T}');
    Error('\p{Is_ODI=True}');
    Error('\P{Is_ODI=True}');
    Error('\p{Other_Grapheme_Extend=No}');
    Error('\P{Other_Grapheme_Extend=No}');
    Error('\p{OGr_Ext=N}');
    Error('\P{OGr_Ext=N}');
    Error('\p{Is_Other_Grapheme_Extend=F}');
    Error('\P{Is_Other_Grapheme_Extend=F}');
    Error('\p{Is_OGr_Ext=False}');
    Error('\P{Is_OGr_Ext=False}');
    Error('\p{Other_Grapheme_Extend=Yes}');
    Error('\P{Other_Grapheme_Extend=Yes}');
    Error('\p{OGr_Ext=Y}');
    Error('\P{OGr_Ext=Y}');
    Error('\p{Is_Other_Grapheme_Extend=T}');
    Error('\P{Is_Other_Grapheme_Extend=T}');
    Error('\p{Is_OGr_Ext=True}');
    Error('\P{Is_OGr_Ext=True}');
    Error('\p{Other_ID_Continue=No}');
    Error('\P{Other_ID_Continue=No}');
    Error('\p{OIDC=N}');
    Error('\P{OIDC=N}');
    Error('\p{Is_Other_ID_Continue=F}');
    Error('\P{Is_Other_ID_Continue=F}');
    Error('\p{Is_OIDC: False}');
    Error('\P{Is_OIDC: False}');
    Error('\p{Other_ID_Continue=Yes}');
    Error('\P{Other_ID_Continue=Yes}');
    Error('\p{OIDC=Y}');
    Error('\P{OIDC=Y}');
    Error('\p{Is_Other_ID_Continue:	T}');
    Error('\P{Is_Other_ID_Continue:	T}');
    Error('\p{Is_OIDC=True}');
    Error('\P{Is_OIDC=True}');
    Error('\p{Other_ID_Start=No}');
    Error('\P{Other_ID_Start=No}');
    Error('\p{OIDS=N}');
    Error('\P{OIDS=N}');
    Error('\p{Is_Other_ID_Start=F}');
    Error('\P{Is_Other_ID_Start=F}');
    Error('\p{Is_OIDS=False}');
    Error('\P{Is_OIDS=False}');
    Error('\p{Other_ID_Start=Yes}');
    Error('\P{Other_ID_Start=Yes}');
    Error('\p{OIDS=Y}');
    Error('\P{OIDS=Y}');
    Error('\p{Is_Other_ID_Start:   T}');
    Error('\P{Is_Other_ID_Start:   T}');
    Error('\p{Is_OIDS=True}');
    Error('\P{Is_OIDS=True}');
    Error('\p{Other_Lowercase=No}');
    Error('\P{Other_Lowercase=No}');
    Error('\p{OLower=N}');
    Error('\P{OLower=N}');
    Error('\p{Is_Other_Lowercase=F}');
    Error('\P{Is_Other_Lowercase=F}');
    Error('\p{Is_OLower=False}');
    Error('\P{Is_OLower=False}');
    Error('\p{Other_Lowercase=Yes}');
    Error('\P{Other_Lowercase=Yes}');
    Error('\p{OLower=Y}');
    Error('\P{OLower=Y}');
    Error('\p{Is_Other_Lowercase=T}');
    Error('\P{Is_Other_Lowercase=T}');
    Error('\p{Is_OLower=True}');
    Error('\P{Is_OLower=True}');
    Error('\p{Other_Math=No}');
    Error('\P{Other_Math=No}');
    Error('\p{OMath=N}');
    Error('\P{OMath=N}');
    Error('\p{Is_Other_Math=F}');
    Error('\P{Is_Other_Math=F}');
    Error('\p{Is_OMath=False}');
    Error('\P{Is_OMath=False}');
    Error('\p{Other_Math=Yes}');
    Error('\P{Other_Math=Yes}');
    Error('\p{OMath:   Y}');
    Error('\P{OMath:   Y}');
    Error('\p{Is_Other_Math=T}');
    Error('\P{Is_Other_Math=T}');
    Error('\p{Is_OMath=True}');
    Error('\P{Is_OMath=True}');
    Error('\p{Other_Uppercase=No}');
    Error('\P{Other_Uppercase=No}');
    Error('\p{OUpper=N}');
    Error('\P{OUpper=N}');
    Error('\p{Is_Other_Uppercase=F}');
    Error('\P{Is_Other_Uppercase=F}');
    Error('\p{Is_OUpper:   False}');
    Error('\P{Is_OUpper:   False}');
    Error('\p{Other_Uppercase=Yes}');
    Error('\P{Other_Uppercase=Yes}');
    Error('\p{OUpper:	Y}');
    Error('\P{OUpper:	Y}');
    Error('\p{Is_Other_Uppercase=T}');
    Error('\P{Is_Other_Uppercase=T}');
    Error('\p{Is_OUpper=True}');
    Error('\P{Is_OUpper=True}');
    Error('\p{Pattern_Syntax=/a/No}');
    Error('\P{Pattern_Syntax=/a/No}');
    Expect(1, 65095, '\p{Pattern_Syntax=no}', "");
    Expect(0, 65095, '\p{^Pattern_Syntax=no}', "");
    Expect(0, 65095, '\P{Pattern_Syntax=no}', "");
    Expect(1, 65095, '\P{^Pattern_Syntax=no}', "");
    Expect(0, 65094, '\p{Pattern_Syntax=no}', "");
    Expect(1, 65094, '\p{^Pattern_Syntax=no}', "");
    Expect(1, 65094, '\P{Pattern_Syntax=no}', "");
    Expect(0, 65094, '\P{^Pattern_Syntax=no}', "");
    Expect(1, 65095, '\p{Pattern_Syntax=  No}', "");
    Expect(0, 65095, '\p{^Pattern_Syntax=  No}', "");
    Expect(0, 65095, '\P{Pattern_Syntax=  No}', "");
    Expect(1, 65095, '\P{^Pattern_Syntax=  No}', "");
    Expect(0, 65094, '\p{Pattern_Syntax=  No}', "");
    Expect(1, 65094, '\p{^Pattern_Syntax=  No}', "");
    Expect(1, 65094, '\P{Pattern_Syntax=  No}', "");
    Expect(0, 65094, '\P{^Pattern_Syntax=  No}', "");
    Error('\p{Pat_Syn=--n:=}');
    Error('\P{Pat_Syn=--n:=}');
    Expect(1, 65095, '\p{Pat_Syn=n}', "");
    Expect(0, 65095, '\p{^Pat_Syn=n}', "");
    Expect(0, 65095, '\P{Pat_Syn=n}', "");
    Expect(1, 65095, '\P{^Pat_Syn=n}', "");
    Expect(0, 65094, '\p{Pat_Syn=n}', "");
    Expect(1, 65094, '\p{^Pat_Syn=n}', "");
    Expect(1, 65094, '\P{Pat_Syn=n}', "");
    Expect(0, 65094, '\P{^Pat_Syn=n}', "");
    Expect(1, 65095, '\p{Pat_Syn:     N}', "");
    Expect(0, 65095, '\p{^Pat_Syn:     N}', "");
    Expect(0, 65095, '\P{Pat_Syn:     N}', "");
    Expect(1, 65095, '\P{^Pat_Syn:     N}', "");
    Expect(0, 65094, '\p{Pat_Syn:     N}', "");
    Expect(1, 65094, '\p{^Pat_Syn:     N}', "");
    Expect(1, 65094, '\P{Pat_Syn:     N}', "");
    Expect(0, 65094, '\P{^Pat_Syn:     N}', "");
    Error('\p{Is_Pattern_Syntax=:=-_F}');
    Error('\P{Is_Pattern_Syntax=:=-_F}');
    Expect(1, 65095, '\p{Is_Pattern_Syntax=f}', "");
    Expect(0, 65095, '\p{^Is_Pattern_Syntax=f}', "");
    Expect(0, 65095, '\P{Is_Pattern_Syntax=f}', "");
    Expect(1, 65095, '\P{^Is_Pattern_Syntax=f}', "");
    Expect(0, 65094, '\p{Is_Pattern_Syntax=f}', "");
    Expect(1, 65094, '\p{^Is_Pattern_Syntax=f}', "");
    Expect(1, 65094, '\P{Is_Pattern_Syntax=f}', "");
    Expect(0, 65094, '\P{^Is_Pattern_Syntax=f}', "");
    Expect(1, 65095, '\p{Is_Pattern_Syntax: -F}', "");
    Expect(0, 65095, '\p{^Is_Pattern_Syntax: -F}', "");
    Expect(0, 65095, '\P{Is_Pattern_Syntax: -F}', "");
    Expect(1, 65095, '\P{^Is_Pattern_Syntax: -F}', "");
    Expect(0, 65094, '\p{Is_Pattern_Syntax: -F}', "");
    Expect(1, 65094, '\p{^Is_Pattern_Syntax: -F}', "");
    Expect(1, 65094, '\P{Is_Pattern_Syntax: -F}', "");
    Expect(0, 65094, '\P{^Is_Pattern_Syntax: -F}', "");
    Error('\p{Is_Pat_Syn:   _:=False}');
    Error('\P{Is_Pat_Syn:   _:=False}');
    Expect(1, 65095, '\p{Is_Pat_Syn=false}', "");
    Expect(0, 65095, '\p{^Is_Pat_Syn=false}', "");
    Expect(0, 65095, '\P{Is_Pat_Syn=false}', "");
    Expect(1, 65095, '\P{^Is_Pat_Syn=false}', "");
    Expect(0, 65094, '\p{Is_Pat_Syn=false}', "");
    Expect(1, 65094, '\p{^Is_Pat_Syn=false}', "");
    Expect(1, 65094, '\P{Is_Pat_Syn=false}', "");
    Expect(0, 65094, '\P{^Is_Pat_Syn=false}', "");
    Expect(1, 65095, '\p{Is_Pat_Syn=_FALSE}', "");
    Expect(0, 65095, '\p{^Is_Pat_Syn=_FALSE}', "");
    Expect(0, 65095, '\P{Is_Pat_Syn=_FALSE}', "");
    Expect(1, 65095, '\P{^Is_Pat_Syn=_FALSE}', "");
    Expect(0, 65094, '\p{Is_Pat_Syn=_FALSE}', "");
    Expect(1, 65094, '\p{^Is_Pat_Syn=_FALSE}', "");
    Expect(1, 65094, '\P{Is_Pat_Syn=_FALSE}', "");
    Expect(0, 65094, '\P{^Is_Pat_Syn=_FALSE}', "");
    Error('\p{Pattern_Syntax=/a/_yes}');
    Error('\P{Pattern_Syntax=/a/_yes}');
    Expect(1, 65094, '\p{Pattern_Syntax=yes}', "");
    Expect(0, 65094, '\p{^Pattern_Syntax=yes}', "");
    Expect(0, 65094, '\P{Pattern_Syntax=yes}', "");
    Expect(1, 65094, '\P{^Pattern_Syntax=yes}', "");
    Expect(0, 65095, '\p{Pattern_Syntax=yes}', "");
    Expect(1, 65095, '\p{^Pattern_Syntax=yes}', "");
    Expect(1, 65095, '\P{Pattern_Syntax=yes}', "");
    Expect(0, 65095, '\P{^Pattern_Syntax=yes}', "");
    Expect(1, 65094, '\p{Pattern_Syntax= YES}', "");
    Expect(0, 65094, '\p{^Pattern_Syntax= YES}', "");
    Expect(0, 65094, '\P{Pattern_Syntax= YES}', "");
    Expect(1, 65094, '\P{^Pattern_Syntax= YES}', "");
    Expect(0, 65095, '\p{Pattern_Syntax= YES}', "");
    Expect(1, 65095, '\p{^Pattern_Syntax= YES}', "");
    Expect(1, 65095, '\P{Pattern_Syntax= YES}', "");
    Expect(0, 65095, '\P{^Pattern_Syntax= YES}', "");
    Error('\p{Pat_Syn=-/a/y}');
    Error('\P{Pat_Syn=-/a/y}');
    Expect(1, 65094, '\p{Pat_Syn=y}', "");
    Expect(0, 65094, '\p{^Pat_Syn=y}', "");
    Expect(0, 65094, '\P{Pat_Syn=y}', "");
    Expect(1, 65094, '\P{^Pat_Syn=y}', "");
    Expect(0, 65095, '\p{Pat_Syn=y}', "");
    Expect(1, 65095, '\p{^Pat_Syn=y}', "");
    Expect(1, 65095, '\P{Pat_Syn=y}', "");
    Expect(0, 65095, '\P{^Pat_Syn=y}', "");
    Expect(1, 65094, '\p{Pat_Syn= Y}', "");
    Expect(0, 65094, '\p{^Pat_Syn= Y}', "");
    Expect(0, 65094, '\P{Pat_Syn= Y}', "");
    Expect(1, 65094, '\P{^Pat_Syn= Y}', "");
    Expect(0, 65095, '\p{Pat_Syn= Y}', "");
    Expect(1, 65095, '\p{^Pat_Syn= Y}', "");
    Expect(1, 65095, '\P{Pat_Syn= Y}', "");
    Expect(0, 65095, '\P{^Pat_Syn= Y}', "");
    Error('\p{Is_Pattern_Syntax=:=_t}');
    Error('\P{Is_Pattern_Syntax=:=_t}');
    Expect(1, 65094, '\p{Is_Pattern_Syntax=t}', "");
    Expect(0, 65094, '\p{^Is_Pattern_Syntax=t}', "");
    Expect(0, 65094, '\P{Is_Pattern_Syntax=t}', "");
    Expect(1, 65094, '\P{^Is_Pattern_Syntax=t}', "");
    Expect(0, 65095, '\p{Is_Pattern_Syntax=t}', "");
    Expect(1, 65095, '\p{^Is_Pattern_Syntax=t}', "");
    Expect(1, 65095, '\P{Is_Pattern_Syntax=t}', "");
    Expect(0, 65095, '\P{^Is_Pattern_Syntax=t}', "");
    Expect(1, 65094, '\p{Is_Pattern_Syntax=_	T}', "");
    Expect(0, 65094, '\p{^Is_Pattern_Syntax=_	T}', "");
    Expect(0, 65094, '\P{Is_Pattern_Syntax=_	T}', "");
    Expect(1, 65094, '\P{^Is_Pattern_Syntax=_	T}', "");
    Expect(0, 65095, '\p{Is_Pattern_Syntax=_	T}', "");
    Expect(1, 65095, '\p{^Is_Pattern_Syntax=_	T}', "");
    Expect(1, 65095, '\P{Is_Pattern_Syntax=_	T}', "");
    Expect(0, 65095, '\P{^Is_Pattern_Syntax=_	T}', "");
    Error('\p{Is_Pat_Syn=:=_true}');
    Error('\P{Is_Pat_Syn=:=_true}');
    Expect(1, 65094, '\p{Is_Pat_Syn:true}', "");
    Expect(0, 65094, '\p{^Is_Pat_Syn:true}', "");
    Expect(0, 65094, '\P{Is_Pat_Syn:true}', "");
    Expect(1, 65094, '\P{^Is_Pat_Syn:true}', "");
    Expect(0, 65095, '\p{Is_Pat_Syn:true}', "");
    Expect(1, 65095, '\p{^Is_Pat_Syn:true}', "");
    Expect(1, 65095, '\P{Is_Pat_Syn:true}', "");
    Expect(0, 65095, '\P{^Is_Pat_Syn:true}', "");
    Expect(1, 65094, '\p{Is_Pat_Syn=_ True}', "");
    Expect(0, 65094, '\p{^Is_Pat_Syn=_ True}', "");
    Expect(0, 65094, '\P{Is_Pat_Syn=_ True}', "");
    Expect(1, 65094, '\P{^Is_Pat_Syn=_ True}', "");
    Expect(0, 65095, '\p{Is_Pat_Syn=_ True}', "");
    Expect(1, 65095, '\p{^Is_Pat_Syn=_ True}', "");
    Expect(1, 65095, '\P{Is_Pat_Syn=_ True}', "");
    Expect(0, 65095, '\P{^Is_Pat_Syn=_ True}', "");
    Error('\p{Pattern_White_Space=__No:=}');
    Error('\P{Pattern_White_Space=__No:=}');
    Expect(1, 8234, '\p{Pattern_White_Space=no}', "");
    Expect(0, 8234, '\p{^Pattern_White_Space=no}', "");
    Expect(0, 8234, '\P{Pattern_White_Space=no}', "");
    Expect(1, 8234, '\P{^Pattern_White_Space=no}', "");
    Expect(0, 8233, '\p{Pattern_White_Space=no}', "");
    Expect(1, 8233, '\p{^Pattern_White_Space=no}', "");
    Expect(1, 8233, '\P{Pattern_White_Space=no}', "");
    Expect(0, 8233, '\P{^Pattern_White_Space=no}', "");
    Expect(1, 8234, '\p{Pattern_White_Space=_No}', "");
    Expect(0, 8234, '\p{^Pattern_White_Space=_No}', "");
    Expect(0, 8234, '\P{Pattern_White_Space=_No}', "");
    Expect(1, 8234, '\P{^Pattern_White_Space=_No}', "");
    Expect(0, 8233, '\p{Pattern_White_Space=_No}', "");
    Expect(1, 8233, '\p{^Pattern_White_Space=_No}', "");
    Expect(1, 8233, '\P{Pattern_White_Space=_No}', "");
    Expect(0, 8233, '\P{^Pattern_White_Space=_No}', "");
    Error('\p{Pat_WS=_	N/a/}');
    Error('\P{Pat_WS=_	N/a/}');
    Expect(1, 8234, '\p{Pat_WS=n}', "");
    Expect(0, 8234, '\p{^Pat_WS=n}', "");
    Expect(0, 8234, '\P{Pat_WS=n}', "");
    Expect(1, 8234, '\P{^Pat_WS=n}', "");
    Expect(0, 8233, '\p{Pat_WS=n}', "");
    Expect(1, 8233, '\p{^Pat_WS=n}', "");
    Expect(1, 8233, '\P{Pat_WS=n}', "");
    Expect(0, 8233, '\P{^Pat_WS=n}', "");
    Expect(1, 8234, '\p{Pat_WS= 	N}', "");
    Expect(0, 8234, '\p{^Pat_WS= 	N}', "");
    Expect(0, 8234, '\P{Pat_WS= 	N}', "");
    Expect(1, 8234, '\P{^Pat_WS= 	N}', "");
    Expect(0, 8233, '\p{Pat_WS= 	N}', "");
    Expect(1, 8233, '\p{^Pat_WS= 	N}', "");
    Expect(1, 8233, '\P{Pat_WS= 	N}', "");
    Expect(0, 8233, '\P{^Pat_WS= 	N}', "");
    Error('\p{Is_Pattern_White_Space=-/a/F}');
    Error('\P{Is_Pattern_White_Space=-/a/F}');
    Expect(1, 8234, '\p{Is_Pattern_White_Space=f}', "");
    Expect(0, 8234, '\p{^Is_Pattern_White_Space=f}', "");
    Expect(0, 8234, '\P{Is_Pattern_White_Space=f}', "");
    Expect(1, 8234, '\P{^Is_Pattern_White_Space=f}', "");
    Expect(0, 8233, '\p{Is_Pattern_White_Space=f}', "");
    Expect(1, 8233, '\p{^Is_Pattern_White_Space=f}', "");
    Expect(1, 8233, '\P{Is_Pattern_White_Space=f}', "");
    Expect(0, 8233, '\P{^Is_Pattern_White_Space=f}', "");
    Expect(1, 8234, '\p{Is_Pattern_White_Space=		F}', "");
    Expect(0, 8234, '\p{^Is_Pattern_White_Space=		F}', "");
    Expect(0, 8234, '\P{Is_Pattern_White_Space=		F}', "");
    Expect(1, 8234, '\P{^Is_Pattern_White_Space=		F}', "");
    Expect(0, 8233, '\p{Is_Pattern_White_Space=		F}', "");
    Expect(1, 8233, '\p{^Is_Pattern_White_Space=		F}', "");
    Expect(1, 8233, '\P{Is_Pattern_White_Space=		F}', "");
    Expect(0, 8233, '\P{^Is_Pattern_White_Space=		F}', "");
    Error('\p{Is_Pat_WS=	:=False}');
    Error('\P{Is_Pat_WS=	:=False}');
    Expect(1, 8234, '\p{Is_Pat_WS:false}', "");
    Expect(0, 8234, '\p{^Is_Pat_WS:false}', "");
    Expect(0, 8234, '\P{Is_Pat_WS:false}', "");
    Expect(1, 8234, '\P{^Is_Pat_WS:false}', "");
    Expect(0, 8233, '\p{Is_Pat_WS:false}', "");
    Expect(1, 8233, '\p{^Is_Pat_WS:false}', "");
    Expect(1, 8233, '\P{Is_Pat_WS:false}', "");
    Expect(0, 8233, '\P{^Is_Pat_WS:false}', "");
    Expect(1, 8234, '\p{Is_Pat_WS=  FALSE}', "");
    Expect(0, 8234, '\p{^Is_Pat_WS=  FALSE}', "");
    Expect(0, 8234, '\P{Is_Pat_WS=  FALSE}', "");
    Expect(1, 8234, '\P{^Is_Pat_WS=  FALSE}', "");
    Expect(0, 8233, '\p{Is_Pat_WS=  FALSE}', "");
    Expect(1, 8233, '\p{^Is_Pat_WS=  FALSE}', "");
    Expect(1, 8233, '\P{Is_Pat_WS=  FALSE}', "");
    Expect(0, 8233, '\P{^Is_Pat_WS=  FALSE}', "");
    Error('\p{Pattern_White_Space= :=yes}');
    Error('\P{Pattern_White_Space= :=yes}');
    Expect(1, 8233, '\p{Pattern_White_Space=yes}', "");
    Expect(0, 8233, '\p{^Pattern_White_Space=yes}', "");
    Expect(0, 8233, '\P{Pattern_White_Space=yes}', "");
    Expect(1, 8233, '\P{^Pattern_White_Space=yes}', "");
    Expect(0, 8234, '\p{Pattern_White_Space=yes}', "");
    Expect(1, 8234, '\p{^Pattern_White_Space=yes}', "");
    Expect(1, 8234, '\P{Pattern_White_Space=yes}', "");
    Expect(0, 8234, '\P{^Pattern_White_Space=yes}', "");
    Expect(1, 8233, '\p{Pattern_White_Space=  Yes}', "");
    Expect(0, 8233, '\p{^Pattern_White_Space=  Yes}', "");
    Expect(0, 8233, '\P{Pattern_White_Space=  Yes}', "");
    Expect(1, 8233, '\P{^Pattern_White_Space=  Yes}', "");
    Expect(0, 8234, '\p{Pattern_White_Space=  Yes}', "");
    Expect(1, 8234, '\p{^Pattern_White_Space=  Yes}', "");
    Expect(1, 8234, '\P{Pattern_White_Space=  Yes}', "");
    Expect(0, 8234, '\P{^Pattern_White_Space=  Yes}', "");
    Error('\p{Pat_WS=:=		y}');
    Error('\P{Pat_WS=:=		y}');
    Expect(1, 8233, '\p{Pat_WS=y}', "");
    Expect(0, 8233, '\p{^Pat_WS=y}', "");
    Expect(0, 8233, '\P{Pat_WS=y}', "");
    Expect(1, 8233, '\P{^Pat_WS=y}', "");
    Expect(0, 8234, '\p{Pat_WS=y}', "");
    Expect(1, 8234, '\p{^Pat_WS=y}', "");
    Expect(1, 8234, '\P{Pat_WS=y}', "");
    Expect(0, 8234, '\P{^Pat_WS=y}', "");
    Expect(1, 8233, '\p{Pat_WS=--Y}', "");
    Expect(0, 8233, '\p{^Pat_WS=--Y}', "");
    Expect(0, 8233, '\P{Pat_WS=--Y}', "");
    Expect(1, 8233, '\P{^Pat_WS=--Y}', "");
    Expect(0, 8234, '\p{Pat_WS=--Y}', "");
    Expect(1, 8234, '\p{^Pat_WS=--Y}', "");
    Expect(1, 8234, '\P{Pat_WS=--Y}', "");
    Expect(0, 8234, '\P{^Pat_WS=--Y}', "");
    Error('\p{Is_Pattern_White_Space=	/a/T}');
    Error('\P{Is_Pattern_White_Space=	/a/T}');
    Expect(1, 8233, '\p{Is_Pattern_White_Space=t}', "");
    Expect(0, 8233, '\p{^Is_Pattern_White_Space=t}', "");
    Expect(0, 8233, '\P{Is_Pattern_White_Space=t}', "");
    Expect(1, 8233, '\P{^Is_Pattern_White_Space=t}', "");
    Expect(0, 8234, '\p{Is_Pattern_White_Space=t}', "");
    Expect(1, 8234, '\p{^Is_Pattern_White_Space=t}', "");
    Expect(1, 8234, '\P{Is_Pattern_White_Space=t}', "");
    Expect(0, 8234, '\P{^Is_Pattern_White_Space=t}', "");
    Expect(1, 8233, '\p{Is_Pattern_White_Space= 	T}', "");
    Expect(0, 8233, '\p{^Is_Pattern_White_Space= 	T}', "");
    Expect(0, 8233, '\P{Is_Pattern_White_Space= 	T}', "");
    Expect(1, 8233, '\P{^Is_Pattern_White_Space= 	T}', "");
    Expect(0, 8234, '\p{Is_Pattern_White_Space= 	T}', "");
    Expect(1, 8234, '\p{^Is_Pattern_White_Space= 	T}', "");
    Expect(1, 8234, '\P{Is_Pattern_White_Space= 	T}', "");
    Expect(0, 8234, '\P{^Is_Pattern_White_Space= 	T}', "");
    Error('\p{Is_Pat_WS=/a/	 True}');
    Error('\P{Is_Pat_WS=/a/	 True}');
    Expect(1, 8233, '\p{Is_Pat_WS:	true}', "");
    Expect(0, 8233, '\p{^Is_Pat_WS:	true}', "");
    Expect(0, 8233, '\P{Is_Pat_WS:	true}', "");
    Expect(1, 8233, '\P{^Is_Pat_WS:	true}', "");
    Expect(0, 8234, '\p{Is_Pat_WS:	true}', "");
    Expect(1, 8234, '\p{^Is_Pat_WS:	true}', "");
    Expect(1, 8234, '\P{Is_Pat_WS:	true}', "");
    Expect(0, 8234, '\P{^Is_Pat_WS:	true}', "");
    Expect(1, 8233, '\p{Is_Pat_WS=- TRUE}', "");
    Expect(0, 8233, '\p{^Is_Pat_WS=- TRUE}', "");
    Expect(0, 8233, '\P{Is_Pat_WS=- TRUE}', "");
    Expect(1, 8233, '\P{^Is_Pat_WS=- TRUE}', "");
    Expect(0, 8234, '\p{Is_Pat_WS=- TRUE}', "");
    Expect(1, 8234, '\p{^Is_Pat_WS=- TRUE}', "");
    Expect(1, 8234, '\P{Is_Pat_WS=- TRUE}', "");
    Expect(0, 8234, '\P{^Is_Pat_WS=- TRUE}', "");
    Error('\p{Prepended_Concatenation_Mark=-:=No}');
    Error('\P{Prepended_Concatenation_Mark=-:=No}');
    Expect(1, 69822, '\p{Prepended_Concatenation_Mark:	no}', "");
    Expect(0, 69822, '\p{^Prepended_Concatenation_Mark:	no}', "");
    Expect(0, 69822, '\P{Prepended_Concatenation_Mark:	no}', "");
    Expect(1, 69822, '\P{^Prepended_Concatenation_Mark:	no}', "");
    Expect(0, 69821, '\p{Prepended_Concatenation_Mark:	no}', "");
    Expect(1, 69821, '\p{^Prepended_Concatenation_Mark:	no}', "");
    Expect(1, 69821, '\P{Prepended_Concatenation_Mark:	no}', "");
    Expect(0, 69821, '\P{^Prepended_Concatenation_Mark:	no}', "");
    Expect(1, 69822, '\p{Prepended_Concatenation_Mark=	No}', "");
    Expect(0, 69822, '\p{^Prepended_Concatenation_Mark=	No}', "");
    Expect(0, 69822, '\P{Prepended_Concatenation_Mark=	No}', "");
    Expect(1, 69822, '\P{^Prepended_Concatenation_Mark=	No}', "");
    Expect(0, 69821, '\p{Prepended_Concatenation_Mark=	No}', "");
    Expect(1, 69821, '\p{^Prepended_Concatenation_Mark=	No}', "");
    Expect(1, 69821, '\P{Prepended_Concatenation_Mark=	No}', "");
    Expect(0, 69821, '\P{^Prepended_Concatenation_Mark=	No}', "");
    Error('\p{PCM=/a/N}');
    Error('\P{PCM=/a/N}');
    Expect(1, 69822, '\p{PCM=n}', "");
    Expect(0, 69822, '\p{^PCM=n}', "");
    Expect(0, 69822, '\P{PCM=n}', "");
    Expect(1, 69822, '\P{^PCM=n}', "");
    Expect(0, 69821, '\p{PCM=n}', "");
    Expect(1, 69821, '\p{^PCM=n}', "");
    Expect(1, 69821, '\P{PCM=n}', "");
    Expect(0, 69821, '\P{^PCM=n}', "");
    Expect(1, 69822, '\p{PCM=	 N}', "");
    Expect(0, 69822, '\p{^PCM=	 N}', "");
    Expect(0, 69822, '\P{PCM=	 N}', "");
    Expect(1, 69822, '\P{^PCM=	 N}', "");
    Expect(0, 69821, '\p{PCM=	 N}', "");
    Expect(1, 69821, '\p{^PCM=	 N}', "");
    Expect(1, 69821, '\P{PCM=	 N}', "");
    Expect(0, 69821, '\P{^PCM=	 N}', "");
    Error('\p{Is_Prepended_Concatenation_Mark=:= -f}');
    Error('\P{Is_Prepended_Concatenation_Mark=:= -f}');
    Expect(1, 69822, '\p{Is_Prepended_Concatenation_Mark: f}', "");
    Expect(0, 69822, '\p{^Is_Prepended_Concatenation_Mark: f}', "");
    Expect(0, 69822, '\P{Is_Prepended_Concatenation_Mark: f}', "");
    Expect(1, 69822, '\P{^Is_Prepended_Concatenation_Mark: f}', "");
    Expect(0, 69821, '\p{Is_Prepended_Concatenation_Mark: f}', "");
    Expect(1, 69821, '\p{^Is_Prepended_Concatenation_Mark: f}', "");
    Expect(1, 69821, '\P{Is_Prepended_Concatenation_Mark: f}', "");
    Expect(0, 69821, '\P{^Is_Prepended_Concatenation_Mark: f}', "");
    Expect(1, 69822, '\p{Is_Prepended_Concatenation_Mark= f}', "");
    Expect(0, 69822, '\p{^Is_Prepended_Concatenation_Mark= f}', "");
    Expect(0, 69822, '\P{Is_Prepended_Concatenation_Mark= f}', "");
    Expect(1, 69822, '\P{^Is_Prepended_Concatenation_Mark= f}', "");
    Expect(0, 69821, '\p{Is_Prepended_Concatenation_Mark= f}', "");
    Expect(1, 69821, '\p{^Is_Prepended_Concatenation_Mark= f}', "");
    Expect(1, 69821, '\P{Is_Prepended_Concatenation_Mark= f}', "");
    Expect(0, 69821, '\P{^Is_Prepended_Concatenation_Mark= f}', "");
    Error('\p{Is_PCM=_/a/false}');
    Error('\P{Is_PCM=_/a/false}');
    Expect(1, 69822, '\p{Is_PCM=false}', "");
    Expect(0, 69822, '\p{^Is_PCM=false}', "");
    Expect(0, 69822, '\P{Is_PCM=false}', "");
    Expect(1, 69822, '\P{^Is_PCM=false}', "");
    Expect(0, 69821, '\p{Is_PCM=false}', "");
    Expect(1, 69821, '\p{^Is_PCM=false}', "");
    Expect(1, 69821, '\P{Is_PCM=false}', "");
    Expect(0, 69821, '\P{^Is_PCM=false}', "");
    Expect(1, 69822, '\p{Is_PCM=-False}', "");
    Expect(0, 69822, '\p{^Is_PCM=-False}', "");
    Expect(0, 69822, '\P{Is_PCM=-False}', "");
    Expect(1, 69822, '\P{^Is_PCM=-False}', "");
    Expect(0, 69821, '\p{Is_PCM=-False}', "");
    Expect(1, 69821, '\p{^Is_PCM=-False}', "");
    Expect(1, 69821, '\P{Is_PCM=-False}', "");
    Expect(0, 69821, '\P{^Is_PCM=-False}', "");
    Error('\p{Prepended_Concatenation_Mark=_:=yes}');
    Error('\P{Prepended_Concatenation_Mark=_:=yes}');
    Expect(1, 69821, '\p{Prepended_Concatenation_Mark=yes}', "");
    Expect(0, 69821, '\p{^Prepended_Concatenation_Mark=yes}', "");
    Expect(0, 69821, '\P{Prepended_Concatenation_Mark=yes}', "");
    Expect(1, 69821, '\P{^Prepended_Concatenation_Mark=yes}', "");
    Expect(0, 69822, '\p{Prepended_Concatenation_Mark=yes}', "");
    Expect(1, 69822, '\p{^Prepended_Concatenation_Mark=yes}', "");
    Expect(1, 69822, '\P{Prepended_Concatenation_Mark=yes}', "");
    Expect(0, 69822, '\P{^Prepended_Concatenation_Mark=yes}', "");
    Expect(1, 69821, '\p{Prepended_Concatenation_Mark=-_YES}', "");
    Expect(0, 69821, '\p{^Prepended_Concatenation_Mark=-_YES}', "");
    Expect(0, 69821, '\P{Prepended_Concatenation_Mark=-_YES}', "");
    Expect(1, 69821, '\P{^Prepended_Concatenation_Mark=-_YES}', "");
    Expect(0, 69822, '\p{Prepended_Concatenation_Mark=-_YES}', "");
    Expect(1, 69822, '\p{^Prepended_Concatenation_Mark=-_YES}', "");
    Expect(1, 69822, '\P{Prepended_Concatenation_Mark=-_YES}', "");
    Expect(0, 69822, '\P{^Prepended_Concatenation_Mark=-_YES}', "");
    Error('\p{PCM=/a/-_y}');
    Error('\P{PCM=/a/-_y}');
    Expect(1, 69821, '\p{PCM=y}', "");
    Expect(0, 69821, '\p{^PCM=y}', "");
    Expect(0, 69821, '\P{PCM=y}', "");
    Expect(1, 69821, '\P{^PCM=y}', "");
    Expect(0, 69822, '\p{PCM=y}', "");
    Expect(1, 69822, '\p{^PCM=y}', "");
    Expect(1, 69822, '\P{PCM=y}', "");
    Expect(0, 69822, '\P{^PCM=y}', "");
    Expect(1, 69821, '\p{PCM:	y}', "");
    Expect(0, 69821, '\p{^PCM:	y}', "");
    Expect(0, 69821, '\P{PCM:	y}', "");
    Expect(1, 69821, '\P{^PCM:	y}', "");
    Expect(0, 69822, '\p{PCM:	y}', "");
    Expect(1, 69822, '\p{^PCM:	y}', "");
    Expect(1, 69822, '\P{PCM:	y}', "");
    Expect(0, 69822, '\P{^PCM:	y}', "");
    Error('\p{Is_Prepended_Concatenation_Mark=- t:=}');
    Error('\P{Is_Prepended_Concatenation_Mark=- t:=}');
    Expect(1, 69821, '\p{Is_Prepended_Concatenation_Mark=t}', "");
    Expect(0, 69821, '\p{^Is_Prepended_Concatenation_Mark=t}', "");
    Expect(0, 69821, '\P{Is_Prepended_Concatenation_Mark=t}', "");
    Expect(1, 69821, '\P{^Is_Prepended_Concatenation_Mark=t}', "");
    Expect(0, 69822, '\p{Is_Prepended_Concatenation_Mark=t}', "");
    Expect(1, 69822, '\p{^Is_Prepended_Concatenation_Mark=t}', "");
    Expect(1, 69822, '\P{Is_Prepended_Concatenation_Mark=t}', "");
    Expect(0, 69822, '\P{^Is_Prepended_Concatenation_Mark=t}', "");
    Expect(1, 69821, '\p{Is_Prepended_Concatenation_Mark=__T}', "");
    Expect(0, 69821, '\p{^Is_Prepended_Concatenation_Mark=__T}', "");
    Expect(0, 69821, '\P{Is_Prepended_Concatenation_Mark=__T}', "");
    Expect(1, 69821, '\P{^Is_Prepended_Concatenation_Mark=__T}', "");
    Expect(0, 69822, '\p{Is_Prepended_Concatenation_Mark=__T}', "");
    Expect(1, 69822, '\p{^Is_Prepended_Concatenation_Mark=__T}', "");
    Expect(1, 69822, '\P{Is_Prepended_Concatenation_Mark=__T}', "");
    Expect(0, 69822, '\P{^Is_Prepended_Concatenation_Mark=__T}', "");
    Error('\p{Is_PCM=:=_true}');
    Error('\P{Is_PCM=:=_true}');
    Expect(1, 69821, '\p{Is_PCM=true}', "");
    Expect(0, 69821, '\p{^Is_PCM=true}', "");
    Expect(0, 69821, '\P{Is_PCM=true}', "");
    Expect(1, 69821, '\P{^Is_PCM=true}', "");
    Expect(0, 69822, '\p{Is_PCM=true}', "");
    Expect(1, 69822, '\p{^Is_PCM=true}', "");
    Expect(1, 69822, '\P{Is_PCM=true}', "");
    Expect(0, 69822, '\P{^Is_PCM=true}', "");
    Expect(1, 69821, '\p{Is_PCM=-true}', "");
    Expect(0, 69821, '\p{^Is_PCM=-true}', "");
    Expect(0, 69821, '\P{Is_PCM=-true}', "");
    Expect(1, 69821, '\P{^Is_PCM=-true}', "");
    Expect(0, 69822, '\p{Is_PCM=-true}', "");
    Expect(1, 69822, '\p{^Is_PCM=-true}', "");
    Expect(1, 69822, '\P{Is_PCM=-true}', "");
    Expect(0, 69822, '\P{^Is_PCM=-true}', "");
    Error('\p{perl}');
    Error('\P{perl}');
    Error('\p{/a/_Soft_DOTTED}');
    Error('\P{/a/_Soft_DOTTED}');
    Expect(1, 120467, '\p{softdotted}', "");
    Expect(0, 120467, '\p{^softdotted}', "");
    Expect(0, 120467, '\P{softdotted}', "");
    Expect(1, 120467, '\P{^softdotted}', "");
    Expect(0, 120468, '\p{softdotted}', "");
    Expect(1, 120468, '\p{^softdotted}', "");
    Expect(1, 120468, '\P{softdotted}', "");
    Expect(0, 120468, '\P{^softdotted}', "");
    Expect(1, 120467, '\p{-_Soft_Dotted}', "");
    Expect(0, 120467, '\p{^-_Soft_Dotted}', "");
    Expect(0, 120467, '\P{-_Soft_Dotted}', "");
    Expect(1, 120467, '\P{^-_Soft_Dotted}', "");
    Expect(0, 120468, '\p{-_Soft_Dotted}', "");
    Expect(1, 120468, '\p{^-_Soft_Dotted}', "");
    Expect(1, 120468, '\P{-_Soft_Dotted}', "");
    Expect(0, 120468, '\P{^-_Soft_Dotted}', "");
    Error('\p{-is_soft_dotted:=}');
    Error('\P{-is_soft_dotted:=}');
    Expect(1, 120467, '\p{issoftdotted}', "");
    Expect(0, 120467, '\p{^issoftdotted}', "");
    Expect(0, 120467, '\P{issoftdotted}', "");
    Expect(1, 120467, '\P{^issoftdotted}', "");
    Expect(0, 120468, '\p{issoftdotted}', "");
    Expect(1, 120468, '\p{^issoftdotted}', "");
    Expect(1, 120468, '\P{issoftdotted}', "");
    Expect(0, 120468, '\P{^issoftdotted}', "");
    Expect(1, 120467, '\p{ -Is_Soft_DOTTED}', "");
    Expect(0, 120467, '\p{^ -Is_Soft_DOTTED}', "");
    Expect(0, 120467, '\P{ -Is_Soft_DOTTED}', "");
    Expect(1, 120467, '\P{^ -Is_Soft_DOTTED}', "");
    Expect(0, 120468, '\p{ -Is_Soft_DOTTED}', "");
    Expect(1, 120468, '\p{^ -Is_Soft_DOTTED}', "");
    Expect(1, 120468, '\P{ -Is_Soft_DOTTED}', "");
    Expect(0, 120468, '\P{^ -Is_Soft_DOTTED}', "");
    Error('\p{:=	_SD}');
    Error('\P{:=	_SD}');
    Expect(1, 120467, '\p{sd}', "");
    Expect(0, 120467, '\p{^sd}', "");
    Expect(0, 120467, '\P{sd}', "");
    Expect(1, 120467, '\P{^sd}', "");
    Expect(0, 120468, '\p{sd}', "");
    Expect(1, 120468, '\p{^sd}', "");
    Expect(1, 120468, '\P{sd}', "");
    Expect(0, 120468, '\P{^sd}', "");
    Expect(1, 120467, '\p{ SD}', "");
    Expect(0, 120467, '\p{^ SD}', "");
    Expect(0, 120467, '\P{ SD}', "");
    Expect(1, 120467, '\P{^ SD}', "");
    Expect(0, 120468, '\p{ SD}', "");
    Expect(1, 120468, '\p{^ SD}', "");
    Expect(1, 120468, '\P{ SD}', "");
    Expect(0, 120468, '\P{^ SD}', "");
    Error('\p{:=- is_sd}');
    Error('\P{:=- is_sd}');
    Expect(1, 120467, '\p{issd}', "");
    Expect(0, 120467, '\p{^issd}', "");
    Expect(0, 120467, '\P{issd}', "");
    Expect(1, 120467, '\P{^issd}', "");
    Expect(0, 120468, '\p{issd}', "");
    Expect(1, 120468, '\p{^issd}', "");
    Expect(1, 120468, '\P{issd}', "");
    Expect(0, 120468, '\P{^issd}', "");
    Expect(1, 120467, '\p{_IS_sd}', "");
    Expect(0, 120467, '\p{^_IS_sd}', "");
    Expect(0, 120467, '\P{_IS_sd}', "");
    Expect(1, 120467, '\P{^_IS_sd}', "");
    Expect(0, 120468, '\p{_IS_sd}', "");
    Expect(1, 120468, '\p{^_IS_sd}', "");
    Expect(1, 120468, '\P{_IS_sd}', "");
    Expect(0, 120468, '\P{^_IS_sd}', "");
    Error('\p{/a/	_CanonDCIJ}');
    Error('\P{/a/	_CanonDCIJ}');
    Expect(1, 120467, '\p{_CANONDCIJ}', "");
    Expect(0, 120467, '\p{^_CANONDCIJ}', "");
    Expect(0, 120467, '\P{_CANONDCIJ}', "");
    Expect(1, 120467, '\P{^_CANONDCIJ}', "");
    Expect(0, 120468, '\p{_CANONDCIJ}', "");
    Expect(1, 120468, '\p{^_CANONDCIJ}', "");
    Expect(1, 120468, '\P{_CANONDCIJ}', "");
    Expect(0, 120468, '\P{^_CANONDCIJ}', "");
    Error('\p{ 	Case_ignorable/a/}');
    Error('\P{ 	Case_ignorable/a/}');
    Expect(1, 917999, '\p{caseignorable}', "");
    Expect(0, 917999, '\p{^caseignorable}', "");
    Expect(0, 917999, '\P{caseignorable}', "");
    Expect(1, 917999, '\P{^caseignorable}', "");
    Expect(0, 918000, '\p{caseignorable}', "");
    Expect(1, 918000, '\p{^caseignorable}', "");
    Expect(1, 918000, '\P{caseignorable}', "");
    Expect(0, 918000, '\P{^caseignorable}', "");
    Expect(1, 917999, '\p{Case_Ignorable}', "");
    Expect(0, 917999, '\p{^Case_Ignorable}', "");
    Expect(0, 917999, '\P{Case_Ignorable}', "");
    Expect(1, 917999, '\P{^Case_Ignorable}', "");
    Expect(0, 918000, '\p{Case_Ignorable}', "");
    Expect(1, 918000, '\p{^Case_Ignorable}', "");
    Expect(1, 918000, '\P{Case_Ignorable}', "");
    Expect(0, 918000, '\P{^Case_Ignorable}', "");
    Error('\p{	-is_Case_Ignorable:=}');
    Error('\P{	-is_Case_Ignorable:=}');
    Expect(1, 917999, '\p{iscaseignorable}', "");
    Expect(0, 917999, '\p{^iscaseignorable}', "");
    Expect(0, 917999, '\P{iscaseignorable}', "");
    Expect(1, 917999, '\P{^iscaseignorable}', "");
    Expect(0, 918000, '\p{iscaseignorable}', "");
    Expect(1, 918000, '\p{^iscaseignorable}', "");
    Expect(1, 918000, '\P{iscaseignorable}', "");
    Expect(0, 918000, '\P{^iscaseignorable}', "");
    Expect(1, 917999, '\p{--IS_case_IGNORABLE}', "");
    Expect(0, 917999, '\p{^--IS_case_IGNORABLE}', "");
    Expect(0, 917999, '\P{--IS_case_IGNORABLE}', "");
    Expect(1, 917999, '\P{^--IS_case_IGNORABLE}', "");
    Expect(0, 918000, '\p{--IS_case_IGNORABLE}', "");
    Expect(1, 918000, '\p{^--IS_case_IGNORABLE}', "");
    Expect(1, 918000, '\P{--IS_case_IGNORABLE}', "");
    Expect(0, 918000, '\P{^--IS_case_IGNORABLE}', "");
    Error('\p{_-CI:=}');
    Error('\P{_-CI:=}');
    Expect(1, 917999, '\p{ci}', "");
    Expect(0, 917999, '\p{^ci}', "");
    Expect(0, 917999, '\P{ci}', "");
    Expect(1, 917999, '\P{^ci}', "");
    Expect(0, 918000, '\p{ci}', "");
    Expect(1, 918000, '\p{^ci}', "");
    Expect(1, 918000, '\P{ci}', "");
    Expect(0, 918000, '\P{^ci}', "");
    Expect(1, 917999, '\p{ -ci}', "");
    Expect(0, 917999, '\p{^ -ci}', "");
    Expect(0, 917999, '\P{ -ci}', "");
    Expect(1, 917999, '\P{^ -ci}', "");
    Expect(0, 918000, '\p{ -ci}', "");
    Expect(1, 918000, '\p{^ -ci}', "");
    Expect(1, 918000, '\P{ -ci}', "");
    Expect(0, 918000, '\P{^ -ci}', "");
    Error('\p{:= Is_CI}');
    Error('\P{:= Is_CI}');
    Expect(1, 917999, '\p{isci}', "");
    Expect(0, 917999, '\p{^isci}', "");
    Expect(0, 917999, '\P{isci}', "");
    Expect(1, 917999, '\P{^isci}', "");
    Expect(0, 918000, '\p{isci}', "");
    Expect(1, 918000, '\p{^isci}', "");
    Expect(1, 918000, '\P{isci}', "");
    Expect(0, 918000, '\P{^isci}', "");
    Expect(1, 917999, '\p{  Is_ci}', "");
    Expect(0, 917999, '\p{^  Is_ci}', "");
    Expect(0, 917999, '\P{  Is_ci}', "");
    Expect(1, 917999, '\P{^  Is_ci}', "");
    Expect(0, 918000, '\p{  Is_ci}', "");
    Expect(1, 918000, '\p{^  Is_ci}', "");
    Expect(1, 918000, '\P{  Is_ci}', "");
    Expect(0, 918000, '\P{^  Is_ci}', "");
    Error('\p{ /a/_CASE_Ignorable}');
    Error('\P{ /a/_CASE_Ignorable}');
    Expect(1, 917999, '\p{_Case_Ignorable}', "");
    Expect(0, 917999, '\p{^_Case_Ignorable}', "");
    Expect(0, 917999, '\P{_Case_Ignorable}', "");
    Expect(1, 917999, '\P{^_Case_Ignorable}', "");
    Expect(0, 918000, '\p{_Case_Ignorable}', "");
    Expect(1, 918000, '\p{^_Case_Ignorable}', "");
    Expect(1, 918000, '\P{_Case_Ignorable}', "");
    Expect(0, 918000, '\P{^_Case_Ignorable}', "");
    Error('\p{-/a/_COMBABOVE}');
    Error('\P{-/a/_COMBABOVE}');
    Expect(1, 125257, '\p{_COMBABOVE}', "");
    Expect(0, 125257, '\p{^_COMBABOVE}', "");
    Expect(0, 125257, '\P{_COMBABOVE}', "");
    Expect(1, 125257, '\P{^_COMBABOVE}', "");
    Expect(0, 125258, '\p{_COMBABOVE}', "");
    Expect(1, 125258, '\p{^_COMBABOVE}', "");
    Expect(1, 125258, '\P{_COMBABOVE}', "");
    Expect(0, 125258, '\P{^_COMBABOVE}', "");
    Error('\p{:=	__COMBABOVE}');
    Error('\P{:=	__COMBABOVE}');
    Expect(1, 125257, '\p{_CombAbove}', "");
    Expect(0, 125257, '\p{^_CombAbove}', "");
    Expect(0, 125257, '\P{_CombAbove}', "");
    Expect(1, 125257, '\P{^_CombAbove}', "");
    Expect(0, 125258, '\p{_CombAbove}', "");
    Expect(1, 125258, '\p{^_CombAbove}', "");
    Expect(1, 125258, '\P{_CombAbove}', "");
    Expect(0, 125258, '\P{^_CombAbove}', "");
    Error('\p{/a/	ADLAM}');
    Error('\P{/a/	ADLAM}');
    Expect(1, 125279, '\p{adlam}', "");
    Expect(0, 125279, '\p{^adlam}', "");
    Expect(0, 125279, '\P{adlam}', "");
    Expect(1, 125279, '\P{^adlam}', "");
    Expect(0, 125280, '\p{adlam}', "");
    Expect(1, 125280, '\p{^adlam}', "");
    Expect(1, 125280, '\P{adlam}', "");
    Expect(0, 125280, '\P{^adlam}', "");
    Expect(1, 125279, '\p{_-ADLAM}', "");
    Expect(0, 125279, '\p{^_-ADLAM}', "");
    Expect(0, 125279, '\P{_-ADLAM}', "");
    Expect(1, 125279, '\P{^_-ADLAM}', "");
    Expect(0, 125280, '\p{_-ADLAM}', "");
    Expect(1, 125280, '\p{^_-ADLAM}', "");
    Expect(1, 125280, '\P{_-ADLAM}', "");
    Expect(0, 125280, '\P{^_-ADLAM}', "");
    Error('\p{/a/ _Is_Adlam}');
    Error('\P{/a/ _Is_Adlam}');
    Expect(1, 125279, '\p{isadlam}', "");
    Expect(0, 125279, '\p{^isadlam}', "");
    Expect(0, 125279, '\P{isadlam}', "");
    Expect(1, 125279, '\P{^isadlam}', "");
    Expect(0, 125280, '\p{isadlam}', "");
    Expect(1, 125280, '\p{^isadlam}', "");
    Expect(1, 125280, '\P{isadlam}', "");
    Expect(0, 125280, '\P{^isadlam}', "");
    Expect(1, 125279, '\p{ -IS_adlam}', "");
    Expect(0, 125279, '\p{^ -IS_adlam}', "");
    Expect(0, 125279, '\P{ -IS_adlam}', "");
    Expect(1, 125279, '\P{^ -IS_adlam}', "");
    Expect(0, 125280, '\p{ -IS_adlam}', "");
    Expect(1, 125280, '\p{^ -IS_adlam}', "");
    Expect(1, 125280, '\P{ -IS_adlam}', "");
    Expect(0, 125280, '\P{^ -IS_adlam}', "");
    Error('\p{  adlm:=}');
    Error('\P{  adlm:=}');
    Expect(1, 125279, '\p{adlm}', "");
    Expect(0, 125279, '\p{^adlm}', "");
    Expect(0, 125279, '\P{adlm}', "");
    Expect(1, 125279, '\P{^adlm}', "");
    Expect(0, 125280, '\p{adlm}', "");
    Expect(1, 125280, '\p{^adlm}', "");
    Expect(1, 125280, '\P{adlm}', "");
    Expect(0, 125280, '\P{^adlm}', "");
    Expect(1, 125279, '\p{-ADLM}', "");
    Expect(0, 125279, '\p{^-ADLM}', "");
    Expect(0, 125279, '\P{-ADLM}', "");
    Expect(1, 125279, '\P{^-ADLM}', "");
    Expect(0, 125280, '\p{-ADLM}', "");
    Expect(1, 125280, '\p{^-ADLM}', "");
    Expect(1, 125280, '\P{-ADLM}', "");
    Expect(0, 125280, '\P{^-ADLM}', "");
    Error('\p{	/a/Is_adlm}');
    Error('\P{	/a/Is_adlm}');
    Expect(1, 125279, '\p{isadlm}', "");
    Expect(0, 125279, '\p{^isadlm}', "");
    Expect(0, 125279, '\P{isadlm}', "");
    Expect(1, 125279, '\P{^isadlm}', "");
    Expect(0, 125280, '\p{isadlm}', "");
    Expect(1, 125280, '\p{^isadlm}', "");
    Expect(1, 125280, '\P{isadlm}', "");
    Expect(0, 125280, '\P{^isadlm}', "");
    Expect(1, 125279, '\p{_IS_ADLM}', "");
    Expect(0, 125279, '\p{^_IS_ADLM}', "");
    Expect(0, 125279, '\P{_IS_ADLM}', "");
    Expect(1, 125279, '\P{^_IS_ADLM}', "");
    Expect(0, 125280, '\p{_IS_ADLM}', "");
    Expect(1, 125280, '\p{^_IS_ADLM}', "");
    Expect(1, 125280, '\P{_IS_ADLM}', "");
    Expect(0, 125280, '\P{^_IS_ADLM}', "");
    Error('\p{-:=Aegean_numbers}');
    Error('\P{-:=Aegean_numbers}');
    Expect(1, 65855, '\p{aegeannumbers}', "");
    Expect(0, 65855, '\p{^aegeannumbers}', "");
    Expect(0, 65855, '\P{aegeannumbers}', "");
    Expect(1, 65855, '\P{^aegeannumbers}', "");
    Expect(0, 65856, '\p{aegeannumbers}', "");
    Expect(1, 65856, '\p{^aegeannumbers}', "");
    Expect(1, 65856, '\P{aegeannumbers}', "");
    Expect(0, 65856, '\P{^aegeannumbers}', "");
    Expect(1, 65855, '\p{_ aegean_Numbers}', "");
    Expect(0, 65855, '\p{^_ aegean_Numbers}', "");
    Expect(0, 65855, '\P{_ aegean_Numbers}', "");
    Expect(1, 65855, '\P{^_ aegean_Numbers}', "");
    Expect(0, 65856, '\p{_ aegean_Numbers}', "");
    Expect(1, 65856, '\p{^_ aegean_Numbers}', "");
    Expect(1, 65856, '\P{_ aegean_Numbers}', "");
    Expect(0, 65856, '\P{^_ aegean_Numbers}', "");
    Error('\p{-/a/IS_AEGEAN_numbers}');
    Error('\P{-/a/IS_AEGEAN_numbers}');
    Expect(1, 65855, '\p{isaegeannumbers}', "");
    Expect(0, 65855, '\p{^isaegeannumbers}', "");
    Expect(0, 65855, '\P{isaegeannumbers}', "");
    Expect(1, 65855, '\P{^isaegeannumbers}', "");
    Expect(0, 65856, '\p{isaegeannumbers}', "");
    Expect(1, 65856, '\p{^isaegeannumbers}', "");
    Expect(1, 65856, '\P{isaegeannumbers}', "");
    Expect(0, 65856, '\P{^isaegeannumbers}', "");
    Expect(1, 65855, '\p{ 	IS_Aegean_Numbers}', "");
    Expect(0, 65855, '\p{^ 	IS_Aegean_Numbers}', "");
    Expect(0, 65855, '\P{ 	IS_Aegean_Numbers}', "");
    Expect(1, 65855, '\P{^ 	IS_Aegean_Numbers}', "");
    Expect(0, 65856, '\p{ 	IS_Aegean_Numbers}', "");
    Expect(1, 65856, '\p{^ 	IS_Aegean_Numbers}', "");
    Expect(1, 65856, '\P{ 	IS_Aegean_Numbers}', "");
    Expect(0, 65856, '\P{^ 	IS_Aegean_Numbers}', "");
    Error('\p{ :=IN_Aegean_Numbers}');
    Error('\P{ :=IN_Aegean_Numbers}');
    Expect(1, 65855, '\p{inaegeannumbers}', "");
    Expect(0, 65855, '\p{^inaegeannumbers}', "");
    Expect(0, 65855, '\P{inaegeannumbers}', "");
    Expect(1, 65855, '\P{^inaegeannumbers}', "");
    Expect(0, 65856, '\p{inaegeannumbers}', "");
    Expect(1, 65856, '\p{^inaegeannumbers}', "");
    Expect(1, 65856, '\P{inaegeannumbers}', "");
    Expect(0, 65856, '\P{^inaegeannumbers}', "");
    Expect(1, 65855, '\p{-In_Aegean_Numbers}', "");
    Expect(0, 65855, '\p{^-In_Aegean_Numbers}', "");
    Expect(0, 65855, '\P{-In_Aegean_Numbers}', "");
    Expect(1, 65855, '\P{^-In_Aegean_Numbers}', "");
    Expect(0, 65856, '\p{-In_Aegean_Numbers}', "");
    Expect(1, 65856, '\p{^-In_Aegean_Numbers}', "");
    Expect(1, 65856, '\P{-In_Aegean_Numbers}', "");
    Expect(0, 65856, '\P{^-In_Aegean_Numbers}', "");
    Error('\p{- ahom:=}');
    Error('\P{- ahom:=}');
    Expect(1, 71487, '\p{ahom}', "");
    Expect(0, 71487, '\p{^ahom}', "");
    Expect(0, 71487, '\P{ahom}', "");
    Expect(1, 71487, '\P{^ahom}', "");
    Expect(0, 71488, '\p{ahom}', "");
    Expect(1, 71488, '\p{^ahom}', "");
    Expect(1, 71488, '\P{ahom}', "");
    Expect(0, 71488, '\P{^ahom}', "");
    Expect(1, 71487, '\p{_	Ahom}', "");
    Expect(0, 71487, '\p{^_	Ahom}', "");
    Expect(0, 71487, '\P{_	Ahom}', "");
    Expect(1, 71487, '\P{^_	Ahom}', "");
    Expect(0, 71488, '\p{_	Ahom}', "");
    Expect(1, 71488, '\p{^_	Ahom}', "");
    Expect(1, 71488, '\P{_	Ahom}', "");
    Expect(0, 71488, '\P{^_	Ahom}', "");
    Error('\p{/a/ _IS_AHOM}');
    Error('\P{/a/ _IS_AHOM}');
    Expect(1, 71487, '\p{isahom}', "");
    Expect(0, 71487, '\p{^isahom}', "");
    Expect(0, 71487, '\P{isahom}', "");
    Expect(1, 71487, '\P{^isahom}', "");
    Expect(0, 71488, '\p{isahom}', "");
    Expect(1, 71488, '\p{^isahom}', "");
    Expect(1, 71488, '\P{isahom}', "");
    Expect(0, 71488, '\P{^isahom}', "");
    Expect(1, 71487, '\p{--Is_AHOM}', "");
    Expect(0, 71487, '\p{^--Is_AHOM}', "");
    Expect(0, 71487, '\P{--Is_AHOM}', "");
    Expect(1, 71487, '\P{^--Is_AHOM}', "");
    Expect(0, 71488, '\p{--Is_AHOM}', "");
    Expect(1, 71488, '\p{^--Is_AHOM}', "");
    Expect(1, 71488, '\P{--Is_AHOM}', "");
    Expect(0, 71488, '\P{^--Is_AHOM}', "");
    Error('\p{_/a/alchemical_symbols}');
    Error('\P{_/a/alchemical_symbols}');
    Expect(1, 128895, '\p{alchemicalsymbols}', "");
    Expect(0, 128895, '\p{^alchemicalsymbols}', "");
    Expect(0, 128895, '\P{alchemicalsymbols}', "");
    Expect(1, 128895, '\P{^alchemicalsymbols}', "");
    Expect(0, 128896, '\p{alchemicalsymbols}', "");
    Expect(1, 128896, '\p{^alchemicalsymbols}', "");
    Expect(1, 128896, '\P{alchemicalsymbols}', "");
    Expect(0, 128896, '\P{^alchemicalsymbols}', "");
    Expect(1, 128895, '\p{-Alchemical_symbols}', "");
    Expect(0, 128895, '\p{^-Alchemical_symbols}', "");
    Expect(0, 128895, '\P{-Alchemical_symbols}', "");
    Expect(1, 128895, '\P{^-Alchemical_symbols}', "");
    Expect(0, 128896, '\p{-Alchemical_symbols}', "");
    Expect(1, 128896, '\p{^-Alchemical_symbols}', "");
    Expect(1, 128896, '\P{-Alchemical_symbols}', "");
    Expect(0, 128896, '\P{^-Alchemical_symbols}', "");
    Error('\p{/a/IS_ALCHEMICAL_Symbols}');
    Error('\P{/a/IS_ALCHEMICAL_Symbols}');
    Expect(1, 128895, '\p{isalchemicalsymbols}', "");
    Expect(0, 128895, '\p{^isalchemicalsymbols}', "");
    Expect(0, 128895, '\P{isalchemicalsymbols}', "");
    Expect(1, 128895, '\P{^isalchemicalsymbols}', "");
    Expect(0, 128896, '\p{isalchemicalsymbols}', "");
    Expect(1, 128896, '\p{^isalchemicalsymbols}', "");
    Expect(1, 128896, '\P{isalchemicalsymbols}', "");
    Expect(0, 128896, '\P{^isalchemicalsymbols}', "");
    Expect(1, 128895, '\p{  Is_ALCHEMICAL_symbols}', "");
    Expect(0, 128895, '\p{^  Is_ALCHEMICAL_symbols}', "");
    Expect(0, 128895, '\P{  Is_ALCHEMICAL_symbols}', "");
    Expect(1, 128895, '\P{^  Is_ALCHEMICAL_symbols}', "");
    Expect(0, 128896, '\p{  Is_ALCHEMICAL_symbols}', "");
    Expect(1, 128896, '\p{^  Is_ALCHEMICAL_symbols}', "");
    Expect(1, 128896, '\P{  Is_ALCHEMICAL_symbols}', "");
    Expect(0, 128896, '\P{^  Is_ALCHEMICAL_symbols}', "");
    Error('\p{	_In_Alchemical_SYMBOLS:=}');
    Error('\P{	_In_Alchemical_SYMBOLS:=}');
    Expect(1, 128895, '\p{inalchemicalsymbols}', "");
    Expect(0, 128895, '\p{^inalchemicalsymbols}', "");
    Expect(0, 128895, '\P{inalchemicalsymbols}', "");
    Expect(1, 128895, '\P{^inalchemicalsymbols}', "");
    Expect(0, 128896, '\p{inalchemicalsymbols}', "");
    Expect(1, 128896, '\p{^inalchemicalsymbols}', "");
    Expect(1, 128896, '\P{inalchemicalsymbols}', "");
    Expect(0, 128896, '\P{^inalchemicalsymbols}', "");
    Expect(1, 128895, '\p{		In_Alchemical_SYMBOLS}', "");
    Expect(0, 128895, '\p{^		In_Alchemical_SYMBOLS}', "");
    Expect(0, 128895, '\P{		In_Alchemical_SYMBOLS}', "");
    Expect(1, 128895, '\P{^		In_Alchemical_SYMBOLS}', "");
    Expect(0, 128896, '\p{		In_Alchemical_SYMBOLS}', "");
    Expect(1, 128896, '\p{^		In_Alchemical_SYMBOLS}', "");
    Expect(1, 128896, '\P{		In_Alchemical_SYMBOLS}', "");
    Expect(0, 128896, '\P{^		In_Alchemical_SYMBOLS}', "");
    Error('\p{/a/alchemical}');
    Error('\P{/a/alchemical}');
    Expect(1, 128895, '\p{alchemical}', "");
    Expect(0, 128895, '\p{^alchemical}', "");
    Expect(0, 128895, '\P{alchemical}', "");
    Expect(1, 128895, '\P{^alchemical}', "");
    Expect(0, 128896, '\p{alchemical}', "");
    Expect(1, 128896, '\p{^alchemical}', "");
    Expect(1, 128896, '\P{alchemical}', "");
    Expect(0, 128896, '\P{^alchemical}', "");
    Expect(1, 128895, '\p{	_ALCHEMICAL}', "");
    Expect(0, 128895, '\p{^	_ALCHEMICAL}', "");
    Expect(0, 128895, '\P{	_ALCHEMICAL}', "");
    Expect(1, 128895, '\P{^	_ALCHEMICAL}', "");
    Expect(0, 128896, '\p{	_ALCHEMICAL}', "");
    Expect(1, 128896, '\p{^	_ALCHEMICAL}', "");
    Expect(1, 128896, '\P{	_ALCHEMICAL}', "");
    Expect(0, 128896, '\P{^	_ALCHEMICAL}', "");
    Error('\p{_:=Is_Alchemical}');
    Error('\P{_:=Is_Alchemical}');
    Expect(1, 128895, '\p{isalchemical}', "");
    Expect(0, 128895, '\p{^isalchemical}', "");
    Expect(0, 128895, '\P{isalchemical}', "");
    Expect(1, 128895, '\P{^isalchemical}', "");
    Expect(0, 128896, '\p{isalchemical}', "");
    Expect(1, 128896, '\p{^isalchemical}', "");
    Expect(1, 128896, '\P{isalchemical}', "");
    Expect(0, 128896, '\P{^isalchemical}', "");
    Expect(1, 128895, '\p{_ IS_Alchemical}', "");
    Expect(0, 128895, '\p{^_ IS_Alchemical}', "");
    Expect(0, 128895, '\P{_ IS_Alchemical}', "");
    Expect(1, 128895, '\P{^_ IS_Alchemical}', "");
    Expect(0, 128896, '\p{_ IS_Alchemical}', "");
    Expect(1, 128896, '\p{^_ IS_Alchemical}', "");
    Expect(1, 128896, '\P{_ IS_Alchemical}', "");
    Expect(0, 128896, '\P{^_ IS_Alchemical}', "");
    Error('\p{	/a/In_Alchemical}');
    Error('\P{	/a/In_Alchemical}');
    Expect(1, 128895, '\p{inalchemical}', "");
    Expect(0, 128895, '\p{^inalchemical}', "");
    Expect(0, 128895, '\P{inalchemical}', "");
    Expect(1, 128895, '\P{^inalchemical}', "");
    Expect(0, 128896, '\p{inalchemical}', "");
    Expect(1, 128896, '\p{^inalchemical}', "");
    Expect(1, 128896, '\P{inalchemical}', "");
    Expect(0, 128896, '\P{^inalchemical}', "");
    Expect(1, 128895, '\p{ _in_ALCHEMICAL}', "");
    Expect(0, 128895, '\p{^ _in_ALCHEMICAL}', "");
    Expect(0, 128895, '\P{ _in_ALCHEMICAL}', "");
    Expect(1, 128895, '\P{^ _in_ALCHEMICAL}', "");
    Expect(0, 128896, '\p{ _in_ALCHEMICAL}', "");
    Expect(1, 128896, '\p{^ _in_ALCHEMICAL}', "");
    Expect(1, 128896, '\P{ _in_ALCHEMICAL}', "");
    Expect(0, 128896, '\P{^ _in_ALCHEMICAL}', "");
    Error('\p{:= -All}');
    Error('\P{:= -All}');
    Expect(1, 1, '\p{all}', "");
    Expect(0, 1, '\p{^all}', "");
    Expect(0, 1, '\P{all}', "");
    Expect(1, 1, '\P{^all}', "");
    Expect(1, 1, '\p{	ALL}', "");
    Expect(0, 1, '\p{^	ALL}', "");
    Expect(0, 1, '\P{	ALL}', "");
    Expect(1, 1, '\P{^	ALL}', "");
    Error('\p{	 IS_ALL/a/}');
    Error('\P{	 IS_ALL/a/}');
    Expect(1, 1, '\p{isall}', "");
    Expect(0, 1, '\p{^isall}', "");
    Expect(0, 1, '\P{isall}', "");
    Expect(1, 1, '\P{^isall}', "");
    Expect(1, 1, '\p{-_is_all}', "");
    Expect(0, 1, '\p{^-_is_all}', "");
    Expect(0, 1, '\P{-_is_all}', "");
    Expect(1, 1, '\P{^-_is_all}', "");
    Error('\p{/a/__XPosixAlnum}');
    Error('\P{/a/__XPosixAlnum}');
    Expect(1, 195101, '\p{xposixalnum}', "");
    Expect(0, 195101, '\p{^xposixalnum}', "");
    Expect(0, 195101, '\P{xposixalnum}', "");
    Expect(1, 195101, '\P{^xposixalnum}', "");
    Expect(0, 195102, '\p{xposixalnum}', "");
    Expect(1, 195102, '\p{^xposixalnum}', "");
    Expect(1, 195102, '\P{xposixalnum}', "");
    Expect(0, 195102, '\P{^xposixalnum}', "");
    Expect(1, 195101, '\p{	 xposixalnum}', "");
    Expect(0, 195101, '\p{^	 xposixalnum}', "");
    Expect(0, 195101, '\P{	 xposixalnum}', "");
    Expect(1, 195101, '\P{^	 xposixalnum}', "");
    Expect(0, 195102, '\p{	 xposixalnum}', "");
    Expect(1, 195102, '\p{^	 xposixalnum}', "");
    Expect(1, 195102, '\P{	 xposixalnum}', "");
    Expect(0, 195102, '\P{^	 xposixalnum}', "");
    Error('\p{:=__Alnum}');
    Error('\P{:=__Alnum}');
    Expect(1, 195101, '\p{alnum}', "");
    Expect(0, 195101, '\p{^alnum}', "");
    Expect(0, 195101, '\P{alnum}', "");
    Expect(1, 195101, '\P{^alnum}', "");
    Expect(0, 195102, '\p{alnum}', "");
    Expect(1, 195102, '\p{^alnum}', "");
    Expect(1, 195102, '\P{alnum}', "");
    Expect(0, 195102, '\P{^alnum}', "");
    Expect(1, 195101, '\p{__ALNUM}', "");
    Expect(0, 195101, '\p{^__ALNUM}', "");
    Expect(0, 195101, '\P{__ALNUM}', "");
    Expect(1, 195101, '\P{^__ALNUM}', "");
    Expect(0, 195102, '\p{__ALNUM}', "");
    Expect(1, 195102, '\p{^__ALNUM}', "");
    Expect(1, 195102, '\P{__ALNUM}', "");
    Expect(0, 195102, '\P{^__ALNUM}', "");
    Error('\p{:=-	Is_XPOSIXALNUM}');
    Error('\P{:=-	Is_XPOSIXALNUM}');
    Expect(1, 195101, '\p{isxposixalnum}', "");
    Expect(0, 195101, '\p{^isxposixalnum}', "");
    Expect(0, 195101, '\P{isxposixalnum}', "");
    Expect(1, 195101, '\P{^isxposixalnum}', "");
    Expect(0, 195102, '\p{isxposixalnum}', "");
    Expect(1, 195102, '\p{^isxposixalnum}', "");
    Expect(1, 195102, '\P{isxposixalnum}', "");
    Expect(0, 195102, '\P{^isxposixalnum}', "");
    Expect(1, 195101, '\p{ IS_XPosixAlnum}', "");
    Expect(0, 195101, '\p{^ IS_XPosixAlnum}', "");
    Expect(0, 195101, '\P{ IS_XPosixAlnum}', "");
    Expect(1, 195101, '\P{^ IS_XPosixAlnum}', "");
    Expect(0, 195102, '\p{ IS_XPosixAlnum}', "");
    Expect(1, 195102, '\p{^ IS_XPosixAlnum}', "");
    Expect(1, 195102, '\P{ IS_XPosixAlnum}', "");
    Expect(0, 195102, '\P{^ IS_XPosixAlnum}', "");
    Error('\p{	/a/Is_Alnum}');
    Error('\P{	/a/Is_Alnum}');
    Expect(1, 195101, '\p{isalnum}', "");
    Expect(0, 195101, '\p{^isalnum}', "");
    Expect(0, 195101, '\P{isalnum}', "");
    Expect(1, 195101, '\P{^isalnum}', "");
    Expect(0, 195102, '\p{isalnum}', "");
    Expect(1, 195102, '\p{^isalnum}', "");
    Expect(1, 195102, '\P{isalnum}', "");
    Expect(0, 195102, '\P{^isalnum}', "");
    Expect(1, 195101, '\p{_Is_Alnum}', "");
    Expect(0, 195101, '\p{^_Is_Alnum}', "");
    Expect(0, 195101, '\P{_Is_Alnum}', "");
    Expect(1, 195101, '\P{^_Is_Alnum}', "");
    Expect(0, 195102, '\p{_Is_Alnum}', "");
    Expect(1, 195102, '\p{^_Is_Alnum}', "");
    Expect(1, 195102, '\P{_Is_Alnum}', "");
    Expect(0, 195102, '\P{^_Is_Alnum}', "");
    Error('\p{_-ALPHABETIC_Presentation_FORMS/a/}');
    Error('\P{_-ALPHABETIC_Presentation_FORMS/a/}');
    Expect(1, 64335, '\p{alphabeticpresentationforms}', "");
    Expect(0, 64335, '\p{^alphabeticpresentationforms}', "");
    Expect(0, 64335, '\P{alphabeticpresentationforms}', "");
    Expect(1, 64335, '\P{^alphabeticpresentationforms}', "");
    Expect(0, 64336, '\p{alphabeticpresentationforms}', "");
    Expect(1, 64336, '\p{^alphabeticpresentationforms}', "");
    Expect(1, 64336, '\P{alphabeticpresentationforms}', "");
    Expect(0, 64336, '\P{^alphabeticpresentationforms}', "");
    Expect(1, 64335, '\p{ alphabetic_presentation_forms}', "");
    Expect(0, 64335, '\p{^ alphabetic_presentation_forms}', "");
    Expect(0, 64335, '\P{ alphabetic_presentation_forms}', "");
    Expect(1, 64335, '\P{^ alphabetic_presentation_forms}', "");
    Expect(0, 64336, '\p{ alphabetic_presentation_forms}', "");
    Expect(1, 64336, '\p{^ alphabetic_presentation_forms}', "");
    Expect(1, 64336, '\P{ alphabetic_presentation_forms}', "");
    Expect(0, 64336, '\P{^ alphabetic_presentation_forms}', "");
    Error('\p{-IS_Alphabetic_PRESENTATION_forms/a/}');
    Error('\P{-IS_Alphabetic_PRESENTATION_forms/a/}');
    Expect(1, 64335, '\p{isalphabeticpresentationforms}', "");
    Expect(0, 64335, '\p{^isalphabeticpresentationforms}', "");
    Expect(0, 64335, '\P{isalphabeticpresentationforms}', "");
    Expect(1, 64335, '\P{^isalphabeticpresentationforms}', "");
    Expect(0, 64336, '\p{isalphabeticpresentationforms}', "");
    Expect(1, 64336, '\p{^isalphabeticpresentationforms}', "");
    Expect(1, 64336, '\P{isalphabeticpresentationforms}', "");
    Expect(0, 64336, '\P{^isalphabeticpresentationforms}', "");
    Expect(1, 64335, '\p{	 Is_ALPHABETIC_presentation_FORMS}', "");
    Expect(0, 64335, '\p{^	 Is_ALPHABETIC_presentation_FORMS}', "");
    Expect(0, 64335, '\P{	 Is_ALPHABETIC_presentation_FORMS}', "");
    Expect(1, 64335, '\P{^	 Is_ALPHABETIC_presentation_FORMS}', "");
    Expect(0, 64336, '\p{	 Is_ALPHABETIC_presentation_FORMS}', "");
    Expect(1, 64336, '\p{^	 Is_ALPHABETIC_presentation_FORMS}', "");
    Expect(1, 64336, '\P{	 Is_ALPHABETIC_presentation_FORMS}', "");
    Expect(0, 64336, '\P{^	 Is_ALPHABETIC_presentation_FORMS}', "");
    Error('\p{	In_Alphabetic_Presentation_forms/a/}');
    Error('\P{	In_Alphabetic_Presentation_forms/a/}');
    Expect(1, 64335, '\p{inalphabeticpresentationforms}', "");
    Expect(0, 64335, '\p{^inalphabeticpresentationforms}', "");
    Expect(0, 64335, '\P{inalphabeticpresentationforms}', "");
    Expect(1, 64335, '\P{^inalphabeticpresentationforms}', "");
    Expect(0, 64336, '\p{inalphabeticpresentationforms}', "");
    Expect(1, 64336, '\p{^inalphabeticpresentationforms}', "");
    Expect(1, 64336, '\P{inalphabeticpresentationforms}', "");
    Expect(0, 64336, '\P{^inalphabeticpresentationforms}', "");
    Expect(1, 64335, '\p{-_in_alphabetic_PRESENTATION_Forms}', "");
    Expect(0, 64335, '\p{^-_in_alphabetic_PRESENTATION_Forms}', "");
    Expect(0, 64335, '\P{-_in_alphabetic_PRESENTATION_Forms}', "");
    Expect(1, 64335, '\P{^-_in_alphabetic_PRESENTATION_Forms}', "");
    Expect(0, 64336, '\p{-_in_alphabetic_PRESENTATION_Forms}', "");
    Expect(1, 64336, '\p{^-_in_alphabetic_PRESENTATION_Forms}', "");
    Expect(1, 64336, '\P{-_in_alphabetic_PRESENTATION_Forms}', "");
    Expect(0, 64336, '\P{^-_in_alphabetic_PRESENTATION_Forms}', "");
    Error('\p{/a/ _ALPHABETIC_PF}');
    Error('\P{/a/ _ALPHABETIC_PF}');
    Expect(1, 64335, '\p{alphabeticpf}', "");
    Expect(0, 64335, '\p{^alphabeticpf}', "");
    Expect(0, 64335, '\P{alphabeticpf}', "");
    Expect(1, 64335, '\P{^alphabeticpf}', "");
    Expect(0, 64336, '\p{alphabeticpf}', "");
    Expect(1, 64336, '\p{^alphabeticpf}', "");
    Expect(1, 64336, '\P{alphabeticpf}', "");
    Expect(0, 64336, '\P{^alphabeticpf}', "");
    Expect(1, 64335, '\p{_alphabetic_PF}', "");
    Expect(0, 64335, '\p{^_alphabetic_PF}', "");
    Expect(0, 64335, '\P{_alphabetic_PF}', "");
    Expect(1, 64335, '\P{^_alphabetic_PF}', "");
    Expect(0, 64336, '\p{_alphabetic_PF}', "");
    Expect(1, 64336, '\p{^_alphabetic_PF}', "");
    Expect(1, 64336, '\P{_alphabetic_PF}', "");
    Expect(0, 64336, '\P{^_alphabetic_PF}', "");
    Error('\p{:=	_IS_Alphabetic_PF}');
    Error('\P{:=	_IS_Alphabetic_PF}');
    Expect(1, 64335, '\p{isalphabeticpf}', "");
    Expect(0, 64335, '\p{^isalphabeticpf}', "");
    Expect(0, 64335, '\P{isalphabeticpf}', "");
    Expect(1, 64335, '\P{^isalphabeticpf}', "");
    Expect(0, 64336, '\p{isalphabeticpf}', "");
    Expect(1, 64336, '\p{^isalphabeticpf}', "");
    Expect(1, 64336, '\P{isalphabeticpf}', "");
    Expect(0, 64336, '\P{^isalphabeticpf}', "");
    Expect(1, 64335, '\p{	IS_ALPHABETIC_PF}', "");
    Expect(0, 64335, '\p{^	IS_ALPHABETIC_PF}', "");
    Expect(0, 64335, '\P{	IS_ALPHABETIC_PF}', "");
    Expect(1, 64335, '\P{^	IS_ALPHABETIC_PF}', "");
    Expect(0, 64336, '\p{	IS_ALPHABETIC_PF}', "");
    Expect(1, 64336, '\p{^	IS_ALPHABETIC_PF}', "");
    Expect(1, 64336, '\P{	IS_ALPHABETIC_PF}', "");
    Expect(0, 64336, '\P{^	IS_ALPHABETIC_PF}', "");
    Error('\p{/a/__In_ALPHABETIC_PF}');
    Error('\P{/a/__In_ALPHABETIC_PF}');
    Expect(1, 64335, '\p{inalphabeticpf}', "");
    Expect(0, 64335, '\p{^inalphabeticpf}', "");
    Expect(0, 64335, '\P{inalphabeticpf}', "");
    Expect(1, 64335, '\P{^inalphabeticpf}', "");
    Expect(0, 64336, '\p{inalphabeticpf}', "");
    Expect(1, 64336, '\p{^inalphabeticpf}', "");
    Expect(1, 64336, '\P{inalphabeticpf}', "");
    Expect(0, 64336, '\P{^inalphabeticpf}', "");
    Expect(1, 64335, '\p{__In_ALPHABETIC_PF}', "");
    Expect(0, 64335, '\p{^__In_ALPHABETIC_PF}', "");
    Expect(0, 64335, '\P{__In_ALPHABETIC_PF}', "");
    Expect(1, 64335, '\P{^__In_ALPHABETIC_PF}', "");
    Expect(0, 64336, '\p{__In_ALPHABETIC_PF}', "");
    Expect(1, 64336, '\p{^__In_ALPHABETIC_PF}', "");
    Expect(1, 64336, '\P{__In_ALPHABETIC_PF}', "");
    Expect(0, 64336, '\P{^__In_ALPHABETIC_PF}', "");
    Error('\p{-/a/Anatolian_Hieroglyphs}');
    Error('\P{-/a/Anatolian_Hieroglyphs}');
    Expect(1, 83526, '\p{anatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^anatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{anatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^anatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{anatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^anatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{anatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^anatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{	_Anatolian_Hieroglyphs}', "");
    Expect(0, 83526, '\p{^	_Anatolian_Hieroglyphs}', "");
    Expect(0, 83526, '\P{	_Anatolian_Hieroglyphs}', "");
    Expect(1, 83526, '\P{^	_Anatolian_Hieroglyphs}', "");
    Expect(0, 83527, '\p{	_Anatolian_Hieroglyphs}', "");
    Expect(1, 83527, '\p{^	_Anatolian_Hieroglyphs}', "");
    Expect(1, 83527, '\P{	_Anatolian_Hieroglyphs}', "");
    Expect(0, 83527, '\P{^	_Anatolian_Hieroglyphs}', "");
    Error('\p{-:=is_Anatolian_hieroglyphs}');
    Error('\P{-:=is_Anatolian_hieroglyphs}');
    Expect(1, 83526, '\p{isanatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^isanatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{isanatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^isanatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{isanatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^isanatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{isanatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^isanatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{	is_Anatolian_Hieroglyphs}', "");
    Expect(0, 83526, '\p{^	is_Anatolian_Hieroglyphs}', "");
    Expect(0, 83526, '\P{	is_Anatolian_Hieroglyphs}', "");
    Expect(1, 83526, '\P{^	is_Anatolian_Hieroglyphs}', "");
    Expect(0, 83527, '\p{	is_Anatolian_Hieroglyphs}', "");
    Expect(1, 83527, '\p{^	is_Anatolian_Hieroglyphs}', "");
    Expect(1, 83527, '\P{	is_Anatolian_Hieroglyphs}', "");
    Expect(0, 83527, '\P{^	is_Anatolian_Hieroglyphs}', "");
    Error('\p{/a/-_Hluw}');
    Error('\P{/a/-_Hluw}');
    Expect(1, 83526, '\p{hluw}', "");
    Expect(0, 83526, '\p{^hluw}', "");
    Expect(0, 83526, '\P{hluw}', "");
    Expect(1, 83526, '\P{^hluw}', "");
    Expect(0, 83527, '\p{hluw}', "");
    Expect(1, 83527, '\p{^hluw}', "");
    Expect(1, 83527, '\P{hluw}', "");
    Expect(0, 83527, '\P{^hluw}', "");
    Expect(1, 83526, '\p{_-Hluw}', "");
    Expect(0, 83526, '\p{^_-Hluw}', "");
    Expect(0, 83526, '\P{_-Hluw}', "");
    Expect(1, 83526, '\P{^_-Hluw}', "");
    Expect(0, 83527, '\p{_-Hluw}', "");
    Expect(1, 83527, '\p{^_-Hluw}', "");
    Expect(1, 83527, '\P{_-Hluw}', "");
    Expect(0, 83527, '\P{^_-Hluw}', "");
    Error('\p{	_is_hluw/a/}');
    Error('\P{	_is_hluw/a/}');
    Expect(1, 83526, '\p{ishluw}', "");
    Expect(0, 83526, '\p{^ishluw}', "");
    Expect(0, 83526, '\P{ishluw}', "");
    Expect(1, 83526, '\P{^ishluw}', "");
    Expect(0, 83527, '\p{ishluw}', "");
    Expect(1, 83527, '\p{^ishluw}', "");
    Expect(1, 83527, '\P{ishluw}', "");
    Expect(0, 83527, '\P{^ishluw}', "");
    Expect(1, 83526, '\p{	is_HLUW}', "");
    Expect(0, 83526, '\p{^	is_HLUW}', "");
    Expect(0, 83526, '\P{	is_HLUW}', "");
    Expect(1, 83526, '\P{^	is_HLUW}', "");
    Expect(0, 83527, '\p{	is_HLUW}', "");
    Expect(1, 83527, '\p{^	is_HLUW}', "");
    Expect(1, 83527, '\P{	is_HLUW}', "");
    Expect(0, 83527, '\P{^	is_HLUW}', "");
    Error('\p{-/a/Ancient_Greek_Musical_notation}');
    Error('\P{-/a/Ancient_Greek_Musical_notation}');
    Expect(1, 119375, '\p{ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\p{^ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\P{ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\P{^ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\p{ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\p{^ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\P{ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\P{^ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\p{-	ancient_greek_Musical_notation}', "");
    Expect(0, 119375, '\p{^-	ancient_greek_Musical_notation}', "");
    Expect(0, 119375, '\P{-	ancient_greek_Musical_notation}', "");
    Expect(1, 119375, '\P{^-	ancient_greek_Musical_notation}', "");
    Expect(0, 119376, '\p{-	ancient_greek_Musical_notation}', "");
    Expect(1, 119376, '\p{^-	ancient_greek_Musical_notation}', "");
    Expect(1, 119376, '\P{-	ancient_greek_Musical_notation}', "");
    Expect(0, 119376, '\P{^-	ancient_greek_Musical_notation}', "");
    Error('\p{:=- IS_Ancient_Greek_MUSICAL_NOTATION}');
    Error('\P{:=- IS_Ancient_Greek_MUSICAL_NOTATION}');
    Expect(1, 119375, '\p{isancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\p{^isancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\P{isancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\P{^isancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\p{isancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\p{^isancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\P{isancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\P{^isancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\p{is_ANCIENT_Greek_MUSICAL_notation}', "");
    Expect(0, 119375, '\p{^is_ANCIENT_Greek_MUSICAL_notation}', "");
    Expect(0, 119375, '\P{is_ANCIENT_Greek_MUSICAL_notation}', "");
    Expect(1, 119375, '\P{^is_ANCIENT_Greek_MUSICAL_notation}', "");
    Expect(0, 119376, '\p{is_ANCIENT_Greek_MUSICAL_notation}', "");
    Expect(1, 119376, '\p{^is_ANCIENT_Greek_MUSICAL_notation}', "");
    Expect(1, 119376, '\P{is_ANCIENT_Greek_MUSICAL_notation}', "");
    Expect(0, 119376, '\P{^is_ANCIENT_Greek_MUSICAL_notation}', "");
    Error('\p{	 In_Ancient_GREEK_MUSICAL_Notation/a/}');
    Error('\P{	 In_Ancient_GREEK_MUSICAL_Notation/a/}');
    Expect(1, 119375, '\p{inancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\p{^inancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\P{inancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\P{^inancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\p{inancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\p{^inancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\P{inancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\P{^inancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\p{_-IN_Ancient_Greek_MUSICAL_NOTATION}', "");
    Expect(0, 119375, '\p{^_-IN_Ancient_Greek_MUSICAL_NOTATION}', "");
    Expect(0, 119375, '\P{_-IN_Ancient_Greek_MUSICAL_NOTATION}', "");
    Expect(1, 119375, '\P{^_-IN_Ancient_Greek_MUSICAL_NOTATION}', "");
    Expect(0, 119376, '\p{_-IN_Ancient_Greek_MUSICAL_NOTATION}', "");
    Expect(1, 119376, '\p{^_-IN_Ancient_Greek_MUSICAL_NOTATION}', "");
    Expect(1, 119376, '\P{_-IN_Ancient_Greek_MUSICAL_NOTATION}', "");
    Expect(0, 119376, '\P{^_-IN_Ancient_Greek_MUSICAL_NOTATION}', "");
    Error('\p{/a/ANCIENT_greek_MUSIC}');
    Error('\P{/a/ANCIENT_greek_MUSIC}');
    Expect(1, 119375, '\p{ancientgreekmusic}', "");
    Expect(0, 119375, '\p{^ancientgreekmusic}', "");
    Expect(0, 119375, '\P{ancientgreekmusic}', "");
    Expect(1, 119375, '\P{^ancientgreekmusic}', "");
    Expect(0, 119376, '\p{ancientgreekmusic}', "");
    Expect(1, 119376, '\p{^ancientgreekmusic}', "");
    Expect(1, 119376, '\P{ancientgreekmusic}', "");
    Expect(0, 119376, '\P{^ancientgreekmusic}', "");
    Expect(1, 119375, '\p{_Ancient_Greek_Music}', "");
    Expect(0, 119375, '\p{^_Ancient_Greek_Music}', "");
    Expect(0, 119375, '\P{_Ancient_Greek_Music}', "");
    Expect(1, 119375, '\P{^_Ancient_Greek_Music}', "");
    Expect(0, 119376, '\p{_Ancient_Greek_Music}', "");
    Expect(1, 119376, '\p{^_Ancient_Greek_Music}', "");
    Expect(1, 119376, '\P{_Ancient_Greek_Music}', "");
    Expect(0, 119376, '\P{^_Ancient_Greek_Music}', "");
    Error('\p{-/a/Is_ancient_GREEK_MUSIC}');
    Error('\P{-/a/Is_ancient_GREEK_MUSIC}');
    Expect(1, 119375, '\p{isancientgreekmusic}', "");
    Expect(0, 119375, '\p{^isancientgreekmusic}', "");
    Expect(0, 119375, '\P{isancientgreekmusic}', "");
    Expect(1, 119375, '\P{^isancientgreekmusic}', "");
    Expect(0, 119376, '\p{isancientgreekmusic}', "");
    Expect(1, 119376, '\p{^isancientgreekmusic}', "");
    Expect(1, 119376, '\P{isancientgreekmusic}', "");
    Expect(0, 119376, '\P{^isancientgreekmusic}', "");
    Expect(1, 119375, '\p{	-Is_Ancient_Greek_music}', "");
    Expect(0, 119375, '\p{^	-Is_Ancient_Greek_music}', "");
    Expect(0, 119375, '\P{	-Is_Ancient_Greek_music}', "");
    Expect(1, 119375, '\P{^	-Is_Ancient_Greek_music}', "");
    Expect(0, 119376, '\p{	-Is_Ancient_Greek_music}', "");
    Expect(1, 119376, '\p{^	-Is_Ancient_Greek_music}', "");
    Expect(1, 119376, '\P{	-Is_Ancient_Greek_music}', "");
    Expect(0, 119376, '\P{^	-Is_Ancient_Greek_music}', "");
    Error('\p{In_ANCIENT_Greek_Music:=}');
    Error('\P{In_ANCIENT_Greek_Music:=}');
    Expect(1, 119375, '\p{inancientgreekmusic}', "");
    Expect(0, 119375, '\p{^inancientgreekmusic}', "");
    Expect(0, 119375, '\P{inancientgreekmusic}', "");
    Expect(1, 119375, '\P{^inancientgreekmusic}', "");
    Expect(0, 119376, '\p{inancientgreekmusic}', "");
    Expect(1, 119376, '\p{^inancientgreekmusic}', "");
    Expect(1, 119376, '\P{inancientgreekmusic}', "");
    Expect(0, 119376, '\P{^inancientgreekmusic}', "");
    Expect(1, 119375, '\p{-	IN_ANCIENT_GREEK_Music}', "");
    Expect(0, 119375, '\p{^-	IN_ANCIENT_GREEK_Music}', "");
    Expect(0, 119375, '\P{-	IN_ANCIENT_GREEK_Music}', "");
    Expect(1, 119375, '\P{^-	IN_ANCIENT_GREEK_Music}', "");
    Expect(0, 119376, '\p{-	IN_ANCIENT_GREEK_Music}', "");
    Expect(1, 119376, '\p{^-	IN_ANCIENT_GREEK_Music}', "");
    Expect(1, 119376, '\P{-	IN_ANCIENT_GREEK_Music}', "");
    Expect(0, 119376, '\P{^-	IN_ANCIENT_GREEK_Music}', "");
    Error('\p{	/a/ANCIENT_Greek_Numbers}');
    Error('\P{	/a/ANCIENT_Greek_Numbers}');
    Expect(1, 65935, '\p{ancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^ancientgreeknumbers}', "");
    Expect(0, 65935, '\P{ancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^ancientgreeknumbers}', "");
    Expect(0, 65936, '\p{ancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^ancientgreeknumbers}', "");
    Expect(1, 65936, '\P{ancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^ancientgreeknumbers}', "");
    Expect(1, 65935, '\p{  ANCIENT_greek_NUMBERS}', "");
    Expect(0, 65935, '\p{^  ANCIENT_greek_NUMBERS}', "");
    Expect(0, 65935, '\P{  ANCIENT_greek_NUMBERS}', "");
    Expect(1, 65935, '\P{^  ANCIENT_greek_NUMBERS}', "");
    Expect(0, 65936, '\p{  ANCIENT_greek_NUMBERS}', "");
    Expect(1, 65936, '\p{^  ANCIENT_greek_NUMBERS}', "");
    Expect(1, 65936, '\P{  ANCIENT_greek_NUMBERS}', "");
    Expect(0, 65936, '\P{^  ANCIENT_greek_NUMBERS}', "");
    Error('\p{/a/_-is_Ancient_Greek_numbers}');
    Error('\P{/a/_-is_Ancient_Greek_numbers}');
    Expect(1, 65935, '\p{isancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^isancientgreeknumbers}', "");
    Expect(0, 65935, '\P{isancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^isancientgreeknumbers}', "");
    Expect(0, 65936, '\p{isancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^isancientgreeknumbers}', "");
    Expect(1, 65936, '\P{isancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^isancientgreeknumbers}', "");
    Expect(1, 65935, '\p{ Is_ANCIENT_greek_Numbers}', "");
    Expect(0, 65935, '\p{^ Is_ANCIENT_greek_Numbers}', "");
    Expect(0, 65935, '\P{ Is_ANCIENT_greek_Numbers}', "");
    Expect(1, 65935, '\P{^ Is_ANCIENT_greek_Numbers}', "");
    Expect(0, 65936, '\p{ Is_ANCIENT_greek_Numbers}', "");
    Expect(1, 65936, '\p{^ Is_ANCIENT_greek_Numbers}', "");
    Expect(1, 65936, '\P{ Is_ANCIENT_greek_Numbers}', "");
    Expect(0, 65936, '\P{^ Is_ANCIENT_greek_Numbers}', "");
    Error('\p{:=_In_ancient_GREEK_Numbers}');
    Error('\P{:=_In_ancient_GREEK_Numbers}');
    Expect(1, 65935, '\p{inancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^inancientgreeknumbers}', "");
    Expect(0, 65935, '\P{inancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^inancientgreeknumbers}', "");
    Expect(0, 65936, '\p{inancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^inancientgreeknumbers}', "");
    Expect(1, 65936, '\P{inancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^inancientgreeknumbers}', "");
    Expect(1, 65935, '\p{__In_Ancient_Greek_numbers}', "");
    Expect(0, 65935, '\p{^__In_Ancient_Greek_numbers}', "");
    Expect(0, 65935, '\P{__In_Ancient_Greek_numbers}', "");
    Expect(1, 65935, '\P{^__In_Ancient_Greek_numbers}', "");
    Expect(0, 65936, '\p{__In_Ancient_Greek_numbers}', "");
    Expect(1, 65936, '\p{^__In_Ancient_Greek_numbers}', "");
    Expect(1, 65936, '\P{__In_Ancient_Greek_numbers}', "");
    Expect(0, 65936, '\P{^__In_Ancient_Greek_numbers}', "");
    Error('\p{/a/ANCIENT_Symbols}');
    Error('\P{/a/ANCIENT_Symbols}');
    Expect(1, 65999, '\p{ancientsymbols}', "");
    Expect(0, 65999, '\p{^ancientsymbols}', "");
    Expect(0, 65999, '\P{ancientsymbols}', "");
    Expect(1, 65999, '\P{^ancientsymbols}', "");
    Expect(0, 66000, '\p{ancientsymbols}', "");
    Expect(1, 66000, '\p{^ancientsymbols}', "");
    Expect(1, 66000, '\P{ancientsymbols}', "");
    Expect(0, 66000, '\P{^ancientsymbols}', "");
    Expect(1, 65999, '\p{ -ANCIENT_SYMBOLS}', "");
    Expect(0, 65999, '\p{^ -ANCIENT_SYMBOLS}', "");
    Expect(0, 65999, '\P{ -ANCIENT_SYMBOLS}', "");
    Expect(1, 65999, '\P{^ -ANCIENT_SYMBOLS}', "");
    Expect(0, 66000, '\p{ -ANCIENT_SYMBOLS}', "");
    Expect(1, 66000, '\p{^ -ANCIENT_SYMBOLS}', "");
    Expect(1, 66000, '\P{ -ANCIENT_SYMBOLS}', "");
    Expect(0, 66000, '\P{^ -ANCIENT_SYMBOLS}', "");
    Error('\p{  Is_ANCIENT_Symbols:=}');
    Error('\P{  Is_ANCIENT_Symbols:=}');
    Expect(1, 65999, '\p{isancientsymbols}', "");
    Expect(0, 65999, '\p{^isancientsymbols}', "");
    Expect(0, 65999, '\P{isancientsymbols}', "");
    Expect(1, 65999, '\P{^isancientsymbols}', "");
    Expect(0, 66000, '\p{isancientsymbols}', "");
    Expect(1, 66000, '\p{^isancientsymbols}', "");
    Expect(1, 66000, '\P{isancientsymbols}', "");
    Expect(0, 66000, '\P{^isancientsymbols}', "");
    Expect(1, 65999, '\p{-Is_Ancient_SYMBOLS}', "");
    Expect(0, 65999, '\p{^-Is_Ancient_SYMBOLS}', "");
    Expect(0, 65999, '\P{-Is_Ancient_SYMBOLS}', "");
    Expect(1, 65999, '\P{^-Is_Ancient_SYMBOLS}', "");
    Expect(0, 66000, '\p{-Is_Ancient_SYMBOLS}', "");
    Expect(1, 66000, '\p{^-Is_Ancient_SYMBOLS}', "");
    Expect(1, 66000, '\P{-Is_Ancient_SYMBOLS}', "");
    Expect(0, 66000, '\P{^-Is_Ancient_SYMBOLS}', "");
    Error('\p{ /a/In_ancient_symbols}');
    Error('\P{ /a/In_ancient_symbols}');
    Expect(1, 65999, '\p{inancientsymbols}', "");
    Expect(0, 65999, '\p{^inancientsymbols}', "");
    Expect(0, 65999, '\P{inancientsymbols}', "");
    Expect(1, 65999, '\P{^inancientsymbols}', "");
    Expect(0, 66000, '\p{inancientsymbols}', "");
    Expect(1, 66000, '\p{^inancientsymbols}', "");
    Expect(1, 66000, '\P{inancientsymbols}', "");
    Expect(0, 66000, '\P{^inancientsymbols}', "");
    Expect(1, 65999, '\p{_In_ancient_symbols}', "");
    Expect(0, 65999, '\p{^_In_ancient_symbols}', "");
    Expect(0, 65999, '\P{_In_ancient_symbols}', "");
    Expect(1, 65999, '\P{^_In_ancient_symbols}', "");
    Expect(0, 66000, '\p{_In_ancient_symbols}', "");
    Expect(1, 66000, '\p{^_In_ancient_symbols}', "");
    Expect(1, 66000, '\P{_In_ancient_symbols}', "");
    Expect(0, 66000, '\P{^_In_ancient_symbols}', "");
    Error('\p{/a/__ANY}');
    Error('\P{/a/__ANY}');
    Expect(1, 1, '\p{any}', "");
    Expect(0, 1, '\p{^any}', "");
    Expect(0, 1, '\P{any}', "");
    Expect(1, 1, '\P{^any}', "");
    Expect(0, 8912887, '\p{any}', "");
    Expect(1, 8912887, '\p{^any}', "");
    Expect(1, 8912887, '\P{any}', "");
    Expect(0, 8912887, '\P{^any}', "");
    Expect(1, 1, '\p{--Any}', "");
    Expect(0, 1, '\p{^--Any}', "");
    Expect(0, 1, '\P{--Any}', "");
    Expect(1, 1, '\P{^--Any}', "");
    Expect(0, 8912887, '\p{--Any}', "");
    Expect(1, 8912887, '\p{^--Any}', "");
    Expect(1, 8912887, '\P{--Any}', "");
    Expect(0, 8912887, '\P{^--Any}', "");
    Error('\p{:=UNICODE}');
    Error('\P{:=UNICODE}');
    Expect(1, 1, '\p{unicode}', "");
    Expect(0, 1, '\p{^unicode}', "");
    Expect(0, 1, '\P{unicode}', "");
    Expect(1, 1, '\P{^unicode}', "");
    Expect(0, 8912887, '\p{unicode}', "");
    Expect(1, 8912887, '\p{^unicode}', "");
    Expect(1, 8912887, '\P{unicode}', "");
    Expect(0, 8912887, '\P{^unicode}', "");
    Expect(1, 1, '\p{-	Unicode}', "");
    Expect(0, 1, '\p{^-	Unicode}', "");
    Expect(0, 1, '\P{-	Unicode}', "");
    Expect(1, 1, '\P{^-	Unicode}', "");
    Expect(0, 8912887, '\p{-	Unicode}', "");
    Expect(1, 8912887, '\p{^-	Unicode}', "");
    Expect(1, 8912887, '\P{-	Unicode}', "");
    Expect(0, 8912887, '\P{^-	Unicode}', "");
    Error('\p{:=_Is_Any}');
    Error('\P{:=_Is_Any}');
    Expect(1, 1, '\p{isany}', "");
    Expect(0, 1, '\p{^isany}', "");
    Expect(0, 1, '\P{isany}', "");
    Expect(1, 1, '\P{^isany}', "");
    Expect(0, 8912887, '\p{isany}', "");
    Expect(1, 8912887, '\p{^isany}', "");
    Expect(1, 8912887, '\P{isany}', "");
    Expect(0, 8912887, '\P{^isany}', "");
    Expect(1, 1, '\p{_Is_Any}', "");
    Expect(0, 1, '\p{^_Is_Any}', "");
    Expect(0, 1, '\P{_Is_Any}', "");
    Expect(1, 1, '\P{^_Is_Any}', "");
    Expect(0, 8912887, '\p{_Is_Any}', "");
    Expect(1, 8912887, '\p{^_Is_Any}', "");
    Expect(1, 8912887, '\P{_Is_Any}', "");
    Expect(0, 8912887, '\P{^_Is_Any}', "");
    Error('\p{_:=Is_unicode}');
    Error('\P{_:=Is_unicode}');
    Expect(1, 1, '\p{isunicode}', "");
    Expect(0, 1, '\p{^isunicode}', "");
    Expect(0, 1, '\P{isunicode}', "");
    Expect(1, 1, '\P{^isunicode}', "");
    Expect(0, 8912887, '\p{isunicode}', "");
    Expect(1, 8912887, '\p{^isunicode}', "");
    Expect(1, 8912887, '\P{isunicode}', "");
    Expect(0, 8912887, '\P{^isunicode}', "");
    Expect(1, 1, '\p{_ Is_UNICODE}', "");
    Expect(0, 1, '\p{^_ Is_UNICODE}', "");
    Expect(0, 1, '\P{_ Is_UNICODE}', "");
    Expect(1, 1, '\P{^_ Is_UNICODE}', "");
    Expect(0, 8912887, '\p{_ Is_UNICODE}', "");
    Expect(1, 8912887, '\p{^_ Is_UNICODE}', "");
    Expect(1, 8912887, '\P{_ Is_UNICODE}', "");
    Expect(0, 8912887, '\P{^_ Is_UNICODE}', "");
    Error('\p{	ARABIC/a/}');
    Error('\P{	ARABIC/a/}');
    Expect(1, 126705, '\p{arabic}', "");
    Expect(0, 126705, '\p{^arabic}', "");
    Expect(0, 126705, '\P{arabic}', "");
    Expect(1, 126705, '\P{^arabic}', "");
    Expect(0, 126706, '\p{arabic}', "");
    Expect(1, 126706, '\p{^arabic}', "");
    Expect(1, 126706, '\P{arabic}', "");
    Expect(0, 126706, '\P{^arabic}', "");
    Expect(1, 126705, '\p{_ARABIC}', "");
    Expect(0, 126705, '\p{^_ARABIC}', "");
    Expect(0, 126705, '\P{_ARABIC}', "");
    Expect(1, 126705, '\P{^_ARABIC}', "");
    Expect(0, 126706, '\p{_ARABIC}', "");
    Expect(1, 126706, '\p{^_ARABIC}', "");
    Expect(1, 126706, '\P{_ARABIC}', "");
    Expect(0, 126706, '\P{^_ARABIC}', "");
    Error('\p{ IS_ARABIC/a/}');
    Error('\P{ IS_ARABIC/a/}');
    Expect(1, 126705, '\p{isarabic}', "");
    Expect(0, 126705, '\p{^isarabic}', "");
    Expect(0, 126705, '\P{isarabic}', "");
    Expect(1, 126705, '\P{^isarabic}', "");
    Expect(0, 126706, '\p{isarabic}', "");
    Expect(1, 126706, '\p{^isarabic}', "");
    Expect(1, 126706, '\P{isarabic}', "");
    Expect(0, 126706, '\P{^isarabic}', "");
    Expect(1, 126705, '\p{	Is_arabic}', "");
    Expect(0, 126705, '\p{^	Is_arabic}', "");
    Expect(0, 126705, '\P{	Is_arabic}', "");
    Expect(1, 126705, '\P{^	Is_arabic}', "");
    Expect(0, 126706, '\p{	Is_arabic}', "");
    Expect(1, 126706, '\p{^	Is_arabic}', "");
    Expect(1, 126706, '\P{	Is_arabic}', "");
    Expect(0, 126706, '\P{^	Is_arabic}', "");
    Error('\p{	:=arab}');
    Error('\P{	:=arab}');
    Expect(1, 126705, '\p{arab}', "");
    Expect(0, 126705, '\p{^arab}', "");
    Expect(0, 126705, '\P{arab}', "");
    Expect(1, 126705, '\P{^arab}', "");
    Expect(0, 126706, '\p{arab}', "");
    Expect(1, 126706, '\p{^arab}', "");
    Expect(1, 126706, '\P{arab}', "");
    Expect(0, 126706, '\P{^arab}', "");
    Expect(1, 126705, '\p{	ARAB}', "");
    Expect(0, 126705, '\p{^	ARAB}', "");
    Expect(0, 126705, '\P{	ARAB}', "");
    Expect(1, 126705, '\P{^	ARAB}', "");
    Expect(0, 126706, '\p{	ARAB}', "");
    Expect(1, 126706, '\p{^	ARAB}', "");
    Expect(1, 126706, '\P{	ARAB}', "");
    Expect(0, 126706, '\P{^	ARAB}', "");
    Error('\p{	Is_Arab/a/}');
    Error('\P{	Is_Arab/a/}');
    Expect(1, 126705, '\p{isarab}', "");
    Expect(0, 126705, '\p{^isarab}', "");
    Expect(0, 126705, '\P{isarab}', "");
    Expect(1, 126705, '\P{^isarab}', "");
    Expect(0, 126706, '\p{isarab}', "");
    Expect(1, 126706, '\p{^isarab}', "");
    Expect(1, 126706, '\P{isarab}', "");
    Expect(0, 126706, '\P{^isarab}', "");
    Expect(1, 126705, '\p{	-Is_Arab}', "");
    Expect(0, 126705, '\p{^	-Is_Arab}', "");
    Expect(0, 126705, '\P{	-Is_Arab}', "");
    Expect(1, 126705, '\P{^	-Is_Arab}', "");
    Expect(0, 126706, '\p{	-Is_Arab}', "");
    Expect(1, 126706, '\p{^	-Is_Arab}', "");
    Expect(1, 126706, '\P{	-Is_Arab}', "");
    Expect(0, 126706, '\P{^	-Is_Arab}', "");
    Error('\p{_/a/arabic_Extended_A}');
    Error('\P{_/a/arabic_Extended_A}');
    Expect(1, 2303, '\p{arabicextendeda}', "");
    Expect(0, 2303, '\p{^arabicextendeda}', "");
    Expect(0, 2303, '\P{arabicextendeda}', "");
    Expect(1, 2303, '\P{^arabicextendeda}', "");
    Expect(0, 2304, '\p{arabicextendeda}', "");
    Expect(1, 2304, '\p{^arabicextendeda}', "");
    Expect(1, 2304, '\P{arabicextendeda}', "");
    Expect(0, 2304, '\P{^arabicextendeda}', "");
    Expect(1, 2303, '\p{	Arabic_EXTENDED_A}', "");
    Expect(0, 2303, '\p{^	Arabic_EXTENDED_A}', "");
    Expect(0, 2303, '\P{	Arabic_EXTENDED_A}', "");
    Expect(1, 2303, '\P{^	Arabic_EXTENDED_A}', "");
    Expect(0, 2304, '\p{	Arabic_EXTENDED_A}', "");
    Expect(1, 2304, '\p{^	Arabic_EXTENDED_A}', "");
    Expect(1, 2304, '\P{	Arabic_EXTENDED_A}', "");
    Expect(0, 2304, '\P{^	Arabic_EXTENDED_A}', "");
    Error('\p{_ Is_Arabic_extended_a/a/}');
    Error('\P{_ Is_Arabic_extended_a/a/}');
    Expect(1, 2303, '\p{isarabicextendeda}', "");
    Expect(0, 2303, '\p{^isarabicextendeda}', "");
    Expect(0, 2303, '\P{isarabicextendeda}', "");
    Expect(1, 2303, '\P{^isarabicextendeda}', "");
    Expect(0, 2304, '\p{isarabicextendeda}', "");
    Expect(1, 2304, '\p{^isarabicextendeda}', "");
    Expect(1, 2304, '\P{isarabicextendeda}', "");
    Expect(0, 2304, '\P{^isarabicextendeda}', "");
    Expect(1, 2303, '\p{_is_Arabic_Extended_A}', "");
    Expect(0, 2303, '\p{^_is_Arabic_Extended_A}', "");
    Expect(0, 2303, '\P{_is_Arabic_Extended_A}', "");
    Expect(1, 2303, '\P{^_is_Arabic_Extended_A}', "");
    Expect(0, 2304, '\p{_is_Arabic_Extended_A}', "");
    Expect(1, 2304, '\p{^_is_Arabic_Extended_A}', "");
    Expect(1, 2304, '\P{_is_Arabic_Extended_A}', "");
    Expect(0, 2304, '\P{^_is_Arabic_Extended_A}', "");
    Error('\p{/a/	-In_Arabic_EXTENDED_A}');
    Error('\P{/a/	-In_Arabic_EXTENDED_A}');
    Expect(1, 2303, '\p{inarabicextendeda}', "");
    Expect(0, 2303, '\p{^inarabicextendeda}', "");
    Expect(0, 2303, '\P{inarabicextendeda}', "");
    Expect(1, 2303, '\P{^inarabicextendeda}', "");
    Expect(0, 2304, '\p{inarabicextendeda}', "");
    Expect(1, 2304, '\p{^inarabicextendeda}', "");
    Expect(1, 2304, '\P{inarabicextendeda}', "");
    Expect(0, 2304, '\P{^inarabicextendeda}', "");
    Expect(1, 2303, '\p{- In_Arabic_Extended_A}', "");
    Expect(0, 2303, '\p{^- In_Arabic_Extended_A}', "");
    Expect(0, 2303, '\P{- In_Arabic_Extended_A}', "");
    Expect(1, 2303, '\P{^- In_Arabic_Extended_A}', "");
    Expect(0, 2304, '\p{- In_Arabic_Extended_A}', "");
    Expect(1, 2304, '\p{^- In_Arabic_Extended_A}', "");
    Expect(1, 2304, '\P{- In_Arabic_Extended_A}', "");
    Expect(0, 2304, '\P{^- In_Arabic_Extended_A}', "");
    Error('\p{:=ARABIC_EXT_a}');
    Error('\P{:=ARABIC_EXT_a}');
    Expect(1, 2303, '\p{arabicexta}', "");
    Expect(0, 2303, '\p{^arabicexta}', "");
    Expect(0, 2303, '\P{arabicexta}', "");
    Expect(1, 2303, '\P{^arabicexta}', "");
    Expect(0, 2304, '\p{arabicexta}', "");
    Expect(1, 2304, '\p{^arabicexta}', "");
    Expect(1, 2304, '\P{arabicexta}', "");
    Expect(0, 2304, '\P{^arabicexta}', "");
    Expect(1, 2303, '\p{ -Arabic_EXT_a}', "");
    Expect(0, 2303, '\p{^ -Arabic_EXT_a}', "");
    Expect(0, 2303, '\P{ -Arabic_EXT_a}', "");
    Expect(1, 2303, '\P{^ -Arabic_EXT_a}', "");
    Expect(0, 2304, '\p{ -Arabic_EXT_a}', "");
    Expect(1, 2304, '\p{^ -Arabic_EXT_a}', "");
    Expect(1, 2304, '\P{ -Arabic_EXT_a}', "");
    Expect(0, 2304, '\P{^ -Arabic_EXT_a}', "");
    Error('\p{-:=IS_ARABIC_Ext_A}');
    Error('\P{-:=IS_ARABIC_Ext_A}');
    Expect(1, 2303, '\p{isarabicexta}', "");
    Expect(0, 2303, '\p{^isarabicexta}', "");
    Expect(0, 2303, '\P{isarabicexta}', "");
    Expect(1, 2303, '\P{^isarabicexta}', "");
    Expect(0, 2304, '\p{isarabicexta}', "");
    Expect(1, 2304, '\p{^isarabicexta}', "");
    Expect(1, 2304, '\P{isarabicexta}', "");
    Expect(0, 2304, '\P{^isarabicexta}', "");
    Expect(1, 2303, '\p{-	Is_Arabic_ext_A}', "");
    Expect(0, 2303, '\p{^-	Is_Arabic_ext_A}', "");
    Expect(0, 2303, '\P{-	Is_Arabic_ext_A}', "");
    Expect(1, 2303, '\P{^-	Is_Arabic_ext_A}', "");
    Expect(0, 2304, '\p{-	Is_Arabic_ext_A}', "");
    Expect(1, 2304, '\p{^-	Is_Arabic_ext_A}', "");
    Expect(1, 2304, '\P{-	Is_Arabic_ext_A}', "");
    Expect(0, 2304, '\P{^-	Is_Arabic_ext_A}', "");
    Error('\p{--In_arabic_ext_a/a/}');
    Error('\P{--In_arabic_ext_a/a/}');
    Expect(1, 2303, '\p{inarabicexta}', "");
    Expect(0, 2303, '\p{^inarabicexta}', "");
    Expect(0, 2303, '\P{inarabicexta}', "");
    Expect(1, 2303, '\P{^inarabicexta}', "");
    Expect(0, 2304, '\p{inarabicexta}', "");
    Expect(1, 2304, '\p{^inarabicexta}', "");
    Expect(1, 2304, '\P{inarabicexta}', "");
    Expect(0, 2304, '\P{^inarabicexta}', "");
    Expect(1, 2303, '\p{__In_Arabic_Ext_A}', "");
    Expect(0, 2303, '\p{^__In_Arabic_Ext_A}', "");
    Expect(0, 2303, '\P{__In_Arabic_Ext_A}', "");
    Expect(1, 2303, '\P{^__In_Arabic_Ext_A}', "");
    Expect(0, 2304, '\p{__In_Arabic_Ext_A}', "");
    Expect(1, 2304, '\p{^__In_Arabic_Ext_A}', "");
    Expect(1, 2304, '\P{__In_Arabic_Ext_A}', "");
    Expect(0, 2304, '\P{^__In_Arabic_Ext_A}', "");
    Error('\p{:=arabic_MATHEMATICAL_Alphabetic_Symbols}');
    Error('\P{:=arabic_MATHEMATICAL_Alphabetic_Symbols}');
    Expect(1, 126719, '\p{arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\p{^arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\P{arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\P{^arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\p{arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\p{^arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\P{arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\P{^arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\p{  Arabic_Mathematical_Alphabetic_Symbols}', "");
    Expect(0, 126719, '\p{^  Arabic_Mathematical_Alphabetic_Symbols}', "");
    Expect(0, 126719, '\P{  Arabic_Mathematical_Alphabetic_Symbols}', "");
    Expect(1, 126719, '\P{^  Arabic_Mathematical_Alphabetic_Symbols}', "");
    Expect(0, 126720, '\p{  Arabic_Mathematical_Alphabetic_Symbols}', "");
    Expect(1, 126720, '\p{^  Arabic_Mathematical_Alphabetic_Symbols}', "");
    Expect(1, 126720, '\P{  Arabic_Mathematical_Alphabetic_Symbols}', "");
    Expect(0, 126720, '\P{^  Arabic_Mathematical_Alphabetic_Symbols}', "");
    Error('\p{-/a/Is_ARABIC_MATHEMATICAL_Alphabetic_symbols}');
    Error('\P{-/a/Is_ARABIC_MATHEMATICAL_Alphabetic_symbols}');
    Expect(1, 126719, '\p{isarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\p{^isarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\P{isarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\P{^isarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\p{isarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\p{^isarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\P{isarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\P{^isarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\p{--is_Arabic_Mathematical_ALPHABETIC_SYMBOLS}', "");
    Expect(0, 126719, '\p{^--is_Arabic_Mathematical_ALPHABETIC_SYMBOLS}', "");
    Expect(0, 126719, '\P{--is_Arabic_Mathematical_ALPHABETIC_SYMBOLS}', "");
    Expect(1, 126719, '\P{^--is_Arabic_Mathematical_ALPHABETIC_SYMBOLS}', "");
    Expect(0, 126720, '\p{--is_Arabic_Mathematical_ALPHABETIC_SYMBOLS}', "");
    Expect(1, 126720, '\p{^--is_Arabic_Mathematical_ALPHABETIC_SYMBOLS}', "");
    Expect(1, 126720, '\P{--is_Arabic_Mathematical_ALPHABETIC_SYMBOLS}', "");
    Expect(0, 126720, '\P{^--is_Arabic_Mathematical_ALPHABETIC_SYMBOLS}', "");
    Error('\p{:=	IN_Arabic_Mathematical_ALPHABETIC_SYMBOLS}');
    Error('\P{:=	IN_Arabic_Mathematical_ALPHABETIC_SYMBOLS}');
    Expect(1, 126719, '\p{inarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\p{^inarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\P{inarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\P{^inarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\p{inarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\p{^inarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\P{inarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\P{^inarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\p{		in_ARABIC_Mathematical_alphabetic_Symbols}', "");
    Expect(0, 126719, '\p{^		in_ARABIC_Mathematical_alphabetic_Symbols}', "");
    Expect(0, 126719, '\P{		in_ARABIC_Mathematical_alphabetic_Symbols}', "");
    Expect(1, 126719, '\P{^		in_ARABIC_Mathematical_alphabetic_Symbols}', "");
    Expect(0, 126720, '\p{		in_ARABIC_Mathematical_alphabetic_Symbols}', "");
    Expect(1, 126720, '\p{^		in_ARABIC_Mathematical_alphabetic_Symbols}', "");
    Expect(1, 126720, '\P{		in_ARABIC_Mathematical_alphabetic_Symbols}', "");
    Expect(0, 126720, '\P{^		in_ARABIC_Mathematical_alphabetic_Symbols}', "");
    Error('\p{/a/-Arabic_Math}');
    Error('\P{/a/-Arabic_Math}');
    Expect(1, 126719, '\p{arabicmath}', "");
    Expect(0, 126719, '\p{^arabicmath}', "");
    Expect(0, 126719, '\P{arabicmath}', "");
    Expect(1, 126719, '\P{^arabicmath}', "");
    Expect(0, 126720, '\p{arabicmath}', "");
    Expect(1, 126720, '\p{^arabicmath}', "");
    Expect(1, 126720, '\P{arabicmath}', "");
    Expect(0, 126720, '\P{^arabicmath}', "");
    Expect(1, 126719, '\p{Arabic_Math}', "");
    Expect(0, 126719, '\p{^Arabic_Math}', "");
    Expect(0, 126719, '\P{Arabic_Math}', "");
    Expect(1, 126719, '\P{^Arabic_Math}', "");
    Expect(0, 126720, '\p{Arabic_Math}', "");
    Expect(1, 126720, '\p{^Arabic_Math}', "");
    Expect(1, 126720, '\P{Arabic_Math}', "");
    Expect(0, 126720, '\P{^Arabic_Math}', "");
    Error('\p{/a/ -Is_ARABIC_Math}');
    Error('\P{/a/ -Is_ARABIC_Math}');
    Expect(1, 126719, '\p{isarabicmath}', "");
    Expect(0, 126719, '\p{^isarabicmath}', "");
    Expect(0, 126719, '\P{isarabicmath}', "");
    Expect(1, 126719, '\P{^isarabicmath}', "");
    Expect(0, 126720, '\p{isarabicmath}', "");
    Expect(1, 126720, '\p{^isarabicmath}', "");
    Expect(1, 126720, '\P{isarabicmath}', "");
    Expect(0, 126720, '\P{^isarabicmath}', "");
    Expect(1, 126719, '\p{Is_ARABIC_math}', "");
    Expect(0, 126719, '\p{^Is_ARABIC_math}', "");
    Expect(0, 126719, '\P{Is_ARABIC_math}', "");
    Expect(1, 126719, '\P{^Is_ARABIC_math}', "");
    Expect(0, 126720, '\p{Is_ARABIC_math}', "");
    Expect(1, 126720, '\p{^Is_ARABIC_math}', "");
    Expect(1, 126720, '\P{Is_ARABIC_math}', "");
    Expect(0, 126720, '\P{^Is_ARABIC_math}', "");
    Error('\p{:=In_Arabic_MATH}');
    Error('\P{:=In_Arabic_MATH}');
    Expect(1, 126719, '\p{inarabicmath}', "");
    Expect(0, 126719, '\p{^inarabicmath}', "");
    Expect(0, 126719, '\P{inarabicmath}', "");
    Expect(1, 126719, '\P{^inarabicmath}', "");
    Expect(0, 126720, '\p{inarabicmath}', "");
    Expect(1, 126720, '\p{^inarabicmath}', "");
    Expect(1, 126720, '\P{inarabicmath}', "");
    Expect(0, 126720, '\P{^inarabicmath}', "");
    Expect(1, 126719, '\p{ -IN_Arabic_Math}', "");
    Expect(0, 126719, '\p{^ -IN_Arabic_Math}', "");
    Expect(0, 126719, '\P{ -IN_Arabic_Math}', "");
    Expect(1, 126719, '\P{^ -IN_Arabic_Math}', "");
    Expect(0, 126720, '\p{ -IN_Arabic_Math}', "");
    Expect(1, 126720, '\p{^ -IN_Arabic_Math}', "");
    Expect(1, 126720, '\P{ -IN_Arabic_Math}', "");
    Expect(0, 126720, '\P{^ -IN_Arabic_Math}', "");
    Error('\p{_/a/arabic_presentation_forms_A}');
    Error('\P{_/a/arabic_presentation_forms_A}');
    Expect(1, 65023, '\p{arabicpresentationformsa}', "");
    Expect(0, 65023, '\p{^arabicpresentationformsa}', "");
    Expect(0, 65023, '\P{arabicpresentationformsa}', "");
    Expect(1, 65023, '\P{^arabicpresentationformsa}', "");
    Expect(0, 65024, '\p{arabicpresentationformsa}', "");
    Expect(1, 65024, '\p{^arabicpresentationformsa}', "");
    Expect(1, 65024, '\P{arabicpresentationformsa}', "");
    Expect(0, 65024, '\P{^arabicpresentationformsa}', "");
    Expect(1, 65023, '\p{-Arabic_Presentation_Forms_A}', "");
    Expect(0, 65023, '\p{^-Arabic_Presentation_Forms_A}', "");
    Expect(0, 65023, '\P{-Arabic_Presentation_Forms_A}', "");
    Expect(1, 65023, '\P{^-Arabic_Presentation_Forms_A}', "");
    Expect(0, 65024, '\p{-Arabic_Presentation_Forms_A}', "");
    Expect(1, 65024, '\p{^-Arabic_Presentation_Forms_A}', "");
    Expect(1, 65024, '\P{-Arabic_Presentation_Forms_A}', "");
    Expect(0, 65024, '\P{^-Arabic_Presentation_Forms_A}', "");
    Error('\p{/a/	Is_arabic_Presentation_forms_A}');
    Error('\P{/a/	Is_arabic_Presentation_forms_A}');
    Expect(1, 65023, '\p{isarabicpresentationformsa}', "");
    Expect(0, 65023, '\p{^isarabicpresentationformsa}', "");
    Expect(0, 65023, '\P{isarabicpresentationformsa}', "");
    Expect(1, 65023, '\P{^isarabicpresentationformsa}', "");
    Expect(0, 65024, '\p{isarabicpresentationformsa}', "");
    Expect(1, 65024, '\p{^isarabicpresentationformsa}', "");
    Expect(1, 65024, '\P{isarabicpresentationformsa}', "");
    Expect(0, 65024, '\P{^isarabicpresentationformsa}', "");
    Expect(1, 65023, '\p{--is_arabic_Presentation_FORMS_a}', "");
    Expect(0, 65023, '\p{^--is_arabic_Presentation_FORMS_a}', "");
    Expect(0, 65023, '\P{--is_arabic_Presentation_FORMS_a}', "");
    Expect(1, 65023, '\P{^--is_arabic_Presentation_FORMS_a}', "");
    Expect(0, 65024, '\p{--is_arabic_Presentation_FORMS_a}', "");
    Expect(1, 65024, '\p{^--is_arabic_Presentation_FORMS_a}', "");
    Expect(1, 65024, '\P{--is_arabic_Presentation_FORMS_a}', "");
    Expect(0, 65024, '\P{^--is_arabic_Presentation_FORMS_a}', "");
    Error('\p{:=  In_Arabic_presentation_forms_A}');
    Error('\P{:=  In_Arabic_presentation_forms_A}');
    Expect(1, 65023, '\p{inarabicpresentationformsa}', "");
    Expect(0, 65023, '\p{^inarabicpresentationformsa}', "");
    Expect(0, 65023, '\P{inarabicpresentationformsa}', "");
    Expect(1, 65023, '\P{^inarabicpresentationformsa}', "");
    Expect(0, 65024, '\p{inarabicpresentationformsa}', "");
    Expect(1, 65024, '\p{^inarabicpresentationformsa}', "");
    Expect(1, 65024, '\P{inarabicpresentationformsa}', "");
    Expect(0, 65024, '\P{^inarabicpresentationformsa}', "");
    Expect(1, 65023, '\p{_ IN_Arabic_Presentation_Forms_A}', "");
    Expect(0, 65023, '\p{^_ IN_Arabic_Presentation_Forms_A}', "");
    Expect(0, 65023, '\P{_ IN_Arabic_Presentation_Forms_A}', "");
    Expect(1, 65023, '\P{^_ IN_Arabic_Presentation_Forms_A}', "");
    Expect(0, 65024, '\p{_ IN_Arabic_Presentation_Forms_A}', "");
    Expect(1, 65024, '\p{^_ IN_Arabic_Presentation_Forms_A}', "");
    Expect(1, 65024, '\P{_ IN_Arabic_Presentation_Forms_A}', "");
    Expect(0, 65024, '\P{^_ IN_Arabic_Presentation_Forms_A}', "");
    Error('\p{	ARABIC_PF_A/a/}');
    Error('\P{	ARABIC_PF_A/a/}');
    Expect(1, 65023, '\p{arabicpfa}', "");
    Expect(0, 65023, '\p{^arabicpfa}', "");
    Expect(0, 65023, '\P{arabicpfa}', "");
    Expect(1, 65023, '\P{^arabicpfa}', "");
    Expect(0, 65024, '\p{arabicpfa}', "");
    Expect(1, 65024, '\p{^arabicpfa}', "");
    Expect(1, 65024, '\P{arabicpfa}', "");
    Expect(0, 65024, '\P{^arabicpfa}', "");
    Expect(1, 65023, '\p{-_Arabic_PF_A}', "");
    Expect(0, 65023, '\p{^-_Arabic_PF_A}', "");
    Expect(0, 65023, '\P{-_Arabic_PF_A}', "");
    Expect(1, 65023, '\P{^-_Arabic_PF_A}', "");
    Expect(0, 65024, '\p{-_Arabic_PF_A}', "");
    Expect(1, 65024, '\p{^-_Arabic_PF_A}', "");
    Expect(1, 65024, '\P{-_Arabic_PF_A}', "");
    Expect(0, 65024, '\P{^-_Arabic_PF_A}', "");
    Error('\p{:= -is_Arabic_PF_A}');
    Error('\P{:= -is_Arabic_PF_A}');
    Expect(1, 65023, '\p{isarabicpfa}', "");
    Expect(0, 65023, '\p{^isarabicpfa}', "");
    Expect(0, 65023, '\P{isarabicpfa}', "");
    Expect(1, 65023, '\P{^isarabicpfa}', "");
    Expect(0, 65024, '\p{isarabicpfa}', "");
    Expect(1, 65024, '\p{^isarabicpfa}', "");
    Expect(1, 65024, '\P{isarabicpfa}', "");
    Expect(0, 65024, '\P{^isarabicpfa}', "");
    Expect(1, 65023, '\p{_is_arabic_PF_A}', "");
    Expect(0, 65023, '\p{^_is_arabic_PF_A}', "");
    Expect(0, 65023, '\P{_is_arabic_PF_A}', "");
    Expect(1, 65023, '\P{^_is_arabic_PF_A}', "");
    Expect(0, 65024, '\p{_is_arabic_PF_A}', "");
    Expect(1, 65024, '\p{^_is_arabic_PF_A}', "");
    Expect(1, 65024, '\P{_is_arabic_PF_A}', "");
    Expect(0, 65024, '\P{^_is_arabic_PF_A}', "");
    Error('\p{_In_Arabic_PF_A:=}');
    Error('\P{_In_Arabic_PF_A:=}');
    Expect(1, 65023, '\p{inarabicpfa}', "");
    Expect(0, 65023, '\p{^inarabicpfa}', "");
    Expect(0, 65023, '\P{inarabicpfa}', "");
    Expect(1, 65023, '\P{^inarabicpfa}', "");
    Expect(0, 65024, '\p{inarabicpfa}', "");
    Expect(1, 65024, '\p{^inarabicpfa}', "");
    Expect(1, 65024, '\P{inarabicpfa}', "");
    Expect(0, 65024, '\P{^inarabicpfa}', "");
    Expect(1, 65023, '\p{  In_arabic_PF_A}', "");
    Expect(0, 65023, '\p{^  In_arabic_PF_A}', "");
    Expect(0, 65023, '\P{  In_arabic_PF_A}', "");
    Expect(1, 65023, '\P{^  In_arabic_PF_A}', "");
    Expect(0, 65024, '\p{  In_arabic_PF_A}', "");
    Expect(1, 65024, '\p{^  In_arabic_PF_A}', "");
    Expect(1, 65024, '\P{  In_arabic_PF_A}', "");
    Expect(0, 65024, '\P{^  In_arabic_PF_A}', "");
    Error('\p{_ARABIC_presentation_FORMS_B:=}');
    Error('\P{_ARABIC_presentation_FORMS_B:=}');
    Expect(1, 65279, '\p{arabicpresentationformsb}', "");
    Expect(0, 65279, '\p{^arabicpresentationformsb}', "");
    Expect(0, 65279, '\P{arabicpresentationformsb}', "");
    Expect(1, 65279, '\P{^arabicpresentationformsb}', "");
    Expect(0, 65280, '\p{arabicpresentationformsb}', "");
    Expect(1, 65280, '\p{^arabicpresentationformsb}', "");
    Expect(1, 65280, '\P{arabicpresentationformsb}', "");
    Expect(0, 65280, '\P{^arabicpresentationformsb}', "");
    Expect(1, 65279, '\p{ Arabic_Presentation_Forms_B}', "");
    Expect(0, 65279, '\p{^ Arabic_Presentation_Forms_B}', "");
    Expect(0, 65279, '\P{ Arabic_Presentation_Forms_B}', "");
    Expect(1, 65279, '\P{^ Arabic_Presentation_Forms_B}', "");
    Expect(0, 65280, '\p{ Arabic_Presentation_Forms_B}', "");
    Expect(1, 65280, '\p{^ Arabic_Presentation_Forms_B}', "");
    Expect(1, 65280, '\P{ Arabic_Presentation_Forms_B}', "");
    Expect(0, 65280, '\P{^ Arabic_Presentation_Forms_B}', "");
    Error('\p{_	IS_ARABIC_presentation_Forms_B:=}');
    Error('\P{_	IS_ARABIC_presentation_Forms_B:=}');
    Expect(1, 65279, '\p{isarabicpresentationformsb}', "");
    Expect(0, 65279, '\p{^isarabicpresentationformsb}', "");
    Expect(0, 65279, '\P{isarabicpresentationformsb}', "");
    Expect(1, 65279, '\P{^isarabicpresentationformsb}', "");
    Expect(0, 65280, '\p{isarabicpresentationformsb}', "");
    Expect(1, 65280, '\p{^isarabicpresentationformsb}', "");
    Expect(1, 65280, '\P{isarabicpresentationformsb}', "");
    Expect(0, 65280, '\P{^isarabicpresentationformsb}', "");
    Expect(1, 65279, '\p{ _Is_Arabic_PRESENTATION_forms_B}', "");
    Expect(0, 65279, '\p{^ _Is_Arabic_PRESENTATION_forms_B}', "");
    Expect(0, 65279, '\P{ _Is_Arabic_PRESENTATION_forms_B}', "");
    Expect(1, 65279, '\P{^ _Is_Arabic_PRESENTATION_forms_B}', "");
    Expect(0, 65280, '\p{ _Is_Arabic_PRESENTATION_forms_B}', "");
    Expect(1, 65280, '\p{^ _Is_Arabic_PRESENTATION_forms_B}', "");
    Expect(1, 65280, '\P{ _Is_Arabic_PRESENTATION_forms_B}', "");
    Expect(0, 65280, '\P{^ _Is_Arabic_PRESENTATION_forms_B}', "");
    Error('\p{:=	-IN_Arabic_Presentation_Forms_B}');
    Error('\P{:=	-IN_Arabic_Presentation_Forms_B}');
    Expect(1, 65279, '\p{inarabicpresentationformsb}', "");
    Expect(0, 65279, '\p{^inarabicpresentationformsb}', "");
    Expect(0, 65279, '\P{inarabicpresentationformsb}', "");
    Expect(1, 65279, '\P{^inarabicpresentationformsb}', "");
    Expect(0, 65280, '\p{inarabicpresentationformsb}', "");
    Expect(1, 65280, '\p{^inarabicpresentationformsb}', "");
    Expect(1, 65280, '\P{inarabicpresentationformsb}', "");
    Expect(0, 65280, '\P{^inarabicpresentationformsb}', "");
    Expect(1, 65279, '\p{_	In_arabic_Presentation_Forms_B}', "");
    Expect(0, 65279, '\p{^_	In_arabic_Presentation_Forms_B}', "");
    Expect(0, 65279, '\P{_	In_arabic_Presentation_Forms_B}', "");
    Expect(1, 65279, '\P{^_	In_arabic_Presentation_Forms_B}', "");
    Expect(0, 65280, '\p{_	In_arabic_Presentation_Forms_B}', "");
    Expect(1, 65280, '\p{^_	In_arabic_Presentation_Forms_B}', "");
    Expect(1, 65280, '\P{_	In_arabic_Presentation_Forms_B}', "");
    Expect(0, 65280, '\P{^_	In_arabic_Presentation_Forms_B}', "");
    Error('\p{:=		ARABIC_pf_B}');
    Error('\P{:=		ARABIC_pf_B}');
    Expect(1, 65279, '\p{arabicpfb}', "");
    Expect(0, 65279, '\p{^arabicpfb}', "");
    Expect(0, 65279, '\P{arabicpfb}', "");
    Expect(1, 65279, '\P{^arabicpfb}', "");
    Expect(0, 65280, '\p{arabicpfb}', "");
    Expect(1, 65280, '\p{^arabicpfb}', "");
    Expect(1, 65280, '\P{arabicpfb}', "");
    Expect(0, 65280, '\P{^arabicpfb}', "");
    Expect(1, 65279, '\p{_arabic_PF_B}', "");
    Expect(0, 65279, '\p{^_arabic_PF_B}', "");
    Expect(0, 65279, '\P{_arabic_PF_B}', "");
    Expect(1, 65279, '\P{^_arabic_PF_B}', "");
    Expect(0, 65280, '\p{_arabic_PF_B}', "");
    Expect(1, 65280, '\p{^_arabic_PF_B}', "");
    Expect(1, 65280, '\P{_arabic_PF_B}', "");
    Expect(0, 65280, '\P{^_arabic_PF_B}', "");
    Error('\p{/a/	_Is_Arabic_PF_B}');
    Error('\P{/a/	_Is_Arabic_PF_B}');
    Expect(1, 65279, '\p{isarabicpfb}', "");
    Expect(0, 65279, '\p{^isarabicpfb}', "");
    Expect(0, 65279, '\P{isarabicpfb}', "");
    Expect(1, 65279, '\P{^isarabicpfb}', "");
    Expect(0, 65280, '\p{isarabicpfb}', "");
    Expect(1, 65280, '\p{^isarabicpfb}', "");
    Expect(1, 65280, '\P{isarabicpfb}', "");
    Expect(0, 65280, '\P{^isarabicpfb}', "");
    Expect(1, 65279, '\p{-Is_arabic_PF_B}', "");
    Expect(0, 65279, '\p{^-Is_arabic_PF_B}', "");
    Expect(0, 65279, '\P{-Is_arabic_PF_B}', "");
    Expect(1, 65279, '\P{^-Is_arabic_PF_B}', "");
    Expect(0, 65280, '\p{-Is_arabic_PF_B}', "");
    Expect(1, 65280, '\p{^-Is_arabic_PF_B}', "");
    Expect(1, 65280, '\P{-Is_arabic_PF_B}', "");
    Expect(0, 65280, '\P{^-Is_arabic_PF_B}', "");
    Error('\p{	_In_arabic_PF_B/a/}');
    Error('\P{	_In_arabic_PF_B/a/}');
    Expect(1, 65279, '\p{inarabicpfb}', "");
    Expect(0, 65279, '\p{^inarabicpfb}', "");
    Expect(0, 65279, '\P{inarabicpfb}', "");
    Expect(1, 65279, '\P{^inarabicpfb}', "");
    Expect(0, 65280, '\p{inarabicpfb}', "");
    Expect(1, 65280, '\p{^inarabicpfb}', "");
    Expect(1, 65280, '\P{inarabicpfb}', "");
    Expect(0, 65280, '\P{^inarabicpfb}', "");
    Expect(1, 65279, '\p{ In_Arabic_PF_B}', "");
    Expect(0, 65279, '\p{^ In_Arabic_PF_B}', "");
    Expect(0, 65279, '\P{ In_Arabic_PF_B}', "");
    Expect(1, 65279, '\P{^ In_Arabic_PF_B}', "");
    Expect(0, 65280, '\p{ In_Arabic_PF_B}', "");
    Expect(1, 65280, '\p{^ In_Arabic_PF_B}', "");
    Expect(1, 65280, '\P{ In_Arabic_PF_B}', "");
    Expect(0, 65280, '\P{^ In_Arabic_PF_B}', "");
    Error('\p{	:=Arabic_supplement}');
    Error('\P{	:=Arabic_supplement}');
    Expect(1, 1919, '\p{arabicsupplement}', "");
    Expect(0, 1919, '\p{^arabicsupplement}', "");
    Expect(0, 1919, '\P{arabicsupplement}', "");
    Expect(1, 1919, '\P{^arabicsupplement}', "");
    Expect(0, 1920, '\p{arabicsupplement}', "");
    Expect(1, 1920, '\p{^arabicsupplement}', "");
    Expect(1, 1920, '\P{arabicsupplement}', "");
    Expect(0, 1920, '\P{^arabicsupplement}', "");
    Expect(1, 1919, '\p{-arabic_supplement}', "");
    Expect(0, 1919, '\p{^-arabic_supplement}', "");
    Expect(0, 1919, '\P{-arabic_supplement}', "");
    Expect(1, 1919, '\P{^-arabic_supplement}', "");
    Expect(0, 1920, '\p{-arabic_supplement}', "");
    Expect(1, 1920, '\p{^-arabic_supplement}', "");
    Expect(1, 1920, '\P{-arabic_supplement}', "");
    Expect(0, 1920, '\P{^-arabic_supplement}', "");
    Error('\p{:=-is_arabic_Supplement}');
    Error('\P{:=-is_arabic_Supplement}');
    Expect(1, 1919, '\p{isarabicsupplement}', "");
    Expect(0, 1919, '\p{^isarabicsupplement}', "");
    Expect(0, 1919, '\P{isarabicsupplement}', "");
    Expect(1, 1919, '\P{^isarabicsupplement}', "");
    Expect(0, 1920, '\p{isarabicsupplement}', "");
    Expect(1, 1920, '\p{^isarabicsupplement}', "");
    Expect(1, 1920, '\P{isarabicsupplement}', "");
    Expect(0, 1920, '\P{^isarabicsupplement}', "");
    Expect(1, 1919, '\p{ -Is_Arabic_Supplement}', "");
    Expect(0, 1919, '\p{^ -Is_Arabic_Supplement}', "");
    Expect(0, 1919, '\P{ -Is_Arabic_Supplement}', "");
    Expect(1, 1919, '\P{^ -Is_Arabic_Supplement}', "");
    Expect(0, 1920, '\p{ -Is_Arabic_Supplement}', "");
    Expect(1, 1920, '\p{^ -Is_Arabic_Supplement}', "");
    Expect(1, 1920, '\P{ -Is_Arabic_Supplement}', "");
    Expect(0, 1920, '\P{^ -Is_Arabic_Supplement}', "");
    Error('\p{/a/	In_Arabic_Supplement}');
    Error('\P{/a/	In_Arabic_Supplement}');
    Expect(1, 1919, '\p{inarabicsupplement}', "");
    Expect(0, 1919, '\p{^inarabicsupplement}', "");
    Expect(0, 1919, '\P{inarabicsupplement}', "");
    Expect(1, 1919, '\P{^inarabicsupplement}', "");
    Expect(0, 1920, '\p{inarabicsupplement}', "");
    Expect(1, 1920, '\p{^inarabicsupplement}', "");
    Expect(1, 1920, '\P{inarabicsupplement}', "");
    Expect(0, 1920, '\P{^inarabicsupplement}', "");
    Expect(1, 1919, '\p{_-In_Arabic_supplement}', "");
    Expect(0, 1919, '\p{^_-In_Arabic_supplement}', "");
    Expect(0, 1919, '\P{_-In_Arabic_supplement}', "");
    Expect(1, 1919, '\P{^_-In_Arabic_supplement}', "");
    Expect(0, 1920, '\p{_-In_Arabic_supplement}', "");
    Expect(1, 1920, '\p{^_-In_Arabic_supplement}', "");
    Expect(1, 1920, '\P{_-In_Arabic_supplement}', "");
    Expect(0, 1920, '\P{^_-In_Arabic_supplement}', "");
    Error('\p{ arabic_SUP/a/}');
    Error('\P{ arabic_SUP/a/}');
    Expect(1, 1919, '\p{arabicsup}', "");
    Expect(0, 1919, '\p{^arabicsup}', "");
    Expect(0, 1919, '\P{arabicsup}', "");
    Expect(1, 1919, '\P{^arabicsup}', "");
    Expect(0, 1920, '\p{arabicsup}', "");
    Expect(1, 1920, '\p{^arabicsup}', "");
    Expect(1, 1920, '\P{arabicsup}', "");
    Expect(0, 1920, '\P{^arabicsup}', "");
    Expect(1, 1919, '\p{-Arabic_Sup}', "");
    Expect(0, 1919, '\p{^-Arabic_Sup}', "");
    Expect(0, 1919, '\P{-Arabic_Sup}', "");
    Expect(1, 1919, '\P{^-Arabic_Sup}', "");
    Expect(0, 1920, '\p{-Arabic_Sup}', "");
    Expect(1, 1920, '\p{^-Arabic_Sup}', "");
    Expect(1, 1920, '\P{-Arabic_Sup}', "");
    Expect(0, 1920, '\P{^-Arabic_Sup}', "");
    Error('\p{-/a/is_arabic_SUP}');
    Error('\P{-/a/is_arabic_SUP}');
    Expect(1, 1919, '\p{isarabicsup}', "");
    Expect(0, 1919, '\p{^isarabicsup}', "");
    Expect(0, 1919, '\P{isarabicsup}', "");
    Expect(1, 1919, '\P{^isarabicsup}', "");
    Expect(0, 1920, '\p{isarabicsup}', "");
    Expect(1, 1920, '\p{^isarabicsup}', "");
    Expect(1, 1920, '\P{isarabicsup}', "");
    Expect(0, 1920, '\P{^isarabicsup}', "");
    Expect(1, 1919, '\p{_IS_Arabic_SUP}', "");
    Expect(0, 1919, '\p{^_IS_Arabic_SUP}', "");
    Expect(0, 1919, '\P{_IS_Arabic_SUP}', "");
    Expect(1, 1919, '\P{^_IS_Arabic_SUP}', "");
    Expect(0, 1920, '\p{_IS_Arabic_SUP}', "");
    Expect(1, 1920, '\p{^_IS_Arabic_SUP}', "");
    Expect(1, 1920, '\P{_IS_Arabic_SUP}', "");
    Expect(0, 1920, '\P{^_IS_Arabic_SUP}', "");
    Error('\p{:=in_ARABIC_SUP}');
    Error('\P{:=in_ARABIC_SUP}');
    Expect(1, 1919, '\p{inarabicsup}', "");
    Expect(0, 1919, '\p{^inarabicsup}', "");
    Expect(0, 1919, '\P{inarabicsup}', "");
    Expect(1, 1919, '\P{^inarabicsup}', "");
    Expect(0, 1920, '\p{inarabicsup}', "");
    Expect(1, 1920, '\p{^inarabicsup}', "");
    Expect(1, 1920, '\P{inarabicsup}', "");
    Expect(0, 1920, '\P{^inarabicsup}', "");
    Expect(1, 1919, '\p{_ In_arabic_Sup}', "");
    Expect(0, 1919, '\p{^_ In_arabic_Sup}', "");
    Expect(0, 1919, '\P{_ In_arabic_Sup}', "");
    Expect(1, 1919, '\P{^_ In_arabic_Sup}', "");
    Expect(0, 1920, '\p{_ In_arabic_Sup}', "");
    Expect(1, 1920, '\p{^_ In_arabic_Sup}', "");
    Expect(1, 1920, '\P{_ In_arabic_Sup}', "");
    Expect(0, 1920, '\P{^_ In_arabic_Sup}', "");
    Error('\p{_/a/armenian}');
    Error('\P{_/a/armenian}');
    Expect(1, 64279, '\p{armenian}', "");
    Expect(0, 64279, '\p{^armenian}', "");
    Expect(0, 64279, '\P{armenian}', "");
    Expect(1, 64279, '\P{^armenian}', "");
    Expect(0, 64280, '\p{armenian}', "");
    Expect(1, 64280, '\p{^armenian}', "");
    Expect(1, 64280, '\P{armenian}', "");
    Expect(0, 64280, '\P{^armenian}', "");
    Expect(1, 64279, '\p{_Armenian}', "");
    Expect(0, 64279, '\p{^_Armenian}', "");
    Expect(0, 64279, '\P{_Armenian}', "");
    Expect(1, 64279, '\P{^_Armenian}', "");
    Expect(0, 64280, '\p{_Armenian}', "");
    Expect(1, 64280, '\p{^_Armenian}', "");
    Expect(1, 64280, '\P{_Armenian}', "");
    Expect(0, 64280, '\P{^_Armenian}', "");
    Error('\p{_ is_ARMENIAN:=}');
    Error('\P{_ is_ARMENIAN:=}');
    Expect(1, 64279, '\p{isarmenian}', "");
    Expect(0, 64279, '\p{^isarmenian}', "");
    Expect(0, 64279, '\P{isarmenian}', "");
    Expect(1, 64279, '\P{^isarmenian}', "");
    Expect(0, 64280, '\p{isarmenian}', "");
    Expect(1, 64280, '\p{^isarmenian}', "");
    Expect(1, 64280, '\P{isarmenian}', "");
    Expect(0, 64280, '\P{^isarmenian}', "");
    Expect(1, 64279, '\p{  Is_ARMENIAN}', "");
    Expect(0, 64279, '\p{^  Is_ARMENIAN}', "");
    Expect(0, 64279, '\P{  Is_ARMENIAN}', "");
    Expect(1, 64279, '\P{^  Is_ARMENIAN}', "");
    Expect(0, 64280, '\p{  Is_ARMENIAN}', "");
    Expect(1, 64280, '\p{^  Is_ARMENIAN}', "");
    Expect(1, 64280, '\P{  Is_ARMENIAN}', "");
    Expect(0, 64280, '\P{^  Is_ARMENIAN}', "");
    Error('\p{/a/Armn}');
    Error('\P{/a/Armn}');
    Expect(1, 64279, '\p{armn}', "");
    Expect(0, 64279, '\p{^armn}', "");
    Expect(0, 64279, '\P{armn}', "");
    Expect(1, 64279, '\P{^armn}', "");
    Expect(0, 64280, '\p{armn}', "");
    Expect(1, 64280, '\p{^armn}', "");
    Expect(1, 64280, '\P{armn}', "");
    Expect(0, 64280, '\P{^armn}', "");
    Expect(1, 64279, '\p{ armn}', "");
    Expect(0, 64279, '\p{^ armn}', "");
    Expect(0, 64279, '\P{ armn}', "");
    Expect(1, 64279, '\P{^ armn}', "");
    Expect(0, 64280, '\p{ armn}', "");
    Expect(1, 64280, '\p{^ armn}', "");
    Expect(1, 64280, '\P{ armn}', "");
    Expect(0, 64280, '\P{^ armn}', "");
    Error('\p{:= 	is_Armn}');
    Error('\P{:= 	is_Armn}');
    Expect(1, 64279, '\p{isarmn}', "");
    Expect(0, 64279, '\p{^isarmn}', "");
    Expect(0, 64279, '\P{isarmn}', "");
    Expect(1, 64279, '\P{^isarmn}', "");
    Expect(0, 64280, '\p{isarmn}', "");
    Expect(1, 64280, '\p{^isarmn}', "");
    Expect(1, 64280, '\P{isarmn}', "");
    Expect(0, 64280, '\P{^isarmn}', "");
    Expect(1, 64279, '\p{-	IS_Armn}', "");
    Expect(0, 64279, '\p{^-	IS_Armn}', "");
    Expect(0, 64279, '\P{-	IS_Armn}', "");
    Expect(1, 64279, '\P{^-	IS_Armn}', "");
    Expect(0, 64280, '\p{-	IS_Armn}', "");
    Expect(1, 64280, '\p{^-	IS_Armn}', "");
    Expect(1, 64280, '\P{-	IS_Armn}', "");
    Expect(0, 64280, '\P{^-	IS_Armn}', "");
    Error('\p{/a/-	Arrows}');
    Error('\P{/a/-	Arrows}');
    Expect(1, 8703, '\p{arrows}', "");
    Expect(0, 8703, '\p{^arrows}', "");
    Expect(0, 8703, '\P{arrows}', "");
    Expect(1, 8703, '\P{^arrows}', "");
    Expect(0, 8704, '\p{arrows}', "");
    Expect(1, 8704, '\p{^arrows}', "");
    Expect(1, 8704, '\P{arrows}', "");
    Expect(0, 8704, '\P{^arrows}', "");
    Expect(1, 8703, '\p{ Arrows}', "");
    Expect(0, 8703, '\p{^ Arrows}', "");
    Expect(0, 8703, '\P{ Arrows}', "");
    Expect(1, 8703, '\P{^ Arrows}', "");
    Expect(0, 8704, '\p{ Arrows}', "");
    Expect(1, 8704, '\p{^ Arrows}', "");
    Expect(1, 8704, '\P{ Arrows}', "");
    Expect(0, 8704, '\P{^ Arrows}', "");
    Error('\p{_IS_Arrows:=}');
    Error('\P{_IS_Arrows:=}');
    Expect(1, 8703, '\p{isarrows}', "");
    Expect(0, 8703, '\p{^isarrows}', "");
    Expect(0, 8703, '\P{isarrows}', "");
    Expect(1, 8703, '\P{^isarrows}', "");
    Expect(0, 8704, '\p{isarrows}', "");
    Expect(1, 8704, '\p{^isarrows}', "");
    Expect(1, 8704, '\P{isarrows}', "");
    Expect(0, 8704, '\P{^isarrows}', "");
    Expect(1, 8703, '\p{		Is_ARROWS}', "");
    Expect(0, 8703, '\p{^		Is_ARROWS}', "");
    Expect(0, 8703, '\P{		Is_ARROWS}', "");
    Expect(1, 8703, '\P{^		Is_ARROWS}', "");
    Expect(0, 8704, '\p{		Is_ARROWS}', "");
    Expect(1, 8704, '\p{^		Is_ARROWS}', "");
    Expect(1, 8704, '\P{		Is_ARROWS}', "");
    Expect(0, 8704, '\P{^		Is_ARROWS}', "");
    Error('\p{/a/  IN_Arrows}');
    Error('\P{/a/  IN_Arrows}');
    Expect(1, 8703, '\p{inarrows}', "");
    Expect(0, 8703, '\p{^inarrows}', "");
    Expect(0, 8703, '\P{inarrows}', "");
    Expect(1, 8703, '\P{^inarrows}', "");
    Expect(0, 8704, '\p{inarrows}', "");
    Expect(1, 8704, '\p{^inarrows}', "");
    Expect(1, 8704, '\P{inarrows}', "");
    Expect(0, 8704, '\P{^inarrows}', "");
    Expect(1, 8703, '\p{-In_Arrows}', "");
    Expect(0, 8703, '\p{^-In_Arrows}', "");
    Expect(0, 8703, '\P{-In_Arrows}', "");
    Expect(1, 8703, '\P{^-In_Arrows}', "");
    Expect(0, 8704, '\p{-In_Arrows}', "");
    Expect(1, 8704, '\p{^-In_Arrows}', "");
    Expect(1, 8704, '\P{-In_Arrows}', "");
    Expect(0, 8704, '\P{^-In_Arrows}', "");
    Error('\p{	-ascii:=}');
    Error('\P{	-ascii:=}');
    Expect(1, 127, '\p{ascii}', "");
    Expect(0, 127, '\p{^ascii}', "");
    Expect(0, 127, '\P{ascii}', "");
    Expect(1, 127, '\P{^ascii}', "");
    Expect(0, 128, '\p{ascii}', "");
    Expect(1, 128, '\p{^ascii}', "");
    Expect(1, 128, '\P{ascii}', "");
    Expect(0, 128, '\P{^ascii}', "");
    Expect(1, 127, '\p{_ ASCII}', "");
    Expect(0, 127, '\p{^_ ASCII}', "");
    Expect(0, 127, '\P{_ ASCII}', "");
    Expect(1, 127, '\P{^_ ASCII}', "");
    Expect(0, 128, '\p{_ ASCII}', "");
    Expect(1, 128, '\p{^_ ASCII}', "");
    Expect(1, 128, '\P{_ ASCII}', "");
    Expect(0, 128, '\P{^_ ASCII}', "");
    Error('\p{:=_Is_ASCII}');
    Error('\P{:=_Is_ASCII}');
    Expect(1, 127, '\p{isascii}', "");
    Expect(0, 127, '\p{^isascii}', "");
    Expect(0, 127, '\P{isascii}', "");
    Expect(1, 127, '\P{^isascii}', "");
    Expect(0, 128, '\p{isascii}', "");
    Expect(1, 128, '\p{^isascii}', "");
    Expect(1, 128, '\P{isascii}', "");
    Expect(0, 128, '\P{^isascii}', "");
    Expect(1, 127, '\p{	_IS_ASCII}', "");
    Expect(0, 127, '\p{^	_IS_ASCII}', "");
    Expect(0, 127, '\P{	_IS_ASCII}', "");
    Expect(1, 127, '\P{^	_IS_ASCII}', "");
    Expect(0, 128, '\p{	_IS_ASCII}', "");
    Expect(1, 128, '\p{^	_IS_ASCII}', "");
    Expect(1, 128, '\P{	_IS_ASCII}', "");
    Expect(0, 128, '\P{^	_IS_ASCII}', "");
    Error('\p{:=	Basic_Latin}');
    Error('\P{:=	Basic_Latin}');
    Expect(1, 127, '\p{basiclatin}', "");
    Expect(0, 127, '\p{^basiclatin}', "");
    Expect(0, 127, '\P{basiclatin}', "");
    Expect(1, 127, '\P{^basiclatin}', "");
    Expect(0, 128, '\p{basiclatin}', "");
    Expect(1, 128, '\p{^basiclatin}', "");
    Expect(1, 128, '\P{basiclatin}', "");
    Expect(0, 128, '\P{^basiclatin}', "");
    Expect(1, 127, '\p{_-Basic_Latin}', "");
    Expect(0, 127, '\p{^_-Basic_Latin}', "");
    Expect(0, 127, '\P{_-Basic_Latin}', "");
    Expect(1, 127, '\P{^_-Basic_Latin}', "");
    Expect(0, 128, '\p{_-Basic_Latin}', "");
    Expect(1, 128, '\p{^_-Basic_Latin}', "");
    Expect(1, 128, '\P{_-Basic_Latin}', "");
    Expect(0, 128, '\P{^_-Basic_Latin}', "");
    Error('\p{-Is_BASIC_latin:=}');
    Error('\P{-Is_BASIC_latin:=}');
    Expect(1, 127, '\p{isbasiclatin}', "");
    Expect(0, 127, '\p{^isbasiclatin}', "");
    Expect(0, 127, '\P{isbasiclatin}', "");
    Expect(1, 127, '\P{^isbasiclatin}', "");
    Expect(0, 128, '\p{isbasiclatin}', "");
    Expect(1, 128, '\p{^isbasiclatin}', "");
    Expect(1, 128, '\P{isbasiclatin}', "");
    Expect(0, 128, '\P{^isbasiclatin}', "");
    Expect(1, 127, '\p{		Is_BASIC_latin}', "");
    Expect(0, 127, '\p{^		Is_BASIC_latin}', "");
    Expect(0, 127, '\P{		Is_BASIC_latin}', "");
    Expect(1, 127, '\P{^		Is_BASIC_latin}', "");
    Expect(0, 128, '\p{		Is_BASIC_latin}', "");
    Expect(1, 128, '\p{^		Is_BASIC_latin}', "");
    Expect(1, 128, '\P{		Is_BASIC_latin}', "");
    Expect(0, 128, '\P{^		Is_BASIC_latin}', "");
    Error('\p{:=_ In_Basic_latin}');
    Error('\P{:=_ In_Basic_latin}');
    Expect(1, 127, '\p{inbasiclatin}', "");
    Expect(0, 127, '\p{^inbasiclatin}', "");
    Expect(0, 127, '\P{inbasiclatin}', "");
    Expect(1, 127, '\P{^inbasiclatin}', "");
    Expect(0, 128, '\p{inbasiclatin}', "");
    Expect(1, 128, '\p{^inbasiclatin}', "");
    Expect(1, 128, '\P{inbasiclatin}', "");
    Expect(0, 128, '\P{^inbasiclatin}', "");
    Expect(1, 127, '\p{	in_Basic_Latin}', "");
    Expect(0, 127, '\p{^	in_Basic_Latin}', "");
    Expect(0, 127, '\P{	in_Basic_Latin}', "");
    Expect(1, 127, '\P{^	in_Basic_Latin}', "");
    Expect(0, 128, '\p{	in_Basic_Latin}', "");
    Expect(1, 128, '\p{^	in_Basic_Latin}', "");
    Expect(1, 128, '\P{	in_Basic_Latin}', "");
    Expect(0, 128, '\P{^	in_Basic_Latin}', "");
    Error('\p{ :=In_ascii}');
    Error('\P{ :=In_ascii}');
    Expect(1, 127, '\p{inascii}', "");
    Expect(0, 127, '\p{^inascii}', "");
    Expect(0, 127, '\P{inascii}', "");
    Expect(1, 127, '\P{^inascii}', "");
    Expect(0, 128, '\p{inascii}', "");
    Expect(1, 128, '\p{^inascii}', "");
    Expect(1, 128, '\P{inascii}', "");
    Expect(0, 128, '\P{^inascii}', "");
    Expect(1, 127, '\p{_ In_ASCII}', "");
    Expect(0, 127, '\p{^_ In_ASCII}', "");
    Expect(0, 127, '\P{_ In_ASCII}', "");
    Expect(1, 127, '\P{^_ In_ASCII}', "");
    Expect(0, 128, '\p{_ In_ASCII}', "");
    Expect(1, 128, '\p{^_ In_ASCII}', "");
    Expect(1, 128, '\P{_ In_ASCII}', "");
    Expect(0, 128, '\P{^_ In_ASCII}', "");
    Error('\p{:=Assigned}');
    Error('\P{:=Assigned}');
    Expect(1, 1114109, '\p{assigned}', "");
    Expect(0, 1114109, '\p{^assigned}', "");
    Expect(0, 1114109, '\P{assigned}', "");
    Expect(1, 1114109, '\P{^assigned}', "");
    Expect(0, 918000, '\p{assigned}', "");
    Expect(1, 918000, '\p{^assigned}', "");
    Expect(1, 918000, '\P{assigned}', "");
    Expect(0, 918000, '\P{^assigned}', "");
    Expect(1, 1114109, '\p{--Assigned}', "");
    Expect(0, 1114109, '\p{^--Assigned}', "");
    Expect(0, 1114109, '\P{--Assigned}', "");
    Expect(1, 1114109, '\P{^--Assigned}', "");
    Expect(0, 918000, '\p{--Assigned}', "");
    Expect(1, 918000, '\p{^--Assigned}', "");
    Expect(1, 918000, '\P{--Assigned}', "");
    Expect(0, 918000, '\P{^--Assigned}', "");
    Error('\p{/a/Is_ASSIGNED}');
    Error('\P{/a/Is_ASSIGNED}');
    Expect(1, 1114109, '\p{isassigned}', "");
    Expect(0, 1114109, '\p{^isassigned}', "");
    Expect(0, 1114109, '\P{isassigned}', "");
    Expect(1, 1114109, '\P{^isassigned}', "");
    Expect(0, 918000, '\p{isassigned}', "");
    Expect(1, 918000, '\p{^isassigned}', "");
    Expect(1, 918000, '\P{isassigned}', "");
    Expect(0, 918000, '\P{^isassigned}', "");
    Expect(1, 1114109, '\p{_Is_Assigned}', "");
    Expect(0, 1114109, '\p{^_Is_Assigned}', "");
    Expect(0, 1114109, '\P{_Is_Assigned}', "");
    Expect(1, 1114109, '\P{^_Is_Assigned}', "");
    Expect(0, 918000, '\p{_Is_Assigned}', "");
    Expect(1, 918000, '\p{^_Is_Assigned}', "");
    Expect(1, 918000, '\P{_Is_Assigned}', "");
    Expect(0, 918000, '\P{^_Is_Assigned}', "");
    Error('\p{ Avestan/a/}');
    Error('\P{ Avestan/a/}');
    Expect(1, 68415, '\p{avestan}', "");
    Expect(0, 68415, '\p{^avestan}', "");
    Expect(0, 68415, '\P{avestan}', "");
    Expect(1, 68415, '\P{^avestan}', "");
    Expect(0, 68416, '\p{avestan}', "");
    Expect(1, 68416, '\p{^avestan}', "");
    Expect(1, 68416, '\P{avestan}', "");
    Expect(0, 68416, '\P{^avestan}', "");
    Expect(1, 68415, '\p{- AVESTAN}', "");
    Expect(0, 68415, '\p{^- AVESTAN}', "");
    Expect(0, 68415, '\P{- AVESTAN}', "");
    Expect(1, 68415, '\P{^- AVESTAN}', "");
    Expect(0, 68416, '\p{- AVESTAN}', "");
    Expect(1, 68416, '\p{^- AVESTAN}', "");
    Expect(1, 68416, '\P{- AVESTAN}', "");
    Expect(0, 68416, '\P{^- AVESTAN}', "");
    Error('\p{_/a/is_Avestan}');
    Error('\P{_/a/is_Avestan}');
    Expect(1, 68415, '\p{isavestan}', "");
    Expect(0, 68415, '\p{^isavestan}', "");
    Expect(0, 68415, '\P{isavestan}', "");
    Expect(1, 68415, '\P{^isavestan}', "");
    Expect(0, 68416, '\p{isavestan}', "");
    Expect(1, 68416, '\p{^isavestan}', "");
    Expect(1, 68416, '\P{isavestan}', "");
    Expect(0, 68416, '\P{^isavestan}', "");
    Expect(1, 68415, '\p{_-Is_Avestan}', "");
    Expect(0, 68415, '\p{^_-Is_Avestan}', "");
    Expect(0, 68415, '\P{_-Is_Avestan}', "");
    Expect(1, 68415, '\P{^_-Is_Avestan}', "");
    Expect(0, 68416, '\p{_-Is_Avestan}', "");
    Expect(1, 68416, '\p{^_-Is_Avestan}', "");
    Expect(1, 68416, '\P{_-Is_Avestan}', "");
    Expect(0, 68416, '\P{^_-Is_Avestan}', "");
    Error('\p{/a/-Avst}');
    Error('\P{/a/-Avst}');
    Expect(1, 68415, '\p{avst}', "");
    Expect(0, 68415, '\p{^avst}', "");
    Expect(0, 68415, '\P{avst}', "");
    Expect(1, 68415, '\P{^avst}', "");
    Expect(0, 68416, '\p{avst}', "");
    Expect(1, 68416, '\p{^avst}', "");
    Expect(1, 68416, '\P{avst}', "");
    Expect(0, 68416, '\P{^avst}', "");
    Expect(1, 68415, '\p{	avst}', "");
    Expect(0, 68415, '\p{^	avst}', "");
    Expect(0, 68415, '\P{	avst}', "");
    Expect(1, 68415, '\P{^	avst}', "");
    Expect(0, 68416, '\p{	avst}', "");
    Expect(1, 68416, '\p{^	avst}', "");
    Expect(1, 68416, '\P{	avst}', "");
    Expect(0, 68416, '\P{^	avst}', "");
    Error('\p{ 	IS_Avst/a/}');
    Error('\P{ 	IS_Avst/a/}');
    Expect(1, 68415, '\p{isavst}', "");
    Expect(0, 68415, '\p{^isavst}', "");
    Expect(0, 68415, '\P{isavst}', "");
    Expect(1, 68415, '\P{^isavst}', "");
    Expect(0, 68416, '\p{isavst}', "");
    Expect(1, 68416, '\p{^isavst}', "");
    Expect(1, 68416, '\P{isavst}', "");
    Expect(0, 68416, '\P{^isavst}', "");
    Expect(1, 68415, '\p{_is_avst}', "");
    Expect(0, 68415, '\p{^_is_avst}', "");
    Expect(0, 68415, '\P{_is_avst}', "");
    Expect(1, 68415, '\P{^_is_avst}', "");
    Expect(0, 68416, '\p{_is_avst}', "");
    Expect(1, 68416, '\p{^_is_avst}', "");
    Expect(1, 68416, '\P{_is_avst}', "");
    Expect(0, 68416, '\P{^_is_avst}', "");
    Error('\p{/a/_	Balinese}');
    Error('\P{/a/_	Balinese}');
    Expect(1, 7036, '\p{balinese}', "");
    Expect(0, 7036, '\p{^balinese}', "");
    Expect(0, 7036, '\P{balinese}', "");
    Expect(1, 7036, '\P{^balinese}', "");
    Expect(0, 7037, '\p{balinese}', "");
    Expect(1, 7037, '\p{^balinese}', "");
    Expect(1, 7037, '\P{balinese}', "");
    Expect(0, 7037, '\P{^balinese}', "");
    Expect(1, 7036, '\p{_ BALINESE}', "");
    Expect(0, 7036, '\p{^_ BALINESE}', "");
    Expect(0, 7036, '\P{_ BALINESE}', "");
    Expect(1, 7036, '\P{^_ BALINESE}', "");
    Expect(0, 7037, '\p{_ BALINESE}', "");
    Expect(1, 7037, '\p{^_ BALINESE}', "");
    Expect(1, 7037, '\P{_ BALINESE}', "");
    Expect(0, 7037, '\P{^_ BALINESE}', "");
    Error('\p{:=	 Is_balinese}');
    Error('\P{:=	 Is_balinese}');
    Expect(1, 7036, '\p{isbalinese}', "");
    Expect(0, 7036, '\p{^isbalinese}', "");
    Expect(0, 7036, '\P{isbalinese}', "");
    Expect(1, 7036, '\P{^isbalinese}', "");
    Expect(0, 7037, '\p{isbalinese}', "");
    Expect(1, 7037, '\p{^isbalinese}', "");
    Expect(1, 7037, '\P{isbalinese}', "");
    Expect(0, 7037, '\P{^isbalinese}', "");
    Expect(1, 7036, '\p{_-Is_Balinese}', "");
    Expect(0, 7036, '\p{^_-Is_Balinese}', "");
    Expect(0, 7036, '\P{_-Is_Balinese}', "");
    Expect(1, 7036, '\P{^_-Is_Balinese}', "");
    Expect(0, 7037, '\p{_-Is_Balinese}', "");
    Expect(1, 7037, '\p{^_-Is_Balinese}', "");
    Expect(1, 7037, '\P{_-Is_Balinese}', "");
    Expect(0, 7037, '\P{^_-Is_Balinese}', "");
    Error('\p{:= bali}');
    Error('\P{:= bali}');
    Expect(1, 7036, '\p{bali}', "");
    Expect(0, 7036, '\p{^bali}', "");
    Expect(0, 7036, '\P{bali}', "");
    Expect(1, 7036, '\P{^bali}', "");
    Expect(0, 7037, '\p{bali}', "");
    Expect(1, 7037, '\p{^bali}', "");
    Expect(1, 7037, '\P{bali}', "");
    Expect(0, 7037, '\P{^bali}', "");
    Expect(1, 7036, '\p{	_Bali}', "");
    Expect(0, 7036, '\p{^	_Bali}', "");
    Expect(0, 7036, '\P{	_Bali}', "");
    Expect(1, 7036, '\P{^	_Bali}', "");
    Expect(0, 7037, '\p{	_Bali}', "");
    Expect(1, 7037, '\p{^	_Bali}', "");
    Expect(1, 7037, '\P{	_Bali}', "");
    Expect(0, 7037, '\P{^	_Bali}', "");
    Error('\p{/a/is_Bali}');
    Error('\P{/a/is_Bali}');
    Expect(1, 7036, '\p{isbali}', "");
    Expect(0, 7036, '\p{^isbali}', "");
    Expect(0, 7036, '\P{isbali}', "");
    Expect(1, 7036, '\P{^isbali}', "");
    Expect(0, 7037, '\p{isbali}', "");
    Expect(1, 7037, '\p{^isbali}', "");
    Expect(1, 7037, '\P{isbali}', "");
    Expect(0, 7037, '\P{^isbali}', "");
    Expect(1, 7036, '\p{ IS_Bali}', "");
    Expect(0, 7036, '\p{^ IS_Bali}', "");
    Expect(0, 7036, '\P{ IS_Bali}', "");
    Expect(1, 7036, '\P{^ IS_Bali}', "");
    Expect(0, 7037, '\p{ IS_Bali}', "");
    Expect(1, 7037, '\p{^ IS_Bali}', "");
    Expect(1, 7037, '\P{ IS_Bali}', "");
    Expect(0, 7037, '\P{^ IS_Bali}', "");
    Error('\p{	/a/Bamum}');
    Error('\P{	/a/Bamum}');
    Expect(1, 92728, '\p{bamum}', "");
    Expect(0, 92728, '\p{^bamum}', "");
    Expect(0, 92728, '\P{bamum}', "");
    Expect(1, 92728, '\P{^bamum}', "");
    Expect(0, 92729, '\p{bamum}', "");
    Expect(1, 92729, '\p{^bamum}', "");
    Expect(1, 92729, '\P{bamum}', "");
    Expect(0, 92729, '\P{^bamum}', "");
    Expect(1, 92728, '\p{_	BAMUM}', "");
    Expect(0, 92728, '\p{^_	BAMUM}', "");
    Expect(0, 92728, '\P{_	BAMUM}', "");
    Expect(1, 92728, '\P{^_	BAMUM}', "");
    Expect(0, 92729, '\p{_	BAMUM}', "");
    Expect(1, 92729, '\p{^_	BAMUM}', "");
    Expect(1, 92729, '\P{_	BAMUM}', "");
    Expect(0, 92729, '\P{^_	BAMUM}', "");
    Error('\p{-:=is_Bamum}');
    Error('\P{-:=is_Bamum}');
    Expect(1, 92728, '\p{isbamum}', "");
    Expect(0, 92728, '\p{^isbamum}', "");
    Expect(0, 92728, '\P{isbamum}', "");
    Expect(1, 92728, '\P{^isbamum}', "");
    Expect(0, 92729, '\p{isbamum}', "");
    Expect(1, 92729, '\p{^isbamum}', "");
    Expect(1, 92729, '\P{isbamum}', "");
    Expect(0, 92729, '\P{^isbamum}', "");
    Expect(1, 92728, '\p{	 Is_BAMUM}', "");
    Expect(0, 92728, '\p{^	 Is_BAMUM}', "");
    Expect(0, 92728, '\P{	 Is_BAMUM}', "");
    Expect(1, 92728, '\P{^	 Is_BAMUM}', "");
    Expect(0, 92729, '\p{	 Is_BAMUM}', "");
    Expect(1, 92729, '\p{^	 Is_BAMUM}', "");
    Expect(1, 92729, '\P{	 Is_BAMUM}', "");
    Expect(0, 92729, '\P{^	 Is_BAMUM}', "");
    Error('\p{ /a/Bamu}');
    Error('\P{ /a/Bamu}');
    Expect(1, 92728, '\p{bamu}', "");
    Expect(0, 92728, '\p{^bamu}', "");
    Expect(0, 92728, '\P{bamu}', "");
    Expect(1, 92728, '\P{^bamu}', "");
    Expect(0, 92729, '\p{bamu}', "");
    Expect(1, 92729, '\p{^bamu}', "");
    Expect(1, 92729, '\P{bamu}', "");
    Expect(0, 92729, '\P{^bamu}', "");
    Expect(1, 92728, '\p{	BAMU}', "");
    Expect(0, 92728, '\p{^	BAMU}', "");
    Expect(0, 92728, '\P{	BAMU}', "");
    Expect(1, 92728, '\P{^	BAMU}', "");
    Expect(0, 92729, '\p{	BAMU}', "");
    Expect(1, 92729, '\p{^	BAMU}', "");
    Expect(1, 92729, '\P{	BAMU}', "");
    Expect(0, 92729, '\P{^	BAMU}', "");
    Error('\p{_-is_Bamu/a/}');
    Error('\P{_-is_Bamu/a/}');
    Expect(1, 92728, '\p{isbamu}', "");
    Expect(0, 92728, '\p{^isbamu}', "");
    Expect(0, 92728, '\P{isbamu}', "");
    Expect(1, 92728, '\P{^isbamu}', "");
    Expect(0, 92729, '\p{isbamu}', "");
    Expect(1, 92729, '\p{^isbamu}', "");
    Expect(1, 92729, '\P{isbamu}', "");
    Expect(0, 92729, '\P{^isbamu}', "");
    Expect(1, 92728, '\p{_	Is_Bamu}', "");
    Expect(0, 92728, '\p{^_	Is_Bamu}', "");
    Expect(0, 92728, '\P{_	Is_Bamu}', "");
    Expect(1, 92728, '\P{^_	Is_Bamu}', "");
    Expect(0, 92729, '\p{_	Is_Bamu}', "");
    Expect(1, 92729, '\p{^_	Is_Bamu}', "");
    Expect(1, 92729, '\P{_	Is_Bamu}', "");
    Expect(0, 92729, '\P{^_	Is_Bamu}', "");
    Error('\p{	_BAMUM_supplement/a/}');
    Error('\P{	_BAMUM_supplement/a/}');
    Expect(1, 92735, '\p{bamumsupplement}', "");
    Expect(0, 92735, '\p{^bamumsupplement}', "");
    Expect(0, 92735, '\P{bamumsupplement}', "");
    Expect(1, 92735, '\P{^bamumsupplement}', "");
    Expect(0, 92736, '\p{bamumsupplement}', "");
    Expect(1, 92736, '\p{^bamumsupplement}', "");
    Expect(1, 92736, '\P{bamumsupplement}', "");
    Expect(0, 92736, '\P{^bamumsupplement}', "");
    Expect(1, 92735, '\p{-bamum_supplement}', "");
    Expect(0, 92735, '\p{^-bamum_supplement}', "");
    Expect(0, 92735, '\P{-bamum_supplement}', "");
    Expect(1, 92735, '\P{^-bamum_supplement}', "");
    Expect(0, 92736, '\p{-bamum_supplement}', "");
    Expect(1, 92736, '\p{^-bamum_supplement}', "");
    Expect(1, 92736, '\P{-bamum_supplement}', "");
    Expect(0, 92736, '\P{^-bamum_supplement}', "");
    Error('\p{_Is_Bamum_supplement/a/}');
    Error('\P{_Is_Bamum_supplement/a/}');
    Expect(1, 92735, '\p{isbamumsupplement}', "");
    Expect(0, 92735, '\p{^isbamumsupplement}', "");
    Expect(0, 92735, '\P{isbamumsupplement}', "");
    Expect(1, 92735, '\P{^isbamumsupplement}', "");
    Expect(0, 92736, '\p{isbamumsupplement}', "");
    Expect(1, 92736, '\p{^isbamumsupplement}', "");
    Expect(1, 92736, '\P{isbamumsupplement}', "");
    Expect(0, 92736, '\P{^isbamumsupplement}', "");
    Expect(1, 92735, '\p{_ Is_Bamum_supplement}', "");
    Expect(0, 92735, '\p{^_ Is_Bamum_supplement}', "");
    Expect(0, 92735, '\P{_ Is_Bamum_supplement}', "");
    Expect(1, 92735, '\P{^_ Is_Bamum_supplement}', "");
    Expect(0, 92736, '\p{_ Is_Bamum_supplement}', "");
    Expect(1, 92736, '\p{^_ Is_Bamum_supplement}', "");
    Expect(1, 92736, '\P{_ Is_Bamum_supplement}', "");
    Expect(0, 92736, '\P{^_ Is_Bamum_supplement}', "");
    Error('\p{-IN_BAMUM_Supplement/a/}');
    Error('\P{-IN_BAMUM_Supplement/a/}');
    Expect(1, 92735, '\p{inbamumsupplement}', "");
    Expect(0, 92735, '\p{^inbamumsupplement}', "");
    Expect(0, 92735, '\P{inbamumsupplement}', "");
    Expect(1, 92735, '\P{^inbamumsupplement}', "");
    Expect(0, 92736, '\p{inbamumsupplement}', "");
    Expect(1, 92736, '\p{^inbamumsupplement}', "");
    Expect(1, 92736, '\P{inbamumsupplement}', "");
    Expect(0, 92736, '\P{^inbamumsupplement}', "");
    Expect(1, 92735, '\p{	-In_Bamum_Supplement}', "");
    Expect(0, 92735, '\p{^	-In_Bamum_Supplement}', "");
    Expect(0, 92735, '\P{	-In_Bamum_Supplement}', "");
    Expect(1, 92735, '\P{^	-In_Bamum_Supplement}', "");
    Expect(0, 92736, '\p{	-In_Bamum_Supplement}', "");
    Expect(1, 92736, '\p{^	-In_Bamum_Supplement}', "");
    Expect(1, 92736, '\P{	-In_Bamum_Supplement}', "");
    Expect(0, 92736, '\P{^	-In_Bamum_Supplement}', "");
    Error('\p{/a/ bamum_SUP}');
    Error('\P{/a/ bamum_SUP}');
    Expect(1, 92735, '\p{bamumsup}', "");
    Expect(0, 92735, '\p{^bamumsup}', "");
    Expect(0, 92735, '\P{bamumsup}', "");
    Expect(1, 92735, '\P{^bamumsup}', "");
    Expect(0, 92736, '\p{bamumsup}', "");
    Expect(1, 92736, '\p{^bamumsup}', "");
    Expect(1, 92736, '\P{bamumsup}', "");
    Expect(0, 92736, '\P{^bamumsup}', "");
    Expect(1, 92735, '\p{	BAMUM_sup}', "");
    Expect(0, 92735, '\p{^	BAMUM_sup}', "");
    Expect(0, 92735, '\P{	BAMUM_sup}', "");
    Expect(1, 92735, '\P{^	BAMUM_sup}', "");
    Expect(0, 92736, '\p{	BAMUM_sup}', "");
    Expect(1, 92736, '\p{^	BAMUM_sup}', "");
    Expect(1, 92736, '\P{	BAMUM_sup}', "");
    Expect(0, 92736, '\P{^	BAMUM_sup}', "");
    Error('\p{/a/Is_bamum_SUP}');
    Error('\P{/a/Is_bamum_SUP}');
    Expect(1, 92735, '\p{isbamumsup}', "");
    Expect(0, 92735, '\p{^isbamumsup}', "");
    Expect(0, 92735, '\P{isbamumsup}', "");
    Expect(1, 92735, '\P{^isbamumsup}', "");
    Expect(0, 92736, '\p{isbamumsup}', "");
    Expect(1, 92736, '\p{^isbamumsup}', "");
    Expect(1, 92736, '\P{isbamumsup}', "");
    Expect(0, 92736, '\P{^isbamumsup}', "");
    Expect(1, 92735, '\p{ _Is_bamum_SUP}', "");
    Expect(0, 92735, '\p{^ _Is_bamum_SUP}', "");
    Expect(0, 92735, '\P{ _Is_bamum_SUP}', "");
    Expect(1, 92735, '\P{^ _Is_bamum_SUP}', "");
    Expect(0, 92736, '\p{ _Is_bamum_SUP}', "");
    Expect(1, 92736, '\p{^ _Is_bamum_SUP}', "");
    Expect(1, 92736, '\P{ _Is_bamum_SUP}', "");
    Expect(0, 92736, '\P{^ _Is_bamum_SUP}', "");
    Error('\p{ :=In_Bamum_SUP}');
    Error('\P{ :=In_Bamum_SUP}');
    Expect(1, 92735, '\p{inbamumsup}', "");
    Expect(0, 92735, '\p{^inbamumsup}', "");
    Expect(0, 92735, '\P{inbamumsup}', "");
    Expect(1, 92735, '\P{^inbamumsup}', "");
    Expect(0, 92736, '\p{inbamumsup}', "");
    Expect(1, 92736, '\p{^inbamumsup}', "");
    Expect(1, 92736, '\P{inbamumsup}', "");
    Expect(0, 92736, '\P{^inbamumsup}', "");
    Expect(1, 92735, '\p{-In_Bamum_Sup}', "");
    Expect(0, 92735, '\p{^-In_Bamum_Sup}', "");
    Expect(0, 92735, '\P{-In_Bamum_Sup}', "");
    Expect(1, 92735, '\P{^-In_Bamum_Sup}', "");
    Expect(0, 92736, '\p{-In_Bamum_Sup}', "");
    Expect(1, 92736, '\p{^-In_Bamum_Sup}', "");
    Expect(1, 92736, '\P{-In_Bamum_Sup}', "");
    Expect(0, 92736, '\P{^-In_Bamum_Sup}', "");
    Error('\p{:= Bassa_Vah}');
    Error('\P{:= Bassa_Vah}');
    Expect(1, 92917, '\p{bassavah}', "");
    Expect(0, 92917, '\p{^bassavah}', "");
    Expect(0, 92917, '\P{bassavah}', "");
    Expect(1, 92917, '\P{^bassavah}', "");
    Expect(0, 92918, '\p{bassavah}', "");
    Expect(1, 92918, '\p{^bassavah}', "");
    Expect(1, 92918, '\P{bassavah}', "");
    Expect(0, 92918, '\P{^bassavah}', "");
    Expect(1, 92917, '\p{_-BASSA_Vah}', "");
    Expect(0, 92917, '\p{^_-BASSA_Vah}', "");
    Expect(0, 92917, '\P{_-BASSA_Vah}', "");
    Expect(1, 92917, '\P{^_-BASSA_Vah}', "");
    Expect(0, 92918, '\p{_-BASSA_Vah}', "");
    Expect(1, 92918, '\p{^_-BASSA_Vah}', "");
    Expect(1, 92918, '\P{_-BASSA_Vah}', "");
    Expect(0, 92918, '\P{^_-BASSA_Vah}', "");
    Error('\p{/a/	IS_BASSA_vah}');
    Error('\P{/a/	IS_BASSA_vah}');
    Expect(1, 92917, '\p{isbassavah}', "");
    Expect(0, 92917, '\p{^isbassavah}', "");
    Expect(0, 92917, '\P{isbassavah}', "");
    Expect(1, 92917, '\P{^isbassavah}', "");
    Expect(0, 92918, '\p{isbassavah}', "");
    Expect(1, 92918, '\p{^isbassavah}', "");
    Expect(1, 92918, '\P{isbassavah}', "");
    Expect(0, 92918, '\P{^isbassavah}', "");
    Expect(1, 92917, '\p{	 IS_BASSA_Vah}', "");
    Expect(0, 92917, '\p{^	 IS_BASSA_Vah}', "");
    Expect(0, 92917, '\P{	 IS_BASSA_Vah}', "");
    Expect(1, 92917, '\P{^	 IS_BASSA_Vah}', "");
    Expect(0, 92918, '\p{	 IS_BASSA_Vah}', "");
    Expect(1, 92918, '\p{^	 IS_BASSA_Vah}', "");
    Expect(1, 92918, '\P{	 IS_BASSA_Vah}', "");
    Expect(0, 92918, '\P{^	 IS_BASSA_Vah}', "");
    Error('\p{-/a/Bass}');
    Error('\P{-/a/Bass}');
    Expect(1, 92917, '\p{bass}', "");
    Expect(0, 92917, '\p{^bass}', "");
    Expect(0, 92917, '\P{bass}', "");
    Expect(1, 92917, '\P{^bass}', "");
    Expect(0, 92918, '\p{bass}', "");
    Expect(1, 92918, '\p{^bass}', "");
    Expect(1, 92918, '\P{bass}', "");
    Expect(0, 92918, '\P{^bass}', "");
    Expect(1, 92917, '\p{ bass}', "");
    Expect(0, 92917, '\p{^ bass}', "");
    Expect(0, 92917, '\P{ bass}', "");
    Expect(1, 92917, '\P{^ bass}', "");
    Expect(0, 92918, '\p{ bass}', "");
    Expect(1, 92918, '\p{^ bass}', "");
    Expect(1, 92918, '\P{ bass}', "");
    Expect(0, 92918, '\P{^ bass}', "");
    Error('\p{:=_IS_BASS}');
    Error('\P{:=_IS_BASS}');
    Expect(1, 92917, '\p{isbass}', "");
    Expect(0, 92917, '\p{^isbass}', "");
    Expect(0, 92917, '\P{isbass}', "");
    Expect(1, 92917, '\P{^isbass}', "");
    Expect(0, 92918, '\p{isbass}', "");
    Expect(1, 92918, '\p{^isbass}', "");
    Expect(1, 92918, '\P{isbass}', "");
    Expect(0, 92918, '\P{^isbass}', "");
    Expect(1, 92917, '\p{ IS_Bass}', "");
    Expect(0, 92917, '\p{^ IS_Bass}', "");
    Expect(0, 92917, '\P{ IS_Bass}', "");
    Expect(1, 92917, '\P{^ IS_Bass}', "");
    Expect(0, 92918, '\p{ IS_Bass}', "");
    Expect(1, 92918, '\p{^ IS_Bass}', "");
    Expect(1, 92918, '\P{ IS_Bass}', "");
    Expect(0, 92918, '\P{^ IS_Bass}', "");
    Error('\p{__BATAK:=}');
    Error('\P{__BATAK:=}');
    Expect(1, 7167, '\p{batak}', "");
    Expect(0, 7167, '\p{^batak}', "");
    Expect(0, 7167, '\P{batak}', "");
    Expect(1, 7167, '\P{^batak}', "");
    Expect(0, 7168, '\p{batak}', "");
    Expect(1, 7168, '\p{^batak}', "");
    Expect(1, 7168, '\P{batak}', "");
    Expect(0, 7168, '\P{^batak}', "");
    Expect(1, 7167, '\p{ Batak}', "");
    Expect(0, 7167, '\p{^ Batak}', "");
    Expect(0, 7167, '\P{ Batak}', "");
    Expect(1, 7167, '\P{^ Batak}', "");
    Expect(0, 7168, '\p{ Batak}', "");
    Expect(1, 7168, '\p{^ Batak}', "");
    Expect(1, 7168, '\P{ Batak}', "");
    Expect(0, 7168, '\P{^ Batak}', "");
    Error('\p{/a/--is_batak}');
    Error('\P{/a/--is_batak}');
    Expect(1, 7167, '\p{isbatak}', "");
    Expect(0, 7167, '\p{^isbatak}', "");
    Expect(0, 7167, '\P{isbatak}', "");
    Expect(1, 7167, '\P{^isbatak}', "");
    Expect(0, 7168, '\p{isbatak}', "");
    Expect(1, 7168, '\p{^isbatak}', "");
    Expect(1, 7168, '\P{isbatak}', "");
    Expect(0, 7168, '\P{^isbatak}', "");
    Expect(1, 7167, '\p{_ Is_batak}', "");
    Expect(0, 7167, '\p{^_ Is_batak}', "");
    Expect(0, 7167, '\P{_ Is_batak}', "");
    Expect(1, 7167, '\P{^_ Is_batak}', "");
    Expect(0, 7168, '\p{_ Is_batak}', "");
    Expect(1, 7168, '\p{^_ Is_batak}', "");
    Expect(1, 7168, '\P{_ Is_batak}', "");
    Expect(0, 7168, '\P{^_ Is_batak}', "");
    Error('\p{/a/	 Batk}');
    Error('\P{/a/	 Batk}');
    Expect(1, 7167, '\p{batk}', "");
    Expect(0, 7167, '\p{^batk}', "");
    Expect(0, 7167, '\P{batk}', "");
    Expect(1, 7167, '\P{^batk}', "");
    Expect(0, 7168, '\p{batk}', "");
    Expect(1, 7168, '\p{^batk}', "");
    Expect(1, 7168, '\P{batk}', "");
    Expect(0, 7168, '\P{^batk}', "");
    Expect(1, 7167, '\p{	-Batk}', "");
    Expect(0, 7167, '\p{^	-Batk}', "");
    Expect(0, 7167, '\P{	-Batk}', "");
    Expect(1, 7167, '\P{^	-Batk}', "");
    Expect(0, 7168, '\p{	-Batk}', "");
    Expect(1, 7168, '\p{^	-Batk}', "");
    Expect(1, 7168, '\P{	-Batk}', "");
    Expect(0, 7168, '\P{^	-Batk}', "");
    Error('\p{	_Is_Batk:=}');
    Error('\P{	_Is_Batk:=}');
    Expect(1, 7167, '\p{isbatk}', "");
    Expect(0, 7167, '\p{^isbatk}', "");
    Expect(0, 7167, '\P{isbatk}', "");
    Expect(1, 7167, '\P{^isbatk}', "");
    Expect(0, 7168, '\p{isbatk}', "");
    Expect(1, 7168, '\p{^isbatk}', "");
    Expect(1, 7168, '\P{isbatk}', "");
    Expect(0, 7168, '\P{^isbatk}', "");
    Expect(1, 7167, '\p{	_IS_Batk}', "");
    Expect(0, 7167, '\p{^	_IS_Batk}', "");
    Expect(0, 7167, '\P{	_IS_Batk}', "");
    Expect(1, 7167, '\P{^	_IS_Batk}', "");
    Expect(0, 7168, '\p{	_IS_Batk}', "");
    Expect(1, 7168, '\p{^	_IS_Batk}', "");
    Expect(1, 7168, '\P{	_IS_Batk}', "");
    Expect(0, 7168, '\P{^	_IS_Batk}', "");
    Error('\p{-_bengali/a/}');
    Error('\P{-_bengali/a/}');
    Expect(1, 43249, '\p{bengali}', "");
    Expect(0, 43249, '\p{^bengali}', "");
    Expect(0, 43249, '\P{bengali}', "");
    Expect(1, 43249, '\P{^bengali}', "");
    Expect(0, 43250, '\p{bengali}', "");
    Expect(1, 43250, '\p{^bengali}', "");
    Expect(1, 43250, '\P{bengali}', "");
    Expect(0, 43250, '\P{^bengali}', "");
    Expect(1, 43249, '\p{_Bengali}', "");
    Expect(0, 43249, '\p{^_Bengali}', "");
    Expect(0, 43249, '\P{_Bengali}', "");
    Expect(1, 43249, '\P{^_Bengali}', "");
    Expect(0, 43250, '\p{_Bengali}', "");
    Expect(1, 43250, '\p{^_Bengali}', "");
    Expect(1, 43250, '\P{_Bengali}', "");
    Expect(0, 43250, '\P{^_Bengali}', "");
    Error('\p{/a/- IS_Bengali}');
    Error('\P{/a/- IS_Bengali}');
    Expect(1, 43249, '\p{isbengali}', "");
    Expect(0, 43249, '\p{^isbengali}', "");
    Expect(0, 43249, '\P{isbengali}', "");
    Expect(1, 43249, '\P{^isbengali}', "");
    Expect(0, 43250, '\p{isbengali}', "");
    Expect(1, 43250, '\p{^isbengali}', "");
    Expect(1, 43250, '\P{isbengali}', "");
    Expect(0, 43250, '\P{^isbengali}', "");
    Expect(1, 43249, '\p{_is_BENGALI}', "");
    Expect(0, 43249, '\p{^_is_BENGALI}', "");
    Expect(0, 43249, '\P{_is_BENGALI}', "");
    Expect(1, 43249, '\P{^_is_BENGALI}', "");
    Expect(0, 43250, '\p{_is_BENGALI}', "");
    Expect(1, 43250, '\p{^_is_BENGALI}', "");
    Expect(1, 43250, '\P{_is_BENGALI}', "");
    Expect(0, 43250, '\P{^_is_BENGALI}', "");
    Error('\p{/a/beng}');
    Error('\P{/a/beng}');
    Expect(1, 43249, '\p{beng}', "");
    Expect(0, 43249, '\p{^beng}', "");
    Expect(0, 43249, '\P{beng}', "");
    Expect(1, 43249, '\P{^beng}', "");
    Expect(0, 43250, '\p{beng}', "");
    Expect(1, 43250, '\p{^beng}', "");
    Expect(1, 43250, '\P{beng}', "");
    Expect(0, 43250, '\P{^beng}', "");
    Expect(1, 43249, '\p{	_Beng}', "");
    Expect(0, 43249, '\p{^	_Beng}', "");
    Expect(0, 43249, '\P{	_Beng}', "");
    Expect(1, 43249, '\P{^	_Beng}', "");
    Expect(0, 43250, '\p{	_Beng}', "");
    Expect(1, 43250, '\p{^	_Beng}', "");
    Expect(1, 43250, '\P{	_Beng}', "");
    Expect(0, 43250, '\P{^	_Beng}', "");
    Error('\p{_Is_beng/a/}');
    Error('\P{_Is_beng/a/}');
    Expect(1, 43249, '\p{isbeng}', "");
    Expect(0, 43249, '\p{^isbeng}', "");
    Expect(0, 43249, '\P{isbeng}', "");
    Expect(1, 43249, '\P{^isbeng}', "");
    Expect(0, 43250, '\p{isbeng}', "");
    Expect(1, 43250, '\p{^isbeng}', "");
    Expect(1, 43250, '\P{isbeng}', "");
    Expect(0, 43250, '\P{^isbeng}', "");
    Expect(1, 43249, '\p{__is_BENG}', "");
    Expect(0, 43249, '\p{^__is_BENG}', "");
    Expect(0, 43249, '\P{__is_BENG}', "");
    Expect(1, 43249, '\P{^__is_BENG}', "");
    Expect(0, 43250, '\p{__is_BENG}', "");
    Expect(1, 43250, '\p{^__is_BENG}', "");
    Expect(1, 43250, '\P{__is_BENG}', "");
    Expect(0, 43250, '\P{^__is_BENG}', "");
    Error('\p{	_Bhaiksuki/a/}');
    Error('\P{	_Bhaiksuki/a/}');
    Expect(1, 72812, '\p{bhaiksuki}', "");
    Expect(0, 72812, '\p{^bhaiksuki}', "");
    Expect(0, 72812, '\P{bhaiksuki}', "");
    Expect(1, 72812, '\P{^bhaiksuki}', "");
    Expect(0, 72813, '\p{bhaiksuki}', "");
    Expect(1, 72813, '\p{^bhaiksuki}', "");
    Expect(1, 72813, '\P{bhaiksuki}', "");
    Expect(0, 72813, '\P{^bhaiksuki}', "");
    Expect(1, 72812, '\p{- bhaiksuki}', "");
    Expect(0, 72812, '\p{^- bhaiksuki}', "");
    Expect(0, 72812, '\P{- bhaiksuki}', "");
    Expect(1, 72812, '\P{^- bhaiksuki}', "");
    Expect(0, 72813, '\p{- bhaiksuki}', "");
    Expect(1, 72813, '\p{^- bhaiksuki}', "");
    Expect(1, 72813, '\P{- bhaiksuki}', "");
    Expect(0, 72813, '\P{^- bhaiksuki}', "");
    Error('\p{:=_-Is_Bhaiksuki}');
    Error('\P{:=_-Is_Bhaiksuki}');
    Expect(1, 72812, '\p{isbhaiksuki}', "");
    Expect(0, 72812, '\p{^isbhaiksuki}', "");
    Expect(0, 72812, '\P{isbhaiksuki}', "");
    Expect(1, 72812, '\P{^isbhaiksuki}', "");
    Expect(0, 72813, '\p{isbhaiksuki}', "");
    Expect(1, 72813, '\p{^isbhaiksuki}', "");
    Expect(1, 72813, '\P{isbhaiksuki}', "");
    Expect(0, 72813, '\P{^isbhaiksuki}', "");
    Expect(1, 72812, '\p{-Is_BHAIKSUKI}', "");
    Expect(0, 72812, '\p{^-Is_BHAIKSUKI}', "");
    Expect(0, 72812, '\P{-Is_BHAIKSUKI}', "");
    Expect(1, 72812, '\P{^-Is_BHAIKSUKI}', "");
    Expect(0, 72813, '\p{-Is_BHAIKSUKI}', "");
    Expect(1, 72813, '\p{^-Is_BHAIKSUKI}', "");
    Expect(1, 72813, '\P{-Is_BHAIKSUKI}', "");
    Expect(0, 72813, '\P{^-Is_BHAIKSUKI}', "");
    Error('\p{ 	Bhks:=}');
    Error('\P{ 	Bhks:=}');
    Expect(1, 72812, '\p{bhks}', "");
    Expect(0, 72812, '\p{^bhks}', "");
    Expect(0, 72812, '\P{bhks}', "");
    Expect(1, 72812, '\P{^bhks}', "");
    Expect(0, 72813, '\p{bhks}', "");
    Expect(1, 72813, '\p{^bhks}', "");
    Expect(1, 72813, '\P{bhks}', "");
    Expect(0, 72813, '\P{^bhks}', "");
    Expect(1, 72812, '\p{ Bhks}', "");
    Expect(0, 72812, '\p{^ Bhks}', "");
    Expect(0, 72812, '\P{ Bhks}', "");
    Expect(1, 72812, '\P{^ Bhks}', "");
    Expect(0, 72813, '\p{ Bhks}', "");
    Expect(1, 72813, '\p{^ Bhks}', "");
    Expect(1, 72813, '\P{ Bhks}', "");
    Expect(0, 72813, '\P{^ Bhks}', "");
    Error('\p{ :=Is_BHKS}');
    Error('\P{ :=Is_BHKS}');
    Expect(1, 72812, '\p{isbhks}', "");
    Expect(0, 72812, '\p{^isbhks}', "");
    Expect(0, 72812, '\P{isbhks}', "");
    Expect(1, 72812, '\P{^isbhks}', "");
    Expect(0, 72813, '\p{isbhks}', "");
    Expect(1, 72813, '\p{^isbhks}', "");
    Expect(1, 72813, '\P{isbhks}', "");
    Expect(0, 72813, '\P{^isbhks}', "");
    Expect(1, 72812, '\p{	Is_bhks}', "");
    Expect(0, 72812, '\p{^	Is_bhks}', "");
    Expect(0, 72812, '\P{	Is_bhks}', "");
    Expect(1, 72812, '\P{^	Is_bhks}', "");
    Expect(0, 72813, '\p{	Is_bhks}', "");
    Expect(1, 72813, '\p{^	Is_bhks}', "");
    Expect(1, 72813, '\P{	Is_bhks}', "");
    Expect(0, 72813, '\P{^	Is_bhks}', "");
    Error('\p{	bidi_Control/a/}');
    Error('\P{	bidi_Control/a/}');
    Expect(1, 8297, '\p{bidicontrol}', "");
    Expect(0, 8297, '\p{^bidicontrol}', "");
    Expect(0, 8297, '\P{bidicontrol}', "");
    Expect(1, 8297, '\P{^bidicontrol}', "");
    Expect(0, 8298, '\p{bidicontrol}', "");
    Expect(1, 8298, '\p{^bidicontrol}', "");
    Expect(1, 8298, '\P{bidicontrol}', "");
    Expect(0, 8298, '\P{^bidicontrol}', "");
    Expect(1, 8297, '\p{		bidi_Control}', "");
    Expect(0, 8297, '\p{^		bidi_Control}', "");
    Expect(0, 8297, '\P{		bidi_Control}', "");
    Expect(1, 8297, '\P{^		bidi_Control}', "");
    Expect(0, 8298, '\p{		bidi_Control}', "");
    Expect(1, 8298, '\p{^		bidi_Control}', "");
    Expect(1, 8298, '\P{		bidi_Control}', "");
    Expect(0, 8298, '\P{^		bidi_Control}', "");
    Error('\p{is_BIDI_Control/a/}');
    Error('\P{is_BIDI_Control/a/}');
    Expect(1, 8297, '\p{isbidicontrol}', "");
    Expect(0, 8297, '\p{^isbidicontrol}', "");
    Expect(0, 8297, '\P{isbidicontrol}', "");
    Expect(1, 8297, '\P{^isbidicontrol}', "");
    Expect(0, 8298, '\p{isbidicontrol}', "");
    Expect(1, 8298, '\p{^isbidicontrol}', "");
    Expect(1, 8298, '\P{isbidicontrol}', "");
    Expect(0, 8298, '\P{^isbidicontrol}', "");
    Expect(1, 8297, '\p{	_IS_Bidi_control}', "");
    Expect(0, 8297, '\p{^	_IS_Bidi_control}', "");
    Expect(0, 8297, '\P{	_IS_Bidi_control}', "");
    Expect(1, 8297, '\P{^	_IS_Bidi_control}', "");
    Expect(0, 8298, '\p{	_IS_Bidi_control}', "");
    Expect(1, 8298, '\p{^	_IS_Bidi_control}', "");
    Expect(1, 8298, '\P{	_IS_Bidi_control}', "");
    Expect(0, 8298, '\P{^	_IS_Bidi_control}', "");
    Error('\p{-bidi_C/a/}');
    Error('\P{-bidi_C/a/}');
    Expect(1, 8297, '\p{bidic}', "");
    Expect(0, 8297, '\p{^bidic}', "");
    Expect(0, 8297, '\P{bidic}', "");
    Expect(1, 8297, '\P{^bidic}', "");
    Expect(0, 8298, '\p{bidic}', "");
    Expect(1, 8298, '\p{^bidic}', "");
    Expect(1, 8298, '\P{bidic}', "");
    Expect(0, 8298, '\P{^bidic}', "");
    Expect(1, 8297, '\p{_	BIDI_C}', "");
    Expect(0, 8297, '\p{^_	BIDI_C}', "");
    Expect(0, 8297, '\P{_	BIDI_C}', "");
    Expect(1, 8297, '\P{^_	BIDI_C}', "");
    Expect(0, 8298, '\p{_	BIDI_C}', "");
    Expect(1, 8298, '\p{^_	BIDI_C}', "");
    Expect(1, 8298, '\P{_	BIDI_C}', "");
    Expect(0, 8298, '\P{^_	BIDI_C}', "");
    Error('\p{ :=Is_Bidi_c}');
    Error('\P{ :=Is_Bidi_c}');
    Expect(1, 8297, '\p{isbidic}', "");
    Expect(0, 8297, '\p{^isbidic}', "");
    Expect(0, 8297, '\P{isbidic}', "");
    Expect(1, 8297, '\P{^isbidic}', "");
    Expect(0, 8298, '\p{isbidic}', "");
    Expect(1, 8298, '\p{^isbidic}', "");
    Expect(1, 8298, '\P{isbidic}', "");
    Expect(0, 8298, '\P{^isbidic}', "");
    Expect(1, 8297, '\p{	_IS_bidi_C}', "");
    Expect(0, 8297, '\p{^	_IS_bidi_C}', "");
    Expect(0, 8297, '\P{	_IS_bidi_C}', "");
    Expect(1, 8297, '\P{^	_IS_bidi_C}', "");
    Expect(0, 8298, '\p{	_IS_bidi_C}', "");
    Expect(1, 8298, '\p{^	_IS_bidi_C}', "");
    Expect(1, 8298, '\P{	_IS_bidi_C}', "");
    Expect(0, 8298, '\P{^	_IS_bidi_C}', "");
    Error('\p{:=_Bidi_Mirrored}');
    Error('\P{:=_Bidi_Mirrored}');
    Expect(1, 120771, '\p{bidimirrored}', "");
    Expect(0, 120771, '\p{^bidimirrored}', "");
    Expect(0, 120771, '\P{bidimirrored}', "");
    Expect(1, 120771, '\P{^bidimirrored}', "");
    Expect(0, 120772, '\p{bidimirrored}', "");
    Expect(1, 120772, '\p{^bidimirrored}', "");
    Expect(1, 120772, '\P{bidimirrored}', "");
    Expect(0, 120772, '\P{^bidimirrored}', "");
    Expect(1, 120771, '\p{ -Bidi_Mirrored}', "");
    Expect(0, 120771, '\p{^ -Bidi_Mirrored}', "");
    Expect(0, 120771, '\P{ -Bidi_Mirrored}', "");
    Expect(1, 120771, '\P{^ -Bidi_Mirrored}', "");
    Expect(0, 120772, '\p{ -Bidi_Mirrored}', "");
    Expect(1, 120772, '\p{^ -Bidi_Mirrored}', "");
    Expect(1, 120772, '\P{ -Bidi_Mirrored}', "");
    Expect(0, 120772, '\P{^ -Bidi_Mirrored}', "");
    Error('\p{	 Is_bidi_MIRRORED:=}');
    Error('\P{	 Is_bidi_MIRRORED:=}');
    Expect(1, 120771, '\p{isbidimirrored}', "");
    Expect(0, 120771, '\p{^isbidimirrored}', "");
    Expect(0, 120771, '\P{isbidimirrored}', "");
    Expect(1, 120771, '\P{^isbidimirrored}', "");
    Expect(0, 120772, '\p{isbidimirrored}', "");
    Expect(1, 120772, '\p{^isbidimirrored}', "");
    Expect(1, 120772, '\P{isbidimirrored}', "");
    Expect(0, 120772, '\P{^isbidimirrored}', "");
    Expect(1, 120771, '\p{-IS_bidi_MIRRORED}', "");
    Expect(0, 120771, '\p{^-IS_bidi_MIRRORED}', "");
    Expect(0, 120771, '\P{-IS_bidi_MIRRORED}', "");
    Expect(1, 120771, '\P{^-IS_bidi_MIRRORED}', "");
    Expect(0, 120772, '\p{-IS_bidi_MIRRORED}', "");
    Expect(1, 120772, '\p{^-IS_bidi_MIRRORED}', "");
    Expect(1, 120772, '\P{-IS_bidi_MIRRORED}', "");
    Expect(0, 120772, '\P{^-IS_bidi_MIRRORED}', "");
    Error('\p{	:=BIDI_M}');
    Error('\P{	:=BIDI_M}');
    Expect(1, 120771, '\p{bidim}', "");
    Expect(0, 120771, '\p{^bidim}', "");
    Expect(0, 120771, '\P{bidim}', "");
    Expect(1, 120771, '\P{^bidim}', "");
    Expect(0, 120772, '\p{bidim}', "");
    Expect(1, 120772, '\p{^bidim}', "");
    Expect(1, 120772, '\P{bidim}', "");
    Expect(0, 120772, '\P{^bidim}', "");
    Expect(1, 120771, '\p{--bidi_M}', "");
    Expect(0, 120771, '\p{^--bidi_M}', "");
    Expect(0, 120771, '\P{--bidi_M}', "");
    Expect(1, 120771, '\P{^--bidi_M}', "");
    Expect(0, 120772, '\p{--bidi_M}', "");
    Expect(1, 120772, '\p{^--bidi_M}', "");
    Expect(1, 120772, '\P{--bidi_M}', "");
    Expect(0, 120772, '\P{^--bidi_M}', "");
    Error('\p{:=IS_BIDI_M}');
    Error('\P{:=IS_BIDI_M}');
    Expect(1, 120771, '\p{isbidim}', "");
    Expect(0, 120771, '\p{^isbidim}', "");
    Expect(0, 120771, '\P{isbidim}', "");
    Expect(1, 120771, '\P{^isbidim}', "");
    Expect(0, 120772, '\p{isbidim}', "");
    Expect(1, 120772, '\p{^isbidim}', "");
    Expect(1, 120772, '\P{isbidim}', "");
    Expect(0, 120772, '\P{^isbidim}', "");
    Expect(1, 120771, '\p{-is_bidi_M}', "");
    Expect(0, 120771, '\p{^-is_bidi_M}', "");
    Expect(0, 120771, '\P{-is_bidi_M}', "");
    Expect(1, 120771, '\P{^-is_bidi_M}', "");
    Expect(0, 120772, '\p{-is_bidi_M}', "");
    Expect(1, 120772, '\p{^-is_bidi_M}', "");
    Expect(1, 120772, '\P{-is_bidi_M}', "");
    Expect(0, 120772, '\P{^-is_bidi_M}', "");
    Error('\p{	_XPosixBlank/a/}');
    Error('\P{	_XPosixBlank/a/}');
    Expect(1, 12288, '\p{xposixblank}', "");
    Expect(0, 12288, '\p{^xposixblank}', "");
    Expect(0, 12288, '\P{xposixblank}', "");
    Expect(1, 12288, '\P{^xposixblank}', "");
    Expect(0, 12289, '\p{xposixblank}', "");
    Expect(1, 12289, '\p{^xposixblank}', "");
    Expect(1, 12289, '\P{xposixblank}', "");
    Expect(0, 12289, '\P{^xposixblank}', "");
    Expect(1, 12288, '\p{XPosixBlank}', "");
    Expect(0, 12288, '\p{^XPosixBlank}', "");
    Expect(0, 12288, '\P{XPosixBlank}', "");
    Expect(1, 12288, '\P{^XPosixBlank}', "");
    Expect(0, 12289, '\p{XPosixBlank}', "");
    Expect(1, 12289, '\p{^XPosixBlank}', "");
    Expect(1, 12289, '\P{XPosixBlank}', "");
    Expect(0, 12289, '\P{^XPosixBlank}', "");
    Error('\p{	:=Blank}');
    Error('\P{	:=Blank}');
    Expect(1, 12288, '\p{blank}', "");
    Expect(0, 12288, '\p{^blank}', "");
    Expect(0, 12288, '\P{blank}', "");
    Expect(1, 12288, '\P{^blank}', "");
    Expect(0, 12289, '\p{blank}', "");
    Expect(1, 12289, '\p{^blank}', "");
    Expect(1, 12289, '\P{blank}', "");
    Expect(0, 12289, '\P{^blank}', "");
    Expect(1, 12288, '\p{  Blank}', "");
    Expect(0, 12288, '\p{^  Blank}', "");
    Expect(0, 12288, '\P{  Blank}', "");
    Expect(1, 12288, '\P{^  Blank}', "");
    Expect(0, 12289, '\p{  Blank}', "");
    Expect(1, 12289, '\p{^  Blank}', "");
    Expect(1, 12289, '\P{  Blank}', "");
    Expect(0, 12289, '\P{^  Blank}', "");
    Error('\p{_HORIZSPACE/a/}');
    Error('\P{_HORIZSPACE/a/}');
    Expect(1, 12288, '\p{horizspace}', "");
    Expect(0, 12288, '\p{^horizspace}', "");
    Expect(0, 12288, '\P{horizspace}', "");
    Expect(1, 12288, '\P{^horizspace}', "");
    Expect(0, 12289, '\p{horizspace}', "");
    Expect(1, 12289, '\p{^horizspace}', "");
    Expect(1, 12289, '\P{horizspace}', "");
    Expect(0, 12289, '\P{^horizspace}', "");
    Expect(1, 12288, '\p{-HorizSpace}', "");
    Expect(0, 12288, '\p{^-HorizSpace}', "");
    Expect(0, 12288, '\P{-HorizSpace}', "");
    Expect(1, 12288, '\P{^-HorizSpace}', "");
    Expect(0, 12289, '\p{-HorizSpace}', "");
    Expect(1, 12289, '\p{^-HorizSpace}', "");
    Expect(1, 12289, '\P{-HorizSpace}', "");
    Expect(0, 12289, '\P{^-HorizSpace}', "");
    Error('\p{/a/ -Is_xposixblank}');
    Error('\P{/a/ -Is_xposixblank}');
    Expect(1, 12288, '\p{isxposixblank}', "");
    Expect(0, 12288, '\p{^isxposixblank}', "");
    Expect(0, 12288, '\P{isxposixblank}', "");
    Expect(1, 12288, '\P{^isxposixblank}', "");
    Expect(0, 12289, '\p{isxposixblank}', "");
    Expect(1, 12289, '\p{^isxposixblank}', "");
    Expect(1, 12289, '\P{isxposixblank}', "");
    Expect(0, 12289, '\P{^isxposixblank}', "");
    Expect(1, 12288, '\p{__Is_XPOSIXBLANK}', "");
    Expect(0, 12288, '\p{^__Is_XPOSIXBLANK}', "");
    Expect(0, 12288, '\P{__Is_XPOSIXBLANK}', "");
    Expect(1, 12288, '\P{^__Is_XPOSIXBLANK}', "");
    Expect(0, 12289, '\p{__Is_XPOSIXBLANK}', "");
    Expect(1, 12289, '\p{^__Is_XPOSIXBLANK}', "");
    Expect(1, 12289, '\P{__Is_XPOSIXBLANK}', "");
    Expect(0, 12289, '\P{^__Is_XPOSIXBLANK}', "");
    Error('\p{ :=Is_blank}');
    Error('\P{ :=Is_blank}');
    Expect(1, 12288, '\p{isblank}', "");
    Expect(0, 12288, '\p{^isblank}', "");
    Expect(0, 12288, '\P{isblank}', "");
    Expect(1, 12288, '\P{^isblank}', "");
    Expect(0, 12289, '\p{isblank}', "");
    Expect(1, 12289, '\p{^isblank}', "");
    Expect(1, 12289, '\P{isblank}', "");
    Expect(0, 12289, '\P{^isblank}', "");
    Expect(1, 12288, '\p{IS_BLANK}', "");
    Expect(0, 12288, '\p{^IS_BLANK}', "");
    Expect(0, 12288, '\P{IS_BLANK}', "");
    Expect(1, 12288, '\P{^IS_BLANK}', "");
    Expect(0, 12289, '\p{IS_BLANK}', "");
    Expect(1, 12289, '\p{^IS_BLANK}', "");
    Expect(1, 12289, '\P{IS_BLANK}', "");
    Expect(0, 12289, '\P{^IS_BLANK}', "");
    Error('\p{ /a/Is_HORIZSPACE}');
    Error('\P{ /a/Is_HORIZSPACE}');
    Expect(1, 12288, '\p{ishorizspace}', "");
    Expect(0, 12288, '\p{^ishorizspace}', "");
    Expect(0, 12288, '\P{ishorizspace}', "");
    Expect(1, 12288, '\P{^ishorizspace}', "");
    Expect(0, 12289, '\p{ishorizspace}', "");
    Expect(1, 12289, '\p{^ishorizspace}', "");
    Expect(1, 12289, '\P{ishorizspace}', "");
    Expect(0, 12289, '\P{^ishorizspace}', "");
    Expect(1, 12288, '\p{-is_HorizSpace}', "");
    Expect(0, 12288, '\p{^-is_HorizSpace}', "");
    Expect(0, 12288, '\P{-is_HorizSpace}', "");
    Expect(1, 12288, '\P{^-is_HorizSpace}', "");
    Expect(0, 12289, '\p{-is_HorizSpace}', "");
    Expect(1, 12289, '\p{^-is_HorizSpace}', "");
    Expect(1, 12289, '\P{-is_HorizSpace}', "");
    Expect(0, 12289, '\P{^-is_HorizSpace}', "");
    Error('\p{ :=Block_Elements}');
    Error('\P{ :=Block_Elements}');
    Expect(1, 9631, '\p{blockelements}', "");
    Expect(0, 9631, '\p{^blockelements}', "");
    Expect(0, 9631, '\P{blockelements}', "");
    Expect(1, 9631, '\P{^blockelements}', "");
    Expect(0, 9632, '\p{blockelements}', "");
    Expect(1, 9632, '\p{^blockelements}', "");
    Expect(1, 9632, '\P{blockelements}', "");
    Expect(0, 9632, '\P{^blockelements}', "");
    Expect(1, 9631, '\p{	-block_Elements}', "");
    Expect(0, 9631, '\p{^	-block_Elements}', "");
    Expect(0, 9631, '\P{	-block_Elements}', "");
    Expect(1, 9631, '\P{^	-block_Elements}', "");
    Expect(0, 9632, '\p{	-block_Elements}', "");
    Expect(1, 9632, '\p{^	-block_Elements}', "");
    Expect(1, 9632, '\P{	-block_Elements}', "");
    Expect(0, 9632, '\P{^	-block_Elements}', "");
    Error('\p{_-is_block_elements/a/}');
    Error('\P{_-is_block_elements/a/}');
    Expect(1, 9631, '\p{isblockelements}', "");
    Expect(0, 9631, '\p{^isblockelements}', "");
    Expect(0, 9631, '\P{isblockelements}', "");
    Expect(1, 9631, '\P{^isblockelements}', "");
    Expect(0, 9632, '\p{isblockelements}', "");
    Expect(1, 9632, '\p{^isblockelements}', "");
    Expect(1, 9632, '\P{isblockelements}', "");
    Expect(0, 9632, '\P{^isblockelements}', "");
    Expect(1, 9631, '\p{		Is_BLOCK_elements}', "");
    Expect(0, 9631, '\p{^		Is_BLOCK_elements}', "");
    Expect(0, 9631, '\P{		Is_BLOCK_elements}', "");
    Expect(1, 9631, '\P{^		Is_BLOCK_elements}', "");
    Expect(0, 9632, '\p{		Is_BLOCK_elements}', "");
    Expect(1, 9632, '\p{^		Is_BLOCK_elements}', "");
    Expect(1, 9632, '\P{		Is_BLOCK_elements}', "");
    Expect(0, 9632, '\P{^		Is_BLOCK_elements}', "");
    Error('\p{ /a/In_Block_ELEMENTS}');
    Error('\P{ /a/In_Block_ELEMENTS}');
    Expect(1, 9631, '\p{inblockelements}', "");
    Expect(0, 9631, '\p{^inblockelements}', "");
    Expect(0, 9631, '\P{inblockelements}', "");
    Expect(1, 9631, '\P{^inblockelements}', "");
    Expect(0, 9632, '\p{inblockelements}', "");
    Expect(1, 9632, '\p{^inblockelements}', "");
    Expect(1, 9632, '\P{inblockelements}', "");
    Expect(0, 9632, '\P{^inblockelements}', "");
    Expect(1, 9631, '\p{		in_block_elements}', "");
    Expect(0, 9631, '\p{^		in_block_elements}', "");
    Expect(0, 9631, '\P{		in_block_elements}', "");
    Expect(1, 9631, '\P{^		in_block_elements}', "");
    Expect(0, 9632, '\p{		in_block_elements}', "");
    Expect(1, 9632, '\p{^		in_block_elements}', "");
    Expect(1, 9632, '\P{		in_block_elements}', "");
    Expect(0, 9632, '\P{^		in_block_elements}', "");
    Error('\p{:= -Bopomofo}');
    Error('\P{:= -Bopomofo}');
    Expect(1, 65381, '\p{bopomofo}', "");
    Expect(0, 65381, '\p{^bopomofo}', "");
    Expect(0, 65381, '\P{bopomofo}', "");
    Expect(1, 65381, '\P{^bopomofo}', "");
    Expect(0, 65382, '\p{bopomofo}', "");
    Expect(1, 65382, '\p{^bopomofo}', "");
    Expect(1, 65382, '\P{bopomofo}', "");
    Expect(0, 65382, '\P{^bopomofo}', "");
    Expect(1, 65381, '\p{  Bopomofo}', "");
    Expect(0, 65381, '\p{^  Bopomofo}', "");
    Expect(0, 65381, '\P{  Bopomofo}', "");
    Expect(1, 65381, '\P{^  Bopomofo}', "");
    Expect(0, 65382, '\p{  Bopomofo}', "");
    Expect(1, 65382, '\p{^  Bopomofo}', "");
    Expect(1, 65382, '\P{  Bopomofo}', "");
    Expect(0, 65382, '\P{^  Bopomofo}', "");
    Error('\p{:= _Is_Bopomofo}');
    Error('\P{:= _Is_Bopomofo}');
    Expect(1, 65381, '\p{isbopomofo}', "");
    Expect(0, 65381, '\p{^isbopomofo}', "");
    Expect(0, 65381, '\P{isbopomofo}', "");
    Expect(1, 65381, '\P{^isbopomofo}', "");
    Expect(0, 65382, '\p{isbopomofo}', "");
    Expect(1, 65382, '\p{^isbopomofo}', "");
    Expect(1, 65382, '\P{isbopomofo}', "");
    Expect(0, 65382, '\P{^isbopomofo}', "");
    Expect(1, 65381, '\p{-_is_bopomofo}', "");
    Expect(0, 65381, '\p{^-_is_bopomofo}', "");
    Expect(0, 65381, '\P{-_is_bopomofo}', "");
    Expect(1, 65381, '\P{^-_is_bopomofo}', "");
    Expect(0, 65382, '\p{-_is_bopomofo}', "");
    Expect(1, 65382, '\p{^-_is_bopomofo}', "");
    Expect(1, 65382, '\P{-_is_bopomofo}', "");
    Expect(0, 65382, '\P{^-_is_bopomofo}', "");
    Error('\p{  bopo:=}');
    Error('\P{  bopo:=}');
    Expect(1, 65381, '\p{bopo}', "");
    Expect(0, 65381, '\p{^bopo}', "");
    Expect(0, 65381, '\P{bopo}', "");
    Expect(1, 65381, '\P{^bopo}', "");
    Expect(0, 65382, '\p{bopo}', "");
    Expect(1, 65382, '\p{^bopo}', "");
    Expect(1, 65382, '\P{bopo}', "");
    Expect(0, 65382, '\P{^bopo}', "");
    Expect(1, 65381, '\p{_bopo}', "");
    Expect(0, 65381, '\p{^_bopo}', "");
    Expect(0, 65381, '\P{_bopo}', "");
    Expect(1, 65381, '\P{^_bopo}', "");
    Expect(0, 65382, '\p{_bopo}', "");
    Expect(1, 65382, '\p{^_bopo}', "");
    Expect(1, 65382, '\P{_bopo}', "");
    Expect(0, 65382, '\P{^_bopo}', "");
    Error('\p{/a/	_is_bopo}');
    Error('\P{/a/	_is_bopo}');
    Expect(1, 65381, '\p{isbopo}', "");
    Expect(0, 65381, '\p{^isbopo}', "");
    Expect(0, 65381, '\P{isbopo}', "");
    Expect(1, 65381, '\P{^isbopo}', "");
    Expect(0, 65382, '\p{isbopo}', "");
    Expect(1, 65382, '\p{^isbopo}', "");
    Expect(1, 65382, '\P{isbopo}', "");
    Expect(0, 65382, '\P{^isbopo}', "");
    Expect(1, 65381, '\p{_IS_Bopo}', "");
    Expect(0, 65381, '\p{^_IS_Bopo}', "");
    Expect(0, 65381, '\P{_IS_Bopo}', "");
    Expect(1, 65381, '\P{^_IS_Bopo}', "");
    Expect(0, 65382, '\p{_IS_Bopo}', "");
    Expect(1, 65382, '\p{^_IS_Bopo}', "");
    Expect(1, 65382, '\P{_IS_Bopo}', "");
    Expect(0, 65382, '\P{^_IS_Bopo}', "");
    Error('\p{:= 	Bopomofo_Extended}');
    Error('\P{:= 	Bopomofo_Extended}');
    Expect(1, 12735, '\p{bopomofoextended}', "");
    Expect(0, 12735, '\p{^bopomofoextended}', "");
    Expect(0, 12735, '\P{bopomofoextended}', "");
    Expect(1, 12735, '\P{^bopomofoextended}', "");
    Expect(0, 12736, '\p{bopomofoextended}', "");
    Expect(1, 12736, '\p{^bopomofoextended}', "");
    Expect(1, 12736, '\P{bopomofoextended}', "");
    Expect(0, 12736, '\P{^bopomofoextended}', "");
    Expect(1, 12735, '\p{_	BOPOMOFO_Extended}', "");
    Expect(0, 12735, '\p{^_	BOPOMOFO_Extended}', "");
    Expect(0, 12735, '\P{_	BOPOMOFO_Extended}', "");
    Expect(1, 12735, '\P{^_	BOPOMOFO_Extended}', "");
    Expect(0, 12736, '\p{_	BOPOMOFO_Extended}', "");
    Expect(1, 12736, '\p{^_	BOPOMOFO_Extended}', "");
    Expect(1, 12736, '\P{_	BOPOMOFO_Extended}', "");
    Expect(0, 12736, '\P{^_	BOPOMOFO_Extended}', "");
    Error('\p{-/a/Is_bopomofo_Extended}');
    Error('\P{-/a/Is_bopomofo_Extended}');
    Expect(1, 12735, '\p{isbopomofoextended}', "");
    Expect(0, 12735, '\p{^isbopomofoextended}', "");
    Expect(0, 12735, '\P{isbopomofoextended}', "");
    Expect(1, 12735, '\P{^isbopomofoextended}', "");
    Expect(0, 12736, '\p{isbopomofoextended}', "");
    Expect(1, 12736, '\p{^isbopomofoextended}', "");
    Expect(1, 12736, '\P{isbopomofoextended}', "");
    Expect(0, 12736, '\P{^isbopomofoextended}', "");
    Expect(1, 12735, '\p{	Is_Bopomofo_EXTENDED}', "");
    Expect(0, 12735, '\p{^	Is_Bopomofo_EXTENDED}', "");
    Expect(0, 12735, '\P{	Is_Bopomofo_EXTENDED}', "");
    Expect(1, 12735, '\P{^	Is_Bopomofo_EXTENDED}', "");
    Expect(0, 12736, '\p{	Is_Bopomofo_EXTENDED}', "");
    Expect(1, 12736, '\p{^	Is_Bopomofo_EXTENDED}', "");
    Expect(1, 12736, '\P{	Is_Bopomofo_EXTENDED}', "");
    Expect(0, 12736, '\P{^	Is_Bopomofo_EXTENDED}', "");
    Error('\p{--In_Bopomofo_Extended:=}');
    Error('\P{--In_Bopomofo_Extended:=}');
    Expect(1, 12735, '\p{inbopomofoextended}', "");
    Expect(0, 12735, '\p{^inbopomofoextended}', "");
    Expect(0, 12735, '\P{inbopomofoextended}', "");
    Expect(1, 12735, '\P{^inbopomofoextended}', "");
    Expect(0, 12736, '\p{inbopomofoextended}', "");
    Expect(1, 12736, '\p{^inbopomofoextended}', "");
    Expect(1, 12736, '\P{inbopomofoextended}', "");
    Expect(0, 12736, '\P{^inbopomofoextended}', "");
    Expect(1, 12735, '\p{_In_Bopomofo_EXTENDED}', "");
    Expect(0, 12735, '\p{^_In_Bopomofo_EXTENDED}', "");
    Expect(0, 12735, '\P{_In_Bopomofo_EXTENDED}', "");
    Expect(1, 12735, '\P{^_In_Bopomofo_EXTENDED}', "");
    Expect(0, 12736, '\p{_In_Bopomofo_EXTENDED}', "");
    Expect(1, 12736, '\p{^_In_Bopomofo_EXTENDED}', "");
    Expect(1, 12736, '\P{_In_Bopomofo_EXTENDED}', "");
    Expect(0, 12736, '\P{^_In_Bopomofo_EXTENDED}', "");
    Error('\p{:=_BOPOMOFO_Ext}');
    Error('\P{:=_BOPOMOFO_Ext}');
    Expect(1, 12735, '\p{bopomofoext}', "");
    Expect(0, 12735, '\p{^bopomofoext}', "");
    Expect(0, 12735, '\P{bopomofoext}', "");
    Expect(1, 12735, '\P{^bopomofoext}', "");
    Expect(0, 12736, '\p{bopomofoext}', "");
    Expect(1, 12736, '\p{^bopomofoext}', "");
    Expect(1, 12736, '\P{bopomofoext}', "");
    Expect(0, 12736, '\P{^bopomofoext}', "");
    Expect(1, 12735, '\p{_Bopomofo_Ext}', "");
    Expect(0, 12735, '\p{^_Bopomofo_Ext}', "");
    Expect(0, 12735, '\P{_Bopomofo_Ext}', "");
    Expect(1, 12735, '\P{^_Bopomofo_Ext}', "");
    Expect(0, 12736, '\p{_Bopomofo_Ext}', "");
    Expect(1, 12736, '\p{^_Bopomofo_Ext}', "");
    Expect(1, 12736, '\P{_Bopomofo_Ext}', "");
    Expect(0, 12736, '\P{^_Bopomofo_Ext}', "");
    Error('\p{  Is_bopomofo_EXT/a/}');
    Error('\P{  Is_bopomofo_EXT/a/}');
    Expect(1, 12735, '\p{isbopomofoext}', "");
    Expect(0, 12735, '\p{^isbopomofoext}', "");
    Expect(0, 12735, '\P{isbopomofoext}', "");
    Expect(1, 12735, '\P{^isbopomofoext}', "");
    Expect(0, 12736, '\p{isbopomofoext}', "");
    Expect(1, 12736, '\p{^isbopomofoext}', "");
    Expect(1, 12736, '\P{isbopomofoext}', "");
    Expect(0, 12736, '\P{^isbopomofoext}', "");
    Expect(1, 12735, '\p{__Is_bopomofo_EXT}', "");
    Expect(0, 12735, '\p{^__Is_bopomofo_EXT}', "");
    Expect(0, 12735, '\P{__Is_bopomofo_EXT}', "");
    Expect(1, 12735, '\P{^__Is_bopomofo_EXT}', "");
    Expect(0, 12736, '\p{__Is_bopomofo_EXT}', "");
    Expect(1, 12736, '\p{^__Is_bopomofo_EXT}', "");
    Expect(1, 12736, '\P{__Is_bopomofo_EXT}', "");
    Expect(0, 12736, '\P{^__Is_bopomofo_EXT}', "");
    Error('\p{/a/  IN_Bopomofo_Ext}');
    Error('\P{/a/  IN_Bopomofo_Ext}');
    Expect(1, 12735, '\p{inbopomofoext}', "");
    Expect(0, 12735, '\p{^inbopomofoext}', "");
    Expect(0, 12735, '\P{inbopomofoext}', "");
    Expect(1, 12735, '\P{^inbopomofoext}', "");
    Expect(0, 12736, '\p{inbopomofoext}', "");
    Expect(1, 12736, '\p{^inbopomofoext}', "");
    Expect(1, 12736, '\P{inbopomofoext}', "");
    Expect(0, 12736, '\P{^inbopomofoext}', "");
    Expect(1, 12735, '\p{In_bopomofo_Ext}', "");
    Expect(0, 12735, '\p{^In_bopomofo_Ext}', "");
    Expect(0, 12735, '\P{In_bopomofo_Ext}', "");
    Expect(1, 12735, '\P{^In_bopomofo_Ext}', "");
    Expect(0, 12736, '\p{In_bopomofo_Ext}', "");
    Expect(1, 12736, '\p{^In_bopomofo_Ext}', "");
    Expect(1, 12736, '\P{In_bopomofo_Ext}', "");
    Expect(0, 12736, '\P{^In_bopomofo_Ext}', "");
    Error('\p{:=Box_DRAWING}');
    Error('\P{:=Box_DRAWING}');
    Expect(1, 9599, '\p{boxdrawing}', "");
    Expect(0, 9599, '\p{^boxdrawing}', "");
    Expect(0, 9599, '\P{boxdrawing}', "");
    Expect(1, 9599, '\P{^boxdrawing}', "");
    Expect(0, 9600, '\p{boxdrawing}', "");
    Expect(1, 9600, '\p{^boxdrawing}', "");
    Expect(1, 9600, '\P{boxdrawing}', "");
    Expect(0, 9600, '\P{^boxdrawing}', "");
    Expect(1, 9599, '\p{-_box_Drawing}', "");
    Expect(0, 9599, '\p{^-_box_Drawing}', "");
    Expect(0, 9599, '\P{-_box_Drawing}', "");
    Expect(1, 9599, '\P{^-_box_Drawing}', "");
    Expect(0, 9600, '\p{-_box_Drawing}', "");
    Expect(1, 9600, '\p{^-_box_Drawing}', "");
    Expect(1, 9600, '\P{-_box_Drawing}', "");
    Expect(0, 9600, '\P{^-_box_Drawing}', "");
    Error('\p{-/a/IS_Box_DRAWING}');
    Error('\P{-/a/IS_Box_DRAWING}');
    Expect(1, 9599, '\p{isboxdrawing}', "");
    Expect(0, 9599, '\p{^isboxdrawing}', "");
    Expect(0, 9599, '\P{isboxdrawing}', "");
    Expect(1, 9599, '\P{^isboxdrawing}', "");
    Expect(0, 9600, '\p{isboxdrawing}', "");
    Expect(1, 9600, '\p{^isboxdrawing}', "");
    Expect(1, 9600, '\P{isboxdrawing}', "");
    Expect(0, 9600, '\P{^isboxdrawing}', "");
    Expect(1, 9599, '\p{ -is_box_DRAWING}', "");
    Expect(0, 9599, '\p{^ -is_box_DRAWING}', "");
    Expect(0, 9599, '\P{ -is_box_DRAWING}', "");
    Expect(1, 9599, '\P{^ -is_box_DRAWING}', "");
    Expect(0, 9600, '\p{ -is_box_DRAWING}', "");
    Expect(1, 9600, '\p{^ -is_box_DRAWING}', "");
    Expect(1, 9600, '\P{ -is_box_DRAWING}', "");
    Expect(0, 9600, '\P{^ -is_box_DRAWING}', "");
    Error('\p{_/a/IN_Box_DRAWING}');
    Error('\P{_/a/IN_Box_DRAWING}');
    Expect(1, 9599, '\p{inboxdrawing}', "");
    Expect(0, 9599, '\p{^inboxdrawing}', "");
    Expect(0, 9599, '\P{inboxdrawing}', "");
    Expect(1, 9599, '\P{^inboxdrawing}', "");
    Expect(0, 9600, '\p{inboxdrawing}', "");
    Expect(1, 9600, '\p{^inboxdrawing}', "");
    Expect(1, 9600, '\P{inboxdrawing}', "");
    Expect(0, 9600, '\P{^inboxdrawing}', "");
    Expect(1, 9599, '\p{ _In_Box_Drawing}', "");
    Expect(0, 9599, '\p{^ _In_Box_Drawing}', "");
    Expect(0, 9599, '\P{ _In_Box_Drawing}', "");
    Expect(1, 9599, '\P{^ _In_Box_Drawing}', "");
    Expect(0, 9600, '\p{ _In_Box_Drawing}', "");
    Expect(1, 9600, '\p{^ _In_Box_Drawing}', "");
    Expect(1, 9600, '\P{ _In_Box_Drawing}', "");
    Expect(0, 9600, '\P{^ _In_Box_Drawing}', "");
    Error('\p{Brahmi/a/}');
    Error('\P{Brahmi/a/}');
    Expect(1, 69759, '\p{brahmi}', "");
    Expect(0, 69759, '\p{^brahmi}', "");
    Expect(0, 69759, '\P{brahmi}', "");
    Expect(1, 69759, '\P{^brahmi}', "");
    Expect(0, 69760, '\p{brahmi}', "");
    Expect(1, 69760, '\p{^brahmi}', "");
    Expect(1, 69760, '\P{brahmi}', "");
    Expect(0, 69760, '\P{^brahmi}', "");
    Expect(1, 69759, '\p{		BRAHMI}', "");
    Expect(0, 69759, '\p{^		BRAHMI}', "");
    Expect(0, 69759, '\P{		BRAHMI}', "");
    Expect(1, 69759, '\P{^		BRAHMI}', "");
    Expect(0, 69760, '\p{		BRAHMI}', "");
    Expect(1, 69760, '\p{^		BRAHMI}', "");
    Expect(1, 69760, '\P{		BRAHMI}', "");
    Expect(0, 69760, '\P{^		BRAHMI}', "");
    Error('\p{--is_Brahmi/a/}');
    Error('\P{--is_Brahmi/a/}');
    Expect(1, 69759, '\p{isbrahmi}', "");
    Expect(0, 69759, '\p{^isbrahmi}', "");
    Expect(0, 69759, '\P{isbrahmi}', "");
    Expect(1, 69759, '\P{^isbrahmi}', "");
    Expect(0, 69760, '\p{isbrahmi}', "");
    Expect(1, 69760, '\p{^isbrahmi}', "");
    Expect(1, 69760, '\P{isbrahmi}', "");
    Expect(0, 69760, '\P{^isbrahmi}', "");
    Expect(1, 69759, '\p{	_is_BRAHMI}', "");
    Expect(0, 69759, '\p{^	_is_BRAHMI}', "");
    Expect(0, 69759, '\P{	_is_BRAHMI}', "");
    Expect(1, 69759, '\P{^	_is_BRAHMI}', "");
    Expect(0, 69760, '\p{	_is_BRAHMI}', "");
    Expect(1, 69760, '\p{^	_is_BRAHMI}', "");
    Expect(1, 69760, '\P{	_is_BRAHMI}', "");
    Expect(0, 69760, '\P{^	_is_BRAHMI}', "");
    Error('\p{-/a/Brah}');
    Error('\P{-/a/Brah}');
    Expect(1, 69759, '\p{brah}', "");
    Expect(0, 69759, '\p{^brah}', "");
    Expect(0, 69759, '\P{brah}', "");
    Expect(1, 69759, '\P{^brah}', "");
    Expect(0, 69760, '\p{brah}', "");
    Expect(1, 69760, '\p{^brah}', "");
    Expect(1, 69760, '\P{brah}', "");
    Expect(0, 69760, '\P{^brah}', "");
    Expect(1, 69759, '\p{--Brah}', "");
    Expect(0, 69759, '\p{^--Brah}', "");
    Expect(0, 69759, '\P{--Brah}', "");
    Expect(1, 69759, '\P{^--Brah}', "");
    Expect(0, 69760, '\p{--Brah}', "");
    Expect(1, 69760, '\p{^--Brah}', "");
    Expect(1, 69760, '\P{--Brah}', "");
    Expect(0, 69760, '\P{^--Brah}', "");
    Error('\p{_	is_brah:=}');
    Error('\P{_	is_brah:=}');
    Expect(1, 69759, '\p{isbrah}', "");
    Expect(0, 69759, '\p{^isbrah}', "");
    Expect(0, 69759, '\P{isbrah}', "");
    Expect(1, 69759, '\P{^isbrah}', "");
    Expect(0, 69760, '\p{isbrah}', "");
    Expect(1, 69760, '\p{^isbrah}', "");
    Expect(1, 69760, '\P{isbrah}', "");
    Expect(0, 69760, '\P{^isbrah}', "");
    Expect(1, 69759, '\p{--IS_Brah}', "");
    Expect(0, 69759, '\p{^--IS_Brah}', "");
    Expect(0, 69759, '\P{--IS_Brah}', "");
    Expect(1, 69759, '\P{^--IS_Brah}', "");
    Expect(0, 69760, '\p{--IS_Brah}', "");
    Expect(1, 69760, '\p{^--IS_Brah}', "");
    Expect(1, 69760, '\P{--IS_Brah}', "");
    Expect(0, 69760, '\P{^--IS_Brah}', "");
    Error('\p{	_Braille:=}');
    Error('\P{	_Braille:=}');
    Expect(1, 10495, '\p{braille}', "");
    Expect(0, 10495, '\p{^braille}', "");
    Expect(0, 10495, '\P{braille}', "");
    Expect(1, 10495, '\P{^braille}', "");
    Expect(0, 10496, '\p{braille}', "");
    Expect(1, 10496, '\p{^braille}', "");
    Expect(1, 10496, '\P{braille}', "");
    Expect(0, 10496, '\P{^braille}', "");
    Expect(1, 10495, '\p{--BRAILLE}', "");
    Expect(0, 10495, '\p{^--BRAILLE}', "");
    Expect(0, 10495, '\P{--BRAILLE}', "");
    Expect(1, 10495, '\P{^--BRAILLE}', "");
    Expect(0, 10496, '\p{--BRAILLE}', "");
    Expect(1, 10496, '\p{^--BRAILLE}', "");
    Expect(1, 10496, '\P{--BRAILLE}', "");
    Expect(0, 10496, '\P{^--BRAILLE}', "");
    Error('\p{_:=Is_Braille}');
    Error('\P{_:=Is_Braille}');
    Expect(1, 10495, '\p{isbraille}', "");
    Expect(0, 10495, '\p{^isbraille}', "");
    Expect(0, 10495, '\P{isbraille}', "");
    Expect(1, 10495, '\P{^isbraille}', "");
    Expect(0, 10496, '\p{isbraille}', "");
    Expect(1, 10496, '\p{^isbraille}', "");
    Expect(1, 10496, '\P{isbraille}', "");
    Expect(0, 10496, '\P{^isbraille}', "");
    Expect(1, 10495, '\p{-Is_BRAILLE}', "");
    Expect(0, 10495, '\p{^-Is_BRAILLE}', "");
    Expect(0, 10495, '\P{-Is_BRAILLE}', "");
    Expect(1, 10495, '\P{^-Is_BRAILLE}', "");
    Expect(0, 10496, '\p{-Is_BRAILLE}', "");
    Expect(1, 10496, '\p{^-Is_BRAILLE}', "");
    Expect(1, 10496, '\P{-Is_BRAILLE}', "");
    Expect(0, 10496, '\P{^-Is_BRAILLE}', "");
    Error('\p{:=	-brai}');
    Error('\P{:=	-brai}');
    Expect(1, 10495, '\p{brai}', "");
    Expect(0, 10495, '\p{^brai}', "");
    Expect(0, 10495, '\P{brai}', "");
    Expect(1, 10495, '\P{^brai}', "");
    Expect(0, 10496, '\p{brai}', "");
    Expect(1, 10496, '\p{^brai}', "");
    Expect(1, 10496, '\P{brai}', "");
    Expect(0, 10496, '\P{^brai}', "");
    Expect(1, 10495, '\p{ brai}', "");
    Expect(0, 10495, '\p{^ brai}', "");
    Expect(0, 10495, '\P{ brai}', "");
    Expect(1, 10495, '\P{^ brai}', "");
    Expect(0, 10496, '\p{ brai}', "");
    Expect(1, 10496, '\p{^ brai}', "");
    Expect(1, 10496, '\P{ brai}', "");
    Expect(0, 10496, '\P{^ brai}', "");
    Error('\p{ -is_BRAI/a/}');
    Error('\P{ -is_BRAI/a/}');
    Expect(1, 10495, '\p{isbrai}', "");
    Expect(0, 10495, '\p{^isbrai}', "");
    Expect(0, 10495, '\P{isbrai}', "");
    Expect(1, 10495, '\P{^isbrai}', "");
    Expect(0, 10496, '\p{isbrai}', "");
    Expect(1, 10496, '\p{^isbrai}', "");
    Expect(1, 10496, '\P{isbrai}', "");
    Expect(0, 10496, '\P{^isbrai}', "");
    Expect(1, 10495, '\p{-_IS_Brai}', "");
    Expect(0, 10495, '\p{^-_IS_Brai}', "");
    Expect(0, 10495, '\P{-_IS_Brai}', "");
    Expect(1, 10495, '\P{^-_IS_Brai}', "");
    Expect(0, 10496, '\p{-_IS_Brai}', "");
    Expect(1, 10496, '\p{^-_IS_Brai}', "");
    Expect(1, 10496, '\P{-_IS_Brai}', "");
    Expect(0, 10496, '\P{^-_IS_Brai}', "");
    Error('\p{	/a/BRAILLE_PATTERNS}');
    Error('\P{	/a/BRAILLE_PATTERNS}');
    Expect(1, 10495, '\p{braillepatterns}', "");
    Expect(0, 10495, '\p{^braillepatterns}', "");
    Expect(0, 10495, '\P{braillepatterns}', "");
    Expect(1, 10495, '\P{^braillepatterns}', "");
    Expect(0, 10496, '\p{braillepatterns}', "");
    Expect(1, 10496, '\p{^braillepatterns}', "");
    Expect(1, 10496, '\P{braillepatterns}', "");
    Expect(0, 10496, '\P{^braillepatterns}', "");
    Expect(1, 10495, '\p{-	Braille_patterns}', "");
    Expect(0, 10495, '\p{^-	Braille_patterns}', "");
    Expect(0, 10495, '\P{-	Braille_patterns}', "");
    Expect(1, 10495, '\P{^-	Braille_patterns}', "");
    Expect(0, 10496, '\p{-	Braille_patterns}', "");
    Expect(1, 10496, '\p{^-	Braille_patterns}', "");
    Expect(1, 10496, '\P{-	Braille_patterns}', "");
    Expect(0, 10496, '\P{^-	Braille_patterns}', "");
    Error('\p{/a/		IS_Braille_patterns}');
    Error('\P{/a/		IS_Braille_patterns}');
    Expect(1, 10495, '\p{isbraillepatterns}', "");
    Expect(0, 10495, '\p{^isbraillepatterns}', "");
    Expect(0, 10495, '\P{isbraillepatterns}', "");
    Expect(1, 10495, '\P{^isbraillepatterns}', "");
    Expect(0, 10496, '\p{isbraillepatterns}', "");
    Expect(1, 10496, '\p{^isbraillepatterns}', "");
    Expect(1, 10496, '\P{isbraillepatterns}', "");
    Expect(0, 10496, '\P{^isbraillepatterns}', "");
    Expect(1, 10495, '\p{_	Is_braille_Patterns}', "");
    Expect(0, 10495, '\p{^_	Is_braille_Patterns}', "");
    Expect(0, 10495, '\P{_	Is_braille_Patterns}', "");
    Expect(1, 10495, '\P{^_	Is_braille_Patterns}', "");
    Expect(0, 10496, '\p{_	Is_braille_Patterns}', "");
    Expect(1, 10496, '\p{^_	Is_braille_Patterns}', "");
    Expect(1, 10496, '\P{_	Is_braille_Patterns}', "");
    Expect(0, 10496, '\P{^_	Is_braille_Patterns}', "");
    Error('\p{:=in_Braille_PATTERNS}');
    Error('\P{:=in_Braille_PATTERNS}');
    Expect(1, 10495, '\p{inbraillepatterns}', "");
    Expect(0, 10495, '\p{^inbraillepatterns}', "");
    Expect(0, 10495, '\P{inbraillepatterns}', "");
    Expect(1, 10495, '\P{^inbraillepatterns}', "");
    Expect(0, 10496, '\p{inbraillepatterns}', "");
    Expect(1, 10496, '\p{^inbraillepatterns}', "");
    Expect(1, 10496, '\P{inbraillepatterns}', "");
    Expect(0, 10496, '\P{^inbraillepatterns}', "");
    Expect(1, 10495, '\p{		In_BRAILLE_PATTERNS}', "");
    Expect(0, 10495, '\p{^		In_BRAILLE_PATTERNS}', "");
    Expect(0, 10495, '\P{		In_BRAILLE_PATTERNS}', "");
    Expect(1, 10495, '\P{^		In_BRAILLE_PATTERNS}', "");
    Expect(0, 10496, '\p{		In_BRAILLE_PATTERNS}', "");
    Expect(1, 10496, '\p{^		In_BRAILLE_PATTERNS}', "");
    Expect(1, 10496, '\P{		In_BRAILLE_PATTERNS}', "");
    Expect(0, 10496, '\P{^		In_BRAILLE_PATTERNS}', "");
    Error('\p{/a/	 IN_Braille}');
    Error('\P{/a/	 IN_Braille}');
    Expect(1, 10495, '\p{inbraille}', "");
    Expect(0, 10495, '\p{^inbraille}', "");
    Expect(0, 10495, '\P{inbraille}', "");
    Expect(1, 10495, '\P{^inbraille}', "");
    Expect(0, 10496, '\p{inbraille}', "");
    Expect(1, 10496, '\p{^inbraille}', "");
    Expect(1, 10496, '\P{inbraille}', "");
    Expect(0, 10496, '\P{^inbraille}', "");
    Expect(1, 10495, '\p{	_In_Braille}', "");
    Expect(0, 10495, '\p{^	_In_Braille}', "");
    Expect(0, 10495, '\P{	_In_Braille}', "");
    Expect(1, 10495, '\P{^	_In_Braille}', "");
    Expect(0, 10496, '\p{	_In_Braille}', "");
    Expect(1, 10496, '\p{^	_In_Braille}', "");
    Expect(1, 10496, '\P{	_In_Braille}', "");
    Expect(0, 10496, '\P{^	_In_Braille}', "");
    Error('\p{:=Buginese}');
    Error('\P{:=Buginese}');
    Expect(1, 43471, '\p{buginese}', "");
    Expect(0, 43471, '\p{^buginese}', "");
    Expect(0, 43471, '\P{buginese}', "");
    Expect(1, 43471, '\P{^buginese}', "");
    Expect(0, 43472, '\p{buginese}', "");
    Expect(1, 43472, '\p{^buginese}', "");
    Expect(1, 43472, '\P{buginese}', "");
    Expect(0, 43472, '\P{^buginese}', "");
    Expect(1, 43471, '\p{-Buginese}', "");
    Expect(0, 43471, '\p{^-Buginese}', "");
    Expect(0, 43471, '\P{-Buginese}', "");
    Expect(1, 43471, '\P{^-Buginese}', "");
    Expect(0, 43472, '\p{-Buginese}', "");
    Expect(1, 43472, '\p{^-Buginese}', "");
    Expect(1, 43472, '\P{-Buginese}', "");
    Expect(0, 43472, '\P{^-Buginese}', "");
    Error('\p{_	Is_Buginese:=}');
    Error('\P{_	Is_Buginese:=}');
    Expect(1, 43471, '\p{isbuginese}', "");
    Expect(0, 43471, '\p{^isbuginese}', "");
    Expect(0, 43471, '\P{isbuginese}', "");
    Expect(1, 43471, '\P{^isbuginese}', "");
    Expect(0, 43472, '\p{isbuginese}', "");
    Expect(1, 43472, '\p{^isbuginese}', "");
    Expect(1, 43472, '\P{isbuginese}', "");
    Expect(0, 43472, '\P{^isbuginese}', "");
    Expect(1, 43471, '\p{--Is_BUGINESE}', "");
    Expect(0, 43471, '\p{^--Is_BUGINESE}', "");
    Expect(0, 43471, '\P{--Is_BUGINESE}', "");
    Expect(1, 43471, '\P{^--Is_BUGINESE}', "");
    Expect(0, 43472, '\p{--Is_BUGINESE}', "");
    Expect(1, 43472, '\p{^--Is_BUGINESE}', "");
    Expect(1, 43472, '\P{--Is_BUGINESE}', "");
    Expect(0, 43472, '\P{^--Is_BUGINESE}', "");
    Error('\p{/a/	BUGI}');
    Error('\P{/a/	BUGI}');
    Expect(1, 43471, '\p{bugi}', "");
    Expect(0, 43471, '\p{^bugi}', "");
    Expect(0, 43471, '\P{bugi}', "");
    Expect(1, 43471, '\P{^bugi}', "");
    Expect(0, 43472, '\p{bugi}', "");
    Expect(1, 43472, '\p{^bugi}', "");
    Expect(1, 43472, '\P{bugi}', "");
    Expect(0, 43472, '\P{^bugi}', "");
    Expect(1, 43471, '\p{	 Bugi}', "");
    Expect(0, 43471, '\p{^	 Bugi}', "");
    Expect(0, 43471, '\P{	 Bugi}', "");
    Expect(1, 43471, '\P{^	 Bugi}', "");
    Expect(0, 43472, '\p{	 Bugi}', "");
    Expect(1, 43472, '\p{^	 Bugi}', "");
    Expect(1, 43472, '\P{	 Bugi}', "");
    Expect(0, 43472, '\P{^	 Bugi}', "");
    Error('\p{-_Is_bugi/a/}');
    Error('\P{-_Is_bugi/a/}');
    Expect(1, 43471, '\p{isbugi}', "");
    Expect(0, 43471, '\p{^isbugi}', "");
    Expect(0, 43471, '\P{isbugi}', "");
    Expect(1, 43471, '\P{^isbugi}', "");
    Expect(0, 43472, '\p{isbugi}', "");
    Expect(1, 43472, '\p{^isbugi}', "");
    Expect(1, 43472, '\P{isbugi}', "");
    Expect(0, 43472, '\P{^isbugi}', "");
    Expect(1, 43471, '\p{		IS_Bugi}', "");
    Expect(0, 43471, '\p{^		IS_Bugi}', "");
    Expect(0, 43471, '\P{		IS_Bugi}', "");
    Expect(1, 43471, '\P{^		IS_Bugi}', "");
    Expect(0, 43472, '\p{		IS_Bugi}', "");
    Expect(1, 43472, '\p{^		IS_Bugi}', "");
    Expect(1, 43472, '\P{		IS_Bugi}', "");
    Expect(0, 43472, '\P{^		IS_Bugi}', "");
    Error('\p{--buhid/a/}');
    Error('\P{--buhid/a/}');
    Expect(1, 5971, '\p{buhid}', "");
    Expect(0, 5971, '\p{^buhid}', "");
    Expect(0, 5971, '\P{buhid}', "");
    Expect(1, 5971, '\P{^buhid}', "");
    Expect(0, 5972, '\p{buhid}', "");
    Expect(1, 5972, '\p{^buhid}', "");
    Expect(1, 5972, '\P{buhid}', "");
    Expect(0, 5972, '\P{^buhid}', "");
    Expect(1, 5971, '\p{_ Buhid}', "");
    Expect(0, 5971, '\p{^_ Buhid}', "");
    Expect(0, 5971, '\P{_ Buhid}', "");
    Expect(1, 5971, '\P{^_ Buhid}', "");
    Expect(0, 5972, '\p{_ Buhid}', "");
    Expect(1, 5972, '\p{^_ Buhid}', "");
    Expect(1, 5972, '\P{_ Buhid}', "");
    Expect(0, 5972, '\P{^_ Buhid}', "");
    Error('\p{:=  is_Buhid}');
    Error('\P{:=  is_Buhid}');
    Expect(1, 5971, '\p{isbuhid}', "");
    Expect(0, 5971, '\p{^isbuhid}', "");
    Expect(0, 5971, '\P{isbuhid}', "");
    Expect(1, 5971, '\P{^isbuhid}', "");
    Expect(0, 5972, '\p{isbuhid}', "");
    Expect(1, 5972, '\p{^isbuhid}', "");
    Expect(1, 5972, '\P{isbuhid}', "");
    Expect(0, 5972, '\P{^isbuhid}', "");
    Expect(1, 5971, '\p{  Is_buhid}', "");
    Expect(0, 5971, '\p{^  Is_buhid}', "");
    Expect(0, 5971, '\P{  Is_buhid}', "");
    Expect(1, 5971, '\P{^  Is_buhid}', "");
    Expect(0, 5972, '\p{  Is_buhid}', "");
    Expect(1, 5972, '\p{^  Is_buhid}', "");
    Expect(1, 5972, '\P{  Is_buhid}', "");
    Expect(0, 5972, '\P{^  Is_buhid}', "");
    Error('\p{/a/	 buhd}');
    Error('\P{/a/	 buhd}');
    Expect(1, 5971, '\p{buhd}', "");
    Expect(0, 5971, '\p{^buhd}', "");
    Expect(0, 5971, '\P{buhd}', "");
    Expect(1, 5971, '\P{^buhd}', "");
    Expect(0, 5972, '\p{buhd}', "");
    Expect(1, 5972, '\p{^buhd}', "");
    Expect(1, 5972, '\P{buhd}', "");
    Expect(0, 5972, '\P{^buhd}', "");
    Expect(1, 5971, '\p{  buhd}', "");
    Expect(0, 5971, '\p{^  buhd}', "");
    Expect(0, 5971, '\P{  buhd}', "");
    Expect(1, 5971, '\P{^  buhd}', "");
    Expect(0, 5972, '\p{  buhd}', "");
    Expect(1, 5972, '\p{^  buhd}', "");
    Expect(1, 5972, '\P{  buhd}', "");
    Expect(0, 5972, '\P{^  buhd}', "");
    Error('\p{/a/ IS_Buhd}');
    Error('\P{/a/ IS_Buhd}');
    Expect(1, 5971, '\p{isbuhd}', "");
    Expect(0, 5971, '\p{^isbuhd}', "");
    Expect(0, 5971, '\P{isbuhd}', "");
    Expect(1, 5971, '\P{^isbuhd}', "");
    Expect(0, 5972, '\p{isbuhd}', "");
    Expect(1, 5972, '\p{^isbuhd}', "");
    Expect(1, 5972, '\P{isbuhd}', "");
    Expect(0, 5972, '\P{^isbuhd}', "");
    Expect(1, 5971, '\p{ -is_Buhd}', "");
    Expect(0, 5971, '\p{^ -is_Buhd}', "");
    Expect(0, 5971, '\P{ -is_Buhd}', "");
    Expect(1, 5971, '\P{^ -is_Buhd}', "");
    Expect(0, 5972, '\p{ -is_Buhd}', "");
    Expect(1, 5972, '\p{^ -is_Buhd}', "");
    Expect(1, 5972, '\P{ -is_Buhd}', "");
    Expect(0, 5972, '\P{^ -is_Buhd}', "");
    Error('\p{- Byzantine_Musical_Symbols/a/}');
    Error('\P{- Byzantine_Musical_Symbols/a/}');
    Expect(1, 119039, '\p{byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\p{^byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\P{byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\P{^byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\p{byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\p{^byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\P{byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\P{^byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\p{_Byzantine_musical_SYMBOLS}', "");
    Expect(0, 119039, '\p{^_Byzantine_musical_SYMBOLS}', "");
    Expect(0, 119039, '\P{_Byzantine_musical_SYMBOLS}', "");
    Expect(1, 119039, '\P{^_Byzantine_musical_SYMBOLS}', "");
    Expect(0, 119040, '\p{_Byzantine_musical_SYMBOLS}', "");
    Expect(1, 119040, '\p{^_Byzantine_musical_SYMBOLS}', "");
    Expect(1, 119040, '\P{_Byzantine_musical_SYMBOLS}', "");
    Expect(0, 119040, '\P{^_Byzantine_musical_SYMBOLS}', "");
    Error('\p{-:=is_Byzantine_MUSICAL_Symbols}');
    Error('\P{-:=is_Byzantine_MUSICAL_Symbols}');
    Expect(1, 119039, '\p{isbyzantinemusicalsymbols}', "");
    Expect(0, 119039, '\p{^isbyzantinemusicalsymbols}', "");
    Expect(0, 119039, '\P{isbyzantinemusicalsymbols}', "");
    Expect(1, 119039, '\P{^isbyzantinemusicalsymbols}', "");
    Expect(0, 119040, '\p{isbyzantinemusicalsymbols}', "");
    Expect(1, 119040, '\p{^isbyzantinemusicalsymbols}', "");
    Expect(1, 119040, '\P{isbyzantinemusicalsymbols}', "");
    Expect(0, 119040, '\P{^isbyzantinemusicalsymbols}', "");
    Expect(1, 119039, '\p{	 is_Byzantine_musical_SYMBOLS}', "");
    Expect(0, 119039, '\p{^	 is_Byzantine_musical_SYMBOLS}', "");
    Expect(0, 119039, '\P{	 is_Byzantine_musical_SYMBOLS}', "");
    Expect(1, 119039, '\P{^	 is_Byzantine_musical_SYMBOLS}', "");
    Expect(0, 119040, '\p{	 is_Byzantine_musical_SYMBOLS}', "");
    Expect(1, 119040, '\p{^	 is_Byzantine_musical_SYMBOLS}', "");
    Expect(1, 119040, '\P{	 is_Byzantine_musical_SYMBOLS}', "");
    Expect(0, 119040, '\P{^	 is_Byzantine_musical_SYMBOLS}', "");
    Error('\p{	-In_Byzantine_MUSICAL_Symbols/a/}');
    Error('\P{	-In_Byzantine_MUSICAL_Symbols/a/}');
    Expect(1, 119039, '\p{inbyzantinemusicalsymbols}', "");
    Expect(0, 119039, '\p{^inbyzantinemusicalsymbols}', "");
    Expect(0, 119039, '\P{inbyzantinemusicalsymbols}', "");
    Expect(1, 119039, '\P{^inbyzantinemusicalsymbols}', "");
    Expect(0, 119040, '\p{inbyzantinemusicalsymbols}', "");
    Expect(1, 119040, '\p{^inbyzantinemusicalsymbols}', "");
    Expect(1, 119040, '\P{inbyzantinemusicalsymbols}', "");
    Expect(0, 119040, '\P{^inbyzantinemusicalsymbols}', "");
    Expect(1, 119039, '\p{  In_BYZANTINE_musical_Symbols}', "");
    Expect(0, 119039, '\p{^  In_BYZANTINE_musical_Symbols}', "");
    Expect(0, 119039, '\P{  In_BYZANTINE_musical_Symbols}', "");
    Expect(1, 119039, '\P{^  In_BYZANTINE_musical_Symbols}', "");
    Expect(0, 119040, '\p{  In_BYZANTINE_musical_Symbols}', "");
    Expect(1, 119040, '\p{^  In_BYZANTINE_musical_Symbols}', "");
    Expect(1, 119040, '\P{  In_BYZANTINE_musical_Symbols}', "");
    Expect(0, 119040, '\P{^  In_BYZANTINE_musical_Symbols}', "");
    Error('\p{:=	Byzantine_Music}');
    Error('\P{:=	Byzantine_Music}');
    Expect(1, 119039, '\p{byzantinemusic}', "");
    Expect(0, 119039, '\p{^byzantinemusic}', "");
    Expect(0, 119039, '\P{byzantinemusic}', "");
    Expect(1, 119039, '\P{^byzantinemusic}', "");
    Expect(0, 119040, '\p{byzantinemusic}', "");
    Expect(1, 119040, '\p{^byzantinemusic}', "");
    Expect(1, 119040, '\P{byzantinemusic}', "");
    Expect(0, 119040, '\P{^byzantinemusic}', "");
    Expect(1, 119039, '\p{	_byzantine_music}', "");
    Expect(0, 119039, '\p{^	_byzantine_music}', "");
    Expect(0, 119039, '\P{	_byzantine_music}', "");
    Expect(1, 119039, '\P{^	_byzantine_music}', "");
    Expect(0, 119040, '\p{	_byzantine_music}', "");
    Expect(1, 119040, '\p{^	_byzantine_music}', "");
    Expect(1, 119040, '\P{	_byzantine_music}', "");
    Expect(0, 119040, '\P{^	_byzantine_music}', "");
    Error('\p{:=_ IS_byzantine_MUSIC}');
    Error('\P{:=_ IS_byzantine_MUSIC}');
    Expect(1, 119039, '\p{isbyzantinemusic}', "");
    Expect(0, 119039, '\p{^isbyzantinemusic}', "");
    Expect(0, 119039, '\P{isbyzantinemusic}', "");
    Expect(1, 119039, '\P{^isbyzantinemusic}', "");
    Expect(0, 119040, '\p{isbyzantinemusic}', "");
    Expect(1, 119040, '\p{^isbyzantinemusic}', "");
    Expect(1, 119040, '\P{isbyzantinemusic}', "");
    Expect(0, 119040, '\P{^isbyzantinemusic}', "");
    Expect(1, 119039, '\p{  is_byzantine_music}', "");
    Expect(0, 119039, '\p{^  is_byzantine_music}', "");
    Expect(0, 119039, '\P{  is_byzantine_music}', "");
    Expect(1, 119039, '\P{^  is_byzantine_music}', "");
    Expect(0, 119040, '\p{  is_byzantine_music}', "");
    Expect(1, 119040, '\p{^  is_byzantine_music}', "");
    Expect(1, 119040, '\P{  is_byzantine_music}', "");
    Expect(0, 119040, '\P{^  is_byzantine_music}', "");
    Error('\p{/a/_	In_BYZANTINE_Music}');
    Error('\P{/a/_	In_BYZANTINE_Music}');
    Expect(1, 119039, '\p{inbyzantinemusic}', "");
    Expect(0, 119039, '\p{^inbyzantinemusic}', "");
    Expect(0, 119039, '\P{inbyzantinemusic}', "");
    Expect(1, 119039, '\P{^inbyzantinemusic}', "");
    Expect(0, 119040, '\p{inbyzantinemusic}', "");
    Expect(1, 119040, '\p{^inbyzantinemusic}', "");
    Expect(1, 119040, '\P{inbyzantinemusic}', "");
    Expect(0, 119040, '\P{^inbyzantinemusic}', "");
    Expect(1, 119039, '\p{	In_Byzantine_Music}', "");
    Expect(0, 119039, '\p{^	In_Byzantine_Music}', "");
    Expect(0, 119039, '\P{	In_Byzantine_Music}', "");
    Expect(1, 119039, '\P{^	In_Byzantine_Music}', "");
    Expect(0, 119040, '\p{	In_Byzantine_Music}', "");
    Expect(1, 119040, '\p{^	In_Byzantine_Music}', "");
    Expect(1, 119040, '\P{	In_Byzantine_Music}', "");
    Expect(0, 119040, '\P{^	In_Byzantine_Music}', "");
    Error('\p{/a/	-CANADIAN_Aboriginal}');
    Error('\P{/a/	-CANADIAN_Aboriginal}');
    Expect(1, 6389, '\p{canadianaboriginal}', "");
    Expect(0, 6389, '\p{^canadianaboriginal}', "");
    Expect(0, 6389, '\P{canadianaboriginal}', "");
    Expect(1, 6389, '\P{^canadianaboriginal}', "");
    Expect(0, 6390, '\p{canadianaboriginal}', "");
    Expect(1, 6390, '\p{^canadianaboriginal}', "");
    Expect(1, 6390, '\P{canadianaboriginal}', "");
    Expect(0, 6390, '\P{^canadianaboriginal}', "");
    Expect(1, 6389, '\p{ 	canadian_aboriginal}', "");
    Expect(0, 6389, '\p{^ 	canadian_aboriginal}', "");
    Expect(0, 6389, '\P{ 	canadian_aboriginal}', "");
    Expect(1, 6389, '\P{^ 	canadian_aboriginal}', "");
    Expect(0, 6390, '\p{ 	canadian_aboriginal}', "");
    Expect(1, 6390, '\p{^ 	canadian_aboriginal}', "");
    Expect(1, 6390, '\P{ 	canadian_aboriginal}', "");
    Expect(0, 6390, '\P{^ 	canadian_aboriginal}', "");
    Error('\p{:= -Is_CANADIAN_Aboriginal}');
    Error('\P{:= -Is_CANADIAN_Aboriginal}');
    Expect(1, 6389, '\p{iscanadianaboriginal}', "");
    Expect(0, 6389, '\p{^iscanadianaboriginal}', "");
    Expect(0, 6389, '\P{iscanadianaboriginal}', "");
    Expect(1, 6389, '\P{^iscanadianaboriginal}', "");
    Expect(0, 6390, '\p{iscanadianaboriginal}', "");
    Expect(1, 6390, '\p{^iscanadianaboriginal}', "");
    Expect(1, 6390, '\P{iscanadianaboriginal}', "");
    Expect(0, 6390, '\P{^iscanadianaboriginal}', "");
    Expect(1, 6389, '\p{-	IS_Canadian_Aboriginal}', "");
    Expect(0, 6389, '\p{^-	IS_Canadian_Aboriginal}', "");
    Expect(0, 6389, '\P{-	IS_Canadian_Aboriginal}', "");
    Expect(1, 6389, '\P{^-	IS_Canadian_Aboriginal}', "");
    Expect(0, 6390, '\p{-	IS_Canadian_Aboriginal}', "");
    Expect(1, 6390, '\p{^-	IS_Canadian_Aboriginal}', "");
    Expect(1, 6390, '\P{-	IS_Canadian_Aboriginal}', "");
    Expect(0, 6390, '\P{^-	IS_Canadian_Aboriginal}', "");
    Error('\p{_cans:=}');
    Error('\P{_cans:=}');
    Expect(1, 6389, '\p{cans}', "");
    Expect(0, 6389, '\p{^cans}', "");
    Expect(0, 6389, '\P{cans}', "");
    Expect(1, 6389, '\P{^cans}', "");
    Expect(0, 6390, '\p{cans}', "");
    Expect(1, 6390, '\p{^cans}', "");
    Expect(1, 6390, '\P{cans}', "");
    Expect(0, 6390, '\P{^cans}', "");
    Expect(1, 6389, '\p{	Cans}', "");
    Expect(0, 6389, '\p{^	Cans}', "");
    Expect(0, 6389, '\P{	Cans}', "");
    Expect(1, 6389, '\P{^	Cans}', "");
    Expect(0, 6390, '\p{	Cans}', "");
    Expect(1, 6390, '\p{^	Cans}', "");
    Expect(1, 6390, '\P{	Cans}', "");
    Expect(0, 6390, '\P{^	Cans}', "");
    Error('\p{	-is_CANS/a/}');
    Error('\P{	-is_CANS/a/}');
    Expect(1, 6389, '\p{iscans}', "");
    Expect(0, 6389, '\p{^iscans}', "");
    Expect(0, 6389, '\P{iscans}', "");
    Expect(1, 6389, '\P{^iscans}', "");
    Expect(0, 6390, '\p{iscans}', "");
    Expect(1, 6390, '\p{^iscans}', "");
    Expect(1, 6390, '\P{iscans}', "");
    Expect(0, 6390, '\P{^iscans}', "");
    Expect(1, 6389, '\p{- Is_CANS}', "");
    Expect(0, 6389, '\p{^- Is_CANS}', "");
    Expect(0, 6389, '\P{- Is_CANS}', "");
    Expect(1, 6389, '\P{^- Is_CANS}', "");
    Expect(0, 6390, '\p{- Is_CANS}', "");
    Expect(1, 6390, '\p{^- Is_CANS}', "");
    Expect(1, 6390, '\P{- Is_CANS}', "");
    Expect(0, 6390, '\P{^- Is_CANS}', "");
    Error('\p{-/a/carian}');
    Error('\P{-/a/carian}');
    Expect(1, 66256, '\p{carian}', "");
    Expect(0, 66256, '\p{^carian}', "");
    Expect(0, 66256, '\P{carian}', "");
    Expect(1, 66256, '\P{^carian}', "");
    Expect(0, 66257, '\p{carian}', "");
    Expect(1, 66257, '\p{^carian}', "");
    Expect(1, 66257, '\P{carian}', "");
    Expect(0, 66257, '\P{^carian}', "");
    Expect(1, 66256, '\p{__Carian}', "");
    Expect(0, 66256, '\p{^__Carian}', "");
    Expect(0, 66256, '\P{__Carian}', "");
    Expect(1, 66256, '\P{^__Carian}', "");
    Expect(0, 66257, '\p{__Carian}', "");
    Expect(1, 66257, '\p{^__Carian}', "");
    Expect(1, 66257, '\P{__Carian}', "");
    Expect(0, 66257, '\P{^__Carian}', "");
    Error('\p{/a/	 Is_Carian}');
    Error('\P{/a/	 Is_Carian}');
    Expect(1, 66256, '\p{iscarian}', "");
    Expect(0, 66256, '\p{^iscarian}', "");
    Expect(0, 66256, '\P{iscarian}', "");
    Expect(1, 66256, '\P{^iscarian}', "");
    Expect(0, 66257, '\p{iscarian}', "");
    Expect(1, 66257, '\p{^iscarian}', "");
    Expect(1, 66257, '\P{iscarian}', "");
    Expect(0, 66257, '\P{^iscarian}', "");
    Expect(1, 66256, '\p{  Is_Carian}', "");
    Expect(0, 66256, '\p{^  Is_Carian}', "");
    Expect(0, 66256, '\P{  Is_Carian}', "");
    Expect(1, 66256, '\P{^  Is_Carian}', "");
    Expect(0, 66257, '\p{  Is_Carian}', "");
    Expect(1, 66257, '\p{^  Is_Carian}', "");
    Expect(1, 66257, '\P{  Is_Carian}', "");
    Expect(0, 66257, '\P{^  Is_Carian}', "");
    Error('\p{-_CARI:=}');
    Error('\P{-_CARI:=}');
    Expect(1, 66256, '\p{cari}', "");
    Expect(0, 66256, '\p{^cari}', "");
    Expect(0, 66256, '\P{cari}', "");
    Expect(1, 66256, '\P{^cari}', "");
    Expect(0, 66257, '\p{cari}', "");
    Expect(1, 66257, '\p{^cari}', "");
    Expect(1, 66257, '\P{cari}', "");
    Expect(0, 66257, '\P{^cari}', "");
    Expect(1, 66256, '\p{- cari}', "");
    Expect(0, 66256, '\p{^- cari}', "");
    Expect(0, 66256, '\P{- cari}', "");
    Expect(1, 66256, '\P{^- cari}', "");
    Expect(0, 66257, '\p{- cari}', "");
    Expect(1, 66257, '\p{^- cari}', "");
    Expect(1, 66257, '\P{- cari}', "");
    Expect(0, 66257, '\P{^- cari}', "");
    Error('\p{	Is_cari/a/}');
    Error('\P{	Is_cari/a/}');
    Expect(1, 66256, '\p{iscari}', "");
    Expect(0, 66256, '\p{^iscari}', "");
    Expect(0, 66256, '\P{iscari}', "");
    Expect(1, 66256, '\P{^iscari}', "");
    Expect(0, 66257, '\p{iscari}', "");
    Expect(1, 66257, '\p{^iscari}', "");
    Expect(1, 66257, '\P{iscari}', "");
    Expect(0, 66257, '\P{^iscari}', "");
    Expect(1, 66256, '\p{	IS_Cari}', "");
    Expect(0, 66256, '\p{^	IS_Cari}', "");
    Expect(0, 66256, '\P{	IS_Cari}', "");
    Expect(1, 66256, '\P{^	IS_Cari}', "");
    Expect(0, 66257, '\p{	IS_Cari}', "");
    Expect(1, 66257, '\p{^	IS_Cari}', "");
    Expect(1, 66257, '\P{	IS_Cari}', "");
    Expect(0, 66257, '\P{^	IS_Cari}', "");
    Error('\p{/a/-cased}');
    Error('\P{/a/-cased}');
    Expect(1, 127369, '\p{cased}', "");
    Expect(0, 127369, '\p{^cased}', "");
    Expect(0, 127369, '\P{cased}', "");
    Expect(1, 127369, '\P{^cased}', "");
    Expect(0, 127370, '\p{cased}', "");
    Expect(1, 127370, '\p{^cased}', "");
    Expect(1, 127370, '\P{cased}', "");
    Expect(0, 127370, '\P{^cased}', "");
    Expect(1, 127369, '\p{_-CASED}', "");
    Expect(0, 127369, '\p{^_-CASED}', "");
    Expect(0, 127369, '\P{_-CASED}', "");
    Expect(1, 127369, '\P{^_-CASED}', "");
    Expect(0, 127370, '\p{_-CASED}', "");
    Expect(1, 127370, '\p{^_-CASED}', "");
    Expect(1, 127370, '\P{_-CASED}', "");
    Expect(0, 127370, '\P{^_-CASED}', "");
    Error('\p{	 Is_Cased:=}');
    Error('\P{	 Is_Cased:=}');
    Expect(1, 127369, '\p{iscased}', "");
    Expect(0, 127369, '\p{^iscased}', "");
    Expect(0, 127369, '\P{iscased}', "");
    Expect(1, 127369, '\P{^iscased}', "");
    Expect(0, 127370, '\p{iscased}', "");
    Expect(1, 127370, '\p{^iscased}', "");
    Expect(1, 127370, '\P{iscased}', "");
    Expect(0, 127370, '\P{^iscased}', "");
    Expect(1, 127369, '\p{	 Is_CASED}', "");
    Expect(0, 127369, '\p{^	 Is_CASED}', "");
    Expect(0, 127369, '\P{	 Is_CASED}', "");
    Expect(1, 127369, '\P{^	 Is_CASED}', "");
    Expect(0, 127370, '\p{	 Is_CASED}', "");
    Expect(1, 127370, '\p{^	 Is_CASED}', "");
    Expect(1, 127370, '\P{	 Is_CASED}', "");
    Expect(0, 127370, '\P{^	 Is_CASED}', "");
    Error('\p{/a/Cased_Letter}');
    Error('\P{/a/Cased_Letter}');
    Expect(1, 125251, '\p{casedletter}', "");
    Expect(0, 125251, '\p{^casedletter}', "");
    Expect(0, 125251, '\P{casedletter}', "");
    Expect(1, 125251, '\P{^casedletter}', "");
    Expect(0, 125252, '\p{casedletter}', "");
    Expect(1, 125252, '\p{^casedletter}', "");
    Expect(1, 125252, '\P{casedletter}', "");
    Expect(0, 125252, '\P{^casedletter}', "");
    Expect(1, 125251, '\p{ cased_LETTER}', "");
    Expect(0, 125251, '\p{^ cased_LETTER}', "");
    Expect(0, 125251, '\P{ cased_LETTER}', "");
    Expect(1, 125251, '\P{^ cased_LETTER}', "");
    Expect(0, 125252, '\p{ cased_LETTER}', "");
    Expect(1, 125252, '\p{^ cased_LETTER}', "");
    Expect(1, 125252, '\P{ cased_LETTER}', "");
    Expect(0, 125252, '\P{^ cased_LETTER}', "");
    Error('\p{_/a/Is_Cased_LETTER}');
    Error('\P{_/a/Is_Cased_LETTER}');
    Expect(1, 125251, '\p{iscasedletter}', "");
    Expect(0, 125251, '\p{^iscasedletter}', "");
    Expect(0, 125251, '\P{iscasedletter}', "");
    Expect(1, 125251, '\P{^iscasedletter}', "");
    Expect(0, 125252, '\p{iscasedletter}', "");
    Expect(1, 125252, '\p{^iscasedletter}', "");
    Expect(1, 125252, '\P{iscasedletter}', "");
    Expect(0, 125252, '\P{^iscasedletter}', "");
    Expect(1, 125251, '\p{-	IS_Cased_LETTER}', "");
    Expect(0, 125251, '\p{^-	IS_Cased_LETTER}', "");
    Expect(0, 125251, '\P{-	IS_Cased_LETTER}', "");
    Expect(1, 125251, '\P{^-	IS_Cased_LETTER}', "");
    Expect(0, 125252, '\p{-	IS_Cased_LETTER}', "");
    Expect(1, 125252, '\p{^-	IS_Cased_LETTER}', "");
    Expect(1, 125252, '\P{-	IS_Cased_LETTER}', "");
    Expect(0, 125252, '\P{^-	IS_Cased_LETTER}', "");
    Error('\p{_-LC:=}');
    Error('\P{_-LC:=}');
    Expect(1, 125251, '\p{lc}', "");
    Expect(0, 125251, '\p{^lc}', "");
    Expect(0, 125251, '\P{lc}', "");
    Expect(1, 125251, '\P{^lc}', "");
    Expect(0, 125252, '\p{lc}', "");
    Expect(1, 125252, '\p{^lc}', "");
    Expect(1, 125252, '\P{lc}', "");
    Expect(0, 125252, '\P{^lc}', "");
    Expect(1, 125251, '\p{_	LC}', "");
    Expect(0, 125251, '\p{^_	LC}', "");
    Expect(0, 125251, '\P{_	LC}', "");
    Expect(1, 125251, '\P{^_	LC}', "");
    Expect(0, 125252, '\p{_	LC}', "");
    Expect(1, 125252, '\p{^_	LC}', "");
    Expect(1, 125252, '\P{_	LC}', "");
    Expect(0, 125252, '\P{^_	LC}', "");
    Error('\p{-:=IS_LC}');
    Error('\P{-:=IS_LC}');
    Expect(1, 125251, '\p{islc}', "");
    Expect(0, 125251, '\p{^islc}', "");
    Expect(0, 125251, '\P{islc}', "");
    Expect(1, 125251, '\P{^islc}', "");
    Expect(0, 125252, '\p{islc}', "");
    Expect(1, 125252, '\p{^islc}', "");
    Expect(1, 125252, '\P{islc}', "");
    Expect(0, 125252, '\P{^islc}', "");
    Expect(1, 125251, '\p{_Is_LC}', "");
    Expect(0, 125251, '\p{^_Is_LC}', "");
    Expect(0, 125251, '\P{_Is_LC}', "");
    Expect(1, 125251, '\P{^_Is_LC}', "");
    Expect(0, 125252, '\p{_Is_LC}', "");
    Expect(1, 125252, '\p{^_Is_LC}', "");
    Expect(1, 125252, '\P{_Is_LC}', "");
    Expect(0, 125252, '\P{^_Is_LC}', "");
    Error('\p{__L_/a/}');
    Error('\P{__L_/a/}');
    Expect(1, 125251, '\p{l_}', "");
    Expect(0, 125251, '\p{^l_}', "");
    Expect(0, 125251, '\P{l_}', "");
    Expect(1, 125251, '\P{^l_}', "");
    Expect(0, 125252, '\p{l_}', "");
    Expect(1, 125252, '\p{^l_}', "");
    Expect(1, 125252, '\P{l_}', "");
    Expect(0, 125252, '\P{^l_}', "");
    Expect(1, 125251, '\p{_ L_}', "");
    Expect(0, 125251, '\p{^_ L_}', "");
    Expect(0, 125251, '\P{_ L_}', "");
    Expect(1, 125251, '\P{^_ L_}', "");
    Expect(0, 125252, '\p{_ L_}', "");
    Expect(1, 125252, '\p{^_ L_}', "");
    Expect(1, 125252, '\P{_ L_}', "");
    Expect(0, 125252, '\P{^_ L_}', "");
    Error('\p{:= IS_l_}');
    Error('\P{:= IS_l_}');
    Expect(1, 125251, '\p{isl_}', "");
    Expect(0, 125251, '\p{^isl_}', "");
    Expect(0, 125251, '\P{isl_}', "");
    Expect(1, 125251, '\P{^isl_}', "");
    Expect(0, 125252, '\p{isl_}', "");
    Expect(1, 125252, '\p{^isl_}', "");
    Expect(1, 125252, '\P{isl_}', "");
    Expect(0, 125252, '\P{^isl_}', "");
    Expect(1, 125251, '\p{	is_L_}', "");
    Expect(0, 125251, '\p{^	is_L_}', "");
    Expect(0, 125251, '\P{	is_L_}', "");
    Expect(1, 125251, '\P{^	is_L_}', "");
    Expect(0, 125252, '\p{	is_L_}', "");
    Expect(1, 125252, '\p{^	is_L_}', "");
    Expect(1, 125252, '\P{	is_L_}', "");
    Expect(0, 125252, '\P{^	is_L_}', "");
    Error('\p{-:=L&}');
    Error('\P{-:=L&}');
    Expect(1, 125251, '\p{l&}', "");
    Expect(0, 125251, '\p{^l&}', "");
    Expect(0, 125251, '\P{l&}', "");
    Expect(1, 125251, '\P{^l&}', "");
    Expect(0, 125252, '\p{l&}', "");
    Expect(1, 125252, '\p{^l&}', "");
    Expect(1, 125252, '\P{l&}', "");
    Expect(0, 125252, '\P{^l&}', "");
    Expect(1, 125251, '\p{		l&}', "");
    Expect(0, 125251, '\p{^		l&}', "");
    Expect(0, 125251, '\P{		l&}', "");
    Expect(1, 125251, '\P{^		l&}', "");
    Expect(0, 125252, '\p{		l&}', "");
    Expect(1, 125252, '\p{^		l&}', "");
    Expect(1, 125252, '\P{		l&}', "");
    Expect(0, 125252, '\P{^		l&}', "");
    Error('\p{_/a/is_l&}');
    Error('\P{_/a/is_l&}');
    Expect(1, 125251, '\p{isl&}', "");
    Expect(0, 125251, '\p{^isl&}', "");
    Expect(0, 125251, '\P{isl&}', "");
    Expect(1, 125251, '\P{^isl&}', "");
    Expect(0, 125252, '\p{isl&}', "");
    Expect(1, 125252, '\p{^isl&}', "");
    Expect(1, 125252, '\P{isl&}', "");
    Expect(0, 125252, '\P{^isl&}', "");
    Expect(1, 125251, '\p{_ is_l&}', "");
    Expect(0, 125251, '\p{^_ is_l&}', "");
    Expect(0, 125251, '\P{_ is_l&}', "");
    Expect(1, 125251, '\P{^_ is_l&}', "");
    Expect(0, 125252, '\p{_ is_l&}', "");
    Expect(1, 125252, '\p{^_ is_l&}', "");
    Expect(1, 125252, '\P{_ is_l&}', "");
    Expect(0, 125252, '\P{^_ is_l&}', "");
    Error('\p{:=-_caucasian_Albanian}');
    Error('\P{:=-_caucasian_Albanian}');
    Expect(1, 66927, '\p{caucasianalbanian}', "");
    Expect(0, 66927, '\p{^caucasianalbanian}', "");
    Expect(0, 66927, '\P{caucasianalbanian}', "");
    Expect(1, 66927, '\P{^caucasianalbanian}', "");
    Expect(0, 66928, '\p{caucasianalbanian}', "");
    Expect(1, 66928, '\p{^caucasianalbanian}', "");
    Expect(1, 66928, '\P{caucasianalbanian}', "");
    Expect(0, 66928, '\P{^caucasianalbanian}', "");
    Expect(1, 66927, '\p{ Caucasian_ALBANIAN}', "");
    Expect(0, 66927, '\p{^ Caucasian_ALBANIAN}', "");
    Expect(0, 66927, '\P{ Caucasian_ALBANIAN}', "");
    Expect(1, 66927, '\P{^ Caucasian_ALBANIAN}', "");
    Expect(0, 66928, '\p{ Caucasian_ALBANIAN}', "");
    Expect(1, 66928, '\p{^ Caucasian_ALBANIAN}', "");
    Expect(1, 66928, '\P{ Caucasian_ALBANIAN}', "");
    Expect(0, 66928, '\P{^ Caucasian_ALBANIAN}', "");
    Error('\p{ /a/is_Caucasian_albanian}');
    Error('\P{ /a/is_Caucasian_albanian}');
    Expect(1, 66927, '\p{iscaucasianalbanian}', "");
    Expect(0, 66927, '\p{^iscaucasianalbanian}', "");
    Expect(0, 66927, '\P{iscaucasianalbanian}', "");
    Expect(1, 66927, '\P{^iscaucasianalbanian}', "");
    Expect(0, 66928, '\p{iscaucasianalbanian}', "");
    Expect(1, 66928, '\p{^iscaucasianalbanian}', "");
    Expect(1, 66928, '\P{iscaucasianalbanian}', "");
    Expect(0, 66928, '\P{^iscaucasianalbanian}', "");
    Expect(1, 66927, '\p{--Is_caucasian_Albanian}', "");
    Expect(0, 66927, '\p{^--Is_caucasian_Albanian}', "");
    Expect(0, 66927, '\P{--Is_caucasian_Albanian}', "");
    Expect(1, 66927, '\P{^--Is_caucasian_Albanian}', "");
    Expect(0, 66928, '\p{--Is_caucasian_Albanian}', "");
    Expect(1, 66928, '\p{^--Is_caucasian_Albanian}', "");
    Expect(1, 66928, '\P{--Is_caucasian_Albanian}', "");
    Expect(0, 66928, '\P{^--Is_caucasian_Albanian}', "");
    Error('\p{-	AGHB/a/}');
    Error('\P{-	AGHB/a/}');
    Expect(1, 66927, '\p{aghb}', "");
    Expect(0, 66927, '\p{^aghb}', "");
    Expect(0, 66927, '\P{aghb}', "");
    Expect(1, 66927, '\P{^aghb}', "");
    Expect(0, 66928, '\p{aghb}', "");
    Expect(1, 66928, '\p{^aghb}', "");
    Expect(1, 66928, '\P{aghb}', "");
    Expect(0, 66928, '\P{^aghb}', "");
    Expect(1, 66927, '\p{- Aghb}', "");
    Expect(0, 66927, '\p{^- Aghb}', "");
    Expect(0, 66927, '\P{- Aghb}', "");
    Expect(1, 66927, '\P{^- Aghb}', "");
    Expect(0, 66928, '\p{- Aghb}', "");
    Expect(1, 66928, '\p{^- Aghb}', "");
    Expect(1, 66928, '\P{- Aghb}', "");
    Expect(0, 66928, '\P{^- Aghb}', "");
    Error('\p{:=-	is_AGHB}');
    Error('\P{:=-	is_AGHB}');
    Expect(1, 66927, '\p{isaghb}', "");
    Expect(0, 66927, '\p{^isaghb}', "");
    Expect(0, 66927, '\P{isaghb}', "");
    Expect(1, 66927, '\P{^isaghb}', "");
    Expect(0, 66928, '\p{isaghb}', "");
    Expect(1, 66928, '\p{^isaghb}', "");
    Expect(1, 66928, '\P{isaghb}', "");
    Expect(0, 66928, '\P{^isaghb}', "");
    Expect(1, 66927, '\p{_-Is_AGHB}', "");
    Expect(0, 66927, '\p{^_-Is_AGHB}', "");
    Expect(0, 66927, '\P{_-Is_AGHB}', "");
    Expect(1, 66927, '\P{^_-Is_AGHB}', "");
    Expect(0, 66928, '\p{_-Is_AGHB}', "");
    Expect(1, 66928, '\p{^_-Is_AGHB}', "");
    Expect(1, 66928, '\P{_-Is_AGHB}', "");
    Expect(0, 66928, '\P{^_-Is_AGHB}', "");
    Error('\p{	/a/Chakma}');
    Error('\P{	/a/Chakma}');
    Expect(1, 69955, '\p{chakma}', "");
    Expect(0, 69955, '\p{^chakma}', "");
    Expect(0, 69955, '\P{chakma}', "");
    Expect(1, 69955, '\P{^chakma}', "");
    Expect(0, 69956, '\p{chakma}', "");
    Expect(1, 69956, '\p{^chakma}', "");
    Expect(1, 69956, '\P{chakma}', "");
    Expect(0, 69956, '\P{^chakma}', "");
    Expect(1, 69955, '\p{	-Chakma}', "");
    Expect(0, 69955, '\p{^	-Chakma}', "");
    Expect(0, 69955, '\P{	-Chakma}', "");
    Expect(1, 69955, '\P{^	-Chakma}', "");
    Expect(0, 69956, '\p{	-Chakma}', "");
    Expect(1, 69956, '\p{^	-Chakma}', "");
    Expect(1, 69956, '\P{	-Chakma}', "");
    Expect(0, 69956, '\P{^	-Chakma}', "");
    Error('\p{ /a/IS_chakma}');
    Error('\P{ /a/IS_chakma}');
    Expect(1, 69955, '\p{ischakma}', "");
    Expect(0, 69955, '\p{^ischakma}', "");
    Expect(0, 69955, '\P{ischakma}', "");
    Expect(1, 69955, '\P{^ischakma}', "");
    Expect(0, 69956, '\p{ischakma}', "");
    Expect(1, 69956, '\p{^ischakma}', "");
    Expect(1, 69956, '\P{ischakma}', "");
    Expect(0, 69956, '\P{^ischakma}', "");
    Expect(1, 69955, '\p{__Is_Chakma}', "");
    Expect(0, 69955, '\p{^__Is_Chakma}', "");
    Expect(0, 69955, '\P{__Is_Chakma}', "");
    Expect(1, 69955, '\P{^__Is_Chakma}', "");
    Expect(0, 69956, '\p{__Is_Chakma}', "");
    Expect(1, 69956, '\p{^__Is_Chakma}', "");
    Expect(1, 69956, '\P{__Is_Chakma}', "");
    Expect(0, 69956, '\P{^__Is_Chakma}', "");
    Error('\p{	Cakm/a/}');
    Error('\P{	Cakm/a/}');
    Expect(1, 69955, '\p{cakm}', "");
    Expect(0, 69955, '\p{^cakm}', "");
    Expect(0, 69955, '\P{cakm}', "");
    Expect(1, 69955, '\P{^cakm}', "");
    Expect(0, 69956, '\p{cakm}', "");
    Expect(1, 69956, '\p{^cakm}', "");
    Expect(1, 69956, '\P{cakm}', "");
    Expect(0, 69956, '\P{^cakm}', "");
    Expect(1, 69955, '\p{_-Cakm}', "");
    Expect(0, 69955, '\p{^_-Cakm}', "");
    Expect(0, 69955, '\P{_-Cakm}', "");
    Expect(1, 69955, '\P{^_-Cakm}', "");
    Expect(0, 69956, '\p{_-Cakm}', "");
    Expect(1, 69956, '\p{^_-Cakm}', "");
    Expect(1, 69956, '\P{_-Cakm}', "");
    Expect(0, 69956, '\P{^_-Cakm}', "");
    Error('\p{_	is_CAKM:=}');
    Error('\P{_	is_CAKM:=}');
    Expect(1, 69955, '\p{iscakm}', "");
    Expect(0, 69955, '\p{^iscakm}', "");
    Expect(0, 69955, '\P{iscakm}', "");
    Expect(1, 69955, '\P{^iscakm}', "");
    Expect(0, 69956, '\p{iscakm}', "");
    Expect(1, 69956, '\p{^iscakm}', "");
    Expect(1, 69956, '\P{iscakm}', "");
    Expect(0, 69956, '\P{^iscakm}', "");
    Expect(1, 69955, '\p{	-IS_CAKM}', "");
    Expect(0, 69955, '\p{^	-IS_CAKM}', "");
    Expect(0, 69955, '\P{	-IS_CAKM}', "");
    Expect(1, 69955, '\P{^	-IS_CAKM}', "");
    Expect(0, 69956, '\p{	-IS_CAKM}', "");
    Expect(1, 69956, '\p{^	-IS_CAKM}', "");
    Expect(1, 69956, '\P{	-IS_CAKM}', "");
    Expect(0, 69956, '\P{^	-IS_CAKM}', "");
    Error('\p{	cham/a/}');
    Error('\P{	cham/a/}');
    Expect(1, 43615, '\p{cham}', "");
    Expect(0, 43615, '\p{^cham}', "");
    Expect(0, 43615, '\P{cham}', "");
    Expect(1, 43615, '\P{^cham}', "");
    Expect(0, 43616, '\p{cham}', "");
    Expect(1, 43616, '\p{^cham}', "");
    Expect(1, 43616, '\P{cham}', "");
    Expect(0, 43616, '\P{^cham}', "");
    Expect(1, 43615, '\p{_Cham}', "");
    Expect(0, 43615, '\p{^_Cham}', "");
    Expect(0, 43615, '\P{_Cham}', "");
    Expect(1, 43615, '\P{^_Cham}', "");
    Expect(0, 43616, '\p{_Cham}', "");
    Expect(1, 43616, '\p{^_Cham}', "");
    Expect(1, 43616, '\P{_Cham}', "");
    Expect(0, 43616, '\P{^_Cham}', "");
    Error('\p{	_Is_cham:=}');
    Error('\P{	_Is_cham:=}');
    Expect(1, 43615, '\p{ischam}', "");
    Expect(0, 43615, '\p{^ischam}', "");
    Expect(0, 43615, '\P{ischam}', "");
    Expect(1, 43615, '\P{^ischam}', "");
    Expect(0, 43616, '\p{ischam}', "");
    Expect(1, 43616, '\p{^ischam}', "");
    Expect(1, 43616, '\P{ischam}', "");
    Expect(0, 43616, '\P{^ischam}', "");
    Expect(1, 43615, '\p{-IS_CHAM}', "");
    Expect(0, 43615, '\p{^-IS_CHAM}', "");
    Expect(0, 43615, '\P{-IS_CHAM}', "");
    Expect(1, 43615, '\P{^-IS_CHAM}', "");
    Expect(0, 43616, '\p{-IS_CHAM}', "");
    Expect(1, 43616, '\p{^-IS_CHAM}', "");
    Expect(1, 43616, '\P{-IS_CHAM}', "");
    Expect(0, 43616, '\P{^-IS_CHAM}', "");
    Error('\p{/a/	 Changes_When_casefolded}');
    Error('\P{/a/	 Changes_When_casefolded}');
    Expect(1, 125217, '\p{changeswhencasefolded}', "");
    Expect(0, 125217, '\p{^changeswhencasefolded}', "");
    Expect(0, 125217, '\P{changeswhencasefolded}', "");
    Expect(1, 125217, '\P{^changeswhencasefolded}', "");
    Expect(0, 125218, '\p{changeswhencasefolded}', "");
    Expect(1, 125218, '\p{^changeswhencasefolded}', "");
    Expect(1, 125218, '\P{changeswhencasefolded}', "");
    Expect(0, 125218, '\P{^changeswhencasefolded}', "");
    Expect(1, 125217, '\p{	Changes_When_casefolded}', "");
    Expect(0, 125217, '\p{^	Changes_When_casefolded}', "");
    Expect(0, 125217, '\P{	Changes_When_casefolded}', "");
    Expect(1, 125217, '\P{^	Changes_When_casefolded}', "");
    Expect(0, 125218, '\p{	Changes_When_casefolded}', "");
    Expect(1, 125218, '\p{^	Changes_When_casefolded}', "");
    Expect(1, 125218, '\P{	Changes_When_casefolded}', "");
    Expect(0, 125218, '\P{^	Changes_When_casefolded}', "");
    Error('\p{-:=IS_changes_WHEN_casefolded}');
    Error('\P{-:=IS_changes_WHEN_casefolded}');
    Expect(1, 125217, '\p{ischangeswhencasefolded}', "");
    Expect(0, 125217, '\p{^ischangeswhencasefolded}', "");
    Expect(0, 125217, '\P{ischangeswhencasefolded}', "");
    Expect(1, 125217, '\P{^ischangeswhencasefolded}', "");
    Expect(0, 125218, '\p{ischangeswhencasefolded}', "");
    Expect(1, 125218, '\p{^ischangeswhencasefolded}', "");
    Expect(1, 125218, '\P{ischangeswhencasefolded}', "");
    Expect(0, 125218, '\P{^ischangeswhencasefolded}', "");
    Expect(1, 125217, '\p{IS_Changes_When_casefolded}', "");
    Expect(0, 125217, '\p{^IS_Changes_When_casefolded}', "");
    Expect(0, 125217, '\P{IS_Changes_When_casefolded}', "");
    Expect(1, 125217, '\P{^IS_Changes_When_casefolded}', "");
    Expect(0, 125218, '\p{IS_Changes_When_casefolded}', "");
    Expect(1, 125218, '\p{^IS_Changes_When_casefolded}', "");
    Expect(1, 125218, '\P{IS_Changes_When_casefolded}', "");
    Expect(0, 125218, '\P{^IS_Changes_When_casefolded}', "");
    Error('\p{	:=CWCF}');
    Error('\P{	:=CWCF}');
    Expect(1, 125217, '\p{cwcf}', "");
    Expect(0, 125217, '\p{^cwcf}', "");
    Expect(0, 125217, '\P{cwcf}', "");
    Expect(1, 125217, '\P{^cwcf}', "");
    Expect(0, 125218, '\p{cwcf}', "");
    Expect(1, 125218, '\p{^cwcf}', "");
    Expect(1, 125218, '\P{cwcf}', "");
    Expect(0, 125218, '\P{^cwcf}', "");
    Expect(1, 125217, '\p{__cwcf}', "");
    Expect(0, 125217, '\p{^__cwcf}', "");
    Expect(0, 125217, '\P{__cwcf}', "");
    Expect(1, 125217, '\P{^__cwcf}', "");
    Expect(0, 125218, '\p{__cwcf}', "");
    Expect(1, 125218, '\p{^__cwcf}', "");
    Expect(1, 125218, '\P{__cwcf}', "");
    Expect(0, 125218, '\P{^__cwcf}', "");
    Error('\p{_	IS_CWCF/a/}');
    Error('\P{_	IS_CWCF/a/}');
    Expect(1, 125217, '\p{iscwcf}', "");
    Expect(0, 125217, '\p{^iscwcf}', "");
    Expect(0, 125217, '\P{iscwcf}', "");
    Expect(1, 125217, '\P{^iscwcf}', "");
    Expect(0, 125218, '\p{iscwcf}', "");
    Expect(1, 125218, '\p{^iscwcf}', "");
    Expect(1, 125218, '\P{iscwcf}', "");
    Expect(0, 125218, '\P{^iscwcf}', "");
    Expect(1, 125217, '\p{_-Is_CWCF}', "");
    Expect(0, 125217, '\p{^_-Is_CWCF}', "");
    Expect(0, 125217, '\P{_-Is_CWCF}', "");
    Expect(1, 125217, '\P{^_-Is_CWCF}', "");
    Expect(0, 125218, '\p{_-Is_CWCF}', "");
    Expect(1, 125218, '\p{^_-Is_CWCF}', "");
    Expect(1, 125218, '\P{_-Is_CWCF}', "");
    Expect(0, 125218, '\P{^_-Is_CWCF}', "");
    Error('\p{-/a/CHANGES_When_Casemapped}');
    Error('\P{-/a/CHANGES_When_Casemapped}');
    Expect(1, 125251, '\p{changeswhencasemapped}', "");
    Expect(0, 125251, '\p{^changeswhencasemapped}', "");
    Expect(0, 125251, '\P{changeswhencasemapped}', "");
    Expect(1, 125251, '\P{^changeswhencasemapped}', "");
    Expect(0, 125252, '\p{changeswhencasemapped}', "");
    Expect(1, 125252, '\p{^changeswhencasemapped}', "");
    Expect(1, 125252, '\P{changeswhencasemapped}', "");
    Expect(0, 125252, '\P{^changeswhencasemapped}', "");
    Expect(1, 125251, '\p{	_CHANGES_when_casemapped}', "");
    Expect(0, 125251, '\p{^	_CHANGES_when_casemapped}', "");
    Expect(0, 125251, '\P{	_CHANGES_when_casemapped}', "");
    Expect(1, 125251, '\P{^	_CHANGES_when_casemapped}', "");
    Expect(0, 125252, '\p{	_CHANGES_when_casemapped}', "");
    Expect(1, 125252, '\p{^	_CHANGES_when_casemapped}', "");
    Expect(1, 125252, '\P{	_CHANGES_when_casemapped}', "");
    Expect(0, 125252, '\P{^	_CHANGES_when_casemapped}', "");
    Error('\p{:=_is_Changes_When_CASEMAPPED}');
    Error('\P{:=_is_Changes_When_CASEMAPPED}');
    Expect(1, 125251, '\p{ischangeswhencasemapped}', "");
    Expect(0, 125251, '\p{^ischangeswhencasemapped}', "");
    Expect(0, 125251, '\P{ischangeswhencasemapped}', "");
    Expect(1, 125251, '\P{^ischangeswhencasemapped}', "");
    Expect(0, 125252, '\p{ischangeswhencasemapped}', "");
    Expect(1, 125252, '\p{^ischangeswhencasemapped}', "");
    Expect(1, 125252, '\P{ischangeswhencasemapped}', "");
    Expect(0, 125252, '\P{^ischangeswhencasemapped}', "");
    Expect(1, 125251, '\p{ -IS_CHANGES_When_casemapped}', "");
    Expect(0, 125251, '\p{^ -IS_CHANGES_When_casemapped}', "");
    Expect(0, 125251, '\P{ -IS_CHANGES_When_casemapped}', "");
    Expect(1, 125251, '\P{^ -IS_CHANGES_When_casemapped}', "");
    Expect(0, 125252, '\p{ -IS_CHANGES_When_casemapped}', "");
    Expect(1, 125252, '\p{^ -IS_CHANGES_When_casemapped}', "");
    Expect(1, 125252, '\P{ -IS_CHANGES_When_casemapped}', "");
    Expect(0, 125252, '\P{^ -IS_CHANGES_When_casemapped}', "");
    Error('\p{-/a/CWCM}');
    Error('\P{-/a/CWCM}');
    Expect(1, 125251, '\p{cwcm}', "");
    Expect(0, 125251, '\p{^cwcm}', "");
    Expect(0, 125251, '\P{cwcm}', "");
    Expect(1, 125251, '\P{^cwcm}', "");
    Expect(0, 125252, '\p{cwcm}', "");
    Expect(1, 125252, '\p{^cwcm}', "");
    Expect(1, 125252, '\P{cwcm}', "");
    Expect(0, 125252, '\P{^cwcm}', "");
    Expect(1, 125251, '\p{	 CWCM}', "");
    Expect(0, 125251, '\p{^	 CWCM}', "");
    Expect(0, 125251, '\P{	 CWCM}', "");
    Expect(1, 125251, '\P{^	 CWCM}', "");
    Expect(0, 125252, '\p{	 CWCM}', "");
    Expect(1, 125252, '\p{^	 CWCM}', "");
    Expect(1, 125252, '\P{	 CWCM}', "");
    Expect(0, 125252, '\P{^	 CWCM}', "");
    Error('\p{ /a/Is_CWCM}');
    Error('\P{ /a/Is_CWCM}');
    Expect(1, 125251, '\p{iscwcm}', "");
    Expect(0, 125251, '\p{^iscwcm}', "");
    Expect(0, 125251, '\P{iscwcm}', "");
    Expect(1, 125251, '\P{^iscwcm}', "");
    Expect(0, 125252, '\p{iscwcm}', "");
    Expect(1, 125252, '\p{^iscwcm}', "");
    Expect(1, 125252, '\P{iscwcm}', "");
    Expect(0, 125252, '\P{^iscwcm}', "");
    Expect(1, 125251, '\p{ _is_CWCM}', "");
    Expect(0, 125251, '\p{^ _is_CWCM}', "");
    Expect(0, 125251, '\P{ _is_CWCM}', "");
    Expect(1, 125251, '\P{^ _is_CWCM}', "");
    Expect(0, 125252, '\p{ _is_CWCM}', "");
    Expect(1, 125252, '\p{^ _is_CWCM}', "");
    Expect(1, 125252, '\P{ _is_CWCM}', "");
    Expect(0, 125252, '\P{^ _is_CWCM}', "");
    Error('\p{-	CHANGES_when_Lowercased/a/}');
    Error('\P{-	CHANGES_when_Lowercased/a/}');
    Expect(1, 125217, '\p{changeswhenlowercased}', "");
    Expect(0, 125217, '\p{^changeswhenlowercased}', "");
    Expect(0, 125217, '\P{changeswhenlowercased}', "");
    Expect(1, 125217, '\P{^changeswhenlowercased}', "");
    Expect(0, 125218, '\p{changeswhenlowercased}', "");
    Expect(1, 125218, '\p{^changeswhenlowercased}', "");
    Expect(1, 125218, '\P{changeswhenlowercased}', "");
    Expect(0, 125218, '\P{^changeswhenlowercased}', "");
    Expect(1, 125217, '\p{  changes_WHEN_Lowercased}', "");
    Expect(0, 125217, '\p{^  changes_WHEN_Lowercased}', "");
    Expect(0, 125217, '\P{  changes_WHEN_Lowercased}', "");
    Expect(1, 125217, '\P{^  changes_WHEN_Lowercased}', "");
    Expect(0, 125218, '\p{  changes_WHEN_Lowercased}', "");
    Expect(1, 125218, '\p{^  changes_WHEN_Lowercased}', "");
    Expect(1, 125218, '\P{  changes_WHEN_Lowercased}', "");
    Expect(0, 125218, '\P{^  changes_WHEN_Lowercased}', "");
    Error('\p{ :=is_Changes_When_lowercased}');
    Error('\P{ :=is_Changes_When_lowercased}');
    Expect(1, 125217, '\p{ischangeswhenlowercased}', "");
    Expect(0, 125217, '\p{^ischangeswhenlowercased}', "");
    Expect(0, 125217, '\P{ischangeswhenlowercased}', "");
    Expect(1, 125217, '\P{^ischangeswhenlowercased}', "");
    Expect(0, 125218, '\p{ischangeswhenlowercased}', "");
    Expect(1, 125218, '\p{^ischangeswhenlowercased}', "");
    Expect(1, 125218, '\P{ischangeswhenlowercased}', "");
    Expect(0, 125218, '\P{^ischangeswhenlowercased}', "");
    Expect(1, 125217, '\p{	 Is_Changes_When_Lowercased}', "");
    Expect(0, 125217, '\p{^	 Is_Changes_When_Lowercased}', "");
    Expect(0, 125217, '\P{	 Is_Changes_When_Lowercased}', "");
    Expect(1, 125217, '\P{^	 Is_Changes_When_Lowercased}', "");
    Expect(0, 125218, '\p{	 Is_Changes_When_Lowercased}', "");
    Expect(1, 125218, '\p{^	 Is_Changes_When_Lowercased}', "");
    Expect(1, 125218, '\P{	 Is_Changes_When_Lowercased}', "");
    Expect(0, 125218, '\P{^	 Is_Changes_When_Lowercased}', "");
    Error('\p{:=CWL}');
    Error('\P{:=CWL}');
    Expect(1, 125217, '\p{cwl}', "");
    Expect(0, 125217, '\p{^cwl}', "");
    Expect(0, 125217, '\P{cwl}', "");
    Expect(1, 125217, '\P{^cwl}', "");
    Expect(0, 125218, '\p{cwl}', "");
    Expect(1, 125218, '\p{^cwl}', "");
    Expect(1, 125218, '\P{cwl}', "");
    Expect(0, 125218, '\P{^cwl}', "");
    Expect(1, 125217, '\p{ CWL}', "");
    Expect(0, 125217, '\p{^ CWL}', "");
    Expect(0, 125217, '\P{ CWL}', "");
    Expect(1, 125217, '\P{^ CWL}', "");
    Expect(0, 125218, '\p{ CWL}', "");
    Expect(1, 125218, '\p{^ CWL}', "");
    Expect(1, 125218, '\P{ CWL}', "");
    Expect(0, 125218, '\P{^ CWL}', "");
    Error('\p{is_CWL/a/}');
    Error('\P{is_CWL/a/}');
    Expect(1, 125217, '\p{iscwl}', "");
    Expect(0, 125217, '\p{^iscwl}', "");
    Expect(0, 125217, '\P{iscwl}', "");
    Expect(1, 125217, '\P{^iscwl}', "");
    Expect(0, 125218, '\p{iscwl}', "");
    Expect(1, 125218, '\p{^iscwl}', "");
    Expect(1, 125218, '\P{iscwl}', "");
    Expect(0, 125218, '\P{^iscwl}', "");
    Expect(1, 125217, '\p{ is_CWL}', "");
    Expect(0, 125217, '\p{^ is_CWL}', "");
    Expect(0, 125217, '\P{ is_CWL}', "");
    Expect(1, 125217, '\P{^ is_CWL}', "");
    Expect(0, 125218, '\p{ is_CWL}', "");
    Expect(1, 125218, '\p{^ is_CWL}', "");
    Expect(1, 125218, '\P{ is_CWL}', "");
    Expect(0, 125218, '\P{^ is_CWL}', "");
    Error('\p{  Changes_When_NFKC_casefolded:=}');
    Error('\P{  Changes_When_NFKC_casefolded:=}');
    Expect(1, 921599, '\p{changeswhennfkccasefolded}', "");
    Expect(0, 921599, '\p{^changeswhennfkccasefolded}', "");
    Expect(0, 921599, '\P{changeswhennfkccasefolded}', "");
    Expect(1, 921599, '\P{^changeswhennfkccasefolded}', "");
    Expect(0, 921600, '\p{changeswhennfkccasefolded}', "");
    Expect(1, 921600, '\p{^changeswhennfkccasefolded}', "");
    Expect(1, 921600, '\P{changeswhennfkccasefolded}', "");
    Expect(0, 921600, '\P{^changeswhennfkccasefolded}', "");
    Expect(1, 921599, '\p{ Changes_When_NFKC_casefolded}', "");
    Expect(0, 921599, '\p{^ Changes_When_NFKC_casefolded}', "");
    Expect(0, 921599, '\P{ Changes_When_NFKC_casefolded}', "");
    Expect(1, 921599, '\P{^ Changes_When_NFKC_casefolded}', "");
    Expect(0, 921600, '\p{ Changes_When_NFKC_casefolded}', "");
    Expect(1, 921600, '\p{^ Changes_When_NFKC_casefolded}', "");
    Expect(1, 921600, '\P{ Changes_When_NFKC_casefolded}', "");
    Expect(0, 921600, '\P{^ Changes_When_NFKC_casefolded}', "");
    Error('\p{	Is_CHANGES_When_NFKC_Casefolded:=}');
    Error('\P{	Is_CHANGES_When_NFKC_Casefolded:=}');
    Expect(1, 921599, '\p{ischangeswhennfkccasefolded}', "");
    Expect(0, 921599, '\p{^ischangeswhennfkccasefolded}', "");
    Expect(0, 921599, '\P{ischangeswhennfkccasefolded}', "");
    Expect(1, 921599, '\P{^ischangeswhennfkccasefolded}', "");
    Expect(0, 921600, '\p{ischangeswhennfkccasefolded}', "");
    Expect(1, 921600, '\p{^ischangeswhennfkccasefolded}', "");
    Expect(1, 921600, '\P{ischangeswhennfkccasefolded}', "");
    Expect(0, 921600, '\P{^ischangeswhennfkccasefolded}', "");
    Expect(1, 921599, '\p{__Is_Changes_WHEN_NFKC_CASEFOLDED}', "");
    Expect(0, 921599, '\p{^__Is_Changes_WHEN_NFKC_CASEFOLDED}', "");
    Expect(0, 921599, '\P{__Is_Changes_WHEN_NFKC_CASEFOLDED}', "");
    Expect(1, 921599, '\P{^__Is_Changes_WHEN_NFKC_CASEFOLDED}', "");
    Expect(0, 921600, '\p{__Is_Changes_WHEN_NFKC_CASEFOLDED}', "");
    Expect(1, 921600, '\p{^__Is_Changes_WHEN_NFKC_CASEFOLDED}', "");
    Expect(1, 921600, '\P{__Is_Changes_WHEN_NFKC_CASEFOLDED}', "");
    Expect(0, 921600, '\P{^__Is_Changes_WHEN_NFKC_CASEFOLDED}', "");
    Error('\p{/a/	CWKCF}');
    Error('\P{/a/	CWKCF}');
    Expect(1, 921599, '\p{cwkcf}', "");
    Expect(0, 921599, '\p{^cwkcf}', "");
    Expect(0, 921599, '\P{cwkcf}', "");
    Expect(1, 921599, '\P{^cwkcf}', "");
    Expect(0, 921600, '\p{cwkcf}', "");
    Expect(1, 921600, '\p{^cwkcf}', "");
    Expect(1, 921600, '\P{cwkcf}', "");
    Expect(0, 921600, '\P{^cwkcf}', "");
    Expect(1, 921599, '\p{	CWKCF}', "");
    Expect(0, 921599, '\p{^	CWKCF}', "");
    Expect(0, 921599, '\P{	CWKCF}', "");
    Expect(1, 921599, '\P{^	CWKCF}', "");
    Expect(0, 921600, '\p{	CWKCF}', "");
    Expect(1, 921600, '\p{^	CWKCF}', "");
    Expect(1, 921600, '\P{	CWKCF}', "");
    Expect(0, 921600, '\P{^	CWKCF}', "");
    Error('\p{-:=is_CWKCF}');
    Error('\P{-:=is_CWKCF}');
    Expect(1, 921599, '\p{iscwkcf}', "");
    Expect(0, 921599, '\p{^iscwkcf}', "");
    Expect(0, 921599, '\P{iscwkcf}', "");
    Expect(1, 921599, '\P{^iscwkcf}', "");
    Expect(0, 921600, '\p{iscwkcf}', "");
    Expect(1, 921600, '\p{^iscwkcf}', "");
    Expect(1, 921600, '\P{iscwkcf}', "");
    Expect(0, 921600, '\P{^iscwkcf}', "");
    Expect(1, 921599, '\p{_ Is_CWKCF}', "");
    Expect(0, 921599, '\p{^_ Is_CWKCF}', "");
    Expect(0, 921599, '\P{_ Is_CWKCF}', "");
    Expect(1, 921599, '\P{^_ Is_CWKCF}', "");
    Expect(0, 921600, '\p{_ Is_CWKCF}', "");
    Expect(1, 921600, '\p{^_ Is_CWKCF}', "");
    Expect(1, 921600, '\P{_ Is_CWKCF}', "");
    Expect(0, 921600, '\P{^_ Is_CWKCF}', "");
    Error('\p{ /a/CHANGES_WHEN_Titlecased}');
    Error('\P{ /a/CHANGES_WHEN_Titlecased}');
    Expect(1, 125251, '\p{changeswhentitlecased}', "");
    Expect(0, 125251, '\p{^changeswhentitlecased}', "");
    Expect(0, 125251, '\P{changeswhentitlecased}', "");
    Expect(1, 125251, '\P{^changeswhentitlecased}', "");
    Expect(0, 125252, '\p{changeswhentitlecased}', "");
    Expect(1, 125252, '\p{^changeswhentitlecased}', "");
    Expect(1, 125252, '\P{changeswhentitlecased}', "");
    Expect(0, 125252, '\P{^changeswhentitlecased}', "");
    Expect(1, 125251, '\p{	_Changes_When_Titlecased}', "");
    Expect(0, 125251, '\p{^	_Changes_When_Titlecased}', "");
    Expect(0, 125251, '\P{	_Changes_When_Titlecased}', "");
    Expect(1, 125251, '\P{^	_Changes_When_Titlecased}', "");
    Expect(0, 125252, '\p{	_Changes_When_Titlecased}', "");
    Expect(1, 125252, '\p{^	_Changes_When_Titlecased}', "");
    Expect(1, 125252, '\P{	_Changes_When_Titlecased}', "");
    Expect(0, 125252, '\P{^	_Changes_When_Titlecased}', "");
    Error('\p{/a/-	Is_CHANGES_When_Titlecased}');
    Error('\P{/a/-	Is_CHANGES_When_Titlecased}');
    Expect(1, 125251, '\p{ischangeswhentitlecased}', "");
    Expect(0, 125251, '\p{^ischangeswhentitlecased}', "");
    Expect(0, 125251, '\P{ischangeswhentitlecased}', "");
    Expect(1, 125251, '\P{^ischangeswhentitlecased}', "");
    Expect(0, 125252, '\p{ischangeswhentitlecased}', "");
    Expect(1, 125252, '\p{^ischangeswhentitlecased}', "");
    Expect(1, 125252, '\P{ischangeswhentitlecased}', "");
    Expect(0, 125252, '\P{^ischangeswhentitlecased}', "");
    Expect(1, 125251, '\p{_Is_Changes_When_TITLECASED}', "");
    Expect(0, 125251, '\p{^_Is_Changes_When_TITLECASED}', "");
    Expect(0, 125251, '\P{_Is_Changes_When_TITLECASED}', "");
    Expect(1, 125251, '\P{^_Is_Changes_When_TITLECASED}', "");
    Expect(0, 125252, '\p{_Is_Changes_When_TITLECASED}', "");
    Expect(1, 125252, '\p{^_Is_Changes_When_TITLECASED}', "");
    Expect(1, 125252, '\P{_Is_Changes_When_TITLECASED}', "");
    Expect(0, 125252, '\P{^_Is_Changes_When_TITLECASED}', "");
    Error('\p{/a/_	CWT}');
    Error('\P{/a/_	CWT}');
    Expect(1, 125251, '\p{cwt}', "");
    Expect(0, 125251, '\p{^cwt}', "");
    Expect(0, 125251, '\P{cwt}', "");
    Expect(1, 125251, '\P{^cwt}', "");
    Expect(0, 125252, '\p{cwt}', "");
    Expect(1, 125252, '\p{^cwt}', "");
    Expect(1, 125252, '\P{cwt}', "");
    Expect(0, 125252, '\P{^cwt}', "");
    Expect(1, 125251, '\p{	cwt}', "");
    Expect(0, 125251, '\p{^	cwt}', "");
    Expect(0, 125251, '\P{	cwt}', "");
    Expect(1, 125251, '\P{^	cwt}', "");
    Expect(0, 125252, '\p{	cwt}', "");
    Expect(1, 125252, '\p{^	cwt}', "");
    Expect(1, 125252, '\P{	cwt}', "");
    Expect(0, 125252, '\P{^	cwt}', "");
    Error('\p{ /a/Is_cwt}');
    Error('\P{ /a/Is_cwt}');
    Expect(1, 125251, '\p{iscwt}', "");
    Expect(0, 125251, '\p{^iscwt}', "");
    Expect(0, 125251, '\P{iscwt}', "");
    Expect(1, 125251, '\P{^iscwt}', "");
    Expect(0, 125252, '\p{iscwt}', "");
    Expect(1, 125252, '\p{^iscwt}', "");
    Expect(1, 125252, '\P{iscwt}', "");
    Expect(0, 125252, '\P{^iscwt}', "");
    Expect(1, 125251, '\p{		is_CWT}', "");
    Expect(0, 125251, '\p{^		is_CWT}', "");
    Expect(0, 125251, '\P{		is_CWT}', "");
    Expect(1, 125251, '\P{^		is_CWT}', "");
    Expect(0, 125252, '\p{		is_CWT}', "");
    Expect(1, 125252, '\p{^		is_CWT}', "");
    Expect(1, 125252, '\P{		is_CWT}', "");
    Expect(0, 125252, '\P{^		is_CWT}', "");
    Error('\p{-	Changes_WHEN_UPPERCASED:=}');
    Error('\P{-	Changes_WHEN_UPPERCASED:=}');
    Expect(1, 125251, '\p{changeswhenuppercased}', "");
    Expect(0, 125251, '\p{^changeswhenuppercased}', "");
    Expect(0, 125251, '\P{changeswhenuppercased}', "");
    Expect(1, 125251, '\P{^changeswhenuppercased}', "");
    Expect(0, 125252, '\p{changeswhenuppercased}', "");
    Expect(1, 125252, '\p{^changeswhenuppercased}', "");
    Expect(1, 125252, '\P{changeswhenuppercased}', "");
    Expect(0, 125252, '\P{^changeswhenuppercased}', "");
    Expect(1, 125251, '\p{	changes_When_Uppercased}', "");
    Expect(0, 125251, '\p{^	changes_When_Uppercased}', "");
    Expect(0, 125251, '\P{	changes_When_Uppercased}', "");
    Expect(1, 125251, '\P{^	changes_When_Uppercased}', "");
    Expect(0, 125252, '\p{	changes_When_Uppercased}', "");
    Expect(1, 125252, '\p{^	changes_When_Uppercased}', "");
    Expect(1, 125252, '\P{	changes_When_Uppercased}', "");
    Expect(0, 125252, '\P{^	changes_When_Uppercased}', "");
    Error('\p{ Is_Changes_When_Uppercased:=}');
    Error('\P{ Is_Changes_When_Uppercased:=}');
    Expect(1, 125251, '\p{ischangeswhenuppercased}', "");
    Expect(0, 125251, '\p{^ischangeswhenuppercased}', "");
    Expect(0, 125251, '\P{ischangeswhenuppercased}', "");
    Expect(1, 125251, '\P{^ischangeswhenuppercased}', "");
    Expect(0, 125252, '\p{ischangeswhenuppercased}', "");
    Expect(1, 125252, '\p{^ischangeswhenuppercased}', "");
    Expect(1, 125252, '\P{ischangeswhenuppercased}', "");
    Expect(0, 125252, '\P{^ischangeswhenuppercased}', "");
    Expect(1, 125251, '\p{ 	Is_changes_when_uppercased}', "");
    Expect(0, 125251, '\p{^ 	Is_changes_when_uppercased}', "");
    Expect(0, 125251, '\P{ 	Is_changes_when_uppercased}', "");
    Expect(1, 125251, '\P{^ 	Is_changes_when_uppercased}', "");
    Expect(0, 125252, '\p{ 	Is_changes_when_uppercased}', "");
    Expect(1, 125252, '\p{^ 	Is_changes_when_uppercased}', "");
    Expect(1, 125252, '\P{ 	Is_changes_when_uppercased}', "");
    Expect(0, 125252, '\P{^ 	Is_changes_when_uppercased}', "");
    Error('\p{-_cwu/a/}');
    Error('\P{-_cwu/a/}');
    Expect(1, 125251, '\p{cwu}', "");
    Expect(0, 125251, '\p{^cwu}', "");
    Expect(0, 125251, '\P{cwu}', "");
    Expect(1, 125251, '\P{^cwu}', "");
    Expect(0, 125252, '\p{cwu}', "");
    Expect(1, 125252, '\p{^cwu}', "");
    Expect(1, 125252, '\P{cwu}', "");
    Expect(0, 125252, '\P{^cwu}', "");
    Expect(1, 125251, '\p{-CWU}', "");
    Expect(0, 125251, '\p{^-CWU}', "");
    Expect(0, 125251, '\P{-CWU}', "");
    Expect(1, 125251, '\P{^-CWU}', "");
    Expect(0, 125252, '\p{-CWU}', "");
    Expect(1, 125252, '\p{^-CWU}', "");
    Expect(1, 125252, '\P{-CWU}', "");
    Expect(0, 125252, '\P{^-CWU}', "");
    Error('\p{ is_cwu:=}');
    Error('\P{ is_cwu:=}');
    Expect(1, 125251, '\p{iscwu}', "");
    Expect(0, 125251, '\p{^iscwu}', "");
    Expect(0, 125251, '\P{iscwu}', "");
    Expect(1, 125251, '\P{^iscwu}', "");
    Expect(0, 125252, '\p{iscwu}', "");
    Expect(1, 125252, '\p{^iscwu}', "");
    Expect(1, 125252, '\P{iscwu}', "");
    Expect(0, 125252, '\P{^iscwu}', "");
    Expect(1, 125251, '\p{-is_CWU}', "");
    Expect(0, 125251, '\p{^-is_CWU}', "");
    Expect(0, 125251, '\P{-is_CWU}', "");
    Expect(1, 125251, '\P{^-is_CWU}', "");
    Expect(0, 125252, '\p{-is_CWU}', "");
    Expect(1, 125252, '\p{^-is_CWU}', "");
    Expect(1, 125252, '\P{-is_CWU}', "");
    Expect(0, 125252, '\P{^-is_CWU}', "");
    Error('\p{ Cherokee/a/}');
    Error('\P{ Cherokee/a/}');
    Expect(1, 43967, '\p{cherokee}', "");
    Expect(0, 43967, '\p{^cherokee}', "");
    Expect(0, 43967, '\P{cherokee}', "");
    Expect(1, 43967, '\P{^cherokee}', "");
    Expect(0, 43968, '\p{cherokee}', "");
    Expect(1, 43968, '\p{^cherokee}', "");
    Expect(1, 43968, '\P{cherokee}', "");
    Expect(0, 43968, '\P{^cherokee}', "");
    Expect(1, 43967, '\p{ -cherokee}', "");
    Expect(0, 43967, '\p{^ -cherokee}', "");
    Expect(0, 43967, '\P{ -cherokee}', "");
    Expect(1, 43967, '\P{^ -cherokee}', "");
    Expect(0, 43968, '\p{ -cherokee}', "");
    Expect(1, 43968, '\p{^ -cherokee}', "");
    Expect(1, 43968, '\P{ -cherokee}', "");
    Expect(0, 43968, '\P{^ -cherokee}', "");
    Error('\p{  IS_CHEROKEE:=}');
    Error('\P{  IS_CHEROKEE:=}');
    Expect(1, 43967, '\p{ischerokee}', "");
    Expect(0, 43967, '\p{^ischerokee}', "");
    Expect(0, 43967, '\P{ischerokee}', "");
    Expect(1, 43967, '\P{^ischerokee}', "");
    Expect(0, 43968, '\p{ischerokee}', "");
    Expect(1, 43968, '\p{^ischerokee}', "");
    Expect(1, 43968, '\P{ischerokee}', "");
    Expect(0, 43968, '\P{^ischerokee}', "");
    Expect(1, 43967, '\p{- Is_cherokee}', "");
    Expect(0, 43967, '\p{^- Is_cherokee}', "");
    Expect(0, 43967, '\P{- Is_cherokee}', "");
    Expect(1, 43967, '\P{^- Is_cherokee}', "");
    Expect(0, 43968, '\p{- Is_cherokee}', "");
    Expect(1, 43968, '\p{^- Is_cherokee}', "");
    Expect(1, 43968, '\P{- Is_cherokee}', "");
    Expect(0, 43968, '\P{^- Is_cherokee}', "");
    Error('\p{:=_-CHER}');
    Error('\P{:=_-CHER}');
    Expect(1, 43967, '\p{cher}', "");
    Expect(0, 43967, '\p{^cher}', "");
    Expect(0, 43967, '\P{cher}', "");
    Expect(1, 43967, '\P{^cher}', "");
    Expect(0, 43968, '\p{cher}', "");
    Expect(1, 43968, '\p{^cher}', "");
    Expect(1, 43968, '\P{cher}', "");
    Expect(0, 43968, '\P{^cher}', "");
    Expect(1, 43967, '\p{_Cher}', "");
    Expect(0, 43967, '\p{^_Cher}', "");
    Expect(0, 43967, '\P{_Cher}', "");
    Expect(1, 43967, '\P{^_Cher}', "");
    Expect(0, 43968, '\p{_Cher}', "");
    Expect(1, 43968, '\p{^_Cher}', "");
    Expect(1, 43968, '\P{_Cher}', "");
    Expect(0, 43968, '\P{^_Cher}', "");
    Error('\p{ /a/IS_Cher}');
    Error('\P{ /a/IS_Cher}');
    Expect(1, 43967, '\p{ischer}', "");
    Expect(0, 43967, '\p{^ischer}', "");
    Expect(0, 43967, '\P{ischer}', "");
    Expect(1, 43967, '\P{^ischer}', "");
    Expect(0, 43968, '\p{ischer}', "");
    Expect(1, 43968, '\p{^ischer}', "");
    Expect(1, 43968, '\P{ischer}', "");
    Expect(0, 43968, '\P{^ischer}', "");
    Expect(1, 43967, '\p{	_Is_Cher}', "");
    Expect(0, 43967, '\p{^	_Is_Cher}', "");
    Expect(0, 43967, '\P{	_Is_Cher}', "");
    Expect(1, 43967, '\P{^	_Is_Cher}', "");
    Expect(0, 43968, '\p{	_Is_Cher}', "");
    Expect(1, 43968, '\p{^	_Is_Cher}', "");
    Expect(1, 43968, '\P{	_Is_Cher}', "");
    Expect(0, 43968, '\P{^	_Is_Cher}', "");
    Error('\p{	cherokee_Supplement/a/}');
    Error('\P{	cherokee_Supplement/a/}');
    Expect(1, 43967, '\p{cherokeesupplement}', "");
    Expect(0, 43967, '\p{^cherokeesupplement}', "");
    Expect(0, 43967, '\P{cherokeesupplement}', "");
    Expect(1, 43967, '\P{^cherokeesupplement}', "");
    Expect(0, 43968, '\p{cherokeesupplement}', "");
    Expect(1, 43968, '\p{^cherokeesupplement}', "");
    Expect(1, 43968, '\P{cherokeesupplement}', "");
    Expect(0, 43968, '\P{^cherokeesupplement}', "");
    Expect(1, 43967, '\p{_Cherokee_supplement}', "");
    Expect(0, 43967, '\p{^_Cherokee_supplement}', "");
    Expect(0, 43967, '\P{_Cherokee_supplement}', "");
    Expect(1, 43967, '\P{^_Cherokee_supplement}', "");
    Expect(0, 43968, '\p{_Cherokee_supplement}', "");
    Expect(1, 43968, '\p{^_Cherokee_supplement}', "");
    Expect(1, 43968, '\P{_Cherokee_supplement}', "");
    Expect(0, 43968, '\P{^_Cherokee_supplement}', "");
    Error('\p{_:=Is_cherokee_supplement}');
    Error('\P{_:=Is_cherokee_supplement}');
    Expect(1, 43967, '\p{ischerokeesupplement}', "");
    Expect(0, 43967, '\p{^ischerokeesupplement}', "");
    Expect(0, 43967, '\P{ischerokeesupplement}', "");
    Expect(1, 43967, '\P{^ischerokeesupplement}', "");
    Expect(0, 43968, '\p{ischerokeesupplement}', "");
    Expect(1, 43968, '\p{^ischerokeesupplement}', "");
    Expect(1, 43968, '\P{ischerokeesupplement}', "");
    Expect(0, 43968, '\P{^ischerokeesupplement}', "");
    Expect(1, 43967, '\p{ _Is_Cherokee_supplement}', "");
    Expect(0, 43967, '\p{^ _Is_Cherokee_supplement}', "");
    Expect(0, 43967, '\P{ _Is_Cherokee_supplement}', "");
    Expect(1, 43967, '\P{^ _Is_Cherokee_supplement}', "");
    Expect(0, 43968, '\p{ _Is_Cherokee_supplement}', "");
    Expect(1, 43968, '\p{^ _Is_Cherokee_supplement}', "");
    Expect(1, 43968, '\P{ _Is_Cherokee_supplement}', "");
    Expect(0, 43968, '\P{^ _Is_Cherokee_supplement}', "");
    Error('\p{ _In_cherokee_Supplement:=}');
    Error('\P{ _In_cherokee_Supplement:=}');
    Expect(1, 43967, '\p{incherokeesupplement}', "");
    Expect(0, 43967, '\p{^incherokeesupplement}', "");
    Expect(0, 43967, '\P{incherokeesupplement}', "");
    Expect(1, 43967, '\P{^incherokeesupplement}', "");
    Expect(0, 43968, '\p{incherokeesupplement}', "");
    Expect(1, 43968, '\p{^incherokeesupplement}', "");
    Expect(1, 43968, '\P{incherokeesupplement}', "");
    Expect(0, 43968, '\P{^incherokeesupplement}', "");
    Expect(1, 43967, '\p{_In_CHEROKEE_SUPPLEMENT}', "");
    Expect(0, 43967, '\p{^_In_CHEROKEE_SUPPLEMENT}', "");
    Expect(0, 43967, '\P{_In_CHEROKEE_SUPPLEMENT}', "");
    Expect(1, 43967, '\P{^_In_CHEROKEE_SUPPLEMENT}', "");
    Expect(0, 43968, '\p{_In_CHEROKEE_SUPPLEMENT}', "");
    Expect(1, 43968, '\p{^_In_CHEROKEE_SUPPLEMENT}', "");
    Expect(1, 43968, '\P{_In_CHEROKEE_SUPPLEMENT}', "");
    Expect(0, 43968, '\P{^_In_CHEROKEE_SUPPLEMENT}', "");
    Error('\p{:= -cherokee_sup}');
    Error('\P{:= -cherokee_sup}');
    Expect(1, 43967, '\p{cherokeesup}', "");
    Expect(0, 43967, '\p{^cherokeesup}', "");
    Expect(0, 43967, '\P{cherokeesup}', "");
    Expect(1, 43967, '\P{^cherokeesup}', "");
    Expect(0, 43968, '\p{cherokeesup}', "");
    Expect(1, 43968, '\p{^cherokeesup}', "");
    Expect(1, 43968, '\P{cherokeesup}', "");
    Expect(0, 43968, '\P{^cherokeesup}', "");
    Expect(1, 43967, '\p{ Cherokee_sup}', "");
    Expect(0, 43967, '\p{^ Cherokee_sup}', "");
    Expect(0, 43967, '\P{ Cherokee_sup}', "");
    Expect(1, 43967, '\P{^ Cherokee_sup}', "");
    Expect(0, 43968, '\p{ Cherokee_sup}', "");
    Expect(1, 43968, '\p{^ Cherokee_sup}', "");
    Expect(1, 43968, '\P{ Cherokee_sup}', "");
    Expect(0, 43968, '\P{^ Cherokee_sup}', "");
    Error('\p{:=-_is_Cherokee_sup}');
    Error('\P{:=-_is_Cherokee_sup}');
    Expect(1, 43967, '\p{ischerokeesup}', "");
    Expect(0, 43967, '\p{^ischerokeesup}', "");
    Expect(0, 43967, '\P{ischerokeesup}', "");
    Expect(1, 43967, '\P{^ischerokeesup}', "");
    Expect(0, 43968, '\p{ischerokeesup}', "");
    Expect(1, 43968, '\p{^ischerokeesup}', "");
    Expect(1, 43968, '\P{ischerokeesup}', "");
    Expect(0, 43968, '\P{^ischerokeesup}', "");
    Expect(1, 43967, '\p{_Is_CHEROKEE_Sup}', "");
    Expect(0, 43967, '\p{^_Is_CHEROKEE_Sup}', "");
    Expect(0, 43967, '\P{_Is_CHEROKEE_Sup}', "");
    Expect(1, 43967, '\P{^_Is_CHEROKEE_Sup}', "");
    Expect(0, 43968, '\p{_Is_CHEROKEE_Sup}', "");
    Expect(1, 43968, '\p{^_Is_CHEROKEE_Sup}', "");
    Expect(1, 43968, '\P{_Is_CHEROKEE_Sup}', "");
    Expect(0, 43968, '\P{^_Is_CHEROKEE_Sup}', "");
    Error('\p{-IN_Cherokee_SUP:=}');
    Error('\P{-IN_Cherokee_SUP:=}');
    Expect(1, 43967, '\p{incherokeesup}', "");
    Expect(0, 43967, '\p{^incherokeesup}', "");
    Expect(0, 43967, '\P{incherokeesup}', "");
    Expect(1, 43967, '\P{^incherokeesup}', "");
    Expect(0, 43968, '\p{incherokeesup}', "");
    Expect(1, 43968, '\p{^incherokeesup}', "");
    Expect(1, 43968, '\P{incherokeesup}', "");
    Expect(0, 43968, '\P{^incherokeesup}', "");
    Expect(1, 43967, '\p{	In_Cherokee_sup}', "");
    Expect(0, 43967, '\p{^	In_Cherokee_sup}', "");
    Expect(0, 43967, '\P{	In_Cherokee_sup}', "");
    Expect(1, 43967, '\P{^	In_Cherokee_sup}', "");
    Expect(0, 43968, '\p{	In_Cherokee_sup}', "");
    Expect(1, 43968, '\p{^	In_Cherokee_sup}', "");
    Expect(1, 43968, '\P{	In_Cherokee_sup}', "");
    Expect(0, 43968, '\P{^	In_Cherokee_sup}', "");
    Error('\p{/a/ 	CJK_Compatibility}');
    Error('\P{/a/ 	CJK_Compatibility}');
    Expect(1, 13311, '\p{cjkcompatibility}', "");
    Expect(0, 13311, '\p{^cjkcompatibility}', "");
    Expect(0, 13311, '\P{cjkcompatibility}', "");
    Expect(1, 13311, '\P{^cjkcompatibility}', "");
    Expect(0, 13312, '\p{cjkcompatibility}', "");
    Expect(1, 13312, '\p{^cjkcompatibility}', "");
    Expect(1, 13312, '\P{cjkcompatibility}', "");
    Expect(0, 13312, '\P{^cjkcompatibility}', "");
    Expect(1, 13311, '\p{ CJK_Compatibility}', "");
    Expect(0, 13311, '\p{^ CJK_Compatibility}', "");
    Expect(0, 13311, '\P{ CJK_Compatibility}', "");
    Expect(1, 13311, '\P{^ CJK_Compatibility}', "");
    Expect(0, 13312, '\p{ CJK_Compatibility}', "");
    Expect(1, 13312, '\p{^ CJK_Compatibility}', "");
    Expect(1, 13312, '\P{ CJK_Compatibility}', "");
    Expect(0, 13312, '\P{^ CJK_Compatibility}', "");
    Error('\p{:=_	Is_CJK_Compatibility}');
    Error('\P{:=_	Is_CJK_Compatibility}');
    Expect(1, 13311, '\p{iscjkcompatibility}', "");
    Expect(0, 13311, '\p{^iscjkcompatibility}', "");
    Expect(0, 13311, '\P{iscjkcompatibility}', "");
    Expect(1, 13311, '\P{^iscjkcompatibility}', "");
    Expect(0, 13312, '\p{iscjkcompatibility}', "");
    Expect(1, 13312, '\p{^iscjkcompatibility}', "");
    Expect(1, 13312, '\P{iscjkcompatibility}', "");
    Expect(0, 13312, '\P{^iscjkcompatibility}', "");
    Expect(1, 13311, '\p{_Is_cjk_Compatibility}', "");
    Expect(0, 13311, '\p{^_Is_cjk_Compatibility}', "");
    Expect(0, 13311, '\P{_Is_cjk_Compatibility}', "");
    Expect(1, 13311, '\P{^_Is_cjk_Compatibility}', "");
    Expect(0, 13312, '\p{_Is_cjk_Compatibility}', "");
    Expect(1, 13312, '\p{^_Is_cjk_Compatibility}', "");
    Expect(1, 13312, '\P{_Is_cjk_Compatibility}', "");
    Expect(0, 13312, '\P{^_Is_cjk_Compatibility}', "");
    Error('\p{_In_cjk_COMPATIBILITY/a/}');
    Error('\P{_In_cjk_COMPATIBILITY/a/}');
    Expect(1, 13311, '\p{incjkcompatibility}', "");
    Expect(0, 13311, '\p{^incjkcompatibility}', "");
    Expect(0, 13311, '\P{incjkcompatibility}', "");
    Expect(1, 13311, '\P{^incjkcompatibility}', "");
    Expect(0, 13312, '\p{incjkcompatibility}', "");
    Expect(1, 13312, '\p{^incjkcompatibility}', "");
    Expect(1, 13312, '\P{incjkcompatibility}', "");
    Expect(0, 13312, '\P{^incjkcompatibility}', "");
    Expect(1, 13311, '\p{_	In_CJK_Compatibility}', "");
    Expect(0, 13311, '\p{^_	In_CJK_Compatibility}', "");
    Expect(0, 13311, '\P{_	In_CJK_Compatibility}', "");
    Expect(1, 13311, '\P{^_	In_CJK_Compatibility}', "");
    Expect(0, 13312, '\p{_	In_CJK_Compatibility}', "");
    Expect(1, 13312, '\p{^_	In_CJK_Compatibility}', "");
    Expect(1, 13312, '\P{_	In_CJK_Compatibility}', "");
    Expect(0, 13312, '\P{^_	In_CJK_Compatibility}', "");
    Error('\p{/a/-CJK_compat}');
    Error('\P{/a/-CJK_compat}');
    Expect(1, 13311, '\p{cjkcompat}', "");
    Expect(0, 13311, '\p{^cjkcompat}', "");
    Expect(0, 13311, '\P{cjkcompat}', "");
    Expect(1, 13311, '\P{^cjkcompat}', "");
    Expect(0, 13312, '\p{cjkcompat}', "");
    Expect(1, 13312, '\p{^cjkcompat}', "");
    Expect(1, 13312, '\P{cjkcompat}', "");
    Expect(0, 13312, '\P{^cjkcompat}', "");
    Expect(1, 13311, '\p{- CJK_COMPAT}', "");
    Expect(0, 13311, '\p{^- CJK_COMPAT}', "");
    Expect(0, 13311, '\P{- CJK_COMPAT}', "");
    Expect(1, 13311, '\P{^- CJK_COMPAT}', "");
    Expect(0, 13312, '\p{- CJK_COMPAT}', "");
    Expect(1, 13312, '\p{^- CJK_COMPAT}', "");
    Expect(1, 13312, '\P{- CJK_COMPAT}', "");
    Expect(0, 13312, '\P{^- CJK_COMPAT}', "");
    Error('\p{/a/Is_CJK_COMPAT}');
    Error('\P{/a/Is_CJK_COMPAT}');
    Expect(1, 13311, '\p{iscjkcompat}', "");
    Expect(0, 13311, '\p{^iscjkcompat}', "");
    Expect(0, 13311, '\P{iscjkcompat}', "");
    Expect(1, 13311, '\P{^iscjkcompat}', "");
    Expect(0, 13312, '\p{iscjkcompat}', "");
    Expect(1, 13312, '\p{^iscjkcompat}', "");
    Expect(1, 13312, '\P{iscjkcompat}', "");
    Expect(0, 13312, '\P{^iscjkcompat}', "");
    Expect(1, 13311, '\p{-	Is_CJK_compat}', "");
    Expect(0, 13311, '\p{^-	Is_CJK_compat}', "");
    Expect(0, 13311, '\P{-	Is_CJK_compat}', "");
    Expect(1, 13311, '\P{^-	Is_CJK_compat}', "");
    Expect(0, 13312, '\p{-	Is_CJK_compat}', "");
    Expect(1, 13312, '\p{^-	Is_CJK_compat}', "");
    Expect(1, 13312, '\P{-	Is_CJK_compat}', "");
    Expect(0, 13312, '\P{^-	Is_CJK_compat}', "");
    Error('\p{/a/	IN_cjk_COMPAT}');
    Error('\P{/a/	IN_cjk_COMPAT}');
    Expect(1, 13311, '\p{incjkcompat}', "");
    Expect(0, 13311, '\p{^incjkcompat}', "");
    Expect(0, 13311, '\P{incjkcompat}', "");
    Expect(1, 13311, '\P{^incjkcompat}', "");
    Expect(0, 13312, '\p{incjkcompat}', "");
    Expect(1, 13312, '\p{^incjkcompat}', "");
    Expect(1, 13312, '\P{incjkcompat}', "");
    Expect(0, 13312, '\P{^incjkcompat}', "");
    Expect(1, 13311, '\p{-in_CJK_compat}', "");
    Expect(0, 13311, '\p{^-in_CJK_compat}', "");
    Expect(0, 13311, '\P{-in_CJK_compat}', "");
    Expect(1, 13311, '\P{^-in_CJK_compat}', "");
    Expect(0, 13312, '\p{-in_CJK_compat}', "");
    Expect(1, 13312, '\p{^-in_CJK_compat}', "");
    Expect(1, 13312, '\P{-in_CJK_compat}', "");
    Expect(0, 13312, '\P{^-in_CJK_compat}', "");
    Error('\p{_CJK_Compatibility_Forms:=}');
    Error('\P{_CJK_Compatibility_Forms:=}');
    Expect(1, 65103, '\p{cjkcompatibilityforms}', "");
    Expect(0, 65103, '\p{^cjkcompatibilityforms}', "");
    Expect(0, 65103, '\P{cjkcompatibilityforms}', "");
    Expect(1, 65103, '\P{^cjkcompatibilityforms}', "");
    Expect(0, 65104, '\p{cjkcompatibilityforms}', "");
    Expect(1, 65104, '\p{^cjkcompatibilityforms}', "");
    Expect(1, 65104, '\P{cjkcompatibilityforms}', "");
    Expect(0, 65104, '\P{^cjkcompatibilityforms}', "");
    Expect(1, 65103, '\p{	 cjk_Compatibility_Forms}', "");
    Expect(0, 65103, '\p{^	 cjk_Compatibility_Forms}', "");
    Expect(0, 65103, '\P{	 cjk_Compatibility_Forms}', "");
    Expect(1, 65103, '\P{^	 cjk_Compatibility_Forms}', "");
    Expect(0, 65104, '\p{	 cjk_Compatibility_Forms}', "");
    Expect(1, 65104, '\p{^	 cjk_Compatibility_Forms}', "");
    Expect(1, 65104, '\P{	 cjk_Compatibility_Forms}', "");
    Expect(0, 65104, '\P{^	 cjk_Compatibility_Forms}', "");
    Error('\p{ IS_CJK_Compatibility_Forms/a/}');
    Error('\P{ IS_CJK_Compatibility_Forms/a/}');
    Expect(1, 65103, '\p{iscjkcompatibilityforms}', "");
    Expect(0, 65103, '\p{^iscjkcompatibilityforms}', "");
    Expect(0, 65103, '\P{iscjkcompatibilityforms}', "");
    Expect(1, 65103, '\P{^iscjkcompatibilityforms}', "");
    Expect(0, 65104, '\p{iscjkcompatibilityforms}', "");
    Expect(1, 65104, '\p{^iscjkcompatibilityforms}', "");
    Expect(1, 65104, '\P{iscjkcompatibilityforms}', "");
    Expect(0, 65104, '\P{^iscjkcompatibilityforms}', "");
    Expect(1, 65103, '\p{IS_cjk_Compatibility_Forms}', "");
    Expect(0, 65103, '\p{^IS_cjk_Compatibility_Forms}', "");
    Expect(0, 65103, '\P{IS_cjk_Compatibility_Forms}', "");
    Expect(1, 65103, '\P{^IS_cjk_Compatibility_Forms}', "");
    Expect(0, 65104, '\p{IS_cjk_Compatibility_Forms}', "");
    Expect(1, 65104, '\p{^IS_cjk_Compatibility_Forms}', "");
    Expect(1, 65104, '\P{IS_cjk_Compatibility_Forms}', "");
    Expect(0, 65104, '\P{^IS_cjk_Compatibility_Forms}', "");
    Error('\p{:=_in_cjk_COMPATIBILITY_Forms}');
    Error('\P{:=_in_cjk_COMPATIBILITY_Forms}');
    Expect(1, 65103, '\p{incjkcompatibilityforms}', "");
    Expect(0, 65103, '\p{^incjkcompatibilityforms}', "");
    Expect(0, 65103, '\P{incjkcompatibilityforms}', "");
    Expect(1, 65103, '\P{^incjkcompatibilityforms}', "");
    Expect(0, 65104, '\p{incjkcompatibilityforms}', "");
    Expect(1, 65104, '\p{^incjkcompatibilityforms}', "");
    Expect(1, 65104, '\P{incjkcompatibilityforms}', "");
    Expect(0, 65104, '\P{^incjkcompatibilityforms}', "");
    Expect(1, 65103, '\p{-In_CJK_COMPATIBILITY_Forms}', "");
    Expect(0, 65103, '\p{^-In_CJK_COMPATIBILITY_Forms}', "");
    Expect(0, 65103, '\P{-In_CJK_COMPATIBILITY_Forms}', "");
    Expect(1, 65103, '\P{^-In_CJK_COMPATIBILITY_Forms}', "");
    Expect(0, 65104, '\p{-In_CJK_COMPATIBILITY_Forms}', "");
    Expect(1, 65104, '\p{^-In_CJK_COMPATIBILITY_Forms}', "");
    Expect(1, 65104, '\P{-In_CJK_COMPATIBILITY_Forms}', "");
    Expect(0, 65104, '\P{^-In_CJK_COMPATIBILITY_Forms}', "");
    Error('\p{_/a/CJK_COMPAT_FORMS}');
    Error('\P{_/a/CJK_COMPAT_FORMS}');
    Expect(1, 65103, '\p{cjkcompatforms}', "");
    Expect(0, 65103, '\p{^cjkcompatforms}', "");
    Expect(0, 65103, '\P{cjkcompatforms}', "");
    Expect(1, 65103, '\P{^cjkcompatforms}', "");
    Expect(0, 65104, '\p{cjkcompatforms}', "");
    Expect(1, 65104, '\p{^cjkcompatforms}', "");
    Expect(1, 65104, '\P{cjkcompatforms}', "");
    Expect(0, 65104, '\P{^cjkcompatforms}', "");
    Expect(1, 65103, '\p{  CJK_compat_Forms}', "");
    Expect(0, 65103, '\p{^  CJK_compat_Forms}', "");
    Expect(0, 65103, '\P{  CJK_compat_Forms}', "");
    Expect(1, 65103, '\P{^  CJK_compat_Forms}', "");
    Expect(0, 65104, '\p{  CJK_compat_Forms}', "");
    Expect(1, 65104, '\p{^  CJK_compat_Forms}', "");
    Expect(1, 65104, '\P{  CJK_compat_Forms}', "");
    Expect(0, 65104, '\P{^  CJK_compat_Forms}', "");
    Error('\p{:= _is_CJK_COMPAT_Forms}');
    Error('\P{:= _is_CJK_COMPAT_Forms}');
    Expect(1, 65103, '\p{iscjkcompatforms}', "");
    Expect(0, 65103, '\p{^iscjkcompatforms}', "");
    Expect(0, 65103, '\P{iscjkcompatforms}', "");
    Expect(1, 65103, '\P{^iscjkcompatforms}', "");
    Expect(0, 65104, '\p{iscjkcompatforms}', "");
    Expect(1, 65104, '\p{^iscjkcompatforms}', "");
    Expect(1, 65104, '\P{iscjkcompatforms}', "");
    Expect(0, 65104, '\P{^iscjkcompatforms}', "");
    Expect(1, 65103, '\p{- IS_CJK_Compat_FORMS}', "");
    Expect(0, 65103, '\p{^- IS_CJK_Compat_FORMS}', "");
    Expect(0, 65103, '\P{- IS_CJK_Compat_FORMS}', "");
    Expect(1, 65103, '\P{^- IS_CJK_Compat_FORMS}', "");
    Expect(0, 65104, '\p{- IS_CJK_Compat_FORMS}', "");
    Expect(1, 65104, '\p{^- IS_CJK_Compat_FORMS}', "");
    Expect(1, 65104, '\P{- IS_CJK_Compat_FORMS}', "");
    Expect(0, 65104, '\P{^- IS_CJK_Compat_FORMS}', "");
    Error('\p{ in_CJK_Compat_FORMS/a/}');
    Error('\P{ in_CJK_Compat_FORMS/a/}');
    Expect(1, 65103, '\p{incjkcompatforms}', "");
    Expect(0, 65103, '\p{^incjkcompatforms}', "");
    Expect(0, 65103, '\P{incjkcompatforms}', "");
    Expect(1, 65103, '\P{^incjkcompatforms}', "");
    Expect(0, 65104, '\p{incjkcompatforms}', "");
    Expect(1, 65104, '\p{^incjkcompatforms}', "");
    Expect(1, 65104, '\P{incjkcompatforms}', "");
    Expect(0, 65104, '\P{^incjkcompatforms}', "");
    Expect(1, 65103, '\p{--IN_CJK_Compat_Forms}', "");
    Expect(0, 65103, '\p{^--IN_CJK_Compat_Forms}', "");
    Expect(0, 65103, '\P{--IN_CJK_Compat_Forms}', "");
    Expect(1, 65103, '\P{^--IN_CJK_Compat_Forms}', "");
    Expect(0, 65104, '\p{--IN_CJK_Compat_Forms}', "");
    Expect(1, 65104, '\p{^--IN_CJK_Compat_Forms}', "");
    Expect(1, 65104, '\P{--IN_CJK_Compat_Forms}', "");
    Expect(0, 65104, '\P{^--IN_CJK_Compat_Forms}', "");
    Error('\p{-/a/cjk_compatibility_IDEOGRAPHS}');
    Error('\P{-/a/cjk_compatibility_IDEOGRAPHS}');
    Expect(1, 64255, '\p{cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\p{^cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\P{cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\P{^cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\p{cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\p{^cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\P{cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\P{^cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\p{- CJK_Compatibility_IDEOGRAPHS}', "");
    Expect(0, 64255, '\p{^- CJK_Compatibility_IDEOGRAPHS}', "");
    Expect(0, 64255, '\P{- CJK_Compatibility_IDEOGRAPHS}', "");
    Expect(1, 64255, '\P{^- CJK_Compatibility_IDEOGRAPHS}', "");
    Expect(0, 64256, '\p{- CJK_Compatibility_IDEOGRAPHS}', "");
    Expect(1, 64256, '\p{^- CJK_Compatibility_IDEOGRAPHS}', "");
    Expect(1, 64256, '\P{- CJK_Compatibility_IDEOGRAPHS}', "");
    Expect(0, 64256, '\P{^- CJK_Compatibility_IDEOGRAPHS}', "");
    Error('\p{is_CJK_Compatibility_IDEOGRAPHS:=}');
    Error('\P{is_CJK_Compatibility_IDEOGRAPHS:=}');
    Expect(1, 64255, '\p{iscjkcompatibilityideographs}', "");
    Expect(0, 64255, '\p{^iscjkcompatibilityideographs}', "");
    Expect(0, 64255, '\P{iscjkcompatibilityideographs}', "");
    Expect(1, 64255, '\P{^iscjkcompatibilityideographs}', "");
    Expect(0, 64256, '\p{iscjkcompatibilityideographs}', "");
    Expect(1, 64256, '\p{^iscjkcompatibilityideographs}', "");
    Expect(1, 64256, '\P{iscjkcompatibilityideographs}', "");
    Expect(0, 64256, '\P{^iscjkcompatibilityideographs}', "");
    Expect(1, 64255, '\p{ Is_CJK_compatibility_ideographs}', "");
    Expect(0, 64255, '\p{^ Is_CJK_compatibility_ideographs}', "");
    Expect(0, 64255, '\P{ Is_CJK_compatibility_ideographs}', "");
    Expect(1, 64255, '\P{^ Is_CJK_compatibility_ideographs}', "");
    Expect(0, 64256, '\p{ Is_CJK_compatibility_ideographs}', "");
    Expect(1, 64256, '\p{^ Is_CJK_compatibility_ideographs}', "");
    Expect(1, 64256, '\P{ Is_CJK_compatibility_ideographs}', "");
    Expect(0, 64256, '\P{^ Is_CJK_compatibility_ideographs}', "");
    Error('\p{/a/In_cjk_COMPATIBILITY_IDEOGRAPHS}');
    Error('\P{/a/In_cjk_COMPATIBILITY_IDEOGRAPHS}');
    Expect(1, 64255, '\p{incjkcompatibilityideographs}', "");
    Expect(0, 64255, '\p{^incjkcompatibilityideographs}', "");
    Expect(0, 64255, '\P{incjkcompatibilityideographs}', "");
    Expect(1, 64255, '\P{^incjkcompatibilityideographs}', "");
    Expect(0, 64256, '\p{incjkcompatibilityideographs}', "");
    Expect(1, 64256, '\p{^incjkcompatibilityideographs}', "");
    Expect(1, 64256, '\P{incjkcompatibilityideographs}', "");
    Expect(0, 64256, '\P{^incjkcompatibilityideographs}', "");
    Expect(1, 64255, '\p{_in_cjk_compatibility_Ideographs}', "");
    Expect(0, 64255, '\p{^_in_cjk_compatibility_Ideographs}', "");
    Expect(0, 64255, '\P{_in_cjk_compatibility_Ideographs}', "");
    Expect(1, 64255, '\P{^_in_cjk_compatibility_Ideographs}', "");
    Expect(0, 64256, '\p{_in_cjk_compatibility_Ideographs}', "");
    Expect(1, 64256, '\p{^_in_cjk_compatibility_Ideographs}', "");
    Expect(1, 64256, '\P{_in_cjk_compatibility_Ideographs}', "");
    Expect(0, 64256, '\P{^_in_cjk_compatibility_Ideographs}', "");
    Error('\p{  CJK_compat_ideographs:=}');
    Error('\P{  CJK_compat_ideographs:=}');
    Expect(1, 64255, '\p{cjkcompatideographs}', "");
    Expect(0, 64255, '\p{^cjkcompatideographs}', "");
    Expect(0, 64255, '\P{cjkcompatideographs}', "");
    Expect(1, 64255, '\P{^cjkcompatideographs}', "");
    Expect(0, 64256, '\p{cjkcompatideographs}', "");
    Expect(1, 64256, '\p{^cjkcompatideographs}', "");
    Expect(1, 64256, '\P{cjkcompatideographs}', "");
    Expect(0, 64256, '\P{^cjkcompatideographs}', "");
    Expect(1, 64255, '\p{_	CJK_Compat_Ideographs}', "");
    Expect(0, 64255, '\p{^_	CJK_Compat_Ideographs}', "");
    Expect(0, 64255, '\P{_	CJK_Compat_Ideographs}', "");
    Expect(1, 64255, '\P{^_	CJK_Compat_Ideographs}', "");
    Expect(0, 64256, '\p{_	CJK_Compat_Ideographs}', "");
    Expect(1, 64256, '\p{^_	CJK_Compat_Ideographs}', "");
    Expect(1, 64256, '\P{_	CJK_Compat_Ideographs}', "");
    Expect(0, 64256, '\P{^_	CJK_Compat_Ideographs}', "");
    Error('\p{:=_	Is_CJK_Compat_Ideographs}');
    Error('\P{:=_	Is_CJK_Compat_Ideographs}');
    Expect(1, 64255, '\p{iscjkcompatideographs}', "");
    Expect(0, 64255, '\p{^iscjkcompatideographs}', "");
    Expect(0, 64255, '\P{iscjkcompatideographs}', "");
    Expect(1, 64255, '\P{^iscjkcompatideographs}', "");
    Expect(0, 64256, '\p{iscjkcompatideographs}', "");
    Expect(1, 64256, '\p{^iscjkcompatideographs}', "");
    Expect(1, 64256, '\P{iscjkcompatideographs}', "");
    Expect(0, 64256, '\P{^iscjkcompatideographs}', "");
    Expect(1, 64255, '\p{_IS_CJK_Compat_ideographs}', "");
    Expect(0, 64255, '\p{^_IS_CJK_Compat_ideographs}', "");
    Expect(0, 64255, '\P{_IS_CJK_Compat_ideographs}', "");
    Expect(1, 64255, '\P{^_IS_CJK_Compat_ideographs}', "");
    Expect(0, 64256, '\p{_IS_CJK_Compat_ideographs}', "");
    Expect(1, 64256, '\p{^_IS_CJK_Compat_ideographs}', "");
    Expect(1, 64256, '\P{_IS_CJK_Compat_ideographs}', "");
    Expect(0, 64256, '\P{^_IS_CJK_Compat_ideographs}', "");
    Error('\p{_/a/IN_CJK_COMPAT_Ideographs}');
    Error('\P{_/a/IN_CJK_COMPAT_Ideographs}');
    Expect(1, 64255, '\p{incjkcompatideographs}', "");
    Expect(0, 64255, '\p{^incjkcompatideographs}', "");
    Expect(0, 64255, '\P{incjkcompatideographs}', "");
    Expect(1, 64255, '\P{^incjkcompatideographs}', "");
    Expect(0, 64256, '\p{incjkcompatideographs}', "");
    Expect(1, 64256, '\p{^incjkcompatideographs}', "");
    Expect(1, 64256, '\P{incjkcompatideographs}', "");
    Expect(0, 64256, '\P{^incjkcompatideographs}', "");
    Expect(1, 64255, '\p{_ In_CJK_compat_IDEOGRAPHS}', "");
    Expect(0, 64255, '\p{^_ In_CJK_compat_IDEOGRAPHS}', "");
    Expect(0, 64255, '\P{_ In_CJK_compat_IDEOGRAPHS}', "");
    Expect(1, 64255, '\P{^_ In_CJK_compat_IDEOGRAPHS}', "");
    Expect(0, 64256, '\p{_ In_CJK_compat_IDEOGRAPHS}', "");
    Expect(1, 64256, '\p{^_ In_CJK_compat_IDEOGRAPHS}', "");
    Expect(1, 64256, '\P{_ In_CJK_compat_IDEOGRAPHS}', "");
    Expect(0, 64256, '\P{^_ In_CJK_compat_IDEOGRAPHS}', "");
    Error('\p{_-cjk_Compatibility_ideographs_supplement:=}');
    Error('\P{_-cjk_Compatibility_ideographs_supplement:=}');
    Expect(1, 195103, '\p{cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\p{^cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\P{cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\P{^cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\p{cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\p{^cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\P{cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\P{^cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\p{_CJK_Compatibility_Ideographs_Supplement}', "");
    Expect(0, 195103, '\p{^_CJK_Compatibility_Ideographs_Supplement}', "");
    Expect(0, 195103, '\P{_CJK_Compatibility_Ideographs_Supplement}', "");
    Expect(1, 195103, '\P{^_CJK_Compatibility_Ideographs_Supplement}', "");
    Expect(0, 195104, '\p{_CJK_Compatibility_Ideographs_Supplement}', "");
    Expect(1, 195104, '\p{^_CJK_Compatibility_Ideographs_Supplement}', "");
    Expect(1, 195104, '\P{_CJK_Compatibility_Ideographs_Supplement}', "");
    Expect(0, 195104, '\P{^_CJK_Compatibility_Ideographs_Supplement}', "");
    Error('\p{-:=Is_CJK_compatibility_IDEOGRAPHS_supplement}');
    Error('\P{-:=Is_CJK_compatibility_IDEOGRAPHS_supplement}');
    Expect(1, 195103, '\p{iscjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\p{^iscjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\P{iscjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\P{^iscjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\p{iscjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\p{^iscjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\P{iscjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\P{^iscjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\p{ _Is_cjk_COMPATIBILITY_Ideographs_SUPPLEMENT}', "");
    Expect(0, 195103, '\p{^ _Is_cjk_COMPATIBILITY_Ideographs_SUPPLEMENT}', "");
    Expect(0, 195103, '\P{ _Is_cjk_COMPATIBILITY_Ideographs_SUPPLEMENT}', "");
    Expect(1, 195103, '\P{^ _Is_cjk_COMPATIBILITY_Ideographs_SUPPLEMENT}', "");
    Expect(0, 195104, '\p{ _Is_cjk_COMPATIBILITY_Ideographs_SUPPLEMENT}', "");
    Expect(1, 195104, '\p{^ _Is_cjk_COMPATIBILITY_Ideographs_SUPPLEMENT}', "");
    Expect(1, 195104, '\P{ _Is_cjk_COMPATIBILITY_Ideographs_SUPPLEMENT}', "");
    Expect(0, 195104, '\P{^ _Is_cjk_COMPATIBILITY_Ideographs_SUPPLEMENT}', "");
    Error('\p{ :=In_cjk_COMPATIBILITY_Ideographs_SUPPLEMENT}');
    Error('\P{ :=In_cjk_COMPATIBILITY_Ideographs_SUPPLEMENT}');
    Expect(1, 195103, '\p{incjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\p{^incjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\P{incjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\P{^incjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\p{incjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\p{^incjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\P{incjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\P{^incjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\p{_In_CJK_compatibility_ideographs_Supplement}', "");
    Expect(0, 195103, '\p{^_In_CJK_compatibility_ideographs_Supplement}', "");
    Expect(0, 195103, '\P{_In_CJK_compatibility_ideographs_Supplement}', "");
    Expect(1, 195103, '\P{^_In_CJK_compatibility_ideographs_Supplement}', "");
    Expect(0, 195104, '\p{_In_CJK_compatibility_ideographs_Supplement}', "");
    Expect(1, 195104, '\p{^_In_CJK_compatibility_ideographs_Supplement}', "");
    Expect(1, 195104, '\P{_In_CJK_compatibility_ideographs_Supplement}', "");
    Expect(0, 195104, '\P{^_In_CJK_compatibility_ideographs_Supplement}', "");
    Error('\p{-:=CJK_compat_IDEOGRAPHS_Sup}');
    Error('\P{-:=CJK_compat_IDEOGRAPHS_Sup}');
    Expect(1, 195103, '\p{cjkcompatideographssup}', "");
    Expect(0, 195103, '\p{^cjkcompatideographssup}', "");
    Expect(0, 195103, '\P{cjkcompatideographssup}', "");
    Expect(1, 195103, '\P{^cjkcompatideographssup}', "");
    Expect(0, 195104, '\p{cjkcompatideographssup}', "");
    Expect(1, 195104, '\p{^cjkcompatideographssup}', "");
    Expect(1, 195104, '\P{cjkcompatideographssup}', "");
    Expect(0, 195104, '\P{^cjkcompatideographssup}', "");
    Expect(1, 195103, '\p{ 	cjk_Compat_IDEOGRAPHS_Sup}', "");
    Expect(0, 195103, '\p{^ 	cjk_Compat_IDEOGRAPHS_Sup}', "");
    Expect(0, 195103, '\P{ 	cjk_Compat_IDEOGRAPHS_Sup}', "");
    Expect(1, 195103, '\P{^ 	cjk_Compat_IDEOGRAPHS_Sup}', "");
    Expect(0, 195104, '\p{ 	cjk_Compat_IDEOGRAPHS_Sup}', "");
    Expect(1, 195104, '\p{^ 	cjk_Compat_IDEOGRAPHS_Sup}', "");
    Expect(1, 195104, '\P{ 	cjk_Compat_IDEOGRAPHS_Sup}', "");
    Expect(0, 195104, '\P{^ 	cjk_Compat_IDEOGRAPHS_Sup}', "");
    Error('\p{/a/Is_CJK_COMPAT_ideographs_SUP}');
    Error('\P{/a/Is_CJK_COMPAT_ideographs_SUP}');
    Expect(1, 195103, '\p{iscjkcompatideographssup}', "");
    Expect(0, 195103, '\p{^iscjkcompatideographssup}', "");
    Expect(0, 195103, '\P{iscjkcompatideographssup}', "");
    Expect(1, 195103, '\P{^iscjkcompatideographssup}', "");
    Expect(0, 195104, '\p{iscjkcompatideographssup}', "");
    Expect(1, 195104, '\p{^iscjkcompatideographssup}', "");
    Expect(1, 195104, '\P{iscjkcompatideographssup}', "");
    Expect(0, 195104, '\P{^iscjkcompatideographssup}', "");
    Expect(1, 195103, '\p{	_Is_CJK_COMPAT_Ideographs_SUP}', "");
    Expect(0, 195103, '\p{^	_Is_CJK_COMPAT_Ideographs_SUP}', "");
    Expect(0, 195103, '\P{	_Is_CJK_COMPAT_Ideographs_SUP}', "");
    Expect(1, 195103, '\P{^	_Is_CJK_COMPAT_Ideographs_SUP}', "");
    Expect(0, 195104, '\p{	_Is_CJK_COMPAT_Ideographs_SUP}', "");
    Expect(1, 195104, '\p{^	_Is_CJK_COMPAT_Ideographs_SUP}', "");
    Expect(1, 195104, '\P{	_Is_CJK_COMPAT_Ideographs_SUP}', "");
    Expect(0, 195104, '\P{^	_Is_CJK_COMPAT_Ideographs_SUP}', "");
    Error('\p{:=-In_cjk_COMPAT_ideographs_SUP}');
    Error('\P{:=-In_cjk_COMPAT_ideographs_SUP}');
    Expect(1, 195103, '\p{incjkcompatideographssup}', "");
    Expect(0, 195103, '\p{^incjkcompatideographssup}', "");
    Expect(0, 195103, '\P{incjkcompatideographssup}', "");
    Expect(1, 195103, '\P{^incjkcompatideographssup}', "");
    Expect(0, 195104, '\p{incjkcompatideographssup}', "");
    Expect(1, 195104, '\p{^incjkcompatideographssup}', "");
    Expect(1, 195104, '\P{incjkcompatideographssup}', "");
    Expect(0, 195104, '\P{^incjkcompatideographssup}', "");
    Expect(1, 195103, '\p{ 	In_cjk_Compat_Ideographs_sup}', "");
    Expect(0, 195103, '\p{^ 	In_cjk_Compat_Ideographs_sup}', "");
    Expect(0, 195103, '\P{ 	In_cjk_Compat_Ideographs_sup}', "");
    Expect(1, 195103, '\P{^ 	In_cjk_Compat_Ideographs_sup}', "");
    Expect(0, 195104, '\p{ 	In_cjk_Compat_Ideographs_sup}', "");
    Expect(1, 195104, '\p{^ 	In_cjk_Compat_Ideographs_sup}', "");
    Expect(1, 195104, '\P{ 	In_cjk_Compat_Ideographs_sup}', "");
    Expect(0, 195104, '\P{^ 	In_cjk_Compat_Ideographs_sup}', "");
    Error('\p{/a/	CJK_radicals_supplement}');
    Error('\P{/a/	CJK_radicals_supplement}');
    Expect(1, 12031, '\p{cjkradicalssupplement}', "");
    Expect(0, 12031, '\p{^cjkradicalssupplement}', "");
    Expect(0, 12031, '\P{cjkradicalssupplement}', "");
    Expect(1, 12031, '\P{^cjkradicalssupplement}', "");
    Expect(0, 12032, '\p{cjkradicalssupplement}', "");
    Expect(1, 12032, '\p{^cjkradicalssupplement}', "");
    Expect(1, 12032, '\P{cjkradicalssupplement}', "");
    Expect(0, 12032, '\P{^cjkradicalssupplement}', "");
    Expect(1, 12031, '\p{_	cjk_RADICALS_Supplement}', "");
    Expect(0, 12031, '\p{^_	cjk_RADICALS_Supplement}', "");
    Expect(0, 12031, '\P{_	cjk_RADICALS_Supplement}', "");
    Expect(1, 12031, '\P{^_	cjk_RADICALS_Supplement}', "");
    Expect(0, 12032, '\p{_	cjk_RADICALS_Supplement}', "");
    Expect(1, 12032, '\p{^_	cjk_RADICALS_Supplement}', "");
    Expect(1, 12032, '\P{_	cjk_RADICALS_Supplement}', "");
    Expect(0, 12032, '\P{^_	cjk_RADICALS_Supplement}', "");
    Error('\p{/a/_	is_CJK_Radicals_SUPPLEMENT}');
    Error('\P{/a/_	is_CJK_Radicals_SUPPLEMENT}');
    Expect(1, 12031, '\p{iscjkradicalssupplement}', "");
    Expect(0, 12031, '\p{^iscjkradicalssupplement}', "");
    Expect(0, 12031, '\P{iscjkradicalssupplement}', "");
    Expect(1, 12031, '\P{^iscjkradicalssupplement}', "");
    Expect(0, 12032, '\p{iscjkradicalssupplement}', "");
    Expect(1, 12032, '\p{^iscjkradicalssupplement}', "");
    Expect(1, 12032, '\P{iscjkradicalssupplement}', "");
    Expect(0, 12032, '\P{^iscjkradicalssupplement}', "");
    Expect(1, 12031, '\p{-	Is_CJK_Radicals_supplement}', "");
    Expect(0, 12031, '\p{^-	Is_CJK_Radicals_supplement}', "");
    Expect(0, 12031, '\P{-	Is_CJK_Radicals_supplement}', "");
    Expect(1, 12031, '\P{^-	Is_CJK_Radicals_supplement}', "");
    Expect(0, 12032, '\p{-	Is_CJK_Radicals_supplement}', "");
    Expect(1, 12032, '\p{^-	Is_CJK_Radicals_supplement}', "");
    Expect(1, 12032, '\P{-	Is_CJK_Radicals_supplement}', "");
    Expect(0, 12032, '\P{^-	Is_CJK_Radicals_supplement}', "");
    Error('\p{ :=In_CJK_Radicals_Supplement}');
    Error('\P{ :=In_CJK_Radicals_Supplement}');
    Expect(1, 12031, '\p{incjkradicalssupplement}', "");
    Expect(0, 12031, '\p{^incjkradicalssupplement}', "");
    Expect(0, 12031, '\P{incjkradicalssupplement}', "");
    Expect(1, 12031, '\P{^incjkradicalssupplement}', "");
    Expect(0, 12032, '\p{incjkradicalssupplement}', "");
    Expect(1, 12032, '\p{^incjkradicalssupplement}', "");
    Expect(1, 12032, '\P{incjkradicalssupplement}', "");
    Expect(0, 12032, '\P{^incjkradicalssupplement}', "");
    Expect(1, 12031, '\p{-In_CJK_radicals_SUPPLEMENT}', "");
    Expect(0, 12031, '\p{^-In_CJK_radicals_SUPPLEMENT}', "");
    Expect(0, 12031, '\P{-In_CJK_radicals_SUPPLEMENT}', "");
    Expect(1, 12031, '\P{^-In_CJK_radicals_SUPPLEMENT}', "");
    Expect(0, 12032, '\p{-In_CJK_radicals_SUPPLEMENT}', "");
    Expect(1, 12032, '\p{^-In_CJK_radicals_SUPPLEMENT}', "");
    Expect(1, 12032, '\P{-In_CJK_radicals_SUPPLEMENT}', "");
    Expect(0, 12032, '\P{^-In_CJK_radicals_SUPPLEMENT}', "");
    Error('\p{	:=CJK_RADICALS_Sup}');
    Error('\P{	:=CJK_RADICALS_Sup}');
    Expect(1, 12031, '\p{cjkradicalssup}', "");
    Expect(0, 12031, '\p{^cjkradicalssup}', "");
    Expect(0, 12031, '\P{cjkradicalssup}', "");
    Expect(1, 12031, '\P{^cjkradicalssup}', "");
    Expect(0, 12032, '\p{cjkradicalssup}', "");
    Expect(1, 12032, '\p{^cjkradicalssup}', "");
    Expect(1, 12032, '\P{cjkradicalssup}', "");
    Expect(0, 12032, '\P{^cjkradicalssup}', "");
    Expect(1, 12031, '\p{ 	CJK_Radicals_SUP}', "");
    Expect(0, 12031, '\p{^ 	CJK_Radicals_SUP}', "");
    Expect(0, 12031, '\P{ 	CJK_Radicals_SUP}', "");
    Expect(1, 12031, '\P{^ 	CJK_Radicals_SUP}', "");
    Expect(0, 12032, '\p{ 	CJK_Radicals_SUP}', "");
    Expect(1, 12032, '\p{^ 	CJK_Radicals_SUP}', "");
    Expect(1, 12032, '\P{ 	CJK_Radicals_SUP}', "");
    Expect(0, 12032, '\P{^ 	CJK_Radicals_SUP}', "");
    Error('\p{_/a/IS_cjk_Radicals_Sup}');
    Error('\P{_/a/IS_cjk_Radicals_Sup}');
    Expect(1, 12031, '\p{iscjkradicalssup}', "");
    Expect(0, 12031, '\p{^iscjkradicalssup}', "");
    Expect(0, 12031, '\P{iscjkradicalssup}', "");
    Expect(1, 12031, '\P{^iscjkradicalssup}', "");
    Expect(0, 12032, '\p{iscjkradicalssup}', "");
    Expect(1, 12032, '\p{^iscjkradicalssup}', "");
    Expect(1, 12032, '\P{iscjkradicalssup}', "");
    Expect(0, 12032, '\P{^iscjkradicalssup}', "");
    Expect(1, 12031, '\p{-	Is_cjk_RADICALS_SUP}', "");
    Expect(0, 12031, '\p{^-	Is_cjk_RADICALS_SUP}', "");
    Expect(0, 12031, '\P{-	Is_cjk_RADICALS_SUP}', "");
    Expect(1, 12031, '\P{^-	Is_cjk_RADICALS_SUP}', "");
    Expect(0, 12032, '\p{-	Is_cjk_RADICALS_SUP}', "");
    Expect(1, 12032, '\p{^-	Is_cjk_RADICALS_SUP}', "");
    Expect(1, 12032, '\P{-	Is_cjk_RADICALS_SUP}', "");
    Expect(0, 12032, '\P{^-	Is_cjk_RADICALS_SUP}', "");
    Error('\p{_/a/In_CJK_radicals_sup}');
    Error('\P{_/a/In_CJK_radicals_sup}');
    Expect(1, 12031, '\p{incjkradicalssup}', "");
    Expect(0, 12031, '\p{^incjkradicalssup}', "");
    Expect(0, 12031, '\P{incjkradicalssup}', "");
    Expect(1, 12031, '\P{^incjkradicalssup}', "");
    Expect(0, 12032, '\p{incjkradicalssup}', "");
    Expect(1, 12032, '\p{^incjkradicalssup}', "");
    Expect(1, 12032, '\P{incjkradicalssup}', "");
    Expect(0, 12032, '\P{^incjkradicalssup}', "");
    Expect(1, 12031, '\p{_	In_CJK_radicals_SUP}', "");
    Expect(0, 12031, '\p{^_	In_CJK_radicals_SUP}', "");
    Expect(0, 12031, '\P{_	In_CJK_radicals_SUP}', "");
    Expect(1, 12031, '\P{^_	In_CJK_radicals_SUP}', "");
    Expect(0, 12032, '\p{_	In_CJK_radicals_SUP}', "");
    Expect(1, 12032, '\p{^_	In_CJK_radicals_SUP}', "");
    Expect(1, 12032, '\P{_	In_CJK_radicals_SUP}', "");
    Expect(0, 12032, '\P{^_	In_CJK_radicals_SUP}', "");
    Error('\p{:=CJK_Strokes}');
    Error('\P{:=CJK_Strokes}');
    Expect(1, 12783, '\p{cjkstrokes}', "");
    Expect(0, 12783, '\p{^cjkstrokes}', "");
    Expect(0, 12783, '\P{cjkstrokes}', "");
    Expect(1, 12783, '\P{^cjkstrokes}', "");
    Expect(0, 12784, '\p{cjkstrokes}', "");
    Expect(1, 12784, '\p{^cjkstrokes}', "");
    Expect(1, 12784, '\P{cjkstrokes}', "");
    Expect(0, 12784, '\P{^cjkstrokes}', "");
    Expect(1, 12783, '\p{ _CJK_Strokes}', "");
    Expect(0, 12783, '\p{^ _CJK_Strokes}', "");
    Expect(0, 12783, '\P{ _CJK_Strokes}', "");
    Expect(1, 12783, '\P{^ _CJK_Strokes}', "");
    Expect(0, 12784, '\p{ _CJK_Strokes}', "");
    Expect(1, 12784, '\p{^ _CJK_Strokes}', "");
    Expect(1, 12784, '\P{ _CJK_Strokes}', "");
    Expect(0, 12784, '\P{^ _CJK_Strokes}', "");
    Error('\p{	-is_cjk_Strokes:=}');
    Error('\P{	-is_cjk_Strokes:=}');
    Expect(1, 12783, '\p{iscjkstrokes}', "");
    Expect(0, 12783, '\p{^iscjkstrokes}', "");
    Expect(0, 12783, '\P{iscjkstrokes}', "");
    Expect(1, 12783, '\P{^iscjkstrokes}', "");
    Expect(0, 12784, '\p{iscjkstrokes}', "");
    Expect(1, 12784, '\p{^iscjkstrokes}', "");
    Expect(1, 12784, '\P{iscjkstrokes}', "");
    Expect(0, 12784, '\P{^iscjkstrokes}', "");
    Expect(1, 12783, '\p{-_Is_CJK_strokes}', "");
    Expect(0, 12783, '\p{^-_Is_CJK_strokes}', "");
    Expect(0, 12783, '\P{-_Is_CJK_strokes}', "");
    Expect(1, 12783, '\P{^-_Is_CJK_strokes}', "");
    Expect(0, 12784, '\p{-_Is_CJK_strokes}', "");
    Expect(1, 12784, '\p{^-_Is_CJK_strokes}', "");
    Expect(1, 12784, '\P{-_Is_CJK_strokes}', "");
    Expect(0, 12784, '\P{^-_Is_CJK_strokes}', "");
    Error('\p{_/a/in_CJK_Strokes}');
    Error('\P{_/a/in_CJK_Strokes}');
    Expect(1, 12783, '\p{incjkstrokes}', "");
    Expect(0, 12783, '\p{^incjkstrokes}', "");
    Expect(0, 12783, '\P{incjkstrokes}', "");
    Expect(1, 12783, '\P{^incjkstrokes}', "");
    Expect(0, 12784, '\p{incjkstrokes}', "");
    Expect(1, 12784, '\p{^incjkstrokes}', "");
    Expect(1, 12784, '\P{incjkstrokes}', "");
    Expect(0, 12784, '\P{^incjkstrokes}', "");
    Expect(1, 12783, '\p{-In_CJK_Strokes}', "");
    Expect(0, 12783, '\p{^-In_CJK_Strokes}', "");
    Expect(0, 12783, '\P{-In_CJK_Strokes}', "");
    Expect(1, 12783, '\P{^-In_CJK_Strokes}', "");
    Expect(0, 12784, '\p{-In_CJK_Strokes}', "");
    Expect(1, 12784, '\p{^-In_CJK_Strokes}', "");
    Expect(1, 12784, '\P{-In_CJK_Strokes}', "");
    Expect(0, 12784, '\P{^-In_CJK_Strokes}', "");
    Error('\p{/a/_CJK_Symbols_and_punctuation}');
    Error('\P{/a/_CJK_Symbols_and_punctuation}');
    Expect(1, 12351, '\p{cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\p{^cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\P{cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\P{^cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\p{cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\p{^cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\P{cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\P{^cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\p{	-CJK_Symbols_and_punctuation}', "");
    Expect(0, 12351, '\p{^	-CJK_Symbols_and_punctuation}', "");
    Expect(0, 12351, '\P{	-CJK_Symbols_and_punctuation}', "");
    Expect(1, 12351, '\P{^	-CJK_Symbols_and_punctuation}', "");
    Expect(0, 12352, '\p{	-CJK_Symbols_and_punctuation}', "");
    Expect(1, 12352, '\p{^	-CJK_Symbols_and_punctuation}', "");
    Expect(1, 12352, '\P{	-CJK_Symbols_and_punctuation}', "");
    Expect(0, 12352, '\P{^	-CJK_Symbols_and_punctuation}', "");
    Error('\p{/a/_Is_CJK_Symbols_AND_Punctuation}');
    Error('\P{/a/_Is_CJK_Symbols_AND_Punctuation}');
    Expect(1, 12351, '\p{iscjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\p{^iscjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\P{iscjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\P{^iscjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\p{iscjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\p{^iscjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\P{iscjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\P{^iscjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\p{- Is_cjk_symbols_and_Punctuation}', "");
    Expect(0, 12351, '\p{^- Is_cjk_symbols_and_Punctuation}', "");
    Expect(0, 12351, '\P{- Is_cjk_symbols_and_Punctuation}', "");
    Expect(1, 12351, '\P{^- Is_cjk_symbols_and_Punctuation}', "");
    Expect(0, 12352, '\p{- Is_cjk_symbols_and_Punctuation}', "");
    Expect(1, 12352, '\p{^- Is_cjk_symbols_and_Punctuation}', "");
    Expect(1, 12352, '\P{- Is_cjk_symbols_and_Punctuation}', "");
    Expect(0, 12352, '\P{^- Is_cjk_symbols_and_Punctuation}', "");
    Error('\p{/a/In_CJK_Symbols_AND_PUNCTUATION}');
    Error('\P{/a/In_CJK_Symbols_AND_PUNCTUATION}');
    Expect(1, 12351, '\p{incjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\p{^incjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\P{incjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\P{^incjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\p{incjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\p{^incjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\P{incjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\P{^incjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\p{_In_CJK_Symbols_AND_PUNCTUATION}', "");
    Expect(0, 12351, '\p{^_In_CJK_Symbols_AND_PUNCTUATION}', "");
    Expect(0, 12351, '\P{_In_CJK_Symbols_AND_PUNCTUATION}', "");
    Expect(1, 12351, '\P{^_In_CJK_Symbols_AND_PUNCTUATION}', "");
    Expect(0, 12352, '\p{_In_CJK_Symbols_AND_PUNCTUATION}', "");
    Expect(1, 12352, '\p{^_In_CJK_Symbols_AND_PUNCTUATION}', "");
    Expect(1, 12352, '\P{_In_CJK_Symbols_AND_PUNCTUATION}', "");
    Expect(0, 12352, '\P{^_In_CJK_Symbols_AND_PUNCTUATION}', "");
    Error('\p{ /a/CJK_Symbols}');
    Error('\P{ /a/CJK_Symbols}');
    Expect(1, 12351, '\p{cjksymbols}', "");
    Expect(0, 12351, '\p{^cjksymbols}', "");
    Expect(0, 12351, '\P{cjksymbols}', "");
    Expect(1, 12351, '\P{^cjksymbols}', "");
    Expect(0, 12352, '\p{cjksymbols}', "");
    Expect(1, 12352, '\p{^cjksymbols}', "");
    Expect(1, 12352, '\P{cjksymbols}', "");
    Expect(0, 12352, '\P{^cjksymbols}', "");
    Expect(1, 12351, '\p{ 	cjk_Symbols}', "");
    Expect(0, 12351, '\p{^ 	cjk_Symbols}', "");
    Expect(0, 12351, '\P{ 	cjk_Symbols}', "");
    Expect(1, 12351, '\P{^ 	cjk_Symbols}', "");
    Expect(0, 12352, '\p{ 	cjk_Symbols}', "");
    Expect(1, 12352, '\p{^ 	cjk_Symbols}', "");
    Expect(1, 12352, '\P{ 	cjk_Symbols}', "");
    Expect(0, 12352, '\P{^ 	cjk_Symbols}', "");
    Error('\p{/a/Is_CJK_symbols}');
    Error('\P{/a/Is_CJK_symbols}');
    Expect(1, 12351, '\p{iscjksymbols}', "");
    Expect(0, 12351, '\p{^iscjksymbols}', "");
    Expect(0, 12351, '\P{iscjksymbols}', "");
    Expect(1, 12351, '\P{^iscjksymbols}', "");
    Expect(0, 12352, '\p{iscjksymbols}', "");
    Expect(1, 12352, '\p{^iscjksymbols}', "");
    Expect(1, 12352, '\P{iscjksymbols}', "");
    Expect(0, 12352, '\P{^iscjksymbols}', "");
    Expect(1, 12351, '\p{ Is_cjk_Symbols}', "");
    Expect(0, 12351, '\p{^ Is_cjk_Symbols}', "");
    Expect(0, 12351, '\P{ Is_cjk_Symbols}', "");
    Expect(1, 12351, '\P{^ Is_cjk_Symbols}', "");
    Expect(0, 12352, '\p{ Is_cjk_Symbols}', "");
    Expect(1, 12352, '\p{^ Is_cjk_Symbols}', "");
    Expect(1, 12352, '\P{ Is_cjk_Symbols}', "");
    Expect(0, 12352, '\P{^ Is_cjk_Symbols}', "");
    Error('\p{	/a/IN_CJK_Symbols}');
    Error('\P{	/a/IN_CJK_Symbols}');
    Expect(1, 12351, '\p{incjksymbols}', "");
    Expect(0, 12351, '\p{^incjksymbols}', "");
    Expect(0, 12351, '\P{incjksymbols}', "");
    Expect(1, 12351, '\P{^incjksymbols}', "");
    Expect(0, 12352, '\p{incjksymbols}', "");
    Expect(1, 12352, '\p{^incjksymbols}', "");
    Expect(1, 12352, '\P{incjksymbols}', "");
    Expect(0, 12352, '\P{^incjksymbols}', "");
    Expect(1, 12351, '\p{  In_CJK_SYMBOLS}', "");
    Expect(0, 12351, '\p{^  In_CJK_SYMBOLS}', "");
    Expect(0, 12351, '\P{  In_CJK_SYMBOLS}', "");
    Expect(1, 12351, '\P{^  In_CJK_SYMBOLS}', "");
    Expect(0, 12352, '\p{  In_CJK_SYMBOLS}', "");
    Expect(1, 12352, '\p{^  In_CJK_SYMBOLS}', "");
    Expect(1, 12352, '\P{  In_CJK_SYMBOLS}', "");
    Expect(0, 12352, '\P{^  In_CJK_SYMBOLS}', "");
    Error('\p{-_CJK_UNIFIED_IDEOGRAPHS:=}');
    Error('\P{-_CJK_UNIFIED_IDEOGRAPHS:=}');
    Expect(1, 40959, '\p{cjkunifiedideographs}', "");
    Expect(0, 40959, '\p{^cjkunifiedideographs}', "");
    Expect(0, 40959, '\P{cjkunifiedideographs}', "");
    Expect(1, 40959, '\P{^cjkunifiedideographs}', "");
    Expect(0, 40960, '\p{cjkunifiedideographs}', "");
    Expect(1, 40960, '\p{^cjkunifiedideographs}', "");
    Expect(1, 40960, '\P{cjkunifiedideographs}', "");
    Expect(0, 40960, '\P{^cjkunifiedideographs}', "");
    Expect(1, 40959, '\p{_cjk_Unified_Ideographs}', "");
    Expect(0, 40959, '\p{^_cjk_Unified_Ideographs}', "");
    Expect(0, 40959, '\P{_cjk_Unified_Ideographs}', "");
    Expect(1, 40959, '\P{^_cjk_Unified_Ideographs}', "");
    Expect(0, 40960, '\p{_cjk_Unified_Ideographs}', "");
    Expect(1, 40960, '\p{^_cjk_Unified_Ideographs}', "");
    Expect(1, 40960, '\P{_cjk_Unified_Ideographs}', "");
    Expect(0, 40960, '\P{^_cjk_Unified_Ideographs}', "");
    Error('\p{_	Is_CJK_UNIFIED_Ideographs:=}');
    Error('\P{_	Is_CJK_UNIFIED_Ideographs:=}');
    Expect(1, 40959, '\p{iscjkunifiedideographs}', "");
    Expect(0, 40959, '\p{^iscjkunifiedideographs}', "");
    Expect(0, 40959, '\P{iscjkunifiedideographs}', "");
    Expect(1, 40959, '\P{^iscjkunifiedideographs}', "");
    Expect(0, 40960, '\p{iscjkunifiedideographs}', "");
    Expect(1, 40960, '\p{^iscjkunifiedideographs}', "");
    Expect(1, 40960, '\P{iscjkunifiedideographs}', "");
    Expect(0, 40960, '\P{^iscjkunifiedideographs}', "");
    Expect(1, 40959, '\p{__Is_CJK_UNIFIED_ideographs}', "");
    Expect(0, 40959, '\p{^__Is_CJK_UNIFIED_ideographs}', "");
    Expect(0, 40959, '\P{__Is_CJK_UNIFIED_ideographs}', "");
    Expect(1, 40959, '\P{^__Is_CJK_UNIFIED_ideographs}', "");
    Expect(0, 40960, '\p{__Is_CJK_UNIFIED_ideographs}', "");
    Expect(1, 40960, '\p{^__Is_CJK_UNIFIED_ideographs}', "");
    Expect(1, 40960, '\P{__Is_CJK_UNIFIED_ideographs}', "");
    Expect(0, 40960, '\P{^__Is_CJK_UNIFIED_ideographs}', "");
    Error('\p{_	In_CJK_Unified_ideographs/a/}');
    Error('\P{_	In_CJK_Unified_ideographs/a/}');
    Expect(1, 40959, '\p{incjkunifiedideographs}', "");
    Expect(0, 40959, '\p{^incjkunifiedideographs}', "");
    Expect(0, 40959, '\P{incjkunifiedideographs}', "");
    Expect(1, 40959, '\P{^incjkunifiedideographs}', "");
    Expect(0, 40960, '\p{incjkunifiedideographs}', "");
    Expect(1, 40960, '\p{^incjkunifiedideographs}', "");
    Expect(1, 40960, '\P{incjkunifiedideographs}', "");
    Expect(0, 40960, '\P{^incjkunifiedideographs}', "");
    Expect(1, 40959, '\p{-	in_cjk_Unified_ideographs}', "");
    Expect(0, 40959, '\p{^-	in_cjk_Unified_ideographs}', "");
    Expect(0, 40959, '\P{-	in_cjk_Unified_ideographs}', "");
    Expect(1, 40959, '\P{^-	in_cjk_Unified_ideographs}', "");
    Expect(0, 40960, '\p{-	in_cjk_Unified_ideographs}', "");
    Expect(1, 40960, '\p{^-	in_cjk_Unified_ideographs}', "");
    Expect(1, 40960, '\P{-	in_cjk_Unified_ideographs}', "");
    Expect(0, 40960, '\P{^-	in_cjk_Unified_ideographs}', "");
    Error('\p{	:=cjk}');
    Error('\P{	:=cjk}');
    Expect(1, 40959, '\p{cjk}', "");
    Expect(0, 40959, '\p{^cjk}', "");
    Expect(0, 40959, '\P{cjk}', "");
    Expect(1, 40959, '\P{^cjk}', "");
    Expect(0, 40960, '\p{cjk}', "");
    Expect(1, 40960, '\p{^cjk}', "");
    Expect(1, 40960, '\P{cjk}', "");
    Expect(0, 40960, '\P{^cjk}', "");
    Expect(1, 40959, '\p{ -CJK}', "");
    Expect(0, 40959, '\p{^ -CJK}', "");
    Expect(0, 40959, '\P{ -CJK}', "");
    Expect(1, 40959, '\P{^ -CJK}', "");
    Expect(0, 40960, '\p{ -CJK}', "");
    Expect(1, 40960, '\p{^ -CJK}', "");
    Expect(1, 40960, '\P{ -CJK}', "");
    Expect(0, 40960, '\P{^ -CJK}', "");
    Error('\p{:=	IS_CJK}');
    Error('\P{:=	IS_CJK}');
    Expect(1, 40959, '\p{iscjk}', "");
    Expect(0, 40959, '\p{^iscjk}', "");
    Expect(0, 40959, '\P{iscjk}', "");
    Expect(1, 40959, '\P{^iscjk}', "");
    Expect(0, 40960, '\p{iscjk}', "");
    Expect(1, 40960, '\p{^iscjk}', "");
    Expect(1, 40960, '\P{iscjk}', "");
    Expect(0, 40960, '\P{^iscjk}', "");
    Expect(1, 40959, '\p{_	IS_CJK}', "");
    Expect(0, 40959, '\p{^_	IS_CJK}', "");
    Expect(0, 40959, '\P{_	IS_CJK}', "");
    Expect(1, 40959, '\P{^_	IS_CJK}', "");
    Expect(0, 40960, '\p{_	IS_CJK}', "");
    Expect(1, 40960, '\p{^_	IS_CJK}', "");
    Expect(1, 40960, '\P{_	IS_CJK}', "");
    Expect(0, 40960, '\P{^_	IS_CJK}', "");
    Error('\p{-:=in_CJK}');
    Error('\P{-:=in_CJK}');
    Expect(1, 40959, '\p{incjk}', "");
    Expect(0, 40959, '\p{^incjk}', "");
    Expect(0, 40959, '\P{incjk}', "");
    Expect(1, 40959, '\P{^incjk}', "");
    Expect(0, 40960, '\p{incjk}', "");
    Expect(1, 40960, '\p{^incjk}', "");
    Expect(1, 40960, '\P{incjk}', "");
    Expect(0, 40960, '\P{^incjk}', "");
    Expect(1, 40959, '\p{_IN_CJK}', "");
    Expect(0, 40959, '\p{^_IN_CJK}', "");
    Expect(0, 40959, '\P{_IN_CJK}', "");
    Expect(1, 40959, '\P{^_IN_CJK}', "");
    Expect(0, 40960, '\p{_IN_CJK}', "");
    Expect(1, 40960, '\p{^_IN_CJK}', "");
    Expect(1, 40960, '\P{_IN_CJK}', "");
    Expect(0, 40960, '\P{^_IN_CJK}', "");
    Error('\p{		CJK_Unified_Ideographs_Extension_A:=}');
    Error('\P{		CJK_Unified_Ideographs_Extension_A:=}');
    Expect(1, 19903, '\p{cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\p{^cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\P{cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\P{^cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\p{cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\p{^cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\P{cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\P{^cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\p{-_CJK_Unified_IDEOGRAPHS_EXTENSION_A}', "");
    Expect(0, 19903, '\p{^-_CJK_Unified_IDEOGRAPHS_EXTENSION_A}', "");
    Expect(0, 19903, '\P{-_CJK_Unified_IDEOGRAPHS_EXTENSION_A}', "");
    Expect(1, 19903, '\P{^-_CJK_Unified_IDEOGRAPHS_EXTENSION_A}', "");
    Expect(0, 19904, '\p{-_CJK_Unified_IDEOGRAPHS_EXTENSION_A}', "");
    Expect(1, 19904, '\p{^-_CJK_Unified_IDEOGRAPHS_EXTENSION_A}', "");
    Expect(1, 19904, '\P{-_CJK_Unified_IDEOGRAPHS_EXTENSION_A}', "");
    Expect(0, 19904, '\P{^-_CJK_Unified_IDEOGRAPHS_EXTENSION_A}', "");
    Error('\p{/a/	 Is_CJK_UNIFIED_Ideographs_Extension_A}');
    Error('\P{/a/	 Is_CJK_UNIFIED_Ideographs_Extension_A}');
    Expect(1, 19903, '\p{iscjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\p{^iscjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\P{iscjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\P{^iscjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\p{iscjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\p{^iscjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\P{iscjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\P{^iscjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\p{ 	Is_CJK_UNIFIED_IDEOGRAPHS_extension_a}', "");
    Expect(0, 19903, '\p{^ 	Is_CJK_UNIFIED_IDEOGRAPHS_extension_a}', "");
    Expect(0, 19903, '\P{ 	Is_CJK_UNIFIED_IDEOGRAPHS_extension_a}', "");
    Expect(1, 19903, '\P{^ 	Is_CJK_UNIFIED_IDEOGRAPHS_extension_a}', "");
    Expect(0, 19904, '\p{ 	Is_CJK_UNIFIED_IDEOGRAPHS_extension_a}', "");
    Expect(1, 19904, '\p{^ 	Is_CJK_UNIFIED_IDEOGRAPHS_extension_a}', "");
    Expect(1, 19904, '\P{ 	Is_CJK_UNIFIED_IDEOGRAPHS_extension_a}', "");
    Expect(0, 19904, '\P{^ 	Is_CJK_UNIFIED_IDEOGRAPHS_extension_a}', "");
    Error('\p{-	In_CJK_unified_IDEOGRAPHS_EXTENSION_a:=}');
    Error('\P{-	In_CJK_unified_IDEOGRAPHS_EXTENSION_a:=}');
    Expect(1, 19903, '\p{incjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\p{^incjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\P{incjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\P{^incjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\p{incjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\p{^incjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\P{incjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\P{^incjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\p{	-In_CJK_unified_IDEOGRAPHS_Extension_A}', "");
    Expect(0, 19903, '\p{^	-In_CJK_unified_IDEOGRAPHS_Extension_A}', "");
    Expect(0, 19903, '\P{	-In_CJK_unified_IDEOGRAPHS_Extension_A}', "");
    Expect(1, 19903, '\P{^	-In_CJK_unified_IDEOGRAPHS_Extension_A}', "");
    Expect(0, 19904, '\p{	-In_CJK_unified_IDEOGRAPHS_Extension_A}', "");
    Expect(1, 19904, '\p{^	-In_CJK_unified_IDEOGRAPHS_Extension_A}', "");
    Expect(1, 19904, '\P{	-In_CJK_unified_IDEOGRAPHS_Extension_A}', "");
    Expect(0, 19904, '\P{^	-In_CJK_unified_IDEOGRAPHS_Extension_A}', "");
    Error('\p{:= CJK_ext_A}');
    Error('\P{:= CJK_ext_A}');
    Expect(1, 19903, '\p{cjkexta}', "");
    Expect(0, 19903, '\p{^cjkexta}', "");
    Expect(0, 19903, '\P{cjkexta}', "");
    Expect(1, 19903, '\P{^cjkexta}', "");
    Expect(0, 19904, '\p{cjkexta}', "");
    Expect(1, 19904, '\p{^cjkexta}', "");
    Expect(1, 19904, '\P{cjkexta}', "");
    Expect(0, 19904, '\P{^cjkexta}', "");
    Expect(1, 19903, '\p{ 	CJK_ext_a}', "");
    Expect(0, 19903, '\p{^ 	CJK_ext_a}', "");
    Expect(0, 19903, '\P{ 	CJK_ext_a}', "");
    Expect(1, 19903, '\P{^ 	CJK_ext_a}', "");
    Expect(0, 19904, '\p{ 	CJK_ext_a}', "");
    Expect(1, 19904, '\p{^ 	CJK_ext_a}', "");
    Expect(1, 19904, '\P{ 	CJK_ext_a}', "");
    Expect(0, 19904, '\P{^ 	CJK_ext_a}', "");
    Error('\p{:=_Is_CJK_EXT_A}');
    Error('\P{:=_Is_CJK_EXT_A}');
    Expect(1, 19903, '\p{iscjkexta}', "");
    Expect(0, 19903, '\p{^iscjkexta}', "");
    Expect(0, 19903, '\P{iscjkexta}', "");
    Expect(1, 19903, '\P{^iscjkexta}', "");
    Expect(0, 19904, '\p{iscjkexta}', "");
    Expect(1, 19904, '\p{^iscjkexta}', "");
    Expect(1, 19904, '\P{iscjkexta}', "");
    Expect(0, 19904, '\P{^iscjkexta}', "");
    Expect(1, 19903, '\p{	_Is_CJK_EXT_A}', "");
    Expect(0, 19903, '\p{^	_Is_CJK_EXT_A}', "");
    Expect(0, 19903, '\P{	_Is_CJK_EXT_A}', "");
    Expect(1, 19903, '\P{^	_Is_CJK_EXT_A}', "");
    Expect(0, 19904, '\p{	_Is_CJK_EXT_A}', "");
    Expect(1, 19904, '\p{^	_Is_CJK_EXT_A}', "");
    Expect(1, 19904, '\P{	_Is_CJK_EXT_A}', "");
    Expect(0, 19904, '\P{^	_Is_CJK_EXT_A}', "");
    Error('\p{:=	_IN_CJK_EXT_a}');
    Error('\P{:=	_IN_CJK_EXT_a}');
    Expect(1, 19903, '\p{incjkexta}', "");
    Expect(0, 19903, '\p{^incjkexta}', "");
    Expect(0, 19903, '\P{incjkexta}', "");
    Expect(1, 19903, '\P{^incjkexta}', "");
    Expect(0, 19904, '\p{incjkexta}', "");
    Expect(1, 19904, '\p{^incjkexta}', "");
    Expect(1, 19904, '\P{incjkexta}', "");
    Expect(0, 19904, '\P{^incjkexta}', "");
    Expect(1, 19903, '\p{_	in_cjk_ext_A}', "");
    Expect(0, 19903, '\p{^_	in_cjk_ext_A}', "");
    Expect(0, 19903, '\P{_	in_cjk_ext_A}', "");
    Expect(1, 19903, '\P{^_	in_cjk_ext_A}', "");
    Expect(0, 19904, '\p{_	in_cjk_ext_A}', "");
    Expect(1, 19904, '\p{^_	in_cjk_ext_A}', "");
    Expect(1, 19904, '\P{_	in_cjk_ext_A}', "");
    Expect(0, 19904, '\P{^_	in_cjk_ext_A}', "");
    Error('\p{:=_cjk_Unified_IDEOGRAPHS_extension_B}');
    Error('\P{:=_cjk_Unified_IDEOGRAPHS_extension_B}');
    Expect(1, 173791, '\p{cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\p{^cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\P{cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\P{^cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\p{cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\p{^cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\P{cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\P{^cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\p{-_cjk_Unified_IDEOGRAPHS_extension_B}', "");
    Expect(0, 173791, '\p{^-_cjk_Unified_IDEOGRAPHS_extension_B}', "");
    Expect(0, 173791, '\P{-_cjk_Unified_IDEOGRAPHS_extension_B}', "");
    Expect(1, 173791, '\P{^-_cjk_Unified_IDEOGRAPHS_extension_B}', "");
    Expect(0, 173792, '\p{-_cjk_Unified_IDEOGRAPHS_extension_B}', "");
    Expect(1, 173792, '\p{^-_cjk_Unified_IDEOGRAPHS_extension_B}', "");
    Expect(1, 173792, '\P{-_cjk_Unified_IDEOGRAPHS_extension_B}', "");
    Expect(0, 173792, '\P{^-_cjk_Unified_IDEOGRAPHS_extension_B}', "");
    Error('\p{	/a/Is_CJK_Unified_ideographs_extension_b}');
    Error('\P{	/a/Is_CJK_Unified_ideographs_extension_b}');
    Expect(1, 173791, '\p{iscjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\p{^iscjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\P{iscjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\P{^iscjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\p{iscjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\p{^iscjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\P{iscjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\P{^iscjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\p{- Is_CJK_Unified_Ideographs_extension_B}', "");
    Expect(0, 173791, '\p{^- Is_CJK_Unified_Ideographs_extension_B}', "");
    Expect(0, 173791, '\P{- Is_CJK_Unified_Ideographs_extension_B}', "");
    Expect(1, 173791, '\P{^- Is_CJK_Unified_Ideographs_extension_B}', "");
    Expect(0, 173792, '\p{- Is_CJK_Unified_Ideographs_extension_B}', "");
    Expect(1, 173792, '\p{^- Is_CJK_Unified_Ideographs_extension_B}', "");
    Expect(1, 173792, '\P{- Is_CJK_Unified_Ideographs_extension_B}', "");
    Expect(0, 173792, '\P{^- Is_CJK_Unified_Ideographs_extension_B}', "");
    Error('\p{	/a/In_cjk_unified_ideographs_EXTENSION_B}');
    Error('\P{	/a/In_cjk_unified_ideographs_EXTENSION_B}');
    Expect(1, 173791, '\p{incjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\p{^incjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\P{incjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\P{^incjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\p{incjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\p{^incjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\P{incjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\P{^incjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\p{_	In_cjk_UNIFIED_IDEOGRAPHS_Extension_B}', "");
    Expect(0, 173791, '\p{^_	In_cjk_UNIFIED_IDEOGRAPHS_Extension_B}', "");
    Expect(0, 173791, '\P{_	In_cjk_UNIFIED_IDEOGRAPHS_Extension_B}', "");
    Expect(1, 173791, '\P{^_	In_cjk_UNIFIED_IDEOGRAPHS_Extension_B}', "");
    Expect(0, 173792, '\p{_	In_cjk_UNIFIED_IDEOGRAPHS_Extension_B}', "");
    Expect(1, 173792, '\p{^_	In_cjk_UNIFIED_IDEOGRAPHS_Extension_B}', "");
    Expect(1, 173792, '\P{_	In_cjk_UNIFIED_IDEOGRAPHS_Extension_B}', "");
    Expect(0, 173792, '\P{^_	In_cjk_UNIFIED_IDEOGRAPHS_Extension_B}', "");
    Error('\p{_CJK_EXT_B:=}');
    Error('\P{_CJK_EXT_B:=}');
    Expect(1, 173791, '\p{cjkextb}', "");
    Expect(0, 173791, '\p{^cjkextb}', "");
    Expect(0, 173791, '\P{cjkextb}', "");
    Expect(1, 173791, '\P{^cjkextb}', "");
    Expect(0, 173792, '\p{cjkextb}', "");
    Expect(1, 173792, '\p{^cjkextb}', "");
    Expect(1, 173792, '\P{cjkextb}', "");
    Expect(0, 173792, '\P{^cjkextb}', "");
    Expect(1, 173791, '\p{	CJK_EXT_B}', "");
    Expect(0, 173791, '\p{^	CJK_EXT_B}', "");
    Expect(0, 173791, '\P{	CJK_EXT_B}', "");
    Expect(1, 173791, '\P{^	CJK_EXT_B}', "");
    Expect(0, 173792, '\p{	CJK_EXT_B}', "");
    Expect(1, 173792, '\p{^	CJK_EXT_B}', "");
    Expect(1, 173792, '\P{	CJK_EXT_B}', "");
    Expect(0, 173792, '\P{^	CJK_EXT_B}', "");
    Error('\p{	/a/IS_cjk_ext_B}');
    Error('\P{	/a/IS_cjk_ext_B}');
    Expect(1, 173791, '\p{iscjkextb}', "");
    Expect(0, 173791, '\p{^iscjkextb}', "");
    Expect(0, 173791, '\P{iscjkextb}', "");
    Expect(1, 173791, '\P{^iscjkextb}', "");
    Expect(0, 173792, '\p{iscjkextb}', "");
    Expect(1, 173792, '\p{^iscjkextb}', "");
    Expect(1, 173792, '\P{iscjkextb}', "");
    Expect(0, 173792, '\P{^iscjkextb}', "");
    Expect(1, 173791, '\p{_ IS_CJK_Ext_b}', "");
    Expect(0, 173791, '\p{^_ IS_CJK_Ext_b}', "");
    Expect(0, 173791, '\P{_ IS_CJK_Ext_b}', "");
    Expect(1, 173791, '\P{^_ IS_CJK_Ext_b}', "");
    Expect(0, 173792, '\p{_ IS_CJK_Ext_b}', "");
    Expect(1, 173792, '\p{^_ IS_CJK_Ext_b}', "");
    Expect(1, 173792, '\P{_ IS_CJK_Ext_b}', "");
    Expect(0, 173792, '\P{^_ IS_CJK_Ext_b}', "");
    Error('\p{	-in_cjk_Ext_b/a/}');
    Error('\P{	-in_cjk_Ext_b/a/}');
    Expect(1, 173791, '\p{incjkextb}', "");
    Expect(0, 173791, '\p{^incjkextb}', "");
    Expect(0, 173791, '\P{incjkextb}', "");
    Expect(1, 173791, '\P{^incjkextb}', "");
    Expect(0, 173792, '\p{incjkextb}', "");
    Expect(1, 173792, '\p{^incjkextb}', "");
    Expect(1, 173792, '\P{incjkextb}', "");
    Expect(0, 173792, '\P{^incjkextb}', "");
    Expect(1, 173791, '\p{	in_CJK_Ext_B}', "");
    Expect(0, 173791, '\p{^	in_CJK_Ext_B}', "");
    Expect(0, 173791, '\P{	in_CJK_Ext_B}', "");
    Expect(1, 173791, '\P{^	in_CJK_Ext_B}', "");
    Expect(0, 173792, '\p{	in_CJK_Ext_B}', "");
    Expect(1, 173792, '\p{^	in_CJK_Ext_B}', "");
    Expect(1, 173792, '\P{	in_CJK_Ext_B}', "");
    Expect(0, 173792, '\P{^	in_CJK_Ext_B}', "");
    Error('\p{-:=cjk_Unified_ideographs_Extension_C}');
    Error('\P{-:=cjk_Unified_ideographs_Extension_C}');
    Expect(1, 177983, '\p{cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\p{^cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\P{cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\P{^cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\p{cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\p{^cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\P{cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\P{^cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\p{  CJK_Unified_IDEOGRAPHS_Extension_C}', "");
    Expect(0, 177983, '\p{^  CJK_Unified_IDEOGRAPHS_Extension_C}', "");
    Expect(0, 177983, '\P{  CJK_Unified_IDEOGRAPHS_Extension_C}', "");
    Expect(1, 177983, '\P{^  CJK_Unified_IDEOGRAPHS_Extension_C}', "");
    Expect(0, 177984, '\p{  CJK_Unified_IDEOGRAPHS_Extension_C}', "");
    Expect(1, 177984, '\p{^  CJK_Unified_IDEOGRAPHS_Extension_C}', "");
    Expect(1, 177984, '\P{  CJK_Unified_IDEOGRAPHS_Extension_C}', "");
    Expect(0, 177984, '\P{^  CJK_Unified_IDEOGRAPHS_Extension_C}', "");
    Error('\p{--Is_CJK_UNIFIED_Ideographs_Extension_c:=}');
    Error('\P{--Is_CJK_UNIFIED_Ideographs_Extension_c:=}');
    Expect(1, 177983, '\p{iscjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\p{^iscjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\P{iscjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\P{^iscjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\p{iscjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\p{^iscjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\P{iscjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\P{^iscjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\p{ _IS_cjk_Unified_ideographs_extension_C}', "");
    Expect(0, 177983, '\p{^ _IS_cjk_Unified_ideographs_extension_C}', "");
    Expect(0, 177983, '\P{ _IS_cjk_Unified_ideographs_extension_C}', "");
    Expect(1, 177983, '\P{^ _IS_cjk_Unified_ideographs_extension_C}', "");
    Expect(0, 177984, '\p{ _IS_cjk_Unified_ideographs_extension_C}', "");
    Expect(1, 177984, '\p{^ _IS_cjk_Unified_ideographs_extension_C}', "");
    Expect(1, 177984, '\P{ _IS_cjk_Unified_ideographs_extension_C}', "");
    Expect(0, 177984, '\P{^ _IS_cjk_Unified_ideographs_extension_C}', "");
    Error('\p{IN_CJK_unified_IDEOGRAPHS_EXTENSION_C:=}');
    Error('\P{IN_CJK_unified_IDEOGRAPHS_EXTENSION_C:=}');
    Expect(1, 177983, '\p{incjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\p{^incjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\P{incjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\P{^incjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\p{incjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\p{^incjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\P{incjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\P{^incjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\p{  In_cjk_Unified_Ideographs_Extension_C}', "");
    Expect(0, 177983, '\p{^  In_cjk_Unified_Ideographs_Extension_C}', "");
    Expect(0, 177983, '\P{  In_cjk_Unified_Ideographs_Extension_C}', "");
    Expect(1, 177983, '\P{^  In_cjk_Unified_Ideographs_Extension_C}', "");
    Expect(0, 177984, '\p{  In_cjk_Unified_Ideographs_Extension_C}', "");
    Expect(1, 177984, '\p{^  In_cjk_Unified_Ideographs_Extension_C}', "");
    Expect(1, 177984, '\P{  In_cjk_Unified_Ideographs_Extension_C}', "");
    Expect(0, 177984, '\P{^  In_cjk_Unified_Ideographs_Extension_C}', "");
    Error('\p{/a/_cjk_Ext_c}');
    Error('\P{/a/_cjk_Ext_c}');
    Expect(1, 177983, '\p{cjkextc}', "");
    Expect(0, 177983, '\p{^cjkextc}', "");
    Expect(0, 177983, '\P{cjkextc}', "");
    Expect(1, 177983, '\P{^cjkextc}', "");
    Expect(0, 177984, '\p{cjkextc}', "");
    Expect(1, 177984, '\p{^cjkextc}', "");
    Expect(1, 177984, '\P{cjkextc}', "");
    Expect(0, 177984, '\P{^cjkextc}', "");
    Expect(1, 177983, '\p{_CJK_EXT_C}', "");
    Expect(0, 177983, '\p{^_CJK_EXT_C}', "");
    Expect(0, 177983, '\P{_CJK_EXT_C}', "");
    Expect(1, 177983, '\P{^_CJK_EXT_C}', "");
    Expect(0, 177984, '\p{_CJK_EXT_C}', "");
    Expect(1, 177984, '\p{^_CJK_EXT_C}', "");
    Expect(1, 177984, '\P{_CJK_EXT_C}', "");
    Expect(0, 177984, '\P{^_CJK_EXT_C}', "");
    Error('\p{  Is_CJK_Ext_C/a/}');
    Error('\P{  Is_CJK_Ext_C/a/}');
    Expect(1, 177983, '\p{iscjkextc}', "");
    Expect(0, 177983, '\p{^iscjkextc}', "");
    Expect(0, 177983, '\P{iscjkextc}', "");
    Expect(1, 177983, '\P{^iscjkextc}', "");
    Expect(0, 177984, '\p{iscjkextc}', "");
    Expect(1, 177984, '\p{^iscjkextc}', "");
    Expect(1, 177984, '\P{iscjkextc}', "");
    Expect(0, 177984, '\P{^iscjkextc}', "");
    Expect(1, 177983, '\p{ 	Is_CJK_Ext_c}', "");
    Expect(0, 177983, '\p{^ 	Is_CJK_Ext_c}', "");
    Expect(0, 177983, '\P{ 	Is_CJK_Ext_c}', "");
    Expect(1, 177983, '\P{^ 	Is_CJK_Ext_c}', "");
    Expect(0, 177984, '\p{ 	Is_CJK_Ext_c}', "");
    Expect(1, 177984, '\p{^ 	Is_CJK_Ext_c}', "");
    Expect(1, 177984, '\P{ 	Is_CJK_Ext_c}', "");
    Expect(0, 177984, '\P{^ 	Is_CJK_Ext_c}', "");
    Error('\p{:=In_cjk_EXT_C}');
    Error('\P{:=In_cjk_EXT_C}');
    Expect(1, 177983, '\p{incjkextc}', "");
    Expect(0, 177983, '\p{^incjkextc}', "");
    Expect(0, 177983, '\P{incjkextc}', "");
    Expect(1, 177983, '\P{^incjkextc}', "");
    Expect(0, 177984, '\p{incjkextc}', "");
    Expect(1, 177984, '\p{^incjkextc}', "");
    Expect(1, 177984, '\P{incjkextc}', "");
    Expect(0, 177984, '\P{^incjkextc}', "");
    Expect(1, 177983, '\p{ In_cjk_ext_C}', "");
    Expect(0, 177983, '\p{^ In_cjk_ext_C}', "");
    Expect(0, 177983, '\P{ In_cjk_ext_C}', "");
    Expect(1, 177983, '\P{^ In_cjk_ext_C}', "");
    Expect(0, 177984, '\p{ In_cjk_ext_C}', "");
    Expect(1, 177984, '\p{^ In_cjk_ext_C}', "");
    Expect(1, 177984, '\P{ In_cjk_ext_C}', "");
    Expect(0, 177984, '\P{^ In_cjk_ext_C}', "");
    Error('\p{ 	CJK_UNIFIED_Ideographs_extension_d/a/}');
    Error('\P{ 	CJK_UNIFIED_Ideographs_extension_d/a/}');
    Expect(1, 178207, '\p{cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\p{^cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\P{cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\P{^cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\p{cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\p{^cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\P{cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\P{^cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\p{__CJK_Unified_ideographs_extension_D}', "");
    Expect(0, 178207, '\p{^__CJK_Unified_ideographs_extension_D}', "");
    Expect(0, 178207, '\P{__CJK_Unified_ideographs_extension_D}', "");
    Expect(1, 178207, '\P{^__CJK_Unified_ideographs_extension_D}', "");
    Expect(0, 178208, '\p{__CJK_Unified_ideographs_extension_D}', "");
    Expect(1, 178208, '\p{^__CJK_Unified_ideographs_extension_D}', "");
    Expect(1, 178208, '\P{__CJK_Unified_ideographs_extension_D}', "");
    Expect(0, 178208, '\P{^__CJK_Unified_ideographs_extension_D}', "");
    Error('\p{:=	Is_CJK_Unified_ideographs_extension_D}');
    Error('\P{:=	Is_CJK_Unified_ideographs_extension_D}');
    Expect(1, 178207, '\p{iscjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\p{^iscjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\P{iscjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\P{^iscjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\p{iscjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\p{^iscjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\P{iscjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\P{^iscjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\p{_Is_CJK_UNIFIED_IDEOGRAPHS_extension_D}', "");
    Expect(0, 178207, '\p{^_Is_CJK_UNIFIED_IDEOGRAPHS_extension_D}', "");
    Expect(0, 178207, '\P{_Is_CJK_UNIFIED_IDEOGRAPHS_extension_D}', "");
    Expect(1, 178207, '\P{^_Is_CJK_UNIFIED_IDEOGRAPHS_extension_D}', "");
    Expect(0, 178208, '\p{_Is_CJK_UNIFIED_IDEOGRAPHS_extension_D}', "");
    Expect(1, 178208, '\p{^_Is_CJK_UNIFIED_IDEOGRAPHS_extension_D}', "");
    Expect(1, 178208, '\P{_Is_CJK_UNIFIED_IDEOGRAPHS_extension_D}', "");
    Expect(0, 178208, '\P{^_Is_CJK_UNIFIED_IDEOGRAPHS_extension_D}', "");
    Error('\p{:=-_In_CJK_Unified_ideographs_Extension_d}');
    Error('\P{:=-_In_CJK_Unified_ideographs_Extension_d}');
    Expect(1, 178207, '\p{incjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\p{^incjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\P{incjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\P{^incjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\p{incjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\p{^incjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\P{incjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\P{^incjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\p{ _IN_cjk_Unified_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(0, 178207, '\p{^ _IN_cjk_Unified_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(0, 178207, '\P{ _IN_cjk_Unified_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(1, 178207, '\P{^ _IN_cjk_Unified_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(0, 178208, '\p{ _IN_cjk_Unified_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(1, 178208, '\p{^ _IN_cjk_Unified_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(1, 178208, '\P{ _IN_cjk_Unified_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(0, 178208, '\P{^ _IN_cjk_Unified_IDEOGRAPHS_EXTENSION_D}', "");
    Error('\p{	 CJK_EXT_D:=}');
    Error('\P{	 CJK_EXT_D:=}');
    Expect(1, 178207, '\p{cjkextd}', "");
    Expect(0, 178207, '\p{^cjkextd}', "");
    Expect(0, 178207, '\P{cjkextd}', "");
    Expect(1, 178207, '\P{^cjkextd}', "");
    Expect(0, 178208, '\p{cjkextd}', "");
    Expect(1, 178208, '\p{^cjkextd}', "");
    Expect(1, 178208, '\P{cjkextd}', "");
    Expect(0, 178208, '\P{^cjkextd}', "");
    Expect(1, 178207, '\p{_cjk_EXT_D}', "");
    Expect(0, 178207, '\p{^_cjk_EXT_D}', "");
    Expect(0, 178207, '\P{_cjk_EXT_D}', "");
    Expect(1, 178207, '\P{^_cjk_EXT_D}', "");
    Expect(0, 178208, '\p{_cjk_EXT_D}', "");
    Expect(1, 178208, '\p{^_cjk_EXT_D}', "");
    Expect(1, 178208, '\P{_cjk_EXT_D}', "");
    Expect(0, 178208, '\P{^_cjk_EXT_D}', "");
    Error('\p{-IS_CJK_ext_D/a/}');
    Error('\P{-IS_CJK_ext_D/a/}');
    Expect(1, 178207, '\p{iscjkextd}', "");
    Expect(0, 178207, '\p{^iscjkextd}', "");
    Expect(0, 178207, '\P{iscjkextd}', "");
    Expect(1, 178207, '\P{^iscjkextd}', "");
    Expect(0, 178208, '\p{iscjkextd}', "");
    Expect(1, 178208, '\p{^iscjkextd}', "");
    Expect(1, 178208, '\P{iscjkextd}', "");
    Expect(0, 178208, '\P{^iscjkextd}', "");
    Expect(1, 178207, '\p{	_Is_CJK_ext_D}', "");
    Expect(0, 178207, '\p{^	_Is_CJK_ext_D}', "");
    Expect(0, 178207, '\P{	_Is_CJK_ext_D}', "");
    Expect(1, 178207, '\P{^	_Is_CJK_ext_D}', "");
    Expect(0, 178208, '\p{	_Is_CJK_ext_D}', "");
    Expect(1, 178208, '\p{^	_Is_CJK_ext_D}', "");
    Expect(1, 178208, '\P{	_Is_CJK_ext_D}', "");
    Expect(0, 178208, '\P{^	_Is_CJK_ext_D}', "");
    Error('\p{_/a/in_CJK_ext_D}');
    Error('\P{_/a/in_CJK_ext_D}');
    Expect(1, 178207, '\p{incjkextd}', "");
    Expect(0, 178207, '\p{^incjkextd}', "");
    Expect(0, 178207, '\P{incjkextd}', "");
    Expect(1, 178207, '\P{^incjkextd}', "");
    Expect(0, 178208, '\p{incjkextd}', "");
    Expect(1, 178208, '\p{^incjkextd}', "");
    Expect(1, 178208, '\P{incjkextd}', "");
    Expect(0, 178208, '\P{^incjkextd}', "");
    Expect(1, 178207, '\p{  IN_cjk_EXT_D}', "");
    Expect(0, 178207, '\p{^  IN_cjk_EXT_D}', "");
    Expect(0, 178207, '\P{  IN_cjk_EXT_D}', "");
    Expect(1, 178207, '\P{^  IN_cjk_EXT_D}', "");
    Expect(0, 178208, '\p{  IN_cjk_EXT_D}', "");
    Expect(1, 178208, '\p{^  IN_cjk_EXT_D}', "");
    Expect(1, 178208, '\P{  IN_cjk_EXT_D}', "");
    Expect(0, 178208, '\P{^  IN_cjk_EXT_D}', "");
    Error('\p{:=-	CJK_Unified_ideographs_Extension_E}');
    Error('\P{:=-	CJK_Unified_ideographs_Extension_E}');
    Expect(1, 183983, '\p{cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\p{^cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\P{cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\P{^cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\p{cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\p{^cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\P{cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\P{^cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\p{_ CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Expect(0, 183983, '\p{^_ CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Expect(0, 183983, '\P{_ CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Expect(1, 183983, '\P{^_ CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Expect(0, 183984, '\p{_ CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Expect(1, 183984, '\p{^_ CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Expect(1, 183984, '\P{_ CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Expect(0, 183984, '\P{^_ CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Error('\p{- Is_cjk_Unified_IDEOGRAPHS_Extension_E/a/}');
    Error('\P{- Is_cjk_Unified_IDEOGRAPHS_Extension_E/a/}');
    Expect(1, 183983, '\p{iscjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\p{^iscjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\P{iscjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\P{^iscjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\p{iscjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\p{^iscjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\P{iscjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\P{^iscjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\p{	 is_CJK_UNIFIED_Ideographs_EXTENSION_E}', "");
    Expect(0, 183983, '\p{^	 is_CJK_UNIFIED_Ideographs_EXTENSION_E}', "");
    Expect(0, 183983, '\P{	 is_CJK_UNIFIED_Ideographs_EXTENSION_E}', "");
    Expect(1, 183983, '\P{^	 is_CJK_UNIFIED_Ideographs_EXTENSION_E}', "");
    Expect(0, 183984, '\p{	 is_CJK_UNIFIED_Ideographs_EXTENSION_E}', "");
    Expect(1, 183984, '\p{^	 is_CJK_UNIFIED_Ideographs_EXTENSION_E}', "");
    Expect(1, 183984, '\P{	 is_CJK_UNIFIED_Ideographs_EXTENSION_E}', "");
    Expect(0, 183984, '\P{^	 is_CJK_UNIFIED_Ideographs_EXTENSION_E}', "");
    Error('\p{-:=in_CJK_UNIFIED_Ideographs_Extension_e}');
    Error('\P{-:=in_CJK_UNIFIED_Ideographs_Extension_e}');
    Expect(1, 183983, '\p{incjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\p{^incjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\P{incjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\P{^incjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\p{incjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\p{^incjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\P{incjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\P{^incjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\p{ -In_cjk_Unified_Ideographs_Extension_E}', "");
    Expect(0, 183983, '\p{^ -In_cjk_Unified_Ideographs_Extension_E}', "");
    Expect(0, 183983, '\P{ -In_cjk_Unified_Ideographs_Extension_E}', "");
    Expect(1, 183983, '\P{^ -In_cjk_Unified_Ideographs_Extension_E}', "");
    Expect(0, 183984, '\p{ -In_cjk_Unified_Ideographs_Extension_E}', "");
    Expect(1, 183984, '\p{^ -In_cjk_Unified_Ideographs_Extension_E}', "");
    Expect(1, 183984, '\P{ -In_cjk_Unified_Ideographs_Extension_E}', "");
    Expect(0, 183984, '\P{^ -In_cjk_Unified_Ideographs_Extension_E}', "");
    Error('\p{	:=CJK_EXT_e}');
    Error('\P{	:=CJK_EXT_e}');
    Expect(1, 183983, '\p{cjkexte}', "");
    Expect(0, 183983, '\p{^cjkexte}', "");
    Expect(0, 183983, '\P{cjkexte}', "");
    Expect(1, 183983, '\P{^cjkexte}', "");
    Expect(0, 183984, '\p{cjkexte}', "");
    Expect(1, 183984, '\p{^cjkexte}', "");
    Expect(1, 183984, '\P{cjkexte}', "");
    Expect(0, 183984, '\P{^cjkexte}', "");
    Expect(1, 183983, '\p{- CJK_Ext_E}', "");
    Expect(0, 183983, '\p{^- CJK_Ext_E}', "");
    Expect(0, 183983, '\P{- CJK_Ext_E}', "");
    Expect(1, 183983, '\P{^- CJK_Ext_E}', "");
    Expect(0, 183984, '\p{- CJK_Ext_E}', "");
    Expect(1, 183984, '\p{^- CJK_Ext_E}', "");
    Expect(1, 183984, '\P{- CJK_Ext_E}', "");
    Expect(0, 183984, '\P{^- CJK_Ext_E}', "");
    Error('\p{-is_CJK_Ext_E:=}');
    Error('\P{-is_CJK_Ext_E:=}');
    Expect(1, 183983, '\p{iscjkexte}', "");
    Expect(0, 183983, '\p{^iscjkexte}', "");
    Expect(0, 183983, '\P{iscjkexte}', "");
    Expect(1, 183983, '\P{^iscjkexte}', "");
    Expect(0, 183984, '\p{iscjkexte}', "");
    Expect(1, 183984, '\p{^iscjkexte}', "");
    Expect(1, 183984, '\P{iscjkexte}', "");
    Expect(0, 183984, '\P{^iscjkexte}', "");
    Expect(1, 183983, '\p{ Is_CJK_EXT_E}', "");
    Expect(0, 183983, '\p{^ Is_CJK_EXT_E}', "");
    Expect(0, 183983, '\P{ Is_CJK_EXT_E}', "");
    Expect(1, 183983, '\P{^ Is_CJK_EXT_E}', "");
    Expect(0, 183984, '\p{ Is_CJK_EXT_E}', "");
    Expect(1, 183984, '\p{^ Is_CJK_EXT_E}', "");
    Expect(1, 183984, '\P{ Is_CJK_EXT_E}', "");
    Expect(0, 183984, '\P{^ Is_CJK_EXT_E}', "");
    Error('\p{:=-In_cjk_Ext_e}');
    Error('\P{:=-In_cjk_Ext_e}');
    Expect(1, 183983, '\p{incjkexte}', "");
    Expect(0, 183983, '\p{^incjkexte}', "");
    Expect(0, 183983, '\P{incjkexte}', "");
    Expect(1, 183983, '\P{^incjkexte}', "");
    Expect(0, 183984, '\p{incjkexte}', "");
    Expect(1, 183984, '\p{^incjkexte}', "");
    Expect(1, 183984, '\P{incjkexte}', "");
    Expect(0, 183984, '\P{^incjkexte}', "");
    Expect(1, 183983, '\p{ _In_CJK_ext_E}', "");
    Expect(0, 183983, '\p{^ _In_CJK_ext_E}', "");
    Expect(0, 183983, '\P{ _In_CJK_ext_E}', "");
    Expect(1, 183983, '\P{^ _In_CJK_ext_E}', "");
    Expect(0, 183984, '\p{ _In_CJK_ext_E}', "");
    Expect(1, 183984, '\p{^ _In_CJK_ext_E}', "");
    Expect(1, 183984, '\P{ _In_CJK_ext_E}', "");
    Expect(0, 183984, '\P{^ _In_CJK_ext_E}', "");
    Error('\p{:=	CJK_Unified_Ideographs_Extension_f}');
    Error('\P{:=	CJK_Unified_Ideographs_Extension_f}');
    Expect(1, 191471, '\p{cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\p{^cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\P{cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\P{^cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\p{cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\p{^cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\P{cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\P{^cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\p{ 	CJK_Unified_Ideographs_extension_F}', "");
    Expect(0, 191471, '\p{^ 	CJK_Unified_Ideographs_extension_F}', "");
    Expect(0, 191471, '\P{ 	CJK_Unified_Ideographs_extension_F}', "");
    Expect(1, 191471, '\P{^ 	CJK_Unified_Ideographs_extension_F}', "");
    Expect(0, 191472, '\p{ 	CJK_Unified_Ideographs_extension_F}', "");
    Expect(1, 191472, '\p{^ 	CJK_Unified_Ideographs_extension_F}', "");
    Expect(1, 191472, '\P{ 	CJK_Unified_Ideographs_extension_F}', "");
    Expect(0, 191472, '\P{^ 	CJK_Unified_Ideographs_extension_F}', "");
    Error('\p{/a/is_cjk_Unified_ideographs_Extension_F}');
    Error('\P{/a/is_cjk_Unified_ideographs_Extension_F}');
    Expect(1, 191471, '\p{iscjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\p{^iscjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\P{iscjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\P{^iscjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\p{iscjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\p{^iscjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\P{iscjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\P{^iscjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\p{ 	is_CJK_UNIFIED_ideographs_Extension_F}', "");
    Expect(0, 191471, '\p{^ 	is_CJK_UNIFIED_ideographs_Extension_F}', "");
    Expect(0, 191471, '\P{ 	is_CJK_UNIFIED_ideographs_Extension_F}', "");
    Expect(1, 191471, '\P{^ 	is_CJK_UNIFIED_ideographs_Extension_F}', "");
    Expect(0, 191472, '\p{ 	is_CJK_UNIFIED_ideographs_Extension_F}', "");
    Expect(1, 191472, '\p{^ 	is_CJK_UNIFIED_ideographs_Extension_F}', "");
    Expect(1, 191472, '\P{ 	is_CJK_UNIFIED_ideographs_Extension_F}', "");
    Expect(0, 191472, '\P{^ 	is_CJK_UNIFIED_ideographs_Extension_F}', "");
    Error('\p{:=-in_CJK_Unified_Ideographs_Extension_F}');
    Error('\P{:=-in_CJK_Unified_Ideographs_Extension_F}');
    Expect(1, 191471, '\p{incjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\p{^incjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\P{incjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\P{^incjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\p{incjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\p{^incjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\P{incjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\P{^incjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\p{-_IN_CJK_UNIFIED_Ideographs_extension_F}', "");
    Expect(0, 191471, '\p{^-_IN_CJK_UNIFIED_Ideographs_extension_F}', "");
    Expect(0, 191471, '\P{-_IN_CJK_UNIFIED_Ideographs_extension_F}', "");
    Expect(1, 191471, '\P{^-_IN_CJK_UNIFIED_Ideographs_extension_F}', "");
    Expect(0, 191472, '\p{-_IN_CJK_UNIFIED_Ideographs_extension_F}', "");
    Expect(1, 191472, '\p{^-_IN_CJK_UNIFIED_Ideographs_extension_F}', "");
    Expect(1, 191472, '\P{-_IN_CJK_UNIFIED_Ideographs_extension_F}', "");
    Expect(0, 191472, '\P{^-_IN_CJK_UNIFIED_Ideographs_extension_F}', "");
    Error('\p{_:=CJK_Ext_F}');
    Error('\P{_:=CJK_Ext_F}');
    Expect(1, 191471, '\p{cjkextf}', "");
    Expect(0, 191471, '\p{^cjkextf}', "");
    Expect(0, 191471, '\P{cjkextf}', "");
    Expect(1, 191471, '\P{^cjkextf}', "");
    Expect(0, 191472, '\p{cjkextf}', "");
    Expect(1, 191472, '\p{^cjkextf}', "");
    Expect(1, 191472, '\P{cjkextf}', "");
    Expect(0, 191472, '\P{^cjkextf}', "");
    Expect(1, 191471, '\p{	-CJK_Ext_f}', "");
    Expect(0, 191471, '\p{^	-CJK_Ext_f}', "");
    Expect(0, 191471, '\P{	-CJK_Ext_f}', "");
    Expect(1, 191471, '\P{^	-CJK_Ext_f}', "");
    Expect(0, 191472, '\p{	-CJK_Ext_f}', "");
    Expect(1, 191472, '\p{^	-CJK_Ext_f}', "");
    Expect(1, 191472, '\P{	-CJK_Ext_f}', "");
    Expect(0, 191472, '\P{^	-CJK_Ext_f}', "");
    Error('\p{/a/		is_cjk_ext_F}');
    Error('\P{/a/		is_cjk_ext_F}');
    Expect(1, 191471, '\p{iscjkextf}', "");
    Expect(0, 191471, '\p{^iscjkextf}', "");
    Expect(0, 191471, '\P{iscjkextf}', "");
    Expect(1, 191471, '\P{^iscjkextf}', "");
    Expect(0, 191472, '\p{iscjkextf}', "");
    Expect(1, 191472, '\p{^iscjkextf}', "");
    Expect(1, 191472, '\P{iscjkextf}', "");
    Expect(0, 191472, '\P{^iscjkextf}', "");
    Expect(1, 191471, '\p{	Is_CJK_Ext_F}', "");
    Expect(0, 191471, '\p{^	Is_CJK_Ext_F}', "");
    Expect(0, 191471, '\P{	Is_CJK_Ext_F}', "");
    Expect(1, 191471, '\P{^	Is_CJK_Ext_F}', "");
    Expect(0, 191472, '\p{	Is_CJK_Ext_F}', "");
    Expect(1, 191472, '\p{^	Is_CJK_Ext_F}', "");
    Expect(1, 191472, '\P{	Is_CJK_Ext_F}', "");
    Expect(0, 191472, '\P{^	Is_CJK_Ext_F}', "");
    Error('\p{-_IN_CJK_Ext_f/a/}');
    Error('\P{-_IN_CJK_Ext_f/a/}');
    Expect(1, 191471, '\p{incjkextf}', "");
    Expect(0, 191471, '\p{^incjkextf}', "");
    Expect(0, 191471, '\P{incjkextf}', "");
    Expect(1, 191471, '\P{^incjkextf}', "");
    Expect(0, 191472, '\p{incjkextf}', "");
    Expect(1, 191472, '\p{^incjkextf}', "");
    Expect(1, 191472, '\P{incjkextf}', "");
    Expect(0, 191472, '\P{^incjkextf}', "");
    Expect(1, 191471, '\p{IN_cjk_EXT_F}', "");
    Expect(0, 191471, '\p{^IN_cjk_EXT_F}', "");
    Expect(0, 191471, '\P{IN_cjk_EXT_F}', "");
    Expect(1, 191471, '\P{^IN_cjk_EXT_F}', "");
    Expect(0, 191472, '\p{IN_cjk_EXT_F}', "");
    Expect(1, 191472, '\p{^IN_cjk_EXT_F}', "");
    Expect(1, 191472, '\P{IN_cjk_EXT_F}', "");
    Expect(0, 191472, '\P{^IN_cjk_EXT_F}', "");
    Error('\p{-:=Close_PUNCTUATION}');
    Error('\P{-:=Close_PUNCTUATION}');
    Expect(1, 65379, '\p{closepunctuation}', "");
    Expect(0, 65379, '\p{^closepunctuation}', "");
    Expect(0, 65379, '\P{closepunctuation}', "");
    Expect(1, 65379, '\P{^closepunctuation}', "");
    Expect(0, 65380, '\p{closepunctuation}', "");
    Expect(1, 65380, '\p{^closepunctuation}', "");
    Expect(1, 65380, '\P{closepunctuation}', "");
    Expect(0, 65380, '\P{^closepunctuation}', "");
    Expect(1, 65379, '\p{ 	close_Punctuation}', "");
    Expect(0, 65379, '\p{^ 	close_Punctuation}', "");
    Expect(0, 65379, '\P{ 	close_Punctuation}', "");
    Expect(1, 65379, '\P{^ 	close_Punctuation}', "");
    Expect(0, 65380, '\p{ 	close_Punctuation}', "");
    Expect(1, 65380, '\p{^ 	close_Punctuation}', "");
    Expect(1, 65380, '\P{ 	close_Punctuation}', "");
    Expect(0, 65380, '\P{^ 	close_Punctuation}', "");
    Error('\p{- IS_close_Punctuation/a/}');
    Error('\P{- IS_close_Punctuation/a/}');
    Expect(1, 65379, '\p{isclosepunctuation}', "");
    Expect(0, 65379, '\p{^isclosepunctuation}', "");
    Expect(0, 65379, '\P{isclosepunctuation}', "");
    Expect(1, 65379, '\P{^isclosepunctuation}', "");
    Expect(0, 65380, '\p{isclosepunctuation}', "");
    Expect(1, 65380, '\p{^isclosepunctuation}', "");
    Expect(1, 65380, '\P{isclosepunctuation}', "");
    Expect(0, 65380, '\P{^isclosepunctuation}', "");
    Expect(1, 65379, '\p{--is_CLOSE_Punctuation}', "");
    Expect(0, 65379, '\p{^--is_CLOSE_Punctuation}', "");
    Expect(0, 65379, '\P{--is_CLOSE_Punctuation}', "");
    Expect(1, 65379, '\P{^--is_CLOSE_Punctuation}', "");
    Expect(0, 65380, '\p{--is_CLOSE_Punctuation}', "");
    Expect(1, 65380, '\p{^--is_CLOSE_Punctuation}', "");
    Expect(1, 65380, '\P{--is_CLOSE_Punctuation}', "");
    Expect(0, 65380, '\P{^--is_CLOSE_Punctuation}', "");
    Error('\p{/a/_	Pe}');
    Error('\P{/a/_	Pe}');
    Expect(1, 65379, '\p{pe}', "");
    Expect(0, 65379, '\p{^pe}', "");
    Expect(0, 65379, '\P{pe}', "");
    Expect(1, 65379, '\P{^pe}', "");
    Expect(0, 65380, '\p{pe}', "");
    Expect(1, 65380, '\p{^pe}', "");
    Expect(1, 65380, '\P{pe}', "");
    Expect(0, 65380, '\P{^pe}', "");
    Expect(1, 65379, '\p{	-PE}', "");
    Expect(0, 65379, '\p{^	-PE}', "");
    Expect(0, 65379, '\P{	-PE}', "");
    Expect(1, 65379, '\P{^	-PE}', "");
    Expect(0, 65380, '\p{	-PE}', "");
    Expect(1, 65380, '\p{^	-PE}', "");
    Expect(1, 65380, '\P{	-PE}', "");
    Expect(0, 65380, '\P{^	-PE}', "");
    Error('\p{/a/-	IS_Pe}');
    Error('\P{/a/-	IS_Pe}');
    Expect(1, 65379, '\p{ispe}', "");
    Expect(0, 65379, '\p{^ispe}', "");
    Expect(0, 65379, '\P{ispe}', "");
    Expect(1, 65379, '\P{^ispe}', "");
    Expect(0, 65380, '\p{ispe}', "");
    Expect(1, 65380, '\p{^ispe}', "");
    Expect(1, 65380, '\P{ispe}', "");
    Expect(0, 65380, '\P{^ispe}', "");
    Expect(1, 65379, '\p{ Is_PE}', "");
    Expect(0, 65379, '\p{^ Is_PE}', "");
    Expect(0, 65379, '\P{ Is_PE}', "");
    Expect(1, 65379, '\P{^ Is_PE}', "");
    Expect(0, 65380, '\p{ Is_PE}', "");
    Expect(1, 65380, '\p{^ Is_PE}', "");
    Expect(1, 65380, '\P{ Is_PE}', "");
    Expect(0, 65380, '\P{^ Is_PE}', "");
    Error('\p{- XPOSIXCNTRL/a/}');
    Error('\P{- XPOSIXCNTRL/a/}');
    Expect(1, 159, '\p{xposixcntrl}', "");
    Expect(0, 159, '\p{^xposixcntrl}', "");
    Expect(0, 159, '\P{xposixcntrl}', "");
    Expect(1, 159, '\P{^xposixcntrl}', "");
    Expect(0, 160, '\p{xposixcntrl}', "");
    Expect(1, 160, '\p{^xposixcntrl}', "");
    Expect(1, 160, '\P{xposixcntrl}', "");
    Expect(0, 160, '\P{^xposixcntrl}', "");
    Expect(1, 159, '\p{__XPosixCntrl}', "");
    Expect(0, 159, '\p{^__XPosixCntrl}', "");
    Expect(0, 159, '\P{__XPosixCntrl}', "");
    Expect(1, 159, '\P{^__XPosixCntrl}', "");
    Expect(0, 160, '\p{__XPosixCntrl}', "");
    Expect(1, 160, '\p{^__XPosixCntrl}', "");
    Expect(1, 160, '\P{__XPosixCntrl}', "");
    Expect(0, 160, '\P{^__XPosixCntrl}', "");
    Error('\p{:=Cntrl}');
    Error('\P{:=Cntrl}');
    Expect(1, 159, '\p{cntrl}', "");
    Expect(0, 159, '\p{^cntrl}', "");
    Expect(0, 159, '\P{cntrl}', "");
    Expect(1, 159, '\P{^cntrl}', "");
    Expect(0, 160, '\p{cntrl}', "");
    Expect(1, 160, '\p{^cntrl}', "");
    Expect(1, 160, '\P{cntrl}', "");
    Expect(0, 160, '\P{^cntrl}', "");
    Expect(1, 159, '\p{- cntrl}', "");
    Expect(0, 159, '\p{^- cntrl}', "");
    Expect(0, 159, '\P{- cntrl}', "");
    Expect(1, 159, '\P{^- cntrl}', "");
    Expect(0, 160, '\p{- cntrl}', "");
    Expect(1, 160, '\p{^- cntrl}', "");
    Expect(1, 160, '\P{- cntrl}', "");
    Expect(0, 160, '\P{^- cntrl}', "");
    Error('\p{/a/	is_XPosixCntrl}');
    Error('\P{/a/	is_XPosixCntrl}');
    Expect(1, 159, '\p{isxposixcntrl}', "");
    Expect(0, 159, '\p{^isxposixcntrl}', "");
    Expect(0, 159, '\P{isxposixcntrl}', "");
    Expect(1, 159, '\P{^isxposixcntrl}', "");
    Expect(0, 160, '\p{isxposixcntrl}', "");
    Expect(1, 160, '\p{^isxposixcntrl}', "");
    Expect(1, 160, '\P{isxposixcntrl}', "");
    Expect(0, 160, '\P{^isxposixcntrl}', "");
    Expect(1, 159, '\p{ -Is_xposixcntrl}', "");
    Expect(0, 159, '\p{^ -Is_xposixcntrl}', "");
    Expect(0, 159, '\P{ -Is_xposixcntrl}', "");
    Expect(1, 159, '\P{^ -Is_xposixcntrl}', "");
    Expect(0, 160, '\p{ -Is_xposixcntrl}', "");
    Expect(1, 160, '\p{^ -Is_xposixcntrl}', "");
    Expect(1, 160, '\P{ -Is_xposixcntrl}', "");
    Expect(0, 160, '\P{^ -Is_xposixcntrl}', "");
    Error('\p{:=is_Cntrl}');
    Error('\P{:=is_Cntrl}');
    Expect(1, 159, '\p{iscntrl}', "");
    Expect(0, 159, '\p{^iscntrl}', "");
    Expect(0, 159, '\P{iscntrl}', "");
    Expect(1, 159, '\P{^iscntrl}', "");
    Expect(0, 160, '\p{iscntrl}', "");
    Expect(1, 160, '\p{^iscntrl}', "");
    Expect(1, 160, '\P{iscntrl}', "");
    Expect(0, 160, '\P{^iscntrl}', "");
    Expect(1, 159, '\p{	_Is_Cntrl}', "");
    Expect(0, 159, '\p{^	_Is_Cntrl}', "");
    Expect(0, 159, '\P{	_Is_Cntrl}', "");
    Expect(1, 159, '\P{^	_Is_Cntrl}', "");
    Expect(0, 160, '\p{	_Is_Cntrl}', "");
    Expect(1, 160, '\p{^	_Is_Cntrl}', "");
    Expect(1, 160, '\P{	_Is_Cntrl}', "");
    Expect(0, 160, '\P{^	_Is_Cntrl}', "");
    Error('\p{ :=CONTROL}');
    Error('\P{ :=CONTROL}');
    Expect(1, 159, '\p{control}', "");
    Expect(0, 159, '\p{^control}', "");
    Expect(0, 159, '\P{control}', "");
    Expect(1, 159, '\P{^control}', "");
    Expect(0, 160, '\p{control}', "");
    Expect(1, 160, '\p{^control}', "");
    Expect(1, 160, '\P{control}', "");
    Expect(0, 160, '\P{^control}', "");
    Expect(1, 159, '\p{ Control}', "");
    Expect(0, 159, '\p{^ Control}', "");
    Expect(0, 159, '\P{ Control}', "");
    Expect(1, 159, '\P{^ Control}', "");
    Expect(0, 160, '\p{ Control}', "");
    Expect(1, 160, '\p{^ Control}', "");
    Expect(1, 160, '\P{ Control}', "");
    Expect(0, 160, '\P{^ Control}', "");
    Error('\p{		IS_CONTROL/a/}');
    Error('\P{		IS_CONTROL/a/}');
    Expect(1, 159, '\p{iscontrol}', "");
    Expect(0, 159, '\p{^iscontrol}', "");
    Expect(0, 159, '\P{iscontrol}', "");
    Expect(1, 159, '\P{^iscontrol}', "");
    Expect(0, 160, '\p{iscontrol}', "");
    Expect(1, 160, '\p{^iscontrol}', "");
    Expect(1, 160, '\P{iscontrol}', "");
    Expect(0, 160, '\P{^iscontrol}', "");
    Expect(1, 159, '\p{_Is_Control}', "");
    Expect(0, 159, '\p{^_Is_Control}', "");
    Expect(0, 159, '\P{_Is_Control}', "");
    Expect(1, 159, '\P{^_Is_Control}', "");
    Expect(0, 160, '\p{_Is_Control}', "");
    Expect(1, 160, '\p{^_Is_Control}', "");
    Expect(1, 160, '\P{_Is_Control}', "");
    Expect(0, 160, '\P{^_Is_Control}', "");
    Error('\p{/a/	_CC}');
    Error('\P{/a/	_CC}');
    Expect(1, 159, '\p{cc}', "");
    Expect(0, 159, '\p{^cc}', "");
    Expect(0, 159, '\P{cc}', "");
    Expect(1, 159, '\P{^cc}', "");
    Expect(0, 160, '\p{cc}', "");
    Expect(1, 160, '\p{^cc}', "");
    Expect(1, 160, '\P{cc}', "");
    Expect(0, 160, '\P{^cc}', "");
    Expect(1, 159, '\p{_-Cc}', "");
    Expect(0, 159, '\p{^_-Cc}', "");
    Expect(0, 159, '\P{_-Cc}', "");
    Expect(1, 159, '\P{^_-Cc}', "");
    Expect(0, 160, '\p{_-Cc}', "");
    Expect(1, 160, '\p{^_-Cc}', "");
    Expect(1, 160, '\P{_-Cc}', "");
    Expect(0, 160, '\P{^_-Cc}', "");
    Error('\p{/a/		is_cc}');
    Error('\P{/a/		is_cc}');
    Expect(1, 159, '\p{iscc}', "");
    Expect(0, 159, '\p{^iscc}', "");
    Expect(0, 159, '\P{iscc}', "");
    Expect(1, 159, '\P{^iscc}', "");
    Expect(0, 160, '\p{iscc}', "");
    Expect(1, 160, '\p{^iscc}', "");
    Expect(1, 160, '\P{iscc}', "");
    Expect(0, 160, '\P{^iscc}', "");
    Expect(1, 159, '\p{_Is_cc}', "");
    Expect(0, 159, '\p{^_Is_cc}', "");
    Expect(0, 159, '\P{_Is_cc}', "");
    Expect(1, 159, '\P{^_Is_cc}', "");
    Expect(0, 160, '\p{_Is_cc}', "");
    Expect(1, 160, '\p{^_Is_cc}', "");
    Expect(1, 160, '\P{_Is_cc}', "");
    Expect(0, 160, '\P{^_Is_cc}', "");
    Error('\p{:=- COMBINING_diacritical_Marks}');
    Error('\P{:=- COMBINING_diacritical_Marks}');
    Expect(1, 879, '\p{combiningdiacriticalmarks}', "");
    Expect(0, 879, '\p{^combiningdiacriticalmarks}', "");
    Expect(0, 879, '\P{combiningdiacriticalmarks}', "");
    Expect(1, 879, '\P{^combiningdiacriticalmarks}', "");
    Expect(0, 880, '\p{combiningdiacriticalmarks}', "");
    Expect(1, 880, '\p{^combiningdiacriticalmarks}', "");
    Expect(1, 880, '\P{combiningdiacriticalmarks}', "");
    Expect(0, 880, '\P{^combiningdiacriticalmarks}', "");
    Expect(1, 879, '\p{	Combining_Diacritical_Marks}', "");
    Expect(0, 879, '\p{^	Combining_Diacritical_Marks}', "");
    Expect(0, 879, '\P{	Combining_Diacritical_Marks}', "");
    Expect(1, 879, '\P{^	Combining_Diacritical_Marks}', "");
    Expect(0, 880, '\p{	Combining_Diacritical_Marks}', "");
    Expect(1, 880, '\p{^	Combining_Diacritical_Marks}', "");
    Expect(1, 880, '\P{	Combining_Diacritical_Marks}', "");
    Expect(0, 880, '\P{^	Combining_Diacritical_Marks}', "");
    Error('\p{_-IS_combining_DIACRITICAL_Marks:=}');
    Error('\P{_-IS_combining_DIACRITICAL_Marks:=}');
    Expect(1, 879, '\p{iscombiningdiacriticalmarks}', "");
    Expect(0, 879, '\p{^iscombiningdiacriticalmarks}', "");
    Expect(0, 879, '\P{iscombiningdiacriticalmarks}', "");
    Expect(1, 879, '\P{^iscombiningdiacriticalmarks}', "");
    Expect(0, 880, '\p{iscombiningdiacriticalmarks}', "");
    Expect(1, 880, '\p{^iscombiningdiacriticalmarks}', "");
    Expect(1, 880, '\P{iscombiningdiacriticalmarks}', "");
    Expect(0, 880, '\P{^iscombiningdiacriticalmarks}', "");
    Expect(1, 879, '\p{ _Is_Combining_Diacritical_marks}', "");
    Expect(0, 879, '\p{^ _Is_Combining_Diacritical_marks}', "");
    Expect(0, 879, '\P{ _Is_Combining_Diacritical_marks}', "");
    Expect(1, 879, '\P{^ _Is_Combining_Diacritical_marks}', "");
    Expect(0, 880, '\p{ _Is_Combining_Diacritical_marks}', "");
    Expect(1, 880, '\p{^ _Is_Combining_Diacritical_marks}', "");
    Expect(1, 880, '\P{ _Is_Combining_Diacritical_marks}', "");
    Expect(0, 880, '\P{^ _Is_Combining_Diacritical_marks}', "");
    Error('\p{-	In_Combining_Diacritical_Marks:=}');
    Error('\P{-	In_Combining_Diacritical_Marks:=}');
    Expect(1, 879, '\p{incombiningdiacriticalmarks}', "");
    Expect(0, 879, '\p{^incombiningdiacriticalmarks}', "");
    Expect(0, 879, '\P{incombiningdiacriticalmarks}', "");
    Expect(1, 879, '\P{^incombiningdiacriticalmarks}', "");
    Expect(0, 880, '\p{incombiningdiacriticalmarks}', "");
    Expect(1, 880, '\p{^incombiningdiacriticalmarks}', "");
    Expect(1, 880, '\P{incombiningdiacriticalmarks}', "");
    Expect(0, 880, '\P{^incombiningdiacriticalmarks}', "");
    Expect(1, 879, '\p{	_IN_Combining_Diacritical_Marks}', "");
    Expect(0, 879, '\p{^	_IN_Combining_Diacritical_Marks}', "");
    Expect(0, 879, '\P{	_IN_Combining_Diacritical_Marks}', "");
    Expect(1, 879, '\P{^	_IN_Combining_Diacritical_Marks}', "");
    Expect(0, 880, '\p{	_IN_Combining_Diacritical_Marks}', "");
    Expect(1, 880, '\p{^	_IN_Combining_Diacritical_Marks}', "");
    Expect(1, 880, '\P{	_IN_Combining_Diacritical_Marks}', "");
    Expect(0, 880, '\P{^	_IN_Combining_Diacritical_Marks}', "");
    Error('\p{_/a/diacriticals}');
    Error('\P{_/a/diacriticals}');
    Expect(1, 879, '\p{diacriticals}', "");
    Expect(0, 879, '\p{^diacriticals}', "");
    Expect(0, 879, '\P{diacriticals}', "");
    Expect(1, 879, '\P{^diacriticals}', "");
    Expect(0, 880, '\p{diacriticals}', "");
    Expect(1, 880, '\p{^diacriticals}', "");
    Expect(1, 880, '\P{diacriticals}', "");
    Expect(0, 880, '\P{^diacriticals}', "");
    Expect(1, 879, '\p{	Diacriticals}', "");
    Expect(0, 879, '\p{^	Diacriticals}', "");
    Expect(0, 879, '\P{	Diacriticals}', "");
    Expect(1, 879, '\P{^	Diacriticals}', "");
    Expect(0, 880, '\p{	Diacriticals}', "");
    Expect(1, 880, '\p{^	Diacriticals}', "");
    Expect(1, 880, '\P{	Diacriticals}', "");
    Expect(0, 880, '\P{^	Diacriticals}', "");
    Error('\p{:= -Is_Diacriticals}');
    Error('\P{:= -Is_Diacriticals}');
    Expect(1, 879, '\p{isdiacriticals}', "");
    Expect(0, 879, '\p{^isdiacriticals}', "");
    Expect(0, 879, '\P{isdiacriticals}', "");
    Expect(1, 879, '\P{^isdiacriticals}', "");
    Expect(0, 880, '\p{isdiacriticals}', "");
    Expect(1, 880, '\p{^isdiacriticals}', "");
    Expect(1, 880, '\P{isdiacriticals}', "");
    Expect(0, 880, '\P{^isdiacriticals}', "");
    Expect(1, 879, '\p{ 	IS_diacriticals}', "");
    Expect(0, 879, '\p{^ 	IS_diacriticals}', "");
    Expect(0, 879, '\P{ 	IS_diacriticals}', "");
    Expect(1, 879, '\P{^ 	IS_diacriticals}', "");
    Expect(0, 880, '\p{ 	IS_diacriticals}', "");
    Expect(1, 880, '\p{^ 	IS_diacriticals}', "");
    Expect(1, 880, '\P{ 	IS_diacriticals}', "");
    Expect(0, 880, '\P{^ 	IS_diacriticals}', "");
    Error('\p{	In_diacriticals:=}');
    Error('\P{	In_diacriticals:=}');
    Expect(1, 879, '\p{indiacriticals}', "");
    Expect(0, 879, '\p{^indiacriticals}', "");
    Expect(0, 879, '\P{indiacriticals}', "");
    Expect(1, 879, '\P{^indiacriticals}', "");
    Expect(0, 880, '\p{indiacriticals}', "");
    Expect(1, 880, '\p{^indiacriticals}', "");
    Expect(1, 880, '\P{indiacriticals}', "");
    Expect(0, 880, '\P{^indiacriticals}', "");
    Expect(1, 879, '\p{_ In_Diacriticals}', "");
    Expect(0, 879, '\p{^_ In_Diacriticals}', "");
    Expect(0, 879, '\P{_ In_Diacriticals}', "");
    Expect(1, 879, '\P{^_ In_Diacriticals}', "");
    Expect(0, 880, '\p{_ In_Diacriticals}', "");
    Expect(1, 880, '\p{^_ In_Diacriticals}', "");
    Expect(1, 880, '\P{_ In_Diacriticals}', "");
    Expect(0, 880, '\P{^_ In_Diacriticals}', "");
    Error('\p{_:=COMBINING_DIACRITICAL_marks_EXTENDED}');
    Error('\P{_:=COMBINING_DIACRITICAL_marks_EXTENDED}');
    Expect(1, 6911, '\p{combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\p{^combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\P{combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\P{^combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\p{combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\p{^combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\P{combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\P{^combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\p{--Combining_diacritical_Marks_Extended}', "");
    Expect(0, 6911, '\p{^--Combining_diacritical_Marks_Extended}', "");
    Expect(0, 6911, '\P{--Combining_diacritical_Marks_Extended}', "");
    Expect(1, 6911, '\P{^--Combining_diacritical_Marks_Extended}', "");
    Expect(0, 6912, '\p{--Combining_diacritical_Marks_Extended}', "");
    Expect(1, 6912, '\p{^--Combining_diacritical_Marks_Extended}', "");
    Expect(1, 6912, '\P{--Combining_diacritical_Marks_Extended}', "");
    Expect(0, 6912, '\P{^--Combining_diacritical_Marks_Extended}', "");
    Error('\p{/a/_ Is_combining_DIACRITICAL_MARKS_Extended}');
    Error('\P{/a/_ Is_combining_DIACRITICAL_MARKS_Extended}');
    Expect(1, 6911, '\p{iscombiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\p{^iscombiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\P{iscombiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\P{^iscombiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\p{iscombiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\p{^iscombiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\P{iscombiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\P{^iscombiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\p{-is_Combining_diacritical_Marks_Extended}', "");
    Expect(0, 6911, '\p{^-is_Combining_diacritical_Marks_Extended}', "");
    Expect(0, 6911, '\P{-is_Combining_diacritical_Marks_Extended}', "");
    Expect(1, 6911, '\P{^-is_Combining_diacritical_Marks_Extended}', "");
    Expect(0, 6912, '\p{-is_Combining_diacritical_Marks_Extended}', "");
    Expect(1, 6912, '\p{^-is_Combining_diacritical_Marks_Extended}', "");
    Expect(1, 6912, '\P{-is_Combining_diacritical_Marks_Extended}', "");
    Expect(0, 6912, '\P{^-is_Combining_diacritical_Marks_Extended}', "");
    Error('\p{	-In_Combining_diacritical_MARKS_extended/a/}');
    Error('\P{	-In_Combining_diacritical_MARKS_extended/a/}');
    Expect(1, 6911, '\p{incombiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\p{^incombiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\P{incombiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\P{^incombiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\p{incombiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\p{^incombiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\P{incombiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\P{^incombiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\p{		In_combining_Diacritical_marks_Extended}', "");
    Expect(0, 6911, '\p{^		In_combining_Diacritical_marks_Extended}', "");
    Expect(0, 6911, '\P{		In_combining_Diacritical_marks_Extended}', "");
    Expect(1, 6911, '\P{^		In_combining_Diacritical_marks_Extended}', "");
    Expect(0, 6912, '\p{		In_combining_Diacritical_marks_Extended}', "");
    Expect(1, 6912, '\p{^		In_combining_Diacritical_marks_Extended}', "");
    Expect(1, 6912, '\P{		In_combining_Diacritical_marks_Extended}', "");
    Expect(0, 6912, '\P{^		In_combining_Diacritical_marks_Extended}', "");
    Error('\p{_Diacriticals_ext/a/}');
    Error('\P{_Diacriticals_ext/a/}');
    Expect(1, 6911, '\p{diacriticalsext}', "");
    Expect(0, 6911, '\p{^diacriticalsext}', "");
    Expect(0, 6911, '\P{diacriticalsext}', "");
    Expect(1, 6911, '\P{^diacriticalsext}', "");
    Expect(0, 6912, '\p{diacriticalsext}', "");
    Expect(1, 6912, '\p{^diacriticalsext}', "");
    Expect(1, 6912, '\P{diacriticalsext}', "");
    Expect(0, 6912, '\P{^diacriticalsext}', "");
    Expect(1, 6911, '\p{-DIACRITICALS_Ext}', "");
    Expect(0, 6911, '\p{^-DIACRITICALS_Ext}', "");
    Expect(0, 6911, '\P{-DIACRITICALS_Ext}', "");
    Expect(1, 6911, '\P{^-DIACRITICALS_Ext}', "");
    Expect(0, 6912, '\p{-DIACRITICALS_Ext}', "");
    Expect(1, 6912, '\p{^-DIACRITICALS_Ext}', "");
    Expect(1, 6912, '\P{-DIACRITICALS_Ext}', "");
    Expect(0, 6912, '\P{^-DIACRITICALS_Ext}', "");
    Error('\p{ -IS_Diacriticals_EXT:=}');
    Error('\P{ -IS_Diacriticals_EXT:=}');
    Expect(1, 6911, '\p{isdiacriticalsext}', "");
    Expect(0, 6911, '\p{^isdiacriticalsext}', "");
    Expect(0, 6911, '\P{isdiacriticalsext}', "");
    Expect(1, 6911, '\P{^isdiacriticalsext}', "");
    Expect(0, 6912, '\p{isdiacriticalsext}', "");
    Expect(1, 6912, '\p{^isdiacriticalsext}', "");
    Expect(1, 6912, '\P{isdiacriticalsext}', "");
    Expect(0, 6912, '\P{^isdiacriticalsext}', "");
    Expect(1, 6911, '\p{ _IS_diacriticals_ext}', "");
    Expect(0, 6911, '\p{^ _IS_diacriticals_ext}', "");
    Expect(0, 6911, '\P{ _IS_diacriticals_ext}', "");
    Expect(1, 6911, '\P{^ _IS_diacriticals_ext}', "");
    Expect(0, 6912, '\p{ _IS_diacriticals_ext}', "");
    Expect(1, 6912, '\p{^ _IS_diacriticals_ext}', "");
    Expect(1, 6912, '\P{ _IS_diacriticals_ext}', "");
    Expect(0, 6912, '\P{^ _IS_diacriticals_ext}', "");
    Error('\p{:= in_Diacriticals_Ext}');
    Error('\P{:= in_Diacriticals_Ext}');
    Expect(1, 6911, '\p{indiacriticalsext}', "");
    Expect(0, 6911, '\p{^indiacriticalsext}', "");
    Expect(0, 6911, '\P{indiacriticalsext}', "");
    Expect(1, 6911, '\P{^indiacriticalsext}', "");
    Expect(0, 6912, '\p{indiacriticalsext}', "");
    Expect(1, 6912, '\p{^indiacriticalsext}', "");
    Expect(1, 6912, '\P{indiacriticalsext}', "");
    Expect(0, 6912, '\P{^indiacriticalsext}', "");
    Expect(1, 6911, '\p{_-In_Diacriticals_EXT}', "");
    Expect(0, 6911, '\p{^_-In_Diacriticals_EXT}', "");
    Expect(0, 6911, '\P{_-In_Diacriticals_EXT}', "");
    Expect(1, 6911, '\P{^_-In_Diacriticals_EXT}', "");
    Expect(0, 6912, '\p{_-In_Diacriticals_EXT}', "");
    Expect(1, 6912, '\p{^_-In_Diacriticals_EXT}', "");
    Expect(1, 6912, '\P{_-In_Diacriticals_EXT}', "");
    Expect(0, 6912, '\P{^_-In_Diacriticals_EXT}', "");
    Error('\p{/a/Combining_DIACRITICAL_Marks_for_SYMBOLS}');
    Error('\P{/a/Combining_DIACRITICAL_Marks_for_SYMBOLS}');
    Expect(1, 8447, '\p{combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\p{^combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\P{combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\P{^combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\p{combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\p{^combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\P{combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\P{^combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\p{	Combining_diacritical_Marks_for_SYMBOLS}', "");
    Expect(0, 8447, '\p{^	Combining_diacritical_Marks_for_SYMBOLS}', "");
    Expect(0, 8447, '\P{	Combining_diacritical_Marks_for_SYMBOLS}', "");
    Expect(1, 8447, '\P{^	Combining_diacritical_Marks_for_SYMBOLS}', "");
    Expect(0, 8448, '\p{	Combining_diacritical_Marks_for_SYMBOLS}', "");
    Expect(1, 8448, '\p{^	Combining_diacritical_Marks_for_SYMBOLS}', "");
    Expect(1, 8448, '\P{	Combining_diacritical_Marks_for_SYMBOLS}', "");
    Expect(0, 8448, '\P{^	Combining_diacritical_Marks_for_SYMBOLS}', "");
    Error('\p{-Is_combining_DIACRITICAL_marks_FOR_SYMBOLS/a/}');
    Error('\P{-Is_combining_DIACRITICAL_marks_FOR_SYMBOLS/a/}');
    Expect(1, 8447, '\p{iscombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\p{^iscombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\P{iscombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\P{^iscombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\p{iscombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\p{^iscombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\P{iscombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\P{^iscombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\p{_-Is_Combining_Diacritical_marks_FOR_SYMBOLS}', "");
    Expect(0, 8447, '\p{^_-Is_Combining_Diacritical_marks_FOR_SYMBOLS}', "");
    Expect(0, 8447, '\P{_-Is_Combining_Diacritical_marks_FOR_SYMBOLS}', "");
    Expect(1, 8447, '\P{^_-Is_Combining_Diacritical_marks_FOR_SYMBOLS}', "");
    Expect(0, 8448, '\p{_-Is_Combining_Diacritical_marks_FOR_SYMBOLS}', "");
    Expect(1, 8448, '\p{^_-Is_Combining_Diacritical_marks_FOR_SYMBOLS}', "");
    Expect(1, 8448, '\P{_-Is_Combining_Diacritical_marks_FOR_SYMBOLS}', "");
    Expect(0, 8448, '\P{^_-Is_Combining_Diacritical_marks_FOR_SYMBOLS}', "");
    Error('\p{-_in_Combining_DIACRITICAL_Marks_FOR_Symbols:=}');
    Error('\P{-_in_Combining_DIACRITICAL_Marks_FOR_Symbols:=}');
    Expect(1, 8447, '\p{incombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\p{^incombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\P{incombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\P{^incombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\p{incombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\p{^incombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\P{incombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\P{^incombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\p{-in_combining_DIACRITICAL_MARKS_for_symbols}', "");
    Expect(0, 8447, '\p{^-in_combining_DIACRITICAL_MARKS_for_symbols}', "");
    Expect(0, 8447, '\P{-in_combining_DIACRITICAL_MARKS_for_symbols}', "");
    Expect(1, 8447, '\P{^-in_combining_DIACRITICAL_MARKS_for_symbols}', "");
    Expect(0, 8448, '\p{-in_combining_DIACRITICAL_MARKS_for_symbols}', "");
    Expect(1, 8448, '\p{^-in_combining_DIACRITICAL_MARKS_for_symbols}', "");
    Expect(1, 8448, '\P{-in_combining_DIACRITICAL_MARKS_for_symbols}', "");
    Expect(0, 8448, '\P{^-in_combining_DIACRITICAL_MARKS_for_symbols}', "");
    Error('\p{_	DIACRITICALS_FOR_Symbols:=}');
    Error('\P{_	DIACRITICALS_FOR_Symbols:=}');
    Expect(1, 8447, '\p{diacriticalsforsymbols}', "");
    Expect(0, 8447, '\p{^diacriticalsforsymbols}', "");
    Expect(0, 8447, '\P{diacriticalsforsymbols}', "");
    Expect(1, 8447, '\P{^diacriticalsforsymbols}', "");
    Expect(0, 8448, '\p{diacriticalsforsymbols}', "");
    Expect(1, 8448, '\p{^diacriticalsforsymbols}', "");
    Expect(1, 8448, '\P{diacriticalsforsymbols}', "");
    Expect(0, 8448, '\P{^diacriticalsforsymbols}', "");
    Expect(1, 8447, '\p{ _DIACRITICALS_For_symbols}', "");
    Expect(0, 8447, '\p{^ _DIACRITICALS_For_symbols}', "");
    Expect(0, 8447, '\P{ _DIACRITICALS_For_symbols}', "");
    Expect(1, 8447, '\P{^ _DIACRITICALS_For_symbols}', "");
    Expect(0, 8448, '\p{ _DIACRITICALS_For_symbols}', "");
    Expect(1, 8448, '\p{^ _DIACRITICALS_For_symbols}', "");
    Expect(1, 8448, '\P{ _DIACRITICALS_For_symbols}', "");
    Expect(0, 8448, '\P{^ _DIACRITICALS_For_symbols}', "");
    Error('\p{	-Is_DIACRITICALS_For_Symbols/a/}');
    Error('\P{	-Is_DIACRITICALS_For_Symbols/a/}');
    Expect(1, 8447, '\p{isdiacriticalsforsymbols}', "");
    Expect(0, 8447, '\p{^isdiacriticalsforsymbols}', "");
    Expect(0, 8447, '\P{isdiacriticalsforsymbols}', "");
    Expect(1, 8447, '\P{^isdiacriticalsforsymbols}', "");
    Expect(0, 8448, '\p{isdiacriticalsforsymbols}', "");
    Expect(1, 8448, '\p{^isdiacriticalsforsymbols}', "");
    Expect(1, 8448, '\P{isdiacriticalsforsymbols}', "");
    Expect(0, 8448, '\P{^isdiacriticalsforsymbols}', "");
    Expect(1, 8447, '\p{-	is_Diacriticals_For_symbols}', "");
    Expect(0, 8447, '\p{^-	is_Diacriticals_For_symbols}', "");
    Expect(0, 8447, '\P{-	is_Diacriticals_For_symbols}', "");
    Expect(1, 8447, '\P{^-	is_Diacriticals_For_symbols}', "");
    Expect(0, 8448, '\p{-	is_Diacriticals_For_symbols}', "");
    Expect(1, 8448, '\p{^-	is_Diacriticals_For_symbols}', "");
    Expect(1, 8448, '\P{-	is_Diacriticals_For_symbols}', "");
    Expect(0, 8448, '\P{^-	is_Diacriticals_For_symbols}', "");
    Error('\p{ /a/IN_DIACRITICALS_for_Symbols}');
    Error('\P{ /a/IN_DIACRITICALS_for_Symbols}');
    Expect(1, 8447, '\p{indiacriticalsforsymbols}', "");
    Expect(0, 8447, '\p{^indiacriticalsforsymbols}', "");
    Expect(0, 8447, '\P{indiacriticalsforsymbols}', "");
    Expect(1, 8447, '\P{^indiacriticalsforsymbols}', "");
    Expect(0, 8448, '\p{indiacriticalsforsymbols}', "");
    Expect(1, 8448, '\p{^indiacriticalsforsymbols}', "");
    Expect(1, 8448, '\P{indiacriticalsforsymbols}', "");
    Expect(0, 8448, '\P{^indiacriticalsforsymbols}', "");
    Expect(1, 8447, '\p{-_in_diacriticals_For_SYMBOLS}', "");
    Expect(0, 8447, '\p{^-_in_diacriticals_For_SYMBOLS}', "");
    Expect(0, 8447, '\P{-_in_diacriticals_For_SYMBOLS}', "");
    Expect(1, 8447, '\P{^-_in_diacriticals_For_SYMBOLS}', "");
    Expect(0, 8448, '\p{-_in_diacriticals_For_SYMBOLS}', "");
    Expect(1, 8448, '\p{^-_in_diacriticals_For_SYMBOLS}', "");
    Expect(1, 8448, '\P{-_in_diacriticals_For_SYMBOLS}', "");
    Expect(0, 8448, '\P{^-_in_diacriticals_For_SYMBOLS}', "");
    Error('\p{ :=combining_marks_For_symbols}');
    Error('\P{ :=combining_marks_For_symbols}');
    Expect(1, 8447, '\p{combiningmarksforsymbols}', "");
    Expect(0, 8447, '\p{^combiningmarksforsymbols}', "");
    Expect(0, 8447, '\P{combiningmarksforsymbols}', "");
    Expect(1, 8447, '\P{^combiningmarksforsymbols}', "");
    Expect(0, 8448, '\p{combiningmarksforsymbols}', "");
    Expect(1, 8448, '\p{^combiningmarksforsymbols}', "");
    Expect(1, 8448, '\P{combiningmarksforsymbols}', "");
    Expect(0, 8448, '\P{^combiningmarksforsymbols}', "");
    Expect(1, 8447, '\p{ combining_Marks_For_Symbols}', "");
    Expect(0, 8447, '\p{^ combining_Marks_For_Symbols}', "");
    Expect(0, 8447, '\P{ combining_Marks_For_Symbols}', "");
    Expect(1, 8447, '\P{^ combining_Marks_For_Symbols}', "");
    Expect(0, 8448, '\p{ combining_Marks_For_Symbols}', "");
    Expect(1, 8448, '\p{^ combining_Marks_For_Symbols}', "");
    Expect(1, 8448, '\P{ combining_Marks_For_Symbols}', "");
    Expect(0, 8448, '\P{^ combining_Marks_For_Symbols}', "");
    Error('\p{/a/-_is_Combining_Marks_For_Symbols}');
    Error('\P{/a/-_is_Combining_Marks_For_Symbols}');
    Expect(1, 8447, '\p{iscombiningmarksforsymbols}', "");
    Expect(0, 8447, '\p{^iscombiningmarksforsymbols}', "");
    Expect(0, 8447, '\P{iscombiningmarksforsymbols}', "");
    Expect(1, 8447, '\P{^iscombiningmarksforsymbols}', "");
    Expect(0, 8448, '\p{iscombiningmarksforsymbols}', "");
    Expect(1, 8448, '\p{^iscombiningmarksforsymbols}', "");
    Expect(1, 8448, '\P{iscombiningmarksforsymbols}', "");
    Expect(0, 8448, '\P{^iscombiningmarksforsymbols}', "");
    Expect(1, 8447, '\p{ is_Combining_Marks_For_Symbols}', "");
    Expect(0, 8447, '\p{^ is_Combining_Marks_For_Symbols}', "");
    Expect(0, 8447, '\P{ is_Combining_Marks_For_Symbols}', "");
    Expect(1, 8447, '\P{^ is_Combining_Marks_For_Symbols}', "");
    Expect(0, 8448, '\p{ is_Combining_Marks_For_Symbols}', "");
    Expect(1, 8448, '\p{^ is_Combining_Marks_For_Symbols}', "");
    Expect(1, 8448, '\P{ is_Combining_Marks_For_Symbols}', "");
    Expect(0, 8448, '\P{^ is_Combining_Marks_For_Symbols}', "");
    Error('\p{/a/_-IN_COMBINING_Marks_FOR_SYMBOLS}');
    Error('\P{/a/_-IN_COMBINING_Marks_FOR_SYMBOLS}');
    Expect(1, 8447, '\p{incombiningmarksforsymbols}', "");
    Expect(0, 8447, '\p{^incombiningmarksforsymbols}', "");
    Expect(0, 8447, '\P{incombiningmarksforsymbols}', "");
    Expect(1, 8447, '\P{^incombiningmarksforsymbols}', "");
    Expect(0, 8448, '\p{incombiningmarksforsymbols}', "");
    Expect(1, 8448, '\p{^incombiningmarksforsymbols}', "");
    Expect(1, 8448, '\P{incombiningmarksforsymbols}', "");
    Expect(0, 8448, '\P{^incombiningmarksforsymbols}', "");
    Expect(1, 8447, '\p{-	In_Combining_MARKS_For_SYMBOLS}', "");
    Expect(0, 8447, '\p{^-	In_Combining_MARKS_For_SYMBOLS}', "");
    Expect(0, 8447, '\P{-	In_Combining_MARKS_For_SYMBOLS}', "");
    Expect(1, 8447, '\P{^-	In_Combining_MARKS_For_SYMBOLS}', "");
    Expect(0, 8448, '\p{-	In_Combining_MARKS_For_SYMBOLS}', "");
    Expect(1, 8448, '\p{^-	In_Combining_MARKS_For_SYMBOLS}', "");
    Expect(1, 8448, '\P{-	In_Combining_MARKS_For_SYMBOLS}', "");
    Expect(0, 8448, '\P{^-	In_Combining_MARKS_For_SYMBOLS}', "");
    Error('\p{:=COMBINING_DIACRITICAL_marks_Supplement}');
    Error('\P{:=COMBINING_DIACRITICAL_marks_Supplement}');
    Expect(1, 7679, '\p{combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\p{^combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\P{combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\P{^combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\p{combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\p{^combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\P{combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\P{^combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\p{_COMBINING_Diacritical_Marks_SUPPLEMENT}', "");
    Expect(0, 7679, '\p{^_COMBINING_Diacritical_Marks_SUPPLEMENT}', "");
    Expect(0, 7679, '\P{_COMBINING_Diacritical_Marks_SUPPLEMENT}', "");
    Expect(1, 7679, '\P{^_COMBINING_Diacritical_Marks_SUPPLEMENT}', "");
    Expect(0, 7680, '\p{_COMBINING_Diacritical_Marks_SUPPLEMENT}', "");
    Expect(1, 7680, '\p{^_COMBINING_Diacritical_Marks_SUPPLEMENT}', "");
    Expect(1, 7680, '\P{_COMBINING_Diacritical_Marks_SUPPLEMENT}', "");
    Expect(0, 7680, '\P{^_COMBINING_Diacritical_Marks_SUPPLEMENT}', "");
    Error('\p{/a/ -Is_Combining_DIACRITICAL_Marks_Supplement}');
    Error('\P{/a/ -Is_Combining_DIACRITICAL_Marks_Supplement}');
    Expect(1, 7679, '\p{iscombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\p{^iscombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\P{iscombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\P{^iscombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\p{iscombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\p{^iscombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\P{iscombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\P{^iscombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\p{is_combining_DIACRITICAL_Marks_Supplement}', "");
    Expect(0, 7679, '\p{^is_combining_DIACRITICAL_Marks_Supplement}', "");
    Expect(0, 7679, '\P{is_combining_DIACRITICAL_Marks_Supplement}', "");
    Expect(1, 7679, '\P{^is_combining_DIACRITICAL_Marks_Supplement}', "");
    Expect(0, 7680, '\p{is_combining_DIACRITICAL_Marks_Supplement}', "");
    Expect(1, 7680, '\p{^is_combining_DIACRITICAL_Marks_Supplement}', "");
    Expect(1, 7680, '\P{is_combining_DIACRITICAL_Marks_Supplement}', "");
    Expect(0, 7680, '\P{^is_combining_DIACRITICAL_Marks_Supplement}', "");
    Error('\p{/a/-_In_COMBINING_DIACRITICAL_marks_SUPPLEMENT}');
    Error('\P{/a/-_In_COMBINING_DIACRITICAL_marks_SUPPLEMENT}');
    Expect(1, 7679, '\p{incombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\p{^incombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\P{incombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\P{^incombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\p{incombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\p{^incombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\P{incombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\P{^incombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\p{in_COMBINING_diacritical_MARKS_Supplement}', "");
    Expect(0, 7679, '\p{^in_COMBINING_diacritical_MARKS_Supplement}', "");
    Expect(0, 7679, '\P{in_COMBINING_diacritical_MARKS_Supplement}', "");
    Expect(1, 7679, '\P{^in_COMBINING_diacritical_MARKS_Supplement}', "");
    Expect(0, 7680, '\p{in_COMBINING_diacritical_MARKS_Supplement}', "");
    Expect(1, 7680, '\p{^in_COMBINING_diacritical_MARKS_Supplement}', "");
    Expect(1, 7680, '\P{in_COMBINING_diacritical_MARKS_Supplement}', "");
    Expect(0, 7680, '\P{^in_COMBINING_diacritical_MARKS_Supplement}', "");
    Error('\p{--Diacriticals_Sup/a/}');
    Error('\P{--Diacriticals_Sup/a/}');
    Expect(1, 7679, '\p{diacriticalssup}', "");
    Expect(0, 7679, '\p{^diacriticalssup}', "");
    Expect(0, 7679, '\P{diacriticalssup}', "");
    Expect(1, 7679, '\P{^diacriticalssup}', "");
    Expect(0, 7680, '\p{diacriticalssup}', "");
    Expect(1, 7680, '\p{^diacriticalssup}', "");
    Expect(1, 7680, '\P{diacriticalssup}', "");
    Expect(0, 7680, '\P{^diacriticalssup}', "");
    Expect(1, 7679, '\p{	-Diacriticals_sup}', "");
    Expect(0, 7679, '\p{^	-Diacriticals_sup}', "");
    Expect(0, 7679, '\P{	-Diacriticals_sup}', "");
    Expect(1, 7679, '\P{^	-Diacriticals_sup}', "");
    Expect(0, 7680, '\p{	-Diacriticals_sup}', "");
    Expect(1, 7680, '\p{^	-Diacriticals_sup}', "");
    Expect(1, 7680, '\P{	-Diacriticals_sup}', "");
    Expect(0, 7680, '\P{^	-Diacriticals_sup}', "");
    Error('\p{_-is_Diacriticals_Sup/a/}');
    Error('\P{_-is_Diacriticals_Sup/a/}');
    Expect(1, 7679, '\p{isdiacriticalssup}', "");
    Expect(0, 7679, '\p{^isdiacriticalssup}', "");
    Expect(0, 7679, '\P{isdiacriticalssup}', "");
    Expect(1, 7679, '\P{^isdiacriticalssup}', "");
    Expect(0, 7680, '\p{isdiacriticalssup}', "");
    Expect(1, 7680, '\p{^isdiacriticalssup}', "");
    Expect(1, 7680, '\P{isdiacriticalssup}', "");
    Expect(0, 7680, '\P{^isdiacriticalssup}', "");
    Expect(1, 7679, '\p{ is_diacriticals_sup}', "");
    Expect(0, 7679, '\p{^ is_diacriticals_sup}', "");
    Expect(0, 7679, '\P{ is_diacriticals_sup}', "");
    Expect(1, 7679, '\P{^ is_diacriticals_sup}', "");
    Expect(0, 7680, '\p{ is_diacriticals_sup}', "");
    Expect(1, 7680, '\p{^ is_diacriticals_sup}', "");
    Expect(1, 7680, '\P{ is_diacriticals_sup}', "");
    Expect(0, 7680, '\P{^ is_diacriticals_sup}', "");
    Error('\p{-/a/in_DIACRITICALS_Sup}');
    Error('\P{-/a/in_DIACRITICALS_Sup}');
    Expect(1, 7679, '\p{indiacriticalssup}', "");
    Expect(0, 7679, '\p{^indiacriticalssup}', "");
    Expect(0, 7679, '\P{indiacriticalssup}', "");
    Expect(1, 7679, '\P{^indiacriticalssup}', "");
    Expect(0, 7680, '\p{indiacriticalssup}', "");
    Expect(1, 7680, '\p{^indiacriticalssup}', "");
    Expect(1, 7680, '\P{indiacriticalssup}', "");
    Expect(0, 7680, '\P{^indiacriticalssup}', "");
    Expect(1, 7679, '\p{ 	IN_Diacriticals_sup}', "");
    Expect(0, 7679, '\p{^ 	IN_Diacriticals_sup}', "");
    Expect(0, 7679, '\P{ 	IN_Diacriticals_sup}', "");
    Expect(1, 7679, '\P{^ 	IN_Diacriticals_sup}', "");
    Expect(0, 7680, '\p{ 	IN_Diacriticals_sup}', "");
    Expect(1, 7680, '\p{^ 	IN_Diacriticals_sup}', "");
    Expect(1, 7680, '\P{ 	IN_Diacriticals_sup}', "");
    Expect(0, 7680, '\P{^ 	IN_Diacriticals_sup}', "");
    Error('\p{:= combining_Half_MARKS}');
    Error('\P{:= combining_Half_MARKS}');
    Expect(1, 65071, '\p{combininghalfmarks}', "");
    Expect(0, 65071, '\p{^combininghalfmarks}', "");
    Expect(0, 65071, '\P{combininghalfmarks}', "");
    Expect(1, 65071, '\P{^combininghalfmarks}', "");
    Expect(0, 65072, '\p{combininghalfmarks}', "");
    Expect(1, 65072, '\p{^combininghalfmarks}', "");
    Expect(1, 65072, '\P{combininghalfmarks}', "");
    Expect(0, 65072, '\P{^combininghalfmarks}', "");
    Expect(1, 65071, '\p{-	combining_Half_Marks}', "");
    Expect(0, 65071, '\p{^-	combining_Half_Marks}', "");
    Expect(0, 65071, '\P{-	combining_Half_Marks}', "");
    Expect(1, 65071, '\P{^-	combining_Half_Marks}', "");
    Expect(0, 65072, '\p{-	combining_Half_Marks}', "");
    Expect(1, 65072, '\p{^-	combining_Half_Marks}', "");
    Expect(1, 65072, '\P{-	combining_Half_Marks}', "");
    Expect(0, 65072, '\P{^-	combining_Half_Marks}', "");
    Error('\p{:=		IS_COMBINING_Half_Marks}');
    Error('\P{:=		IS_COMBINING_Half_Marks}');
    Expect(1, 65071, '\p{iscombininghalfmarks}', "");
    Expect(0, 65071, '\p{^iscombininghalfmarks}', "");
    Expect(0, 65071, '\P{iscombininghalfmarks}', "");
    Expect(1, 65071, '\P{^iscombininghalfmarks}', "");
    Expect(0, 65072, '\p{iscombininghalfmarks}', "");
    Expect(1, 65072, '\p{^iscombininghalfmarks}', "");
    Expect(1, 65072, '\P{iscombininghalfmarks}', "");
    Expect(0, 65072, '\P{^iscombininghalfmarks}', "");
    Expect(1, 65071, '\p{_-is_COMBINING_HALF_MARKS}', "");
    Expect(0, 65071, '\p{^_-is_COMBINING_HALF_MARKS}', "");
    Expect(0, 65071, '\P{_-is_COMBINING_HALF_MARKS}', "");
    Expect(1, 65071, '\P{^_-is_COMBINING_HALF_MARKS}', "");
    Expect(0, 65072, '\p{_-is_COMBINING_HALF_MARKS}', "");
    Expect(1, 65072, '\p{^_-is_COMBINING_HALF_MARKS}', "");
    Expect(1, 65072, '\P{_-is_COMBINING_HALF_MARKS}', "");
    Expect(0, 65072, '\P{^_-is_COMBINING_HALF_MARKS}', "");
    Error('\p{-_In_Combining_half_Marks/a/}');
    Error('\P{-_In_Combining_half_Marks/a/}');
    Expect(1, 65071, '\p{incombininghalfmarks}', "");
    Expect(0, 65071, '\p{^incombininghalfmarks}', "");
    Expect(0, 65071, '\P{incombininghalfmarks}', "");
    Expect(1, 65071, '\P{^incombininghalfmarks}', "");
    Expect(0, 65072, '\p{incombininghalfmarks}', "");
    Expect(1, 65072, '\p{^incombininghalfmarks}', "");
    Expect(1, 65072, '\P{incombininghalfmarks}', "");
    Expect(0, 65072, '\P{^incombininghalfmarks}', "");
    Expect(1, 65071, '\p{_-In_Combining_half_marks}', "");
    Expect(0, 65071, '\p{^_-In_Combining_half_marks}', "");
    Expect(0, 65071, '\P{_-In_Combining_half_marks}', "");
    Expect(1, 65071, '\P{^_-In_Combining_half_marks}', "");
    Expect(0, 65072, '\p{_-In_Combining_half_marks}', "");
    Expect(1, 65072, '\p{^_-In_Combining_half_marks}', "");
    Expect(1, 65072, '\P{_-In_Combining_half_marks}', "");
    Expect(0, 65072, '\P{^_-In_Combining_half_marks}', "");
    Error('\p{/a/HALF_Marks}');
    Error('\P{/a/HALF_Marks}');
    Expect(1, 65071, '\p{halfmarks}', "");
    Expect(0, 65071, '\p{^halfmarks}', "");
    Expect(0, 65071, '\P{halfmarks}', "");
    Expect(1, 65071, '\P{^halfmarks}', "");
    Expect(0, 65072, '\p{halfmarks}', "");
    Expect(1, 65072, '\p{^halfmarks}', "");
    Expect(1, 65072, '\P{halfmarks}', "");
    Expect(0, 65072, '\P{^halfmarks}', "");
    Expect(1, 65071, '\p{	_Half_Marks}', "");
    Expect(0, 65071, '\p{^	_Half_Marks}', "");
    Expect(0, 65071, '\P{	_Half_Marks}', "");
    Expect(1, 65071, '\P{^	_Half_Marks}', "");
    Expect(0, 65072, '\p{	_Half_Marks}', "");
    Expect(1, 65072, '\p{^	_Half_Marks}', "");
    Expect(1, 65072, '\P{	_Half_Marks}', "");
    Expect(0, 65072, '\P{^	_Half_Marks}', "");
    Error('\p{- is_half_marks:=}');
    Error('\P{- is_half_marks:=}');
    Expect(1, 65071, '\p{ishalfmarks}', "");
    Expect(0, 65071, '\p{^ishalfmarks}', "");
    Expect(0, 65071, '\P{ishalfmarks}', "");
    Expect(1, 65071, '\P{^ishalfmarks}', "");
    Expect(0, 65072, '\p{ishalfmarks}', "");
    Expect(1, 65072, '\p{^ishalfmarks}', "");
    Expect(1, 65072, '\P{ishalfmarks}', "");
    Expect(0, 65072, '\P{^ishalfmarks}', "");
    Expect(1, 65071, '\p{  Is_Half_MARKS}', "");
    Expect(0, 65071, '\p{^  Is_Half_MARKS}', "");
    Expect(0, 65071, '\P{  Is_Half_MARKS}', "");
    Expect(1, 65071, '\P{^  Is_Half_MARKS}', "");
    Expect(0, 65072, '\p{  Is_Half_MARKS}', "");
    Expect(1, 65072, '\p{^  Is_Half_MARKS}', "");
    Expect(1, 65072, '\P{  Is_Half_MARKS}', "");
    Expect(0, 65072, '\P{^  Is_Half_MARKS}', "");
    Error('\p{ :=In_HALF_marks}');
    Error('\P{ :=In_HALF_marks}');
    Expect(1, 65071, '\p{inhalfmarks}', "");
    Expect(0, 65071, '\p{^inhalfmarks}', "");
    Expect(0, 65071, '\P{inhalfmarks}', "");
    Expect(1, 65071, '\P{^inhalfmarks}', "");
    Expect(0, 65072, '\p{inhalfmarks}', "");
    Expect(1, 65072, '\p{^inhalfmarks}', "");
    Expect(1, 65072, '\P{inhalfmarks}', "");
    Expect(0, 65072, '\P{^inhalfmarks}', "");
    Expect(1, 65071, '\p{In_HALF_Marks}', "");
    Expect(0, 65071, '\p{^In_HALF_Marks}', "");
    Expect(0, 65071, '\P{In_HALF_Marks}', "");
    Expect(1, 65071, '\P{^In_HALF_Marks}', "");
    Expect(0, 65072, '\p{In_HALF_Marks}', "");
    Expect(1, 65072, '\p{^In_HALF_Marks}', "");
    Expect(1, 65072, '\P{In_HALF_Marks}', "");
    Expect(0, 65072, '\P{^In_HALF_Marks}', "");
    Error('\p{_	common:=}');
    Error('\P{_	common:=}');
    Expect(1, 917631, '\p{common}', "");
    Expect(0, 917631, '\p{^common}', "");
    Expect(0, 917631, '\P{common}', "");
    Expect(1, 917631, '\P{^common}', "");
    Expect(0, 917632, '\p{common}', "");
    Expect(1, 917632, '\p{^common}', "");
    Expect(1, 917632, '\P{common}', "");
    Expect(0, 917632, '\P{^common}', "");
    Expect(1, 917631, '\p{	-COMMON}', "");
    Expect(0, 917631, '\p{^	-COMMON}', "");
    Expect(0, 917631, '\P{	-COMMON}', "");
    Expect(1, 917631, '\P{^	-COMMON}', "");
    Expect(0, 917632, '\p{	-COMMON}', "");
    Expect(1, 917632, '\p{^	-COMMON}', "");
    Expect(1, 917632, '\P{	-COMMON}', "");
    Expect(0, 917632, '\P{^	-COMMON}', "");
    Error('\p{_:=IS_common}');
    Error('\P{_:=IS_common}');
    Expect(1, 917631, '\p{iscommon}', "");
    Expect(0, 917631, '\p{^iscommon}', "");
    Expect(0, 917631, '\P{iscommon}', "");
    Expect(1, 917631, '\P{^iscommon}', "");
    Expect(0, 917632, '\p{iscommon}', "");
    Expect(1, 917632, '\p{^iscommon}', "");
    Expect(1, 917632, '\P{iscommon}', "");
    Expect(0, 917632, '\P{^iscommon}', "");
    Expect(1, 917631, '\p{- IS_COMMON}', "");
    Expect(0, 917631, '\p{^- IS_COMMON}', "");
    Expect(0, 917631, '\P{- IS_COMMON}', "");
    Expect(1, 917631, '\P{^- IS_COMMON}', "");
    Expect(0, 917632, '\p{- IS_COMMON}', "");
    Expect(1, 917632, '\p{^- IS_COMMON}', "");
    Expect(1, 917632, '\P{- IS_COMMON}', "");
    Expect(0, 917632, '\P{^- IS_COMMON}', "");
    Error('\p{:=  Zyyy}');
    Error('\P{:=  Zyyy}');
    Expect(1, 917631, '\p{zyyy}', "");
    Expect(0, 917631, '\p{^zyyy}', "");
    Expect(0, 917631, '\P{zyyy}', "");
    Expect(1, 917631, '\P{^zyyy}', "");
    Expect(0, 917632, '\p{zyyy}', "");
    Expect(1, 917632, '\p{^zyyy}', "");
    Expect(1, 917632, '\P{zyyy}', "");
    Expect(0, 917632, '\P{^zyyy}', "");
    Expect(1, 917631, '\p{	 ZYYY}', "");
    Expect(0, 917631, '\p{^	 ZYYY}', "");
    Expect(0, 917631, '\P{	 ZYYY}', "");
    Expect(1, 917631, '\P{^	 ZYYY}', "");
    Expect(0, 917632, '\p{	 ZYYY}', "");
    Expect(1, 917632, '\p{^	 ZYYY}', "");
    Expect(1, 917632, '\P{	 ZYYY}', "");
    Expect(0, 917632, '\P{^	 ZYYY}', "");
    Error('\p{/a/	 is_Zyyy}');
    Error('\P{/a/	 is_Zyyy}');
    Expect(1, 917631, '\p{iszyyy}', "");
    Expect(0, 917631, '\p{^iszyyy}', "");
    Expect(0, 917631, '\P{iszyyy}', "");
    Expect(1, 917631, '\P{^iszyyy}', "");
    Expect(0, 917632, '\p{iszyyy}', "");
    Expect(1, 917632, '\p{^iszyyy}', "");
    Expect(1, 917632, '\P{iszyyy}', "");
    Expect(0, 917632, '\P{^iszyyy}', "");
    Expect(1, 917631, '\p{Is_Zyyy}', "");
    Expect(0, 917631, '\p{^Is_Zyyy}', "");
    Expect(0, 917631, '\P{Is_Zyyy}', "");
    Expect(1, 917631, '\P{^Is_Zyyy}', "");
    Expect(0, 917632, '\p{Is_Zyyy}', "");
    Expect(1, 917632, '\p{^Is_Zyyy}', "");
    Expect(1, 917632, '\P{Is_Zyyy}', "");
    Expect(0, 917632, '\P{^Is_Zyyy}', "");
    Error('\p{-/a/common_Indic_NUMBER_FORMS}');
    Error('\P{-/a/common_Indic_NUMBER_FORMS}');
    Expect(1, 43071, '\p{commonindicnumberforms}', "");
    Expect(0, 43071, '\p{^commonindicnumberforms}', "");
    Expect(0, 43071, '\P{commonindicnumberforms}', "");
    Expect(1, 43071, '\P{^commonindicnumberforms}', "");
    Expect(0, 43072, '\p{commonindicnumberforms}', "");
    Expect(1, 43072, '\p{^commonindicnumberforms}', "");
    Expect(1, 43072, '\P{commonindicnumberforms}', "");
    Expect(0, 43072, '\P{^commonindicnumberforms}', "");
    Expect(1, 43071, '\p{	COMMON_Indic_Number_forms}', "");
    Expect(0, 43071, '\p{^	COMMON_Indic_Number_forms}', "");
    Expect(0, 43071, '\P{	COMMON_Indic_Number_forms}', "");
    Expect(1, 43071, '\P{^	COMMON_Indic_Number_forms}', "");
    Expect(0, 43072, '\p{	COMMON_Indic_Number_forms}', "");
    Expect(1, 43072, '\p{^	COMMON_Indic_Number_forms}', "");
    Expect(1, 43072, '\P{	COMMON_Indic_Number_forms}', "");
    Expect(0, 43072, '\P{^	COMMON_Indic_Number_forms}', "");
    Error('\p{:=IS_Common_INDIC_Number_FORMS}');
    Error('\P{:=IS_Common_INDIC_Number_FORMS}');
    Expect(1, 43071, '\p{iscommonindicnumberforms}', "");
    Expect(0, 43071, '\p{^iscommonindicnumberforms}', "");
    Expect(0, 43071, '\P{iscommonindicnumberforms}', "");
    Expect(1, 43071, '\P{^iscommonindicnumberforms}', "");
    Expect(0, 43072, '\p{iscommonindicnumberforms}', "");
    Expect(1, 43072, '\p{^iscommonindicnumberforms}', "");
    Expect(1, 43072, '\P{iscommonindicnumberforms}', "");
    Expect(0, 43072, '\P{^iscommonindicnumberforms}', "");
    Expect(1, 43071, '\p{_IS_Common_INDIC_number_Forms}', "");
    Expect(0, 43071, '\p{^_IS_Common_INDIC_number_Forms}', "");
    Expect(0, 43071, '\P{_IS_Common_INDIC_number_Forms}', "");
    Expect(1, 43071, '\P{^_IS_Common_INDIC_number_Forms}', "");
    Expect(0, 43072, '\p{_IS_Common_INDIC_number_Forms}', "");
    Expect(1, 43072, '\p{^_IS_Common_INDIC_number_Forms}', "");
    Expect(1, 43072, '\P{_IS_Common_INDIC_number_Forms}', "");
    Expect(0, 43072, '\P{^_IS_Common_INDIC_number_Forms}', "");
    Error('\p{-/a/in_COMMON_Indic_Number_Forms}');
    Error('\P{-/a/in_COMMON_Indic_Number_Forms}');
    Expect(1, 43071, '\p{incommonindicnumberforms}', "");
    Expect(0, 43071, '\p{^incommonindicnumberforms}', "");
    Expect(0, 43071, '\P{incommonindicnumberforms}', "");
    Expect(1, 43071, '\P{^incommonindicnumberforms}', "");
    Expect(0, 43072, '\p{incommonindicnumberforms}', "");
    Expect(1, 43072, '\p{^incommonindicnumberforms}', "");
    Expect(1, 43072, '\P{incommonindicnumberforms}', "");
    Expect(0, 43072, '\P{^incommonindicnumberforms}', "");
    Expect(1, 43071, '\p{_-in_common_Indic_number_Forms}', "");
    Expect(0, 43071, '\p{^_-in_common_Indic_number_Forms}', "");
    Expect(0, 43071, '\P{_-in_common_Indic_number_Forms}', "");
    Expect(1, 43071, '\P{^_-in_common_Indic_number_Forms}', "");
    Expect(0, 43072, '\p{_-in_common_Indic_number_Forms}', "");
    Expect(1, 43072, '\p{^_-in_common_Indic_number_Forms}', "");
    Expect(1, 43072, '\P{_-in_common_Indic_number_Forms}', "");
    Expect(0, 43072, '\P{^_-in_common_Indic_number_Forms}', "");
    Error('\p{	/a/INDIC_NUMBER_Forms}');
    Error('\P{	/a/INDIC_NUMBER_Forms}');
    Expect(1, 43071, '\p{indicnumberforms}', "");
    Expect(0, 43071, '\p{^indicnumberforms}', "");
    Expect(0, 43071, '\P{indicnumberforms}', "");
    Expect(1, 43071, '\P{^indicnumberforms}', "");
    Expect(0, 43072, '\p{indicnumberforms}', "");
    Expect(1, 43072, '\p{^indicnumberforms}', "");
    Expect(1, 43072, '\P{indicnumberforms}', "");
    Expect(0, 43072, '\P{^indicnumberforms}', "");
    Expect(1, 43071, '\p{_Indic_NUMBER_Forms}', "");
    Expect(0, 43071, '\p{^_Indic_NUMBER_Forms}', "");
    Expect(0, 43071, '\P{_Indic_NUMBER_Forms}', "");
    Expect(1, 43071, '\P{^_Indic_NUMBER_Forms}', "");
    Expect(0, 43072, '\p{_Indic_NUMBER_Forms}', "");
    Expect(1, 43072, '\p{^_Indic_NUMBER_Forms}', "");
    Expect(1, 43072, '\P{_Indic_NUMBER_Forms}', "");
    Expect(0, 43072, '\P{^_Indic_NUMBER_Forms}', "");
    Error('\p{-_Is_Indic_NUMBER_Forms:=}');
    Error('\P{-_Is_Indic_NUMBER_Forms:=}');
    Expect(1, 43071, '\p{isindicnumberforms}', "");
    Expect(0, 43071, '\p{^isindicnumberforms}', "");
    Expect(0, 43071, '\P{isindicnumberforms}', "");
    Expect(1, 43071, '\P{^isindicnumberforms}', "");
    Expect(0, 43072, '\p{isindicnumberforms}', "");
    Expect(1, 43072, '\p{^isindicnumberforms}', "");
    Expect(1, 43072, '\P{isindicnumberforms}', "");
    Expect(0, 43072, '\P{^isindicnumberforms}', "");
    Expect(1, 43071, '\p{Is_Indic_NUMBER_Forms}', "");
    Expect(0, 43071, '\p{^Is_Indic_NUMBER_Forms}', "");
    Expect(0, 43071, '\P{Is_Indic_NUMBER_Forms}', "");
    Expect(1, 43071, '\P{^Is_Indic_NUMBER_Forms}', "");
    Expect(0, 43072, '\p{Is_Indic_NUMBER_Forms}', "");
    Expect(1, 43072, '\p{^Is_Indic_NUMBER_Forms}', "");
    Expect(1, 43072, '\P{Is_Indic_NUMBER_Forms}', "");
    Expect(0, 43072, '\P{^Is_Indic_NUMBER_Forms}', "");
    Error('\p{	IN_indic_Number_Forms/a/}');
    Error('\P{	IN_indic_Number_Forms/a/}');
    Expect(1, 43071, '\p{inindicnumberforms}', "");
    Expect(0, 43071, '\p{^inindicnumberforms}', "");
    Expect(0, 43071, '\P{inindicnumberforms}', "");
    Expect(1, 43071, '\P{^inindicnumberforms}', "");
    Expect(0, 43072, '\p{inindicnumberforms}', "");
    Expect(1, 43072, '\p{^inindicnumberforms}', "");
    Expect(1, 43072, '\P{inindicnumberforms}', "");
    Expect(0, 43072, '\P{^inindicnumberforms}', "");
    Expect(1, 43071, '\p{-In_INDIC_NUMBER_Forms}', "");
    Expect(0, 43071, '\p{^-In_INDIC_NUMBER_Forms}', "");
    Expect(0, 43071, '\P{-In_INDIC_NUMBER_Forms}', "");
    Expect(1, 43071, '\P{^-In_INDIC_NUMBER_Forms}', "");
    Expect(0, 43072, '\p{-In_INDIC_NUMBER_Forms}', "");
    Expect(1, 43072, '\p{^-In_INDIC_NUMBER_Forms}', "");
    Expect(1, 43072, '\P{-In_INDIC_NUMBER_Forms}', "");
    Expect(0, 43072, '\P{^-In_INDIC_NUMBER_Forms}', "");
    Error('\p{ 	COMPOSITION_exclusion:=}');
    Error('\P{ 	COMPOSITION_exclusion:=}');
    Expect(1, 119232, '\p{compositionexclusion}', "");
    Expect(0, 119232, '\p{^compositionexclusion}', "");
    Expect(0, 119232, '\P{compositionexclusion}', "");
    Expect(1, 119232, '\P{^compositionexclusion}', "");
    Expect(0, 119233, '\p{compositionexclusion}', "");
    Expect(1, 119233, '\p{^compositionexclusion}', "");
    Expect(1, 119233, '\P{compositionexclusion}', "");
    Expect(0, 119233, '\P{^compositionexclusion}', "");
    Expect(1, 119232, '\p{		composition_Exclusion}', "");
    Expect(0, 119232, '\p{^		composition_Exclusion}', "");
    Expect(0, 119232, '\P{		composition_Exclusion}', "");
    Expect(1, 119232, '\P{^		composition_Exclusion}', "");
    Expect(0, 119233, '\p{		composition_Exclusion}', "");
    Expect(1, 119233, '\p{^		composition_Exclusion}', "");
    Expect(1, 119233, '\P{		composition_Exclusion}', "");
    Expect(0, 119233, '\P{^		composition_Exclusion}', "");
    Error('\p{  Is_Composition_exclusion:=}');
    Error('\P{  Is_Composition_exclusion:=}');
    Expect(1, 119232, '\p{iscompositionexclusion}', "");
    Expect(0, 119232, '\p{^iscompositionexclusion}', "");
    Expect(0, 119232, '\P{iscompositionexclusion}', "");
    Expect(1, 119232, '\P{^iscompositionexclusion}', "");
    Expect(0, 119233, '\p{iscompositionexclusion}', "");
    Expect(1, 119233, '\p{^iscompositionexclusion}', "");
    Expect(1, 119233, '\P{iscompositionexclusion}', "");
    Expect(0, 119233, '\P{^iscompositionexclusion}', "");
    Expect(1, 119232, '\p{ _is_Composition_Exclusion}', "");
    Expect(0, 119232, '\p{^ _is_Composition_Exclusion}', "");
    Expect(0, 119232, '\P{ _is_Composition_Exclusion}', "");
    Expect(1, 119232, '\P{^ _is_Composition_Exclusion}', "");
    Expect(0, 119233, '\p{ _is_Composition_Exclusion}', "");
    Expect(1, 119233, '\p{^ _is_Composition_Exclusion}', "");
    Expect(1, 119233, '\P{ _is_Composition_Exclusion}', "");
    Expect(0, 119233, '\P{^ _is_Composition_Exclusion}', "");
    Error('\p{:=_ce}');
    Error('\P{:=_ce}');
    Expect(1, 119232, '\p{ce}', "");
    Expect(0, 119232, '\p{^ce}', "");
    Expect(0, 119232, '\P{ce}', "");
    Expect(1, 119232, '\P{^ce}', "");
    Expect(0, 119233, '\p{ce}', "");
    Expect(1, 119233, '\p{^ce}', "");
    Expect(1, 119233, '\P{ce}', "");
    Expect(0, 119233, '\P{^ce}', "");
    Expect(1, 119232, '\p{ _CE}', "");
    Expect(0, 119232, '\p{^ _CE}', "");
    Expect(0, 119232, '\P{ _CE}', "");
    Expect(1, 119232, '\P{^ _CE}', "");
    Expect(0, 119233, '\p{ _CE}', "");
    Expect(1, 119233, '\p{^ _CE}', "");
    Expect(1, 119233, '\P{ _CE}', "");
    Expect(0, 119233, '\P{^ _CE}', "");
    Error('\p{	/a/is_CE}');
    Error('\P{	/a/is_CE}');
    Expect(1, 119232, '\p{isce}', "");
    Expect(0, 119232, '\p{^isce}', "");
    Expect(0, 119232, '\P{isce}', "");
    Expect(1, 119232, '\P{^isce}', "");
    Expect(0, 119233, '\p{isce}', "");
    Expect(1, 119233, '\p{^isce}', "");
    Expect(1, 119233, '\P{isce}', "");
    Expect(0, 119233, '\P{^isce}', "");
    Expect(1, 119232, '\p{-	is_ce}', "");
    Expect(0, 119232, '\p{^-	is_ce}', "");
    Expect(0, 119232, '\P{-	is_ce}', "");
    Expect(1, 119232, '\P{^-	is_ce}', "");
    Expect(0, 119233, '\p{-	is_ce}', "");
    Expect(1, 119233, '\p{^-	is_ce}', "");
    Expect(1, 119233, '\P{-	is_ce}', "");
    Expect(0, 119233, '\P{^-	is_ce}', "");
    Error('\p{	CONNECTOR_Punctuation:=}');
    Error('\P{	CONNECTOR_Punctuation:=}');
    Expect(1, 65343, '\p{connectorpunctuation}', "");
    Expect(0, 65343, '\p{^connectorpunctuation}', "");
    Expect(0, 65343, '\P{connectorpunctuation}', "");
    Expect(1, 65343, '\P{^connectorpunctuation}', "");
    Expect(0, 65344, '\p{connectorpunctuation}', "");
    Expect(1, 65344, '\p{^connectorpunctuation}', "");
    Expect(1, 65344, '\P{connectorpunctuation}', "");
    Expect(0, 65344, '\P{^connectorpunctuation}', "");
    Expect(1, 65343, '\p{_ Connector_punctuation}', "");
    Expect(0, 65343, '\p{^_ Connector_punctuation}', "");
    Expect(0, 65343, '\P{_ Connector_punctuation}', "");
    Expect(1, 65343, '\P{^_ Connector_punctuation}', "");
    Expect(0, 65344, '\p{_ Connector_punctuation}', "");
    Expect(1, 65344, '\p{^_ Connector_punctuation}', "");
    Expect(1, 65344, '\P{_ Connector_punctuation}', "");
    Expect(0, 65344, '\P{^_ Connector_punctuation}', "");
    Error('\p{/a/--Is_CONNECTOR_PUNCTUATION}');
    Error('\P{/a/--Is_CONNECTOR_PUNCTUATION}');
    Expect(1, 65343, '\p{isconnectorpunctuation}', "");
    Expect(0, 65343, '\p{^isconnectorpunctuation}', "");
    Expect(0, 65343, '\P{isconnectorpunctuation}', "");
    Expect(1, 65343, '\P{^isconnectorpunctuation}', "");
    Expect(0, 65344, '\p{isconnectorpunctuation}', "");
    Expect(1, 65344, '\p{^isconnectorpunctuation}', "");
    Expect(1, 65344, '\P{isconnectorpunctuation}', "");
    Expect(0, 65344, '\P{^isconnectorpunctuation}', "");
    Expect(1, 65343, '\p{ IS_Connector_PUNCTUATION}', "");
    Expect(0, 65343, '\p{^ IS_Connector_PUNCTUATION}', "");
    Expect(0, 65343, '\P{ IS_Connector_PUNCTUATION}', "");
    Expect(1, 65343, '\P{^ IS_Connector_PUNCTUATION}', "");
    Expect(0, 65344, '\p{ IS_Connector_PUNCTUATION}', "");
    Expect(1, 65344, '\p{^ IS_Connector_PUNCTUATION}', "");
    Expect(1, 65344, '\P{ IS_Connector_PUNCTUATION}', "");
    Expect(0, 65344, '\P{^ IS_Connector_PUNCTUATION}', "");
    Error('\p{_	Pc/a/}');
    Error('\P{_	Pc/a/}');
    Expect(1, 65343, '\p{pc}', "");
    Expect(0, 65343, '\p{^pc}', "");
    Expect(0, 65343, '\P{pc}', "");
    Expect(1, 65343, '\P{^pc}', "");
    Expect(0, 65344, '\p{pc}', "");
    Expect(1, 65344, '\p{^pc}', "");
    Expect(1, 65344, '\P{pc}', "");
    Expect(0, 65344, '\P{^pc}', "");
    Expect(1, 65343, '\p{	-PC}', "");
    Expect(0, 65343, '\p{^	-PC}', "");
    Expect(0, 65343, '\P{	-PC}', "");
    Expect(1, 65343, '\P{^	-PC}', "");
    Expect(0, 65344, '\p{	-PC}', "");
    Expect(1, 65344, '\p{^	-PC}', "");
    Expect(1, 65344, '\P{	-PC}', "");
    Expect(0, 65344, '\P{^	-PC}', "");
    Error('\p{ -is_pc:=}');
    Error('\P{ -is_pc:=}');
    Expect(1, 65343, '\p{ispc}', "");
    Expect(0, 65343, '\p{^ispc}', "");
    Expect(0, 65343, '\P{ispc}', "");
    Expect(1, 65343, '\P{^ispc}', "");
    Expect(0, 65344, '\p{ispc}', "");
    Expect(1, 65344, '\p{^ispc}', "");
    Expect(1, 65344, '\P{ispc}', "");
    Expect(0, 65344, '\P{^ispc}', "");
    Expect(1, 65343, '\p{ is_Pc}', "");
    Expect(0, 65343, '\p{^ is_Pc}', "");
    Expect(0, 65343, '\P{ is_Pc}', "");
    Expect(1, 65343, '\P{^ is_Pc}', "");
    Expect(0, 65344, '\p{ is_Pc}', "");
    Expect(1, 65344, '\p{^ is_Pc}', "");
    Expect(1, 65344, '\P{ is_Pc}', "");
    Expect(0, 65344, '\P{^ is_Pc}', "");
    Error('\p{-_Control_pictures:=}');
    Error('\P{-_Control_pictures:=}');
    Expect(1, 9279, '\p{controlpictures}', "");
    Expect(0, 9279, '\p{^controlpictures}', "");
    Expect(0, 9279, '\P{controlpictures}', "");
    Expect(1, 9279, '\P{^controlpictures}', "");
    Expect(0, 9280, '\p{controlpictures}', "");
    Expect(1, 9280, '\p{^controlpictures}', "");
    Expect(1, 9280, '\P{controlpictures}', "");
    Expect(0, 9280, '\P{^controlpictures}', "");
    Expect(1, 9279, '\p{ -CONTROL_Pictures}', "");
    Expect(0, 9279, '\p{^ -CONTROL_Pictures}', "");
    Expect(0, 9279, '\P{ -CONTROL_Pictures}', "");
    Expect(1, 9279, '\P{^ -CONTROL_Pictures}', "");
    Expect(0, 9280, '\p{ -CONTROL_Pictures}', "");
    Expect(1, 9280, '\p{^ -CONTROL_Pictures}', "");
    Expect(1, 9280, '\P{ -CONTROL_Pictures}', "");
    Expect(0, 9280, '\P{^ -CONTROL_Pictures}', "");
    Error('\p{-	Is_Control_pictures:=}');
    Error('\P{-	Is_Control_pictures:=}');
    Expect(1, 9279, '\p{iscontrolpictures}', "");
    Expect(0, 9279, '\p{^iscontrolpictures}', "");
    Expect(0, 9279, '\P{iscontrolpictures}', "");
    Expect(1, 9279, '\P{^iscontrolpictures}', "");
    Expect(0, 9280, '\p{iscontrolpictures}', "");
    Expect(1, 9280, '\p{^iscontrolpictures}', "");
    Expect(1, 9280, '\P{iscontrolpictures}', "");
    Expect(0, 9280, '\P{^iscontrolpictures}', "");
    Expect(1, 9279, '\p{ IS_control_pictures}', "");
    Expect(0, 9279, '\p{^ IS_control_pictures}', "");
    Expect(0, 9279, '\P{ IS_control_pictures}', "");
    Expect(1, 9279, '\P{^ IS_control_pictures}', "");
    Expect(0, 9280, '\p{ IS_control_pictures}', "");
    Expect(1, 9280, '\p{^ IS_control_pictures}', "");
    Expect(1, 9280, '\P{ IS_control_pictures}', "");
    Expect(0, 9280, '\P{^ IS_control_pictures}', "");
    Error('\p{ :=IN_Control_PICTURES}');
    Error('\P{ :=IN_Control_PICTURES}');
    Expect(1, 9279, '\p{incontrolpictures}', "");
    Expect(0, 9279, '\p{^incontrolpictures}', "");
    Expect(0, 9279, '\P{incontrolpictures}', "");
    Expect(1, 9279, '\P{^incontrolpictures}', "");
    Expect(0, 9280, '\p{incontrolpictures}', "");
    Expect(1, 9280, '\p{^incontrolpictures}', "");
    Expect(1, 9280, '\P{incontrolpictures}', "");
    Expect(0, 9280, '\P{^incontrolpictures}', "");
    Expect(1, 9279, '\p{ _in_Control_PICTURES}', "");
    Expect(0, 9279, '\p{^ _in_Control_PICTURES}', "");
    Expect(0, 9279, '\P{ _in_Control_PICTURES}', "");
    Expect(1, 9279, '\P{^ _in_Control_PICTURES}', "");
    Expect(0, 9280, '\p{ _in_Control_PICTURES}', "");
    Expect(1, 9280, '\p{^ _in_Control_PICTURES}', "");
    Expect(1, 9280, '\P{ _in_Control_PICTURES}', "");
    Expect(0, 9280, '\P{^ _in_Control_PICTURES}', "");
    Error('\p{_	Coptic:=}');
    Error('\P{_	Coptic:=}');
    Expect(1, 66299, '\p{coptic}', "");
    Expect(0, 66299, '\p{^coptic}', "");
    Expect(0, 66299, '\P{coptic}', "");
    Expect(1, 66299, '\P{^coptic}', "");
    Expect(0, 66300, '\p{coptic}', "");
    Expect(1, 66300, '\p{^coptic}', "");
    Expect(1, 66300, '\P{coptic}', "");
    Expect(0, 66300, '\P{^coptic}', "");
    Expect(1, 66299, '\p{  Coptic}', "");
    Expect(0, 66299, '\p{^  Coptic}', "");
    Expect(0, 66299, '\P{  Coptic}', "");
    Expect(1, 66299, '\P{^  Coptic}', "");
    Expect(0, 66300, '\p{  Coptic}', "");
    Expect(1, 66300, '\p{^  Coptic}', "");
    Expect(1, 66300, '\P{  Coptic}', "");
    Expect(0, 66300, '\P{^  Coptic}', "");
    Error('\p{/a/_-IS_coptic}');
    Error('\P{/a/_-IS_coptic}');
    Expect(1, 66299, '\p{iscoptic}', "");
    Expect(0, 66299, '\p{^iscoptic}', "");
    Expect(0, 66299, '\P{iscoptic}', "");
    Expect(1, 66299, '\P{^iscoptic}', "");
    Expect(0, 66300, '\p{iscoptic}', "");
    Expect(1, 66300, '\p{^iscoptic}', "");
    Expect(1, 66300, '\P{iscoptic}', "");
    Expect(0, 66300, '\P{^iscoptic}', "");
    Expect(1, 66299, '\p{ _Is_Coptic}', "");
    Expect(0, 66299, '\p{^ _Is_Coptic}', "");
    Expect(0, 66299, '\P{ _Is_Coptic}', "");
    Expect(1, 66299, '\P{^ _Is_Coptic}', "");
    Expect(0, 66300, '\p{ _Is_Coptic}', "");
    Expect(1, 66300, '\p{^ _Is_Coptic}', "");
    Expect(1, 66300, '\P{ _Is_Coptic}', "");
    Expect(0, 66300, '\P{^ _Is_Coptic}', "");
    Error('\p{_:=Copt}');
    Error('\P{_:=Copt}');
    Expect(1, 66299, '\p{copt}', "");
    Expect(0, 66299, '\p{^copt}', "");
    Expect(0, 66299, '\P{copt}', "");
    Expect(1, 66299, '\P{^copt}', "");
    Expect(0, 66300, '\p{copt}', "");
    Expect(1, 66300, '\p{^copt}', "");
    Expect(1, 66300, '\P{copt}', "");
    Expect(0, 66300, '\P{^copt}', "");
    Expect(1, 66299, '\p{  Copt}', "");
    Expect(0, 66299, '\p{^  Copt}', "");
    Expect(0, 66299, '\P{  Copt}', "");
    Expect(1, 66299, '\P{^  Copt}', "");
    Expect(0, 66300, '\p{  Copt}', "");
    Expect(1, 66300, '\p{^  Copt}', "");
    Expect(1, 66300, '\P{  Copt}', "");
    Expect(0, 66300, '\P{^  Copt}', "");
    Error('\p{/a/Is_Copt}');
    Error('\P{/a/Is_Copt}');
    Expect(1, 66299, '\p{iscopt}', "");
    Expect(0, 66299, '\p{^iscopt}', "");
    Expect(0, 66299, '\P{iscopt}', "");
    Expect(1, 66299, '\P{^iscopt}', "");
    Expect(0, 66300, '\p{iscopt}', "");
    Expect(1, 66300, '\p{^iscopt}', "");
    Expect(1, 66300, '\P{iscopt}', "");
    Expect(0, 66300, '\P{^iscopt}', "");
    Expect(1, 66299, '\p{		Is_Copt}', "");
    Expect(0, 66299, '\p{^		Is_Copt}', "");
    Expect(0, 66299, '\P{		Is_Copt}', "");
    Expect(1, 66299, '\P{^		Is_Copt}', "");
    Expect(0, 66300, '\p{		Is_Copt}', "");
    Expect(1, 66300, '\p{^		Is_Copt}', "");
    Expect(1, 66300, '\P{		Is_Copt}', "");
    Expect(0, 66300, '\P{^		Is_Copt}', "");
    Error('\p{-:=qaac}');
    Error('\P{-:=qaac}');
    Expect(1, 66299, '\p{qaac}', "");
    Expect(0, 66299, '\p{^qaac}', "");
    Expect(0, 66299, '\P{qaac}', "");
    Expect(1, 66299, '\P{^qaac}', "");
    Expect(0, 66300, '\p{qaac}', "");
    Expect(1, 66300, '\p{^qaac}', "");
    Expect(1, 66300, '\P{qaac}', "");
    Expect(0, 66300, '\P{^qaac}', "");
    Error('\p{/a/-IS_Qaac}');
    Error('\P{/a/-IS_Qaac}');
    Expect(1, 66299, '\p{isqaac}', "");
    Expect(0, 66299, '\p{^isqaac}', "");
    Expect(0, 66299, '\P{isqaac}', "");
    Expect(1, 66299, '\P{^isqaac}', "");
    Expect(0, 66300, '\p{isqaac}', "");
    Expect(1, 66300, '\p{^isqaac}', "");
    Expect(1, 66300, '\P{isqaac}', "");
    Expect(0, 66300, '\P{^isqaac}', "");
    Expect(1, 66299, '\p{_	Is_Qaac}', "");
    Expect(0, 66299, '\p{^_	Is_Qaac}', "");
    Expect(0, 66299, '\P{_	Is_Qaac}', "");
    Expect(1, 66299, '\P{^_	Is_Qaac}', "");
    Expect(0, 66300, '\p{_	Is_Qaac}', "");
    Expect(1, 66300, '\p{^_	Is_Qaac}', "");
    Expect(1, 66300, '\P{_	Is_Qaac}', "");
    Expect(0, 66300, '\P{^_	Is_Qaac}', "");
    Error('\p{:=Coptic_EPACT_NUMBERS}');
    Error('\P{:=Coptic_EPACT_NUMBERS}');
    Expect(1, 66303, '\p{copticepactnumbers}', "");
    Expect(0, 66303, '\p{^copticepactnumbers}', "");
    Expect(0, 66303, '\P{copticepactnumbers}', "");
    Expect(1, 66303, '\P{^copticepactnumbers}', "");
    Expect(0, 66304, '\p{copticepactnumbers}', "");
    Expect(1, 66304, '\p{^copticepactnumbers}', "");
    Expect(1, 66304, '\P{copticepactnumbers}', "");
    Expect(0, 66304, '\P{^copticepactnumbers}', "");
    Expect(1, 66303, '\p{ _coptic_EPACT_NUMBERS}', "");
    Expect(0, 66303, '\p{^ _coptic_EPACT_NUMBERS}', "");
    Expect(0, 66303, '\P{ _coptic_EPACT_NUMBERS}', "");
    Expect(1, 66303, '\P{^ _coptic_EPACT_NUMBERS}', "");
    Expect(0, 66304, '\p{ _coptic_EPACT_NUMBERS}', "");
    Expect(1, 66304, '\p{^ _coptic_EPACT_NUMBERS}', "");
    Expect(1, 66304, '\P{ _coptic_EPACT_NUMBERS}', "");
    Expect(0, 66304, '\P{^ _coptic_EPACT_NUMBERS}', "");
    Error('\p{:=	Is_Coptic_epact_Numbers}');
    Error('\P{:=	Is_Coptic_epact_Numbers}');
    Expect(1, 66303, '\p{iscopticepactnumbers}', "");
    Expect(0, 66303, '\p{^iscopticepactnumbers}', "");
    Expect(0, 66303, '\P{iscopticepactnumbers}', "");
    Expect(1, 66303, '\P{^iscopticepactnumbers}', "");
    Expect(0, 66304, '\p{iscopticepactnumbers}', "");
    Expect(1, 66304, '\p{^iscopticepactnumbers}', "");
    Expect(1, 66304, '\P{iscopticepactnumbers}', "");
    Expect(0, 66304, '\P{^iscopticepactnumbers}', "");
    Expect(1, 66303, '\p{_-Is_coptic_Epact_Numbers}', "");
    Expect(0, 66303, '\p{^_-Is_coptic_Epact_Numbers}', "");
    Expect(0, 66303, '\P{_-Is_coptic_Epact_Numbers}', "");
    Expect(1, 66303, '\P{^_-Is_coptic_Epact_Numbers}', "");
    Expect(0, 66304, '\p{_-Is_coptic_Epact_Numbers}', "");
    Expect(1, 66304, '\p{^_-Is_coptic_Epact_Numbers}', "");
    Expect(1, 66304, '\P{_-Is_coptic_Epact_Numbers}', "");
    Expect(0, 66304, '\P{^_-Is_coptic_Epact_Numbers}', "");
    Error('\p{-	in_Coptic_epact_Numbers:=}');
    Error('\P{-	in_Coptic_epact_Numbers:=}');
    Expect(1, 66303, '\p{incopticepactnumbers}', "");
    Expect(0, 66303, '\p{^incopticepactnumbers}', "");
    Expect(0, 66303, '\P{incopticepactnumbers}', "");
    Expect(1, 66303, '\P{^incopticepactnumbers}', "");
    Expect(0, 66304, '\p{incopticepactnumbers}', "");
    Expect(1, 66304, '\p{^incopticepactnumbers}', "");
    Expect(1, 66304, '\P{incopticepactnumbers}', "");
    Expect(0, 66304, '\P{^incopticepactnumbers}', "");
    Expect(1, 66303, '\p{_In_COPTIC_Epact_Numbers}', "");
    Expect(0, 66303, '\p{^_In_COPTIC_Epact_Numbers}', "");
    Expect(0, 66303, '\P{_In_COPTIC_Epact_Numbers}', "");
    Expect(1, 66303, '\P{^_In_COPTIC_Epact_Numbers}', "");
    Expect(0, 66304, '\p{_In_COPTIC_Epact_Numbers}', "");
    Expect(1, 66304, '\p{^_In_COPTIC_Epact_Numbers}', "");
    Expect(1, 66304, '\P{_In_COPTIC_Epact_Numbers}', "");
    Expect(0, 66304, '\P{^_In_COPTIC_Epact_Numbers}', "");
    Error('\p{-:=counting_Rod_numerals}');
    Error('\P{-:=counting_Rod_numerals}');
    Expect(1, 119679, '\p{countingrodnumerals}', "");
    Expect(0, 119679, '\p{^countingrodnumerals}', "");
    Expect(0, 119679, '\P{countingrodnumerals}', "");
    Expect(1, 119679, '\P{^countingrodnumerals}', "");
    Expect(0, 119680, '\p{countingrodnumerals}', "");
    Expect(1, 119680, '\p{^countingrodnumerals}', "");
    Expect(1, 119680, '\P{countingrodnumerals}', "");
    Expect(0, 119680, '\P{^countingrodnumerals}', "");
    Expect(1, 119679, '\p{	-counting_rod_numerals}', "");
    Expect(0, 119679, '\p{^	-counting_rod_numerals}', "");
    Expect(0, 119679, '\P{	-counting_rod_numerals}', "");
    Expect(1, 119679, '\P{^	-counting_rod_numerals}', "");
    Expect(0, 119680, '\p{	-counting_rod_numerals}', "");
    Expect(1, 119680, '\p{^	-counting_rod_numerals}', "");
    Expect(1, 119680, '\P{	-counting_rod_numerals}', "");
    Expect(0, 119680, '\P{^	-counting_rod_numerals}', "");
    Error('\p{	 is_Counting_rod_Numerals:=}');
    Error('\P{	 is_Counting_rod_Numerals:=}');
    Expect(1, 119679, '\p{iscountingrodnumerals}', "");
    Expect(0, 119679, '\p{^iscountingrodnumerals}', "");
    Expect(0, 119679, '\P{iscountingrodnumerals}', "");
    Expect(1, 119679, '\P{^iscountingrodnumerals}', "");
    Expect(0, 119680, '\p{iscountingrodnumerals}', "");
    Expect(1, 119680, '\p{^iscountingrodnumerals}', "");
    Expect(1, 119680, '\P{iscountingrodnumerals}', "");
    Expect(0, 119680, '\P{^iscountingrodnumerals}', "");
    Expect(1, 119679, '\p{  IS_Counting_ROD_Numerals}', "");
    Expect(0, 119679, '\p{^  IS_Counting_ROD_Numerals}', "");
    Expect(0, 119679, '\P{  IS_Counting_ROD_Numerals}', "");
    Expect(1, 119679, '\P{^  IS_Counting_ROD_Numerals}', "");
    Expect(0, 119680, '\p{  IS_Counting_ROD_Numerals}', "");
    Expect(1, 119680, '\p{^  IS_Counting_ROD_Numerals}', "");
    Expect(1, 119680, '\P{  IS_Counting_ROD_Numerals}', "");
    Expect(0, 119680, '\P{^  IS_Counting_ROD_Numerals}', "");
    Error('\p{/a/	-IN_counting_rod_numerals}');
    Error('\P{/a/	-IN_counting_rod_numerals}');
    Expect(1, 119679, '\p{incountingrodnumerals}', "");
    Expect(0, 119679, '\p{^incountingrodnumerals}', "");
    Expect(0, 119679, '\P{incountingrodnumerals}', "");
    Expect(1, 119679, '\P{^incountingrodnumerals}', "");
    Expect(0, 119680, '\p{incountingrodnumerals}', "");
    Expect(1, 119680, '\p{^incountingrodnumerals}', "");
    Expect(1, 119680, '\P{incountingrodnumerals}', "");
    Expect(0, 119680, '\P{^incountingrodnumerals}', "");
    Expect(1, 119679, '\p{_IN_counting_rod_NUMERALS}', "");
    Expect(0, 119679, '\p{^_IN_counting_rod_NUMERALS}', "");
    Expect(0, 119679, '\P{_IN_counting_rod_NUMERALS}', "");
    Expect(1, 119679, '\P{^_IN_counting_rod_NUMERALS}', "");
    Expect(0, 119680, '\p{_IN_counting_rod_NUMERALS}', "");
    Expect(1, 119680, '\p{^_IN_counting_rod_NUMERALS}', "");
    Expect(1, 119680, '\P{_IN_counting_rod_NUMERALS}', "");
    Expect(0, 119680, '\P{^_IN_counting_rod_NUMERALS}', "");
    Error('\p{ /a/Counting_Rod}');
    Error('\P{ /a/Counting_Rod}');
    Expect(1, 119679, '\p{countingrod}', "");
    Expect(0, 119679, '\p{^countingrod}', "");
    Expect(0, 119679, '\P{countingrod}', "");
    Expect(1, 119679, '\P{^countingrod}', "");
    Expect(0, 119680, '\p{countingrod}', "");
    Expect(1, 119680, '\p{^countingrod}', "");
    Expect(1, 119680, '\P{countingrod}', "");
    Expect(0, 119680, '\P{^countingrod}', "");
    Expect(1, 119679, '\p{_-Counting_Rod}', "");
    Expect(0, 119679, '\p{^_-Counting_Rod}', "");
    Expect(0, 119679, '\P{_-Counting_Rod}', "");
    Expect(1, 119679, '\P{^_-Counting_Rod}', "");
    Expect(0, 119680, '\p{_-Counting_Rod}', "");
    Expect(1, 119680, '\p{^_-Counting_Rod}', "");
    Expect(1, 119680, '\P{_-Counting_Rod}', "");
    Expect(0, 119680, '\P{^_-Counting_Rod}', "");
    Error('\p{	is_COUNTING_rod:=}');
    Error('\P{	is_COUNTING_rod:=}');
    Expect(1, 119679, '\p{iscountingrod}', "");
    Expect(0, 119679, '\p{^iscountingrod}', "");
    Expect(0, 119679, '\P{iscountingrod}', "");
    Expect(1, 119679, '\P{^iscountingrod}', "");
    Expect(0, 119680, '\p{iscountingrod}', "");
    Expect(1, 119680, '\p{^iscountingrod}', "");
    Expect(1, 119680, '\P{iscountingrod}', "");
    Expect(0, 119680, '\P{^iscountingrod}', "");
    Expect(1, 119679, '\p{	is_Counting_Rod}', "");
    Expect(0, 119679, '\p{^	is_Counting_Rod}', "");
    Expect(0, 119679, '\P{	is_Counting_Rod}', "");
    Expect(1, 119679, '\P{^	is_Counting_Rod}', "");
    Expect(0, 119680, '\p{	is_Counting_Rod}', "");
    Expect(1, 119680, '\p{^	is_Counting_Rod}', "");
    Expect(1, 119680, '\P{	is_Counting_Rod}', "");
    Expect(0, 119680, '\P{^	is_Counting_Rod}', "");
    Error('\p{--IN_Counting_rod/a/}');
    Error('\P{--IN_Counting_rod/a/}');
    Expect(1, 119679, '\p{incountingrod}', "");
    Expect(0, 119679, '\p{^incountingrod}', "");
    Expect(0, 119679, '\P{incountingrod}', "");
    Expect(1, 119679, '\P{^incountingrod}', "");
    Expect(0, 119680, '\p{incountingrod}', "");
    Expect(1, 119680, '\p{^incountingrod}', "");
    Expect(1, 119680, '\P{incountingrod}', "");
    Expect(0, 119680, '\P{^incountingrod}', "");
    Expect(1, 119679, '\p{ _In_counting_Rod}', "");
    Expect(0, 119679, '\p{^ _In_counting_Rod}', "");
    Expect(0, 119679, '\P{ _In_counting_Rod}', "");
    Expect(1, 119679, '\P{^ _In_counting_Rod}', "");
    Expect(0, 119680, '\p{ _In_counting_Rod}', "");
    Expect(1, 119680, '\p{^ _In_counting_Rod}', "");
    Expect(1, 119680, '\P{ _In_counting_Rod}', "");
    Expect(0, 119680, '\P{^ _In_counting_Rod}', "");
    Error('\p{/a/	_CUNEIFORM}');
    Error('\P{/a/	_CUNEIFORM}');
    Expect(1, 75075, '\p{cuneiform}', "");
    Expect(0, 75075, '\p{^cuneiform}', "");
    Expect(0, 75075, '\P{cuneiform}', "");
    Expect(1, 75075, '\P{^cuneiform}', "");
    Expect(0, 75076, '\p{cuneiform}', "");
    Expect(1, 75076, '\p{^cuneiform}', "");
    Expect(1, 75076, '\P{cuneiform}', "");
    Expect(0, 75076, '\P{^cuneiform}', "");
    Expect(1, 75075, '\p{	-CUNEIFORM}', "");
    Expect(0, 75075, '\p{^	-CUNEIFORM}', "");
    Expect(0, 75075, '\P{	-CUNEIFORM}', "");
    Expect(1, 75075, '\P{^	-CUNEIFORM}', "");
    Expect(0, 75076, '\p{	-CUNEIFORM}', "");
    Expect(1, 75076, '\p{^	-CUNEIFORM}', "");
    Expect(1, 75076, '\P{	-CUNEIFORM}', "");
    Expect(0, 75076, '\P{^	-CUNEIFORM}', "");
    Error('\p{ -IS_Cuneiform/a/}');
    Error('\P{ -IS_Cuneiform/a/}');
    Expect(1, 75075, '\p{iscuneiform}', "");
    Expect(0, 75075, '\p{^iscuneiform}', "");
    Expect(0, 75075, '\P{iscuneiform}', "");
    Expect(1, 75075, '\P{^iscuneiform}', "");
    Expect(0, 75076, '\p{iscuneiform}', "");
    Expect(1, 75076, '\p{^iscuneiform}', "");
    Expect(1, 75076, '\P{iscuneiform}', "");
    Expect(0, 75076, '\P{^iscuneiform}', "");
    Expect(1, 75075, '\p{  is_cuneiform}', "");
    Expect(0, 75075, '\p{^  is_cuneiform}', "");
    Expect(0, 75075, '\P{  is_cuneiform}', "");
    Expect(1, 75075, '\P{^  is_cuneiform}', "");
    Expect(0, 75076, '\p{  is_cuneiform}', "");
    Expect(1, 75076, '\p{^  is_cuneiform}', "");
    Expect(1, 75076, '\P{  is_cuneiform}', "");
    Expect(0, 75076, '\P{^  is_cuneiform}', "");
    Error('\p{/a/-xsux}');
    Error('\P{/a/-xsux}');
    Expect(1, 75075, '\p{xsux}', "");
    Expect(0, 75075, '\p{^xsux}', "");
    Expect(0, 75075, '\P{xsux}', "");
    Expect(1, 75075, '\P{^xsux}', "");
    Expect(0, 75076, '\p{xsux}', "");
    Expect(1, 75076, '\p{^xsux}', "");
    Expect(1, 75076, '\P{xsux}', "");
    Expect(0, 75076, '\P{^xsux}', "");
    Expect(1, 75075, '\p{ _xsux}', "");
    Expect(0, 75075, '\p{^ _xsux}', "");
    Expect(0, 75075, '\P{ _xsux}', "");
    Expect(1, 75075, '\P{^ _xsux}', "");
    Expect(0, 75076, '\p{ _xsux}', "");
    Expect(1, 75076, '\p{^ _xsux}', "");
    Expect(1, 75076, '\P{ _xsux}', "");
    Expect(0, 75076, '\P{^ _xsux}', "");
    Error('\p{:=_Is_Xsux}');
    Error('\P{:=_Is_Xsux}');
    Expect(1, 75075, '\p{isxsux}', "");
    Expect(0, 75075, '\p{^isxsux}', "");
    Expect(0, 75075, '\P{isxsux}', "");
    Expect(1, 75075, '\P{^isxsux}', "");
    Expect(0, 75076, '\p{isxsux}', "");
    Expect(1, 75076, '\p{^isxsux}', "");
    Expect(1, 75076, '\P{isxsux}', "");
    Expect(0, 75076, '\P{^isxsux}', "");
    Expect(1, 75075, '\p{ _Is_XSUX}', "");
    Expect(0, 75075, '\p{^ _Is_XSUX}', "");
    Expect(0, 75075, '\P{ _Is_XSUX}', "");
    Expect(1, 75075, '\P{^ _Is_XSUX}', "");
    Expect(0, 75076, '\p{ _Is_XSUX}', "");
    Expect(1, 75076, '\p{^ _Is_XSUX}', "");
    Expect(1, 75076, '\P{ _Is_XSUX}', "");
    Expect(0, 75076, '\P{^ _Is_XSUX}', "");
    Error('\p{_:=cuneiform_NUMBERS_and_Punctuation}');
    Error('\P{_:=cuneiform_NUMBERS_and_Punctuation}');
    Expect(1, 74879, '\p{cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\p{^cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\P{cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\P{^cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\p{cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\p{^cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\P{cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\P{^cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\p{_CUNEIFORM_numbers_AND_Punctuation}', "");
    Expect(0, 74879, '\p{^_CUNEIFORM_numbers_AND_Punctuation}', "");
    Expect(0, 74879, '\P{_CUNEIFORM_numbers_AND_Punctuation}', "");
    Expect(1, 74879, '\P{^_CUNEIFORM_numbers_AND_Punctuation}', "");
    Expect(0, 74880, '\p{_CUNEIFORM_numbers_AND_Punctuation}', "");
    Expect(1, 74880, '\p{^_CUNEIFORM_numbers_AND_Punctuation}', "");
    Expect(1, 74880, '\P{_CUNEIFORM_numbers_AND_Punctuation}', "");
    Expect(0, 74880, '\P{^_CUNEIFORM_numbers_AND_Punctuation}', "");
    Error('\p{/a/-IS_Cuneiform_numbers_And_punctuation}');
    Error('\P{/a/-IS_Cuneiform_numbers_And_punctuation}');
    Expect(1, 74879, '\p{iscuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\p{^iscuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\P{iscuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\P{^iscuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\p{iscuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\p{^iscuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\P{iscuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\P{^iscuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\p{	Is_cuneiform_Numbers_and_PUNCTUATION}', "");
    Expect(0, 74879, '\p{^	Is_cuneiform_Numbers_and_PUNCTUATION}', "");
    Expect(0, 74879, '\P{	Is_cuneiform_Numbers_and_PUNCTUATION}', "");
    Expect(1, 74879, '\P{^	Is_cuneiform_Numbers_and_PUNCTUATION}', "");
    Expect(0, 74880, '\p{	Is_cuneiform_Numbers_and_PUNCTUATION}', "");
    Expect(1, 74880, '\p{^	Is_cuneiform_Numbers_and_PUNCTUATION}', "");
    Expect(1, 74880, '\P{	Is_cuneiform_Numbers_and_PUNCTUATION}', "");
    Expect(0, 74880, '\P{^	Is_cuneiform_Numbers_and_PUNCTUATION}', "");
    Error('\p{-/a/In_Cuneiform_Numbers_and_Punctuation}');
    Error('\P{-/a/In_Cuneiform_Numbers_and_Punctuation}');
    Expect(1, 74879, '\p{incuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\p{^incuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\P{incuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\P{^incuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\p{incuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\p{^incuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\P{incuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\P{^incuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\p{In_CUNEIFORM_Numbers_AND_Punctuation}', "");
    Expect(0, 74879, '\p{^In_CUNEIFORM_Numbers_AND_Punctuation}', "");
    Expect(0, 74879, '\P{In_CUNEIFORM_Numbers_AND_Punctuation}', "");
    Expect(1, 74879, '\P{^In_CUNEIFORM_Numbers_AND_Punctuation}', "");
    Expect(0, 74880, '\p{In_CUNEIFORM_Numbers_AND_Punctuation}', "");
    Expect(1, 74880, '\p{^In_CUNEIFORM_Numbers_AND_Punctuation}', "");
    Expect(1, 74880, '\P{In_CUNEIFORM_Numbers_AND_Punctuation}', "");
    Expect(0, 74880, '\P{^In_CUNEIFORM_Numbers_AND_Punctuation}', "");
    Error('\p{-:=Cuneiform_Numbers}');
    Error('\P{-:=Cuneiform_Numbers}');
    Expect(1, 74879, '\p{cuneiformnumbers}', "");
    Expect(0, 74879, '\p{^cuneiformnumbers}', "");
    Expect(0, 74879, '\P{cuneiformnumbers}', "");
    Expect(1, 74879, '\P{^cuneiformnumbers}', "");
    Expect(0, 74880, '\p{cuneiformnumbers}', "");
    Expect(1, 74880, '\p{^cuneiformnumbers}', "");
    Expect(1, 74880, '\P{cuneiformnumbers}', "");
    Expect(0, 74880, '\P{^cuneiformnumbers}', "");
    Expect(1, 74879, '\p{	_cuneiform_Numbers}', "");
    Expect(0, 74879, '\p{^	_cuneiform_Numbers}', "");
    Expect(0, 74879, '\P{	_cuneiform_Numbers}', "");
    Expect(1, 74879, '\P{^	_cuneiform_Numbers}', "");
    Expect(0, 74880, '\p{	_cuneiform_Numbers}', "");
    Expect(1, 74880, '\p{^	_cuneiform_Numbers}', "");
    Expect(1, 74880, '\P{	_cuneiform_Numbers}', "");
    Expect(0, 74880, '\P{^	_cuneiform_Numbers}', "");
    Error('\p{-_Is_Cuneiform_Numbers:=}');
    Error('\P{-_Is_Cuneiform_Numbers:=}');
    Expect(1, 74879, '\p{iscuneiformnumbers}', "");
    Expect(0, 74879, '\p{^iscuneiformnumbers}', "");
    Expect(0, 74879, '\P{iscuneiformnumbers}', "");
    Expect(1, 74879, '\P{^iscuneiformnumbers}', "");
    Expect(0, 74880, '\p{iscuneiformnumbers}', "");
    Expect(1, 74880, '\p{^iscuneiformnumbers}', "");
    Expect(1, 74880, '\P{iscuneiformnumbers}', "");
    Expect(0, 74880, '\P{^iscuneiformnumbers}', "");
    Expect(1, 74879, '\p{ _Is_CUNEIFORM_Numbers}', "");
    Expect(0, 74879, '\p{^ _Is_CUNEIFORM_Numbers}', "");
    Expect(0, 74879, '\P{ _Is_CUNEIFORM_Numbers}', "");
    Expect(1, 74879, '\P{^ _Is_CUNEIFORM_Numbers}', "");
    Expect(0, 74880, '\p{ _Is_CUNEIFORM_Numbers}', "");
    Expect(1, 74880, '\p{^ _Is_CUNEIFORM_Numbers}', "");
    Expect(1, 74880, '\P{ _Is_CUNEIFORM_Numbers}', "");
    Expect(0, 74880, '\P{^ _Is_CUNEIFORM_Numbers}', "");
    Error('\p{_ In_Cuneiform_NUMBERS:=}');
    Error('\P{_ In_Cuneiform_NUMBERS:=}');
    Expect(1, 74879, '\p{incuneiformnumbers}', "");
    Expect(0, 74879, '\p{^incuneiformnumbers}', "");
    Expect(0, 74879, '\P{incuneiformnumbers}', "");
    Expect(1, 74879, '\P{^incuneiformnumbers}', "");
    Expect(0, 74880, '\p{incuneiformnumbers}', "");
    Expect(1, 74880, '\p{^incuneiformnumbers}', "");
    Expect(1, 74880, '\P{incuneiformnumbers}', "");
    Expect(0, 74880, '\P{^incuneiformnumbers}', "");
    Expect(1, 74879, '\p{	 in_CUNEIFORM_Numbers}', "");
    Expect(0, 74879, '\p{^	 in_CUNEIFORM_Numbers}', "");
    Expect(0, 74879, '\P{	 in_CUNEIFORM_Numbers}', "");
    Expect(1, 74879, '\P{^	 in_CUNEIFORM_Numbers}', "");
    Expect(0, 74880, '\p{	 in_CUNEIFORM_Numbers}', "");
    Expect(1, 74880, '\p{^	 in_CUNEIFORM_Numbers}', "");
    Expect(1, 74880, '\P{	 in_CUNEIFORM_Numbers}', "");
    Expect(0, 74880, '\P{^	 in_CUNEIFORM_Numbers}', "");
    Error('\p{/a/- currency_Symbol}');
    Error('\P{/a/- currency_Symbol}');
    Expect(1, 65510, '\p{currencysymbol}', "");
    Expect(0, 65510, '\p{^currencysymbol}', "");
    Expect(0, 65510, '\P{currencysymbol}', "");
    Expect(1, 65510, '\P{^currencysymbol}', "");
    Expect(0, 65511, '\p{currencysymbol}', "");
    Expect(1, 65511, '\p{^currencysymbol}', "");
    Expect(1, 65511, '\P{currencysymbol}', "");
    Expect(0, 65511, '\P{^currencysymbol}', "");
    Expect(1, 65510, '\p{	Currency_SYMBOL}', "");
    Expect(0, 65510, '\p{^	Currency_SYMBOL}', "");
    Expect(0, 65510, '\P{	Currency_SYMBOL}', "");
    Expect(1, 65510, '\P{^	Currency_SYMBOL}', "");
    Expect(0, 65511, '\p{	Currency_SYMBOL}', "");
    Expect(1, 65511, '\p{^	Currency_SYMBOL}', "");
    Expect(1, 65511, '\P{	Currency_SYMBOL}', "");
    Expect(0, 65511, '\P{^	Currency_SYMBOL}', "");
    Error('\p{/a/-Is_Currency_Symbol}');
    Error('\P{/a/-Is_Currency_Symbol}');
    Expect(1, 65510, '\p{iscurrencysymbol}', "");
    Expect(0, 65510, '\p{^iscurrencysymbol}', "");
    Expect(0, 65510, '\P{iscurrencysymbol}', "");
    Expect(1, 65510, '\P{^iscurrencysymbol}', "");
    Expect(0, 65511, '\p{iscurrencysymbol}', "");
    Expect(1, 65511, '\p{^iscurrencysymbol}', "");
    Expect(1, 65511, '\P{iscurrencysymbol}', "");
    Expect(0, 65511, '\P{^iscurrencysymbol}', "");
    Expect(1, 65510, '\p{ _Is_Currency_Symbol}', "");
    Expect(0, 65510, '\p{^ _Is_Currency_Symbol}', "");
    Expect(0, 65510, '\P{ _Is_Currency_Symbol}', "");
    Expect(1, 65510, '\P{^ _Is_Currency_Symbol}', "");
    Expect(0, 65511, '\p{ _Is_Currency_Symbol}', "");
    Expect(1, 65511, '\p{^ _Is_Currency_Symbol}', "");
    Expect(1, 65511, '\P{ _Is_Currency_Symbol}', "");
    Expect(0, 65511, '\P{^ _Is_Currency_Symbol}', "");
    Error('\p{/a/  Sc}');
    Error('\P{/a/  Sc}');
    Expect(1, 65510, '\p{sc}', "");
    Expect(0, 65510, '\p{^sc}', "");
    Expect(0, 65510, '\P{sc}', "");
    Expect(1, 65510, '\P{^sc}', "");
    Expect(0, 65511, '\p{sc}', "");
    Expect(1, 65511, '\p{^sc}', "");
    Expect(1, 65511, '\P{sc}', "");
    Expect(0, 65511, '\P{^sc}', "");
    Expect(1, 65510, '\p{_SC}', "");
    Expect(0, 65510, '\p{^_SC}', "");
    Expect(0, 65510, '\P{_SC}', "");
    Expect(1, 65510, '\P{^_SC}', "");
    Expect(0, 65511, '\p{_SC}', "");
    Expect(1, 65511, '\p{^_SC}', "");
    Expect(1, 65511, '\P{_SC}', "");
    Expect(0, 65511, '\P{^_SC}', "");
    Error('\p{/a/- IS_Sc}');
    Error('\P{/a/- IS_Sc}');
    Expect(1, 65510, '\p{issc}', "");
    Expect(0, 65510, '\p{^issc}', "");
    Expect(0, 65510, '\P{issc}', "");
    Expect(1, 65510, '\P{^issc}', "");
    Expect(0, 65511, '\p{issc}', "");
    Expect(1, 65511, '\p{^issc}', "");
    Expect(1, 65511, '\P{issc}', "");
    Expect(0, 65511, '\P{^issc}', "");
    Expect(1, 65510, '\p{_Is_sc}', "");
    Expect(0, 65510, '\p{^_Is_sc}', "");
    Expect(0, 65510, '\P{_Is_sc}', "");
    Expect(1, 65510, '\P{^_Is_sc}', "");
    Expect(0, 65511, '\p{_Is_sc}', "");
    Expect(1, 65511, '\p{^_Is_sc}', "");
    Expect(1, 65511, '\P{_Is_sc}', "");
    Expect(0, 65511, '\P{^_Is_sc}', "");
    Error('\p{/a/-	currency_symbols}');
    Error('\P{/a/-	currency_symbols}');
    Expect(1, 8399, '\p{currencysymbols}', "");
    Expect(0, 8399, '\p{^currencysymbols}', "");
    Expect(0, 8399, '\P{currencysymbols}', "");
    Expect(1, 8399, '\P{^currencysymbols}', "");
    Expect(0, 8400, '\p{currencysymbols}', "");
    Expect(1, 8400, '\p{^currencysymbols}', "");
    Expect(1, 8400, '\P{currencysymbols}', "");
    Expect(0, 8400, '\P{^currencysymbols}', "");
    Expect(1, 8399, '\p{-Currency_Symbols}', "");
    Expect(0, 8399, '\p{^-Currency_Symbols}', "");
    Expect(0, 8399, '\P{-Currency_Symbols}', "");
    Expect(1, 8399, '\P{^-Currency_Symbols}', "");
    Expect(0, 8400, '\p{-Currency_Symbols}', "");
    Expect(1, 8400, '\p{^-Currency_Symbols}', "");
    Expect(1, 8400, '\P{-Currency_Symbols}', "");
    Expect(0, 8400, '\P{^-Currency_Symbols}', "");
    Error('\p{-/a/IS_Currency_Symbols}');
    Error('\P{-/a/IS_Currency_Symbols}');
    Expect(1, 8399, '\p{iscurrencysymbols}', "");
    Expect(0, 8399, '\p{^iscurrencysymbols}', "");
    Expect(0, 8399, '\P{iscurrencysymbols}', "");
    Expect(1, 8399, '\P{^iscurrencysymbols}', "");
    Expect(0, 8400, '\p{iscurrencysymbols}', "");
    Expect(1, 8400, '\p{^iscurrencysymbols}', "");
    Expect(1, 8400, '\P{iscurrencysymbols}', "");
    Expect(0, 8400, '\P{^iscurrencysymbols}', "");
    Expect(1, 8399, '\p{ IS_Currency_symbols}', "");
    Expect(0, 8399, '\p{^ IS_Currency_symbols}', "");
    Expect(0, 8399, '\P{ IS_Currency_symbols}', "");
    Expect(1, 8399, '\P{^ IS_Currency_symbols}', "");
    Expect(0, 8400, '\p{ IS_Currency_symbols}', "");
    Expect(1, 8400, '\p{^ IS_Currency_symbols}', "");
    Expect(1, 8400, '\P{ IS_Currency_symbols}', "");
    Expect(0, 8400, '\P{^ IS_Currency_symbols}', "");
    Error('\p{:=	In_Currency_symbols}');
    Error('\P{:=	In_Currency_symbols}');
    Expect(1, 8399, '\p{incurrencysymbols}', "");
    Expect(0, 8399, '\p{^incurrencysymbols}', "");
    Expect(0, 8399, '\P{incurrencysymbols}', "");
    Expect(1, 8399, '\P{^incurrencysymbols}', "");
    Expect(0, 8400, '\p{incurrencysymbols}', "");
    Expect(1, 8400, '\p{^incurrencysymbols}', "");
    Expect(1, 8400, '\P{incurrencysymbols}', "");
    Expect(0, 8400, '\P{^incurrencysymbols}', "");
    Expect(1, 8399, '\p{	-in_CURRENCY_Symbols}', "");
    Expect(0, 8399, '\p{^	-in_CURRENCY_Symbols}', "");
    Expect(0, 8399, '\P{	-in_CURRENCY_Symbols}', "");
    Expect(1, 8399, '\P{^	-in_CURRENCY_Symbols}', "");
    Expect(0, 8400, '\p{	-in_CURRENCY_Symbols}', "");
    Expect(1, 8400, '\p{^	-in_CURRENCY_Symbols}', "");
    Expect(1, 8400, '\P{	-in_CURRENCY_Symbols}', "");
    Expect(0, 8400, '\P{^	-in_CURRENCY_Symbols}', "");
    Error('\p{:=- cypriot}');
    Error('\P{:=- cypriot}');
    Expect(1, 67647, '\p{cypriot}', "");
    Expect(0, 67647, '\p{^cypriot}', "");
    Expect(0, 67647, '\P{cypriot}', "");
    Expect(1, 67647, '\P{^cypriot}', "");
    Expect(0, 67648, '\p{cypriot}', "");
    Expect(1, 67648, '\p{^cypriot}', "");
    Expect(1, 67648, '\P{cypriot}', "");
    Expect(0, 67648, '\P{^cypriot}', "");
    Expect(1, 67647, '\p{_Cypriot}', "");
    Expect(0, 67647, '\p{^_Cypriot}', "");
    Expect(0, 67647, '\P{_Cypriot}', "");
    Expect(1, 67647, '\P{^_Cypriot}', "");
    Expect(0, 67648, '\p{_Cypriot}', "");
    Expect(1, 67648, '\p{^_Cypriot}', "");
    Expect(1, 67648, '\P{_Cypriot}', "");
    Expect(0, 67648, '\P{^_Cypriot}', "");
    Error('\p{:= _Is_cypriot}');
    Error('\P{:= _Is_cypriot}');
    Expect(1, 67647, '\p{iscypriot}', "");
    Expect(0, 67647, '\p{^iscypriot}', "");
    Expect(0, 67647, '\P{iscypriot}', "");
    Expect(1, 67647, '\P{^iscypriot}', "");
    Expect(0, 67648, '\p{iscypriot}', "");
    Expect(1, 67648, '\p{^iscypriot}', "");
    Expect(1, 67648, '\P{iscypriot}', "");
    Expect(0, 67648, '\P{^iscypriot}', "");
    Expect(1, 67647, '\p{__IS_cypriot}', "");
    Expect(0, 67647, '\p{^__IS_cypriot}', "");
    Expect(0, 67647, '\P{__IS_cypriot}', "");
    Expect(1, 67647, '\P{^__IS_cypriot}', "");
    Expect(0, 67648, '\p{__IS_cypriot}', "");
    Expect(1, 67648, '\p{^__IS_cypriot}', "");
    Expect(1, 67648, '\P{__IS_cypriot}', "");
    Expect(0, 67648, '\P{^__IS_cypriot}', "");
    Error('\p{:=CPRT}');
    Error('\P{:=CPRT}');
    Expect(1, 67647, '\p{cprt}', "");
    Expect(0, 67647, '\p{^cprt}', "");
    Expect(0, 67647, '\P{cprt}', "");
    Expect(1, 67647, '\P{^cprt}', "");
    Expect(0, 67648, '\p{cprt}', "");
    Expect(1, 67648, '\p{^cprt}', "");
    Expect(1, 67648, '\P{cprt}', "");
    Expect(0, 67648, '\P{^cprt}', "");
    Expect(1, 67647, '\p{__Cprt}', "");
    Expect(0, 67647, '\p{^__Cprt}', "");
    Expect(0, 67647, '\P{__Cprt}', "");
    Expect(1, 67647, '\P{^__Cprt}', "");
    Expect(0, 67648, '\p{__Cprt}', "");
    Expect(1, 67648, '\p{^__Cprt}', "");
    Expect(1, 67648, '\P{__Cprt}', "");
    Expect(0, 67648, '\P{^__Cprt}', "");
    Error('\p{ /a/is_CPRT}');
    Error('\P{ /a/is_CPRT}');
    Expect(1, 67647, '\p{iscprt}', "");
    Expect(0, 67647, '\p{^iscprt}', "");
    Expect(0, 67647, '\P{iscprt}', "");
    Expect(1, 67647, '\P{^iscprt}', "");
    Expect(0, 67648, '\p{iscprt}', "");
    Expect(1, 67648, '\p{^iscprt}', "");
    Expect(1, 67648, '\P{iscprt}', "");
    Expect(0, 67648, '\P{^iscprt}', "");
    Expect(1, 67647, '\p{-	Is_Cprt}', "");
    Expect(0, 67647, '\p{^-	Is_Cprt}', "");
    Expect(0, 67647, '\P{-	Is_Cprt}', "");
    Expect(1, 67647, '\P{^-	Is_Cprt}', "");
    Expect(0, 67648, '\p{-	Is_Cprt}', "");
    Expect(1, 67648, '\p{^-	Is_Cprt}', "");
    Expect(1, 67648, '\P{-	Is_Cprt}', "");
    Expect(0, 67648, '\P{^-	Is_Cprt}', "");
    Error('\p{:=	-Cypriot_Syllabary}');
    Error('\P{:=	-Cypriot_Syllabary}');
    Expect(1, 67647, '\p{cypriotsyllabary}', "");
    Expect(0, 67647, '\p{^cypriotsyllabary}', "");
    Expect(0, 67647, '\P{cypriotsyllabary}', "");
    Expect(1, 67647, '\P{^cypriotsyllabary}', "");
    Expect(0, 67648, '\p{cypriotsyllabary}', "");
    Expect(1, 67648, '\p{^cypriotsyllabary}', "");
    Expect(1, 67648, '\P{cypriotsyllabary}', "");
    Expect(0, 67648, '\P{^cypriotsyllabary}', "");
    Expect(1, 67647, '\p{-_Cypriot_SYLLABARY}', "");
    Expect(0, 67647, '\p{^-_Cypriot_SYLLABARY}', "");
    Expect(0, 67647, '\P{-_Cypriot_SYLLABARY}', "");
    Expect(1, 67647, '\P{^-_Cypriot_SYLLABARY}', "");
    Expect(0, 67648, '\p{-_Cypriot_SYLLABARY}', "");
    Expect(1, 67648, '\p{^-_Cypriot_SYLLABARY}', "");
    Expect(1, 67648, '\P{-_Cypriot_SYLLABARY}', "");
    Expect(0, 67648, '\P{^-_Cypriot_SYLLABARY}', "");
    Error('\p{/a/	 Is_Cypriot_Syllabary}');
    Error('\P{/a/	 Is_Cypriot_Syllabary}');
    Expect(1, 67647, '\p{iscypriotsyllabary}', "");
    Expect(0, 67647, '\p{^iscypriotsyllabary}', "");
    Expect(0, 67647, '\P{iscypriotsyllabary}', "");
    Expect(1, 67647, '\P{^iscypriotsyllabary}', "");
    Expect(0, 67648, '\p{iscypriotsyllabary}', "");
    Expect(1, 67648, '\p{^iscypriotsyllabary}', "");
    Expect(1, 67648, '\P{iscypriotsyllabary}', "");
    Expect(0, 67648, '\P{^iscypriotsyllabary}', "");
    Expect(1, 67647, '\p{ 	Is_cypriot_syllabary}', "");
    Expect(0, 67647, '\p{^ 	Is_cypriot_syllabary}', "");
    Expect(0, 67647, '\P{ 	Is_cypriot_syllabary}', "");
    Expect(1, 67647, '\P{^ 	Is_cypriot_syllabary}', "");
    Expect(0, 67648, '\p{ 	Is_cypriot_syllabary}', "");
    Expect(1, 67648, '\p{^ 	Is_cypriot_syllabary}', "");
    Expect(1, 67648, '\P{ 	Is_cypriot_syllabary}', "");
    Expect(0, 67648, '\P{^ 	Is_cypriot_syllabary}', "");
    Error('\p{:=__In_cypriot_SYLLABARY}');
    Error('\P{:=__In_cypriot_SYLLABARY}');
    Expect(1, 67647, '\p{incypriotsyllabary}', "");
    Expect(0, 67647, '\p{^incypriotsyllabary}', "");
    Expect(0, 67647, '\P{incypriotsyllabary}', "");
    Expect(1, 67647, '\P{^incypriotsyllabary}', "");
    Expect(0, 67648, '\p{incypriotsyllabary}', "");
    Expect(1, 67648, '\p{^incypriotsyllabary}', "");
    Expect(1, 67648, '\P{incypriotsyllabary}', "");
    Expect(0, 67648, '\P{^incypriotsyllabary}', "");
    Expect(1, 67647, '\p{--In_cypriot_syllabary}', "");
    Expect(0, 67647, '\p{^--In_cypriot_syllabary}', "");
    Expect(0, 67647, '\P{--In_cypriot_syllabary}', "");
    Expect(1, 67647, '\P{^--In_cypriot_syllabary}', "");
    Expect(0, 67648, '\p{--In_cypriot_syllabary}', "");
    Expect(1, 67648, '\p{^--In_cypriot_syllabary}', "");
    Expect(1, 67648, '\P{--In_cypriot_syllabary}', "");
    Expect(0, 67648, '\P{^--In_cypriot_syllabary}', "");
    Error('\p{-	cyrillic:=}');
    Error('\P{-	cyrillic:=}');
    Expect(1, 65071, '\p{cyrillic}', "");
    Expect(0, 65071, '\p{^cyrillic}', "");
    Expect(0, 65071, '\P{cyrillic}', "");
    Expect(1, 65071, '\P{^cyrillic}', "");
    Expect(0, 65072, '\p{cyrillic}', "");
    Expect(1, 65072, '\p{^cyrillic}', "");
    Expect(1, 65072, '\P{cyrillic}', "");
    Expect(0, 65072, '\P{^cyrillic}', "");
    Expect(1, 65071, '\p{_cyrillic}', "");
    Expect(0, 65071, '\p{^_cyrillic}', "");
    Expect(0, 65071, '\P{_cyrillic}', "");
    Expect(1, 65071, '\P{^_cyrillic}', "");
    Expect(0, 65072, '\p{_cyrillic}', "");
    Expect(1, 65072, '\p{^_cyrillic}', "");
    Expect(1, 65072, '\P{_cyrillic}', "");
    Expect(0, 65072, '\P{^_cyrillic}', "");
    Error('\p{Is_Cyrillic:=}');
    Error('\P{Is_Cyrillic:=}');
    Expect(1, 65071, '\p{iscyrillic}', "");
    Expect(0, 65071, '\p{^iscyrillic}', "");
    Expect(0, 65071, '\P{iscyrillic}', "");
    Expect(1, 65071, '\P{^iscyrillic}', "");
    Expect(0, 65072, '\p{iscyrillic}', "");
    Expect(1, 65072, '\p{^iscyrillic}', "");
    Expect(1, 65072, '\P{iscyrillic}', "");
    Expect(0, 65072, '\P{^iscyrillic}', "");
    Expect(1, 65071, '\p{--Is_cyrillic}', "");
    Expect(0, 65071, '\p{^--Is_cyrillic}', "");
    Expect(0, 65071, '\P{--Is_cyrillic}', "");
    Expect(1, 65071, '\P{^--Is_cyrillic}', "");
    Expect(0, 65072, '\p{--Is_cyrillic}', "");
    Expect(1, 65072, '\p{^--Is_cyrillic}', "");
    Expect(1, 65072, '\P{--Is_cyrillic}', "");
    Expect(0, 65072, '\P{^--Is_cyrillic}', "");
    Error('\p{	-cyrl:=}');
    Error('\P{	-cyrl:=}');
    Expect(1, 65071, '\p{cyrl}', "");
    Expect(0, 65071, '\p{^cyrl}', "");
    Expect(0, 65071, '\P{cyrl}', "");
    Expect(1, 65071, '\P{^cyrl}', "");
    Expect(0, 65072, '\p{cyrl}', "");
    Expect(1, 65072, '\p{^cyrl}', "");
    Expect(1, 65072, '\P{cyrl}', "");
    Expect(0, 65072, '\P{^cyrl}', "");
    Expect(1, 65071, '\p{-	CYRL}', "");
    Expect(0, 65071, '\p{^-	CYRL}', "");
    Expect(0, 65071, '\P{-	CYRL}', "");
    Expect(1, 65071, '\P{^-	CYRL}', "");
    Expect(0, 65072, '\p{-	CYRL}', "");
    Expect(1, 65072, '\p{^-	CYRL}', "");
    Expect(1, 65072, '\P{-	CYRL}', "");
    Expect(0, 65072, '\P{^-	CYRL}', "");
    Error('\p{-	Is_Cyrl/a/}');
    Error('\P{-	Is_Cyrl/a/}');
    Expect(1, 65071, '\p{iscyrl}', "");
    Expect(0, 65071, '\p{^iscyrl}', "");
    Expect(0, 65071, '\P{iscyrl}', "");
    Expect(1, 65071, '\P{^iscyrl}', "");
    Expect(0, 65072, '\p{iscyrl}', "");
    Expect(1, 65072, '\p{^iscyrl}', "");
    Expect(1, 65072, '\P{iscyrl}', "");
    Expect(0, 65072, '\P{^iscyrl}', "");
    Expect(1, 65071, '\p{	IS_cyrl}', "");
    Expect(0, 65071, '\p{^	IS_cyrl}', "");
    Expect(0, 65071, '\P{	IS_cyrl}', "");
    Expect(1, 65071, '\P{^	IS_cyrl}', "");
    Expect(0, 65072, '\p{	IS_cyrl}', "");
    Expect(1, 65072, '\p{^	IS_cyrl}', "");
    Expect(1, 65072, '\P{	IS_cyrl}', "");
    Expect(0, 65072, '\P{^	IS_cyrl}', "");
    Error('\p{:=-Cyrillic_Extended_A}');
    Error('\P{:=-Cyrillic_Extended_A}');
    Expect(1, 11775, '\p{cyrillicextendeda}', "");
    Expect(0, 11775, '\p{^cyrillicextendeda}', "");
    Expect(0, 11775, '\P{cyrillicextendeda}', "");
    Expect(1, 11775, '\P{^cyrillicextendeda}', "");
    Expect(0, 11776, '\p{cyrillicextendeda}', "");
    Expect(1, 11776, '\p{^cyrillicextendeda}', "");
    Expect(1, 11776, '\P{cyrillicextendeda}', "");
    Expect(0, 11776, '\P{^cyrillicextendeda}', "");
    Expect(1, 11775, '\p{	CYRILLIC_EXTENDED_A}', "");
    Expect(0, 11775, '\p{^	CYRILLIC_EXTENDED_A}', "");
    Expect(0, 11775, '\P{	CYRILLIC_EXTENDED_A}', "");
    Expect(1, 11775, '\P{^	CYRILLIC_EXTENDED_A}', "");
    Expect(0, 11776, '\p{	CYRILLIC_EXTENDED_A}', "");
    Expect(1, 11776, '\p{^	CYRILLIC_EXTENDED_A}', "");
    Expect(1, 11776, '\P{	CYRILLIC_EXTENDED_A}', "");
    Expect(0, 11776, '\P{^	CYRILLIC_EXTENDED_A}', "");
    Error('\p{:=  is_Cyrillic_Extended_A}');
    Error('\P{:=  is_Cyrillic_Extended_A}');
    Expect(1, 11775, '\p{iscyrillicextendeda}', "");
    Expect(0, 11775, '\p{^iscyrillicextendeda}', "");
    Expect(0, 11775, '\P{iscyrillicextendeda}', "");
    Expect(1, 11775, '\P{^iscyrillicextendeda}', "");
    Expect(0, 11776, '\p{iscyrillicextendeda}', "");
    Expect(1, 11776, '\p{^iscyrillicextendeda}', "");
    Expect(1, 11776, '\P{iscyrillicextendeda}', "");
    Expect(0, 11776, '\P{^iscyrillicextendeda}', "");
    Expect(1, 11775, '\p{-_IS_CYRILLIC_extended_A}', "");
    Expect(0, 11775, '\p{^-_IS_CYRILLIC_extended_A}', "");
    Expect(0, 11775, '\P{-_IS_CYRILLIC_extended_A}', "");
    Expect(1, 11775, '\P{^-_IS_CYRILLIC_extended_A}', "");
    Expect(0, 11776, '\p{-_IS_CYRILLIC_extended_A}', "");
    Expect(1, 11776, '\p{^-_IS_CYRILLIC_extended_A}', "");
    Expect(1, 11776, '\P{-_IS_CYRILLIC_extended_A}', "");
    Expect(0, 11776, '\P{^-_IS_CYRILLIC_extended_A}', "");
    Error('\p{:=_-In_Cyrillic_Extended_A}');
    Error('\P{:=_-In_Cyrillic_Extended_A}');
    Expect(1, 11775, '\p{incyrillicextendeda}', "");
    Expect(0, 11775, '\p{^incyrillicextendeda}', "");
    Expect(0, 11775, '\P{incyrillicextendeda}', "");
    Expect(1, 11775, '\P{^incyrillicextendeda}', "");
    Expect(0, 11776, '\p{incyrillicextendeda}', "");
    Expect(1, 11776, '\p{^incyrillicextendeda}', "");
    Expect(1, 11776, '\P{incyrillicextendeda}', "");
    Expect(0, 11776, '\P{^incyrillicextendeda}', "");
    Expect(1, 11775, '\p{	IN_cyrillic_Extended_A}', "");
    Expect(0, 11775, '\p{^	IN_cyrillic_Extended_A}', "");
    Expect(0, 11775, '\P{	IN_cyrillic_Extended_A}', "");
    Expect(1, 11775, '\P{^	IN_cyrillic_Extended_A}', "");
    Expect(0, 11776, '\p{	IN_cyrillic_Extended_A}', "");
    Expect(1, 11776, '\p{^	IN_cyrillic_Extended_A}', "");
    Expect(1, 11776, '\P{	IN_cyrillic_Extended_A}', "");
    Expect(0, 11776, '\P{^	IN_cyrillic_Extended_A}', "");
    Error('\p{/a/ 	Cyrillic_EXT_A}');
    Error('\P{/a/ 	Cyrillic_EXT_A}');
    Expect(1, 11775, '\p{cyrillicexta}', "");
    Expect(0, 11775, '\p{^cyrillicexta}', "");
    Expect(0, 11775, '\P{cyrillicexta}', "");
    Expect(1, 11775, '\P{^cyrillicexta}', "");
    Expect(0, 11776, '\p{cyrillicexta}', "");
    Expect(1, 11776, '\p{^cyrillicexta}', "");
    Expect(1, 11776, '\P{cyrillicexta}', "");
    Expect(0, 11776, '\P{^cyrillicexta}', "");
    Expect(1, 11775, '\p{ _Cyrillic_Ext_A}', "");
    Expect(0, 11775, '\p{^ _Cyrillic_Ext_A}', "");
    Expect(0, 11775, '\P{ _Cyrillic_Ext_A}', "");
    Expect(1, 11775, '\P{^ _Cyrillic_Ext_A}', "");
    Expect(0, 11776, '\p{ _Cyrillic_Ext_A}', "");
    Expect(1, 11776, '\p{^ _Cyrillic_Ext_A}', "");
    Expect(1, 11776, '\P{ _Cyrillic_Ext_A}', "");
    Expect(0, 11776, '\P{^ _Cyrillic_Ext_A}', "");
    Error('\p{:=is_Cyrillic_EXT_a}');
    Error('\P{:=is_Cyrillic_EXT_a}');
    Expect(1, 11775, '\p{iscyrillicexta}', "");
    Expect(0, 11775, '\p{^iscyrillicexta}', "");
    Expect(0, 11775, '\P{iscyrillicexta}', "");
    Expect(1, 11775, '\P{^iscyrillicexta}', "");
    Expect(0, 11776, '\p{iscyrillicexta}', "");
    Expect(1, 11776, '\p{^iscyrillicexta}', "");
    Expect(1, 11776, '\P{iscyrillicexta}', "");
    Expect(0, 11776, '\P{^iscyrillicexta}', "");
    Expect(1, 11775, '\p{	-Is_Cyrillic_Ext_A}', "");
    Expect(0, 11775, '\p{^	-Is_Cyrillic_Ext_A}', "");
    Expect(0, 11775, '\P{	-Is_Cyrillic_Ext_A}', "");
    Expect(1, 11775, '\P{^	-Is_Cyrillic_Ext_A}', "");
    Expect(0, 11776, '\p{	-Is_Cyrillic_Ext_A}', "");
    Expect(1, 11776, '\p{^	-Is_Cyrillic_Ext_A}', "");
    Expect(1, 11776, '\P{	-Is_Cyrillic_Ext_A}', "");
    Expect(0, 11776, '\P{^	-Is_Cyrillic_Ext_A}', "");
    Error('\p{/a/__In_cyrillic_ext_a}');
    Error('\P{/a/__In_cyrillic_ext_a}');
    Expect(1, 11775, '\p{incyrillicexta}', "");
    Expect(0, 11775, '\p{^incyrillicexta}', "");
    Expect(0, 11775, '\P{incyrillicexta}', "");
    Expect(1, 11775, '\P{^incyrillicexta}', "");
    Expect(0, 11776, '\p{incyrillicexta}', "");
    Expect(1, 11776, '\p{^incyrillicexta}', "");
    Expect(1, 11776, '\P{incyrillicexta}', "");
    Expect(0, 11776, '\P{^incyrillicexta}', "");
    Expect(1, 11775, '\p{__IN_Cyrillic_EXT_A}', "");
    Expect(0, 11775, '\p{^__IN_Cyrillic_EXT_A}', "");
    Expect(0, 11775, '\P{__IN_Cyrillic_EXT_A}', "");
    Expect(1, 11775, '\P{^__IN_Cyrillic_EXT_A}', "");
    Expect(0, 11776, '\p{__IN_Cyrillic_EXT_A}', "");
    Expect(1, 11776, '\p{^__IN_Cyrillic_EXT_A}', "");
    Expect(1, 11776, '\P{__IN_Cyrillic_EXT_A}', "");
    Expect(0, 11776, '\P{^__IN_Cyrillic_EXT_A}', "");
    Error('\p{:=		Cyrillic_EXTENDED_B}');
    Error('\P{:=		Cyrillic_EXTENDED_B}');
    Expect(1, 42655, '\p{cyrillicextendedb}', "");
    Expect(0, 42655, '\p{^cyrillicextendedb}', "");
    Expect(0, 42655, '\P{cyrillicextendedb}', "");
    Expect(1, 42655, '\P{^cyrillicextendedb}', "");
    Expect(0, 42656, '\p{cyrillicextendedb}', "");
    Expect(1, 42656, '\p{^cyrillicextendedb}', "");
    Expect(1, 42656, '\P{cyrillicextendedb}', "");
    Expect(0, 42656, '\P{^cyrillicextendedb}', "");
    Expect(1, 42655, '\p{--CYRILLIC_Extended_B}', "");
    Expect(0, 42655, '\p{^--CYRILLIC_Extended_B}', "");
    Expect(0, 42655, '\P{--CYRILLIC_Extended_B}', "");
    Expect(1, 42655, '\P{^--CYRILLIC_Extended_B}', "");
    Expect(0, 42656, '\p{--CYRILLIC_Extended_B}', "");
    Expect(1, 42656, '\p{^--CYRILLIC_Extended_B}', "");
    Expect(1, 42656, '\P{--CYRILLIC_Extended_B}', "");
    Expect(0, 42656, '\P{^--CYRILLIC_Extended_B}', "");
    Error('\p{	IS_cyrillic_Extended_b:=}');
    Error('\P{	IS_cyrillic_Extended_b:=}');
    Expect(1, 42655, '\p{iscyrillicextendedb}', "");
    Expect(0, 42655, '\p{^iscyrillicextendedb}', "");
    Expect(0, 42655, '\P{iscyrillicextendedb}', "");
    Expect(1, 42655, '\P{^iscyrillicextendedb}', "");
    Expect(0, 42656, '\p{iscyrillicextendedb}', "");
    Expect(1, 42656, '\p{^iscyrillicextendedb}', "");
    Expect(1, 42656, '\P{iscyrillicextendedb}', "");
    Expect(0, 42656, '\P{^iscyrillicextendedb}', "");
    Expect(1, 42655, '\p{		Is_Cyrillic_EXTENDED_B}', "");
    Expect(0, 42655, '\p{^		Is_Cyrillic_EXTENDED_B}', "");
    Expect(0, 42655, '\P{		Is_Cyrillic_EXTENDED_B}', "");
    Expect(1, 42655, '\P{^		Is_Cyrillic_EXTENDED_B}', "");
    Expect(0, 42656, '\p{		Is_Cyrillic_EXTENDED_B}', "");
    Expect(1, 42656, '\p{^		Is_Cyrillic_EXTENDED_B}', "");
    Expect(1, 42656, '\P{		Is_Cyrillic_EXTENDED_B}', "");
    Expect(0, 42656, '\P{^		Is_Cyrillic_EXTENDED_B}', "");
    Error('\p{	In_Cyrillic_extended_b:=}');
    Error('\P{	In_Cyrillic_extended_b:=}');
    Expect(1, 42655, '\p{incyrillicextendedb}', "");
    Expect(0, 42655, '\p{^incyrillicextendedb}', "");
    Expect(0, 42655, '\P{incyrillicextendedb}', "");
    Expect(1, 42655, '\P{^incyrillicextendedb}', "");
    Expect(0, 42656, '\p{incyrillicextendedb}', "");
    Expect(1, 42656, '\p{^incyrillicextendedb}', "");
    Expect(1, 42656, '\P{incyrillicextendedb}', "");
    Expect(0, 42656, '\P{^incyrillicextendedb}', "");
    Expect(1, 42655, '\p{-IN_CYRILLIC_extended_B}', "");
    Expect(0, 42655, '\p{^-IN_CYRILLIC_extended_B}', "");
    Expect(0, 42655, '\P{-IN_CYRILLIC_extended_B}', "");
    Expect(1, 42655, '\P{^-IN_CYRILLIC_extended_B}', "");
    Expect(0, 42656, '\p{-IN_CYRILLIC_extended_B}', "");
    Expect(1, 42656, '\p{^-IN_CYRILLIC_extended_B}', "");
    Expect(1, 42656, '\P{-IN_CYRILLIC_extended_B}', "");
    Expect(0, 42656, '\P{^-IN_CYRILLIC_extended_B}', "");
    Error('\p{/a/-Cyrillic_ext_b}');
    Error('\P{/a/-Cyrillic_ext_b}');
    Expect(1, 42655, '\p{cyrillicextb}', "");
    Expect(0, 42655, '\p{^cyrillicextb}', "");
    Expect(0, 42655, '\P{cyrillicextb}', "");
    Expect(1, 42655, '\P{^cyrillicextb}', "");
    Expect(0, 42656, '\p{cyrillicextb}', "");
    Expect(1, 42656, '\p{^cyrillicextb}', "");
    Expect(1, 42656, '\P{cyrillicextb}', "");
    Expect(0, 42656, '\P{^cyrillicextb}', "");
    Expect(1, 42655, '\p{- Cyrillic_Ext_B}', "");
    Expect(0, 42655, '\p{^- Cyrillic_Ext_B}', "");
    Expect(0, 42655, '\P{- Cyrillic_Ext_B}', "");
    Expect(1, 42655, '\P{^- Cyrillic_Ext_B}', "");
    Expect(0, 42656, '\p{- Cyrillic_Ext_B}', "");
    Expect(1, 42656, '\p{^- Cyrillic_Ext_B}', "");
    Expect(1, 42656, '\P{- Cyrillic_Ext_B}', "");
    Expect(0, 42656, '\P{^- Cyrillic_Ext_B}', "");
    Error('\p{:= IS_Cyrillic_Ext_B}');
    Error('\P{:= IS_Cyrillic_Ext_B}');
    Expect(1, 42655, '\p{iscyrillicextb}', "");
    Expect(0, 42655, '\p{^iscyrillicextb}', "");
    Expect(0, 42655, '\P{iscyrillicextb}', "");
    Expect(1, 42655, '\P{^iscyrillicextb}', "");
    Expect(0, 42656, '\p{iscyrillicextb}', "");
    Expect(1, 42656, '\p{^iscyrillicextb}', "");
    Expect(1, 42656, '\P{iscyrillicextb}', "");
    Expect(0, 42656, '\P{^iscyrillicextb}', "");
    Expect(1, 42655, '\p{_-Is_Cyrillic_Ext_B}', "");
    Expect(0, 42655, '\p{^_-Is_Cyrillic_Ext_B}', "");
    Expect(0, 42655, '\P{_-Is_Cyrillic_Ext_B}', "");
    Expect(1, 42655, '\P{^_-Is_Cyrillic_Ext_B}', "");
    Expect(0, 42656, '\p{_-Is_Cyrillic_Ext_B}', "");
    Expect(1, 42656, '\p{^_-Is_Cyrillic_Ext_B}', "");
    Expect(1, 42656, '\P{_-Is_Cyrillic_Ext_B}', "");
    Expect(0, 42656, '\P{^_-Is_Cyrillic_Ext_B}', "");
    Error('\p{/a/	_in_Cyrillic_EXT_B}');
    Error('\P{/a/	_in_Cyrillic_EXT_B}');
    Expect(1, 42655, '\p{incyrillicextb}', "");
    Expect(0, 42655, '\p{^incyrillicextb}', "");
    Expect(0, 42655, '\P{incyrillicextb}', "");
    Expect(1, 42655, '\P{^incyrillicextb}', "");
    Expect(0, 42656, '\p{incyrillicextb}', "");
    Expect(1, 42656, '\p{^incyrillicextb}', "");
    Expect(1, 42656, '\P{incyrillicextb}', "");
    Expect(0, 42656, '\P{^incyrillicextb}', "");
    Expect(1, 42655, '\p{	-In_cyrillic_EXT_b}', "");
    Expect(0, 42655, '\p{^	-In_cyrillic_EXT_b}', "");
    Expect(0, 42655, '\P{	-In_cyrillic_EXT_b}', "");
    Expect(1, 42655, '\P{^	-In_cyrillic_EXT_b}', "");
    Expect(0, 42656, '\p{	-In_cyrillic_EXT_b}', "");
    Expect(1, 42656, '\p{^	-In_cyrillic_EXT_b}', "");
    Expect(1, 42656, '\P{	-In_cyrillic_EXT_b}', "");
    Expect(0, 42656, '\P{^	-In_cyrillic_EXT_b}', "");
    Error('\p{	CYRILLIC_Extended_C/a/}');
    Error('\P{	CYRILLIC_Extended_C/a/}');
    Expect(1, 7311, '\p{cyrillicextendedc}', "");
    Expect(0, 7311, '\p{^cyrillicextendedc}', "");
    Expect(0, 7311, '\P{cyrillicextendedc}', "");
    Expect(1, 7311, '\P{^cyrillicextendedc}', "");
    Expect(0, 7312, '\p{cyrillicextendedc}', "");
    Expect(1, 7312, '\p{^cyrillicextendedc}', "");
    Expect(1, 7312, '\P{cyrillicextendedc}', "");
    Expect(0, 7312, '\P{^cyrillicextendedc}', "");
    Expect(1, 7311, '\p{-CYRILLIC_EXTENDED_C}', "");
    Expect(0, 7311, '\p{^-CYRILLIC_EXTENDED_C}', "");
    Expect(0, 7311, '\P{-CYRILLIC_EXTENDED_C}', "");
    Expect(1, 7311, '\P{^-CYRILLIC_EXTENDED_C}', "");
    Expect(0, 7312, '\p{-CYRILLIC_EXTENDED_C}', "");
    Expect(1, 7312, '\p{^-CYRILLIC_EXTENDED_C}', "");
    Expect(1, 7312, '\P{-CYRILLIC_EXTENDED_C}', "");
    Expect(0, 7312, '\P{^-CYRILLIC_EXTENDED_C}', "");
    Error('\p{/a/is_Cyrillic_Extended_C}');
    Error('\P{/a/is_Cyrillic_Extended_C}');
    Expect(1, 7311, '\p{iscyrillicextendedc}', "");
    Expect(0, 7311, '\p{^iscyrillicextendedc}', "");
    Expect(0, 7311, '\P{iscyrillicextendedc}', "");
    Expect(1, 7311, '\P{^iscyrillicextendedc}', "");
    Expect(0, 7312, '\p{iscyrillicextendedc}', "");
    Expect(1, 7312, '\p{^iscyrillicextendedc}', "");
    Expect(1, 7312, '\P{iscyrillicextendedc}', "");
    Expect(0, 7312, '\P{^iscyrillicextendedc}', "");
    Expect(1, 7311, '\p{-is_Cyrillic_Extended_C}', "");
    Expect(0, 7311, '\p{^-is_Cyrillic_Extended_C}', "");
    Expect(0, 7311, '\P{-is_Cyrillic_Extended_C}', "");
    Expect(1, 7311, '\P{^-is_Cyrillic_Extended_C}', "");
    Expect(0, 7312, '\p{-is_Cyrillic_Extended_C}', "");
    Expect(1, 7312, '\p{^-is_Cyrillic_Extended_C}', "");
    Expect(1, 7312, '\P{-is_Cyrillic_Extended_C}', "");
    Expect(0, 7312, '\P{^-is_Cyrillic_Extended_C}', "");
    Error('\p{-/a/In_CYRILLIC_Extended_c}');
    Error('\P{-/a/In_CYRILLIC_Extended_c}');
    Expect(1, 7311, '\p{incyrillicextendedc}', "");
    Expect(0, 7311, '\p{^incyrillicextendedc}', "");
    Expect(0, 7311, '\P{incyrillicextendedc}', "");
    Expect(1, 7311, '\P{^incyrillicextendedc}', "");
    Expect(0, 7312, '\p{incyrillicextendedc}', "");
    Expect(1, 7312, '\p{^incyrillicextendedc}', "");
    Expect(1, 7312, '\P{incyrillicextendedc}', "");
    Expect(0, 7312, '\P{^incyrillicextendedc}', "");
    Expect(1, 7311, '\p{-In_CYRILLIC_extended_c}', "");
    Expect(0, 7311, '\p{^-In_CYRILLIC_extended_c}', "");
    Expect(0, 7311, '\P{-In_CYRILLIC_extended_c}', "");
    Expect(1, 7311, '\P{^-In_CYRILLIC_extended_c}', "");
    Expect(0, 7312, '\p{-In_CYRILLIC_extended_c}', "");
    Expect(1, 7312, '\p{^-In_CYRILLIC_extended_c}', "");
    Expect(1, 7312, '\P{-In_CYRILLIC_extended_c}', "");
    Expect(0, 7312, '\P{^-In_CYRILLIC_extended_c}', "");
    Error('\p{_:=Cyrillic_ext_C}');
    Error('\P{_:=Cyrillic_ext_C}');
    Expect(1, 7311, '\p{cyrillicextc}', "");
    Expect(0, 7311, '\p{^cyrillicextc}', "");
    Expect(0, 7311, '\P{cyrillicextc}', "");
    Expect(1, 7311, '\P{^cyrillicextc}', "");
    Expect(0, 7312, '\p{cyrillicextc}', "");
    Expect(1, 7312, '\p{^cyrillicextc}', "");
    Expect(1, 7312, '\P{cyrillicextc}', "");
    Expect(0, 7312, '\P{^cyrillicextc}', "");
    Expect(1, 7311, '\p{ Cyrillic_ext_c}', "");
    Expect(0, 7311, '\p{^ Cyrillic_ext_c}', "");
    Expect(0, 7311, '\P{ Cyrillic_ext_c}', "");
    Expect(1, 7311, '\P{^ Cyrillic_ext_c}', "");
    Expect(0, 7312, '\p{ Cyrillic_ext_c}', "");
    Expect(1, 7312, '\p{^ Cyrillic_ext_c}', "");
    Expect(1, 7312, '\P{ Cyrillic_ext_c}', "");
    Expect(0, 7312, '\P{^ Cyrillic_ext_c}', "");
    Error('\p{_/a/IS_Cyrillic_Ext_C}');
    Error('\P{_/a/IS_Cyrillic_Ext_C}');
    Expect(1, 7311, '\p{iscyrillicextc}', "");
    Expect(0, 7311, '\p{^iscyrillicextc}', "");
    Expect(0, 7311, '\P{iscyrillicextc}', "");
    Expect(1, 7311, '\P{^iscyrillicextc}', "");
    Expect(0, 7312, '\p{iscyrillicextc}', "");
    Expect(1, 7312, '\p{^iscyrillicextc}', "");
    Expect(1, 7312, '\P{iscyrillicextc}', "");
    Expect(0, 7312, '\P{^iscyrillicextc}', "");
    Expect(1, 7311, '\p{__Is_cyrillic_ext_C}', "");
    Expect(0, 7311, '\p{^__Is_cyrillic_ext_C}', "");
    Expect(0, 7311, '\P{__Is_cyrillic_ext_C}', "");
    Expect(1, 7311, '\P{^__Is_cyrillic_ext_C}', "");
    Expect(0, 7312, '\p{__Is_cyrillic_ext_C}', "");
    Expect(1, 7312, '\p{^__Is_cyrillic_ext_C}', "");
    Expect(1, 7312, '\P{__Is_cyrillic_ext_C}', "");
    Expect(0, 7312, '\P{^__Is_cyrillic_ext_C}', "");
    Error('\p{-_In_Cyrillic_ext_C/a/}');
    Error('\P{-_In_Cyrillic_ext_C/a/}');
    Expect(1, 7311, '\p{incyrillicextc}', "");
    Expect(0, 7311, '\p{^incyrillicextc}', "");
    Expect(0, 7311, '\P{incyrillicextc}', "");
    Expect(1, 7311, '\P{^incyrillicextc}', "");
    Expect(0, 7312, '\p{incyrillicextc}', "");
    Expect(1, 7312, '\p{^incyrillicextc}', "");
    Expect(1, 7312, '\P{incyrillicextc}', "");
    Expect(0, 7312, '\P{^incyrillicextc}', "");
    Expect(1, 7311, '\p{ _IN_CYRILLIC_EXT_C}', "");
    Expect(0, 7311, '\p{^ _IN_CYRILLIC_EXT_C}', "");
    Expect(0, 7311, '\P{ _IN_CYRILLIC_EXT_C}', "");
    Expect(1, 7311, '\P{^ _IN_CYRILLIC_EXT_C}', "");
    Expect(0, 7312, '\p{ _IN_CYRILLIC_EXT_C}', "");
    Expect(1, 7312, '\p{^ _IN_CYRILLIC_EXT_C}', "");
    Expect(1, 7312, '\P{ _IN_CYRILLIC_EXT_C}', "");
    Expect(0, 7312, '\P{^ _IN_CYRILLIC_EXT_C}', "");
    Error('\p{_ cyrillic_SUPPLEMENT/a/}');
    Error('\P{_ cyrillic_SUPPLEMENT/a/}');
    Expect(1, 1327, '\p{cyrillicsupplement}', "");
    Expect(0, 1327, '\p{^cyrillicsupplement}', "");
    Expect(0, 1327, '\P{cyrillicsupplement}', "");
    Expect(1, 1327, '\P{^cyrillicsupplement}', "");
    Expect(0, 1328, '\p{cyrillicsupplement}', "");
    Expect(1, 1328, '\p{^cyrillicsupplement}', "");
    Expect(1, 1328, '\P{cyrillicsupplement}', "");
    Expect(0, 1328, '\P{^cyrillicsupplement}', "");
    Expect(1, 1327, '\p{- Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1327, '\p{^- Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1327, '\P{- Cyrillic_SUPPLEMENT}', "");
    Expect(1, 1327, '\P{^- Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1328, '\p{- Cyrillic_SUPPLEMENT}', "");
    Expect(1, 1328, '\p{^- Cyrillic_SUPPLEMENT}', "");
    Expect(1, 1328, '\P{- Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1328, '\P{^- Cyrillic_SUPPLEMENT}', "");
    Error('\p{_/a/IS_Cyrillic_Supplement}');
    Error('\P{_/a/IS_Cyrillic_Supplement}');
    Expect(1, 1327, '\p{iscyrillicsupplement}', "");
    Expect(0, 1327, '\p{^iscyrillicsupplement}', "");
    Expect(0, 1327, '\P{iscyrillicsupplement}', "");
    Expect(1, 1327, '\P{^iscyrillicsupplement}', "");
    Expect(0, 1328, '\p{iscyrillicsupplement}', "");
    Expect(1, 1328, '\p{^iscyrillicsupplement}', "");
    Expect(1, 1328, '\P{iscyrillicsupplement}', "");
    Expect(0, 1328, '\P{^iscyrillicsupplement}', "");
    Expect(1, 1327, '\p{-_IS_CYRILLIC_Supplement}', "");
    Expect(0, 1327, '\p{^-_IS_CYRILLIC_Supplement}', "");
    Expect(0, 1327, '\P{-_IS_CYRILLIC_Supplement}', "");
    Expect(1, 1327, '\P{^-_IS_CYRILLIC_Supplement}', "");
    Expect(0, 1328, '\p{-_IS_CYRILLIC_Supplement}', "");
    Expect(1, 1328, '\p{^-_IS_CYRILLIC_Supplement}', "");
    Expect(1, 1328, '\P{-_IS_CYRILLIC_Supplement}', "");
    Expect(0, 1328, '\P{^-_IS_CYRILLIC_Supplement}', "");
    Error('\p{/a/	-In_Cyrillic_SUPPLEMENT}');
    Error('\P{/a/	-In_Cyrillic_SUPPLEMENT}');
    Expect(1, 1327, '\p{incyrillicsupplement}', "");
    Expect(0, 1327, '\p{^incyrillicsupplement}', "");
    Expect(0, 1327, '\P{incyrillicsupplement}', "");
    Expect(1, 1327, '\P{^incyrillicsupplement}', "");
    Expect(0, 1328, '\p{incyrillicsupplement}', "");
    Expect(1, 1328, '\p{^incyrillicsupplement}', "");
    Expect(1, 1328, '\P{incyrillicsupplement}', "");
    Expect(0, 1328, '\P{^incyrillicsupplement}', "");
    Expect(1, 1327, '\p{_-IN_CYRILLIC_Supplement}', "");
    Expect(0, 1327, '\p{^_-IN_CYRILLIC_Supplement}', "");
    Expect(0, 1327, '\P{_-IN_CYRILLIC_Supplement}', "");
    Expect(1, 1327, '\P{^_-IN_CYRILLIC_Supplement}', "");
    Expect(0, 1328, '\p{_-IN_CYRILLIC_Supplement}', "");
    Expect(1, 1328, '\p{^_-IN_CYRILLIC_Supplement}', "");
    Expect(1, 1328, '\P{_-IN_CYRILLIC_Supplement}', "");
    Expect(0, 1328, '\P{^_-IN_CYRILLIC_Supplement}', "");
    Error('\p{/a/-Cyrillic_sup}');
    Error('\P{/a/-Cyrillic_sup}');
    Expect(1, 1327, '\p{cyrillicsup}', "");
    Expect(0, 1327, '\p{^cyrillicsup}', "");
    Expect(0, 1327, '\P{cyrillicsup}', "");
    Expect(1, 1327, '\P{^cyrillicsup}', "");
    Expect(0, 1328, '\p{cyrillicsup}', "");
    Expect(1, 1328, '\p{^cyrillicsup}', "");
    Expect(1, 1328, '\P{cyrillicsup}', "");
    Expect(0, 1328, '\P{^cyrillicsup}', "");
    Expect(1, 1327, '\p{_Cyrillic_Sup}', "");
    Expect(0, 1327, '\p{^_Cyrillic_Sup}', "");
    Expect(0, 1327, '\P{_Cyrillic_Sup}', "");
    Expect(1, 1327, '\P{^_Cyrillic_Sup}', "");
    Expect(0, 1328, '\p{_Cyrillic_Sup}', "");
    Expect(1, 1328, '\p{^_Cyrillic_Sup}', "");
    Expect(1, 1328, '\P{_Cyrillic_Sup}', "");
    Expect(0, 1328, '\P{^_Cyrillic_Sup}', "");
    Error('\p{_IS_cyrillic_Sup:=}');
    Error('\P{_IS_cyrillic_Sup:=}');
    Expect(1, 1327, '\p{iscyrillicsup}', "");
    Expect(0, 1327, '\p{^iscyrillicsup}', "");
    Expect(0, 1327, '\P{iscyrillicsup}', "");
    Expect(1, 1327, '\P{^iscyrillicsup}', "");
    Expect(0, 1328, '\p{iscyrillicsup}', "");
    Expect(1, 1328, '\p{^iscyrillicsup}', "");
    Expect(1, 1328, '\P{iscyrillicsup}', "");
    Expect(0, 1328, '\P{^iscyrillicsup}', "");
    Expect(1, 1327, '\p{		Is_Cyrillic_Sup}', "");
    Expect(0, 1327, '\p{^		Is_Cyrillic_Sup}', "");
    Expect(0, 1327, '\P{		Is_Cyrillic_Sup}', "");
    Expect(1, 1327, '\P{^		Is_Cyrillic_Sup}', "");
    Expect(0, 1328, '\p{		Is_Cyrillic_Sup}', "");
    Expect(1, 1328, '\p{^		Is_Cyrillic_Sup}', "");
    Expect(1, 1328, '\P{		Is_Cyrillic_Sup}', "");
    Expect(0, 1328, '\P{^		Is_Cyrillic_Sup}', "");
    Error('\p{-/a/In_CYRILLIC_Sup}');
    Error('\P{-/a/In_CYRILLIC_Sup}');
    Expect(1, 1327, '\p{incyrillicsup}', "");
    Expect(0, 1327, '\p{^incyrillicsup}', "");
    Expect(0, 1327, '\P{incyrillicsup}', "");
    Expect(1, 1327, '\P{^incyrillicsup}', "");
    Expect(0, 1328, '\p{incyrillicsup}', "");
    Expect(1, 1328, '\p{^incyrillicsup}', "");
    Expect(1, 1328, '\P{incyrillicsup}', "");
    Expect(0, 1328, '\P{^incyrillicsup}', "");
    Expect(1, 1327, '\p{ 	In_CYRILLIC_Sup}', "");
    Expect(0, 1327, '\p{^ 	In_CYRILLIC_Sup}', "");
    Expect(0, 1327, '\P{ 	In_CYRILLIC_Sup}', "");
    Expect(1, 1327, '\P{^ 	In_CYRILLIC_Sup}', "");
    Expect(0, 1328, '\p{ 	In_CYRILLIC_Sup}', "");
    Expect(1, 1328, '\p{^ 	In_CYRILLIC_Sup}', "");
    Expect(1, 1328, '\P{ 	In_CYRILLIC_Sup}', "");
    Expect(0, 1328, '\P{^ 	In_CYRILLIC_Sup}', "");
    Error('\p{/a/-Cyrillic_Supplementary}');
    Error('\P{/a/-Cyrillic_Supplementary}');
    Expect(1, 1327, '\p{cyrillicsupplementary}', "");
    Expect(0, 1327, '\p{^cyrillicsupplementary}', "");
    Expect(0, 1327, '\P{cyrillicsupplementary}', "");
    Expect(1, 1327, '\P{^cyrillicsupplementary}', "");
    Expect(0, 1328, '\p{cyrillicsupplementary}', "");
    Expect(1, 1328, '\p{^cyrillicsupplementary}', "");
    Expect(1, 1328, '\P{cyrillicsupplementary}', "");
    Expect(0, 1328, '\P{^cyrillicsupplementary}', "");
    Expect(1, 1327, '\p{--Cyrillic_supplementary}', "");
    Expect(0, 1327, '\p{^--Cyrillic_supplementary}', "");
    Expect(0, 1327, '\P{--Cyrillic_supplementary}', "");
    Expect(1, 1327, '\P{^--Cyrillic_supplementary}', "");
    Expect(0, 1328, '\p{--Cyrillic_supplementary}', "");
    Expect(1, 1328, '\p{^--Cyrillic_supplementary}', "");
    Expect(1, 1328, '\P{--Cyrillic_supplementary}', "");
    Expect(0, 1328, '\P{^--Cyrillic_supplementary}', "");
    Error('\p{:= is_Cyrillic_SUPPLEMENTARY}');
    Error('\P{:= is_Cyrillic_SUPPLEMENTARY}');
    Expect(1, 1327, '\p{iscyrillicsupplementary}', "");
    Expect(0, 1327, '\p{^iscyrillicsupplementary}', "");
    Expect(0, 1327, '\P{iscyrillicsupplementary}', "");
    Expect(1, 1327, '\P{^iscyrillicsupplementary}', "");
    Expect(0, 1328, '\p{iscyrillicsupplementary}', "");
    Expect(1, 1328, '\p{^iscyrillicsupplementary}', "");
    Expect(1, 1328, '\P{iscyrillicsupplementary}', "");
    Expect(0, 1328, '\P{^iscyrillicsupplementary}', "");
    Expect(1, 1327, '\p{ -is_cyrillic_Supplementary}', "");
    Expect(0, 1327, '\p{^ -is_cyrillic_Supplementary}', "");
    Expect(0, 1327, '\P{ -is_cyrillic_Supplementary}', "");
    Expect(1, 1327, '\P{^ -is_cyrillic_Supplementary}', "");
    Expect(0, 1328, '\p{ -is_cyrillic_Supplementary}', "");
    Expect(1, 1328, '\p{^ -is_cyrillic_Supplementary}', "");
    Expect(1, 1328, '\P{ -is_cyrillic_Supplementary}', "");
    Expect(0, 1328, '\P{^ -is_cyrillic_Supplementary}', "");
    Error('\p{ -In_Cyrillic_Supplementary/a/}');
    Error('\P{ -In_Cyrillic_Supplementary/a/}');
    Expect(1, 1327, '\p{incyrillicsupplementary}', "");
    Expect(0, 1327, '\p{^incyrillicsupplementary}', "");
    Expect(0, 1327, '\P{incyrillicsupplementary}', "");
    Expect(1, 1327, '\P{^incyrillicsupplementary}', "");
    Expect(0, 1328, '\p{incyrillicsupplementary}', "");
    Expect(1, 1328, '\p{^incyrillicsupplementary}', "");
    Expect(1, 1328, '\P{incyrillicsupplementary}', "");
    Expect(0, 1328, '\P{^incyrillicsupplementary}', "");
    Expect(1, 1327, '\p{_-In_Cyrillic_supplementary}', "");
    Expect(0, 1327, '\p{^_-In_Cyrillic_supplementary}', "");
    Expect(0, 1327, '\P{_-In_Cyrillic_supplementary}', "");
    Expect(1, 1327, '\P{^_-In_Cyrillic_supplementary}', "");
    Expect(0, 1328, '\p{_-In_Cyrillic_supplementary}', "");
    Expect(1, 1328, '\p{^_-In_Cyrillic_supplementary}', "");
    Expect(1, 1328, '\P{_-In_Cyrillic_supplementary}', "");
    Expect(0, 1328, '\P{^_-In_Cyrillic_supplementary}', "");
    Error('\p{:=dash}');
    Error('\P{:=dash}');
    Expect(1, 65293, '\p{dash}', "");
    Expect(0, 65293, '\p{^dash}', "");
    Expect(0, 65293, '\P{dash}', "");
    Expect(1, 65293, '\P{^dash}', "");
    Expect(0, 65294, '\p{dash}', "");
    Expect(1, 65294, '\p{^dash}', "");
    Expect(1, 65294, '\P{dash}', "");
    Expect(0, 65294, '\P{^dash}', "");
    Expect(1, 65293, '\p{_-dash}', "");
    Expect(0, 65293, '\p{^_-dash}', "");
    Expect(0, 65293, '\P{_-dash}', "");
    Expect(1, 65293, '\P{^_-dash}', "");
    Expect(0, 65294, '\p{_-dash}', "");
    Expect(1, 65294, '\p{^_-dash}', "");
    Expect(1, 65294, '\P{_-dash}', "");
    Expect(0, 65294, '\P{^_-dash}', "");
    Error('\p{_:=Is_Dash}');
    Error('\P{_:=Is_Dash}');
    Expect(1, 65293, '\p{isdash}', "");
    Expect(0, 65293, '\p{^isdash}', "");
    Expect(0, 65293, '\P{isdash}', "");
    Expect(1, 65293, '\P{^isdash}', "");
    Expect(0, 65294, '\p{isdash}', "");
    Expect(1, 65294, '\p{^isdash}', "");
    Expect(1, 65294, '\P{isdash}', "");
    Expect(0, 65294, '\P{^isdash}', "");
    Expect(1, 65293, '\p{_Is_dash}', "");
    Expect(0, 65293, '\p{^_Is_dash}', "");
    Expect(0, 65293, '\P{_Is_dash}', "");
    Expect(1, 65293, '\P{^_Is_dash}', "");
    Expect(0, 65294, '\p{_Is_dash}', "");
    Expect(1, 65294, '\p{^_Is_dash}', "");
    Expect(1, 65294, '\P{_Is_dash}', "");
    Expect(0, 65294, '\P{^_Is_dash}', "");
    Error('\p{:=-_DASH_Punctuation}');
    Error('\P{:=-_DASH_Punctuation}');
    Expect(1, 65293, '\p{dashpunctuation}', "");
    Expect(0, 65293, '\p{^dashpunctuation}', "");
    Expect(0, 65293, '\P{dashpunctuation}', "");
    Expect(1, 65293, '\P{^dashpunctuation}', "");
    Expect(0, 65294, '\p{dashpunctuation}', "");
    Expect(1, 65294, '\p{^dashpunctuation}', "");
    Expect(1, 65294, '\P{dashpunctuation}', "");
    Expect(0, 65294, '\P{^dashpunctuation}', "");
    Expect(1, 65293, '\p{  DASH_Punctuation}', "");
    Expect(0, 65293, '\p{^  DASH_Punctuation}', "");
    Expect(0, 65293, '\P{  DASH_Punctuation}', "");
    Expect(1, 65293, '\P{^  DASH_Punctuation}', "");
    Expect(0, 65294, '\p{  DASH_Punctuation}', "");
    Expect(1, 65294, '\p{^  DASH_Punctuation}', "");
    Expect(1, 65294, '\P{  DASH_Punctuation}', "");
    Expect(0, 65294, '\P{^  DASH_Punctuation}', "");
    Error('\p{ _Is_Dash_punctuation:=}');
    Error('\P{ _Is_Dash_punctuation:=}');
    Expect(1, 65293, '\p{isdashpunctuation}', "");
    Expect(0, 65293, '\p{^isdashpunctuation}', "");
    Expect(0, 65293, '\P{isdashpunctuation}', "");
    Expect(1, 65293, '\P{^isdashpunctuation}', "");
    Expect(0, 65294, '\p{isdashpunctuation}', "");
    Expect(1, 65294, '\p{^isdashpunctuation}', "");
    Expect(1, 65294, '\P{isdashpunctuation}', "");
    Expect(0, 65294, '\P{^isdashpunctuation}', "");
    Expect(1, 65293, '\p{ 	Is_dash_Punctuation}', "");
    Expect(0, 65293, '\p{^ 	Is_dash_Punctuation}', "");
    Expect(0, 65293, '\P{ 	Is_dash_Punctuation}', "");
    Expect(1, 65293, '\P{^ 	Is_dash_Punctuation}', "");
    Expect(0, 65294, '\p{ 	Is_dash_Punctuation}', "");
    Expect(1, 65294, '\p{^ 	Is_dash_Punctuation}', "");
    Expect(1, 65294, '\P{ 	Is_dash_Punctuation}', "");
    Expect(0, 65294, '\P{^ 	Is_dash_Punctuation}', "");
    Error('\p{_ pd/a/}');
    Error('\P{_ pd/a/}');
    Expect(1, 65293, '\p{pd}', "");
    Expect(0, 65293, '\p{^pd}', "");
    Expect(0, 65293, '\P{pd}', "");
    Expect(1, 65293, '\P{^pd}', "");
    Expect(0, 65294, '\p{pd}', "");
    Expect(1, 65294, '\p{^pd}', "");
    Expect(1, 65294, '\P{pd}', "");
    Expect(0, 65294, '\P{^pd}', "");
    Expect(1, 65293, '\p{-PD}', "");
    Expect(0, 65293, '\p{^-PD}', "");
    Expect(0, 65293, '\P{-PD}', "");
    Expect(1, 65293, '\P{^-PD}', "");
    Expect(0, 65294, '\p{-PD}', "");
    Expect(1, 65294, '\p{^-PD}', "");
    Expect(1, 65294, '\P{-PD}', "");
    Expect(0, 65294, '\P{^-PD}', "");
    Error('\p{:=IS_Pd}');
    Error('\P{:=IS_Pd}');
    Expect(1, 65293, '\p{ispd}', "");
    Expect(0, 65293, '\p{^ispd}', "");
    Expect(0, 65293, '\P{ispd}', "");
    Expect(1, 65293, '\P{^ispd}', "");
    Expect(0, 65294, '\p{ispd}', "");
    Expect(1, 65294, '\p{^ispd}', "");
    Expect(1, 65294, '\P{ispd}', "");
    Expect(0, 65294, '\P{^ispd}', "");
    Expect(1, 65293, '\p{	Is_pd}', "");
    Expect(0, 65293, '\p{^	Is_pd}', "");
    Expect(0, 65293, '\P{	Is_pd}', "");
    Expect(1, 65293, '\P{^	Is_pd}', "");
    Expect(0, 65294, '\p{	Is_pd}', "");
    Expect(1, 65294, '\p{^	Is_pd}', "");
    Expect(1, 65294, '\P{	Is_pd}', "");
    Expect(0, 65294, '\P{^	Is_pd}', "");
    Error('\p{	:=Default_IGNORABLE_Code_Point}');
    Error('\P{	:=Default_IGNORABLE_Code_Point}');
    Expect(1, 921599, '\p{defaultignorablecodepoint}', "");
    Expect(0, 921599, '\p{^defaultignorablecodepoint}', "");
    Expect(0, 921599, '\P{defaultignorablecodepoint}', "");
    Expect(1, 921599, '\P{^defaultignorablecodepoint}', "");
    Expect(0, 921600, '\p{defaultignorablecodepoint}', "");
    Expect(1, 921600, '\p{^defaultignorablecodepoint}', "");
    Expect(1, 921600, '\P{defaultignorablecodepoint}', "");
    Expect(0, 921600, '\P{^defaultignorablecodepoint}', "");
    Expect(1, 921599, '\p{ -default_ignorable_code_Point}', "");
    Expect(0, 921599, '\p{^ -default_ignorable_code_Point}', "");
    Expect(0, 921599, '\P{ -default_ignorable_code_Point}', "");
    Expect(1, 921599, '\P{^ -default_ignorable_code_Point}', "");
    Expect(0, 921600, '\p{ -default_ignorable_code_Point}', "");
    Expect(1, 921600, '\p{^ -default_ignorable_code_Point}', "");
    Expect(1, 921600, '\P{ -default_ignorable_code_Point}', "");
    Expect(0, 921600, '\P{^ -default_ignorable_code_Point}', "");
    Error('\p{is_Default_ignorable_Code_POINT/a/}');
    Error('\P{is_Default_ignorable_Code_POINT/a/}');
    Expect(1, 921599, '\p{isdefaultignorablecodepoint}', "");
    Expect(0, 921599, '\p{^isdefaultignorablecodepoint}', "");
    Expect(0, 921599, '\P{isdefaultignorablecodepoint}', "");
    Expect(1, 921599, '\P{^isdefaultignorablecodepoint}', "");
    Expect(0, 921600, '\p{isdefaultignorablecodepoint}', "");
    Expect(1, 921600, '\p{^isdefaultignorablecodepoint}', "");
    Expect(1, 921600, '\P{isdefaultignorablecodepoint}', "");
    Expect(0, 921600, '\P{^isdefaultignorablecodepoint}', "");
    Expect(1, 921599, '\p{_	is_default_ignorable_Code_Point}', "");
    Expect(0, 921599, '\p{^_	is_default_ignorable_Code_Point}', "");
    Expect(0, 921599, '\P{_	is_default_ignorable_Code_Point}', "");
    Expect(1, 921599, '\P{^_	is_default_ignorable_Code_Point}', "");
    Expect(0, 921600, '\p{_	is_default_ignorable_Code_Point}', "");
    Expect(1, 921600, '\p{^_	is_default_ignorable_Code_Point}', "");
    Expect(1, 921600, '\P{_	is_default_ignorable_Code_Point}', "");
    Expect(0, 921600, '\P{^_	is_default_ignorable_Code_Point}', "");
    Error('\p{ /a/DI}');
    Error('\P{ /a/DI}');
    Expect(1, 921599, '\p{di}', "");
    Expect(0, 921599, '\p{^di}', "");
    Expect(0, 921599, '\P{di}', "");
    Expect(1, 921599, '\P{^di}', "");
    Expect(0, 921600, '\p{di}', "");
    Expect(1, 921600, '\p{^di}', "");
    Expect(1, 921600, '\P{di}', "");
    Expect(0, 921600, '\P{^di}', "");
    Expect(1, 921599, '\p{--di}', "");
    Expect(0, 921599, '\p{^--di}', "");
    Expect(0, 921599, '\P{--di}', "");
    Expect(1, 921599, '\P{^--di}', "");
    Expect(0, 921600, '\p{--di}', "");
    Expect(1, 921600, '\p{^--di}', "");
    Expect(1, 921600, '\P{--di}', "");
    Expect(0, 921600, '\P{^--di}', "");
    Error('\p{	 Is_di:=}');
    Error('\P{	 Is_di:=}');
    Expect(1, 921599, '\p{isdi}', "");
    Expect(0, 921599, '\p{^isdi}', "");
    Expect(0, 921599, '\P{isdi}', "");
    Expect(1, 921599, '\P{^isdi}', "");
    Expect(0, 921600, '\p{isdi}', "");
    Expect(1, 921600, '\p{^isdi}', "");
    Expect(1, 921600, '\P{isdi}', "");
    Expect(0, 921600, '\P{^isdi}', "");
    Expect(1, 921599, '\p{_Is_DI}', "");
    Expect(0, 921599, '\p{^_Is_DI}', "");
    Expect(0, 921599, '\P{_Is_DI}', "");
    Expect(1, 921599, '\P{^_Is_DI}', "");
    Expect(0, 921600, '\p{_Is_DI}', "");
    Expect(1, 921600, '\p{^_Is_DI}', "");
    Expect(1, 921600, '\P{_Is_DI}', "");
    Expect(0, 921600, '\P{^_Is_DI}', "");
    Error('\p{	DEPRECATED:=}');
    Error('\P{	DEPRECATED:=}');
    Expect(1, 917505, '\p{deprecated}', "");
    Expect(0, 917505, '\p{^deprecated}', "");
    Expect(0, 917505, '\P{deprecated}', "");
    Expect(1, 917505, '\P{^deprecated}', "");
    Expect(0, 917506, '\p{deprecated}', "");
    Expect(1, 917506, '\p{^deprecated}', "");
    Expect(1, 917506, '\P{deprecated}', "");
    Expect(0, 917506, '\P{^deprecated}', "");
    Expect(1, 917505, '\p{DEPRECATED}', "");
    Expect(0, 917505, '\p{^DEPRECATED}', "");
    Expect(0, 917505, '\P{DEPRECATED}', "");
    Expect(1, 917505, '\P{^DEPRECATED}', "");
    Expect(0, 917506, '\p{DEPRECATED}', "");
    Expect(1, 917506, '\p{^DEPRECATED}', "");
    Expect(1, 917506, '\P{DEPRECATED}', "");
    Expect(0, 917506, '\P{^DEPRECATED}', "");
    Error('\p{/a/is_Deprecated}');
    Error('\P{/a/is_Deprecated}');
    Expect(1, 917505, '\p{isdeprecated}', "");
    Expect(0, 917505, '\p{^isdeprecated}', "");
    Expect(0, 917505, '\P{isdeprecated}', "");
    Expect(1, 917505, '\P{^isdeprecated}', "");
    Expect(0, 917506, '\p{isdeprecated}', "");
    Expect(1, 917506, '\p{^isdeprecated}', "");
    Expect(1, 917506, '\P{isdeprecated}', "");
    Expect(0, 917506, '\P{^isdeprecated}', "");
    Expect(1, 917505, '\p{ Is_Deprecated}', "");
    Expect(0, 917505, '\p{^ Is_Deprecated}', "");
    Expect(0, 917505, '\P{ Is_Deprecated}', "");
    Expect(1, 917505, '\P{^ Is_Deprecated}', "");
    Expect(0, 917506, '\p{ Is_Deprecated}', "");
    Expect(1, 917506, '\p{^ Is_Deprecated}', "");
    Expect(1, 917506, '\P{ Is_Deprecated}', "");
    Expect(0, 917506, '\P{^ Is_Deprecated}', "");
    Error('\p{-dep:=}');
    Error('\P{-dep:=}');
    Expect(1, 917505, '\p{dep}', "");
    Expect(0, 917505, '\p{^dep}', "");
    Expect(0, 917505, '\P{dep}', "");
    Expect(1, 917505, '\P{^dep}', "");
    Expect(0, 917506, '\p{dep}', "");
    Expect(1, 917506, '\p{^dep}', "");
    Expect(1, 917506, '\P{dep}', "");
    Expect(0, 917506, '\P{^dep}', "");
    Expect(1, 917505, '\p{ DEP}', "");
    Expect(0, 917505, '\p{^ DEP}', "");
    Expect(0, 917505, '\P{ DEP}', "");
    Expect(1, 917505, '\P{^ DEP}', "");
    Expect(0, 917506, '\p{ DEP}', "");
    Expect(1, 917506, '\p{^ DEP}', "");
    Expect(1, 917506, '\P{ DEP}', "");
    Expect(0, 917506, '\P{^ DEP}', "");
    Error('\p{/a/__Is_dep}');
    Error('\P{/a/__Is_dep}');
    Expect(1, 917505, '\p{isdep}', "");
    Expect(0, 917505, '\p{^isdep}', "");
    Expect(0, 917505, '\P{isdep}', "");
    Expect(1, 917505, '\P{^isdep}', "");
    Expect(0, 917506, '\p{isdep}', "");
    Expect(1, 917506, '\p{^isdep}', "");
    Expect(1, 917506, '\P{isdep}', "");
    Expect(0, 917506, '\P{^isdep}', "");
    Expect(1, 917505, '\p{	-Is_Dep}', "");
    Expect(0, 917505, '\p{^	-Is_Dep}', "");
    Expect(0, 917505, '\P{	-Is_Dep}', "");
    Expect(1, 917505, '\P{^	-Is_Dep}', "");
    Expect(0, 917506, '\p{	-Is_Dep}', "");
    Expect(1, 917506, '\p{^	-Is_Dep}', "");
    Expect(1, 917506, '\P{	-Is_Dep}', "");
    Expect(0, 917506, '\P{^	-Is_Dep}', "");
    Error('\p{ :=Deseret}');
    Error('\P{ :=Deseret}');
    Expect(1, 66639, '\p{deseret}', "");
    Expect(0, 66639, '\p{^deseret}', "");
    Expect(0, 66639, '\P{deseret}', "");
    Expect(1, 66639, '\P{^deseret}', "");
    Expect(0, 66640, '\p{deseret}', "");
    Expect(1, 66640, '\p{^deseret}', "");
    Expect(1, 66640, '\P{deseret}', "");
    Expect(0, 66640, '\P{^deseret}', "");
    Expect(1, 66639, '\p{ Deseret}', "");
    Expect(0, 66639, '\p{^ Deseret}', "");
    Expect(0, 66639, '\P{ Deseret}', "");
    Expect(1, 66639, '\P{^ Deseret}', "");
    Expect(0, 66640, '\p{ Deseret}', "");
    Expect(1, 66640, '\p{^ Deseret}', "");
    Expect(1, 66640, '\P{ Deseret}', "");
    Expect(0, 66640, '\P{^ Deseret}', "");
    Error('\p{/a/ IS_DESERET}');
    Error('\P{/a/ IS_DESERET}');
    Expect(1, 66639, '\p{isdeseret}', "");
    Expect(0, 66639, '\p{^isdeseret}', "");
    Expect(0, 66639, '\P{isdeseret}', "");
    Expect(1, 66639, '\P{^isdeseret}', "");
    Expect(0, 66640, '\p{isdeseret}', "");
    Expect(1, 66640, '\p{^isdeseret}', "");
    Expect(1, 66640, '\P{isdeseret}', "");
    Expect(0, 66640, '\P{^isdeseret}', "");
    Expect(1, 66639, '\p{-_is_deseret}', "");
    Expect(0, 66639, '\p{^-_is_deseret}', "");
    Expect(0, 66639, '\P{-_is_deseret}', "");
    Expect(1, 66639, '\P{^-_is_deseret}', "");
    Expect(0, 66640, '\p{-_is_deseret}', "");
    Expect(1, 66640, '\p{^-_is_deseret}', "");
    Expect(1, 66640, '\P{-_is_deseret}', "");
    Expect(0, 66640, '\P{^-_is_deseret}', "");
    Error('\p{/a/__DSRT}');
    Error('\P{/a/__DSRT}');
    Expect(1, 66639, '\p{dsrt}', "");
    Expect(0, 66639, '\p{^dsrt}', "");
    Expect(0, 66639, '\P{dsrt}', "");
    Expect(1, 66639, '\P{^dsrt}', "");
    Expect(0, 66640, '\p{dsrt}', "");
    Expect(1, 66640, '\p{^dsrt}', "");
    Expect(1, 66640, '\P{dsrt}', "");
    Expect(0, 66640, '\P{^dsrt}', "");
    Expect(1, 66639, '\p{-Dsrt}', "");
    Expect(0, 66639, '\p{^-Dsrt}', "");
    Expect(0, 66639, '\P{-Dsrt}', "");
    Expect(1, 66639, '\P{^-Dsrt}', "");
    Expect(0, 66640, '\p{-Dsrt}', "");
    Expect(1, 66640, '\p{^-Dsrt}', "");
    Expect(1, 66640, '\P{-Dsrt}', "");
    Expect(0, 66640, '\P{^-Dsrt}', "");
    Error('\p{_is_Dsrt/a/}');
    Error('\P{_is_Dsrt/a/}');
    Expect(1, 66639, '\p{isdsrt}', "");
    Expect(0, 66639, '\p{^isdsrt}', "");
    Expect(0, 66639, '\P{isdsrt}', "");
    Expect(1, 66639, '\P{^isdsrt}', "");
    Expect(0, 66640, '\p{isdsrt}', "");
    Expect(1, 66640, '\p{^isdsrt}', "");
    Expect(1, 66640, '\P{isdsrt}', "");
    Expect(0, 66640, '\P{^isdsrt}', "");
    Expect(1, 66639, '\p{is_Dsrt}', "");
    Expect(0, 66639, '\p{^is_Dsrt}', "");
    Expect(0, 66639, '\P{is_Dsrt}', "");
    Expect(1, 66639, '\P{^is_Dsrt}', "");
    Expect(0, 66640, '\p{is_Dsrt}', "");
    Expect(1, 66640, '\p{^is_Dsrt}', "");
    Expect(1, 66640, '\P{is_Dsrt}', "");
    Expect(0, 66640, '\P{^is_Dsrt}', "");
    Error('\p{_ devanagari/a/}');
    Error('\P{_ devanagari/a/}');
    Expect(1, 43261, '\p{devanagari}', "");
    Expect(0, 43261, '\p{^devanagari}', "");
    Expect(0, 43261, '\P{devanagari}', "");
    Expect(1, 43261, '\P{^devanagari}', "");
    Expect(0, 43262, '\p{devanagari}', "");
    Expect(1, 43262, '\p{^devanagari}', "");
    Expect(1, 43262, '\P{devanagari}', "");
    Expect(0, 43262, '\P{^devanagari}', "");
    Expect(1, 43261, '\p{ 	DEVANAGARI}', "");
    Expect(0, 43261, '\p{^ 	DEVANAGARI}', "");
    Expect(0, 43261, '\P{ 	DEVANAGARI}', "");
    Expect(1, 43261, '\P{^ 	DEVANAGARI}', "");
    Expect(0, 43262, '\p{ 	DEVANAGARI}', "");
    Expect(1, 43262, '\p{^ 	DEVANAGARI}', "");
    Expect(1, 43262, '\P{ 	DEVANAGARI}', "");
    Expect(0, 43262, '\P{^ 	DEVANAGARI}', "");
    Error('\p{-/a/is_DEVANAGARI}');
    Error('\P{-/a/is_DEVANAGARI}');
    Expect(1, 43261, '\p{isdevanagari}', "");
    Expect(0, 43261, '\p{^isdevanagari}', "");
    Expect(0, 43261, '\P{isdevanagari}', "");
    Expect(1, 43261, '\P{^isdevanagari}', "");
    Expect(0, 43262, '\p{isdevanagari}', "");
    Expect(1, 43262, '\p{^isdevanagari}', "");
    Expect(1, 43262, '\P{isdevanagari}', "");
    Expect(0, 43262, '\P{^isdevanagari}', "");
    Expect(1, 43261, '\p{-Is_Devanagari}', "");
    Expect(0, 43261, '\p{^-Is_Devanagari}', "");
    Expect(0, 43261, '\P{-Is_Devanagari}', "");
    Expect(1, 43261, '\P{^-Is_Devanagari}', "");
    Expect(0, 43262, '\p{-Is_Devanagari}', "");
    Expect(1, 43262, '\p{^-Is_Devanagari}', "");
    Expect(1, 43262, '\P{-Is_Devanagari}', "");
    Expect(0, 43262, '\P{^-Is_Devanagari}', "");
    Error('\p{- deva:=}');
    Error('\P{- deva:=}');
    Expect(1, 43261, '\p{deva}', "");
    Expect(0, 43261, '\p{^deva}', "");
    Expect(0, 43261, '\P{deva}', "");
    Expect(1, 43261, '\P{^deva}', "");
    Expect(0, 43262, '\p{deva}', "");
    Expect(1, 43262, '\p{^deva}', "");
    Expect(1, 43262, '\P{deva}', "");
    Expect(0, 43262, '\P{^deva}', "");
    Expect(1, 43261, '\p{	_Deva}', "");
    Expect(0, 43261, '\p{^	_Deva}', "");
    Expect(0, 43261, '\P{	_Deva}', "");
    Expect(1, 43261, '\P{^	_Deva}', "");
    Expect(0, 43262, '\p{	_Deva}', "");
    Expect(1, 43262, '\p{^	_Deva}', "");
    Expect(1, 43262, '\P{	_Deva}', "");
    Expect(0, 43262, '\P{^	_Deva}', "");
    Error('\p{_:=Is_Deva}');
    Error('\P{_:=Is_Deva}');
    Expect(1, 43261, '\p{isdeva}', "");
    Expect(0, 43261, '\p{^isdeva}', "");
    Expect(0, 43261, '\P{isdeva}', "");
    Expect(1, 43261, '\P{^isdeva}', "");
    Expect(0, 43262, '\p{isdeva}', "");
    Expect(1, 43262, '\p{^isdeva}', "");
    Expect(1, 43262, '\P{isdeva}', "");
    Expect(0, 43262, '\P{^isdeva}', "");
    Expect(1, 43261, '\p{ _IS_DEVA}', "");
    Expect(0, 43261, '\p{^ _IS_DEVA}', "");
    Expect(0, 43261, '\P{ _IS_DEVA}', "");
    Expect(1, 43261, '\P{^ _IS_DEVA}', "");
    Expect(0, 43262, '\p{ _IS_DEVA}', "");
    Expect(1, 43262, '\p{^ _IS_DEVA}', "");
    Expect(1, 43262, '\P{ _IS_DEVA}', "");
    Expect(0, 43262, '\P{^ _IS_DEVA}', "");
    Error('\p{/a/ Devanagari_extended}');
    Error('\P{/a/ Devanagari_extended}');
    Expect(1, 43263, '\p{devanagariextended}', "");
    Expect(0, 43263, '\p{^devanagariextended}', "");
    Expect(0, 43263, '\P{devanagariextended}', "");
    Expect(1, 43263, '\P{^devanagariextended}', "");
    Expect(0, 43264, '\p{devanagariextended}', "");
    Expect(1, 43264, '\p{^devanagariextended}', "");
    Expect(1, 43264, '\P{devanagariextended}', "");
    Expect(0, 43264, '\P{^devanagariextended}', "");
    Expect(1, 43263, '\p{_	devanagari_EXTENDED}', "");
    Expect(0, 43263, '\p{^_	devanagari_EXTENDED}', "");
    Expect(0, 43263, '\P{_	devanagari_EXTENDED}', "");
    Expect(1, 43263, '\P{^_	devanagari_EXTENDED}', "");
    Expect(0, 43264, '\p{_	devanagari_EXTENDED}', "");
    Expect(1, 43264, '\p{^_	devanagari_EXTENDED}', "");
    Expect(1, 43264, '\P{_	devanagari_EXTENDED}', "");
    Expect(0, 43264, '\P{^_	devanagari_EXTENDED}', "");
    Error('\p{:=	IS_Devanagari_EXTENDED}');
    Error('\P{:=	IS_Devanagari_EXTENDED}');
    Expect(1, 43263, '\p{isdevanagariextended}', "");
    Expect(0, 43263, '\p{^isdevanagariextended}', "");
    Expect(0, 43263, '\P{isdevanagariextended}', "");
    Expect(1, 43263, '\P{^isdevanagariextended}', "");
    Expect(0, 43264, '\p{isdevanagariextended}', "");
    Expect(1, 43264, '\p{^isdevanagariextended}', "");
    Expect(1, 43264, '\P{isdevanagariextended}', "");
    Expect(0, 43264, '\P{^isdevanagariextended}', "");
    Expect(1, 43263, '\p{_-IS_devanagari_extended}', "");
    Expect(0, 43263, '\p{^_-IS_devanagari_extended}', "");
    Expect(0, 43263, '\P{_-IS_devanagari_extended}', "");
    Expect(1, 43263, '\P{^_-IS_devanagari_extended}', "");
    Expect(0, 43264, '\p{_-IS_devanagari_extended}', "");
    Expect(1, 43264, '\p{^_-IS_devanagari_extended}', "");
    Expect(1, 43264, '\P{_-IS_devanagari_extended}', "");
    Expect(0, 43264, '\P{^_-IS_devanagari_extended}', "");
    Error('\p{-	In_devanagari_EXTENDED/a/}');
    Error('\P{-	In_devanagari_EXTENDED/a/}');
    Expect(1, 43263, '\p{indevanagariextended}', "");
    Expect(0, 43263, '\p{^indevanagariextended}', "");
    Expect(0, 43263, '\P{indevanagariextended}', "");
    Expect(1, 43263, '\P{^indevanagariextended}', "");
    Expect(0, 43264, '\p{indevanagariextended}', "");
    Expect(1, 43264, '\p{^indevanagariextended}', "");
    Expect(1, 43264, '\P{indevanagariextended}', "");
    Expect(0, 43264, '\P{^indevanagariextended}', "");
    Expect(1, 43263, '\p{-in_Devanagari_Extended}', "");
    Expect(0, 43263, '\p{^-in_Devanagari_Extended}', "");
    Expect(0, 43263, '\P{-in_Devanagari_Extended}', "");
    Expect(1, 43263, '\P{^-in_Devanagari_Extended}', "");
    Expect(0, 43264, '\p{-in_Devanagari_Extended}', "");
    Expect(1, 43264, '\p{^-in_Devanagari_Extended}', "");
    Expect(1, 43264, '\P{-in_Devanagari_Extended}', "");
    Expect(0, 43264, '\P{^-in_Devanagari_Extended}', "");
    Error('\p{/a/-	DEVANAGARI_EXT}');
    Error('\P{/a/-	DEVANAGARI_EXT}');
    Expect(1, 43263, '\p{devanagariext}', "");
    Expect(0, 43263, '\p{^devanagariext}', "");
    Expect(0, 43263, '\P{devanagariext}', "");
    Expect(1, 43263, '\P{^devanagariext}', "");
    Expect(0, 43264, '\p{devanagariext}', "");
    Expect(1, 43264, '\p{^devanagariext}', "");
    Expect(1, 43264, '\P{devanagariext}', "");
    Expect(0, 43264, '\P{^devanagariext}', "");
    Expect(1, 43263, '\p{--DEVANAGARI_EXT}', "");
    Expect(0, 43263, '\p{^--DEVANAGARI_EXT}', "");
    Expect(0, 43263, '\P{--DEVANAGARI_EXT}', "");
    Expect(1, 43263, '\P{^--DEVANAGARI_EXT}', "");
    Expect(0, 43264, '\p{--DEVANAGARI_EXT}', "");
    Expect(1, 43264, '\p{^--DEVANAGARI_EXT}', "");
    Expect(1, 43264, '\P{--DEVANAGARI_EXT}', "");
    Expect(0, 43264, '\P{^--DEVANAGARI_EXT}', "");
    Error('\p{/a/IS_devanagari_EXT}');
    Error('\P{/a/IS_devanagari_EXT}');
    Expect(1, 43263, '\p{isdevanagariext}', "");
    Expect(0, 43263, '\p{^isdevanagariext}', "");
    Expect(0, 43263, '\P{isdevanagariext}', "");
    Expect(1, 43263, '\P{^isdevanagariext}', "");
    Expect(0, 43264, '\p{isdevanagariext}', "");
    Expect(1, 43264, '\p{^isdevanagariext}', "");
    Expect(1, 43264, '\P{isdevanagariext}', "");
    Expect(0, 43264, '\P{^isdevanagariext}', "");
    Expect(1, 43263, '\p{_-is_Devanagari_Ext}', "");
    Expect(0, 43263, '\p{^_-is_Devanagari_Ext}', "");
    Expect(0, 43263, '\P{_-is_Devanagari_Ext}', "");
    Expect(1, 43263, '\P{^_-is_Devanagari_Ext}', "");
    Expect(0, 43264, '\p{_-is_Devanagari_Ext}', "");
    Expect(1, 43264, '\p{^_-is_Devanagari_Ext}', "");
    Expect(1, 43264, '\P{_-is_Devanagari_Ext}', "");
    Expect(0, 43264, '\P{^_-is_Devanagari_Ext}', "");
    Error('\p{:=-IN_Devanagari_Ext}');
    Error('\P{:=-IN_Devanagari_Ext}');
    Expect(1, 43263, '\p{indevanagariext}', "");
    Expect(0, 43263, '\p{^indevanagariext}', "");
    Expect(0, 43263, '\P{indevanagariext}', "");
    Expect(1, 43263, '\P{^indevanagariext}', "");
    Expect(0, 43264, '\p{indevanagariext}', "");
    Expect(1, 43264, '\p{^indevanagariext}', "");
    Expect(1, 43264, '\P{indevanagariext}', "");
    Expect(0, 43264, '\P{^indevanagariext}', "");
    Expect(1, 43263, '\p{	-in_Devanagari_ext}', "");
    Expect(0, 43263, '\p{^	-in_Devanagari_ext}', "");
    Expect(0, 43263, '\P{	-in_Devanagari_ext}', "");
    Expect(1, 43263, '\P{^	-in_Devanagari_ext}', "");
    Expect(0, 43264, '\p{	-in_Devanagari_ext}', "");
    Expect(1, 43264, '\p{^	-in_Devanagari_ext}', "");
    Expect(1, 43264, '\P{	-in_Devanagari_ext}', "");
    Expect(0, 43264, '\P{^	-in_Devanagari_ext}', "");
    Error('\p{ /a/Diacritic}');
    Error('\P{ /a/Diacritic}');
    Expect(1, 125258, '\p{diacritic}', "");
    Expect(0, 125258, '\p{^diacritic}', "");
    Expect(0, 125258, '\P{diacritic}', "");
    Expect(1, 125258, '\P{^diacritic}', "");
    Expect(0, 125259, '\p{diacritic}', "");
    Expect(1, 125259, '\p{^diacritic}', "");
    Expect(1, 125259, '\P{diacritic}', "");
    Expect(0, 125259, '\P{^diacritic}', "");
    Expect(1, 125258, '\p{_diacritic}', "");
    Expect(0, 125258, '\p{^_diacritic}', "");
    Expect(0, 125258, '\P{_diacritic}', "");
    Expect(1, 125258, '\P{^_diacritic}', "");
    Expect(0, 125259, '\p{_diacritic}', "");
    Expect(1, 125259, '\p{^_diacritic}', "");
    Expect(1, 125259, '\P{_diacritic}', "");
    Expect(0, 125259, '\P{^_diacritic}', "");
    Error('\p{-Is_DIACRITIC:=}');
    Error('\P{-Is_DIACRITIC:=}');
    Expect(1, 125258, '\p{isdiacritic}', "");
    Expect(0, 125258, '\p{^isdiacritic}', "");
    Expect(0, 125258, '\P{isdiacritic}', "");
    Expect(1, 125258, '\P{^isdiacritic}', "");
    Expect(0, 125259, '\p{isdiacritic}', "");
    Expect(1, 125259, '\p{^isdiacritic}', "");
    Expect(1, 125259, '\P{isdiacritic}', "");
    Expect(0, 125259, '\P{^isdiacritic}', "");
    Expect(1, 125258, '\p{_is_diacritic}', "");
    Expect(0, 125258, '\p{^_is_diacritic}', "");
    Expect(0, 125258, '\P{_is_diacritic}', "");
    Expect(1, 125258, '\P{^_is_diacritic}', "");
    Expect(0, 125259, '\p{_is_diacritic}', "");
    Expect(1, 125259, '\p{^_is_diacritic}', "");
    Expect(1, 125259, '\P{_is_diacritic}', "");
    Expect(0, 125259, '\P{^_is_diacritic}', "");
    Error('\p{	DIA:=}');
    Error('\P{	DIA:=}');
    Expect(1, 125258, '\p{dia}', "");
    Expect(0, 125258, '\p{^dia}', "");
    Expect(0, 125258, '\P{dia}', "");
    Expect(1, 125258, '\P{^dia}', "");
    Expect(0, 125259, '\p{dia}', "");
    Expect(1, 125259, '\p{^dia}', "");
    Expect(1, 125259, '\P{dia}', "");
    Expect(0, 125259, '\P{^dia}', "");
    Expect(1, 125258, '\p{ Dia}', "");
    Expect(0, 125258, '\p{^ Dia}', "");
    Expect(0, 125258, '\P{ Dia}', "");
    Expect(1, 125258, '\P{^ Dia}', "");
    Expect(0, 125259, '\p{ Dia}', "");
    Expect(1, 125259, '\p{^ Dia}', "");
    Expect(1, 125259, '\P{ Dia}', "");
    Expect(0, 125259, '\P{^ Dia}', "");
    Error('\p{	/a/Is_Dia}');
    Error('\P{	/a/Is_Dia}');
    Expect(1, 125258, '\p{isdia}', "");
    Expect(0, 125258, '\p{^isdia}', "");
    Expect(0, 125258, '\P{isdia}', "");
    Expect(1, 125258, '\P{^isdia}', "");
    Expect(0, 125259, '\p{isdia}', "");
    Expect(1, 125259, '\p{^isdia}', "");
    Expect(1, 125259, '\P{isdia}', "");
    Expect(0, 125259, '\P{^isdia}', "");
    Expect(1, 125258, '\p{ Is_DIA}', "");
    Expect(0, 125258, '\p{^ Is_DIA}', "");
    Expect(0, 125258, '\P{ Is_DIA}', "");
    Expect(1, 125258, '\P{^ Is_DIA}', "");
    Expect(0, 125259, '\p{ Is_DIA}', "");
    Expect(1, 125259, '\p{^ Is_DIA}', "");
    Expect(1, 125259, '\P{ Is_DIA}', "");
    Expect(0, 125259, '\P{^ Is_DIA}', "");
    Error('\p{/a/	xposixdigit}');
    Error('\P{/a/	xposixdigit}');
    Expect(1, 125273, '\p{xposixdigit}', "");
    Expect(0, 125273, '\p{^xposixdigit}', "");
    Expect(0, 125273, '\P{xposixdigit}', "");
    Expect(1, 125273, '\P{^xposixdigit}', "");
    Expect(0, 125274, '\p{xposixdigit}', "");
    Expect(1, 125274, '\p{^xposixdigit}', "");
    Expect(1, 125274, '\P{xposixdigit}', "");
    Expect(0, 125274, '\P{^xposixdigit}', "");
    Expect(1, 125273, '\p{XPosixDigit}', "");
    Expect(0, 125273, '\p{^XPosixDigit}', "");
    Expect(0, 125273, '\P{XPosixDigit}', "");
    Expect(1, 125273, '\P{^XPosixDigit}', "");
    Expect(0, 125274, '\p{XPosixDigit}', "");
    Expect(1, 125274, '\p{^XPosixDigit}', "");
    Expect(1, 125274, '\P{XPosixDigit}', "");
    Expect(0, 125274, '\P{^XPosixDigit}', "");
    Error('\p{	DIGIT:=}');
    Error('\P{	DIGIT:=}');
    Expect(1, 125273, '\p{digit}', "");
    Expect(0, 125273, '\p{^digit}', "");
    Expect(0, 125273, '\P{digit}', "");
    Expect(1, 125273, '\P{^digit}', "");
    Expect(0, 125274, '\p{digit}', "");
    Expect(1, 125274, '\p{^digit}', "");
    Expect(1, 125274, '\P{digit}', "");
    Expect(0, 125274, '\P{^digit}', "");
    Expect(1, 125273, '\p{	_DIGIT}', "");
    Expect(0, 125273, '\p{^	_DIGIT}', "");
    Expect(0, 125273, '\P{	_DIGIT}', "");
    Expect(1, 125273, '\P{^	_DIGIT}', "");
    Expect(0, 125274, '\p{	_DIGIT}', "");
    Expect(1, 125274, '\p{^	_DIGIT}', "");
    Expect(1, 125274, '\P{	_DIGIT}', "");
    Expect(0, 125274, '\P{^	_DIGIT}', "");
    Error('\p{_	Is_xposixdigit:=}');
    Error('\P{_	Is_xposixdigit:=}');
    Expect(1, 125273, '\p{isxposixdigit}', "");
    Expect(0, 125273, '\p{^isxposixdigit}', "");
    Expect(0, 125273, '\P{isxposixdigit}', "");
    Expect(1, 125273, '\P{^isxposixdigit}', "");
    Expect(0, 125274, '\p{isxposixdigit}', "");
    Expect(1, 125274, '\p{^isxposixdigit}', "");
    Expect(1, 125274, '\P{isxposixdigit}', "");
    Expect(0, 125274, '\P{^isxposixdigit}', "");
    Expect(1, 125273, '\p{_Is_XPosixDigit}', "");
    Expect(0, 125273, '\p{^_Is_XPosixDigit}', "");
    Expect(0, 125273, '\P{_Is_XPosixDigit}', "");
    Expect(1, 125273, '\P{^_Is_XPosixDigit}', "");
    Expect(0, 125274, '\p{_Is_XPosixDigit}', "");
    Expect(1, 125274, '\p{^_Is_XPosixDigit}', "");
    Expect(1, 125274, '\P{_Is_XPosixDigit}', "");
    Expect(0, 125274, '\P{^_Is_XPosixDigit}', "");
    Error('\p{-	Is_Digit/a/}');
    Error('\P{-	Is_Digit/a/}');
    Expect(1, 125273, '\p{isdigit}', "");
    Expect(0, 125273, '\p{^isdigit}', "");
    Expect(0, 125273, '\P{isdigit}', "");
    Expect(1, 125273, '\P{^isdigit}', "");
    Expect(0, 125274, '\p{isdigit}', "");
    Expect(1, 125274, '\p{^isdigit}', "");
    Expect(1, 125274, '\P{isdigit}', "");
    Expect(0, 125274, '\P{^isdigit}', "");
    Expect(1, 125273, '\p{Is_Digit}', "");
    Expect(0, 125273, '\p{^Is_Digit}', "");
    Expect(0, 125273, '\P{Is_Digit}', "");
    Expect(1, 125273, '\P{^Is_Digit}', "");
    Expect(0, 125274, '\p{Is_Digit}', "");
    Expect(1, 125274, '\p{^Is_Digit}', "");
    Expect(1, 125274, '\P{Is_Digit}', "");
    Expect(0, 125274, '\P{^Is_Digit}', "");
    Error('\p{-DECIMAL_number/a/}');
    Error('\P{-DECIMAL_number/a/}');
    Expect(1, 125273, '\p{decimalnumber}', "");
    Expect(0, 125273, '\p{^decimalnumber}', "");
    Expect(0, 125273, '\P{decimalnumber}', "");
    Expect(1, 125273, '\P{^decimalnumber}', "");
    Expect(0, 125274, '\p{decimalnumber}', "");
    Expect(1, 125274, '\p{^decimalnumber}', "");
    Expect(1, 125274, '\P{decimalnumber}', "");
    Expect(0, 125274, '\P{^decimalnumber}', "");
    Expect(1, 125273, '\p{-	decimal_Number}', "");
    Expect(0, 125273, '\p{^-	decimal_Number}', "");
    Expect(0, 125273, '\P{-	decimal_Number}', "");
    Expect(1, 125273, '\P{^-	decimal_Number}', "");
    Expect(0, 125274, '\p{-	decimal_Number}', "");
    Expect(1, 125274, '\p{^-	decimal_Number}', "");
    Expect(1, 125274, '\P{-	decimal_Number}', "");
    Expect(0, 125274, '\P{^-	decimal_Number}', "");
    Error('\p{_-is_decimal_NUMBER:=}');
    Error('\P{_-is_decimal_NUMBER:=}');
    Expect(1, 125273, '\p{isdecimalnumber}', "");
    Expect(0, 125273, '\p{^isdecimalnumber}', "");
    Expect(0, 125273, '\P{isdecimalnumber}', "");
    Expect(1, 125273, '\P{^isdecimalnumber}', "");
    Expect(0, 125274, '\p{isdecimalnumber}', "");
    Expect(1, 125274, '\p{^isdecimalnumber}', "");
    Expect(1, 125274, '\P{isdecimalnumber}', "");
    Expect(0, 125274, '\P{^isdecimalnumber}', "");
    Expect(1, 125273, '\p{		Is_decimal_Number}', "");
    Expect(0, 125273, '\p{^		Is_decimal_Number}', "");
    Expect(0, 125273, '\P{		Is_decimal_Number}', "");
    Expect(1, 125273, '\P{^		Is_decimal_Number}', "");
    Expect(0, 125274, '\p{		Is_decimal_Number}', "");
    Expect(1, 125274, '\p{^		Is_decimal_Number}', "");
    Expect(1, 125274, '\P{		Is_decimal_Number}', "");
    Expect(0, 125274, '\P{^		Is_decimal_Number}', "");
    Error('\p{/a/		Nd}');
    Error('\P{/a/		Nd}');
    Expect(1, 125273, '\p{nd}', "");
    Expect(0, 125273, '\p{^nd}', "");
    Expect(0, 125273, '\P{nd}', "");
    Expect(1, 125273, '\P{^nd}', "");
    Expect(0, 125274, '\p{nd}', "");
    Expect(1, 125274, '\p{^nd}', "");
    Expect(1, 125274, '\P{nd}', "");
    Expect(0, 125274, '\P{^nd}', "");
    Expect(1, 125273, '\p{_Nd}', "");
    Expect(0, 125273, '\p{^_Nd}', "");
    Expect(0, 125273, '\P{_Nd}', "");
    Expect(1, 125273, '\P{^_Nd}', "");
    Expect(0, 125274, '\p{_Nd}', "");
    Expect(1, 125274, '\p{^_Nd}', "");
    Expect(1, 125274, '\P{_Nd}', "");
    Expect(0, 125274, '\P{^_Nd}', "");
    Error('\p{:=		Is_ND}');
    Error('\P{:=		Is_ND}');
    Expect(1, 125273, '\p{isnd}', "");
    Expect(0, 125273, '\p{^isnd}', "");
    Expect(0, 125273, '\P{isnd}', "");
    Expect(1, 125273, '\P{^isnd}', "");
    Expect(0, 125274, '\p{isnd}', "");
    Expect(1, 125274, '\p{^isnd}', "");
    Expect(1, 125274, '\P{isnd}', "");
    Expect(0, 125274, '\P{^isnd}', "");
    Expect(1, 125273, '\p{	is_Nd}', "");
    Expect(0, 125273, '\p{^	is_Nd}', "");
    Expect(0, 125273, '\P{	is_Nd}', "");
    Expect(1, 125273, '\P{^	is_Nd}', "");
    Expect(0, 125274, '\p{	is_Nd}', "");
    Expect(1, 125274, '\p{^	is_Nd}', "");
    Expect(1, 125274, '\P{	is_Nd}', "");
    Expect(0, 125274, '\P{^	is_Nd}', "");
    Error('\p{/a/- dingbats}');
    Error('\P{/a/- dingbats}');
    Expect(1, 10175, '\p{dingbats}', "");
    Expect(0, 10175, '\p{^dingbats}', "");
    Expect(0, 10175, '\P{dingbats}', "");
    Expect(1, 10175, '\P{^dingbats}', "");
    Expect(0, 10176, '\p{dingbats}', "");
    Expect(1, 10176, '\p{^dingbats}', "");
    Expect(1, 10176, '\P{dingbats}', "");
    Expect(0, 10176, '\P{^dingbats}', "");
    Expect(1, 10175, '\p{		Dingbats}', "");
    Expect(0, 10175, '\p{^		Dingbats}', "");
    Expect(0, 10175, '\P{		Dingbats}', "");
    Expect(1, 10175, '\P{^		Dingbats}', "");
    Expect(0, 10176, '\p{		Dingbats}', "");
    Expect(1, 10176, '\p{^		Dingbats}', "");
    Expect(1, 10176, '\P{		Dingbats}', "");
    Expect(0, 10176, '\P{^		Dingbats}', "");
    Error('\p{/a/__IS_Dingbats}');
    Error('\P{/a/__IS_Dingbats}');
    Expect(1, 10175, '\p{isdingbats}', "");
    Expect(0, 10175, '\p{^isdingbats}', "");
    Expect(0, 10175, '\P{isdingbats}', "");
    Expect(1, 10175, '\P{^isdingbats}', "");
    Expect(0, 10176, '\p{isdingbats}', "");
    Expect(1, 10176, '\p{^isdingbats}', "");
    Expect(1, 10176, '\P{isdingbats}', "");
    Expect(0, 10176, '\P{^isdingbats}', "");
    Expect(1, 10175, '\p{-Is_DINGBATS}', "");
    Expect(0, 10175, '\p{^-Is_DINGBATS}', "");
    Expect(0, 10175, '\P{-Is_DINGBATS}', "");
    Expect(1, 10175, '\P{^-Is_DINGBATS}', "");
    Expect(0, 10176, '\p{-Is_DINGBATS}', "");
    Expect(1, 10176, '\p{^-Is_DINGBATS}', "");
    Expect(1, 10176, '\P{-Is_DINGBATS}', "");
    Expect(0, 10176, '\P{^-Is_DINGBATS}', "");
    Error('\p{  In_DINGBATS:=}');
    Error('\P{  In_DINGBATS:=}');
    Expect(1, 10175, '\p{indingbats}', "");
    Expect(0, 10175, '\p{^indingbats}', "");
    Expect(0, 10175, '\P{indingbats}', "");
    Expect(1, 10175, '\P{^indingbats}', "");
    Expect(0, 10176, '\p{indingbats}', "");
    Expect(1, 10176, '\p{^indingbats}', "");
    Expect(1, 10176, '\P{indingbats}', "");
    Expect(0, 10176, '\P{^indingbats}', "");
    Expect(1, 10175, '\p{-In_Dingbats}', "");
    Expect(0, 10175, '\p{^-In_Dingbats}', "");
    Expect(0, 10175, '\P{-In_Dingbats}', "");
    Expect(1, 10175, '\P{^-In_Dingbats}', "");
    Expect(0, 10176, '\p{-In_Dingbats}', "");
    Expect(1, 10176, '\p{^-In_Dingbats}', "");
    Expect(1, 10176, '\P{-In_Dingbats}', "");
    Expect(0, 10176, '\P{^-In_Dingbats}', "");
    Error('\p{:=	DOMINO_Tiles}');
    Error('\P{:=	DOMINO_Tiles}');
    Expect(1, 127135, '\p{dominotiles}', "");
    Expect(0, 127135, '\p{^dominotiles}', "");
    Expect(0, 127135, '\P{dominotiles}', "");
    Expect(1, 127135, '\P{^dominotiles}', "");
    Expect(0, 127136, '\p{dominotiles}', "");
    Expect(1, 127136, '\p{^dominotiles}', "");
    Expect(1, 127136, '\P{dominotiles}', "");
    Expect(0, 127136, '\P{^dominotiles}', "");
    Expect(1, 127135, '\p{-domino_Tiles}', "");
    Expect(0, 127135, '\p{^-domino_Tiles}', "");
    Expect(0, 127135, '\P{-domino_Tiles}', "");
    Expect(1, 127135, '\P{^-domino_Tiles}', "");
    Expect(0, 127136, '\p{-domino_Tiles}', "");
    Expect(1, 127136, '\p{^-domino_Tiles}', "");
    Expect(1, 127136, '\P{-domino_Tiles}', "");
    Expect(0, 127136, '\P{^-domino_Tiles}', "");
    Error('\p{/a/_is_DOMINO_TILES}');
    Error('\P{/a/_is_DOMINO_TILES}');
    Expect(1, 127135, '\p{isdominotiles}', "");
    Expect(0, 127135, '\p{^isdominotiles}', "");
    Expect(0, 127135, '\P{isdominotiles}', "");
    Expect(1, 127135, '\P{^isdominotiles}', "");
    Expect(0, 127136, '\p{isdominotiles}', "");
    Expect(1, 127136, '\p{^isdominotiles}', "");
    Expect(1, 127136, '\P{isdominotiles}', "");
    Expect(0, 127136, '\P{^isdominotiles}', "");
    Expect(1, 127135, '\p{	Is_Domino_TILES}', "");
    Expect(0, 127135, '\p{^	Is_Domino_TILES}', "");
    Expect(0, 127135, '\P{	Is_Domino_TILES}', "");
    Expect(1, 127135, '\P{^	Is_Domino_TILES}', "");
    Expect(0, 127136, '\p{	Is_Domino_TILES}', "");
    Expect(1, 127136, '\p{^	Is_Domino_TILES}', "");
    Expect(1, 127136, '\P{	Is_Domino_TILES}', "");
    Expect(0, 127136, '\P{^	Is_Domino_TILES}', "");
    Error('\p{:= in_Domino_tiles}');
    Error('\P{:= in_Domino_tiles}');
    Expect(1, 127135, '\p{indominotiles}', "");
    Expect(0, 127135, '\p{^indominotiles}', "");
    Expect(0, 127135, '\P{indominotiles}', "");
    Expect(1, 127135, '\P{^indominotiles}', "");
    Expect(0, 127136, '\p{indominotiles}', "");
    Expect(1, 127136, '\p{^indominotiles}', "");
    Expect(1, 127136, '\P{indominotiles}', "");
    Expect(0, 127136, '\P{^indominotiles}', "");
    Expect(1, 127135, '\p{	In_Domino_tiles}', "");
    Expect(0, 127135, '\p{^	In_Domino_tiles}', "");
    Expect(0, 127135, '\P{	In_Domino_tiles}', "");
    Expect(1, 127135, '\P{^	In_Domino_tiles}', "");
    Expect(0, 127136, '\p{	In_Domino_tiles}', "");
    Expect(1, 127136, '\p{^	In_Domino_tiles}', "");
    Expect(1, 127136, '\P{	In_Domino_tiles}', "");
    Expect(0, 127136, '\P{^	In_Domino_tiles}', "");
    Error('\p{--domino/a/}');
    Error('\P{--domino/a/}');
    Expect(1, 127135, '\p{domino}', "");
    Expect(0, 127135, '\p{^domino}', "");
    Expect(0, 127135, '\P{domino}', "");
    Expect(1, 127135, '\P{^domino}', "");
    Expect(0, 127136, '\p{domino}', "");
    Expect(1, 127136, '\p{^domino}', "");
    Expect(1, 127136, '\P{domino}', "");
    Expect(0, 127136, '\P{^domino}', "");
    Expect(1, 127135, '\p{_	Domino}', "");
    Expect(0, 127135, '\p{^_	Domino}', "");
    Expect(0, 127135, '\P{_	Domino}', "");
    Expect(1, 127135, '\P{^_	Domino}', "");
    Expect(0, 127136, '\p{_	Domino}', "");
    Expect(1, 127136, '\p{^_	Domino}', "");
    Expect(1, 127136, '\P{_	Domino}', "");
    Expect(0, 127136, '\P{^_	Domino}', "");
    Error('\p{:=is_domino}');
    Error('\P{:=is_domino}');
    Expect(1, 127135, '\p{isdomino}', "");
    Expect(0, 127135, '\p{^isdomino}', "");
    Expect(0, 127135, '\P{isdomino}', "");
    Expect(1, 127135, '\P{^isdomino}', "");
    Expect(0, 127136, '\p{isdomino}', "");
    Expect(1, 127136, '\p{^isdomino}', "");
    Expect(1, 127136, '\P{isdomino}', "");
    Expect(0, 127136, '\P{^isdomino}', "");
    Expect(1, 127135, '\p{ is_DOMINO}', "");
    Expect(0, 127135, '\p{^ is_DOMINO}', "");
    Expect(0, 127135, '\P{ is_DOMINO}', "");
    Expect(1, 127135, '\P{^ is_DOMINO}', "");
    Expect(0, 127136, '\p{ is_DOMINO}', "");
    Expect(1, 127136, '\p{^ is_DOMINO}', "");
    Expect(1, 127136, '\P{ is_DOMINO}', "");
    Expect(0, 127136, '\P{^ is_DOMINO}', "");
    Error('\p{:=_	IN_Domino}');
    Error('\P{:=_	IN_Domino}');
    Expect(1, 127135, '\p{indomino}', "");
    Expect(0, 127135, '\p{^indomino}', "");
    Expect(0, 127135, '\P{indomino}', "");
    Expect(1, 127135, '\P{^indomino}', "");
    Expect(0, 127136, '\p{indomino}', "");
    Expect(1, 127136, '\p{^indomino}', "");
    Expect(1, 127136, '\P{indomino}', "");
    Expect(0, 127136, '\P{^indomino}', "");
    Expect(1, 127135, '\p{_ In_Domino}', "");
    Expect(0, 127135, '\p{^_ In_Domino}', "");
    Expect(0, 127135, '\P{_ In_Domino}', "");
    Expect(1, 127135, '\P{^_ In_Domino}', "");
    Expect(0, 127136, '\p{_ In_Domino}', "");
    Expect(1, 127136, '\p{^_ In_Domino}', "");
    Expect(1, 127136, '\P{_ In_Domino}', "");
    Expect(0, 127136, '\P{^_ In_Domino}', "");
    Error('\p{_Duployan:=}');
    Error('\P{_Duployan:=}');
    Expect(1, 113827, '\p{duployan}', "");
    Expect(0, 113827, '\p{^duployan}', "");
    Expect(0, 113827, '\P{duployan}', "");
    Expect(1, 113827, '\P{^duployan}', "");
    Expect(0, 113828, '\p{duployan}', "");
    Expect(1, 113828, '\p{^duployan}', "");
    Expect(1, 113828, '\P{duployan}', "");
    Expect(0, 113828, '\P{^duployan}', "");
    Expect(1, 113827, '\p{	Duployan}', "");
    Expect(0, 113827, '\p{^	Duployan}', "");
    Expect(0, 113827, '\P{	Duployan}', "");
    Expect(1, 113827, '\P{^	Duployan}', "");
    Expect(0, 113828, '\p{	Duployan}', "");
    Expect(1, 113828, '\p{^	Duployan}', "");
    Expect(1, 113828, '\P{	Duployan}', "");
    Expect(0, 113828, '\P{^	Duployan}', "");
    Error('\p{:=-Is_DUPLOYAN}');
    Error('\P{:=-Is_DUPLOYAN}');
    Expect(1, 113827, '\p{isduployan}', "");
    Expect(0, 113827, '\p{^isduployan}', "");
    Expect(0, 113827, '\P{isduployan}', "");
    Expect(1, 113827, '\P{^isduployan}', "");
    Expect(0, 113828, '\p{isduployan}', "");
    Expect(1, 113828, '\p{^isduployan}', "");
    Expect(1, 113828, '\P{isduployan}', "");
    Expect(0, 113828, '\P{^isduployan}', "");
    Expect(1, 113827, '\p{_	Is_Duployan}', "");
    Expect(0, 113827, '\p{^_	Is_Duployan}', "");
    Expect(0, 113827, '\P{_	Is_Duployan}', "");
    Expect(1, 113827, '\P{^_	Is_Duployan}', "");
    Expect(0, 113828, '\p{_	Is_Duployan}', "");
    Expect(1, 113828, '\p{^_	Is_Duployan}', "");
    Expect(1, 113828, '\P{_	Is_Duployan}', "");
    Expect(0, 113828, '\P{^_	Is_Duployan}', "");
    Error('\p{ :=Dupl}');
    Error('\P{ :=Dupl}');
    Expect(1, 113827, '\p{dupl}', "");
    Expect(0, 113827, '\p{^dupl}', "");
    Expect(0, 113827, '\P{dupl}', "");
    Expect(1, 113827, '\P{^dupl}', "");
    Expect(0, 113828, '\p{dupl}', "");
    Expect(1, 113828, '\p{^dupl}', "");
    Expect(1, 113828, '\P{dupl}', "");
    Expect(0, 113828, '\P{^dupl}', "");
    Expect(1, 113827, '\p{ Dupl}', "");
    Expect(0, 113827, '\p{^ Dupl}', "");
    Expect(0, 113827, '\P{ Dupl}', "");
    Expect(1, 113827, '\P{^ Dupl}', "");
    Expect(0, 113828, '\p{ Dupl}', "");
    Expect(1, 113828, '\p{^ Dupl}', "");
    Expect(1, 113828, '\P{ Dupl}', "");
    Expect(0, 113828, '\P{^ Dupl}', "");
    Error('\p{-:=Is_dupl}');
    Error('\P{-:=Is_dupl}');
    Expect(1, 113827, '\p{isdupl}', "");
    Expect(0, 113827, '\p{^isdupl}', "");
    Expect(0, 113827, '\P{isdupl}', "");
    Expect(1, 113827, '\P{^isdupl}', "");
    Expect(0, 113828, '\p{isdupl}', "");
    Expect(1, 113828, '\p{^isdupl}', "");
    Expect(1, 113828, '\P{isdupl}', "");
    Expect(0, 113828, '\P{^isdupl}', "");
    Expect(1, 113827, '\p{_ IS_DUPL}', "");
    Expect(0, 113827, '\p{^_ IS_DUPL}', "");
    Expect(0, 113827, '\P{_ IS_DUPL}', "");
    Expect(1, 113827, '\P{^_ IS_DUPL}', "");
    Expect(0, 113828, '\p{_ IS_DUPL}', "");
    Expect(1, 113828, '\p{^_ IS_DUPL}', "");
    Expect(1, 113828, '\P{_ IS_DUPL}', "");
    Expect(0, 113828, '\P{^_ IS_DUPL}', "");
    Error('\p{_:=EARLY_DYNASTIC_CUNEIFORM}');
    Error('\P{_:=EARLY_DYNASTIC_CUNEIFORM}');
    Expect(1, 75087, '\p{earlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^earlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{earlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^earlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{earlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^earlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{earlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^earlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{-_Early_DYNASTIC_CUNEIFORM}', "");
    Expect(0, 75087, '\p{^-_Early_DYNASTIC_CUNEIFORM}', "");
    Expect(0, 75087, '\P{-_Early_DYNASTIC_CUNEIFORM}', "");
    Expect(1, 75087, '\P{^-_Early_DYNASTIC_CUNEIFORM}', "");
    Expect(0, 75088, '\p{-_Early_DYNASTIC_CUNEIFORM}', "");
    Expect(1, 75088, '\p{^-_Early_DYNASTIC_CUNEIFORM}', "");
    Expect(1, 75088, '\P{-_Early_DYNASTIC_CUNEIFORM}', "");
    Expect(0, 75088, '\P{^-_Early_DYNASTIC_CUNEIFORM}', "");
    Error('\p{		Is_Early_Dynastic_Cuneiform/a/}');
    Error('\P{		Is_Early_Dynastic_Cuneiform/a/}');
    Expect(1, 75087, '\p{isearlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^isearlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{isearlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^isearlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{isearlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^isearlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{isearlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^isearlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{-_IS_Early_Dynastic_cuneiform}', "");
    Expect(0, 75087, '\p{^-_IS_Early_Dynastic_cuneiform}', "");
    Expect(0, 75087, '\P{-_IS_Early_Dynastic_cuneiform}', "");
    Expect(1, 75087, '\P{^-_IS_Early_Dynastic_cuneiform}', "");
    Expect(0, 75088, '\p{-_IS_Early_Dynastic_cuneiform}', "");
    Expect(1, 75088, '\p{^-_IS_Early_Dynastic_cuneiform}', "");
    Expect(1, 75088, '\P{-_IS_Early_Dynastic_cuneiform}', "");
    Expect(0, 75088, '\P{^-_IS_Early_Dynastic_cuneiform}', "");
    Error('\p{/a/IN_EARLY_Dynastic_Cuneiform}');
    Error('\P{/a/IN_EARLY_Dynastic_Cuneiform}');
    Expect(1, 75087, '\p{inearlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^inearlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{inearlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^inearlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{inearlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^inearlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{inearlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^inearlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{		in_Early_Dynastic_cuneiform}', "");
    Expect(0, 75087, '\p{^		in_Early_Dynastic_cuneiform}', "");
    Expect(0, 75087, '\P{		in_Early_Dynastic_cuneiform}', "");
    Expect(1, 75087, '\P{^		in_Early_Dynastic_cuneiform}', "");
    Expect(0, 75088, '\p{		in_Early_Dynastic_cuneiform}', "");
    Expect(1, 75088, '\p{^		in_Early_Dynastic_cuneiform}', "");
    Expect(1, 75088, '\P{		in_Early_Dynastic_cuneiform}', "");
    Expect(0, 75088, '\P{^		in_Early_Dynastic_cuneiform}', "");
    Error('\p{-/a/Egyptian_Hieroglyphs}');
    Error('\P{-/a/Egyptian_Hieroglyphs}');
    Expect(1, 78894, '\p{egyptianhieroglyphs}', "");
    Expect(0, 78894, '\p{^egyptianhieroglyphs}', "");
    Expect(0, 78894, '\P{egyptianhieroglyphs}', "");
    Expect(1, 78894, '\P{^egyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{egyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{^egyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{egyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{^egyptianhieroglyphs}', "");
    Expect(1, 78894, '\p{	-Egyptian_Hieroglyphs}', "");
    Expect(0, 78894, '\p{^	-Egyptian_Hieroglyphs}', "");
    Expect(0, 78894, '\P{	-Egyptian_Hieroglyphs}', "");
    Expect(1, 78894, '\P{^	-Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\p{	-Egyptian_Hieroglyphs}', "");
    Expect(1, 78895, '\p{^	-Egyptian_Hieroglyphs}', "");
    Expect(1, 78895, '\P{	-Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\P{^	-Egyptian_Hieroglyphs}', "");
    Error('\p{_Is_egyptian_HIEROGLYPHS/a/}');
    Error('\P{_Is_egyptian_HIEROGLYPHS/a/}');
    Expect(1, 78894, '\p{isegyptianhieroglyphs}', "");
    Expect(0, 78894, '\p{^isegyptianhieroglyphs}', "");
    Expect(0, 78894, '\P{isegyptianhieroglyphs}', "");
    Expect(1, 78894, '\P{^isegyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{isegyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{^isegyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{isegyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{^isegyptianhieroglyphs}', "");
    Expect(1, 78894, '\p{-Is_EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78894, '\p{^-Is_EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78894, '\P{-Is_EGYPTIAN_Hieroglyphs}', "");
    Expect(1, 78894, '\P{^-Is_EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78895, '\p{-Is_EGYPTIAN_Hieroglyphs}', "");
    Expect(1, 78895, '\p{^-Is_EGYPTIAN_Hieroglyphs}', "");
    Expect(1, 78895, '\P{-Is_EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78895, '\P{^-Is_EGYPTIAN_Hieroglyphs}', "");
    Error('\p{	Egyp/a/}');
    Error('\P{	Egyp/a/}');
    Expect(1, 78894, '\p{egyp}', "");
    Expect(0, 78894, '\p{^egyp}', "");
    Expect(0, 78894, '\P{egyp}', "");
    Expect(1, 78894, '\P{^egyp}', "");
    Expect(0, 78895, '\p{egyp}', "");
    Expect(1, 78895, '\p{^egyp}', "");
    Expect(1, 78895, '\P{egyp}', "");
    Expect(0, 78895, '\P{^egyp}', "");
    Expect(1, 78894, '\p{ 	Egyp}', "");
    Expect(0, 78894, '\p{^ 	Egyp}', "");
    Expect(0, 78894, '\P{ 	Egyp}', "");
    Expect(1, 78894, '\P{^ 	Egyp}', "");
    Expect(0, 78895, '\p{ 	Egyp}', "");
    Expect(1, 78895, '\p{^ 	Egyp}', "");
    Expect(1, 78895, '\P{ 	Egyp}', "");
    Expect(0, 78895, '\P{^ 	Egyp}', "");
    Error('\p{:= is_Egyp}');
    Error('\P{:= is_Egyp}');
    Expect(1, 78894, '\p{isegyp}', "");
    Expect(0, 78894, '\p{^isegyp}', "");
    Expect(0, 78894, '\P{isegyp}', "");
    Expect(1, 78894, '\P{^isegyp}', "");
    Expect(0, 78895, '\p{isegyp}', "");
    Expect(1, 78895, '\p{^isegyp}', "");
    Expect(1, 78895, '\P{isegyp}', "");
    Expect(0, 78895, '\P{^isegyp}', "");
    Expect(1, 78894, '\p{ Is_Egyp}', "");
    Expect(0, 78894, '\p{^ Is_Egyp}', "");
    Expect(0, 78894, '\P{ Is_Egyp}', "");
    Expect(1, 78894, '\P{^ Is_Egyp}', "");
    Expect(0, 78895, '\p{ Is_Egyp}', "");
    Expect(1, 78895, '\p{^ Is_Egyp}', "");
    Expect(1, 78895, '\P{ Is_Egyp}', "");
    Expect(0, 78895, '\P{^ Is_Egyp}', "");
    Error('\p{/a/elbasan}');
    Error('\P{/a/elbasan}');
    Expect(1, 66855, '\p{elbasan}', "");
    Expect(0, 66855, '\p{^elbasan}', "");
    Expect(0, 66855, '\P{elbasan}', "");
    Expect(1, 66855, '\P{^elbasan}', "");
    Expect(0, 66856, '\p{elbasan}', "");
    Expect(1, 66856, '\p{^elbasan}', "");
    Expect(1, 66856, '\P{elbasan}', "");
    Expect(0, 66856, '\P{^elbasan}', "");
    Expect(1, 66855, '\p{-	Elbasan}', "");
    Expect(0, 66855, '\p{^-	Elbasan}', "");
    Expect(0, 66855, '\P{-	Elbasan}', "");
    Expect(1, 66855, '\P{^-	Elbasan}', "");
    Expect(0, 66856, '\p{-	Elbasan}', "");
    Expect(1, 66856, '\p{^-	Elbasan}', "");
    Expect(1, 66856, '\P{-	Elbasan}', "");
    Expect(0, 66856, '\P{^-	Elbasan}', "");
    Error('\p{/a/  is_elbasan}');
    Error('\P{/a/  is_elbasan}');
    Expect(1, 66855, '\p{iselbasan}', "");
    Expect(0, 66855, '\p{^iselbasan}', "");
    Expect(0, 66855, '\P{iselbasan}', "");
    Expect(1, 66855, '\P{^iselbasan}', "");
    Expect(0, 66856, '\p{iselbasan}', "");
    Expect(1, 66856, '\p{^iselbasan}', "");
    Expect(1, 66856, '\P{iselbasan}', "");
    Expect(0, 66856, '\P{^iselbasan}', "");
    Expect(1, 66855, '\p{ -Is_Elbasan}', "");
    Expect(0, 66855, '\p{^ -Is_Elbasan}', "");
    Expect(0, 66855, '\P{ -Is_Elbasan}', "");
    Expect(1, 66855, '\P{^ -Is_Elbasan}', "");
    Expect(0, 66856, '\p{ -Is_Elbasan}', "");
    Expect(1, 66856, '\p{^ -Is_Elbasan}', "");
    Expect(1, 66856, '\P{ -Is_Elbasan}', "");
    Expect(0, 66856, '\P{^ -Is_Elbasan}', "");
    Error('\p{ :=Elba}');
    Error('\P{ :=Elba}');
    Expect(1, 66855, '\p{elba}', "");
    Expect(0, 66855, '\p{^elba}', "");
    Expect(0, 66855, '\P{elba}', "");
    Expect(1, 66855, '\P{^elba}', "");
    Expect(0, 66856, '\p{elba}', "");
    Expect(1, 66856, '\p{^elba}', "");
    Expect(1, 66856, '\P{elba}', "");
    Expect(0, 66856, '\P{^elba}', "");
    Expect(1, 66855, '\p{  elba}', "");
    Expect(0, 66855, '\p{^  elba}', "");
    Expect(0, 66855, '\P{  elba}', "");
    Expect(1, 66855, '\P{^  elba}', "");
    Expect(0, 66856, '\p{  elba}', "");
    Expect(1, 66856, '\p{^  elba}', "");
    Expect(1, 66856, '\P{  elba}', "");
    Expect(0, 66856, '\P{^  elba}', "");
    Error('\p{	is_ELBA:=}');
    Error('\P{	is_ELBA:=}');
    Expect(1, 66855, '\p{iselba}', "");
    Expect(0, 66855, '\p{^iselba}', "");
    Expect(0, 66855, '\P{iselba}', "");
    Expect(1, 66855, '\P{^iselba}', "");
    Expect(0, 66856, '\p{iselba}', "");
    Expect(1, 66856, '\p{^iselba}', "");
    Expect(1, 66856, '\P{iselba}', "");
    Expect(0, 66856, '\P{^iselba}', "");
    Expect(1, 66855, '\p{	IS_ELBA}', "");
    Expect(0, 66855, '\p{^	IS_ELBA}', "");
    Expect(0, 66855, '\P{	IS_ELBA}', "");
    Expect(1, 66855, '\P{^	IS_ELBA}', "");
    Expect(0, 66856, '\p{	IS_ELBA}', "");
    Expect(1, 66856, '\p{^	IS_ELBA}', "");
    Expect(1, 66856, '\P{	IS_ELBA}', "");
    Expect(0, 66856, '\P{^	IS_ELBA}', "");
    Error('\p{_-Emoticons/a/}');
    Error('\P{_-Emoticons/a/}');
    Expect(1, 128591, '\p{emoticons}', "");
    Expect(0, 128591, '\p{^emoticons}', "");
    Expect(0, 128591, '\P{emoticons}', "");
    Expect(1, 128591, '\P{^emoticons}', "");
    Expect(0, 128592, '\p{emoticons}', "");
    Expect(1, 128592, '\p{^emoticons}', "");
    Expect(1, 128592, '\P{emoticons}', "");
    Expect(0, 128592, '\P{^emoticons}', "");
    Expect(1, 128591, '\p{--Emoticons}', "");
    Expect(0, 128591, '\p{^--Emoticons}', "");
    Expect(0, 128591, '\P{--Emoticons}', "");
    Expect(1, 128591, '\P{^--Emoticons}', "");
    Expect(0, 128592, '\p{--Emoticons}', "");
    Expect(1, 128592, '\p{^--Emoticons}', "");
    Expect(1, 128592, '\P{--Emoticons}', "");
    Expect(0, 128592, '\P{^--Emoticons}', "");
    Error('\p{/a/_IS_EMOTICONS}');
    Error('\P{/a/_IS_EMOTICONS}');
    Expect(1, 128591, '\p{isemoticons}', "");
    Expect(0, 128591, '\p{^isemoticons}', "");
    Expect(0, 128591, '\P{isemoticons}', "");
    Expect(1, 128591, '\P{^isemoticons}', "");
    Expect(0, 128592, '\p{isemoticons}', "");
    Expect(1, 128592, '\p{^isemoticons}', "");
    Expect(1, 128592, '\P{isemoticons}', "");
    Expect(0, 128592, '\P{^isemoticons}', "");
    Expect(1, 128591, '\p{-_Is_Emoticons}', "");
    Expect(0, 128591, '\p{^-_Is_Emoticons}', "");
    Expect(0, 128591, '\P{-_Is_Emoticons}', "");
    Expect(1, 128591, '\P{^-_Is_Emoticons}', "");
    Expect(0, 128592, '\p{-_Is_Emoticons}', "");
    Expect(1, 128592, '\p{^-_Is_Emoticons}', "");
    Expect(1, 128592, '\P{-_Is_Emoticons}', "");
    Expect(0, 128592, '\P{^-_Is_Emoticons}', "");
    Error('\p{_	IN_Emoticons:=}');
    Error('\P{_	IN_Emoticons:=}');
    Expect(1, 128591, '\p{inemoticons}', "");
    Expect(0, 128591, '\p{^inemoticons}', "");
    Expect(0, 128591, '\P{inemoticons}', "");
    Expect(1, 128591, '\P{^inemoticons}', "");
    Expect(0, 128592, '\p{inemoticons}', "");
    Expect(1, 128592, '\p{^inemoticons}', "");
    Expect(1, 128592, '\P{inemoticons}', "");
    Expect(0, 128592, '\P{^inemoticons}', "");
    Expect(1, 128591, '\p{ -In_emoticons}', "");
    Expect(0, 128591, '\p{^ -In_emoticons}', "");
    Expect(0, 128591, '\P{ -In_emoticons}', "");
    Expect(1, 128591, '\P{^ -In_emoticons}', "");
    Expect(0, 128592, '\p{ -In_emoticons}', "");
    Expect(1, 128592, '\p{^ -In_emoticons}', "");
    Expect(1, 128592, '\P{ -In_emoticons}', "");
    Expect(0, 128592, '\P{^ -In_emoticons}', "");
    Error('\p{_:=Enclosed_Alphanumeric_supplement}');
    Error('\P{_:=Enclosed_Alphanumeric_supplement}');
    Expect(1, 127487, '\p{enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\p{^enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\P{enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\P{^enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\p{enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\p{^enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\P{enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\P{^enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\p{-_ENCLOSED_Alphanumeric_Supplement}', "");
    Expect(0, 127487, '\p{^-_ENCLOSED_Alphanumeric_Supplement}', "");
    Expect(0, 127487, '\P{-_ENCLOSED_Alphanumeric_Supplement}', "");
    Expect(1, 127487, '\P{^-_ENCLOSED_Alphanumeric_Supplement}', "");
    Expect(0, 127488, '\p{-_ENCLOSED_Alphanumeric_Supplement}', "");
    Expect(1, 127488, '\p{^-_ENCLOSED_Alphanumeric_Supplement}', "");
    Expect(1, 127488, '\P{-_ENCLOSED_Alphanumeric_Supplement}', "");
    Expect(0, 127488, '\P{^-_ENCLOSED_Alphanumeric_Supplement}', "");
    Error('\p{:=_ is_enclosed_alphanumeric_Supplement}');
    Error('\P{:=_ is_enclosed_alphanumeric_Supplement}');
    Expect(1, 127487, '\p{isenclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\p{^isenclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\P{isenclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\P{^isenclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\p{isenclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\p{^isenclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\P{isenclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\P{^isenclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\p{ -Is_enclosed_alphanumeric_supplement}', "");
    Expect(0, 127487, '\p{^ -Is_enclosed_alphanumeric_supplement}', "");
    Expect(0, 127487, '\P{ -Is_enclosed_alphanumeric_supplement}', "");
    Expect(1, 127487, '\P{^ -Is_enclosed_alphanumeric_supplement}', "");
    Expect(0, 127488, '\p{ -Is_enclosed_alphanumeric_supplement}', "");
    Expect(1, 127488, '\p{^ -Is_enclosed_alphanumeric_supplement}', "");
    Expect(1, 127488, '\P{ -Is_enclosed_alphanumeric_supplement}', "");
    Expect(0, 127488, '\P{^ -Is_enclosed_alphanumeric_supplement}', "");
    Error('\p{-in_enclosed_Alphanumeric_Supplement:=}');
    Error('\P{-in_enclosed_Alphanumeric_Supplement:=}');
    Expect(1, 127487, '\p{inenclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\p{^inenclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\P{inenclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\P{^inenclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\p{inenclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\p{^inenclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\P{inenclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\P{^inenclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\p{--in_enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127487, '\p{^--in_enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127487, '\P{--in_enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(1, 127487, '\P{^--in_enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127488, '\p{--in_enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(1, 127488, '\p{^--in_enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(1, 127488, '\P{--in_enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127488, '\P{^--in_enclosed_Alphanumeric_SUPPLEMENT}', "");
    Error('\p{_ Enclosed_Alphanum_SUP/a/}');
    Error('\P{_ Enclosed_Alphanum_SUP/a/}');
    Expect(1, 127487, '\p{enclosedalphanumsup}', "");
    Expect(0, 127487, '\p{^enclosedalphanumsup}', "");
    Expect(0, 127487, '\P{enclosedalphanumsup}', "");
    Expect(1, 127487, '\P{^enclosedalphanumsup}', "");
    Expect(0, 127488, '\p{enclosedalphanumsup}', "");
    Expect(1, 127488, '\p{^enclosedalphanumsup}', "");
    Expect(1, 127488, '\P{enclosedalphanumsup}', "");
    Expect(0, 127488, '\P{^enclosedalphanumsup}', "");
    Expect(1, 127487, '\p{	-ENCLOSED_alphanum_Sup}', "");
    Expect(0, 127487, '\p{^	-ENCLOSED_alphanum_Sup}', "");
    Expect(0, 127487, '\P{	-ENCLOSED_alphanum_Sup}', "");
    Expect(1, 127487, '\P{^	-ENCLOSED_alphanum_Sup}', "");
    Expect(0, 127488, '\p{	-ENCLOSED_alphanum_Sup}', "");
    Expect(1, 127488, '\p{^	-ENCLOSED_alphanum_Sup}', "");
    Expect(1, 127488, '\P{	-ENCLOSED_alphanum_Sup}', "");
    Expect(0, 127488, '\P{^	-ENCLOSED_alphanum_Sup}', "");
    Error('\p{:=Is_Enclosed_Alphanum_SUP}');
    Error('\P{:=Is_Enclosed_Alphanum_SUP}');
    Expect(1, 127487, '\p{isenclosedalphanumsup}', "");
    Expect(0, 127487, '\p{^isenclosedalphanumsup}', "");
    Expect(0, 127487, '\P{isenclosedalphanumsup}', "");
    Expect(1, 127487, '\P{^isenclosedalphanumsup}', "");
    Expect(0, 127488, '\p{isenclosedalphanumsup}', "");
    Expect(1, 127488, '\p{^isenclosedalphanumsup}', "");
    Expect(1, 127488, '\P{isenclosedalphanumsup}', "");
    Expect(0, 127488, '\P{^isenclosedalphanumsup}', "");
    Expect(1, 127487, '\p{	-IS_ENCLOSED_Alphanum_sup}', "");
    Expect(0, 127487, '\p{^	-IS_ENCLOSED_Alphanum_sup}', "");
    Expect(0, 127487, '\P{	-IS_ENCLOSED_Alphanum_sup}', "");
    Expect(1, 127487, '\P{^	-IS_ENCLOSED_Alphanum_sup}', "");
    Expect(0, 127488, '\p{	-IS_ENCLOSED_Alphanum_sup}', "");
    Expect(1, 127488, '\p{^	-IS_ENCLOSED_Alphanum_sup}', "");
    Expect(1, 127488, '\P{	-IS_ENCLOSED_Alphanum_sup}', "");
    Expect(0, 127488, '\P{^	-IS_ENCLOSED_Alphanum_sup}', "");
    Error('\p{/a/ IN_enclosed_alphanum_Sup}');
    Error('\P{/a/ IN_enclosed_alphanum_Sup}');
    Expect(1, 127487, '\p{inenclosedalphanumsup}', "");
    Expect(0, 127487, '\p{^inenclosedalphanumsup}', "");
    Expect(0, 127487, '\P{inenclosedalphanumsup}', "");
    Expect(1, 127487, '\P{^inenclosedalphanumsup}', "");
    Expect(0, 127488, '\p{inenclosedalphanumsup}', "");
    Expect(1, 127488, '\p{^inenclosedalphanumsup}', "");
    Expect(1, 127488, '\P{inenclosedalphanumsup}', "");
    Expect(0, 127488, '\P{^inenclosedalphanumsup}', "");
    Expect(1, 127487, '\p{ 	in_ENCLOSED_ALPHANUM_Sup}', "");
    Expect(0, 127487, '\p{^ 	in_ENCLOSED_ALPHANUM_Sup}', "");
    Expect(0, 127487, '\P{ 	in_ENCLOSED_ALPHANUM_Sup}', "");
    Expect(1, 127487, '\P{^ 	in_ENCLOSED_ALPHANUM_Sup}', "");
    Expect(0, 127488, '\p{ 	in_ENCLOSED_ALPHANUM_Sup}', "");
    Expect(1, 127488, '\p{^ 	in_ENCLOSED_ALPHANUM_Sup}', "");
    Expect(1, 127488, '\P{ 	in_ENCLOSED_ALPHANUM_Sup}', "");
    Expect(0, 127488, '\P{^ 	in_ENCLOSED_ALPHANUM_Sup}', "");
    Error('\p{	-ENCLOSED_Alphanumerics/a/}');
    Error('\P{	-ENCLOSED_Alphanumerics/a/}');
    Expect(1, 9471, '\p{enclosedalphanumerics}', "");
    Expect(0, 9471, '\p{^enclosedalphanumerics}', "");
    Expect(0, 9471, '\P{enclosedalphanumerics}', "");
    Expect(1, 9471, '\P{^enclosedalphanumerics}', "");
    Expect(0, 9472, '\p{enclosedalphanumerics}', "");
    Expect(1, 9472, '\p{^enclosedalphanumerics}', "");
    Expect(1, 9472, '\P{enclosedalphanumerics}', "");
    Expect(0, 9472, '\P{^enclosedalphanumerics}', "");
    Expect(1, 9471, '\p{	-enclosed_alphanumerics}', "");
    Expect(0, 9471, '\p{^	-enclosed_alphanumerics}', "");
    Expect(0, 9471, '\P{	-enclosed_alphanumerics}', "");
    Expect(1, 9471, '\P{^	-enclosed_alphanumerics}', "");
    Expect(0, 9472, '\p{	-enclosed_alphanumerics}', "");
    Expect(1, 9472, '\p{^	-enclosed_alphanumerics}', "");
    Expect(1, 9472, '\P{	-enclosed_alphanumerics}', "");
    Expect(0, 9472, '\P{^	-enclosed_alphanumerics}', "");
    Error('\p{	:=is_Enclosed_Alphanumerics}');
    Error('\P{	:=is_Enclosed_Alphanumerics}');
    Expect(1, 9471, '\p{isenclosedalphanumerics}', "");
    Expect(0, 9471, '\p{^isenclosedalphanumerics}', "");
    Expect(0, 9471, '\P{isenclosedalphanumerics}', "");
    Expect(1, 9471, '\P{^isenclosedalphanumerics}', "");
    Expect(0, 9472, '\p{isenclosedalphanumerics}', "");
    Expect(1, 9472, '\p{^isenclosedalphanumerics}', "");
    Expect(1, 9472, '\P{isenclosedalphanumerics}', "");
    Expect(0, 9472, '\P{^isenclosedalphanumerics}', "");
    Expect(1, 9471, '\p{	 IS_Enclosed_ALPHANUMERICS}', "");
    Expect(0, 9471, '\p{^	 IS_Enclosed_ALPHANUMERICS}', "");
    Expect(0, 9471, '\P{	 IS_Enclosed_ALPHANUMERICS}', "");
    Expect(1, 9471, '\P{^	 IS_Enclosed_ALPHANUMERICS}', "");
    Expect(0, 9472, '\p{	 IS_Enclosed_ALPHANUMERICS}', "");
    Expect(1, 9472, '\p{^	 IS_Enclosed_ALPHANUMERICS}', "");
    Expect(1, 9472, '\P{	 IS_Enclosed_ALPHANUMERICS}', "");
    Expect(0, 9472, '\P{^	 IS_Enclosed_ALPHANUMERICS}', "");
    Error('\p{/a/IN_Enclosed_Alphanumerics}');
    Error('\P{/a/IN_Enclosed_Alphanumerics}');
    Expect(1, 9471, '\p{inenclosedalphanumerics}', "");
    Expect(0, 9471, '\p{^inenclosedalphanumerics}', "");
    Expect(0, 9471, '\P{inenclosedalphanumerics}', "");
    Expect(1, 9471, '\P{^inenclosedalphanumerics}', "");
    Expect(0, 9472, '\p{inenclosedalphanumerics}', "");
    Expect(1, 9472, '\p{^inenclosedalphanumerics}', "");
    Expect(1, 9472, '\P{inenclosedalphanumerics}', "");
    Expect(0, 9472, '\P{^inenclosedalphanumerics}', "");
    Expect(1, 9471, '\p{ _In_enclosed_alphanumerics}', "");
    Expect(0, 9471, '\p{^ _In_enclosed_alphanumerics}', "");
    Expect(0, 9471, '\P{ _In_enclosed_alphanumerics}', "");
    Expect(1, 9471, '\P{^ _In_enclosed_alphanumerics}', "");
    Expect(0, 9472, '\p{ _In_enclosed_alphanumerics}', "");
    Expect(1, 9472, '\p{^ _In_enclosed_alphanumerics}', "");
    Expect(1, 9472, '\P{ _In_enclosed_alphanumerics}', "");
    Expect(0, 9472, '\P{^ _In_enclosed_alphanumerics}', "");
    Error('\p{_:=enclosed_Alphanum}');
    Error('\P{_:=enclosed_Alphanum}');
    Expect(1, 9471, '\p{enclosedalphanum}', "");
    Expect(0, 9471, '\p{^enclosedalphanum}', "");
    Expect(0, 9471, '\P{enclosedalphanum}', "");
    Expect(1, 9471, '\P{^enclosedalphanum}', "");
    Expect(0, 9472, '\p{enclosedalphanum}', "");
    Expect(1, 9472, '\p{^enclosedalphanum}', "");
    Expect(1, 9472, '\P{enclosedalphanum}', "");
    Expect(0, 9472, '\P{^enclosedalphanum}', "");
    Expect(1, 9471, '\p{__enclosed_Alphanum}', "");
    Expect(0, 9471, '\p{^__enclosed_Alphanum}', "");
    Expect(0, 9471, '\P{__enclosed_Alphanum}', "");
    Expect(1, 9471, '\P{^__enclosed_Alphanum}', "");
    Expect(0, 9472, '\p{__enclosed_Alphanum}', "");
    Expect(1, 9472, '\p{^__enclosed_Alphanum}', "");
    Expect(1, 9472, '\P{__enclosed_Alphanum}', "");
    Expect(0, 9472, '\P{^__enclosed_Alphanum}', "");
    Error('\p{:=	_Is_enclosed_ALPHANUM}');
    Error('\P{:=	_Is_enclosed_ALPHANUM}');
    Expect(1, 9471, '\p{isenclosedalphanum}', "");
    Expect(0, 9471, '\p{^isenclosedalphanum}', "");
    Expect(0, 9471, '\P{isenclosedalphanum}', "");
    Expect(1, 9471, '\P{^isenclosedalphanum}', "");
    Expect(0, 9472, '\p{isenclosedalphanum}', "");
    Expect(1, 9472, '\p{^isenclosedalphanum}', "");
    Expect(1, 9472, '\P{isenclosedalphanum}', "");
    Expect(0, 9472, '\P{^isenclosedalphanum}', "");
    Expect(1, 9471, '\p{--is_Enclosed_ALPHANUM}', "");
    Expect(0, 9471, '\p{^--is_Enclosed_ALPHANUM}', "");
    Expect(0, 9471, '\P{--is_Enclosed_ALPHANUM}', "");
    Expect(1, 9471, '\P{^--is_Enclosed_ALPHANUM}', "");
    Expect(0, 9472, '\p{--is_Enclosed_ALPHANUM}', "");
    Expect(1, 9472, '\p{^--is_Enclosed_ALPHANUM}', "");
    Expect(1, 9472, '\P{--is_Enclosed_ALPHANUM}', "");
    Expect(0, 9472, '\P{^--is_Enclosed_ALPHANUM}', "");
    Error('\p{	_in_enclosed_Alphanum:=}');
    Error('\P{	_in_enclosed_Alphanum:=}');
    Expect(1, 9471, '\p{inenclosedalphanum}', "");
    Expect(0, 9471, '\p{^inenclosedalphanum}', "");
    Expect(0, 9471, '\P{inenclosedalphanum}', "");
    Expect(1, 9471, '\P{^inenclosedalphanum}', "");
    Expect(0, 9472, '\p{inenclosedalphanum}', "");
    Expect(1, 9472, '\p{^inenclosedalphanum}', "");
    Expect(1, 9472, '\P{inenclosedalphanum}', "");
    Expect(0, 9472, '\P{^inenclosedalphanum}', "");
    Expect(1, 9471, '\p{-	In_enclosed_Alphanum}', "");
    Expect(0, 9471, '\p{^-	In_enclosed_Alphanum}', "");
    Expect(0, 9471, '\P{-	In_enclosed_Alphanum}', "");
    Expect(1, 9471, '\P{^-	In_enclosed_Alphanum}', "");
    Expect(0, 9472, '\p{-	In_enclosed_Alphanum}', "");
    Expect(1, 9472, '\p{^-	In_enclosed_Alphanum}', "");
    Expect(1, 9472, '\P{-	In_enclosed_Alphanum}', "");
    Expect(0, 9472, '\P{^-	In_enclosed_Alphanum}', "");
    Error('\p{:=-	enclosed_CJK_LETTERS_And_Months}');
    Error('\P{:=-	enclosed_CJK_LETTERS_And_Months}');
    Expect(1, 13055, '\p{enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\p{^enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\P{enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\P{^enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\p{enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\p{^enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\P{enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\P{^enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\p{ 	Enclosed_CJK_Letters_And_Months}', "");
    Expect(0, 13055, '\p{^ 	Enclosed_CJK_Letters_And_Months}', "");
    Expect(0, 13055, '\P{ 	Enclosed_CJK_Letters_And_Months}', "");
    Expect(1, 13055, '\P{^ 	Enclosed_CJK_Letters_And_Months}', "");
    Expect(0, 13056, '\p{ 	Enclosed_CJK_Letters_And_Months}', "");
    Expect(1, 13056, '\p{^ 	Enclosed_CJK_Letters_And_Months}', "");
    Expect(1, 13056, '\P{ 	Enclosed_CJK_Letters_And_Months}', "");
    Expect(0, 13056, '\P{^ 	Enclosed_CJK_Letters_And_Months}', "");
    Error('\p{-Is_ENCLOSED_CJK_LETTERS_And_MONTHS/a/}');
    Error('\P{-Is_ENCLOSED_CJK_LETTERS_And_MONTHS/a/}');
    Expect(1, 13055, '\p{isenclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\p{^isenclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\P{isenclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\P{^isenclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\p{isenclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\p{^isenclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\P{isenclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\P{^isenclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\p{	 Is_Enclosed_CJK_letters_And_Months}', "");
    Expect(0, 13055, '\p{^	 Is_Enclosed_CJK_letters_And_Months}', "");
    Expect(0, 13055, '\P{	 Is_Enclosed_CJK_letters_And_Months}', "");
    Expect(1, 13055, '\P{^	 Is_Enclosed_CJK_letters_And_Months}', "");
    Expect(0, 13056, '\p{	 Is_Enclosed_CJK_letters_And_Months}', "");
    Expect(1, 13056, '\p{^	 Is_Enclosed_CJK_letters_And_Months}', "");
    Expect(1, 13056, '\P{	 Is_Enclosed_CJK_letters_And_Months}', "");
    Expect(0, 13056, '\P{^	 Is_Enclosed_CJK_letters_And_Months}', "");
    Error('\p{_ IN_Enclosed_CJK_letters_and_months/a/}');
    Error('\P{_ IN_Enclosed_CJK_letters_and_months/a/}');
    Expect(1, 13055, '\p{inenclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\p{^inenclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\P{inenclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\P{^inenclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\p{inenclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\p{^inenclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\P{inenclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\P{^inenclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\p{	IN_Enclosed_CJK_Letters_and_Months}', "");
    Expect(0, 13055, '\p{^	IN_Enclosed_CJK_Letters_and_Months}', "");
    Expect(0, 13055, '\P{	IN_Enclosed_CJK_Letters_and_Months}', "");
    Expect(1, 13055, '\P{^	IN_Enclosed_CJK_Letters_and_Months}', "");
    Expect(0, 13056, '\p{	IN_Enclosed_CJK_Letters_and_Months}', "");
    Expect(1, 13056, '\p{^	IN_Enclosed_CJK_Letters_and_Months}', "");
    Expect(1, 13056, '\P{	IN_Enclosed_CJK_Letters_and_Months}', "");
    Expect(0, 13056, '\P{^	IN_Enclosed_CJK_Letters_and_Months}', "");
    Error('\p{	:=enclosed_CJK}');
    Error('\P{	:=enclosed_CJK}');
    Expect(1, 13055, '\p{enclosedcjk}', "");
    Expect(0, 13055, '\p{^enclosedcjk}', "");
    Expect(0, 13055, '\P{enclosedcjk}', "");
    Expect(1, 13055, '\P{^enclosedcjk}', "");
    Expect(0, 13056, '\p{enclosedcjk}', "");
    Expect(1, 13056, '\p{^enclosedcjk}', "");
    Expect(1, 13056, '\P{enclosedcjk}', "");
    Expect(0, 13056, '\P{^enclosedcjk}', "");
    Expect(1, 13055, '\p{-enclosed_CJK}', "");
    Expect(0, 13055, '\p{^-enclosed_CJK}', "");
    Expect(0, 13055, '\P{-enclosed_CJK}', "");
    Expect(1, 13055, '\P{^-enclosed_CJK}', "");
    Expect(0, 13056, '\p{-enclosed_CJK}', "");
    Expect(1, 13056, '\p{^-enclosed_CJK}', "");
    Expect(1, 13056, '\P{-enclosed_CJK}', "");
    Expect(0, 13056, '\P{^-enclosed_CJK}', "");
    Error('\p{-IS_Enclosed_CJK/a/}');
    Error('\P{-IS_Enclosed_CJK/a/}');
    Expect(1, 13055, '\p{isenclosedcjk}', "");
    Expect(0, 13055, '\p{^isenclosedcjk}', "");
    Expect(0, 13055, '\P{isenclosedcjk}', "");
    Expect(1, 13055, '\P{^isenclosedcjk}', "");
    Expect(0, 13056, '\p{isenclosedcjk}', "");
    Expect(1, 13056, '\p{^isenclosedcjk}', "");
    Expect(1, 13056, '\P{isenclosedcjk}', "");
    Expect(0, 13056, '\P{^isenclosedcjk}', "");
    Expect(1, 13055, '\p{_Is_Enclosed_CJK}', "");
    Expect(0, 13055, '\p{^_Is_Enclosed_CJK}', "");
    Expect(0, 13055, '\P{_Is_Enclosed_CJK}', "");
    Expect(1, 13055, '\P{^_Is_Enclosed_CJK}', "");
    Expect(0, 13056, '\p{_Is_Enclosed_CJK}', "");
    Expect(1, 13056, '\p{^_Is_Enclosed_CJK}', "");
    Expect(1, 13056, '\P{_Is_Enclosed_CJK}', "");
    Expect(0, 13056, '\P{^_Is_Enclosed_CJK}', "");
    Error('\p{	:=In_Enclosed_CJK}');
    Error('\P{	:=In_Enclosed_CJK}');
    Expect(1, 13055, '\p{inenclosedcjk}', "");
    Expect(0, 13055, '\p{^inenclosedcjk}', "");
    Expect(0, 13055, '\P{inenclosedcjk}', "");
    Expect(1, 13055, '\P{^inenclosedcjk}', "");
    Expect(0, 13056, '\p{inenclosedcjk}', "");
    Expect(1, 13056, '\p{^inenclosedcjk}', "");
    Expect(1, 13056, '\P{inenclosedcjk}', "");
    Expect(0, 13056, '\P{^inenclosedcjk}', "");
    Expect(1, 13055, '\p{_IN_Enclosed_CJK}', "");
    Expect(0, 13055, '\p{^_IN_Enclosed_CJK}', "");
    Expect(0, 13055, '\P{_IN_Enclosed_CJK}', "");
    Expect(1, 13055, '\P{^_IN_Enclosed_CJK}', "");
    Expect(0, 13056, '\p{_IN_Enclosed_CJK}', "");
    Expect(1, 13056, '\p{^_IN_Enclosed_CJK}', "");
    Expect(1, 13056, '\P{_IN_Enclosed_CJK}', "");
    Expect(0, 13056, '\P{^_IN_Enclosed_CJK}', "");
    Error('\p{	ENCLOSED_ideographic_Supplement:=}');
    Error('\P{	ENCLOSED_ideographic_Supplement:=}');
    Expect(1, 127743, '\p{enclosedideographicsupplement}', "");
    Expect(0, 127743, '\p{^enclosedideographicsupplement}', "");
    Expect(0, 127743, '\P{enclosedideographicsupplement}', "");
    Expect(1, 127743, '\P{^enclosedideographicsupplement}', "");
    Expect(0, 127744, '\p{enclosedideographicsupplement}', "");
    Expect(1, 127744, '\p{^enclosedideographicsupplement}', "");
    Expect(1, 127744, '\P{enclosedideographicsupplement}', "");
    Expect(0, 127744, '\P{^enclosedideographicsupplement}', "");
    Expect(1, 127743, '\p{-_ENCLOSED_IDEOGRAPHIC_supplement}', "");
    Expect(0, 127743, '\p{^-_ENCLOSED_IDEOGRAPHIC_supplement}', "");
    Expect(0, 127743, '\P{-_ENCLOSED_IDEOGRAPHIC_supplement}', "");
    Expect(1, 127743, '\P{^-_ENCLOSED_IDEOGRAPHIC_supplement}', "");
    Expect(0, 127744, '\p{-_ENCLOSED_IDEOGRAPHIC_supplement}', "");
    Expect(1, 127744, '\p{^-_ENCLOSED_IDEOGRAPHIC_supplement}', "");
    Expect(1, 127744, '\P{-_ENCLOSED_IDEOGRAPHIC_supplement}', "");
    Expect(0, 127744, '\P{^-_ENCLOSED_IDEOGRAPHIC_supplement}', "");
    Error('\p{	Is_ENCLOSED_ideographic_SUPPLEMENT/a/}');
    Error('\P{	Is_ENCLOSED_ideographic_SUPPLEMENT/a/}');
    Expect(1, 127743, '\p{isenclosedideographicsupplement}', "");
    Expect(0, 127743, '\p{^isenclosedideographicsupplement}', "");
    Expect(0, 127743, '\P{isenclosedideographicsupplement}', "");
    Expect(1, 127743, '\P{^isenclosedideographicsupplement}', "");
    Expect(0, 127744, '\p{isenclosedideographicsupplement}', "");
    Expect(1, 127744, '\p{^isenclosedideographicsupplement}', "");
    Expect(1, 127744, '\P{isenclosedideographicsupplement}', "");
    Expect(0, 127744, '\P{^isenclosedideographicsupplement}', "");
    Expect(1, 127743, '\p{	IS_Enclosed_Ideographic_supplement}', "");
    Expect(0, 127743, '\p{^	IS_Enclosed_Ideographic_supplement}', "");
    Expect(0, 127743, '\P{	IS_Enclosed_Ideographic_supplement}', "");
    Expect(1, 127743, '\P{^	IS_Enclosed_Ideographic_supplement}', "");
    Expect(0, 127744, '\p{	IS_Enclosed_Ideographic_supplement}', "");
    Expect(1, 127744, '\p{^	IS_Enclosed_Ideographic_supplement}', "");
    Expect(1, 127744, '\P{	IS_Enclosed_Ideographic_supplement}', "");
    Expect(0, 127744, '\P{^	IS_Enclosed_Ideographic_supplement}', "");
    Error('\p{:=	-in_Enclosed_ideographic_supplement}');
    Error('\P{:=	-in_Enclosed_ideographic_supplement}');
    Expect(1, 127743, '\p{inenclosedideographicsupplement}', "");
    Expect(0, 127743, '\p{^inenclosedideographicsupplement}', "");
    Expect(0, 127743, '\P{inenclosedideographicsupplement}', "");
    Expect(1, 127743, '\P{^inenclosedideographicsupplement}', "");
    Expect(0, 127744, '\p{inenclosedideographicsupplement}', "");
    Expect(1, 127744, '\p{^inenclosedideographicsupplement}', "");
    Expect(1, 127744, '\P{inenclosedideographicsupplement}', "");
    Expect(0, 127744, '\P{^inenclosedideographicsupplement}', "");
    Expect(1, 127743, '\p{_in_ENCLOSED_Ideographic_supplement}', "");
    Expect(0, 127743, '\p{^_in_ENCLOSED_Ideographic_supplement}', "");
    Expect(0, 127743, '\P{_in_ENCLOSED_Ideographic_supplement}', "");
    Expect(1, 127743, '\P{^_in_ENCLOSED_Ideographic_supplement}', "");
    Expect(0, 127744, '\p{_in_ENCLOSED_Ideographic_supplement}', "");
    Expect(1, 127744, '\p{^_in_ENCLOSED_Ideographic_supplement}', "");
    Expect(1, 127744, '\P{_in_ENCLOSED_Ideographic_supplement}', "");
    Expect(0, 127744, '\P{^_in_ENCLOSED_Ideographic_supplement}', "");
    Error('\p{/a/_-enclosed_Ideographic_Sup}');
    Error('\P{/a/_-enclosed_Ideographic_Sup}');
    Expect(1, 127743, '\p{enclosedideographicsup}', "");
    Expect(0, 127743, '\p{^enclosedideographicsup}', "");
    Expect(0, 127743, '\P{enclosedideographicsup}', "");
    Expect(1, 127743, '\P{^enclosedideographicsup}', "");
    Expect(0, 127744, '\p{enclosedideographicsup}', "");
    Expect(1, 127744, '\p{^enclosedideographicsup}', "");
    Expect(1, 127744, '\P{enclosedideographicsup}', "");
    Expect(0, 127744, '\P{^enclosedideographicsup}', "");
    Expect(1, 127743, '\p{_Enclosed_Ideographic_SUP}', "");
    Expect(0, 127743, '\p{^_Enclosed_Ideographic_SUP}', "");
    Expect(0, 127743, '\P{_Enclosed_Ideographic_SUP}', "");
    Expect(1, 127743, '\P{^_Enclosed_Ideographic_SUP}', "");
    Expect(0, 127744, '\p{_Enclosed_Ideographic_SUP}', "");
    Expect(1, 127744, '\p{^_Enclosed_Ideographic_SUP}', "");
    Expect(1, 127744, '\P{_Enclosed_Ideographic_SUP}', "");
    Expect(0, 127744, '\P{^_Enclosed_Ideographic_SUP}', "");
    Error('\p{_is_enclosed_ideographic_sup/a/}');
    Error('\P{_is_enclosed_ideographic_sup/a/}');
    Expect(1, 127743, '\p{isenclosedideographicsup}', "");
    Expect(0, 127743, '\p{^isenclosedideographicsup}', "");
    Expect(0, 127743, '\P{isenclosedideographicsup}', "");
    Expect(1, 127743, '\P{^isenclosedideographicsup}', "");
    Expect(0, 127744, '\p{isenclosedideographicsup}', "");
    Expect(1, 127744, '\p{^isenclosedideographicsup}', "");
    Expect(1, 127744, '\P{isenclosedideographicsup}', "");
    Expect(0, 127744, '\P{^isenclosedideographicsup}', "");
    Expect(1, 127743, '\p{		Is_Enclosed_IDEOGRAPHIC_Sup}', "");
    Expect(0, 127743, '\p{^		Is_Enclosed_IDEOGRAPHIC_Sup}', "");
    Expect(0, 127743, '\P{		Is_Enclosed_IDEOGRAPHIC_Sup}', "");
    Expect(1, 127743, '\P{^		Is_Enclosed_IDEOGRAPHIC_Sup}', "");
    Expect(0, 127744, '\p{		Is_Enclosed_IDEOGRAPHIC_Sup}', "");
    Expect(1, 127744, '\p{^		Is_Enclosed_IDEOGRAPHIC_Sup}', "");
    Expect(1, 127744, '\P{		Is_Enclosed_IDEOGRAPHIC_Sup}', "");
    Expect(0, 127744, '\P{^		Is_Enclosed_IDEOGRAPHIC_Sup}', "");
    Error('\p{ :=IN_ENCLOSED_IDEOGRAPHIC_Sup}');
    Error('\P{ :=IN_ENCLOSED_IDEOGRAPHIC_Sup}');
    Expect(1, 127743, '\p{inenclosedideographicsup}', "");
    Expect(0, 127743, '\p{^inenclosedideographicsup}', "");
    Expect(0, 127743, '\P{inenclosedideographicsup}', "");
    Expect(1, 127743, '\P{^inenclosedideographicsup}', "");
    Expect(0, 127744, '\p{inenclosedideographicsup}', "");
    Expect(1, 127744, '\p{^inenclosedideographicsup}', "");
    Expect(1, 127744, '\P{inenclosedideographicsup}', "");
    Expect(0, 127744, '\P{^inenclosedideographicsup}', "");
    Expect(1, 127743, '\p{	_in_Enclosed_IDEOGRAPHIC_Sup}', "");
    Expect(0, 127743, '\p{^	_in_Enclosed_IDEOGRAPHIC_Sup}', "");
    Expect(0, 127743, '\P{	_in_Enclosed_IDEOGRAPHIC_Sup}', "");
    Expect(1, 127743, '\P{^	_in_Enclosed_IDEOGRAPHIC_Sup}', "");
    Expect(0, 127744, '\p{	_in_Enclosed_IDEOGRAPHIC_Sup}', "");
    Expect(1, 127744, '\p{^	_in_Enclosed_IDEOGRAPHIC_Sup}', "");
    Expect(1, 127744, '\P{	_in_Enclosed_IDEOGRAPHIC_Sup}', "");
    Expect(0, 127744, '\P{^	_in_Enclosed_IDEOGRAPHIC_Sup}', "");
    Error('\p{ :=Enclosing_Mark}');
    Error('\P{ :=Enclosing_Mark}');
    Expect(1, 42610, '\p{enclosingmark}', "");
    Expect(0, 42610, '\p{^enclosingmark}', "");
    Expect(0, 42610, '\P{enclosingmark}', "");
    Expect(1, 42610, '\P{^enclosingmark}', "");
    Expect(0, 42611, '\p{enclosingmark}', "");
    Expect(1, 42611, '\p{^enclosingmark}', "");
    Expect(1, 42611, '\P{enclosingmark}', "");
    Expect(0, 42611, '\P{^enclosingmark}', "");
    Expect(1, 42610, '\p{ enclosing_mark}', "");
    Expect(0, 42610, '\p{^ enclosing_mark}', "");
    Expect(0, 42610, '\P{ enclosing_mark}', "");
    Expect(1, 42610, '\P{^ enclosing_mark}', "");
    Expect(0, 42611, '\p{ enclosing_mark}', "");
    Expect(1, 42611, '\p{^ enclosing_mark}', "");
    Expect(1, 42611, '\P{ enclosing_mark}', "");
    Expect(0, 42611, '\P{^ enclosing_mark}', "");
    Error('\p{	/a/is_enclosing_mark}');
    Error('\P{	/a/is_enclosing_mark}');
    Expect(1, 42610, '\p{isenclosingmark}', "");
    Expect(0, 42610, '\p{^isenclosingmark}', "");
    Expect(0, 42610, '\P{isenclosingmark}', "");
    Expect(1, 42610, '\P{^isenclosingmark}', "");
    Expect(0, 42611, '\p{isenclosingmark}', "");
    Expect(1, 42611, '\p{^isenclosingmark}', "");
    Expect(1, 42611, '\P{isenclosingmark}', "");
    Expect(0, 42611, '\P{^isenclosingmark}', "");
    Expect(1, 42610, '\p{	is_enclosing_Mark}', "");
    Expect(0, 42610, '\p{^	is_enclosing_Mark}', "");
    Expect(0, 42610, '\P{	is_enclosing_Mark}', "");
    Expect(1, 42610, '\P{^	is_enclosing_Mark}', "");
    Expect(0, 42611, '\p{	is_enclosing_Mark}', "");
    Expect(1, 42611, '\p{^	is_enclosing_Mark}', "");
    Expect(1, 42611, '\P{	is_enclosing_Mark}', "");
    Expect(0, 42611, '\P{^	is_enclosing_Mark}', "");
    Error('\p{ _ME:=}');
    Error('\P{ _ME:=}');
    Expect(1, 42610, '\p{me}', "");
    Expect(0, 42610, '\p{^me}', "");
    Expect(0, 42610, '\P{me}', "");
    Expect(1, 42610, '\P{^me}', "");
    Expect(0, 42611, '\p{me}', "");
    Expect(1, 42611, '\p{^me}', "");
    Expect(1, 42611, '\P{me}', "");
    Expect(0, 42611, '\P{^me}', "");
    Expect(1, 42610, '\p{_Me}', "");
    Expect(0, 42610, '\p{^_Me}', "");
    Expect(0, 42610, '\P{_Me}', "");
    Expect(1, 42610, '\P{^_Me}', "");
    Expect(0, 42611, '\p{_Me}', "");
    Expect(1, 42611, '\p{^_Me}', "");
    Expect(1, 42611, '\P{_Me}', "");
    Expect(0, 42611, '\P{^_Me}', "");
    Error('\p{ 	IS_Me/a/}');
    Error('\P{ 	IS_Me/a/}');
    Expect(1, 42610, '\p{isme}', "");
    Expect(0, 42610, '\p{^isme}', "");
    Expect(0, 42610, '\P{isme}', "");
    Expect(1, 42610, '\P{^isme}', "");
    Expect(0, 42611, '\p{isme}', "");
    Expect(1, 42611, '\p{^isme}', "");
    Expect(1, 42611, '\P{isme}', "");
    Expect(0, 42611, '\P{^isme}', "");
    Expect(1, 42610, '\p{ Is_Me}', "");
    Expect(0, 42610, '\p{^ Is_Me}', "");
    Expect(0, 42610, '\P{ Is_Me}', "");
    Expect(1, 42610, '\P{^ Is_Me}', "");
    Expect(0, 42611, '\p{ Is_Me}', "");
    Expect(1, 42611, '\p{^ Is_Me}', "");
    Expect(1, 42611, '\P{ Is_Me}', "");
    Expect(0, 42611, '\P{^ Is_Me}', "");
    Error('\p{:= Ethiopic}');
    Error('\P{:= Ethiopic}');
    Expect(1, 43822, '\p{ethiopic}', "");
    Expect(0, 43822, '\p{^ethiopic}', "");
    Expect(0, 43822, '\P{ethiopic}', "");
    Expect(1, 43822, '\P{^ethiopic}', "");
    Expect(0, 43823, '\p{ethiopic}', "");
    Expect(1, 43823, '\p{^ethiopic}', "");
    Expect(1, 43823, '\P{ethiopic}', "");
    Expect(0, 43823, '\P{^ethiopic}', "");
    Expect(1, 43822, '\p{	-ETHIOPIC}', "");
    Expect(0, 43822, '\p{^	-ETHIOPIC}', "");
    Expect(0, 43822, '\P{	-ETHIOPIC}', "");
    Expect(1, 43822, '\P{^	-ETHIOPIC}', "");
    Expect(0, 43823, '\p{	-ETHIOPIC}', "");
    Expect(1, 43823, '\p{^	-ETHIOPIC}', "");
    Expect(1, 43823, '\P{	-ETHIOPIC}', "");
    Expect(0, 43823, '\P{^	-ETHIOPIC}', "");
    Error('\p{/a/is_Ethiopic}');
    Error('\P{/a/is_Ethiopic}');
    Expect(1, 43822, '\p{isethiopic}', "");
    Expect(0, 43822, '\p{^isethiopic}', "");
    Expect(0, 43822, '\P{isethiopic}', "");
    Expect(1, 43822, '\P{^isethiopic}', "");
    Expect(0, 43823, '\p{isethiopic}', "");
    Expect(1, 43823, '\p{^isethiopic}', "");
    Expect(1, 43823, '\P{isethiopic}', "");
    Expect(0, 43823, '\P{^isethiopic}', "");
    Expect(1, 43822, '\p{ -IS_ethiopic}', "");
    Expect(0, 43822, '\p{^ -IS_ethiopic}', "");
    Expect(0, 43822, '\P{ -IS_ethiopic}', "");
    Expect(1, 43822, '\P{^ -IS_ethiopic}', "");
    Expect(0, 43823, '\p{ -IS_ethiopic}', "");
    Expect(1, 43823, '\p{^ -IS_ethiopic}', "");
    Expect(1, 43823, '\P{ -IS_ethiopic}', "");
    Expect(0, 43823, '\P{^ -IS_ethiopic}', "");
    Error('\p{	_ETHI/a/}');
    Error('\P{	_ETHI/a/}');
    Expect(1, 43822, '\p{ethi}', "");
    Expect(0, 43822, '\p{^ethi}', "");
    Expect(0, 43822, '\P{ethi}', "");
    Expect(1, 43822, '\P{^ethi}', "");
    Expect(0, 43823, '\p{ethi}', "");
    Expect(1, 43823, '\p{^ethi}', "");
    Expect(1, 43823, '\P{ethi}', "");
    Expect(0, 43823, '\P{^ethi}', "");
    Expect(1, 43822, '\p{-	ethi}', "");
    Expect(0, 43822, '\p{^-	ethi}', "");
    Expect(0, 43822, '\P{-	ethi}', "");
    Expect(1, 43822, '\P{^-	ethi}', "");
    Expect(0, 43823, '\p{-	ethi}', "");
    Expect(1, 43823, '\p{^-	ethi}', "");
    Expect(1, 43823, '\P{-	ethi}', "");
    Expect(0, 43823, '\P{^-	ethi}', "");
    Error('\p{/a/		IS_ETHI}');
    Error('\P{/a/		IS_ETHI}');
    Expect(1, 43822, '\p{isethi}', "");
    Expect(0, 43822, '\p{^isethi}', "");
    Expect(0, 43822, '\P{isethi}', "");
    Expect(1, 43822, '\P{^isethi}', "");
    Expect(0, 43823, '\p{isethi}', "");
    Expect(1, 43823, '\p{^isethi}', "");
    Expect(1, 43823, '\P{isethi}', "");
    Expect(0, 43823, '\P{^isethi}', "");
    Expect(1, 43822, '\p{_ is_Ethi}', "");
    Expect(0, 43822, '\p{^_ is_Ethi}', "");
    Expect(0, 43822, '\P{_ is_Ethi}', "");
    Expect(1, 43822, '\P{^_ is_Ethi}', "");
    Expect(0, 43823, '\p{_ is_Ethi}', "");
    Expect(1, 43823, '\p{^_ is_Ethi}', "");
    Expect(1, 43823, '\P{_ is_Ethi}', "");
    Expect(0, 43823, '\P{^_ is_Ethi}', "");
    Error('\p{__Ethiopic_extended:=}');
    Error('\P{__Ethiopic_extended:=}');
    Expect(1, 11743, '\p{ethiopicextended}', "");
    Expect(0, 11743, '\p{^ethiopicextended}', "");
    Expect(0, 11743, '\P{ethiopicextended}', "");
    Expect(1, 11743, '\P{^ethiopicextended}', "");
    Expect(0, 11744, '\p{ethiopicextended}', "");
    Expect(1, 11744, '\p{^ethiopicextended}', "");
    Expect(1, 11744, '\P{ethiopicextended}', "");
    Expect(0, 11744, '\P{^ethiopicextended}', "");
    Expect(1, 11743, '\p{  Ethiopic_extended}', "");
    Expect(0, 11743, '\p{^  Ethiopic_extended}', "");
    Expect(0, 11743, '\P{  Ethiopic_extended}', "");
    Expect(1, 11743, '\P{^  Ethiopic_extended}', "");
    Expect(0, 11744, '\p{  Ethiopic_extended}', "");
    Expect(1, 11744, '\p{^  Ethiopic_extended}', "");
    Expect(1, 11744, '\P{  Ethiopic_extended}', "");
    Expect(0, 11744, '\P{^  Ethiopic_extended}', "");
    Error('\p{	:=IS_Ethiopic_extended}');
    Error('\P{	:=IS_Ethiopic_extended}');
    Expect(1, 11743, '\p{isethiopicextended}', "");
    Expect(0, 11743, '\p{^isethiopicextended}', "");
    Expect(0, 11743, '\P{isethiopicextended}', "");
    Expect(1, 11743, '\P{^isethiopicextended}', "");
    Expect(0, 11744, '\p{isethiopicextended}', "");
    Expect(1, 11744, '\p{^isethiopicextended}', "");
    Expect(1, 11744, '\P{isethiopicextended}', "");
    Expect(0, 11744, '\P{^isethiopicextended}', "");
    Expect(1, 11743, '\p{_-Is_Ethiopic_Extended}', "");
    Expect(0, 11743, '\p{^_-Is_Ethiopic_Extended}', "");
    Expect(0, 11743, '\P{_-Is_Ethiopic_Extended}', "");
    Expect(1, 11743, '\P{^_-Is_Ethiopic_Extended}', "");
    Expect(0, 11744, '\p{_-Is_Ethiopic_Extended}', "");
    Expect(1, 11744, '\p{^_-Is_Ethiopic_Extended}', "");
    Expect(1, 11744, '\P{_-Is_Ethiopic_Extended}', "");
    Expect(0, 11744, '\P{^_-Is_Ethiopic_Extended}', "");
    Error('\p{ :=IN_Ethiopic_Extended}');
    Error('\P{ :=IN_Ethiopic_Extended}');
    Expect(1, 11743, '\p{inethiopicextended}', "");
    Expect(0, 11743, '\p{^inethiopicextended}', "");
    Expect(0, 11743, '\P{inethiopicextended}', "");
    Expect(1, 11743, '\P{^inethiopicextended}', "");
    Expect(0, 11744, '\p{inethiopicextended}', "");
    Expect(1, 11744, '\p{^inethiopicextended}', "");
    Expect(1, 11744, '\P{inethiopicextended}', "");
    Expect(0, 11744, '\P{^inethiopicextended}', "");
    Expect(1, 11743, '\p{-	IN_ethiopic_Extended}', "");
    Expect(0, 11743, '\p{^-	IN_ethiopic_Extended}', "");
    Expect(0, 11743, '\P{-	IN_ethiopic_Extended}', "");
    Expect(1, 11743, '\P{^-	IN_ethiopic_Extended}', "");
    Expect(0, 11744, '\p{-	IN_ethiopic_Extended}', "");
    Expect(1, 11744, '\p{^-	IN_ethiopic_Extended}', "");
    Expect(1, 11744, '\P{-	IN_ethiopic_Extended}', "");
    Expect(0, 11744, '\P{^-	IN_ethiopic_Extended}', "");
    Error('\p{-	Ethiopic_Ext:=}');
    Error('\P{-	Ethiopic_Ext:=}');
    Expect(1, 11743, '\p{ethiopicext}', "");
    Expect(0, 11743, '\p{^ethiopicext}', "");
    Expect(0, 11743, '\P{ethiopicext}', "");
    Expect(1, 11743, '\P{^ethiopicext}', "");
    Expect(0, 11744, '\p{ethiopicext}', "");
    Expect(1, 11744, '\p{^ethiopicext}', "");
    Expect(1, 11744, '\P{ethiopicext}', "");
    Expect(0, 11744, '\P{^ethiopicext}', "");
    Expect(1, 11743, '\p{_ Ethiopic_EXT}', "");
    Expect(0, 11743, '\p{^_ Ethiopic_EXT}', "");
    Expect(0, 11743, '\P{_ Ethiopic_EXT}', "");
    Expect(1, 11743, '\P{^_ Ethiopic_EXT}', "");
    Expect(0, 11744, '\p{_ Ethiopic_EXT}', "");
    Expect(1, 11744, '\p{^_ Ethiopic_EXT}', "");
    Expect(1, 11744, '\P{_ Ethiopic_EXT}', "");
    Expect(0, 11744, '\P{^_ Ethiopic_EXT}', "");
    Error('\p{ /a/Is_Ethiopic_Ext}');
    Error('\P{ /a/Is_Ethiopic_Ext}');
    Expect(1, 11743, '\p{isethiopicext}', "");
    Expect(0, 11743, '\p{^isethiopicext}', "");
    Expect(0, 11743, '\P{isethiopicext}', "");
    Expect(1, 11743, '\P{^isethiopicext}', "");
    Expect(0, 11744, '\p{isethiopicext}', "");
    Expect(1, 11744, '\p{^isethiopicext}', "");
    Expect(1, 11744, '\P{isethiopicext}', "");
    Expect(0, 11744, '\P{^isethiopicext}', "");
    Expect(1, 11743, '\p{--IS_Ethiopic_EXT}', "");
    Expect(0, 11743, '\p{^--IS_Ethiopic_EXT}', "");
    Expect(0, 11743, '\P{--IS_Ethiopic_EXT}', "");
    Expect(1, 11743, '\P{^--IS_Ethiopic_EXT}', "");
    Expect(0, 11744, '\p{--IS_Ethiopic_EXT}', "");
    Expect(1, 11744, '\p{^--IS_Ethiopic_EXT}', "");
    Expect(1, 11744, '\P{--IS_Ethiopic_EXT}', "");
    Expect(0, 11744, '\P{^--IS_Ethiopic_EXT}', "");
    Error('\p{/a/-In_ETHIOPIC_EXT}');
    Error('\P{/a/-In_ETHIOPIC_EXT}');
    Expect(1, 11743, '\p{inethiopicext}', "");
    Expect(0, 11743, '\p{^inethiopicext}', "");
    Expect(0, 11743, '\P{inethiopicext}', "");
    Expect(1, 11743, '\P{^inethiopicext}', "");
    Expect(0, 11744, '\p{inethiopicext}', "");
    Expect(1, 11744, '\p{^inethiopicext}', "");
    Expect(1, 11744, '\P{inethiopicext}', "");
    Expect(0, 11744, '\P{^inethiopicext}', "");
    Expect(1, 11743, '\p{_-in_Ethiopic_Ext}', "");
    Expect(0, 11743, '\p{^_-in_Ethiopic_Ext}', "");
    Expect(0, 11743, '\P{_-in_Ethiopic_Ext}', "");
    Expect(1, 11743, '\P{^_-in_Ethiopic_Ext}', "");
    Expect(0, 11744, '\p{_-in_Ethiopic_Ext}', "");
    Expect(1, 11744, '\p{^_-in_Ethiopic_Ext}', "");
    Expect(1, 11744, '\P{_-in_Ethiopic_Ext}', "");
    Expect(0, 11744, '\P{^_-in_Ethiopic_Ext}', "");
    Error('\p{_	Ethiopic_EXTENDED_A:=}');
    Error('\P{_	Ethiopic_EXTENDED_A:=}');
    Expect(1, 43823, '\p{ethiopicextendeda}', "");
    Expect(0, 43823, '\p{^ethiopicextendeda}', "");
    Expect(0, 43823, '\P{ethiopicextendeda}', "");
    Expect(1, 43823, '\P{^ethiopicextendeda}', "");
    Expect(0, 43824, '\p{ethiopicextendeda}', "");
    Expect(1, 43824, '\p{^ethiopicextendeda}', "");
    Expect(1, 43824, '\P{ethiopicextendeda}', "");
    Expect(0, 43824, '\P{^ethiopicextendeda}', "");
    Expect(1, 43823, '\p{	ethiopic_EXTENDED_A}', "");
    Expect(0, 43823, '\p{^	ethiopic_EXTENDED_A}', "");
    Expect(0, 43823, '\P{	ethiopic_EXTENDED_A}', "");
    Expect(1, 43823, '\P{^	ethiopic_EXTENDED_A}', "");
    Expect(0, 43824, '\p{	ethiopic_EXTENDED_A}', "");
    Expect(1, 43824, '\p{^	ethiopic_EXTENDED_A}', "");
    Expect(1, 43824, '\P{	ethiopic_EXTENDED_A}', "");
    Expect(0, 43824, '\P{^	ethiopic_EXTENDED_A}', "");
    Error('\p{ Is_Ethiopic_EXTENDED_a/a/}');
    Error('\P{ Is_Ethiopic_EXTENDED_a/a/}');
    Expect(1, 43823, '\p{isethiopicextendeda}', "");
    Expect(0, 43823, '\p{^isethiopicextendeda}', "");
    Expect(0, 43823, '\P{isethiopicextendeda}', "");
    Expect(1, 43823, '\P{^isethiopicextendeda}', "");
    Expect(0, 43824, '\p{isethiopicextendeda}', "");
    Expect(1, 43824, '\p{^isethiopicextendeda}', "");
    Expect(1, 43824, '\P{isethiopicextendeda}', "");
    Expect(0, 43824, '\P{^isethiopicextendeda}', "");
    Expect(1, 43823, '\p{	IS_Ethiopic_Extended_A}', "");
    Expect(0, 43823, '\p{^	IS_Ethiopic_Extended_A}', "");
    Expect(0, 43823, '\P{	IS_Ethiopic_Extended_A}', "");
    Expect(1, 43823, '\P{^	IS_Ethiopic_Extended_A}', "");
    Expect(0, 43824, '\p{	IS_Ethiopic_Extended_A}', "");
    Expect(1, 43824, '\p{^	IS_Ethiopic_Extended_A}', "");
    Expect(1, 43824, '\P{	IS_Ethiopic_Extended_A}', "");
    Expect(0, 43824, '\P{^	IS_Ethiopic_Extended_A}', "");
    Error('\p{:=_-IN_Ethiopic_EXTENDED_a}');
    Error('\P{:=_-IN_Ethiopic_EXTENDED_a}');
    Expect(1, 43823, '\p{inethiopicextendeda}', "");
    Expect(0, 43823, '\p{^inethiopicextendeda}', "");
    Expect(0, 43823, '\P{inethiopicextendeda}', "");
    Expect(1, 43823, '\P{^inethiopicextendeda}', "");
    Expect(0, 43824, '\p{inethiopicextendeda}', "");
    Expect(1, 43824, '\p{^inethiopicextendeda}', "");
    Expect(1, 43824, '\P{inethiopicextendeda}', "");
    Expect(0, 43824, '\P{^inethiopicextendeda}', "");
    Expect(1, 43823, '\p{		in_Ethiopic_extended_a}', "");
    Expect(0, 43823, '\p{^		in_Ethiopic_extended_a}', "");
    Expect(0, 43823, '\P{		in_Ethiopic_extended_a}', "");
    Expect(1, 43823, '\P{^		in_Ethiopic_extended_a}', "");
    Expect(0, 43824, '\p{		in_Ethiopic_extended_a}', "");
    Expect(1, 43824, '\p{^		in_Ethiopic_extended_a}', "");
    Expect(1, 43824, '\P{		in_Ethiopic_extended_a}', "");
    Expect(0, 43824, '\P{^		in_Ethiopic_extended_a}', "");
    Error('\p{-/a/ethiopic_EXT_A}');
    Error('\P{-/a/ethiopic_EXT_A}');
    Expect(1, 43823, '\p{ethiopicexta}', "");
    Expect(0, 43823, '\p{^ethiopicexta}', "");
    Expect(0, 43823, '\P{ethiopicexta}', "");
    Expect(1, 43823, '\P{^ethiopicexta}', "");
    Expect(0, 43824, '\p{ethiopicexta}', "");
    Expect(1, 43824, '\p{^ethiopicexta}', "");
    Expect(1, 43824, '\P{ethiopicexta}', "");
    Expect(0, 43824, '\P{^ethiopicexta}', "");
    Expect(1, 43823, '\p{_	Ethiopic_EXT_A}', "");
    Expect(0, 43823, '\p{^_	Ethiopic_EXT_A}', "");
    Expect(0, 43823, '\P{_	Ethiopic_EXT_A}', "");
    Expect(1, 43823, '\P{^_	Ethiopic_EXT_A}', "");
    Expect(0, 43824, '\p{_	Ethiopic_EXT_A}', "");
    Expect(1, 43824, '\p{^_	Ethiopic_EXT_A}', "");
    Expect(1, 43824, '\P{_	Ethiopic_EXT_A}', "");
    Expect(0, 43824, '\P{^_	Ethiopic_EXT_A}', "");
    Error('\p{ _Is_ethiopic_ext_A:=}');
    Error('\P{ _Is_ethiopic_ext_A:=}');
    Expect(1, 43823, '\p{isethiopicexta}', "");
    Expect(0, 43823, '\p{^isethiopicexta}', "");
    Expect(0, 43823, '\P{isethiopicexta}', "");
    Expect(1, 43823, '\P{^isethiopicexta}', "");
    Expect(0, 43824, '\p{isethiopicexta}', "");
    Expect(1, 43824, '\p{^isethiopicexta}', "");
    Expect(1, 43824, '\P{isethiopicexta}', "");
    Expect(0, 43824, '\P{^isethiopicexta}', "");
    Expect(1, 43823, '\p{ Is_ETHIOPIC_EXT_a}', "");
    Expect(0, 43823, '\p{^ Is_ETHIOPIC_EXT_a}', "");
    Expect(0, 43823, '\P{ Is_ETHIOPIC_EXT_a}', "");
    Expect(1, 43823, '\P{^ Is_ETHIOPIC_EXT_a}', "");
    Expect(0, 43824, '\p{ Is_ETHIOPIC_EXT_a}', "");
    Expect(1, 43824, '\p{^ Is_ETHIOPIC_EXT_a}', "");
    Expect(1, 43824, '\P{ Is_ETHIOPIC_EXT_a}', "");
    Expect(0, 43824, '\P{^ Is_ETHIOPIC_EXT_a}', "");
    Error('\p{:= -In_Ethiopic_EXT_A}');
    Error('\P{:= -In_Ethiopic_EXT_A}');
    Expect(1, 43823, '\p{inethiopicexta}', "");
    Expect(0, 43823, '\p{^inethiopicexta}', "");
    Expect(0, 43823, '\P{inethiopicexta}', "");
    Expect(1, 43823, '\P{^inethiopicexta}', "");
    Expect(0, 43824, '\p{inethiopicexta}', "");
    Expect(1, 43824, '\p{^inethiopicexta}', "");
    Expect(1, 43824, '\P{inethiopicexta}', "");
    Expect(0, 43824, '\P{^inethiopicexta}', "");
    Expect(1, 43823, '\p{ _in_ETHIOPIC_Ext_A}', "");
    Expect(0, 43823, '\p{^ _in_ETHIOPIC_Ext_A}', "");
    Expect(0, 43823, '\P{ _in_ETHIOPIC_Ext_A}', "");
    Expect(1, 43823, '\P{^ _in_ETHIOPIC_Ext_A}', "");
    Expect(0, 43824, '\p{ _in_ETHIOPIC_Ext_A}', "");
    Expect(1, 43824, '\p{^ _in_ETHIOPIC_Ext_A}', "");
    Expect(1, 43824, '\P{ _in_ETHIOPIC_Ext_A}', "");
    Expect(0, 43824, '\P{^ _in_ETHIOPIC_Ext_A}', "");
    Error('\p{_/a/Ethiopic_Supplement}');
    Error('\P{_/a/Ethiopic_Supplement}');
    Expect(1, 5023, '\p{ethiopicsupplement}', "");
    Expect(0, 5023, '\p{^ethiopicsupplement}', "");
    Expect(0, 5023, '\P{ethiopicsupplement}', "");
    Expect(1, 5023, '\P{^ethiopicsupplement}', "");
    Expect(0, 5024, '\p{ethiopicsupplement}', "");
    Expect(1, 5024, '\p{^ethiopicsupplement}', "");
    Expect(1, 5024, '\P{ethiopicsupplement}', "");
    Expect(0, 5024, '\P{^ethiopicsupplement}', "");
    Expect(1, 5023, '\p{	ethiopic_supplement}', "");
    Expect(0, 5023, '\p{^	ethiopic_supplement}', "");
    Expect(0, 5023, '\P{	ethiopic_supplement}', "");
    Expect(1, 5023, '\P{^	ethiopic_supplement}', "");
    Expect(0, 5024, '\p{	ethiopic_supplement}', "");
    Expect(1, 5024, '\p{^	ethiopic_supplement}', "");
    Expect(1, 5024, '\P{	ethiopic_supplement}', "");
    Expect(0, 5024, '\P{^	ethiopic_supplement}', "");
    Error('\p{/a/	 IS_ethiopic_Supplement}');
    Error('\P{/a/	 IS_ethiopic_Supplement}');
    Expect(1, 5023, '\p{isethiopicsupplement}', "");
    Expect(0, 5023, '\p{^isethiopicsupplement}', "");
    Expect(0, 5023, '\P{isethiopicsupplement}', "");
    Expect(1, 5023, '\P{^isethiopicsupplement}', "");
    Expect(0, 5024, '\p{isethiopicsupplement}', "");
    Expect(1, 5024, '\p{^isethiopicsupplement}', "");
    Expect(1, 5024, '\P{isethiopicsupplement}', "");
    Expect(0, 5024, '\P{^isethiopicsupplement}', "");
    Expect(1, 5023, '\p{  is_ethiopic_SUPPLEMENT}', "");
    Expect(0, 5023, '\p{^  is_ethiopic_SUPPLEMENT}', "");
    Expect(0, 5023, '\P{  is_ethiopic_SUPPLEMENT}', "");
    Expect(1, 5023, '\P{^  is_ethiopic_SUPPLEMENT}', "");
    Expect(0, 5024, '\p{  is_ethiopic_SUPPLEMENT}', "");
    Expect(1, 5024, '\p{^  is_ethiopic_SUPPLEMENT}', "");
    Expect(1, 5024, '\P{  is_ethiopic_SUPPLEMENT}', "");
    Expect(0, 5024, '\P{^  is_ethiopic_SUPPLEMENT}', "");
    Error('\p{:= _IN_Ethiopic_supplement}');
    Error('\P{:= _IN_Ethiopic_supplement}');
    Expect(1, 5023, '\p{inethiopicsupplement}', "");
    Expect(0, 5023, '\p{^inethiopicsupplement}', "");
    Expect(0, 5023, '\P{inethiopicsupplement}', "");
    Expect(1, 5023, '\P{^inethiopicsupplement}', "");
    Expect(0, 5024, '\p{inethiopicsupplement}', "");
    Expect(1, 5024, '\p{^inethiopicsupplement}', "");
    Expect(1, 5024, '\P{inethiopicsupplement}', "");
    Expect(0, 5024, '\P{^inethiopicsupplement}', "");
    Expect(1, 5023, '\p{_IN_Ethiopic_SUPPLEMENT}', "");
    Expect(0, 5023, '\p{^_IN_Ethiopic_SUPPLEMENT}', "");
    Expect(0, 5023, '\P{_IN_Ethiopic_SUPPLEMENT}', "");
    Expect(1, 5023, '\P{^_IN_Ethiopic_SUPPLEMENT}', "");
    Expect(0, 5024, '\p{_IN_Ethiopic_SUPPLEMENT}', "");
    Expect(1, 5024, '\p{^_IN_Ethiopic_SUPPLEMENT}', "");
    Expect(1, 5024, '\P{_IN_Ethiopic_SUPPLEMENT}', "");
    Expect(0, 5024, '\P{^_IN_Ethiopic_SUPPLEMENT}', "");
    Error('\p{/a/ Ethiopic_Sup}');
    Error('\P{/a/ Ethiopic_Sup}');
    Expect(1, 5023, '\p{ethiopicsup}', "");
    Expect(0, 5023, '\p{^ethiopicsup}', "");
    Expect(0, 5023, '\P{ethiopicsup}', "");
    Expect(1, 5023, '\P{^ethiopicsup}', "");
    Expect(0, 5024, '\p{ethiopicsup}', "");
    Expect(1, 5024, '\p{^ethiopicsup}', "");
    Expect(1, 5024, '\P{ethiopicsup}', "");
    Expect(0, 5024, '\P{^ethiopicsup}', "");
    Expect(1, 5023, '\p{ -Ethiopic_Sup}', "");
    Expect(0, 5023, '\p{^ -Ethiopic_Sup}', "");
    Expect(0, 5023, '\P{ -Ethiopic_Sup}', "");
    Expect(1, 5023, '\P{^ -Ethiopic_Sup}', "");
    Expect(0, 5024, '\p{ -Ethiopic_Sup}', "");
    Expect(1, 5024, '\p{^ -Ethiopic_Sup}', "");
    Expect(1, 5024, '\P{ -Ethiopic_Sup}', "");
    Expect(0, 5024, '\P{^ -Ethiopic_Sup}', "");
    Error('\p{-/a/Is_ethiopic_Sup}');
    Error('\P{-/a/Is_ethiopic_Sup}');
    Expect(1, 5023, '\p{isethiopicsup}', "");
    Expect(0, 5023, '\p{^isethiopicsup}', "");
    Expect(0, 5023, '\P{isethiopicsup}', "");
    Expect(1, 5023, '\P{^isethiopicsup}', "");
    Expect(0, 5024, '\p{isethiopicsup}', "");
    Expect(1, 5024, '\p{^isethiopicsup}', "");
    Expect(1, 5024, '\P{isethiopicsup}', "");
    Expect(0, 5024, '\P{^isethiopicsup}', "");
    Expect(1, 5023, '\p{ Is_ethiopic_sup}', "");
    Expect(0, 5023, '\p{^ Is_ethiopic_sup}', "");
    Expect(0, 5023, '\P{ Is_ethiopic_sup}', "");
    Expect(1, 5023, '\P{^ Is_ethiopic_sup}', "");
    Expect(0, 5024, '\p{ Is_ethiopic_sup}', "");
    Expect(1, 5024, '\p{^ Is_ethiopic_sup}', "");
    Expect(1, 5024, '\P{ Is_ethiopic_sup}', "");
    Expect(0, 5024, '\P{^ Is_ethiopic_sup}', "");
    Error('\p{/a/_-IN_ethiopic_Sup}');
    Error('\P{/a/_-IN_ethiopic_Sup}');
    Expect(1, 5023, '\p{inethiopicsup}', "");
    Expect(0, 5023, '\p{^inethiopicsup}', "");
    Expect(0, 5023, '\P{inethiopicsup}', "");
    Expect(1, 5023, '\P{^inethiopicsup}', "");
    Expect(0, 5024, '\p{inethiopicsup}', "");
    Expect(1, 5024, '\p{^inethiopicsup}', "");
    Expect(1, 5024, '\P{inethiopicsup}', "");
    Expect(0, 5024, '\P{^inethiopicsup}', "");
    Expect(1, 5023, '\p{__in_Ethiopic_SUP}', "");
    Expect(0, 5023, '\p{^__in_Ethiopic_SUP}', "");
    Expect(0, 5023, '\P{__in_Ethiopic_SUP}', "");
    Expect(1, 5023, '\P{^__in_Ethiopic_SUP}', "");
    Expect(0, 5024, '\p{__in_Ethiopic_SUP}', "");
    Expect(1, 5024, '\p{^__in_Ethiopic_SUP}', "");
    Expect(1, 5024, '\P{__in_Ethiopic_SUP}', "");
    Expect(0, 5024, '\P{^__in_Ethiopic_SUP}', "");
    Error('\p{Expands_On_NFC}');
    Error('\P{Expands_On_NFC}');
    Error('\p{Is_Expands_On_NFC}');
    Error('\P{Is_Expands_On_NFC}');
    Error('\p{XO_NFC}');
    Error('\P{XO_NFC}');
    Error('\p{Is_XO_NFC}');
    Error('\P{Is_XO_NFC}');
    Error('\p{Expands_On_NFD}');
    Error('\P{Expands_On_NFD}');
    Error('\p{Is_Expands_On_NFD}');
    Error('\P{Is_Expands_On_NFD}');
    Error('\p{XO_NFD}');
    Error('\P{XO_NFD}');
    Error('\p{Is_XO_NFD}');
    Error('\P{Is_XO_NFD}');
    Error('\p{Expands_On_NFKC}');
    Error('\P{Expands_On_NFKC}');
    Error('\p{Is_Expands_On_NFKC}');
    Error('\P{Is_Expands_On_NFKC}');
    Error('\p{XO_NFKC}');
    Error('\P{XO_NFKC}');
    Error('\p{Is_XO_NFKC}');
    Error('\P{Is_XO_NFKC}');
    Error('\p{Expands_On_NFKD}');
    Error('\P{Expands_On_NFKD}');
    Error('\p{Is_Expands_On_NFKD}');
    Error('\P{Is_Expands_On_NFKD}');
    Error('\p{XO_NFKD}');
    Error('\P{XO_NFKD}');
    Error('\p{Is_XO_NFKD}');
    Error('\P{Is_XO_NFKD}');
    Error('\p{:=_ EXTENDER}');
    Error('\P{:=_ EXTENDER}');
    Expect(1, 125254, '\p{extender}', "");
    Expect(0, 125254, '\p{^extender}', "");
    Expect(0, 125254, '\P{extender}', "");
    Expect(1, 125254, '\P{^extender}', "");
    Expect(0, 125255, '\p{extender}', "");
    Expect(1, 125255, '\p{^extender}', "");
    Expect(1, 125255, '\P{extender}', "");
    Expect(0, 125255, '\P{^extender}', "");
    Expect(1, 125254, '\p{_extender}', "");
    Expect(0, 125254, '\p{^_extender}', "");
    Expect(0, 125254, '\P{_extender}', "");
    Expect(1, 125254, '\P{^_extender}', "");
    Expect(0, 125255, '\p{_extender}', "");
    Expect(1, 125255, '\p{^_extender}', "");
    Expect(1, 125255, '\P{_extender}', "");
    Expect(0, 125255, '\P{^_extender}', "");
    Error('\p{	/a/Is_Extender}');
    Error('\P{	/a/Is_Extender}');
    Expect(1, 125254, '\p{isextender}', "");
    Expect(0, 125254, '\p{^isextender}', "");
    Expect(0, 125254, '\P{isextender}', "");
    Expect(1, 125254, '\P{^isextender}', "");
    Expect(0, 125255, '\p{isextender}', "");
    Expect(1, 125255, '\p{^isextender}', "");
    Expect(1, 125255, '\P{isextender}', "");
    Expect(0, 125255, '\P{^isextender}', "");
    Expect(1, 125254, '\p{	Is_extender}', "");
    Expect(0, 125254, '\p{^	Is_extender}', "");
    Expect(0, 125254, '\P{	Is_extender}', "");
    Expect(1, 125254, '\P{^	Is_extender}', "");
    Expect(0, 125255, '\p{	Is_extender}', "");
    Expect(1, 125255, '\p{^	Is_extender}', "");
    Expect(1, 125255, '\P{	Is_extender}', "");
    Expect(0, 125255, '\P{^	Is_extender}', "");
    Error('\p{/a/	EXT}');
    Error('\P{/a/	EXT}');
    Expect(1, 125254, '\p{ext}', "");
    Expect(0, 125254, '\p{^ext}', "");
    Expect(0, 125254, '\P{ext}', "");
    Expect(1, 125254, '\P{^ext}', "");
    Expect(0, 125255, '\p{ext}', "");
    Expect(1, 125255, '\p{^ext}', "");
    Expect(1, 125255, '\P{ext}', "");
    Expect(0, 125255, '\P{^ext}', "");
    Expect(1, 125254, '\p{_Ext}', "");
    Expect(0, 125254, '\p{^_Ext}', "");
    Expect(0, 125254, '\P{_Ext}', "");
    Expect(1, 125254, '\P{^_Ext}', "");
    Expect(0, 125255, '\p{_Ext}', "");
    Expect(1, 125255, '\p{^_Ext}', "");
    Expect(1, 125255, '\P{_Ext}', "");
    Expect(0, 125255, '\P{^_Ext}', "");
    Error('\p{ /a/is_Ext}');
    Error('\P{ /a/is_Ext}');
    Expect(1, 125254, '\p{isext}', "");
    Expect(0, 125254, '\p{^isext}', "");
    Expect(0, 125254, '\P{isext}', "");
    Expect(1, 125254, '\P{^isext}', "");
    Expect(0, 125255, '\p{isext}', "");
    Expect(1, 125255, '\p{^isext}', "");
    Expect(1, 125255, '\P{isext}', "");
    Expect(0, 125255, '\P{^isext}', "");
    Expect(1, 125254, '\p{		is_ext}', "");
    Expect(0, 125254, '\p{^		is_ext}', "");
    Expect(0, 125254, '\P{		is_ext}', "");
    Expect(1, 125254, '\P{^		is_ext}', "");
    Expect(0, 125255, '\p{		is_ext}', "");
    Expect(1, 125255, '\p{^		is_ext}', "");
    Expect(1, 125255, '\P{		is_ext}', "");
    Expect(0, 125255, '\P{^		is_ext}', "");
    Error('\p{/a/ Final_punctuation}');
    Error('\P{/a/ Final_punctuation}');
    Expect(1, 11809, '\p{finalpunctuation}', "");
    Expect(0, 11809, '\p{^finalpunctuation}', "");
    Expect(0, 11809, '\P{finalpunctuation}', "");
    Expect(1, 11809, '\P{^finalpunctuation}', "");
    Expect(0, 11810, '\p{finalpunctuation}', "");
    Expect(1, 11810, '\p{^finalpunctuation}', "");
    Expect(1, 11810, '\P{finalpunctuation}', "");
    Expect(0, 11810, '\P{^finalpunctuation}', "");
    Expect(1, 11809, '\p{ _final_punctuation}', "");
    Expect(0, 11809, '\p{^ _final_punctuation}', "");
    Expect(0, 11809, '\P{ _final_punctuation}', "");
    Expect(1, 11809, '\P{^ _final_punctuation}', "");
    Expect(0, 11810, '\p{ _final_punctuation}', "");
    Expect(1, 11810, '\p{^ _final_punctuation}', "");
    Expect(1, 11810, '\P{ _final_punctuation}', "");
    Expect(0, 11810, '\P{^ _final_punctuation}', "");
    Error('\p{-IS_final_Punctuation/a/}');
    Error('\P{-IS_final_Punctuation/a/}');
    Expect(1, 11809, '\p{isfinalpunctuation}', "");
    Expect(0, 11809, '\p{^isfinalpunctuation}', "");
    Expect(0, 11809, '\P{isfinalpunctuation}', "");
    Expect(1, 11809, '\P{^isfinalpunctuation}', "");
    Expect(0, 11810, '\p{isfinalpunctuation}', "");
    Expect(1, 11810, '\p{^isfinalpunctuation}', "");
    Expect(1, 11810, '\P{isfinalpunctuation}', "");
    Expect(0, 11810, '\P{^isfinalpunctuation}', "");
    Expect(1, 11809, '\p{_	Is_Final_PUNCTUATION}', "");
    Expect(0, 11809, '\p{^_	Is_Final_PUNCTUATION}', "");
    Expect(0, 11809, '\P{_	Is_Final_PUNCTUATION}', "");
    Expect(1, 11809, '\P{^_	Is_Final_PUNCTUATION}', "");
    Expect(0, 11810, '\p{_	Is_Final_PUNCTUATION}', "");
    Expect(1, 11810, '\p{^_	Is_Final_PUNCTUATION}', "");
    Expect(1, 11810, '\P{_	Is_Final_PUNCTUATION}', "");
    Expect(0, 11810, '\P{^_	Is_Final_PUNCTUATION}', "");
    Error('\p{:=- PF}');
    Error('\P{:=- PF}');
    Expect(1, 11809, '\p{pf}', "");
    Expect(0, 11809, '\p{^pf}', "");
    Expect(0, 11809, '\P{pf}', "");
    Expect(1, 11809, '\P{^pf}', "");
    Expect(0, 11810, '\p{pf}', "");
    Expect(1, 11810, '\p{^pf}', "");
    Expect(1, 11810, '\P{pf}', "");
    Expect(0, 11810, '\P{^pf}', "");
    Expect(1, 11809, '\p{_ pf}', "");
    Expect(0, 11809, '\p{^_ pf}', "");
    Expect(0, 11809, '\P{_ pf}', "");
    Expect(1, 11809, '\P{^_ pf}', "");
    Expect(0, 11810, '\p{_ pf}', "");
    Expect(1, 11810, '\p{^_ pf}', "");
    Expect(1, 11810, '\P{_ pf}', "");
    Expect(0, 11810, '\P{^_ pf}', "");
    Error('\p{-_IS_PF:=}');
    Error('\P{-_IS_PF:=}');
    Expect(1, 11809, '\p{ispf}', "");
    Expect(0, 11809, '\p{^ispf}', "");
    Expect(0, 11809, '\P{ispf}', "");
    Expect(1, 11809, '\P{^ispf}', "");
    Expect(0, 11810, '\p{ispf}', "");
    Expect(1, 11810, '\p{^ispf}', "");
    Expect(1, 11810, '\P{ispf}', "");
    Expect(0, 11810, '\P{^ispf}', "");
    Expect(1, 11809, '\p{_Is_Pf}', "");
    Expect(0, 11809, '\p{^_Is_Pf}', "");
    Expect(0, 11809, '\P{_Is_Pf}', "");
    Expect(1, 11809, '\P{^_Is_Pf}', "");
    Expect(0, 11810, '\p{_Is_Pf}', "");
    Expect(1, 11810, '\p{^_Is_Pf}', "");
    Expect(1, 11810, '\P{_Is_Pf}', "");
    Expect(0, 11810, '\P{^_Is_Pf}', "");
    Error('\p{:=Format}');
    Error('\P{:=Format}');
    Expect(1, 917631, '\p{format}', "");
    Expect(0, 917631, '\p{^format}', "");
    Expect(0, 917631, '\P{format}', "");
    Expect(1, 917631, '\P{^format}', "");
    Expect(0, 917632, '\p{format}', "");
    Expect(1, 917632, '\p{^format}', "");
    Expect(1, 917632, '\P{format}', "");
    Expect(0, 917632, '\P{^format}', "");
    Expect(1, 917631, '\p{ -format}', "");
    Expect(0, 917631, '\p{^ -format}', "");
    Expect(0, 917631, '\P{ -format}', "");
    Expect(1, 917631, '\P{^ -format}', "");
    Expect(0, 917632, '\p{ -format}', "");
    Expect(1, 917632, '\p{^ -format}', "");
    Expect(1, 917632, '\P{ -format}', "");
    Expect(0, 917632, '\P{^ -format}', "");
    Error('\p{:=  Is_Format}');
    Error('\P{:=  Is_Format}');
    Expect(1, 917631, '\p{isformat}', "");
    Expect(0, 917631, '\p{^isformat}', "");
    Expect(0, 917631, '\P{isformat}', "");
    Expect(1, 917631, '\P{^isformat}', "");
    Expect(0, 917632, '\p{isformat}', "");
    Expect(1, 917632, '\p{^isformat}', "");
    Expect(1, 917632, '\P{isformat}', "");
    Expect(0, 917632, '\P{^isformat}', "");
    Expect(1, 917631, '\p{-Is_FORMAT}', "");
    Expect(0, 917631, '\p{^-Is_FORMAT}', "");
    Expect(0, 917631, '\P{-Is_FORMAT}', "");
    Expect(1, 917631, '\P{^-Is_FORMAT}', "");
    Expect(0, 917632, '\p{-Is_FORMAT}', "");
    Expect(1, 917632, '\p{^-Is_FORMAT}', "");
    Expect(1, 917632, '\P{-Is_FORMAT}', "");
    Expect(0, 917632, '\P{^-Is_FORMAT}', "");
    Error('\p{CF:=}');
    Error('\P{CF:=}');
    Expect(1, 917631, '\p{cf}', "");
    Expect(0, 917631, '\p{^cf}', "");
    Expect(0, 917631, '\P{cf}', "");
    Expect(1, 917631, '\P{^cf}', "");
    Expect(0, 917632, '\p{cf}', "");
    Expect(1, 917632, '\p{^cf}', "");
    Expect(1, 917632, '\P{cf}', "");
    Expect(0, 917632, '\P{^cf}', "");
    Expect(1, 917631, '\p{-	Cf}', "");
    Expect(0, 917631, '\p{^-	Cf}', "");
    Expect(0, 917631, '\P{-	Cf}', "");
    Expect(1, 917631, '\P{^-	Cf}', "");
    Expect(0, 917632, '\p{-	Cf}', "");
    Expect(1, 917632, '\p{^-	Cf}', "");
    Expect(1, 917632, '\P{-	Cf}', "");
    Expect(0, 917632, '\P{^-	Cf}', "");
    Error('\p{/a/_ is_CF}');
    Error('\P{/a/_ is_CF}');
    Expect(1, 917631, '\p{iscf}', "");
    Expect(0, 917631, '\p{^iscf}', "");
    Expect(0, 917631, '\P{iscf}', "");
    Expect(1, 917631, '\P{^iscf}', "");
    Expect(0, 917632, '\p{iscf}', "");
    Expect(1, 917632, '\p{^iscf}', "");
    Expect(1, 917632, '\P{iscf}', "");
    Expect(0, 917632, '\P{^iscf}', "");
    Expect(1, 917631, '\p{ _is_CF}', "");
    Expect(0, 917631, '\p{^ _is_CF}', "");
    Expect(0, 917631, '\P{ _is_CF}', "");
    Expect(1, 917631, '\P{^ _is_CF}', "");
    Expect(0, 917632, '\p{ _is_CF}', "");
    Expect(1, 917632, '\p{^ _is_CF}', "");
    Expect(1, 917632, '\P{ _is_CF}', "");
    Expect(0, 917632, '\P{^ _is_CF}', "");
    Error('\p{/a/Full_COMPOSITION_exclusion}');
    Error('\P{/a/Full_COMPOSITION_exclusion}');
    Expect(1, 195101, '\p{fullcompositionexclusion}', "");
    Expect(0, 195101, '\p{^fullcompositionexclusion}', "");
    Expect(0, 195101, '\P{fullcompositionexclusion}', "");
    Expect(1, 195101, '\P{^fullcompositionexclusion}', "");
    Expect(0, 195102, '\p{fullcompositionexclusion}', "");
    Expect(1, 195102, '\p{^fullcompositionexclusion}', "");
    Expect(1, 195102, '\P{fullcompositionexclusion}', "");
    Expect(0, 195102, '\P{^fullcompositionexclusion}', "");
    Expect(1, 195101, '\p{	_Full_Composition_Exclusion}', "");
    Expect(0, 195101, '\p{^	_Full_Composition_Exclusion}', "");
    Expect(0, 195101, '\P{	_Full_Composition_Exclusion}', "");
    Expect(1, 195101, '\P{^	_Full_Composition_Exclusion}', "");
    Expect(0, 195102, '\p{	_Full_Composition_Exclusion}', "");
    Expect(1, 195102, '\p{^	_Full_Composition_Exclusion}', "");
    Expect(1, 195102, '\P{	_Full_Composition_Exclusion}', "");
    Expect(0, 195102, '\P{^	_Full_Composition_Exclusion}', "");
    Error('\p{-:=Is_FULL_Composition_EXCLUSION}');
    Error('\P{-:=Is_FULL_Composition_EXCLUSION}');
    Expect(1, 195101, '\p{isfullcompositionexclusion}', "");
    Expect(0, 195101, '\p{^isfullcompositionexclusion}', "");
    Expect(0, 195101, '\P{isfullcompositionexclusion}', "");
    Expect(1, 195101, '\P{^isfullcompositionexclusion}', "");
    Expect(0, 195102, '\p{isfullcompositionexclusion}', "");
    Expect(1, 195102, '\p{^isfullcompositionexclusion}', "");
    Expect(1, 195102, '\P{isfullcompositionexclusion}', "");
    Expect(0, 195102, '\P{^isfullcompositionexclusion}', "");
    Expect(1, 195101, '\p{		is_FULL_Composition_EXCLUSION}', "");
    Expect(0, 195101, '\p{^		is_FULL_Composition_EXCLUSION}', "");
    Expect(0, 195101, '\P{		is_FULL_Composition_EXCLUSION}', "");
    Expect(1, 195101, '\P{^		is_FULL_Composition_EXCLUSION}', "");
    Expect(0, 195102, '\p{		is_FULL_Composition_EXCLUSION}', "");
    Expect(1, 195102, '\p{^		is_FULL_Composition_EXCLUSION}', "");
    Expect(1, 195102, '\P{		is_FULL_Composition_EXCLUSION}', "");
    Expect(0, 195102, '\P{^		is_FULL_Composition_EXCLUSION}', "");
    Error('\p{/a/	-COMP_Ex}');
    Error('\P{/a/	-COMP_Ex}');
    Expect(1, 195101, '\p{compex}', "");
    Expect(0, 195101, '\p{^compex}', "");
    Expect(0, 195101, '\P{compex}', "");
    Expect(1, 195101, '\P{^compex}', "");
    Expect(0, 195102, '\p{compex}', "");
    Expect(1, 195102, '\p{^compex}', "");
    Expect(1, 195102, '\P{compex}', "");
    Expect(0, 195102, '\P{^compex}', "");
    Expect(1, 195101, '\p{_COMP_Ex}', "");
    Expect(0, 195101, '\p{^_COMP_Ex}', "");
    Expect(0, 195101, '\P{_COMP_Ex}', "");
    Expect(1, 195101, '\P{^_COMP_Ex}', "");
    Expect(0, 195102, '\p{_COMP_Ex}', "");
    Expect(1, 195102, '\p{^_COMP_Ex}', "");
    Expect(1, 195102, '\P{_COMP_Ex}', "");
    Expect(0, 195102, '\P{^_COMP_Ex}', "");
    Error('\p{:=- Is_comp_EX}');
    Error('\P{:=- Is_comp_EX}');
    Expect(1, 195101, '\p{iscompex}', "");
    Expect(0, 195101, '\p{^iscompex}', "");
    Expect(0, 195101, '\P{iscompex}', "");
    Expect(1, 195101, '\P{^iscompex}', "");
    Expect(0, 195102, '\p{iscompex}', "");
    Expect(1, 195102, '\p{^iscompex}', "");
    Expect(1, 195102, '\P{iscompex}', "");
    Expect(0, 195102, '\P{^iscompex}', "");
    Expect(1, 195101, '\p{ _IS_Comp_EX}', "");
    Expect(0, 195101, '\p{^ _IS_Comp_EX}', "");
    Expect(0, 195101, '\P{ _IS_Comp_EX}', "");
    Expect(1, 195101, '\P{^ _IS_Comp_EX}', "");
    Expect(0, 195102, '\p{ _IS_Comp_EX}', "");
    Expect(1, 195102, '\p{^ _IS_Comp_EX}', "");
    Expect(1, 195102, '\P{ _IS_Comp_EX}', "");
    Expect(0, 195102, '\P{^ _IS_Comp_EX}', "");
    Error('\p{-/a/general_punctuation}');
    Error('\P{-/a/general_punctuation}');
    Expect(1, 8303, '\p{generalpunctuation}', "");
    Expect(0, 8303, '\p{^generalpunctuation}', "");
    Expect(0, 8303, '\P{generalpunctuation}', "");
    Expect(1, 8303, '\P{^generalpunctuation}', "");
    Expect(0, 8304, '\p{generalpunctuation}', "");
    Expect(1, 8304, '\p{^generalpunctuation}', "");
    Expect(1, 8304, '\P{generalpunctuation}', "");
    Expect(0, 8304, '\P{^generalpunctuation}', "");
    Expect(1, 8303, '\p{ GENERAL_Punctuation}', "");
    Expect(0, 8303, '\p{^ GENERAL_Punctuation}', "");
    Expect(0, 8303, '\P{ GENERAL_Punctuation}', "");
    Expect(1, 8303, '\P{^ GENERAL_Punctuation}', "");
    Expect(0, 8304, '\p{ GENERAL_Punctuation}', "");
    Expect(1, 8304, '\p{^ GENERAL_Punctuation}', "");
    Expect(1, 8304, '\P{ GENERAL_Punctuation}', "");
    Expect(0, 8304, '\P{^ GENERAL_Punctuation}', "");
    Error('\p{_/a/Is_GENERAL_Punctuation}');
    Error('\P{_/a/Is_GENERAL_Punctuation}');
    Expect(1, 8303, '\p{isgeneralpunctuation}', "");
    Expect(0, 8303, '\p{^isgeneralpunctuation}', "");
    Expect(0, 8303, '\P{isgeneralpunctuation}', "");
    Expect(1, 8303, '\P{^isgeneralpunctuation}', "");
    Expect(0, 8304, '\p{isgeneralpunctuation}', "");
    Expect(1, 8304, '\p{^isgeneralpunctuation}', "");
    Expect(1, 8304, '\P{isgeneralpunctuation}', "");
    Expect(0, 8304, '\P{^isgeneralpunctuation}', "");
    Expect(1, 8303, '\p{-	is_GENERAL_PUNCTUATION}', "");
    Expect(0, 8303, '\p{^-	is_GENERAL_PUNCTUATION}', "");
    Expect(0, 8303, '\P{-	is_GENERAL_PUNCTUATION}', "");
    Expect(1, 8303, '\P{^-	is_GENERAL_PUNCTUATION}', "");
    Expect(0, 8304, '\p{-	is_GENERAL_PUNCTUATION}', "");
    Expect(1, 8304, '\p{^-	is_GENERAL_PUNCTUATION}', "");
    Expect(1, 8304, '\P{-	is_GENERAL_PUNCTUATION}', "");
    Expect(0, 8304, '\P{^-	is_GENERAL_PUNCTUATION}', "");
    Error('\p{/a/IN_General_Punctuation}');
    Error('\P{/a/IN_General_Punctuation}');
    Expect(1, 8303, '\p{ingeneralpunctuation}', "");
    Expect(0, 8303, '\p{^ingeneralpunctuation}', "");
    Expect(0, 8303, '\P{ingeneralpunctuation}', "");
    Expect(1, 8303, '\P{^ingeneralpunctuation}', "");
    Expect(0, 8304, '\p{ingeneralpunctuation}', "");
    Expect(1, 8304, '\p{^ingeneralpunctuation}', "");
    Expect(1, 8304, '\P{ingeneralpunctuation}', "");
    Expect(0, 8304, '\P{^ingeneralpunctuation}', "");
    Expect(1, 8303, '\p{ In_General_Punctuation}', "");
    Expect(0, 8303, '\p{^ In_General_Punctuation}', "");
    Expect(0, 8303, '\P{ In_General_Punctuation}', "");
    Expect(1, 8303, '\P{^ In_General_Punctuation}', "");
    Expect(0, 8304, '\p{ In_General_Punctuation}', "");
    Expect(1, 8304, '\p{^ In_General_Punctuation}', "");
    Expect(1, 8304, '\P{ In_General_Punctuation}', "");
    Expect(0, 8304, '\P{^ In_General_Punctuation}', "");
    Error('\p{:= In_PUNCTUATION}');
    Error('\P{:= In_PUNCTUATION}');
    Expect(1, 8303, '\p{inpunctuation}', "");
    Expect(0, 8303, '\p{^inpunctuation}', "");
    Expect(0, 8303, '\P{inpunctuation}', "");
    Expect(1, 8303, '\P{^inpunctuation}', "");
    Expect(0, 8304, '\p{inpunctuation}', "");
    Expect(1, 8304, '\p{^inpunctuation}', "");
    Expect(1, 8304, '\P{inpunctuation}', "");
    Expect(0, 8304, '\P{^inpunctuation}', "");
    Expect(1, 8303, '\p{ 	in_punctuation}', "");
    Expect(0, 8303, '\p{^ 	in_punctuation}', "");
    Expect(0, 8303, '\P{ 	in_punctuation}', "");
    Expect(1, 8303, '\P{^ 	in_punctuation}', "");
    Expect(0, 8304, '\p{ 	in_punctuation}', "");
    Expect(1, 8304, '\p{^ 	in_punctuation}', "");
    Expect(1, 8304, '\P{ 	in_punctuation}', "");
    Expect(0, 8304, '\P{^ 	in_punctuation}', "");
    Error('\p{/a/ geometric_SHAPES}');
    Error('\P{/a/ geometric_SHAPES}');
    Expect(1, 9727, '\p{geometricshapes}', "");
    Expect(0, 9727, '\p{^geometricshapes}', "");
    Expect(0, 9727, '\P{geometricshapes}', "");
    Expect(1, 9727, '\P{^geometricshapes}', "");
    Expect(0, 9728, '\p{geometricshapes}', "");
    Expect(1, 9728, '\p{^geometricshapes}', "");
    Expect(1, 9728, '\P{geometricshapes}', "");
    Expect(0, 9728, '\P{^geometricshapes}', "");
    Expect(1, 9727, '\p{-	GEOMETRIC_SHAPES}', "");
    Expect(0, 9727, '\p{^-	GEOMETRIC_SHAPES}', "");
    Expect(0, 9727, '\P{-	GEOMETRIC_SHAPES}', "");
    Expect(1, 9727, '\P{^-	GEOMETRIC_SHAPES}', "");
    Expect(0, 9728, '\p{-	GEOMETRIC_SHAPES}', "");
    Expect(1, 9728, '\p{^-	GEOMETRIC_SHAPES}', "");
    Expect(1, 9728, '\P{-	GEOMETRIC_SHAPES}', "");
    Expect(0, 9728, '\P{^-	GEOMETRIC_SHAPES}', "");
    Error('\p{/a/		IS_Geometric_Shapes}');
    Error('\P{/a/		IS_Geometric_Shapes}');
    Expect(1, 9727, '\p{isgeometricshapes}', "");
    Expect(0, 9727, '\p{^isgeometricshapes}', "");
    Expect(0, 9727, '\P{isgeometricshapes}', "");
    Expect(1, 9727, '\P{^isgeometricshapes}', "");
    Expect(0, 9728, '\p{isgeometricshapes}', "");
    Expect(1, 9728, '\p{^isgeometricshapes}', "");
    Expect(1, 9728, '\P{isgeometricshapes}', "");
    Expect(0, 9728, '\P{^isgeometricshapes}', "");
    Expect(1, 9727, '\p{	-IS_Geometric_Shapes}', "");
    Expect(0, 9727, '\p{^	-IS_Geometric_Shapes}', "");
    Expect(0, 9727, '\P{	-IS_Geometric_Shapes}', "");
    Expect(1, 9727, '\P{^	-IS_Geometric_Shapes}', "");
    Expect(0, 9728, '\p{	-IS_Geometric_Shapes}', "");
    Expect(1, 9728, '\p{^	-IS_Geometric_Shapes}', "");
    Expect(1, 9728, '\P{	-IS_Geometric_Shapes}', "");
    Expect(0, 9728, '\P{^	-IS_Geometric_Shapes}', "");
    Error('\p{:= _in_Geometric_shapes}');
    Error('\P{:= _in_Geometric_shapes}');
    Expect(1, 9727, '\p{ingeometricshapes}', "");
    Expect(0, 9727, '\p{^ingeometricshapes}', "");
    Expect(0, 9727, '\P{ingeometricshapes}', "");
    Expect(1, 9727, '\P{^ingeometricshapes}', "");
    Expect(0, 9728, '\p{ingeometricshapes}', "");
    Expect(1, 9728, '\p{^ingeometricshapes}', "");
    Expect(1, 9728, '\P{ingeometricshapes}', "");
    Expect(0, 9728, '\P{^ingeometricshapes}', "");
    Expect(1, 9727, '\p{-_In_geometric_shapes}', "");
    Expect(0, 9727, '\p{^-_In_geometric_shapes}', "");
    Expect(0, 9727, '\P{-_In_geometric_shapes}', "");
    Expect(1, 9727, '\P{^-_In_geometric_shapes}', "");
    Expect(0, 9728, '\p{-_In_geometric_shapes}', "");
    Expect(1, 9728, '\p{^-_In_geometric_shapes}', "");
    Expect(1, 9728, '\P{-_In_geometric_shapes}', "");
    Expect(0, 9728, '\P{^-_In_geometric_shapes}', "");
    Error('\p{-:=Geometric_shapes_Extended}');
    Error('\P{-:=Geometric_shapes_Extended}');
    Expect(1, 129023, '\p{geometricshapesextended}', "");
    Expect(0, 129023, '\p{^geometricshapesextended}', "");
    Expect(0, 129023, '\P{geometricshapesextended}', "");
    Expect(1, 129023, '\P{^geometricshapesextended}', "");
    Expect(0, 129024, '\p{geometricshapesextended}', "");
    Expect(1, 129024, '\p{^geometricshapesextended}', "");
    Expect(1, 129024, '\P{geometricshapesextended}', "");
    Expect(0, 129024, '\P{^geometricshapesextended}', "");
    Expect(1, 129023, '\p{-Geometric_SHAPES_Extended}', "");
    Expect(0, 129023, '\p{^-Geometric_SHAPES_Extended}', "");
    Expect(0, 129023, '\P{-Geometric_SHAPES_Extended}', "");
    Expect(1, 129023, '\P{^-Geometric_SHAPES_Extended}', "");
    Expect(0, 129024, '\p{-Geometric_SHAPES_Extended}', "");
    Expect(1, 129024, '\p{^-Geometric_SHAPES_Extended}', "");
    Expect(1, 129024, '\P{-Geometric_SHAPES_Extended}', "");
    Expect(0, 129024, '\P{^-Geometric_SHAPES_Extended}', "");
    Error('\p{:=_-is_Geometric_shapes_EXTENDED}');
    Error('\P{:=_-is_Geometric_shapes_EXTENDED}');
    Expect(1, 129023, '\p{isgeometricshapesextended}', "");
    Expect(0, 129023, '\p{^isgeometricshapesextended}', "");
    Expect(0, 129023, '\P{isgeometricshapesextended}', "");
    Expect(1, 129023, '\P{^isgeometricshapesextended}', "");
    Expect(0, 129024, '\p{isgeometricshapesextended}', "");
    Expect(1, 129024, '\p{^isgeometricshapesextended}', "");
    Expect(1, 129024, '\P{isgeometricshapesextended}', "");
    Expect(0, 129024, '\P{^isgeometricshapesextended}', "");
    Expect(1, 129023, '\p{is_GEOMETRIC_SHAPES_Extended}', "");
    Expect(0, 129023, '\p{^is_GEOMETRIC_SHAPES_Extended}', "");
    Expect(0, 129023, '\P{is_GEOMETRIC_SHAPES_Extended}', "");
    Expect(1, 129023, '\P{^is_GEOMETRIC_SHAPES_Extended}', "");
    Expect(0, 129024, '\p{is_GEOMETRIC_SHAPES_Extended}', "");
    Expect(1, 129024, '\p{^is_GEOMETRIC_SHAPES_Extended}', "");
    Expect(1, 129024, '\P{is_GEOMETRIC_SHAPES_Extended}', "");
    Expect(0, 129024, '\P{^is_GEOMETRIC_SHAPES_Extended}', "");
    Error('\p{_:=In_GEOMETRIC_Shapes_Extended}');
    Error('\P{_:=In_GEOMETRIC_Shapes_Extended}');
    Expect(1, 129023, '\p{ingeometricshapesextended}', "");
    Expect(0, 129023, '\p{^ingeometricshapesextended}', "");
    Expect(0, 129023, '\P{ingeometricshapesextended}', "");
    Expect(1, 129023, '\P{^ingeometricshapesextended}', "");
    Expect(0, 129024, '\p{ingeometricshapesextended}', "");
    Expect(1, 129024, '\p{^ingeometricshapesextended}', "");
    Expect(1, 129024, '\P{ingeometricshapesextended}', "");
    Expect(0, 129024, '\P{^ingeometricshapesextended}', "");
    Expect(1, 129023, '\p{	 in_Geometric_Shapes_EXTENDED}', "");
    Expect(0, 129023, '\p{^	 in_Geometric_Shapes_EXTENDED}', "");
    Expect(0, 129023, '\P{	 in_Geometric_Shapes_EXTENDED}', "");
    Expect(1, 129023, '\P{^	 in_Geometric_Shapes_EXTENDED}', "");
    Expect(0, 129024, '\p{	 in_Geometric_Shapes_EXTENDED}', "");
    Expect(1, 129024, '\p{^	 in_Geometric_Shapes_EXTENDED}', "");
    Expect(1, 129024, '\P{	 in_Geometric_Shapes_EXTENDED}', "");
    Expect(0, 129024, '\P{^	 in_Geometric_Shapes_EXTENDED}', "");
    Error('\p{	-geometric_Shapes_Ext/a/}');
    Error('\P{	-geometric_Shapes_Ext/a/}');
    Expect(1, 129023, '\p{geometricshapesext}', "");
    Expect(0, 129023, '\p{^geometricshapesext}', "");
    Expect(0, 129023, '\P{geometricshapesext}', "");
    Expect(1, 129023, '\P{^geometricshapesext}', "");
    Expect(0, 129024, '\p{geometricshapesext}', "");
    Expect(1, 129024, '\p{^geometricshapesext}', "");
    Expect(1, 129024, '\P{geometricshapesext}', "");
    Expect(0, 129024, '\P{^geometricshapesext}', "");
    Expect(1, 129023, '\p{ -Geometric_SHAPES_ext}', "");
    Expect(0, 129023, '\p{^ -Geometric_SHAPES_ext}', "");
    Expect(0, 129023, '\P{ -Geometric_SHAPES_ext}', "");
    Expect(1, 129023, '\P{^ -Geometric_SHAPES_ext}', "");
    Expect(0, 129024, '\p{ -Geometric_SHAPES_ext}', "");
    Expect(1, 129024, '\p{^ -Geometric_SHAPES_ext}', "");
    Expect(1, 129024, '\P{ -Geometric_SHAPES_ext}', "");
    Expect(0, 129024, '\P{^ -Geometric_SHAPES_ext}', "");
    Error('\p{	/a/Is_Geometric_Shapes_Ext}');
    Error('\P{	/a/Is_Geometric_Shapes_Ext}');
    Expect(1, 129023, '\p{isgeometricshapesext}', "");
    Expect(0, 129023, '\p{^isgeometricshapesext}', "");
    Expect(0, 129023, '\P{isgeometricshapesext}', "");
    Expect(1, 129023, '\P{^isgeometricshapesext}', "");
    Expect(0, 129024, '\p{isgeometricshapesext}', "");
    Expect(1, 129024, '\p{^isgeometricshapesext}', "");
    Expect(1, 129024, '\P{isgeometricshapesext}', "");
    Expect(0, 129024, '\P{^isgeometricshapesext}', "");
    Expect(1, 129023, '\p{	 IS_GEOMETRIC_Shapes_ext}', "");
    Expect(0, 129023, '\p{^	 IS_GEOMETRIC_Shapes_ext}', "");
    Expect(0, 129023, '\P{	 IS_GEOMETRIC_Shapes_ext}', "");
    Expect(1, 129023, '\P{^	 IS_GEOMETRIC_Shapes_ext}', "");
    Expect(0, 129024, '\p{	 IS_GEOMETRIC_Shapes_ext}', "");
    Expect(1, 129024, '\p{^	 IS_GEOMETRIC_Shapes_ext}', "");
    Expect(1, 129024, '\P{	 IS_GEOMETRIC_Shapes_ext}', "");
    Expect(0, 129024, '\P{^	 IS_GEOMETRIC_Shapes_ext}', "");
    Error('\p{_in_Geometric_Shapes_EXT/a/}');
    Error('\P{_in_Geometric_Shapes_EXT/a/}');
    Expect(1, 129023, '\p{ingeometricshapesext}', "");
    Expect(0, 129023, '\p{^ingeometricshapesext}', "");
    Expect(0, 129023, '\P{ingeometricshapesext}', "");
    Expect(1, 129023, '\P{^ingeometricshapesext}', "");
    Expect(0, 129024, '\p{ingeometricshapesext}', "");
    Expect(1, 129024, '\p{^ingeometricshapesext}', "");
    Expect(1, 129024, '\P{ingeometricshapesext}', "");
    Expect(0, 129024, '\P{^ingeometricshapesext}', "");
    Expect(1, 129023, '\p{_	In_Geometric_SHAPES_EXT}', "");
    Expect(0, 129023, '\p{^_	In_Geometric_SHAPES_EXT}', "");
    Expect(0, 129023, '\P{_	In_Geometric_SHAPES_EXT}', "");
    Expect(1, 129023, '\P{^_	In_Geometric_SHAPES_EXT}', "");
    Expect(0, 129024, '\p{_	In_Geometric_SHAPES_EXT}', "");
    Expect(1, 129024, '\p{^_	In_Geometric_SHAPES_EXT}', "");
    Expect(1, 129024, '\P{_	In_Geometric_SHAPES_EXT}', "");
    Expect(0, 129024, '\P{^_	In_Geometric_SHAPES_EXT}', "");
    Error('\p{/a/_	Georgian}');
    Error('\P{/a/_	Georgian}');
    Expect(1, 11565, '\p{georgian}', "");
    Expect(0, 11565, '\p{^georgian}', "");
    Expect(0, 11565, '\P{georgian}', "");
    Expect(1, 11565, '\P{^georgian}', "");
    Expect(0, 11566, '\p{georgian}', "");
    Expect(1, 11566, '\p{^georgian}', "");
    Expect(1, 11566, '\P{georgian}', "");
    Expect(0, 11566, '\P{^georgian}', "");
    Expect(1, 11565, '\p{_-georgian}', "");
    Expect(0, 11565, '\p{^_-georgian}', "");
    Expect(0, 11565, '\P{_-georgian}', "");
    Expect(1, 11565, '\P{^_-georgian}', "");
    Expect(0, 11566, '\p{_-georgian}', "");
    Expect(1, 11566, '\p{^_-georgian}', "");
    Expect(1, 11566, '\P{_-georgian}', "");
    Expect(0, 11566, '\P{^_-georgian}', "");
    Error('\p{_/a/Is_georgian}');
    Error('\P{_/a/Is_georgian}');
    Expect(1, 11565, '\p{isgeorgian}', "");
    Expect(0, 11565, '\p{^isgeorgian}', "");
    Expect(0, 11565, '\P{isgeorgian}', "");
    Expect(1, 11565, '\P{^isgeorgian}', "");
    Expect(0, 11566, '\p{isgeorgian}', "");
    Expect(1, 11566, '\p{^isgeorgian}', "");
    Expect(1, 11566, '\P{isgeorgian}', "");
    Expect(0, 11566, '\P{^isgeorgian}', "");
    Expect(1, 11565, '\p{- IS_Georgian}', "");
    Expect(0, 11565, '\p{^- IS_Georgian}', "");
    Expect(0, 11565, '\P{- IS_Georgian}', "");
    Expect(1, 11565, '\P{^- IS_Georgian}', "");
    Expect(0, 11566, '\p{- IS_Georgian}', "");
    Expect(1, 11566, '\p{^- IS_Georgian}', "");
    Expect(1, 11566, '\P{- IS_Georgian}', "");
    Expect(0, 11566, '\P{^- IS_Georgian}', "");
    Error('\p{  Geor:=}');
    Error('\P{  Geor:=}');
    Expect(1, 11565, '\p{geor}', "");
    Expect(0, 11565, '\p{^geor}', "");
    Expect(0, 11565, '\P{geor}', "");
    Expect(1, 11565, '\P{^geor}', "");
    Expect(0, 11566, '\p{geor}', "");
    Expect(1, 11566, '\p{^geor}', "");
    Expect(1, 11566, '\P{geor}', "");
    Expect(0, 11566, '\P{^geor}', "");
    Expect(1, 11565, '\p{__GEOR}', "");
    Expect(0, 11565, '\p{^__GEOR}', "");
    Expect(0, 11565, '\P{__GEOR}', "");
    Expect(1, 11565, '\P{^__GEOR}', "");
    Expect(0, 11566, '\p{__GEOR}', "");
    Expect(1, 11566, '\p{^__GEOR}', "");
    Expect(1, 11566, '\P{__GEOR}', "");
    Expect(0, 11566, '\P{^__GEOR}', "");
    Error('\p{:=-Is_Geor}');
    Error('\P{:=-Is_Geor}');
    Expect(1, 11565, '\p{isgeor}', "");
    Expect(0, 11565, '\p{^isgeor}', "");
    Expect(0, 11565, '\P{isgeor}', "");
    Expect(1, 11565, '\P{^isgeor}', "");
    Expect(0, 11566, '\p{isgeor}', "");
    Expect(1, 11566, '\p{^isgeor}', "");
    Expect(1, 11566, '\P{isgeor}', "");
    Expect(0, 11566, '\P{^isgeor}', "");
    Expect(1, 11565, '\p{Is_Geor}', "");
    Expect(0, 11565, '\p{^Is_Geor}', "");
    Expect(0, 11565, '\P{Is_Geor}', "");
    Expect(1, 11565, '\P{^Is_Geor}', "");
    Expect(0, 11566, '\p{Is_Geor}', "");
    Expect(1, 11566, '\p{^Is_Geor}', "");
    Expect(1, 11566, '\P{Is_Geor}', "");
    Expect(0, 11566, '\P{^Is_Geor}', "");
    Error('\p{ /a/GEORGIAN_supplement}');
    Error('\P{ /a/GEORGIAN_supplement}');
    Expect(1, 11567, '\p{georgiansupplement}', "");
    Expect(0, 11567, '\p{^georgiansupplement}', "");
    Expect(0, 11567, '\P{georgiansupplement}', "");
    Expect(1, 11567, '\P{^georgiansupplement}', "");
    Expect(0, 11568, '\p{georgiansupplement}', "");
    Expect(1, 11568, '\p{^georgiansupplement}', "");
    Expect(1, 11568, '\P{georgiansupplement}', "");
    Expect(0, 11568, '\P{^georgiansupplement}', "");
    Expect(1, 11567, '\p{-GEORGIAN_supplement}', "");
    Expect(0, 11567, '\p{^-GEORGIAN_supplement}', "");
    Expect(0, 11567, '\P{-GEORGIAN_supplement}', "");
    Expect(1, 11567, '\P{^-GEORGIAN_supplement}', "");
    Expect(0, 11568, '\p{-GEORGIAN_supplement}', "");
    Expect(1, 11568, '\p{^-GEORGIAN_supplement}', "");
    Expect(1, 11568, '\P{-GEORGIAN_supplement}', "");
    Expect(0, 11568, '\P{^-GEORGIAN_supplement}', "");
    Error('\p{ :=Is_GEORGIAN_Supplement}');
    Error('\P{ :=Is_GEORGIAN_Supplement}');
    Expect(1, 11567, '\p{isgeorgiansupplement}', "");
    Expect(0, 11567, '\p{^isgeorgiansupplement}', "");
    Expect(0, 11567, '\P{isgeorgiansupplement}', "");
    Expect(1, 11567, '\P{^isgeorgiansupplement}', "");
    Expect(0, 11568, '\p{isgeorgiansupplement}', "");
    Expect(1, 11568, '\p{^isgeorgiansupplement}', "");
    Expect(1, 11568, '\P{isgeorgiansupplement}', "");
    Expect(0, 11568, '\P{^isgeorgiansupplement}', "");
    Expect(1, 11567, '\p{  Is_GEORGIAN_supplement}', "");
    Expect(0, 11567, '\p{^  Is_GEORGIAN_supplement}', "");
    Expect(0, 11567, '\P{  Is_GEORGIAN_supplement}', "");
    Expect(1, 11567, '\P{^  Is_GEORGIAN_supplement}', "");
    Expect(0, 11568, '\p{  Is_GEORGIAN_supplement}', "");
    Expect(1, 11568, '\p{^  Is_GEORGIAN_supplement}', "");
    Expect(1, 11568, '\P{  Is_GEORGIAN_supplement}', "");
    Expect(0, 11568, '\P{^  Is_GEORGIAN_supplement}', "");
    Error('\p{/a/ In_georgian_Supplement}');
    Error('\P{/a/ In_georgian_Supplement}');
    Expect(1, 11567, '\p{ingeorgiansupplement}', "");
    Expect(0, 11567, '\p{^ingeorgiansupplement}', "");
    Expect(0, 11567, '\P{ingeorgiansupplement}', "");
    Expect(1, 11567, '\P{^ingeorgiansupplement}', "");
    Expect(0, 11568, '\p{ingeorgiansupplement}', "");
    Expect(1, 11568, '\p{^ingeorgiansupplement}', "");
    Expect(1, 11568, '\P{ingeorgiansupplement}', "");
    Expect(0, 11568, '\P{^ingeorgiansupplement}', "");
    Expect(1, 11567, '\p{ _In_georgian_SUPPLEMENT}', "");
    Expect(0, 11567, '\p{^ _In_georgian_SUPPLEMENT}', "");
    Expect(0, 11567, '\P{ _In_georgian_SUPPLEMENT}', "");
    Expect(1, 11567, '\P{^ _In_georgian_SUPPLEMENT}', "");
    Expect(0, 11568, '\p{ _In_georgian_SUPPLEMENT}', "");
    Expect(1, 11568, '\p{^ _In_georgian_SUPPLEMENT}', "");
    Expect(1, 11568, '\P{ _In_georgian_SUPPLEMENT}', "");
    Expect(0, 11568, '\P{^ _In_georgian_SUPPLEMENT}', "");
    Error('\p{:=__Georgian_Sup}');
    Error('\P{:=__Georgian_Sup}');
    Expect(1, 11567, '\p{georgiansup}', "");
    Expect(0, 11567, '\p{^georgiansup}', "");
    Expect(0, 11567, '\P{georgiansup}', "");
    Expect(1, 11567, '\P{^georgiansup}', "");
    Expect(0, 11568, '\p{georgiansup}', "");
    Expect(1, 11568, '\p{^georgiansup}', "");
    Expect(1, 11568, '\P{georgiansup}', "");
    Expect(0, 11568, '\P{^georgiansup}', "");
    Expect(1, 11567, '\p{_Georgian_Sup}', "");
    Expect(0, 11567, '\p{^_Georgian_Sup}', "");
    Expect(0, 11567, '\P{_Georgian_Sup}', "");
    Expect(1, 11567, '\P{^_Georgian_Sup}', "");
    Expect(0, 11568, '\p{_Georgian_Sup}', "");
    Expect(1, 11568, '\p{^_Georgian_Sup}', "");
    Expect(1, 11568, '\P{_Georgian_Sup}', "");
    Expect(0, 11568, '\P{^_Georgian_Sup}', "");
    Error('\p{	/a/IS_GEORGIAN_Sup}');
    Error('\P{	/a/IS_GEORGIAN_Sup}');
    Expect(1, 11567, '\p{isgeorgiansup}', "");
    Expect(0, 11567, '\p{^isgeorgiansup}', "");
    Expect(0, 11567, '\P{isgeorgiansup}', "");
    Expect(1, 11567, '\P{^isgeorgiansup}', "");
    Expect(0, 11568, '\p{isgeorgiansup}', "");
    Expect(1, 11568, '\p{^isgeorgiansup}', "");
    Expect(1, 11568, '\P{isgeorgiansup}', "");
    Expect(0, 11568, '\P{^isgeorgiansup}', "");
    Expect(1, 11567, '\p{	 Is_Georgian_SUP}', "");
    Expect(0, 11567, '\p{^	 Is_Georgian_SUP}', "");
    Expect(0, 11567, '\P{	 Is_Georgian_SUP}', "");
    Expect(1, 11567, '\P{^	 Is_Georgian_SUP}', "");
    Expect(0, 11568, '\p{	 Is_Georgian_SUP}', "");
    Expect(1, 11568, '\p{^	 Is_Georgian_SUP}', "");
    Expect(1, 11568, '\P{	 Is_Georgian_SUP}', "");
    Expect(0, 11568, '\P{^	 Is_Georgian_SUP}', "");
    Error('\p{	_In_Georgian_SUP/a/}');
    Error('\P{	_In_Georgian_SUP/a/}');
    Expect(1, 11567, '\p{ingeorgiansup}', "");
    Expect(0, 11567, '\p{^ingeorgiansup}', "");
    Expect(0, 11567, '\P{ingeorgiansup}', "");
    Expect(1, 11567, '\P{^ingeorgiansup}', "");
    Expect(0, 11568, '\p{ingeorgiansup}', "");
    Expect(1, 11568, '\p{^ingeorgiansup}', "");
    Expect(1, 11568, '\P{ingeorgiansup}', "");
    Expect(0, 11568, '\P{^ingeorgiansup}', "");
    Expect(1, 11567, '\p{ 	In_GEORGIAN_Sup}', "");
    Expect(0, 11567, '\p{^ 	In_GEORGIAN_Sup}', "");
    Expect(0, 11567, '\P{ 	In_GEORGIAN_Sup}', "");
    Expect(1, 11567, '\P{^ 	In_GEORGIAN_Sup}', "");
    Expect(0, 11568, '\p{ 	In_GEORGIAN_Sup}', "");
    Expect(1, 11568, '\p{^ 	In_GEORGIAN_Sup}', "");
    Expect(1, 11568, '\P{ 	In_GEORGIAN_Sup}', "");
    Expect(0, 11568, '\P{^ 	In_GEORGIAN_Sup}', "");
    Error('\p{/a/_GLAGOLITIC}');
    Error('\P{/a/_GLAGOLITIC}');
    Expect(1, 122922, '\p{glagolitic}', "");
    Expect(0, 122922, '\p{^glagolitic}', "");
    Expect(0, 122922, '\P{glagolitic}', "");
    Expect(1, 122922, '\P{^glagolitic}', "");
    Expect(0, 122923, '\p{glagolitic}', "");
    Expect(1, 122923, '\p{^glagolitic}', "");
    Expect(1, 122923, '\P{glagolitic}', "");
    Expect(0, 122923, '\P{^glagolitic}', "");
    Expect(1, 122922, '\p{-GLAGOLITIC}', "");
    Expect(0, 122922, '\p{^-GLAGOLITIC}', "");
    Expect(0, 122922, '\P{-GLAGOLITIC}', "");
    Expect(1, 122922, '\P{^-GLAGOLITIC}', "");
    Expect(0, 122923, '\p{-GLAGOLITIC}', "");
    Expect(1, 122923, '\p{^-GLAGOLITIC}', "");
    Expect(1, 122923, '\P{-GLAGOLITIC}', "");
    Expect(0, 122923, '\P{^-GLAGOLITIC}', "");
    Error('\p{-:=is_Glagolitic}');
    Error('\P{-:=is_Glagolitic}');
    Expect(1, 122922, '\p{isglagolitic}', "");
    Expect(0, 122922, '\p{^isglagolitic}', "");
    Expect(0, 122922, '\P{isglagolitic}', "");
    Expect(1, 122922, '\P{^isglagolitic}', "");
    Expect(0, 122923, '\p{isglagolitic}', "");
    Expect(1, 122923, '\p{^isglagolitic}', "");
    Expect(1, 122923, '\P{isglagolitic}', "");
    Expect(0, 122923, '\P{^isglagolitic}', "");
    Expect(1, 122922, '\p{IS_GLAGOLITIC}', "");
    Expect(0, 122922, '\p{^IS_GLAGOLITIC}', "");
    Expect(0, 122922, '\P{IS_GLAGOLITIC}', "");
    Expect(1, 122922, '\P{^IS_GLAGOLITIC}', "");
    Expect(0, 122923, '\p{IS_GLAGOLITIC}', "");
    Expect(1, 122923, '\p{^IS_GLAGOLITIC}', "");
    Expect(1, 122923, '\P{IS_GLAGOLITIC}', "");
    Expect(0, 122923, '\P{^IS_GLAGOLITIC}', "");
    Error('\p{ -Glag/a/}');
    Error('\P{ -Glag/a/}');
    Expect(1, 122922, '\p{glag}', "");
    Expect(0, 122922, '\p{^glag}', "");
    Expect(0, 122922, '\P{glag}', "");
    Expect(1, 122922, '\P{^glag}', "");
    Expect(0, 122923, '\p{glag}', "");
    Expect(1, 122923, '\p{^glag}', "");
    Expect(1, 122923, '\P{glag}', "");
    Expect(0, 122923, '\P{^glag}', "");
    Expect(1, 122922, '\p{--Glag}', "");
    Expect(0, 122922, '\p{^--Glag}', "");
    Expect(0, 122922, '\P{--Glag}', "");
    Expect(1, 122922, '\P{^--Glag}', "");
    Expect(0, 122923, '\p{--Glag}', "");
    Expect(1, 122923, '\p{^--Glag}', "");
    Expect(1, 122923, '\P{--Glag}', "");
    Expect(0, 122923, '\P{^--Glag}', "");
    Error('\p{/a/	Is_GLAG}');
    Error('\P{/a/	Is_GLAG}');
    Expect(1, 122922, '\p{isglag}', "");
    Expect(0, 122922, '\p{^isglag}', "");
    Expect(0, 122922, '\P{isglag}', "");
    Expect(1, 122922, '\P{^isglag}', "");
    Expect(0, 122923, '\p{isglag}', "");
    Expect(1, 122923, '\p{^isglag}', "");
    Expect(1, 122923, '\P{isglag}', "");
    Expect(0, 122923, '\P{^isglag}', "");
    Expect(1, 122922, '\p{IS_GLAG}', "");
    Expect(0, 122922, '\p{^IS_GLAG}', "");
    Expect(0, 122922, '\P{IS_GLAG}', "");
    Expect(1, 122922, '\P{^IS_GLAG}', "");
    Expect(0, 122923, '\p{IS_GLAG}', "");
    Expect(1, 122923, '\p{^IS_GLAG}', "");
    Expect(1, 122923, '\P{IS_GLAG}', "");
    Expect(0, 122923, '\P{^IS_GLAG}', "");
    Error('\p{_ glagolitic_Supplement:=}');
    Error('\P{_ glagolitic_Supplement:=}');
    Expect(1, 122927, '\p{glagoliticsupplement}', "");
    Expect(0, 122927, '\p{^glagoliticsupplement}', "");
    Expect(0, 122927, '\P{glagoliticsupplement}', "");
    Expect(1, 122927, '\P{^glagoliticsupplement}', "");
    Expect(0, 122928, '\p{glagoliticsupplement}', "");
    Expect(1, 122928, '\p{^glagoliticsupplement}', "");
    Expect(1, 122928, '\P{glagoliticsupplement}', "");
    Expect(0, 122928, '\P{^glagoliticsupplement}', "");
    Expect(1, 122927, '\p{	Glagolitic_Supplement}', "");
    Expect(0, 122927, '\p{^	Glagolitic_Supplement}', "");
    Expect(0, 122927, '\P{	Glagolitic_Supplement}', "");
    Expect(1, 122927, '\P{^	Glagolitic_Supplement}', "");
    Expect(0, 122928, '\p{	Glagolitic_Supplement}', "");
    Expect(1, 122928, '\p{^	Glagolitic_Supplement}', "");
    Expect(1, 122928, '\P{	Glagolitic_Supplement}', "");
    Expect(0, 122928, '\P{^	Glagolitic_Supplement}', "");
    Error('\p{/a/ 	Is_Glagolitic_SUPPLEMENT}');
    Error('\P{/a/ 	Is_Glagolitic_SUPPLEMENT}');
    Expect(1, 122927, '\p{isglagoliticsupplement}', "");
    Expect(0, 122927, '\p{^isglagoliticsupplement}', "");
    Expect(0, 122927, '\P{isglagoliticsupplement}', "");
    Expect(1, 122927, '\P{^isglagoliticsupplement}', "");
    Expect(0, 122928, '\p{isglagoliticsupplement}', "");
    Expect(1, 122928, '\p{^isglagoliticsupplement}', "");
    Expect(1, 122928, '\P{isglagoliticsupplement}', "");
    Expect(0, 122928, '\P{^isglagoliticsupplement}', "");
    Expect(1, 122927, '\p{ 	is_glagolitic_supplement}', "");
    Expect(0, 122927, '\p{^ 	is_glagolitic_supplement}', "");
    Expect(0, 122927, '\P{ 	is_glagolitic_supplement}', "");
    Expect(1, 122927, '\P{^ 	is_glagolitic_supplement}', "");
    Expect(0, 122928, '\p{ 	is_glagolitic_supplement}', "");
    Expect(1, 122928, '\p{^ 	is_glagolitic_supplement}', "");
    Expect(1, 122928, '\P{ 	is_glagolitic_supplement}', "");
    Expect(0, 122928, '\P{^ 	is_glagolitic_supplement}', "");
    Error('\p{/a/in_Glagolitic_Supplement}');
    Error('\P{/a/in_Glagolitic_Supplement}');
    Expect(1, 122927, '\p{inglagoliticsupplement}', "");
    Expect(0, 122927, '\p{^inglagoliticsupplement}', "");
    Expect(0, 122927, '\P{inglagoliticsupplement}', "");
    Expect(1, 122927, '\P{^inglagoliticsupplement}', "");
    Expect(0, 122928, '\p{inglagoliticsupplement}', "");
    Expect(1, 122928, '\p{^inglagoliticsupplement}', "");
    Expect(1, 122928, '\P{inglagoliticsupplement}', "");
    Expect(0, 122928, '\P{^inglagoliticsupplement}', "");
    Expect(1, 122927, '\p{_-In_Glagolitic_supplement}', "");
    Expect(0, 122927, '\p{^_-In_Glagolitic_supplement}', "");
    Expect(0, 122927, '\P{_-In_Glagolitic_supplement}', "");
    Expect(1, 122927, '\P{^_-In_Glagolitic_supplement}', "");
    Expect(0, 122928, '\p{_-In_Glagolitic_supplement}', "");
    Expect(1, 122928, '\p{^_-In_Glagolitic_supplement}', "");
    Expect(1, 122928, '\P{_-In_Glagolitic_supplement}', "");
    Expect(0, 122928, '\P{^_-In_Glagolitic_supplement}', "");
    Error('\p{-:=Glagolitic_sup}');
    Error('\P{-:=Glagolitic_sup}');
    Expect(1, 122927, '\p{glagoliticsup}', "");
    Expect(0, 122927, '\p{^glagoliticsup}', "");
    Expect(0, 122927, '\P{glagoliticsup}', "");
    Expect(1, 122927, '\P{^glagoliticsup}', "");
    Expect(0, 122928, '\p{glagoliticsup}', "");
    Expect(1, 122928, '\p{^glagoliticsup}', "");
    Expect(1, 122928, '\P{glagoliticsup}', "");
    Expect(0, 122928, '\P{^glagoliticsup}', "");
    Expect(1, 122927, '\p{-	Glagolitic_sup}', "");
    Expect(0, 122927, '\p{^-	Glagolitic_sup}', "");
    Expect(0, 122927, '\P{-	Glagolitic_sup}', "");
    Expect(1, 122927, '\P{^-	Glagolitic_sup}', "");
    Expect(0, 122928, '\p{-	Glagolitic_sup}', "");
    Expect(1, 122928, '\p{^-	Glagolitic_sup}', "");
    Expect(1, 122928, '\P{-	Glagolitic_sup}', "");
    Expect(0, 122928, '\P{^-	Glagolitic_sup}', "");
    Error('\p{:= 	is_GLAGOLITIC_Sup}');
    Error('\P{:= 	is_GLAGOLITIC_Sup}');
    Expect(1, 122927, '\p{isglagoliticsup}', "");
    Expect(0, 122927, '\p{^isglagoliticsup}', "");
    Expect(0, 122927, '\P{isglagoliticsup}', "");
    Expect(1, 122927, '\P{^isglagoliticsup}', "");
    Expect(0, 122928, '\p{isglagoliticsup}', "");
    Expect(1, 122928, '\p{^isglagoliticsup}', "");
    Expect(1, 122928, '\P{isglagoliticsup}', "");
    Expect(0, 122928, '\P{^isglagoliticsup}', "");
    Expect(1, 122927, '\p{-Is_GLAGOLITIC_sup}', "");
    Expect(0, 122927, '\p{^-Is_GLAGOLITIC_sup}', "");
    Expect(0, 122927, '\P{-Is_GLAGOLITIC_sup}', "");
    Expect(1, 122927, '\P{^-Is_GLAGOLITIC_sup}', "");
    Expect(0, 122928, '\p{-Is_GLAGOLITIC_sup}', "");
    Expect(1, 122928, '\p{^-Is_GLAGOLITIC_sup}', "");
    Expect(1, 122928, '\P{-Is_GLAGOLITIC_sup}', "");
    Expect(0, 122928, '\P{^-Is_GLAGOLITIC_sup}', "");
    Error('\p{/a/	_In_glagolitic_SUP}');
    Error('\P{/a/	_In_glagolitic_SUP}');
    Expect(1, 122927, '\p{inglagoliticsup}', "");
    Expect(0, 122927, '\p{^inglagoliticsup}', "");
    Expect(0, 122927, '\P{inglagoliticsup}', "");
    Expect(1, 122927, '\P{^inglagoliticsup}', "");
    Expect(0, 122928, '\p{inglagoliticsup}', "");
    Expect(1, 122928, '\p{^inglagoliticsup}', "");
    Expect(1, 122928, '\P{inglagoliticsup}', "");
    Expect(0, 122928, '\P{^inglagoliticsup}', "");
    Expect(1, 122927, '\p{- In_Glagolitic_sup}', "");
    Expect(0, 122927, '\p{^- In_Glagolitic_sup}', "");
    Expect(0, 122927, '\P{- In_Glagolitic_sup}', "");
    Expect(1, 122927, '\P{^- In_Glagolitic_sup}', "");
    Expect(0, 122928, '\p{- In_Glagolitic_sup}', "");
    Expect(1, 122928, '\p{^- In_Glagolitic_sup}', "");
    Expect(1, 122928, '\P{- In_Glagolitic_sup}', "");
    Expect(0, 122928, '\P{^- In_Glagolitic_sup}', "");
    Error('\p{_/a/gothic}');
    Error('\P{_/a/gothic}');
    Expect(1, 66378, '\p{gothic}', "");
    Expect(0, 66378, '\p{^gothic}', "");
    Expect(0, 66378, '\P{gothic}', "");
    Expect(1, 66378, '\P{^gothic}', "");
    Expect(0, 66379, '\p{gothic}', "");
    Expect(1, 66379, '\p{^gothic}', "");
    Expect(1, 66379, '\P{gothic}', "");
    Expect(0, 66379, '\P{^gothic}', "");
    Expect(1, 66378, '\p{ Gothic}', "");
    Expect(0, 66378, '\p{^ Gothic}', "");
    Expect(0, 66378, '\P{ Gothic}', "");
    Expect(1, 66378, '\P{^ Gothic}', "");
    Expect(0, 66379, '\p{ Gothic}', "");
    Expect(1, 66379, '\p{^ Gothic}', "");
    Expect(1, 66379, '\P{ Gothic}', "");
    Expect(0, 66379, '\P{^ Gothic}', "");
    Error('\p{	/a/is_Gothic}');
    Error('\P{	/a/is_Gothic}');
    Expect(1, 66378, '\p{isgothic}', "");
    Expect(0, 66378, '\p{^isgothic}', "");
    Expect(0, 66378, '\P{isgothic}', "");
    Expect(1, 66378, '\P{^isgothic}', "");
    Expect(0, 66379, '\p{isgothic}', "");
    Expect(1, 66379, '\p{^isgothic}', "");
    Expect(1, 66379, '\P{isgothic}', "");
    Expect(0, 66379, '\P{^isgothic}', "");
    Expect(1, 66378, '\p{	-is_Gothic}', "");
    Expect(0, 66378, '\p{^	-is_Gothic}', "");
    Expect(0, 66378, '\P{	-is_Gothic}', "");
    Expect(1, 66378, '\P{^	-is_Gothic}', "");
    Expect(0, 66379, '\p{	-is_Gothic}', "");
    Expect(1, 66379, '\p{^	-is_Gothic}', "");
    Expect(1, 66379, '\P{	-is_Gothic}', "");
    Expect(0, 66379, '\P{^	-is_Gothic}', "");
    Error('\p{_:=Goth}');
    Error('\P{_:=Goth}');
    Expect(1, 66378, '\p{goth}', "");
    Expect(0, 66378, '\p{^goth}', "");
    Expect(0, 66378, '\P{goth}', "");
    Expect(1, 66378, '\P{^goth}', "");
    Expect(0, 66379, '\p{goth}', "");
    Expect(1, 66379, '\p{^goth}', "");
    Expect(1, 66379, '\P{goth}', "");
    Expect(0, 66379, '\P{^goth}', "");
    Expect(1, 66378, '\p{- goth}', "");
    Expect(0, 66378, '\p{^- goth}', "");
    Expect(0, 66378, '\P{- goth}', "");
    Expect(1, 66378, '\P{^- goth}', "");
    Expect(0, 66379, '\p{- goth}', "");
    Expect(1, 66379, '\p{^- goth}', "");
    Expect(1, 66379, '\P{- goth}', "");
    Expect(0, 66379, '\P{^- goth}', "");
    Error('\p{:=	Is_GOTH}');
    Error('\P{:=	Is_GOTH}');
    Expect(1, 66378, '\p{isgoth}', "");
    Expect(0, 66378, '\p{^isgoth}', "");
    Expect(0, 66378, '\P{isgoth}', "");
    Expect(1, 66378, '\P{^isgoth}', "");
    Expect(0, 66379, '\p{isgoth}', "");
    Expect(1, 66379, '\p{^isgoth}', "");
    Expect(1, 66379, '\P{isgoth}', "");
    Expect(0, 66379, '\P{^isgoth}', "");
    Expect(1, 66378, '\p{ Is_Goth}', "");
    Expect(0, 66378, '\p{^ Is_Goth}', "");
    Expect(0, 66378, '\P{ Is_Goth}', "");
    Expect(1, 66378, '\P{^ Is_Goth}', "");
    Expect(0, 66379, '\p{ Is_Goth}', "");
    Expect(1, 66379, '\p{^ Is_Goth}', "");
    Expect(1, 66379, '\P{ Is_Goth}', "");
    Expect(0, 66379, '\P{^ Is_Goth}', "");
    Error('\p{_Grantha:=}');
    Error('\P{_Grantha:=}');
    Expect(1, 70516, '\p{grantha}', "");
    Expect(0, 70516, '\p{^grantha}', "");
    Expect(0, 70516, '\P{grantha}', "");
    Expect(1, 70516, '\P{^grantha}', "");
    Expect(0, 70517, '\p{grantha}', "");
    Expect(1, 70517, '\p{^grantha}', "");
    Expect(1, 70517, '\P{grantha}', "");
    Expect(0, 70517, '\P{^grantha}', "");
    Expect(1, 70516, '\p{	_Grantha}', "");
    Expect(0, 70516, '\p{^	_Grantha}', "");
    Expect(0, 70516, '\P{	_Grantha}', "");
    Expect(1, 70516, '\P{^	_Grantha}', "");
    Expect(0, 70517, '\p{	_Grantha}', "");
    Expect(1, 70517, '\p{^	_Grantha}', "");
    Expect(1, 70517, '\P{	_Grantha}', "");
    Expect(0, 70517, '\P{^	_Grantha}', "");
    Error('\p{:=--is_Grantha}');
    Error('\P{:=--is_Grantha}');
    Expect(1, 70516, '\p{isgrantha}', "");
    Expect(0, 70516, '\p{^isgrantha}', "");
    Expect(0, 70516, '\P{isgrantha}', "");
    Expect(1, 70516, '\P{^isgrantha}', "");
    Expect(0, 70517, '\p{isgrantha}', "");
    Expect(1, 70517, '\p{^isgrantha}', "");
    Expect(1, 70517, '\P{isgrantha}', "");
    Expect(0, 70517, '\P{^isgrantha}', "");
    Expect(1, 70516, '\p{	 IS_GRANTHA}', "");
    Expect(0, 70516, '\p{^	 IS_GRANTHA}', "");
    Expect(0, 70516, '\P{	 IS_GRANTHA}', "");
    Expect(1, 70516, '\P{^	 IS_GRANTHA}', "");
    Expect(0, 70517, '\p{	 IS_GRANTHA}', "");
    Expect(1, 70517, '\p{^	 IS_GRANTHA}', "");
    Expect(1, 70517, '\P{	 IS_GRANTHA}', "");
    Expect(0, 70517, '\P{^	 IS_GRANTHA}', "");
    Error('\p{:=__Gran}');
    Error('\P{:=__Gran}');
    Expect(1, 70516, '\p{gran}', "");
    Expect(0, 70516, '\p{^gran}', "");
    Expect(0, 70516, '\P{gran}', "");
    Expect(1, 70516, '\P{^gran}', "");
    Expect(0, 70517, '\p{gran}', "");
    Expect(1, 70517, '\p{^gran}', "");
    Expect(1, 70517, '\P{gran}', "");
    Expect(0, 70517, '\P{^gran}', "");
    Expect(1, 70516, '\p{__Gran}', "");
    Expect(0, 70516, '\p{^__Gran}', "");
    Expect(0, 70516, '\P{__Gran}', "");
    Expect(1, 70516, '\P{^__Gran}', "");
    Expect(0, 70517, '\p{__Gran}', "");
    Expect(1, 70517, '\p{^__Gran}', "");
    Expect(1, 70517, '\P{__Gran}', "");
    Expect(0, 70517, '\P{^__Gran}', "");
    Error('\p{:=	-IS_Gran}');
    Error('\P{:=	-IS_Gran}');
    Expect(1, 70516, '\p{isgran}', "");
    Expect(0, 70516, '\p{^isgran}', "");
    Expect(0, 70516, '\P{isgran}', "");
    Expect(1, 70516, '\P{^isgran}', "");
    Expect(0, 70517, '\p{isgran}', "");
    Expect(1, 70517, '\p{^isgran}', "");
    Expect(1, 70517, '\P{isgran}', "");
    Expect(0, 70517, '\P{^isgran}', "");
    Expect(1, 70516, '\p{	Is_gran}', "");
    Expect(0, 70516, '\p{^	Is_gran}', "");
    Expect(0, 70516, '\P{	Is_gran}', "");
    Expect(1, 70516, '\P{^	Is_gran}', "");
    Expect(0, 70517, '\p{	Is_gran}', "");
    Expect(1, 70517, '\p{^	Is_gran}', "");
    Expect(1, 70517, '\P{	Is_gran}', "");
    Expect(0, 70517, '\P{^	Is_gran}', "");
    Error('\p{_:=xposixgraph}');
    Error('\P{_:=xposixgraph}');
    Expect(1, 1114109, '\p{xposixgraph}', "");
    Expect(0, 1114109, '\p{^xposixgraph}', "");
    Expect(0, 1114109, '\P{xposixgraph}', "");
    Expect(1, 1114109, '\P{^xposixgraph}', "");
    Expect(0, 918000, '\p{xposixgraph}', "");
    Expect(1, 918000, '\p{^xposixgraph}', "");
    Expect(1, 918000, '\P{xposixgraph}', "");
    Expect(0, 918000, '\P{^xposixgraph}', "");
    Expect(1, 1114109, '\p{	 XPosixGraph}', "");
    Expect(0, 1114109, '\p{^	 XPosixGraph}', "");
    Expect(0, 1114109, '\P{	 XPosixGraph}', "");
    Expect(1, 1114109, '\P{^	 XPosixGraph}', "");
    Expect(0, 918000, '\p{	 XPosixGraph}', "");
    Expect(1, 918000, '\p{^	 XPosixGraph}', "");
    Expect(1, 918000, '\P{	 XPosixGraph}', "");
    Expect(0, 918000, '\P{^	 XPosixGraph}', "");
    Error('\p{/a/graph}');
    Error('\P{/a/graph}');
    Expect(1, 1114109, '\p{graph}', "");
    Expect(0, 1114109, '\p{^graph}', "");
    Expect(0, 1114109, '\P{graph}', "");
    Expect(1, 1114109, '\P{^graph}', "");
    Expect(0, 918000, '\p{graph}', "");
    Expect(1, 918000, '\p{^graph}', "");
    Expect(1, 918000, '\P{graph}', "");
    Expect(0, 918000, '\P{^graph}', "");
    Expect(1, 1114109, '\p{ _Graph}', "");
    Expect(0, 1114109, '\p{^ _Graph}', "");
    Expect(0, 1114109, '\P{ _Graph}', "");
    Expect(1, 1114109, '\P{^ _Graph}', "");
    Expect(0, 918000, '\p{ _Graph}', "");
    Expect(1, 918000, '\p{^ _Graph}', "");
    Expect(1, 918000, '\P{ _Graph}', "");
    Expect(0, 918000, '\P{^ _Graph}', "");
    Error('\p{-/a/is_XPOSIXGRAPH}');
    Error('\P{-/a/is_XPOSIXGRAPH}');
    Expect(1, 1114109, '\p{isxposixgraph}', "");
    Expect(0, 1114109, '\p{^isxposixgraph}', "");
    Expect(0, 1114109, '\P{isxposixgraph}', "");
    Expect(1, 1114109, '\P{^isxposixgraph}', "");
    Expect(0, 918000, '\p{isxposixgraph}', "");
    Expect(1, 918000, '\p{^isxposixgraph}', "");
    Expect(1, 918000, '\P{isxposixgraph}', "");
    Expect(0, 918000, '\P{^isxposixgraph}', "");
    Expect(1, 1114109, '\p{	_Is_XPOSIXGRAPH}', "");
    Expect(0, 1114109, '\p{^	_Is_XPOSIXGRAPH}', "");
    Expect(0, 1114109, '\P{	_Is_XPOSIXGRAPH}', "");
    Expect(1, 1114109, '\P{^	_Is_XPOSIXGRAPH}', "");
    Expect(0, 918000, '\p{	_Is_XPOSIXGRAPH}', "");
    Expect(1, 918000, '\p{^	_Is_XPOSIXGRAPH}', "");
    Expect(1, 918000, '\P{	_Is_XPOSIXGRAPH}', "");
    Expect(0, 918000, '\P{^	_Is_XPOSIXGRAPH}', "");
    Error('\p{-_Is_GRAPH:=}');
    Error('\P{-_Is_GRAPH:=}');
    Expect(1, 1114109, '\p{isgraph}', "");
    Expect(0, 1114109, '\p{^isgraph}', "");
    Expect(0, 1114109, '\P{isgraph}', "");
    Expect(1, 1114109, '\P{^isgraph}', "");
    Expect(0, 918000, '\p{isgraph}', "");
    Expect(1, 918000, '\p{^isgraph}', "");
    Expect(1, 918000, '\P{isgraph}', "");
    Expect(0, 918000, '\P{^isgraph}', "");
    Expect(1, 1114109, '\p{	-IS_GRAPH}', "");
    Expect(0, 1114109, '\p{^	-IS_GRAPH}', "");
    Expect(0, 1114109, '\P{	-IS_GRAPH}', "");
    Expect(1, 1114109, '\P{^	-IS_GRAPH}', "");
    Expect(0, 918000, '\p{	-IS_GRAPH}', "");
    Expect(1, 918000, '\p{^	-IS_GRAPH}', "");
    Expect(1, 918000, '\P{	-IS_GRAPH}', "");
    Expect(0, 918000, '\P{^	-IS_GRAPH}', "");
    Error('\p{-:=grapheme_Base}');
    Error('\P{-:=grapheme_Base}');
    Expect(1, 195101, '\p{graphemebase}', "");
    Expect(0, 195101, '\p{^graphemebase}', "");
    Expect(0, 195101, '\P{graphemebase}', "");
    Expect(1, 195101, '\P{^graphemebase}', "");
    Expect(0, 195102, '\p{graphemebase}', "");
    Expect(1, 195102, '\p{^graphemebase}', "");
    Expect(1, 195102, '\P{graphemebase}', "");
    Expect(0, 195102, '\P{^graphemebase}', "");
    Expect(1, 195101, '\p{_Grapheme_base}', "");
    Expect(0, 195101, '\p{^_Grapheme_base}', "");
    Expect(0, 195101, '\P{_Grapheme_base}', "");
    Expect(1, 195101, '\P{^_Grapheme_base}', "");
    Expect(0, 195102, '\p{_Grapheme_base}', "");
    Expect(1, 195102, '\p{^_Grapheme_base}', "");
    Expect(1, 195102, '\P{_Grapheme_base}', "");
    Expect(0, 195102, '\P{^_Grapheme_base}', "");
    Error('\p{_ Is_Grapheme_base:=}');
    Error('\P{_ Is_Grapheme_base:=}');
    Expect(1, 195101, '\p{isgraphemebase}', "");
    Expect(0, 195101, '\p{^isgraphemebase}', "");
    Expect(0, 195101, '\P{isgraphemebase}', "");
    Expect(1, 195101, '\P{^isgraphemebase}', "");
    Expect(0, 195102, '\p{isgraphemebase}', "");
    Expect(1, 195102, '\p{^isgraphemebase}', "");
    Expect(1, 195102, '\P{isgraphemebase}', "");
    Expect(0, 195102, '\P{^isgraphemebase}', "");
    Expect(1, 195101, '\p{	_Is_GRAPHEME_Base}', "");
    Expect(0, 195101, '\p{^	_Is_GRAPHEME_Base}', "");
    Expect(0, 195101, '\P{	_Is_GRAPHEME_Base}', "");
    Expect(1, 195101, '\P{^	_Is_GRAPHEME_Base}', "");
    Expect(0, 195102, '\p{	_Is_GRAPHEME_Base}', "");
    Expect(1, 195102, '\p{^	_Is_GRAPHEME_Base}', "");
    Expect(1, 195102, '\P{	_Is_GRAPHEME_Base}', "");
    Expect(0, 195102, '\P{^	_Is_GRAPHEME_Base}', "");
    Error('\p{/a/ 	Gr_base}');
    Error('\P{/a/ 	Gr_base}');
    Expect(1, 195101, '\p{grbase}', "");
    Expect(0, 195101, '\p{^grbase}', "");
    Expect(0, 195101, '\P{grbase}', "");
    Expect(1, 195101, '\P{^grbase}', "");
    Expect(0, 195102, '\p{grbase}', "");
    Expect(1, 195102, '\p{^grbase}', "");
    Expect(1, 195102, '\P{grbase}', "");
    Expect(0, 195102, '\P{^grbase}', "");
    Expect(1, 195101, '\p{_-gr_base}', "");
    Expect(0, 195101, '\p{^_-gr_base}', "");
    Expect(0, 195101, '\P{_-gr_base}', "");
    Expect(1, 195101, '\P{^_-gr_base}', "");
    Expect(0, 195102, '\p{_-gr_base}', "");
    Expect(1, 195102, '\p{^_-gr_base}', "");
    Expect(1, 195102, '\P{_-gr_base}', "");
    Expect(0, 195102, '\P{^_-gr_base}', "");
    Error('\p{/a/ is_Gr_BASE}');
    Error('\P{/a/ is_Gr_BASE}');
    Expect(1, 195101, '\p{isgrbase}', "");
    Expect(0, 195101, '\p{^isgrbase}', "");
    Expect(0, 195101, '\P{isgrbase}', "");
    Expect(1, 195101, '\P{^isgrbase}', "");
    Expect(0, 195102, '\p{isgrbase}', "");
    Expect(1, 195102, '\p{^isgrbase}', "");
    Expect(1, 195102, '\P{isgrbase}', "");
    Expect(0, 195102, '\P{^isgrbase}', "");
    Expect(1, 195101, '\p{	IS_Gr_base}', "");
    Expect(0, 195101, '\p{^	IS_Gr_base}', "");
    Expect(0, 195101, '\P{	IS_Gr_base}', "");
    Expect(1, 195101, '\P{^	IS_Gr_base}', "");
    Expect(0, 195102, '\p{	IS_Gr_base}', "");
    Expect(1, 195102, '\p{^	IS_Gr_base}', "");
    Expect(1, 195102, '\P{	IS_Gr_base}', "");
    Expect(0, 195102, '\P{^	IS_Gr_base}', "");
    Error('\p{- grapheme_Extend:=}');
    Error('\P{- grapheme_Extend:=}');
    Expect(1, 917999, '\p{graphemeextend}', "");
    Expect(0, 917999, '\p{^graphemeextend}', "");
    Expect(0, 917999, '\P{graphemeextend}', "");
    Expect(1, 917999, '\P{^graphemeextend}', "");
    Expect(0, 918000, '\p{graphemeextend}', "");
    Expect(1, 918000, '\p{^graphemeextend}', "");
    Expect(1, 918000, '\P{graphemeextend}', "");
    Expect(0, 918000, '\P{^graphemeextend}', "");
    Expect(1, 917999, '\p{ _GRAPHEME_extend}', "");
    Expect(0, 917999, '\p{^ _GRAPHEME_extend}', "");
    Expect(0, 917999, '\P{ _GRAPHEME_extend}', "");
    Expect(1, 917999, '\P{^ _GRAPHEME_extend}', "");
    Expect(0, 918000, '\p{ _GRAPHEME_extend}', "");
    Expect(1, 918000, '\p{^ _GRAPHEME_extend}', "");
    Expect(1, 918000, '\P{ _GRAPHEME_extend}', "");
    Expect(0, 918000, '\P{^ _GRAPHEME_extend}', "");
    Error('\p{-_Is_Grapheme_extend/a/}');
    Error('\P{-_Is_Grapheme_extend/a/}');
    Expect(1, 917999, '\p{isgraphemeextend}', "");
    Expect(0, 917999, '\p{^isgraphemeextend}', "");
    Expect(0, 917999, '\P{isgraphemeextend}', "");
    Expect(1, 917999, '\P{^isgraphemeextend}', "");
    Expect(0, 918000, '\p{isgraphemeextend}', "");
    Expect(1, 918000, '\p{^isgraphemeextend}', "");
    Expect(1, 918000, '\P{isgraphemeextend}', "");
    Expect(0, 918000, '\P{^isgraphemeextend}', "");
    Expect(1, 917999, '\p{_-Is_Grapheme_EXTEND}', "");
    Expect(0, 917999, '\p{^_-Is_Grapheme_EXTEND}', "");
    Expect(0, 917999, '\P{_-Is_Grapheme_EXTEND}', "");
    Expect(1, 917999, '\P{^_-Is_Grapheme_EXTEND}', "");
    Expect(0, 918000, '\p{_-Is_Grapheme_EXTEND}', "");
    Expect(1, 918000, '\p{^_-Is_Grapheme_EXTEND}', "");
    Expect(1, 918000, '\P{_-Is_Grapheme_EXTEND}', "");
    Expect(0, 918000, '\P{^_-Is_Grapheme_EXTEND}', "");
    Error('\p{ :=Gr_EXT}');
    Error('\P{ :=Gr_EXT}');
    Expect(1, 917999, '\p{grext}', "");
    Expect(0, 917999, '\p{^grext}', "");
    Expect(0, 917999, '\P{grext}', "");
    Expect(1, 917999, '\P{^grext}', "");
    Expect(0, 918000, '\p{grext}', "");
    Expect(1, 918000, '\p{^grext}', "");
    Expect(1, 918000, '\P{grext}', "");
    Expect(0, 918000, '\P{^grext}', "");
    Expect(1, 917999, '\p{ GR_Ext}', "");
    Expect(0, 917999, '\p{^ GR_Ext}', "");
    Expect(0, 917999, '\P{ GR_Ext}', "");
    Expect(1, 917999, '\P{^ GR_Ext}', "");
    Expect(0, 918000, '\p{ GR_Ext}', "");
    Expect(1, 918000, '\p{^ GR_Ext}', "");
    Expect(1, 918000, '\P{ GR_Ext}', "");
    Expect(0, 918000, '\P{^ GR_Ext}', "");
    Error('\p{/a/_is_gr_ext}');
    Error('\P{/a/_is_gr_ext}');
    Expect(1, 917999, '\p{isgrext}', "");
    Expect(0, 917999, '\p{^isgrext}', "");
    Expect(0, 917999, '\P{isgrext}', "");
    Expect(1, 917999, '\P{^isgrext}', "");
    Expect(0, 918000, '\p{isgrext}', "");
    Expect(1, 918000, '\p{^isgrext}', "");
    Expect(1, 918000, '\P{isgrext}', "");
    Expect(0, 918000, '\P{^isgrext}', "");
    Expect(1, 917999, '\p{Is_Gr_Ext}', "");
    Expect(0, 917999, '\p{^Is_Gr_Ext}', "");
    Expect(0, 917999, '\P{Is_Gr_Ext}', "");
    Expect(1, 917999, '\P{^Is_Gr_Ext}', "");
    Expect(0, 918000, '\p{Is_Gr_Ext}', "");
    Expect(1, 918000, '\p{^Is_Gr_Ext}', "");
    Expect(1, 918000, '\P{Is_Gr_Ext}', "");
    Expect(0, 918000, '\P{^Is_Gr_Ext}', "");
    Error('\p{Grapheme_Link}');
    Error('\P{Grapheme_Link}');
    Error('\p{Is_Grapheme_Link}');
    Error('\P{Is_Grapheme_Link}');
    Error('\p{Gr_Link}');
    Error('\P{Gr_Link}');
    Error('\p{Is_Gr_Link}');
    Error('\P{Is_Gr_Link}');
    Error('\p{-	Greek:=}');
    Error('\P{-	Greek:=}');
    Expect(1, 119365, '\p{greek}', "");
    Expect(0, 119365, '\p{^greek}', "");
    Expect(0, 119365, '\P{greek}', "");
    Expect(1, 119365, '\P{^greek}', "");
    Expect(0, 119366, '\p{greek}', "");
    Expect(1, 119366, '\p{^greek}', "");
    Expect(1, 119366, '\P{greek}', "");
    Expect(0, 119366, '\P{^greek}', "");
    Error('\p{		IS_Greek:=}');
    Error('\P{		IS_Greek:=}');
    Expect(1, 119365, '\p{isgreek}', "");
    Expect(0, 119365, '\p{^isgreek}', "");
    Expect(0, 119365, '\P{isgreek}', "");
    Expect(1, 119365, '\P{^isgreek}', "");
    Expect(0, 119366, '\p{isgreek}', "");
    Expect(1, 119366, '\p{^isgreek}', "");
    Expect(1, 119366, '\P{isgreek}', "");
    Expect(0, 119366, '\P{^isgreek}', "");
    Expect(1, 119365, '\p{- Is_Greek}', "");
    Expect(0, 119365, '\p{^- Is_Greek}', "");
    Expect(0, 119365, '\P{- Is_Greek}', "");
    Expect(1, 119365, '\P{^- Is_Greek}', "");
    Expect(0, 119366, '\p{- Is_Greek}', "");
    Expect(1, 119366, '\p{^- Is_Greek}', "");
    Expect(1, 119366, '\P{- Is_Greek}', "");
    Expect(0, 119366, '\P{^- Is_Greek}', "");
    Error('\p{/a/ -GREK}');
    Error('\P{/a/ -GREK}');
    Expect(1, 119365, '\p{grek}', "");
    Expect(0, 119365, '\p{^grek}', "");
    Expect(0, 119365, '\P{grek}', "");
    Expect(1, 119365, '\P{^grek}', "");
    Expect(0, 119366, '\p{grek}', "");
    Expect(1, 119366, '\p{^grek}', "");
    Expect(1, 119366, '\P{grek}', "");
    Expect(0, 119366, '\P{^grek}', "");
    Expect(1, 119365, '\p{	_Grek}', "");
    Expect(0, 119365, '\p{^	_Grek}', "");
    Expect(0, 119365, '\P{	_Grek}', "");
    Expect(1, 119365, '\P{^	_Grek}', "");
    Expect(0, 119366, '\p{	_Grek}', "");
    Expect(1, 119366, '\p{^	_Grek}', "");
    Expect(1, 119366, '\P{	_Grek}', "");
    Expect(0, 119366, '\P{^	_Grek}', "");
    Error('\p{:=- is_Grek}');
    Error('\P{:=- is_Grek}');
    Expect(1, 119365, '\p{isgrek}', "");
    Expect(0, 119365, '\p{^isgrek}', "");
    Expect(0, 119365, '\P{isgrek}', "");
    Expect(1, 119365, '\P{^isgrek}', "");
    Expect(0, 119366, '\p{isgrek}', "");
    Expect(1, 119366, '\p{^isgrek}', "");
    Expect(1, 119366, '\P{isgrek}', "");
    Expect(0, 119366, '\P{^isgrek}', "");
    Expect(1, 119365, '\p{_is_Grek}', "");
    Expect(0, 119365, '\p{^_is_Grek}', "");
    Expect(0, 119365, '\P{_is_Grek}', "");
    Expect(1, 119365, '\P{^_is_Grek}', "");
    Expect(0, 119366, '\p{_is_Grek}', "");
    Expect(1, 119366, '\p{^_is_Grek}', "");
    Expect(1, 119366, '\P{_is_Grek}', "");
    Expect(0, 119366, '\P{^_is_Grek}', "");
    Error('\p{/a/Greek_and_coptic}');
    Error('\P{/a/Greek_and_coptic}');
    Expect(1, 1023, '\p{greekandcoptic}', "");
    Expect(0, 1023, '\p{^greekandcoptic}', "");
    Expect(0, 1023, '\P{greekandcoptic}', "");
    Expect(1, 1023, '\P{^greekandcoptic}', "");
    Expect(0, 1024, '\p{greekandcoptic}', "");
    Expect(1, 1024, '\p{^greekandcoptic}', "");
    Expect(1, 1024, '\P{greekandcoptic}', "");
    Expect(0, 1024, '\P{^greekandcoptic}', "");
    Expect(1, 1023, '\p{ 	GREEK_and_COPTIC}', "");
    Expect(0, 1023, '\p{^ 	GREEK_and_COPTIC}', "");
    Expect(0, 1023, '\P{ 	GREEK_and_COPTIC}', "");
    Expect(1, 1023, '\P{^ 	GREEK_and_COPTIC}', "");
    Expect(0, 1024, '\p{ 	GREEK_and_COPTIC}', "");
    Expect(1, 1024, '\p{^ 	GREEK_and_COPTIC}', "");
    Expect(1, 1024, '\P{ 	GREEK_and_COPTIC}', "");
    Expect(0, 1024, '\P{^ 	GREEK_and_COPTIC}', "");
    Error('\p{/a/-Is_GREEK_AND_Coptic}');
    Error('\P{/a/-Is_GREEK_AND_Coptic}');
    Expect(1, 1023, '\p{isgreekandcoptic}', "");
    Expect(0, 1023, '\p{^isgreekandcoptic}', "");
    Expect(0, 1023, '\P{isgreekandcoptic}', "");
    Expect(1, 1023, '\P{^isgreekandcoptic}', "");
    Expect(0, 1024, '\p{isgreekandcoptic}', "");
    Expect(1, 1024, '\p{^isgreekandcoptic}', "");
    Expect(1, 1024, '\P{isgreekandcoptic}', "");
    Expect(0, 1024, '\P{^isgreekandcoptic}', "");
    Expect(1, 1023, '\p{- is_GREEK_AND_coptic}', "");
    Expect(0, 1023, '\p{^- is_GREEK_AND_coptic}', "");
    Expect(0, 1023, '\P{- is_GREEK_AND_coptic}', "");
    Expect(1, 1023, '\P{^- is_GREEK_AND_coptic}', "");
    Expect(0, 1024, '\p{- is_GREEK_AND_coptic}', "");
    Expect(1, 1024, '\p{^- is_GREEK_AND_coptic}', "");
    Expect(1, 1024, '\P{- is_GREEK_AND_coptic}', "");
    Expect(0, 1024, '\P{^- is_GREEK_AND_coptic}', "");
    Error('\p{- In_Greek_And_Coptic/a/}');
    Error('\P{- In_Greek_And_Coptic/a/}');
    Expect(1, 1023, '\p{ingreekandcoptic}', "");
    Expect(0, 1023, '\p{^ingreekandcoptic}', "");
    Expect(0, 1023, '\P{ingreekandcoptic}', "");
    Expect(1, 1023, '\P{^ingreekandcoptic}', "");
    Expect(0, 1024, '\p{ingreekandcoptic}', "");
    Expect(1, 1024, '\p{^ingreekandcoptic}', "");
    Expect(1, 1024, '\P{ingreekandcoptic}', "");
    Expect(0, 1024, '\P{^ingreekandcoptic}', "");
    Expect(1, 1023, '\p{-in_GREEK_And_Coptic}', "");
    Expect(0, 1023, '\p{^-in_GREEK_And_Coptic}', "");
    Expect(0, 1023, '\P{-in_GREEK_And_Coptic}', "");
    Expect(1, 1023, '\P{^-in_GREEK_And_Coptic}', "");
    Expect(0, 1024, '\p{-in_GREEK_And_Coptic}', "");
    Expect(1, 1024, '\p{^-in_GREEK_And_Coptic}', "");
    Expect(1, 1024, '\P{-in_GREEK_And_Coptic}', "");
    Expect(0, 1024, '\P{^-in_GREEK_And_Coptic}', "");
    Error('\p{_IN_GREEK/a/}');
    Error('\P{_IN_GREEK/a/}');
    Expect(1, 1023, '\p{ingreek}', "");
    Expect(0, 1023, '\p{^ingreek}', "");
    Expect(0, 1023, '\P{ingreek}', "");
    Expect(1, 1023, '\P{^ingreek}', "");
    Expect(0, 1024, '\p{ingreek}', "");
    Expect(1, 1024, '\p{^ingreek}', "");
    Expect(1, 1024, '\P{ingreek}', "");
    Expect(0, 1024, '\P{^ingreek}', "");
    Expect(1, 1023, '\p{--IN_GREEK}', "");
    Expect(0, 1023, '\p{^--IN_GREEK}', "");
    Expect(0, 1023, '\P{--IN_GREEK}', "");
    Expect(1, 1023, '\P{^--IN_GREEK}', "");
    Expect(0, 1024, '\p{--IN_GREEK}', "");
    Expect(1, 1024, '\p{^--IN_GREEK}', "");
    Expect(1, 1024, '\P{--IN_GREEK}', "");
    Expect(0, 1024, '\P{^--IN_GREEK}', "");
    Error('\p{ -GREEK_Extended:=}');
    Error('\P{ -GREEK_Extended:=}');
    Expect(1, 8191, '\p{greekextended}', "");
    Expect(0, 8191, '\p{^greekextended}', "");
    Expect(0, 8191, '\P{greekextended}', "");
    Expect(1, 8191, '\P{^greekextended}', "");
    Expect(0, 8192, '\p{greekextended}', "");
    Expect(1, 8192, '\p{^greekextended}', "");
    Expect(1, 8192, '\P{greekextended}', "");
    Expect(0, 8192, '\P{^greekextended}', "");
    Expect(1, 8191, '\p{ -Greek_Extended}', "");
    Expect(0, 8191, '\p{^ -Greek_Extended}', "");
    Expect(0, 8191, '\P{ -Greek_Extended}', "");
    Expect(1, 8191, '\P{^ -Greek_Extended}', "");
    Expect(0, 8192, '\p{ -Greek_Extended}', "");
    Expect(1, 8192, '\p{^ -Greek_Extended}', "");
    Expect(1, 8192, '\P{ -Greek_Extended}', "");
    Expect(0, 8192, '\P{^ -Greek_Extended}', "");
    Error('\p{	:=IS_Greek_Extended}');
    Error('\P{	:=IS_Greek_Extended}');
    Expect(1, 8191, '\p{isgreekextended}', "");
    Expect(0, 8191, '\p{^isgreekextended}', "");
    Expect(0, 8191, '\P{isgreekextended}', "");
    Expect(1, 8191, '\P{^isgreekextended}', "");
    Expect(0, 8192, '\p{isgreekextended}', "");
    Expect(1, 8192, '\p{^isgreekextended}', "");
    Expect(1, 8192, '\P{isgreekextended}', "");
    Expect(0, 8192, '\P{^isgreekextended}', "");
    Expect(1, 8191, '\p{ -is_GREEK_Extended}', "");
    Expect(0, 8191, '\p{^ -is_GREEK_Extended}', "");
    Expect(0, 8191, '\P{ -is_GREEK_Extended}', "");
    Expect(1, 8191, '\P{^ -is_GREEK_Extended}', "");
    Expect(0, 8192, '\p{ -is_GREEK_Extended}', "");
    Expect(1, 8192, '\p{^ -is_GREEK_Extended}', "");
    Expect(1, 8192, '\P{ -is_GREEK_Extended}', "");
    Expect(0, 8192, '\P{^ -is_GREEK_Extended}', "");
    Error('\p{ /a/IN_Greek_Extended}');
    Error('\P{ /a/IN_Greek_Extended}');
    Expect(1, 8191, '\p{ingreekextended}', "");
    Expect(0, 8191, '\p{^ingreekextended}', "");
    Expect(0, 8191, '\P{ingreekextended}', "");
    Expect(1, 8191, '\P{^ingreekextended}', "");
    Expect(0, 8192, '\p{ingreekextended}', "");
    Expect(1, 8192, '\p{^ingreekextended}', "");
    Expect(1, 8192, '\P{ingreekextended}', "");
    Expect(0, 8192, '\P{^ingreekextended}', "");
    Expect(1, 8191, '\p{	-In_Greek_EXTENDED}', "");
    Expect(0, 8191, '\p{^	-In_Greek_EXTENDED}', "");
    Expect(0, 8191, '\P{	-In_Greek_EXTENDED}', "");
    Expect(1, 8191, '\P{^	-In_Greek_EXTENDED}', "");
    Expect(0, 8192, '\p{	-In_Greek_EXTENDED}', "");
    Expect(1, 8192, '\p{^	-In_Greek_EXTENDED}', "");
    Expect(1, 8192, '\P{	-In_Greek_EXTENDED}', "");
    Expect(0, 8192, '\P{^	-In_Greek_EXTENDED}', "");
    Error('\p{_-Greek_EXT/a/}');
    Error('\P{_-Greek_EXT/a/}');
    Expect(1, 8191, '\p{greekext}', "");
    Expect(0, 8191, '\p{^greekext}', "");
    Expect(0, 8191, '\P{greekext}', "");
    Expect(1, 8191, '\P{^greekext}', "");
    Expect(0, 8192, '\p{greekext}', "");
    Expect(1, 8192, '\p{^greekext}', "");
    Expect(1, 8192, '\P{greekext}', "");
    Expect(0, 8192, '\P{^greekext}', "");
    Expect(1, 8191, '\p{  GREEK_Ext}', "");
    Expect(0, 8191, '\p{^  GREEK_Ext}', "");
    Expect(0, 8191, '\P{  GREEK_Ext}', "");
    Expect(1, 8191, '\P{^  GREEK_Ext}', "");
    Expect(0, 8192, '\p{  GREEK_Ext}', "");
    Expect(1, 8192, '\p{^  GREEK_Ext}', "");
    Expect(1, 8192, '\P{  GREEK_Ext}', "");
    Expect(0, 8192, '\P{^  GREEK_Ext}', "");
    Error('\p{		IS_GREEK_EXT/a/}');
    Error('\P{		IS_GREEK_EXT/a/}');
    Expect(1, 8191, '\p{isgreekext}', "");
    Expect(0, 8191, '\p{^isgreekext}', "");
    Expect(0, 8191, '\P{isgreekext}', "");
    Expect(1, 8191, '\P{^isgreekext}', "");
    Expect(0, 8192, '\p{isgreekext}', "");
    Expect(1, 8192, '\p{^isgreekext}', "");
    Expect(1, 8192, '\P{isgreekext}', "");
    Expect(0, 8192, '\P{^isgreekext}', "");
    Expect(1, 8191, '\p{	is_greek_Ext}', "");
    Expect(0, 8191, '\p{^	is_greek_Ext}', "");
    Expect(0, 8191, '\P{	is_greek_Ext}', "");
    Expect(1, 8191, '\P{^	is_greek_Ext}', "");
    Expect(0, 8192, '\p{	is_greek_Ext}', "");
    Expect(1, 8192, '\p{^	is_greek_Ext}', "");
    Expect(1, 8192, '\P{	is_greek_Ext}', "");
    Expect(0, 8192, '\P{^	is_greek_Ext}', "");
    Error('\p{/a/_-in_greek_Ext}');
    Error('\P{/a/_-in_greek_Ext}');
    Expect(1, 8191, '\p{ingreekext}', "");
    Expect(0, 8191, '\p{^ingreekext}', "");
    Expect(0, 8191, '\P{ingreekext}', "");
    Expect(1, 8191, '\P{^ingreekext}', "");
    Expect(0, 8192, '\p{ingreekext}', "");
    Expect(1, 8192, '\p{^ingreekext}', "");
    Expect(1, 8192, '\P{ingreekext}', "");
    Expect(0, 8192, '\P{^ingreekext}', "");
    Expect(1, 8191, '\p{	_In_greek_EXT}', "");
    Expect(0, 8191, '\p{^	_In_greek_EXT}', "");
    Expect(0, 8191, '\P{	_In_greek_EXT}', "");
    Expect(1, 8191, '\P{^	_In_greek_EXT}', "");
    Expect(0, 8192, '\p{	_In_greek_EXT}', "");
    Expect(1, 8192, '\p{^	_In_greek_EXT}', "");
    Expect(1, 8192, '\P{	_In_greek_EXT}', "");
    Expect(0, 8192, '\P{^	_In_greek_EXT}', "");
    Error('\p{:=	_gujarati}');
    Error('\P{:=	_gujarati}');
    Expect(1, 43065, '\p{gujarati}', "");
    Expect(0, 43065, '\p{^gujarati}', "");
    Expect(0, 43065, '\P{gujarati}', "");
    Expect(1, 43065, '\P{^gujarati}', "");
    Expect(0, 43066, '\p{gujarati}', "");
    Expect(1, 43066, '\p{^gujarati}', "");
    Expect(1, 43066, '\P{gujarati}', "");
    Expect(0, 43066, '\P{^gujarati}', "");
    Expect(1, 43065, '\p{-	Gujarati}', "");
    Expect(0, 43065, '\p{^-	Gujarati}', "");
    Expect(0, 43065, '\P{-	Gujarati}', "");
    Expect(1, 43065, '\P{^-	Gujarati}', "");
    Expect(0, 43066, '\p{-	Gujarati}', "");
    Expect(1, 43066, '\p{^-	Gujarati}', "");
    Expect(1, 43066, '\P{-	Gujarati}', "");
    Expect(0, 43066, '\P{^-	Gujarati}', "");
    Error('\p{ IS_gujarati:=}');
    Error('\P{ IS_gujarati:=}');
    Expect(1, 43065, '\p{isgujarati}', "");
    Expect(0, 43065, '\p{^isgujarati}', "");
    Expect(0, 43065, '\P{isgujarati}', "");
    Expect(1, 43065, '\P{^isgujarati}', "");
    Expect(0, 43066, '\p{isgujarati}', "");
    Expect(1, 43066, '\p{^isgujarati}', "");
    Expect(1, 43066, '\P{isgujarati}', "");
    Expect(0, 43066, '\P{^isgujarati}', "");
    Expect(1, 43065, '\p{_is_Gujarati}', "");
    Expect(0, 43065, '\p{^_is_Gujarati}', "");
    Expect(0, 43065, '\P{_is_Gujarati}', "");
    Expect(1, 43065, '\P{^_is_Gujarati}', "");
    Expect(0, 43066, '\p{_is_Gujarati}', "");
    Expect(1, 43066, '\p{^_is_Gujarati}', "");
    Expect(1, 43066, '\P{_is_Gujarati}', "");
    Expect(0, 43066, '\P{^_is_Gujarati}', "");
    Error('\p{:=Gujr}');
    Error('\P{:=Gujr}');
    Expect(1, 43065, '\p{gujr}', "");
    Expect(0, 43065, '\p{^gujr}', "");
    Expect(0, 43065, '\P{gujr}', "");
    Expect(1, 43065, '\P{^gujr}', "");
    Expect(0, 43066, '\p{gujr}', "");
    Expect(1, 43066, '\p{^gujr}', "");
    Expect(1, 43066, '\P{gujr}', "");
    Expect(0, 43066, '\P{^gujr}', "");
    Error('\p{/a/-_Is_Gujr}');
    Error('\P{/a/-_Is_Gujr}');
    Expect(1, 43065, '\p{isgujr}', "");
    Expect(0, 43065, '\p{^isgujr}', "");
    Expect(0, 43065, '\P{isgujr}', "");
    Expect(1, 43065, '\P{^isgujr}', "");
    Expect(0, 43066, '\p{isgujr}', "");
    Expect(1, 43066, '\p{^isgujr}', "");
    Expect(1, 43066, '\P{isgujr}', "");
    Expect(0, 43066, '\P{^isgujr}', "");
    Expect(1, 43065, '\p{is_GUJR}', "");
    Expect(0, 43065, '\p{^is_GUJR}', "");
    Expect(0, 43065, '\P{is_GUJR}', "");
    Expect(1, 43065, '\P{^is_GUJR}', "");
    Expect(0, 43066, '\p{is_GUJR}', "");
    Expect(1, 43066, '\p{^is_GUJR}', "");
    Expect(1, 43066, '\P{is_GUJR}', "");
    Expect(0, 43066, '\P{^is_GUJR}', "");
    Error('\p{__Gurmukhi:=}');
    Error('\P{__Gurmukhi:=}');
    Expect(1, 43065, '\p{gurmukhi}', "");
    Expect(0, 43065, '\p{^gurmukhi}', "");
    Expect(0, 43065, '\P{gurmukhi}', "");
    Expect(1, 43065, '\P{^gurmukhi}', "");
    Expect(0, 43066, '\p{gurmukhi}', "");
    Expect(1, 43066, '\p{^gurmukhi}', "");
    Expect(1, 43066, '\P{gurmukhi}', "");
    Expect(0, 43066, '\P{^gurmukhi}', "");
    Expect(1, 43065, '\p{-_gurmukhi}', "");
    Expect(0, 43065, '\p{^-_gurmukhi}', "");
    Expect(0, 43065, '\P{-_gurmukhi}', "");
    Expect(1, 43065, '\P{^-_gurmukhi}', "");
    Expect(0, 43066, '\p{-_gurmukhi}', "");
    Expect(1, 43066, '\p{^-_gurmukhi}', "");
    Expect(1, 43066, '\P{-_gurmukhi}', "");
    Expect(0, 43066, '\P{^-_gurmukhi}', "");
    Error('\p{ /a/is_Gurmukhi}');
    Error('\P{ /a/is_Gurmukhi}');
    Expect(1, 43065, '\p{isgurmukhi}', "");
    Expect(0, 43065, '\p{^isgurmukhi}', "");
    Expect(0, 43065, '\P{isgurmukhi}', "");
    Expect(1, 43065, '\P{^isgurmukhi}', "");
    Expect(0, 43066, '\p{isgurmukhi}', "");
    Expect(1, 43066, '\p{^isgurmukhi}', "");
    Expect(1, 43066, '\P{isgurmukhi}', "");
    Expect(0, 43066, '\P{^isgurmukhi}', "");
    Expect(1, 43065, '\p{	_is_Gurmukhi}', "");
    Expect(0, 43065, '\p{^	_is_Gurmukhi}', "");
    Expect(0, 43065, '\P{	_is_Gurmukhi}', "");
    Expect(1, 43065, '\P{^	_is_Gurmukhi}', "");
    Expect(0, 43066, '\p{	_is_Gurmukhi}', "");
    Expect(1, 43066, '\p{^	_is_Gurmukhi}', "");
    Expect(1, 43066, '\P{	_is_Gurmukhi}', "");
    Expect(0, 43066, '\P{^	_is_Gurmukhi}', "");
    Error('\p{	:=Guru}');
    Error('\P{	:=Guru}');
    Expect(1, 43065, '\p{guru}', "");
    Expect(0, 43065, '\p{^guru}', "");
    Expect(0, 43065, '\P{guru}', "");
    Expect(1, 43065, '\P{^guru}', "");
    Expect(0, 43066, '\p{guru}', "");
    Expect(1, 43066, '\p{^guru}', "");
    Expect(1, 43066, '\P{guru}', "");
    Expect(0, 43066, '\P{^guru}', "");
    Expect(1, 43065, '\p{- Guru}', "");
    Expect(0, 43065, '\p{^- Guru}', "");
    Expect(0, 43065, '\P{- Guru}', "");
    Expect(1, 43065, '\P{^- Guru}', "");
    Expect(0, 43066, '\p{- Guru}', "");
    Expect(1, 43066, '\p{^- Guru}', "");
    Expect(1, 43066, '\P{- Guru}', "");
    Expect(0, 43066, '\P{^- Guru}', "");
    Error('\p{ _IS_Guru:=}');
    Error('\P{ _IS_Guru:=}');
    Expect(1, 43065, '\p{isguru}', "");
    Expect(0, 43065, '\p{^isguru}', "");
    Expect(0, 43065, '\P{isguru}', "");
    Expect(1, 43065, '\P{^isguru}', "");
    Expect(0, 43066, '\p{isguru}', "");
    Expect(1, 43066, '\p{^isguru}', "");
    Expect(1, 43066, '\P{isguru}', "");
    Expect(0, 43066, '\P{^isguru}', "");
    Expect(1, 43065, '\p{- Is_Guru}', "");
    Expect(0, 43065, '\p{^- Is_Guru}', "");
    Expect(0, 43065, '\P{- Is_Guru}', "");
    Expect(1, 43065, '\P{^- Is_Guru}', "");
    Expect(0, 43066, '\p{- Is_Guru}', "");
    Expect(1, 43066, '\p{^- Is_Guru}', "");
    Expect(1, 43066, '\P{- Is_Guru}', "");
    Expect(0, 43066, '\P{^- Is_Guru}', "");
    Error('\p{/a/ Halfwidth_And_Fullwidth_FORMS}');
    Error('\P{/a/ Halfwidth_And_Fullwidth_FORMS}');
    Expect(1, 65519, '\p{halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\p{^halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\P{halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\P{^halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\p{halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\p{^halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\P{halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\P{^halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\p{ 	HALFWIDTH_And_FULLWIDTH_forms}', "");
    Expect(0, 65519, '\p{^ 	HALFWIDTH_And_FULLWIDTH_forms}', "");
    Expect(0, 65519, '\P{ 	HALFWIDTH_And_FULLWIDTH_forms}', "");
    Expect(1, 65519, '\P{^ 	HALFWIDTH_And_FULLWIDTH_forms}', "");
    Expect(0, 65520, '\p{ 	HALFWIDTH_And_FULLWIDTH_forms}', "");
    Expect(1, 65520, '\p{^ 	HALFWIDTH_And_FULLWIDTH_forms}', "");
    Expect(1, 65520, '\P{ 	HALFWIDTH_And_FULLWIDTH_forms}', "");
    Expect(0, 65520, '\P{^ 	HALFWIDTH_And_FULLWIDTH_forms}', "");
    Error('\p{	/a/Is_Halfwidth_And_Fullwidth_Forms}');
    Error('\P{	/a/Is_Halfwidth_And_Fullwidth_Forms}');
    Expect(1, 65519, '\p{ishalfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\p{^ishalfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\P{ishalfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\P{^ishalfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\p{ishalfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\p{^ishalfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\P{ishalfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\P{^ishalfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\p{_	is_halfwidth_And_Fullwidth_forms}', "");
    Expect(0, 65519, '\p{^_	is_halfwidth_And_Fullwidth_forms}', "");
    Expect(0, 65519, '\P{_	is_halfwidth_And_Fullwidth_forms}', "");
    Expect(1, 65519, '\P{^_	is_halfwidth_And_Fullwidth_forms}', "");
    Expect(0, 65520, '\p{_	is_halfwidth_And_Fullwidth_forms}', "");
    Expect(1, 65520, '\p{^_	is_halfwidth_And_Fullwidth_forms}', "");
    Expect(1, 65520, '\P{_	is_halfwidth_And_Fullwidth_forms}', "");
    Expect(0, 65520, '\P{^_	is_halfwidth_And_Fullwidth_forms}', "");
    Error('\p{_	IN_HALFWIDTH_and_Fullwidth_forms/a/}');
    Error('\P{_	IN_HALFWIDTH_and_Fullwidth_forms/a/}');
    Expect(1, 65519, '\p{inhalfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\p{^inhalfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\P{inhalfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\P{^inhalfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\p{inhalfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\p{^inhalfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\P{inhalfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\P{^inhalfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\p{	IN_halfwidth_And_FULLWIDTH_forms}', "");
    Expect(0, 65519, '\p{^	IN_halfwidth_And_FULLWIDTH_forms}', "");
    Expect(0, 65519, '\P{	IN_halfwidth_And_FULLWIDTH_forms}', "");
    Expect(1, 65519, '\P{^	IN_halfwidth_And_FULLWIDTH_forms}', "");
    Expect(0, 65520, '\p{	IN_halfwidth_And_FULLWIDTH_forms}', "");
    Expect(1, 65520, '\p{^	IN_halfwidth_And_FULLWIDTH_forms}', "");
    Expect(1, 65520, '\P{	IN_halfwidth_And_FULLWIDTH_forms}', "");
    Expect(0, 65520, '\P{^	IN_halfwidth_And_FULLWIDTH_forms}', "");
    Error('\p{:=		Half_AND_Full_Forms}');
    Error('\P{:=		Half_AND_Full_Forms}');
    Expect(1, 65519, '\p{halfandfullforms}', "");
    Expect(0, 65519, '\p{^halfandfullforms}', "");
    Expect(0, 65519, '\P{halfandfullforms}', "");
    Expect(1, 65519, '\P{^halfandfullforms}', "");
    Expect(0, 65520, '\p{halfandfullforms}', "");
    Expect(1, 65520, '\p{^halfandfullforms}', "");
    Expect(1, 65520, '\P{halfandfullforms}', "");
    Expect(0, 65520, '\P{^halfandfullforms}', "");
    Expect(1, 65519, '\p{  half_And_FULL_Forms}', "");
    Expect(0, 65519, '\p{^  half_And_FULL_Forms}', "");
    Expect(0, 65519, '\P{  half_And_FULL_Forms}', "");
    Expect(1, 65519, '\P{^  half_And_FULL_Forms}', "");
    Expect(0, 65520, '\p{  half_And_FULL_Forms}', "");
    Expect(1, 65520, '\p{^  half_And_FULL_Forms}', "");
    Expect(1, 65520, '\P{  half_And_FULL_Forms}', "");
    Expect(0, 65520, '\P{^  half_And_FULL_Forms}', "");
    Error('\p{		is_Half_and_Full_Forms/a/}');
    Error('\P{		is_Half_and_Full_Forms/a/}');
    Expect(1, 65519, '\p{ishalfandfullforms}', "");
    Expect(0, 65519, '\p{^ishalfandfullforms}', "");
    Expect(0, 65519, '\P{ishalfandfullforms}', "");
    Expect(1, 65519, '\P{^ishalfandfullforms}', "");
    Expect(0, 65520, '\p{ishalfandfullforms}', "");
    Expect(1, 65520, '\p{^ishalfandfullforms}', "");
    Expect(1, 65520, '\P{ishalfandfullforms}', "");
    Expect(0, 65520, '\P{^ishalfandfullforms}', "");
    Expect(1, 65519, '\p{	_IS_Half_and_FULL_FORMS}', "");
    Expect(0, 65519, '\p{^	_IS_Half_and_FULL_FORMS}', "");
    Expect(0, 65519, '\P{	_IS_Half_and_FULL_FORMS}', "");
    Expect(1, 65519, '\P{^	_IS_Half_and_FULL_FORMS}', "");
    Expect(0, 65520, '\p{	_IS_Half_and_FULL_FORMS}', "");
    Expect(1, 65520, '\p{^	_IS_Half_and_FULL_FORMS}', "");
    Expect(1, 65520, '\P{	_IS_Half_and_FULL_FORMS}', "");
    Expect(0, 65520, '\P{^	_IS_Half_and_FULL_FORMS}', "");
    Error('\p{-/a/IN_HALF_AND_Full_Forms}');
    Error('\P{-/a/IN_HALF_AND_Full_Forms}');
    Expect(1, 65519, '\p{inhalfandfullforms}', "");
    Expect(0, 65519, '\p{^inhalfandfullforms}', "");
    Expect(0, 65519, '\P{inhalfandfullforms}', "");
    Expect(1, 65519, '\P{^inhalfandfullforms}', "");
    Expect(0, 65520, '\p{inhalfandfullforms}', "");
    Expect(1, 65520, '\p{^inhalfandfullforms}', "");
    Expect(1, 65520, '\P{inhalfandfullforms}', "");
    Expect(0, 65520, '\P{^inhalfandfullforms}', "");
    Expect(1, 65519, '\p{	In_HALF_And_Full_Forms}', "");
    Expect(0, 65519, '\p{^	In_HALF_And_Full_Forms}', "");
    Expect(0, 65519, '\P{	In_HALF_And_Full_Forms}', "");
    Expect(1, 65519, '\P{^	In_HALF_And_Full_Forms}', "");
    Expect(0, 65520, '\p{	In_HALF_And_Full_Forms}', "");
    Expect(1, 65520, '\p{^	In_HALF_And_Full_Forms}', "");
    Expect(1, 65520, '\P{	In_HALF_And_Full_Forms}', "");
    Expect(0, 65520, '\P{^	In_HALF_And_Full_Forms}', "");
    Error('\p{	:=Han}');
    Error('\P{	:=Han}');
    Expect(1, 195101, '\p{han}', "");
    Expect(0, 195101, '\p{^han}', "");
    Expect(0, 195101, '\P{han}', "");
    Expect(1, 195101, '\P{^han}', "");
    Expect(0, 195102, '\p{han}', "");
    Expect(1, 195102, '\p{^han}', "");
    Expect(1, 195102, '\P{han}', "");
    Expect(0, 195102, '\P{^han}', "");
    Expect(1, 195101, '\p{  HAN}', "");
    Expect(0, 195101, '\p{^  HAN}', "");
    Expect(0, 195101, '\P{  HAN}', "");
    Expect(1, 195101, '\P{^  HAN}', "");
    Expect(0, 195102, '\p{  HAN}', "");
    Expect(1, 195102, '\p{^  HAN}', "");
    Expect(1, 195102, '\P{  HAN}', "");
    Expect(0, 195102, '\P{^  HAN}', "");
    Error('\p{ 	is_Han/a/}');
    Error('\P{ 	is_Han/a/}');
    Expect(1, 195101, '\p{ishan}', "");
    Expect(0, 195101, '\p{^ishan}', "");
    Expect(0, 195101, '\P{ishan}', "");
    Expect(1, 195101, '\P{^ishan}', "");
    Expect(0, 195102, '\p{ishan}', "");
    Expect(1, 195102, '\p{^ishan}', "");
    Expect(1, 195102, '\P{ishan}', "");
    Expect(0, 195102, '\P{^ishan}', "");
    Expect(1, 195101, '\p{ _Is_HAN}', "");
    Expect(0, 195101, '\p{^ _Is_HAN}', "");
    Expect(0, 195101, '\P{ _Is_HAN}', "");
    Expect(1, 195101, '\P{^ _Is_HAN}', "");
    Expect(0, 195102, '\p{ _Is_HAN}', "");
    Expect(1, 195102, '\p{^ _Is_HAN}', "");
    Expect(1, 195102, '\P{ _Is_HAN}', "");
    Expect(0, 195102, '\P{^ _Is_HAN}', "");
    Error('\p{/a/	_hani}');
    Error('\P{/a/	_hani}');
    Expect(1, 195101, '\p{hani}', "");
    Expect(0, 195101, '\p{^hani}', "");
    Expect(0, 195101, '\P{hani}', "");
    Expect(1, 195101, '\P{^hani}', "");
    Expect(0, 195102, '\p{hani}', "");
    Expect(1, 195102, '\p{^hani}', "");
    Expect(1, 195102, '\P{hani}', "");
    Expect(0, 195102, '\P{^hani}', "");
    Expect(1, 195101, '\p{ -Hani}', "");
    Expect(0, 195101, '\p{^ -Hani}', "");
    Expect(0, 195101, '\P{ -Hani}', "");
    Expect(1, 195101, '\P{^ -Hani}', "");
    Expect(0, 195102, '\p{ -Hani}', "");
    Expect(1, 195102, '\p{^ -Hani}', "");
    Expect(1, 195102, '\P{ -Hani}', "");
    Expect(0, 195102, '\P{^ -Hani}', "");
    Error('\p{_:=Is_Hani}');
    Error('\P{_:=Is_Hani}');
    Expect(1, 195101, '\p{ishani}', "");
    Expect(0, 195101, '\p{^ishani}', "");
    Expect(0, 195101, '\P{ishani}', "");
    Expect(1, 195101, '\P{^ishani}', "");
    Expect(0, 195102, '\p{ishani}', "");
    Expect(1, 195102, '\p{^ishani}', "");
    Expect(1, 195102, '\P{ishani}', "");
    Expect(0, 195102, '\P{^ishani}', "");
    Expect(1, 195101, '\p{ 	is_Hani}', "");
    Expect(0, 195101, '\p{^ 	is_Hani}', "");
    Expect(0, 195101, '\P{ 	is_Hani}', "");
    Expect(1, 195101, '\P{^ 	is_Hani}', "");
    Expect(0, 195102, '\p{ 	is_Hani}', "");
    Expect(1, 195102, '\p{^ 	is_Hani}', "");
    Expect(1, 195102, '\P{ 	is_Hani}', "");
    Expect(0, 195102, '\P{^ 	is_Hani}', "");
    Error('\p{_Hangul:=}');
    Error('\P{_Hangul:=}');
    Expect(1, 65500, '\p{hangul}', "");
    Expect(0, 65500, '\p{^hangul}', "");
    Expect(0, 65500, '\P{hangul}', "");
    Expect(1, 65500, '\P{^hangul}', "");
    Expect(0, 65501, '\p{hangul}', "");
    Expect(1, 65501, '\p{^hangul}', "");
    Expect(1, 65501, '\P{hangul}', "");
    Expect(0, 65501, '\P{^hangul}', "");
    Expect(1, 65500, '\p{--Hangul}', "");
    Expect(0, 65500, '\p{^--Hangul}', "");
    Expect(0, 65500, '\P{--Hangul}', "");
    Expect(1, 65500, '\P{^--Hangul}', "");
    Expect(0, 65501, '\p{--Hangul}', "");
    Expect(1, 65501, '\p{^--Hangul}', "");
    Expect(1, 65501, '\P{--Hangul}', "");
    Expect(0, 65501, '\P{^--Hangul}', "");
    Error('\p{:=_	Is_Hangul}');
    Error('\P{:=_	Is_Hangul}');
    Expect(1, 65500, '\p{ishangul}', "");
    Expect(0, 65500, '\p{^ishangul}', "");
    Expect(0, 65500, '\P{ishangul}', "");
    Expect(1, 65500, '\P{^ishangul}', "");
    Expect(0, 65501, '\p{ishangul}', "");
    Expect(1, 65501, '\p{^ishangul}', "");
    Expect(1, 65501, '\P{ishangul}', "");
    Expect(0, 65501, '\P{^ishangul}', "");
    Expect(1, 65500, '\p{_ Is_Hangul}', "");
    Expect(0, 65500, '\p{^_ Is_Hangul}', "");
    Expect(0, 65500, '\P{_ Is_Hangul}', "");
    Expect(1, 65500, '\P{^_ Is_Hangul}', "");
    Expect(0, 65501, '\p{_ Is_Hangul}', "");
    Expect(1, 65501, '\p{^_ Is_Hangul}', "");
    Expect(1, 65501, '\P{_ Is_Hangul}', "");
    Expect(0, 65501, '\P{^_ Is_Hangul}', "");
    Error('\p{/a/_Hang}');
    Error('\P{/a/_Hang}');
    Expect(1, 65500, '\p{hang}', "");
    Expect(0, 65500, '\p{^hang}', "");
    Expect(0, 65500, '\P{hang}', "");
    Expect(1, 65500, '\P{^hang}', "");
    Expect(0, 65501, '\p{hang}', "");
    Expect(1, 65501, '\p{^hang}', "");
    Expect(1, 65501, '\P{hang}', "");
    Expect(0, 65501, '\P{^hang}', "");
    Expect(1, 65500, '\p{_	Hang}', "");
    Expect(0, 65500, '\p{^_	Hang}', "");
    Expect(0, 65500, '\P{_	Hang}', "");
    Expect(1, 65500, '\P{^_	Hang}', "");
    Expect(0, 65501, '\p{_	Hang}', "");
    Expect(1, 65501, '\p{^_	Hang}', "");
    Expect(1, 65501, '\P{_	Hang}', "");
    Expect(0, 65501, '\P{^_	Hang}', "");
    Error('\p{--Is_hang:=}');
    Error('\P{--Is_hang:=}');
    Expect(1, 65500, '\p{ishang}', "");
    Expect(0, 65500, '\p{^ishang}', "");
    Expect(0, 65500, '\P{ishang}', "");
    Expect(1, 65500, '\P{^ishang}', "");
    Expect(0, 65501, '\p{ishang}', "");
    Expect(1, 65501, '\p{^ishang}', "");
    Expect(1, 65501, '\P{ishang}', "");
    Expect(0, 65501, '\P{^ishang}', "");
    Expect(1, 65500, '\p{_	IS_HANG}', "");
    Expect(0, 65500, '\p{^_	IS_HANG}', "");
    Expect(0, 65500, '\P{_	IS_HANG}', "");
    Expect(1, 65500, '\P{^_	IS_HANG}', "");
    Expect(0, 65501, '\p{_	IS_HANG}', "");
    Expect(1, 65501, '\p{^_	IS_HANG}', "");
    Expect(1, 65501, '\P{_	IS_HANG}', "");
    Expect(0, 65501, '\P{^_	IS_HANG}', "");
    Error('\p{	/a/Hangul_Compatibility_Jamo}');
    Error('\P{	/a/Hangul_Compatibility_Jamo}');
    Expect(1, 12687, '\p{hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\p{^hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\P{hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\P{^hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\p{hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\p{^hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\P{hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\P{^hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\p{ 	HANGUL_COMPATIBILITY_Jamo}', "");
    Expect(0, 12687, '\p{^ 	HANGUL_COMPATIBILITY_Jamo}', "");
    Expect(0, 12687, '\P{ 	HANGUL_COMPATIBILITY_Jamo}', "");
    Expect(1, 12687, '\P{^ 	HANGUL_COMPATIBILITY_Jamo}', "");
    Expect(0, 12688, '\p{ 	HANGUL_COMPATIBILITY_Jamo}', "");
    Expect(1, 12688, '\p{^ 	HANGUL_COMPATIBILITY_Jamo}', "");
    Expect(1, 12688, '\P{ 	HANGUL_COMPATIBILITY_Jamo}', "");
    Expect(0, 12688, '\P{^ 	HANGUL_COMPATIBILITY_Jamo}', "");
    Error('\p{	/a/IS_HANGUL_Compatibility_Jamo}');
    Error('\P{	/a/IS_HANGUL_Compatibility_Jamo}');
    Expect(1, 12687, '\p{ishangulcompatibilityjamo}', "");
    Expect(0, 12687, '\p{^ishangulcompatibilityjamo}', "");
    Expect(0, 12687, '\P{ishangulcompatibilityjamo}', "");
    Expect(1, 12687, '\P{^ishangulcompatibilityjamo}', "");
    Expect(0, 12688, '\p{ishangulcompatibilityjamo}', "");
    Expect(1, 12688, '\p{^ishangulcompatibilityjamo}', "");
    Expect(1, 12688, '\P{ishangulcompatibilityjamo}', "");
    Expect(0, 12688, '\P{^ishangulcompatibilityjamo}', "");
    Expect(1, 12687, '\p{	is_hangul_Compatibility_jamo}', "");
    Expect(0, 12687, '\p{^	is_hangul_Compatibility_jamo}', "");
    Expect(0, 12687, '\P{	is_hangul_Compatibility_jamo}', "");
    Expect(1, 12687, '\P{^	is_hangul_Compatibility_jamo}', "");
    Expect(0, 12688, '\p{	is_hangul_Compatibility_jamo}', "");
    Expect(1, 12688, '\p{^	is_hangul_Compatibility_jamo}', "");
    Expect(1, 12688, '\P{	is_hangul_Compatibility_jamo}', "");
    Expect(0, 12688, '\P{^	is_hangul_Compatibility_jamo}', "");
    Error('\p{-/a/in_HANGUL_compatibility_Jamo}');
    Error('\P{-/a/in_HANGUL_compatibility_Jamo}');
    Expect(1, 12687, '\p{inhangulcompatibilityjamo}', "");
    Expect(0, 12687, '\p{^inhangulcompatibilityjamo}', "");
    Expect(0, 12687, '\P{inhangulcompatibilityjamo}', "");
    Expect(1, 12687, '\P{^inhangulcompatibilityjamo}', "");
    Expect(0, 12688, '\p{inhangulcompatibilityjamo}', "");
    Expect(1, 12688, '\p{^inhangulcompatibilityjamo}', "");
    Expect(1, 12688, '\P{inhangulcompatibilityjamo}', "");
    Expect(0, 12688, '\P{^inhangulcompatibilityjamo}', "");
    Expect(1, 12687, '\p{_ In_Hangul_compatibility_JAMO}', "");
    Expect(0, 12687, '\p{^_ In_Hangul_compatibility_JAMO}', "");
    Expect(0, 12687, '\P{_ In_Hangul_compatibility_JAMO}', "");
    Expect(1, 12687, '\P{^_ In_Hangul_compatibility_JAMO}', "");
    Expect(0, 12688, '\p{_ In_Hangul_compatibility_JAMO}', "");
    Expect(1, 12688, '\p{^_ In_Hangul_compatibility_JAMO}', "");
    Expect(1, 12688, '\P{_ In_Hangul_compatibility_JAMO}', "");
    Expect(0, 12688, '\P{^_ In_Hangul_compatibility_JAMO}', "");
    Error('\p{	Compat_Jamo/a/}');
    Error('\P{	Compat_Jamo/a/}');
    Expect(1, 12687, '\p{compatjamo}', "");
    Expect(0, 12687, '\p{^compatjamo}', "");
    Expect(0, 12687, '\P{compatjamo}', "");
    Expect(1, 12687, '\P{^compatjamo}', "");
    Expect(0, 12688, '\p{compatjamo}', "");
    Expect(1, 12688, '\p{^compatjamo}', "");
    Expect(1, 12688, '\P{compatjamo}', "");
    Expect(0, 12688, '\P{^compatjamo}', "");
    Expect(1, 12687, '\p{	Compat_JAMO}', "");
    Expect(0, 12687, '\p{^	Compat_JAMO}', "");
    Expect(0, 12687, '\P{	Compat_JAMO}', "");
    Expect(1, 12687, '\P{^	Compat_JAMO}', "");
    Expect(0, 12688, '\p{	Compat_JAMO}', "");
    Expect(1, 12688, '\p{^	Compat_JAMO}', "");
    Expect(1, 12688, '\P{	Compat_JAMO}', "");
    Expect(0, 12688, '\P{^	Compat_JAMO}', "");
    Error('\p{	-Is_compat_Jamo/a/}');
    Error('\P{	-Is_compat_Jamo/a/}');
    Expect(1, 12687, '\p{iscompatjamo}', "");
    Expect(0, 12687, '\p{^iscompatjamo}', "");
    Expect(0, 12687, '\P{iscompatjamo}', "");
    Expect(1, 12687, '\P{^iscompatjamo}', "");
    Expect(0, 12688, '\p{iscompatjamo}', "");
    Expect(1, 12688, '\p{^iscompatjamo}', "");
    Expect(1, 12688, '\P{iscompatjamo}', "");
    Expect(0, 12688, '\P{^iscompatjamo}', "");
    Expect(1, 12687, '\p{	_Is_COMPAT_JAMO}', "");
    Expect(0, 12687, '\p{^	_Is_COMPAT_JAMO}', "");
    Expect(0, 12687, '\P{	_Is_COMPAT_JAMO}', "");
    Expect(1, 12687, '\P{^	_Is_COMPAT_JAMO}', "");
    Expect(0, 12688, '\p{	_Is_COMPAT_JAMO}', "");
    Expect(1, 12688, '\p{^	_Is_COMPAT_JAMO}', "");
    Expect(1, 12688, '\P{	_Is_COMPAT_JAMO}', "");
    Expect(0, 12688, '\P{^	_Is_COMPAT_JAMO}', "");
    Error('\p{	:=In_COMPAT_Jamo}');
    Error('\P{	:=In_COMPAT_Jamo}');
    Expect(1, 12687, '\p{incompatjamo}', "");
    Expect(0, 12687, '\p{^incompatjamo}', "");
    Expect(0, 12687, '\P{incompatjamo}', "");
    Expect(1, 12687, '\P{^incompatjamo}', "");
    Expect(0, 12688, '\p{incompatjamo}', "");
    Expect(1, 12688, '\p{^incompatjamo}', "");
    Expect(1, 12688, '\P{incompatjamo}', "");
    Expect(0, 12688, '\P{^incompatjamo}', "");
    Expect(1, 12687, '\p{	_In_Compat_jamo}', "");
    Expect(0, 12687, '\p{^	_In_Compat_jamo}', "");
    Expect(0, 12687, '\P{	_In_Compat_jamo}', "");
    Expect(1, 12687, '\P{^	_In_Compat_jamo}', "");
    Expect(0, 12688, '\p{	_In_Compat_jamo}', "");
    Expect(1, 12688, '\p{^	_In_Compat_jamo}', "");
    Expect(1, 12688, '\P{	_In_Compat_jamo}', "");
    Expect(0, 12688, '\P{^	_In_Compat_jamo}', "");
    Error('\p{_HANGUL_Jamo/a/}');
    Error('\P{_HANGUL_Jamo/a/}');
    Expect(1, 4607, '\p{hanguljamo}', "");
    Expect(0, 4607, '\p{^hanguljamo}', "");
    Expect(0, 4607, '\P{hanguljamo}', "");
    Expect(1, 4607, '\P{^hanguljamo}', "");
    Expect(0, 4608, '\p{hanguljamo}', "");
    Expect(1, 4608, '\p{^hanguljamo}', "");
    Expect(1, 4608, '\P{hanguljamo}', "");
    Expect(0, 4608, '\P{^hanguljamo}', "");
    Expect(1, 4607, '\p{_	Hangul_jamo}', "");
    Expect(0, 4607, '\p{^_	Hangul_jamo}', "");
    Expect(0, 4607, '\P{_	Hangul_jamo}', "");
    Expect(1, 4607, '\P{^_	Hangul_jamo}', "");
    Expect(0, 4608, '\p{_	Hangul_jamo}', "");
    Expect(1, 4608, '\p{^_	Hangul_jamo}', "");
    Expect(1, 4608, '\P{_	Hangul_jamo}', "");
    Expect(0, 4608, '\P{^_	Hangul_jamo}', "");
    Error('\p{-/a/IS_HANGUL_jamo}');
    Error('\P{-/a/IS_HANGUL_jamo}');
    Expect(1, 4607, '\p{ishanguljamo}', "");
    Expect(0, 4607, '\p{^ishanguljamo}', "");
    Expect(0, 4607, '\P{ishanguljamo}', "");
    Expect(1, 4607, '\P{^ishanguljamo}', "");
    Expect(0, 4608, '\p{ishanguljamo}', "");
    Expect(1, 4608, '\p{^ishanguljamo}', "");
    Expect(1, 4608, '\P{ishanguljamo}', "");
    Expect(0, 4608, '\P{^ishanguljamo}', "");
    Expect(1, 4607, '\p{_	Is_HANGUL_Jamo}', "");
    Expect(0, 4607, '\p{^_	Is_HANGUL_Jamo}', "");
    Expect(0, 4607, '\P{_	Is_HANGUL_Jamo}', "");
    Expect(1, 4607, '\P{^_	Is_HANGUL_Jamo}', "");
    Expect(0, 4608, '\p{_	Is_HANGUL_Jamo}', "");
    Expect(1, 4608, '\p{^_	Is_HANGUL_Jamo}', "");
    Expect(1, 4608, '\P{_	Is_HANGUL_Jamo}', "");
    Expect(0, 4608, '\P{^_	Is_HANGUL_Jamo}', "");
    Error('\p{:=	In_Hangul_jamo}');
    Error('\P{:=	In_Hangul_jamo}');
    Expect(1, 4607, '\p{inhanguljamo}', "");
    Expect(0, 4607, '\p{^inhanguljamo}', "");
    Expect(0, 4607, '\P{inhanguljamo}', "");
    Expect(1, 4607, '\P{^inhanguljamo}', "");
    Expect(0, 4608, '\p{inhanguljamo}', "");
    Expect(1, 4608, '\p{^inhanguljamo}', "");
    Expect(1, 4608, '\P{inhanguljamo}', "");
    Expect(0, 4608, '\P{^inhanguljamo}', "");
    Expect(1, 4607, '\p{--IN_HANGUL_jamo}', "");
    Expect(0, 4607, '\p{^--IN_HANGUL_jamo}', "");
    Expect(0, 4607, '\P{--IN_HANGUL_jamo}', "");
    Expect(1, 4607, '\P{^--IN_HANGUL_jamo}', "");
    Expect(0, 4608, '\p{--IN_HANGUL_jamo}', "");
    Expect(1, 4608, '\p{^--IN_HANGUL_jamo}', "");
    Expect(1, 4608, '\P{--IN_HANGUL_jamo}', "");
    Expect(0, 4608, '\P{^--IN_HANGUL_jamo}', "");
    Error('\p{/a/	jamo}');
    Error('\P{/a/	jamo}');
    Expect(1, 4607, '\p{jamo}', "");
    Expect(0, 4607, '\p{^jamo}', "");
    Expect(0, 4607, '\P{jamo}', "");
    Expect(1, 4607, '\P{^jamo}', "");
    Expect(0, 4608, '\p{jamo}', "");
    Expect(1, 4608, '\p{^jamo}', "");
    Expect(1, 4608, '\P{jamo}', "");
    Expect(0, 4608, '\P{^jamo}', "");
    Expect(1, 4607, '\p{	 jamo}', "");
    Expect(0, 4607, '\p{^	 jamo}', "");
    Expect(0, 4607, '\P{	 jamo}', "");
    Expect(1, 4607, '\P{^	 jamo}', "");
    Expect(0, 4608, '\p{	 jamo}', "");
    Expect(1, 4608, '\p{^	 jamo}', "");
    Expect(1, 4608, '\P{	 jamo}', "");
    Expect(0, 4608, '\P{^	 jamo}', "");
    Error('\p{ -Is_jamo:=}');
    Error('\P{ -Is_jamo:=}');
    Expect(1, 4607, '\p{isjamo}', "");
    Expect(0, 4607, '\p{^isjamo}', "");
    Expect(0, 4607, '\P{isjamo}', "");
    Expect(1, 4607, '\P{^isjamo}', "");
    Expect(0, 4608, '\p{isjamo}', "");
    Expect(1, 4608, '\p{^isjamo}', "");
    Expect(1, 4608, '\P{isjamo}', "");
    Expect(0, 4608, '\P{^isjamo}', "");
    Expect(1, 4607, '\p{_ is_jamo}', "");
    Expect(0, 4607, '\p{^_ is_jamo}', "");
    Expect(0, 4607, '\P{_ is_jamo}', "");
    Expect(1, 4607, '\P{^_ is_jamo}', "");
    Expect(0, 4608, '\p{_ is_jamo}', "");
    Expect(1, 4608, '\p{^_ is_jamo}', "");
    Expect(1, 4608, '\P{_ is_jamo}', "");
    Expect(0, 4608, '\P{^_ is_jamo}', "");
    Error('\p{:=-IN_Jamo}');
    Error('\P{:=-IN_Jamo}');
    Expect(1, 4607, '\p{injamo}', "");
    Expect(0, 4607, '\p{^injamo}', "");
    Expect(0, 4607, '\P{injamo}', "");
    Expect(1, 4607, '\P{^injamo}', "");
    Expect(0, 4608, '\p{injamo}', "");
    Expect(1, 4608, '\p{^injamo}', "");
    Expect(1, 4608, '\P{injamo}', "");
    Expect(0, 4608, '\P{^injamo}', "");
    Expect(1, 4607, '\p{ _In_jamo}', "");
    Expect(0, 4607, '\p{^ _In_jamo}', "");
    Expect(0, 4607, '\P{ _In_jamo}', "");
    Expect(1, 4607, '\P{^ _In_jamo}', "");
    Expect(0, 4608, '\p{ _In_jamo}', "");
    Expect(1, 4608, '\p{^ _In_jamo}', "");
    Expect(1, 4608, '\P{ _In_jamo}', "");
    Expect(0, 4608, '\P{^ _In_jamo}', "");
    Error('\p{_/a/hangul_JAMO_extended_A}');
    Error('\P{_/a/hangul_JAMO_extended_A}');
    Expect(1, 43391, '\p{hanguljamoextendeda}', "");
    Expect(0, 43391, '\p{^hanguljamoextendeda}', "");
    Expect(0, 43391, '\P{hanguljamoextendeda}', "");
    Expect(1, 43391, '\P{^hanguljamoextendeda}', "");
    Expect(0, 43392, '\p{hanguljamoextendeda}', "");
    Expect(1, 43392, '\p{^hanguljamoextendeda}', "");
    Expect(1, 43392, '\P{hanguljamoextendeda}', "");
    Expect(0, 43392, '\P{^hanguljamoextendeda}', "");
    Expect(1, 43391, '\p{_	Hangul_JAMO_EXTENDED_A}', "");
    Expect(0, 43391, '\p{^_	Hangul_JAMO_EXTENDED_A}', "");
    Expect(0, 43391, '\P{_	Hangul_JAMO_EXTENDED_A}', "");
    Expect(1, 43391, '\P{^_	Hangul_JAMO_EXTENDED_A}', "");
    Expect(0, 43392, '\p{_	Hangul_JAMO_EXTENDED_A}', "");
    Expect(1, 43392, '\p{^_	Hangul_JAMO_EXTENDED_A}', "");
    Expect(1, 43392, '\P{_	Hangul_JAMO_EXTENDED_A}', "");
    Expect(0, 43392, '\P{^_	Hangul_JAMO_EXTENDED_A}', "");
    Error('\p{/a/-_Is_Hangul_Jamo_Extended_a}');
    Error('\P{/a/-_Is_Hangul_Jamo_Extended_a}');
    Expect(1, 43391, '\p{ishanguljamoextendeda}', "");
    Expect(0, 43391, '\p{^ishanguljamoextendeda}', "");
    Expect(0, 43391, '\P{ishanguljamoextendeda}', "");
    Expect(1, 43391, '\P{^ishanguljamoextendeda}', "");
    Expect(0, 43392, '\p{ishanguljamoextendeda}', "");
    Expect(1, 43392, '\p{^ishanguljamoextendeda}', "");
    Expect(1, 43392, '\P{ishanguljamoextendeda}', "");
    Expect(0, 43392, '\P{^ishanguljamoextendeda}', "");
    Expect(1, 43391, '\p{_Is_Hangul_JAMO_EXTENDED_A}', "");
    Expect(0, 43391, '\p{^_Is_Hangul_JAMO_EXTENDED_A}', "");
    Expect(0, 43391, '\P{_Is_Hangul_JAMO_EXTENDED_A}', "");
    Expect(1, 43391, '\P{^_Is_Hangul_JAMO_EXTENDED_A}', "");
    Expect(0, 43392, '\p{_Is_Hangul_JAMO_EXTENDED_A}', "");
    Expect(1, 43392, '\p{^_Is_Hangul_JAMO_EXTENDED_A}', "");
    Expect(1, 43392, '\P{_Is_Hangul_JAMO_EXTENDED_A}', "");
    Expect(0, 43392, '\P{^_Is_Hangul_JAMO_EXTENDED_A}', "");
    Error('\p{:=-IN_HANGUL_JAMO_extended_A}');
    Error('\P{:=-IN_HANGUL_JAMO_extended_A}');
    Expect(1, 43391, '\p{inhanguljamoextendeda}', "");
    Expect(0, 43391, '\p{^inhanguljamoextendeda}', "");
    Expect(0, 43391, '\P{inhanguljamoextendeda}', "");
    Expect(1, 43391, '\P{^inhanguljamoextendeda}', "");
    Expect(0, 43392, '\p{inhanguljamoextendeda}', "");
    Expect(1, 43392, '\p{^inhanguljamoextendeda}', "");
    Expect(1, 43392, '\P{inhanguljamoextendeda}', "");
    Expect(0, 43392, '\P{^inhanguljamoextendeda}', "");
    Expect(1, 43391, '\p{	in_Hangul_jamo_Extended_A}', "");
    Expect(0, 43391, '\p{^	in_Hangul_jamo_Extended_A}', "");
    Expect(0, 43391, '\P{	in_Hangul_jamo_Extended_A}', "");
    Expect(1, 43391, '\P{^	in_Hangul_jamo_Extended_A}', "");
    Expect(0, 43392, '\p{	in_Hangul_jamo_Extended_A}', "");
    Expect(1, 43392, '\p{^	in_Hangul_jamo_Extended_A}', "");
    Expect(1, 43392, '\P{	in_Hangul_jamo_Extended_A}', "");
    Expect(0, 43392, '\P{^	in_Hangul_jamo_Extended_A}', "");
    Error('\p{:=_-jamo_Ext_A}');
    Error('\P{:=_-jamo_Ext_A}');
    Expect(1, 43391, '\p{jamoexta}', "");
    Expect(0, 43391, '\p{^jamoexta}', "");
    Expect(0, 43391, '\P{jamoexta}', "");
    Expect(1, 43391, '\P{^jamoexta}', "");
    Expect(0, 43392, '\p{jamoexta}', "");
    Expect(1, 43392, '\p{^jamoexta}', "");
    Expect(1, 43392, '\P{jamoexta}', "");
    Expect(0, 43392, '\P{^jamoexta}', "");
    Expect(1, 43391, '\p{__Jamo_Ext_A}', "");
    Expect(0, 43391, '\p{^__Jamo_Ext_A}', "");
    Expect(0, 43391, '\P{__Jamo_Ext_A}', "");
    Expect(1, 43391, '\P{^__Jamo_Ext_A}', "");
    Expect(0, 43392, '\p{__Jamo_Ext_A}', "");
    Expect(1, 43392, '\p{^__Jamo_Ext_A}', "");
    Expect(1, 43392, '\P{__Jamo_Ext_A}', "");
    Expect(0, 43392, '\P{^__Jamo_Ext_A}', "");
    Error('\p{:=_IS_Jamo_ext_A}');
    Error('\P{:=_IS_Jamo_ext_A}');
    Expect(1, 43391, '\p{isjamoexta}', "");
    Expect(0, 43391, '\p{^isjamoexta}', "");
    Expect(0, 43391, '\P{isjamoexta}', "");
    Expect(1, 43391, '\P{^isjamoexta}', "");
    Expect(0, 43392, '\p{isjamoexta}', "");
    Expect(1, 43392, '\p{^isjamoexta}', "");
    Expect(1, 43392, '\P{isjamoexta}', "");
    Expect(0, 43392, '\P{^isjamoexta}', "");
    Expect(1, 43391, '\p{	IS_jamo_Ext_A}', "");
    Expect(0, 43391, '\p{^	IS_jamo_Ext_A}', "");
    Expect(0, 43391, '\P{	IS_jamo_Ext_A}', "");
    Expect(1, 43391, '\P{^	IS_jamo_Ext_A}', "");
    Expect(0, 43392, '\p{	IS_jamo_Ext_A}', "");
    Expect(1, 43392, '\p{^	IS_jamo_Ext_A}', "");
    Expect(1, 43392, '\P{	IS_jamo_Ext_A}', "");
    Expect(0, 43392, '\P{^	IS_jamo_Ext_A}', "");
    Error('\p{_	In_jamo_ext_a:=}');
    Error('\P{_	In_jamo_ext_a:=}');
    Expect(1, 43391, '\p{injamoexta}', "");
    Expect(0, 43391, '\p{^injamoexta}', "");
    Expect(0, 43391, '\P{injamoexta}', "");
    Expect(1, 43391, '\P{^injamoexta}', "");
    Expect(0, 43392, '\p{injamoexta}', "");
    Expect(1, 43392, '\p{^injamoexta}', "");
    Expect(1, 43392, '\P{injamoexta}', "");
    Expect(0, 43392, '\P{^injamoexta}', "");
    Expect(1, 43391, '\p{	 in_Jamo_Ext_a}', "");
    Expect(0, 43391, '\p{^	 in_Jamo_Ext_a}', "");
    Expect(0, 43391, '\P{	 in_Jamo_Ext_a}', "");
    Expect(1, 43391, '\P{^	 in_Jamo_Ext_a}', "");
    Expect(0, 43392, '\p{	 in_Jamo_Ext_a}', "");
    Expect(1, 43392, '\p{^	 in_Jamo_Ext_a}', "");
    Expect(1, 43392, '\P{	 in_Jamo_Ext_a}', "");
    Expect(0, 43392, '\P{^	 in_Jamo_Ext_a}', "");
    Error('\p{	:=HANGUL_Jamo_Extended_B}');
    Error('\P{	:=HANGUL_Jamo_Extended_B}');
    Expect(1, 55295, '\p{hanguljamoextendedb}', "");
    Expect(0, 55295, '\p{^hanguljamoextendedb}', "");
    Expect(0, 55295, '\P{hanguljamoextendedb}', "");
    Expect(1, 55295, '\P{^hanguljamoextendedb}', "");
    Expect(0, 57344, '\p{hanguljamoextendedb}', "");
    Expect(1, 57344, '\p{^hanguljamoextendedb}', "");
    Expect(1, 57344, '\P{hanguljamoextendedb}', "");
    Expect(0, 57344, '\P{^hanguljamoextendedb}', "");
    Expect(1, 55295, '\p{Hangul_jamo_Extended_B}', "");
    Expect(0, 55295, '\p{^Hangul_jamo_Extended_B}', "");
    Expect(0, 55295, '\P{Hangul_jamo_Extended_B}', "");
    Expect(1, 55295, '\P{^Hangul_jamo_Extended_B}', "");
    Expect(0, 57344, '\p{Hangul_jamo_Extended_B}', "");
    Expect(1, 57344, '\p{^Hangul_jamo_Extended_B}', "");
    Expect(1, 57344, '\P{Hangul_jamo_Extended_B}', "");
    Expect(0, 57344, '\P{^Hangul_jamo_Extended_B}', "");
    Error('\p{/a/- Is_hangul_jamo_extended_B}');
    Error('\P{/a/- Is_hangul_jamo_extended_B}');
    Expect(1, 55295, '\p{ishanguljamoextendedb}', "");
    Expect(0, 55295, '\p{^ishanguljamoextendedb}', "");
    Expect(0, 55295, '\P{ishanguljamoextendedb}', "");
    Expect(1, 55295, '\P{^ishanguljamoextendedb}', "");
    Expect(0, 57344, '\p{ishanguljamoextendedb}', "");
    Expect(1, 57344, '\p{^ishanguljamoextendedb}', "");
    Expect(1, 57344, '\P{ishanguljamoextendedb}', "");
    Expect(0, 57344, '\P{^ishanguljamoextendedb}', "");
    Expect(1, 55295, '\p{_is_Hangul_Jamo_EXTENDED_B}', "");
    Expect(0, 55295, '\p{^_is_Hangul_Jamo_EXTENDED_B}', "");
    Expect(0, 55295, '\P{_is_Hangul_Jamo_EXTENDED_B}', "");
    Expect(1, 55295, '\P{^_is_Hangul_Jamo_EXTENDED_B}', "");
    Expect(0, 57344, '\p{_is_Hangul_Jamo_EXTENDED_B}', "");
    Expect(1, 57344, '\p{^_is_Hangul_Jamo_EXTENDED_B}', "");
    Expect(1, 57344, '\P{_is_Hangul_Jamo_EXTENDED_B}', "");
    Expect(0, 57344, '\P{^_is_Hangul_Jamo_EXTENDED_B}', "");
    Error('\p{:=In_hangul_JAMO_extended_B}');
    Error('\P{:=In_hangul_JAMO_extended_B}');
    Expect(1, 55295, '\p{inhanguljamoextendedb}', "");
    Expect(0, 55295, '\p{^inhanguljamoextendedb}', "");
    Expect(0, 55295, '\P{inhanguljamoextendedb}', "");
    Expect(1, 55295, '\P{^inhanguljamoextendedb}', "");
    Expect(0, 57344, '\p{inhanguljamoextendedb}', "");
    Expect(1, 57344, '\p{^inhanguljamoextendedb}', "");
    Expect(1, 57344, '\P{inhanguljamoextendedb}', "");
    Expect(0, 57344, '\P{^inhanguljamoextendedb}', "");
    Expect(1, 55295, '\p{	_In_Hangul_Jamo_extended_B}', "");
    Expect(0, 55295, '\p{^	_In_Hangul_Jamo_extended_B}', "");
    Expect(0, 55295, '\P{	_In_Hangul_Jamo_extended_B}', "");
    Expect(1, 55295, '\P{^	_In_Hangul_Jamo_extended_B}', "");
    Expect(0, 57344, '\p{	_In_Hangul_Jamo_extended_B}', "");
    Expect(1, 57344, '\p{^	_In_Hangul_Jamo_extended_B}', "");
    Expect(1, 57344, '\P{	_In_Hangul_Jamo_extended_B}', "");
    Expect(0, 57344, '\P{^	_In_Hangul_Jamo_extended_B}', "");
    Error('\p{ /a/Jamo_Ext_b}');
    Error('\P{ /a/Jamo_Ext_b}');
    Expect(1, 55295, '\p{jamoextb}', "");
    Expect(0, 55295, '\p{^jamoextb}', "");
    Expect(0, 55295, '\P{jamoextb}', "");
    Expect(1, 55295, '\P{^jamoextb}', "");
    Expect(0, 57344, '\p{jamoextb}', "");
    Expect(1, 57344, '\p{^jamoextb}', "");
    Expect(1, 57344, '\P{jamoextb}', "");
    Expect(0, 57344, '\P{^jamoextb}', "");
    Expect(1, 55295, '\p{_-jamo_ext_B}', "");
    Expect(0, 55295, '\p{^_-jamo_ext_B}', "");
    Expect(0, 55295, '\P{_-jamo_ext_B}', "");
    Expect(1, 55295, '\P{^_-jamo_ext_B}', "");
    Expect(0, 57344, '\p{_-jamo_ext_B}', "");
    Expect(1, 57344, '\p{^_-jamo_ext_B}', "");
    Expect(1, 57344, '\P{_-jamo_ext_B}', "");
    Expect(0, 57344, '\P{^_-jamo_ext_B}', "");
    Error('\p{	 Is_Jamo_Ext_B:=}');
    Error('\P{	 Is_Jamo_Ext_B:=}');
    Expect(1, 55295, '\p{isjamoextb}', "");
    Expect(0, 55295, '\p{^isjamoextb}', "");
    Expect(0, 55295, '\P{isjamoextb}', "");
    Expect(1, 55295, '\P{^isjamoextb}', "");
    Expect(0, 57344, '\p{isjamoextb}', "");
    Expect(1, 57344, '\p{^isjamoextb}', "");
    Expect(1, 57344, '\P{isjamoextb}', "");
    Expect(0, 57344, '\P{^isjamoextb}', "");
    Expect(1, 55295, '\p{_IS_JAMO_Ext_B}', "");
    Expect(0, 55295, '\p{^_IS_JAMO_Ext_B}', "");
    Expect(0, 55295, '\P{_IS_JAMO_Ext_B}', "");
    Expect(1, 55295, '\P{^_IS_JAMO_Ext_B}', "");
    Expect(0, 57344, '\p{_IS_JAMO_Ext_B}', "");
    Expect(1, 57344, '\p{^_IS_JAMO_Ext_B}', "");
    Expect(1, 57344, '\P{_IS_JAMO_Ext_B}', "");
    Expect(0, 57344, '\P{^_IS_JAMO_Ext_B}', "");
    Error('\p{-in_jamo_EXT_B:=}');
    Error('\P{-in_jamo_EXT_B:=}');
    Expect(1, 55295, '\p{injamoextb}', "");
    Expect(0, 55295, '\p{^injamoextb}', "");
    Expect(0, 55295, '\P{injamoextb}', "");
    Expect(1, 55295, '\P{^injamoextb}', "");
    Expect(0, 57344, '\p{injamoextb}', "");
    Expect(1, 57344, '\p{^injamoextb}', "");
    Expect(1, 57344, '\P{injamoextb}', "");
    Expect(0, 57344, '\P{^injamoextb}', "");
    Expect(1, 55295, '\p{_in_jamo_Ext_B}', "");
    Expect(0, 55295, '\p{^_in_jamo_Ext_B}', "");
    Expect(0, 55295, '\P{_in_jamo_Ext_B}', "");
    Expect(1, 55295, '\P{^_in_jamo_Ext_B}', "");
    Expect(0, 57344, '\p{_in_jamo_Ext_B}', "");
    Expect(1, 57344, '\p{^_in_jamo_Ext_B}', "");
    Expect(1, 57344, '\P{_in_jamo_Ext_B}', "");
    Expect(0, 57344, '\P{^_in_jamo_Ext_B}', "");
    Error('\p{ :=HANGUL_Syllables}');
    Error('\P{ :=HANGUL_Syllables}');
    Expect(1, 55215, '\p{hangulsyllables}', "");
    Expect(0, 55215, '\p{^hangulsyllables}', "");
    Expect(0, 55215, '\P{hangulsyllables}', "");
    Expect(1, 55215, '\P{^hangulsyllables}', "");
    Expect(0, 55216, '\p{hangulsyllables}', "");
    Expect(1, 55216, '\p{^hangulsyllables}', "");
    Expect(1, 55216, '\P{hangulsyllables}', "");
    Expect(0, 55216, '\P{^hangulsyllables}', "");
    Expect(1, 55215, '\p{		HANGUL_syllables}', "");
    Expect(0, 55215, '\p{^		HANGUL_syllables}', "");
    Expect(0, 55215, '\P{		HANGUL_syllables}', "");
    Expect(1, 55215, '\P{^		HANGUL_syllables}', "");
    Expect(0, 55216, '\p{		HANGUL_syllables}', "");
    Expect(1, 55216, '\p{^		HANGUL_syllables}', "");
    Expect(1, 55216, '\P{		HANGUL_syllables}', "");
    Expect(0, 55216, '\P{^		HANGUL_syllables}', "");
    Error('\p{_/a/Is_hangul_SYLLABLES}');
    Error('\P{_/a/Is_hangul_SYLLABLES}');
    Expect(1, 55215, '\p{ishangulsyllables}', "");
    Expect(0, 55215, '\p{^ishangulsyllables}', "");
    Expect(0, 55215, '\P{ishangulsyllables}', "");
    Expect(1, 55215, '\P{^ishangulsyllables}', "");
    Expect(0, 55216, '\p{ishangulsyllables}', "");
    Expect(1, 55216, '\p{^ishangulsyllables}', "");
    Expect(1, 55216, '\P{ishangulsyllables}', "");
    Expect(0, 55216, '\P{^ishangulsyllables}', "");
    Expect(1, 55215, '\p{_ IS_hangul_SYLLABLES}', "");
    Expect(0, 55215, '\p{^_ IS_hangul_SYLLABLES}', "");
    Expect(0, 55215, '\P{_ IS_hangul_SYLLABLES}', "");
    Expect(1, 55215, '\P{^_ IS_hangul_SYLLABLES}', "");
    Expect(0, 55216, '\p{_ IS_hangul_SYLLABLES}', "");
    Expect(1, 55216, '\p{^_ IS_hangul_SYLLABLES}', "");
    Expect(1, 55216, '\P{_ IS_hangul_SYLLABLES}', "");
    Expect(0, 55216, '\P{^_ IS_hangul_SYLLABLES}', "");
    Error('\p{- IN_Hangul_Syllables:=}');
    Error('\P{- IN_Hangul_Syllables:=}');
    Expect(1, 55215, '\p{inhangulsyllables}', "");
    Expect(0, 55215, '\p{^inhangulsyllables}', "");
    Expect(0, 55215, '\P{inhangulsyllables}', "");
    Expect(1, 55215, '\P{^inhangulsyllables}', "");
    Expect(0, 55216, '\p{inhangulsyllables}', "");
    Expect(1, 55216, '\p{^inhangulsyllables}', "");
    Expect(1, 55216, '\P{inhangulsyllables}', "");
    Expect(0, 55216, '\P{^inhangulsyllables}', "");
    Expect(1, 55215, '\p{	in_Hangul_syllables}', "");
    Expect(0, 55215, '\p{^	in_Hangul_syllables}', "");
    Expect(0, 55215, '\P{	in_Hangul_syllables}', "");
    Expect(1, 55215, '\P{^	in_Hangul_syllables}', "");
    Expect(0, 55216, '\p{	in_Hangul_syllables}', "");
    Expect(1, 55216, '\p{^	in_Hangul_syllables}', "");
    Expect(1, 55216, '\P{	in_Hangul_syllables}', "");
    Expect(0, 55216, '\P{^	in_Hangul_syllables}', "");
    Error('\p{_:=In_hangul}');
    Error('\P{_:=In_hangul}');
    Expect(1, 55215, '\p{inhangul}', "");
    Expect(0, 55215, '\p{^inhangul}', "");
    Expect(0, 55215, '\P{inhangul}', "");
    Expect(1, 55215, '\P{^inhangul}', "");
    Expect(0, 55216, '\p{inhangul}', "");
    Expect(1, 55216, '\p{^inhangul}', "");
    Expect(1, 55216, '\P{inhangul}', "");
    Expect(0, 55216, '\P{^inhangul}', "");
    Expect(1, 55215, '\p{- in_Hangul}', "");
    Expect(0, 55215, '\p{^- in_Hangul}', "");
    Expect(0, 55215, '\P{- in_Hangul}', "");
    Expect(1, 55215, '\P{^- in_Hangul}', "");
    Expect(0, 55216, '\p{- in_Hangul}', "");
    Expect(1, 55216, '\p{^- in_Hangul}', "");
    Expect(1, 55216, '\P{- in_Hangul}', "");
    Expect(0, 55216, '\P{^- in_Hangul}', "");
    Error('\p{-:=Hanunoo}');
    Error('\P{-:=Hanunoo}');
    Expect(1, 5942, '\p{hanunoo}', "");
    Expect(0, 5942, '\p{^hanunoo}', "");
    Expect(0, 5942, '\P{hanunoo}', "");
    Expect(1, 5942, '\P{^hanunoo}', "");
    Expect(0, 5943, '\p{hanunoo}', "");
    Expect(1, 5943, '\p{^hanunoo}', "");
    Expect(1, 5943, '\P{hanunoo}', "");
    Expect(0, 5943, '\P{^hanunoo}', "");
    Expect(1, 5942, '\p{_ Hanunoo}', "");
    Expect(0, 5942, '\p{^_ Hanunoo}', "");
    Expect(0, 5942, '\P{_ Hanunoo}', "");
    Expect(1, 5942, '\P{^_ Hanunoo}', "");
    Expect(0, 5943, '\p{_ Hanunoo}', "");
    Expect(1, 5943, '\p{^_ Hanunoo}', "");
    Expect(1, 5943, '\P{_ Hanunoo}', "");
    Expect(0, 5943, '\P{^_ Hanunoo}', "");
    Error('\p{-/a/IS_hanunoo}');
    Error('\P{-/a/IS_hanunoo}');
    Expect(1, 5942, '\p{ishanunoo}', "");
    Expect(0, 5942, '\p{^ishanunoo}', "");
    Expect(0, 5942, '\P{ishanunoo}', "");
    Expect(1, 5942, '\P{^ishanunoo}', "");
    Expect(0, 5943, '\p{ishanunoo}', "");
    Expect(1, 5943, '\p{^ishanunoo}', "");
    Expect(1, 5943, '\P{ishanunoo}', "");
    Expect(0, 5943, '\P{^ishanunoo}', "");
    Expect(1, 5942, '\p{ _Is_Hanunoo}', "");
    Expect(0, 5942, '\p{^ _Is_Hanunoo}', "");
    Expect(0, 5942, '\P{ _Is_Hanunoo}', "");
    Expect(1, 5942, '\P{^ _Is_Hanunoo}', "");
    Expect(0, 5943, '\p{ _Is_Hanunoo}', "");
    Expect(1, 5943, '\p{^ _Is_Hanunoo}', "");
    Expect(1, 5943, '\P{ _Is_Hanunoo}', "");
    Expect(0, 5943, '\P{^ _Is_Hanunoo}', "");
    Error('\p{	/a/hano}');
    Error('\P{	/a/hano}');
    Expect(1, 5942, '\p{hano}', "");
    Expect(0, 5942, '\p{^hano}', "");
    Expect(0, 5942, '\P{hano}', "");
    Expect(1, 5942, '\P{^hano}', "");
    Expect(0, 5943, '\p{hano}', "");
    Expect(1, 5943, '\p{^hano}', "");
    Expect(1, 5943, '\P{hano}', "");
    Expect(0, 5943, '\P{^hano}', "");
    Expect(1, 5942, '\p{Hano}', "");
    Expect(0, 5942, '\p{^Hano}', "");
    Expect(0, 5942, '\P{Hano}', "");
    Expect(1, 5942, '\P{^Hano}', "");
    Expect(0, 5943, '\p{Hano}', "");
    Expect(1, 5943, '\p{^Hano}', "");
    Expect(1, 5943, '\P{Hano}', "");
    Expect(0, 5943, '\P{^Hano}', "");
    Error('\p{_/a/Is_Hano}');
    Error('\P{_/a/Is_Hano}');
    Expect(1, 5942, '\p{ishano}', "");
    Expect(0, 5942, '\p{^ishano}', "");
    Expect(0, 5942, '\P{ishano}', "");
    Expect(1, 5942, '\P{^ishano}', "");
    Expect(0, 5943, '\p{ishano}', "");
    Expect(1, 5943, '\p{^ishano}', "");
    Expect(1, 5943, '\P{ishano}', "");
    Expect(0, 5943, '\P{^ishano}', "");
    Expect(1, 5942, '\p{	-is_HANO}', "");
    Expect(0, 5942, '\p{^	-is_HANO}', "");
    Expect(0, 5942, '\P{	-is_HANO}', "");
    Expect(1, 5942, '\P{^	-is_HANO}', "");
    Expect(0, 5943, '\p{	-is_HANO}', "");
    Expect(1, 5943, '\p{^	-is_HANO}', "");
    Expect(1, 5943, '\P{	-is_HANO}', "");
    Expect(0, 5943, '\P{^	-is_HANO}', "");
    Error('\p{/a/ -hatran}');
    Error('\P{/a/ -hatran}');
    Expect(1, 67839, '\p{hatran}', "");
    Expect(0, 67839, '\p{^hatran}', "");
    Expect(0, 67839, '\P{hatran}', "");
    Expect(1, 67839, '\P{^hatran}', "");
    Expect(0, 67840, '\p{hatran}', "");
    Expect(1, 67840, '\p{^hatran}', "");
    Expect(1, 67840, '\P{hatran}', "");
    Expect(0, 67840, '\P{^hatran}', "");
    Expect(1, 67839, '\p{ 	hatran}', "");
    Expect(0, 67839, '\p{^ 	hatran}', "");
    Expect(0, 67839, '\P{ 	hatran}', "");
    Expect(1, 67839, '\P{^ 	hatran}', "");
    Expect(0, 67840, '\p{ 	hatran}', "");
    Expect(1, 67840, '\p{^ 	hatran}', "");
    Expect(1, 67840, '\P{ 	hatran}', "");
    Expect(0, 67840, '\P{^ 	hatran}', "");
    Error('\p{ /a/Is_Hatran}');
    Error('\P{ /a/Is_Hatran}');
    Expect(1, 67839, '\p{ishatran}', "");
    Expect(0, 67839, '\p{^ishatran}', "");
    Expect(0, 67839, '\P{ishatran}', "");
    Expect(1, 67839, '\P{^ishatran}', "");
    Expect(0, 67840, '\p{ishatran}', "");
    Expect(1, 67840, '\p{^ishatran}', "");
    Expect(1, 67840, '\P{ishatran}', "");
    Expect(0, 67840, '\P{^ishatran}', "");
    Expect(1, 67839, '\p{  IS_hatran}', "");
    Expect(0, 67839, '\p{^  IS_hatran}', "");
    Expect(0, 67839, '\P{  IS_hatran}', "");
    Expect(1, 67839, '\P{^  IS_hatran}', "");
    Expect(0, 67840, '\p{  IS_hatran}', "");
    Expect(1, 67840, '\p{^  IS_hatran}', "");
    Expect(1, 67840, '\P{  IS_hatran}', "");
    Expect(0, 67840, '\P{^  IS_hatran}', "");
    Error('\p{-/a/HATR}');
    Error('\P{-/a/HATR}');
    Expect(1, 67839, '\p{hatr}', "");
    Expect(0, 67839, '\p{^hatr}', "");
    Expect(0, 67839, '\P{hatr}', "");
    Expect(1, 67839, '\P{^hatr}', "");
    Expect(0, 67840, '\p{hatr}', "");
    Expect(1, 67840, '\p{^hatr}', "");
    Expect(1, 67840, '\P{hatr}', "");
    Expect(0, 67840, '\P{^hatr}', "");
    Expect(1, 67839, '\p{	 Hatr}', "");
    Expect(0, 67839, '\p{^	 Hatr}', "");
    Expect(0, 67839, '\P{	 Hatr}', "");
    Expect(1, 67839, '\P{^	 Hatr}', "");
    Expect(0, 67840, '\p{	 Hatr}', "");
    Expect(1, 67840, '\p{^	 Hatr}', "");
    Expect(1, 67840, '\P{	 Hatr}', "");
    Expect(0, 67840, '\P{^	 Hatr}', "");
    Error('\p{/a/--Is_HATR}');
    Error('\P{/a/--Is_HATR}');
    Expect(1, 67839, '\p{ishatr}', "");
    Expect(0, 67839, '\p{^ishatr}', "");
    Expect(0, 67839, '\P{ishatr}', "");
    Expect(1, 67839, '\P{^ishatr}', "");
    Expect(0, 67840, '\p{ishatr}', "");
    Expect(1, 67840, '\p{^ishatr}', "");
    Expect(1, 67840, '\P{ishatr}', "");
    Expect(0, 67840, '\P{^ishatr}', "");
    Expect(1, 67839, '\p{	_is_HATR}', "");
    Expect(0, 67839, '\p{^	_is_HATR}', "");
    Expect(0, 67839, '\P{	_is_HATR}', "");
    Expect(1, 67839, '\P{^	_is_HATR}', "");
    Expect(0, 67840, '\p{	_is_HATR}', "");
    Expect(1, 67840, '\p{^	_is_HATR}', "");
    Expect(1, 67840, '\P{	_is_HATR}', "");
    Expect(0, 67840, '\P{^	_is_HATR}', "");
    Error('\p{/a/Hebrew}');
    Error('\P{/a/Hebrew}');
    Expect(1, 64335, '\p{hebrew}', "");
    Expect(0, 64335, '\p{^hebrew}', "");
    Expect(0, 64335, '\P{hebrew}', "");
    Expect(1, 64335, '\P{^hebrew}', "");
    Expect(0, 64336, '\p{hebrew}', "");
    Expect(1, 64336, '\p{^hebrew}', "");
    Expect(1, 64336, '\P{hebrew}', "");
    Expect(0, 64336, '\P{^hebrew}', "");
    Expect(1, 64335, '\p{  hebrew}', "");
    Expect(0, 64335, '\p{^  hebrew}', "");
    Expect(0, 64335, '\P{  hebrew}', "");
    Expect(1, 64335, '\P{^  hebrew}', "");
    Expect(0, 64336, '\p{  hebrew}', "");
    Expect(1, 64336, '\p{^  hebrew}', "");
    Expect(1, 64336, '\P{  hebrew}', "");
    Expect(0, 64336, '\P{^  hebrew}', "");
    Error('\p{:=	_Is_Hebrew}');
    Error('\P{:=	_Is_Hebrew}');
    Expect(1, 64335, '\p{ishebrew}', "");
    Expect(0, 64335, '\p{^ishebrew}', "");
    Expect(0, 64335, '\P{ishebrew}', "");
    Expect(1, 64335, '\P{^ishebrew}', "");
    Expect(0, 64336, '\p{ishebrew}', "");
    Expect(1, 64336, '\p{^ishebrew}', "");
    Expect(1, 64336, '\P{ishebrew}', "");
    Expect(0, 64336, '\P{^ishebrew}', "");
    Expect(1, 64335, '\p{ _Is_HEBREW}', "");
    Expect(0, 64335, '\p{^ _Is_HEBREW}', "");
    Expect(0, 64335, '\P{ _Is_HEBREW}', "");
    Expect(1, 64335, '\P{^ _Is_HEBREW}', "");
    Expect(0, 64336, '\p{ _Is_HEBREW}', "");
    Expect(1, 64336, '\p{^ _Is_HEBREW}', "");
    Expect(1, 64336, '\P{ _Is_HEBREW}', "");
    Expect(0, 64336, '\P{^ _Is_HEBREW}', "");
    Error('\p{	 HEBR:=}');
    Error('\P{	 HEBR:=}');
    Expect(1, 64335, '\p{hebr}', "");
    Expect(0, 64335, '\p{^hebr}', "");
    Expect(0, 64335, '\P{hebr}', "");
    Expect(1, 64335, '\P{^hebr}', "");
    Expect(0, 64336, '\p{hebr}', "");
    Expect(1, 64336, '\p{^hebr}', "");
    Expect(1, 64336, '\P{hebr}', "");
    Expect(0, 64336, '\P{^hebr}', "");
    Expect(1, 64335, '\p{_ Hebr}', "");
    Expect(0, 64335, '\p{^_ Hebr}', "");
    Expect(0, 64335, '\P{_ Hebr}', "");
    Expect(1, 64335, '\P{^_ Hebr}', "");
    Expect(0, 64336, '\p{_ Hebr}', "");
    Expect(1, 64336, '\p{^_ Hebr}', "");
    Expect(1, 64336, '\P{_ Hebr}', "");
    Expect(0, 64336, '\P{^_ Hebr}', "");
    Error('\p{_	is_Hebr:=}');
    Error('\P{_	is_Hebr:=}');
    Expect(1, 64335, '\p{ishebr}', "");
    Expect(0, 64335, '\p{^ishebr}', "");
    Expect(0, 64335, '\P{ishebr}', "");
    Expect(1, 64335, '\P{^ishebr}', "");
    Expect(0, 64336, '\p{ishebr}', "");
    Expect(1, 64336, '\p{^ishebr}', "");
    Expect(1, 64336, '\P{ishebr}', "");
    Expect(0, 64336, '\P{^ishebr}', "");
    Expect(1, 64335, '\p{-	IS_Hebr}', "");
    Expect(0, 64335, '\p{^-	IS_Hebr}', "");
    Expect(0, 64335, '\P{-	IS_Hebr}', "");
    Expect(1, 64335, '\P{^-	IS_Hebr}', "");
    Expect(0, 64336, '\p{-	IS_Hebr}', "");
    Expect(1, 64336, '\p{^-	IS_Hebr}', "");
    Expect(1, 64336, '\P{-	IS_Hebr}', "");
    Expect(0, 64336, '\P{^-	IS_Hebr}', "");
    Error('\p{:=--HIGH_Private_Use_Surrogates}');
    Error('\P{:=--HIGH_Private_Use_Surrogates}');
    Expect(1, 56319, '\p{highprivateusesurrogates}', "");
    Expect(0, 56319, '\p{^highprivateusesurrogates}', "");
    Expect(0, 56319, '\P{highprivateusesurrogates}', "");
    Expect(1, 56319, '\P{^highprivateusesurrogates}', "");
    Expect(0, 57344, '\p{highprivateusesurrogates}', "");
    Expect(1, 57344, '\p{^highprivateusesurrogates}', "");
    Expect(1, 57344, '\P{highprivateusesurrogates}', "");
    Expect(0, 57344, '\P{^highprivateusesurrogates}', "");
    Expect(1, 56319, '\p{- High_private_use_surrogates}', "");
    Expect(0, 56319, '\p{^- High_private_use_surrogates}', "");
    Expect(0, 56319, '\P{- High_private_use_surrogates}', "");
    Expect(1, 56319, '\P{^- High_private_use_surrogates}', "");
    Expect(0, 57344, '\p{- High_private_use_surrogates}', "");
    Expect(1, 57344, '\p{^- High_private_use_surrogates}', "");
    Expect(1, 57344, '\P{- High_private_use_surrogates}', "");
    Expect(0, 57344, '\P{^- High_private_use_surrogates}', "");
    Error('\p{:=is_HIGH_PRIVATE_Use_SURROGATES}');
    Error('\P{:=is_HIGH_PRIVATE_Use_SURROGATES}');
    Expect(1, 56319, '\p{ishighprivateusesurrogates}', "");
    Expect(0, 56319, '\p{^ishighprivateusesurrogates}', "");
    Expect(0, 56319, '\P{ishighprivateusesurrogates}', "");
    Expect(1, 56319, '\P{^ishighprivateusesurrogates}', "");
    Expect(0, 57344, '\p{ishighprivateusesurrogates}', "");
    Expect(1, 57344, '\p{^ishighprivateusesurrogates}', "");
    Expect(1, 57344, '\P{ishighprivateusesurrogates}', "");
    Expect(0, 57344, '\P{^ishighprivateusesurrogates}', "");
    Expect(1, 56319, '\p{-	Is_High_private_USE_Surrogates}', "");
    Expect(0, 56319, '\p{^-	Is_High_private_USE_Surrogates}', "");
    Expect(0, 56319, '\P{-	Is_High_private_USE_Surrogates}', "");
    Expect(1, 56319, '\P{^-	Is_High_private_USE_Surrogates}', "");
    Expect(0, 57344, '\p{-	Is_High_private_USE_Surrogates}', "");
    Expect(1, 57344, '\p{^-	Is_High_private_USE_Surrogates}', "");
    Expect(1, 57344, '\P{-	Is_High_private_USE_Surrogates}', "");
    Expect(0, 57344, '\P{^-	Is_High_private_USE_Surrogates}', "");
    Error('\p{/a/_-In_high_PRIVATE_Use_SURROGATES}');
    Error('\P{/a/_-In_high_PRIVATE_Use_SURROGATES}');
    Expect(1, 56319, '\p{inhighprivateusesurrogates}', "");
    Expect(0, 56319, '\p{^inhighprivateusesurrogates}', "");
    Expect(0, 56319, '\P{inhighprivateusesurrogates}', "");
    Expect(1, 56319, '\P{^inhighprivateusesurrogates}', "");
    Expect(0, 57344, '\p{inhighprivateusesurrogates}', "");
    Expect(1, 57344, '\p{^inhighprivateusesurrogates}', "");
    Expect(1, 57344, '\P{inhighprivateusesurrogates}', "");
    Expect(0, 57344, '\P{^inhighprivateusesurrogates}', "");
    Expect(1, 56319, '\p{-In_high_PRIVATE_Use_SURROGATES}', "");
    Expect(0, 56319, '\p{^-In_high_PRIVATE_Use_SURROGATES}', "");
    Expect(0, 56319, '\P{-In_high_PRIVATE_Use_SURROGATES}', "");
    Expect(1, 56319, '\P{^-In_high_PRIVATE_Use_SURROGATES}', "");
    Expect(0, 57344, '\p{-In_high_PRIVATE_Use_SURROGATES}', "");
    Expect(1, 57344, '\p{^-In_high_PRIVATE_Use_SURROGATES}', "");
    Expect(1, 57344, '\P{-In_high_PRIVATE_Use_SURROGATES}', "");
    Expect(0, 57344, '\P{^-In_high_PRIVATE_Use_SURROGATES}', "");
    Error('\p{/a/High_PU_surrogates}');
    Error('\P{/a/High_PU_surrogates}');
    Expect(1, 56319, '\p{highpusurrogates}', "");
    Expect(0, 56319, '\p{^highpusurrogates}', "");
    Expect(0, 56319, '\P{highpusurrogates}', "");
    Expect(1, 56319, '\P{^highpusurrogates}', "");
    Expect(0, 57344, '\p{highpusurrogates}', "");
    Expect(1, 57344, '\p{^highpusurrogates}', "");
    Expect(1, 57344, '\P{highpusurrogates}', "");
    Expect(0, 57344, '\P{^highpusurrogates}', "");
    Expect(1, 56319, '\p{_	HIGH_pu_surrogates}', "");
    Expect(0, 56319, '\p{^_	HIGH_pu_surrogates}', "");
    Expect(0, 56319, '\P{_	HIGH_pu_surrogates}', "");
    Expect(1, 56319, '\P{^_	HIGH_pu_surrogates}', "");
    Expect(0, 57344, '\p{_	HIGH_pu_surrogates}', "");
    Expect(1, 57344, '\p{^_	HIGH_pu_surrogates}', "");
    Expect(1, 57344, '\P{_	HIGH_pu_surrogates}', "");
    Expect(0, 57344, '\P{^_	HIGH_pu_surrogates}', "");
    Error('\p{:= -is_High_pu_Surrogates}');
    Error('\P{:= -is_High_pu_Surrogates}');
    Expect(1, 56319, '\p{ishighpusurrogates}', "");
    Expect(0, 56319, '\p{^ishighpusurrogates}', "");
    Expect(0, 56319, '\P{ishighpusurrogates}', "");
    Expect(1, 56319, '\P{^ishighpusurrogates}', "");
    Expect(0, 57344, '\p{ishighpusurrogates}', "");
    Expect(1, 57344, '\p{^ishighpusurrogates}', "");
    Expect(1, 57344, '\P{ishighpusurrogates}', "");
    Expect(0, 57344, '\P{^ishighpusurrogates}', "");
    Expect(1, 56319, '\p{		is_HIGH_PU_Surrogates}', "");
    Expect(0, 56319, '\p{^		is_HIGH_PU_Surrogates}', "");
    Expect(0, 56319, '\P{		is_HIGH_PU_Surrogates}', "");
    Expect(1, 56319, '\P{^		is_HIGH_PU_Surrogates}', "");
    Expect(0, 57344, '\p{		is_HIGH_PU_Surrogates}', "");
    Expect(1, 57344, '\p{^		is_HIGH_PU_Surrogates}', "");
    Expect(1, 57344, '\P{		is_HIGH_PU_Surrogates}', "");
    Expect(0, 57344, '\P{^		is_HIGH_PU_Surrogates}', "");
    Error('\p{	_in_high_PU_SURROGATES/a/}');
    Error('\P{	_in_high_PU_SURROGATES/a/}');
    Expect(1, 56319, '\p{inhighpusurrogates}', "");
    Expect(0, 56319, '\p{^inhighpusurrogates}', "");
    Expect(0, 56319, '\P{inhighpusurrogates}', "");
    Expect(1, 56319, '\P{^inhighpusurrogates}', "");
    Expect(0, 57344, '\p{inhighpusurrogates}', "");
    Expect(1, 57344, '\p{^inhighpusurrogates}', "");
    Expect(1, 57344, '\P{inhighpusurrogates}', "");
    Expect(0, 57344, '\P{^inhighpusurrogates}', "");
    Expect(1, 56319, '\p{	-In_high_PU_SURROGATES}', "");
    Expect(0, 56319, '\p{^	-In_high_PU_SURROGATES}', "");
    Expect(0, 56319, '\P{	-In_high_PU_SURROGATES}', "");
    Expect(1, 56319, '\P{^	-In_high_PU_SURROGATES}', "");
    Expect(0, 57344, '\p{	-In_high_PU_SURROGATES}', "");
    Expect(1, 57344, '\p{^	-In_high_PU_SURROGATES}', "");
    Expect(1, 57344, '\P{	-In_high_PU_SURROGATES}', "");
    Expect(0, 57344, '\P{^	-In_high_PU_SURROGATES}', "");
    Error('\p{:=_HIGH_surrogates}');
    Error('\P{:=_HIGH_surrogates}');
    Expect(1, 56191, '\p{highsurrogates}', "");
    Expect(0, 56191, '\p{^highsurrogates}', "");
    Expect(0, 56191, '\P{highsurrogates}', "");
    Expect(1, 56191, '\P{^highsurrogates}', "");
    Expect(0, 57344, '\p{highsurrogates}', "");
    Expect(1, 57344, '\p{^highsurrogates}', "");
    Expect(1, 57344, '\P{highsurrogates}', "");
    Expect(0, 57344, '\P{^highsurrogates}', "");
    Expect(1, 56191, '\p{_-High_SURROGATES}', "");
    Expect(0, 56191, '\p{^_-High_SURROGATES}', "");
    Expect(0, 56191, '\P{_-High_SURROGATES}', "");
    Expect(1, 56191, '\P{^_-High_SURROGATES}', "");
    Expect(0, 57344, '\p{_-High_SURROGATES}', "");
    Expect(1, 57344, '\p{^_-High_SURROGATES}', "");
    Expect(1, 57344, '\P{_-High_SURROGATES}', "");
    Expect(0, 57344, '\P{^_-High_SURROGATES}', "");
    Error('\p{_/a/Is_High_surrogates}');
    Error('\P{_/a/Is_High_surrogates}');
    Expect(1, 56191, '\p{ishighsurrogates}', "");
    Expect(0, 56191, '\p{^ishighsurrogates}', "");
    Expect(0, 56191, '\P{ishighsurrogates}', "");
    Expect(1, 56191, '\P{^ishighsurrogates}', "");
    Expect(0, 57344, '\p{ishighsurrogates}', "");
    Expect(1, 57344, '\p{^ishighsurrogates}', "");
    Expect(1, 57344, '\P{ishighsurrogates}', "");
    Expect(0, 57344, '\P{^ishighsurrogates}', "");
    Expect(1, 56191, '\p{ Is_HIGH_surrogates}', "");
    Expect(0, 56191, '\p{^ Is_HIGH_surrogates}', "");
    Expect(0, 56191, '\P{ Is_HIGH_surrogates}', "");
    Expect(1, 56191, '\P{^ Is_HIGH_surrogates}', "");
    Expect(0, 57344, '\p{ Is_HIGH_surrogates}', "");
    Expect(1, 57344, '\p{^ Is_HIGH_surrogates}', "");
    Expect(1, 57344, '\P{ Is_HIGH_surrogates}', "");
    Expect(0, 57344, '\P{^ Is_HIGH_surrogates}', "");
    Error('\p{/a/	 in_HIGH_Surrogates}');
    Error('\P{/a/	 in_HIGH_Surrogates}');
    Expect(1, 56191, '\p{inhighsurrogates}', "");
    Expect(0, 56191, '\p{^inhighsurrogates}', "");
    Expect(0, 56191, '\P{inhighsurrogates}', "");
    Expect(1, 56191, '\P{^inhighsurrogates}', "");
    Expect(0, 57344, '\p{inhighsurrogates}', "");
    Expect(1, 57344, '\p{^inhighsurrogates}', "");
    Expect(1, 57344, '\P{inhighsurrogates}', "");
    Expect(0, 57344, '\P{^inhighsurrogates}', "");
    Expect(1, 56191, '\p{-In_High_surrogates}', "");
    Expect(0, 56191, '\p{^-In_High_surrogates}', "");
    Expect(0, 56191, '\P{-In_High_surrogates}', "");
    Expect(1, 56191, '\P{^-In_High_surrogates}', "");
    Expect(0, 57344, '\p{-In_High_surrogates}', "");
    Expect(1, 57344, '\p{^-In_High_surrogates}', "");
    Expect(1, 57344, '\P{-In_High_surrogates}', "");
    Expect(0, 57344, '\P{^-In_High_surrogates}', "");
    Error('\p{-:=Hiragana}');
    Error('\P{-:=Hiragana}');
    Expect(1, 127488, '\p{hiragana}', "");
    Expect(0, 127488, '\p{^hiragana}', "");
    Expect(0, 127488, '\P{hiragana}', "");
    Expect(1, 127488, '\P{^hiragana}', "");
    Expect(0, 127489, '\p{hiragana}', "");
    Expect(1, 127489, '\p{^hiragana}', "");
    Expect(1, 127489, '\P{hiragana}', "");
    Expect(0, 127489, '\P{^hiragana}', "");
    Expect(1, 127488, '\p{_	HIRAGANA}', "");
    Expect(0, 127488, '\p{^_	HIRAGANA}', "");
    Expect(0, 127488, '\P{_	HIRAGANA}', "");
    Expect(1, 127488, '\P{^_	HIRAGANA}', "");
    Expect(0, 127489, '\p{_	HIRAGANA}', "");
    Expect(1, 127489, '\p{^_	HIRAGANA}', "");
    Expect(1, 127489, '\P{_	HIRAGANA}', "");
    Expect(0, 127489, '\P{^_	HIRAGANA}', "");
    Error('\p{:=--Is_hiragana}');
    Error('\P{:=--Is_hiragana}');
    Expect(1, 127488, '\p{ishiragana}', "");
    Expect(0, 127488, '\p{^ishiragana}', "");
    Expect(0, 127488, '\P{ishiragana}', "");
    Expect(1, 127488, '\P{^ishiragana}', "");
    Expect(0, 127489, '\p{ishiragana}', "");
    Expect(1, 127489, '\p{^ishiragana}', "");
    Expect(1, 127489, '\P{ishiragana}', "");
    Expect(0, 127489, '\P{^ishiragana}', "");
    Expect(1, 127488, '\p{_ IS_hiragana}', "");
    Expect(0, 127488, '\p{^_ IS_hiragana}', "");
    Expect(0, 127488, '\P{_ IS_hiragana}', "");
    Expect(1, 127488, '\P{^_ IS_hiragana}', "");
    Expect(0, 127489, '\p{_ IS_hiragana}', "");
    Expect(1, 127489, '\p{^_ IS_hiragana}', "");
    Expect(1, 127489, '\P{_ IS_hiragana}', "");
    Expect(0, 127489, '\P{^_ IS_hiragana}', "");
    Error('\p{:=_-Hira}');
    Error('\P{:=_-Hira}');
    Expect(1, 127488, '\p{hira}', "");
    Expect(0, 127488, '\p{^hira}', "");
    Expect(0, 127488, '\P{hira}', "");
    Expect(1, 127488, '\P{^hira}', "");
    Expect(0, 127489, '\p{hira}', "");
    Expect(1, 127489, '\p{^hira}', "");
    Expect(1, 127489, '\P{hira}', "");
    Expect(0, 127489, '\P{^hira}', "");
    Expect(1, 127488, '\p{-HIRA}', "");
    Expect(0, 127488, '\p{^-HIRA}', "");
    Expect(0, 127488, '\P{-HIRA}', "");
    Expect(1, 127488, '\P{^-HIRA}', "");
    Expect(0, 127489, '\p{-HIRA}', "");
    Expect(1, 127489, '\p{^-HIRA}', "");
    Expect(1, 127489, '\P{-HIRA}', "");
    Expect(0, 127489, '\P{^-HIRA}', "");
    Error('\p{/a/_ Is_Hira}');
    Error('\P{/a/_ Is_Hira}');
    Expect(1, 127488, '\p{ishira}', "");
    Expect(0, 127488, '\p{^ishira}', "");
    Expect(0, 127488, '\P{ishira}', "");
    Expect(1, 127488, '\P{^ishira}', "");
    Expect(0, 127489, '\p{ishira}', "");
    Expect(1, 127489, '\p{^ishira}', "");
    Expect(1, 127489, '\P{ishira}', "");
    Expect(0, 127489, '\P{^ishira}', "");
    Expect(1, 127488, '\p{_	is_Hira}', "");
    Expect(0, 127488, '\p{^_	is_Hira}', "");
    Expect(0, 127488, '\P{_	is_Hira}', "");
    Expect(1, 127488, '\P{^_	is_Hira}', "");
    Expect(0, 127489, '\p{_	is_Hira}', "");
    Expect(1, 127489, '\p{^_	is_Hira}', "");
    Expect(1, 127489, '\P{_	is_Hira}', "");
    Expect(0, 127489, '\P{^_	is_Hira}', "");
    Error('\p{--Hyphen/a/}');
    Error('\P{--Hyphen/a/}');
    Expect(1, 65381, '\p{hyphen}', 'deprecated');
    Expect(0, 65381, '\p{^hyphen}', 'deprecated');
    Expect(0, 65381, '\P{hyphen}', 'deprecated');
    Expect(1, 65381, '\P{^hyphen}', 'deprecated');
    Expect(0, 65382, '\p{hyphen}', 'deprecated');
    Expect(1, 65382, '\p{^hyphen}', 'deprecated');
    Expect(1, 65382, '\P{hyphen}', 'deprecated');
    Expect(0, 65382, '\P{^hyphen}', 'deprecated');
    Expect(1, 65381, '\p{	hyphen}', 'deprecated');
    Expect(0, 65381, '\p{^	hyphen}', 'deprecated');
    Expect(0, 65381, '\P{	hyphen}', 'deprecated');
    Expect(1, 65381, '\P{^	hyphen}', 'deprecated');
    Expect(0, 65382, '\p{	hyphen}', 'deprecated');
    Expect(1, 65382, '\p{^	hyphen}', 'deprecated');
    Expect(1, 65382, '\P{	hyphen}', 'deprecated');
    Expect(0, 65382, '\P{^	hyphen}', 'deprecated');
    Error('\p{ /a/IS_hyphen}');
    Error('\P{ /a/IS_hyphen}');
    Expect(1, 65381, '\p{ishyphen}', 'deprecated');
    Expect(0, 65381, '\p{^ishyphen}', 'deprecated');
    Expect(0, 65381, '\P{ishyphen}', 'deprecated');
    Expect(1, 65381, '\P{^ishyphen}', 'deprecated');
    Expect(0, 65382, '\p{ishyphen}', 'deprecated');
    Expect(1, 65382, '\p{^ishyphen}', 'deprecated');
    Expect(1, 65382, '\P{ishyphen}', 'deprecated');
    Expect(0, 65382, '\P{^ishyphen}', 'deprecated');
    Expect(1, 65381, '\p{	Is_Hyphen}', 'deprecated');
    Expect(0, 65381, '\p{^	Is_Hyphen}', 'deprecated');
    Expect(0, 65381, '\P{	Is_Hyphen}', 'deprecated');
    Expect(1, 65381, '\P{^	Is_Hyphen}', 'deprecated');
    Expect(0, 65382, '\p{	Is_Hyphen}', 'deprecated');
    Expect(1, 65382, '\p{^	Is_Hyphen}', 'deprecated');
    Expect(1, 65382, '\P{	Is_Hyphen}', 'deprecated');
    Expect(0, 65382, '\P{^	Is_Hyphen}', 'deprecated');
    Error('\p{/a/  ID_Continue}');
    Error('\P{/a/  ID_Continue}');
    Expect(1, 917999, '\p{idcontinue}', "");
    Expect(0, 917999, '\p{^idcontinue}', "");
    Expect(0, 917999, '\P{idcontinue}', "");
    Expect(1, 917999, '\P{^idcontinue}', "");
    Expect(0, 918000, '\p{idcontinue}', "");
    Expect(1, 918000, '\p{^idcontinue}', "");
    Expect(1, 918000, '\P{idcontinue}', "");
    Expect(0, 918000, '\P{^idcontinue}', "");
    Expect(1, 917999, '\p{	_ID_CONTINUE}', "");
    Expect(0, 917999, '\p{^	_ID_CONTINUE}', "");
    Expect(0, 917999, '\P{	_ID_CONTINUE}', "");
    Expect(1, 917999, '\P{^	_ID_CONTINUE}', "");
    Expect(0, 918000, '\p{	_ID_CONTINUE}', "");
    Expect(1, 918000, '\p{^	_ID_CONTINUE}', "");
    Expect(1, 918000, '\P{	_ID_CONTINUE}', "");
    Expect(0, 918000, '\P{^	_ID_CONTINUE}', "");
    Error('\p{-IS_ID_Continue:=}');
    Error('\P{-IS_ID_Continue:=}');
    Expect(1, 917999, '\p{isidcontinue}', "");
    Expect(0, 917999, '\p{^isidcontinue}', "");
    Expect(0, 917999, '\P{isidcontinue}', "");
    Expect(1, 917999, '\P{^isidcontinue}', "");
    Expect(0, 918000, '\p{isidcontinue}', "");
    Expect(1, 918000, '\p{^isidcontinue}', "");
    Expect(1, 918000, '\P{isidcontinue}', "");
    Expect(0, 918000, '\P{^isidcontinue}', "");
    Expect(1, 917999, '\p{ IS_id_Continue}', "");
    Expect(0, 917999, '\p{^ IS_id_Continue}', "");
    Expect(0, 917999, '\P{ IS_id_Continue}', "");
    Expect(1, 917999, '\P{^ IS_id_Continue}', "");
    Expect(0, 918000, '\p{ IS_id_Continue}', "");
    Expect(1, 918000, '\p{^ IS_id_Continue}', "");
    Expect(1, 918000, '\P{ IS_id_Continue}', "");
    Expect(0, 918000, '\P{^ IS_id_Continue}', "");
    Error('\p{-_IDC:=}');
    Error('\P{-_IDC:=}');
    Expect(1, 917999, '\p{idc}', "");
    Expect(0, 917999, '\p{^idc}', "");
    Expect(0, 917999, '\P{idc}', "");
    Expect(1, 917999, '\P{^idc}', "");
    Expect(0, 918000, '\p{idc}', "");
    Expect(1, 918000, '\p{^idc}', "");
    Expect(1, 918000, '\P{idc}', "");
    Expect(0, 918000, '\P{^idc}', "");
    Expect(1, 917999, '\p{_IDC}', "");
    Expect(0, 917999, '\p{^_IDC}', "");
    Expect(0, 917999, '\P{_IDC}', "");
    Expect(1, 917999, '\P{^_IDC}', "");
    Expect(0, 918000, '\p{_IDC}', "");
    Expect(1, 918000, '\p{^_IDC}', "");
    Expect(1, 918000, '\P{_IDC}', "");
    Expect(0, 918000, '\P{^_IDC}', "");
    Error('\p{/a/ Is_IDC}');
    Error('\P{/a/ Is_IDC}');
    Expect(1, 917999, '\p{isidc}', "");
    Expect(0, 917999, '\p{^isidc}', "");
    Expect(0, 917999, '\P{isidc}', "");
    Expect(1, 917999, '\P{^isidc}', "");
    Expect(0, 918000, '\p{isidc}', "");
    Expect(1, 918000, '\p{^isidc}', "");
    Expect(1, 918000, '\P{isidc}', "");
    Expect(0, 918000, '\P{^isidc}', "");
    Expect(1, 917999, '\p{ IS_idc}', "");
    Expect(0, 917999, '\p{^ IS_idc}', "");
    Expect(0, 917999, '\P{ IS_idc}', "");
    Expect(1, 917999, '\P{^ IS_idc}', "");
    Expect(0, 918000, '\p{ IS_idc}', "");
    Expect(1, 918000, '\p{^ IS_idc}', "");
    Expect(1, 918000, '\P{ IS_idc}', "");
    Expect(0, 918000, '\P{^ IS_idc}', "");
    Error('\p{_/a/ID_start}');
    Error('\P{_/a/ID_start}');
    Expect(1, 195101, '\p{idstart}', "");
    Expect(0, 195101, '\p{^idstart}', "");
    Expect(0, 195101, '\P{idstart}', "");
    Expect(1, 195101, '\P{^idstart}', "");
    Expect(0, 195102, '\p{idstart}', "");
    Expect(1, 195102, '\p{^idstart}', "");
    Expect(1, 195102, '\P{idstart}', "");
    Expect(0, 195102, '\P{^idstart}', "");
    Expect(1, 195101, '\p{-ID_Start}', "");
    Expect(0, 195101, '\p{^-ID_Start}', "");
    Expect(0, 195101, '\P{-ID_Start}', "");
    Expect(1, 195101, '\P{^-ID_Start}', "");
    Expect(0, 195102, '\p{-ID_Start}', "");
    Expect(1, 195102, '\p{^-ID_Start}', "");
    Expect(1, 195102, '\P{-ID_Start}', "");
    Expect(0, 195102, '\P{^-ID_Start}', "");
    Error('\p{/a/_ Is_ID_START}');
    Error('\P{/a/_ Is_ID_START}');
    Expect(1, 195101, '\p{isidstart}', "");
    Expect(0, 195101, '\p{^isidstart}', "");
    Expect(0, 195101, '\P{isidstart}', "");
    Expect(1, 195101, '\P{^isidstart}', "");
    Expect(0, 195102, '\p{isidstart}', "");
    Expect(1, 195102, '\p{^isidstart}', "");
    Expect(1, 195102, '\P{isidstart}', "");
    Expect(0, 195102, '\P{^isidstart}', "");
    Expect(1, 195101, '\p{Is_id_START}', "");
    Expect(0, 195101, '\p{^Is_id_START}', "");
    Expect(0, 195101, '\P{Is_id_START}', "");
    Expect(1, 195101, '\P{^Is_id_START}', "");
    Expect(0, 195102, '\p{Is_id_START}', "");
    Expect(1, 195102, '\p{^Is_id_START}', "");
    Expect(1, 195102, '\P{Is_id_START}', "");
    Expect(0, 195102, '\P{^Is_id_START}', "");
    Error('\p{  IDS:=}');
    Error('\P{  IDS:=}');
    Expect(1, 195101, '\p{ids}', "");
    Expect(0, 195101, '\p{^ids}', "");
    Expect(0, 195101, '\P{ids}', "");
    Expect(1, 195101, '\P{^ids}', "");
    Expect(0, 195102, '\p{ids}', "");
    Expect(1, 195102, '\p{^ids}', "");
    Expect(1, 195102, '\P{ids}', "");
    Expect(0, 195102, '\P{^ids}', "");
    Expect(1, 195101, '\p{--IDS}', "");
    Expect(0, 195101, '\p{^--IDS}', "");
    Expect(0, 195101, '\P{--IDS}', "");
    Expect(1, 195101, '\P{^--IDS}', "");
    Expect(0, 195102, '\p{--IDS}', "");
    Expect(1, 195102, '\p{^--IDS}', "");
    Expect(1, 195102, '\P{--IDS}', "");
    Expect(0, 195102, '\P{^--IDS}', "");
    Error('\p{	/a/is_IDS}');
    Error('\P{	/a/is_IDS}');
    Expect(1, 195101, '\p{isids}', "");
    Expect(0, 195101, '\p{^isids}', "");
    Expect(0, 195101, '\P{isids}', "");
    Expect(1, 195101, '\P{^isids}', "");
    Expect(0, 195102, '\p{isids}', "");
    Expect(1, 195102, '\p{^isids}', "");
    Expect(1, 195102, '\P{isids}', "");
    Expect(0, 195102, '\P{^isids}', "");
    Expect(1, 195101, '\p{-Is_ids}', "");
    Expect(0, 195101, '\p{^-Is_ids}', "");
    Expect(0, 195101, '\P{-Is_ids}', "");
    Expect(1, 195101, '\P{^-Is_ids}', "");
    Expect(0, 195102, '\p{-Is_ids}', "");
    Expect(1, 195102, '\p{^-Is_ids}', "");
    Expect(1, 195102, '\P{-Is_ids}', "");
    Expect(0, 195102, '\P{^-Is_ids}', "");
    Error('\p{/a/ Ideographic}');
    Error('\P{/a/ Ideographic}');
    Expect(1, 195101, '\p{ideographic}', "");
    Expect(0, 195101, '\p{^ideographic}', "");
    Expect(0, 195101, '\P{ideographic}', "");
    Expect(1, 195101, '\P{^ideographic}', "");
    Expect(0, 195102, '\p{ideographic}', "");
    Expect(1, 195102, '\p{^ideographic}', "");
    Expect(1, 195102, '\P{ideographic}', "");
    Expect(0, 195102, '\P{^ideographic}', "");
    Expect(1, 195101, '\p{Ideographic}', "");
    Expect(0, 195101, '\p{^Ideographic}', "");
    Expect(0, 195101, '\P{Ideographic}', "");
    Expect(1, 195101, '\P{^Ideographic}', "");
    Expect(0, 195102, '\p{Ideographic}', "");
    Expect(1, 195102, '\p{^Ideographic}', "");
    Expect(1, 195102, '\P{Ideographic}', "");
    Expect(0, 195102, '\P{^Ideographic}', "");
    Error('\p{/a/is_ideographic}');
    Error('\P{/a/is_ideographic}');
    Expect(1, 195101, '\p{isideographic}', "");
    Expect(0, 195101, '\p{^isideographic}', "");
    Expect(0, 195101, '\P{isideographic}', "");
    Expect(1, 195101, '\P{^isideographic}', "");
    Expect(0, 195102, '\p{isideographic}', "");
    Expect(1, 195102, '\p{^isideographic}', "");
    Expect(1, 195102, '\P{isideographic}', "");
    Expect(0, 195102, '\P{^isideographic}', "");
    Expect(1, 195101, '\p{__IS_ideographic}', "");
    Expect(0, 195101, '\p{^__IS_ideographic}', "");
    Expect(0, 195101, '\P{__IS_ideographic}', "");
    Expect(1, 195101, '\P{^__IS_ideographic}', "");
    Expect(0, 195102, '\p{__IS_ideographic}', "");
    Expect(1, 195102, '\p{^__IS_ideographic}', "");
    Expect(1, 195102, '\P{__IS_ideographic}', "");
    Expect(0, 195102, '\P{^__IS_ideographic}', "");
    Error('\p{ /a/Ideo}');
    Error('\P{ /a/Ideo}');
    Expect(1, 195101, '\p{ideo}', "");
    Expect(0, 195101, '\p{^ideo}', "");
    Expect(0, 195101, '\P{ideo}', "");
    Expect(1, 195101, '\P{^ideo}', "");
    Expect(0, 195102, '\p{ideo}', "");
    Expect(1, 195102, '\p{^ideo}', "");
    Expect(1, 195102, '\P{ideo}', "");
    Expect(0, 195102, '\P{^ideo}', "");
    Expect(1, 195101, '\p{__ideo}', "");
    Expect(0, 195101, '\p{^__ideo}', "");
    Expect(0, 195101, '\P{__ideo}', "");
    Expect(1, 195101, '\P{^__ideo}', "");
    Expect(0, 195102, '\p{__ideo}', "");
    Expect(1, 195102, '\p{^__ideo}', "");
    Expect(1, 195102, '\P{__ideo}', "");
    Expect(0, 195102, '\P{^__ideo}', "");
    Error('\p{/a/ _is_IDEO}');
    Error('\P{/a/ _is_IDEO}');
    Expect(1, 195101, '\p{isideo}', "");
    Expect(0, 195101, '\p{^isideo}', "");
    Expect(0, 195101, '\P{isideo}', "");
    Expect(1, 195101, '\P{^isideo}', "");
    Expect(0, 195102, '\p{isideo}', "");
    Expect(1, 195102, '\p{^isideo}', "");
    Expect(1, 195102, '\P{isideo}', "");
    Expect(0, 195102, '\P{^isideo}', "");
    Expect(1, 195101, '\p{ 	IS_Ideo}', "");
    Expect(0, 195101, '\p{^ 	IS_Ideo}', "");
    Expect(0, 195101, '\P{ 	IS_Ideo}', "");
    Expect(1, 195101, '\P{^ 	IS_Ideo}', "");
    Expect(0, 195102, '\p{ 	IS_Ideo}', "");
    Expect(1, 195102, '\p{^ 	IS_Ideo}', "");
    Expect(1, 195102, '\P{ 	IS_Ideo}', "");
    Expect(0, 195102, '\P{^ 	IS_Ideo}', "");
    Error('\p{/a/_	ideographic_Description_Characters}');
    Error('\P{/a/_	ideographic_Description_Characters}');
    Expect(1, 12287, '\p{ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\p{^ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\P{ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\P{^ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\p{ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\p{^ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\P{ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\P{^ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\p{IDEOGRAPHIC_DESCRIPTION_characters}', "");
    Expect(0, 12287, '\p{^IDEOGRAPHIC_DESCRIPTION_characters}', "");
    Expect(0, 12287, '\P{IDEOGRAPHIC_DESCRIPTION_characters}', "");
    Expect(1, 12287, '\P{^IDEOGRAPHIC_DESCRIPTION_characters}', "");
    Expect(0, 12288, '\p{IDEOGRAPHIC_DESCRIPTION_characters}', "");
    Expect(1, 12288, '\p{^IDEOGRAPHIC_DESCRIPTION_characters}', "");
    Expect(1, 12288, '\P{IDEOGRAPHIC_DESCRIPTION_characters}', "");
    Expect(0, 12288, '\P{^IDEOGRAPHIC_DESCRIPTION_characters}', "");
    Error('\p{ /a/Is_Ideographic_Description_CHARACTERS}');
    Error('\P{ /a/Is_Ideographic_Description_CHARACTERS}');
    Expect(1, 12287, '\p{isideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\p{^isideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\P{isideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\P{^isideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\p{isideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\p{^isideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\P{isideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\P{^isideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\p{ 	Is_IDEOGRAPHIC_Description_Characters}', "");
    Expect(0, 12287, '\p{^ 	Is_IDEOGRAPHIC_Description_Characters}', "");
    Expect(0, 12287, '\P{ 	Is_IDEOGRAPHIC_Description_Characters}', "");
    Expect(1, 12287, '\P{^ 	Is_IDEOGRAPHIC_Description_Characters}', "");
    Expect(0, 12288, '\p{ 	Is_IDEOGRAPHIC_Description_Characters}', "");
    Expect(1, 12288, '\p{^ 	Is_IDEOGRAPHIC_Description_Characters}', "");
    Expect(1, 12288, '\P{ 	Is_IDEOGRAPHIC_Description_Characters}', "");
    Expect(0, 12288, '\P{^ 	Is_IDEOGRAPHIC_Description_Characters}', "");
    Error('\p{-in_ideographic_Description_characters/a/}');
    Error('\P{-in_ideographic_Description_characters/a/}');
    Expect(1, 12287, '\p{inideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\p{^inideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\P{inideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\P{^inideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\p{inideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\p{^inideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\P{inideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\P{^inideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\p{		in_Ideographic_Description_Characters}', "");
    Expect(0, 12287, '\p{^		in_Ideographic_Description_Characters}', "");
    Expect(0, 12287, '\P{		in_Ideographic_Description_Characters}', "");
    Expect(1, 12287, '\P{^		in_Ideographic_Description_Characters}', "");
    Expect(0, 12288, '\p{		in_Ideographic_Description_Characters}', "");
    Expect(1, 12288, '\p{^		in_Ideographic_Description_Characters}', "");
    Expect(1, 12288, '\P{		in_Ideographic_Description_Characters}', "");
    Expect(0, 12288, '\P{^		in_Ideographic_Description_Characters}', "");
    Error('\p{In_IDC/a/}');
    Error('\P{In_IDC/a/}');
    Expect(1, 12287, '\p{inidc}', "");
    Expect(0, 12287, '\p{^inidc}', "");
    Expect(0, 12287, '\P{inidc}', "");
    Expect(1, 12287, '\P{^inidc}', "");
    Expect(0, 12288, '\p{inidc}', "");
    Expect(1, 12288, '\p{^inidc}', "");
    Expect(1, 12288, '\P{inidc}', "");
    Expect(0, 12288, '\P{^inidc}', "");
    Expect(1, 12287, '\p{-_In_idc}', "");
    Expect(0, 12287, '\p{^-_In_idc}', "");
    Expect(0, 12287, '\P{-_In_idc}', "");
    Expect(1, 12287, '\P{^-_In_idc}', "");
    Expect(0, 12288, '\p{-_In_idc}', "");
    Expect(1, 12288, '\p{^-_In_idc}', "");
    Expect(1, 12288, '\P{-_In_idc}', "");
    Expect(0, 12288, '\P{^-_In_idc}', "");
    Error('\p{_/a/Ideographic_Symbols_AND_PUNCTUATION}');
    Error('\P{_/a/Ideographic_Symbols_AND_PUNCTUATION}');
    Expect(1, 94207, '\p{ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\p{^ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\P{ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\P{^ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\p{ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\p{^ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\P{ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\P{^ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\p{- ideographic_SYMBOLS_AND_Punctuation}', "");
    Expect(0, 94207, '\p{^- ideographic_SYMBOLS_AND_Punctuation}', "");
    Expect(0, 94207, '\P{- ideographic_SYMBOLS_AND_Punctuation}', "");
    Expect(1, 94207, '\P{^- ideographic_SYMBOLS_AND_Punctuation}', "");
    Expect(0, 94208, '\p{- ideographic_SYMBOLS_AND_Punctuation}', "");
    Expect(1, 94208, '\p{^- ideographic_SYMBOLS_AND_Punctuation}', "");
    Expect(1, 94208, '\P{- ideographic_SYMBOLS_AND_Punctuation}', "");
    Expect(0, 94208, '\P{^- ideographic_SYMBOLS_AND_Punctuation}', "");
    Error('\p{:= Is_Ideographic_Symbols_AND_PUNCTUATION}');
    Error('\P{:= Is_Ideographic_Symbols_AND_PUNCTUATION}');
    Expect(1, 94207, '\p{isideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\p{^isideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\P{isideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\P{^isideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\p{isideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\p{^isideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\P{isideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\P{^isideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\p{	_Is_IDEOGRAPHIC_Symbols_And_Punctuation}', "");
    Expect(0, 94207, '\p{^	_Is_IDEOGRAPHIC_Symbols_And_Punctuation}', "");
    Expect(0, 94207, '\P{	_Is_IDEOGRAPHIC_Symbols_And_Punctuation}', "");
    Expect(1, 94207, '\P{^	_Is_IDEOGRAPHIC_Symbols_And_Punctuation}', "");
    Expect(0, 94208, '\p{	_Is_IDEOGRAPHIC_Symbols_And_Punctuation}', "");
    Expect(1, 94208, '\p{^	_Is_IDEOGRAPHIC_Symbols_And_Punctuation}', "");
    Expect(1, 94208, '\P{	_Is_IDEOGRAPHIC_Symbols_And_Punctuation}', "");
    Expect(0, 94208, '\P{^	_Is_IDEOGRAPHIC_Symbols_And_Punctuation}', "");
    Error('\p{_	In_Ideographic_Symbols_And_PUNCTUATION/a/}');
    Error('\P{_	In_Ideographic_Symbols_And_PUNCTUATION/a/}');
    Expect(1, 94207, '\p{inideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\p{^inideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\P{inideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\P{^inideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\p{inideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\p{^inideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\P{inideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\P{^inideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\p{	_In_IDEOGRAPHIC_Symbols_and_PUNCTUATION}', "");
    Expect(0, 94207, '\p{^	_In_IDEOGRAPHIC_Symbols_and_PUNCTUATION}', "");
    Expect(0, 94207, '\P{	_In_IDEOGRAPHIC_Symbols_and_PUNCTUATION}', "");
    Expect(1, 94207, '\P{^	_In_IDEOGRAPHIC_Symbols_and_PUNCTUATION}', "");
    Expect(0, 94208, '\p{	_In_IDEOGRAPHIC_Symbols_and_PUNCTUATION}', "");
    Expect(1, 94208, '\p{^	_In_IDEOGRAPHIC_Symbols_and_PUNCTUATION}', "");
    Expect(1, 94208, '\P{	_In_IDEOGRAPHIC_Symbols_and_PUNCTUATION}', "");
    Expect(0, 94208, '\P{^	_In_IDEOGRAPHIC_Symbols_and_PUNCTUATION}', "");
    Error('\p{/a/	-IDEOGRAPHIC_SYMBOLS}');
    Error('\P{/a/	-IDEOGRAPHIC_SYMBOLS}');
    Expect(1, 94207, '\p{ideographicsymbols}', "");
    Expect(0, 94207, '\p{^ideographicsymbols}', "");
    Expect(0, 94207, '\P{ideographicsymbols}', "");
    Expect(1, 94207, '\P{^ideographicsymbols}', "");
    Expect(0, 94208, '\p{ideographicsymbols}', "");
    Expect(1, 94208, '\p{^ideographicsymbols}', "");
    Expect(1, 94208, '\P{ideographicsymbols}', "");
    Expect(0, 94208, '\P{^ideographicsymbols}', "");
    Expect(1, 94207, '\p{_	Ideographic_Symbols}', "");
    Expect(0, 94207, '\p{^_	Ideographic_Symbols}', "");
    Expect(0, 94207, '\P{_	Ideographic_Symbols}', "");
    Expect(1, 94207, '\P{^_	Ideographic_Symbols}', "");
    Expect(0, 94208, '\p{_	Ideographic_Symbols}', "");
    Expect(1, 94208, '\p{^_	Ideographic_Symbols}', "");
    Expect(1, 94208, '\P{_	Ideographic_Symbols}', "");
    Expect(0, 94208, '\P{^_	Ideographic_Symbols}', "");
    Error('\p{-/a/IS_Ideographic_SYMBOLS}');
    Error('\P{-/a/IS_Ideographic_SYMBOLS}');
    Expect(1, 94207, '\p{isideographicsymbols}', "");
    Expect(0, 94207, '\p{^isideographicsymbols}', "");
    Expect(0, 94207, '\P{isideographicsymbols}', "");
    Expect(1, 94207, '\P{^isideographicsymbols}', "");
    Expect(0, 94208, '\p{isideographicsymbols}', "");
    Expect(1, 94208, '\p{^isideographicsymbols}', "");
    Expect(1, 94208, '\P{isideographicsymbols}', "");
    Expect(0, 94208, '\P{^isideographicsymbols}', "");
    Expect(1, 94207, '\p{_Is_Ideographic_Symbols}', "");
    Expect(0, 94207, '\p{^_Is_Ideographic_Symbols}', "");
    Expect(0, 94207, '\P{_Is_Ideographic_Symbols}', "");
    Expect(1, 94207, '\P{^_Is_Ideographic_Symbols}', "");
    Expect(0, 94208, '\p{_Is_Ideographic_Symbols}', "");
    Expect(1, 94208, '\p{^_Is_Ideographic_Symbols}', "");
    Expect(1, 94208, '\P{_Is_Ideographic_Symbols}', "");
    Expect(0, 94208, '\P{^_Is_Ideographic_Symbols}', "");
    Error('\p{:=_	IN_ideographic_symbols}');
    Error('\P{:=_	IN_ideographic_symbols}');
    Expect(1, 94207, '\p{inideographicsymbols}', "");
    Expect(0, 94207, '\p{^inideographicsymbols}', "");
    Expect(0, 94207, '\P{inideographicsymbols}', "");
    Expect(1, 94207, '\P{^inideographicsymbols}', "");
    Expect(0, 94208, '\p{inideographicsymbols}', "");
    Expect(1, 94208, '\p{^inideographicsymbols}', "");
    Expect(1, 94208, '\P{inideographicsymbols}', "");
    Expect(0, 94208, '\P{^inideographicsymbols}', "");
    Expect(1, 94207, '\p{-	in_IDEOGRAPHIC_SYMBOLS}', "");
    Expect(0, 94207, '\p{^-	in_IDEOGRAPHIC_SYMBOLS}', "");
    Expect(0, 94207, '\P{-	in_IDEOGRAPHIC_SYMBOLS}', "");
    Expect(1, 94207, '\P{^-	in_IDEOGRAPHIC_SYMBOLS}', "");
    Expect(0, 94208, '\p{-	in_IDEOGRAPHIC_SYMBOLS}', "");
    Expect(1, 94208, '\p{^-	in_IDEOGRAPHIC_SYMBOLS}', "");
    Expect(1, 94208, '\P{-	in_IDEOGRAPHIC_SYMBOLS}', "");
    Expect(0, 94208, '\P{^-	in_IDEOGRAPHIC_SYMBOLS}', "");
    Error('\p{	/a/IDS_binary_Operator}');
    Error('\P{	/a/IDS_binary_Operator}');
    Expect(1, 12283, '\p{idsbinaryoperator}', "");
    Expect(0, 12283, '\p{^idsbinaryoperator}', "");
    Expect(0, 12283, '\P{idsbinaryoperator}', "");
    Expect(1, 12283, '\P{^idsbinaryoperator}', "");
    Expect(0, 12284, '\p{idsbinaryoperator}', "");
    Expect(1, 12284, '\p{^idsbinaryoperator}', "");
    Expect(1, 12284, '\P{idsbinaryoperator}', "");
    Expect(0, 12284, '\P{^idsbinaryoperator}', "");
    Expect(1, 12283, '\p{ IDS_Binary_operator}', "");
    Expect(0, 12283, '\p{^ IDS_Binary_operator}', "");
    Expect(0, 12283, '\P{ IDS_Binary_operator}', "");
    Expect(1, 12283, '\P{^ IDS_Binary_operator}', "");
    Expect(0, 12284, '\p{ IDS_Binary_operator}', "");
    Expect(1, 12284, '\p{^ IDS_Binary_operator}', "");
    Expect(1, 12284, '\P{ IDS_Binary_operator}', "");
    Expect(0, 12284, '\P{^ IDS_Binary_operator}', "");
    Error('\p{/a/Is_IDS_Binary_OPERATOR}');
    Error('\P{/a/Is_IDS_Binary_OPERATOR}');
    Expect(1, 12283, '\p{isidsbinaryoperator}', "");
    Expect(0, 12283, '\p{^isidsbinaryoperator}', "");
    Expect(0, 12283, '\P{isidsbinaryoperator}', "");
    Expect(1, 12283, '\P{^isidsbinaryoperator}', "");
    Expect(0, 12284, '\p{isidsbinaryoperator}', "");
    Expect(1, 12284, '\p{^isidsbinaryoperator}', "");
    Expect(1, 12284, '\P{isidsbinaryoperator}', "");
    Expect(0, 12284, '\P{^isidsbinaryoperator}', "");
    Expect(1, 12283, '\p{__Is_IDS_BINARY_operator}', "");
    Expect(0, 12283, '\p{^__Is_IDS_BINARY_operator}', "");
    Expect(0, 12283, '\P{__Is_IDS_BINARY_operator}', "");
    Expect(1, 12283, '\P{^__Is_IDS_BINARY_operator}', "");
    Expect(0, 12284, '\p{__Is_IDS_BINARY_operator}', "");
    Expect(1, 12284, '\p{^__Is_IDS_BINARY_operator}', "");
    Expect(1, 12284, '\P{__Is_IDS_BINARY_operator}', "");
    Expect(0, 12284, '\P{^__Is_IDS_BINARY_operator}', "");
    Error('\p{-IDSB:=}');
    Error('\P{-IDSB:=}');
    Expect(1, 12283, '\p{idsb}', "");
    Expect(0, 12283, '\p{^idsb}', "");
    Expect(0, 12283, '\P{idsb}', "");
    Expect(1, 12283, '\P{^idsb}', "");
    Expect(0, 12284, '\p{idsb}', "");
    Expect(1, 12284, '\p{^idsb}', "");
    Expect(1, 12284, '\P{idsb}', "");
    Expect(0, 12284, '\P{^idsb}', "");
    Expect(1, 12283, '\p{	IDSB}', "");
    Expect(0, 12283, '\p{^	IDSB}', "");
    Expect(0, 12283, '\P{	IDSB}', "");
    Expect(1, 12283, '\P{^	IDSB}', "");
    Expect(0, 12284, '\p{	IDSB}', "");
    Expect(1, 12284, '\p{^	IDSB}', "");
    Expect(1, 12284, '\P{	IDSB}', "");
    Expect(0, 12284, '\P{^	IDSB}', "");
    Error('\p{ 	Is_IDSB:=}');
    Error('\P{ 	Is_IDSB:=}');
    Expect(1, 12283, '\p{isidsb}', "");
    Expect(0, 12283, '\p{^isidsb}', "");
    Expect(0, 12283, '\P{isidsb}', "");
    Expect(1, 12283, '\P{^isidsb}', "");
    Expect(0, 12284, '\p{isidsb}', "");
    Expect(1, 12284, '\p{^isidsb}', "");
    Expect(1, 12284, '\P{isidsb}', "");
    Expect(0, 12284, '\P{^isidsb}', "");
    Expect(1, 12283, '\p{ is_IDSB}', "");
    Expect(0, 12283, '\p{^ is_IDSB}', "");
    Expect(0, 12283, '\P{ is_IDSB}', "");
    Expect(1, 12283, '\P{^ is_IDSB}', "");
    Expect(0, 12284, '\p{ is_IDSB}', "");
    Expect(1, 12284, '\p{^ is_IDSB}', "");
    Expect(1, 12284, '\P{ is_IDSB}', "");
    Expect(0, 12284, '\P{^ is_IDSB}', "");
    Error('\p{-IDS_TRINARY_operator/a/}');
    Error('\P{-IDS_TRINARY_operator/a/}');
    Expect(1, 12275, '\p{idstrinaryoperator}', "");
    Expect(0, 12275, '\p{^idstrinaryoperator}', "");
    Expect(0, 12275, '\P{idstrinaryoperator}', "");
    Expect(1, 12275, '\P{^idstrinaryoperator}', "");
    Expect(0, 12276, '\p{idstrinaryoperator}', "");
    Expect(1, 12276, '\p{^idstrinaryoperator}', "");
    Expect(1, 12276, '\P{idstrinaryoperator}', "");
    Expect(0, 12276, '\P{^idstrinaryoperator}', "");
    Expect(1, 12275, '\p{- IDS_Trinary_Operator}', "");
    Expect(0, 12275, '\p{^- IDS_Trinary_Operator}', "");
    Expect(0, 12275, '\P{- IDS_Trinary_Operator}', "");
    Expect(1, 12275, '\P{^- IDS_Trinary_Operator}', "");
    Expect(0, 12276, '\p{- IDS_Trinary_Operator}', "");
    Expect(1, 12276, '\p{^- IDS_Trinary_Operator}', "");
    Expect(1, 12276, '\P{- IDS_Trinary_Operator}', "");
    Expect(0, 12276, '\P{^- IDS_Trinary_Operator}', "");
    Error('\p{-_Is_IDS_Trinary_OPERATOR/a/}');
    Error('\P{-_Is_IDS_Trinary_OPERATOR/a/}');
    Expect(1, 12275, '\p{isidstrinaryoperator}', "");
    Expect(0, 12275, '\p{^isidstrinaryoperator}', "");
    Expect(0, 12275, '\P{isidstrinaryoperator}', "");
    Expect(1, 12275, '\P{^isidstrinaryoperator}', "");
    Expect(0, 12276, '\p{isidstrinaryoperator}', "");
    Expect(1, 12276, '\p{^isidstrinaryoperator}', "");
    Expect(1, 12276, '\P{isidstrinaryoperator}', "");
    Expect(0, 12276, '\P{^isidstrinaryoperator}', "");
    Expect(1, 12275, '\p{- IS_IDS_trinary_Operator}', "");
    Expect(0, 12275, '\p{^- IS_IDS_trinary_Operator}', "");
    Expect(0, 12275, '\P{- IS_IDS_trinary_Operator}', "");
    Expect(1, 12275, '\P{^- IS_IDS_trinary_Operator}', "");
    Expect(0, 12276, '\p{- IS_IDS_trinary_Operator}', "");
    Expect(1, 12276, '\p{^- IS_IDS_trinary_Operator}', "");
    Expect(1, 12276, '\P{- IS_IDS_trinary_Operator}', "");
    Expect(0, 12276, '\P{^- IS_IDS_trinary_Operator}', "");
    Error('\p{:=_IDST}');
    Error('\P{:=_IDST}');
    Expect(1, 12275, '\p{idst}', "");
    Expect(0, 12275, '\p{^idst}', "");
    Expect(0, 12275, '\P{idst}', "");
    Expect(1, 12275, '\P{^idst}', "");
    Expect(0, 12276, '\p{idst}', "");
    Expect(1, 12276, '\p{^idst}', "");
    Expect(1, 12276, '\P{idst}', "");
    Expect(0, 12276, '\P{^idst}', "");
    Expect(1, 12275, '\p{-IDST}', "");
    Expect(0, 12275, '\p{^-IDST}', "");
    Expect(0, 12275, '\P{-IDST}', "");
    Expect(1, 12275, '\P{^-IDST}', "");
    Expect(0, 12276, '\p{-IDST}', "");
    Expect(1, 12276, '\p{^-IDST}', "");
    Expect(1, 12276, '\P{-IDST}', "");
    Expect(0, 12276, '\P{^-IDST}', "");
    Error('\p{/a/_Is_idst}');
    Error('\P{/a/_Is_idst}');
    Expect(1, 12275, '\p{isidst}', "");
    Expect(0, 12275, '\p{^isidst}', "");
    Expect(0, 12275, '\P{isidst}', "");
    Expect(1, 12275, '\P{^isidst}', "");
    Expect(0, 12276, '\p{isidst}', "");
    Expect(1, 12276, '\p{^isidst}', "");
    Expect(1, 12276, '\P{isidst}', "");
    Expect(0, 12276, '\P{^isidst}', "");
    Expect(1, 12275, '\p{ _Is_IDST}', "");
    Expect(0, 12275, '\p{^ _Is_IDST}', "");
    Expect(0, 12275, '\P{ _Is_IDST}', "");
    Expect(1, 12275, '\P{^ _Is_IDST}', "");
    Expect(0, 12276, '\p{ _Is_IDST}', "");
    Expect(1, 12276, '\p{^ _Is_IDST}', "");
    Expect(1, 12276, '\P{ _Is_IDST}', "");
    Expect(0, 12276, '\P{^ _Is_IDST}', "");
    Error('\p{ /a/Imperial_Aramaic}');
    Error('\P{ /a/Imperial_Aramaic}');
    Expect(1, 67679, '\p{imperialaramaic}', "");
    Expect(0, 67679, '\p{^imperialaramaic}', "");
    Expect(0, 67679, '\P{imperialaramaic}', "");
    Expect(1, 67679, '\P{^imperialaramaic}', "");
    Expect(0, 67680, '\p{imperialaramaic}', "");
    Expect(1, 67680, '\p{^imperialaramaic}', "");
    Expect(1, 67680, '\P{imperialaramaic}', "");
    Expect(0, 67680, '\P{^imperialaramaic}', "");
    Expect(1, 67679, '\p{	 Imperial_Aramaic}', "");
    Expect(0, 67679, '\p{^	 Imperial_Aramaic}', "");
    Expect(0, 67679, '\P{	 Imperial_Aramaic}', "");
    Expect(1, 67679, '\P{^	 Imperial_Aramaic}', "");
    Expect(0, 67680, '\p{	 Imperial_Aramaic}', "");
    Expect(1, 67680, '\p{^	 Imperial_Aramaic}', "");
    Expect(1, 67680, '\P{	 Imperial_Aramaic}', "");
    Expect(0, 67680, '\P{^	 Imperial_Aramaic}', "");
    Error('\p{  IS_imperial_Aramaic/a/}');
    Error('\P{  IS_imperial_Aramaic/a/}');
    Expect(1, 67679, '\p{isimperialaramaic}', "");
    Expect(0, 67679, '\p{^isimperialaramaic}', "");
    Expect(0, 67679, '\P{isimperialaramaic}', "");
    Expect(1, 67679, '\P{^isimperialaramaic}', "");
    Expect(0, 67680, '\p{isimperialaramaic}', "");
    Expect(1, 67680, '\p{^isimperialaramaic}', "");
    Expect(1, 67680, '\P{isimperialaramaic}', "");
    Expect(0, 67680, '\P{^isimperialaramaic}', "");
    Expect(1, 67679, '\p{ is_Imperial_Aramaic}', "");
    Expect(0, 67679, '\p{^ is_Imperial_Aramaic}', "");
    Expect(0, 67679, '\P{ is_Imperial_Aramaic}', "");
    Expect(1, 67679, '\P{^ is_Imperial_Aramaic}', "");
    Expect(0, 67680, '\p{ is_Imperial_Aramaic}', "");
    Expect(1, 67680, '\p{^ is_Imperial_Aramaic}', "");
    Expect(1, 67680, '\P{ is_Imperial_Aramaic}', "");
    Expect(0, 67680, '\P{^ is_Imperial_Aramaic}', "");
    Error('\p{/a/ARMI}');
    Error('\P{/a/ARMI}');
    Expect(1, 67679, '\p{armi}', "");
    Expect(0, 67679, '\p{^armi}', "");
    Expect(0, 67679, '\P{armi}', "");
    Expect(1, 67679, '\P{^armi}', "");
    Expect(0, 67680, '\p{armi}', "");
    Expect(1, 67680, '\p{^armi}', "");
    Expect(1, 67680, '\P{armi}', "");
    Expect(0, 67680, '\P{^armi}', "");
    Expect(1, 67679, '\p{_armi}', "");
    Expect(0, 67679, '\p{^_armi}', "");
    Expect(0, 67679, '\P{_armi}', "");
    Expect(1, 67679, '\P{^_armi}', "");
    Expect(0, 67680, '\p{_armi}', "");
    Expect(1, 67680, '\p{^_armi}', "");
    Expect(1, 67680, '\P{_armi}', "");
    Expect(0, 67680, '\P{^_armi}', "");
    Error('\p{ _is_Armi/a/}');
    Error('\P{ _is_Armi/a/}');
    Expect(1, 67679, '\p{isarmi}', "");
    Expect(0, 67679, '\p{^isarmi}', "");
    Expect(0, 67679, '\P{isarmi}', "");
    Expect(1, 67679, '\P{^isarmi}', "");
    Expect(0, 67680, '\p{isarmi}', "");
    Expect(1, 67680, '\p{^isarmi}', "");
    Expect(1, 67680, '\P{isarmi}', "");
    Expect(0, 67680, '\P{^isarmi}', "");
    Expect(1, 67679, '\p{	is_Armi}', "");
    Expect(0, 67679, '\p{^	is_Armi}', "");
    Expect(0, 67679, '\P{	is_Armi}', "");
    Expect(1, 67679, '\P{^	is_Armi}', "");
    Expect(0, 67680, '\p{	is_Armi}', "");
    Expect(1, 67680, '\p{^	is_Armi}', "");
    Expect(1, 67680, '\P{	is_Armi}', "");
    Expect(0, 67680, '\P{^	is_Armi}', "");
    Error('\p{	IN_ADLAM:=}');
    Error('\P{	IN_ADLAM:=}');
    Expect(1, 125279, '\p{inadlam}', "");
    Expect(0, 125279, '\p{^inadlam}', "");
    Expect(0, 125279, '\P{inadlam}', "");
    Expect(1, 125279, '\P{^inadlam}', "");
    Expect(0, 125280, '\p{inadlam}', "");
    Expect(1, 125280, '\p{^inadlam}', "");
    Expect(1, 125280, '\P{inadlam}', "");
    Expect(0, 125280, '\P{^inadlam}', "");
    Expect(1, 125279, '\p{-in_adlam}', "");
    Expect(0, 125279, '\p{^-in_adlam}', "");
    Expect(0, 125279, '\P{-in_adlam}', "");
    Expect(1, 125279, '\P{^-in_adlam}', "");
    Expect(0, 125280, '\p{-in_adlam}', "");
    Expect(1, 125280, '\p{^-in_adlam}', "");
    Expect(1, 125280, '\P{-in_adlam}', "");
    Expect(0, 125280, '\P{^-in_adlam}', "");
    Error('\p{ In_Adlam/a/}');
    Error('\P{ In_Adlam/a/}');
    Expect(1, 125279, '\p{_In_ADLAM}', "");
    Expect(0, 125279, '\p{^_In_ADLAM}', "");
    Expect(0, 125279, '\P{_In_ADLAM}', "");
    Expect(1, 125279, '\P{^_In_ADLAM}', "");
    Expect(0, 125280, '\p{_In_ADLAM}', "");
    Expect(1, 125280, '\p{^_In_ADLAM}', "");
    Expect(1, 125280, '\P{_In_ADLAM}', "");
    Expect(0, 125280, '\P{^_In_ADLAM}', "");
    Error('\p{_-IN_AHOM/a/}');
    Error('\P{_-IN_AHOM/a/}');
    Expect(1, 71487, '\p{inahom}', "");
    Expect(0, 71487, '\p{^inahom}', "");
    Expect(0, 71487, '\P{inahom}', "");
    Expect(1, 71487, '\P{^inahom}', "");
    Expect(0, 71488, '\p{inahom}', "");
    Expect(1, 71488, '\p{^inahom}', "");
    Expect(1, 71488, '\P{inahom}', "");
    Expect(0, 71488, '\P{^inahom}', "");
    Expect(1, 71487, '\p{-	In_Ahom}', "");
    Expect(0, 71487, '\p{^-	In_Ahom}', "");
    Expect(0, 71487, '\P{-	In_Ahom}', "");
    Expect(1, 71487, '\P{^-	In_Ahom}', "");
    Expect(0, 71488, '\p{-	In_Ahom}', "");
    Expect(1, 71488, '\p{^-	In_Ahom}', "");
    Expect(1, 71488, '\P{-	In_Ahom}', "");
    Expect(0, 71488, '\P{^-	In_Ahom}', "");
    Error('\p{/a/in_ahom}');
    Error('\P{/a/in_ahom}');
    Expect(1, 71487, '\p{_-IN_ahom}', "");
    Expect(0, 71487, '\p{^_-IN_ahom}', "");
    Expect(0, 71487, '\P{_-IN_ahom}', "");
    Expect(1, 71487, '\P{^_-IN_ahom}', "");
    Expect(0, 71488, '\p{_-IN_ahom}', "");
    Expect(1, 71488, '\p{^_-IN_ahom}', "");
    Expect(1, 71488, '\P{_-IN_ahom}', "");
    Expect(0, 71488, '\P{^_-IN_ahom}', "");
    Error('\p{:=in_anatolian_hieroglyphs}');
    Error('\P{:=in_anatolian_hieroglyphs}');
    Expect(1, 83583, '\p{inanatolianhieroglyphs}', "");
    Expect(0, 83583, '\p{^inanatolianhieroglyphs}', "");
    Expect(0, 83583, '\P{inanatolianhieroglyphs}', "");
    Expect(1, 83583, '\P{^inanatolianhieroglyphs}', "");
    Expect(0, 83584, '\p{inanatolianhieroglyphs}', "");
    Expect(1, 83584, '\p{^inanatolianhieroglyphs}', "");
    Expect(1, 83584, '\P{inanatolianhieroglyphs}', "");
    Expect(0, 83584, '\P{^inanatolianhieroglyphs}', "");
    Expect(1, 83583, '\p{_-IN_anatolian_Hieroglyphs}', "");
    Expect(0, 83583, '\p{^_-IN_anatolian_Hieroglyphs}', "");
    Expect(0, 83583, '\P{_-IN_anatolian_Hieroglyphs}', "");
    Expect(1, 83583, '\P{^_-IN_anatolian_Hieroglyphs}', "");
    Expect(0, 83584, '\p{_-IN_anatolian_Hieroglyphs}', "");
    Expect(1, 83584, '\p{^_-IN_anatolian_Hieroglyphs}', "");
    Expect(1, 83584, '\P{_-IN_anatolian_Hieroglyphs}', "");
    Expect(0, 83584, '\P{^_-IN_anatolian_Hieroglyphs}', "");
    Error('\p{	IN_Anatolian_Hieroglyphs:=}');
    Error('\P{	IN_Anatolian_Hieroglyphs:=}');
    Expect(1, 83583, '\p{_	In_Anatolian_Hieroglyphs}', "");
    Expect(0, 83583, '\p{^_	In_Anatolian_Hieroglyphs}', "");
    Expect(0, 83583, '\P{_	In_Anatolian_Hieroglyphs}', "");
    Expect(1, 83583, '\P{^_	In_Anatolian_Hieroglyphs}', "");
    Expect(0, 83584, '\p{_	In_Anatolian_Hieroglyphs}', "");
    Expect(1, 83584, '\p{^_	In_Anatolian_Hieroglyphs}', "");
    Expect(1, 83584, '\P{_	In_Anatolian_Hieroglyphs}', "");
    Expect(0, 83584, '\P{^_	In_Anatolian_Hieroglyphs}', "");
    Error('\p{ /a/IN_Arabic}');
    Error('\P{ /a/IN_Arabic}');
    Expect(1, 1791, '\p{inarabic}', "");
    Expect(0, 1791, '\p{^inarabic}', "");
    Expect(0, 1791, '\P{inarabic}', "");
    Expect(1, 1791, '\P{^inarabic}', "");
    Expect(0, 1792, '\p{inarabic}', "");
    Expect(1, 1792, '\p{^inarabic}', "");
    Expect(1, 1792, '\P{inarabic}', "");
    Expect(0, 1792, '\P{^inarabic}', "");
    Expect(1, 1791, '\p{		in_Arabic}', "");
    Expect(0, 1791, '\p{^		in_Arabic}', "");
    Expect(0, 1791, '\P{		in_Arabic}', "");
    Expect(1, 1791, '\P{^		in_Arabic}', "");
    Expect(0, 1792, '\p{		in_Arabic}', "");
    Expect(1, 1792, '\p{^		in_Arabic}', "");
    Expect(1, 1792, '\P{		in_Arabic}', "");
    Expect(0, 1792, '\P{^		in_Arabic}', "");
    Error('\p{_	IN_ARABIC:=}');
    Error('\P{_	IN_ARABIC:=}');
    Expect(1, 1791, '\p{	In_ARABIC}', "");
    Expect(0, 1791, '\p{^	In_ARABIC}', "");
    Expect(0, 1791, '\P{	In_ARABIC}', "");
    Expect(1, 1791, '\P{^	In_ARABIC}', "");
    Expect(0, 1792, '\p{	In_ARABIC}', "");
    Expect(1, 1792, '\p{^	In_ARABIC}', "");
    Expect(1, 1792, '\P{	In_ARABIC}', "");
    Expect(0, 1792, '\P{^	In_ARABIC}', "");
    Error('\p{ :=in_ARMENIAN}');
    Error('\P{ :=in_ARMENIAN}');
    Expect(1, 1423, '\p{inarmenian}', "");
    Expect(0, 1423, '\p{^inarmenian}', "");
    Expect(0, 1423, '\P{inarmenian}', "");
    Expect(1, 1423, '\P{^inarmenian}', "");
    Expect(0, 1424, '\p{inarmenian}', "");
    Expect(1, 1424, '\p{^inarmenian}', "");
    Expect(1, 1424, '\P{inarmenian}', "");
    Expect(0, 1424, '\P{^inarmenian}', "");
    Expect(1, 1423, '\p{- in_ARMENIAN}', "");
    Expect(0, 1423, '\p{^- in_ARMENIAN}', "");
    Expect(0, 1423, '\P{- in_ARMENIAN}', "");
    Expect(1, 1423, '\P{^- in_ARMENIAN}', "");
    Expect(0, 1424, '\p{- in_ARMENIAN}', "");
    Expect(1, 1424, '\p{^- in_ARMENIAN}', "");
    Expect(1, 1424, '\P{- in_ARMENIAN}', "");
    Expect(0, 1424, '\P{^- in_ARMENIAN}', "");
    Error('\p{	_In_armenian/a/}');
    Error('\P{	_In_armenian/a/}');
    Expect(1, 1423, '\p{_In_ARMENIAN}', "");
    Expect(0, 1423, '\p{^_In_ARMENIAN}', "");
    Expect(0, 1423, '\P{_In_ARMENIAN}', "");
    Expect(1, 1423, '\P{^_In_ARMENIAN}', "");
    Expect(0, 1424, '\p{_In_ARMENIAN}', "");
    Expect(1, 1424, '\p{^_In_ARMENIAN}', "");
    Expect(1, 1424, '\P{_In_ARMENIAN}', "");
    Expect(0, 1424, '\P{^_In_ARMENIAN}', "");
    Error('\p{ _in_AVESTAN/a/}');
    Error('\P{ _in_AVESTAN/a/}');
    Expect(1, 68415, '\p{inavestan}', "");
    Expect(0, 68415, '\p{^inavestan}', "");
    Expect(0, 68415, '\P{inavestan}', "");
    Expect(1, 68415, '\P{^inavestan}', "");
    Expect(0, 68416, '\p{inavestan}', "");
    Expect(1, 68416, '\p{^inavestan}', "");
    Expect(1, 68416, '\P{inavestan}', "");
    Expect(0, 68416, '\P{^inavestan}', "");
    Expect(1, 68415, '\p{--in_Avestan}', "");
    Expect(0, 68415, '\p{^--in_Avestan}', "");
    Expect(0, 68415, '\P{--in_Avestan}', "");
    Expect(1, 68415, '\P{^--in_Avestan}', "");
    Expect(0, 68416, '\p{--in_Avestan}', "");
    Expect(1, 68416, '\p{^--in_Avestan}', "");
    Expect(1, 68416, '\P{--in_Avestan}', "");
    Expect(0, 68416, '\P{^--in_Avestan}', "");
    Error('\p{/a/__in_Avestan}');
    Error('\P{/a/__in_Avestan}');
    Expect(1, 68415, '\p{		IN_Avestan}', "");
    Expect(0, 68415, '\p{^		IN_Avestan}', "");
    Expect(0, 68415, '\P{		IN_Avestan}', "");
    Expect(1, 68415, '\P{^		IN_Avestan}', "");
    Expect(0, 68416, '\p{		IN_Avestan}', "");
    Expect(1, 68416, '\p{^		IN_Avestan}', "");
    Expect(1, 68416, '\P{		IN_Avestan}', "");
    Expect(0, 68416, '\P{^		IN_Avestan}', "");
    Error('\p{	_In_balinese/a/}');
    Error('\P{	_In_balinese/a/}');
    Expect(1, 7039, '\p{inbalinese}', "");
    Expect(0, 7039, '\p{^inbalinese}', "");
    Expect(0, 7039, '\P{inbalinese}', "");
    Expect(1, 7039, '\P{^inbalinese}', "");
    Expect(0, 7040, '\p{inbalinese}', "");
    Expect(1, 7040, '\p{^inbalinese}', "");
    Expect(1, 7040, '\P{inbalinese}', "");
    Expect(0, 7040, '\P{^inbalinese}', "");
    Expect(1, 7039, '\p{- IN_balinese}', "");
    Expect(0, 7039, '\p{^- IN_balinese}', "");
    Expect(0, 7039, '\P{- IN_balinese}', "");
    Expect(1, 7039, '\P{^- IN_balinese}', "");
    Expect(0, 7040, '\p{- IN_balinese}', "");
    Expect(1, 7040, '\p{^- IN_balinese}', "");
    Expect(1, 7040, '\P{- IN_balinese}', "");
    Expect(0, 7040, '\P{^- IN_balinese}', "");
    Error('\p{:=	in_BALINESE}');
    Error('\P{:=	in_BALINESE}');
    Expect(1, 7039, '\p{- in_balinese}', "");
    Expect(0, 7039, '\p{^- in_balinese}', "");
    Expect(0, 7039, '\P{- in_balinese}', "");
    Expect(1, 7039, '\P{^- in_balinese}', "");
    Expect(0, 7040, '\p{- in_balinese}', "");
    Expect(1, 7040, '\p{^- in_balinese}', "");
    Expect(1, 7040, '\P{- in_balinese}', "");
    Expect(0, 7040, '\P{^- in_balinese}', "");
    Error('\p{	/a/In_Bamum}');
    Error('\P{	/a/In_Bamum}');
    Expect(1, 42751, '\p{inbamum}', "");
    Expect(0, 42751, '\p{^inbamum}', "");
    Expect(0, 42751, '\P{inbamum}', "");
    Expect(1, 42751, '\P{^inbamum}', "");
    Expect(0, 42752, '\p{inbamum}', "");
    Expect(1, 42752, '\p{^inbamum}', "");
    Expect(1, 42752, '\P{inbamum}', "");
    Expect(0, 42752, '\P{^inbamum}', "");
    Expect(1, 42751, '\p{	 In_Bamum}', "");
    Expect(0, 42751, '\p{^	 In_Bamum}', "");
    Expect(0, 42751, '\P{	 In_Bamum}', "");
    Expect(1, 42751, '\P{^	 In_Bamum}', "");
    Expect(0, 42752, '\p{	 In_Bamum}', "");
    Expect(1, 42752, '\p{^	 In_Bamum}', "");
    Expect(1, 42752, '\P{	 In_Bamum}', "");
    Expect(0, 42752, '\P{^	 In_Bamum}', "");
    Error('\p{_In_Bamum/a/}');
    Error('\P{_In_Bamum/a/}');
    Expect(1, 42751, '\p{	in_Bamum}', "");
    Expect(0, 42751, '\p{^	in_Bamum}', "");
    Expect(0, 42751, '\P{	in_Bamum}', "");
    Expect(1, 42751, '\P{^	in_Bamum}', "");
    Expect(0, 42752, '\p{	in_Bamum}', "");
    Expect(1, 42752, '\p{^	in_Bamum}', "");
    Expect(1, 42752, '\P{	in_Bamum}', "");
    Expect(0, 42752, '\P{^	in_Bamum}', "");
    Error('\p{	/a/In_Bassa_vah}');
    Error('\P{	/a/In_Bassa_vah}');
    Expect(1, 92927, '\p{inbassavah}', "");
    Expect(0, 92927, '\p{^inbassavah}', "");
    Expect(0, 92927, '\P{inbassavah}', "");
    Expect(1, 92927, '\P{^inbassavah}', "");
    Expect(0, 92928, '\p{inbassavah}', "");
    Expect(1, 92928, '\p{^inbassavah}', "");
    Expect(1, 92928, '\P{inbassavah}', "");
    Expect(0, 92928, '\P{^inbassavah}', "");
    Expect(1, 92927, '\p{	In_Bassa_Vah}', "");
    Expect(0, 92927, '\p{^	In_Bassa_Vah}', "");
    Expect(0, 92927, '\P{	In_Bassa_Vah}', "");
    Expect(1, 92927, '\P{^	In_Bassa_Vah}', "");
    Expect(0, 92928, '\p{	In_Bassa_Vah}', "");
    Expect(1, 92928, '\p{^	In_Bassa_Vah}', "");
    Expect(1, 92928, '\P{	In_Bassa_Vah}', "");
    Expect(0, 92928, '\P{^	In_Bassa_Vah}', "");
    Error('\p{/a/	_In_bassa_Vah}');
    Error('\P{/a/	_In_bassa_Vah}');
    Expect(1, 92927, '\p{-IN_bassa_VAH}', "");
    Expect(0, 92927, '\p{^-IN_bassa_VAH}', "");
    Expect(0, 92927, '\P{-IN_bassa_VAH}', "");
    Expect(1, 92927, '\P{^-IN_bassa_VAH}', "");
    Expect(0, 92928, '\p{-IN_bassa_VAH}', "");
    Expect(1, 92928, '\p{^-IN_bassa_VAH}', "");
    Expect(1, 92928, '\P{-IN_bassa_VAH}', "");
    Expect(0, 92928, '\P{^-IN_bassa_VAH}', "");
    Error('\p{-/a/In_Batak}');
    Error('\P{-/a/In_Batak}');
    Expect(1, 7167, '\p{inbatak}', "");
    Expect(0, 7167, '\p{^inbatak}', "");
    Expect(0, 7167, '\P{inbatak}', "");
    Expect(1, 7167, '\P{^inbatak}', "");
    Expect(0, 7168, '\p{inbatak}', "");
    Expect(1, 7168, '\p{^inbatak}', "");
    Expect(1, 7168, '\P{inbatak}', "");
    Expect(0, 7168, '\P{^inbatak}', "");
    Expect(1, 7167, '\p{ 	In_BATAK}', "");
    Expect(0, 7167, '\p{^ 	In_BATAK}', "");
    Expect(0, 7167, '\P{ 	In_BATAK}', "");
    Expect(1, 7167, '\P{^ 	In_BATAK}', "");
    Expect(0, 7168, '\p{ 	In_BATAK}', "");
    Expect(1, 7168, '\p{^ 	In_BATAK}', "");
    Expect(1, 7168, '\P{ 	In_BATAK}', "");
    Expect(0, 7168, '\P{^ 	In_BATAK}', "");
    Error('\p{-In_BATAK/a/}');
    Error('\P{-In_BATAK/a/}');
    Error('\p{/a/	In_Bengali}');
    Error('\P{/a/	In_Bengali}');
    Expect(1, 2559, '\p{inbengali}', "");
    Expect(0, 2559, '\p{^inbengali}', "");
    Expect(0, 2559, '\P{inbengali}', "");
    Expect(1, 2559, '\P{^inbengali}', "");
    Expect(0, 2560, '\p{inbengali}', "");
    Expect(1, 2560, '\p{^inbengali}', "");
    Expect(1, 2560, '\P{inbengali}', "");
    Expect(0, 2560, '\P{^inbengali}', "");
    Expect(1, 2559, '\p{ In_BENGALI}', "");
    Expect(0, 2559, '\p{^ In_BENGALI}', "");
    Expect(0, 2559, '\P{ In_BENGALI}', "");
    Expect(1, 2559, '\P{^ In_BENGALI}', "");
    Expect(0, 2560, '\p{ In_BENGALI}', "");
    Expect(1, 2560, '\p{^ In_BENGALI}', "");
    Expect(1, 2560, '\P{ In_BENGALI}', "");
    Expect(0, 2560, '\P{^ In_BENGALI}', "");
    Error('\p{_/a/In_BENGALI}');
    Error('\P{_/a/In_BENGALI}');
    Expect(1, 2559, '\p{  in_Bengali}', "");
    Expect(0, 2559, '\p{^  in_Bengali}', "");
    Expect(0, 2559, '\P{  in_Bengali}', "");
    Expect(1, 2559, '\P{^  in_Bengali}', "");
    Expect(0, 2560, '\p{  in_Bengali}', "");
    Expect(1, 2560, '\p{^  in_Bengali}', "");
    Expect(1, 2560, '\P{  in_Bengali}', "");
    Expect(0, 2560, '\P{^  in_Bengali}', "");
    Error('\p{_/a/in_BHAIKSUKI}');
    Error('\P{_/a/in_BHAIKSUKI}');
    Expect(1, 72815, '\p{inbhaiksuki}', "");
    Expect(0, 72815, '\p{^inbhaiksuki}', "");
    Expect(0, 72815, '\P{inbhaiksuki}', "");
    Expect(1, 72815, '\P{^inbhaiksuki}', "");
    Expect(0, 72816, '\p{inbhaiksuki}', "");
    Expect(1, 72816, '\p{^inbhaiksuki}', "");
    Expect(1, 72816, '\P{inbhaiksuki}', "");
    Expect(0, 72816, '\P{^inbhaiksuki}', "");
    Expect(1, 72815, '\p{-In_BHAIKSUKI}', "");
    Expect(0, 72815, '\p{^-In_BHAIKSUKI}', "");
    Expect(0, 72815, '\P{-In_BHAIKSUKI}', "");
    Expect(1, 72815, '\P{^-In_BHAIKSUKI}', "");
    Expect(0, 72816, '\p{-In_BHAIKSUKI}', "");
    Expect(1, 72816, '\p{^-In_BHAIKSUKI}', "");
    Expect(1, 72816, '\P{-In_BHAIKSUKI}', "");
    Expect(0, 72816, '\P{^-In_BHAIKSUKI}', "");
    Error('\p{:= _In_bhaiksuki}');
    Error('\P{:= _In_bhaiksuki}');
    Expect(1, 72815, '\p{-In_Bhaiksuki}', "");
    Expect(0, 72815, '\p{^-In_Bhaiksuki}', "");
    Expect(0, 72815, '\P{-In_Bhaiksuki}', "");
    Expect(1, 72815, '\P{^-In_Bhaiksuki}', "");
    Expect(0, 72816, '\p{-In_Bhaiksuki}', "");
    Expect(1, 72816, '\p{^-In_Bhaiksuki}', "");
    Expect(1, 72816, '\P{-In_Bhaiksuki}', "");
    Expect(0, 72816, '\P{^-In_Bhaiksuki}', "");
    Error('\p{_in_bopomofo/a/}');
    Error('\P{_in_bopomofo/a/}');
    Expect(1, 12591, '\p{inbopomofo}', "");
    Expect(0, 12591, '\p{^inbopomofo}', "");
    Expect(0, 12591, '\P{inbopomofo}', "");
    Expect(1, 12591, '\P{^inbopomofo}', "");
    Expect(0, 12592, '\p{inbopomofo}', "");
    Expect(1, 12592, '\p{^inbopomofo}', "");
    Expect(1, 12592, '\P{inbopomofo}', "");
    Expect(0, 12592, '\P{^inbopomofo}', "");
    Expect(1, 12591, '\p{_ IN_Bopomofo}', "");
    Expect(0, 12591, '\p{^_ IN_Bopomofo}', "");
    Expect(0, 12591, '\P{_ IN_Bopomofo}', "");
    Expect(1, 12591, '\P{^_ IN_Bopomofo}', "");
    Expect(0, 12592, '\p{_ IN_Bopomofo}', "");
    Expect(1, 12592, '\p{^_ IN_Bopomofo}', "");
    Expect(1, 12592, '\P{_ IN_Bopomofo}', "");
    Expect(0, 12592, '\P{^_ IN_Bopomofo}', "");
    Error('\p{:=-In_Bopomofo}');
    Error('\P{:=-In_Bopomofo}');
    Expect(1, 12591, '\p{-In_Bopomofo}', "");
    Expect(0, 12591, '\p{^-In_Bopomofo}', "");
    Expect(0, 12591, '\P{-In_Bopomofo}', "");
    Expect(1, 12591, '\P{^-In_Bopomofo}', "");
    Expect(0, 12592, '\p{-In_Bopomofo}', "");
    Expect(1, 12592, '\p{^-In_Bopomofo}', "");
    Expect(1, 12592, '\P{-In_Bopomofo}', "");
    Expect(0, 12592, '\P{^-In_Bopomofo}', "");
    Error('\p{/a/IN_BRAHMI}');
    Error('\P{/a/IN_BRAHMI}');
    Expect(1, 69759, '\p{inbrahmi}', "");
    Expect(0, 69759, '\p{^inbrahmi}', "");
    Expect(0, 69759, '\P{inbrahmi}', "");
    Expect(1, 69759, '\P{^inbrahmi}', "");
    Expect(0, 69760, '\p{inbrahmi}', "");
    Expect(1, 69760, '\p{^inbrahmi}', "");
    Expect(1, 69760, '\P{inbrahmi}', "");
    Expect(0, 69760, '\P{^inbrahmi}', "");
    Expect(1, 69759, '\p{-_in_Brahmi}', "");
    Expect(0, 69759, '\p{^-_in_Brahmi}', "");
    Expect(0, 69759, '\P{-_in_Brahmi}', "");
    Expect(1, 69759, '\P{^-_in_Brahmi}', "");
    Expect(0, 69760, '\p{-_in_Brahmi}', "");
    Expect(1, 69760, '\p{^-_in_Brahmi}', "");
    Expect(1, 69760, '\P{-_in_Brahmi}', "");
    Expect(0, 69760, '\P{^-_in_Brahmi}', "");
    Error('\p{:=	 In_brahmi}');
    Error('\P{:=	 In_brahmi}');
    Expect(1, 69759, '\p{	-In_brahmi}', "");
    Expect(0, 69759, '\p{^	-In_brahmi}', "");
    Expect(0, 69759, '\P{	-In_brahmi}', "");
    Expect(1, 69759, '\P{^	-In_brahmi}', "");
    Expect(0, 69760, '\p{	-In_brahmi}', "");
    Expect(1, 69760, '\p{^	-In_brahmi}', "");
    Expect(1, 69760, '\P{	-In_brahmi}', "");
    Expect(0, 69760, '\P{^	-In_brahmi}', "");
    Error('\p{:=	 IN_BUGINESE}');
    Error('\P{:=	 IN_BUGINESE}');
    Expect(1, 6687, '\p{inbuginese}', "");
    Expect(0, 6687, '\p{^inbuginese}', "");
    Expect(0, 6687, '\P{inbuginese}', "");
    Expect(1, 6687, '\P{^inbuginese}', "");
    Expect(0, 6688, '\p{inbuginese}', "");
    Expect(1, 6688, '\p{^inbuginese}', "");
    Expect(1, 6688, '\P{inbuginese}', "");
    Expect(0, 6688, '\P{^inbuginese}', "");
    Expect(1, 6687, '\p{ _IN_buginese}', "");
    Expect(0, 6687, '\p{^ _IN_buginese}', "");
    Expect(0, 6687, '\P{ _IN_buginese}', "");
    Expect(1, 6687, '\P{^ _IN_buginese}', "");
    Expect(0, 6688, '\p{ _IN_buginese}', "");
    Expect(1, 6688, '\p{^ _IN_buginese}', "");
    Expect(1, 6688, '\P{ _IN_buginese}', "");
    Expect(0, 6688, '\P{^ _IN_buginese}', "");
    Error('\p{:= in_BUGINESE}');
    Error('\P{:= in_BUGINESE}');
    Expect(1, 6687, '\p{-	in_Buginese}', "");
    Expect(0, 6687, '\p{^-	in_Buginese}', "");
    Expect(0, 6687, '\P{-	in_Buginese}', "");
    Expect(1, 6687, '\P{^-	in_Buginese}', "");
    Expect(0, 6688, '\p{-	in_Buginese}', "");
    Expect(1, 6688, '\p{^-	in_Buginese}', "");
    Expect(1, 6688, '\P{-	in_Buginese}', "");
    Expect(0, 6688, '\P{^-	in_Buginese}', "");
    Error('\p{- In_buhid:=}');
    Error('\P{- In_buhid:=}');
    Expect(1, 5983, '\p{inbuhid}', "");
    Expect(0, 5983, '\p{^inbuhid}', "");
    Expect(0, 5983, '\P{inbuhid}', "");
    Expect(1, 5983, '\P{^inbuhid}', "");
    Expect(0, 5984, '\p{inbuhid}', "");
    Expect(1, 5984, '\p{^inbuhid}', "");
    Expect(1, 5984, '\P{inbuhid}', "");
    Expect(0, 5984, '\P{^inbuhid}', "");
    Expect(1, 5983, '\p{--IN_Buhid}', "");
    Expect(0, 5983, '\p{^--IN_Buhid}', "");
    Expect(0, 5983, '\P{--IN_Buhid}', "");
    Expect(1, 5983, '\P{^--IN_Buhid}', "");
    Expect(0, 5984, '\p{--IN_Buhid}', "");
    Expect(1, 5984, '\p{^--IN_Buhid}', "");
    Expect(1, 5984, '\P{--IN_Buhid}', "");
    Expect(0, 5984, '\P{^--IN_Buhid}', "");
    Error('\p{	In_Buhid:=}');
    Error('\P{	In_Buhid:=}');
    Expect(1, 5983, '\p{- in_BUHID}', "");
    Expect(0, 5983, '\p{^- in_BUHID}', "");
    Expect(0, 5983, '\P{- in_BUHID}', "");
    Expect(1, 5983, '\P{^- in_BUHID}', "");
    Expect(0, 5984, '\p{- in_BUHID}', "");
    Expect(1, 5984, '\p{^- in_BUHID}', "");
    Expect(1, 5984, '\P{- in_BUHID}', "");
    Expect(0, 5984, '\P{^- in_BUHID}', "");
    Error('\p{:=-	IN_Carian}');
    Error('\P{:=-	IN_Carian}');
    Expect(1, 66271, '\p{incarian}', "");
    Expect(0, 66271, '\p{^incarian}', "");
    Expect(0, 66271, '\P{incarian}', "");
    Expect(1, 66271, '\P{^incarian}', "");
    Expect(0, 66272, '\p{incarian}', "");
    Expect(1, 66272, '\p{^incarian}', "");
    Expect(1, 66272, '\P{incarian}', "");
    Expect(0, 66272, '\P{^incarian}', "");
    Expect(1, 66271, '\p{	in_Carian}', "");
    Expect(0, 66271, '\p{^	in_Carian}', "");
    Expect(0, 66271, '\P{	in_Carian}', "");
    Expect(1, 66271, '\P{^	in_Carian}', "");
    Expect(0, 66272, '\p{	in_Carian}', "");
    Expect(1, 66272, '\p{^	in_Carian}', "");
    Expect(1, 66272, '\P{	in_Carian}', "");
    Expect(0, 66272, '\P{^	in_Carian}', "");
    Error('\p{	:=In_CARIAN}');
    Error('\P{	:=In_CARIAN}');
    Expect(1, 66271, '\p{		IN_Carian}', "");
    Expect(0, 66271, '\p{^		IN_Carian}', "");
    Expect(0, 66271, '\P{		IN_Carian}', "");
    Expect(1, 66271, '\P{^		IN_Carian}', "");
    Expect(0, 66272, '\p{		IN_Carian}', "");
    Expect(1, 66272, '\p{^		IN_Carian}', "");
    Expect(1, 66272, '\P{		IN_Carian}', "");
    Expect(0, 66272, '\P{^		IN_Carian}', "");
    Error('\p{_in_Caucasian_ALBANIAN:=}');
    Error('\P{_in_Caucasian_ALBANIAN:=}');
    Expect(1, 66927, '\p{incaucasianalbanian}', "");
    Expect(0, 66927, '\p{^incaucasianalbanian}', "");
    Expect(0, 66927, '\P{incaucasianalbanian}', "");
    Expect(1, 66927, '\P{^incaucasianalbanian}', "");
    Expect(0, 66928, '\p{incaucasianalbanian}', "");
    Expect(1, 66928, '\p{^incaucasianalbanian}', "");
    Expect(1, 66928, '\P{incaucasianalbanian}', "");
    Expect(0, 66928, '\P{^incaucasianalbanian}', "");
    Expect(1, 66927, '\p{	In_caucasian_Albanian}', "");
    Expect(0, 66927, '\p{^	In_caucasian_Albanian}', "");
    Expect(0, 66927, '\P{	In_caucasian_Albanian}', "");
    Expect(1, 66927, '\P{^	In_caucasian_Albanian}', "");
    Expect(0, 66928, '\p{	In_caucasian_Albanian}', "");
    Expect(1, 66928, '\p{^	In_caucasian_Albanian}', "");
    Expect(1, 66928, '\P{	In_caucasian_Albanian}', "");
    Expect(0, 66928, '\P{^	In_caucasian_Albanian}', "");
    Error('\p{-/a/In_CAUCASIAN_Albanian}');
    Error('\P{-/a/In_CAUCASIAN_Albanian}');
    Expect(1, 66927, '\p{ In_CAUCASIAN_albanian}', "");
    Expect(0, 66927, '\p{^ In_CAUCASIAN_albanian}', "");
    Expect(0, 66927, '\P{ In_CAUCASIAN_albanian}', "");
    Expect(1, 66927, '\P{^ In_CAUCASIAN_albanian}', "");
    Expect(0, 66928, '\p{ In_CAUCASIAN_albanian}', "");
    Expect(1, 66928, '\p{^ In_CAUCASIAN_albanian}', "");
    Expect(1, 66928, '\P{ In_CAUCASIAN_albanian}', "");
    Expect(0, 66928, '\P{^ In_CAUCASIAN_albanian}', "");
    Error('\p{:=	_in_Chakma}');
    Error('\P{:=	_in_Chakma}');
    Expect(1, 69967, '\p{inchakma}', "");
    Expect(0, 69967, '\p{^inchakma}', "");
    Expect(0, 69967, '\P{inchakma}', "");
    Expect(1, 69967, '\P{^inchakma}', "");
    Expect(0, 69968, '\p{inchakma}', "");
    Expect(1, 69968, '\p{^inchakma}', "");
    Expect(1, 69968, '\P{inchakma}', "");
    Expect(0, 69968, '\P{^inchakma}', "");
    Expect(1, 69967, '\p{-	IN_Chakma}', "");
    Expect(0, 69967, '\p{^-	IN_Chakma}', "");
    Expect(0, 69967, '\P{-	IN_Chakma}', "");
    Expect(1, 69967, '\P{^-	IN_Chakma}', "");
    Expect(0, 69968, '\p{-	IN_Chakma}', "");
    Expect(1, 69968, '\p{^-	IN_Chakma}', "");
    Expect(1, 69968, '\P{-	IN_Chakma}', "");
    Expect(0, 69968, '\P{^-	IN_Chakma}', "");
    Error('\p{_/a/In_Chakma}');
    Error('\P{_/a/In_Chakma}');
    Expect(1, 69967, '\p{_ IN_chakma}', "");
    Expect(0, 69967, '\p{^_ IN_chakma}', "");
    Expect(0, 69967, '\P{_ IN_chakma}', "");
    Expect(1, 69967, '\P{^_ IN_chakma}', "");
    Expect(0, 69968, '\p{_ IN_chakma}', "");
    Expect(1, 69968, '\p{^_ IN_chakma}', "");
    Expect(1, 69968, '\P{_ IN_chakma}', "");
    Expect(0, 69968, '\P{^_ IN_chakma}', "");
    Error('\p{ in_cham:=}');
    Error('\P{ in_cham:=}');
    Expect(1, 43615, '\p{incham}', "");
    Expect(0, 43615, '\p{^incham}', "");
    Expect(0, 43615, '\P{incham}', "");
    Expect(1, 43615, '\P{^incham}', "");
    Expect(0, 43616, '\p{incham}', "");
    Expect(1, 43616, '\p{^incham}', "");
    Expect(1, 43616, '\P{incham}', "");
    Expect(0, 43616, '\P{^incham}', "");
    Expect(1, 43615, '\p{	 in_Cham}', "");
    Expect(0, 43615, '\p{^	 in_Cham}', "");
    Expect(0, 43615, '\P{	 in_Cham}', "");
    Expect(1, 43615, '\P{^	 in_Cham}', "");
    Expect(0, 43616, '\p{	 in_Cham}', "");
    Expect(1, 43616, '\p{^	 in_Cham}', "");
    Expect(1, 43616, '\P{	 in_Cham}', "");
    Expect(0, 43616, '\P{^	 in_Cham}', "");
    Error('\p{:=_ In_cham}');
    Error('\P{:=_ In_cham}');
    Expect(1, 43615, '\p{  IN_CHAM}', "");
    Expect(0, 43615, '\p{^  IN_CHAM}', "");
    Expect(0, 43615, '\P{  IN_CHAM}', "");
    Expect(1, 43615, '\P{^  IN_CHAM}', "");
    Expect(0, 43616, '\p{  IN_CHAM}', "");
    Expect(1, 43616, '\p{^  IN_CHAM}', "");
    Expect(1, 43616, '\P{  IN_CHAM}', "");
    Expect(0, 43616, '\P{^  IN_CHAM}', "");
    Error('\p{_ in_Cherokee/a/}');
    Error('\P{_ in_Cherokee/a/}');
    Expect(1, 5119, '\p{incherokee}', "");
    Expect(0, 5119, '\p{^incherokee}', "");
    Expect(0, 5119, '\P{incherokee}', "");
    Expect(1, 5119, '\P{^incherokee}', "");
    Expect(0, 5120, '\p{incherokee}', "");
    Expect(1, 5120, '\p{^incherokee}', "");
    Expect(1, 5120, '\P{incherokee}', "");
    Expect(0, 5120, '\P{^incherokee}', "");
    Expect(1, 5119, '\p{  In_Cherokee}', "");
    Expect(0, 5119, '\p{^  In_Cherokee}', "");
    Expect(0, 5119, '\P{  In_Cherokee}', "");
    Expect(1, 5119, '\P{^  In_Cherokee}', "");
    Expect(0, 5120, '\p{  In_Cherokee}', "");
    Expect(1, 5120, '\p{^  In_Cherokee}', "");
    Expect(1, 5120, '\P{  In_Cherokee}', "");
    Expect(0, 5120, '\P{^  In_Cherokee}', "");
    Error('\p{:=In_Cherokee}');
    Error('\P{:=In_Cherokee}');
    Expect(1, 5119, '\p{ -In_Cherokee}', "");
    Expect(0, 5119, '\p{^ -In_Cherokee}', "");
    Expect(0, 5119, '\P{ -In_Cherokee}', "");
    Expect(1, 5119, '\P{^ -In_Cherokee}', "");
    Expect(0, 5120, '\p{ -In_Cherokee}', "");
    Expect(1, 5120, '\p{^ -In_Cherokee}', "");
    Expect(1, 5120, '\P{ -In_Cherokee}', "");
    Expect(0, 5120, '\P{^ -In_Cherokee}', "");
    Error('\p{/a/	_IN_Coptic}');
    Error('\P{/a/	_IN_Coptic}');
    Expect(1, 11519, '\p{incoptic}', "");
    Expect(0, 11519, '\p{^incoptic}', "");
    Expect(0, 11519, '\P{incoptic}', "");
    Expect(1, 11519, '\P{^incoptic}', "");
    Expect(0, 11520, '\p{incoptic}', "");
    Expect(1, 11520, '\p{^incoptic}', "");
    Expect(1, 11520, '\P{incoptic}', "");
    Expect(0, 11520, '\P{^incoptic}', "");
    Expect(1, 11519, '\p{ _IN_coptic}', "");
    Expect(0, 11519, '\p{^ _IN_coptic}', "");
    Expect(0, 11519, '\P{ _IN_coptic}', "");
    Expect(1, 11519, '\P{^ _IN_coptic}', "");
    Expect(0, 11520, '\p{ _IN_coptic}', "");
    Expect(1, 11520, '\p{^ _IN_coptic}', "");
    Expect(1, 11520, '\P{ _IN_coptic}', "");
    Expect(0, 11520, '\P{^ _IN_coptic}', "");
    Error('\p{/a/_-in_Coptic}');
    Error('\P{/a/_-in_Coptic}');
    Expect(1, 11519, '\p{	_in_COPTIC}', "");
    Expect(0, 11519, '\p{^	_in_COPTIC}', "");
    Expect(0, 11519, '\P{	_in_COPTIC}', "");
    Expect(1, 11519, '\P{^	_in_COPTIC}', "");
    Expect(0, 11520, '\p{	_in_COPTIC}', "");
    Expect(1, 11520, '\p{^	_in_COPTIC}', "");
    Expect(1, 11520, '\P{	_in_COPTIC}', "");
    Expect(0, 11520, '\P{^	_in_COPTIC}', "");
    Error('\p{	-In_Cuneiform/a/}');
    Error('\P{	-In_Cuneiform/a/}');
    Expect(1, 74751, '\p{incuneiform}', "");
    Expect(0, 74751, '\p{^incuneiform}', "");
    Expect(0, 74751, '\P{incuneiform}', "");
    Expect(1, 74751, '\P{^incuneiform}', "");
    Expect(0, 74752, '\p{incuneiform}', "");
    Expect(1, 74752, '\p{^incuneiform}', "");
    Expect(1, 74752, '\P{incuneiform}', "");
    Expect(0, 74752, '\P{^incuneiform}', "");
    Expect(1, 74751, '\p{ IN_CUNEIFORM}', "");
    Expect(0, 74751, '\p{^ IN_CUNEIFORM}', "");
    Expect(0, 74751, '\P{ IN_CUNEIFORM}', "");
    Expect(1, 74751, '\P{^ IN_CUNEIFORM}', "");
    Expect(0, 74752, '\p{ IN_CUNEIFORM}', "");
    Expect(1, 74752, '\p{^ IN_CUNEIFORM}', "");
    Expect(1, 74752, '\P{ IN_CUNEIFORM}', "");
    Expect(0, 74752, '\P{^ IN_CUNEIFORM}', "");
    Error('\p{_In_Cuneiform:=}');
    Error('\P{_In_Cuneiform:=}');
    Expect(1, 74751, '\p{_In_Cuneiform}', "");
    Expect(0, 74751, '\p{^_In_Cuneiform}', "");
    Expect(0, 74751, '\P{_In_Cuneiform}', "");
    Expect(1, 74751, '\P{^_In_Cuneiform}', "");
    Expect(0, 74752, '\p{_In_Cuneiform}', "");
    Expect(1, 74752, '\p{^_In_Cuneiform}', "");
    Expect(1, 74752, '\P{_In_Cuneiform}', "");
    Expect(0, 74752, '\P{^_In_Cuneiform}', "");
    Error('\p{/a/ _IN_Cyrillic}');
    Error('\P{/a/ _IN_Cyrillic}');
    Expect(1, 1279, '\p{incyrillic}', "");
    Expect(0, 1279, '\p{^incyrillic}', "");
    Expect(0, 1279, '\P{incyrillic}', "");
    Expect(1, 1279, '\P{^incyrillic}', "");
    Expect(0, 1280, '\p{incyrillic}', "");
    Expect(1, 1280, '\p{^incyrillic}', "");
    Expect(1, 1280, '\P{incyrillic}', "");
    Expect(0, 1280, '\P{^incyrillic}', "");
    Expect(1, 1279, '\p{-	in_cyrillic}', "");
    Expect(0, 1279, '\p{^-	in_cyrillic}', "");
    Expect(0, 1279, '\P{-	in_cyrillic}', "");
    Expect(1, 1279, '\P{^-	in_cyrillic}', "");
    Expect(0, 1280, '\p{-	in_cyrillic}', "");
    Expect(1, 1280, '\p{^-	in_cyrillic}', "");
    Expect(1, 1280, '\P{-	in_cyrillic}', "");
    Expect(0, 1280, '\P{^-	in_cyrillic}', "");
    Error('\p{:=-	In_Cyrillic}');
    Error('\P{:=-	In_Cyrillic}');
    Expect(1, 1279, '\p{ 	in_cyrillic}', "");
    Expect(0, 1279, '\p{^ 	in_cyrillic}', "");
    Expect(0, 1279, '\P{ 	in_cyrillic}', "");
    Expect(1, 1279, '\P{^ 	in_cyrillic}', "");
    Expect(0, 1280, '\p{ 	in_cyrillic}', "");
    Expect(1, 1280, '\p{^ 	in_cyrillic}', "");
    Expect(1, 1280, '\P{ 	in_cyrillic}', "");
    Expect(0, 1280, '\P{^ 	in_cyrillic}', "");
    Error('\p{ :=In_Deseret}');
    Error('\P{ :=In_Deseret}');
    Expect(1, 66639, '\p{indeseret}', "");
    Expect(0, 66639, '\p{^indeseret}', "");
    Expect(0, 66639, '\P{indeseret}', "");
    Expect(1, 66639, '\P{^indeseret}', "");
    Expect(0, 66640, '\p{indeseret}', "");
    Expect(1, 66640, '\p{^indeseret}', "");
    Expect(1, 66640, '\P{indeseret}', "");
    Expect(0, 66640, '\P{^indeseret}', "");
    Expect(1, 66639, '\p{-IN_Deseret}', "");
    Expect(0, 66639, '\p{^-IN_Deseret}', "");
    Expect(0, 66639, '\P{-IN_Deseret}', "");
    Expect(1, 66639, '\P{^-IN_Deseret}', "");
    Expect(0, 66640, '\p{-IN_Deseret}', "");
    Expect(1, 66640, '\p{^-IN_Deseret}', "");
    Expect(1, 66640, '\P{-IN_Deseret}', "");
    Expect(0, 66640, '\P{^-IN_Deseret}', "");
    Error('\p{  In_Deseret/a/}');
    Error('\P{  In_Deseret/a/}');
    Expect(1, 66639, '\p{ IN_DESERET}', "");
    Expect(0, 66639, '\p{^ IN_DESERET}', "");
    Expect(0, 66639, '\P{ IN_DESERET}', "");
    Expect(1, 66639, '\P{^ IN_DESERET}', "");
    Expect(0, 66640, '\p{ IN_DESERET}', "");
    Expect(1, 66640, '\p{^ IN_DESERET}', "");
    Expect(1, 66640, '\P{ IN_DESERET}', "");
    Expect(0, 66640, '\P{^ IN_DESERET}', "");
    Error('\p{/a/_-In_DEVANAGARI}');
    Error('\P{/a/_-In_DEVANAGARI}');
    Expect(1, 2431, '\p{indevanagari}', "");
    Expect(0, 2431, '\p{^indevanagari}', "");
    Expect(0, 2431, '\P{indevanagari}', "");
    Expect(1, 2431, '\P{^indevanagari}', "");
    Expect(0, 2432, '\p{indevanagari}', "");
    Expect(1, 2432, '\p{^indevanagari}', "");
    Expect(1, 2432, '\P{indevanagari}', "");
    Expect(0, 2432, '\P{^indevanagari}', "");
    Expect(1, 2431, '\p{ _in_Devanagari}', "");
    Expect(0, 2431, '\p{^ _in_Devanagari}', "");
    Expect(0, 2431, '\P{ _in_Devanagari}', "");
    Expect(1, 2431, '\P{^ _in_Devanagari}', "");
    Expect(0, 2432, '\p{ _in_Devanagari}', "");
    Expect(1, 2432, '\p{^ _in_Devanagari}', "");
    Expect(1, 2432, '\P{ _in_Devanagari}', "");
    Expect(0, 2432, '\P{^ _in_Devanagari}', "");
    Error('\p{ /a/in_Devanagari}');
    Error('\P{ /a/in_Devanagari}');
    Expect(1, 2431, '\p{	 In_Devanagari}', "");
    Expect(0, 2431, '\p{^	 In_Devanagari}', "");
    Expect(0, 2431, '\P{	 In_Devanagari}', "");
    Expect(1, 2431, '\P{^	 In_Devanagari}', "");
    Expect(0, 2432, '\p{	 In_Devanagari}', "");
    Expect(1, 2432, '\p{^	 In_Devanagari}', "");
    Expect(1, 2432, '\P{	 In_Devanagari}', "");
    Expect(0, 2432, '\P{^	 In_Devanagari}', "");
    Error('\p{ :=In_Duployan}');
    Error('\P{ :=In_Duployan}');
    Expect(1, 113823, '\p{induployan}', "");
    Expect(0, 113823, '\p{^induployan}', "");
    Expect(0, 113823, '\P{induployan}', "");
    Expect(1, 113823, '\P{^induployan}', "");
    Expect(0, 113824, '\p{induployan}', "");
    Expect(1, 113824, '\p{^induployan}', "");
    Expect(1, 113824, '\P{induployan}', "");
    Expect(0, 113824, '\P{^induployan}', "");
    Expect(1, 113823, '\p{-IN_duployan}', "");
    Expect(0, 113823, '\p{^-IN_duployan}', "");
    Expect(0, 113823, '\P{-IN_duployan}', "");
    Expect(1, 113823, '\P{^-IN_duployan}', "");
    Expect(0, 113824, '\p{-IN_duployan}', "");
    Expect(1, 113824, '\p{^-IN_duployan}', "");
    Expect(1, 113824, '\P{-IN_duployan}', "");
    Expect(0, 113824, '\P{^-IN_duployan}', "");
    Error('\p{:=	In_Duployan}');
    Error('\P{:=	In_Duployan}');
    Expect(1, 113823, '\p{ In_Duployan}', "");
    Expect(0, 113823, '\p{^ In_Duployan}', "");
    Expect(0, 113823, '\P{ In_Duployan}', "");
    Expect(1, 113823, '\P{^ In_Duployan}', "");
    Expect(0, 113824, '\p{ In_Duployan}', "");
    Expect(1, 113824, '\p{^ In_Duployan}', "");
    Expect(1, 113824, '\P{ In_Duployan}', "");
    Expect(0, 113824, '\P{^ In_Duployan}', "");
    Error('\p{-:=In_EGYPTIAN_Hieroglyphs}');
    Error('\P{-:=In_EGYPTIAN_Hieroglyphs}');
    Expect(1, 78895, '\p{inegyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{^inegyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{inegyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{^inegyptianhieroglyphs}', "");
    Expect(0, 78896, '\p{inegyptianhieroglyphs}', "");
    Expect(1, 78896, '\p{^inegyptianhieroglyphs}', "");
    Expect(1, 78896, '\P{inegyptianhieroglyphs}', "");
    Expect(0, 78896, '\P{^inegyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{_-in_Egyptian_hieroglyphs}', "");
    Expect(0, 78895, '\p{^_-in_Egyptian_hieroglyphs}', "");
    Expect(0, 78895, '\P{_-in_Egyptian_hieroglyphs}', "");
    Expect(1, 78895, '\P{^_-in_Egyptian_hieroglyphs}', "");
    Expect(0, 78896, '\p{_-in_Egyptian_hieroglyphs}', "");
    Expect(1, 78896, '\p{^_-in_Egyptian_hieroglyphs}', "");
    Expect(1, 78896, '\P{_-in_Egyptian_hieroglyphs}', "");
    Expect(0, 78896, '\P{^_-in_Egyptian_hieroglyphs}', "");
    Error('\p{:=_-IN_Egyptian_hieroglyphs}');
    Error('\P{:=_-IN_Egyptian_hieroglyphs}');
    Expect(1, 78895, '\p{	 in_EGYPTIAN_HIEROGLYPHS}', "");
    Expect(0, 78895, '\p{^	 in_EGYPTIAN_HIEROGLYPHS}', "");
    Expect(0, 78895, '\P{	 in_EGYPTIAN_HIEROGLYPHS}', "");
    Expect(1, 78895, '\P{^	 in_EGYPTIAN_HIEROGLYPHS}', "");
    Expect(0, 78896, '\p{	 in_EGYPTIAN_HIEROGLYPHS}', "");
    Expect(1, 78896, '\p{^	 in_EGYPTIAN_HIEROGLYPHS}', "");
    Expect(1, 78896, '\P{	 in_EGYPTIAN_HIEROGLYPHS}', "");
    Expect(0, 78896, '\P{^	 in_EGYPTIAN_HIEROGLYPHS}', "");
    Error('\p{	/a/In_Elbasan}');
    Error('\P{	/a/In_Elbasan}');
    Expect(1, 66863, '\p{inelbasan}', "");
    Expect(0, 66863, '\p{^inelbasan}', "");
    Expect(0, 66863, '\P{inelbasan}', "");
    Expect(1, 66863, '\P{^inelbasan}', "");
    Expect(0, 66864, '\p{inelbasan}', "");
    Expect(1, 66864, '\p{^inelbasan}', "");
    Expect(1, 66864, '\P{inelbasan}', "");
    Expect(0, 66864, '\P{^inelbasan}', "");
    Expect(1, 66863, '\p{ -In_ELBASAN}', "");
    Expect(0, 66863, '\p{^ -In_ELBASAN}', "");
    Expect(0, 66863, '\P{ -In_ELBASAN}', "");
    Expect(1, 66863, '\P{^ -In_ELBASAN}', "");
    Expect(0, 66864, '\p{ -In_ELBASAN}', "");
    Expect(1, 66864, '\p{^ -In_ELBASAN}', "");
    Expect(1, 66864, '\P{ -In_ELBASAN}', "");
    Expect(0, 66864, '\P{^ -In_ELBASAN}', "");
    Error('\p{		In_ELBASAN/a/}');
    Error('\P{		In_ELBASAN/a/}');
    Expect(1, 66863, '\p{ _In_Elbasan}', "");
    Expect(0, 66863, '\p{^ _In_Elbasan}', "");
    Expect(0, 66863, '\P{ _In_Elbasan}', "");
    Expect(1, 66863, '\P{^ _In_Elbasan}', "");
    Expect(0, 66864, '\p{ _In_Elbasan}', "");
    Expect(1, 66864, '\p{^ _In_Elbasan}', "");
    Expect(1, 66864, '\P{ _In_Elbasan}', "");
    Expect(0, 66864, '\P{^ _In_Elbasan}', "");
    Error('\p{:=_-IN_Ethiopic}');
    Error('\P{:=_-IN_Ethiopic}');
    Expect(1, 4991, '\p{inethiopic}', "");
    Expect(0, 4991, '\p{^inethiopic}', "");
    Expect(0, 4991, '\P{inethiopic}', "");
    Expect(1, 4991, '\P{^inethiopic}', "");
    Expect(0, 4992, '\p{inethiopic}', "");
    Expect(1, 4992, '\p{^inethiopic}', "");
    Expect(1, 4992, '\P{inethiopic}', "");
    Expect(0, 4992, '\P{^inethiopic}', "");
    Expect(1, 4991, '\p{_-In_Ethiopic}', "");
    Expect(0, 4991, '\p{^_-In_Ethiopic}', "");
    Expect(0, 4991, '\P{_-In_Ethiopic}', "");
    Expect(1, 4991, '\P{^_-In_Ethiopic}', "");
    Expect(0, 4992, '\p{_-In_Ethiopic}', "");
    Expect(1, 4992, '\p{^_-In_Ethiopic}', "");
    Expect(1, 4992, '\P{_-In_Ethiopic}', "");
    Expect(0, 4992, '\P{^_-In_Ethiopic}', "");
    Error('\p{/a/ _In_Ethiopic}');
    Error('\P{/a/ _In_Ethiopic}');
    Expect(1, 4991, '\p{_ In_ETHIOPIC}', "");
    Expect(0, 4991, '\p{^_ In_ETHIOPIC}', "");
    Expect(0, 4991, '\P{_ In_ETHIOPIC}', "");
    Expect(1, 4991, '\P{^_ In_ETHIOPIC}', "");
    Expect(0, 4992, '\p{_ In_ETHIOPIC}', "");
    Expect(1, 4992, '\p{^_ In_ETHIOPIC}', "");
    Expect(1, 4992, '\P{_ In_ETHIOPIC}', "");
    Expect(0, 4992, '\P{^_ In_ETHIOPIC}', "");
    Error('\p{		In_Georgian/a/}');
    Error('\P{		In_Georgian/a/}');
    Expect(1, 4351, '\p{ingeorgian}', "");
    Expect(0, 4351, '\p{^ingeorgian}', "");
    Expect(0, 4351, '\P{ingeorgian}', "");
    Expect(1, 4351, '\P{^ingeorgian}', "");
    Expect(0, 4352, '\p{ingeorgian}', "");
    Expect(1, 4352, '\p{^ingeorgian}', "");
    Expect(1, 4352, '\P{ingeorgian}', "");
    Expect(0, 4352, '\P{^ingeorgian}', "");
    Expect(1, 4351, '\p{_ In_GEORGIAN}', "");
    Expect(0, 4351, '\p{^_ In_GEORGIAN}', "");
    Expect(0, 4351, '\P{_ In_GEORGIAN}', "");
    Expect(1, 4351, '\P{^_ In_GEORGIAN}', "");
    Expect(0, 4352, '\p{_ In_GEORGIAN}', "");
    Expect(1, 4352, '\p{^_ In_GEORGIAN}', "");
    Expect(1, 4352, '\P{_ In_GEORGIAN}', "");
    Expect(0, 4352, '\P{^_ In_GEORGIAN}', "");
    Error('\p{ 	In_Georgian/a/}');
    Error('\P{ 	In_Georgian/a/}');
    Expect(1, 4351, '\p{_ IN_Georgian}', "");
    Expect(0, 4351, '\p{^_ IN_Georgian}', "");
    Expect(0, 4351, '\P{_ IN_Georgian}', "");
    Expect(1, 4351, '\P{^_ IN_Georgian}', "");
    Expect(0, 4352, '\p{_ IN_Georgian}', "");
    Expect(1, 4352, '\p{^_ IN_Georgian}', "");
    Expect(1, 4352, '\P{_ IN_Georgian}', "");
    Expect(0, 4352, '\P{^_ IN_Georgian}', "");
    Error('\p{_In_Glagolitic:=}');
    Error('\P{_In_Glagolitic:=}');
    Expect(1, 11359, '\p{inglagolitic}', "");
    Expect(0, 11359, '\p{^inglagolitic}', "");
    Expect(0, 11359, '\P{inglagolitic}', "");
    Expect(1, 11359, '\P{^inglagolitic}', "");
    Expect(0, 11360, '\p{inglagolitic}', "");
    Expect(1, 11360, '\p{^inglagolitic}', "");
    Expect(1, 11360, '\P{inglagolitic}', "");
    Expect(0, 11360, '\P{^inglagolitic}', "");
    Expect(1, 11359, '\p{_In_GLAGOLITIC}', "");
    Expect(0, 11359, '\p{^_In_GLAGOLITIC}', "");
    Expect(0, 11359, '\P{_In_GLAGOLITIC}', "");
    Expect(1, 11359, '\P{^_In_GLAGOLITIC}', "");
    Expect(0, 11360, '\p{_In_GLAGOLITIC}', "");
    Expect(1, 11360, '\p{^_In_GLAGOLITIC}', "");
    Expect(1, 11360, '\P{_In_GLAGOLITIC}', "");
    Expect(0, 11360, '\P{^_In_GLAGOLITIC}', "");
    Error('\p{ :=In_Glagolitic}');
    Error('\P{ :=In_Glagolitic}');
    Expect(1, 11359, '\p{  IN_glagolitic}', "");
    Expect(0, 11359, '\p{^  IN_glagolitic}', "");
    Expect(0, 11359, '\P{  IN_glagolitic}', "");
    Expect(1, 11359, '\P{^  IN_glagolitic}', "");
    Expect(0, 11360, '\p{  IN_glagolitic}', "");
    Expect(1, 11360, '\p{^  IN_glagolitic}', "");
    Expect(1, 11360, '\P{  IN_glagolitic}', "");
    Expect(0, 11360, '\P{^  IN_glagolitic}', "");
    Error('\p{-:=In_gothic}');
    Error('\P{-:=In_gothic}');
    Expect(1, 66383, '\p{ingothic}', "");
    Expect(0, 66383, '\p{^ingothic}', "");
    Expect(0, 66383, '\P{ingothic}', "");
    Expect(1, 66383, '\P{^ingothic}', "");
    Expect(0, 66384, '\p{ingothic}', "");
    Expect(1, 66384, '\p{^ingothic}', "");
    Expect(1, 66384, '\P{ingothic}', "");
    Expect(0, 66384, '\P{^ingothic}', "");
    Expect(1, 66383, '\p{		In_GOTHIC}', "");
    Expect(0, 66383, '\p{^		In_GOTHIC}', "");
    Expect(0, 66383, '\P{		In_GOTHIC}', "");
    Expect(1, 66383, '\P{^		In_GOTHIC}', "");
    Expect(0, 66384, '\p{		In_GOTHIC}', "");
    Expect(1, 66384, '\p{^		In_GOTHIC}', "");
    Expect(1, 66384, '\P{		In_GOTHIC}', "");
    Expect(0, 66384, '\P{^		In_GOTHIC}', "");
    Error('\p{:=		in_gothic}');
    Error('\P{:=		in_gothic}');
    Expect(1, 66383, '\p{		in_Gothic}', "");
    Expect(0, 66383, '\p{^		in_Gothic}', "");
    Expect(0, 66383, '\P{		in_Gothic}', "");
    Expect(1, 66383, '\P{^		in_Gothic}', "");
    Expect(0, 66384, '\p{		in_Gothic}', "");
    Expect(1, 66384, '\p{^		in_Gothic}', "");
    Expect(1, 66384, '\P{		in_Gothic}', "");
    Expect(0, 66384, '\P{^		in_Gothic}', "");
    Error('\p{ /a/IN_Grantha}');
    Error('\P{ /a/IN_Grantha}');
    Expect(1, 70527, '\p{ingrantha}', "");
    Expect(0, 70527, '\p{^ingrantha}', "");
    Expect(0, 70527, '\P{ingrantha}', "");
    Expect(1, 70527, '\P{^ingrantha}', "");
    Expect(0, 70528, '\p{ingrantha}', "");
    Expect(1, 70528, '\p{^ingrantha}', "");
    Expect(1, 70528, '\P{ingrantha}', "");
    Expect(0, 70528, '\P{^ingrantha}', "");
    Expect(1, 70527, '\p{__In_Grantha}', "");
    Expect(0, 70527, '\p{^__In_Grantha}', "");
    Expect(0, 70527, '\P{__In_Grantha}', "");
    Expect(1, 70527, '\P{^__In_Grantha}', "");
    Expect(0, 70528, '\p{__In_Grantha}', "");
    Expect(1, 70528, '\p{^__In_Grantha}', "");
    Expect(1, 70528, '\P{__In_Grantha}', "");
    Expect(0, 70528, '\P{^__In_Grantha}', "");
    Error('\p{-In_Grantha:=}');
    Error('\P{-In_Grantha:=}');
    Expect(1, 70527, '\p{ 	in_Grantha}', "");
    Expect(0, 70527, '\p{^ 	in_Grantha}', "");
    Expect(0, 70527, '\P{ 	in_Grantha}', "");
    Expect(1, 70527, '\P{^ 	in_Grantha}', "");
    Expect(0, 70528, '\p{ 	in_Grantha}', "");
    Expect(1, 70528, '\p{^ 	in_Grantha}', "");
    Expect(1, 70528, '\P{ 	in_Grantha}', "");
    Expect(0, 70528, '\P{^ 	in_Grantha}', "");
    Error('\p{/a/	 IN_gujarati}');
    Error('\P{/a/	 IN_gujarati}');
    Expect(1, 2815, '\p{ingujarati}', "");
    Expect(0, 2815, '\p{^ingujarati}', "");
    Expect(0, 2815, '\P{ingujarati}', "");
    Expect(1, 2815, '\P{^ingujarati}', "");
    Expect(0, 2816, '\p{ingujarati}', "");
    Expect(1, 2816, '\p{^ingujarati}', "");
    Expect(1, 2816, '\P{ingujarati}', "");
    Expect(0, 2816, '\P{^ingujarati}', "");
    Expect(1, 2815, '\p{ In_gujarati}', "");
    Expect(0, 2815, '\p{^ In_gujarati}', "");
    Expect(0, 2815, '\P{ In_gujarati}', "");
    Expect(1, 2815, '\P{^ In_gujarati}', "");
    Expect(0, 2816, '\p{ In_gujarati}', "");
    Expect(1, 2816, '\p{^ In_gujarati}', "");
    Expect(1, 2816, '\P{ In_gujarati}', "");
    Expect(0, 2816, '\P{^ In_gujarati}', "");
    Error('\p{ In_Gujarati/a/}');
    Error('\P{ In_Gujarati/a/}');
    Expect(1, 2815, '\p{-	IN_gujarati}', "");
    Expect(0, 2815, '\p{^-	IN_gujarati}', "");
    Expect(0, 2815, '\P{-	IN_gujarati}', "");
    Expect(1, 2815, '\P{^-	IN_gujarati}', "");
    Expect(0, 2816, '\p{-	IN_gujarati}', "");
    Expect(1, 2816, '\p{^-	IN_gujarati}', "");
    Expect(1, 2816, '\P{-	IN_gujarati}', "");
    Expect(0, 2816, '\P{^-	IN_gujarati}', "");
    Error('\p{_ in_GURMUKHI:=}');
    Error('\P{_ in_GURMUKHI:=}');
    Expect(1, 2687, '\p{ingurmukhi}', "");
    Expect(0, 2687, '\p{^ingurmukhi}', "");
    Expect(0, 2687, '\P{ingurmukhi}', "");
    Expect(1, 2687, '\P{^ingurmukhi}', "");
    Expect(0, 2688, '\p{ingurmukhi}', "");
    Expect(1, 2688, '\p{^ingurmukhi}', "");
    Expect(1, 2688, '\P{ingurmukhi}', "");
    Expect(0, 2688, '\P{^ingurmukhi}', "");
    Expect(1, 2687, '\p{	 in_GURMUKHI}', "");
    Expect(0, 2687, '\p{^	 in_GURMUKHI}', "");
    Expect(0, 2687, '\P{	 in_GURMUKHI}', "");
    Expect(1, 2687, '\P{^	 in_GURMUKHI}', "");
    Expect(0, 2688, '\p{	 in_GURMUKHI}', "");
    Expect(1, 2688, '\p{^	 in_GURMUKHI}', "");
    Expect(1, 2688, '\P{	 in_GURMUKHI}', "");
    Expect(0, 2688, '\P{^	 in_GURMUKHI}', "");
    Error('\p{	In_Gurmukhi:=}');
    Error('\P{	In_Gurmukhi:=}');
    Expect(1, 2687, '\p{ In_Gurmukhi}', "");
    Expect(0, 2687, '\p{^ In_Gurmukhi}', "");
    Expect(0, 2687, '\P{ In_Gurmukhi}', "");
    Expect(1, 2687, '\P{^ In_Gurmukhi}', "");
    Expect(0, 2688, '\p{ In_Gurmukhi}', "");
    Expect(1, 2688, '\p{^ In_Gurmukhi}', "");
    Expect(1, 2688, '\P{ In_Gurmukhi}', "");
    Expect(0, 2688, '\P{^ In_Gurmukhi}', "");
    Error('\p{	_IN_hanunoo:=}');
    Error('\P{	_IN_hanunoo:=}');
    Expect(1, 5951, '\p{inhanunoo}', "");
    Expect(0, 5951, '\p{^inhanunoo}', "");
    Expect(0, 5951, '\P{inhanunoo}', "");
    Expect(1, 5951, '\P{^inhanunoo}', "");
    Expect(0, 5952, '\p{inhanunoo}', "");
    Expect(1, 5952, '\p{^inhanunoo}', "");
    Expect(1, 5952, '\P{inhanunoo}', "");
    Expect(0, 5952, '\P{^inhanunoo}', "");
    Expect(1, 5951, '\p{-	In_Hanunoo}', "");
    Expect(0, 5951, '\p{^-	In_Hanunoo}', "");
    Expect(0, 5951, '\P{-	In_Hanunoo}', "");
    Expect(1, 5951, '\P{^-	In_Hanunoo}', "");
    Expect(0, 5952, '\p{-	In_Hanunoo}', "");
    Expect(1, 5952, '\p{^-	In_Hanunoo}', "");
    Expect(1, 5952, '\P{-	In_Hanunoo}', "");
    Expect(0, 5952, '\P{^-	In_Hanunoo}', "");
    Error('\p{	in_hanunoo:=}');
    Error('\P{	in_hanunoo:=}');
    Expect(1, 5951, '\p{__IN_HANUNOO}', "");
    Expect(0, 5951, '\p{^__IN_HANUNOO}', "");
    Expect(0, 5951, '\P{__IN_HANUNOO}', "");
    Expect(1, 5951, '\P{^__IN_HANUNOO}', "");
    Expect(0, 5952, '\p{__IN_HANUNOO}', "");
    Expect(1, 5952, '\p{^__IN_HANUNOO}', "");
    Expect(1, 5952, '\P{__IN_HANUNOO}', "");
    Expect(0, 5952, '\P{^__IN_HANUNOO}', "");
    Error('\p{_-IN_hatran:=}');
    Error('\P{_-IN_hatran:=}');
    Expect(1, 67839, '\p{inhatran}', "");
    Expect(0, 67839, '\p{^inhatran}', "");
    Expect(0, 67839, '\P{inhatran}', "");
    Expect(1, 67839, '\P{^inhatran}', "");
    Expect(0, 67840, '\p{inhatran}', "");
    Expect(1, 67840, '\p{^inhatran}', "");
    Expect(1, 67840, '\P{inhatran}', "");
    Expect(0, 67840, '\P{^inhatran}', "");
    Expect(1, 67839, '\p{-	In_Hatran}', "");
    Expect(0, 67839, '\p{^-	In_Hatran}', "");
    Expect(0, 67839, '\P{-	In_Hatran}', "");
    Expect(1, 67839, '\P{^-	In_Hatran}', "");
    Expect(0, 67840, '\p{-	In_Hatran}', "");
    Expect(1, 67840, '\p{^-	In_Hatran}', "");
    Expect(1, 67840, '\P{-	In_Hatran}', "");
    Expect(0, 67840, '\P{^-	In_Hatran}', "");
    Error('\p{:=	IN_Hatran}');
    Error('\P{:=	IN_Hatran}');
    Expect(1, 67839, '\p{	In_hatran}', "");
    Expect(0, 67839, '\p{^	In_hatran}', "");
    Expect(0, 67839, '\P{	In_hatran}', "");
    Expect(1, 67839, '\P{^	In_hatran}', "");
    Expect(0, 67840, '\p{	In_hatran}', "");
    Expect(1, 67840, '\p{^	In_hatran}', "");
    Expect(1, 67840, '\P{	In_hatran}', "");
    Expect(0, 67840, '\P{^	In_hatran}', "");
    Error('\p{_:=in_Hebrew}');
    Error('\P{_:=in_Hebrew}');
    Expect(1, 1535, '\p{inhebrew}', "");
    Expect(0, 1535, '\p{^inhebrew}', "");
    Expect(0, 1535, '\P{inhebrew}', "");
    Expect(1, 1535, '\P{^inhebrew}', "");
    Expect(0, 1536, '\p{inhebrew}', "");
    Expect(1, 1536, '\p{^inhebrew}', "");
    Expect(1, 1536, '\P{inhebrew}', "");
    Expect(0, 1536, '\P{^inhebrew}', "");
    Expect(1, 1535, '\p{-_In_Hebrew}', "");
    Expect(0, 1535, '\p{^-_In_Hebrew}', "");
    Expect(0, 1535, '\P{-_In_Hebrew}', "");
    Expect(1, 1535, '\P{^-_In_Hebrew}', "");
    Expect(0, 1536, '\p{-_In_Hebrew}', "");
    Expect(1, 1536, '\p{^-_In_Hebrew}', "");
    Expect(1, 1536, '\P{-_In_Hebrew}', "");
    Expect(0, 1536, '\P{^-_In_Hebrew}', "");
    Error('\p{-IN_hebrew/a/}');
    Error('\P{-IN_hebrew/a/}');
    Expect(1, 1535, '\p{_	IN_HEBREW}', "");
    Expect(0, 1535, '\p{^_	IN_HEBREW}', "");
    Expect(0, 1535, '\P{_	IN_HEBREW}', "");
    Expect(1, 1535, '\P{^_	IN_HEBREW}', "");
    Expect(0, 1536, '\p{_	IN_HEBREW}', "");
    Expect(1, 1536, '\p{^_	IN_HEBREW}', "");
    Expect(1, 1536, '\P{_	IN_HEBREW}', "");
    Expect(0, 1536, '\P{^_	IN_HEBREW}', "");
    Error('\p{_In_Hiragana:=}');
    Error('\P{_In_Hiragana:=}');
    Expect(1, 12447, '\p{inhiragana}', "");
    Expect(0, 12447, '\p{^inhiragana}', "");
    Expect(0, 12447, '\P{inhiragana}', "");
    Expect(1, 12447, '\P{^inhiragana}', "");
    Expect(0, 12448, '\p{inhiragana}', "");
    Expect(1, 12448, '\p{^inhiragana}', "");
    Expect(1, 12448, '\P{inhiragana}', "");
    Expect(0, 12448, '\P{^inhiragana}', "");
    Expect(1, 12447, '\p{	in_HIRAGANA}', "");
    Expect(0, 12447, '\p{^	in_HIRAGANA}', "");
    Expect(0, 12447, '\P{	in_HIRAGANA}', "");
    Expect(1, 12447, '\P{^	in_HIRAGANA}', "");
    Expect(0, 12448, '\p{	in_HIRAGANA}', "");
    Expect(1, 12448, '\p{^	in_HIRAGANA}', "");
    Expect(1, 12448, '\P{	in_HIRAGANA}', "");
    Expect(0, 12448, '\P{^	in_HIRAGANA}', "");
    Error('\p{	/a/in_HIRAGANA}');
    Error('\P{	/a/in_HIRAGANA}');
    Expect(1, 12447, '\p{	in_Hiragana}', "");
    Expect(0, 12447, '\p{^	in_Hiragana}', "");
    Expect(0, 12447, '\P{	in_Hiragana}', "");
    Expect(1, 12447, '\P{^	in_Hiragana}', "");
    Expect(0, 12448, '\p{	in_Hiragana}', "");
    Expect(1, 12448, '\p{^	in_Hiragana}', "");
    Expect(1, 12448, '\P{	in_Hiragana}', "");
    Expect(0, 12448, '\P{^	in_Hiragana}', "");
    Error('\p{_	in_IMPERIAL_ARAMAIC:=}');
    Error('\P{_	in_IMPERIAL_ARAMAIC:=}');
    Expect(1, 67679, '\p{inimperialaramaic}', "");
    Expect(0, 67679, '\p{^inimperialaramaic}', "");
    Expect(0, 67679, '\P{inimperialaramaic}', "");
    Expect(1, 67679, '\P{^inimperialaramaic}', "");
    Expect(0, 67680, '\p{inimperialaramaic}', "");
    Expect(1, 67680, '\p{^inimperialaramaic}', "");
    Expect(1, 67680, '\P{inimperialaramaic}', "");
    Expect(0, 67680, '\P{^inimperialaramaic}', "");
    Expect(1, 67679, '\p{		In_IMPERIAL_Aramaic}', "");
    Expect(0, 67679, '\p{^		In_IMPERIAL_Aramaic}', "");
    Expect(0, 67679, '\P{		In_IMPERIAL_Aramaic}', "");
    Expect(1, 67679, '\P{^		In_IMPERIAL_Aramaic}', "");
    Expect(0, 67680, '\p{		In_IMPERIAL_Aramaic}', "");
    Expect(1, 67680, '\p{^		In_IMPERIAL_Aramaic}', "");
    Expect(1, 67680, '\P{		In_IMPERIAL_Aramaic}', "");
    Expect(0, 67680, '\P{^		In_IMPERIAL_Aramaic}', "");
    Error('\p{/a/IN_IMPERIAL_aramaic}');
    Error('\P{/a/IN_IMPERIAL_aramaic}');
    Expect(1, 67679, '\p{ -in_IMPERIAL_Aramaic}', "");
    Expect(0, 67679, '\p{^ -in_IMPERIAL_Aramaic}', "");
    Expect(0, 67679, '\P{ -in_IMPERIAL_Aramaic}', "");
    Expect(1, 67679, '\P{^ -in_IMPERIAL_Aramaic}', "");
    Expect(0, 67680, '\p{ -in_IMPERIAL_Aramaic}', "");
    Expect(1, 67680, '\p{^ -in_IMPERIAL_Aramaic}', "");
    Expect(1, 67680, '\P{ -in_IMPERIAL_Aramaic}', "");
    Expect(0, 67680, '\P{^ -in_IMPERIAL_Aramaic}', "");
    Error('\p{	:=In_inscriptional_PAHLAVI}');
    Error('\P{	:=In_inscriptional_PAHLAVI}');
    Expect(1, 68479, '\p{ininscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^ininscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{ininscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^ininscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{ininscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^ininscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{ininscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^ininscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{	 In_inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\p{^	 In_inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\P{	 In_inscriptional_Pahlavi}', "");
    Expect(1, 68479, '\P{^	 In_inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\p{	 In_inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\p{^	 In_inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\P{	 In_inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\P{^	 In_inscriptional_Pahlavi}', "");
    Error('\p{ -In_INSCRIPTIONAL_PAHLAVI/a/}');
    Error('\P{ -In_INSCRIPTIONAL_PAHLAVI/a/}');
    Expect(1, 68479, '\p{ 	in_inscriptional_pahlavi}', "");
    Expect(0, 68479, '\p{^ 	in_inscriptional_pahlavi}', "");
    Expect(0, 68479, '\P{ 	in_inscriptional_pahlavi}', "");
    Expect(1, 68479, '\P{^ 	in_inscriptional_pahlavi}', "");
    Expect(0, 68480, '\p{ 	in_inscriptional_pahlavi}', "");
    Expect(1, 68480, '\p{^ 	in_inscriptional_pahlavi}', "");
    Expect(1, 68480, '\P{ 	in_inscriptional_pahlavi}', "");
    Expect(0, 68480, '\P{^ 	in_inscriptional_pahlavi}', "");
    Error('\p{:=_-IN_Inscriptional_Parthian}');
    Error('\P{:=_-IN_Inscriptional_Parthian}');
    Expect(1, 68447, '\p{ininscriptionalparthian}', "");
    Expect(0, 68447, '\p{^ininscriptionalparthian}', "");
    Expect(0, 68447, '\P{ininscriptionalparthian}', "");
    Expect(1, 68447, '\P{^ininscriptionalparthian}', "");
    Expect(0, 68448, '\p{ininscriptionalparthian}', "");
    Expect(1, 68448, '\p{^ininscriptionalparthian}', "");
    Expect(1, 68448, '\P{ininscriptionalparthian}', "");
    Expect(0, 68448, '\P{^ininscriptionalparthian}', "");
    Expect(1, 68447, '\p{-	in_Inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\p{^-	in_Inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\P{-	in_Inscriptional_PARTHIAN}', "");
    Expect(1, 68447, '\P{^-	in_Inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\p{-	in_Inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\p{^-	in_Inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\P{-	in_Inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\P{^-	in_Inscriptional_PARTHIAN}', "");
    Error('\p{	-IN_INSCRIPTIONAL_Parthian/a/}');
    Error('\P{	-IN_INSCRIPTIONAL_Parthian/a/}');
    Expect(1, 68447, '\p{	In_inscriptional_parthian}', "");
    Expect(0, 68447, '\p{^	In_inscriptional_parthian}', "");
    Expect(0, 68447, '\P{	In_inscriptional_parthian}', "");
    Expect(1, 68447, '\P{^	In_inscriptional_parthian}', "");
    Expect(0, 68448, '\p{	In_inscriptional_parthian}', "");
    Expect(1, 68448, '\p{^	In_inscriptional_parthian}', "");
    Expect(1, 68448, '\P{	In_inscriptional_parthian}', "");
    Expect(0, 68448, '\P{^	In_inscriptional_parthian}', "");
    Error('\p{_:=In_javanese}');
    Error('\P{_:=In_javanese}');
    Expect(1, 43487, '\p{injavanese}', "");
    Expect(0, 43487, '\p{^injavanese}', "");
    Expect(0, 43487, '\P{injavanese}', "");
    Expect(1, 43487, '\P{^injavanese}', "");
    Expect(0, 43488, '\p{injavanese}', "");
    Expect(1, 43488, '\p{^injavanese}', "");
    Expect(1, 43488, '\P{injavanese}', "");
    Expect(0, 43488, '\P{^injavanese}', "");
    Expect(1, 43487, '\p{ In_JAVANESE}', "");
    Expect(0, 43487, '\p{^ In_JAVANESE}', "");
    Expect(0, 43487, '\P{ In_JAVANESE}', "");
    Expect(1, 43487, '\P{^ In_JAVANESE}', "");
    Expect(0, 43488, '\p{ In_JAVANESE}', "");
    Expect(1, 43488, '\p{^ In_JAVANESE}', "");
    Expect(1, 43488, '\P{ In_JAVANESE}', "");
    Expect(0, 43488, '\P{^ In_JAVANESE}', "");
    Error('\p{	/a/in_Javanese}');
    Error('\P{	/a/in_Javanese}');
    Expect(1, 43487, '\p{ 	In_JAVANESE}', "");
    Expect(0, 43487, '\p{^ 	In_JAVANESE}', "");
    Expect(0, 43487, '\P{ 	In_JAVANESE}', "");
    Expect(1, 43487, '\P{^ 	In_JAVANESE}', "");
    Expect(0, 43488, '\p{ 	In_JAVANESE}', "");
    Expect(1, 43488, '\p{^ 	In_JAVANESE}', "");
    Expect(1, 43488, '\P{ 	In_JAVANESE}', "");
    Expect(0, 43488, '\P{^ 	In_JAVANESE}', "");
    Error('\p{		IN_Kaithi/a/}');
    Error('\P{		IN_Kaithi/a/}');
    Expect(1, 69839, '\p{inkaithi}', "");
    Expect(0, 69839, '\p{^inkaithi}', "");
    Expect(0, 69839, '\P{inkaithi}', "");
    Expect(1, 69839, '\P{^inkaithi}', "");
    Expect(0, 69840, '\p{inkaithi}', "");
    Expect(1, 69840, '\p{^inkaithi}', "");
    Expect(1, 69840, '\P{inkaithi}', "");
    Expect(0, 69840, '\P{^inkaithi}', "");
    Expect(1, 69839, '\p{	_in_kaithi}', "");
    Expect(0, 69839, '\p{^	_in_kaithi}', "");
    Expect(0, 69839, '\P{	_in_kaithi}', "");
    Expect(1, 69839, '\P{^	_in_kaithi}', "");
    Expect(0, 69840, '\p{	_in_kaithi}', "");
    Expect(1, 69840, '\p{^	_in_kaithi}', "");
    Expect(1, 69840, '\P{	_in_kaithi}', "");
    Expect(0, 69840, '\P{^	_in_kaithi}', "");
    Error('\p{:= in_kaithi}');
    Error('\P{:= in_kaithi}');
    Expect(1, 69839, '\p{-_IN_kaithi}', "");
    Expect(0, 69839, '\p{^-_IN_kaithi}', "");
    Expect(0, 69839, '\P{-_IN_kaithi}', "");
    Expect(1, 69839, '\P{^-_IN_kaithi}', "");
    Expect(0, 69840, '\p{-_IN_kaithi}', "");
    Expect(1, 69840, '\p{^-_IN_kaithi}', "");
    Expect(1, 69840, '\P{-_IN_kaithi}', "");
    Expect(0, 69840, '\P{^-_IN_kaithi}', "");
    Error('\p{_	in_Kannada:=}');
    Error('\P{_	in_Kannada:=}');
    Expect(1, 3327, '\p{inkannada}', "");
    Expect(0, 3327, '\p{^inkannada}', "");
    Expect(0, 3327, '\P{inkannada}', "");
    Expect(1, 3327, '\P{^inkannada}', "");
    Expect(0, 3328, '\p{inkannada}', "");
    Expect(1, 3328, '\p{^inkannada}', "");
    Expect(1, 3328, '\P{inkannada}', "");
    Expect(0, 3328, '\P{^inkannada}', "");
    Expect(1, 3327, '\p{_In_Kannada}', "");
    Expect(0, 3327, '\p{^_In_Kannada}', "");
    Expect(0, 3327, '\P{_In_Kannada}', "");
    Expect(1, 3327, '\P{^_In_Kannada}', "");
    Expect(0, 3328, '\p{_In_Kannada}', "");
    Expect(1, 3328, '\p{^_In_Kannada}', "");
    Expect(1, 3328, '\P{_In_Kannada}', "");
    Expect(0, 3328, '\P{^_In_Kannada}', "");
    Error('\p{:=_-In_Kannada}');
    Error('\P{:=_-In_Kannada}');
    Expect(1, 3327, '\p{--in_kannada}', "");
    Expect(0, 3327, '\p{^--in_kannada}', "");
    Expect(0, 3327, '\P{--in_kannada}', "");
    Expect(1, 3327, '\P{^--in_kannada}', "");
    Expect(0, 3328, '\p{--in_kannada}', "");
    Expect(1, 3328, '\p{^--in_kannada}', "");
    Expect(1, 3328, '\P{--in_kannada}', "");
    Expect(0, 3328, '\P{^--in_kannada}', "");
    Error('\p{_/a/In_katakana}');
    Error('\P{_/a/In_katakana}');
    Expect(1, 12543, '\p{inkatakana}', "");
    Expect(0, 12543, '\p{^inkatakana}', "");
    Expect(0, 12543, '\P{inkatakana}', "");
    Expect(1, 12543, '\P{^inkatakana}', "");
    Expect(0, 12544, '\p{inkatakana}', "");
    Expect(1, 12544, '\p{^inkatakana}', "");
    Expect(1, 12544, '\P{inkatakana}', "");
    Expect(0, 12544, '\P{^inkatakana}', "");
    Expect(1, 12543, '\p{	in_Katakana}', "");
    Expect(0, 12543, '\p{^	in_Katakana}', "");
    Expect(0, 12543, '\P{	in_Katakana}', "");
    Expect(1, 12543, '\P{^	in_Katakana}', "");
    Expect(0, 12544, '\p{	in_Katakana}', "");
    Expect(1, 12544, '\p{^	in_Katakana}', "");
    Expect(1, 12544, '\P{	in_Katakana}', "");
    Expect(0, 12544, '\P{^	in_Katakana}', "");
    Error('\p{ _In_KATAKANA:=}');
    Error('\P{ _In_KATAKANA:=}');
    Expect(1, 12543, '\p{ 	In_Katakana}', "");
    Expect(0, 12543, '\p{^ 	In_Katakana}', "");
    Expect(0, 12543, '\P{ 	In_Katakana}', "");
    Expect(1, 12543, '\P{^ 	In_Katakana}', "");
    Expect(0, 12544, '\p{ 	In_Katakana}', "");
    Expect(1, 12544, '\p{^ 	In_Katakana}', "");
    Expect(1, 12544, '\P{ 	In_Katakana}', "");
    Expect(0, 12544, '\P{^ 	In_Katakana}', "");
    Error('\p{_In_KAYAH_LI:=}');
    Error('\P{_In_KAYAH_LI:=}');
    Expect(1, 43311, '\p{inkayahli}', "");
    Expect(0, 43311, '\p{^inkayahli}', "");
    Expect(0, 43311, '\P{inkayahli}', "");
    Expect(1, 43311, '\P{^inkayahli}', "");
    Expect(0, 43312, '\p{inkayahli}', "");
    Expect(1, 43312, '\p{^inkayahli}', "");
    Expect(1, 43312, '\P{inkayahli}', "");
    Expect(0, 43312, '\P{^inkayahli}', "");
    Expect(1, 43311, '\p{	 In_Kayah_LI}', "");
    Expect(0, 43311, '\p{^	 In_Kayah_LI}', "");
    Expect(0, 43311, '\P{	 In_Kayah_LI}', "");
    Expect(1, 43311, '\P{^	 In_Kayah_LI}', "");
    Expect(0, 43312, '\p{	 In_Kayah_LI}', "");
    Expect(1, 43312, '\p{^	 In_Kayah_LI}', "");
    Expect(1, 43312, '\P{	 In_Kayah_LI}', "");
    Expect(0, 43312, '\P{^	 In_Kayah_LI}', "");
    Error('\p{/a/ _IN_kayah_Li}');
    Error('\P{/a/ _IN_kayah_Li}');
    Expect(1, 43311, '\p{_In_Kayah_Li}', "");
    Expect(0, 43311, '\p{^_In_Kayah_Li}', "");
    Expect(0, 43311, '\P{_In_Kayah_Li}', "");
    Expect(1, 43311, '\P{^_In_Kayah_Li}', "");
    Expect(0, 43312, '\p{_In_Kayah_Li}', "");
    Expect(1, 43312, '\p{^_In_Kayah_Li}', "");
    Expect(1, 43312, '\P{_In_Kayah_Li}', "");
    Expect(0, 43312, '\P{^_In_Kayah_Li}', "");
    Error('\p{		IN_KHAROSHTHI/a/}');
    Error('\P{		IN_KHAROSHTHI/a/}');
    Expect(1, 68191, '\p{inkharoshthi}', "");
    Expect(0, 68191, '\p{^inkharoshthi}', "");
    Expect(0, 68191, '\P{inkharoshthi}', "");
    Expect(1, 68191, '\P{^inkharoshthi}', "");
    Expect(0, 68192, '\p{inkharoshthi}', "");
    Expect(1, 68192, '\p{^inkharoshthi}', "");
    Expect(1, 68192, '\P{inkharoshthi}', "");
    Expect(0, 68192, '\P{^inkharoshthi}', "");
    Expect(1, 68191, '\p{_in_kharoshthi}', "");
    Expect(0, 68191, '\p{^_in_kharoshthi}', "");
    Expect(0, 68191, '\P{_in_kharoshthi}', "");
    Expect(1, 68191, '\P{^_in_kharoshthi}', "");
    Expect(0, 68192, '\p{_in_kharoshthi}', "");
    Expect(1, 68192, '\p{^_in_kharoshthi}', "");
    Expect(1, 68192, '\P{_in_kharoshthi}', "");
    Expect(0, 68192, '\P{^_in_kharoshthi}', "");
    Error('\p{/a/In_Kharoshthi}');
    Error('\P{/a/In_Kharoshthi}');
    Expect(1, 68191, '\p{ IN_kharoshthi}', "");
    Expect(0, 68191, '\p{^ IN_kharoshthi}', "");
    Expect(0, 68191, '\P{ IN_kharoshthi}', "");
    Expect(1, 68191, '\P{^ IN_kharoshthi}', "");
    Expect(0, 68192, '\p{ IN_kharoshthi}', "");
    Expect(1, 68192, '\p{^ IN_kharoshthi}', "");
    Expect(1, 68192, '\P{ IN_kharoshthi}', "");
    Expect(0, 68192, '\P{^ IN_kharoshthi}', "");
    Error('\p{:=	In_Khmer}');
    Error('\P{:=	In_Khmer}');
    Expect(1, 6143, '\p{inkhmer}', "");
    Expect(0, 6143, '\p{^inkhmer}', "");
    Expect(0, 6143, '\P{inkhmer}', "");
    Expect(1, 6143, '\P{^inkhmer}', "");
    Expect(0, 6144, '\p{inkhmer}', "");
    Expect(1, 6144, '\p{^inkhmer}', "");
    Expect(1, 6144, '\P{inkhmer}', "");
    Expect(0, 6144, '\P{^inkhmer}', "");
    Expect(1, 6143, '\p{ In_khmer}', "");
    Expect(0, 6143, '\p{^ In_khmer}', "");
    Expect(0, 6143, '\P{ In_khmer}', "");
    Expect(1, 6143, '\P{^ In_khmer}', "");
    Expect(0, 6144, '\p{ In_khmer}', "");
    Expect(1, 6144, '\p{^ In_khmer}', "");
    Expect(1, 6144, '\P{ In_khmer}', "");
    Expect(0, 6144, '\P{^ In_khmer}', "");
    Error('\p{/a/_ In_Khmer}');
    Error('\P{/a/_ In_Khmer}');
    Expect(1, 6143, '\p{		IN_KHMER}', "");
    Expect(0, 6143, '\p{^		IN_KHMER}', "");
    Expect(0, 6143, '\P{		IN_KHMER}', "");
    Expect(1, 6143, '\P{^		IN_KHMER}', "");
    Expect(0, 6144, '\p{		IN_KHMER}', "");
    Expect(1, 6144, '\p{^		IN_KHMER}', "");
    Expect(1, 6144, '\P{		IN_KHMER}', "");
    Expect(0, 6144, '\P{^		IN_KHMER}', "");
    Error('\p{ /a/IN_khojki}');
    Error('\P{ /a/IN_khojki}');
    Expect(1, 70223, '\p{inkhojki}', "");
    Expect(0, 70223, '\p{^inkhojki}', "");
    Expect(0, 70223, '\P{inkhojki}', "");
    Expect(1, 70223, '\P{^inkhojki}', "");
    Expect(0, 70224, '\p{inkhojki}', "");
    Expect(1, 70224, '\p{^inkhojki}', "");
    Expect(1, 70224, '\P{inkhojki}', "");
    Expect(0, 70224, '\P{^inkhojki}', "");
    Expect(1, 70223, '\p{_-IN_KHOJKI}', "");
    Expect(0, 70223, '\p{^_-IN_KHOJKI}', "");
    Expect(0, 70223, '\P{_-IN_KHOJKI}', "");
    Expect(1, 70223, '\P{^_-IN_KHOJKI}', "");
    Expect(0, 70224, '\p{_-IN_KHOJKI}', "");
    Expect(1, 70224, '\p{^_-IN_KHOJKI}', "");
    Expect(1, 70224, '\P{_-IN_KHOJKI}', "");
    Expect(0, 70224, '\P{^_-IN_KHOJKI}', "");
    Error('\p{_:=In_Khojki}');
    Error('\P{_:=In_Khojki}');
    Expect(1, 70223, '\p{		IN_Khojki}', "");
    Expect(0, 70223, '\p{^		IN_Khojki}', "");
    Expect(0, 70223, '\P{		IN_Khojki}', "");
    Expect(1, 70223, '\P{^		IN_Khojki}', "");
    Expect(0, 70224, '\p{		IN_Khojki}', "");
    Expect(1, 70224, '\p{^		IN_Khojki}', "");
    Expect(1, 70224, '\P{		IN_Khojki}', "");
    Expect(0, 70224, '\P{^		IN_Khojki}', "");
    Error('\p{/a/ 	In_khudawadi}');
    Error('\P{/a/ 	In_khudawadi}');
    Expect(1, 70399, '\p{inkhudawadi}', "");
    Expect(0, 70399, '\p{^inkhudawadi}', "");
    Expect(0, 70399, '\P{inkhudawadi}', "");
    Expect(1, 70399, '\P{^inkhudawadi}', "");
    Expect(0, 70400, '\p{inkhudawadi}', "");
    Expect(1, 70400, '\p{^inkhudawadi}', "");
    Expect(1, 70400, '\P{inkhudawadi}', "");
    Expect(0, 70400, '\P{^inkhudawadi}', "");
    Expect(1, 70399, '\p{- In_khudawadi}', "");
    Expect(0, 70399, '\p{^- In_khudawadi}', "");
    Expect(0, 70399, '\P{- In_khudawadi}', "");
    Expect(1, 70399, '\P{^- In_khudawadi}', "");
    Expect(0, 70400, '\p{- In_khudawadi}', "");
    Expect(1, 70400, '\p{^- In_khudawadi}', "");
    Expect(1, 70400, '\P{- In_khudawadi}', "");
    Expect(0, 70400, '\P{^- In_khudawadi}', "");
    Error('\p{:=in_KHUDAWADI}');
    Error('\P{:=in_KHUDAWADI}');
    Expect(1, 70399, '\p{_	In_Khudawadi}', "");
    Expect(0, 70399, '\p{^_	In_Khudawadi}', "");
    Expect(0, 70399, '\P{_	In_Khudawadi}', "");
    Expect(1, 70399, '\P{^_	In_Khudawadi}', "");
    Expect(0, 70400, '\p{_	In_Khudawadi}', "");
    Expect(1, 70400, '\p{^_	In_Khudawadi}', "");
    Expect(1, 70400, '\P{_	In_Khudawadi}', "");
    Expect(0, 70400, '\P{^_	In_Khudawadi}', "");
    Error('\p{_In_Lao/a/}');
    Error('\P{_In_Lao/a/}');
    Expect(1, 3839, '\p{inlao}', "");
    Expect(0, 3839, '\p{^inlao}', "");
    Expect(0, 3839, '\P{inlao}', "");
    Expect(1, 3839, '\P{^inlao}', "");
    Expect(0, 3840, '\p{inlao}', "");
    Expect(1, 3840, '\p{^inlao}', "");
    Expect(1, 3840, '\P{inlao}', "");
    Expect(0, 3840, '\P{^inlao}', "");
    Expect(1, 3839, '\p{ In_Lao}', "");
    Expect(0, 3839, '\p{^ In_Lao}', "");
    Expect(0, 3839, '\P{ In_Lao}', "");
    Expect(1, 3839, '\P{^ In_Lao}', "");
    Expect(0, 3840, '\p{ In_Lao}', "");
    Expect(1, 3840, '\p{^ In_Lao}', "");
    Expect(1, 3840, '\P{ In_Lao}', "");
    Expect(0, 3840, '\P{^ In_Lao}', "");
    Error('\p{ 	In_LAO/a/}');
    Error('\P{ 	In_LAO/a/}');
    Expect(1, 3839, '\p{		In_lao}', "");
    Expect(0, 3839, '\p{^		In_lao}', "");
    Expect(0, 3839, '\P{		In_lao}', "");
    Expect(1, 3839, '\P{^		In_lao}', "");
    Expect(0, 3840, '\p{		In_lao}', "");
    Expect(1, 3840, '\p{^		In_lao}', "");
    Expect(1, 3840, '\P{		In_lao}', "");
    Expect(0, 3840, '\P{^		In_lao}', "");
    Error('\p{/a/-_In_Lepcha}');
    Error('\P{/a/-_In_Lepcha}');
    Expect(1, 7247, '\p{inlepcha}', "");
    Expect(0, 7247, '\p{^inlepcha}', "");
    Expect(0, 7247, '\P{inlepcha}', "");
    Expect(1, 7247, '\P{^inlepcha}', "");
    Expect(0, 7248, '\p{inlepcha}', "");
    Expect(1, 7248, '\p{^inlepcha}', "");
    Expect(1, 7248, '\P{inlepcha}', "");
    Expect(0, 7248, '\P{^inlepcha}', "");
    Expect(1, 7247, '\p{	-In_Lepcha}', "");
    Expect(0, 7247, '\p{^	-In_Lepcha}', "");
    Expect(0, 7247, '\P{	-In_Lepcha}', "");
    Expect(1, 7247, '\P{^	-In_Lepcha}', "");
    Expect(0, 7248, '\p{	-In_Lepcha}', "");
    Expect(1, 7248, '\p{^	-In_Lepcha}', "");
    Expect(1, 7248, '\P{	-In_Lepcha}', "");
    Expect(0, 7248, '\P{^	-In_Lepcha}', "");
    Error('\p{ IN_LEPCHA/a/}');
    Error('\P{ IN_LEPCHA/a/}');
    Expect(1, 7247, '\p{_-In_lepcha}', "");
    Expect(0, 7247, '\p{^_-In_lepcha}', "");
    Expect(0, 7247, '\P{_-In_lepcha}', "");
    Expect(1, 7247, '\P{^_-In_lepcha}', "");
    Expect(0, 7248, '\p{_-In_lepcha}', "");
    Expect(1, 7248, '\p{^_-In_lepcha}', "");
    Expect(1, 7248, '\P{_-In_lepcha}', "");
    Expect(0, 7248, '\P{^_-In_lepcha}', "");
    Error('\p{:=	_in_Limbu}');
    Error('\P{:=	_in_Limbu}');
    Expect(1, 6479, '\p{inlimbu}', "");
    Expect(0, 6479, '\p{^inlimbu}', "");
    Expect(0, 6479, '\P{inlimbu}', "");
    Expect(1, 6479, '\P{^inlimbu}', "");
    Expect(0, 6480, '\p{inlimbu}', "");
    Expect(1, 6480, '\p{^inlimbu}', "");
    Expect(1, 6480, '\P{inlimbu}', "");
    Expect(0, 6480, '\P{^inlimbu}', "");
    Expect(1, 6479, '\p{	-IN_LIMBU}', "");
    Expect(0, 6479, '\p{^	-IN_LIMBU}', "");
    Expect(0, 6479, '\P{	-IN_LIMBU}', "");
    Expect(1, 6479, '\P{^	-IN_LIMBU}', "");
    Expect(0, 6480, '\p{	-IN_LIMBU}', "");
    Expect(1, 6480, '\p{^	-IN_LIMBU}', "");
    Expect(1, 6480, '\P{	-IN_LIMBU}', "");
    Expect(0, 6480, '\P{^	-IN_LIMBU}', "");
    Error('\p{:=_-In_Limbu}');
    Error('\P{:=_-In_Limbu}');
    Expect(1, 6479, '\p{_-in_LIMBU}', "");
    Expect(0, 6479, '\p{^_-in_LIMBU}', "");
    Expect(0, 6479, '\P{_-in_LIMBU}', "");
    Expect(1, 6479, '\P{^_-in_LIMBU}', "");
    Expect(0, 6480, '\p{_-in_LIMBU}', "");
    Expect(1, 6480, '\p{^_-in_LIMBU}', "");
    Expect(1, 6480, '\P{_-in_LIMBU}', "");
    Expect(0, 6480, '\P{^_-in_LIMBU}', "");
    Error('\p{_	In_Linear_A/a/}');
    Error('\P{_	In_Linear_A/a/}');
    Expect(1, 67455, '\p{inlineara}', "");
    Expect(0, 67455, '\p{^inlineara}', "");
    Expect(0, 67455, '\P{inlineara}', "");
    Expect(1, 67455, '\P{^inlineara}', "");
    Expect(0, 67456, '\p{inlineara}', "");
    Expect(1, 67456, '\p{^inlineara}', "");
    Expect(1, 67456, '\P{inlineara}', "");
    Expect(0, 67456, '\P{^inlineara}', "");
    Expect(1, 67455, '\p{ In_linear_A}', "");
    Expect(0, 67455, '\p{^ In_linear_A}', "");
    Expect(0, 67455, '\P{ In_linear_A}', "");
    Expect(1, 67455, '\P{^ In_linear_A}', "");
    Expect(0, 67456, '\p{ In_linear_A}', "");
    Expect(1, 67456, '\p{^ In_linear_A}', "");
    Expect(1, 67456, '\P{ In_linear_A}', "");
    Expect(0, 67456, '\P{^ In_linear_A}', "");
    Error('\p{-In_Linear_A:=}');
    Error('\P{-In_Linear_A:=}');
    Expect(1, 67455, '\p{__in_Linear_a}', "");
    Expect(0, 67455, '\p{^__in_Linear_a}', "");
    Expect(0, 67455, '\P{__in_Linear_a}', "");
    Expect(1, 67455, '\P{^__in_Linear_a}', "");
    Expect(0, 67456, '\p{__in_Linear_a}', "");
    Expect(1, 67456, '\p{^__in_Linear_a}', "");
    Expect(1, 67456, '\P{__in_Linear_a}', "");
    Expect(0, 67456, '\P{^__in_Linear_a}', "");
    Error('\p{:=_In_Lisu}');
    Error('\P{:=_In_Lisu}');
    Expect(1, 42239, '\p{inlisu}', "");
    Expect(0, 42239, '\p{^inlisu}', "");
    Expect(0, 42239, '\P{inlisu}', "");
    Expect(1, 42239, '\P{^inlisu}', "");
    Expect(0, 42240, '\p{inlisu}', "");
    Expect(1, 42240, '\p{^inlisu}', "");
    Expect(1, 42240, '\P{inlisu}', "");
    Expect(0, 42240, '\P{^inlisu}', "");
    Expect(1, 42239, '\p{	IN_lisu}', "");
    Expect(0, 42239, '\p{^	IN_lisu}', "");
    Expect(0, 42239, '\P{	IN_lisu}', "");
    Expect(1, 42239, '\P{^	IN_lisu}', "");
    Expect(0, 42240, '\p{	IN_lisu}', "");
    Expect(1, 42240, '\p{^	IN_lisu}', "");
    Expect(1, 42240, '\P{	IN_lisu}', "");
    Expect(0, 42240, '\P{^	IN_lisu}', "");
    Error('\p{:= 	IN_lisu}');
    Error('\P{:= 	IN_lisu}');
    Expect(1, 42239, '\p{- In_LISU}', "");
    Expect(0, 42239, '\p{^- In_LISU}', "");
    Expect(0, 42239, '\P{- In_LISU}', "");
    Expect(1, 42239, '\P{^- In_LISU}', "");
    Expect(0, 42240, '\p{- In_LISU}', "");
    Expect(1, 42240, '\p{^- In_LISU}', "");
    Expect(1, 42240, '\P{- In_LISU}', "");
    Expect(0, 42240, '\P{^- In_LISU}', "");
    Error('\p{/a/_	In_Lycian}');
    Error('\P{/a/_	In_Lycian}');
    Expect(1, 66207, '\p{inlycian}', "");
    Expect(0, 66207, '\p{^inlycian}', "");
    Expect(0, 66207, '\P{inlycian}', "");
    Expect(1, 66207, '\P{^inlycian}', "");
    Expect(0, 66208, '\p{inlycian}', "");
    Expect(1, 66208, '\p{^inlycian}', "");
    Expect(1, 66208, '\P{inlycian}', "");
    Expect(0, 66208, '\P{^inlycian}', "");
    Expect(1, 66207, '\p{	In_LYCIAN}', "");
    Expect(0, 66207, '\p{^	In_LYCIAN}', "");
    Expect(0, 66207, '\P{	In_LYCIAN}', "");
    Expect(1, 66207, '\P{^	In_LYCIAN}', "");
    Expect(0, 66208, '\p{	In_LYCIAN}', "");
    Expect(1, 66208, '\p{^	In_LYCIAN}', "");
    Expect(1, 66208, '\P{	In_LYCIAN}', "");
    Expect(0, 66208, '\P{^	In_LYCIAN}', "");
    Error('\p{_:=In_LYCIAN}');
    Error('\P{_:=In_LYCIAN}');
    Expect(1, 66207, '\p{ in_Lycian}', "");
    Expect(0, 66207, '\p{^ in_Lycian}', "");
    Expect(0, 66207, '\P{ in_Lycian}', "");
    Expect(1, 66207, '\P{^ in_Lycian}', "");
    Expect(0, 66208, '\p{ in_Lycian}', "");
    Expect(1, 66208, '\p{^ in_Lycian}', "");
    Expect(1, 66208, '\P{ in_Lycian}', "");
    Expect(0, 66208, '\P{^ in_Lycian}', "");
    Error('\p{In_lydian:=}');
    Error('\P{In_lydian:=}');
    Expect(1, 67903, '\p{inlydian}', "");
    Expect(0, 67903, '\p{^inlydian}', "");
    Expect(0, 67903, '\P{inlydian}', "");
    Expect(1, 67903, '\P{^inlydian}', "");
    Expect(0, 67904, '\p{inlydian}', "");
    Expect(1, 67904, '\p{^inlydian}', "");
    Expect(1, 67904, '\P{inlydian}', "");
    Expect(0, 67904, '\P{^inlydian}', "");
    Expect(1, 67903, '\p{-In_Lydian}', "");
    Expect(0, 67903, '\p{^-In_Lydian}', "");
    Expect(0, 67903, '\P{-In_Lydian}', "");
    Expect(1, 67903, '\P{^-In_Lydian}', "");
    Expect(0, 67904, '\p{-In_Lydian}', "");
    Expect(1, 67904, '\p{^-In_Lydian}', "");
    Expect(1, 67904, '\P{-In_Lydian}', "");
    Expect(0, 67904, '\P{^-In_Lydian}', "");
    Error('\p{_-IN_LYDIAN:=}');
    Error('\P{_-IN_LYDIAN:=}');
    Expect(1, 67903, '\p{	 In_LYDIAN}', "");
    Expect(0, 67903, '\p{^	 In_LYDIAN}', "");
    Expect(0, 67903, '\P{	 In_LYDIAN}', "");
    Expect(1, 67903, '\P{^	 In_LYDIAN}', "");
    Expect(0, 67904, '\p{	 In_LYDIAN}', "");
    Expect(1, 67904, '\p{^	 In_LYDIAN}', "");
    Expect(1, 67904, '\P{	 In_LYDIAN}', "");
    Expect(0, 67904, '\P{^	 In_LYDIAN}', "");
    Error('\p{:=  in_Mahajani}');
    Error('\P{:=  in_Mahajani}');
    Expect(1, 70015, '\p{inmahajani}', "");
    Expect(0, 70015, '\p{^inmahajani}', "");
    Expect(0, 70015, '\P{inmahajani}', "");
    Expect(1, 70015, '\P{^inmahajani}', "");
    Expect(0, 70016, '\p{inmahajani}', "");
    Expect(1, 70016, '\p{^inmahajani}', "");
    Expect(1, 70016, '\P{inmahajani}', "");
    Expect(0, 70016, '\P{^inmahajani}', "");
    Expect(1, 70015, '\p{ _IN_Mahajani}', "");
    Expect(0, 70015, '\p{^ _IN_Mahajani}', "");
    Expect(0, 70015, '\P{ _IN_Mahajani}', "");
    Expect(1, 70015, '\P{^ _IN_Mahajani}', "");
    Expect(0, 70016, '\p{ _IN_Mahajani}', "");
    Expect(1, 70016, '\p{^ _IN_Mahajani}', "");
    Expect(1, 70016, '\P{ _IN_Mahajani}', "");
    Expect(0, 70016, '\P{^ _IN_Mahajani}', "");
    Error('\p{/a/	In_Mahajani}');
    Error('\P{/a/	In_Mahajani}');
    Expect(1, 70015, '\p{- In_Mahajani}', "");
    Expect(0, 70015, '\p{^- In_Mahajani}', "");
    Expect(0, 70015, '\P{- In_Mahajani}', "");
    Expect(1, 70015, '\P{^- In_Mahajani}', "");
    Expect(0, 70016, '\p{- In_Mahajani}', "");
    Expect(1, 70016, '\p{^- In_Mahajani}', "");
    Expect(1, 70016, '\P{- In_Mahajani}', "");
    Expect(0, 70016, '\P{^- In_Mahajani}', "");
    Error('\p{-/a/In_Malayalam}');
    Error('\P{-/a/In_Malayalam}');
    Expect(1, 3455, '\p{inmalayalam}', "");
    Expect(0, 3455, '\p{^inmalayalam}', "");
    Expect(0, 3455, '\P{inmalayalam}', "");
    Expect(1, 3455, '\P{^inmalayalam}', "");
    Expect(0, 3456, '\p{inmalayalam}', "");
    Expect(1, 3456, '\p{^inmalayalam}', "");
    Expect(1, 3456, '\P{inmalayalam}', "");
    Expect(0, 3456, '\P{^inmalayalam}', "");
    Expect(1, 3455, '\p{	_in_malayalam}', "");
    Expect(0, 3455, '\p{^	_in_malayalam}', "");
    Expect(0, 3455, '\P{	_in_malayalam}', "");
    Expect(1, 3455, '\P{^	_in_malayalam}', "");
    Expect(0, 3456, '\p{	_in_malayalam}', "");
    Expect(1, 3456, '\p{^	_in_malayalam}', "");
    Expect(1, 3456, '\P{	_in_malayalam}', "");
    Expect(0, 3456, '\P{^	_in_malayalam}', "");
    Error('\p{ IN_Malayalam:=}');
    Error('\P{ IN_Malayalam:=}');
    Expect(1, 3455, '\p{-	In_Malayalam}', "");
    Expect(0, 3455, '\p{^-	In_Malayalam}', "");
    Expect(0, 3455, '\P{-	In_Malayalam}', "");
    Expect(1, 3455, '\P{^-	In_Malayalam}', "");
    Expect(0, 3456, '\p{-	In_Malayalam}', "");
    Expect(1, 3456, '\p{^-	In_Malayalam}', "");
    Expect(1, 3456, '\P{-	In_Malayalam}', "");
    Expect(0, 3456, '\P{^-	In_Malayalam}', "");
    Error('\p{_	in_MANDAIC:=}');
    Error('\P{_	in_MANDAIC:=}');
    Expect(1, 2143, '\p{inmandaic}', "");
    Expect(0, 2143, '\p{^inmandaic}', "");
    Expect(0, 2143, '\P{inmandaic}', "");
    Expect(1, 2143, '\P{^inmandaic}', "");
    Expect(0, 2144, '\p{inmandaic}', "");
    Expect(1, 2144, '\p{^inmandaic}', "");
    Expect(1, 2144, '\P{inmandaic}', "");
    Expect(0, 2144, '\P{^inmandaic}', "");
    Expect(1, 2143, '\p{	_In_Mandaic}', "");
    Expect(0, 2143, '\p{^	_In_Mandaic}', "");
    Expect(0, 2143, '\P{	_In_Mandaic}', "");
    Expect(1, 2143, '\P{^	_In_Mandaic}', "");
    Expect(0, 2144, '\p{	_In_Mandaic}', "");
    Expect(1, 2144, '\p{^	_In_Mandaic}', "");
    Expect(1, 2144, '\P{	_In_Mandaic}', "");
    Expect(0, 2144, '\P{^	_In_Mandaic}', "");
    Error('\p{ -IN_Mandaic/a/}');
    Error('\P{ -IN_Mandaic/a/}');
    Expect(1, 2143, '\p{_ In_Mandaic}', "");
    Expect(0, 2143, '\p{^_ In_Mandaic}', "");
    Expect(0, 2143, '\P{_ In_Mandaic}', "");
    Expect(1, 2143, '\P{^_ In_Mandaic}', "");
    Expect(0, 2144, '\p{_ In_Mandaic}', "");
    Expect(1, 2144, '\p{^_ In_Mandaic}', "");
    Expect(1, 2144, '\P{_ In_Mandaic}', "");
    Expect(0, 2144, '\P{^_ In_Mandaic}', "");
    Error('\p{ -in_Manichaean:=}');
    Error('\P{ -in_Manichaean:=}');
    Expect(1, 68351, '\p{inmanichaean}', "");
    Expect(0, 68351, '\p{^inmanichaean}', "");
    Expect(0, 68351, '\P{inmanichaean}', "");
    Expect(1, 68351, '\P{^inmanichaean}', "");
    Expect(0, 68352, '\p{inmanichaean}', "");
    Expect(1, 68352, '\p{^inmanichaean}', "");
    Expect(1, 68352, '\P{inmanichaean}', "");
    Expect(0, 68352, '\P{^inmanichaean}', "");
    Expect(1, 68351, '\p{_	In_manichaean}', "");
    Expect(0, 68351, '\p{^_	In_manichaean}', "");
    Expect(0, 68351, '\P{_	In_manichaean}', "");
    Expect(1, 68351, '\P{^_	In_manichaean}', "");
    Expect(0, 68352, '\p{_	In_manichaean}', "");
    Expect(1, 68352, '\p{^_	In_manichaean}', "");
    Expect(1, 68352, '\P{_	In_manichaean}', "");
    Expect(0, 68352, '\P{^_	In_manichaean}', "");
    Error('\p{:=IN_Manichaean}');
    Error('\P{:=IN_Manichaean}');
    Expect(1, 68351, '\p{	 In_MANICHAEAN}', "");
    Expect(0, 68351, '\p{^	 In_MANICHAEAN}', "");
    Expect(0, 68351, '\P{	 In_MANICHAEAN}', "");
    Expect(1, 68351, '\P{^	 In_MANICHAEAN}', "");
    Expect(0, 68352, '\p{	 In_MANICHAEAN}', "");
    Expect(1, 68352, '\p{^	 In_MANICHAEAN}', "");
    Expect(1, 68352, '\P{	 In_MANICHAEAN}', "");
    Expect(0, 68352, '\P{^	 In_MANICHAEAN}', "");
    Error('\p{ In_MARCHEN:=}');
    Error('\P{ In_MARCHEN:=}');
    Expect(1, 72895, '\p{inmarchen}', "");
    Expect(0, 72895, '\p{^inmarchen}', "");
    Expect(0, 72895, '\P{inmarchen}', "");
    Expect(1, 72895, '\P{^inmarchen}', "");
    Expect(0, 72896, '\p{inmarchen}', "");
    Expect(1, 72896, '\p{^inmarchen}', "");
    Expect(1, 72896, '\P{inmarchen}', "");
    Expect(0, 72896, '\P{^inmarchen}', "");
    Expect(1, 72895, '\p{_	In_MARCHEN}', "");
    Expect(0, 72895, '\p{^_	In_MARCHEN}', "");
    Expect(0, 72895, '\P{_	In_MARCHEN}', "");
    Expect(1, 72895, '\P{^_	In_MARCHEN}', "");
    Expect(0, 72896, '\p{_	In_MARCHEN}', "");
    Expect(1, 72896, '\p{^_	In_MARCHEN}', "");
    Expect(1, 72896, '\P{_	In_MARCHEN}', "");
    Expect(0, 72896, '\P{^_	In_MARCHEN}', "");
    Error('\p{ _In_Marchen/a/}');
    Error('\P{ _In_Marchen/a/}');
    Expect(1, 72895, '\p{		In_MARCHEN}', "");
    Expect(0, 72895, '\p{^		In_MARCHEN}', "");
    Expect(0, 72895, '\P{		In_MARCHEN}', "");
    Expect(1, 72895, '\P{^		In_MARCHEN}', "");
    Expect(0, 72896, '\p{		In_MARCHEN}', "");
    Expect(1, 72896, '\p{^		In_MARCHEN}', "");
    Expect(1, 72896, '\P{		In_MARCHEN}', "");
    Expect(0, 72896, '\P{^		In_MARCHEN}', "");
    Error('\p{/a/	-In_MASARAM_Gondi}');
    Error('\P{/a/	-In_MASARAM_Gondi}');
    Expect(1, 73055, '\p{inmasaramgondi}', "");
    Expect(0, 73055, '\p{^inmasaramgondi}', "");
    Expect(0, 73055, '\P{inmasaramgondi}', "");
    Expect(1, 73055, '\P{^inmasaramgondi}', "");
    Expect(0, 73056, '\p{inmasaramgondi}', "");
    Expect(1, 73056, '\p{^inmasaramgondi}', "");
    Expect(1, 73056, '\P{inmasaramgondi}', "");
    Expect(0, 73056, '\P{^inmasaramgondi}', "");
    Expect(1, 73055, '\p{		IN_Masaram_gondi}', "");
    Expect(0, 73055, '\p{^		IN_Masaram_gondi}', "");
    Expect(0, 73055, '\P{		IN_Masaram_gondi}', "");
    Expect(1, 73055, '\P{^		IN_Masaram_gondi}', "");
    Expect(0, 73056, '\p{		IN_Masaram_gondi}', "");
    Expect(1, 73056, '\p{^		IN_Masaram_gondi}', "");
    Expect(1, 73056, '\P{		IN_Masaram_gondi}', "");
    Expect(0, 73056, '\P{^		IN_Masaram_gondi}', "");
    Error('\p{ IN_Masaram_gondi:=}');
    Error('\P{ IN_Masaram_gondi:=}');
    Expect(1, 73055, '\p{ 	IN_MASARAM_gondi}', "");
    Expect(0, 73055, '\p{^ 	IN_MASARAM_gondi}', "");
    Expect(0, 73055, '\P{ 	IN_MASARAM_gondi}', "");
    Expect(1, 73055, '\P{^ 	IN_MASARAM_gondi}', "");
    Expect(0, 73056, '\p{ 	IN_MASARAM_gondi}', "");
    Expect(1, 73056, '\p{^ 	IN_MASARAM_gondi}', "");
    Expect(1, 73056, '\P{ 	IN_MASARAM_gondi}', "");
    Expect(0, 73056, '\P{^ 	IN_MASARAM_gondi}', "");
    Error('\p{:= In_Meetei_Mayek}');
    Error('\P{:= In_Meetei_Mayek}');
    Expect(1, 44031, '\p{inmeeteimayek}', "");
    Expect(0, 44031, '\p{^inmeeteimayek}', "");
    Expect(0, 44031, '\P{inmeeteimayek}', "");
    Expect(1, 44031, '\P{^inmeeteimayek}', "");
    Expect(0, 44032, '\p{inmeeteimayek}', "");
    Expect(1, 44032, '\p{^inmeeteimayek}', "");
    Expect(1, 44032, '\P{inmeeteimayek}', "");
    Expect(0, 44032, '\P{^inmeeteimayek}', "");
    Expect(1, 44031, '\p{		in_MEETEI_mayek}', "");
    Expect(0, 44031, '\p{^		in_MEETEI_mayek}', "");
    Expect(0, 44031, '\P{		in_MEETEI_mayek}', "");
    Expect(1, 44031, '\P{^		in_MEETEI_mayek}', "");
    Expect(0, 44032, '\p{		in_MEETEI_mayek}', "");
    Expect(1, 44032, '\p{^		in_MEETEI_mayek}', "");
    Expect(1, 44032, '\P{		in_MEETEI_mayek}', "");
    Expect(0, 44032, '\P{^		in_MEETEI_mayek}', "");
    Error('\p{/a/IN_MEETEI_mayek}');
    Error('\P{/a/IN_MEETEI_mayek}');
    Expect(1, 44031, '\p{-	In_meetei_mayek}', "");
    Expect(0, 44031, '\p{^-	In_meetei_mayek}', "");
    Expect(0, 44031, '\P{-	In_meetei_mayek}', "");
    Expect(1, 44031, '\P{^-	In_meetei_mayek}', "");
    Expect(0, 44032, '\p{-	In_meetei_mayek}', "");
    Expect(1, 44032, '\p{^-	In_meetei_mayek}', "");
    Expect(1, 44032, '\P{-	In_meetei_mayek}', "");
    Expect(0, 44032, '\P{^-	In_meetei_mayek}', "");
    Error('\p{_ in_mende_KIKAKUI:=}');
    Error('\P{_ in_mende_KIKAKUI:=}');
    Expect(1, 125151, '\p{inmendekikakui}', "");
    Expect(0, 125151, '\p{^inmendekikakui}', "");
    Expect(0, 125151, '\P{inmendekikakui}', "");
    Expect(1, 125151, '\P{^inmendekikakui}', "");
    Expect(0, 125152, '\p{inmendekikakui}', "");
    Expect(1, 125152, '\p{^inmendekikakui}', "");
    Expect(1, 125152, '\P{inmendekikakui}', "");
    Expect(0, 125152, '\P{^inmendekikakui}', "");
    Expect(1, 125151, '\p{ in_mende_Kikakui}', "");
    Expect(0, 125151, '\p{^ in_mende_Kikakui}', "");
    Expect(0, 125151, '\P{ in_mende_Kikakui}', "");
    Expect(1, 125151, '\P{^ in_mende_Kikakui}', "");
    Expect(0, 125152, '\p{ in_mende_Kikakui}', "");
    Expect(1, 125152, '\p{^ in_mende_Kikakui}', "");
    Expect(1, 125152, '\P{ in_mende_Kikakui}', "");
    Expect(0, 125152, '\P{^ in_mende_Kikakui}', "");
    Error('\p{	-in_Mende_Kikakui:=}');
    Error('\P{	-in_Mende_Kikakui:=}');
    Expect(1, 125151, '\p{  In_MENDE_Kikakui}', "");
    Expect(0, 125151, '\p{^  In_MENDE_Kikakui}', "");
    Expect(0, 125151, '\P{  In_MENDE_Kikakui}', "");
    Expect(1, 125151, '\P{^  In_MENDE_Kikakui}', "");
    Expect(0, 125152, '\p{  In_MENDE_Kikakui}', "");
    Expect(1, 125152, '\p{^  In_MENDE_Kikakui}', "");
    Expect(1, 125152, '\P{  In_MENDE_Kikakui}', "");
    Expect(0, 125152, '\P{^  In_MENDE_Kikakui}', "");
    Error('\p{	IN_meroitic_CURSIVE:=}');
    Error('\P{	IN_meroitic_CURSIVE:=}');
    Expect(1, 68095, '\p{inmeroiticcursive}', "");
    Expect(0, 68095, '\p{^inmeroiticcursive}', "");
    Expect(0, 68095, '\P{inmeroiticcursive}', "");
    Expect(1, 68095, '\P{^inmeroiticcursive}', "");
    Expect(0, 68096, '\p{inmeroiticcursive}', "");
    Expect(1, 68096, '\p{^inmeroiticcursive}', "");
    Expect(1, 68096, '\P{inmeroiticcursive}', "");
    Expect(0, 68096, '\P{^inmeroiticcursive}', "");
    Expect(1, 68095, '\p{in_Meroitic_Cursive}', "");
    Expect(0, 68095, '\p{^in_Meroitic_Cursive}', "");
    Expect(0, 68095, '\P{in_Meroitic_Cursive}', "");
    Expect(1, 68095, '\P{^in_Meroitic_Cursive}', "");
    Expect(0, 68096, '\p{in_Meroitic_Cursive}', "");
    Expect(1, 68096, '\p{^in_Meroitic_Cursive}', "");
    Expect(1, 68096, '\P{in_Meroitic_Cursive}', "");
    Expect(0, 68096, '\P{^in_Meroitic_Cursive}', "");
    Error('\p{-In_MEROITIC_CURSIVE/a/}');
    Error('\P{-In_MEROITIC_CURSIVE/a/}');
    Expect(1, 68095, '\p{__IN_Meroitic_CURSIVE}', "");
    Expect(0, 68095, '\p{^__IN_Meroitic_CURSIVE}', "");
    Expect(0, 68095, '\P{__IN_Meroitic_CURSIVE}', "");
    Expect(1, 68095, '\P{^__IN_Meroitic_CURSIVE}', "");
    Expect(0, 68096, '\p{__IN_Meroitic_CURSIVE}', "");
    Expect(1, 68096, '\p{^__IN_Meroitic_CURSIVE}', "");
    Expect(1, 68096, '\P{__IN_Meroitic_CURSIVE}', "");
    Expect(0, 68096, '\P{^__IN_Meroitic_CURSIVE}', "");
    Error('\p{_/a/In_MEROITIC_HIEROGLYPHS}');
    Error('\P{_/a/In_MEROITIC_HIEROGLYPHS}');
    Expect(1, 67999, '\p{inmeroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^inmeroitichieroglyphs}', "");
    Expect(0, 67999, '\P{inmeroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^inmeroitichieroglyphs}', "");
    Expect(0, 68000, '\p{inmeroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^inmeroitichieroglyphs}', "");
    Expect(1, 68000, '\P{inmeroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^inmeroitichieroglyphs}', "");
    Expect(1, 67999, '\p{ -IN_MEROITIC_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^ -IN_MEROITIC_Hieroglyphs}', "");
    Expect(0, 67999, '\P{ -IN_MEROITIC_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^ -IN_MEROITIC_Hieroglyphs}', "");
    Expect(0, 68000, '\p{ -IN_MEROITIC_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^ -IN_MEROITIC_Hieroglyphs}', "");
    Expect(1, 68000, '\P{ -IN_MEROITIC_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^ -IN_MEROITIC_Hieroglyphs}', "");
    Error('\p{ in_Meroitic_hieroglyphs:=}');
    Error('\P{ in_Meroitic_hieroglyphs:=}');
    Expect(1, 67999, '\p{ in_Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^ in_Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\P{ in_Meroitic_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^ in_Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\p{ in_Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^ in_Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\P{ in_Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^ in_Meroitic_Hieroglyphs}', "");
    Error('\p{/a/__IN_Miao}');
    Error('\P{/a/__IN_Miao}');
    Expect(1, 94111, '\p{inmiao}', "");
    Expect(0, 94111, '\p{^inmiao}', "");
    Expect(0, 94111, '\P{inmiao}', "");
    Expect(1, 94111, '\P{^inmiao}', "");
    Expect(0, 94112, '\p{inmiao}', "");
    Expect(1, 94112, '\p{^inmiao}', "");
    Expect(1, 94112, '\P{inmiao}', "");
    Expect(0, 94112, '\P{^inmiao}', "");
    Expect(1, 94111, '\p{	_in_Miao}', "");
    Expect(0, 94111, '\p{^	_in_Miao}', "");
    Expect(0, 94111, '\P{	_in_Miao}', "");
    Expect(1, 94111, '\P{^	_in_Miao}', "");
    Expect(0, 94112, '\p{	_in_Miao}', "");
    Expect(1, 94112, '\p{^	_in_Miao}', "");
    Expect(1, 94112, '\P{	_in_Miao}', "");
    Expect(0, 94112, '\P{^	_in_Miao}', "");
    Error('\p{:= 	IN_miao}');
    Error('\P{:= 	IN_miao}');
    Expect(1, 94111, '\p{ -in_miao}', "");
    Expect(0, 94111, '\p{^ -in_miao}', "");
    Expect(0, 94111, '\P{ -in_miao}', "");
    Expect(1, 94111, '\P{^ -in_miao}', "");
    Expect(0, 94112, '\p{ -in_miao}', "");
    Expect(1, 94112, '\p{^ -in_miao}', "");
    Expect(1, 94112, '\P{ -in_miao}', "");
    Expect(0, 94112, '\P{^ -in_miao}', "");
    Error('\p{	 In_modi/a/}');
    Error('\P{	 In_modi/a/}');
    Expect(1, 71263, '\p{inmodi}', "");
    Expect(0, 71263, '\p{^inmodi}', "");
    Expect(0, 71263, '\P{inmodi}', "");
    Expect(1, 71263, '\P{^inmodi}', "");
    Expect(0, 71264, '\p{inmodi}', "");
    Expect(1, 71264, '\p{^inmodi}', "");
    Expect(1, 71264, '\P{inmodi}', "");
    Expect(0, 71264, '\P{^inmodi}', "");
    Expect(1, 71263, '\p{--IN_MODI}', "");
    Expect(0, 71263, '\p{^--IN_MODI}', "");
    Expect(0, 71263, '\P{--IN_MODI}', "");
    Expect(1, 71263, '\P{^--IN_MODI}', "");
    Expect(0, 71264, '\p{--IN_MODI}', "");
    Expect(1, 71264, '\p{^--IN_MODI}', "");
    Expect(1, 71264, '\P{--IN_MODI}', "");
    Expect(0, 71264, '\P{^--IN_MODI}', "");
    Error('\p{		in_modi/a/}');
    Error('\P{		in_modi/a/}');
    Expect(1, 71263, '\p{	_in_Modi}', "");
    Expect(0, 71263, '\p{^	_in_Modi}', "");
    Expect(0, 71263, '\P{	_in_Modi}', "");
    Expect(1, 71263, '\P{^	_in_Modi}', "");
    Expect(0, 71264, '\p{	_in_Modi}', "");
    Expect(1, 71264, '\p{^	_in_Modi}', "");
    Expect(1, 71264, '\P{	_in_Modi}', "");
    Expect(0, 71264, '\P{^	_in_Modi}', "");
    Error('\p{ _IN_Mongolian:=}');
    Error('\P{ _IN_Mongolian:=}');
    Expect(1, 6319, '\p{inmongolian}', "");
    Expect(0, 6319, '\p{^inmongolian}', "");
    Expect(0, 6319, '\P{inmongolian}', "");
    Expect(1, 6319, '\P{^inmongolian}', "");
    Expect(0, 6320, '\p{inmongolian}', "");
    Expect(1, 6320, '\p{^inmongolian}', "");
    Expect(1, 6320, '\P{inmongolian}', "");
    Expect(0, 6320, '\P{^inmongolian}', "");
    Expect(1, 6319, '\p{ _In_Mongolian}', "");
    Expect(0, 6319, '\p{^ _In_Mongolian}', "");
    Expect(0, 6319, '\P{ _In_Mongolian}', "");
    Expect(1, 6319, '\P{^ _In_Mongolian}', "");
    Expect(0, 6320, '\p{ _In_Mongolian}', "");
    Expect(1, 6320, '\p{^ _In_Mongolian}', "");
    Expect(1, 6320, '\P{ _In_Mongolian}', "");
    Expect(0, 6320, '\P{^ _In_Mongolian}', "");
    Error('\p{ /a/in_Mongolian}');
    Error('\P{ /a/in_Mongolian}');
    Expect(1, 6319, '\p{	IN_Mongolian}', "");
    Expect(0, 6319, '\p{^	IN_Mongolian}', "");
    Expect(0, 6319, '\P{	IN_Mongolian}', "");
    Expect(1, 6319, '\P{^	IN_Mongolian}', "");
    Expect(0, 6320, '\p{	IN_Mongolian}', "");
    Expect(1, 6320, '\p{^	IN_Mongolian}', "");
    Expect(1, 6320, '\P{	IN_Mongolian}', "");
    Expect(0, 6320, '\P{^	IN_Mongolian}', "");
    Error('\p{/a/in_Mro}');
    Error('\P{/a/in_Mro}');
    Expect(1, 92783, '\p{inmro}', "");
    Expect(0, 92783, '\p{^inmro}', "");
    Expect(0, 92783, '\P{inmro}', "");
    Expect(1, 92783, '\P{^inmro}', "");
    Expect(0, 92784, '\p{inmro}', "");
    Expect(1, 92784, '\p{^inmro}', "");
    Expect(1, 92784, '\P{inmro}', "");
    Expect(0, 92784, '\P{^inmro}', "");
    Expect(1, 92783, '\p{ in_Mro}', "");
    Expect(0, 92783, '\p{^ in_Mro}', "");
    Expect(0, 92783, '\P{ in_Mro}', "");
    Expect(1, 92783, '\P{^ in_Mro}', "");
    Expect(0, 92784, '\p{ in_Mro}', "");
    Expect(1, 92784, '\p{^ in_Mro}', "");
    Expect(1, 92784, '\P{ in_Mro}', "");
    Expect(0, 92784, '\P{^ in_Mro}', "");
    Error('\p{ -In_MRO/a/}');
    Error('\P{ -In_MRO/a/}');
    Expect(1, 92783, '\p{		IN_Mro}', "");
    Expect(0, 92783, '\p{^		IN_Mro}', "");
    Expect(0, 92783, '\P{		IN_Mro}', "");
    Expect(1, 92783, '\P{^		IN_Mro}', "");
    Expect(0, 92784, '\p{		IN_Mro}', "");
    Expect(1, 92784, '\p{^		IN_Mro}', "");
    Expect(1, 92784, '\P{		IN_Mro}', "");
    Expect(0, 92784, '\P{^		IN_Mro}', "");
    Error('\p{:=_ In_multani}');
    Error('\P{:=_ In_multani}');
    Expect(1, 70319, '\p{inmultani}', "");
    Expect(0, 70319, '\p{^inmultani}', "");
    Expect(0, 70319, '\P{inmultani}', "");
    Expect(1, 70319, '\P{^inmultani}', "");
    Expect(0, 70320, '\p{inmultani}', "");
    Expect(1, 70320, '\p{^inmultani}', "");
    Expect(1, 70320, '\P{inmultani}', "");
    Expect(0, 70320, '\P{^inmultani}', "");
    Expect(1, 70319, '\p{		In_Multani}', "");
    Expect(0, 70319, '\p{^		In_Multani}', "");
    Expect(0, 70319, '\P{		In_Multani}', "");
    Expect(1, 70319, '\P{^		In_Multani}', "");
    Expect(0, 70320, '\p{		In_Multani}', "");
    Expect(1, 70320, '\p{^		In_Multani}', "");
    Expect(1, 70320, '\P{		In_Multani}', "");
    Expect(0, 70320, '\P{^		In_Multani}', "");
    Error('\p{/a/IN_MULTANI}');
    Error('\P{/a/IN_MULTANI}');
    Expect(1, 70319, '\p{ _IN_multani}', "");
    Expect(0, 70319, '\p{^ _IN_multani}', "");
    Expect(0, 70319, '\P{ _IN_multani}', "");
    Expect(1, 70319, '\P{^ _IN_multani}', "");
    Expect(0, 70320, '\p{ _IN_multani}', "");
    Expect(1, 70320, '\p{^ _IN_multani}', "");
    Expect(1, 70320, '\P{ _IN_multani}', "");
    Expect(0, 70320, '\P{^ _IN_multani}', "");
    Error('\p{_-In_myanmar/a/}');
    Error('\P{_-In_myanmar/a/}');
    Expect(1, 4255, '\p{inmyanmar}', "");
    Expect(0, 4255, '\p{^inmyanmar}', "");
    Expect(0, 4255, '\P{inmyanmar}', "");
    Expect(1, 4255, '\P{^inmyanmar}', "");
    Expect(0, 4256, '\p{inmyanmar}', "");
    Expect(1, 4256, '\p{^inmyanmar}', "");
    Expect(1, 4256, '\P{inmyanmar}', "");
    Expect(0, 4256, '\P{^inmyanmar}', "");
    Expect(1, 4255, '\p{-_In_myanmar}', "");
    Expect(0, 4255, '\p{^-_In_myanmar}', "");
    Expect(0, 4255, '\P{-_In_myanmar}', "");
    Expect(1, 4255, '\P{^-_In_myanmar}', "");
    Expect(0, 4256, '\p{-_In_myanmar}', "");
    Expect(1, 4256, '\p{^-_In_myanmar}', "");
    Expect(1, 4256, '\P{-_In_myanmar}', "");
    Expect(0, 4256, '\P{^-_In_myanmar}', "");
    Error('\p{-:=IN_myanmar}');
    Error('\P{-:=IN_myanmar}');
    Expect(1, 4255, '\p{-In_Myanmar}', "");
    Expect(0, 4255, '\p{^-In_Myanmar}', "");
    Expect(0, 4255, '\P{-In_Myanmar}', "");
    Expect(1, 4255, '\P{^-In_Myanmar}', "");
    Expect(0, 4256, '\p{-In_Myanmar}', "");
    Expect(1, 4256, '\p{^-In_Myanmar}', "");
    Expect(1, 4256, '\P{-In_Myanmar}', "");
    Expect(0, 4256, '\P{^-In_Myanmar}', "");
    Error('\p{/a/In_Nabataean}');
    Error('\P{/a/In_Nabataean}');
    Expect(1, 67759, '\p{innabataean}', "");
    Expect(0, 67759, '\p{^innabataean}', "");
    Expect(0, 67759, '\P{innabataean}', "");
    Expect(1, 67759, '\P{^innabataean}', "");
    Expect(0, 67760, '\p{innabataean}', "");
    Expect(1, 67760, '\p{^innabataean}', "");
    Expect(1, 67760, '\P{innabataean}', "");
    Expect(0, 67760, '\P{^innabataean}', "");
    Expect(1, 67759, '\p{		In_Nabataean}', "");
    Expect(0, 67759, '\p{^		In_Nabataean}', "");
    Expect(0, 67759, '\P{		In_Nabataean}', "");
    Expect(1, 67759, '\P{^		In_Nabataean}', "");
    Expect(0, 67760, '\p{		In_Nabataean}', "");
    Expect(1, 67760, '\p{^		In_Nabataean}', "");
    Expect(1, 67760, '\P{		In_Nabataean}', "");
    Expect(0, 67760, '\P{^		In_Nabataean}', "");
    Error('\p{ In_NABATAEAN/a/}');
    Error('\P{ In_NABATAEAN/a/}');
    Expect(1, 67759, '\p{-_in_nabataean}', "");
    Expect(0, 67759, '\p{^-_in_nabataean}', "");
    Expect(0, 67759, '\P{-_in_nabataean}', "");
    Expect(1, 67759, '\P{^-_in_nabataean}', "");
    Expect(0, 67760, '\p{-_in_nabataean}', "");
    Expect(1, 67760, '\p{^-_in_nabataean}', "");
    Expect(1, 67760, '\P{-_in_nabataean}', "");
    Expect(0, 67760, '\P{^-_in_nabataean}', "");
    Error('\p{/a/	 In_NEW_Tai_Lue}');
    Error('\P{/a/	 In_NEW_Tai_Lue}');
    Expect(1, 6623, '\p{innewtailue}', "");
    Expect(0, 6623, '\p{^innewtailue}', "");
    Expect(0, 6623, '\P{innewtailue}', "");
    Expect(1, 6623, '\P{^innewtailue}', "");
    Expect(0, 6624, '\p{innewtailue}', "");
    Expect(1, 6624, '\p{^innewtailue}', "");
    Expect(1, 6624, '\P{innewtailue}', "");
    Expect(0, 6624, '\P{^innewtailue}', "");
    Expect(1, 6623, '\p{ -In_New_Tai_LUE}', "");
    Expect(0, 6623, '\p{^ -In_New_Tai_LUE}', "");
    Expect(0, 6623, '\P{ -In_New_Tai_LUE}', "");
    Expect(1, 6623, '\P{^ -In_New_Tai_LUE}', "");
    Expect(0, 6624, '\p{ -In_New_Tai_LUE}', "");
    Expect(1, 6624, '\p{^ -In_New_Tai_LUE}', "");
    Expect(1, 6624, '\P{ -In_New_Tai_LUE}', "");
    Expect(0, 6624, '\P{^ -In_New_Tai_LUE}', "");
    Error('\p{	:=In_New_TAI_Lue}');
    Error('\P{	:=In_New_TAI_Lue}');
    Expect(1, 6623, '\p{ _In_New_Tai_Lue}', "");
    Expect(0, 6623, '\p{^ _In_New_Tai_Lue}', "");
    Expect(0, 6623, '\P{ _In_New_Tai_Lue}', "");
    Expect(1, 6623, '\P{^ _In_New_Tai_Lue}', "");
    Expect(0, 6624, '\p{ _In_New_Tai_Lue}', "");
    Expect(1, 6624, '\p{^ _In_New_Tai_Lue}', "");
    Expect(1, 6624, '\P{ _In_New_Tai_Lue}', "");
    Expect(0, 6624, '\P{^ _In_New_Tai_Lue}', "");
    Error('\p{_-IN_Newa/a/}');
    Error('\P{_-IN_Newa/a/}');
    Expect(1, 70783, '\p{innewa}', "");
    Expect(0, 70783, '\p{^innewa}', "");
    Expect(0, 70783, '\P{innewa}', "");
    Expect(1, 70783, '\P{^innewa}', "");
    Expect(0, 70784, '\p{innewa}', "");
    Expect(1, 70784, '\p{^innewa}', "");
    Expect(1, 70784, '\P{innewa}', "");
    Expect(0, 70784, '\P{^innewa}', "");
    Expect(1, 70783, '\p{ _In_Newa}', "");
    Expect(0, 70783, '\p{^ _In_Newa}', "");
    Expect(0, 70783, '\P{ _In_Newa}', "");
    Expect(1, 70783, '\P{^ _In_Newa}', "");
    Expect(0, 70784, '\p{ _In_Newa}', "");
    Expect(1, 70784, '\p{^ _In_Newa}', "");
    Expect(1, 70784, '\P{ _In_Newa}', "");
    Expect(0, 70784, '\P{^ _In_Newa}', "");
    Error('\p{-in_Newa/a/}');
    Error('\P{-in_Newa/a/}');
    Expect(1, 70783, '\p{--in_NEWA}', "");
    Expect(0, 70783, '\p{^--in_NEWA}', "");
    Expect(0, 70783, '\P{--in_NEWA}', "");
    Expect(1, 70783, '\P{^--in_NEWA}', "");
    Expect(0, 70784, '\p{--in_NEWA}', "");
    Expect(1, 70784, '\p{^--in_NEWA}', "");
    Expect(1, 70784, '\P{--in_NEWA}', "");
    Expect(0, 70784, '\P{^--in_NEWA}', "");
    Error('\p{:=-In_NKo}');
    Error('\P{:=-In_NKo}');
    Expect(1, 2047, '\p{innko}', "");
    Expect(0, 2047, '\p{^innko}', "");
    Expect(0, 2047, '\P{innko}', "");
    Expect(1, 2047, '\P{^innko}', "");
    Expect(0, 2048, '\p{innko}', "");
    Expect(1, 2048, '\p{^innko}', "");
    Expect(1, 2048, '\P{innko}', "");
    Expect(0, 2048, '\P{^innko}', "");
    Expect(1, 2047, '\p{ 	In_NKO}', "");
    Expect(0, 2047, '\p{^ 	In_NKO}', "");
    Expect(0, 2047, '\P{ 	In_NKO}', "");
    Expect(1, 2047, '\P{^ 	In_NKO}', "");
    Expect(0, 2048, '\p{ 	In_NKO}', "");
    Expect(1, 2048, '\p{^ 	In_NKO}', "");
    Expect(1, 2048, '\P{ 	In_NKO}', "");
    Expect(0, 2048, '\P{^ 	In_NKO}', "");
    Error('\p{	:=IN_NKo}');
    Error('\P{	:=IN_NKo}');
    Expect(1, 2047, '\p{-In_nko}', "");
    Expect(0, 2047, '\p{^-In_nko}', "");
    Expect(0, 2047, '\P{-In_nko}', "");
    Expect(1, 2047, '\P{^-In_nko}', "");
    Expect(0, 2048, '\p{-In_nko}', "");
    Expect(1, 2048, '\p{^-In_nko}', "");
    Expect(1, 2048, '\P{-In_nko}', "");
    Expect(0, 2048, '\P{^-In_nko}', "");
    Error('\p{:=-	In_Nushu}');
    Error('\P{:=-	In_Nushu}');
    Expect(1, 111359, '\p{innushu}', "");
    Expect(0, 111359, '\p{^innushu}', "");
    Expect(0, 111359, '\P{innushu}', "");
    Expect(1, 111359, '\P{^innushu}', "");
    Expect(0, 111360, '\p{innushu}', "");
    Expect(1, 111360, '\p{^innushu}', "");
    Expect(1, 111360, '\P{innushu}', "");
    Expect(0, 111360, '\P{^innushu}', "");
    Expect(1, 111359, '\p{  In_Nushu}', "");
    Expect(0, 111359, '\p{^  In_Nushu}', "");
    Expect(0, 111359, '\P{  In_Nushu}', "");
    Expect(1, 111359, '\P{^  In_Nushu}', "");
    Expect(0, 111360, '\p{  In_Nushu}', "");
    Expect(1, 111360, '\p{^  In_Nushu}', "");
    Expect(1, 111360, '\P{  In_Nushu}', "");
    Expect(0, 111360, '\P{^  In_Nushu}', "");
    Error('\p{-/a/IN_nushu}');
    Error('\P{-/a/IN_nushu}');
    Expect(1, 111359, '\p{	in_Nushu}', "");
    Expect(0, 111359, '\p{^	in_Nushu}', "");
    Expect(0, 111359, '\P{	in_Nushu}', "");
    Expect(1, 111359, '\P{^	in_Nushu}', "");
    Expect(0, 111360, '\p{	in_Nushu}', "");
    Expect(1, 111360, '\p{^	in_Nushu}', "");
    Expect(1, 111360, '\P{	in_Nushu}', "");
    Expect(0, 111360, '\P{^	in_Nushu}', "");
    Error('\p{:=-in_Ogham}');
    Error('\P{:=-in_Ogham}');
    Expect(1, 5791, '\p{inogham}', "");
    Expect(0, 5791, '\p{^inogham}', "");
    Expect(0, 5791, '\P{inogham}', "");
    Expect(1, 5791, '\P{^inogham}', "");
    Expect(0, 5792, '\p{inogham}', "");
    Expect(1, 5792, '\p{^inogham}', "");
    Expect(1, 5792, '\P{inogham}', "");
    Expect(0, 5792, '\P{^inogham}', "");
    Expect(1, 5791, '\p{_In_Ogham}', "");
    Expect(0, 5791, '\p{^_In_Ogham}', "");
    Expect(0, 5791, '\P{_In_Ogham}', "");
    Expect(1, 5791, '\P{^_In_Ogham}', "");
    Expect(0, 5792, '\p{_In_Ogham}', "");
    Expect(1, 5792, '\p{^_In_Ogham}', "");
    Expect(1, 5792, '\P{_In_Ogham}', "");
    Expect(0, 5792, '\P{^_In_Ogham}', "");
    Error('\p{_/a/In_Ogham}');
    Error('\P{_/a/In_Ogham}');
    Expect(1, 5791, '\p{ in_Ogham}', "");
    Expect(0, 5791, '\p{^ in_Ogham}', "");
    Expect(0, 5791, '\P{ in_Ogham}', "");
    Expect(1, 5791, '\P{^ in_Ogham}', "");
    Expect(0, 5792, '\p{ in_Ogham}', "");
    Expect(1, 5792, '\p{^ in_Ogham}', "");
    Expect(1, 5792, '\P{ in_Ogham}', "");
    Expect(0, 5792, '\P{^ in_Ogham}', "");
    Error('\p{:=-In_ol_CHIKI}');
    Error('\P{:=-In_ol_CHIKI}');
    Expect(1, 7295, '\p{inolchiki}', "");
    Expect(0, 7295, '\p{^inolchiki}', "");
    Expect(0, 7295, '\P{inolchiki}', "");
    Expect(1, 7295, '\P{^inolchiki}', "");
    Expect(0, 7296, '\p{inolchiki}', "");
    Expect(1, 7296, '\p{^inolchiki}', "");
    Expect(1, 7296, '\P{inolchiki}', "");
    Expect(0, 7296, '\P{^inolchiki}', "");
    Expect(1, 7295, '\p{  IN_Ol_chiki}', "");
    Expect(0, 7295, '\p{^  IN_Ol_chiki}', "");
    Expect(0, 7295, '\P{  IN_Ol_chiki}', "");
    Expect(1, 7295, '\P{^  IN_Ol_chiki}', "");
    Expect(0, 7296, '\p{  IN_Ol_chiki}', "");
    Expect(1, 7296, '\p{^  IN_Ol_chiki}', "");
    Expect(1, 7296, '\P{  IN_Ol_chiki}', "");
    Expect(0, 7296, '\P{^  IN_Ol_chiki}', "");
    Error('\p{ _In_ol_Chiki:=}');
    Error('\P{ _In_ol_Chiki:=}');
    Expect(1, 7295, '\p{- In_ol_Chiki}', "");
    Expect(0, 7295, '\p{^- In_ol_Chiki}', "");
    Expect(0, 7295, '\P{- In_ol_Chiki}', "");
    Expect(1, 7295, '\P{^- In_ol_Chiki}', "");
    Expect(0, 7296, '\p{- In_ol_Chiki}', "");
    Expect(1, 7296, '\p{^- In_ol_Chiki}', "");
    Expect(1, 7296, '\P{- In_ol_Chiki}', "");
    Expect(0, 7296, '\P{^- In_ol_Chiki}', "");
    Error('\p{/a/	In_old_Hungarian}');
    Error('\P{/a/	In_old_Hungarian}');
    Expect(1, 68863, '\p{inoldhungarian}', "");
    Expect(0, 68863, '\p{^inoldhungarian}', "");
    Expect(0, 68863, '\P{inoldhungarian}', "");
    Expect(1, 68863, '\P{^inoldhungarian}', "");
    Expect(0, 68864, '\p{inoldhungarian}', "");
    Expect(1, 68864, '\p{^inoldhungarian}', "");
    Expect(1, 68864, '\P{inoldhungarian}', "");
    Expect(0, 68864, '\P{^inoldhungarian}', "");
    Expect(1, 68863, '\p{ 	In_OLD_HUNGARIAN}', "");
    Expect(0, 68863, '\p{^ 	In_OLD_HUNGARIAN}', "");
    Expect(0, 68863, '\P{ 	In_OLD_HUNGARIAN}', "");
    Expect(1, 68863, '\P{^ 	In_OLD_HUNGARIAN}', "");
    Expect(0, 68864, '\p{ 	In_OLD_HUNGARIAN}', "");
    Expect(1, 68864, '\p{^ 	In_OLD_HUNGARIAN}', "");
    Expect(1, 68864, '\P{ 	In_OLD_HUNGARIAN}', "");
    Expect(0, 68864, '\P{^ 	In_OLD_HUNGARIAN}', "");
    Error('\p{:= in_OLD_hungarian}');
    Error('\P{:= in_OLD_hungarian}');
    Expect(1, 68863, '\p{ _IN_OLD_Hungarian}', "");
    Expect(0, 68863, '\p{^ _IN_OLD_Hungarian}', "");
    Expect(0, 68863, '\P{ _IN_OLD_Hungarian}', "");
    Expect(1, 68863, '\P{^ _IN_OLD_Hungarian}', "");
    Expect(0, 68864, '\p{ _IN_OLD_Hungarian}', "");
    Expect(1, 68864, '\p{^ _IN_OLD_Hungarian}', "");
    Expect(1, 68864, '\P{ _IN_OLD_Hungarian}', "");
    Expect(0, 68864, '\P{^ _IN_OLD_Hungarian}', "");
    Error('\p{:=	In_old_Italic}');
    Error('\P{:=	In_old_Italic}');
    Expect(1, 66351, '\p{inolditalic}', "");
    Expect(0, 66351, '\p{^inolditalic}', "");
    Expect(0, 66351, '\P{inolditalic}', "");
    Expect(1, 66351, '\P{^inolditalic}', "");
    Expect(0, 66352, '\p{inolditalic}', "");
    Expect(1, 66352, '\p{^inolditalic}', "");
    Expect(1, 66352, '\P{inolditalic}', "");
    Expect(0, 66352, '\P{^inolditalic}', "");
    Expect(1, 66351, '\p{  IN_Old_italic}', "");
    Expect(0, 66351, '\p{^  IN_Old_italic}', "");
    Expect(0, 66351, '\P{  IN_Old_italic}', "");
    Expect(1, 66351, '\P{^  IN_Old_italic}', "");
    Expect(0, 66352, '\p{  IN_Old_italic}', "");
    Expect(1, 66352, '\p{^  IN_Old_italic}', "");
    Expect(1, 66352, '\P{  IN_Old_italic}', "");
    Expect(0, 66352, '\P{^  IN_Old_italic}', "");
    Error('\p{-:=in_Old_Italic}');
    Error('\P{-:=in_Old_Italic}');
    Expect(1, 66351, '\p{-In_Old_italic}', "");
    Expect(0, 66351, '\p{^-In_Old_italic}', "");
    Expect(0, 66351, '\P{-In_Old_italic}', "");
    Expect(1, 66351, '\P{^-In_Old_italic}', "");
    Expect(0, 66352, '\p{-In_Old_italic}', "");
    Expect(1, 66352, '\p{^-In_Old_italic}', "");
    Expect(1, 66352, '\P{-In_Old_italic}', "");
    Expect(0, 66352, '\P{^-In_Old_italic}', "");
    Error('\p{:=  In_Old_NORTH_arabian}');
    Error('\P{:=  In_Old_NORTH_arabian}');
    Expect(1, 68255, '\p{inoldnortharabian}', "");
    Expect(0, 68255, '\p{^inoldnortharabian}', "");
    Expect(0, 68255, '\P{inoldnortharabian}', "");
    Expect(1, 68255, '\P{^inoldnortharabian}', "");
    Expect(0, 68256, '\p{inoldnortharabian}', "");
    Expect(1, 68256, '\p{^inoldnortharabian}', "");
    Expect(1, 68256, '\P{inoldnortharabian}', "");
    Expect(0, 68256, '\P{^inoldnortharabian}', "");
    Expect(1, 68255, '\p{-In_Old_North_ARABIAN}', "");
    Expect(0, 68255, '\p{^-In_Old_North_ARABIAN}', "");
    Expect(0, 68255, '\P{-In_Old_North_ARABIAN}', "");
    Expect(1, 68255, '\P{^-In_Old_North_ARABIAN}', "");
    Expect(0, 68256, '\p{-In_Old_North_ARABIAN}', "");
    Expect(1, 68256, '\p{^-In_Old_North_ARABIAN}', "");
    Expect(1, 68256, '\P{-In_Old_North_ARABIAN}', "");
    Expect(0, 68256, '\P{^-In_Old_North_ARABIAN}', "");
    Error('\p{/a/--In_old_North_Arabian}');
    Error('\P{/a/--In_old_North_Arabian}');
    Expect(1, 68255, '\p{ -In_OLD_north_arabian}', "");
    Expect(0, 68255, '\p{^ -In_OLD_north_arabian}', "");
    Expect(0, 68255, '\P{ -In_OLD_north_arabian}', "");
    Expect(1, 68255, '\P{^ -In_OLD_north_arabian}', "");
    Expect(0, 68256, '\p{ -In_OLD_north_arabian}', "");
    Expect(1, 68256, '\p{^ -In_OLD_north_arabian}', "");
    Expect(1, 68256, '\P{ -In_OLD_north_arabian}', "");
    Expect(0, 68256, '\P{^ -In_OLD_north_arabian}', "");
    Error('\p{  in_Old_permic:=}');
    Error('\P{  in_Old_permic:=}');
    Expect(1, 66431, '\p{inoldpermic}', "");
    Expect(0, 66431, '\p{^inoldpermic}', "");
    Expect(0, 66431, '\P{inoldpermic}', "");
    Expect(1, 66431, '\P{^inoldpermic}', "");
    Expect(0, 66432, '\p{inoldpermic}', "");
    Expect(1, 66432, '\p{^inoldpermic}', "");
    Expect(1, 66432, '\P{inoldpermic}', "");
    Expect(0, 66432, '\P{^inoldpermic}', "");
    Expect(1, 66431, '\p{	IN_Old_Permic}', "");
    Expect(0, 66431, '\p{^	IN_Old_Permic}', "");
    Expect(0, 66431, '\P{	IN_Old_Permic}', "");
    Expect(1, 66431, '\P{^	IN_Old_Permic}', "");
    Expect(0, 66432, '\p{	IN_Old_Permic}', "");
    Expect(1, 66432, '\p{^	IN_Old_Permic}', "");
    Expect(1, 66432, '\P{	IN_Old_Permic}', "");
    Expect(0, 66432, '\P{^	IN_Old_Permic}', "");
    Error('\p{ in_OLD_Permic:=}');
    Error('\P{ in_OLD_Permic:=}');
    Expect(1, 66431, '\p{	In_OLD_Permic}', "");
    Expect(0, 66431, '\p{^	In_OLD_Permic}', "");
    Expect(0, 66431, '\P{	In_OLD_Permic}', "");
    Expect(1, 66431, '\P{^	In_OLD_Permic}', "");
    Expect(0, 66432, '\p{	In_OLD_Permic}', "");
    Expect(1, 66432, '\p{^	In_OLD_Permic}', "");
    Expect(1, 66432, '\P{	In_OLD_Permic}', "");
    Expect(0, 66432, '\P{^	In_OLD_Permic}', "");
    Error('\p{/a/ -in_OLD_persian}');
    Error('\P{/a/ -in_OLD_persian}');
    Expect(1, 66527, '\p{inoldpersian}', "");
    Expect(0, 66527, '\p{^inoldpersian}', "");
    Expect(0, 66527, '\P{inoldpersian}', "");
    Expect(1, 66527, '\P{^inoldpersian}', "");
    Expect(0, 66528, '\p{inoldpersian}', "");
    Expect(1, 66528, '\p{^inoldpersian}', "");
    Expect(1, 66528, '\P{inoldpersian}', "");
    Expect(0, 66528, '\P{^inoldpersian}', "");
    Expect(1, 66527, '\p{--in_old_Persian}', "");
    Expect(0, 66527, '\p{^--in_old_Persian}', "");
    Expect(0, 66527, '\P{--in_old_Persian}', "");
    Expect(1, 66527, '\P{^--in_old_Persian}', "");
    Expect(0, 66528, '\p{--in_old_Persian}', "");
    Expect(1, 66528, '\p{^--in_old_Persian}', "");
    Expect(1, 66528, '\P{--in_old_Persian}', "");
    Expect(0, 66528, '\P{^--in_old_Persian}', "");
    Error('\p{ :=In_old_Persian}');
    Error('\P{ :=In_old_Persian}');
    Expect(1, 66527, '\p{_-In_OLD_Persian}', "");
    Expect(0, 66527, '\p{^_-In_OLD_Persian}', "");
    Expect(0, 66527, '\P{_-In_OLD_Persian}', "");
    Expect(1, 66527, '\P{^_-In_OLD_Persian}', "");
    Expect(0, 66528, '\p{_-In_OLD_Persian}', "");
    Expect(1, 66528, '\p{^_-In_OLD_Persian}', "");
    Expect(1, 66528, '\P{_-In_OLD_Persian}', "");
    Expect(0, 66528, '\P{^_-In_OLD_Persian}', "");
    Error('\p{ :=in_Old_south_Arabian}');
    Error('\P{ :=in_Old_south_Arabian}');
    Expect(1, 68223, '\p{inoldsoutharabian}', "");
    Expect(0, 68223, '\p{^inoldsoutharabian}', "");
    Expect(0, 68223, '\P{inoldsoutharabian}', "");
    Expect(1, 68223, '\P{^inoldsoutharabian}', "");
    Expect(0, 68224, '\p{inoldsoutharabian}', "");
    Expect(1, 68224, '\p{^inoldsoutharabian}', "");
    Expect(1, 68224, '\P{inoldsoutharabian}', "");
    Expect(0, 68224, '\P{^inoldsoutharabian}', "");
    Expect(1, 68223, '\p{	In_Old_SOUTH_arabian}', "");
    Expect(0, 68223, '\p{^	In_Old_SOUTH_arabian}', "");
    Expect(0, 68223, '\P{	In_Old_SOUTH_arabian}', "");
    Expect(1, 68223, '\P{^	In_Old_SOUTH_arabian}', "");
    Expect(0, 68224, '\p{	In_Old_SOUTH_arabian}', "");
    Expect(1, 68224, '\p{^	In_Old_SOUTH_arabian}', "");
    Expect(1, 68224, '\P{	In_Old_SOUTH_arabian}', "");
    Expect(0, 68224, '\P{^	In_Old_SOUTH_arabian}', "");
    Error('\p{:=In_Old_south_arabian}');
    Error('\P{:=In_Old_south_arabian}');
    Expect(1, 68223, '\p{In_Old_South_Arabian}', "");
    Expect(0, 68223, '\p{^In_Old_South_Arabian}', "");
    Expect(0, 68223, '\P{In_Old_South_Arabian}', "");
    Expect(1, 68223, '\P{^In_Old_South_Arabian}', "");
    Expect(0, 68224, '\p{In_Old_South_Arabian}', "");
    Expect(1, 68224, '\p{^In_Old_South_Arabian}', "");
    Expect(1, 68224, '\P{In_Old_South_Arabian}', "");
    Expect(0, 68224, '\P{^In_Old_South_Arabian}', "");
    Error('\p{__IN_OLD_Turkic/a/}');
    Error('\P{__IN_OLD_Turkic/a/}');
    Expect(1, 68687, '\p{inoldturkic}', "");
    Expect(0, 68687, '\p{^inoldturkic}', "");
    Expect(0, 68687, '\P{inoldturkic}', "");
    Expect(1, 68687, '\P{^inoldturkic}', "");
    Expect(0, 68688, '\p{inoldturkic}', "");
    Expect(1, 68688, '\p{^inoldturkic}', "");
    Expect(1, 68688, '\P{inoldturkic}', "");
    Expect(0, 68688, '\P{^inoldturkic}', "");
    Expect(1, 68687, '\p{-In_old_TURKIC}', "");
    Expect(0, 68687, '\p{^-In_old_TURKIC}', "");
    Expect(0, 68687, '\P{-In_old_TURKIC}', "");
    Expect(1, 68687, '\P{^-In_old_TURKIC}', "");
    Expect(0, 68688, '\p{-In_old_TURKIC}', "");
    Expect(1, 68688, '\p{^-In_old_TURKIC}', "");
    Expect(1, 68688, '\P{-In_old_TURKIC}', "");
    Expect(0, 68688, '\P{^-In_old_TURKIC}', "");
    Error('\p{:=-in_old_turkic}');
    Error('\P{:=-in_old_turkic}');
    Expect(1, 68687, '\p{-IN_Old_Turkic}', "");
    Expect(0, 68687, '\p{^-IN_Old_Turkic}', "");
    Expect(0, 68687, '\P{-IN_Old_Turkic}', "");
    Expect(1, 68687, '\P{^-IN_Old_Turkic}', "");
    Expect(0, 68688, '\p{-IN_Old_Turkic}', "");
    Expect(1, 68688, '\p{^-IN_Old_Turkic}', "");
    Expect(1, 68688, '\P{-IN_Old_Turkic}', "");
    Expect(0, 68688, '\P{^-IN_Old_Turkic}', "");
    Error('\p{/a/-_in_oriya}');
    Error('\P{/a/-_in_oriya}');
    Expect(1, 2943, '\p{inoriya}', "");
    Expect(0, 2943, '\p{^inoriya}', "");
    Expect(0, 2943, '\P{inoriya}', "");
    Expect(1, 2943, '\P{^inoriya}', "");
    Expect(0, 2944, '\p{inoriya}', "");
    Expect(1, 2944, '\p{^inoriya}', "");
    Expect(1, 2944, '\P{inoriya}', "");
    Expect(0, 2944, '\P{^inoriya}', "");
    Expect(1, 2943, '\p{ _In_oriya}', "");
    Expect(0, 2943, '\p{^ _In_oriya}', "");
    Expect(0, 2943, '\P{ _In_oriya}', "");
    Expect(1, 2943, '\P{^ _In_oriya}', "");
    Expect(0, 2944, '\p{ _In_oriya}', "");
    Expect(1, 2944, '\p{^ _In_oriya}', "");
    Expect(1, 2944, '\P{ _In_oriya}', "");
    Expect(0, 2944, '\P{^ _In_oriya}', "");
    Error('\p{_ IN_oriya:=}');
    Error('\P{_ IN_oriya:=}');
    Expect(1, 2943, '\p{	In_oriya}', "");
    Expect(0, 2943, '\p{^	In_oriya}', "");
    Expect(0, 2943, '\P{	In_oriya}', "");
    Expect(1, 2943, '\P{^	In_oriya}', "");
    Expect(0, 2944, '\p{	In_oriya}', "");
    Expect(1, 2944, '\p{^	In_oriya}', "");
    Expect(1, 2944, '\P{	In_oriya}', "");
    Expect(0, 2944, '\P{^	In_oriya}', "");
    Error('\p{/a/_in_OSAGE}');
    Error('\P{/a/_in_OSAGE}');
    Expect(1, 66815, '\p{inosage}', "");
    Expect(0, 66815, '\p{^inosage}', "");
    Expect(0, 66815, '\P{inosage}', "");
    Expect(1, 66815, '\P{^inosage}', "");
    Expect(0, 66816, '\p{inosage}', "");
    Expect(1, 66816, '\p{^inosage}', "");
    Expect(1, 66816, '\P{inosage}', "");
    Expect(0, 66816, '\P{^inosage}', "");
    Expect(1, 66815, '\p{	 In_Osage}', "");
    Expect(0, 66815, '\p{^	 In_Osage}', "");
    Expect(0, 66815, '\P{	 In_Osage}', "");
    Expect(1, 66815, '\P{^	 In_Osage}', "");
    Expect(0, 66816, '\p{	 In_Osage}', "");
    Expect(1, 66816, '\p{^	 In_Osage}', "");
    Expect(1, 66816, '\P{	 In_Osage}', "");
    Expect(0, 66816, '\P{^	 In_Osage}', "");
    Error('\p{:= In_OSAGE}');
    Error('\P{:= In_OSAGE}');
    Expect(1, 66815, '\p{ _In_Osage}', "");
    Expect(0, 66815, '\p{^ _In_Osage}', "");
    Expect(0, 66815, '\P{ _In_Osage}', "");
    Expect(1, 66815, '\P{^ _In_Osage}', "");
    Expect(0, 66816, '\p{ _In_Osage}', "");
    Expect(1, 66816, '\p{^ _In_Osage}', "");
    Expect(1, 66816, '\P{ _In_Osage}', "");
    Expect(0, 66816, '\P{^ _In_Osage}', "");
    Error('\p{:=_-in_OSMANYA}');
    Error('\P{:=_-in_OSMANYA}');
    Expect(1, 66735, '\p{inosmanya}', "");
    Expect(0, 66735, '\p{^inosmanya}', "");
    Expect(0, 66735, '\P{inosmanya}', "");
    Expect(1, 66735, '\P{^inosmanya}', "");
    Expect(0, 66736, '\p{inosmanya}', "");
    Expect(1, 66736, '\p{^inosmanya}', "");
    Expect(1, 66736, '\P{inosmanya}', "");
    Expect(0, 66736, '\P{^inosmanya}', "");
    Expect(1, 66735, '\p{	-In_Osmanya}', "");
    Expect(0, 66735, '\p{^	-In_Osmanya}', "");
    Expect(0, 66735, '\P{	-In_Osmanya}', "");
    Expect(1, 66735, '\P{^	-In_Osmanya}', "");
    Expect(0, 66736, '\p{	-In_Osmanya}', "");
    Expect(1, 66736, '\p{^	-In_Osmanya}', "");
    Expect(1, 66736, '\P{	-In_Osmanya}', "");
    Expect(0, 66736, '\P{^	-In_Osmanya}', "");
    Error('\p{/a/_-IN_Osmanya}');
    Error('\P{/a/_-IN_Osmanya}');
    Expect(1, 66735, '\p{-_in_osmanya}', "");
    Expect(0, 66735, '\p{^-_in_osmanya}', "");
    Expect(0, 66735, '\P{-_in_osmanya}', "");
    Expect(1, 66735, '\P{^-_in_osmanya}', "");
    Expect(0, 66736, '\p{-_in_osmanya}', "");
    Expect(1, 66736, '\p{^-_in_osmanya}', "");
    Expect(1, 66736, '\P{-_in_osmanya}', "");
    Expect(0, 66736, '\P{^-_in_osmanya}', "");
    Error('\p{ :=in_PAHAWH_Hmong}');
    Error('\P{ :=in_PAHAWH_Hmong}');
    Expect(1, 93071, '\p{inpahawhhmong}', "");
    Expect(0, 93071, '\p{^inpahawhhmong}', "");
    Expect(0, 93071, '\P{inpahawhhmong}', "");
    Expect(1, 93071, '\P{^inpahawhhmong}', "");
    Expect(0, 93072, '\p{inpahawhhmong}', "");
    Expect(1, 93072, '\p{^inpahawhhmong}', "");
    Expect(1, 93072, '\P{inpahawhhmong}', "");
    Expect(0, 93072, '\P{^inpahawhhmong}', "");
    Expect(1, 93071, '\p{	 in_Pahawh_Hmong}', "");
    Expect(0, 93071, '\p{^	 in_Pahawh_Hmong}', "");
    Expect(0, 93071, '\P{	 in_Pahawh_Hmong}', "");
    Expect(1, 93071, '\P{^	 in_Pahawh_Hmong}', "");
    Expect(0, 93072, '\p{	 in_Pahawh_Hmong}', "");
    Expect(1, 93072, '\p{^	 in_Pahawh_Hmong}', "");
    Expect(1, 93072, '\P{	 in_Pahawh_Hmong}', "");
    Expect(0, 93072, '\P{^	 in_Pahawh_Hmong}', "");
    Error('\p{_In_PAHAWH_Hmong:=}');
    Error('\P{_In_PAHAWH_Hmong:=}');
    Expect(1, 93071, '\p{ In_pahawh_Hmong}', "");
    Expect(0, 93071, '\p{^ In_pahawh_Hmong}', "");
    Expect(0, 93071, '\P{ In_pahawh_Hmong}', "");
    Expect(1, 93071, '\P{^ In_pahawh_Hmong}', "");
    Expect(0, 93072, '\p{ In_pahawh_Hmong}', "");
    Expect(1, 93072, '\p{^ In_pahawh_Hmong}', "");
    Expect(1, 93072, '\P{ In_pahawh_Hmong}', "");
    Expect(0, 93072, '\P{^ In_pahawh_Hmong}', "");
    Error('\p{-	In_PALMYRENE:=}');
    Error('\P{-	In_PALMYRENE:=}');
    Expect(1, 67711, '\p{inpalmyrene}', "");
    Expect(0, 67711, '\p{^inpalmyrene}', "");
    Expect(0, 67711, '\P{inpalmyrene}', "");
    Expect(1, 67711, '\P{^inpalmyrene}', "");
    Expect(0, 67712, '\p{inpalmyrene}', "");
    Expect(1, 67712, '\p{^inpalmyrene}', "");
    Expect(1, 67712, '\P{inpalmyrene}', "");
    Expect(0, 67712, '\P{^inpalmyrene}', "");
    Expect(1, 67711, '\p{__IN_Palmyrene}', "");
    Expect(0, 67711, '\p{^__IN_Palmyrene}', "");
    Expect(0, 67711, '\P{__IN_Palmyrene}', "");
    Expect(1, 67711, '\P{^__IN_Palmyrene}', "");
    Expect(0, 67712, '\p{__IN_Palmyrene}', "");
    Expect(1, 67712, '\p{^__IN_Palmyrene}', "");
    Expect(1, 67712, '\P{__IN_Palmyrene}', "");
    Expect(0, 67712, '\P{^__IN_Palmyrene}', "");
    Error('\p{	In_Palmyrene:=}');
    Error('\P{	In_Palmyrene:=}');
    Expect(1, 67711, '\p{-_In_Palmyrene}', "");
    Expect(0, 67711, '\p{^-_In_Palmyrene}', "");
    Expect(0, 67711, '\P{-_In_Palmyrene}', "");
    Expect(1, 67711, '\P{^-_In_Palmyrene}', "");
    Expect(0, 67712, '\p{-_In_Palmyrene}', "");
    Expect(1, 67712, '\p{^-_In_Palmyrene}', "");
    Expect(1, 67712, '\P{-_In_Palmyrene}', "");
    Expect(0, 67712, '\P{^-_In_Palmyrene}', "");
    Error('\p{ _in_pau_Cin_hau/a/}');
    Error('\P{ _in_pau_Cin_hau/a/}');
    Expect(1, 72447, '\p{inpaucinhau}', "");
    Expect(0, 72447, '\p{^inpaucinhau}', "");
    Expect(0, 72447, '\P{inpaucinhau}', "");
    Expect(1, 72447, '\P{^inpaucinhau}', "");
    Expect(0, 72448, '\p{inpaucinhau}', "");
    Expect(1, 72448, '\p{^inpaucinhau}', "");
    Expect(1, 72448, '\P{inpaucinhau}', "");
    Expect(0, 72448, '\P{^inpaucinhau}', "");
    Expect(1, 72447, '\p{-_in_pau_CIN_Hau}', "");
    Expect(0, 72447, '\p{^-_in_pau_CIN_Hau}', "");
    Expect(0, 72447, '\P{-_in_pau_CIN_Hau}', "");
    Expect(1, 72447, '\P{^-_in_pau_CIN_Hau}', "");
    Expect(0, 72448, '\p{-_in_pau_CIN_Hau}', "");
    Expect(1, 72448, '\p{^-_in_pau_CIN_Hau}', "");
    Expect(1, 72448, '\P{-_in_pau_CIN_Hau}', "");
    Expect(0, 72448, '\P{^-_in_pau_CIN_Hau}', "");
    Error('\p{ -In_Pau_Cin_HAU:=}');
    Error('\P{ -In_Pau_Cin_HAU:=}');
    Expect(1, 72447, '\p{_	IN_pau_cin_Hau}', "");
    Expect(0, 72447, '\p{^_	IN_pau_cin_Hau}', "");
    Expect(0, 72447, '\P{_	IN_pau_cin_Hau}', "");
    Expect(1, 72447, '\P{^_	IN_pau_cin_Hau}', "");
    Expect(0, 72448, '\p{_	IN_pau_cin_Hau}', "");
    Expect(1, 72448, '\p{^_	IN_pau_cin_Hau}', "");
    Expect(1, 72448, '\P{_	IN_pau_cin_Hau}', "");
    Expect(0, 72448, '\P{^_	IN_pau_cin_Hau}', "");
    Error('\p{__IN_PHAGS_Pa:=}');
    Error('\P{__IN_PHAGS_Pa:=}');
    Expect(1, 43135, '\p{inphagspa}', "");
    Expect(0, 43135, '\p{^inphagspa}', "");
    Expect(0, 43135, '\P{inphagspa}', "");
    Expect(1, 43135, '\P{^inphagspa}', "");
    Expect(0, 43136, '\p{inphagspa}', "");
    Expect(1, 43136, '\p{^inphagspa}', "");
    Expect(1, 43136, '\P{inphagspa}', "");
    Expect(0, 43136, '\P{^inphagspa}', "");
    Expect(1, 43135, '\p{	IN_phags_Pa}', "");
    Expect(0, 43135, '\p{^	IN_phags_Pa}', "");
    Expect(0, 43135, '\P{	IN_phags_Pa}', "");
    Expect(1, 43135, '\P{^	IN_phags_Pa}', "");
    Expect(0, 43136, '\p{	IN_phags_Pa}', "");
    Expect(1, 43136, '\p{^	IN_phags_Pa}', "");
    Expect(1, 43136, '\P{	IN_phags_Pa}', "");
    Expect(0, 43136, '\P{^	IN_phags_Pa}', "");
    Error('\p{-/a/In_phags_PA}');
    Error('\P{-/a/In_phags_PA}');
    Expect(1, 43135, '\p{ In_phags_Pa}', "");
    Expect(0, 43135, '\p{^ In_phags_Pa}', "");
    Expect(0, 43135, '\P{ In_phags_Pa}', "");
    Expect(1, 43135, '\P{^ In_phags_Pa}', "");
    Expect(0, 43136, '\p{ In_phags_Pa}', "");
    Expect(1, 43136, '\p{^ In_phags_Pa}', "");
    Expect(1, 43136, '\P{ In_phags_Pa}', "");
    Expect(0, 43136, '\P{^ In_phags_Pa}', "");
    Error('\p{/a/_ IN_PHOENICIAN}');
    Error('\P{/a/_ IN_PHOENICIAN}');
    Expect(1, 67871, '\p{inphoenician}', "");
    Expect(0, 67871, '\p{^inphoenician}', "");
    Expect(0, 67871, '\P{inphoenician}', "");
    Expect(1, 67871, '\P{^inphoenician}', "");
    Expect(0, 67872, '\p{inphoenician}', "");
    Expect(1, 67872, '\p{^inphoenician}', "");
    Expect(1, 67872, '\P{inphoenician}', "");
    Expect(0, 67872, '\P{^inphoenician}', "");
    Expect(1, 67871, '\p{ _In_Phoenician}', "");
    Expect(0, 67871, '\p{^ _In_Phoenician}', "");
    Expect(0, 67871, '\P{ _In_Phoenician}', "");
    Expect(1, 67871, '\P{^ _In_Phoenician}', "");
    Expect(0, 67872, '\p{ _In_Phoenician}', "");
    Expect(1, 67872, '\p{^ _In_Phoenician}', "");
    Expect(1, 67872, '\P{ _In_Phoenician}', "");
    Expect(0, 67872, '\P{^ _In_Phoenician}', "");
    Error('\p{/a/-_in_phoenician}');
    Error('\P{/a/-_in_phoenician}');
    Expect(1, 67871, '\p{	 In_PHOENICIAN}', "");
    Expect(0, 67871, '\p{^	 In_PHOENICIAN}', "");
    Expect(0, 67871, '\P{	 In_PHOENICIAN}', "");
    Expect(1, 67871, '\P{^	 In_PHOENICIAN}', "");
    Expect(0, 67872, '\p{	 In_PHOENICIAN}', "");
    Expect(1, 67872, '\p{^	 In_PHOENICIAN}', "");
    Expect(1, 67872, '\P{	 In_PHOENICIAN}', "");
    Expect(0, 67872, '\P{^	 In_PHOENICIAN}', "");
    Error('\p{	/a/In_psalter_pahlavi}');
    Error('\P{	/a/In_psalter_pahlavi}');
    Expect(1, 68527, '\p{inpsalterpahlavi}', "");
    Expect(0, 68527, '\p{^inpsalterpahlavi}', "");
    Expect(0, 68527, '\P{inpsalterpahlavi}', "");
    Expect(1, 68527, '\P{^inpsalterpahlavi}', "");
    Expect(0, 68528, '\p{inpsalterpahlavi}', "");
    Expect(1, 68528, '\p{^inpsalterpahlavi}', "");
    Expect(1, 68528, '\P{inpsalterpahlavi}', "");
    Expect(0, 68528, '\P{^inpsalterpahlavi}', "");
    Expect(1, 68527, '\p{ IN_Psalter_Pahlavi}', "");
    Expect(0, 68527, '\p{^ IN_Psalter_Pahlavi}', "");
    Expect(0, 68527, '\P{ IN_Psalter_Pahlavi}', "");
    Expect(1, 68527, '\P{^ IN_Psalter_Pahlavi}', "");
    Expect(0, 68528, '\p{ IN_Psalter_Pahlavi}', "");
    Expect(1, 68528, '\p{^ IN_Psalter_Pahlavi}', "");
    Expect(1, 68528, '\P{ IN_Psalter_Pahlavi}', "");
    Expect(0, 68528, '\P{^ IN_Psalter_Pahlavi}', "");
    Error('\p{	-in_Psalter_PAHLAVI/a/}');
    Error('\P{	-in_Psalter_PAHLAVI/a/}');
    Expect(1, 68527, '\p{_ In_Psalter_PAHLAVI}', "");
    Expect(0, 68527, '\p{^_ In_Psalter_PAHLAVI}', "");
    Expect(0, 68527, '\P{_ In_Psalter_PAHLAVI}', "");
    Expect(1, 68527, '\P{^_ In_Psalter_PAHLAVI}', "");
    Expect(0, 68528, '\p{_ In_Psalter_PAHLAVI}', "");
    Expect(1, 68528, '\p{^_ In_Psalter_PAHLAVI}', "");
    Expect(1, 68528, '\P{_ In_Psalter_PAHLAVI}', "");
    Expect(0, 68528, '\P{^_ In_Psalter_PAHLAVI}', "");
    Error('\p{In_Rejang/a/}');
    Error('\P{In_Rejang/a/}');
    Expect(1, 43359, '\p{inrejang}', "");
    Expect(0, 43359, '\p{^inrejang}', "");
    Expect(0, 43359, '\P{inrejang}', "");
    Expect(1, 43359, '\P{^inrejang}', "");
    Expect(0, 43360, '\p{inrejang}', "");
    Expect(1, 43360, '\p{^inrejang}', "");
    Expect(1, 43360, '\P{inrejang}', "");
    Expect(0, 43360, '\P{^inrejang}', "");
    Expect(1, 43359, '\p{--IN_Rejang}', "");
    Expect(0, 43359, '\p{^--IN_Rejang}', "");
    Expect(0, 43359, '\P{--IN_Rejang}', "");
    Expect(1, 43359, '\P{^--IN_Rejang}', "");
    Expect(0, 43360, '\p{--IN_Rejang}', "");
    Expect(1, 43360, '\p{^--IN_Rejang}', "");
    Expect(1, 43360, '\P{--IN_Rejang}', "");
    Expect(0, 43360, '\P{^--IN_Rejang}', "");
    Error('\p{ 	In_REJANG/a/}');
    Error('\P{ 	In_REJANG/a/}');
    Expect(1, 43359, '\p{ in_Rejang}', "");
    Expect(0, 43359, '\p{^ in_Rejang}', "");
    Expect(0, 43359, '\P{ in_Rejang}', "");
    Expect(1, 43359, '\P{^ in_Rejang}', "");
    Expect(0, 43360, '\p{ in_Rejang}', "");
    Expect(1, 43360, '\p{^ in_Rejang}', "");
    Expect(1, 43360, '\P{ in_Rejang}', "");
    Expect(0, 43360, '\P{^ in_Rejang}', "");
    Error('\p{ /a/In_Runic}');
    Error('\P{ /a/In_Runic}');
    Expect(1, 5887, '\p{inrunic}', "");
    Expect(0, 5887, '\p{^inrunic}', "");
    Expect(0, 5887, '\P{inrunic}', "");
    Expect(1, 5887, '\P{^inrunic}', "");
    Expect(0, 5888, '\p{inrunic}', "");
    Expect(1, 5888, '\p{^inrunic}', "");
    Expect(1, 5888, '\P{inrunic}', "");
    Expect(0, 5888, '\P{^inrunic}', "");
    Expect(1, 5887, '\p{_in_RUNIC}', "");
    Expect(0, 5887, '\p{^_in_RUNIC}', "");
    Expect(0, 5887, '\P{_in_RUNIC}', "");
    Expect(1, 5887, '\P{^_in_RUNIC}', "");
    Expect(0, 5888, '\p{_in_RUNIC}', "");
    Expect(1, 5888, '\p{^_in_RUNIC}', "");
    Expect(1, 5888, '\P{_in_RUNIC}', "");
    Expect(0, 5888, '\P{^_in_RUNIC}', "");
    Error('\p{ _In_Runic:=}');
    Error('\P{ _In_Runic:=}');
    Expect(1, 5887, '\p{	in_Runic}', "");
    Expect(0, 5887, '\p{^	in_Runic}', "");
    Expect(0, 5887, '\P{	in_Runic}', "");
    Expect(1, 5887, '\P{^	in_Runic}', "");
    Expect(0, 5888, '\p{	in_Runic}', "");
    Expect(1, 5888, '\p{^	in_Runic}', "");
    Expect(1, 5888, '\P{	in_Runic}', "");
    Expect(0, 5888, '\P{^	in_Runic}', "");
    Error('\p{_	In_SAMARITAN/a/}');
    Error('\P{_	In_SAMARITAN/a/}');
    Expect(1, 2111, '\p{insamaritan}', "");
    Expect(0, 2111, '\p{^insamaritan}', "");
    Expect(0, 2111, '\P{insamaritan}', "");
    Expect(1, 2111, '\P{^insamaritan}', "");
    Expect(0, 2112, '\p{insamaritan}', "");
    Expect(1, 2112, '\p{^insamaritan}', "");
    Expect(1, 2112, '\P{insamaritan}', "");
    Expect(0, 2112, '\P{^insamaritan}', "");
    Expect(1, 2111, '\p{-_In_samaritan}', "");
    Expect(0, 2111, '\p{^-_In_samaritan}', "");
    Expect(0, 2111, '\P{-_In_samaritan}', "");
    Expect(1, 2111, '\P{^-_In_samaritan}', "");
    Expect(0, 2112, '\p{-_In_samaritan}', "");
    Expect(1, 2112, '\p{^-_In_samaritan}', "");
    Expect(1, 2112, '\P{-_In_samaritan}', "");
    Expect(0, 2112, '\P{^-_In_samaritan}', "");
    Error('\p{_-in_Samaritan/a/}');
    Error('\P{_-in_Samaritan/a/}');
    Expect(1, 2111, '\p{--IN_Samaritan}', "");
    Expect(0, 2111, '\p{^--IN_Samaritan}', "");
    Expect(0, 2111, '\P{--IN_Samaritan}', "");
    Expect(1, 2111, '\P{^--IN_Samaritan}', "");
    Expect(0, 2112, '\p{--IN_Samaritan}', "");
    Expect(1, 2112, '\p{^--IN_Samaritan}', "");
    Expect(1, 2112, '\P{--IN_Samaritan}', "");
    Expect(0, 2112, '\P{^--IN_Samaritan}', "");
    Error('\p{:=In_SAURASHTRA}');
    Error('\P{:=In_SAURASHTRA}');
    Expect(1, 43231, '\p{insaurashtra}', "");
    Expect(0, 43231, '\p{^insaurashtra}', "");
    Expect(0, 43231, '\P{insaurashtra}', "");
    Expect(1, 43231, '\P{^insaurashtra}', "");
    Expect(0, 43232, '\p{insaurashtra}', "");
    Expect(1, 43232, '\p{^insaurashtra}', "");
    Expect(1, 43232, '\P{insaurashtra}', "");
    Expect(0, 43232, '\P{^insaurashtra}', "");
    Expect(1, 43231, '\p{ 	In_saurashtra}', "");
    Expect(0, 43231, '\p{^ 	In_saurashtra}', "");
    Expect(0, 43231, '\P{ 	In_saurashtra}', "");
    Expect(1, 43231, '\P{^ 	In_saurashtra}', "");
    Expect(0, 43232, '\p{ 	In_saurashtra}', "");
    Expect(1, 43232, '\p{^ 	In_saurashtra}', "");
    Expect(1, 43232, '\P{ 	In_saurashtra}', "");
    Expect(0, 43232, '\P{^ 	In_saurashtra}', "");
    Error('\p{ -IN_SAURASHTRA:=}');
    Error('\P{ -IN_SAURASHTRA:=}');
    Expect(1, 43231, '\p{	 In_Saurashtra}', "");
    Expect(0, 43231, '\p{^	 In_Saurashtra}', "");
    Expect(0, 43231, '\P{	 In_Saurashtra}', "");
    Expect(1, 43231, '\P{^	 In_Saurashtra}', "");
    Expect(0, 43232, '\p{	 In_Saurashtra}', "");
    Expect(1, 43232, '\p{^	 In_Saurashtra}', "");
    Expect(1, 43232, '\P{	 In_Saurashtra}', "");
    Expect(0, 43232, '\P{^	 In_Saurashtra}', "");
    Error('\p{ _In_Sharada/a/}');
    Error('\P{ _In_Sharada/a/}');
    Expect(1, 70111, '\p{insharada}', "");
    Expect(0, 70111, '\p{^insharada}', "");
    Expect(0, 70111, '\P{insharada}', "");
    Expect(1, 70111, '\P{^insharada}', "");
    Expect(0, 70112, '\p{insharada}', "");
    Expect(1, 70112, '\p{^insharada}', "");
    Expect(1, 70112, '\P{insharada}', "");
    Expect(0, 70112, '\P{^insharada}', "");
    Expect(1, 70111, '\p{	-in_sharada}', "");
    Expect(0, 70111, '\p{^	-in_sharada}', "");
    Expect(0, 70111, '\P{	-in_sharada}', "");
    Expect(1, 70111, '\P{^	-in_sharada}', "");
    Expect(0, 70112, '\p{	-in_sharada}', "");
    Expect(1, 70112, '\p{^	-in_sharada}', "");
    Expect(1, 70112, '\P{	-in_sharada}', "");
    Expect(0, 70112, '\P{^	-in_sharada}', "");
    Error('\p{:=-_IN_Sharada}');
    Error('\P{:=-_IN_Sharada}');
    Expect(1, 70111, '\p{ -IN_SHARADA}', "");
    Expect(0, 70111, '\p{^ -IN_SHARADA}', "");
    Expect(0, 70111, '\P{ -IN_SHARADA}', "");
    Expect(1, 70111, '\P{^ -IN_SHARADA}', "");
    Expect(0, 70112, '\p{ -IN_SHARADA}', "");
    Expect(1, 70112, '\p{^ -IN_SHARADA}', "");
    Expect(1, 70112, '\P{ -IN_SHARADA}', "");
    Expect(0, 70112, '\P{^ -IN_SHARADA}', "");
    Error('\p{/a/	-IN_Shavian}');
    Error('\P{/a/	-IN_Shavian}');
    Expect(1, 66687, '\p{inshavian}', "");
    Expect(0, 66687, '\p{^inshavian}', "");
    Expect(0, 66687, '\P{inshavian}', "");
    Expect(1, 66687, '\P{^inshavian}', "");
    Expect(0, 66688, '\p{inshavian}', "");
    Expect(1, 66688, '\p{^inshavian}', "");
    Expect(1, 66688, '\P{inshavian}', "");
    Expect(0, 66688, '\P{^inshavian}', "");
    Expect(1, 66687, '\p{		In_SHAVIAN}', "");
    Expect(0, 66687, '\p{^		In_SHAVIAN}', "");
    Expect(0, 66687, '\P{		In_SHAVIAN}', "");
    Expect(1, 66687, '\P{^		In_SHAVIAN}', "");
    Expect(0, 66688, '\p{		In_SHAVIAN}', "");
    Expect(1, 66688, '\p{^		In_SHAVIAN}', "");
    Expect(1, 66688, '\P{		In_SHAVIAN}', "");
    Expect(0, 66688, '\P{^		In_SHAVIAN}', "");
    Error('\p{:=_ In_Shavian}');
    Error('\P{:=_ In_Shavian}');
    Expect(1, 66687, '\p{ -IN_Shavian}', "");
    Expect(0, 66687, '\p{^ -IN_Shavian}', "");
    Expect(0, 66687, '\P{ -IN_Shavian}', "");
    Expect(1, 66687, '\P{^ -IN_Shavian}', "");
    Expect(0, 66688, '\p{ -IN_Shavian}', "");
    Expect(1, 66688, '\p{^ -IN_Shavian}', "");
    Expect(1, 66688, '\P{ -IN_Shavian}', "");
    Expect(0, 66688, '\P{^ -IN_Shavian}', "");
    Error('\p{_in_Siddham/a/}');
    Error('\P{_in_Siddham/a/}');
    Expect(1, 71167, '\p{insiddham}', "");
    Expect(0, 71167, '\p{^insiddham}', "");
    Expect(0, 71167, '\P{insiddham}', "");
    Expect(1, 71167, '\P{^insiddham}', "");
    Expect(0, 71168, '\p{insiddham}', "");
    Expect(1, 71168, '\p{^insiddham}', "");
    Expect(1, 71168, '\P{insiddham}', "");
    Expect(0, 71168, '\P{^insiddham}', "");
    Expect(1, 71167, '\p{	In_siddham}', "");
    Expect(0, 71167, '\p{^	In_siddham}', "");
    Expect(0, 71167, '\P{	In_siddham}', "");
    Expect(1, 71167, '\P{^	In_siddham}', "");
    Expect(0, 71168, '\p{	In_siddham}', "");
    Expect(1, 71168, '\p{^	In_siddham}', "");
    Expect(1, 71168, '\P{	In_siddham}', "");
    Expect(0, 71168, '\P{^	In_siddham}', "");
    Error('\p{	:=In_SIDDHAM}');
    Error('\P{	:=In_SIDDHAM}');
    Expect(1, 71167, '\p{ -In_Siddham}', "");
    Expect(0, 71167, '\p{^ -In_Siddham}', "");
    Expect(0, 71167, '\P{ -In_Siddham}', "");
    Expect(1, 71167, '\P{^ -In_Siddham}', "");
    Expect(0, 71168, '\p{ -In_Siddham}', "");
    Expect(1, 71168, '\p{^ -In_Siddham}', "");
    Expect(1, 71168, '\P{ -In_Siddham}', "");
    Expect(0, 71168, '\P{^ -In_Siddham}', "");
    Error('\p{/a/-In_Sinhala}');
    Error('\P{/a/-In_Sinhala}');
    Expect(1, 3583, '\p{insinhala}', "");
    Expect(0, 3583, '\p{^insinhala}', "");
    Expect(0, 3583, '\P{insinhala}', "");
    Expect(1, 3583, '\P{^insinhala}', "");
    Expect(0, 3584, '\p{insinhala}', "");
    Expect(1, 3584, '\p{^insinhala}', "");
    Expect(1, 3584, '\P{insinhala}', "");
    Expect(0, 3584, '\P{^insinhala}', "");
    Expect(1, 3583, '\p{_in_Sinhala}', "");
    Expect(0, 3583, '\p{^_in_Sinhala}', "");
    Expect(0, 3583, '\P{_in_Sinhala}', "");
    Expect(1, 3583, '\P{^_in_Sinhala}', "");
    Expect(0, 3584, '\p{_in_Sinhala}', "");
    Expect(1, 3584, '\p{^_in_Sinhala}', "");
    Expect(1, 3584, '\P{_in_Sinhala}', "");
    Expect(0, 3584, '\P{^_in_Sinhala}', "");
    Error('\p{ /a/IN_SINHALA}');
    Error('\P{ /a/IN_SINHALA}');
    Expect(1, 3583, '\p{	_IN_SINHALA}', "");
    Expect(0, 3583, '\p{^	_IN_SINHALA}', "");
    Expect(0, 3583, '\P{	_IN_SINHALA}', "");
    Expect(1, 3583, '\P{^	_IN_SINHALA}', "");
    Expect(0, 3584, '\p{	_IN_SINHALA}', "");
    Expect(1, 3584, '\p{^	_IN_SINHALA}', "");
    Expect(1, 3584, '\P{	_IN_SINHALA}', "");
    Expect(0, 3584, '\P{^	_IN_SINHALA}', "");
    Error('\p{ in_SORA_SOMPENG/a/}');
    Error('\P{ in_SORA_SOMPENG/a/}');
    Expect(1, 69887, '\p{insorasompeng}', "");
    Expect(0, 69887, '\p{^insorasompeng}', "");
    Expect(0, 69887, '\P{insorasompeng}', "");
    Expect(1, 69887, '\P{^insorasompeng}', "");
    Expect(0, 69888, '\p{insorasompeng}', "");
    Expect(1, 69888, '\p{^insorasompeng}', "");
    Expect(1, 69888, '\P{insorasompeng}', "");
    Expect(0, 69888, '\P{^insorasompeng}', "");
    Expect(1, 69887, '\p{__in_sora_Sompeng}', "");
    Expect(0, 69887, '\p{^__in_sora_Sompeng}', "");
    Expect(0, 69887, '\P{__in_sora_Sompeng}', "");
    Expect(1, 69887, '\P{^__in_sora_Sompeng}', "");
    Expect(0, 69888, '\p{__in_sora_Sompeng}', "");
    Expect(1, 69888, '\p{^__in_sora_Sompeng}', "");
    Expect(1, 69888, '\P{__in_sora_Sompeng}', "");
    Expect(0, 69888, '\P{^__in_sora_Sompeng}', "");
    Error('\p{:=-_in_SORA_Sompeng}');
    Error('\P{:=-_in_SORA_Sompeng}');
    Expect(1, 69887, '\p{	-IN_SORA_SOMPENG}', "");
    Expect(0, 69887, '\p{^	-IN_SORA_SOMPENG}', "");
    Expect(0, 69887, '\P{	-IN_SORA_SOMPENG}', "");
    Expect(1, 69887, '\P{^	-IN_SORA_SOMPENG}', "");
    Expect(0, 69888, '\p{	-IN_SORA_SOMPENG}', "");
    Expect(1, 69888, '\p{^	-IN_SORA_SOMPENG}', "");
    Expect(1, 69888, '\P{	-IN_SORA_SOMPENG}', "");
    Expect(0, 69888, '\P{^	-IN_SORA_SOMPENG}', "");
    Error('\p{ /a/IN_soyombo}');
    Error('\P{ /a/IN_soyombo}');
    Expect(1, 72367, '\p{insoyombo}', "");
    Expect(0, 72367, '\p{^insoyombo}', "");
    Expect(0, 72367, '\P{insoyombo}', "");
    Expect(1, 72367, '\P{^insoyombo}', "");
    Expect(0, 72368, '\p{insoyombo}', "");
    Expect(1, 72368, '\p{^insoyombo}', "");
    Expect(1, 72368, '\P{insoyombo}', "");
    Expect(0, 72368, '\P{^insoyombo}', "");
    Expect(1, 72367, '\p{	-IN_Soyombo}', "");
    Expect(0, 72367, '\p{^	-IN_Soyombo}', "");
    Expect(0, 72367, '\P{	-IN_Soyombo}', "");
    Expect(1, 72367, '\P{^	-IN_Soyombo}', "");
    Expect(0, 72368, '\p{	-IN_Soyombo}', "");
    Expect(1, 72368, '\p{^	-IN_Soyombo}', "");
    Expect(1, 72368, '\P{	-IN_Soyombo}', "");
    Expect(0, 72368, '\P{^	-IN_Soyombo}', "");
    Error('\p{	/a/IN_Soyombo}');
    Error('\P{	/a/IN_Soyombo}');
    Expect(1, 72367, '\p{	 In_SOYOMBO}', "");
    Expect(0, 72367, '\p{^	 In_SOYOMBO}', "");
    Expect(0, 72367, '\P{	 In_SOYOMBO}', "");
    Expect(1, 72367, '\P{^	 In_SOYOMBO}', "");
    Expect(0, 72368, '\p{	 In_SOYOMBO}', "");
    Expect(1, 72368, '\p{^	 In_SOYOMBO}', "");
    Expect(1, 72368, '\P{	 In_SOYOMBO}', "");
    Expect(0, 72368, '\P{^	 In_SOYOMBO}', "");
    Error('\p{_/a/In_Sundanese}');
    Error('\P{_/a/In_Sundanese}');
    Expect(1, 7103, '\p{insundanese}', "");
    Expect(0, 7103, '\p{^insundanese}', "");
    Expect(0, 7103, '\P{insundanese}', "");
    Expect(1, 7103, '\P{^insundanese}', "");
    Expect(0, 7104, '\p{insundanese}', "");
    Expect(1, 7104, '\p{^insundanese}', "");
    Expect(1, 7104, '\P{insundanese}', "");
    Expect(0, 7104, '\P{^insundanese}', "");
    Expect(1, 7103, '\p{	IN_SUNDANESE}', "");
    Expect(0, 7103, '\p{^	IN_SUNDANESE}', "");
    Expect(0, 7103, '\P{	IN_SUNDANESE}', "");
    Expect(1, 7103, '\P{^	IN_SUNDANESE}', "");
    Expect(0, 7104, '\p{	IN_SUNDANESE}', "");
    Expect(1, 7104, '\p{^	IN_SUNDANESE}', "");
    Expect(1, 7104, '\P{	IN_SUNDANESE}', "");
    Expect(0, 7104, '\P{^	IN_SUNDANESE}', "");
    Error('\p{/a/ IN_Sundanese}');
    Error('\P{/a/ IN_Sundanese}');
    Expect(1, 7103, '\p{_-IN_Sundanese}', "");
    Expect(0, 7103, '\p{^_-IN_Sundanese}', "");
    Expect(0, 7103, '\P{_-IN_Sundanese}', "");
    Expect(1, 7103, '\P{^_-IN_Sundanese}', "");
    Expect(0, 7104, '\p{_-IN_Sundanese}', "");
    Expect(1, 7104, '\p{^_-IN_Sundanese}', "");
    Expect(1, 7104, '\P{_-IN_Sundanese}', "");
    Expect(0, 7104, '\P{^_-IN_Sundanese}', "");
    Error('\p{_ In_syloti_Nagri/a/}');
    Error('\P{_ In_syloti_Nagri/a/}');
    Expect(1, 43055, '\p{insylotinagri}', "");
    Expect(0, 43055, '\p{^insylotinagri}', "");
    Expect(0, 43055, '\P{insylotinagri}', "");
    Expect(1, 43055, '\P{^insylotinagri}', "");
    Expect(0, 43056, '\p{insylotinagri}', "");
    Expect(1, 43056, '\p{^insylotinagri}', "");
    Expect(1, 43056, '\P{insylotinagri}', "");
    Expect(0, 43056, '\P{^insylotinagri}', "");
    Expect(1, 43055, '\p{_ In_SYLOTI_Nagri}', "");
    Expect(0, 43055, '\p{^_ In_SYLOTI_Nagri}', "");
    Expect(0, 43055, '\P{_ In_SYLOTI_Nagri}', "");
    Expect(1, 43055, '\P{^_ In_SYLOTI_Nagri}', "");
    Expect(0, 43056, '\p{_ In_SYLOTI_Nagri}', "");
    Expect(1, 43056, '\p{^_ In_SYLOTI_Nagri}', "");
    Expect(1, 43056, '\P{_ In_SYLOTI_Nagri}', "");
    Expect(0, 43056, '\P{^_ In_SYLOTI_Nagri}', "");
    Error('\p{	in_Syloti_Nagri:=}');
    Error('\P{	in_Syloti_Nagri:=}');
    Expect(1, 43055, '\p{	 IN_Syloti_nagri}', "");
    Expect(0, 43055, '\p{^	 IN_Syloti_nagri}', "");
    Expect(0, 43055, '\P{	 IN_Syloti_nagri}', "");
    Expect(1, 43055, '\P{^	 IN_Syloti_nagri}', "");
    Expect(0, 43056, '\p{	 IN_Syloti_nagri}', "");
    Expect(1, 43056, '\p{^	 IN_Syloti_nagri}', "");
    Expect(1, 43056, '\P{	 IN_Syloti_nagri}', "");
    Expect(0, 43056, '\P{^	 IN_Syloti_nagri}', "");
    Error('\p{:=_-in_syriac}');
    Error('\P{:=_-in_syriac}');
    Expect(1, 1871, '\p{insyriac}', "");
    Expect(0, 1871, '\p{^insyriac}', "");
    Expect(0, 1871, '\P{insyriac}', "");
    Expect(1, 1871, '\P{^insyriac}', "");
    Expect(0, 1872, '\p{insyriac}', "");
    Expect(1, 1872, '\p{^insyriac}', "");
    Expect(1, 1872, '\P{insyriac}', "");
    Expect(0, 1872, '\P{^insyriac}', "");
    Expect(1, 1871, '\p{  IN_Syriac}', "");
    Expect(0, 1871, '\p{^  IN_Syriac}', "");
    Expect(0, 1871, '\P{  IN_Syriac}', "");
    Expect(1, 1871, '\P{^  IN_Syriac}', "");
    Expect(0, 1872, '\p{  IN_Syriac}', "");
    Expect(1, 1872, '\p{^  IN_Syriac}', "");
    Expect(1, 1872, '\P{  IN_Syriac}', "");
    Expect(0, 1872, '\P{^  IN_Syriac}', "");
    Error('\p{ _in_SYRIAC/a/}');
    Error('\P{ _in_SYRIAC/a/}');
    Expect(1, 1871, '\p{-	In_SYRIAC}', "");
    Expect(0, 1871, '\p{^-	In_SYRIAC}', "");
    Expect(0, 1871, '\P{-	In_SYRIAC}', "");
    Expect(1, 1871, '\P{^-	In_SYRIAC}', "");
    Expect(0, 1872, '\p{-	In_SYRIAC}', "");
    Expect(1, 1872, '\p{^-	In_SYRIAC}', "");
    Expect(1, 1872, '\P{-	In_SYRIAC}', "");
    Expect(0, 1872, '\P{^-	In_SYRIAC}', "");
    Error('\p{_:=In_Tagalog}');
    Error('\P{_:=In_Tagalog}');
    Expect(1, 5919, '\p{intagalog}', "");
    Expect(0, 5919, '\p{^intagalog}', "");
    Expect(0, 5919, '\P{intagalog}', "");
    Expect(1, 5919, '\P{^intagalog}', "");
    Expect(0, 5920, '\p{intagalog}', "");
    Expect(1, 5920, '\p{^intagalog}', "");
    Expect(1, 5920, '\P{intagalog}', "");
    Expect(0, 5920, '\P{^intagalog}', "");
    Expect(1, 5919, '\p{	_in_TAGALOG}', "");
    Expect(0, 5919, '\p{^	_in_TAGALOG}', "");
    Expect(0, 5919, '\P{	_in_TAGALOG}', "");
    Expect(1, 5919, '\P{^	_in_TAGALOG}', "");
    Expect(0, 5920, '\p{	_in_TAGALOG}', "");
    Expect(1, 5920, '\p{^	_in_TAGALOG}', "");
    Expect(1, 5920, '\P{	_in_TAGALOG}', "");
    Expect(0, 5920, '\P{^	_in_TAGALOG}', "");
    Error('\p{-	in_tagalog:=}');
    Error('\P{-	in_tagalog:=}');
    Expect(1, 5919, '\p{	-In_TAGALOG}', "");
    Expect(0, 5919, '\p{^	-In_TAGALOG}', "");
    Expect(0, 5919, '\P{	-In_TAGALOG}', "");
    Expect(1, 5919, '\P{^	-In_TAGALOG}', "");
    Expect(0, 5920, '\p{	-In_TAGALOG}', "");
    Expect(1, 5920, '\p{^	-In_TAGALOG}', "");
    Expect(1, 5920, '\P{	-In_TAGALOG}', "");
    Expect(0, 5920, '\P{^	-In_TAGALOG}', "");
    Error('\p{	In_Tagbanwa:=}');
    Error('\P{	In_Tagbanwa:=}');
    Expect(1, 6015, '\p{intagbanwa}', "");
    Expect(0, 6015, '\p{^intagbanwa}', "");
    Expect(0, 6015, '\P{intagbanwa}', "");
    Expect(1, 6015, '\P{^intagbanwa}', "");
    Expect(0, 6016, '\p{intagbanwa}', "");
    Expect(1, 6016, '\p{^intagbanwa}', "");
    Expect(1, 6016, '\P{intagbanwa}', "");
    Expect(0, 6016, '\P{^intagbanwa}', "");
    Expect(1, 6015, '\p{ in_Tagbanwa}', "");
    Expect(0, 6015, '\p{^ in_Tagbanwa}', "");
    Expect(0, 6015, '\P{ in_Tagbanwa}', "");
    Expect(1, 6015, '\P{^ in_Tagbanwa}', "");
    Expect(0, 6016, '\p{ in_Tagbanwa}', "");
    Expect(1, 6016, '\p{^ in_Tagbanwa}', "");
    Expect(1, 6016, '\P{ in_Tagbanwa}', "");
    Expect(0, 6016, '\P{^ in_Tagbanwa}', "");
    Error('\p{:= _In_TAGBANWA}');
    Error('\P{:= _In_TAGBANWA}');
    Expect(1, 6015, '\p{_-In_tagbanwa}', "");
    Expect(0, 6015, '\p{^_-In_tagbanwa}', "");
    Expect(0, 6015, '\P{_-In_tagbanwa}', "");
    Expect(1, 6015, '\P{^_-In_tagbanwa}', "");
    Expect(0, 6016, '\p{_-In_tagbanwa}', "");
    Expect(1, 6016, '\p{^_-In_tagbanwa}', "");
    Expect(1, 6016, '\P{_-In_tagbanwa}', "");
    Expect(0, 6016, '\P{^_-In_tagbanwa}', "");
    Error('\p{_:=IN_Tai_LE}');
    Error('\P{_:=IN_Tai_LE}');
    Expect(1, 6527, '\p{intaile}', "");
    Expect(0, 6527, '\p{^intaile}', "");
    Expect(0, 6527, '\P{intaile}', "");
    Expect(1, 6527, '\P{^intaile}', "");
    Expect(0, 6528, '\p{intaile}', "");
    Expect(1, 6528, '\p{^intaile}', "");
    Expect(1, 6528, '\P{intaile}', "");
    Expect(0, 6528, '\P{^intaile}', "");
    Expect(1, 6527, '\p{ _In_tai_le}', "");
    Expect(0, 6527, '\p{^ _In_tai_le}', "");
    Expect(0, 6527, '\P{ _In_tai_le}', "");
    Expect(1, 6527, '\P{^ _In_tai_le}', "");
    Expect(0, 6528, '\p{ _In_tai_le}', "");
    Expect(1, 6528, '\p{^ _In_tai_le}', "");
    Expect(1, 6528, '\P{ _In_tai_le}', "");
    Expect(0, 6528, '\P{^ _In_tai_le}', "");
    Error('\p{/a/	 in_TAI_LE}');
    Error('\P{/a/	 in_TAI_LE}');
    Expect(1, 6527, '\p{ -In_TAI_LE}', "");
    Expect(0, 6527, '\p{^ -In_TAI_LE}', "");
    Expect(0, 6527, '\P{ -In_TAI_LE}', "");
    Expect(1, 6527, '\P{^ -In_TAI_LE}', "");
    Expect(0, 6528, '\p{ -In_TAI_LE}', "");
    Expect(1, 6528, '\p{^ -In_TAI_LE}', "");
    Expect(1, 6528, '\P{ -In_TAI_LE}', "");
    Expect(0, 6528, '\P{^ -In_TAI_LE}', "");
    Error('\p{/a/	In_tai_Tham}');
    Error('\P{/a/	In_tai_Tham}');
    Expect(1, 6831, '\p{intaitham}', "");
    Expect(0, 6831, '\p{^intaitham}', "");
    Expect(0, 6831, '\P{intaitham}', "");
    Expect(1, 6831, '\P{^intaitham}', "");
    Expect(0, 6832, '\p{intaitham}', "");
    Expect(1, 6832, '\p{^intaitham}', "");
    Expect(1, 6832, '\P{intaitham}', "");
    Expect(0, 6832, '\P{^intaitham}', "");
    Expect(1, 6831, '\p{-In_TAI_tham}', "");
    Expect(0, 6831, '\p{^-In_TAI_tham}', "");
    Expect(0, 6831, '\P{-In_TAI_tham}', "");
    Expect(1, 6831, '\P{^-In_TAI_tham}', "");
    Expect(0, 6832, '\p{-In_TAI_tham}', "");
    Expect(1, 6832, '\p{^-In_TAI_tham}', "");
    Expect(1, 6832, '\P{-In_TAI_tham}', "");
    Expect(0, 6832, '\P{^-In_TAI_tham}', "");
    Error('\p{__in_TAI_Tham:=}');
    Error('\P{__in_TAI_Tham:=}');
    Expect(1, 6831, '\p{-in_Tai_tham}', "");
    Expect(0, 6831, '\p{^-in_Tai_tham}', "");
    Expect(0, 6831, '\P{-in_Tai_tham}', "");
    Expect(1, 6831, '\P{^-in_Tai_tham}', "");
    Expect(0, 6832, '\p{-in_Tai_tham}', "");
    Expect(1, 6832, '\p{^-in_Tai_tham}', "");
    Expect(1, 6832, '\P{-in_Tai_tham}', "");
    Expect(0, 6832, '\P{^-in_Tai_tham}', "");
    Error('\p{/a/ -in_Tai_VIET}');
    Error('\P{/a/ -in_Tai_VIET}');
    Expect(1, 43743, '\p{intaiviet}', "");
    Expect(0, 43743, '\p{^intaiviet}', "");
    Expect(0, 43743, '\P{intaiviet}', "");
    Expect(1, 43743, '\P{^intaiviet}', "");
    Expect(0, 43744, '\p{intaiviet}', "");
    Expect(1, 43744, '\p{^intaiviet}', "");
    Expect(1, 43744, '\P{intaiviet}', "");
    Expect(0, 43744, '\P{^intaiviet}', "");
    Expect(1, 43743, '\p{__In_Tai_Viet}', "");
    Expect(0, 43743, '\p{^__In_Tai_Viet}', "");
    Expect(0, 43743, '\P{__In_Tai_Viet}', "");
    Expect(1, 43743, '\P{^__In_Tai_Viet}', "");
    Expect(0, 43744, '\p{__In_Tai_Viet}', "");
    Expect(1, 43744, '\p{^__In_Tai_Viet}', "");
    Expect(1, 43744, '\P{__In_Tai_Viet}', "");
    Expect(0, 43744, '\P{^__In_Tai_Viet}', "");
    Error('\p{-_IN_Tai_VIET:=}');
    Error('\P{-_IN_Tai_VIET:=}');
    Expect(1, 43743, '\p{_In_Tai_VIET}', "");
    Expect(0, 43743, '\p{^_In_Tai_VIET}', "");
    Expect(0, 43743, '\P{_In_Tai_VIET}', "");
    Expect(1, 43743, '\P{^_In_Tai_VIET}', "");
    Expect(0, 43744, '\p{_In_Tai_VIET}', "");
    Expect(1, 43744, '\p{^_In_Tai_VIET}', "");
    Expect(1, 43744, '\P{_In_Tai_VIET}', "");
    Expect(0, 43744, '\P{^_In_Tai_VIET}', "");
    Error('\p{-IN_Takri:=}');
    Error('\P{-IN_Takri:=}');
    Expect(1, 71375, '\p{intakri}', "");
    Expect(0, 71375, '\p{^intakri}', "");
    Expect(0, 71375, '\P{intakri}', "");
    Expect(1, 71375, '\P{^intakri}', "");
    Expect(0, 71376, '\p{intakri}', "");
    Expect(1, 71376, '\p{^intakri}', "");
    Expect(1, 71376, '\P{intakri}', "");
    Expect(0, 71376, '\P{^intakri}', "");
    Expect(1, 71375, '\p{__In_Takri}', "");
    Expect(0, 71375, '\p{^__In_Takri}', "");
    Expect(0, 71375, '\P{__In_Takri}', "");
    Expect(1, 71375, '\P{^__In_Takri}', "");
    Expect(0, 71376, '\p{__In_Takri}', "");
    Expect(1, 71376, '\p{^__In_Takri}', "");
    Expect(1, 71376, '\P{__In_Takri}', "");
    Expect(0, 71376, '\P{^__In_Takri}', "");
    Error('\p{:=	 in_Takri}');
    Error('\P{:=	 in_Takri}');
    Expect(1, 71375, '\p{-in_TAKRI}', "");
    Expect(0, 71375, '\p{^-in_TAKRI}', "");
    Expect(0, 71375, '\P{-in_TAKRI}', "");
    Expect(1, 71375, '\P{^-in_TAKRI}', "");
    Expect(0, 71376, '\p{-in_TAKRI}', "");
    Expect(1, 71376, '\p{^-in_TAKRI}', "");
    Expect(1, 71376, '\P{-in_TAKRI}', "");
    Expect(0, 71376, '\P{^-in_TAKRI}', "");
    Error('\p{	In_Tamil/a/}');
    Error('\P{	In_Tamil/a/}');
    Expect(1, 3071, '\p{intamil}', "");
    Expect(0, 3071, '\p{^intamil}', "");
    Expect(0, 3071, '\P{intamil}', "");
    Expect(1, 3071, '\P{^intamil}', "");
    Expect(0, 3072, '\p{intamil}', "");
    Expect(1, 3072, '\p{^intamil}', "");
    Expect(1, 3072, '\P{intamil}', "");
    Expect(0, 3072, '\P{^intamil}', "");
    Expect(1, 3071, '\p{ 	In_Tamil}', "");
    Expect(0, 3071, '\p{^ 	In_Tamil}', "");
    Expect(0, 3071, '\P{ 	In_Tamil}', "");
    Expect(1, 3071, '\P{^ 	In_Tamil}', "");
    Expect(0, 3072, '\p{ 	In_Tamil}', "");
    Expect(1, 3072, '\p{^ 	In_Tamil}', "");
    Expect(1, 3072, '\P{ 	In_Tamil}', "");
    Expect(0, 3072, '\P{^ 	In_Tamil}', "");
    Error('\p{:=-In_tamil}');
    Error('\P{:=-In_tamil}');
    Expect(1, 3071, '\p{--in_TAMIL}', "");
    Expect(0, 3071, '\p{^--in_TAMIL}', "");
    Expect(0, 3071, '\P{--in_TAMIL}', "");
    Expect(1, 3071, '\P{^--in_TAMIL}', "");
    Expect(0, 3072, '\p{--in_TAMIL}', "");
    Expect(1, 3072, '\p{^--in_TAMIL}', "");
    Expect(1, 3072, '\P{--in_TAMIL}', "");
    Expect(0, 3072, '\P{^--in_TAMIL}', "");
    Error('\p{-in_tangut/a/}');
    Error('\P{-in_tangut/a/}');
    Expect(1, 100351, '\p{intangut}', "");
    Expect(0, 100351, '\p{^intangut}', "");
    Expect(0, 100351, '\P{intangut}', "");
    Expect(1, 100351, '\P{^intangut}', "");
    Expect(0, 100352, '\p{intangut}', "");
    Expect(1, 100352, '\p{^intangut}', "");
    Expect(1, 100352, '\P{intangut}', "");
    Expect(0, 100352, '\P{^intangut}', "");
    Expect(1, 100351, '\p{--In_Tangut}', "");
    Expect(0, 100351, '\p{^--In_Tangut}', "");
    Expect(0, 100351, '\P{--In_Tangut}', "");
    Expect(1, 100351, '\P{^--In_Tangut}', "");
    Expect(0, 100352, '\p{--In_Tangut}', "");
    Expect(1, 100352, '\p{^--In_Tangut}', "");
    Expect(1, 100352, '\P{--In_Tangut}', "");
    Expect(0, 100352, '\P{^--In_Tangut}', "");
    Error('\p{:=-	in_Tangut}');
    Error('\P{:=-	in_Tangut}');
    Expect(1, 100351, '\p{In_Tangut}', "");
    Expect(0, 100351, '\p{^In_Tangut}', "");
    Expect(0, 100351, '\P{In_Tangut}', "");
    Expect(1, 100351, '\P{^In_Tangut}', "");
    Expect(0, 100352, '\p{In_Tangut}', "");
    Expect(1, 100352, '\p{^In_Tangut}', "");
    Expect(1, 100352, '\P{In_Tangut}', "");
    Expect(0, 100352, '\P{^In_Tangut}', "");
    Error('\p{:=	IN_TELUGU}');
    Error('\P{:=	IN_TELUGU}');
    Expect(1, 3199, '\p{intelugu}', "");
    Expect(0, 3199, '\p{^intelugu}', "");
    Expect(0, 3199, '\P{intelugu}', "");
    Expect(1, 3199, '\P{^intelugu}', "");
    Expect(0, 3200, '\p{intelugu}', "");
    Expect(1, 3200, '\p{^intelugu}', "");
    Expect(1, 3200, '\P{intelugu}', "");
    Expect(0, 3200, '\P{^intelugu}', "");
    Expect(1, 3199, '\p{_In_telugu}', "");
    Expect(0, 3199, '\p{^_In_telugu}', "");
    Expect(0, 3199, '\P{_In_telugu}', "");
    Expect(1, 3199, '\P{^_In_telugu}', "");
    Expect(0, 3200, '\p{_In_telugu}', "");
    Expect(1, 3200, '\p{^_In_telugu}', "");
    Expect(1, 3200, '\P{_In_telugu}', "");
    Expect(0, 3200, '\P{^_In_telugu}', "");
    Error('\p{_	in_telugu/a/}');
    Error('\P{_	in_telugu/a/}');
    Expect(1, 3199, '\p{-IN_Telugu}', "");
    Expect(0, 3199, '\p{^-IN_Telugu}', "");
    Expect(0, 3199, '\P{-IN_Telugu}', "");
    Expect(1, 3199, '\P{^-IN_Telugu}', "");
    Expect(0, 3200, '\p{-IN_Telugu}', "");
    Expect(1, 3200, '\p{^-IN_Telugu}', "");
    Expect(1, 3200, '\P{-IN_Telugu}', "");
    Expect(0, 3200, '\P{^-IN_Telugu}', "");
    Error('\p{ :=In_THAANA}');
    Error('\P{ :=In_THAANA}');
    Expect(1, 1983, '\p{inthaana}', "");
    Expect(0, 1983, '\p{^inthaana}', "");
    Expect(0, 1983, '\P{inthaana}', "");
    Expect(1, 1983, '\P{^inthaana}', "");
    Expect(0, 1984, '\p{inthaana}', "");
    Expect(1, 1984, '\p{^inthaana}', "");
    Expect(1, 1984, '\P{inthaana}', "");
    Expect(0, 1984, '\P{^inthaana}', "");
    Expect(1, 1983, '\p{ IN_THAANA}', "");
    Expect(0, 1983, '\p{^ IN_THAANA}', "");
    Expect(0, 1983, '\P{ IN_THAANA}', "");
    Expect(1, 1983, '\P{^ IN_THAANA}', "");
    Expect(0, 1984, '\p{ IN_THAANA}', "");
    Expect(1, 1984, '\p{^ IN_THAANA}', "");
    Expect(1, 1984, '\P{ IN_THAANA}', "");
    Expect(0, 1984, '\P{^ IN_THAANA}', "");
    Error('\p{-_In_Thaana:=}');
    Error('\P{-_In_Thaana:=}');
    Expect(1, 1983, '\p{_in_Thaana}', "");
    Expect(0, 1983, '\p{^_in_Thaana}', "");
    Expect(0, 1983, '\P{_in_Thaana}', "");
    Expect(1, 1983, '\P{^_in_Thaana}', "");
    Expect(0, 1984, '\p{_in_Thaana}', "");
    Expect(1, 1984, '\p{^_in_Thaana}', "");
    Expect(1, 1984, '\P{_in_Thaana}', "");
    Expect(0, 1984, '\P{^_in_Thaana}', "");
    Error('\p{_ IN_Thai/a/}');
    Error('\P{_ IN_Thai/a/}');
    Expect(1, 3711, '\p{inthai}', "");
    Expect(0, 3711, '\p{^inthai}', "");
    Expect(0, 3711, '\P{inthai}', "");
    Expect(1, 3711, '\P{^inthai}', "");
    Expect(0, 3712, '\p{inthai}', "");
    Expect(1, 3712, '\p{^inthai}', "");
    Expect(1, 3712, '\P{inthai}', "");
    Expect(0, 3712, '\P{^inthai}', "");
    Expect(1, 3711, '\p{_	In_Thai}', "");
    Expect(0, 3711, '\p{^_	In_Thai}', "");
    Expect(0, 3711, '\P{_	In_Thai}', "");
    Expect(1, 3711, '\P{^_	In_Thai}', "");
    Expect(0, 3712, '\p{_	In_Thai}', "");
    Expect(1, 3712, '\p{^_	In_Thai}', "");
    Expect(1, 3712, '\P{_	In_Thai}', "");
    Expect(0, 3712, '\P{^_	In_Thai}', "");
    Error('\p{/a/In_Thai}');
    Error('\P{/a/In_Thai}');
    Expect(1, 3711, '\p{--In_thai}', "");
    Expect(0, 3711, '\p{^--In_thai}', "");
    Expect(0, 3711, '\P{--In_thai}', "");
    Expect(1, 3711, '\P{^--In_thai}', "");
    Expect(0, 3712, '\p{--In_thai}', "");
    Expect(1, 3712, '\p{^--In_thai}', "");
    Expect(1, 3712, '\P{--In_thai}', "");
    Expect(0, 3712, '\P{^--In_thai}', "");
    Error('\p{_ IN_Tibetan/a/}');
    Error('\P{_ IN_Tibetan/a/}');
    Expect(1, 4095, '\p{intibetan}', "");
    Expect(0, 4095, '\p{^intibetan}', "");
    Expect(0, 4095, '\P{intibetan}', "");
    Expect(1, 4095, '\P{^intibetan}', "");
    Expect(0, 4096, '\p{intibetan}', "");
    Expect(1, 4096, '\p{^intibetan}', "");
    Expect(1, 4096, '\P{intibetan}', "");
    Expect(0, 4096, '\P{^intibetan}', "");
    Expect(1, 4095, '\p{	 IN_Tibetan}', "");
    Expect(0, 4095, '\p{^	 IN_Tibetan}', "");
    Expect(0, 4095, '\P{	 IN_Tibetan}', "");
    Expect(1, 4095, '\P{^	 IN_Tibetan}', "");
    Expect(0, 4096, '\p{	 IN_Tibetan}', "");
    Expect(1, 4096, '\p{^	 IN_Tibetan}', "");
    Expect(1, 4096, '\P{	 IN_Tibetan}', "");
    Expect(0, 4096, '\P{^	 IN_Tibetan}', "");
    Error('\p{:=	IN_TIBETAN}');
    Error('\P{:=	IN_TIBETAN}');
    Expect(1, 4095, '\p{__IN_Tibetan}', "");
    Expect(0, 4095, '\p{^__IN_Tibetan}', "");
    Expect(0, 4095, '\P{__IN_Tibetan}', "");
    Expect(1, 4095, '\P{^__IN_Tibetan}', "");
    Expect(0, 4096, '\p{__IN_Tibetan}', "");
    Expect(1, 4096, '\p{^__IN_Tibetan}', "");
    Expect(1, 4096, '\P{__IN_Tibetan}', "");
    Expect(0, 4096, '\P{^__IN_Tibetan}', "");
    Error('\p{:=-In_tifinagh}');
    Error('\P{:=-In_tifinagh}');
    Expect(1, 11647, '\p{intifinagh}', "");
    Expect(0, 11647, '\p{^intifinagh}', "");
    Expect(0, 11647, '\P{intifinagh}', "");
    Expect(1, 11647, '\P{^intifinagh}', "");
    Expect(0, 11648, '\p{intifinagh}', "");
    Expect(1, 11648, '\p{^intifinagh}', "");
    Expect(1, 11648, '\P{intifinagh}', "");
    Expect(0, 11648, '\P{^intifinagh}', "");
    Expect(1, 11647, '\p{_In_TIFINAGH}', "");
    Expect(0, 11647, '\p{^_In_TIFINAGH}', "");
    Expect(0, 11647, '\P{_In_TIFINAGH}', "");
    Expect(1, 11647, '\P{^_In_TIFINAGH}', "");
    Expect(0, 11648, '\p{_In_TIFINAGH}', "");
    Expect(1, 11648, '\p{^_In_TIFINAGH}', "");
    Expect(1, 11648, '\P{_In_TIFINAGH}', "");
    Expect(0, 11648, '\P{^_In_TIFINAGH}', "");
    Error('\p{-:=In_TIFINAGH}');
    Error('\P{-:=In_TIFINAGH}');
    Expect(1, 11647, '\p{	-In_Tifinagh}', "");
    Expect(0, 11647, '\p{^	-In_Tifinagh}', "");
    Expect(0, 11647, '\P{	-In_Tifinagh}', "");
    Expect(1, 11647, '\P{^	-In_Tifinagh}', "");
    Expect(0, 11648, '\p{	-In_Tifinagh}', "");
    Expect(1, 11648, '\p{^	-In_Tifinagh}', "");
    Expect(1, 11648, '\P{	-In_Tifinagh}', "");
    Expect(0, 11648, '\P{^	-In_Tifinagh}', "");
    Error('\p{-	in_Tirhuta:=}');
    Error('\P{-	in_Tirhuta:=}');
    Expect(1, 70879, '\p{intirhuta}', "");
    Expect(0, 70879, '\p{^intirhuta}', "");
    Expect(0, 70879, '\P{intirhuta}', "");
    Expect(1, 70879, '\P{^intirhuta}', "");
    Expect(0, 70880, '\p{intirhuta}', "");
    Expect(1, 70880, '\p{^intirhuta}', "");
    Expect(1, 70880, '\P{intirhuta}', "");
    Expect(0, 70880, '\P{^intirhuta}', "");
    Expect(1, 70879, '\p{  In_TIRHUTA}', "");
    Expect(0, 70879, '\p{^  In_TIRHUTA}', "");
    Expect(0, 70879, '\P{  In_TIRHUTA}', "");
    Expect(1, 70879, '\P{^  In_TIRHUTA}', "");
    Expect(0, 70880, '\p{  In_TIRHUTA}', "");
    Expect(1, 70880, '\p{^  In_TIRHUTA}', "");
    Expect(1, 70880, '\P{  In_TIRHUTA}', "");
    Expect(0, 70880, '\P{^  In_TIRHUTA}', "");
    Error('\p{/a/In_TIRHUTA}');
    Error('\P{/a/In_TIRHUTA}');
    Expect(1, 70879, '\p{-_In_TIRHUTA}', "");
    Expect(0, 70879, '\p{^-_In_TIRHUTA}', "");
    Expect(0, 70879, '\P{-_In_TIRHUTA}', "");
    Expect(1, 70879, '\P{^-_In_TIRHUTA}', "");
    Expect(0, 70880, '\p{-_In_TIRHUTA}', "");
    Expect(1, 70880, '\p{^-_In_TIRHUTA}', "");
    Expect(1, 70880, '\P{-_In_TIRHUTA}', "");
    Expect(0, 70880, '\P{^-_In_TIRHUTA}', "");
    Error('\p{--IN_Ugaritic/a/}');
    Error('\P{--IN_Ugaritic/a/}');
    Expect(1, 66463, '\p{inugaritic}', "");
    Expect(0, 66463, '\p{^inugaritic}', "");
    Expect(0, 66463, '\P{inugaritic}', "");
    Expect(1, 66463, '\P{^inugaritic}', "");
    Expect(0, 66464, '\p{inugaritic}', "");
    Expect(1, 66464, '\p{^inugaritic}', "");
    Expect(1, 66464, '\P{inugaritic}', "");
    Expect(0, 66464, '\P{^inugaritic}', "");
    Expect(1, 66463, '\p{	 In_Ugaritic}', "");
    Expect(0, 66463, '\p{^	 In_Ugaritic}', "");
    Expect(0, 66463, '\P{	 In_Ugaritic}', "");
    Expect(1, 66463, '\P{^	 In_Ugaritic}', "");
    Expect(0, 66464, '\p{	 In_Ugaritic}', "");
    Expect(1, 66464, '\p{^	 In_Ugaritic}', "");
    Expect(1, 66464, '\P{	 In_Ugaritic}', "");
    Expect(0, 66464, '\P{^	 In_Ugaritic}', "");
    Error('\p{:=-IN_Ugaritic}');
    Error('\P{:=-IN_Ugaritic}');
    Expect(1, 66463, '\p{--In_Ugaritic}', "");
    Expect(0, 66463, '\p{^--In_Ugaritic}', "");
    Expect(0, 66463, '\P{--In_Ugaritic}', "");
    Expect(1, 66463, '\P{^--In_Ugaritic}', "");
    Expect(0, 66464, '\p{--In_Ugaritic}', "");
    Expect(1, 66464, '\p{^--In_Ugaritic}', "");
    Expect(1, 66464, '\P{--In_Ugaritic}', "");
    Expect(0, 66464, '\P{^--In_Ugaritic}', "");
    Error('\p{/a/ 	in_vai}');
    Error('\P{/a/ 	in_vai}');
    Expect(1, 42559, '\p{invai}', "");
    Expect(0, 42559, '\p{^invai}', "");
    Expect(0, 42559, '\P{invai}', "");
    Expect(1, 42559, '\P{^invai}', "");
    Expect(0, 42560, '\p{invai}', "");
    Expect(1, 42560, '\p{^invai}', "");
    Expect(1, 42560, '\P{invai}', "");
    Expect(0, 42560, '\P{^invai}', "");
    Expect(1, 42559, '\p{ In_VAI}', "");
    Expect(0, 42559, '\p{^ In_VAI}', "");
    Expect(0, 42559, '\P{ In_VAI}', "");
    Expect(1, 42559, '\P{^ In_VAI}', "");
    Expect(0, 42560, '\p{ In_VAI}', "");
    Expect(1, 42560, '\p{^ In_VAI}', "");
    Expect(1, 42560, '\P{ In_VAI}', "");
    Expect(0, 42560, '\P{^ In_VAI}', "");
    Error('\p{/a/_-IN_VAI}');
    Error('\P{/a/_-IN_VAI}');
    Expect(1, 42559, '\p{		IN_vai}', "");
    Expect(0, 42559, '\p{^		IN_vai}', "");
    Expect(0, 42559, '\P{		IN_vai}', "");
    Expect(1, 42559, '\P{^		IN_vai}', "");
    Expect(0, 42560, '\p{		IN_vai}', "");
    Expect(1, 42560, '\p{^		IN_vai}', "");
    Expect(1, 42560, '\P{		IN_vai}', "");
    Expect(0, 42560, '\P{^		IN_vai}', "");
    Error('\p{_IN_Warang_CITI/a/}');
    Error('\P{_IN_Warang_CITI/a/}');
    Expect(1, 71935, '\p{inwarangciti}', "");
    Expect(0, 71935, '\p{^inwarangciti}', "");
    Expect(0, 71935, '\P{inwarangciti}', "");
    Expect(1, 71935, '\P{^inwarangciti}', "");
    Expect(0, 71936, '\p{inwarangciti}', "");
    Expect(1, 71936, '\p{^inwarangciti}', "");
    Expect(1, 71936, '\P{inwarangciti}', "");
    Expect(0, 71936, '\P{^inwarangciti}', "");
    Expect(1, 71935, '\p{	in_warang_citi}', "");
    Expect(0, 71935, '\p{^	in_warang_citi}', "");
    Expect(0, 71935, '\P{	in_warang_citi}', "");
    Expect(1, 71935, '\P{^	in_warang_citi}', "");
    Expect(0, 71936, '\p{	in_warang_citi}', "");
    Expect(1, 71936, '\p{^	in_warang_citi}', "");
    Expect(1, 71936, '\P{	in_warang_citi}', "");
    Expect(0, 71936, '\P{^	in_warang_citi}', "");
    Error('\p{:=In_Warang_citi}');
    Error('\P{:=In_Warang_citi}');
    Expect(1, 71935, '\p{	-IN_Warang_Citi}', "");
    Expect(0, 71935, '\p{^	-IN_Warang_Citi}', "");
    Expect(0, 71935, '\P{	-IN_Warang_Citi}', "");
    Expect(1, 71935, '\P{^	-IN_Warang_Citi}', "");
    Expect(0, 71936, '\p{	-IN_Warang_Citi}', "");
    Expect(1, 71936, '\p{^	-IN_Warang_Citi}', "");
    Expect(1, 71936, '\P{	-IN_Warang_Citi}', "");
    Expect(0, 71936, '\P{^	-IN_Warang_Citi}', "");
    Error('\p{:=	in_ZANABAZAR_SQUARE}');
    Error('\P{:=	in_ZANABAZAR_SQUARE}');
    Expect(1, 72271, '\p{inzanabazarsquare}', "");
    Expect(0, 72271, '\p{^inzanabazarsquare}', "");
    Expect(0, 72271, '\P{inzanabazarsquare}', "");
    Expect(1, 72271, '\P{^inzanabazarsquare}', "");
    Expect(0, 72272, '\p{inzanabazarsquare}', "");
    Expect(1, 72272, '\p{^inzanabazarsquare}', "");
    Expect(1, 72272, '\P{inzanabazarsquare}', "");
    Expect(0, 72272, '\P{^inzanabazarsquare}', "");
    Expect(1, 72271, '\p{--In_zanabazar_square}', "");
    Expect(0, 72271, '\p{^--In_zanabazar_square}', "");
    Expect(0, 72271, '\P{--In_zanabazar_square}', "");
    Expect(1, 72271, '\P{^--In_zanabazar_square}', "");
    Expect(0, 72272, '\p{--In_zanabazar_square}', "");
    Expect(1, 72272, '\p{^--In_zanabazar_square}', "");
    Expect(1, 72272, '\P{--In_zanabazar_square}', "");
    Expect(0, 72272, '\P{^--In_zanabazar_square}', "");
    Error('\p{  In_Zanabazar_square/a/}');
    Error('\P{  In_Zanabazar_square/a/}');
    Expect(1, 72271, '\p{ 	IN_zanabazar_Square}', "");
    Expect(0, 72271, '\p{^ 	IN_zanabazar_Square}', "");
    Expect(0, 72271, '\P{ 	IN_zanabazar_Square}', "");
    Expect(1, 72271, '\P{^ 	IN_zanabazar_Square}', "");
    Expect(0, 72272, '\p{ 	IN_zanabazar_Square}', "");
    Expect(1, 72272, '\p{^ 	IN_zanabazar_Square}', "");
    Expect(1, 72272, '\P{ 	IN_zanabazar_Square}', "");
    Expect(0, 72272, '\P{^ 	IN_zanabazar_Square}', "");
    Error('\p{-:=inherited}');
    Error('\P{-:=inherited}');
    Expect(1, 917999, '\p{inherited}', "");
    Expect(0, 917999, '\p{^inherited}', "");
    Expect(0, 917999, '\P{inherited}', "");
    Expect(1, 917999, '\P{^inherited}', "");
    Expect(0, 918000, '\p{inherited}', "");
    Expect(1, 918000, '\p{^inherited}', "");
    Expect(1, 918000, '\P{inherited}', "");
    Expect(0, 918000, '\P{^inherited}', "");
    Expect(1, 917999, '\p{_-inherited}', "");
    Expect(0, 917999, '\p{^_-inherited}', "");
    Expect(0, 917999, '\P{_-inherited}', "");
    Expect(1, 917999, '\P{^_-inherited}', "");
    Expect(0, 918000, '\p{_-inherited}', "");
    Expect(1, 918000, '\p{^_-inherited}', "");
    Expect(1, 918000, '\P{_-inherited}', "");
    Expect(0, 918000, '\P{^_-inherited}', "");
    Error('\p{_:=is_inherited}');
    Error('\P{_:=is_inherited}');
    Expect(1, 917999, '\p{isinherited}', "");
    Expect(0, 917999, '\p{^isinherited}', "");
    Expect(0, 917999, '\P{isinherited}', "");
    Expect(1, 917999, '\P{^isinherited}', "");
    Expect(0, 918000, '\p{isinherited}', "");
    Expect(1, 918000, '\p{^isinherited}', "");
    Expect(1, 918000, '\P{isinherited}', "");
    Expect(0, 918000, '\P{^isinherited}', "");
    Expect(1, 917999, '\p{-	is_inherited}', "");
    Expect(0, 917999, '\p{^-	is_inherited}', "");
    Expect(0, 917999, '\P{-	is_inherited}', "");
    Expect(1, 917999, '\P{^-	is_inherited}', "");
    Expect(0, 918000, '\p{-	is_inherited}', "");
    Expect(1, 918000, '\p{^-	is_inherited}', "");
    Expect(1, 918000, '\P{-	is_inherited}', "");
    Expect(0, 918000, '\P{^-	is_inherited}', "");
    Error('\p{/a/-	ZINH}');
    Error('\P{/a/-	ZINH}');
    Expect(1, 917999, '\p{zinh}', "");
    Expect(0, 917999, '\p{^zinh}', "");
    Expect(0, 917999, '\P{zinh}', "");
    Expect(1, 917999, '\P{^zinh}', "");
    Expect(0, 918000, '\p{zinh}', "");
    Expect(1, 918000, '\p{^zinh}', "");
    Expect(1, 918000, '\P{zinh}', "");
    Expect(0, 918000, '\P{^zinh}', "");
    Expect(1, 917999, '\p{_	Zinh}', "");
    Expect(0, 917999, '\p{^_	Zinh}', "");
    Expect(0, 917999, '\P{_	Zinh}', "");
    Expect(1, 917999, '\P{^_	Zinh}', "");
    Expect(0, 918000, '\p{_	Zinh}', "");
    Expect(1, 918000, '\p{^_	Zinh}', "");
    Expect(1, 918000, '\P{_	Zinh}', "");
    Expect(0, 918000, '\P{^_	Zinh}', "");
    Error('\p{	:=IS_Zinh}');
    Error('\P{	:=IS_Zinh}');
    Expect(1, 917999, '\p{iszinh}', "");
    Expect(0, 917999, '\p{^iszinh}', "");
    Expect(0, 917999, '\P{iszinh}', "");
    Expect(1, 917999, '\P{^iszinh}', "");
    Expect(0, 918000, '\p{iszinh}', "");
    Expect(1, 918000, '\p{^iszinh}', "");
    Expect(1, 918000, '\P{iszinh}', "");
    Expect(0, 918000, '\P{^iszinh}', "");
    Expect(1, 917999, '\p{_ Is_zinh}', "");
    Expect(0, 917999, '\p{^_ Is_zinh}', "");
    Expect(0, 917999, '\P{_ Is_zinh}', "");
    Expect(1, 917999, '\P{^_ Is_zinh}', "");
    Expect(0, 918000, '\p{_ Is_zinh}', "");
    Expect(1, 918000, '\p{^_ Is_zinh}', "");
    Expect(1, 918000, '\P{_ Is_zinh}', "");
    Expect(0, 918000, '\P{^_ Is_zinh}', "");
    Error('\p{	/a/Qaai}');
    Error('\P{	/a/Qaai}');
    Expect(1, 917999, '\p{qaai}', "");
    Expect(0, 917999, '\p{^qaai}', "");
    Expect(0, 917999, '\P{qaai}', "");
    Expect(1, 917999, '\P{^qaai}', "");
    Expect(0, 918000, '\p{qaai}', "");
    Expect(1, 918000, '\p{^qaai}', "");
    Expect(1, 918000, '\P{qaai}', "");
    Expect(0, 918000, '\P{^qaai}', "");
    Expect(1, 917999, '\p{_qaai}', "");
    Expect(0, 917999, '\p{^_qaai}', "");
    Expect(0, 917999, '\P{_qaai}', "");
    Expect(1, 917999, '\P{^_qaai}', "");
    Expect(0, 918000, '\p{_qaai}', "");
    Expect(1, 918000, '\p{^_qaai}', "");
    Expect(1, 918000, '\P{_qaai}', "");
    Expect(0, 918000, '\P{^_qaai}', "");
    Error('\p{:=_	IS_Qaai}');
    Error('\P{:=_	IS_Qaai}');
    Expect(1, 917999, '\p{isqaai}', "");
    Expect(0, 917999, '\p{^isqaai}', "");
    Expect(0, 917999, '\P{isqaai}', "");
    Expect(1, 917999, '\P{^isqaai}', "");
    Expect(0, 918000, '\p{isqaai}', "");
    Expect(1, 918000, '\p{^isqaai}', "");
    Expect(1, 918000, '\P{isqaai}', "");
    Expect(0, 918000, '\P{^isqaai}', "");
    Expect(1, 917999, '\p{ 	Is_qaai}', "");
    Expect(0, 917999, '\p{^ 	Is_qaai}', "");
    Expect(0, 917999, '\P{ 	Is_qaai}', "");
    Expect(1, 917999, '\P{^ 	Is_qaai}', "");
    Expect(0, 918000, '\p{ 	Is_qaai}', "");
    Expect(1, 918000, '\p{^ 	Is_qaai}', "");
    Expect(1, 918000, '\P{ 	Is_qaai}', "");
    Expect(0, 918000, '\P{^ 	Is_qaai}', "");
    Error('\p{	/a/initial_punctuation}');
    Error('\P{	/a/initial_punctuation}');
    Expect(1, 11808, '\p{initialpunctuation}', "");
    Expect(0, 11808, '\p{^initialpunctuation}', "");
    Expect(0, 11808, '\P{initialpunctuation}', "");
    Expect(1, 11808, '\P{^initialpunctuation}', "");
    Expect(0, 11809, '\p{initialpunctuation}', "");
    Expect(1, 11809, '\p{^initialpunctuation}', "");
    Expect(1, 11809, '\P{initialpunctuation}', "");
    Expect(0, 11809, '\P{^initialpunctuation}', "");
    Expect(1, 11808, '\p{  INITIAL_Punctuation}', "");
    Expect(0, 11808, '\p{^  INITIAL_Punctuation}', "");
    Expect(0, 11808, '\P{  INITIAL_Punctuation}', "");
    Expect(1, 11808, '\P{^  INITIAL_Punctuation}', "");
    Expect(0, 11809, '\p{  INITIAL_Punctuation}', "");
    Expect(1, 11809, '\p{^  INITIAL_Punctuation}', "");
    Expect(1, 11809, '\P{  INITIAL_Punctuation}', "");
    Expect(0, 11809, '\P{^  INITIAL_Punctuation}', "");
    Error('\p{Is_initial_Punctuation/a/}');
    Error('\P{Is_initial_Punctuation/a/}');
    Expect(1, 11808, '\p{isinitialpunctuation}', "");
    Expect(0, 11808, '\p{^isinitialpunctuation}', "");
    Expect(0, 11808, '\P{isinitialpunctuation}', "");
    Expect(1, 11808, '\P{^isinitialpunctuation}', "");
    Expect(0, 11809, '\p{isinitialpunctuation}', "");
    Expect(1, 11809, '\p{^isinitialpunctuation}', "");
    Expect(1, 11809, '\P{isinitialpunctuation}', "");
    Expect(0, 11809, '\P{^isinitialpunctuation}', "");
    Expect(1, 11808, '\p{-_is_INITIAL_PUNCTUATION}', "");
    Expect(0, 11808, '\p{^-_is_INITIAL_PUNCTUATION}', "");
    Expect(0, 11808, '\P{-_is_INITIAL_PUNCTUATION}', "");
    Expect(1, 11808, '\P{^-_is_INITIAL_PUNCTUATION}', "");
    Expect(0, 11809, '\p{-_is_INITIAL_PUNCTUATION}', "");
    Expect(1, 11809, '\p{^-_is_INITIAL_PUNCTUATION}', "");
    Expect(1, 11809, '\P{-_is_INITIAL_PUNCTUATION}', "");
    Expect(0, 11809, '\P{^-_is_INITIAL_PUNCTUATION}', "");
    Error('\p{-:=pi}');
    Error('\P{-:=pi}');
    Expect(1, 11808, '\p{pi}', "");
    Expect(0, 11808, '\p{^pi}', "");
    Expect(0, 11808, '\P{pi}', "");
    Expect(1, 11808, '\P{^pi}', "");
    Expect(0, 11809, '\p{pi}', "");
    Expect(1, 11809, '\p{^pi}', "");
    Expect(1, 11809, '\P{pi}', "");
    Expect(0, 11809, '\P{^pi}', "");
    Expect(1, 11808, '\p{ pi}', "");
    Expect(0, 11808, '\p{^ pi}', "");
    Expect(0, 11808, '\P{ pi}', "");
    Expect(1, 11808, '\P{^ pi}', "");
    Expect(0, 11809, '\p{ pi}', "");
    Expect(1, 11809, '\p{^ pi}', "");
    Expect(1, 11809, '\P{ pi}', "");
    Expect(0, 11809, '\P{^ pi}', "");
    Error('\p{- Is_Pi:=}');
    Error('\P{- Is_Pi:=}');
    Expect(1, 11808, '\p{ispi}', "");
    Expect(0, 11808, '\p{^ispi}', "");
    Expect(0, 11808, '\P{ispi}', "");
    Expect(1, 11808, '\P{^ispi}', "");
    Expect(0, 11809, '\p{ispi}', "");
    Expect(1, 11809, '\p{^ispi}', "");
    Expect(1, 11809, '\P{ispi}', "");
    Expect(0, 11809, '\P{^ispi}', "");
    Expect(1, 11808, '\p{IS_pi}', "");
    Expect(0, 11808, '\p{^IS_pi}', "");
    Expect(0, 11808, '\P{IS_pi}', "");
    Expect(1, 11808, '\P{^IS_pi}', "");
    Expect(0, 11809, '\p{IS_pi}', "");
    Expect(1, 11809, '\p{^IS_pi}', "");
    Expect(1, 11809, '\P{IS_pi}', "");
    Expect(0, 11809, '\P{^IS_pi}', "");
    Error('\p{:=__INSCRIPTIONAL_PAHLAVI}');
    Error('\P{:=__INSCRIPTIONAL_PAHLAVI}');
    Expect(1, 68479, '\p{inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{-_INSCRIPTIONAL_pahlavi}', "");
    Expect(0, 68479, '\p{^-_INSCRIPTIONAL_pahlavi}', "");
    Expect(0, 68479, '\P{-_INSCRIPTIONAL_pahlavi}', "");
    Expect(1, 68479, '\P{^-_INSCRIPTIONAL_pahlavi}', "");
    Expect(0, 68480, '\p{-_INSCRIPTIONAL_pahlavi}', "");
    Expect(1, 68480, '\p{^-_INSCRIPTIONAL_pahlavi}', "");
    Expect(1, 68480, '\P{-_INSCRIPTIONAL_pahlavi}', "");
    Expect(0, 68480, '\P{^-_INSCRIPTIONAL_pahlavi}', "");
    Error('\p{ is_inscriptional_Pahlavi/a/}');
    Error('\P{ is_inscriptional_Pahlavi/a/}');
    Expect(1, 68479, '\p{isinscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^isinscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{isinscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^isinscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{isinscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^isinscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{isinscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^isinscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{  IS_Inscriptional_pahlavi}', "");
    Expect(0, 68479, '\p{^  IS_Inscriptional_pahlavi}', "");
    Expect(0, 68479, '\P{  IS_Inscriptional_pahlavi}', "");
    Expect(1, 68479, '\P{^  IS_Inscriptional_pahlavi}', "");
    Expect(0, 68480, '\p{  IS_Inscriptional_pahlavi}', "");
    Expect(1, 68480, '\p{^  IS_Inscriptional_pahlavi}', "");
    Expect(1, 68480, '\P{  IS_Inscriptional_pahlavi}', "");
    Expect(0, 68480, '\P{^  IS_Inscriptional_pahlavi}', "");
    Error('\p{ Phli/a/}');
    Error('\P{ Phli/a/}');
    Expect(1, 68479, '\p{phli}', "");
    Expect(0, 68479, '\p{^phli}', "");
    Expect(0, 68479, '\P{phli}', "");
    Expect(1, 68479, '\P{^phli}', "");
    Expect(0, 68480, '\p{phli}', "");
    Expect(1, 68480, '\p{^phli}', "");
    Expect(1, 68480, '\P{phli}', "");
    Expect(0, 68480, '\P{^phli}', "");
    Expect(1, 68479, '\p{  Phli}', "");
    Expect(0, 68479, '\p{^  Phli}', "");
    Expect(0, 68479, '\P{  Phli}', "");
    Expect(1, 68479, '\P{^  Phli}', "");
    Expect(0, 68480, '\p{  Phli}', "");
    Expect(1, 68480, '\p{^  Phli}', "");
    Expect(1, 68480, '\P{  Phli}', "");
    Expect(0, 68480, '\P{^  Phli}', "");
    Error('\p{-Is_phli:=}');
    Error('\P{-Is_phli:=}');
    Expect(1, 68479, '\p{isphli}', "");
    Expect(0, 68479, '\p{^isphli}', "");
    Expect(0, 68479, '\P{isphli}', "");
    Expect(1, 68479, '\P{^isphli}', "");
    Expect(0, 68480, '\p{isphli}', "");
    Expect(1, 68480, '\p{^isphli}', "");
    Expect(1, 68480, '\P{isphli}', "");
    Expect(0, 68480, '\P{^isphli}', "");
    Expect(1, 68479, '\p{_is_PHLI}', "");
    Expect(0, 68479, '\p{^_is_PHLI}', "");
    Expect(0, 68479, '\P{_is_PHLI}', "");
    Expect(1, 68479, '\P{^_is_PHLI}', "");
    Expect(0, 68480, '\p{_is_PHLI}', "");
    Expect(1, 68480, '\p{^_is_PHLI}', "");
    Expect(1, 68480, '\P{_is_PHLI}', "");
    Expect(0, 68480, '\P{^_is_PHLI}', "");
    Error('\p{  INSCRIPTIONAL_Parthian/a/}');
    Error('\P{  INSCRIPTIONAL_Parthian/a/}');
    Expect(1, 68447, '\p{inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^inscriptionalparthian}', "");
    Expect(0, 68447, '\P{inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^inscriptionalparthian}', "");
    Expect(0, 68448, '\p{inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^inscriptionalparthian}', "");
    Expect(1, 68448, '\P{inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^inscriptionalparthian}', "");
    Expect(1, 68447, '\p{-inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\p{^-inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\P{-inscriptional_PARTHIAN}', "");
    Expect(1, 68447, '\P{^-inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\p{-inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\p{^-inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\P{-inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\P{^-inscriptional_PARTHIAN}', "");
    Error('\p{:=	 Is_inscriptional_Parthian}');
    Error('\P{:=	 Is_inscriptional_Parthian}');
    Expect(1, 68447, '\p{isinscriptionalparthian}', "");
    Expect(0, 68447, '\p{^isinscriptionalparthian}', "");
    Expect(0, 68447, '\P{isinscriptionalparthian}', "");
    Expect(1, 68447, '\P{^isinscriptionalparthian}', "");
    Expect(0, 68448, '\p{isinscriptionalparthian}', "");
    Expect(1, 68448, '\p{^isinscriptionalparthian}', "");
    Expect(1, 68448, '\P{isinscriptionalparthian}', "");
    Expect(0, 68448, '\P{^isinscriptionalparthian}', "");
    Expect(1, 68447, '\p{		IS_Inscriptional_Parthian}', "");
    Expect(0, 68447, '\p{^		IS_Inscriptional_Parthian}', "");
    Expect(0, 68447, '\P{		IS_Inscriptional_Parthian}', "");
    Expect(1, 68447, '\P{^		IS_Inscriptional_Parthian}', "");
    Expect(0, 68448, '\p{		IS_Inscriptional_Parthian}', "");
    Expect(1, 68448, '\p{^		IS_Inscriptional_Parthian}', "");
    Expect(1, 68448, '\P{		IS_Inscriptional_Parthian}', "");
    Expect(0, 68448, '\P{^		IS_Inscriptional_Parthian}', "");
    Error('\p{/a/ 	Prti}');
    Error('\P{/a/ 	Prti}');
    Expect(1, 68447, '\p{prti}', "");
    Expect(0, 68447, '\p{^prti}', "");
    Expect(0, 68447, '\P{prti}', "");
    Expect(1, 68447, '\P{^prti}', "");
    Expect(0, 68448, '\p{prti}', "");
    Expect(1, 68448, '\p{^prti}', "");
    Expect(1, 68448, '\P{prti}', "");
    Expect(0, 68448, '\P{^prti}', "");
    Expect(1, 68447, '\p{_PRTI}', "");
    Expect(0, 68447, '\p{^_PRTI}', "");
    Expect(0, 68447, '\P{_PRTI}', "");
    Expect(1, 68447, '\P{^_PRTI}', "");
    Expect(0, 68448, '\p{_PRTI}', "");
    Expect(1, 68448, '\p{^_PRTI}', "");
    Expect(1, 68448, '\P{_PRTI}', "");
    Expect(0, 68448, '\P{^_PRTI}', "");
    Error('\p{_ Is_prti:=}');
    Error('\P{_ Is_prti:=}');
    Expect(1, 68447, '\p{isprti}', "");
    Expect(0, 68447, '\p{^isprti}', "");
    Expect(0, 68447, '\P{isprti}', "");
    Expect(1, 68447, '\P{^isprti}', "");
    Expect(0, 68448, '\p{isprti}', "");
    Expect(1, 68448, '\p{^isprti}', "");
    Expect(1, 68448, '\P{isprti}', "");
    Expect(0, 68448, '\P{^isprti}', "");
    Expect(1, 68447, '\p{		IS_Prti}', "");
    Expect(0, 68447, '\p{^		IS_Prti}', "");
    Expect(0, 68447, '\P{		IS_Prti}', "");
    Expect(1, 68447, '\P{^		IS_Prti}', "");
    Expect(0, 68448, '\p{		IS_Prti}', "");
    Expect(1, 68448, '\p{^		IS_Prti}', "");
    Expect(1, 68448, '\P{		IS_Prti}', "");
    Expect(0, 68448, '\P{^		IS_Prti}', "");
    Error('\p{ _ipa_Extensions:=}');
    Error('\P{ _ipa_Extensions:=}');
    Expect(1, 687, '\p{ipaextensions}', "");
    Expect(0, 687, '\p{^ipaextensions}', "");
    Expect(0, 687, '\P{ipaextensions}', "");
    Expect(1, 687, '\P{^ipaextensions}', "");
    Expect(0, 688, '\p{ipaextensions}', "");
    Expect(1, 688, '\p{^ipaextensions}', "");
    Expect(1, 688, '\P{ipaextensions}', "");
    Expect(0, 688, '\P{^ipaextensions}', "");
    Expect(1, 687, '\p{	-IPA_Extensions}', "");
    Expect(0, 687, '\p{^	-IPA_Extensions}', "");
    Expect(0, 687, '\P{	-IPA_Extensions}', "");
    Expect(1, 687, '\P{^	-IPA_Extensions}', "");
    Expect(0, 688, '\p{	-IPA_Extensions}', "");
    Expect(1, 688, '\p{^	-IPA_Extensions}', "");
    Expect(1, 688, '\P{	-IPA_Extensions}', "");
    Expect(0, 688, '\P{^	-IPA_Extensions}', "");
    Error('\p{-Is_ipa_EXTENSIONS/a/}');
    Error('\P{-Is_ipa_EXTENSIONS/a/}');
    Expect(1, 687, '\p{isipaextensions}', "");
    Expect(0, 687, '\p{^isipaextensions}', "");
    Expect(0, 687, '\P{isipaextensions}', "");
    Expect(1, 687, '\P{^isipaextensions}', "");
    Expect(0, 688, '\p{isipaextensions}', "");
    Expect(1, 688, '\p{^isipaextensions}', "");
    Expect(1, 688, '\P{isipaextensions}', "");
    Expect(0, 688, '\P{^isipaextensions}', "");
    Expect(1, 687, '\p{__IS_IPA_Extensions}', "");
    Expect(0, 687, '\p{^__IS_IPA_Extensions}', "");
    Expect(0, 687, '\P{__IS_IPA_Extensions}', "");
    Expect(1, 687, '\P{^__IS_IPA_Extensions}', "");
    Expect(0, 688, '\p{__IS_IPA_Extensions}', "");
    Expect(1, 688, '\p{^__IS_IPA_Extensions}', "");
    Expect(1, 688, '\P{__IS_IPA_Extensions}', "");
    Expect(0, 688, '\P{^__IS_IPA_Extensions}', "");
    Error('\p{/a/	 IN_ipa_EXTENSIONS}');
    Error('\P{/a/	 IN_ipa_EXTENSIONS}');
    Expect(1, 687, '\p{inipaextensions}', "");
    Expect(0, 687, '\p{^inipaextensions}', "");
    Expect(0, 687, '\P{inipaextensions}', "");
    Expect(1, 687, '\P{^inipaextensions}', "");
    Expect(0, 688, '\p{inipaextensions}', "");
    Expect(1, 688, '\p{^inipaextensions}', "");
    Expect(1, 688, '\P{inipaextensions}', "");
    Expect(0, 688, '\P{^inipaextensions}', "");
    Expect(1, 687, '\p{	-IN_IPA_EXTENSIONS}', "");
    Expect(0, 687, '\p{^	-IN_IPA_EXTENSIONS}', "");
    Expect(0, 687, '\P{	-IN_IPA_EXTENSIONS}', "");
    Expect(1, 687, '\P{^	-IN_IPA_EXTENSIONS}', "");
    Expect(0, 688, '\p{	-IN_IPA_EXTENSIONS}', "");
    Expect(1, 688, '\p{^	-IN_IPA_EXTENSIONS}', "");
    Expect(1, 688, '\P{	-IN_IPA_EXTENSIONS}', "");
    Expect(0, 688, '\P{^	-IN_IPA_EXTENSIONS}', "");
    Error('\p{-/a/IPA_EXT}');
    Error('\P{-/a/IPA_EXT}');
    Expect(1, 687, '\p{ipaext}', "");
    Expect(0, 687, '\p{^ipaext}', "");
    Expect(0, 687, '\P{ipaext}', "");
    Expect(1, 687, '\P{^ipaext}', "");
    Expect(0, 688, '\p{ipaext}', "");
    Expect(1, 688, '\p{^ipaext}', "");
    Expect(1, 688, '\P{ipaext}', "");
    Expect(0, 688, '\P{^ipaext}', "");
    Expect(1, 687, '\p{-ipa_Ext}', "");
    Expect(0, 687, '\p{^-ipa_Ext}', "");
    Expect(0, 687, '\P{-ipa_Ext}', "");
    Expect(1, 687, '\P{^-ipa_Ext}', "");
    Expect(0, 688, '\p{-ipa_Ext}', "");
    Expect(1, 688, '\p{^-ipa_Ext}', "");
    Expect(1, 688, '\P{-ipa_Ext}', "");
    Expect(0, 688, '\P{^-ipa_Ext}', "");
    Error('\p{	-Is_ipa_EXT/a/}');
    Error('\P{	-Is_ipa_EXT/a/}');
    Expect(1, 687, '\p{isipaext}', "");
    Expect(0, 687, '\p{^isipaext}', "");
    Expect(0, 687, '\P{isipaext}', "");
    Expect(1, 687, '\P{^isipaext}', "");
    Expect(0, 688, '\p{isipaext}', "");
    Expect(1, 688, '\p{^isipaext}', "");
    Expect(1, 688, '\P{isipaext}', "");
    Expect(0, 688, '\P{^isipaext}', "");
    Expect(1, 687, '\p{  Is_ipa_Ext}', "");
    Expect(0, 687, '\p{^  Is_ipa_Ext}', "");
    Expect(0, 687, '\P{  Is_ipa_Ext}', "");
    Expect(1, 687, '\P{^  Is_ipa_Ext}', "");
    Expect(0, 688, '\p{  Is_ipa_Ext}', "");
    Expect(1, 688, '\p{^  Is_ipa_Ext}', "");
    Expect(1, 688, '\P{  Is_ipa_Ext}', "");
    Expect(0, 688, '\P{^  Is_ipa_Ext}', "");
    Error('\p{_ In_IPA_Ext:=}');
    Error('\P{_ In_IPA_Ext:=}');
    Expect(1, 687, '\p{inipaext}', "");
    Expect(0, 687, '\p{^inipaext}', "");
    Expect(0, 687, '\P{inipaext}', "");
    Expect(1, 687, '\P{^inipaext}', "");
    Expect(0, 688, '\p{inipaext}', "");
    Expect(1, 688, '\p{^inipaext}', "");
    Expect(1, 688, '\P{inipaext}', "");
    Expect(0, 688, '\P{^inipaext}', "");
    Expect(1, 687, '\p{	 in_ipa_ext}', "");
    Expect(0, 687, '\p{^	 in_ipa_ext}', "");
    Expect(0, 687, '\P{	 in_ipa_ext}', "");
    Expect(1, 687, '\P{^	 in_ipa_ext}', "");
    Expect(0, 688, '\p{	 in_ipa_ext}', "");
    Expect(1, 688, '\p{^	 in_ipa_ext}', "");
    Expect(1, 688, '\P{	 in_ipa_ext}', "");
    Expect(0, 688, '\P{^	 in_ipa_ext}', "");
    Error('\p{	Javanese:=}');
    Error('\P{	Javanese:=}');
    Expect(1, 43487, '\p{javanese}', "");
    Expect(0, 43487, '\p{^javanese}', "");
    Expect(0, 43487, '\P{javanese}', "");
    Expect(1, 43487, '\P{^javanese}', "");
    Expect(0, 43488, '\p{javanese}', "");
    Expect(1, 43488, '\p{^javanese}', "");
    Expect(1, 43488, '\P{javanese}', "");
    Expect(0, 43488, '\P{^javanese}', "");
    Expect(1, 43487, '\p{ -JAVANESE}', "");
    Expect(0, 43487, '\p{^ -JAVANESE}', "");
    Expect(0, 43487, '\P{ -JAVANESE}', "");
    Expect(1, 43487, '\P{^ -JAVANESE}', "");
    Expect(0, 43488, '\p{ -JAVANESE}', "");
    Expect(1, 43488, '\p{^ -JAVANESE}', "");
    Expect(1, 43488, '\P{ -JAVANESE}', "");
    Expect(0, 43488, '\P{^ -JAVANESE}', "");
    Error('\p{-/a/Is_Javanese}');
    Error('\P{-/a/Is_Javanese}');
    Expect(1, 43487, '\p{isjavanese}', "");
    Expect(0, 43487, '\p{^isjavanese}', "");
    Expect(0, 43487, '\P{isjavanese}', "");
    Expect(1, 43487, '\P{^isjavanese}', "");
    Expect(0, 43488, '\p{isjavanese}', "");
    Expect(1, 43488, '\p{^isjavanese}', "");
    Expect(1, 43488, '\P{isjavanese}', "");
    Expect(0, 43488, '\P{^isjavanese}', "");
    Expect(1, 43487, '\p{_	is_javanese}', "");
    Expect(0, 43487, '\p{^_	is_javanese}', "");
    Expect(0, 43487, '\P{_	is_javanese}', "");
    Expect(1, 43487, '\P{^_	is_javanese}', "");
    Expect(0, 43488, '\p{_	is_javanese}', "");
    Expect(1, 43488, '\p{^_	is_javanese}', "");
    Expect(1, 43488, '\P{_	is_javanese}', "");
    Expect(0, 43488, '\P{^_	is_javanese}', "");
    Error('\p{/a/_-JAVA}');
    Error('\P{/a/_-JAVA}');
    Expect(1, 43487, '\p{java}', "");
    Expect(0, 43487, '\p{^java}', "");
    Expect(0, 43487, '\P{java}', "");
    Expect(1, 43487, '\P{^java}', "");
    Expect(0, 43488, '\p{java}', "");
    Expect(1, 43488, '\p{^java}', "");
    Expect(1, 43488, '\P{java}', "");
    Expect(0, 43488, '\P{^java}', "");
    Expect(1, 43487, '\p{ Java}', "");
    Expect(0, 43487, '\p{^ Java}', "");
    Expect(0, 43487, '\P{ Java}', "");
    Expect(1, 43487, '\P{^ Java}', "");
    Expect(0, 43488, '\p{ Java}', "");
    Expect(1, 43488, '\p{^ Java}', "");
    Expect(1, 43488, '\P{ Java}', "");
    Expect(0, 43488, '\P{^ Java}', "");
    Error('\p{:=_-is_JAVA}');
    Error('\P{:=_-is_JAVA}');
    Expect(1, 43487, '\p{isjava}', "");
    Expect(0, 43487, '\p{^isjava}', "");
    Expect(0, 43487, '\P{isjava}', "");
    Expect(1, 43487, '\P{^isjava}', "");
    Expect(0, 43488, '\p{isjava}', "");
    Expect(1, 43488, '\p{^isjava}', "");
    Expect(1, 43488, '\P{isjava}', "");
    Expect(0, 43488, '\P{^isjava}', "");
    Expect(1, 43487, '\p{-	IS_java}', "");
    Expect(0, 43487, '\p{^-	IS_java}', "");
    Expect(0, 43487, '\P{-	IS_java}', "");
    Expect(1, 43487, '\P{^-	IS_java}', "");
    Expect(0, 43488, '\p{-	IS_java}', "");
    Expect(1, 43488, '\p{^-	IS_java}', "");
    Expect(1, 43488, '\P{-	IS_java}', "");
    Expect(0, 43488, '\P{^-	IS_java}', "");
    Error('\p{_	join_CONTROL/a/}');
    Error('\P{_	join_CONTROL/a/}');
    Expect(1, 8205, '\p{joincontrol}', "");
    Expect(0, 8205, '\p{^joincontrol}', "");
    Expect(0, 8205, '\P{joincontrol}', "");
    Expect(1, 8205, '\P{^joincontrol}', "");
    Expect(0, 8206, '\p{joincontrol}', "");
    Expect(1, 8206, '\p{^joincontrol}', "");
    Expect(1, 8206, '\P{joincontrol}', "");
    Expect(0, 8206, '\P{^joincontrol}', "");
    Expect(1, 8205, '\p{	Join_CONTROL}', "");
    Expect(0, 8205, '\p{^	Join_CONTROL}', "");
    Expect(0, 8205, '\P{	Join_CONTROL}', "");
    Expect(1, 8205, '\P{^	Join_CONTROL}', "");
    Expect(0, 8206, '\p{	Join_CONTROL}', "");
    Expect(1, 8206, '\p{^	Join_CONTROL}', "");
    Expect(1, 8206, '\P{	Join_CONTROL}', "");
    Expect(0, 8206, '\P{^	Join_CONTROL}', "");
    Error('\p{_/a/is_Join_Control}');
    Error('\P{_/a/is_Join_Control}');
    Expect(1, 8205, '\p{isjoincontrol}', "");
    Expect(0, 8205, '\p{^isjoincontrol}', "");
    Expect(0, 8205, '\P{isjoincontrol}', "");
    Expect(1, 8205, '\P{^isjoincontrol}', "");
    Expect(0, 8206, '\p{isjoincontrol}', "");
    Expect(1, 8206, '\p{^isjoincontrol}', "");
    Expect(1, 8206, '\P{isjoincontrol}', "");
    Expect(0, 8206, '\P{^isjoincontrol}', "");
    Expect(1, 8205, '\p{- IS_Join_Control}', "");
    Expect(0, 8205, '\p{^- IS_Join_Control}', "");
    Expect(0, 8205, '\P{- IS_Join_Control}', "");
    Expect(1, 8205, '\P{^- IS_Join_Control}', "");
    Expect(0, 8206, '\p{- IS_Join_Control}', "");
    Expect(1, 8206, '\p{^- IS_Join_Control}', "");
    Expect(1, 8206, '\P{- IS_Join_Control}', "");
    Expect(0, 8206, '\P{^- IS_Join_Control}', "");
    Error('\p{	:=Join_C}');
    Error('\P{	:=Join_C}');
    Expect(1, 8205, '\p{joinc}', "");
    Expect(0, 8205, '\p{^joinc}', "");
    Expect(0, 8205, '\P{joinc}', "");
    Expect(1, 8205, '\P{^joinc}', "");
    Expect(0, 8206, '\p{joinc}', "");
    Expect(1, 8206, '\p{^joinc}', "");
    Expect(1, 8206, '\P{joinc}', "");
    Expect(0, 8206, '\P{^joinc}', "");
    Expect(1, 8205, '\p{	_Join_C}', "");
    Expect(0, 8205, '\p{^	_Join_C}', "");
    Expect(0, 8205, '\P{	_Join_C}', "");
    Expect(1, 8205, '\P{^	_Join_C}', "");
    Expect(0, 8206, '\p{	_Join_C}', "");
    Expect(1, 8206, '\p{^	_Join_C}', "");
    Expect(1, 8206, '\P{	_Join_C}', "");
    Expect(0, 8206, '\P{^	_Join_C}', "");
    Error('\p{/a/ IS_JOIN_c}');
    Error('\P{/a/ IS_JOIN_c}');
    Expect(1, 8205, '\p{isjoinc}', "");
    Expect(0, 8205, '\p{^isjoinc}', "");
    Expect(0, 8205, '\P{isjoinc}', "");
    Expect(1, 8205, '\P{^isjoinc}', "");
    Expect(0, 8206, '\p{isjoinc}', "");
    Expect(1, 8206, '\p{^isjoinc}', "");
    Expect(1, 8206, '\P{isjoinc}', "");
    Expect(0, 8206, '\P{^isjoinc}', "");
    Expect(1, 8205, '\p{-_Is_Join_C}', "");
    Expect(0, 8205, '\p{^-_Is_Join_C}', "");
    Expect(0, 8205, '\P{-_Is_Join_C}', "");
    Expect(1, 8205, '\P{^-_Is_Join_C}', "");
    Expect(0, 8206, '\p{-_Is_Join_C}', "");
    Expect(1, 8206, '\p{^-_Is_Join_C}', "");
    Expect(1, 8206, '\P{-_Is_Join_C}', "");
    Expect(0, 8206, '\P{^-_Is_Join_C}', "");
    Error('\p{	_Kaithi:=}');
    Error('\P{	_Kaithi:=}');
    Expect(1, 69825, '\p{kaithi}', "");
    Expect(0, 69825, '\p{^kaithi}', "");
    Expect(0, 69825, '\P{kaithi}', "");
    Expect(1, 69825, '\P{^kaithi}', "");
    Expect(0, 69826, '\p{kaithi}', "");
    Expect(1, 69826, '\p{^kaithi}', "");
    Expect(1, 69826, '\P{kaithi}', "");
    Expect(0, 69826, '\P{^kaithi}', "");
    Expect(1, 69825, '\p{ -kaithi}', "");
    Expect(0, 69825, '\p{^ -kaithi}', "");
    Expect(0, 69825, '\P{ -kaithi}', "");
    Expect(1, 69825, '\P{^ -kaithi}', "");
    Expect(0, 69826, '\p{ -kaithi}', "");
    Expect(1, 69826, '\p{^ -kaithi}', "");
    Expect(1, 69826, '\P{ -kaithi}', "");
    Expect(0, 69826, '\P{^ -kaithi}', "");
    Error('\p{-	is_kaithi:=}');
    Error('\P{-	is_kaithi:=}');
    Expect(1, 69825, '\p{iskaithi}', "");
    Expect(0, 69825, '\p{^iskaithi}', "");
    Expect(0, 69825, '\P{iskaithi}', "");
    Expect(1, 69825, '\P{^iskaithi}', "");
    Expect(0, 69826, '\p{iskaithi}', "");
    Expect(1, 69826, '\p{^iskaithi}', "");
    Expect(1, 69826, '\P{iskaithi}', "");
    Expect(0, 69826, '\P{^iskaithi}', "");
    Expect(1, 69825, '\p{  IS_Kaithi}', "");
    Expect(0, 69825, '\p{^  IS_Kaithi}', "");
    Expect(0, 69825, '\P{  IS_Kaithi}', "");
    Expect(1, 69825, '\P{^  IS_Kaithi}', "");
    Expect(0, 69826, '\p{  IS_Kaithi}', "");
    Expect(1, 69826, '\p{^  IS_Kaithi}', "");
    Expect(1, 69826, '\P{  IS_Kaithi}', "");
    Expect(0, 69826, '\P{^  IS_Kaithi}', "");
    Error('\p{--KTHI/a/}');
    Error('\P{--KTHI/a/}');
    Expect(1, 69825, '\p{kthi}', "");
    Expect(0, 69825, '\p{^kthi}', "");
    Expect(0, 69825, '\P{kthi}', "");
    Expect(1, 69825, '\P{^kthi}', "");
    Expect(0, 69826, '\p{kthi}', "");
    Expect(1, 69826, '\p{^kthi}', "");
    Expect(1, 69826, '\P{kthi}', "");
    Expect(0, 69826, '\P{^kthi}', "");
    Expect(1, 69825, '\p{_KTHI}', "");
    Expect(0, 69825, '\p{^_KTHI}', "");
    Expect(0, 69825, '\P{_KTHI}', "");
    Expect(1, 69825, '\P{^_KTHI}', "");
    Expect(0, 69826, '\p{_KTHI}', "");
    Expect(1, 69826, '\p{^_KTHI}', "");
    Expect(1, 69826, '\P{_KTHI}', "");
    Expect(0, 69826, '\P{^_KTHI}', "");
    Error('\p{/a/Is_kthi}');
    Error('\P{/a/Is_kthi}');
    Expect(1, 69825, '\p{iskthi}', "");
    Expect(0, 69825, '\p{^iskthi}', "");
    Expect(0, 69825, '\P{iskthi}', "");
    Expect(1, 69825, '\P{^iskthi}', "");
    Expect(0, 69826, '\p{iskthi}', "");
    Expect(1, 69826, '\p{^iskthi}', "");
    Expect(1, 69826, '\P{iskthi}', "");
    Expect(0, 69826, '\P{^iskthi}', "");
    Expect(1, 69825, '\p{_is_KTHI}', "");
    Expect(0, 69825, '\p{^_is_KTHI}', "");
    Expect(0, 69825, '\P{_is_KTHI}', "");
    Expect(1, 69825, '\P{^_is_KTHI}', "");
    Expect(0, 69826, '\p{_is_KTHI}', "");
    Expect(1, 69826, '\p{^_is_KTHI}', "");
    Expect(1, 69826, '\P{_is_KTHI}', "");
    Expect(0, 69826, '\P{^_is_KTHI}', "");
    Error('\p{-:=KANA_Extended_a}');
    Error('\P{-:=KANA_Extended_a}');
    Expect(1, 110895, '\p{kanaextendeda}', "");
    Expect(0, 110895, '\p{^kanaextendeda}', "");
    Expect(0, 110895, '\P{kanaextendeda}', "");
    Expect(1, 110895, '\P{^kanaextendeda}', "");
    Expect(0, 110896, '\p{kanaextendeda}', "");
    Expect(1, 110896, '\p{^kanaextendeda}', "");
    Expect(1, 110896, '\P{kanaextendeda}', "");
    Expect(0, 110896, '\P{^kanaextendeda}', "");
    Expect(1, 110895, '\p{-	Kana_extended_A}', "");
    Expect(0, 110895, '\p{^-	Kana_extended_A}', "");
    Expect(0, 110895, '\P{-	Kana_extended_A}', "");
    Expect(1, 110895, '\P{^-	Kana_extended_A}', "");
    Expect(0, 110896, '\p{-	Kana_extended_A}', "");
    Expect(1, 110896, '\p{^-	Kana_extended_A}', "");
    Expect(1, 110896, '\P{-	Kana_extended_A}', "");
    Expect(0, 110896, '\P{^-	Kana_extended_A}', "");
    Error('\p{ is_kana_extended_a:=}');
    Error('\P{ is_kana_extended_a:=}');
    Expect(1, 110895, '\p{iskanaextendeda}', "");
    Expect(0, 110895, '\p{^iskanaextendeda}', "");
    Expect(0, 110895, '\P{iskanaextendeda}', "");
    Expect(1, 110895, '\P{^iskanaextendeda}', "");
    Expect(0, 110896, '\p{iskanaextendeda}', "");
    Expect(1, 110896, '\p{^iskanaextendeda}', "");
    Expect(1, 110896, '\P{iskanaextendeda}', "");
    Expect(0, 110896, '\P{^iskanaextendeda}', "");
    Expect(1, 110895, '\p{_-IS_Kana_extended_A}', "");
    Expect(0, 110895, '\p{^_-IS_Kana_extended_A}', "");
    Expect(0, 110895, '\P{_-IS_Kana_extended_A}', "");
    Expect(1, 110895, '\P{^_-IS_Kana_extended_A}', "");
    Expect(0, 110896, '\p{_-IS_Kana_extended_A}', "");
    Expect(1, 110896, '\p{^_-IS_Kana_extended_A}', "");
    Expect(1, 110896, '\P{_-IS_Kana_extended_A}', "");
    Expect(0, 110896, '\P{^_-IS_Kana_extended_A}', "");
    Error('\p{-In_kana_Extended_A:=}');
    Error('\P{-In_kana_Extended_A:=}');
    Expect(1, 110895, '\p{inkanaextendeda}', "");
    Expect(0, 110895, '\p{^inkanaextendeda}', "");
    Expect(0, 110895, '\P{inkanaextendeda}', "");
    Expect(1, 110895, '\P{^inkanaextendeda}', "");
    Expect(0, 110896, '\p{inkanaextendeda}', "");
    Expect(1, 110896, '\p{^inkanaextendeda}', "");
    Expect(1, 110896, '\P{inkanaextendeda}', "");
    Expect(0, 110896, '\P{^inkanaextendeda}', "");
    Expect(1, 110895, '\p{	In_kana_extended_A}', "");
    Expect(0, 110895, '\p{^	In_kana_extended_A}', "");
    Expect(0, 110895, '\P{	In_kana_extended_A}', "");
    Expect(1, 110895, '\P{^	In_kana_extended_A}', "");
    Expect(0, 110896, '\p{	In_kana_extended_A}', "");
    Expect(1, 110896, '\p{^	In_kana_extended_A}', "");
    Expect(1, 110896, '\P{	In_kana_extended_A}', "");
    Expect(0, 110896, '\P{^	In_kana_extended_A}', "");
    Error('\p{ :=kana_Ext_a}');
    Error('\P{ :=kana_Ext_a}');
    Expect(1, 110895, '\p{kanaexta}', "");
    Expect(0, 110895, '\p{^kanaexta}', "");
    Expect(0, 110895, '\P{kanaexta}', "");
    Expect(1, 110895, '\P{^kanaexta}', "");
    Expect(0, 110896, '\p{kanaexta}', "");
    Expect(1, 110896, '\p{^kanaexta}', "");
    Expect(1, 110896, '\P{kanaexta}', "");
    Expect(0, 110896, '\P{^kanaexta}', "");
    Expect(1, 110895, '\p{_ KANA_ext_A}', "");
    Expect(0, 110895, '\p{^_ KANA_ext_A}', "");
    Expect(0, 110895, '\P{_ KANA_ext_A}', "");
    Expect(1, 110895, '\P{^_ KANA_ext_A}', "");
    Expect(0, 110896, '\p{_ KANA_ext_A}', "");
    Expect(1, 110896, '\p{^_ KANA_ext_A}', "");
    Expect(1, 110896, '\P{_ KANA_ext_A}', "");
    Expect(0, 110896, '\P{^_ KANA_ext_A}', "");
    Error('\p{_:=IS_Kana_Ext_A}');
    Error('\P{_:=IS_Kana_Ext_A}');
    Expect(1, 110895, '\p{iskanaexta}', "");
    Expect(0, 110895, '\p{^iskanaexta}', "");
    Expect(0, 110895, '\P{iskanaexta}', "");
    Expect(1, 110895, '\P{^iskanaexta}', "");
    Expect(0, 110896, '\p{iskanaexta}', "");
    Expect(1, 110896, '\p{^iskanaexta}', "");
    Expect(1, 110896, '\P{iskanaexta}', "");
    Expect(0, 110896, '\P{^iskanaexta}', "");
    Expect(1, 110895, '\p{_ Is_KANA_EXT_a}', "");
    Expect(0, 110895, '\p{^_ Is_KANA_EXT_a}', "");
    Expect(0, 110895, '\P{_ Is_KANA_EXT_a}', "");
    Expect(1, 110895, '\P{^_ Is_KANA_EXT_a}', "");
    Expect(0, 110896, '\p{_ Is_KANA_EXT_a}', "");
    Expect(1, 110896, '\p{^_ Is_KANA_EXT_a}', "");
    Expect(1, 110896, '\P{_ Is_KANA_EXT_a}', "");
    Expect(0, 110896, '\P{^_ Is_KANA_EXT_a}', "");
    Error('\p{	in_Kana_Ext_A/a/}');
    Error('\P{	in_Kana_Ext_A/a/}');
    Expect(1, 110895, '\p{inkanaexta}', "");
    Expect(0, 110895, '\p{^inkanaexta}', "");
    Expect(0, 110895, '\P{inkanaexta}', "");
    Expect(1, 110895, '\P{^inkanaexta}', "");
    Expect(0, 110896, '\p{inkanaexta}', "");
    Expect(1, 110896, '\p{^inkanaexta}', "");
    Expect(1, 110896, '\P{inkanaexta}', "");
    Expect(0, 110896, '\P{^inkanaexta}', "");
    Expect(1, 110895, '\p{-IN_Kana_ext_A}', "");
    Expect(0, 110895, '\p{^-IN_Kana_ext_A}', "");
    Expect(0, 110895, '\P{-IN_Kana_ext_A}', "");
    Expect(1, 110895, '\P{^-IN_Kana_ext_A}', "");
    Expect(0, 110896, '\p{-IN_Kana_ext_A}', "");
    Expect(1, 110896, '\p{^-IN_Kana_ext_A}', "");
    Expect(1, 110896, '\P{-IN_Kana_ext_A}', "");
    Expect(0, 110896, '\P{^-IN_Kana_ext_A}', "");
    Error('\p{/a/_-Kana_Supplement}');
    Error('\P{/a/_-Kana_Supplement}');
    Expect(1, 110847, '\p{kanasupplement}', "");
    Expect(0, 110847, '\p{^kanasupplement}', "");
    Expect(0, 110847, '\P{kanasupplement}', "");
    Expect(1, 110847, '\P{^kanasupplement}', "");
    Expect(0, 110848, '\p{kanasupplement}', "");
    Expect(1, 110848, '\p{^kanasupplement}', "");
    Expect(1, 110848, '\P{kanasupplement}', "");
    Expect(0, 110848, '\P{^kanasupplement}', "");
    Expect(1, 110847, '\p{	-kana_supplement}', "");
    Expect(0, 110847, '\p{^	-kana_supplement}', "");
    Expect(0, 110847, '\P{	-kana_supplement}', "");
    Expect(1, 110847, '\P{^	-kana_supplement}', "");
    Expect(0, 110848, '\p{	-kana_supplement}', "");
    Expect(1, 110848, '\p{^	-kana_supplement}', "");
    Expect(1, 110848, '\P{	-kana_supplement}', "");
    Expect(0, 110848, '\P{^	-kana_supplement}', "");
    Error('\p{:=IS_Kana_Supplement}');
    Error('\P{:=IS_Kana_Supplement}');
    Expect(1, 110847, '\p{iskanasupplement}', "");
    Expect(0, 110847, '\p{^iskanasupplement}', "");
    Expect(0, 110847, '\P{iskanasupplement}', "");
    Expect(1, 110847, '\P{^iskanasupplement}', "");
    Expect(0, 110848, '\p{iskanasupplement}', "");
    Expect(1, 110848, '\p{^iskanasupplement}', "");
    Expect(1, 110848, '\P{iskanasupplement}', "");
    Expect(0, 110848, '\P{^iskanasupplement}', "");
    Expect(1, 110847, '\p{ _Is_Kana_Supplement}', "");
    Expect(0, 110847, '\p{^ _Is_Kana_Supplement}', "");
    Expect(0, 110847, '\P{ _Is_Kana_Supplement}', "");
    Expect(1, 110847, '\P{^ _Is_Kana_Supplement}', "");
    Expect(0, 110848, '\p{ _Is_Kana_Supplement}', "");
    Expect(1, 110848, '\p{^ _Is_Kana_Supplement}', "");
    Expect(1, 110848, '\P{ _Is_Kana_Supplement}', "");
    Expect(0, 110848, '\P{^ _Is_Kana_Supplement}', "");
    Error('\p{_In_KANA_Supplement:=}');
    Error('\P{_In_KANA_Supplement:=}');
    Expect(1, 110847, '\p{inkanasupplement}', "");
    Expect(0, 110847, '\p{^inkanasupplement}', "");
    Expect(0, 110847, '\P{inkanasupplement}', "");
    Expect(1, 110847, '\P{^inkanasupplement}', "");
    Expect(0, 110848, '\p{inkanasupplement}', "");
    Expect(1, 110848, '\p{^inkanasupplement}', "");
    Expect(1, 110848, '\P{inkanasupplement}', "");
    Expect(0, 110848, '\P{^inkanasupplement}', "");
    Expect(1, 110847, '\p{	In_Kana_Supplement}', "");
    Expect(0, 110847, '\p{^	In_Kana_Supplement}', "");
    Expect(0, 110847, '\P{	In_Kana_Supplement}', "");
    Expect(1, 110847, '\P{^	In_Kana_Supplement}', "");
    Expect(0, 110848, '\p{	In_Kana_Supplement}', "");
    Expect(1, 110848, '\p{^	In_Kana_Supplement}', "");
    Expect(1, 110848, '\P{	In_Kana_Supplement}', "");
    Expect(0, 110848, '\P{^	In_Kana_Supplement}', "");
    Error('\p{:=kana_sup}');
    Error('\P{:=kana_sup}');
    Expect(1, 110847, '\p{kanasup}', "");
    Expect(0, 110847, '\p{^kanasup}', "");
    Expect(0, 110847, '\P{kanasup}', "");
    Expect(1, 110847, '\P{^kanasup}', "");
    Expect(0, 110848, '\p{kanasup}', "");
    Expect(1, 110848, '\p{^kanasup}', "");
    Expect(1, 110848, '\P{kanasup}', "");
    Expect(0, 110848, '\P{^kanasup}', "");
    Expect(1, 110847, '\p{ -kana_Sup}', "");
    Expect(0, 110847, '\p{^ -kana_Sup}', "");
    Expect(0, 110847, '\P{ -kana_Sup}', "");
    Expect(1, 110847, '\P{^ -kana_Sup}', "");
    Expect(0, 110848, '\p{ -kana_Sup}', "");
    Expect(1, 110848, '\p{^ -kana_Sup}', "");
    Expect(1, 110848, '\P{ -kana_Sup}', "");
    Expect(0, 110848, '\P{^ -kana_Sup}', "");
    Error('\p{/a/--is_KANA_SUP}');
    Error('\P{/a/--is_KANA_SUP}');
    Expect(1, 110847, '\p{iskanasup}', "");
    Expect(0, 110847, '\p{^iskanasup}', "");
    Expect(0, 110847, '\P{iskanasup}', "");
    Expect(1, 110847, '\P{^iskanasup}', "");
    Expect(0, 110848, '\p{iskanasup}', "");
    Expect(1, 110848, '\p{^iskanasup}', "");
    Expect(1, 110848, '\P{iskanasup}', "");
    Expect(0, 110848, '\P{^iskanasup}', "");
    Expect(1, 110847, '\p{_Is_kana_Sup}', "");
    Expect(0, 110847, '\p{^_Is_kana_Sup}', "");
    Expect(0, 110847, '\P{_Is_kana_Sup}', "");
    Expect(1, 110847, '\P{^_Is_kana_Sup}', "");
    Expect(0, 110848, '\p{_Is_kana_Sup}', "");
    Expect(1, 110848, '\p{^_Is_kana_Sup}', "");
    Expect(1, 110848, '\P{_Is_kana_Sup}', "");
    Expect(0, 110848, '\P{^_Is_kana_Sup}', "");
    Error('\p{In_Kana_Sup:=}');
    Error('\P{In_Kana_Sup:=}');
    Expect(1, 110847, '\p{inkanasup}', "");
    Expect(0, 110847, '\p{^inkanasup}', "");
    Expect(0, 110847, '\P{inkanasup}', "");
    Expect(1, 110847, '\P{^inkanasup}', "");
    Expect(0, 110848, '\p{inkanasup}', "");
    Expect(1, 110848, '\p{^inkanasup}', "");
    Expect(1, 110848, '\P{inkanasup}', "");
    Expect(0, 110848, '\P{^inkanasup}', "");
    Expect(1, 110847, '\p{	_in_KANA_Sup}', "");
    Expect(0, 110847, '\p{^	_in_KANA_Sup}', "");
    Expect(0, 110847, '\P{	_in_KANA_Sup}', "");
    Expect(1, 110847, '\P{^	_in_KANA_Sup}', "");
    Expect(0, 110848, '\p{	_in_KANA_Sup}', "");
    Expect(1, 110848, '\p{^	_in_KANA_Sup}', "");
    Expect(1, 110848, '\P{	_in_KANA_Sup}', "");
    Expect(0, 110848, '\P{^	_in_KANA_Sup}', "");
    Error('\p{/a/ Kanbun}');
    Error('\P{/a/ Kanbun}');
    Expect(1, 12703, '\p{kanbun}', "");
    Expect(0, 12703, '\p{^kanbun}', "");
    Expect(0, 12703, '\P{kanbun}', "");
    Expect(1, 12703, '\P{^kanbun}', "");
    Expect(0, 12704, '\p{kanbun}', "");
    Expect(1, 12704, '\p{^kanbun}', "");
    Expect(1, 12704, '\P{kanbun}', "");
    Expect(0, 12704, '\P{^kanbun}', "");
    Expect(1, 12703, '\p{_ KANBUN}', "");
    Expect(0, 12703, '\p{^_ KANBUN}', "");
    Expect(0, 12703, '\P{_ KANBUN}', "");
    Expect(1, 12703, '\P{^_ KANBUN}', "");
    Expect(0, 12704, '\p{_ KANBUN}', "");
    Expect(1, 12704, '\p{^_ KANBUN}', "");
    Expect(1, 12704, '\P{_ KANBUN}', "");
    Expect(0, 12704, '\P{^_ KANBUN}', "");
    Error('\p{_:=Is_Kanbun}');
    Error('\P{_:=Is_Kanbun}');
    Expect(1, 12703, '\p{iskanbun}', "");
    Expect(0, 12703, '\p{^iskanbun}', "");
    Expect(0, 12703, '\P{iskanbun}', "");
    Expect(1, 12703, '\P{^iskanbun}', "");
    Expect(0, 12704, '\p{iskanbun}', "");
    Expect(1, 12704, '\p{^iskanbun}', "");
    Expect(1, 12704, '\P{iskanbun}', "");
    Expect(0, 12704, '\P{^iskanbun}', "");
    Expect(1, 12703, '\p{	Is_kanbun}', "");
    Expect(0, 12703, '\p{^	Is_kanbun}', "");
    Expect(0, 12703, '\P{	Is_kanbun}', "");
    Expect(1, 12703, '\P{^	Is_kanbun}', "");
    Expect(0, 12704, '\p{	Is_kanbun}', "");
    Expect(1, 12704, '\p{^	Is_kanbun}', "");
    Expect(1, 12704, '\P{	Is_kanbun}', "");
    Expect(0, 12704, '\P{^	Is_kanbun}', "");
    Error('\p{:=	In_Kanbun}');
    Error('\P{:=	In_Kanbun}');
    Expect(1, 12703, '\p{inkanbun}', "");
    Expect(0, 12703, '\p{^inkanbun}', "");
    Expect(0, 12703, '\P{inkanbun}', "");
    Expect(1, 12703, '\P{^inkanbun}', "");
    Expect(0, 12704, '\p{inkanbun}', "");
    Expect(1, 12704, '\p{^inkanbun}', "");
    Expect(1, 12704, '\P{inkanbun}', "");
    Expect(0, 12704, '\P{^inkanbun}', "");
    Expect(1, 12703, '\p{	_In_Kanbun}', "");
    Expect(0, 12703, '\p{^	_In_Kanbun}', "");
    Expect(0, 12703, '\P{	_In_Kanbun}', "");
    Expect(1, 12703, '\P{^	_In_Kanbun}', "");
    Expect(0, 12704, '\p{	_In_Kanbun}', "");
    Expect(1, 12704, '\p{^	_In_Kanbun}', "");
    Expect(1, 12704, '\P{	_In_Kanbun}', "");
    Expect(0, 12704, '\P{^	_In_Kanbun}', "");
    Error('\p{-KANGXI_radicals:=}');
    Error('\P{-KANGXI_radicals:=}');
    Expect(1, 12255, '\p{kangxiradicals}', "");
    Expect(0, 12255, '\p{^kangxiradicals}', "");
    Expect(0, 12255, '\P{kangxiradicals}', "");
    Expect(1, 12255, '\P{^kangxiradicals}', "");
    Expect(0, 12256, '\p{kangxiradicals}', "");
    Expect(1, 12256, '\p{^kangxiradicals}', "");
    Expect(1, 12256, '\P{kangxiradicals}', "");
    Expect(0, 12256, '\P{^kangxiradicals}', "");
    Expect(1, 12255, '\p{_	kangxi_Radicals}', "");
    Expect(0, 12255, '\p{^_	kangxi_Radicals}', "");
    Expect(0, 12255, '\P{_	kangxi_Radicals}', "");
    Expect(1, 12255, '\P{^_	kangxi_Radicals}', "");
    Expect(0, 12256, '\p{_	kangxi_Radicals}', "");
    Expect(1, 12256, '\p{^_	kangxi_Radicals}', "");
    Expect(1, 12256, '\P{_	kangxi_Radicals}', "");
    Expect(0, 12256, '\P{^_	kangxi_Radicals}', "");
    Error('\p{	/a/IS_kangxi_Radicals}');
    Error('\P{	/a/IS_kangxi_Radicals}');
    Expect(1, 12255, '\p{iskangxiradicals}', "");
    Expect(0, 12255, '\p{^iskangxiradicals}', "");
    Expect(0, 12255, '\P{iskangxiradicals}', "");
    Expect(1, 12255, '\P{^iskangxiradicals}', "");
    Expect(0, 12256, '\p{iskangxiradicals}', "");
    Expect(1, 12256, '\p{^iskangxiradicals}', "");
    Expect(1, 12256, '\P{iskangxiradicals}', "");
    Expect(0, 12256, '\P{^iskangxiradicals}', "");
    Expect(1, 12255, '\p{	is_Kangxi_Radicals}', "");
    Expect(0, 12255, '\p{^	is_Kangxi_Radicals}', "");
    Expect(0, 12255, '\P{	is_Kangxi_Radicals}', "");
    Expect(1, 12255, '\P{^	is_Kangxi_Radicals}', "");
    Expect(0, 12256, '\p{	is_Kangxi_Radicals}', "");
    Expect(1, 12256, '\p{^	is_Kangxi_Radicals}', "");
    Expect(1, 12256, '\P{	is_Kangxi_Radicals}', "");
    Expect(0, 12256, '\P{^	is_Kangxi_Radicals}', "");
    Error('\p{/a/In_Kangxi_Radicals}');
    Error('\P{/a/In_Kangxi_Radicals}');
    Expect(1, 12255, '\p{inkangxiradicals}', "");
    Expect(0, 12255, '\p{^inkangxiradicals}', "");
    Expect(0, 12255, '\P{inkangxiradicals}', "");
    Expect(1, 12255, '\P{^inkangxiradicals}', "");
    Expect(0, 12256, '\p{inkangxiradicals}', "");
    Expect(1, 12256, '\p{^inkangxiradicals}', "");
    Expect(1, 12256, '\P{inkangxiradicals}', "");
    Expect(0, 12256, '\P{^inkangxiradicals}', "");
    Expect(1, 12255, '\p{	In_KANGXI_RADICALS}', "");
    Expect(0, 12255, '\p{^	In_KANGXI_RADICALS}', "");
    Expect(0, 12255, '\P{	In_KANGXI_RADICALS}', "");
    Expect(1, 12255, '\P{^	In_KANGXI_RADICALS}', "");
    Expect(0, 12256, '\p{	In_KANGXI_RADICALS}', "");
    Expect(1, 12256, '\p{^	In_KANGXI_RADICALS}', "");
    Expect(1, 12256, '\P{	In_KANGXI_RADICALS}', "");
    Expect(0, 12256, '\P{^	In_KANGXI_RADICALS}', "");
    Error('\p{/a/kangxi}');
    Error('\P{/a/kangxi}');
    Expect(1, 12255, '\p{kangxi}', "");
    Expect(0, 12255, '\p{^kangxi}', "");
    Expect(0, 12255, '\P{kangxi}', "");
    Expect(1, 12255, '\P{^kangxi}', "");
    Expect(0, 12256, '\p{kangxi}', "");
    Expect(1, 12256, '\p{^kangxi}', "");
    Expect(1, 12256, '\P{kangxi}', "");
    Expect(0, 12256, '\P{^kangxi}', "");
    Expect(1, 12255, '\p{--Kangxi}', "");
    Expect(0, 12255, '\p{^--Kangxi}', "");
    Expect(0, 12255, '\P{--Kangxi}', "");
    Expect(1, 12255, '\P{^--Kangxi}', "");
    Expect(0, 12256, '\p{--Kangxi}', "");
    Expect(1, 12256, '\p{^--Kangxi}', "");
    Expect(1, 12256, '\P{--Kangxi}', "");
    Expect(0, 12256, '\P{^--Kangxi}', "");
    Error('\p{ /a/is_kangxi}');
    Error('\P{ /a/is_kangxi}');
    Expect(1, 12255, '\p{iskangxi}', "");
    Expect(0, 12255, '\p{^iskangxi}', "");
    Expect(0, 12255, '\P{iskangxi}', "");
    Expect(1, 12255, '\P{^iskangxi}', "");
    Expect(0, 12256, '\p{iskangxi}', "");
    Expect(1, 12256, '\p{^iskangxi}', "");
    Expect(1, 12256, '\P{iskangxi}', "");
    Expect(0, 12256, '\P{^iskangxi}', "");
    Expect(1, 12255, '\p{-IS_kangxi}', "");
    Expect(0, 12255, '\p{^-IS_kangxi}', "");
    Expect(0, 12255, '\P{-IS_kangxi}', "");
    Expect(1, 12255, '\P{^-IS_kangxi}', "");
    Expect(0, 12256, '\p{-IS_kangxi}', "");
    Expect(1, 12256, '\p{^-IS_kangxi}', "");
    Expect(1, 12256, '\P{-IS_kangxi}', "");
    Expect(0, 12256, '\P{^-IS_kangxi}', "");
    Error('\p{/a/in_Kangxi}');
    Error('\P{/a/in_Kangxi}');
    Expect(1, 12255, '\p{inkangxi}', "");
    Expect(0, 12255, '\p{^inkangxi}', "");
    Expect(0, 12255, '\P{inkangxi}', "");
    Expect(1, 12255, '\P{^inkangxi}', "");
    Expect(0, 12256, '\p{inkangxi}', "");
    Expect(1, 12256, '\p{^inkangxi}', "");
    Expect(1, 12256, '\P{inkangxi}', "");
    Expect(0, 12256, '\P{^inkangxi}', "");
    Expect(1, 12255, '\p{-	in_Kangxi}', "");
    Expect(0, 12255, '\p{^-	in_Kangxi}', "");
    Expect(0, 12255, '\P{-	in_Kangxi}', "");
    Expect(1, 12255, '\P{^-	in_Kangxi}', "");
    Expect(0, 12256, '\p{-	in_Kangxi}', "");
    Expect(1, 12256, '\p{^-	in_Kangxi}', "");
    Expect(1, 12256, '\P{-	in_Kangxi}', "");
    Expect(0, 12256, '\P{^-	in_Kangxi}', "");
    Error('\p{_Kannada/a/}');
    Error('\P{_Kannada/a/}');
    Expect(1, 43061, '\p{kannada}', "");
    Expect(0, 43061, '\p{^kannada}', "");
    Expect(0, 43061, '\P{kannada}', "");
    Expect(1, 43061, '\P{^kannada}', "");
    Expect(0, 43062, '\p{kannada}', "");
    Expect(1, 43062, '\p{^kannada}', "");
    Expect(1, 43062, '\P{kannada}', "");
    Expect(0, 43062, '\P{^kannada}', "");
    Expect(1, 43061, '\p{-	Kannada}', "");
    Expect(0, 43061, '\p{^-	Kannada}', "");
    Expect(0, 43061, '\P{-	Kannada}', "");
    Expect(1, 43061, '\P{^-	Kannada}', "");
    Expect(0, 43062, '\p{-	Kannada}', "");
    Expect(1, 43062, '\p{^-	Kannada}', "");
    Expect(1, 43062, '\P{-	Kannada}', "");
    Expect(0, 43062, '\P{^-	Kannada}', "");
    Error('\p{:=Is_Kannada}');
    Error('\P{:=Is_Kannada}');
    Expect(1, 43061, '\p{iskannada}', "");
    Expect(0, 43061, '\p{^iskannada}', "");
    Expect(0, 43061, '\P{iskannada}', "");
    Expect(1, 43061, '\P{^iskannada}', "");
    Expect(0, 43062, '\p{iskannada}', "");
    Expect(1, 43062, '\p{^iskannada}', "");
    Expect(1, 43062, '\P{iskannada}', "");
    Expect(0, 43062, '\P{^iskannada}', "");
    Expect(1, 43061, '\p{--Is_Kannada}', "");
    Expect(0, 43061, '\p{^--Is_Kannada}', "");
    Expect(0, 43061, '\P{--Is_Kannada}', "");
    Expect(1, 43061, '\P{^--Is_Kannada}', "");
    Expect(0, 43062, '\p{--Is_Kannada}', "");
    Expect(1, 43062, '\p{^--Is_Kannada}', "");
    Expect(1, 43062, '\P{--Is_Kannada}', "");
    Expect(0, 43062, '\P{^--Is_Kannada}', "");
    Error('\p{ _Knda:=}');
    Error('\P{ _Knda:=}');
    Expect(1, 43061, '\p{knda}', "");
    Expect(0, 43061, '\p{^knda}', "");
    Expect(0, 43061, '\P{knda}', "");
    Expect(1, 43061, '\P{^knda}', "");
    Expect(0, 43062, '\p{knda}', "");
    Expect(1, 43062, '\p{^knda}', "");
    Expect(1, 43062, '\P{knda}', "");
    Expect(0, 43062, '\P{^knda}', "");
    Expect(1, 43061, '\p{-knda}', "");
    Expect(0, 43061, '\p{^-knda}', "");
    Expect(0, 43061, '\P{-knda}', "");
    Expect(1, 43061, '\P{^-knda}', "");
    Expect(0, 43062, '\p{-knda}', "");
    Expect(1, 43062, '\p{^-knda}', "");
    Expect(1, 43062, '\P{-knda}', "");
    Expect(0, 43062, '\P{^-knda}', "");
    Error('\p{ IS_Knda/a/}');
    Error('\P{ IS_Knda/a/}');
    Expect(1, 43061, '\p{isknda}', "");
    Expect(0, 43061, '\p{^isknda}', "");
    Expect(0, 43061, '\P{isknda}', "");
    Expect(1, 43061, '\P{^isknda}', "");
    Expect(0, 43062, '\p{isknda}', "");
    Expect(1, 43062, '\p{^isknda}', "");
    Expect(1, 43062, '\P{isknda}', "");
    Expect(0, 43062, '\P{^isknda}', "");
    Expect(1, 43061, '\p{-_Is_Knda}', "");
    Expect(0, 43061, '\p{^-_Is_Knda}', "");
    Expect(0, 43061, '\P{-_Is_Knda}', "");
    Expect(1, 43061, '\P{^-_Is_Knda}', "");
    Expect(0, 43062, '\p{-_Is_Knda}', "");
    Expect(1, 43062, '\p{^-_Is_Knda}', "");
    Expect(1, 43062, '\P{-_Is_Knda}', "");
    Expect(0, 43062, '\P{^-_Is_Knda}', "");
    Error('\p{ Katakana/a/}');
    Error('\P{ Katakana/a/}');
    Expect(1, 110592, '\p{katakana}', "");
    Expect(0, 110592, '\p{^katakana}', "");
    Expect(0, 110592, '\P{katakana}', "");
    Expect(1, 110592, '\P{^katakana}', "");
    Expect(0, 110593, '\p{katakana}', "");
    Expect(1, 110593, '\p{^katakana}', "");
    Expect(1, 110593, '\P{katakana}', "");
    Expect(0, 110593, '\P{^katakana}', "");
    Expect(1, 110592, '\p{_	Katakana}', "");
    Expect(0, 110592, '\p{^_	Katakana}', "");
    Expect(0, 110592, '\P{_	Katakana}', "");
    Expect(1, 110592, '\P{^_	Katakana}', "");
    Expect(0, 110593, '\p{_	Katakana}', "");
    Expect(1, 110593, '\p{^_	Katakana}', "");
    Expect(1, 110593, '\P{_	Katakana}', "");
    Expect(0, 110593, '\P{^_	Katakana}', "");
    Error('\p{ :=Is_Katakana}');
    Error('\P{ :=Is_Katakana}');
    Expect(1, 110592, '\p{iskatakana}', "");
    Expect(0, 110592, '\p{^iskatakana}', "");
    Expect(0, 110592, '\P{iskatakana}', "");
    Expect(1, 110592, '\P{^iskatakana}', "");
    Expect(0, 110593, '\p{iskatakana}', "");
    Expect(1, 110593, '\p{^iskatakana}', "");
    Expect(1, 110593, '\P{iskatakana}', "");
    Expect(0, 110593, '\P{^iskatakana}', "");
    Expect(1, 110592, '\p{_-Is_Katakana}', "");
    Expect(0, 110592, '\p{^_-Is_Katakana}', "");
    Expect(0, 110592, '\P{_-Is_Katakana}', "");
    Expect(1, 110592, '\P{^_-Is_Katakana}', "");
    Expect(0, 110593, '\p{_-Is_Katakana}', "");
    Expect(1, 110593, '\p{^_-Is_Katakana}', "");
    Expect(1, 110593, '\P{_-Is_Katakana}', "");
    Expect(0, 110593, '\P{^_-Is_Katakana}', "");
    Error('\p{_Kana:=}');
    Error('\P{_Kana:=}');
    Expect(1, 110592, '\p{kana}', "");
    Expect(0, 110592, '\p{^kana}', "");
    Expect(0, 110592, '\P{kana}', "");
    Expect(1, 110592, '\P{^kana}', "");
    Expect(0, 110593, '\p{kana}', "");
    Expect(1, 110593, '\p{^kana}', "");
    Expect(1, 110593, '\P{kana}', "");
    Expect(0, 110593, '\P{^kana}', "");
    Expect(1, 110592, '\p{ -Kana}', "");
    Expect(0, 110592, '\p{^ -Kana}', "");
    Expect(0, 110592, '\P{ -Kana}', "");
    Expect(1, 110592, '\P{^ -Kana}', "");
    Expect(0, 110593, '\p{ -Kana}', "");
    Expect(1, 110593, '\p{^ -Kana}', "");
    Expect(1, 110593, '\P{ -Kana}', "");
    Expect(0, 110593, '\P{^ -Kana}', "");
    Error('\p{-/a/Is_KANA}');
    Error('\P{-/a/Is_KANA}');
    Expect(1, 110592, '\p{iskana}', "");
    Expect(0, 110592, '\p{^iskana}', "");
    Expect(0, 110592, '\P{iskana}', "");
    Expect(1, 110592, '\P{^iskana}', "");
    Expect(0, 110593, '\p{iskana}', "");
    Expect(1, 110593, '\p{^iskana}', "");
    Expect(1, 110593, '\P{iskana}', "");
    Expect(0, 110593, '\P{^iskana}', "");
    Expect(1, 110592, '\p{ -Is_Kana}', "");
    Expect(0, 110592, '\p{^ -Is_Kana}', "");
    Expect(0, 110592, '\P{ -Is_Kana}', "");
    Expect(1, 110592, '\P{^ -Is_Kana}', "");
    Expect(0, 110593, '\p{ -Is_Kana}', "");
    Expect(1, 110593, '\p{^ -Is_Kana}', "");
    Expect(1, 110593, '\P{ -Is_Kana}', "");
    Expect(0, 110593, '\P{^ -Is_Kana}', "");
    Error('\p{Katakana_Or_Hiragana}');
    Error('\P{Katakana_Or_Hiragana}');
    Error('\p{Is_Katakana_Or_Hiragana}');
    Error('\P{Is_Katakana_Or_Hiragana}');
    Error('\p{Hrkt}');
    Error('\P{Hrkt}');
    Error('\p{Is_Hrkt}');
    Error('\P{Is_Hrkt}');
    Error('\p{	:=KATAKANA_Phonetic_Extensions}');
    Error('\P{	:=KATAKANA_Phonetic_Extensions}');
    Expect(1, 12799, '\p{katakanaphoneticextensions}', "");
    Expect(0, 12799, '\p{^katakanaphoneticextensions}', "");
    Expect(0, 12799, '\P{katakanaphoneticextensions}', "");
    Expect(1, 12799, '\P{^katakanaphoneticextensions}', "");
    Expect(0, 12800, '\p{katakanaphoneticextensions}', "");
    Expect(1, 12800, '\p{^katakanaphoneticextensions}', "");
    Expect(1, 12800, '\P{katakanaphoneticextensions}', "");
    Expect(0, 12800, '\P{^katakanaphoneticextensions}', "");
    Expect(1, 12799, '\p{-Katakana_phonetic_extensions}', "");
    Expect(0, 12799, '\p{^-Katakana_phonetic_extensions}', "");
    Expect(0, 12799, '\P{-Katakana_phonetic_extensions}', "");
    Expect(1, 12799, '\P{^-Katakana_phonetic_extensions}', "");
    Expect(0, 12800, '\p{-Katakana_phonetic_extensions}', "");
    Expect(1, 12800, '\p{^-Katakana_phonetic_extensions}', "");
    Expect(1, 12800, '\P{-Katakana_phonetic_extensions}', "");
    Expect(0, 12800, '\P{^-Katakana_phonetic_extensions}', "");
    Error('\p{_-Is_Katakana_PHONETIC_Extensions:=}');
    Error('\P{_-Is_Katakana_PHONETIC_Extensions:=}');
    Expect(1, 12799, '\p{iskatakanaphoneticextensions}', "");
    Expect(0, 12799, '\p{^iskatakanaphoneticextensions}', "");
    Expect(0, 12799, '\P{iskatakanaphoneticextensions}', "");
    Expect(1, 12799, '\P{^iskatakanaphoneticextensions}', "");
    Expect(0, 12800, '\p{iskatakanaphoneticextensions}', "");
    Expect(1, 12800, '\p{^iskatakanaphoneticextensions}', "");
    Expect(1, 12800, '\P{iskatakanaphoneticextensions}', "");
    Expect(0, 12800, '\P{^iskatakanaphoneticextensions}', "");
    Expect(1, 12799, '\p{-Is_KATAKANA_phonetic_Extensions}', "");
    Expect(0, 12799, '\p{^-Is_KATAKANA_phonetic_Extensions}', "");
    Expect(0, 12799, '\P{-Is_KATAKANA_phonetic_Extensions}', "");
    Expect(1, 12799, '\P{^-Is_KATAKANA_phonetic_Extensions}', "");
    Expect(0, 12800, '\p{-Is_KATAKANA_phonetic_Extensions}', "");
    Expect(1, 12800, '\p{^-Is_KATAKANA_phonetic_Extensions}', "");
    Expect(1, 12800, '\P{-Is_KATAKANA_phonetic_Extensions}', "");
    Expect(0, 12800, '\P{^-Is_KATAKANA_phonetic_Extensions}', "");
    Error('\p{	in_Katakana_Phonetic_Extensions/a/}');
    Error('\P{	in_Katakana_Phonetic_Extensions/a/}');
    Expect(1, 12799, '\p{inkatakanaphoneticextensions}', "");
    Expect(0, 12799, '\p{^inkatakanaphoneticextensions}', "");
    Expect(0, 12799, '\P{inkatakanaphoneticextensions}', "");
    Expect(1, 12799, '\P{^inkatakanaphoneticextensions}', "");
    Expect(0, 12800, '\p{inkatakanaphoneticextensions}', "");
    Expect(1, 12800, '\p{^inkatakanaphoneticextensions}', "");
    Expect(1, 12800, '\P{inkatakanaphoneticextensions}', "");
    Expect(0, 12800, '\P{^inkatakanaphoneticextensions}', "");
    Expect(1, 12799, '\p{	-In_katakana_Phonetic_extensions}', "");
    Expect(0, 12799, '\p{^	-In_katakana_Phonetic_extensions}', "");
    Expect(0, 12799, '\P{	-In_katakana_Phonetic_extensions}', "");
    Expect(1, 12799, '\P{^	-In_katakana_Phonetic_extensions}', "");
    Expect(0, 12800, '\p{	-In_katakana_Phonetic_extensions}', "");
    Expect(1, 12800, '\p{^	-In_katakana_Phonetic_extensions}', "");
    Expect(1, 12800, '\P{	-In_katakana_Phonetic_extensions}', "");
    Expect(0, 12800, '\P{^	-In_katakana_Phonetic_extensions}', "");
    Error('\p{	katakana_EXT/a/}');
    Error('\P{	katakana_EXT/a/}');
    Expect(1, 12799, '\p{katakanaext}', "");
    Expect(0, 12799, '\p{^katakanaext}', "");
    Expect(0, 12799, '\P{katakanaext}', "");
    Expect(1, 12799, '\P{^katakanaext}', "");
    Expect(0, 12800, '\p{katakanaext}', "");
    Expect(1, 12800, '\p{^katakanaext}', "");
    Expect(1, 12800, '\P{katakanaext}', "");
    Expect(0, 12800, '\P{^katakanaext}', "");
    Expect(1, 12799, '\p{ Katakana_Ext}', "");
    Expect(0, 12799, '\p{^ Katakana_Ext}', "");
    Expect(0, 12799, '\P{ Katakana_Ext}', "");
    Expect(1, 12799, '\P{^ Katakana_Ext}', "");
    Expect(0, 12800, '\p{ Katakana_Ext}', "");
    Expect(1, 12800, '\p{^ Katakana_Ext}', "");
    Expect(1, 12800, '\P{ Katakana_Ext}', "");
    Expect(0, 12800, '\P{^ Katakana_Ext}', "");
    Error('\p{ 	Is_katakana_Ext/a/}');
    Error('\P{ 	Is_katakana_Ext/a/}');
    Expect(1, 12799, '\p{iskatakanaext}', "");
    Expect(0, 12799, '\p{^iskatakanaext}', "");
    Expect(0, 12799, '\P{iskatakanaext}', "");
    Expect(1, 12799, '\P{^iskatakanaext}', "");
    Expect(0, 12800, '\p{iskatakanaext}', "");
    Expect(1, 12800, '\p{^iskatakanaext}', "");
    Expect(1, 12800, '\P{iskatakanaext}', "");
    Expect(0, 12800, '\P{^iskatakanaext}', "");
    Expect(1, 12799, '\p{		IS_Katakana_ext}', "");
    Expect(0, 12799, '\p{^		IS_Katakana_ext}', "");
    Expect(0, 12799, '\P{		IS_Katakana_ext}', "");
    Expect(1, 12799, '\P{^		IS_Katakana_ext}', "");
    Expect(0, 12800, '\p{		IS_Katakana_ext}', "");
    Expect(1, 12800, '\p{^		IS_Katakana_ext}', "");
    Expect(1, 12800, '\P{		IS_Katakana_ext}', "");
    Expect(0, 12800, '\P{^		IS_Katakana_ext}', "");
    Error('\p{_in_Katakana_ext:=}');
    Error('\P{_in_Katakana_ext:=}');
    Expect(1, 12799, '\p{inkatakanaext}', "");
    Expect(0, 12799, '\p{^inkatakanaext}', "");
    Expect(0, 12799, '\P{inkatakanaext}', "");
    Expect(1, 12799, '\P{^inkatakanaext}', "");
    Expect(0, 12800, '\p{inkatakanaext}', "");
    Expect(1, 12800, '\p{^inkatakanaext}', "");
    Expect(1, 12800, '\P{inkatakanaext}', "");
    Expect(0, 12800, '\P{^inkatakanaext}', "");
    Expect(1, 12799, '\p{-	in_katakana_EXT}', "");
    Expect(0, 12799, '\p{^-	in_katakana_EXT}', "");
    Expect(0, 12799, '\P{-	in_katakana_EXT}', "");
    Expect(1, 12799, '\P{^-	in_katakana_EXT}', "");
    Expect(0, 12800, '\p{-	in_katakana_EXT}', "");
    Expect(1, 12800, '\p{^-	in_katakana_EXT}', "");
    Expect(1, 12800, '\P{-	in_katakana_EXT}', "");
    Expect(0, 12800, '\P{^-	in_katakana_EXT}', "");
    Error('\p{	kayah_LI/a/}');
    Error('\P{	kayah_LI/a/}');
    Expect(1, 43311, '\p{kayahli}', "");
    Expect(0, 43311, '\p{^kayahli}', "");
    Expect(0, 43311, '\P{kayahli}', "");
    Expect(1, 43311, '\P{^kayahli}', "");
    Expect(0, 43312, '\p{kayahli}', "");
    Expect(1, 43312, '\p{^kayahli}', "");
    Expect(1, 43312, '\P{kayahli}', "");
    Expect(0, 43312, '\P{^kayahli}', "");
    Expect(1, 43311, '\p{	-KAYAH_LI}', "");
    Expect(0, 43311, '\p{^	-KAYAH_LI}', "");
    Expect(0, 43311, '\P{	-KAYAH_LI}', "");
    Expect(1, 43311, '\P{^	-KAYAH_LI}', "");
    Expect(0, 43312, '\p{	-KAYAH_LI}', "");
    Expect(1, 43312, '\p{^	-KAYAH_LI}', "");
    Expect(1, 43312, '\P{	-KAYAH_LI}', "");
    Expect(0, 43312, '\P{^	-KAYAH_LI}', "");
    Error('\p{ /a/is_Kayah_Li}');
    Error('\P{ /a/is_Kayah_Li}');
    Expect(1, 43311, '\p{iskayahli}', "");
    Expect(0, 43311, '\p{^iskayahli}', "");
    Expect(0, 43311, '\P{iskayahli}', "");
    Expect(1, 43311, '\P{^iskayahli}', "");
    Expect(0, 43312, '\p{iskayahli}', "");
    Expect(1, 43312, '\p{^iskayahli}', "");
    Expect(1, 43312, '\P{iskayahli}', "");
    Expect(0, 43312, '\P{^iskayahli}', "");
    Expect(1, 43311, '\p{_-Is_Kayah_Li}', "");
    Expect(0, 43311, '\p{^_-Is_Kayah_Li}', "");
    Expect(0, 43311, '\P{_-Is_Kayah_Li}', "");
    Expect(1, 43311, '\P{^_-Is_Kayah_Li}', "");
    Expect(0, 43312, '\p{_-Is_Kayah_Li}', "");
    Expect(1, 43312, '\p{^_-Is_Kayah_Li}', "");
    Expect(1, 43312, '\P{_-Is_Kayah_Li}', "");
    Expect(0, 43312, '\P{^_-Is_Kayah_Li}', "");
    Error('\p{-:=Kali}');
    Error('\P{-:=Kali}');
    Expect(1, 43311, '\p{kali}', "");
    Expect(0, 43311, '\p{^kali}', "");
    Expect(0, 43311, '\P{kali}', "");
    Expect(1, 43311, '\P{^kali}', "");
    Expect(0, 43312, '\p{kali}', "");
    Expect(1, 43312, '\p{^kali}', "");
    Expect(1, 43312, '\P{kali}', "");
    Expect(0, 43312, '\P{^kali}', "");
    Expect(1, 43311, '\p{ 	kali}', "");
    Expect(0, 43311, '\p{^ 	kali}', "");
    Expect(0, 43311, '\P{ 	kali}', "");
    Expect(1, 43311, '\P{^ 	kali}', "");
    Expect(0, 43312, '\p{ 	kali}', "");
    Expect(1, 43312, '\p{^ 	kali}', "");
    Expect(1, 43312, '\P{ 	kali}', "");
    Expect(0, 43312, '\P{^ 	kali}', "");
    Error('\p{	 Is_Kali:=}');
    Error('\P{	 Is_Kali:=}');
    Expect(1, 43311, '\p{iskali}', "");
    Expect(0, 43311, '\p{^iskali}', "");
    Expect(0, 43311, '\P{iskali}', "");
    Expect(1, 43311, '\P{^iskali}', "");
    Expect(0, 43312, '\p{iskali}', "");
    Expect(1, 43312, '\p{^iskali}', "");
    Expect(1, 43312, '\P{iskali}', "");
    Expect(0, 43312, '\P{^iskali}', "");
    Expect(1, 43311, '\p{	_is_Kali}', "");
    Expect(0, 43311, '\p{^	_is_Kali}', "");
    Expect(0, 43311, '\P{	_is_Kali}', "");
    Expect(1, 43311, '\P{^	_is_Kali}', "");
    Expect(0, 43312, '\p{	_is_Kali}', "");
    Expect(1, 43312, '\p{^	_is_Kali}', "");
    Expect(1, 43312, '\P{	_is_Kali}', "");
    Expect(0, 43312, '\P{^	_is_Kali}', "");
    Error('\p{_:=Kharoshthi}');
    Error('\P{_:=Kharoshthi}');
    Expect(1, 68184, '\p{kharoshthi}', "");
    Expect(0, 68184, '\p{^kharoshthi}', "");
    Expect(0, 68184, '\P{kharoshthi}', "");
    Expect(1, 68184, '\P{^kharoshthi}', "");
    Expect(0, 68185, '\p{kharoshthi}', "");
    Expect(1, 68185, '\p{^kharoshthi}', "");
    Expect(1, 68185, '\P{kharoshthi}', "");
    Expect(0, 68185, '\P{^kharoshthi}', "");
    Expect(1, 68184, '\p{	_kharoshthi}', "");
    Expect(0, 68184, '\p{^	_kharoshthi}', "");
    Expect(0, 68184, '\P{	_kharoshthi}', "");
    Expect(1, 68184, '\P{^	_kharoshthi}', "");
    Expect(0, 68185, '\p{	_kharoshthi}', "");
    Expect(1, 68185, '\p{^	_kharoshthi}', "");
    Expect(1, 68185, '\P{	_kharoshthi}', "");
    Expect(0, 68185, '\P{^	_kharoshthi}', "");
    Error('\p{/a/  Is_kharoshthi}');
    Error('\P{/a/  Is_kharoshthi}');
    Expect(1, 68184, '\p{iskharoshthi}', "");
    Expect(0, 68184, '\p{^iskharoshthi}', "");
    Expect(0, 68184, '\P{iskharoshthi}', "");
    Expect(1, 68184, '\P{^iskharoshthi}', "");
    Expect(0, 68185, '\p{iskharoshthi}', "");
    Expect(1, 68185, '\p{^iskharoshthi}', "");
    Expect(1, 68185, '\P{iskharoshthi}', "");
    Expect(0, 68185, '\P{^iskharoshthi}', "");
    Expect(1, 68184, '\p{ -is_Kharoshthi}', "");
    Expect(0, 68184, '\p{^ -is_Kharoshthi}', "");
    Expect(0, 68184, '\P{ -is_Kharoshthi}', "");
    Expect(1, 68184, '\P{^ -is_Kharoshthi}', "");
    Expect(0, 68185, '\p{ -is_Kharoshthi}', "");
    Expect(1, 68185, '\p{^ -is_Kharoshthi}', "");
    Expect(1, 68185, '\P{ -is_Kharoshthi}', "");
    Expect(0, 68185, '\P{^ -is_Kharoshthi}', "");
    Error('\p{:= Khar}');
    Error('\P{:= Khar}');
    Expect(1, 68184, '\p{khar}', "");
    Expect(0, 68184, '\p{^khar}', "");
    Expect(0, 68184, '\P{khar}', "");
    Expect(1, 68184, '\P{^khar}', "");
    Expect(0, 68185, '\p{khar}', "");
    Expect(1, 68185, '\p{^khar}', "");
    Expect(1, 68185, '\P{khar}', "");
    Expect(0, 68185, '\P{^khar}', "");
    Expect(1, 68184, '\p{- KHAR}', "");
    Expect(0, 68184, '\p{^- KHAR}', "");
    Expect(0, 68184, '\P{- KHAR}', "");
    Expect(1, 68184, '\P{^- KHAR}', "");
    Expect(0, 68185, '\p{- KHAR}', "");
    Expect(1, 68185, '\p{^- KHAR}', "");
    Expect(1, 68185, '\P{- KHAR}', "");
    Expect(0, 68185, '\P{^- KHAR}', "");
    Error('\p{Is_Khar:=}');
    Error('\P{Is_Khar:=}');
    Expect(1, 68184, '\p{iskhar}', "");
    Expect(0, 68184, '\p{^iskhar}', "");
    Expect(0, 68184, '\P{iskhar}', "");
    Expect(1, 68184, '\P{^iskhar}', "");
    Expect(0, 68185, '\p{iskhar}', "");
    Expect(1, 68185, '\p{^iskhar}', "");
    Expect(1, 68185, '\P{iskhar}', "");
    Expect(0, 68185, '\P{^iskhar}', "");
    Expect(1, 68184, '\p{__Is_KHAR}', "");
    Expect(0, 68184, '\p{^__Is_KHAR}', "");
    Expect(0, 68184, '\P{__Is_KHAR}', "");
    Expect(1, 68184, '\P{^__Is_KHAR}', "");
    Expect(0, 68185, '\p{__Is_KHAR}', "");
    Expect(1, 68185, '\p{^__Is_KHAR}', "");
    Expect(1, 68185, '\P{__Is_KHAR}', "");
    Expect(0, 68185, '\P{^__Is_KHAR}', "");
    Error('\p{:=_Khmer}');
    Error('\P{:=_Khmer}');
    Expect(1, 6655, '\p{khmer}', "");
    Expect(0, 6655, '\p{^khmer}', "");
    Expect(0, 6655, '\P{khmer}', "");
    Expect(1, 6655, '\P{^khmer}', "");
    Expect(0, 6656, '\p{khmer}', "");
    Expect(1, 6656, '\p{^khmer}', "");
    Expect(1, 6656, '\P{khmer}', "");
    Expect(0, 6656, '\P{^khmer}', "");
    Expect(1, 6655, '\p{	Khmer}', "");
    Expect(0, 6655, '\p{^	Khmer}', "");
    Expect(0, 6655, '\P{	Khmer}', "");
    Expect(1, 6655, '\P{^	Khmer}', "");
    Expect(0, 6656, '\p{	Khmer}', "");
    Expect(1, 6656, '\p{^	Khmer}', "");
    Expect(1, 6656, '\P{	Khmer}', "");
    Expect(0, 6656, '\P{^	Khmer}', "");
    Error('\p{		Is_khmer:=}');
    Error('\P{		Is_khmer:=}');
    Expect(1, 6655, '\p{iskhmer}', "");
    Expect(0, 6655, '\p{^iskhmer}', "");
    Expect(0, 6655, '\P{iskhmer}', "");
    Expect(1, 6655, '\P{^iskhmer}', "");
    Expect(0, 6656, '\p{iskhmer}', "");
    Expect(1, 6656, '\p{^iskhmer}', "");
    Expect(1, 6656, '\P{iskhmer}', "");
    Expect(0, 6656, '\P{^iskhmer}', "");
    Expect(1, 6655, '\p{-IS_Khmer}', "");
    Expect(0, 6655, '\p{^-IS_Khmer}', "");
    Expect(0, 6655, '\P{-IS_Khmer}', "");
    Expect(1, 6655, '\P{^-IS_Khmer}', "");
    Expect(0, 6656, '\p{-IS_Khmer}', "");
    Expect(1, 6656, '\p{^-IS_Khmer}', "");
    Expect(1, 6656, '\P{-IS_Khmer}', "");
    Expect(0, 6656, '\P{^-IS_Khmer}', "");
    Error('\p{:=khmr}');
    Error('\P{:=khmr}');
    Expect(1, 6655, '\p{khmr}', "");
    Expect(0, 6655, '\p{^khmr}', "");
    Expect(0, 6655, '\P{khmr}', "");
    Expect(1, 6655, '\P{^khmr}', "");
    Expect(0, 6656, '\p{khmr}', "");
    Expect(1, 6656, '\p{^khmr}', "");
    Expect(1, 6656, '\P{khmr}', "");
    Expect(0, 6656, '\P{^khmr}', "");
    Expect(1, 6655, '\p{		KHMR}', "");
    Expect(0, 6655, '\p{^		KHMR}', "");
    Expect(0, 6655, '\P{		KHMR}', "");
    Expect(1, 6655, '\P{^		KHMR}', "");
    Expect(0, 6656, '\p{		KHMR}', "");
    Expect(1, 6656, '\p{^		KHMR}', "");
    Expect(1, 6656, '\P{		KHMR}', "");
    Expect(0, 6656, '\P{^		KHMR}', "");
    Error('\p{:=-	IS_Khmr}');
    Error('\P{:=-	IS_Khmr}');
    Expect(1, 6655, '\p{iskhmr}', "");
    Expect(0, 6655, '\p{^iskhmr}', "");
    Expect(0, 6655, '\P{iskhmr}', "");
    Expect(1, 6655, '\P{^iskhmr}', "");
    Expect(0, 6656, '\p{iskhmr}', "");
    Expect(1, 6656, '\p{^iskhmr}', "");
    Expect(1, 6656, '\P{iskhmr}', "");
    Expect(0, 6656, '\P{^iskhmr}', "");
    Expect(1, 6655, '\p{__Is_Khmr}', "");
    Expect(0, 6655, '\p{^__Is_Khmr}', "");
    Expect(0, 6655, '\P{__Is_Khmr}', "");
    Expect(1, 6655, '\P{^__Is_Khmr}', "");
    Expect(0, 6656, '\p{__Is_Khmr}', "");
    Expect(1, 6656, '\p{^__Is_Khmr}', "");
    Expect(1, 6656, '\P{__Is_Khmr}', "");
    Expect(0, 6656, '\P{^__Is_Khmr}', "");
    Error('\p{ _Khmer_SYMBOLS:=}');
    Error('\P{ _Khmer_SYMBOLS:=}');
    Expect(1, 6655, '\p{khmersymbols}', "");
    Expect(0, 6655, '\p{^khmersymbols}', "");
    Expect(0, 6655, '\P{khmersymbols}', "");
    Expect(1, 6655, '\P{^khmersymbols}', "");
    Expect(0, 6656, '\p{khmersymbols}', "");
    Expect(1, 6656, '\p{^khmersymbols}', "");
    Expect(1, 6656, '\P{khmersymbols}', "");
    Expect(0, 6656, '\P{^khmersymbols}', "");
    Expect(1, 6655, '\p{_ khmer_symbols}', "");
    Expect(0, 6655, '\p{^_ khmer_symbols}', "");
    Expect(0, 6655, '\P{_ khmer_symbols}', "");
    Expect(1, 6655, '\P{^_ khmer_symbols}', "");
    Expect(0, 6656, '\p{_ khmer_symbols}', "");
    Expect(1, 6656, '\p{^_ khmer_symbols}', "");
    Expect(1, 6656, '\P{_ khmer_symbols}', "");
    Expect(0, 6656, '\P{^_ khmer_symbols}', "");
    Error('\p{/a/ is_khmer_Symbols}');
    Error('\P{/a/ is_khmer_Symbols}');
    Expect(1, 6655, '\p{iskhmersymbols}', "");
    Expect(0, 6655, '\p{^iskhmersymbols}', "");
    Expect(0, 6655, '\P{iskhmersymbols}', "");
    Expect(1, 6655, '\P{^iskhmersymbols}', "");
    Expect(0, 6656, '\p{iskhmersymbols}', "");
    Expect(1, 6656, '\p{^iskhmersymbols}', "");
    Expect(1, 6656, '\P{iskhmersymbols}', "");
    Expect(0, 6656, '\P{^iskhmersymbols}', "");
    Expect(1, 6655, '\p{--IS_khmer_SYMBOLS}', "");
    Expect(0, 6655, '\p{^--IS_khmer_SYMBOLS}', "");
    Expect(0, 6655, '\P{--IS_khmer_SYMBOLS}', "");
    Expect(1, 6655, '\P{^--IS_khmer_SYMBOLS}', "");
    Expect(0, 6656, '\p{--IS_khmer_SYMBOLS}', "");
    Expect(1, 6656, '\p{^--IS_khmer_SYMBOLS}', "");
    Expect(1, 6656, '\P{--IS_khmer_SYMBOLS}', "");
    Expect(0, 6656, '\P{^--IS_khmer_SYMBOLS}', "");
    Error('\p{ _In_Khmer_SYMBOLS:=}');
    Error('\P{ _In_Khmer_SYMBOLS:=}');
    Expect(1, 6655, '\p{inkhmersymbols}', "");
    Expect(0, 6655, '\p{^inkhmersymbols}', "");
    Expect(0, 6655, '\P{inkhmersymbols}', "");
    Expect(1, 6655, '\P{^inkhmersymbols}', "");
    Expect(0, 6656, '\p{inkhmersymbols}', "");
    Expect(1, 6656, '\p{^inkhmersymbols}', "");
    Expect(1, 6656, '\P{inkhmersymbols}', "");
    Expect(0, 6656, '\P{^inkhmersymbols}', "");
    Expect(1, 6655, '\p{	In_KHMER_SYMBOLS}', "");
    Expect(0, 6655, '\p{^	In_KHMER_SYMBOLS}', "");
    Expect(0, 6655, '\P{	In_KHMER_SYMBOLS}', "");
    Expect(1, 6655, '\P{^	In_KHMER_SYMBOLS}', "");
    Expect(0, 6656, '\p{	In_KHMER_SYMBOLS}', "");
    Expect(1, 6656, '\p{^	In_KHMER_SYMBOLS}', "");
    Expect(1, 6656, '\P{	In_KHMER_SYMBOLS}', "");
    Expect(0, 6656, '\P{^	In_KHMER_SYMBOLS}', "");
    Error('\p{/a/ -Khojki}');
    Error('\P{/a/ -Khojki}');
    Expect(1, 70206, '\p{khojki}', "");
    Expect(0, 70206, '\p{^khojki}', "");
    Expect(0, 70206, '\P{khojki}', "");
    Expect(1, 70206, '\P{^khojki}', "");
    Expect(0, 70207, '\p{khojki}', "");
    Expect(1, 70207, '\p{^khojki}', "");
    Expect(1, 70207, '\P{khojki}', "");
    Expect(0, 70207, '\P{^khojki}', "");
    Expect(1, 70206, '\p{	-khojki}', "");
    Expect(0, 70206, '\p{^	-khojki}', "");
    Expect(0, 70206, '\P{	-khojki}', "");
    Expect(1, 70206, '\P{^	-khojki}', "");
    Expect(0, 70207, '\p{	-khojki}', "");
    Expect(1, 70207, '\p{^	-khojki}', "");
    Expect(1, 70207, '\P{	-khojki}', "");
    Expect(0, 70207, '\P{^	-khojki}', "");
    Error('\p{	-Is_Khojki:=}');
    Error('\P{	-Is_Khojki:=}');
    Expect(1, 70206, '\p{iskhojki}', "");
    Expect(0, 70206, '\p{^iskhojki}', "");
    Expect(0, 70206, '\P{iskhojki}', "");
    Expect(1, 70206, '\P{^iskhojki}', "");
    Expect(0, 70207, '\p{iskhojki}', "");
    Expect(1, 70207, '\p{^iskhojki}', "");
    Expect(1, 70207, '\P{iskhojki}', "");
    Expect(0, 70207, '\P{^iskhojki}', "");
    Expect(1, 70206, '\p{_is_Khojki}', "");
    Expect(0, 70206, '\p{^_is_Khojki}', "");
    Expect(0, 70206, '\P{_is_Khojki}', "");
    Expect(1, 70206, '\P{^_is_Khojki}', "");
    Expect(0, 70207, '\p{_is_Khojki}', "");
    Expect(1, 70207, '\p{^_is_Khojki}', "");
    Expect(1, 70207, '\P{_is_Khojki}', "");
    Expect(0, 70207, '\P{^_is_Khojki}', "");
    Error('\p{	-KHOJ:=}');
    Error('\P{	-KHOJ:=}');
    Expect(1, 70206, '\p{khoj}', "");
    Expect(0, 70206, '\p{^khoj}', "");
    Expect(0, 70206, '\P{khoj}', "");
    Expect(1, 70206, '\P{^khoj}', "");
    Expect(0, 70207, '\p{khoj}', "");
    Expect(1, 70207, '\p{^khoj}', "");
    Expect(1, 70207, '\P{khoj}', "");
    Expect(0, 70207, '\P{^khoj}', "");
    Expect(1, 70206, '\p{_ khoj}', "");
    Expect(0, 70206, '\p{^_ khoj}', "");
    Expect(0, 70206, '\P{_ khoj}', "");
    Expect(1, 70206, '\P{^_ khoj}', "");
    Expect(0, 70207, '\p{_ khoj}', "");
    Expect(1, 70207, '\p{^_ khoj}', "");
    Expect(1, 70207, '\P{_ khoj}', "");
    Expect(0, 70207, '\P{^_ khoj}', "");
    Error('\p{-	Is_KHOJ/a/}');
    Error('\P{-	Is_KHOJ/a/}');
    Expect(1, 70206, '\p{iskhoj}', "");
    Expect(0, 70206, '\p{^iskhoj}', "");
    Expect(0, 70206, '\P{iskhoj}', "");
    Expect(1, 70206, '\P{^iskhoj}', "");
    Expect(0, 70207, '\p{iskhoj}', "");
    Expect(1, 70207, '\p{^iskhoj}', "");
    Expect(1, 70207, '\P{iskhoj}', "");
    Expect(0, 70207, '\P{^iskhoj}', "");
    Expect(1, 70206, '\p{--IS_Khoj}', "");
    Expect(0, 70206, '\p{^--IS_Khoj}', "");
    Expect(0, 70206, '\P{--IS_Khoj}', "");
    Expect(1, 70206, '\P{^--IS_Khoj}', "");
    Expect(0, 70207, '\p{--IS_Khoj}', "");
    Expect(1, 70207, '\p{^--IS_Khoj}', "");
    Expect(1, 70207, '\P{--IS_Khoj}', "");
    Expect(0, 70207, '\P{^--IS_Khoj}', "");
    Error('\p{/a/Khudawadi}');
    Error('\P{/a/Khudawadi}');
    Expect(1, 70393, '\p{khudawadi}', "");
    Expect(0, 70393, '\p{^khudawadi}', "");
    Expect(0, 70393, '\P{khudawadi}', "");
    Expect(1, 70393, '\P{^khudawadi}', "");
    Expect(0, 70394, '\p{khudawadi}', "");
    Expect(1, 70394, '\p{^khudawadi}', "");
    Expect(1, 70394, '\P{khudawadi}', "");
    Expect(0, 70394, '\P{^khudawadi}', "");
    Expect(1, 70393, '\p{ _khudawadi}', "");
    Expect(0, 70393, '\p{^ _khudawadi}', "");
    Expect(0, 70393, '\P{ _khudawadi}', "");
    Expect(1, 70393, '\P{^ _khudawadi}', "");
    Expect(0, 70394, '\p{ _khudawadi}', "");
    Expect(1, 70394, '\p{^ _khudawadi}', "");
    Expect(1, 70394, '\P{ _khudawadi}', "");
    Expect(0, 70394, '\P{^ _khudawadi}', "");
    Error('\p{_/a/Is_KHUDAWADI}');
    Error('\P{_/a/Is_KHUDAWADI}');
    Expect(1, 70393, '\p{iskhudawadi}', "");
    Expect(0, 70393, '\p{^iskhudawadi}', "");
    Expect(0, 70393, '\P{iskhudawadi}', "");
    Expect(1, 70393, '\P{^iskhudawadi}', "");
    Expect(0, 70394, '\p{iskhudawadi}', "");
    Expect(1, 70394, '\p{^iskhudawadi}', "");
    Expect(1, 70394, '\P{iskhudawadi}', "");
    Expect(0, 70394, '\P{^iskhudawadi}', "");
    Expect(1, 70393, '\p{-_Is_KHUDAWADI}', "");
    Expect(0, 70393, '\p{^-_Is_KHUDAWADI}', "");
    Expect(0, 70393, '\P{-_Is_KHUDAWADI}', "");
    Expect(1, 70393, '\P{^-_Is_KHUDAWADI}', "");
    Expect(0, 70394, '\p{-_Is_KHUDAWADI}', "");
    Expect(1, 70394, '\p{^-_Is_KHUDAWADI}', "");
    Expect(1, 70394, '\P{-_Is_KHUDAWADI}', "");
    Expect(0, 70394, '\P{^-_Is_KHUDAWADI}', "");
    Error('\p{/a/ 	SIND}');
    Error('\P{/a/ 	SIND}');
    Expect(1, 70393, '\p{sind}', "");
    Expect(0, 70393, '\p{^sind}', "");
    Expect(0, 70393, '\P{sind}', "");
    Expect(1, 70393, '\P{^sind}', "");
    Expect(0, 70394, '\p{sind}', "");
    Expect(1, 70394, '\p{^sind}', "");
    Expect(1, 70394, '\P{sind}', "");
    Expect(0, 70394, '\P{^sind}', "");
    Expect(1, 70393, '\p{ -SIND}', "");
    Expect(0, 70393, '\p{^ -SIND}', "");
    Expect(0, 70393, '\P{ -SIND}', "");
    Expect(1, 70393, '\P{^ -SIND}', "");
    Expect(0, 70394, '\p{ -SIND}', "");
    Expect(1, 70394, '\p{^ -SIND}', "");
    Expect(1, 70394, '\P{ -SIND}', "");
    Expect(0, 70394, '\P{^ -SIND}', "");
    Error('\p{:=	-Is_Sind}');
    Error('\P{:=	-Is_Sind}');
    Expect(1, 70393, '\p{issind}', "");
    Expect(0, 70393, '\p{^issind}', "");
    Expect(0, 70393, '\P{issind}', "");
    Expect(1, 70393, '\P{^issind}', "");
    Expect(0, 70394, '\p{issind}', "");
    Expect(1, 70394, '\p{^issind}', "");
    Expect(1, 70394, '\P{issind}', "");
    Expect(0, 70394, '\P{^issind}', "");
    Expect(1, 70393, '\p{_Is_SIND}', "");
    Expect(0, 70393, '\p{^_Is_SIND}', "");
    Expect(0, 70393, '\P{_Is_SIND}', "");
    Expect(1, 70393, '\P{^_Is_SIND}', "");
    Expect(0, 70394, '\p{_Is_SIND}', "");
    Expect(1, 70394, '\p{^_Is_SIND}', "");
    Expect(1, 70394, '\P{_Is_SIND}', "");
    Expect(0, 70394, '\P{^_Is_SIND}', "");
    Error('\p{_:=Lao}');
    Error('\P{_:=Lao}');
    Expect(1, 3807, '\p{lao}', "");
    Expect(0, 3807, '\p{^lao}', "");
    Expect(0, 3807, '\P{lao}', "");
    Expect(1, 3807, '\P{^lao}', "");
    Expect(0, 3808, '\p{lao}', "");
    Expect(1, 3808, '\p{^lao}', "");
    Expect(1, 3808, '\P{lao}', "");
    Expect(0, 3808, '\P{^lao}', "");
    Expect(1, 3807, '\p{		LAO}', "");
    Expect(0, 3807, '\p{^		LAO}', "");
    Expect(0, 3807, '\P{		LAO}', "");
    Expect(1, 3807, '\P{^		LAO}', "");
    Expect(0, 3808, '\p{		LAO}', "");
    Expect(1, 3808, '\p{^		LAO}', "");
    Expect(1, 3808, '\P{		LAO}', "");
    Expect(0, 3808, '\P{^		LAO}', "");
    Error('\p{__Is_lao/a/}');
    Error('\P{__Is_lao/a/}');
    Expect(1, 3807, '\p{islao}', "");
    Expect(0, 3807, '\p{^islao}', "");
    Expect(0, 3807, '\P{islao}', "");
    Expect(1, 3807, '\P{^islao}', "");
    Expect(0, 3808, '\p{islao}', "");
    Expect(1, 3808, '\p{^islao}', "");
    Expect(1, 3808, '\P{islao}', "");
    Expect(0, 3808, '\P{^islao}', "");
    Expect(1, 3807, '\p{- Is_lao}', "");
    Expect(0, 3807, '\p{^- Is_lao}', "");
    Expect(0, 3807, '\P{- Is_lao}', "");
    Expect(1, 3807, '\P{^- Is_lao}', "");
    Expect(0, 3808, '\p{- Is_lao}', "");
    Expect(1, 3808, '\p{^- Is_lao}', "");
    Expect(1, 3808, '\P{- Is_lao}', "");
    Expect(0, 3808, '\P{^- Is_lao}', "");
    Error('\p{	/a/Laoo}');
    Error('\P{	/a/Laoo}');
    Expect(1, 3807, '\p{laoo}', "");
    Expect(0, 3807, '\p{^laoo}', "");
    Expect(0, 3807, '\P{laoo}', "");
    Expect(1, 3807, '\P{^laoo}', "");
    Expect(0, 3808, '\p{laoo}', "");
    Expect(1, 3808, '\p{^laoo}', "");
    Expect(1, 3808, '\P{laoo}', "");
    Expect(0, 3808, '\P{^laoo}', "");
    Expect(1, 3807, '\p{ Laoo}', "");
    Expect(0, 3807, '\p{^ Laoo}', "");
    Expect(0, 3807, '\P{ Laoo}', "");
    Expect(1, 3807, '\P{^ Laoo}', "");
    Expect(0, 3808, '\p{ Laoo}', "");
    Expect(1, 3808, '\p{^ Laoo}', "");
    Expect(1, 3808, '\P{ Laoo}', "");
    Expect(0, 3808, '\P{^ Laoo}', "");
    Error('\p{IS_laoo:=}');
    Error('\P{IS_laoo:=}');
    Expect(1, 3807, '\p{islaoo}', "");
    Expect(0, 3807, '\p{^islaoo}', "");
    Expect(0, 3807, '\P{islaoo}', "");
    Expect(1, 3807, '\P{^islaoo}', "");
    Expect(0, 3808, '\p{islaoo}', "");
    Expect(1, 3808, '\p{^islaoo}', "");
    Expect(1, 3808, '\P{islaoo}', "");
    Expect(0, 3808, '\P{^islaoo}', "");
    Expect(1, 3807, '\p{	_is_Laoo}', "");
    Expect(0, 3807, '\p{^	_is_Laoo}', "");
    Expect(0, 3807, '\P{	_is_Laoo}', "");
    Expect(1, 3807, '\P{^	_is_Laoo}', "");
    Expect(0, 3808, '\p{	_is_Laoo}', "");
    Expect(1, 3808, '\p{^	_is_Laoo}', "");
    Expect(1, 3808, '\P{	_is_Laoo}', "");
    Expect(0, 3808, '\P{^	_is_Laoo}', "");
    Error('\p{_Latin:=}');
    Error('\P{_Latin:=}');
    Expect(1, 65370, '\p{latin}', "");
    Expect(0, 65370, '\p{^latin}', "");
    Expect(0, 65370, '\P{latin}', "");
    Expect(1, 65370, '\P{^latin}', "");
    Expect(0, 65371, '\p{latin}', "");
    Expect(1, 65371, '\p{^latin}', "");
    Expect(1, 65371, '\P{latin}', "");
    Expect(0, 65371, '\P{^latin}', "");
    Expect(1, 65370, '\p{_	LATIN}', "");
    Expect(0, 65370, '\p{^_	LATIN}', "");
    Expect(0, 65370, '\P{_	LATIN}', "");
    Expect(1, 65370, '\P{^_	LATIN}', "");
    Expect(0, 65371, '\p{_	LATIN}', "");
    Expect(1, 65371, '\p{^_	LATIN}', "");
    Expect(1, 65371, '\P{_	LATIN}', "");
    Expect(0, 65371, '\P{^_	LATIN}', "");
    Error('\p{ 	Is_Latin/a/}');
    Error('\P{ 	Is_Latin/a/}');
    Expect(1, 65370, '\p{islatin}', "");
    Expect(0, 65370, '\p{^islatin}', "");
    Expect(0, 65370, '\P{islatin}', "");
    Expect(1, 65370, '\P{^islatin}', "");
    Expect(0, 65371, '\p{islatin}', "");
    Expect(1, 65371, '\p{^islatin}', "");
    Expect(1, 65371, '\P{islatin}', "");
    Expect(0, 65371, '\P{^islatin}', "");
    Expect(1, 65370, '\p{ IS_Latin}', "");
    Expect(0, 65370, '\p{^ IS_Latin}', "");
    Expect(0, 65370, '\P{ IS_Latin}', "");
    Expect(1, 65370, '\P{^ IS_Latin}', "");
    Expect(0, 65371, '\p{ IS_Latin}', "");
    Expect(1, 65371, '\p{^ IS_Latin}', "");
    Expect(1, 65371, '\P{ IS_Latin}', "");
    Expect(0, 65371, '\P{^ IS_Latin}', "");
    Error('\p{-/a/LATN}');
    Error('\P{-/a/LATN}');
    Expect(1, 65370, '\p{latn}', "");
    Expect(0, 65370, '\p{^latn}', "");
    Expect(0, 65370, '\P{latn}', "");
    Expect(1, 65370, '\P{^latn}', "");
    Expect(0, 65371, '\p{latn}', "");
    Expect(1, 65371, '\p{^latn}', "");
    Expect(1, 65371, '\P{latn}', "");
    Expect(0, 65371, '\P{^latn}', "");
    Expect(1, 65370, '\p{	_latn}', "");
    Expect(0, 65370, '\p{^	_latn}', "");
    Expect(0, 65370, '\P{	_latn}', "");
    Expect(1, 65370, '\P{^	_latn}', "");
    Expect(0, 65371, '\p{	_latn}', "");
    Expect(1, 65371, '\p{^	_latn}', "");
    Expect(1, 65371, '\P{	_latn}', "");
    Expect(0, 65371, '\P{^	_latn}', "");
    Error('\p{:=-	Is_Latn}');
    Error('\P{:=-	Is_Latn}');
    Expect(1, 65370, '\p{islatn}', "");
    Expect(0, 65370, '\p{^islatn}', "");
    Expect(0, 65370, '\P{islatn}', "");
    Expect(1, 65370, '\P{^islatn}', "");
    Expect(0, 65371, '\p{islatn}', "");
    Expect(1, 65371, '\p{^islatn}', "");
    Expect(1, 65371, '\P{islatn}', "");
    Expect(0, 65371, '\P{^islatn}', "");
    Expect(1, 65370, '\p{ Is_LATN}', "");
    Expect(0, 65370, '\p{^ Is_LATN}', "");
    Expect(0, 65370, '\P{ Is_LATN}', "");
    Expect(1, 65370, '\P{^ Is_LATN}', "");
    Expect(0, 65371, '\p{ Is_LATN}', "");
    Expect(1, 65371, '\p{^ Is_LATN}', "");
    Expect(1, 65371, '\P{ Is_LATN}', "");
    Expect(0, 65371, '\P{^ Is_LATN}', "");
    Error('\p{:=  Latin_1_supplement}');
    Error('\P{:=  Latin_1_supplement}');
    Expect(1, 255, '\p{latin1supplement}', "");
    Expect(0, 255, '\p{^latin1supplement}', "");
    Expect(0, 255, '\P{latin1supplement}', "");
    Expect(1, 255, '\P{^latin1supplement}', "");
    Expect(0, 256, '\p{latin1supplement}', "");
    Expect(1, 256, '\p{^latin1supplement}', "");
    Expect(1, 256, '\P{latin1supplement}', "");
    Expect(0, 256, '\P{^latin1supplement}', "");
    Expect(1, 255, '\p{- LATIN_1_Supplement}', "");
    Expect(0, 255, '\p{^- LATIN_1_Supplement}', "");
    Expect(0, 255, '\P{- LATIN_1_Supplement}', "");
    Expect(1, 255, '\P{^- LATIN_1_Supplement}', "");
    Expect(0, 256, '\p{- LATIN_1_Supplement}', "");
    Expect(1, 256, '\p{^- LATIN_1_Supplement}', "");
    Expect(1, 256, '\P{- LATIN_1_Supplement}', "");
    Expect(0, 256, '\P{^- LATIN_1_Supplement}', "");
    Error('\p{:= is_Latin_1_Supplement}');
    Error('\P{:= is_Latin_1_Supplement}');
    Expect(1, 255, '\p{islatin1supplement}', "");
    Expect(0, 255, '\p{^islatin1supplement}', "");
    Expect(0, 255, '\P{islatin1supplement}', "");
    Expect(1, 255, '\P{^islatin1supplement}', "");
    Expect(0, 256, '\p{islatin1supplement}', "");
    Expect(1, 256, '\p{^islatin1supplement}', "");
    Expect(1, 256, '\P{islatin1supplement}', "");
    Expect(0, 256, '\P{^islatin1supplement}', "");
    Expect(1, 255, '\p{_-Is_LATIN_1_supplement}', "");
    Expect(0, 255, '\p{^_-Is_LATIN_1_supplement}', "");
    Expect(0, 255, '\P{_-Is_LATIN_1_supplement}', "");
    Expect(1, 255, '\P{^_-Is_LATIN_1_supplement}', "");
    Expect(0, 256, '\p{_-Is_LATIN_1_supplement}', "");
    Expect(1, 256, '\p{^_-Is_LATIN_1_supplement}', "");
    Expect(1, 256, '\P{_-Is_LATIN_1_supplement}', "");
    Expect(0, 256, '\P{^_-Is_LATIN_1_supplement}', "");
    Error('\p{/a/_ In_Latin_1_supplement}');
    Error('\P{/a/_ In_Latin_1_supplement}');
    Expect(1, 255, '\p{inlatin1supplement}', "");
    Expect(0, 255, '\p{^inlatin1supplement}', "");
    Expect(0, 255, '\P{inlatin1supplement}', "");
    Expect(1, 255, '\P{^inlatin1supplement}', "");
    Expect(0, 256, '\p{inlatin1supplement}', "");
    Expect(1, 256, '\p{^inlatin1supplement}', "");
    Expect(1, 256, '\P{inlatin1supplement}', "");
    Expect(0, 256, '\P{^inlatin1supplement}', "");
    Expect(1, 255, '\p{	_In_Latin_1_Supplement}', "");
    Expect(0, 255, '\p{^	_In_Latin_1_Supplement}', "");
    Expect(0, 255, '\P{	_In_Latin_1_Supplement}', "");
    Expect(1, 255, '\P{^	_In_Latin_1_Supplement}', "");
    Expect(0, 256, '\p{	_In_Latin_1_Supplement}', "");
    Expect(1, 256, '\p{^	_In_Latin_1_Supplement}', "");
    Expect(1, 256, '\P{	_In_Latin_1_Supplement}', "");
    Expect(0, 256, '\P{^	_In_Latin_1_Supplement}', "");
    Error('\p{/a/ -latin_1_Sup}');
    Error('\P{/a/ -latin_1_Sup}');
    Expect(1, 255, '\p{latin1sup}', "");
    Expect(0, 255, '\p{^latin1sup}', "");
    Expect(0, 255, '\P{latin1sup}', "");
    Expect(1, 255, '\P{^latin1sup}', "");
    Expect(0, 256, '\p{latin1sup}', "");
    Expect(1, 256, '\p{^latin1sup}', "");
    Expect(1, 256, '\P{latin1sup}', "");
    Expect(0, 256, '\P{^latin1sup}', "");
    Expect(1, 255, '\p{_-Latin_1_Sup}', "");
    Expect(0, 255, '\p{^_-Latin_1_Sup}', "");
    Expect(0, 255, '\P{_-Latin_1_Sup}', "");
    Expect(1, 255, '\P{^_-Latin_1_Sup}', "");
    Expect(0, 256, '\p{_-Latin_1_Sup}', "");
    Expect(1, 256, '\p{^_-Latin_1_Sup}', "");
    Expect(1, 256, '\P{_-Latin_1_Sup}', "");
    Expect(0, 256, '\P{^_-Latin_1_Sup}', "");
    Error('\p{/a/ -IS_LATIN_1_sup}');
    Error('\P{/a/ -IS_LATIN_1_sup}');
    Expect(1, 255, '\p{islatin1sup}', "");
    Expect(0, 255, '\p{^islatin1sup}', "");
    Expect(0, 255, '\P{islatin1sup}', "");
    Expect(1, 255, '\P{^islatin1sup}', "");
    Expect(0, 256, '\p{islatin1sup}', "");
    Expect(1, 256, '\p{^islatin1sup}', "");
    Expect(1, 256, '\P{islatin1sup}', "");
    Expect(0, 256, '\P{^islatin1sup}', "");
    Expect(1, 255, '\p{-_Is_latin_1_SUP}', "");
    Expect(0, 255, '\p{^-_Is_latin_1_SUP}', "");
    Expect(0, 255, '\P{-_Is_latin_1_SUP}', "");
    Expect(1, 255, '\P{^-_Is_latin_1_SUP}', "");
    Expect(0, 256, '\p{-_Is_latin_1_SUP}', "");
    Expect(1, 256, '\p{^-_Is_latin_1_SUP}', "");
    Expect(1, 256, '\P{-_Is_latin_1_SUP}', "");
    Expect(0, 256, '\P{^-_Is_latin_1_SUP}', "");
    Error('\p{/a/- In_latin_1_Sup}');
    Error('\P{/a/- In_latin_1_Sup}');
    Expect(1, 255, '\p{inlatin1sup}', "");
    Expect(0, 255, '\p{^inlatin1sup}', "");
    Expect(0, 255, '\P{inlatin1sup}', "");
    Expect(1, 255, '\P{^inlatin1sup}', "");
    Expect(0, 256, '\p{inlatin1sup}', "");
    Expect(1, 256, '\p{^inlatin1sup}', "");
    Expect(1, 256, '\P{inlatin1sup}', "");
    Expect(0, 256, '\P{^inlatin1sup}', "");
    Expect(1, 255, '\p{	 In_LATIN_1_Sup}', "");
    Expect(0, 255, '\p{^	 In_LATIN_1_Sup}', "");
    Expect(0, 255, '\P{	 In_LATIN_1_Sup}', "");
    Expect(1, 255, '\P{^	 In_LATIN_1_Sup}', "");
    Expect(0, 256, '\p{	 In_LATIN_1_Sup}', "");
    Expect(1, 256, '\p{^	 In_LATIN_1_Sup}', "");
    Expect(1, 256, '\P{	 In_LATIN_1_Sup}', "");
    Expect(0, 256, '\P{^	 In_LATIN_1_Sup}', "");
    Error('\p{:=_Latin_1}');
    Error('\P{:=_Latin_1}');
    Expect(1, 255, '\p{latin1}', "");
    Expect(0, 255, '\p{^latin1}', "");
    Expect(0, 255, '\P{latin1}', "");
    Expect(1, 255, '\P{^latin1}', "");
    Expect(0, 256, '\p{latin1}', "");
    Expect(1, 256, '\p{^latin1}', "");
    Expect(1, 256, '\P{latin1}', "");
    Expect(0, 256, '\P{^latin1}', "");
    Expect(1, 255, '\p{	-Latin_1}', "");
    Expect(0, 255, '\p{^	-Latin_1}', "");
    Expect(0, 255, '\P{	-Latin_1}', "");
    Expect(1, 255, '\P{^	-Latin_1}', "");
    Expect(0, 256, '\p{	-Latin_1}', "");
    Expect(1, 256, '\p{^	-Latin_1}', "");
    Expect(1, 256, '\P{	-Latin_1}', "");
    Expect(0, 256, '\P{^	-Latin_1}', "");
    Error('\p{/a/	-is_LATIN_1}');
    Error('\P{/a/	-is_LATIN_1}');
    Expect(1, 255, '\p{islatin1}', "");
    Expect(0, 255, '\p{^islatin1}', "");
    Expect(0, 255, '\P{islatin1}', "");
    Expect(1, 255, '\P{^islatin1}', "");
    Expect(0, 256, '\p{islatin1}', "");
    Expect(1, 256, '\p{^islatin1}', "");
    Expect(1, 256, '\P{islatin1}', "");
    Expect(0, 256, '\P{^islatin1}', "");
    Expect(1, 255, '\p{		is_latin_1}', "");
    Expect(0, 255, '\p{^		is_latin_1}', "");
    Expect(0, 255, '\P{		is_latin_1}', "");
    Expect(1, 255, '\P{^		is_latin_1}', "");
    Expect(0, 256, '\p{		is_latin_1}', "");
    Expect(1, 256, '\p{^		is_latin_1}', "");
    Expect(1, 256, '\P{		is_latin_1}', "");
    Expect(0, 256, '\P{^		is_latin_1}', "");
    Error('\p{_	IN_LATIN_1/a/}');
    Error('\P{_	IN_LATIN_1/a/}');
    Expect(1, 255, '\p{inlatin1}', "");
    Expect(0, 255, '\p{^inlatin1}', "");
    Expect(0, 255, '\P{inlatin1}', "");
    Expect(1, 255, '\P{^inlatin1}', "");
    Expect(0, 256, '\p{inlatin1}', "");
    Expect(1, 256, '\p{^inlatin1}', "");
    Expect(1, 256, '\P{inlatin1}', "");
    Expect(0, 256, '\P{^inlatin1}', "");
    Expect(1, 255, '\p{__In_Latin_1}', "");
    Expect(0, 255, '\p{^__In_Latin_1}', "");
    Expect(0, 255, '\P{__In_Latin_1}', "");
    Expect(1, 255, '\P{^__In_Latin_1}', "");
    Expect(0, 256, '\p{__In_Latin_1}', "");
    Expect(1, 256, '\p{^__In_Latin_1}', "");
    Expect(1, 256, '\P{__In_Latin_1}', "");
    Expect(0, 256, '\P{^__In_Latin_1}', "");
    Error('\p{:=_	LATIN_extended_A}');
    Error('\P{:=_	LATIN_extended_A}');
    Expect(1, 383, '\p{latinextendeda}', "");
    Expect(0, 383, '\p{^latinextendeda}', "");
    Expect(0, 383, '\P{latinextendeda}', "");
    Expect(1, 383, '\P{^latinextendeda}', "");
    Expect(0, 384, '\p{latinextendeda}', "");
    Expect(1, 384, '\p{^latinextendeda}', "");
    Expect(1, 384, '\P{latinextendeda}', "");
    Expect(0, 384, '\P{^latinextendeda}', "");
    Expect(1, 383, '\p{-Latin_extended_A}', "");
    Expect(0, 383, '\p{^-Latin_extended_A}', "");
    Expect(0, 383, '\P{-Latin_extended_A}', "");
    Expect(1, 383, '\P{^-Latin_extended_A}', "");
    Expect(0, 384, '\p{-Latin_extended_A}', "");
    Expect(1, 384, '\p{^-Latin_extended_A}', "");
    Expect(1, 384, '\P{-Latin_extended_A}', "");
    Expect(0, 384, '\P{^-Latin_extended_A}', "");
    Error('\p{	/a/is_latin_EXTENDED_A}');
    Error('\P{	/a/is_latin_EXTENDED_A}');
    Expect(1, 383, '\p{islatinextendeda}', "");
    Expect(0, 383, '\p{^islatinextendeda}', "");
    Expect(0, 383, '\P{islatinextendeda}', "");
    Expect(1, 383, '\P{^islatinextendeda}', "");
    Expect(0, 384, '\p{islatinextendeda}', "");
    Expect(1, 384, '\p{^islatinextendeda}', "");
    Expect(1, 384, '\P{islatinextendeda}', "");
    Expect(0, 384, '\P{^islatinextendeda}', "");
    Expect(1, 383, '\p{		Is_Latin_extended_A}', "");
    Expect(0, 383, '\p{^		Is_Latin_extended_A}', "");
    Expect(0, 383, '\P{		Is_Latin_extended_A}', "");
    Expect(1, 383, '\P{^		Is_Latin_extended_A}', "");
    Expect(0, 384, '\p{		Is_Latin_extended_A}', "");
    Expect(1, 384, '\p{^		Is_Latin_extended_A}', "");
    Expect(1, 384, '\P{		Is_Latin_extended_A}', "");
    Expect(0, 384, '\P{^		Is_Latin_extended_A}', "");
    Error('\p{/a/	_IN_Latin_Extended_a}');
    Error('\P{/a/	_IN_Latin_Extended_a}');
    Expect(1, 383, '\p{inlatinextendeda}', "");
    Expect(0, 383, '\p{^inlatinextendeda}', "");
    Expect(0, 383, '\P{inlatinextendeda}', "");
    Expect(1, 383, '\P{^inlatinextendeda}', "");
    Expect(0, 384, '\p{inlatinextendeda}', "");
    Expect(1, 384, '\p{^inlatinextendeda}', "");
    Expect(1, 384, '\P{inlatinextendeda}', "");
    Expect(0, 384, '\P{^inlatinextendeda}', "");
    Expect(1, 383, '\p{ In_Latin_Extended_A}', "");
    Expect(0, 383, '\p{^ In_Latin_Extended_A}', "");
    Expect(0, 383, '\P{ In_Latin_Extended_A}', "");
    Expect(1, 383, '\P{^ In_Latin_Extended_A}', "");
    Expect(0, 384, '\p{ In_Latin_Extended_A}', "");
    Expect(1, 384, '\p{^ In_Latin_Extended_A}', "");
    Expect(1, 384, '\P{ In_Latin_Extended_A}', "");
    Expect(0, 384, '\P{^ In_Latin_Extended_A}', "");
    Error('\p{_-LATIN_ext_a/a/}');
    Error('\P{_-LATIN_ext_a/a/}');
    Expect(1, 383, '\p{latinexta}', "");
    Expect(0, 383, '\p{^latinexta}', "");
    Expect(0, 383, '\P{latinexta}', "");
    Expect(1, 383, '\P{^latinexta}', "");
    Expect(0, 384, '\p{latinexta}', "");
    Expect(1, 384, '\p{^latinexta}', "");
    Expect(1, 384, '\P{latinexta}', "");
    Expect(0, 384, '\P{^latinexta}', "");
    Expect(1, 383, '\p{	-Latin_Ext_A}', "");
    Expect(0, 383, '\p{^	-Latin_Ext_A}', "");
    Expect(0, 383, '\P{	-Latin_Ext_A}', "");
    Expect(1, 383, '\P{^	-Latin_Ext_A}', "");
    Expect(0, 384, '\p{	-Latin_Ext_A}', "");
    Expect(1, 384, '\p{^	-Latin_Ext_A}', "");
    Expect(1, 384, '\P{	-Latin_Ext_A}', "");
    Expect(0, 384, '\P{^	-Latin_Ext_A}', "");
    Error('\p{/a/IS_Latin_Ext_a}');
    Error('\P{/a/IS_Latin_Ext_a}');
    Expect(1, 383, '\p{islatinexta}', "");
    Expect(0, 383, '\p{^islatinexta}', "");
    Expect(0, 383, '\P{islatinexta}', "");
    Expect(1, 383, '\P{^islatinexta}', "");
    Expect(0, 384, '\p{islatinexta}', "");
    Expect(1, 384, '\p{^islatinexta}', "");
    Expect(1, 384, '\P{islatinexta}', "");
    Expect(0, 384, '\P{^islatinexta}', "");
    Expect(1, 383, '\p{	Is_latin_ext_A}', "");
    Expect(0, 383, '\p{^	Is_latin_ext_A}', "");
    Expect(0, 383, '\P{	Is_latin_ext_A}', "");
    Expect(1, 383, '\P{^	Is_latin_ext_A}', "");
    Expect(0, 384, '\p{	Is_latin_ext_A}', "");
    Expect(1, 384, '\p{^	Is_latin_ext_A}', "");
    Expect(1, 384, '\P{	Is_latin_ext_A}', "");
    Expect(0, 384, '\P{^	Is_latin_ext_A}', "");
    Error('\p{- IN_latin_Ext_A:=}');
    Error('\P{- IN_latin_Ext_A:=}');
    Expect(1, 383, '\p{inlatinexta}', "");
    Expect(0, 383, '\p{^inlatinexta}', "");
    Expect(0, 383, '\P{inlatinexta}', "");
    Expect(1, 383, '\P{^inlatinexta}', "");
    Expect(0, 384, '\p{inlatinexta}', "");
    Expect(1, 384, '\p{^inlatinexta}', "");
    Expect(1, 384, '\P{inlatinexta}', "");
    Expect(0, 384, '\P{^inlatinexta}', "");
    Expect(1, 383, '\p{ In_Latin_Ext_a}', "");
    Expect(0, 383, '\p{^ In_Latin_Ext_a}', "");
    Expect(0, 383, '\P{ In_Latin_Ext_a}', "");
    Expect(1, 383, '\P{^ In_Latin_Ext_a}', "");
    Expect(0, 384, '\p{ In_Latin_Ext_a}', "");
    Expect(1, 384, '\p{^ In_Latin_Ext_a}', "");
    Expect(1, 384, '\P{ In_Latin_Ext_a}', "");
    Expect(0, 384, '\P{^ In_Latin_Ext_a}', "");
    Error('\p{ /a/Latin_Extended_Additional}');
    Error('\P{ /a/Latin_Extended_Additional}');
    Expect(1, 7935, '\p{latinextendedadditional}', "");
    Expect(0, 7935, '\p{^latinextendedadditional}', "");
    Expect(0, 7935, '\P{latinextendedadditional}', "");
    Expect(1, 7935, '\P{^latinextendedadditional}', "");
    Expect(0, 7936, '\p{latinextendedadditional}', "");
    Expect(1, 7936, '\p{^latinextendedadditional}', "");
    Expect(1, 7936, '\P{latinextendedadditional}', "");
    Expect(0, 7936, '\P{^latinextendedadditional}', "");
    Expect(1, 7935, '\p{ -Latin_Extended_Additional}', "");
    Expect(0, 7935, '\p{^ -Latin_Extended_Additional}', "");
    Expect(0, 7935, '\P{ -Latin_Extended_Additional}', "");
    Expect(1, 7935, '\P{^ -Latin_Extended_Additional}', "");
    Expect(0, 7936, '\p{ -Latin_Extended_Additional}', "");
    Expect(1, 7936, '\p{^ -Latin_Extended_Additional}', "");
    Expect(1, 7936, '\P{ -Latin_Extended_Additional}', "");
    Expect(0, 7936, '\P{^ -Latin_Extended_Additional}', "");
    Error('\p{--Is_latin_EXTENDED_Additional/a/}');
    Error('\P{--Is_latin_EXTENDED_Additional/a/}');
    Expect(1, 7935, '\p{islatinextendedadditional}', "");
    Expect(0, 7935, '\p{^islatinextendedadditional}', "");
    Expect(0, 7935, '\P{islatinextendedadditional}', "");
    Expect(1, 7935, '\P{^islatinextendedadditional}', "");
    Expect(0, 7936, '\p{islatinextendedadditional}', "");
    Expect(1, 7936, '\p{^islatinextendedadditional}', "");
    Expect(1, 7936, '\P{islatinextendedadditional}', "");
    Expect(0, 7936, '\P{^islatinextendedadditional}', "");
    Expect(1, 7935, '\p{_-Is_Latin_Extended_ADDITIONAL}', "");
    Expect(0, 7935, '\p{^_-Is_Latin_Extended_ADDITIONAL}', "");
    Expect(0, 7935, '\P{_-Is_Latin_Extended_ADDITIONAL}', "");
    Expect(1, 7935, '\P{^_-Is_Latin_Extended_ADDITIONAL}', "");
    Expect(0, 7936, '\p{_-Is_Latin_Extended_ADDITIONAL}', "");
    Expect(1, 7936, '\p{^_-Is_Latin_Extended_ADDITIONAL}', "");
    Expect(1, 7936, '\P{_-Is_Latin_Extended_ADDITIONAL}', "");
    Expect(0, 7936, '\P{^_-Is_Latin_Extended_ADDITIONAL}', "");
    Error('\p{	_in_LATIN_Extended_additional:=}');
    Error('\P{	_in_LATIN_Extended_additional:=}');
    Expect(1, 7935, '\p{inlatinextendedadditional}', "");
    Expect(0, 7935, '\p{^inlatinextendedadditional}', "");
    Expect(0, 7935, '\P{inlatinextendedadditional}', "");
    Expect(1, 7935, '\P{^inlatinextendedadditional}', "");
    Expect(0, 7936, '\p{inlatinextendedadditional}', "");
    Expect(1, 7936, '\p{^inlatinextendedadditional}', "");
    Expect(1, 7936, '\P{inlatinextendedadditional}', "");
    Expect(0, 7936, '\P{^inlatinextendedadditional}', "");
    Expect(1, 7935, '\p{_-IN_latin_Extended_Additional}', "");
    Expect(0, 7935, '\p{^_-IN_latin_Extended_Additional}', "");
    Expect(0, 7935, '\P{_-IN_latin_Extended_Additional}', "");
    Expect(1, 7935, '\P{^_-IN_latin_Extended_Additional}', "");
    Expect(0, 7936, '\p{_-IN_latin_Extended_Additional}', "");
    Expect(1, 7936, '\p{^_-IN_latin_Extended_Additional}', "");
    Expect(1, 7936, '\P{_-IN_latin_Extended_Additional}', "");
    Expect(0, 7936, '\P{^_-IN_latin_Extended_Additional}', "");
    Error('\p{  Latin_ext_additional/a/}');
    Error('\P{  Latin_ext_additional/a/}');
    Expect(1, 7935, '\p{latinextadditional}', "");
    Expect(0, 7935, '\p{^latinextadditional}', "");
    Expect(0, 7935, '\P{latinextadditional}', "");
    Expect(1, 7935, '\P{^latinextadditional}', "");
    Expect(0, 7936, '\p{latinextadditional}', "");
    Expect(1, 7936, '\p{^latinextadditional}', "");
    Expect(1, 7936, '\P{latinextadditional}', "");
    Expect(0, 7936, '\P{^latinextadditional}', "");
    Expect(1, 7935, '\p{		LATIN_ext_Additional}', "");
    Expect(0, 7935, '\p{^		LATIN_ext_Additional}', "");
    Expect(0, 7935, '\P{		LATIN_ext_Additional}', "");
    Expect(1, 7935, '\P{^		LATIN_ext_Additional}', "");
    Expect(0, 7936, '\p{		LATIN_ext_Additional}', "");
    Expect(1, 7936, '\p{^		LATIN_ext_Additional}', "");
    Expect(1, 7936, '\P{		LATIN_ext_Additional}', "");
    Expect(0, 7936, '\P{^		LATIN_ext_Additional}', "");
    Error('\p{:=__Is_LATIN_ext_ADDITIONAL}');
    Error('\P{:=__Is_LATIN_ext_ADDITIONAL}');
    Expect(1, 7935, '\p{islatinextadditional}', "");
    Expect(0, 7935, '\p{^islatinextadditional}', "");
    Expect(0, 7935, '\P{islatinextadditional}', "");
    Expect(1, 7935, '\P{^islatinextadditional}', "");
    Expect(0, 7936, '\p{islatinextadditional}', "");
    Expect(1, 7936, '\p{^islatinextadditional}', "");
    Expect(1, 7936, '\P{islatinextadditional}', "");
    Expect(0, 7936, '\P{^islatinextadditional}', "");
    Expect(1, 7935, '\p{_	IS_Latin_Ext_ADDITIONAL}', "");
    Expect(0, 7935, '\p{^_	IS_Latin_Ext_ADDITIONAL}', "");
    Expect(0, 7935, '\P{_	IS_Latin_Ext_ADDITIONAL}', "");
    Expect(1, 7935, '\P{^_	IS_Latin_Ext_ADDITIONAL}', "");
    Expect(0, 7936, '\p{_	IS_Latin_Ext_ADDITIONAL}', "");
    Expect(1, 7936, '\p{^_	IS_Latin_Ext_ADDITIONAL}', "");
    Expect(1, 7936, '\P{_	IS_Latin_Ext_ADDITIONAL}', "");
    Expect(0, 7936, '\P{^_	IS_Latin_Ext_ADDITIONAL}', "");
    Error('\p{_/a/IN_Latin_Ext_Additional}');
    Error('\P{_/a/IN_Latin_Ext_Additional}');
    Expect(1, 7935, '\p{inlatinextadditional}', "");
    Expect(0, 7935, '\p{^inlatinextadditional}', "");
    Expect(0, 7935, '\P{inlatinextadditional}', "");
    Expect(1, 7935, '\P{^inlatinextadditional}', "");
    Expect(0, 7936, '\p{inlatinextadditional}', "");
    Expect(1, 7936, '\p{^inlatinextadditional}', "");
    Expect(1, 7936, '\P{inlatinextadditional}', "");
    Expect(0, 7936, '\P{^inlatinextadditional}', "");
    Expect(1, 7935, '\p{	-In_latin_Ext_Additional}', "");
    Expect(0, 7935, '\p{^	-In_latin_Ext_Additional}', "");
    Expect(0, 7935, '\P{	-In_latin_Ext_Additional}', "");
    Expect(1, 7935, '\P{^	-In_latin_Ext_Additional}', "");
    Expect(0, 7936, '\p{	-In_latin_Ext_Additional}', "");
    Expect(1, 7936, '\p{^	-In_latin_Ext_Additional}', "");
    Expect(1, 7936, '\P{	-In_latin_Ext_Additional}', "");
    Expect(0, 7936, '\P{^	-In_latin_Ext_Additional}', "");
    Error('\p{/a/  LATIN_extended_b}');
    Error('\P{/a/  LATIN_extended_b}');
    Expect(1, 591, '\p{latinextendedb}', "");
    Expect(0, 591, '\p{^latinextendedb}', "");
    Expect(0, 591, '\P{latinextendedb}', "");
    Expect(1, 591, '\P{^latinextendedb}', "");
    Expect(0, 592, '\p{latinextendedb}', "");
    Expect(1, 592, '\p{^latinextendedb}', "");
    Expect(1, 592, '\P{latinextendedb}', "");
    Expect(0, 592, '\P{^latinextendedb}', "");
    Expect(1, 591, '\p{	latin_EXTENDED_B}', "");
    Expect(0, 591, '\p{^	latin_EXTENDED_B}', "");
    Expect(0, 591, '\P{	latin_EXTENDED_B}', "");
    Expect(1, 591, '\P{^	latin_EXTENDED_B}', "");
    Expect(0, 592, '\p{	latin_EXTENDED_B}', "");
    Expect(1, 592, '\p{^	latin_EXTENDED_B}', "");
    Expect(1, 592, '\P{	latin_EXTENDED_B}', "");
    Expect(0, 592, '\P{^	latin_EXTENDED_B}', "");
    Error('\p{/a/-	Is_latin_extended_b}');
    Error('\P{/a/-	Is_latin_extended_b}');
    Expect(1, 591, '\p{islatinextendedb}', "");
    Expect(0, 591, '\p{^islatinextendedb}', "");
    Expect(0, 591, '\P{islatinextendedb}', "");
    Expect(1, 591, '\P{^islatinextendedb}', "");
    Expect(0, 592, '\p{islatinextendedb}', "");
    Expect(1, 592, '\p{^islatinextendedb}', "");
    Expect(1, 592, '\P{islatinextendedb}', "");
    Expect(0, 592, '\P{^islatinextendedb}', "");
    Expect(1, 591, '\p{	IS_LATIN_EXTENDED_b}', "");
    Expect(0, 591, '\p{^	IS_LATIN_EXTENDED_b}', "");
    Expect(0, 591, '\P{	IS_LATIN_EXTENDED_b}', "");
    Expect(1, 591, '\P{^	IS_LATIN_EXTENDED_b}', "");
    Expect(0, 592, '\p{	IS_LATIN_EXTENDED_b}', "");
    Expect(1, 592, '\p{^	IS_LATIN_EXTENDED_b}', "");
    Expect(1, 592, '\P{	IS_LATIN_EXTENDED_b}', "");
    Expect(0, 592, '\P{^	IS_LATIN_EXTENDED_b}', "");
    Error('\p{/a/		IN_Latin_Extended_B}');
    Error('\P{/a/		IN_Latin_Extended_B}');
    Expect(1, 591, '\p{inlatinextendedb}', "");
    Expect(0, 591, '\p{^inlatinextendedb}', "");
    Expect(0, 591, '\P{inlatinextendedb}', "");
    Expect(1, 591, '\P{^inlatinextendedb}', "");
    Expect(0, 592, '\p{inlatinextendedb}', "");
    Expect(1, 592, '\p{^inlatinextendedb}', "");
    Expect(1, 592, '\P{inlatinextendedb}', "");
    Expect(0, 592, '\P{^inlatinextendedb}', "");
    Expect(1, 591, '\p{__In_Latin_Extended_B}', "");
    Expect(0, 591, '\p{^__In_Latin_Extended_B}', "");
    Expect(0, 591, '\P{__In_Latin_Extended_B}', "");
    Expect(1, 591, '\P{^__In_Latin_Extended_B}', "");
    Expect(0, 592, '\p{__In_Latin_Extended_B}', "");
    Expect(1, 592, '\p{^__In_Latin_Extended_B}', "");
    Expect(1, 592, '\P{__In_Latin_Extended_B}', "");
    Expect(0, 592, '\P{^__In_Latin_Extended_B}', "");
    Error('\p{:=__Latin_Ext_B}');
    Error('\P{:=__Latin_Ext_B}');
    Expect(1, 591, '\p{latinextb}', "");
    Expect(0, 591, '\p{^latinextb}', "");
    Expect(0, 591, '\P{latinextb}', "");
    Expect(1, 591, '\P{^latinextb}', "");
    Expect(0, 592, '\p{latinextb}', "");
    Expect(1, 592, '\p{^latinextb}', "");
    Expect(1, 592, '\P{latinextb}', "");
    Expect(0, 592, '\P{^latinextb}', "");
    Expect(1, 591, '\p{		Latin_Ext_B}', "");
    Expect(0, 591, '\p{^		Latin_Ext_B}', "");
    Expect(0, 591, '\P{		Latin_Ext_B}', "");
    Expect(1, 591, '\P{^		Latin_Ext_B}', "");
    Expect(0, 592, '\p{		Latin_Ext_B}', "");
    Expect(1, 592, '\p{^		Latin_Ext_B}', "");
    Expect(1, 592, '\P{		Latin_Ext_B}', "");
    Expect(0, 592, '\P{^		Latin_Ext_B}', "");
    Error('\p{:=-_Is_Latin_EXT_B}');
    Error('\P{:=-_Is_Latin_EXT_B}');
    Expect(1, 591, '\p{islatinextb}', "");
    Expect(0, 591, '\p{^islatinextb}', "");
    Expect(0, 591, '\P{islatinextb}', "");
    Expect(1, 591, '\P{^islatinextb}', "");
    Expect(0, 592, '\p{islatinextb}', "");
    Expect(1, 592, '\p{^islatinextb}', "");
    Expect(1, 592, '\P{islatinextb}', "");
    Expect(0, 592, '\P{^islatinextb}', "");
    Expect(1, 591, '\p{- IS_latin_Ext_B}', "");
    Expect(0, 591, '\p{^- IS_latin_Ext_B}', "");
    Expect(0, 591, '\P{- IS_latin_Ext_B}', "");
    Expect(1, 591, '\P{^- IS_latin_Ext_B}', "");
    Expect(0, 592, '\p{- IS_latin_Ext_B}', "");
    Expect(1, 592, '\p{^- IS_latin_Ext_B}', "");
    Expect(1, 592, '\P{- IS_latin_Ext_B}', "");
    Expect(0, 592, '\P{^- IS_latin_Ext_B}', "");
    Error('\p{:=--IN_Latin_EXT_B}');
    Error('\P{:=--IN_Latin_EXT_B}');
    Expect(1, 591, '\p{inlatinextb}', "");
    Expect(0, 591, '\p{^inlatinextb}', "");
    Expect(0, 591, '\P{inlatinextb}', "");
    Expect(1, 591, '\P{^inlatinextb}', "");
    Expect(0, 592, '\p{inlatinextb}', "");
    Expect(1, 592, '\p{^inlatinextb}', "");
    Expect(1, 592, '\P{inlatinextb}', "");
    Expect(0, 592, '\P{^inlatinextb}', "");
    Expect(1, 591, '\p{_In_Latin_ext_b}', "");
    Expect(0, 591, '\p{^_In_Latin_ext_b}', "");
    Expect(0, 591, '\P{_In_Latin_ext_b}', "");
    Expect(1, 591, '\P{^_In_Latin_ext_b}', "");
    Expect(0, 592, '\p{_In_Latin_ext_b}', "");
    Expect(1, 592, '\p{^_In_Latin_ext_b}', "");
    Expect(1, 592, '\P{_In_Latin_ext_b}', "");
    Expect(0, 592, '\P{^_In_Latin_ext_b}', "");
    Error('\p{:=-Latin_Extended_C}');
    Error('\P{:=-Latin_Extended_C}');
    Expect(1, 11391, '\p{latinextendedc}', "");
    Expect(0, 11391, '\p{^latinextendedc}', "");
    Expect(0, 11391, '\P{latinextendedc}', "");
    Expect(1, 11391, '\P{^latinextendedc}', "");
    Expect(0, 11392, '\p{latinextendedc}', "");
    Expect(1, 11392, '\p{^latinextendedc}', "");
    Expect(1, 11392, '\P{latinextendedc}', "");
    Expect(0, 11392, '\P{^latinextendedc}', "");
    Expect(1, 11391, '\p{ Latin_Extended_C}', "");
    Expect(0, 11391, '\p{^ Latin_Extended_C}', "");
    Expect(0, 11391, '\P{ Latin_Extended_C}', "");
    Expect(1, 11391, '\P{^ Latin_Extended_C}', "");
    Expect(0, 11392, '\p{ Latin_Extended_C}', "");
    Expect(1, 11392, '\p{^ Latin_Extended_C}', "");
    Expect(1, 11392, '\P{ Latin_Extended_C}', "");
    Expect(0, 11392, '\P{^ Latin_Extended_C}', "");
    Error('\p{-_Is_LATIN_extended_c/a/}');
    Error('\P{-_Is_LATIN_extended_c/a/}');
    Expect(1, 11391, '\p{islatinextendedc}', "");
    Expect(0, 11391, '\p{^islatinextendedc}', "");
    Expect(0, 11391, '\P{islatinextendedc}', "");
    Expect(1, 11391, '\P{^islatinextendedc}', "");
    Expect(0, 11392, '\p{islatinextendedc}', "");
    Expect(1, 11392, '\p{^islatinextendedc}', "");
    Expect(1, 11392, '\P{islatinextendedc}', "");
    Expect(0, 11392, '\P{^islatinextendedc}', "");
    Expect(1, 11391, '\p{__is_latin_Extended_c}', "");
    Expect(0, 11391, '\p{^__is_latin_Extended_c}', "");
    Expect(0, 11391, '\P{__is_latin_Extended_c}', "");
    Expect(1, 11391, '\P{^__is_latin_Extended_c}', "");
    Expect(0, 11392, '\p{__is_latin_Extended_c}', "");
    Expect(1, 11392, '\p{^__is_latin_Extended_c}', "");
    Expect(1, 11392, '\P{__is_latin_Extended_c}', "");
    Expect(0, 11392, '\P{^__is_latin_Extended_c}', "");
    Error('\p{ /a/In_Latin_Extended_c}');
    Error('\P{ /a/In_Latin_Extended_c}');
    Expect(1, 11391, '\p{inlatinextendedc}', "");
    Expect(0, 11391, '\p{^inlatinextendedc}', "");
    Expect(0, 11391, '\P{inlatinextendedc}', "");
    Expect(1, 11391, '\P{^inlatinextendedc}', "");
    Expect(0, 11392, '\p{inlatinextendedc}', "");
    Expect(1, 11392, '\p{^inlatinextendedc}', "");
    Expect(1, 11392, '\P{inlatinextendedc}', "");
    Expect(0, 11392, '\P{^inlatinextendedc}', "");
    Expect(1, 11391, '\p{	-In_latin_Extended_c}', "");
    Expect(0, 11391, '\p{^	-In_latin_Extended_c}', "");
    Expect(0, 11391, '\P{	-In_latin_Extended_c}', "");
    Expect(1, 11391, '\P{^	-In_latin_Extended_c}', "");
    Expect(0, 11392, '\p{	-In_latin_Extended_c}', "");
    Expect(1, 11392, '\p{^	-In_latin_Extended_c}', "");
    Expect(1, 11392, '\P{	-In_latin_Extended_c}', "");
    Expect(0, 11392, '\P{^	-In_latin_Extended_c}', "");
    Error('\p{/a/	_Latin_EXT_C}');
    Error('\P{/a/	_Latin_EXT_C}');
    Expect(1, 11391, '\p{latinextc}', "");
    Expect(0, 11391, '\p{^latinextc}', "");
    Expect(0, 11391, '\P{latinextc}', "");
    Expect(1, 11391, '\P{^latinextc}', "");
    Expect(0, 11392, '\p{latinextc}', "");
    Expect(1, 11392, '\p{^latinextc}', "");
    Expect(1, 11392, '\P{latinextc}', "");
    Expect(0, 11392, '\P{^latinextc}', "");
    Expect(1, 11391, '\p{ _LATIN_EXT_c}', "");
    Expect(0, 11391, '\p{^ _LATIN_EXT_c}', "");
    Expect(0, 11391, '\P{ _LATIN_EXT_c}', "");
    Expect(1, 11391, '\P{^ _LATIN_EXT_c}', "");
    Expect(0, 11392, '\p{ _LATIN_EXT_c}', "");
    Expect(1, 11392, '\p{^ _LATIN_EXT_c}', "");
    Expect(1, 11392, '\P{ _LATIN_EXT_c}', "");
    Expect(0, 11392, '\P{^ _LATIN_EXT_c}', "");
    Error('\p{ /a/IS_Latin_EXT_C}');
    Error('\P{ /a/IS_Latin_EXT_C}');
    Expect(1, 11391, '\p{islatinextc}', "");
    Expect(0, 11391, '\p{^islatinextc}', "");
    Expect(0, 11391, '\P{islatinextc}', "");
    Expect(1, 11391, '\P{^islatinextc}', "");
    Expect(0, 11392, '\p{islatinextc}', "");
    Expect(1, 11392, '\p{^islatinextc}', "");
    Expect(1, 11392, '\P{islatinextc}', "");
    Expect(0, 11392, '\P{^islatinextc}', "");
    Expect(1, 11391, '\p{ _IS_Latin_ext_c}', "");
    Expect(0, 11391, '\p{^ _IS_Latin_ext_c}', "");
    Expect(0, 11391, '\P{ _IS_Latin_ext_c}', "");
    Expect(1, 11391, '\P{^ _IS_Latin_ext_c}', "");
    Expect(0, 11392, '\p{ _IS_Latin_ext_c}', "");
    Expect(1, 11392, '\p{^ _IS_Latin_ext_c}', "");
    Expect(1, 11392, '\P{ _IS_Latin_ext_c}', "");
    Expect(0, 11392, '\P{^ _IS_Latin_ext_c}', "");
    Error('\p{-_IN_LATIN_Ext_C/a/}');
    Error('\P{-_IN_LATIN_Ext_C/a/}');
    Expect(1, 11391, '\p{inlatinextc}', "");
    Expect(0, 11391, '\p{^inlatinextc}', "");
    Expect(0, 11391, '\P{inlatinextc}', "");
    Expect(1, 11391, '\P{^inlatinextc}', "");
    Expect(0, 11392, '\p{inlatinextc}', "");
    Expect(1, 11392, '\p{^inlatinextc}', "");
    Expect(1, 11392, '\P{inlatinextc}', "");
    Expect(0, 11392, '\P{^inlatinextc}', "");
    Expect(1, 11391, '\p{  in_latin_Ext_C}', "");
    Expect(0, 11391, '\p{^  in_latin_Ext_C}', "");
    Expect(0, 11391, '\P{  in_latin_Ext_C}', "");
    Expect(1, 11391, '\P{^  in_latin_Ext_C}', "");
    Expect(0, 11392, '\p{  in_latin_Ext_C}', "");
    Expect(1, 11392, '\p{^  in_latin_Ext_C}', "");
    Expect(1, 11392, '\P{  in_latin_Ext_C}', "");
    Expect(0, 11392, '\P{^  in_latin_Ext_C}', "");
    Error('\p{_ latin_extended_d/a/}');
    Error('\P{_ latin_extended_d/a/}');
    Expect(1, 43007, '\p{latinextendedd}', "");
    Expect(0, 43007, '\p{^latinextendedd}', "");
    Expect(0, 43007, '\P{latinextendedd}', "");
    Expect(1, 43007, '\P{^latinextendedd}', "");
    Expect(0, 43008, '\p{latinextendedd}', "");
    Expect(1, 43008, '\p{^latinextendedd}', "");
    Expect(1, 43008, '\P{latinextendedd}', "");
    Expect(0, 43008, '\P{^latinextendedd}', "");
    Expect(1, 43007, '\p{ -LATIN_extended_D}', "");
    Expect(0, 43007, '\p{^ -LATIN_extended_D}', "");
    Expect(0, 43007, '\P{ -LATIN_extended_D}', "");
    Expect(1, 43007, '\P{^ -LATIN_extended_D}', "");
    Expect(0, 43008, '\p{ -LATIN_extended_D}', "");
    Expect(1, 43008, '\p{^ -LATIN_extended_D}', "");
    Expect(1, 43008, '\P{ -LATIN_extended_D}', "");
    Expect(0, 43008, '\P{^ -LATIN_extended_D}', "");
    Error('\p{	:=IS_latin_EXTENDED_D}');
    Error('\P{	:=IS_latin_EXTENDED_D}');
    Expect(1, 43007, '\p{islatinextendedd}', "");
    Expect(0, 43007, '\p{^islatinextendedd}', "");
    Expect(0, 43007, '\P{islatinextendedd}', "");
    Expect(1, 43007, '\P{^islatinextendedd}', "");
    Expect(0, 43008, '\p{islatinextendedd}', "");
    Expect(1, 43008, '\p{^islatinextendedd}', "");
    Expect(1, 43008, '\P{islatinextendedd}', "");
    Expect(0, 43008, '\P{^islatinextendedd}', "");
    Expect(1, 43007, '\p{ _Is_Latin_Extended_D}', "");
    Expect(0, 43007, '\p{^ _Is_Latin_Extended_D}', "");
    Expect(0, 43007, '\P{ _Is_Latin_Extended_D}', "");
    Expect(1, 43007, '\P{^ _Is_Latin_Extended_D}', "");
    Expect(0, 43008, '\p{ _Is_Latin_Extended_D}', "");
    Expect(1, 43008, '\p{^ _Is_Latin_Extended_D}', "");
    Expect(1, 43008, '\P{ _Is_Latin_Extended_D}', "");
    Expect(0, 43008, '\P{^ _Is_Latin_Extended_D}', "");
    Error('\p{-_IN_latin_extended_d/a/}');
    Error('\P{-_IN_latin_extended_d/a/}');
    Expect(1, 43007, '\p{inlatinextendedd}', "");
    Expect(0, 43007, '\p{^inlatinextendedd}', "");
    Expect(0, 43007, '\P{inlatinextendedd}', "");
    Expect(1, 43007, '\P{^inlatinextendedd}', "");
    Expect(0, 43008, '\p{inlatinextendedd}', "");
    Expect(1, 43008, '\p{^inlatinextendedd}', "");
    Expect(1, 43008, '\P{inlatinextendedd}', "");
    Expect(0, 43008, '\P{^inlatinextendedd}', "");
    Expect(1, 43007, '\p{ In_Latin_extended_D}', "");
    Expect(0, 43007, '\p{^ In_Latin_extended_D}', "");
    Expect(0, 43007, '\P{ In_Latin_extended_D}', "");
    Expect(1, 43007, '\P{^ In_Latin_extended_D}', "");
    Expect(0, 43008, '\p{ In_Latin_extended_D}', "");
    Expect(1, 43008, '\p{^ In_Latin_extended_D}', "");
    Expect(1, 43008, '\P{ In_Latin_extended_D}', "");
    Expect(0, 43008, '\P{^ In_Latin_extended_D}', "");
    Error('\p{:=	LATIN_EXT_D}');
    Error('\P{:=	LATIN_EXT_D}');
    Expect(1, 43007, '\p{latinextd}', "");
    Expect(0, 43007, '\p{^latinextd}', "");
    Expect(0, 43007, '\P{latinextd}', "");
    Expect(1, 43007, '\P{^latinextd}', "");
    Expect(0, 43008, '\p{latinextd}', "");
    Expect(1, 43008, '\p{^latinextd}', "");
    Expect(1, 43008, '\P{latinextd}', "");
    Expect(0, 43008, '\P{^latinextd}', "");
    Expect(1, 43007, '\p{ 	Latin_EXT_D}', "");
    Expect(0, 43007, '\p{^ 	Latin_EXT_D}', "");
    Expect(0, 43007, '\P{ 	Latin_EXT_D}', "");
    Expect(1, 43007, '\P{^ 	Latin_EXT_D}', "");
    Expect(0, 43008, '\p{ 	Latin_EXT_D}', "");
    Expect(1, 43008, '\p{^ 	Latin_EXT_D}', "");
    Expect(1, 43008, '\P{ 	Latin_EXT_D}', "");
    Expect(0, 43008, '\P{^ 	Latin_EXT_D}', "");
    Error('\p{-_is_latin_Ext_D:=}');
    Error('\P{-_is_latin_Ext_D:=}');
    Expect(1, 43007, '\p{islatinextd}', "");
    Expect(0, 43007, '\p{^islatinextd}', "");
    Expect(0, 43007, '\P{islatinextd}', "");
    Expect(1, 43007, '\P{^islatinextd}', "");
    Expect(0, 43008, '\p{islatinextd}', "");
    Expect(1, 43008, '\p{^islatinextd}', "");
    Expect(1, 43008, '\P{islatinextd}', "");
    Expect(0, 43008, '\P{^islatinextd}', "");
    Expect(1, 43007, '\p{ 	Is_latin_Ext_D}', "");
    Expect(0, 43007, '\p{^ 	Is_latin_Ext_D}', "");
    Expect(0, 43007, '\P{ 	Is_latin_Ext_D}', "");
    Expect(1, 43007, '\P{^ 	Is_latin_Ext_D}', "");
    Expect(0, 43008, '\p{ 	Is_latin_Ext_D}', "");
    Expect(1, 43008, '\p{^ 	Is_latin_Ext_D}', "");
    Expect(1, 43008, '\P{ 	Is_latin_Ext_D}', "");
    Expect(0, 43008, '\P{^ 	Is_latin_Ext_D}', "");
    Error('\p{	/a/In_LATIN_Ext_D}');
    Error('\P{	/a/In_LATIN_Ext_D}');
    Expect(1, 43007, '\p{inlatinextd}', "");
    Expect(0, 43007, '\p{^inlatinextd}', "");
    Expect(0, 43007, '\P{inlatinextd}', "");
    Expect(1, 43007, '\P{^inlatinextd}', "");
    Expect(0, 43008, '\p{inlatinextd}', "");
    Expect(1, 43008, '\p{^inlatinextd}', "");
    Expect(1, 43008, '\P{inlatinextd}', "");
    Expect(0, 43008, '\P{^inlatinextd}', "");
    Expect(1, 43007, '\p{_in_latin_EXT_D}', "");
    Expect(0, 43007, '\p{^_in_latin_EXT_D}', "");
    Expect(0, 43007, '\P{_in_latin_EXT_D}', "");
    Expect(1, 43007, '\P{^_in_latin_EXT_D}', "");
    Expect(0, 43008, '\p{_in_latin_EXT_D}', "");
    Expect(1, 43008, '\p{^_in_latin_EXT_D}', "");
    Expect(1, 43008, '\P{_in_latin_EXT_D}', "");
    Expect(0, 43008, '\P{^_in_latin_EXT_D}', "");
    Error('\p{_-Latin_Extended_E/a/}');
    Error('\P{_-Latin_Extended_E/a/}');
    Expect(1, 43887, '\p{latinextendede}', "");
    Expect(0, 43887, '\p{^latinextendede}', "");
    Expect(0, 43887, '\P{latinextendede}', "");
    Expect(1, 43887, '\P{^latinextendede}', "");
    Expect(0, 43888, '\p{latinextendede}', "");
    Expect(1, 43888, '\p{^latinextendede}', "");
    Expect(1, 43888, '\P{latinextendede}', "");
    Expect(0, 43888, '\P{^latinextendede}', "");
    Expect(1, 43887, '\p{	-LATIN_EXTENDED_E}', "");
    Expect(0, 43887, '\p{^	-LATIN_EXTENDED_E}', "");
    Expect(0, 43887, '\P{	-LATIN_EXTENDED_E}', "");
    Expect(1, 43887, '\P{^	-LATIN_EXTENDED_E}', "");
    Expect(0, 43888, '\p{	-LATIN_EXTENDED_E}', "");
    Expect(1, 43888, '\p{^	-LATIN_EXTENDED_E}', "");
    Expect(1, 43888, '\P{	-LATIN_EXTENDED_E}', "");
    Expect(0, 43888, '\P{^	-LATIN_EXTENDED_E}', "");
    Error('\p{:=  Is_LATIN_extended_e}');
    Error('\P{:=  Is_LATIN_extended_e}');
    Expect(1, 43887, '\p{islatinextendede}', "");
    Expect(0, 43887, '\p{^islatinextendede}', "");
    Expect(0, 43887, '\P{islatinextendede}', "");
    Expect(1, 43887, '\P{^islatinextendede}', "");
    Expect(0, 43888, '\p{islatinextendede}', "");
    Expect(1, 43888, '\p{^islatinextendede}', "");
    Expect(1, 43888, '\P{islatinextendede}', "");
    Expect(0, 43888, '\P{^islatinextendede}', "");
    Expect(1, 43887, '\p{	Is_LATIN_Extended_E}', "");
    Expect(0, 43887, '\p{^	Is_LATIN_Extended_E}', "");
    Expect(0, 43887, '\P{	Is_LATIN_Extended_E}', "");
    Expect(1, 43887, '\P{^	Is_LATIN_Extended_E}', "");
    Expect(0, 43888, '\p{	Is_LATIN_Extended_E}', "");
    Expect(1, 43888, '\p{^	Is_LATIN_Extended_E}', "");
    Expect(1, 43888, '\P{	Is_LATIN_Extended_E}', "");
    Expect(0, 43888, '\P{^	Is_LATIN_Extended_E}', "");
    Error('\p{/a/-_IN_latin_EXTENDED_E}');
    Error('\P{/a/-_IN_latin_EXTENDED_E}');
    Expect(1, 43887, '\p{inlatinextendede}', "");
    Expect(0, 43887, '\p{^inlatinextendede}', "");
    Expect(0, 43887, '\P{inlatinextendede}', "");
    Expect(1, 43887, '\P{^inlatinextendede}', "");
    Expect(0, 43888, '\p{inlatinextendede}', "");
    Expect(1, 43888, '\p{^inlatinextendede}', "");
    Expect(1, 43888, '\P{inlatinextendede}', "");
    Expect(0, 43888, '\P{^inlatinextendede}', "");
    Expect(1, 43887, '\p{ -In_Latin_EXTENDED_e}', "");
    Expect(0, 43887, '\p{^ -In_Latin_EXTENDED_e}', "");
    Expect(0, 43887, '\P{ -In_Latin_EXTENDED_e}', "");
    Expect(1, 43887, '\P{^ -In_Latin_EXTENDED_e}', "");
    Expect(0, 43888, '\p{ -In_Latin_EXTENDED_e}', "");
    Expect(1, 43888, '\p{^ -In_Latin_EXTENDED_e}', "");
    Expect(1, 43888, '\P{ -In_Latin_EXTENDED_e}', "");
    Expect(0, 43888, '\P{^ -In_Latin_EXTENDED_e}', "");
    Error('\p{:=_-latin_EXT_e}');
    Error('\P{:=_-latin_EXT_e}');
    Expect(1, 43887, '\p{latinexte}', "");
    Expect(0, 43887, '\p{^latinexte}', "");
    Expect(0, 43887, '\P{latinexte}', "");
    Expect(1, 43887, '\P{^latinexte}', "");
    Expect(0, 43888, '\p{latinexte}', "");
    Expect(1, 43888, '\p{^latinexte}', "");
    Expect(1, 43888, '\P{latinexte}', "");
    Expect(0, 43888, '\P{^latinexte}', "");
    Expect(1, 43887, '\p{_	Latin_Ext_E}', "");
    Expect(0, 43887, '\p{^_	Latin_Ext_E}', "");
    Expect(0, 43887, '\P{_	Latin_Ext_E}', "");
    Expect(1, 43887, '\P{^_	Latin_Ext_E}', "");
    Expect(0, 43888, '\p{_	Latin_Ext_E}', "");
    Expect(1, 43888, '\p{^_	Latin_Ext_E}', "");
    Expect(1, 43888, '\P{_	Latin_Ext_E}', "");
    Expect(0, 43888, '\P{^_	Latin_Ext_E}', "");
    Error('\p{:=IS_Latin_EXT_E}');
    Error('\P{:=IS_Latin_EXT_E}');
    Expect(1, 43887, '\p{islatinexte}', "");
    Expect(0, 43887, '\p{^islatinexte}', "");
    Expect(0, 43887, '\P{islatinexte}', "");
    Expect(1, 43887, '\P{^islatinexte}', "");
    Expect(0, 43888, '\p{islatinexte}', "");
    Expect(1, 43888, '\p{^islatinexte}', "");
    Expect(1, 43888, '\P{islatinexte}', "");
    Expect(0, 43888, '\P{^islatinexte}', "");
    Expect(1, 43887, '\p{		Is_LATIN_Ext_E}', "");
    Expect(0, 43887, '\p{^		Is_LATIN_Ext_E}', "");
    Expect(0, 43887, '\P{		Is_LATIN_Ext_E}', "");
    Expect(1, 43887, '\P{^		Is_LATIN_Ext_E}', "");
    Expect(0, 43888, '\p{		Is_LATIN_Ext_E}', "");
    Expect(1, 43888, '\p{^		Is_LATIN_Ext_E}', "");
    Expect(1, 43888, '\P{		Is_LATIN_Ext_E}', "");
    Expect(0, 43888, '\P{^		Is_LATIN_Ext_E}', "");
    Error('\p{/a/-IN_Latin_Ext_E}');
    Error('\P{/a/-IN_Latin_Ext_E}');
    Expect(1, 43887, '\p{inlatinexte}', "");
    Expect(0, 43887, '\p{^inlatinexte}', "");
    Expect(0, 43887, '\P{inlatinexte}', "");
    Expect(1, 43887, '\P{^inlatinexte}', "");
    Expect(0, 43888, '\p{inlatinexte}', "");
    Expect(1, 43888, '\p{^inlatinexte}', "");
    Expect(1, 43888, '\P{inlatinexte}', "");
    Expect(0, 43888, '\P{^inlatinexte}', "");
    Expect(1, 43887, '\p{-in_Latin_EXT_e}', "");
    Expect(0, 43887, '\p{^-in_Latin_EXT_e}', "");
    Expect(0, 43887, '\P{-in_Latin_EXT_e}', "");
    Expect(1, 43887, '\P{^-in_Latin_EXT_e}', "");
    Expect(0, 43888, '\p{-in_Latin_EXT_e}', "");
    Expect(1, 43888, '\p{^-in_Latin_EXT_e}', "");
    Expect(1, 43888, '\P{-in_Latin_EXT_e}', "");
    Expect(0, 43888, '\P{^-in_Latin_EXT_e}', "");
    Error('\p{	/a/Lepcha}');
    Error('\P{	/a/Lepcha}');
    Expect(1, 7247, '\p{lepcha}', "");
    Expect(0, 7247, '\p{^lepcha}', "");
    Expect(0, 7247, '\P{lepcha}', "");
    Expect(1, 7247, '\P{^lepcha}', "");
    Expect(0, 7248, '\p{lepcha}', "");
    Expect(1, 7248, '\p{^lepcha}', "");
    Expect(1, 7248, '\P{lepcha}', "");
    Expect(0, 7248, '\P{^lepcha}', "");
    Expect(1, 7247, '\p{_-LEPCHA}', "");
    Expect(0, 7247, '\p{^_-LEPCHA}', "");
    Expect(0, 7247, '\P{_-LEPCHA}', "");
    Expect(1, 7247, '\P{^_-LEPCHA}', "");
    Expect(0, 7248, '\p{_-LEPCHA}', "");
    Expect(1, 7248, '\p{^_-LEPCHA}', "");
    Expect(1, 7248, '\P{_-LEPCHA}', "");
    Expect(0, 7248, '\P{^_-LEPCHA}', "");
    Error('\p{-/a/Is_Lepcha}');
    Error('\P{-/a/Is_Lepcha}');
    Expect(1, 7247, '\p{islepcha}', "");
    Expect(0, 7247, '\p{^islepcha}', "");
    Expect(0, 7247, '\P{islepcha}', "");
    Expect(1, 7247, '\P{^islepcha}', "");
    Expect(0, 7248, '\p{islepcha}', "");
    Expect(1, 7248, '\p{^islepcha}', "");
    Expect(1, 7248, '\P{islepcha}', "");
    Expect(0, 7248, '\P{^islepcha}', "");
    Expect(1, 7247, '\p{_IS_Lepcha}', "");
    Expect(0, 7247, '\p{^_IS_Lepcha}', "");
    Expect(0, 7247, '\P{_IS_Lepcha}', "");
    Expect(1, 7247, '\P{^_IS_Lepcha}', "");
    Expect(0, 7248, '\p{_IS_Lepcha}', "");
    Expect(1, 7248, '\p{^_IS_Lepcha}', "");
    Expect(1, 7248, '\P{_IS_Lepcha}', "");
    Expect(0, 7248, '\P{^_IS_Lepcha}', "");
    Error('\p{  Lepc:=}');
    Error('\P{  Lepc:=}');
    Expect(1, 7247, '\p{lepc}', "");
    Expect(0, 7247, '\p{^lepc}', "");
    Expect(0, 7247, '\P{lepc}', "");
    Expect(1, 7247, '\P{^lepc}', "");
    Expect(0, 7248, '\p{lepc}', "");
    Expect(1, 7248, '\p{^lepc}', "");
    Expect(1, 7248, '\P{lepc}', "");
    Expect(0, 7248, '\P{^lepc}', "");
    Expect(1, 7247, '\p{	 Lepc}', "");
    Expect(0, 7247, '\p{^	 Lepc}', "");
    Expect(0, 7247, '\P{	 Lepc}', "");
    Expect(1, 7247, '\P{^	 Lepc}', "");
    Expect(0, 7248, '\p{	 Lepc}', "");
    Expect(1, 7248, '\p{^	 Lepc}', "");
    Expect(1, 7248, '\P{	 Lepc}', "");
    Expect(0, 7248, '\P{^	 Lepc}', "");
    Error('\p{_:=Is_LEPC}');
    Error('\P{_:=Is_LEPC}');
    Expect(1, 7247, '\p{islepc}', "");
    Expect(0, 7247, '\p{^islepc}', "");
    Expect(0, 7247, '\P{islepc}', "");
    Expect(1, 7247, '\P{^islepc}', "");
    Expect(0, 7248, '\p{islepc}', "");
    Expect(1, 7248, '\p{^islepc}', "");
    Expect(1, 7248, '\P{islepc}', "");
    Expect(0, 7248, '\P{^islepc}', "");
    Expect(1, 7247, '\p{	Is_Lepc}', "");
    Expect(0, 7247, '\p{^	Is_Lepc}', "");
    Expect(0, 7247, '\P{	Is_Lepc}', "");
    Expect(1, 7247, '\P{^	Is_Lepc}', "");
    Expect(0, 7248, '\p{	Is_Lepc}', "");
    Expect(1, 7248, '\p{^	Is_Lepc}', "");
    Expect(1, 7248, '\P{	Is_Lepc}', "");
    Expect(0, 7248, '\P{^	Is_Lepc}', "");
    Error('\p{	 letter/a/}');
    Error('\P{	 letter/a/}');
    Expect(1, 195101, '\p{letter}', "");
    Expect(0, 195101, '\p{^letter}', "");
    Expect(0, 195101, '\P{letter}', "");
    Expect(1, 195101, '\P{^letter}', "");
    Expect(0, 195102, '\p{letter}', "");
    Expect(1, 195102, '\p{^letter}', "");
    Expect(1, 195102, '\P{letter}', "");
    Expect(0, 195102, '\P{^letter}', "");
    Expect(1, 195101, '\p{ 	Letter}', "");
    Expect(0, 195101, '\p{^ 	Letter}', "");
    Expect(0, 195101, '\P{ 	Letter}', "");
    Expect(1, 195101, '\P{^ 	Letter}', "");
    Expect(0, 195102, '\p{ 	Letter}', "");
    Expect(1, 195102, '\p{^ 	Letter}', "");
    Expect(1, 195102, '\P{ 	Letter}', "");
    Expect(0, 195102, '\P{^ 	Letter}', "");
    Error('\p{  is_letter/a/}');
    Error('\P{  is_letter/a/}');
    Expect(1, 195101, '\p{isletter}', "");
    Expect(0, 195101, '\p{^isletter}', "");
    Expect(0, 195101, '\P{isletter}', "");
    Expect(1, 195101, '\P{^isletter}', "");
    Expect(0, 195102, '\p{isletter}', "");
    Expect(1, 195102, '\p{^isletter}', "");
    Expect(1, 195102, '\P{isletter}', "");
    Expect(0, 195102, '\P{^isletter}', "");
    Expect(1, 195101, '\p{_IS_letter}', "");
    Expect(0, 195101, '\p{^_IS_letter}', "");
    Expect(0, 195101, '\P{_IS_letter}', "");
    Expect(1, 195101, '\P{^_IS_letter}', "");
    Expect(0, 195102, '\p{_IS_letter}', "");
    Expect(1, 195102, '\p{^_IS_letter}', "");
    Expect(1, 195102, '\P{_IS_letter}', "");
    Expect(0, 195102, '\P{^_IS_letter}', "");
    Error('\p{:= L}');
    Error('\P{:= L}');
    Expect(1, 195101, '\p{l}', "");
    Expect(0, 195101, '\p{^l}', "");
    Expect(0, 195101, '\P{l}', "");
    Expect(1, 195101, '\P{^l}', "");
    Expect(0, 195102, '\p{l}', "");
    Expect(1, 195102, '\p{^l}', "");
    Expect(1, 195102, '\P{l}', "");
    Expect(0, 195102, '\P{^l}', "");
    Expect(1, 195101, '\p{ _L}', "");
    Expect(0, 195101, '\p{^ _L}', "");
    Expect(0, 195101, '\P{ _L}', "");
    Expect(1, 195101, '\P{^ _L}', "");
    Expect(0, 195102, '\p{ _L}', "");
    Expect(1, 195102, '\p{^ _L}', "");
    Expect(1, 195102, '\P{ _L}', "");
    Expect(0, 195102, '\P{^ _L}', "");
    Error('\p{	/a/IS_L}');
    Error('\P{	/a/IS_L}');
    Expect(1, 195101, '\p{isl}', "");
    Expect(0, 195101, '\p{^isl}', "");
    Expect(0, 195101, '\P{isl}', "");
    Expect(1, 195101, '\P{^isl}', "");
    Expect(0, 195102, '\p{isl}', "");
    Expect(1, 195102, '\p{^isl}', "");
    Expect(1, 195102, '\P{isl}', "");
    Expect(0, 195102, '\P{^isl}', "");
    Expect(1, 195101, '\p{  is_L}', "");
    Expect(0, 195101, '\p{^  is_L}', "");
    Expect(0, 195101, '\P{  is_L}', "");
    Expect(1, 195101, '\P{^  is_L}', "");
    Expect(0, 195102, '\p{  is_L}', "");
    Expect(1, 195102, '\p{^  is_L}', "");
    Expect(1, 195102, '\P{  is_L}', "");
    Expect(0, 195102, '\P{^  is_L}', "");
    Error('\p{:=_-Letter_number}');
    Error('\P{:=_-Letter_number}');
    Expect(1, 74862, '\p{letternumber}', "");
    Expect(0, 74862, '\p{^letternumber}', "");
    Expect(0, 74862, '\P{letternumber}', "");
    Expect(1, 74862, '\P{^letternumber}', "");
    Expect(0, 74863, '\p{letternumber}', "");
    Expect(1, 74863, '\p{^letternumber}', "");
    Expect(1, 74863, '\P{letternumber}', "");
    Expect(0, 74863, '\P{^letternumber}', "");
    Expect(1, 74862, '\p{_ Letter_Number}', "");
    Expect(0, 74862, '\p{^_ Letter_Number}', "");
    Expect(0, 74862, '\P{_ Letter_Number}', "");
    Expect(1, 74862, '\P{^_ Letter_Number}', "");
    Expect(0, 74863, '\p{_ Letter_Number}', "");
    Expect(1, 74863, '\p{^_ Letter_Number}', "");
    Expect(1, 74863, '\P{_ Letter_Number}', "");
    Expect(0, 74863, '\P{^_ Letter_Number}', "");
    Error('\p{--IS_letter_Number/a/}');
    Error('\P{--IS_letter_Number/a/}');
    Expect(1, 74862, '\p{isletternumber}', "");
    Expect(0, 74862, '\p{^isletternumber}', "");
    Expect(0, 74862, '\P{isletternumber}', "");
    Expect(1, 74862, '\P{^isletternumber}', "");
    Expect(0, 74863, '\p{isletternumber}', "");
    Expect(1, 74863, '\p{^isletternumber}', "");
    Expect(1, 74863, '\P{isletternumber}', "");
    Expect(0, 74863, '\P{^isletternumber}', "");
    Expect(1, 74862, '\p{- Is_letter_NUMBER}', "");
    Expect(0, 74862, '\p{^- Is_letter_NUMBER}', "");
    Expect(0, 74862, '\P{- Is_letter_NUMBER}', "");
    Expect(1, 74862, '\P{^- Is_letter_NUMBER}', "");
    Expect(0, 74863, '\p{- Is_letter_NUMBER}', "");
    Expect(1, 74863, '\p{^- Is_letter_NUMBER}', "");
    Expect(1, 74863, '\P{- Is_letter_NUMBER}', "");
    Expect(0, 74863, '\P{^- Is_letter_NUMBER}', "");
    Error('\p{_NL:=}');
    Error('\P{_NL:=}');
    Expect(1, 74862, '\p{nl}', "");
    Expect(0, 74862, '\p{^nl}', "");
    Expect(0, 74862, '\P{nl}', "");
    Expect(1, 74862, '\P{^nl}', "");
    Expect(0, 74863, '\p{nl}', "");
    Expect(1, 74863, '\p{^nl}', "");
    Expect(1, 74863, '\P{nl}', "");
    Expect(0, 74863, '\P{^nl}', "");
    Expect(1, 74862, '\p{_	Nl}', "");
    Expect(0, 74862, '\p{^_	Nl}', "");
    Expect(0, 74862, '\P{_	Nl}', "");
    Expect(1, 74862, '\P{^_	Nl}', "");
    Expect(0, 74863, '\p{_	Nl}', "");
    Expect(1, 74863, '\p{^_	Nl}', "");
    Expect(1, 74863, '\P{_	Nl}', "");
    Expect(0, 74863, '\P{^_	Nl}', "");
    Error('\p{ Is_Nl:=}');
    Error('\P{ Is_Nl:=}');
    Expect(1, 74862, '\p{isnl}', "");
    Expect(0, 74862, '\p{^isnl}', "");
    Expect(0, 74862, '\P{isnl}', "");
    Expect(1, 74862, '\P{^isnl}', "");
    Expect(0, 74863, '\p{isnl}', "");
    Expect(1, 74863, '\p{^isnl}', "");
    Expect(1, 74863, '\P{isnl}', "");
    Expect(0, 74863, '\P{^isnl}', "");
    Expect(1, 74862, '\p{ IS_nl}', "");
    Expect(0, 74862, '\p{^ IS_nl}', "");
    Expect(0, 74862, '\P{ IS_nl}', "");
    Expect(1, 74862, '\P{^ IS_nl}', "");
    Expect(0, 74863, '\p{ IS_nl}', "");
    Expect(1, 74863, '\p{^ IS_nl}', "");
    Expect(1, 74863, '\P{ IS_nl}', "");
    Expect(0, 74863, '\P{^ IS_nl}', "");
    Error('\p{ Letterlike_SYMBOLS/a/}');
    Error('\P{ Letterlike_SYMBOLS/a/}');
    Expect(1, 8527, '\p{letterlikesymbols}', "");
    Expect(0, 8527, '\p{^letterlikesymbols}', "");
    Expect(0, 8527, '\P{letterlikesymbols}', "");
    Expect(1, 8527, '\P{^letterlikesymbols}', "");
    Expect(0, 8528, '\p{letterlikesymbols}', "");
    Expect(1, 8528, '\p{^letterlikesymbols}', "");
    Expect(1, 8528, '\P{letterlikesymbols}', "");
    Expect(0, 8528, '\P{^letterlikesymbols}', "");
    Expect(1, 8527, '\p{- Letterlike_Symbols}', "");
    Expect(0, 8527, '\p{^- Letterlike_Symbols}', "");
    Expect(0, 8527, '\P{- Letterlike_Symbols}', "");
    Expect(1, 8527, '\P{^- Letterlike_Symbols}', "");
    Expect(0, 8528, '\p{- Letterlike_Symbols}', "");
    Expect(1, 8528, '\p{^- Letterlike_Symbols}', "");
    Expect(1, 8528, '\P{- Letterlike_Symbols}', "");
    Expect(0, 8528, '\P{^- Letterlike_Symbols}', "");
    Error('\p{- Is_Letterlike_Symbols/a/}');
    Error('\P{- Is_Letterlike_Symbols/a/}');
    Expect(1, 8527, '\p{isletterlikesymbols}', "");
    Expect(0, 8527, '\p{^isletterlikesymbols}', "");
    Expect(0, 8527, '\P{isletterlikesymbols}', "");
    Expect(1, 8527, '\P{^isletterlikesymbols}', "");
    Expect(0, 8528, '\p{isletterlikesymbols}', "");
    Expect(1, 8528, '\p{^isletterlikesymbols}', "");
    Expect(1, 8528, '\P{isletterlikesymbols}', "");
    Expect(0, 8528, '\P{^isletterlikesymbols}', "");
    Expect(1, 8527, '\p{		IS_Letterlike_SYMBOLS}', "");
    Expect(0, 8527, '\p{^		IS_Letterlike_SYMBOLS}', "");
    Expect(0, 8527, '\P{		IS_Letterlike_SYMBOLS}', "");
    Expect(1, 8527, '\P{^		IS_Letterlike_SYMBOLS}', "");
    Expect(0, 8528, '\p{		IS_Letterlike_SYMBOLS}', "");
    Expect(1, 8528, '\p{^		IS_Letterlike_SYMBOLS}', "");
    Expect(1, 8528, '\P{		IS_Letterlike_SYMBOLS}', "");
    Expect(0, 8528, '\P{^		IS_Letterlike_SYMBOLS}', "");
    Error('\p{:=__In_LETTERLIKE_Symbols}');
    Error('\P{:=__In_LETTERLIKE_Symbols}');
    Expect(1, 8527, '\p{inletterlikesymbols}', "");
    Expect(0, 8527, '\p{^inletterlikesymbols}', "");
    Expect(0, 8527, '\P{inletterlikesymbols}', "");
    Expect(1, 8527, '\P{^inletterlikesymbols}', "");
    Expect(0, 8528, '\p{inletterlikesymbols}', "");
    Expect(1, 8528, '\p{^inletterlikesymbols}', "");
    Expect(1, 8528, '\P{inletterlikesymbols}', "");
    Expect(0, 8528, '\P{^inletterlikesymbols}', "");
    Expect(1, 8527, '\p{_IN_Letterlike_Symbols}', "");
    Expect(0, 8527, '\p{^_IN_Letterlike_Symbols}', "");
    Expect(0, 8527, '\P{_IN_Letterlike_Symbols}', "");
    Expect(1, 8527, '\P{^_IN_Letterlike_Symbols}', "");
    Expect(0, 8528, '\p{_IN_Letterlike_Symbols}', "");
    Expect(1, 8528, '\p{^_IN_Letterlike_Symbols}', "");
    Expect(1, 8528, '\P{_IN_Letterlike_Symbols}', "");
    Expect(0, 8528, '\P{^_IN_Letterlike_Symbols}', "");
    Error('\p{:=_	Limbu}');
    Error('\P{:=_	Limbu}');
    Expect(1, 6479, '\p{limbu}', "");
    Expect(0, 6479, '\p{^limbu}', "");
    Expect(0, 6479, '\P{limbu}', "");
    Expect(1, 6479, '\P{^limbu}', "");
    Expect(0, 6480, '\p{limbu}', "");
    Expect(1, 6480, '\p{^limbu}', "");
    Expect(1, 6480, '\P{limbu}', "");
    Expect(0, 6480, '\P{^limbu}', "");
    Expect(1, 6479, '\p{__Limbu}', "");
    Expect(0, 6479, '\p{^__Limbu}', "");
    Expect(0, 6479, '\P{__Limbu}', "");
    Expect(1, 6479, '\P{^__Limbu}', "");
    Expect(0, 6480, '\p{__Limbu}', "");
    Expect(1, 6480, '\p{^__Limbu}', "");
    Expect(1, 6480, '\P{__Limbu}', "");
    Expect(0, 6480, '\P{^__Limbu}', "");
    Error('\p{-/a/is_LIMBU}');
    Error('\P{-/a/is_LIMBU}');
    Expect(1, 6479, '\p{islimbu}', "");
    Expect(0, 6479, '\p{^islimbu}', "");
    Expect(0, 6479, '\P{islimbu}', "");
    Expect(1, 6479, '\P{^islimbu}', "");
    Expect(0, 6480, '\p{islimbu}', "");
    Expect(1, 6480, '\p{^islimbu}', "");
    Expect(1, 6480, '\P{islimbu}', "");
    Expect(0, 6480, '\P{^islimbu}', "");
    Expect(1, 6479, '\p{		is_Limbu}', "");
    Expect(0, 6479, '\p{^		is_Limbu}', "");
    Expect(0, 6479, '\P{		is_Limbu}', "");
    Expect(1, 6479, '\P{^		is_Limbu}', "");
    Expect(0, 6480, '\p{		is_Limbu}', "");
    Expect(1, 6480, '\p{^		is_Limbu}', "");
    Expect(1, 6480, '\P{		is_Limbu}', "");
    Expect(0, 6480, '\P{^		is_Limbu}', "");
    Error('\p{/a/  Limb}');
    Error('\P{/a/  Limb}');
    Expect(1, 6479, '\p{limb}', "");
    Expect(0, 6479, '\p{^limb}', "");
    Expect(0, 6479, '\P{limb}', "");
    Expect(1, 6479, '\P{^limb}', "");
    Expect(0, 6480, '\p{limb}', "");
    Expect(1, 6480, '\p{^limb}', "");
    Expect(1, 6480, '\P{limb}', "");
    Expect(0, 6480, '\P{^limb}', "");
    Expect(1, 6479, '\p{_limb}', "");
    Expect(0, 6479, '\p{^_limb}', "");
    Expect(0, 6479, '\P{_limb}', "");
    Expect(1, 6479, '\P{^_limb}', "");
    Expect(0, 6480, '\p{_limb}', "");
    Expect(1, 6480, '\p{^_limb}', "");
    Expect(1, 6480, '\P{_limb}', "");
    Expect(0, 6480, '\P{^_limb}', "");
    Error('\p{/a/	Is_LIMB}');
    Error('\P{/a/	Is_LIMB}');
    Expect(1, 6479, '\p{islimb}', "");
    Expect(0, 6479, '\p{^islimb}', "");
    Expect(0, 6479, '\P{islimb}', "");
    Expect(1, 6479, '\P{^islimb}', "");
    Expect(0, 6480, '\p{islimb}', "");
    Expect(1, 6480, '\p{^islimb}', "");
    Expect(1, 6480, '\P{islimb}', "");
    Expect(0, 6480, '\P{^islimb}', "");
    Expect(1, 6479, '\p{ -is_Limb}', "");
    Expect(0, 6479, '\p{^ -is_Limb}', "");
    Expect(0, 6479, '\P{ -is_Limb}', "");
    Expect(1, 6479, '\P{^ -is_Limb}', "");
    Expect(0, 6480, '\p{ -is_Limb}', "");
    Expect(1, 6480, '\p{^ -is_Limb}', "");
    Expect(1, 6480, '\P{ -is_Limb}', "");
    Expect(0, 6480, '\P{^ -is_Limb}', "");
    Error('\p{		Line_Separator/a/}');
    Error('\P{		Line_Separator/a/}');
    Expect(1, 8232, '\p{lineseparator}', "");
    Expect(0, 8232, '\p{^lineseparator}', "");
    Expect(0, 8232, '\P{lineseparator}', "");
    Expect(1, 8232, '\P{^lineseparator}', "");
    Expect(0, 8233, '\p{lineseparator}', "");
    Expect(1, 8233, '\p{^lineseparator}', "");
    Expect(1, 8233, '\P{lineseparator}', "");
    Expect(0, 8233, '\P{^lineseparator}', "");
    Expect(1, 8232, '\p{- Line_SEPARATOR}', "");
    Expect(0, 8232, '\p{^- Line_SEPARATOR}', "");
    Expect(0, 8232, '\P{- Line_SEPARATOR}', "");
    Expect(1, 8232, '\P{^- Line_SEPARATOR}', "");
    Expect(0, 8233, '\p{- Line_SEPARATOR}', "");
    Expect(1, 8233, '\p{^- Line_SEPARATOR}', "");
    Expect(1, 8233, '\P{- Line_SEPARATOR}', "");
    Expect(0, 8233, '\P{^- Line_SEPARATOR}', "");
    Error('\p{:=		Is_LINE_Separator}');
    Error('\P{:=		Is_LINE_Separator}');
    Expect(1, 8232, '\p{islineseparator}', "");
    Expect(0, 8232, '\p{^islineseparator}', "");
    Expect(0, 8232, '\P{islineseparator}', "");
    Expect(1, 8232, '\P{^islineseparator}', "");
    Expect(0, 8233, '\p{islineseparator}', "");
    Expect(1, 8233, '\p{^islineseparator}', "");
    Expect(1, 8233, '\P{islineseparator}', "");
    Expect(0, 8233, '\P{^islineseparator}', "");
    Expect(1, 8232, '\p{	Is_Line_Separator}', "");
    Expect(0, 8232, '\p{^	Is_Line_Separator}', "");
    Expect(0, 8232, '\P{	Is_Line_Separator}', "");
    Expect(1, 8232, '\P{^	Is_Line_Separator}', "");
    Expect(0, 8233, '\p{	Is_Line_Separator}', "");
    Expect(1, 8233, '\p{^	Is_Line_Separator}', "");
    Expect(1, 8233, '\P{	Is_Line_Separator}', "");
    Expect(0, 8233, '\P{^	Is_Line_Separator}', "");
    Error('\p{- ZL/a/}');
    Error('\P{- ZL/a/}');
    Expect(1, 8232, '\p{zl}', "");
    Expect(0, 8232, '\p{^zl}', "");
    Expect(0, 8232, '\P{zl}', "");
    Expect(1, 8232, '\P{^zl}', "");
    Expect(0, 8233, '\p{zl}', "");
    Expect(1, 8233, '\p{^zl}', "");
    Expect(1, 8233, '\P{zl}', "");
    Expect(0, 8233, '\P{^zl}', "");
    Expect(1, 8232, '\p{	Zl}', "");
    Expect(0, 8232, '\p{^	Zl}', "");
    Expect(0, 8232, '\P{	Zl}', "");
    Expect(1, 8232, '\P{^	Zl}', "");
    Expect(0, 8233, '\p{	Zl}', "");
    Expect(1, 8233, '\p{^	Zl}', "");
    Expect(1, 8233, '\P{	Zl}', "");
    Expect(0, 8233, '\P{^	Zl}', "");
    Error('\p{/a/_Is_ZL}');
    Error('\P{/a/_Is_ZL}');
    Expect(1, 8232, '\p{iszl}', "");
    Expect(0, 8232, '\p{^iszl}', "");
    Expect(0, 8232, '\P{iszl}', "");
    Expect(1, 8232, '\P{^iszl}', "");
    Expect(0, 8233, '\p{iszl}', "");
    Expect(1, 8233, '\p{^iszl}', "");
    Expect(1, 8233, '\P{iszl}', "");
    Expect(0, 8233, '\P{^iszl}', "");
    Expect(1, 8232, '\p{ is_zl}', "");
    Expect(0, 8232, '\p{^ is_zl}', "");
    Expect(0, 8232, '\P{ is_zl}', "");
    Expect(1, 8232, '\P{^ is_zl}', "");
    Expect(0, 8233, '\p{ is_zl}', "");
    Expect(1, 8233, '\p{^ is_zl}', "");
    Expect(1, 8233, '\P{ is_zl}', "");
    Expect(0, 8233, '\P{^ is_zl}', "");
    Error('\p{_:=LINEAR_A}');
    Error('\P{_:=LINEAR_A}');
    Expect(1, 67431, '\p{lineara}', "");
    Expect(0, 67431, '\p{^lineara}', "");
    Expect(0, 67431, '\P{lineara}', "");
    Expect(1, 67431, '\P{^lineara}', "");
    Expect(0, 67432, '\p{lineara}', "");
    Expect(1, 67432, '\p{^lineara}', "");
    Expect(1, 67432, '\P{lineara}', "");
    Expect(0, 67432, '\P{^lineara}', "");
    Expect(1, 67431, '\p{__Linear_a}', "");
    Expect(0, 67431, '\p{^__Linear_a}', "");
    Expect(0, 67431, '\P{__Linear_a}', "");
    Expect(1, 67431, '\P{^__Linear_a}', "");
    Expect(0, 67432, '\p{__Linear_a}', "");
    Expect(1, 67432, '\p{^__Linear_a}', "");
    Expect(1, 67432, '\P{__Linear_a}', "");
    Expect(0, 67432, '\P{^__Linear_a}', "");
    Error('\p{:=		IS_Linear_A}');
    Error('\P{:=		IS_Linear_A}');
    Expect(1, 67431, '\p{islineara}', "");
    Expect(0, 67431, '\p{^islineara}', "");
    Expect(0, 67431, '\P{islineara}', "");
    Expect(1, 67431, '\P{^islineara}', "");
    Expect(0, 67432, '\p{islineara}', "");
    Expect(1, 67432, '\p{^islineara}', "");
    Expect(1, 67432, '\P{islineara}', "");
    Expect(0, 67432, '\P{^islineara}', "");
    Expect(1, 67431, '\p{ 	is_Linear_a}', "");
    Expect(0, 67431, '\p{^ 	is_Linear_a}', "");
    Expect(0, 67431, '\P{ 	is_Linear_a}', "");
    Expect(1, 67431, '\P{^ 	is_Linear_a}', "");
    Expect(0, 67432, '\p{ 	is_Linear_a}', "");
    Expect(1, 67432, '\p{^ 	is_Linear_a}', "");
    Expect(1, 67432, '\P{ 	is_Linear_a}', "");
    Expect(0, 67432, '\P{^ 	is_Linear_a}', "");
    Error('\p{_:=lina}');
    Error('\P{_:=lina}');
    Expect(1, 67431, '\p{lina}', "");
    Expect(0, 67431, '\p{^lina}', "");
    Expect(0, 67431, '\P{lina}', "");
    Expect(1, 67431, '\P{^lina}', "");
    Expect(0, 67432, '\p{lina}', "");
    Expect(1, 67432, '\p{^lina}', "");
    Expect(1, 67432, '\P{lina}', "");
    Expect(0, 67432, '\P{^lina}', "");
    Expect(1, 67431, '\p{	Lina}', "");
    Expect(0, 67431, '\p{^	Lina}', "");
    Expect(0, 67431, '\P{	Lina}', "");
    Expect(1, 67431, '\P{^	Lina}', "");
    Expect(0, 67432, '\p{	Lina}', "");
    Expect(1, 67432, '\p{^	Lina}', "");
    Expect(1, 67432, '\P{	Lina}', "");
    Expect(0, 67432, '\P{^	Lina}', "");
    Error('\p{/a/--IS_Lina}');
    Error('\P{/a/--IS_Lina}');
    Expect(1, 67431, '\p{islina}', "");
    Expect(0, 67431, '\p{^islina}', "");
    Expect(0, 67431, '\P{islina}', "");
    Expect(1, 67431, '\P{^islina}', "");
    Expect(0, 67432, '\p{islina}', "");
    Expect(1, 67432, '\p{^islina}', "");
    Expect(1, 67432, '\P{islina}', "");
    Expect(0, 67432, '\P{^islina}', "");
    Expect(1, 67431, '\p{ is_Lina}', "");
    Expect(0, 67431, '\p{^ is_Lina}', "");
    Expect(0, 67431, '\P{ is_Lina}', "");
    Expect(1, 67431, '\P{^ is_Lina}', "");
    Expect(0, 67432, '\p{ is_Lina}', "");
    Expect(1, 67432, '\p{^ is_Lina}', "");
    Expect(1, 67432, '\P{ is_Lina}', "");
    Expect(0, 67432, '\P{^ is_Lina}', "");
    Error('\p{_linear_b:=}');
    Error('\P{_linear_b:=}');
    Expect(1, 65855, '\p{linearb}', "");
    Expect(0, 65855, '\p{^linearb}', "");
    Expect(0, 65855, '\P{linearb}', "");
    Expect(1, 65855, '\P{^linearb}', "");
    Expect(0, 65856, '\p{linearb}', "");
    Expect(1, 65856, '\p{^linearb}', "");
    Expect(1, 65856, '\P{linearb}', "");
    Expect(0, 65856, '\P{^linearb}', "");
    Expect(1, 65855, '\p{	Linear_B}', "");
    Expect(0, 65855, '\p{^	Linear_B}', "");
    Expect(0, 65855, '\P{	Linear_B}', "");
    Expect(1, 65855, '\P{^	Linear_B}', "");
    Expect(0, 65856, '\p{	Linear_B}', "");
    Expect(1, 65856, '\p{^	Linear_B}', "");
    Expect(1, 65856, '\P{	Linear_B}', "");
    Expect(0, 65856, '\P{^	Linear_B}', "");
    Error('\p{:=  Is_LINEAR_b}');
    Error('\P{:=  Is_LINEAR_b}');
    Expect(1, 65855, '\p{islinearb}', "");
    Expect(0, 65855, '\p{^islinearb}', "");
    Expect(0, 65855, '\P{islinearb}', "");
    Expect(1, 65855, '\P{^islinearb}', "");
    Expect(0, 65856, '\p{islinearb}', "");
    Expect(1, 65856, '\p{^islinearb}', "");
    Expect(1, 65856, '\P{islinearb}', "");
    Expect(0, 65856, '\P{^islinearb}', "");
    Expect(1, 65855, '\p{-IS_LINEAR_B}', "");
    Expect(0, 65855, '\p{^-IS_LINEAR_B}', "");
    Expect(0, 65855, '\P{-IS_LINEAR_B}', "");
    Expect(1, 65855, '\P{^-IS_LINEAR_B}', "");
    Expect(0, 65856, '\p{-IS_LINEAR_B}', "");
    Expect(1, 65856, '\p{^-IS_LINEAR_B}', "");
    Expect(1, 65856, '\P{-IS_LINEAR_B}', "");
    Expect(0, 65856, '\P{^-IS_LINEAR_B}', "");
    Error('\p{_/a/Linb}');
    Error('\P{_/a/Linb}');
    Expect(1, 65855, '\p{linb}', "");
    Expect(0, 65855, '\p{^linb}', "");
    Expect(0, 65855, '\P{linb}', "");
    Expect(1, 65855, '\P{^linb}', "");
    Expect(0, 65856, '\p{linb}', "");
    Expect(1, 65856, '\p{^linb}', "");
    Expect(1, 65856, '\P{linb}', "");
    Expect(0, 65856, '\P{^linb}', "");
    Expect(1, 65855, '\p{ _linb}', "");
    Expect(0, 65855, '\p{^ _linb}', "");
    Expect(0, 65855, '\P{ _linb}', "");
    Expect(1, 65855, '\P{^ _linb}', "");
    Expect(0, 65856, '\p{ _linb}', "");
    Expect(1, 65856, '\p{^ _linb}', "");
    Expect(1, 65856, '\P{ _linb}', "");
    Expect(0, 65856, '\P{^ _linb}', "");
    Error('\p{:=_Is_Linb}');
    Error('\P{:=_Is_Linb}');
    Expect(1, 65855, '\p{islinb}', "");
    Expect(0, 65855, '\p{^islinb}', "");
    Expect(0, 65855, '\P{islinb}', "");
    Expect(1, 65855, '\P{^islinb}', "");
    Expect(0, 65856, '\p{islinb}', "");
    Expect(1, 65856, '\p{^islinb}', "");
    Expect(1, 65856, '\P{islinb}', "");
    Expect(0, 65856, '\P{^islinb}', "");
    Expect(1, 65855, '\p{_	IS_Linb}', "");
    Expect(0, 65855, '\p{^_	IS_Linb}', "");
    Expect(0, 65855, '\P{_	IS_Linb}', "");
    Expect(1, 65855, '\P{^_	IS_Linb}', "");
    Expect(0, 65856, '\p{_	IS_Linb}', "");
    Expect(1, 65856, '\p{^_	IS_Linb}', "");
    Expect(1, 65856, '\P{_	IS_Linb}', "");
    Expect(0, 65856, '\P{^_	IS_Linb}', "");
    Error('\p{ Linear_b_Ideograms:=}');
    Error('\P{ Linear_b_Ideograms:=}');
    Expect(1, 65791, '\p{linearbideograms}', "");
    Expect(0, 65791, '\p{^linearbideograms}', "");
    Expect(0, 65791, '\P{linearbideograms}', "");
    Expect(1, 65791, '\P{^linearbideograms}', "");
    Expect(0, 65792, '\p{linearbideograms}', "");
    Expect(1, 65792, '\p{^linearbideograms}', "");
    Expect(1, 65792, '\P{linearbideograms}', "");
    Expect(0, 65792, '\P{^linearbideograms}', "");
    Expect(1, 65791, '\p{_-LINEAR_B_ideograms}', "");
    Expect(0, 65791, '\p{^_-LINEAR_B_ideograms}', "");
    Expect(0, 65791, '\P{_-LINEAR_B_ideograms}', "");
    Expect(1, 65791, '\P{^_-LINEAR_B_ideograms}', "");
    Expect(0, 65792, '\p{_-LINEAR_B_ideograms}', "");
    Expect(1, 65792, '\p{^_-LINEAR_B_ideograms}', "");
    Expect(1, 65792, '\P{_-LINEAR_B_ideograms}', "");
    Expect(0, 65792, '\P{^_-LINEAR_B_ideograms}', "");
    Error('\p{	/a/Is_linear_B_Ideograms}');
    Error('\P{	/a/Is_linear_B_Ideograms}');
    Expect(1, 65791, '\p{islinearbideograms}', "");
    Expect(0, 65791, '\p{^islinearbideograms}', "");
    Expect(0, 65791, '\P{islinearbideograms}', "");
    Expect(1, 65791, '\P{^islinearbideograms}', "");
    Expect(0, 65792, '\p{islinearbideograms}', "");
    Expect(1, 65792, '\p{^islinearbideograms}', "");
    Expect(1, 65792, '\P{islinearbideograms}', "");
    Expect(0, 65792, '\P{^islinearbideograms}', "");
    Expect(1, 65791, '\p{_ Is_LINEAR_B_IDEOGRAMS}', "");
    Expect(0, 65791, '\p{^_ Is_LINEAR_B_IDEOGRAMS}', "");
    Expect(0, 65791, '\P{_ Is_LINEAR_B_IDEOGRAMS}', "");
    Expect(1, 65791, '\P{^_ Is_LINEAR_B_IDEOGRAMS}', "");
    Expect(0, 65792, '\p{_ Is_LINEAR_B_IDEOGRAMS}', "");
    Expect(1, 65792, '\p{^_ Is_LINEAR_B_IDEOGRAMS}', "");
    Expect(1, 65792, '\P{_ Is_LINEAR_B_IDEOGRAMS}', "");
    Expect(0, 65792, '\P{^_ Is_LINEAR_B_IDEOGRAMS}', "");
    Error('\p{	/a/In_Linear_b_IDEOGRAMS}');
    Error('\P{	/a/In_Linear_b_IDEOGRAMS}');
    Expect(1, 65791, '\p{inlinearbideograms}', "");
    Expect(0, 65791, '\p{^inlinearbideograms}', "");
    Expect(0, 65791, '\P{inlinearbideograms}', "");
    Expect(1, 65791, '\P{^inlinearbideograms}', "");
    Expect(0, 65792, '\p{inlinearbideograms}', "");
    Expect(1, 65792, '\p{^inlinearbideograms}', "");
    Expect(1, 65792, '\P{inlinearbideograms}', "");
    Expect(0, 65792, '\P{^inlinearbideograms}', "");
    Expect(1, 65791, '\p{	in_Linear_B_Ideograms}', "");
    Expect(0, 65791, '\p{^	in_Linear_B_Ideograms}', "");
    Expect(0, 65791, '\P{	in_Linear_B_Ideograms}', "");
    Expect(1, 65791, '\P{^	in_Linear_B_Ideograms}', "");
    Expect(0, 65792, '\p{	in_Linear_B_Ideograms}', "");
    Expect(1, 65792, '\p{^	in_Linear_B_Ideograms}', "");
    Expect(1, 65792, '\P{	in_Linear_B_Ideograms}', "");
    Expect(0, 65792, '\P{^	in_Linear_B_Ideograms}', "");
    Error('\p{:=	 Linear_B_Syllabary}');
    Error('\P{:=	 Linear_B_Syllabary}');
    Expect(1, 65663, '\p{linearbsyllabary}', "");
    Expect(0, 65663, '\p{^linearbsyllabary}', "");
    Expect(0, 65663, '\P{linearbsyllabary}', "");
    Expect(1, 65663, '\P{^linearbsyllabary}', "");
    Expect(0, 65664, '\p{linearbsyllabary}', "");
    Expect(1, 65664, '\p{^linearbsyllabary}', "");
    Expect(1, 65664, '\P{linearbsyllabary}', "");
    Expect(0, 65664, '\P{^linearbsyllabary}', "");
    Expect(1, 65663, '\p{	_Linear_B_SYLLABARY}', "");
    Expect(0, 65663, '\p{^	_Linear_B_SYLLABARY}', "");
    Expect(0, 65663, '\P{	_Linear_B_SYLLABARY}', "");
    Expect(1, 65663, '\P{^	_Linear_B_SYLLABARY}', "");
    Expect(0, 65664, '\p{	_Linear_B_SYLLABARY}', "");
    Expect(1, 65664, '\p{^	_Linear_B_SYLLABARY}', "");
    Expect(1, 65664, '\P{	_Linear_B_SYLLABARY}', "");
    Expect(0, 65664, '\P{^	_Linear_B_SYLLABARY}', "");
    Error('\p{--IS_Linear_B_SYLLABARY:=}');
    Error('\P{--IS_Linear_B_SYLLABARY:=}');
    Expect(1, 65663, '\p{islinearbsyllabary}', "");
    Expect(0, 65663, '\p{^islinearbsyllabary}', "");
    Expect(0, 65663, '\P{islinearbsyllabary}', "");
    Expect(1, 65663, '\P{^islinearbsyllabary}', "");
    Expect(0, 65664, '\p{islinearbsyllabary}', "");
    Expect(1, 65664, '\p{^islinearbsyllabary}', "");
    Expect(1, 65664, '\P{islinearbsyllabary}', "");
    Expect(0, 65664, '\P{^islinearbsyllabary}', "");
    Expect(1, 65663, '\p{	is_Linear_B_Syllabary}', "");
    Expect(0, 65663, '\p{^	is_Linear_B_Syllabary}', "");
    Expect(0, 65663, '\P{	is_Linear_B_Syllabary}', "");
    Expect(1, 65663, '\P{^	is_Linear_B_Syllabary}', "");
    Expect(0, 65664, '\p{	is_Linear_B_Syllabary}', "");
    Expect(1, 65664, '\p{^	is_Linear_B_Syllabary}', "");
    Expect(1, 65664, '\P{	is_Linear_B_Syllabary}', "");
    Expect(0, 65664, '\P{^	is_Linear_B_Syllabary}', "");
    Error('\p{/a/  IN_Linear_B_syllabary}');
    Error('\P{/a/  IN_Linear_B_syllabary}');
    Expect(1, 65663, '\p{inlinearbsyllabary}', "");
    Expect(0, 65663, '\p{^inlinearbsyllabary}', "");
    Expect(0, 65663, '\P{inlinearbsyllabary}', "");
    Expect(1, 65663, '\P{^inlinearbsyllabary}', "");
    Expect(0, 65664, '\p{inlinearbsyllabary}', "");
    Expect(1, 65664, '\p{^inlinearbsyllabary}', "");
    Expect(1, 65664, '\P{inlinearbsyllabary}', "");
    Expect(0, 65664, '\P{^inlinearbsyllabary}', "");
    Expect(1, 65663, '\p{_In_LINEAR_B_Syllabary}', "");
    Expect(0, 65663, '\p{^_In_LINEAR_B_Syllabary}', "");
    Expect(0, 65663, '\P{_In_LINEAR_B_Syllabary}', "");
    Expect(1, 65663, '\P{^_In_LINEAR_B_Syllabary}', "");
    Expect(0, 65664, '\p{_In_LINEAR_B_Syllabary}', "");
    Expect(1, 65664, '\p{^_In_LINEAR_B_Syllabary}', "");
    Expect(1, 65664, '\P{_In_LINEAR_B_Syllabary}', "");
    Expect(0, 65664, '\P{^_In_LINEAR_B_Syllabary}', "");
    Error('\p{_/a/Lisu}');
    Error('\P{_/a/Lisu}');
    Expect(1, 42239, '\p{lisu}', "");
    Expect(0, 42239, '\p{^lisu}', "");
    Expect(0, 42239, '\P{lisu}', "");
    Expect(1, 42239, '\P{^lisu}', "");
    Expect(0, 42240, '\p{lisu}', "");
    Expect(1, 42240, '\p{^lisu}', "");
    Expect(1, 42240, '\P{lisu}', "");
    Expect(0, 42240, '\P{^lisu}', "");
    Expect(1, 42239, '\p{ _lisu}', "");
    Expect(0, 42239, '\p{^ _lisu}', "");
    Expect(0, 42239, '\P{ _lisu}', "");
    Expect(1, 42239, '\P{^ _lisu}', "");
    Expect(0, 42240, '\p{ _lisu}', "");
    Expect(1, 42240, '\p{^ _lisu}', "");
    Expect(1, 42240, '\P{ _lisu}', "");
    Expect(0, 42240, '\P{^ _lisu}', "");
    Error('\p{-:=is_Lisu}');
    Error('\P{-:=is_Lisu}');
    Expect(1, 42239, '\p{islisu}', "");
    Expect(0, 42239, '\p{^islisu}', "");
    Expect(0, 42239, '\P{islisu}', "");
    Expect(1, 42239, '\P{^islisu}', "");
    Expect(0, 42240, '\p{islisu}', "");
    Expect(1, 42240, '\p{^islisu}', "");
    Expect(1, 42240, '\P{islisu}', "");
    Expect(0, 42240, '\P{^islisu}', "");
    Expect(1, 42239, '\p{-Is_lisu}', "");
    Expect(0, 42239, '\p{^-Is_lisu}', "");
    Expect(0, 42239, '\P{-Is_lisu}', "");
    Expect(1, 42239, '\P{^-Is_lisu}', "");
    Expect(0, 42240, '\p{-Is_lisu}', "");
    Expect(1, 42240, '\p{^-Is_lisu}', "");
    Expect(1, 42240, '\P{-Is_lisu}', "");
    Expect(0, 42240, '\P{^-Is_lisu}', "");
    Error('\p{ 	LOGICAL_order_Exception/a/}');
    Error('\P{ 	LOGICAL_order_Exception/a/}');
    Expect(1, 43708, '\p{logicalorderexception}', "");
    Expect(0, 43708, '\p{^logicalorderexception}', "");
    Expect(0, 43708, '\P{logicalorderexception}', "");
    Expect(1, 43708, '\P{^logicalorderexception}', "");
    Expect(0, 43709, '\p{logicalorderexception}', "");
    Expect(1, 43709, '\p{^logicalorderexception}', "");
    Expect(1, 43709, '\P{logicalorderexception}', "");
    Expect(0, 43709, '\P{^logicalorderexception}', "");
    Expect(1, 43708, '\p{ -Logical_ORDER_exception}', "");
    Expect(0, 43708, '\p{^ -Logical_ORDER_exception}', "");
    Expect(0, 43708, '\P{ -Logical_ORDER_exception}', "");
    Expect(1, 43708, '\P{^ -Logical_ORDER_exception}', "");
    Expect(0, 43709, '\p{ -Logical_ORDER_exception}', "");
    Expect(1, 43709, '\p{^ -Logical_ORDER_exception}', "");
    Expect(1, 43709, '\P{ -Logical_ORDER_exception}', "");
    Expect(0, 43709, '\P{^ -Logical_ORDER_exception}', "");
    Error('\p{/a/	Is_Logical_Order_Exception}');
    Error('\P{/a/	Is_Logical_Order_Exception}');
    Expect(1, 43708, '\p{islogicalorderexception}', "");
    Expect(0, 43708, '\p{^islogicalorderexception}', "");
    Expect(0, 43708, '\P{islogicalorderexception}', "");
    Expect(1, 43708, '\P{^islogicalorderexception}', "");
    Expect(0, 43709, '\p{islogicalorderexception}', "");
    Expect(1, 43709, '\p{^islogicalorderexception}', "");
    Expect(1, 43709, '\P{islogicalorderexception}', "");
    Expect(0, 43709, '\P{^islogicalorderexception}', "");
    Expect(1, 43708, '\p{--IS_LOGICAL_Order_exception}', "");
    Expect(0, 43708, '\p{^--IS_LOGICAL_Order_exception}', "");
    Expect(0, 43708, '\P{--IS_LOGICAL_Order_exception}', "");
    Expect(1, 43708, '\P{^--IS_LOGICAL_Order_exception}', "");
    Expect(0, 43709, '\p{--IS_LOGICAL_Order_exception}', "");
    Expect(1, 43709, '\p{^--IS_LOGICAL_Order_exception}', "");
    Expect(1, 43709, '\P{--IS_LOGICAL_Order_exception}', "");
    Expect(0, 43709, '\P{^--IS_LOGICAL_Order_exception}', "");
    Error('\p{ :=LOE}');
    Error('\P{ :=LOE}');
    Expect(1, 43708, '\p{loe}', "");
    Expect(0, 43708, '\p{^loe}', "");
    Expect(0, 43708, '\P{loe}', "");
    Expect(1, 43708, '\P{^loe}', "");
    Expect(0, 43709, '\p{loe}', "");
    Expect(1, 43709, '\p{^loe}', "");
    Expect(1, 43709, '\P{loe}', "");
    Expect(0, 43709, '\P{^loe}', "");
    Expect(1, 43708, '\p{  LOE}', "");
    Expect(0, 43708, '\p{^  LOE}', "");
    Expect(0, 43708, '\P{  LOE}', "");
    Expect(1, 43708, '\P{^  LOE}', "");
    Expect(0, 43709, '\p{  LOE}', "");
    Expect(1, 43709, '\p{^  LOE}', "");
    Expect(1, 43709, '\P{  LOE}', "");
    Expect(0, 43709, '\P{^  LOE}', "");
    Error('\p{		is_loe/a/}');
    Error('\P{		is_loe/a/}');
    Expect(1, 43708, '\p{isloe}', "");
    Expect(0, 43708, '\p{^isloe}', "");
    Expect(0, 43708, '\P{isloe}', "");
    Expect(1, 43708, '\P{^isloe}', "");
    Expect(0, 43709, '\p{isloe}', "");
    Expect(1, 43709, '\p{^isloe}', "");
    Expect(1, 43709, '\P{isloe}', "");
    Expect(0, 43709, '\P{^isloe}', "");
    Expect(1, 43708, '\p{	IS_LOE}', "");
    Expect(0, 43708, '\p{^	IS_LOE}', "");
    Expect(0, 43708, '\P{	IS_LOE}', "");
    Expect(1, 43708, '\P{^	IS_LOE}', "");
    Expect(0, 43709, '\p{	IS_LOE}', "");
    Expect(1, 43709, '\p{^	IS_LOE}', "");
    Expect(1, 43709, '\P{	IS_LOE}', "");
    Expect(0, 43709, '\P{^	IS_LOE}', "");
    Error('\p{/a/_	low_surrogates}');
    Error('\P{/a/_	low_surrogates}');
    Expect(1, 57343, '\p{lowsurrogates}', "");
    Expect(0, 57343, '\p{^lowsurrogates}', "");
    Expect(0, 57343, '\P{lowsurrogates}', "");
    Expect(1, 57343, '\P{^lowsurrogates}', "");
    Expect(0, 57344, '\p{lowsurrogates}', "");
    Expect(1, 57344, '\p{^lowsurrogates}', "");
    Expect(1, 57344, '\P{lowsurrogates}', "");
    Expect(0, 57344, '\P{^lowsurrogates}', "");
    Expect(1, 57343, '\p{	 Low_Surrogates}', "");
    Expect(0, 57343, '\p{^	 Low_Surrogates}', "");
    Expect(0, 57343, '\P{	 Low_Surrogates}', "");
    Expect(1, 57343, '\P{^	 Low_Surrogates}', "");
    Expect(0, 57344, '\p{	 Low_Surrogates}', "");
    Expect(1, 57344, '\p{^	 Low_Surrogates}', "");
    Expect(1, 57344, '\P{	 Low_Surrogates}', "");
    Expect(0, 57344, '\P{^	 Low_Surrogates}', "");
    Error('\p{Is_LOW_surrogates/a/}');
    Error('\P{Is_LOW_surrogates/a/}');
    Expect(1, 57343, '\p{islowsurrogates}', "");
    Expect(0, 57343, '\p{^islowsurrogates}', "");
    Expect(0, 57343, '\P{islowsurrogates}', "");
    Expect(1, 57343, '\P{^islowsurrogates}', "");
    Expect(0, 57344, '\p{islowsurrogates}', "");
    Expect(1, 57344, '\p{^islowsurrogates}', "");
    Expect(1, 57344, '\P{islowsurrogates}', "");
    Expect(0, 57344, '\P{^islowsurrogates}', "");
    Expect(1, 57343, '\p{_-IS_low_Surrogates}', "");
    Expect(0, 57343, '\p{^_-IS_low_Surrogates}', "");
    Expect(0, 57343, '\P{_-IS_low_Surrogates}', "");
    Expect(1, 57343, '\P{^_-IS_low_Surrogates}', "");
    Expect(0, 57344, '\p{_-IS_low_Surrogates}', "");
    Expect(1, 57344, '\p{^_-IS_low_Surrogates}', "");
    Expect(1, 57344, '\P{_-IS_low_Surrogates}', "");
    Expect(0, 57344, '\P{^_-IS_low_Surrogates}', "");
    Error('\p{/a/	 IN_Low_Surrogates}');
    Error('\P{/a/	 IN_Low_Surrogates}');
    Expect(1, 57343, '\p{inlowsurrogates}', "");
    Expect(0, 57343, '\p{^inlowsurrogates}', "");
    Expect(0, 57343, '\P{inlowsurrogates}', "");
    Expect(1, 57343, '\P{^inlowsurrogates}', "");
    Expect(0, 57344, '\p{inlowsurrogates}', "");
    Expect(1, 57344, '\p{^inlowsurrogates}', "");
    Expect(1, 57344, '\P{inlowsurrogates}', "");
    Expect(0, 57344, '\P{^inlowsurrogates}', "");
    Expect(1, 57343, '\p{	_in_low_Surrogates}', "");
    Expect(0, 57343, '\p{^	_in_low_Surrogates}', "");
    Expect(0, 57343, '\P{	_in_low_Surrogates}', "");
    Expect(1, 57343, '\P{^	_in_low_Surrogates}', "");
    Expect(0, 57344, '\p{	_in_low_Surrogates}', "");
    Expect(1, 57344, '\p{^	_in_low_Surrogates}', "");
    Expect(1, 57344, '\P{	_in_low_Surrogates}', "");
    Expect(0, 57344, '\P{^	_in_low_Surrogates}', "");
    Error('\p{-_Lowercase_Letter/a/}');
    Error('\P{-_Lowercase_Letter/a/}');
    Expect(1, 125251, '\p{lowercaseletter}', "");
    Expect(0, 125251, '\p{^lowercaseletter}', "");
    Expect(0, 125251, '\P{lowercaseletter}', "");
    Expect(1, 125251, '\P{^lowercaseletter}', "");
    Expect(0, 125252, '\p{lowercaseletter}', "");
    Expect(1, 125252, '\p{^lowercaseletter}', "");
    Expect(1, 125252, '\P{lowercaseletter}', "");
    Expect(0, 125252, '\P{^lowercaseletter}', "");
    Expect(1, 125251, '\p{ -Lowercase_LETTER}', "");
    Expect(0, 125251, '\p{^ -Lowercase_LETTER}', "");
    Expect(0, 125251, '\P{ -Lowercase_LETTER}', "");
    Expect(1, 125251, '\P{^ -Lowercase_LETTER}', "");
    Expect(0, 125252, '\p{ -Lowercase_LETTER}', "");
    Expect(1, 125252, '\p{^ -Lowercase_LETTER}', "");
    Expect(1, 125252, '\P{ -Lowercase_LETTER}', "");
    Expect(0, 125252, '\P{^ -Lowercase_LETTER}', "");
    Error('\p{:=IS_LOWERCASE_letter}');
    Error('\P{:=IS_LOWERCASE_letter}');
    Expect(1, 125251, '\p{islowercaseletter}', "");
    Expect(0, 125251, '\p{^islowercaseletter}', "");
    Expect(0, 125251, '\P{islowercaseletter}', "");
    Expect(1, 125251, '\P{^islowercaseletter}', "");
    Expect(0, 125252, '\p{islowercaseletter}', "");
    Expect(1, 125252, '\p{^islowercaseletter}', "");
    Expect(1, 125252, '\P{islowercaseletter}', "");
    Expect(0, 125252, '\P{^islowercaseletter}', "");
    Expect(1, 125251, '\p{		is_lowercase_Letter}', "");
    Expect(0, 125251, '\p{^		is_lowercase_Letter}', "");
    Expect(0, 125251, '\P{		is_lowercase_Letter}', "");
    Expect(1, 125251, '\P{^		is_lowercase_Letter}', "");
    Expect(0, 125252, '\p{		is_lowercase_Letter}', "");
    Expect(1, 125252, '\p{^		is_lowercase_Letter}', "");
    Expect(1, 125252, '\P{		is_lowercase_Letter}', "");
    Expect(0, 125252, '\P{^		is_lowercase_Letter}', "");
    Error('\p{/a/ Ll}');
    Error('\P{/a/ Ll}');
    Expect(1, 125251, '\p{ll}', "");
    Expect(0, 125251, '\p{^ll}', "");
    Expect(0, 125251, '\P{ll}', "");
    Expect(1, 125251, '\P{^ll}', "");
    Expect(0, 125252, '\p{ll}', "");
    Expect(1, 125252, '\p{^ll}', "");
    Expect(1, 125252, '\P{ll}', "");
    Expect(0, 125252, '\P{^ll}', "");
    Expect(1, 125251, '\p{-LL}', "");
    Expect(0, 125251, '\p{^-LL}', "");
    Expect(0, 125251, '\P{-LL}', "");
    Expect(1, 125251, '\P{^-LL}', "");
    Expect(0, 125252, '\p{-LL}', "");
    Expect(1, 125252, '\p{^-LL}', "");
    Expect(1, 125252, '\P{-LL}', "");
    Expect(0, 125252, '\P{^-LL}', "");
    Error('\p{ /a/Is_Ll}');
    Error('\P{ /a/Is_Ll}');
    Expect(1, 125251, '\p{isll}', "");
    Expect(0, 125251, '\p{^isll}', "");
    Expect(0, 125251, '\P{isll}', "");
    Expect(1, 125251, '\P{^isll}', "");
    Expect(0, 125252, '\p{isll}', "");
    Expect(1, 125252, '\p{^isll}', "");
    Expect(1, 125252, '\P{isll}', "");
    Expect(0, 125252, '\P{^isll}', "");
    Expect(1, 125251, '\p{_IS_ll}', "");
    Expect(0, 125251, '\p{^_IS_ll}', "");
    Expect(0, 125251, '\P{_IS_ll}', "");
    Expect(1, 125251, '\P{^_IS_ll}', "");
    Expect(0, 125252, '\p{_IS_ll}', "");
    Expect(1, 125252, '\p{^_IS_ll}', "");
    Expect(1, 125252, '\P{_IS_ll}', "");
    Expect(0, 125252, '\P{^_IS_ll}', "");
    Error('\p{:=_-LYCIAN}');
    Error('\P{:=_-LYCIAN}');
    Expect(1, 66204, '\p{lycian}', "");
    Expect(0, 66204, '\p{^lycian}', "");
    Expect(0, 66204, '\P{lycian}', "");
    Expect(1, 66204, '\P{^lycian}', "");
    Expect(0, 66205, '\p{lycian}', "");
    Expect(1, 66205, '\p{^lycian}', "");
    Expect(1, 66205, '\P{lycian}', "");
    Expect(0, 66205, '\P{^lycian}', "");
    Expect(1, 66204, '\p{ Lycian}', "");
    Expect(0, 66204, '\p{^ Lycian}', "");
    Expect(0, 66204, '\P{ Lycian}', "");
    Expect(1, 66204, '\P{^ Lycian}', "");
    Expect(0, 66205, '\p{ Lycian}', "");
    Expect(1, 66205, '\p{^ Lycian}', "");
    Expect(1, 66205, '\P{ Lycian}', "");
    Expect(0, 66205, '\P{^ Lycian}', "");
    Error('\p{--Is_LYCIAN:=}');
    Error('\P{--Is_LYCIAN:=}');
    Expect(1, 66204, '\p{islycian}', "");
    Expect(0, 66204, '\p{^islycian}', "");
    Expect(0, 66204, '\P{islycian}', "");
    Expect(1, 66204, '\P{^islycian}', "");
    Expect(0, 66205, '\p{islycian}', "");
    Expect(1, 66205, '\p{^islycian}', "");
    Expect(1, 66205, '\P{islycian}', "");
    Expect(0, 66205, '\P{^islycian}', "");
    Expect(1, 66204, '\p{	-Is_Lycian}', "");
    Expect(0, 66204, '\p{^	-Is_Lycian}', "");
    Expect(0, 66204, '\P{	-Is_Lycian}', "");
    Expect(1, 66204, '\P{^	-Is_Lycian}', "");
    Expect(0, 66205, '\p{	-Is_Lycian}', "");
    Expect(1, 66205, '\p{^	-Is_Lycian}', "");
    Expect(1, 66205, '\P{	-Is_Lycian}', "");
    Expect(0, 66205, '\P{^	-Is_Lycian}', "");
    Error('\p{	:=lyci}');
    Error('\P{	:=lyci}');
    Expect(1, 66204, '\p{lyci}', "");
    Expect(0, 66204, '\p{^lyci}', "");
    Expect(0, 66204, '\P{lyci}', "");
    Expect(1, 66204, '\P{^lyci}', "");
    Expect(0, 66205, '\p{lyci}', "");
    Expect(1, 66205, '\p{^lyci}', "");
    Expect(1, 66205, '\P{lyci}', "");
    Expect(0, 66205, '\P{^lyci}', "");
    Expect(1, 66204, '\p{- Lyci}', "");
    Expect(0, 66204, '\p{^- Lyci}', "");
    Expect(0, 66204, '\P{- Lyci}', "");
    Expect(1, 66204, '\P{^- Lyci}', "");
    Expect(0, 66205, '\p{- Lyci}', "");
    Expect(1, 66205, '\p{^- Lyci}', "");
    Expect(1, 66205, '\P{- Lyci}', "");
    Expect(0, 66205, '\P{^- Lyci}', "");
    Error('\p{_:=Is_Lyci}');
    Error('\P{_:=Is_Lyci}');
    Expect(1, 66204, '\p{islyci}', "");
    Expect(0, 66204, '\p{^islyci}', "");
    Expect(0, 66204, '\P{islyci}', "");
    Expect(1, 66204, '\P{^islyci}', "");
    Expect(0, 66205, '\p{islyci}', "");
    Expect(1, 66205, '\p{^islyci}', "");
    Expect(1, 66205, '\P{islyci}', "");
    Expect(0, 66205, '\P{^islyci}', "");
    Expect(1, 66204, '\p{	is_Lyci}', "");
    Expect(0, 66204, '\p{^	is_Lyci}', "");
    Expect(0, 66204, '\P{	is_Lyci}', "");
    Expect(1, 66204, '\P{^	is_Lyci}', "");
    Expect(0, 66205, '\p{	is_Lyci}', "");
    Expect(1, 66205, '\p{^	is_Lyci}', "");
    Expect(1, 66205, '\P{	is_Lyci}', "");
    Expect(0, 66205, '\P{^	is_Lyci}', "");
    Error('\p{:=	Lydian}');
    Error('\P{:=	Lydian}');
    Expect(1, 67903, '\p{lydian}', "");
    Expect(0, 67903, '\p{^lydian}', "");
    Expect(0, 67903, '\P{lydian}', "");
    Expect(1, 67903, '\P{^lydian}', "");
    Expect(0, 67904, '\p{lydian}', "");
    Expect(1, 67904, '\p{^lydian}', "");
    Expect(1, 67904, '\P{lydian}', "");
    Expect(0, 67904, '\P{^lydian}', "");
    Expect(1, 67903, '\p{ Lydian}', "");
    Expect(0, 67903, '\p{^ Lydian}', "");
    Expect(0, 67903, '\P{ Lydian}', "");
    Expect(1, 67903, '\P{^ Lydian}', "");
    Expect(0, 67904, '\p{ Lydian}', "");
    Expect(1, 67904, '\p{^ Lydian}', "");
    Expect(1, 67904, '\P{ Lydian}', "");
    Expect(0, 67904, '\P{^ Lydian}', "");
    Error('\p{	:=Is_Lydian}');
    Error('\P{	:=Is_Lydian}');
    Expect(1, 67903, '\p{islydian}', "");
    Expect(0, 67903, '\p{^islydian}', "");
    Expect(0, 67903, '\P{islydian}', "");
    Expect(1, 67903, '\P{^islydian}', "");
    Expect(0, 67904, '\p{islydian}', "");
    Expect(1, 67904, '\p{^islydian}', "");
    Expect(1, 67904, '\P{islydian}', "");
    Expect(0, 67904, '\P{^islydian}', "");
    Expect(1, 67903, '\p{	 Is_LYDIAN}', "");
    Expect(0, 67903, '\p{^	 Is_LYDIAN}', "");
    Expect(0, 67903, '\P{	 Is_LYDIAN}', "");
    Expect(1, 67903, '\P{^	 Is_LYDIAN}', "");
    Expect(0, 67904, '\p{	 Is_LYDIAN}', "");
    Expect(1, 67904, '\p{^	 Is_LYDIAN}', "");
    Expect(1, 67904, '\P{	 Is_LYDIAN}', "");
    Expect(0, 67904, '\P{^	 Is_LYDIAN}', "");
    Error('\p{-Lydi/a/}');
    Error('\P{-Lydi/a/}');
    Expect(1, 67903, '\p{lydi}', "");
    Expect(0, 67903, '\p{^lydi}', "");
    Expect(0, 67903, '\P{lydi}', "");
    Expect(1, 67903, '\P{^lydi}', "");
    Expect(0, 67904, '\p{lydi}', "");
    Expect(1, 67904, '\p{^lydi}', "");
    Expect(1, 67904, '\P{lydi}', "");
    Expect(0, 67904, '\P{^lydi}', "");
    Expect(1, 67903, '\p{	_Lydi}', "");
    Expect(0, 67903, '\p{^	_Lydi}', "");
    Expect(0, 67903, '\P{	_Lydi}', "");
    Expect(1, 67903, '\P{^	_Lydi}', "");
    Expect(0, 67904, '\p{	_Lydi}', "");
    Expect(1, 67904, '\p{^	_Lydi}', "");
    Expect(1, 67904, '\P{	_Lydi}', "");
    Expect(0, 67904, '\P{^	_Lydi}', "");
    Error('\p{	/a/is_Lydi}');
    Error('\P{	/a/is_Lydi}');
    Expect(1, 67903, '\p{islydi}', "");
    Expect(0, 67903, '\p{^islydi}', "");
    Expect(0, 67903, '\P{islydi}', "");
    Expect(1, 67903, '\P{^islydi}', "");
    Expect(0, 67904, '\p{islydi}', "");
    Expect(1, 67904, '\p{^islydi}', "");
    Expect(1, 67904, '\P{islydi}', "");
    Expect(0, 67904, '\P{^islydi}', "");
    Expect(1, 67903, '\p{		is_lydi}', "");
    Expect(0, 67903, '\p{^		is_lydi}', "");
    Expect(0, 67903, '\P{		is_lydi}', "");
    Expect(1, 67903, '\P{^		is_lydi}', "");
    Expect(0, 67904, '\p{		is_lydi}', "");
    Expect(1, 67904, '\p{^		is_lydi}', "");
    Expect(1, 67904, '\P{		is_lydi}', "");
    Expect(0, 67904, '\P{^		is_lydi}', "");
    Error('\p{-:=MAHAJANI}');
    Error('\P{-:=MAHAJANI}');
    Expect(1, 70006, '\p{mahajani}', "");
    Expect(0, 70006, '\p{^mahajani}', "");
    Expect(0, 70006, '\P{mahajani}', "");
    Expect(1, 70006, '\P{^mahajani}', "");
    Expect(0, 70007, '\p{mahajani}', "");
    Expect(1, 70007, '\p{^mahajani}', "");
    Expect(1, 70007, '\P{mahajani}', "");
    Expect(0, 70007, '\P{^mahajani}', "");
    Expect(1, 70006, '\p{ MAHAJANI}', "");
    Expect(0, 70006, '\p{^ MAHAJANI}', "");
    Expect(0, 70006, '\P{ MAHAJANI}', "");
    Expect(1, 70006, '\P{^ MAHAJANI}', "");
    Expect(0, 70007, '\p{ MAHAJANI}', "");
    Expect(1, 70007, '\p{^ MAHAJANI}', "");
    Expect(1, 70007, '\P{ MAHAJANI}', "");
    Expect(0, 70007, '\P{^ MAHAJANI}', "");
    Error('\p{-IS_Mahajani/a/}');
    Error('\P{-IS_Mahajani/a/}');
    Expect(1, 70006, '\p{ismahajani}', "");
    Expect(0, 70006, '\p{^ismahajani}', "");
    Expect(0, 70006, '\P{ismahajani}', "");
    Expect(1, 70006, '\P{^ismahajani}', "");
    Expect(0, 70007, '\p{ismahajani}', "");
    Expect(1, 70007, '\p{^ismahajani}', "");
    Expect(1, 70007, '\P{ismahajani}', "");
    Expect(0, 70007, '\P{^ismahajani}', "");
    Expect(1, 70006, '\p{ _Is_mahajani}', "");
    Expect(0, 70006, '\p{^ _Is_mahajani}', "");
    Expect(0, 70006, '\P{ _Is_mahajani}', "");
    Expect(1, 70006, '\P{^ _Is_mahajani}', "");
    Expect(0, 70007, '\p{ _Is_mahajani}', "");
    Expect(1, 70007, '\p{^ _Is_mahajani}', "");
    Expect(1, 70007, '\P{ _Is_mahajani}', "");
    Expect(0, 70007, '\P{^ _Is_mahajani}', "");
    Error('\p{/a/-Mahj}');
    Error('\P{/a/-Mahj}');
    Expect(1, 70006, '\p{mahj}', "");
    Expect(0, 70006, '\p{^mahj}', "");
    Expect(0, 70006, '\P{mahj}', "");
    Expect(1, 70006, '\P{^mahj}', "");
    Expect(0, 70007, '\p{mahj}', "");
    Expect(1, 70007, '\p{^mahj}', "");
    Expect(1, 70007, '\P{mahj}', "");
    Expect(0, 70007, '\P{^mahj}', "");
    Expect(1, 70006, '\p{- Mahj}', "");
    Expect(0, 70006, '\p{^- Mahj}', "");
    Expect(0, 70006, '\P{- Mahj}', "");
    Expect(1, 70006, '\P{^- Mahj}', "");
    Expect(0, 70007, '\p{- Mahj}', "");
    Expect(1, 70007, '\p{^- Mahj}', "");
    Expect(1, 70007, '\P{- Mahj}', "");
    Expect(0, 70007, '\P{^- Mahj}', "");
    Error('\p{/a/  IS_MAHJ}');
    Error('\P{/a/  IS_MAHJ}');
    Expect(1, 70006, '\p{ismahj}', "");
    Expect(0, 70006, '\p{^ismahj}', "");
    Expect(0, 70006, '\P{ismahj}', "");
    Expect(1, 70006, '\P{^ismahj}', "");
    Expect(0, 70007, '\p{ismahj}', "");
    Expect(1, 70007, '\p{^ismahj}', "");
    Expect(1, 70007, '\P{ismahj}', "");
    Expect(0, 70007, '\P{^ismahj}', "");
    Expect(1, 70006, '\p{--is_MAHJ}', "");
    Expect(0, 70006, '\p{^--is_MAHJ}', "");
    Expect(0, 70006, '\P{--is_MAHJ}', "");
    Expect(1, 70006, '\P{^--is_MAHJ}', "");
    Expect(0, 70007, '\p{--is_MAHJ}', "");
    Expect(1, 70007, '\p{^--is_MAHJ}', "");
    Expect(1, 70007, '\P{--is_MAHJ}', "");
    Expect(0, 70007, '\P{^--is_MAHJ}', "");
    Error('\p{/a/_	MAHJONG_Tiles}');
    Error('\P{/a/_	MAHJONG_Tiles}');
    Expect(1, 127023, '\p{mahjongtiles}', "");
    Expect(0, 127023, '\p{^mahjongtiles}', "");
    Expect(0, 127023, '\P{mahjongtiles}', "");
    Expect(1, 127023, '\P{^mahjongtiles}', "");
    Expect(0, 127024, '\p{mahjongtiles}', "");
    Expect(1, 127024, '\p{^mahjongtiles}', "");
    Expect(1, 127024, '\P{mahjongtiles}', "");
    Expect(0, 127024, '\P{^mahjongtiles}', "");
    Expect(1, 127023, '\p{__Mahjong_Tiles}', "");
    Expect(0, 127023, '\p{^__Mahjong_Tiles}', "");
    Expect(0, 127023, '\P{__Mahjong_Tiles}', "");
    Expect(1, 127023, '\P{^__Mahjong_Tiles}', "");
    Expect(0, 127024, '\p{__Mahjong_Tiles}', "");
    Expect(1, 127024, '\p{^__Mahjong_Tiles}', "");
    Expect(1, 127024, '\P{__Mahjong_Tiles}', "");
    Expect(0, 127024, '\P{^__Mahjong_Tiles}', "");
    Error('\p{_/a/Is_Mahjong_TILES}');
    Error('\P{_/a/Is_Mahjong_TILES}');
    Expect(1, 127023, '\p{ismahjongtiles}', "");
    Expect(0, 127023, '\p{^ismahjongtiles}', "");
    Expect(0, 127023, '\P{ismahjongtiles}', "");
    Expect(1, 127023, '\P{^ismahjongtiles}', "");
    Expect(0, 127024, '\p{ismahjongtiles}', "");
    Expect(1, 127024, '\p{^ismahjongtiles}', "");
    Expect(1, 127024, '\P{ismahjongtiles}', "");
    Expect(0, 127024, '\P{^ismahjongtiles}', "");
    Expect(1, 127023, '\p{-is_Mahjong_Tiles}', "");
    Expect(0, 127023, '\p{^-is_Mahjong_Tiles}', "");
    Expect(0, 127023, '\P{-is_Mahjong_Tiles}', "");
    Expect(1, 127023, '\P{^-is_Mahjong_Tiles}', "");
    Expect(0, 127024, '\p{-is_Mahjong_Tiles}', "");
    Expect(1, 127024, '\p{^-is_Mahjong_Tiles}', "");
    Expect(1, 127024, '\P{-is_Mahjong_Tiles}', "");
    Expect(0, 127024, '\P{^-is_Mahjong_Tiles}', "");
    Error('\p{ In_Mahjong_TILES/a/}');
    Error('\P{ In_Mahjong_TILES/a/}');
    Expect(1, 127023, '\p{inmahjongtiles}', "");
    Expect(0, 127023, '\p{^inmahjongtiles}', "");
    Expect(0, 127023, '\P{inmahjongtiles}', "");
    Expect(1, 127023, '\P{^inmahjongtiles}', "");
    Expect(0, 127024, '\p{inmahjongtiles}', "");
    Expect(1, 127024, '\p{^inmahjongtiles}', "");
    Expect(1, 127024, '\P{inmahjongtiles}', "");
    Expect(0, 127024, '\P{^inmahjongtiles}', "");
    Expect(1, 127023, '\p{IN_Mahjong_Tiles}', "");
    Expect(0, 127023, '\p{^IN_Mahjong_Tiles}', "");
    Expect(0, 127023, '\P{IN_Mahjong_Tiles}', "");
    Expect(1, 127023, '\P{^IN_Mahjong_Tiles}', "");
    Expect(0, 127024, '\p{IN_Mahjong_Tiles}', "");
    Expect(1, 127024, '\p{^IN_Mahjong_Tiles}', "");
    Expect(1, 127024, '\P{IN_Mahjong_Tiles}', "");
    Expect(0, 127024, '\P{^IN_Mahjong_Tiles}', "");
    Error('\p{:=	Mahjong}');
    Error('\P{:=	Mahjong}');
    Expect(1, 127023, '\p{mahjong}', "");
    Expect(0, 127023, '\p{^mahjong}', "");
    Expect(0, 127023, '\P{mahjong}', "");
    Expect(1, 127023, '\P{^mahjong}', "");
    Expect(0, 127024, '\p{mahjong}', "");
    Expect(1, 127024, '\p{^mahjong}', "");
    Expect(1, 127024, '\P{mahjong}', "");
    Expect(0, 127024, '\P{^mahjong}', "");
    Expect(1, 127023, '\p{-MAHJONG}', "");
    Expect(0, 127023, '\p{^-MAHJONG}', "");
    Expect(0, 127023, '\P{-MAHJONG}', "");
    Expect(1, 127023, '\P{^-MAHJONG}', "");
    Expect(0, 127024, '\p{-MAHJONG}', "");
    Expect(1, 127024, '\p{^-MAHJONG}', "");
    Expect(1, 127024, '\P{-MAHJONG}', "");
    Expect(0, 127024, '\P{^-MAHJONG}', "");
    Error('\p{/a/IS_mahjong}');
    Error('\P{/a/IS_mahjong}');
    Expect(1, 127023, '\p{ismahjong}', "");
    Expect(0, 127023, '\p{^ismahjong}', "");
    Expect(0, 127023, '\P{ismahjong}', "");
    Expect(1, 127023, '\P{^ismahjong}', "");
    Expect(0, 127024, '\p{ismahjong}', "");
    Expect(1, 127024, '\p{^ismahjong}', "");
    Expect(1, 127024, '\P{ismahjong}', "");
    Expect(0, 127024, '\P{^ismahjong}', "");
    Expect(1, 127023, '\p{-_is_mahjong}', "");
    Expect(0, 127023, '\p{^-_is_mahjong}', "");
    Expect(0, 127023, '\P{-_is_mahjong}', "");
    Expect(1, 127023, '\P{^-_is_mahjong}', "");
    Expect(0, 127024, '\p{-_is_mahjong}', "");
    Expect(1, 127024, '\p{^-_is_mahjong}', "");
    Expect(1, 127024, '\P{-_is_mahjong}', "");
    Expect(0, 127024, '\P{^-_is_mahjong}', "");
    Error('\p{:=-_IN_Mahjong}');
    Error('\P{:=-_IN_Mahjong}');
    Expect(1, 127023, '\p{inmahjong}', "");
    Expect(0, 127023, '\p{^inmahjong}', "");
    Expect(0, 127023, '\P{inmahjong}', "");
    Expect(1, 127023, '\P{^inmahjong}', "");
    Expect(0, 127024, '\p{inmahjong}', "");
    Expect(1, 127024, '\p{^inmahjong}', "");
    Expect(1, 127024, '\P{inmahjong}', "");
    Expect(0, 127024, '\P{^inmahjong}', "");
    Expect(1, 127023, '\p{		In_Mahjong}', "");
    Expect(0, 127023, '\p{^		In_Mahjong}', "");
    Expect(0, 127023, '\P{		In_Mahjong}', "");
    Expect(1, 127023, '\P{^		In_Mahjong}', "");
    Expect(0, 127024, '\p{		In_Mahjong}', "");
    Expect(1, 127024, '\p{^		In_Mahjong}', "");
    Expect(1, 127024, '\P{		In_Mahjong}', "");
    Expect(0, 127024, '\P{^		In_Mahjong}', "");
    Error('\p{ :=Malayalam}');
    Error('\P{ :=Malayalam}');
    Expect(1, 7386, '\p{malayalam}', "");
    Expect(0, 7386, '\p{^malayalam}', "");
    Expect(0, 7386, '\P{malayalam}', "");
    Expect(1, 7386, '\P{^malayalam}', "");
    Expect(0, 7387, '\p{malayalam}', "");
    Expect(1, 7387, '\p{^malayalam}', "");
    Expect(1, 7387, '\P{malayalam}', "");
    Expect(0, 7387, '\P{^malayalam}', "");
    Expect(1, 7386, '\p{ Malayalam}', "");
    Expect(0, 7386, '\p{^ Malayalam}', "");
    Expect(0, 7386, '\P{ Malayalam}', "");
    Expect(1, 7386, '\P{^ Malayalam}', "");
    Expect(0, 7387, '\p{ Malayalam}', "");
    Expect(1, 7387, '\p{^ Malayalam}', "");
    Expect(1, 7387, '\P{ Malayalam}', "");
    Expect(0, 7387, '\P{^ Malayalam}', "");
    Error('\p{__is_Malayalam/a/}');
    Error('\P{__is_Malayalam/a/}');
    Expect(1, 7386, '\p{ismalayalam}', "");
    Expect(0, 7386, '\p{^ismalayalam}', "");
    Expect(0, 7386, '\P{ismalayalam}', "");
    Expect(1, 7386, '\P{^ismalayalam}', "");
    Expect(0, 7387, '\p{ismalayalam}', "");
    Expect(1, 7387, '\p{^ismalayalam}', "");
    Expect(1, 7387, '\P{ismalayalam}', "");
    Expect(0, 7387, '\P{^ismalayalam}', "");
    Expect(1, 7386, '\p{ is_MALAYALAM}', "");
    Expect(0, 7386, '\p{^ is_MALAYALAM}', "");
    Expect(0, 7386, '\P{ is_MALAYALAM}', "");
    Expect(1, 7386, '\P{^ is_MALAYALAM}', "");
    Expect(0, 7387, '\p{ is_MALAYALAM}', "");
    Expect(1, 7387, '\p{^ is_MALAYALAM}', "");
    Expect(1, 7387, '\P{ is_MALAYALAM}', "");
    Expect(0, 7387, '\P{^ is_MALAYALAM}', "");
    Error('\p{:=_ Mlym}');
    Error('\P{:=_ Mlym}');
    Expect(1, 7386, '\p{mlym}', "");
    Expect(0, 7386, '\p{^mlym}', "");
    Expect(0, 7386, '\P{mlym}', "");
    Expect(1, 7386, '\P{^mlym}', "");
    Expect(0, 7387, '\p{mlym}', "");
    Expect(1, 7387, '\p{^mlym}', "");
    Expect(1, 7387, '\P{mlym}', "");
    Expect(0, 7387, '\P{^mlym}', "");
    Expect(1, 7386, '\p{ _MLYM}', "");
    Expect(0, 7386, '\p{^ _MLYM}', "");
    Expect(0, 7386, '\P{ _MLYM}', "");
    Expect(1, 7386, '\P{^ _MLYM}', "");
    Expect(0, 7387, '\p{ _MLYM}', "");
    Expect(1, 7387, '\p{^ _MLYM}', "");
    Expect(1, 7387, '\P{ _MLYM}', "");
    Expect(0, 7387, '\P{^ _MLYM}', "");
    Error('\p{:= _IS_MLYM}');
    Error('\P{:= _IS_MLYM}');
    Expect(1, 7386, '\p{ismlym}', "");
    Expect(0, 7386, '\p{^ismlym}', "");
    Expect(0, 7386, '\P{ismlym}', "");
    Expect(1, 7386, '\P{^ismlym}', "");
    Expect(0, 7387, '\p{ismlym}', "");
    Expect(1, 7387, '\p{^ismlym}', "");
    Expect(1, 7387, '\P{ismlym}', "");
    Expect(0, 7387, '\P{^ismlym}', "");
    Expect(1, 7386, '\p{	 Is_Mlym}', "");
    Expect(0, 7386, '\p{^	 Is_Mlym}', "");
    Expect(0, 7386, '\P{	 Is_Mlym}', "");
    Expect(1, 7386, '\P{^	 Is_Mlym}', "");
    Expect(0, 7387, '\p{	 Is_Mlym}', "");
    Expect(1, 7387, '\p{^	 Is_Mlym}', "");
    Expect(1, 7387, '\P{	 Is_Mlym}', "");
    Expect(0, 7387, '\P{^	 Is_Mlym}', "");
    Error('\p{  Mandaic:=}');
    Error('\P{  Mandaic:=}');
    Expect(1, 2142, '\p{mandaic}', "");
    Expect(0, 2142, '\p{^mandaic}', "");
    Expect(0, 2142, '\P{mandaic}', "");
    Expect(1, 2142, '\P{^mandaic}', "");
    Expect(0, 2143, '\p{mandaic}', "");
    Expect(1, 2143, '\p{^mandaic}', "");
    Expect(1, 2143, '\P{mandaic}', "");
    Expect(0, 2143, '\P{^mandaic}', "");
    Expect(1, 2142, '\p{_mandaic}', "");
    Expect(0, 2142, '\p{^_mandaic}', "");
    Expect(0, 2142, '\P{_mandaic}', "");
    Expect(1, 2142, '\P{^_mandaic}', "");
    Expect(0, 2143, '\p{_mandaic}', "");
    Expect(1, 2143, '\p{^_mandaic}', "");
    Expect(1, 2143, '\P{_mandaic}', "");
    Expect(0, 2143, '\P{^_mandaic}', "");
    Error('\p{/a/ 	Is_Mandaic}');
    Error('\P{/a/ 	Is_Mandaic}');
    Expect(1, 2142, '\p{ismandaic}', "");
    Expect(0, 2142, '\p{^ismandaic}', "");
    Expect(0, 2142, '\P{ismandaic}', "");
    Expect(1, 2142, '\P{^ismandaic}', "");
    Expect(0, 2143, '\p{ismandaic}', "");
    Expect(1, 2143, '\p{^ismandaic}', "");
    Expect(1, 2143, '\P{ismandaic}', "");
    Expect(0, 2143, '\P{^ismandaic}', "");
    Expect(1, 2142, '\p{	IS_Mandaic}', "");
    Expect(0, 2142, '\p{^	IS_Mandaic}', "");
    Expect(0, 2142, '\P{	IS_Mandaic}', "");
    Expect(1, 2142, '\P{^	IS_Mandaic}', "");
    Expect(0, 2143, '\p{	IS_Mandaic}', "");
    Expect(1, 2143, '\p{^	IS_Mandaic}', "");
    Expect(1, 2143, '\P{	IS_Mandaic}', "");
    Expect(0, 2143, '\P{^	IS_Mandaic}', "");
    Error('\p{/a/	Mand}');
    Error('\P{/a/	Mand}');
    Expect(1, 2142, '\p{mand}', "");
    Expect(0, 2142, '\p{^mand}', "");
    Expect(0, 2142, '\P{mand}', "");
    Expect(1, 2142, '\P{^mand}', "");
    Expect(0, 2143, '\p{mand}', "");
    Expect(1, 2143, '\p{^mand}', "");
    Expect(1, 2143, '\P{mand}', "");
    Expect(0, 2143, '\P{^mand}', "");
    Expect(1, 2142, '\p{_-mand}', "");
    Expect(0, 2142, '\p{^_-mand}', "");
    Expect(0, 2142, '\P{_-mand}', "");
    Expect(1, 2142, '\P{^_-mand}', "");
    Expect(0, 2143, '\p{_-mand}', "");
    Expect(1, 2143, '\p{^_-mand}', "");
    Expect(1, 2143, '\P{_-mand}', "");
    Expect(0, 2143, '\P{^_-mand}', "");
    Error('\p{ /a/Is_Mand}');
    Error('\P{ /a/Is_Mand}');
    Expect(1, 2142, '\p{ismand}', "");
    Expect(0, 2142, '\p{^ismand}', "");
    Expect(0, 2142, '\P{ismand}', "");
    Expect(1, 2142, '\P{^ismand}', "");
    Expect(0, 2143, '\p{ismand}', "");
    Expect(1, 2143, '\p{^ismand}', "");
    Expect(1, 2143, '\P{ismand}', "");
    Expect(0, 2143, '\P{^ismand}', "");
    Expect(1, 2142, '\p{  IS_Mand}', "");
    Expect(0, 2142, '\p{^  IS_Mand}', "");
    Expect(0, 2142, '\P{  IS_Mand}', "");
    Expect(1, 2142, '\P{^  IS_Mand}', "");
    Expect(0, 2143, '\p{  IS_Mand}', "");
    Expect(1, 2143, '\p{^  IS_Mand}', "");
    Expect(1, 2143, '\P{  IS_Mand}', "");
    Expect(0, 2143, '\P{^  IS_Mand}', "");
    Error('\p{-:=Manichaean}');
    Error('\P{-:=Manichaean}');
    Expect(1, 68342, '\p{manichaean}', "");
    Expect(0, 68342, '\p{^manichaean}', "");
    Expect(0, 68342, '\P{manichaean}', "");
    Expect(1, 68342, '\P{^manichaean}', "");
    Expect(0, 68343, '\p{manichaean}', "");
    Expect(1, 68343, '\p{^manichaean}', "");
    Expect(1, 68343, '\P{manichaean}', "");
    Expect(0, 68343, '\P{^manichaean}', "");
    Expect(1, 68342, '\p{	manichaean}', "");
    Expect(0, 68342, '\p{^	manichaean}', "");
    Expect(0, 68342, '\P{	manichaean}', "");
    Expect(1, 68342, '\P{^	manichaean}', "");
    Expect(0, 68343, '\p{	manichaean}', "");
    Expect(1, 68343, '\p{^	manichaean}', "");
    Expect(1, 68343, '\P{	manichaean}', "");
    Expect(0, 68343, '\P{^	manichaean}', "");
    Error('\p{-/a/is_MANICHAEAN}');
    Error('\P{-/a/is_MANICHAEAN}');
    Expect(1, 68342, '\p{ismanichaean}', "");
    Expect(0, 68342, '\p{^ismanichaean}', "");
    Expect(0, 68342, '\P{ismanichaean}', "");
    Expect(1, 68342, '\P{^ismanichaean}', "");
    Expect(0, 68343, '\p{ismanichaean}', "");
    Expect(1, 68343, '\p{^ismanichaean}', "");
    Expect(1, 68343, '\P{ismanichaean}', "");
    Expect(0, 68343, '\P{^ismanichaean}', "");
    Expect(1, 68342, '\p{-_Is_MANICHAEAN}', "");
    Expect(0, 68342, '\p{^-_Is_MANICHAEAN}', "");
    Expect(0, 68342, '\P{-_Is_MANICHAEAN}', "");
    Expect(1, 68342, '\P{^-_Is_MANICHAEAN}', "");
    Expect(0, 68343, '\p{-_Is_MANICHAEAN}', "");
    Expect(1, 68343, '\p{^-_Is_MANICHAEAN}', "");
    Expect(1, 68343, '\P{-_Is_MANICHAEAN}', "");
    Expect(0, 68343, '\P{^-_Is_MANICHAEAN}', "");
    Error('\p{_:=mani}');
    Error('\P{_:=mani}');
    Expect(1, 68342, '\p{mani}', "");
    Expect(0, 68342, '\p{^mani}', "");
    Expect(0, 68342, '\P{mani}', "");
    Expect(1, 68342, '\P{^mani}', "");
    Expect(0, 68343, '\p{mani}', "");
    Expect(1, 68343, '\p{^mani}', "");
    Expect(1, 68343, '\P{mani}', "");
    Expect(0, 68343, '\P{^mani}', "");
    Expect(1, 68342, '\p{ Mani}', "");
    Expect(0, 68342, '\p{^ Mani}', "");
    Expect(0, 68342, '\P{ Mani}', "");
    Expect(1, 68342, '\P{^ Mani}', "");
    Expect(0, 68343, '\p{ Mani}', "");
    Expect(1, 68343, '\p{^ Mani}', "");
    Expect(1, 68343, '\P{ Mani}', "");
    Expect(0, 68343, '\P{^ Mani}', "");
    Error('\p{__IS_MANI:=}');
    Error('\P{__IS_MANI:=}');
    Expect(1, 68342, '\p{ismani}', "");
    Expect(0, 68342, '\p{^ismani}', "");
    Expect(0, 68342, '\P{ismani}', "");
    Expect(1, 68342, '\P{^ismani}', "");
    Expect(0, 68343, '\p{ismani}', "");
    Expect(1, 68343, '\p{^ismani}', "");
    Expect(1, 68343, '\P{ismani}', "");
    Expect(0, 68343, '\P{^ismani}', "");
    Expect(1, 68342, '\p{_	is_Mani}', "");
    Expect(0, 68342, '\p{^_	is_Mani}', "");
    Expect(0, 68342, '\P{_	is_Mani}', "");
    Expect(1, 68342, '\P{^_	is_Mani}', "");
    Expect(0, 68343, '\p{_	is_Mani}', "");
    Expect(1, 68343, '\p{^_	is_Mani}', "");
    Expect(1, 68343, '\P{_	is_Mani}', "");
    Expect(0, 68343, '\P{^_	is_Mani}', "");
    Error('\p{-/a/marchen}');
    Error('\P{-/a/marchen}');
    Expect(1, 72886, '\p{marchen}', "");
    Expect(0, 72886, '\p{^marchen}', "");
    Expect(0, 72886, '\P{marchen}', "");
    Expect(1, 72886, '\P{^marchen}', "");
    Expect(0, 72887, '\p{marchen}', "");
    Expect(1, 72887, '\p{^marchen}', "");
    Expect(1, 72887, '\P{marchen}', "");
    Expect(0, 72887, '\P{^marchen}', "");
    Error('\p{--Is_Marchen:=}');
    Error('\P{--Is_Marchen:=}');
    Expect(1, 72886, '\p{ismarchen}', "");
    Expect(0, 72886, '\p{^ismarchen}', "");
    Expect(0, 72886, '\P{ismarchen}', "");
    Expect(1, 72886, '\P{^ismarchen}', "");
    Expect(0, 72887, '\p{ismarchen}', "");
    Expect(1, 72887, '\p{^ismarchen}', "");
    Expect(1, 72887, '\P{ismarchen}', "");
    Expect(0, 72887, '\P{^ismarchen}', "");
    Expect(1, 72886, '\p{_	is_marchen}', "");
    Expect(0, 72886, '\p{^_	is_marchen}', "");
    Expect(0, 72886, '\P{_	is_marchen}', "");
    Expect(1, 72886, '\P{^_	is_marchen}', "");
    Expect(0, 72887, '\p{_	is_marchen}', "");
    Expect(1, 72887, '\p{^_	is_marchen}', "");
    Expect(1, 72887, '\P{_	is_marchen}', "");
    Expect(0, 72887, '\P{^_	is_marchen}', "");
    Error('\p{/a/-Marc}');
    Error('\P{/a/-Marc}');
    Expect(1, 72886, '\p{marc}', "");
    Expect(0, 72886, '\p{^marc}', "");
    Expect(0, 72886, '\P{marc}', "");
    Expect(1, 72886, '\P{^marc}', "");
    Expect(0, 72887, '\p{marc}', "");
    Expect(1, 72887, '\p{^marc}', "");
    Expect(1, 72887, '\P{marc}', "");
    Expect(0, 72887, '\P{^marc}', "");
    Expect(1, 72886, '\p{__MARC}', "");
    Expect(0, 72886, '\p{^__MARC}', "");
    Expect(0, 72886, '\P{__MARC}', "");
    Expect(1, 72886, '\P{^__MARC}', "");
    Expect(0, 72887, '\p{__MARC}', "");
    Expect(1, 72887, '\p{^__MARC}', "");
    Expect(1, 72887, '\P{__MARC}', "");
    Expect(0, 72887, '\P{^__MARC}', "");
    Error('\p{:=	Is_Marc}');
    Error('\P{:=	Is_Marc}');
    Expect(1, 72886, '\p{ismarc}', "");
    Expect(0, 72886, '\p{^ismarc}', "");
    Expect(0, 72886, '\P{ismarc}', "");
    Expect(1, 72886, '\P{^ismarc}', "");
    Expect(0, 72887, '\p{ismarc}', "");
    Expect(1, 72887, '\p{^ismarc}', "");
    Expect(1, 72887, '\P{ismarc}', "");
    Expect(0, 72887, '\P{^ismarc}', "");
    Expect(1, 72886, '\p{ 	Is_Marc}', "");
    Expect(0, 72886, '\p{^ 	Is_Marc}', "");
    Expect(0, 72886, '\P{ 	Is_Marc}', "");
    Expect(1, 72886, '\P{^ 	Is_Marc}', "");
    Expect(0, 72887, '\p{ 	Is_Marc}', "");
    Expect(1, 72887, '\p{^ 	Is_Marc}', "");
    Expect(1, 72887, '\P{ 	Is_Marc}', "");
    Expect(0, 72887, '\P{^ 	Is_Marc}', "");
    Error('\p{-/a/MARK}');
    Error('\P{-/a/MARK}');
    Expect(1, 917999, '\p{mark}', "");
    Expect(0, 917999, '\p{^mark}', "");
    Expect(0, 917999, '\P{mark}', "");
    Expect(1, 917999, '\P{^mark}', "");
    Expect(0, 918000, '\p{mark}', "");
    Expect(1, 918000, '\p{^mark}', "");
    Expect(1, 918000, '\P{mark}', "");
    Expect(0, 918000, '\P{^mark}', "");
    Expect(1, 917999, '\p{	mark}', "");
    Expect(0, 917999, '\p{^	mark}', "");
    Expect(0, 917999, '\P{	mark}', "");
    Expect(1, 917999, '\P{^	mark}', "");
    Expect(0, 918000, '\p{	mark}', "");
    Expect(1, 918000, '\p{^	mark}', "");
    Expect(1, 918000, '\P{	mark}', "");
    Expect(0, 918000, '\P{^	mark}', "");
    Error('\p{/a/ 	Is_Mark}');
    Error('\P{/a/ 	Is_Mark}');
    Expect(1, 917999, '\p{ismark}', "");
    Expect(0, 917999, '\p{^ismark}', "");
    Expect(0, 917999, '\P{ismark}', "");
    Expect(1, 917999, '\P{^ismark}', "");
    Expect(0, 918000, '\p{ismark}', "");
    Expect(1, 918000, '\p{^ismark}', "");
    Expect(1, 918000, '\P{ismark}', "");
    Expect(0, 918000, '\P{^ismark}', "");
    Expect(1, 917999, '\p{  IS_MARK}', "");
    Expect(0, 917999, '\p{^  IS_MARK}', "");
    Expect(0, 917999, '\P{  IS_MARK}', "");
    Expect(1, 917999, '\P{^  IS_MARK}', "");
    Expect(0, 918000, '\p{  IS_MARK}', "");
    Expect(1, 918000, '\p{^  IS_MARK}', "");
    Expect(1, 918000, '\P{  IS_MARK}', "");
    Expect(0, 918000, '\P{^  IS_MARK}', "");
    Error('\p{	 m/a/}');
    Error('\P{	 m/a/}');
    Expect(1, 917999, '\p{m}', "");
    Expect(0, 917999, '\p{^m}', "");
    Expect(0, 917999, '\P{m}', "");
    Expect(1, 917999, '\P{^m}', "");
    Expect(0, 918000, '\p{m}', "");
    Expect(1, 918000, '\p{^m}', "");
    Expect(1, 918000, '\P{m}', "");
    Expect(0, 918000, '\P{^m}', "");
    Expect(1, 917999, '\p{ M}', "");
    Expect(0, 917999, '\p{^ M}', "");
    Expect(0, 917999, '\P{ M}', "");
    Expect(1, 917999, '\P{^ M}', "");
    Expect(0, 918000, '\p{ M}', "");
    Expect(1, 918000, '\p{^ M}', "");
    Expect(1, 918000, '\P{ M}', "");
    Expect(0, 918000, '\P{^ M}', "");
    Error('\p{/a/	Is_M}');
    Error('\P{/a/	Is_M}');
    Expect(1, 917999, '\p{ism}', "");
    Expect(0, 917999, '\p{^ism}', "");
    Expect(0, 917999, '\P{ism}', "");
    Expect(1, 917999, '\P{^ism}', "");
    Expect(0, 918000, '\p{ism}', "");
    Expect(1, 918000, '\p{^ism}', "");
    Expect(1, 918000, '\P{ism}', "");
    Expect(0, 918000, '\P{^ism}', "");
    Expect(1, 917999, '\p{  is_m}', "");
    Expect(0, 917999, '\p{^  is_m}', "");
    Expect(0, 917999, '\P{  is_m}', "");
    Expect(1, 917999, '\P{^  is_m}', "");
    Expect(0, 918000, '\p{  is_m}', "");
    Expect(1, 918000, '\p{^  is_m}', "");
    Expect(1, 918000, '\P{  is_m}', "");
    Expect(0, 918000, '\P{^  is_m}', "");
    Error('\p{Combining_MARK:=}');
    Error('\P{Combining_MARK:=}');
    Expect(1, 917999, '\p{combiningmark}', "");
    Expect(0, 917999, '\p{^combiningmark}', "");
    Expect(0, 917999, '\P{combiningmark}', "");
    Expect(1, 917999, '\P{^combiningmark}', "");
    Expect(0, 918000, '\p{combiningmark}', "");
    Expect(1, 918000, '\p{^combiningmark}', "");
    Expect(1, 918000, '\P{combiningmark}', "");
    Expect(0, 918000, '\P{^combiningmark}', "");
    Expect(1, 917999, '\p{	combining_mark}', "");
    Expect(0, 917999, '\p{^	combining_mark}', "");
    Expect(0, 917999, '\P{	combining_mark}', "");
    Expect(1, 917999, '\P{^	combining_mark}', "");
    Expect(0, 918000, '\p{	combining_mark}', "");
    Expect(1, 918000, '\p{^	combining_mark}', "");
    Expect(1, 918000, '\P{	combining_mark}', "");
    Expect(0, 918000, '\P{^	combining_mark}', "");
    Error('\p{/a/Is_Combining_Mark}');
    Error('\P{/a/Is_Combining_Mark}');
    Expect(1, 917999, '\p{iscombiningmark}', "");
    Expect(0, 917999, '\p{^iscombiningmark}', "");
    Expect(0, 917999, '\P{iscombiningmark}', "");
    Expect(1, 917999, '\P{^iscombiningmark}', "");
    Expect(0, 918000, '\p{iscombiningmark}', "");
    Expect(1, 918000, '\p{^iscombiningmark}', "");
    Expect(1, 918000, '\P{iscombiningmark}', "");
    Expect(0, 918000, '\P{^iscombiningmark}', "");
    Expect(1, 917999, '\p{-	Is_COMBINING_mark}', "");
    Expect(0, 917999, '\p{^-	Is_COMBINING_mark}', "");
    Expect(0, 917999, '\P{-	Is_COMBINING_mark}', "");
    Expect(1, 917999, '\P{^-	Is_COMBINING_mark}', "");
    Expect(0, 918000, '\p{-	Is_COMBINING_mark}', "");
    Expect(1, 918000, '\p{^-	Is_COMBINING_mark}', "");
    Expect(1, 918000, '\P{-	Is_COMBINING_mark}', "");
    Expect(0, 918000, '\P{^-	Is_COMBINING_mark}', "");
    Error('\p{ _masaram_Gondi/a/}');
    Error('\P{ _masaram_Gondi/a/}');
    Expect(1, 73049, '\p{masaramgondi}', "");
    Expect(0, 73049, '\p{^masaramgondi}', "");
    Expect(0, 73049, '\P{masaramgondi}', "");
    Expect(1, 73049, '\P{^masaramgondi}', "");
    Expect(0, 73050, '\p{masaramgondi}', "");
    Expect(1, 73050, '\p{^masaramgondi}', "");
    Expect(1, 73050, '\P{masaramgondi}', "");
    Expect(0, 73050, '\P{^masaramgondi}', "");
    Expect(1, 73049, '\p{-_masaram_Gondi}', "");
    Expect(0, 73049, '\p{^-_masaram_Gondi}', "");
    Expect(0, 73049, '\P{-_masaram_Gondi}', "");
    Expect(1, 73049, '\P{^-_masaram_Gondi}', "");
    Expect(0, 73050, '\p{-_masaram_Gondi}', "");
    Expect(1, 73050, '\p{^-_masaram_Gondi}', "");
    Expect(1, 73050, '\P{-_masaram_Gondi}', "");
    Expect(0, 73050, '\P{^-_masaram_Gondi}', "");
    Error('\p{	_Is_Masaram_gondi/a/}');
    Error('\P{	_Is_Masaram_gondi/a/}');
    Expect(1, 73049, '\p{ismasaramgondi}', "");
    Expect(0, 73049, '\p{^ismasaramgondi}', "");
    Expect(0, 73049, '\P{ismasaramgondi}', "");
    Expect(1, 73049, '\P{^ismasaramgondi}', "");
    Expect(0, 73050, '\p{ismasaramgondi}', "");
    Expect(1, 73050, '\p{^ismasaramgondi}', "");
    Expect(1, 73050, '\P{ismasaramgondi}', "");
    Expect(0, 73050, '\P{^ismasaramgondi}', "");
    Expect(1, 73049, '\p{-	is_masaram_Gondi}', "");
    Expect(0, 73049, '\p{^-	is_masaram_Gondi}', "");
    Expect(0, 73049, '\P{-	is_masaram_Gondi}', "");
    Expect(1, 73049, '\P{^-	is_masaram_Gondi}', "");
    Expect(0, 73050, '\p{-	is_masaram_Gondi}', "");
    Expect(1, 73050, '\p{^-	is_masaram_Gondi}', "");
    Expect(1, 73050, '\P{-	is_masaram_Gondi}', "");
    Expect(0, 73050, '\P{^-	is_masaram_Gondi}', "");
    Error('\p{-	gonm/a/}');
    Error('\P{-	gonm/a/}');
    Expect(1, 73049, '\p{gonm}', "");
    Expect(0, 73049, '\p{^gonm}', "");
    Expect(0, 73049, '\P{gonm}', "");
    Expect(1, 73049, '\P{^gonm}', "");
    Expect(0, 73050, '\p{gonm}', "");
    Expect(1, 73050, '\p{^gonm}', "");
    Expect(1, 73050, '\P{gonm}', "");
    Expect(0, 73050, '\P{^gonm}', "");
    Expect(1, 73049, '\p{ _gonm}', "");
    Expect(0, 73049, '\p{^ _gonm}', "");
    Expect(0, 73049, '\P{ _gonm}', "");
    Expect(1, 73049, '\P{^ _gonm}', "");
    Expect(0, 73050, '\p{ _gonm}', "");
    Expect(1, 73050, '\p{^ _gonm}', "");
    Expect(1, 73050, '\P{ _gonm}', "");
    Expect(0, 73050, '\P{^ _gonm}', "");
    Error('\p{:=-_Is_Gonm}');
    Error('\P{:=-_Is_Gonm}');
    Expect(1, 73049, '\p{isgonm}', "");
    Expect(0, 73049, '\p{^isgonm}', "");
    Expect(0, 73049, '\P{isgonm}', "");
    Expect(1, 73049, '\P{^isgonm}', "");
    Expect(0, 73050, '\p{isgonm}', "");
    Expect(1, 73050, '\p{^isgonm}', "");
    Expect(1, 73050, '\P{isgonm}', "");
    Expect(0, 73050, '\P{^isgonm}', "");
    Expect(1, 73049, '\p{-IS_Gonm}', "");
    Expect(0, 73049, '\p{^-IS_Gonm}', "");
    Expect(0, 73049, '\P{-IS_Gonm}', "");
    Expect(1, 73049, '\P{^-IS_Gonm}', "");
    Expect(0, 73050, '\p{-IS_Gonm}', "");
    Expect(1, 73050, '\p{^-IS_Gonm}', "");
    Expect(1, 73050, '\P{-IS_Gonm}', "");
    Expect(0, 73050, '\P{^-IS_Gonm}', "");
    Error('\p{:=	MATH}');
    Error('\P{:=	MATH}');
    Expect(1, 126705, '\p{math}', "");
    Expect(0, 126705, '\p{^math}', "");
    Expect(0, 126705, '\P{math}', "");
    Expect(1, 126705, '\P{^math}', "");
    Expect(0, 126706, '\p{math}', "");
    Expect(1, 126706, '\p{^math}', "");
    Expect(1, 126706, '\P{math}', "");
    Expect(0, 126706, '\P{^math}', "");
    Expect(1, 126705, '\p{_-Math}', "");
    Expect(0, 126705, '\p{^_-Math}', "");
    Expect(0, 126705, '\P{_-Math}', "");
    Expect(1, 126705, '\P{^_-Math}', "");
    Expect(0, 126706, '\p{_-Math}', "");
    Expect(1, 126706, '\p{^_-Math}', "");
    Expect(1, 126706, '\P{_-Math}', "");
    Expect(0, 126706, '\P{^_-Math}', "");
    Error('\p{/a/ IS_Math}');
    Error('\P{/a/ IS_Math}');
    Expect(1, 126705, '\p{ismath}', "");
    Expect(0, 126705, '\p{^ismath}', "");
    Expect(0, 126705, '\P{ismath}', "");
    Expect(1, 126705, '\P{^ismath}', "");
    Expect(0, 126706, '\p{ismath}', "");
    Expect(1, 126706, '\p{^ismath}', "");
    Expect(1, 126706, '\P{ismath}', "");
    Expect(0, 126706, '\P{^ismath}', "");
    Expect(1, 126705, '\p{ -Is_Math}', "");
    Expect(0, 126705, '\p{^ -Is_Math}', "");
    Expect(0, 126705, '\P{ -Is_Math}', "");
    Expect(1, 126705, '\P{^ -Is_Math}', "");
    Expect(0, 126706, '\p{ -Is_Math}', "");
    Expect(1, 126706, '\p{^ -Is_Math}', "");
    Expect(1, 126706, '\P{ -Is_Math}', "");
    Expect(0, 126706, '\P{^ -Is_Math}', "");
    Error('\p{:=_MATH_Symbol}');
    Error('\P{:=_MATH_Symbol}');
    Expect(1, 126705, '\p{mathsymbol}', "");
    Expect(0, 126705, '\p{^mathsymbol}', "");
    Expect(0, 126705, '\P{mathsymbol}', "");
    Expect(1, 126705, '\P{^mathsymbol}', "");
    Expect(0, 126706, '\p{mathsymbol}', "");
    Expect(1, 126706, '\p{^mathsymbol}', "");
    Expect(1, 126706, '\P{mathsymbol}', "");
    Expect(0, 126706, '\P{^mathsymbol}', "");
    Expect(1, 126705, '\p{_	Math_Symbol}', "");
    Expect(0, 126705, '\p{^_	Math_Symbol}', "");
    Expect(0, 126705, '\P{_	Math_Symbol}', "");
    Expect(1, 126705, '\P{^_	Math_Symbol}', "");
    Expect(0, 126706, '\p{_	Math_Symbol}', "");
    Expect(1, 126706, '\p{^_	Math_Symbol}', "");
    Expect(1, 126706, '\P{_	Math_Symbol}', "");
    Expect(0, 126706, '\P{^_	Math_Symbol}', "");
    Error('\p{:=-Is_math_SYMBOL}');
    Error('\P{:=-Is_math_SYMBOL}');
    Expect(1, 126705, '\p{ismathsymbol}', "");
    Expect(0, 126705, '\p{^ismathsymbol}', "");
    Expect(0, 126705, '\P{ismathsymbol}', "");
    Expect(1, 126705, '\P{^ismathsymbol}', "");
    Expect(0, 126706, '\p{ismathsymbol}', "");
    Expect(1, 126706, '\p{^ismathsymbol}', "");
    Expect(1, 126706, '\P{ismathsymbol}', "");
    Expect(0, 126706, '\P{^ismathsymbol}', "");
    Expect(1, 126705, '\p{_is_MATH_SYMBOL}', "");
    Expect(0, 126705, '\p{^_is_MATH_SYMBOL}', "");
    Expect(0, 126705, '\P{_is_MATH_SYMBOL}', "");
    Expect(1, 126705, '\P{^_is_MATH_SYMBOL}', "");
    Expect(0, 126706, '\p{_is_MATH_SYMBOL}', "");
    Expect(1, 126706, '\p{^_is_MATH_SYMBOL}', "");
    Expect(1, 126706, '\P{_is_MATH_SYMBOL}', "");
    Expect(0, 126706, '\P{^_is_MATH_SYMBOL}', "");
    Error('\p{ 	Sm/a/}');
    Error('\P{ 	Sm/a/}');
    Expect(1, 126705, '\p{sm}', "");
    Expect(0, 126705, '\p{^sm}', "");
    Expect(0, 126705, '\P{sm}', "");
    Expect(1, 126705, '\P{^sm}', "");
    Expect(0, 126706, '\p{sm}', "");
    Expect(1, 126706, '\p{^sm}', "");
    Expect(1, 126706, '\P{sm}', "");
    Expect(0, 126706, '\P{^sm}', "");
    Expect(1, 126705, '\p{ -Sm}', "");
    Expect(0, 126705, '\p{^ -Sm}', "");
    Expect(0, 126705, '\P{ -Sm}', "");
    Expect(1, 126705, '\P{^ -Sm}', "");
    Expect(0, 126706, '\p{ -Sm}', "");
    Expect(1, 126706, '\p{^ -Sm}', "");
    Expect(1, 126706, '\P{ -Sm}', "");
    Expect(0, 126706, '\P{^ -Sm}', "");
    Error('\p{:=--is_Sm}');
    Error('\P{:=--is_Sm}');
    Expect(1, 126705, '\p{issm}', "");
    Expect(0, 126705, '\p{^issm}', "");
    Expect(0, 126705, '\P{issm}', "");
    Expect(1, 126705, '\P{^issm}', "");
    Expect(0, 126706, '\p{issm}', "");
    Expect(1, 126706, '\p{^issm}', "");
    Expect(1, 126706, '\P{issm}', "");
    Expect(0, 126706, '\P{^issm}', "");
    Expect(1, 126705, '\p{		Is_SM}', "");
    Expect(0, 126705, '\p{^		Is_SM}', "");
    Expect(0, 126705, '\P{		Is_SM}', "");
    Expect(1, 126705, '\P{^		Is_SM}', "");
    Expect(0, 126706, '\p{		Is_SM}', "");
    Expect(1, 126706, '\p{^		Is_SM}', "");
    Expect(1, 126706, '\P{		Is_SM}', "");
    Expect(0, 126706, '\P{^		Is_SM}', "");
    Error('\p{	Mathematical_ALPHANUMERIC_symbols:=}');
    Error('\P{	Mathematical_ALPHANUMERIC_symbols:=}');
    Expect(1, 120831, '\p{mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\p{^mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\P{mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\P{^mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\p{mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\p{^mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\P{mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\P{^mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\p{_MATHEMATICAL_alphanumeric_Symbols}', "");
    Expect(0, 120831, '\p{^_MATHEMATICAL_alphanumeric_Symbols}', "");
    Expect(0, 120831, '\P{_MATHEMATICAL_alphanumeric_Symbols}', "");
    Expect(1, 120831, '\P{^_MATHEMATICAL_alphanumeric_Symbols}', "");
    Expect(0, 120832, '\p{_MATHEMATICAL_alphanumeric_Symbols}', "");
    Expect(1, 120832, '\p{^_MATHEMATICAL_alphanumeric_Symbols}', "");
    Expect(1, 120832, '\P{_MATHEMATICAL_alphanumeric_Symbols}', "");
    Expect(0, 120832, '\P{^_MATHEMATICAL_alphanumeric_Symbols}', "");
    Error('\p{/a/	-Is_Mathematical_Alphanumeric_SYMBOLS}');
    Error('\P{/a/	-Is_Mathematical_Alphanumeric_SYMBOLS}');
    Expect(1, 120831, '\p{ismathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\p{^ismathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\P{ismathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\P{^ismathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\p{ismathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\p{^ismathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\P{ismathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\P{^ismathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\p{-_Is_Mathematical_alphanumeric_Symbols}', "");
    Expect(0, 120831, '\p{^-_Is_Mathematical_alphanumeric_Symbols}', "");
    Expect(0, 120831, '\P{-_Is_Mathematical_alphanumeric_Symbols}', "");
    Expect(1, 120831, '\P{^-_Is_Mathematical_alphanumeric_Symbols}', "");
    Expect(0, 120832, '\p{-_Is_Mathematical_alphanumeric_Symbols}', "");
    Expect(1, 120832, '\p{^-_Is_Mathematical_alphanumeric_Symbols}', "");
    Expect(1, 120832, '\P{-_Is_Mathematical_alphanumeric_Symbols}', "");
    Expect(0, 120832, '\P{^-_Is_Mathematical_alphanumeric_Symbols}', "");
    Error('\p{_In_MATHEMATICAL_Alphanumeric_Symbols/a/}');
    Error('\P{_In_MATHEMATICAL_Alphanumeric_Symbols/a/}');
    Expect(1, 120831, '\p{inmathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\p{^inmathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\P{inmathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\P{^inmathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\p{inmathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\p{^inmathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\P{inmathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\P{^inmathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\p{_ in_Mathematical_alphanumeric_symbols}', "");
    Expect(0, 120831, '\p{^_ in_Mathematical_alphanumeric_symbols}', "");
    Expect(0, 120831, '\P{_ in_Mathematical_alphanumeric_symbols}', "");
    Expect(1, 120831, '\P{^_ in_Mathematical_alphanumeric_symbols}', "");
    Expect(0, 120832, '\p{_ in_Mathematical_alphanumeric_symbols}', "");
    Expect(1, 120832, '\p{^_ in_Mathematical_alphanumeric_symbols}', "");
    Expect(1, 120832, '\P{_ in_Mathematical_alphanumeric_symbols}', "");
    Expect(0, 120832, '\P{^_ in_Mathematical_alphanumeric_symbols}', "");
    Error('\p{	/a/Math_Alphanum}');
    Error('\P{	/a/Math_Alphanum}');
    Expect(1, 120831, '\p{mathalphanum}', "");
    Expect(0, 120831, '\p{^mathalphanum}', "");
    Expect(0, 120831, '\P{mathalphanum}', "");
    Expect(1, 120831, '\P{^mathalphanum}', "");
    Expect(0, 120832, '\p{mathalphanum}', "");
    Expect(1, 120832, '\p{^mathalphanum}', "");
    Expect(1, 120832, '\P{mathalphanum}', "");
    Expect(0, 120832, '\P{^mathalphanum}', "");
    Expect(1, 120831, '\p{ MATH_Alphanum}', "");
    Expect(0, 120831, '\p{^ MATH_Alphanum}', "");
    Expect(0, 120831, '\P{ MATH_Alphanum}', "");
    Expect(1, 120831, '\P{^ MATH_Alphanum}', "");
    Expect(0, 120832, '\p{ MATH_Alphanum}', "");
    Expect(1, 120832, '\p{^ MATH_Alphanum}', "");
    Expect(1, 120832, '\P{ MATH_Alphanum}', "");
    Expect(0, 120832, '\P{^ MATH_Alphanum}', "");
    Error('\p{_ IS_Math_Alphanum/a/}');
    Error('\P{_ IS_Math_Alphanum/a/}');
    Expect(1, 120831, '\p{ismathalphanum}', "");
    Expect(0, 120831, '\p{^ismathalphanum}', "");
    Expect(0, 120831, '\P{ismathalphanum}', "");
    Expect(1, 120831, '\P{^ismathalphanum}', "");
    Expect(0, 120832, '\p{ismathalphanum}', "");
    Expect(1, 120832, '\p{^ismathalphanum}', "");
    Expect(1, 120832, '\P{ismathalphanum}', "");
    Expect(0, 120832, '\P{^ismathalphanum}', "");
    Expect(1, 120831, '\p{__Is_math_Alphanum}', "");
    Expect(0, 120831, '\p{^__Is_math_Alphanum}', "");
    Expect(0, 120831, '\P{__Is_math_Alphanum}', "");
    Expect(1, 120831, '\P{^__Is_math_Alphanum}', "");
    Expect(0, 120832, '\p{__Is_math_Alphanum}', "");
    Expect(1, 120832, '\p{^__Is_math_Alphanum}', "");
    Expect(1, 120832, '\P{__Is_math_Alphanum}', "");
    Expect(0, 120832, '\P{^__Is_math_Alphanum}', "");
    Error('\p{_In_Math_Alphanum/a/}');
    Error('\P{_In_Math_Alphanum/a/}');
    Expect(1, 120831, '\p{inmathalphanum}', "");
    Expect(0, 120831, '\p{^inmathalphanum}', "");
    Expect(0, 120831, '\P{inmathalphanum}', "");
    Expect(1, 120831, '\P{^inmathalphanum}', "");
    Expect(0, 120832, '\p{inmathalphanum}', "");
    Expect(1, 120832, '\p{^inmathalphanum}', "");
    Expect(1, 120832, '\P{inmathalphanum}', "");
    Expect(0, 120832, '\P{^inmathalphanum}', "");
    Expect(1, 120831, '\p{	IN_MATH_Alphanum}', "");
    Expect(0, 120831, '\p{^	IN_MATH_Alphanum}', "");
    Expect(0, 120831, '\P{	IN_MATH_Alphanum}', "");
    Expect(1, 120831, '\P{^	IN_MATH_Alphanum}', "");
    Expect(0, 120832, '\p{	IN_MATH_Alphanum}', "");
    Expect(1, 120832, '\p{^	IN_MATH_Alphanum}', "");
    Expect(1, 120832, '\P{	IN_MATH_Alphanum}', "");
    Expect(0, 120832, '\P{^	IN_MATH_Alphanum}', "");
    Error('\p{/a/ _mathematical_operators}');
    Error('\P{/a/ _mathematical_operators}');
    Expect(1, 8959, '\p{mathematicaloperators}', "");
    Expect(0, 8959, '\p{^mathematicaloperators}', "");
    Expect(0, 8959, '\P{mathematicaloperators}', "");
    Expect(1, 8959, '\P{^mathematicaloperators}', "");
    Expect(0, 8960, '\p{mathematicaloperators}', "");
    Expect(1, 8960, '\p{^mathematicaloperators}', "");
    Expect(1, 8960, '\P{mathematicaloperators}', "");
    Expect(0, 8960, '\P{^mathematicaloperators}', "");
    Expect(1, 8959, '\p{	 Mathematical_Operators}', "");
    Expect(0, 8959, '\p{^	 Mathematical_Operators}', "");
    Expect(0, 8959, '\P{	 Mathematical_Operators}', "");
    Expect(1, 8959, '\P{^	 Mathematical_Operators}', "");
    Expect(0, 8960, '\p{	 Mathematical_Operators}', "");
    Expect(1, 8960, '\p{^	 Mathematical_Operators}', "");
    Expect(1, 8960, '\P{	 Mathematical_Operators}', "");
    Expect(0, 8960, '\P{^	 Mathematical_Operators}', "");
    Error('\p{/a/	IS_MATHEMATICAL_Operators}');
    Error('\P{/a/	IS_MATHEMATICAL_Operators}');
    Expect(1, 8959, '\p{ismathematicaloperators}', "");
    Expect(0, 8959, '\p{^ismathematicaloperators}', "");
    Expect(0, 8959, '\P{ismathematicaloperators}', "");
    Expect(1, 8959, '\P{^ismathematicaloperators}', "");
    Expect(0, 8960, '\p{ismathematicaloperators}', "");
    Expect(1, 8960, '\p{^ismathematicaloperators}', "");
    Expect(1, 8960, '\P{ismathematicaloperators}', "");
    Expect(0, 8960, '\P{^ismathematicaloperators}', "");
    Expect(1, 8959, '\p{_Is_Mathematical_OPERATORS}', "");
    Expect(0, 8959, '\p{^_Is_Mathematical_OPERATORS}', "");
    Expect(0, 8959, '\P{_Is_Mathematical_OPERATORS}', "");
    Expect(1, 8959, '\P{^_Is_Mathematical_OPERATORS}', "");
    Expect(0, 8960, '\p{_Is_Mathematical_OPERATORS}', "");
    Expect(1, 8960, '\p{^_Is_Mathematical_OPERATORS}', "");
    Expect(1, 8960, '\P{_Is_Mathematical_OPERATORS}', "");
    Expect(0, 8960, '\P{^_Is_Mathematical_OPERATORS}', "");
    Error('\p{/a/	In_Mathematical_OPERATORS}');
    Error('\P{/a/	In_Mathematical_OPERATORS}');
    Expect(1, 8959, '\p{inmathematicaloperators}', "");
    Expect(0, 8959, '\p{^inmathematicaloperators}', "");
    Expect(0, 8959, '\P{inmathematicaloperators}', "");
    Expect(1, 8959, '\P{^inmathematicaloperators}', "");
    Expect(0, 8960, '\p{inmathematicaloperators}', "");
    Expect(1, 8960, '\p{^inmathematicaloperators}', "");
    Expect(1, 8960, '\P{inmathematicaloperators}', "");
    Expect(0, 8960, '\P{^inmathematicaloperators}', "");
    Expect(1, 8959, '\p{  in_Mathematical_operators}', "");
    Expect(0, 8959, '\p{^  in_Mathematical_operators}', "");
    Expect(0, 8959, '\P{  in_Mathematical_operators}', "");
    Expect(1, 8959, '\P{^  in_Mathematical_operators}', "");
    Expect(0, 8960, '\p{  in_Mathematical_operators}', "");
    Expect(1, 8960, '\p{^  in_Mathematical_operators}', "");
    Expect(1, 8960, '\P{  in_Mathematical_operators}', "");
    Expect(0, 8960, '\P{^  in_Mathematical_operators}', "");
    Error('\p{-/a/Math_Operators}');
    Error('\P{-/a/Math_Operators}');
    Expect(1, 8959, '\p{mathoperators}', "");
    Expect(0, 8959, '\p{^mathoperators}', "");
    Expect(0, 8959, '\P{mathoperators}', "");
    Expect(1, 8959, '\P{^mathoperators}', "");
    Expect(0, 8960, '\p{mathoperators}', "");
    Expect(1, 8960, '\p{^mathoperators}', "");
    Expect(1, 8960, '\P{mathoperators}', "");
    Expect(0, 8960, '\P{^mathoperators}', "");
    Expect(1, 8959, '\p{ 	Math_Operators}', "");
    Expect(0, 8959, '\p{^ 	Math_Operators}', "");
    Expect(0, 8959, '\P{ 	Math_Operators}', "");
    Expect(1, 8959, '\P{^ 	Math_Operators}', "");
    Expect(0, 8960, '\p{ 	Math_Operators}', "");
    Expect(1, 8960, '\p{^ 	Math_Operators}', "");
    Expect(1, 8960, '\P{ 	Math_Operators}', "");
    Expect(0, 8960, '\P{^ 	Math_Operators}', "");
    Error('\p{ Is_Math_operators/a/}');
    Error('\P{ Is_Math_operators/a/}');
    Expect(1, 8959, '\p{ismathoperators}', "");
    Expect(0, 8959, '\p{^ismathoperators}', "");
    Expect(0, 8959, '\P{ismathoperators}', "");
    Expect(1, 8959, '\P{^ismathoperators}', "");
    Expect(0, 8960, '\p{ismathoperators}', "");
    Expect(1, 8960, '\p{^ismathoperators}', "");
    Expect(1, 8960, '\P{ismathoperators}', "");
    Expect(0, 8960, '\P{^ismathoperators}', "");
    Expect(1, 8959, '\p{ Is_Math_Operators}', "");
    Expect(0, 8959, '\p{^ Is_Math_Operators}', "");
    Expect(0, 8959, '\P{ Is_Math_Operators}', "");
    Expect(1, 8959, '\P{^ Is_Math_Operators}', "");
    Expect(0, 8960, '\p{ Is_Math_Operators}', "");
    Expect(1, 8960, '\p{^ Is_Math_Operators}', "");
    Expect(1, 8960, '\P{ Is_Math_Operators}', "");
    Expect(0, 8960, '\P{^ Is_Math_Operators}', "");
    Error('\p{	-In_math_OPERATORS:=}');
    Error('\P{	-In_math_OPERATORS:=}');
    Expect(1, 8959, '\p{inmathoperators}', "");
    Expect(0, 8959, '\p{^inmathoperators}', "");
    Expect(0, 8959, '\P{inmathoperators}', "");
    Expect(1, 8959, '\P{^inmathoperators}', "");
    Expect(0, 8960, '\p{inmathoperators}', "");
    Expect(1, 8960, '\p{^inmathoperators}', "");
    Expect(1, 8960, '\P{inmathoperators}', "");
    Expect(0, 8960, '\P{^inmathoperators}', "");
    Expect(1, 8959, '\p{	In_math_Operators}', "");
    Expect(0, 8959, '\p{^	In_math_Operators}', "");
    Expect(0, 8959, '\P{	In_math_Operators}', "");
    Expect(1, 8959, '\P{^	In_math_Operators}', "");
    Expect(0, 8960, '\p{	In_math_Operators}', "");
    Expect(1, 8960, '\p{^	In_math_Operators}', "");
    Expect(1, 8960, '\P{	In_math_Operators}', "");
    Expect(0, 8960, '\P{^	In_math_Operators}', "");
    Error('\p{_:=Meetei_MAYEK}');
    Error('\P{_:=Meetei_MAYEK}');
    Expect(1, 44025, '\p{meeteimayek}', "");
    Expect(0, 44025, '\p{^meeteimayek}', "");
    Expect(0, 44025, '\P{meeteimayek}', "");
    Expect(1, 44025, '\P{^meeteimayek}', "");
    Expect(0, 44026, '\p{meeteimayek}', "");
    Expect(1, 44026, '\p{^meeteimayek}', "");
    Expect(1, 44026, '\P{meeteimayek}', "");
    Expect(0, 44026, '\P{^meeteimayek}', "");
    Expect(1, 44025, '\p{	Meetei_Mayek}', "");
    Expect(0, 44025, '\p{^	Meetei_Mayek}', "");
    Expect(0, 44025, '\P{	Meetei_Mayek}', "");
    Expect(1, 44025, '\P{^	Meetei_Mayek}', "");
    Expect(0, 44026, '\p{	Meetei_Mayek}', "");
    Expect(1, 44026, '\p{^	Meetei_Mayek}', "");
    Expect(1, 44026, '\P{	Meetei_Mayek}', "");
    Expect(0, 44026, '\P{^	Meetei_Mayek}', "");
    Error('\p{/a/ -IS_Meetei_MAYEK}');
    Error('\P{/a/ -IS_Meetei_MAYEK}');
    Expect(1, 44025, '\p{ismeeteimayek}', "");
    Expect(0, 44025, '\p{^ismeeteimayek}', "");
    Expect(0, 44025, '\P{ismeeteimayek}', "");
    Expect(1, 44025, '\P{^ismeeteimayek}', "");
    Expect(0, 44026, '\p{ismeeteimayek}', "");
    Expect(1, 44026, '\p{^ismeeteimayek}', "");
    Expect(1, 44026, '\P{ismeeteimayek}', "");
    Expect(0, 44026, '\P{^ismeeteimayek}', "");
    Expect(1, 44025, '\p{-_Is_Meetei_mayek}', "");
    Expect(0, 44025, '\p{^-_Is_Meetei_mayek}', "");
    Expect(0, 44025, '\P{-_Is_Meetei_mayek}', "");
    Expect(1, 44025, '\P{^-_Is_Meetei_mayek}', "");
    Expect(0, 44026, '\p{-_Is_Meetei_mayek}', "");
    Expect(1, 44026, '\p{^-_Is_Meetei_mayek}', "");
    Expect(1, 44026, '\P{-_Is_Meetei_mayek}', "");
    Expect(0, 44026, '\P{^-_Is_Meetei_mayek}', "");
    Error('\p{ :=MTEI}');
    Error('\P{ :=MTEI}');
    Expect(1, 44025, '\p{mtei}', "");
    Expect(0, 44025, '\p{^mtei}', "");
    Expect(0, 44025, '\P{mtei}', "");
    Expect(1, 44025, '\P{^mtei}', "");
    Expect(0, 44026, '\p{mtei}', "");
    Expect(1, 44026, '\p{^mtei}', "");
    Expect(1, 44026, '\P{mtei}', "");
    Expect(0, 44026, '\P{^mtei}', "");
    Expect(1, 44025, '\p{-_Mtei}', "");
    Expect(0, 44025, '\p{^-_Mtei}', "");
    Expect(0, 44025, '\P{-_Mtei}', "");
    Expect(1, 44025, '\P{^-_Mtei}', "");
    Expect(0, 44026, '\p{-_Mtei}', "");
    Expect(1, 44026, '\p{^-_Mtei}', "");
    Expect(1, 44026, '\P{-_Mtei}', "");
    Expect(0, 44026, '\P{^-_Mtei}', "");
    Error('\p{:=_	is_Mtei}');
    Error('\P{:=_	is_Mtei}');
    Expect(1, 44025, '\p{ismtei}', "");
    Expect(0, 44025, '\p{^ismtei}', "");
    Expect(0, 44025, '\P{ismtei}', "");
    Expect(1, 44025, '\P{^ismtei}', "");
    Expect(0, 44026, '\p{ismtei}', "");
    Expect(1, 44026, '\p{^ismtei}', "");
    Expect(1, 44026, '\P{ismtei}', "");
    Expect(0, 44026, '\P{^ismtei}', "");
    Expect(1, 44025, '\p{Is_MTEI}', "");
    Expect(0, 44025, '\p{^Is_MTEI}', "");
    Expect(0, 44025, '\P{Is_MTEI}', "");
    Expect(1, 44025, '\P{^Is_MTEI}', "");
    Expect(0, 44026, '\p{Is_MTEI}', "");
    Expect(1, 44026, '\p{^Is_MTEI}', "");
    Expect(1, 44026, '\P{Is_MTEI}', "");
    Expect(0, 44026, '\P{^Is_MTEI}', "");
    Error('\p{ /a/MEETEI_mayek_Extensions}');
    Error('\P{ /a/MEETEI_mayek_Extensions}');
    Expect(1, 43775, '\p{meeteimayekextensions}', "");
    Expect(0, 43775, '\p{^meeteimayekextensions}', "");
    Expect(0, 43775, '\P{meeteimayekextensions}', "");
    Expect(1, 43775, '\P{^meeteimayekextensions}', "");
    Expect(0, 43776, '\p{meeteimayekextensions}', "");
    Expect(1, 43776, '\p{^meeteimayekextensions}', "");
    Expect(1, 43776, '\P{meeteimayekextensions}', "");
    Expect(0, 43776, '\P{^meeteimayekextensions}', "");
    Expect(1, 43775, '\p{_	Meetei_Mayek_extensions}', "");
    Expect(0, 43775, '\p{^_	Meetei_Mayek_extensions}', "");
    Expect(0, 43775, '\P{_	Meetei_Mayek_extensions}', "");
    Expect(1, 43775, '\P{^_	Meetei_Mayek_extensions}', "");
    Expect(0, 43776, '\p{_	Meetei_Mayek_extensions}', "");
    Expect(1, 43776, '\p{^_	Meetei_Mayek_extensions}', "");
    Expect(1, 43776, '\P{_	Meetei_Mayek_extensions}', "");
    Expect(0, 43776, '\P{^_	Meetei_Mayek_extensions}', "");
    Error('\p{/a/IS_MEETEI_mayek_EXTENSIONS}');
    Error('\P{/a/IS_MEETEI_mayek_EXTENSIONS}');
    Expect(1, 43775, '\p{ismeeteimayekextensions}', "");
    Expect(0, 43775, '\p{^ismeeteimayekextensions}', "");
    Expect(0, 43775, '\P{ismeeteimayekextensions}', "");
    Expect(1, 43775, '\P{^ismeeteimayekextensions}', "");
    Expect(0, 43776, '\p{ismeeteimayekextensions}', "");
    Expect(1, 43776, '\p{^ismeeteimayekextensions}', "");
    Expect(1, 43776, '\P{ismeeteimayekextensions}', "");
    Expect(0, 43776, '\P{^ismeeteimayekextensions}', "");
    Expect(1, 43775, '\p{	Is_meetei_Mayek_EXTENSIONS}', "");
    Expect(0, 43775, '\p{^	Is_meetei_Mayek_EXTENSIONS}', "");
    Expect(0, 43775, '\P{	Is_meetei_Mayek_EXTENSIONS}', "");
    Expect(1, 43775, '\P{^	Is_meetei_Mayek_EXTENSIONS}', "");
    Expect(0, 43776, '\p{	Is_meetei_Mayek_EXTENSIONS}', "");
    Expect(1, 43776, '\p{^	Is_meetei_Mayek_EXTENSIONS}', "");
    Expect(1, 43776, '\P{	Is_meetei_Mayek_EXTENSIONS}', "");
    Expect(0, 43776, '\P{^	Is_meetei_Mayek_EXTENSIONS}', "");
    Error('\p{:=In_Meetei_MAYEK_Extensions}');
    Error('\P{:=In_Meetei_MAYEK_Extensions}');
    Expect(1, 43775, '\p{inmeeteimayekextensions}', "");
    Expect(0, 43775, '\p{^inmeeteimayekextensions}', "");
    Expect(0, 43775, '\P{inmeeteimayekextensions}', "");
    Expect(1, 43775, '\P{^inmeeteimayekextensions}', "");
    Expect(0, 43776, '\p{inmeeteimayekextensions}', "");
    Expect(1, 43776, '\p{^inmeeteimayekextensions}', "");
    Expect(1, 43776, '\P{inmeeteimayekextensions}', "");
    Expect(0, 43776, '\P{^inmeeteimayekextensions}', "");
    Expect(1, 43775, '\p{ IN_Meetei_Mayek_EXTENSIONS}', "");
    Expect(0, 43775, '\p{^ IN_Meetei_Mayek_EXTENSIONS}', "");
    Expect(0, 43775, '\P{ IN_Meetei_Mayek_EXTENSIONS}', "");
    Expect(1, 43775, '\P{^ IN_Meetei_Mayek_EXTENSIONS}', "");
    Expect(0, 43776, '\p{ IN_Meetei_Mayek_EXTENSIONS}', "");
    Expect(1, 43776, '\p{^ IN_Meetei_Mayek_EXTENSIONS}', "");
    Expect(1, 43776, '\P{ IN_Meetei_Mayek_EXTENSIONS}', "");
    Expect(0, 43776, '\P{^ IN_Meetei_Mayek_EXTENSIONS}', "");
    Error('\p{	/a/Meetei_mayek_Ext}');
    Error('\P{	/a/Meetei_mayek_Ext}');
    Expect(1, 43775, '\p{meeteimayekext}', "");
    Expect(0, 43775, '\p{^meeteimayekext}', "");
    Expect(0, 43775, '\P{meeteimayekext}', "");
    Expect(1, 43775, '\P{^meeteimayekext}', "");
    Expect(0, 43776, '\p{meeteimayekext}', "");
    Expect(1, 43776, '\p{^meeteimayekext}', "");
    Expect(1, 43776, '\P{meeteimayekext}', "");
    Expect(0, 43776, '\P{^meeteimayekext}', "");
    Expect(1, 43775, '\p{ Meetei_MAYEK_Ext}', "");
    Expect(0, 43775, '\p{^ Meetei_MAYEK_Ext}', "");
    Expect(0, 43775, '\P{ Meetei_MAYEK_Ext}', "");
    Expect(1, 43775, '\P{^ Meetei_MAYEK_Ext}', "");
    Expect(0, 43776, '\p{ Meetei_MAYEK_Ext}', "");
    Expect(1, 43776, '\p{^ Meetei_MAYEK_Ext}', "");
    Expect(1, 43776, '\P{ Meetei_MAYEK_Ext}', "");
    Expect(0, 43776, '\P{^ Meetei_MAYEK_Ext}', "");
    Error('\p{		Is_MEETEI_mayek_EXT:=}');
    Error('\P{		Is_MEETEI_mayek_EXT:=}');
    Expect(1, 43775, '\p{ismeeteimayekext}', "");
    Expect(0, 43775, '\p{^ismeeteimayekext}', "");
    Expect(0, 43775, '\P{ismeeteimayekext}', "");
    Expect(1, 43775, '\P{^ismeeteimayekext}', "");
    Expect(0, 43776, '\p{ismeeteimayekext}', "");
    Expect(1, 43776, '\p{^ismeeteimayekext}', "");
    Expect(1, 43776, '\P{ismeeteimayekext}', "");
    Expect(0, 43776, '\P{^ismeeteimayekext}', "");
    Expect(1, 43775, '\p{_ Is_Meetei_Mayek_EXT}', "");
    Expect(0, 43775, '\p{^_ Is_Meetei_Mayek_EXT}', "");
    Expect(0, 43775, '\P{_ Is_Meetei_Mayek_EXT}', "");
    Expect(1, 43775, '\P{^_ Is_Meetei_Mayek_EXT}', "");
    Expect(0, 43776, '\p{_ Is_Meetei_Mayek_EXT}', "");
    Expect(1, 43776, '\p{^_ Is_Meetei_Mayek_EXT}', "");
    Expect(1, 43776, '\P{_ Is_Meetei_Mayek_EXT}', "");
    Expect(0, 43776, '\P{^_ Is_Meetei_Mayek_EXT}', "");
    Error('\p{__In_meetei_Mayek_Ext:=}');
    Error('\P{__In_meetei_Mayek_Ext:=}');
    Expect(1, 43775, '\p{inmeeteimayekext}', "");
    Expect(0, 43775, '\p{^inmeeteimayekext}', "");
    Expect(0, 43775, '\P{inmeeteimayekext}', "");
    Expect(1, 43775, '\P{^inmeeteimayekext}', "");
    Expect(0, 43776, '\p{inmeeteimayekext}', "");
    Expect(1, 43776, '\p{^inmeeteimayekext}', "");
    Expect(1, 43776, '\P{inmeeteimayekext}', "");
    Expect(0, 43776, '\P{^inmeeteimayekext}', "");
    Expect(1, 43775, '\p{_ IN_MEETEI_mayek_ext}', "");
    Expect(0, 43775, '\p{^_ IN_MEETEI_mayek_ext}', "");
    Expect(0, 43775, '\P{_ IN_MEETEI_mayek_ext}', "");
    Expect(1, 43775, '\P{^_ IN_MEETEI_mayek_ext}', "");
    Expect(0, 43776, '\p{_ IN_MEETEI_mayek_ext}', "");
    Expect(1, 43776, '\p{^_ IN_MEETEI_mayek_ext}', "");
    Expect(1, 43776, '\P{_ IN_MEETEI_mayek_ext}', "");
    Expect(0, 43776, '\P{^_ IN_MEETEI_mayek_ext}', "");
    Error('\p{ Mende_KIKAKUI/a/}');
    Error('\P{ Mende_KIKAKUI/a/}');
    Expect(1, 125142, '\p{mendekikakui}', "");
    Expect(0, 125142, '\p{^mendekikakui}', "");
    Expect(0, 125142, '\P{mendekikakui}', "");
    Expect(1, 125142, '\P{^mendekikakui}', "");
    Expect(0, 125143, '\p{mendekikakui}', "");
    Expect(1, 125143, '\p{^mendekikakui}', "");
    Expect(1, 125143, '\P{mendekikakui}', "");
    Expect(0, 125143, '\P{^mendekikakui}', "");
    Expect(1, 125142, '\p{__mende_KIKAKUI}', "");
    Expect(0, 125142, '\p{^__mende_KIKAKUI}', "");
    Expect(0, 125142, '\P{__mende_KIKAKUI}', "");
    Expect(1, 125142, '\P{^__mende_KIKAKUI}', "");
    Expect(0, 125143, '\p{__mende_KIKAKUI}', "");
    Expect(1, 125143, '\p{^__mende_KIKAKUI}', "");
    Expect(1, 125143, '\P{__mende_KIKAKUI}', "");
    Expect(0, 125143, '\P{^__mende_KIKAKUI}', "");
    Error('\p{--IS_MENDE_Kikakui:=}');
    Error('\P{--IS_MENDE_Kikakui:=}');
    Expect(1, 125142, '\p{ismendekikakui}', "");
    Expect(0, 125142, '\p{^ismendekikakui}', "");
    Expect(0, 125142, '\P{ismendekikakui}', "");
    Expect(1, 125142, '\P{^ismendekikakui}', "");
    Expect(0, 125143, '\p{ismendekikakui}', "");
    Expect(1, 125143, '\p{^ismendekikakui}', "");
    Expect(1, 125143, '\P{ismendekikakui}', "");
    Expect(0, 125143, '\P{^ismendekikakui}', "");
    Expect(1, 125142, '\p{ Is_MENDE_KIKAKUI}', "");
    Expect(0, 125142, '\p{^ Is_MENDE_KIKAKUI}', "");
    Expect(0, 125142, '\P{ Is_MENDE_KIKAKUI}', "");
    Expect(1, 125142, '\P{^ Is_MENDE_KIKAKUI}', "");
    Expect(0, 125143, '\p{ Is_MENDE_KIKAKUI}', "");
    Expect(1, 125143, '\p{^ Is_MENDE_KIKAKUI}', "");
    Expect(1, 125143, '\P{ Is_MENDE_KIKAKUI}', "");
    Expect(0, 125143, '\P{^ Is_MENDE_KIKAKUI}', "");
    Error('\p{ Mend:=}');
    Error('\P{ Mend:=}');
    Expect(1, 125142, '\p{mend}', "");
    Expect(0, 125142, '\p{^mend}', "");
    Expect(0, 125142, '\P{mend}', "");
    Expect(1, 125142, '\P{^mend}', "");
    Expect(0, 125143, '\p{mend}', "");
    Expect(1, 125143, '\p{^mend}', "");
    Expect(1, 125143, '\P{mend}', "");
    Expect(0, 125143, '\P{^mend}', "");
    Expect(1, 125142, '\p{_ Mend}', "");
    Expect(0, 125142, '\p{^_ Mend}', "");
    Expect(0, 125142, '\P{_ Mend}', "");
    Expect(1, 125142, '\P{^_ Mend}', "");
    Expect(0, 125143, '\p{_ Mend}', "");
    Expect(1, 125143, '\p{^_ Mend}', "");
    Expect(1, 125143, '\P{_ Mend}', "");
    Expect(0, 125143, '\P{^_ Mend}', "");
    Error('\p{-/a/IS_Mend}');
    Error('\P{-/a/IS_Mend}');
    Expect(1, 125142, '\p{ismend}', "");
    Expect(0, 125142, '\p{^ismend}', "");
    Expect(0, 125142, '\P{ismend}', "");
    Expect(1, 125142, '\P{^ismend}', "");
    Expect(0, 125143, '\p{ismend}', "");
    Expect(1, 125143, '\p{^ismend}', "");
    Expect(1, 125143, '\P{ismend}', "");
    Expect(0, 125143, '\P{^ismend}', "");
    Expect(1, 125142, '\p{	_IS_MEND}', "");
    Expect(0, 125142, '\p{^	_IS_MEND}', "");
    Expect(0, 125142, '\P{	_IS_MEND}', "");
    Expect(1, 125142, '\P{^	_IS_MEND}', "");
    Expect(0, 125143, '\p{	_IS_MEND}', "");
    Expect(1, 125143, '\p{^	_IS_MEND}', "");
    Expect(1, 125143, '\P{	_IS_MEND}', "");
    Expect(0, 125143, '\P{^	_IS_MEND}', "");
    Error('\p{/a/	_MEROITIC_cursive}');
    Error('\P{/a/	_MEROITIC_cursive}');
    Expect(1, 68095, '\p{meroiticcursive}', "");
    Expect(0, 68095, '\p{^meroiticcursive}', "");
    Expect(0, 68095, '\P{meroiticcursive}', "");
    Expect(1, 68095, '\P{^meroiticcursive}', "");
    Expect(0, 68096, '\p{meroiticcursive}', "");
    Expect(1, 68096, '\p{^meroiticcursive}', "");
    Expect(1, 68096, '\P{meroiticcursive}', "");
    Expect(0, 68096, '\P{^meroiticcursive}', "");
    Expect(1, 68095, '\p{		MEROITIC_CURSIVE}', "");
    Expect(0, 68095, '\p{^		MEROITIC_CURSIVE}', "");
    Expect(0, 68095, '\P{		MEROITIC_CURSIVE}', "");
    Expect(1, 68095, '\P{^		MEROITIC_CURSIVE}', "");
    Expect(0, 68096, '\p{		MEROITIC_CURSIVE}', "");
    Expect(1, 68096, '\p{^		MEROITIC_CURSIVE}', "");
    Expect(1, 68096, '\P{		MEROITIC_CURSIVE}', "");
    Expect(0, 68096, '\P{^		MEROITIC_CURSIVE}', "");
    Error('\p{/a/ _IS_Meroitic_Cursive}');
    Error('\P{/a/ _IS_Meroitic_Cursive}');
    Expect(1, 68095, '\p{ismeroiticcursive}', "");
    Expect(0, 68095, '\p{^ismeroiticcursive}', "");
    Expect(0, 68095, '\P{ismeroiticcursive}', "");
    Expect(1, 68095, '\P{^ismeroiticcursive}', "");
    Expect(0, 68096, '\p{ismeroiticcursive}', "");
    Expect(1, 68096, '\p{^ismeroiticcursive}', "");
    Expect(1, 68096, '\P{ismeroiticcursive}', "");
    Expect(0, 68096, '\P{^ismeroiticcursive}', "");
    Expect(1, 68095, '\p{	_Is_Meroitic_Cursive}', "");
    Expect(0, 68095, '\p{^	_Is_Meroitic_Cursive}', "");
    Expect(0, 68095, '\P{	_Is_Meroitic_Cursive}', "");
    Expect(1, 68095, '\P{^	_Is_Meroitic_Cursive}', "");
    Expect(0, 68096, '\p{	_Is_Meroitic_Cursive}', "");
    Expect(1, 68096, '\p{^	_Is_Meroitic_Cursive}', "");
    Expect(1, 68096, '\P{	_Is_Meroitic_Cursive}', "");
    Expect(0, 68096, '\P{^	_Is_Meroitic_Cursive}', "");
    Error('\p{/a/Merc}');
    Error('\P{/a/Merc}');
    Expect(1, 68095, '\p{merc}', "");
    Expect(0, 68095, '\p{^merc}', "");
    Expect(0, 68095, '\P{merc}', "");
    Expect(1, 68095, '\P{^merc}', "");
    Expect(0, 68096, '\p{merc}', "");
    Expect(1, 68096, '\p{^merc}', "");
    Expect(1, 68096, '\P{merc}', "");
    Expect(0, 68096, '\P{^merc}', "");
    Expect(1, 68095, '\p{-merc}', "");
    Expect(0, 68095, '\p{^-merc}', "");
    Expect(0, 68095, '\P{-merc}', "");
    Expect(1, 68095, '\P{^-merc}', "");
    Expect(0, 68096, '\p{-merc}', "");
    Expect(1, 68096, '\p{^-merc}', "");
    Expect(1, 68096, '\P{-merc}', "");
    Expect(0, 68096, '\P{^-merc}', "");
    Error('\p{-IS_MERC/a/}');
    Error('\P{-IS_MERC/a/}');
    Expect(1, 68095, '\p{ismerc}', "");
    Expect(0, 68095, '\p{^ismerc}', "");
    Expect(0, 68095, '\P{ismerc}', "");
    Expect(1, 68095, '\P{^ismerc}', "");
    Expect(0, 68096, '\p{ismerc}', "");
    Expect(1, 68096, '\p{^ismerc}', "");
    Expect(1, 68096, '\P{ismerc}', "");
    Expect(0, 68096, '\P{^ismerc}', "");
    Expect(1, 68095, '\p{_	is_MERC}', "");
    Expect(0, 68095, '\p{^_	is_MERC}', "");
    Expect(0, 68095, '\P{_	is_MERC}', "");
    Expect(1, 68095, '\P{^_	is_MERC}', "");
    Expect(0, 68096, '\p{_	is_MERC}', "");
    Expect(1, 68096, '\p{^_	is_MERC}', "");
    Expect(1, 68096, '\P{_	is_MERC}', "");
    Expect(0, 68096, '\P{^_	is_MERC}', "");
    Error('\p{ /a/MEROITIC_HIEROGLYPHS}');
    Error('\P{ /a/MEROITIC_HIEROGLYPHS}');
    Expect(1, 67999, '\p{meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{	 meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^	 meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\P{	 meroitic_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^	 meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\p{	 meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^	 meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\P{	 meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^	 meroitic_Hieroglyphs}', "");
    Error('\p{-_Is_MEROITIC_Hieroglyphs:=}');
    Error('\P{-_Is_MEROITIC_Hieroglyphs:=}');
    Expect(1, 67999, '\p{ismeroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^ismeroitichieroglyphs}', "");
    Expect(0, 67999, '\P{ismeroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^ismeroitichieroglyphs}', "");
    Expect(0, 68000, '\p{ismeroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^ismeroitichieroglyphs}', "");
    Expect(1, 68000, '\P{ismeroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^ismeroitichieroglyphs}', "");
    Expect(1, 67999, '\p{ Is_Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^ Is_Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\P{ Is_Meroitic_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^ Is_Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\p{ Is_Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^ Is_Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\P{ Is_Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^ Is_Meroitic_Hieroglyphs}', "");
    Error('\p{ :=Mero}');
    Error('\P{ :=Mero}');
    Expect(1, 67999, '\p{mero}', "");
    Expect(0, 67999, '\p{^mero}', "");
    Expect(0, 67999, '\P{mero}', "");
    Expect(1, 67999, '\P{^mero}', "");
    Expect(0, 68000, '\p{mero}', "");
    Expect(1, 68000, '\p{^mero}', "");
    Expect(1, 68000, '\P{mero}', "");
    Expect(0, 68000, '\P{^mero}', "");
    Expect(1, 67999, '\p{ -mero}', "");
    Expect(0, 67999, '\p{^ -mero}', "");
    Expect(0, 67999, '\P{ -mero}', "");
    Expect(1, 67999, '\P{^ -mero}', "");
    Expect(0, 68000, '\p{ -mero}', "");
    Expect(1, 68000, '\p{^ -mero}', "");
    Expect(1, 68000, '\P{ -mero}', "");
    Expect(0, 68000, '\P{^ -mero}', "");
    Error('\p{:= 	is_Mero}');
    Error('\P{:= 	is_Mero}');
    Expect(1, 67999, '\p{ismero}', "");
    Expect(0, 67999, '\p{^ismero}', "");
    Expect(0, 67999, '\P{ismero}', "");
    Expect(1, 67999, '\P{^ismero}', "");
    Expect(0, 68000, '\p{ismero}', "");
    Expect(1, 68000, '\p{^ismero}', "");
    Expect(1, 68000, '\P{ismero}', "");
    Expect(0, 68000, '\P{^ismero}', "");
    Expect(1, 67999, '\p{	Is_Mero}', "");
    Expect(0, 67999, '\p{^	Is_Mero}', "");
    Expect(0, 67999, '\P{	Is_Mero}', "");
    Expect(1, 67999, '\P{^	Is_Mero}', "");
    Expect(0, 68000, '\p{	Is_Mero}', "");
    Expect(1, 68000, '\p{^	Is_Mero}', "");
    Expect(1, 68000, '\P{	Is_Mero}', "");
    Expect(0, 68000, '\P{^	Is_Mero}', "");
    Error('\p{:=  MIAO}');
    Error('\P{:=  MIAO}');
    Expect(1, 94111, '\p{miao}', "");
    Expect(0, 94111, '\p{^miao}', "");
    Expect(0, 94111, '\P{miao}', "");
    Expect(1, 94111, '\P{^miao}', "");
    Expect(0, 94112, '\p{miao}', "");
    Expect(1, 94112, '\p{^miao}', "");
    Expect(1, 94112, '\P{miao}', "");
    Expect(0, 94112, '\P{^miao}', "");
    Expect(1, 94111, '\p{ -miao}', "");
    Expect(0, 94111, '\p{^ -miao}', "");
    Expect(0, 94111, '\P{ -miao}', "");
    Expect(1, 94111, '\P{^ -miao}', "");
    Expect(0, 94112, '\p{ -miao}', "");
    Expect(1, 94112, '\p{^ -miao}', "");
    Expect(1, 94112, '\P{ -miao}', "");
    Expect(0, 94112, '\P{^ -miao}', "");
    Error('\p{/a/--Is_Miao}');
    Error('\P{/a/--Is_Miao}');
    Expect(1, 94111, '\p{ismiao}', "");
    Expect(0, 94111, '\p{^ismiao}', "");
    Expect(0, 94111, '\P{ismiao}', "");
    Expect(1, 94111, '\P{^ismiao}', "");
    Expect(0, 94112, '\p{ismiao}', "");
    Expect(1, 94112, '\p{^ismiao}', "");
    Expect(1, 94112, '\P{ismiao}', "");
    Expect(0, 94112, '\P{^ismiao}', "");
    Expect(1, 94111, '\p{ -Is_MIAO}', "");
    Expect(0, 94111, '\p{^ -Is_MIAO}', "");
    Expect(0, 94111, '\P{ -Is_MIAO}', "");
    Expect(1, 94111, '\P{^ -Is_MIAO}', "");
    Expect(0, 94112, '\p{ -Is_MIAO}', "");
    Expect(1, 94112, '\p{^ -Is_MIAO}', "");
    Expect(1, 94112, '\P{ -Is_MIAO}', "");
    Expect(0, 94112, '\P{^ -Is_MIAO}', "");
    Error('\p{:=--Plrd}');
    Error('\P{:=--Plrd}');
    Expect(1, 94111, '\p{plrd}', "");
    Expect(0, 94111, '\p{^plrd}', "");
    Expect(0, 94111, '\P{plrd}', "");
    Expect(1, 94111, '\P{^plrd}', "");
    Expect(0, 94112, '\p{plrd}', "");
    Expect(1, 94112, '\p{^plrd}', "");
    Expect(1, 94112, '\P{plrd}', "");
    Expect(0, 94112, '\P{^plrd}', "");
    Expect(1, 94111, '\p{_ PLRD}', "");
    Expect(0, 94111, '\p{^_ PLRD}', "");
    Expect(0, 94111, '\P{_ PLRD}', "");
    Expect(1, 94111, '\P{^_ PLRD}', "");
    Expect(0, 94112, '\p{_ PLRD}', "");
    Expect(1, 94112, '\p{^_ PLRD}', "");
    Expect(1, 94112, '\P{_ PLRD}', "");
    Expect(0, 94112, '\P{^_ PLRD}', "");
    Error('\p{/a/- Is_plrd}');
    Error('\P{/a/- Is_plrd}');
    Expect(1, 94111, '\p{isplrd}', "");
    Expect(0, 94111, '\p{^isplrd}', "");
    Expect(0, 94111, '\P{isplrd}', "");
    Expect(1, 94111, '\P{^isplrd}', "");
    Expect(0, 94112, '\p{isplrd}', "");
    Expect(1, 94112, '\p{^isplrd}', "");
    Expect(1, 94112, '\P{isplrd}', "");
    Expect(0, 94112, '\P{^isplrd}', "");
    Expect(1, 94111, '\p{Is_Plrd}', "");
    Expect(0, 94111, '\p{^Is_Plrd}', "");
    Expect(0, 94111, '\P{Is_Plrd}', "");
    Expect(1, 94111, '\P{^Is_Plrd}', "");
    Expect(0, 94112, '\p{Is_Plrd}', "");
    Expect(1, 94112, '\p{^Is_Plrd}', "");
    Expect(1, 94112, '\P{Is_Plrd}', "");
    Expect(0, 94112, '\P{^Is_Plrd}', "");
    Error('\p{/a/MISCELLANEOUS_MATHEMATICAL_Symbols_a}');
    Error('\P{/a/MISCELLANEOUS_MATHEMATICAL_Symbols_a}');
    Expect(1, 10223, '\p{miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\p{^miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\P{miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\P{^miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\p{miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\p{^miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\P{miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\P{^miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\p{-	Miscellaneous_Mathematical_SYMBOLS_A}', "");
    Expect(0, 10223, '\p{^-	Miscellaneous_Mathematical_SYMBOLS_A}', "");
    Expect(0, 10223, '\P{-	Miscellaneous_Mathematical_SYMBOLS_A}', "");
    Expect(1, 10223, '\P{^-	Miscellaneous_Mathematical_SYMBOLS_A}', "");
    Expect(0, 10224, '\p{-	Miscellaneous_Mathematical_SYMBOLS_A}', "");
    Expect(1, 10224, '\p{^-	Miscellaneous_Mathematical_SYMBOLS_A}', "");
    Expect(1, 10224, '\P{-	Miscellaneous_Mathematical_SYMBOLS_A}', "");
    Expect(0, 10224, '\P{^-	Miscellaneous_Mathematical_SYMBOLS_A}', "");
    Error('\p{/a/ _is_Miscellaneous_Mathematical_Symbols_A}');
    Error('\P{/a/ _is_Miscellaneous_Mathematical_Symbols_A}');
    Expect(1, 10223, '\p{ismiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\p{^ismiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\P{ismiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\P{^ismiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\p{ismiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\p{^ismiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\P{ismiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\P{^ismiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\p{ IS_Miscellaneous_mathematical_Symbols_a}', "");
    Expect(0, 10223, '\p{^ IS_Miscellaneous_mathematical_Symbols_a}', "");
    Expect(0, 10223, '\P{ IS_Miscellaneous_mathematical_Symbols_a}', "");
    Expect(1, 10223, '\P{^ IS_Miscellaneous_mathematical_Symbols_a}', "");
    Expect(0, 10224, '\p{ IS_Miscellaneous_mathematical_Symbols_a}', "");
    Expect(1, 10224, '\p{^ IS_Miscellaneous_mathematical_Symbols_a}', "");
    Expect(1, 10224, '\P{ IS_Miscellaneous_mathematical_Symbols_a}', "");
    Expect(0, 10224, '\P{^ IS_Miscellaneous_mathematical_Symbols_a}', "");
    Error('\p{	In_miscellaneous_mathematical_Symbols_A:=}');
    Error('\P{	In_miscellaneous_mathematical_Symbols_A:=}');
    Expect(1, 10223, '\p{inmiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\p{^inmiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\P{inmiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\P{^inmiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\p{inmiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\p{^inmiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\P{inmiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\P{^inmiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\p{__In_Miscellaneous_mathematical_Symbols_A}', "");
    Expect(0, 10223, '\p{^__In_Miscellaneous_mathematical_Symbols_A}', "");
    Expect(0, 10223, '\P{__In_Miscellaneous_mathematical_Symbols_A}', "");
    Expect(1, 10223, '\P{^__In_Miscellaneous_mathematical_Symbols_A}', "");
    Expect(0, 10224, '\p{__In_Miscellaneous_mathematical_Symbols_A}', "");
    Expect(1, 10224, '\p{^__In_Miscellaneous_mathematical_Symbols_A}', "");
    Expect(1, 10224, '\P{__In_Miscellaneous_mathematical_Symbols_A}', "");
    Expect(0, 10224, '\P{^__In_Miscellaneous_mathematical_Symbols_A}', "");
    Error('\p{:=  Misc_math_Symbols_A}');
    Error('\P{:=  Misc_math_Symbols_A}');
    Expect(1, 10223, '\p{miscmathsymbolsa}', "");
    Expect(0, 10223, '\p{^miscmathsymbolsa}', "");
    Expect(0, 10223, '\P{miscmathsymbolsa}', "");
    Expect(1, 10223, '\P{^miscmathsymbolsa}', "");
    Expect(0, 10224, '\p{miscmathsymbolsa}', "");
    Expect(1, 10224, '\p{^miscmathsymbolsa}', "");
    Expect(1, 10224, '\P{miscmathsymbolsa}', "");
    Expect(0, 10224, '\P{^miscmathsymbolsa}', "");
    Expect(1, 10223, '\p{	-Misc_MATH_symbols_A}', "");
    Expect(0, 10223, '\p{^	-Misc_MATH_symbols_A}', "");
    Expect(0, 10223, '\P{	-Misc_MATH_symbols_A}', "");
    Expect(1, 10223, '\P{^	-Misc_MATH_symbols_A}', "");
    Expect(0, 10224, '\p{	-Misc_MATH_symbols_A}', "");
    Expect(1, 10224, '\p{^	-Misc_MATH_symbols_A}', "");
    Expect(1, 10224, '\P{	-Misc_MATH_symbols_A}', "");
    Expect(0, 10224, '\P{^	-Misc_MATH_symbols_A}', "");
    Error('\p{/a/ Is_misc_math_SYMBOLS_A}');
    Error('\P{/a/ Is_misc_math_SYMBOLS_A}');
    Expect(1, 10223, '\p{ismiscmathsymbolsa}', "");
    Expect(0, 10223, '\p{^ismiscmathsymbolsa}', "");
    Expect(0, 10223, '\P{ismiscmathsymbolsa}', "");
    Expect(1, 10223, '\P{^ismiscmathsymbolsa}', "");
    Expect(0, 10224, '\p{ismiscmathsymbolsa}', "");
    Expect(1, 10224, '\p{^ismiscmathsymbolsa}', "");
    Expect(1, 10224, '\P{ismiscmathsymbolsa}', "");
    Expect(0, 10224, '\P{^ismiscmathsymbolsa}', "");
    Expect(1, 10223, '\p{- IS_Misc_Math_SYMBOLS_a}', "");
    Expect(0, 10223, '\p{^- IS_Misc_Math_SYMBOLS_a}', "");
    Expect(0, 10223, '\P{- IS_Misc_Math_SYMBOLS_a}', "");
    Expect(1, 10223, '\P{^- IS_Misc_Math_SYMBOLS_a}', "");
    Expect(0, 10224, '\p{- IS_Misc_Math_SYMBOLS_a}', "");
    Expect(1, 10224, '\p{^- IS_Misc_Math_SYMBOLS_a}', "");
    Expect(1, 10224, '\P{- IS_Misc_Math_SYMBOLS_a}', "");
    Expect(0, 10224, '\P{^- IS_Misc_Math_SYMBOLS_a}', "");
    Error('\p{		in_Misc_MATH_symbols_A:=}');
    Error('\P{		in_Misc_MATH_symbols_A:=}');
    Expect(1, 10223, '\p{inmiscmathsymbolsa}', "");
    Expect(0, 10223, '\p{^inmiscmathsymbolsa}', "");
    Expect(0, 10223, '\P{inmiscmathsymbolsa}', "");
    Expect(1, 10223, '\P{^inmiscmathsymbolsa}', "");
    Expect(0, 10224, '\p{inmiscmathsymbolsa}', "");
    Expect(1, 10224, '\p{^inmiscmathsymbolsa}', "");
    Expect(1, 10224, '\P{inmiscmathsymbolsa}', "");
    Expect(0, 10224, '\P{^inmiscmathsymbolsa}', "");
    Expect(1, 10223, '\p{	 in_Misc_Math_Symbols_A}', "");
    Expect(0, 10223, '\p{^	 in_Misc_Math_Symbols_A}', "");
    Expect(0, 10223, '\P{	 in_Misc_Math_Symbols_A}', "");
    Expect(1, 10223, '\P{^	 in_Misc_Math_Symbols_A}', "");
    Expect(0, 10224, '\p{	 in_Misc_Math_Symbols_A}', "");
    Expect(1, 10224, '\p{^	 in_Misc_Math_Symbols_A}', "");
    Expect(1, 10224, '\P{	 in_Misc_Math_Symbols_A}', "");
    Expect(0, 10224, '\P{^	 in_Misc_Math_Symbols_A}', "");
    Error('\p{- Miscellaneous_mathematical_SYMBOLS_b/a/}');
    Error('\P{- Miscellaneous_mathematical_SYMBOLS_b/a/}');
    Expect(1, 10751, '\p{miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\p{^miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\P{miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\P{^miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\p{miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\p{^miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\P{miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\P{^miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\p{_MISCELLANEOUS_mathematical_Symbols_b}', "");
    Expect(0, 10751, '\p{^_MISCELLANEOUS_mathematical_Symbols_b}', "");
    Expect(0, 10751, '\P{_MISCELLANEOUS_mathematical_Symbols_b}', "");
    Expect(1, 10751, '\P{^_MISCELLANEOUS_mathematical_Symbols_b}', "");
    Expect(0, 10752, '\p{_MISCELLANEOUS_mathematical_Symbols_b}', "");
    Expect(1, 10752, '\p{^_MISCELLANEOUS_mathematical_Symbols_b}', "");
    Expect(1, 10752, '\P{_MISCELLANEOUS_mathematical_Symbols_b}', "");
    Expect(0, 10752, '\P{^_MISCELLANEOUS_mathematical_Symbols_b}', "");
    Error('\p{-:=Is_Miscellaneous_MATHEMATICAL_Symbols_B}');
    Error('\P{-:=Is_Miscellaneous_MATHEMATICAL_Symbols_B}');
    Expect(1, 10751, '\p{ismiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\p{^ismiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\P{ismiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\P{^ismiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\p{ismiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\p{^ismiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\P{ismiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\P{^ismiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\p{ 	IS_MISCELLANEOUS_Mathematical_SYMBOLS_B}', "");
    Expect(0, 10751, '\p{^ 	IS_MISCELLANEOUS_Mathematical_SYMBOLS_B}', "");
    Expect(0, 10751, '\P{ 	IS_MISCELLANEOUS_Mathematical_SYMBOLS_B}', "");
    Expect(1, 10751, '\P{^ 	IS_MISCELLANEOUS_Mathematical_SYMBOLS_B}', "");
    Expect(0, 10752, '\p{ 	IS_MISCELLANEOUS_Mathematical_SYMBOLS_B}', "");
    Expect(1, 10752, '\p{^ 	IS_MISCELLANEOUS_Mathematical_SYMBOLS_B}', "");
    Expect(1, 10752, '\P{ 	IS_MISCELLANEOUS_Mathematical_SYMBOLS_B}', "");
    Expect(0, 10752, '\P{^ 	IS_MISCELLANEOUS_Mathematical_SYMBOLS_B}', "");
    Error('\p{--in_Miscellaneous_Mathematical_Symbols_B:=}');
    Error('\P{--in_Miscellaneous_Mathematical_Symbols_B:=}');
    Expect(1, 10751, '\p{inmiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\p{^inmiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\P{inmiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\P{^inmiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\p{inmiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\p{^inmiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\P{inmiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\P{^inmiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\p{	_IN_miscellaneous_Mathematical_symbols_B}', "");
    Expect(0, 10751, '\p{^	_IN_miscellaneous_Mathematical_symbols_B}', "");
    Expect(0, 10751, '\P{	_IN_miscellaneous_Mathematical_symbols_B}', "");
    Expect(1, 10751, '\P{^	_IN_miscellaneous_Mathematical_symbols_B}', "");
    Expect(0, 10752, '\p{	_IN_miscellaneous_Mathematical_symbols_B}', "");
    Expect(1, 10752, '\p{^	_IN_miscellaneous_Mathematical_symbols_B}', "");
    Expect(1, 10752, '\P{	_IN_miscellaneous_Mathematical_symbols_B}', "");
    Expect(0, 10752, '\P{^	_IN_miscellaneous_Mathematical_symbols_B}', "");
    Error('\p{_:=Misc_math_Symbols_B}');
    Error('\P{_:=Misc_math_Symbols_B}');
    Expect(1, 10751, '\p{miscmathsymbolsb}', "");
    Expect(0, 10751, '\p{^miscmathsymbolsb}', "");
    Expect(0, 10751, '\P{miscmathsymbolsb}', "");
    Expect(1, 10751, '\P{^miscmathsymbolsb}', "");
    Expect(0, 10752, '\p{miscmathsymbolsb}', "");
    Expect(1, 10752, '\p{^miscmathsymbolsb}', "");
    Expect(1, 10752, '\P{miscmathsymbolsb}', "");
    Expect(0, 10752, '\P{^miscmathsymbolsb}', "");
    Expect(1, 10751, '\p{-	misc_math_Symbols_B}', "");
    Expect(0, 10751, '\p{^-	misc_math_Symbols_B}', "");
    Expect(0, 10751, '\P{-	misc_math_Symbols_B}', "");
    Expect(1, 10751, '\P{^-	misc_math_Symbols_B}', "");
    Expect(0, 10752, '\p{-	misc_math_Symbols_B}', "");
    Expect(1, 10752, '\p{^-	misc_math_Symbols_B}', "");
    Expect(1, 10752, '\P{-	misc_math_Symbols_B}', "");
    Expect(0, 10752, '\P{^-	misc_math_Symbols_B}', "");
    Error('\p{_ Is_MISC_MATH_Symbols_B/a/}');
    Error('\P{_ Is_MISC_MATH_Symbols_B/a/}');
    Expect(1, 10751, '\p{ismiscmathsymbolsb}', "");
    Expect(0, 10751, '\p{^ismiscmathsymbolsb}', "");
    Expect(0, 10751, '\P{ismiscmathsymbolsb}', "");
    Expect(1, 10751, '\P{^ismiscmathsymbolsb}', "");
    Expect(0, 10752, '\p{ismiscmathsymbolsb}', "");
    Expect(1, 10752, '\p{^ismiscmathsymbolsb}', "");
    Expect(1, 10752, '\P{ismiscmathsymbolsb}', "");
    Expect(0, 10752, '\P{^ismiscmathsymbolsb}', "");
    Expect(1, 10751, '\p{ _Is_Misc_MATH_Symbols_b}', "");
    Expect(0, 10751, '\p{^ _Is_Misc_MATH_Symbols_b}', "");
    Expect(0, 10751, '\P{ _Is_Misc_MATH_Symbols_b}', "");
    Expect(1, 10751, '\P{^ _Is_Misc_MATH_Symbols_b}', "");
    Expect(0, 10752, '\p{ _Is_Misc_MATH_Symbols_b}', "");
    Expect(1, 10752, '\p{^ _Is_Misc_MATH_Symbols_b}', "");
    Expect(1, 10752, '\P{ _Is_Misc_MATH_Symbols_b}', "");
    Expect(0, 10752, '\P{^ _Is_Misc_MATH_Symbols_b}', "");
    Error('\p{ /a/In_Misc_MATH_Symbols_b}');
    Error('\P{ /a/In_Misc_MATH_Symbols_b}');
    Expect(1, 10751, '\p{inmiscmathsymbolsb}', "");
    Expect(0, 10751, '\p{^inmiscmathsymbolsb}', "");
    Expect(0, 10751, '\P{inmiscmathsymbolsb}', "");
    Expect(1, 10751, '\P{^inmiscmathsymbolsb}', "");
    Expect(0, 10752, '\p{inmiscmathsymbolsb}', "");
    Expect(1, 10752, '\p{^inmiscmathsymbolsb}', "");
    Expect(1, 10752, '\P{inmiscmathsymbolsb}', "");
    Expect(0, 10752, '\P{^inmiscmathsymbolsb}', "");
    Expect(1, 10751, '\p{_	In_misc_Math_SYMBOLS_B}', "");
    Expect(0, 10751, '\p{^_	In_misc_Math_SYMBOLS_B}', "");
    Expect(0, 10751, '\P{_	In_misc_Math_SYMBOLS_B}', "");
    Expect(1, 10751, '\P{^_	In_misc_Math_SYMBOLS_B}', "");
    Expect(0, 10752, '\p{_	In_misc_Math_SYMBOLS_B}', "");
    Expect(1, 10752, '\p{^_	In_misc_Math_SYMBOLS_B}', "");
    Expect(1, 10752, '\P{_	In_misc_Math_SYMBOLS_B}', "");
    Expect(0, 10752, '\P{^_	In_misc_Math_SYMBOLS_B}', "");
    Error('\p{	Miscellaneous_SYMBOLS/a/}');
    Error('\P{	Miscellaneous_SYMBOLS/a/}');
    Expect(1, 9983, '\p{miscellaneoussymbols}', "");
    Expect(0, 9983, '\p{^miscellaneoussymbols}', "");
    Expect(0, 9983, '\P{miscellaneoussymbols}', "");
    Expect(1, 9983, '\P{^miscellaneoussymbols}', "");
    Expect(0, 9984, '\p{miscellaneoussymbols}', "");
    Expect(1, 9984, '\p{^miscellaneoussymbols}', "");
    Expect(1, 9984, '\P{miscellaneoussymbols}', "");
    Expect(0, 9984, '\P{^miscellaneoussymbols}', "");
    Expect(1, 9983, '\p{ _Miscellaneous_Symbols}', "");
    Expect(0, 9983, '\p{^ _Miscellaneous_Symbols}', "");
    Expect(0, 9983, '\P{ _Miscellaneous_Symbols}', "");
    Expect(1, 9983, '\P{^ _Miscellaneous_Symbols}', "");
    Expect(0, 9984, '\p{ _Miscellaneous_Symbols}', "");
    Expect(1, 9984, '\p{^ _Miscellaneous_Symbols}', "");
    Expect(1, 9984, '\P{ _Miscellaneous_Symbols}', "");
    Expect(0, 9984, '\P{^ _Miscellaneous_Symbols}', "");
    Error('\p{:=- Is_Miscellaneous_symbols}');
    Error('\P{:=- Is_Miscellaneous_symbols}');
    Expect(1, 9983, '\p{ismiscellaneoussymbols}', "");
    Expect(0, 9983, '\p{^ismiscellaneoussymbols}', "");
    Expect(0, 9983, '\P{ismiscellaneoussymbols}', "");
    Expect(1, 9983, '\P{^ismiscellaneoussymbols}', "");
    Expect(0, 9984, '\p{ismiscellaneoussymbols}', "");
    Expect(1, 9984, '\p{^ismiscellaneoussymbols}', "");
    Expect(1, 9984, '\P{ismiscellaneoussymbols}', "");
    Expect(0, 9984, '\P{^ismiscellaneoussymbols}', "");
    Expect(1, 9983, '\p{_ Is_miscellaneous_Symbols}', "");
    Expect(0, 9983, '\p{^_ Is_miscellaneous_Symbols}', "");
    Expect(0, 9983, '\P{_ Is_miscellaneous_Symbols}', "");
    Expect(1, 9983, '\P{^_ Is_miscellaneous_Symbols}', "");
    Expect(0, 9984, '\p{_ Is_miscellaneous_Symbols}', "");
    Expect(1, 9984, '\p{^_ Is_miscellaneous_Symbols}', "");
    Expect(1, 9984, '\P{_ Is_miscellaneous_Symbols}', "");
    Expect(0, 9984, '\P{^_ Is_miscellaneous_Symbols}', "");
    Error('\p{:=_IN_MISCELLANEOUS_SYMBOLS}');
    Error('\P{:=_IN_MISCELLANEOUS_SYMBOLS}');
    Expect(1, 9983, '\p{inmiscellaneoussymbols}', "");
    Expect(0, 9983, '\p{^inmiscellaneoussymbols}', "");
    Expect(0, 9983, '\P{inmiscellaneoussymbols}', "");
    Expect(1, 9983, '\P{^inmiscellaneoussymbols}', "");
    Expect(0, 9984, '\p{inmiscellaneoussymbols}', "");
    Expect(1, 9984, '\p{^inmiscellaneoussymbols}', "");
    Expect(1, 9984, '\P{inmiscellaneoussymbols}', "");
    Expect(0, 9984, '\P{^inmiscellaneoussymbols}', "");
    Expect(1, 9983, '\p{		IN_miscellaneous_symbols}', "");
    Expect(0, 9983, '\p{^		IN_miscellaneous_symbols}', "");
    Expect(0, 9983, '\P{		IN_miscellaneous_symbols}', "");
    Expect(1, 9983, '\P{^		IN_miscellaneous_symbols}', "");
    Expect(0, 9984, '\p{		IN_miscellaneous_symbols}', "");
    Expect(1, 9984, '\p{^		IN_miscellaneous_symbols}', "");
    Expect(1, 9984, '\P{		IN_miscellaneous_symbols}', "");
    Expect(0, 9984, '\P{^		IN_miscellaneous_symbols}', "");
    Error('\p{:=misc_SYMBOLS}');
    Error('\P{:=misc_SYMBOLS}');
    Expect(1, 9983, '\p{miscsymbols}', "");
    Expect(0, 9983, '\p{^miscsymbols}', "");
    Expect(0, 9983, '\P{miscsymbols}', "");
    Expect(1, 9983, '\P{^miscsymbols}', "");
    Expect(0, 9984, '\p{miscsymbols}', "");
    Expect(1, 9984, '\p{^miscsymbols}', "");
    Expect(1, 9984, '\P{miscsymbols}', "");
    Expect(0, 9984, '\P{^miscsymbols}', "");
    Expect(1, 9983, '\p{- Misc_SYMBOLS}', "");
    Expect(0, 9983, '\p{^- Misc_SYMBOLS}', "");
    Expect(0, 9983, '\P{- Misc_SYMBOLS}', "");
    Expect(1, 9983, '\P{^- Misc_SYMBOLS}', "");
    Expect(0, 9984, '\p{- Misc_SYMBOLS}', "");
    Expect(1, 9984, '\p{^- Misc_SYMBOLS}', "");
    Expect(1, 9984, '\P{- Misc_SYMBOLS}', "");
    Expect(0, 9984, '\P{^- Misc_SYMBOLS}', "");
    Error('\p{is_MISC_SYMBOLS:=}');
    Error('\P{is_MISC_SYMBOLS:=}');
    Expect(1, 9983, '\p{ismiscsymbols}', "");
    Expect(0, 9983, '\p{^ismiscsymbols}', "");
    Expect(0, 9983, '\P{ismiscsymbols}', "");
    Expect(1, 9983, '\P{^ismiscsymbols}', "");
    Expect(0, 9984, '\p{ismiscsymbols}', "");
    Expect(1, 9984, '\p{^ismiscsymbols}', "");
    Expect(1, 9984, '\P{ismiscsymbols}', "");
    Expect(0, 9984, '\P{^ismiscsymbols}', "");
    Expect(1, 9983, '\p{_-Is_Misc_Symbols}', "");
    Expect(0, 9983, '\p{^_-Is_Misc_Symbols}', "");
    Expect(0, 9983, '\P{_-Is_Misc_Symbols}', "");
    Expect(1, 9983, '\P{^_-Is_Misc_Symbols}', "");
    Expect(0, 9984, '\p{_-Is_Misc_Symbols}', "");
    Expect(1, 9984, '\p{^_-Is_Misc_Symbols}', "");
    Expect(1, 9984, '\P{_-Is_Misc_Symbols}', "");
    Expect(0, 9984, '\P{^_-Is_Misc_Symbols}', "");
    Error('\p{- in_MISC_Symbols:=}');
    Error('\P{- in_MISC_Symbols:=}');
    Expect(1, 9983, '\p{inmiscsymbols}', "");
    Expect(0, 9983, '\p{^inmiscsymbols}', "");
    Expect(0, 9983, '\P{inmiscsymbols}', "");
    Expect(1, 9983, '\P{^inmiscsymbols}', "");
    Expect(0, 9984, '\p{inmiscsymbols}', "");
    Expect(1, 9984, '\p{^inmiscsymbols}', "");
    Expect(1, 9984, '\P{inmiscsymbols}', "");
    Expect(0, 9984, '\P{^inmiscsymbols}', "");
    Expect(1, 9983, '\p{  In_misc_Symbols}', "");
    Expect(0, 9983, '\p{^  In_misc_Symbols}', "");
    Expect(0, 9983, '\P{  In_misc_Symbols}', "");
    Expect(1, 9983, '\P{^  In_misc_Symbols}', "");
    Expect(0, 9984, '\p{  In_misc_Symbols}', "");
    Expect(1, 9984, '\p{^  In_misc_Symbols}', "");
    Expect(1, 9984, '\P{  In_misc_Symbols}', "");
    Expect(0, 9984, '\P{^  In_misc_Symbols}', "");
    Error('\p{_ miscellaneous_Symbols_and_ARROWS/a/}');
    Error('\P{_ miscellaneous_Symbols_and_ARROWS/a/}');
    Expect(1, 11263, '\p{miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\p{^miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\P{miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\P{^miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\p{miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\p{^miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\P{miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\P{^miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\p{-_MISCELLANEOUS_Symbols_AND_ARROWS}', "");
    Expect(0, 11263, '\p{^-_MISCELLANEOUS_Symbols_AND_ARROWS}', "");
    Expect(0, 11263, '\P{-_MISCELLANEOUS_Symbols_AND_ARROWS}', "");
    Expect(1, 11263, '\P{^-_MISCELLANEOUS_Symbols_AND_ARROWS}', "");
    Expect(0, 11264, '\p{-_MISCELLANEOUS_Symbols_AND_ARROWS}', "");
    Expect(1, 11264, '\p{^-_MISCELLANEOUS_Symbols_AND_ARROWS}', "");
    Expect(1, 11264, '\P{-_MISCELLANEOUS_Symbols_AND_ARROWS}', "");
    Expect(0, 11264, '\P{^-_MISCELLANEOUS_Symbols_AND_ARROWS}', "");
    Error('\p{:=_Is_MISCELLANEOUS_Symbols_And_Arrows}');
    Error('\P{:=_Is_MISCELLANEOUS_Symbols_And_Arrows}');
    Expect(1, 11263, '\p{ismiscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\p{^ismiscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\P{ismiscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\P{^ismiscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\p{ismiscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\p{^ismiscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\P{ismiscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\P{^ismiscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\p{-	Is_miscellaneous_Symbols_and_arrows}', "");
    Expect(0, 11263, '\p{^-	Is_miscellaneous_Symbols_and_arrows}', "");
    Expect(0, 11263, '\P{-	Is_miscellaneous_Symbols_and_arrows}', "");
    Expect(1, 11263, '\P{^-	Is_miscellaneous_Symbols_and_arrows}', "");
    Expect(0, 11264, '\p{-	Is_miscellaneous_Symbols_and_arrows}', "");
    Expect(1, 11264, '\p{^-	Is_miscellaneous_Symbols_and_arrows}', "");
    Expect(1, 11264, '\P{-	Is_miscellaneous_Symbols_and_arrows}', "");
    Expect(0, 11264, '\P{^-	Is_miscellaneous_Symbols_and_arrows}', "");
    Error('\p{-:=IN_Miscellaneous_Symbols_And_Arrows}');
    Error('\P{-:=IN_Miscellaneous_Symbols_And_Arrows}');
    Expect(1, 11263, '\p{inmiscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\p{^inmiscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\P{inmiscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\P{^inmiscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\p{inmiscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\p{^inmiscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\P{inmiscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\P{^inmiscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\p{	in_Miscellaneous_symbols_And_ARROWS}', "");
    Expect(0, 11263, '\p{^	in_Miscellaneous_symbols_And_ARROWS}', "");
    Expect(0, 11263, '\P{	in_Miscellaneous_symbols_And_ARROWS}', "");
    Expect(1, 11263, '\P{^	in_Miscellaneous_symbols_And_ARROWS}', "");
    Expect(0, 11264, '\p{	in_Miscellaneous_symbols_And_ARROWS}', "");
    Expect(1, 11264, '\p{^	in_Miscellaneous_symbols_And_ARROWS}', "");
    Expect(1, 11264, '\P{	in_Miscellaneous_symbols_And_ARROWS}', "");
    Expect(0, 11264, '\P{^	in_Miscellaneous_symbols_And_ARROWS}', "");
    Error('\p{-/a/MISC_Arrows}');
    Error('\P{-/a/MISC_Arrows}');
    Expect(1, 11263, '\p{miscarrows}', "");
    Expect(0, 11263, '\p{^miscarrows}', "");
    Expect(0, 11263, '\P{miscarrows}', "");
    Expect(1, 11263, '\P{^miscarrows}', "");
    Expect(0, 11264, '\p{miscarrows}', "");
    Expect(1, 11264, '\p{^miscarrows}', "");
    Expect(1, 11264, '\P{miscarrows}', "");
    Expect(0, 11264, '\P{^miscarrows}', "");
    Expect(1, 11263, '\p{- Misc_arrows}', "");
    Expect(0, 11263, '\p{^- Misc_arrows}', "");
    Expect(0, 11263, '\P{- Misc_arrows}', "");
    Expect(1, 11263, '\P{^- Misc_arrows}', "");
    Expect(0, 11264, '\p{- Misc_arrows}', "");
    Expect(1, 11264, '\p{^- Misc_arrows}', "");
    Expect(1, 11264, '\P{- Misc_arrows}', "");
    Expect(0, 11264, '\P{^- Misc_arrows}', "");
    Error('\p{		is_MISC_Arrows/a/}');
    Error('\P{		is_MISC_Arrows/a/}');
    Expect(1, 11263, '\p{ismiscarrows}', "");
    Expect(0, 11263, '\p{^ismiscarrows}', "");
    Expect(0, 11263, '\P{ismiscarrows}', "");
    Expect(1, 11263, '\P{^ismiscarrows}', "");
    Expect(0, 11264, '\p{ismiscarrows}', "");
    Expect(1, 11264, '\p{^ismiscarrows}', "");
    Expect(1, 11264, '\P{ismiscarrows}', "");
    Expect(0, 11264, '\P{^ismiscarrows}', "");
    Expect(1, 11263, '\p{_-is_MISC_Arrows}', "");
    Expect(0, 11263, '\p{^_-is_MISC_Arrows}', "");
    Expect(0, 11263, '\P{_-is_MISC_Arrows}', "");
    Expect(1, 11263, '\P{^_-is_MISC_Arrows}', "");
    Expect(0, 11264, '\p{_-is_MISC_Arrows}', "");
    Expect(1, 11264, '\p{^_-is_MISC_Arrows}', "");
    Expect(1, 11264, '\P{_-is_MISC_Arrows}', "");
    Expect(0, 11264, '\P{^_-is_MISC_Arrows}', "");
    Error('\p{:=_ IN_Misc_Arrows}');
    Error('\P{:=_ IN_Misc_Arrows}');
    Expect(1, 11263, '\p{inmiscarrows}', "");
    Expect(0, 11263, '\p{^inmiscarrows}', "");
    Expect(0, 11263, '\P{inmiscarrows}', "");
    Expect(1, 11263, '\P{^inmiscarrows}', "");
    Expect(0, 11264, '\p{inmiscarrows}', "");
    Expect(1, 11264, '\p{^inmiscarrows}', "");
    Expect(1, 11264, '\P{inmiscarrows}', "");
    Expect(0, 11264, '\P{^inmiscarrows}', "");
    Expect(1, 11263, '\p{in_MISC_Arrows}', "");
    Expect(0, 11263, '\p{^in_MISC_Arrows}', "");
    Expect(0, 11263, '\P{in_MISC_Arrows}', "");
    Expect(1, 11263, '\P{^in_MISC_Arrows}', "");
    Expect(0, 11264, '\p{in_MISC_Arrows}', "");
    Expect(1, 11264, '\p{^in_MISC_Arrows}', "");
    Expect(1, 11264, '\P{in_MISC_Arrows}', "");
    Expect(0, 11264, '\P{^in_MISC_Arrows}', "");
    Error('\p{_-Miscellaneous_Symbols_And_pictographs:=}');
    Error('\P{_-Miscellaneous_Symbols_And_pictographs:=}');
    Expect(1, 128511, '\p{miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\p{^miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\P{miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\P{^miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\p{miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\p{^miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\P{miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\P{^miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\p{-	miscellaneous_SYMBOLS_and_PICTOGRAPHS}', "");
    Expect(0, 128511, '\p{^-	miscellaneous_SYMBOLS_and_PICTOGRAPHS}', "");
    Expect(0, 128511, '\P{-	miscellaneous_SYMBOLS_and_PICTOGRAPHS}', "");
    Expect(1, 128511, '\P{^-	miscellaneous_SYMBOLS_and_PICTOGRAPHS}', "");
    Expect(0, 128512, '\p{-	miscellaneous_SYMBOLS_and_PICTOGRAPHS}', "");
    Expect(1, 128512, '\p{^-	miscellaneous_SYMBOLS_and_PICTOGRAPHS}', "");
    Expect(1, 128512, '\P{-	miscellaneous_SYMBOLS_and_PICTOGRAPHS}', "");
    Expect(0, 128512, '\P{^-	miscellaneous_SYMBOLS_and_PICTOGRAPHS}', "");
    Error('\p{/a/-_Is_Miscellaneous_Symbols_and_Pictographs}');
    Error('\P{/a/-_Is_Miscellaneous_Symbols_and_Pictographs}');
    Expect(1, 128511, '\p{ismiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\p{^ismiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\P{ismiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\P{^ismiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\p{ismiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\p{^ismiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\P{ismiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\P{^ismiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\p{ is_MISCELLANEOUS_Symbols_AND_Pictographs}', "");
    Expect(0, 128511, '\p{^ is_MISCELLANEOUS_Symbols_AND_Pictographs}', "");
    Expect(0, 128511, '\P{ is_MISCELLANEOUS_Symbols_AND_Pictographs}', "");
    Expect(1, 128511, '\P{^ is_MISCELLANEOUS_Symbols_AND_Pictographs}', "");
    Expect(0, 128512, '\p{ is_MISCELLANEOUS_Symbols_AND_Pictographs}', "");
    Expect(1, 128512, '\p{^ is_MISCELLANEOUS_Symbols_AND_Pictographs}', "");
    Expect(1, 128512, '\P{ is_MISCELLANEOUS_Symbols_AND_Pictographs}', "");
    Expect(0, 128512, '\P{^ is_MISCELLANEOUS_Symbols_AND_Pictographs}', "");
    Error('\p{_/a/In_Miscellaneous_Symbols_AND_PICTOGRAPHS}');
    Error('\P{_/a/In_Miscellaneous_Symbols_AND_PICTOGRAPHS}');
    Expect(1, 128511, '\p{inmiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\p{^inmiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\P{inmiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\P{^inmiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\p{inmiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\p{^inmiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\P{inmiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\P{^inmiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\p{- IN_miscellaneous_Symbols_and_Pictographs}', "");
    Expect(0, 128511, '\p{^- IN_miscellaneous_Symbols_and_Pictographs}', "");
    Expect(0, 128511, '\P{- IN_miscellaneous_Symbols_and_Pictographs}', "");
    Expect(1, 128511, '\P{^- IN_miscellaneous_Symbols_and_Pictographs}', "");
    Expect(0, 128512, '\p{- IN_miscellaneous_Symbols_and_Pictographs}', "");
    Expect(1, 128512, '\p{^- IN_miscellaneous_Symbols_and_Pictographs}', "");
    Expect(1, 128512, '\P{- IN_miscellaneous_Symbols_and_Pictographs}', "");
    Expect(0, 128512, '\P{^- IN_miscellaneous_Symbols_and_Pictographs}', "");
    Error('\p{:=	Misc_Pictographs}');
    Error('\P{:=	Misc_Pictographs}');
    Expect(1, 128511, '\p{miscpictographs}', "");
    Expect(0, 128511, '\p{^miscpictographs}', "");
    Expect(0, 128511, '\P{miscpictographs}', "");
    Expect(1, 128511, '\P{^miscpictographs}', "");
    Expect(0, 128512, '\p{miscpictographs}', "");
    Expect(1, 128512, '\p{^miscpictographs}', "");
    Expect(1, 128512, '\P{miscpictographs}', "");
    Expect(0, 128512, '\P{^miscpictographs}', "");
    Expect(1, 128511, '\p{-misc_pictographs}', "");
    Expect(0, 128511, '\p{^-misc_pictographs}', "");
    Expect(0, 128511, '\P{-misc_pictographs}', "");
    Expect(1, 128511, '\P{^-misc_pictographs}', "");
    Expect(0, 128512, '\p{-misc_pictographs}', "");
    Expect(1, 128512, '\p{^-misc_pictographs}', "");
    Expect(1, 128512, '\P{-misc_pictographs}', "");
    Expect(0, 128512, '\P{^-misc_pictographs}', "");
    Error('\p{ :=Is_Misc_PICTOGRAPHS}');
    Error('\P{ :=Is_Misc_PICTOGRAPHS}');
    Expect(1, 128511, '\p{ismiscpictographs}', "");
    Expect(0, 128511, '\p{^ismiscpictographs}', "");
    Expect(0, 128511, '\P{ismiscpictographs}', "");
    Expect(1, 128511, '\P{^ismiscpictographs}', "");
    Expect(0, 128512, '\p{ismiscpictographs}', "");
    Expect(1, 128512, '\p{^ismiscpictographs}', "");
    Expect(1, 128512, '\P{ismiscpictographs}', "");
    Expect(0, 128512, '\P{^ismiscpictographs}', "");
    Expect(1, 128511, '\p{- IS_Misc_pictographs}', "");
    Expect(0, 128511, '\p{^- IS_Misc_pictographs}', "");
    Expect(0, 128511, '\P{- IS_Misc_pictographs}', "");
    Expect(1, 128511, '\P{^- IS_Misc_pictographs}', "");
    Expect(0, 128512, '\p{- IS_Misc_pictographs}', "");
    Expect(1, 128512, '\p{^- IS_Misc_pictographs}', "");
    Expect(1, 128512, '\P{- IS_Misc_pictographs}', "");
    Expect(0, 128512, '\P{^- IS_Misc_pictographs}', "");
    Error('\p{	:=In_Misc_Pictographs}');
    Error('\P{	:=In_Misc_Pictographs}');
    Expect(1, 128511, '\p{inmiscpictographs}', "");
    Expect(0, 128511, '\p{^inmiscpictographs}', "");
    Expect(0, 128511, '\P{inmiscpictographs}', "");
    Expect(1, 128511, '\P{^inmiscpictographs}', "");
    Expect(0, 128512, '\p{inmiscpictographs}', "");
    Expect(1, 128512, '\p{^inmiscpictographs}', "");
    Expect(1, 128512, '\P{inmiscpictographs}', "");
    Expect(0, 128512, '\P{^inmiscpictographs}', "");
    Expect(1, 128511, '\p{ _IN_Misc_PICTOGRAPHS}', "");
    Expect(0, 128511, '\p{^ _IN_Misc_PICTOGRAPHS}', "");
    Expect(0, 128511, '\P{ _IN_Misc_PICTOGRAPHS}', "");
    Expect(1, 128511, '\P{^ _IN_Misc_PICTOGRAPHS}', "");
    Expect(0, 128512, '\p{ _IN_Misc_PICTOGRAPHS}', "");
    Expect(1, 128512, '\p{^ _IN_Misc_PICTOGRAPHS}', "");
    Expect(1, 128512, '\P{ _IN_Misc_PICTOGRAPHS}', "");
    Expect(0, 128512, '\P{^ _IN_Misc_PICTOGRAPHS}', "");
    Error('\p{	/a/Miscellaneous_Technical}');
    Error('\P{	/a/Miscellaneous_Technical}');
    Expect(1, 9215, '\p{miscellaneoustechnical}', "");
    Expect(0, 9215, '\p{^miscellaneoustechnical}', "");
    Expect(0, 9215, '\P{miscellaneoustechnical}', "");
    Expect(1, 9215, '\P{^miscellaneoustechnical}', "");
    Expect(0, 9216, '\p{miscellaneoustechnical}', "");
    Expect(1, 9216, '\p{^miscellaneoustechnical}', "");
    Expect(1, 9216, '\P{miscellaneoustechnical}', "");
    Expect(0, 9216, '\P{^miscellaneoustechnical}', "");
    Expect(1, 9215, '\p{_ MISCELLANEOUS_technical}', "");
    Expect(0, 9215, '\p{^_ MISCELLANEOUS_technical}', "");
    Expect(0, 9215, '\P{_ MISCELLANEOUS_technical}', "");
    Expect(1, 9215, '\P{^_ MISCELLANEOUS_technical}', "");
    Expect(0, 9216, '\p{_ MISCELLANEOUS_technical}', "");
    Expect(1, 9216, '\p{^_ MISCELLANEOUS_technical}', "");
    Expect(1, 9216, '\P{_ MISCELLANEOUS_technical}', "");
    Expect(0, 9216, '\P{^_ MISCELLANEOUS_technical}', "");
    Error('\p{:=	 Is_Miscellaneous_technical}');
    Error('\P{:=	 Is_Miscellaneous_technical}');
    Expect(1, 9215, '\p{ismiscellaneoustechnical}', "");
    Expect(0, 9215, '\p{^ismiscellaneoustechnical}', "");
    Expect(0, 9215, '\P{ismiscellaneoustechnical}', "");
    Expect(1, 9215, '\P{^ismiscellaneoustechnical}', "");
    Expect(0, 9216, '\p{ismiscellaneoustechnical}', "");
    Expect(1, 9216, '\p{^ismiscellaneoustechnical}', "");
    Expect(1, 9216, '\P{ismiscellaneoustechnical}', "");
    Expect(0, 9216, '\P{^ismiscellaneoustechnical}', "");
    Expect(1, 9215, '\p{_-Is_Miscellaneous_TECHNICAL}', "");
    Expect(0, 9215, '\p{^_-Is_Miscellaneous_TECHNICAL}', "");
    Expect(0, 9215, '\P{_-Is_Miscellaneous_TECHNICAL}', "");
    Expect(1, 9215, '\P{^_-Is_Miscellaneous_TECHNICAL}', "");
    Expect(0, 9216, '\p{_-Is_Miscellaneous_TECHNICAL}', "");
    Expect(1, 9216, '\p{^_-Is_Miscellaneous_TECHNICAL}', "");
    Expect(1, 9216, '\P{_-Is_Miscellaneous_TECHNICAL}', "");
    Expect(0, 9216, '\P{^_-Is_Miscellaneous_TECHNICAL}', "");
    Error('\p{ -In_Miscellaneous_Technical:=}');
    Error('\P{ -In_Miscellaneous_Technical:=}');
    Expect(1, 9215, '\p{inmiscellaneoustechnical}', "");
    Expect(0, 9215, '\p{^inmiscellaneoustechnical}', "");
    Expect(0, 9215, '\P{inmiscellaneoustechnical}', "");
    Expect(1, 9215, '\P{^inmiscellaneoustechnical}', "");
    Expect(0, 9216, '\p{inmiscellaneoustechnical}', "");
    Expect(1, 9216, '\p{^inmiscellaneoustechnical}', "");
    Expect(1, 9216, '\P{inmiscellaneoustechnical}', "");
    Expect(0, 9216, '\P{^inmiscellaneoustechnical}', "");
    Expect(1, 9215, '\p{In_Miscellaneous_Technical}', "");
    Expect(0, 9215, '\p{^In_Miscellaneous_Technical}', "");
    Expect(0, 9215, '\P{In_Miscellaneous_Technical}', "");
    Expect(1, 9215, '\P{^In_Miscellaneous_Technical}', "");
    Expect(0, 9216, '\p{In_Miscellaneous_Technical}', "");
    Expect(1, 9216, '\p{^In_Miscellaneous_Technical}', "");
    Expect(1, 9216, '\P{In_Miscellaneous_Technical}', "");
    Expect(0, 9216, '\P{^In_Miscellaneous_Technical}', "");
    Error('\p{	/a/Misc_Technical}');
    Error('\P{	/a/Misc_Technical}');
    Expect(1, 9215, '\p{misctechnical}', "");
    Expect(0, 9215, '\p{^misctechnical}', "");
    Expect(0, 9215, '\P{misctechnical}', "");
    Expect(1, 9215, '\P{^misctechnical}', "");
    Expect(0, 9216, '\p{misctechnical}', "");
    Expect(1, 9216, '\p{^misctechnical}', "");
    Expect(1, 9216, '\P{misctechnical}', "");
    Expect(0, 9216, '\P{^misctechnical}', "");
    Expect(1, 9215, '\p{- MISC_Technical}', "");
    Expect(0, 9215, '\p{^- MISC_Technical}', "");
    Expect(0, 9215, '\P{- MISC_Technical}', "");
    Expect(1, 9215, '\P{^- MISC_Technical}', "");
    Expect(0, 9216, '\p{- MISC_Technical}', "");
    Expect(1, 9216, '\p{^- MISC_Technical}', "");
    Expect(1, 9216, '\P{- MISC_Technical}', "");
    Expect(0, 9216, '\P{^- MISC_Technical}', "");
    Error('\p{-IS_MISC_Technical:=}');
    Error('\P{-IS_MISC_Technical:=}');
    Expect(1, 9215, '\p{ismisctechnical}', "");
    Expect(0, 9215, '\p{^ismisctechnical}', "");
    Expect(0, 9215, '\P{ismisctechnical}', "");
    Expect(1, 9215, '\P{^ismisctechnical}', "");
    Expect(0, 9216, '\p{ismisctechnical}', "");
    Expect(1, 9216, '\p{^ismisctechnical}', "");
    Expect(1, 9216, '\P{ismisctechnical}', "");
    Expect(0, 9216, '\P{^ismisctechnical}', "");
    Expect(1, 9215, '\p{_	IS_Misc_TECHNICAL}', "");
    Expect(0, 9215, '\p{^_	IS_Misc_TECHNICAL}', "");
    Expect(0, 9215, '\P{_	IS_Misc_TECHNICAL}', "");
    Expect(1, 9215, '\P{^_	IS_Misc_TECHNICAL}', "");
    Expect(0, 9216, '\p{_	IS_Misc_TECHNICAL}', "");
    Expect(1, 9216, '\p{^_	IS_Misc_TECHNICAL}', "");
    Expect(1, 9216, '\P{_	IS_Misc_TECHNICAL}', "");
    Expect(0, 9216, '\P{^_	IS_Misc_TECHNICAL}', "");
    Error('\p{:=In_Misc_Technical}');
    Error('\P{:=In_Misc_Technical}');
    Expect(1, 9215, '\p{inmisctechnical}', "");
    Expect(0, 9215, '\p{^inmisctechnical}', "");
    Expect(0, 9215, '\P{inmisctechnical}', "");
    Expect(1, 9215, '\P{^inmisctechnical}', "");
    Expect(0, 9216, '\p{inmisctechnical}', "");
    Expect(1, 9216, '\p{^inmisctechnical}', "");
    Expect(1, 9216, '\P{inmisctechnical}', "");
    Expect(0, 9216, '\P{^inmisctechnical}', "");
    Expect(1, 9215, '\p{-	IN_Misc_technical}', "");
    Expect(0, 9215, '\p{^-	IN_Misc_technical}', "");
    Expect(0, 9215, '\P{-	IN_Misc_technical}', "");
    Expect(1, 9215, '\P{^-	IN_Misc_technical}', "");
    Expect(0, 9216, '\p{-	IN_Misc_technical}', "");
    Expect(1, 9216, '\p{^-	IN_Misc_technical}', "");
    Expect(1, 9216, '\P{-	IN_Misc_technical}', "");
    Expect(0, 9216, '\P{^-	IN_Misc_technical}', "");
    Error('\p{-/a/Modi}');
    Error('\P{-/a/Modi}');
    Expect(1, 71257, '\p{modi}', "");
    Expect(0, 71257, '\p{^modi}', "");
    Expect(0, 71257, '\P{modi}', "");
    Expect(1, 71257, '\P{^modi}', "");
    Expect(0, 71258, '\p{modi}', "");
    Expect(1, 71258, '\p{^modi}', "");
    Expect(1, 71258, '\P{modi}', "");
    Expect(0, 71258, '\P{^modi}', "");
    Expect(1, 71257, '\p{-	Modi}', "");
    Expect(0, 71257, '\p{^-	Modi}', "");
    Expect(0, 71257, '\P{-	Modi}', "");
    Expect(1, 71257, '\P{^-	Modi}', "");
    Expect(0, 71258, '\p{-	Modi}', "");
    Expect(1, 71258, '\p{^-	Modi}', "");
    Expect(1, 71258, '\P{-	Modi}', "");
    Expect(0, 71258, '\P{^-	Modi}', "");
    Error('\p{_:=is_MODI}');
    Error('\P{_:=is_MODI}');
    Expect(1, 71257, '\p{ismodi}', "");
    Expect(0, 71257, '\p{^ismodi}', "");
    Expect(0, 71257, '\P{ismodi}', "");
    Expect(1, 71257, '\P{^ismodi}', "");
    Expect(0, 71258, '\p{ismodi}', "");
    Expect(1, 71258, '\p{^ismodi}', "");
    Expect(1, 71258, '\P{ismodi}', "");
    Expect(0, 71258, '\P{^ismodi}', "");
    Expect(1, 71257, '\p{ Is_Modi}', "");
    Expect(0, 71257, '\p{^ Is_Modi}', "");
    Expect(0, 71257, '\P{ Is_Modi}', "");
    Expect(1, 71257, '\P{^ Is_Modi}', "");
    Expect(0, 71258, '\p{ Is_Modi}', "");
    Expect(1, 71258, '\p{^ Is_Modi}', "");
    Expect(1, 71258, '\P{ Is_Modi}', "");
    Expect(0, 71258, '\P{^ Is_Modi}', "");
    Error('\p{_ Modifier_letter/a/}');
    Error('\P{_ Modifier_letter/a/}');
    Expect(1, 94177, '\p{modifierletter}', "");
    Expect(0, 94177, '\p{^modifierletter}', "");
    Expect(0, 94177, '\P{modifierletter}', "");
    Expect(1, 94177, '\P{^modifierletter}', "");
    Expect(0, 94178, '\p{modifierletter}', "");
    Expect(1, 94178, '\p{^modifierletter}', "");
    Expect(1, 94178, '\P{modifierletter}', "");
    Expect(0, 94178, '\P{^modifierletter}', "");
    Expect(1, 94177, '\p{-modifier_Letter}', "");
    Expect(0, 94177, '\p{^-modifier_Letter}', "");
    Expect(0, 94177, '\P{-modifier_Letter}', "");
    Expect(1, 94177, '\P{^-modifier_Letter}', "");
    Expect(0, 94178, '\p{-modifier_Letter}', "");
    Expect(1, 94178, '\p{^-modifier_Letter}', "");
    Expect(1, 94178, '\P{-modifier_Letter}', "");
    Expect(0, 94178, '\P{^-modifier_Letter}', "");
    Error('\p{/a/IS_Modifier_Letter}');
    Error('\P{/a/IS_Modifier_Letter}');
    Expect(1, 94177, '\p{ismodifierletter}', "");
    Expect(0, 94177, '\p{^ismodifierletter}', "");
    Expect(0, 94177, '\P{ismodifierletter}', "");
    Expect(1, 94177, '\P{^ismodifierletter}', "");
    Expect(0, 94178, '\p{ismodifierletter}', "");
    Expect(1, 94178, '\p{^ismodifierletter}', "");
    Expect(1, 94178, '\P{ismodifierletter}', "");
    Expect(0, 94178, '\P{^ismodifierletter}', "");
    Expect(1, 94177, '\p{	_Is_MODIFIER_Letter}', "");
    Expect(0, 94177, '\p{^	_Is_MODIFIER_Letter}', "");
    Expect(0, 94177, '\P{	_Is_MODIFIER_Letter}', "");
    Expect(1, 94177, '\P{^	_Is_MODIFIER_Letter}', "");
    Expect(0, 94178, '\p{	_Is_MODIFIER_Letter}', "");
    Expect(1, 94178, '\p{^	_Is_MODIFIER_Letter}', "");
    Expect(1, 94178, '\P{	_Is_MODIFIER_Letter}', "");
    Expect(0, 94178, '\P{^	_Is_MODIFIER_Letter}', "");
    Error('\p{:= 	Lm}');
    Error('\P{:= 	Lm}');
    Expect(1, 94177, '\p{lm}', "");
    Expect(0, 94177, '\p{^lm}', "");
    Expect(0, 94177, '\P{lm}', "");
    Expect(1, 94177, '\P{^lm}', "");
    Expect(0, 94178, '\p{lm}', "");
    Expect(1, 94178, '\p{^lm}', "");
    Expect(1, 94178, '\P{lm}', "");
    Expect(0, 94178, '\P{^lm}', "");
    Expect(1, 94177, '\p{ lm}', "");
    Expect(0, 94177, '\p{^ lm}', "");
    Expect(0, 94177, '\P{ lm}', "");
    Expect(1, 94177, '\P{^ lm}', "");
    Expect(0, 94178, '\p{ lm}', "");
    Expect(1, 94178, '\p{^ lm}', "");
    Expect(1, 94178, '\P{ lm}', "");
    Expect(0, 94178, '\P{^ lm}', "");
    Error('\p{:=-is_Lm}');
    Error('\P{:=-is_Lm}');
    Expect(1, 94177, '\p{islm}', "");
    Expect(0, 94177, '\p{^islm}', "");
    Expect(0, 94177, '\P{islm}', "");
    Expect(1, 94177, '\P{^islm}', "");
    Expect(0, 94178, '\p{islm}', "");
    Expect(1, 94178, '\p{^islm}', "");
    Expect(1, 94178, '\P{islm}', "");
    Expect(0, 94178, '\P{^islm}', "");
    Expect(1, 94177, '\p{Is_Lm}', "");
    Expect(0, 94177, '\p{^Is_Lm}', "");
    Expect(0, 94177, '\P{Is_Lm}', "");
    Expect(1, 94177, '\P{^Is_Lm}', "");
    Expect(0, 94178, '\p{Is_Lm}', "");
    Expect(1, 94178, '\p{^Is_Lm}', "");
    Expect(1, 94178, '\P{Is_Lm}', "");
    Expect(0, 94178, '\P{^Is_Lm}', "");
    Error('\p{/a/- modifier_symbol}');
    Error('\P{/a/- modifier_symbol}');
    Expect(1, 127999, '\p{modifiersymbol}', "");
    Expect(0, 127999, '\p{^modifiersymbol}', "");
    Expect(0, 127999, '\P{modifiersymbol}', "");
    Expect(1, 127999, '\P{^modifiersymbol}', "");
    Expect(0, 128000, '\p{modifiersymbol}', "");
    Expect(1, 128000, '\p{^modifiersymbol}', "");
    Expect(1, 128000, '\P{modifiersymbol}', "");
    Expect(0, 128000, '\P{^modifiersymbol}', "");
    Expect(1, 127999, '\p{ -Modifier_SYMBOL}', "");
    Expect(0, 127999, '\p{^ -Modifier_SYMBOL}', "");
    Expect(0, 127999, '\P{ -Modifier_SYMBOL}', "");
    Expect(1, 127999, '\P{^ -Modifier_SYMBOL}', "");
    Expect(0, 128000, '\p{ -Modifier_SYMBOL}', "");
    Expect(1, 128000, '\p{^ -Modifier_SYMBOL}', "");
    Expect(1, 128000, '\P{ -Modifier_SYMBOL}', "");
    Expect(0, 128000, '\P{^ -Modifier_SYMBOL}', "");
    Error('\p{_/a/is_MODIFIER_Symbol}');
    Error('\P{_/a/is_MODIFIER_Symbol}');
    Expect(1, 127999, '\p{ismodifiersymbol}', "");
    Expect(0, 127999, '\p{^ismodifiersymbol}', "");
    Expect(0, 127999, '\P{ismodifiersymbol}', "");
    Expect(1, 127999, '\P{^ismodifiersymbol}', "");
    Expect(0, 128000, '\p{ismodifiersymbol}', "");
    Expect(1, 128000, '\p{^ismodifiersymbol}', "");
    Expect(1, 128000, '\P{ismodifiersymbol}', "");
    Expect(0, 128000, '\P{^ismodifiersymbol}', "");
    Expect(1, 127999, '\p{-	IS_modifier_Symbol}', "");
    Expect(0, 127999, '\p{^-	IS_modifier_Symbol}', "");
    Expect(0, 127999, '\P{-	IS_modifier_Symbol}', "");
    Expect(1, 127999, '\P{^-	IS_modifier_Symbol}', "");
    Expect(0, 128000, '\p{-	IS_modifier_Symbol}', "");
    Expect(1, 128000, '\p{^-	IS_modifier_Symbol}', "");
    Expect(1, 128000, '\P{-	IS_modifier_Symbol}', "");
    Expect(0, 128000, '\P{^-	IS_modifier_Symbol}', "");
    Error('\p{/a/	sk}');
    Error('\P{/a/	sk}');
    Expect(1, 127999, '\p{sk}', "");
    Expect(0, 127999, '\p{^sk}', "");
    Expect(0, 127999, '\P{sk}', "");
    Expect(1, 127999, '\P{^sk}', "");
    Expect(0, 128000, '\p{sk}', "");
    Expect(1, 128000, '\p{^sk}', "");
    Expect(1, 128000, '\P{sk}', "");
    Expect(0, 128000, '\P{^sk}', "");
    Expect(1, 127999, '\p{_sk}', "");
    Expect(0, 127999, '\p{^_sk}', "");
    Expect(0, 127999, '\P{_sk}', "");
    Expect(1, 127999, '\P{^_sk}', "");
    Expect(0, 128000, '\p{_sk}', "");
    Expect(1, 128000, '\p{^_sk}', "");
    Expect(1, 128000, '\P{_sk}', "");
    Expect(0, 128000, '\P{^_sk}', "");
    Error('\p{:=	Is_Sk}');
    Error('\P{:=	Is_Sk}');
    Expect(1, 127999, '\p{issk}', "");
    Expect(0, 127999, '\p{^issk}', "");
    Expect(0, 127999, '\P{issk}', "");
    Expect(1, 127999, '\P{^issk}', "");
    Expect(0, 128000, '\p{issk}', "");
    Expect(1, 128000, '\p{^issk}', "");
    Expect(1, 128000, '\P{issk}', "");
    Expect(0, 128000, '\P{^issk}', "");
    Expect(1, 127999, '\p{ IS_sk}', "");
    Expect(0, 127999, '\p{^ IS_sk}', "");
    Expect(0, 127999, '\P{ IS_sk}', "");
    Expect(1, 127999, '\P{^ IS_sk}', "");
    Expect(0, 128000, '\p{ IS_sk}', "");
    Expect(1, 128000, '\p{^ IS_sk}', "");
    Expect(1, 128000, '\P{ IS_sk}', "");
    Expect(0, 128000, '\P{^ IS_sk}', "");
    Error('\p{ /a/Modifier_tone_Letters}');
    Error('\P{ /a/Modifier_tone_Letters}');
    Expect(1, 42783, '\p{modifiertoneletters}', "");
    Expect(0, 42783, '\p{^modifiertoneletters}', "");
    Expect(0, 42783, '\P{modifiertoneletters}', "");
    Expect(1, 42783, '\P{^modifiertoneletters}', "");
    Expect(0, 42784, '\p{modifiertoneletters}', "");
    Expect(1, 42784, '\p{^modifiertoneletters}', "");
    Expect(1, 42784, '\P{modifiertoneletters}', "");
    Expect(0, 42784, '\P{^modifiertoneletters}', "");
    Expect(1, 42783, '\p{_ MODIFIER_TONE_Letters}', "");
    Expect(0, 42783, '\p{^_ MODIFIER_TONE_Letters}', "");
    Expect(0, 42783, '\P{_ MODIFIER_TONE_Letters}', "");
    Expect(1, 42783, '\P{^_ MODIFIER_TONE_Letters}', "");
    Expect(0, 42784, '\p{_ MODIFIER_TONE_Letters}', "");
    Expect(1, 42784, '\p{^_ MODIFIER_TONE_Letters}', "");
    Expect(1, 42784, '\P{_ MODIFIER_TONE_Letters}', "");
    Expect(0, 42784, '\P{^_ MODIFIER_TONE_Letters}', "");
    Error('\p{/a/	-Is_Modifier_Tone_Letters}');
    Error('\P{/a/	-Is_Modifier_Tone_Letters}');
    Expect(1, 42783, '\p{ismodifiertoneletters}', "");
    Expect(0, 42783, '\p{^ismodifiertoneletters}', "");
    Expect(0, 42783, '\P{ismodifiertoneletters}', "");
    Expect(1, 42783, '\P{^ismodifiertoneletters}', "");
    Expect(0, 42784, '\p{ismodifiertoneletters}', "");
    Expect(1, 42784, '\p{^ismodifiertoneletters}', "");
    Expect(1, 42784, '\P{ismodifiertoneletters}', "");
    Expect(0, 42784, '\P{^ismodifiertoneletters}', "");
    Expect(1, 42783, '\p{_Is_modifier_Tone_LETTERS}', "");
    Expect(0, 42783, '\p{^_Is_modifier_Tone_LETTERS}', "");
    Expect(0, 42783, '\P{_Is_modifier_Tone_LETTERS}', "");
    Expect(1, 42783, '\P{^_Is_modifier_Tone_LETTERS}', "");
    Expect(0, 42784, '\p{_Is_modifier_Tone_LETTERS}', "");
    Expect(1, 42784, '\p{^_Is_modifier_Tone_LETTERS}', "");
    Expect(1, 42784, '\P{_Is_modifier_Tone_LETTERS}', "");
    Expect(0, 42784, '\P{^_Is_modifier_Tone_LETTERS}', "");
    Error('\p{/a/	In_Modifier_Tone_Letters}');
    Error('\P{/a/	In_Modifier_Tone_Letters}');
    Expect(1, 42783, '\p{inmodifiertoneletters}', "");
    Expect(0, 42783, '\p{^inmodifiertoneletters}', "");
    Expect(0, 42783, '\P{inmodifiertoneletters}', "");
    Expect(1, 42783, '\P{^inmodifiertoneletters}', "");
    Expect(0, 42784, '\p{inmodifiertoneletters}', "");
    Expect(1, 42784, '\p{^inmodifiertoneletters}', "");
    Expect(1, 42784, '\P{inmodifiertoneletters}', "");
    Expect(0, 42784, '\P{^inmodifiertoneletters}', "");
    Expect(1, 42783, '\p{-in_Modifier_TONE_Letters}', "");
    Expect(0, 42783, '\p{^-in_Modifier_TONE_Letters}', "");
    Expect(0, 42783, '\P{-in_Modifier_TONE_Letters}', "");
    Expect(1, 42783, '\P{^-in_Modifier_TONE_Letters}', "");
    Expect(0, 42784, '\p{-in_Modifier_TONE_Letters}', "");
    Expect(1, 42784, '\p{^-in_Modifier_TONE_Letters}', "");
    Expect(1, 42784, '\P{-in_Modifier_TONE_Letters}', "");
    Expect(0, 42784, '\P{^-in_Modifier_TONE_Letters}', "");
    Error('\p{:=Mongolian}');
    Error('\P{:=Mongolian}');
    Expect(1, 71276, '\p{mongolian}', "");
    Expect(0, 71276, '\p{^mongolian}', "");
    Expect(0, 71276, '\P{mongolian}', "");
    Expect(1, 71276, '\P{^mongolian}', "");
    Expect(0, 71277, '\p{mongolian}', "");
    Expect(1, 71277, '\p{^mongolian}', "");
    Expect(1, 71277, '\P{mongolian}', "");
    Expect(0, 71277, '\P{^mongolian}', "");
    Expect(1, 71276, '\p{ MONGOLIAN}', "");
    Expect(0, 71276, '\p{^ MONGOLIAN}', "");
    Expect(0, 71276, '\P{ MONGOLIAN}', "");
    Expect(1, 71276, '\P{^ MONGOLIAN}', "");
    Expect(0, 71277, '\p{ MONGOLIAN}', "");
    Expect(1, 71277, '\p{^ MONGOLIAN}', "");
    Expect(1, 71277, '\P{ MONGOLIAN}', "");
    Expect(0, 71277, '\P{^ MONGOLIAN}', "");
    Error('\p{	/a/is_Mongolian}');
    Error('\P{	/a/is_Mongolian}');
    Expect(1, 71276, '\p{ismongolian}', "");
    Expect(0, 71276, '\p{^ismongolian}', "");
    Expect(0, 71276, '\P{ismongolian}', "");
    Expect(1, 71276, '\P{^ismongolian}', "");
    Expect(0, 71277, '\p{ismongolian}', "");
    Expect(1, 71277, '\p{^ismongolian}', "");
    Expect(1, 71277, '\P{ismongolian}', "");
    Expect(0, 71277, '\P{^ismongolian}', "");
    Expect(1, 71276, '\p{__is_MONGOLIAN}', "");
    Expect(0, 71276, '\p{^__is_MONGOLIAN}', "");
    Expect(0, 71276, '\P{__is_MONGOLIAN}', "");
    Expect(1, 71276, '\P{^__is_MONGOLIAN}', "");
    Expect(0, 71277, '\p{__is_MONGOLIAN}', "");
    Expect(1, 71277, '\p{^__is_MONGOLIAN}', "");
    Expect(1, 71277, '\P{__is_MONGOLIAN}', "");
    Expect(0, 71277, '\P{^__is_MONGOLIAN}', "");
    Error('\p{:=-_MONG}');
    Error('\P{:=-_MONG}');
    Expect(1, 71276, '\p{mong}', "");
    Expect(0, 71276, '\p{^mong}', "");
    Expect(0, 71276, '\P{mong}', "");
    Expect(1, 71276, '\P{^mong}', "");
    Expect(0, 71277, '\p{mong}', "");
    Expect(1, 71277, '\p{^mong}', "");
    Expect(1, 71277, '\P{mong}', "");
    Expect(0, 71277, '\P{^mong}', "");
    Expect(1, 71276, '\p{--MONG}', "");
    Expect(0, 71276, '\p{^--MONG}', "");
    Expect(0, 71276, '\P{--MONG}', "");
    Expect(1, 71276, '\P{^--MONG}', "");
    Expect(0, 71277, '\p{--MONG}', "");
    Expect(1, 71277, '\p{^--MONG}', "");
    Expect(1, 71277, '\P{--MONG}', "");
    Expect(0, 71277, '\P{^--MONG}', "");
    Error('\p{	/a/IS_MONG}');
    Error('\P{	/a/IS_MONG}');
    Expect(1, 71276, '\p{ismong}', "");
    Expect(0, 71276, '\p{^ismong}', "");
    Expect(0, 71276, '\P{ismong}', "");
    Expect(1, 71276, '\P{^ismong}', "");
    Expect(0, 71277, '\p{ismong}', "");
    Expect(1, 71277, '\p{^ismong}', "");
    Expect(1, 71277, '\P{ismong}', "");
    Expect(0, 71277, '\P{^ismong}', "");
    Expect(1, 71276, '\p{ is_mong}', "");
    Expect(0, 71276, '\p{^ is_mong}', "");
    Expect(0, 71276, '\P{ is_mong}', "");
    Expect(1, 71276, '\P{^ is_mong}', "");
    Expect(0, 71277, '\p{ is_mong}', "");
    Expect(1, 71277, '\p{^ is_mong}', "");
    Expect(1, 71277, '\P{ is_mong}', "");
    Expect(0, 71277, '\P{^ is_mong}', "");
    Error('\p{--mongolian_supplement:=}');
    Error('\P{--mongolian_supplement:=}');
    Expect(1, 71295, '\p{mongoliansupplement}', "");
    Expect(0, 71295, '\p{^mongoliansupplement}', "");
    Expect(0, 71295, '\P{mongoliansupplement}', "");
    Expect(1, 71295, '\P{^mongoliansupplement}', "");
    Expect(0, 71296, '\p{mongoliansupplement}', "");
    Expect(1, 71296, '\p{^mongoliansupplement}', "");
    Expect(1, 71296, '\P{mongoliansupplement}', "");
    Expect(0, 71296, '\P{^mongoliansupplement}', "");
    Expect(1, 71295, '\p{-Mongolian_Supplement}', "");
    Expect(0, 71295, '\p{^-Mongolian_Supplement}', "");
    Expect(0, 71295, '\P{-Mongolian_Supplement}', "");
    Expect(1, 71295, '\P{^-Mongolian_Supplement}', "");
    Expect(0, 71296, '\p{-Mongolian_Supplement}', "");
    Expect(1, 71296, '\p{^-Mongolian_Supplement}', "");
    Expect(1, 71296, '\P{-Mongolian_Supplement}', "");
    Expect(0, 71296, '\P{^-Mongolian_Supplement}', "");
    Error('\p{_:=Is_Mongolian_Supplement}');
    Error('\P{_:=Is_Mongolian_Supplement}');
    Expect(1, 71295, '\p{ismongoliansupplement}', "");
    Expect(0, 71295, '\p{^ismongoliansupplement}', "");
    Expect(0, 71295, '\P{ismongoliansupplement}', "");
    Expect(1, 71295, '\P{^ismongoliansupplement}', "");
    Expect(0, 71296, '\p{ismongoliansupplement}', "");
    Expect(1, 71296, '\p{^ismongoliansupplement}', "");
    Expect(1, 71296, '\P{ismongoliansupplement}', "");
    Expect(0, 71296, '\P{^ismongoliansupplement}', "");
    Expect(1, 71295, '\p{	-Is_mongolian_Supplement}', "");
    Expect(0, 71295, '\p{^	-Is_mongolian_Supplement}', "");
    Expect(0, 71295, '\P{	-Is_mongolian_Supplement}', "");
    Expect(1, 71295, '\P{^	-Is_mongolian_Supplement}', "");
    Expect(0, 71296, '\p{	-Is_mongolian_Supplement}', "");
    Expect(1, 71296, '\p{^	-Is_mongolian_Supplement}', "");
    Expect(1, 71296, '\P{	-Is_mongolian_Supplement}', "");
    Expect(0, 71296, '\P{^	-Is_mongolian_Supplement}', "");
    Error('\p{/a/ _in_MONGOLIAN_Supplement}');
    Error('\P{/a/ _in_MONGOLIAN_Supplement}');
    Expect(1, 71295, '\p{inmongoliansupplement}', "");
    Expect(0, 71295, '\p{^inmongoliansupplement}', "");
    Expect(0, 71295, '\P{inmongoliansupplement}', "");
    Expect(1, 71295, '\P{^inmongoliansupplement}', "");
    Expect(0, 71296, '\p{inmongoliansupplement}', "");
    Expect(1, 71296, '\p{^inmongoliansupplement}', "");
    Expect(1, 71296, '\P{inmongoliansupplement}', "");
    Expect(0, 71296, '\P{^inmongoliansupplement}', "");
    Expect(1, 71295, '\p{_	IN_mongolian_Supplement}', "");
    Expect(0, 71295, '\p{^_	IN_mongolian_Supplement}', "");
    Expect(0, 71295, '\P{_	IN_mongolian_Supplement}', "");
    Expect(1, 71295, '\P{^_	IN_mongolian_Supplement}', "");
    Expect(0, 71296, '\p{_	IN_mongolian_Supplement}', "");
    Expect(1, 71296, '\p{^_	IN_mongolian_Supplement}', "");
    Expect(1, 71296, '\P{_	IN_mongolian_Supplement}', "");
    Expect(0, 71296, '\P{^_	IN_mongolian_Supplement}', "");
    Error('\p{/a/Mongolian_sup}');
    Error('\P{/a/Mongolian_sup}');
    Expect(1, 71295, '\p{mongoliansup}', "");
    Expect(0, 71295, '\p{^mongoliansup}', "");
    Expect(0, 71295, '\P{mongoliansup}', "");
    Expect(1, 71295, '\P{^mongoliansup}', "");
    Expect(0, 71296, '\p{mongoliansup}', "");
    Expect(1, 71296, '\p{^mongoliansup}', "");
    Expect(1, 71296, '\P{mongoliansup}', "");
    Expect(0, 71296, '\P{^mongoliansup}', "");
    Expect(1, 71295, '\p{_ mongolian_SUP}', "");
    Expect(0, 71295, '\p{^_ mongolian_SUP}', "");
    Expect(0, 71295, '\P{_ mongolian_SUP}', "");
    Expect(1, 71295, '\P{^_ mongolian_SUP}', "");
    Expect(0, 71296, '\p{_ mongolian_SUP}', "");
    Expect(1, 71296, '\p{^_ mongolian_SUP}', "");
    Expect(1, 71296, '\P{_ mongolian_SUP}', "");
    Expect(0, 71296, '\P{^_ mongolian_SUP}', "");
    Error('\p{_	IS_MONGOLIAN_Sup/a/}');
    Error('\P{_	IS_MONGOLIAN_Sup/a/}');
    Expect(1, 71295, '\p{ismongoliansup}', "");
    Expect(0, 71295, '\p{^ismongoliansup}', "");
    Expect(0, 71295, '\P{ismongoliansup}', "");
    Expect(1, 71295, '\P{^ismongoliansup}', "");
    Expect(0, 71296, '\p{ismongoliansup}', "");
    Expect(1, 71296, '\p{^ismongoliansup}', "");
    Expect(1, 71296, '\P{ismongoliansup}', "");
    Expect(0, 71296, '\P{^ismongoliansup}', "");
    Expect(1, 71295, '\p{__IS_Mongolian_Sup}', "");
    Expect(0, 71295, '\p{^__IS_Mongolian_Sup}', "");
    Expect(0, 71295, '\P{__IS_Mongolian_Sup}', "");
    Expect(1, 71295, '\P{^__IS_Mongolian_Sup}', "");
    Expect(0, 71296, '\p{__IS_Mongolian_Sup}', "");
    Expect(1, 71296, '\p{^__IS_Mongolian_Sup}', "");
    Expect(1, 71296, '\P{__IS_Mongolian_Sup}', "");
    Expect(0, 71296, '\P{^__IS_Mongolian_Sup}', "");
    Error('\p{-In_MONGOLIAN_SUP/a/}');
    Error('\P{-In_MONGOLIAN_SUP/a/}');
    Expect(1, 71295, '\p{inmongoliansup}', "");
    Expect(0, 71295, '\p{^inmongoliansup}', "");
    Expect(0, 71295, '\P{inmongoliansup}', "");
    Expect(1, 71295, '\P{^inmongoliansup}', "");
    Expect(0, 71296, '\p{inmongoliansup}', "");
    Expect(1, 71296, '\p{^inmongoliansup}', "");
    Expect(1, 71296, '\P{inmongoliansup}', "");
    Expect(0, 71296, '\P{^inmongoliansup}', "");
    Expect(1, 71295, '\p{_ In_MONGOLIAN_SUP}', "");
    Expect(0, 71295, '\p{^_ In_MONGOLIAN_SUP}', "");
    Expect(0, 71295, '\P{_ In_MONGOLIAN_SUP}', "");
    Expect(1, 71295, '\P{^_ In_MONGOLIAN_SUP}', "");
    Expect(0, 71296, '\p{_ In_MONGOLIAN_SUP}', "");
    Expect(1, 71296, '\p{^_ In_MONGOLIAN_SUP}', "");
    Expect(1, 71296, '\P{_ In_MONGOLIAN_SUP}', "");
    Expect(0, 71296, '\P{^_ In_MONGOLIAN_SUP}', "");
    Error('\p{_-Mro/a/}');
    Error('\P{_-Mro/a/}');
    Expect(1, 92783, '\p{mro}', "");
    Expect(0, 92783, '\p{^mro}', "");
    Expect(0, 92783, '\P{mro}', "");
    Expect(1, 92783, '\P{^mro}', "");
    Expect(0, 92784, '\p{mro}', "");
    Expect(1, 92784, '\p{^mro}', "");
    Expect(1, 92784, '\P{mro}', "");
    Expect(0, 92784, '\P{^mro}', "");
    Expect(1, 92783, '\p{	-MRO}', "");
    Expect(0, 92783, '\p{^	-MRO}', "");
    Expect(0, 92783, '\P{	-MRO}', "");
    Expect(1, 92783, '\P{^	-MRO}', "");
    Expect(0, 92784, '\p{	-MRO}', "");
    Expect(1, 92784, '\p{^	-MRO}', "");
    Expect(1, 92784, '\P{	-MRO}', "");
    Expect(0, 92784, '\P{^	-MRO}', "");
    Error('\p{:= Is_Mro}');
    Error('\P{:= Is_Mro}');
    Expect(1, 92783, '\p{ismro}', "");
    Expect(0, 92783, '\p{^ismro}', "");
    Expect(0, 92783, '\P{ismro}', "");
    Expect(1, 92783, '\P{^ismro}', "");
    Expect(0, 92784, '\p{ismro}', "");
    Expect(1, 92784, '\p{^ismro}', "");
    Expect(1, 92784, '\P{ismro}', "");
    Expect(0, 92784, '\P{^ismro}', "");
    Expect(1, 92783, '\p{_is_mro}', "");
    Expect(0, 92783, '\p{^_is_mro}', "");
    Expect(0, 92783, '\P{_is_mro}', "");
    Expect(1, 92783, '\P{^_is_mro}', "");
    Expect(0, 92784, '\p{_is_mro}', "");
    Expect(1, 92784, '\p{^_is_mro}', "");
    Expect(1, 92784, '\P{_is_mro}', "");
    Expect(0, 92784, '\P{^_is_mro}', "");
    Error('\p{-_Mroo/a/}');
    Error('\P{-_Mroo/a/}');
    Expect(1, 92783, '\p{mroo}', "");
    Expect(0, 92783, '\p{^mroo}', "");
    Expect(0, 92783, '\P{mroo}', "");
    Expect(1, 92783, '\P{^mroo}', "");
    Expect(0, 92784, '\p{mroo}', "");
    Expect(1, 92784, '\p{^mroo}', "");
    Expect(1, 92784, '\P{mroo}', "");
    Expect(0, 92784, '\P{^mroo}', "");
    Expect(1, 92783, '\p{Mroo}', "");
    Expect(0, 92783, '\p{^Mroo}', "");
    Expect(0, 92783, '\P{Mroo}', "");
    Expect(1, 92783, '\P{^Mroo}', "");
    Expect(0, 92784, '\p{Mroo}', "");
    Expect(1, 92784, '\p{^Mroo}', "");
    Expect(1, 92784, '\P{Mroo}', "");
    Expect(0, 92784, '\P{^Mroo}', "");
    Error('\p{ _Is_Mroo:=}');
    Error('\P{ _Is_Mroo:=}');
    Expect(1, 92783, '\p{ismroo}', "");
    Expect(0, 92783, '\p{^ismroo}', "");
    Expect(0, 92783, '\P{ismroo}', "");
    Expect(1, 92783, '\P{^ismroo}', "");
    Expect(0, 92784, '\p{ismroo}', "");
    Expect(1, 92784, '\p{^ismroo}', "");
    Expect(1, 92784, '\P{ismroo}', "");
    Expect(0, 92784, '\P{^ismroo}', "");
    Expect(1, 92783, '\p{_	IS_mroo}', "");
    Expect(0, 92783, '\p{^_	IS_mroo}', "");
    Expect(0, 92783, '\P{_	IS_mroo}', "");
    Expect(1, 92783, '\P{^_	IS_mroo}', "");
    Expect(0, 92784, '\p{_	IS_mroo}', "");
    Expect(1, 92784, '\p{^_	IS_mroo}', "");
    Expect(1, 92784, '\P{_	IS_mroo}', "");
    Expect(0, 92784, '\P{^_	IS_mroo}', "");
    Error('\p{/a/ 	multani}');
    Error('\P{/a/ 	multani}');
    Expect(1, 70313, '\p{multani}', "");
    Expect(0, 70313, '\p{^multani}', "");
    Expect(0, 70313, '\P{multani}', "");
    Expect(1, 70313, '\P{^multani}', "");
    Expect(0, 70314, '\p{multani}', "");
    Expect(1, 70314, '\p{^multani}', "");
    Expect(1, 70314, '\P{multani}', "");
    Expect(0, 70314, '\P{^multani}', "");
    Expect(1, 70313, '\p{ -Multani}', "");
    Expect(0, 70313, '\p{^ -Multani}', "");
    Expect(0, 70313, '\P{ -Multani}', "");
    Expect(1, 70313, '\P{^ -Multani}', "");
    Expect(0, 70314, '\p{ -Multani}', "");
    Expect(1, 70314, '\p{^ -Multani}', "");
    Expect(1, 70314, '\P{ -Multani}', "");
    Expect(0, 70314, '\P{^ -Multani}', "");
    Error('\p{_-Is_multani/a/}');
    Error('\P{_-Is_multani/a/}');
    Expect(1, 70313, '\p{ismultani}', "");
    Expect(0, 70313, '\p{^ismultani}', "");
    Expect(0, 70313, '\P{ismultani}', "");
    Expect(1, 70313, '\P{^ismultani}', "");
    Expect(0, 70314, '\p{ismultani}', "");
    Expect(1, 70314, '\p{^ismultani}', "");
    Expect(1, 70314, '\P{ismultani}', "");
    Expect(0, 70314, '\P{^ismultani}', "");
    Expect(1, 70313, '\p{	Is_MULTANI}', "");
    Expect(0, 70313, '\p{^	Is_MULTANI}', "");
    Expect(0, 70313, '\P{	Is_MULTANI}', "");
    Expect(1, 70313, '\P{^	Is_MULTANI}', "");
    Expect(0, 70314, '\p{	Is_MULTANI}', "");
    Expect(1, 70314, '\p{^	Is_MULTANI}', "");
    Expect(1, 70314, '\P{	Is_MULTANI}', "");
    Expect(0, 70314, '\P{^	Is_MULTANI}', "");
    Error('\p{:= _Mult}');
    Error('\P{:= _Mult}');
    Expect(1, 70313, '\p{mult}', "");
    Expect(0, 70313, '\p{^mult}', "");
    Expect(0, 70313, '\P{mult}', "");
    Expect(1, 70313, '\P{^mult}', "");
    Expect(0, 70314, '\p{mult}', "");
    Expect(1, 70314, '\p{^mult}', "");
    Expect(1, 70314, '\P{mult}', "");
    Expect(0, 70314, '\P{^mult}', "");
    Expect(1, 70313, '\p{ Mult}', "");
    Expect(0, 70313, '\p{^ Mult}', "");
    Expect(0, 70313, '\P{ Mult}', "");
    Expect(1, 70313, '\P{^ Mult}', "");
    Expect(0, 70314, '\p{ Mult}', "");
    Expect(1, 70314, '\p{^ Mult}', "");
    Expect(1, 70314, '\P{ Mult}', "");
    Expect(0, 70314, '\P{^ Mult}', "");
    Error('\p{:= 	Is_mult}');
    Error('\P{:= 	Is_mult}');
    Expect(1, 70313, '\p{ismult}', "");
    Expect(0, 70313, '\p{^ismult}', "");
    Expect(0, 70313, '\P{ismult}', "");
    Expect(1, 70313, '\P{^ismult}', "");
    Expect(0, 70314, '\p{ismult}', "");
    Expect(1, 70314, '\p{^ismult}', "");
    Expect(1, 70314, '\P{ismult}', "");
    Expect(0, 70314, '\P{^ismult}', "");
    Expect(1, 70313, '\p{__IS_MULT}', "");
    Expect(0, 70313, '\p{^__IS_MULT}', "");
    Expect(0, 70313, '\P{__IS_MULT}', "");
    Expect(1, 70313, '\P{^__IS_MULT}', "");
    Expect(0, 70314, '\p{__IS_MULT}', "");
    Expect(1, 70314, '\p{^__IS_MULT}', "");
    Expect(1, 70314, '\P{__IS_MULT}', "");
    Expect(0, 70314, '\P{^__IS_MULT}', "");
    Error('\p{-_Musical_Symbols:=}');
    Error('\P{-_Musical_Symbols:=}');
    Expect(1, 119295, '\p{musicalsymbols}', "");
    Expect(0, 119295, '\p{^musicalsymbols}', "");
    Expect(0, 119295, '\P{musicalsymbols}', "");
    Expect(1, 119295, '\P{^musicalsymbols}', "");
    Expect(0, 119296, '\p{musicalsymbols}', "");
    Expect(1, 119296, '\p{^musicalsymbols}', "");
    Expect(1, 119296, '\P{musicalsymbols}', "");
    Expect(0, 119296, '\P{^musicalsymbols}', "");
    Expect(1, 119295, '\p{__Musical_Symbols}', "");
    Expect(0, 119295, '\p{^__Musical_Symbols}', "");
    Expect(0, 119295, '\P{__Musical_Symbols}', "");
    Expect(1, 119295, '\P{^__Musical_Symbols}', "");
    Expect(0, 119296, '\p{__Musical_Symbols}', "");
    Expect(1, 119296, '\p{^__Musical_Symbols}', "");
    Expect(1, 119296, '\P{__Musical_Symbols}', "");
    Expect(0, 119296, '\P{^__Musical_Symbols}', "");
    Error('\p{/a/  Is_musical_symbols}');
    Error('\P{/a/  Is_musical_symbols}');
    Expect(1, 119295, '\p{ismusicalsymbols}', "");
    Expect(0, 119295, '\p{^ismusicalsymbols}', "");
    Expect(0, 119295, '\P{ismusicalsymbols}', "");
    Expect(1, 119295, '\P{^ismusicalsymbols}', "");
    Expect(0, 119296, '\p{ismusicalsymbols}', "");
    Expect(1, 119296, '\p{^ismusicalsymbols}', "");
    Expect(1, 119296, '\P{ismusicalsymbols}', "");
    Expect(0, 119296, '\P{^ismusicalsymbols}', "");
    Expect(1, 119295, '\p{ is_Musical_Symbols}', "");
    Expect(0, 119295, '\p{^ is_Musical_Symbols}', "");
    Expect(0, 119295, '\P{ is_Musical_Symbols}', "");
    Expect(1, 119295, '\P{^ is_Musical_Symbols}', "");
    Expect(0, 119296, '\p{ is_Musical_Symbols}', "");
    Expect(1, 119296, '\p{^ is_Musical_Symbols}', "");
    Expect(1, 119296, '\P{ is_Musical_Symbols}', "");
    Expect(0, 119296, '\P{^ is_Musical_Symbols}', "");
    Error('\p{-	in_MUSICAL_SYMBOLS:=}');
    Error('\P{-	in_MUSICAL_SYMBOLS:=}');
    Expect(1, 119295, '\p{inmusicalsymbols}', "");
    Expect(0, 119295, '\p{^inmusicalsymbols}', "");
    Expect(0, 119295, '\P{inmusicalsymbols}', "");
    Expect(1, 119295, '\P{^inmusicalsymbols}', "");
    Expect(0, 119296, '\p{inmusicalsymbols}', "");
    Expect(1, 119296, '\p{^inmusicalsymbols}', "");
    Expect(1, 119296, '\P{inmusicalsymbols}', "");
    Expect(0, 119296, '\P{^inmusicalsymbols}', "");
    Expect(1, 119295, '\p{- IN_musical_SYMBOLS}', "");
    Expect(0, 119295, '\p{^- IN_musical_SYMBOLS}', "");
    Expect(0, 119295, '\P{- IN_musical_SYMBOLS}', "");
    Expect(1, 119295, '\P{^- IN_musical_SYMBOLS}', "");
    Expect(0, 119296, '\p{- IN_musical_SYMBOLS}', "");
    Expect(1, 119296, '\p{^- IN_musical_SYMBOLS}', "");
    Expect(1, 119296, '\P{- IN_musical_SYMBOLS}', "");
    Expect(0, 119296, '\P{^- IN_musical_SYMBOLS}', "");
    Error('\p{-music:=}');
    Error('\P{-music:=}');
    Expect(1, 119295, '\p{music}', "");
    Expect(0, 119295, '\p{^music}', "");
    Expect(0, 119295, '\P{music}', "");
    Expect(1, 119295, '\P{^music}', "");
    Expect(0, 119296, '\p{music}', "");
    Expect(1, 119296, '\p{^music}', "");
    Expect(1, 119296, '\P{music}', "");
    Expect(0, 119296, '\P{^music}', "");
    Expect(1, 119295, '\p{	_music}', "");
    Expect(0, 119295, '\p{^	_music}', "");
    Expect(0, 119295, '\P{	_music}', "");
    Expect(1, 119295, '\P{^	_music}', "");
    Expect(0, 119296, '\p{	_music}', "");
    Expect(1, 119296, '\p{^	_music}', "");
    Expect(1, 119296, '\P{	_music}', "");
    Expect(0, 119296, '\P{^	_music}', "");
    Error('\p{/a/IS_Music}');
    Error('\P{/a/IS_Music}');
    Expect(1, 119295, '\p{ismusic}', "");
    Expect(0, 119295, '\p{^ismusic}', "");
    Expect(0, 119295, '\P{ismusic}', "");
    Expect(1, 119295, '\P{^ismusic}', "");
    Expect(0, 119296, '\p{ismusic}', "");
    Expect(1, 119296, '\p{^ismusic}', "");
    Expect(1, 119296, '\P{ismusic}', "");
    Expect(0, 119296, '\P{^ismusic}', "");
    Expect(1, 119295, '\p{-is_MUSIC}', "");
    Expect(0, 119295, '\p{^-is_MUSIC}', "");
    Expect(0, 119295, '\P{-is_MUSIC}', "");
    Expect(1, 119295, '\P{^-is_MUSIC}', "");
    Expect(0, 119296, '\p{-is_MUSIC}', "");
    Expect(1, 119296, '\p{^-is_MUSIC}', "");
    Expect(1, 119296, '\P{-is_MUSIC}', "");
    Expect(0, 119296, '\P{^-is_MUSIC}', "");
    Error('\p{/a/  In_music}');
    Error('\P{/a/  In_music}');
    Expect(1, 119295, '\p{inmusic}', "");
    Expect(0, 119295, '\p{^inmusic}', "");
    Expect(0, 119295, '\P{inmusic}', "");
    Expect(1, 119295, '\P{^inmusic}', "");
    Expect(0, 119296, '\p{inmusic}', "");
    Expect(1, 119296, '\p{^inmusic}', "");
    Expect(1, 119296, '\P{inmusic}', "");
    Expect(0, 119296, '\P{^inmusic}', "");
    Expect(1, 119295, '\p{_	In_Music}', "");
    Expect(0, 119295, '\p{^_	In_Music}', "");
    Expect(0, 119295, '\P{_	In_Music}', "");
    Expect(1, 119295, '\P{^_	In_Music}', "");
    Expect(0, 119296, '\p{_	In_Music}', "");
    Expect(1, 119296, '\p{^_	In_Music}', "");
    Expect(1, 119296, '\P{_	In_Music}', "");
    Expect(0, 119296, '\P{^_	In_Music}', "");
    Error('\p{/a/Myanmar}');
    Error('\P{/a/Myanmar}');
    Expect(1, 43647, '\p{myanmar}', "");
    Expect(0, 43647, '\p{^myanmar}', "");
    Expect(0, 43647, '\P{myanmar}', "");
    Expect(1, 43647, '\P{^myanmar}', "");
    Expect(0, 43648, '\p{myanmar}', "");
    Expect(1, 43648, '\p{^myanmar}', "");
    Expect(1, 43648, '\P{myanmar}', "");
    Expect(0, 43648, '\P{^myanmar}', "");
    Expect(1, 43647, '\p{	 myanmar}', "");
    Expect(0, 43647, '\p{^	 myanmar}', "");
    Expect(0, 43647, '\P{	 myanmar}', "");
    Expect(1, 43647, '\P{^	 myanmar}', "");
    Expect(0, 43648, '\p{	 myanmar}', "");
    Expect(1, 43648, '\p{^	 myanmar}', "");
    Expect(1, 43648, '\P{	 myanmar}', "");
    Expect(0, 43648, '\P{^	 myanmar}', "");
    Error('\p{:=__is_Myanmar}');
    Error('\P{:=__is_Myanmar}');
    Expect(1, 43647, '\p{ismyanmar}', "");
    Expect(0, 43647, '\p{^ismyanmar}', "");
    Expect(0, 43647, '\P{ismyanmar}', "");
    Expect(1, 43647, '\P{^ismyanmar}', "");
    Expect(0, 43648, '\p{ismyanmar}', "");
    Expect(1, 43648, '\p{^ismyanmar}', "");
    Expect(1, 43648, '\P{ismyanmar}', "");
    Expect(0, 43648, '\P{^ismyanmar}', "");
    Expect(1, 43647, '\p{_ Is_Myanmar}', "");
    Expect(0, 43647, '\p{^_ Is_Myanmar}', "");
    Expect(0, 43647, '\P{_ Is_Myanmar}', "");
    Expect(1, 43647, '\P{^_ Is_Myanmar}', "");
    Expect(0, 43648, '\p{_ Is_Myanmar}', "");
    Expect(1, 43648, '\p{^_ Is_Myanmar}', "");
    Expect(1, 43648, '\P{_ Is_Myanmar}', "");
    Expect(0, 43648, '\P{^_ Is_Myanmar}', "");
    Error('\p{/a/-Mymr}');
    Error('\P{/a/-Mymr}');
    Expect(1, 43647, '\p{mymr}', "");
    Expect(0, 43647, '\p{^mymr}', "");
    Expect(0, 43647, '\P{mymr}', "");
    Expect(1, 43647, '\P{^mymr}', "");
    Expect(0, 43648, '\p{mymr}', "");
    Expect(1, 43648, '\p{^mymr}', "");
    Expect(1, 43648, '\P{mymr}', "");
    Expect(0, 43648, '\P{^mymr}', "");
    Expect(1, 43647, '\p{_	MYMR}', "");
    Expect(0, 43647, '\p{^_	MYMR}', "");
    Expect(0, 43647, '\P{_	MYMR}', "");
    Expect(1, 43647, '\P{^_	MYMR}', "");
    Expect(0, 43648, '\p{_	MYMR}', "");
    Expect(1, 43648, '\p{^_	MYMR}', "");
    Expect(1, 43648, '\P{_	MYMR}', "");
    Expect(0, 43648, '\P{^_	MYMR}', "");
    Error('\p{/a/ Is_Mymr}');
    Error('\P{/a/ Is_Mymr}');
    Expect(1, 43647, '\p{ismymr}', "");
    Expect(0, 43647, '\p{^ismymr}', "");
    Expect(0, 43647, '\P{ismymr}', "");
    Expect(1, 43647, '\P{^ismymr}', "");
    Expect(0, 43648, '\p{ismymr}', "");
    Expect(1, 43648, '\p{^ismymr}', "");
    Expect(1, 43648, '\P{ismymr}', "");
    Expect(0, 43648, '\P{^ismymr}', "");
    Expect(1, 43647, '\p{__is_Mymr}', "");
    Expect(0, 43647, '\p{^__is_Mymr}', "");
    Expect(0, 43647, '\P{__is_Mymr}', "");
    Expect(1, 43647, '\P{^__is_Mymr}', "");
    Expect(0, 43648, '\p{__is_Mymr}', "");
    Expect(1, 43648, '\p{^__is_Mymr}', "");
    Expect(1, 43648, '\P{__is_Mymr}', "");
    Expect(0, 43648, '\P{^__is_Mymr}', "");
    Error('\p{-:=Myanmar_Extended_A}');
    Error('\P{-:=Myanmar_Extended_A}');
    Expect(1, 43647, '\p{myanmarextendeda}', "");
    Expect(0, 43647, '\p{^myanmarextendeda}', "");
    Expect(0, 43647, '\P{myanmarextendeda}', "");
    Expect(1, 43647, '\P{^myanmarextendeda}', "");
    Expect(0, 43648, '\p{myanmarextendeda}', "");
    Expect(1, 43648, '\p{^myanmarextendeda}', "");
    Expect(1, 43648, '\P{myanmarextendeda}', "");
    Expect(0, 43648, '\P{^myanmarextendeda}', "");
    Expect(1, 43647, '\p{--myanmar_Extended_A}', "");
    Expect(0, 43647, '\p{^--myanmar_Extended_A}', "");
    Expect(0, 43647, '\P{--myanmar_Extended_A}', "");
    Expect(1, 43647, '\P{^--myanmar_Extended_A}', "");
    Expect(0, 43648, '\p{--myanmar_Extended_A}', "");
    Expect(1, 43648, '\p{^--myanmar_Extended_A}', "");
    Expect(1, 43648, '\P{--myanmar_Extended_A}', "");
    Expect(0, 43648, '\P{^--myanmar_Extended_A}', "");
    Error('\p{ :=Is_myanmar_EXTENDED_A}');
    Error('\P{ :=Is_myanmar_EXTENDED_A}');
    Expect(1, 43647, '\p{ismyanmarextendeda}', "");
    Expect(0, 43647, '\p{^ismyanmarextendeda}', "");
    Expect(0, 43647, '\P{ismyanmarextendeda}', "");
    Expect(1, 43647, '\P{^ismyanmarextendeda}', "");
    Expect(0, 43648, '\p{ismyanmarextendeda}', "");
    Expect(1, 43648, '\p{^ismyanmarextendeda}', "");
    Expect(1, 43648, '\P{ismyanmarextendeda}', "");
    Expect(0, 43648, '\P{^ismyanmarextendeda}', "");
    Expect(1, 43647, '\p{ -IS_myanmar_EXTENDED_A}', "");
    Expect(0, 43647, '\p{^ -IS_myanmar_EXTENDED_A}', "");
    Expect(0, 43647, '\P{ -IS_myanmar_EXTENDED_A}', "");
    Expect(1, 43647, '\P{^ -IS_myanmar_EXTENDED_A}', "");
    Expect(0, 43648, '\p{ -IS_myanmar_EXTENDED_A}', "");
    Expect(1, 43648, '\p{^ -IS_myanmar_EXTENDED_A}', "");
    Expect(1, 43648, '\P{ -IS_myanmar_EXTENDED_A}', "");
    Expect(0, 43648, '\P{^ -IS_myanmar_EXTENDED_A}', "");
    Error('\p{_ IN_Myanmar_EXTENDED_A/a/}');
    Error('\P{_ IN_Myanmar_EXTENDED_A/a/}');
    Expect(1, 43647, '\p{inmyanmarextendeda}', "");
    Expect(0, 43647, '\p{^inmyanmarextendeda}', "");
    Expect(0, 43647, '\P{inmyanmarextendeda}', "");
    Expect(1, 43647, '\P{^inmyanmarextendeda}', "");
    Expect(0, 43648, '\p{inmyanmarextendeda}', "");
    Expect(1, 43648, '\p{^inmyanmarextendeda}', "");
    Expect(1, 43648, '\P{inmyanmarextendeda}', "");
    Expect(0, 43648, '\P{^inmyanmarextendeda}', "");
    Expect(1, 43647, '\p{ 	in_myanmar_Extended_A}', "");
    Expect(0, 43647, '\p{^ 	in_myanmar_Extended_A}', "");
    Expect(0, 43647, '\P{ 	in_myanmar_Extended_A}', "");
    Expect(1, 43647, '\P{^ 	in_myanmar_Extended_A}', "");
    Expect(0, 43648, '\p{ 	in_myanmar_Extended_A}', "");
    Expect(1, 43648, '\p{^ 	in_myanmar_Extended_A}', "");
    Expect(1, 43648, '\P{ 	in_myanmar_Extended_A}', "");
    Expect(0, 43648, '\P{^ 	in_myanmar_Extended_A}', "");
    Error('\p{:=myanmar_Ext_a}');
    Error('\P{:=myanmar_Ext_a}');
    Expect(1, 43647, '\p{myanmarexta}', "");
    Expect(0, 43647, '\p{^myanmarexta}', "");
    Expect(0, 43647, '\P{myanmarexta}', "");
    Expect(1, 43647, '\P{^myanmarexta}', "");
    Expect(0, 43648, '\p{myanmarexta}', "");
    Expect(1, 43648, '\p{^myanmarexta}', "");
    Expect(1, 43648, '\P{myanmarexta}', "");
    Expect(0, 43648, '\P{^myanmarexta}', "");
    Expect(1, 43647, '\p{		Myanmar_ext_a}', "");
    Expect(0, 43647, '\p{^		Myanmar_ext_a}', "");
    Expect(0, 43647, '\P{		Myanmar_ext_a}', "");
    Expect(1, 43647, '\P{^		Myanmar_ext_a}', "");
    Expect(0, 43648, '\p{		Myanmar_ext_a}', "");
    Expect(1, 43648, '\p{^		Myanmar_ext_a}', "");
    Expect(1, 43648, '\P{		Myanmar_ext_a}', "");
    Expect(0, 43648, '\P{^		Myanmar_ext_a}', "");
    Error('\p{/a/_IS_Myanmar_Ext_a}');
    Error('\P{/a/_IS_Myanmar_Ext_a}');
    Expect(1, 43647, '\p{ismyanmarexta}', "");
    Expect(0, 43647, '\p{^ismyanmarexta}', "");
    Expect(0, 43647, '\P{ismyanmarexta}', "");
    Expect(1, 43647, '\P{^ismyanmarexta}', "");
    Expect(0, 43648, '\p{ismyanmarexta}', "");
    Expect(1, 43648, '\p{^ismyanmarexta}', "");
    Expect(1, 43648, '\P{ismyanmarexta}', "");
    Expect(0, 43648, '\P{^ismyanmarexta}', "");
    Expect(1, 43647, '\p{ is_Myanmar_ext_A}', "");
    Expect(0, 43647, '\p{^ is_Myanmar_ext_A}', "");
    Expect(0, 43647, '\P{ is_Myanmar_ext_A}', "");
    Expect(1, 43647, '\P{^ is_Myanmar_ext_A}', "");
    Expect(0, 43648, '\p{ is_Myanmar_ext_A}', "");
    Expect(1, 43648, '\p{^ is_Myanmar_ext_A}', "");
    Expect(1, 43648, '\P{ is_Myanmar_ext_A}', "");
    Expect(0, 43648, '\P{^ is_Myanmar_ext_A}', "");
    Error('\p{/a/__In_Myanmar_ext_A}');
    Error('\P{/a/__In_Myanmar_ext_A}');
    Expect(1, 43647, '\p{inmyanmarexta}', "");
    Expect(0, 43647, '\p{^inmyanmarexta}', "");
    Expect(0, 43647, '\P{inmyanmarexta}', "");
    Expect(1, 43647, '\P{^inmyanmarexta}', "");
    Expect(0, 43648, '\p{inmyanmarexta}', "");
    Expect(1, 43648, '\p{^inmyanmarexta}', "");
    Expect(1, 43648, '\P{inmyanmarexta}', "");
    Expect(0, 43648, '\P{^inmyanmarexta}', "");
    Expect(1, 43647, '\p{	_IN_MYANMAR_Ext_A}', "");
    Expect(0, 43647, '\p{^	_IN_MYANMAR_Ext_A}', "");
    Expect(0, 43647, '\P{	_IN_MYANMAR_Ext_A}', "");
    Expect(1, 43647, '\P{^	_IN_MYANMAR_Ext_A}', "");
    Expect(0, 43648, '\p{	_IN_MYANMAR_Ext_A}', "");
    Expect(1, 43648, '\p{^	_IN_MYANMAR_Ext_A}', "");
    Expect(1, 43648, '\P{	_IN_MYANMAR_Ext_A}', "");
    Expect(0, 43648, '\P{^	_IN_MYANMAR_Ext_A}', "");
    Error('\p{:=__myanmar_extended_B}');
    Error('\P{:=__myanmar_extended_B}');
    Expect(1, 43519, '\p{myanmarextendedb}', "");
    Expect(0, 43519, '\p{^myanmarextendedb}', "");
    Expect(0, 43519, '\P{myanmarextendedb}', "");
    Expect(1, 43519, '\P{^myanmarextendedb}', "");
    Expect(0, 43520, '\p{myanmarextendedb}', "");
    Expect(1, 43520, '\p{^myanmarextendedb}', "");
    Expect(1, 43520, '\P{myanmarextendedb}', "");
    Expect(0, 43520, '\P{^myanmarextendedb}', "");
    Expect(1, 43519, '\p{ myanmar_EXTENDED_B}', "");
    Expect(0, 43519, '\p{^ myanmar_EXTENDED_B}', "");
    Expect(0, 43519, '\P{ myanmar_EXTENDED_B}', "");
    Expect(1, 43519, '\P{^ myanmar_EXTENDED_B}', "");
    Expect(0, 43520, '\p{ myanmar_EXTENDED_B}', "");
    Expect(1, 43520, '\p{^ myanmar_EXTENDED_B}', "");
    Expect(1, 43520, '\P{ myanmar_EXTENDED_B}', "");
    Expect(0, 43520, '\P{^ myanmar_EXTENDED_B}', "");
    Error('\p{-Is_Myanmar_Extended_B/a/}');
    Error('\P{-Is_Myanmar_Extended_B/a/}');
    Expect(1, 43519, '\p{ismyanmarextendedb}', "");
    Expect(0, 43519, '\p{^ismyanmarextendedb}', "");
    Expect(0, 43519, '\P{ismyanmarextendedb}', "");
    Expect(1, 43519, '\P{^ismyanmarextendedb}', "");
    Expect(0, 43520, '\p{ismyanmarextendedb}', "");
    Expect(1, 43520, '\p{^ismyanmarextendedb}', "");
    Expect(1, 43520, '\P{ismyanmarextendedb}', "");
    Expect(0, 43520, '\P{^ismyanmarextendedb}', "");
    Expect(1, 43519, '\p{	Is_Myanmar_Extended_B}', "");
    Expect(0, 43519, '\p{^	Is_Myanmar_Extended_B}', "");
    Expect(0, 43519, '\P{	Is_Myanmar_Extended_B}', "");
    Expect(1, 43519, '\P{^	Is_Myanmar_Extended_B}', "");
    Expect(0, 43520, '\p{	Is_Myanmar_Extended_B}', "");
    Expect(1, 43520, '\p{^	Is_Myanmar_Extended_B}', "");
    Expect(1, 43520, '\P{	Is_Myanmar_Extended_B}', "");
    Expect(0, 43520, '\P{^	Is_Myanmar_Extended_B}', "");
    Error('\p{:=-In_MYANMAR_Extended_B}');
    Error('\P{:=-In_MYANMAR_Extended_B}');
    Expect(1, 43519, '\p{inmyanmarextendedb}', "");
    Expect(0, 43519, '\p{^inmyanmarextendedb}', "");
    Expect(0, 43519, '\P{inmyanmarextendedb}', "");
    Expect(1, 43519, '\P{^inmyanmarextendedb}', "");
    Expect(0, 43520, '\p{inmyanmarextendedb}', "");
    Expect(1, 43520, '\p{^inmyanmarextendedb}', "");
    Expect(1, 43520, '\P{inmyanmarextendedb}', "");
    Expect(0, 43520, '\P{^inmyanmarextendedb}', "");
    Expect(1, 43519, '\p{		In_myanmar_EXTENDED_B}', "");
    Expect(0, 43519, '\p{^		In_myanmar_EXTENDED_B}', "");
    Expect(0, 43519, '\P{		In_myanmar_EXTENDED_B}', "");
    Expect(1, 43519, '\P{^		In_myanmar_EXTENDED_B}', "");
    Expect(0, 43520, '\p{		In_myanmar_EXTENDED_B}', "");
    Expect(1, 43520, '\p{^		In_myanmar_EXTENDED_B}', "");
    Expect(1, 43520, '\P{		In_myanmar_EXTENDED_B}', "");
    Expect(0, 43520, '\P{^		In_myanmar_EXTENDED_B}', "");
    Error('\p{/a/  MYANMAR_ext_b}');
    Error('\P{/a/  MYANMAR_ext_b}');
    Expect(1, 43519, '\p{myanmarextb}', "");
    Expect(0, 43519, '\p{^myanmarextb}', "");
    Expect(0, 43519, '\P{myanmarextb}', "");
    Expect(1, 43519, '\P{^myanmarextb}', "");
    Expect(0, 43520, '\p{myanmarextb}', "");
    Expect(1, 43520, '\p{^myanmarextb}', "");
    Expect(1, 43520, '\P{myanmarextb}', "");
    Expect(0, 43520, '\P{^myanmarextb}', "");
    Expect(1, 43519, '\p{		Myanmar_ext_B}', "");
    Expect(0, 43519, '\p{^		Myanmar_ext_B}', "");
    Expect(0, 43519, '\P{		Myanmar_ext_B}', "");
    Expect(1, 43519, '\P{^		Myanmar_ext_B}', "");
    Expect(0, 43520, '\p{		Myanmar_ext_B}', "");
    Expect(1, 43520, '\p{^		Myanmar_ext_B}', "");
    Expect(1, 43520, '\P{		Myanmar_ext_B}', "");
    Expect(0, 43520, '\P{^		Myanmar_ext_B}', "");
    Error('\p{ :=is_Myanmar_ext_B}');
    Error('\P{ :=is_Myanmar_ext_B}');
    Expect(1, 43519, '\p{ismyanmarextb}', "");
    Expect(0, 43519, '\p{^ismyanmarextb}', "");
    Expect(0, 43519, '\P{ismyanmarextb}', "");
    Expect(1, 43519, '\P{^ismyanmarextb}', "");
    Expect(0, 43520, '\p{ismyanmarextb}', "");
    Expect(1, 43520, '\p{^ismyanmarextb}', "");
    Expect(1, 43520, '\P{ismyanmarextb}', "");
    Expect(0, 43520, '\P{^ismyanmarextb}', "");
    Expect(1, 43519, '\p{ _is_myanmar_EXT_B}', "");
    Expect(0, 43519, '\p{^ _is_myanmar_EXT_B}', "");
    Expect(0, 43519, '\P{ _is_myanmar_EXT_B}', "");
    Expect(1, 43519, '\P{^ _is_myanmar_EXT_B}', "");
    Expect(0, 43520, '\p{ _is_myanmar_EXT_B}', "");
    Expect(1, 43520, '\p{^ _is_myanmar_EXT_B}', "");
    Expect(1, 43520, '\P{ _is_myanmar_EXT_B}', "");
    Expect(0, 43520, '\P{^ _is_myanmar_EXT_B}', "");
    Error('\p{_/a/IN_Myanmar_Ext_b}');
    Error('\P{_/a/IN_Myanmar_Ext_b}');
    Expect(1, 43519, '\p{inmyanmarextb}', "");
    Expect(0, 43519, '\p{^inmyanmarextb}', "");
    Expect(0, 43519, '\P{inmyanmarextb}', "");
    Expect(1, 43519, '\P{^inmyanmarextb}', "");
    Expect(0, 43520, '\p{inmyanmarextb}', "");
    Expect(1, 43520, '\p{^inmyanmarextb}', "");
    Expect(1, 43520, '\P{inmyanmarextb}', "");
    Expect(0, 43520, '\P{^inmyanmarextb}', "");
    Expect(1, 43519, '\p{_	IN_Myanmar_EXT_b}', "");
    Expect(0, 43519, '\p{^_	IN_Myanmar_EXT_b}', "");
    Expect(0, 43519, '\P{_	IN_Myanmar_EXT_b}', "");
    Expect(1, 43519, '\P{^_	IN_Myanmar_EXT_b}', "");
    Expect(0, 43520, '\p{_	IN_Myanmar_EXT_b}', "");
    Expect(1, 43520, '\p{^_	IN_Myanmar_EXT_b}', "");
    Expect(1, 43520, '\P{_	IN_Myanmar_EXT_b}', "");
    Expect(0, 43520, '\P{^_	IN_Myanmar_EXT_b}', "");
    Error('\p{-:=Nabataean}');
    Error('\P{-:=Nabataean}');
    Expect(1, 67759, '\p{nabataean}', "");
    Expect(0, 67759, '\p{^nabataean}', "");
    Expect(0, 67759, '\P{nabataean}', "");
    Expect(1, 67759, '\P{^nabataean}', "");
    Expect(0, 67760, '\p{nabataean}', "");
    Expect(1, 67760, '\p{^nabataean}', "");
    Expect(1, 67760, '\P{nabataean}', "");
    Expect(0, 67760, '\P{^nabataean}', "");
    Expect(1, 67759, '\p{ _Nabataean}', "");
    Expect(0, 67759, '\p{^ _Nabataean}', "");
    Expect(0, 67759, '\P{ _Nabataean}', "");
    Expect(1, 67759, '\P{^ _Nabataean}', "");
    Expect(0, 67760, '\p{ _Nabataean}', "");
    Expect(1, 67760, '\p{^ _Nabataean}', "");
    Expect(1, 67760, '\P{ _Nabataean}', "");
    Expect(0, 67760, '\P{^ _Nabataean}', "");
    Error('\p{--IS_NABATAEAN:=}');
    Error('\P{--IS_NABATAEAN:=}');
    Expect(1, 67759, '\p{isnabataean}', "");
    Expect(0, 67759, '\p{^isnabataean}', "");
    Expect(0, 67759, '\P{isnabataean}', "");
    Expect(1, 67759, '\P{^isnabataean}', "");
    Expect(0, 67760, '\p{isnabataean}', "");
    Expect(1, 67760, '\p{^isnabataean}', "");
    Expect(1, 67760, '\P{isnabataean}', "");
    Expect(0, 67760, '\P{^isnabataean}', "");
    Expect(1, 67759, '\p{ -IS_Nabataean}', "");
    Expect(0, 67759, '\p{^ -IS_Nabataean}', "");
    Expect(0, 67759, '\P{ -IS_Nabataean}', "");
    Expect(1, 67759, '\P{^ -IS_Nabataean}', "");
    Expect(0, 67760, '\p{ -IS_Nabataean}', "");
    Expect(1, 67760, '\p{^ -IS_Nabataean}', "");
    Expect(1, 67760, '\P{ -IS_Nabataean}', "");
    Expect(0, 67760, '\P{^ -IS_Nabataean}', "");
    Error('\p{:=NBAT}');
    Error('\P{:=NBAT}');
    Expect(1, 67759, '\p{nbat}', "");
    Expect(0, 67759, '\p{^nbat}', "");
    Expect(0, 67759, '\P{nbat}', "");
    Expect(1, 67759, '\P{^nbat}', "");
    Expect(0, 67760, '\p{nbat}', "");
    Expect(1, 67760, '\p{^nbat}', "");
    Expect(1, 67760, '\P{nbat}', "");
    Expect(0, 67760, '\P{^nbat}', "");
    Expect(1, 67759, '\p{	_Nbat}', "");
    Expect(0, 67759, '\p{^	_Nbat}', "");
    Expect(0, 67759, '\P{	_Nbat}', "");
    Expect(1, 67759, '\P{^	_Nbat}', "");
    Expect(0, 67760, '\p{	_Nbat}', "");
    Expect(1, 67760, '\p{^	_Nbat}', "");
    Expect(1, 67760, '\P{	_Nbat}', "");
    Expect(0, 67760, '\P{^	_Nbat}', "");
    Error('\p{/a/Is_NBAT}');
    Error('\P{/a/Is_NBAT}');
    Expect(1, 67759, '\p{isnbat}', "");
    Expect(0, 67759, '\p{^isnbat}', "");
    Expect(0, 67759, '\P{isnbat}', "");
    Expect(1, 67759, '\P{^isnbat}', "");
    Expect(0, 67760, '\p{isnbat}', "");
    Expect(1, 67760, '\p{^isnbat}', "");
    Expect(1, 67760, '\P{isnbat}', "");
    Expect(0, 67760, '\P{^isnbat}', "");
    Expect(1, 67759, '\p{_is_nbat}', "");
    Expect(0, 67759, '\p{^_is_nbat}', "");
    Expect(0, 67759, '\P{_is_nbat}', "");
    Expect(1, 67759, '\P{^_is_nbat}', "");
    Expect(0, 67760, '\p{_is_nbat}', "");
    Expect(1, 67760, '\p{^_is_nbat}', "");
    Expect(1, 67760, '\P{_is_nbat}', "");
    Expect(0, 67760, '\P{^_is_nbat}', "");
    Error('\p{:= 	new_Tai_Lue}');
    Error('\P{:= 	new_Tai_Lue}');
    Expect(1, 6623, '\p{newtailue}', "");
    Expect(0, 6623, '\p{^newtailue}', "");
    Expect(0, 6623, '\P{newtailue}', "");
    Expect(1, 6623, '\P{^newtailue}', "");
    Expect(0, 6624, '\p{newtailue}', "");
    Expect(1, 6624, '\p{^newtailue}', "");
    Expect(1, 6624, '\P{newtailue}', "");
    Expect(0, 6624, '\P{^newtailue}', "");
    Expect(1, 6623, '\p{-New_Tai_Lue}', "");
    Expect(0, 6623, '\p{^-New_Tai_Lue}', "");
    Expect(0, 6623, '\P{-New_Tai_Lue}', "");
    Expect(1, 6623, '\P{^-New_Tai_Lue}', "");
    Expect(0, 6624, '\p{-New_Tai_Lue}', "");
    Expect(1, 6624, '\p{^-New_Tai_Lue}', "");
    Expect(1, 6624, '\P{-New_Tai_Lue}', "");
    Expect(0, 6624, '\P{^-New_Tai_Lue}', "");
    Error('\p{-/a/is_New_TAI_LUE}');
    Error('\P{-/a/is_New_TAI_LUE}');
    Expect(1, 6623, '\p{isnewtailue}', "");
    Expect(0, 6623, '\p{^isnewtailue}', "");
    Expect(0, 6623, '\P{isnewtailue}', "");
    Expect(1, 6623, '\P{^isnewtailue}', "");
    Expect(0, 6624, '\p{isnewtailue}', "");
    Expect(1, 6624, '\p{^isnewtailue}', "");
    Expect(1, 6624, '\P{isnewtailue}', "");
    Expect(0, 6624, '\P{^isnewtailue}', "");
    Expect(1, 6623, '\p{	IS_NEW_TAI_Lue}', "");
    Expect(0, 6623, '\p{^	IS_NEW_TAI_Lue}', "");
    Expect(0, 6623, '\P{	IS_NEW_TAI_Lue}', "");
    Expect(1, 6623, '\P{^	IS_NEW_TAI_Lue}', "");
    Expect(0, 6624, '\p{	IS_NEW_TAI_Lue}', "");
    Expect(1, 6624, '\p{^	IS_NEW_TAI_Lue}', "");
    Expect(1, 6624, '\P{	IS_NEW_TAI_Lue}', "");
    Expect(0, 6624, '\P{^	IS_NEW_TAI_Lue}', "");
    Error('\p{:=_talu}');
    Error('\P{:=_talu}');
    Expect(1, 6623, '\p{talu}', "");
    Expect(0, 6623, '\p{^talu}', "");
    Expect(0, 6623, '\P{talu}', "");
    Expect(1, 6623, '\P{^talu}', "");
    Expect(0, 6624, '\p{talu}', "");
    Expect(1, 6624, '\p{^talu}', "");
    Expect(1, 6624, '\P{talu}', "");
    Expect(0, 6624, '\P{^talu}', "");
    Expect(1, 6623, '\p{--talu}', "");
    Expect(0, 6623, '\p{^--talu}', "");
    Expect(0, 6623, '\P{--talu}', "");
    Expect(1, 6623, '\P{^--talu}', "");
    Expect(0, 6624, '\p{--talu}', "");
    Expect(1, 6624, '\p{^--talu}', "");
    Expect(1, 6624, '\P{--talu}', "");
    Expect(0, 6624, '\P{^--talu}', "");
    Error('\p{-is_talu/a/}');
    Error('\P{-is_talu/a/}');
    Expect(1, 6623, '\p{istalu}', "");
    Expect(0, 6623, '\p{^istalu}', "");
    Expect(0, 6623, '\P{istalu}', "");
    Expect(1, 6623, '\P{^istalu}', "");
    Expect(0, 6624, '\p{istalu}', "");
    Expect(1, 6624, '\p{^istalu}', "");
    Expect(1, 6624, '\P{istalu}', "");
    Expect(0, 6624, '\P{^istalu}', "");
    Expect(1, 6623, '\p{is_Talu}', "");
    Expect(0, 6623, '\p{^is_Talu}', "");
    Expect(0, 6623, '\P{is_Talu}', "");
    Expect(1, 6623, '\P{^is_Talu}', "");
    Expect(0, 6624, '\p{is_Talu}', "");
    Expect(1, 6624, '\p{^is_Talu}', "");
    Expect(1, 6624, '\P{is_Talu}', "");
    Expect(0, 6624, '\P{^is_Talu}', "");
    Error('\p{/a/	NEWA}');
    Error('\P{/a/	NEWA}');
    Expect(1, 70749, '\p{newa}', "");
    Expect(0, 70749, '\p{^newa}', "");
    Expect(0, 70749, '\P{newa}', "");
    Expect(1, 70749, '\P{^newa}', "");
    Expect(0, 70750, '\p{newa}', "");
    Expect(1, 70750, '\p{^newa}', "");
    Expect(1, 70750, '\P{newa}', "");
    Expect(0, 70750, '\P{^newa}', "");
    Expect(1, 70749, '\p{-	newa}', "");
    Expect(0, 70749, '\p{^-	newa}', "");
    Expect(0, 70749, '\P{-	newa}', "");
    Expect(1, 70749, '\P{^-	newa}', "");
    Expect(0, 70750, '\p{-	newa}', "");
    Expect(1, 70750, '\p{^-	newa}', "");
    Expect(1, 70750, '\P{-	newa}', "");
    Expect(0, 70750, '\P{^-	newa}', "");
    Error('\p{:=	IS_Newa}');
    Error('\P{:=	IS_Newa}');
    Expect(1, 70749, '\p{isnewa}', "");
    Expect(0, 70749, '\p{^isnewa}', "");
    Expect(0, 70749, '\P{isnewa}', "");
    Expect(1, 70749, '\P{^isnewa}', "");
    Expect(0, 70750, '\p{isnewa}', "");
    Expect(1, 70750, '\p{^isnewa}', "");
    Expect(1, 70750, '\P{isnewa}', "");
    Expect(0, 70750, '\P{^isnewa}', "");
    Expect(1, 70749, '\p{	Is_Newa}', "");
    Expect(0, 70749, '\p{^	Is_Newa}', "");
    Expect(0, 70749, '\P{	Is_Newa}', "");
    Expect(1, 70749, '\P{^	Is_Newa}', "");
    Expect(0, 70750, '\p{	Is_Newa}', "");
    Expect(1, 70750, '\p{^	Is_Newa}', "");
    Expect(1, 70750, '\P{	Is_Newa}', "");
    Expect(0, 70750, '\P{^	Is_Newa}', "");
    Error('\p{/a/	Nko}');
    Error('\P{/a/	Nko}');
    Expect(1, 2042, '\p{nko}', "");
    Expect(0, 2042, '\p{^nko}', "");
    Expect(0, 2042, '\P{nko}', "");
    Expect(1, 2042, '\P{^nko}', "");
    Expect(0, 2043, '\p{nko}', "");
    Expect(1, 2043, '\p{^nko}', "");
    Expect(1, 2043, '\P{nko}', "");
    Expect(0, 2043, '\P{^nko}', "");
    Expect(1, 2042, '\p{-_nko}', "");
    Expect(0, 2042, '\p{^-_nko}', "");
    Expect(0, 2042, '\P{-_nko}', "");
    Expect(1, 2042, '\P{^-_nko}', "");
    Expect(0, 2043, '\p{-_nko}', "");
    Expect(1, 2043, '\p{^-_nko}', "");
    Expect(1, 2043, '\P{-_nko}', "");
    Expect(0, 2043, '\P{^-_nko}', "");
    Error('\p{-Is_nko:=}');
    Error('\P{-Is_nko:=}');
    Expect(1, 2042, '\p{isnko}', "");
    Expect(0, 2042, '\p{^isnko}', "");
    Expect(0, 2042, '\P{isnko}', "");
    Expect(1, 2042, '\P{^isnko}', "");
    Expect(0, 2043, '\p{isnko}', "");
    Expect(1, 2043, '\p{^isnko}', "");
    Expect(1, 2043, '\P{isnko}', "");
    Expect(0, 2043, '\P{^isnko}', "");
    Expect(1, 2042, '\p{ -is_Nko}', "");
    Expect(0, 2042, '\p{^ -is_Nko}', "");
    Expect(0, 2042, '\P{ -is_Nko}', "");
    Expect(1, 2042, '\P{^ -is_Nko}', "");
    Expect(0, 2043, '\p{ -is_Nko}', "");
    Expect(1, 2043, '\p{^ -is_Nko}', "");
    Expect(1, 2043, '\P{ -is_Nko}', "");
    Expect(0, 2043, '\P{^ -is_Nko}', "");
    Error('\p{/a/		NKOO}');
    Error('\P{/a/		NKOO}');
    Expect(1, 2042, '\p{nkoo}', "");
    Expect(0, 2042, '\p{^nkoo}', "");
    Expect(0, 2042, '\P{nkoo}', "");
    Expect(1, 2042, '\P{^nkoo}', "");
    Expect(0, 2043, '\p{nkoo}', "");
    Expect(1, 2043, '\p{^nkoo}', "");
    Expect(1, 2043, '\P{nkoo}', "");
    Expect(0, 2043, '\P{^nkoo}', "");
    Expect(1, 2042, '\p{--nkoo}', "");
    Expect(0, 2042, '\p{^--nkoo}', "");
    Expect(0, 2042, '\P{--nkoo}', "");
    Expect(1, 2042, '\P{^--nkoo}', "");
    Expect(0, 2043, '\p{--nkoo}', "");
    Expect(1, 2043, '\p{^--nkoo}', "");
    Expect(1, 2043, '\P{--nkoo}', "");
    Expect(0, 2043, '\P{^--nkoo}', "");
    Error('\p{ :=IS_Nkoo}');
    Error('\P{ :=IS_Nkoo}');
    Expect(1, 2042, '\p{isnkoo}', "");
    Expect(0, 2042, '\p{^isnkoo}', "");
    Expect(0, 2042, '\P{isnkoo}', "");
    Expect(1, 2042, '\P{^isnkoo}', "");
    Expect(0, 2043, '\p{isnkoo}', "");
    Expect(1, 2043, '\p{^isnkoo}', "");
    Expect(1, 2043, '\P{isnkoo}', "");
    Expect(0, 2043, '\P{^isnkoo}', "");
    Expect(1, 2042, '\p{	-is_Nkoo}', "");
    Expect(0, 2042, '\p{^	-is_Nkoo}', "");
    Expect(0, 2042, '\P{	-is_Nkoo}', "");
    Expect(1, 2042, '\P{^	-is_Nkoo}', "");
    Expect(0, 2043, '\p{	-is_Nkoo}', "");
    Expect(1, 2043, '\p{^	-is_Nkoo}', "");
    Expect(1, 2043, '\P{	-is_Nkoo}', "");
    Expect(0, 2043, '\P{^	-is_Nkoo}', "");
    Error('\p{:=--NO_Block}');
    Error('\P{:=--NO_Block}');
    Expect(1, 918000, '\p{noblock}', "");
    Expect(0, 918000, '\p{^noblock}', "");
    Expect(0, 918000, '\P{noblock}', "");
    Expect(1, 918000, '\P{^noblock}', "");
    Expect(0, 983040, '\p{noblock}', "");
    Expect(1, 983040, '\p{^noblock}', "");
    Expect(1, 983040, '\P{noblock}', "");
    Expect(0, 983040, '\P{^noblock}', "");
    Expect(1, 918000, '\p{ _No_BLOCK}', "");
    Expect(0, 918000, '\p{^ _No_BLOCK}', "");
    Expect(0, 918000, '\P{ _No_BLOCK}', "");
    Expect(1, 918000, '\P{^ _No_BLOCK}', "");
    Expect(0, 983040, '\p{ _No_BLOCK}', "");
    Expect(1, 983040, '\p{^ _No_BLOCK}', "");
    Expect(1, 983040, '\P{ _No_BLOCK}', "");
    Expect(0, 983040, '\P{^ _No_BLOCK}', "");
    Error('\p{/a/_ is_NO_Block}');
    Error('\P{/a/_ is_NO_Block}');
    Expect(1, 918000, '\p{isnoblock}', "");
    Expect(0, 918000, '\p{^isnoblock}', "");
    Expect(0, 918000, '\P{isnoblock}', "");
    Expect(1, 918000, '\P{^isnoblock}', "");
    Expect(0, 983040, '\p{isnoblock}', "");
    Expect(1, 983040, '\p{^isnoblock}', "");
    Expect(1, 983040, '\P{isnoblock}', "");
    Expect(0, 983040, '\P{^isnoblock}', "");
    Expect(1, 918000, '\p{__Is_No_block}', "");
    Expect(0, 918000, '\p{^__Is_No_block}', "");
    Expect(0, 918000, '\P{__Is_No_block}', "");
    Expect(1, 918000, '\P{^__Is_No_block}', "");
    Expect(0, 983040, '\p{__Is_No_block}', "");
    Expect(1, 983040, '\p{^__Is_No_block}', "");
    Expect(1, 983040, '\P{__Is_No_block}', "");
    Expect(0, 983040, '\P{^__Is_No_block}', "");
    Error('\p{:= -In_No_Block}');
    Error('\P{:= -In_No_Block}');
    Expect(1, 918000, '\p{innoblock}', "");
    Expect(0, 918000, '\p{^innoblock}', "");
    Expect(0, 918000, '\P{innoblock}', "");
    Expect(1, 918000, '\P{^innoblock}', "");
    Expect(0, 983040, '\p{innoblock}', "");
    Expect(1, 983040, '\p{^innoblock}', "");
    Expect(1, 983040, '\P{innoblock}', "");
    Expect(0, 983040, '\P{^innoblock}', "");
    Expect(1, 918000, '\p{ -In_NO_Block}', "");
    Expect(0, 918000, '\p{^ -In_NO_Block}', "");
    Expect(0, 918000, '\P{ -In_NO_Block}', "");
    Expect(1, 918000, '\P{^ -In_NO_Block}', "");
    Expect(0, 983040, '\p{ -In_NO_Block}', "");
    Expect(1, 983040, '\p{^ -In_NO_Block}', "");
    Expect(1, 983040, '\P{ -In_NO_Block}', "");
    Expect(0, 983040, '\P{^ -In_NO_Block}', "");
    Error('\p{/a/	_nb}');
    Error('\P{/a/	_nb}');
    Expect(1, 918000, '\p{nb}', "");
    Expect(0, 918000, '\p{^nb}', "");
    Expect(0, 918000, '\P{nb}', "");
    Expect(1, 918000, '\P{^nb}', "");
    Expect(0, 983040, '\p{nb}', "");
    Expect(1, 983040, '\p{^nb}', "");
    Expect(1, 983040, '\P{nb}', "");
    Expect(0, 983040, '\P{^nb}', "");
    Expect(1, 918000, '\p{  nb}', "");
    Expect(0, 918000, '\p{^  nb}', "");
    Expect(0, 918000, '\P{  nb}', "");
    Expect(1, 918000, '\P{^  nb}', "");
    Expect(0, 983040, '\p{  nb}', "");
    Expect(1, 983040, '\p{^  nb}', "");
    Expect(1, 983040, '\P{  nb}', "");
    Expect(0, 983040, '\P{^  nb}', "");
    Error('\p{/a/Is_NB}');
    Error('\P{/a/Is_NB}');
    Expect(1, 918000, '\p{isnb}', "");
    Expect(0, 918000, '\p{^isnb}', "");
    Expect(0, 918000, '\P{isnb}', "");
    Expect(1, 918000, '\P{^isnb}', "");
    Expect(0, 983040, '\p{isnb}', "");
    Expect(1, 983040, '\p{^isnb}', "");
    Expect(1, 983040, '\P{isnb}', "");
    Expect(0, 983040, '\P{^isnb}', "");
    Expect(1, 918000, '\p{ _Is_NB}', "");
    Expect(0, 918000, '\p{^ _Is_NB}', "");
    Expect(0, 918000, '\P{ _Is_NB}', "");
    Expect(1, 918000, '\P{^ _Is_NB}', "");
    Expect(0, 983040, '\p{ _Is_NB}', "");
    Expect(1, 983040, '\p{^ _Is_NB}', "");
    Expect(1, 983040, '\P{ _Is_NB}', "");
    Expect(0, 983040, '\P{^ _Is_NB}', "");
    Error('\p{--in_NB:=}');
    Error('\P{--in_NB:=}');
    Expect(1, 918000, '\p{innb}', "");
    Expect(0, 918000, '\p{^innb}', "");
    Expect(0, 918000, '\P{innb}', "");
    Expect(1, 918000, '\P{^innb}', "");
    Expect(0, 983040, '\p{innb}', "");
    Expect(1, 983040, '\p{^innb}', "");
    Expect(1, 983040, '\P{innb}', "");
    Expect(0, 983040, '\P{^innb}', "");
    Expect(1, 918000, '\p{_ In_NB}', "");
    Expect(0, 918000, '\p{^_ In_NB}', "");
    Expect(0, 918000, '\P{_ In_NB}', "");
    Expect(1, 918000, '\P{^_ In_NB}', "");
    Expect(0, 983040, '\p{_ In_NB}', "");
    Expect(1, 983040, '\p{^_ In_NB}', "");
    Expect(1, 983040, '\P{_ In_NB}', "");
    Expect(0, 983040, '\P{^_ In_NB}', "");
    Error('\p{:=__Noncharacter_Code_Point}');
    Error('\P{:=__Noncharacter_Code_Point}');
    Expect(1, 1114111, '\p{noncharactercodepoint}', "");
    Expect(0, 1114111, '\p{^noncharactercodepoint}', "");
    Expect(0, 1114111, '\P{noncharactercodepoint}', "");
    Expect(1, 1114111, '\P{^noncharactercodepoint}', "");
    Expect(0, 1114109, '\p{noncharactercodepoint}', "");
    Expect(1, 1114109, '\p{^noncharactercodepoint}', "");
    Expect(1, 1114109, '\P{noncharactercodepoint}', "");
    Expect(0, 1114109, '\P{^noncharactercodepoint}', "");
    Expect(1, 1114111, '\p{-_NONCHARACTER_CODE_Point}', "");
    Expect(0, 1114111, '\p{^-_NONCHARACTER_CODE_Point}', "");
    Expect(0, 1114111, '\P{-_NONCHARACTER_CODE_Point}', "");
    Expect(1, 1114111, '\P{^-_NONCHARACTER_CODE_Point}', "");
    Expect(0, 1114109, '\p{-_NONCHARACTER_CODE_Point}', "");
    Expect(1, 1114109, '\p{^-_NONCHARACTER_CODE_Point}', "");
    Expect(1, 1114109, '\P{-_NONCHARACTER_CODE_Point}', "");
    Expect(0, 1114109, '\P{^-_NONCHARACTER_CODE_Point}', "");
    Error('\p{-	Is_Noncharacter_Code_POINT:=}');
    Error('\P{-	Is_Noncharacter_Code_POINT:=}');
    Expect(1, 1114111, '\p{isnoncharactercodepoint}', "");
    Expect(0, 1114111, '\p{^isnoncharactercodepoint}', "");
    Expect(0, 1114111, '\P{isnoncharactercodepoint}', "");
    Expect(1, 1114111, '\P{^isnoncharactercodepoint}', "");
    Expect(0, 1114109, '\p{isnoncharactercodepoint}', "");
    Expect(1, 1114109, '\p{^isnoncharactercodepoint}', "");
    Expect(1, 1114109, '\P{isnoncharactercodepoint}', "");
    Expect(0, 1114109, '\P{^isnoncharactercodepoint}', "");
    Expect(1, 1114111, '\p{-IS_NONCHARACTER_Code_POINT}', "");
    Expect(0, 1114111, '\p{^-IS_NONCHARACTER_Code_POINT}', "");
    Expect(0, 1114111, '\P{-IS_NONCHARACTER_Code_POINT}', "");
    Expect(1, 1114111, '\P{^-IS_NONCHARACTER_Code_POINT}', "");
    Expect(0, 1114109, '\p{-IS_NONCHARACTER_Code_POINT}', "");
    Expect(1, 1114109, '\p{^-IS_NONCHARACTER_Code_POINT}', "");
    Expect(1, 1114109, '\P{-IS_NONCHARACTER_Code_POINT}', "");
    Expect(0, 1114109, '\P{^-IS_NONCHARACTER_Code_POINT}', "");
    Error('\p{ _NCHAR:=}');
    Error('\P{ _NCHAR:=}');
    Expect(1, 1114111, '\p{nchar}', "");
    Expect(0, 1114111, '\p{^nchar}', "");
    Expect(0, 1114111, '\P{nchar}', "");
    Expect(1, 1114111, '\P{^nchar}', "");
    Expect(0, 1114109, '\p{nchar}', "");
    Expect(1, 1114109, '\p{^nchar}', "");
    Expect(1, 1114109, '\P{nchar}', "");
    Expect(0, 1114109, '\P{^nchar}', "");
    Expect(1, 1114111, '\p{__NCHAR}', "");
    Expect(0, 1114111, '\p{^__NCHAR}', "");
    Expect(0, 1114111, '\P{__NCHAR}', "");
    Expect(1, 1114111, '\P{^__NCHAR}', "");
    Expect(0, 1114109, '\p{__NCHAR}', "");
    Expect(1, 1114109, '\p{^__NCHAR}', "");
    Expect(1, 1114109, '\P{__NCHAR}', "");
    Expect(0, 1114109, '\P{^__NCHAR}', "");
    Error('\p{	is_NChar:=}');
    Error('\P{	is_NChar:=}');
    Expect(1, 1114111, '\p{isnchar}', "");
    Expect(0, 1114111, '\p{^isnchar}', "");
    Expect(0, 1114111, '\P{isnchar}', "");
    Expect(1, 1114111, '\P{^isnchar}', "");
    Expect(0, 1114109, '\p{isnchar}', "");
    Expect(1, 1114109, '\p{^isnchar}', "");
    Expect(1, 1114109, '\P{isnchar}', "");
    Expect(0, 1114109, '\P{^isnchar}', "");
    Expect(1, 1114111, '\p{ -Is_NChar}', "");
    Expect(0, 1114111, '\p{^ -Is_NChar}', "");
    Expect(0, 1114111, '\P{ -Is_NChar}', "");
    Expect(1, 1114111, '\P{^ -Is_NChar}', "");
    Expect(0, 1114109, '\p{ -Is_NChar}', "");
    Expect(1, 1114109, '\p{^ -Is_NChar}', "");
    Expect(1, 1114109, '\P{ -Is_NChar}', "");
    Expect(0, 1114109, '\P{^ -Is_NChar}', "");
    Error('\p{/a/__NONSPACING_MARK}');
    Error('\P{/a/__NONSPACING_MARK}');
    Expect(1, 917999, '\p{nonspacingmark}', "");
    Expect(0, 917999, '\p{^nonspacingmark}', "");
    Expect(0, 917999, '\P{nonspacingmark}', "");
    Expect(1, 917999, '\P{^nonspacingmark}', "");
    Expect(0, 918000, '\p{nonspacingmark}', "");
    Expect(1, 918000, '\p{^nonspacingmark}', "");
    Expect(1, 918000, '\P{nonspacingmark}', "");
    Expect(0, 918000, '\P{^nonspacingmark}', "");
    Expect(1, 917999, '\p{	-Nonspacing_Mark}', "");
    Expect(0, 917999, '\p{^	-Nonspacing_Mark}', "");
    Expect(0, 917999, '\P{	-Nonspacing_Mark}', "");
    Expect(1, 917999, '\P{^	-Nonspacing_Mark}', "");
    Expect(0, 918000, '\p{	-Nonspacing_Mark}', "");
    Expect(1, 918000, '\p{^	-Nonspacing_Mark}', "");
    Expect(1, 918000, '\P{	-Nonspacing_Mark}', "");
    Expect(0, 918000, '\P{^	-Nonspacing_Mark}', "");
    Error('\p{	:=Is_nonspacing_Mark}');
    Error('\P{	:=Is_nonspacing_Mark}');
    Expect(1, 917999, '\p{isnonspacingmark}', "");
    Expect(0, 917999, '\p{^isnonspacingmark}', "");
    Expect(0, 917999, '\P{isnonspacingmark}', "");
    Expect(1, 917999, '\P{^isnonspacingmark}', "");
    Expect(0, 918000, '\p{isnonspacingmark}', "");
    Expect(1, 918000, '\p{^isnonspacingmark}', "");
    Expect(1, 918000, '\P{isnonspacingmark}', "");
    Expect(0, 918000, '\P{^isnonspacingmark}', "");
    Expect(1, 917999, '\p{_is_NONSPACING_Mark}', "");
    Expect(0, 917999, '\p{^_is_NONSPACING_Mark}', "");
    Expect(0, 917999, '\P{_is_NONSPACING_Mark}', "");
    Expect(1, 917999, '\P{^_is_NONSPACING_Mark}', "");
    Expect(0, 918000, '\p{_is_NONSPACING_Mark}', "");
    Expect(1, 918000, '\p{^_is_NONSPACING_Mark}', "");
    Expect(1, 918000, '\P{_is_NONSPACING_Mark}', "");
    Expect(0, 918000, '\P{^_is_NONSPACING_Mark}', "");
    Error('\p{ _Mn/a/}');
    Error('\P{ _Mn/a/}');
    Expect(1, 917999, '\p{mn}', "");
    Expect(0, 917999, '\p{^mn}', "");
    Expect(0, 917999, '\P{mn}', "");
    Expect(1, 917999, '\P{^mn}', "");
    Expect(0, 918000, '\p{mn}', "");
    Expect(1, 918000, '\p{^mn}', "");
    Expect(1, 918000, '\P{mn}', "");
    Expect(0, 918000, '\P{^mn}', "");
    Expect(1, 917999, '\p{-Mn}', "");
    Expect(0, 917999, '\p{^-Mn}', "");
    Expect(0, 917999, '\P{-Mn}', "");
    Expect(1, 917999, '\P{^-Mn}', "");
    Expect(0, 918000, '\p{-Mn}', "");
    Expect(1, 918000, '\p{^-Mn}', "");
    Expect(1, 918000, '\P{-Mn}', "");
    Expect(0, 918000, '\P{^-Mn}', "");
    Error('\p{ Is_Mn:=}');
    Error('\P{ Is_Mn:=}');
    Expect(1, 917999, '\p{ismn}', "");
    Expect(0, 917999, '\p{^ismn}', "");
    Expect(0, 917999, '\P{ismn}', "");
    Expect(1, 917999, '\P{^ismn}', "");
    Expect(0, 918000, '\p{ismn}', "");
    Expect(1, 918000, '\p{^ismn}', "");
    Expect(1, 918000, '\P{ismn}', "");
    Expect(0, 918000, '\P{^ismn}', "");
    Expect(1, 917999, '\p{ is_Mn}', "");
    Expect(0, 917999, '\p{^ is_Mn}', "");
    Expect(0, 917999, '\P{ is_Mn}', "");
    Expect(1, 917999, '\P{^ is_Mn}', "");
    Expect(0, 918000, '\p{ is_Mn}', "");
    Expect(1, 918000, '\p{^ is_Mn}', "");
    Expect(1, 918000, '\P{ is_Mn}', "");
    Expect(0, 918000, '\P{^ is_Mn}', "");
    Error('\p{ Number/a/}');
    Error('\P{ Number/a/}');
    Expect(1, 127244, '\p{number}', "");
    Expect(0, 127244, '\p{^number}', "");
    Expect(0, 127244, '\P{number}', "");
    Expect(1, 127244, '\P{^number}', "");
    Expect(0, 127245, '\p{number}', "");
    Expect(1, 127245, '\p{^number}', "");
    Expect(1, 127245, '\P{number}', "");
    Expect(0, 127245, '\P{^number}', "");
    Expect(1, 127244, '\p{_NUMBER}', "");
    Expect(0, 127244, '\p{^_NUMBER}', "");
    Expect(0, 127244, '\P{_NUMBER}', "");
    Expect(1, 127244, '\P{^_NUMBER}', "");
    Expect(0, 127245, '\p{_NUMBER}', "");
    Expect(1, 127245, '\p{^_NUMBER}', "");
    Expect(1, 127245, '\P{_NUMBER}', "");
    Expect(0, 127245, '\P{^_NUMBER}', "");
    Error('\p{/a/-is_Number}');
    Error('\P{/a/-is_Number}');
    Expect(1, 127244, '\p{isnumber}', "");
    Expect(0, 127244, '\p{^isnumber}', "");
    Expect(0, 127244, '\P{isnumber}', "");
    Expect(1, 127244, '\P{^isnumber}', "");
    Expect(0, 127245, '\p{isnumber}', "");
    Expect(1, 127245, '\p{^isnumber}', "");
    Expect(1, 127245, '\P{isnumber}', "");
    Expect(0, 127245, '\P{^isnumber}', "");
    Expect(1, 127244, '\p{_IS_NUMBER}', "");
    Expect(0, 127244, '\p{^_IS_NUMBER}', "");
    Expect(0, 127244, '\P{_IS_NUMBER}', "");
    Expect(1, 127244, '\P{^_IS_NUMBER}', "");
    Expect(0, 127245, '\p{_IS_NUMBER}', "");
    Expect(1, 127245, '\p{^_IS_NUMBER}', "");
    Expect(1, 127245, '\P{_IS_NUMBER}', "");
    Expect(0, 127245, '\P{^_IS_NUMBER}', "");
    Error('\p{_:=n}');
    Error('\P{_:=n}');
    Expect(1, 127244, '\p{n}', "");
    Expect(0, 127244, '\p{^n}', "");
    Expect(0, 127244, '\P{n}', "");
    Expect(1, 127244, '\P{^n}', "");
    Expect(0, 127245, '\p{n}', "");
    Expect(1, 127245, '\p{^n}', "");
    Expect(1, 127245, '\P{n}', "");
    Expect(0, 127245, '\P{^n}', "");
    Expect(1, 127244, '\p{_N}', "");
    Expect(0, 127244, '\p{^_N}', "");
    Expect(0, 127244, '\P{_N}', "");
    Expect(1, 127244, '\P{^_N}', "");
    Expect(0, 127245, '\p{_N}', "");
    Expect(1, 127245, '\p{^_N}', "");
    Expect(1, 127245, '\P{_N}', "");
    Expect(0, 127245, '\P{^_N}', "");
    Error('\p{_	is_n:=}');
    Error('\P{_	is_n:=}');
    Expect(1, 127244, '\p{isn}', "");
    Expect(0, 127244, '\p{^isn}', "");
    Expect(0, 127244, '\P{isn}', "");
    Expect(1, 127244, '\P{^isn}', "");
    Expect(0, 127245, '\p{isn}', "");
    Expect(1, 127245, '\p{^isn}', "");
    Expect(1, 127245, '\P{isn}', "");
    Expect(0, 127245, '\P{^isn}', "");
    Expect(1, 127244, '\p{--IS_N}', "");
    Expect(0, 127244, '\p{^--IS_N}', "");
    Expect(0, 127244, '\P{--IS_N}', "");
    Expect(1, 127244, '\P{^--IS_N}', "");
    Expect(0, 127245, '\p{--IS_N}', "");
    Expect(1, 127245, '\p{^--IS_N}', "");
    Expect(1, 127245, '\P{--IS_N}', "");
    Expect(0, 127245, '\P{^--IS_N}', "");
    Error('\p{_/a/Number_Forms}');
    Error('\P{_/a/Number_Forms}');
    Expect(1, 8591, '\p{numberforms}', "");
    Expect(0, 8591, '\p{^numberforms}', "");
    Expect(0, 8591, '\P{numberforms}', "");
    Expect(1, 8591, '\P{^numberforms}', "");
    Expect(0, 8592, '\p{numberforms}', "");
    Expect(1, 8592, '\p{^numberforms}', "");
    Expect(1, 8592, '\P{numberforms}', "");
    Expect(0, 8592, '\P{^numberforms}', "");
    Expect(1, 8591, '\p{		number_FORMS}', "");
    Expect(0, 8591, '\p{^		number_FORMS}', "");
    Expect(0, 8591, '\P{		number_FORMS}', "");
    Expect(1, 8591, '\P{^		number_FORMS}', "");
    Expect(0, 8592, '\p{		number_FORMS}', "");
    Expect(1, 8592, '\p{^		number_FORMS}', "");
    Expect(1, 8592, '\P{		number_FORMS}', "");
    Expect(0, 8592, '\P{^		number_FORMS}', "");
    Error('\p{_is_Number_Forms/a/}');
    Error('\P{_is_Number_Forms/a/}');
    Expect(1, 8591, '\p{isnumberforms}', "");
    Expect(0, 8591, '\p{^isnumberforms}', "");
    Expect(0, 8591, '\P{isnumberforms}', "");
    Expect(1, 8591, '\P{^isnumberforms}', "");
    Expect(0, 8592, '\p{isnumberforms}', "");
    Expect(1, 8592, '\p{^isnumberforms}', "");
    Expect(1, 8592, '\P{isnumberforms}', "");
    Expect(0, 8592, '\P{^isnumberforms}', "");
    Expect(1, 8591, '\p{-	Is_Number_Forms}', "");
    Expect(0, 8591, '\p{^-	Is_Number_Forms}', "");
    Expect(0, 8591, '\P{-	Is_Number_Forms}', "");
    Expect(1, 8591, '\P{^-	Is_Number_Forms}', "");
    Expect(0, 8592, '\p{-	Is_Number_Forms}', "");
    Expect(1, 8592, '\p{^-	Is_Number_Forms}', "");
    Expect(1, 8592, '\P{-	Is_Number_Forms}', "");
    Expect(0, 8592, '\P{^-	Is_Number_Forms}', "");
    Error('\p{_	In_Number_Forms:=}');
    Error('\P{_	In_Number_Forms:=}');
    Expect(1, 8591, '\p{innumberforms}', "");
    Expect(0, 8591, '\p{^innumberforms}', "");
    Expect(0, 8591, '\P{innumberforms}', "");
    Expect(1, 8591, '\P{^innumberforms}', "");
    Expect(0, 8592, '\p{innumberforms}', "");
    Expect(1, 8592, '\p{^innumberforms}', "");
    Expect(1, 8592, '\P{innumberforms}', "");
    Expect(0, 8592, '\P{^innumberforms}', "");
    Expect(1, 8591, '\p{-	In_Number_FORMS}', "");
    Expect(0, 8591, '\p{^-	In_Number_FORMS}', "");
    Expect(0, 8591, '\P{-	In_Number_FORMS}', "");
    Expect(1, 8591, '\P{^-	In_Number_FORMS}', "");
    Expect(0, 8592, '\p{-	In_Number_FORMS}', "");
    Expect(1, 8592, '\p{^-	In_Number_FORMS}', "");
    Expect(1, 8592, '\P{-	In_Number_FORMS}', "");
    Expect(0, 8592, '\P{^-	In_Number_FORMS}', "");
    Error('\p{__NUSHU:=}');
    Error('\P{__NUSHU:=}');
    Expect(1, 111355, '\p{nushu}', "");
    Expect(0, 111355, '\p{^nushu}', "");
    Expect(0, 111355, '\P{nushu}', "");
    Expect(1, 111355, '\P{^nushu}', "");
    Expect(0, 111356, '\p{nushu}', "");
    Expect(1, 111356, '\p{^nushu}', "");
    Expect(1, 111356, '\P{nushu}', "");
    Expect(0, 111356, '\P{^nushu}', "");
    Expect(1, 111355, '\p{	-Nushu}', "");
    Expect(0, 111355, '\p{^	-Nushu}', "");
    Expect(0, 111355, '\P{	-Nushu}', "");
    Expect(1, 111355, '\P{^	-Nushu}', "");
    Expect(0, 111356, '\p{	-Nushu}', "");
    Expect(1, 111356, '\p{^	-Nushu}', "");
    Expect(1, 111356, '\P{	-Nushu}', "");
    Expect(0, 111356, '\P{^	-Nushu}', "");
    Error('\p{ -is_Nushu/a/}');
    Error('\P{ -is_Nushu/a/}');
    Expect(1, 111355, '\p{isnushu}', "");
    Expect(0, 111355, '\p{^isnushu}', "");
    Expect(0, 111355, '\P{isnushu}', "");
    Expect(1, 111355, '\P{^isnushu}', "");
    Expect(0, 111356, '\p{isnushu}', "");
    Expect(1, 111356, '\p{^isnushu}', "");
    Expect(1, 111356, '\P{isnushu}', "");
    Expect(0, 111356, '\P{^isnushu}', "");
    Expect(1, 111355, '\p{--Is_nushu}', "");
    Expect(0, 111355, '\p{^--Is_nushu}', "");
    Expect(0, 111355, '\P{--Is_nushu}', "");
    Expect(1, 111355, '\P{^--Is_nushu}', "");
    Expect(0, 111356, '\p{--Is_nushu}', "");
    Expect(1, 111356, '\p{^--Is_nushu}', "");
    Expect(1, 111356, '\P{--Is_nushu}', "");
    Expect(0, 111356, '\P{^--Is_nushu}', "");
    Error('\p{/a/		NSHU}');
    Error('\P{/a/		NSHU}');
    Expect(1, 111355, '\p{nshu}', "");
    Expect(0, 111355, '\p{^nshu}', "");
    Expect(0, 111355, '\P{nshu}', "");
    Expect(1, 111355, '\P{^nshu}', "");
    Expect(0, 111356, '\p{nshu}', "");
    Expect(1, 111356, '\p{^nshu}', "");
    Expect(1, 111356, '\P{nshu}', "");
    Expect(0, 111356, '\P{^nshu}', "");
    Expect(1, 111355, '\p{-	nshu}', "");
    Expect(0, 111355, '\p{^-	nshu}', "");
    Expect(0, 111355, '\P{-	nshu}', "");
    Expect(1, 111355, '\P{^-	nshu}', "");
    Expect(0, 111356, '\p{-	nshu}', "");
    Expect(1, 111356, '\p{^-	nshu}', "");
    Expect(1, 111356, '\P{-	nshu}', "");
    Expect(0, 111356, '\P{^-	nshu}', "");
    Error('\p{:=	is_Nshu}');
    Error('\P{:=	is_Nshu}');
    Expect(1, 111355, '\p{isnshu}', "");
    Expect(0, 111355, '\p{^isnshu}', "");
    Expect(0, 111355, '\P{isnshu}', "");
    Expect(1, 111355, '\P{^isnshu}', "");
    Expect(0, 111356, '\p{isnshu}', "");
    Expect(1, 111356, '\p{^isnshu}', "");
    Expect(1, 111356, '\P{isnshu}', "");
    Expect(0, 111356, '\P{^isnshu}', "");
    Expect(1, 111355, '\p{ Is_Nshu}', "");
    Expect(0, 111355, '\p{^ Is_Nshu}', "");
    Expect(0, 111355, '\P{ Is_Nshu}', "");
    Expect(1, 111355, '\P{^ Is_Nshu}', "");
    Expect(0, 111356, '\p{ Is_Nshu}', "");
    Expect(1, 111356, '\p{^ Is_Nshu}', "");
    Expect(1, 111356, '\P{ Is_Nshu}', "");
    Expect(0, 111356, '\P{^ Is_Nshu}', "");
    Error('\p{-	OGHAM/a/}');
    Error('\P{-	OGHAM/a/}');
    Expect(1, 5788, '\p{ogham}', "");
    Expect(0, 5788, '\p{^ogham}', "");
    Expect(0, 5788, '\P{ogham}', "");
    Expect(1, 5788, '\P{^ogham}', "");
    Expect(0, 5789, '\p{ogham}', "");
    Expect(1, 5789, '\p{^ogham}', "");
    Expect(1, 5789, '\P{ogham}', "");
    Expect(0, 5789, '\P{^ogham}', "");
    Expect(1, 5788, '\p{	 Ogham}', "");
    Expect(0, 5788, '\p{^	 Ogham}', "");
    Expect(0, 5788, '\P{	 Ogham}', "");
    Expect(1, 5788, '\P{^	 Ogham}', "");
    Expect(0, 5789, '\p{	 Ogham}', "");
    Expect(1, 5789, '\p{^	 Ogham}', "");
    Expect(1, 5789, '\P{	 Ogham}', "");
    Expect(0, 5789, '\P{^	 Ogham}', "");
    Error('\p{/a/_	Is_Ogham}');
    Error('\P{/a/_	Is_Ogham}');
    Expect(1, 5788, '\p{isogham}', "");
    Expect(0, 5788, '\p{^isogham}', "");
    Expect(0, 5788, '\P{isogham}', "");
    Expect(1, 5788, '\P{^isogham}', "");
    Expect(0, 5789, '\p{isogham}', "");
    Expect(1, 5789, '\p{^isogham}', "");
    Expect(1, 5789, '\P{isogham}', "");
    Expect(0, 5789, '\P{^isogham}', "");
    Expect(1, 5788, '\p{ _IS_Ogham}', "");
    Expect(0, 5788, '\p{^ _IS_Ogham}', "");
    Expect(0, 5788, '\P{ _IS_Ogham}', "");
    Expect(1, 5788, '\P{^ _IS_Ogham}', "");
    Expect(0, 5789, '\p{ _IS_Ogham}', "");
    Expect(1, 5789, '\p{^ _IS_Ogham}', "");
    Expect(1, 5789, '\P{ _IS_Ogham}', "");
    Expect(0, 5789, '\P{^ _IS_Ogham}', "");
    Error('\p{_:=Ogam}');
    Error('\P{_:=Ogam}');
    Expect(1, 5788, '\p{ogam}', "");
    Expect(0, 5788, '\p{^ogam}', "");
    Expect(0, 5788, '\P{ogam}', "");
    Expect(1, 5788, '\P{^ogam}', "");
    Expect(0, 5789, '\p{ogam}', "");
    Expect(1, 5789, '\p{^ogam}', "");
    Expect(1, 5789, '\P{ogam}', "");
    Expect(0, 5789, '\P{^ogam}', "");
    Expect(1, 5788, '\p{_Ogam}', "");
    Expect(0, 5788, '\p{^_Ogam}', "");
    Expect(0, 5788, '\P{_Ogam}', "");
    Expect(1, 5788, '\P{^_Ogam}', "");
    Expect(0, 5789, '\p{_Ogam}', "");
    Expect(1, 5789, '\p{^_Ogam}', "");
    Expect(1, 5789, '\P{_Ogam}', "");
    Expect(0, 5789, '\P{^_Ogam}', "");
    Error('\p{ Is_Ogam:=}');
    Error('\P{ Is_Ogam:=}');
    Expect(1, 5788, '\p{isogam}', "");
    Expect(0, 5788, '\p{^isogam}', "");
    Expect(0, 5788, '\P{isogam}', "");
    Expect(1, 5788, '\P{^isogam}', "");
    Expect(0, 5789, '\p{isogam}', "");
    Expect(1, 5789, '\p{^isogam}', "");
    Expect(1, 5789, '\P{isogam}', "");
    Expect(0, 5789, '\P{^isogam}', "");
    Expect(1, 5788, '\p{-Is_ogam}', "");
    Expect(0, 5788, '\p{^-Is_ogam}', "");
    Expect(0, 5788, '\P{-Is_ogam}', "");
    Expect(1, 5788, '\P{^-Is_ogam}', "");
    Expect(0, 5789, '\p{-Is_ogam}', "");
    Expect(1, 5789, '\p{^-Is_ogam}', "");
    Expect(1, 5789, '\P{-Is_ogam}', "");
    Expect(0, 5789, '\P{^-Is_ogam}', "");
    Error('\p{ 	OL_chiki:=}');
    Error('\P{ 	OL_chiki:=}');
    Expect(1, 7295, '\p{olchiki}', "");
    Expect(0, 7295, '\p{^olchiki}', "");
    Expect(0, 7295, '\P{olchiki}', "");
    Expect(1, 7295, '\P{^olchiki}', "");
    Expect(0, 7296, '\p{olchiki}', "");
    Expect(1, 7296, '\p{^olchiki}', "");
    Expect(1, 7296, '\P{olchiki}', "");
    Expect(0, 7296, '\P{^olchiki}', "");
    Expect(1, 7295, '\p{		ol_CHIKI}', "");
    Expect(0, 7295, '\p{^		ol_CHIKI}', "");
    Expect(0, 7295, '\P{		ol_CHIKI}', "");
    Expect(1, 7295, '\P{^		ol_CHIKI}', "");
    Expect(0, 7296, '\p{		ol_CHIKI}', "");
    Expect(1, 7296, '\p{^		ol_CHIKI}', "");
    Expect(1, 7296, '\P{		ol_CHIKI}', "");
    Expect(0, 7296, '\P{^		ol_CHIKI}', "");
    Error('\p{/a/ _IS_Ol_CHIKI}');
    Error('\P{/a/ _IS_Ol_CHIKI}');
    Expect(1, 7295, '\p{isolchiki}', "");
    Expect(0, 7295, '\p{^isolchiki}', "");
    Expect(0, 7295, '\P{isolchiki}', "");
    Expect(1, 7295, '\P{^isolchiki}', "");
    Expect(0, 7296, '\p{isolchiki}', "");
    Expect(1, 7296, '\p{^isolchiki}', "");
    Expect(1, 7296, '\P{isolchiki}', "");
    Expect(0, 7296, '\P{^isolchiki}', "");
    Expect(1, 7295, '\p{	 Is_ol_chiki}', "");
    Expect(0, 7295, '\p{^	 Is_ol_chiki}', "");
    Expect(0, 7295, '\P{	 Is_ol_chiki}', "");
    Expect(1, 7295, '\P{^	 Is_ol_chiki}', "");
    Expect(0, 7296, '\p{	 Is_ol_chiki}', "");
    Expect(1, 7296, '\p{^	 Is_ol_chiki}', "");
    Expect(1, 7296, '\P{	 Is_ol_chiki}', "");
    Expect(0, 7296, '\P{^	 Is_ol_chiki}', "");
    Error('\p{- olck/a/}');
    Error('\P{- olck/a/}');
    Expect(1, 7295, '\p{olck}', "");
    Expect(0, 7295, '\p{^olck}', "");
    Expect(0, 7295, '\P{olck}', "");
    Expect(1, 7295, '\P{^olck}', "");
    Expect(0, 7296, '\p{olck}', "");
    Expect(1, 7296, '\p{^olck}', "");
    Expect(1, 7296, '\P{olck}', "");
    Expect(0, 7296, '\P{^olck}', "");
    Expect(1, 7295, '\p{__Olck}', "");
    Expect(0, 7295, '\p{^__Olck}', "");
    Expect(0, 7295, '\P{__Olck}', "");
    Expect(1, 7295, '\P{^__Olck}', "");
    Expect(0, 7296, '\p{__Olck}', "");
    Expect(1, 7296, '\p{^__Olck}', "");
    Expect(1, 7296, '\P{__Olck}', "");
    Expect(0, 7296, '\P{^__Olck}', "");
    Error('\p{-:=Is_OLCK}');
    Error('\P{-:=Is_OLCK}');
    Expect(1, 7295, '\p{isolck}', "");
    Expect(0, 7295, '\p{^isolck}', "");
    Expect(0, 7295, '\P{isolck}', "");
    Expect(1, 7295, '\P{^isolck}', "");
    Expect(0, 7296, '\p{isolck}', "");
    Expect(1, 7296, '\p{^isolck}', "");
    Expect(1, 7296, '\P{isolck}', "");
    Expect(0, 7296, '\P{^isolck}', "");
    Expect(1, 7295, '\p{  Is_OLCK}', "");
    Expect(0, 7295, '\p{^  Is_OLCK}', "");
    Expect(0, 7295, '\P{  Is_OLCK}', "");
    Expect(1, 7295, '\P{^  Is_OLCK}', "");
    Expect(0, 7296, '\p{  Is_OLCK}', "");
    Expect(1, 7296, '\p{^  Is_OLCK}', "");
    Expect(1, 7296, '\P{  Is_OLCK}', "");
    Expect(0, 7296, '\P{^  Is_OLCK}', "");
    Error('\p{ -old_Hungarian/a/}');
    Error('\P{ -old_Hungarian/a/}');
    Expect(1, 68863, '\p{oldhungarian}', "");
    Expect(0, 68863, '\p{^oldhungarian}', "");
    Expect(0, 68863, '\P{oldhungarian}', "");
    Expect(1, 68863, '\P{^oldhungarian}', "");
    Expect(0, 68864, '\p{oldhungarian}', "");
    Expect(1, 68864, '\p{^oldhungarian}', "");
    Expect(1, 68864, '\P{oldhungarian}', "");
    Expect(0, 68864, '\P{^oldhungarian}', "");
    Expect(1, 68863, '\p{	-Old_HUNGARIAN}', "");
    Expect(0, 68863, '\p{^	-Old_HUNGARIAN}', "");
    Expect(0, 68863, '\P{	-Old_HUNGARIAN}', "");
    Expect(1, 68863, '\P{^	-Old_HUNGARIAN}', "");
    Expect(0, 68864, '\p{	-Old_HUNGARIAN}', "");
    Expect(1, 68864, '\p{^	-Old_HUNGARIAN}', "");
    Expect(1, 68864, '\P{	-Old_HUNGARIAN}', "");
    Expect(0, 68864, '\P{^	-Old_HUNGARIAN}', "");
    Error('\p{:= IS_Old_hungarian}');
    Error('\P{:= IS_Old_hungarian}');
    Expect(1, 68863, '\p{isoldhungarian}', "");
    Expect(0, 68863, '\p{^isoldhungarian}', "");
    Expect(0, 68863, '\P{isoldhungarian}', "");
    Expect(1, 68863, '\P{^isoldhungarian}', "");
    Expect(0, 68864, '\p{isoldhungarian}', "");
    Expect(1, 68864, '\p{^isoldhungarian}', "");
    Expect(1, 68864, '\P{isoldhungarian}', "");
    Expect(0, 68864, '\P{^isoldhungarian}', "");
    Expect(1, 68863, '\p{_IS_old_hungarian}', "");
    Expect(0, 68863, '\p{^_IS_old_hungarian}', "");
    Expect(0, 68863, '\P{_IS_old_hungarian}', "");
    Expect(1, 68863, '\P{^_IS_old_hungarian}', "");
    Expect(0, 68864, '\p{_IS_old_hungarian}', "");
    Expect(1, 68864, '\p{^_IS_old_hungarian}', "");
    Expect(1, 68864, '\P{_IS_old_hungarian}', "");
    Expect(0, 68864, '\P{^_IS_old_hungarian}', "");
    Error('\p{:=hung}');
    Error('\P{:=hung}');
    Expect(1, 68863, '\p{hung}', "");
    Expect(0, 68863, '\p{^hung}', "");
    Expect(0, 68863, '\P{hung}', "");
    Expect(1, 68863, '\P{^hung}', "");
    Expect(0, 68864, '\p{hung}', "");
    Expect(1, 68864, '\p{^hung}', "");
    Expect(1, 68864, '\P{hung}', "");
    Expect(0, 68864, '\P{^hung}', "");
    Expect(1, 68863, '\p{	_hung}', "");
    Expect(0, 68863, '\p{^	_hung}', "");
    Expect(0, 68863, '\P{	_hung}', "");
    Expect(1, 68863, '\P{^	_hung}', "");
    Expect(0, 68864, '\p{	_hung}', "");
    Expect(1, 68864, '\p{^	_hung}', "");
    Expect(1, 68864, '\P{	_hung}', "");
    Expect(0, 68864, '\P{^	_hung}', "");
    Error('\p{-_is_HUNG:=}');
    Error('\P{-_is_HUNG:=}');
    Expect(1, 68863, '\p{ishung}', "");
    Expect(0, 68863, '\p{^ishung}', "");
    Expect(0, 68863, '\P{ishung}', "");
    Expect(1, 68863, '\P{^ishung}', "");
    Expect(0, 68864, '\p{ishung}', "");
    Expect(1, 68864, '\p{^ishung}', "");
    Expect(1, 68864, '\P{ishung}', "");
    Expect(0, 68864, '\P{^ishung}', "");
    Expect(1, 68863, '\p{_IS_hung}', "");
    Expect(0, 68863, '\p{^_IS_hung}', "");
    Expect(0, 68863, '\P{_IS_hung}', "");
    Expect(1, 68863, '\P{^_IS_hung}', "");
    Expect(0, 68864, '\p{_IS_hung}', "");
    Expect(1, 68864, '\p{^_IS_hung}', "");
    Expect(1, 68864, '\P{_IS_hung}', "");
    Expect(0, 68864, '\P{^_IS_hung}', "");
    Error('\p{_/a/OLD_ITALIC}');
    Error('\P{_/a/OLD_ITALIC}');
    Expect(1, 66351, '\p{olditalic}', "");
    Expect(0, 66351, '\p{^olditalic}', "");
    Expect(0, 66351, '\P{olditalic}', "");
    Expect(1, 66351, '\P{^olditalic}', "");
    Expect(0, 66352, '\p{olditalic}', "");
    Expect(1, 66352, '\p{^olditalic}', "");
    Expect(1, 66352, '\P{olditalic}', "");
    Expect(0, 66352, '\P{^olditalic}', "");
    Expect(1, 66351, '\p{		OLD_italic}', "");
    Expect(0, 66351, '\p{^		OLD_italic}', "");
    Expect(0, 66351, '\P{		OLD_italic}', "");
    Expect(1, 66351, '\P{^		OLD_italic}', "");
    Expect(0, 66352, '\p{		OLD_italic}', "");
    Expect(1, 66352, '\p{^		OLD_italic}', "");
    Expect(1, 66352, '\P{		OLD_italic}', "");
    Expect(0, 66352, '\P{^		OLD_italic}', "");
    Error('\p{/a/_Is_Old_Italic}');
    Error('\P{/a/_Is_Old_Italic}');
    Expect(1, 66351, '\p{isolditalic}', "");
    Expect(0, 66351, '\p{^isolditalic}', "");
    Expect(0, 66351, '\P{isolditalic}', "");
    Expect(1, 66351, '\P{^isolditalic}', "");
    Expect(0, 66352, '\p{isolditalic}', "");
    Expect(1, 66352, '\p{^isolditalic}', "");
    Expect(1, 66352, '\P{isolditalic}', "");
    Expect(0, 66352, '\P{^isolditalic}', "");
    Expect(1, 66351, '\p{	Is_old_ITALIC}', "");
    Expect(0, 66351, '\p{^	Is_old_ITALIC}', "");
    Expect(0, 66351, '\P{	Is_old_ITALIC}', "");
    Expect(1, 66351, '\P{^	Is_old_ITALIC}', "");
    Expect(0, 66352, '\p{	Is_old_ITALIC}', "");
    Expect(1, 66352, '\p{^	Is_old_ITALIC}', "");
    Expect(1, 66352, '\P{	Is_old_ITALIC}', "");
    Expect(0, 66352, '\P{^	Is_old_ITALIC}', "");
    Error('\p{-ITAL/a/}');
    Error('\P{-ITAL/a/}');
    Expect(1, 66351, '\p{ital}', "");
    Expect(0, 66351, '\p{^ital}', "");
    Expect(0, 66351, '\P{ital}', "");
    Expect(1, 66351, '\P{^ital}', "");
    Expect(0, 66352, '\p{ital}', "");
    Expect(1, 66352, '\p{^ital}', "");
    Expect(1, 66352, '\P{ital}', "");
    Expect(0, 66352, '\P{^ital}', "");
    Expect(1, 66351, '\p{_-ITAL}', "");
    Expect(0, 66351, '\p{^_-ITAL}', "");
    Expect(0, 66351, '\P{_-ITAL}', "");
    Expect(1, 66351, '\P{^_-ITAL}', "");
    Expect(0, 66352, '\p{_-ITAL}', "");
    Expect(1, 66352, '\p{^_-ITAL}', "");
    Expect(1, 66352, '\P{_-ITAL}', "");
    Expect(0, 66352, '\P{^_-ITAL}', "");
    Error('\p{-	IS_Ital:=}');
    Error('\P{-	IS_Ital:=}');
    Expect(1, 66351, '\p{isital}', "");
    Expect(0, 66351, '\p{^isital}', "");
    Expect(0, 66351, '\P{isital}', "");
    Expect(1, 66351, '\P{^isital}', "");
    Expect(0, 66352, '\p{isital}', "");
    Expect(1, 66352, '\p{^isital}', "");
    Expect(1, 66352, '\P{isital}', "");
    Expect(0, 66352, '\P{^isital}', "");
    Expect(1, 66351, '\p{-	Is_Ital}', "");
    Expect(0, 66351, '\p{^-	Is_Ital}', "");
    Expect(0, 66351, '\P{-	Is_Ital}', "");
    Expect(1, 66351, '\P{^-	Is_Ital}', "");
    Expect(0, 66352, '\p{-	Is_Ital}', "");
    Expect(1, 66352, '\p{^-	Is_Ital}', "");
    Expect(1, 66352, '\P{-	Is_Ital}', "");
    Expect(0, 66352, '\P{^-	Is_Ital}', "");
    Error('\p{__Old_north_arabian:=}');
    Error('\P{__Old_north_arabian:=}');
    Expect(1, 68255, '\p{oldnortharabian}', "");
    Expect(0, 68255, '\p{^oldnortharabian}', "");
    Expect(0, 68255, '\P{oldnortharabian}', "");
    Expect(1, 68255, '\P{^oldnortharabian}', "");
    Expect(0, 68256, '\p{oldnortharabian}', "");
    Expect(1, 68256, '\p{^oldnortharabian}', "");
    Expect(1, 68256, '\P{oldnortharabian}', "");
    Expect(0, 68256, '\P{^oldnortharabian}', "");
    Expect(1, 68255, '\p{--OLD_north_Arabian}', "");
    Expect(0, 68255, '\p{^--OLD_north_Arabian}', "");
    Expect(0, 68255, '\P{--OLD_north_Arabian}', "");
    Expect(1, 68255, '\P{^--OLD_north_Arabian}', "");
    Expect(0, 68256, '\p{--OLD_north_Arabian}', "");
    Expect(1, 68256, '\p{^--OLD_north_Arabian}', "");
    Expect(1, 68256, '\P{--OLD_north_Arabian}', "");
    Expect(0, 68256, '\P{^--OLD_north_Arabian}', "");
    Error('\p{_/a/Is_old_North_Arabian}');
    Error('\P{_/a/Is_old_North_Arabian}');
    Expect(1, 68255, '\p{isoldnortharabian}', "");
    Expect(0, 68255, '\p{^isoldnortharabian}', "");
    Expect(0, 68255, '\P{isoldnortharabian}', "");
    Expect(1, 68255, '\P{^isoldnortharabian}', "");
    Expect(0, 68256, '\p{isoldnortharabian}', "");
    Expect(1, 68256, '\p{^isoldnortharabian}', "");
    Expect(1, 68256, '\P{isoldnortharabian}', "");
    Expect(0, 68256, '\P{^isoldnortharabian}', "");
    Expect(1, 68255, '\p{IS_old_North_Arabian}', "");
    Expect(0, 68255, '\p{^IS_old_North_Arabian}', "");
    Expect(0, 68255, '\P{IS_old_North_Arabian}', "");
    Expect(1, 68255, '\P{^IS_old_North_Arabian}', "");
    Expect(0, 68256, '\p{IS_old_North_Arabian}', "");
    Expect(1, 68256, '\p{^IS_old_North_Arabian}', "");
    Expect(1, 68256, '\P{IS_old_North_Arabian}', "");
    Expect(0, 68256, '\P{^IS_old_North_Arabian}', "");
    Error('\p{-/a/Narb}');
    Error('\P{-/a/Narb}');
    Expect(1, 68255, '\p{narb}', "");
    Expect(0, 68255, '\p{^narb}', "");
    Expect(0, 68255, '\P{narb}', "");
    Expect(1, 68255, '\P{^narb}', "");
    Expect(0, 68256, '\p{narb}', "");
    Expect(1, 68256, '\p{^narb}', "");
    Expect(1, 68256, '\P{narb}', "");
    Expect(0, 68256, '\P{^narb}', "");
    Expect(1, 68255, '\p{_-Narb}', "");
    Expect(0, 68255, '\p{^_-Narb}', "");
    Expect(0, 68255, '\P{_-Narb}', "");
    Expect(1, 68255, '\P{^_-Narb}', "");
    Expect(0, 68256, '\p{_-Narb}', "");
    Expect(1, 68256, '\p{^_-Narb}', "");
    Expect(1, 68256, '\P{_-Narb}', "");
    Expect(0, 68256, '\P{^_-Narb}', "");
    Error('\p{_/a/is_Narb}');
    Error('\P{_/a/is_Narb}');
    Expect(1, 68255, '\p{isnarb}', "");
    Expect(0, 68255, '\p{^isnarb}', "");
    Expect(0, 68255, '\P{isnarb}', "");
    Expect(1, 68255, '\P{^isnarb}', "");
    Expect(0, 68256, '\p{isnarb}', "");
    Expect(1, 68256, '\p{^isnarb}', "");
    Expect(1, 68256, '\P{isnarb}', "");
    Expect(0, 68256, '\P{^isnarb}', "");
    Expect(1, 68255, '\p{	IS_NARB}', "");
    Expect(0, 68255, '\p{^	IS_NARB}', "");
    Expect(0, 68255, '\P{	IS_NARB}', "");
    Expect(1, 68255, '\P{^	IS_NARB}', "");
    Expect(0, 68256, '\p{	IS_NARB}', "");
    Expect(1, 68256, '\p{^	IS_NARB}', "");
    Expect(1, 68256, '\P{	IS_NARB}', "");
    Expect(0, 68256, '\P{^	IS_NARB}', "");
    Error('\p{-Old_PERMIC/a/}');
    Error('\P{-Old_PERMIC/a/}');
    Expect(1, 66426, '\p{oldpermic}', "");
    Expect(0, 66426, '\p{^oldpermic}', "");
    Expect(0, 66426, '\P{oldpermic}', "");
    Expect(1, 66426, '\P{^oldpermic}', "");
    Expect(0, 66427, '\p{oldpermic}', "");
    Expect(1, 66427, '\p{^oldpermic}', "");
    Expect(1, 66427, '\P{oldpermic}', "");
    Expect(0, 66427, '\P{^oldpermic}', "");
    Expect(1, 66426, '\p{		Old_permic}', "");
    Expect(0, 66426, '\p{^		Old_permic}', "");
    Expect(0, 66426, '\P{		Old_permic}', "");
    Expect(1, 66426, '\P{^		Old_permic}', "");
    Expect(0, 66427, '\p{		Old_permic}', "");
    Expect(1, 66427, '\p{^		Old_permic}', "");
    Expect(1, 66427, '\P{		Old_permic}', "");
    Expect(0, 66427, '\P{^		Old_permic}', "");
    Error('\p{/a/is_Old_PERMIC}');
    Error('\P{/a/is_Old_PERMIC}');
    Expect(1, 66426, '\p{isoldpermic}', "");
    Expect(0, 66426, '\p{^isoldpermic}', "");
    Expect(0, 66426, '\P{isoldpermic}', "");
    Expect(1, 66426, '\P{^isoldpermic}', "");
    Expect(0, 66427, '\p{isoldpermic}', "");
    Expect(1, 66427, '\p{^isoldpermic}', "");
    Expect(1, 66427, '\P{isoldpermic}', "");
    Expect(0, 66427, '\P{^isoldpermic}', "");
    Expect(1, 66426, '\p{-is_Old_Permic}', "");
    Expect(0, 66426, '\p{^-is_Old_Permic}', "");
    Expect(0, 66426, '\P{-is_Old_Permic}', "");
    Expect(1, 66426, '\P{^-is_Old_Permic}', "");
    Expect(0, 66427, '\p{-is_Old_Permic}', "");
    Expect(1, 66427, '\p{^-is_Old_Permic}', "");
    Expect(1, 66427, '\P{-is_Old_Permic}', "");
    Expect(0, 66427, '\P{^-is_Old_Permic}', "");
    Error('\p{-/a/Perm}');
    Error('\P{-/a/Perm}');
    Expect(1, 66426, '\p{perm}', "");
    Expect(0, 66426, '\p{^perm}', "");
    Expect(0, 66426, '\P{perm}', "");
    Expect(1, 66426, '\P{^perm}', "");
    Expect(0, 66427, '\p{perm}', "");
    Expect(1, 66427, '\p{^perm}', "");
    Expect(1, 66427, '\P{perm}', "");
    Expect(0, 66427, '\P{^perm}', "");
    Expect(1, 66426, '\p{	_perm}', "");
    Expect(0, 66426, '\p{^	_perm}', "");
    Expect(0, 66426, '\P{	_perm}', "");
    Expect(1, 66426, '\P{^	_perm}', "");
    Expect(0, 66427, '\p{	_perm}', "");
    Expect(1, 66427, '\p{^	_perm}', "");
    Expect(1, 66427, '\P{	_perm}', "");
    Expect(0, 66427, '\P{^	_perm}', "");
    Error('\p{:=		IS_PERM}');
    Error('\P{:=		IS_PERM}');
    Expect(1, 66426, '\p{isperm}', "");
    Expect(0, 66426, '\p{^isperm}', "");
    Expect(0, 66426, '\P{isperm}', "");
    Expect(1, 66426, '\P{^isperm}', "");
    Expect(0, 66427, '\p{isperm}', "");
    Expect(1, 66427, '\p{^isperm}', "");
    Expect(1, 66427, '\P{isperm}', "");
    Expect(0, 66427, '\P{^isperm}', "");
    Expect(1, 66426, '\p{-	IS_Perm}', "");
    Expect(0, 66426, '\p{^-	IS_Perm}', "");
    Expect(0, 66426, '\P{-	IS_Perm}', "");
    Expect(1, 66426, '\P{^-	IS_Perm}', "");
    Expect(0, 66427, '\p{-	IS_Perm}', "");
    Expect(1, 66427, '\p{^-	IS_Perm}', "");
    Expect(1, 66427, '\P{-	IS_Perm}', "");
    Expect(0, 66427, '\P{^-	IS_Perm}', "");
    Error('\p{:=--OLD_Persian}');
    Error('\P{:=--OLD_Persian}');
    Expect(1, 66517, '\p{oldpersian}', "");
    Expect(0, 66517, '\p{^oldpersian}', "");
    Expect(0, 66517, '\P{oldpersian}', "");
    Expect(1, 66517, '\P{^oldpersian}', "");
    Expect(0, 66518, '\p{oldpersian}', "");
    Expect(1, 66518, '\p{^oldpersian}', "");
    Expect(1, 66518, '\P{oldpersian}', "");
    Expect(0, 66518, '\P{^oldpersian}', "");
    Expect(1, 66517, '\p{  Old_persian}', "");
    Expect(0, 66517, '\p{^  Old_persian}', "");
    Expect(0, 66517, '\P{  Old_persian}', "");
    Expect(1, 66517, '\P{^  Old_persian}', "");
    Expect(0, 66518, '\p{  Old_persian}', "");
    Expect(1, 66518, '\p{^  Old_persian}', "");
    Expect(1, 66518, '\P{  Old_persian}', "");
    Expect(0, 66518, '\P{^  Old_persian}', "");
    Error('\p{Is_OLD_Persian:=}');
    Error('\P{Is_OLD_Persian:=}');
    Expect(1, 66517, '\p{isoldpersian}', "");
    Expect(0, 66517, '\p{^isoldpersian}', "");
    Expect(0, 66517, '\P{isoldpersian}', "");
    Expect(1, 66517, '\P{^isoldpersian}', "");
    Expect(0, 66518, '\p{isoldpersian}', "");
    Expect(1, 66518, '\p{^isoldpersian}', "");
    Expect(1, 66518, '\P{isoldpersian}', "");
    Expect(0, 66518, '\P{^isoldpersian}', "");
    Expect(1, 66517, '\p{Is_old_Persian}', "");
    Expect(0, 66517, '\p{^Is_old_Persian}', "");
    Expect(0, 66517, '\P{Is_old_Persian}', "");
    Expect(1, 66517, '\P{^Is_old_Persian}', "");
    Expect(0, 66518, '\p{Is_old_Persian}', "");
    Expect(1, 66518, '\p{^Is_old_Persian}', "");
    Expect(1, 66518, '\P{Is_old_Persian}', "");
    Expect(0, 66518, '\P{^Is_old_Persian}', "");
    Error('\p{/a/--Xpeo}');
    Error('\P{/a/--Xpeo}');
    Expect(1, 66517, '\p{xpeo}', "");
    Expect(0, 66517, '\p{^xpeo}', "");
    Expect(0, 66517, '\P{xpeo}', "");
    Expect(1, 66517, '\P{^xpeo}', "");
    Expect(0, 66518, '\p{xpeo}', "");
    Expect(1, 66518, '\p{^xpeo}', "");
    Expect(1, 66518, '\P{xpeo}', "");
    Expect(0, 66518, '\P{^xpeo}', "");
    Expect(1, 66517, '\p{	 XPEO}', "");
    Expect(0, 66517, '\p{^	 XPEO}', "");
    Expect(0, 66517, '\P{	 XPEO}', "");
    Expect(1, 66517, '\P{^	 XPEO}', "");
    Expect(0, 66518, '\p{	 XPEO}', "");
    Expect(1, 66518, '\p{^	 XPEO}', "");
    Expect(1, 66518, '\P{	 XPEO}', "");
    Expect(0, 66518, '\P{^	 XPEO}', "");
    Error('\p{  Is_Xpeo/a/}');
    Error('\P{  Is_Xpeo/a/}');
    Expect(1, 66517, '\p{isxpeo}', "");
    Expect(0, 66517, '\p{^isxpeo}', "");
    Expect(0, 66517, '\P{isxpeo}', "");
    Expect(1, 66517, '\P{^isxpeo}', "");
    Expect(0, 66518, '\p{isxpeo}', "");
    Expect(1, 66518, '\p{^isxpeo}', "");
    Expect(1, 66518, '\P{isxpeo}', "");
    Expect(0, 66518, '\P{^isxpeo}', "");
    Expect(1, 66517, '\p{_is_Xpeo}', "");
    Expect(0, 66517, '\p{^_is_Xpeo}', "");
    Expect(0, 66517, '\P{_is_Xpeo}', "");
    Expect(1, 66517, '\P{^_is_Xpeo}', "");
    Expect(0, 66518, '\p{_is_Xpeo}', "");
    Expect(1, 66518, '\p{^_is_Xpeo}', "");
    Expect(1, 66518, '\P{_is_Xpeo}', "");
    Expect(0, 66518, '\P{^_is_Xpeo}', "");
    Error('\p{ :=OLD_South_arabian}');
    Error('\P{ :=OLD_South_arabian}');
    Expect(1, 68223, '\p{oldsoutharabian}', "");
    Expect(0, 68223, '\p{^oldsoutharabian}', "");
    Expect(0, 68223, '\P{oldsoutharabian}', "");
    Expect(1, 68223, '\P{^oldsoutharabian}', "");
    Expect(0, 68224, '\p{oldsoutharabian}', "");
    Expect(1, 68224, '\p{^oldsoutharabian}', "");
    Expect(1, 68224, '\P{oldsoutharabian}', "");
    Expect(0, 68224, '\P{^oldsoutharabian}', "");
    Expect(1, 68223, '\p{_	OLD_south_Arabian}', "");
    Expect(0, 68223, '\p{^_	OLD_south_Arabian}', "");
    Expect(0, 68223, '\P{_	OLD_south_Arabian}', "");
    Expect(1, 68223, '\P{^_	OLD_south_Arabian}', "");
    Expect(0, 68224, '\p{_	OLD_south_Arabian}', "");
    Expect(1, 68224, '\p{^_	OLD_south_Arabian}', "");
    Expect(1, 68224, '\P{_	OLD_south_Arabian}', "");
    Expect(0, 68224, '\P{^_	OLD_south_Arabian}', "");
    Error('\p{	is_Old_SOUTH_Arabian:=}');
    Error('\P{	is_Old_SOUTH_Arabian:=}');
    Expect(1, 68223, '\p{isoldsoutharabian}', "");
    Expect(0, 68223, '\p{^isoldsoutharabian}', "");
    Expect(0, 68223, '\P{isoldsoutharabian}', "");
    Expect(1, 68223, '\P{^isoldsoutharabian}', "");
    Expect(0, 68224, '\p{isoldsoutharabian}', "");
    Expect(1, 68224, '\p{^isoldsoutharabian}', "");
    Expect(1, 68224, '\P{isoldsoutharabian}', "");
    Expect(0, 68224, '\P{^isoldsoutharabian}', "");
    Expect(1, 68223, '\p{_-IS_OLD_South_Arabian}', "");
    Expect(0, 68223, '\p{^_-IS_OLD_South_Arabian}', "");
    Expect(0, 68223, '\P{_-IS_OLD_South_Arabian}', "");
    Expect(1, 68223, '\P{^_-IS_OLD_South_Arabian}', "");
    Expect(0, 68224, '\p{_-IS_OLD_South_Arabian}', "");
    Expect(1, 68224, '\p{^_-IS_OLD_South_Arabian}', "");
    Expect(1, 68224, '\P{_-IS_OLD_South_Arabian}', "");
    Expect(0, 68224, '\P{^_-IS_OLD_South_Arabian}', "");
    Error('\p{		sarb:=}');
    Error('\P{		sarb:=}');
    Expect(1, 68223, '\p{sarb}', "");
    Expect(0, 68223, '\p{^sarb}', "");
    Expect(0, 68223, '\P{sarb}', "");
    Expect(1, 68223, '\P{^sarb}', "");
    Expect(0, 68224, '\p{sarb}', "");
    Expect(1, 68224, '\p{^sarb}', "");
    Expect(1, 68224, '\P{sarb}', "");
    Expect(0, 68224, '\P{^sarb}', "");
    Expect(1, 68223, '\p{ -Sarb}', "");
    Expect(0, 68223, '\p{^ -Sarb}', "");
    Expect(0, 68223, '\P{ -Sarb}', "");
    Expect(1, 68223, '\P{^ -Sarb}', "");
    Expect(0, 68224, '\p{ -Sarb}', "");
    Expect(1, 68224, '\p{^ -Sarb}', "");
    Expect(1, 68224, '\P{ -Sarb}', "");
    Expect(0, 68224, '\P{^ -Sarb}', "");
    Error('\p{	:=IS_SARB}');
    Error('\P{	:=IS_SARB}');
    Expect(1, 68223, '\p{issarb}', "");
    Expect(0, 68223, '\p{^issarb}', "");
    Expect(0, 68223, '\P{issarb}', "");
    Expect(1, 68223, '\P{^issarb}', "");
    Expect(0, 68224, '\p{issarb}', "");
    Expect(1, 68224, '\p{^issarb}', "");
    Expect(1, 68224, '\P{issarb}', "");
    Expect(0, 68224, '\P{^issarb}', "");
    Expect(1, 68223, '\p{ -IS_sarb}', "");
    Expect(0, 68223, '\p{^ -IS_sarb}', "");
    Expect(0, 68223, '\P{ -IS_sarb}', "");
    Expect(1, 68223, '\P{^ -IS_sarb}', "");
    Expect(0, 68224, '\p{ -IS_sarb}', "");
    Expect(1, 68224, '\p{^ -IS_sarb}', "");
    Expect(1, 68224, '\P{ -IS_sarb}', "");
    Expect(0, 68224, '\P{^ -IS_sarb}', "");
    Error('\p{_	Old_Turkic:=}');
    Error('\P{_	Old_Turkic:=}');
    Expect(1, 68680, '\p{oldturkic}', "");
    Expect(0, 68680, '\p{^oldturkic}', "");
    Expect(0, 68680, '\P{oldturkic}', "");
    Expect(1, 68680, '\P{^oldturkic}', "");
    Expect(0, 68681, '\p{oldturkic}', "");
    Expect(1, 68681, '\p{^oldturkic}', "");
    Expect(1, 68681, '\P{oldturkic}', "");
    Expect(0, 68681, '\P{^oldturkic}', "");
    Expect(1, 68680, '\p{  OLD_Turkic}', "");
    Expect(0, 68680, '\p{^  OLD_Turkic}', "");
    Expect(0, 68680, '\P{  OLD_Turkic}', "");
    Expect(1, 68680, '\P{^  OLD_Turkic}', "");
    Expect(0, 68681, '\p{  OLD_Turkic}', "");
    Expect(1, 68681, '\p{^  OLD_Turkic}', "");
    Expect(1, 68681, '\P{  OLD_Turkic}', "");
    Expect(0, 68681, '\P{^  OLD_Turkic}', "");
    Error('\p{ :=Is_Old_turkic}');
    Error('\P{ :=Is_Old_turkic}');
    Expect(1, 68680, '\p{isoldturkic}', "");
    Expect(0, 68680, '\p{^isoldturkic}', "");
    Expect(0, 68680, '\P{isoldturkic}', "");
    Expect(1, 68680, '\P{^isoldturkic}', "");
    Expect(0, 68681, '\p{isoldturkic}', "");
    Expect(1, 68681, '\p{^isoldturkic}', "");
    Expect(1, 68681, '\P{isoldturkic}', "");
    Expect(0, 68681, '\P{^isoldturkic}', "");
    Expect(1, 68680, '\p{- is_Old_Turkic}', "");
    Expect(0, 68680, '\p{^- is_Old_Turkic}', "");
    Expect(0, 68680, '\P{- is_Old_Turkic}', "");
    Expect(1, 68680, '\P{^- is_Old_Turkic}', "");
    Expect(0, 68681, '\p{- is_Old_Turkic}', "");
    Expect(1, 68681, '\p{^- is_Old_Turkic}', "");
    Expect(1, 68681, '\P{- is_Old_Turkic}', "");
    Expect(0, 68681, '\P{^- is_Old_Turkic}', "");
    Error('\p{:=Orkh}');
    Error('\P{:=Orkh}');
    Expect(1, 68680, '\p{orkh}', "");
    Expect(0, 68680, '\p{^orkh}', "");
    Expect(0, 68680, '\P{orkh}', "");
    Expect(1, 68680, '\P{^orkh}', "");
    Expect(0, 68681, '\p{orkh}', "");
    Expect(1, 68681, '\p{^orkh}', "");
    Expect(1, 68681, '\P{orkh}', "");
    Expect(0, 68681, '\P{^orkh}', "");
    Expect(1, 68680, '\p{	_orkh}', "");
    Expect(0, 68680, '\p{^	_orkh}', "");
    Expect(0, 68680, '\P{	_orkh}', "");
    Expect(1, 68680, '\P{^	_orkh}', "");
    Expect(0, 68681, '\p{	_orkh}', "");
    Expect(1, 68681, '\p{^	_orkh}', "");
    Expect(1, 68681, '\P{	_orkh}', "");
    Expect(0, 68681, '\P{^	_orkh}', "");
    Error('\p{-:=IS_orkh}');
    Error('\P{-:=IS_orkh}');
    Expect(1, 68680, '\p{isorkh}', "");
    Expect(0, 68680, '\p{^isorkh}', "");
    Expect(0, 68680, '\P{isorkh}', "");
    Expect(1, 68680, '\P{^isorkh}', "");
    Expect(0, 68681, '\p{isorkh}', "");
    Expect(1, 68681, '\p{^isorkh}', "");
    Expect(1, 68681, '\P{isorkh}', "");
    Expect(0, 68681, '\P{^isorkh}', "");
    Expect(1, 68680, '\p{ -is_ORKH}', "");
    Expect(0, 68680, '\p{^ -is_ORKH}', "");
    Expect(0, 68680, '\P{ -is_ORKH}', "");
    Expect(1, 68680, '\P{^ -is_ORKH}', "");
    Expect(0, 68681, '\p{ -is_ORKH}', "");
    Expect(1, 68681, '\p{^ -is_ORKH}', "");
    Expect(1, 68681, '\P{ -is_ORKH}', "");
    Expect(0, 68681, '\P{^ -is_ORKH}', "");
    Error('\p{/a/	open_Punctuation}');
    Error('\P{/a/	open_Punctuation}');
    Expect(1, 65378, '\p{openpunctuation}', "");
    Expect(0, 65378, '\p{^openpunctuation}', "");
    Expect(0, 65378, '\P{openpunctuation}', "");
    Expect(1, 65378, '\P{^openpunctuation}', "");
    Expect(0, 65379, '\p{openpunctuation}', "");
    Expect(1, 65379, '\p{^openpunctuation}', "");
    Expect(1, 65379, '\P{openpunctuation}', "");
    Expect(0, 65379, '\P{^openpunctuation}', "");
    Expect(1, 65378, '\p{  Open_Punctuation}', "");
    Expect(0, 65378, '\p{^  Open_Punctuation}', "");
    Expect(0, 65378, '\P{  Open_Punctuation}', "");
    Expect(1, 65378, '\P{^  Open_Punctuation}', "");
    Expect(0, 65379, '\p{  Open_Punctuation}', "");
    Expect(1, 65379, '\p{^  Open_Punctuation}', "");
    Expect(1, 65379, '\P{  Open_Punctuation}', "");
    Expect(0, 65379, '\P{^  Open_Punctuation}', "");
    Error('\p{:=	 IS_OPEN_Punctuation}');
    Error('\P{:=	 IS_OPEN_Punctuation}');
    Expect(1, 65378, '\p{isopenpunctuation}', "");
    Expect(0, 65378, '\p{^isopenpunctuation}', "");
    Expect(0, 65378, '\P{isopenpunctuation}', "");
    Expect(1, 65378, '\P{^isopenpunctuation}', "");
    Expect(0, 65379, '\p{isopenpunctuation}', "");
    Expect(1, 65379, '\p{^isopenpunctuation}', "");
    Expect(1, 65379, '\P{isopenpunctuation}', "");
    Expect(0, 65379, '\P{^isopenpunctuation}', "");
    Expect(1, 65378, '\p{-	Is_open_Punctuation}', "");
    Expect(0, 65378, '\p{^-	Is_open_Punctuation}', "");
    Expect(0, 65378, '\P{-	Is_open_Punctuation}', "");
    Expect(1, 65378, '\P{^-	Is_open_Punctuation}', "");
    Expect(0, 65379, '\p{-	Is_open_Punctuation}', "");
    Expect(1, 65379, '\p{^-	Is_open_Punctuation}', "");
    Expect(1, 65379, '\P{-	Is_open_Punctuation}', "");
    Expect(0, 65379, '\P{^-	Is_open_Punctuation}', "");
    Error('\p{_PS/a/}');
    Error('\P{_PS/a/}');
    Expect(1, 65378, '\p{ps}', "");
    Expect(0, 65378, '\p{^ps}', "");
    Expect(0, 65378, '\P{ps}', "");
    Expect(1, 65378, '\P{^ps}', "");
    Expect(0, 65379, '\p{ps}', "");
    Expect(1, 65379, '\p{^ps}', "");
    Expect(1, 65379, '\P{ps}', "");
    Expect(0, 65379, '\P{^ps}', "");
    Expect(1, 65378, '\p{ 	Ps}', "");
    Expect(0, 65378, '\p{^ 	Ps}', "");
    Expect(0, 65378, '\P{ 	Ps}', "");
    Expect(1, 65378, '\P{^ 	Ps}', "");
    Expect(0, 65379, '\p{ 	Ps}', "");
    Expect(1, 65379, '\p{^ 	Ps}', "");
    Expect(1, 65379, '\P{ 	Ps}', "");
    Expect(0, 65379, '\P{^ 	Ps}', "");
    Error('\p{-/a/is_ps}');
    Error('\P{-/a/is_ps}');
    Expect(1, 65378, '\p{isps}', "");
    Expect(0, 65378, '\p{^isps}', "");
    Expect(0, 65378, '\P{isps}', "");
    Expect(1, 65378, '\P{^isps}', "");
    Expect(0, 65379, '\p{isps}', "");
    Expect(1, 65379, '\p{^isps}', "");
    Expect(1, 65379, '\P{isps}', "");
    Expect(0, 65379, '\P{^isps}', "");
    Expect(1, 65378, '\p{	is_ps}', "");
    Expect(0, 65378, '\p{^	is_ps}', "");
    Expect(0, 65378, '\P{	is_ps}', "");
    Expect(1, 65378, '\P{^	is_ps}', "");
    Expect(0, 65379, '\p{	is_ps}', "");
    Expect(1, 65379, '\p{^	is_ps}', "");
    Expect(1, 65379, '\P{	is_ps}', "");
    Expect(0, 65379, '\P{^	is_ps}', "");
    Error('\p{-:=Optical_character_Recognition}');
    Error('\P{-:=Optical_character_Recognition}');
    Expect(1, 9311, '\p{opticalcharacterrecognition}', "");
    Expect(0, 9311, '\p{^opticalcharacterrecognition}', "");
    Expect(0, 9311, '\P{opticalcharacterrecognition}', "");
    Expect(1, 9311, '\P{^opticalcharacterrecognition}', "");
    Expect(0, 9312, '\p{opticalcharacterrecognition}', "");
    Expect(1, 9312, '\p{^opticalcharacterrecognition}', "");
    Expect(1, 9312, '\P{opticalcharacterrecognition}', "");
    Expect(0, 9312, '\P{^opticalcharacterrecognition}', "");
    Expect(1, 9311, '\p{	Optical_CHARACTER_RECOGNITION}', "");
    Expect(0, 9311, '\p{^	Optical_CHARACTER_RECOGNITION}', "");
    Expect(0, 9311, '\P{	Optical_CHARACTER_RECOGNITION}', "");
    Expect(1, 9311, '\P{^	Optical_CHARACTER_RECOGNITION}', "");
    Expect(0, 9312, '\p{	Optical_CHARACTER_RECOGNITION}', "");
    Expect(1, 9312, '\p{^	Optical_CHARACTER_RECOGNITION}', "");
    Expect(1, 9312, '\P{	Optical_CHARACTER_RECOGNITION}', "");
    Expect(0, 9312, '\P{^	Optical_CHARACTER_RECOGNITION}', "");
    Error('\p{-Is_optical_CHARACTER_RECOGNITION:=}');
    Error('\P{-Is_optical_CHARACTER_RECOGNITION:=}');
    Expect(1, 9311, '\p{isopticalcharacterrecognition}', "");
    Expect(0, 9311, '\p{^isopticalcharacterrecognition}', "");
    Expect(0, 9311, '\P{isopticalcharacterrecognition}', "");
    Expect(1, 9311, '\P{^isopticalcharacterrecognition}', "");
    Expect(0, 9312, '\p{isopticalcharacterrecognition}', "");
    Expect(1, 9312, '\p{^isopticalcharacterrecognition}', "");
    Expect(1, 9312, '\P{isopticalcharacterrecognition}', "");
    Expect(0, 9312, '\P{^isopticalcharacterrecognition}', "");
    Expect(1, 9311, '\p{__IS_Optical_Character_recognition}', "");
    Expect(0, 9311, '\p{^__IS_Optical_Character_recognition}', "");
    Expect(0, 9311, '\P{__IS_Optical_Character_recognition}', "");
    Expect(1, 9311, '\P{^__IS_Optical_Character_recognition}', "");
    Expect(0, 9312, '\p{__IS_Optical_Character_recognition}', "");
    Expect(1, 9312, '\p{^__IS_Optical_Character_recognition}', "");
    Expect(1, 9312, '\P{__IS_Optical_Character_recognition}', "");
    Expect(0, 9312, '\P{^__IS_Optical_Character_recognition}', "");
    Error('\p{	:=in_Optical_CHARACTER_Recognition}');
    Error('\P{	:=in_Optical_CHARACTER_Recognition}');
    Expect(1, 9311, '\p{inopticalcharacterrecognition}', "");
    Expect(0, 9311, '\p{^inopticalcharacterrecognition}', "");
    Expect(0, 9311, '\P{inopticalcharacterrecognition}', "");
    Expect(1, 9311, '\P{^inopticalcharacterrecognition}', "");
    Expect(0, 9312, '\p{inopticalcharacterrecognition}', "");
    Expect(1, 9312, '\p{^inopticalcharacterrecognition}', "");
    Expect(1, 9312, '\P{inopticalcharacterrecognition}', "");
    Expect(0, 9312, '\P{^inopticalcharacterrecognition}', "");
    Expect(1, 9311, '\p{	in_OPTICAL_character_RECOGNITION}', "");
    Expect(0, 9311, '\p{^	in_OPTICAL_character_RECOGNITION}', "");
    Expect(0, 9311, '\P{	in_OPTICAL_character_RECOGNITION}', "");
    Expect(1, 9311, '\P{^	in_OPTICAL_character_RECOGNITION}', "");
    Expect(0, 9312, '\p{	in_OPTICAL_character_RECOGNITION}', "");
    Expect(1, 9312, '\p{^	in_OPTICAL_character_RECOGNITION}', "");
    Expect(1, 9312, '\P{	in_OPTICAL_character_RECOGNITION}', "");
    Expect(0, 9312, '\P{^	in_OPTICAL_character_RECOGNITION}', "");
    Error('\p{_	OCR:=}');
    Error('\P{_	OCR:=}');
    Expect(1, 9311, '\p{ocr}', "");
    Expect(0, 9311, '\p{^ocr}', "");
    Expect(0, 9311, '\P{ocr}', "");
    Expect(1, 9311, '\P{^ocr}', "");
    Expect(0, 9312, '\p{ocr}', "");
    Expect(1, 9312, '\p{^ocr}', "");
    Expect(1, 9312, '\P{ocr}', "");
    Expect(0, 9312, '\P{^ocr}', "");
    Expect(1, 9311, '\p{_OCR}', "");
    Expect(0, 9311, '\p{^_OCR}', "");
    Expect(0, 9311, '\P{_OCR}', "");
    Expect(1, 9311, '\P{^_OCR}', "");
    Expect(0, 9312, '\p{_OCR}', "");
    Expect(1, 9312, '\p{^_OCR}', "");
    Expect(1, 9312, '\P{_OCR}', "");
    Expect(0, 9312, '\P{^_OCR}', "");
    Error('\p{/a/_ Is_OCR}');
    Error('\P{/a/_ Is_OCR}');
    Expect(1, 9311, '\p{isocr}', "");
    Expect(0, 9311, '\p{^isocr}', "");
    Expect(0, 9311, '\P{isocr}', "");
    Expect(1, 9311, '\P{^isocr}', "");
    Expect(0, 9312, '\p{isocr}', "");
    Expect(1, 9312, '\p{^isocr}', "");
    Expect(1, 9312, '\P{isocr}', "");
    Expect(0, 9312, '\P{^isocr}', "");
    Expect(1, 9311, '\p{Is_OCR}', "");
    Expect(0, 9311, '\p{^Is_OCR}', "");
    Expect(0, 9311, '\P{Is_OCR}', "");
    Expect(1, 9311, '\P{^Is_OCR}', "");
    Expect(0, 9312, '\p{Is_OCR}', "");
    Expect(1, 9312, '\p{^Is_OCR}', "");
    Expect(1, 9312, '\P{Is_OCR}', "");
    Expect(0, 9312, '\P{^Is_OCR}', "");
    Error('\p{:= In_OCR}');
    Error('\P{:= In_OCR}');
    Expect(1, 9311, '\p{inocr}', "");
    Expect(0, 9311, '\p{^inocr}', "");
    Expect(0, 9311, '\P{inocr}', "");
    Expect(1, 9311, '\P{^inocr}', "");
    Expect(0, 9312, '\p{inocr}', "");
    Expect(1, 9312, '\p{^inocr}', "");
    Expect(1, 9312, '\P{inocr}', "");
    Expect(0, 9312, '\P{^inocr}', "");
    Expect(1, 9311, '\p{	 In_OCR}', "");
    Expect(0, 9311, '\p{^	 In_OCR}', "");
    Expect(0, 9311, '\P{	 In_OCR}', "");
    Expect(1, 9311, '\P{^	 In_OCR}', "");
    Expect(0, 9312, '\p{	 In_OCR}', "");
    Expect(1, 9312, '\p{^	 In_OCR}', "");
    Expect(1, 9312, '\P{	 In_OCR}', "");
    Expect(0, 9312, '\P{^	 In_OCR}', "");
    Error('\p{:=_	Oriya}');
    Error('\P{:=_	Oriya}');
    Expect(1, 2935, '\p{oriya}', "");
    Expect(0, 2935, '\p{^oriya}', "");
    Expect(0, 2935, '\P{oriya}', "");
    Expect(1, 2935, '\P{^oriya}', "");
    Expect(0, 2936, '\p{oriya}', "");
    Expect(1, 2936, '\p{^oriya}', "");
    Expect(1, 2936, '\P{oriya}', "");
    Expect(0, 2936, '\P{^oriya}', "");
    Expect(1, 2935, '\p{	ORIYA}', "");
    Expect(0, 2935, '\p{^	ORIYA}', "");
    Expect(0, 2935, '\P{	ORIYA}', "");
    Expect(1, 2935, '\P{^	ORIYA}', "");
    Expect(0, 2936, '\p{	ORIYA}', "");
    Expect(1, 2936, '\p{^	ORIYA}', "");
    Expect(1, 2936, '\P{	ORIYA}', "");
    Expect(0, 2936, '\P{^	ORIYA}', "");
    Error('\p{/a/is_oriya}');
    Error('\P{/a/is_oriya}');
    Expect(1, 2935, '\p{isoriya}', "");
    Expect(0, 2935, '\p{^isoriya}', "");
    Expect(0, 2935, '\P{isoriya}', "");
    Expect(1, 2935, '\P{^isoriya}', "");
    Expect(0, 2936, '\p{isoriya}', "");
    Expect(1, 2936, '\p{^isoriya}', "");
    Expect(1, 2936, '\P{isoriya}', "");
    Expect(0, 2936, '\P{^isoriya}', "");
    Expect(1, 2935, '\p{_Is_Oriya}', "");
    Expect(0, 2935, '\p{^_Is_Oriya}', "");
    Expect(0, 2935, '\P{_Is_Oriya}', "");
    Expect(1, 2935, '\P{^_Is_Oriya}', "");
    Expect(0, 2936, '\p{_Is_Oriya}', "");
    Expect(1, 2936, '\p{^_Is_Oriya}', "");
    Expect(1, 2936, '\P{_Is_Oriya}', "");
    Expect(0, 2936, '\P{^_Is_Oriya}', "");
    Error('\p{_/a/Orya}');
    Error('\P{_/a/Orya}');
    Expect(1, 2935, '\p{orya}', "");
    Expect(0, 2935, '\p{^orya}', "");
    Expect(0, 2935, '\P{orya}', "");
    Expect(1, 2935, '\P{^orya}', "");
    Expect(0, 2936, '\p{orya}', "");
    Expect(1, 2936, '\p{^orya}', "");
    Expect(1, 2936, '\P{orya}', "");
    Expect(0, 2936, '\P{^orya}', "");
    Expect(1, 2935, '\p{- ORYA}', "");
    Expect(0, 2935, '\p{^- ORYA}', "");
    Expect(0, 2935, '\P{- ORYA}', "");
    Expect(1, 2935, '\P{^- ORYA}', "");
    Expect(0, 2936, '\p{- ORYA}', "");
    Expect(1, 2936, '\p{^- ORYA}', "");
    Expect(1, 2936, '\P{- ORYA}', "");
    Expect(0, 2936, '\P{^- ORYA}', "");
    Error('\p{/a/_-IS_orya}');
    Error('\P{/a/_-IS_orya}');
    Expect(1, 2935, '\p{isorya}', "");
    Expect(0, 2935, '\p{^isorya}', "");
    Expect(0, 2935, '\P{isorya}', "");
    Expect(1, 2935, '\P{^isorya}', "");
    Expect(0, 2936, '\p{isorya}', "");
    Expect(1, 2936, '\p{^isorya}', "");
    Expect(1, 2936, '\P{isorya}', "");
    Expect(0, 2936, '\P{^isorya}', "");
    Expect(1, 2935, '\p{_IS_Orya}', "");
    Expect(0, 2935, '\p{^_IS_Orya}', "");
    Expect(0, 2935, '\P{_IS_Orya}', "");
    Expect(1, 2935, '\P{^_IS_Orya}', "");
    Expect(0, 2936, '\p{_IS_Orya}', "");
    Expect(1, 2936, '\p{^_IS_Orya}', "");
    Expect(1, 2936, '\P{_IS_Orya}', "");
    Expect(0, 2936, '\P{^_IS_Orya}', "");
    Error('\p{/a/-_Ornamental_DINGBATS}');
    Error('\P{/a/-_Ornamental_DINGBATS}');
    Expect(1, 128639, '\p{ornamentaldingbats}', "");
    Expect(0, 128639, '\p{^ornamentaldingbats}', "");
    Expect(0, 128639, '\P{ornamentaldingbats}', "");
    Expect(1, 128639, '\P{^ornamentaldingbats}', "");
    Expect(0, 128640, '\p{ornamentaldingbats}', "");
    Expect(1, 128640, '\p{^ornamentaldingbats}', "");
    Expect(1, 128640, '\P{ornamentaldingbats}', "");
    Expect(0, 128640, '\P{^ornamentaldingbats}', "");
    Expect(1, 128639, '\p{_ORNAMENTAL_dingbats}', "");
    Expect(0, 128639, '\p{^_ORNAMENTAL_dingbats}', "");
    Expect(0, 128639, '\P{_ORNAMENTAL_dingbats}', "");
    Expect(1, 128639, '\P{^_ORNAMENTAL_dingbats}', "");
    Expect(0, 128640, '\p{_ORNAMENTAL_dingbats}', "");
    Expect(1, 128640, '\p{^_ORNAMENTAL_dingbats}', "");
    Expect(1, 128640, '\P{_ORNAMENTAL_dingbats}', "");
    Expect(0, 128640, '\P{^_ORNAMENTAL_dingbats}', "");
    Error('\p{	/a/Is_Ornamental_DINGBATS}');
    Error('\P{	/a/Is_Ornamental_DINGBATS}');
    Expect(1, 128639, '\p{isornamentaldingbats}', "");
    Expect(0, 128639, '\p{^isornamentaldingbats}', "");
    Expect(0, 128639, '\P{isornamentaldingbats}', "");
    Expect(1, 128639, '\P{^isornamentaldingbats}', "");
    Expect(0, 128640, '\p{isornamentaldingbats}', "");
    Expect(1, 128640, '\p{^isornamentaldingbats}', "");
    Expect(1, 128640, '\P{isornamentaldingbats}', "");
    Expect(0, 128640, '\P{^isornamentaldingbats}', "");
    Expect(1, 128639, '\p{_	Is_Ornamental_dingbats}', "");
    Expect(0, 128639, '\p{^_	Is_Ornamental_dingbats}', "");
    Expect(0, 128639, '\P{_	Is_Ornamental_dingbats}', "");
    Expect(1, 128639, '\P{^_	Is_Ornamental_dingbats}', "");
    Expect(0, 128640, '\p{_	Is_Ornamental_dingbats}', "");
    Expect(1, 128640, '\p{^_	Is_Ornamental_dingbats}', "");
    Expect(1, 128640, '\P{_	Is_Ornamental_dingbats}', "");
    Expect(0, 128640, '\P{^_	Is_Ornamental_dingbats}', "");
    Error('\p{/a/-	In_Ornamental_Dingbats}');
    Error('\P{/a/-	In_Ornamental_Dingbats}');
    Expect(1, 128639, '\p{inornamentaldingbats}', "");
    Expect(0, 128639, '\p{^inornamentaldingbats}', "");
    Expect(0, 128639, '\P{inornamentaldingbats}', "");
    Expect(1, 128639, '\P{^inornamentaldingbats}', "");
    Expect(0, 128640, '\p{inornamentaldingbats}', "");
    Expect(1, 128640, '\p{^inornamentaldingbats}', "");
    Expect(1, 128640, '\P{inornamentaldingbats}', "");
    Expect(0, 128640, '\P{^inornamentaldingbats}', "");
    Expect(1, 128639, '\p{__IN_Ornamental_dingbats}', "");
    Expect(0, 128639, '\p{^__IN_Ornamental_dingbats}', "");
    Expect(0, 128639, '\P{__IN_Ornamental_dingbats}', "");
    Expect(1, 128639, '\P{^__IN_Ornamental_dingbats}', "");
    Expect(0, 128640, '\p{__IN_Ornamental_dingbats}', "");
    Expect(1, 128640, '\p{^__IN_Ornamental_dingbats}', "");
    Expect(1, 128640, '\P{__IN_Ornamental_dingbats}', "");
    Expect(0, 128640, '\P{^__IN_Ornamental_dingbats}', "");
    Error('\p{	OSAGE:=}');
    Error('\P{	OSAGE:=}');
    Expect(1, 66811, '\p{osage}', "");
    Expect(0, 66811, '\p{^osage}', "");
    Expect(0, 66811, '\P{osage}', "");
    Expect(1, 66811, '\P{^osage}', "");
    Expect(0, 66812, '\p{osage}', "");
    Expect(1, 66812, '\p{^osage}', "");
    Expect(1, 66812, '\P{osage}', "");
    Expect(0, 66812, '\P{^osage}', "");
    Expect(1, 66811, '\p{_	Osage}', "");
    Expect(0, 66811, '\p{^_	Osage}', "");
    Expect(0, 66811, '\P{_	Osage}', "");
    Expect(1, 66811, '\P{^_	Osage}', "");
    Expect(0, 66812, '\p{_	Osage}', "");
    Expect(1, 66812, '\p{^_	Osage}', "");
    Expect(1, 66812, '\P{_	Osage}', "");
    Expect(0, 66812, '\P{^_	Osage}', "");
    Error('\p{ /a/Is_Osage}');
    Error('\P{ /a/Is_Osage}');
    Expect(1, 66811, '\p{isosage}', "");
    Expect(0, 66811, '\p{^isosage}', "");
    Expect(0, 66811, '\P{isosage}', "");
    Expect(1, 66811, '\P{^isosage}', "");
    Expect(0, 66812, '\p{isosage}', "");
    Expect(1, 66812, '\p{^isosage}', "");
    Expect(1, 66812, '\P{isosage}', "");
    Expect(0, 66812, '\P{^isosage}', "");
    Expect(1, 66811, '\p{  Is_Osage}', "");
    Expect(0, 66811, '\p{^  Is_Osage}', "");
    Expect(0, 66811, '\P{  Is_Osage}', "");
    Expect(1, 66811, '\P{^  Is_Osage}', "");
    Expect(0, 66812, '\p{  Is_Osage}', "");
    Expect(1, 66812, '\p{^  Is_Osage}', "");
    Expect(1, 66812, '\P{  Is_Osage}', "");
    Expect(0, 66812, '\P{^  Is_Osage}', "");
    Error('\p{/a/_Osge}');
    Error('\P{/a/_Osge}');
    Expect(1, 66811, '\p{osge}', "");
    Expect(0, 66811, '\p{^osge}', "");
    Expect(0, 66811, '\P{osge}', "");
    Expect(1, 66811, '\P{^osge}', "");
    Expect(0, 66812, '\p{osge}', "");
    Expect(1, 66812, '\p{^osge}', "");
    Expect(1, 66812, '\P{osge}', "");
    Expect(0, 66812, '\P{^osge}', "");
    Expect(1, 66811, '\p{Osge}', "");
    Expect(0, 66811, '\p{^Osge}', "");
    Expect(0, 66811, '\P{Osge}', "");
    Expect(1, 66811, '\P{^Osge}', "");
    Expect(0, 66812, '\p{Osge}', "");
    Expect(1, 66812, '\p{^Osge}', "");
    Expect(1, 66812, '\P{Osge}', "");
    Expect(0, 66812, '\P{^Osge}', "");
    Error('\p{:=		Is_OSGE}');
    Error('\P{:=		Is_OSGE}');
    Expect(1, 66811, '\p{isosge}', "");
    Expect(0, 66811, '\p{^isosge}', "");
    Expect(0, 66811, '\P{isosge}', "");
    Expect(1, 66811, '\P{^isosge}', "");
    Expect(0, 66812, '\p{isosge}', "");
    Expect(1, 66812, '\p{^isosge}', "");
    Expect(1, 66812, '\P{isosge}', "");
    Expect(0, 66812, '\P{^isosge}', "");
    Expect(1, 66811, '\p{	Is_Osge}', "");
    Expect(0, 66811, '\p{^	Is_Osge}', "");
    Expect(0, 66811, '\P{	Is_Osge}', "");
    Expect(1, 66811, '\P{^	Is_Osge}', "");
    Expect(0, 66812, '\p{	Is_Osge}', "");
    Expect(1, 66812, '\p{^	Is_Osge}', "");
    Expect(1, 66812, '\P{	Is_Osge}', "");
    Expect(0, 66812, '\P{^	Is_Osge}', "");
    Error('\p{--Osmanya/a/}');
    Error('\P{--Osmanya/a/}');
    Expect(1, 66729, '\p{osmanya}', "");
    Expect(0, 66729, '\p{^osmanya}', "");
    Expect(0, 66729, '\P{osmanya}', "");
    Expect(1, 66729, '\P{^osmanya}', "");
    Expect(0, 66730, '\p{osmanya}', "");
    Expect(1, 66730, '\p{^osmanya}', "");
    Expect(1, 66730, '\P{osmanya}', "");
    Expect(0, 66730, '\P{^osmanya}', "");
    Expect(1, 66729, '\p{ 	osmanya}', "");
    Expect(0, 66729, '\p{^ 	osmanya}', "");
    Expect(0, 66729, '\P{ 	osmanya}', "");
    Expect(1, 66729, '\P{^ 	osmanya}', "");
    Expect(0, 66730, '\p{ 	osmanya}', "");
    Expect(1, 66730, '\p{^ 	osmanya}', "");
    Expect(1, 66730, '\P{ 	osmanya}', "");
    Expect(0, 66730, '\P{^ 	osmanya}', "");
    Error('\p{		is_Osmanya/a/}');
    Error('\P{		is_Osmanya/a/}');
    Expect(1, 66729, '\p{isosmanya}', "");
    Expect(0, 66729, '\p{^isosmanya}', "");
    Expect(0, 66729, '\P{isosmanya}', "");
    Expect(1, 66729, '\P{^isosmanya}', "");
    Expect(0, 66730, '\p{isosmanya}', "");
    Expect(1, 66730, '\p{^isosmanya}', "");
    Expect(1, 66730, '\P{isosmanya}', "");
    Expect(0, 66730, '\P{^isosmanya}', "");
    Expect(1, 66729, '\p{ Is_Osmanya}', "");
    Expect(0, 66729, '\p{^ Is_Osmanya}', "");
    Expect(0, 66729, '\P{ Is_Osmanya}', "");
    Expect(1, 66729, '\P{^ Is_Osmanya}', "");
    Expect(0, 66730, '\p{ Is_Osmanya}', "");
    Expect(1, 66730, '\p{^ Is_Osmanya}', "");
    Expect(1, 66730, '\P{ Is_Osmanya}', "");
    Expect(0, 66730, '\P{^ Is_Osmanya}', "");
    Error('\p{_/a/osma}');
    Error('\P{_/a/osma}');
    Expect(1, 66729, '\p{osma}', "");
    Expect(0, 66729, '\p{^osma}', "");
    Expect(0, 66729, '\P{osma}', "");
    Expect(1, 66729, '\P{^osma}', "");
    Expect(0, 66730, '\p{osma}', "");
    Expect(1, 66730, '\p{^osma}', "");
    Expect(1, 66730, '\P{osma}', "");
    Expect(0, 66730, '\P{^osma}', "");
    Expect(1, 66729, '\p{-_osma}', "");
    Expect(0, 66729, '\p{^-_osma}', "");
    Expect(0, 66729, '\P{-_osma}', "");
    Expect(1, 66729, '\P{^-_osma}', "");
    Expect(0, 66730, '\p{-_osma}', "");
    Expect(1, 66730, '\p{^-_osma}', "");
    Expect(1, 66730, '\P{-_osma}', "");
    Expect(0, 66730, '\P{^-_osma}', "");
    Error('\p{:=Is_osma}');
    Error('\P{:=Is_osma}');
    Expect(1, 66729, '\p{isosma}', "");
    Expect(0, 66729, '\p{^isosma}', "");
    Expect(0, 66729, '\P{isosma}', "");
    Expect(1, 66729, '\P{^isosma}', "");
    Expect(0, 66730, '\p{isosma}', "");
    Expect(1, 66730, '\p{^isosma}', "");
    Expect(1, 66730, '\P{isosma}', "");
    Expect(0, 66730, '\P{^isosma}', "");
    Expect(1, 66729, '\p{-is_Osma}', "");
    Expect(0, 66729, '\p{^-is_Osma}', "");
    Expect(0, 66729, '\P{-is_Osma}', "");
    Expect(1, 66729, '\P{^-is_Osma}', "");
    Expect(0, 66730, '\p{-is_Osma}', "");
    Expect(1, 66730, '\p{^-is_Osma}', "");
    Expect(1, 66730, '\P{-is_Osma}', "");
    Expect(0, 66730, '\P{^-is_Osma}', "");
    Error('\p{_/a/Other}');
    Error('\P{_/a/Other}');
    Expect(1, 918000, '\p{other}', "");
    Expect(0, 918000, '\p{^other}', "");
    Expect(0, 918000, '\P{other}', "");
    Expect(1, 918000, '\P{^other}', "");
    Expect(0, 917999, '\p{other}', "");
    Expect(1, 917999, '\p{^other}', "");
    Expect(1, 917999, '\P{other}', "");
    Expect(0, 917999, '\P{^other}', "");
    Expect(1, 918000, '\p{_other}', "");
    Expect(0, 918000, '\p{^_other}', "");
    Expect(0, 918000, '\P{_other}', "");
    Expect(1, 918000, '\P{^_other}', "");
    Expect(0, 917999, '\p{_other}', "");
    Expect(1, 917999, '\p{^_other}', "");
    Expect(1, 917999, '\P{_other}', "");
    Expect(0, 917999, '\P{^_other}', "");
    Error('\p{:=_ Is_other}');
    Error('\P{:=_ Is_other}');
    Expect(1, 918000, '\p{isother}', "");
    Expect(0, 918000, '\p{^isother}', "");
    Expect(0, 918000, '\P{isother}', "");
    Expect(1, 918000, '\P{^isother}', "");
    Expect(0, 917999, '\p{isother}', "");
    Expect(1, 917999, '\p{^isother}', "");
    Expect(1, 917999, '\P{isother}', "");
    Expect(0, 917999, '\P{^isother}', "");
    Expect(1, 918000, '\p{	_IS_OTHER}', "");
    Expect(0, 918000, '\p{^	_IS_OTHER}', "");
    Expect(0, 918000, '\P{	_IS_OTHER}', "");
    Expect(1, 918000, '\P{^	_IS_OTHER}', "");
    Expect(0, 917999, '\p{	_IS_OTHER}', "");
    Expect(1, 917999, '\p{^	_IS_OTHER}', "");
    Expect(1, 917999, '\P{	_IS_OTHER}', "");
    Expect(0, 917999, '\P{^	_IS_OTHER}', "");
    Error('\p{__C/a/}');
    Error('\P{__C/a/}');
    Expect(1, 918000, '\p{c}', "");
    Expect(0, 918000, '\p{^c}', "");
    Expect(0, 918000, '\P{c}', "");
    Expect(1, 918000, '\P{^c}', "");
    Expect(0, 917999, '\p{c}', "");
    Expect(1, 917999, '\p{^c}', "");
    Expect(1, 917999, '\P{c}', "");
    Expect(0, 917999, '\P{^c}', "");
    Expect(1, 918000, '\p{_ C}', "");
    Expect(0, 918000, '\p{^_ C}', "");
    Expect(0, 918000, '\P{_ C}', "");
    Expect(1, 918000, '\P{^_ C}', "");
    Expect(0, 917999, '\p{_ C}', "");
    Expect(1, 917999, '\p{^_ C}', "");
    Expect(1, 917999, '\P{_ C}', "");
    Expect(0, 917999, '\P{^_ C}', "");
    Error('\p{	IS_C/a/}');
    Error('\P{	IS_C/a/}');
    Expect(1, 918000, '\p{isc}', "");
    Expect(0, 918000, '\p{^isc}', "");
    Expect(0, 918000, '\P{isc}', "");
    Expect(1, 918000, '\P{^isc}', "");
    Expect(0, 917999, '\p{isc}', "");
    Expect(1, 917999, '\p{^isc}', "");
    Expect(1, 917999, '\P{isc}', "");
    Expect(0, 917999, '\P{^isc}', "");
    Expect(1, 918000, '\p{- IS_c}', "");
    Expect(0, 918000, '\p{^- IS_c}', "");
    Expect(0, 918000, '\P{- IS_c}', "");
    Expect(1, 918000, '\P{^- IS_c}', "");
    Expect(0, 917999, '\p{- IS_c}', "");
    Expect(1, 917999, '\p{^- IS_c}', "");
    Expect(1, 917999, '\P{- IS_c}', "");
    Expect(0, 917999, '\P{^- IS_c}', "");
    Error('\p{Other_Alphabetic}');
    Error('\P{Other_Alphabetic}');
    Error('\p{Is_Other_Alphabetic}');
    Error('\P{Is_Other_Alphabetic}');
    Error('\p{OAlpha}');
    Error('\P{OAlpha}');
    Error('\p{Is_OAlpha}');
    Error('\P{Is_OAlpha}');
    Error('\p{Other_Default_Ignorable_Code_Point}');
    Error('\P{Other_Default_Ignorable_Code_Point}');
    Error('\p{Is_Other_Default_Ignorable_Code_Point}');
    Error('\P{Is_Other_Default_Ignorable_Code_Point}');
    Error('\p{ODI}');
    Error('\P{ODI}');
    Error('\p{Is_ODI}');
    Error('\P{Is_ODI}');
    Error('\p{Other_Grapheme_Extend}');
    Error('\P{Other_Grapheme_Extend}');
    Error('\p{Is_Other_Grapheme_Extend}');
    Error('\P{Is_Other_Grapheme_Extend}');
    Error('\p{OGr_Ext}');
    Error('\P{OGr_Ext}');
    Error('\p{Is_OGr_Ext}');
    Error('\P{Is_OGr_Ext}');
    Error('\p{Other_ID_Continue}');
    Error('\P{Other_ID_Continue}');
    Error('\p{Is_Other_ID_Continue}');
    Error('\P{Is_Other_ID_Continue}');
    Error('\p{OIDC}');
    Error('\P{OIDC}');
    Error('\p{Is_OIDC}');
    Error('\P{Is_OIDC}');
    Error('\p{Other_ID_Start}');
    Error('\P{Other_ID_Start}');
    Error('\p{Is_Other_ID_Start}');
    Error('\P{Is_Other_ID_Start}');
    Error('\p{OIDS}');
    Error('\P{OIDS}');
    Error('\p{Is_OIDS}');
    Error('\P{Is_OIDS}');
    Error('\p{- OTHER_Letter:=}');
    Error('\P{- OTHER_Letter:=}');
    Expect(1, 195101, '\p{otherletter}', "");
    Expect(0, 195101, '\p{^otherletter}', "");
    Expect(0, 195101, '\P{otherletter}', "");
    Expect(1, 195101, '\P{^otherletter}', "");
    Expect(0, 195102, '\p{otherletter}', "");
    Expect(1, 195102, '\p{^otherletter}', "");
    Expect(1, 195102, '\P{otherletter}', "");
    Expect(0, 195102, '\P{^otherletter}', "");
    Expect(1, 195101, '\p{Other_LETTER}', "");
    Expect(0, 195101, '\p{^Other_LETTER}', "");
    Expect(0, 195101, '\P{Other_LETTER}', "");
    Expect(1, 195101, '\P{^Other_LETTER}', "");
    Expect(0, 195102, '\p{Other_LETTER}', "");
    Expect(1, 195102, '\p{^Other_LETTER}', "");
    Expect(1, 195102, '\P{Other_LETTER}', "");
    Expect(0, 195102, '\P{^Other_LETTER}', "");
    Error('\p{  Is_Other_letter:=}');
    Error('\P{  Is_Other_letter:=}');
    Expect(1, 195101, '\p{isotherletter}', "");
    Expect(0, 195101, '\p{^isotherletter}', "");
    Expect(0, 195101, '\P{isotherletter}', "");
    Expect(1, 195101, '\P{^isotherletter}', "");
    Expect(0, 195102, '\p{isotherletter}', "");
    Expect(1, 195102, '\p{^isotherletter}', "");
    Expect(1, 195102, '\P{isotherletter}', "");
    Expect(0, 195102, '\P{^isotherletter}', "");
    Expect(1, 195101, '\p{_	IS_OTHER_Letter}', "");
    Expect(0, 195101, '\p{^_	IS_OTHER_Letter}', "");
    Expect(0, 195101, '\P{_	IS_OTHER_Letter}', "");
    Expect(1, 195101, '\P{^_	IS_OTHER_Letter}', "");
    Expect(0, 195102, '\p{_	IS_OTHER_Letter}', "");
    Expect(1, 195102, '\p{^_	IS_OTHER_Letter}', "");
    Expect(1, 195102, '\P{_	IS_OTHER_Letter}', "");
    Expect(0, 195102, '\P{^_	IS_OTHER_Letter}', "");
    Error('\p{-_LO:=}');
    Error('\P{-_LO:=}');
    Expect(1, 195101, '\p{lo}', "");
    Expect(0, 195101, '\p{^lo}', "");
    Expect(0, 195101, '\P{lo}', "");
    Expect(1, 195101, '\P{^lo}', "");
    Expect(0, 195102, '\p{lo}', "");
    Expect(1, 195102, '\p{^lo}', "");
    Expect(1, 195102, '\P{lo}', "");
    Expect(0, 195102, '\P{^lo}', "");
    Expect(1, 195101, '\p{_Lo}', "");
    Expect(0, 195101, '\p{^_Lo}', "");
    Expect(0, 195101, '\P{_Lo}', "");
    Expect(1, 195101, '\P{^_Lo}', "");
    Expect(0, 195102, '\p{_Lo}', "");
    Expect(1, 195102, '\p{^_Lo}', "");
    Expect(1, 195102, '\P{_Lo}', "");
    Expect(0, 195102, '\P{^_Lo}', "");
    Error('\p{- is_Lo:=}');
    Error('\P{- is_Lo:=}');
    Expect(1, 195101, '\p{islo}', "");
    Expect(0, 195101, '\p{^islo}', "");
    Expect(0, 195101, '\P{islo}', "");
    Expect(1, 195101, '\P{^islo}', "");
    Expect(0, 195102, '\p{islo}', "");
    Expect(1, 195102, '\p{^islo}', "");
    Expect(1, 195102, '\P{islo}', "");
    Expect(0, 195102, '\P{^islo}', "");
    Expect(1, 195101, '\p{_IS_LO}', "");
    Expect(0, 195101, '\p{^_IS_LO}', "");
    Expect(0, 195101, '\P{_IS_LO}', "");
    Expect(1, 195101, '\P{^_IS_LO}', "");
    Expect(0, 195102, '\p{_IS_LO}', "");
    Expect(1, 195102, '\p{^_IS_LO}', "");
    Expect(1, 195102, '\P{_IS_LO}', "");
    Expect(0, 195102, '\P{^_IS_LO}', "");
    Error('\p{Other_Lowercase}');
    Error('\P{Other_Lowercase}');
    Error('\p{Is_Other_Lowercase}');
    Error('\P{Is_Other_Lowercase}');
    Error('\p{OLower}');
    Error('\P{OLower}');
    Error('\p{Is_OLower}');
    Error('\P{Is_OLower}');
    Error('\p{Other_Math}');
    Error('\P{Other_Math}');
    Error('\p{Is_Other_Math}');
    Error('\P{Is_Other_Math}');
    Error('\p{OMath}');
    Error('\P{OMath}');
    Error('\p{Is_OMath}');
    Error('\P{Is_OMath}');
    Error('\p{ :=OTHER_NUMBER}');
    Error('\P{ :=OTHER_NUMBER}');
    Expect(1, 127244, '\p{othernumber}', "");
    Expect(0, 127244, '\p{^othernumber}', "");
    Expect(0, 127244, '\P{othernumber}', "");
    Expect(1, 127244, '\P{^othernumber}', "");
    Expect(0, 127245, '\p{othernumber}', "");
    Expect(1, 127245, '\p{^othernumber}', "");
    Expect(1, 127245, '\P{othernumber}', "");
    Expect(0, 127245, '\P{^othernumber}', "");
    Expect(1, 127244, '\p{Other_NUMBER}', "");
    Expect(0, 127244, '\p{^Other_NUMBER}', "");
    Expect(0, 127244, '\P{Other_NUMBER}', "");
    Expect(1, 127244, '\P{^Other_NUMBER}', "");
    Expect(0, 127245, '\p{Other_NUMBER}', "");
    Expect(1, 127245, '\p{^Other_NUMBER}', "");
    Expect(1, 127245, '\P{Other_NUMBER}', "");
    Expect(0, 127245, '\P{^Other_NUMBER}', "");
    Error('\p{_Is_Other_NUMBER/a/}');
    Error('\P{_Is_Other_NUMBER/a/}');
    Expect(1, 127244, '\p{isothernumber}', "");
    Expect(0, 127244, '\p{^isothernumber}', "");
    Expect(0, 127244, '\P{isothernumber}', "");
    Expect(1, 127244, '\P{^isothernumber}', "");
    Expect(0, 127245, '\p{isothernumber}', "");
    Expect(1, 127245, '\p{^isothernumber}', "");
    Expect(1, 127245, '\P{isothernumber}', "");
    Expect(0, 127245, '\P{^isothernumber}', "");
    Expect(1, 127244, '\p{-_IS_Other_number}', "");
    Expect(0, 127244, '\p{^-_IS_Other_number}', "");
    Expect(0, 127244, '\P{-_IS_Other_number}', "");
    Expect(1, 127244, '\P{^-_IS_Other_number}', "");
    Expect(0, 127245, '\p{-_IS_Other_number}', "");
    Expect(1, 127245, '\p{^-_IS_Other_number}', "");
    Expect(1, 127245, '\P{-_IS_Other_number}', "");
    Expect(0, 127245, '\P{^-_IS_Other_number}', "");
    Error('\p{:=_ no}');
    Error('\P{:=_ no}');
    Expect(1, 127244, '\p{no}', "");
    Expect(0, 127244, '\p{^no}', "");
    Expect(0, 127244, '\P{no}', "");
    Expect(1, 127244, '\P{^no}', "");
    Expect(0, 127245, '\p{no}', "");
    Expect(1, 127245, '\p{^no}', "");
    Expect(1, 127245, '\P{no}', "");
    Expect(0, 127245, '\P{^no}', "");
    Expect(1, 127244, '\p{No}', "");
    Expect(0, 127244, '\p{^No}', "");
    Expect(0, 127244, '\P{No}', "");
    Expect(1, 127244, '\P{^No}', "");
    Expect(0, 127245, '\p{No}', "");
    Expect(1, 127245, '\p{^No}', "");
    Expect(1, 127245, '\P{No}', "");
    Expect(0, 127245, '\P{^No}', "");
    Error('\p{/a/	IS_NO}');
    Error('\P{/a/	IS_NO}');
    Expect(1, 127244, '\p{isno}', "");
    Expect(0, 127244, '\p{^isno}', "");
    Expect(0, 127244, '\P{isno}', "");
    Expect(1, 127244, '\P{^isno}', "");
    Expect(0, 127245, '\p{isno}', "");
    Expect(1, 127245, '\p{^isno}', "");
    Expect(1, 127245, '\P{isno}', "");
    Expect(0, 127245, '\P{^isno}', "");
    Expect(1, 127244, '\p{- is_no}', "");
    Expect(0, 127244, '\p{^- is_no}', "");
    Expect(0, 127244, '\P{- is_no}', "");
    Expect(1, 127244, '\P{^- is_no}', "");
    Expect(0, 127245, '\p{- is_no}', "");
    Expect(1, 127245, '\p{^- is_no}', "");
    Expect(1, 127245, '\P{- is_no}', "");
    Expect(0, 127245, '\P{^- is_no}', "");
    Error('\p{/a/	_OTHER_Punctuation}');
    Error('\P{/a/	_OTHER_Punctuation}');
    Expect(1, 125279, '\p{otherpunctuation}', "");
    Expect(0, 125279, '\p{^otherpunctuation}', "");
    Expect(0, 125279, '\P{otherpunctuation}', "");
    Expect(1, 125279, '\P{^otherpunctuation}', "");
    Expect(0, 125280, '\p{otherpunctuation}', "");
    Expect(1, 125280, '\p{^otherpunctuation}', "");
    Expect(1, 125280, '\P{otherpunctuation}', "");
    Expect(0, 125280, '\P{^otherpunctuation}', "");
    Expect(1, 125279, '\p{_-Other_Punctuation}', "");
    Expect(0, 125279, '\p{^_-Other_Punctuation}', "");
    Expect(0, 125279, '\P{_-Other_Punctuation}', "");
    Expect(1, 125279, '\P{^_-Other_Punctuation}', "");
    Expect(0, 125280, '\p{_-Other_Punctuation}', "");
    Expect(1, 125280, '\p{^_-Other_Punctuation}', "");
    Expect(1, 125280, '\P{_-Other_Punctuation}', "");
    Expect(0, 125280, '\P{^_-Other_Punctuation}', "");
    Error('\p{/a/_is_Other_punctuation}');
    Error('\P{/a/_is_Other_punctuation}');
    Expect(1, 125279, '\p{isotherpunctuation}', "");
    Expect(0, 125279, '\p{^isotherpunctuation}', "");
    Expect(0, 125279, '\P{isotherpunctuation}', "");
    Expect(1, 125279, '\P{^isotherpunctuation}', "");
    Expect(0, 125280, '\p{isotherpunctuation}', "");
    Expect(1, 125280, '\p{^isotherpunctuation}', "");
    Expect(1, 125280, '\P{isotherpunctuation}', "");
    Expect(0, 125280, '\P{^isotherpunctuation}', "");
    Expect(1, 125279, '\p{_	Is_Other_Punctuation}', "");
    Expect(0, 125279, '\p{^_	Is_Other_Punctuation}', "");
    Expect(0, 125279, '\P{_	Is_Other_Punctuation}', "");
    Expect(1, 125279, '\P{^_	Is_Other_Punctuation}', "");
    Expect(0, 125280, '\p{_	Is_Other_Punctuation}', "");
    Expect(1, 125280, '\p{^_	Is_Other_Punctuation}', "");
    Expect(1, 125280, '\P{_	Is_Other_Punctuation}', "");
    Expect(0, 125280, '\P{^_	Is_Other_Punctuation}', "");
    Error('\p{	_Po:=}');
    Error('\P{	_Po:=}');
    Expect(1, 125279, '\p{po}', "");
    Expect(0, 125279, '\p{^po}', "");
    Expect(0, 125279, '\P{po}', "");
    Expect(1, 125279, '\P{^po}', "");
    Expect(0, 125280, '\p{po}', "");
    Expect(1, 125280, '\p{^po}', "");
    Expect(1, 125280, '\P{po}', "");
    Expect(0, 125280, '\P{^po}', "");
    Expect(1, 125279, '\p{_-Po}', "");
    Expect(0, 125279, '\p{^_-Po}', "");
    Expect(0, 125279, '\P{_-Po}', "");
    Expect(1, 125279, '\P{^_-Po}', "");
    Expect(0, 125280, '\p{_-Po}', "");
    Expect(1, 125280, '\p{^_-Po}', "");
    Expect(1, 125280, '\P{_-Po}', "");
    Expect(0, 125280, '\P{^_-Po}', "");
    Error('\p{_IS_po/a/}');
    Error('\P{_IS_po/a/}');
    Expect(1, 125279, '\p{ispo}', "");
    Expect(0, 125279, '\p{^ispo}', "");
    Expect(0, 125279, '\P{ispo}', "");
    Expect(1, 125279, '\P{^ispo}', "");
    Expect(0, 125280, '\p{ispo}', "");
    Expect(1, 125280, '\p{^ispo}', "");
    Expect(1, 125280, '\P{ispo}', "");
    Expect(0, 125280, '\P{^ispo}', "");
    Expect(1, 125279, '\p{_ IS_Po}', "");
    Expect(0, 125279, '\p{^_ IS_Po}', "");
    Expect(0, 125279, '\P{_ IS_Po}', "");
    Expect(1, 125279, '\P{^_ IS_Po}', "");
    Expect(0, 125280, '\p{_ IS_Po}', "");
    Expect(1, 125280, '\p{^_ IS_Po}', "");
    Expect(1, 125280, '\P{_ IS_Po}', "");
    Expect(0, 125280, '\P{^_ IS_Po}', "");
    Error('\p{:=	_Other_symbol}');
    Error('\P{:=	_Other_symbol}');
    Expect(1, 129510, '\p{othersymbol}', "");
    Expect(0, 129510, '\p{^othersymbol}', "");
    Expect(0, 129510, '\P{othersymbol}', "");
    Expect(1, 129510, '\P{^othersymbol}', "");
    Expect(0, 129511, '\p{othersymbol}', "");
    Expect(1, 129511, '\p{^othersymbol}', "");
    Expect(1, 129511, '\P{othersymbol}', "");
    Expect(0, 129511, '\P{^othersymbol}', "");
    Expect(1, 129510, '\p{_-Other_Symbol}', "");
    Expect(0, 129510, '\p{^_-Other_Symbol}', "");
    Expect(0, 129510, '\P{_-Other_Symbol}', "");
    Expect(1, 129510, '\P{^_-Other_Symbol}', "");
    Expect(0, 129511, '\p{_-Other_Symbol}', "");
    Expect(1, 129511, '\p{^_-Other_Symbol}', "");
    Expect(1, 129511, '\P{_-Other_Symbol}', "");
    Expect(0, 129511, '\P{^_-Other_Symbol}', "");
    Error('\p{ /a/is_Other_Symbol}');
    Error('\P{ /a/is_Other_Symbol}');
    Expect(1, 129510, '\p{isothersymbol}', "");
    Expect(0, 129510, '\p{^isothersymbol}', "");
    Expect(0, 129510, '\P{isothersymbol}', "");
    Expect(1, 129510, '\P{^isothersymbol}', "");
    Expect(0, 129511, '\p{isothersymbol}', "");
    Expect(1, 129511, '\p{^isothersymbol}', "");
    Expect(1, 129511, '\P{isothersymbol}', "");
    Expect(0, 129511, '\P{^isothersymbol}', "");
    Expect(1, 129510, '\p{ 	IS_Other_Symbol}', "");
    Expect(0, 129510, '\p{^ 	IS_Other_Symbol}', "");
    Expect(0, 129510, '\P{ 	IS_Other_Symbol}', "");
    Expect(1, 129510, '\P{^ 	IS_Other_Symbol}', "");
    Expect(0, 129511, '\p{ 	IS_Other_Symbol}', "");
    Expect(1, 129511, '\p{^ 	IS_Other_Symbol}', "");
    Expect(1, 129511, '\P{ 	IS_Other_Symbol}', "");
    Expect(0, 129511, '\P{^ 	IS_Other_Symbol}', "");
    Error('\p{--So/a/}');
    Error('\P{--So/a/}');
    Expect(1, 129510, '\p{so}', "");
    Expect(0, 129510, '\p{^so}', "");
    Expect(0, 129510, '\P{so}', "");
    Expect(1, 129510, '\P{^so}', "");
    Expect(0, 129511, '\p{so}', "");
    Expect(1, 129511, '\p{^so}', "");
    Expect(1, 129511, '\P{so}', "");
    Expect(0, 129511, '\P{^so}', "");
    Expect(1, 129510, '\p{ SO}', "");
    Expect(0, 129510, '\p{^ SO}', "");
    Expect(0, 129510, '\P{ SO}', "");
    Expect(1, 129510, '\P{^ SO}', "");
    Expect(0, 129511, '\p{ SO}', "");
    Expect(1, 129511, '\p{^ SO}', "");
    Expect(1, 129511, '\P{ SO}', "");
    Expect(0, 129511, '\P{^ SO}', "");
    Error('\p{ :=IS_So}');
    Error('\P{ :=IS_So}');
    Expect(1, 129510, '\p{isso}', "");
    Expect(0, 129510, '\p{^isso}', "");
    Expect(0, 129510, '\P{isso}', "");
    Expect(1, 129510, '\P{^isso}', "");
    Expect(0, 129511, '\p{isso}', "");
    Expect(1, 129511, '\p{^isso}', "");
    Expect(1, 129511, '\P{isso}', "");
    Expect(0, 129511, '\P{^isso}', "");
    Expect(1, 129510, '\p{_Is_SO}', "");
    Expect(0, 129510, '\p{^_Is_SO}', "");
    Expect(0, 129510, '\P{_Is_SO}', "");
    Expect(1, 129510, '\P{^_Is_SO}', "");
    Expect(0, 129511, '\p{_Is_SO}', "");
    Expect(1, 129511, '\p{^_Is_SO}', "");
    Expect(1, 129511, '\P{_Is_SO}', "");
    Expect(0, 129511, '\P{^_Is_SO}', "");
    Error('\p{Other_Uppercase}');
    Error('\P{Other_Uppercase}');
    Error('\p{Is_Other_Uppercase}');
    Error('\P{Is_Other_Uppercase}');
    Error('\p{OUpper}');
    Error('\P{OUpper}');
    Error('\p{Is_OUpper}');
    Error('\P{Is_OUpper}');
    Error('\p{:=PAHAWH_Hmong}');
    Error('\P{:=PAHAWH_Hmong}');
    Expect(1, 93071, '\p{pahawhhmong}', "");
    Expect(0, 93071, '\p{^pahawhhmong}', "");
    Expect(0, 93071, '\P{pahawhhmong}', "");
    Expect(1, 93071, '\P{^pahawhhmong}', "");
    Expect(0, 93072, '\p{pahawhhmong}', "");
    Expect(1, 93072, '\p{^pahawhhmong}', "");
    Expect(1, 93072, '\P{pahawhhmong}', "");
    Expect(0, 93072, '\P{^pahawhhmong}', "");
    Expect(1, 93071, '\p{	Pahawh_HMONG}', "");
    Expect(0, 93071, '\p{^	Pahawh_HMONG}', "");
    Expect(0, 93071, '\P{	Pahawh_HMONG}', "");
    Expect(1, 93071, '\P{^	Pahawh_HMONG}', "");
    Expect(0, 93072, '\p{	Pahawh_HMONG}', "");
    Expect(1, 93072, '\p{^	Pahawh_HMONG}', "");
    Expect(1, 93072, '\P{	Pahawh_HMONG}', "");
    Expect(0, 93072, '\P{^	Pahawh_HMONG}', "");
    Error('\p{ Is_Pahawh_Hmong:=}');
    Error('\P{ Is_Pahawh_Hmong:=}');
    Expect(1, 93071, '\p{ispahawhhmong}', "");
    Expect(0, 93071, '\p{^ispahawhhmong}', "");
    Expect(0, 93071, '\P{ispahawhhmong}', "");
    Expect(1, 93071, '\P{^ispahawhhmong}', "");
    Expect(0, 93072, '\p{ispahawhhmong}', "");
    Expect(1, 93072, '\p{^ispahawhhmong}', "");
    Expect(1, 93072, '\P{ispahawhhmong}', "");
    Expect(0, 93072, '\P{^ispahawhhmong}', "");
    Expect(1, 93071, '\p{__Is_Pahawh_Hmong}', "");
    Expect(0, 93071, '\p{^__Is_Pahawh_Hmong}', "");
    Expect(0, 93071, '\P{__Is_Pahawh_Hmong}', "");
    Expect(1, 93071, '\P{^__Is_Pahawh_Hmong}', "");
    Expect(0, 93072, '\p{__Is_Pahawh_Hmong}', "");
    Expect(1, 93072, '\p{^__Is_Pahawh_Hmong}', "");
    Expect(1, 93072, '\P{__Is_Pahawh_Hmong}', "");
    Expect(0, 93072, '\P{^__Is_Pahawh_Hmong}', "");
    Error('\p{_/a/hmng}');
    Error('\P{_/a/hmng}');
    Expect(1, 93071, '\p{hmng}', "");
    Expect(0, 93071, '\p{^hmng}', "");
    Expect(0, 93071, '\P{hmng}', "");
    Expect(1, 93071, '\P{^hmng}', "");
    Expect(0, 93072, '\p{hmng}', "");
    Expect(1, 93072, '\p{^hmng}', "");
    Expect(1, 93072, '\P{hmng}', "");
    Expect(0, 93072, '\P{^hmng}', "");
    Expect(1, 93071, '\p{	 Hmng}', "");
    Expect(0, 93071, '\p{^	 Hmng}', "");
    Expect(0, 93071, '\P{	 Hmng}', "");
    Expect(1, 93071, '\P{^	 Hmng}', "");
    Expect(0, 93072, '\p{	 Hmng}', "");
    Expect(1, 93072, '\p{^	 Hmng}', "");
    Expect(1, 93072, '\P{	 Hmng}', "");
    Expect(0, 93072, '\P{^	 Hmng}', "");
    Error('\p{/a/-_IS_HMNG}');
    Error('\P{/a/-_IS_HMNG}');
    Expect(1, 93071, '\p{ishmng}', "");
    Expect(0, 93071, '\p{^ishmng}', "");
    Expect(0, 93071, '\P{ishmng}', "");
    Expect(1, 93071, '\P{^ishmng}', "");
    Expect(0, 93072, '\p{ishmng}', "");
    Expect(1, 93072, '\p{^ishmng}', "");
    Expect(1, 93072, '\P{ishmng}', "");
    Expect(0, 93072, '\P{^ishmng}', "");
    Expect(1, 93071, '\p{--IS_HMNG}', "");
    Expect(0, 93071, '\p{^--IS_HMNG}', "");
    Expect(0, 93071, '\P{--IS_HMNG}', "");
    Expect(1, 93071, '\P{^--IS_HMNG}', "");
    Expect(0, 93072, '\p{--IS_HMNG}', "");
    Expect(1, 93072, '\p{^--IS_HMNG}', "");
    Expect(1, 93072, '\P{--IS_HMNG}', "");
    Expect(0, 93072, '\P{^--IS_HMNG}', "");
    Error('\p{:=	_PALMYRENE}');
    Error('\P{:=	_PALMYRENE}');
    Expect(1, 67711, '\p{palmyrene}', "");
    Expect(0, 67711, '\p{^palmyrene}', "");
    Expect(0, 67711, '\P{palmyrene}', "");
    Expect(1, 67711, '\P{^palmyrene}', "");
    Expect(0, 67712, '\p{palmyrene}', "");
    Expect(1, 67712, '\p{^palmyrene}', "");
    Expect(1, 67712, '\P{palmyrene}', "");
    Expect(0, 67712, '\P{^palmyrene}', "");
    Expect(1, 67711, '\p{_-Palmyrene}', "");
    Expect(0, 67711, '\p{^_-Palmyrene}', "");
    Expect(0, 67711, '\P{_-Palmyrene}', "");
    Expect(1, 67711, '\P{^_-Palmyrene}', "");
    Expect(0, 67712, '\p{_-Palmyrene}', "");
    Expect(1, 67712, '\p{^_-Palmyrene}', "");
    Expect(1, 67712, '\P{_-Palmyrene}', "");
    Expect(0, 67712, '\P{^_-Palmyrene}', "");
    Error('\p{:=	-Is_Palmyrene}');
    Error('\P{:=	-Is_Palmyrene}');
    Expect(1, 67711, '\p{ispalmyrene}', "");
    Expect(0, 67711, '\p{^ispalmyrene}', "");
    Expect(0, 67711, '\P{ispalmyrene}', "");
    Expect(1, 67711, '\P{^ispalmyrene}', "");
    Expect(0, 67712, '\p{ispalmyrene}', "");
    Expect(1, 67712, '\p{^ispalmyrene}', "");
    Expect(1, 67712, '\P{ispalmyrene}', "");
    Expect(0, 67712, '\P{^ispalmyrene}', "");
    Expect(1, 67711, '\p{- Is_palmyrene}', "");
    Expect(0, 67711, '\p{^- Is_palmyrene}', "");
    Expect(0, 67711, '\P{- Is_palmyrene}', "");
    Expect(1, 67711, '\P{^- Is_palmyrene}', "");
    Expect(0, 67712, '\p{- Is_palmyrene}', "");
    Expect(1, 67712, '\p{^- Is_palmyrene}', "");
    Expect(1, 67712, '\P{- Is_palmyrene}', "");
    Expect(0, 67712, '\P{^- Is_palmyrene}', "");
    Error('\p{:=	Palm}');
    Error('\P{:=	Palm}');
    Expect(1, 67711, '\p{palm}', "");
    Expect(0, 67711, '\p{^palm}', "");
    Expect(0, 67711, '\P{palm}', "");
    Expect(1, 67711, '\P{^palm}', "");
    Expect(0, 67712, '\p{palm}', "");
    Expect(1, 67712, '\p{^palm}', "");
    Expect(1, 67712, '\P{palm}', "");
    Expect(0, 67712, '\P{^palm}', "");
    Expect(1, 67711, '\p{  Palm}', "");
    Expect(0, 67711, '\p{^  Palm}', "");
    Expect(0, 67711, '\P{  Palm}', "");
    Expect(1, 67711, '\P{^  Palm}', "");
    Expect(0, 67712, '\p{  Palm}', "");
    Expect(1, 67712, '\p{^  Palm}', "");
    Expect(1, 67712, '\P{  Palm}', "");
    Expect(0, 67712, '\P{^  Palm}', "");
    Error('\p{-IS_Palm/a/}');
    Error('\P{-IS_Palm/a/}');
    Expect(1, 67711, '\p{ispalm}', "");
    Expect(0, 67711, '\p{^ispalm}', "");
    Expect(0, 67711, '\P{ispalm}', "");
    Expect(1, 67711, '\P{^ispalm}', "");
    Expect(0, 67712, '\p{ispalm}', "");
    Expect(1, 67712, '\p{^ispalm}', "");
    Expect(1, 67712, '\P{ispalm}', "");
    Expect(0, 67712, '\P{^ispalm}', "");
    Expect(1, 67711, '\p{_Is_PALM}', "");
    Expect(0, 67711, '\p{^_Is_PALM}', "");
    Expect(0, 67711, '\P{_Is_PALM}', "");
    Expect(1, 67711, '\P{^_Is_PALM}', "");
    Expect(0, 67712, '\p{_Is_PALM}', "");
    Expect(1, 67712, '\p{^_Is_PALM}', "");
    Expect(1, 67712, '\P{_Is_PALM}', "");
    Expect(0, 67712, '\P{^_Is_PALM}', "");
    Error('\p{ :=PARAGRAPH_SEPARATOR}');
    Error('\P{ :=PARAGRAPH_SEPARATOR}');
    Expect(1, 8233, '\p{paragraphseparator}', "");
    Expect(0, 8233, '\p{^paragraphseparator}', "");
    Expect(0, 8233, '\P{paragraphseparator}', "");
    Expect(1, 8233, '\P{^paragraphseparator}', "");
    Expect(0, 8234, '\p{paragraphseparator}', "");
    Expect(1, 8234, '\p{^paragraphseparator}', "");
    Expect(1, 8234, '\P{paragraphseparator}', "");
    Expect(0, 8234, '\P{^paragraphseparator}', "");
    Expect(1, 8233, '\p{ _Paragraph_separator}', "");
    Expect(0, 8233, '\p{^ _Paragraph_separator}', "");
    Expect(0, 8233, '\P{ _Paragraph_separator}', "");
    Expect(1, 8233, '\P{^ _Paragraph_separator}', "");
    Expect(0, 8234, '\p{ _Paragraph_separator}', "");
    Expect(1, 8234, '\p{^ _Paragraph_separator}', "");
    Expect(1, 8234, '\P{ _Paragraph_separator}', "");
    Expect(0, 8234, '\P{^ _Paragraph_separator}', "");
    Error('\p{/a/_ Is_Paragraph_SEPARATOR}');
    Error('\P{/a/_ Is_Paragraph_SEPARATOR}');
    Expect(1, 8233, '\p{isparagraphseparator}', "");
    Expect(0, 8233, '\p{^isparagraphseparator}', "");
    Expect(0, 8233, '\P{isparagraphseparator}', "");
    Expect(1, 8233, '\P{^isparagraphseparator}', "");
    Expect(0, 8234, '\p{isparagraphseparator}', "");
    Expect(1, 8234, '\p{^isparagraphseparator}', "");
    Expect(1, 8234, '\P{isparagraphseparator}', "");
    Expect(0, 8234, '\P{^isparagraphseparator}', "");
    Expect(1, 8233, '\p{	-Is_PARAGRAPH_Separator}', "");
    Expect(0, 8233, '\p{^	-Is_PARAGRAPH_Separator}', "");
    Expect(0, 8233, '\P{	-Is_PARAGRAPH_Separator}', "");
    Expect(1, 8233, '\P{^	-Is_PARAGRAPH_Separator}', "");
    Expect(0, 8234, '\p{	-Is_PARAGRAPH_Separator}', "");
    Expect(1, 8234, '\p{^	-Is_PARAGRAPH_Separator}', "");
    Expect(1, 8234, '\P{	-Is_PARAGRAPH_Separator}', "");
    Expect(0, 8234, '\P{^	-Is_PARAGRAPH_Separator}', "");
    Error('\p{-_zp:=}');
    Error('\P{-_zp:=}');
    Expect(1, 8233, '\p{zp}', "");
    Expect(0, 8233, '\p{^zp}', "");
    Expect(0, 8233, '\P{zp}', "");
    Expect(1, 8233, '\P{^zp}', "");
    Expect(0, 8234, '\p{zp}', "");
    Expect(1, 8234, '\p{^zp}', "");
    Expect(1, 8234, '\P{zp}', "");
    Expect(0, 8234, '\P{^zp}', "");
    Expect(1, 8233, '\p{-Zp}', "");
    Expect(0, 8233, '\p{^-Zp}', "");
    Expect(0, 8233, '\P{-Zp}', "");
    Expect(1, 8233, '\P{^-Zp}', "");
    Expect(0, 8234, '\p{-Zp}', "");
    Expect(1, 8234, '\p{^-Zp}', "");
    Expect(1, 8234, '\P{-Zp}', "");
    Expect(0, 8234, '\P{^-Zp}', "");
    Error('\p{- Is_Zp:=}');
    Error('\P{- Is_Zp:=}');
    Expect(1, 8233, '\p{iszp}', "");
    Expect(0, 8233, '\p{^iszp}', "");
    Expect(0, 8233, '\P{iszp}', "");
    Expect(1, 8233, '\P{^iszp}', "");
    Expect(0, 8234, '\p{iszp}', "");
    Expect(1, 8234, '\p{^iszp}', "");
    Expect(1, 8234, '\P{iszp}', "");
    Expect(0, 8234, '\P{^iszp}', "");
    Expect(1, 8233, '\p{_ Is_Zp}', "");
    Expect(0, 8233, '\p{^_ Is_Zp}', "");
    Expect(0, 8233, '\P{_ Is_Zp}', "");
    Expect(1, 8233, '\P{^_ Is_Zp}', "");
    Expect(0, 8234, '\p{_ Is_Zp}', "");
    Expect(1, 8234, '\p{^_ Is_Zp}', "");
    Expect(1, 8234, '\P{_ Is_Zp}', "");
    Expect(0, 8234, '\P{^_ Is_Zp}', "");
    Error('\p{:=_-Pattern_Syntax}');
    Error('\P{:=_-Pattern_Syntax}');
    Expect(1, 65094, '\p{patternsyntax}', "");
    Expect(0, 65094, '\p{^patternsyntax}', "");
    Expect(0, 65094, '\P{patternsyntax}', "");
    Expect(1, 65094, '\P{^patternsyntax}', "");
    Expect(0, 65095, '\p{patternsyntax}', "");
    Expect(1, 65095, '\p{^patternsyntax}', "");
    Expect(1, 65095, '\P{patternsyntax}', "");
    Expect(0, 65095, '\P{^patternsyntax}', "");
    Expect(1, 65094, '\p{ _Pattern_syntax}', "");
    Expect(0, 65094, '\p{^ _Pattern_syntax}', "");
    Expect(0, 65094, '\P{ _Pattern_syntax}', "");
    Expect(1, 65094, '\P{^ _Pattern_syntax}', "");
    Expect(0, 65095, '\p{ _Pattern_syntax}', "");
    Expect(1, 65095, '\p{^ _Pattern_syntax}', "");
    Expect(1, 65095, '\P{ _Pattern_syntax}', "");
    Expect(0, 65095, '\P{^ _Pattern_syntax}', "");
    Error('\p{  Is_PATTERN_SYNTAX/a/}');
    Error('\P{  Is_PATTERN_SYNTAX/a/}');
    Expect(1, 65094, '\p{ispatternsyntax}', "");
    Expect(0, 65094, '\p{^ispatternsyntax}', "");
    Expect(0, 65094, '\P{ispatternsyntax}', "");
    Expect(1, 65094, '\P{^ispatternsyntax}', "");
    Expect(0, 65095, '\p{ispatternsyntax}', "");
    Expect(1, 65095, '\p{^ispatternsyntax}', "");
    Expect(1, 65095, '\P{ispatternsyntax}', "");
    Expect(0, 65095, '\P{^ispatternsyntax}', "");
    Expect(1, 65094, '\p{-_Is_Pattern_SYNTAX}', "");
    Expect(0, 65094, '\p{^-_Is_Pattern_SYNTAX}', "");
    Expect(0, 65094, '\P{-_Is_Pattern_SYNTAX}', "");
    Expect(1, 65094, '\P{^-_Is_Pattern_SYNTAX}', "");
    Expect(0, 65095, '\p{-_Is_Pattern_SYNTAX}', "");
    Expect(1, 65095, '\p{^-_Is_Pattern_SYNTAX}', "");
    Expect(1, 65095, '\P{-_Is_Pattern_SYNTAX}', "");
    Expect(0, 65095, '\P{^-_Is_Pattern_SYNTAX}', "");
    Error('\p{:=-_Pat_Syn}');
    Error('\P{:=-_Pat_Syn}');
    Expect(1, 65094, '\p{patsyn}', "");
    Expect(0, 65094, '\p{^patsyn}', "");
    Expect(0, 65094, '\P{patsyn}', "");
    Expect(1, 65094, '\P{^patsyn}', "");
    Expect(0, 65095, '\p{patsyn}', "");
    Expect(1, 65095, '\p{^patsyn}', "");
    Expect(1, 65095, '\P{patsyn}', "");
    Expect(0, 65095, '\P{^patsyn}', "");
    Expect(1, 65094, '\p{_	Pat_Syn}', "");
    Expect(0, 65094, '\p{^_	Pat_Syn}', "");
    Expect(0, 65094, '\P{_	Pat_Syn}', "");
    Expect(1, 65094, '\P{^_	Pat_Syn}', "");
    Expect(0, 65095, '\p{_	Pat_Syn}', "");
    Expect(1, 65095, '\p{^_	Pat_Syn}', "");
    Expect(1, 65095, '\P{_	Pat_Syn}', "");
    Expect(0, 65095, '\P{^_	Pat_Syn}', "");
    Error('\p{-Is_Pat_syn/a/}');
    Error('\P{-Is_Pat_syn/a/}');
    Expect(1, 65094, '\p{ispatsyn}', "");
    Expect(0, 65094, '\p{^ispatsyn}', "");
    Expect(0, 65094, '\P{ispatsyn}', "");
    Expect(1, 65094, '\P{^ispatsyn}', "");
    Expect(0, 65095, '\p{ispatsyn}', "");
    Expect(1, 65095, '\p{^ispatsyn}', "");
    Expect(1, 65095, '\P{ispatsyn}', "");
    Expect(0, 65095, '\P{^ispatsyn}', "");
    Expect(1, 65094, '\p{  Is_Pat_Syn}', "");
    Expect(0, 65094, '\p{^  Is_Pat_Syn}', "");
    Expect(0, 65094, '\P{  Is_Pat_Syn}', "");
    Expect(1, 65094, '\P{^  Is_Pat_Syn}', "");
    Expect(0, 65095, '\p{  Is_Pat_Syn}', "");
    Expect(1, 65095, '\p{^  Is_Pat_Syn}', "");
    Expect(1, 65095, '\P{  Is_Pat_Syn}', "");
    Expect(0, 65095, '\P{^  Is_Pat_Syn}', "");
    Error('\p{ 	PATTERN_White_Space:=}');
    Error('\P{ 	PATTERN_White_Space:=}');
    Expect(1, 8233, '\p{patternwhitespace}', "");
    Expect(0, 8233, '\p{^patternwhitespace}', "");
    Expect(0, 8233, '\P{patternwhitespace}', "");
    Expect(1, 8233, '\P{^patternwhitespace}', "");
    Expect(0, 8234, '\p{patternwhitespace}', "");
    Expect(1, 8234, '\p{^patternwhitespace}', "");
    Expect(1, 8234, '\P{patternwhitespace}', "");
    Expect(0, 8234, '\P{^patternwhitespace}', "");
    Expect(1, 8233, '\p{_pattern_WHITE_Space}', "");
    Expect(0, 8233, '\p{^_pattern_WHITE_Space}', "");
    Expect(0, 8233, '\P{_pattern_WHITE_Space}', "");
    Expect(1, 8233, '\P{^_pattern_WHITE_Space}', "");
    Expect(0, 8234, '\p{_pattern_WHITE_Space}', "");
    Expect(1, 8234, '\p{^_pattern_WHITE_Space}', "");
    Expect(1, 8234, '\P{_pattern_WHITE_Space}', "");
    Expect(0, 8234, '\P{^_pattern_WHITE_Space}', "");
    Error('\p{ Is_Pattern_White_Space/a/}');
    Error('\P{ Is_Pattern_White_Space/a/}');
    Expect(1, 8233, '\p{ispatternwhitespace}', "");
    Expect(0, 8233, '\p{^ispatternwhitespace}', "");
    Expect(0, 8233, '\P{ispatternwhitespace}', "");
    Expect(1, 8233, '\P{^ispatternwhitespace}', "");
    Expect(0, 8234, '\p{ispatternwhitespace}', "");
    Expect(1, 8234, '\p{^ispatternwhitespace}', "");
    Expect(1, 8234, '\P{ispatternwhitespace}', "");
    Expect(0, 8234, '\P{^ispatternwhitespace}', "");
    Expect(1, 8233, '\p{	Is_pattern_WHITE_space}', "");
    Expect(0, 8233, '\p{^	Is_pattern_WHITE_space}', "");
    Expect(0, 8233, '\P{	Is_pattern_WHITE_space}', "");
    Expect(1, 8233, '\P{^	Is_pattern_WHITE_space}', "");
    Expect(0, 8234, '\p{	Is_pattern_WHITE_space}', "");
    Expect(1, 8234, '\p{^	Is_pattern_WHITE_space}', "");
    Expect(1, 8234, '\P{	Is_pattern_WHITE_space}', "");
    Expect(0, 8234, '\P{^	Is_pattern_WHITE_space}', "");
    Error('\p{/a/Pat_WS}');
    Error('\P{/a/Pat_WS}');
    Expect(1, 8233, '\p{patws}', "");
    Expect(0, 8233, '\p{^patws}', "");
    Expect(0, 8233, '\P{patws}', "");
    Expect(1, 8233, '\P{^patws}', "");
    Expect(0, 8234, '\p{patws}', "");
    Expect(1, 8234, '\p{^patws}', "");
    Expect(1, 8234, '\P{patws}', "");
    Expect(0, 8234, '\P{^patws}', "");
    Expect(1, 8233, '\p{_PAT_ws}', "");
    Expect(0, 8233, '\p{^_PAT_ws}', "");
    Expect(0, 8233, '\P{_PAT_ws}', "");
    Expect(1, 8233, '\P{^_PAT_ws}', "");
    Expect(0, 8234, '\p{_PAT_ws}', "");
    Expect(1, 8234, '\p{^_PAT_ws}', "");
    Expect(1, 8234, '\P{_PAT_ws}', "");
    Expect(0, 8234, '\P{^_PAT_ws}', "");
    Error('\p{	/a/is_PAT_WS}');
    Error('\P{	/a/is_PAT_WS}');
    Expect(1, 8233, '\p{ispatws}', "");
    Expect(0, 8233, '\p{^ispatws}', "");
    Expect(0, 8233, '\P{ispatws}', "");
    Expect(1, 8233, '\P{^ispatws}', "");
    Expect(0, 8234, '\p{ispatws}', "");
    Expect(1, 8234, '\p{^ispatws}', "");
    Expect(1, 8234, '\P{ispatws}', "");
    Expect(0, 8234, '\P{^ispatws}', "");
    Expect(1, 8233, '\p{	is_pat_ws}', "");
    Expect(0, 8233, '\p{^	is_pat_ws}', "");
    Expect(0, 8233, '\P{	is_pat_ws}', "");
    Expect(1, 8233, '\P{^	is_pat_ws}', "");
    Expect(0, 8234, '\p{	is_pat_ws}', "");
    Expect(1, 8234, '\p{^	is_pat_ws}', "");
    Expect(1, 8234, '\P{	is_pat_ws}', "");
    Expect(0, 8234, '\P{^	is_pat_ws}', "");
    Error('\p{-/a/Pau_CIN_HAU}');
    Error('\P{-/a/Pau_CIN_HAU}');
    Expect(1, 72440, '\p{paucinhau}', "");
    Expect(0, 72440, '\p{^paucinhau}', "");
    Expect(0, 72440, '\P{paucinhau}', "");
    Expect(1, 72440, '\P{^paucinhau}', "");
    Expect(0, 72441, '\p{paucinhau}', "");
    Expect(1, 72441, '\p{^paucinhau}', "");
    Expect(1, 72441, '\P{paucinhau}', "");
    Expect(0, 72441, '\P{^paucinhau}', "");
    Expect(1, 72440, '\p{	-Pau_Cin_Hau}', "");
    Expect(0, 72440, '\p{^	-Pau_Cin_Hau}', "");
    Expect(0, 72440, '\P{	-Pau_Cin_Hau}', "");
    Expect(1, 72440, '\P{^	-Pau_Cin_Hau}', "");
    Expect(0, 72441, '\p{	-Pau_Cin_Hau}', "");
    Expect(1, 72441, '\p{^	-Pau_Cin_Hau}', "");
    Expect(1, 72441, '\P{	-Pau_Cin_Hau}', "");
    Expect(0, 72441, '\P{^	-Pau_Cin_Hau}', "");
    Error('\p{/a/IS_Pau_CIN_Hau}');
    Error('\P{/a/IS_Pau_CIN_Hau}');
    Expect(1, 72440, '\p{ispaucinhau}', "");
    Expect(0, 72440, '\p{^ispaucinhau}', "");
    Expect(0, 72440, '\P{ispaucinhau}', "");
    Expect(1, 72440, '\P{^ispaucinhau}', "");
    Expect(0, 72441, '\p{ispaucinhau}', "");
    Expect(1, 72441, '\p{^ispaucinhau}', "");
    Expect(1, 72441, '\P{ispaucinhau}', "");
    Expect(0, 72441, '\P{^ispaucinhau}', "");
    Expect(1, 72440, '\p{		Is_PAU_CIN_Hau}', "");
    Expect(0, 72440, '\p{^		Is_PAU_CIN_Hau}', "");
    Expect(0, 72440, '\P{		Is_PAU_CIN_Hau}', "");
    Expect(1, 72440, '\P{^		Is_PAU_CIN_Hau}', "");
    Expect(0, 72441, '\p{		Is_PAU_CIN_Hau}', "");
    Expect(1, 72441, '\p{^		Is_PAU_CIN_Hau}', "");
    Expect(1, 72441, '\P{		Is_PAU_CIN_Hau}', "");
    Expect(0, 72441, '\P{^		Is_PAU_CIN_Hau}', "");
    Error('\p{Pauc:=}');
    Error('\P{Pauc:=}');
    Expect(1, 72440, '\p{pauc}', "");
    Expect(0, 72440, '\p{^pauc}', "");
    Expect(0, 72440, '\P{pauc}', "");
    Expect(1, 72440, '\P{^pauc}', "");
    Expect(0, 72441, '\p{pauc}', "");
    Expect(1, 72441, '\p{^pauc}', "");
    Expect(1, 72441, '\P{pauc}', "");
    Expect(0, 72441, '\P{^pauc}', "");
    Expect(1, 72440, '\p{_-Pauc}', "");
    Expect(0, 72440, '\p{^_-Pauc}', "");
    Expect(0, 72440, '\P{_-Pauc}', "");
    Expect(1, 72440, '\P{^_-Pauc}', "");
    Expect(0, 72441, '\p{_-Pauc}', "");
    Expect(1, 72441, '\p{^_-Pauc}', "");
    Expect(1, 72441, '\P{_-Pauc}', "");
    Expect(0, 72441, '\P{^_-Pauc}', "");
    Error('\p{	 IS_PAUC/a/}');
    Error('\P{	 IS_PAUC/a/}');
    Expect(1, 72440, '\p{ispauc}', "");
    Expect(0, 72440, '\p{^ispauc}', "");
    Expect(0, 72440, '\P{ispauc}', "");
    Expect(1, 72440, '\P{^ispauc}', "");
    Expect(0, 72441, '\p{ispauc}', "");
    Expect(1, 72441, '\p{^ispauc}', "");
    Expect(1, 72441, '\P{ispauc}', "");
    Expect(0, 72441, '\P{^ispauc}', "");
    Expect(1, 72440, '\p{	 Is_pauc}', "");
    Expect(0, 72440, '\p{^	 Is_pauc}', "");
    Expect(0, 72440, '\P{	 Is_pauc}', "");
    Expect(1, 72440, '\P{^	 Is_pauc}', "");
    Expect(0, 72441, '\p{	 Is_pauc}', "");
    Expect(1, 72441, '\p{^	 Is_pauc}', "");
    Expect(1, 72441, '\P{	 Is_pauc}', "");
    Expect(0, 72441, '\P{^	 Is_pauc}', "");
    Error('\p{ :=phags_Pa}');
    Error('\P{ :=phags_Pa}');
    Expect(1, 43127, '\p{phagspa}', "");
    Expect(0, 43127, '\p{^phagspa}', "");
    Expect(0, 43127, '\P{phagspa}', "");
    Expect(1, 43127, '\P{^phagspa}', "");
    Expect(0, 43128, '\p{phagspa}', "");
    Expect(1, 43128, '\p{^phagspa}', "");
    Expect(1, 43128, '\P{phagspa}', "");
    Expect(0, 43128, '\P{^phagspa}', "");
    Expect(1, 43127, '\p{  phags_pa}', "");
    Expect(0, 43127, '\p{^  phags_pa}', "");
    Expect(0, 43127, '\P{  phags_pa}', "");
    Expect(1, 43127, '\P{^  phags_pa}', "");
    Expect(0, 43128, '\p{  phags_pa}', "");
    Expect(1, 43128, '\p{^  phags_pa}', "");
    Expect(1, 43128, '\P{  phags_pa}', "");
    Expect(0, 43128, '\P{^  phags_pa}', "");
    Error('\p{	:=IS_phags_PA}');
    Error('\P{	:=IS_phags_PA}');
    Expect(1, 43127, '\p{isphagspa}', "");
    Expect(0, 43127, '\p{^isphagspa}', "");
    Expect(0, 43127, '\P{isphagspa}', "");
    Expect(1, 43127, '\P{^isphagspa}', "");
    Expect(0, 43128, '\p{isphagspa}', "");
    Expect(1, 43128, '\p{^isphagspa}', "");
    Expect(1, 43128, '\P{isphagspa}', "");
    Expect(0, 43128, '\P{^isphagspa}', "");
    Expect(1, 43127, '\p{ Is_Phags_PA}', "");
    Expect(0, 43127, '\p{^ Is_Phags_PA}', "");
    Expect(0, 43127, '\P{ Is_Phags_PA}', "");
    Expect(1, 43127, '\P{^ Is_Phags_PA}', "");
    Expect(0, 43128, '\p{ Is_Phags_PA}', "");
    Expect(1, 43128, '\p{^ Is_Phags_PA}', "");
    Expect(1, 43128, '\P{ Is_Phags_PA}', "");
    Expect(0, 43128, '\P{^ Is_Phags_PA}', "");
    Error('\p{_-Phag/a/}');
    Error('\P{_-Phag/a/}');
    Expect(1, 43127, '\p{phag}', "");
    Expect(0, 43127, '\p{^phag}', "");
    Expect(0, 43127, '\P{phag}', "");
    Expect(1, 43127, '\P{^phag}', "");
    Expect(0, 43128, '\p{phag}', "");
    Expect(1, 43128, '\p{^phag}', "");
    Expect(1, 43128, '\P{phag}', "");
    Expect(0, 43128, '\P{^phag}', "");
    Expect(1, 43127, '\p{		Phag}', "");
    Expect(0, 43127, '\p{^		Phag}', "");
    Expect(0, 43127, '\P{		Phag}', "");
    Expect(1, 43127, '\P{^		Phag}', "");
    Expect(0, 43128, '\p{		Phag}', "");
    Expect(1, 43128, '\p{^		Phag}', "");
    Expect(1, 43128, '\P{		Phag}', "");
    Expect(0, 43128, '\P{^		Phag}', "");
    Error('\p{/a/		is_PHAG}');
    Error('\P{/a/		is_PHAG}');
    Expect(1, 43127, '\p{isphag}', "");
    Expect(0, 43127, '\p{^isphag}', "");
    Expect(0, 43127, '\P{isphag}', "");
    Expect(1, 43127, '\P{^isphag}', "");
    Expect(0, 43128, '\p{isphag}', "");
    Expect(1, 43128, '\p{^isphag}', "");
    Expect(1, 43128, '\P{isphag}', "");
    Expect(0, 43128, '\P{^isphag}', "");
    Expect(1, 43127, '\p{	Is_Phag}', "");
    Expect(0, 43127, '\p{^	Is_Phag}', "");
    Expect(0, 43127, '\P{	Is_Phag}', "");
    Expect(1, 43127, '\P{^	Is_Phag}', "");
    Expect(0, 43128, '\p{	Is_Phag}', "");
    Expect(1, 43128, '\p{^	Is_Phag}', "");
    Expect(1, 43128, '\P{	Is_Phag}', "");
    Expect(0, 43128, '\P{^	Is_Phag}', "");
    Error('\p{	-Phaistos_Disc/a/}');
    Error('\P{	-Phaistos_Disc/a/}');
    Expect(1, 66047, '\p{phaistosdisc}', "");
    Expect(0, 66047, '\p{^phaistosdisc}', "");
    Expect(0, 66047, '\P{phaistosdisc}', "");
    Expect(1, 66047, '\P{^phaistosdisc}', "");
    Expect(0, 66048, '\p{phaistosdisc}', "");
    Expect(1, 66048, '\p{^phaistosdisc}', "");
    Expect(1, 66048, '\P{phaistosdisc}', "");
    Expect(0, 66048, '\P{^phaistosdisc}', "");
    Expect(1, 66047, '\p{ 	PHAISTOS_Disc}', "");
    Expect(0, 66047, '\p{^ 	PHAISTOS_Disc}', "");
    Expect(0, 66047, '\P{ 	PHAISTOS_Disc}', "");
    Expect(1, 66047, '\P{^ 	PHAISTOS_Disc}', "");
    Expect(0, 66048, '\p{ 	PHAISTOS_Disc}', "");
    Expect(1, 66048, '\p{^ 	PHAISTOS_Disc}', "");
    Expect(1, 66048, '\P{ 	PHAISTOS_Disc}', "");
    Expect(0, 66048, '\P{^ 	PHAISTOS_Disc}', "");
    Error('\p{-/a/is_PHAISTOS_disc}');
    Error('\P{-/a/is_PHAISTOS_disc}');
    Expect(1, 66047, '\p{isphaistosdisc}', "");
    Expect(0, 66047, '\p{^isphaistosdisc}', "");
    Expect(0, 66047, '\P{isphaistosdisc}', "");
    Expect(1, 66047, '\P{^isphaistosdisc}', "");
    Expect(0, 66048, '\p{isphaistosdisc}', "");
    Expect(1, 66048, '\p{^isphaistosdisc}', "");
    Expect(1, 66048, '\P{isphaistosdisc}', "");
    Expect(0, 66048, '\P{^isphaistosdisc}', "");
    Expect(1, 66047, '\p{_	Is_Phaistos_Disc}', "");
    Expect(0, 66047, '\p{^_	Is_Phaistos_Disc}', "");
    Expect(0, 66047, '\P{_	Is_Phaistos_Disc}', "");
    Expect(1, 66047, '\P{^_	Is_Phaistos_Disc}', "");
    Expect(0, 66048, '\p{_	Is_Phaistos_Disc}', "");
    Expect(1, 66048, '\p{^_	Is_Phaistos_Disc}', "");
    Expect(1, 66048, '\P{_	Is_Phaistos_Disc}', "");
    Expect(0, 66048, '\P{^_	Is_Phaistos_Disc}', "");
    Error('\p{-In_phaistos_Disc/a/}');
    Error('\P{-In_phaistos_Disc/a/}');
    Expect(1, 66047, '\p{inphaistosdisc}', "");
    Expect(0, 66047, '\p{^inphaistosdisc}', "");
    Expect(0, 66047, '\P{inphaistosdisc}', "");
    Expect(1, 66047, '\P{^inphaistosdisc}', "");
    Expect(0, 66048, '\p{inphaistosdisc}', "");
    Expect(1, 66048, '\p{^inphaistosdisc}', "");
    Expect(1, 66048, '\P{inphaistosdisc}', "");
    Expect(0, 66048, '\P{^inphaistosdisc}', "");
    Expect(1, 66047, '\p{__IN_PHAISTOS_disc}', "");
    Expect(0, 66047, '\p{^__IN_PHAISTOS_disc}', "");
    Expect(0, 66047, '\P{__IN_PHAISTOS_disc}', "");
    Expect(1, 66047, '\P{^__IN_PHAISTOS_disc}', "");
    Expect(0, 66048, '\p{__IN_PHAISTOS_disc}', "");
    Expect(1, 66048, '\p{^__IN_PHAISTOS_disc}', "");
    Expect(1, 66048, '\P{__IN_PHAISTOS_disc}', "");
    Expect(0, 66048, '\P{^__IN_PHAISTOS_disc}', "");
    Error('\p{	:=PHAISTOS}');
    Error('\P{	:=PHAISTOS}');
    Expect(1, 66047, '\p{phaistos}', "");
    Expect(0, 66047, '\p{^phaistos}', "");
    Expect(0, 66047, '\P{phaistos}', "");
    Expect(1, 66047, '\P{^phaistos}', "");
    Expect(0, 66048, '\p{phaistos}', "");
    Expect(1, 66048, '\p{^phaistos}', "");
    Expect(1, 66048, '\P{phaistos}', "");
    Expect(0, 66048, '\P{^phaistos}', "");
    Expect(1, 66047, '\p{_phaistos}', "");
    Expect(0, 66047, '\p{^_phaistos}', "");
    Expect(0, 66047, '\P{_phaistos}', "");
    Expect(1, 66047, '\P{^_phaistos}', "");
    Expect(0, 66048, '\p{_phaistos}', "");
    Expect(1, 66048, '\p{^_phaistos}', "");
    Expect(1, 66048, '\P{_phaistos}', "");
    Expect(0, 66048, '\P{^_phaistos}', "");
    Error('\p{/a/-Is_Phaistos}');
    Error('\P{/a/-Is_Phaistos}');
    Expect(1, 66047, '\p{isphaistos}', "");
    Expect(0, 66047, '\p{^isphaistos}', "");
    Expect(0, 66047, '\P{isphaistos}', "");
    Expect(1, 66047, '\P{^isphaistos}', "");
    Expect(0, 66048, '\p{isphaistos}', "");
    Expect(1, 66048, '\p{^isphaistos}', "");
    Expect(1, 66048, '\P{isphaistos}', "");
    Expect(0, 66048, '\P{^isphaistos}', "");
    Expect(1, 66047, '\p{		IS_phaistos}', "");
    Expect(0, 66047, '\p{^		IS_phaistos}', "");
    Expect(0, 66047, '\P{		IS_phaistos}', "");
    Expect(1, 66047, '\P{^		IS_phaistos}', "");
    Expect(0, 66048, '\p{		IS_phaistos}', "");
    Expect(1, 66048, '\p{^		IS_phaistos}', "");
    Expect(1, 66048, '\P{		IS_phaistos}', "");
    Expect(0, 66048, '\P{^		IS_phaistos}', "");
    Error('\p{/a/_in_PHAISTOS}');
    Error('\P{/a/_in_PHAISTOS}');
    Expect(1, 66047, '\p{inphaistos}', "");
    Expect(0, 66047, '\p{^inphaistos}', "");
    Expect(0, 66047, '\P{inphaistos}', "");
    Expect(1, 66047, '\P{^inphaistos}', "");
    Expect(0, 66048, '\p{inphaistos}', "");
    Expect(1, 66048, '\p{^inphaistos}', "");
    Expect(1, 66048, '\P{inphaistos}', "");
    Expect(0, 66048, '\P{^inphaistos}', "");
    Expect(1, 66047, '\p{_	In_Phaistos}', "");
    Expect(0, 66047, '\p{^_	In_Phaistos}', "");
    Expect(0, 66047, '\P{_	In_Phaistos}', "");
    Expect(1, 66047, '\P{^_	In_Phaistos}', "");
    Expect(0, 66048, '\p{_	In_Phaistos}', "");
    Expect(1, 66048, '\p{^_	In_Phaistos}', "");
    Expect(1, 66048, '\P{_	In_Phaistos}', "");
    Expect(0, 66048, '\P{^_	In_Phaistos}', "");
    Error('\p{	 PHOENICIAN:=}');
    Error('\P{	 PHOENICIAN:=}');
    Expect(1, 67871, '\p{phoenician}', "");
    Expect(0, 67871, '\p{^phoenician}', "");
    Expect(0, 67871, '\P{phoenician}', "");
    Expect(1, 67871, '\P{^phoenician}', "");
    Expect(0, 67872, '\p{phoenician}', "");
    Expect(1, 67872, '\p{^phoenician}', "");
    Expect(1, 67872, '\P{phoenician}', "");
    Expect(0, 67872, '\P{^phoenician}', "");
    Expect(1, 67871, '\p{ Phoenician}', "");
    Expect(0, 67871, '\p{^ Phoenician}', "");
    Expect(0, 67871, '\P{ Phoenician}', "");
    Expect(1, 67871, '\P{^ Phoenician}', "");
    Expect(0, 67872, '\p{ Phoenician}', "");
    Expect(1, 67872, '\p{^ Phoenician}', "");
    Expect(1, 67872, '\P{ Phoenician}', "");
    Expect(0, 67872, '\P{^ Phoenician}', "");
    Error('\p{:=-_Is_phoenician}');
    Error('\P{:=-_Is_phoenician}');
    Expect(1, 67871, '\p{isphoenician}', "");
    Expect(0, 67871, '\p{^isphoenician}', "");
    Expect(0, 67871, '\P{isphoenician}', "");
    Expect(1, 67871, '\P{^isphoenician}', "");
    Expect(0, 67872, '\p{isphoenician}', "");
    Expect(1, 67872, '\p{^isphoenician}', "");
    Expect(1, 67872, '\P{isphoenician}', "");
    Expect(0, 67872, '\P{^isphoenician}', "");
    Expect(1, 67871, '\p{_-Is_phoenician}', "");
    Expect(0, 67871, '\p{^_-Is_phoenician}', "");
    Expect(0, 67871, '\P{_-Is_phoenician}', "");
    Expect(1, 67871, '\P{^_-Is_phoenician}', "");
    Expect(0, 67872, '\p{_-Is_phoenician}', "");
    Expect(1, 67872, '\p{^_-Is_phoenician}', "");
    Expect(1, 67872, '\P{_-Is_phoenician}', "");
    Expect(0, 67872, '\P{^_-Is_phoenician}', "");
    Error('\p{	Phnx/a/}');
    Error('\P{	Phnx/a/}');
    Expect(1, 67871, '\p{phnx}', "");
    Expect(0, 67871, '\p{^phnx}', "");
    Expect(0, 67871, '\P{phnx}', "");
    Expect(1, 67871, '\P{^phnx}', "");
    Expect(0, 67872, '\p{phnx}', "");
    Expect(1, 67872, '\p{^phnx}', "");
    Expect(1, 67872, '\P{phnx}', "");
    Expect(0, 67872, '\P{^phnx}', "");
    Expect(1, 67871, '\p{ _PHNX}', "");
    Expect(0, 67871, '\p{^ _PHNX}', "");
    Expect(0, 67871, '\P{ _PHNX}', "");
    Expect(1, 67871, '\P{^ _PHNX}', "");
    Expect(0, 67872, '\p{ _PHNX}', "");
    Expect(1, 67872, '\p{^ _PHNX}', "");
    Expect(1, 67872, '\P{ _PHNX}', "");
    Expect(0, 67872, '\P{^ _PHNX}', "");
    Error('\p{-	is_PHNX:=}');
    Error('\P{-	is_PHNX:=}');
    Expect(1, 67871, '\p{isphnx}', "");
    Expect(0, 67871, '\p{^isphnx}', "");
    Expect(0, 67871, '\P{isphnx}', "");
    Expect(1, 67871, '\P{^isphnx}', "");
    Expect(0, 67872, '\p{isphnx}', "");
    Expect(1, 67872, '\p{^isphnx}', "");
    Expect(1, 67872, '\P{isphnx}', "");
    Expect(0, 67872, '\P{^isphnx}', "");
    Expect(1, 67871, '\p{-IS_Phnx}', "");
    Expect(0, 67871, '\p{^-IS_Phnx}', "");
    Expect(0, 67871, '\P{-IS_Phnx}', "");
    Expect(1, 67871, '\P{^-IS_Phnx}', "");
    Expect(0, 67872, '\p{-IS_Phnx}', "");
    Expect(1, 67872, '\p{^-IS_Phnx}', "");
    Expect(1, 67872, '\P{-IS_Phnx}', "");
    Expect(0, 67872, '\P{^-IS_Phnx}', "");
    Error('\p{ -Phonetic_EXTENSIONS/a/}');
    Error('\P{ -Phonetic_EXTENSIONS/a/}');
    Expect(1, 7551, '\p{phoneticextensions}', "");
    Expect(0, 7551, '\p{^phoneticextensions}', "");
    Expect(0, 7551, '\P{phoneticextensions}', "");
    Expect(1, 7551, '\P{^phoneticextensions}', "");
    Expect(0, 7552, '\p{phoneticextensions}', "");
    Expect(1, 7552, '\p{^phoneticextensions}', "");
    Expect(1, 7552, '\P{phoneticextensions}', "");
    Expect(0, 7552, '\P{^phoneticextensions}', "");
    Expect(1, 7551, '\p{	 Phonetic_Extensions}', "");
    Expect(0, 7551, '\p{^	 Phonetic_Extensions}', "");
    Expect(0, 7551, '\P{	 Phonetic_Extensions}', "");
    Expect(1, 7551, '\P{^	 Phonetic_Extensions}', "");
    Expect(0, 7552, '\p{	 Phonetic_Extensions}', "");
    Expect(1, 7552, '\p{^	 Phonetic_Extensions}', "");
    Expect(1, 7552, '\P{	 Phonetic_Extensions}', "");
    Expect(0, 7552, '\P{^	 Phonetic_Extensions}', "");
    Error('\p{	Is_Phonetic_extensions/a/}');
    Error('\P{	Is_Phonetic_extensions/a/}');
    Expect(1, 7551, '\p{isphoneticextensions}', "");
    Expect(0, 7551, '\p{^isphoneticextensions}', "");
    Expect(0, 7551, '\P{isphoneticextensions}', "");
    Expect(1, 7551, '\P{^isphoneticextensions}', "");
    Expect(0, 7552, '\p{isphoneticextensions}', "");
    Expect(1, 7552, '\p{^isphoneticextensions}', "");
    Expect(1, 7552, '\P{isphoneticextensions}', "");
    Expect(0, 7552, '\P{^isphoneticextensions}', "");
    Expect(1, 7551, '\p{-IS_Phonetic_EXTENSIONS}', "");
    Expect(0, 7551, '\p{^-IS_Phonetic_EXTENSIONS}', "");
    Expect(0, 7551, '\P{-IS_Phonetic_EXTENSIONS}', "");
    Expect(1, 7551, '\P{^-IS_Phonetic_EXTENSIONS}', "");
    Expect(0, 7552, '\p{-IS_Phonetic_EXTENSIONS}', "");
    Expect(1, 7552, '\p{^-IS_Phonetic_EXTENSIONS}', "");
    Expect(1, 7552, '\P{-IS_Phonetic_EXTENSIONS}', "");
    Expect(0, 7552, '\P{^-IS_Phonetic_EXTENSIONS}', "");
    Error('\p{:=_-IN_PHONETIC_Extensions}');
    Error('\P{:=_-IN_PHONETIC_Extensions}');
    Expect(1, 7551, '\p{inphoneticextensions}', "");
    Expect(0, 7551, '\p{^inphoneticextensions}', "");
    Expect(0, 7551, '\P{inphoneticextensions}', "");
    Expect(1, 7551, '\P{^inphoneticextensions}', "");
    Expect(0, 7552, '\p{inphoneticextensions}', "");
    Expect(1, 7552, '\p{^inphoneticextensions}', "");
    Expect(1, 7552, '\P{inphoneticextensions}', "");
    Expect(0, 7552, '\P{^inphoneticextensions}', "");
    Expect(1, 7551, '\p{--in_PHONETIC_EXTENSIONS}', "");
    Expect(0, 7551, '\p{^--in_PHONETIC_EXTENSIONS}', "");
    Expect(0, 7551, '\P{--in_PHONETIC_EXTENSIONS}', "");
    Expect(1, 7551, '\P{^--in_PHONETIC_EXTENSIONS}', "");
    Expect(0, 7552, '\p{--in_PHONETIC_EXTENSIONS}', "");
    Expect(1, 7552, '\p{^--in_PHONETIC_EXTENSIONS}', "");
    Expect(1, 7552, '\P{--in_PHONETIC_EXTENSIONS}', "");
    Expect(0, 7552, '\P{^--in_PHONETIC_EXTENSIONS}', "");
    Error('\p{/a/- Phonetic_Ext}');
    Error('\P{/a/- Phonetic_Ext}');
    Expect(1, 7551, '\p{phoneticext}', "");
    Expect(0, 7551, '\p{^phoneticext}', "");
    Expect(0, 7551, '\P{phoneticext}', "");
    Expect(1, 7551, '\P{^phoneticext}', "");
    Expect(0, 7552, '\p{phoneticext}', "");
    Expect(1, 7552, '\p{^phoneticext}', "");
    Expect(1, 7552, '\P{phoneticext}', "");
    Expect(0, 7552, '\P{^phoneticext}', "");
    Expect(1, 7551, '\p{_Phonetic_EXT}', "");
    Expect(0, 7551, '\p{^_Phonetic_EXT}', "");
    Expect(0, 7551, '\P{_Phonetic_EXT}', "");
    Expect(1, 7551, '\P{^_Phonetic_EXT}', "");
    Expect(0, 7552, '\p{_Phonetic_EXT}', "");
    Expect(1, 7552, '\p{^_Phonetic_EXT}', "");
    Expect(1, 7552, '\P{_Phonetic_EXT}', "");
    Expect(0, 7552, '\P{^_Phonetic_EXT}', "");
    Error('\p{ 	is_Phonetic_Ext:=}');
    Error('\P{ 	is_Phonetic_Ext:=}');
    Expect(1, 7551, '\p{isphoneticext}', "");
    Expect(0, 7551, '\p{^isphoneticext}', "");
    Expect(0, 7551, '\P{isphoneticext}', "");
    Expect(1, 7551, '\P{^isphoneticext}', "");
    Expect(0, 7552, '\p{isphoneticext}', "");
    Expect(1, 7552, '\p{^isphoneticext}', "");
    Expect(1, 7552, '\P{isphoneticext}', "");
    Expect(0, 7552, '\P{^isphoneticext}', "");
    Expect(1, 7551, '\p{ IS_PHONETIC_Ext}', "");
    Expect(0, 7551, '\p{^ IS_PHONETIC_Ext}', "");
    Expect(0, 7551, '\P{ IS_PHONETIC_Ext}', "");
    Expect(1, 7551, '\P{^ IS_PHONETIC_Ext}', "");
    Expect(0, 7552, '\p{ IS_PHONETIC_Ext}', "");
    Expect(1, 7552, '\p{^ IS_PHONETIC_Ext}', "");
    Expect(1, 7552, '\P{ IS_PHONETIC_Ext}', "");
    Expect(0, 7552, '\P{^ IS_PHONETIC_Ext}', "");
    Error('\p{_:=IN_Phonetic_Ext}');
    Error('\P{_:=IN_Phonetic_Ext}');
    Expect(1, 7551, '\p{inphoneticext}', "");
    Expect(0, 7551, '\p{^inphoneticext}', "");
    Expect(0, 7551, '\P{inphoneticext}', "");
    Expect(1, 7551, '\P{^inphoneticext}', "");
    Expect(0, 7552, '\p{inphoneticext}', "");
    Expect(1, 7552, '\p{^inphoneticext}', "");
    Expect(1, 7552, '\P{inphoneticext}', "");
    Expect(0, 7552, '\P{^inphoneticext}', "");
    Expect(1, 7551, '\p{IN_PHONETIC_EXT}', "");
    Expect(0, 7551, '\p{^IN_PHONETIC_EXT}', "");
    Expect(0, 7551, '\P{IN_PHONETIC_EXT}', "");
    Expect(1, 7551, '\P{^IN_PHONETIC_EXT}', "");
    Expect(0, 7552, '\p{IN_PHONETIC_EXT}', "");
    Expect(1, 7552, '\p{^IN_PHONETIC_EXT}', "");
    Expect(1, 7552, '\P{IN_PHONETIC_EXT}', "");
    Expect(0, 7552, '\P{^IN_PHONETIC_EXT}', "");
    Error('\p{_	Phonetic_EXTENSIONS_supplement/a/}');
    Error('\P{_	Phonetic_EXTENSIONS_supplement/a/}');
    Expect(1, 7615, '\p{phoneticextensionssupplement}', "");
    Expect(0, 7615, '\p{^phoneticextensionssupplement}', "");
    Expect(0, 7615, '\P{phoneticextensionssupplement}', "");
    Expect(1, 7615, '\P{^phoneticextensionssupplement}', "");
    Expect(0, 7616, '\p{phoneticextensionssupplement}', "");
    Expect(1, 7616, '\p{^phoneticextensionssupplement}', "");
    Expect(1, 7616, '\P{phoneticextensionssupplement}', "");
    Expect(0, 7616, '\P{^phoneticextensionssupplement}', "");
    Expect(1, 7615, '\p{Phonetic_extensions_SUPPLEMENT}', "");
    Expect(0, 7615, '\p{^Phonetic_extensions_SUPPLEMENT}', "");
    Expect(0, 7615, '\P{Phonetic_extensions_SUPPLEMENT}', "");
    Expect(1, 7615, '\P{^Phonetic_extensions_SUPPLEMENT}', "");
    Expect(0, 7616, '\p{Phonetic_extensions_SUPPLEMENT}', "");
    Expect(1, 7616, '\p{^Phonetic_extensions_SUPPLEMENT}', "");
    Expect(1, 7616, '\P{Phonetic_extensions_SUPPLEMENT}', "");
    Expect(0, 7616, '\P{^Phonetic_extensions_SUPPLEMENT}', "");
    Error('\p{-_Is_phonetic_extensions_supplement:=}');
    Error('\P{-_Is_phonetic_extensions_supplement:=}');
    Expect(1, 7615, '\p{isphoneticextensionssupplement}', "");
    Expect(0, 7615, '\p{^isphoneticextensionssupplement}', "");
    Expect(0, 7615, '\P{isphoneticextensionssupplement}', "");
    Expect(1, 7615, '\P{^isphoneticextensionssupplement}', "");
    Expect(0, 7616, '\p{isphoneticextensionssupplement}', "");
    Expect(1, 7616, '\p{^isphoneticextensionssupplement}', "");
    Expect(1, 7616, '\P{isphoneticextensionssupplement}', "");
    Expect(0, 7616, '\P{^isphoneticextensionssupplement}', "");
    Expect(1, 7615, '\p{ 	Is_Phonetic_EXTENSIONS_Supplement}', "");
    Expect(0, 7615, '\p{^ 	Is_Phonetic_EXTENSIONS_Supplement}', "");
    Expect(0, 7615, '\P{ 	Is_Phonetic_EXTENSIONS_Supplement}', "");
    Expect(1, 7615, '\P{^ 	Is_Phonetic_EXTENSIONS_Supplement}', "");
    Expect(0, 7616, '\p{ 	Is_Phonetic_EXTENSIONS_Supplement}', "");
    Expect(1, 7616, '\p{^ 	Is_Phonetic_EXTENSIONS_Supplement}', "");
    Expect(1, 7616, '\P{ 	Is_Phonetic_EXTENSIONS_Supplement}', "");
    Expect(0, 7616, '\P{^ 	Is_Phonetic_EXTENSIONS_Supplement}', "");
    Error('\p{--In_Phonetic_extensions_Supplement/a/}');
    Error('\P{--In_Phonetic_extensions_Supplement/a/}');
    Expect(1, 7615, '\p{inphoneticextensionssupplement}', "");
    Expect(0, 7615, '\p{^inphoneticextensionssupplement}', "");
    Expect(0, 7615, '\P{inphoneticextensionssupplement}', "");
    Expect(1, 7615, '\P{^inphoneticextensionssupplement}', "");
    Expect(0, 7616, '\p{inphoneticextensionssupplement}', "");
    Expect(1, 7616, '\p{^inphoneticextensionssupplement}', "");
    Expect(1, 7616, '\P{inphoneticextensionssupplement}', "");
    Expect(0, 7616, '\P{^inphoneticextensionssupplement}', "");
    Expect(1, 7615, '\p{_-In_PHONETIC_Extensions_SUPPLEMENT}', "");
    Expect(0, 7615, '\p{^_-In_PHONETIC_Extensions_SUPPLEMENT}', "");
    Expect(0, 7615, '\P{_-In_PHONETIC_Extensions_SUPPLEMENT}', "");
    Expect(1, 7615, '\P{^_-In_PHONETIC_Extensions_SUPPLEMENT}', "");
    Expect(0, 7616, '\p{_-In_PHONETIC_Extensions_SUPPLEMENT}', "");
    Expect(1, 7616, '\p{^_-In_PHONETIC_Extensions_SUPPLEMENT}', "");
    Expect(1, 7616, '\P{_-In_PHONETIC_Extensions_SUPPLEMENT}', "");
    Expect(0, 7616, '\P{^_-In_PHONETIC_Extensions_SUPPLEMENT}', "");
    Error('\p{ /a/Phonetic_Ext_Sup}');
    Error('\P{ /a/Phonetic_Ext_Sup}');
    Expect(1, 7615, '\p{phoneticextsup}', "");
    Expect(0, 7615, '\p{^phoneticextsup}', "");
    Expect(0, 7615, '\P{phoneticextsup}', "");
    Expect(1, 7615, '\P{^phoneticextsup}', "");
    Expect(0, 7616, '\p{phoneticextsup}', "");
    Expect(1, 7616, '\p{^phoneticextsup}', "");
    Expect(1, 7616, '\P{phoneticextsup}', "");
    Expect(0, 7616, '\P{^phoneticextsup}', "");
    Expect(1, 7615, '\p{-Phonetic_EXT_Sup}', "");
    Expect(0, 7615, '\p{^-Phonetic_EXT_Sup}', "");
    Expect(0, 7615, '\P{-Phonetic_EXT_Sup}', "");
    Expect(1, 7615, '\P{^-Phonetic_EXT_Sup}', "");
    Expect(0, 7616, '\p{-Phonetic_EXT_Sup}', "");
    Expect(1, 7616, '\p{^-Phonetic_EXT_Sup}', "");
    Expect(1, 7616, '\P{-Phonetic_EXT_Sup}', "");
    Expect(0, 7616, '\P{^-Phonetic_EXT_Sup}', "");
    Error('\p{/a/IS_Phonetic_Ext_Sup}');
    Error('\P{/a/IS_Phonetic_Ext_Sup}');
    Expect(1, 7615, '\p{isphoneticextsup}', "");
    Expect(0, 7615, '\p{^isphoneticextsup}', "");
    Expect(0, 7615, '\P{isphoneticextsup}', "");
    Expect(1, 7615, '\P{^isphoneticextsup}', "");
    Expect(0, 7616, '\p{isphoneticextsup}', "");
    Expect(1, 7616, '\p{^isphoneticextsup}', "");
    Expect(1, 7616, '\P{isphoneticextsup}', "");
    Expect(0, 7616, '\P{^isphoneticextsup}', "");
    Expect(1, 7615, '\p{ _IS_Phonetic_ext_Sup}', "");
    Expect(0, 7615, '\p{^ _IS_Phonetic_ext_Sup}', "");
    Expect(0, 7615, '\P{ _IS_Phonetic_ext_Sup}', "");
    Expect(1, 7615, '\P{^ _IS_Phonetic_ext_Sup}', "");
    Expect(0, 7616, '\p{ _IS_Phonetic_ext_Sup}', "");
    Expect(1, 7616, '\p{^ _IS_Phonetic_ext_Sup}', "");
    Expect(1, 7616, '\P{ _IS_Phonetic_ext_Sup}', "");
    Expect(0, 7616, '\P{^ _IS_Phonetic_ext_Sup}', "");
    Error('\p{:=_IN_phonetic_ext_SUP}');
    Error('\P{:=_IN_phonetic_ext_SUP}');
    Expect(1, 7615, '\p{inphoneticextsup}', "");
    Expect(0, 7615, '\p{^inphoneticextsup}', "");
    Expect(0, 7615, '\P{inphoneticextsup}', "");
    Expect(1, 7615, '\P{^inphoneticextsup}', "");
    Expect(0, 7616, '\p{inphoneticextsup}', "");
    Expect(1, 7616, '\p{^inphoneticextsup}', "");
    Expect(1, 7616, '\P{inphoneticextsup}', "");
    Expect(0, 7616, '\P{^inphoneticextsup}', "");
    Expect(1, 7615, '\p{  In_Phonetic_Ext_SUP}', "");
    Expect(0, 7615, '\p{^  In_Phonetic_Ext_SUP}', "");
    Expect(0, 7615, '\P{  In_Phonetic_Ext_SUP}', "");
    Expect(1, 7615, '\P{^  In_Phonetic_Ext_SUP}', "");
    Expect(0, 7616, '\p{  In_Phonetic_Ext_SUP}', "");
    Expect(1, 7616, '\p{^  In_Phonetic_Ext_SUP}', "");
    Expect(1, 7616, '\P{  In_Phonetic_Ext_SUP}', "");
    Expect(0, 7616, '\P{^  In_Phonetic_Ext_SUP}', "");
    Error('\p{:=	-Playing_Cards}');
    Error('\P{:=	-Playing_Cards}');
    Expect(1, 127231, '\p{playingcards}', "");
    Expect(0, 127231, '\p{^playingcards}', "");
    Expect(0, 127231, '\P{playingcards}', "");
    Expect(1, 127231, '\P{^playingcards}', "");
    Expect(0, 127232, '\p{playingcards}', "");
    Expect(1, 127232, '\p{^playingcards}', "");
    Expect(1, 127232, '\P{playingcards}', "");
    Expect(0, 127232, '\P{^playingcards}', "");
    Expect(1, 127231, '\p{_ playing_Cards}', "");
    Expect(0, 127231, '\p{^_ playing_Cards}', "");
    Expect(0, 127231, '\P{_ playing_Cards}', "");
    Expect(1, 127231, '\P{^_ playing_Cards}', "");
    Expect(0, 127232, '\p{_ playing_Cards}', "");
    Expect(1, 127232, '\p{^_ playing_Cards}', "");
    Expect(1, 127232, '\P{_ playing_Cards}', "");
    Expect(0, 127232, '\P{^_ playing_Cards}', "");
    Error('\p{ /a/is_PLAYING_cards}');
    Error('\P{ /a/is_PLAYING_cards}');
    Expect(1, 127231, '\p{isplayingcards}', "");
    Expect(0, 127231, '\p{^isplayingcards}', "");
    Expect(0, 127231, '\P{isplayingcards}', "");
    Expect(1, 127231, '\P{^isplayingcards}', "");
    Expect(0, 127232, '\p{isplayingcards}', "");
    Expect(1, 127232, '\p{^isplayingcards}', "");
    Expect(1, 127232, '\P{isplayingcards}', "");
    Expect(0, 127232, '\P{^isplayingcards}', "");
    Expect(1, 127231, '\p{		is_Playing_Cards}', "");
    Expect(0, 127231, '\p{^		is_Playing_Cards}', "");
    Expect(0, 127231, '\P{		is_Playing_Cards}', "");
    Expect(1, 127231, '\P{^		is_Playing_Cards}', "");
    Expect(0, 127232, '\p{		is_Playing_Cards}', "");
    Expect(1, 127232, '\p{^		is_Playing_Cards}', "");
    Expect(1, 127232, '\P{		is_Playing_Cards}', "");
    Expect(0, 127232, '\P{^		is_Playing_Cards}', "");
    Error('\p{:=-_In_playing_cards}');
    Error('\P{:=-_In_playing_cards}');
    Expect(1, 127231, '\p{inplayingcards}', "");
    Expect(0, 127231, '\p{^inplayingcards}', "");
    Expect(0, 127231, '\P{inplayingcards}', "");
    Expect(1, 127231, '\P{^inplayingcards}', "");
    Expect(0, 127232, '\p{inplayingcards}', "");
    Expect(1, 127232, '\p{^inplayingcards}', "");
    Expect(1, 127232, '\P{inplayingcards}', "");
    Expect(0, 127232, '\P{^inplayingcards}', "");
    Expect(1, 127231, '\p{  IN_Playing_cards}', "");
    Expect(0, 127231, '\p{^  IN_Playing_cards}', "");
    Expect(0, 127231, '\P{  IN_Playing_cards}', "");
    Expect(1, 127231, '\P{^  IN_Playing_cards}', "");
    Expect(0, 127232, '\p{  IN_Playing_cards}', "");
    Expect(1, 127232, '\p{^  IN_Playing_cards}', "");
    Expect(1, 127232, '\P{  IN_Playing_cards}', "");
    Expect(0, 127232, '\P{^  IN_Playing_cards}', "");
    Error('\p{-_posixalnum/a/}');
    Error('\P{-_posixalnum/a/}');
    Expect(1, 122, '\p{posixalnum}', "");
    Expect(0, 122, '\p{^posixalnum}', "");
    Expect(0, 122, '\P{posixalnum}', "");
    Expect(1, 122, '\P{^posixalnum}', "");
    Expect(0, 123, '\p{posixalnum}', "");
    Expect(1, 123, '\p{^posixalnum}', "");
    Expect(1, 123, '\P{posixalnum}', "");
    Expect(0, 123, '\P{^posixalnum}', "");
    Expect(1, 122, '\p{__PosixAlnum}', "");
    Expect(0, 122, '\p{^__PosixAlnum}', "");
    Expect(0, 122, '\P{__PosixAlnum}', "");
    Expect(1, 122, '\P{^__PosixAlnum}', "");
    Expect(0, 123, '\p{__PosixAlnum}', "");
    Expect(1, 123, '\p{^__PosixAlnum}', "");
    Expect(1, 123, '\P{__PosixAlnum}', "");
    Expect(0, 123, '\P{^__PosixAlnum}', "");
    Error('\p{_ is_PosixAlnum:=}');
    Error('\P{_ is_PosixAlnum:=}');
    Expect(1, 122, '\p{isposixalnum}', "");
    Expect(0, 122, '\p{^isposixalnum}', "");
    Expect(0, 122, '\P{isposixalnum}', "");
    Expect(1, 122, '\P{^isposixalnum}', "");
    Expect(0, 123, '\p{isposixalnum}', "");
    Expect(1, 123, '\p{^isposixalnum}', "");
    Expect(1, 123, '\P{isposixalnum}', "");
    Expect(0, 123, '\P{^isposixalnum}', "");
    Expect(1, 122, '\p{ 	is_PosixAlnum}', "");
    Expect(0, 122, '\p{^ 	is_PosixAlnum}', "");
    Expect(0, 122, '\P{ 	is_PosixAlnum}', "");
    Expect(1, 122, '\P{^ 	is_PosixAlnum}', "");
    Expect(0, 123, '\p{ 	is_PosixAlnum}', "");
    Expect(1, 123, '\p{^ 	is_PosixAlnum}', "");
    Expect(1, 123, '\P{ 	is_PosixAlnum}', "");
    Expect(0, 123, '\P{^ 	is_PosixAlnum}', "");
    Error('\p{:=- posixalpha}');
    Error('\P{:=- posixalpha}');
    Expect(1, 122, '\p{posixalpha}', "");
    Expect(0, 122, '\p{^posixalpha}', "");
    Expect(0, 122, '\P{posixalpha}', "");
    Expect(1, 122, '\P{^posixalpha}', "");
    Expect(0, 123, '\p{posixalpha}', "");
    Expect(1, 123, '\p{^posixalpha}', "");
    Expect(1, 123, '\P{posixalpha}', "");
    Expect(0, 123, '\P{^posixalpha}', "");
    Expect(1, 122, '\p{  PosixAlpha}', "");
    Expect(0, 122, '\p{^  PosixAlpha}', "");
    Expect(0, 122, '\P{  PosixAlpha}', "");
    Expect(1, 122, '\P{^  PosixAlpha}', "");
    Expect(0, 123, '\p{  PosixAlpha}', "");
    Expect(1, 123, '\p{^  PosixAlpha}', "");
    Expect(1, 123, '\P{  PosixAlpha}', "");
    Expect(0, 123, '\P{^  PosixAlpha}', "");
    Error('\p{:=-	Is_POSIXALPHA}');
    Error('\P{:=-	Is_POSIXALPHA}');
    Expect(1, 122, '\p{isposixalpha}', "");
    Expect(0, 122, '\p{^isposixalpha}', "");
    Expect(0, 122, '\P{isposixalpha}', "");
    Expect(1, 122, '\P{^isposixalpha}', "");
    Expect(0, 123, '\p{isposixalpha}', "");
    Expect(1, 123, '\p{^isposixalpha}', "");
    Expect(1, 123, '\P{isposixalpha}', "");
    Expect(0, 123, '\P{^isposixalpha}', "");
    Expect(1, 122, '\p{_-Is_posixalpha}', "");
    Expect(0, 122, '\p{^_-Is_posixalpha}', "");
    Expect(0, 122, '\P{_-Is_posixalpha}', "");
    Expect(1, 122, '\P{^_-Is_posixalpha}', "");
    Expect(0, 123, '\p{_-Is_posixalpha}', "");
    Expect(1, 123, '\p{^_-Is_posixalpha}', "");
    Expect(1, 123, '\P{_-Is_posixalpha}', "");
    Expect(0, 123, '\P{^_-Is_posixalpha}', "");
    Error('\p{:=	 PosixBlank}');
    Error('\P{:=	 PosixBlank}');
    Expect(1, 32, '\p{posixblank}', "");
    Expect(0, 32, '\p{^posixblank}', "");
    Expect(0, 32, '\P{posixblank}', "");
    Expect(1, 32, '\P{^posixblank}', "");
    Expect(0, 33, '\p{posixblank}', "");
    Expect(1, 33, '\p{^posixblank}', "");
    Expect(1, 33, '\P{posixblank}', "");
    Expect(0, 33, '\P{^posixblank}', "");
    Expect(1, 32, '\p{- PosixBlank}', "");
    Expect(0, 32, '\p{^- PosixBlank}', "");
    Expect(0, 32, '\P{- PosixBlank}', "");
    Expect(1, 32, '\P{^- PosixBlank}', "");
    Expect(0, 33, '\p{- PosixBlank}', "");
    Expect(1, 33, '\p{^- PosixBlank}', "");
    Expect(1, 33, '\P{- PosixBlank}', "");
    Expect(0, 33, '\P{^- PosixBlank}', "");
    Error('\p{/a/is_posixblank}');
    Error('\P{/a/is_posixblank}');
    Expect(1, 32, '\p{isposixblank}', "");
    Expect(0, 32, '\p{^isposixblank}', "");
    Expect(0, 32, '\P{isposixblank}', "");
    Expect(1, 32, '\P{^isposixblank}', "");
    Expect(0, 33, '\p{isposixblank}', "");
    Expect(1, 33, '\p{^isposixblank}', "");
    Expect(1, 33, '\P{isposixblank}', "");
    Expect(0, 33, '\P{^isposixblank}', "");
    Expect(1, 32, '\p{-_is_PosixBlank}', "");
    Expect(0, 32, '\p{^-_is_PosixBlank}', "");
    Expect(0, 32, '\P{-_is_PosixBlank}', "");
    Expect(1, 32, '\P{^-_is_PosixBlank}', "");
    Expect(0, 33, '\p{-_is_PosixBlank}', "");
    Expect(1, 33, '\p{^-_is_PosixBlank}', "");
    Expect(1, 33, '\P{-_is_PosixBlank}', "");
    Expect(0, 33, '\P{^-_is_PosixBlank}', "");
    Error('\p{/a/ _posixcntrl}');
    Error('\P{/a/ _posixcntrl}');
    Expect(1, 127, '\p{posixcntrl}', "");
    Expect(0, 127, '\p{^posixcntrl}', "");
    Expect(0, 127, '\P{posixcntrl}', "");
    Expect(1, 127, '\P{^posixcntrl}', "");
    Expect(0, 128, '\p{posixcntrl}', "");
    Expect(1, 128, '\p{^posixcntrl}', "");
    Expect(1, 128, '\P{posixcntrl}', "");
    Expect(0, 128, '\P{^posixcntrl}', "");
    Expect(1, 127, '\p{	-POSIXCNTRL}', "");
    Expect(0, 127, '\p{^	-POSIXCNTRL}', "");
    Expect(0, 127, '\P{	-POSIXCNTRL}', "");
    Expect(1, 127, '\P{^	-POSIXCNTRL}', "");
    Expect(0, 128, '\p{	-POSIXCNTRL}', "");
    Expect(1, 128, '\p{^	-POSIXCNTRL}', "");
    Expect(1, 128, '\P{	-POSIXCNTRL}', "");
    Expect(0, 128, '\P{^	-POSIXCNTRL}', "");
    Error('\p{_ Is_PosixCntrl:=}');
    Error('\P{_ Is_PosixCntrl:=}');
    Expect(1, 127, '\p{isposixcntrl}', "");
    Expect(0, 127, '\p{^isposixcntrl}', "");
    Expect(0, 127, '\P{isposixcntrl}', "");
    Expect(1, 127, '\P{^isposixcntrl}', "");
    Expect(0, 128, '\p{isposixcntrl}', "");
    Expect(1, 128, '\p{^isposixcntrl}', "");
    Expect(1, 128, '\P{isposixcntrl}', "");
    Expect(0, 128, '\P{^isposixcntrl}', "");
    Expect(1, 127, '\p{	-IS_posixcntrl}', "");
    Expect(0, 127, '\p{^	-IS_posixcntrl}', "");
    Expect(0, 127, '\P{	-IS_posixcntrl}', "");
    Expect(1, 127, '\P{^	-IS_posixcntrl}', "");
    Expect(0, 128, '\p{	-IS_posixcntrl}', "");
    Expect(1, 128, '\p{^	-IS_posixcntrl}', "");
    Expect(1, 128, '\P{	-IS_posixcntrl}', "");
    Expect(0, 128, '\P{^	-IS_posixcntrl}', "");
    Error('\p{	 PosixDigit/a/}');
    Error('\P{	 PosixDigit/a/}');
    Expect(1, 57, '\p{posixdigit}', "");
    Expect(0, 57, '\p{^posixdigit}', "");
    Expect(0, 57, '\P{posixdigit}', "");
    Expect(1, 57, '\P{^posixdigit}', "");
    Expect(0, 58, '\p{posixdigit}', "");
    Expect(1, 58, '\p{^posixdigit}', "");
    Expect(1, 58, '\P{posixdigit}', "");
    Expect(0, 58, '\P{^posixdigit}', "");
    Expect(1, 57, '\p{ posixdigit}', "");
    Expect(0, 57, '\p{^ posixdigit}', "");
    Expect(0, 57, '\P{ posixdigit}', "");
    Expect(1, 57, '\P{^ posixdigit}', "");
    Expect(0, 58, '\p{ posixdigit}', "");
    Expect(1, 58, '\p{^ posixdigit}', "");
    Expect(1, 58, '\P{ posixdigit}', "");
    Expect(0, 58, '\P{^ posixdigit}', "");
    Error('\p{-Is_posixdigit/a/}');
    Error('\P{-Is_posixdigit/a/}');
    Expect(1, 57, '\p{isposixdigit}', "");
    Expect(0, 57, '\p{^isposixdigit}', "");
    Expect(0, 57, '\P{isposixdigit}', "");
    Expect(1, 57, '\P{^isposixdigit}', "");
    Expect(0, 58, '\p{isposixdigit}', "");
    Expect(1, 58, '\p{^isposixdigit}', "");
    Expect(1, 58, '\P{isposixdigit}', "");
    Expect(0, 58, '\P{^isposixdigit}', "");
    Expect(1, 57, '\p{_	Is_PosixDigit}', "");
    Expect(0, 57, '\p{^_	Is_PosixDigit}', "");
    Expect(0, 57, '\P{_	Is_PosixDigit}', "");
    Expect(1, 57, '\P{^_	Is_PosixDigit}', "");
    Expect(0, 58, '\p{_	Is_PosixDigit}', "");
    Expect(1, 58, '\p{^_	Is_PosixDigit}', "");
    Expect(1, 58, '\P{_	Is_PosixDigit}', "");
    Expect(0, 58, '\P{^_	Is_PosixDigit}', "");
    Error('\p{- PosixGraph:=}');
    Error('\P{- PosixGraph:=}');
    Expect(1, 126, '\p{posixgraph}', "");
    Expect(0, 126, '\p{^posixgraph}', "");
    Expect(0, 126, '\P{posixgraph}', "");
    Expect(1, 126, '\P{^posixgraph}', "");
    Expect(0, 127, '\p{posixgraph}', "");
    Expect(1, 127, '\p{^posixgraph}', "");
    Expect(1, 127, '\P{posixgraph}', "");
    Expect(0, 127, '\P{^posixgraph}', "");
    Expect(1, 126, '\p{__PosixGraph}', "");
    Expect(0, 126, '\p{^__PosixGraph}', "");
    Expect(0, 126, '\P{__PosixGraph}', "");
    Expect(1, 126, '\P{^__PosixGraph}', "");
    Expect(0, 127, '\p{__PosixGraph}', "");
    Expect(1, 127, '\p{^__PosixGraph}', "");
    Expect(1, 127, '\P{__PosixGraph}', "");
    Expect(0, 127, '\P{^__PosixGraph}', "");
    Error('\p{	:=Is_POSIXGRAPH}');
    Error('\P{	:=Is_POSIXGRAPH}');
    Expect(1, 126, '\p{isposixgraph}', "");
    Expect(0, 126, '\p{^isposixgraph}', "");
    Expect(0, 126, '\P{isposixgraph}', "");
    Expect(1, 126, '\P{^isposixgraph}', "");
    Expect(0, 127, '\p{isposixgraph}', "");
    Expect(1, 127, '\p{^isposixgraph}', "");
    Expect(1, 127, '\P{isposixgraph}', "");
    Expect(0, 127, '\P{^isposixgraph}', "");
    Expect(1, 126, '\p{_	IS_posixgraph}', "");
    Expect(0, 126, '\p{^_	IS_posixgraph}', "");
    Expect(0, 126, '\P{_	IS_posixgraph}', "");
    Expect(1, 126, '\P{^_	IS_posixgraph}', "");
    Expect(0, 127, '\p{_	IS_posixgraph}', "");
    Expect(1, 127, '\p{^_	IS_posixgraph}', "");
    Expect(1, 127, '\P{_	IS_posixgraph}', "");
    Expect(0, 127, '\P{^_	IS_posixgraph}', "");
    Error('\p{/a/_ PosixLower}');
    Error('\P{/a/_ PosixLower}');
    Expect(1, 122, '\p{posixlower}', "");
    Expect(0, 122, '\p{^posixlower}', "");
    Expect(0, 122, '\P{posixlower}', "");
    Expect(1, 122, '\P{^posixlower}', "");
    Expect(0, 123, '\p{posixlower}', "");
    Expect(1, 123, '\p{^posixlower}', "");
    Expect(1, 123, '\P{posixlower}', "");
    Expect(0, 123, '\P{^posixlower}', "");
    Expect(1, 122, '\p{	PosixLower}', "");
    Expect(0, 122, '\p{^	PosixLower}', "");
    Expect(0, 122, '\P{	PosixLower}', "");
    Expect(1, 122, '\P{^	PosixLower}', "");
    Expect(0, 123, '\p{	PosixLower}', "");
    Expect(1, 123, '\p{^	PosixLower}', "");
    Expect(1, 123, '\P{	PosixLower}', "");
    Expect(0, 123, '\P{^	PosixLower}', "");
    Error('\p{ :=Is_posixlower}');
    Error('\P{ :=Is_posixlower}');
    Expect(1, 122, '\p{isposixlower}', "");
    Expect(0, 122, '\p{^isposixlower}', "");
    Expect(0, 122, '\P{isposixlower}', "");
    Expect(1, 122, '\P{^isposixlower}', "");
    Expect(0, 123, '\p{isposixlower}', "");
    Expect(1, 123, '\p{^isposixlower}', "");
    Expect(1, 123, '\P{isposixlower}', "");
    Expect(0, 123, '\P{^isposixlower}', "");
    Expect(1, 122, '\p{	is_posixlower}', "");
    Expect(0, 122, '\p{^	is_posixlower}', "");
    Expect(0, 122, '\P{	is_posixlower}', "");
    Expect(1, 122, '\P{^	is_posixlower}', "");
    Expect(0, 123, '\p{	is_posixlower}', "");
    Expect(1, 123, '\p{^	is_posixlower}', "");
    Expect(1, 123, '\P{	is_posixlower}', "");
    Expect(0, 123, '\P{^	is_posixlower}', "");
    Error('\p{:=- PosixPrint}');
    Error('\P{:=- PosixPrint}');
    Expect(1, 126, '\p{posixprint}', "");
    Expect(0, 126, '\p{^posixprint}', "");
    Expect(0, 126, '\P{posixprint}', "");
    Expect(1, 126, '\P{^posixprint}', "");
    Expect(0, 127, '\p{posixprint}', "");
    Expect(1, 127, '\p{^posixprint}', "");
    Expect(1, 127, '\P{posixprint}', "");
    Expect(0, 127, '\P{^posixprint}', "");
    Expect(1, 126, '\p{ -posixprint}', "");
    Expect(0, 126, '\p{^ -posixprint}', "");
    Expect(0, 126, '\P{ -posixprint}', "");
    Expect(1, 126, '\P{^ -posixprint}', "");
    Expect(0, 127, '\p{ -posixprint}', "");
    Expect(1, 127, '\p{^ -posixprint}', "");
    Expect(1, 127, '\P{ -posixprint}', "");
    Expect(0, 127, '\P{^ -posixprint}', "");
    Error('\p{	/a/Is_POSIXPRINT}');
    Error('\P{	/a/Is_POSIXPRINT}');
    Expect(1, 126, '\p{isposixprint}', "");
    Expect(0, 126, '\p{^isposixprint}', "");
    Expect(0, 126, '\P{isposixprint}', "");
    Expect(1, 126, '\P{^isposixprint}', "");
    Expect(0, 127, '\p{isposixprint}', "");
    Expect(1, 127, '\p{^isposixprint}', "");
    Expect(1, 127, '\P{isposixprint}', "");
    Expect(0, 127, '\P{^isposixprint}', "");
    Expect(1, 126, '\p{ 	IS_POSIXPRINT}', "");
    Expect(0, 126, '\p{^ 	IS_POSIXPRINT}', "");
    Expect(0, 126, '\P{ 	IS_POSIXPRINT}', "");
    Expect(1, 126, '\P{^ 	IS_POSIXPRINT}', "");
    Expect(0, 127, '\p{ 	IS_POSIXPRINT}', "");
    Expect(1, 127, '\p{^ 	IS_POSIXPRINT}', "");
    Expect(1, 127, '\P{ 	IS_POSIXPRINT}', "");
    Expect(0, 127, '\P{^ 	IS_POSIXPRINT}', "");
    Error('\p{:=-PosixPunct}');
    Error('\P{:=-PosixPunct}');
    Expect(1, 126, '\p{posixpunct}', "");
    Expect(0, 126, '\p{^posixpunct}', "");
    Expect(0, 126, '\P{posixpunct}', "");
    Expect(1, 126, '\P{^posixpunct}', "");
    Expect(0, 127, '\p{posixpunct}', "");
    Expect(1, 127, '\p{^posixpunct}', "");
    Expect(1, 127, '\P{posixpunct}', "");
    Expect(0, 127, '\P{^posixpunct}', "");
    Expect(1, 126, '\p{-	PosixPunct}', "");
    Expect(0, 126, '\p{^-	PosixPunct}', "");
    Expect(0, 126, '\P{-	PosixPunct}', "");
    Expect(1, 126, '\P{^-	PosixPunct}', "");
    Expect(0, 127, '\p{-	PosixPunct}', "");
    Expect(1, 127, '\p{^-	PosixPunct}', "");
    Expect(1, 127, '\P{-	PosixPunct}', "");
    Expect(0, 127, '\P{^-	PosixPunct}', "");
    Error('\p{-:=Is_PosixPunct}');
    Error('\P{-:=Is_PosixPunct}');
    Expect(1, 126, '\p{isposixpunct}', "");
    Expect(0, 126, '\p{^isposixpunct}', "");
    Expect(0, 126, '\P{isposixpunct}', "");
    Expect(1, 126, '\P{^isposixpunct}', "");
    Expect(0, 127, '\p{isposixpunct}', "");
    Expect(1, 127, '\p{^isposixpunct}', "");
    Expect(1, 127, '\P{isposixpunct}', "");
    Expect(0, 127, '\P{^isposixpunct}', "");
    Expect(1, 126, '\p{ 	IS_PosixPunct}', "");
    Expect(0, 126, '\p{^ 	IS_PosixPunct}', "");
    Expect(0, 126, '\P{ 	IS_PosixPunct}', "");
    Expect(1, 126, '\P{^ 	IS_PosixPunct}', "");
    Expect(0, 127, '\p{ 	IS_PosixPunct}', "");
    Expect(1, 127, '\p{^ 	IS_PosixPunct}', "");
    Expect(1, 127, '\P{ 	IS_PosixPunct}', "");
    Expect(0, 127, '\P{^ 	IS_PosixPunct}', "");
    Error('\p{	:=PosixSpace}');
    Error('\P{	:=PosixSpace}');
    Expect(1, 32, '\p{posixspace}', "");
    Expect(0, 32, '\p{^posixspace}', "");
    Expect(0, 32, '\P{posixspace}', "");
    Expect(1, 32, '\P{^posixspace}', "");
    Expect(0, 33, '\p{posixspace}', "");
    Expect(1, 33, '\p{^posixspace}', "");
    Expect(1, 33, '\P{posixspace}', "");
    Expect(0, 33, '\P{^posixspace}', "");
    Expect(1, 32, '\p{ 	posixspace}', "");
    Expect(0, 32, '\p{^ 	posixspace}', "");
    Expect(0, 32, '\P{ 	posixspace}', "");
    Expect(1, 32, '\P{^ 	posixspace}', "");
    Expect(0, 33, '\p{ 	posixspace}', "");
    Expect(1, 33, '\p{^ 	posixspace}', "");
    Expect(1, 33, '\P{ 	posixspace}', "");
    Expect(0, 33, '\P{^ 	posixspace}', "");
    Error('\p{ _PERLSPACE:=}');
    Error('\P{ _PERLSPACE:=}');
    Expect(1, 32, '\p{perlspace}', "");
    Expect(0, 32, '\p{^perlspace}', "");
    Expect(0, 32, '\P{perlspace}', "");
    Expect(1, 32, '\P{^perlspace}', "");
    Expect(0, 33, '\p{perlspace}', "");
    Expect(1, 33, '\p{^perlspace}', "");
    Expect(1, 33, '\P{perlspace}', "");
    Expect(0, 33, '\P{^perlspace}', "");
    Expect(1, 32, '\p{_PerlSpace}', "");
    Expect(0, 32, '\p{^_PerlSpace}', "");
    Expect(0, 32, '\P{_PerlSpace}', "");
    Expect(1, 32, '\P{^_PerlSpace}', "");
    Expect(0, 33, '\p{_PerlSpace}', "");
    Expect(1, 33, '\p{^_PerlSpace}', "");
    Expect(1, 33, '\P{_PerlSpace}', "");
    Expect(0, 33, '\P{^_PerlSpace}', "");
    Error('\p{/a/ is_PosixSpace}');
    Error('\P{/a/ is_PosixSpace}');
    Expect(1, 32, '\p{isposixspace}', "");
    Expect(0, 32, '\p{^isposixspace}', "");
    Expect(0, 32, '\P{isposixspace}', "");
    Expect(1, 32, '\P{^isposixspace}', "");
    Expect(0, 33, '\p{isposixspace}', "");
    Expect(1, 33, '\p{^isposixspace}', "");
    Expect(1, 33, '\P{isposixspace}', "");
    Expect(0, 33, '\P{^isposixspace}', "");
    Expect(1, 32, '\p{ 	Is_posixspace}', "");
    Expect(0, 32, '\p{^ 	Is_posixspace}', "");
    Expect(0, 32, '\P{ 	Is_posixspace}', "");
    Expect(1, 32, '\P{^ 	Is_posixspace}', "");
    Expect(0, 33, '\p{ 	Is_posixspace}', "");
    Expect(1, 33, '\p{^ 	Is_posixspace}', "");
    Expect(1, 33, '\P{ 	Is_posixspace}', "");
    Expect(0, 33, '\P{^ 	Is_posixspace}', "");
    Error('\p{/a/	IS_perlspace}');
    Error('\P{/a/	IS_perlspace}');
    Expect(1, 32, '\p{isperlspace}', "");
    Expect(0, 32, '\p{^isperlspace}', "");
    Expect(0, 32, '\P{isperlspace}', "");
    Expect(1, 32, '\P{^isperlspace}', "");
    Expect(0, 33, '\p{isperlspace}', "");
    Expect(1, 33, '\p{^isperlspace}', "");
    Expect(1, 33, '\P{isperlspace}', "");
    Expect(0, 33, '\P{^isperlspace}', "");
    Expect(1, 32, '\p{	_Is_PERLSPACE}', "");
    Expect(0, 32, '\p{^	_Is_PERLSPACE}', "");
    Expect(0, 32, '\P{	_Is_PERLSPACE}', "");
    Expect(1, 32, '\P{^	_Is_PERLSPACE}', "");
    Expect(0, 33, '\p{	_Is_PERLSPACE}', "");
    Expect(1, 33, '\p{^	_Is_PERLSPACE}', "");
    Expect(1, 33, '\P{	_Is_PERLSPACE}', "");
    Expect(0, 33, '\P{^	_Is_PERLSPACE}', "");
    Error('\p{-PosixUpper:=}');
    Error('\P{-PosixUpper:=}');
    Expect(1, 90, '\p{posixupper}', "");
    Expect(0, 90, '\p{^posixupper}', "");
    Expect(0, 90, '\P{posixupper}', "");
    Expect(1, 90, '\P{^posixupper}', "");
    Expect(0, 91, '\p{posixupper}', "");
    Expect(1, 91, '\p{^posixupper}', "");
    Expect(1, 91, '\P{posixupper}', "");
    Expect(0, 91, '\P{^posixupper}', "");
    Expect(1, 90, '\p{_PosixUpper}', "");
    Expect(0, 90, '\p{^_PosixUpper}', "");
    Expect(0, 90, '\P{_PosixUpper}', "");
    Expect(1, 90, '\P{^_PosixUpper}', "");
    Expect(0, 91, '\p{_PosixUpper}', "");
    Expect(1, 91, '\p{^_PosixUpper}', "");
    Expect(1, 91, '\P{_PosixUpper}', "");
    Expect(0, 91, '\P{^_PosixUpper}', "");
    Error('\p{/a/	_Is_PosixUpper}');
    Error('\P{/a/	_Is_PosixUpper}');
    Expect(1, 90, '\p{isposixupper}', "");
    Expect(0, 90, '\p{^isposixupper}', "");
    Expect(0, 90, '\P{isposixupper}', "");
    Expect(1, 90, '\P{^isposixupper}', "");
    Expect(0, 91, '\p{isposixupper}', "");
    Expect(1, 91, '\p{^isposixupper}', "");
    Expect(1, 91, '\P{isposixupper}', "");
    Expect(0, 91, '\P{^isposixupper}', "");
    Expect(1, 90, '\p{-	Is_PosixUpper}', "");
    Expect(0, 90, '\p{^-	Is_PosixUpper}', "");
    Expect(0, 90, '\P{-	Is_PosixUpper}', "");
    Expect(1, 90, '\P{^-	Is_PosixUpper}', "");
    Expect(0, 91, '\p{-	Is_PosixUpper}', "");
    Expect(1, 91, '\p{^-	Is_PosixUpper}', "");
    Expect(1, 91, '\P{-	Is_PosixUpper}', "");
    Expect(0, 91, '\P{^-	Is_PosixUpper}', "");
    Error('\p{/a/ -POSIXWORD}');
    Error('\P{/a/ -POSIXWORD}');
    Expect(1, 122, '\p{posixword}', "");
    Expect(0, 122, '\p{^posixword}', "");
    Expect(0, 122, '\P{posixword}', "");
    Expect(1, 122, '\P{^posixword}', "");
    Expect(0, 123, '\p{posixword}', "");
    Expect(1, 123, '\p{^posixword}', "");
    Expect(1, 123, '\P{posixword}', "");
    Expect(0, 123, '\P{^posixword}', "");
    Expect(1, 122, '\p{_	PosixWord}', "");
    Expect(0, 122, '\p{^_	PosixWord}', "");
    Expect(0, 122, '\P{_	PosixWord}', "");
    Expect(1, 122, '\P{^_	PosixWord}', "");
    Expect(0, 123, '\p{_	PosixWord}', "");
    Expect(1, 123, '\p{^_	PosixWord}', "");
    Expect(1, 123, '\P{_	PosixWord}', "");
    Expect(0, 123, '\P{^_	PosixWord}', "");
    Error('\p{ :=PERLWORD}');
    Error('\P{ :=PERLWORD}');
    Expect(1, 122, '\p{perlword}', "");
    Expect(0, 122, '\p{^perlword}', "");
    Expect(0, 122, '\P{perlword}', "");
    Expect(1, 122, '\P{^perlword}', "");
    Expect(0, 123, '\p{perlword}', "");
    Expect(1, 123, '\p{^perlword}', "");
    Expect(1, 123, '\P{perlword}', "");
    Expect(0, 123, '\P{^perlword}', "");
    Expect(1, 122, '\p{	PerlWord}', "");
    Expect(0, 122, '\p{^	PerlWord}', "");
    Expect(0, 122, '\P{	PerlWord}', "");
    Expect(1, 122, '\P{^	PerlWord}', "");
    Expect(0, 123, '\p{	PerlWord}', "");
    Expect(1, 123, '\p{^	PerlWord}', "");
    Expect(1, 123, '\P{	PerlWord}', "");
    Expect(0, 123, '\P{^	PerlWord}', "");
    Error('\p{/a/	-is_PosixWord}');
    Error('\P{/a/	-is_PosixWord}');
    Expect(1, 122, '\p{isposixword}', "");
    Expect(0, 122, '\p{^isposixword}', "");
    Expect(0, 122, '\P{isposixword}', "");
    Expect(1, 122, '\P{^isposixword}', "");
    Expect(0, 123, '\p{isposixword}', "");
    Expect(1, 123, '\p{^isposixword}', "");
    Expect(1, 123, '\P{isposixword}', "");
    Expect(0, 123, '\P{^isposixword}', "");
    Expect(1, 122, '\p{_-Is_POSIXWORD}', "");
    Expect(0, 122, '\p{^_-Is_POSIXWORD}', "");
    Expect(0, 122, '\P{_-Is_POSIXWORD}', "");
    Expect(1, 122, '\P{^_-Is_POSIXWORD}', "");
    Expect(0, 123, '\p{_-Is_POSIXWORD}', "");
    Expect(1, 123, '\p{^_-Is_POSIXWORD}', "");
    Expect(1, 123, '\P{_-Is_POSIXWORD}', "");
    Expect(0, 123, '\P{^_-Is_POSIXWORD}', "");
    Error('\p{_ is_PerlWord/a/}');
    Error('\P{_ is_PerlWord/a/}');
    Expect(1, 122, '\p{isperlword}', "");
    Expect(0, 122, '\p{^isperlword}', "");
    Expect(0, 122, '\P{isperlword}', "");
    Expect(1, 122, '\P{^isperlword}', "");
    Expect(0, 123, '\p{isperlword}', "");
    Expect(1, 123, '\p{^isperlword}', "");
    Expect(1, 123, '\P{isperlword}', "");
    Expect(0, 123, '\P{^isperlword}', "");
    Expect(1, 122, '\p{--is_PerlWord}', "");
    Expect(0, 122, '\p{^--is_PerlWord}', "");
    Expect(0, 122, '\P{--is_PerlWord}', "");
    Expect(1, 122, '\P{^--is_PerlWord}', "");
    Expect(0, 123, '\p{--is_PerlWord}', "");
    Expect(1, 123, '\p{^--is_PerlWord}', "");
    Expect(1, 123, '\P{--is_PerlWord}', "");
    Expect(0, 123, '\P{^--is_PerlWord}', "");
    Error('\p{	:=PosixXDigit}');
    Error('\P{	:=PosixXDigit}');
    Expect(1, 102, '\p{posixxdigit}', "");
    Expect(0, 102, '\p{^posixxdigit}', "");
    Expect(0, 102, '\P{posixxdigit}', "");
    Expect(1, 102, '\P{^posixxdigit}', "");
    Expect(0, 103, '\p{posixxdigit}', "");
    Expect(1, 103, '\p{^posixxdigit}', "");
    Expect(1, 103, '\P{posixxdigit}', "");
    Expect(0, 103, '\P{^posixxdigit}', "");
    Expect(1, 102, '\p{ posixxdigit}', "");
    Expect(0, 102, '\p{^ posixxdigit}', "");
    Expect(0, 102, '\P{ posixxdigit}', "");
    Expect(1, 102, '\P{^ posixxdigit}', "");
    Expect(0, 103, '\p{ posixxdigit}', "");
    Expect(1, 103, '\p{^ posixxdigit}', "");
    Expect(1, 103, '\P{ posixxdigit}', "");
    Expect(0, 103, '\P{^ posixxdigit}', "");
    Error('\p{ 	Is_posixxdigit:=}');
    Error('\P{ 	Is_posixxdigit:=}');
    Expect(1, 102, '\p{isposixxdigit}', "");
    Expect(0, 102, '\p{^isposixxdigit}', "");
    Expect(0, 102, '\P{isposixxdigit}', "");
    Expect(1, 102, '\P{^isposixxdigit}', "");
    Expect(0, 103, '\p{isposixxdigit}', "");
    Expect(1, 103, '\p{^isposixxdigit}', "");
    Expect(1, 103, '\P{isposixxdigit}', "");
    Expect(0, 103, '\P{^isposixxdigit}', "");
    Expect(1, 102, '\p{ _IS_PosixXDigit}', "");
    Expect(0, 102, '\p{^ _IS_PosixXDigit}', "");
    Expect(0, 102, '\P{ _IS_PosixXDigit}', "");
    Expect(1, 102, '\P{^ _IS_PosixXDigit}', "");
    Expect(0, 103, '\p{ _IS_PosixXDigit}', "");
    Expect(1, 103, '\p{^ _IS_PosixXDigit}', "");
    Expect(1, 103, '\P{ _IS_PosixXDigit}', "");
    Expect(0, 103, '\P{^ _IS_PosixXDigit}', "");
    Error('\p{_	ASCII_Hex_Digit/a/}');
    Error('\P{_	ASCII_Hex_Digit/a/}');
    Expect(1, 102, '\p{asciihexdigit}', "");
    Expect(0, 102, '\p{^asciihexdigit}', "");
    Expect(0, 102, '\P{asciihexdigit}', "");
    Expect(1, 102, '\P{^asciihexdigit}', "");
    Expect(0, 103, '\p{asciihexdigit}', "");
    Expect(1, 103, '\p{^asciihexdigit}', "");
    Expect(1, 103, '\P{asciihexdigit}', "");
    Expect(0, 103, '\P{^asciihexdigit}', "");
    Expect(1, 102, '\p{_ASCII_Hex_DIGIT}', "");
    Expect(0, 102, '\p{^_ASCII_Hex_DIGIT}', "");
    Expect(0, 102, '\P{_ASCII_Hex_DIGIT}', "");
    Expect(1, 102, '\P{^_ASCII_Hex_DIGIT}', "");
    Expect(0, 103, '\p{_ASCII_Hex_DIGIT}', "");
    Expect(1, 103, '\p{^_ASCII_Hex_DIGIT}', "");
    Expect(1, 103, '\P{_ASCII_Hex_DIGIT}', "");
    Expect(0, 103, '\P{^_ASCII_Hex_DIGIT}', "");
    Error('\p{/a/ -IS_ascii_HEX_digit}');
    Error('\P{/a/ -IS_ascii_HEX_digit}');
    Expect(1, 102, '\p{isasciihexdigit}', "");
    Expect(0, 102, '\p{^isasciihexdigit}', "");
    Expect(0, 102, '\P{isasciihexdigit}', "");
    Expect(1, 102, '\P{^isasciihexdigit}', "");
    Expect(0, 103, '\p{isasciihexdigit}', "");
    Expect(1, 103, '\p{^isasciihexdigit}', "");
    Expect(1, 103, '\P{isasciihexdigit}', "");
    Expect(0, 103, '\P{^isasciihexdigit}', "");
    Expect(1, 102, '\p{ 	Is_ASCII_hex_Digit}', "");
    Expect(0, 102, '\p{^ 	Is_ASCII_hex_Digit}', "");
    Expect(0, 102, '\P{ 	Is_ASCII_hex_Digit}', "");
    Expect(1, 102, '\P{^ 	Is_ASCII_hex_Digit}', "");
    Expect(0, 103, '\p{ 	Is_ASCII_hex_Digit}', "");
    Expect(1, 103, '\p{^ 	Is_ASCII_hex_Digit}', "");
    Expect(1, 103, '\P{ 	Is_ASCII_hex_Digit}', "");
    Expect(0, 103, '\P{^ 	Is_ASCII_hex_Digit}', "");
    Error('\p{ AHex/a/}');
    Error('\P{ AHex/a/}');
    Expect(1, 102, '\p{ahex}', "");
    Expect(0, 102, '\p{^ahex}', "");
    Expect(0, 102, '\P{ahex}', "");
    Expect(1, 102, '\P{^ahex}', "");
    Expect(0, 103, '\p{ahex}', "");
    Expect(1, 103, '\p{^ahex}', "");
    Expect(1, 103, '\P{ahex}', "");
    Expect(0, 103, '\P{^ahex}', "");
    Expect(1, 102, '\p{		AHex}', "");
    Expect(0, 102, '\p{^		AHex}', "");
    Expect(0, 102, '\P{		AHex}', "");
    Expect(1, 102, '\P{^		AHex}', "");
    Expect(0, 103, '\p{		AHex}', "");
    Expect(1, 103, '\p{^		AHex}', "");
    Expect(1, 103, '\P{		AHex}', "");
    Expect(0, 103, '\P{^		AHex}', "");
    Error('\p{/a/ _Is_AHEX}');
    Error('\P{/a/ _Is_AHEX}');
    Expect(1, 102, '\p{isahex}', "");
    Expect(0, 102, '\p{^isahex}', "");
    Expect(0, 102, '\P{isahex}', "");
    Expect(1, 102, '\P{^isahex}', "");
    Expect(0, 103, '\p{isahex}', "");
    Expect(1, 103, '\p{^isahex}', "");
    Expect(1, 103, '\P{isahex}', "");
    Expect(0, 103, '\P{^isahex}', "");
    Expect(1, 102, '\p{		is_AHex}', "");
    Expect(0, 102, '\p{^		is_AHex}', "");
    Expect(0, 102, '\P{		is_AHex}', "");
    Expect(1, 102, '\P{^		is_AHex}', "");
    Expect(0, 103, '\p{		is_AHex}', "");
    Expect(1, 103, '\p{^		is_AHex}', "");
    Expect(1, 103, '\P{		is_AHex}', "");
    Expect(0, 103, '\P{^		is_AHex}', "");
    Error('\p{-	PREPENDED_CONCATENATION_mark:=}');
    Error('\P{-	PREPENDED_CONCATENATION_mark:=}');
    Expect(1, 69821, '\p{prependedconcatenationmark}', "");
    Expect(0, 69821, '\p{^prependedconcatenationmark}', "");
    Expect(0, 69821, '\P{prependedconcatenationmark}', "");
    Expect(1, 69821, '\P{^prependedconcatenationmark}', "");
    Expect(0, 69822, '\p{prependedconcatenationmark}', "");
    Expect(1, 69822, '\p{^prependedconcatenationmark}', "");
    Expect(1, 69822, '\P{prependedconcatenationmark}', "");
    Expect(0, 69822, '\P{^prependedconcatenationmark}', "");
    Expect(1, 69821, '\p{-prepended_Concatenation_MARK}', "");
    Expect(0, 69821, '\p{^-prepended_Concatenation_MARK}', "");
    Expect(0, 69821, '\P{-prepended_Concatenation_MARK}', "");
    Expect(1, 69821, '\P{^-prepended_Concatenation_MARK}', "");
    Expect(0, 69822, '\p{-prepended_Concatenation_MARK}', "");
    Expect(1, 69822, '\p{^-prepended_Concatenation_MARK}', "");
    Expect(1, 69822, '\P{-prepended_Concatenation_MARK}', "");
    Expect(0, 69822, '\P{^-prepended_Concatenation_MARK}', "");
    Error('\p{_ IS_Prepended_CONCATENATION_Mark/a/}');
    Error('\P{_ IS_Prepended_CONCATENATION_Mark/a/}');
    Expect(1, 69821, '\p{isprependedconcatenationmark}', "");
    Expect(0, 69821, '\p{^isprependedconcatenationmark}', "");
    Expect(0, 69821, '\P{isprependedconcatenationmark}', "");
    Expect(1, 69821, '\P{^isprependedconcatenationmark}', "");
    Expect(0, 69822, '\p{isprependedconcatenationmark}', "");
    Expect(1, 69822, '\p{^isprependedconcatenationmark}', "");
    Expect(1, 69822, '\P{isprependedconcatenationmark}', "");
    Expect(0, 69822, '\P{^isprependedconcatenationmark}', "");
    Expect(1, 69821, '\p{--Is_prepended_Concatenation_mark}', "");
    Expect(0, 69821, '\p{^--Is_prepended_Concatenation_mark}', "");
    Expect(0, 69821, '\P{--Is_prepended_Concatenation_mark}', "");
    Expect(1, 69821, '\P{^--Is_prepended_Concatenation_mark}', "");
    Expect(0, 69822, '\p{--Is_prepended_Concatenation_mark}', "");
    Expect(1, 69822, '\p{^--Is_prepended_Concatenation_mark}', "");
    Expect(1, 69822, '\P{--Is_prepended_Concatenation_mark}', "");
    Expect(0, 69822, '\P{^--Is_prepended_Concatenation_mark}', "");
    Error('\p{pcm/a/}');
    Error('\P{pcm/a/}');
    Expect(1, 69821, '\p{pcm}', "");
    Expect(0, 69821, '\p{^pcm}', "");
    Expect(0, 69821, '\P{pcm}', "");
    Expect(1, 69821, '\P{^pcm}', "");
    Expect(0, 69822, '\p{pcm}', "");
    Expect(1, 69822, '\p{^pcm}', "");
    Expect(1, 69822, '\P{pcm}', "");
    Expect(0, 69822, '\P{^pcm}', "");
    Expect(1, 69821, '\p{	pcm}', "");
    Expect(0, 69821, '\p{^	pcm}', "");
    Expect(0, 69821, '\P{	pcm}', "");
    Expect(1, 69821, '\P{^	pcm}', "");
    Expect(0, 69822, '\p{	pcm}', "");
    Expect(1, 69822, '\p{^	pcm}', "");
    Expect(1, 69822, '\P{	pcm}', "");
    Expect(0, 69822, '\P{^	pcm}', "");
    Error('\p{:= Is_pcm}');
    Error('\P{:= Is_pcm}');
    Expect(1, 69821, '\p{ispcm}', "");
    Expect(0, 69821, '\p{^ispcm}', "");
    Expect(0, 69821, '\P{ispcm}', "");
    Expect(1, 69821, '\P{^ispcm}', "");
    Expect(0, 69822, '\p{ispcm}', "");
    Expect(1, 69822, '\p{^ispcm}', "");
    Expect(1, 69822, '\P{ispcm}', "");
    Expect(0, 69822, '\P{^ispcm}', "");
    Expect(1, 69821, '\p{-_Is_PCM}', "");
    Expect(0, 69821, '\p{^-_Is_PCM}', "");
    Expect(0, 69821, '\P{-_Is_PCM}', "");
    Expect(1, 69821, '\P{^-_Is_PCM}', "");
    Expect(0, 69822, '\p{-_Is_PCM}', "");
    Expect(1, 69822, '\p{^-_Is_PCM}', "");
    Expect(1, 69822, '\P{-_Is_PCM}', "");
    Expect(0, 69822, '\P{^-_Is_PCM}', "");
    Error('\p{/a/ 	XPosixPrint}');
    Error('\P{/a/ 	XPosixPrint}');
    Expect(1, 1114109, '\p{xposixprint}', "");
    Expect(0, 1114109, '\p{^xposixprint}', "");
    Expect(0, 1114109, '\P{xposixprint}', "");
    Expect(1, 1114109, '\P{^xposixprint}', "");
    Expect(0, 918000, '\p{xposixprint}', "");
    Expect(1, 918000, '\p{^xposixprint}', "");
    Expect(1, 918000, '\P{xposixprint}', "");
    Expect(0, 918000, '\P{^xposixprint}', "");
    Expect(1, 1114109, '\p{-_xposixprint}', "");
    Expect(0, 1114109, '\p{^-_xposixprint}', "");
    Expect(0, 1114109, '\P{-_xposixprint}', "");
    Expect(1, 1114109, '\P{^-_xposixprint}', "");
    Expect(0, 918000, '\p{-_xposixprint}', "");
    Expect(1, 918000, '\p{^-_xposixprint}', "");
    Expect(1, 918000, '\P{-_xposixprint}', "");
    Expect(0, 918000, '\P{^-_xposixprint}', "");
    Error('\p{ Print:=}');
    Error('\P{ Print:=}');
    Expect(1, 1114109, '\p{print}', "");
    Expect(0, 1114109, '\p{^print}', "");
    Expect(0, 1114109, '\P{print}', "");
    Expect(1, 1114109, '\P{^print}', "");
    Expect(0, 918000, '\p{print}', "");
    Expect(1, 918000, '\p{^print}', "");
    Expect(1, 918000, '\P{print}', "");
    Expect(0, 918000, '\P{^print}', "");
    Expect(1, 1114109, '\p{_Print}', "");
    Expect(0, 1114109, '\p{^_Print}', "");
    Expect(0, 1114109, '\P{_Print}', "");
    Expect(1, 1114109, '\P{^_Print}', "");
    Expect(0, 918000, '\p{_Print}', "");
    Expect(1, 918000, '\p{^_Print}', "");
    Expect(1, 918000, '\P{_Print}', "");
    Expect(0, 918000, '\P{^_Print}', "");
    Error('\p{:=-is_xposixprint}');
    Error('\P{:=-is_xposixprint}');
    Expect(1, 1114109, '\p{isxposixprint}', "");
    Expect(0, 1114109, '\p{^isxposixprint}', "");
    Expect(0, 1114109, '\P{isxposixprint}', "");
    Expect(1, 1114109, '\P{^isxposixprint}', "");
    Expect(0, 918000, '\p{isxposixprint}', "");
    Expect(1, 918000, '\p{^isxposixprint}', "");
    Expect(1, 918000, '\P{isxposixprint}', "");
    Expect(0, 918000, '\P{^isxposixprint}', "");
    Expect(1, 1114109, '\p{ 	IS_XPOSIXPRINT}', "");
    Expect(0, 1114109, '\p{^ 	IS_XPOSIXPRINT}', "");
    Expect(0, 1114109, '\P{ 	IS_XPOSIXPRINT}', "");
    Expect(1, 1114109, '\P{^ 	IS_XPOSIXPRINT}', "");
    Expect(0, 918000, '\p{ 	IS_XPOSIXPRINT}', "");
    Expect(1, 918000, '\p{^ 	IS_XPOSIXPRINT}', "");
    Expect(1, 918000, '\P{ 	IS_XPOSIXPRINT}', "");
    Expect(0, 918000, '\P{^ 	IS_XPOSIXPRINT}', "");
    Error('\p{  Is_print:=}');
    Error('\P{  Is_print:=}');
    Expect(1, 1114109, '\p{isprint}', "");
    Expect(0, 1114109, '\p{^isprint}', "");
    Expect(0, 1114109, '\P{isprint}', "");
    Expect(1, 1114109, '\P{^isprint}', "");
    Expect(0, 918000, '\p{isprint}', "");
    Expect(1, 918000, '\p{^isprint}', "");
    Expect(1, 918000, '\P{isprint}', "");
    Expect(0, 918000, '\P{^isprint}', "");
    Expect(1, 1114109, '\p{	 is_Print}', "");
    Expect(0, 1114109, '\p{^	 is_Print}', "");
    Expect(0, 1114109, '\P{	 is_Print}', "");
    Expect(1, 1114109, '\P{^	 is_Print}', "");
    Expect(0, 918000, '\p{	 is_Print}', "");
    Expect(1, 918000, '\p{^	 is_Print}', "");
    Expect(1, 918000, '\P{	 is_Print}', "");
    Expect(0, 918000, '\P{^	 is_Print}', "");
    Error('\p{:=_Private_use}');
    Error('\P{:=_Private_use}');
    Expect(1, 1114109, '\p{privateuse}', "");
    Expect(0, 1114109, '\p{^privateuse}', "");
    Expect(0, 1114109, '\P{privateuse}', "");
    Expect(1, 1114109, '\P{^privateuse}', "");
    Expect(0, 63744, '\p{privateuse}', "");
    Expect(1, 63744, '\p{^privateuse}', "");
    Expect(1, 63744, '\P{privateuse}', "");
    Expect(0, 63744, '\P{^privateuse}', "");
    Expect(1, 1114109, '\p{	Private_USE}', "");
    Expect(0, 1114109, '\p{^	Private_USE}', "");
    Expect(0, 1114109, '\P{	Private_USE}', "");
    Expect(1, 1114109, '\P{^	Private_USE}', "");
    Expect(0, 63744, '\p{	Private_USE}', "");
    Expect(1, 63744, '\p{^	Private_USE}', "");
    Expect(1, 63744, '\P{	Private_USE}', "");
    Expect(0, 63744, '\P{^	Private_USE}', "");
    Error('\p{/a/	 IS_Private_USE}');
    Error('\P{/a/	 IS_Private_USE}');
    Expect(1, 1114109, '\p{isprivateuse}', "");
    Expect(0, 1114109, '\p{^isprivateuse}', "");
    Expect(0, 1114109, '\P{isprivateuse}', "");
    Expect(1, 1114109, '\P{^isprivateuse}', "");
    Expect(0, 63744, '\p{isprivateuse}', "");
    Expect(1, 63744, '\p{^isprivateuse}', "");
    Expect(1, 63744, '\P{isprivateuse}', "");
    Expect(0, 63744, '\P{^isprivateuse}', "");
    Expect(1, 1114109, '\p{-_IS_PRIVATE_use}', "");
    Expect(0, 1114109, '\p{^-_IS_PRIVATE_use}', "");
    Expect(0, 1114109, '\P{-_IS_PRIVATE_use}', "");
    Expect(1, 1114109, '\P{^-_IS_PRIVATE_use}', "");
    Expect(0, 63744, '\p{-_IS_PRIVATE_use}', "");
    Expect(1, 63744, '\p{^-_IS_PRIVATE_use}', "");
    Expect(1, 63744, '\P{-_IS_PRIVATE_use}', "");
    Expect(0, 63744, '\P{^-_IS_PRIVATE_use}', "");
    Error('\p{	Co/a/}');
    Error('\P{	Co/a/}');
    Expect(1, 1114109, '\p{co}', "");
    Expect(0, 1114109, '\p{^co}', "");
    Expect(0, 1114109, '\P{co}', "");
    Expect(1, 1114109, '\P{^co}', "");
    Expect(0, 63744, '\p{co}', "");
    Expect(1, 63744, '\p{^co}', "");
    Expect(1, 63744, '\P{co}', "");
    Expect(0, 63744, '\P{^co}', "");
    Expect(1, 1114109, '\p{		Co}', "");
    Expect(0, 1114109, '\p{^		Co}', "");
    Expect(0, 1114109, '\P{		Co}', "");
    Expect(1, 1114109, '\P{^		Co}', "");
    Expect(0, 63744, '\p{		Co}', "");
    Expect(1, 63744, '\p{^		Co}', "");
    Expect(1, 63744, '\P{		Co}', "");
    Expect(0, 63744, '\P{^		Co}', "");
    Error('\p{	:=IS_co}');
    Error('\P{	:=IS_co}');
    Expect(1, 1114109, '\p{isco}', "");
    Expect(0, 1114109, '\p{^isco}', "");
    Expect(0, 1114109, '\P{isco}', "");
    Expect(1, 1114109, '\P{^isco}', "");
    Expect(0, 63744, '\p{isco}', "");
    Expect(1, 63744, '\p{^isco}', "");
    Expect(1, 63744, '\P{isco}', "");
    Expect(0, 63744, '\P{^isco}', "");
    Expect(1, 1114109, '\p{ Is_co}', "");
    Expect(0, 1114109, '\p{^ Is_co}', "");
    Expect(0, 1114109, '\P{ Is_co}', "");
    Expect(1, 1114109, '\P{^ Is_co}', "");
    Expect(0, 63744, '\p{ Is_co}', "");
    Expect(1, 63744, '\p{^ Is_co}', "");
    Expect(1, 63744, '\P{ Is_co}', "");
    Expect(0, 63744, '\P{^ Is_co}', "");
    Error('\p{/a/		private_Use_Area}');
    Error('\P{/a/		private_Use_Area}');
    Expect(1, 63743, '\p{privateusearea}', "");
    Expect(0, 63743, '\p{^privateusearea}', "");
    Expect(0, 63743, '\P{privateusearea}', "");
    Expect(1, 63743, '\P{^privateusearea}', "");
    Expect(0, 63744, '\p{privateusearea}', "");
    Expect(1, 63744, '\p{^privateusearea}', "");
    Expect(1, 63744, '\P{privateusearea}', "");
    Expect(0, 63744, '\P{^privateusearea}', "");
    Expect(1, 63743, '\p{ 	PRIVATE_Use_AREA}', "");
    Expect(0, 63743, '\p{^ 	PRIVATE_Use_AREA}', "");
    Expect(0, 63743, '\P{ 	PRIVATE_Use_AREA}', "");
    Expect(1, 63743, '\P{^ 	PRIVATE_Use_AREA}', "");
    Expect(0, 63744, '\p{ 	PRIVATE_Use_AREA}', "");
    Expect(1, 63744, '\p{^ 	PRIVATE_Use_AREA}', "");
    Expect(1, 63744, '\P{ 	PRIVATE_Use_AREA}', "");
    Expect(0, 63744, '\P{^ 	PRIVATE_Use_AREA}', "");
    Error('\p{	-Is_private_Use_Area/a/}');
    Error('\P{	-Is_private_Use_Area/a/}');
    Expect(1, 63743, '\p{isprivateusearea}', "");
    Expect(0, 63743, '\p{^isprivateusearea}', "");
    Expect(0, 63743, '\P{isprivateusearea}', "");
    Expect(1, 63743, '\P{^isprivateusearea}', "");
    Expect(0, 63744, '\p{isprivateusearea}', "");
    Expect(1, 63744, '\p{^isprivateusearea}', "");
    Expect(1, 63744, '\P{isprivateusearea}', "");
    Expect(0, 63744, '\P{^isprivateusearea}', "");
    Expect(1, 63743, '\p{is_Private_use_area}', "");
    Expect(0, 63743, '\p{^is_Private_use_area}', "");
    Expect(0, 63743, '\P{is_Private_use_area}', "");
    Expect(1, 63743, '\P{^is_Private_use_area}', "");
    Expect(0, 63744, '\p{is_Private_use_area}', "");
    Expect(1, 63744, '\p{^is_Private_use_area}', "");
    Expect(1, 63744, '\P{is_Private_use_area}', "");
    Expect(0, 63744, '\P{^is_Private_use_area}', "");
    Error('\p{/a/ IN_PRIVATE_Use_Area}');
    Error('\P{/a/ IN_PRIVATE_Use_Area}');
    Expect(1, 63743, '\p{inprivateusearea}', "");
    Expect(0, 63743, '\p{^inprivateusearea}', "");
    Expect(0, 63743, '\P{inprivateusearea}', "");
    Expect(1, 63743, '\P{^inprivateusearea}', "");
    Expect(0, 63744, '\p{inprivateusearea}', "");
    Expect(1, 63744, '\p{^inprivateusearea}', "");
    Expect(1, 63744, '\P{inprivateusearea}', "");
    Expect(0, 63744, '\P{^inprivateusearea}', "");
    Expect(1, 63743, '\p{	_In_private_Use_Area}', "");
    Expect(0, 63743, '\p{^	_In_private_Use_Area}', "");
    Expect(0, 63743, '\P{	_In_private_Use_Area}', "");
    Expect(1, 63743, '\P{^	_In_private_Use_Area}', "");
    Expect(0, 63744, '\p{	_In_private_Use_Area}', "");
    Expect(1, 63744, '\p{^	_In_private_Use_Area}', "");
    Expect(1, 63744, '\P{	_In_private_Use_Area}', "");
    Expect(0, 63744, '\P{^	_In_private_Use_Area}', "");
    Error('\p{/a/_PUA}');
    Error('\P{/a/_PUA}');
    Expect(1, 63743, '\p{pua}', "");
    Expect(0, 63743, '\p{^pua}', "");
    Expect(0, 63743, '\P{pua}', "");
    Expect(1, 63743, '\P{^pua}', "");
    Expect(0, 63744, '\p{pua}', "");
    Expect(1, 63744, '\p{^pua}', "");
    Expect(1, 63744, '\P{pua}', "");
    Expect(0, 63744, '\P{^pua}', "");
    Expect(1, 63743, '\p{	PUA}', "");
    Expect(0, 63743, '\p{^	PUA}', "");
    Expect(0, 63743, '\P{	PUA}', "");
    Expect(1, 63743, '\P{^	PUA}', "");
    Expect(0, 63744, '\p{	PUA}', "");
    Expect(1, 63744, '\p{^	PUA}', "");
    Expect(1, 63744, '\P{	PUA}', "");
    Expect(0, 63744, '\P{^	PUA}', "");
    Error('\p{-	is_PUA:=}');
    Error('\P{-	is_PUA:=}');
    Expect(1, 63743, '\p{ispua}', "");
    Expect(0, 63743, '\p{^ispua}', "");
    Expect(0, 63743, '\P{ispua}', "");
    Expect(1, 63743, '\P{^ispua}', "");
    Expect(0, 63744, '\p{ispua}', "");
    Expect(1, 63744, '\p{^ispua}', "");
    Expect(1, 63744, '\P{ispua}', "");
    Expect(0, 63744, '\P{^ispua}', "");
    Expect(1, 63743, '\p{	 Is_PUA}', "");
    Expect(0, 63743, '\p{^	 Is_PUA}', "");
    Expect(0, 63743, '\P{	 Is_PUA}', "");
    Expect(1, 63743, '\P{^	 Is_PUA}', "");
    Expect(0, 63744, '\p{	 Is_PUA}', "");
    Expect(1, 63744, '\p{^	 Is_PUA}', "");
    Expect(1, 63744, '\P{	 Is_PUA}', "");
    Expect(0, 63744, '\P{^	 Is_PUA}', "");
    Error('\p{-In_PUA:=}');
    Error('\P{-In_PUA:=}');
    Expect(1, 63743, '\p{inpua}', "");
    Expect(0, 63743, '\p{^inpua}', "");
    Expect(0, 63743, '\P{inpua}', "");
    Expect(1, 63743, '\P{^inpua}', "");
    Expect(0, 63744, '\p{inpua}', "");
    Expect(1, 63744, '\p{^inpua}', "");
    Expect(1, 63744, '\P{inpua}', "");
    Expect(0, 63744, '\P{^inpua}', "");
    Expect(1, 63743, '\p{	-IN_PUA}', "");
    Expect(0, 63743, '\p{^	-IN_PUA}', "");
    Expect(0, 63743, '\P{	-IN_PUA}', "");
    Expect(1, 63743, '\P{^	-IN_PUA}', "");
    Expect(0, 63744, '\p{	-IN_PUA}', "");
    Expect(1, 63744, '\p{^	-IN_PUA}', "");
    Expect(1, 63744, '\P{	-IN_PUA}', "");
    Expect(0, 63744, '\P{^	-IN_PUA}', "");
    Error('\p{/a/	 In_private_USE}');
    Error('\P{/a/	 In_private_USE}');
    Expect(1, 63743, '\p{inprivateuse}', "");
    Expect(0, 63743, '\p{^inprivateuse}', "");
    Expect(0, 63743, '\P{inprivateuse}', "");
    Expect(1, 63743, '\P{^inprivateuse}', "");
    Expect(0, 63744, '\p{inprivateuse}', "");
    Expect(1, 63744, '\p{^inprivateuse}', "");
    Expect(1, 63744, '\P{inprivateuse}', "");
    Expect(0, 63744, '\P{^inprivateuse}', "");
    Expect(1, 63743, '\p{In_private_Use}', "");
    Expect(0, 63743, '\p{^In_private_Use}', "");
    Expect(0, 63743, '\P{In_private_Use}', "");
    Expect(1, 63743, '\P{^In_private_Use}', "");
    Expect(0, 63744, '\p{In_private_Use}', "");
    Expect(1, 63744, '\p{^In_private_Use}', "");
    Expect(1, 63744, '\P{In_private_Use}', "");
    Expect(0, 63744, '\P{^In_private_Use}', "");
    Error('\p{/a/- psalter_Pahlavi}');
    Error('\P{/a/- psalter_Pahlavi}');
    Expect(1, 68527, '\p{psalterpahlavi}', "");
    Expect(0, 68527, '\p{^psalterpahlavi}', "");
    Expect(0, 68527, '\P{psalterpahlavi}', "");
    Expect(1, 68527, '\P{^psalterpahlavi}', "");
    Expect(0, 68528, '\p{psalterpahlavi}', "");
    Expect(1, 68528, '\p{^psalterpahlavi}', "");
    Expect(1, 68528, '\P{psalterpahlavi}', "");
    Expect(0, 68528, '\P{^psalterpahlavi}', "");
    Expect(1, 68527, '\p{ PSALTER_PAHLAVI}', "");
    Expect(0, 68527, '\p{^ PSALTER_PAHLAVI}', "");
    Expect(0, 68527, '\P{ PSALTER_PAHLAVI}', "");
    Expect(1, 68527, '\P{^ PSALTER_PAHLAVI}', "");
    Expect(0, 68528, '\p{ PSALTER_PAHLAVI}', "");
    Expect(1, 68528, '\p{^ PSALTER_PAHLAVI}', "");
    Expect(1, 68528, '\P{ PSALTER_PAHLAVI}', "");
    Expect(0, 68528, '\P{^ PSALTER_PAHLAVI}', "");
    Error('\p{-/a/IS_Psalter_pahlavi}');
    Error('\P{-/a/IS_Psalter_pahlavi}');
    Expect(1, 68527, '\p{ispsalterpahlavi}', "");
    Expect(0, 68527, '\p{^ispsalterpahlavi}', "");
    Expect(0, 68527, '\P{ispsalterpahlavi}', "");
    Expect(1, 68527, '\P{^ispsalterpahlavi}', "");
    Expect(0, 68528, '\p{ispsalterpahlavi}', "");
    Expect(1, 68528, '\p{^ispsalterpahlavi}', "");
    Expect(1, 68528, '\P{ispsalterpahlavi}', "");
    Expect(0, 68528, '\P{^ispsalterpahlavi}', "");
    Expect(1, 68527, '\p{  Is_Psalter_Pahlavi}', "");
    Expect(0, 68527, '\p{^  Is_Psalter_Pahlavi}', "");
    Expect(0, 68527, '\P{  Is_Psalter_Pahlavi}', "");
    Expect(1, 68527, '\P{^  Is_Psalter_Pahlavi}', "");
    Expect(0, 68528, '\p{  Is_Psalter_Pahlavi}', "");
    Expect(1, 68528, '\p{^  Is_Psalter_Pahlavi}', "");
    Expect(1, 68528, '\P{  Is_Psalter_Pahlavi}', "");
    Expect(0, 68528, '\P{^  Is_Psalter_Pahlavi}', "");
    Error('\p{_/a/Phlp}');
    Error('\P{_/a/Phlp}');
    Expect(1, 68527, '\p{phlp}', "");
    Expect(0, 68527, '\p{^phlp}', "");
    Expect(0, 68527, '\P{phlp}', "");
    Expect(1, 68527, '\P{^phlp}', "");
    Expect(0, 68528, '\p{phlp}', "");
    Expect(1, 68528, '\p{^phlp}', "");
    Expect(1, 68528, '\P{phlp}', "");
    Expect(0, 68528, '\P{^phlp}', "");
    Expect(1, 68527, '\p{__phlp}', "");
    Expect(0, 68527, '\p{^__phlp}', "");
    Expect(0, 68527, '\P{__phlp}', "");
    Expect(1, 68527, '\P{^__phlp}', "");
    Expect(0, 68528, '\p{__phlp}', "");
    Expect(1, 68528, '\p{^__phlp}', "");
    Expect(1, 68528, '\P{__phlp}', "");
    Expect(0, 68528, '\P{^__phlp}', "");
    Error('\p{	-Is_Phlp/a/}');
    Error('\P{	-Is_Phlp/a/}');
    Expect(1, 68527, '\p{isphlp}', "");
    Expect(0, 68527, '\p{^isphlp}', "");
    Expect(0, 68527, '\P{isphlp}', "");
    Expect(1, 68527, '\P{^isphlp}', "");
    Expect(0, 68528, '\p{isphlp}', "");
    Expect(1, 68528, '\p{^isphlp}', "");
    Expect(1, 68528, '\P{isphlp}', "");
    Expect(0, 68528, '\P{^isphlp}', "");
    Expect(1, 68527, '\p{-_IS_PHLP}', "");
    Expect(0, 68527, '\p{^-_IS_PHLP}', "");
    Expect(0, 68527, '\P{-_IS_PHLP}', "");
    Expect(1, 68527, '\P{^-_IS_PHLP}', "");
    Expect(0, 68528, '\p{-_IS_PHLP}', "");
    Expect(1, 68528, '\p{^-_IS_PHLP}', "");
    Expect(1, 68528, '\P{-_IS_PHLP}', "");
    Expect(0, 68528, '\P{^-_IS_PHLP}', "");
    Error('\p{	_Punct/a/}');
    Error('\P{	_Punct/a/}');
    Expect(1, 125279, '\p{punct}', "");
    Expect(0, 125279, '\p{^punct}', "");
    Expect(0, 125279, '\P{punct}', "");
    Expect(1, 125279, '\P{^punct}', "");
    Expect(0, 125280, '\p{punct}', "");
    Expect(1, 125280, '\p{^punct}', "");
    Expect(1, 125280, '\P{punct}', "");
    Expect(0, 125280, '\P{^punct}', "");
    Expect(1, 125279, '\p{--punct}', "");
    Expect(0, 125279, '\p{^--punct}', "");
    Expect(0, 125279, '\P{--punct}', "");
    Expect(1, 125279, '\P{^--punct}', "");
    Expect(0, 125280, '\p{--punct}', "");
    Expect(1, 125280, '\p{^--punct}', "");
    Expect(1, 125280, '\P{--punct}', "");
    Expect(0, 125280, '\P{^--punct}', "");
    Error('\p{	is_Punct/a/}');
    Error('\P{	is_Punct/a/}');
    Expect(1, 125279, '\p{ispunct}', "");
    Expect(0, 125279, '\p{^ispunct}', "");
    Expect(0, 125279, '\P{ispunct}', "");
    Expect(1, 125279, '\P{^ispunct}', "");
    Expect(0, 125280, '\p{ispunct}', "");
    Expect(1, 125280, '\p{^ispunct}', "");
    Expect(1, 125280, '\P{ispunct}', "");
    Expect(0, 125280, '\P{^ispunct}', "");
    Expect(1, 125279, '\p{ -Is_punct}', "");
    Expect(0, 125279, '\p{^ -Is_punct}', "");
    Expect(0, 125279, '\P{ -Is_punct}', "");
    Expect(1, 125279, '\P{^ -Is_punct}', "");
    Expect(0, 125280, '\p{ -Is_punct}', "");
    Expect(1, 125280, '\p{^ -Is_punct}', "");
    Expect(1, 125280, '\P{ -Is_punct}', "");
    Expect(0, 125280, '\P{^ -Is_punct}', "");
    Error('\p{/a/__punctuation}');
    Error('\P{/a/__punctuation}');
    Expect(1, 125279, '\p{punctuation}', "");
    Expect(0, 125279, '\p{^punctuation}', "");
    Expect(0, 125279, '\P{punctuation}', "");
    Expect(1, 125279, '\P{^punctuation}', "");
    Expect(0, 125280, '\p{punctuation}', "");
    Expect(1, 125280, '\p{^punctuation}', "");
    Expect(1, 125280, '\P{punctuation}', "");
    Expect(0, 125280, '\P{^punctuation}', "");
    Expect(1, 125279, '\p{	_Punctuation}', "");
    Expect(0, 125279, '\p{^	_Punctuation}', "");
    Expect(0, 125279, '\P{	_Punctuation}', "");
    Expect(1, 125279, '\P{^	_Punctuation}', "");
    Expect(0, 125280, '\p{	_Punctuation}', "");
    Expect(1, 125280, '\p{^	_Punctuation}', "");
    Expect(1, 125280, '\P{	_Punctuation}', "");
    Expect(0, 125280, '\P{^	_Punctuation}', "");
    Error('\p{:=--Is_Punctuation}');
    Error('\P{:=--Is_Punctuation}');
    Expect(1, 125279, '\p{ispunctuation}', "");
    Expect(0, 125279, '\p{^ispunctuation}', "");
    Expect(0, 125279, '\P{ispunctuation}', "");
    Expect(1, 125279, '\P{^ispunctuation}', "");
    Expect(0, 125280, '\p{ispunctuation}', "");
    Expect(1, 125280, '\p{^ispunctuation}', "");
    Expect(1, 125280, '\P{ispunctuation}', "");
    Expect(0, 125280, '\P{^ispunctuation}', "");
    Expect(1, 125279, '\p{ Is_Punctuation}', "");
    Expect(0, 125279, '\p{^ Is_Punctuation}', "");
    Expect(0, 125279, '\P{ Is_Punctuation}', "");
    Expect(1, 125279, '\P{^ Is_Punctuation}', "");
    Expect(0, 125280, '\p{ Is_Punctuation}', "");
    Expect(1, 125280, '\p{^ Is_Punctuation}', "");
    Expect(1, 125280, '\P{ Is_Punctuation}', "");
    Expect(0, 125280, '\P{^ Is_Punctuation}', "");
    Error('\p{_/a/P}');
    Error('\P{_/a/P}');
    Expect(1, 125279, '\p{p}', "");
    Expect(0, 125279, '\p{^p}', "");
    Expect(0, 125279, '\P{p}', "");
    Expect(1, 125279, '\P{^p}', "");
    Expect(0, 125280, '\p{p}', "");
    Expect(1, 125280, '\p{^p}', "");
    Expect(1, 125280, '\P{p}', "");
    Expect(0, 125280, '\P{^p}', "");
    Expect(1, 125279, '\p{_ P}', "");
    Expect(0, 125279, '\p{^_ P}', "");
    Expect(0, 125279, '\P{_ P}', "");
    Expect(1, 125279, '\P{^_ P}', "");
    Expect(0, 125280, '\p{_ P}', "");
    Expect(1, 125280, '\p{^_ P}', "");
    Expect(1, 125280, '\P{_ P}', "");
    Expect(0, 125280, '\P{^_ P}', "");
    Error('\p{_	Is_P:=}');
    Error('\P{_	Is_P:=}');
    Expect(1, 125279, '\p{isp}', "");
    Expect(0, 125279, '\p{^isp}', "");
    Expect(0, 125279, '\P{isp}', "");
    Expect(1, 125279, '\P{^isp}', "");
    Expect(0, 125280, '\p{isp}', "");
    Expect(1, 125280, '\p{^isp}', "");
    Expect(1, 125280, '\P{isp}', "");
    Expect(0, 125280, '\P{^isp}', "");
    Expect(1, 125279, '\p{ 	is_p}', "");
    Expect(0, 125279, '\p{^ 	is_p}', "");
    Expect(0, 125279, '\P{ 	is_p}', "");
    Expect(1, 125279, '\P{^ 	is_p}', "");
    Expect(0, 125280, '\p{ 	is_p}', "");
    Expect(1, 125280, '\p{^ 	is_p}', "");
    Expect(1, 125280, '\P{ 	is_p}', "");
    Expect(0, 125280, '\P{^ 	is_p}', "");
    Error('\p{ /a/QUOTATION_Mark}');
    Error('\P{ /a/QUOTATION_Mark}');
    Expect(1, 65379, '\p{quotationmark}', "");
    Expect(0, 65379, '\p{^quotationmark}', "");
    Expect(0, 65379, '\P{quotationmark}', "");
    Expect(1, 65379, '\P{^quotationmark}', "");
    Expect(0, 65380, '\p{quotationmark}', "");
    Expect(1, 65380, '\p{^quotationmark}', "");
    Expect(1, 65380, '\P{quotationmark}', "");
    Expect(0, 65380, '\P{^quotationmark}', "");
    Expect(1, 65379, '\p{ quotation_MARK}', "");
    Expect(0, 65379, '\p{^ quotation_MARK}', "");
    Expect(0, 65379, '\P{ quotation_MARK}', "");
    Expect(1, 65379, '\P{^ quotation_MARK}', "");
    Expect(0, 65380, '\p{ quotation_MARK}', "");
    Expect(1, 65380, '\p{^ quotation_MARK}', "");
    Expect(1, 65380, '\P{ quotation_MARK}', "");
    Expect(0, 65380, '\P{^ quotation_MARK}', "");
    Error('\p{:=IS_Quotation_MARK}');
    Error('\P{:=IS_Quotation_MARK}');
    Expect(1, 65379, '\p{isquotationmark}', "");
    Expect(0, 65379, '\p{^isquotationmark}', "");
    Expect(0, 65379, '\P{isquotationmark}', "");
    Expect(1, 65379, '\P{^isquotationmark}', "");
    Expect(0, 65380, '\p{isquotationmark}', "");
    Expect(1, 65380, '\p{^isquotationmark}', "");
    Expect(1, 65380, '\P{isquotationmark}', "");
    Expect(0, 65380, '\P{^isquotationmark}', "");
    Expect(1, 65379, '\p{ Is_Quotation_Mark}', "");
    Expect(0, 65379, '\p{^ Is_Quotation_Mark}', "");
    Expect(0, 65379, '\P{ Is_Quotation_Mark}', "");
    Expect(1, 65379, '\P{^ Is_Quotation_Mark}', "");
    Expect(0, 65380, '\p{ Is_Quotation_Mark}', "");
    Expect(1, 65380, '\p{^ Is_Quotation_Mark}', "");
    Expect(1, 65380, '\P{ Is_Quotation_Mark}', "");
    Expect(0, 65380, '\P{^ Is_Quotation_Mark}', "");
    Error('\p{/a/_	QMark}');
    Error('\P{/a/_	QMark}');
    Expect(1, 65379, '\p{qmark}', "");
    Expect(0, 65379, '\p{^qmark}', "");
    Expect(0, 65379, '\P{qmark}', "");
    Expect(1, 65379, '\P{^qmark}', "");
    Expect(0, 65380, '\p{qmark}', "");
    Expect(1, 65380, '\p{^qmark}', "");
    Expect(1, 65380, '\P{qmark}', "");
    Expect(0, 65380, '\P{^qmark}', "");
    Expect(1, 65379, '\p{  qmark}', "");
    Expect(0, 65379, '\p{^  qmark}', "");
    Expect(0, 65379, '\P{  qmark}', "");
    Expect(1, 65379, '\P{^  qmark}', "");
    Expect(0, 65380, '\p{  qmark}', "");
    Expect(1, 65380, '\p{^  qmark}', "");
    Expect(1, 65380, '\P{  qmark}', "");
    Expect(0, 65380, '\P{^  qmark}', "");
    Error('\p{	Is_qmark:=}');
    Error('\P{	Is_qmark:=}');
    Expect(1, 65379, '\p{isqmark}', "");
    Expect(0, 65379, '\p{^isqmark}', "");
    Expect(0, 65379, '\P{isqmark}', "");
    Expect(1, 65379, '\P{^isqmark}', "");
    Expect(0, 65380, '\p{isqmark}', "");
    Expect(1, 65380, '\p{^isqmark}', "");
    Expect(1, 65380, '\P{isqmark}', "");
    Expect(0, 65380, '\P{^isqmark}', "");
    Expect(1, 65379, '\p{	 is_QMark}', "");
    Expect(0, 65379, '\p{^	 is_QMark}', "");
    Expect(0, 65379, '\P{	 is_QMark}', "");
    Expect(1, 65379, '\P{^	 is_QMark}', "");
    Expect(0, 65380, '\p{	 is_QMark}', "");
    Expect(1, 65380, '\p{^	 is_QMark}', "");
    Expect(1, 65380, '\P{	 is_QMark}', "");
    Expect(0, 65380, '\P{^	 is_QMark}', "");
    Error('\p{_:=radical}');
    Error('\P{_:=radical}');
    Expect(1, 12245, '\p{radical}', "");
    Expect(0, 12245, '\p{^radical}', "");
    Expect(0, 12245, '\P{radical}', "");
    Expect(1, 12245, '\P{^radical}', "");
    Expect(0, 12246, '\p{radical}', "");
    Expect(1, 12246, '\p{^radical}', "");
    Expect(1, 12246, '\P{radical}', "");
    Expect(0, 12246, '\P{^radical}', "");
    Expect(1, 12245, '\p{_Radical}', "");
    Expect(0, 12245, '\p{^_Radical}', "");
    Expect(0, 12245, '\P{_Radical}', "");
    Expect(1, 12245, '\P{^_Radical}', "");
    Expect(0, 12246, '\p{_Radical}', "");
    Expect(1, 12246, '\p{^_Radical}', "");
    Expect(1, 12246, '\P{_Radical}', "");
    Expect(0, 12246, '\P{^_Radical}', "");
    Error('\p{ Is_RADICAL:=}');
    Error('\P{ Is_RADICAL:=}');
    Expect(1, 12245, '\p{isradical}', "");
    Expect(0, 12245, '\p{^isradical}', "");
    Expect(0, 12245, '\P{isradical}', "");
    Expect(1, 12245, '\P{^isradical}', "");
    Expect(0, 12246, '\p{isradical}', "");
    Expect(1, 12246, '\p{^isradical}', "");
    Expect(1, 12246, '\P{isradical}', "");
    Expect(0, 12246, '\P{^isradical}', "");
    Expect(1, 12245, '\p{_is_Radical}', "");
    Expect(0, 12245, '\p{^_is_Radical}', "");
    Expect(0, 12245, '\P{_is_Radical}', "");
    Expect(1, 12245, '\P{^_is_Radical}', "");
    Expect(0, 12246, '\p{_is_Radical}', "");
    Expect(1, 12246, '\p{^_is_Radical}', "");
    Expect(1, 12246, '\P{_is_Radical}', "");
    Expect(0, 12246, '\P{^_is_Radical}', "");
    Error('\p{:=_	regional_indicator}');
    Error('\P{:=_	regional_indicator}');
    Expect(1, 127487, '\p{regionalindicator}', "");
    Expect(0, 127487, '\p{^regionalindicator}', "");
    Expect(0, 127487, '\P{regionalindicator}', "");
    Expect(1, 127487, '\P{^regionalindicator}', "");
    Expect(0, 127488, '\p{regionalindicator}', "");
    Expect(1, 127488, '\p{^regionalindicator}', "");
    Expect(1, 127488, '\P{regionalindicator}', "");
    Expect(0, 127488, '\P{^regionalindicator}', "");
    Expect(1, 127487, '\p{	regional_Indicator}', "");
    Expect(0, 127487, '\p{^	regional_Indicator}', "");
    Expect(0, 127487, '\P{	regional_Indicator}', "");
    Expect(1, 127487, '\P{^	regional_Indicator}', "");
    Expect(0, 127488, '\p{	regional_Indicator}', "");
    Expect(1, 127488, '\p{^	regional_Indicator}', "");
    Expect(1, 127488, '\P{	regional_Indicator}', "");
    Expect(0, 127488, '\P{^	regional_Indicator}', "");
    Error('\p{:=-Is_Regional_Indicator}');
    Error('\P{:=-Is_Regional_Indicator}');
    Expect(1, 127487, '\p{isregionalindicator}', "");
    Expect(0, 127487, '\p{^isregionalindicator}', "");
    Expect(0, 127487, '\P{isregionalindicator}', "");
    Expect(1, 127487, '\P{^isregionalindicator}', "");
    Expect(0, 127488, '\p{isregionalindicator}', "");
    Expect(1, 127488, '\p{^isregionalindicator}', "");
    Expect(1, 127488, '\P{isregionalindicator}', "");
    Expect(0, 127488, '\P{^isregionalindicator}', "");
    Expect(1, 127487, '\p{_	Is_REGIONAL_Indicator}', "");
    Expect(0, 127487, '\p{^_	Is_REGIONAL_Indicator}', "");
    Expect(0, 127487, '\P{_	Is_REGIONAL_Indicator}', "");
    Expect(1, 127487, '\P{^_	Is_REGIONAL_Indicator}', "");
    Expect(0, 127488, '\p{_	Is_REGIONAL_Indicator}', "");
    Expect(1, 127488, '\p{^_	Is_REGIONAL_Indicator}', "");
    Expect(1, 127488, '\P{_	Is_REGIONAL_Indicator}', "");
    Expect(0, 127488, '\P{^_	Is_REGIONAL_Indicator}', "");
    Error('\p{- RI:=}');
    Error('\P{- RI:=}');
    Expect(1, 127487, '\p{ri}', "");
    Expect(0, 127487, '\p{^ri}', "");
    Expect(0, 127487, '\P{ri}', "");
    Expect(1, 127487, '\P{^ri}', "");
    Expect(0, 127488, '\p{ri}', "");
    Expect(1, 127488, '\p{^ri}', "");
    Expect(1, 127488, '\P{ri}', "");
    Expect(0, 127488, '\P{^ri}', "");
    Expect(1, 127487, '\p{_ RI}', "");
    Expect(0, 127487, '\p{^_ RI}', "");
    Expect(0, 127487, '\P{_ RI}', "");
    Expect(1, 127487, '\P{^_ RI}', "");
    Expect(0, 127488, '\p{_ RI}', "");
    Expect(1, 127488, '\p{^_ RI}', "");
    Expect(1, 127488, '\P{_ RI}', "");
    Expect(0, 127488, '\P{^_ RI}', "");
    Error('\p{_ Is_ri:=}');
    Error('\P{_ Is_ri:=}');
    Expect(1, 127487, '\p{isri}', "");
    Expect(0, 127487, '\p{^isri}', "");
    Expect(0, 127487, '\P{isri}', "");
    Expect(1, 127487, '\P{^isri}', "");
    Expect(0, 127488, '\p{isri}', "");
    Expect(1, 127488, '\p{^isri}', "");
    Expect(1, 127488, '\P{isri}', "");
    Expect(0, 127488, '\P{^isri}', "");
    Expect(1, 127487, '\p{ Is_ri}', "");
    Expect(0, 127487, '\p{^ Is_ri}', "");
    Expect(0, 127487, '\P{ Is_ri}', "");
    Expect(1, 127487, '\P{^ Is_ri}', "");
    Expect(0, 127488, '\p{ Is_ri}', "");
    Expect(1, 127488, '\p{^ Is_ri}', "");
    Expect(1, 127488, '\P{ Is_ri}', "");
    Expect(0, 127488, '\P{^ Is_ri}', "");
    Error('\p{--Rejang/a/}');
    Error('\P{--Rejang/a/}');
    Expect(1, 43359, '\p{rejang}', "");
    Expect(0, 43359, '\p{^rejang}', "");
    Expect(0, 43359, '\P{rejang}', "");
    Expect(1, 43359, '\P{^rejang}', "");
    Expect(0, 43360, '\p{rejang}', "");
    Expect(1, 43360, '\p{^rejang}', "");
    Expect(1, 43360, '\P{rejang}', "");
    Expect(0, 43360, '\P{^rejang}', "");
    Expect(1, 43359, '\p{_ REJANG}', "");
    Expect(0, 43359, '\p{^_ REJANG}', "");
    Expect(0, 43359, '\P{_ REJANG}', "");
    Expect(1, 43359, '\P{^_ REJANG}', "");
    Expect(0, 43360, '\p{_ REJANG}', "");
    Expect(1, 43360, '\p{^_ REJANG}', "");
    Expect(1, 43360, '\P{_ REJANG}', "");
    Expect(0, 43360, '\P{^_ REJANG}', "");
    Error('\p{-/a/is_REJANG}');
    Error('\P{-/a/is_REJANG}');
    Expect(1, 43359, '\p{isrejang}', "");
    Expect(0, 43359, '\p{^isrejang}', "");
    Expect(0, 43359, '\P{isrejang}', "");
    Expect(1, 43359, '\P{^isrejang}', "");
    Expect(0, 43360, '\p{isrejang}', "");
    Expect(1, 43360, '\p{^isrejang}', "");
    Expect(1, 43360, '\P{isrejang}', "");
    Expect(0, 43360, '\P{^isrejang}', "");
    Expect(1, 43359, '\p{	_IS_Rejang}', "");
    Expect(0, 43359, '\p{^	_IS_Rejang}', "");
    Expect(0, 43359, '\P{	_IS_Rejang}', "");
    Expect(1, 43359, '\P{^	_IS_Rejang}', "");
    Expect(0, 43360, '\p{	_IS_Rejang}', "");
    Expect(1, 43360, '\p{^	_IS_Rejang}', "");
    Expect(1, 43360, '\P{	_IS_Rejang}', "");
    Expect(0, 43360, '\P{^	_IS_Rejang}', "");
    Error('\p{	RJNG:=}');
    Error('\P{	RJNG:=}');
    Expect(1, 43359, '\p{rjng}', "");
    Expect(0, 43359, '\p{^rjng}', "");
    Expect(0, 43359, '\P{rjng}', "");
    Expect(1, 43359, '\P{^rjng}', "");
    Expect(0, 43360, '\p{rjng}', "");
    Expect(1, 43360, '\p{^rjng}', "");
    Expect(1, 43360, '\P{rjng}', "");
    Expect(0, 43360, '\P{^rjng}', "");
    Expect(1, 43359, '\p{-	Rjng}', "");
    Expect(0, 43359, '\p{^-	Rjng}', "");
    Expect(0, 43359, '\P{-	Rjng}', "");
    Expect(1, 43359, '\P{^-	Rjng}', "");
    Expect(0, 43360, '\p{-	Rjng}', "");
    Expect(1, 43360, '\p{^-	Rjng}', "");
    Expect(1, 43360, '\P{-	Rjng}', "");
    Expect(0, 43360, '\P{^-	Rjng}', "");
    Error('\p{  Is_Rjng:=}');
    Error('\P{  Is_Rjng:=}');
    Expect(1, 43359, '\p{isrjng}', "");
    Expect(0, 43359, '\p{^isrjng}', "");
    Expect(0, 43359, '\P{isrjng}', "");
    Expect(1, 43359, '\P{^isrjng}', "");
    Expect(0, 43360, '\p{isrjng}', "");
    Expect(1, 43360, '\p{^isrjng}', "");
    Expect(1, 43360, '\P{isrjng}', "");
    Expect(0, 43360, '\P{^isrjng}', "");
    Expect(1, 43359, '\p{_	Is_Rjng}', "");
    Expect(0, 43359, '\p{^_	Is_Rjng}', "");
    Expect(0, 43359, '\P{_	Is_Rjng}', "");
    Expect(1, 43359, '\P{^_	Is_Rjng}', "");
    Expect(0, 43360, '\p{_	Is_Rjng}', "");
    Expect(1, 43360, '\p{^_	Is_Rjng}', "");
    Expect(1, 43360, '\P{_	Is_Rjng}', "");
    Expect(0, 43360, '\P{^_	Is_Rjng}', "");
    Error('\p{-:=rumi_NUMERAL_SYMBOLS}');
    Error('\P{-:=rumi_NUMERAL_SYMBOLS}');
    Expect(1, 69247, '\p{ruminumeralsymbols}', "");
    Expect(0, 69247, '\p{^ruminumeralsymbols}', "");
    Expect(0, 69247, '\P{ruminumeralsymbols}', "");
    Expect(1, 69247, '\P{^ruminumeralsymbols}', "");
    Expect(0, 69248, '\p{ruminumeralsymbols}', "");
    Expect(1, 69248, '\p{^ruminumeralsymbols}', "");
    Expect(1, 69248, '\P{ruminumeralsymbols}', "");
    Expect(0, 69248, '\P{^ruminumeralsymbols}', "");
    Expect(1, 69247, '\p{--Rumi_Numeral_SYMBOLS}', "");
    Expect(0, 69247, '\p{^--Rumi_Numeral_SYMBOLS}', "");
    Expect(0, 69247, '\P{--Rumi_Numeral_SYMBOLS}', "");
    Expect(1, 69247, '\P{^--Rumi_Numeral_SYMBOLS}', "");
    Expect(0, 69248, '\p{--Rumi_Numeral_SYMBOLS}', "");
    Expect(1, 69248, '\p{^--Rumi_Numeral_SYMBOLS}', "");
    Expect(1, 69248, '\P{--Rumi_Numeral_SYMBOLS}', "");
    Expect(0, 69248, '\P{^--Rumi_Numeral_SYMBOLS}', "");
    Error('\p{  IS_rumi_numeral_Symbols/a/}');
    Error('\P{  IS_rumi_numeral_Symbols/a/}');
    Expect(1, 69247, '\p{isruminumeralsymbols}', "");
    Expect(0, 69247, '\p{^isruminumeralsymbols}', "");
    Expect(0, 69247, '\P{isruminumeralsymbols}', "");
    Expect(1, 69247, '\P{^isruminumeralsymbols}', "");
    Expect(0, 69248, '\p{isruminumeralsymbols}', "");
    Expect(1, 69248, '\p{^isruminumeralsymbols}', "");
    Expect(1, 69248, '\P{isruminumeralsymbols}', "");
    Expect(0, 69248, '\P{^isruminumeralsymbols}', "");
    Expect(1, 69247, '\p{  IS_Rumi_NUMERAL_symbols}', "");
    Expect(0, 69247, '\p{^  IS_Rumi_NUMERAL_symbols}', "");
    Expect(0, 69247, '\P{  IS_Rumi_NUMERAL_symbols}', "");
    Expect(1, 69247, '\P{^  IS_Rumi_NUMERAL_symbols}', "");
    Expect(0, 69248, '\p{  IS_Rumi_NUMERAL_symbols}', "");
    Expect(1, 69248, '\p{^  IS_Rumi_NUMERAL_symbols}', "");
    Expect(1, 69248, '\P{  IS_Rumi_NUMERAL_symbols}', "");
    Expect(0, 69248, '\P{^  IS_Rumi_NUMERAL_symbols}', "");
    Error('\p{/a/_ In_Rumi_numeral_symbols}');
    Error('\P{/a/_ In_Rumi_numeral_symbols}');
    Expect(1, 69247, '\p{inruminumeralsymbols}', "");
    Expect(0, 69247, '\p{^inruminumeralsymbols}', "");
    Expect(0, 69247, '\P{inruminumeralsymbols}', "");
    Expect(1, 69247, '\P{^inruminumeralsymbols}', "");
    Expect(0, 69248, '\p{inruminumeralsymbols}', "");
    Expect(1, 69248, '\p{^inruminumeralsymbols}', "");
    Expect(1, 69248, '\P{inruminumeralsymbols}', "");
    Expect(0, 69248, '\P{^inruminumeralsymbols}', "");
    Expect(1, 69247, '\p{		IN_Rumi_Numeral_symbols}', "");
    Expect(0, 69247, '\p{^		IN_Rumi_Numeral_symbols}', "");
    Expect(0, 69247, '\P{		IN_Rumi_Numeral_symbols}', "");
    Expect(1, 69247, '\P{^		IN_Rumi_Numeral_symbols}', "");
    Expect(0, 69248, '\p{		IN_Rumi_Numeral_symbols}', "");
    Expect(1, 69248, '\p{^		IN_Rumi_Numeral_symbols}', "");
    Expect(1, 69248, '\P{		IN_Rumi_Numeral_symbols}', "");
    Expect(0, 69248, '\P{^		IN_Rumi_Numeral_symbols}', "");
    Error('\p{Rumi/a/}');
    Error('\P{Rumi/a/}');
    Expect(1, 69247, '\p{rumi}', "");
    Expect(0, 69247, '\p{^rumi}', "");
    Expect(0, 69247, '\P{rumi}', "");
    Expect(1, 69247, '\P{^rumi}', "");
    Expect(0, 69248, '\p{rumi}', "");
    Expect(1, 69248, '\p{^rumi}', "");
    Expect(1, 69248, '\P{rumi}', "");
    Expect(0, 69248, '\P{^rumi}', "");
    Expect(1, 69247, '\p{__Rumi}', "");
    Expect(0, 69247, '\p{^__Rumi}', "");
    Expect(0, 69247, '\P{__Rumi}', "");
    Expect(1, 69247, '\P{^__Rumi}', "");
    Expect(0, 69248, '\p{__Rumi}', "");
    Expect(1, 69248, '\p{^__Rumi}', "");
    Expect(1, 69248, '\P{__Rumi}', "");
    Expect(0, 69248, '\P{^__Rumi}', "");
    Error('\p{:=Is_Rumi}');
    Error('\P{:=Is_Rumi}');
    Expect(1, 69247, '\p{isrumi}', "");
    Expect(0, 69247, '\p{^isrumi}', "");
    Expect(0, 69247, '\P{isrumi}', "");
    Expect(1, 69247, '\P{^isrumi}', "");
    Expect(0, 69248, '\p{isrumi}', "");
    Expect(1, 69248, '\p{^isrumi}', "");
    Expect(1, 69248, '\P{isrumi}', "");
    Expect(0, 69248, '\P{^isrumi}', "");
    Expect(1, 69247, '\p{-	Is_Rumi}', "");
    Expect(0, 69247, '\p{^-	Is_Rumi}', "");
    Expect(0, 69247, '\P{-	Is_Rumi}', "");
    Expect(1, 69247, '\P{^-	Is_Rumi}', "");
    Expect(0, 69248, '\p{-	Is_Rumi}', "");
    Expect(1, 69248, '\p{^-	Is_Rumi}', "");
    Expect(1, 69248, '\P{-	Is_Rumi}', "");
    Expect(0, 69248, '\P{^-	Is_Rumi}', "");
    Error('\p{-in_Rumi/a/}');
    Error('\P{-in_Rumi/a/}');
    Expect(1, 69247, '\p{inrumi}', "");
    Expect(0, 69247, '\p{^inrumi}', "");
    Expect(0, 69247, '\P{inrumi}', "");
    Expect(1, 69247, '\P{^inrumi}', "");
    Expect(0, 69248, '\p{inrumi}', "");
    Expect(1, 69248, '\p{^inrumi}', "");
    Expect(1, 69248, '\P{inrumi}', "");
    Expect(0, 69248, '\P{^inrumi}', "");
    Expect(1, 69247, '\p{ -in_Rumi}', "");
    Expect(0, 69247, '\p{^ -in_Rumi}', "");
    Expect(0, 69247, '\P{ -in_Rumi}', "");
    Expect(1, 69247, '\P{^ -in_Rumi}', "");
    Expect(0, 69248, '\p{ -in_Rumi}', "");
    Expect(1, 69248, '\p{^ -in_Rumi}', "");
    Expect(1, 69248, '\P{ -in_Rumi}', "");
    Expect(0, 69248, '\P{^ -in_Rumi}', "");
    Error('\p{:=_ Runic}');
    Error('\P{:=_ Runic}');
    Expect(1, 5880, '\p{runic}', "");
    Expect(0, 5880, '\p{^runic}', "");
    Expect(0, 5880, '\P{runic}', "");
    Expect(1, 5880, '\P{^runic}', "");
    Expect(0, 5881, '\p{runic}', "");
    Expect(1, 5881, '\p{^runic}', "");
    Expect(1, 5881, '\P{runic}', "");
    Expect(0, 5881, '\P{^runic}', "");
    Expect(1, 5880, '\p{-	runic}', "");
    Expect(0, 5880, '\p{^-	runic}', "");
    Expect(0, 5880, '\P{-	runic}', "");
    Expect(1, 5880, '\P{^-	runic}', "");
    Expect(0, 5881, '\p{-	runic}', "");
    Expect(1, 5881, '\p{^-	runic}', "");
    Expect(1, 5881, '\P{-	runic}', "");
    Expect(0, 5881, '\P{^-	runic}', "");
    Error('\p{/a/IS_RUNIC}');
    Error('\P{/a/IS_RUNIC}');
    Expect(1, 5880, '\p{isrunic}', "");
    Expect(0, 5880, '\p{^isrunic}', "");
    Expect(0, 5880, '\P{isrunic}', "");
    Expect(1, 5880, '\P{^isrunic}', "");
    Expect(0, 5881, '\p{isrunic}', "");
    Expect(1, 5881, '\p{^isrunic}', "");
    Expect(1, 5881, '\P{isrunic}', "");
    Expect(0, 5881, '\P{^isrunic}', "");
    Expect(1, 5880, '\p{ _Is_RUNIC}', "");
    Expect(0, 5880, '\p{^ _Is_RUNIC}', "");
    Expect(0, 5880, '\P{ _Is_RUNIC}', "");
    Expect(1, 5880, '\P{^ _Is_RUNIC}', "");
    Expect(0, 5881, '\p{ _Is_RUNIC}', "");
    Expect(1, 5881, '\p{^ _Is_RUNIC}', "");
    Expect(1, 5881, '\P{ _Is_RUNIC}', "");
    Expect(0, 5881, '\P{^ _Is_RUNIC}', "");
    Error('\p{ :=Runr}');
    Error('\P{ :=Runr}');
    Expect(1, 5880, '\p{runr}', "");
    Expect(0, 5880, '\p{^runr}', "");
    Expect(0, 5880, '\P{runr}', "");
    Expect(1, 5880, '\P{^runr}', "");
    Expect(0, 5881, '\p{runr}', "");
    Expect(1, 5881, '\p{^runr}', "");
    Expect(1, 5881, '\P{runr}', "");
    Expect(0, 5881, '\P{^runr}', "");
    Expect(1, 5880, '\p{-Runr}', "");
    Expect(0, 5880, '\p{^-Runr}', "");
    Expect(0, 5880, '\P{-Runr}', "");
    Expect(1, 5880, '\P{^-Runr}', "");
    Expect(0, 5881, '\p{-Runr}', "");
    Expect(1, 5881, '\p{^-Runr}', "");
    Expect(1, 5881, '\P{-Runr}', "");
    Expect(0, 5881, '\P{^-Runr}', "");
    Error('\p{:=-is_Runr}');
    Error('\P{:=-is_Runr}');
    Expect(1, 5880, '\p{isrunr}', "");
    Expect(0, 5880, '\p{^isrunr}', "");
    Expect(0, 5880, '\P{isrunr}', "");
    Expect(1, 5880, '\P{^isrunr}', "");
    Expect(0, 5881, '\p{isrunr}', "");
    Expect(1, 5881, '\p{^isrunr}', "");
    Expect(1, 5881, '\P{isrunr}', "");
    Expect(0, 5881, '\P{^isrunr}', "");
    Expect(1, 5880, '\p{  Is_Runr}', "");
    Expect(0, 5880, '\p{^  Is_Runr}', "");
    Expect(0, 5880, '\P{  Is_Runr}', "");
    Expect(1, 5880, '\P{^  Is_Runr}', "");
    Expect(0, 5881, '\p{  Is_Runr}', "");
    Expect(1, 5881, '\p{^  Is_Runr}', "");
    Expect(1, 5881, '\P{  Is_Runr}', "");
    Expect(0, 5881, '\P{^  Is_Runr}', "");
    Error('\p{	/a/Samaritan}');
    Error('\P{	/a/Samaritan}');
    Expect(1, 2110, '\p{samaritan}', "");
    Expect(0, 2110, '\p{^samaritan}', "");
    Expect(0, 2110, '\P{samaritan}', "");
    Expect(1, 2110, '\P{^samaritan}', "");
    Expect(0, 2111, '\p{samaritan}', "");
    Expect(1, 2111, '\p{^samaritan}', "");
    Expect(1, 2111, '\P{samaritan}', "");
    Expect(0, 2111, '\P{^samaritan}', "");
    Expect(1, 2110, '\p{_Samaritan}', "");
    Expect(0, 2110, '\p{^_Samaritan}', "");
    Expect(0, 2110, '\P{_Samaritan}', "");
    Expect(1, 2110, '\P{^_Samaritan}', "");
    Expect(0, 2111, '\p{_Samaritan}', "");
    Expect(1, 2111, '\p{^_Samaritan}', "");
    Expect(1, 2111, '\P{_Samaritan}', "");
    Expect(0, 2111, '\P{^_Samaritan}', "");
    Error('\p{:=-Is_Samaritan}');
    Error('\P{:=-Is_Samaritan}');
    Expect(1, 2110, '\p{issamaritan}', "");
    Expect(0, 2110, '\p{^issamaritan}', "");
    Expect(0, 2110, '\P{issamaritan}', "");
    Expect(1, 2110, '\P{^issamaritan}', "");
    Expect(0, 2111, '\p{issamaritan}', "");
    Expect(1, 2111, '\p{^issamaritan}', "");
    Expect(1, 2111, '\P{issamaritan}', "");
    Expect(0, 2111, '\P{^issamaritan}', "");
    Expect(1, 2110, '\p{-_IS_samaritan}', "");
    Expect(0, 2110, '\p{^-_IS_samaritan}', "");
    Expect(0, 2110, '\P{-_IS_samaritan}', "");
    Expect(1, 2110, '\P{^-_IS_samaritan}', "");
    Expect(0, 2111, '\p{-_IS_samaritan}', "");
    Expect(1, 2111, '\p{^-_IS_samaritan}', "");
    Expect(1, 2111, '\P{-_IS_samaritan}', "");
    Expect(0, 2111, '\P{^-_IS_samaritan}', "");
    Error('\p{_:=Samr}');
    Error('\P{_:=Samr}');
    Expect(1, 2110, '\p{samr}', "");
    Expect(0, 2110, '\p{^samr}', "");
    Expect(0, 2110, '\P{samr}', "");
    Expect(1, 2110, '\P{^samr}', "");
    Expect(0, 2111, '\p{samr}', "");
    Expect(1, 2111, '\p{^samr}', "");
    Expect(1, 2111, '\P{samr}', "");
    Expect(0, 2111, '\P{^samr}', "");
    Expect(1, 2110, '\p{SAMR}', "");
    Expect(0, 2110, '\p{^SAMR}', "");
    Expect(0, 2110, '\P{SAMR}', "");
    Expect(1, 2110, '\P{^SAMR}', "");
    Expect(0, 2111, '\p{SAMR}', "");
    Expect(1, 2111, '\p{^SAMR}', "");
    Expect(1, 2111, '\P{SAMR}', "");
    Expect(0, 2111, '\P{^SAMR}', "");
    Error('\p{	:=IS_samr}');
    Error('\P{	:=IS_samr}');
    Expect(1, 2110, '\p{issamr}', "");
    Expect(0, 2110, '\p{^issamr}', "");
    Expect(0, 2110, '\P{issamr}', "");
    Expect(1, 2110, '\P{^issamr}', "");
    Expect(0, 2111, '\p{issamr}', "");
    Expect(1, 2111, '\p{^issamr}', "");
    Expect(1, 2111, '\P{issamr}', "");
    Expect(0, 2111, '\P{^issamr}', "");
    Expect(1, 2110, '\p{	IS_Samr}', "");
    Expect(0, 2110, '\p{^	IS_Samr}', "");
    Expect(0, 2110, '\P{	IS_Samr}', "");
    Expect(1, 2110, '\P{^	IS_Samr}', "");
    Expect(0, 2111, '\p{	IS_Samr}', "");
    Expect(1, 2111, '\p{^	IS_Samr}', "");
    Expect(1, 2111, '\P{	IS_Samr}', "");
    Expect(0, 2111, '\P{^	IS_Samr}', "");
    Error('\p{/a/__saurashtra}');
    Error('\P{/a/__saurashtra}');
    Expect(1, 43225, '\p{saurashtra}', "");
    Expect(0, 43225, '\p{^saurashtra}', "");
    Expect(0, 43225, '\P{saurashtra}', "");
    Expect(1, 43225, '\P{^saurashtra}', "");
    Expect(0, 43226, '\p{saurashtra}', "");
    Expect(1, 43226, '\p{^saurashtra}', "");
    Expect(1, 43226, '\P{saurashtra}', "");
    Expect(0, 43226, '\P{^saurashtra}', "");
    Expect(1, 43225, '\p{  Saurashtra}', "");
    Expect(0, 43225, '\p{^  Saurashtra}', "");
    Expect(0, 43225, '\P{  Saurashtra}', "");
    Expect(1, 43225, '\P{^  Saurashtra}', "");
    Expect(0, 43226, '\p{  Saurashtra}', "");
    Expect(1, 43226, '\p{^  Saurashtra}', "");
    Expect(1, 43226, '\P{  Saurashtra}', "");
    Expect(0, 43226, '\P{^  Saurashtra}', "");
    Error('\p{/a/--Is_saurashtra}');
    Error('\P{/a/--Is_saurashtra}');
    Expect(1, 43225, '\p{issaurashtra}', "");
    Expect(0, 43225, '\p{^issaurashtra}', "");
    Expect(0, 43225, '\P{issaurashtra}', "");
    Expect(1, 43225, '\P{^issaurashtra}', "");
    Expect(0, 43226, '\p{issaurashtra}', "");
    Expect(1, 43226, '\p{^issaurashtra}', "");
    Expect(1, 43226, '\P{issaurashtra}', "");
    Expect(0, 43226, '\P{^issaurashtra}', "");
    Expect(1, 43225, '\p{-_is_Saurashtra}', "");
    Expect(0, 43225, '\p{^-_is_Saurashtra}', "");
    Expect(0, 43225, '\P{-_is_Saurashtra}', "");
    Expect(1, 43225, '\P{^-_is_Saurashtra}', "");
    Expect(0, 43226, '\p{-_is_Saurashtra}', "");
    Expect(1, 43226, '\p{^-_is_Saurashtra}', "");
    Expect(1, 43226, '\P{-_is_Saurashtra}', "");
    Expect(0, 43226, '\P{^-_is_Saurashtra}', "");
    Error('\p{:=  SAUR}');
    Error('\P{:=  SAUR}');
    Expect(1, 43225, '\p{saur}', "");
    Expect(0, 43225, '\p{^saur}', "");
    Expect(0, 43225, '\P{saur}', "");
    Expect(1, 43225, '\P{^saur}', "");
    Expect(0, 43226, '\p{saur}', "");
    Expect(1, 43226, '\p{^saur}', "");
    Expect(1, 43226, '\P{saur}', "");
    Expect(0, 43226, '\P{^saur}', "");
    Expect(1, 43225, '\p{-SAUR}', "");
    Expect(0, 43225, '\p{^-SAUR}', "");
    Expect(0, 43225, '\P{-SAUR}', "");
    Expect(1, 43225, '\P{^-SAUR}', "");
    Expect(0, 43226, '\p{-SAUR}', "");
    Expect(1, 43226, '\p{^-SAUR}', "");
    Expect(1, 43226, '\P{-SAUR}', "");
    Expect(0, 43226, '\P{^-SAUR}', "");
    Error('\p{		is_saur:=}');
    Error('\P{		is_saur:=}');
    Expect(1, 43225, '\p{issaur}', "");
    Expect(0, 43225, '\p{^issaur}', "");
    Expect(0, 43225, '\P{issaur}', "");
    Expect(1, 43225, '\P{^issaur}', "");
    Expect(0, 43226, '\p{issaur}', "");
    Expect(1, 43226, '\p{^issaur}', "");
    Expect(1, 43226, '\P{issaur}', "");
    Expect(0, 43226, '\P{^issaur}', "");
    Expect(1, 43225, '\p{ IS_Saur}', "");
    Expect(0, 43225, '\p{^ IS_Saur}', "");
    Expect(0, 43225, '\P{ IS_Saur}', "");
    Expect(1, 43225, '\P{^ IS_Saur}', "");
    Expect(0, 43226, '\p{ IS_Saur}', "");
    Expect(1, 43226, '\p{^ IS_Saur}', "");
    Expect(1, 43226, '\P{ IS_Saur}', "");
    Expect(0, 43226, '\P{^ IS_Saur}', "");
    Error('\p{:=  Sentence_TERMINAL}');
    Error('\P{:=  Sentence_TERMINAL}');
    Expect(1, 121480, '\p{sentenceterminal}', "");
    Expect(0, 121480, '\p{^sentenceterminal}', "");
    Expect(0, 121480, '\P{sentenceterminal}', "");
    Expect(1, 121480, '\P{^sentenceterminal}', "");
    Expect(0, 121481, '\p{sentenceterminal}', "");
    Expect(1, 121481, '\p{^sentenceterminal}', "");
    Expect(1, 121481, '\P{sentenceterminal}', "");
    Expect(0, 121481, '\P{^sentenceterminal}', "");
    Expect(1, 121480, '\p{	 Sentence_Terminal}', "");
    Expect(0, 121480, '\p{^	 Sentence_Terminal}', "");
    Expect(0, 121480, '\P{	 Sentence_Terminal}', "");
    Expect(1, 121480, '\P{^	 Sentence_Terminal}', "");
    Expect(0, 121481, '\p{	 Sentence_Terminal}', "");
    Expect(1, 121481, '\p{^	 Sentence_Terminal}', "");
    Expect(1, 121481, '\P{	 Sentence_Terminal}', "");
    Expect(0, 121481, '\P{^	 Sentence_Terminal}', "");
    Error('\p{-/a/Is_Sentence_Terminal}');
    Error('\P{-/a/Is_Sentence_Terminal}');
    Expect(1, 121480, '\p{issentenceterminal}', "");
    Expect(0, 121480, '\p{^issentenceterminal}', "");
    Expect(0, 121480, '\P{issentenceterminal}', "");
    Expect(1, 121480, '\P{^issentenceterminal}', "");
    Expect(0, 121481, '\p{issentenceterminal}', "");
    Expect(1, 121481, '\p{^issentenceterminal}', "");
    Expect(1, 121481, '\P{issentenceterminal}', "");
    Expect(0, 121481, '\P{^issentenceterminal}', "");
    Expect(1, 121480, '\p{-	IS_Sentence_terminal}', "");
    Expect(0, 121480, '\p{^-	IS_Sentence_terminal}', "");
    Expect(0, 121480, '\P{-	IS_Sentence_terminal}', "");
    Expect(1, 121480, '\P{^-	IS_Sentence_terminal}', "");
    Expect(0, 121481, '\p{-	IS_Sentence_terminal}', "");
    Expect(1, 121481, '\p{^-	IS_Sentence_terminal}', "");
    Expect(1, 121481, '\P{-	IS_Sentence_terminal}', "");
    Expect(0, 121481, '\P{^-	IS_Sentence_terminal}', "");
    Error('\p{-/a/sterm}');
    Error('\P{-/a/sterm}');
    Expect(1, 121480, '\p{sterm}', "");
    Expect(0, 121480, '\p{^sterm}', "");
    Expect(0, 121480, '\P{sterm}', "");
    Expect(1, 121480, '\P{^sterm}', "");
    Expect(0, 121481, '\p{sterm}', "");
    Expect(1, 121481, '\p{^sterm}', "");
    Expect(1, 121481, '\P{sterm}', "");
    Expect(0, 121481, '\P{^sterm}', "");
    Expect(1, 121480, '\p{	sterm}', "");
    Expect(0, 121480, '\p{^	sterm}', "");
    Expect(0, 121480, '\P{	sterm}', "");
    Expect(1, 121480, '\P{^	sterm}', "");
    Expect(0, 121481, '\p{	sterm}', "");
    Expect(1, 121481, '\p{^	sterm}', "");
    Expect(1, 121481, '\P{	sterm}', "");
    Expect(0, 121481, '\P{^	sterm}', "");
    Error('\p{:=-_is_STERM}');
    Error('\P{:=-_is_STERM}');
    Expect(1, 121480, '\p{issterm}', "");
    Expect(0, 121480, '\p{^issterm}', "");
    Expect(0, 121480, '\P{issterm}', "");
    Expect(1, 121480, '\P{^issterm}', "");
    Expect(0, 121481, '\p{issterm}', "");
    Expect(1, 121481, '\p{^issterm}', "");
    Expect(1, 121481, '\P{issterm}', "");
    Expect(0, 121481, '\P{^issterm}', "");
    Expect(1, 121480, '\p{__Is_sterm}', "");
    Expect(0, 121480, '\p{^__Is_sterm}', "");
    Expect(0, 121480, '\P{__Is_sterm}', "");
    Expect(1, 121480, '\P{^__Is_sterm}', "");
    Expect(0, 121481, '\p{__Is_sterm}', "");
    Expect(1, 121481, '\p{^__Is_sterm}', "");
    Expect(1, 121481, '\P{__Is_sterm}', "");
    Expect(0, 121481, '\P{^__Is_sterm}', "");
    Error('\p{-/a/SEPARATOR}');
    Error('\P{-/a/SEPARATOR}');
    Expect(1, 12288, '\p{separator}', "");
    Expect(0, 12288, '\p{^separator}', "");
    Expect(0, 12288, '\P{separator}', "");
    Expect(1, 12288, '\P{^separator}', "");
    Expect(0, 12289, '\p{separator}', "");
    Expect(1, 12289, '\p{^separator}', "");
    Expect(1, 12289, '\P{separator}', "");
    Expect(0, 12289, '\P{^separator}', "");
    Expect(1, 12288, '\p{  separator}', "");
    Expect(0, 12288, '\p{^  separator}', "");
    Expect(0, 12288, '\P{  separator}', "");
    Expect(1, 12288, '\P{^  separator}', "");
    Expect(0, 12289, '\p{  separator}', "");
    Expect(1, 12289, '\p{^  separator}', "");
    Expect(1, 12289, '\P{  separator}', "");
    Expect(0, 12289, '\P{^  separator}', "");
    Error('\p{	Is_separator:=}');
    Error('\P{	Is_separator:=}');
    Expect(1, 12288, '\p{isseparator}', "");
    Expect(0, 12288, '\p{^isseparator}', "");
    Expect(0, 12288, '\P{isseparator}', "");
    Expect(1, 12288, '\P{^isseparator}', "");
    Expect(0, 12289, '\p{isseparator}', "");
    Expect(1, 12289, '\p{^isseparator}', "");
    Expect(1, 12289, '\P{isseparator}', "");
    Expect(0, 12289, '\P{^isseparator}', "");
    Expect(1, 12288, '\p{	IS_separator}', "");
    Expect(0, 12288, '\p{^	IS_separator}', "");
    Expect(0, 12288, '\P{	IS_separator}', "");
    Expect(1, 12288, '\P{^	IS_separator}', "");
    Expect(0, 12289, '\p{	IS_separator}', "");
    Expect(1, 12289, '\p{^	IS_separator}', "");
    Expect(1, 12289, '\P{	IS_separator}', "");
    Expect(0, 12289, '\P{^	IS_separator}', "");
    Error('\p{ :=Z}');
    Error('\P{ :=Z}');
    Expect(1, 12288, '\p{z}', "");
    Expect(0, 12288, '\p{^z}', "");
    Expect(0, 12288, '\P{z}', "");
    Expect(1, 12288, '\P{^z}', "");
    Expect(0, 12289, '\p{z}', "");
    Expect(1, 12289, '\p{^z}', "");
    Expect(1, 12289, '\P{z}', "");
    Expect(0, 12289, '\P{^z}', "");
    Expect(1, 12288, '\p{_Z}', "");
    Expect(0, 12288, '\p{^_Z}', "");
    Expect(0, 12288, '\P{_Z}', "");
    Expect(1, 12288, '\P{^_Z}', "");
    Expect(0, 12289, '\p{_Z}', "");
    Expect(1, 12289, '\p{^_Z}', "");
    Expect(1, 12289, '\P{_Z}', "");
    Expect(0, 12289, '\P{^_Z}', "");
    Error('\p{/a/__Is_Z}');
    Error('\P{/a/__Is_Z}');
    Expect(1, 12288, '\p{isz}', "");
    Expect(0, 12288, '\p{^isz}', "");
    Expect(0, 12288, '\P{isz}', "");
    Expect(1, 12288, '\P{^isz}', "");
    Expect(0, 12289, '\p{isz}', "");
    Expect(1, 12289, '\p{^isz}', "");
    Expect(1, 12289, '\P{isz}', "");
    Expect(0, 12289, '\P{^isz}', "");
    Expect(1, 12288, '\p{_	is_Z}', "");
    Expect(0, 12288, '\p{^_	is_Z}', "");
    Expect(0, 12288, '\P{_	is_Z}', "");
    Expect(1, 12288, '\P{^_	is_Z}', "");
    Expect(0, 12289, '\p{_	is_Z}', "");
    Expect(1, 12289, '\p{^_	is_Z}', "");
    Expect(1, 12289, '\P{_	is_Z}', "");
    Expect(0, 12289, '\P{^_	is_Z}', "");
    Error('\p{	_Sharada/a/}');
    Error('\P{	_Sharada/a/}');
    Expect(1, 70111, '\p{sharada}', "");
    Expect(0, 70111, '\p{^sharada}', "");
    Expect(0, 70111, '\P{sharada}', "");
    Expect(1, 70111, '\P{^sharada}', "");
    Expect(0, 70112, '\p{sharada}', "");
    Expect(1, 70112, '\p{^sharada}', "");
    Expect(1, 70112, '\P{sharada}', "");
    Expect(0, 70112, '\P{^sharada}', "");
    Expect(1, 70111, '\p{ SHARADA}', "");
    Expect(0, 70111, '\p{^ SHARADA}', "");
    Expect(0, 70111, '\P{ SHARADA}', "");
    Expect(1, 70111, '\P{^ SHARADA}', "");
    Expect(0, 70112, '\p{ SHARADA}', "");
    Expect(1, 70112, '\p{^ SHARADA}', "");
    Expect(1, 70112, '\P{ SHARADA}', "");
    Expect(0, 70112, '\P{^ SHARADA}', "");
    Error('\p{/a/	-Is_SHARADA}');
    Error('\P{/a/	-Is_SHARADA}');
    Expect(1, 70111, '\p{issharada}', "");
    Expect(0, 70111, '\p{^issharada}', "");
    Expect(0, 70111, '\P{issharada}', "");
    Expect(1, 70111, '\P{^issharada}', "");
    Expect(0, 70112, '\p{issharada}', "");
    Expect(1, 70112, '\p{^issharada}', "");
    Expect(1, 70112, '\P{issharada}', "");
    Expect(0, 70112, '\P{^issharada}', "");
    Expect(1, 70111, '\p{ -IS_sharada}', "");
    Expect(0, 70111, '\p{^ -IS_sharada}', "");
    Expect(0, 70111, '\P{ -IS_sharada}', "");
    Expect(1, 70111, '\P{^ -IS_sharada}', "");
    Expect(0, 70112, '\p{ -IS_sharada}', "");
    Expect(1, 70112, '\p{^ -IS_sharada}', "");
    Expect(1, 70112, '\P{ -IS_sharada}', "");
    Expect(0, 70112, '\P{^ -IS_sharada}', "");
    Error('\p{/a/		Shrd}');
    Error('\P{/a/		Shrd}');
    Expect(1, 70111, '\p{shrd}', "");
    Expect(0, 70111, '\p{^shrd}', "");
    Expect(0, 70111, '\P{shrd}', "");
    Expect(1, 70111, '\P{^shrd}', "");
    Expect(0, 70112, '\p{shrd}', "");
    Expect(1, 70112, '\p{^shrd}', "");
    Expect(1, 70112, '\P{shrd}', "");
    Expect(0, 70112, '\P{^shrd}', "");
    Expect(1, 70111, '\p{	SHRD}', "");
    Expect(0, 70111, '\p{^	SHRD}', "");
    Expect(0, 70111, '\P{	SHRD}', "");
    Expect(1, 70111, '\P{^	SHRD}', "");
    Expect(0, 70112, '\p{	SHRD}', "");
    Expect(1, 70112, '\p{^	SHRD}', "");
    Expect(1, 70112, '\P{	SHRD}', "");
    Expect(0, 70112, '\P{^	SHRD}', "");
    Error('\p{/a/ -IS_Shrd}');
    Error('\P{/a/ -IS_Shrd}');
    Expect(1, 70111, '\p{isshrd}', "");
    Expect(0, 70111, '\p{^isshrd}', "");
    Expect(0, 70111, '\P{isshrd}', "");
    Expect(1, 70111, '\P{^isshrd}', "");
    Expect(0, 70112, '\p{isshrd}', "");
    Expect(1, 70112, '\p{^isshrd}', "");
    Expect(1, 70112, '\P{isshrd}', "");
    Expect(0, 70112, '\P{^isshrd}', "");
    Expect(1, 70111, '\p{	Is_SHRD}', "");
    Expect(0, 70111, '\p{^	Is_SHRD}', "");
    Expect(0, 70111, '\P{	Is_SHRD}', "");
    Expect(1, 70111, '\P{^	Is_SHRD}', "");
    Expect(0, 70112, '\p{	Is_SHRD}', "");
    Expect(1, 70112, '\p{^	Is_SHRD}', "");
    Expect(1, 70112, '\P{	Is_SHRD}', "");
    Expect(0, 70112, '\P{^	Is_SHRD}', "");
    Error('\p{_	Shavian/a/}');
    Error('\P{_	Shavian/a/}');
    Expect(1, 66687, '\p{shavian}', "");
    Expect(0, 66687, '\p{^shavian}', "");
    Expect(0, 66687, '\P{shavian}', "");
    Expect(1, 66687, '\P{^shavian}', "");
    Expect(0, 66688, '\p{shavian}', "");
    Expect(1, 66688, '\p{^shavian}', "");
    Expect(1, 66688, '\P{shavian}', "");
    Expect(0, 66688, '\P{^shavian}', "");
    Expect(1, 66687, '\p{-SHAVIAN}', "");
    Expect(0, 66687, '\p{^-SHAVIAN}', "");
    Expect(0, 66687, '\P{-SHAVIAN}', "");
    Expect(1, 66687, '\P{^-SHAVIAN}', "");
    Expect(0, 66688, '\p{-SHAVIAN}', "");
    Expect(1, 66688, '\p{^-SHAVIAN}', "");
    Expect(1, 66688, '\P{-SHAVIAN}', "");
    Expect(0, 66688, '\P{^-SHAVIAN}', "");
    Error('\p{/a/-Is_Shavian}');
    Error('\P{/a/-Is_Shavian}');
    Expect(1, 66687, '\p{isshavian}', "");
    Expect(0, 66687, '\p{^isshavian}', "");
    Expect(0, 66687, '\P{isshavian}', "");
    Expect(1, 66687, '\P{^isshavian}', "");
    Expect(0, 66688, '\p{isshavian}', "");
    Expect(1, 66688, '\p{^isshavian}', "");
    Expect(1, 66688, '\P{isshavian}', "");
    Expect(0, 66688, '\P{^isshavian}', "");
    Expect(1, 66687, '\p{-Is_shavian}', "");
    Expect(0, 66687, '\p{^-Is_shavian}', "");
    Expect(0, 66687, '\P{-Is_shavian}', "");
    Expect(1, 66687, '\P{^-Is_shavian}', "");
    Expect(0, 66688, '\p{-Is_shavian}', "");
    Expect(1, 66688, '\p{^-Is_shavian}', "");
    Expect(1, 66688, '\P{-Is_shavian}', "");
    Expect(0, 66688, '\P{^-Is_shavian}', "");
    Error('\p{--Shaw:=}');
    Error('\P{--Shaw:=}');
    Expect(1, 66687, '\p{shaw}', "");
    Expect(0, 66687, '\p{^shaw}', "");
    Expect(0, 66687, '\P{shaw}', "");
    Expect(1, 66687, '\P{^shaw}', "");
    Expect(0, 66688, '\p{shaw}', "");
    Expect(1, 66688, '\p{^shaw}', "");
    Expect(1, 66688, '\P{shaw}', "");
    Expect(0, 66688, '\P{^shaw}', "");
    Expect(1, 66687, '\p{ _Shaw}', "");
    Expect(0, 66687, '\p{^ _Shaw}', "");
    Expect(0, 66687, '\P{ _Shaw}', "");
    Expect(1, 66687, '\P{^ _Shaw}', "");
    Expect(0, 66688, '\p{ _Shaw}', "");
    Expect(1, 66688, '\p{^ _Shaw}', "");
    Expect(1, 66688, '\P{ _Shaw}', "");
    Expect(0, 66688, '\P{^ _Shaw}', "");
    Error('\p{/a/_IS_Shaw}');
    Error('\P{/a/_IS_Shaw}');
    Expect(1, 66687, '\p{isshaw}', "");
    Expect(0, 66687, '\p{^isshaw}', "");
    Expect(0, 66687, '\P{isshaw}', "");
    Expect(1, 66687, '\P{^isshaw}', "");
    Expect(0, 66688, '\p{isshaw}', "");
    Expect(1, 66688, '\p{^isshaw}', "");
    Expect(1, 66688, '\P{isshaw}', "");
    Expect(0, 66688, '\P{^isshaw}', "");
    Expect(1, 66687, '\p{--is_SHAW}', "");
    Expect(0, 66687, '\p{^--is_SHAW}', "");
    Expect(0, 66687, '\P{--is_SHAW}', "");
    Expect(1, 66687, '\P{^--is_SHAW}', "");
    Expect(0, 66688, '\p{--is_SHAW}', "");
    Expect(1, 66688, '\p{^--is_SHAW}', "");
    Expect(1, 66688, '\P{--is_SHAW}', "");
    Expect(0, 66688, '\P{^--is_SHAW}', "");
    Error('\p{ -Shorthand_Format_Controls:=}');
    Error('\P{ -Shorthand_Format_Controls:=}');
    Expect(1, 113839, '\p{shorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^shorthandformatcontrols}', "");
    Expect(0, 113839, '\P{shorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^shorthandformatcontrols}', "");
    Expect(0, 113840, '\p{shorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^shorthandformatcontrols}', "");
    Expect(1, 113840, '\P{shorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^shorthandformatcontrols}', "");
    Expect(1, 113839, '\p{ _Shorthand_Format_controls}', "");
    Expect(0, 113839, '\p{^ _Shorthand_Format_controls}', "");
    Expect(0, 113839, '\P{ _Shorthand_Format_controls}', "");
    Expect(1, 113839, '\P{^ _Shorthand_Format_controls}', "");
    Expect(0, 113840, '\p{ _Shorthand_Format_controls}', "");
    Expect(1, 113840, '\p{^ _Shorthand_Format_controls}', "");
    Expect(1, 113840, '\P{ _Shorthand_Format_controls}', "");
    Expect(0, 113840, '\P{^ _Shorthand_Format_controls}', "");
    Error('\p{:=	is_SHORTHAND_format_Controls}');
    Error('\P{:=	is_SHORTHAND_format_Controls}');
    Expect(1, 113839, '\p{isshorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^isshorthandformatcontrols}', "");
    Expect(0, 113839, '\P{isshorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^isshorthandformatcontrols}', "");
    Expect(0, 113840, '\p{isshorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^isshorthandformatcontrols}', "");
    Expect(1, 113840, '\P{isshorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^isshorthandformatcontrols}', "");
    Expect(1, 113839, '\p{-	is_shorthand_Format_controls}', "");
    Expect(0, 113839, '\p{^-	is_shorthand_Format_controls}', "");
    Expect(0, 113839, '\P{-	is_shorthand_Format_controls}', "");
    Expect(1, 113839, '\P{^-	is_shorthand_Format_controls}', "");
    Expect(0, 113840, '\p{-	is_shorthand_Format_controls}', "");
    Expect(1, 113840, '\p{^-	is_shorthand_Format_controls}', "");
    Expect(1, 113840, '\P{-	is_shorthand_Format_controls}', "");
    Expect(0, 113840, '\P{^-	is_shorthand_Format_controls}', "");
    Error('\p{/a/	 in_SHORTHAND_Format_controls}');
    Error('\P{/a/	 in_SHORTHAND_Format_controls}');
    Expect(1, 113839, '\p{inshorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^inshorthandformatcontrols}', "");
    Expect(0, 113839, '\P{inshorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^inshorthandformatcontrols}', "");
    Expect(0, 113840, '\p{inshorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^inshorthandformatcontrols}', "");
    Expect(1, 113840, '\P{inshorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^inshorthandformatcontrols}', "");
    Expect(1, 113839, '\p{	_IN_Shorthand_Format_controls}', "");
    Expect(0, 113839, '\p{^	_IN_Shorthand_Format_controls}', "");
    Expect(0, 113839, '\P{	_IN_Shorthand_Format_controls}', "");
    Expect(1, 113839, '\P{^	_IN_Shorthand_Format_controls}', "");
    Expect(0, 113840, '\p{	_IN_Shorthand_Format_controls}', "");
    Expect(1, 113840, '\p{^	_IN_Shorthand_Format_controls}', "");
    Expect(1, 113840, '\P{	_IN_Shorthand_Format_controls}', "");
    Expect(0, 113840, '\P{^	_IN_Shorthand_Format_controls}', "");
    Error('\p{-_Siddham:=}');
    Error('\P{-_Siddham:=}');
    Expect(1, 71133, '\p{siddham}', "");
    Expect(0, 71133, '\p{^siddham}', "");
    Expect(0, 71133, '\P{siddham}', "");
    Expect(1, 71133, '\P{^siddham}', "");
    Expect(0, 71134, '\p{siddham}', "");
    Expect(1, 71134, '\p{^siddham}', "");
    Expect(1, 71134, '\P{siddham}', "");
    Expect(0, 71134, '\P{^siddham}', "");
    Expect(1, 71133, '\p{ _Siddham}', "");
    Expect(0, 71133, '\p{^ _Siddham}', "");
    Expect(0, 71133, '\P{ _Siddham}', "");
    Expect(1, 71133, '\P{^ _Siddham}', "");
    Expect(0, 71134, '\p{ _Siddham}', "");
    Expect(1, 71134, '\p{^ _Siddham}', "");
    Expect(1, 71134, '\P{ _Siddham}', "");
    Expect(0, 71134, '\P{^ _Siddham}', "");
    Error('\p{/a/--is_Siddham}');
    Error('\P{/a/--is_Siddham}');
    Expect(1, 71133, '\p{issiddham}', "");
    Expect(0, 71133, '\p{^issiddham}', "");
    Expect(0, 71133, '\P{issiddham}', "");
    Expect(1, 71133, '\P{^issiddham}', "");
    Expect(0, 71134, '\p{issiddham}', "");
    Expect(1, 71134, '\p{^issiddham}', "");
    Expect(1, 71134, '\P{issiddham}', "");
    Expect(0, 71134, '\P{^issiddham}', "");
    Expect(1, 71133, '\p{	_Is_Siddham}', "");
    Expect(0, 71133, '\p{^	_Is_Siddham}', "");
    Expect(0, 71133, '\P{	_Is_Siddham}', "");
    Expect(1, 71133, '\P{^	_Is_Siddham}', "");
    Expect(0, 71134, '\p{	_Is_Siddham}', "");
    Expect(1, 71134, '\p{^	_Is_Siddham}', "");
    Expect(1, 71134, '\P{	_Is_Siddham}', "");
    Expect(0, 71134, '\P{^	_Is_Siddham}', "");
    Error('\p{:= 	Sidd}');
    Error('\P{:= 	Sidd}');
    Expect(1, 71133, '\p{sidd}', "");
    Expect(0, 71133, '\p{^sidd}', "");
    Expect(0, 71133, '\P{sidd}', "");
    Expect(1, 71133, '\P{^sidd}', "");
    Expect(0, 71134, '\p{sidd}', "");
    Expect(1, 71134, '\p{^sidd}', "");
    Expect(1, 71134, '\P{sidd}', "");
    Expect(0, 71134, '\P{^sidd}', "");
    Expect(1, 71133, '\p{	Sidd}', "");
    Expect(0, 71133, '\p{^	Sidd}', "");
    Expect(0, 71133, '\P{	Sidd}', "");
    Expect(1, 71133, '\P{^	Sidd}', "");
    Expect(0, 71134, '\p{	Sidd}', "");
    Expect(1, 71134, '\p{^	Sidd}', "");
    Expect(1, 71134, '\P{	Sidd}', "");
    Expect(0, 71134, '\P{^	Sidd}', "");
    Error('\p{-/a/is_SIDD}');
    Error('\P{-/a/is_SIDD}');
    Expect(1, 71133, '\p{issidd}', "");
    Expect(0, 71133, '\p{^issidd}', "");
    Expect(0, 71133, '\P{issidd}', "");
    Expect(1, 71133, '\P{^issidd}', "");
    Expect(0, 71134, '\p{issidd}', "");
    Expect(1, 71134, '\p{^issidd}', "");
    Expect(1, 71134, '\P{issidd}', "");
    Expect(0, 71134, '\P{^issidd}', "");
    Expect(1, 71133, '\p{_Is_Sidd}', "");
    Expect(0, 71133, '\p{^_Is_Sidd}', "");
    Expect(0, 71133, '\P{_Is_Sidd}', "");
    Expect(1, 71133, '\P{^_Is_Sidd}', "");
    Expect(0, 71134, '\p{_Is_Sidd}', "");
    Expect(1, 71134, '\p{^_Is_Sidd}', "");
    Expect(1, 71134, '\P{_Is_Sidd}', "");
    Expect(0, 71134, '\P{^_Is_Sidd}', "");
    Error('\p{	/a/signwriting}');
    Error('\P{	/a/signwriting}');
    Expect(1, 121519, '\p{signwriting}', "");
    Expect(0, 121519, '\p{^signwriting}', "");
    Expect(0, 121519, '\P{signwriting}', "");
    Expect(1, 121519, '\P{^signwriting}', "");
    Expect(0, 121520, '\p{signwriting}', "");
    Expect(1, 121520, '\p{^signwriting}', "");
    Expect(1, 121520, '\P{signwriting}', "");
    Expect(0, 121520, '\P{^signwriting}', "");
    Expect(1, 121519, '\p{ -signwriting}', "");
    Expect(0, 121519, '\p{^ -signwriting}', "");
    Expect(0, 121519, '\P{ -signwriting}', "");
    Expect(1, 121519, '\P{^ -signwriting}', "");
    Expect(0, 121520, '\p{ -signwriting}', "");
    Expect(1, 121520, '\p{^ -signwriting}', "");
    Expect(1, 121520, '\P{ -signwriting}', "");
    Expect(0, 121520, '\P{^ -signwriting}', "");
    Error('\p{-	is_signwriting/a/}');
    Error('\P{-	is_signwriting/a/}');
    Expect(1, 121519, '\p{issignwriting}', "");
    Expect(0, 121519, '\p{^issignwriting}', "");
    Expect(0, 121519, '\P{issignwriting}', "");
    Expect(1, 121519, '\P{^issignwriting}', "");
    Expect(0, 121520, '\p{issignwriting}', "");
    Expect(1, 121520, '\p{^issignwriting}', "");
    Expect(1, 121520, '\P{issignwriting}', "");
    Expect(0, 121520, '\P{^issignwriting}', "");
    Expect(1, 121519, '\p{IS_SignWriting}', "");
    Expect(0, 121519, '\p{^IS_SignWriting}', "");
    Expect(0, 121519, '\P{IS_SignWriting}', "");
    Expect(1, 121519, '\P{^IS_SignWriting}', "");
    Expect(0, 121520, '\p{IS_SignWriting}', "");
    Expect(1, 121520, '\p{^IS_SignWriting}', "");
    Expect(1, 121520, '\P{IS_SignWriting}', "");
    Expect(0, 121520, '\P{^IS_SignWriting}', "");
    Error('\p{:=- Sgnw}');
    Error('\P{:=- Sgnw}');
    Expect(1, 121519, '\p{sgnw}', "");
    Expect(0, 121519, '\p{^sgnw}', "");
    Expect(0, 121519, '\P{sgnw}', "");
    Expect(1, 121519, '\P{^sgnw}', "");
    Expect(0, 121520, '\p{sgnw}', "");
    Expect(1, 121520, '\p{^sgnw}', "");
    Expect(1, 121520, '\P{sgnw}', "");
    Expect(0, 121520, '\P{^sgnw}', "");
    Expect(1, 121519, '\p{	-SGNW}', "");
    Expect(0, 121519, '\p{^	-SGNW}', "");
    Expect(0, 121519, '\P{	-SGNW}', "");
    Expect(1, 121519, '\P{^	-SGNW}', "");
    Expect(0, 121520, '\p{	-SGNW}', "");
    Expect(1, 121520, '\p{^	-SGNW}', "");
    Expect(1, 121520, '\P{	-SGNW}', "");
    Expect(0, 121520, '\P{^	-SGNW}', "");
    Error('\p{_/a/is_SGNW}');
    Error('\P{_/a/is_SGNW}');
    Expect(1, 121519, '\p{issgnw}', "");
    Expect(0, 121519, '\p{^issgnw}', "");
    Expect(0, 121519, '\P{issgnw}', "");
    Expect(1, 121519, '\P{^issgnw}', "");
    Expect(0, 121520, '\p{issgnw}', "");
    Expect(1, 121520, '\p{^issgnw}', "");
    Expect(1, 121520, '\P{issgnw}', "");
    Expect(0, 121520, '\P{^issgnw}', "");
    Expect(1, 121519, '\p{  Is_Sgnw}', "");
    Expect(0, 121519, '\p{^  Is_Sgnw}', "");
    Expect(0, 121519, '\P{  Is_Sgnw}', "");
    Expect(1, 121519, '\P{^  Is_Sgnw}', "");
    Expect(0, 121520, '\p{  Is_Sgnw}', "");
    Expect(1, 121520, '\p{^  Is_Sgnw}', "");
    Expect(1, 121520, '\P{  Is_Sgnw}', "");
    Expect(0, 121520, '\P{^  Is_Sgnw}', "");
    Error('\p{		SINHALA:=}');
    Error('\P{		SINHALA:=}');
    Expect(1, 70132, '\p{sinhala}', "");
    Expect(0, 70132, '\p{^sinhala}', "");
    Expect(0, 70132, '\P{sinhala}', "");
    Expect(1, 70132, '\P{^sinhala}', "");
    Expect(0, 70133, '\p{sinhala}', "");
    Expect(1, 70133, '\p{^sinhala}', "");
    Expect(1, 70133, '\P{sinhala}', "");
    Expect(0, 70133, '\P{^sinhala}', "");
    Expect(1, 70132, '\p{	SINHALA}', "");
    Expect(0, 70132, '\p{^	SINHALA}', "");
    Expect(0, 70132, '\P{	SINHALA}', "");
    Expect(1, 70132, '\P{^	SINHALA}', "");
    Expect(0, 70133, '\p{	SINHALA}', "");
    Expect(1, 70133, '\p{^	SINHALA}', "");
    Expect(1, 70133, '\P{	SINHALA}', "");
    Expect(0, 70133, '\P{^	SINHALA}', "");
    Error('\p{__is_sinhala/a/}');
    Error('\P{__is_sinhala/a/}');
    Expect(1, 70132, '\p{issinhala}', "");
    Expect(0, 70132, '\p{^issinhala}', "");
    Expect(0, 70132, '\P{issinhala}', "");
    Expect(1, 70132, '\P{^issinhala}', "");
    Expect(0, 70133, '\p{issinhala}', "");
    Expect(1, 70133, '\p{^issinhala}', "");
    Expect(1, 70133, '\P{issinhala}', "");
    Expect(0, 70133, '\P{^issinhala}', "");
    Expect(1, 70132, '\p{_Is_Sinhala}', "");
    Expect(0, 70132, '\p{^_Is_Sinhala}', "");
    Expect(0, 70132, '\P{_Is_Sinhala}', "");
    Expect(1, 70132, '\P{^_Is_Sinhala}', "");
    Expect(0, 70133, '\p{_Is_Sinhala}', "");
    Expect(1, 70133, '\p{^_Is_Sinhala}', "");
    Expect(1, 70133, '\P{_Is_Sinhala}', "");
    Expect(0, 70133, '\P{^_Is_Sinhala}', "");
    Error('\p{	:=SINH}');
    Error('\P{	:=SINH}');
    Expect(1, 70132, '\p{sinh}', "");
    Expect(0, 70132, '\p{^sinh}', "");
    Expect(0, 70132, '\P{sinh}', "");
    Expect(1, 70132, '\P{^sinh}', "");
    Expect(0, 70133, '\p{sinh}', "");
    Expect(1, 70133, '\p{^sinh}', "");
    Expect(1, 70133, '\P{sinh}', "");
    Expect(0, 70133, '\P{^sinh}', "");
    Expect(1, 70132, '\p{-_Sinh}', "");
    Expect(0, 70132, '\p{^-_Sinh}', "");
    Expect(0, 70132, '\P{-_Sinh}', "");
    Expect(1, 70132, '\P{^-_Sinh}', "");
    Expect(0, 70133, '\p{-_Sinh}', "");
    Expect(1, 70133, '\p{^-_Sinh}', "");
    Expect(1, 70133, '\P{-_Sinh}', "");
    Expect(0, 70133, '\P{^-_Sinh}', "");
    Error('\p{/a/ 	is_Sinh}');
    Error('\P{/a/ 	is_Sinh}');
    Expect(1, 70132, '\p{issinh}', "");
    Expect(0, 70132, '\p{^issinh}', "");
    Expect(0, 70132, '\P{issinh}', "");
    Expect(1, 70132, '\P{^issinh}', "");
    Expect(0, 70133, '\p{issinh}', "");
    Expect(1, 70133, '\p{^issinh}', "");
    Expect(1, 70133, '\P{issinh}', "");
    Expect(0, 70133, '\P{^issinh}', "");
    Expect(1, 70132, '\p{- is_Sinh}', "");
    Expect(0, 70132, '\p{^- is_Sinh}', "");
    Expect(0, 70132, '\P{- is_Sinh}', "");
    Expect(1, 70132, '\P{^- is_Sinh}', "");
    Expect(0, 70133, '\p{- is_Sinh}', "");
    Expect(1, 70133, '\p{^- is_Sinh}', "");
    Expect(1, 70133, '\P{- is_Sinh}', "");
    Expect(0, 70133, '\P{^- is_Sinh}', "");
    Error('\p{/a/	_SINHALA_Archaic_numbers}');
    Error('\P{/a/	_SINHALA_Archaic_numbers}');
    Expect(1, 70143, '\p{sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{SINHALA_archaic_Numbers}', "");
    Expect(0, 70143, '\p{^SINHALA_archaic_Numbers}', "");
    Expect(0, 70143, '\P{SINHALA_archaic_Numbers}', "");
    Expect(1, 70143, '\P{^SINHALA_archaic_Numbers}', "");
    Expect(0, 70144, '\p{SINHALA_archaic_Numbers}', "");
    Expect(1, 70144, '\p{^SINHALA_archaic_Numbers}', "");
    Expect(1, 70144, '\P{SINHALA_archaic_Numbers}', "");
    Expect(0, 70144, '\P{^SINHALA_archaic_Numbers}', "");
    Error('\p{_/a/IS_Sinhala_archaic_Numbers}');
    Error('\P{_/a/IS_Sinhala_archaic_Numbers}');
    Expect(1, 70143, '\p{issinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^issinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{issinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^issinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{issinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^issinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{issinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^issinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{-	is_Sinhala_Archaic_numbers}', "");
    Expect(0, 70143, '\p{^-	is_Sinhala_Archaic_numbers}', "");
    Expect(0, 70143, '\P{-	is_Sinhala_Archaic_numbers}', "");
    Expect(1, 70143, '\P{^-	is_Sinhala_Archaic_numbers}', "");
    Expect(0, 70144, '\p{-	is_Sinhala_Archaic_numbers}', "");
    Expect(1, 70144, '\p{^-	is_Sinhala_Archaic_numbers}', "");
    Expect(1, 70144, '\P{-	is_Sinhala_Archaic_numbers}', "");
    Expect(0, 70144, '\P{^-	is_Sinhala_Archaic_numbers}', "");
    Error('\p{_/a/in_SINHALA_Archaic_Numbers}');
    Error('\P{_/a/in_SINHALA_Archaic_Numbers}');
    Expect(1, 70143, '\p{insinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^insinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{insinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^insinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{insinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^insinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{insinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^insinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{--in_sinhala_archaic_numbers}', "");
    Expect(0, 70143, '\p{^--in_sinhala_archaic_numbers}', "");
    Expect(0, 70143, '\P{--in_sinhala_archaic_numbers}', "");
    Expect(1, 70143, '\P{^--in_sinhala_archaic_numbers}', "");
    Expect(0, 70144, '\p{--in_sinhala_archaic_numbers}', "");
    Expect(1, 70144, '\p{^--in_sinhala_archaic_numbers}', "");
    Expect(1, 70144, '\P{--in_sinhala_archaic_numbers}', "");
    Expect(0, 70144, '\P{^--in_sinhala_archaic_numbers}', "");
    Error('\p{_/a/SMALL_Form_Variants}');
    Error('\P{_/a/SMALL_Form_Variants}');
    Expect(1, 65135, '\p{smallformvariants}', "");
    Expect(0, 65135, '\p{^smallformvariants}', "");
    Expect(0, 65135, '\P{smallformvariants}', "");
    Expect(1, 65135, '\P{^smallformvariants}', "");
    Expect(0, 65136, '\p{smallformvariants}', "");
    Expect(1, 65136, '\p{^smallformvariants}', "");
    Expect(1, 65136, '\P{smallformvariants}', "");
    Expect(0, 65136, '\P{^smallformvariants}', "");
    Expect(1, 65135, '\p{_SMALL_Form_VARIANTS}', "");
    Expect(0, 65135, '\p{^_SMALL_Form_VARIANTS}', "");
    Expect(0, 65135, '\P{_SMALL_Form_VARIANTS}', "");
    Expect(1, 65135, '\P{^_SMALL_Form_VARIANTS}', "");
    Expect(0, 65136, '\p{_SMALL_Form_VARIANTS}', "");
    Expect(1, 65136, '\p{^_SMALL_Form_VARIANTS}', "");
    Expect(1, 65136, '\P{_SMALL_Form_VARIANTS}', "");
    Expect(0, 65136, '\P{^_SMALL_Form_VARIANTS}', "");
    Error('\p{is_Small_FORM_Variants/a/}');
    Error('\P{is_Small_FORM_Variants/a/}');
    Expect(1, 65135, '\p{issmallformvariants}', "");
    Expect(0, 65135, '\p{^issmallformvariants}', "");
    Expect(0, 65135, '\P{issmallformvariants}', "");
    Expect(1, 65135, '\P{^issmallformvariants}', "");
    Expect(0, 65136, '\p{issmallformvariants}', "");
    Expect(1, 65136, '\p{^issmallformvariants}', "");
    Expect(1, 65136, '\P{issmallformvariants}', "");
    Expect(0, 65136, '\P{^issmallformvariants}', "");
    Expect(1, 65135, '\p{-_is_Small_FORM_VARIANTS}', "");
    Expect(0, 65135, '\p{^-_is_Small_FORM_VARIANTS}', "");
    Expect(0, 65135, '\P{-_is_Small_FORM_VARIANTS}', "");
    Expect(1, 65135, '\P{^-_is_Small_FORM_VARIANTS}', "");
    Expect(0, 65136, '\p{-_is_Small_FORM_VARIANTS}', "");
    Expect(1, 65136, '\p{^-_is_Small_FORM_VARIANTS}', "");
    Expect(1, 65136, '\P{-_is_Small_FORM_VARIANTS}', "");
    Expect(0, 65136, '\P{^-_is_Small_FORM_VARIANTS}', "");
    Error('\p{	In_Small_FORM_Variants/a/}');
    Error('\P{	In_Small_FORM_Variants/a/}');
    Expect(1, 65135, '\p{insmallformvariants}', "");
    Expect(0, 65135, '\p{^insmallformvariants}', "");
    Expect(0, 65135, '\P{insmallformvariants}', "");
    Expect(1, 65135, '\P{^insmallformvariants}', "");
    Expect(0, 65136, '\p{insmallformvariants}', "");
    Expect(1, 65136, '\p{^insmallformvariants}', "");
    Expect(1, 65136, '\P{insmallformvariants}', "");
    Expect(0, 65136, '\P{^insmallformvariants}', "");
    Expect(1, 65135, '\p{ IN_SMALL_FORM_Variants}', "");
    Expect(0, 65135, '\p{^ IN_SMALL_FORM_Variants}', "");
    Expect(0, 65135, '\P{ IN_SMALL_FORM_Variants}', "");
    Expect(1, 65135, '\P{^ IN_SMALL_FORM_Variants}', "");
    Expect(0, 65136, '\p{ IN_SMALL_FORM_Variants}', "");
    Expect(1, 65136, '\p{^ IN_SMALL_FORM_Variants}', "");
    Expect(1, 65136, '\P{ IN_SMALL_FORM_Variants}', "");
    Expect(0, 65136, '\P{^ IN_SMALL_FORM_Variants}', "");
    Error('\p{_small_Forms:=}');
    Error('\P{_small_Forms:=}');
    Expect(1, 65135, '\p{smallforms}', "");
    Expect(0, 65135, '\p{^smallforms}', "");
    Expect(0, 65135, '\P{smallforms}', "");
    Expect(1, 65135, '\P{^smallforms}', "");
    Expect(0, 65136, '\p{smallforms}', "");
    Expect(1, 65136, '\p{^smallforms}', "");
    Expect(1, 65136, '\P{smallforms}', "");
    Expect(0, 65136, '\P{^smallforms}', "");
    Expect(1, 65135, '\p{_	Small_forms}', "");
    Expect(0, 65135, '\p{^_	Small_forms}', "");
    Expect(0, 65135, '\P{_	Small_forms}', "");
    Expect(1, 65135, '\P{^_	Small_forms}', "");
    Expect(0, 65136, '\p{_	Small_forms}', "");
    Expect(1, 65136, '\p{^_	Small_forms}', "");
    Expect(1, 65136, '\P{_	Small_forms}', "");
    Expect(0, 65136, '\P{^_	Small_forms}', "");
    Error('\p{:= Is_small_FORMS}');
    Error('\P{:= Is_small_FORMS}');
    Expect(1, 65135, '\p{issmallforms}', "");
    Expect(0, 65135, '\p{^issmallforms}', "");
    Expect(0, 65135, '\P{issmallforms}', "");
    Expect(1, 65135, '\P{^issmallforms}', "");
    Expect(0, 65136, '\p{issmallforms}', "");
    Expect(1, 65136, '\p{^issmallforms}', "");
    Expect(1, 65136, '\P{issmallforms}', "");
    Expect(0, 65136, '\P{^issmallforms}', "");
    Expect(1, 65135, '\p{	-is_SMALL_Forms}', "");
    Expect(0, 65135, '\p{^	-is_SMALL_Forms}', "");
    Expect(0, 65135, '\P{	-is_SMALL_Forms}', "");
    Expect(1, 65135, '\P{^	-is_SMALL_Forms}', "");
    Expect(0, 65136, '\p{	-is_SMALL_Forms}', "");
    Expect(1, 65136, '\p{^	-is_SMALL_Forms}', "");
    Expect(1, 65136, '\P{	-is_SMALL_Forms}', "");
    Expect(0, 65136, '\P{^	-is_SMALL_Forms}', "");
    Error('\p{ :=in_Small_forms}');
    Error('\P{ :=in_Small_forms}');
    Expect(1, 65135, '\p{insmallforms}', "");
    Expect(0, 65135, '\p{^insmallforms}', "");
    Expect(0, 65135, '\P{insmallforms}', "");
    Expect(1, 65135, '\P{^insmallforms}', "");
    Expect(0, 65136, '\p{insmallforms}', "");
    Expect(1, 65136, '\p{^insmallforms}', "");
    Expect(1, 65136, '\P{insmallforms}', "");
    Expect(0, 65136, '\P{^insmallforms}', "");
    Expect(1, 65135, '\p{ -In_SMALL_FORMS}', "");
    Expect(0, 65135, '\p{^ -In_SMALL_FORMS}', "");
    Expect(0, 65135, '\P{ -In_SMALL_FORMS}', "");
    Expect(1, 65135, '\P{^ -In_SMALL_FORMS}', "");
    Expect(0, 65136, '\p{ -In_SMALL_FORMS}', "");
    Expect(1, 65136, '\p{^ -In_SMALL_FORMS}', "");
    Expect(1, 65136, '\P{ -In_SMALL_FORMS}', "");
    Expect(0, 65136, '\P{^ -In_SMALL_FORMS}', "");
    Error('\p{:=SORA_Sompeng}');
    Error('\P{:=SORA_Sompeng}');
    Expect(1, 69881, '\p{sorasompeng}', "");
    Expect(0, 69881, '\p{^sorasompeng}', "");
    Expect(0, 69881, '\P{sorasompeng}', "");
    Expect(1, 69881, '\P{^sorasompeng}', "");
    Expect(0, 69882, '\p{sorasompeng}', "");
    Expect(1, 69882, '\p{^sorasompeng}', "");
    Expect(1, 69882, '\P{sorasompeng}', "");
    Expect(0, 69882, '\P{^sorasompeng}', "");
    Expect(1, 69881, '\p{ 	SORA_Sompeng}', "");
    Expect(0, 69881, '\p{^ 	SORA_Sompeng}', "");
    Expect(0, 69881, '\P{ 	SORA_Sompeng}', "");
    Expect(1, 69881, '\P{^ 	SORA_Sompeng}', "");
    Expect(0, 69882, '\p{ 	SORA_Sompeng}', "");
    Expect(1, 69882, '\p{^ 	SORA_Sompeng}', "");
    Expect(1, 69882, '\P{ 	SORA_Sompeng}', "");
    Expect(0, 69882, '\P{^ 	SORA_Sompeng}', "");
    Error('\p{	:=is_SORA_sompeng}');
    Error('\P{	:=is_SORA_sompeng}');
    Expect(1, 69881, '\p{issorasompeng}', "");
    Expect(0, 69881, '\p{^issorasompeng}', "");
    Expect(0, 69881, '\P{issorasompeng}', "");
    Expect(1, 69881, '\P{^issorasompeng}', "");
    Expect(0, 69882, '\p{issorasompeng}', "");
    Expect(1, 69882, '\p{^issorasompeng}', "");
    Expect(1, 69882, '\P{issorasompeng}', "");
    Expect(0, 69882, '\P{^issorasompeng}', "");
    Expect(1, 69881, '\p{- Is_sora_SOMPENG}', "");
    Expect(0, 69881, '\p{^- Is_sora_SOMPENG}', "");
    Expect(0, 69881, '\P{- Is_sora_SOMPENG}', "");
    Expect(1, 69881, '\P{^- Is_sora_SOMPENG}', "");
    Expect(0, 69882, '\p{- Is_sora_SOMPENG}', "");
    Expect(1, 69882, '\p{^- Is_sora_SOMPENG}', "");
    Expect(1, 69882, '\P{- Is_sora_SOMPENG}', "");
    Expect(0, 69882, '\P{^- Is_sora_SOMPENG}', "");
    Error('\p{	Sora/a/}');
    Error('\P{	Sora/a/}');
    Expect(1, 69881, '\p{sora}', "");
    Expect(0, 69881, '\p{^sora}', "");
    Expect(0, 69881, '\P{sora}', "");
    Expect(1, 69881, '\P{^sora}', "");
    Expect(0, 69882, '\p{sora}', "");
    Expect(1, 69882, '\p{^sora}', "");
    Expect(1, 69882, '\P{sora}', "");
    Expect(0, 69882, '\P{^sora}', "");
    Expect(1, 69881, '\p{- SORA}', "");
    Expect(0, 69881, '\p{^- SORA}', "");
    Expect(0, 69881, '\P{- SORA}', "");
    Expect(1, 69881, '\P{^- SORA}', "");
    Expect(0, 69882, '\p{- SORA}', "");
    Expect(1, 69882, '\p{^- SORA}', "");
    Expect(1, 69882, '\P{- SORA}', "");
    Expect(0, 69882, '\P{^- SORA}', "");
    Error('\p{-Is_SORA:=}');
    Error('\P{-Is_SORA:=}');
    Expect(1, 69881, '\p{issora}', "");
    Expect(0, 69881, '\p{^issora}', "");
    Expect(0, 69881, '\P{issora}', "");
    Expect(1, 69881, '\P{^issora}', "");
    Expect(0, 69882, '\p{issora}', "");
    Expect(1, 69882, '\p{^issora}', "");
    Expect(1, 69882, '\P{issora}', "");
    Expect(0, 69882, '\P{^issora}', "");
    Expect(1, 69881, '\p{IS_sora}', "");
    Expect(0, 69881, '\p{^IS_sora}', "");
    Expect(0, 69881, '\P{IS_sora}', "");
    Expect(1, 69881, '\P{^IS_sora}', "");
    Expect(0, 69882, '\p{IS_sora}', "");
    Expect(1, 69882, '\p{^IS_sora}', "");
    Expect(1, 69882, '\P{IS_sora}', "");
    Expect(0, 69882, '\P{^IS_sora}', "");
    Error('\p{-SOYOMBO:=}');
    Error('\P{-SOYOMBO:=}');
    Expect(1, 72354, '\p{soyombo}', "");
    Expect(0, 72354, '\p{^soyombo}', "");
    Expect(0, 72354, '\P{soyombo}', "");
    Expect(1, 72354, '\P{^soyombo}', "");
    Expect(0, 72355, '\p{soyombo}', "");
    Expect(1, 72355, '\p{^soyombo}', "");
    Expect(1, 72355, '\P{soyombo}', "");
    Expect(0, 72355, '\P{^soyombo}', "");
    Expect(1, 72354, '\p{ _Soyombo}', "");
    Expect(0, 72354, '\p{^ _Soyombo}', "");
    Expect(0, 72354, '\P{ _Soyombo}', "");
    Expect(1, 72354, '\P{^ _Soyombo}', "");
    Expect(0, 72355, '\p{ _Soyombo}', "");
    Expect(1, 72355, '\p{^ _Soyombo}', "");
    Expect(1, 72355, '\P{ _Soyombo}', "");
    Expect(0, 72355, '\P{^ _Soyombo}', "");
    Error('\p{:=	is_Soyombo}');
    Error('\P{:=	is_Soyombo}');
    Expect(1, 72354, '\p{issoyombo}', "");
    Expect(0, 72354, '\p{^issoyombo}', "");
    Expect(0, 72354, '\P{issoyombo}', "");
    Expect(1, 72354, '\P{^issoyombo}', "");
    Expect(0, 72355, '\p{issoyombo}', "");
    Expect(1, 72355, '\p{^issoyombo}', "");
    Expect(1, 72355, '\P{issoyombo}', "");
    Expect(0, 72355, '\P{^issoyombo}', "");
    Expect(1, 72354, '\p{ _Is_Soyombo}', "");
    Expect(0, 72354, '\p{^ _Is_Soyombo}', "");
    Expect(0, 72354, '\P{ _Is_Soyombo}', "");
    Expect(1, 72354, '\P{^ _Is_Soyombo}', "");
    Expect(0, 72355, '\p{ _Is_Soyombo}', "");
    Expect(1, 72355, '\p{^ _Is_Soyombo}', "");
    Expect(1, 72355, '\P{ _Is_Soyombo}', "");
    Expect(0, 72355, '\P{^ _Is_Soyombo}', "");
    Error('\p{	:=Soyo}');
    Error('\P{	:=Soyo}');
    Expect(1, 72354, '\p{soyo}', "");
    Expect(0, 72354, '\p{^soyo}', "");
    Expect(0, 72354, '\P{soyo}', "");
    Expect(1, 72354, '\P{^soyo}', "");
    Expect(0, 72355, '\p{soyo}', "");
    Expect(1, 72355, '\p{^soyo}', "");
    Expect(1, 72355, '\P{soyo}', "");
    Expect(0, 72355, '\P{^soyo}', "");
    Expect(1, 72354, '\p{__SOYO}', "");
    Expect(0, 72354, '\p{^__SOYO}', "");
    Expect(0, 72354, '\P{__SOYO}', "");
    Expect(1, 72354, '\P{^__SOYO}', "");
    Expect(0, 72355, '\p{__SOYO}', "");
    Expect(1, 72355, '\p{^__SOYO}', "");
    Expect(1, 72355, '\P{__SOYO}', "");
    Expect(0, 72355, '\P{^__SOYO}', "");
    Error('\p{	/a/Is_Soyo}');
    Error('\P{	/a/Is_Soyo}');
    Expect(1, 72354, '\p{issoyo}', "");
    Expect(0, 72354, '\p{^issoyo}', "");
    Expect(0, 72354, '\P{issoyo}', "");
    Expect(1, 72354, '\P{^issoyo}', "");
    Expect(0, 72355, '\p{issoyo}', "");
    Expect(1, 72355, '\p{^issoyo}', "");
    Expect(1, 72355, '\P{issoyo}', "");
    Expect(0, 72355, '\P{^issoyo}', "");
    Expect(1, 72354, '\p{_Is_SOYO}', "");
    Expect(0, 72354, '\p{^_Is_SOYO}', "");
    Expect(0, 72354, '\P{_Is_SOYO}', "");
    Expect(1, 72354, '\P{^_Is_SOYO}', "");
    Expect(0, 72355, '\p{_Is_SOYO}', "");
    Expect(1, 72355, '\p{^_Is_SOYO}', "");
    Expect(1, 72355, '\P{_Is_SOYO}', "");
    Expect(0, 72355, '\P{^_Is_SOYO}', "");
    Error('\p{:= Space_Separator}');
    Error('\P{:= Space_Separator}');
    Expect(1, 12288, '\p{spaceseparator}', "");
    Expect(0, 12288, '\p{^spaceseparator}', "");
    Expect(0, 12288, '\P{spaceseparator}', "");
    Expect(1, 12288, '\P{^spaceseparator}', "");
    Expect(0, 12289, '\p{spaceseparator}', "");
    Expect(1, 12289, '\p{^spaceseparator}', "");
    Expect(1, 12289, '\P{spaceseparator}', "");
    Expect(0, 12289, '\P{^spaceseparator}', "");
    Expect(1, 12288, '\p{_ space_separator}', "");
    Expect(0, 12288, '\p{^_ space_separator}', "");
    Expect(0, 12288, '\P{_ space_separator}', "");
    Expect(1, 12288, '\P{^_ space_separator}', "");
    Expect(0, 12289, '\p{_ space_separator}', "");
    Expect(1, 12289, '\p{^_ space_separator}', "");
    Expect(1, 12289, '\P{_ space_separator}', "");
    Expect(0, 12289, '\P{^_ space_separator}', "");
    Error('\p{ :=Is_Space_Separator}');
    Error('\P{ :=Is_Space_Separator}');
    Expect(1, 12288, '\p{isspaceseparator}', "");
    Expect(0, 12288, '\p{^isspaceseparator}', "");
    Expect(0, 12288, '\P{isspaceseparator}', "");
    Expect(1, 12288, '\P{^isspaceseparator}', "");
    Expect(0, 12289, '\p{isspaceseparator}', "");
    Expect(1, 12289, '\p{^isspaceseparator}', "");
    Expect(1, 12289, '\P{isspaceseparator}', "");
    Expect(0, 12289, '\P{^isspaceseparator}', "");
    Expect(1, 12288, '\p{ 	Is_space_SEPARATOR}', "");
    Expect(0, 12288, '\p{^ 	Is_space_SEPARATOR}', "");
    Expect(0, 12288, '\P{ 	Is_space_SEPARATOR}', "");
    Expect(1, 12288, '\P{^ 	Is_space_SEPARATOR}', "");
    Expect(0, 12289, '\p{ 	Is_space_SEPARATOR}', "");
    Expect(1, 12289, '\p{^ 	Is_space_SEPARATOR}', "");
    Expect(1, 12289, '\P{ 	Is_space_SEPARATOR}', "");
    Expect(0, 12289, '\P{^ 	Is_space_SEPARATOR}', "");
    Error('\p{:=_	Zs}');
    Error('\P{:=_	Zs}');
    Expect(1, 12288, '\p{zs}', "");
    Expect(0, 12288, '\p{^zs}', "");
    Expect(0, 12288, '\P{zs}', "");
    Expect(1, 12288, '\P{^zs}', "");
    Expect(0, 12289, '\p{zs}', "");
    Expect(1, 12289, '\p{^zs}', "");
    Expect(1, 12289, '\P{zs}', "");
    Expect(0, 12289, '\P{^zs}', "");
    Expect(1, 12288, '\p{_Zs}', "");
    Expect(0, 12288, '\p{^_Zs}', "");
    Expect(0, 12288, '\P{_Zs}', "");
    Expect(1, 12288, '\P{^_Zs}', "");
    Expect(0, 12289, '\p{_Zs}', "");
    Expect(1, 12289, '\p{^_Zs}', "");
    Expect(1, 12289, '\P{_Zs}', "");
    Expect(0, 12289, '\P{^_Zs}', "");
    Error('\p{:=--IS_Zs}');
    Error('\P{:=--IS_Zs}');
    Expect(1, 12288, '\p{iszs}', "");
    Expect(0, 12288, '\p{^iszs}', "");
    Expect(0, 12288, '\P{iszs}', "");
    Expect(1, 12288, '\P{^iszs}', "");
    Expect(0, 12289, '\p{iszs}', "");
    Expect(1, 12289, '\p{^iszs}', "");
    Expect(1, 12289, '\P{iszs}', "");
    Expect(0, 12289, '\P{^iszs}', "");
    Expect(1, 12288, '\p{ 	Is_zs}', "");
    Expect(0, 12288, '\p{^ 	Is_zs}', "");
    Expect(0, 12288, '\P{ 	Is_zs}', "");
    Expect(1, 12288, '\P{^ 	Is_zs}', "");
    Expect(0, 12289, '\p{ 	Is_zs}', "");
    Expect(1, 12289, '\p{^ 	Is_zs}', "");
    Expect(1, 12289, '\P{ 	Is_zs}', "");
    Expect(0, 12289, '\P{^ 	Is_zs}', "");
    Error('\p{/a/ 	Spacing_MARK}');
    Error('\P{/a/ 	Spacing_MARK}');
    Expect(1, 119154, '\p{spacingmark}', "");
    Expect(0, 119154, '\p{^spacingmark}', "");
    Expect(0, 119154, '\P{spacingmark}', "");
    Expect(1, 119154, '\P{^spacingmark}', "");
    Expect(0, 119155, '\p{spacingmark}', "");
    Expect(1, 119155, '\p{^spacingmark}', "");
    Expect(1, 119155, '\P{spacingmark}', "");
    Expect(0, 119155, '\P{^spacingmark}', "");
    Expect(1, 119154, '\p{ _spacing_Mark}', "");
    Expect(0, 119154, '\p{^ _spacing_Mark}', "");
    Expect(0, 119154, '\P{ _spacing_Mark}', "");
    Expect(1, 119154, '\P{^ _spacing_Mark}', "");
    Expect(0, 119155, '\p{ _spacing_Mark}', "");
    Expect(1, 119155, '\p{^ _spacing_Mark}', "");
    Expect(1, 119155, '\P{ _spacing_Mark}', "");
    Expect(0, 119155, '\P{^ _spacing_Mark}', "");
    Error('\p{--is_Spacing_MARK:=}');
    Error('\P{--is_Spacing_MARK:=}');
    Expect(1, 119154, '\p{isspacingmark}', "");
    Expect(0, 119154, '\p{^isspacingmark}', "");
    Expect(0, 119154, '\P{isspacingmark}', "");
    Expect(1, 119154, '\P{^isspacingmark}', "");
    Expect(0, 119155, '\p{isspacingmark}', "");
    Expect(1, 119155, '\p{^isspacingmark}', "");
    Expect(1, 119155, '\P{isspacingmark}', "");
    Expect(0, 119155, '\P{^isspacingmark}', "");
    Expect(1, 119154, '\p{_Is_spacing_Mark}', "");
    Expect(0, 119154, '\p{^_Is_spacing_Mark}', "");
    Expect(0, 119154, '\P{_Is_spacing_Mark}', "");
    Expect(1, 119154, '\P{^_Is_spacing_Mark}', "");
    Expect(0, 119155, '\p{_Is_spacing_Mark}', "");
    Expect(1, 119155, '\p{^_Is_spacing_Mark}', "");
    Expect(1, 119155, '\P{_Is_spacing_Mark}', "");
    Expect(0, 119155, '\P{^_Is_spacing_Mark}', "");
    Error('\p{/a/	_mc}');
    Error('\P{/a/	_mc}');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 4) {
    Expect(1, 119154, '\p{mc}', "");
    Expect(0, 119154, '\p{^mc}', "");
    Expect(0, 119154, '\P{mc}', "");
    Expect(1, 119154, '\P{^mc}', "");
    Expect(0, 119155, '\p{mc}', "");
    Expect(1, 119155, '\p{^mc}', "");
    Expect(1, 119155, '\P{mc}', "");
    Expect(0, 119155, '\P{^mc}', "");
    Expect(1, 119154, '\p{_Mc}', "");
    Expect(0, 119154, '\p{^_Mc}', "");
    Expect(0, 119154, '\P{_Mc}', "");
    Expect(1, 119154, '\P{^_Mc}', "");
    Expect(0, 119155, '\p{_Mc}', "");
    Expect(1, 119155, '\p{^_Mc}', "");
    Expect(1, 119155, '\P{_Mc}', "");
    Expect(0, 119155, '\P{^_Mc}', "");
    Error('\p{__Is_Mc/a/}');
    Error('\P{__Is_Mc/a/}');
    Expect(1, 119154, '\p{ismc}', "");
    Expect(0, 119154, '\p{^ismc}', "");
    Expect(0, 119154, '\P{ismc}', "");
    Expect(1, 119154, '\P{^ismc}', "");
    Expect(0, 119155, '\p{ismc}', "");
    Expect(1, 119155, '\p{^ismc}', "");
    Expect(1, 119155, '\P{ismc}', "");
    Expect(0, 119155, '\P{^ismc}', "");
    Expect(1, 119154, '\p{ _is_Mc}', "");
    Expect(0, 119154, '\p{^ _is_Mc}', "");
    Expect(0, 119154, '\P{ _is_Mc}', "");
    Expect(1, 119154, '\P{^ _is_Mc}', "");
    Expect(0, 119155, '\p{ _is_Mc}', "");
    Expect(1, 119155, '\p{^ _is_Mc}', "");
    Expect(1, 119155, '\P{ _is_Mc}', "");
    Expect(0, 119155, '\P{^ _is_Mc}', "");
    Error('\p{_-Spacing_Modifier_Letters:=}');
    Error('\P{_-Spacing_Modifier_Letters:=}');
    Expect(1, 767, '\p{spacingmodifierletters}', "");
    Expect(0, 767, '\p{^spacingmodifierletters}', "");
    Expect(0, 767, '\P{spacingmodifierletters}', "");
    Expect(1, 767, '\P{^spacingmodifierletters}', "");
    Expect(0, 768, '\p{spacingmodifierletters}', "");
    Expect(1, 768, '\p{^spacingmodifierletters}', "");
    Expect(1, 768, '\P{spacingmodifierletters}', "");
    Expect(0, 768, '\P{^spacingmodifierletters}', "");
    Expect(1, 767, '\p{ -Spacing_Modifier_Letters}', "");
    Expect(0, 767, '\p{^ -Spacing_Modifier_Letters}', "");
    Expect(0, 767, '\P{ -Spacing_Modifier_Letters}', "");
    Expect(1, 767, '\P{^ -Spacing_Modifier_Letters}', "");
    Expect(0, 768, '\p{ -Spacing_Modifier_Letters}', "");
    Expect(1, 768, '\p{^ -Spacing_Modifier_Letters}', "");
    Expect(1, 768, '\P{ -Spacing_Modifier_Letters}', "");
    Expect(0, 768, '\P{^ -Spacing_Modifier_Letters}', "");
    Error('\p{:= Is_spacing_Modifier_LETTERS}');
    Error('\P{:= Is_spacing_Modifier_LETTERS}');
    Expect(1, 767, '\p{isspacingmodifierletters}', "");
    Expect(0, 767, '\p{^isspacingmodifierletters}', "");
    Expect(0, 767, '\P{isspacingmodifierletters}', "");
    Expect(1, 767, '\P{^isspacingmodifierletters}', "");
    Expect(0, 768, '\p{isspacingmodifierletters}', "");
    Expect(1, 768, '\p{^isspacingmodifierletters}', "");
    Expect(1, 768, '\P{isspacingmodifierletters}', "");
    Expect(0, 768, '\P{^isspacingmodifierletters}', "");
    Expect(1, 767, '\p{- Is_Spacing_Modifier_Letters}', "");
    Expect(0, 767, '\p{^- Is_Spacing_Modifier_Letters}', "");
    Expect(0, 767, '\P{- Is_Spacing_Modifier_Letters}', "");
    Expect(1, 767, '\P{^- Is_Spacing_Modifier_Letters}', "");
    Expect(0, 768, '\p{- Is_Spacing_Modifier_Letters}', "");
    Expect(1, 768, '\p{^- Is_Spacing_Modifier_Letters}', "");
    Expect(1, 768, '\P{- Is_Spacing_Modifier_Letters}', "");
    Expect(0, 768, '\P{^- Is_Spacing_Modifier_Letters}', "");
    Error('\p{ :=in_Spacing_MODIFIER_Letters}');
    Error('\P{ :=in_Spacing_MODIFIER_Letters}');
    Expect(1, 767, '\p{inspacingmodifierletters}', "");
    Expect(0, 767, '\p{^inspacingmodifierletters}', "");
    Expect(0, 767, '\P{inspacingmodifierletters}', "");
    Expect(1, 767, '\P{^inspacingmodifierletters}', "");
    Expect(0, 768, '\p{inspacingmodifierletters}', "");
    Expect(1, 768, '\p{^inspacingmodifierletters}', "");
    Expect(1, 768, '\P{inspacingmodifierletters}', "");
    Expect(0, 768, '\P{^inspacingmodifierletters}', "");
    Expect(1, 767, '\p{-	In_Spacing_MODIFIER_Letters}', "");
    Expect(0, 767, '\p{^-	In_Spacing_MODIFIER_Letters}', "");
    Expect(0, 767, '\P{-	In_Spacing_MODIFIER_Letters}', "");
    Expect(1, 767, '\P{^-	In_Spacing_MODIFIER_Letters}', "");
    Expect(0, 768, '\p{-	In_Spacing_MODIFIER_Letters}', "");
    Expect(1, 768, '\p{^-	In_Spacing_MODIFIER_Letters}', "");
    Expect(1, 768, '\P{-	In_Spacing_MODIFIER_Letters}', "");
    Expect(0, 768, '\P{^-	In_Spacing_MODIFIER_Letters}', "");
    Error('\p{/a/	modifier_Letters}');
    Error('\P{/a/	modifier_Letters}');
    Expect(1, 767, '\p{modifierletters}', "");
    Expect(0, 767, '\p{^modifierletters}', "");
    Expect(0, 767, '\P{modifierletters}', "");
    Expect(1, 767, '\P{^modifierletters}', "");
    Expect(0, 768, '\p{modifierletters}', "");
    Expect(1, 768, '\p{^modifierletters}', "");
    Expect(1, 768, '\P{modifierletters}', "");
    Expect(0, 768, '\P{^modifierletters}', "");
    Expect(1, 767, '\p{		MODIFIER_letters}', "");
    Expect(0, 767, '\p{^		MODIFIER_letters}', "");
    Expect(0, 767, '\P{		MODIFIER_letters}', "");
    Expect(1, 767, '\P{^		MODIFIER_letters}', "");
    Expect(0, 768, '\p{		MODIFIER_letters}', "");
    Expect(1, 768, '\p{^		MODIFIER_letters}', "");
    Expect(1, 768, '\P{		MODIFIER_letters}', "");
    Expect(0, 768, '\P{^		MODIFIER_letters}', "");
    Error('\p{Is_Modifier_letters/a/}');
    Error('\P{Is_Modifier_letters/a/}');
    Expect(1, 767, '\p{ismodifierletters}', "");
    Expect(0, 767, '\p{^ismodifierletters}', "");
    Expect(0, 767, '\P{ismodifierletters}', "");
    Expect(1, 767, '\P{^ismodifierletters}', "");
    Expect(0, 768, '\p{ismodifierletters}', "");
    Expect(1, 768, '\p{^ismodifierletters}', "");
    Expect(1, 768, '\P{ismodifierletters}', "");
    Expect(0, 768, '\P{^ismodifierletters}', "");
    Expect(1, 767, '\p{  is_MODIFIER_Letters}', "");
    Expect(0, 767, '\p{^  is_MODIFIER_Letters}', "");
    Expect(0, 767, '\P{  is_MODIFIER_Letters}', "");
    Expect(1, 767, '\P{^  is_MODIFIER_Letters}', "");
    Expect(0, 768, '\p{  is_MODIFIER_Letters}', "");
    Expect(1, 768, '\p{^  is_MODIFIER_Letters}', "");
    Expect(1, 768, '\P{  is_MODIFIER_Letters}', "");
    Expect(0, 768, '\P{^  is_MODIFIER_Letters}', "");
    Error('\p{_In_Modifier_Letters:=}');
    Error('\P{_In_Modifier_Letters:=}');
    Expect(1, 767, '\p{inmodifierletters}', "");
    Expect(0, 767, '\p{^inmodifierletters}', "");
    Expect(0, 767, '\P{inmodifierletters}', "");
    Expect(1, 767, '\P{^inmodifierletters}', "");
    Expect(0, 768, '\p{inmodifierletters}', "");
    Expect(1, 768, '\p{^inmodifierletters}', "");
    Expect(1, 768, '\P{inmodifierletters}', "");
    Expect(0, 768, '\P{^inmodifierletters}', "");
    Expect(1, 767, '\p{_-In_Modifier_LETTERS}', "");
    Expect(0, 767, '\p{^_-In_Modifier_LETTERS}', "");
    Expect(0, 767, '\P{_-In_Modifier_LETTERS}', "");
    Expect(1, 767, '\P{^_-In_Modifier_LETTERS}', "");
    Expect(0, 768, '\p{_-In_Modifier_LETTERS}', "");
    Expect(1, 768, '\p{^_-In_Modifier_LETTERS}', "");
    Expect(1, 768, '\P{_-In_Modifier_LETTERS}', "");
    Expect(0, 768, '\P{^_-In_Modifier_LETTERS}', "");
    Error('\p{/a/specials}');
    Error('\P{/a/specials}');
    Expect(1, 65520, '\p{specials}', "");
    Expect(0, 65520, '\p{^specials}', "");
    Expect(0, 65520, '\P{specials}', "");
    Expect(1, 65520, '\P{^specials}', "");
    Expect(0, 65536, '\p{specials}', "");
    Expect(1, 65536, '\p{^specials}', "");
    Expect(1, 65536, '\P{specials}', "");
    Expect(0, 65536, '\P{^specials}', "");
    Expect(1, 65520, '\p{ -Specials}', "");
    Expect(0, 65520, '\p{^ -Specials}', "");
    Expect(0, 65520, '\P{ -Specials}', "");
    Expect(1, 65520, '\P{^ -Specials}', "");
    Expect(0, 65536, '\p{ -Specials}', "");
    Expect(1, 65536, '\p{^ -Specials}', "");
    Expect(1, 65536, '\P{ -Specials}', "");
    Expect(0, 65536, '\P{^ -Specials}', "");
    Error('\p{:=IS_specials}');
    Error('\P{:=IS_specials}');
    Expect(1, 65520, '\p{isspecials}', "");
    Expect(0, 65520, '\p{^isspecials}', "");
    Expect(0, 65520, '\P{isspecials}', "");
    Expect(1, 65520, '\P{^isspecials}', "");
    Expect(0, 65536, '\p{isspecials}', "");
    Expect(1, 65536, '\p{^isspecials}', "");
    Expect(1, 65536, '\P{isspecials}', "");
    Expect(0, 65536, '\P{^isspecials}', "");
    Expect(1, 65520, '\p{--is_SPECIALS}', "");
    Expect(0, 65520, '\p{^--is_SPECIALS}', "");
    Expect(0, 65520, '\P{--is_SPECIALS}', "");
    Expect(1, 65520, '\P{^--is_SPECIALS}', "");
    Expect(0, 65536, '\p{--is_SPECIALS}', "");
    Expect(1, 65536, '\p{^--is_SPECIALS}', "");
    Expect(1, 65536, '\P{--is_SPECIALS}', "");
    Expect(0, 65536, '\P{^--is_SPECIALS}', "");
    Error('\p{:=	 IN_Specials}');
    Error('\P{:=	 IN_Specials}');
    Expect(1, 65520, '\p{inspecials}', "");
    Expect(0, 65520, '\p{^inspecials}', "");
    Expect(0, 65520, '\P{inspecials}', "");
    Expect(1, 65520, '\P{^inspecials}', "");
    Expect(0, 65536, '\p{inspecials}', "");
    Expect(1, 65536, '\p{^inspecials}', "");
    Expect(1, 65536, '\P{inspecials}', "");
    Expect(0, 65536, '\P{^inspecials}', "");
    Expect(1, 65520, '\p{-in_specials}', "");
    Expect(0, 65520, '\p{^-in_specials}', "");
    Expect(0, 65520, '\P{-in_specials}', "");
    Expect(1, 65520, '\P{^-in_specials}', "");
    Expect(0, 65536, '\p{-in_specials}', "");
    Expect(1, 65536, '\p{^-in_specials}', "");
    Expect(1, 65536, '\P{-in_specials}', "");
    Expect(0, 65536, '\P{^-in_specials}', "");
    Error('\p{	-Sundanese:=}');
    Error('\P{	-Sundanese:=}');
    Expect(1, 7367, '\p{sundanese}', "");
    Expect(0, 7367, '\p{^sundanese}', "");
    Expect(0, 7367, '\P{sundanese}', "");
    Expect(1, 7367, '\P{^sundanese}', "");
    Expect(0, 7368, '\p{sundanese}', "");
    Expect(1, 7368, '\p{^sundanese}', "");
    Expect(1, 7368, '\P{sundanese}', "");
    Expect(0, 7368, '\P{^sundanese}', "");
    Expect(1, 7367, '\p{	Sundanese}', "");
    Expect(0, 7367, '\p{^	Sundanese}', "");
    Expect(0, 7367, '\P{	Sundanese}', "");
    Expect(1, 7367, '\P{^	Sundanese}', "");
    Expect(0, 7368, '\p{	Sundanese}', "");
    Expect(1, 7368, '\p{^	Sundanese}', "");
    Expect(1, 7368, '\P{	Sundanese}', "");
    Expect(0, 7368, '\P{^	Sundanese}', "");
    Error('\p{_	Is_sundanese:=}');
    Error('\P{_	Is_sundanese:=}');
    Expect(1, 7367, '\p{issundanese}', "");
    Expect(0, 7367, '\p{^issundanese}', "");
    Expect(0, 7367, '\P{issundanese}', "");
    Expect(1, 7367, '\P{^issundanese}', "");
    Expect(0, 7368, '\p{issundanese}', "");
    Expect(1, 7368, '\p{^issundanese}', "");
    Expect(1, 7368, '\P{issundanese}', "");
    Expect(0, 7368, '\P{^issundanese}', "");
    Expect(1, 7367, '\p{	-Is_Sundanese}', "");
    Expect(0, 7367, '\p{^	-Is_Sundanese}', "");
    Expect(0, 7367, '\P{	-Is_Sundanese}', "");
    Expect(1, 7367, '\P{^	-Is_Sundanese}', "");
    Expect(0, 7368, '\p{	-Is_Sundanese}', "");
    Expect(1, 7368, '\p{^	-Is_Sundanese}', "");
    Expect(1, 7368, '\P{	-Is_Sundanese}', "");
    Expect(0, 7368, '\P{^	-Is_Sundanese}', "");
    Error('\p{:=- SUND}');
    Error('\P{:=- SUND}');
    Expect(1, 7367, '\p{sund}', "");
    Expect(0, 7367, '\p{^sund}', "");
    Expect(0, 7367, '\P{sund}', "");
    Expect(1, 7367, '\P{^sund}', "");
    Expect(0, 7368, '\p{sund}', "");
    Expect(1, 7368, '\p{^sund}', "");
    Expect(1, 7368, '\P{sund}', "");
    Expect(0, 7368, '\P{^sund}', "");
    Expect(1, 7367, '\p{-	Sund}', "");
    Expect(0, 7367, '\p{^-	Sund}', "");
    Expect(0, 7367, '\P{-	Sund}', "");
    Expect(1, 7367, '\P{^-	Sund}', "");
    Expect(0, 7368, '\p{-	Sund}', "");
    Expect(1, 7368, '\p{^-	Sund}', "");
    Expect(1, 7368, '\P{-	Sund}', "");
    Expect(0, 7368, '\P{^-	Sund}', "");
    Error('\p{ _IS_sund/a/}');
    Error('\P{ _IS_sund/a/}');
    Expect(1, 7367, '\p{issund}', "");
    Expect(0, 7367, '\p{^issund}', "");
    Expect(0, 7367, '\P{issund}', "");
    Expect(1, 7367, '\P{^issund}', "");
    Expect(0, 7368, '\p{issund}', "");
    Expect(1, 7368, '\p{^issund}', "");
    Expect(1, 7368, '\P{issund}', "");
    Expect(0, 7368, '\P{^issund}', "");
    Expect(1, 7367, '\p{--IS_Sund}', "");
    Expect(0, 7367, '\p{^--IS_Sund}', "");
    Expect(0, 7367, '\P{--IS_Sund}', "");
    Expect(1, 7367, '\P{^--IS_Sund}', "");
    Expect(0, 7368, '\p{--IS_Sund}', "");
    Expect(1, 7368, '\p{^--IS_Sund}', "");
    Expect(1, 7368, '\P{--IS_Sund}', "");
    Expect(0, 7368, '\P{^--IS_Sund}', "");
    Error('\p{ _Sundanese_Supplement/a/}');
    Error('\P{ _Sundanese_Supplement/a/}');
    Expect(1, 7375, '\p{sundanesesupplement}', "");
    Expect(0, 7375, '\p{^sundanesesupplement}', "");
    Expect(0, 7375, '\P{sundanesesupplement}', "");
    Expect(1, 7375, '\P{^sundanesesupplement}', "");
    Expect(0, 7376, '\p{sundanesesupplement}', "");
    Expect(1, 7376, '\p{^sundanesesupplement}', "");
    Expect(1, 7376, '\P{sundanesesupplement}', "");
    Expect(0, 7376, '\P{^sundanesesupplement}', "");
    Expect(1, 7375, '\p{ _Sundanese_Supplement}', "");
    Expect(0, 7375, '\p{^ _Sundanese_Supplement}', "");
    Expect(0, 7375, '\P{ _Sundanese_Supplement}', "");
    Expect(1, 7375, '\P{^ _Sundanese_Supplement}', "");
    Expect(0, 7376, '\p{ _Sundanese_Supplement}', "");
    Expect(1, 7376, '\p{^ _Sundanese_Supplement}', "");
    Expect(1, 7376, '\P{ _Sundanese_Supplement}', "");
    Expect(0, 7376, '\P{^ _Sundanese_Supplement}', "");
    Error('\p{	:=Is_Sundanese_supplement}');
    Error('\P{	:=Is_Sundanese_supplement}');
    Expect(1, 7375, '\p{issundanesesupplement}', "");
    Expect(0, 7375, '\p{^issundanesesupplement}', "");
    Expect(0, 7375, '\P{issundanesesupplement}', "");
    Expect(1, 7375, '\P{^issundanesesupplement}', "");
    Expect(0, 7376, '\p{issundanesesupplement}', "");
    Expect(1, 7376, '\p{^issundanesesupplement}', "");
    Expect(1, 7376, '\P{issundanesesupplement}', "");
    Expect(0, 7376, '\P{^issundanesesupplement}', "");
    Expect(1, 7375, '\p{-Is_SUNDANESE_supplement}', "");
    Expect(0, 7375, '\p{^-Is_SUNDANESE_supplement}', "");
    Expect(0, 7375, '\P{-Is_SUNDANESE_supplement}', "");
    Expect(1, 7375, '\P{^-Is_SUNDANESE_supplement}', "");
    Expect(0, 7376, '\p{-Is_SUNDANESE_supplement}', "");
    Expect(1, 7376, '\p{^-Is_SUNDANESE_supplement}', "");
    Expect(1, 7376, '\P{-Is_SUNDANESE_supplement}', "");
    Expect(0, 7376, '\P{^-Is_SUNDANESE_supplement}', "");
    Error('\p{/a/_IN_Sundanese_SUPPLEMENT}');
    Error('\P{/a/_IN_Sundanese_SUPPLEMENT}');
    Expect(1, 7375, '\p{insundanesesupplement}', "");
    Expect(0, 7375, '\p{^insundanesesupplement}', "");
    Expect(0, 7375, '\P{insundanesesupplement}', "");
    Expect(1, 7375, '\P{^insundanesesupplement}', "");
    Expect(0, 7376, '\p{insundanesesupplement}', "");
    Expect(1, 7376, '\p{^insundanesesupplement}', "");
    Expect(1, 7376, '\P{insundanesesupplement}', "");
    Expect(0, 7376, '\P{^insundanesesupplement}', "");
    Expect(1, 7375, '\p{ _In_Sundanese_Supplement}', "");
    Expect(0, 7375, '\p{^ _In_Sundanese_Supplement}', "");
    Expect(0, 7375, '\P{ _In_Sundanese_Supplement}', "");
    Expect(1, 7375, '\P{^ _In_Sundanese_Supplement}', "");
    Expect(0, 7376, '\p{ _In_Sundanese_Supplement}', "");
    Expect(1, 7376, '\p{^ _In_Sundanese_Supplement}', "");
    Expect(1, 7376, '\P{ _In_Sundanese_Supplement}', "");
    Expect(0, 7376, '\P{^ _In_Sundanese_Supplement}', "");
    Error('\p{_/a/SUNDANESE_SUP}');
    Error('\P{_/a/SUNDANESE_SUP}');
    Expect(1, 7375, '\p{sundanesesup}', "");
    Expect(0, 7375, '\p{^sundanesesup}', "");
    Expect(0, 7375, '\P{sundanesesup}', "");
    Expect(1, 7375, '\P{^sundanesesup}', "");
    Expect(0, 7376, '\p{sundanesesup}', "");
    Expect(1, 7376, '\p{^sundanesesup}', "");
    Expect(1, 7376, '\P{sundanesesup}', "");
    Expect(0, 7376, '\P{^sundanesesup}', "");
    Expect(1, 7375, '\p{	sundanese_SUP}', "");
    Expect(0, 7375, '\p{^	sundanese_SUP}', "");
    Expect(0, 7375, '\P{	sundanese_SUP}', "");
    Expect(1, 7375, '\P{^	sundanese_SUP}', "");
    Expect(0, 7376, '\p{	sundanese_SUP}', "");
    Expect(1, 7376, '\p{^	sundanese_SUP}', "");
    Expect(1, 7376, '\P{	sundanese_SUP}', "");
    Expect(0, 7376, '\P{^	sundanese_SUP}', "");
    Error('\p{/a/_	IS_Sundanese_SUP}');
    Error('\P{/a/_	IS_Sundanese_SUP}');
    Expect(1, 7375, '\p{issundanesesup}', "");
    Expect(0, 7375, '\p{^issundanesesup}', "");
    Expect(0, 7375, '\P{issundanesesup}', "");
    Expect(1, 7375, '\P{^issundanesesup}', "");
    Expect(0, 7376, '\p{issundanesesup}', "");
    Expect(1, 7376, '\p{^issundanesesup}', "");
    Expect(1, 7376, '\P{issundanesesup}', "");
    Expect(0, 7376, '\P{^issundanesesup}', "");
    Expect(1, 7375, '\p{_ IS_Sundanese_sup}', "");
    Expect(0, 7375, '\p{^_ IS_Sundanese_sup}', "");
    Expect(0, 7375, '\P{_ IS_Sundanese_sup}', "");
    Expect(1, 7375, '\P{^_ IS_Sundanese_sup}', "");
    Expect(0, 7376, '\p{_ IS_Sundanese_sup}', "");
    Expect(1, 7376, '\p{^_ IS_Sundanese_sup}', "");
    Expect(1, 7376, '\P{_ IS_Sundanese_sup}', "");
    Expect(0, 7376, '\P{^_ IS_Sundanese_sup}', "");
    Error('\p{/a/__In_SUNDANESE_SUP}');
    Error('\P{/a/__In_SUNDANESE_SUP}');
    Expect(1, 7375, '\p{insundanesesup}', "");
    Expect(0, 7375, '\p{^insundanesesup}', "");
    Expect(0, 7375, '\P{insundanesesup}', "");
    Expect(1, 7375, '\P{^insundanesesup}', "");
    Expect(0, 7376, '\p{insundanesesup}', "");
    Expect(1, 7376, '\p{^insundanesesup}', "");
    Expect(1, 7376, '\P{insundanesesup}', "");
    Expect(0, 7376, '\P{^insundanesesup}', "");
    Expect(1, 7375, '\p{-_in_sundanese_SUP}', "");
    Expect(0, 7375, '\p{^-_in_sundanese_SUP}', "");
    Expect(0, 7375, '\P{-_in_sundanese_SUP}', "");
    Expect(1, 7375, '\P{^-_in_sundanese_SUP}', "");
    Expect(0, 7376, '\p{-_in_sundanese_SUP}', "");
    Expect(1, 7376, '\p{^-_in_sundanese_SUP}', "");
    Expect(1, 7376, '\P{-_in_sundanese_SUP}', "");
    Expect(0, 7376, '\P{^-_in_sundanese_SUP}', "");
    Error('\p{/a/  superscripts_And_subscripts}');
    Error('\P{/a/  superscripts_And_subscripts}');
    Expect(1, 8351, '\p{superscriptsandsubscripts}', "");
    Expect(0, 8351, '\p{^superscriptsandsubscripts}', "");
    Expect(0, 8351, '\P{superscriptsandsubscripts}', "");
    Expect(1, 8351, '\P{^superscriptsandsubscripts}', "");
    Expect(0, 8352, '\p{superscriptsandsubscripts}', "");
    Expect(1, 8352, '\p{^superscriptsandsubscripts}', "");
    Expect(1, 8352, '\P{superscriptsandsubscripts}', "");
    Expect(0, 8352, '\P{^superscriptsandsubscripts}', "");
    Expect(1, 8351, '\p{ Superscripts_AND_Subscripts}', "");
    Expect(0, 8351, '\p{^ Superscripts_AND_Subscripts}', "");
    Expect(0, 8351, '\P{ Superscripts_AND_Subscripts}', "");
    Expect(1, 8351, '\P{^ Superscripts_AND_Subscripts}', "");
    Expect(0, 8352, '\p{ Superscripts_AND_Subscripts}', "");
    Expect(1, 8352, '\p{^ Superscripts_AND_Subscripts}', "");
    Expect(1, 8352, '\P{ Superscripts_AND_Subscripts}', "");
    Expect(0, 8352, '\P{^ Superscripts_AND_Subscripts}', "");
    Error('\p{/a/__Is_Superscripts_AND_subscripts}');
    Error('\P{/a/__Is_Superscripts_AND_subscripts}');
    Expect(1, 8351, '\p{issuperscriptsandsubscripts}', "");
    Expect(0, 8351, '\p{^issuperscriptsandsubscripts}', "");
    Expect(0, 8351, '\P{issuperscriptsandsubscripts}', "");
    Expect(1, 8351, '\P{^issuperscriptsandsubscripts}', "");
    Expect(0, 8352, '\p{issuperscriptsandsubscripts}', "");
    Expect(1, 8352, '\p{^issuperscriptsandsubscripts}', "");
    Expect(1, 8352, '\P{issuperscriptsandsubscripts}', "");
    Expect(0, 8352, '\P{^issuperscriptsandsubscripts}', "");
    Expect(1, 8351, '\p{	 Is_Superscripts_And_Subscripts}', "");
    Expect(0, 8351, '\p{^	 Is_Superscripts_And_Subscripts}', "");
    Expect(0, 8351, '\P{	 Is_Superscripts_And_Subscripts}', "");
    Expect(1, 8351, '\P{^	 Is_Superscripts_And_Subscripts}', "");
    Expect(0, 8352, '\p{	 Is_Superscripts_And_Subscripts}', "");
    Expect(1, 8352, '\p{^	 Is_Superscripts_And_Subscripts}', "");
    Expect(1, 8352, '\P{	 Is_Superscripts_And_Subscripts}', "");
    Expect(0, 8352, '\P{^	 Is_Superscripts_And_Subscripts}', "");
    Error('\p{:= _in_superscripts_And_Subscripts}');
    Error('\P{:= _in_superscripts_And_Subscripts}');
    Expect(1, 8351, '\p{insuperscriptsandsubscripts}', "");
    Expect(0, 8351, '\p{^insuperscriptsandsubscripts}', "");
    Expect(0, 8351, '\P{insuperscriptsandsubscripts}', "");
    Expect(1, 8351, '\P{^insuperscriptsandsubscripts}', "");
    Expect(0, 8352, '\p{insuperscriptsandsubscripts}', "");
    Expect(1, 8352, '\p{^insuperscriptsandsubscripts}', "");
    Expect(1, 8352, '\P{insuperscriptsandsubscripts}', "");
    Expect(0, 8352, '\P{^insuperscriptsandsubscripts}', "");
    Expect(1, 8351, '\p{-In_Superscripts_and_SUBSCRIPTS}', "");
    Expect(0, 8351, '\p{^-In_Superscripts_and_SUBSCRIPTS}', "");
    Expect(0, 8351, '\P{-In_Superscripts_and_SUBSCRIPTS}', "");
    Expect(1, 8351, '\P{^-In_Superscripts_and_SUBSCRIPTS}', "");
    Expect(0, 8352, '\p{-In_Superscripts_and_SUBSCRIPTS}', "");
    Expect(1, 8352, '\p{^-In_Superscripts_and_SUBSCRIPTS}', "");
    Expect(1, 8352, '\P{-In_Superscripts_and_SUBSCRIPTS}', "");
    Expect(0, 8352, '\P{^-In_Superscripts_and_SUBSCRIPTS}', "");
    Error('\p{	 Super_and_Sub/a/}');
    Error('\P{	 Super_and_Sub/a/}');
    Expect(1, 8351, '\p{superandsub}', "");
    Expect(0, 8351, '\p{^superandsub}', "");
    Expect(0, 8351, '\P{superandsub}', "");
    Expect(1, 8351, '\P{^superandsub}', "");
    Expect(0, 8352, '\p{superandsub}', "");
    Expect(1, 8352, '\p{^superandsub}', "");
    Expect(1, 8352, '\P{superandsub}', "");
    Expect(0, 8352, '\P{^superandsub}', "");
    Expect(1, 8351, '\p{	 super_and_SUB}', "");
    Expect(0, 8351, '\p{^	 super_and_SUB}', "");
    Expect(0, 8351, '\P{	 super_and_SUB}', "");
    Expect(1, 8351, '\P{^	 super_and_SUB}', "");
    Expect(0, 8352, '\p{	 super_and_SUB}', "");
    Expect(1, 8352, '\p{^	 super_and_SUB}', "");
    Expect(1, 8352, '\P{	 super_and_SUB}', "");
    Expect(0, 8352, '\P{^	 super_and_SUB}', "");
    Error('\p{:=-_is_super_And_Sub}');
    Error('\P{:=-_is_super_And_Sub}');
    Expect(1, 8351, '\p{issuperandsub}', "");
    Expect(0, 8351, '\p{^issuperandsub}', "");
    Expect(0, 8351, '\P{issuperandsub}', "");
    Expect(1, 8351, '\P{^issuperandsub}', "");
    Expect(0, 8352, '\p{issuperandsub}', "");
    Expect(1, 8352, '\p{^issuperandsub}', "");
    Expect(1, 8352, '\P{issuperandsub}', "");
    Expect(0, 8352, '\P{^issuperandsub}', "");
    Expect(1, 8351, '\p{-IS_Super_AND_Sub}', "");
    Expect(0, 8351, '\p{^-IS_Super_AND_Sub}', "");
    Expect(0, 8351, '\P{-IS_Super_AND_Sub}', "");
    Expect(1, 8351, '\P{^-IS_Super_AND_Sub}', "");
    Expect(0, 8352, '\p{-IS_Super_AND_Sub}', "");
    Expect(1, 8352, '\p{^-IS_Super_AND_Sub}', "");
    Expect(1, 8352, '\P{-IS_Super_AND_Sub}', "");
    Expect(0, 8352, '\P{^-IS_Super_AND_Sub}', "");
    Error('\p{_	IN_Super_And_SUB/a/}');
    Error('\P{_	IN_Super_And_SUB/a/}');
    Expect(1, 8351, '\p{insuperandsub}', "");
    Expect(0, 8351, '\p{^insuperandsub}', "");
    Expect(0, 8351, '\P{insuperandsub}', "");
    Expect(1, 8351, '\P{^insuperandsub}', "");
    Expect(0, 8352, '\p{insuperandsub}', "");
    Expect(1, 8352, '\p{^insuperandsub}', "");
    Expect(1, 8352, '\P{insuperandsub}', "");
    Expect(0, 8352, '\P{^insuperandsub}', "");
    Expect(1, 8351, '\p{  In_SUPER_and_Sub}', "");
    Expect(0, 8351, '\p{^  In_SUPER_and_Sub}', "");
    Expect(0, 8351, '\P{  In_SUPER_and_Sub}', "");
    Expect(1, 8351, '\P{^  In_SUPER_and_Sub}', "");
    Expect(0, 8352, '\p{  In_SUPER_and_Sub}', "");
    Expect(1, 8352, '\p{^  In_SUPER_and_Sub}', "");
    Expect(1, 8352, '\P{  In_SUPER_and_Sub}', "");
    Expect(0, 8352, '\P{^  In_SUPER_and_Sub}', "");
    Error('\p{-SUPPLEMENTAL_Arrows_A:=}');
    Error('\P{-SUPPLEMENTAL_Arrows_A:=}');
    Expect(1, 10239, '\p{supplementalarrowsa}', "");
    Expect(0, 10239, '\p{^supplementalarrowsa}', "");
    Expect(0, 10239, '\P{supplementalarrowsa}', "");
    Expect(1, 10239, '\P{^supplementalarrowsa}', "");
    Expect(0, 10240, '\p{supplementalarrowsa}', "");
    Expect(1, 10240, '\p{^supplementalarrowsa}', "");
    Expect(1, 10240, '\P{supplementalarrowsa}', "");
    Expect(0, 10240, '\P{^supplementalarrowsa}', "");
    Expect(1, 10239, '\p{		supplemental_Arrows_A}', "");
    Expect(0, 10239, '\p{^		supplemental_Arrows_A}', "");
    Expect(0, 10239, '\P{		supplemental_Arrows_A}', "");
    Expect(1, 10239, '\P{^		supplemental_Arrows_A}', "");
    Expect(0, 10240, '\p{		supplemental_Arrows_A}', "");
    Expect(1, 10240, '\p{^		supplemental_Arrows_A}', "");
    Expect(1, 10240, '\P{		supplemental_Arrows_A}', "");
    Expect(0, 10240, '\P{^		supplemental_Arrows_A}', "");
    Error('\p{	Is_supplemental_ARROWS_A:=}');
    Error('\P{	Is_supplemental_ARROWS_A:=}');
    Expect(1, 10239, '\p{issupplementalarrowsa}', "");
    Expect(0, 10239, '\p{^issupplementalarrowsa}', "");
    Expect(0, 10239, '\P{issupplementalarrowsa}', "");
    Expect(1, 10239, '\P{^issupplementalarrowsa}', "");
    Expect(0, 10240, '\p{issupplementalarrowsa}', "");
    Expect(1, 10240, '\p{^issupplementalarrowsa}', "");
    Expect(1, 10240, '\P{issupplementalarrowsa}', "");
    Expect(0, 10240, '\P{^issupplementalarrowsa}', "");
    Expect(1, 10239, '\p{ 	IS_SUPPLEMENTAL_Arrows_A}', "");
    Expect(0, 10239, '\p{^ 	IS_SUPPLEMENTAL_Arrows_A}', "");
    Expect(0, 10239, '\P{ 	IS_SUPPLEMENTAL_Arrows_A}', "");
    Expect(1, 10239, '\P{^ 	IS_SUPPLEMENTAL_Arrows_A}', "");
    Expect(0, 10240, '\p{ 	IS_SUPPLEMENTAL_Arrows_A}', "");
    Expect(1, 10240, '\p{^ 	IS_SUPPLEMENTAL_Arrows_A}', "");
    Expect(1, 10240, '\P{ 	IS_SUPPLEMENTAL_Arrows_A}', "");
    Expect(0, 10240, '\P{^ 	IS_SUPPLEMENTAL_Arrows_A}', "");
    Error('\p{ 	in_Supplemental_arrows_A:=}');
    Error('\P{ 	in_Supplemental_arrows_A:=}');
    Expect(1, 10239, '\p{insupplementalarrowsa}', "");
    Expect(0, 10239, '\p{^insupplementalarrowsa}', "");
    Expect(0, 10239, '\P{insupplementalarrowsa}', "");
    Expect(1, 10239, '\P{^insupplementalarrowsa}', "");
    Expect(0, 10240, '\p{insupplementalarrowsa}', "");
    Expect(1, 10240, '\p{^insupplementalarrowsa}', "");
    Expect(1, 10240, '\P{insupplementalarrowsa}', "");
    Expect(0, 10240, '\P{^insupplementalarrowsa}', "");
    Expect(1, 10239, '\p{ 	In_supplemental_Arrows_A}', "");
    Expect(0, 10239, '\p{^ 	In_supplemental_Arrows_A}', "");
    Expect(0, 10239, '\P{ 	In_supplemental_Arrows_A}', "");
    Expect(1, 10239, '\P{^ 	In_supplemental_Arrows_A}', "");
    Expect(0, 10240, '\p{ 	In_supplemental_Arrows_A}', "");
    Expect(1, 10240, '\p{^ 	In_supplemental_Arrows_A}', "");
    Expect(1, 10240, '\P{ 	In_supplemental_Arrows_A}', "");
    Expect(0, 10240, '\P{^ 	In_supplemental_Arrows_A}', "");
    Error('\p{/a/sup_Arrows_a}');
    Error('\P{/a/sup_Arrows_a}');
    Expect(1, 10239, '\p{suparrowsa}', "");
    Expect(0, 10239, '\p{^suparrowsa}', "");
    Expect(0, 10239, '\P{suparrowsa}', "");
    Expect(1, 10239, '\P{^suparrowsa}', "");
    Expect(0, 10240, '\p{suparrowsa}', "");
    Expect(1, 10240, '\p{^suparrowsa}', "");
    Expect(1, 10240, '\P{suparrowsa}', "");
    Expect(0, 10240, '\P{^suparrowsa}', "");
    Expect(1, 10239, '\p{_	SUP_Arrows_A}', "");
    Expect(0, 10239, '\p{^_	SUP_Arrows_A}', "");
    Expect(0, 10239, '\P{_	SUP_Arrows_A}', "");
    Expect(1, 10239, '\P{^_	SUP_Arrows_A}', "");
    Expect(0, 10240, '\p{_	SUP_Arrows_A}', "");
    Expect(1, 10240, '\p{^_	SUP_Arrows_A}', "");
    Expect(1, 10240, '\P{_	SUP_Arrows_A}', "");
    Expect(0, 10240, '\P{^_	SUP_Arrows_A}', "");
    Error('\p{/a/  IS_SUP_Arrows_A}');
    Error('\P{/a/  IS_SUP_Arrows_A}');
    Expect(1, 10239, '\p{issuparrowsa}', "");
    Expect(0, 10239, '\p{^issuparrowsa}', "");
    Expect(0, 10239, '\P{issuparrowsa}', "");
    Expect(1, 10239, '\P{^issuparrowsa}', "");
    Expect(0, 10240, '\p{issuparrowsa}', "");
    Expect(1, 10240, '\p{^issuparrowsa}', "");
    Expect(1, 10240, '\P{issuparrowsa}', "");
    Expect(0, 10240, '\P{^issuparrowsa}', "");
    Expect(1, 10239, '\p{_IS_sup_arrows_A}', "");
    Expect(0, 10239, '\p{^_IS_sup_arrows_A}', "");
    Expect(0, 10239, '\P{_IS_sup_arrows_A}', "");
    Expect(1, 10239, '\P{^_IS_sup_arrows_A}', "");
    Expect(0, 10240, '\p{_IS_sup_arrows_A}', "");
    Expect(1, 10240, '\p{^_IS_sup_arrows_A}', "");
    Expect(1, 10240, '\P{_IS_sup_arrows_A}', "");
    Expect(0, 10240, '\P{^_IS_sup_arrows_A}', "");
    Error('\p{_In_Sup_ARROWS_A/a/}');
    Error('\P{_In_Sup_ARROWS_A/a/}');
    Expect(1, 10239, '\p{insuparrowsa}', "");
    Expect(0, 10239, '\p{^insuparrowsa}', "");
    Expect(0, 10239, '\P{insuparrowsa}', "");
    Expect(1, 10239, '\P{^insuparrowsa}', "");
    Expect(0, 10240, '\p{insuparrowsa}', "");
    Expect(1, 10240, '\p{^insuparrowsa}', "");
    Expect(1, 10240, '\P{insuparrowsa}', "");
    Expect(0, 10240, '\P{^insuparrowsa}', "");
    Expect(1, 10239, '\p{_	In_Sup_arrows_A}', "");
    Expect(0, 10239, '\p{^_	In_Sup_arrows_A}', "");
    Expect(0, 10239, '\P{_	In_Sup_arrows_A}', "");
    Expect(1, 10239, '\P{^_	In_Sup_arrows_A}', "");
    Expect(0, 10240, '\p{_	In_Sup_arrows_A}', "");
    Expect(1, 10240, '\p{^_	In_Sup_arrows_A}', "");
    Expect(1, 10240, '\P{_	In_Sup_arrows_A}', "");
    Expect(0, 10240, '\P{^_	In_Sup_arrows_A}', "");
    Error('\p{:=--Supplemental_Arrows_B}');
    Error('\P{:=--Supplemental_Arrows_B}');
    Expect(1, 10623, '\p{supplementalarrowsb}', "");
    Expect(0, 10623, '\p{^supplementalarrowsb}', "");
    Expect(0, 10623, '\P{supplementalarrowsb}', "");
    Expect(1, 10623, '\P{^supplementalarrowsb}', "");
    Expect(0, 10624, '\p{supplementalarrowsb}', "");
    Expect(1, 10624, '\p{^supplementalarrowsb}', "");
    Expect(1, 10624, '\P{supplementalarrowsb}', "");
    Expect(0, 10624, '\P{^supplementalarrowsb}', "");
    Expect(1, 10623, '\p{  Supplemental_ARROWS_B}', "");
    Expect(0, 10623, '\p{^  Supplemental_ARROWS_B}', "");
    Expect(0, 10623, '\P{  Supplemental_ARROWS_B}', "");
    Expect(1, 10623, '\P{^  Supplemental_ARROWS_B}', "");
    Expect(0, 10624, '\p{  Supplemental_ARROWS_B}', "");
    Expect(1, 10624, '\p{^  Supplemental_ARROWS_B}', "");
    Expect(1, 10624, '\P{  Supplemental_ARROWS_B}', "");
    Expect(0, 10624, '\P{^  Supplemental_ARROWS_B}', "");
    Error('\p{_:=IS_SUPPLEMENTAL_arrows_B}');
    Error('\P{_:=IS_SUPPLEMENTAL_arrows_B}');
    Expect(1, 10623, '\p{issupplementalarrowsb}', "");
    Expect(0, 10623, '\p{^issupplementalarrowsb}', "");
    Expect(0, 10623, '\P{issupplementalarrowsb}', "");
    Expect(1, 10623, '\P{^issupplementalarrowsb}', "");
    Expect(0, 10624, '\p{issupplementalarrowsb}', "");
    Expect(1, 10624, '\p{^issupplementalarrowsb}', "");
    Expect(1, 10624, '\P{issupplementalarrowsb}', "");
    Expect(0, 10624, '\P{^issupplementalarrowsb}', "");
    Expect(1, 10623, '\p{__Is_Supplemental_ARROWS_B}', "");
    Expect(0, 10623, '\p{^__Is_Supplemental_ARROWS_B}', "");
    Expect(0, 10623, '\P{__Is_Supplemental_ARROWS_B}', "");
    Expect(1, 10623, '\P{^__Is_Supplemental_ARROWS_B}', "");
    Expect(0, 10624, '\p{__Is_Supplemental_ARROWS_B}', "");
    Expect(1, 10624, '\p{^__Is_Supplemental_ARROWS_B}', "");
    Expect(1, 10624, '\P{__Is_Supplemental_ARROWS_B}', "");
    Expect(0, 10624, '\P{^__Is_Supplemental_ARROWS_B}', "");
    Error('\p{:=-_in_Supplemental_Arrows_B}');
    Error('\P{:=-_in_Supplemental_Arrows_B}');
    Expect(1, 10623, '\p{insupplementalarrowsb}', "");
    Expect(0, 10623, '\p{^insupplementalarrowsb}', "");
    Expect(0, 10623, '\P{insupplementalarrowsb}', "");
    Expect(1, 10623, '\P{^insupplementalarrowsb}', "");
    Expect(0, 10624, '\p{insupplementalarrowsb}', "");
    Expect(1, 10624, '\p{^insupplementalarrowsb}', "");
    Expect(1, 10624, '\P{insupplementalarrowsb}', "");
    Expect(0, 10624, '\P{^insupplementalarrowsb}', "");
    Expect(1, 10623, '\p{ In_SUPPLEMENTAL_ARROWS_B}', "");
    Expect(0, 10623, '\p{^ In_SUPPLEMENTAL_ARROWS_B}', "");
    Expect(0, 10623, '\P{ In_SUPPLEMENTAL_ARROWS_B}', "");
    Expect(1, 10623, '\P{^ In_SUPPLEMENTAL_ARROWS_B}', "");
    Expect(0, 10624, '\p{ In_SUPPLEMENTAL_ARROWS_B}', "");
    Expect(1, 10624, '\p{^ In_SUPPLEMENTAL_ARROWS_B}', "");
    Expect(1, 10624, '\P{ In_SUPPLEMENTAL_ARROWS_B}', "");
    Expect(0, 10624, '\P{^ In_SUPPLEMENTAL_ARROWS_B}', "");
    Error('\p{/a/	 sup_Arrows_b}');
    Error('\P{/a/	 sup_Arrows_b}');
    Expect(1, 10623, '\p{suparrowsb}', "");
    Expect(0, 10623, '\p{^suparrowsb}', "");
    Expect(0, 10623, '\P{suparrowsb}', "");
    Expect(1, 10623, '\P{^suparrowsb}', "");
    Expect(0, 10624, '\p{suparrowsb}', "");
    Expect(1, 10624, '\p{^suparrowsb}', "");
    Expect(1, 10624, '\P{suparrowsb}', "");
    Expect(0, 10624, '\P{^suparrowsb}', "");
    Expect(1, 10623, '\p{		sup_Arrows_B}', "");
    Expect(0, 10623, '\p{^		sup_Arrows_B}', "");
    Expect(0, 10623, '\P{		sup_Arrows_B}', "");
    Expect(1, 10623, '\P{^		sup_Arrows_B}', "");
    Expect(0, 10624, '\p{		sup_Arrows_B}', "");
    Expect(1, 10624, '\p{^		sup_Arrows_B}', "");
    Expect(1, 10624, '\P{		sup_Arrows_B}', "");
    Expect(0, 10624, '\P{^		sup_Arrows_B}', "");
    Error('\p{_is_sup_ARROWS_B:=}');
    Error('\P{_is_sup_ARROWS_B:=}');
    Expect(1, 10623, '\p{issuparrowsb}', "");
    Expect(0, 10623, '\p{^issuparrowsb}', "");
    Expect(0, 10623, '\P{issuparrowsb}', "");
    Expect(1, 10623, '\P{^issuparrowsb}', "");
    Expect(0, 10624, '\p{issuparrowsb}', "");
    Expect(1, 10624, '\p{^issuparrowsb}', "");
    Expect(1, 10624, '\P{issuparrowsb}', "");
    Expect(0, 10624, '\P{^issuparrowsb}', "");
    Expect(1, 10623, '\p{ Is_Sup_ARROWS_B}', "");
    Expect(0, 10623, '\p{^ Is_Sup_ARROWS_B}', "");
    Expect(0, 10623, '\P{ Is_Sup_ARROWS_B}', "");
    Expect(1, 10623, '\P{^ Is_Sup_ARROWS_B}', "");
    Expect(0, 10624, '\p{ Is_Sup_ARROWS_B}', "");
    Expect(1, 10624, '\p{^ Is_Sup_ARROWS_B}', "");
    Expect(1, 10624, '\P{ Is_Sup_ARROWS_B}', "");
    Expect(0, 10624, '\P{^ Is_Sup_ARROWS_B}', "");
    Error('\p{	in_sup_Arrows_b/a/}');
    Error('\P{	in_sup_Arrows_b/a/}');
    Expect(1, 10623, '\p{insuparrowsb}', "");
    Expect(0, 10623, '\p{^insuparrowsb}', "");
    Expect(0, 10623, '\P{insuparrowsb}', "");
    Expect(1, 10623, '\P{^insuparrowsb}', "");
    Expect(0, 10624, '\p{insuparrowsb}', "");
    Expect(1, 10624, '\p{^insuparrowsb}', "");
    Expect(1, 10624, '\P{insuparrowsb}', "");
    Expect(0, 10624, '\P{^insuparrowsb}', "");
    Expect(1, 10623, '\p{ 	In_SUP_Arrows_B}', "");
    Expect(0, 10623, '\p{^ 	In_SUP_Arrows_B}', "");
    Expect(0, 10623, '\P{ 	In_SUP_Arrows_B}', "");
    Expect(1, 10623, '\P{^ 	In_SUP_Arrows_B}', "");
    Expect(0, 10624, '\p{ 	In_SUP_Arrows_B}', "");
    Expect(1, 10624, '\p{^ 	In_SUP_Arrows_B}', "");
    Expect(1, 10624, '\P{ 	In_SUP_Arrows_B}', "");
    Expect(0, 10624, '\P{^ 	In_SUP_Arrows_B}', "");
    Error('\p{-:=supplemental_Arrows_C}');
    Error('\P{-:=supplemental_Arrows_C}');
    Expect(1, 129279, '\p{supplementalarrowsc}', "");
    Expect(0, 129279, '\p{^supplementalarrowsc}', "");
    Expect(0, 129279, '\P{supplementalarrowsc}', "");
    Expect(1, 129279, '\P{^supplementalarrowsc}', "");
    Expect(0, 129280, '\p{supplementalarrowsc}', "");
    Expect(1, 129280, '\p{^supplementalarrowsc}', "");
    Expect(1, 129280, '\P{supplementalarrowsc}', "");
    Expect(0, 129280, '\P{^supplementalarrowsc}', "");
    Expect(1, 129279, '\p{-SUPPLEMENTAL_Arrows_c}', "");
    Expect(0, 129279, '\p{^-SUPPLEMENTAL_Arrows_c}', "");
    Expect(0, 129279, '\P{-SUPPLEMENTAL_Arrows_c}', "");
    Expect(1, 129279, '\P{^-SUPPLEMENTAL_Arrows_c}', "");
    Expect(0, 129280, '\p{-SUPPLEMENTAL_Arrows_c}', "");
    Expect(1, 129280, '\p{^-SUPPLEMENTAL_Arrows_c}', "");
    Expect(1, 129280, '\P{-SUPPLEMENTAL_Arrows_c}', "");
    Expect(0, 129280, '\P{^-SUPPLEMENTAL_Arrows_c}', "");
    Error('\p{/a/- Is_supplemental_Arrows_C}');
    Error('\P{/a/- Is_supplemental_Arrows_C}');
    Expect(1, 129279, '\p{issupplementalarrowsc}', "");
    Expect(0, 129279, '\p{^issupplementalarrowsc}', "");
    Expect(0, 129279, '\P{issupplementalarrowsc}', "");
    Expect(1, 129279, '\P{^issupplementalarrowsc}', "");
    Expect(0, 129280, '\p{issupplementalarrowsc}', "");
    Expect(1, 129280, '\p{^issupplementalarrowsc}', "");
    Expect(1, 129280, '\P{issupplementalarrowsc}', "");
    Expect(0, 129280, '\P{^issupplementalarrowsc}', "");
    Expect(1, 129279, '\p{-IS_supplemental_Arrows_c}', "");
    Expect(0, 129279, '\p{^-IS_supplemental_Arrows_c}', "");
    Expect(0, 129279, '\P{-IS_supplemental_Arrows_c}', "");
    Expect(1, 129279, '\P{^-IS_supplemental_Arrows_c}', "");
    Expect(0, 129280, '\p{-IS_supplemental_Arrows_c}', "");
    Expect(1, 129280, '\p{^-IS_supplemental_Arrows_c}', "");
    Expect(1, 129280, '\P{-IS_supplemental_Arrows_c}', "");
    Expect(0, 129280, '\P{^-IS_supplemental_Arrows_c}', "");
    Error('\p{:= In_Supplemental_ARROWS_C}');
    Error('\P{:= In_Supplemental_ARROWS_C}');
    Expect(1, 129279, '\p{insupplementalarrowsc}', "");
    Expect(0, 129279, '\p{^insupplementalarrowsc}', "");
    Expect(0, 129279, '\P{insupplementalarrowsc}', "");
    Expect(1, 129279, '\P{^insupplementalarrowsc}', "");
    Expect(0, 129280, '\p{insupplementalarrowsc}', "");
    Expect(1, 129280, '\p{^insupplementalarrowsc}', "");
    Expect(1, 129280, '\P{insupplementalarrowsc}', "");
    Expect(0, 129280, '\P{^insupplementalarrowsc}', "");
    Expect(1, 129279, '\p{	in_Supplemental_Arrows_C}', "");
    Expect(0, 129279, '\p{^	in_Supplemental_Arrows_C}', "");
    Expect(0, 129279, '\P{	in_Supplemental_Arrows_C}', "");
    Expect(1, 129279, '\P{^	in_Supplemental_Arrows_C}', "");
    Expect(0, 129280, '\p{	in_Supplemental_Arrows_C}', "");
    Expect(1, 129280, '\p{^	in_Supplemental_Arrows_C}', "");
    Expect(1, 129280, '\P{	in_Supplemental_Arrows_C}', "");
    Expect(0, 129280, '\P{^	in_Supplemental_Arrows_C}', "");
    Error('\p{	 Sup_Arrows_C:=}');
    Error('\P{	 Sup_Arrows_C:=}');
    Expect(1, 129279, '\p{suparrowsc}', "");
    Expect(0, 129279, '\p{^suparrowsc}', "");
    Expect(0, 129279, '\P{suparrowsc}', "");
    Expect(1, 129279, '\P{^suparrowsc}', "");
    Expect(0, 129280, '\p{suparrowsc}', "");
    Expect(1, 129280, '\p{^suparrowsc}', "");
    Expect(1, 129280, '\P{suparrowsc}', "");
    Expect(0, 129280, '\P{^suparrowsc}', "");
    Expect(1, 129279, '\p{-	Sup_Arrows_C}', "");
    Expect(0, 129279, '\p{^-	Sup_Arrows_C}', "");
    Expect(0, 129279, '\P{-	Sup_Arrows_C}', "");
    Expect(1, 129279, '\P{^-	Sup_Arrows_C}', "");
    Expect(0, 129280, '\p{-	Sup_Arrows_C}', "");
    Expect(1, 129280, '\p{^-	Sup_Arrows_C}', "");
    Expect(1, 129280, '\P{-	Sup_Arrows_C}', "");
    Expect(0, 129280, '\P{^-	Sup_Arrows_C}', "");
    Error('\p{	-Is_Sup_Arrows_C:=}');
    Error('\P{	-Is_Sup_Arrows_C:=}');
    Expect(1, 129279, '\p{issuparrowsc}', "");
    Expect(0, 129279, '\p{^issuparrowsc}', "");
    Expect(0, 129279, '\P{issuparrowsc}', "");
    Expect(1, 129279, '\P{^issuparrowsc}', "");
    Expect(0, 129280, '\p{issuparrowsc}', "");
    Expect(1, 129280, '\p{^issuparrowsc}', "");
    Expect(1, 129280, '\P{issuparrowsc}', "");
    Expect(0, 129280, '\P{^issuparrowsc}', "");
    Expect(1, 129279, '\p{ -is_sup_Arrows_C}', "");
    Expect(0, 129279, '\p{^ -is_sup_Arrows_C}', "");
    Expect(0, 129279, '\P{ -is_sup_Arrows_C}', "");
    Expect(1, 129279, '\P{^ -is_sup_Arrows_C}', "");
    Expect(0, 129280, '\p{ -is_sup_Arrows_C}', "");
    Expect(1, 129280, '\p{^ -is_sup_Arrows_C}', "");
    Expect(1, 129280, '\P{ -is_sup_Arrows_C}', "");
    Expect(0, 129280, '\P{^ -is_sup_Arrows_C}', "");
    Error('\p{		In_Sup_Arrows_C/a/}');
    Error('\P{		In_Sup_Arrows_C/a/}');
    Expect(1, 129279, '\p{insuparrowsc}', "");
    Expect(0, 129279, '\p{^insuparrowsc}', "");
    Expect(0, 129279, '\P{insuparrowsc}', "");
    Expect(1, 129279, '\P{^insuparrowsc}', "");
    Expect(0, 129280, '\p{insuparrowsc}', "");
    Expect(1, 129280, '\p{^insuparrowsc}', "");
    Expect(1, 129280, '\P{insuparrowsc}', "");
    Expect(0, 129280, '\P{^insuparrowsc}', "");
    Expect(1, 129279, '\p{ IN_Sup_arrows_c}', "");
    Expect(0, 129279, '\p{^ IN_Sup_arrows_c}', "");
    Expect(0, 129279, '\P{ IN_Sup_arrows_c}', "");
    Expect(1, 129279, '\P{^ IN_Sup_arrows_c}', "");
    Expect(0, 129280, '\p{ IN_Sup_arrows_c}', "");
    Expect(1, 129280, '\p{^ IN_Sup_arrows_c}', "");
    Expect(1, 129280, '\P{ IN_Sup_arrows_c}', "");
    Expect(0, 129280, '\P{^ IN_Sup_arrows_c}', "");
    Error('\p{	:=Supplemental_Mathematical_Operators}');
    Error('\P{	:=Supplemental_Mathematical_Operators}');
    Expect(1, 11007, '\p{supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\p{^supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\P{supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\P{^supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\p{supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\p{^supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\P{supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\P{^supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\p{	_Supplemental_MATHEMATICAL_Operators}', "");
    Expect(0, 11007, '\p{^	_Supplemental_MATHEMATICAL_Operators}', "");
    Expect(0, 11007, '\P{	_Supplemental_MATHEMATICAL_Operators}', "");
    Expect(1, 11007, '\P{^	_Supplemental_MATHEMATICAL_Operators}', "");
    Expect(0, 11008, '\p{	_Supplemental_MATHEMATICAL_Operators}', "");
    Expect(1, 11008, '\p{^	_Supplemental_MATHEMATICAL_Operators}', "");
    Expect(1, 11008, '\P{	_Supplemental_MATHEMATICAL_Operators}', "");
    Expect(0, 11008, '\P{^	_Supplemental_MATHEMATICAL_Operators}', "");
    Error('\p{:=	 Is_SUPPLEMENTAL_Mathematical_Operators}');
    Error('\P{:=	 Is_SUPPLEMENTAL_Mathematical_Operators}');
    Expect(1, 11007, '\p{issupplementalmathematicaloperators}', "");
    Expect(0, 11007, '\p{^issupplementalmathematicaloperators}', "");
    Expect(0, 11007, '\P{issupplementalmathematicaloperators}', "");
    Expect(1, 11007, '\P{^issupplementalmathematicaloperators}', "");
    Expect(0, 11008, '\p{issupplementalmathematicaloperators}', "");
    Expect(1, 11008, '\p{^issupplementalmathematicaloperators}', "");
    Expect(1, 11008, '\P{issupplementalmathematicaloperators}', "");
    Expect(0, 11008, '\P{^issupplementalmathematicaloperators}', "");
    Expect(1, 11007, '\p{	_Is_Supplemental_Mathematical_Operators}', "");
    Expect(0, 11007, '\p{^	_Is_Supplemental_Mathematical_Operators}', "");
    Expect(0, 11007, '\P{	_Is_Supplemental_Mathematical_Operators}', "");
    Expect(1, 11007, '\P{^	_Is_Supplemental_Mathematical_Operators}', "");
    Expect(0, 11008, '\p{	_Is_Supplemental_Mathematical_Operators}', "");
    Expect(1, 11008, '\p{^	_Is_Supplemental_Mathematical_Operators}', "");
    Expect(1, 11008, '\P{	_Is_Supplemental_Mathematical_Operators}', "");
    Expect(0, 11008, '\P{^	_Is_Supplemental_Mathematical_Operators}', "");
    Error('\p{/a/_In_supplemental_Mathematical_Operators}');
    Error('\P{/a/_In_supplemental_Mathematical_Operators}');
    Expect(1, 11007, '\p{insupplementalmathematicaloperators}', "");
    Expect(0, 11007, '\p{^insupplementalmathematicaloperators}', "");
    Expect(0, 11007, '\P{insupplementalmathematicaloperators}', "");
    Expect(1, 11007, '\P{^insupplementalmathematicaloperators}', "");
    Expect(0, 11008, '\p{insupplementalmathematicaloperators}', "");
    Expect(1, 11008, '\p{^insupplementalmathematicaloperators}', "");
    Expect(1, 11008, '\P{insupplementalmathematicaloperators}', "");
    Expect(0, 11008, '\P{^insupplementalmathematicaloperators}', "");
    Expect(1, 11007, '\p{-	In_supplemental_Mathematical_Operators}', "");
    Expect(0, 11007, '\p{^-	In_supplemental_Mathematical_Operators}', "");
    Expect(0, 11007, '\P{-	In_supplemental_Mathematical_Operators}', "");
    Expect(1, 11007, '\P{^-	In_supplemental_Mathematical_Operators}', "");
    Expect(0, 11008, '\p{-	In_supplemental_Mathematical_Operators}', "");
    Expect(1, 11008, '\p{^-	In_supplemental_Mathematical_Operators}', "");
    Expect(1, 11008, '\P{-	In_supplemental_Mathematical_Operators}', "");
    Expect(0, 11008, '\P{^-	In_supplemental_Mathematical_Operators}', "");
    Error('\p{_ Sup_Math_Operators/a/}');
    Error('\P{_ Sup_Math_Operators/a/}');
    Expect(1, 11007, '\p{supmathoperators}', "");
    Expect(0, 11007, '\p{^supmathoperators}', "");
    Expect(0, 11007, '\P{supmathoperators}', "");
    Expect(1, 11007, '\P{^supmathoperators}', "");
    Expect(0, 11008, '\p{supmathoperators}', "");
    Expect(1, 11008, '\p{^supmathoperators}', "");
    Expect(1, 11008, '\P{supmathoperators}', "");
    Expect(0, 11008, '\P{^supmathoperators}', "");
    Expect(1, 11007, '\p{  SUP_Math_Operators}', "");
    Expect(0, 11007, '\p{^  SUP_Math_Operators}', "");
    Expect(0, 11007, '\P{  SUP_Math_Operators}', "");
    Expect(1, 11007, '\P{^  SUP_Math_Operators}', "");
    Expect(0, 11008, '\p{  SUP_Math_Operators}', "");
    Expect(1, 11008, '\p{^  SUP_Math_Operators}', "");
    Expect(1, 11008, '\P{  SUP_Math_Operators}', "");
    Expect(0, 11008, '\P{^  SUP_Math_Operators}', "");
    Error('\p{	/a/is_sup_MATH_Operators}');
    Error('\P{	/a/is_sup_MATH_Operators}');
    Expect(1, 11007, '\p{issupmathoperators}', "");
    Expect(0, 11007, '\p{^issupmathoperators}', "");
    Expect(0, 11007, '\P{issupmathoperators}', "");
    Expect(1, 11007, '\P{^issupmathoperators}', "");
    Expect(0, 11008, '\p{issupmathoperators}', "");
    Expect(1, 11008, '\p{^issupmathoperators}', "");
    Expect(1, 11008, '\P{issupmathoperators}', "");
    Expect(0, 11008, '\P{^issupmathoperators}', "");
    Expect(1, 11007, '\p{	_Is_sup_MATH_Operators}', "");
    Expect(0, 11007, '\p{^	_Is_sup_MATH_Operators}', "");
    Expect(0, 11007, '\P{	_Is_sup_MATH_Operators}', "");
    Expect(1, 11007, '\P{^	_Is_sup_MATH_Operators}', "");
    Expect(0, 11008, '\p{	_Is_sup_MATH_Operators}', "");
    Expect(1, 11008, '\p{^	_Is_sup_MATH_Operators}', "");
    Expect(1, 11008, '\P{	_Is_sup_MATH_Operators}', "");
    Expect(0, 11008, '\P{^	_Is_sup_MATH_Operators}', "");
    Error('\p{ _IN_SUP_math_OPERATORS/a/}');
    Error('\P{ _IN_SUP_math_OPERATORS/a/}');
    Expect(1, 11007, '\p{insupmathoperators}', "");
    Expect(0, 11007, '\p{^insupmathoperators}', "");
    Expect(0, 11007, '\P{insupmathoperators}', "");
    Expect(1, 11007, '\P{^insupmathoperators}', "");
    Expect(0, 11008, '\p{insupmathoperators}', "");
    Expect(1, 11008, '\p{^insupmathoperators}', "");
    Expect(1, 11008, '\P{insupmathoperators}', "");
    Expect(0, 11008, '\P{^insupmathoperators}', "");
    Expect(1, 11007, '\p{_In_sup_math_OPERATORS}', "");
    Expect(0, 11007, '\p{^_In_sup_math_OPERATORS}', "");
    Expect(0, 11007, '\P{_In_sup_math_OPERATORS}', "");
    Expect(1, 11007, '\P{^_In_sup_math_OPERATORS}', "");
    Expect(0, 11008, '\p{_In_sup_math_OPERATORS}', "");
    Expect(1, 11008, '\p{^_In_sup_math_OPERATORS}', "");
    Expect(1, 11008, '\P{_In_sup_math_OPERATORS}', "");
    Expect(0, 11008, '\P{^_In_sup_math_OPERATORS}', "");
    Error('\p{ Supplemental_Punctuation:=}');
    Error('\P{ Supplemental_Punctuation:=}');
    Expect(1, 11903, '\p{supplementalpunctuation}', "");
    Expect(0, 11903, '\p{^supplementalpunctuation}', "");
    Expect(0, 11903, '\P{supplementalpunctuation}', "");
    Expect(1, 11903, '\P{^supplementalpunctuation}', "");
    Expect(0, 11904, '\p{supplementalpunctuation}', "");
    Expect(1, 11904, '\p{^supplementalpunctuation}', "");
    Expect(1, 11904, '\P{supplementalpunctuation}', "");
    Expect(0, 11904, '\P{^supplementalpunctuation}', "");
    Expect(1, 11903, '\p{	_supplemental_Punctuation}', "");
    Expect(0, 11903, '\p{^	_supplemental_Punctuation}', "");
    Expect(0, 11903, '\P{	_supplemental_Punctuation}', "");
    Expect(1, 11903, '\P{^	_supplemental_Punctuation}', "");
    Expect(0, 11904, '\p{	_supplemental_Punctuation}', "");
    Expect(1, 11904, '\p{^	_supplemental_Punctuation}', "");
    Expect(1, 11904, '\P{	_supplemental_Punctuation}', "");
    Expect(0, 11904, '\P{^	_supplemental_Punctuation}', "");
    Error('\p{/a/_-Is_supplemental_PUNCTUATION}');
    Error('\P{/a/_-Is_supplemental_PUNCTUATION}');
    Expect(1, 11903, '\p{issupplementalpunctuation}', "");
    Expect(0, 11903, '\p{^issupplementalpunctuation}', "");
    Expect(0, 11903, '\P{issupplementalpunctuation}', "");
    Expect(1, 11903, '\P{^issupplementalpunctuation}', "");
    Expect(0, 11904, '\p{issupplementalpunctuation}', "");
    Expect(1, 11904, '\p{^issupplementalpunctuation}', "");
    Expect(1, 11904, '\P{issupplementalpunctuation}', "");
    Expect(0, 11904, '\P{^issupplementalpunctuation}', "");
    Expect(1, 11903, '\p{  is_Supplemental_Punctuation}', "");
    Expect(0, 11903, '\p{^  is_Supplemental_Punctuation}', "");
    Expect(0, 11903, '\P{  is_Supplemental_Punctuation}', "");
    Expect(1, 11903, '\P{^  is_Supplemental_Punctuation}', "");
    Expect(0, 11904, '\p{  is_Supplemental_Punctuation}', "");
    Expect(1, 11904, '\p{^  is_Supplemental_Punctuation}', "");
    Expect(1, 11904, '\P{  is_Supplemental_Punctuation}', "");
    Expect(0, 11904, '\P{^  is_Supplemental_Punctuation}', "");
    Error('\p{-In_SUPPLEMENTAL_punctuation:=}');
    Error('\P{-In_SUPPLEMENTAL_punctuation:=}');
    Expect(1, 11903, '\p{insupplementalpunctuation}', "");
    Expect(0, 11903, '\p{^insupplementalpunctuation}', "");
    Expect(0, 11903, '\P{insupplementalpunctuation}', "");
    Expect(1, 11903, '\P{^insupplementalpunctuation}', "");
    Expect(0, 11904, '\p{insupplementalpunctuation}', "");
    Expect(1, 11904, '\p{^insupplementalpunctuation}', "");
    Expect(1, 11904, '\P{insupplementalpunctuation}', "");
    Expect(0, 11904, '\P{^insupplementalpunctuation}', "");
    Expect(1, 11903, '\p{-In_Supplemental_Punctuation}', "");
    Expect(0, 11903, '\p{^-In_Supplemental_Punctuation}', "");
    Expect(0, 11903, '\P{-In_Supplemental_Punctuation}', "");
    Expect(1, 11903, '\P{^-In_Supplemental_Punctuation}', "");
    Expect(0, 11904, '\p{-In_Supplemental_Punctuation}', "");
    Expect(1, 11904, '\p{^-In_Supplemental_Punctuation}', "");
    Expect(1, 11904, '\P{-In_Supplemental_Punctuation}', "");
    Expect(0, 11904, '\P{^-In_Supplemental_Punctuation}', "");
    Error('\p{	_Sup_Punctuation:=}');
    Error('\P{	_Sup_Punctuation:=}');
    Expect(1, 11903, '\p{suppunctuation}', "");
    Expect(0, 11903, '\p{^suppunctuation}', "");
    Expect(0, 11903, '\P{suppunctuation}', "");
    Expect(1, 11903, '\P{^suppunctuation}', "");
    Expect(0, 11904, '\p{suppunctuation}', "");
    Expect(1, 11904, '\p{^suppunctuation}', "");
    Expect(1, 11904, '\P{suppunctuation}', "");
    Expect(0, 11904, '\P{^suppunctuation}', "");
    Expect(1, 11903, '\p{Sup_punctuation}', "");
    Expect(0, 11903, '\p{^Sup_punctuation}', "");
    Expect(0, 11903, '\P{Sup_punctuation}', "");
    Expect(1, 11903, '\P{^Sup_punctuation}', "");
    Expect(0, 11904, '\p{Sup_punctuation}', "");
    Expect(1, 11904, '\p{^Sup_punctuation}', "");
    Expect(1, 11904, '\P{Sup_punctuation}', "");
    Expect(0, 11904, '\P{^Sup_punctuation}', "");
    Error('\p{/a/_is_SUP_punctuation}');
    Error('\P{/a/_is_SUP_punctuation}');
    Expect(1, 11903, '\p{issuppunctuation}', "");
    Expect(0, 11903, '\p{^issuppunctuation}', "");
    Expect(0, 11903, '\P{issuppunctuation}', "");
    Expect(1, 11903, '\P{^issuppunctuation}', "");
    Expect(0, 11904, '\p{issuppunctuation}', "");
    Expect(1, 11904, '\p{^issuppunctuation}', "");
    Expect(1, 11904, '\P{issuppunctuation}', "");
    Expect(0, 11904, '\P{^issuppunctuation}', "");
    Expect(1, 11903, '\p{	-IS_SUP_Punctuation}', "");
    Expect(0, 11903, '\p{^	-IS_SUP_Punctuation}', "");
    Expect(0, 11903, '\P{	-IS_SUP_Punctuation}', "");
    Expect(1, 11903, '\P{^	-IS_SUP_Punctuation}', "");
    Expect(0, 11904, '\p{	-IS_SUP_Punctuation}', "");
    Expect(1, 11904, '\p{^	-IS_SUP_Punctuation}', "");
    Expect(1, 11904, '\P{	-IS_SUP_Punctuation}', "");
    Expect(0, 11904, '\P{^	-IS_SUP_Punctuation}', "");
    Error('\p{__in_Sup_Punctuation:=}');
    Error('\P{__in_Sup_Punctuation:=}');
    Expect(1, 11903, '\p{insuppunctuation}', "");
    Expect(0, 11903, '\p{^insuppunctuation}', "");
    Expect(0, 11903, '\P{insuppunctuation}', "");
    Expect(1, 11903, '\P{^insuppunctuation}', "");
    Expect(0, 11904, '\p{insuppunctuation}', "");
    Expect(1, 11904, '\p{^insuppunctuation}', "");
    Expect(1, 11904, '\P{insuppunctuation}', "");
    Expect(0, 11904, '\P{^insuppunctuation}', "");
    Expect(1, 11903, '\p{	in_SUP_punctuation}', "");
    Expect(0, 11903, '\p{^	in_SUP_punctuation}', "");
    Expect(0, 11903, '\P{	in_SUP_punctuation}', "");
    Expect(1, 11903, '\P{^	in_SUP_punctuation}', "");
    Expect(0, 11904, '\p{	in_SUP_punctuation}', "");
    Expect(1, 11904, '\p{^	in_SUP_punctuation}', "");
    Expect(1, 11904, '\P{	in_SUP_punctuation}', "");
    Expect(0, 11904, '\P{^	in_SUP_punctuation}', "");
    Error('\p{ supplemental_Symbols_And_pictographs:=}');
    Error('\P{ supplemental_Symbols_And_pictographs:=}');
    Expect(1, 129535, '\p{supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{-_Supplemental_symbols_And_Pictographs}', "");
    Expect(0, 129535, '\p{^-_Supplemental_symbols_And_Pictographs}', "");
    Expect(0, 129535, '\P{-_Supplemental_symbols_And_Pictographs}', "");
    Expect(1, 129535, '\P{^-_Supplemental_symbols_And_Pictographs}', "");
    Expect(0, 129536, '\p{-_Supplemental_symbols_And_Pictographs}', "");
    Expect(1, 129536, '\p{^-_Supplemental_symbols_And_Pictographs}', "");
    Expect(1, 129536, '\P{-_Supplemental_symbols_And_Pictographs}', "");
    Expect(0, 129536, '\P{^-_Supplemental_symbols_And_Pictographs}', "");
    Error('\p{- Is_SUPPLEMENTAL_SYMBOLS_And_Pictographs:=}');
    Error('\P{- Is_SUPPLEMENTAL_SYMBOLS_And_Pictographs:=}');
    Expect(1, 129535, '\p{issupplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^issupplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{issupplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^issupplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{issupplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^issupplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{issupplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^issupplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{is_SUPPLEMENTAL_Symbols_and_PICTOGRAPHS}', "");
    Expect(0, 129535, '\p{^is_SUPPLEMENTAL_Symbols_and_PICTOGRAPHS}', "");
    Expect(0, 129535, '\P{is_SUPPLEMENTAL_Symbols_and_PICTOGRAPHS}', "");
    Expect(1, 129535, '\P{^is_SUPPLEMENTAL_Symbols_and_PICTOGRAPHS}', "");
    Expect(0, 129536, '\p{is_SUPPLEMENTAL_Symbols_and_PICTOGRAPHS}', "");
    Expect(1, 129536, '\p{^is_SUPPLEMENTAL_Symbols_and_PICTOGRAPHS}', "");
    Expect(1, 129536, '\P{is_SUPPLEMENTAL_Symbols_and_PICTOGRAPHS}', "");
    Expect(0, 129536, '\P{^is_SUPPLEMENTAL_Symbols_and_PICTOGRAPHS}', "");
    Error('\p{ in_SUPPLEMENTAL_Symbols_And_Pictographs:=}');
    Error('\P{ in_SUPPLEMENTAL_Symbols_And_Pictographs:=}');
    Expect(1, 129535, '\p{insupplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^insupplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{insupplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^insupplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{insupplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^insupplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{insupplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^insupplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{_in_Supplemental_Symbols_AND_Pictographs}', "");
    Expect(0, 129535, '\p{^_in_Supplemental_Symbols_AND_Pictographs}', "");
    Expect(0, 129535, '\P{_in_Supplemental_Symbols_AND_Pictographs}', "");
    Expect(1, 129535, '\P{^_in_Supplemental_Symbols_AND_Pictographs}', "");
    Expect(0, 129536, '\p{_in_Supplemental_Symbols_AND_Pictographs}', "");
    Expect(1, 129536, '\p{^_in_Supplemental_Symbols_AND_Pictographs}', "");
    Expect(1, 129536, '\P{_in_Supplemental_Symbols_AND_Pictographs}', "");
    Expect(0, 129536, '\P{^_in_Supplemental_Symbols_AND_Pictographs}', "");
    Error('\p{	_Sup_SYMBOLS_AND_Pictographs:=}');
    Error('\P{	_Sup_SYMBOLS_AND_Pictographs:=}');
    Expect(1, 129535, '\p{supsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^supsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{supsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^supsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{supsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^supsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{supsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^supsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{ 	Sup_Symbols_and_PICTOGRAPHS}', "");
    Expect(0, 129535, '\p{^ 	Sup_Symbols_and_PICTOGRAPHS}', "");
    Expect(0, 129535, '\P{ 	Sup_Symbols_and_PICTOGRAPHS}', "");
    Expect(1, 129535, '\P{^ 	Sup_Symbols_and_PICTOGRAPHS}', "");
    Expect(0, 129536, '\p{ 	Sup_Symbols_and_PICTOGRAPHS}', "");
    Expect(1, 129536, '\p{^ 	Sup_Symbols_and_PICTOGRAPHS}', "");
    Expect(1, 129536, '\P{ 	Sup_Symbols_and_PICTOGRAPHS}', "");
    Expect(0, 129536, '\P{^ 	Sup_Symbols_and_PICTOGRAPHS}', "");
    Error('\p{_-Is_Sup_Symbols_And_Pictographs:=}');
    Error('\P{_-Is_Sup_Symbols_And_Pictographs:=}');
    Expect(1, 129535, '\p{issupsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^issupsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{issupsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^issupsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{issupsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^issupsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{issupsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^issupsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{_Is_Sup_symbols_And_Pictographs}', "");
    Expect(0, 129535, '\p{^_Is_Sup_symbols_And_Pictographs}', "");
    Expect(0, 129535, '\P{_Is_Sup_symbols_And_Pictographs}', "");
    Expect(1, 129535, '\P{^_Is_Sup_symbols_And_Pictographs}', "");
    Expect(0, 129536, '\p{_Is_Sup_symbols_And_Pictographs}', "");
    Expect(1, 129536, '\p{^_Is_Sup_symbols_And_Pictographs}', "");
    Expect(1, 129536, '\P{_Is_Sup_symbols_And_Pictographs}', "");
    Expect(0, 129536, '\P{^_Is_Sup_symbols_And_Pictographs}', "");
    Error('\p{:=	_In_SUP_Symbols_And_pictographs}');
    Error('\P{:=	_In_SUP_Symbols_And_pictographs}');
    Expect(1, 129535, '\p{insupsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^insupsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{insupsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^insupsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{insupsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^insupsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{insupsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^insupsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{-	In_sup_symbols_And_Pictographs}', "");
    Expect(0, 129535, '\p{^-	In_sup_symbols_And_Pictographs}', "");
    Expect(0, 129535, '\P{-	In_sup_symbols_And_Pictographs}', "");
    Expect(1, 129535, '\P{^-	In_sup_symbols_And_Pictographs}', "");
    Expect(0, 129536, '\p{-	In_sup_symbols_And_Pictographs}', "");
    Expect(1, 129536, '\p{^-	In_sup_symbols_And_Pictographs}', "");
    Expect(1, 129536, '\P{-	In_sup_symbols_And_Pictographs}', "");
    Expect(0, 129536, '\P{^-	In_sup_symbols_And_Pictographs}', "");
    Error('\p{-/a/Supplementary_PRIVATE_USE_AREA_A}');
    Error('\P{-/a/Supplementary_PRIVATE_USE_AREA_A}');
    Expect(1, 983040, '\p{supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\p{^supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\P{supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\P{^supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\p{supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\p{^supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\P{supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\P{^supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\p{ supplementary_PRIVATE_USE_area_a}', "");
    Expect(0, 983040, '\p{^ supplementary_PRIVATE_USE_area_a}', "");
    Expect(0, 983040, '\P{ supplementary_PRIVATE_USE_area_a}', "");
    Expect(1, 983040, '\P{^ supplementary_PRIVATE_USE_area_a}', "");
    Expect(0, 1048576, '\p{ supplementary_PRIVATE_USE_area_a}', "");
    Expect(1, 1048576, '\p{^ supplementary_PRIVATE_USE_area_a}', "");
    Expect(1, 1048576, '\P{ supplementary_PRIVATE_USE_area_a}', "");
    Expect(0, 1048576, '\P{^ supplementary_PRIVATE_USE_area_a}', "");
    Error('\p{-:=Is_SUPPLEMENTARY_Private_Use_area_A}');
    Error('\P{-:=Is_SUPPLEMENTARY_Private_Use_area_A}');
    Expect(1, 983040, '\p{issupplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\p{^issupplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\P{issupplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\P{^issupplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\p{issupplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\p{^issupplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\P{issupplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\P{^issupplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\p{_ is_SUPPLEMENTARY_Private_use_Area_A}', "");
    Expect(0, 983040, '\p{^_ is_SUPPLEMENTARY_Private_use_Area_A}', "");
    Expect(0, 983040, '\P{_ is_SUPPLEMENTARY_Private_use_Area_A}', "");
    Expect(1, 983040, '\P{^_ is_SUPPLEMENTARY_Private_use_Area_A}', "");
    Expect(0, 1048576, '\p{_ is_SUPPLEMENTARY_Private_use_Area_A}', "");
    Expect(1, 1048576, '\p{^_ is_SUPPLEMENTARY_Private_use_Area_A}', "");
    Expect(1, 1048576, '\P{_ is_SUPPLEMENTARY_Private_use_Area_A}', "");
    Expect(0, 1048576, '\P{^_ is_SUPPLEMENTARY_Private_use_Area_A}', "");
    Error('\p{:=-In_Supplementary_Private_Use_AREA_A}');
    Error('\P{:=-In_Supplementary_Private_Use_AREA_A}');
    Expect(1, 983040, '\p{insupplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\p{^insupplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\P{insupplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\P{^insupplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\p{insupplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\p{^insupplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\P{insupplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\P{^insupplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\p{ IN_supplementary_private_use_area_A}', "");
    Expect(0, 983040, '\p{^ IN_supplementary_private_use_area_A}', "");
    Expect(0, 983040, '\P{ IN_supplementary_private_use_area_A}', "");
    Expect(1, 983040, '\P{^ IN_supplementary_private_use_area_A}', "");
    Expect(0, 1048576, '\p{ IN_supplementary_private_use_area_A}', "");
    Expect(1, 1048576, '\p{^ IN_supplementary_private_use_area_A}', "");
    Expect(1, 1048576, '\P{ IN_supplementary_private_use_area_A}', "");
    Expect(0, 1048576, '\P{^ IN_supplementary_private_use_area_A}', "");
    Error('\p{_:=SUP_PUA_a}');
    Error('\P{_:=SUP_PUA_a}');
    Expect(1, 983040, '\p{suppuaa}', "");
    Expect(0, 983040, '\p{^suppuaa}', "");
    Expect(0, 983040, '\P{suppuaa}', "");
    Expect(1, 983040, '\P{^suppuaa}', "");
    Expect(0, 1048576, '\p{suppuaa}', "");
    Expect(1, 1048576, '\p{^suppuaa}', "");
    Expect(1, 1048576, '\P{suppuaa}', "");
    Expect(0, 1048576, '\P{^suppuaa}', "");
    Expect(1, 983040, '\p{	 Sup_pua_a}', "");
    Expect(0, 983040, '\p{^	 Sup_pua_a}', "");
    Expect(0, 983040, '\P{	 Sup_pua_a}', "");
    Expect(1, 983040, '\P{^	 Sup_pua_a}', "");
    Expect(0, 1048576, '\p{	 Sup_pua_a}', "");
    Expect(1, 1048576, '\p{^	 Sup_pua_a}', "");
    Expect(1, 1048576, '\P{	 Sup_pua_a}', "");
    Expect(0, 1048576, '\P{^	 Sup_pua_a}', "");
    Error('\p{/a/		Is_Sup_PUA_a}');
    Error('\P{/a/		Is_Sup_PUA_a}');
    Expect(1, 983040, '\p{issuppuaa}', "");
    Expect(0, 983040, '\p{^issuppuaa}', "");
    Expect(0, 983040, '\P{issuppuaa}', "");
    Expect(1, 983040, '\P{^issuppuaa}', "");
    Expect(0, 1048576, '\p{issuppuaa}', "");
    Expect(1, 1048576, '\p{^issuppuaa}', "");
    Expect(1, 1048576, '\P{issuppuaa}', "");
    Expect(0, 1048576, '\P{^issuppuaa}', "");
    Expect(1, 983040, '\p{ _Is_Sup_PUA_A}', "");
    Expect(0, 983040, '\p{^ _Is_Sup_PUA_A}', "");
    Expect(0, 983040, '\P{ _Is_Sup_PUA_A}', "");
    Expect(1, 983040, '\P{^ _Is_Sup_PUA_A}', "");
    Expect(0, 1048576, '\p{ _Is_Sup_PUA_A}', "");
    Expect(1, 1048576, '\p{^ _Is_Sup_PUA_A}', "");
    Expect(1, 1048576, '\P{ _Is_Sup_PUA_A}', "");
    Expect(0, 1048576, '\P{^ _Is_Sup_PUA_A}', "");
    Error('\p{_/a/In_Sup_PUA_A}');
    Error('\P{_/a/In_Sup_PUA_A}');
    Expect(1, 983040, '\p{insuppuaa}', "");
    Expect(0, 983040, '\p{^insuppuaa}', "");
    Expect(0, 983040, '\P{insuppuaa}', "");
    Expect(1, 983040, '\P{^insuppuaa}', "");
    Expect(0, 1048576, '\p{insuppuaa}', "");
    Expect(1, 1048576, '\p{^insuppuaa}', "");
    Expect(1, 1048576, '\P{insuppuaa}', "");
    Expect(0, 1048576, '\P{^insuppuaa}', "");
    Expect(1, 983040, '\p{-	in_sup_pua_A}', "");
    Expect(0, 983040, '\p{^-	in_sup_pua_A}', "");
    Expect(0, 983040, '\P{-	in_sup_pua_A}', "");
    Expect(1, 983040, '\P{^-	in_sup_pua_A}', "");
    Expect(0, 1048576, '\p{-	in_sup_pua_A}', "");
    Expect(1, 1048576, '\p{^-	in_sup_pua_A}', "");
    Expect(1, 1048576, '\P{-	in_sup_pua_A}', "");
    Expect(0, 1048576, '\P{^-	in_sup_pua_A}', "");
    Error('\p{-SUPPLEMENTARY_private_use_Area_B/a/}');
    Error('\P{-SUPPLEMENTARY_private_use_Area_B/a/}');
    Expect(1, 1048576, '\p{supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\p{^supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\P{supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\P{^supplementaryprivateuseareab}', "");
    Expect(0, 1, '\p{supplementaryprivateuseareab}', "");
    Expect(1, 1, '\p{^supplementaryprivateuseareab}', "");
    Expect(1, 1, '\P{supplementaryprivateuseareab}', "");
    Expect(0, 1, '\P{^supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\p{		Supplementary_Private_USE_AREA_B}', "");
    Expect(0, 1048576, '\p{^		Supplementary_Private_USE_AREA_B}', "");
    Expect(0, 1048576, '\P{		Supplementary_Private_USE_AREA_B}', "");
    Expect(1, 1048576, '\P{^		Supplementary_Private_USE_AREA_B}', "");
    Expect(0, 1, '\p{		Supplementary_Private_USE_AREA_B}', "");
    Expect(1, 1, '\p{^		Supplementary_Private_USE_AREA_B}', "");
    Expect(1, 1, '\P{		Supplementary_Private_USE_AREA_B}', "");
    Expect(0, 1, '\P{^		Supplementary_Private_USE_AREA_B}', "");
    Error('\p{/a/ _Is_supplementary_Private_USE_AREA_B}');
    Error('\P{/a/ _Is_supplementary_Private_USE_AREA_B}');
    Expect(1, 1048576, '\p{issupplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\p{^issupplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\P{issupplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\P{^issupplementaryprivateuseareab}', "");
    Expect(0, 1, '\p{issupplementaryprivateuseareab}', "");
    Expect(1, 1, '\p{^issupplementaryprivateuseareab}', "");
    Expect(1, 1, '\P{issupplementaryprivateuseareab}', "");
    Expect(0, 1, '\P{^issupplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\p{-IS_SUPPLEMENTARY_Private_Use_Area_B}', "");
    Expect(0, 1048576, '\p{^-IS_SUPPLEMENTARY_Private_Use_Area_B}', "");
    Expect(0, 1048576, '\P{-IS_SUPPLEMENTARY_Private_Use_Area_B}', "");
    Expect(1, 1048576, '\P{^-IS_SUPPLEMENTARY_Private_Use_Area_B}', "");
    Expect(0, 1, '\p{-IS_SUPPLEMENTARY_Private_Use_Area_B}', "");
    Expect(1, 1, '\p{^-IS_SUPPLEMENTARY_Private_Use_Area_B}', "");
    Expect(1, 1, '\P{-IS_SUPPLEMENTARY_Private_Use_Area_B}', "");
    Expect(0, 1, '\P{^-IS_SUPPLEMENTARY_Private_Use_Area_B}', "");
    Error('\p{- IN_SUPPLEMENTARY_Private_Use_Area_B:=}');
    Error('\P{- IN_SUPPLEMENTARY_Private_Use_Area_B:=}');
    Expect(1, 1048576, '\p{insupplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\p{^insupplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\P{insupplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\P{^insupplementaryprivateuseareab}', "");
    Expect(0, 1, '\p{insupplementaryprivateuseareab}', "");
    Expect(1, 1, '\p{^insupplementaryprivateuseareab}', "");
    Expect(1, 1, '\P{insupplementaryprivateuseareab}', "");
    Expect(0, 1, '\P{^insupplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\p{-_In_Supplementary_Private_Use_area_B}', "");
    Expect(0, 1048576, '\p{^-_In_Supplementary_Private_Use_area_B}', "");
    Expect(0, 1048576, '\P{-_In_Supplementary_Private_Use_area_B}', "");
    Expect(1, 1048576, '\P{^-_In_Supplementary_Private_Use_area_B}', "");
    Expect(0, 1, '\p{-_In_Supplementary_Private_Use_area_B}', "");
    Expect(1, 1, '\p{^-_In_Supplementary_Private_Use_area_B}', "");
    Expect(1, 1, '\P{-_In_Supplementary_Private_Use_area_B}', "");
    Expect(0, 1, '\P{^-_In_Supplementary_Private_Use_area_B}', "");
    Error('\p{__SUP_PUA_B:=}');
    Error('\P{__SUP_PUA_B:=}');
    Expect(1, 1048576, '\p{suppuab}', "");
    Expect(0, 1048576, '\p{^suppuab}', "");
    Expect(0, 1048576, '\P{suppuab}', "");
    Expect(1, 1048576, '\P{^suppuab}', "");
    Expect(0, 1, '\p{suppuab}', "");
    Expect(1, 1, '\p{^suppuab}', "");
    Expect(1, 1, '\P{suppuab}', "");
    Expect(0, 1, '\P{^suppuab}', "");
    Expect(1, 1048576, '\p{ 	sup_pua_B}', "");
    Expect(0, 1048576, '\p{^ 	sup_pua_B}', "");
    Expect(0, 1048576, '\P{ 	sup_pua_B}', "");
    Expect(1, 1048576, '\P{^ 	sup_pua_B}', "");
    Expect(0, 1, '\p{ 	sup_pua_B}', "");
    Expect(1, 1, '\p{^ 	sup_pua_B}', "");
    Expect(1, 1, '\P{ 	sup_pua_B}', "");
    Expect(0, 1, '\P{^ 	sup_pua_B}', "");
    Error('\p{-IS_sup_PUA_b:=}');
    Error('\P{-IS_sup_PUA_b:=}');
    Expect(1, 1048576, '\p{issuppuab}', "");
    Expect(0, 1048576, '\p{^issuppuab}', "");
    Expect(0, 1048576, '\P{issuppuab}', "");
    Expect(1, 1048576, '\P{^issuppuab}', "");
    Expect(0, 1, '\p{issuppuab}', "");
    Expect(1, 1, '\p{^issuppuab}', "");
    Expect(1, 1, '\P{issuppuab}', "");
    Expect(0, 1, '\P{^issuppuab}', "");
    Expect(1, 1048576, '\p{		Is_Sup_pua_b}', "");
    Expect(0, 1048576, '\p{^		Is_Sup_pua_b}', "");
    Expect(0, 1048576, '\P{		Is_Sup_pua_b}', "");
    Expect(1, 1048576, '\P{^		Is_Sup_pua_b}', "");
    Expect(0, 1, '\p{		Is_Sup_pua_b}', "");
    Expect(1, 1, '\p{^		Is_Sup_pua_b}', "");
    Expect(1, 1, '\P{		Is_Sup_pua_b}', "");
    Expect(0, 1, '\P{^		Is_Sup_pua_b}', "");
    Error('\p{ :=In_sup_PUA_B}');
    Error('\P{ :=In_sup_PUA_B}');
    Expect(1, 1048576, '\p{insuppuab}', "");
    Expect(0, 1048576, '\p{^insuppuab}', "");
    Expect(0, 1048576, '\P{insuppuab}', "");
    Expect(1, 1048576, '\P{^insuppuab}', "");
    Expect(0, 1, '\p{insuppuab}', "");
    Expect(1, 1, '\p{^insuppuab}', "");
    Expect(1, 1, '\P{insuppuab}', "");
    Expect(0, 1, '\P{^insuppuab}', "");
    Expect(1, 1048576, '\p{		In_SUP_pua_b}', "");
    Expect(0, 1048576, '\p{^		In_SUP_pua_b}', "");
    Expect(0, 1048576, '\P{		In_SUP_pua_b}', "");
    Expect(1, 1048576, '\P{^		In_SUP_pua_b}', "");
    Expect(0, 1, '\p{		In_SUP_pua_b}', "");
    Expect(1, 1, '\p{^		In_SUP_pua_b}', "");
    Expect(1, 1, '\P{		In_SUP_pua_b}', "");
    Expect(0, 1, '\P{^		In_SUP_pua_b}', "");
    Error('\p{/a/	Surrogate}');
    Error('\P{/a/	Surrogate}');
    Expect(1, 57343, '\p{surrogate}', "");
    Expect(0, 57343, '\p{^surrogate}', "");
    Expect(0, 57343, '\P{surrogate}', "");
    Expect(1, 57343, '\P{^surrogate}', "");
    Expect(0, 57344, '\p{surrogate}', "");
    Expect(1, 57344, '\p{^surrogate}', "");
    Expect(1, 57344, '\P{surrogate}', "");
    Expect(0, 57344, '\P{^surrogate}', "");
    Expect(1, 57343, '\p{-Surrogate}', "");
    Expect(0, 57343, '\p{^-Surrogate}', "");
    Expect(0, 57343, '\P{-Surrogate}', "");
    Expect(1, 57343, '\P{^-Surrogate}', "");
    Expect(0, 57344, '\p{-Surrogate}', "");
    Expect(1, 57344, '\p{^-Surrogate}', "");
    Expect(1, 57344, '\P{-Surrogate}', "");
    Expect(0, 57344, '\P{^-Surrogate}', "");
    Error('\p{_/a/IS_Surrogate}');
    Error('\P{_/a/IS_Surrogate}');
    Expect(1, 57343, '\p{issurrogate}', "");
    Expect(0, 57343, '\p{^issurrogate}', "");
    Expect(0, 57343, '\P{issurrogate}', "");
    Expect(1, 57343, '\P{^issurrogate}', "");
    Expect(0, 57344, '\p{issurrogate}', "");
    Expect(1, 57344, '\p{^issurrogate}', "");
    Expect(1, 57344, '\P{issurrogate}', "");
    Expect(0, 57344, '\P{^issurrogate}', "");
    Expect(1, 57343, '\p{-_is_Surrogate}', "");
    Expect(0, 57343, '\p{^-_is_Surrogate}', "");
    Expect(0, 57343, '\P{-_is_Surrogate}', "");
    Expect(1, 57343, '\P{^-_is_Surrogate}', "");
    Expect(0, 57344, '\p{-_is_Surrogate}', "");
    Expect(1, 57344, '\p{^-_is_Surrogate}', "");
    Expect(1, 57344, '\P{-_is_Surrogate}', "");
    Expect(0, 57344, '\P{^-_is_Surrogate}', "");
    Error('\p{:=CS}');
    Error('\P{:=CS}');
    Expect(1, 57343, '\p{cs}', "");
    Expect(0, 57343, '\p{^cs}', "");
    Expect(0, 57343, '\P{cs}', "");
    Expect(1, 57343, '\P{^cs}', "");
    Expect(0, 57344, '\p{cs}', "");
    Expect(1, 57344, '\p{^cs}', "");
    Expect(1, 57344, '\P{cs}', "");
    Expect(0, 57344, '\P{^cs}', "");
    Expect(1, 57343, '\p{_-Cs}', "");
    Expect(0, 57343, '\p{^_-Cs}', "");
    Expect(0, 57343, '\P{_-Cs}', "");
    Expect(1, 57343, '\P{^_-Cs}', "");
    Expect(0, 57344, '\p{_-Cs}', "");
    Expect(1, 57344, '\p{^_-Cs}', "");
    Expect(1, 57344, '\P{_-Cs}', "");
    Expect(0, 57344, '\P{^_-Cs}', "");
    Error('\p{_Is_Cs:=}');
    Error('\P{_Is_Cs:=}');
    Expect(1, 57343, '\p{iscs}', "");
    Expect(0, 57343, '\p{^iscs}', "");
    Expect(0, 57343, '\P{iscs}', "");
    Expect(1, 57343, '\P{^iscs}', "");
    Expect(0, 57344, '\p{iscs}', "");
    Expect(1, 57344, '\p{^iscs}', "");
    Expect(1, 57344, '\P{iscs}', "");
    Expect(0, 57344, '\P{^iscs}', "");
    Expect(1, 57343, '\p{_is_cs}', "");
    Expect(0, 57343, '\p{^_is_cs}', "");
    Expect(0, 57343, '\P{_is_cs}', "");
    Expect(1, 57343, '\P{^_is_cs}', "");
    Expect(0, 57344, '\p{_is_cs}', "");
    Expect(1, 57344, '\p{^_is_cs}', "");
    Expect(1, 57344, '\P{_is_cs}', "");
    Expect(0, 57344, '\P{^_is_cs}', "");
    Error('\p{- sutton_signwriting/a/}');
    Error('\P{- sutton_signwriting/a/}');
    Expect(1, 121519, '\p{suttonsignwriting}', "");
    Expect(0, 121519, '\p{^suttonsignwriting}', "");
    Expect(0, 121519, '\P{suttonsignwriting}', "");
    Expect(1, 121519, '\P{^suttonsignwriting}', "");
    Expect(0, 121520, '\p{suttonsignwriting}', "");
    Expect(1, 121520, '\p{^suttonsignwriting}', "");
    Expect(1, 121520, '\P{suttonsignwriting}', "");
    Expect(0, 121520, '\P{^suttonsignwriting}', "");
    Expect(1, 121519, '\p{	SUTTON_SIGNWRITING}', "");
    Expect(0, 121519, '\p{^	SUTTON_SIGNWRITING}', "");
    Expect(0, 121519, '\P{	SUTTON_SIGNWRITING}', "");
    Expect(1, 121519, '\P{^	SUTTON_SIGNWRITING}', "");
    Expect(0, 121520, '\p{	SUTTON_SIGNWRITING}', "");
    Expect(1, 121520, '\p{^	SUTTON_SIGNWRITING}', "");
    Expect(1, 121520, '\P{	SUTTON_SIGNWRITING}', "");
    Expect(0, 121520, '\P{^	SUTTON_SIGNWRITING}', "");
    Error('\p{	-IS_SUTTON_SIGNWRITING/a/}');
    Error('\P{	-IS_SUTTON_SIGNWRITING/a/}');
    Expect(1, 121519, '\p{issuttonsignwriting}', "");
    Expect(0, 121519, '\p{^issuttonsignwriting}', "");
    Expect(0, 121519, '\P{issuttonsignwriting}', "");
    Expect(1, 121519, '\P{^issuttonsignwriting}', "");
    Expect(0, 121520, '\p{issuttonsignwriting}', "");
    Expect(1, 121520, '\p{^issuttonsignwriting}', "");
    Expect(1, 121520, '\P{issuttonsignwriting}', "");
    Expect(0, 121520, '\P{^issuttonsignwriting}', "");
    Expect(1, 121519, '\p{_IS_Sutton_SIGNWRITING}', "");
    Expect(0, 121519, '\p{^_IS_Sutton_SIGNWRITING}', "");
    Expect(0, 121519, '\P{_IS_Sutton_SIGNWRITING}', "");
    Expect(1, 121519, '\P{^_IS_Sutton_SIGNWRITING}', "");
    Expect(0, 121520, '\p{_IS_Sutton_SIGNWRITING}', "");
    Expect(1, 121520, '\p{^_IS_Sutton_SIGNWRITING}', "");
    Expect(1, 121520, '\P{_IS_Sutton_SIGNWRITING}', "");
    Expect(0, 121520, '\P{^_IS_Sutton_SIGNWRITING}', "");
    Error('\p{	/a/in_Sutton_signwriting}');
    Error('\P{	/a/in_Sutton_signwriting}');
    Expect(1, 121519, '\p{insuttonsignwriting}', "");
    Expect(0, 121519, '\p{^insuttonsignwriting}', "");
    Expect(0, 121519, '\P{insuttonsignwriting}', "");
    Expect(1, 121519, '\P{^insuttonsignwriting}', "");
    Expect(0, 121520, '\p{insuttonsignwriting}', "");
    Expect(1, 121520, '\p{^insuttonsignwriting}', "");
    Expect(1, 121520, '\P{insuttonsignwriting}', "");
    Expect(0, 121520, '\P{^insuttonsignwriting}', "");
    Expect(1, 121519, '\p{ -in_SUTTON_signwriting}', "");
    Expect(0, 121519, '\p{^ -in_SUTTON_signwriting}', "");
    Expect(0, 121519, '\P{ -in_SUTTON_signwriting}', "");
    Expect(1, 121519, '\P{^ -in_SUTTON_signwriting}', "");
    Expect(0, 121520, '\p{ -in_SUTTON_signwriting}', "");
    Expect(1, 121520, '\p{^ -in_SUTTON_signwriting}', "");
    Expect(1, 121520, '\P{ -in_SUTTON_signwriting}', "");
    Expect(0, 121520, '\P{^ -in_SUTTON_signwriting}', "");
    Error('\p{/a/SYLOTI_Nagri}');
    Error('\P{/a/SYLOTI_Nagri}');
    Expect(1, 43051, '\p{sylotinagri}', "");
    Expect(0, 43051, '\p{^sylotinagri}', "");
    Expect(0, 43051, '\P{sylotinagri}', "");
    Expect(1, 43051, '\P{^sylotinagri}', "");
    Expect(0, 43052, '\p{sylotinagri}', "");
    Expect(1, 43052, '\p{^sylotinagri}', "");
    Expect(1, 43052, '\P{sylotinagri}', "");
    Expect(0, 43052, '\P{^sylotinagri}', "");
    Expect(1, 43051, '\p{-syloti_Nagri}', "");
    Expect(0, 43051, '\p{^-syloti_Nagri}', "");
    Expect(0, 43051, '\P{-syloti_Nagri}', "");
    Expect(1, 43051, '\P{^-syloti_Nagri}', "");
    Expect(0, 43052, '\p{-syloti_Nagri}', "");
    Expect(1, 43052, '\p{^-syloti_Nagri}', "");
    Expect(1, 43052, '\P{-syloti_Nagri}', "");
    Expect(0, 43052, '\P{^-syloti_Nagri}', "");
    Error('\p{-is_Syloti_NAGRI/a/}');
    Error('\P{-is_Syloti_NAGRI/a/}');
    Expect(1, 43051, '\p{issylotinagri}', "");
    Expect(0, 43051, '\p{^issylotinagri}', "");
    Expect(0, 43051, '\P{issylotinagri}', "");
    Expect(1, 43051, '\P{^issylotinagri}', "");
    Expect(0, 43052, '\p{issylotinagri}', "");
    Expect(1, 43052, '\p{^issylotinagri}', "");
    Expect(1, 43052, '\P{issylotinagri}', "");
    Expect(0, 43052, '\P{^issylotinagri}', "");
    Expect(1, 43051, '\p{ _Is_Syloti_Nagri}', "");
    Expect(0, 43051, '\p{^ _Is_Syloti_Nagri}', "");
    Expect(0, 43051, '\P{ _Is_Syloti_Nagri}', "");
    Expect(1, 43051, '\P{^ _Is_Syloti_Nagri}', "");
    Expect(0, 43052, '\p{ _Is_Syloti_Nagri}', "");
    Expect(1, 43052, '\p{^ _Is_Syloti_Nagri}', "");
    Expect(1, 43052, '\P{ _Is_Syloti_Nagri}', "");
    Expect(0, 43052, '\P{^ _Is_Syloti_Nagri}', "");
    Error('\p{:=sylo}');
    Error('\P{:=sylo}');
    Expect(1, 43051, '\p{sylo}', "");
    Expect(0, 43051, '\p{^sylo}', "");
    Expect(0, 43051, '\P{sylo}', "");
    Expect(1, 43051, '\P{^sylo}', "");
    Expect(0, 43052, '\p{sylo}', "");
    Expect(1, 43052, '\p{^sylo}', "");
    Expect(1, 43052, '\P{sylo}', "");
    Expect(0, 43052, '\P{^sylo}', "");
    Expect(1, 43051, '\p{ Sylo}', "");
    Expect(0, 43051, '\p{^ Sylo}', "");
    Expect(0, 43051, '\P{ Sylo}', "");
    Expect(1, 43051, '\P{^ Sylo}', "");
    Expect(0, 43052, '\p{ Sylo}', "");
    Expect(1, 43052, '\p{^ Sylo}', "");
    Expect(1, 43052, '\P{ Sylo}', "");
    Expect(0, 43052, '\P{^ Sylo}', "");
    Error('\p{:=	 is_Sylo}');
    Error('\P{:=	 is_Sylo}');
    Expect(1, 43051, '\p{issylo}', "");
    Expect(0, 43051, '\p{^issylo}', "");
    Expect(0, 43051, '\P{issylo}', "");
    Expect(1, 43051, '\P{^issylo}', "");
    Expect(0, 43052, '\p{issylo}', "");
    Expect(1, 43052, '\p{^issylo}', "");
    Expect(1, 43052, '\P{issylo}', "");
    Expect(0, 43052, '\P{^issylo}', "");
    Expect(1, 43051, '\p{	is_Sylo}', "");
    Expect(0, 43051, '\p{^	is_Sylo}', "");
    Expect(0, 43051, '\P{	is_Sylo}', "");
    Expect(1, 43051, '\P{^	is_Sylo}', "");
    Expect(0, 43052, '\p{	is_Sylo}', "");
    Expect(1, 43052, '\p{^	is_Sylo}', "");
    Expect(1, 43052, '\P{	is_Sylo}', "");
    Expect(0, 43052, '\P{^	is_Sylo}', "");
    Error('\p{Symbol:=}');
    Error('\P{Symbol:=}');
    Expect(1, 129510, '\p{symbol}', "");
    Expect(0, 129510, '\p{^symbol}', "");
    Expect(0, 129510, '\P{symbol}', "");
    Expect(1, 129510, '\P{^symbol}', "");
    Expect(0, 129511, '\p{symbol}', "");
    Expect(1, 129511, '\p{^symbol}', "");
    Expect(1, 129511, '\P{symbol}', "");
    Expect(0, 129511, '\P{^symbol}', "");
    Expect(1, 129510, '\p{	 SYMBOL}', "");
    Expect(0, 129510, '\p{^	 SYMBOL}', "");
    Expect(0, 129510, '\P{	 SYMBOL}', "");
    Expect(1, 129510, '\P{^	 SYMBOL}', "");
    Expect(0, 129511, '\p{	 SYMBOL}', "");
    Expect(1, 129511, '\p{^	 SYMBOL}', "");
    Expect(1, 129511, '\P{	 SYMBOL}', "");
    Expect(0, 129511, '\P{^	 SYMBOL}', "");
    Error('\p{-_Is_Symbol:=}');
    Error('\P{-_Is_Symbol:=}');
    Expect(1, 129510, '\p{issymbol}', "");
    Expect(0, 129510, '\p{^issymbol}', "");
    Expect(0, 129510, '\P{issymbol}', "");
    Expect(1, 129510, '\P{^issymbol}', "");
    Expect(0, 129511, '\p{issymbol}', "");
    Expect(1, 129511, '\p{^issymbol}', "");
    Expect(1, 129511, '\P{issymbol}', "");
    Expect(0, 129511, '\P{^issymbol}', "");
    Expect(1, 129510, '\p{  is_Symbol}', "");
    Expect(0, 129510, '\p{^  is_Symbol}', "");
    Expect(0, 129510, '\P{  is_Symbol}', "");
    Expect(1, 129510, '\P{^  is_Symbol}', "");
    Expect(0, 129511, '\p{  is_Symbol}', "");
    Expect(1, 129511, '\p{^  is_Symbol}', "");
    Expect(1, 129511, '\P{  is_Symbol}', "");
    Expect(0, 129511, '\P{^  is_Symbol}', "");
    Error('\p{/a/-S}');
    Error('\P{/a/-S}');
    Expect(1, 129510, '\p{s}', "");
    Expect(0, 129510, '\p{^s}', "");
    Expect(0, 129510, '\P{s}', "");
    Expect(1, 129510, '\P{^s}', "");
    Expect(0, 129511, '\p{s}', "");
    Expect(1, 129511, '\p{^s}', "");
    Expect(1, 129511, '\P{s}', "");
    Expect(0, 129511, '\P{^s}', "");
    Expect(1, 129510, '\p{ 	S}', "");
    Expect(0, 129510, '\p{^ 	S}', "");
    Expect(0, 129510, '\P{ 	S}', "");
    Expect(1, 129510, '\P{^ 	S}', "");
    Expect(0, 129511, '\p{ 	S}', "");
    Expect(1, 129511, '\p{^ 	S}', "");
    Expect(1, 129511, '\P{ 	S}', "");
    Expect(0, 129511, '\P{^ 	S}', "");
    Error('\p{	:=Is_S}');
    Error('\P{	:=Is_S}');
    Expect(1, 129510, '\p{iss}', "");
    Expect(0, 129510, '\p{^iss}', "");
    Expect(0, 129510, '\P{iss}', "");
    Expect(1, 129510, '\P{^iss}', "");
    Expect(0, 129511, '\p{iss}', "");
    Expect(1, 129511, '\p{^iss}', "");
    Expect(1, 129511, '\P{iss}', "");
    Expect(0, 129511, '\P{^iss}', "");
    Expect(1, 129510, '\p{	Is_S}', "");
    Expect(0, 129510, '\p{^	Is_S}', "");
    Expect(0, 129510, '\P{	Is_S}', "");
    Expect(1, 129510, '\P{^	Is_S}', "");
    Expect(0, 129511, '\p{	Is_S}', "");
    Expect(1, 129511, '\p{^	Is_S}', "");
    Expect(1, 129511, '\P{	Is_S}', "");
    Expect(0, 129511, '\P{^	Is_S}', "");
    Error('\p{:=-_Syriac}');
    Error('\P{:=-_Syriac}');
    Expect(1, 2154, '\p{syriac}', "");
    Expect(0, 2154, '\p{^syriac}', "");
    Expect(0, 2154, '\P{syriac}', "");
    Expect(1, 2154, '\P{^syriac}', "");
    Expect(0, 2155, '\p{syriac}', "");
    Expect(1, 2155, '\p{^syriac}', "");
    Expect(1, 2155, '\P{syriac}', "");
    Expect(0, 2155, '\P{^syriac}', "");
    Expect(1, 2154, '\p{	_Syriac}', "");
    Expect(0, 2154, '\p{^	_Syriac}', "");
    Expect(0, 2154, '\P{	_Syriac}', "");
    Expect(1, 2154, '\P{^	_Syriac}', "");
    Expect(0, 2155, '\p{	_Syriac}', "");
    Expect(1, 2155, '\p{^	_Syriac}', "");
    Expect(1, 2155, '\P{	_Syriac}', "");
    Expect(0, 2155, '\P{^	_Syriac}', "");
    Error('\p{/a/-Is_syriac}');
    Error('\P{/a/-Is_syriac}');
    Expect(1, 2154, '\p{issyriac}', "");
    Expect(0, 2154, '\p{^issyriac}', "");
    Expect(0, 2154, '\P{issyriac}', "");
    Expect(1, 2154, '\P{^issyriac}', "");
    Expect(0, 2155, '\p{issyriac}', "");
    Expect(1, 2155, '\p{^issyriac}', "");
    Expect(1, 2155, '\P{issyriac}', "");
    Expect(0, 2155, '\P{^issyriac}', "");
    Expect(1, 2154, '\p{__Is_SYRIAC}', "");
    Expect(0, 2154, '\p{^__Is_SYRIAC}', "");
    Expect(0, 2154, '\P{__Is_SYRIAC}', "");
    Expect(1, 2154, '\P{^__Is_SYRIAC}', "");
    Expect(0, 2155, '\p{__Is_SYRIAC}', "");
    Expect(1, 2155, '\p{^__Is_SYRIAC}', "");
    Expect(1, 2155, '\P{__Is_SYRIAC}', "");
    Expect(0, 2155, '\P{^__Is_SYRIAC}', "");
    Error('\p{--Syrc/a/}');
    Error('\P{--Syrc/a/}');
    Expect(1, 2154, '\p{syrc}', "");
    Expect(0, 2154, '\p{^syrc}', "");
    Expect(0, 2154, '\P{syrc}', "");
    Expect(1, 2154, '\P{^syrc}', "");
    Expect(0, 2155, '\p{syrc}', "");
    Expect(1, 2155, '\p{^syrc}', "");
    Expect(1, 2155, '\P{syrc}', "");
    Expect(0, 2155, '\P{^syrc}', "");
    Expect(1, 2154, '\p{_ SYRC}', "");
    Expect(0, 2154, '\p{^_ SYRC}', "");
    Expect(0, 2154, '\P{_ SYRC}', "");
    Expect(1, 2154, '\P{^_ SYRC}', "");
    Expect(0, 2155, '\p{_ SYRC}', "");
    Expect(1, 2155, '\p{^_ SYRC}', "");
    Expect(1, 2155, '\P{_ SYRC}', "");
    Expect(0, 2155, '\P{^_ SYRC}', "");
    Error('\p{	/a/Is_SYRC}');
    Error('\P{	/a/Is_SYRC}');
    Expect(1, 2154, '\p{issyrc}', "");
    Expect(0, 2154, '\p{^issyrc}', "");
    Expect(0, 2154, '\P{issyrc}', "");
    Expect(1, 2154, '\P{^issyrc}', "");
    Expect(0, 2155, '\p{issyrc}', "");
    Expect(1, 2155, '\p{^issyrc}', "");
    Expect(1, 2155, '\P{issyrc}', "");
    Expect(0, 2155, '\P{^issyrc}', "");
    Expect(1, 2154, '\p{-is_SYRC}', "");
    Expect(0, 2154, '\p{^-is_SYRC}', "");
    Expect(0, 2154, '\P{-is_SYRC}', "");
    Expect(1, 2154, '\P{^-is_SYRC}', "");
    Expect(0, 2155, '\p{-is_SYRC}', "");
    Expect(1, 2155, '\p{^-is_SYRC}', "");
    Expect(1, 2155, '\P{-is_SYRC}', "");
    Expect(0, 2155, '\P{^-is_SYRC}', "");
    Error('\p{/a/syriac_SUPPLEMENT}');
    Error('\P{/a/syriac_SUPPLEMENT}');
    Expect(1, 2159, '\p{syriacsupplement}', "");
    Expect(0, 2159, '\p{^syriacsupplement}', "");
    Expect(0, 2159, '\P{syriacsupplement}', "");
    Expect(1, 2159, '\P{^syriacsupplement}', "");
    Expect(0, 2160, '\p{syriacsupplement}', "");
    Expect(1, 2160, '\p{^syriacsupplement}', "");
    Expect(1, 2160, '\P{syriacsupplement}', "");
    Expect(0, 2160, '\P{^syriacsupplement}', "");
    Expect(1, 2159, '\p{	syriac_Supplement}', "");
    Expect(0, 2159, '\p{^	syriac_Supplement}', "");
    Expect(0, 2159, '\P{	syriac_Supplement}', "");
    Expect(1, 2159, '\P{^	syriac_Supplement}', "");
    Expect(0, 2160, '\p{	syriac_Supplement}', "");
    Expect(1, 2160, '\p{^	syriac_Supplement}', "");
    Expect(1, 2160, '\P{	syriac_Supplement}', "");
    Expect(0, 2160, '\P{^	syriac_Supplement}', "");
    Error('\p{-/a/IS_Syriac_supplement}');
    Error('\P{-/a/IS_Syriac_supplement}');
    Expect(1, 2159, '\p{issyriacsupplement}', "");
    Expect(0, 2159, '\p{^issyriacsupplement}', "");
    Expect(0, 2159, '\P{issyriacsupplement}', "");
    Expect(1, 2159, '\P{^issyriacsupplement}', "");
    Expect(0, 2160, '\p{issyriacsupplement}', "");
    Expect(1, 2160, '\p{^issyriacsupplement}', "");
    Expect(1, 2160, '\P{issyriacsupplement}', "");
    Expect(0, 2160, '\P{^issyriacsupplement}', "");
    Expect(1, 2159, '\p{ is_SYRIAC_SUPPLEMENT}', "");
    Expect(0, 2159, '\p{^ is_SYRIAC_SUPPLEMENT}', "");
    Expect(0, 2159, '\P{ is_SYRIAC_SUPPLEMENT}', "");
    Expect(1, 2159, '\P{^ is_SYRIAC_SUPPLEMENT}', "");
    Expect(0, 2160, '\p{ is_SYRIAC_SUPPLEMENT}', "");
    Expect(1, 2160, '\p{^ is_SYRIAC_SUPPLEMENT}', "");
    Expect(1, 2160, '\P{ is_SYRIAC_SUPPLEMENT}', "");
    Expect(0, 2160, '\P{^ is_SYRIAC_SUPPLEMENT}', "");
    Error('\p{-/a/In_syriac_Supplement}');
    Error('\P{-/a/In_syriac_Supplement}');
    Expect(1, 2159, '\p{insyriacsupplement}', "");
    Expect(0, 2159, '\p{^insyriacsupplement}', "");
    Expect(0, 2159, '\P{insyriacsupplement}', "");
    Expect(1, 2159, '\P{^insyriacsupplement}', "");
    Expect(0, 2160, '\p{insyriacsupplement}', "");
    Expect(1, 2160, '\p{^insyriacsupplement}', "");
    Expect(1, 2160, '\P{insyriacsupplement}', "");
    Expect(0, 2160, '\P{^insyriacsupplement}', "");
    Expect(1, 2159, '\p{- In_Syriac_SUPPLEMENT}', "");
    Expect(0, 2159, '\p{^- In_Syriac_SUPPLEMENT}', "");
    Expect(0, 2159, '\P{- In_Syriac_SUPPLEMENT}', "");
    Expect(1, 2159, '\P{^- In_Syriac_SUPPLEMENT}', "");
    Expect(0, 2160, '\p{- In_Syriac_SUPPLEMENT}', "");
    Expect(1, 2160, '\p{^- In_Syriac_SUPPLEMENT}', "");
    Expect(1, 2160, '\P{- In_Syriac_SUPPLEMENT}', "");
    Expect(0, 2160, '\P{^- In_Syriac_SUPPLEMENT}', "");
    Error('\p{	-syriac_SUP/a/}');
    Error('\P{	-syriac_SUP/a/}');
    Expect(1, 2159, '\p{syriacsup}', "");
    Expect(0, 2159, '\p{^syriacsup}', "");
    Expect(0, 2159, '\P{syriacsup}', "");
    Expect(1, 2159, '\P{^syriacsup}', "");
    Expect(0, 2160, '\p{syriacsup}', "");
    Expect(1, 2160, '\p{^syriacsup}', "");
    Expect(1, 2160, '\P{syriacsup}', "");
    Expect(0, 2160, '\P{^syriacsup}', "");
    Expect(1, 2159, '\p{  syriac_Sup}', "");
    Expect(0, 2159, '\p{^  syriac_Sup}', "");
    Expect(0, 2159, '\P{  syriac_Sup}', "");
    Expect(1, 2159, '\P{^  syriac_Sup}', "");
    Expect(0, 2160, '\p{  syriac_Sup}', "");
    Expect(1, 2160, '\p{^  syriac_Sup}', "");
    Expect(1, 2160, '\P{  syriac_Sup}', "");
    Expect(0, 2160, '\P{^  syriac_Sup}', "");
    Error('\p{/a/	-Is_syriac_SUP}');
    Error('\P{/a/	-Is_syriac_SUP}');
    Expect(1, 2159, '\p{issyriacsup}', "");
    Expect(0, 2159, '\p{^issyriacsup}', "");
    Expect(0, 2159, '\P{issyriacsup}', "");
    Expect(1, 2159, '\P{^issyriacsup}', "");
    Expect(0, 2160, '\p{issyriacsup}', "");
    Expect(1, 2160, '\p{^issyriacsup}', "");
    Expect(1, 2160, '\P{issyriacsup}', "");
    Expect(0, 2160, '\P{^issyriacsup}', "");
    Expect(1, 2159, '\p{	Is_SYRIAC_Sup}', "");
    Expect(0, 2159, '\p{^	Is_SYRIAC_Sup}', "");
    Expect(0, 2159, '\P{	Is_SYRIAC_Sup}', "");
    Expect(1, 2159, '\P{^	Is_SYRIAC_Sup}', "");
    Expect(0, 2160, '\p{	Is_SYRIAC_Sup}', "");
    Expect(1, 2160, '\p{^	Is_SYRIAC_Sup}', "");
    Expect(1, 2160, '\P{	Is_SYRIAC_Sup}', "");
    Expect(0, 2160, '\P{^	Is_SYRIAC_Sup}', "");
    Error('\p{/a/-In_syriac_sup}');
    Error('\P{/a/-In_syriac_sup}');
    Expect(1, 2159, '\p{insyriacsup}', "");
    Expect(0, 2159, '\p{^insyriacsup}', "");
    Expect(0, 2159, '\P{insyriacsup}', "");
    Expect(1, 2159, '\P{^insyriacsup}', "");
    Expect(0, 2160, '\p{insyriacsup}', "");
    Expect(1, 2160, '\p{^insyriacsup}', "");
    Expect(1, 2160, '\P{insyriacsup}', "");
    Expect(0, 2160, '\P{^insyriacsup}', "");
    Expect(1, 2159, '\p{_-in_syriac_Sup}', "");
    Expect(0, 2159, '\p{^_-in_syriac_Sup}', "");
    Expect(0, 2159, '\P{_-in_syriac_Sup}', "");
    Expect(1, 2159, '\P{^_-in_syriac_Sup}', "");
    Expect(0, 2160, '\p{_-in_syriac_Sup}', "");
    Expect(1, 2160, '\p{^_-in_syriac_Sup}', "");
    Expect(1, 2160, '\P{_-in_syriac_Sup}', "");
    Expect(0, 2160, '\P{^_-in_syriac_Sup}', "");
    Error('\p{ 	Tagalog:=}');
    Error('\P{ 	Tagalog:=}');
    Expect(1, 5942, '\p{tagalog}', "");
    Expect(0, 5942, '\p{^tagalog}', "");
    Expect(0, 5942, '\P{tagalog}', "");
    Expect(1, 5942, '\P{^tagalog}', "");
    Expect(0, 5943, '\p{tagalog}', "");
    Expect(1, 5943, '\p{^tagalog}', "");
    Expect(1, 5943, '\P{tagalog}', "");
    Expect(0, 5943, '\P{^tagalog}', "");
    Expect(1, 5942, '\p{	-Tagalog}', "");
    Expect(0, 5942, '\p{^	-Tagalog}', "");
    Expect(0, 5942, '\P{	-Tagalog}', "");
    Expect(1, 5942, '\P{^	-Tagalog}', "");
    Expect(0, 5943, '\p{	-Tagalog}', "");
    Expect(1, 5943, '\p{^	-Tagalog}', "");
    Expect(1, 5943, '\P{	-Tagalog}', "");
    Expect(0, 5943, '\P{^	-Tagalog}', "");
    Error('\p{		IS_TAGALOG/a/}');
    Error('\P{		IS_TAGALOG/a/}');
    Expect(1, 5942, '\p{istagalog}', "");
    Expect(0, 5942, '\p{^istagalog}', "");
    Expect(0, 5942, '\P{istagalog}', "");
    Expect(1, 5942, '\P{^istagalog}', "");
    Expect(0, 5943, '\p{istagalog}', "");
    Expect(1, 5943, '\p{^istagalog}', "");
    Expect(1, 5943, '\P{istagalog}', "");
    Expect(0, 5943, '\P{^istagalog}', "");
    Expect(1, 5942, '\p{-_Is_Tagalog}', "");
    Expect(0, 5942, '\p{^-_Is_Tagalog}', "");
    Expect(0, 5942, '\P{-_Is_Tagalog}', "");
    Expect(1, 5942, '\P{^-_Is_Tagalog}', "");
    Expect(0, 5943, '\p{-_Is_Tagalog}', "");
    Expect(1, 5943, '\p{^-_Is_Tagalog}', "");
    Expect(1, 5943, '\P{-_Is_Tagalog}', "");
    Expect(0, 5943, '\P{^-_Is_Tagalog}', "");
    Error('\p{:=Tglg}');
    Error('\P{:=Tglg}');
    Expect(1, 5942, '\p{tglg}', "");
    Expect(0, 5942, '\p{^tglg}', "");
    Expect(0, 5942, '\P{tglg}', "");
    Expect(1, 5942, '\P{^tglg}', "");
    Expect(0, 5943, '\p{tglg}', "");
    Expect(1, 5943, '\p{^tglg}', "");
    Expect(1, 5943, '\P{tglg}', "");
    Expect(0, 5943, '\P{^tglg}', "");
    Expect(1, 5942, '\p{ -tglg}', "");
    Expect(0, 5942, '\p{^ -tglg}', "");
    Expect(0, 5942, '\P{ -tglg}', "");
    Expect(1, 5942, '\P{^ -tglg}', "");
    Expect(0, 5943, '\p{ -tglg}', "");
    Expect(1, 5943, '\p{^ -tglg}', "");
    Expect(1, 5943, '\P{ -tglg}', "");
    Expect(0, 5943, '\P{^ -tglg}', "");
    Error('\p{--IS_Tglg:=}');
    Error('\P{--IS_Tglg:=}');
    Expect(1, 5942, '\p{istglg}', "");
    Expect(0, 5942, '\p{^istglg}', "");
    Expect(0, 5942, '\P{istglg}', "");
    Expect(1, 5942, '\P{^istglg}', "");
    Expect(0, 5943, '\p{istglg}', "");
    Expect(1, 5943, '\p{^istglg}', "");
    Expect(1, 5943, '\P{istglg}', "");
    Expect(0, 5943, '\P{^istglg}', "");
    Expect(1, 5942, '\p{_Is_Tglg}', "");
    Expect(0, 5942, '\p{^_Is_Tglg}', "");
    Expect(0, 5942, '\P{_Is_Tglg}', "");
    Expect(1, 5942, '\P{^_Is_Tglg}', "");
    Expect(0, 5943, '\p{_Is_Tglg}', "");
    Expect(1, 5943, '\p{^_Is_Tglg}', "");
    Expect(1, 5943, '\P{_Is_Tglg}', "");
    Expect(0, 5943, '\P{^_Is_Tglg}', "");
    Error('\p{ :=tagbanwa}');
    Error('\P{ :=tagbanwa}');
    Expect(1, 6003, '\p{tagbanwa}', "");
    Expect(0, 6003, '\p{^tagbanwa}', "");
    Expect(0, 6003, '\P{tagbanwa}', "");
    Expect(1, 6003, '\P{^tagbanwa}', "");
    Expect(0, 6004, '\p{tagbanwa}', "");
    Expect(1, 6004, '\p{^tagbanwa}', "");
    Expect(1, 6004, '\P{tagbanwa}', "");
    Expect(0, 6004, '\P{^tagbanwa}', "");
    Expect(1, 6003, '\p{_tagbanwa}', "");
    Expect(0, 6003, '\p{^_tagbanwa}', "");
    Expect(0, 6003, '\P{_tagbanwa}', "");
    Expect(1, 6003, '\P{^_tagbanwa}', "");
    Expect(0, 6004, '\p{_tagbanwa}', "");
    Expect(1, 6004, '\p{^_tagbanwa}', "");
    Expect(1, 6004, '\P{_tagbanwa}', "");
    Expect(0, 6004, '\P{^_tagbanwa}', "");
    Error('\p{/a/	is_TAGBANWA}');
    Error('\P{/a/	is_TAGBANWA}');
    Expect(1, 6003, '\p{istagbanwa}', "");
    Expect(0, 6003, '\p{^istagbanwa}', "");
    Expect(0, 6003, '\P{istagbanwa}', "");
    Expect(1, 6003, '\P{^istagbanwa}', "");
    Expect(0, 6004, '\p{istagbanwa}', "");
    Expect(1, 6004, '\p{^istagbanwa}', "");
    Expect(1, 6004, '\P{istagbanwa}', "");
    Expect(0, 6004, '\P{^istagbanwa}', "");
    Expect(1, 6003, '\p{	 Is_TAGBANWA}', "");
    Expect(0, 6003, '\p{^	 Is_TAGBANWA}', "");
    Expect(0, 6003, '\P{	 Is_TAGBANWA}', "");
    Expect(1, 6003, '\P{^	 Is_TAGBANWA}', "");
    Expect(0, 6004, '\p{	 Is_TAGBANWA}', "");
    Expect(1, 6004, '\p{^	 Is_TAGBANWA}', "");
    Expect(1, 6004, '\P{	 Is_TAGBANWA}', "");
    Expect(0, 6004, '\P{^	 Is_TAGBANWA}', "");
    Error('\p{_:=Tagb}');
    Error('\P{_:=Tagb}');
    Expect(1, 6003, '\p{tagb}', "");
    Expect(0, 6003, '\p{^tagb}', "");
    Expect(0, 6003, '\P{tagb}', "");
    Expect(1, 6003, '\P{^tagb}', "");
    Expect(0, 6004, '\p{tagb}', "");
    Expect(1, 6004, '\p{^tagb}', "");
    Expect(1, 6004, '\P{tagb}', "");
    Expect(0, 6004, '\P{^tagb}', "");
    Expect(1, 6003, '\p{_tagb}', "");
    Expect(0, 6003, '\p{^_tagb}', "");
    Expect(0, 6003, '\P{_tagb}', "");
    Expect(1, 6003, '\P{^_tagb}', "");
    Expect(0, 6004, '\p{_tagb}', "");
    Expect(1, 6004, '\p{^_tagb}', "");
    Expect(1, 6004, '\P{_tagb}', "");
    Expect(0, 6004, '\P{^_tagb}', "");
    Error('\p{:=	 is_TAGB}');
    Error('\P{:=	 is_TAGB}');
    Expect(1, 6003, '\p{istagb}', "");
    Expect(0, 6003, '\p{^istagb}', "");
    Expect(0, 6003, '\P{istagb}', "");
    Expect(1, 6003, '\P{^istagb}', "");
    Expect(0, 6004, '\p{istagb}', "");
    Expect(1, 6004, '\p{^istagb}', "");
    Expect(1, 6004, '\P{istagb}', "");
    Expect(0, 6004, '\P{^istagb}', "");
    Expect(1, 6003, '\p{-is_tagb}', "");
    Expect(0, 6003, '\p{^-is_tagb}', "");
    Expect(0, 6003, '\P{-is_tagb}', "");
    Expect(1, 6003, '\P{^-is_tagb}', "");
    Expect(0, 6004, '\p{-is_tagb}', "");
    Expect(1, 6004, '\p{^-is_tagb}', "");
    Expect(1, 6004, '\P{-is_tagb}', "");
    Expect(0, 6004, '\P{^-is_tagb}', "");
    Error('\p{/a/		Tags}');
    Error('\P{/a/		Tags}');
    Expect(1, 917631, '\p{tags}', "");
    Expect(0, 917631, '\p{^tags}', "");
    Expect(0, 917631, '\P{tags}', "");
    Expect(1, 917631, '\P{^tags}', "");
    Expect(0, 917632, '\p{tags}', "");
    Expect(1, 917632, '\p{^tags}', "");
    Expect(1, 917632, '\P{tags}', "");
    Expect(0, 917632, '\P{^tags}', "");
    Expect(1, 917631, '\p{_Tags}', "");
    Expect(0, 917631, '\p{^_Tags}', "");
    Expect(0, 917631, '\P{_Tags}', "");
    Expect(1, 917631, '\P{^_Tags}', "");
    Expect(0, 917632, '\p{_Tags}', "");
    Expect(1, 917632, '\p{^_Tags}', "");
    Expect(1, 917632, '\P{_Tags}', "");
    Expect(0, 917632, '\P{^_Tags}', "");
    Error('\p{/a/	-Is_TAGS}');
    Error('\P{/a/	-Is_TAGS}');
    Expect(1, 917631, '\p{istags}', "");
    Expect(0, 917631, '\p{^istags}', "");
    Expect(0, 917631, '\P{istags}', "");
    Expect(1, 917631, '\P{^istags}', "");
    Expect(0, 917632, '\p{istags}', "");
    Expect(1, 917632, '\p{^istags}', "");
    Expect(1, 917632, '\P{istags}', "");
    Expect(0, 917632, '\P{^istags}', "");
    Expect(1, 917631, '\p{_	Is_Tags}', "");
    Expect(0, 917631, '\p{^_	Is_Tags}', "");
    Expect(0, 917631, '\P{_	Is_Tags}', "");
    Expect(1, 917631, '\P{^_	Is_Tags}', "");
    Expect(0, 917632, '\p{_	Is_Tags}', "");
    Expect(1, 917632, '\p{^_	Is_Tags}', "");
    Expect(1, 917632, '\P{_	Is_Tags}', "");
    Expect(0, 917632, '\P{^_	Is_Tags}', "");
    Error('\p{:=in_Tags}');
    Error('\P{:=in_Tags}');
    Expect(1, 917631, '\p{intags}', "");
    Expect(0, 917631, '\p{^intags}', "");
    Expect(0, 917631, '\P{intags}', "");
    Expect(1, 917631, '\P{^intags}', "");
    Expect(0, 917632, '\p{intags}', "");
    Expect(1, 917632, '\p{^intags}', "");
    Expect(1, 917632, '\P{intags}', "");
    Expect(0, 917632, '\P{^intags}', "");
    Expect(1, 917631, '\p{_in_tags}', "");
    Expect(0, 917631, '\p{^_in_tags}', "");
    Expect(0, 917631, '\P{_in_tags}', "");
    Expect(1, 917631, '\P{^_in_tags}', "");
    Expect(0, 917632, '\p{_in_tags}', "");
    Expect(1, 917632, '\p{^_in_tags}', "");
    Expect(1, 917632, '\P{_in_tags}', "");
    Expect(0, 917632, '\P{^_in_tags}', "");
    Error('\p{/a/ Tai_le}');
    Error('\P{/a/ Tai_le}');
    Expect(1, 6516, '\p{taile}', "");
    Expect(0, 6516, '\p{^taile}', "");
    Expect(0, 6516, '\P{taile}', "");
    Expect(1, 6516, '\P{^taile}', "");
    Expect(0, 6517, '\p{taile}', "");
    Expect(1, 6517, '\p{^taile}', "");
    Expect(1, 6517, '\P{taile}', "");
    Expect(0, 6517, '\P{^taile}', "");
    Expect(1, 6516, '\p{-_Tai_LE}', "");
    Expect(0, 6516, '\p{^-_Tai_LE}', "");
    Expect(0, 6516, '\P{-_Tai_LE}', "");
    Expect(1, 6516, '\P{^-_Tai_LE}', "");
    Expect(0, 6517, '\p{-_Tai_LE}', "");
    Expect(1, 6517, '\p{^-_Tai_LE}', "");
    Expect(1, 6517, '\P{-_Tai_LE}', "");
    Expect(0, 6517, '\P{^-_Tai_LE}', "");
    Error('\p{_:=Is_Tai_LE}');
    Error('\P{_:=Is_Tai_LE}');
    Expect(1, 6516, '\p{istaile}', "");
    Expect(0, 6516, '\p{^istaile}', "");
    Expect(0, 6516, '\P{istaile}', "");
    Expect(1, 6516, '\P{^istaile}', "");
    Expect(0, 6517, '\p{istaile}', "");
    Expect(1, 6517, '\p{^istaile}', "");
    Expect(1, 6517, '\P{istaile}', "");
    Expect(0, 6517, '\P{^istaile}', "");
    Expect(1, 6516, '\p{-	is_Tai_le}', "");
    Expect(0, 6516, '\p{^-	is_Tai_le}', "");
    Expect(0, 6516, '\P{-	is_Tai_le}', "");
    Expect(1, 6516, '\P{^-	is_Tai_le}', "");
    Expect(0, 6517, '\p{-	is_Tai_le}', "");
    Expect(1, 6517, '\p{^-	is_Tai_le}', "");
    Expect(1, 6517, '\P{-	is_Tai_le}', "");
    Expect(0, 6517, '\P{^-	is_Tai_le}', "");
    Error('\p{:= TALE}');
    Error('\P{:= TALE}');
    Expect(1, 6516, '\p{tale}', "");
    Expect(0, 6516, '\p{^tale}', "");
    Expect(0, 6516, '\P{tale}', "");
    Expect(1, 6516, '\P{^tale}', "");
    Expect(0, 6517, '\p{tale}', "");
    Expect(1, 6517, '\p{^tale}', "");
    Expect(1, 6517, '\P{tale}', "");
    Expect(0, 6517, '\P{^tale}', "");
    Expect(1, 6516, '\p{-_tale}', "");
    Expect(0, 6516, '\p{^-_tale}', "");
    Expect(0, 6516, '\P{-_tale}', "");
    Expect(1, 6516, '\P{^-_tale}', "");
    Expect(0, 6517, '\p{-_tale}', "");
    Expect(1, 6517, '\p{^-_tale}', "");
    Expect(1, 6517, '\P{-_tale}', "");
    Expect(0, 6517, '\P{^-_tale}', "");
    Error('\p{	:=Is_tale}');
    Error('\P{	:=Is_tale}');
    Expect(1, 6516, '\p{istale}', "");
    Expect(0, 6516, '\p{^istale}', "");
    Expect(0, 6516, '\P{istale}', "");
    Expect(1, 6516, '\P{^istale}', "");
    Expect(0, 6517, '\p{istale}', "");
    Expect(1, 6517, '\p{^istale}', "");
    Expect(1, 6517, '\P{istale}', "");
    Expect(0, 6517, '\P{^istale}', "");
    Expect(1, 6516, '\p{-Is_tale}', "");
    Expect(0, 6516, '\p{^-Is_tale}', "");
    Expect(0, 6516, '\P{-Is_tale}', "");
    Expect(1, 6516, '\P{^-Is_tale}', "");
    Expect(0, 6517, '\p{-Is_tale}', "");
    Expect(1, 6517, '\p{^-Is_tale}', "");
    Expect(1, 6517, '\P{-Is_tale}', "");
    Expect(0, 6517, '\P{^-Is_tale}', "");
    Error('\p{	-tai_THAM/a/}');
    Error('\P{	-tai_THAM/a/}');
    Expect(1, 6829, '\p{taitham}', "");
    Expect(0, 6829, '\p{^taitham}', "");
    Expect(0, 6829, '\P{taitham}', "");
    Expect(1, 6829, '\P{^taitham}', "");
    Expect(0, 6830, '\p{taitham}', "");
    Expect(1, 6830, '\p{^taitham}', "");
    Expect(1, 6830, '\P{taitham}', "");
    Expect(0, 6830, '\P{^taitham}', "");
    Expect(1, 6829, '\p{ Tai_THAM}', "");
    Expect(0, 6829, '\p{^ Tai_THAM}', "");
    Expect(0, 6829, '\P{ Tai_THAM}', "");
    Expect(1, 6829, '\P{^ Tai_THAM}', "");
    Expect(0, 6830, '\p{ Tai_THAM}', "");
    Expect(1, 6830, '\p{^ Tai_THAM}', "");
    Expect(1, 6830, '\P{ Tai_THAM}', "");
    Expect(0, 6830, '\P{^ Tai_THAM}', "");
    Error('\p{ /a/IS_Tai_tham}');
    Error('\P{ /a/IS_Tai_tham}');
    Expect(1, 6829, '\p{istaitham}', "");
    Expect(0, 6829, '\p{^istaitham}', "");
    Expect(0, 6829, '\P{istaitham}', "");
    Expect(1, 6829, '\P{^istaitham}', "");
    Expect(0, 6830, '\p{istaitham}', "");
    Expect(1, 6830, '\p{^istaitham}', "");
    Expect(1, 6830, '\P{istaitham}', "");
    Expect(0, 6830, '\P{^istaitham}', "");
    Expect(1, 6829, '\p{ _Is_TAI_tham}', "");
    Expect(0, 6829, '\p{^ _Is_TAI_tham}', "");
    Expect(0, 6829, '\P{ _Is_TAI_tham}', "");
    Expect(1, 6829, '\P{^ _Is_TAI_tham}', "");
    Expect(0, 6830, '\p{ _Is_TAI_tham}', "");
    Expect(1, 6830, '\p{^ _Is_TAI_tham}', "");
    Expect(1, 6830, '\P{ _Is_TAI_tham}', "");
    Expect(0, 6830, '\P{^ _Is_TAI_tham}', "");
    Error('\p{-	LANA:=}');
    Error('\P{-	LANA:=}');
    Expect(1, 6829, '\p{lana}', "");
    Expect(0, 6829, '\p{^lana}', "");
    Expect(0, 6829, '\P{lana}', "");
    Expect(1, 6829, '\P{^lana}', "");
    Expect(0, 6830, '\p{lana}', "");
    Expect(1, 6830, '\p{^lana}', "");
    Expect(1, 6830, '\P{lana}', "");
    Expect(0, 6830, '\P{^lana}', "");
    Expect(1, 6829, '\p{_ Lana}', "");
    Expect(0, 6829, '\p{^_ Lana}', "");
    Expect(0, 6829, '\P{_ Lana}', "");
    Expect(1, 6829, '\P{^_ Lana}', "");
    Expect(0, 6830, '\p{_ Lana}', "");
    Expect(1, 6830, '\p{^_ Lana}', "");
    Expect(1, 6830, '\P{_ Lana}', "");
    Expect(0, 6830, '\P{^_ Lana}', "");
    Error('\p{	-IS_Lana:=}');
    Error('\P{	-IS_Lana:=}');
    Expect(1, 6829, '\p{islana}', "");
    Expect(0, 6829, '\p{^islana}', "");
    Expect(0, 6829, '\P{islana}', "");
    Expect(1, 6829, '\P{^islana}', "");
    Expect(0, 6830, '\p{islana}', "");
    Expect(1, 6830, '\p{^islana}', "");
    Expect(1, 6830, '\P{islana}', "");
    Expect(0, 6830, '\P{^islana}', "");
    Expect(1, 6829, '\p{-is_Lana}', "");
    Expect(0, 6829, '\p{^-is_Lana}', "");
    Expect(0, 6829, '\P{-is_Lana}', "");
    Expect(1, 6829, '\P{^-is_Lana}', "");
    Expect(0, 6830, '\p{-is_Lana}', "");
    Expect(1, 6830, '\p{^-is_Lana}', "");
    Expect(1, 6830, '\P{-is_Lana}', "");
    Expect(0, 6830, '\P{^-is_Lana}', "");
    Error('\p{-:=Tai_viet}');
    Error('\P{-:=Tai_viet}');
    Expect(1, 43743, '\p{taiviet}', "");
    Expect(0, 43743, '\p{^taiviet}', "");
    Expect(0, 43743, '\P{taiviet}', "");
    Expect(1, 43743, '\P{^taiviet}', "");
    Expect(0, 43744, '\p{taiviet}', "");
    Expect(1, 43744, '\p{^taiviet}', "");
    Expect(1, 43744, '\P{taiviet}', "");
    Expect(0, 43744, '\P{^taiviet}', "");
    Expect(1, 43743, '\p{	Tai_VIET}', "");
    Expect(0, 43743, '\p{^	Tai_VIET}', "");
    Expect(0, 43743, '\P{	Tai_VIET}', "");
    Expect(1, 43743, '\P{^	Tai_VIET}', "");
    Expect(0, 43744, '\p{	Tai_VIET}', "");
    Expect(1, 43744, '\p{^	Tai_VIET}', "");
    Expect(1, 43744, '\P{	Tai_VIET}', "");
    Expect(0, 43744, '\P{^	Tai_VIET}', "");
    Error('\p{_ is_TAI_Viet:=}');
    Error('\P{_ is_TAI_Viet:=}');
    Expect(1, 43743, '\p{istaiviet}', "");
    Expect(0, 43743, '\p{^istaiviet}', "");
    Expect(0, 43743, '\P{istaiviet}', "");
    Expect(1, 43743, '\P{^istaiviet}', "");
    Expect(0, 43744, '\p{istaiviet}', "");
    Expect(1, 43744, '\p{^istaiviet}', "");
    Expect(1, 43744, '\P{istaiviet}', "");
    Expect(0, 43744, '\P{^istaiviet}', "");
    Expect(1, 43743, '\p{ 	is_TAI_Viet}', "");
    Expect(0, 43743, '\p{^ 	is_TAI_Viet}', "");
    Expect(0, 43743, '\P{ 	is_TAI_Viet}', "");
    Expect(1, 43743, '\P{^ 	is_TAI_Viet}', "");
    Expect(0, 43744, '\p{ 	is_TAI_Viet}', "");
    Expect(1, 43744, '\p{^ 	is_TAI_Viet}', "");
    Expect(1, 43744, '\P{ 	is_TAI_Viet}', "");
    Expect(0, 43744, '\P{^ 	is_TAI_Viet}', "");
    Error('\p{-/a/Tavt}');
    Error('\P{-/a/Tavt}');
    Expect(1, 43743, '\p{tavt}', "");
    Expect(0, 43743, '\p{^tavt}', "");
    Expect(0, 43743, '\P{tavt}', "");
    Expect(1, 43743, '\P{^tavt}', "");
    Expect(0, 43744, '\p{tavt}', "");
    Expect(1, 43744, '\p{^tavt}', "");
    Expect(1, 43744, '\P{tavt}', "");
    Expect(0, 43744, '\P{^tavt}', "");
    Expect(1, 43743, '\p{	Tavt}', "");
    Expect(0, 43743, '\p{^	Tavt}', "");
    Expect(0, 43743, '\P{	Tavt}', "");
    Expect(1, 43743, '\P{^	Tavt}', "");
    Expect(0, 43744, '\p{	Tavt}', "");
    Expect(1, 43744, '\p{^	Tavt}', "");
    Expect(1, 43744, '\P{	Tavt}', "");
    Expect(0, 43744, '\P{^	Tavt}', "");
    Error('\p{:=__is_Tavt}');
    Error('\P{:=__is_Tavt}');
    Expect(1, 43743, '\p{istavt}', "");
    Expect(0, 43743, '\p{^istavt}', "");
    Expect(0, 43743, '\P{istavt}', "");
    Expect(1, 43743, '\P{^istavt}', "");
    Expect(0, 43744, '\p{istavt}', "");
    Expect(1, 43744, '\p{^istavt}', "");
    Expect(1, 43744, '\P{istavt}', "");
    Expect(0, 43744, '\P{^istavt}', "");
    Expect(1, 43743, '\p{ is_TAVT}', "");
    Expect(0, 43743, '\p{^ is_TAVT}', "");
    Expect(0, 43743, '\P{ is_TAVT}', "");
    Expect(1, 43743, '\P{^ is_TAVT}', "");
    Expect(0, 43744, '\p{ is_TAVT}', "");
    Expect(1, 43744, '\p{^ is_TAVT}', "");
    Expect(1, 43744, '\P{ is_TAVT}', "");
    Expect(0, 43744, '\P{^ is_TAVT}', "");
    Error('\p{- Tai_Xuan_Jing_Symbols/a/}');
    Error('\P{- Tai_Xuan_Jing_Symbols/a/}');
    Expect(1, 119647, '\p{taixuanjingsymbols}', "");
    Expect(0, 119647, '\p{^taixuanjingsymbols}', "");
    Expect(0, 119647, '\P{taixuanjingsymbols}', "");
    Expect(1, 119647, '\P{^taixuanjingsymbols}', "");
    Expect(0, 119648, '\p{taixuanjingsymbols}', "");
    Expect(1, 119648, '\p{^taixuanjingsymbols}', "");
    Expect(1, 119648, '\P{taixuanjingsymbols}', "");
    Expect(0, 119648, '\P{^taixuanjingsymbols}', "");
    Expect(1, 119647, '\p{	TAI_XUAN_Jing_Symbols}', "");
    Expect(0, 119647, '\p{^	TAI_XUAN_Jing_Symbols}', "");
    Expect(0, 119647, '\P{	TAI_XUAN_Jing_Symbols}', "");
    Expect(1, 119647, '\P{^	TAI_XUAN_Jing_Symbols}', "");
    Expect(0, 119648, '\p{	TAI_XUAN_Jing_Symbols}', "");
    Expect(1, 119648, '\p{^	TAI_XUAN_Jing_Symbols}', "");
    Expect(1, 119648, '\P{	TAI_XUAN_Jing_Symbols}', "");
    Expect(0, 119648, '\P{^	TAI_XUAN_Jing_Symbols}', "");
    Error('\p{-	Is_tai_Xuan_JING_SYMBOLS:=}');
    Error('\P{-	Is_tai_Xuan_JING_SYMBOLS:=}');
    Expect(1, 119647, '\p{istaixuanjingsymbols}', "");
    Expect(0, 119647, '\p{^istaixuanjingsymbols}', "");
    Expect(0, 119647, '\P{istaixuanjingsymbols}', "");
    Expect(1, 119647, '\P{^istaixuanjingsymbols}', "");
    Expect(0, 119648, '\p{istaixuanjingsymbols}', "");
    Expect(1, 119648, '\p{^istaixuanjingsymbols}', "");
    Expect(1, 119648, '\P{istaixuanjingsymbols}', "");
    Expect(0, 119648, '\P{^istaixuanjingsymbols}', "");
    Expect(1, 119647, '\p{_Is_Tai_Xuan_Jing_Symbols}', "");
    Expect(0, 119647, '\p{^_Is_Tai_Xuan_Jing_Symbols}', "");
    Expect(0, 119647, '\P{_Is_Tai_Xuan_Jing_Symbols}', "");
    Expect(1, 119647, '\P{^_Is_Tai_Xuan_Jing_Symbols}', "");
    Expect(0, 119648, '\p{_Is_Tai_Xuan_Jing_Symbols}', "");
    Expect(1, 119648, '\p{^_Is_Tai_Xuan_Jing_Symbols}', "");
    Expect(1, 119648, '\P{_Is_Tai_Xuan_Jing_Symbols}', "");
    Expect(0, 119648, '\P{^_Is_Tai_Xuan_Jing_Symbols}', "");
    Error('\p{/a/- In_Tai_Xuan_Jing_Symbols}');
    Error('\P{/a/- In_Tai_Xuan_Jing_Symbols}');
    Expect(1, 119647, '\p{intaixuanjingsymbols}', "");
    Expect(0, 119647, '\p{^intaixuanjingsymbols}', "");
    Expect(0, 119647, '\P{intaixuanjingsymbols}', "");
    Expect(1, 119647, '\P{^intaixuanjingsymbols}', "");
    Expect(0, 119648, '\p{intaixuanjingsymbols}', "");
    Expect(1, 119648, '\p{^intaixuanjingsymbols}', "");
    Expect(1, 119648, '\P{intaixuanjingsymbols}', "");
    Expect(0, 119648, '\P{^intaixuanjingsymbols}', "");
    Expect(1, 119647, '\p{ IN_tai_XUAN_JING_SYMBOLS}', "");
    Expect(0, 119647, '\p{^ IN_tai_XUAN_JING_SYMBOLS}', "");
    Expect(0, 119647, '\P{ IN_tai_XUAN_JING_SYMBOLS}', "");
    Expect(1, 119647, '\P{^ IN_tai_XUAN_JING_SYMBOLS}', "");
    Expect(0, 119648, '\p{ IN_tai_XUAN_JING_SYMBOLS}', "");
    Expect(1, 119648, '\p{^ IN_tai_XUAN_JING_SYMBOLS}', "");
    Expect(1, 119648, '\P{ IN_tai_XUAN_JING_SYMBOLS}', "");
    Expect(0, 119648, '\P{^ IN_tai_XUAN_JING_SYMBOLS}', "");
    Error('\p{:=--TAI_Xuan_jing}');
    Error('\P{:=--TAI_Xuan_jing}');
    Expect(1, 119647, '\p{taixuanjing}', "");
    Expect(0, 119647, '\p{^taixuanjing}', "");
    Expect(0, 119647, '\P{taixuanjing}', "");
    Expect(1, 119647, '\P{^taixuanjing}', "");
    Expect(0, 119648, '\p{taixuanjing}', "");
    Expect(1, 119648, '\p{^taixuanjing}', "");
    Expect(1, 119648, '\P{taixuanjing}', "");
    Expect(0, 119648, '\P{^taixuanjing}', "");
    Expect(1, 119647, '\p{_ tai_Xuan_jing}', "");
    Expect(0, 119647, '\p{^_ tai_Xuan_jing}', "");
    Expect(0, 119647, '\P{_ tai_Xuan_jing}', "");
    Expect(1, 119647, '\P{^_ tai_Xuan_jing}', "");
    Expect(0, 119648, '\p{_ tai_Xuan_jing}', "");
    Expect(1, 119648, '\p{^_ tai_Xuan_jing}', "");
    Expect(1, 119648, '\P{_ tai_Xuan_jing}', "");
    Expect(0, 119648, '\P{^_ tai_Xuan_jing}', "");
    Error('\p{:=	IS_TAI_xuan_Jing}');
    Error('\P{:=	IS_TAI_xuan_Jing}');
    Expect(1, 119647, '\p{istaixuanjing}', "");
    Expect(0, 119647, '\p{^istaixuanjing}', "");
    Expect(0, 119647, '\P{istaixuanjing}', "");
    Expect(1, 119647, '\P{^istaixuanjing}', "");
    Expect(0, 119648, '\p{istaixuanjing}', "");
    Expect(1, 119648, '\p{^istaixuanjing}', "");
    Expect(1, 119648, '\P{istaixuanjing}', "");
    Expect(0, 119648, '\P{^istaixuanjing}', "");
    Expect(1, 119647, '\p{-	is_Tai_xuan_Jing}', "");
    Expect(0, 119647, '\p{^-	is_Tai_xuan_Jing}', "");
    Expect(0, 119647, '\P{-	is_Tai_xuan_Jing}', "");
    Expect(1, 119647, '\P{^-	is_Tai_xuan_Jing}', "");
    Expect(0, 119648, '\p{-	is_Tai_xuan_Jing}', "");
    Expect(1, 119648, '\p{^-	is_Tai_xuan_Jing}', "");
    Expect(1, 119648, '\P{-	is_Tai_xuan_Jing}', "");
    Expect(0, 119648, '\P{^-	is_Tai_xuan_Jing}', "");
    Error('\p{/a/_ In_TAI_Xuan_JING}');
    Error('\P{/a/_ In_TAI_Xuan_JING}');
    Expect(1, 119647, '\p{intaixuanjing}', "");
    Expect(0, 119647, '\p{^intaixuanjing}', "");
    Expect(0, 119647, '\P{intaixuanjing}', "");
    Expect(1, 119647, '\P{^intaixuanjing}', "");
    Expect(0, 119648, '\p{intaixuanjing}', "");
    Expect(1, 119648, '\p{^intaixuanjing}', "");
    Expect(1, 119648, '\P{intaixuanjing}', "");
    Expect(0, 119648, '\P{^intaixuanjing}', "");
    Expect(1, 119647, '\p{ in_tai_xuan_Jing}', "");
    Expect(0, 119647, '\p{^ in_tai_xuan_Jing}', "");
    Expect(0, 119647, '\P{ in_tai_xuan_Jing}', "");
    Expect(1, 119647, '\P{^ in_tai_xuan_Jing}', "");
    Expect(0, 119648, '\p{ in_tai_xuan_Jing}', "");
    Expect(1, 119648, '\p{^ in_tai_xuan_Jing}', "");
    Expect(1, 119648, '\P{ in_tai_xuan_Jing}', "");
    Expect(0, 119648, '\P{^ in_tai_xuan_Jing}', "");
    Error('\p{	/a/Takri}');
    Error('\P{	/a/Takri}');
    Expect(1, 71369, '\p{takri}', "");
    Expect(0, 71369, '\p{^takri}', "");
    Expect(0, 71369, '\P{takri}', "");
    Expect(1, 71369, '\P{^takri}', "");
    Expect(0, 71370, '\p{takri}', "");
    Expect(1, 71370, '\p{^takri}', "");
    Expect(1, 71370, '\P{takri}', "");
    Expect(0, 71370, '\P{^takri}', "");
    Expect(1, 71369, '\p{ -Takri}', "");
    Expect(0, 71369, '\p{^ -Takri}', "");
    Expect(0, 71369, '\P{ -Takri}', "");
    Expect(1, 71369, '\P{^ -Takri}', "");
    Expect(0, 71370, '\p{ -Takri}', "");
    Expect(1, 71370, '\p{^ -Takri}', "");
    Expect(1, 71370, '\P{ -Takri}', "");
    Expect(0, 71370, '\P{^ -Takri}', "");
    Error('\p{:=_-IS_takri}');
    Error('\P{:=_-IS_takri}');
    Expect(1, 71369, '\p{istakri}', "");
    Expect(0, 71369, '\p{^istakri}', "");
    Expect(0, 71369, '\P{istakri}', "");
    Expect(1, 71369, '\P{^istakri}', "");
    Expect(0, 71370, '\p{istakri}', "");
    Expect(1, 71370, '\p{^istakri}', "");
    Expect(1, 71370, '\P{istakri}', "");
    Expect(0, 71370, '\P{^istakri}', "");
    Expect(1, 71369, '\p{		is_takri}', "");
    Expect(0, 71369, '\p{^		is_takri}', "");
    Expect(0, 71369, '\P{		is_takri}', "");
    Expect(1, 71369, '\P{^		is_takri}', "");
    Expect(0, 71370, '\p{		is_takri}', "");
    Expect(1, 71370, '\p{^		is_takri}', "");
    Expect(1, 71370, '\P{		is_takri}', "");
    Expect(0, 71370, '\P{^		is_takri}', "");
    Error('\p{/a/ -Takr}');
    Error('\P{/a/ -Takr}');
    Expect(1, 71369, '\p{takr}', "");
    Expect(0, 71369, '\p{^takr}', "");
    Expect(0, 71369, '\P{takr}', "");
    Expect(1, 71369, '\P{^takr}', "");
    Expect(0, 71370, '\p{takr}', "");
    Expect(1, 71370, '\p{^takr}', "");
    Expect(1, 71370, '\P{takr}', "");
    Expect(0, 71370, '\P{^takr}', "");
    Expect(1, 71369, '\p{	Takr}', "");
    Expect(0, 71369, '\p{^	Takr}', "");
    Expect(0, 71369, '\P{	Takr}', "");
    Expect(1, 71369, '\P{^	Takr}', "");
    Expect(0, 71370, '\p{	Takr}', "");
    Expect(1, 71370, '\p{^	Takr}', "");
    Expect(1, 71370, '\P{	Takr}', "");
    Expect(0, 71370, '\P{^	Takr}', "");
    Error('\p{	/a/Is_Takr}');
    Error('\P{	/a/Is_Takr}');
    Expect(1, 71369, '\p{istakr}', "");
    Expect(0, 71369, '\p{^istakr}', "");
    Expect(0, 71369, '\P{istakr}', "");
    Expect(1, 71369, '\P{^istakr}', "");
    Expect(0, 71370, '\p{istakr}', "");
    Expect(1, 71370, '\p{^istakr}', "");
    Expect(1, 71370, '\P{istakr}', "");
    Expect(0, 71370, '\P{^istakr}', "");
    Expect(1, 71369, '\p{_ IS_Takr}', "");
    Expect(0, 71369, '\p{^_ IS_Takr}', "");
    Expect(0, 71369, '\P{_ IS_Takr}', "");
    Expect(1, 71369, '\P{^_ IS_Takr}', "");
    Expect(0, 71370, '\p{_ IS_Takr}', "");
    Expect(1, 71370, '\p{^_ IS_Takr}', "");
    Expect(1, 71370, '\P{_ IS_Takr}', "");
    Expect(0, 71370, '\P{^_ IS_Takr}', "");
    Error('\p{:=tamil}');
    Error('\P{:=tamil}');
    Expect(1, 70460, '\p{tamil}', "");
    Expect(0, 70460, '\p{^tamil}', "");
    Expect(0, 70460, '\P{tamil}', "");
    Expect(1, 70460, '\P{^tamil}', "");
    Expect(0, 70461, '\p{tamil}', "");
    Expect(1, 70461, '\p{^tamil}', "");
    Expect(1, 70461, '\P{tamil}', "");
    Expect(0, 70461, '\P{^tamil}', "");
    Expect(1, 70460, '\p{_ Tamil}', "");
    Expect(0, 70460, '\p{^_ Tamil}', "");
    Expect(0, 70460, '\P{_ Tamil}', "");
    Expect(1, 70460, '\P{^_ Tamil}', "");
    Expect(0, 70461, '\p{_ Tamil}', "");
    Expect(1, 70461, '\p{^_ Tamil}', "");
    Expect(1, 70461, '\P{_ Tamil}', "");
    Expect(0, 70461, '\P{^_ Tamil}', "");
    Error('\p{/a/	-IS_Tamil}');
    Error('\P{/a/	-IS_Tamil}');
    Expect(1, 70460, '\p{istamil}', "");
    Expect(0, 70460, '\p{^istamil}', "");
    Expect(0, 70460, '\P{istamil}', "");
    Expect(1, 70460, '\P{^istamil}', "");
    Expect(0, 70461, '\p{istamil}', "");
    Expect(1, 70461, '\p{^istamil}', "");
    Expect(1, 70461, '\P{istamil}', "");
    Expect(0, 70461, '\P{^istamil}', "");
    Expect(1, 70460, '\p{-	IS_TAMIL}', "");
    Expect(0, 70460, '\p{^-	IS_TAMIL}', "");
    Expect(0, 70460, '\P{-	IS_TAMIL}', "");
    Expect(1, 70460, '\P{^-	IS_TAMIL}', "");
    Expect(0, 70461, '\p{-	IS_TAMIL}', "");
    Expect(1, 70461, '\p{^-	IS_TAMIL}', "");
    Expect(1, 70461, '\P{-	IS_TAMIL}', "");
    Expect(0, 70461, '\P{^-	IS_TAMIL}', "");
    Error('\p{__Taml/a/}');
    Error('\P{__Taml/a/}');
    Expect(1, 70460, '\p{taml}', "");
    Expect(0, 70460, '\p{^taml}', "");
    Expect(0, 70460, '\P{taml}', "");
    Expect(1, 70460, '\P{^taml}', "");
    Expect(0, 70461, '\p{taml}', "");
    Expect(1, 70461, '\p{^taml}', "");
    Expect(1, 70461, '\P{taml}', "");
    Expect(0, 70461, '\P{^taml}', "");
    Error('\p{-:=is_TAML}');
    Error('\P{-:=is_TAML}');
    Expect(1, 70460, '\p{istaml}', "");
    Expect(0, 70460, '\p{^istaml}', "");
    Expect(0, 70460, '\P{istaml}', "");
    Expect(1, 70460, '\P{^istaml}', "");
    Expect(0, 70461, '\p{istaml}', "");
    Expect(1, 70461, '\p{^istaml}', "");
    Expect(1, 70461, '\P{istaml}', "");
    Expect(0, 70461, '\P{^istaml}', "");
    Expect(1, 70460, '\p{	Is_TAML}', "");
    Expect(0, 70460, '\p{^	Is_TAML}', "");
    Expect(0, 70460, '\P{	Is_TAML}', "");
    Expect(1, 70460, '\P{^	Is_TAML}', "");
    Expect(0, 70461, '\p{	Is_TAML}', "");
    Expect(1, 70461, '\p{^	Is_TAML}', "");
    Expect(1, 70461, '\P{	Is_TAML}', "");
    Expect(0, 70461, '\P{^	Is_TAML}', "");
    Error('\p{	_Tangut/a/}');
    Error('\P{	_Tangut/a/}');
    Expect(1, 101106, '\p{tangut}', "");
    Expect(0, 101106, '\p{^tangut}', "");
    Expect(0, 101106, '\P{tangut}', "");
    Expect(1, 101106, '\P{^tangut}', "");
    Expect(0, 101107, '\p{tangut}', "");
    Expect(1, 101107, '\p{^tangut}', "");
    Expect(1, 101107, '\P{tangut}', "");
    Expect(0, 101107, '\P{^tangut}', "");
    Expect(1, 101106, '\p{  tangut}', "");
    Expect(0, 101106, '\p{^  tangut}', "");
    Expect(0, 101106, '\P{  tangut}', "");
    Expect(1, 101106, '\P{^  tangut}', "");
    Expect(0, 101107, '\p{  tangut}', "");
    Expect(1, 101107, '\p{^  tangut}', "");
    Expect(1, 101107, '\P{  tangut}', "");
    Expect(0, 101107, '\P{^  tangut}', "");
    Error('\p{-:=Is_TANGUT}');
    Error('\P{-:=Is_TANGUT}');
    Expect(1, 101106, '\p{istangut}', "");
    Expect(0, 101106, '\p{^istangut}', "");
    Expect(0, 101106, '\P{istangut}', "");
    Expect(1, 101106, '\P{^istangut}', "");
    Expect(0, 101107, '\p{istangut}', "");
    Expect(1, 101107, '\p{^istangut}', "");
    Expect(1, 101107, '\P{istangut}', "");
    Expect(0, 101107, '\P{^istangut}', "");
    Expect(1, 101106, '\p{ 	Is_Tangut}', "");
    Expect(0, 101106, '\p{^ 	Is_Tangut}', "");
    Expect(0, 101106, '\P{ 	Is_Tangut}', "");
    Expect(1, 101106, '\P{^ 	Is_Tangut}', "");
    Expect(0, 101107, '\p{ 	Is_Tangut}', "");
    Expect(1, 101107, '\p{^ 	Is_Tangut}', "");
    Expect(1, 101107, '\P{ 	Is_Tangut}', "");
    Expect(0, 101107, '\P{^ 	Is_Tangut}', "");
    Error('\p{:= -tang}');
    Error('\P{:= -tang}');
    Expect(1, 101106, '\p{tang}', "");
    Expect(0, 101106, '\p{^tang}', "");
    Expect(0, 101106, '\P{tang}', "");
    Expect(1, 101106, '\P{^tang}', "");
    Expect(0, 101107, '\p{tang}', "");
    Expect(1, 101107, '\p{^tang}', "");
    Expect(1, 101107, '\P{tang}', "");
    Expect(0, 101107, '\P{^tang}', "");
    Expect(1, 101106, '\p{_-Tang}', "");
    Expect(0, 101106, '\p{^_-Tang}', "");
    Expect(0, 101106, '\P{_-Tang}', "");
    Expect(1, 101106, '\P{^_-Tang}', "");
    Expect(0, 101107, '\p{_-Tang}', "");
    Expect(1, 101107, '\p{^_-Tang}', "");
    Expect(1, 101107, '\P{_-Tang}', "");
    Expect(0, 101107, '\P{^_-Tang}', "");
    Error('\p{ :=IS_tang}');
    Error('\P{ :=IS_tang}');
    Expect(1, 101106, '\p{istang}', "");
    Expect(0, 101106, '\p{^istang}', "");
    Expect(0, 101106, '\P{istang}', "");
    Expect(1, 101106, '\P{^istang}', "");
    Expect(0, 101107, '\p{istang}', "");
    Expect(1, 101107, '\p{^istang}', "");
    Expect(1, 101107, '\P{istang}', "");
    Expect(0, 101107, '\P{^istang}', "");
    Expect(1, 101106, '\p{  Is_tang}', "");
    Expect(0, 101106, '\p{^  Is_tang}', "");
    Expect(0, 101106, '\P{  Is_tang}', "");
    Expect(1, 101106, '\P{^  Is_tang}', "");
    Expect(0, 101107, '\p{  Is_tang}', "");
    Expect(1, 101107, '\p{^  Is_tang}', "");
    Expect(1, 101107, '\P{  Is_tang}', "");
    Expect(0, 101107, '\P{^  Is_tang}', "");
    Error('\p{_ Tangut_Components:=}');
    Error('\P{_ Tangut_Components:=}');
    Expect(1, 101119, '\p{tangutcomponents}', "");
    Expect(0, 101119, '\p{^tangutcomponents}', "");
    Expect(0, 101119, '\P{tangutcomponents}', "");
    Expect(1, 101119, '\P{^tangutcomponents}', "");
    Expect(0, 101120, '\p{tangutcomponents}', "");
    Expect(1, 101120, '\p{^tangutcomponents}', "");
    Expect(1, 101120, '\P{tangutcomponents}', "");
    Expect(0, 101120, '\P{^tangutcomponents}', "");
    Expect(1, 101119, '\p{_Tangut_Components}', "");
    Expect(0, 101119, '\p{^_Tangut_Components}', "");
    Expect(0, 101119, '\P{_Tangut_Components}', "");
    Expect(1, 101119, '\P{^_Tangut_Components}', "");
    Expect(0, 101120, '\p{_Tangut_Components}', "");
    Expect(1, 101120, '\p{^_Tangut_Components}', "");
    Expect(1, 101120, '\P{_Tangut_Components}', "");
    Expect(0, 101120, '\P{^_Tangut_Components}', "");
    Error('\p{ 	Is_tangut_components:=}');
    Error('\P{ 	Is_tangut_components:=}');
    Expect(1, 101119, '\p{istangutcomponents}', "");
    Expect(0, 101119, '\p{^istangutcomponents}', "");
    Expect(0, 101119, '\P{istangutcomponents}', "");
    Expect(1, 101119, '\P{^istangutcomponents}', "");
    Expect(0, 101120, '\p{istangutcomponents}', "");
    Expect(1, 101120, '\p{^istangutcomponents}', "");
    Expect(1, 101120, '\P{istangutcomponents}', "");
    Expect(0, 101120, '\P{^istangutcomponents}', "");
    Expect(1, 101119, '\p{	Is_tangut_COMPONENTS}', "");
    Expect(0, 101119, '\p{^	Is_tangut_COMPONENTS}', "");
    Expect(0, 101119, '\P{	Is_tangut_COMPONENTS}', "");
    Expect(1, 101119, '\P{^	Is_tangut_COMPONENTS}', "");
    Expect(0, 101120, '\p{	Is_tangut_COMPONENTS}', "");
    Expect(1, 101120, '\p{^	Is_tangut_COMPONENTS}', "");
    Expect(1, 101120, '\P{	Is_tangut_COMPONENTS}', "");
    Expect(0, 101120, '\P{^	Is_tangut_COMPONENTS}', "");
    Error('\p{/a/__in_tangut_Components}');
    Error('\P{/a/__in_tangut_Components}');
    Expect(1, 101119, '\p{intangutcomponents}', "");
    Expect(0, 101119, '\p{^intangutcomponents}', "");
    Expect(0, 101119, '\P{intangutcomponents}', "");
    Expect(1, 101119, '\P{^intangutcomponents}', "");
    Expect(0, 101120, '\p{intangutcomponents}', "");
    Expect(1, 101120, '\p{^intangutcomponents}', "");
    Expect(1, 101120, '\P{intangutcomponents}', "");
    Expect(0, 101120, '\P{^intangutcomponents}', "");
    Expect(1, 101119, '\p{	 IN_tangut_Components}', "");
    Expect(0, 101119, '\p{^	 IN_tangut_Components}', "");
    Expect(0, 101119, '\P{	 IN_tangut_Components}', "");
    Expect(1, 101119, '\P{^	 IN_tangut_Components}', "");
    Expect(0, 101120, '\p{	 IN_tangut_Components}', "");
    Expect(1, 101120, '\p{^	 IN_tangut_Components}', "");
    Expect(1, 101120, '\P{	 IN_tangut_Components}', "");
    Expect(0, 101120, '\P{^	 IN_tangut_Components}', "");
    Error('\p{_/a/Telugu}');
    Error('\P{_/a/Telugu}');
    Expect(1, 7386, '\p{telugu}', "");
    Expect(0, 7386, '\p{^telugu}', "");
    Expect(0, 7386, '\P{telugu}', "");
    Expect(1, 7386, '\P{^telugu}', "");
    Expect(0, 7387, '\p{telugu}', "");
    Expect(1, 7387, '\p{^telugu}', "");
    Expect(1, 7387, '\P{telugu}', "");
    Expect(0, 7387, '\P{^telugu}', "");
    Expect(1, 7386, '\p{__Telugu}', "");
    Expect(0, 7386, '\p{^__Telugu}', "");
    Expect(0, 7386, '\P{__Telugu}', "");
    Expect(1, 7386, '\P{^__Telugu}', "");
    Expect(0, 7387, '\p{__Telugu}', "");
    Expect(1, 7387, '\p{^__Telugu}', "");
    Expect(1, 7387, '\P{__Telugu}', "");
    Expect(0, 7387, '\P{^__Telugu}', "");
    Error('\p{ Is_TELUGU/a/}');
    Error('\P{ Is_TELUGU/a/}');
    Expect(1, 7386, '\p{istelugu}', "");
    Expect(0, 7386, '\p{^istelugu}', "");
    Expect(0, 7386, '\P{istelugu}', "");
    Expect(1, 7386, '\P{^istelugu}', "");
    Expect(0, 7387, '\p{istelugu}', "");
    Expect(1, 7387, '\p{^istelugu}', "");
    Expect(1, 7387, '\P{istelugu}', "");
    Expect(0, 7387, '\P{^istelugu}', "");
    Expect(1, 7386, '\p{ _Is_telugu}', "");
    Expect(0, 7386, '\p{^ _Is_telugu}', "");
    Expect(0, 7386, '\P{ _Is_telugu}', "");
    Expect(1, 7386, '\P{^ _Is_telugu}', "");
    Expect(0, 7387, '\p{ _Is_telugu}', "");
    Expect(1, 7387, '\p{^ _Is_telugu}', "");
    Expect(1, 7387, '\P{ _Is_telugu}', "");
    Expect(0, 7387, '\P{^ _Is_telugu}', "");
    Error('\p{/a/-telu}');
    Error('\P{/a/-telu}');
    Expect(1, 7386, '\p{telu}', "");
    Expect(0, 7386, '\p{^telu}', "");
    Expect(0, 7386, '\P{telu}', "");
    Expect(1, 7386, '\P{^telu}', "");
    Expect(0, 7387, '\p{telu}', "");
    Expect(1, 7387, '\p{^telu}', "");
    Expect(1, 7387, '\P{telu}', "");
    Expect(0, 7387, '\P{^telu}', "");
    Expect(1, 7386, '\p{ 	TELU}', "");
    Expect(0, 7386, '\p{^ 	TELU}', "");
    Expect(0, 7386, '\P{ 	TELU}', "");
    Expect(1, 7386, '\P{^ 	TELU}', "");
    Expect(0, 7387, '\p{ 	TELU}', "");
    Expect(1, 7387, '\p{^ 	TELU}', "");
    Expect(1, 7387, '\P{ 	TELU}', "");
    Expect(0, 7387, '\P{^ 	TELU}', "");
    Error('\p{ :=Is_Telu}');
    Error('\P{ :=Is_Telu}');
    Expect(1, 7386, '\p{istelu}', "");
    Expect(0, 7386, '\p{^istelu}', "");
    Expect(0, 7386, '\P{istelu}', "");
    Expect(1, 7386, '\P{^istelu}', "");
    Expect(0, 7387, '\p{istelu}', "");
    Expect(1, 7387, '\p{^istelu}', "");
    Expect(1, 7387, '\P{istelu}', "");
    Expect(0, 7387, '\P{^istelu}', "");
    Expect(1, 7386, '\p{__Is_TELU}', "");
    Expect(0, 7386, '\p{^__Is_TELU}', "");
    Expect(0, 7386, '\P{__Is_TELU}', "");
    Expect(1, 7386, '\P{^__Is_TELU}', "");
    Expect(0, 7387, '\p{__Is_TELU}', "");
    Expect(1, 7387, '\p{^__Is_TELU}', "");
    Expect(1, 7387, '\P{__Is_TELU}', "");
    Expect(0, 7387, '\P{^__Is_TELU}', "");
    Error('\p{-/a/TERMINAL_PUNCTUATION}');
    Error('\P{-/a/TERMINAL_PUNCTUATION}');
    Expect(1, 121482, '\p{terminalpunctuation}', "");
    Expect(0, 121482, '\p{^terminalpunctuation}', "");
    Expect(0, 121482, '\P{terminalpunctuation}', "");
    Expect(1, 121482, '\P{^terminalpunctuation}', "");
    Expect(0, 121483, '\p{terminalpunctuation}', "");
    Expect(1, 121483, '\p{^terminalpunctuation}', "");
    Expect(1, 121483, '\P{terminalpunctuation}', "");
    Expect(0, 121483, '\P{^terminalpunctuation}', "");
    Expect(1, 121482, '\p{_ TERMINAL_Punctuation}', "");
    Expect(0, 121482, '\p{^_ TERMINAL_Punctuation}', "");
    Expect(0, 121482, '\P{_ TERMINAL_Punctuation}', "");
    Expect(1, 121482, '\P{^_ TERMINAL_Punctuation}', "");
    Expect(0, 121483, '\p{_ TERMINAL_Punctuation}', "");
    Expect(1, 121483, '\p{^_ TERMINAL_Punctuation}', "");
    Expect(1, 121483, '\P{_ TERMINAL_Punctuation}', "");
    Expect(0, 121483, '\P{^_ TERMINAL_Punctuation}', "");
    Error('\p{/a/-IS_Terminal_PUNCTUATION}');
    Error('\P{/a/-IS_Terminal_PUNCTUATION}');
    Expect(1, 121482, '\p{isterminalpunctuation}', "");
    Expect(0, 121482, '\p{^isterminalpunctuation}', "");
    Expect(0, 121482, '\P{isterminalpunctuation}', "");
    Expect(1, 121482, '\P{^isterminalpunctuation}', "");
    Expect(0, 121483, '\p{isterminalpunctuation}', "");
    Expect(1, 121483, '\p{^isterminalpunctuation}', "");
    Expect(1, 121483, '\P{isterminalpunctuation}', "");
    Expect(0, 121483, '\P{^isterminalpunctuation}', "");
    Expect(1, 121482, '\p{	-Is_Terminal_PUNCTUATION}', "");
    Expect(0, 121482, '\p{^	-Is_Terminal_PUNCTUATION}', "");
    Expect(0, 121482, '\P{	-Is_Terminal_PUNCTUATION}', "");
    Expect(1, 121482, '\P{^	-Is_Terminal_PUNCTUATION}', "");
    Expect(0, 121483, '\p{	-Is_Terminal_PUNCTUATION}', "");
    Expect(1, 121483, '\p{^	-Is_Terminal_PUNCTUATION}', "");
    Expect(1, 121483, '\P{	-Is_Terminal_PUNCTUATION}', "");
    Expect(0, 121483, '\P{^	-Is_Terminal_PUNCTUATION}', "");
    Error('\p{:=-term}');
    Error('\P{:=-term}');
    Expect(1, 121482, '\p{term}', "");
    Expect(0, 121482, '\p{^term}', "");
    Expect(0, 121482, '\P{term}', "");
    Expect(1, 121482, '\P{^term}', "");
    Expect(0, 121483, '\p{term}', "");
    Expect(1, 121483, '\p{^term}', "");
    Expect(1, 121483, '\P{term}', "");
    Expect(0, 121483, '\P{^term}', "");
    Expect(1, 121482, '\p{	TERM}', "");
    Expect(0, 121482, '\p{^	TERM}', "");
    Expect(0, 121482, '\P{	TERM}', "");
    Expect(1, 121482, '\P{^	TERM}', "");
    Expect(0, 121483, '\p{	TERM}', "");
    Expect(1, 121483, '\p{^	TERM}', "");
    Expect(1, 121483, '\P{	TERM}', "");
    Expect(0, 121483, '\P{^	TERM}', "");
    Error('\p{-/a/is_Term}');
    Error('\P{-/a/is_Term}');
    Expect(1, 121482, '\p{isterm}', "");
    Expect(0, 121482, '\p{^isterm}', "");
    Expect(0, 121482, '\P{isterm}', "");
    Expect(1, 121482, '\P{^isterm}', "");
    Expect(0, 121483, '\p{isterm}', "");
    Expect(1, 121483, '\p{^isterm}', "");
    Expect(1, 121483, '\P{isterm}', "");
    Expect(0, 121483, '\P{^isterm}', "");
    Expect(1, 121482, '\p{ is_Term}', "");
    Expect(0, 121482, '\p{^ is_Term}', "");
    Expect(0, 121482, '\P{ is_Term}', "");
    Expect(1, 121482, '\P{^ is_Term}', "");
    Expect(0, 121483, '\p{ is_Term}', "");
    Expect(1, 121483, '\p{^ is_Term}', "");
    Expect(1, 121483, '\P{ is_Term}', "");
    Expect(0, 121483, '\P{^ is_Term}', "");
    Error('\p{	:=Thaana}');
    Error('\P{	:=Thaana}');
    Expect(1, 65021, '\p{thaana}', "");
    Expect(0, 65021, '\p{^thaana}', "");
    Expect(0, 65021, '\P{thaana}', "");
    Expect(1, 65021, '\P{^thaana}', "");
    Expect(0, 65022, '\p{thaana}', "");
    Expect(1, 65022, '\p{^thaana}', "");
    Expect(1, 65022, '\P{thaana}', "");
    Expect(0, 65022, '\P{^thaana}', "");
    Expect(1, 65021, '\p{  Thaana}', "");
    Expect(0, 65021, '\p{^  Thaana}', "");
    Expect(0, 65021, '\P{  Thaana}', "");
    Expect(1, 65021, '\P{^  Thaana}', "");
    Expect(0, 65022, '\p{  Thaana}', "");
    Expect(1, 65022, '\p{^  Thaana}', "");
    Expect(1, 65022, '\P{  Thaana}', "");
    Expect(0, 65022, '\P{^  Thaana}', "");
    Error('\p{_Is_thaana:=}');
    Error('\P{_Is_thaana:=}');
    Expect(1, 65021, '\p{isthaana}', "");
    Expect(0, 65021, '\p{^isthaana}', "");
    Expect(0, 65021, '\P{isthaana}', "");
    Expect(1, 65021, '\P{^isthaana}', "");
    Expect(0, 65022, '\p{isthaana}', "");
    Expect(1, 65022, '\p{^isthaana}', "");
    Expect(1, 65022, '\P{isthaana}', "");
    Expect(0, 65022, '\P{^isthaana}', "");
    Expect(1, 65021, '\p{	IS_Thaana}', "");
    Expect(0, 65021, '\p{^	IS_Thaana}', "");
    Expect(0, 65021, '\P{	IS_Thaana}', "");
    Expect(1, 65021, '\P{^	IS_Thaana}', "");
    Expect(0, 65022, '\p{	IS_Thaana}', "");
    Expect(1, 65022, '\p{^	IS_Thaana}', "");
    Expect(1, 65022, '\P{	IS_Thaana}', "");
    Expect(0, 65022, '\P{^	IS_Thaana}', "");
    Error('\p{ 	Thaa:=}');
    Error('\P{ 	Thaa:=}');
    Expect(1, 65021, '\p{thaa}', "");
    Expect(0, 65021, '\p{^thaa}', "");
    Expect(0, 65021, '\P{thaa}', "");
    Expect(1, 65021, '\P{^thaa}', "");
    Expect(0, 65022, '\p{thaa}', "");
    Expect(1, 65022, '\p{^thaa}', "");
    Expect(1, 65022, '\P{thaa}', "");
    Expect(0, 65022, '\P{^thaa}', "");
    Expect(1, 65021, '\p{_Thaa}', "");
    Expect(0, 65021, '\p{^_Thaa}', "");
    Expect(0, 65021, '\P{_Thaa}', "");
    Expect(1, 65021, '\P{^_Thaa}', "");
    Expect(0, 65022, '\p{_Thaa}', "");
    Expect(1, 65022, '\p{^_Thaa}', "");
    Expect(1, 65022, '\P{_Thaa}', "");
    Expect(0, 65022, '\P{^_Thaa}', "");
    Error('\p{	 Is_Thaa:=}');
    Error('\P{	 Is_Thaa:=}');
    Expect(1, 65021, '\p{isthaa}', "");
    Expect(0, 65021, '\p{^isthaa}', "");
    Expect(0, 65021, '\P{isthaa}', "");
    Expect(1, 65021, '\P{^isthaa}', "");
    Expect(0, 65022, '\p{isthaa}', "");
    Expect(1, 65022, '\p{^isthaa}', "");
    Expect(1, 65022, '\P{isthaa}', "");
    Expect(0, 65022, '\P{^isthaa}', "");
    Expect(1, 65021, '\p{ is_THAA}', "");
    Expect(0, 65021, '\p{^ is_THAA}', "");
    Expect(0, 65021, '\P{ is_THAA}', "");
    Expect(1, 65021, '\P{^ is_THAA}', "");
    Expect(0, 65022, '\p{ is_THAA}', "");
    Expect(1, 65022, '\p{^ is_THAA}', "");
    Expect(1, 65022, '\P{ is_THAA}', "");
    Expect(0, 65022, '\P{^ is_THAA}', "");
    Error('\p{ 	thai:=}');
    Error('\P{ 	thai:=}');
    Expect(1, 3675, '\p{thai}', "");
    Expect(0, 3675, '\p{^thai}', "");
    Expect(0, 3675, '\P{thai}', "");
    Expect(1, 3675, '\P{^thai}', "");
    Expect(0, 3676, '\p{thai}', "");
    Expect(1, 3676, '\p{^thai}', "");
    Expect(1, 3676, '\P{thai}', "");
    Expect(0, 3676, '\P{^thai}', "");
    Expect(1, 3675, '\p{  Thai}', "");
    Expect(0, 3675, '\p{^  Thai}', "");
    Expect(0, 3675, '\P{  Thai}', "");
    Expect(1, 3675, '\P{^  Thai}', "");
    Expect(0, 3676, '\p{  Thai}', "");
    Expect(1, 3676, '\p{^  Thai}', "");
    Expect(1, 3676, '\P{  Thai}', "");
    Expect(0, 3676, '\P{^  Thai}', "");
    Error('\p{/a/		Is_Thai}');
    Error('\P{/a/		Is_Thai}');
    Expect(1, 3675, '\p{isthai}', "");
    Expect(0, 3675, '\p{^isthai}', "");
    Expect(0, 3675, '\P{isthai}', "");
    Expect(1, 3675, '\P{^isthai}', "");
    Expect(0, 3676, '\p{isthai}', "");
    Expect(1, 3676, '\p{^isthai}', "");
    Expect(1, 3676, '\P{isthai}', "");
    Expect(0, 3676, '\P{^isthai}', "");
    Expect(1, 3675, '\p{	is_Thai}', "");
    Expect(0, 3675, '\p{^	is_Thai}', "");
    Expect(0, 3675, '\P{	is_Thai}', "");
    Expect(1, 3675, '\P{^	is_Thai}', "");
    Expect(0, 3676, '\p{	is_Thai}', "");
    Expect(1, 3676, '\p{^	is_Thai}', "");
    Expect(1, 3676, '\P{	is_Thai}', "");
    Expect(0, 3676, '\P{^	is_Thai}', "");
    Error('\p{:=_ TIBETAN}');
    Error('\P{:=_ TIBETAN}');
    Expect(1, 4058, '\p{tibetan}', "");
    Expect(0, 4058, '\p{^tibetan}', "");
    Expect(0, 4058, '\P{tibetan}', "");
    Expect(1, 4058, '\P{^tibetan}', "");
    Expect(0, 4059, '\p{tibetan}', "");
    Expect(1, 4059, '\p{^tibetan}', "");
    Expect(1, 4059, '\P{tibetan}', "");
    Expect(0, 4059, '\P{^tibetan}', "");
    Expect(1, 4058, '\p{_ TIBETAN}', "");
    Expect(0, 4058, '\p{^_ TIBETAN}', "");
    Expect(0, 4058, '\P{_ TIBETAN}', "");
    Expect(1, 4058, '\P{^_ TIBETAN}', "");
    Expect(0, 4059, '\p{_ TIBETAN}', "");
    Expect(1, 4059, '\p{^_ TIBETAN}', "");
    Expect(1, 4059, '\P{_ TIBETAN}', "");
    Expect(0, 4059, '\P{^_ TIBETAN}', "");
    Error('\p{_/a/Is_Tibetan}');
    Error('\P{_/a/Is_Tibetan}');
    Expect(1, 4058, '\p{istibetan}', "");
    Expect(0, 4058, '\p{^istibetan}', "");
    Expect(0, 4058, '\P{istibetan}', "");
    Expect(1, 4058, '\P{^istibetan}', "");
    Expect(0, 4059, '\p{istibetan}', "");
    Expect(1, 4059, '\p{^istibetan}', "");
    Expect(1, 4059, '\P{istibetan}', "");
    Expect(0, 4059, '\P{^istibetan}', "");
    Expect(1, 4058, '\p{		Is_tibetan}', "");
    Expect(0, 4058, '\p{^		Is_tibetan}', "");
    Expect(0, 4058, '\P{		Is_tibetan}', "");
    Expect(1, 4058, '\P{^		Is_tibetan}', "");
    Expect(0, 4059, '\p{		Is_tibetan}', "");
    Expect(1, 4059, '\p{^		Is_tibetan}', "");
    Expect(1, 4059, '\P{		Is_tibetan}', "");
    Expect(0, 4059, '\P{^		Is_tibetan}', "");
    Error('\p{-/a/Tibt}');
    Error('\P{-/a/Tibt}');
    Expect(1, 4058, '\p{tibt}', "");
    Expect(0, 4058, '\p{^tibt}', "");
    Expect(0, 4058, '\P{tibt}', "");
    Expect(1, 4058, '\P{^tibt}', "");
    Expect(0, 4059, '\p{tibt}', "");
    Expect(1, 4059, '\p{^tibt}', "");
    Expect(1, 4059, '\P{tibt}', "");
    Expect(0, 4059, '\P{^tibt}', "");
    Expect(1, 4058, '\p{_Tibt}', "");
    Expect(0, 4058, '\p{^_Tibt}', "");
    Expect(0, 4058, '\P{_Tibt}', "");
    Expect(1, 4058, '\P{^_Tibt}', "");
    Expect(0, 4059, '\p{_Tibt}', "");
    Expect(1, 4059, '\p{^_Tibt}', "");
    Expect(1, 4059, '\P{_Tibt}', "");
    Expect(0, 4059, '\P{^_Tibt}', "");
    Error('\p{_is_tibt:=}');
    Error('\P{_is_tibt:=}');
    Expect(1, 4058, '\p{istibt}', "");
    Expect(0, 4058, '\p{^istibt}', "");
    Expect(0, 4058, '\P{istibt}', "");
    Expect(1, 4058, '\P{^istibt}', "");
    Expect(0, 4059, '\p{istibt}', "");
    Expect(1, 4059, '\p{^istibt}', "");
    Expect(1, 4059, '\P{istibt}', "");
    Expect(0, 4059, '\P{^istibt}', "");
    Expect(1, 4058, '\p{_is_TIBT}', "");
    Expect(0, 4058, '\p{^_is_TIBT}', "");
    Expect(0, 4058, '\P{_is_TIBT}', "");
    Expect(1, 4058, '\P{^_is_TIBT}', "");
    Expect(0, 4059, '\p{_is_TIBT}', "");
    Expect(1, 4059, '\p{^_is_TIBT}', "");
    Expect(1, 4059, '\P{_is_TIBT}', "");
    Expect(0, 4059, '\P{^_is_TIBT}', "");
    Error('\p{	 tifinagh:=}');
    Error('\P{	 tifinagh:=}');
    Expect(1, 11647, '\p{tifinagh}', "");
    Expect(0, 11647, '\p{^tifinagh}', "");
    Expect(0, 11647, '\P{tifinagh}', "");
    Expect(1, 11647, '\P{^tifinagh}', "");
    Expect(0, 11648, '\p{tifinagh}', "");
    Expect(1, 11648, '\p{^tifinagh}', "");
    Expect(1, 11648, '\P{tifinagh}', "");
    Expect(0, 11648, '\P{^tifinagh}', "");
    Expect(1, 11647, '\p{ _TIFINAGH}', "");
    Expect(0, 11647, '\p{^ _TIFINAGH}', "");
    Expect(0, 11647, '\P{ _TIFINAGH}', "");
    Expect(1, 11647, '\P{^ _TIFINAGH}', "");
    Expect(0, 11648, '\p{ _TIFINAGH}', "");
    Expect(1, 11648, '\p{^ _TIFINAGH}', "");
    Expect(1, 11648, '\P{ _TIFINAGH}', "");
    Expect(0, 11648, '\P{^ _TIFINAGH}', "");
    Error('\p{-Is_tifinagh/a/}');
    Error('\P{-Is_tifinagh/a/}');
    Expect(1, 11647, '\p{istifinagh}', "");
    Expect(0, 11647, '\p{^istifinagh}', "");
    Expect(0, 11647, '\P{istifinagh}', "");
    Expect(1, 11647, '\P{^istifinagh}', "");
    Expect(0, 11648, '\p{istifinagh}', "");
    Expect(1, 11648, '\p{^istifinagh}', "");
    Expect(1, 11648, '\P{istifinagh}', "");
    Expect(0, 11648, '\P{^istifinagh}', "");
    Expect(1, 11647, '\p{-	Is_Tifinagh}', "");
    Expect(0, 11647, '\p{^-	Is_Tifinagh}', "");
    Expect(0, 11647, '\P{-	Is_Tifinagh}', "");
    Expect(1, 11647, '\P{^-	Is_Tifinagh}', "");
    Expect(0, 11648, '\p{-	Is_Tifinagh}', "");
    Expect(1, 11648, '\p{^-	Is_Tifinagh}', "");
    Expect(1, 11648, '\P{-	Is_Tifinagh}', "");
    Expect(0, 11648, '\P{^-	Is_Tifinagh}', "");
    Error('\p{-	Tfng:=}');
    Error('\P{-	Tfng:=}');
    Expect(1, 11647, '\p{tfng}', "");
    Expect(0, 11647, '\p{^tfng}', "");
    Expect(0, 11647, '\P{tfng}', "");
    Expect(1, 11647, '\P{^tfng}', "");
    Expect(0, 11648, '\p{tfng}', "");
    Expect(1, 11648, '\p{^tfng}', "");
    Expect(1, 11648, '\P{tfng}', "");
    Expect(0, 11648, '\P{^tfng}', "");
    Expect(1, 11647, '\p{ TFNG}', "");
    Expect(0, 11647, '\p{^ TFNG}', "");
    Expect(0, 11647, '\P{ TFNG}', "");
    Expect(1, 11647, '\P{^ TFNG}', "");
    Expect(0, 11648, '\p{ TFNG}', "");
    Expect(1, 11648, '\p{^ TFNG}', "");
    Expect(1, 11648, '\P{ TFNG}', "");
    Expect(0, 11648, '\P{^ TFNG}', "");
    Error('\p{/a/	IS_Tfng}');
    Error('\P{/a/	IS_Tfng}');
    Expect(1, 11647, '\p{istfng}', "");
    Expect(0, 11647, '\p{^istfng}', "");
    Expect(0, 11647, '\P{istfng}', "");
    Expect(1, 11647, '\P{^istfng}', "");
    Expect(0, 11648, '\p{istfng}', "");
    Expect(1, 11648, '\p{^istfng}', "");
    Expect(1, 11648, '\P{istfng}', "");
    Expect(0, 11648, '\P{^istfng}', "");
    Expect(1, 11647, '\p{	_Is_tfng}', "");
    Expect(0, 11647, '\p{^	_Is_tfng}', "");
    Expect(0, 11647, '\P{	_Is_tfng}', "");
    Expect(1, 11647, '\P{^	_Is_tfng}', "");
    Expect(0, 11648, '\p{	_Is_tfng}', "");
    Expect(1, 11648, '\p{^	_Is_tfng}', "");
    Expect(1, 11648, '\P{	_Is_tfng}', "");
    Expect(0, 11648, '\P{^	_Is_tfng}', "");
    Error('\p{ /a/Tirhuta}');
    Error('\P{ /a/Tirhuta}');
    Expect(1, 70873, '\p{tirhuta}', "");
    Expect(0, 70873, '\p{^tirhuta}', "");
    Expect(0, 70873, '\P{tirhuta}', "");
    Expect(1, 70873, '\P{^tirhuta}', "");
    Expect(0, 70874, '\p{tirhuta}', "");
    Expect(1, 70874, '\p{^tirhuta}', "");
    Expect(1, 70874, '\P{tirhuta}', "");
    Expect(0, 70874, '\P{^tirhuta}', "");
    Expect(1, 70873, '\p{	-Tirhuta}', "");
    Expect(0, 70873, '\p{^	-Tirhuta}', "");
    Expect(0, 70873, '\P{	-Tirhuta}', "");
    Expect(1, 70873, '\P{^	-Tirhuta}', "");
    Expect(0, 70874, '\p{	-Tirhuta}', "");
    Expect(1, 70874, '\p{^	-Tirhuta}', "");
    Expect(1, 70874, '\P{	-Tirhuta}', "");
    Expect(0, 70874, '\P{^	-Tirhuta}', "");
    Error('\p{_-is_Tirhuta/a/}');
    Error('\P{_-is_Tirhuta/a/}');
    Expect(1, 70873, '\p{istirhuta}', "");
    Expect(0, 70873, '\p{^istirhuta}', "");
    Expect(0, 70873, '\P{istirhuta}', "");
    Expect(1, 70873, '\P{^istirhuta}', "");
    Expect(0, 70874, '\p{istirhuta}', "");
    Expect(1, 70874, '\p{^istirhuta}', "");
    Expect(1, 70874, '\P{istirhuta}', "");
    Expect(0, 70874, '\P{^istirhuta}', "");
    Expect(1, 70873, '\p{ Is_Tirhuta}', "");
    Expect(0, 70873, '\p{^ Is_Tirhuta}', "");
    Expect(0, 70873, '\P{ Is_Tirhuta}', "");
    Expect(1, 70873, '\P{^ Is_Tirhuta}', "");
    Expect(0, 70874, '\p{ Is_Tirhuta}', "");
    Expect(1, 70874, '\p{^ Is_Tirhuta}', "");
    Expect(1, 70874, '\P{ Is_Tirhuta}', "");
    Expect(0, 70874, '\P{^ Is_Tirhuta}', "");
    Error('\p{_:=Tirh}');
    Error('\P{_:=Tirh}');
    Expect(1, 70873, '\p{tirh}', "");
    Expect(0, 70873, '\p{^tirh}', "");
    Expect(0, 70873, '\P{tirh}', "");
    Expect(1, 70873, '\P{^tirh}', "");
    Expect(0, 70874, '\p{tirh}', "");
    Expect(1, 70874, '\p{^tirh}', "");
    Expect(1, 70874, '\P{tirh}', "");
    Expect(0, 70874, '\P{^tirh}', "");
    Expect(1, 70873, '\p{__TIRH}', "");
    Expect(0, 70873, '\p{^__TIRH}', "");
    Expect(0, 70873, '\P{__TIRH}', "");
    Expect(1, 70873, '\P{^__TIRH}', "");
    Expect(0, 70874, '\p{__TIRH}', "");
    Expect(1, 70874, '\p{^__TIRH}', "");
    Expect(1, 70874, '\P{__TIRH}', "");
    Expect(0, 70874, '\P{^__TIRH}', "");
    Error('\p{_IS_TIRH/a/}');
    Error('\P{_IS_TIRH/a/}');
    Expect(1, 70873, '\p{istirh}', "");
    Expect(0, 70873, '\p{^istirh}', "");
    Expect(0, 70873, '\P{istirh}', "");
    Expect(1, 70873, '\P{^istirh}', "");
    Expect(0, 70874, '\p{istirh}', "");
    Expect(1, 70874, '\p{^istirh}', "");
    Expect(1, 70874, '\P{istirh}', "");
    Expect(0, 70874, '\P{^istirh}', "");
    Expect(1, 70873, '\p{		Is_Tirh}', "");
    Expect(0, 70873, '\p{^		Is_Tirh}', "");
    Expect(0, 70873, '\P{		Is_Tirh}', "");
    Expect(1, 70873, '\P{^		Is_Tirh}', "");
    Expect(0, 70874, '\p{		Is_Tirh}', "");
    Expect(1, 70874, '\p{^		Is_Tirh}', "");
    Expect(1, 70874, '\P{		Is_Tirh}', "");
    Expect(0, 70874, '\P{^		Is_Tirh}', "");
    Error('\p{ /a/TITLECASE}');
    Error('\P{ /a/TITLECASE}');
    Expect(1, 8188, '\p{titlecase}', "");
    Expect(0, 8188, '\p{^titlecase}', "");
    Expect(0, 8188, '\P{titlecase}', "");
    Expect(1, 8188, '\P{^titlecase}', "");
    Expect(0, 8189, '\p{titlecase}', "");
    Expect(1, 8189, '\p{^titlecase}', "");
    Expect(1, 8189, '\P{titlecase}', "");
    Expect(0, 8189, '\P{^titlecase}', "");
    Expect(1, 8188, '\p{	 Titlecase}', "");
    Expect(0, 8188, '\p{^	 Titlecase}', "");
    Expect(0, 8188, '\P{	 Titlecase}', "");
    Expect(1, 8188, '\P{^	 Titlecase}', "");
    Expect(0, 8189, '\p{	 Titlecase}', "");
    Expect(1, 8189, '\p{^	 Titlecase}', "");
    Expect(1, 8189, '\P{	 Titlecase}', "");
    Expect(0, 8189, '\P{^	 Titlecase}', "");
    Error('\p{	 title/a/}');
    Error('\P{	 title/a/}');
    Expect(1, 8188, '\p{title}', "");
    Expect(0, 8188, '\p{^title}', "");
    Expect(0, 8188, '\P{title}', "");
    Expect(1, 8188, '\P{^title}', "");
    Expect(0, 8189, '\p{title}', "");
    Expect(1, 8189, '\p{^title}', "");
    Expect(1, 8189, '\P{title}', "");
    Expect(0, 8189, '\P{^title}', "");
    Expect(1, 8188, '\p{__Title}', "");
    Expect(0, 8188, '\p{^__Title}', "");
    Expect(0, 8188, '\P{__Title}', "");
    Expect(1, 8188, '\P{^__Title}', "");
    Expect(0, 8189, '\p{__Title}', "");
    Expect(1, 8189, '\p{^__Title}', "");
    Expect(1, 8189, '\P{__Title}', "");
    Expect(0, 8189, '\P{^__Title}', "");
    Error('\p{-is_Titlecase:=}');
    Error('\P{-is_Titlecase:=}');
    Expect(1, 8188, '\p{istitlecase}', "");
    Expect(0, 8188, '\p{^istitlecase}', "");
    Expect(0, 8188, '\P{istitlecase}', "");
    Expect(1, 8188, '\P{^istitlecase}', "");
    Expect(0, 8189, '\p{istitlecase}', "");
    Expect(1, 8189, '\p{^istitlecase}', "");
    Expect(1, 8189, '\P{istitlecase}', "");
    Expect(0, 8189, '\P{^istitlecase}', "");
    Expect(1, 8188, '\p{		IS_Titlecase}', "");
    Expect(0, 8188, '\p{^		IS_Titlecase}', "");
    Expect(0, 8188, '\P{		IS_Titlecase}', "");
    Expect(1, 8188, '\P{^		IS_Titlecase}', "");
    Expect(0, 8189, '\p{		IS_Titlecase}', "");
    Expect(1, 8189, '\p{^		IS_Titlecase}', "");
    Expect(1, 8189, '\P{		IS_Titlecase}', "");
    Expect(0, 8189, '\P{^		IS_Titlecase}', "");
    Error('\p{-	Is_title:=}');
    Error('\P{-	Is_title:=}');
    Expect(1, 8188, '\p{istitle}', "");
    Expect(0, 8188, '\p{^istitle}', "");
    Expect(0, 8188, '\P{istitle}', "");
    Expect(1, 8188, '\P{^istitle}', "");
    Expect(0, 8189, '\p{istitle}', "");
    Expect(1, 8189, '\p{^istitle}', "");
    Expect(1, 8189, '\P{istitle}', "");
    Expect(0, 8189, '\P{^istitle}', "");
    Expect(1, 8188, '\p{-Is_TITLE}', "");
    Expect(0, 8188, '\p{^-Is_TITLE}', "");
    Expect(0, 8188, '\P{-Is_TITLE}', "");
    Expect(1, 8188, '\P{^-Is_TITLE}', "");
    Expect(0, 8189, '\p{-Is_TITLE}', "");
    Expect(1, 8189, '\p{^-Is_TITLE}', "");
    Expect(1, 8189, '\P{-Is_TITLE}', "");
    Expect(0, 8189, '\P{^-Is_TITLE}', "");
    Error('\p{:= Titlecase_letter}');
    Error('\P{:= Titlecase_letter}');
    Expect(1, 8188, '\p{titlecaseletter}', "");
    Expect(0, 8188, '\p{^titlecaseletter}', "");
    Expect(0, 8188, '\P{titlecaseletter}', "");
    Expect(1, 8188, '\P{^titlecaseletter}', "");
    Expect(0, 8189, '\p{titlecaseletter}', "");
    Expect(1, 8189, '\p{^titlecaseletter}', "");
    Expect(1, 8189, '\P{titlecaseletter}', "");
    Expect(0, 8189, '\P{^titlecaseletter}', "");
    Expect(1, 8188, '\p{	_Titlecase_letter}', "");
    Expect(0, 8188, '\p{^	_Titlecase_letter}', "");
    Expect(0, 8188, '\P{	_Titlecase_letter}', "");
    Expect(1, 8188, '\P{^	_Titlecase_letter}', "");
    Expect(0, 8189, '\p{	_Titlecase_letter}', "");
    Expect(1, 8189, '\p{^	_Titlecase_letter}', "");
    Expect(1, 8189, '\P{	_Titlecase_letter}', "");
    Expect(0, 8189, '\P{^	_Titlecase_letter}', "");
    Error('\p{/a/_Is_Titlecase_letter}');
    Error('\P{/a/_Is_Titlecase_letter}');
    Expect(1, 8188, '\p{istitlecaseletter}', "");
    Expect(0, 8188, '\p{^istitlecaseletter}', "");
    Expect(0, 8188, '\P{istitlecaseletter}', "");
    Expect(1, 8188, '\P{^istitlecaseletter}', "");
    Expect(0, 8189, '\p{istitlecaseletter}', "");
    Expect(1, 8189, '\p{^istitlecaseletter}', "");
    Expect(1, 8189, '\P{istitlecaseletter}', "");
    Expect(0, 8189, '\P{^istitlecaseletter}', "");
    Expect(1, 8188, '\p{__Is_titlecase_Letter}', "");
    Expect(0, 8188, '\p{^__Is_titlecase_Letter}', "");
    Expect(0, 8188, '\P{__Is_titlecase_Letter}', "");
    Expect(1, 8188, '\P{^__Is_titlecase_Letter}', "");
    Expect(0, 8189, '\p{__Is_titlecase_Letter}', "");
    Expect(1, 8189, '\p{^__Is_titlecase_Letter}', "");
    Expect(1, 8189, '\P{__Is_titlecase_Letter}', "");
    Expect(0, 8189, '\P{^__Is_titlecase_Letter}', "");
    Error('\p{ Lt:=}');
    Error('\P{ Lt:=}');
    Expect(1, 8188, '\p{lt}', "");
    Expect(0, 8188, '\p{^lt}', "");
    Expect(0, 8188, '\P{lt}', "");
    Expect(1, 8188, '\P{^lt}', "");
    Expect(0, 8189, '\p{lt}', "");
    Expect(1, 8189, '\p{^lt}', "");
    Expect(1, 8189, '\P{lt}', "");
    Expect(0, 8189, '\P{^lt}', "");
    Expect(1, 8188, '\p{ 	lt}', "");
    Expect(0, 8188, '\p{^ 	lt}', "");
    Expect(0, 8188, '\P{ 	lt}', "");
    Expect(1, 8188, '\P{^ 	lt}', "");
    Expect(0, 8189, '\p{ 	lt}', "");
    Expect(1, 8189, '\p{^ 	lt}', "");
    Expect(1, 8189, '\P{ 	lt}', "");
    Expect(0, 8189, '\P{^ 	lt}', "");
    Error('\p{/a/Is_LT}');
    Error('\P{/a/Is_LT}');
    Expect(1, 8188, '\p{islt}', "");
    Expect(0, 8188, '\p{^islt}', "");
    Expect(0, 8188, '\P{islt}', "");
    Expect(1, 8188, '\P{^islt}', "");
    Expect(0, 8189, '\p{islt}', "");
    Expect(1, 8189, '\p{^islt}', "");
    Expect(1, 8189, '\P{islt}', "");
    Expect(0, 8189, '\P{^islt}', "");
    Expect(1, 8188, '\p{	Is_Lt}', "");
    Expect(0, 8188, '\p{^	Is_Lt}', "");
    Expect(0, 8188, '\P{	Is_Lt}', "");
    Expect(1, 8188, '\P{^	Is_Lt}', "");
    Expect(0, 8189, '\p{	Is_Lt}', "");
    Expect(1, 8189, '\p{^	Is_Lt}', "");
    Expect(1, 8189, '\P{	Is_Lt}', "");
    Expect(0, 8189, '\P{^	Is_Lt}', "");
    Error('\p{/a/_	TRANSPORT_And_map_symbols}');
    Error('\P{/a/_	TRANSPORT_And_map_symbols}');
    Expect(1, 128767, '\p{transportandmapsymbols}', "");
    Expect(0, 128767, '\p{^transportandmapsymbols}', "");
    Expect(0, 128767, '\P{transportandmapsymbols}', "");
    Expect(1, 128767, '\P{^transportandmapsymbols}', "");
    Expect(0, 128768, '\p{transportandmapsymbols}', "");
    Expect(1, 128768, '\p{^transportandmapsymbols}', "");
    Expect(1, 128768, '\P{transportandmapsymbols}', "");
    Expect(0, 128768, '\P{^transportandmapsymbols}', "");
    Expect(1, 128767, '\p{_	Transport_and_Map_Symbols}', "");
    Expect(0, 128767, '\p{^_	Transport_and_Map_Symbols}', "");
    Expect(0, 128767, '\P{_	Transport_and_Map_Symbols}', "");
    Expect(1, 128767, '\P{^_	Transport_and_Map_Symbols}', "");
    Expect(0, 128768, '\p{_	Transport_and_Map_Symbols}', "");
    Expect(1, 128768, '\p{^_	Transport_and_Map_Symbols}', "");
    Expect(1, 128768, '\P{_	Transport_and_Map_Symbols}', "");
    Expect(0, 128768, '\P{^_	Transport_and_Map_Symbols}', "");
    Error('\p{/a/IS_TRANSPORT_AND_Map_Symbols}');
    Error('\P{/a/IS_TRANSPORT_AND_Map_Symbols}');
    Expect(1, 128767, '\p{istransportandmapsymbols}', "");
    Expect(0, 128767, '\p{^istransportandmapsymbols}', "");
    Expect(0, 128767, '\P{istransportandmapsymbols}', "");
    Expect(1, 128767, '\P{^istransportandmapsymbols}', "");
    Expect(0, 128768, '\p{istransportandmapsymbols}', "");
    Expect(1, 128768, '\p{^istransportandmapsymbols}', "");
    Expect(1, 128768, '\P{istransportandmapsymbols}', "");
    Expect(0, 128768, '\P{^istransportandmapsymbols}', "");
    Expect(1, 128767, '\p{IS_Transport_And_Map_SYMBOLS}', "");
    Expect(0, 128767, '\p{^IS_Transport_And_Map_SYMBOLS}', "");
    Expect(0, 128767, '\P{IS_Transport_And_Map_SYMBOLS}', "");
    Expect(1, 128767, '\P{^IS_Transport_And_Map_SYMBOLS}', "");
    Expect(0, 128768, '\p{IS_Transport_And_Map_SYMBOLS}', "");
    Expect(1, 128768, '\p{^IS_Transport_And_Map_SYMBOLS}', "");
    Expect(1, 128768, '\P{IS_Transport_And_Map_SYMBOLS}', "");
    Expect(0, 128768, '\P{^IS_Transport_And_Map_SYMBOLS}', "");
    Error('\p{/a/	_in_Transport_and_map_SYMBOLS}');
    Error('\P{/a/	_in_Transport_and_map_SYMBOLS}');
    Expect(1, 128767, '\p{intransportandmapsymbols}', "");
    Expect(0, 128767, '\p{^intransportandmapsymbols}', "");
    Expect(0, 128767, '\P{intransportandmapsymbols}', "");
    Expect(1, 128767, '\P{^intransportandmapsymbols}', "");
    Expect(0, 128768, '\p{intransportandmapsymbols}', "");
    Expect(1, 128768, '\p{^intransportandmapsymbols}', "");
    Expect(1, 128768, '\P{intransportandmapsymbols}', "");
    Expect(0, 128768, '\P{^intransportandmapsymbols}', "");
    Expect(1, 128767, '\p{ In_transport_AND_Map_symbols}', "");
    Expect(0, 128767, '\p{^ In_transport_AND_Map_symbols}', "");
    Expect(0, 128767, '\P{ In_transport_AND_Map_symbols}', "");
    Expect(1, 128767, '\P{^ In_transport_AND_Map_symbols}', "");
    Expect(0, 128768, '\p{ In_transport_AND_Map_symbols}', "");
    Expect(1, 128768, '\p{^ In_transport_AND_Map_symbols}', "");
    Expect(1, 128768, '\P{ In_transport_AND_Map_symbols}', "");
    Expect(0, 128768, '\P{^ In_transport_AND_Map_symbols}', "");
    Error('\p{-Transport_And_Map/a/}');
    Error('\P{-Transport_And_Map/a/}');
    Expect(1, 128767, '\p{transportandmap}', "");
    Expect(0, 128767, '\p{^transportandmap}', "");
    Expect(0, 128767, '\P{transportandmap}', "");
    Expect(1, 128767, '\P{^transportandmap}', "");
    Expect(0, 128768, '\p{transportandmap}', "");
    Expect(1, 128768, '\p{^transportandmap}', "");
    Expect(1, 128768, '\P{transportandmap}', "");
    Expect(0, 128768, '\P{^transportandmap}', "");
    Expect(1, 128767, '\p{Transport_And_map}', "");
    Expect(0, 128767, '\p{^Transport_And_map}', "");
    Expect(0, 128767, '\P{Transport_And_map}', "");
    Expect(1, 128767, '\P{^Transport_And_map}', "");
    Expect(0, 128768, '\p{Transport_And_map}', "");
    Expect(1, 128768, '\p{^Transport_And_map}', "");
    Expect(1, 128768, '\P{Transport_And_map}', "");
    Expect(0, 128768, '\P{^Transport_And_map}', "");
    Error('\p{/a/_-is_Transport_and_MAP}');
    Error('\P{/a/_-is_Transport_and_MAP}');
    Expect(1, 128767, '\p{istransportandmap}', "");
    Expect(0, 128767, '\p{^istransportandmap}', "");
    Expect(0, 128767, '\P{istransportandmap}', "");
    Expect(1, 128767, '\P{^istransportandmap}', "");
    Expect(0, 128768, '\p{istransportandmap}', "");
    Expect(1, 128768, '\p{^istransportandmap}', "");
    Expect(1, 128768, '\P{istransportandmap}', "");
    Expect(0, 128768, '\P{^istransportandmap}', "");
    Expect(1, 128767, '\p{ -is_transport_and_MAP}', "");
    Expect(0, 128767, '\p{^ -is_transport_and_MAP}', "");
    Expect(0, 128767, '\P{ -is_transport_and_MAP}', "");
    Expect(1, 128767, '\P{^ -is_transport_and_MAP}', "");
    Expect(0, 128768, '\p{ -is_transport_and_MAP}', "");
    Expect(1, 128768, '\p{^ -is_transport_and_MAP}', "");
    Expect(1, 128768, '\P{ -is_transport_and_MAP}', "");
    Expect(0, 128768, '\P{^ -is_transport_and_MAP}', "");
    Error('\p{	/a/In_TRANSPORT_and_MAP}');
    Error('\P{	/a/In_TRANSPORT_and_MAP}');
    Expect(1, 128767, '\p{intransportandmap}', "");
    Expect(0, 128767, '\p{^intransportandmap}', "");
    Expect(0, 128767, '\P{intransportandmap}', "");
    Expect(1, 128767, '\P{^intransportandmap}', "");
    Expect(0, 128768, '\p{intransportandmap}', "");
    Expect(1, 128768, '\p{^intransportandmap}', "");
    Expect(1, 128768, '\P{intransportandmap}', "");
    Expect(0, 128768, '\P{^intransportandmap}', "");
    Expect(1, 128767, '\p{-	IN_Transport_And_map}', "");
    Expect(0, 128767, '\p{^-	IN_Transport_And_map}', "");
    Expect(0, 128767, '\P{-	IN_Transport_And_map}', "");
    Expect(1, 128767, '\P{^-	IN_Transport_And_map}', "");
    Expect(0, 128768, '\p{-	IN_Transport_And_map}', "");
    Expect(1, 128768, '\p{^-	IN_Transport_And_map}', "");
    Expect(1, 128768, '\P{-	IN_Transport_And_map}', "");
    Expect(0, 128768, '\P{^-	IN_Transport_And_map}', "");
    Error('\p{-:=ugaritic}');
    Error('\P{-:=ugaritic}');
    Expect(1, 66463, '\p{ugaritic}', "");
    Expect(0, 66463, '\p{^ugaritic}', "");
    Expect(0, 66463, '\P{ugaritic}', "");
    Expect(1, 66463, '\P{^ugaritic}', "");
    Expect(0, 66464, '\p{ugaritic}', "");
    Expect(1, 66464, '\p{^ugaritic}', "");
    Expect(1, 66464, '\P{ugaritic}', "");
    Expect(0, 66464, '\P{^ugaritic}', "");
    Expect(1, 66463, '\p{_	ugaritic}', "");
    Expect(0, 66463, '\p{^_	ugaritic}', "");
    Expect(0, 66463, '\P{_	ugaritic}', "");
    Expect(1, 66463, '\P{^_	ugaritic}', "");
    Expect(0, 66464, '\p{_	ugaritic}', "");
    Expect(1, 66464, '\p{^_	ugaritic}', "");
    Expect(1, 66464, '\P{_	ugaritic}', "");
    Expect(0, 66464, '\P{^_	ugaritic}', "");
    Error('\p{/a/- Is_ugaritic}');
    Error('\P{/a/- Is_ugaritic}');
    Expect(1, 66463, '\p{isugaritic}', "");
    Expect(0, 66463, '\p{^isugaritic}', "");
    Expect(0, 66463, '\P{isugaritic}', "");
    Expect(1, 66463, '\P{^isugaritic}', "");
    Expect(0, 66464, '\p{isugaritic}', "");
    Expect(1, 66464, '\p{^isugaritic}', "");
    Expect(1, 66464, '\P{isugaritic}', "");
    Expect(0, 66464, '\P{^isugaritic}', "");
    Expect(1, 66463, '\p{_	Is_Ugaritic}', "");
    Expect(0, 66463, '\p{^_	Is_Ugaritic}', "");
    Expect(0, 66463, '\P{_	Is_Ugaritic}', "");
    Expect(1, 66463, '\P{^_	Is_Ugaritic}', "");
    Expect(0, 66464, '\p{_	Is_Ugaritic}', "");
    Expect(1, 66464, '\p{^_	Is_Ugaritic}', "");
    Expect(1, 66464, '\P{_	Is_Ugaritic}', "");
    Expect(0, 66464, '\P{^_	Is_Ugaritic}', "");
    Error('\p{ Ugar/a/}');
    Error('\P{ Ugar/a/}');
    Expect(1, 66463, '\p{ugar}', "");
    Expect(0, 66463, '\p{^ugar}', "");
    Expect(0, 66463, '\P{ugar}', "");
    Expect(1, 66463, '\P{^ugar}', "");
    Expect(0, 66464, '\p{ugar}', "");
    Expect(1, 66464, '\p{^ugar}', "");
    Expect(1, 66464, '\P{ugar}', "");
    Expect(0, 66464, '\P{^ugar}', "");
    Expect(1, 66463, '\p{UGAR}', "");
    Expect(0, 66463, '\p{^UGAR}', "");
    Expect(0, 66463, '\P{UGAR}', "");
    Expect(1, 66463, '\P{^UGAR}', "");
    Expect(0, 66464, '\p{UGAR}', "");
    Expect(1, 66464, '\p{^UGAR}', "");
    Expect(1, 66464, '\P{UGAR}', "");
    Expect(0, 66464, '\P{^UGAR}', "");
    Error('\p{:=	Is_UGAR}');
    Error('\P{:=	Is_UGAR}');
    Expect(1, 66463, '\p{isugar}', "");
    Expect(0, 66463, '\p{^isugar}', "");
    Expect(0, 66463, '\P{isugar}', "");
    Expect(1, 66463, '\P{^isugar}', "");
    Expect(0, 66464, '\p{isugar}', "");
    Expect(1, 66464, '\p{^isugar}', "");
    Expect(1, 66464, '\P{isugar}', "");
    Expect(0, 66464, '\P{^isugar}', "");
    Expect(1, 66463, '\p{--Is_UGAR}', "");
    Expect(0, 66463, '\p{^--Is_UGAR}', "");
    Expect(0, 66463, '\P{--Is_UGAR}', "");
    Expect(1, 66463, '\P{^--Is_UGAR}', "");
    Expect(0, 66464, '\p{--Is_UGAR}', "");
    Expect(1, 66464, '\p{^--Is_UGAR}', "");
    Expect(1, 66464, '\P{--Is_UGAR}', "");
    Expect(0, 66464, '\P{^--Is_UGAR}', "");
    Error('\p{/a/- UNASSIGNED}');
    Error('\P{/a/- UNASSIGNED}');
    Expect(1, 918000, '\p{unassigned}', "");
    Expect(0, 918000, '\p{^unassigned}', "");
    Expect(0, 918000, '\P{unassigned}', "");
    Expect(1, 918000, '\P{^unassigned}', "");
    Expect(0, 1114109, '\p{unassigned}', "");
    Expect(1, 1114109, '\p{^unassigned}', "");
    Expect(1, 1114109, '\P{unassigned}', "");
    Expect(0, 1114109, '\P{^unassigned}', "");
    Expect(1, 918000, '\p{- Unassigned}', "");
    Expect(0, 918000, '\p{^- Unassigned}', "");
    Expect(0, 918000, '\P{- Unassigned}', "");
    Expect(1, 918000, '\P{^- Unassigned}', "");
    Expect(0, 1114109, '\p{- Unassigned}', "");
    Expect(1, 1114109, '\p{^- Unassigned}', "");
    Expect(1, 1114109, '\P{- Unassigned}', "");
    Expect(0, 1114109, '\P{^- Unassigned}', "");
    Error('\p{/a/Is_UNASSIGNED}');
    Error('\P{/a/Is_UNASSIGNED}');
    Expect(1, 918000, '\p{isunassigned}', "");
    Expect(0, 918000, '\p{^isunassigned}', "");
    Expect(0, 918000, '\P{isunassigned}', "");
    Expect(1, 918000, '\P{^isunassigned}', "");
    Expect(0, 1114109, '\p{isunassigned}', "");
    Expect(1, 1114109, '\p{^isunassigned}', "");
    Expect(1, 1114109, '\P{isunassigned}', "");
    Expect(0, 1114109, '\P{^isunassigned}', "");
    Expect(1, 918000, '\p{		Is_Unassigned}', "");
    Expect(0, 918000, '\p{^		Is_Unassigned}', "");
    Expect(0, 918000, '\P{		Is_Unassigned}', "");
    Expect(1, 918000, '\P{^		Is_Unassigned}', "");
    Expect(0, 1114109, '\p{		Is_Unassigned}', "");
    Expect(1, 1114109, '\p{^		Is_Unassigned}', "");
    Expect(1, 1114109, '\P{		Is_Unassigned}', "");
    Expect(0, 1114109, '\P{^		Is_Unassigned}', "");
    Error('\p{ /a/Cn}');
    Error('\P{ /a/Cn}');
    Expect(1, 918000, '\p{cn}', "");
    Expect(0, 918000, '\p{^cn}', "");
    Expect(0, 918000, '\P{cn}', "");
    Expect(1, 918000, '\P{^cn}', "");
    Expect(0, 1114109, '\p{cn}', "");
    Expect(1, 1114109, '\p{^cn}', "");
    Expect(1, 1114109, '\P{cn}', "");
    Expect(0, 1114109, '\P{^cn}', "");
    Expect(1, 918000, '\p{ -Cn}', "");
    Expect(0, 918000, '\p{^ -Cn}', "");
    Expect(0, 918000, '\P{ -Cn}', "");
    Expect(1, 918000, '\P{^ -Cn}', "");
    Expect(0, 1114109, '\p{ -Cn}', "");
    Expect(1, 1114109, '\p{^ -Cn}', "");
    Expect(1, 1114109, '\P{ -Cn}', "");
    Expect(0, 1114109, '\P{^ -Cn}', "");
    Error('\p{:=Is_Cn}');
    Error('\P{:=Is_Cn}');
    Expect(1, 918000, '\p{iscn}', "");
    Expect(0, 918000, '\p{^iscn}', "");
    Expect(0, 918000, '\P{iscn}', "");
    Expect(1, 918000, '\P{^iscn}', "");
    Expect(0, 1114109, '\p{iscn}', "");
    Expect(1, 1114109, '\p{^iscn}', "");
    Expect(1, 1114109, '\P{iscn}', "");
    Expect(0, 1114109, '\P{^iscn}', "");
    Expect(1, 918000, '\p{Is_CN}', "");
    Expect(0, 918000, '\p{^Is_CN}', "");
    Expect(0, 918000, '\P{Is_CN}', "");
    Expect(1, 918000, '\P{^Is_CN}', "");
    Expect(0, 1114109, '\p{Is_CN}', "");
    Expect(1, 1114109, '\p{^Is_CN}', "");
    Expect(1, 1114109, '\P{Is_CN}', "");
    Expect(0, 1114109, '\P{^Is_CN}', "");
    Error('\p{:=_	unified_canadian_aboriginal_Syllabics}');
    Error('\P{:=_	unified_canadian_aboriginal_Syllabics}');
    Expect(1, 5759, '\p{unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\p{^unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\P{unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\P{^unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\p{unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\p{^unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\P{unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\P{^unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\p{--unified_Canadian_aboriginal_SYLLABICS}', "");
    Expect(0, 5759, '\p{^--unified_Canadian_aboriginal_SYLLABICS}', "");
    Expect(0, 5759, '\P{--unified_Canadian_aboriginal_SYLLABICS}', "");
    Expect(1, 5759, '\P{^--unified_Canadian_aboriginal_SYLLABICS}', "");
    Expect(0, 5760, '\p{--unified_Canadian_aboriginal_SYLLABICS}', "");
    Expect(1, 5760, '\p{^--unified_Canadian_aboriginal_SYLLABICS}', "");
    Expect(1, 5760, '\P{--unified_Canadian_aboriginal_SYLLABICS}', "");
    Expect(0, 5760, '\P{^--unified_Canadian_aboriginal_SYLLABICS}', "");
    Error('\p{	/a/is_Unified_canadian_Aboriginal_syllabics}');
    Error('\P{	/a/is_Unified_canadian_Aboriginal_syllabics}');
    Expect(1, 5759, '\p{isunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\p{^isunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\P{isunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\P{^isunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\p{isunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\p{^isunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\P{isunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\P{^isunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\p{_Is_UNIFIED_canadian_Aboriginal_Syllabics}', "");
    Expect(0, 5759, '\p{^_Is_UNIFIED_canadian_Aboriginal_Syllabics}', "");
    Expect(0, 5759, '\P{_Is_UNIFIED_canadian_Aboriginal_Syllabics}', "");
    Expect(1, 5759, '\P{^_Is_UNIFIED_canadian_Aboriginal_Syllabics}', "");
    Expect(0, 5760, '\p{_Is_UNIFIED_canadian_Aboriginal_Syllabics}', "");
    Expect(1, 5760, '\p{^_Is_UNIFIED_canadian_Aboriginal_Syllabics}', "");
    Expect(1, 5760, '\P{_Is_UNIFIED_canadian_Aboriginal_Syllabics}', "");
    Expect(0, 5760, '\P{^_Is_UNIFIED_canadian_Aboriginal_Syllabics}', "");
    Error('\p{:=IN_Unified_CANADIAN_ABORIGINAL_Syllabics}');
    Error('\P{:=IN_Unified_CANADIAN_ABORIGINAL_Syllabics}');
    Expect(1, 5759, '\p{inunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\p{^inunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\P{inunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\P{^inunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\p{inunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\p{^inunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\P{inunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\P{^inunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\p{ IN_UNIFIED_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5759, '\p{^ IN_UNIFIED_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5759, '\P{ IN_UNIFIED_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(1, 5759, '\P{^ IN_UNIFIED_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5760, '\p{ IN_UNIFIED_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(1, 5760, '\p{^ IN_UNIFIED_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(1, 5760, '\P{ IN_UNIFIED_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5760, '\P{^ IN_UNIFIED_Canadian_Aboriginal_SYLLABICS}', "");
    Error('\p{:=UCAS}');
    Error('\P{:=UCAS}');
    Expect(1, 5759, '\p{ucas}', "");
    Expect(0, 5759, '\p{^ucas}', "");
    Expect(0, 5759, '\P{ucas}', "");
    Expect(1, 5759, '\P{^ucas}', "");
    Expect(0, 5760, '\p{ucas}', "");
    Expect(1, 5760, '\p{^ucas}', "");
    Expect(1, 5760, '\P{ucas}', "");
    Expect(0, 5760, '\P{^ucas}', "");
    Expect(1, 5759, '\p{ 	UCAS}', "");
    Expect(0, 5759, '\p{^ 	UCAS}', "");
    Expect(0, 5759, '\P{ 	UCAS}', "");
    Expect(1, 5759, '\P{^ 	UCAS}', "");
    Expect(0, 5760, '\p{ 	UCAS}', "");
    Expect(1, 5760, '\p{^ 	UCAS}', "");
    Expect(1, 5760, '\P{ 	UCAS}', "");
    Expect(0, 5760, '\P{^ 	UCAS}', "");
    Error('\p{	/a/is_UCAS}');
    Error('\P{	/a/is_UCAS}');
    Expect(1, 5759, '\p{isucas}', "");
    Expect(0, 5759, '\p{^isucas}', "");
    Expect(0, 5759, '\P{isucas}', "");
    Expect(1, 5759, '\P{^isucas}', "");
    Expect(0, 5760, '\p{isucas}', "");
    Expect(1, 5760, '\p{^isucas}', "");
    Expect(1, 5760, '\P{isucas}', "");
    Expect(0, 5760, '\P{^isucas}', "");
    Expect(1, 5759, '\p{ IS_UCAS}', "");
    Expect(0, 5759, '\p{^ IS_UCAS}', "");
    Expect(0, 5759, '\P{ IS_UCAS}', "");
    Expect(1, 5759, '\P{^ IS_UCAS}', "");
    Expect(0, 5760, '\p{ IS_UCAS}', "");
    Expect(1, 5760, '\p{^ IS_UCAS}', "");
    Expect(1, 5760, '\P{ IS_UCAS}', "");
    Expect(0, 5760, '\P{^ IS_UCAS}', "");
    Error('\p{/a/in_ucas}');
    Error('\P{/a/in_ucas}');
    Expect(1, 5759, '\p{inucas}', "");
    Expect(0, 5759, '\p{^inucas}', "");
    Expect(0, 5759, '\P{inucas}', "");
    Expect(1, 5759, '\P{^inucas}', "");
    Expect(0, 5760, '\p{inucas}', "");
    Expect(1, 5760, '\p{^inucas}', "");
    Expect(1, 5760, '\P{inucas}', "");
    Expect(0, 5760, '\P{^inucas}', "");
    Expect(1, 5759, '\p{_ in_UCAS}', "");
    Expect(0, 5759, '\p{^_ in_UCAS}', "");
    Expect(0, 5759, '\P{_ in_UCAS}', "");
    Expect(1, 5759, '\P{^_ in_UCAS}', "");
    Expect(0, 5760, '\p{_ in_UCAS}', "");
    Expect(1, 5760, '\p{^_ in_UCAS}', "");
    Expect(1, 5760, '\P{_ in_UCAS}', "");
    Expect(0, 5760, '\P{^_ in_UCAS}', "");
    Error('\p{		CANADIAN_syllabics/a/}');
    Error('\P{		CANADIAN_syllabics/a/}');
    Expect(1, 5759, '\p{canadiansyllabics}', "");
    Expect(0, 5759, '\p{^canadiansyllabics}', "");
    Expect(0, 5759, '\P{canadiansyllabics}', "");
    Expect(1, 5759, '\P{^canadiansyllabics}', "");
    Expect(0, 5760, '\p{canadiansyllabics}', "");
    Expect(1, 5760, '\p{^canadiansyllabics}', "");
    Expect(1, 5760, '\P{canadiansyllabics}', "");
    Expect(0, 5760, '\P{^canadiansyllabics}', "");
    Expect(1, 5759, '\p{- canadian_SYLLABICS}', "");
    Expect(0, 5759, '\p{^- canadian_SYLLABICS}', "");
    Expect(0, 5759, '\P{- canadian_SYLLABICS}', "");
    Expect(1, 5759, '\P{^- canadian_SYLLABICS}', "");
    Expect(0, 5760, '\p{- canadian_SYLLABICS}', "");
    Expect(1, 5760, '\p{^- canadian_SYLLABICS}', "");
    Expect(1, 5760, '\P{- canadian_SYLLABICS}', "");
    Expect(0, 5760, '\P{^- canadian_SYLLABICS}', "");
    Error('\p{ :=Is_Canadian_Syllabics}');
    Error('\P{ :=Is_Canadian_Syllabics}');
    Expect(1, 5759, '\p{iscanadiansyllabics}', "");
    Expect(0, 5759, '\p{^iscanadiansyllabics}', "");
    Expect(0, 5759, '\P{iscanadiansyllabics}', "");
    Expect(1, 5759, '\P{^iscanadiansyllabics}', "");
    Expect(0, 5760, '\p{iscanadiansyllabics}', "");
    Expect(1, 5760, '\p{^iscanadiansyllabics}', "");
    Expect(1, 5760, '\P{iscanadiansyllabics}', "");
    Expect(0, 5760, '\P{^iscanadiansyllabics}', "");
    Expect(1, 5759, '\p{	Is_Canadian_Syllabics}', "");
    Expect(0, 5759, '\p{^	Is_Canadian_Syllabics}', "");
    Expect(0, 5759, '\P{	Is_Canadian_Syllabics}', "");
    Expect(1, 5759, '\P{^	Is_Canadian_Syllabics}', "");
    Expect(0, 5760, '\p{	Is_Canadian_Syllabics}', "");
    Expect(1, 5760, '\p{^	Is_Canadian_Syllabics}', "");
    Expect(1, 5760, '\P{	Is_Canadian_Syllabics}', "");
    Expect(0, 5760, '\P{^	Is_Canadian_Syllabics}', "");
    Error('\p{ in_canadian_Syllabics:=}');
    Error('\P{ in_canadian_Syllabics:=}');
    Expect(1, 5759, '\p{incanadiansyllabics}', "");
    Expect(0, 5759, '\p{^incanadiansyllabics}', "");
    Expect(0, 5759, '\P{incanadiansyllabics}', "");
    Expect(1, 5759, '\P{^incanadiansyllabics}', "");
    Expect(0, 5760, '\p{incanadiansyllabics}', "");
    Expect(1, 5760, '\p{^incanadiansyllabics}', "");
    Expect(1, 5760, '\P{incanadiansyllabics}', "");
    Expect(0, 5760, '\P{^incanadiansyllabics}', "");
    Expect(1, 5759, '\p{ in_Canadian_syllabics}', "");
    Expect(0, 5759, '\p{^ in_Canadian_syllabics}', "");
    Expect(0, 5759, '\P{ in_Canadian_syllabics}', "");
    Expect(1, 5759, '\P{^ in_Canadian_syllabics}', "");
    Expect(0, 5760, '\p{ in_Canadian_syllabics}', "");
    Expect(1, 5760, '\p{^ in_Canadian_syllabics}', "");
    Expect(1, 5760, '\P{ in_Canadian_syllabics}', "");
    Expect(0, 5760, '\P{^ in_Canadian_syllabics}', "");
    Error('\p{-/a/UNIFIED_Canadian_aboriginal_Syllabics_Extended}');
    Error('\P{-/a/UNIFIED_Canadian_aboriginal_Syllabics_Extended}');
    Expect(1, 6399, '\p{unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\p{^unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\P{unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\P{^unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\p{unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\p{^unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\P{unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\P{^unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\p{unified_Canadian_aboriginal_SYLLABICS_Extended}', "");
    Expect(0, 6399, '\p{^unified_Canadian_aboriginal_SYLLABICS_Extended}', "");
    Expect(0, 6399, '\P{unified_Canadian_aboriginal_SYLLABICS_Extended}', "");
    Expect(1, 6399, '\P{^unified_Canadian_aboriginal_SYLLABICS_Extended}', "");
    Expect(0, 6400, '\p{unified_Canadian_aboriginal_SYLLABICS_Extended}', "");
    Expect(1, 6400, '\p{^unified_Canadian_aboriginal_SYLLABICS_Extended}', "");
    Expect(1, 6400, '\P{unified_Canadian_aboriginal_SYLLABICS_Extended}', "");
    Expect(0, 6400, '\P{^unified_Canadian_aboriginal_SYLLABICS_Extended}', "");
    Error('\p{	is_Unified_Canadian_ABORIGINAL_Syllabics_extended/a/}');
    Error('\P{	is_Unified_Canadian_ABORIGINAL_Syllabics_extended/a/}');
    Expect(1, 6399, '\p{isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\p{^isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\P{isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\P{^isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\p{isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\p{^isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\P{isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\P{^isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\p{_	Is_Unified_CANADIAN_Aboriginal_SYLLABICS_Extended}', "");
    Expect(0, 6399, '\p{^_	Is_Unified_CANADIAN_Aboriginal_SYLLABICS_Extended}', "");
    Expect(0, 6399, '\P{_	Is_Unified_CANADIAN_Aboriginal_SYLLABICS_Extended}', "");
    Expect(1, 6399, '\P{^_	Is_Unified_CANADIAN_Aboriginal_SYLLABICS_Extended}', "");
    Expect(0, 6400, '\p{_	Is_Unified_CANADIAN_Aboriginal_SYLLABICS_Extended}', "");
    Expect(1, 6400, '\p{^_	Is_Unified_CANADIAN_Aboriginal_SYLLABICS_Extended}', "");
    Expect(1, 6400, '\P{_	Is_Unified_CANADIAN_Aboriginal_SYLLABICS_Extended}', "");
    Expect(0, 6400, '\P{^_	Is_Unified_CANADIAN_Aboriginal_SYLLABICS_Extended}', "");
    Error('\p{- in_Unified_Canadian_aboriginal_SYLLABICS_EXTENDED/a/}');
    Error('\P{- in_Unified_Canadian_aboriginal_SYLLABICS_EXTENDED/a/}');
    Expect(1, 6399, '\p{inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\p{^inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\P{inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\P{^inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\p{inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\p{^inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\P{inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\P{^inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\p{	In_UNIFIED_Canadian_Aboriginal_Syllabics_Extended}', "");
    Expect(0, 6399, '\p{^	In_UNIFIED_Canadian_Aboriginal_Syllabics_Extended}', "");
    Expect(0, 6399, '\P{	In_UNIFIED_Canadian_Aboriginal_Syllabics_Extended}', "");
    Expect(1, 6399, '\P{^	In_UNIFIED_Canadian_Aboriginal_Syllabics_Extended}', "");
    Expect(0, 6400, '\p{	In_UNIFIED_Canadian_Aboriginal_Syllabics_Extended}', "");
    Expect(1, 6400, '\p{^	In_UNIFIED_Canadian_Aboriginal_Syllabics_Extended}', "");
    Expect(1, 6400, '\P{	In_UNIFIED_Canadian_Aboriginal_Syllabics_Extended}', "");
    Expect(0, 6400, '\P{^	In_UNIFIED_Canadian_Aboriginal_Syllabics_Extended}', "");
    Error('\p{:= -UCAS_EXT}');
    Error('\P{:= -UCAS_EXT}');
    Expect(1, 6399, '\p{ucasext}', "");
    Expect(0, 6399, '\p{^ucasext}', "");
    Expect(0, 6399, '\P{ucasext}', "");
    Expect(1, 6399, '\P{^ucasext}', "");
    Expect(0, 6400, '\p{ucasext}', "");
    Expect(1, 6400, '\p{^ucasext}', "");
    Expect(1, 6400, '\P{ucasext}', "");
    Expect(0, 6400, '\P{^ucasext}', "");
    Expect(1, 6399, '\p{ UCAS_Ext}', "");
    Expect(0, 6399, '\p{^ UCAS_Ext}', "");
    Expect(0, 6399, '\P{ UCAS_Ext}', "");
    Expect(1, 6399, '\P{^ UCAS_Ext}', "");
    Expect(0, 6400, '\p{ UCAS_Ext}', "");
    Expect(1, 6400, '\p{^ UCAS_Ext}', "");
    Expect(1, 6400, '\P{ UCAS_Ext}', "");
    Expect(0, 6400, '\P{^ UCAS_Ext}', "");
    Error('\p{IS_UCAS_Ext/a/}');
    Error('\P{IS_UCAS_Ext/a/}');
    Expect(1, 6399, '\p{isucasext}', "");
    Expect(0, 6399, '\p{^isucasext}', "");
    Expect(0, 6399, '\P{isucasext}', "");
    Expect(1, 6399, '\P{^isucasext}', "");
    Expect(0, 6400, '\p{isucasext}', "");
    Expect(1, 6400, '\p{^isucasext}', "");
    Expect(1, 6400, '\P{isucasext}', "");
    Expect(0, 6400, '\P{^isucasext}', "");
    Expect(1, 6399, '\p{ IS_UCAS_Ext}', "");
    Expect(0, 6399, '\p{^ IS_UCAS_Ext}', "");
    Expect(0, 6399, '\P{ IS_UCAS_Ext}', "");
    Expect(1, 6399, '\P{^ IS_UCAS_Ext}', "");
    Expect(0, 6400, '\p{ IS_UCAS_Ext}', "");
    Expect(1, 6400, '\p{^ IS_UCAS_Ext}', "");
    Expect(1, 6400, '\P{ IS_UCAS_Ext}', "");
    Expect(0, 6400, '\P{^ IS_UCAS_Ext}', "");
    Error('\p{-/a/in_ucas_Ext}');
    Error('\P{-/a/in_ucas_Ext}');
    Expect(1, 6399, '\p{inucasext}', "");
    Expect(0, 6399, '\p{^inucasext}', "");
    Expect(0, 6399, '\P{inucasext}', "");
    Expect(1, 6399, '\P{^inucasext}', "");
    Expect(0, 6400, '\p{inucasext}', "");
    Expect(1, 6400, '\p{^inucasext}', "");
    Expect(1, 6400, '\P{inucasext}', "");
    Expect(0, 6400, '\P{^inucasext}', "");
    Expect(1, 6399, '\p{_In_UCAS_Ext}', "");
    Expect(0, 6399, '\p{^_In_UCAS_Ext}', "");
    Expect(0, 6399, '\P{_In_UCAS_Ext}', "");
    Expect(1, 6399, '\P{^_In_UCAS_Ext}', "");
    Expect(0, 6400, '\p{_In_UCAS_Ext}', "");
    Expect(1, 6400, '\p{^_In_UCAS_Ext}', "");
    Expect(1, 6400, '\P{_In_UCAS_Ext}', "");
    Expect(0, 6400, '\P{^_In_UCAS_Ext}', "");
    Error('\p{	/a/Unified_IDEOGRAPH}');
    Error('\P{	/a/Unified_IDEOGRAPH}');
    Expect(1, 191456, '\p{unifiedideograph}', "");
    Expect(0, 191456, '\p{^unifiedideograph}', "");
    Expect(0, 191456, '\P{unifiedideograph}', "");
    Expect(1, 191456, '\P{^unifiedideograph}', "");
    Expect(0, 191457, '\p{unifiedideograph}', "");
    Expect(1, 191457, '\p{^unifiedideograph}', "");
    Expect(1, 191457, '\P{unifiedideograph}', "");
    Expect(0, 191457, '\P{^unifiedideograph}', "");
    Expect(1, 191456, '\p{-unified_Ideograph}', "");
    Expect(0, 191456, '\p{^-unified_Ideograph}', "");
    Expect(0, 191456, '\P{-unified_Ideograph}', "");
    Expect(1, 191456, '\P{^-unified_Ideograph}', "");
    Expect(0, 191457, '\p{-unified_Ideograph}', "");
    Expect(1, 191457, '\p{^-unified_Ideograph}', "");
    Expect(1, 191457, '\P{-unified_Ideograph}', "");
    Expect(0, 191457, '\P{^-unified_Ideograph}', "");
    Error('\p{--is_Unified_Ideograph/a/}');
    Error('\P{--is_Unified_Ideograph/a/}');
    Expect(1, 191456, '\p{isunifiedideograph}', "");
    Expect(0, 191456, '\p{^isunifiedideograph}', "");
    Expect(0, 191456, '\P{isunifiedideograph}', "");
    Expect(1, 191456, '\P{^isunifiedideograph}', "");
    Expect(0, 191457, '\p{isunifiedideograph}', "");
    Expect(1, 191457, '\p{^isunifiedideograph}', "");
    Expect(1, 191457, '\P{isunifiedideograph}', "");
    Expect(0, 191457, '\P{^isunifiedideograph}', "");
    Expect(1, 191456, '\p{ -IS_unified_IDEOGRAPH}', "");
    Expect(0, 191456, '\p{^ -IS_unified_IDEOGRAPH}', "");
    Expect(0, 191456, '\P{ -IS_unified_IDEOGRAPH}', "");
    Expect(1, 191456, '\P{^ -IS_unified_IDEOGRAPH}', "");
    Expect(0, 191457, '\p{ -IS_unified_IDEOGRAPH}', "");
    Expect(1, 191457, '\p{^ -IS_unified_IDEOGRAPH}', "");
    Expect(1, 191457, '\P{ -IS_unified_IDEOGRAPH}', "");
    Expect(0, 191457, '\P{^ -IS_unified_IDEOGRAPH}', "");
    Error('\p{:=  uideo}');
    Error('\P{:=  uideo}');
    Expect(1, 191456, '\p{uideo}', "");
    Expect(0, 191456, '\p{^uideo}', "");
    Expect(0, 191456, '\P{uideo}', "");
    Expect(1, 191456, '\P{^uideo}', "");
    Expect(0, 191457, '\p{uideo}', "");
    Expect(1, 191457, '\p{^uideo}', "");
    Expect(1, 191457, '\P{uideo}', "");
    Expect(0, 191457, '\P{^uideo}', "");
    Expect(1, 191456, '\p{	UIdeo}', "");
    Expect(0, 191456, '\p{^	UIdeo}', "");
    Expect(0, 191456, '\P{	UIdeo}', "");
    Expect(1, 191456, '\P{^	UIdeo}', "");
    Expect(0, 191457, '\p{	UIdeo}', "");
    Expect(1, 191457, '\p{^	UIdeo}', "");
    Expect(1, 191457, '\P{	UIdeo}', "");
    Expect(0, 191457, '\P{^	UIdeo}', "");
    Error('\p{:=--is_UIdeo}');
    Error('\P{:=--is_UIdeo}');
    Expect(1, 191456, '\p{isuideo}', "");
    Expect(0, 191456, '\p{^isuideo}', "");
    Expect(0, 191456, '\P{isuideo}', "");
    Expect(1, 191456, '\P{^isuideo}', "");
    Expect(0, 191457, '\p{isuideo}', "");
    Expect(1, 191457, '\p{^isuideo}', "");
    Expect(1, 191457, '\P{isuideo}', "");
    Expect(0, 191457, '\P{^isuideo}', "");
    Expect(1, 191456, '\p{_Is_UIdeo}', "");
    Expect(0, 191456, '\p{^_Is_UIdeo}', "");
    Expect(0, 191456, '\P{_Is_UIdeo}', "");
    Expect(1, 191456, '\P{^_Is_UIdeo}', "");
    Expect(0, 191457, '\p{_Is_UIdeo}', "");
    Expect(1, 191457, '\p{^_Is_UIdeo}', "");
    Expect(1, 191457, '\P{_Is_UIdeo}', "");
    Expect(0, 191457, '\P{^_Is_UIdeo}', "");
    Error('\p{	:=Unknown}');
    Error('\P{	:=Unknown}');
    Expect(1, 918000, '\p{unknown}', "");
    Expect(0, 918000, '\p{^unknown}', "");
    Expect(0, 918000, '\P{unknown}', "");
    Expect(1, 918000, '\P{^unknown}', "");
    Expect(0, 917999, '\p{unknown}', "");
    Expect(1, 917999, '\p{^unknown}', "");
    Expect(1, 917999, '\P{unknown}', "");
    Expect(0, 917999, '\P{^unknown}', "");
    Expect(1, 918000, '\p{	UNKNOWN}', "");
    Expect(0, 918000, '\p{^	UNKNOWN}', "");
    Expect(0, 918000, '\P{	UNKNOWN}', "");
    Expect(1, 918000, '\P{^	UNKNOWN}', "");
    Expect(0, 917999, '\p{	UNKNOWN}', "");
    Expect(1, 917999, '\p{^	UNKNOWN}', "");
    Expect(1, 917999, '\P{	UNKNOWN}', "");
    Expect(0, 917999, '\P{^	UNKNOWN}', "");
    Error('\p{/a/Is_unknown}');
    Error('\P{/a/Is_unknown}');
    Expect(1, 918000, '\p{isunknown}', "");
    Expect(0, 918000, '\p{^isunknown}', "");
    Expect(0, 918000, '\P{isunknown}', "");
    Expect(1, 918000, '\P{^isunknown}', "");
    Expect(0, 917999, '\p{isunknown}', "");
    Expect(1, 917999, '\p{^isunknown}', "");
    Expect(1, 917999, '\P{isunknown}', "");
    Expect(0, 917999, '\P{^isunknown}', "");
    Expect(1, 918000, '\p{ 	is_Unknown}', "");
    Expect(0, 918000, '\p{^ 	is_Unknown}', "");
    Expect(0, 918000, '\P{ 	is_Unknown}', "");
    Expect(1, 918000, '\P{^ 	is_Unknown}', "");
    Expect(0, 917999, '\p{ 	is_Unknown}', "");
    Expect(1, 917999, '\p{^ 	is_Unknown}', "");
    Expect(1, 917999, '\P{ 	is_Unknown}', "");
    Expect(0, 917999, '\P{^ 	is_Unknown}', "");
    Error('\p{:=_Zzzz}');
    Error('\P{:=_Zzzz}');
    Expect(1, 918000, '\p{zzzz}', "");
    Expect(0, 918000, '\p{^zzzz}', "");
    Expect(0, 918000, '\P{zzzz}', "");
    Expect(1, 918000, '\P{^zzzz}', "");
    Expect(0, 917999, '\p{zzzz}', "");
    Expect(1, 917999, '\p{^zzzz}', "");
    Expect(1, 917999, '\P{zzzz}', "");
    Expect(0, 917999, '\P{^zzzz}', "");
    Expect(1, 918000, '\p{_ZZZZ}', "");
    Expect(0, 918000, '\p{^_ZZZZ}', "");
    Expect(0, 918000, '\P{_ZZZZ}', "");
    Expect(1, 918000, '\P{^_ZZZZ}', "");
    Expect(0, 917999, '\p{_ZZZZ}', "");
    Expect(1, 917999, '\p{^_ZZZZ}', "");
    Expect(1, 917999, '\P{_ZZZZ}', "");
    Expect(0, 917999, '\P{^_ZZZZ}', "");
    Error('\p{/a/  is_Zzzz}');
    Error('\P{/a/  is_Zzzz}');
    Expect(1, 918000, '\p{iszzzz}', "");
    Expect(0, 918000, '\p{^iszzzz}', "");
    Expect(0, 918000, '\P{iszzzz}', "");
    Expect(1, 918000, '\P{^iszzzz}', "");
    Expect(0, 917999, '\p{iszzzz}', "");
    Expect(1, 917999, '\p{^iszzzz}', "");
    Expect(1, 917999, '\P{iszzzz}', "");
    Expect(0, 917999, '\P{^iszzzz}', "");
    Expect(1, 918000, '\p{- Is_zzzz}', "");
    Expect(0, 918000, '\p{^- Is_zzzz}', "");
    Expect(0, 918000, '\P{- Is_zzzz}', "");
    Expect(1, 918000, '\P{^- Is_zzzz}', "");
    Expect(0, 917999, '\p{- Is_zzzz}', "");
    Expect(1, 917999, '\p{^- Is_zzzz}', "");
    Expect(1, 917999, '\P{- Is_zzzz}', "");
    Expect(0, 917999, '\P{^- Is_zzzz}', "");
    Error('\p{:=_ UPPERCASE_letter}');
    Error('\P{:=_ UPPERCASE_letter}');
    Expect(1, 125217, '\p{uppercaseletter}', "");
    Expect(0, 125217, '\p{^uppercaseletter}', "");
    Expect(0, 125217, '\P{uppercaseletter}', "");
    Expect(1, 125217, '\P{^uppercaseletter}', "");
    Expect(0, 125218, '\p{uppercaseletter}', "");
    Expect(1, 125218, '\p{^uppercaseletter}', "");
    Expect(1, 125218, '\P{uppercaseletter}', "");
    Expect(0, 125218, '\P{^uppercaseletter}', "");
    Expect(1, 125217, '\p{	 Uppercase_letter}', "");
    Expect(0, 125217, '\p{^	 Uppercase_letter}', "");
    Expect(0, 125217, '\P{	 Uppercase_letter}', "");
    Expect(1, 125217, '\P{^	 Uppercase_letter}', "");
    Expect(0, 125218, '\p{	 Uppercase_letter}', "");
    Expect(1, 125218, '\p{^	 Uppercase_letter}', "");
    Expect(1, 125218, '\P{	 Uppercase_letter}', "");
    Expect(0, 125218, '\P{^	 Uppercase_letter}', "");
    Error('\p{ /a/Is_Uppercase_letter}');
    Error('\P{ /a/Is_Uppercase_letter}');
    Expect(1, 125217, '\p{isuppercaseletter}', "");
    Expect(0, 125217, '\p{^isuppercaseletter}', "");
    Expect(0, 125217, '\P{isuppercaseletter}', "");
    Expect(1, 125217, '\P{^isuppercaseletter}', "");
    Expect(0, 125218, '\p{isuppercaseletter}', "");
    Expect(1, 125218, '\p{^isuppercaseletter}', "");
    Expect(1, 125218, '\P{isuppercaseletter}', "");
    Expect(0, 125218, '\P{^isuppercaseletter}', "");
    Expect(1, 125217, '\p{_is_UPPERCASE_letter}', "");
    Expect(0, 125217, '\p{^_is_UPPERCASE_letter}', "");
    Expect(0, 125217, '\P{_is_UPPERCASE_letter}', "");
    Expect(1, 125217, '\P{^_is_UPPERCASE_letter}', "");
    Expect(0, 125218, '\p{_is_UPPERCASE_letter}', "");
    Expect(1, 125218, '\p{^_is_UPPERCASE_letter}', "");
    Expect(1, 125218, '\P{_is_UPPERCASE_letter}', "");
    Expect(0, 125218, '\P{^_is_UPPERCASE_letter}', "");
    Error('\p{/a/--LU}');
    Error('\P{/a/--LU}');
    Expect(1, 125217, '\p{lu}', "");
    Expect(0, 125217, '\p{^lu}', "");
    Expect(0, 125217, '\P{lu}', "");
    Expect(1, 125217, '\P{^lu}', "");
    Expect(0, 125218, '\p{lu}', "");
    Expect(1, 125218, '\p{^lu}', "");
    Expect(1, 125218, '\P{lu}', "");
    Expect(0, 125218, '\P{^lu}', "");
    Error('\p{-:=IS_lu}');
    Error('\P{-:=IS_lu}');
    Expect(1, 125217, '\p{islu}', "");
    Expect(0, 125217, '\p{^islu}', "");
    Expect(0, 125217, '\P{islu}', "");
    Expect(1, 125217, '\P{^islu}', "");
    Expect(0, 125218, '\p{islu}', "");
    Expect(1, 125218, '\p{^islu}', "");
    Expect(1, 125218, '\P{islu}', "");
    Expect(0, 125218, '\P{^islu}', "");
    Expect(1, 125217, '\p{_-Is_Lu}', "");
    Expect(0, 125217, '\p{^_-Is_Lu}', "");
    Expect(0, 125217, '\P{_-Is_Lu}', "");
    Expect(1, 125217, '\P{^_-Is_Lu}', "");
    Expect(0, 125218, '\p{_-Is_Lu}', "");
    Expect(1, 125218, '\p{^_-Is_Lu}', "");
    Expect(1, 125218, '\P{_-Is_Lu}', "");
    Expect(0, 125218, '\P{^_-Is_Lu}', "");
    Error('\p{_	vai/a/}');
    Error('\P{_	vai/a/}');
    Expect(1, 42539, '\p{vai}', "");
    Expect(0, 42539, '\p{^vai}', "");
    Expect(0, 42539, '\P{vai}', "");
    Expect(1, 42539, '\P{^vai}', "");
    Expect(0, 42540, '\p{vai}', "");
    Expect(1, 42540, '\p{^vai}', "");
    Expect(1, 42540, '\P{vai}', "");
    Expect(0, 42540, '\P{^vai}', "");
    Expect(1, 42539, '\p{	vai}', "");
    Expect(0, 42539, '\p{^	vai}', "");
    Expect(0, 42539, '\P{	vai}', "");
    Expect(1, 42539, '\P{^	vai}', "");
    Expect(0, 42540, '\p{	vai}', "");
    Expect(1, 42540, '\p{^	vai}', "");
    Expect(1, 42540, '\P{	vai}', "");
    Expect(0, 42540, '\P{^	vai}', "");
    Error('\p{:=		Is_Vai}');
    Error('\P{:=		Is_Vai}');
    Expect(1, 42539, '\p{isvai}', "");
    Expect(0, 42539, '\p{^isvai}', "");
    Expect(0, 42539, '\P{isvai}', "");
    Expect(1, 42539, '\P{^isvai}', "");
    Expect(0, 42540, '\p{isvai}', "");
    Expect(1, 42540, '\p{^isvai}', "");
    Expect(1, 42540, '\P{isvai}', "");
    Expect(0, 42540, '\P{^isvai}', "");
    Expect(1, 42539, '\p{_ is_vai}', "");
    Expect(0, 42539, '\p{^_ is_vai}', "");
    Expect(0, 42539, '\P{_ is_vai}', "");
    Expect(1, 42539, '\P{^_ is_vai}', "");
    Expect(0, 42540, '\p{_ is_vai}', "");
    Expect(1, 42540, '\p{^_ is_vai}', "");
    Expect(1, 42540, '\P{_ is_vai}', "");
    Expect(0, 42540, '\P{^_ is_vai}', "");
    Error('\p{:=	Vaii}');
    Error('\P{:=	Vaii}');
    Expect(1, 42539, '\p{vaii}', "");
    Expect(0, 42539, '\p{^vaii}', "");
    Expect(0, 42539, '\P{vaii}', "");
    Expect(1, 42539, '\P{^vaii}', "");
    Expect(0, 42540, '\p{vaii}', "");
    Expect(1, 42540, '\p{^vaii}', "");
    Expect(1, 42540, '\P{vaii}', "");
    Expect(0, 42540, '\P{^vaii}', "");
    Expect(1, 42539, '\p{-_Vaii}', "");
    Expect(0, 42539, '\p{^-_Vaii}', "");
    Expect(0, 42539, '\P{-_Vaii}', "");
    Expect(1, 42539, '\P{^-_Vaii}', "");
    Expect(0, 42540, '\p{-_Vaii}', "");
    Expect(1, 42540, '\p{^-_Vaii}', "");
    Expect(1, 42540, '\P{-_Vaii}', "");
    Expect(0, 42540, '\P{^-_Vaii}', "");
    Error('\p{/a/ 	Is_vaii}');
    Error('\P{/a/ 	Is_vaii}');
    Expect(1, 42539, '\p{isvaii}', "");
    Expect(0, 42539, '\p{^isvaii}', "");
    Expect(0, 42539, '\P{isvaii}', "");
    Expect(1, 42539, '\P{^isvaii}', "");
    Expect(0, 42540, '\p{isvaii}', "");
    Expect(1, 42540, '\p{^isvaii}', "");
    Expect(1, 42540, '\P{isvaii}', "");
    Expect(0, 42540, '\P{^isvaii}', "");
    Expect(1, 42539, '\p{	_Is_vaii}', "");
    Expect(0, 42539, '\p{^	_Is_vaii}', "");
    Expect(0, 42539, '\P{	_Is_vaii}', "");
    Expect(1, 42539, '\P{^	_Is_vaii}', "");
    Expect(0, 42540, '\p{	_Is_vaii}', "");
    Expect(1, 42540, '\p{^	_Is_vaii}', "");
    Expect(1, 42540, '\P{	_Is_vaii}', "");
    Expect(0, 42540, '\P{^	_Is_vaii}', "");
    Error('\p{:=Variation_SELECTOR}');
    Error('\P{:=Variation_SELECTOR}');
    Expect(1, 917999, '\p{variationselector}', "");
    Expect(0, 917999, '\p{^variationselector}', "");
    Expect(0, 917999, '\P{variationselector}', "");
    Expect(1, 917999, '\P{^variationselector}', "");
    Expect(0, 918000, '\p{variationselector}', "");
    Expect(1, 918000, '\p{^variationselector}', "");
    Expect(1, 918000, '\P{variationselector}', "");
    Expect(0, 918000, '\P{^variationselector}', "");
    Expect(1, 917999, '\p{__Variation_Selector}', "");
    Expect(0, 917999, '\p{^__Variation_Selector}', "");
    Expect(0, 917999, '\P{__Variation_Selector}', "");
    Expect(1, 917999, '\P{^__Variation_Selector}', "");
    Expect(0, 918000, '\p{__Variation_Selector}', "");
    Expect(1, 918000, '\p{^__Variation_Selector}', "");
    Expect(1, 918000, '\P{__Variation_Selector}', "");
    Expect(0, 918000, '\P{^__Variation_Selector}', "");
    Error('\p{_Is_variation_Selector:=}');
    Error('\P{_Is_variation_Selector:=}');
    Expect(1, 917999, '\p{isvariationselector}', "");
    Expect(0, 917999, '\p{^isvariationselector}', "");
    Expect(0, 917999, '\P{isvariationselector}', "");
    Expect(1, 917999, '\P{^isvariationselector}', "");
    Expect(0, 918000, '\p{isvariationselector}', "");
    Expect(1, 918000, '\p{^isvariationselector}', "");
    Expect(1, 918000, '\P{isvariationselector}', "");
    Expect(0, 918000, '\P{^isvariationselector}', "");
    Expect(1, 917999, '\p{_	IS_Variation_SELECTOR}', "");
    Expect(0, 917999, '\p{^_	IS_Variation_SELECTOR}', "");
    Expect(0, 917999, '\P{_	IS_Variation_SELECTOR}', "");
    Expect(1, 917999, '\P{^_	IS_Variation_SELECTOR}', "");
    Expect(0, 918000, '\p{_	IS_Variation_SELECTOR}', "");
    Expect(1, 918000, '\p{^_	IS_Variation_SELECTOR}', "");
    Expect(1, 918000, '\P{_	IS_Variation_SELECTOR}', "");
    Expect(0, 918000, '\P{^_	IS_Variation_SELECTOR}', "");
    Error('\p{_ VS:=}');
    Error('\P{_ VS:=}');
    Expect(1, 917999, '\p{vs}', "");
    Expect(0, 917999, '\p{^vs}', "");
    Expect(0, 917999, '\P{vs}', "");
    Expect(1, 917999, '\P{^vs}', "");
    Expect(0, 918000, '\p{vs}', "");
    Expect(1, 918000, '\p{^vs}', "");
    Expect(1, 918000, '\P{vs}', "");
    Expect(0, 918000, '\P{^vs}', "");
    Expect(1, 917999, '\p{ -VS}', "");
    Expect(0, 917999, '\p{^ -VS}', "");
    Expect(0, 917999, '\P{ -VS}', "");
    Expect(1, 917999, '\P{^ -VS}', "");
    Expect(0, 918000, '\p{ -VS}', "");
    Expect(1, 918000, '\p{^ -VS}', "");
    Expect(1, 918000, '\P{ -VS}', "");
    Expect(0, 918000, '\P{^ -VS}', "");
    Error('\p{:=	Is_VS}');
    Error('\P{:=	Is_VS}');
    Expect(1, 917999, '\p{isvs}', "");
    Expect(0, 917999, '\p{^isvs}', "");
    Expect(0, 917999, '\P{isvs}', "");
    Expect(1, 917999, '\P{^isvs}', "");
    Expect(0, 918000, '\p{isvs}', "");
    Expect(1, 918000, '\p{^isvs}', "");
    Expect(1, 918000, '\P{isvs}', "");
    Expect(0, 918000, '\P{^isvs}', "");
    Expect(1, 917999, '\p{	_is_vs}', "");
    Expect(0, 917999, '\p{^	_is_vs}', "");
    Expect(0, 917999, '\P{	_is_vs}', "");
    Expect(1, 917999, '\P{^	_is_vs}', "");
    Expect(0, 918000, '\p{	_is_vs}', "");
    Expect(1, 918000, '\p{^	_is_vs}', "");
    Expect(1, 918000, '\P{	_is_vs}', "");
    Expect(0, 918000, '\P{^	_is_vs}', "");
    Error('\p{ :=variation_selectors}');
    Error('\P{ :=variation_selectors}');
    Expect(1, 65039, '\p{variationselectors}', "");
    Expect(0, 65039, '\p{^variationselectors}', "");
    Expect(0, 65039, '\P{variationselectors}', "");
    Expect(1, 65039, '\P{^variationselectors}', "");
    Expect(0, 65040, '\p{variationselectors}', "");
    Expect(1, 65040, '\p{^variationselectors}', "");
    Expect(1, 65040, '\P{variationselectors}', "");
    Expect(0, 65040, '\P{^variationselectors}', "");
    Expect(1, 65039, '\p{	Variation_Selectors}', "");
    Expect(0, 65039, '\p{^	Variation_Selectors}', "");
    Expect(0, 65039, '\P{	Variation_Selectors}', "");
    Expect(1, 65039, '\P{^	Variation_Selectors}', "");
    Expect(0, 65040, '\p{	Variation_Selectors}', "");
    Expect(1, 65040, '\p{^	Variation_Selectors}', "");
    Expect(1, 65040, '\P{	Variation_Selectors}', "");
    Expect(0, 65040, '\P{^	Variation_Selectors}', "");
    Error('\p{:=_	Is_Variation_Selectors}');
    Error('\P{:=_	Is_Variation_Selectors}');
    Expect(1, 65039, '\p{isvariationselectors}', "");
    Expect(0, 65039, '\p{^isvariationselectors}', "");
    Expect(0, 65039, '\P{isvariationselectors}', "");
    Expect(1, 65039, '\P{^isvariationselectors}', "");
    Expect(0, 65040, '\p{isvariationselectors}', "");
    Expect(1, 65040, '\p{^isvariationselectors}', "");
    Expect(1, 65040, '\P{isvariationselectors}', "");
    Expect(0, 65040, '\P{^isvariationselectors}', "");
    Expect(1, 65039, '\p{-_IS_VARIATION_SELECTORS}', "");
    Expect(0, 65039, '\p{^-_IS_VARIATION_SELECTORS}', "");
    Expect(0, 65039, '\P{-_IS_VARIATION_SELECTORS}', "");
    Expect(1, 65039, '\P{^-_IS_VARIATION_SELECTORS}', "");
    Expect(0, 65040, '\p{-_IS_VARIATION_SELECTORS}', "");
    Expect(1, 65040, '\p{^-_IS_VARIATION_SELECTORS}', "");
    Expect(1, 65040, '\P{-_IS_VARIATION_SELECTORS}', "");
    Expect(0, 65040, '\P{^-_IS_VARIATION_SELECTORS}', "");
    Error('\p{/a/In_Variation_Selectors}');
    Error('\P{/a/In_Variation_Selectors}');
    Expect(1, 65039, '\p{invariationselectors}', "");
    Expect(0, 65039, '\p{^invariationselectors}', "");
    Expect(0, 65039, '\P{invariationselectors}', "");
    Expect(1, 65039, '\P{^invariationselectors}', "");
    Expect(0, 65040, '\p{invariationselectors}', "");
    Expect(1, 65040, '\p{^invariationselectors}', "");
    Expect(1, 65040, '\P{invariationselectors}', "");
    Expect(0, 65040, '\P{^invariationselectors}', "");
    Expect(1, 65039, '\p{	-in_VARIATION_SELECTORS}', "");
    Expect(0, 65039, '\p{^	-in_VARIATION_SELECTORS}', "");
    Expect(0, 65039, '\P{	-in_VARIATION_SELECTORS}', "");
    Expect(1, 65039, '\P{^	-in_VARIATION_SELECTORS}', "");
    Expect(0, 65040, '\p{	-in_VARIATION_SELECTORS}', "");
    Expect(1, 65040, '\p{^	-in_VARIATION_SELECTORS}', "");
    Expect(1, 65040, '\P{	-in_VARIATION_SELECTORS}', "");
    Expect(0, 65040, '\P{^	-in_VARIATION_SELECTORS}', "");
    Error('\p{_in_VS/a/}');
    Error('\P{_in_VS/a/}');
    Expect(1, 65039, '\p{invs}', "");
    Expect(0, 65039, '\p{^invs}', "");
    Expect(0, 65039, '\P{invs}', "");
    Expect(1, 65039, '\P{^invs}', "");
    Expect(0, 65040, '\p{invs}', "");
    Expect(1, 65040, '\p{^invs}', "");
    Expect(1, 65040, '\P{invs}', "");
    Expect(0, 65040, '\P{^invs}', "");
    Expect(1, 65039, '\p{	In_VS}', "");
    Expect(0, 65039, '\p{^	In_VS}', "");
    Expect(0, 65039, '\P{	In_VS}', "");
    Expect(1, 65039, '\P{^	In_VS}', "");
    Expect(0, 65040, '\p{	In_VS}', "");
    Expect(1, 65040, '\p{^	In_VS}', "");
    Expect(1, 65040, '\P{	In_VS}', "");
    Expect(0, 65040, '\P{^	In_VS}', "");
    Error('\p{ -Variation_selectors_Supplement/a/}');
    Error('\P{ -Variation_selectors_Supplement/a/}');
    Expect(1, 917999, '\p{variationselectorssupplement}', "");
    Expect(0, 917999, '\p{^variationselectorssupplement}', "");
    Expect(0, 917999, '\P{variationselectorssupplement}', "");
    Expect(1, 917999, '\P{^variationselectorssupplement}', "");
    Expect(0, 918000, '\p{variationselectorssupplement}', "");
    Expect(1, 918000, '\p{^variationselectorssupplement}', "");
    Expect(1, 918000, '\P{variationselectorssupplement}', "");
    Expect(0, 918000, '\P{^variationselectorssupplement}', "");
    Expect(1, 917999, '\p{ _Variation_selectors_supplement}', "");
    Expect(0, 917999, '\p{^ _Variation_selectors_supplement}', "");
    Expect(0, 917999, '\P{ _Variation_selectors_supplement}', "");
    Expect(1, 917999, '\P{^ _Variation_selectors_supplement}', "");
    Expect(0, 918000, '\p{ _Variation_selectors_supplement}', "");
    Expect(1, 918000, '\p{^ _Variation_selectors_supplement}', "");
    Expect(1, 918000, '\P{ _Variation_selectors_supplement}', "");
    Expect(0, 918000, '\P{^ _Variation_selectors_supplement}', "");
    Error('\p{ /a/Is_variation_Selectors_supplement}');
    Error('\P{ /a/Is_variation_Selectors_supplement}');
    Expect(1, 917999, '\p{isvariationselectorssupplement}', "");
    Expect(0, 917999, '\p{^isvariationselectorssupplement}', "");
    Expect(0, 917999, '\P{isvariationselectorssupplement}', "");
    Expect(1, 917999, '\P{^isvariationselectorssupplement}', "");
    Expect(0, 918000, '\p{isvariationselectorssupplement}', "");
    Expect(1, 918000, '\p{^isvariationselectorssupplement}', "");
    Expect(1, 918000, '\P{isvariationselectorssupplement}', "");
    Expect(0, 918000, '\P{^isvariationselectorssupplement}', "");
    Expect(1, 917999, '\p{ Is_Variation_SELECTORS_SUPPLEMENT}', "");
    Expect(0, 917999, '\p{^ Is_Variation_SELECTORS_SUPPLEMENT}', "");
    Expect(0, 917999, '\P{ Is_Variation_SELECTORS_SUPPLEMENT}', "");
    Expect(1, 917999, '\P{^ Is_Variation_SELECTORS_SUPPLEMENT}', "");
    Expect(0, 918000, '\p{ Is_Variation_SELECTORS_SUPPLEMENT}', "");
    Expect(1, 918000, '\p{^ Is_Variation_SELECTORS_SUPPLEMENT}', "");
    Expect(1, 918000, '\P{ Is_Variation_SELECTORS_SUPPLEMENT}', "");
    Expect(0, 918000, '\P{^ Is_Variation_SELECTORS_SUPPLEMENT}', "");
    Error('\p{_IN_variation_SELECTORS_Supplement/a/}');
    Error('\P{_IN_variation_SELECTORS_Supplement/a/}');
    Expect(1, 917999, '\p{invariationselectorssupplement}', "");
    Expect(0, 917999, '\p{^invariationselectorssupplement}', "");
    Expect(0, 917999, '\P{invariationselectorssupplement}', "");
    Expect(1, 917999, '\P{^invariationselectorssupplement}', "");
    Expect(0, 918000, '\p{invariationselectorssupplement}', "");
    Expect(1, 918000, '\p{^invariationselectorssupplement}', "");
    Expect(1, 918000, '\P{invariationselectorssupplement}', "");
    Expect(0, 918000, '\P{^invariationselectorssupplement}', "");
    Expect(1, 917999, '\p{ 	in_Variation_selectors_Supplement}', "");
    Expect(0, 917999, '\p{^ 	in_Variation_selectors_Supplement}', "");
    Expect(0, 917999, '\P{ 	in_Variation_selectors_Supplement}', "");
    Expect(1, 917999, '\P{^ 	in_Variation_selectors_Supplement}', "");
    Expect(0, 918000, '\p{ 	in_Variation_selectors_Supplement}', "");
    Expect(1, 918000, '\p{^ 	in_Variation_selectors_Supplement}', "");
    Expect(1, 918000, '\P{ 	in_Variation_selectors_Supplement}', "");
    Expect(0, 918000, '\P{^ 	in_Variation_selectors_Supplement}', "");
    Error('\p{ vs_Sup:=}');
    Error('\P{ vs_Sup:=}');
    Expect(1, 917999, '\p{vssup}', "");
    Expect(0, 917999, '\p{^vssup}', "");
    Expect(0, 917999, '\P{vssup}', "");
    Expect(1, 917999, '\P{^vssup}', "");
    Expect(0, 918000, '\p{vssup}', "");
    Expect(1, 918000, '\p{^vssup}', "");
    Expect(1, 918000, '\P{vssup}', "");
    Expect(0, 918000, '\P{^vssup}', "");
    Expect(1, 917999, '\p{_-VS_SUP}', "");
    Expect(0, 917999, '\p{^_-VS_SUP}', "");
    Expect(0, 917999, '\P{_-VS_SUP}', "");
    Expect(1, 917999, '\P{^_-VS_SUP}', "");
    Expect(0, 918000, '\p{_-VS_SUP}', "");
    Expect(1, 918000, '\p{^_-VS_SUP}', "");
    Expect(1, 918000, '\P{_-VS_SUP}', "");
    Expect(0, 918000, '\P{^_-VS_SUP}', "");
    Error('\p{ :=IS_vs_SUP}');
    Error('\P{ :=IS_vs_SUP}');
    Expect(1, 917999, '\p{isvssup}', "");
    Expect(0, 917999, '\p{^isvssup}', "");
    Expect(0, 917999, '\P{isvssup}', "");
    Expect(1, 917999, '\P{^isvssup}', "");
    Expect(0, 918000, '\p{isvssup}', "");
    Expect(1, 918000, '\p{^isvssup}', "");
    Expect(1, 918000, '\P{isvssup}', "");
    Expect(0, 918000, '\P{^isvssup}', "");
    Expect(1, 917999, '\p{-IS_VS_sup}', "");
    Expect(0, 917999, '\p{^-IS_VS_sup}', "");
    Expect(0, 917999, '\P{-IS_VS_sup}', "");
    Expect(1, 917999, '\P{^-IS_VS_sup}', "");
    Expect(0, 918000, '\p{-IS_VS_sup}', "");
    Expect(1, 918000, '\p{^-IS_VS_sup}', "");
    Expect(1, 918000, '\P{-IS_VS_sup}', "");
    Expect(0, 918000, '\P{^-IS_VS_sup}', "");
    Error('\p{	/a/In_VS_Sup}');
    Error('\P{	/a/In_VS_Sup}');
    Expect(1, 917999, '\p{invssup}', "");
    Expect(0, 917999, '\p{^invssup}', "");
    Expect(0, 917999, '\P{invssup}', "");
    Expect(1, 917999, '\P{^invssup}', "");
    Expect(0, 918000, '\p{invssup}', "");
    Expect(1, 918000, '\p{^invssup}', "");
    Expect(1, 918000, '\P{invssup}', "");
    Expect(0, 918000, '\P{^invssup}', "");
    Expect(1, 917999, '\p{ -In_vs_Sup}', "");
    Expect(0, 917999, '\p{^ -In_vs_Sup}', "");
    Expect(0, 917999, '\P{ -In_vs_Sup}', "");
    Expect(1, 917999, '\P{^ -In_vs_Sup}', "");
    Expect(0, 918000, '\p{ -In_vs_Sup}', "");
    Expect(1, 918000, '\p{^ -In_vs_Sup}', "");
    Expect(1, 918000, '\P{ -In_vs_Sup}', "");
    Expect(0, 918000, '\P{^ -In_vs_Sup}', "");
    Error('\p{-:=Vedic_Extensions}');
    Error('\P{-:=Vedic_Extensions}');
    Expect(1, 7423, '\p{vedicextensions}', "");
    Expect(0, 7423, '\p{^vedicextensions}', "");
    Expect(0, 7423, '\P{vedicextensions}', "");
    Expect(1, 7423, '\P{^vedicextensions}', "");
    Expect(0, 7424, '\p{vedicextensions}', "");
    Expect(1, 7424, '\p{^vedicextensions}', "");
    Expect(1, 7424, '\P{vedicextensions}', "");
    Expect(0, 7424, '\P{^vedicextensions}', "");
    Expect(1, 7423, '\p{	_Vedic_extensions}', "");
    Expect(0, 7423, '\p{^	_Vedic_extensions}', "");
    Expect(0, 7423, '\P{	_Vedic_extensions}', "");
    Expect(1, 7423, '\P{^	_Vedic_extensions}', "");
    Expect(0, 7424, '\p{	_Vedic_extensions}', "");
    Expect(1, 7424, '\p{^	_Vedic_extensions}', "");
    Expect(1, 7424, '\P{	_Vedic_extensions}', "");
    Expect(0, 7424, '\P{^	_Vedic_extensions}', "");
    Error('\p{ :=IS_VEDIC_extensions}');
    Error('\P{ :=IS_VEDIC_extensions}');
    Expect(1, 7423, '\p{isvedicextensions}', "");
    Expect(0, 7423, '\p{^isvedicextensions}', "");
    Expect(0, 7423, '\P{isvedicextensions}', "");
    Expect(1, 7423, '\P{^isvedicextensions}', "");
    Expect(0, 7424, '\p{isvedicextensions}', "");
    Expect(1, 7424, '\p{^isvedicextensions}', "");
    Expect(1, 7424, '\P{isvedicextensions}', "");
    Expect(0, 7424, '\P{^isvedicextensions}', "");
    Expect(1, 7423, '\p{ IS_Vedic_extensions}', "");
    Expect(0, 7423, '\p{^ IS_Vedic_extensions}', "");
    Expect(0, 7423, '\P{ IS_Vedic_extensions}', "");
    Expect(1, 7423, '\P{^ IS_Vedic_extensions}', "");
    Expect(0, 7424, '\p{ IS_Vedic_extensions}', "");
    Expect(1, 7424, '\p{^ IS_Vedic_extensions}', "");
    Expect(1, 7424, '\P{ IS_Vedic_extensions}', "");
    Expect(0, 7424, '\P{^ IS_Vedic_extensions}', "");
    Error('\p{-:=in_vedic_Extensions}');
    Error('\P{-:=in_vedic_Extensions}');
    Expect(1, 7423, '\p{invedicextensions}', "");
    Expect(0, 7423, '\p{^invedicextensions}', "");
    Expect(0, 7423, '\P{invedicextensions}', "");
    Expect(1, 7423, '\P{^invedicextensions}', "");
    Expect(0, 7424, '\p{invedicextensions}', "");
    Expect(1, 7424, '\p{^invedicextensions}', "");
    Expect(1, 7424, '\P{invedicextensions}', "");
    Expect(0, 7424, '\P{^invedicextensions}', "");
    Expect(1, 7423, '\p{		In_VEDIC_Extensions}', "");
    Expect(0, 7423, '\p{^		In_VEDIC_Extensions}', "");
    Expect(0, 7423, '\P{		In_VEDIC_Extensions}', "");
    Expect(1, 7423, '\P{^		In_VEDIC_Extensions}', "");
    Expect(0, 7424, '\p{		In_VEDIC_Extensions}', "");
    Expect(1, 7424, '\p{^		In_VEDIC_Extensions}', "");
    Expect(1, 7424, '\P{		In_VEDIC_Extensions}', "");
    Expect(0, 7424, '\P{^		In_VEDIC_Extensions}', "");
    Error('\p{:=vedic_EXT}');
    Error('\P{:=vedic_EXT}');
    Expect(1, 7423, '\p{vedicext}', "");
    Expect(0, 7423, '\p{^vedicext}', "");
    Expect(0, 7423, '\P{vedicext}', "");
    Expect(1, 7423, '\P{^vedicext}', "");
    Expect(0, 7424, '\p{vedicext}', "");
    Expect(1, 7424, '\p{^vedicext}', "");
    Expect(1, 7424, '\P{vedicext}', "");
    Expect(0, 7424, '\P{^vedicext}', "");
    Expect(1, 7423, '\p{_Vedic_EXT}', "");
    Expect(0, 7423, '\p{^_Vedic_EXT}', "");
    Expect(0, 7423, '\P{_Vedic_EXT}', "");
    Expect(1, 7423, '\P{^_Vedic_EXT}', "");
    Expect(0, 7424, '\p{_Vedic_EXT}', "");
    Expect(1, 7424, '\p{^_Vedic_EXT}', "");
    Expect(1, 7424, '\P{_Vedic_EXT}', "");
    Expect(0, 7424, '\P{^_Vedic_EXT}', "");
    Error('\p{:=_is_VEDIC_EXT}');
    Error('\P{:=_is_VEDIC_EXT}');
    Expect(1, 7423, '\p{isvedicext}', "");
    Expect(0, 7423, '\p{^isvedicext}', "");
    Expect(0, 7423, '\P{isvedicext}', "");
    Expect(1, 7423, '\P{^isvedicext}', "");
    Expect(0, 7424, '\p{isvedicext}', "");
    Expect(1, 7424, '\p{^isvedicext}', "");
    Expect(1, 7424, '\P{isvedicext}', "");
    Expect(0, 7424, '\P{^isvedicext}', "");
    Expect(1, 7423, '\p{Is_Vedic_EXT}', "");
    Expect(0, 7423, '\p{^Is_Vedic_EXT}', "");
    Expect(0, 7423, '\P{Is_Vedic_EXT}', "");
    Expect(1, 7423, '\P{^Is_Vedic_EXT}', "");
    Expect(0, 7424, '\p{Is_Vedic_EXT}', "");
    Expect(1, 7424, '\p{^Is_Vedic_EXT}', "");
    Expect(1, 7424, '\P{Is_Vedic_EXT}', "");
    Expect(0, 7424, '\P{^Is_Vedic_EXT}', "");
    Error('\p{_In_vedic_Ext/a/}');
    Error('\P{_In_vedic_Ext/a/}');
    Expect(1, 7423, '\p{invedicext}', "");
    Expect(0, 7423, '\p{^invedicext}', "");
    Expect(0, 7423, '\P{invedicext}', "");
    Expect(1, 7423, '\P{^invedicext}', "");
    Expect(0, 7424, '\p{invedicext}', "");
    Expect(1, 7424, '\p{^invedicext}', "");
    Expect(1, 7424, '\P{invedicext}', "");
    Expect(0, 7424, '\P{^invedicext}', "");
    Expect(1, 7423, '\p{ _IN_Vedic_EXT}', "");
    Expect(0, 7423, '\p{^ _IN_Vedic_EXT}', "");
    Expect(0, 7423, '\P{ _IN_Vedic_EXT}', "");
    Expect(1, 7423, '\P{^ _IN_Vedic_EXT}', "");
    Expect(0, 7424, '\p{ _IN_Vedic_EXT}', "");
    Expect(1, 7424, '\p{^ _IN_Vedic_EXT}', "");
    Expect(1, 7424, '\P{ _IN_Vedic_EXT}', "");
    Expect(0, 7424, '\P{^ _IN_Vedic_EXT}', "");
    Error('\p{ Vertical_forms:=}');
    Error('\P{ Vertical_forms:=}');
    Expect(1, 65055, '\p{verticalforms}', "");
    Expect(0, 65055, '\p{^verticalforms}', "");
    Expect(0, 65055, '\P{verticalforms}', "");
    Expect(1, 65055, '\P{^verticalforms}', "");
    Expect(0, 65056, '\p{verticalforms}', "");
    Expect(1, 65056, '\p{^verticalforms}', "");
    Expect(1, 65056, '\P{verticalforms}', "");
    Expect(0, 65056, '\P{^verticalforms}', "");
    Expect(1, 65055, '\p{	Vertical_Forms}', "");
    Expect(0, 65055, '\p{^	Vertical_Forms}', "");
    Expect(0, 65055, '\P{	Vertical_Forms}', "");
    Expect(1, 65055, '\P{^	Vertical_Forms}', "");
    Expect(0, 65056, '\p{	Vertical_Forms}', "");
    Expect(1, 65056, '\p{^	Vertical_Forms}', "");
    Expect(1, 65056, '\P{	Vertical_Forms}', "");
    Expect(0, 65056, '\P{^	Vertical_Forms}', "");
    Error('\p{:=- is_Vertical_forms}');
    Error('\P{:=- is_Vertical_forms}');
    Expect(1, 65055, '\p{isverticalforms}', "");
    Expect(0, 65055, '\p{^isverticalforms}', "");
    Expect(0, 65055, '\P{isverticalforms}', "");
    Expect(1, 65055, '\P{^isverticalforms}', "");
    Expect(0, 65056, '\p{isverticalforms}', "");
    Expect(1, 65056, '\p{^isverticalforms}', "");
    Expect(1, 65056, '\P{isverticalforms}', "");
    Expect(0, 65056, '\P{^isverticalforms}', "");
    Expect(1, 65055, '\p{_ is_VERTICAL_forms}', "");
    Expect(0, 65055, '\p{^_ is_VERTICAL_forms}', "");
    Expect(0, 65055, '\P{_ is_VERTICAL_forms}', "");
    Expect(1, 65055, '\P{^_ is_VERTICAL_forms}', "");
    Expect(0, 65056, '\p{_ is_VERTICAL_forms}', "");
    Expect(1, 65056, '\p{^_ is_VERTICAL_forms}', "");
    Expect(1, 65056, '\P{_ is_VERTICAL_forms}', "");
    Expect(0, 65056, '\P{^_ is_VERTICAL_forms}', "");
    Error('\p{_:=In_VERTICAL_Forms}');
    Error('\P{_:=In_VERTICAL_Forms}');
    Expect(1, 65055, '\p{inverticalforms}', "");
    Expect(0, 65055, '\p{^inverticalforms}', "");
    Expect(0, 65055, '\P{inverticalforms}', "");
    Expect(1, 65055, '\P{^inverticalforms}', "");
    Expect(0, 65056, '\p{inverticalforms}', "");
    Expect(1, 65056, '\p{^inverticalforms}', "");
    Expect(1, 65056, '\P{inverticalforms}', "");
    Expect(0, 65056, '\P{^inverticalforms}', "");
    Expect(1, 65055, '\p{-	IN_Vertical_forms}', "");
    Expect(0, 65055, '\p{^-	IN_Vertical_forms}', "");
    Expect(0, 65055, '\P{-	IN_Vertical_forms}', "");
    Expect(1, 65055, '\P{^-	IN_Vertical_forms}', "");
    Expect(0, 65056, '\p{-	IN_Vertical_forms}', "");
    Expect(1, 65056, '\p{^-	IN_Vertical_forms}', "");
    Expect(1, 65056, '\P{-	IN_Vertical_forms}', "");
    Expect(0, 65056, '\P{^-	IN_Vertical_forms}', "");
    Error('\p{/a/ -VertSpace}');
    Error('\P{/a/ -VertSpace}');
    Expect(1, 8233, '\p{vertspace}', "");
    Expect(0, 8233, '\p{^vertspace}', "");
    Expect(0, 8233, '\P{vertspace}', "");
    Expect(1, 8233, '\P{^vertspace}', "");
    Expect(0, 8234, '\p{vertspace}', "");
    Expect(1, 8234, '\p{^vertspace}', "");
    Expect(1, 8234, '\P{vertspace}', "");
    Expect(0, 8234, '\P{^vertspace}', "");
    Expect(1, 8233, '\p{_ vertspace}', "");
    Expect(0, 8233, '\p{^_ vertspace}', "");
    Expect(0, 8233, '\P{_ vertspace}', "");
    Expect(1, 8233, '\P{^_ vertspace}', "");
    Expect(0, 8234, '\p{_ vertspace}', "");
    Expect(1, 8234, '\p{^_ vertspace}', "");
    Expect(1, 8234, '\P{_ vertspace}', "");
    Expect(0, 8234, '\P{^_ vertspace}', "");
    Error('\p{ /a/is_vertspace}');
    Error('\P{ /a/is_vertspace}');
    Expect(1, 8233, '\p{isvertspace}', "");
    Expect(0, 8233, '\p{^isvertspace}', "");
    Expect(0, 8233, '\P{isvertspace}', "");
    Expect(1, 8233, '\P{^isvertspace}', "");
    Expect(0, 8234, '\p{isvertspace}', "");
    Expect(1, 8234, '\p{^isvertspace}', "");
    Expect(1, 8234, '\P{isvertspace}', "");
    Expect(0, 8234, '\P{^isvertspace}', "");
    Expect(1, 8233, '\p{-Is_VertSpace}', "");
    Expect(0, 8233, '\p{^-Is_VertSpace}', "");
    Expect(0, 8233, '\P{-Is_VertSpace}', "");
    Expect(1, 8233, '\P{^-Is_VertSpace}', "");
    Expect(0, 8234, '\p{-Is_VertSpace}', "");
    Expect(1, 8234, '\p{^-Is_VertSpace}', "");
    Expect(1, 8234, '\P{-Is_VertSpace}', "");
    Expect(0, 8234, '\P{^-Is_VertSpace}', "");
    Error('\p{/a/_-Warang_Citi}');
    Error('\P{/a/_-Warang_Citi}');
    Expect(1, 71935, '\p{warangciti}', "");
    Expect(0, 71935, '\p{^warangciti}', "");
    Expect(0, 71935, '\P{warangciti}', "");
    Expect(1, 71935, '\P{^warangciti}', "");
    Expect(0, 71936, '\p{warangciti}', "");
    Expect(1, 71936, '\p{^warangciti}', "");
    Expect(1, 71936, '\P{warangciti}', "");
    Expect(0, 71936, '\P{^warangciti}', "");
    Expect(1, 71935, '\p{ Warang_Citi}', "");
    Expect(0, 71935, '\p{^ Warang_Citi}', "");
    Expect(0, 71935, '\P{ Warang_Citi}', "");
    Expect(1, 71935, '\P{^ Warang_Citi}', "");
    Expect(0, 71936, '\p{ Warang_Citi}', "");
    Expect(1, 71936, '\p{^ Warang_Citi}', "");
    Expect(1, 71936, '\P{ Warang_Citi}', "");
    Expect(0, 71936, '\P{^ Warang_Citi}', "");
    Error('\p{ /a/Is_WARANG_Citi}');
    Error('\P{ /a/Is_WARANG_Citi}');
    Expect(1, 71935, '\p{iswarangciti}', "");
    Expect(0, 71935, '\p{^iswarangciti}', "");
    Expect(0, 71935, '\P{iswarangciti}', "");
    Expect(1, 71935, '\P{^iswarangciti}', "");
    Expect(0, 71936, '\p{iswarangciti}', "");
    Expect(1, 71936, '\p{^iswarangciti}', "");
    Expect(1, 71936, '\P{iswarangciti}', "");
    Expect(0, 71936, '\P{^iswarangciti}', "");
    Expect(1, 71935, '\p{	Is_Warang_citi}', "");
    Expect(0, 71935, '\p{^	Is_Warang_citi}', "");
    Expect(0, 71935, '\P{	Is_Warang_citi}', "");
    Expect(1, 71935, '\P{^	Is_Warang_citi}', "");
    Expect(0, 71936, '\p{	Is_Warang_citi}', "");
    Expect(1, 71936, '\p{^	Is_Warang_citi}', "");
    Expect(1, 71936, '\P{	Is_Warang_citi}', "");
    Expect(0, 71936, '\P{^	Is_Warang_citi}', "");
    Error('\p{_/a/Wara}');
    Error('\P{_/a/Wara}');
    Expect(1, 71935, '\p{wara}', "");
    Expect(0, 71935, '\p{^wara}', "");
    Expect(0, 71935, '\P{wara}', "");
    Expect(1, 71935, '\P{^wara}', "");
    Expect(0, 71936, '\p{wara}', "");
    Expect(1, 71936, '\p{^wara}', "");
    Expect(1, 71936, '\P{wara}', "");
    Expect(0, 71936, '\P{^wara}', "");
    Expect(1, 71935, '\p{_-WARA}', "");
    Expect(0, 71935, '\p{^_-WARA}', "");
    Expect(0, 71935, '\P{_-WARA}', "");
    Expect(1, 71935, '\P{^_-WARA}', "");
    Expect(0, 71936, '\p{_-WARA}', "");
    Expect(1, 71936, '\p{^_-WARA}', "");
    Expect(1, 71936, '\P{_-WARA}', "");
    Expect(0, 71936, '\P{^_-WARA}', "");
    Error('\p{	_Is_wara:=}');
    Error('\P{	_Is_wara:=}');
    Expect(1, 71935, '\p{iswara}', "");
    Expect(0, 71935, '\p{^iswara}', "");
    Expect(0, 71935, '\P{iswara}', "");
    Expect(1, 71935, '\P{^iswara}', "");
    Expect(0, 71936, '\p{iswara}', "");
    Expect(1, 71936, '\p{^iswara}', "");
    Expect(1, 71936, '\P{iswara}', "");
    Expect(0, 71936, '\P{^iswara}', "");
    Expect(1, 71935, '\p{_	is_Wara}', "");
    Expect(0, 71935, '\p{^_	is_Wara}', "");
    Expect(0, 71935, '\P{_	is_Wara}', "");
    Expect(1, 71935, '\P{^_	is_Wara}', "");
    Expect(0, 71936, '\p{_	is_Wara}', "");
    Expect(1, 71936, '\p{^_	is_Wara}', "");
    Expect(1, 71936, '\P{_	is_Wara}', "");
    Expect(0, 71936, '\P{^_	is_Wara}', "");
    Error('\p{ _White_SPACE/a/}');
    Error('\P{ _White_SPACE/a/}');
    Expect(1, 12288, '\p{whitespace}', "");
    Expect(0, 12288, '\p{^whitespace}', "");
    Expect(0, 12288, '\P{whitespace}', "");
    Expect(1, 12288, '\P{^whitespace}', "");
    Expect(0, 12289, '\p{whitespace}', "");
    Expect(1, 12289, '\p{^whitespace}', "");
    Expect(1, 12289, '\P{whitespace}', "");
    Expect(0, 12289, '\P{^whitespace}', "");
    Expect(1, 12288, '\p{--White_SPACE}', "");
    Expect(0, 12288, '\p{^--White_SPACE}', "");
    Expect(0, 12288, '\P{--White_SPACE}', "");
    Expect(1, 12288, '\P{^--White_SPACE}', "");
    Expect(0, 12289, '\p{--White_SPACE}', "");
    Expect(1, 12289, '\p{^--White_SPACE}', "");
    Expect(1, 12289, '\P{--White_SPACE}', "");
    Expect(0, 12289, '\P{^--White_SPACE}', "");
    Error('\p{ /a/is_White_Space}');
    Error('\P{ /a/is_White_Space}');
    Expect(1, 12288, '\p{iswhitespace}', "");
    Expect(0, 12288, '\p{^iswhitespace}', "");
    Expect(0, 12288, '\P{iswhitespace}', "");
    Expect(1, 12288, '\P{^iswhitespace}', "");
    Expect(0, 12289, '\p{iswhitespace}', "");
    Expect(1, 12289, '\p{^iswhitespace}', "");
    Expect(1, 12289, '\P{iswhitespace}', "");
    Expect(0, 12289, '\P{^iswhitespace}', "");
    Expect(1, 12288, '\p{_	IS_White_space}', "");
    Expect(0, 12288, '\p{^_	IS_White_space}', "");
    Expect(0, 12288, '\P{_	IS_White_space}', "");
    Expect(1, 12288, '\P{^_	IS_White_space}', "");
    Expect(0, 12289, '\p{_	IS_White_space}', "");
    Expect(1, 12289, '\p{^_	IS_White_space}', "");
    Expect(1, 12289, '\P{_	IS_White_space}', "");
    Expect(0, 12289, '\P{^_	IS_White_space}', "");
    Error('\p{_/a/WSPACE}');
    Error('\P{_/a/WSPACE}');
    Expect(1, 12288, '\p{wspace}', "");
    Expect(0, 12288, '\p{^wspace}', "");
    Expect(0, 12288, '\P{wspace}', "");
    Expect(1, 12288, '\P{^wspace}', "");
    Expect(0, 12289, '\p{wspace}', "");
    Expect(1, 12289, '\p{^wspace}', "");
    Expect(1, 12289, '\P{wspace}', "");
    Expect(0, 12289, '\P{^wspace}', "");
    Expect(1, 12288, '\p{  WSPACE}', "");
    Expect(0, 12288, '\p{^  WSPACE}', "");
    Expect(0, 12288, '\P{  WSPACE}', "");
    Expect(1, 12288, '\P{^  WSPACE}', "");
    Expect(0, 12289, '\p{  WSPACE}', "");
    Expect(1, 12289, '\p{^  WSPACE}', "");
    Expect(1, 12289, '\P{  WSPACE}', "");
    Expect(0, 12289, '\P{^  WSPACE}', "");
    Error('\p{/a/-IS_wspace}');
    Error('\P{/a/-IS_wspace}');
    Expect(1, 12288, '\p{iswspace}', "");
    Expect(0, 12288, '\p{^iswspace}', "");
    Expect(0, 12288, '\P{iswspace}', "");
    Expect(1, 12288, '\P{^iswspace}', "");
    Expect(0, 12289, '\p{iswspace}', "");
    Expect(1, 12289, '\p{^iswspace}', "");
    Expect(1, 12289, '\P{iswspace}', "");
    Expect(0, 12289, '\P{^iswspace}', "");
    Expect(1, 12288, '\p{- IS_WSpace}', "");
    Expect(0, 12288, '\p{^- IS_WSpace}', "");
    Expect(0, 12288, '\P{- IS_WSpace}', "");
    Expect(1, 12288, '\P{^- IS_WSpace}', "");
    Expect(0, 12289, '\p{- IS_WSpace}', "");
    Expect(1, 12289, '\p{^- IS_WSpace}', "");
    Expect(1, 12289, '\P{- IS_WSpace}', "");
    Expect(0, 12289, '\P{^- IS_WSpace}', "");
    Error('\p{-Space:=}');
    Error('\P{-Space:=}');
    Expect(1, 12288, '\p{space}', "");
    Expect(0, 12288, '\p{^space}', "");
    Expect(0, 12288, '\P{space}', "");
    Expect(1, 12288, '\P{^space}', "");
    Expect(0, 12289, '\p{space}', "");
    Expect(1, 12289, '\p{^space}', "");
    Expect(1, 12289, '\P{space}', "");
    Expect(0, 12289, '\P{^space}', "");
    Expect(1, 12288, '\p{	 space}', "");
    Expect(0, 12288, '\p{^	 space}', "");
    Expect(0, 12288, '\P{	 space}', "");
    Expect(1, 12288, '\P{^	 space}', "");
    Expect(0, 12289, '\p{	 space}', "");
    Expect(1, 12289, '\p{^	 space}', "");
    Expect(1, 12289, '\P{	 space}', "");
    Expect(0, 12289, '\P{^	 space}', "");
    Error('\p{_:=IS_SPACE}');
    Error('\P{_:=IS_SPACE}');
    Expect(1, 12288, '\p{isspace}', "");
    Expect(0, 12288, '\p{^isspace}', "");
    Expect(0, 12288, '\P{isspace}', "");
    Expect(1, 12288, '\P{^isspace}', "");
    Expect(0, 12289, '\p{isspace}', "");
    Expect(1, 12289, '\p{^isspace}', "");
    Expect(1, 12289, '\P{isspace}', "");
    Expect(0, 12289, '\P{^isspace}', "");
    Expect(1, 12288, '\p{_Is_Space}', "");
    Expect(0, 12288, '\p{^_Is_Space}', "");
    Expect(0, 12288, '\P{_Is_Space}', "");
    Expect(1, 12288, '\P{^_Is_Space}', "");
    Expect(0, 12289, '\p{_Is_Space}', "");
    Expect(1, 12289, '\p{^_Is_Space}', "");
    Expect(1, 12289, '\P{_Is_Space}', "");
    Expect(0, 12289, '\P{^_Is_Space}', "");
    Error('\p{/a/ _XPosixWord}');
    Error('\P{/a/ _XPosixWord}');
    Expect(1, 917999, '\p{xposixword}', "");
    Expect(0, 917999, '\p{^xposixword}', "");
    Expect(0, 917999, '\P{xposixword}', "");
    Expect(1, 917999, '\P{^xposixword}', "");
    Expect(0, 918000, '\p{xposixword}', "");
    Expect(1, 918000, '\p{^xposixword}', "");
    Expect(1, 918000, '\P{xposixword}', "");
    Expect(0, 918000, '\P{^xposixword}', "");
    Expect(1, 917999, '\p{	XPosixWord}', "");
    Expect(0, 917999, '\p{^	XPosixWord}', "");
    Expect(0, 917999, '\P{	XPosixWord}', "");
    Expect(1, 917999, '\P{^	XPosixWord}', "");
    Expect(0, 918000, '\p{	XPosixWord}', "");
    Expect(1, 918000, '\p{^	XPosixWord}', "");
    Expect(1, 918000, '\P{	XPosixWord}', "");
    Expect(0, 918000, '\P{^	XPosixWord}', "");
    Error('\p{:=word}');
    Error('\P{:=word}');
    Expect(1, 917999, '\p{word}', "");
    Expect(0, 917999, '\p{^word}', "");
    Expect(0, 917999, '\P{word}', "");
    Expect(1, 917999, '\P{^word}', "");
    Expect(0, 918000, '\p{word}', "");
    Expect(1, 918000, '\p{^word}', "");
    Expect(1, 918000, '\P{word}', "");
    Expect(0, 918000, '\P{^word}', "");
    Expect(1, 917999, '\p{		Word}', "");
    Expect(0, 917999, '\p{^		Word}', "");
    Expect(0, 917999, '\P{		Word}', "");
    Expect(1, 917999, '\P{^		Word}', "");
    Expect(0, 918000, '\p{		Word}', "");
    Expect(1, 918000, '\p{^		Word}', "");
    Expect(1, 918000, '\P{		Word}', "");
    Expect(0, 918000, '\P{^		Word}', "");
    Error('\p{_ is_XPosixWord/a/}');
    Error('\P{_ is_XPosixWord/a/}');
    Expect(1, 917999, '\p{isxposixword}', "");
    Expect(0, 917999, '\p{^isxposixword}', "");
    Expect(0, 917999, '\P{isxposixword}', "");
    Expect(1, 917999, '\P{^isxposixword}', "");
    Expect(0, 918000, '\p{isxposixword}', "");
    Expect(1, 918000, '\p{^isxposixword}', "");
    Expect(1, 918000, '\P{isxposixword}', "");
    Expect(0, 918000, '\P{^isxposixword}', "");
    Expect(1, 917999, '\p{-	is_XPosixWord}', "");
    Expect(0, 917999, '\p{^-	is_XPosixWord}', "");
    Expect(0, 917999, '\P{-	is_XPosixWord}', "");
    Expect(1, 917999, '\P{^-	is_XPosixWord}', "");
    Expect(0, 918000, '\p{-	is_XPosixWord}', "");
    Expect(1, 918000, '\p{^-	is_XPosixWord}', "");
    Expect(1, 918000, '\P{-	is_XPosixWord}', "");
    Expect(0, 918000, '\P{^-	is_XPosixWord}', "");
    Error('\p{	:=Is_Word}');
    Error('\P{	:=Is_Word}');
    Expect(1, 917999, '\p{isword}', "");
    Expect(0, 917999, '\p{^isword}', "");
    Expect(0, 917999, '\P{isword}', "");
    Expect(1, 917999, '\P{^isword}', "");
    Expect(0, 918000, '\p{isword}', "");
    Expect(1, 918000, '\p{^isword}', "");
    Expect(1, 918000, '\P{isword}', "");
    Expect(0, 918000, '\P{^isword}', "");
    Expect(1, 917999, '\p{__Is_Word}', "");
    Expect(0, 917999, '\p{^__Is_Word}', "");
    Expect(0, 917999, '\P{__Is_Word}', "");
    Expect(1, 917999, '\P{^__Is_Word}', "");
    Expect(0, 918000, '\p{__Is_Word}', "");
    Expect(1, 918000, '\p{^__Is_Word}', "");
    Expect(1, 918000, '\P{__Is_Word}', "");
    Expect(0, 918000, '\P{^__Is_Word}', "");
    Error('\p{:=_	xposixxdigit}');
    Error('\P{:=_	xposixxdigit}');
    Expect(1, 65350, '\p{xposixxdigit}', "");
    Expect(0, 65350, '\p{^xposixxdigit}', "");
    Expect(0, 65350, '\P{xposixxdigit}', "");
    Expect(1, 65350, '\P{^xposixxdigit}', "");
    Expect(0, 65351, '\p{xposixxdigit}', "");
    Expect(1, 65351, '\p{^xposixxdigit}', "");
    Expect(1, 65351, '\P{xposixxdigit}', "");
    Expect(0, 65351, '\P{^xposixxdigit}', "");
    Expect(1, 65350, '\p{_	xposixxdigit}', "");
    Expect(0, 65350, '\p{^_	xposixxdigit}', "");
    Expect(0, 65350, '\P{_	xposixxdigit}', "");
    Expect(1, 65350, '\P{^_	xposixxdigit}', "");
    Expect(0, 65351, '\p{_	xposixxdigit}', "");
    Expect(1, 65351, '\p{^_	xposixxdigit}', "");
    Expect(1, 65351, '\P{_	xposixxdigit}', "");
    Expect(0, 65351, '\P{^_	xposixxdigit}', "");
    Error('\p{ /a/XDigit}');
    Error('\P{ /a/XDigit}');
    Expect(1, 65350, '\p{xdigit}', "");
    Expect(0, 65350, '\p{^xdigit}', "");
    Expect(0, 65350, '\P{xdigit}', "");
    Expect(1, 65350, '\P{^xdigit}', "");
    Expect(0, 65351, '\p{xdigit}', "");
    Expect(1, 65351, '\p{^xdigit}', "");
    Expect(1, 65351, '\P{xdigit}', "");
    Expect(0, 65351, '\P{^xdigit}', "");
    Expect(1, 65350, '\p{_	XDigit}', "");
    Expect(0, 65350, '\p{^_	XDigit}', "");
    Expect(0, 65350, '\P{_	XDigit}', "");
    Expect(1, 65350, '\P{^_	XDigit}', "");
    Expect(0, 65351, '\p{_	XDigit}', "");
    Expect(1, 65351, '\p{^_	XDigit}', "");
    Expect(1, 65351, '\P{_	XDigit}', "");
    Expect(0, 65351, '\P{^_	XDigit}', "");
    Error('\p{:=	Is_XPOSIXXDIGIT}');
    Error('\P{:=	Is_XPOSIXXDIGIT}');
    Expect(1, 65350, '\p{isxposixxdigit}', "");
    Expect(0, 65350, '\p{^isxposixxdigit}', "");
    Expect(0, 65350, '\P{isxposixxdigit}', "");
    Expect(1, 65350, '\P{^isxposixxdigit}', "");
    Expect(0, 65351, '\p{isxposixxdigit}', "");
    Expect(1, 65351, '\p{^isxposixxdigit}', "");
    Expect(1, 65351, '\P{isxposixxdigit}', "");
    Expect(0, 65351, '\P{^isxposixxdigit}', "");
    Expect(1, 65350, '\p{ is_xposixxdigit}', "");
    Expect(0, 65350, '\p{^ is_xposixxdigit}', "");
    Expect(0, 65350, '\P{ is_xposixxdigit}', "");
    Expect(1, 65350, '\P{^ is_xposixxdigit}', "");
    Expect(0, 65351, '\p{ is_xposixxdigit}', "");
    Expect(1, 65351, '\p{^ is_xposixxdigit}', "");
    Expect(1, 65351, '\P{ is_xposixxdigit}', "");
    Expect(0, 65351, '\P{^ is_xposixxdigit}', "");
    Error('\p{:= 	is_XDIGIT}');
    Error('\P{:= 	is_XDIGIT}');
    Expect(1, 65350, '\p{isxdigit}', "");
    Expect(0, 65350, '\p{^isxdigit}', "");
    Expect(0, 65350, '\P{isxdigit}', "");
    Expect(1, 65350, '\P{^isxdigit}', "");
    Expect(0, 65351, '\p{isxdigit}', "");
    Expect(1, 65351, '\p{^isxdigit}', "");
    Expect(1, 65351, '\P{isxdigit}', "");
    Expect(0, 65351, '\P{^isxdigit}', "");
    Expect(1, 65350, '\p{  is_xdigit}', "");
    Expect(0, 65350, '\p{^  is_xdigit}', "");
    Expect(0, 65350, '\P{  is_xdigit}', "");
    Expect(1, 65350, '\P{^  is_xdigit}', "");
    Expect(0, 65351, '\p{  is_xdigit}', "");
    Expect(1, 65351, '\p{^  is_xdigit}', "");
    Expect(1, 65351, '\P{  is_xdigit}', "");
    Expect(0, 65351, '\P{^  is_xdigit}', "");
    Error('\p{_:=HEX_Digit}');
    Error('\P{_:=HEX_Digit}');
    Expect(1, 65350, '\p{hexdigit}', "");
    Expect(0, 65350, '\p{^hexdigit}', "");
    Expect(0, 65350, '\P{hexdigit}', "");
    Expect(1, 65350, '\P{^hexdigit}', "");
    Expect(0, 65351, '\p{hexdigit}', "");
    Expect(1, 65351, '\p{^hexdigit}', "");
    Expect(1, 65351, '\P{hexdigit}', "");
    Expect(0, 65351, '\P{^hexdigit}', "");
    Expect(1, 65350, '\p{- Hex_Digit}', "");
    Expect(0, 65350, '\p{^- Hex_Digit}', "");
    Expect(0, 65350, '\P{- Hex_Digit}', "");
    Expect(1, 65350, '\P{^- Hex_Digit}', "");
    Expect(0, 65351, '\p{- Hex_Digit}', "");
    Expect(1, 65351, '\p{^- Hex_Digit}', "");
    Expect(1, 65351, '\P{- Hex_Digit}', "");
    Expect(0, 65351, '\P{^- Hex_Digit}', "");
    Error('\p{/a/	IS_hex_Digit}');
    Error('\P{/a/	IS_hex_Digit}');
    Expect(1, 65350, '\p{ishexdigit}', "");
    Expect(0, 65350, '\p{^ishexdigit}', "");
    Expect(0, 65350, '\P{ishexdigit}', "");
    Expect(1, 65350, '\P{^ishexdigit}', "");
    Expect(0, 65351, '\p{ishexdigit}', "");
    Expect(1, 65351, '\p{^ishexdigit}', "");
    Expect(1, 65351, '\P{ishexdigit}', "");
    Expect(0, 65351, '\P{^ishexdigit}', "");
    Expect(1, 65350, '\p{- Is_hex_DIGIT}', "");
    Expect(0, 65350, '\p{^- Is_hex_DIGIT}', "");
    Expect(0, 65350, '\P{- Is_hex_DIGIT}', "");
    Expect(1, 65350, '\P{^- Is_hex_DIGIT}', "");
    Expect(0, 65351, '\p{- Is_hex_DIGIT}', "");
    Expect(1, 65351, '\p{^- Is_hex_DIGIT}', "");
    Expect(1, 65351, '\P{- Is_hex_DIGIT}', "");
    Expect(0, 65351, '\P{^- Is_hex_DIGIT}', "");
    Error('\p{/a/-	Hex}');
    Error('\P{/a/-	Hex}');
    Expect(1, 65350, '\p{hex}', "");
    Expect(0, 65350, '\p{^hex}', "");
    Expect(0, 65350, '\P{hex}', "");
    Expect(1, 65350, '\P{^hex}', "");
    Expect(0, 65351, '\p{hex}', "");
    Expect(1, 65351, '\p{^hex}', "");
    Expect(1, 65351, '\P{hex}', "");
    Expect(0, 65351, '\P{^hex}', "");
    Expect(1, 65350, '\p{- Hex}', "");
    Expect(0, 65350, '\p{^- Hex}', "");
    Expect(0, 65350, '\P{- Hex}', "");
    Expect(1, 65350, '\P{^- Hex}', "");
    Expect(0, 65351, '\p{- Hex}', "");
    Expect(1, 65351, '\p{^- Hex}', "");
    Expect(1, 65351, '\P{- Hex}', "");
    Expect(0, 65351, '\P{^- Hex}', "");
    Error('\p{/a/-	Is_Hex}');
    Error('\P{/a/-	Is_Hex}');
    Expect(1, 65350, '\p{ishex}', "");
    Expect(0, 65350, '\p{^ishex}', "");
    Expect(0, 65350, '\P{ishex}', "");
    Expect(1, 65350, '\P{^ishex}', "");
    Expect(0, 65351, '\p{ishex}', "");
    Expect(1, 65351, '\p{^ishex}', "");
    Expect(1, 65351, '\P{ishex}', "");
    Expect(0, 65351, '\P{^ishex}', "");
    Expect(1, 65350, '\p{	Is_Hex}', "");
    Expect(0, 65350, '\p{^	Is_Hex}', "");
    Expect(0, 65350, '\P{	Is_Hex}', "");
    Expect(1, 65350, '\P{^	Is_Hex}', "");
    Expect(0, 65351, '\p{	Is_Hex}', "");
    Expect(1, 65351, '\p{^	Is_Hex}', "");
    Expect(1, 65351, '\P{	Is_Hex}', "");
    Expect(0, 65351, '\P{^	Is_Hex}', "");
    Error('\p{:=xid_CONTINUE}');
    Error('\P{:=xid_CONTINUE}');
    Expect(1, 917999, '\p{xidcontinue}', "");
    Expect(0, 917999, '\p{^xidcontinue}', "");
    Expect(0, 917999, '\P{xidcontinue}', "");
    Expect(1, 917999, '\P{^xidcontinue}', "");
    Expect(0, 918000, '\p{xidcontinue}', "");
    Expect(1, 918000, '\p{^xidcontinue}', "");
    Expect(1, 918000, '\P{xidcontinue}', "");
    Expect(0, 918000, '\P{^xidcontinue}', "");
    Expect(1, 917999, '\p{ -XID_CONTINUE}', "");
    Expect(0, 917999, '\p{^ -XID_CONTINUE}', "");
    Expect(0, 917999, '\P{ -XID_CONTINUE}', "");
    Expect(1, 917999, '\P{^ -XID_CONTINUE}', "");
    Expect(0, 918000, '\p{ -XID_CONTINUE}', "");
    Expect(1, 918000, '\p{^ -XID_CONTINUE}', "");
    Expect(1, 918000, '\P{ -XID_CONTINUE}', "");
    Expect(0, 918000, '\P{^ -XID_CONTINUE}', "");
    Error('\p{	-is_XID_continue/a/}');
    Error('\P{	-is_XID_continue/a/}');
    Expect(1, 917999, '\p{isxidcontinue}', "");
    Expect(0, 917999, '\p{^isxidcontinue}', "");
    Expect(0, 917999, '\P{isxidcontinue}', "");
    Expect(1, 917999, '\P{^isxidcontinue}', "");
    Expect(0, 918000, '\p{isxidcontinue}', "");
    Expect(1, 918000, '\p{^isxidcontinue}', "");
    Expect(1, 918000, '\P{isxidcontinue}', "");
    Expect(0, 918000, '\P{^isxidcontinue}', "");
    Expect(1, 917999, '\p{	 Is_XID_Continue}', "");
    Expect(0, 917999, '\p{^	 Is_XID_Continue}', "");
    Expect(0, 917999, '\P{	 Is_XID_Continue}', "");
    Expect(1, 917999, '\P{^	 Is_XID_Continue}', "");
    Expect(0, 918000, '\p{	 Is_XID_Continue}', "");
    Expect(1, 918000, '\p{^	 Is_XID_Continue}', "");
    Expect(1, 918000, '\P{	 Is_XID_Continue}', "");
    Expect(0, 918000, '\P{^	 Is_XID_Continue}', "");
    Error('\p{:=- XIDC}');
    Error('\P{:=- XIDC}');
    Expect(1, 917999, '\p{xidc}', "");
    Expect(0, 917999, '\p{^xidc}', "");
    Expect(0, 917999, '\P{xidc}', "");
    Expect(1, 917999, '\P{^xidc}', "");
    Expect(0, 918000, '\p{xidc}', "");
    Expect(1, 918000, '\p{^xidc}', "");
    Expect(1, 918000, '\P{xidc}', "");
    Expect(0, 918000, '\P{^xidc}', "");
    Expect(1, 917999, '\p{ _XIDC}', "");
    Expect(0, 917999, '\p{^ _XIDC}', "");
    Expect(0, 917999, '\P{ _XIDC}', "");
    Expect(1, 917999, '\P{^ _XIDC}', "");
    Expect(0, 918000, '\p{ _XIDC}', "");
    Expect(1, 918000, '\p{^ _XIDC}', "");
    Expect(1, 918000, '\P{ _XIDC}', "");
    Expect(0, 918000, '\P{^ _XIDC}', "");
    Error('\p{-:=is_XIDC}');
    Error('\P{-:=is_XIDC}');
    Expect(1, 917999, '\p{isxidc}', "");
    Expect(0, 917999, '\p{^isxidc}', "");
    Expect(0, 917999, '\P{isxidc}', "");
    Expect(1, 917999, '\P{^isxidc}', "");
    Expect(0, 918000, '\p{isxidc}', "");
    Expect(1, 918000, '\p{^isxidc}', "");
    Expect(1, 918000, '\P{isxidc}', "");
    Expect(0, 918000, '\P{^isxidc}', "");
    Expect(1, 917999, '\p{--IS_xidc}', "");
    Expect(0, 917999, '\p{^--IS_xidc}', "");
    Expect(0, 917999, '\P{--IS_xidc}', "");
    Expect(1, 917999, '\P{^--IS_xidc}', "");
    Expect(0, 918000, '\p{--IS_xidc}', "");
    Expect(1, 918000, '\p{^--IS_xidc}', "");
    Expect(1, 918000, '\P{--IS_xidc}', "");
    Expect(0, 918000, '\P{^--IS_xidc}', "");
    Error('\p{-:=XID_START}');
    Error('\P{-:=XID_START}');
    Expect(1, 195101, '\p{xidstart}', "");
    Expect(0, 195101, '\p{^xidstart}', "");
    Expect(0, 195101, '\P{xidstart}', "");
    Expect(1, 195101, '\P{^xidstart}', "");
    Expect(0, 195102, '\p{xidstart}', "");
    Expect(1, 195102, '\p{^xidstart}', "");
    Expect(1, 195102, '\P{xidstart}', "");
    Expect(0, 195102, '\P{^xidstart}', "");
    Expect(1, 195101, '\p{-XID_Start}', "");
    Expect(0, 195101, '\p{^-XID_Start}', "");
    Expect(0, 195101, '\P{-XID_Start}', "");
    Expect(1, 195101, '\P{^-XID_Start}', "");
    Expect(0, 195102, '\p{-XID_Start}', "");
    Expect(1, 195102, '\p{^-XID_Start}', "");
    Expect(1, 195102, '\P{-XID_Start}', "");
    Expect(0, 195102, '\P{^-XID_Start}', "");
    Error('\p{:=	Is_XID_START}');
    Error('\P{:=	Is_XID_START}');
    Expect(1, 195101, '\p{isxidstart}', "");
    Expect(0, 195101, '\p{^isxidstart}', "");
    Expect(0, 195101, '\P{isxidstart}', "");
    Expect(1, 195101, '\P{^isxidstart}', "");
    Expect(0, 195102, '\p{isxidstart}', "");
    Expect(1, 195102, '\p{^isxidstart}', "");
    Expect(1, 195102, '\P{isxidstart}', "");
    Expect(0, 195102, '\P{^isxidstart}', "");
    Expect(1, 195101, '\p{	 IS_xid_start}', "");
    Expect(0, 195101, '\p{^	 IS_xid_start}', "");
    Expect(0, 195101, '\P{	 IS_xid_start}', "");
    Expect(1, 195101, '\P{^	 IS_xid_start}', "");
    Expect(0, 195102, '\p{	 IS_xid_start}', "");
    Expect(1, 195102, '\p{^	 IS_xid_start}', "");
    Expect(1, 195102, '\P{	 IS_xid_start}', "");
    Expect(0, 195102, '\P{^	 IS_xid_start}', "");
    Error('\p{_	XIDS:=}');
    Error('\P{_	XIDS:=}');
    Expect(1, 195101, '\p{xids}', "");
    Expect(0, 195101, '\p{^xids}', "");
    Expect(0, 195101, '\P{xids}', "");
    Expect(1, 195101, '\P{^xids}', "");
    Expect(0, 195102, '\p{xids}', "");
    Expect(1, 195102, '\p{^xids}', "");
    Expect(1, 195102, '\P{xids}', "");
    Expect(0, 195102, '\P{^xids}', "");
    Expect(1, 195101, '\p{-XIDS}', "");
    Expect(0, 195101, '\p{^-XIDS}', "");
    Expect(0, 195101, '\P{-XIDS}', "");
    Expect(1, 195101, '\P{^-XIDS}', "");
    Expect(0, 195102, '\p{-XIDS}', "");
    Expect(1, 195102, '\p{^-XIDS}', "");
    Expect(1, 195102, '\P{-XIDS}', "");
    Expect(0, 195102, '\P{^-XIDS}', "");
    Error('\p{- IS_XIDS:=}');
    Error('\P{- IS_XIDS:=}');
    Expect(1, 195101, '\p{isxids}', "");
    Expect(0, 195101, '\p{^isxids}', "");
    Expect(0, 195101, '\P{isxids}', "");
    Expect(1, 195101, '\P{^isxids}', "");
    Expect(0, 195102, '\p{isxids}', "");
    Expect(1, 195102, '\p{^isxids}', "");
    Expect(1, 195102, '\P{isxids}', "");
    Expect(0, 195102, '\P{^isxids}', "");
    Expect(1, 195101, '\p{-	is_xids}', "");
    Expect(0, 195101, '\p{^-	is_xids}', "");
    Expect(0, 195101, '\P{-	is_xids}', "");
    Expect(1, 195101, '\P{^-	is_xids}', "");
    Expect(0, 195102, '\p{-	is_xids}', "");
    Expect(1, 195102, '\p{^-	is_xids}', "");
    Expect(1, 195102, '\P{-	is_xids}', "");
    Expect(0, 195102, '\P{^-	is_xids}', "");
    Error('\p{  xposixalpha/a/}');
    Error('\P{  xposixalpha/a/}');
    Expect(1, 195101, '\p{xposixalpha}', "");
    Expect(0, 195101, '\p{^xposixalpha}', "");
    Expect(0, 195101, '\P{xposixalpha}', "");
    Expect(1, 195101, '\P{^xposixalpha}', "");
    Expect(0, 195102, '\p{xposixalpha}', "");
    Expect(1, 195102, '\p{^xposixalpha}', "");
    Expect(1, 195102, '\P{xposixalpha}', "");
    Expect(0, 195102, '\P{^xposixalpha}', "");
    Expect(1, 195101, '\p{  XPosixAlpha}', "");
    Expect(0, 195101, '\p{^  XPosixAlpha}', "");
    Expect(0, 195101, '\P{  XPosixAlpha}', "");
    Expect(1, 195101, '\P{^  XPosixAlpha}', "");
    Expect(0, 195102, '\p{  XPosixAlpha}', "");
    Expect(1, 195102, '\p{^  XPosixAlpha}', "");
    Expect(1, 195102, '\P{  XPosixAlpha}', "");
    Expect(0, 195102, '\P{^  XPosixAlpha}', "");
    Error('\p{-_Is_xposixalpha:=}');
    Error('\P{-_Is_xposixalpha:=}');
    Expect(1, 195101, '\p{isxposixalpha}', "");
    Expect(0, 195101, '\p{^isxposixalpha}', "");
    Expect(0, 195101, '\P{isxposixalpha}', "");
    Expect(1, 195101, '\P{^isxposixalpha}', "");
    Expect(0, 195102, '\p{isxposixalpha}', "");
    Expect(1, 195102, '\p{^isxposixalpha}', "");
    Expect(1, 195102, '\P{isxposixalpha}', "");
    Expect(0, 195102, '\P{^isxposixalpha}', "");
    Expect(1, 195101, '\p{_Is_XPosixAlpha}', "");
    Expect(0, 195101, '\p{^_Is_XPosixAlpha}', "");
    Expect(0, 195101, '\P{_Is_XPosixAlpha}', "");
    Expect(1, 195101, '\P{^_Is_XPosixAlpha}', "");
    Expect(0, 195102, '\p{_Is_XPosixAlpha}', "");
    Expect(1, 195102, '\p{^_Is_XPosixAlpha}', "");
    Expect(1, 195102, '\P{_Is_XPosixAlpha}', "");
    Expect(0, 195102, '\P{^_Is_XPosixAlpha}', "");
    Error('\p{/a/  alphabetic}');
    Error('\P{/a/  alphabetic}');
    Expect(1, 195101, '\p{alphabetic}', "");
    Expect(0, 195101, '\p{^alphabetic}', "");
    Expect(0, 195101, '\P{alphabetic}', "");
    Expect(1, 195101, '\P{^alphabetic}', "");
    Expect(0, 195102, '\p{alphabetic}', "");
    Expect(1, 195102, '\p{^alphabetic}', "");
    Expect(1, 195102, '\P{alphabetic}', "");
    Expect(0, 195102, '\P{^alphabetic}', "");
    Expect(1, 195101, '\p{-ALPHABETIC}', "");
    Expect(0, 195101, '\p{^-ALPHABETIC}', "");
    Expect(0, 195101, '\P{-ALPHABETIC}', "");
    Expect(1, 195101, '\P{^-ALPHABETIC}', "");
    Expect(0, 195102, '\p{-ALPHABETIC}', "");
    Expect(1, 195102, '\p{^-ALPHABETIC}', "");
    Expect(1, 195102, '\P{-ALPHABETIC}', "");
    Expect(0, 195102, '\P{^-ALPHABETIC}', "");
    Error('\p{/a/-Is_Alphabetic}');
    Error('\P{/a/-Is_Alphabetic}');
    Expect(1, 195101, '\p{isalphabetic}', "");
    Expect(0, 195101, '\p{^isalphabetic}', "");
    Expect(0, 195101, '\P{isalphabetic}', "");
    Expect(1, 195101, '\P{^isalphabetic}', "");
    Expect(0, 195102, '\p{isalphabetic}', "");
    Expect(1, 195102, '\p{^isalphabetic}', "");
    Expect(1, 195102, '\P{isalphabetic}', "");
    Expect(0, 195102, '\P{^isalphabetic}', "");
    Expect(1, 195101, '\p{ _is_ALPHABETIC}', "");
    Expect(0, 195101, '\p{^ _is_ALPHABETIC}', "");
    Expect(0, 195101, '\P{ _is_ALPHABETIC}', "");
    Expect(1, 195101, '\P{^ _is_ALPHABETIC}', "");
    Expect(0, 195102, '\p{ _is_ALPHABETIC}', "");
    Expect(1, 195102, '\p{^ _is_ALPHABETIC}', "");
    Expect(1, 195102, '\P{ _is_ALPHABETIC}', "");
    Expect(0, 195102, '\P{^ _is_ALPHABETIC}', "");
    Error('\p{	 Alpha:=}');
    Error('\P{	 Alpha:=}');
    Expect(1, 195101, '\p{alpha}', "");
    Expect(0, 195101, '\p{^alpha}', "");
    Expect(0, 195101, '\P{alpha}', "");
    Expect(1, 195101, '\P{^alpha}', "");
    Expect(0, 195102, '\p{alpha}', "");
    Expect(1, 195102, '\p{^alpha}', "");
    Expect(1, 195102, '\P{alpha}', "");
    Expect(0, 195102, '\P{^alpha}', "");
    Expect(1, 195101, '\p{	-alpha}', "");
    Expect(0, 195101, '\p{^	-alpha}', "");
    Expect(0, 195101, '\P{	-alpha}', "");
    Expect(1, 195101, '\P{^	-alpha}', "");
    Expect(0, 195102, '\p{	-alpha}', "");
    Expect(1, 195102, '\p{^	-alpha}', "");
    Expect(1, 195102, '\P{	-alpha}', "");
    Expect(0, 195102, '\P{^	-alpha}', "");
    Error('\p{:=-	Is_Alpha}');
    Error('\P{:=-	Is_Alpha}');
    Expect(1, 195101, '\p{isalpha}', "");
    Expect(0, 195101, '\p{^isalpha}', "");
    Expect(0, 195101, '\P{isalpha}', "");
    Expect(1, 195101, '\P{^isalpha}', "");
    Expect(0, 195102, '\p{isalpha}', "");
    Expect(1, 195102, '\p{^isalpha}', "");
    Expect(1, 195102, '\P{isalpha}', "");
    Expect(0, 195102, '\P{^isalpha}', "");
    Expect(1, 195101, '\p{-	IS_ALPHA}', "");
    Expect(0, 195101, '\p{^-	IS_ALPHA}', "");
    Expect(0, 195101, '\P{-	IS_ALPHA}', "");
    Expect(1, 195101, '\P{^-	IS_ALPHA}', "");
    Expect(0, 195102, '\p{-	IS_ALPHA}', "");
    Expect(1, 195102, '\p{^-	IS_ALPHA}', "");
    Expect(1, 195102, '\P{-	IS_ALPHA}', "");
    Expect(0, 195102, '\P{^-	IS_ALPHA}', "");
    Error('\p{/a/ XPosixLower}');
    Error('\P{/a/ XPosixLower}');
    Expect(1, 125251, '\p{xposixlower}', "");
    Expect(0, 125251, '\p{^xposixlower}', "");
    Expect(0, 125251, '\P{xposixlower}', "");
    Expect(1, 125251, '\P{^xposixlower}', "");
    Expect(0, 125252, '\p{xposixlower}', "");
    Expect(1, 125252, '\p{^xposixlower}', "");
    Expect(1, 125252, '\P{xposixlower}', "");
    Expect(0, 125252, '\P{^xposixlower}', "");
    Expect(1, 125251, '\p{	-XPOSIXLOWER}', "");
    Expect(0, 125251, '\p{^	-XPOSIXLOWER}', "");
    Expect(0, 125251, '\P{	-XPOSIXLOWER}', "");
    Expect(1, 125251, '\P{^	-XPOSIXLOWER}', "");
    Expect(0, 125252, '\p{	-XPOSIXLOWER}', "");
    Expect(1, 125252, '\p{^	-XPOSIXLOWER}', "");
    Expect(1, 125252, '\P{	-XPOSIXLOWER}', "");
    Expect(0, 125252, '\P{^	-XPOSIXLOWER}', "");
    Error('\p{ _Is_XPOSIXLOWER/a/}');
    Error('\P{ _Is_XPOSIXLOWER/a/}');
    Expect(1, 125251, '\p{isxposixlower}', "");
    Expect(0, 125251, '\p{^isxposixlower}', "");
    Expect(0, 125251, '\P{isxposixlower}', "");
    Expect(1, 125251, '\P{^isxposixlower}', "");
    Expect(0, 125252, '\p{isxposixlower}', "");
    Expect(1, 125252, '\p{^isxposixlower}', "");
    Expect(1, 125252, '\P{isxposixlower}', "");
    Expect(0, 125252, '\P{^isxposixlower}', "");
    Expect(1, 125251, '\p{-IS_XPOSIXLOWER}', "");
    Expect(0, 125251, '\p{^-IS_XPOSIXLOWER}', "");
    Expect(0, 125251, '\P{-IS_XPOSIXLOWER}', "");
    Expect(1, 125251, '\P{^-IS_XPOSIXLOWER}', "");
    Expect(0, 125252, '\p{-IS_XPOSIXLOWER}', "");
    Expect(1, 125252, '\p{^-IS_XPOSIXLOWER}', "");
    Expect(1, 125252, '\P{-IS_XPOSIXLOWER}', "");
    Expect(0, 125252, '\P{^-IS_XPOSIXLOWER}', "");
    Error('\p{	_Lowercase:=}');
    Error('\P{	_Lowercase:=}');
    Expect(1, 125251, '\p{lowercase}', "");
    Expect(0, 125251, '\p{^lowercase}', "");
    Expect(0, 125251, '\P{lowercase}', "");
    Expect(1, 125251, '\P{^lowercase}', "");
    Expect(0, 125252, '\p{lowercase}', "");
    Expect(1, 125252, '\p{^lowercase}', "");
    Expect(1, 125252, '\P{lowercase}', "");
    Expect(0, 125252, '\P{^lowercase}', "");
    Expect(1, 125251, '\p{- LOWERCASE}', "");
    Expect(0, 125251, '\p{^- LOWERCASE}', "");
    Expect(0, 125251, '\P{- LOWERCASE}', "");
    Expect(1, 125251, '\P{^- LOWERCASE}', "");
    Expect(0, 125252, '\p{- LOWERCASE}', "");
    Expect(1, 125252, '\p{^- LOWERCASE}', "");
    Expect(1, 125252, '\P{- LOWERCASE}', "");
    Expect(0, 125252, '\P{^- LOWERCASE}', "");
    Error('\p{/a/ Is_Lowercase}');
    Error('\P{/a/ Is_Lowercase}');
    Expect(1, 125251, '\p{islowercase}', "");
    Expect(0, 125251, '\p{^islowercase}', "");
    Expect(0, 125251, '\P{islowercase}', "");
    Expect(1, 125251, '\P{^islowercase}', "");
    Expect(0, 125252, '\p{islowercase}', "");
    Expect(1, 125252, '\p{^islowercase}', "");
    Expect(1, 125252, '\P{islowercase}', "");
    Expect(0, 125252, '\P{^islowercase}', "");
    Expect(1, 125251, '\p{	_Is_Lowercase}', "");
    Expect(0, 125251, '\p{^	_Is_Lowercase}', "");
    Expect(0, 125251, '\P{	_Is_Lowercase}', "");
    Expect(1, 125251, '\P{^	_Is_Lowercase}', "");
    Expect(0, 125252, '\p{	_Is_Lowercase}', "");
    Expect(1, 125252, '\p{^	_Is_Lowercase}', "");
    Expect(1, 125252, '\P{	_Is_Lowercase}', "");
    Expect(0, 125252, '\P{^	_Is_Lowercase}', "");
    Error('\p{_ Lower/a/}');
    Error('\P{_ Lower/a/}');
    Expect(1, 125251, '\p{lower}', "");
    Expect(0, 125251, '\p{^lower}', "");
    Expect(0, 125251, '\P{lower}', "");
    Expect(1, 125251, '\P{^lower}', "");
    Expect(0, 125252, '\p{lower}', "");
    Expect(1, 125252, '\p{^lower}', "");
    Expect(1, 125252, '\P{lower}', "");
    Expect(0, 125252, '\P{^lower}', "");
    Expect(1, 125251, '\p{_LOWER}', "");
    Expect(0, 125251, '\p{^_LOWER}', "");
    Expect(0, 125251, '\P{_LOWER}', "");
    Expect(1, 125251, '\P{^_LOWER}', "");
    Expect(0, 125252, '\p{_LOWER}', "");
    Expect(1, 125252, '\p{^_LOWER}', "");
    Expect(1, 125252, '\P{_LOWER}', "");
    Expect(0, 125252, '\P{^_LOWER}', "");
    Error('\p{_:=is_lower}');
    Error('\P{_:=is_lower}');
    Expect(1, 125251, '\p{islower}', "");
    Expect(0, 125251, '\p{^islower}', "");
    Expect(0, 125251, '\P{islower}', "");
    Expect(1, 125251, '\P{^islower}', "");
    Expect(0, 125252, '\p{islower}', "");
    Expect(1, 125252, '\p{^islower}', "");
    Expect(1, 125252, '\P{islower}', "");
    Expect(0, 125252, '\P{^islower}', "");
    Expect(1, 125251, '\p{ 	Is_LOWER}', "");
    Expect(0, 125251, '\p{^ 	Is_LOWER}', "");
    Expect(0, 125251, '\P{ 	Is_LOWER}', "");
    Expect(1, 125251, '\P{^ 	Is_LOWER}', "");
    Expect(0, 125252, '\p{ 	Is_LOWER}', "");
    Expect(1, 125252, '\p{^ 	Is_LOWER}', "");
    Expect(1, 125252, '\P{ 	Is_LOWER}', "");
    Expect(0, 125252, '\P{^ 	Is_LOWER}', "");
    Error('\p{--xposixpunct/a/}');
    Error('\P{--xposixpunct/a/}');
    Expect(1, 125279, '\p{xposixpunct}', "");
    Expect(0, 125279, '\p{^xposixpunct}', "");
    Expect(0, 125279, '\P{xposixpunct}', "");
    Expect(1, 125279, '\P{^xposixpunct}', "");
    Expect(0, 125280, '\p{xposixpunct}', "");
    Expect(1, 125280, '\p{^xposixpunct}', "");
    Expect(1, 125280, '\P{xposixpunct}', "");
    Expect(0, 125280, '\P{^xposixpunct}', "");
    Expect(1, 125279, '\p{ -XPOSIXPUNCT}', "");
    Expect(0, 125279, '\p{^ -XPOSIXPUNCT}', "");
    Expect(0, 125279, '\P{ -XPOSIXPUNCT}', "");
    Expect(1, 125279, '\P{^ -XPOSIXPUNCT}', "");
    Expect(0, 125280, '\p{ -XPOSIXPUNCT}', "");
    Expect(1, 125280, '\p{^ -XPOSIXPUNCT}', "");
    Expect(1, 125280, '\P{ -XPOSIXPUNCT}', "");
    Expect(0, 125280, '\P{^ -XPOSIXPUNCT}', "");
    Error('\p{	:=Is_xposixpunct}');
    Error('\P{	:=Is_xposixpunct}');
    Expect(1, 125279, '\p{isxposixpunct}', "");
    Expect(0, 125279, '\p{^isxposixpunct}', "");
    Expect(0, 125279, '\P{isxposixpunct}', "");
    Expect(1, 125279, '\P{^isxposixpunct}', "");
    Expect(0, 125280, '\p{isxposixpunct}', "");
    Expect(1, 125280, '\p{^isxposixpunct}', "");
    Expect(1, 125280, '\P{isxposixpunct}', "");
    Expect(0, 125280, '\P{^isxposixpunct}', "");
    Expect(1, 125279, '\p{ _Is_XPosixPunct}', "");
    Expect(0, 125279, '\p{^ _Is_XPosixPunct}', "");
    Expect(0, 125279, '\P{ _Is_XPosixPunct}', "");
    Expect(1, 125279, '\P{^ _Is_XPosixPunct}', "");
    Expect(0, 125280, '\p{ _Is_XPosixPunct}', "");
    Expect(1, 125280, '\p{^ _Is_XPosixPunct}', "");
    Expect(1, 125280, '\P{ _Is_XPosixPunct}', "");
    Expect(0, 125280, '\P{^ _Is_XPosixPunct}', "");
    Error('\p{:=	-XPOSIXSPACE}');
    Error('\P{:=	-XPOSIXSPACE}');
    Expect(1, 12288, '\p{xposixspace}', "");
    Expect(0, 12288, '\p{^xposixspace}', "");
    Expect(0, 12288, '\P{xposixspace}', "");
    Expect(1, 12288, '\P{^xposixspace}', "");
    Expect(0, 12289, '\p{xposixspace}', "");
    Expect(1, 12289, '\p{^xposixspace}', "");
    Expect(1, 12289, '\P{xposixspace}', "");
    Expect(0, 12289, '\P{^xposixspace}', "");
    Expect(1, 12288, '\p{__XPOSIXSPACE}', "");
    Expect(0, 12288, '\p{^__XPOSIXSPACE}', "");
    Expect(0, 12288, '\P{__XPOSIXSPACE}', "");
    Expect(1, 12288, '\P{^__XPOSIXSPACE}', "");
    Expect(0, 12289, '\p{__XPOSIXSPACE}', "");
    Expect(1, 12289, '\p{^__XPOSIXSPACE}', "");
    Expect(1, 12289, '\P{__XPOSIXSPACE}', "");
    Expect(0, 12289, '\P{^__XPOSIXSPACE}', "");
    Error('\p{_:=XPERLSPACE}');
    Error('\P{_:=XPERLSPACE}');
    Expect(1, 12288, '\p{xperlspace}', "");
    Expect(0, 12288, '\p{^xperlspace}', "");
    Expect(0, 12288, '\P{xperlspace}', "");
    Expect(1, 12288, '\P{^xperlspace}', "");
    Expect(0, 12289, '\p{xperlspace}', "");
    Expect(1, 12289, '\p{^xperlspace}', "");
    Expect(1, 12289, '\P{xperlspace}', "");
    Expect(0, 12289, '\P{^xperlspace}', "");
    Expect(1, 12288, '\p{-xperlspace}', "");
    Expect(0, 12288, '\p{^-xperlspace}', "");
    Expect(0, 12288, '\P{-xperlspace}', "");
    Expect(1, 12288, '\P{^-xperlspace}', "");
    Expect(0, 12289, '\p{-xperlspace}', "");
    Expect(1, 12289, '\p{^-xperlspace}', "");
    Expect(1, 12289, '\P{-xperlspace}', "");
    Expect(0, 12289, '\P{^-xperlspace}', "");
    Error('\p{	/a/SpacePerl}');
    Error('\P{	/a/SpacePerl}');
    Expect(1, 12288, '\p{spaceperl}', "");
    Expect(0, 12288, '\p{^spaceperl}', "");
    Expect(0, 12288, '\P{spaceperl}', "");
    Expect(1, 12288, '\P{^spaceperl}', "");
    Expect(0, 12289, '\p{spaceperl}', "");
    Expect(1, 12289, '\p{^spaceperl}', "");
    Expect(1, 12289, '\P{spaceperl}', "");
    Expect(0, 12289, '\P{^spaceperl}', "");
    Expect(1, 12288, '\p{-spaceperl}', "");
    Expect(0, 12288, '\p{^-spaceperl}', "");
    Expect(0, 12288, '\P{-spaceperl}', "");
    Expect(1, 12288, '\P{^-spaceperl}', "");
    Expect(0, 12289, '\p{-spaceperl}', "");
    Expect(1, 12289, '\p{^-spaceperl}', "");
    Expect(1, 12289, '\P{-spaceperl}', "");
    Expect(0, 12289, '\P{^-spaceperl}', "");
    Error('\p{ -is_XPosixSpace/a/}');
    Error('\P{ -is_XPosixSpace/a/}');
    Expect(1, 12288, '\p{isxposixspace}', "");
    Expect(0, 12288, '\p{^isxposixspace}', "");
    Expect(0, 12288, '\P{isxposixspace}', "");
    Expect(1, 12288, '\P{^isxposixspace}', "");
    Expect(0, 12289, '\p{isxposixspace}', "");
    Expect(1, 12289, '\p{^isxposixspace}', "");
    Expect(1, 12289, '\P{isxposixspace}', "");
    Expect(0, 12289, '\P{^isxposixspace}', "");
    Expect(1, 12288, '\p{__is_XPosixSpace}', "");
    Expect(0, 12288, '\p{^__is_XPosixSpace}', "");
    Expect(0, 12288, '\P{__is_XPosixSpace}', "");
    Expect(1, 12288, '\P{^__is_XPosixSpace}', "");
    Expect(0, 12289, '\p{__is_XPosixSpace}', "");
    Expect(1, 12289, '\p{^__is_XPosixSpace}', "");
    Expect(1, 12289, '\P{__is_XPosixSpace}', "");
    Expect(0, 12289, '\P{^__is_XPosixSpace}', "");
    Error('\p{/a/IS_XPERLSPACE}');
    Error('\P{/a/IS_XPERLSPACE}');
    Expect(1, 12288, '\p{isxperlspace}', "");
    Expect(0, 12288, '\p{^isxperlspace}', "");
    Expect(0, 12288, '\P{isxperlspace}', "");
    Expect(1, 12288, '\P{^isxperlspace}', "");
    Expect(0, 12289, '\p{isxperlspace}', "");
    Expect(1, 12289, '\p{^isxperlspace}', "");
    Expect(1, 12289, '\P{isxperlspace}', "");
    Expect(0, 12289, '\P{^isxperlspace}', "");
    Expect(1, 12288, '\p{_Is_XPerlSpace}', "");
    Expect(0, 12288, '\p{^_Is_XPerlSpace}', "");
    Expect(0, 12288, '\P{_Is_XPerlSpace}', "");
    Expect(1, 12288, '\P{^_Is_XPerlSpace}', "");
    Expect(0, 12289, '\p{_Is_XPerlSpace}', "");
    Expect(1, 12289, '\p{^_Is_XPerlSpace}', "");
    Expect(1, 12289, '\P{_Is_XPerlSpace}', "");
    Expect(0, 12289, '\P{^_Is_XPerlSpace}', "");
    Error('\p{ /a/is_SpacePerl}');
    Error('\P{ /a/is_SpacePerl}');
    Expect(1, 12288, '\p{isspaceperl}', "");
    Expect(0, 12288, '\p{^isspaceperl}', "");
    Expect(0, 12288, '\P{isspaceperl}', "");
    Expect(1, 12288, '\P{^isspaceperl}', "");
    Expect(0, 12289, '\p{isspaceperl}', "");
    Expect(1, 12289, '\p{^isspaceperl}', "");
    Expect(1, 12289, '\P{isspaceperl}', "");
    Expect(0, 12289, '\P{^isspaceperl}', "");
    Expect(1, 12288, '\p{_IS_SpacePerl}', "");
    Expect(0, 12288, '\p{^_IS_SpacePerl}', "");
    Expect(0, 12288, '\P{_IS_SpacePerl}', "");
    Expect(1, 12288, '\P{^_IS_SpacePerl}', "");
    Expect(0, 12289, '\p{_IS_SpacePerl}', "");
    Expect(1, 12289, '\p{^_IS_SpacePerl}', "");
    Expect(1, 12289, '\P{_IS_SpacePerl}', "");
    Expect(0, 12289, '\P{^_IS_SpacePerl}', "");
    Error('\p{	/a/XPosixUpper}');
    Error('\P{	/a/XPosixUpper}');
    Expect(1, 127369, '\p{xposixupper}', "");
    Expect(0, 127369, '\p{^xposixupper}', "");
    Expect(0, 127369, '\P{xposixupper}', "");
    Expect(1, 127369, '\P{^xposixupper}', "");
    Expect(0, 127370, '\p{xposixupper}', "");
    Expect(1, 127370, '\p{^xposixupper}', "");
    Expect(1, 127370, '\P{xposixupper}', "");
    Expect(0, 127370, '\P{^xposixupper}', "");
    Expect(1, 127369, '\p{	_XPosixUpper}', "");
    Expect(0, 127369, '\p{^	_XPosixUpper}', "");
    Expect(0, 127369, '\P{	_XPosixUpper}', "");
    Expect(1, 127369, '\P{^	_XPosixUpper}', "");
    Expect(0, 127370, '\p{	_XPosixUpper}', "");
    Expect(1, 127370, '\p{^	_XPosixUpper}', "");
    Expect(1, 127370, '\P{	_XPosixUpper}', "");
    Expect(0, 127370, '\P{^	_XPosixUpper}', "");
    Error('\p{:= _Is_XPosixUpper}');
    Error('\P{:= _Is_XPosixUpper}');
    Expect(1, 127369, '\p{isxposixupper}', "");
    Expect(0, 127369, '\p{^isxposixupper}', "");
    Expect(0, 127369, '\P{isxposixupper}', "");
    Expect(1, 127369, '\P{^isxposixupper}', "");
    Expect(0, 127370, '\p{isxposixupper}', "");
    Expect(1, 127370, '\p{^isxposixupper}', "");
    Expect(1, 127370, '\P{isxposixupper}', "");
    Expect(0, 127370, '\P{^isxposixupper}', "");
    Expect(1, 127369, '\p{-	IS_XPosixUpper}', "");
    Expect(0, 127369, '\p{^-	IS_XPosixUpper}', "");
    Expect(0, 127369, '\P{-	IS_XPosixUpper}', "");
    Expect(1, 127369, '\P{^-	IS_XPosixUpper}', "");
    Expect(0, 127370, '\p{-	IS_XPosixUpper}', "");
    Expect(1, 127370, '\p{^-	IS_XPosixUpper}', "");
    Expect(1, 127370, '\P{-	IS_XPosixUpper}', "");
    Expect(0, 127370, '\P{^-	IS_XPosixUpper}', "");
    Error('\p{-:=Uppercase}');
    Error('\P{-:=Uppercase}');
    Expect(1, 127369, '\p{uppercase}', "");
    Expect(0, 127369, '\p{^uppercase}', "");
    Expect(0, 127369, '\P{uppercase}', "");
    Expect(1, 127369, '\P{^uppercase}', "");
    Expect(0, 127370, '\p{uppercase}', "");
    Expect(1, 127370, '\p{^uppercase}', "");
    Expect(1, 127370, '\P{uppercase}', "");
    Expect(0, 127370, '\P{^uppercase}', "");
    Expect(1, 127369, '\p{--Uppercase}', "");
    Expect(0, 127369, '\p{^--Uppercase}', "");
    Expect(0, 127369, '\P{--Uppercase}', "");
    Expect(1, 127369, '\P{^--Uppercase}', "");
    Expect(0, 127370, '\p{--Uppercase}', "");
    Expect(1, 127370, '\p{^--Uppercase}', "");
    Expect(1, 127370, '\P{--Uppercase}', "");
    Expect(0, 127370, '\P{^--Uppercase}', "");
    Error('\p{_-Is_Uppercase:=}');
    Error('\P{_-Is_Uppercase:=}');
    Expect(1, 127369, '\p{isuppercase}', "");
    Expect(0, 127369, '\p{^isuppercase}', "");
    Expect(0, 127369, '\P{isuppercase}', "");
    Expect(1, 127369, '\P{^isuppercase}', "");
    Expect(0, 127370, '\p{isuppercase}', "");
    Expect(1, 127370, '\p{^isuppercase}', "");
    Expect(1, 127370, '\P{isuppercase}', "");
    Expect(0, 127370, '\P{^isuppercase}', "");
    Expect(1, 127369, '\p{IS_uppercase}', "");
    Expect(0, 127369, '\p{^IS_uppercase}', "");
    Expect(0, 127369, '\P{IS_uppercase}', "");
    Expect(1, 127369, '\P{^IS_uppercase}', "");
    Expect(0, 127370, '\p{IS_uppercase}', "");
    Expect(1, 127370, '\p{^IS_uppercase}', "");
    Expect(1, 127370, '\P{IS_uppercase}', "");
    Expect(0, 127370, '\P{^IS_uppercase}', "");
    Error('\p{--Upper/a/}');
    Error('\P{--Upper/a/}');
    Expect(1, 127369, '\p{upper}', "");
    Expect(0, 127369, '\p{^upper}', "");
    Expect(0, 127369, '\P{upper}', "");
    Expect(1, 127369, '\P{^upper}', "");
    Expect(0, 127370, '\p{upper}', "");
    Expect(1, 127370, '\p{^upper}', "");
    Expect(1, 127370, '\P{upper}', "");
    Expect(0, 127370, '\P{^upper}', "");
    Expect(1, 127369, '\p{	upper}', "");
    Expect(0, 127369, '\p{^	upper}', "");
    Expect(0, 127369, '\P{	upper}', "");
    Expect(1, 127369, '\P{^	upper}', "");
    Expect(0, 127370, '\p{	upper}', "");
    Expect(1, 127370, '\p{^	upper}', "");
    Expect(1, 127370, '\P{	upper}', "");
    Expect(0, 127370, '\P{^	upper}', "");
    Error('\p{:=		is_Upper}');
    Error('\P{:=		is_Upper}');
    Expect(1, 127369, '\p{isupper}', "");
    Expect(0, 127369, '\p{^isupper}', "");
    Expect(0, 127369, '\P{isupper}', "");
    Expect(1, 127369, '\P{^isupper}', "");
    Expect(0, 127370, '\p{isupper}', "");
    Expect(1, 127370, '\p{^isupper}', "");
    Expect(1, 127370, '\P{isupper}', "");
    Expect(0, 127370, '\P{^isupper}', "");
    Expect(1, 127369, '\p{-is_Upper}', "");
    Expect(0, 127369, '\p{^-is_Upper}', "");
    Expect(0, 127369, '\P{-is_Upper}', "");
    Expect(1, 127369, '\P{^-is_Upper}', "");
    Expect(0, 127370, '\p{-is_Upper}', "");
    Expect(1, 127370, '\p{^-is_Upper}', "");
    Expect(1, 127370, '\P{-is_Upper}', "");
    Expect(0, 127370, '\P{^-is_Upper}', "");
    Error('\p{__YI/a/}');
    Error('\P{__YI/a/}');
    Expect(1, 65381, '\p{yi}', "");
    Expect(0, 65381, '\p{^yi}', "");
    Expect(0, 65381, '\P{yi}', "");
    Expect(1, 65381, '\P{^yi}', "");
    Expect(0, 65382, '\p{yi}', "");
    Expect(1, 65382, '\p{^yi}', "");
    Expect(1, 65382, '\P{yi}', "");
    Expect(0, 65382, '\P{^yi}', "");
    Expect(1, 65381, '\p{	yi}', "");
    Expect(0, 65381, '\p{^	yi}', "");
    Expect(0, 65381, '\P{	yi}', "");
    Expect(1, 65381, '\P{^	yi}', "");
    Expect(0, 65382, '\p{	yi}', "");
    Expect(1, 65382, '\p{^	yi}', "");
    Expect(1, 65382, '\P{	yi}', "");
    Expect(0, 65382, '\P{^	yi}', "");
    Error('\p{_:=is_Yi}');
    Error('\P{_:=is_Yi}');
    Expect(1, 65381, '\p{isyi}', "");
    Expect(0, 65381, '\p{^isyi}', "");
    Expect(0, 65381, '\P{isyi}', "");
    Expect(1, 65381, '\P{^isyi}', "");
    Expect(0, 65382, '\p{isyi}', "");
    Expect(1, 65382, '\p{^isyi}', "");
    Expect(1, 65382, '\P{isyi}', "");
    Expect(0, 65382, '\P{^isyi}', "");
    Expect(1, 65381, '\p{is_Yi}', "");
    Expect(0, 65381, '\p{^is_Yi}', "");
    Expect(0, 65381, '\P{is_Yi}', "");
    Expect(1, 65381, '\P{^is_Yi}', "");
    Expect(0, 65382, '\p{is_Yi}', "");
    Expect(1, 65382, '\p{^is_Yi}', "");
    Expect(1, 65382, '\P{is_Yi}', "");
    Expect(0, 65382, '\P{^is_Yi}', "");
    Error('\p{/a/__yiii}');
    Error('\P{/a/__yiii}');
    Expect(1, 65381, '\p{yiii}', "");
    Expect(0, 65381, '\p{^yiii}', "");
    Expect(0, 65381, '\P{yiii}', "");
    Expect(1, 65381, '\P{^yiii}', "");
    Expect(0, 65382, '\p{yiii}', "");
    Expect(1, 65382, '\p{^yiii}', "");
    Expect(1, 65382, '\P{yiii}', "");
    Expect(0, 65382, '\P{^yiii}', "");
    Expect(1, 65381, '\p{	yiii}', "");
    Expect(0, 65381, '\p{^	yiii}', "");
    Expect(0, 65381, '\P{	yiii}', "");
    Expect(1, 65381, '\P{^	yiii}', "");
    Expect(0, 65382, '\p{	yiii}', "");
    Expect(1, 65382, '\p{^	yiii}', "");
    Expect(1, 65382, '\P{	yiii}', "");
    Expect(0, 65382, '\P{^	yiii}', "");
    Error('\p{:=	Is_Yiii}');
    Error('\P{:=	Is_Yiii}');
    Expect(1, 65381, '\p{isyiii}', "");
    Expect(0, 65381, '\p{^isyiii}', "");
    Expect(0, 65381, '\P{isyiii}', "");
    Expect(1, 65381, '\P{^isyiii}', "");
    Expect(0, 65382, '\p{isyiii}', "");
    Expect(1, 65382, '\p{^isyiii}', "");
    Expect(1, 65382, '\P{isyiii}', "");
    Expect(0, 65382, '\P{^isyiii}', "");
    Expect(1, 65381, '\p{-is_Yiii}', "");
    Expect(0, 65381, '\p{^-is_Yiii}', "");
    Expect(0, 65381, '\P{-is_Yiii}', "");
    Expect(1, 65381, '\P{^-is_Yiii}', "");
    Expect(0, 65382, '\p{-is_Yiii}', "");
    Expect(1, 65382, '\p{^-is_Yiii}', "");
    Expect(1, 65382, '\P{-is_Yiii}', "");
    Expect(0, 65382, '\P{^-is_Yiii}', "");
    Error('\p{ /a/YI_radicals}');
    Error('\P{ /a/YI_radicals}');
    Expect(1, 42191, '\p{yiradicals}', "");
    Expect(0, 42191, '\p{^yiradicals}', "");
    Expect(0, 42191, '\P{yiradicals}', "");
    Expect(1, 42191, '\P{^yiradicals}', "");
    Expect(0, 42192, '\p{yiradicals}', "");
    Expect(1, 42192, '\p{^yiradicals}', "");
    Expect(1, 42192, '\P{yiradicals}', "");
    Expect(0, 42192, '\P{^yiradicals}', "");
    Expect(1, 42191, '\p{	 yi_radicals}', "");
    Expect(0, 42191, '\p{^	 yi_radicals}', "");
    Expect(0, 42191, '\P{	 yi_radicals}', "");
    Expect(1, 42191, '\P{^	 yi_radicals}', "");
    Expect(0, 42192, '\p{	 yi_radicals}', "");
    Expect(1, 42192, '\p{^	 yi_radicals}', "");
    Expect(1, 42192, '\P{	 yi_radicals}', "");
    Expect(0, 42192, '\P{^	 yi_radicals}', "");
    Error('\p{/a/Is_Yi_radicals}');
    Error('\P{/a/Is_Yi_radicals}');
    Expect(1, 42191, '\p{isyiradicals}', "");
    Expect(0, 42191, '\p{^isyiradicals}', "");
    Expect(0, 42191, '\P{isyiradicals}', "");
    Expect(1, 42191, '\P{^isyiradicals}', "");
    Expect(0, 42192, '\p{isyiradicals}', "");
    Expect(1, 42192, '\p{^isyiradicals}', "");
    Expect(1, 42192, '\P{isyiradicals}', "");
    Expect(0, 42192, '\P{^isyiradicals}', "");
    Expect(1, 42191, '\p{	IS_yi_radicals}', "");
    Expect(0, 42191, '\p{^	IS_yi_radicals}', "");
    Expect(0, 42191, '\P{	IS_yi_radicals}', "");
    Expect(1, 42191, '\P{^	IS_yi_radicals}', "");
    Expect(0, 42192, '\p{	IS_yi_radicals}', "");
    Expect(1, 42192, '\p{^	IS_yi_radicals}', "");
    Expect(1, 42192, '\P{	IS_yi_radicals}', "");
    Expect(0, 42192, '\P{^	IS_yi_radicals}', "");
    Error('\p{__IN_Yi_Radicals/a/}');
    Error('\P{__IN_Yi_Radicals/a/}');
    Expect(1, 42191, '\p{inyiradicals}', "");
    Expect(0, 42191, '\p{^inyiradicals}', "");
    Expect(0, 42191, '\P{inyiradicals}', "");
    Expect(1, 42191, '\P{^inyiradicals}', "");
    Expect(0, 42192, '\p{inyiradicals}', "");
    Expect(1, 42192, '\p{^inyiradicals}', "");
    Expect(1, 42192, '\P{inyiradicals}', "");
    Expect(0, 42192, '\P{^inyiradicals}', "");
    Expect(1, 42191, '\p{	 In_Yi_RADICALS}', "");
    Expect(0, 42191, '\p{^	 In_Yi_RADICALS}', "");
    Expect(0, 42191, '\P{	 In_Yi_RADICALS}', "");
    Expect(1, 42191, '\P{^	 In_Yi_RADICALS}', "");
    Expect(0, 42192, '\p{	 In_Yi_RADICALS}', "");
    Expect(1, 42192, '\p{^	 In_Yi_RADICALS}', "");
    Expect(1, 42192, '\P{	 In_Yi_RADICALS}', "");
    Expect(0, 42192, '\P{^	 In_Yi_RADICALS}', "");
    Error('\p{-YI_Syllables/a/}');
    Error('\P{-YI_Syllables/a/}');
    Expect(1, 42127, '\p{yisyllables}', "");
    Expect(0, 42127, '\p{^yisyllables}', "");
    Expect(0, 42127, '\P{yisyllables}', "");
    Expect(1, 42127, '\P{^yisyllables}', "");
    Expect(0, 42128, '\p{yisyllables}', "");
    Expect(1, 42128, '\p{^yisyllables}', "");
    Expect(1, 42128, '\P{yisyllables}', "");
    Expect(0, 42128, '\P{^yisyllables}', "");
    Expect(1, 42127, '\p{_-YI_Syllables}', "");
    Expect(0, 42127, '\p{^_-YI_Syllables}', "");
    Expect(0, 42127, '\P{_-YI_Syllables}', "");
    Expect(1, 42127, '\P{^_-YI_Syllables}', "");
    Expect(0, 42128, '\p{_-YI_Syllables}', "");
    Expect(1, 42128, '\p{^_-YI_Syllables}', "");
    Expect(1, 42128, '\P{_-YI_Syllables}', "");
    Expect(0, 42128, '\P{^_-YI_Syllables}', "");
    Error('\p{-/a/Is_Yi_Syllables}');
    Error('\P{-/a/Is_Yi_Syllables}');
    Expect(1, 42127, '\p{isyisyllables}', "");
    Expect(0, 42127, '\p{^isyisyllables}', "");
    Expect(0, 42127, '\P{isyisyllables}', "");
    Expect(1, 42127, '\P{^isyisyllables}', "");
    Expect(0, 42128, '\p{isyisyllables}', "");
    Expect(1, 42128, '\p{^isyisyllables}', "");
    Expect(1, 42128, '\P{isyisyllables}', "");
    Expect(0, 42128, '\P{^isyisyllables}', "");
    Expect(1, 42127, '\p{- Is_Yi_syllables}', "");
    Expect(0, 42127, '\p{^- Is_Yi_syllables}', "");
    Expect(0, 42127, '\P{- Is_Yi_syllables}', "");
    Expect(1, 42127, '\P{^- Is_Yi_syllables}', "");
    Expect(0, 42128, '\p{- Is_Yi_syllables}', "");
    Expect(1, 42128, '\p{^- Is_Yi_syllables}', "");
    Expect(1, 42128, '\P{- Is_Yi_syllables}', "");
    Expect(0, 42128, '\P{^- Is_Yi_syllables}', "");
    Error('\p{-/a/In_Yi_syllables}');
    Error('\P{-/a/In_Yi_syllables}');
    Expect(1, 42127, '\p{inyisyllables}', "");
    Expect(0, 42127, '\p{^inyisyllables}', "");
    Expect(0, 42127, '\P{inyisyllables}', "");
    Expect(1, 42127, '\P{^inyisyllables}', "");
    Expect(0, 42128, '\p{inyisyllables}', "");
    Expect(1, 42128, '\p{^inyisyllables}', "");
    Expect(1, 42128, '\P{inyisyllables}', "");
    Expect(0, 42128, '\P{^inyisyllables}', "");
    Expect(1, 42127, '\p{in_Yi_Syllables}', "");
    Expect(0, 42127, '\p{^in_Yi_Syllables}', "");
    Expect(0, 42127, '\P{in_Yi_Syllables}', "");
    Expect(1, 42127, '\P{^in_Yi_Syllables}', "");
    Expect(0, 42128, '\p{in_Yi_Syllables}', "");
    Expect(1, 42128, '\p{^in_Yi_Syllables}', "");
    Expect(1, 42128, '\P{in_Yi_Syllables}', "");
    Expect(0, 42128, '\P{^in_Yi_Syllables}', "");
    Error('\p{	/a/YIJING_Hexagram_SYMBOLS}');
    Error('\P{	/a/YIJING_Hexagram_SYMBOLS}');
    Expect(1, 19967, '\p{yijinghexagramsymbols}', "");
    Expect(0, 19967, '\p{^yijinghexagramsymbols}', "");
    Expect(0, 19967, '\P{yijinghexagramsymbols}', "");
    Expect(1, 19967, '\P{^yijinghexagramsymbols}', "");
    Expect(0, 19968, '\p{yijinghexagramsymbols}', "");
    Expect(1, 19968, '\p{^yijinghexagramsymbols}', "");
    Expect(1, 19968, '\P{yijinghexagramsymbols}', "");
    Expect(0, 19968, '\P{^yijinghexagramsymbols}', "");
    Expect(1, 19967, '\p{_ Yijing_Hexagram_symbols}', "");
    Expect(0, 19967, '\p{^_ Yijing_Hexagram_symbols}', "");
    Expect(0, 19967, '\P{_ Yijing_Hexagram_symbols}', "");
    Expect(1, 19967, '\P{^_ Yijing_Hexagram_symbols}', "");
    Expect(0, 19968, '\p{_ Yijing_Hexagram_symbols}', "");
    Expect(1, 19968, '\p{^_ Yijing_Hexagram_symbols}', "");
    Expect(1, 19968, '\P{_ Yijing_Hexagram_symbols}', "");
    Expect(0, 19968, '\P{^_ Yijing_Hexagram_symbols}', "");
    Error('\p{	/a/is_Yijing_HEXAGRAM_SYMBOLS}');
    Error('\P{	/a/is_Yijing_HEXAGRAM_SYMBOLS}');
    Expect(1, 19967, '\p{isyijinghexagramsymbols}', "");
    Expect(0, 19967, '\p{^isyijinghexagramsymbols}', "");
    Expect(0, 19967, '\P{isyijinghexagramsymbols}', "");
    Expect(1, 19967, '\P{^isyijinghexagramsymbols}', "");
    Expect(0, 19968, '\p{isyijinghexagramsymbols}', "");
    Expect(1, 19968, '\p{^isyijinghexagramsymbols}', "");
    Expect(1, 19968, '\P{isyijinghexagramsymbols}', "");
    Expect(0, 19968, '\P{^isyijinghexagramsymbols}', "");
    Expect(1, 19967, '\p{ Is_Yijing_hexagram_symbols}', "");
    Expect(0, 19967, '\p{^ Is_Yijing_hexagram_symbols}', "");
    Expect(0, 19967, '\P{ Is_Yijing_hexagram_symbols}', "");
    Expect(1, 19967, '\P{^ Is_Yijing_hexagram_symbols}', "");
    Expect(0, 19968, '\p{ Is_Yijing_hexagram_symbols}', "");
    Expect(1, 19968, '\p{^ Is_Yijing_hexagram_symbols}', "");
    Expect(1, 19968, '\P{ Is_Yijing_hexagram_symbols}', "");
    Expect(0, 19968, '\P{^ Is_Yijing_hexagram_symbols}', "");
    Error('\p{-_IN_Yijing_Hexagram_SYMBOLS:=}');
    Error('\P{-_IN_Yijing_Hexagram_SYMBOLS:=}');
    Expect(1, 19967, '\p{inyijinghexagramsymbols}', "");
    Expect(0, 19967, '\p{^inyijinghexagramsymbols}', "");
    Expect(0, 19967, '\P{inyijinghexagramsymbols}', "");
    Expect(1, 19967, '\P{^inyijinghexagramsymbols}', "");
    Expect(0, 19968, '\p{inyijinghexagramsymbols}', "");
    Expect(1, 19968, '\p{^inyijinghexagramsymbols}', "");
    Expect(1, 19968, '\P{inyijinghexagramsymbols}', "");
    Expect(0, 19968, '\P{^inyijinghexagramsymbols}', "");
    Expect(1, 19967, '\p{-in_yijing_hexagram_symbols}', "");
    Expect(0, 19967, '\p{^-in_yijing_hexagram_symbols}', "");
    Expect(0, 19967, '\P{-in_yijing_hexagram_symbols}', "");
    Expect(1, 19967, '\P{^-in_yijing_hexagram_symbols}', "");
    Expect(0, 19968, '\p{-in_yijing_hexagram_symbols}', "");
    Expect(1, 19968, '\p{^-in_yijing_hexagram_symbols}', "");
    Expect(1, 19968, '\P{-in_yijing_hexagram_symbols}', "");
    Expect(0, 19968, '\P{^-in_yijing_hexagram_symbols}', "");
    Error('\p{ 	Yijing:=}');
    Error('\P{ 	Yijing:=}');
    Expect(1, 19967, '\p{yijing}', "");
    Expect(0, 19967, '\p{^yijing}', "");
    Expect(0, 19967, '\P{yijing}', "");
    Expect(1, 19967, '\P{^yijing}', "");
    Expect(0, 19968, '\p{yijing}', "");
    Expect(1, 19968, '\p{^yijing}', "");
    Expect(1, 19968, '\P{yijing}', "");
    Expect(0, 19968, '\P{^yijing}', "");
    Expect(1, 19967, '\p{-yijing}', "");
    Expect(0, 19967, '\p{^-yijing}', "");
    Expect(0, 19967, '\P{-yijing}', "");
    Expect(1, 19967, '\P{^-yijing}', "");
    Expect(0, 19968, '\p{-yijing}', "");
    Expect(1, 19968, '\p{^-yijing}', "");
    Expect(1, 19968, '\P{-yijing}', "");
    Expect(0, 19968, '\P{^-yijing}', "");
    Error('\p{:=-_Is_YIJING}');
    Error('\P{:=-_Is_YIJING}');
    Expect(1, 19967, '\p{isyijing}', "");
    Expect(0, 19967, '\p{^isyijing}', "");
    Expect(0, 19967, '\P{isyijing}', "");
    Expect(1, 19967, '\P{^isyijing}', "");
    Expect(0, 19968, '\p{isyijing}', "");
    Expect(1, 19968, '\p{^isyijing}', "");
    Expect(1, 19968, '\P{isyijing}', "");
    Expect(0, 19968, '\P{^isyijing}', "");
    Expect(1, 19967, '\p{	Is_yijing}', "");
    Expect(0, 19967, '\p{^	Is_yijing}', "");
    Expect(0, 19967, '\P{	Is_yijing}', "");
    Expect(1, 19967, '\P{^	Is_yijing}', "");
    Expect(0, 19968, '\p{	Is_yijing}', "");
    Expect(1, 19968, '\p{^	Is_yijing}', "");
    Expect(1, 19968, '\P{	Is_yijing}', "");
    Expect(0, 19968, '\P{^	Is_yijing}', "");
    Error('\p{ 	IN_YIJING:=}');
    Error('\P{ 	IN_YIJING:=}');
    Expect(1, 19967, '\p{inyijing}', "");
    Expect(0, 19967, '\p{^inyijing}', "");
    Expect(0, 19967, '\P{inyijing}', "");
    Expect(1, 19967, '\P{^inyijing}', "");
    Expect(0, 19968, '\p{inyijing}', "");
    Expect(1, 19968, '\p{^inyijing}', "");
    Expect(1, 19968, '\P{inyijing}', "");
    Expect(0, 19968, '\P{^inyijing}', "");
    Expect(1, 19967, '\p{_in_Yijing}', "");
    Expect(0, 19967, '\p{^_in_Yijing}', "");
    Expect(0, 19967, '\P{_in_Yijing}', "");
    Expect(1, 19967, '\P{^_in_Yijing}', "");
    Expect(0, 19968, '\p{_in_Yijing}', "");
    Expect(1, 19968, '\p{^_in_Yijing}', "");
    Expect(1, 19968, '\P{_in_Yijing}', "");
    Expect(0, 19968, '\P{^_in_Yijing}', "");
    Error('\p{- Zanabazar_SQUARE/a/}');
    Error('\P{- Zanabazar_SQUARE/a/}');
    Expect(1, 72263, '\p{zanabazarsquare}', "");
    Expect(0, 72263, '\p{^zanabazarsquare}', "");
    Expect(0, 72263, '\P{zanabazarsquare}', "");
    Expect(1, 72263, '\P{^zanabazarsquare}', "");
    Expect(0, 72264, '\p{zanabazarsquare}', "");
    Expect(1, 72264, '\p{^zanabazarsquare}', "");
    Expect(1, 72264, '\P{zanabazarsquare}', "");
    Expect(0, 72264, '\P{^zanabazarsquare}', "");
    Expect(1, 72263, '\p{Zanabazar_SQUARE}', "");
    Expect(0, 72263, '\p{^Zanabazar_SQUARE}', "");
    Expect(0, 72263, '\P{Zanabazar_SQUARE}', "");
    Expect(1, 72263, '\P{^Zanabazar_SQUARE}', "");
    Expect(0, 72264, '\p{Zanabazar_SQUARE}', "");
    Expect(1, 72264, '\p{^Zanabazar_SQUARE}', "");
    Expect(1, 72264, '\P{Zanabazar_SQUARE}', "");
    Expect(0, 72264, '\P{^Zanabazar_SQUARE}', "");
    Error('\p{-	IS_ZANABAZAR_Square:=}');
    Error('\P{-	IS_ZANABAZAR_Square:=}');
    Expect(1, 72263, '\p{iszanabazarsquare}', "");
    Expect(0, 72263, '\p{^iszanabazarsquare}', "");
    Expect(0, 72263, '\P{iszanabazarsquare}', "");
    Expect(1, 72263, '\P{^iszanabazarsquare}', "");
    Expect(0, 72264, '\p{iszanabazarsquare}', "");
    Expect(1, 72264, '\p{^iszanabazarsquare}', "");
    Expect(1, 72264, '\P{iszanabazarsquare}', "");
    Expect(0, 72264, '\P{^iszanabazarsquare}', "");
    Expect(1, 72263, '\p{_ is_Zanabazar_SQUARE}', "");
    Expect(0, 72263, '\p{^_ is_Zanabazar_SQUARE}', "");
    Expect(0, 72263, '\P{_ is_Zanabazar_SQUARE}', "");
    Expect(1, 72263, '\P{^_ is_Zanabazar_SQUARE}', "");
    Expect(0, 72264, '\p{_ is_Zanabazar_SQUARE}', "");
    Expect(1, 72264, '\p{^_ is_Zanabazar_SQUARE}', "");
    Expect(1, 72264, '\P{_ is_Zanabazar_SQUARE}', "");
    Expect(0, 72264, '\P{^_ is_Zanabazar_SQUARE}', "");
    Error('\p{	 Zanb/a/}');
    Error('\P{	 Zanb/a/}');
    Expect(1, 72263, '\p{zanb}', "");
    Expect(0, 72263, '\p{^zanb}', "");
    Expect(0, 72263, '\P{zanb}', "");
    Expect(1, 72263, '\P{^zanb}', "");
    Expect(0, 72264, '\p{zanb}', "");
    Expect(1, 72264, '\p{^zanb}', "");
    Expect(1, 72264, '\P{zanb}', "");
    Expect(0, 72264, '\P{^zanb}', "");
    Expect(1, 72263, '\p{--ZANB}', "");
    Expect(0, 72263, '\p{^--ZANB}', "");
    Expect(0, 72263, '\P{--ZANB}', "");
    Expect(1, 72263, '\P{^--ZANB}', "");
    Expect(0, 72264, '\p{--ZANB}', "");
    Expect(1, 72264, '\p{^--ZANB}', "");
    Expect(1, 72264, '\P{--ZANB}', "");
    Expect(0, 72264, '\P{^--ZANB}', "");
    Error('\p{	:=Is_Zanb}');
    Error('\P{	:=Is_Zanb}');
    Expect(1, 72263, '\p{iszanb}', "");
    Expect(0, 72263, '\p{^iszanb}', "");
    Expect(0, 72263, '\P{iszanb}', "");
    Expect(1, 72263, '\P{^iszanb}', "");
    Expect(0, 72264, '\p{iszanb}', "");
    Expect(1, 72264, '\p{^iszanb}', "");
    Expect(1, 72264, '\P{iszanb}', "");
    Expect(0, 72264, '\P{^iszanb}', "");
    Expect(1, 72263, '\p{_is_ZANB}', "");
    Expect(0, 72263, '\p{^_is_ZANB}', "");
    Expect(0, 72263, '\P{_is_ZANB}', "");
    Expect(1, 72263, '\P{^_is_ZANB}', "");
    Expect(0, 72264, '\p{_is_ZANB}', "");
    Expect(1, 72264, '\p{^_is_ZANB}', "");
    Expect(1, 72264, '\P{_is_ZANB}', "");
    Expect(0, 72264, '\P{^_is_ZANB}', "");
    Error('\p{perlcharnames}');
    Error('\P{perlcharnames}');
    Error('\p{perldecimaldigit}');
    Error('\P{perldecimaldigit}');
    Error('\p{perldecompositionmapping}');
    Error('\P{perldecompositionmapping}');
    Error('\p{Quotation_Mark= /a/no}');
    Error('\P{Quotation_Mark= /a/no}');
    Expect(1, 65380, '\p{Quotation_Mark=no}', "");
    Expect(0, 65380, '\p{^Quotation_Mark=no}', "");
    Expect(0, 65380, '\P{Quotation_Mark=no}', "");
    Expect(1, 65380, '\P{^Quotation_Mark=no}', "");
    Expect(0, 65379, '\p{Quotation_Mark=no}', "");
    Expect(1, 65379, '\p{^Quotation_Mark=no}', "");
    Expect(1, 65379, '\P{Quotation_Mark=no}', "");
    Expect(0, 65379, '\P{^Quotation_Mark=no}', "");
    Expect(1, 65380, '\p{Quotation_Mark=-No}', "");
    Expect(0, 65380, '\p{^Quotation_Mark=-No}', "");
    Expect(0, 65380, '\P{Quotation_Mark=-No}', "");
    Expect(1, 65380, '\P{^Quotation_Mark=-No}', "");
    Expect(0, 65379, '\p{Quotation_Mark=-No}', "");
    Expect(1, 65379, '\p{^Quotation_Mark=-No}', "");
    Expect(1, 65379, '\P{Quotation_Mark=-No}', "");
    Expect(0, 65379, '\P{^Quotation_Mark=-No}', "");
    Error('\p{QMark= :=n}');
    Error('\P{QMark= :=n}');
    Expect(1, 65380, '\p{QMark=n}', "");
    Expect(0, 65380, '\p{^QMark=n}', "");
    Expect(0, 65380, '\P{QMark=n}', "");
    Expect(1, 65380, '\P{^QMark=n}', "");
    Expect(0, 65379, '\p{QMark=n}', "");
    Expect(1, 65379, '\p{^QMark=n}', "");
    Expect(1, 65379, '\P{QMark=n}', "");
    Expect(0, 65379, '\P{^QMark=n}', "");
    Expect(1, 65380, '\p{QMark:    n}', "");
    Expect(0, 65380, '\p{^QMark:    n}', "");
    Expect(0, 65380, '\P{QMark:    n}', "");
    Expect(1, 65380, '\P{^QMark:    n}', "");
    Expect(0, 65379, '\p{QMark:    n}', "");
    Expect(1, 65379, '\p{^QMark:    n}', "");
    Expect(1, 65379, '\P{QMark:    n}', "");
    Expect(0, 65379, '\P{^QMark:    n}', "");
    Error('\p{Is_Quotation_Mark=-	F:=}');
    Error('\P{Is_Quotation_Mark=-	F:=}');
    Expect(1, 65380, '\p{Is_Quotation_Mark:	f}', "");
    Expect(0, 65380, '\p{^Is_Quotation_Mark:	f}', "");
    Expect(0, 65380, '\P{Is_Quotation_Mark:	f}', "");
    Expect(1, 65380, '\P{^Is_Quotation_Mark:	f}', "");
    Expect(0, 65379, '\p{Is_Quotation_Mark:	f}', "");
    Expect(1, 65379, '\p{^Is_Quotation_Mark:	f}', "");
    Expect(1, 65379, '\P{Is_Quotation_Mark:	f}', "");
    Expect(0, 65379, '\P{^Is_Quotation_Mark:	f}', "");
    Expect(1, 65380, '\p{Is_Quotation_Mark=_ F}', "");
    Expect(0, 65380, '\p{^Is_Quotation_Mark=_ F}', "");
    Expect(0, 65380, '\P{Is_Quotation_Mark=_ F}', "");
    Expect(1, 65380, '\P{^Is_Quotation_Mark=_ F}', "");
    Expect(0, 65379, '\p{Is_Quotation_Mark=_ F}', "");
    Expect(1, 65379, '\p{^Is_Quotation_Mark=_ F}', "");
    Expect(1, 65379, '\P{Is_Quotation_Mark=_ F}', "");
    Expect(0, 65379, '\P{^Is_Quotation_Mark=_ F}', "");
    Error('\p{Is_QMark=	/a/False}');
    Error('\P{Is_QMark=	/a/False}');
    Expect(1, 65380, '\p{Is_QMark=false}', "");
    Expect(0, 65380, '\p{^Is_QMark=false}', "");
    Expect(0, 65380, '\P{Is_QMark=false}', "");
    Expect(1, 65380, '\P{^Is_QMark=false}', "");
    Expect(0, 65379, '\p{Is_QMark=false}', "");
    Expect(1, 65379, '\p{^Is_QMark=false}', "");
    Expect(1, 65379, '\P{Is_QMark=false}', "");
    Expect(0, 65379, '\P{^Is_QMark=false}', "");
    Expect(1, 65380, '\p{Is_QMark=-_False}', "");
    Expect(0, 65380, '\p{^Is_QMark=-_False}', "");
    Expect(0, 65380, '\P{Is_QMark=-_False}', "");
    Expect(1, 65380, '\P{^Is_QMark=-_False}', "");
    Expect(0, 65379, '\p{Is_QMark=-_False}', "");
    Expect(1, 65379, '\p{^Is_QMark=-_False}', "");
    Expect(1, 65379, '\P{Is_QMark=-_False}', "");
    Expect(0, 65379, '\P{^Is_QMark=-_False}', "");
    Error('\p{Quotation_Mark=  Yes:=}');
    Error('\P{Quotation_Mark=  Yes:=}');
    Expect(1, 65379, '\p{Quotation_Mark=yes}', "");
    Expect(0, 65379, '\p{^Quotation_Mark=yes}', "");
    Expect(0, 65379, '\P{Quotation_Mark=yes}', "");
    Expect(1, 65379, '\P{^Quotation_Mark=yes}', "");
    Expect(0, 65380, '\p{Quotation_Mark=yes}', "");
    Expect(1, 65380, '\p{^Quotation_Mark=yes}', "");
    Expect(1, 65380, '\P{Quotation_Mark=yes}', "");
    Expect(0, 65380, '\P{^Quotation_Mark=yes}', "");
    Expect(1, 65379, '\p{Quotation_Mark: _Yes}', "");
    Expect(0, 65379, '\p{^Quotation_Mark: _Yes}', "");
    Expect(0, 65379, '\P{Quotation_Mark: _Yes}', "");
    Expect(1, 65379, '\P{^Quotation_Mark: _Yes}', "");
    Expect(0, 65380, '\p{Quotation_Mark: _Yes}', "");
    Expect(1, 65380, '\p{^Quotation_Mark: _Yes}', "");
    Expect(1, 65380, '\P{Quotation_Mark: _Yes}', "");
    Expect(0, 65380, '\P{^Quotation_Mark: _Yes}', "");
    Error('\p{QMark=:= y}');
    Error('\P{QMark=:= y}');
    Expect(1, 65379, '\p{QMark=y}', "");
    Expect(0, 65379, '\p{^QMark=y}', "");
    Expect(0, 65379, '\P{QMark=y}', "");
    Expect(1, 65379, '\P{^QMark=y}', "");
    Expect(0, 65380, '\p{QMark=y}', "");
    Expect(1, 65380, '\p{^QMark=y}', "");
    Expect(1, 65380, '\P{QMark=y}', "");
    Expect(0, 65380, '\P{^QMark=y}', "");
    Expect(1, 65379, '\p{QMark: y}', "");
    Expect(0, 65379, '\p{^QMark: y}', "");
    Expect(0, 65379, '\P{QMark: y}', "");
    Expect(1, 65379, '\P{^QMark: y}', "");
    Expect(0, 65380, '\p{QMark: y}', "");
    Expect(1, 65380, '\p{^QMark: y}', "");
    Expect(1, 65380, '\P{QMark: y}', "");
    Expect(0, 65380, '\P{^QMark: y}', "");
    Error('\p{Is_Quotation_Mark=-:=T}');
    Error('\P{Is_Quotation_Mark=-:=T}');
    Expect(1, 65379, '\p{Is_Quotation_Mark=t}', "");
    Expect(0, 65379, '\p{^Is_Quotation_Mark=t}', "");
    Expect(0, 65379, '\P{Is_Quotation_Mark=t}', "");
    Expect(1, 65379, '\P{^Is_Quotation_Mark=t}', "");
    Expect(0, 65380, '\p{Is_Quotation_Mark=t}', "");
    Expect(1, 65380, '\p{^Is_Quotation_Mark=t}', "");
    Expect(1, 65380, '\P{Is_Quotation_Mark=t}', "");
    Expect(0, 65380, '\P{^Is_Quotation_Mark=t}', "");
    Expect(1, 65379, '\p{Is_Quotation_Mark=__t}', "");
    Expect(0, 65379, '\p{^Is_Quotation_Mark=__t}', "");
    Expect(0, 65379, '\P{Is_Quotation_Mark=__t}', "");
    Expect(1, 65379, '\P{^Is_Quotation_Mark=__t}', "");
    Expect(0, 65380, '\p{Is_Quotation_Mark=__t}', "");
    Expect(1, 65380, '\p{^Is_Quotation_Mark=__t}', "");
    Expect(1, 65380, '\P{Is_Quotation_Mark=__t}', "");
    Expect(0, 65380, '\P{^Is_Quotation_Mark=__t}', "");
    Error('\p{Is_QMark=/a/-	True}');
    Error('\P{Is_QMark=/a/-	True}');
    Expect(1, 65379, '\p{Is_QMark:   true}', "");
    Expect(0, 65379, '\p{^Is_QMark:   true}', "");
    Expect(0, 65379, '\P{Is_QMark:   true}', "");
    Expect(1, 65379, '\P{^Is_QMark:   true}', "");
    Expect(0, 65380, '\p{Is_QMark:   true}', "");
    Expect(1, 65380, '\p{^Is_QMark:   true}', "");
    Expect(1, 65380, '\P{Is_QMark:   true}', "");
    Expect(0, 65380, '\P{^Is_QMark:   true}', "");
    Expect(1, 65379, '\p{Is_QMark= true}', "");
    Expect(0, 65379, '\p{^Is_QMark= true}', "");
    Expect(0, 65379, '\P{Is_QMark= true}', "");
    Expect(1, 65379, '\P{^Is_QMark= true}', "");
    Expect(0, 65380, '\p{Is_QMark= true}', "");
    Expect(1, 65380, '\p{^Is_QMark= true}', "");
    Expect(1, 65380, '\P{Is_QMark= true}', "");
    Expect(0, 65380, '\P{^Is_QMark= true}', "");
    Error('\p{Radical=/a/	-NO}');
    Error('\P{Radical=/a/	-NO}');
    Expect(1, 12246, '\p{Radical:	no}', "");
    Expect(0, 12246, '\p{^Radical:	no}', "");
    Expect(0, 12246, '\P{Radical:	no}', "");
    Expect(1, 12246, '\P{^Radical:	no}', "");
    Expect(0, 12245, '\p{Radical:	no}', "");
    Expect(1, 12245, '\p{^Radical:	no}', "");
    Expect(1, 12245, '\P{Radical:	no}', "");
    Expect(0, 12245, '\P{^Radical:	no}', "");
    Expect(1, 12246, '\p{Radical=		No}', "");
    Expect(0, 12246, '\p{^Radical=		No}', "");
    Expect(0, 12246, '\P{Radical=		No}', "");
    Expect(1, 12246, '\P{^Radical=		No}', "");
    Expect(0, 12245, '\p{Radical=		No}', "");
    Expect(1, 12245, '\p{^Radical=		No}', "");
    Expect(1, 12245, '\P{Radical=		No}', "");
    Expect(0, 12245, '\P{^Radical=		No}', "");
    Error('\p{Is_Radical=-	N:=}');
    Error('\P{Is_Radical=-	N:=}');
    Expect(1, 12246, '\p{Is_Radical=n}', "");
    Expect(0, 12246, '\p{^Is_Radical=n}', "");
    Expect(0, 12246, '\P{Is_Radical=n}', "");
    Expect(1, 12246, '\P{^Is_Radical=n}', "");
    Expect(0, 12245, '\p{Is_Radical=n}', "");
    Expect(1, 12245, '\p{^Is_Radical=n}', "");
    Expect(1, 12245, '\P{Is_Radical=n}', "");
    Expect(0, 12245, '\P{^Is_Radical=n}', "");
    Expect(1, 12246, '\p{Is_Radical=	-N}', "");
    Expect(0, 12246, '\p{^Is_Radical=	-N}', "");
    Expect(0, 12246, '\P{Is_Radical=	-N}', "");
    Expect(1, 12246, '\P{^Is_Radical=	-N}', "");
    Expect(0, 12245, '\p{Is_Radical=	-N}', "");
    Expect(1, 12245, '\p{^Is_Radical=	-N}', "");
    Expect(1, 12245, '\P{Is_Radical=	-N}', "");
    Expect(0, 12245, '\P{^Is_Radical=	-N}', "");
    Error('\p{Radical=	/a/F}');
    Error('\P{Radical=	/a/F}');
    Expect(1, 12246, '\p{Radical=f}', "");
    Expect(0, 12246, '\p{^Radical=f}', "");
    Expect(0, 12246, '\P{Radical=f}', "");
    Expect(1, 12246, '\P{^Radical=f}', "");
    Expect(0, 12245, '\p{Radical=f}', "");
    Expect(1, 12245, '\p{^Radical=f}', "");
    Expect(1, 12245, '\P{Radical=f}', "");
    Expect(0, 12245, '\P{^Radical=f}', "");
    Expect(1, 12246, '\p{Radical=_F}', "");
    Expect(0, 12246, '\p{^Radical=_F}', "");
    Expect(0, 12246, '\P{Radical=_F}', "");
    Expect(1, 12246, '\P{^Radical=_F}', "");
    Expect(0, 12245, '\p{Radical=_F}', "");
    Expect(1, 12245, '\p{^Radical=_F}', "");
    Expect(1, 12245, '\P{Radical=_F}', "");
    Expect(0, 12245, '\P{^Radical=_F}', "");
    Error('\p{Is_Radical=-:=False}');
    Error('\P{Is_Radical=-:=False}');
    Expect(1, 12246, '\p{Is_Radical=false}', "");
    Expect(0, 12246, '\p{^Is_Radical=false}', "");
    Expect(0, 12246, '\P{Is_Radical=false}', "");
    Expect(1, 12246, '\P{^Is_Radical=false}', "");
    Expect(0, 12245, '\p{Is_Radical=false}', "");
    Expect(1, 12245, '\p{^Is_Radical=false}', "");
    Expect(1, 12245, '\P{Is_Radical=false}', "");
    Expect(0, 12245, '\P{^Is_Radical=false}', "");
    Expect(1, 12246, '\p{Is_Radical=- False}', "");
    Expect(0, 12246, '\p{^Is_Radical=- False}', "");
    Expect(0, 12246, '\P{Is_Radical=- False}', "");
    Expect(1, 12246, '\P{^Is_Radical=- False}', "");
    Expect(0, 12245, '\p{Is_Radical=- False}', "");
    Expect(1, 12245, '\p{^Is_Radical=- False}', "");
    Expect(1, 12245, '\P{Is_Radical=- False}', "");
    Expect(0, 12245, '\P{^Is_Radical=- False}', "");
    Error('\p{Radical= /a/Yes}');
    Error('\P{Radical= /a/Yes}');
    Expect(1, 12245, '\p{Radical=yes}', "");
    Expect(0, 12245, '\p{^Radical=yes}', "");
    Expect(0, 12245, '\P{Radical=yes}', "");
    Expect(1, 12245, '\P{^Radical=yes}', "");
    Expect(0, 12246, '\p{Radical=yes}', "");
    Expect(1, 12246, '\p{^Radical=yes}', "");
    Expect(1, 12246, '\P{Radical=yes}', "");
    Expect(0, 12246, '\P{^Radical=yes}', "");
    Expect(1, 12245, '\p{Radical=_-Yes}', "");
    Expect(0, 12245, '\p{^Radical=_-Yes}', "");
    Expect(0, 12245, '\P{Radical=_-Yes}', "");
    Expect(1, 12245, '\P{^Radical=_-Yes}', "");
    Expect(0, 12246, '\p{Radical=_-Yes}', "");
    Expect(1, 12246, '\p{^Radical=_-Yes}', "");
    Expect(1, 12246, '\P{Radical=_-Yes}', "");
    Expect(0, 12246, '\P{^Radical=_-Yes}', "");
    Error('\p{Is_Radical=	 Y/a/}');
    Error('\P{Is_Radical=	 Y/a/}');
    Expect(1, 12245, '\p{Is_Radical=y}', "");
    Expect(0, 12245, '\p{^Is_Radical=y}', "");
    Expect(0, 12245, '\P{Is_Radical=y}', "");
    Expect(1, 12245, '\P{^Is_Radical=y}', "");
    Expect(0, 12246, '\p{Is_Radical=y}', "");
    Expect(1, 12246, '\p{^Is_Radical=y}', "");
    Expect(1, 12246, '\P{Is_Radical=y}', "");
    Expect(0, 12246, '\P{^Is_Radical=y}', "");
    Expect(1, 12245, '\p{Is_Radical= Y}', "");
    Expect(0, 12245, '\p{^Is_Radical= Y}', "");
    Expect(0, 12245, '\P{Is_Radical= Y}', "");
    Expect(1, 12245, '\P{^Is_Radical= Y}', "");
    Expect(0, 12246, '\p{Is_Radical= Y}', "");
    Expect(1, 12246, '\p{^Is_Radical= Y}', "");
    Expect(1, 12246, '\P{Is_Radical= Y}', "");
    Expect(0, 12246, '\P{^Is_Radical= Y}', "");
    Error('\p{Radical=:=  T}');
    Error('\P{Radical=:=  T}');
    Expect(1, 12245, '\p{Radical=t}', "");
    Expect(0, 12245, '\p{^Radical=t}', "");
    Expect(0, 12245, '\P{Radical=t}', "");
    Expect(1, 12245, '\P{^Radical=t}', "");
    Expect(0, 12246, '\p{Radical=t}', "");
    Expect(1, 12246, '\p{^Radical=t}', "");
    Expect(1, 12246, '\P{Radical=t}', "");
    Expect(0, 12246, '\P{^Radical=t}', "");
    Expect(1, 12245, '\p{Radical:	-	t}', "");
    Expect(0, 12245, '\p{^Radical:	-	t}', "");
    Expect(0, 12245, '\P{Radical:	-	t}', "");
    Expect(1, 12245, '\P{^Radical:	-	t}', "");
    Expect(0, 12246, '\p{Radical:	-	t}', "");
    Expect(1, 12246, '\p{^Radical:	-	t}', "");
    Expect(1, 12246, '\P{Radical:	-	t}', "");
    Expect(0, 12246, '\P{^Radical:	-	t}', "");
    Error('\p{Is_Radical=:=True}');
    Error('\P{Is_Radical=:=True}');
    Expect(1, 12245, '\p{Is_Radical=true}', "");
    Expect(0, 12245, '\p{^Is_Radical=true}', "");
    Expect(0, 12245, '\P{Is_Radical=true}', "");
    Expect(1, 12245, '\P{^Is_Radical=true}', "");
    Expect(0, 12246, '\p{Is_Radical=true}', "");
    Expect(1, 12246, '\p{^Is_Radical=true}', "");
    Expect(1, 12246, '\P{Is_Radical=true}', "");
    Expect(0, 12246, '\P{^Is_Radical=true}', "");
    Expect(1, 12245, '\p{Is_Radical=-	True}', "");
    Expect(0, 12245, '\p{^Is_Radical=-	True}', "");
    Expect(0, 12245, '\P{Is_Radical=-	True}', "");
    Expect(1, 12245, '\P{^Is_Radical=-	True}', "");
    Expect(0, 12246, '\p{Is_Radical=-	True}', "");
    Expect(1, 12246, '\p{^Is_Radical=-	True}', "");
    Expect(1, 12246, '\P{Is_Radical=-	True}', "");
    Expect(0, 12246, '\P{^Is_Radical=-	True}', "");
    Error('\p{Regional_Indicator=	No:=}');
    Error('\P{Regional_Indicator=	No:=}');
    Expect(1, 127488, '\p{Regional_Indicator=no}', "");
    Expect(0, 127488, '\p{^Regional_Indicator=no}', "");
    Expect(0, 127488, '\P{Regional_Indicator=no}', "");
    Expect(1, 127488, '\P{^Regional_Indicator=no}', "");
    Expect(0, 127487, '\p{Regional_Indicator=no}', "");
    Expect(1, 127487, '\p{^Regional_Indicator=no}', "");
    Expect(1, 127487, '\P{Regional_Indicator=no}', "");
    Expect(0, 127487, '\P{^Regional_Indicator=no}', "");
    Expect(1, 127488, '\p{Regional_Indicator=	-No}', "");
    Expect(0, 127488, '\p{^Regional_Indicator=	-No}', "");
    Expect(0, 127488, '\P{Regional_Indicator=	-No}', "");
    Expect(1, 127488, '\P{^Regional_Indicator=	-No}', "");
    Expect(0, 127487, '\p{Regional_Indicator=	-No}', "");
    Expect(1, 127487, '\p{^Regional_Indicator=	-No}', "");
    Expect(1, 127487, '\P{Regional_Indicator=	-No}', "");
    Expect(0, 127487, '\P{^Regional_Indicator=	-No}', "");
    Error('\p{RI=:=N}');
    Error('\P{RI=:=N}');
    Expect(1, 127488, '\p{RI=n}', "");
    Expect(0, 127488, '\p{^RI=n}', "");
    Expect(0, 127488, '\P{RI=n}', "");
    Expect(1, 127488, '\P{^RI=n}', "");
    Expect(0, 127487, '\p{RI=n}', "");
    Expect(1, 127487, '\p{^RI=n}', "");
    Expect(1, 127487, '\P{RI=n}', "");
    Expect(0, 127487, '\P{^RI=n}', "");
    Expect(1, 127488, '\p{RI=-	N}', "");
    Expect(0, 127488, '\p{^RI=-	N}', "");
    Expect(0, 127488, '\P{RI=-	N}', "");
    Expect(1, 127488, '\P{^RI=-	N}', "");
    Expect(0, 127487, '\p{RI=-	N}', "");
    Expect(1, 127487, '\p{^RI=-	N}', "");
    Expect(1, 127487, '\P{RI=-	N}', "");
    Expect(0, 127487, '\P{^RI=-	N}', "");
    Error('\p{Is_Regional_Indicator=-/a/F}');
    Error('\P{Is_Regional_Indicator=-/a/F}');
    Expect(1, 127488, '\p{Is_Regional_Indicator=f}', "");
    Expect(0, 127488, '\p{^Is_Regional_Indicator=f}', "");
    Expect(0, 127488, '\P{Is_Regional_Indicator=f}', "");
    Expect(1, 127488, '\P{^Is_Regional_Indicator=f}', "");
    Expect(0, 127487, '\p{Is_Regional_Indicator=f}', "");
    Expect(1, 127487, '\p{^Is_Regional_Indicator=f}', "");
    Expect(1, 127487, '\P{Is_Regional_Indicator=f}', "");
    Expect(0, 127487, '\P{^Is_Regional_Indicator=f}', "");
    Expect(1, 127488, '\p{Is_Regional_Indicator=-_F}', "");
    Expect(0, 127488, '\p{^Is_Regional_Indicator=-_F}', "");
    Expect(0, 127488, '\P{Is_Regional_Indicator=-_F}', "");
    Expect(1, 127488, '\P{^Is_Regional_Indicator=-_F}', "");
    Expect(0, 127487, '\p{Is_Regional_Indicator=-_F}', "");
    Expect(1, 127487, '\p{^Is_Regional_Indicator=-_F}', "");
    Expect(1, 127487, '\P{Is_Regional_Indicator=-_F}', "");
    Expect(0, 127487, '\P{^Is_Regional_Indicator=-_F}', "");
    Error('\p{Is_RI=-/a/FALSE}');
    Error('\P{Is_RI=-/a/FALSE}');
    Expect(1, 127488, '\p{Is_RI:false}', "");
    Expect(0, 127488, '\p{^Is_RI:false}', "");
    Expect(0, 127488, '\P{Is_RI:false}', "");
    Expect(1, 127488, '\P{^Is_RI:false}', "");
    Expect(0, 127487, '\p{Is_RI:false}', "");
    Expect(1, 127487, '\p{^Is_RI:false}', "");
    Expect(1, 127487, '\P{Is_RI:false}', "");
    Expect(0, 127487, '\P{^Is_RI:false}', "");
    Error('\p{Regional_Indicator:   _ Yes/a/}');
    Error('\P{Regional_Indicator:   _ Yes/a/}');
    Expect(1, 127487, '\p{Regional_Indicator=yes}', "");
    Expect(0, 127487, '\p{^Regional_Indicator=yes}', "");
    Expect(0, 127487, '\P{Regional_Indicator=yes}', "");
    Expect(1, 127487, '\P{^Regional_Indicator=yes}', "");
    Expect(0, 127488, '\p{Regional_Indicator=yes}', "");
    Expect(1, 127488, '\p{^Regional_Indicator=yes}', "");
    Expect(1, 127488, '\P{Regional_Indicator=yes}', "");
    Expect(0, 127488, '\P{^Regional_Indicator=yes}', "");
    Expect(1, 127487, '\p{Regional_Indicator= Yes}', "");
    Expect(0, 127487, '\p{^Regional_Indicator= Yes}', "");
    Expect(0, 127487, '\P{Regional_Indicator= Yes}', "");
    Expect(1, 127487, '\P{^Regional_Indicator= Yes}', "");
    Expect(0, 127488, '\p{Regional_Indicator= Yes}', "");
    Expect(1, 127488, '\p{^Regional_Indicator= Yes}', "");
    Expect(1, 127488, '\P{Regional_Indicator= Yes}', "");
    Expect(0, 127488, '\P{^Regional_Indicator= Yes}', "");
    Error('\p{RI=/a/Y}');
    Error('\P{RI=/a/Y}');
    Expect(1, 127487, '\p{RI=y}', "");
    Expect(0, 127487, '\p{^RI=y}', "");
    Expect(0, 127487, '\P{RI=y}', "");
    Expect(1, 127487, '\P{^RI=y}', "");
    Expect(0, 127488, '\p{RI=y}', "");
    Expect(1, 127488, '\p{^RI=y}', "");
    Expect(1, 127488, '\P{RI=y}', "");
    Expect(0, 127488, '\P{^RI=y}', "");
    Expect(1, 127487, '\p{RI: -Y}', "");
    Expect(0, 127487, '\p{^RI: -Y}', "");
    Expect(0, 127487, '\P{RI: -Y}', "");
    Expect(1, 127487, '\P{^RI: -Y}', "");
    Expect(0, 127488, '\p{RI: -Y}', "");
    Expect(1, 127488, '\p{^RI: -Y}', "");
    Expect(1, 127488, '\P{RI: -Y}', "");
    Expect(0, 127488, '\P{^RI: -Y}', "");
    Error('\p{Is_Regional_Indicator:   T/a/}');
    Error('\P{Is_Regional_Indicator:   T/a/}');
    Expect(1, 127487, '\p{Is_Regional_Indicator=t}', "");
    Expect(0, 127487, '\p{^Is_Regional_Indicator=t}', "");
    Expect(0, 127487, '\P{Is_Regional_Indicator=t}', "");
    Expect(1, 127487, '\P{^Is_Regional_Indicator=t}', "");
    Expect(0, 127488, '\p{Is_Regional_Indicator=t}', "");
    Expect(1, 127488, '\p{^Is_Regional_Indicator=t}', "");
    Expect(1, 127488, '\P{Is_Regional_Indicator=t}', "");
    Expect(0, 127488, '\P{^Is_Regional_Indicator=t}', "");
    Expect(1, 127487, '\p{Is_Regional_Indicator= 	T}', "");
    Expect(0, 127487, '\p{^Is_Regional_Indicator= 	T}', "");
    Expect(0, 127487, '\P{Is_Regional_Indicator= 	T}', "");
    Expect(1, 127487, '\P{^Is_Regional_Indicator= 	T}', "");
    Expect(0, 127488, '\p{Is_Regional_Indicator= 	T}', "");
    Expect(1, 127488, '\p{^Is_Regional_Indicator= 	T}', "");
    Expect(1, 127488, '\P{Is_Regional_Indicator= 	T}', "");
    Expect(0, 127488, '\P{^Is_Regional_Indicator= 	T}', "");
    Error('\p{Is_RI=:=- TRUE}');
    Error('\P{Is_RI=:=- TRUE}');
    Expect(1, 127487, '\p{Is_RI=true}', "");
    Expect(0, 127487, '\p{^Is_RI=true}', "");
    Expect(0, 127487, '\P{Is_RI=true}', "");
    Expect(1, 127487, '\P{^Is_RI=true}', "");
    Expect(0, 127488, '\p{Is_RI=true}', "");
    Expect(1, 127488, '\p{^Is_RI=true}', "");
    Expect(1, 127488, '\P{Is_RI=true}', "");
    Expect(0, 127488, '\P{^Is_RI=true}', "");
    Expect(1, 127487, '\p{Is_RI=--true}', "");
    Expect(0, 127487, '\p{^Is_RI=--true}', "");
    Expect(0, 127487, '\P{Is_RI=--true}', "");
    Expect(1, 127487, '\P{^Is_RI=--true}', "");
    Expect(0, 127488, '\p{Is_RI=--true}', "");
    Expect(1, 127488, '\p{^Is_RI=--true}', "");
    Expect(1, 127488, '\P{Is_RI=--true}', "");
    Expect(0, 127488, '\P{^Is_RI=--true}', "");
    Error('\p{sentencebreak}');
    Error('\P{sentencebreak}');
    Error('\p{sb}');
    Error('\P{sb}');
    Error('\p{_perlsb}');
    Error('\P{_perlsb}');
    Error('\p{Sentence_Break=	aterm:=}');
    Error('\P{Sentence_Break=	aterm:=}');
    Expect(1, 65294, '\p{Sentence_Break=aterm}', "");
    Expect(0, 65294, '\p{^Sentence_Break=aterm}', "");
    Expect(0, 65294, '\P{Sentence_Break=aterm}', "");
    Expect(1, 65294, '\P{^Sentence_Break=aterm}', "");
    Expect(0, 65295, '\p{Sentence_Break=aterm}', "");
    Expect(1, 65295, '\p{^Sentence_Break=aterm}', "");
    Expect(1, 65295, '\P{Sentence_Break=aterm}', "");
    Expect(0, 65295, '\P{^Sentence_Break=aterm}', "");
    Expect(1, 65294, '\p{Sentence_Break= ATerm}', "");
    Expect(0, 65294, '\p{^Sentence_Break= ATerm}', "");
    Expect(0, 65294, '\P{Sentence_Break= ATerm}', "");
    Expect(1, 65294, '\P{^Sentence_Break= ATerm}', "");
    Expect(0, 65295, '\p{Sentence_Break= ATerm}', "");
    Expect(1, 65295, '\p{^Sentence_Break= ATerm}', "");
    Expect(1, 65295, '\P{Sentence_Break= ATerm}', "");
    Expect(0, 65295, '\P{^Sentence_Break= ATerm}', "");
    Error('\p{SB:__AT:=}');
    Error('\P{SB:__AT:=}');
    Expect(1, 65294, '\p{SB=at}', "");
    Expect(0, 65294, '\p{^SB=at}', "");
    Expect(0, 65294, '\P{SB=at}', "");
    Expect(1, 65294, '\P{^SB=at}', "");
    Expect(0, 65295, '\p{SB=at}', "");
    Expect(1, 65295, '\p{^SB=at}', "");
    Expect(1, 65295, '\P{SB=at}', "");
    Expect(0, 65295, '\P{^SB=at}', "");
    Expect(1, 65294, '\p{SB= _AT}', "");
    Expect(0, 65294, '\p{^SB= _AT}', "");
    Expect(0, 65294, '\P{SB= _AT}', "");
    Expect(1, 65294, '\P{^SB= _AT}', "");
    Expect(0, 65295, '\p{SB= _AT}', "");
    Expect(1, 65295, '\p{^SB= _AT}', "");
    Expect(1, 65295, '\P{SB= _AT}', "");
    Expect(0, 65295, '\P{^SB= _AT}', "");
    Error('\p{Is_Sentence_Break=/a/_	aterm}');
    Error('\P{Is_Sentence_Break=/a/_	aterm}');
    Expect(1, 65294, '\p{Is_Sentence_Break:aterm}', "");
    Expect(0, 65294, '\p{^Is_Sentence_Break:aterm}', "");
    Expect(0, 65294, '\P{Is_Sentence_Break:aterm}', "");
    Expect(1, 65294, '\P{^Is_Sentence_Break:aterm}', "");
    Expect(0, 65295, '\p{Is_Sentence_Break:aterm}', "");
    Expect(1, 65295, '\p{^Is_Sentence_Break:aterm}', "");
    Expect(1, 65295, '\P{Is_Sentence_Break:aterm}', "");
    Expect(0, 65295, '\P{^Is_Sentence_Break:aterm}', "");
    Expect(1, 65294, '\p{Is_Sentence_Break=_ATerm}', "");
    Expect(0, 65294, '\p{^Is_Sentence_Break=_ATerm}', "");
    Expect(0, 65294, '\P{Is_Sentence_Break=_ATerm}', "");
    Expect(1, 65294, '\P{^Is_Sentence_Break=_ATerm}', "");
    Expect(0, 65295, '\p{Is_Sentence_Break=_ATerm}', "");
    Expect(1, 65295, '\p{^Is_Sentence_Break=_ATerm}', "");
    Expect(1, 65295, '\P{Is_Sentence_Break=_ATerm}', "");
    Expect(0, 65295, '\P{^Is_Sentence_Break=_ATerm}', "");
    Error('\p{Is_SB=		AT:=}');
    Error('\P{Is_SB=		AT:=}');
    Expect(1, 65294, '\p{Is_SB=at}', "");
    Expect(0, 65294, '\p{^Is_SB=at}', "");
    Expect(0, 65294, '\P{Is_SB=at}', "");
    Expect(1, 65294, '\P{^Is_SB=at}', "");
    Expect(0, 65295, '\p{Is_SB=at}', "");
    Expect(1, 65295, '\p{^Is_SB=at}', "");
    Expect(1, 65295, '\P{Is_SB=at}', "");
    Expect(0, 65295, '\P{^Is_SB=at}', "");
    Expect(1, 65294, '\p{Is_SB=-_AT}', "");
    Expect(0, 65294, '\p{^Is_SB=-_AT}', "");
    Expect(0, 65294, '\P{Is_SB=-_AT}', "");
    Expect(1, 65294, '\P{^Is_SB=-_AT}', "");
    Expect(0, 65295, '\p{Is_SB=-_AT}', "");
    Expect(1, 65295, '\p{^Is_SB=-_AT}', "");
    Expect(1, 65295, '\P{Is_SB=-_AT}', "");
    Expect(0, 65295, '\P{^Is_SB=-_AT}', "");
    Error('\p{Sentence_Break:   	:=Close}');
    Error('\P{Sentence_Break:   	:=Close}');
    Expect(1, 128632, '\p{Sentence_Break=close}', "");
    Expect(0, 128632, '\p{^Sentence_Break=close}', "");
    Expect(0, 128632, '\P{Sentence_Break=close}', "");
    Expect(1, 128632, '\P{^Sentence_Break=close}', "");
    Expect(0, 128633, '\p{Sentence_Break=close}', "");
    Expect(1, 128633, '\p{^Sentence_Break=close}', "");
    Expect(1, 128633, '\P{Sentence_Break=close}', "");
    Expect(0, 128633, '\P{^Sentence_Break=close}', "");
    Expect(1, 128632, '\p{Sentence_Break=-	Close}', "");
    Expect(0, 128632, '\p{^Sentence_Break=-	Close}', "");
    Expect(0, 128632, '\P{Sentence_Break=-	Close}', "");
    Expect(1, 128632, '\P{^Sentence_Break=-	Close}', "");
    Expect(0, 128633, '\p{Sentence_Break=-	Close}', "");
    Expect(1, 128633, '\p{^Sentence_Break=-	Close}', "");
    Expect(1, 128633, '\P{Sentence_Break=-	Close}', "");
    Expect(0, 128633, '\P{^Sentence_Break=-	Close}', "");
    Error('\p{SB=/a/_CL}');
    Error('\P{SB=/a/_CL}');
    Expect(1, 128632, '\p{SB:	cl}', "");
    Expect(0, 128632, '\p{^SB:	cl}', "");
    Expect(0, 128632, '\P{SB:	cl}', "");
    Expect(1, 128632, '\P{^SB:	cl}', "");
    Expect(0, 128633, '\p{SB:	cl}', "");
    Expect(1, 128633, '\p{^SB:	cl}', "");
    Expect(1, 128633, '\P{SB:	cl}', "");
    Expect(0, 128633, '\P{^SB:	cl}', "");
    Expect(1, 128632, '\p{SB=-_CL}', "");
    Expect(0, 128632, '\p{^SB=-_CL}', "");
    Expect(0, 128632, '\P{SB=-_CL}', "");
    Expect(1, 128632, '\P{^SB=-_CL}', "");
    Expect(0, 128633, '\p{SB=-_CL}', "");
    Expect(1, 128633, '\p{^SB=-_CL}', "");
    Expect(1, 128633, '\P{SB=-_CL}', "");
    Expect(0, 128633, '\P{^SB=-_CL}', "");
    Error('\p{Is_Sentence_Break=_:=Close}');
    Error('\P{Is_Sentence_Break=_:=Close}');
    Expect(1, 128632, '\p{Is_Sentence_Break=close}', "");
    Expect(0, 128632, '\p{^Is_Sentence_Break=close}', "");
    Expect(0, 128632, '\P{Is_Sentence_Break=close}', "");
    Expect(1, 128632, '\P{^Is_Sentence_Break=close}', "");
    Expect(0, 128633, '\p{Is_Sentence_Break=close}', "");
    Expect(1, 128633, '\p{^Is_Sentence_Break=close}', "");
    Expect(1, 128633, '\P{Is_Sentence_Break=close}', "");
    Expect(0, 128633, '\P{^Is_Sentence_Break=close}', "");
    Expect(1, 128632, '\p{Is_Sentence_Break=_Close}', "");
    Expect(0, 128632, '\p{^Is_Sentence_Break=_Close}', "");
    Expect(0, 128632, '\P{Is_Sentence_Break=_Close}', "");
    Expect(1, 128632, '\P{^Is_Sentence_Break=_Close}', "");
    Expect(0, 128633, '\p{Is_Sentence_Break=_Close}', "");
    Expect(1, 128633, '\p{^Is_Sentence_Break=_Close}', "");
    Expect(1, 128633, '\P{Is_Sentence_Break=_Close}', "");
    Expect(0, 128633, '\P{^Is_Sentence_Break=_Close}', "");
    Error('\p{Is_SB=_/a/CL}');
    Error('\P{Is_SB=_/a/CL}');
    Expect(1, 128632, '\p{Is_SB=cl}', "");
    Expect(0, 128632, '\p{^Is_SB=cl}', "");
    Expect(0, 128632, '\P{Is_SB=cl}', "");
    Expect(1, 128632, '\P{^Is_SB=cl}', "");
    Expect(0, 128633, '\p{Is_SB=cl}', "");
    Expect(1, 128633, '\p{^Is_SB=cl}', "");
    Expect(1, 128633, '\P{Is_SB=cl}', "");
    Expect(0, 128633, '\P{^Is_SB=cl}', "");
    Expect(1, 128632, '\p{Is_SB= cl}', "");
    Expect(0, 128632, '\p{^Is_SB= cl}', "");
    Expect(0, 128632, '\P{Is_SB= cl}', "");
    Expect(1, 128632, '\P{^Is_SB= cl}', "");
    Expect(0, 128633, '\p{Is_SB= cl}', "");
    Expect(1, 128633, '\p{^Is_SB= cl}', "");
    Expect(1, 128633, '\P{Is_SB= cl}', "");
    Expect(0, 128633, '\P{^Is_SB= cl}', "");
    Error('\p{Sentence_Break: /a/_	cr}');
    Error('\P{Sentence_Break: /a/_	cr}');
    Expect(1, 13, '\p{Sentence_Break=cr}', "");
    Expect(0, 13, '\p{^Sentence_Break=cr}', "");
    Expect(0, 13, '\P{Sentence_Break=cr}', "");
    Expect(1, 13, '\P{^Sentence_Break=cr}', "");
    Expect(0, 14, '\p{Sentence_Break=cr}', "");
    Expect(1, 14, '\p{^Sentence_Break=cr}', "");
    Expect(1, 14, '\P{Sentence_Break=cr}', "");
    Expect(0, 14, '\P{^Sentence_Break=cr}', "");
    Expect(1, 13, '\p{Sentence_Break=  CR}', "");
    Expect(0, 13, '\p{^Sentence_Break=  CR}', "");
    Expect(0, 13, '\P{Sentence_Break=  CR}', "");
    Expect(1, 13, '\P{^Sentence_Break=  CR}', "");
    Expect(0, 14, '\p{Sentence_Break=  CR}', "");
    Expect(1, 14, '\p{^Sentence_Break=  CR}', "");
    Expect(1, 14, '\P{Sentence_Break=  CR}', "");
    Expect(0, 14, '\P{^Sentence_Break=  CR}', "");
    Error('\p{SB= cr/a/}');
    Error('\P{SB= cr/a/}');
    Expect(1, 13, '\p{SB=cr}', "");
    Expect(0, 13, '\p{^SB=cr}', "");
    Expect(0, 13, '\P{SB=cr}', "");
    Expect(1, 13, '\P{^SB=cr}', "");
    Expect(0, 14, '\p{SB=cr}', "");
    Expect(1, 14, '\p{^SB=cr}', "");
    Expect(1, 14, '\P{SB=cr}', "");
    Expect(0, 14, '\P{^SB=cr}', "");
    Expect(1, 13, '\p{SB=	_CR}', "");
    Expect(0, 13, '\p{^SB=	_CR}', "");
    Expect(0, 13, '\P{SB=	_CR}', "");
    Expect(1, 13, '\P{^SB=	_CR}', "");
    Expect(0, 14, '\p{SB=	_CR}', "");
    Expect(1, 14, '\p{^SB=	_CR}', "");
    Expect(1, 14, '\P{SB=	_CR}', "");
    Expect(0, 14, '\P{^SB=	_CR}', "");
    Error('\p{Is_Sentence_Break:		/a/cr}');
    Error('\P{Is_Sentence_Break:		/a/cr}');
    Expect(1, 13, '\p{Is_Sentence_Break=cr}', "");
    Expect(0, 13, '\p{^Is_Sentence_Break=cr}', "");
    Expect(0, 13, '\P{Is_Sentence_Break=cr}', "");
    Expect(1, 13, '\P{^Is_Sentence_Break=cr}', "");
    Expect(0, 14, '\p{Is_Sentence_Break=cr}', "");
    Expect(1, 14, '\p{^Is_Sentence_Break=cr}', "");
    Expect(1, 14, '\P{Is_Sentence_Break=cr}', "");
    Expect(0, 14, '\P{^Is_Sentence_Break=cr}', "");
    Expect(1, 13, '\p{Is_Sentence_Break= 	CR}', "");
    Expect(0, 13, '\p{^Is_Sentence_Break= 	CR}', "");
    Expect(0, 13, '\P{Is_Sentence_Break= 	CR}', "");
    Expect(1, 13, '\P{^Is_Sentence_Break= 	CR}', "");
    Expect(0, 14, '\p{Is_Sentence_Break= 	CR}', "");
    Expect(1, 14, '\p{^Is_Sentence_Break= 	CR}', "");
    Expect(1, 14, '\P{Is_Sentence_Break= 	CR}', "");
    Expect(0, 14, '\P{^Is_Sentence_Break= 	CR}', "");
    Error('\p{Is_SB=	_CR/a/}');
    Error('\P{Is_SB=	_CR/a/}');
    Expect(1, 13, '\p{Is_SB=cr}', "");
    Expect(0, 13, '\p{^Is_SB=cr}', "");
    Expect(0, 13, '\P{Is_SB=cr}', "");
    Expect(1, 13, '\P{^Is_SB=cr}', "");
    Expect(0, 14, '\p{Is_SB=cr}', "");
    Expect(1, 14, '\p{^Is_SB=cr}', "");
    Expect(1, 14, '\P{Is_SB=cr}', "");
    Expect(0, 14, '\P{^Is_SB=cr}', "");
    Expect(1, 13, '\p{Is_SB=__CR}', "");
    Expect(0, 13, '\p{^Is_SB=__CR}', "");
    Expect(0, 13, '\P{Is_SB=__CR}', "");
    Expect(1, 13, '\P{^Is_SB=__CR}', "");
    Expect(0, 14, '\p{Is_SB=__CR}', "");
    Expect(1, 14, '\p{^Is_SB=__CR}', "");
    Expect(1, 14, '\P{Is_SB=__CR}', "");
    Expect(0, 14, '\P{^Is_SB=__CR}', "");
    Error('\p{Sentence_Break=-:=EXTEND}');
    Error('\P{Sentence_Break=-:=EXTEND}');
    Expect(1, 917999, '\p{Sentence_Break=extend}', "");
    Expect(0, 917999, '\p{^Sentence_Break=extend}', "");
    Expect(0, 917999, '\P{Sentence_Break=extend}', "");
    Expect(1, 917999, '\P{^Sentence_Break=extend}', "");
    Expect(0, 918000, '\p{Sentence_Break=extend}', "");
    Expect(1, 918000, '\p{^Sentence_Break=extend}', "");
    Expect(1, 918000, '\P{Sentence_Break=extend}', "");
    Expect(0, 918000, '\P{^Sentence_Break=extend}', "");
    Expect(1, 917999, '\p{Sentence_Break=	-EXTEND}', "");
    Expect(0, 917999, '\p{^Sentence_Break=	-EXTEND}', "");
    Expect(0, 917999, '\P{Sentence_Break=	-EXTEND}', "");
    Expect(1, 917999, '\P{^Sentence_Break=	-EXTEND}', "");
    Expect(0, 918000, '\p{Sentence_Break=	-EXTEND}', "");
    Expect(1, 918000, '\p{^Sentence_Break=	-EXTEND}', "");
    Expect(1, 918000, '\P{Sentence_Break=	-EXTEND}', "");
    Expect(0, 918000, '\P{^Sentence_Break=	-EXTEND}', "");
    Error('\p{SB=	:=EX}');
    Error('\P{SB=	:=EX}');
    Expect(1, 917999, '\p{SB=ex}', "");
    Expect(0, 917999, '\p{^SB=ex}', "");
    Expect(0, 917999, '\P{SB=ex}', "");
    Expect(1, 917999, '\P{^SB=ex}', "");
    Expect(0, 918000, '\p{SB=ex}', "");
    Expect(1, 918000, '\p{^SB=ex}', "");
    Expect(1, 918000, '\P{SB=ex}', "");
    Expect(0, 918000, '\P{^SB=ex}', "");
    Expect(1, 917999, '\p{SB= ex}', "");
    Expect(0, 917999, '\p{^SB= ex}', "");
    Expect(0, 917999, '\P{SB= ex}', "");
    Expect(1, 917999, '\P{^SB= ex}', "");
    Expect(0, 918000, '\p{SB= ex}', "");
    Expect(1, 918000, '\p{^SB= ex}', "");
    Expect(1, 918000, '\P{SB= ex}', "");
    Expect(0, 918000, '\P{^SB= ex}', "");
    Error('\p{Is_Sentence_Break=-extend/a/}');
    Error('\P{Is_Sentence_Break=-extend/a/}');
    Expect(1, 917999, '\p{Is_Sentence_Break=extend}', "");
    Expect(0, 917999, '\p{^Is_Sentence_Break=extend}', "");
    Expect(0, 917999, '\P{Is_Sentence_Break=extend}', "");
    Expect(1, 917999, '\P{^Is_Sentence_Break=extend}', "");
    Expect(0, 918000, '\p{Is_Sentence_Break=extend}', "");
    Expect(1, 918000, '\p{^Is_Sentence_Break=extend}', "");
    Expect(1, 918000, '\P{Is_Sentence_Break=extend}', "");
    Expect(0, 918000, '\P{^Is_Sentence_Break=extend}', "");
    Expect(1, 917999, '\p{Is_Sentence_Break=	Extend}', "");
    Expect(0, 917999, '\p{^Is_Sentence_Break=	Extend}', "");
    Expect(0, 917999, '\P{Is_Sentence_Break=	Extend}', "");
    Expect(1, 917999, '\P{^Is_Sentence_Break=	Extend}', "");
    Expect(0, 918000, '\p{Is_Sentence_Break=	Extend}', "");
    Expect(1, 918000, '\p{^Is_Sentence_Break=	Extend}', "");
    Expect(1, 918000, '\P{Is_Sentence_Break=	Extend}', "");
    Expect(0, 918000, '\P{^Is_Sentence_Break=	Extend}', "");
    Error('\p{Is_SB=:=- EX}');
    Error('\P{Is_SB=:=- EX}');
    Expect(1, 917999, '\p{Is_SB:ex}', "");
    Expect(0, 917999, '\p{^Is_SB:ex}', "");
    Expect(0, 917999, '\P{Is_SB:ex}', "");
    Expect(1, 917999, '\P{^Is_SB:ex}', "");
    Expect(0, 918000, '\p{Is_SB:ex}', "");
    Expect(1, 918000, '\p{^Is_SB:ex}', "");
    Expect(1, 918000, '\P{Is_SB:ex}', "");
    Expect(0, 918000, '\P{^Is_SB:ex}', "");
    Expect(1, 917999, '\p{Is_SB=-_EX}', "");
    Expect(0, 917999, '\p{^Is_SB=-_EX}', "");
    Expect(0, 917999, '\P{Is_SB=-_EX}', "");
    Expect(1, 917999, '\P{^Is_SB=-_EX}', "");
    Expect(0, 918000, '\p{Is_SB=-_EX}', "");
    Expect(1, 918000, '\p{^Is_SB=-_EX}', "");
    Expect(1, 918000, '\P{Is_SB=-_EX}', "");
    Expect(0, 918000, '\P{^Is_SB=-_EX}', "");
    Error('\p{Sentence_Break: 	:=Format}');
    Error('\P{Sentence_Break: 	:=Format}');
    Expect(1, 917505, '\p{Sentence_Break=format}', "");
    Expect(0, 917505, '\p{^Sentence_Break=format}', "");
    Expect(0, 917505, '\P{Sentence_Break=format}', "");
    Expect(1, 917505, '\P{^Sentence_Break=format}', "");
    Expect(0, 917506, '\p{Sentence_Break=format}', "");
    Expect(1, 917506, '\p{^Sentence_Break=format}', "");
    Expect(1, 917506, '\P{Sentence_Break=format}', "");
    Expect(0, 917506, '\P{^Sentence_Break=format}', "");
    Expect(1, 917505, '\p{Sentence_Break= 	format}', "");
    Expect(0, 917505, '\p{^Sentence_Break= 	format}', "");
    Expect(0, 917505, '\P{Sentence_Break= 	format}', "");
    Expect(1, 917505, '\P{^Sentence_Break= 	format}', "");
    Expect(0, 917506, '\p{Sentence_Break= 	format}', "");
    Expect(1, 917506, '\p{^Sentence_Break= 	format}', "");
    Expect(1, 917506, '\P{Sentence_Break= 	format}', "");
    Expect(0, 917506, '\P{^Sentence_Break= 	format}', "");
    Error('\p{SB= FO/a/}');
    Error('\P{SB= FO/a/}');
    Expect(1, 917505, '\p{SB=fo}', "");
    Expect(0, 917505, '\p{^SB=fo}', "");
    Expect(0, 917505, '\P{SB=fo}', "");
    Expect(1, 917505, '\P{^SB=fo}', "");
    Expect(0, 917506, '\p{SB=fo}', "");
    Expect(1, 917506, '\p{^SB=fo}', "");
    Expect(1, 917506, '\P{SB=fo}', "");
    Expect(0, 917506, '\P{^SB=fo}', "");
    Expect(1, 917505, '\p{SB=	 FO}', "");
    Expect(0, 917505, '\p{^SB=	 FO}', "");
    Expect(0, 917505, '\P{SB=	 FO}', "");
    Expect(1, 917505, '\P{^SB=	 FO}', "");
    Expect(0, 917506, '\p{SB=	 FO}', "");
    Expect(1, 917506, '\p{^SB=	 FO}', "");
    Expect(1, 917506, '\P{SB=	 FO}', "");
    Expect(0, 917506, '\P{^SB=	 FO}', "");
    Error('\p{Is_Sentence_Break=_Format/a/}');
    Error('\P{Is_Sentence_Break=_Format/a/}');
    Expect(1, 917505, '\p{Is_Sentence_Break=format}', "");
    Expect(0, 917505, '\p{^Is_Sentence_Break=format}', "");
    Expect(0, 917505, '\P{Is_Sentence_Break=format}', "");
    Expect(1, 917505, '\P{^Is_Sentence_Break=format}', "");
    Expect(0, 917506, '\p{Is_Sentence_Break=format}', "");
    Expect(1, 917506, '\p{^Is_Sentence_Break=format}', "");
    Expect(1, 917506, '\P{Is_Sentence_Break=format}', "");
    Expect(0, 917506, '\P{^Is_Sentence_Break=format}', "");
    Expect(1, 917505, '\p{Is_Sentence_Break= -Format}', "");
    Expect(0, 917505, '\p{^Is_Sentence_Break= -Format}', "");
    Expect(0, 917505, '\P{Is_Sentence_Break= -Format}', "");
    Expect(1, 917505, '\P{^Is_Sentence_Break= -Format}', "");
    Expect(0, 917506, '\p{Is_Sentence_Break= -Format}', "");
    Expect(1, 917506, '\p{^Is_Sentence_Break= -Format}', "");
    Expect(1, 917506, '\P{Is_Sentence_Break= -Format}', "");
    Expect(0, 917506, '\P{^Is_Sentence_Break= -Format}', "");
    Error('\p{Is_SB=	 fo:=}');
    Error('\P{Is_SB=	 fo:=}');
    Expect(1, 917505, '\p{Is_SB=fo}', "");
    Expect(0, 917505, '\p{^Is_SB=fo}', "");
    Expect(0, 917505, '\P{Is_SB=fo}', "");
    Expect(1, 917505, '\P{^Is_SB=fo}', "");
    Expect(0, 917506, '\p{Is_SB=fo}', "");
    Expect(1, 917506, '\p{^Is_SB=fo}', "");
    Expect(1, 917506, '\P{Is_SB=fo}', "");
    Expect(0, 917506, '\P{^Is_SB=fo}', "");
    Expect(1, 917505, '\p{Is_SB=--FO}', "");
    Expect(0, 917505, '\p{^Is_SB=--FO}', "");
    Expect(0, 917505, '\P{Is_SB=--FO}', "");
    Expect(1, 917505, '\P{^Is_SB=--FO}', "");
    Expect(0, 917506, '\p{Is_SB=--FO}', "");
    Expect(1, 917506, '\p{^Is_SB=--FO}', "");
    Expect(1, 917506, '\P{Is_SB=--FO}', "");
    Expect(0, 917506, '\P{^Is_SB=--FO}', "");
    Error('\p{Sentence_Break=  OLetter:=}');
    Error('\P{Sentence_Break=  OLetter:=}');
    Expect(1, 195101, '\p{Sentence_Break=oletter}', "");
    Expect(0, 195101, '\p{^Sentence_Break=oletter}', "");
    Expect(0, 195101, '\P{Sentence_Break=oletter}', "");
    Expect(1, 195101, '\P{^Sentence_Break=oletter}', "");
    Expect(0, 195102, '\p{Sentence_Break=oletter}', "");
    Expect(1, 195102, '\p{^Sentence_Break=oletter}', "");
    Expect(1, 195102, '\P{Sentence_Break=oletter}', "");
    Expect(0, 195102, '\P{^Sentence_Break=oletter}', "");
    Expect(1, 195101, '\p{Sentence_Break=  OLetter}', "");
    Expect(0, 195101, '\p{^Sentence_Break=  OLetter}', "");
    Expect(0, 195101, '\P{Sentence_Break=  OLetter}', "");
    Expect(1, 195101, '\P{^Sentence_Break=  OLetter}', "");
    Expect(0, 195102, '\p{Sentence_Break=  OLetter}', "");
    Expect(1, 195102, '\p{^Sentence_Break=  OLetter}', "");
    Expect(1, 195102, '\P{Sentence_Break=  OLetter}', "");
    Expect(0, 195102, '\P{^Sentence_Break=  OLetter}', "");
    Error('\p{SB=:=	-le}');
    Error('\P{SB=:=	-le}');
    Expect(1, 195101, '\p{SB=le}', "");
    Expect(0, 195101, '\p{^SB=le}', "");
    Expect(0, 195101, '\P{SB=le}', "");
    Expect(1, 195101, '\P{^SB=le}', "");
    Expect(0, 195102, '\p{SB=le}', "");
    Expect(1, 195102, '\p{^SB=le}', "");
    Expect(1, 195102, '\P{SB=le}', "");
    Expect(0, 195102, '\P{^SB=le}', "");
    Expect(1, 195101, '\p{SB= _LE}', "");
    Expect(0, 195101, '\p{^SB= _LE}', "");
    Expect(0, 195101, '\P{SB= _LE}', "");
    Expect(1, 195101, '\P{^SB= _LE}', "");
    Expect(0, 195102, '\p{SB= _LE}', "");
    Expect(1, 195102, '\p{^SB= _LE}', "");
    Expect(1, 195102, '\P{SB= _LE}', "");
    Expect(0, 195102, '\P{^SB= _LE}', "");
    Error('\p{Is_Sentence_Break=:= OLetter}');
    Error('\P{Is_Sentence_Break=:= OLetter}');
    Expect(1, 195101, '\p{Is_Sentence_Break: oletter}', "");
    Expect(0, 195101, '\p{^Is_Sentence_Break: oletter}', "");
    Expect(0, 195101, '\P{Is_Sentence_Break: oletter}', "");
    Expect(1, 195101, '\P{^Is_Sentence_Break: oletter}', "");
    Expect(0, 195102, '\p{Is_Sentence_Break: oletter}', "");
    Expect(1, 195102, '\p{^Is_Sentence_Break: oletter}', "");
    Expect(1, 195102, '\P{Is_Sentence_Break: oletter}', "");
    Expect(0, 195102, '\P{^Is_Sentence_Break: oletter}', "");
    Expect(1, 195101, '\p{Is_Sentence_Break=-_oletter}', "");
    Expect(0, 195101, '\p{^Is_Sentence_Break=-_oletter}', "");
    Expect(0, 195101, '\P{Is_Sentence_Break=-_oletter}', "");
    Expect(1, 195101, '\P{^Is_Sentence_Break=-_oletter}', "");
    Expect(0, 195102, '\p{Is_Sentence_Break=-_oletter}', "");
    Expect(1, 195102, '\p{^Is_Sentence_Break=-_oletter}', "");
    Expect(1, 195102, '\P{Is_Sentence_Break=-_oletter}', "");
    Expect(0, 195102, '\P{^Is_Sentence_Break=-_oletter}', "");
    Error('\p{Is_SB= /a/LE}');
    Error('\P{Is_SB= /a/LE}');
    Expect(1, 195101, '\p{Is_SB=le}', "");
    Expect(0, 195101, '\p{^Is_SB=le}', "");
    Expect(0, 195101, '\P{Is_SB=le}', "");
    Expect(1, 195101, '\P{^Is_SB=le}', "");
    Expect(0, 195102, '\p{Is_SB=le}', "");
    Expect(1, 195102, '\p{^Is_SB=le}', "");
    Expect(1, 195102, '\P{Is_SB=le}', "");
    Expect(0, 195102, '\P{^Is_SB=le}', "");
    Expect(1, 195101, '\p{Is_SB=	LE}', "");
    Expect(0, 195101, '\p{^Is_SB=	LE}', "");
    Expect(0, 195101, '\P{Is_SB=	LE}', "");
    Expect(1, 195101, '\P{^Is_SB=	LE}', "");
    Expect(0, 195102, '\p{Is_SB=	LE}', "");
    Expect(1, 195102, '\p{^Is_SB=	LE}', "");
    Expect(1, 195102, '\P{Is_SB=	LE}', "");
    Expect(0, 195102, '\P{^Is_SB=	LE}', "");
    Error('\p{Sentence_Break=-:=lf}');
    Error('\P{Sentence_Break=-:=lf}');
    Expect(1, 10, '\p{Sentence_Break=lf}', "");
    Expect(0, 10, '\p{^Sentence_Break=lf}', "");
    Expect(0, 10, '\P{Sentence_Break=lf}', "");
    Expect(1, 10, '\P{^Sentence_Break=lf}', "");
    Expect(0, 11, '\p{Sentence_Break=lf}', "");
    Expect(1, 11, '\p{^Sentence_Break=lf}', "");
    Expect(1, 11, '\P{Sentence_Break=lf}', "");
    Expect(0, 11, '\P{^Sentence_Break=lf}', "");
    Expect(1, 10, '\p{Sentence_Break=_LF}', "");
    Expect(0, 10, '\p{^Sentence_Break=_LF}', "");
    Expect(0, 10, '\P{Sentence_Break=_LF}', "");
    Expect(1, 10, '\P{^Sentence_Break=_LF}', "");
    Expect(0, 11, '\p{Sentence_Break=_LF}', "");
    Expect(1, 11, '\p{^Sentence_Break=_LF}', "");
    Expect(1, 11, '\P{Sentence_Break=_LF}', "");
    Expect(0, 11, '\P{^Sentence_Break=_LF}', "");
    Error('\p{SB= :=LF}');
    Error('\P{SB= :=LF}');
    Expect(1, 10, '\p{SB=lf}', "");
    Expect(0, 10, '\p{^SB=lf}', "");
    Expect(0, 10, '\P{SB=lf}', "");
    Expect(1, 10, '\P{^SB=lf}', "");
    Expect(0, 11, '\p{SB=lf}', "");
    Expect(1, 11, '\p{^SB=lf}', "");
    Expect(1, 11, '\P{SB=lf}', "");
    Expect(0, 11, '\P{^SB=lf}', "");
    Expect(1, 10, '\p{SB:   --lf}', "");
    Expect(0, 10, '\p{^SB:   --lf}', "");
    Expect(0, 10, '\P{SB:   --lf}', "");
    Expect(1, 10, '\P{^SB:   --lf}', "");
    Expect(0, 11, '\p{SB:   --lf}', "");
    Expect(1, 11, '\p{^SB:   --lf}', "");
    Expect(1, 11, '\P{SB:   --lf}', "");
    Expect(0, 11, '\P{^SB:   --lf}', "");
    Error('\p{Is_Sentence_Break= :=LF}');
    Error('\P{Is_Sentence_Break= :=LF}');
    Expect(1, 10, '\p{Is_Sentence_Break=lf}', "");
    Expect(0, 10, '\p{^Is_Sentence_Break=lf}', "");
    Expect(0, 10, '\P{Is_Sentence_Break=lf}', "");
    Expect(1, 10, '\P{^Is_Sentence_Break=lf}', "");
    Expect(0, 11, '\p{Is_Sentence_Break=lf}', "");
    Expect(1, 11, '\p{^Is_Sentence_Break=lf}', "");
    Expect(1, 11, '\P{Is_Sentence_Break=lf}', "");
    Expect(0, 11, '\P{^Is_Sentence_Break=lf}', "");
    Expect(1, 10, '\p{Is_Sentence_Break=-_LF}', "");
    Expect(0, 10, '\p{^Is_Sentence_Break=-_LF}', "");
    Expect(0, 10, '\P{Is_Sentence_Break=-_LF}', "");
    Expect(1, 10, '\P{^Is_Sentence_Break=-_LF}', "");
    Expect(0, 11, '\p{Is_Sentence_Break=-_LF}', "");
    Expect(1, 11, '\p{^Is_Sentence_Break=-_LF}', "");
    Expect(1, 11, '\P{Is_Sentence_Break=-_LF}', "");
    Expect(0, 11, '\P{^Is_Sentence_Break=-_LF}', "");
    Error('\p{Is_SB= :=LF}');
    Error('\P{Is_SB= :=LF}');
    Expect(1, 10, '\p{Is_SB=lf}', "");
    Expect(0, 10, '\p{^Is_SB=lf}', "");
    Expect(0, 10, '\P{Is_SB=lf}', "");
    Expect(1, 10, '\P{^Is_SB=lf}', "");
    Expect(0, 11, '\p{Is_SB=lf}', "");
    Expect(1, 11, '\p{^Is_SB=lf}', "");
    Expect(1, 11, '\P{Is_SB=lf}', "");
    Expect(0, 11, '\P{^Is_SB=lf}', "");
    Expect(1, 10, '\p{Is_SB=		LF}', "");
    Expect(0, 10, '\p{^Is_SB=		LF}', "");
    Expect(0, 10, '\P{Is_SB=		LF}', "");
    Expect(1, 10, '\P{^Is_SB=		LF}', "");
    Expect(0, 11, '\p{Is_SB=		LF}', "");
    Expect(1, 11, '\p{^Is_SB=		LF}', "");
    Expect(1, 11, '\P{Is_SB=		LF}', "");
    Expect(0, 11, '\P{^Is_SB=		LF}', "");
    Error('\p{Sentence_Break=/a/	Lower}');
    Error('\P{Sentence_Break=/a/	Lower}');
    Expect(1, 125251, '\p{Sentence_Break=lower}', "");
    Expect(0, 125251, '\p{^Sentence_Break=lower}', "");
    Expect(0, 125251, '\P{Sentence_Break=lower}', "");
    Expect(1, 125251, '\P{^Sentence_Break=lower}', "");
    Expect(0, 125252, '\p{Sentence_Break=lower}', "");
    Expect(1, 125252, '\p{^Sentence_Break=lower}', "");
    Expect(1, 125252, '\P{Sentence_Break=lower}', "");
    Expect(0, 125252, '\P{^Sentence_Break=lower}', "");
    Expect(1, 125251, '\p{Sentence_Break=-LOWER}', "");
    Expect(0, 125251, '\p{^Sentence_Break=-LOWER}', "");
    Expect(0, 125251, '\P{Sentence_Break=-LOWER}', "");
    Expect(1, 125251, '\P{^Sentence_Break=-LOWER}', "");
    Expect(0, 125252, '\p{Sentence_Break=-LOWER}', "");
    Expect(1, 125252, '\p{^Sentence_Break=-LOWER}', "");
    Expect(1, 125252, '\P{Sentence_Break=-LOWER}', "");
    Expect(0, 125252, '\P{^Sentence_Break=-LOWER}', "");
    Error('\p{SB=-LO/a/}');
    Error('\P{SB=-LO/a/}');
    Expect(1, 125251, '\p{SB=lo}', "");
    Expect(0, 125251, '\p{^SB=lo}', "");
    Expect(0, 125251, '\P{SB=lo}', "");
    Expect(1, 125251, '\P{^SB=lo}', "");
    Expect(0, 125252, '\p{SB=lo}', "");
    Expect(1, 125252, '\p{^SB=lo}', "");
    Expect(1, 125252, '\P{SB=lo}', "");
    Expect(0, 125252, '\P{^SB=lo}', "");
    Expect(1, 125251, '\p{SB=_	LO}', "");
    Expect(0, 125251, '\p{^SB=_	LO}', "");
    Expect(0, 125251, '\P{SB=_	LO}', "");
    Expect(1, 125251, '\P{^SB=_	LO}', "");
    Expect(0, 125252, '\p{SB=_	LO}', "");
    Expect(1, 125252, '\p{^SB=_	LO}', "");
    Expect(1, 125252, '\P{SB=_	LO}', "");
    Expect(0, 125252, '\P{^SB=_	LO}', "");
    Error('\p{Is_Sentence_Break=- Lower:=}');
    Error('\P{Is_Sentence_Break=- Lower:=}');
    Expect(1, 125251, '\p{Is_Sentence_Break=lower}', "");
    Expect(0, 125251, '\p{^Is_Sentence_Break=lower}', "");
    Expect(0, 125251, '\P{Is_Sentence_Break=lower}', "");
    Expect(1, 125251, '\P{^Is_Sentence_Break=lower}', "");
    Expect(0, 125252, '\p{Is_Sentence_Break=lower}', "");
    Expect(1, 125252, '\p{^Is_Sentence_Break=lower}', "");
    Expect(1, 125252, '\P{Is_Sentence_Break=lower}', "");
    Expect(0, 125252, '\P{^Is_Sentence_Break=lower}', "");
    Expect(1, 125251, '\p{Is_Sentence_Break=	 lower}', "");
    Expect(0, 125251, '\p{^Is_Sentence_Break=	 lower}', "");
    Expect(0, 125251, '\P{Is_Sentence_Break=	 lower}', "");
    Expect(1, 125251, '\P{^Is_Sentence_Break=	 lower}', "");
    Expect(0, 125252, '\p{Is_Sentence_Break=	 lower}', "");
    Expect(1, 125252, '\p{^Is_Sentence_Break=	 lower}', "");
    Expect(1, 125252, '\P{Is_Sentence_Break=	 lower}', "");
    Expect(0, 125252, '\P{^Is_Sentence_Break=	 lower}', "");
    Error('\p{Is_SB=:=LO}');
    Error('\P{Is_SB=:=LO}');
    Expect(1, 125251, '\p{Is_SB=lo}', "");
    Expect(0, 125251, '\p{^Is_SB=lo}', "");
    Expect(0, 125251, '\P{Is_SB=lo}', "");
    Expect(1, 125251, '\P{^Is_SB=lo}', "");
    Expect(0, 125252, '\p{Is_SB=lo}', "");
    Expect(1, 125252, '\p{^Is_SB=lo}', "");
    Expect(1, 125252, '\P{Is_SB=lo}', "");
    Expect(0, 125252, '\P{^Is_SB=lo}', "");
    Expect(1, 125251, '\p{Is_SB:   -LO}', "");
    Expect(0, 125251, '\p{^Is_SB:   -LO}', "");
    Expect(0, 125251, '\P{Is_SB:   -LO}', "");
    Expect(1, 125251, '\P{^Is_SB:   -LO}', "");
    Expect(0, 125252, '\p{Is_SB:   -LO}', "");
    Expect(1, 125252, '\p{^Is_SB:   -LO}', "");
    Expect(1, 125252, '\P{Is_SB:   -LO}', "");
    Expect(0, 125252, '\P{^Is_SB:   -LO}', "");
    Error('\p{Sentence_Break:   /a/	 numeric}');
    Error('\P{Sentence_Break:   /a/	 numeric}');
    Expect(1, 125273, '\p{Sentence_Break=numeric}', "");
    Expect(0, 125273, '\p{^Sentence_Break=numeric}', "");
    Expect(0, 125273, '\P{Sentence_Break=numeric}', "");
    Expect(1, 125273, '\P{^Sentence_Break=numeric}', "");
    Expect(0, 125274, '\p{Sentence_Break=numeric}', "");
    Expect(1, 125274, '\p{^Sentence_Break=numeric}', "");
    Expect(1, 125274, '\P{Sentence_Break=numeric}', "");
    Expect(0, 125274, '\P{^Sentence_Break=numeric}', "");
    Expect(1, 125273, '\p{Sentence_Break=-	NUMERIC}', "");
    Expect(0, 125273, '\p{^Sentence_Break=-	NUMERIC}', "");
    Expect(0, 125273, '\P{Sentence_Break=-	NUMERIC}', "");
    Expect(1, 125273, '\P{^Sentence_Break=-	NUMERIC}', "");
    Expect(0, 125274, '\p{Sentence_Break=-	NUMERIC}', "");
    Expect(1, 125274, '\p{^Sentence_Break=-	NUMERIC}', "");
    Expect(1, 125274, '\P{Sentence_Break=-	NUMERIC}', "");
    Expect(0, 125274, '\P{^Sentence_Break=-	NUMERIC}', "");
    Error('\p{SB=:=-	NU}');
    Error('\P{SB=:=-	NU}');
    Expect(1, 125273, '\p{SB=nu}', "");
    Expect(0, 125273, '\p{^SB=nu}', "");
    Expect(0, 125273, '\P{SB=nu}', "");
    Expect(1, 125273, '\P{^SB=nu}', "");
    Expect(0, 125274, '\p{SB=nu}', "");
    Expect(1, 125274, '\p{^SB=nu}', "");
    Expect(1, 125274, '\P{SB=nu}', "");
    Expect(0, 125274, '\P{^SB=nu}', "");
    Expect(1, 125273, '\p{SB=_NU}', "");
    Expect(0, 125273, '\p{^SB=_NU}', "");
    Expect(0, 125273, '\P{SB=_NU}', "");
    Expect(1, 125273, '\P{^SB=_NU}', "");
    Expect(0, 125274, '\p{SB=_NU}', "");
    Expect(1, 125274, '\p{^SB=_NU}', "");
    Expect(1, 125274, '\P{SB=_NU}', "");
    Expect(0, 125274, '\P{^SB=_NU}', "");
    Error('\p{Is_Sentence_Break=/a/_ NUMERIC}');
    Error('\P{Is_Sentence_Break=/a/_ NUMERIC}');
    Expect(1, 125273, '\p{Is_Sentence_Break=numeric}', "");
    Expect(0, 125273, '\p{^Is_Sentence_Break=numeric}', "");
    Expect(0, 125273, '\P{Is_Sentence_Break=numeric}', "");
    Expect(1, 125273, '\P{^Is_Sentence_Break=numeric}', "");
    Expect(0, 125274, '\p{Is_Sentence_Break=numeric}', "");
    Expect(1, 125274, '\p{^Is_Sentence_Break=numeric}', "");
    Expect(1, 125274, '\P{Is_Sentence_Break=numeric}', "");
    Expect(0, 125274, '\P{^Is_Sentence_Break=numeric}', "");
    Expect(1, 125273, '\p{Is_Sentence_Break=		NUMERIC}', "");
    Expect(0, 125273, '\p{^Is_Sentence_Break=		NUMERIC}', "");
    Expect(0, 125273, '\P{Is_Sentence_Break=		NUMERIC}', "");
    Expect(1, 125273, '\P{^Is_Sentence_Break=		NUMERIC}', "");
    Expect(0, 125274, '\p{Is_Sentence_Break=		NUMERIC}', "");
    Expect(1, 125274, '\p{^Is_Sentence_Break=		NUMERIC}', "");
    Expect(1, 125274, '\P{Is_Sentence_Break=		NUMERIC}', "");
    Expect(0, 125274, '\P{^Is_Sentence_Break=		NUMERIC}', "");
    Error('\p{Is_SB=		NU/a/}');
    Error('\P{Is_SB=		NU/a/}');
    Expect(1, 125273, '\p{Is_SB=nu}', "");
    Expect(0, 125273, '\p{^Is_SB=nu}', "");
    Expect(0, 125273, '\P{Is_SB=nu}', "");
    Expect(1, 125273, '\P{^Is_SB=nu}', "");
    Expect(0, 125274, '\p{Is_SB=nu}', "");
    Expect(1, 125274, '\p{^Is_SB=nu}', "");
    Expect(1, 125274, '\P{Is_SB=nu}', "");
    Expect(0, 125274, '\P{^Is_SB=nu}', "");
    Expect(1, 125273, '\p{Is_SB=-NU}', "");
    Expect(0, 125273, '\p{^Is_SB=-NU}', "");
    Expect(0, 125273, '\P{Is_SB=-NU}', "");
    Expect(1, 125273, '\P{^Is_SB=-NU}', "");
    Expect(0, 125274, '\p{Is_SB=-NU}', "");
    Expect(1, 125274, '\p{^Is_SB=-NU}', "");
    Expect(1, 125274, '\P{Is_SB=-NU}', "");
    Expect(0, 125274, '\P{^Is_SB=-NU}', "");
    Error('\p{Sentence_Break= :=SCONTINUE}');
    Error('\P{Sentence_Break= :=SCONTINUE}');
    Expect(1, 65380, '\p{Sentence_Break=scontinue}', "");
    Expect(0, 65380, '\p{^Sentence_Break=scontinue}', "");
    Expect(0, 65380, '\P{Sentence_Break=scontinue}', "");
    Expect(1, 65380, '\P{^Sentence_Break=scontinue}', "");
    Expect(0, 65381, '\p{Sentence_Break=scontinue}', "");
    Expect(1, 65381, '\p{^Sentence_Break=scontinue}', "");
    Expect(1, 65381, '\P{Sentence_Break=scontinue}', "");
    Expect(0, 65381, '\P{^Sentence_Break=scontinue}', "");
    Expect(1, 65380, '\p{Sentence_Break=	 scontinue}', "");
    Expect(0, 65380, '\p{^Sentence_Break=	 scontinue}', "");
    Expect(0, 65380, '\P{Sentence_Break=	 scontinue}', "");
    Expect(1, 65380, '\P{^Sentence_Break=	 scontinue}', "");
    Expect(0, 65381, '\p{Sentence_Break=	 scontinue}', "");
    Expect(1, 65381, '\p{^Sentence_Break=	 scontinue}', "");
    Expect(1, 65381, '\P{Sentence_Break=	 scontinue}', "");
    Expect(0, 65381, '\P{^Sentence_Break=	 scontinue}', "");
    Error('\p{SB=-/a/SC}');
    Error('\P{SB=-/a/SC}');
    Expect(1, 65380, '\p{SB=sc}', "");
    Expect(0, 65380, '\p{^SB=sc}', "");
    Expect(0, 65380, '\P{SB=sc}', "");
    Expect(1, 65380, '\P{^SB=sc}', "");
    Expect(0, 65381, '\p{SB=sc}', "");
    Expect(1, 65381, '\p{^SB=sc}', "");
    Expect(1, 65381, '\P{SB=sc}', "");
    Expect(0, 65381, '\P{^SB=sc}', "");
    Expect(1, 65380, '\p{SB= SC}', "");
    Expect(0, 65380, '\p{^SB= SC}', "");
    Expect(0, 65380, '\P{SB= SC}', "");
    Expect(1, 65380, '\P{^SB= SC}', "");
    Expect(0, 65381, '\p{SB= SC}', "");
    Expect(1, 65381, '\p{^SB= SC}', "");
    Expect(1, 65381, '\P{SB= SC}', "");
    Expect(0, 65381, '\P{^SB= SC}', "");
    Error('\p{Is_Sentence_Break=:=_ SContinue}');
    Error('\P{Is_Sentence_Break=:=_ SContinue}');
    Expect(1, 65380, '\p{Is_Sentence_Break=scontinue}', "");
    Expect(0, 65380, '\p{^Is_Sentence_Break=scontinue}', "");
    Expect(0, 65380, '\P{Is_Sentence_Break=scontinue}', "");
    Expect(1, 65380, '\P{^Is_Sentence_Break=scontinue}', "");
    Expect(0, 65381, '\p{Is_Sentence_Break=scontinue}', "");
    Expect(1, 65381, '\p{^Is_Sentence_Break=scontinue}', "");
    Expect(1, 65381, '\P{Is_Sentence_Break=scontinue}', "");
    Expect(0, 65381, '\P{^Is_Sentence_Break=scontinue}', "");
    Expect(1, 65380, '\p{Is_Sentence_Break: 	 scontinue}', "");
    Expect(0, 65380, '\p{^Is_Sentence_Break: 	 scontinue}', "");
    Expect(0, 65380, '\P{Is_Sentence_Break: 	 scontinue}', "");
    Expect(1, 65380, '\P{^Is_Sentence_Break: 	 scontinue}', "");
    Expect(0, 65381, '\p{Is_Sentence_Break: 	 scontinue}', "");
    Expect(1, 65381, '\p{^Is_Sentence_Break: 	 scontinue}', "");
    Expect(1, 65381, '\P{Is_Sentence_Break: 	 scontinue}', "");
    Expect(0, 65381, '\P{^Is_Sentence_Break: 	 scontinue}', "");
    Error('\p{Is_SB=_/a/SC}');
    Error('\P{Is_SB=_/a/SC}');
    Expect(1, 65380, '\p{Is_SB:sc}', "");
    Expect(0, 65380, '\p{^Is_SB:sc}', "");
    Expect(0, 65380, '\P{Is_SB:sc}', "");
    Expect(1, 65380, '\P{^Is_SB:sc}', "");
    Expect(0, 65381, '\p{Is_SB:sc}', "");
    Expect(1, 65381, '\p{^Is_SB:sc}', "");
    Expect(1, 65381, '\P{Is_SB:sc}', "");
    Expect(0, 65381, '\P{^Is_SB:sc}', "");
    Expect(1, 65380, '\p{Is_SB=_ SC}', "");
    Expect(0, 65380, '\p{^Is_SB=_ SC}', "");
    Expect(0, 65380, '\P{Is_SB=_ SC}', "");
    Expect(1, 65380, '\P{^Is_SB=_ SC}', "");
    Expect(0, 65381, '\p{Is_SB=_ SC}', "");
    Expect(1, 65381, '\p{^Is_SB=_ SC}', "");
    Expect(1, 65381, '\P{Is_SB=_ SC}', "");
    Expect(0, 65381, '\P{^Is_SB=_ SC}', "");
    Error('\p{Sentence_Break=	-sep:=}');
    Error('\P{Sentence_Break=	-sep:=}');
    Expect(1, 8233, '\p{Sentence_Break=sep}', "");
    Expect(0, 8233, '\p{^Sentence_Break=sep}', "");
    Expect(0, 8233, '\P{Sentence_Break=sep}', "");
    Expect(1, 8233, '\P{^Sentence_Break=sep}', "");
    Expect(0, 8234, '\p{Sentence_Break=sep}', "");
    Expect(1, 8234, '\p{^Sentence_Break=sep}', "");
    Expect(1, 8234, '\P{Sentence_Break=sep}', "");
    Expect(0, 8234, '\P{^Sentence_Break=sep}', "");
    Expect(1, 8233, '\p{Sentence_Break=  sep}', "");
    Expect(0, 8233, '\p{^Sentence_Break=  sep}', "");
    Expect(0, 8233, '\P{Sentence_Break=  sep}', "");
    Expect(1, 8233, '\P{^Sentence_Break=  sep}', "");
    Expect(0, 8234, '\p{Sentence_Break=  sep}', "");
    Expect(1, 8234, '\p{^Sentence_Break=  sep}', "");
    Expect(1, 8234, '\P{Sentence_Break=  sep}', "");
    Expect(0, 8234, '\P{^Sentence_Break=  sep}', "");
    Error('\p{SB=:=	-SE}');
    Error('\P{SB=:=	-SE}');
    Expect(1, 8233, '\p{SB=se}', "");
    Expect(0, 8233, '\p{^SB=se}', "");
    Expect(0, 8233, '\P{SB=se}', "");
    Expect(1, 8233, '\P{^SB=se}', "");
    Expect(0, 8234, '\p{SB=se}', "");
    Expect(1, 8234, '\p{^SB=se}', "");
    Expect(1, 8234, '\P{SB=se}', "");
    Expect(0, 8234, '\P{^SB=se}', "");
    Expect(1, 8233, '\p{SB=-_SE}', "");
    Expect(0, 8233, '\p{^SB=-_SE}', "");
    Expect(0, 8233, '\P{SB=-_SE}', "");
    Expect(1, 8233, '\P{^SB=-_SE}', "");
    Expect(0, 8234, '\p{SB=-_SE}', "");
    Expect(1, 8234, '\p{^SB=-_SE}', "");
    Expect(1, 8234, '\P{SB=-_SE}', "");
    Expect(0, 8234, '\P{^SB=-_SE}', "");
    Error('\p{Is_Sentence_Break=	 Sep/a/}');
    Error('\P{Is_Sentence_Break=	 Sep/a/}');
    Expect(1, 8233, '\p{Is_Sentence_Break=sep}', "");
    Expect(0, 8233, '\p{^Is_Sentence_Break=sep}', "");
    Expect(0, 8233, '\P{Is_Sentence_Break=sep}', "");
    Expect(1, 8233, '\P{^Is_Sentence_Break=sep}', "");
    Expect(0, 8234, '\p{Is_Sentence_Break=sep}', "");
    Expect(1, 8234, '\p{^Is_Sentence_Break=sep}', "");
    Expect(1, 8234, '\P{Is_Sentence_Break=sep}', "");
    Expect(0, 8234, '\P{^Is_Sentence_Break=sep}', "");
    Expect(1, 8233, '\p{Is_Sentence_Break=_sep}', "");
    Expect(0, 8233, '\p{^Is_Sentence_Break=_sep}', "");
    Expect(0, 8233, '\P{Is_Sentence_Break=_sep}', "");
    Expect(1, 8233, '\P{^Is_Sentence_Break=_sep}', "");
    Expect(0, 8234, '\p{Is_Sentence_Break=_sep}', "");
    Expect(1, 8234, '\p{^Is_Sentence_Break=_sep}', "");
    Expect(1, 8234, '\P{Is_Sentence_Break=_sep}', "");
    Expect(0, 8234, '\P{^Is_Sentence_Break=_sep}', "");
    Error('\p{Is_SB= :=SE}');
    Error('\P{Is_SB= :=SE}');
    Expect(1, 8233, '\p{Is_SB=se}', "");
    Expect(0, 8233, '\p{^Is_SB=se}', "");
    Expect(0, 8233, '\P{Is_SB=se}', "");
    Expect(1, 8233, '\P{^Is_SB=se}', "");
    Expect(0, 8234, '\p{Is_SB=se}', "");
    Expect(1, 8234, '\p{^Is_SB=se}', "");
    Expect(1, 8234, '\P{Is_SB=se}', "");
    Expect(0, 8234, '\P{^Is_SB=se}', "");
    Expect(1, 8233, '\p{Is_SB=  SE}', "");
    Expect(0, 8233, '\p{^Is_SB=  SE}', "");
    Expect(0, 8233, '\P{Is_SB=  SE}', "");
    Expect(1, 8233, '\P{^Is_SB=  SE}', "");
    Expect(0, 8234, '\p{Is_SB=  SE}', "");
    Expect(1, 8234, '\p{^Is_SB=  SE}', "");
    Expect(1, 8234, '\P{Is_SB=  SE}', "");
    Expect(0, 8234, '\P{^Is_SB=  SE}', "");
    Error('\p{Sentence_Break=-Sp:=}');
    Error('\P{Sentence_Break=-Sp:=}');
    Expect(1, 12288, '\p{Sentence_Break=sp}', "");
    Expect(0, 12288, '\p{^Sentence_Break=sp}', "");
    Expect(0, 12288, '\P{Sentence_Break=sp}', "");
    Expect(1, 12288, '\P{^Sentence_Break=sp}', "");
    Expect(0, 12289, '\p{Sentence_Break=sp}', "");
    Expect(1, 12289, '\p{^Sentence_Break=sp}', "");
    Expect(1, 12289, '\P{Sentence_Break=sp}', "");
    Expect(0, 12289, '\P{^Sentence_Break=sp}', "");
    Expect(1, 12288, '\p{Sentence_Break=- Sp}', "");
    Expect(0, 12288, '\p{^Sentence_Break=- Sp}', "");
    Expect(0, 12288, '\P{Sentence_Break=- Sp}', "");
    Expect(1, 12288, '\P{^Sentence_Break=- Sp}', "");
    Expect(0, 12289, '\p{Sentence_Break=- Sp}', "");
    Expect(1, 12289, '\p{^Sentence_Break=- Sp}', "");
    Expect(1, 12289, '\P{Sentence_Break=- Sp}', "");
    Expect(0, 12289, '\P{^Sentence_Break=- Sp}', "");
    Error('\p{SB=--Sp/a/}');
    Error('\P{SB=--Sp/a/}');
    Expect(1, 12288, '\p{SB:sp}', "");
    Expect(0, 12288, '\p{^SB:sp}', "");
    Expect(0, 12288, '\P{SB:sp}', "");
    Expect(1, 12288, '\P{^SB:sp}', "");
    Expect(0, 12289, '\p{SB:sp}', "");
    Expect(1, 12289, '\p{^SB:sp}', "");
    Expect(1, 12289, '\P{SB:sp}', "");
    Expect(0, 12289, '\P{^SB:sp}', "");
    Expect(1, 12288, '\p{SB= Sp}', "");
    Expect(0, 12288, '\p{^SB= Sp}', "");
    Expect(0, 12288, '\P{SB= Sp}', "");
    Expect(1, 12288, '\P{^SB= Sp}', "");
    Expect(0, 12289, '\p{SB= Sp}', "");
    Expect(1, 12289, '\p{^SB= Sp}', "");
    Expect(1, 12289, '\P{SB= Sp}', "");
    Expect(0, 12289, '\P{^SB= Sp}', "");
    Error('\p{Is_Sentence_Break=/a/- SP}');
    Error('\P{Is_Sentence_Break=/a/- SP}');
    Expect(1, 12288, '\p{Is_Sentence_Break:sp}', "");
    Expect(0, 12288, '\p{^Is_Sentence_Break:sp}', "");
    Expect(0, 12288, '\P{Is_Sentence_Break:sp}', "");
    Expect(1, 12288, '\P{^Is_Sentence_Break:sp}', "");
    Expect(0, 12289, '\p{Is_Sentence_Break:sp}', "");
    Expect(1, 12289, '\p{^Is_Sentence_Break:sp}', "");
    Expect(1, 12289, '\P{Is_Sentence_Break:sp}', "");
    Expect(0, 12289, '\P{^Is_Sentence_Break:sp}', "");
    Expect(1, 12288, '\p{Is_Sentence_Break=_Sp}', "");
    Expect(0, 12288, '\p{^Is_Sentence_Break=_Sp}', "");
    Expect(0, 12288, '\P{Is_Sentence_Break=_Sp}', "");
    Expect(1, 12288, '\P{^Is_Sentence_Break=_Sp}', "");
    Expect(0, 12289, '\p{Is_Sentence_Break=_Sp}', "");
    Expect(1, 12289, '\p{^Is_Sentence_Break=_Sp}', "");
    Expect(1, 12289, '\P{Is_Sentence_Break=_Sp}', "");
    Expect(0, 12289, '\P{^Is_Sentence_Break=_Sp}', "");
    Error('\p{Is_SB=:=sp}');
    Error('\P{Is_SB=:=sp}');
    Expect(1, 12288, '\p{Is_SB=sp}', "");
    Expect(0, 12288, '\p{^Is_SB=sp}', "");
    Expect(0, 12288, '\P{Is_SB=sp}', "");
    Expect(1, 12288, '\P{^Is_SB=sp}', "");
    Expect(0, 12289, '\p{Is_SB=sp}', "");
    Expect(1, 12289, '\p{^Is_SB=sp}', "");
    Expect(1, 12289, '\P{Is_SB=sp}', "");
    Expect(0, 12289, '\P{^Is_SB=sp}', "");
    Expect(1, 12288, '\p{Is_SB=- sp}', "");
    Expect(0, 12288, '\p{^Is_SB=- sp}', "");
    Expect(0, 12288, '\P{Is_SB=- sp}', "");
    Expect(1, 12288, '\P{^Is_SB=- sp}', "");
    Expect(0, 12289, '\p{Is_SB=- sp}', "");
    Expect(1, 12289, '\p{^Is_SB=- sp}', "");
    Expect(1, 12289, '\P{Is_SB=- sp}', "");
    Expect(0, 12289, '\P{^Is_SB=- sp}', "");
    Error('\p{Sentence_Break=-/a/sterm}');
    Error('\P{Sentence_Break=-/a/sterm}');
    Expect(1, 121480, '\p{Sentence_Break=sterm}', "");
    Expect(0, 121480, '\p{^Sentence_Break=sterm}', "");
    Expect(0, 121480, '\P{Sentence_Break=sterm}', "");
    Expect(1, 121480, '\P{^Sentence_Break=sterm}', "");
    Expect(0, 121481, '\p{Sentence_Break=sterm}', "");
    Expect(1, 121481, '\p{^Sentence_Break=sterm}', "");
    Expect(1, 121481, '\P{Sentence_Break=sterm}', "");
    Expect(0, 121481, '\P{^Sentence_Break=sterm}', "");
    Expect(1, 121480, '\p{Sentence_Break=	STerm}', "");
    Expect(0, 121480, '\p{^Sentence_Break=	STerm}', "");
    Expect(0, 121480, '\P{Sentence_Break=	STerm}', "");
    Expect(1, 121480, '\P{^Sentence_Break=	STerm}', "");
    Expect(0, 121481, '\p{Sentence_Break=	STerm}', "");
    Expect(1, 121481, '\p{^Sentence_Break=	STerm}', "");
    Expect(1, 121481, '\P{Sentence_Break=	STerm}', "");
    Expect(0, 121481, '\P{^Sentence_Break=	STerm}', "");
    Error('\p{SB= ST/a/}');
    Error('\P{SB= ST/a/}');
    Expect(1, 121480, '\p{SB=st}', "");
    Expect(0, 121480, '\p{^SB=st}', "");
    Expect(0, 121480, '\P{SB=st}', "");
    Expect(1, 121480, '\P{^SB=st}', "");
    Expect(0, 121481, '\p{SB=st}', "");
    Expect(1, 121481, '\p{^SB=st}', "");
    Expect(1, 121481, '\P{SB=st}', "");
    Expect(0, 121481, '\P{^SB=st}', "");
    Expect(1, 121480, '\p{SB= ST}', "");
    Expect(0, 121480, '\p{^SB= ST}', "");
    Expect(0, 121480, '\P{SB= ST}', "");
    Expect(1, 121480, '\P{^SB= ST}', "");
    Expect(0, 121481, '\p{SB= ST}', "");
    Expect(1, 121481, '\p{^SB= ST}', "");
    Expect(1, 121481, '\P{SB= ST}', "");
    Expect(0, 121481, '\P{^SB= ST}', "");
    Error('\p{Is_Sentence_Break=--STerm:=}');
    Error('\P{Is_Sentence_Break=--STerm:=}');
    Expect(1, 121480, '\p{Is_Sentence_Break=sterm}', "");
    Expect(0, 121480, '\p{^Is_Sentence_Break=sterm}', "");
    Expect(0, 121480, '\P{Is_Sentence_Break=sterm}', "");
    Expect(1, 121480, '\P{^Is_Sentence_Break=sterm}', "");
    Expect(0, 121481, '\p{Is_Sentence_Break=sterm}', "");
    Expect(1, 121481, '\p{^Is_Sentence_Break=sterm}', "");
    Expect(1, 121481, '\P{Is_Sentence_Break=sterm}', "");
    Expect(0, 121481, '\P{^Is_Sentence_Break=sterm}', "");
    Expect(1, 121480, '\p{Is_Sentence_Break:   	STERM}', "");
    Expect(0, 121480, '\p{^Is_Sentence_Break:   	STERM}', "");
    Expect(0, 121480, '\P{Is_Sentence_Break:   	STERM}', "");
    Expect(1, 121480, '\P{^Is_Sentence_Break:   	STERM}', "");
    Expect(0, 121481, '\p{Is_Sentence_Break:   	STERM}', "");
    Expect(1, 121481, '\p{^Is_Sentence_Break:   	STERM}', "");
    Expect(1, 121481, '\P{Is_Sentence_Break:   	STERM}', "");
    Expect(0, 121481, '\P{^Is_Sentence_Break:   	STERM}', "");
    Error('\p{Is_SB: -:=st}');
    Error('\P{Is_SB: -:=st}');
    Expect(1, 121480, '\p{Is_SB: st}', "");
    Expect(0, 121480, '\p{^Is_SB: st}', "");
    Expect(0, 121480, '\P{Is_SB: st}', "");
    Expect(1, 121480, '\P{^Is_SB: st}', "");
    Expect(0, 121481, '\p{Is_SB: st}', "");
    Expect(1, 121481, '\p{^Is_SB: st}', "");
    Expect(1, 121481, '\P{Is_SB: st}', "");
    Expect(0, 121481, '\P{^Is_SB: st}', "");
    Expect(1, 121480, '\p{Is_SB=_	ST}', "");
    Expect(0, 121480, '\p{^Is_SB=_	ST}', "");
    Expect(0, 121480, '\P{Is_SB=_	ST}', "");
    Expect(1, 121480, '\P{^Is_SB=_	ST}', "");
    Expect(0, 121481, '\p{Is_SB=_	ST}', "");
    Expect(1, 121481, '\p{^Is_SB=_	ST}', "");
    Expect(1, 121481, '\P{Is_SB=_	ST}', "");
    Expect(0, 121481, '\P{^Is_SB=_	ST}', "");
    Error('\p{Sentence_Break=		UPPER/a/}');
    Error('\P{Sentence_Break=		UPPER/a/}');
    Expect(1, 127369, '\p{Sentence_Break=upper}', "");
    Expect(0, 127369, '\p{^Sentence_Break=upper}', "");
    Expect(0, 127369, '\P{Sentence_Break=upper}', "");
    Expect(1, 127369, '\P{^Sentence_Break=upper}', "");
    Expect(0, 127370, '\p{Sentence_Break=upper}', "");
    Expect(1, 127370, '\p{^Sentence_Break=upper}', "");
    Expect(1, 127370, '\P{Sentence_Break=upper}', "");
    Expect(0, 127370, '\P{^Sentence_Break=upper}', "");
    Expect(1, 127369, '\p{Sentence_Break=  Upper}', "");
    Expect(0, 127369, '\p{^Sentence_Break=  Upper}', "");
    Expect(0, 127369, '\P{Sentence_Break=  Upper}', "");
    Expect(1, 127369, '\P{^Sentence_Break=  Upper}', "");
    Expect(0, 127370, '\p{Sentence_Break=  Upper}', "");
    Expect(1, 127370, '\p{^Sentence_Break=  Upper}', "");
    Expect(1, 127370, '\P{Sentence_Break=  Upper}', "");
    Expect(0, 127370, '\P{^Sentence_Break=  Upper}', "");
    Error('\p{SB=:=_UP}');
    Error('\P{SB=:=_UP}');
    Expect(1, 127369, '\p{SB=up}', "");
    Expect(0, 127369, '\p{^SB=up}', "");
    Expect(0, 127369, '\P{SB=up}', "");
    Expect(1, 127369, '\P{^SB=up}', "");
    Expect(0, 127370, '\p{SB=up}', "");
    Expect(1, 127370, '\p{^SB=up}', "");
    Expect(1, 127370, '\P{SB=up}', "");
    Expect(0, 127370, '\P{^SB=up}', "");
    Expect(1, 127369, '\p{SB=-_UP}', "");
    Expect(0, 127369, '\p{^SB=-_UP}', "");
    Expect(0, 127369, '\P{SB=-_UP}', "");
    Expect(1, 127369, '\P{^SB=-_UP}', "");
    Expect(0, 127370, '\p{SB=-_UP}', "");
    Expect(1, 127370, '\p{^SB=-_UP}', "");
    Expect(1, 127370, '\P{SB=-_UP}', "");
    Expect(0, 127370, '\P{^SB=-_UP}', "");
    Error('\p{Is_Sentence_Break=-/a/Upper}');
    Error('\P{Is_Sentence_Break=-/a/Upper}');
    Expect(1, 127369, '\p{Is_Sentence_Break: upper}', "");
    Expect(0, 127369, '\p{^Is_Sentence_Break: upper}', "");
    Expect(0, 127369, '\P{Is_Sentence_Break: upper}', "");
    Expect(1, 127369, '\P{^Is_Sentence_Break: upper}', "");
    Expect(0, 127370, '\p{Is_Sentence_Break: upper}', "");
    Expect(1, 127370, '\p{^Is_Sentence_Break: upper}', "");
    Expect(1, 127370, '\P{Is_Sentence_Break: upper}', "");
    Expect(0, 127370, '\P{^Is_Sentence_Break: upper}', "");
    Expect(1, 127369, '\p{Is_Sentence_Break=	upper}', "");
    Expect(0, 127369, '\p{^Is_Sentence_Break=	upper}', "");
    Expect(0, 127369, '\P{Is_Sentence_Break=	upper}', "");
    Expect(1, 127369, '\P{^Is_Sentence_Break=	upper}', "");
    Expect(0, 127370, '\p{Is_Sentence_Break=	upper}', "");
    Expect(1, 127370, '\p{^Is_Sentence_Break=	upper}', "");
    Expect(1, 127370, '\P{Is_Sentence_Break=	upper}', "");
    Expect(0, 127370, '\P{^Is_Sentence_Break=	upper}', "");
    Error('\p{Is_SB=	/a/UP}');
    Error('\P{Is_SB=	/a/UP}');
    Expect(1, 127369, '\p{Is_SB=up}', "");
    Expect(0, 127369, '\p{^Is_SB=up}', "");
    Expect(0, 127369, '\P{Is_SB=up}', "");
    Expect(1, 127369, '\P{^Is_SB=up}', "");
    Expect(0, 127370, '\p{Is_SB=up}', "");
    Expect(1, 127370, '\p{^Is_SB=up}', "");
    Expect(1, 127370, '\P{Is_SB=up}', "");
    Expect(0, 127370, '\P{^Is_SB=up}', "");
    Expect(1, 127369, '\p{Is_SB=-	UP}', "");
    Expect(0, 127369, '\p{^Is_SB=-	UP}', "");
    Expect(0, 127369, '\P{Is_SB=-	UP}', "");
    Expect(1, 127369, '\P{^Is_SB=-	UP}', "");
    Expect(0, 127370, '\p{Is_SB=-	UP}', "");
    Expect(1, 127370, '\p{^Is_SB=-	UP}', "");
    Expect(1, 127370, '\P{Is_SB=-	UP}', "");
    Expect(0, 127370, '\P{^Is_SB=-	UP}', "");
    Error('\p{Sentence_Break=	:=other}');
    Error('\P{Sentence_Break=	:=other}');
    Expect(1, 918000, '\p{Sentence_Break:other}', "");
    Expect(0, 918000, '\p{^Sentence_Break:other}', "");
    Expect(0, 918000, '\P{Sentence_Break:other}', "");
    Expect(1, 918000, '\P{^Sentence_Break:other}', "");
    Expect(0, 917999, '\p{Sentence_Break:other}', "");
    Expect(1, 917999, '\p{^Sentence_Break:other}', "");
    Expect(1, 917999, '\P{Sentence_Break:other}', "");
    Expect(0, 917999, '\P{^Sentence_Break:other}', "");
    Expect(1, 918000, '\p{Sentence_Break= OTHER}', "");
    Expect(0, 918000, '\p{^Sentence_Break= OTHER}', "");
    Expect(0, 918000, '\P{Sentence_Break= OTHER}', "");
    Expect(1, 918000, '\P{^Sentence_Break= OTHER}', "");
    Expect(0, 917999, '\p{Sentence_Break= OTHER}', "");
    Expect(1, 917999, '\p{^Sentence_Break= OTHER}', "");
    Expect(1, 917999, '\P{Sentence_Break= OTHER}', "");
    Expect(0, 917999, '\P{^Sentence_Break= OTHER}', "");
    Error('\p{SB=_:=xx}');
    Error('\P{SB=_:=xx}');
    Expect(1, 918000, '\p{SB=xx}', "");
    Expect(0, 918000, '\p{^SB=xx}', "");
    Expect(0, 918000, '\P{SB=xx}', "");
    Expect(1, 918000, '\P{^SB=xx}', "");
    Expect(0, 917999, '\p{SB=xx}', "");
    Expect(1, 917999, '\p{^SB=xx}', "");
    Expect(1, 917999, '\P{SB=xx}', "");
    Expect(0, 917999, '\P{^SB=xx}', "");
    Expect(1, 918000, '\p{SB=	_XX}', "");
    Expect(0, 918000, '\p{^SB=	_XX}', "");
    Expect(0, 918000, '\P{SB=	_XX}', "");
    Expect(1, 918000, '\P{^SB=	_XX}', "");
    Expect(0, 917999, '\p{SB=	_XX}', "");
    Expect(1, 917999, '\p{^SB=	_XX}', "");
    Expect(1, 917999, '\P{SB=	_XX}', "");
    Expect(0, 917999, '\P{^SB=	_XX}', "");
    Error('\p{Is_Sentence_Break= /a/Other}');
    Error('\P{Is_Sentence_Break= /a/Other}');
    Expect(1, 918000, '\p{Is_Sentence_Break=other}', "");
    Expect(0, 918000, '\p{^Is_Sentence_Break=other}', "");
    Expect(0, 918000, '\P{Is_Sentence_Break=other}', "");
    Expect(1, 918000, '\P{^Is_Sentence_Break=other}', "");
    Expect(0, 917999, '\p{Is_Sentence_Break=other}', "");
    Expect(1, 917999, '\p{^Is_Sentence_Break=other}', "");
    Expect(1, 917999, '\P{Is_Sentence_Break=other}', "");
    Expect(0, 917999, '\P{^Is_Sentence_Break=other}', "");
    Expect(1, 918000, '\p{Is_Sentence_Break= Other}', "");
    Expect(0, 918000, '\p{^Is_Sentence_Break= Other}', "");
    Expect(0, 918000, '\P{Is_Sentence_Break= Other}', "");
    Expect(1, 918000, '\P{^Is_Sentence_Break= Other}', "");
    Expect(0, 917999, '\p{Is_Sentence_Break= Other}', "");
    Expect(1, 917999, '\p{^Is_Sentence_Break= Other}', "");
    Expect(1, 917999, '\P{Is_Sentence_Break= Other}', "");
    Expect(0, 917999, '\P{^Is_Sentence_Break= Other}', "");
    Error('\p{Is_SB=		XX:=}');
    Error('\P{Is_SB=		XX:=}');
    Expect(1, 918000, '\p{Is_SB=xx}', "");
    Expect(0, 918000, '\p{^Is_SB=xx}', "");
    Expect(0, 918000, '\P{Is_SB=xx}', "");
    Expect(1, 918000, '\P{^Is_SB=xx}', "");
    Expect(0, 917999, '\p{Is_SB=xx}', "");
    Expect(1, 917999, '\p{^Is_SB=xx}', "");
    Expect(1, 917999, '\P{Is_SB=xx}', "");
    Expect(0, 917999, '\P{^Is_SB=xx}', "");
    Expect(1, 918000, '\p{Is_SB=	xx}', "");
    Expect(0, 918000, '\p{^Is_SB=	xx}', "");
    Expect(0, 918000, '\P{Is_SB=	xx}', "");
    Expect(1, 918000, '\P{^Is_SB=	xx}', "");
    Expect(0, 917999, '\p{Is_SB=	xx}', "");
    Expect(1, 917999, '\p{^Is_SB=	xx}', "");
    Expect(1, 917999, '\P{Is_SB=	xx}', "");
    Expect(0, 917999, '\P{^Is_SB=	xx}', "");
    Error('\p{script}');
    Error('\P{script}');
    Error('\p{Script=-:=Adlam}');
    Error('\P{Script=-:=Adlam}');
    Expect(1, 125279, '\p{Script=adlam}', "");
    Expect(0, 125279, '\p{^Script=adlam}', "");
    Expect(0, 125279, '\P{Script=adlam}', "");
    Expect(1, 125279, '\P{^Script=adlam}', "");
    Expect(0, 125280, '\p{Script=adlam}', "");
    Expect(1, 125280, '\p{^Script=adlam}', "");
    Expect(1, 125280, '\P{Script=adlam}', "");
    Expect(0, 125280, '\P{^Script=adlam}', "");
    Expect(1, 125279, '\p{Script= _adlam}', "");
    Expect(0, 125279, '\p{^Script= _adlam}', "");
    Expect(0, 125279, '\P{Script= _adlam}', "");
    Expect(1, 125279, '\P{^Script= _adlam}', "");
    Expect(0, 125280, '\p{Script= _adlam}', "");
    Expect(1, 125280, '\p{^Script= _adlam}', "");
    Expect(1, 125280, '\P{Script= _adlam}', "");
    Expect(0, 125280, '\P{^Script= _adlam}', "");
    Error('\p{Sc=__adlm/a/}');
    Error('\P{Sc=__adlm/a/}');
    Expect(1, 125279, '\p{Sc=adlm}', "");
    Expect(0, 125279, '\p{^Sc=adlm}', "");
    Expect(0, 125279, '\P{Sc=adlm}', "");
    Expect(1, 125279, '\P{^Sc=adlm}', "");
    Expect(0, 125280, '\p{Sc=adlm}', "");
    Expect(1, 125280, '\p{^Sc=adlm}', "");
    Expect(1, 125280, '\P{Sc=adlm}', "");
    Expect(0, 125280, '\P{^Sc=adlm}', "");
    Expect(1, 125279, '\p{Sc: --Adlm}', "");
    Expect(0, 125279, '\p{^Sc: --Adlm}', "");
    Expect(0, 125279, '\P{Sc: --Adlm}', "");
    Expect(1, 125279, '\P{^Sc: --Adlm}', "");
    Expect(0, 125280, '\p{Sc: --Adlm}', "");
    Expect(1, 125280, '\p{^Sc: --Adlm}', "");
    Expect(1, 125280, '\P{Sc: --Adlm}', "");
    Expect(0, 125280, '\P{^Sc: --Adlm}', "");
    Error('\p{Is_Script=/a/Adlam}');
    Error('\P{Is_Script=/a/Adlam}');
    Expect(1, 125279, '\p{Is_Script=adlam}', "");
    Expect(0, 125279, '\p{^Is_Script=adlam}', "");
    Expect(0, 125279, '\P{Is_Script=adlam}', "");
    Expect(1, 125279, '\P{^Is_Script=adlam}', "");
    Expect(0, 125280, '\p{Is_Script=adlam}', "");
    Expect(1, 125280, '\p{^Is_Script=adlam}', "");
    Expect(1, 125280, '\P{Is_Script=adlam}', "");
    Expect(0, 125280, '\P{^Is_Script=adlam}', "");
    Expect(1, 125279, '\p{Is_Script=_ADLAM}', "");
    Expect(0, 125279, '\p{^Is_Script=_ADLAM}', "");
    Expect(0, 125279, '\P{Is_Script=_ADLAM}', "");
    Expect(1, 125279, '\P{^Is_Script=_ADLAM}', "");
    Expect(0, 125280, '\p{Is_Script=_ADLAM}', "");
    Expect(1, 125280, '\p{^Is_Script=_ADLAM}', "");
    Expect(1, 125280, '\P{Is_Script=_ADLAM}', "");
    Expect(0, 125280, '\P{^Is_Script=_ADLAM}', "");
    Error('\p{Is_Sc: /a/adlm}');
    Error('\P{Is_Sc: /a/adlm}');
    Expect(1, 125279, '\p{Is_Sc=adlm}', "");
    Expect(0, 125279, '\p{^Is_Sc=adlm}', "");
    Expect(0, 125279, '\P{Is_Sc=adlm}', "");
    Expect(1, 125279, '\P{^Is_Sc=adlm}', "");
    Expect(0, 125280, '\p{Is_Sc=adlm}', "");
    Expect(1, 125280, '\p{^Is_Sc=adlm}', "");
    Expect(1, 125280, '\P{Is_Sc=adlm}', "");
    Expect(0, 125280, '\P{^Is_Sc=adlm}', "");
    Expect(1, 125279, '\p{Is_Sc=ADLM}', "");
    Expect(0, 125279, '\p{^Is_Sc=ADLM}', "");
    Expect(0, 125279, '\P{Is_Sc=ADLM}', "");
    Expect(1, 125279, '\P{^Is_Sc=ADLM}', "");
    Expect(0, 125280, '\p{Is_Sc=ADLM}', "");
    Expect(1, 125280, '\p{^Is_Sc=ADLM}', "");
    Expect(1, 125280, '\P{Is_Sc=ADLM}', "");
    Expect(0, 125280, '\P{^Is_Sc=ADLM}', "");
    Error('\p{Script= :=CAUCASIAN_ALBANIAN}');
    Error('\P{Script= :=CAUCASIAN_ALBANIAN}');
    Expect(1, 66927, '\p{Script=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Script=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Script=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Script=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Script=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Script=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Script=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Script=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Script=	caucasian_ALBANIAN}', "");
    Expect(0, 66927, '\p{^Script=	caucasian_ALBANIAN}', "");
    Expect(0, 66927, '\P{Script=	caucasian_ALBANIAN}', "");
    Expect(1, 66927, '\P{^Script=	caucasian_ALBANIAN}', "");
    Expect(0, 66928, '\p{Script=	caucasian_ALBANIAN}', "");
    Expect(1, 66928, '\p{^Script=	caucasian_ALBANIAN}', "");
    Expect(1, 66928, '\P{Script=	caucasian_ALBANIAN}', "");
    Expect(0, 66928, '\P{^Script=	caucasian_ALBANIAN}', "");
    Error('\p{Sc=Aghb:=}');
    Error('\P{Sc=Aghb:=}');
    Expect(1, 66927, '\p{Sc=aghb}', "");
    Expect(0, 66927, '\p{^Sc=aghb}', "");
    Expect(0, 66927, '\P{Sc=aghb}', "");
    Expect(1, 66927, '\P{^Sc=aghb}', "");
    Expect(0, 66928, '\p{Sc=aghb}', "");
    Expect(1, 66928, '\p{^Sc=aghb}', "");
    Expect(1, 66928, '\P{Sc=aghb}', "");
    Expect(0, 66928, '\P{^Sc=aghb}', "");
    Expect(1, 66927, '\p{Sc=	_AGHB}', "");
    Expect(0, 66927, '\p{^Sc=	_AGHB}', "");
    Expect(0, 66927, '\P{Sc=	_AGHB}', "");
    Expect(1, 66927, '\P{^Sc=	_AGHB}', "");
    Expect(0, 66928, '\p{Sc=	_AGHB}', "");
    Expect(1, 66928, '\p{^Sc=	_AGHB}', "");
    Expect(1, 66928, '\P{Sc=	_AGHB}', "");
    Expect(0, 66928, '\P{^Sc=	_AGHB}', "");
    Error('\p{Is_Script=:=CAUCASIAN_albanian}');
    Error('\P{Is_Script=:=CAUCASIAN_albanian}');
    Expect(1, 66927, '\p{Is_Script=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Is_Script=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Is_Script=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Is_Script=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Is_Script=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Is_Script=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Is_Script=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Is_Script=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Is_Script=_Caucasian_ALBANIAN}', "");
    Expect(0, 66927, '\p{^Is_Script=_Caucasian_ALBANIAN}', "");
    Expect(0, 66927, '\P{Is_Script=_Caucasian_ALBANIAN}', "");
    Expect(1, 66927, '\P{^Is_Script=_Caucasian_ALBANIAN}', "");
    Expect(0, 66928, '\p{Is_Script=_Caucasian_ALBANIAN}', "");
    Expect(1, 66928, '\p{^Is_Script=_Caucasian_ALBANIAN}', "");
    Expect(1, 66928, '\P{Is_Script=_Caucasian_ALBANIAN}', "");
    Expect(0, 66928, '\P{^Is_Script=_Caucasian_ALBANIAN}', "");
    Error('\p{Is_Sc=:=_aghb}');
    Error('\P{Is_Sc=:=_aghb}');
    Expect(1, 66927, '\p{Is_Sc=aghb}', "");
    Expect(0, 66927, '\p{^Is_Sc=aghb}', "");
    Expect(0, 66927, '\P{Is_Sc=aghb}', "");
    Expect(1, 66927, '\P{^Is_Sc=aghb}', "");
    Expect(0, 66928, '\p{Is_Sc=aghb}', "");
    Expect(1, 66928, '\p{^Is_Sc=aghb}', "");
    Expect(1, 66928, '\P{Is_Sc=aghb}', "");
    Expect(0, 66928, '\P{^Is_Sc=aghb}', "");
    Expect(1, 66927, '\p{Is_Sc=_-aghb}', "");
    Expect(0, 66927, '\p{^Is_Sc=_-aghb}', "");
    Expect(0, 66927, '\P{Is_Sc=_-aghb}', "");
    Expect(1, 66927, '\P{^Is_Sc=_-aghb}', "");
    Expect(0, 66928, '\p{Is_Sc=_-aghb}', "");
    Expect(1, 66928, '\p{^Is_Sc=_-aghb}', "");
    Expect(1, 66928, '\P{Is_Sc=_-aghb}', "");
    Expect(0, 66928, '\P{^Is_Sc=_-aghb}', "");
    Error('\p{Script=-/a/Ahom}');
    Error('\P{Script=-/a/Ahom}');
    Expect(1, 71487, '\p{Script=ahom}', "");
    Expect(0, 71487, '\p{^Script=ahom}', "");
    Expect(0, 71487, '\P{Script=ahom}', "");
    Expect(1, 71487, '\P{^Script=ahom}', "");
    Expect(0, 71488, '\p{Script=ahom}', "");
    Expect(1, 71488, '\p{^Script=ahom}', "");
    Expect(1, 71488, '\P{Script=ahom}', "");
    Expect(0, 71488, '\P{^Script=ahom}', "");
    Expect(1, 71487, '\p{Script:   -ahom}', "");
    Expect(0, 71487, '\p{^Script:   -ahom}', "");
    Expect(0, 71487, '\P{Script:   -ahom}', "");
    Expect(1, 71487, '\P{^Script:   -ahom}', "");
    Expect(0, 71488, '\p{Script:   -ahom}', "");
    Expect(1, 71488, '\p{^Script:   -ahom}', "");
    Expect(1, 71488, '\P{Script:   -ahom}', "");
    Expect(0, 71488, '\P{^Script:   -ahom}', "");
    Error('\p{Sc= AHOM/a/}');
    Error('\P{Sc= AHOM/a/}');
    Expect(1, 71487, '\p{Sc=ahom}', "");
    Expect(0, 71487, '\p{^Sc=ahom}', "");
    Expect(0, 71487, '\P{Sc=ahom}', "");
    Expect(1, 71487, '\P{^Sc=ahom}', "");
    Expect(0, 71488, '\p{Sc=ahom}', "");
    Expect(1, 71488, '\p{^Sc=ahom}', "");
    Expect(1, 71488, '\P{Sc=ahom}', "");
    Expect(0, 71488, '\P{^Sc=ahom}', "");
    Expect(1, 71487, '\p{Sc=		AHOM}', "");
    Expect(0, 71487, '\p{^Sc=		AHOM}', "");
    Expect(0, 71487, '\P{Sc=		AHOM}', "");
    Expect(1, 71487, '\P{^Sc=		AHOM}', "");
    Expect(0, 71488, '\p{Sc=		AHOM}', "");
    Expect(1, 71488, '\p{^Sc=		AHOM}', "");
    Expect(1, 71488, '\P{Sc=		AHOM}', "");
    Expect(0, 71488, '\P{^Sc=		AHOM}', "");
    Error('\p{Is_Script=- Ahom:=}');
    Error('\P{Is_Script=- Ahom:=}');
    Expect(1, 71487, '\p{Is_Script=ahom}', "");
    Expect(0, 71487, '\p{^Is_Script=ahom}', "");
    Expect(0, 71487, '\P{Is_Script=ahom}', "");
    Expect(1, 71487, '\P{^Is_Script=ahom}', "");
    Expect(0, 71488, '\p{Is_Script=ahom}', "");
    Expect(1, 71488, '\p{^Is_Script=ahom}', "");
    Expect(1, 71488, '\P{Is_Script=ahom}', "");
    Expect(0, 71488, '\P{^Is_Script=ahom}', "");
    Expect(1, 71487, '\p{Is_Script=AHOM}', "");
    Expect(0, 71487, '\p{^Is_Script=AHOM}', "");
    Expect(0, 71487, '\P{Is_Script=AHOM}', "");
    Expect(1, 71487, '\P{^Is_Script=AHOM}', "");
    Expect(0, 71488, '\p{Is_Script=AHOM}', "");
    Expect(1, 71488, '\p{^Is_Script=AHOM}', "");
    Expect(1, 71488, '\P{Is_Script=AHOM}', "");
    Expect(0, 71488, '\P{^Is_Script=AHOM}', "");
    Error('\p{Is_Sc=/a/	AHOM}');
    Error('\P{Is_Sc=/a/	AHOM}');
    Expect(1, 71487, '\p{Is_Sc=ahom}', "");
    Expect(0, 71487, '\p{^Is_Sc=ahom}', "");
    Expect(0, 71487, '\P{Is_Sc=ahom}', "");
    Expect(1, 71487, '\P{^Is_Sc=ahom}', "");
    Expect(0, 71488, '\p{Is_Sc=ahom}', "");
    Expect(1, 71488, '\p{^Is_Sc=ahom}', "");
    Expect(1, 71488, '\P{Is_Sc=ahom}', "");
    Expect(0, 71488, '\P{^Is_Sc=ahom}', "");
    Expect(1, 71487, '\p{Is_Sc= -AHOM}', "");
    Expect(0, 71487, '\p{^Is_Sc= -AHOM}', "");
    Expect(0, 71487, '\P{Is_Sc= -AHOM}', "");
    Expect(1, 71487, '\P{^Is_Sc= -AHOM}', "");
    Expect(0, 71488, '\p{Is_Sc= -AHOM}', "");
    Expect(1, 71488, '\p{^Is_Sc= -AHOM}', "");
    Expect(1, 71488, '\P{Is_Sc= -AHOM}', "");
    Expect(0, 71488, '\P{^Is_Sc= -AHOM}', "");
    Error('\p{Script=:= _Arabic}');
    Error('\P{Script=:= _Arabic}');
    Expect(1, 126705, '\p{Script:arabic}', "");
    Expect(0, 126705, '\p{^Script:arabic}', "");
    Expect(0, 126705, '\P{Script:arabic}', "");
    Expect(1, 126705, '\P{^Script:arabic}', "");
    Expect(0, 126706, '\p{Script:arabic}', "");
    Expect(1, 126706, '\p{^Script:arabic}', "");
    Expect(1, 126706, '\P{Script:arabic}', "");
    Expect(0, 126706, '\P{^Script:arabic}', "");
    Error('\p{Sc=--arab:=}');
    Error('\P{Sc=--arab:=}');
    Expect(1, 126705, '\p{Sc=arab}', "");
    Expect(0, 126705, '\p{^Sc=arab}', "");
    Expect(0, 126705, '\P{Sc=arab}', "");
    Expect(1, 126705, '\P{^Sc=arab}', "");
    Expect(0, 126706, '\p{Sc=arab}', "");
    Expect(1, 126706, '\p{^Sc=arab}', "");
    Expect(1, 126706, '\P{Sc=arab}', "");
    Expect(0, 126706, '\P{^Sc=arab}', "");
    Expect(1, 126705, '\p{Sc=_ ARAB}', "");
    Expect(0, 126705, '\p{^Sc=_ ARAB}', "");
    Expect(0, 126705, '\P{Sc=_ ARAB}', "");
    Expect(1, 126705, '\P{^Sc=_ ARAB}', "");
    Expect(0, 126706, '\p{Sc=_ ARAB}', "");
    Expect(1, 126706, '\p{^Sc=_ ARAB}', "");
    Expect(1, 126706, '\P{Sc=_ ARAB}', "");
    Expect(0, 126706, '\P{^Sc=_ ARAB}', "");
    Error('\p{Is_Script=_:=ARABIC}');
    Error('\P{Is_Script=_:=ARABIC}');
    Expect(1, 126705, '\p{Is_Script=arabic}', "");
    Expect(0, 126705, '\p{^Is_Script=arabic}', "");
    Expect(0, 126705, '\P{Is_Script=arabic}', "");
    Expect(1, 126705, '\P{^Is_Script=arabic}', "");
    Expect(0, 126706, '\p{Is_Script=arabic}', "");
    Expect(1, 126706, '\p{^Is_Script=arabic}', "");
    Expect(1, 126706, '\P{Is_Script=arabic}', "");
    Expect(0, 126706, '\P{^Is_Script=arabic}', "");
    Error('\p{Is_Sc=_:=ARAB}');
    Error('\P{Is_Sc=_:=ARAB}');
    Expect(1, 126705, '\p{Is_Sc=arab}', "");
    Expect(0, 126705, '\p{^Is_Sc=arab}', "");
    Expect(0, 126705, '\P{Is_Sc=arab}', "");
    Expect(1, 126705, '\P{^Is_Sc=arab}', "");
    Expect(0, 126706, '\p{Is_Sc=arab}', "");
    Expect(1, 126706, '\p{^Is_Sc=arab}', "");
    Expect(1, 126706, '\P{Is_Sc=arab}', "");
    Expect(0, 126706, '\P{^Is_Sc=arab}', "");
    Expect(1, 126705, '\p{Is_Sc=-Arab}', "");
    Expect(0, 126705, '\p{^Is_Sc=-Arab}', "");
    Expect(0, 126705, '\P{Is_Sc=-Arab}', "");
    Expect(1, 126705, '\P{^Is_Sc=-Arab}', "");
    Expect(0, 126706, '\p{Is_Sc=-Arab}', "");
    Expect(1, 126706, '\p{^Is_Sc=-Arab}', "");
    Expect(1, 126706, '\P{Is_Sc=-Arab}', "");
    Expect(0, 126706, '\P{^Is_Sc=-Arab}', "");
    Error('\p{Script:   /a/Imperial_Aramaic}');
    Error('\P{Script:   /a/Imperial_Aramaic}');
    Expect(1, 67679, '\p{Script=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Script=imperialaramaic}', "");
    Expect(0, 67679, '\P{Script=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Script=imperialaramaic}', "");
    Expect(0, 67680, '\p{Script=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Script=imperialaramaic}', "");
    Expect(1, 67680, '\P{Script=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Script=imperialaramaic}', "");
    Expect(1, 67679, '\p{Script:    IMPERIAL_Aramaic}', "");
    Expect(0, 67679, '\p{^Script:    IMPERIAL_Aramaic}', "");
    Expect(0, 67679, '\P{Script:    IMPERIAL_Aramaic}', "");
    Expect(1, 67679, '\P{^Script:    IMPERIAL_Aramaic}', "");
    Expect(0, 67680, '\p{Script:    IMPERIAL_Aramaic}', "");
    Expect(1, 67680, '\p{^Script:    IMPERIAL_Aramaic}', "");
    Expect(1, 67680, '\P{Script:    IMPERIAL_Aramaic}', "");
    Expect(0, 67680, '\P{^Script:    IMPERIAL_Aramaic}', "");
    Error('\p{Sc=-/a/ARMI}');
    Error('\P{Sc=-/a/ARMI}');
    Expect(1, 67679, '\p{Sc=armi}', "");
    Expect(0, 67679, '\p{^Sc=armi}', "");
    Expect(0, 67679, '\P{Sc=armi}', "");
    Expect(1, 67679, '\P{^Sc=armi}', "");
    Expect(0, 67680, '\p{Sc=armi}', "");
    Expect(1, 67680, '\p{^Sc=armi}', "");
    Expect(1, 67680, '\P{Sc=armi}', "");
    Expect(0, 67680, '\P{^Sc=armi}', "");
    Expect(1, 67679, '\p{Sc=-Armi}', "");
    Expect(0, 67679, '\p{^Sc=-Armi}', "");
    Expect(0, 67679, '\P{Sc=-Armi}', "");
    Expect(1, 67679, '\P{^Sc=-Armi}', "");
    Expect(0, 67680, '\p{Sc=-Armi}', "");
    Expect(1, 67680, '\p{^Sc=-Armi}', "");
    Expect(1, 67680, '\P{Sc=-Armi}', "");
    Expect(0, 67680, '\P{^Sc=-Armi}', "");
    Error('\p{Is_Script=- IMPERIAL_ARAMAIC:=}');
    Error('\P{Is_Script=- IMPERIAL_ARAMAIC:=}');
    Expect(1, 67679, '\p{Is_Script=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Is_Script=imperialaramaic}', "");
    Expect(0, 67679, '\P{Is_Script=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Is_Script=imperialaramaic}', "");
    Expect(0, 67680, '\p{Is_Script=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Is_Script=imperialaramaic}', "");
    Expect(1, 67680, '\P{Is_Script=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Is_Script=imperialaramaic}', "");
    Expect(1, 67679, '\p{Is_Script:	_-Imperial_aramaic}', "");
    Expect(0, 67679, '\p{^Is_Script:	_-Imperial_aramaic}', "");
    Expect(0, 67679, '\P{Is_Script:	_-Imperial_aramaic}', "");
    Expect(1, 67679, '\P{^Is_Script:	_-Imperial_aramaic}', "");
    Expect(0, 67680, '\p{Is_Script:	_-Imperial_aramaic}', "");
    Expect(1, 67680, '\p{^Is_Script:	_-Imperial_aramaic}', "");
    Expect(1, 67680, '\P{Is_Script:	_-Imperial_aramaic}', "");
    Expect(0, 67680, '\P{^Is_Script:	_-Imperial_aramaic}', "");
    Error('\p{Is_Sc=:=--ARMI}');
    Error('\P{Is_Sc=:=--ARMI}');
    Expect(1, 67679, '\p{Is_Sc=armi}', "");
    Expect(0, 67679, '\p{^Is_Sc=armi}', "");
    Expect(0, 67679, '\P{Is_Sc=armi}', "");
    Expect(1, 67679, '\P{^Is_Sc=armi}', "");
    Expect(0, 67680, '\p{Is_Sc=armi}', "");
    Expect(1, 67680, '\p{^Is_Sc=armi}', "");
    Expect(1, 67680, '\P{Is_Sc=armi}', "");
    Expect(0, 67680, '\P{^Is_Sc=armi}', "");
    Expect(1, 67679, '\p{Is_Sc=	-ARMI}', "");
    Expect(0, 67679, '\p{^Is_Sc=	-ARMI}', "");
    Expect(0, 67679, '\P{Is_Sc=	-ARMI}', "");
    Expect(1, 67679, '\P{^Is_Sc=	-ARMI}', "");
    Expect(0, 67680, '\p{Is_Sc=	-ARMI}', "");
    Expect(1, 67680, '\p{^Is_Sc=	-ARMI}', "");
    Expect(1, 67680, '\P{Is_Sc=	-ARMI}', "");
    Expect(0, 67680, '\P{^Is_Sc=	-ARMI}', "");
    Error('\p{Script=/a/ Armenian}');
    Error('\P{Script=/a/ Armenian}');
    Expect(1, 64279, '\p{Script:	armenian}', "");
    Expect(0, 64279, '\p{^Script:	armenian}', "");
    Expect(0, 64279, '\P{Script:	armenian}', "");
    Expect(1, 64279, '\P{^Script:	armenian}', "");
    Expect(0, 64280, '\p{Script:	armenian}', "");
    Expect(1, 64280, '\p{^Script:	armenian}', "");
    Expect(1, 64280, '\P{Script:	armenian}', "");
    Expect(0, 64280, '\P{^Script:	armenian}', "");
    Expect(1, 64279, '\p{Script=	_Armenian}', "");
    Expect(0, 64279, '\p{^Script=	_Armenian}', "");
    Expect(0, 64279, '\P{Script=	_Armenian}', "");
    Expect(1, 64279, '\P{^Script=	_Armenian}', "");
    Expect(0, 64280, '\p{Script=	_Armenian}', "");
    Expect(1, 64280, '\p{^Script=	_Armenian}', "");
    Expect(1, 64280, '\P{Script=	_Armenian}', "");
    Expect(0, 64280, '\P{^Script=	_Armenian}', "");
    Error('\p{Sc=	Armn/a/}');
    Error('\P{Sc=	Armn/a/}');
    Expect(1, 64279, '\p{Sc=armn}', "");
    Expect(0, 64279, '\p{^Sc=armn}', "");
    Expect(0, 64279, '\P{Sc=armn}', "");
    Expect(1, 64279, '\P{^Sc=armn}', "");
    Expect(0, 64280, '\p{Sc=armn}', "");
    Expect(1, 64280, '\p{^Sc=armn}', "");
    Expect(1, 64280, '\P{Sc=armn}', "");
    Expect(0, 64280, '\P{^Sc=armn}', "");
    Expect(1, 64279, '\p{Sc=- Armn}', "");
    Expect(0, 64279, '\p{^Sc=- Armn}', "");
    Expect(0, 64279, '\P{Sc=- Armn}', "");
    Expect(1, 64279, '\P{^Sc=- Armn}', "");
    Expect(0, 64280, '\p{Sc=- Armn}', "");
    Expect(1, 64280, '\p{^Sc=- Armn}', "");
    Expect(1, 64280, '\P{Sc=- Armn}', "");
    Expect(0, 64280, '\P{^Sc=- Armn}', "");
    Error('\p{Is_Script=	/a/armenian}');
    Error('\P{Is_Script=	/a/armenian}');
    Expect(1, 64279, '\p{Is_Script=armenian}', "");
    Expect(0, 64279, '\p{^Is_Script=armenian}', "");
    Expect(0, 64279, '\P{Is_Script=armenian}', "");
    Expect(1, 64279, '\P{^Is_Script=armenian}', "");
    Expect(0, 64280, '\p{Is_Script=armenian}', "");
    Expect(1, 64280, '\p{^Is_Script=armenian}', "");
    Expect(1, 64280, '\P{Is_Script=armenian}', "");
    Expect(0, 64280, '\P{^Is_Script=armenian}', "");
    Expect(1, 64279, '\p{Is_Script=--Armenian}', "");
    Expect(0, 64279, '\p{^Is_Script=--Armenian}', "");
    Expect(0, 64279, '\P{Is_Script=--Armenian}', "");
    Expect(1, 64279, '\P{^Is_Script=--Armenian}', "");
    Expect(0, 64280, '\p{Is_Script=--Armenian}', "");
    Expect(1, 64280, '\p{^Is_Script=--Armenian}', "");
    Expect(1, 64280, '\P{Is_Script=--Armenian}', "");
    Expect(0, 64280, '\P{^Is_Script=--Armenian}', "");
    Error('\p{Is_Sc= armn/a/}');
    Error('\P{Is_Sc= armn/a/}');
    Expect(1, 64279, '\p{Is_Sc=armn}', "");
    Expect(0, 64279, '\p{^Is_Sc=armn}', "");
    Expect(0, 64279, '\P{Is_Sc=armn}', "");
    Expect(1, 64279, '\P{^Is_Sc=armn}', "");
    Expect(0, 64280, '\p{Is_Sc=armn}', "");
    Expect(1, 64280, '\p{^Is_Sc=armn}', "");
    Expect(1, 64280, '\P{Is_Sc=armn}', "");
    Expect(0, 64280, '\P{^Is_Sc=armn}', "");
    Expect(1, 64279, '\p{Is_Sc=	-Armn}', "");
    Expect(0, 64279, '\p{^Is_Sc=	-Armn}', "");
    Expect(0, 64279, '\P{Is_Sc=	-Armn}', "");
    Expect(1, 64279, '\P{^Is_Sc=	-Armn}', "");
    Expect(0, 64280, '\p{Is_Sc=	-Armn}', "");
    Expect(1, 64280, '\p{^Is_Sc=	-Armn}', "");
    Expect(1, 64280, '\P{Is_Sc=	-Armn}', "");
    Expect(0, 64280, '\P{^Is_Sc=	-Armn}', "");
    Error('\p{Script=/a/ _AVESTAN}');
    Error('\P{Script=/a/ _AVESTAN}');
    Expect(1, 68415, '\p{Script=avestan}', "");
    Expect(0, 68415, '\p{^Script=avestan}', "");
    Expect(0, 68415, '\P{Script=avestan}', "");
    Expect(1, 68415, '\P{^Script=avestan}', "");
    Expect(0, 68416, '\p{Script=avestan}', "");
    Expect(1, 68416, '\p{^Script=avestan}', "");
    Expect(1, 68416, '\P{Script=avestan}', "");
    Expect(0, 68416, '\P{^Script=avestan}', "");
    Expect(1, 68415, '\p{Script=-Avestan}', "");
    Expect(0, 68415, '\p{^Script=-Avestan}', "");
    Expect(0, 68415, '\P{Script=-Avestan}', "");
    Expect(1, 68415, '\P{^Script=-Avestan}', "");
    Expect(0, 68416, '\p{Script=-Avestan}', "");
    Expect(1, 68416, '\p{^Script=-Avestan}', "");
    Expect(1, 68416, '\P{Script=-Avestan}', "");
    Expect(0, 68416, '\P{^Script=-Avestan}', "");
    Error('\p{Sc::=avst}');
    Error('\P{Sc::=avst}');
    Expect(1, 68415, '\p{Sc=avst}', "");
    Expect(0, 68415, '\p{^Sc=avst}', "");
    Expect(0, 68415, '\P{Sc=avst}', "");
    Expect(1, 68415, '\P{^Sc=avst}', "");
    Expect(0, 68416, '\p{Sc=avst}', "");
    Expect(1, 68416, '\p{^Sc=avst}', "");
    Expect(1, 68416, '\P{Sc=avst}', "");
    Expect(0, 68416, '\P{^Sc=avst}', "");
    Expect(1, 68415, '\p{Sc=	_AVST}', "");
    Expect(0, 68415, '\p{^Sc=	_AVST}', "");
    Expect(0, 68415, '\P{Sc=	_AVST}', "");
    Expect(1, 68415, '\P{^Sc=	_AVST}', "");
    Expect(0, 68416, '\p{Sc=	_AVST}', "");
    Expect(1, 68416, '\p{^Sc=	_AVST}', "");
    Expect(1, 68416, '\P{Sc=	_AVST}', "");
    Expect(0, 68416, '\P{^Sc=	_AVST}', "");
    Error('\p{Is_Script=-AVESTAN/a/}');
    Error('\P{Is_Script=-AVESTAN/a/}');
    Expect(1, 68415, '\p{Is_Script=avestan}', "");
    Expect(0, 68415, '\p{^Is_Script=avestan}', "");
    Expect(0, 68415, '\P{Is_Script=avestan}', "");
    Expect(1, 68415, '\P{^Is_Script=avestan}', "");
    Expect(0, 68416, '\p{Is_Script=avestan}', "");
    Expect(1, 68416, '\p{^Is_Script=avestan}', "");
    Expect(1, 68416, '\P{Is_Script=avestan}', "");
    Expect(0, 68416, '\P{^Is_Script=avestan}', "");
    Expect(1, 68415, '\p{Is_Script=-_avestan}', "");
    Expect(0, 68415, '\p{^Is_Script=-_avestan}', "");
    Expect(0, 68415, '\P{Is_Script=-_avestan}', "");
    Expect(1, 68415, '\P{^Is_Script=-_avestan}', "");
    Expect(0, 68416, '\p{Is_Script=-_avestan}', "");
    Expect(1, 68416, '\p{^Is_Script=-_avestan}', "");
    Expect(1, 68416, '\P{Is_Script=-_avestan}', "");
    Expect(0, 68416, '\P{^Is_Script=-_avestan}', "");
    Error('\p{Is_Sc:    :=avst}');
    Error('\P{Is_Sc:    :=avst}');
    Expect(1, 68415, '\p{Is_Sc=avst}', "");
    Expect(0, 68415, '\p{^Is_Sc=avst}', "");
    Expect(0, 68415, '\P{Is_Sc=avst}', "");
    Expect(1, 68415, '\P{^Is_Sc=avst}', "");
    Expect(0, 68416, '\p{Is_Sc=avst}', "");
    Expect(1, 68416, '\p{^Is_Sc=avst}', "");
    Expect(1, 68416, '\P{Is_Sc=avst}', "");
    Expect(0, 68416, '\P{^Is_Sc=avst}', "");
    Expect(1, 68415, '\p{Is_Sc=_Avst}', "");
    Expect(0, 68415, '\p{^Is_Sc=_Avst}', "");
    Expect(0, 68415, '\P{Is_Sc=_Avst}', "");
    Expect(1, 68415, '\P{^Is_Sc=_Avst}', "");
    Expect(0, 68416, '\p{Is_Sc=_Avst}', "");
    Expect(1, 68416, '\p{^Is_Sc=_Avst}', "");
    Expect(1, 68416, '\P{Is_Sc=_Avst}', "");
    Expect(0, 68416, '\P{^Is_Sc=_Avst}', "");
    Error('\p{Script=	/a/balinese}');
    Error('\P{Script=	/a/balinese}');
    Expect(1, 7036, '\p{Script=balinese}', "");
    Expect(0, 7036, '\p{^Script=balinese}', "");
    Expect(0, 7036, '\P{Script=balinese}', "");
    Expect(1, 7036, '\P{^Script=balinese}', "");
    Expect(0, 7037, '\p{Script=balinese}', "");
    Expect(1, 7037, '\p{^Script=balinese}', "");
    Expect(1, 7037, '\P{Script=balinese}', "");
    Expect(0, 7037, '\P{^Script=balinese}', "");
    Expect(1, 7036, '\p{Script=-BALINESE}', "");
    Expect(0, 7036, '\p{^Script=-BALINESE}', "");
    Expect(0, 7036, '\P{Script=-BALINESE}', "");
    Expect(1, 7036, '\P{^Script=-BALINESE}', "");
    Expect(0, 7037, '\p{Script=-BALINESE}', "");
    Expect(1, 7037, '\p{^Script=-BALINESE}', "");
    Expect(1, 7037, '\P{Script=-BALINESE}', "");
    Expect(0, 7037, '\P{^Script=-BALINESE}', "");
    Error('\p{Sc=:=Bali}');
    Error('\P{Sc=:=Bali}');
    Expect(1, 7036, '\p{Sc=bali}', "");
    Expect(0, 7036, '\p{^Sc=bali}', "");
    Expect(0, 7036, '\P{Sc=bali}', "");
    Expect(1, 7036, '\P{^Sc=bali}', "");
    Expect(0, 7037, '\p{Sc=bali}', "");
    Expect(1, 7037, '\p{^Sc=bali}', "");
    Expect(1, 7037, '\P{Sc=bali}', "");
    Expect(0, 7037, '\P{^Sc=bali}', "");
    Expect(1, 7036, '\p{Sc: -	BALI}', "");
    Expect(0, 7036, '\p{^Sc: -	BALI}', "");
    Expect(0, 7036, '\P{Sc: -	BALI}', "");
    Expect(1, 7036, '\P{^Sc: -	BALI}', "");
    Expect(0, 7037, '\p{Sc: -	BALI}', "");
    Expect(1, 7037, '\p{^Sc: -	BALI}', "");
    Expect(1, 7037, '\P{Sc: -	BALI}', "");
    Expect(0, 7037, '\P{^Sc: -	BALI}', "");
    Error('\p{Is_Script=:= Balinese}');
    Error('\P{Is_Script=:= Balinese}');
    Expect(1, 7036, '\p{Is_Script=balinese}', "");
    Expect(0, 7036, '\p{^Is_Script=balinese}', "");
    Expect(0, 7036, '\P{Is_Script=balinese}', "");
    Expect(1, 7036, '\P{^Is_Script=balinese}', "");
    Expect(0, 7037, '\p{Is_Script=balinese}', "");
    Expect(1, 7037, '\p{^Is_Script=balinese}', "");
    Expect(1, 7037, '\P{Is_Script=balinese}', "");
    Expect(0, 7037, '\P{^Is_Script=balinese}', "");
    Expect(1, 7036, '\p{Is_Script=		balinese}', "");
    Expect(0, 7036, '\p{^Is_Script=		balinese}', "");
    Expect(0, 7036, '\P{Is_Script=		balinese}', "");
    Expect(1, 7036, '\P{^Is_Script=		balinese}', "");
    Expect(0, 7037, '\p{Is_Script=		balinese}', "");
    Expect(1, 7037, '\p{^Is_Script=		balinese}', "");
    Expect(1, 7037, '\P{Is_Script=		balinese}', "");
    Expect(0, 7037, '\P{^Is_Script=		balinese}', "");
    Error('\p{Is_Sc=-:=Bali}');
    Error('\P{Is_Sc=-:=Bali}');
    Expect(1, 7036, '\p{Is_Sc=bali}', "");
    Expect(0, 7036, '\p{^Is_Sc=bali}', "");
    Expect(0, 7036, '\P{Is_Sc=bali}', "");
    Expect(1, 7036, '\P{^Is_Sc=bali}', "");
    Expect(0, 7037, '\p{Is_Sc=bali}', "");
    Expect(1, 7037, '\p{^Is_Sc=bali}', "");
    Expect(1, 7037, '\P{Is_Sc=bali}', "");
    Expect(0, 7037, '\P{^Is_Sc=bali}', "");
    Expect(1, 7036, '\p{Is_Sc=Bali}', "");
    Expect(0, 7036, '\p{^Is_Sc=Bali}', "");
    Expect(0, 7036, '\P{Is_Sc=Bali}', "");
    Expect(1, 7036, '\P{^Is_Sc=Bali}', "");
    Expect(0, 7037, '\p{Is_Sc=Bali}', "");
    Expect(1, 7037, '\p{^Is_Sc=Bali}', "");
    Expect(1, 7037, '\P{Is_Sc=Bali}', "");
    Expect(0, 7037, '\P{^Is_Sc=Bali}', "");
    Error('\p{Script=-	bamum:=}');
    Error('\P{Script=-	bamum:=}');
    Expect(1, 92728, '\p{Script=bamum}', "");
    Expect(0, 92728, '\p{^Script=bamum}', "");
    Expect(0, 92728, '\P{Script=bamum}', "");
    Expect(1, 92728, '\P{^Script=bamum}', "");
    Expect(0, 92729, '\p{Script=bamum}', "");
    Expect(1, 92729, '\p{^Script=bamum}', "");
    Expect(1, 92729, '\P{Script=bamum}', "");
    Expect(0, 92729, '\P{^Script=bamum}', "");
    Expect(1, 92728, '\p{Script=	 bamum}', "");
    Expect(0, 92728, '\p{^Script=	 bamum}', "");
    Expect(0, 92728, '\P{Script=	 bamum}', "");
    Expect(1, 92728, '\P{^Script=	 bamum}', "");
    Expect(0, 92729, '\p{Script=	 bamum}', "");
    Expect(1, 92729, '\p{^Script=	 bamum}', "");
    Expect(1, 92729, '\P{Script=	 bamum}', "");
    Expect(0, 92729, '\P{^Script=	 bamum}', "");
    Error('\p{Sc=	:=Bamu}');
    Error('\P{Sc=	:=Bamu}');
    Expect(1, 92728, '\p{Sc=bamu}', "");
    Expect(0, 92728, '\p{^Sc=bamu}', "");
    Expect(0, 92728, '\P{Sc=bamu}', "");
    Expect(1, 92728, '\P{^Sc=bamu}', "");
    Expect(0, 92729, '\p{Sc=bamu}', "");
    Expect(1, 92729, '\p{^Sc=bamu}', "");
    Expect(1, 92729, '\P{Sc=bamu}', "");
    Expect(0, 92729, '\P{^Sc=bamu}', "");
    Expect(1, 92728, '\p{Sc= BAMU}', "");
    Expect(0, 92728, '\p{^Sc= BAMU}', "");
    Expect(0, 92728, '\P{Sc= BAMU}', "");
    Expect(1, 92728, '\P{^Sc= BAMU}', "");
    Expect(0, 92729, '\p{Sc= BAMU}', "");
    Expect(1, 92729, '\p{^Sc= BAMU}', "");
    Expect(1, 92729, '\P{Sc= BAMU}', "");
    Expect(0, 92729, '\P{^Sc= BAMU}', "");
    Error('\p{Is_Script=-Bamum:=}');
    Error('\P{Is_Script=-Bamum:=}');
    Expect(1, 92728, '\p{Is_Script=bamum}', "");
    Expect(0, 92728, '\p{^Is_Script=bamum}', "");
    Expect(0, 92728, '\P{Is_Script=bamum}', "");
    Expect(1, 92728, '\P{^Is_Script=bamum}', "");
    Expect(0, 92729, '\p{Is_Script=bamum}', "");
    Expect(1, 92729, '\p{^Is_Script=bamum}', "");
    Expect(1, 92729, '\P{Is_Script=bamum}', "");
    Expect(0, 92729, '\P{^Is_Script=bamum}', "");
    Expect(1, 92728, '\p{Is_Script=  Bamum}', "");
    Expect(0, 92728, '\p{^Is_Script=  Bamum}', "");
    Expect(0, 92728, '\P{Is_Script=  Bamum}', "");
    Expect(1, 92728, '\P{^Is_Script=  Bamum}', "");
    Expect(0, 92729, '\p{Is_Script=  Bamum}', "");
    Expect(1, 92729, '\p{^Is_Script=  Bamum}', "");
    Expect(1, 92729, '\P{Is_Script=  Bamum}', "");
    Expect(0, 92729, '\P{^Is_Script=  Bamum}', "");
    Error('\p{Is_Sc:	:=-BAMU}');
    Error('\P{Is_Sc:	:=-BAMU}');
    Expect(1, 92728, '\p{Is_Sc=bamu}', "");
    Expect(0, 92728, '\p{^Is_Sc=bamu}', "");
    Expect(0, 92728, '\P{Is_Sc=bamu}', "");
    Expect(1, 92728, '\P{^Is_Sc=bamu}', "");
    Expect(0, 92729, '\p{Is_Sc=bamu}', "");
    Expect(1, 92729, '\p{^Is_Sc=bamu}', "");
    Expect(1, 92729, '\P{Is_Sc=bamu}', "");
    Expect(0, 92729, '\P{^Is_Sc=bamu}', "");
    Expect(1, 92728, '\p{Is_Sc=- BAMU}', "");
    Expect(0, 92728, '\p{^Is_Sc=- BAMU}', "");
    Expect(0, 92728, '\P{Is_Sc=- BAMU}', "");
    Expect(1, 92728, '\P{^Is_Sc=- BAMU}', "");
    Expect(0, 92729, '\p{Is_Sc=- BAMU}', "");
    Expect(1, 92729, '\p{^Is_Sc=- BAMU}', "");
    Expect(1, 92729, '\P{Is_Sc=- BAMU}', "");
    Expect(0, 92729, '\P{^Is_Sc=- BAMU}', "");
    Error('\p{Script:/a/-	Bassa_Vah}');
    Error('\P{Script:/a/-	Bassa_Vah}');
    Expect(1, 92917, '\p{Script=bassavah}', "");
    Expect(0, 92917, '\p{^Script=bassavah}', "");
    Expect(0, 92917, '\P{Script=bassavah}', "");
    Expect(1, 92917, '\P{^Script=bassavah}', "");
    Expect(0, 92918, '\p{Script=bassavah}', "");
    Expect(1, 92918, '\p{^Script=bassavah}', "");
    Expect(1, 92918, '\P{Script=bassavah}', "");
    Expect(0, 92918, '\P{^Script=bassavah}', "");
    Expect(1, 92917, '\p{Script= _Bassa_VAH}', "");
    Expect(0, 92917, '\p{^Script= _Bassa_VAH}', "");
    Expect(0, 92917, '\P{Script= _Bassa_VAH}', "");
    Expect(1, 92917, '\P{^Script= _Bassa_VAH}', "");
    Expect(0, 92918, '\p{Script= _Bassa_VAH}', "");
    Expect(1, 92918, '\p{^Script= _Bassa_VAH}', "");
    Expect(1, 92918, '\P{Script= _Bassa_VAH}', "");
    Expect(0, 92918, '\P{^Script= _Bassa_VAH}', "");
    Error('\p{Sc=/a/	_BASS}');
    Error('\P{Sc=/a/	_BASS}');
    Expect(1, 92917, '\p{Sc=bass}', "");
    Expect(0, 92917, '\p{^Sc=bass}', "");
    Expect(0, 92917, '\P{Sc=bass}', "");
    Expect(1, 92917, '\P{^Sc=bass}', "");
    Expect(0, 92918, '\p{Sc=bass}', "");
    Expect(1, 92918, '\p{^Sc=bass}', "");
    Expect(1, 92918, '\P{Sc=bass}', "");
    Expect(0, 92918, '\P{^Sc=bass}', "");
    Expect(1, 92917, '\p{Sc=-BASS}', "");
    Expect(0, 92917, '\p{^Sc=-BASS}', "");
    Expect(0, 92917, '\P{Sc=-BASS}', "");
    Expect(1, 92917, '\P{^Sc=-BASS}', "");
    Expect(0, 92918, '\p{Sc=-BASS}', "");
    Expect(1, 92918, '\p{^Sc=-BASS}', "");
    Expect(1, 92918, '\P{Sc=-BASS}', "");
    Expect(0, 92918, '\P{^Sc=-BASS}', "");
    Error('\p{Is_Script=_Bassa_VAH:=}');
    Error('\P{Is_Script=_Bassa_VAH:=}');
    Expect(1, 92917, '\p{Is_Script=bassavah}', "");
    Expect(0, 92917, '\p{^Is_Script=bassavah}', "");
    Expect(0, 92917, '\P{Is_Script=bassavah}', "");
    Expect(1, 92917, '\P{^Is_Script=bassavah}', "");
    Expect(0, 92918, '\p{Is_Script=bassavah}', "");
    Expect(1, 92918, '\p{^Is_Script=bassavah}', "");
    Expect(1, 92918, '\P{Is_Script=bassavah}', "");
    Expect(0, 92918, '\P{^Is_Script=bassavah}', "");
    Expect(1, 92917, '\p{Is_Script=_ Bassa_Vah}', "");
    Expect(0, 92917, '\p{^Is_Script=_ Bassa_Vah}', "");
    Expect(0, 92917, '\P{Is_Script=_ Bassa_Vah}', "");
    Expect(1, 92917, '\P{^Is_Script=_ Bassa_Vah}', "");
    Expect(0, 92918, '\p{Is_Script=_ Bassa_Vah}', "");
    Expect(1, 92918, '\p{^Is_Script=_ Bassa_Vah}', "");
    Expect(1, 92918, '\P{Is_Script=_ Bassa_Vah}', "");
    Expect(0, 92918, '\P{^Is_Script=_ Bassa_Vah}', "");
    Error('\p{Is_Sc=/a/-Bass}');
    Error('\P{Is_Sc=/a/-Bass}');
    Expect(1, 92917, '\p{Is_Sc=bass}', "");
    Expect(0, 92917, '\p{^Is_Sc=bass}', "");
    Expect(0, 92917, '\P{Is_Sc=bass}', "");
    Expect(1, 92917, '\P{^Is_Sc=bass}', "");
    Expect(0, 92918, '\p{Is_Sc=bass}', "");
    Expect(1, 92918, '\p{^Is_Sc=bass}', "");
    Expect(1, 92918, '\P{Is_Sc=bass}', "");
    Expect(0, 92918, '\P{^Is_Sc=bass}', "");
    Expect(1, 92917, '\p{Is_Sc: 	BASS}', "");
    Expect(0, 92917, '\p{^Is_Sc: 	BASS}', "");
    Expect(0, 92917, '\P{Is_Sc: 	BASS}', "");
    Expect(1, 92917, '\P{^Is_Sc: 	BASS}', "");
    Expect(0, 92918, '\p{Is_Sc: 	BASS}', "");
    Expect(1, 92918, '\p{^Is_Sc: 	BASS}', "");
    Expect(1, 92918, '\P{Is_Sc: 	BASS}', "");
    Expect(0, 92918, '\P{^Is_Sc: 	BASS}', "");
    Error('\p{Script=/a/  BATAK}');
    Error('\P{Script=/a/  BATAK}');
    Expect(1, 7167, '\p{Script=batak}', "");
    Expect(0, 7167, '\p{^Script=batak}', "");
    Expect(0, 7167, '\P{Script=batak}', "");
    Expect(1, 7167, '\P{^Script=batak}', "");
    Expect(0, 7168, '\p{Script=batak}', "");
    Expect(1, 7168, '\p{^Script=batak}', "");
    Expect(1, 7168, '\P{Script=batak}', "");
    Expect(0, 7168, '\P{^Script=batak}', "");
    Expect(1, 7167, '\p{Script=  batak}', "");
    Expect(0, 7167, '\p{^Script=  batak}', "");
    Expect(0, 7167, '\P{Script=  batak}', "");
    Expect(1, 7167, '\P{^Script=  batak}', "");
    Expect(0, 7168, '\p{Script=  batak}', "");
    Expect(1, 7168, '\p{^Script=  batak}', "");
    Expect(1, 7168, '\P{Script=  batak}', "");
    Expect(0, 7168, '\P{^Script=  batak}', "");
    Error('\p{Sc=	batk/a/}');
    Error('\P{Sc=	batk/a/}');
    Expect(1, 7167, '\p{Sc=batk}', "");
    Expect(0, 7167, '\p{^Sc=batk}', "");
    Expect(0, 7167, '\P{Sc=batk}', "");
    Expect(1, 7167, '\P{^Sc=batk}', "");
    Expect(0, 7168, '\p{Sc=batk}', "");
    Expect(1, 7168, '\p{^Sc=batk}', "");
    Expect(1, 7168, '\P{Sc=batk}', "");
    Expect(0, 7168, '\P{^Sc=batk}', "");
    Expect(1, 7167, '\p{Sc= -Batk}', "");
    Expect(0, 7167, '\p{^Sc= -Batk}', "");
    Expect(0, 7167, '\P{Sc= -Batk}', "");
    Expect(1, 7167, '\P{^Sc= -Batk}', "");
    Expect(0, 7168, '\p{Sc= -Batk}', "");
    Expect(1, 7168, '\p{^Sc= -Batk}', "");
    Expect(1, 7168, '\P{Sc= -Batk}', "");
    Expect(0, 7168, '\P{^Sc= -Batk}', "");
    Error('\p{Is_Script=:=-	batak}');
    Error('\P{Is_Script=:=-	batak}');
    Expect(1, 7167, '\p{Is_Script=batak}', "");
    Expect(0, 7167, '\p{^Is_Script=batak}', "");
    Expect(0, 7167, '\P{Is_Script=batak}', "");
    Expect(1, 7167, '\P{^Is_Script=batak}', "");
    Expect(0, 7168, '\p{Is_Script=batak}', "");
    Expect(1, 7168, '\p{^Is_Script=batak}', "");
    Expect(1, 7168, '\P{Is_Script=batak}', "");
    Expect(0, 7168, '\P{^Is_Script=batak}', "");
    Expect(1, 7167, '\p{Is_Script:   _	batak}', "");
    Expect(0, 7167, '\p{^Is_Script:   _	batak}', "");
    Expect(0, 7167, '\P{Is_Script:   _	batak}', "");
    Expect(1, 7167, '\P{^Is_Script:   _	batak}', "");
    Expect(0, 7168, '\p{Is_Script:   _	batak}', "");
    Expect(1, 7168, '\p{^Is_Script:   _	batak}', "");
    Expect(1, 7168, '\P{Is_Script:   _	batak}', "");
    Expect(0, 7168, '\P{^Is_Script:   _	batak}', "");
    Error('\p{Is_Sc=:=_batk}');
    Error('\P{Is_Sc=:=_batk}');
    Expect(1, 7167, '\p{Is_Sc=batk}', "");
    Expect(0, 7167, '\p{^Is_Sc=batk}', "");
    Expect(0, 7167, '\P{Is_Sc=batk}', "");
    Expect(1, 7167, '\P{^Is_Sc=batk}', "");
    Expect(0, 7168, '\p{Is_Sc=batk}', "");
    Expect(1, 7168, '\p{^Is_Sc=batk}', "");
    Expect(1, 7168, '\P{Is_Sc=batk}', "");
    Expect(0, 7168, '\P{^Is_Sc=batk}', "");
    Expect(1, 7167, '\p{Is_Sc= BATK}', "");
    Expect(0, 7167, '\p{^Is_Sc= BATK}', "");
    Expect(0, 7167, '\P{Is_Sc= BATK}', "");
    Expect(1, 7167, '\P{^Is_Sc= BATK}', "");
    Expect(0, 7168, '\p{Is_Sc= BATK}', "");
    Expect(1, 7168, '\p{^Is_Sc= BATK}', "");
    Expect(1, 7168, '\P{Is_Sc= BATK}', "");
    Expect(0, 7168, '\P{^Is_Sc= BATK}', "");
    Error('\p{Script:/a/ _BENGALI}');
    Error('\P{Script:/a/ _BENGALI}');
    Expect(1, 2557, '\p{Script=bengali}', "");
    Expect(0, 2557, '\p{^Script=bengali}', "");
    Expect(0, 2557, '\P{Script=bengali}', "");
    Expect(1, 2557, '\P{^Script=bengali}', "");
    Expect(0, 2558, '\p{Script=bengali}', "");
    Expect(1, 2558, '\p{^Script=bengali}', "");
    Expect(1, 2558, '\P{Script=bengali}', "");
    Expect(0, 2558, '\P{^Script=bengali}', "");
    Expect(1, 2557, '\p{Script=	-Bengali}', "");
    Expect(0, 2557, '\p{^Script=	-Bengali}', "");
    Expect(0, 2557, '\P{Script=	-Bengali}', "");
    Expect(1, 2557, '\P{^Script=	-Bengali}', "");
    Expect(0, 2558, '\p{Script=	-Bengali}', "");
    Expect(1, 2558, '\p{^Script=	-Bengali}', "");
    Expect(1, 2558, '\P{Script=	-Bengali}', "");
    Expect(0, 2558, '\P{^Script=	-Bengali}', "");
    Error('\p{Sc=/a/_	Beng}');
    Error('\P{Sc=/a/_	Beng}');
    Expect(1, 2557, '\p{Sc:   beng}', "");
    Expect(0, 2557, '\p{^Sc:   beng}', "");
    Expect(0, 2557, '\P{Sc:   beng}', "");
    Expect(1, 2557, '\P{^Sc:   beng}', "");
    Expect(0, 2558, '\p{Sc:   beng}', "");
    Expect(1, 2558, '\p{^Sc:   beng}', "");
    Expect(1, 2558, '\P{Sc:   beng}', "");
    Expect(0, 2558, '\P{^Sc:   beng}', "");
    Expect(1, 2557, '\p{Sc= 	Beng}', "");
    Expect(0, 2557, '\p{^Sc= 	Beng}', "");
    Expect(0, 2557, '\P{Sc= 	Beng}', "");
    Expect(1, 2557, '\P{^Sc= 	Beng}', "");
    Expect(0, 2558, '\p{Sc= 	Beng}', "");
    Expect(1, 2558, '\p{^Sc= 	Beng}', "");
    Expect(1, 2558, '\P{Sc= 	Beng}', "");
    Expect(0, 2558, '\P{^Sc= 	Beng}', "");
    Error('\p{Is_Script=_/a/BENGALI}');
    Error('\P{Is_Script=_/a/BENGALI}');
    Expect(1, 2557, '\p{Is_Script=bengali}', "");
    Expect(0, 2557, '\p{^Is_Script=bengali}', "");
    Expect(0, 2557, '\P{Is_Script=bengali}', "");
    Expect(1, 2557, '\P{^Is_Script=bengali}', "");
    Expect(0, 2558, '\p{Is_Script=bengali}', "");
    Expect(1, 2558, '\p{^Is_Script=bengali}', "");
    Expect(1, 2558, '\P{Is_Script=bengali}', "");
    Expect(0, 2558, '\P{^Is_Script=bengali}', "");
    Expect(1, 2557, '\p{Is_Script=	-bengali}', "");
    Expect(0, 2557, '\p{^Is_Script=	-bengali}', "");
    Expect(0, 2557, '\P{Is_Script=	-bengali}', "");
    Expect(1, 2557, '\P{^Is_Script=	-bengali}', "");
    Expect(0, 2558, '\p{Is_Script=	-bengali}', "");
    Expect(1, 2558, '\p{^Is_Script=	-bengali}', "");
    Expect(1, 2558, '\P{Is_Script=	-bengali}', "");
    Expect(0, 2558, '\P{^Is_Script=	-bengali}', "");
    Error('\p{Is_Sc=	BENG/a/}');
    Error('\P{Is_Sc=	BENG/a/}');
    Expect(1, 2557, '\p{Is_Sc=beng}', "");
    Expect(0, 2557, '\p{^Is_Sc=beng}', "");
    Expect(0, 2557, '\P{Is_Sc=beng}', "");
    Expect(1, 2557, '\P{^Is_Sc=beng}', "");
    Expect(0, 2558, '\p{Is_Sc=beng}', "");
    Expect(1, 2558, '\p{^Is_Sc=beng}', "");
    Expect(1, 2558, '\P{Is_Sc=beng}', "");
    Expect(0, 2558, '\P{^Is_Sc=beng}', "");
    Expect(1, 2557, '\p{Is_Sc=_ BENG}', "");
    Expect(0, 2557, '\p{^Is_Sc=_ BENG}', "");
    Expect(0, 2557, '\P{Is_Sc=_ BENG}', "");
    Expect(1, 2557, '\P{^Is_Sc=_ BENG}', "");
    Expect(0, 2558, '\p{Is_Sc=_ BENG}', "");
    Expect(1, 2558, '\p{^Is_Sc=_ BENG}', "");
    Expect(1, 2558, '\P{Is_Sc=_ BENG}', "");
    Expect(0, 2558, '\P{^Is_Sc=_ BENG}', "");
    Error('\p{Script=/a/	 bhaiksuki}');
    Error('\P{Script=/a/	 bhaiksuki}');
    Expect(1, 72812, '\p{Script=bhaiksuki}', "");
    Expect(0, 72812, '\p{^Script=bhaiksuki}', "");
    Expect(0, 72812, '\P{Script=bhaiksuki}', "");
    Expect(1, 72812, '\P{^Script=bhaiksuki}', "");
    Expect(0, 72813, '\p{Script=bhaiksuki}', "");
    Expect(1, 72813, '\p{^Script=bhaiksuki}', "");
    Expect(1, 72813, '\P{Script=bhaiksuki}', "");
    Expect(0, 72813, '\P{^Script=bhaiksuki}', "");
    Expect(1, 72812, '\p{Script= bhaiksuki}', "");
    Expect(0, 72812, '\p{^Script= bhaiksuki}', "");
    Expect(0, 72812, '\P{Script= bhaiksuki}', "");
    Expect(1, 72812, '\P{^Script= bhaiksuki}', "");
    Expect(0, 72813, '\p{Script= bhaiksuki}', "");
    Expect(1, 72813, '\p{^Script= bhaiksuki}', "");
    Expect(1, 72813, '\P{Script= bhaiksuki}', "");
    Expect(0, 72813, '\P{^Script= bhaiksuki}', "");
    Error('\p{Sc=- bhks:=}');
    Error('\P{Sc=- bhks:=}');
    Expect(1, 72812, '\p{Sc=bhks}', "");
    Expect(0, 72812, '\p{^Sc=bhks}', "");
    Expect(0, 72812, '\P{Sc=bhks}', "");
    Expect(1, 72812, '\P{^Sc=bhks}', "");
    Expect(0, 72813, '\p{Sc=bhks}', "");
    Expect(1, 72813, '\p{^Sc=bhks}', "");
    Expect(1, 72813, '\P{Sc=bhks}', "");
    Expect(0, 72813, '\P{^Sc=bhks}', "");
    Expect(1, 72812, '\p{Sc= _Bhks}', "");
    Expect(0, 72812, '\p{^Sc= _Bhks}', "");
    Expect(0, 72812, '\P{Sc= _Bhks}', "");
    Expect(1, 72812, '\P{^Sc= _Bhks}', "");
    Expect(0, 72813, '\p{Sc= _Bhks}', "");
    Expect(1, 72813, '\p{^Sc= _Bhks}', "");
    Expect(1, 72813, '\P{Sc= _Bhks}', "");
    Expect(0, 72813, '\P{^Sc= _Bhks}', "");
    Error('\p{Is_Script:	:=_Bhaiksuki}');
    Error('\P{Is_Script:	:=_Bhaiksuki}');
    Expect(1, 72812, '\p{Is_Script=bhaiksuki}', "");
    Expect(0, 72812, '\p{^Is_Script=bhaiksuki}', "");
    Expect(0, 72812, '\P{Is_Script=bhaiksuki}', "");
    Expect(1, 72812, '\P{^Is_Script=bhaiksuki}', "");
    Expect(0, 72813, '\p{Is_Script=bhaiksuki}', "");
    Expect(1, 72813, '\p{^Is_Script=bhaiksuki}', "");
    Expect(1, 72813, '\P{Is_Script=bhaiksuki}', "");
    Expect(0, 72813, '\P{^Is_Script=bhaiksuki}', "");
    Expect(1, 72812, '\p{Is_Script= 	Bhaiksuki}', "");
    Expect(0, 72812, '\p{^Is_Script= 	Bhaiksuki}', "");
    Expect(0, 72812, '\P{Is_Script= 	Bhaiksuki}', "");
    Expect(1, 72812, '\P{^Is_Script= 	Bhaiksuki}', "");
    Expect(0, 72813, '\p{Is_Script= 	Bhaiksuki}', "");
    Expect(1, 72813, '\p{^Is_Script= 	Bhaiksuki}', "");
    Expect(1, 72813, '\P{Is_Script= 	Bhaiksuki}', "");
    Expect(0, 72813, '\P{^Is_Script= 	Bhaiksuki}', "");
    Error('\p{Is_Sc=/a/	bhks}');
    Error('\P{Is_Sc=/a/	bhks}');
    Expect(1, 72812, '\p{Is_Sc=bhks}', "");
    Expect(0, 72812, '\p{^Is_Sc=bhks}', "");
    Expect(0, 72812, '\P{Is_Sc=bhks}', "");
    Expect(1, 72812, '\P{^Is_Sc=bhks}', "");
    Expect(0, 72813, '\p{Is_Sc=bhks}', "");
    Expect(1, 72813, '\p{^Is_Sc=bhks}', "");
    Expect(1, 72813, '\P{Is_Sc=bhks}', "");
    Expect(0, 72813, '\P{^Is_Sc=bhks}', "");
    Expect(1, 72812, '\p{Is_Sc= Bhks}', "");
    Expect(0, 72812, '\p{^Is_Sc= Bhks}', "");
    Expect(0, 72812, '\P{Is_Sc= Bhks}', "");
    Expect(1, 72812, '\P{^Is_Sc= Bhks}', "");
    Expect(0, 72813, '\p{Is_Sc= Bhks}', "");
    Expect(1, 72813, '\p{^Is_Sc= Bhks}', "");
    Expect(1, 72813, '\P{Is_Sc= Bhks}', "");
    Expect(0, 72813, '\P{^Is_Sc= Bhks}', "");
    Error('\p{Script=:=_	Bopomofo}');
    Error('\P{Script=:=_	Bopomofo}');
    Expect(1, 12730, '\p{Script=bopomofo}', "");
    Expect(0, 12730, '\p{^Script=bopomofo}', "");
    Expect(0, 12730, '\P{Script=bopomofo}', "");
    Expect(1, 12730, '\P{^Script=bopomofo}', "");
    Expect(0, 12731, '\p{Script=bopomofo}', "");
    Expect(1, 12731, '\p{^Script=bopomofo}', "");
    Expect(1, 12731, '\P{Script=bopomofo}', "");
    Expect(0, 12731, '\P{^Script=bopomofo}', "");
    Expect(1, 12730, '\p{Script=_	Bopomofo}', "");
    Expect(0, 12730, '\p{^Script=_	Bopomofo}', "");
    Expect(0, 12730, '\P{Script=_	Bopomofo}', "");
    Expect(1, 12730, '\P{^Script=_	Bopomofo}', "");
    Expect(0, 12731, '\p{Script=_	Bopomofo}', "");
    Expect(1, 12731, '\p{^Script=_	Bopomofo}', "");
    Expect(1, 12731, '\P{Script=_	Bopomofo}', "");
    Expect(0, 12731, '\P{^Script=_	Bopomofo}', "");
    Error('\p{Sc=/a/- Bopo}');
    Error('\P{Sc=/a/- Bopo}');
    Expect(1, 12730, '\p{Sc=bopo}', "");
    Expect(0, 12730, '\p{^Sc=bopo}', "");
    Expect(0, 12730, '\P{Sc=bopo}', "");
    Expect(1, 12730, '\P{^Sc=bopo}', "");
    Expect(0, 12731, '\p{Sc=bopo}', "");
    Expect(1, 12731, '\p{^Sc=bopo}', "");
    Expect(1, 12731, '\P{Sc=bopo}', "");
    Expect(0, 12731, '\P{^Sc=bopo}', "");
    Expect(1, 12730, '\p{Sc=-	BOPO}', "");
    Expect(0, 12730, '\p{^Sc=-	BOPO}', "");
    Expect(0, 12730, '\P{Sc=-	BOPO}', "");
    Expect(1, 12730, '\P{^Sc=-	BOPO}', "");
    Expect(0, 12731, '\p{Sc=-	BOPO}', "");
    Expect(1, 12731, '\p{^Sc=-	BOPO}', "");
    Expect(1, 12731, '\P{Sc=-	BOPO}', "");
    Expect(0, 12731, '\P{^Sc=-	BOPO}', "");
    Error('\p{Is_Script=	/a/bopomofo}');
    Error('\P{Is_Script=	/a/bopomofo}');
    Expect(1, 12730, '\p{Is_Script=bopomofo}', "");
    Expect(0, 12730, '\p{^Is_Script=bopomofo}', "");
    Expect(0, 12730, '\P{Is_Script=bopomofo}', "");
    Expect(1, 12730, '\P{^Is_Script=bopomofo}', "");
    Expect(0, 12731, '\p{Is_Script=bopomofo}', "");
    Expect(1, 12731, '\p{^Is_Script=bopomofo}', "");
    Expect(1, 12731, '\P{Is_Script=bopomofo}', "");
    Expect(0, 12731, '\P{^Is_Script=bopomofo}', "");
    Expect(1, 12730, '\p{Is_Script=--BOPOMOFO}', "");
    Expect(0, 12730, '\p{^Is_Script=--BOPOMOFO}', "");
    Expect(0, 12730, '\P{Is_Script=--BOPOMOFO}', "");
    Expect(1, 12730, '\P{^Is_Script=--BOPOMOFO}', "");
    Expect(0, 12731, '\p{Is_Script=--BOPOMOFO}', "");
    Expect(1, 12731, '\p{^Is_Script=--BOPOMOFO}', "");
    Expect(1, 12731, '\P{Is_Script=--BOPOMOFO}', "");
    Expect(0, 12731, '\P{^Is_Script=--BOPOMOFO}', "");
    Error('\p{Is_Sc=:=		BOPO}');
    Error('\P{Is_Sc=:=		BOPO}');
    Expect(1, 12730, '\p{Is_Sc=bopo}', "");
    Expect(0, 12730, '\p{^Is_Sc=bopo}', "");
    Expect(0, 12730, '\P{Is_Sc=bopo}', "");
    Expect(1, 12730, '\P{^Is_Sc=bopo}', "");
    Expect(0, 12731, '\p{Is_Sc=bopo}', "");
    Expect(1, 12731, '\p{^Is_Sc=bopo}', "");
    Expect(1, 12731, '\P{Is_Sc=bopo}', "");
    Expect(0, 12731, '\P{^Is_Sc=bopo}', "");
    Expect(1, 12730, '\p{Is_Sc=	Bopo}', "");
    Expect(0, 12730, '\p{^Is_Sc=	Bopo}', "");
    Expect(0, 12730, '\P{Is_Sc=	Bopo}', "");
    Expect(1, 12730, '\P{^Is_Sc=	Bopo}', "");
    Expect(0, 12731, '\p{Is_Sc=	Bopo}', "");
    Expect(1, 12731, '\p{^Is_Sc=	Bopo}', "");
    Expect(1, 12731, '\P{Is_Sc=	Bopo}', "");
    Expect(0, 12731, '\P{^Is_Sc=	Bopo}', "");
    Error('\p{Script:   /a/ 	brahmi}');
    Error('\P{Script:   /a/ 	brahmi}');
    Expect(1, 69759, '\p{Script=brahmi}', "");
    Expect(0, 69759, '\p{^Script=brahmi}', "");
    Expect(0, 69759, '\P{Script=brahmi}', "");
    Expect(1, 69759, '\P{^Script=brahmi}', "");
    Expect(0, 69760, '\p{Script=brahmi}', "");
    Expect(1, 69760, '\p{^Script=brahmi}', "");
    Expect(1, 69760, '\P{Script=brahmi}', "");
    Expect(0, 69760, '\P{^Script=brahmi}', "");
    Expect(1, 69759, '\p{Script=	-brahmi}', "");
    Expect(0, 69759, '\p{^Script=	-brahmi}', "");
    Expect(0, 69759, '\P{Script=	-brahmi}', "");
    Expect(1, 69759, '\P{^Script=	-brahmi}', "");
    Expect(0, 69760, '\p{Script=	-brahmi}', "");
    Expect(1, 69760, '\p{^Script=	-brahmi}', "");
    Expect(1, 69760, '\P{Script=	-brahmi}', "");
    Expect(0, 69760, '\P{^Script=	-brahmi}', "");
    Error('\p{Sc=_-brah/a/}');
    Error('\P{Sc=_-brah/a/}');
    Expect(1, 69759, '\p{Sc=brah}', "");
    Expect(0, 69759, '\p{^Sc=brah}', "");
    Expect(0, 69759, '\P{Sc=brah}', "");
    Expect(1, 69759, '\P{^Sc=brah}', "");
    Expect(0, 69760, '\p{Sc=brah}', "");
    Expect(1, 69760, '\p{^Sc=brah}', "");
    Expect(1, 69760, '\P{Sc=brah}', "");
    Expect(0, 69760, '\P{^Sc=brah}', "");
    Expect(1, 69759, '\p{Sc=	 brah}', "");
    Expect(0, 69759, '\p{^Sc=	 brah}', "");
    Expect(0, 69759, '\P{Sc=	 brah}', "");
    Expect(1, 69759, '\P{^Sc=	 brah}', "");
    Expect(0, 69760, '\p{Sc=	 brah}', "");
    Expect(1, 69760, '\p{^Sc=	 brah}', "");
    Expect(1, 69760, '\P{Sc=	 brah}', "");
    Expect(0, 69760, '\P{^Sc=	 brah}', "");
    Error('\p{Is_Script:		Brahmi:=}');
    Error('\P{Is_Script:		Brahmi:=}');
    Expect(1, 69759, '\p{Is_Script=brahmi}', "");
    Expect(0, 69759, '\p{^Is_Script=brahmi}', "");
    Expect(0, 69759, '\P{Is_Script=brahmi}', "");
    Expect(1, 69759, '\P{^Is_Script=brahmi}', "");
    Expect(0, 69760, '\p{Is_Script=brahmi}', "");
    Expect(1, 69760, '\p{^Is_Script=brahmi}', "");
    Expect(1, 69760, '\P{Is_Script=brahmi}', "");
    Expect(0, 69760, '\P{^Is_Script=brahmi}', "");
    Expect(1, 69759, '\p{Is_Script=-_Brahmi}', "");
    Expect(0, 69759, '\p{^Is_Script=-_Brahmi}', "");
    Expect(0, 69759, '\P{Is_Script=-_Brahmi}', "");
    Expect(1, 69759, '\P{^Is_Script=-_Brahmi}', "");
    Expect(0, 69760, '\p{Is_Script=-_Brahmi}', "");
    Expect(1, 69760, '\p{^Is_Script=-_Brahmi}', "");
    Expect(1, 69760, '\P{Is_Script=-_Brahmi}', "");
    Expect(0, 69760, '\P{^Is_Script=-_Brahmi}', "");
    Error('\p{Is_Sc=/a/__Brah}');
    Error('\P{Is_Sc=/a/__Brah}');
    Expect(1, 69759, '\p{Is_Sc=brah}', "");
    Expect(0, 69759, '\p{^Is_Sc=brah}', "");
    Expect(0, 69759, '\P{Is_Sc=brah}', "");
    Expect(1, 69759, '\P{^Is_Sc=brah}', "");
    Expect(0, 69760, '\p{Is_Sc=brah}', "");
    Expect(1, 69760, '\p{^Is_Sc=brah}', "");
    Expect(1, 69760, '\P{Is_Sc=brah}', "");
    Expect(0, 69760, '\P{^Is_Sc=brah}', "");
    Expect(1, 69759, '\p{Is_Sc=-Brah}', "");
    Expect(0, 69759, '\p{^Is_Sc=-Brah}', "");
    Expect(0, 69759, '\P{Is_Sc=-Brah}', "");
    Expect(1, 69759, '\P{^Is_Sc=-Brah}', "");
    Expect(0, 69760, '\p{Is_Sc=-Brah}', "");
    Expect(1, 69760, '\p{^Is_Sc=-Brah}', "");
    Expect(1, 69760, '\P{Is_Sc=-Brah}', "");
    Expect(0, 69760, '\P{^Is_Sc=-Brah}', "");
    Error('\p{Script=-	Braille/a/}');
    Error('\P{Script=-	Braille/a/}');
    Expect(1, 10495, '\p{Script=braille}', "");
    Expect(0, 10495, '\p{^Script=braille}', "");
    Expect(0, 10495, '\P{Script=braille}', "");
    Expect(1, 10495, '\P{^Script=braille}', "");
    Expect(0, 10496, '\p{Script=braille}', "");
    Expect(1, 10496, '\p{^Script=braille}', "");
    Expect(1, 10496, '\P{Script=braille}', "");
    Expect(0, 10496, '\P{^Script=braille}', "");
    Expect(1, 10495, '\p{Script=	 Braille}', "");
    Expect(0, 10495, '\p{^Script=	 Braille}', "");
    Expect(0, 10495, '\P{Script=	 Braille}', "");
    Expect(1, 10495, '\P{^Script=	 Braille}', "");
    Expect(0, 10496, '\p{Script=	 Braille}', "");
    Expect(1, 10496, '\p{^Script=	 Braille}', "");
    Expect(1, 10496, '\P{Script=	 Braille}', "");
    Expect(0, 10496, '\P{^Script=	 Braille}', "");
    Error('\p{Sc=:=	_Brai}');
    Error('\P{Sc=:=	_Brai}');
    Expect(1, 10495, '\p{Sc=brai}', "");
    Expect(0, 10495, '\p{^Sc=brai}', "");
    Expect(0, 10495, '\P{Sc=brai}', "");
    Expect(1, 10495, '\P{^Sc=brai}', "");
    Expect(0, 10496, '\p{Sc=brai}', "");
    Expect(1, 10496, '\p{^Sc=brai}', "");
    Expect(1, 10496, '\P{Sc=brai}', "");
    Expect(0, 10496, '\P{^Sc=brai}', "");
    Expect(1, 10495, '\p{Sc=- brai}', "");
    Expect(0, 10495, '\p{^Sc=- brai}', "");
    Expect(0, 10495, '\P{Sc=- brai}', "");
    Expect(1, 10495, '\P{^Sc=- brai}', "");
    Expect(0, 10496, '\p{Sc=- brai}', "");
    Expect(1, 10496, '\p{^Sc=- brai}', "");
    Expect(1, 10496, '\P{Sc=- brai}', "");
    Expect(0, 10496, '\P{^Sc=- brai}', "");
    Error('\p{Is_Script=/a/__Braille}');
    Error('\P{Is_Script=/a/__Braille}');
    Expect(1, 10495, '\p{Is_Script=braille}', "");
    Expect(0, 10495, '\p{^Is_Script=braille}', "");
    Expect(0, 10495, '\P{Is_Script=braille}', "");
    Expect(1, 10495, '\P{^Is_Script=braille}', "");
    Expect(0, 10496, '\p{Is_Script=braille}', "");
    Expect(1, 10496, '\p{^Is_Script=braille}', "");
    Expect(1, 10496, '\P{Is_Script=braille}', "");
    Expect(0, 10496, '\P{^Is_Script=braille}', "");
    Expect(1, 10495, '\p{Is_Script=		Braille}', "");
    Expect(0, 10495, '\p{^Is_Script=		Braille}', "");
    Expect(0, 10495, '\P{Is_Script=		Braille}', "");
    Expect(1, 10495, '\P{^Is_Script=		Braille}', "");
    Expect(0, 10496, '\p{Is_Script=		Braille}', "");
    Expect(1, 10496, '\p{^Is_Script=		Braille}', "");
    Expect(1, 10496, '\P{Is_Script=		Braille}', "");
    Expect(0, 10496, '\P{^Is_Script=		Braille}', "");
    Error('\p{Is_Sc=brai/a/}');
    Error('\P{Is_Sc=brai/a/}');
    Expect(1, 10495, '\p{Is_Sc=brai}', "");
    Expect(0, 10495, '\p{^Is_Sc=brai}', "");
    Expect(0, 10495, '\P{Is_Sc=brai}', "");
    Expect(1, 10495, '\P{^Is_Sc=brai}', "");
    Expect(0, 10496, '\p{Is_Sc=brai}', "");
    Expect(1, 10496, '\p{^Is_Sc=brai}', "");
    Expect(1, 10496, '\P{Is_Sc=brai}', "");
    Expect(0, 10496, '\P{^Is_Sc=brai}', "");
    Expect(1, 10495, '\p{Is_Sc=	_Brai}', "");
    Expect(0, 10495, '\p{^Is_Sc=	_Brai}', "");
    Expect(0, 10495, '\P{Is_Sc=	_Brai}', "");
    Expect(1, 10495, '\P{^Is_Sc=	_Brai}', "");
    Expect(0, 10496, '\p{Is_Sc=	_Brai}', "");
    Expect(1, 10496, '\p{^Is_Sc=	_Brai}', "");
    Expect(1, 10496, '\P{Is_Sc=	_Brai}', "");
    Expect(0, 10496, '\P{^Is_Sc=	_Brai}', "");
    Error('\p{Script= :=BUGINESE}');
    Error('\P{Script= :=BUGINESE}');
    Expect(1, 6687, '\p{Script=buginese}', "");
    Expect(0, 6687, '\p{^Script=buginese}', "");
    Expect(0, 6687, '\P{Script=buginese}', "");
    Expect(1, 6687, '\P{^Script=buginese}', "");
    Expect(0, 6688, '\p{Script=buginese}', "");
    Expect(1, 6688, '\p{^Script=buginese}', "");
    Expect(1, 6688, '\P{Script=buginese}', "");
    Expect(0, 6688, '\P{^Script=buginese}', "");
    Expect(1, 6687, '\p{Script= BUGINESE}', "");
    Expect(0, 6687, '\p{^Script= BUGINESE}', "");
    Expect(0, 6687, '\P{Script= BUGINESE}', "");
    Expect(1, 6687, '\P{^Script= BUGINESE}', "");
    Expect(0, 6688, '\p{Script= BUGINESE}', "");
    Expect(1, 6688, '\p{^Script= BUGINESE}', "");
    Expect(1, 6688, '\P{Script= BUGINESE}', "");
    Expect(0, 6688, '\P{^Script= BUGINESE}', "");
    Error('\p{Sc=:=	Bugi}');
    Error('\P{Sc=:=	Bugi}');
    Expect(1, 6687, '\p{Sc=bugi}', "");
    Expect(0, 6687, '\p{^Sc=bugi}', "");
    Expect(0, 6687, '\P{Sc=bugi}', "");
    Expect(1, 6687, '\P{^Sc=bugi}', "");
    Expect(0, 6688, '\p{Sc=bugi}', "");
    Expect(1, 6688, '\p{^Sc=bugi}', "");
    Expect(1, 6688, '\P{Sc=bugi}', "");
    Expect(0, 6688, '\P{^Sc=bugi}', "");
    Expect(1, 6687, '\p{Sc=_-Bugi}', "");
    Expect(0, 6687, '\p{^Sc=_-Bugi}', "");
    Expect(0, 6687, '\P{Sc=_-Bugi}', "");
    Expect(1, 6687, '\P{^Sc=_-Bugi}', "");
    Expect(0, 6688, '\p{Sc=_-Bugi}', "");
    Expect(1, 6688, '\p{^Sc=_-Bugi}', "");
    Expect(1, 6688, '\P{Sc=_-Bugi}', "");
    Expect(0, 6688, '\P{^Sc=_-Bugi}', "");
    Error('\p{Is_Script=__buginese:=}');
    Error('\P{Is_Script=__buginese:=}');
    Expect(1, 6687, '\p{Is_Script=buginese}', "");
    Expect(0, 6687, '\p{^Is_Script=buginese}', "");
    Expect(0, 6687, '\P{Is_Script=buginese}', "");
    Expect(1, 6687, '\P{^Is_Script=buginese}', "");
    Expect(0, 6688, '\p{Is_Script=buginese}', "");
    Expect(1, 6688, '\p{^Is_Script=buginese}', "");
    Expect(1, 6688, '\P{Is_Script=buginese}', "");
    Expect(0, 6688, '\P{^Is_Script=buginese}', "");
    Expect(1, 6687, '\p{Is_Script=-	Buginese}', "");
    Expect(0, 6687, '\p{^Is_Script=-	Buginese}', "");
    Expect(0, 6687, '\P{Is_Script=-	Buginese}', "");
    Expect(1, 6687, '\P{^Is_Script=-	Buginese}', "");
    Expect(0, 6688, '\p{Is_Script=-	Buginese}', "");
    Expect(1, 6688, '\p{^Is_Script=-	Buginese}', "");
    Expect(1, 6688, '\P{Is_Script=-	Buginese}', "");
    Expect(0, 6688, '\P{^Is_Script=-	Buginese}', "");
    Error('\p{Is_Sc=	:=Bugi}');
    Error('\P{Is_Sc=	:=Bugi}');
    Expect(1, 6687, '\p{Is_Sc=bugi}', "");
    Expect(0, 6687, '\p{^Is_Sc=bugi}', "");
    Expect(0, 6687, '\P{Is_Sc=bugi}', "");
    Expect(1, 6687, '\P{^Is_Sc=bugi}', "");
    Expect(0, 6688, '\p{Is_Sc=bugi}', "");
    Expect(1, 6688, '\p{^Is_Sc=bugi}', "");
    Expect(1, 6688, '\P{Is_Sc=bugi}', "");
    Expect(0, 6688, '\P{^Is_Sc=bugi}', "");
    Expect(1, 6687, '\p{Is_Sc= Bugi}', "");
    Expect(0, 6687, '\p{^Is_Sc= Bugi}', "");
    Expect(0, 6687, '\P{Is_Sc= Bugi}', "");
    Expect(1, 6687, '\P{^Is_Sc= Bugi}', "");
    Expect(0, 6688, '\p{Is_Sc= Bugi}', "");
    Expect(1, 6688, '\p{^Is_Sc= Bugi}', "");
    Expect(1, 6688, '\P{Is_Sc= Bugi}', "");
    Expect(0, 6688, '\P{^Is_Sc= Bugi}', "");
    Error('\p{Script=/a/-BUHID}');
    Error('\P{Script=/a/-BUHID}');
    Expect(1, 5971, '\p{Script=buhid}', "");
    Expect(0, 5971, '\p{^Script=buhid}', "");
    Expect(0, 5971, '\P{Script=buhid}', "");
    Expect(1, 5971, '\P{^Script=buhid}', "");
    Expect(0, 5972, '\p{Script=buhid}', "");
    Expect(1, 5972, '\p{^Script=buhid}', "");
    Expect(1, 5972, '\P{Script=buhid}', "");
    Expect(0, 5972, '\P{^Script=buhid}', "");
    Expect(1, 5971, '\p{Script=	 BUHID}', "");
    Expect(0, 5971, '\p{^Script=	 BUHID}', "");
    Expect(0, 5971, '\P{Script=	 BUHID}', "");
    Expect(1, 5971, '\P{^Script=	 BUHID}', "");
    Expect(0, 5972, '\p{Script=	 BUHID}', "");
    Expect(1, 5972, '\p{^Script=	 BUHID}', "");
    Expect(1, 5972, '\P{Script=	 BUHID}', "");
    Expect(0, 5972, '\P{^Script=	 BUHID}', "");
    Error('\p{Sc=_	BUHD:=}');
    Error('\P{Sc=_	BUHD:=}');
    Expect(1, 5971, '\p{Sc: buhd}', "");
    Expect(0, 5971, '\p{^Sc: buhd}', "");
    Expect(0, 5971, '\P{Sc: buhd}', "");
    Expect(1, 5971, '\P{^Sc: buhd}', "");
    Expect(0, 5972, '\p{Sc: buhd}', "");
    Expect(1, 5972, '\p{^Sc: buhd}', "");
    Expect(1, 5972, '\P{Sc: buhd}', "");
    Expect(0, 5972, '\P{^Sc: buhd}', "");
    Expect(1, 5971, '\p{Sc=-_buhd}', "");
    Expect(0, 5971, '\p{^Sc=-_buhd}', "");
    Expect(0, 5971, '\P{Sc=-_buhd}', "");
    Expect(1, 5971, '\P{^Sc=-_buhd}', "");
    Expect(0, 5972, '\p{Sc=-_buhd}', "");
    Expect(1, 5972, '\p{^Sc=-_buhd}', "");
    Expect(1, 5972, '\P{Sc=-_buhd}', "");
    Expect(0, 5972, '\P{^Sc=-_buhd}', "");
    Error('\p{Is_Script=/a/buhid}');
    Error('\P{Is_Script=/a/buhid}');
    Expect(1, 5971, '\p{Is_Script=buhid}', "");
    Expect(0, 5971, '\p{^Is_Script=buhid}', "");
    Expect(0, 5971, '\P{Is_Script=buhid}', "");
    Expect(1, 5971, '\P{^Is_Script=buhid}', "");
    Expect(0, 5972, '\p{Is_Script=buhid}', "");
    Expect(1, 5972, '\p{^Is_Script=buhid}', "");
    Expect(1, 5972, '\P{Is_Script=buhid}', "");
    Expect(0, 5972, '\P{^Is_Script=buhid}', "");
    Expect(1, 5971, '\p{Is_Script=-_Buhid}', "");
    Expect(0, 5971, '\p{^Is_Script=-_Buhid}', "");
    Expect(0, 5971, '\P{Is_Script=-_Buhid}', "");
    Expect(1, 5971, '\P{^Is_Script=-_Buhid}', "");
    Expect(0, 5972, '\p{Is_Script=-_Buhid}', "");
    Expect(1, 5972, '\p{^Is_Script=-_Buhid}', "");
    Expect(1, 5972, '\P{Is_Script=-_Buhid}', "");
    Expect(0, 5972, '\P{^Is_Script=-_Buhid}', "");
    Error('\p{Is_Sc=/a/-	Buhd}');
    Error('\P{Is_Sc=/a/-	Buhd}');
    Expect(1, 5971, '\p{Is_Sc:buhd}', "");
    Expect(0, 5971, '\p{^Is_Sc:buhd}', "");
    Expect(0, 5971, '\P{Is_Sc:buhd}', "");
    Expect(1, 5971, '\P{^Is_Sc:buhd}', "");
    Expect(0, 5972, '\p{Is_Sc:buhd}', "");
    Expect(1, 5972, '\p{^Is_Sc:buhd}', "");
    Expect(1, 5972, '\P{Is_Sc:buhd}', "");
    Expect(0, 5972, '\P{^Is_Sc:buhd}', "");
    Expect(1, 5971, '\p{Is_Sc=  BUHD}', "");
    Expect(0, 5971, '\p{^Is_Sc=  BUHD}', "");
    Expect(0, 5971, '\P{Is_Sc=  BUHD}', "");
    Expect(1, 5971, '\P{^Is_Sc=  BUHD}', "");
    Expect(0, 5972, '\p{Is_Sc=  BUHD}', "");
    Expect(1, 5972, '\p{^Is_Sc=  BUHD}', "");
    Expect(1, 5972, '\P{Is_Sc=  BUHD}', "");
    Expect(0, 5972, '\P{^Is_Sc=  BUHD}', "");
    Error('\p{Script=:=-_Chakma}');
    Error('\P{Script=:=-_Chakma}');
    Expect(1, 69955, '\p{Script=chakma}', "");
    Expect(0, 69955, '\p{^Script=chakma}', "");
    Expect(0, 69955, '\P{Script=chakma}', "");
    Expect(1, 69955, '\P{^Script=chakma}', "");
    Expect(0, 69956, '\p{Script=chakma}', "");
    Expect(1, 69956, '\p{^Script=chakma}', "");
    Expect(1, 69956, '\P{Script=chakma}', "");
    Expect(0, 69956, '\P{^Script=chakma}', "");
    Expect(1, 69955, '\p{Script=-chakma}', "");
    Expect(0, 69955, '\p{^Script=-chakma}', "");
    Expect(0, 69955, '\P{Script=-chakma}', "");
    Expect(1, 69955, '\P{^Script=-chakma}', "");
    Expect(0, 69956, '\p{Script=-chakma}', "");
    Expect(1, 69956, '\p{^Script=-chakma}', "");
    Expect(1, 69956, '\P{Script=-chakma}', "");
    Expect(0, 69956, '\P{^Script=-chakma}', "");
    Error('\p{Sc= -cakm/a/}');
    Error('\P{Sc= -cakm/a/}');
    Expect(1, 69955, '\p{Sc=cakm}', "");
    Expect(0, 69955, '\p{^Sc=cakm}', "");
    Expect(0, 69955, '\P{Sc=cakm}', "");
    Expect(1, 69955, '\P{^Sc=cakm}', "");
    Expect(0, 69956, '\p{Sc=cakm}', "");
    Expect(1, 69956, '\p{^Sc=cakm}', "");
    Expect(1, 69956, '\P{Sc=cakm}', "");
    Expect(0, 69956, '\P{^Sc=cakm}', "");
    Expect(1, 69955, '\p{Sc:    -CAKM}', "");
    Expect(0, 69955, '\p{^Sc:    -CAKM}', "");
    Expect(0, 69955, '\P{Sc:    -CAKM}', "");
    Expect(1, 69955, '\P{^Sc:    -CAKM}', "");
    Expect(0, 69956, '\p{Sc:    -CAKM}', "");
    Expect(1, 69956, '\p{^Sc:    -CAKM}', "");
    Expect(1, 69956, '\P{Sc:    -CAKM}', "");
    Expect(0, 69956, '\P{^Sc:    -CAKM}', "");
    Error('\p{Is_Script= /a/Chakma}');
    Error('\P{Is_Script= /a/Chakma}');
    Expect(1, 69955, '\p{Is_Script=chakma}', "");
    Expect(0, 69955, '\p{^Is_Script=chakma}', "");
    Expect(0, 69955, '\P{Is_Script=chakma}', "");
    Expect(1, 69955, '\P{^Is_Script=chakma}', "");
    Expect(0, 69956, '\p{Is_Script=chakma}', "");
    Expect(1, 69956, '\p{^Is_Script=chakma}', "");
    Expect(1, 69956, '\P{Is_Script=chakma}', "");
    Expect(0, 69956, '\P{^Is_Script=chakma}', "");
    Expect(1, 69955, '\p{Is_Script=		CHAKMA}', "");
    Expect(0, 69955, '\p{^Is_Script=		CHAKMA}', "");
    Expect(0, 69955, '\P{Is_Script=		CHAKMA}', "");
    Expect(1, 69955, '\P{^Is_Script=		CHAKMA}', "");
    Expect(0, 69956, '\p{Is_Script=		CHAKMA}', "");
    Expect(1, 69956, '\p{^Is_Script=		CHAKMA}', "");
    Expect(1, 69956, '\P{Is_Script=		CHAKMA}', "");
    Expect(0, 69956, '\P{^Is_Script=		CHAKMA}', "");
    Error('\p{Is_Sc=/a/-	cakm}');
    Error('\P{Is_Sc=/a/-	cakm}');
    Expect(1, 69955, '\p{Is_Sc=cakm}', "");
    Expect(0, 69955, '\p{^Is_Sc=cakm}', "");
    Expect(0, 69955, '\P{Is_Sc=cakm}', "");
    Expect(1, 69955, '\P{^Is_Sc=cakm}', "");
    Expect(0, 69956, '\p{Is_Sc=cakm}', "");
    Expect(1, 69956, '\p{^Is_Sc=cakm}', "");
    Expect(1, 69956, '\P{Is_Sc=cakm}', "");
    Expect(0, 69956, '\P{^Is_Sc=cakm}', "");
    Expect(1, 69955, '\p{Is_Sc=	Cakm}', "");
    Expect(0, 69955, '\p{^Is_Sc=	Cakm}', "");
    Expect(0, 69955, '\P{Is_Sc=	Cakm}', "");
    Expect(1, 69955, '\P{^Is_Sc=	Cakm}', "");
    Expect(0, 69956, '\p{Is_Sc=	Cakm}', "");
    Expect(1, 69956, '\p{^Is_Sc=	Cakm}', "");
    Expect(1, 69956, '\P{Is_Sc=	Cakm}', "");
    Expect(0, 69956, '\P{^Is_Sc=	Cakm}', "");
    Error('\p{Script=	 CANADIAN_ABORIGINAL:=}');
    Error('\P{Script=	 CANADIAN_ABORIGINAL:=}');
    Expect(1, 6389, '\p{Script=canadianaboriginal}', "");
    Expect(0, 6389, '\p{^Script=canadianaboriginal}', "");
    Expect(0, 6389, '\P{Script=canadianaboriginal}', "");
    Expect(1, 6389, '\P{^Script=canadianaboriginal}', "");
    Expect(0, 6390, '\p{Script=canadianaboriginal}', "");
    Expect(1, 6390, '\p{^Script=canadianaboriginal}', "");
    Expect(1, 6390, '\P{Script=canadianaboriginal}', "");
    Expect(0, 6390, '\P{^Script=canadianaboriginal}', "");
    Expect(1, 6389, '\p{Script= _canadian_ABORIGINAL}', "");
    Expect(0, 6389, '\p{^Script= _canadian_ABORIGINAL}', "");
    Expect(0, 6389, '\P{Script= _canadian_ABORIGINAL}', "");
    Expect(1, 6389, '\P{^Script= _canadian_ABORIGINAL}', "");
    Expect(0, 6390, '\p{Script= _canadian_ABORIGINAL}', "");
    Expect(1, 6390, '\p{^Script= _canadian_ABORIGINAL}', "");
    Expect(1, 6390, '\P{Script= _canadian_ABORIGINAL}', "");
    Expect(0, 6390, '\P{^Script= _canadian_ABORIGINAL}', "");
    Error('\p{Sc=- Cans/a/}');
    Error('\P{Sc=- Cans/a/}');
    Expect(1, 6389, '\p{Sc=cans}', "");
    Expect(0, 6389, '\p{^Sc=cans}', "");
    Expect(0, 6389, '\P{Sc=cans}', "");
    Expect(1, 6389, '\P{^Sc=cans}', "");
    Expect(0, 6390, '\p{Sc=cans}', "");
    Expect(1, 6390, '\p{^Sc=cans}', "");
    Expect(1, 6390, '\P{Sc=cans}', "");
    Expect(0, 6390, '\P{^Sc=cans}', "");
    Expect(1, 6389, '\p{Sc=	cans}', "");
    Expect(0, 6389, '\p{^Sc=	cans}', "");
    Expect(0, 6389, '\P{Sc=	cans}', "");
    Expect(1, 6389, '\P{^Sc=	cans}', "");
    Expect(0, 6390, '\p{Sc=	cans}', "");
    Expect(1, 6390, '\p{^Sc=	cans}', "");
    Expect(1, 6390, '\P{Sc=	cans}', "");
    Expect(0, 6390, '\P{^Sc=	cans}', "");
    Error('\p{Is_Script=-	Canadian_ABORIGINAL:=}');
    Error('\P{Is_Script=-	Canadian_ABORIGINAL:=}');
    Expect(1, 6389, '\p{Is_Script=canadianaboriginal}', "");
    Expect(0, 6389, '\p{^Is_Script=canadianaboriginal}', "");
    Expect(0, 6389, '\P{Is_Script=canadianaboriginal}', "");
    Expect(1, 6389, '\P{^Is_Script=canadianaboriginal}', "");
    Expect(0, 6390, '\p{Is_Script=canadianaboriginal}', "");
    Expect(1, 6390, '\p{^Is_Script=canadianaboriginal}', "");
    Expect(1, 6390, '\P{Is_Script=canadianaboriginal}', "");
    Expect(0, 6390, '\P{^Is_Script=canadianaboriginal}', "");
    Expect(1, 6389, '\p{Is_Script: 	-CANADIAN_Aboriginal}', "");
    Expect(0, 6389, '\p{^Is_Script: 	-CANADIAN_Aboriginal}', "");
    Expect(0, 6389, '\P{Is_Script: 	-CANADIAN_Aboriginal}', "");
    Expect(1, 6389, '\P{^Is_Script: 	-CANADIAN_Aboriginal}', "");
    Expect(0, 6390, '\p{Is_Script: 	-CANADIAN_Aboriginal}', "");
    Expect(1, 6390, '\p{^Is_Script: 	-CANADIAN_Aboriginal}', "");
    Expect(1, 6390, '\P{Is_Script: 	-CANADIAN_Aboriginal}', "");
    Expect(0, 6390, '\P{^Is_Script: 	-CANADIAN_Aboriginal}', "");
    Error('\p{Is_Sc=-_CANS:=}');
    Error('\P{Is_Sc=-_CANS:=}');
    Expect(1, 6389, '\p{Is_Sc=cans}', "");
    Expect(0, 6389, '\p{^Is_Sc=cans}', "");
    Expect(0, 6389, '\P{Is_Sc=cans}', "");
    Expect(1, 6389, '\P{^Is_Sc=cans}', "");
    Expect(0, 6390, '\p{Is_Sc=cans}', "");
    Expect(1, 6390, '\p{^Is_Sc=cans}', "");
    Expect(1, 6390, '\P{Is_Sc=cans}', "");
    Expect(0, 6390, '\P{^Is_Sc=cans}', "");
    Expect(1, 6389, '\p{Is_Sc: -_cans}', "");
    Expect(0, 6389, '\p{^Is_Sc: -_cans}', "");
    Expect(0, 6389, '\P{Is_Sc: -_cans}', "");
    Expect(1, 6389, '\P{^Is_Sc: -_cans}', "");
    Expect(0, 6390, '\p{Is_Sc: -_cans}', "");
    Expect(1, 6390, '\p{^Is_Sc: -_cans}', "");
    Expect(1, 6390, '\P{Is_Sc: -_cans}', "");
    Expect(0, 6390, '\P{^Is_Sc: -_cans}', "");
    Error('\p{Script=		CARIAN:=}');
    Error('\P{Script=		CARIAN:=}');
    Expect(1, 66256, '\p{Script=carian}', "");
    Expect(0, 66256, '\p{^Script=carian}', "");
    Expect(0, 66256, '\P{Script=carian}', "");
    Expect(1, 66256, '\P{^Script=carian}', "");
    Expect(0, 66257, '\p{Script=carian}', "");
    Expect(1, 66257, '\p{^Script=carian}', "");
    Expect(1, 66257, '\P{Script=carian}', "");
    Expect(0, 66257, '\P{^Script=carian}', "");
    Expect(1, 66256, '\p{Script= carian}', "");
    Expect(0, 66256, '\p{^Script= carian}', "");
    Expect(0, 66256, '\P{Script= carian}', "");
    Expect(1, 66256, '\P{^Script= carian}', "");
    Expect(0, 66257, '\p{Script= carian}', "");
    Expect(1, 66257, '\p{^Script= carian}', "");
    Expect(1, 66257, '\P{Script= carian}', "");
    Expect(0, 66257, '\P{^Script= carian}', "");
    Error('\p{Sc=	:=Cari}');
    Error('\P{Sc=	:=Cari}');
    Expect(1, 66256, '\p{Sc:   cari}', "");
    Expect(0, 66256, '\p{^Sc:   cari}', "");
    Expect(0, 66256, '\P{Sc:   cari}', "");
    Expect(1, 66256, '\P{^Sc:   cari}', "");
    Expect(0, 66257, '\p{Sc:   cari}', "");
    Expect(1, 66257, '\p{^Sc:   cari}', "");
    Expect(1, 66257, '\P{Sc:   cari}', "");
    Expect(0, 66257, '\P{^Sc:   cari}', "");
    Expect(1, 66256, '\p{Sc=	cari}', "");
    Expect(0, 66256, '\p{^Sc=	cari}', "");
    Expect(0, 66256, '\P{Sc=	cari}', "");
    Expect(1, 66256, '\P{^Sc=	cari}', "");
    Expect(0, 66257, '\p{Sc=	cari}', "");
    Expect(1, 66257, '\p{^Sc=	cari}', "");
    Expect(1, 66257, '\P{Sc=	cari}', "");
    Expect(0, 66257, '\P{^Sc=	cari}', "");
    Error('\p{Is_Script=	:=carian}');
    Error('\P{Is_Script=	:=carian}');
    Expect(1, 66256, '\p{Is_Script: carian}', "");
    Expect(0, 66256, '\p{^Is_Script: carian}', "");
    Expect(0, 66256, '\P{Is_Script: carian}', "");
    Expect(1, 66256, '\P{^Is_Script: carian}', "");
    Expect(0, 66257, '\p{Is_Script: carian}', "");
    Expect(1, 66257, '\p{^Is_Script: carian}', "");
    Expect(1, 66257, '\P{Is_Script: carian}', "");
    Expect(0, 66257, '\P{^Is_Script: carian}', "");
    Expect(1, 66256, '\p{Is_Script=-	Carian}', "");
    Expect(0, 66256, '\p{^Is_Script=-	Carian}', "");
    Expect(0, 66256, '\P{Is_Script=-	Carian}', "");
    Expect(1, 66256, '\P{^Is_Script=-	Carian}', "");
    Expect(0, 66257, '\p{Is_Script=-	Carian}', "");
    Expect(1, 66257, '\p{^Is_Script=-	Carian}', "");
    Expect(1, 66257, '\P{Is_Script=-	Carian}', "");
    Expect(0, 66257, '\P{^Is_Script=-	Carian}', "");
    Error('\p{Is_Sc= :=cari}');
    Error('\P{Is_Sc= :=cari}');
    Expect(1, 66256, '\p{Is_Sc=cari}', "");
    Expect(0, 66256, '\p{^Is_Sc=cari}', "");
    Expect(0, 66256, '\P{Is_Sc=cari}', "");
    Expect(1, 66256, '\P{^Is_Sc=cari}', "");
    Expect(0, 66257, '\p{Is_Sc=cari}', "");
    Expect(1, 66257, '\p{^Is_Sc=cari}', "");
    Expect(1, 66257, '\P{Is_Sc=cari}', "");
    Expect(0, 66257, '\P{^Is_Sc=cari}', "");
    Expect(1, 66256, '\p{Is_Sc=	Cari}', "");
    Expect(0, 66256, '\p{^Is_Sc=	Cari}', "");
    Expect(0, 66256, '\P{Is_Sc=	Cari}', "");
    Expect(1, 66256, '\P{^Is_Sc=	Cari}', "");
    Expect(0, 66257, '\p{Is_Sc=	Cari}', "");
    Expect(1, 66257, '\p{^Is_Sc=	Cari}', "");
    Expect(1, 66257, '\P{Is_Sc=	Cari}', "");
    Expect(0, 66257, '\P{^Is_Sc=	Cari}', "");
    Error('\p{Script=:=  cham}');
    Error('\P{Script=:=  cham}');
    Expect(1, 43615, '\p{Script=cham}', "");
    Expect(0, 43615, '\p{^Script=cham}', "");
    Expect(0, 43615, '\P{Script=cham}', "");
    Expect(1, 43615, '\P{^Script=cham}', "");
    Expect(0, 43616, '\p{Script=cham}', "");
    Expect(1, 43616, '\p{^Script=cham}', "");
    Expect(1, 43616, '\P{Script=cham}', "");
    Expect(0, 43616, '\P{^Script=cham}', "");
    Expect(1, 43615, '\p{Script=		cham}', "");
    Expect(0, 43615, '\p{^Script=		cham}', "");
    Expect(0, 43615, '\P{Script=		cham}', "");
    Expect(1, 43615, '\P{^Script=		cham}', "");
    Expect(0, 43616, '\p{Script=		cham}', "");
    Expect(1, 43616, '\p{^Script=		cham}', "");
    Expect(1, 43616, '\P{Script=		cham}', "");
    Expect(0, 43616, '\P{^Script=		cham}', "");
    Error('\p{Sc=_-CHAM/a/}');
    Error('\P{Sc=_-CHAM/a/}');
    Expect(1, 43615, '\p{Sc=cham}', "");
    Expect(0, 43615, '\p{^Sc=cham}', "");
    Expect(0, 43615, '\P{Sc=cham}', "");
    Expect(1, 43615, '\P{^Sc=cham}', "");
    Expect(0, 43616, '\p{Sc=cham}', "");
    Expect(1, 43616, '\p{^Sc=cham}', "");
    Expect(1, 43616, '\P{Sc=cham}', "");
    Expect(0, 43616, '\P{^Sc=cham}', "");
    Expect(1, 43615, '\p{Sc=  CHAM}', "");
    Expect(0, 43615, '\p{^Sc=  CHAM}', "");
    Expect(0, 43615, '\P{Sc=  CHAM}', "");
    Expect(1, 43615, '\P{^Sc=  CHAM}', "");
    Expect(0, 43616, '\p{Sc=  CHAM}', "");
    Expect(1, 43616, '\p{^Sc=  CHAM}', "");
    Expect(1, 43616, '\P{Sc=  CHAM}', "");
    Expect(0, 43616, '\P{^Sc=  CHAM}', "");
    Error('\p{Is_Script=	/a/CHAM}');
    Error('\P{Is_Script=	/a/CHAM}');
    Expect(1, 43615, '\p{Is_Script=cham}', "");
    Expect(0, 43615, '\p{^Is_Script=cham}', "");
    Expect(0, 43615, '\P{Is_Script=cham}', "");
    Expect(1, 43615, '\P{^Is_Script=cham}', "");
    Expect(0, 43616, '\p{Is_Script=cham}', "");
    Expect(1, 43616, '\p{^Is_Script=cham}', "");
    Expect(1, 43616, '\P{Is_Script=cham}', "");
    Expect(0, 43616, '\P{^Is_Script=cham}', "");
    Expect(1, 43615, '\p{Is_Script=-_Cham}', "");
    Expect(0, 43615, '\p{^Is_Script=-_Cham}', "");
    Expect(0, 43615, '\P{Is_Script=-_Cham}', "");
    Expect(1, 43615, '\P{^Is_Script=-_Cham}', "");
    Expect(0, 43616, '\p{Is_Script=-_Cham}', "");
    Expect(1, 43616, '\p{^Is_Script=-_Cham}', "");
    Expect(1, 43616, '\P{Is_Script=-_Cham}', "");
    Expect(0, 43616, '\P{^Is_Script=-_Cham}', "");
    Error('\p{Is_Sc=	/a/CHAM}');
    Error('\P{Is_Sc=	/a/CHAM}');
    Expect(1, 43615, '\p{Is_Sc=cham}', "");
    Expect(0, 43615, '\p{^Is_Sc=cham}', "");
    Expect(0, 43615, '\P{Is_Sc=cham}', "");
    Expect(1, 43615, '\P{^Is_Sc=cham}', "");
    Expect(0, 43616, '\p{Is_Sc=cham}', "");
    Expect(1, 43616, '\p{^Is_Sc=cham}', "");
    Expect(1, 43616, '\P{Is_Sc=cham}', "");
    Expect(0, 43616, '\P{^Is_Sc=cham}', "");
    Expect(1, 43615, '\p{Is_Sc=	_cham}', "");
    Expect(0, 43615, '\p{^Is_Sc=	_cham}', "");
    Expect(0, 43615, '\P{Is_Sc=	_cham}', "");
    Expect(1, 43615, '\P{^Is_Sc=	_cham}', "");
    Expect(0, 43616, '\p{Is_Sc=	_cham}', "");
    Expect(1, 43616, '\p{^Is_Sc=	_cham}', "");
    Expect(1, 43616, '\P{Is_Sc=	_cham}', "");
    Expect(0, 43616, '\P{^Is_Sc=	_cham}', "");
    Error('\p{Script=	:=Cherokee}');
    Error('\P{Script=	:=Cherokee}');
    Expect(1, 43967, '\p{Script=cherokee}', "");
    Expect(0, 43967, '\p{^Script=cherokee}', "");
    Expect(0, 43967, '\P{Script=cherokee}', "");
    Expect(1, 43967, '\P{^Script=cherokee}', "");
    Expect(0, 43968, '\p{Script=cherokee}', "");
    Expect(1, 43968, '\p{^Script=cherokee}', "");
    Expect(1, 43968, '\P{Script=cherokee}', "");
    Expect(0, 43968, '\P{^Script=cherokee}', "");
    Expect(1, 43967, '\p{Script=_Cherokee}', "");
    Expect(0, 43967, '\p{^Script=_Cherokee}', "");
    Expect(0, 43967, '\P{Script=_Cherokee}', "");
    Expect(1, 43967, '\P{^Script=_Cherokee}', "");
    Expect(0, 43968, '\p{Script=_Cherokee}', "");
    Expect(1, 43968, '\p{^Script=_Cherokee}', "");
    Expect(1, 43968, '\P{Script=_Cherokee}', "");
    Expect(0, 43968, '\P{^Script=_Cherokee}', "");
    Error('\p{Sc=:=	cher}');
    Error('\P{Sc=:=	cher}');
    Expect(1, 43967, '\p{Sc=cher}', "");
    Expect(0, 43967, '\p{^Sc=cher}', "");
    Expect(0, 43967, '\P{Sc=cher}', "");
    Expect(1, 43967, '\P{^Sc=cher}', "");
    Expect(0, 43968, '\p{Sc=cher}', "");
    Expect(1, 43968, '\p{^Sc=cher}', "");
    Expect(1, 43968, '\P{Sc=cher}', "");
    Expect(0, 43968, '\P{^Sc=cher}', "");
    Expect(1, 43967, '\p{Sc=	 CHER}', "");
    Expect(0, 43967, '\p{^Sc=	 CHER}', "");
    Expect(0, 43967, '\P{Sc=	 CHER}', "");
    Expect(1, 43967, '\P{^Sc=	 CHER}', "");
    Expect(0, 43968, '\p{Sc=	 CHER}', "");
    Expect(1, 43968, '\p{^Sc=	 CHER}', "");
    Expect(1, 43968, '\P{Sc=	 CHER}', "");
    Expect(0, 43968, '\P{^Sc=	 CHER}', "");
    Error('\p{Is_Script= :=Cherokee}');
    Error('\P{Is_Script= :=Cherokee}');
    Expect(1, 43967, '\p{Is_Script=cherokee}', "");
    Expect(0, 43967, '\p{^Is_Script=cherokee}', "");
    Expect(0, 43967, '\P{Is_Script=cherokee}', "");
    Expect(1, 43967, '\P{^Is_Script=cherokee}', "");
    Expect(0, 43968, '\p{Is_Script=cherokee}', "");
    Expect(1, 43968, '\p{^Is_Script=cherokee}', "");
    Expect(1, 43968, '\P{Is_Script=cherokee}', "");
    Expect(0, 43968, '\P{^Is_Script=cherokee}', "");
    Expect(1, 43967, '\p{Is_Script= 	Cherokee}', "");
    Expect(0, 43967, '\p{^Is_Script= 	Cherokee}', "");
    Expect(0, 43967, '\P{Is_Script= 	Cherokee}', "");
    Expect(1, 43967, '\P{^Is_Script= 	Cherokee}', "");
    Expect(0, 43968, '\p{Is_Script= 	Cherokee}', "");
    Expect(1, 43968, '\p{^Is_Script= 	Cherokee}', "");
    Expect(1, 43968, '\P{Is_Script= 	Cherokee}', "");
    Expect(0, 43968, '\P{^Is_Script= 	Cherokee}', "");
    Error('\p{Is_Sc= -cher:=}');
    Error('\P{Is_Sc= -cher:=}');
    Expect(1, 43967, '\p{Is_Sc=cher}', "");
    Expect(0, 43967, '\p{^Is_Sc=cher}', "");
    Expect(0, 43967, '\P{Is_Sc=cher}', "");
    Expect(1, 43967, '\P{^Is_Sc=cher}', "");
    Expect(0, 43968, '\p{Is_Sc=cher}', "");
    Expect(1, 43968, '\p{^Is_Sc=cher}', "");
    Expect(1, 43968, '\P{Is_Sc=cher}', "");
    Expect(0, 43968, '\P{^Is_Sc=cher}', "");
    Expect(1, 43967, '\p{Is_Sc= 	Cher}', "");
    Expect(0, 43967, '\p{^Is_Sc= 	Cher}', "");
    Expect(0, 43967, '\P{Is_Sc= 	Cher}', "");
    Expect(1, 43967, '\P{^Is_Sc= 	Cher}', "");
    Expect(0, 43968, '\p{Is_Sc= 	Cher}', "");
    Expect(1, 43968, '\p{^Is_Sc= 	Cher}', "");
    Expect(1, 43968, '\P{Is_Sc= 	Cher}', "");
    Expect(0, 43968, '\P{^Is_Sc= 	Cher}', "");
    Error('\p{Script:	-/a/Coptic}');
    Error('\P{Script:	-/a/Coptic}');
    Expect(1, 11519, '\p{Script=coptic}', "");
    Expect(0, 11519, '\p{^Script=coptic}', "");
    Expect(0, 11519, '\P{Script=coptic}', "");
    Expect(1, 11519, '\P{^Script=coptic}', "");
    Expect(0, 11520, '\p{Script=coptic}', "");
    Expect(1, 11520, '\p{^Script=coptic}', "");
    Expect(1, 11520, '\P{Script=coptic}', "");
    Expect(0, 11520, '\P{^Script=coptic}', "");
    Expect(1, 11519, '\p{Script= COPTIC}', "");
    Expect(0, 11519, '\p{^Script= COPTIC}', "");
    Expect(0, 11519, '\P{Script= COPTIC}', "");
    Expect(1, 11519, '\P{^Script= COPTIC}', "");
    Expect(0, 11520, '\p{Script= COPTIC}', "");
    Expect(1, 11520, '\p{^Script= COPTIC}', "");
    Expect(1, 11520, '\P{Script= COPTIC}', "");
    Expect(0, 11520, '\P{^Script= COPTIC}', "");
    Error('\p{Sc:   	_COPT:=}');
    Error('\P{Sc:   	_COPT:=}');
    Expect(1, 11519, '\p{Sc=copt}', "");
    Expect(0, 11519, '\p{^Sc=copt}', "");
    Expect(0, 11519, '\P{Sc=copt}', "");
    Expect(1, 11519, '\P{^Sc=copt}', "");
    Expect(0, 11520, '\p{Sc=copt}', "");
    Expect(1, 11520, '\p{^Sc=copt}', "");
    Expect(1, 11520, '\P{Sc=copt}', "");
    Expect(0, 11520, '\P{^Sc=copt}', "");
    Expect(1, 11519, '\p{Sc=-copt}', "");
    Expect(0, 11519, '\p{^Sc=-copt}', "");
    Expect(0, 11519, '\P{Sc=-copt}', "");
    Expect(1, 11519, '\P{^Sc=-copt}', "");
    Expect(0, 11520, '\p{Sc=-copt}', "");
    Expect(1, 11520, '\p{^Sc=-copt}', "");
    Expect(1, 11520, '\P{Sc=-copt}', "");
    Expect(0, 11520, '\P{^Sc=-copt}', "");
    Error('\p{Is_Script=	-qaac/a/}');
    Error('\P{Is_Script=	-qaac/a/}');
    Expect(1, 11519, '\p{Is_Script=qaac}', "");
    Expect(0, 11519, '\p{^Is_Script=qaac}', "");
    Expect(0, 11519, '\P{Is_Script=qaac}', "");
    Expect(1, 11519, '\P{^Is_Script=qaac}', "");
    Expect(0, 11520, '\p{Is_Script=qaac}', "");
    Expect(1, 11520, '\p{^Is_Script=qaac}', "");
    Expect(1, 11520, '\P{Is_Script=qaac}', "");
    Expect(0, 11520, '\P{^Is_Script=qaac}', "");
    Expect(1, 11519, '\p{Is_Script=__Qaac}', "");
    Expect(0, 11519, '\p{^Is_Script=__Qaac}', "");
    Expect(0, 11519, '\P{Is_Script=__Qaac}', "");
    Expect(1, 11519, '\P{^Is_Script=__Qaac}', "");
    Expect(0, 11520, '\p{Is_Script=__Qaac}', "");
    Expect(1, 11520, '\p{^Is_Script=__Qaac}', "");
    Expect(1, 11520, '\P{Is_Script=__Qaac}', "");
    Expect(0, 11520, '\P{^Is_Script=__Qaac}', "");
    Error('\p{Is_Sc=:=  COPTIC}');
    Error('\P{Is_Sc=:=  COPTIC}');
    Expect(1, 11519, '\p{Is_Sc=coptic}', "");
    Expect(0, 11519, '\p{^Is_Sc=coptic}', "");
    Expect(0, 11519, '\P{Is_Sc=coptic}', "");
    Expect(1, 11519, '\P{^Is_Sc=coptic}', "");
    Expect(0, 11520, '\p{Is_Sc=coptic}', "");
    Expect(1, 11520, '\p{^Is_Sc=coptic}', "");
    Expect(1, 11520, '\P{Is_Sc=coptic}', "");
    Expect(0, 11520, '\P{^Is_Sc=coptic}', "");
    Expect(1, 11519, '\p{Is_Sc=	Coptic}', "");
    Expect(0, 11519, '\p{^Is_Sc=	Coptic}', "");
    Expect(0, 11519, '\P{Is_Sc=	Coptic}', "");
    Expect(1, 11519, '\P{^Is_Sc=	Coptic}', "");
    Expect(0, 11520, '\p{Is_Sc=	Coptic}', "");
    Expect(1, 11520, '\p{^Is_Sc=	Coptic}', "");
    Expect(1, 11520, '\P{Is_Sc=	Coptic}', "");
    Expect(0, 11520, '\P{^Is_Sc=	Coptic}', "");
    Error('\p{Script=_:=Cypriot}');
    Error('\P{Script=_:=Cypriot}');
    Expect(1, 67647, '\p{Script=cypriot}', "");
    Expect(0, 67647, '\p{^Script=cypriot}', "");
    Expect(0, 67647, '\P{Script=cypriot}', "");
    Expect(1, 67647, '\P{^Script=cypriot}', "");
    Expect(0, 67648, '\p{Script=cypriot}', "");
    Expect(1, 67648, '\p{^Script=cypriot}', "");
    Expect(1, 67648, '\P{Script=cypriot}', "");
    Expect(0, 67648, '\P{^Script=cypriot}', "");
    Expect(1, 67647, '\p{Script= cypriot}', "");
    Expect(0, 67647, '\p{^Script= cypriot}', "");
    Expect(0, 67647, '\P{Script= cypriot}', "");
    Expect(1, 67647, '\P{^Script= cypriot}', "");
    Expect(0, 67648, '\p{Script= cypriot}', "");
    Expect(1, 67648, '\p{^Script= cypriot}', "");
    Expect(1, 67648, '\P{Script= cypriot}', "");
    Expect(0, 67648, '\P{^Script= cypriot}', "");
    Error('\p{Sc=:=	-Cprt}');
    Error('\P{Sc=:=	-Cprt}');
    Expect(1, 67647, '\p{Sc=cprt}', "");
    Expect(0, 67647, '\p{^Sc=cprt}', "");
    Expect(0, 67647, '\P{Sc=cprt}', "");
    Expect(1, 67647, '\P{^Sc=cprt}', "");
    Expect(0, 67648, '\p{Sc=cprt}', "");
    Expect(1, 67648, '\p{^Sc=cprt}', "");
    Expect(1, 67648, '\P{Sc=cprt}', "");
    Expect(0, 67648, '\P{^Sc=cprt}', "");
    Expect(1, 67647, '\p{Sc=  cprt}', "");
    Expect(0, 67647, '\p{^Sc=  cprt}', "");
    Expect(0, 67647, '\P{Sc=  cprt}', "");
    Expect(1, 67647, '\P{^Sc=  cprt}', "");
    Expect(0, 67648, '\p{Sc=  cprt}', "");
    Expect(1, 67648, '\p{^Sc=  cprt}', "");
    Expect(1, 67648, '\P{Sc=  cprt}', "");
    Expect(0, 67648, '\P{^Sc=  cprt}', "");
    Error('\p{Is_Script=:= -CYPRIOT}');
    Error('\P{Is_Script=:= -CYPRIOT}');
    Expect(1, 67647, '\p{Is_Script=cypriot}', "");
    Expect(0, 67647, '\p{^Is_Script=cypriot}', "");
    Expect(0, 67647, '\P{Is_Script=cypriot}', "");
    Expect(1, 67647, '\P{^Is_Script=cypriot}', "");
    Expect(0, 67648, '\p{Is_Script=cypriot}', "");
    Expect(1, 67648, '\p{^Is_Script=cypriot}', "");
    Expect(1, 67648, '\P{Is_Script=cypriot}', "");
    Expect(0, 67648, '\P{^Is_Script=cypriot}', "");
    Expect(1, 67647, '\p{Is_Script=-	CYPRIOT}', "");
    Expect(0, 67647, '\p{^Is_Script=-	CYPRIOT}', "");
    Expect(0, 67647, '\P{Is_Script=-	CYPRIOT}', "");
    Expect(1, 67647, '\P{^Is_Script=-	CYPRIOT}', "");
    Expect(0, 67648, '\p{Is_Script=-	CYPRIOT}', "");
    Expect(1, 67648, '\p{^Is_Script=-	CYPRIOT}', "");
    Expect(1, 67648, '\P{Is_Script=-	CYPRIOT}', "");
    Expect(0, 67648, '\P{^Is_Script=-	CYPRIOT}', "");
    Error('\p{Is_Sc:		 Cprt/a/}');
    Error('\P{Is_Sc:		 Cprt/a/}');
    Expect(1, 67647, '\p{Is_Sc=cprt}', "");
    Expect(0, 67647, '\p{^Is_Sc=cprt}', "");
    Expect(0, 67647, '\P{Is_Sc=cprt}', "");
    Expect(1, 67647, '\P{^Is_Sc=cprt}', "");
    Expect(0, 67648, '\p{Is_Sc=cprt}', "");
    Expect(1, 67648, '\p{^Is_Sc=cprt}', "");
    Expect(1, 67648, '\P{Is_Sc=cprt}', "");
    Expect(0, 67648, '\P{^Is_Sc=cprt}', "");
    Expect(1, 67647, '\p{Is_Sc=	-Cprt}', "");
    Expect(0, 67647, '\p{^Is_Sc=	-Cprt}', "");
    Expect(0, 67647, '\P{Is_Sc=	-Cprt}', "");
    Expect(1, 67647, '\P{^Is_Sc=	-Cprt}', "");
    Expect(0, 67648, '\p{Is_Sc=	-Cprt}', "");
    Expect(1, 67648, '\p{^Is_Sc=	-Cprt}', "");
    Expect(1, 67648, '\P{Is_Sc=	-Cprt}', "");
    Expect(0, 67648, '\P{^Is_Sc=	-Cprt}', "");
    Error('\p{Script= cyrillic/a/}');
    Error('\P{Script= cyrillic/a/}');
    Expect(1, 65071, '\p{Script=cyrillic}', "");
    Expect(0, 65071, '\p{^Script=cyrillic}', "");
    Expect(0, 65071, '\P{Script=cyrillic}', "");
    Expect(1, 65071, '\P{^Script=cyrillic}', "");
    Expect(0, 65072, '\p{Script=cyrillic}', "");
    Expect(1, 65072, '\p{^Script=cyrillic}', "");
    Expect(1, 65072, '\P{Script=cyrillic}', "");
    Expect(0, 65072, '\P{^Script=cyrillic}', "");
    Expect(1, 65071, '\p{Script=_ CYRILLIC}', "");
    Expect(0, 65071, '\p{^Script=_ CYRILLIC}', "");
    Expect(0, 65071, '\P{Script=_ CYRILLIC}', "");
    Expect(1, 65071, '\P{^Script=_ CYRILLIC}', "");
    Expect(0, 65072, '\p{Script=_ CYRILLIC}', "");
    Expect(1, 65072, '\p{^Script=_ CYRILLIC}', "");
    Expect(1, 65072, '\P{Script=_ CYRILLIC}', "");
    Expect(0, 65072, '\P{^Script=_ CYRILLIC}', "");
    Error('\p{Sc=-_Cyrl/a/}');
    Error('\P{Sc=-_Cyrl/a/}');
    Expect(1, 65071, '\p{Sc=cyrl}', "");
    Expect(0, 65071, '\p{^Sc=cyrl}', "");
    Expect(0, 65071, '\P{Sc=cyrl}', "");
    Expect(1, 65071, '\P{^Sc=cyrl}', "");
    Expect(0, 65072, '\p{Sc=cyrl}', "");
    Expect(1, 65072, '\p{^Sc=cyrl}', "");
    Expect(1, 65072, '\P{Sc=cyrl}', "");
    Expect(0, 65072, '\P{^Sc=cyrl}', "");
    Expect(1, 65071, '\p{Sc=	-Cyrl}', "");
    Expect(0, 65071, '\p{^Sc=	-Cyrl}', "");
    Expect(0, 65071, '\P{Sc=	-Cyrl}', "");
    Expect(1, 65071, '\P{^Sc=	-Cyrl}', "");
    Expect(0, 65072, '\p{Sc=	-Cyrl}', "");
    Expect(1, 65072, '\p{^Sc=	-Cyrl}', "");
    Expect(1, 65072, '\P{Sc=	-Cyrl}', "");
    Expect(0, 65072, '\P{^Sc=	-Cyrl}', "");
    Error('\p{Is_Script=/a/ Cyrillic}');
    Error('\P{Is_Script=/a/ Cyrillic}');
    Expect(1, 65071, '\p{Is_Script=cyrillic}', "");
    Expect(0, 65071, '\p{^Is_Script=cyrillic}', "");
    Expect(0, 65071, '\P{Is_Script=cyrillic}', "");
    Expect(1, 65071, '\P{^Is_Script=cyrillic}', "");
    Expect(0, 65072, '\p{Is_Script=cyrillic}', "");
    Expect(1, 65072, '\p{^Is_Script=cyrillic}', "");
    Expect(1, 65072, '\P{Is_Script=cyrillic}', "");
    Expect(0, 65072, '\P{^Is_Script=cyrillic}', "");
    Expect(1, 65071, '\p{Is_Script=_ CYRILLIC}', "");
    Expect(0, 65071, '\p{^Is_Script=_ CYRILLIC}', "");
    Expect(0, 65071, '\P{Is_Script=_ CYRILLIC}', "");
    Expect(1, 65071, '\P{^Is_Script=_ CYRILLIC}', "");
    Expect(0, 65072, '\p{Is_Script=_ CYRILLIC}', "");
    Expect(1, 65072, '\p{^Is_Script=_ CYRILLIC}', "");
    Expect(1, 65072, '\P{Is_Script=_ CYRILLIC}', "");
    Expect(0, 65072, '\P{^Is_Script=_ CYRILLIC}', "");
    Error('\p{Is_Sc=:=	_Cyrl}');
    Error('\P{Is_Sc=:=	_Cyrl}');
    Expect(1, 65071, '\p{Is_Sc=cyrl}', "");
    Expect(0, 65071, '\p{^Is_Sc=cyrl}', "");
    Expect(0, 65071, '\P{Is_Sc=cyrl}', "");
    Expect(1, 65071, '\P{^Is_Sc=cyrl}', "");
    Expect(0, 65072, '\p{Is_Sc=cyrl}', "");
    Expect(1, 65072, '\p{^Is_Sc=cyrl}', "");
    Expect(1, 65072, '\P{Is_Sc=cyrl}', "");
    Expect(0, 65072, '\P{^Is_Sc=cyrl}', "");
    Expect(1, 65071, '\p{Is_Sc=_Cyrl}', "");
    Expect(0, 65071, '\p{^Is_Sc=_Cyrl}', "");
    Expect(0, 65071, '\P{Is_Sc=_Cyrl}', "");
    Expect(1, 65071, '\P{^Is_Sc=_Cyrl}', "");
    Expect(0, 65072, '\p{Is_Sc=_Cyrl}', "");
    Expect(1, 65072, '\p{^Is_Sc=_Cyrl}', "");
    Expect(1, 65072, '\P{Is_Sc=_Cyrl}', "");
    Expect(0, 65072, '\P{^Is_Sc=_Cyrl}', "");
    Error('\p{Script=:=_	devanagari}');
    Error('\P{Script=:=_	devanagari}');
    Expect(1, 43261, '\p{Script=devanagari}', "");
    Expect(0, 43261, '\p{^Script=devanagari}', "");
    Expect(0, 43261, '\P{Script=devanagari}', "");
    Expect(1, 43261, '\P{^Script=devanagari}', "");
    Expect(0, 43262, '\p{Script=devanagari}', "");
    Expect(1, 43262, '\p{^Script=devanagari}', "");
    Expect(1, 43262, '\P{Script=devanagari}', "");
    Expect(0, 43262, '\P{^Script=devanagari}', "");
    Expect(1, 43261, '\p{Script:   - devanagari}', "");
    Expect(0, 43261, '\p{^Script:   - devanagari}', "");
    Expect(0, 43261, '\P{Script:   - devanagari}', "");
    Expect(1, 43261, '\P{^Script:   - devanagari}', "");
    Expect(0, 43262, '\p{Script:   - devanagari}', "");
    Expect(1, 43262, '\p{^Script:   - devanagari}', "");
    Expect(1, 43262, '\P{Script:   - devanagari}', "");
    Expect(0, 43262, '\P{^Script:   - devanagari}', "");
    Error('\p{Sc=_	Deva:=}');
    Error('\P{Sc=_	Deva:=}');
    Expect(1, 43261, '\p{Sc=deva}', "");
    Expect(0, 43261, '\p{^Sc=deva}', "");
    Expect(0, 43261, '\P{Sc=deva}', "");
    Expect(1, 43261, '\P{^Sc=deva}', "");
    Expect(0, 43262, '\p{Sc=deva}', "");
    Expect(1, 43262, '\p{^Sc=deva}', "");
    Expect(1, 43262, '\P{Sc=deva}', "");
    Expect(0, 43262, '\P{^Sc=deva}', "");
    Expect(1, 43261, '\p{Sc=-DEVA}', "");
    Expect(0, 43261, '\p{^Sc=-DEVA}', "");
    Expect(0, 43261, '\P{Sc=-DEVA}', "");
    Expect(1, 43261, '\P{^Sc=-DEVA}', "");
    Expect(0, 43262, '\p{Sc=-DEVA}', "");
    Expect(1, 43262, '\p{^Sc=-DEVA}', "");
    Expect(1, 43262, '\P{Sc=-DEVA}', "");
    Expect(0, 43262, '\P{^Sc=-DEVA}', "");
    Error('\p{Is_Script=	/a/DEVANAGARI}');
    Error('\P{Is_Script=	/a/DEVANAGARI}');
    Expect(1, 43261, '\p{Is_Script=devanagari}', "");
    Expect(0, 43261, '\p{^Is_Script=devanagari}', "");
    Expect(0, 43261, '\P{Is_Script=devanagari}', "");
    Expect(1, 43261, '\P{^Is_Script=devanagari}', "");
    Expect(0, 43262, '\p{Is_Script=devanagari}', "");
    Expect(1, 43262, '\p{^Is_Script=devanagari}', "");
    Expect(1, 43262, '\P{Is_Script=devanagari}', "");
    Expect(0, 43262, '\P{^Is_Script=devanagari}', "");
    Expect(1, 43261, '\p{Is_Script=_Devanagari}', "");
    Expect(0, 43261, '\p{^Is_Script=_Devanagari}', "");
    Expect(0, 43261, '\P{Is_Script=_Devanagari}', "");
    Expect(1, 43261, '\P{^Is_Script=_Devanagari}', "");
    Expect(0, 43262, '\p{Is_Script=_Devanagari}', "");
    Expect(1, 43262, '\p{^Is_Script=_Devanagari}', "");
    Expect(1, 43262, '\P{Is_Script=_Devanagari}', "");
    Expect(0, 43262, '\P{^Is_Script=_Devanagari}', "");
    Error('\p{Is_Sc=-/a/Deva}');
    Error('\P{Is_Sc=-/a/Deva}');
    Expect(1, 43261, '\p{Is_Sc=deva}', "");
    Expect(0, 43261, '\p{^Is_Sc=deva}', "");
    Expect(0, 43261, '\P{Is_Sc=deva}', "");
    Expect(1, 43261, '\P{^Is_Sc=deva}', "");
    Expect(0, 43262, '\p{Is_Sc=deva}', "");
    Expect(1, 43262, '\p{^Is_Sc=deva}', "");
    Expect(1, 43262, '\P{Is_Sc=deva}', "");
    Expect(0, 43262, '\P{^Is_Sc=deva}', "");
    Expect(1, 43261, '\p{Is_Sc=-	deva}', "");
    Expect(0, 43261, '\p{^Is_Sc=-	deva}', "");
    Expect(0, 43261, '\P{Is_Sc=-	deva}', "");
    Expect(1, 43261, '\P{^Is_Sc=-	deva}', "");
    Expect(0, 43262, '\p{Is_Sc=-	deva}', "");
    Expect(1, 43262, '\p{^Is_Sc=-	deva}', "");
    Expect(1, 43262, '\P{Is_Sc=-	deva}', "");
    Expect(0, 43262, '\P{^Is_Sc=-	deva}', "");
    Error('\p{Script=	/a/DESERET}');
    Error('\P{Script=	/a/DESERET}');
    Expect(1, 66639, '\p{Script=deseret}', "");
    Expect(0, 66639, '\p{^Script=deseret}', "");
    Expect(0, 66639, '\P{Script=deseret}', "");
    Expect(1, 66639, '\P{^Script=deseret}', "");
    Expect(0, 66640, '\p{Script=deseret}', "");
    Expect(1, 66640, '\p{^Script=deseret}', "");
    Expect(1, 66640, '\P{Script=deseret}', "");
    Expect(0, 66640, '\P{^Script=deseret}', "");
    Expect(1, 66639, '\p{Script=_Deseret}', "");
    Expect(0, 66639, '\p{^Script=_Deseret}', "");
    Expect(0, 66639, '\P{Script=_Deseret}', "");
    Expect(1, 66639, '\P{^Script=_Deseret}', "");
    Expect(0, 66640, '\p{Script=_Deseret}', "");
    Expect(1, 66640, '\p{^Script=_Deseret}', "");
    Expect(1, 66640, '\P{Script=_Deseret}', "");
    Expect(0, 66640, '\P{^Script=_Deseret}', "");
    Error('\p{Sc=/a/ Dsrt}');
    Error('\P{Sc=/a/ Dsrt}');
    Expect(1, 66639, '\p{Sc=dsrt}', "");
    Expect(0, 66639, '\p{^Sc=dsrt}', "");
    Expect(0, 66639, '\P{Sc=dsrt}', "");
    Expect(1, 66639, '\P{^Sc=dsrt}', "");
    Expect(0, 66640, '\p{Sc=dsrt}', "");
    Expect(1, 66640, '\p{^Sc=dsrt}', "");
    Expect(1, 66640, '\P{Sc=dsrt}', "");
    Expect(0, 66640, '\P{^Sc=dsrt}', "");
    Error('\p{Is_Script=	:=deseret}');
    Error('\P{Is_Script=	:=deseret}');
    Expect(1, 66639, '\p{Is_Script=deseret}', "");
    Expect(0, 66639, '\p{^Is_Script=deseret}', "");
    Expect(0, 66639, '\P{Is_Script=deseret}', "");
    Expect(1, 66639, '\P{^Is_Script=deseret}', "");
    Expect(0, 66640, '\p{Is_Script=deseret}', "");
    Expect(1, 66640, '\p{^Is_Script=deseret}', "");
    Expect(1, 66640, '\P{Is_Script=deseret}', "");
    Expect(0, 66640, '\P{^Is_Script=deseret}', "");
    Expect(1, 66639, '\p{Is_Script=- Deseret}', "");
    Expect(0, 66639, '\p{^Is_Script=- Deseret}', "");
    Expect(0, 66639, '\P{Is_Script=- Deseret}', "");
    Expect(1, 66639, '\P{^Is_Script=- Deseret}', "");
    Expect(0, 66640, '\p{Is_Script=- Deseret}', "");
    Expect(1, 66640, '\p{^Is_Script=- Deseret}', "");
    Expect(1, 66640, '\P{Is_Script=- Deseret}', "");
    Expect(0, 66640, '\P{^Is_Script=- Deseret}', "");
    Error('\p{Is_Sc= :=Dsrt}');
    Error('\P{Is_Sc= :=Dsrt}');
    Expect(1, 66639, '\p{Is_Sc=dsrt}', "");
    Expect(0, 66639, '\p{^Is_Sc=dsrt}', "");
    Expect(0, 66639, '\P{Is_Sc=dsrt}', "");
    Expect(1, 66639, '\P{^Is_Sc=dsrt}', "");
    Expect(0, 66640, '\p{Is_Sc=dsrt}', "");
    Expect(1, 66640, '\p{^Is_Sc=dsrt}', "");
    Expect(1, 66640, '\P{Is_Sc=dsrt}', "");
    Expect(0, 66640, '\P{^Is_Sc=dsrt}', "");
    Expect(1, 66639, '\p{Is_Sc=__Dsrt}', "");
    Expect(0, 66639, '\p{^Is_Sc=__Dsrt}', "");
    Expect(0, 66639, '\P{Is_Sc=__Dsrt}', "");
    Expect(1, 66639, '\P{^Is_Sc=__Dsrt}', "");
    Expect(0, 66640, '\p{Is_Sc=__Dsrt}', "");
    Expect(1, 66640, '\p{^Is_Sc=__Dsrt}', "");
    Expect(1, 66640, '\P{Is_Sc=__Dsrt}', "");
    Expect(0, 66640, '\P{^Is_Sc=__Dsrt}', "");
    Error('\p{Script=-:=duployan}');
    Error('\P{Script=-:=duployan}');
    Expect(1, 113823, '\p{Script: duployan}', "");
    Expect(0, 113823, '\p{^Script: duployan}', "");
    Expect(0, 113823, '\P{Script: duployan}', "");
    Expect(1, 113823, '\P{^Script: duployan}', "");
    Expect(0, 113824, '\p{Script: duployan}', "");
    Expect(1, 113824, '\p{^Script: duployan}', "");
    Expect(1, 113824, '\P{Script: duployan}', "");
    Expect(0, 113824, '\P{^Script: duployan}', "");
    Expect(1, 113823, '\p{Script=_ duployan}', "");
    Expect(0, 113823, '\p{^Script=_ duployan}', "");
    Expect(0, 113823, '\P{Script=_ duployan}', "");
    Expect(1, 113823, '\P{^Script=_ duployan}', "");
    Expect(0, 113824, '\p{Script=_ duployan}', "");
    Expect(1, 113824, '\p{^Script=_ duployan}', "");
    Expect(1, 113824, '\P{Script=_ duployan}', "");
    Expect(0, 113824, '\P{^Script=_ duployan}', "");
    Error('\p{Sc=	_dupl/a/}');
    Error('\P{Sc=	_dupl/a/}');
    Expect(1, 113823, '\p{Sc=dupl}', "");
    Expect(0, 113823, '\p{^Sc=dupl}', "");
    Expect(0, 113823, '\P{Sc=dupl}', "");
    Expect(1, 113823, '\P{^Sc=dupl}', "");
    Expect(0, 113824, '\p{Sc=dupl}', "");
    Expect(1, 113824, '\p{^Sc=dupl}', "");
    Expect(1, 113824, '\P{Sc=dupl}', "");
    Expect(0, 113824, '\P{^Sc=dupl}', "");
    Expect(1, 113823, '\p{Sc:     Dupl}', "");
    Expect(0, 113823, '\p{^Sc:     Dupl}', "");
    Expect(0, 113823, '\P{Sc:     Dupl}', "");
    Expect(1, 113823, '\P{^Sc:     Dupl}', "");
    Expect(0, 113824, '\p{Sc:     Dupl}', "");
    Expect(1, 113824, '\p{^Sc:     Dupl}', "");
    Expect(1, 113824, '\P{Sc:     Dupl}', "");
    Expect(0, 113824, '\P{^Sc:     Dupl}', "");
    Error('\p{Is_Script:   /a/ -duployan}');
    Error('\P{Is_Script:   /a/ -duployan}');
    Expect(1, 113823, '\p{Is_Script=duployan}', "");
    Expect(0, 113823, '\p{^Is_Script=duployan}', "");
    Expect(0, 113823, '\P{Is_Script=duployan}', "");
    Expect(1, 113823, '\P{^Is_Script=duployan}', "");
    Expect(0, 113824, '\p{Is_Script=duployan}', "");
    Expect(1, 113824, '\p{^Is_Script=duployan}', "");
    Expect(1, 113824, '\P{Is_Script=duployan}', "");
    Expect(0, 113824, '\P{^Is_Script=duployan}', "");
    Expect(1, 113823, '\p{Is_Script:   _ DUPLOYAN}', "");
    Expect(0, 113823, '\p{^Is_Script:   _ DUPLOYAN}', "");
    Expect(0, 113823, '\P{Is_Script:   _ DUPLOYAN}', "");
    Expect(1, 113823, '\P{^Is_Script:   _ DUPLOYAN}', "");
    Expect(0, 113824, '\p{Is_Script:   _ DUPLOYAN}', "");
    Expect(1, 113824, '\p{^Is_Script:   _ DUPLOYAN}', "");
    Expect(1, 113824, '\P{Is_Script:   _ DUPLOYAN}', "");
    Expect(0, 113824, '\P{^Is_Script:   _ DUPLOYAN}', "");
    Error('\p{Is_Sc= 	dupl:=}');
    Error('\P{Is_Sc= 	dupl:=}');
    Expect(1, 113823, '\p{Is_Sc=dupl}', "");
    Expect(0, 113823, '\p{^Is_Sc=dupl}', "");
    Expect(0, 113823, '\P{Is_Sc=dupl}', "");
    Expect(1, 113823, '\P{^Is_Sc=dupl}', "");
    Expect(0, 113824, '\p{Is_Sc=dupl}', "");
    Expect(1, 113824, '\p{^Is_Sc=dupl}', "");
    Expect(1, 113824, '\P{Is_Sc=dupl}', "");
    Expect(0, 113824, '\P{^Is_Sc=dupl}', "");
    Expect(1, 113823, '\p{Is_Sc=_dupl}', "");
    Expect(0, 113823, '\p{^Is_Sc=_dupl}', "");
    Expect(0, 113823, '\P{Is_Sc=_dupl}', "");
    Expect(1, 113823, '\P{^Is_Sc=_dupl}', "");
    Expect(0, 113824, '\p{Is_Sc=_dupl}', "");
    Expect(1, 113824, '\p{^Is_Sc=_dupl}', "");
    Expect(1, 113824, '\P{Is_Sc=_dupl}', "");
    Expect(0, 113824, '\P{^Is_Sc=_dupl}', "");
    Error('\p{Script=:=--egyptian_HIEROGLYPHS}');
    Error('\P{Script=:=--egyptian_HIEROGLYPHS}');
    Expect(1, 78894, '\p{Script=egyptianhieroglyphs}', "");
    Expect(0, 78894, '\p{^Script=egyptianhieroglyphs}', "");
    Expect(0, 78894, '\P{Script=egyptianhieroglyphs}', "");
    Expect(1, 78894, '\P{^Script=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{Script=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{^Script=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{Script=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{^Script=egyptianhieroglyphs}', "");
    Expect(1, 78894, '\p{Script=_Egyptian_hieroglyphs}', "");
    Expect(0, 78894, '\p{^Script=_Egyptian_hieroglyphs}', "");
    Expect(0, 78894, '\P{Script=_Egyptian_hieroglyphs}', "");
    Expect(1, 78894, '\P{^Script=_Egyptian_hieroglyphs}', "");
    Expect(0, 78895, '\p{Script=_Egyptian_hieroglyphs}', "");
    Expect(1, 78895, '\p{^Script=_Egyptian_hieroglyphs}', "");
    Expect(1, 78895, '\P{Script=_Egyptian_hieroglyphs}', "");
    Expect(0, 78895, '\P{^Script=_Egyptian_hieroglyphs}', "");
    Error('\p{Sc=	EGYP:=}');
    Error('\P{Sc=	EGYP:=}');
    Expect(1, 78894, '\p{Sc=egyp}', "");
    Expect(0, 78894, '\p{^Sc=egyp}', "");
    Expect(0, 78894, '\P{Sc=egyp}', "");
    Expect(1, 78894, '\P{^Sc=egyp}', "");
    Expect(0, 78895, '\p{Sc=egyp}', "");
    Expect(1, 78895, '\p{^Sc=egyp}', "");
    Expect(1, 78895, '\P{Sc=egyp}', "");
    Expect(0, 78895, '\P{^Sc=egyp}', "");
    Expect(1, 78894, '\p{Sc=_-egyp}', "");
    Expect(0, 78894, '\p{^Sc=_-egyp}', "");
    Expect(0, 78894, '\P{Sc=_-egyp}', "");
    Expect(1, 78894, '\P{^Sc=_-egyp}', "");
    Expect(0, 78895, '\p{Sc=_-egyp}', "");
    Expect(1, 78895, '\p{^Sc=_-egyp}', "");
    Expect(1, 78895, '\P{Sc=_-egyp}', "");
    Expect(0, 78895, '\P{^Sc=_-egyp}', "");
    Error('\p{Is_Script=:= 	Egyptian_HIEROGLYPHS}');
    Error('\P{Is_Script=:= 	Egyptian_HIEROGLYPHS}');
    Expect(1, 78894, '\p{Is_Script=egyptianhieroglyphs}', "");
    Expect(0, 78894, '\p{^Is_Script=egyptianhieroglyphs}', "");
    Expect(0, 78894, '\P{Is_Script=egyptianhieroglyphs}', "");
    Expect(1, 78894, '\P{^Is_Script=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{Is_Script=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{^Is_Script=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{Is_Script=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{^Is_Script=egyptianhieroglyphs}', "");
    Expect(1, 78894, '\p{Is_Script=-egyptian_Hieroglyphs}', "");
    Expect(0, 78894, '\p{^Is_Script=-egyptian_Hieroglyphs}', "");
    Expect(0, 78894, '\P{Is_Script=-egyptian_Hieroglyphs}', "");
    Expect(1, 78894, '\P{^Is_Script=-egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\p{Is_Script=-egyptian_Hieroglyphs}', "");
    Expect(1, 78895, '\p{^Is_Script=-egyptian_Hieroglyphs}', "");
    Expect(1, 78895, '\P{Is_Script=-egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\P{^Is_Script=-egyptian_Hieroglyphs}', "");
    Error('\p{Is_Sc=:=  Egyp}');
    Error('\P{Is_Sc=:=  Egyp}');
    Expect(1, 78894, '\p{Is_Sc=egyp}', "");
    Expect(0, 78894, '\p{^Is_Sc=egyp}', "");
    Expect(0, 78894, '\P{Is_Sc=egyp}', "");
    Expect(1, 78894, '\P{^Is_Sc=egyp}', "");
    Expect(0, 78895, '\p{Is_Sc=egyp}', "");
    Expect(1, 78895, '\p{^Is_Sc=egyp}', "");
    Expect(1, 78895, '\P{Is_Sc=egyp}', "");
    Expect(0, 78895, '\P{^Is_Sc=egyp}', "");
    Expect(1, 78894, '\p{Is_Sc= Egyp}', "");
    Expect(0, 78894, '\p{^Is_Sc= Egyp}', "");
    Expect(0, 78894, '\P{Is_Sc= Egyp}', "");
    Expect(1, 78894, '\P{^Is_Sc= Egyp}', "");
    Expect(0, 78895, '\p{Is_Sc= Egyp}', "");
    Expect(1, 78895, '\p{^Is_Sc= Egyp}', "");
    Expect(1, 78895, '\P{Is_Sc= Egyp}', "");
    Expect(0, 78895, '\P{^Is_Sc= Egyp}', "");
    Error('\p{Script:	 elbasan:=}');
    Error('\P{Script:	 elbasan:=}');
    Expect(1, 66855, '\p{Script=elbasan}', "");
    Expect(0, 66855, '\p{^Script=elbasan}', "");
    Expect(0, 66855, '\P{Script=elbasan}', "");
    Expect(1, 66855, '\P{^Script=elbasan}', "");
    Expect(0, 66856, '\p{Script=elbasan}', "");
    Expect(1, 66856, '\p{^Script=elbasan}', "");
    Expect(1, 66856, '\P{Script=elbasan}', "");
    Expect(0, 66856, '\P{^Script=elbasan}', "");
    Expect(1, 66855, '\p{Script:   Elbasan}', "");
    Expect(0, 66855, '\p{^Script:   Elbasan}', "");
    Expect(0, 66855, '\P{Script:   Elbasan}', "");
    Expect(1, 66855, '\P{^Script:   Elbasan}', "");
    Expect(0, 66856, '\p{Script:   Elbasan}', "");
    Expect(1, 66856, '\p{^Script:   Elbasan}', "");
    Expect(1, 66856, '\P{Script:   Elbasan}', "");
    Expect(0, 66856, '\P{^Script:   Elbasan}', "");
    Error('\p{Sc: _elba/a/}');
    Error('\P{Sc: _elba/a/}');
    Expect(1, 66855, '\p{Sc=elba}', "");
    Expect(0, 66855, '\p{^Sc=elba}', "");
    Expect(0, 66855, '\P{Sc=elba}', "");
    Expect(1, 66855, '\P{^Sc=elba}', "");
    Expect(0, 66856, '\p{Sc=elba}', "");
    Expect(1, 66856, '\p{^Sc=elba}', "");
    Expect(1, 66856, '\P{Sc=elba}', "");
    Expect(0, 66856, '\P{^Sc=elba}', "");
    Expect(1, 66855, '\p{Sc=	_Elba}', "");
    Expect(0, 66855, '\p{^Sc=	_Elba}', "");
    Expect(0, 66855, '\P{Sc=	_Elba}', "");
    Expect(1, 66855, '\P{^Sc=	_Elba}', "");
    Expect(0, 66856, '\p{Sc=	_Elba}', "");
    Expect(1, 66856, '\p{^Sc=	_Elba}', "");
    Expect(1, 66856, '\P{Sc=	_Elba}', "");
    Expect(0, 66856, '\P{^Sc=	_Elba}', "");
    Error('\p{Is_Script=/a/-_elbasan}');
    Error('\P{Is_Script=/a/-_elbasan}');
    Expect(1, 66855, '\p{Is_Script=elbasan}', "");
    Expect(0, 66855, '\p{^Is_Script=elbasan}', "");
    Expect(0, 66855, '\P{Is_Script=elbasan}', "");
    Expect(1, 66855, '\P{^Is_Script=elbasan}', "");
    Expect(0, 66856, '\p{Is_Script=elbasan}', "");
    Expect(1, 66856, '\p{^Is_Script=elbasan}', "");
    Expect(1, 66856, '\P{Is_Script=elbasan}', "");
    Expect(0, 66856, '\P{^Is_Script=elbasan}', "");
    Expect(1, 66855, '\p{Is_Script= elbasan}', "");
    Expect(0, 66855, '\p{^Is_Script= elbasan}', "");
    Expect(0, 66855, '\P{Is_Script= elbasan}', "");
    Expect(1, 66855, '\P{^Is_Script= elbasan}', "");
    Expect(0, 66856, '\p{Is_Script= elbasan}', "");
    Expect(1, 66856, '\p{^Is_Script= elbasan}', "");
    Expect(1, 66856, '\P{Is_Script= elbasan}', "");
    Expect(0, 66856, '\P{^Is_Script= elbasan}', "");
    Error('\p{Is_Sc=/a/_-ELBA}');
    Error('\P{Is_Sc=/a/_-ELBA}');
    Expect(1, 66855, '\p{Is_Sc: elba}', "");
    Expect(0, 66855, '\p{^Is_Sc: elba}', "");
    Expect(0, 66855, '\P{Is_Sc: elba}', "");
    Expect(1, 66855, '\P{^Is_Sc: elba}', "");
    Expect(0, 66856, '\p{Is_Sc: elba}', "");
    Expect(1, 66856, '\p{^Is_Sc: elba}', "");
    Expect(1, 66856, '\P{Is_Sc: elba}', "");
    Expect(0, 66856, '\P{^Is_Sc: elba}', "");
    Expect(1, 66855, '\p{Is_Sc= Elba}', "");
    Expect(0, 66855, '\p{^Is_Sc= Elba}', "");
    Expect(0, 66855, '\P{Is_Sc= Elba}', "");
    Expect(1, 66855, '\P{^Is_Sc= Elba}', "");
    Expect(0, 66856, '\p{Is_Sc= Elba}', "");
    Expect(1, 66856, '\p{^Is_Sc= Elba}', "");
    Expect(1, 66856, '\P{Is_Sc= Elba}', "");
    Expect(0, 66856, '\P{^Is_Sc= Elba}', "");
    Error('\p{Script=:=	ETHIOPIC}');
    Error('\P{Script=:=	ETHIOPIC}');
    Expect(1, 43822, '\p{Script=ethiopic}', "");
    Expect(0, 43822, '\p{^Script=ethiopic}', "");
    Expect(0, 43822, '\P{Script=ethiopic}', "");
    Expect(1, 43822, '\P{^Script=ethiopic}', "");
    Expect(0, 43823, '\p{Script=ethiopic}', "");
    Expect(1, 43823, '\p{^Script=ethiopic}', "");
    Expect(1, 43823, '\P{Script=ethiopic}', "");
    Expect(0, 43823, '\P{^Script=ethiopic}', "");
    Expect(1, 43822, '\p{Script= _ethiopic}', "");
    Expect(0, 43822, '\p{^Script= _ethiopic}', "");
    Expect(0, 43822, '\P{Script= _ethiopic}', "");
    Expect(1, 43822, '\P{^Script= _ethiopic}', "");
    Expect(0, 43823, '\p{Script= _ethiopic}', "");
    Expect(1, 43823, '\p{^Script= _ethiopic}', "");
    Expect(1, 43823, '\P{Script= _ethiopic}', "");
    Expect(0, 43823, '\P{^Script= _ethiopic}', "");
    Error('\p{Sc=/a/	_ETHI}');
    Error('\P{Sc=/a/	_ETHI}');
    Expect(1, 43822, '\p{Sc=ethi}', "");
    Expect(0, 43822, '\p{^Sc=ethi}', "");
    Expect(0, 43822, '\P{Sc=ethi}', "");
    Expect(1, 43822, '\P{^Sc=ethi}', "");
    Expect(0, 43823, '\p{Sc=ethi}', "");
    Expect(1, 43823, '\p{^Sc=ethi}', "");
    Expect(1, 43823, '\P{Sc=ethi}', "");
    Expect(0, 43823, '\P{^Sc=ethi}', "");
    Expect(1, 43822, '\p{Sc= _Ethi}', "");
    Expect(0, 43822, '\p{^Sc= _Ethi}', "");
    Expect(0, 43822, '\P{Sc= _Ethi}', "");
    Expect(1, 43822, '\P{^Sc= _Ethi}', "");
    Expect(0, 43823, '\p{Sc= _Ethi}', "");
    Expect(1, 43823, '\p{^Sc= _Ethi}', "");
    Expect(1, 43823, '\P{Sc= _Ethi}', "");
    Expect(0, 43823, '\P{^Sc= _Ethi}', "");
    Error('\p{Is_Script=:=-_Ethiopic}');
    Error('\P{Is_Script=:=-_Ethiopic}');
    Expect(1, 43822, '\p{Is_Script=ethiopic}', "");
    Expect(0, 43822, '\p{^Is_Script=ethiopic}', "");
    Expect(0, 43822, '\P{Is_Script=ethiopic}', "");
    Expect(1, 43822, '\P{^Is_Script=ethiopic}', "");
    Expect(0, 43823, '\p{Is_Script=ethiopic}', "");
    Expect(1, 43823, '\p{^Is_Script=ethiopic}', "");
    Expect(1, 43823, '\P{Is_Script=ethiopic}', "");
    Expect(0, 43823, '\P{^Is_Script=ethiopic}', "");
    Expect(1, 43822, '\p{Is_Script=_ Ethiopic}', "");
    Expect(0, 43822, '\p{^Is_Script=_ Ethiopic}', "");
    Expect(0, 43822, '\P{Is_Script=_ Ethiopic}', "");
    Expect(1, 43822, '\P{^Is_Script=_ Ethiopic}', "");
    Expect(0, 43823, '\p{Is_Script=_ Ethiopic}', "");
    Expect(1, 43823, '\p{^Is_Script=_ Ethiopic}', "");
    Expect(1, 43823, '\P{Is_Script=_ Ethiopic}', "");
    Expect(0, 43823, '\P{^Is_Script=_ Ethiopic}', "");
    Error('\p{Is_Sc=	/a/Ethi}');
    Error('\P{Is_Sc=	/a/Ethi}');
    Expect(1, 43822, '\p{Is_Sc=ethi}', "");
    Expect(0, 43822, '\p{^Is_Sc=ethi}', "");
    Expect(0, 43822, '\P{Is_Sc=ethi}', "");
    Expect(1, 43822, '\P{^Is_Sc=ethi}', "");
    Expect(0, 43823, '\p{Is_Sc=ethi}', "");
    Expect(1, 43823, '\p{^Is_Sc=ethi}', "");
    Expect(1, 43823, '\P{Is_Sc=ethi}', "");
    Expect(0, 43823, '\P{^Is_Sc=ethi}', "");
    Expect(1, 43822, '\p{Is_Sc= _Ethi}', "");
    Expect(0, 43822, '\p{^Is_Sc= _Ethi}', "");
    Expect(0, 43822, '\P{Is_Sc= _Ethi}', "");
    Expect(1, 43822, '\P{^Is_Sc= _Ethi}', "");
    Expect(0, 43823, '\p{Is_Sc= _Ethi}', "");
    Expect(1, 43823, '\p{^Is_Sc= _Ethi}', "");
    Expect(1, 43823, '\P{Is_Sc= _Ethi}', "");
    Expect(0, 43823, '\P{^Is_Sc= _Ethi}', "");
    Error('\p{Script=_-Georgian/a/}');
    Error('\P{Script=_-Georgian/a/}');
    Expect(1, 11565, '\p{Script=georgian}', "");
    Expect(0, 11565, '\p{^Script=georgian}', "");
    Expect(0, 11565, '\P{Script=georgian}', "");
    Expect(1, 11565, '\P{^Script=georgian}', "");
    Expect(0, 11566, '\p{Script=georgian}', "");
    Expect(1, 11566, '\p{^Script=georgian}', "");
    Expect(1, 11566, '\P{Script=georgian}', "");
    Expect(0, 11566, '\P{^Script=georgian}', "");
    Expect(1, 11565, '\p{Script:   -Georgian}', "");
    Expect(0, 11565, '\p{^Script:   -Georgian}', "");
    Expect(0, 11565, '\P{Script:   -Georgian}', "");
    Expect(1, 11565, '\P{^Script:   -Georgian}', "");
    Expect(0, 11566, '\p{Script:   -Georgian}', "");
    Expect(1, 11566, '\p{^Script:   -Georgian}', "");
    Expect(1, 11566, '\P{Script:   -Georgian}', "");
    Expect(0, 11566, '\P{^Script:   -Georgian}', "");
    Error('\p{Sc=	GEOR:=}');
    Error('\P{Sc=	GEOR:=}');
    Expect(1, 11565, '\p{Sc:   geor}', "");
    Expect(0, 11565, '\p{^Sc:   geor}', "");
    Expect(0, 11565, '\P{Sc:   geor}', "");
    Expect(1, 11565, '\P{^Sc:   geor}', "");
    Expect(0, 11566, '\p{Sc:   geor}', "");
    Expect(1, 11566, '\p{^Sc:   geor}', "");
    Expect(1, 11566, '\P{Sc:   geor}', "");
    Expect(0, 11566, '\P{^Sc:   geor}', "");
    Expect(1, 11565, '\p{Sc:	-Geor}', "");
    Expect(0, 11565, '\p{^Sc:	-Geor}', "");
    Expect(0, 11565, '\P{Sc:	-Geor}', "");
    Expect(1, 11565, '\P{^Sc:	-Geor}', "");
    Expect(0, 11566, '\p{Sc:	-Geor}', "");
    Expect(1, 11566, '\p{^Sc:	-Geor}', "");
    Expect(1, 11566, '\P{Sc:	-Geor}', "");
    Expect(0, 11566, '\P{^Sc:	-Geor}', "");
    Error('\p{Is_Script=:=__georgian}');
    Error('\P{Is_Script=:=__georgian}');
    Expect(1, 11565, '\p{Is_Script=georgian}', "");
    Expect(0, 11565, '\p{^Is_Script=georgian}', "");
    Expect(0, 11565, '\P{Is_Script=georgian}', "");
    Expect(1, 11565, '\P{^Is_Script=georgian}', "");
    Expect(0, 11566, '\p{Is_Script=georgian}', "");
    Expect(1, 11566, '\p{^Is_Script=georgian}', "");
    Expect(1, 11566, '\P{Is_Script=georgian}', "");
    Expect(0, 11566, '\P{^Is_Script=georgian}', "");
    Expect(1, 11565, '\p{Is_Script=		Georgian}', "");
    Expect(0, 11565, '\p{^Is_Script=		Georgian}', "");
    Expect(0, 11565, '\P{Is_Script=		Georgian}', "");
    Expect(1, 11565, '\P{^Is_Script=		Georgian}', "");
    Expect(0, 11566, '\p{Is_Script=		Georgian}', "");
    Expect(1, 11566, '\p{^Is_Script=		Georgian}', "");
    Expect(1, 11566, '\P{Is_Script=		Georgian}', "");
    Expect(0, 11566, '\P{^Is_Script=		Georgian}', "");
    Error('\p{Is_Sc=_	Geor:=}');
    Error('\P{Is_Sc=_	Geor:=}');
    Expect(1, 11565, '\p{Is_Sc=geor}', "");
    Expect(0, 11565, '\p{^Is_Sc=geor}', "");
    Expect(0, 11565, '\P{Is_Sc=geor}', "");
    Expect(1, 11565, '\P{^Is_Sc=geor}', "");
    Expect(0, 11566, '\p{Is_Sc=geor}', "");
    Expect(1, 11566, '\p{^Is_Sc=geor}', "");
    Expect(1, 11566, '\P{Is_Sc=geor}', "");
    Expect(0, 11566, '\P{^Is_Sc=geor}', "");
    Expect(1, 11565, '\p{Is_Sc=_Geor}', "");
    Expect(0, 11565, '\p{^Is_Sc=_Geor}', "");
    Expect(0, 11565, '\P{Is_Sc=_Geor}', "");
    Expect(1, 11565, '\P{^Is_Sc=_Geor}', "");
    Expect(0, 11566, '\p{Is_Sc=_Geor}', "");
    Expect(1, 11566, '\p{^Is_Sc=_Geor}', "");
    Expect(1, 11566, '\P{Is_Sc=_Geor}', "");
    Expect(0, 11566, '\P{^Is_Sc=_Geor}', "");
    Error('\p{Script=	 Glagolitic/a/}');
    Error('\P{Script=	 Glagolitic/a/}');
    Expect(1, 122922, '\p{Script=glagolitic}', "");
    Expect(0, 122922, '\p{^Script=glagolitic}', "");
    Expect(0, 122922, '\P{Script=glagolitic}', "");
    Expect(1, 122922, '\P{^Script=glagolitic}', "");
    Expect(0, 122923, '\p{Script=glagolitic}', "");
    Expect(1, 122923, '\p{^Script=glagolitic}', "");
    Expect(1, 122923, '\P{Script=glagolitic}', "");
    Expect(0, 122923, '\P{^Script=glagolitic}', "");
    Expect(1, 122922, '\p{Script= Glagolitic}', "");
    Expect(0, 122922, '\p{^Script= Glagolitic}', "");
    Expect(0, 122922, '\P{Script= Glagolitic}', "");
    Expect(1, 122922, '\P{^Script= Glagolitic}', "");
    Expect(0, 122923, '\p{Script= Glagolitic}', "");
    Expect(1, 122923, '\p{^Script= Glagolitic}', "");
    Expect(1, 122923, '\P{Script= Glagolitic}', "");
    Expect(0, 122923, '\P{^Script= Glagolitic}', "");
    Error('\p{Sc=:=Glag}');
    Error('\P{Sc=:=Glag}');
    Expect(1, 122922, '\p{Sc=glag}', "");
    Expect(0, 122922, '\p{^Sc=glag}', "");
    Expect(0, 122922, '\P{Sc=glag}', "");
    Expect(1, 122922, '\P{^Sc=glag}', "");
    Expect(0, 122923, '\p{Sc=glag}', "");
    Expect(1, 122923, '\p{^Sc=glag}', "");
    Expect(1, 122923, '\P{Sc=glag}', "");
    Expect(0, 122923, '\P{^Sc=glag}', "");
    Expect(1, 122922, '\p{Sc=_	Glag}', "");
    Expect(0, 122922, '\p{^Sc=_	Glag}', "");
    Expect(0, 122922, '\P{Sc=_	Glag}', "");
    Expect(1, 122922, '\P{^Sc=_	Glag}', "");
    Expect(0, 122923, '\p{Sc=_	Glag}', "");
    Expect(1, 122923, '\p{^Sc=_	Glag}', "");
    Expect(1, 122923, '\P{Sc=_	Glag}', "");
    Expect(0, 122923, '\P{^Sc=_	Glag}', "");
    Error('\p{Is_Script=:= -Glagolitic}');
    Error('\P{Is_Script=:= -Glagolitic}');
    Expect(1, 122922, '\p{Is_Script=glagolitic}', "");
    Expect(0, 122922, '\p{^Is_Script=glagolitic}', "");
    Expect(0, 122922, '\P{Is_Script=glagolitic}', "");
    Expect(1, 122922, '\P{^Is_Script=glagolitic}', "");
    Expect(0, 122923, '\p{Is_Script=glagolitic}', "");
    Expect(1, 122923, '\p{^Is_Script=glagolitic}', "");
    Expect(1, 122923, '\P{Is_Script=glagolitic}', "");
    Expect(0, 122923, '\P{^Is_Script=glagolitic}', "");
    Expect(1, 122922, '\p{Is_Script=GLAGOLITIC}', "");
    Expect(0, 122922, '\p{^Is_Script=GLAGOLITIC}', "");
    Expect(0, 122922, '\P{Is_Script=GLAGOLITIC}', "");
    Expect(1, 122922, '\P{^Is_Script=GLAGOLITIC}', "");
    Expect(0, 122923, '\p{Is_Script=GLAGOLITIC}', "");
    Expect(1, 122923, '\p{^Is_Script=GLAGOLITIC}', "");
    Expect(1, 122923, '\P{Is_Script=GLAGOLITIC}', "");
    Expect(0, 122923, '\P{^Is_Script=GLAGOLITIC}', "");
    Error('\p{Is_Sc:	:=_-glag}');
    Error('\P{Is_Sc:	:=_-glag}');
    Expect(1, 122922, '\p{Is_Sc=glag}', "");
    Expect(0, 122922, '\p{^Is_Sc=glag}', "");
    Expect(0, 122922, '\P{Is_Sc=glag}', "");
    Expect(1, 122922, '\P{^Is_Sc=glag}', "");
    Expect(0, 122923, '\p{Is_Sc=glag}', "");
    Expect(1, 122923, '\p{^Is_Sc=glag}', "");
    Expect(1, 122923, '\P{Is_Sc=glag}', "");
    Expect(0, 122923, '\P{^Is_Sc=glag}', "");
    Expect(1, 122922, '\p{Is_Sc=	GLAG}', "");
    Expect(0, 122922, '\p{^Is_Sc=	GLAG}', "");
    Expect(0, 122922, '\P{Is_Sc=	GLAG}', "");
    Expect(1, 122922, '\P{^Is_Sc=	GLAG}', "");
    Expect(0, 122923, '\p{Is_Sc=	GLAG}', "");
    Expect(1, 122923, '\p{^Is_Sc=	GLAG}', "");
    Expect(1, 122923, '\P{Is_Sc=	GLAG}', "");
    Expect(0, 122923, '\P{^Is_Sc=	GLAG}', "");
    Error('\p{Script=:=MASARAM_Gondi}');
    Error('\P{Script=:=MASARAM_Gondi}');
    Expect(1, 73049, '\p{Script=masaramgondi}', "");
    Expect(0, 73049, '\p{^Script=masaramgondi}', "");
    Expect(0, 73049, '\P{Script=masaramgondi}', "");
    Expect(1, 73049, '\P{^Script=masaramgondi}', "");
    Expect(0, 73050, '\p{Script=masaramgondi}', "");
    Expect(1, 73050, '\p{^Script=masaramgondi}', "");
    Expect(1, 73050, '\P{Script=masaramgondi}', "");
    Expect(0, 73050, '\P{^Script=masaramgondi}', "");
    Expect(1, 73049, '\p{Script=- MASARAM_Gondi}', "");
    Expect(0, 73049, '\p{^Script=- MASARAM_Gondi}', "");
    Expect(0, 73049, '\P{Script=- MASARAM_Gondi}', "");
    Expect(1, 73049, '\P{^Script=- MASARAM_Gondi}', "");
    Expect(0, 73050, '\p{Script=- MASARAM_Gondi}', "");
    Expect(1, 73050, '\p{^Script=- MASARAM_Gondi}', "");
    Expect(1, 73050, '\P{Script=- MASARAM_Gondi}', "");
    Expect(0, 73050, '\P{^Script=- MASARAM_Gondi}', "");
    Error('\p{Sc=:= Gonm}');
    Error('\P{Sc=:= Gonm}');
    Expect(1, 73049, '\p{Sc=gonm}', "");
    Expect(0, 73049, '\p{^Sc=gonm}', "");
    Expect(0, 73049, '\P{Sc=gonm}', "");
    Expect(1, 73049, '\P{^Sc=gonm}', "");
    Expect(0, 73050, '\p{Sc=gonm}', "");
    Expect(1, 73050, '\p{^Sc=gonm}', "");
    Expect(1, 73050, '\P{Sc=gonm}', "");
    Expect(0, 73050, '\P{^Sc=gonm}', "");
    Expect(1, 73049, '\p{Sc= _gonm}', "");
    Expect(0, 73049, '\p{^Sc= _gonm}', "");
    Expect(0, 73049, '\P{Sc= _gonm}', "");
    Expect(1, 73049, '\P{^Sc= _gonm}', "");
    Expect(0, 73050, '\p{Sc= _gonm}', "");
    Expect(1, 73050, '\p{^Sc= _gonm}', "");
    Expect(1, 73050, '\P{Sc= _gonm}', "");
    Expect(0, 73050, '\P{^Sc= _gonm}', "");
    Error('\p{Is_Script=_/a/Masaram_GONDI}');
    Error('\P{Is_Script=_/a/Masaram_GONDI}');
    Expect(1, 73049, '\p{Is_Script=masaramgondi}', "");
    Expect(0, 73049, '\p{^Is_Script=masaramgondi}', "");
    Expect(0, 73049, '\P{Is_Script=masaramgondi}', "");
    Expect(1, 73049, '\P{^Is_Script=masaramgondi}', "");
    Expect(0, 73050, '\p{Is_Script=masaramgondi}', "");
    Expect(1, 73050, '\p{^Is_Script=masaramgondi}', "");
    Expect(1, 73050, '\P{Is_Script=masaramgondi}', "");
    Expect(0, 73050, '\P{^Is_Script=masaramgondi}', "");
    Expect(1, 73049, '\p{Is_Script=__MASARAM_Gondi}', "");
    Expect(0, 73049, '\p{^Is_Script=__MASARAM_Gondi}', "");
    Expect(0, 73049, '\P{Is_Script=__MASARAM_Gondi}', "");
    Expect(1, 73049, '\P{^Is_Script=__MASARAM_Gondi}', "");
    Expect(0, 73050, '\p{Is_Script=__MASARAM_Gondi}', "");
    Expect(1, 73050, '\p{^Is_Script=__MASARAM_Gondi}', "");
    Expect(1, 73050, '\P{Is_Script=__MASARAM_Gondi}', "");
    Expect(0, 73050, '\P{^Is_Script=__MASARAM_Gondi}', "");
    Error('\p{Is_Sc=/a/_Gonm}');
    Error('\P{Is_Sc=/a/_Gonm}');
    Expect(1, 73049, '\p{Is_Sc=gonm}', "");
    Expect(0, 73049, '\p{^Is_Sc=gonm}', "");
    Expect(0, 73049, '\P{Is_Sc=gonm}', "");
    Expect(1, 73049, '\P{^Is_Sc=gonm}', "");
    Expect(0, 73050, '\p{Is_Sc=gonm}', "");
    Expect(1, 73050, '\p{^Is_Sc=gonm}', "");
    Expect(1, 73050, '\P{Is_Sc=gonm}', "");
    Expect(0, 73050, '\P{^Is_Sc=gonm}', "");
    Expect(1, 73049, '\p{Is_Sc= -Gonm}', "");
    Expect(0, 73049, '\p{^Is_Sc= -Gonm}', "");
    Expect(0, 73049, '\P{Is_Sc= -Gonm}', "");
    Expect(1, 73049, '\P{^Is_Sc= -Gonm}', "");
    Expect(0, 73050, '\p{Is_Sc= -Gonm}', "");
    Expect(1, 73050, '\p{^Is_Sc= -Gonm}', "");
    Expect(1, 73050, '\P{Is_Sc= -Gonm}', "");
    Expect(0, 73050, '\P{^Is_Sc= -Gonm}', "");
    Error('\p{Script= :=Gothic}');
    Error('\P{Script= :=Gothic}');
    Expect(1, 66378, '\p{Script=gothic}', "");
    Expect(0, 66378, '\p{^Script=gothic}', "");
    Expect(0, 66378, '\P{Script=gothic}', "");
    Expect(1, 66378, '\P{^Script=gothic}', "");
    Expect(0, 66379, '\p{Script=gothic}', "");
    Expect(1, 66379, '\p{^Script=gothic}', "");
    Expect(1, 66379, '\P{Script=gothic}', "");
    Expect(0, 66379, '\P{^Script=gothic}', "");
    Expect(1, 66378, '\p{Script=-gothic}', "");
    Expect(0, 66378, '\p{^Script=-gothic}', "");
    Expect(0, 66378, '\P{Script=-gothic}', "");
    Expect(1, 66378, '\P{^Script=-gothic}', "");
    Expect(0, 66379, '\p{Script=-gothic}', "");
    Expect(1, 66379, '\p{^Script=-gothic}', "");
    Expect(1, 66379, '\P{Script=-gothic}', "");
    Expect(0, 66379, '\P{^Script=-gothic}', "");
    Error('\p{Sc:	/a/-_goth}');
    Error('\P{Sc:	/a/-_goth}');
    Expect(1, 66378, '\p{Sc=goth}', "");
    Expect(0, 66378, '\p{^Sc=goth}', "");
    Expect(0, 66378, '\P{Sc=goth}', "");
    Expect(1, 66378, '\P{^Sc=goth}', "");
    Expect(0, 66379, '\p{Sc=goth}', "");
    Expect(1, 66379, '\p{^Sc=goth}', "");
    Expect(1, 66379, '\P{Sc=goth}', "");
    Expect(0, 66379, '\P{^Sc=goth}', "");
    Expect(1, 66378, '\p{Sc=-_Goth}', "");
    Expect(0, 66378, '\p{^Sc=-_Goth}', "");
    Expect(0, 66378, '\P{Sc=-_Goth}', "");
    Expect(1, 66378, '\P{^Sc=-_Goth}', "");
    Expect(0, 66379, '\p{Sc=-_Goth}', "");
    Expect(1, 66379, '\p{^Sc=-_Goth}', "");
    Expect(1, 66379, '\P{Sc=-_Goth}', "");
    Expect(0, 66379, '\P{^Sc=-_Goth}', "");
    Error('\p{Is_Script=	:=gothic}');
    Error('\P{Is_Script=	:=gothic}');
    Expect(1, 66378, '\p{Is_Script=gothic}', "");
    Expect(0, 66378, '\p{^Is_Script=gothic}', "");
    Expect(0, 66378, '\P{Is_Script=gothic}', "");
    Expect(1, 66378, '\P{^Is_Script=gothic}', "");
    Expect(0, 66379, '\p{Is_Script=gothic}', "");
    Expect(1, 66379, '\p{^Is_Script=gothic}', "");
    Expect(1, 66379, '\P{Is_Script=gothic}', "");
    Expect(0, 66379, '\P{^Is_Script=gothic}', "");
    Expect(1, 66378, '\p{Is_Script=		gothic}', "");
    Expect(0, 66378, '\p{^Is_Script=		gothic}', "");
    Expect(0, 66378, '\P{Is_Script=		gothic}', "");
    Expect(1, 66378, '\P{^Is_Script=		gothic}', "");
    Expect(0, 66379, '\p{Is_Script=		gothic}', "");
    Expect(1, 66379, '\p{^Is_Script=		gothic}', "");
    Expect(1, 66379, '\P{Is_Script=		gothic}', "");
    Expect(0, 66379, '\P{^Is_Script=		gothic}', "");
    Error('\p{Is_Sc:	:=__goth}');
    Error('\P{Is_Sc:	:=__goth}');
    Expect(1, 66378, '\p{Is_Sc=goth}', "");
    Expect(0, 66378, '\p{^Is_Sc=goth}', "");
    Expect(0, 66378, '\P{Is_Sc=goth}', "");
    Expect(1, 66378, '\P{^Is_Sc=goth}', "");
    Expect(0, 66379, '\p{Is_Sc=goth}', "");
    Expect(1, 66379, '\p{^Is_Sc=goth}', "");
    Expect(1, 66379, '\P{Is_Sc=goth}', "");
    Expect(0, 66379, '\P{^Is_Sc=goth}', "");
    Expect(1, 66378, '\p{Is_Sc=-Goth}', "");
    Expect(0, 66378, '\p{^Is_Sc=-Goth}', "");
    Expect(0, 66378, '\P{Is_Sc=-Goth}', "");
    Expect(1, 66378, '\P{^Is_Sc=-Goth}', "");
    Expect(0, 66379, '\p{Is_Sc=-Goth}', "");
    Expect(1, 66379, '\p{^Is_Sc=-Goth}', "");
    Expect(1, 66379, '\P{Is_Sc=-Goth}', "");
    Expect(0, 66379, '\P{^Is_Sc=-Goth}', "");
    Error('\p{Script=:=	GRANTHA}');
    Error('\P{Script=:=	GRANTHA}');
    Expect(1, 70516, '\p{Script=grantha}', "");
    Expect(0, 70516, '\p{^Script=grantha}', "");
    Expect(0, 70516, '\P{Script=grantha}', "");
    Expect(1, 70516, '\P{^Script=grantha}', "");
    Expect(0, 70517, '\p{Script=grantha}', "");
    Expect(1, 70517, '\p{^Script=grantha}', "");
    Expect(1, 70517, '\P{Script=grantha}', "");
    Expect(0, 70517, '\P{^Script=grantha}', "");
    Expect(1, 70516, '\p{Script=-grantha}', "");
    Expect(0, 70516, '\p{^Script=-grantha}', "");
    Expect(0, 70516, '\P{Script=-grantha}', "");
    Expect(1, 70516, '\P{^Script=-grantha}', "");
    Expect(0, 70517, '\p{Script=-grantha}', "");
    Expect(1, 70517, '\p{^Script=-grantha}', "");
    Expect(1, 70517, '\P{Script=-grantha}', "");
    Expect(0, 70517, '\P{^Script=-grantha}', "");
    Error('\p{Sc=_gran:=}');
    Error('\P{Sc=_gran:=}');
    Expect(1, 70516, '\p{Sc=gran}', "");
    Expect(0, 70516, '\p{^Sc=gran}', "");
    Expect(0, 70516, '\P{Sc=gran}', "");
    Expect(1, 70516, '\P{^Sc=gran}', "");
    Expect(0, 70517, '\p{Sc=gran}', "");
    Expect(1, 70517, '\p{^Sc=gran}', "");
    Expect(1, 70517, '\P{Sc=gran}', "");
    Expect(0, 70517, '\P{^Sc=gran}', "");
    Expect(1, 70516, '\p{Sc= gran}', "");
    Expect(0, 70516, '\p{^Sc= gran}', "");
    Expect(0, 70516, '\P{Sc= gran}', "");
    Expect(1, 70516, '\P{^Sc= gran}', "");
    Expect(0, 70517, '\p{Sc= gran}', "");
    Expect(1, 70517, '\p{^Sc= gran}', "");
    Expect(1, 70517, '\P{Sc= gran}', "");
    Expect(0, 70517, '\P{^Sc= gran}', "");
    Error('\p{Is_Script=	_Grantha/a/}');
    Error('\P{Is_Script=	_Grantha/a/}');
    Expect(1, 70516, '\p{Is_Script=grantha}', "");
    Expect(0, 70516, '\p{^Is_Script=grantha}', "");
    Expect(0, 70516, '\P{Is_Script=grantha}', "");
    Expect(1, 70516, '\P{^Is_Script=grantha}', "");
    Expect(0, 70517, '\p{Is_Script=grantha}', "");
    Expect(1, 70517, '\p{^Is_Script=grantha}', "");
    Expect(1, 70517, '\P{Is_Script=grantha}', "");
    Expect(0, 70517, '\P{^Is_Script=grantha}', "");
    Expect(1, 70516, '\p{Is_Script= -grantha}', "");
    Expect(0, 70516, '\p{^Is_Script= -grantha}', "");
    Expect(0, 70516, '\P{Is_Script= -grantha}', "");
    Expect(1, 70516, '\P{^Is_Script= -grantha}', "");
    Expect(0, 70517, '\p{Is_Script= -grantha}', "");
    Expect(1, 70517, '\p{^Is_Script= -grantha}', "");
    Expect(1, 70517, '\P{Is_Script= -grantha}', "");
    Expect(0, 70517, '\P{^Is_Script= -grantha}', "");
    Error('\p{Is_Sc=/a/ Gran}');
    Error('\P{Is_Sc=/a/ Gran}');
    Expect(1, 70516, '\p{Is_Sc=gran}', "");
    Expect(0, 70516, '\p{^Is_Sc=gran}', "");
    Expect(0, 70516, '\P{Is_Sc=gran}', "");
    Expect(1, 70516, '\P{^Is_Sc=gran}', "");
    Expect(0, 70517, '\p{Is_Sc=gran}', "");
    Expect(1, 70517, '\p{^Is_Sc=gran}', "");
    Expect(1, 70517, '\P{Is_Sc=gran}', "");
    Expect(0, 70517, '\P{^Is_Sc=gran}', "");
    Expect(1, 70516, '\p{Is_Sc= Gran}', "");
    Expect(0, 70516, '\p{^Is_Sc= Gran}', "");
    Expect(0, 70516, '\P{Is_Sc= Gran}', "");
    Expect(1, 70516, '\P{^Is_Sc= Gran}', "");
    Expect(0, 70517, '\p{Is_Sc= Gran}', "");
    Expect(1, 70517, '\p{^Is_Sc= Gran}', "");
    Expect(1, 70517, '\P{Is_Sc= Gran}', "");
    Expect(0, 70517, '\P{^Is_Sc= Gran}', "");
    Error('\p{Script:	_:=Greek}');
    Error('\P{Script:	_:=Greek}');
    Expect(1, 119365, '\p{Script=greek}', "");
    Expect(0, 119365, '\p{^Script=greek}', "");
    Expect(0, 119365, '\P{Script=greek}', "");
    Expect(1, 119365, '\P{^Script=greek}', "");
    Expect(0, 119366, '\p{Script=greek}', "");
    Expect(1, 119366, '\p{^Script=greek}', "");
    Expect(1, 119366, '\P{Script=greek}', "");
    Expect(0, 119366, '\P{^Script=greek}', "");
    Expect(1, 119365, '\p{Script=_greek}', "");
    Expect(0, 119365, '\p{^Script=_greek}', "");
    Expect(0, 119365, '\P{Script=_greek}', "");
    Expect(1, 119365, '\P{^Script=_greek}', "");
    Expect(0, 119366, '\p{Script=_greek}', "");
    Expect(1, 119366, '\p{^Script=_greek}', "");
    Expect(1, 119366, '\P{Script=_greek}', "");
    Expect(0, 119366, '\P{^Script=_greek}', "");
    Error('\p{Sc=grek:=}');
    Error('\P{Sc=grek:=}');
    Expect(1, 119365, '\p{Sc=grek}', "");
    Expect(0, 119365, '\p{^Sc=grek}', "");
    Expect(0, 119365, '\P{Sc=grek}', "");
    Expect(1, 119365, '\P{^Sc=grek}', "");
    Expect(0, 119366, '\p{Sc=grek}', "");
    Expect(1, 119366, '\p{^Sc=grek}', "");
    Expect(1, 119366, '\P{Sc=grek}', "");
    Expect(0, 119366, '\P{^Sc=grek}', "");
    Expect(1, 119365, '\p{Sc=_	grek}', "");
    Expect(0, 119365, '\p{^Sc=_	grek}', "");
    Expect(0, 119365, '\P{Sc=_	grek}', "");
    Expect(1, 119365, '\P{^Sc=_	grek}', "");
    Expect(0, 119366, '\p{Sc=_	grek}', "");
    Expect(1, 119366, '\p{^Sc=_	grek}', "");
    Expect(1, 119366, '\P{Sc=_	grek}', "");
    Expect(0, 119366, '\P{^Sc=_	grek}', "");
    Error('\p{Is_Script=-greek:=}');
    Error('\P{Is_Script=-greek:=}');
    Expect(1, 119365, '\p{Is_Script=greek}', "");
    Expect(0, 119365, '\p{^Is_Script=greek}', "");
    Expect(0, 119365, '\P{Is_Script=greek}', "");
    Expect(1, 119365, '\P{^Is_Script=greek}', "");
    Expect(0, 119366, '\p{Is_Script=greek}', "");
    Expect(1, 119366, '\p{^Is_Script=greek}', "");
    Expect(1, 119366, '\P{Is_Script=greek}', "");
    Expect(0, 119366, '\P{^Is_Script=greek}', "");
    Expect(1, 119365, '\p{Is_Script= 	greek}', "");
    Expect(0, 119365, '\p{^Is_Script= 	greek}', "");
    Expect(0, 119365, '\P{Is_Script= 	greek}', "");
    Expect(1, 119365, '\P{^Is_Script= 	greek}', "");
    Expect(0, 119366, '\p{Is_Script= 	greek}', "");
    Expect(1, 119366, '\p{^Is_Script= 	greek}', "");
    Expect(1, 119366, '\P{Is_Script= 	greek}', "");
    Expect(0, 119366, '\P{^Is_Script= 	greek}', "");
    Error('\p{Is_Sc= /a/Grek}');
    Error('\P{Is_Sc= /a/Grek}');
    Expect(1, 119365, '\p{Is_Sc=grek}', "");
    Expect(0, 119365, '\p{^Is_Sc=grek}', "");
    Expect(0, 119365, '\P{Is_Sc=grek}', "");
    Expect(1, 119365, '\P{^Is_Sc=grek}', "");
    Expect(0, 119366, '\p{Is_Sc=grek}', "");
    Expect(1, 119366, '\p{^Is_Sc=grek}', "");
    Expect(1, 119366, '\P{Is_Sc=grek}', "");
    Expect(0, 119366, '\P{^Is_Sc=grek}', "");
    Expect(1, 119365, '\p{Is_Sc=_	Grek}', "");
    Expect(0, 119365, '\p{^Is_Sc=_	Grek}', "");
    Expect(0, 119365, '\P{Is_Sc=_	Grek}', "");
    Expect(1, 119365, '\P{^Is_Sc=_	Grek}', "");
    Expect(0, 119366, '\p{Is_Sc=_	Grek}', "");
    Expect(1, 119366, '\p{^Is_Sc=_	Grek}', "");
    Expect(1, 119366, '\P{Is_Sc=_	Grek}', "");
    Expect(0, 119366, '\P{^Is_Sc=_	Grek}', "");
    Error('\p{Script=/a/GUJARATI}');
    Error('\P{Script=/a/GUJARATI}');
    Expect(1, 2815, '\p{Script=gujarati}', "");
    Expect(0, 2815, '\p{^Script=gujarati}', "");
    Expect(0, 2815, '\P{Script=gujarati}', "");
    Expect(1, 2815, '\P{^Script=gujarati}', "");
    Expect(0, 2816, '\p{Script=gujarati}', "");
    Expect(1, 2816, '\p{^Script=gujarati}', "");
    Expect(1, 2816, '\P{Script=gujarati}', "");
    Expect(0, 2816, '\P{^Script=gujarati}', "");
    Expect(1, 2815, '\p{Script=__Gujarati}', "");
    Expect(0, 2815, '\p{^Script=__Gujarati}', "");
    Expect(0, 2815, '\P{Script=__Gujarati}', "");
    Expect(1, 2815, '\P{^Script=__Gujarati}', "");
    Expect(0, 2816, '\p{Script=__Gujarati}', "");
    Expect(1, 2816, '\p{^Script=__Gujarati}', "");
    Expect(1, 2816, '\P{Script=__Gujarati}', "");
    Expect(0, 2816, '\P{^Script=__Gujarati}', "");
    Error('\p{Sc=-	Gujr/a/}');
    Error('\P{Sc=-	Gujr/a/}');
    Expect(1, 2815, '\p{Sc=gujr}', "");
    Expect(0, 2815, '\p{^Sc=gujr}', "");
    Expect(0, 2815, '\P{Sc=gujr}', "");
    Expect(1, 2815, '\P{^Sc=gujr}', "");
    Expect(0, 2816, '\p{Sc=gujr}', "");
    Expect(1, 2816, '\p{^Sc=gujr}', "");
    Expect(1, 2816, '\P{Sc=gujr}', "");
    Expect(0, 2816, '\P{^Sc=gujr}', "");
    Expect(1, 2815, '\p{Sc=	-Gujr}', "");
    Expect(0, 2815, '\p{^Sc=	-Gujr}', "");
    Expect(0, 2815, '\P{Sc=	-Gujr}', "");
    Expect(1, 2815, '\P{^Sc=	-Gujr}', "");
    Expect(0, 2816, '\p{Sc=	-Gujr}', "");
    Expect(1, 2816, '\p{^Sc=	-Gujr}', "");
    Expect(1, 2816, '\P{Sc=	-Gujr}', "");
    Expect(0, 2816, '\P{^Sc=	-Gujr}', "");
    Error('\p{Is_Script= 	GUJARATI/a/}');
    Error('\P{Is_Script= 	GUJARATI/a/}');
    Expect(1, 2815, '\p{Is_Script=gujarati}', "");
    Expect(0, 2815, '\p{^Is_Script=gujarati}', "");
    Expect(0, 2815, '\P{Is_Script=gujarati}', "");
    Expect(1, 2815, '\P{^Is_Script=gujarati}', "");
    Expect(0, 2816, '\p{Is_Script=gujarati}', "");
    Expect(1, 2816, '\p{^Is_Script=gujarati}', "");
    Expect(1, 2816, '\P{Is_Script=gujarati}', "");
    Expect(0, 2816, '\P{^Is_Script=gujarati}', "");
    Expect(1, 2815, '\p{Is_Script=	_GUJARATI}', "");
    Expect(0, 2815, '\p{^Is_Script=	_GUJARATI}', "");
    Expect(0, 2815, '\P{Is_Script=	_GUJARATI}', "");
    Expect(1, 2815, '\P{^Is_Script=	_GUJARATI}', "");
    Expect(0, 2816, '\p{Is_Script=	_GUJARATI}', "");
    Expect(1, 2816, '\p{^Is_Script=	_GUJARATI}', "");
    Expect(1, 2816, '\P{Is_Script=	_GUJARATI}', "");
    Expect(0, 2816, '\P{^Is_Script=	_GUJARATI}', "");
    Error('\p{Is_Sc=/a/ 	GUJR}');
    Error('\P{Is_Sc=/a/ 	GUJR}');
    Expect(1, 2815, '\p{Is_Sc=gujr}', "");
    Expect(0, 2815, '\p{^Is_Sc=gujr}', "");
    Expect(0, 2815, '\P{Is_Sc=gujr}', "");
    Expect(1, 2815, '\P{^Is_Sc=gujr}', "");
    Expect(0, 2816, '\p{Is_Sc=gujr}', "");
    Expect(1, 2816, '\p{^Is_Sc=gujr}', "");
    Expect(1, 2816, '\P{Is_Sc=gujr}', "");
    Expect(0, 2816, '\P{^Is_Sc=gujr}', "");
    Expect(1, 2815, '\p{Is_Sc=Gujr}', "");
    Expect(0, 2815, '\p{^Is_Sc=Gujr}', "");
    Expect(0, 2815, '\P{Is_Sc=Gujr}', "");
    Expect(1, 2815, '\P{^Is_Sc=Gujr}', "");
    Expect(0, 2816, '\p{Is_Sc=Gujr}', "");
    Expect(1, 2816, '\p{^Is_Sc=Gujr}', "");
    Expect(1, 2816, '\P{Is_Sc=Gujr}', "");
    Expect(0, 2816, '\P{^Is_Sc=Gujr}', "");
    Error('\p{Script= _gurmukhi/a/}');
    Error('\P{Script= _gurmukhi/a/}');
    Expect(1, 2677, '\p{Script=gurmukhi}', "");
    Expect(0, 2677, '\p{^Script=gurmukhi}', "");
    Expect(0, 2677, '\P{Script=gurmukhi}', "");
    Expect(1, 2677, '\P{^Script=gurmukhi}', "");
    Expect(0, 2678, '\p{Script=gurmukhi}', "");
    Expect(1, 2678, '\p{^Script=gurmukhi}', "");
    Expect(1, 2678, '\P{Script=gurmukhi}', "");
    Expect(0, 2678, '\P{^Script=gurmukhi}', "");
    Expect(1, 2677, '\p{Script=--gurmukhi}', "");
    Expect(0, 2677, '\p{^Script=--gurmukhi}', "");
    Expect(0, 2677, '\P{Script=--gurmukhi}', "");
    Expect(1, 2677, '\P{^Script=--gurmukhi}', "");
    Expect(0, 2678, '\p{Script=--gurmukhi}', "");
    Expect(1, 2678, '\p{^Script=--gurmukhi}', "");
    Expect(1, 2678, '\P{Script=--gurmukhi}', "");
    Expect(0, 2678, '\P{^Script=--gurmukhi}', "");
    Error('\p{Sc:	-:=Guru}');
    Error('\P{Sc:	-:=Guru}');
    Expect(1, 2677, '\p{Sc=guru}', "");
    Expect(0, 2677, '\p{^Sc=guru}', "");
    Expect(0, 2677, '\P{Sc=guru}', "");
    Expect(1, 2677, '\P{^Sc=guru}', "");
    Expect(0, 2678, '\p{Sc=guru}', "");
    Expect(1, 2678, '\p{^Sc=guru}', "");
    Expect(1, 2678, '\P{Sc=guru}', "");
    Expect(0, 2678, '\P{^Sc=guru}', "");
    Expect(1, 2677, '\p{Sc=	guru}', "");
    Expect(0, 2677, '\p{^Sc=	guru}', "");
    Expect(0, 2677, '\P{Sc=	guru}', "");
    Expect(1, 2677, '\P{^Sc=	guru}', "");
    Expect(0, 2678, '\p{Sc=	guru}', "");
    Expect(1, 2678, '\p{^Sc=	guru}', "");
    Expect(1, 2678, '\P{Sc=	guru}', "");
    Expect(0, 2678, '\P{^Sc=	guru}', "");
    Error('\p{Is_Script=_/a/GURMUKHI}');
    Error('\P{Is_Script=_/a/GURMUKHI}');
    Expect(1, 2677, '\p{Is_Script=gurmukhi}', "");
    Expect(0, 2677, '\p{^Is_Script=gurmukhi}', "");
    Expect(0, 2677, '\P{Is_Script=gurmukhi}', "");
    Expect(1, 2677, '\P{^Is_Script=gurmukhi}', "");
    Expect(0, 2678, '\p{Is_Script=gurmukhi}', "");
    Expect(1, 2678, '\p{^Is_Script=gurmukhi}', "");
    Expect(1, 2678, '\P{Is_Script=gurmukhi}', "");
    Expect(0, 2678, '\P{^Is_Script=gurmukhi}', "");
    Expect(1, 2677, '\p{Is_Script= -Gurmukhi}', "");
    Expect(0, 2677, '\p{^Is_Script= -Gurmukhi}', "");
    Expect(0, 2677, '\P{Is_Script= -Gurmukhi}', "");
    Expect(1, 2677, '\P{^Is_Script= -Gurmukhi}', "");
    Expect(0, 2678, '\p{Is_Script= -Gurmukhi}', "");
    Expect(1, 2678, '\p{^Is_Script= -Gurmukhi}', "");
    Expect(1, 2678, '\P{Is_Script= -Gurmukhi}', "");
    Expect(0, 2678, '\P{^Is_Script= -Gurmukhi}', "");
    Error('\p{Is_Sc=:= -Guru}');
    Error('\P{Is_Sc=:= -Guru}');
    Expect(1, 2677, '\p{Is_Sc=guru}', "");
    Expect(0, 2677, '\p{^Is_Sc=guru}', "");
    Expect(0, 2677, '\P{Is_Sc=guru}', "");
    Expect(1, 2677, '\P{^Is_Sc=guru}', "");
    Expect(0, 2678, '\p{Is_Sc=guru}', "");
    Expect(1, 2678, '\p{^Is_Sc=guru}', "");
    Expect(1, 2678, '\P{Is_Sc=guru}', "");
    Expect(0, 2678, '\P{^Is_Sc=guru}', "");
    Expect(1, 2677, '\p{Is_Sc: 	-guru}', "");
    Expect(0, 2677, '\p{^Is_Sc: 	-guru}', "");
    Expect(0, 2677, '\P{Is_Sc: 	-guru}', "");
    Expect(1, 2677, '\P{^Is_Sc: 	-guru}', "");
    Expect(0, 2678, '\p{Is_Sc: 	-guru}', "");
    Expect(1, 2678, '\p{^Is_Sc: 	-guru}', "");
    Expect(1, 2678, '\P{Is_Sc: 	-guru}', "");
    Expect(0, 2678, '\P{^Is_Sc: 	-guru}', "");
    Error('\p{Script=/a/ _Hangul}');
    Error('\P{Script=/a/ _Hangul}');
    Expect(1, 65500, '\p{Script=hangul}', "");
    Expect(0, 65500, '\p{^Script=hangul}', "");
    Expect(0, 65500, '\P{Script=hangul}', "");
    Expect(1, 65500, '\P{^Script=hangul}', "");
    Expect(0, 65501, '\p{Script=hangul}', "");
    Expect(1, 65501, '\p{^Script=hangul}', "");
    Expect(1, 65501, '\P{Script=hangul}', "");
    Expect(0, 65501, '\P{^Script=hangul}', "");
    Expect(1, 65500, '\p{Script:-_HANGUL}', "");
    Expect(0, 65500, '\p{^Script:-_HANGUL}', "");
    Expect(0, 65500, '\P{Script:-_HANGUL}', "");
    Expect(1, 65500, '\P{^Script:-_HANGUL}', "");
    Expect(0, 65501, '\p{Script:-_HANGUL}', "");
    Expect(1, 65501, '\p{^Script:-_HANGUL}', "");
    Expect(1, 65501, '\P{Script:-_HANGUL}', "");
    Expect(0, 65501, '\P{^Script:-_HANGUL}', "");
    Error('\p{Sc=:=_ HANG}');
    Error('\P{Sc=:=_ HANG}');
    Expect(1, 65500, '\p{Sc:   hang}', "");
    Expect(0, 65500, '\p{^Sc:   hang}', "");
    Expect(0, 65500, '\P{Sc:   hang}', "");
    Expect(1, 65500, '\P{^Sc:   hang}', "");
    Expect(0, 65501, '\p{Sc:   hang}', "");
    Expect(1, 65501, '\p{^Sc:   hang}', "");
    Expect(1, 65501, '\P{Sc:   hang}', "");
    Expect(0, 65501, '\P{^Sc:   hang}', "");
    Expect(1, 65500, '\p{Sc=_-HANG}', "");
    Expect(0, 65500, '\p{^Sc=_-HANG}', "");
    Expect(0, 65500, '\P{Sc=_-HANG}', "");
    Expect(1, 65500, '\P{^Sc=_-HANG}', "");
    Expect(0, 65501, '\p{Sc=_-HANG}', "");
    Expect(1, 65501, '\p{^Sc=_-HANG}', "");
    Expect(1, 65501, '\P{Sc=_-HANG}', "");
    Expect(0, 65501, '\P{^Sc=_-HANG}', "");
    Error('\p{Is_Script=/a/ 	HANGUL}');
    Error('\P{Is_Script=/a/ 	HANGUL}');
    Expect(1, 65500, '\p{Is_Script=hangul}', "");
    Expect(0, 65500, '\p{^Is_Script=hangul}', "");
    Expect(0, 65500, '\P{Is_Script=hangul}', "");
    Expect(1, 65500, '\P{^Is_Script=hangul}', "");
    Expect(0, 65501, '\p{Is_Script=hangul}', "");
    Expect(1, 65501, '\p{^Is_Script=hangul}', "");
    Expect(1, 65501, '\P{Is_Script=hangul}', "");
    Expect(0, 65501, '\P{^Is_Script=hangul}', "");
    Expect(1, 65500, '\p{Is_Script=  Hangul}', "");
    Expect(0, 65500, '\p{^Is_Script=  Hangul}', "");
    Expect(0, 65500, '\P{Is_Script=  Hangul}', "");
    Expect(1, 65500, '\P{^Is_Script=  Hangul}', "");
    Expect(0, 65501, '\p{Is_Script=  Hangul}', "");
    Expect(1, 65501, '\p{^Is_Script=  Hangul}', "");
    Expect(1, 65501, '\P{Is_Script=  Hangul}', "");
    Expect(0, 65501, '\P{^Is_Script=  Hangul}', "");
    Error('\p{Is_Sc=-/a/hang}');
    Error('\P{Is_Sc=-/a/hang}');
    Expect(1, 65500, '\p{Is_Sc=hang}', "");
    Expect(0, 65500, '\p{^Is_Sc=hang}', "");
    Expect(0, 65500, '\P{Is_Sc=hang}', "");
    Expect(1, 65500, '\P{^Is_Sc=hang}', "");
    Expect(0, 65501, '\p{Is_Sc=hang}', "");
    Expect(1, 65501, '\p{^Is_Sc=hang}', "");
    Expect(1, 65501, '\P{Is_Sc=hang}', "");
    Expect(0, 65501, '\P{^Is_Sc=hang}', "");
    Expect(1, 65500, '\p{Is_Sc=	-Hang}', "");
    Expect(0, 65500, '\p{^Is_Sc=	-Hang}', "");
    Expect(0, 65500, '\P{Is_Sc=	-Hang}', "");
    Expect(1, 65500, '\P{^Is_Sc=	-Hang}', "");
    Expect(0, 65501, '\p{Is_Sc=	-Hang}', "");
    Expect(1, 65501, '\p{^Is_Sc=	-Hang}', "");
    Expect(1, 65501, '\P{Is_Sc=	-Hang}', "");
    Expect(0, 65501, '\P{^Is_Sc=	-Hang}', "");
    Error('\p{Script=-:=Han}');
    Error('\P{Script=-:=Han}');
    Expect(1, 195101, '\p{Script=han}', "");
    Expect(0, 195101, '\p{^Script=han}', "");
    Expect(0, 195101, '\P{Script=han}', "");
    Expect(1, 195101, '\P{^Script=han}', "");
    Expect(0, 195102, '\p{Script=han}', "");
    Expect(1, 195102, '\p{^Script=han}', "");
    Expect(1, 195102, '\P{Script=han}', "");
    Expect(0, 195102, '\P{^Script=han}', "");
    Expect(1, 195101, '\p{Script=_	HAN}', "");
    Expect(0, 195101, '\p{^Script=_	HAN}', "");
    Expect(0, 195101, '\P{Script=_	HAN}', "");
    Expect(1, 195101, '\P{^Script=_	HAN}', "");
    Expect(0, 195102, '\p{Script=_	HAN}', "");
    Expect(1, 195102, '\p{^Script=_	HAN}', "");
    Expect(1, 195102, '\P{Script=_	HAN}', "");
    Expect(0, 195102, '\P{^Script=_	HAN}', "");
    Error('\p{Sc=/a/_hani}');
    Error('\P{Sc=/a/_hani}');
    Expect(1, 195101, '\p{Sc=hani}', "");
    Expect(0, 195101, '\p{^Sc=hani}', "");
    Expect(0, 195101, '\P{Sc=hani}', "");
    Expect(1, 195101, '\P{^Sc=hani}', "");
    Expect(0, 195102, '\p{Sc=hani}', "");
    Expect(1, 195102, '\p{^Sc=hani}', "");
    Expect(1, 195102, '\P{Sc=hani}', "");
    Expect(0, 195102, '\P{^Sc=hani}', "");
    Expect(1, 195101, '\p{Sc:_-Hani}', "");
    Expect(0, 195101, '\p{^Sc:_-Hani}', "");
    Expect(0, 195101, '\P{Sc:_-Hani}', "");
    Expect(1, 195101, '\P{^Sc:_-Hani}', "");
    Expect(0, 195102, '\p{Sc:_-Hani}', "");
    Expect(1, 195102, '\p{^Sc:_-Hani}', "");
    Expect(1, 195102, '\P{Sc:_-Hani}', "");
    Expect(0, 195102, '\P{^Sc:_-Hani}', "");
    Error('\p{Is_Script=-:=HAN}');
    Error('\P{Is_Script=-:=HAN}');
    Expect(1, 195101, '\p{Is_Script:han}', "");
    Expect(0, 195101, '\p{^Is_Script:han}', "");
    Expect(0, 195101, '\P{Is_Script:han}', "");
    Expect(1, 195101, '\P{^Is_Script:han}', "");
    Expect(0, 195102, '\p{Is_Script:han}', "");
    Expect(1, 195102, '\p{^Is_Script:han}', "");
    Expect(1, 195102, '\P{Is_Script:han}', "");
    Expect(0, 195102, '\P{^Is_Script:han}', "");
    Expect(1, 195101, '\p{Is_Script=- Han}', "");
    Expect(0, 195101, '\p{^Is_Script=- Han}', "");
    Expect(0, 195101, '\P{Is_Script=- Han}', "");
    Expect(1, 195101, '\P{^Is_Script=- Han}', "");
    Expect(0, 195102, '\p{Is_Script=- Han}', "");
    Expect(1, 195102, '\p{^Is_Script=- Han}', "");
    Expect(1, 195102, '\P{Is_Script=- Han}', "");
    Expect(0, 195102, '\P{^Is_Script=- Han}', "");
    Error('\p{Is_Sc=	 HANI:=}');
    Error('\P{Is_Sc=	 HANI:=}');
    Expect(1, 195101, '\p{Is_Sc=hani}', "");
    Expect(0, 195101, '\p{^Is_Sc=hani}', "");
    Expect(0, 195101, '\P{Is_Sc=hani}', "");
    Expect(1, 195101, '\P{^Is_Sc=hani}', "");
    Expect(0, 195102, '\p{Is_Sc=hani}', "");
    Expect(1, 195102, '\p{^Is_Sc=hani}', "");
    Expect(1, 195102, '\P{Is_Sc=hani}', "");
    Expect(0, 195102, '\P{^Is_Sc=hani}', "");
    Expect(1, 195101, '\p{Is_Sc=-hani}', "");
    Expect(0, 195101, '\p{^Is_Sc=-hani}', "");
    Expect(0, 195101, '\P{Is_Sc=-hani}', "");
    Expect(1, 195101, '\P{^Is_Sc=-hani}', "");
    Expect(0, 195102, '\p{Is_Sc=-hani}', "");
    Expect(1, 195102, '\p{^Is_Sc=-hani}', "");
    Expect(1, 195102, '\P{Is_Sc=-hani}', "");
    Expect(0, 195102, '\P{^Is_Sc=-hani}', "");
    Error('\p{Script=Hanunoo/a/}');
    Error('\P{Script=Hanunoo/a/}');
    Expect(1, 5940, '\p{Script=hanunoo}', "");
    Expect(0, 5940, '\p{^Script=hanunoo}', "");
    Expect(0, 5940, '\P{Script=hanunoo}', "");
    Expect(1, 5940, '\P{^Script=hanunoo}', "");
    Expect(0, 5941, '\p{Script=hanunoo}', "");
    Expect(1, 5941, '\p{^Script=hanunoo}', "");
    Expect(1, 5941, '\P{Script=hanunoo}', "");
    Expect(0, 5941, '\P{^Script=hanunoo}', "");
    Expect(1, 5940, '\p{Script= _hanunoo}', "");
    Expect(0, 5940, '\p{^Script= _hanunoo}', "");
    Expect(0, 5940, '\P{Script= _hanunoo}', "");
    Expect(1, 5940, '\P{^Script= _hanunoo}', "");
    Expect(0, 5941, '\p{Script= _hanunoo}', "");
    Expect(1, 5941, '\p{^Script= _hanunoo}', "");
    Expect(1, 5941, '\P{Script= _hanunoo}', "");
    Expect(0, 5941, '\P{^Script= _hanunoo}', "");
    Error('\p{Sc=:=  hano}');
    Error('\P{Sc=:=  hano}');
    Expect(1, 5940, '\p{Sc=hano}', "");
    Expect(0, 5940, '\p{^Sc=hano}', "");
    Expect(0, 5940, '\P{Sc=hano}', "");
    Expect(1, 5940, '\P{^Sc=hano}', "");
    Expect(0, 5941, '\p{Sc=hano}', "");
    Expect(1, 5941, '\p{^Sc=hano}', "");
    Expect(1, 5941, '\P{Sc=hano}', "");
    Expect(0, 5941, '\P{^Sc=hano}', "");
    Expect(1, 5940, '\p{Sc=-_hano}', "");
    Expect(0, 5940, '\p{^Sc=-_hano}', "");
    Expect(0, 5940, '\P{Sc=-_hano}', "");
    Expect(1, 5940, '\P{^Sc=-_hano}', "");
    Expect(0, 5941, '\p{Sc=-_hano}', "");
    Expect(1, 5941, '\p{^Sc=-_hano}', "");
    Expect(1, 5941, '\P{Sc=-_hano}', "");
    Expect(0, 5941, '\P{^Sc=-_hano}', "");
    Error('\p{Is_Script=:=  HANUNOO}');
    Error('\P{Is_Script=:=  HANUNOO}');
    Expect(1, 5940, '\p{Is_Script=hanunoo}', "");
    Expect(0, 5940, '\p{^Is_Script=hanunoo}', "");
    Expect(0, 5940, '\P{Is_Script=hanunoo}', "");
    Expect(1, 5940, '\P{^Is_Script=hanunoo}', "");
    Expect(0, 5941, '\p{Is_Script=hanunoo}', "");
    Expect(1, 5941, '\p{^Is_Script=hanunoo}', "");
    Expect(1, 5941, '\P{Is_Script=hanunoo}', "");
    Expect(0, 5941, '\P{^Is_Script=hanunoo}', "");
    Expect(1, 5940, '\p{Is_Script= -hanunoo}', "");
    Expect(0, 5940, '\p{^Is_Script= -hanunoo}', "");
    Expect(0, 5940, '\P{Is_Script= -hanunoo}', "");
    Expect(1, 5940, '\P{^Is_Script= -hanunoo}', "");
    Expect(0, 5941, '\p{Is_Script= -hanunoo}', "");
    Expect(1, 5941, '\p{^Is_Script= -hanunoo}', "");
    Expect(1, 5941, '\P{Is_Script= -hanunoo}', "");
    Expect(0, 5941, '\P{^Is_Script= -hanunoo}', "");
    Error('\p{Is_Sc=:=-_HANO}');
    Error('\P{Is_Sc=:=-_HANO}');
    Expect(1, 5940, '\p{Is_Sc=hano}', "");
    Expect(0, 5940, '\p{^Is_Sc=hano}', "");
    Expect(0, 5940, '\P{Is_Sc=hano}', "");
    Expect(1, 5940, '\P{^Is_Sc=hano}', "");
    Expect(0, 5941, '\p{Is_Sc=hano}', "");
    Expect(1, 5941, '\p{^Is_Sc=hano}', "");
    Expect(1, 5941, '\P{Is_Sc=hano}', "");
    Expect(0, 5941, '\P{^Is_Sc=hano}', "");
    Error('\p{Script=/a/	HATRAN}');
    Error('\P{Script=/a/	HATRAN}');
    Expect(1, 67839, '\p{Script=hatran}', "");
    Expect(0, 67839, '\p{^Script=hatran}', "");
    Expect(0, 67839, '\P{Script=hatran}', "");
    Expect(1, 67839, '\P{^Script=hatran}', "");
    Expect(0, 67840, '\p{Script=hatran}', "");
    Expect(1, 67840, '\p{^Script=hatran}', "");
    Expect(1, 67840, '\P{Script=hatran}', "");
    Expect(0, 67840, '\P{^Script=hatran}', "");
    Expect(1, 67839, '\p{Script=_ Hatran}', "");
    Expect(0, 67839, '\p{^Script=_ Hatran}', "");
    Expect(0, 67839, '\P{Script=_ Hatran}', "");
    Expect(1, 67839, '\P{^Script=_ Hatran}', "");
    Expect(0, 67840, '\p{Script=_ Hatran}', "");
    Expect(1, 67840, '\p{^Script=_ Hatran}', "");
    Expect(1, 67840, '\P{Script=_ Hatran}', "");
    Expect(0, 67840, '\P{^Script=_ Hatran}', "");
    Error('\p{Sc=_/a/Hatr}');
    Error('\P{Sc=_/a/Hatr}');
    Expect(1, 67839, '\p{Sc=hatr}', "");
    Expect(0, 67839, '\p{^Sc=hatr}', "");
    Expect(0, 67839, '\P{Sc=hatr}', "");
    Expect(1, 67839, '\P{^Sc=hatr}', "");
    Expect(0, 67840, '\p{Sc=hatr}', "");
    Expect(1, 67840, '\p{^Sc=hatr}', "");
    Expect(1, 67840, '\P{Sc=hatr}', "");
    Expect(0, 67840, '\P{^Sc=hatr}', "");
    Expect(1, 67839, '\p{Sc: - Hatr}', "");
    Expect(0, 67839, '\p{^Sc: - Hatr}', "");
    Expect(0, 67839, '\P{Sc: - Hatr}', "");
    Expect(1, 67839, '\P{^Sc: - Hatr}', "");
    Expect(0, 67840, '\p{Sc: - Hatr}', "");
    Expect(1, 67840, '\p{^Sc: - Hatr}', "");
    Expect(1, 67840, '\P{Sc: - Hatr}', "");
    Expect(0, 67840, '\P{^Sc: - Hatr}', "");
    Error('\p{Is_Script=- Hatran/a/}');
    Error('\P{Is_Script=- Hatran/a/}');
    Expect(1, 67839, '\p{Is_Script=hatran}', "");
    Expect(0, 67839, '\p{^Is_Script=hatran}', "");
    Expect(0, 67839, '\P{Is_Script=hatran}', "");
    Expect(1, 67839, '\P{^Is_Script=hatran}', "");
    Expect(0, 67840, '\p{Is_Script=hatran}', "");
    Expect(1, 67840, '\p{^Is_Script=hatran}', "");
    Expect(1, 67840, '\P{Is_Script=hatran}', "");
    Expect(0, 67840, '\P{^Is_Script=hatran}', "");
    Expect(1, 67839, '\p{Is_Script= 	hatran}', "");
    Expect(0, 67839, '\p{^Is_Script= 	hatran}', "");
    Expect(0, 67839, '\P{Is_Script= 	hatran}', "");
    Expect(1, 67839, '\P{^Is_Script= 	hatran}', "");
    Expect(0, 67840, '\p{Is_Script= 	hatran}', "");
    Expect(1, 67840, '\p{^Is_Script= 	hatran}', "");
    Expect(1, 67840, '\P{Is_Script= 	hatran}', "");
    Expect(0, 67840, '\P{^Is_Script= 	hatran}', "");
    Error('\p{Is_Sc=:=--Hatr}');
    Error('\P{Is_Sc=:=--Hatr}');
    Expect(1, 67839, '\p{Is_Sc:	hatr}', "");
    Expect(0, 67839, '\p{^Is_Sc:	hatr}', "");
    Expect(0, 67839, '\P{Is_Sc:	hatr}', "");
    Expect(1, 67839, '\P{^Is_Sc:	hatr}', "");
    Expect(0, 67840, '\p{Is_Sc:	hatr}', "");
    Expect(1, 67840, '\p{^Is_Sc:	hatr}', "");
    Expect(1, 67840, '\P{Is_Sc:	hatr}', "");
    Expect(0, 67840, '\P{^Is_Sc:	hatr}', "");
    Expect(1, 67839, '\p{Is_Sc=Hatr}', "");
    Expect(0, 67839, '\p{^Is_Sc=Hatr}', "");
    Expect(0, 67839, '\P{Is_Sc=Hatr}', "");
    Expect(1, 67839, '\P{^Is_Sc=Hatr}', "");
    Expect(0, 67840, '\p{Is_Sc=Hatr}', "");
    Expect(1, 67840, '\p{^Is_Sc=Hatr}', "");
    Expect(1, 67840, '\P{Is_Sc=Hatr}', "");
    Expect(0, 67840, '\P{^Is_Sc=Hatr}', "");
    Error('\p{Script= hebrew:=}');
    Error('\P{Script= hebrew:=}');
    Expect(1, 64335, '\p{Script=hebrew}', "");
    Expect(0, 64335, '\p{^Script=hebrew}', "");
    Expect(0, 64335, '\P{Script=hebrew}', "");
    Expect(1, 64335, '\P{^Script=hebrew}', "");
    Expect(0, 64336, '\p{Script=hebrew}', "");
    Expect(1, 64336, '\p{^Script=hebrew}', "");
    Expect(1, 64336, '\P{Script=hebrew}', "");
    Expect(0, 64336, '\P{^Script=hebrew}', "");
    Expect(1, 64335, '\p{Script=-	HEBREW}', "");
    Expect(0, 64335, '\p{^Script=-	HEBREW}', "");
    Expect(0, 64335, '\P{Script=-	HEBREW}', "");
    Expect(1, 64335, '\P{^Script=-	HEBREW}', "");
    Expect(0, 64336, '\p{Script=-	HEBREW}', "");
    Expect(1, 64336, '\p{^Script=-	HEBREW}', "");
    Expect(1, 64336, '\P{Script=-	HEBREW}', "");
    Expect(0, 64336, '\P{^Script=-	HEBREW}', "");
    Error('\p{Sc=		Hebr/a/}');
    Error('\P{Sc=		Hebr/a/}');
    Expect(1, 64335, '\p{Sc=hebr}', "");
    Expect(0, 64335, '\p{^Sc=hebr}', "");
    Expect(0, 64335, '\P{Sc=hebr}', "");
    Expect(1, 64335, '\P{^Sc=hebr}', "");
    Expect(0, 64336, '\p{Sc=hebr}', "");
    Expect(1, 64336, '\p{^Sc=hebr}', "");
    Expect(1, 64336, '\P{Sc=hebr}', "");
    Expect(0, 64336, '\P{^Sc=hebr}', "");
    Expect(1, 64335, '\p{Sc=	 Hebr}', "");
    Expect(0, 64335, '\p{^Sc=	 Hebr}', "");
    Expect(0, 64335, '\P{Sc=	 Hebr}', "");
    Expect(1, 64335, '\P{^Sc=	 Hebr}', "");
    Expect(0, 64336, '\p{Sc=	 Hebr}', "");
    Expect(1, 64336, '\p{^Sc=	 Hebr}', "");
    Expect(1, 64336, '\P{Sc=	 Hebr}', "");
    Expect(0, 64336, '\P{^Sc=	 Hebr}', "");
    Error('\p{Is_Script=:=-Hebrew}');
    Error('\P{Is_Script=:=-Hebrew}');
    Expect(1, 64335, '\p{Is_Script=hebrew}', "");
    Expect(0, 64335, '\p{^Is_Script=hebrew}', "");
    Expect(0, 64335, '\P{Is_Script=hebrew}', "");
    Expect(1, 64335, '\P{^Is_Script=hebrew}', "");
    Expect(0, 64336, '\p{Is_Script=hebrew}', "");
    Expect(1, 64336, '\p{^Is_Script=hebrew}', "");
    Expect(1, 64336, '\P{Is_Script=hebrew}', "");
    Expect(0, 64336, '\P{^Is_Script=hebrew}', "");
    Expect(1, 64335, '\p{Is_Script=		Hebrew}', "");
    Expect(0, 64335, '\p{^Is_Script=		Hebrew}', "");
    Expect(0, 64335, '\P{Is_Script=		Hebrew}', "");
    Expect(1, 64335, '\P{^Is_Script=		Hebrew}', "");
    Expect(0, 64336, '\p{Is_Script=		Hebrew}', "");
    Expect(1, 64336, '\p{^Is_Script=		Hebrew}', "");
    Expect(1, 64336, '\P{Is_Script=		Hebrew}', "");
    Expect(0, 64336, '\P{^Is_Script=		Hebrew}', "");
    Error('\p{Is_Sc=  hebr/a/}');
    Error('\P{Is_Sc=  hebr/a/}');
    Expect(1, 64335, '\p{Is_Sc=hebr}', "");
    Expect(0, 64335, '\p{^Is_Sc=hebr}', "");
    Expect(0, 64335, '\P{Is_Sc=hebr}', "");
    Expect(1, 64335, '\P{^Is_Sc=hebr}', "");
    Expect(0, 64336, '\p{Is_Sc=hebr}', "");
    Expect(1, 64336, '\p{^Is_Sc=hebr}', "");
    Expect(1, 64336, '\P{Is_Sc=hebr}', "");
    Expect(0, 64336, '\P{^Is_Sc=hebr}', "");
    Expect(1, 64335, '\p{Is_Sc=--hebr}', "");
    Expect(0, 64335, '\p{^Is_Sc=--hebr}', "");
    Expect(0, 64335, '\P{Is_Sc=--hebr}', "");
    Expect(1, 64335, '\P{^Is_Sc=--hebr}', "");
    Expect(0, 64336, '\p{Is_Sc=--hebr}', "");
    Expect(1, 64336, '\p{^Is_Sc=--hebr}', "");
    Expect(1, 64336, '\P{Is_Sc=--hebr}', "");
    Expect(0, 64336, '\P{^Is_Sc=--hebr}', "");
    Error('\p{Script=-:=Hiragana}');
    Error('\P{Script=-:=Hiragana}');
    Expect(1, 127488, '\p{Script=hiragana}', "");
    Expect(0, 127488, '\p{^Script=hiragana}', "");
    Expect(0, 127488, '\P{Script=hiragana}', "");
    Expect(1, 127488, '\P{^Script=hiragana}', "");
    Expect(0, 127489, '\p{Script=hiragana}', "");
    Expect(1, 127489, '\p{^Script=hiragana}', "");
    Expect(1, 127489, '\P{Script=hiragana}', "");
    Expect(0, 127489, '\P{^Script=hiragana}', "");
    Expect(1, 127488, '\p{Script=	 Hiragana}', "");
    Expect(0, 127488, '\p{^Script=	 Hiragana}', "");
    Expect(0, 127488, '\P{Script=	 Hiragana}', "");
    Expect(1, 127488, '\P{^Script=	 Hiragana}', "");
    Expect(0, 127489, '\p{Script=	 Hiragana}', "");
    Expect(1, 127489, '\p{^Script=	 Hiragana}', "");
    Expect(1, 127489, '\P{Script=	 Hiragana}', "");
    Expect(0, 127489, '\P{^Script=	 Hiragana}', "");
    Error('\p{Sc=	:=Hira}');
    Error('\P{Sc=	:=Hira}');
    Expect(1, 127488, '\p{Sc=hira}', "");
    Expect(0, 127488, '\p{^Sc=hira}', "");
    Expect(0, 127488, '\P{Sc=hira}', "");
    Expect(1, 127488, '\P{^Sc=hira}', "");
    Expect(0, 127489, '\p{Sc=hira}', "");
    Expect(1, 127489, '\p{^Sc=hira}', "");
    Expect(1, 127489, '\P{Sc=hira}', "");
    Expect(0, 127489, '\P{^Sc=hira}', "");
    Expect(1, 127488, '\p{Sc:   	 hira}', "");
    Expect(0, 127488, '\p{^Sc:   	 hira}', "");
    Expect(0, 127488, '\P{Sc:   	 hira}', "");
    Expect(1, 127488, '\P{^Sc:   	 hira}', "");
    Expect(0, 127489, '\p{Sc:   	 hira}', "");
    Expect(1, 127489, '\p{^Sc:   	 hira}', "");
    Expect(1, 127489, '\P{Sc:   	 hira}', "");
    Expect(0, 127489, '\P{^Sc:   	 hira}', "");
    Error('\p{Is_Script=_ HIRAGANA:=}');
    Error('\P{Is_Script=_ HIRAGANA:=}');
    Expect(1, 127488, '\p{Is_Script=hiragana}', "");
    Expect(0, 127488, '\p{^Is_Script=hiragana}', "");
    Expect(0, 127488, '\P{Is_Script=hiragana}', "");
    Expect(1, 127488, '\P{^Is_Script=hiragana}', "");
    Expect(0, 127489, '\p{Is_Script=hiragana}', "");
    Expect(1, 127489, '\p{^Is_Script=hiragana}', "");
    Expect(1, 127489, '\P{Is_Script=hiragana}', "");
    Expect(0, 127489, '\P{^Is_Script=hiragana}', "");
    Expect(1, 127488, '\p{Is_Script=-_Hiragana}', "");
    Expect(0, 127488, '\p{^Is_Script=-_Hiragana}', "");
    Expect(0, 127488, '\P{Is_Script=-_Hiragana}', "");
    Expect(1, 127488, '\P{^Is_Script=-_Hiragana}', "");
    Expect(0, 127489, '\p{Is_Script=-_Hiragana}', "");
    Expect(1, 127489, '\p{^Is_Script=-_Hiragana}', "");
    Expect(1, 127489, '\P{Is_Script=-_Hiragana}', "");
    Expect(0, 127489, '\P{^Is_Script=-_Hiragana}', "");
    Error('\p{Is_Sc=/a/-hira}');
    Error('\P{Is_Sc=/a/-hira}');
    Expect(1, 127488, '\p{Is_Sc=hira}', "");
    Expect(0, 127488, '\p{^Is_Sc=hira}', "");
    Expect(0, 127488, '\P{Is_Sc=hira}', "");
    Expect(1, 127488, '\P{^Is_Sc=hira}', "");
    Expect(0, 127489, '\p{Is_Sc=hira}', "");
    Expect(1, 127489, '\p{^Is_Sc=hira}', "");
    Expect(1, 127489, '\P{Is_Sc=hira}', "");
    Expect(0, 127489, '\P{^Is_Sc=hira}', "");
    Error('\p{Script=_/a/ANATOLIAN_hieroglyphs}');
    Error('\P{Script=_/a/ANATOLIAN_hieroglyphs}');
    Expect(1, 83526, '\p{Script: anatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^Script: anatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{Script: anatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^Script: anatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{Script: anatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^Script: anatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{Script: anatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^Script: anatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{Script=_-Anatolian_Hieroglyphs}', "");
    Expect(0, 83526, '\p{^Script=_-Anatolian_Hieroglyphs}', "");
    Expect(0, 83526, '\P{Script=_-Anatolian_Hieroglyphs}', "");
    Expect(1, 83526, '\P{^Script=_-Anatolian_Hieroglyphs}', "");
    Expect(0, 83527, '\p{Script=_-Anatolian_Hieroglyphs}', "");
    Expect(1, 83527, '\p{^Script=_-Anatolian_Hieroglyphs}', "");
    Expect(1, 83527, '\P{Script=_-Anatolian_Hieroglyphs}', "");
    Expect(0, 83527, '\P{^Script=_-Anatolian_Hieroglyphs}', "");
    Error('\p{Sc=-_Hluw/a/}');
    Error('\P{Sc=-_Hluw/a/}');
    Expect(1, 83526, '\p{Sc:   hluw}', "");
    Expect(0, 83526, '\p{^Sc:   hluw}', "");
    Expect(0, 83526, '\P{Sc:   hluw}', "");
    Expect(1, 83526, '\P{^Sc:   hluw}', "");
    Expect(0, 83527, '\p{Sc:   hluw}', "");
    Expect(1, 83527, '\p{^Sc:   hluw}', "");
    Expect(1, 83527, '\P{Sc:   hluw}', "");
    Expect(0, 83527, '\P{^Sc:   hluw}', "");
    Expect(1, 83526, '\p{Sc=	hluw}', "");
    Expect(0, 83526, '\p{^Sc=	hluw}', "");
    Expect(0, 83526, '\P{Sc=	hluw}', "");
    Expect(1, 83526, '\P{^Sc=	hluw}', "");
    Expect(0, 83527, '\p{Sc=	hluw}', "");
    Expect(1, 83527, '\p{^Sc=	hluw}', "");
    Expect(1, 83527, '\P{Sc=	hluw}', "");
    Expect(0, 83527, '\P{^Sc=	hluw}', "");
    Error('\p{Is_Script=	:=Anatolian_Hieroglyphs}');
    Error('\P{Is_Script=	:=Anatolian_Hieroglyphs}');
    Expect(1, 83526, '\p{Is_Script=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^Is_Script=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{Is_Script=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^Is_Script=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{Is_Script=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^Is_Script=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{Is_Script=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^Is_Script=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{Is_Script: _Anatolian_hieroglyphs}', "");
    Expect(0, 83526, '\p{^Is_Script: _Anatolian_hieroglyphs}', "");
    Expect(0, 83526, '\P{Is_Script: _Anatolian_hieroglyphs}', "");
    Expect(1, 83526, '\P{^Is_Script: _Anatolian_hieroglyphs}', "");
    Expect(0, 83527, '\p{Is_Script: _Anatolian_hieroglyphs}', "");
    Expect(1, 83527, '\p{^Is_Script: _Anatolian_hieroglyphs}', "");
    Expect(1, 83527, '\P{Is_Script: _Anatolian_hieroglyphs}', "");
    Expect(0, 83527, '\P{^Is_Script: _Anatolian_hieroglyphs}', "");
    Error('\p{Is_Sc=:=-hluw}');
    Error('\P{Is_Sc=:=-hluw}');
    Expect(1, 83526, '\p{Is_Sc=hluw}', "");
    Expect(0, 83526, '\p{^Is_Sc=hluw}', "");
    Expect(0, 83526, '\P{Is_Sc=hluw}', "");
    Expect(1, 83526, '\P{^Is_Sc=hluw}', "");
    Expect(0, 83527, '\p{Is_Sc=hluw}', "");
    Expect(1, 83527, '\p{^Is_Sc=hluw}', "");
    Expect(1, 83527, '\P{Is_Sc=hluw}', "");
    Expect(0, 83527, '\P{^Is_Sc=hluw}', "");
    Expect(1, 83526, '\p{Is_Sc=	 hluw}', "");
    Expect(0, 83526, '\p{^Is_Sc=	 hluw}', "");
    Expect(0, 83526, '\P{Is_Sc=	 hluw}', "");
    Expect(1, 83526, '\P{^Is_Sc=	 hluw}', "");
    Expect(0, 83527, '\p{Is_Sc=	 hluw}', "");
    Expect(1, 83527, '\p{^Is_Sc=	 hluw}', "");
    Expect(1, 83527, '\P{Is_Sc=	 hluw}', "");
    Expect(0, 83527, '\P{^Is_Sc=	 hluw}', "");
    Error('\p{Script=:=_ PAHAWH_Hmong}');
    Error('\P{Script=:=_ PAHAWH_Hmong}');
    Expect(1, 93071, '\p{Script:   pahawhhmong}', "");
    Expect(0, 93071, '\p{^Script:   pahawhhmong}', "");
    Expect(0, 93071, '\P{Script:   pahawhhmong}', "");
    Expect(1, 93071, '\P{^Script:   pahawhhmong}', "");
    Expect(0, 93072, '\p{Script:   pahawhhmong}', "");
    Expect(1, 93072, '\p{^Script:   pahawhhmong}', "");
    Expect(1, 93072, '\P{Script:   pahawhhmong}', "");
    Expect(0, 93072, '\P{^Script:   pahawhhmong}', "");
    Expect(1, 93071, '\p{Script=	-Pahawh_HMONG}', "");
    Expect(0, 93071, '\p{^Script=	-Pahawh_HMONG}', "");
    Expect(0, 93071, '\P{Script=	-Pahawh_HMONG}', "");
    Expect(1, 93071, '\P{^Script=	-Pahawh_HMONG}', "");
    Expect(0, 93072, '\p{Script=	-Pahawh_HMONG}', "");
    Expect(1, 93072, '\p{^Script=	-Pahawh_HMONG}', "");
    Expect(1, 93072, '\P{Script=	-Pahawh_HMONG}', "");
    Expect(0, 93072, '\P{^Script=	-Pahawh_HMONG}', "");
    Error('\p{Sc=-_Hmng:=}');
    Error('\P{Sc=-_Hmng:=}');
    Expect(1, 93071, '\p{Sc:	hmng}', "");
    Expect(0, 93071, '\p{^Sc:	hmng}', "");
    Expect(0, 93071, '\P{Sc:	hmng}', "");
    Expect(1, 93071, '\P{^Sc:	hmng}', "");
    Expect(0, 93072, '\p{Sc:	hmng}', "");
    Expect(1, 93072, '\p{^Sc:	hmng}', "");
    Expect(1, 93072, '\P{Sc:	hmng}', "");
    Expect(0, 93072, '\P{^Sc:	hmng}', "");
    Expect(1, 93071, '\p{Sc=_hmng}', "");
    Expect(0, 93071, '\p{^Sc=_hmng}', "");
    Expect(0, 93071, '\P{Sc=_hmng}', "");
    Expect(1, 93071, '\P{^Sc=_hmng}', "");
    Expect(0, 93072, '\p{Sc=_hmng}', "");
    Expect(1, 93072, '\p{^Sc=_hmng}', "");
    Expect(1, 93072, '\P{Sc=_hmng}', "");
    Expect(0, 93072, '\P{^Sc=_hmng}', "");
    Error('\p{Is_Script:	-/a/Pahawh_Hmong}');
    Error('\P{Is_Script:	-/a/Pahawh_Hmong}');
    Expect(1, 93071, '\p{Is_Script=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Is_Script=pahawhhmong}', "");
    Expect(0, 93071, '\P{Is_Script=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Is_Script=pahawhhmong}', "");
    Expect(0, 93072, '\p{Is_Script=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Is_Script=pahawhhmong}', "");
    Expect(1, 93072, '\P{Is_Script=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Is_Script=pahawhhmong}', "");
    Expect(1, 93071, '\p{Is_Script= 	PAHAWH_Hmong}', "");
    Expect(0, 93071, '\p{^Is_Script= 	PAHAWH_Hmong}', "");
    Expect(0, 93071, '\P{Is_Script= 	PAHAWH_Hmong}', "");
    Expect(1, 93071, '\P{^Is_Script= 	PAHAWH_Hmong}', "");
    Expect(0, 93072, '\p{Is_Script= 	PAHAWH_Hmong}', "");
    Expect(1, 93072, '\p{^Is_Script= 	PAHAWH_Hmong}', "");
    Expect(1, 93072, '\P{Is_Script= 	PAHAWH_Hmong}', "");
    Expect(0, 93072, '\P{^Is_Script= 	PAHAWH_Hmong}', "");
    Error('\p{Is_Sc=/a/ HMNG}');
    Error('\P{Is_Sc=/a/ HMNG}');
    Expect(1, 93071, '\p{Is_Sc=hmng}', "");
    Expect(0, 93071, '\p{^Is_Sc=hmng}', "");
    Expect(0, 93071, '\P{Is_Sc=hmng}', "");
    Expect(1, 93071, '\P{^Is_Sc=hmng}', "");
    Expect(0, 93072, '\p{Is_Sc=hmng}', "");
    Expect(1, 93072, '\p{^Is_Sc=hmng}', "");
    Expect(1, 93072, '\P{Is_Sc=hmng}', "");
    Expect(0, 93072, '\P{^Is_Sc=hmng}', "");
    Expect(1, 93071, '\p{Is_Sc=_ HMNG}', "");
    Expect(0, 93071, '\p{^Is_Sc=_ HMNG}', "");
    Expect(0, 93071, '\P{Is_Sc=_ HMNG}', "");
    Expect(1, 93071, '\P{^Is_Sc=_ HMNG}', "");
    Expect(0, 93072, '\p{Is_Sc=_ HMNG}', "");
    Expect(1, 93072, '\p{^Is_Sc=_ HMNG}', "");
    Expect(1, 93072, '\P{Is_Sc=_ HMNG}', "");
    Expect(0, 93072, '\P{^Is_Sc=_ HMNG}', "");
    Error('\p{Script=Katakana_Or_Hiragana}');
    Error('\P{Script=Katakana_Or_Hiragana}');
    Error('\p{Sc=Hrkt}');
    Error('\P{Sc=Hrkt}');
    Error('\p{Is_Script=Katakana_Or_Hiragana}');
    Error('\P{Is_Script=Katakana_Or_Hiragana}');
    Error('\p{Is_Sc=Hrkt}');
    Error('\P{Is_Sc=Hrkt}');
    Error('\p{Script=/a/--old_Hungarian}');
    Error('\P{Script=/a/--old_Hungarian}');
    Expect(1, 68863, '\p{Script=oldhungarian}', "");
    Expect(0, 68863, '\p{^Script=oldhungarian}', "");
    Expect(0, 68863, '\P{Script=oldhungarian}', "");
    Expect(1, 68863, '\P{^Script=oldhungarian}', "");
    Expect(0, 68864, '\p{Script=oldhungarian}', "");
    Expect(1, 68864, '\p{^Script=oldhungarian}', "");
    Expect(1, 68864, '\P{Script=oldhungarian}', "");
    Expect(0, 68864, '\P{^Script=oldhungarian}', "");
    Expect(1, 68863, '\p{Script=	old_Hungarian}', "");
    Expect(0, 68863, '\p{^Script=	old_Hungarian}', "");
    Expect(0, 68863, '\P{Script=	old_Hungarian}', "");
    Expect(1, 68863, '\P{^Script=	old_Hungarian}', "");
    Expect(0, 68864, '\p{Script=	old_Hungarian}', "");
    Expect(1, 68864, '\p{^Script=	old_Hungarian}', "");
    Expect(1, 68864, '\P{Script=	old_Hungarian}', "");
    Expect(0, 68864, '\P{^Script=	old_Hungarian}', "");
    Error('\p{Sc=__hung/a/}');
    Error('\P{Sc=__hung/a/}');
    Expect(1, 68863, '\p{Sc=hung}', "");
    Expect(0, 68863, '\p{^Sc=hung}', "");
    Expect(0, 68863, '\P{Sc=hung}', "");
    Expect(1, 68863, '\P{^Sc=hung}', "");
    Expect(0, 68864, '\p{Sc=hung}', "");
    Expect(1, 68864, '\p{^Sc=hung}', "");
    Expect(1, 68864, '\P{Sc=hung}', "");
    Expect(0, 68864, '\P{^Sc=hung}', "");
    Expect(1, 68863, '\p{Sc:  _Hung}', "");
    Expect(0, 68863, '\p{^Sc:  _Hung}', "");
    Expect(0, 68863, '\P{Sc:  _Hung}', "");
    Expect(1, 68863, '\P{^Sc:  _Hung}', "");
    Expect(0, 68864, '\p{Sc:  _Hung}', "");
    Expect(1, 68864, '\p{^Sc:  _Hung}', "");
    Expect(1, 68864, '\P{Sc:  _Hung}', "");
    Expect(0, 68864, '\P{^Sc:  _Hung}', "");
    Error('\p{Is_Script=-:=Old_hungarian}');
    Error('\P{Is_Script=-:=Old_hungarian}');
    Expect(1, 68863, '\p{Is_Script=oldhungarian}', "");
    Expect(0, 68863, '\p{^Is_Script=oldhungarian}', "");
    Expect(0, 68863, '\P{Is_Script=oldhungarian}', "");
    Expect(1, 68863, '\P{^Is_Script=oldhungarian}', "");
    Expect(0, 68864, '\p{Is_Script=oldhungarian}', "");
    Expect(1, 68864, '\p{^Is_Script=oldhungarian}', "");
    Expect(1, 68864, '\P{Is_Script=oldhungarian}', "");
    Expect(0, 68864, '\P{^Is_Script=oldhungarian}', "");
    Expect(1, 68863, '\p{Is_Script=  Old_HUNGARIAN}', "");
    Expect(0, 68863, '\p{^Is_Script=  Old_HUNGARIAN}', "");
    Expect(0, 68863, '\P{Is_Script=  Old_HUNGARIAN}', "");
    Expect(1, 68863, '\P{^Is_Script=  Old_HUNGARIAN}', "");
    Expect(0, 68864, '\p{Is_Script=  Old_HUNGARIAN}', "");
    Expect(1, 68864, '\p{^Is_Script=  Old_HUNGARIAN}', "");
    Expect(1, 68864, '\P{Is_Script=  Old_HUNGARIAN}', "");
    Expect(0, 68864, '\P{^Is_Script=  Old_HUNGARIAN}', "");
    Error('\p{Is_Sc=Hung:=}');
    Error('\P{Is_Sc=Hung:=}');
    Expect(1, 68863, '\p{Is_Sc:	hung}', "");
    Expect(0, 68863, '\p{^Is_Sc:	hung}', "");
    Expect(0, 68863, '\P{Is_Sc:	hung}', "");
    Expect(1, 68863, '\P{^Is_Sc:	hung}', "");
    Expect(0, 68864, '\p{Is_Sc:	hung}', "");
    Expect(1, 68864, '\p{^Is_Sc:	hung}', "");
    Expect(1, 68864, '\P{Is_Sc:	hung}', "");
    Expect(0, 68864, '\P{^Is_Sc:	hung}', "");
    Expect(1, 68863, '\p{Is_Sc=_	hung}', "");
    Expect(0, 68863, '\p{^Is_Sc=_	hung}', "");
    Expect(0, 68863, '\P{Is_Sc=_	hung}', "");
    Expect(1, 68863, '\P{^Is_Sc=_	hung}', "");
    Expect(0, 68864, '\p{Is_Sc=_	hung}', "");
    Expect(1, 68864, '\p{^Is_Sc=_	hung}', "");
    Expect(1, 68864, '\P{Is_Sc=_	hung}', "");
    Expect(0, 68864, '\P{^Is_Sc=_	hung}', "");
    Error('\p{Script=_/a/OLD_italic}');
    Error('\P{Script=_/a/OLD_italic}');
    Expect(1, 66351, '\p{Script=olditalic}', "");
    Expect(0, 66351, '\p{^Script=olditalic}', "");
    Expect(0, 66351, '\P{Script=olditalic}', "");
    Expect(1, 66351, '\P{^Script=olditalic}', "");
    Expect(0, 66352, '\p{Script=olditalic}', "");
    Expect(1, 66352, '\p{^Script=olditalic}', "");
    Expect(1, 66352, '\P{Script=olditalic}', "");
    Expect(0, 66352, '\P{^Script=olditalic}', "");
    Expect(1, 66351, '\p{Script=_Old_ITALIC}', "");
    Expect(0, 66351, '\p{^Script=_Old_ITALIC}', "");
    Expect(0, 66351, '\P{Script=_Old_ITALIC}', "");
    Expect(1, 66351, '\P{^Script=_Old_ITALIC}', "");
    Expect(0, 66352, '\p{Script=_Old_ITALIC}', "");
    Expect(1, 66352, '\p{^Script=_Old_ITALIC}', "");
    Expect(1, 66352, '\P{Script=_Old_ITALIC}', "");
    Expect(0, 66352, '\P{^Script=_Old_ITALIC}', "");
    Error('\p{Sc=:= Ital}');
    Error('\P{Sc=:= Ital}');
    Expect(1, 66351, '\p{Sc=ital}', "");
    Expect(0, 66351, '\p{^Sc=ital}', "");
    Expect(0, 66351, '\P{Sc=ital}', "");
    Expect(1, 66351, '\P{^Sc=ital}', "");
    Expect(0, 66352, '\p{Sc=ital}', "");
    Expect(1, 66352, '\p{^Sc=ital}', "");
    Expect(1, 66352, '\P{Sc=ital}', "");
    Expect(0, 66352, '\P{^Sc=ital}', "");
    Expect(1, 66351, '\p{Sc=_ ITAL}', "");
    Expect(0, 66351, '\p{^Sc=_ ITAL}', "");
    Expect(0, 66351, '\P{Sc=_ ITAL}', "");
    Expect(1, 66351, '\P{^Sc=_ ITAL}', "");
    Expect(0, 66352, '\p{Sc=_ ITAL}', "");
    Expect(1, 66352, '\p{^Sc=_ ITAL}', "");
    Expect(1, 66352, '\P{Sc=_ ITAL}', "");
    Expect(0, 66352, '\P{^Sc=_ ITAL}', "");
    Error('\p{Is_Script=_ Old_Italic/a/}');
    Error('\P{Is_Script=_ Old_Italic/a/}');
    Expect(1, 66351, '\p{Is_Script=olditalic}', "");
    Expect(0, 66351, '\p{^Is_Script=olditalic}', "");
    Expect(0, 66351, '\P{Is_Script=olditalic}', "");
    Expect(1, 66351, '\P{^Is_Script=olditalic}', "");
    Expect(0, 66352, '\p{Is_Script=olditalic}', "");
    Expect(1, 66352, '\p{^Is_Script=olditalic}', "");
    Expect(1, 66352, '\P{Is_Script=olditalic}', "");
    Expect(0, 66352, '\P{^Is_Script=olditalic}', "");
    Expect(1, 66351, '\p{Is_Script=-OLD_Italic}', "");
    Expect(0, 66351, '\p{^Is_Script=-OLD_Italic}', "");
    Expect(0, 66351, '\P{Is_Script=-OLD_Italic}', "");
    Expect(1, 66351, '\P{^Is_Script=-OLD_Italic}', "");
    Expect(0, 66352, '\p{Is_Script=-OLD_Italic}', "");
    Expect(1, 66352, '\p{^Is_Script=-OLD_Italic}', "");
    Expect(1, 66352, '\P{Is_Script=-OLD_Italic}', "");
    Expect(0, 66352, '\P{^Is_Script=-OLD_Italic}', "");
    Error('\p{Is_Sc=:=_ITAL}');
    Error('\P{Is_Sc=:=_ITAL}');
    Expect(1, 66351, '\p{Is_Sc:	ital}', "");
    Expect(0, 66351, '\p{^Is_Sc:	ital}', "");
    Expect(0, 66351, '\P{Is_Sc:	ital}', "");
    Expect(1, 66351, '\P{^Is_Sc:	ital}', "");
    Expect(0, 66352, '\p{Is_Sc:	ital}', "");
    Expect(1, 66352, '\p{^Is_Sc:	ital}', "");
    Expect(1, 66352, '\P{Is_Sc:	ital}', "");
    Expect(0, 66352, '\P{^Is_Sc:	ital}', "");
    Expect(1, 66351, '\p{Is_Sc=_ital}', "");
    Expect(0, 66351, '\p{^Is_Sc=_ital}', "");
    Expect(0, 66351, '\P{Is_Sc=_ital}', "");
    Expect(1, 66351, '\P{^Is_Sc=_ital}', "");
    Expect(0, 66352, '\p{Is_Sc=_ital}', "");
    Expect(1, 66352, '\p{^Is_Sc=_ital}', "");
    Expect(1, 66352, '\P{Is_Sc=_ital}', "");
    Expect(0, 66352, '\P{^Is_Sc=_ital}', "");
    Error('\p{Script=- javanese/a/}');
    Error('\P{Script=- javanese/a/}');
    Expect(1, 43487, '\p{Script:   javanese}', "");
    Expect(0, 43487, '\p{^Script:   javanese}', "");
    Expect(0, 43487, '\P{Script:   javanese}', "");
    Expect(1, 43487, '\P{^Script:   javanese}', "");
    Expect(0, 43488, '\p{Script:   javanese}', "");
    Expect(1, 43488, '\p{^Script:   javanese}', "");
    Expect(1, 43488, '\P{Script:   javanese}', "");
    Expect(0, 43488, '\P{^Script:   javanese}', "");
    Expect(1, 43487, '\p{Script= javanese}', "");
    Expect(0, 43487, '\p{^Script= javanese}', "");
    Expect(0, 43487, '\P{Script= javanese}', "");
    Expect(1, 43487, '\P{^Script= javanese}', "");
    Expect(0, 43488, '\p{Script= javanese}', "");
    Expect(1, 43488, '\p{^Script= javanese}', "");
    Expect(1, 43488, '\P{Script= javanese}', "");
    Expect(0, 43488, '\P{^Script= javanese}', "");
    Error('\p{Sc=/a/_ Java}');
    Error('\P{Sc=/a/_ Java}');
    Expect(1, 43487, '\p{Sc=java}', "");
    Expect(0, 43487, '\p{^Sc=java}', "");
    Expect(0, 43487, '\P{Sc=java}', "");
    Expect(1, 43487, '\P{^Sc=java}', "");
    Expect(0, 43488, '\p{Sc=java}', "");
    Expect(1, 43488, '\p{^Sc=java}', "");
    Expect(1, 43488, '\P{Sc=java}', "");
    Expect(0, 43488, '\P{^Sc=java}', "");
    Expect(1, 43487, '\p{Sc=	-Java}', "");
    Expect(0, 43487, '\p{^Sc=	-Java}', "");
    Expect(0, 43487, '\P{Sc=	-Java}', "");
    Expect(1, 43487, '\P{^Sc=	-Java}', "");
    Expect(0, 43488, '\p{Sc=	-Java}', "");
    Expect(1, 43488, '\p{^Sc=	-Java}', "");
    Expect(1, 43488, '\P{Sc=	-Java}', "");
    Expect(0, 43488, '\P{^Sc=	-Java}', "");
    Error('\p{Is_Script=	/a/Javanese}');
    Error('\P{Is_Script=	/a/Javanese}');
    Expect(1, 43487, '\p{Is_Script=javanese}', "");
    Expect(0, 43487, '\p{^Is_Script=javanese}', "");
    Expect(0, 43487, '\P{Is_Script=javanese}', "");
    Expect(1, 43487, '\P{^Is_Script=javanese}', "");
    Expect(0, 43488, '\p{Is_Script=javanese}', "");
    Expect(1, 43488, '\p{^Is_Script=javanese}', "");
    Expect(1, 43488, '\P{Is_Script=javanese}', "");
    Expect(0, 43488, '\P{^Is_Script=javanese}', "");
    Expect(1, 43487, '\p{Is_Script=-	Javanese}', "");
    Expect(0, 43487, '\p{^Is_Script=-	Javanese}', "");
    Expect(0, 43487, '\P{Is_Script=-	Javanese}', "");
    Expect(1, 43487, '\P{^Is_Script=-	Javanese}', "");
    Expect(0, 43488, '\p{Is_Script=-	Javanese}', "");
    Expect(1, 43488, '\p{^Is_Script=-	Javanese}', "");
    Expect(1, 43488, '\P{Is_Script=-	Javanese}', "");
    Expect(0, 43488, '\P{^Is_Script=-	Javanese}', "");
    Error('\p{Is_Sc=:= Java}');
    Error('\P{Is_Sc=:= Java}');
    Expect(1, 43487, '\p{Is_Sc=java}', "");
    Expect(0, 43487, '\p{^Is_Sc=java}', "");
    Expect(0, 43487, '\P{Is_Sc=java}', "");
    Expect(1, 43487, '\P{^Is_Sc=java}', "");
    Expect(0, 43488, '\p{Is_Sc=java}', "");
    Expect(1, 43488, '\p{^Is_Sc=java}', "");
    Expect(1, 43488, '\P{Is_Sc=java}', "");
    Expect(0, 43488, '\P{^Is_Sc=java}', "");
    Expect(1, 43487, '\p{Is_Sc= -Java}', "");
    Expect(0, 43487, '\p{^Is_Sc= -Java}', "");
    Expect(0, 43487, '\P{Is_Sc= -Java}', "");
    Expect(1, 43487, '\P{^Is_Sc= -Java}', "");
    Expect(0, 43488, '\p{Is_Sc= -Java}', "");
    Expect(1, 43488, '\p{^Is_Sc= -Java}', "");
    Expect(1, 43488, '\P{Is_Sc= -Java}', "");
    Expect(0, 43488, '\P{^Is_Sc= -Java}', "");
    Error('\p{Script=:=- kayah_LI}');
    Error('\P{Script=:=- kayah_LI}');
    Expect(1, 43311, '\p{Script=kayahli}', "");
    Expect(0, 43311, '\p{^Script=kayahli}', "");
    Expect(0, 43311, '\P{Script=kayahli}', "");
    Expect(1, 43311, '\P{^Script=kayahli}', "");
    Expect(0, 43312, '\p{Script=kayahli}', "");
    Expect(1, 43312, '\p{^Script=kayahli}', "");
    Expect(1, 43312, '\P{Script=kayahli}', "");
    Expect(0, 43312, '\P{^Script=kayahli}', "");
    Expect(1, 43311, '\p{Script=	-KAYAH_li}', "");
    Expect(0, 43311, '\p{^Script=	-KAYAH_li}', "");
    Expect(0, 43311, '\P{Script=	-KAYAH_li}', "");
    Expect(1, 43311, '\P{^Script=	-KAYAH_li}', "");
    Expect(0, 43312, '\p{Script=	-KAYAH_li}', "");
    Expect(1, 43312, '\p{^Script=	-KAYAH_li}', "");
    Expect(1, 43312, '\P{Script=	-KAYAH_li}', "");
    Expect(0, 43312, '\P{^Script=	-KAYAH_li}', "");
    Error('\p{Sc=:=_kali}');
    Error('\P{Sc=:=_kali}');
    Expect(1, 43311, '\p{Sc=kali}', "");
    Expect(0, 43311, '\p{^Sc=kali}', "");
    Expect(0, 43311, '\P{Sc=kali}', "");
    Expect(1, 43311, '\P{^Sc=kali}', "");
    Expect(0, 43312, '\p{Sc=kali}', "");
    Expect(1, 43312, '\p{^Sc=kali}', "");
    Expect(1, 43312, '\P{Sc=kali}', "");
    Expect(0, 43312, '\P{^Sc=kali}', "");
    Expect(1, 43311, '\p{Sc=_ Kali}', "");
    Expect(0, 43311, '\p{^Sc=_ Kali}', "");
    Expect(0, 43311, '\P{Sc=_ Kali}', "");
    Expect(1, 43311, '\P{^Sc=_ Kali}', "");
    Expect(0, 43312, '\p{Sc=_ Kali}', "");
    Expect(1, 43312, '\p{^Sc=_ Kali}', "");
    Expect(1, 43312, '\P{Sc=_ Kali}', "");
    Expect(0, 43312, '\P{^Sc=_ Kali}', "");
    Error('\p{Is_Script:/a/  Kayah_Li}');
    Error('\P{Is_Script:/a/  Kayah_Li}');
    Expect(1, 43311, '\p{Is_Script=kayahli}', "");
    Expect(0, 43311, '\p{^Is_Script=kayahli}', "");
    Expect(0, 43311, '\P{Is_Script=kayahli}', "");
    Expect(1, 43311, '\P{^Is_Script=kayahli}', "");
    Expect(0, 43312, '\p{Is_Script=kayahli}', "");
    Expect(1, 43312, '\p{^Is_Script=kayahli}', "");
    Expect(1, 43312, '\P{Is_Script=kayahli}', "");
    Expect(0, 43312, '\P{^Is_Script=kayahli}', "");
    Expect(1, 43311, '\p{Is_Script: _	Kayah_LI}', "");
    Expect(0, 43311, '\p{^Is_Script: _	Kayah_LI}', "");
    Expect(0, 43311, '\P{Is_Script: _	Kayah_LI}', "");
    Expect(1, 43311, '\P{^Is_Script: _	Kayah_LI}', "");
    Expect(0, 43312, '\p{Is_Script: _	Kayah_LI}', "");
    Expect(1, 43312, '\p{^Is_Script: _	Kayah_LI}', "");
    Expect(1, 43312, '\P{Is_Script: _	Kayah_LI}', "");
    Expect(0, 43312, '\P{^Is_Script: _	Kayah_LI}', "");
    Error('\p{Is_Sc:	:=kali}');
    Error('\P{Is_Sc:	:=kali}');
    Expect(1, 43311, '\p{Is_Sc=kali}', "");
    Expect(0, 43311, '\p{^Is_Sc=kali}', "");
    Expect(0, 43311, '\P{Is_Sc=kali}', "");
    Expect(1, 43311, '\P{^Is_Sc=kali}', "");
    Expect(0, 43312, '\p{Is_Sc=kali}', "");
    Expect(1, 43312, '\p{^Is_Sc=kali}', "");
    Expect(1, 43312, '\P{Is_Sc=kali}', "");
    Expect(0, 43312, '\P{^Is_Sc=kali}', "");
    Expect(1, 43311, '\p{Is_Sc=-	Kali}', "");
    Expect(0, 43311, '\p{^Is_Sc=-	Kali}', "");
    Expect(0, 43311, '\P{Is_Sc=-	Kali}', "");
    Expect(1, 43311, '\P{^Is_Sc=-	Kali}', "");
    Expect(0, 43312, '\p{Is_Sc=-	Kali}', "");
    Expect(1, 43312, '\p{^Is_Sc=-	Kali}', "");
    Expect(1, 43312, '\P{Is_Sc=-	Kali}', "");
    Expect(0, 43312, '\P{^Is_Sc=-	Kali}', "");
    Error('\p{Script= Katakana/a/}');
    Error('\P{Script= Katakana/a/}');
    Expect(1, 110592, '\p{Script=katakana}', "");
    Expect(0, 110592, '\p{^Script=katakana}', "");
    Expect(0, 110592, '\P{Script=katakana}', "");
    Expect(1, 110592, '\P{^Script=katakana}', "");
    Expect(0, 110593, '\p{Script=katakana}', "");
    Expect(1, 110593, '\p{^Script=katakana}', "");
    Expect(1, 110593, '\P{Script=katakana}', "");
    Expect(0, 110593, '\P{^Script=katakana}', "");
    Expect(1, 110592, '\p{Script=_katakana}', "");
    Expect(0, 110592, '\p{^Script=_katakana}', "");
    Expect(0, 110592, '\P{Script=_katakana}', "");
    Expect(1, 110592, '\P{^Script=_katakana}', "");
    Expect(0, 110593, '\p{Script=_katakana}', "");
    Expect(1, 110593, '\p{^Script=_katakana}', "");
    Expect(1, 110593, '\P{Script=_katakana}', "");
    Expect(0, 110593, '\P{^Script=_katakana}', "");
    Error('\p{Sc=/a/	 Kana}');
    Error('\P{Sc=/a/	 Kana}');
    Expect(1, 110592, '\p{Sc=kana}', "");
    Expect(0, 110592, '\p{^Sc=kana}', "");
    Expect(0, 110592, '\P{Sc=kana}', "");
    Expect(1, 110592, '\P{^Sc=kana}', "");
    Expect(0, 110593, '\p{Sc=kana}', "");
    Expect(1, 110593, '\p{^Sc=kana}', "");
    Expect(1, 110593, '\P{Sc=kana}', "");
    Expect(0, 110593, '\P{^Sc=kana}', "");
    Expect(1, 110592, '\p{Sc=	 Kana}', "");
    Expect(0, 110592, '\p{^Sc=	 Kana}', "");
    Expect(0, 110592, '\P{Sc=	 Kana}', "");
    Expect(1, 110592, '\P{^Sc=	 Kana}', "");
    Expect(0, 110593, '\p{Sc=	 Kana}', "");
    Expect(1, 110593, '\p{^Sc=	 Kana}', "");
    Expect(1, 110593, '\P{Sc=	 Kana}', "");
    Expect(0, 110593, '\P{^Sc=	 Kana}', "");
    Error('\p{Is_Script=	 katakana:=}');
    Error('\P{Is_Script=	 katakana:=}');
    Expect(1, 110592, '\p{Is_Script=katakana}', "");
    Expect(0, 110592, '\p{^Is_Script=katakana}', "");
    Expect(0, 110592, '\P{Is_Script=katakana}', "");
    Expect(1, 110592, '\P{^Is_Script=katakana}', "");
    Expect(0, 110593, '\p{Is_Script=katakana}', "");
    Expect(1, 110593, '\p{^Is_Script=katakana}', "");
    Expect(1, 110593, '\P{Is_Script=katakana}', "");
    Expect(0, 110593, '\P{^Is_Script=katakana}', "");
    Expect(1, 110592, '\p{Is_Script= 	Katakana}', "");
    Expect(0, 110592, '\p{^Is_Script= 	Katakana}', "");
    Expect(0, 110592, '\P{Is_Script= 	Katakana}', "");
    Expect(1, 110592, '\P{^Is_Script= 	Katakana}', "");
    Expect(0, 110593, '\p{Is_Script= 	Katakana}', "");
    Expect(1, 110593, '\p{^Is_Script= 	Katakana}', "");
    Expect(1, 110593, '\P{Is_Script= 	Katakana}', "");
    Expect(0, 110593, '\P{^Is_Script= 	Katakana}', "");
    Error('\p{Is_Sc=/a/-	KANA}');
    Error('\P{Is_Sc=/a/-	KANA}');
    Expect(1, 110592, '\p{Is_Sc:kana}', "");
    Expect(0, 110592, '\p{^Is_Sc:kana}', "");
    Expect(0, 110592, '\P{Is_Sc:kana}', "");
    Expect(1, 110592, '\P{^Is_Sc:kana}', "");
    Expect(0, 110593, '\p{Is_Sc:kana}', "");
    Expect(1, 110593, '\p{^Is_Sc:kana}', "");
    Expect(1, 110593, '\P{Is_Sc:kana}', "");
    Expect(0, 110593, '\P{^Is_Sc:kana}', "");
    Expect(1, 110592, '\p{Is_Sc= Kana}', "");
    Expect(0, 110592, '\p{^Is_Sc= Kana}', "");
    Expect(0, 110592, '\P{Is_Sc= Kana}', "");
    Expect(1, 110592, '\P{^Is_Sc= Kana}', "");
    Expect(0, 110593, '\p{Is_Sc= Kana}', "");
    Expect(1, 110593, '\p{^Is_Sc= Kana}', "");
    Expect(1, 110593, '\P{Is_Sc= Kana}', "");
    Expect(0, 110593, '\P{^Is_Sc= Kana}', "");
    Error('\p{Script= _Kharoshthi/a/}');
    Error('\P{Script= _Kharoshthi/a/}');
    Expect(1, 68184, '\p{Script=kharoshthi}', "");
    Expect(0, 68184, '\p{^Script=kharoshthi}', "");
    Expect(0, 68184, '\P{Script=kharoshthi}', "");
    Expect(1, 68184, '\P{^Script=kharoshthi}', "");
    Expect(0, 68185, '\p{Script=kharoshthi}', "");
    Expect(1, 68185, '\p{^Script=kharoshthi}', "");
    Expect(1, 68185, '\P{Script=kharoshthi}', "");
    Expect(0, 68185, '\P{^Script=kharoshthi}', "");
    Expect(1, 68184, '\p{Script=_-KHAROSHTHI}', "");
    Expect(0, 68184, '\p{^Script=_-KHAROSHTHI}', "");
    Expect(0, 68184, '\P{Script=_-KHAROSHTHI}', "");
    Expect(1, 68184, '\P{^Script=_-KHAROSHTHI}', "");
    Expect(0, 68185, '\p{Script=_-KHAROSHTHI}', "");
    Expect(1, 68185, '\p{^Script=_-KHAROSHTHI}', "");
    Expect(1, 68185, '\P{Script=_-KHAROSHTHI}', "");
    Expect(0, 68185, '\P{^Script=_-KHAROSHTHI}', "");
    Error('\p{Sc=/a/	_Khar}');
    Error('\P{Sc=/a/	_Khar}');
    Expect(1, 68184, '\p{Sc=khar}', "");
    Expect(0, 68184, '\p{^Sc=khar}', "");
    Expect(0, 68184, '\P{Sc=khar}', "");
    Expect(1, 68184, '\P{^Sc=khar}', "");
    Expect(0, 68185, '\p{Sc=khar}', "");
    Expect(1, 68185, '\p{^Sc=khar}', "");
    Expect(1, 68185, '\P{Sc=khar}', "");
    Expect(0, 68185, '\P{^Sc=khar}', "");
    Expect(1, 68184, '\p{Sc=  Khar}', "");
    Expect(0, 68184, '\p{^Sc=  Khar}', "");
    Expect(0, 68184, '\P{Sc=  Khar}', "");
    Expect(1, 68184, '\P{^Sc=  Khar}', "");
    Expect(0, 68185, '\p{Sc=  Khar}', "");
    Expect(1, 68185, '\p{^Sc=  Khar}', "");
    Expect(1, 68185, '\P{Sc=  Khar}', "");
    Expect(0, 68185, '\P{^Sc=  Khar}', "");
    Error('\p{Is_Script= :=kharoshthi}');
    Error('\P{Is_Script= :=kharoshthi}');
    Expect(1, 68184, '\p{Is_Script=kharoshthi}', "");
    Expect(0, 68184, '\p{^Is_Script=kharoshthi}', "");
    Expect(0, 68184, '\P{Is_Script=kharoshthi}', "");
    Expect(1, 68184, '\P{^Is_Script=kharoshthi}', "");
    Expect(0, 68185, '\p{Is_Script=kharoshthi}', "");
    Expect(1, 68185, '\p{^Is_Script=kharoshthi}', "");
    Expect(1, 68185, '\P{Is_Script=kharoshthi}', "");
    Expect(0, 68185, '\P{^Is_Script=kharoshthi}', "");
    Expect(1, 68184, '\p{Is_Script=-	Kharoshthi}', "");
    Expect(0, 68184, '\p{^Is_Script=-	Kharoshthi}', "");
    Expect(0, 68184, '\P{Is_Script=-	Kharoshthi}', "");
    Expect(1, 68184, '\P{^Is_Script=-	Kharoshthi}', "");
    Expect(0, 68185, '\p{Is_Script=-	Kharoshthi}', "");
    Expect(1, 68185, '\p{^Is_Script=-	Kharoshthi}', "");
    Expect(1, 68185, '\P{Is_Script=-	Kharoshthi}', "");
    Expect(0, 68185, '\P{^Is_Script=-	Kharoshthi}', "");
    Error('\p{Is_Sc= _khar/a/}');
    Error('\P{Is_Sc= _khar/a/}');
    Expect(1, 68184, '\p{Is_Sc=khar}', "");
    Expect(0, 68184, '\p{^Is_Sc=khar}', "");
    Expect(0, 68184, '\P{Is_Sc=khar}', "");
    Expect(1, 68184, '\P{^Is_Sc=khar}', "");
    Expect(0, 68185, '\p{Is_Sc=khar}', "");
    Expect(1, 68185, '\p{^Is_Sc=khar}', "");
    Expect(1, 68185, '\P{Is_Sc=khar}', "");
    Expect(0, 68185, '\P{^Is_Sc=khar}', "");
    Expect(1, 68184, '\p{Is_Sc=	_KHAR}', "");
    Expect(0, 68184, '\p{^Is_Sc=	_KHAR}', "");
    Expect(0, 68184, '\P{Is_Sc=	_KHAR}', "");
    Expect(1, 68184, '\P{^Is_Sc=	_KHAR}', "");
    Expect(0, 68185, '\p{Is_Sc=	_KHAR}', "");
    Expect(1, 68185, '\p{^Is_Sc=	_KHAR}', "");
    Expect(1, 68185, '\P{Is_Sc=	_KHAR}', "");
    Expect(0, 68185, '\P{^Is_Sc=	_KHAR}', "");
    Error('\p{Script:  	Khmer/a/}');
    Error('\P{Script:  	Khmer/a/}');
    Expect(1, 6655, '\p{Script=khmer}', "");
    Expect(0, 6655, '\p{^Script=khmer}', "");
    Expect(0, 6655, '\P{Script=khmer}', "");
    Expect(1, 6655, '\P{^Script=khmer}', "");
    Expect(0, 6656, '\p{Script=khmer}', "");
    Expect(1, 6656, '\p{^Script=khmer}', "");
    Expect(1, 6656, '\P{Script=khmer}', "");
    Expect(0, 6656, '\P{^Script=khmer}', "");
    Expect(1, 6655, '\p{Script=	-Khmer}', "");
    Expect(0, 6655, '\p{^Script=	-Khmer}', "");
    Expect(0, 6655, '\P{Script=	-Khmer}', "");
    Expect(1, 6655, '\P{^Script=	-Khmer}', "");
    Expect(0, 6656, '\p{Script=	-Khmer}', "");
    Expect(1, 6656, '\p{^Script=	-Khmer}', "");
    Expect(1, 6656, '\P{Script=	-Khmer}', "");
    Expect(0, 6656, '\P{^Script=	-Khmer}', "");
    Error('\p{Sc=/a/_KHMR}');
    Error('\P{Sc=/a/_KHMR}');
    Expect(1, 6655, '\p{Sc=khmr}', "");
    Expect(0, 6655, '\p{^Sc=khmr}', "");
    Expect(0, 6655, '\P{Sc=khmr}', "");
    Expect(1, 6655, '\P{^Sc=khmr}', "");
    Expect(0, 6656, '\p{Sc=khmr}', "");
    Expect(1, 6656, '\p{^Sc=khmr}', "");
    Expect(1, 6656, '\P{Sc=khmr}', "");
    Expect(0, 6656, '\P{^Sc=khmr}', "");
    Expect(1, 6655, '\p{Sc= Khmr}', "");
    Expect(0, 6655, '\p{^Sc= Khmr}', "");
    Expect(0, 6655, '\P{Sc= Khmr}', "");
    Expect(1, 6655, '\P{^Sc= Khmr}', "");
    Expect(0, 6656, '\p{Sc= Khmr}', "");
    Expect(1, 6656, '\p{^Sc= Khmr}', "");
    Expect(1, 6656, '\P{Sc= Khmr}', "");
    Expect(0, 6656, '\P{^Sc= Khmr}', "");
    Error('\p{Is_Script=_:=Khmer}');
    Error('\P{Is_Script=_:=Khmer}');
    Expect(1, 6655, '\p{Is_Script=khmer}', "");
    Expect(0, 6655, '\p{^Is_Script=khmer}', "");
    Expect(0, 6655, '\P{Is_Script=khmer}', "");
    Expect(1, 6655, '\P{^Is_Script=khmer}', "");
    Expect(0, 6656, '\p{Is_Script=khmer}', "");
    Expect(1, 6656, '\p{^Is_Script=khmer}', "");
    Expect(1, 6656, '\P{Is_Script=khmer}', "");
    Expect(0, 6656, '\P{^Is_Script=khmer}', "");
    Expect(1, 6655, '\p{Is_Script=- Khmer}', "");
    Expect(0, 6655, '\p{^Is_Script=- Khmer}', "");
    Expect(0, 6655, '\P{Is_Script=- Khmer}', "");
    Expect(1, 6655, '\P{^Is_Script=- Khmer}', "");
    Expect(0, 6656, '\p{Is_Script=- Khmer}', "");
    Expect(1, 6656, '\p{^Is_Script=- Khmer}', "");
    Expect(1, 6656, '\P{Is_Script=- Khmer}', "");
    Expect(0, 6656, '\P{^Is_Script=- Khmer}', "");
    Error('\p{Is_Sc=khmr:=}');
    Error('\P{Is_Sc=khmr:=}');
    Expect(1, 6655, '\p{Is_Sc=khmr}', "");
    Expect(0, 6655, '\p{^Is_Sc=khmr}', "");
    Expect(0, 6655, '\P{Is_Sc=khmr}', "");
    Expect(1, 6655, '\P{^Is_Sc=khmr}', "");
    Expect(0, 6656, '\p{Is_Sc=khmr}', "");
    Expect(1, 6656, '\p{^Is_Sc=khmr}', "");
    Expect(1, 6656, '\P{Is_Sc=khmr}', "");
    Expect(0, 6656, '\P{^Is_Sc=khmr}', "");
    Expect(1, 6655, '\p{Is_Sc=--khmr}', "");
    Expect(0, 6655, '\p{^Is_Sc=--khmr}', "");
    Expect(0, 6655, '\P{Is_Sc=--khmr}', "");
    Expect(1, 6655, '\P{^Is_Sc=--khmr}', "");
    Expect(0, 6656, '\p{Is_Sc=--khmr}', "");
    Expect(1, 6656, '\p{^Is_Sc=--khmr}', "");
    Expect(1, 6656, '\P{Is_Sc=--khmr}', "");
    Expect(0, 6656, '\P{^Is_Sc=--khmr}', "");
    Error('\p{Script=  Khojki/a/}');
    Error('\P{Script=  Khojki/a/}');
    Expect(1, 70206, '\p{Script=khojki}', "");
    Expect(0, 70206, '\p{^Script=khojki}', "");
    Expect(0, 70206, '\P{Script=khojki}', "");
    Expect(1, 70206, '\P{^Script=khojki}', "");
    Expect(0, 70207, '\p{Script=khojki}', "");
    Expect(1, 70207, '\p{^Script=khojki}', "");
    Expect(1, 70207, '\P{Script=khojki}', "");
    Expect(0, 70207, '\P{^Script=khojki}', "");
    Expect(1, 70206, '\p{Script:		-KHOJKI}', "");
    Expect(0, 70206, '\p{^Script:		-KHOJKI}', "");
    Expect(0, 70206, '\P{Script:		-KHOJKI}', "");
    Expect(1, 70206, '\P{^Script:		-KHOJKI}', "");
    Expect(0, 70207, '\p{Script:		-KHOJKI}', "");
    Expect(1, 70207, '\p{^Script:		-KHOJKI}', "");
    Expect(1, 70207, '\P{Script:		-KHOJKI}', "");
    Expect(0, 70207, '\P{^Script:		-KHOJKI}', "");
    Error('\p{Sc=		Khoj:=}');
    Error('\P{Sc=		Khoj:=}');
    Expect(1, 70206, '\p{Sc=khoj}', "");
    Expect(0, 70206, '\p{^Sc=khoj}', "");
    Expect(0, 70206, '\P{Sc=khoj}', "");
    Expect(1, 70206, '\P{^Sc=khoj}', "");
    Expect(0, 70207, '\p{Sc=khoj}', "");
    Expect(1, 70207, '\p{^Sc=khoj}', "");
    Expect(1, 70207, '\P{Sc=khoj}', "");
    Expect(0, 70207, '\P{^Sc=khoj}', "");
    Expect(1, 70206, '\p{Sc=  KHOJ}', "");
    Expect(0, 70206, '\p{^Sc=  KHOJ}', "");
    Expect(0, 70206, '\P{Sc=  KHOJ}', "");
    Expect(1, 70206, '\P{^Sc=  KHOJ}', "");
    Expect(0, 70207, '\p{Sc=  KHOJ}', "");
    Expect(1, 70207, '\p{^Sc=  KHOJ}', "");
    Expect(1, 70207, '\P{Sc=  KHOJ}', "");
    Expect(0, 70207, '\P{^Sc=  KHOJ}', "");
    Error('\p{Is_Script= :=khojki}');
    Error('\P{Is_Script= :=khojki}');
    Expect(1, 70206, '\p{Is_Script=khojki}', "");
    Expect(0, 70206, '\p{^Is_Script=khojki}', "");
    Expect(0, 70206, '\P{Is_Script=khojki}', "");
    Expect(1, 70206, '\P{^Is_Script=khojki}', "");
    Expect(0, 70207, '\p{Is_Script=khojki}', "");
    Expect(1, 70207, '\p{^Is_Script=khojki}', "");
    Expect(1, 70207, '\P{Is_Script=khojki}', "");
    Expect(0, 70207, '\P{^Is_Script=khojki}', "");
    Expect(1, 70206, '\p{Is_Script=-khojki}', "");
    Expect(0, 70206, '\p{^Is_Script=-khojki}', "");
    Expect(0, 70206, '\P{Is_Script=-khojki}', "");
    Expect(1, 70206, '\P{^Is_Script=-khojki}', "");
    Expect(0, 70207, '\p{Is_Script=-khojki}', "");
    Expect(1, 70207, '\p{^Is_Script=-khojki}', "");
    Expect(1, 70207, '\P{Is_Script=-khojki}', "");
    Expect(0, 70207, '\P{^Is_Script=-khojki}', "");
    Error('\p{Is_Sc=_/a/Khoj}');
    Error('\P{Is_Sc=_/a/Khoj}');
    Expect(1, 70206, '\p{Is_Sc=khoj}', "");
    Expect(0, 70206, '\p{^Is_Sc=khoj}', "");
    Expect(0, 70206, '\P{Is_Sc=khoj}', "");
    Expect(1, 70206, '\P{^Is_Sc=khoj}', "");
    Expect(0, 70207, '\p{Is_Sc=khoj}', "");
    Expect(1, 70207, '\p{^Is_Sc=khoj}', "");
    Expect(1, 70207, '\P{Is_Sc=khoj}', "");
    Expect(0, 70207, '\P{^Is_Sc=khoj}', "");
    Expect(1, 70206, '\p{Is_Sc=-	khoj}', "");
    Expect(0, 70206, '\p{^Is_Sc=-	khoj}', "");
    Expect(0, 70206, '\P{Is_Sc=-	khoj}', "");
    Expect(1, 70206, '\P{^Is_Sc=-	khoj}', "");
    Expect(0, 70207, '\p{Is_Sc=-	khoj}', "");
    Expect(1, 70207, '\p{^Is_Sc=-	khoj}', "");
    Expect(1, 70207, '\P{Is_Sc=-	khoj}', "");
    Expect(0, 70207, '\P{^Is_Sc=-	khoj}', "");
    Error('\p{Script=:=_	Kannada}');
    Error('\P{Script=:=_	Kannada}');
    Expect(1, 3314, '\p{Script=kannada}', "");
    Expect(0, 3314, '\p{^Script=kannada}', "");
    Expect(0, 3314, '\P{Script=kannada}', "");
    Expect(1, 3314, '\P{^Script=kannada}', "");
    Expect(0, 3315, '\p{Script=kannada}', "");
    Expect(1, 3315, '\p{^Script=kannada}', "");
    Expect(1, 3315, '\P{Script=kannada}', "");
    Expect(0, 3315, '\P{^Script=kannada}', "");
    Expect(1, 3314, '\p{Script=_-Kannada}', "");
    Expect(0, 3314, '\p{^Script=_-Kannada}', "");
    Expect(0, 3314, '\P{Script=_-Kannada}', "");
    Expect(1, 3314, '\P{^Script=_-Kannada}', "");
    Expect(0, 3315, '\p{Script=_-Kannada}', "");
    Expect(1, 3315, '\p{^Script=_-Kannada}', "");
    Expect(1, 3315, '\P{Script=_-Kannada}', "");
    Expect(0, 3315, '\P{^Script=_-Kannada}', "");
    Error('\p{Sc=:=_	Knda}');
    Error('\P{Sc=:=_	Knda}');
    Expect(1, 3314, '\p{Sc=knda}', "");
    Expect(0, 3314, '\p{^Sc=knda}', "");
    Expect(0, 3314, '\P{Sc=knda}', "");
    Expect(1, 3314, '\P{^Sc=knda}', "");
    Expect(0, 3315, '\p{Sc=knda}', "");
    Expect(1, 3315, '\p{^Sc=knda}', "");
    Expect(1, 3315, '\P{Sc=knda}', "");
    Expect(0, 3315, '\P{^Sc=knda}', "");
    Expect(1, 3314, '\p{Sc:-knda}', "");
    Expect(0, 3314, '\p{^Sc:-knda}', "");
    Expect(0, 3314, '\P{Sc:-knda}', "");
    Expect(1, 3314, '\P{^Sc:-knda}', "");
    Expect(0, 3315, '\p{Sc:-knda}', "");
    Expect(1, 3315, '\p{^Sc:-knda}', "");
    Expect(1, 3315, '\P{Sc:-knda}', "");
    Expect(0, 3315, '\P{^Sc:-knda}', "");
    Error('\p{Is_Script=/a/ -Kannada}');
    Error('\P{Is_Script=/a/ -Kannada}');
    Expect(1, 3314, '\p{Is_Script=kannada}', "");
    Expect(0, 3314, '\p{^Is_Script=kannada}', "");
    Expect(0, 3314, '\P{Is_Script=kannada}', "");
    Expect(1, 3314, '\P{^Is_Script=kannada}', "");
    Expect(0, 3315, '\p{Is_Script=kannada}', "");
    Expect(1, 3315, '\p{^Is_Script=kannada}', "");
    Expect(1, 3315, '\P{Is_Script=kannada}', "");
    Expect(0, 3315, '\P{^Is_Script=kannada}', "");
    Expect(1, 3314, '\p{Is_Script=_	Kannada}', "");
    Expect(0, 3314, '\p{^Is_Script=_	Kannada}', "");
    Expect(0, 3314, '\P{Is_Script=_	Kannada}', "");
    Expect(1, 3314, '\P{^Is_Script=_	Kannada}', "");
    Expect(0, 3315, '\p{Is_Script=_	Kannada}', "");
    Expect(1, 3315, '\p{^Is_Script=_	Kannada}', "");
    Expect(1, 3315, '\P{Is_Script=_	Kannada}', "");
    Expect(0, 3315, '\P{^Is_Script=_	Kannada}', "");
    Error('\p{Is_Sc=/a/Knda}');
    Error('\P{Is_Sc=/a/Knda}');
    Expect(1, 3314, '\p{Is_Sc:   knda}', "");
    Expect(0, 3314, '\p{^Is_Sc:   knda}', "");
    Expect(0, 3314, '\P{Is_Sc:   knda}', "");
    Expect(1, 3314, '\P{^Is_Sc:   knda}', "");
    Expect(0, 3315, '\p{Is_Sc:   knda}', "");
    Expect(1, 3315, '\p{^Is_Sc:   knda}', "");
    Expect(1, 3315, '\P{Is_Sc:   knda}', "");
    Expect(0, 3315, '\P{^Is_Sc:   knda}', "");
    Expect(1, 3314, '\p{Is_Sc=_	KNDA}', "");
    Expect(0, 3314, '\p{^Is_Sc=_	KNDA}', "");
    Expect(0, 3314, '\P{Is_Sc=_	KNDA}', "");
    Expect(1, 3314, '\P{^Is_Sc=_	KNDA}', "");
    Expect(0, 3315, '\p{Is_Sc=_	KNDA}', "");
    Expect(1, 3315, '\p{^Is_Sc=_	KNDA}', "");
    Expect(1, 3315, '\P{Is_Sc=_	KNDA}', "");
    Expect(0, 3315, '\P{^Is_Sc=_	KNDA}', "");
    Error('\p{Script=	/a/Kaithi}');
    Error('\P{Script=	/a/Kaithi}');
    Expect(1, 69825, '\p{Script=kaithi}', "");
    Expect(0, 69825, '\p{^Script=kaithi}', "");
    Expect(0, 69825, '\P{Script=kaithi}', "");
    Expect(1, 69825, '\P{^Script=kaithi}', "");
    Expect(0, 69826, '\p{Script=kaithi}', "");
    Expect(1, 69826, '\p{^Script=kaithi}', "");
    Expect(1, 69826, '\P{Script=kaithi}', "");
    Expect(0, 69826, '\P{^Script=kaithi}', "");
    Expect(1, 69825, '\p{Script=	kaithi}', "");
    Expect(0, 69825, '\p{^Script=	kaithi}', "");
    Expect(0, 69825, '\P{Script=	kaithi}', "");
    Expect(1, 69825, '\P{^Script=	kaithi}', "");
    Expect(0, 69826, '\p{Script=	kaithi}', "");
    Expect(1, 69826, '\p{^Script=	kaithi}', "");
    Expect(1, 69826, '\P{Script=	kaithi}', "");
    Expect(0, 69826, '\P{^Script=	kaithi}', "");
    Error('\p{Sc= KTHI/a/}');
    Error('\P{Sc= KTHI/a/}');
    Expect(1, 69825, '\p{Sc:   kthi}', "");
    Expect(0, 69825, '\p{^Sc:   kthi}', "");
    Expect(0, 69825, '\P{Sc:   kthi}', "");
    Expect(1, 69825, '\P{^Sc:   kthi}', "");
    Expect(0, 69826, '\p{Sc:   kthi}', "");
    Expect(1, 69826, '\p{^Sc:   kthi}', "");
    Expect(1, 69826, '\P{Sc:   kthi}', "");
    Expect(0, 69826, '\P{^Sc:   kthi}', "");
    Expect(1, 69825, '\p{Sc=Kthi}', "");
    Expect(0, 69825, '\p{^Sc=Kthi}', "");
    Expect(0, 69825, '\P{Sc=Kthi}', "");
    Expect(1, 69825, '\P{^Sc=Kthi}', "");
    Expect(0, 69826, '\p{Sc=Kthi}', "");
    Expect(1, 69826, '\p{^Sc=Kthi}', "");
    Expect(1, 69826, '\P{Sc=Kthi}', "");
    Expect(0, 69826, '\P{^Sc=Kthi}', "");
    Error('\p{Is_Script=-:=kaithi}');
    Error('\P{Is_Script=-:=kaithi}');
    Expect(1, 69825, '\p{Is_Script=kaithi}', "");
    Expect(0, 69825, '\p{^Is_Script=kaithi}', "");
    Expect(0, 69825, '\P{Is_Script=kaithi}', "");
    Expect(1, 69825, '\P{^Is_Script=kaithi}', "");
    Expect(0, 69826, '\p{Is_Script=kaithi}', "");
    Expect(1, 69826, '\p{^Is_Script=kaithi}', "");
    Expect(1, 69826, '\P{Is_Script=kaithi}', "");
    Expect(0, 69826, '\P{^Is_Script=kaithi}', "");
    Expect(1, 69825, '\p{Is_Script= kaithi}', "");
    Expect(0, 69825, '\p{^Is_Script= kaithi}', "");
    Expect(0, 69825, '\P{Is_Script= kaithi}', "");
    Expect(1, 69825, '\P{^Is_Script= kaithi}', "");
    Expect(0, 69826, '\p{Is_Script= kaithi}', "");
    Expect(1, 69826, '\p{^Is_Script= kaithi}', "");
    Expect(1, 69826, '\P{Is_Script= kaithi}', "");
    Expect(0, 69826, '\P{^Is_Script= kaithi}', "");
    Error('\p{Is_Sc=/a/-	KTHI}');
    Error('\P{Is_Sc=/a/-	KTHI}');
    Expect(1, 69825, '\p{Is_Sc=kthi}', "");
    Expect(0, 69825, '\p{^Is_Sc=kthi}', "");
    Expect(0, 69825, '\P{Is_Sc=kthi}', "");
    Expect(1, 69825, '\P{^Is_Sc=kthi}', "");
    Expect(0, 69826, '\p{Is_Sc=kthi}', "");
    Expect(1, 69826, '\p{^Is_Sc=kthi}', "");
    Expect(1, 69826, '\P{Is_Sc=kthi}', "");
    Expect(0, 69826, '\P{^Is_Sc=kthi}', "");
    Expect(1, 69825, '\p{Is_Sc= Kthi}', "");
    Expect(0, 69825, '\p{^Is_Sc= Kthi}', "");
    Expect(0, 69825, '\P{Is_Sc= Kthi}', "");
    Expect(1, 69825, '\P{^Is_Sc= Kthi}', "");
    Expect(0, 69826, '\p{Is_Sc= Kthi}', "");
    Expect(1, 69826, '\p{^Is_Sc= Kthi}', "");
    Expect(1, 69826, '\P{Is_Sc= Kthi}', "");
    Expect(0, 69826, '\P{^Is_Sc= Kthi}', "");
    Error('\p{Script::=	TAI_THAM}');
    Error('\P{Script::=	TAI_THAM}');
    Expect(1, 6829, '\p{Script:   taitham}', "");
    Expect(0, 6829, '\p{^Script:   taitham}', "");
    Expect(0, 6829, '\P{Script:   taitham}', "");
    Expect(1, 6829, '\P{^Script:   taitham}', "");
    Expect(0, 6830, '\p{Script:   taitham}', "");
    Expect(1, 6830, '\p{^Script:   taitham}', "");
    Expect(1, 6830, '\P{Script:   taitham}', "");
    Expect(0, 6830, '\P{^Script:   taitham}', "");
    Expect(1, 6829, '\p{Script=- Tai_Tham}', "");
    Expect(0, 6829, '\p{^Script=- Tai_Tham}', "");
    Expect(0, 6829, '\P{Script=- Tai_Tham}', "");
    Expect(1, 6829, '\P{^Script=- Tai_Tham}', "");
    Expect(0, 6830, '\p{Script=- Tai_Tham}', "");
    Expect(1, 6830, '\p{^Script=- Tai_Tham}', "");
    Expect(1, 6830, '\P{Script=- Tai_Tham}', "");
    Expect(0, 6830, '\P{^Script=- Tai_Tham}', "");
    Error('\p{Sc=:=	LANA}');
    Error('\P{Sc=:=	LANA}');
    Expect(1, 6829, '\p{Sc=lana}', "");
    Expect(0, 6829, '\p{^Sc=lana}', "");
    Expect(0, 6829, '\P{Sc=lana}', "");
    Expect(1, 6829, '\P{^Sc=lana}', "");
    Expect(0, 6830, '\p{Sc=lana}', "");
    Expect(1, 6830, '\p{^Sc=lana}', "");
    Expect(1, 6830, '\P{Sc=lana}', "");
    Expect(0, 6830, '\P{^Sc=lana}', "");
    Expect(1, 6829, '\p{Sc=_lana}', "");
    Expect(0, 6829, '\p{^Sc=_lana}', "");
    Expect(0, 6829, '\P{Sc=_lana}', "");
    Expect(1, 6829, '\P{^Sc=_lana}', "");
    Expect(0, 6830, '\p{Sc=_lana}', "");
    Expect(1, 6830, '\p{^Sc=_lana}', "");
    Expect(1, 6830, '\P{Sc=_lana}', "");
    Expect(0, 6830, '\P{^Sc=_lana}', "");
    Error('\p{Is_Script=:=--tai_tham}');
    Error('\P{Is_Script=:=--tai_tham}');
    Expect(1, 6829, '\p{Is_Script=taitham}', "");
    Expect(0, 6829, '\p{^Is_Script=taitham}', "");
    Expect(0, 6829, '\P{Is_Script=taitham}', "");
    Expect(1, 6829, '\P{^Is_Script=taitham}', "");
    Expect(0, 6830, '\p{Is_Script=taitham}', "");
    Expect(1, 6830, '\p{^Is_Script=taitham}', "");
    Expect(1, 6830, '\P{Is_Script=taitham}', "");
    Expect(0, 6830, '\P{^Is_Script=taitham}', "");
    Expect(1, 6829, '\p{Is_Script=	Tai_Tham}', "");
    Expect(0, 6829, '\p{^Is_Script=	Tai_Tham}', "");
    Expect(0, 6829, '\P{Is_Script=	Tai_Tham}', "");
    Expect(1, 6829, '\P{^Is_Script=	Tai_Tham}', "");
    Expect(0, 6830, '\p{Is_Script=	Tai_Tham}', "");
    Expect(1, 6830, '\p{^Is_Script=	Tai_Tham}', "");
    Expect(1, 6830, '\P{Is_Script=	Tai_Tham}', "");
    Expect(0, 6830, '\P{^Is_Script=	Tai_Tham}', "");
    Error('\p{Is_Sc:	 lana/a/}');
    Error('\P{Is_Sc:	 lana/a/}');
    Expect(1, 6829, '\p{Is_Sc=lana}', "");
    Expect(0, 6829, '\p{^Is_Sc=lana}', "");
    Expect(0, 6829, '\P{Is_Sc=lana}', "");
    Expect(1, 6829, '\P{^Is_Sc=lana}', "");
    Expect(0, 6830, '\p{Is_Sc=lana}', "");
    Expect(1, 6830, '\p{^Is_Sc=lana}', "");
    Expect(1, 6830, '\P{Is_Sc=lana}', "");
    Expect(0, 6830, '\P{^Is_Sc=lana}', "");
    Expect(1, 6829, '\p{Is_Sc= 	lana}', "");
    Expect(0, 6829, '\p{^Is_Sc= 	lana}', "");
    Expect(0, 6829, '\P{Is_Sc= 	lana}', "");
    Expect(1, 6829, '\P{^Is_Sc= 	lana}', "");
    Expect(0, 6830, '\p{Is_Sc= 	lana}', "");
    Expect(1, 6830, '\p{^Is_Sc= 	lana}', "");
    Expect(1, 6830, '\P{Is_Sc= 	lana}', "");
    Expect(0, 6830, '\P{^Is_Sc= 	lana}', "");
    Error('\p{Script=/a/-_lao}');
    Error('\P{Script=/a/-_lao}');
    Expect(1, 3807, '\p{Script=lao}', "");
    Expect(0, 3807, '\p{^Script=lao}', "");
    Expect(0, 3807, '\P{Script=lao}', "");
    Expect(1, 3807, '\P{^Script=lao}', "");
    Expect(0, 3808, '\p{Script=lao}', "");
    Expect(1, 3808, '\p{^Script=lao}', "");
    Expect(1, 3808, '\P{Script=lao}', "");
    Expect(0, 3808, '\P{^Script=lao}', "");
    Expect(1, 3807, '\p{Script=	LAO}', "");
    Expect(0, 3807, '\p{^Script=	LAO}', "");
    Expect(0, 3807, '\P{Script=	LAO}', "");
    Expect(1, 3807, '\P{^Script=	LAO}', "");
    Expect(0, 3808, '\p{Script=	LAO}', "");
    Expect(1, 3808, '\p{^Script=	LAO}', "");
    Expect(1, 3808, '\P{Script=	LAO}', "");
    Expect(0, 3808, '\P{^Script=	LAO}', "");
    Error('\p{Sc=_:=laoo}');
    Error('\P{Sc=_:=laoo}');
    Expect(1, 3807, '\p{Sc=laoo}', "");
    Expect(0, 3807, '\p{^Sc=laoo}', "");
    Expect(0, 3807, '\P{Sc=laoo}', "");
    Expect(1, 3807, '\P{^Sc=laoo}', "");
    Expect(0, 3808, '\p{Sc=laoo}', "");
    Expect(1, 3808, '\p{^Sc=laoo}', "");
    Expect(1, 3808, '\P{Sc=laoo}', "");
    Expect(0, 3808, '\P{^Sc=laoo}', "");
    Expect(1, 3807, '\p{Sc:   		Laoo}', "");
    Expect(0, 3807, '\p{^Sc:   		Laoo}', "");
    Expect(0, 3807, '\P{Sc:   		Laoo}', "");
    Expect(1, 3807, '\P{^Sc:   		Laoo}', "");
    Expect(0, 3808, '\p{Sc:   		Laoo}', "");
    Expect(1, 3808, '\p{^Sc:   		Laoo}', "");
    Expect(1, 3808, '\P{Sc:   		Laoo}', "");
    Expect(0, 3808, '\P{^Sc:   		Laoo}', "");
    Error('\p{Is_Script:	/a/-_Lao}');
    Error('\P{Is_Script:	/a/-_Lao}');
    Expect(1, 3807, '\p{Is_Script=lao}', "");
    Expect(0, 3807, '\p{^Is_Script=lao}', "");
    Expect(0, 3807, '\P{Is_Script=lao}', "");
    Expect(1, 3807, '\P{^Is_Script=lao}', "");
    Expect(0, 3808, '\p{Is_Script=lao}', "");
    Expect(1, 3808, '\p{^Is_Script=lao}', "");
    Expect(1, 3808, '\P{Is_Script=lao}', "");
    Expect(0, 3808, '\P{^Is_Script=lao}', "");
    Expect(1, 3807, '\p{Is_Script: LAO}', "");
    Expect(0, 3807, '\p{^Is_Script: LAO}', "");
    Expect(0, 3807, '\P{Is_Script: LAO}', "");
    Expect(1, 3807, '\P{^Is_Script: LAO}', "");
    Expect(0, 3808, '\p{Is_Script: LAO}', "");
    Expect(1, 3808, '\p{^Is_Script: LAO}', "");
    Expect(1, 3808, '\P{Is_Script: LAO}', "");
    Expect(0, 3808, '\P{^Is_Script: LAO}', "");
    Error('\p{Is_Sc=/a/--LAOO}');
    Error('\P{Is_Sc=/a/--LAOO}');
    Expect(1, 3807, '\p{Is_Sc=laoo}', "");
    Expect(0, 3807, '\p{^Is_Sc=laoo}', "");
    Expect(0, 3807, '\P{Is_Sc=laoo}', "");
    Expect(1, 3807, '\P{^Is_Sc=laoo}', "");
    Expect(0, 3808, '\p{Is_Sc=laoo}', "");
    Expect(1, 3808, '\p{^Is_Sc=laoo}', "");
    Expect(1, 3808, '\P{Is_Sc=laoo}', "");
    Expect(0, 3808, '\P{^Is_Sc=laoo}', "");
    Expect(1, 3807, '\p{Is_Sc= laoo}', "");
    Expect(0, 3807, '\p{^Is_Sc= laoo}', "");
    Expect(0, 3807, '\P{Is_Sc= laoo}', "");
    Expect(1, 3807, '\P{^Is_Sc= laoo}', "");
    Expect(0, 3808, '\p{Is_Sc= laoo}', "");
    Expect(1, 3808, '\p{^Is_Sc= laoo}', "");
    Expect(1, 3808, '\P{Is_Sc= laoo}', "");
    Expect(0, 3808, '\P{^Is_Sc= laoo}', "");
    Error('\p{Script=/a/		LATIN}');
    Error('\P{Script=/a/		LATIN}');
    Expect(1, 65370, '\p{Script=latin}', "");
    Expect(0, 65370, '\p{^Script=latin}', "");
    Expect(0, 65370, '\P{Script=latin}', "");
    Expect(1, 65370, '\P{^Script=latin}', "");
    Expect(0, 65371, '\p{Script=latin}', "");
    Expect(1, 65371, '\p{^Script=latin}', "");
    Expect(1, 65371, '\P{Script=latin}', "");
    Expect(0, 65371, '\P{^Script=latin}', "");
    Expect(1, 65370, '\p{Script:		LATIN}', "");
    Expect(0, 65370, '\p{^Script:		LATIN}', "");
    Expect(0, 65370, '\P{Script:		LATIN}', "");
    Expect(1, 65370, '\P{^Script:		LATIN}', "");
    Expect(0, 65371, '\p{Script:		LATIN}', "");
    Expect(1, 65371, '\p{^Script:		LATIN}', "");
    Expect(1, 65371, '\P{Script:		LATIN}', "");
    Expect(0, 65371, '\P{^Script:		LATIN}', "");
    Error('\p{Sc=- Latn/a/}');
    Error('\P{Sc=- Latn/a/}');
    Expect(1, 65370, '\p{Sc=latn}', "");
    Expect(0, 65370, '\p{^Sc=latn}', "");
    Expect(0, 65370, '\P{Sc=latn}', "");
    Expect(1, 65370, '\P{^Sc=latn}', "");
    Expect(0, 65371, '\p{Sc=latn}', "");
    Expect(1, 65371, '\p{^Sc=latn}', "");
    Expect(1, 65371, '\P{Sc=latn}', "");
    Expect(0, 65371, '\P{^Sc=latn}', "");
    Expect(1, 65370, '\p{Sc=		LATN}', "");
    Expect(0, 65370, '\p{^Sc=		LATN}', "");
    Expect(0, 65370, '\P{Sc=		LATN}', "");
    Expect(1, 65370, '\P{^Sc=		LATN}', "");
    Expect(0, 65371, '\p{Sc=		LATN}', "");
    Expect(1, 65371, '\p{^Sc=		LATN}', "");
    Expect(1, 65371, '\P{Sc=		LATN}', "");
    Expect(0, 65371, '\P{^Sc=		LATN}', "");
    Error('\p{Is_Script=:= _Latin}');
    Error('\P{Is_Script=:= _Latin}');
    Expect(1, 65370, '\p{Is_Script=latin}', "");
    Expect(0, 65370, '\p{^Is_Script=latin}', "");
    Expect(0, 65370, '\P{Is_Script=latin}', "");
    Expect(1, 65370, '\P{^Is_Script=latin}', "");
    Expect(0, 65371, '\p{Is_Script=latin}', "");
    Expect(1, 65371, '\p{^Is_Script=latin}', "");
    Expect(1, 65371, '\P{Is_Script=latin}', "");
    Expect(0, 65371, '\P{^Is_Script=latin}', "");
    Expect(1, 65370, '\p{Is_Script=_	Latin}', "");
    Expect(0, 65370, '\p{^Is_Script=_	Latin}', "");
    Expect(0, 65370, '\P{Is_Script=_	Latin}', "");
    Expect(1, 65370, '\P{^Is_Script=_	Latin}', "");
    Expect(0, 65371, '\p{Is_Script=_	Latin}', "");
    Expect(1, 65371, '\p{^Is_Script=_	Latin}', "");
    Expect(1, 65371, '\P{Is_Script=_	Latin}', "");
    Expect(0, 65371, '\P{^Is_Script=_	Latin}', "");
    Error('\p{Is_Sc=:=Latn}');
    Error('\P{Is_Sc=:=Latn}');
    Expect(1, 65370, '\p{Is_Sc=latn}', "");
    Expect(0, 65370, '\p{^Is_Sc=latn}', "");
    Expect(0, 65370, '\P{Is_Sc=latn}', "");
    Expect(1, 65370, '\P{^Is_Sc=latn}', "");
    Expect(0, 65371, '\p{Is_Sc=latn}', "");
    Expect(1, 65371, '\p{^Is_Sc=latn}', "");
    Expect(1, 65371, '\P{Is_Sc=latn}', "");
    Expect(0, 65371, '\P{^Is_Sc=latn}', "");
    Expect(1, 65370, '\p{Is_Sc=	-latn}', "");
    Expect(0, 65370, '\p{^Is_Sc=	-latn}', "");
    Expect(0, 65370, '\P{Is_Sc=	-latn}', "");
    Expect(1, 65370, '\P{^Is_Sc=	-latn}', "");
    Expect(0, 65371, '\p{Is_Sc=	-latn}', "");
    Expect(1, 65371, '\p{^Is_Sc=	-latn}', "");
    Expect(1, 65371, '\P{Is_Sc=	-latn}', "");
    Expect(0, 65371, '\P{^Is_Sc=	-latn}', "");
    Error('\p{Script=_-Lepcha:=}');
    Error('\P{Script=_-Lepcha:=}');
    Expect(1, 7247, '\p{Script=lepcha}', "");
    Expect(0, 7247, '\p{^Script=lepcha}', "");
    Expect(0, 7247, '\P{Script=lepcha}', "");
    Expect(1, 7247, '\P{^Script=lepcha}', "");
    Expect(0, 7248, '\p{Script=lepcha}', "");
    Expect(1, 7248, '\p{^Script=lepcha}', "");
    Expect(1, 7248, '\P{Script=lepcha}', "");
    Expect(0, 7248, '\P{^Script=lepcha}', "");
    Expect(1, 7247, '\p{Script=_LEPCHA}', "");
    Expect(0, 7247, '\p{^Script=_LEPCHA}', "");
    Expect(0, 7247, '\P{Script=_LEPCHA}', "");
    Expect(1, 7247, '\P{^Script=_LEPCHA}', "");
    Expect(0, 7248, '\p{Script=_LEPCHA}', "");
    Expect(1, 7248, '\p{^Script=_LEPCHA}', "");
    Expect(1, 7248, '\P{Script=_LEPCHA}', "");
    Expect(0, 7248, '\P{^Script=_LEPCHA}', "");
    Error('\p{Sc=-/a/Lepc}');
    Error('\P{Sc=-/a/Lepc}');
    Expect(1, 7247, '\p{Sc=lepc}', "");
    Expect(0, 7247, '\p{^Sc=lepc}', "");
    Expect(0, 7247, '\P{Sc=lepc}', "");
    Expect(1, 7247, '\P{^Sc=lepc}', "");
    Expect(0, 7248, '\p{Sc=lepc}', "");
    Expect(1, 7248, '\p{^Sc=lepc}', "");
    Expect(1, 7248, '\P{Sc=lepc}', "");
    Expect(0, 7248, '\P{^Sc=lepc}', "");
    Expect(1, 7247, '\p{Sc=_Lepc}', "");
    Expect(0, 7247, '\p{^Sc=_Lepc}', "");
    Expect(0, 7247, '\P{Sc=_Lepc}', "");
    Expect(1, 7247, '\P{^Sc=_Lepc}', "");
    Expect(0, 7248, '\p{Sc=_Lepc}', "");
    Expect(1, 7248, '\p{^Sc=_Lepc}', "");
    Expect(1, 7248, '\P{Sc=_Lepc}', "");
    Expect(0, 7248, '\P{^Sc=_Lepc}', "");
    Error('\p{Is_Script=	_Lepcha/a/}');
    Error('\P{Is_Script=	_Lepcha/a/}');
    Expect(1, 7247, '\p{Is_Script=lepcha}', "");
    Expect(0, 7247, '\p{^Is_Script=lepcha}', "");
    Expect(0, 7247, '\P{Is_Script=lepcha}', "");
    Expect(1, 7247, '\P{^Is_Script=lepcha}', "");
    Expect(0, 7248, '\p{Is_Script=lepcha}', "");
    Expect(1, 7248, '\p{^Is_Script=lepcha}', "");
    Expect(1, 7248, '\P{Is_Script=lepcha}', "");
    Expect(0, 7248, '\P{^Is_Script=lepcha}', "");
    Expect(1, 7247, '\p{Is_Script=-	lepcha}', "");
    Expect(0, 7247, '\p{^Is_Script=-	lepcha}', "");
    Expect(0, 7247, '\P{Is_Script=-	lepcha}', "");
    Expect(1, 7247, '\P{^Is_Script=-	lepcha}', "");
    Expect(0, 7248, '\p{Is_Script=-	lepcha}', "");
    Expect(1, 7248, '\p{^Is_Script=-	lepcha}', "");
    Expect(1, 7248, '\P{Is_Script=-	lepcha}', "");
    Expect(0, 7248, '\P{^Is_Script=-	lepcha}', "");
    Error('\p{Is_Sc=_/a/LEPC}');
    Error('\P{Is_Sc=_/a/LEPC}');
    Expect(1, 7247, '\p{Is_Sc: lepc}', "");
    Expect(0, 7247, '\p{^Is_Sc: lepc}', "");
    Expect(0, 7247, '\P{Is_Sc: lepc}', "");
    Expect(1, 7247, '\P{^Is_Sc: lepc}', "");
    Expect(0, 7248, '\p{Is_Sc: lepc}', "");
    Expect(1, 7248, '\p{^Is_Sc: lepc}', "");
    Expect(1, 7248, '\P{Is_Sc: lepc}', "");
    Expect(0, 7248, '\P{^Is_Sc: lepc}', "");
    Expect(1, 7247, '\p{Is_Sc=	-Lepc}', "");
    Expect(0, 7247, '\p{^Is_Sc=	-Lepc}', "");
    Expect(0, 7247, '\P{Is_Sc=	-Lepc}', "");
    Expect(1, 7247, '\P{^Is_Sc=	-Lepc}', "");
    Expect(0, 7248, '\p{Is_Sc=	-Lepc}', "");
    Expect(1, 7248, '\p{^Is_Sc=	-Lepc}', "");
    Expect(1, 7248, '\P{Is_Sc=	-Lepc}', "");
    Expect(0, 7248, '\P{^Is_Sc=	-Lepc}', "");
    Error('\p{Script=	limbu:=}');
    Error('\P{Script=	limbu:=}');
    Expect(1, 6479, '\p{Script=limbu}', "");
    Expect(0, 6479, '\p{^Script=limbu}', "");
    Expect(0, 6479, '\P{Script=limbu}', "");
    Expect(1, 6479, '\P{^Script=limbu}', "");
    Expect(0, 6480, '\p{Script=limbu}', "");
    Expect(1, 6480, '\p{^Script=limbu}', "");
    Expect(1, 6480, '\P{Script=limbu}', "");
    Expect(0, 6480, '\P{^Script=limbu}', "");
    Expect(1, 6479, '\p{Script=-limbu}', "");
    Expect(0, 6479, '\p{^Script=-limbu}', "");
    Expect(0, 6479, '\P{Script=-limbu}', "");
    Expect(1, 6479, '\P{^Script=-limbu}', "");
    Expect(0, 6480, '\p{Script=-limbu}', "");
    Expect(1, 6480, '\p{^Script=-limbu}', "");
    Expect(1, 6480, '\P{Script=-limbu}', "");
    Expect(0, 6480, '\P{^Script=-limbu}', "");
    Error('\p{Sc=	:=limb}');
    Error('\P{Sc=	:=limb}');
    Expect(1, 6479, '\p{Sc=limb}', "");
    Expect(0, 6479, '\p{^Sc=limb}', "");
    Expect(0, 6479, '\P{Sc=limb}', "");
    Expect(1, 6479, '\P{^Sc=limb}', "");
    Expect(0, 6480, '\p{Sc=limb}', "");
    Expect(1, 6480, '\p{^Sc=limb}', "");
    Expect(1, 6480, '\P{Sc=limb}', "");
    Expect(0, 6480, '\P{^Sc=limb}', "");
    Expect(1, 6479, '\p{Sc=	Limb}', "");
    Expect(0, 6479, '\p{^Sc=	Limb}', "");
    Expect(0, 6479, '\P{Sc=	Limb}', "");
    Expect(1, 6479, '\P{^Sc=	Limb}', "");
    Expect(0, 6480, '\p{Sc=	Limb}', "");
    Expect(1, 6480, '\p{^Sc=	Limb}', "");
    Expect(1, 6480, '\P{Sc=	Limb}', "");
    Expect(0, 6480, '\P{^Sc=	Limb}', "");
    Error('\p{Is_Script=_:=Limbu}');
    Error('\P{Is_Script=_:=Limbu}');
    Expect(1, 6479, '\p{Is_Script=limbu}', "");
    Expect(0, 6479, '\p{^Is_Script=limbu}', "");
    Expect(0, 6479, '\P{Is_Script=limbu}', "");
    Expect(1, 6479, '\P{^Is_Script=limbu}', "");
    Expect(0, 6480, '\p{Is_Script=limbu}', "");
    Expect(1, 6480, '\p{^Is_Script=limbu}', "");
    Expect(1, 6480, '\P{Is_Script=limbu}', "");
    Expect(0, 6480, '\P{^Is_Script=limbu}', "");
    Expect(1, 6479, '\p{Is_Script= -Limbu}', "");
    Expect(0, 6479, '\p{^Is_Script= -Limbu}', "");
    Expect(0, 6479, '\P{Is_Script= -Limbu}', "");
    Expect(1, 6479, '\P{^Is_Script= -Limbu}', "");
    Expect(0, 6480, '\p{Is_Script= -Limbu}', "");
    Expect(1, 6480, '\p{^Is_Script= -Limbu}', "");
    Expect(1, 6480, '\P{Is_Script= -Limbu}', "");
    Expect(0, 6480, '\P{^Is_Script= -Limbu}', "");
    Error('\p{Is_Sc=- limb:=}');
    Error('\P{Is_Sc=- limb:=}');
    Expect(1, 6479, '\p{Is_Sc=limb}', "");
    Expect(0, 6479, '\p{^Is_Sc=limb}', "");
    Expect(0, 6479, '\P{Is_Sc=limb}', "");
    Expect(1, 6479, '\P{^Is_Sc=limb}', "");
    Expect(0, 6480, '\p{Is_Sc=limb}', "");
    Expect(1, 6480, '\p{^Is_Sc=limb}', "");
    Expect(1, 6480, '\P{Is_Sc=limb}', "");
    Expect(0, 6480, '\P{^Is_Sc=limb}', "");
    Expect(1, 6479, '\p{Is_Sc=_ LIMB}', "");
    Expect(0, 6479, '\p{^Is_Sc=_ LIMB}', "");
    Expect(0, 6479, '\P{Is_Sc=_ LIMB}', "");
    Expect(1, 6479, '\P{^Is_Sc=_ LIMB}', "");
    Expect(0, 6480, '\p{Is_Sc=_ LIMB}', "");
    Expect(1, 6480, '\p{^Is_Sc=_ LIMB}', "");
    Expect(1, 6480, '\P{Is_Sc=_ LIMB}', "");
    Expect(0, 6480, '\P{^Is_Sc=_ LIMB}', "");
    Error('\p{Script=:= -Linear_a}');
    Error('\P{Script=:= -Linear_a}');
    Expect(1, 67431, '\p{Script=lineara}', "");
    Expect(0, 67431, '\p{^Script=lineara}', "");
    Expect(0, 67431, '\P{Script=lineara}', "");
    Expect(1, 67431, '\P{^Script=lineara}', "");
    Expect(0, 67432, '\p{Script=lineara}', "");
    Expect(1, 67432, '\p{^Script=lineara}', "");
    Expect(1, 67432, '\P{Script=lineara}', "");
    Expect(0, 67432, '\P{^Script=lineara}', "");
    Expect(1, 67431, '\p{Script=	LINEAR_a}', "");
    Expect(0, 67431, '\p{^Script=	LINEAR_a}', "");
    Expect(0, 67431, '\P{Script=	LINEAR_a}', "");
    Expect(1, 67431, '\P{^Script=	LINEAR_a}', "");
    Expect(0, 67432, '\p{Script=	LINEAR_a}', "");
    Expect(1, 67432, '\p{^Script=	LINEAR_a}', "");
    Expect(1, 67432, '\P{Script=	LINEAR_a}', "");
    Expect(0, 67432, '\P{^Script=	LINEAR_a}', "");
    Error('\p{Sc= Lina/a/}');
    Error('\P{Sc= Lina/a/}');
    Expect(1, 67431, '\p{Sc=lina}', "");
    Expect(0, 67431, '\p{^Sc=lina}', "");
    Expect(0, 67431, '\P{Sc=lina}', "");
    Expect(1, 67431, '\P{^Sc=lina}', "");
    Expect(0, 67432, '\p{Sc=lina}', "");
    Expect(1, 67432, '\p{^Sc=lina}', "");
    Expect(1, 67432, '\P{Sc=lina}', "");
    Expect(0, 67432, '\P{^Sc=lina}', "");
    Expect(1, 67431, '\p{Sc=	lina}', "");
    Expect(0, 67431, '\p{^Sc=	lina}', "");
    Expect(0, 67431, '\P{Sc=	lina}', "");
    Expect(1, 67431, '\P{^Sc=	lina}', "");
    Expect(0, 67432, '\p{Sc=	lina}', "");
    Expect(1, 67432, '\p{^Sc=	lina}', "");
    Expect(1, 67432, '\P{Sc=	lina}', "");
    Expect(0, 67432, '\P{^Sc=	lina}', "");
    Error('\p{Is_Script=_:=Linear_a}');
    Error('\P{Is_Script=_:=Linear_a}');
    Expect(1, 67431, '\p{Is_Script=lineara}', "");
    Expect(0, 67431, '\p{^Is_Script=lineara}', "");
    Expect(0, 67431, '\P{Is_Script=lineara}', "");
    Expect(1, 67431, '\P{^Is_Script=lineara}', "");
    Expect(0, 67432, '\p{Is_Script=lineara}', "");
    Expect(1, 67432, '\p{^Is_Script=lineara}', "");
    Expect(1, 67432, '\P{Is_Script=lineara}', "");
    Expect(0, 67432, '\P{^Is_Script=lineara}', "");
    Expect(1, 67431, '\p{Is_Script=	 linear_a}', "");
    Expect(0, 67431, '\p{^Is_Script=	 linear_a}', "");
    Expect(0, 67431, '\P{Is_Script=	 linear_a}', "");
    Expect(1, 67431, '\P{^Is_Script=	 linear_a}', "");
    Expect(0, 67432, '\p{Is_Script=	 linear_a}', "");
    Expect(1, 67432, '\p{^Is_Script=	 linear_a}', "");
    Expect(1, 67432, '\P{Is_Script=	 linear_a}', "");
    Expect(0, 67432, '\P{^Is_Script=	 linear_a}', "");
    Error('\p{Is_Sc=	:=lina}');
    Error('\P{Is_Sc=	:=lina}');
    Expect(1, 67431, '\p{Is_Sc=lina}', "");
    Expect(0, 67431, '\p{^Is_Sc=lina}', "");
    Expect(0, 67431, '\P{Is_Sc=lina}', "");
    Expect(1, 67431, '\P{^Is_Sc=lina}', "");
    Expect(0, 67432, '\p{Is_Sc=lina}', "");
    Expect(1, 67432, '\p{^Is_Sc=lina}', "");
    Expect(1, 67432, '\P{Is_Sc=lina}', "");
    Expect(0, 67432, '\P{^Is_Sc=lina}', "");
    Expect(1, 67431, '\p{Is_Sc= 	Lina}', "");
    Expect(0, 67431, '\p{^Is_Sc= 	Lina}', "");
    Expect(0, 67431, '\P{Is_Sc= 	Lina}', "");
    Expect(1, 67431, '\P{^Is_Sc= 	Lina}', "");
    Expect(0, 67432, '\p{Is_Sc= 	Lina}', "");
    Expect(1, 67432, '\p{^Is_Sc= 	Lina}', "");
    Expect(1, 67432, '\P{Is_Sc= 	Lina}', "");
    Expect(0, 67432, '\P{^Is_Sc= 	Lina}', "");
    Error('\p{Script=_LINEAR_B/a/}');
    Error('\P{Script=_LINEAR_B/a/}');
    Expect(1, 65786, '\p{Script:linearb}', "");
    Expect(0, 65786, '\p{^Script:linearb}', "");
    Expect(0, 65786, '\P{Script:linearb}', "");
    Expect(1, 65786, '\P{^Script:linearb}', "");
    Expect(0, 65787, '\p{Script:linearb}', "");
    Expect(1, 65787, '\p{^Script:linearb}', "");
    Expect(1, 65787, '\P{Script:linearb}', "");
    Expect(0, 65787, '\P{^Script:linearb}', "");
    Expect(1, 65786, '\p{Script=- linear_B}', "");
    Expect(0, 65786, '\p{^Script=- linear_B}', "");
    Expect(0, 65786, '\P{Script=- linear_B}', "");
    Expect(1, 65786, '\P{^Script=- linear_B}', "");
    Expect(0, 65787, '\p{Script=- linear_B}', "");
    Expect(1, 65787, '\p{^Script=- linear_B}', "");
    Expect(1, 65787, '\P{Script=- linear_B}', "");
    Expect(0, 65787, '\P{^Script=- linear_B}', "");
    Error('\p{Sc=:=- Linb}');
    Error('\P{Sc=:=- Linb}');
    Expect(1, 65786, '\p{Sc=linb}', "");
    Expect(0, 65786, '\p{^Sc=linb}', "");
    Expect(0, 65786, '\P{Sc=linb}', "");
    Expect(1, 65786, '\P{^Sc=linb}', "");
    Expect(0, 65787, '\p{Sc=linb}', "");
    Expect(1, 65787, '\p{^Sc=linb}', "");
    Expect(1, 65787, '\P{Sc=linb}', "");
    Expect(0, 65787, '\P{^Sc=linb}', "");
    Expect(1, 65786, '\p{Sc= _Linb}', "");
    Expect(0, 65786, '\p{^Sc= _Linb}', "");
    Expect(0, 65786, '\P{Sc= _Linb}', "");
    Expect(1, 65786, '\P{^Sc= _Linb}', "");
    Expect(0, 65787, '\p{Sc= _Linb}', "");
    Expect(1, 65787, '\p{^Sc= _Linb}', "");
    Expect(1, 65787, '\P{Sc= _Linb}', "");
    Expect(0, 65787, '\P{^Sc= _Linb}', "");
    Error('\p{Is_Script=_/a/LINEAR_B}');
    Error('\P{Is_Script=_/a/LINEAR_B}');
    Expect(1, 65786, '\p{Is_Script=linearb}', "");
    Expect(0, 65786, '\p{^Is_Script=linearb}', "");
    Expect(0, 65786, '\P{Is_Script=linearb}', "");
    Expect(1, 65786, '\P{^Is_Script=linearb}', "");
    Expect(0, 65787, '\p{Is_Script=linearb}', "");
    Expect(1, 65787, '\p{^Is_Script=linearb}', "");
    Expect(1, 65787, '\P{Is_Script=linearb}', "");
    Expect(0, 65787, '\P{^Is_Script=linearb}', "");
    Expect(1, 65786, '\p{Is_Script=	 linear_B}', "");
    Expect(0, 65786, '\p{^Is_Script=	 linear_B}', "");
    Expect(0, 65786, '\P{Is_Script=	 linear_B}', "");
    Expect(1, 65786, '\P{^Is_Script=	 linear_B}', "");
    Expect(0, 65787, '\p{Is_Script=	 linear_B}', "");
    Expect(1, 65787, '\p{^Is_Script=	 linear_B}', "");
    Expect(1, 65787, '\P{Is_Script=	 linear_B}', "");
    Expect(0, 65787, '\P{^Is_Script=	 linear_B}', "");
    Error('\p{Is_Sc=/a/	Linb}');
    Error('\P{Is_Sc=/a/	Linb}');
    Expect(1, 65786, '\p{Is_Sc=linb}', "");
    Expect(0, 65786, '\p{^Is_Sc=linb}', "");
    Expect(0, 65786, '\P{Is_Sc=linb}', "");
    Expect(1, 65786, '\P{^Is_Sc=linb}', "");
    Expect(0, 65787, '\p{Is_Sc=linb}', "");
    Expect(1, 65787, '\p{^Is_Sc=linb}', "");
    Expect(1, 65787, '\P{Is_Sc=linb}', "");
    Expect(0, 65787, '\P{^Is_Sc=linb}', "");
    Expect(1, 65786, '\p{Is_Sc=		Linb}', "");
    Expect(0, 65786, '\p{^Is_Sc=		Linb}', "");
    Expect(0, 65786, '\P{Is_Sc=		Linb}', "");
    Expect(1, 65786, '\P{^Is_Sc=		Linb}', "");
    Expect(0, 65787, '\p{Is_Sc=		Linb}', "");
    Expect(1, 65787, '\p{^Is_Sc=		Linb}', "");
    Expect(1, 65787, '\P{Is_Sc=		Linb}', "");
    Expect(0, 65787, '\P{^Is_Sc=		Linb}', "");
    Error('\p{Script=:=_	Lisu}');
    Error('\P{Script=:=_	Lisu}');
    Expect(1, 42239, '\p{Script=lisu}', "");
    Expect(0, 42239, '\p{^Script=lisu}', "");
    Expect(0, 42239, '\P{Script=lisu}', "");
    Expect(1, 42239, '\P{^Script=lisu}', "");
    Expect(0, 42240, '\p{Script=lisu}', "");
    Expect(1, 42240, '\p{^Script=lisu}', "");
    Expect(1, 42240, '\P{Script=lisu}', "");
    Expect(0, 42240, '\P{^Script=lisu}', "");
    Expect(1, 42239, '\p{Script:	lisu}', "");
    Expect(0, 42239, '\p{^Script:	lisu}', "");
    Expect(0, 42239, '\P{Script:	lisu}', "");
    Expect(1, 42239, '\P{^Script:	lisu}', "");
    Expect(0, 42240, '\p{Script:	lisu}', "");
    Expect(1, 42240, '\p{^Script:	lisu}', "");
    Expect(1, 42240, '\P{Script:	lisu}', "");
    Expect(0, 42240, '\P{^Script:	lisu}', "");
    Error('\p{Sc=_Lisu/a/}');
    Error('\P{Sc=_Lisu/a/}');
    Expect(1, 42239, '\p{Sc=lisu}', "");
    Expect(0, 42239, '\p{^Sc=lisu}', "");
    Expect(0, 42239, '\P{Sc=lisu}', "");
    Expect(1, 42239, '\P{^Sc=lisu}', "");
    Expect(0, 42240, '\p{Sc=lisu}', "");
    Expect(1, 42240, '\p{^Sc=lisu}', "");
    Expect(1, 42240, '\P{Sc=lisu}', "");
    Expect(0, 42240, '\P{^Sc=lisu}', "");
    Expect(1, 42239, '\p{Sc:		 LISU}', "");
    Expect(0, 42239, '\p{^Sc:		 LISU}', "");
    Expect(0, 42239, '\P{Sc:		 LISU}', "");
    Expect(1, 42239, '\P{^Sc:		 LISU}', "");
    Expect(0, 42240, '\p{Sc:		 LISU}', "");
    Expect(1, 42240, '\p{^Sc:		 LISU}', "");
    Expect(1, 42240, '\P{Sc:		 LISU}', "");
    Expect(0, 42240, '\P{^Sc:		 LISU}', "");
    Error('\p{Is_Script=_-Lisu/a/}');
    Error('\P{Is_Script=_-Lisu/a/}');
    Expect(1, 42239, '\p{Is_Script=lisu}', "");
    Expect(0, 42239, '\p{^Is_Script=lisu}', "");
    Expect(0, 42239, '\P{Is_Script=lisu}', "");
    Expect(1, 42239, '\P{^Is_Script=lisu}', "");
    Expect(0, 42240, '\p{Is_Script=lisu}', "");
    Expect(1, 42240, '\p{^Is_Script=lisu}', "");
    Expect(1, 42240, '\P{Is_Script=lisu}', "");
    Expect(0, 42240, '\P{^Is_Script=lisu}', "");
    Expect(1, 42239, '\p{Is_Script=  LISU}', "");
    Expect(0, 42239, '\p{^Is_Script=  LISU}', "");
    Expect(0, 42239, '\P{Is_Script=  LISU}', "");
    Expect(1, 42239, '\P{^Is_Script=  LISU}', "");
    Expect(0, 42240, '\p{Is_Script=  LISU}', "");
    Expect(1, 42240, '\p{^Is_Script=  LISU}', "");
    Expect(1, 42240, '\P{Is_Script=  LISU}', "");
    Expect(0, 42240, '\P{^Is_Script=  LISU}', "");
    Error('\p{Is_Sc=	 lisu:=}');
    Error('\P{Is_Sc=	 lisu:=}');
    Expect(1, 42239, '\p{Is_Sc=lisu}', "");
    Expect(0, 42239, '\p{^Is_Sc=lisu}', "");
    Expect(0, 42239, '\P{Is_Sc=lisu}', "");
    Expect(1, 42239, '\P{^Is_Sc=lisu}', "");
    Expect(0, 42240, '\p{Is_Sc=lisu}', "");
    Expect(1, 42240, '\p{^Is_Sc=lisu}', "");
    Expect(1, 42240, '\P{Is_Sc=lisu}', "");
    Expect(0, 42240, '\P{^Is_Sc=lisu}', "");
    Expect(1, 42239, '\p{Is_Sc=--Lisu}', "");
    Expect(0, 42239, '\p{^Is_Sc=--Lisu}', "");
    Expect(0, 42239, '\P{Is_Sc=--Lisu}', "");
    Expect(1, 42239, '\P{^Is_Sc=--Lisu}', "");
    Expect(0, 42240, '\p{Is_Sc=--Lisu}', "");
    Expect(1, 42240, '\p{^Is_Sc=--Lisu}', "");
    Expect(1, 42240, '\P{Is_Sc=--Lisu}', "");
    Expect(0, 42240, '\P{^Is_Sc=--Lisu}', "");
    Error('\p{Script=/a/ _Lycian}');
    Error('\P{Script=/a/ _Lycian}');
    Expect(1, 66204, '\p{Script:lycian}', "");
    Expect(0, 66204, '\p{^Script:lycian}', "");
    Expect(0, 66204, '\P{Script:lycian}', "");
    Expect(1, 66204, '\P{^Script:lycian}', "");
    Expect(0, 66205, '\p{Script:lycian}', "");
    Expect(1, 66205, '\p{^Script:lycian}', "");
    Expect(1, 66205, '\P{Script:lycian}', "");
    Expect(0, 66205, '\P{^Script:lycian}', "");
    Expect(1, 66204, '\p{Script=  Lycian}', "");
    Expect(0, 66204, '\p{^Script=  Lycian}', "");
    Expect(0, 66204, '\P{Script=  Lycian}', "");
    Expect(1, 66204, '\P{^Script=  Lycian}', "");
    Expect(0, 66205, '\p{Script=  Lycian}', "");
    Expect(1, 66205, '\p{^Script=  Lycian}', "");
    Expect(1, 66205, '\P{Script=  Lycian}', "");
    Expect(0, 66205, '\P{^Script=  Lycian}', "");
    Error('\p{Sc: LYCI:=}');
    Error('\P{Sc: LYCI:=}');
    Expect(1, 66204, '\p{Sc=lyci}', "");
    Expect(0, 66204, '\p{^Sc=lyci}', "");
    Expect(0, 66204, '\P{Sc=lyci}', "");
    Expect(1, 66204, '\P{^Sc=lyci}', "");
    Expect(0, 66205, '\p{Sc=lyci}', "");
    Expect(1, 66205, '\p{^Sc=lyci}', "");
    Expect(1, 66205, '\P{Sc=lyci}', "");
    Expect(0, 66205, '\P{^Sc=lyci}', "");
    Expect(1, 66204, '\p{Sc=-Lyci}', "");
    Expect(0, 66204, '\p{^Sc=-Lyci}', "");
    Expect(0, 66204, '\P{Sc=-Lyci}', "");
    Expect(1, 66204, '\P{^Sc=-Lyci}', "");
    Expect(0, 66205, '\p{Sc=-Lyci}', "");
    Expect(1, 66205, '\p{^Sc=-Lyci}', "");
    Expect(1, 66205, '\P{Sc=-Lyci}', "");
    Expect(0, 66205, '\P{^Sc=-Lyci}', "");
    Error('\p{Is_Script=:=lycian}');
    Error('\P{Is_Script=:=lycian}');
    Expect(1, 66204, '\p{Is_Script=lycian}', "");
    Expect(0, 66204, '\p{^Is_Script=lycian}', "");
    Expect(0, 66204, '\P{Is_Script=lycian}', "");
    Expect(1, 66204, '\P{^Is_Script=lycian}', "");
    Expect(0, 66205, '\p{Is_Script=lycian}', "");
    Expect(1, 66205, '\p{^Is_Script=lycian}', "");
    Expect(1, 66205, '\P{Is_Script=lycian}', "");
    Expect(0, 66205, '\P{^Is_Script=lycian}', "");
    Expect(1, 66204, '\p{Is_Script=		Lycian}', "");
    Expect(0, 66204, '\p{^Is_Script=		Lycian}', "");
    Expect(0, 66204, '\P{Is_Script=		Lycian}', "");
    Expect(1, 66204, '\P{^Is_Script=		Lycian}', "");
    Expect(0, 66205, '\p{Is_Script=		Lycian}', "");
    Expect(1, 66205, '\p{^Is_Script=		Lycian}', "");
    Expect(1, 66205, '\P{Is_Script=		Lycian}', "");
    Expect(0, 66205, '\P{^Is_Script=		Lycian}', "");
    Error('\p{Is_Sc=_	LYCI:=}');
    Error('\P{Is_Sc=_	LYCI:=}');
    Expect(1, 66204, '\p{Is_Sc=lyci}', "");
    Expect(0, 66204, '\p{^Is_Sc=lyci}', "");
    Expect(0, 66204, '\P{Is_Sc=lyci}', "");
    Expect(1, 66204, '\P{^Is_Sc=lyci}', "");
    Expect(0, 66205, '\p{Is_Sc=lyci}', "");
    Expect(1, 66205, '\p{^Is_Sc=lyci}', "");
    Expect(1, 66205, '\P{Is_Sc=lyci}', "");
    Expect(0, 66205, '\P{^Is_Sc=lyci}', "");
    Expect(1, 66204, '\p{Is_Sc=		Lyci}', "");
    Expect(0, 66204, '\p{^Is_Sc=		Lyci}', "");
    Expect(0, 66204, '\P{Is_Sc=		Lyci}', "");
    Expect(1, 66204, '\P{^Is_Sc=		Lyci}', "");
    Expect(0, 66205, '\p{Is_Sc=		Lyci}', "");
    Expect(1, 66205, '\p{^Is_Sc=		Lyci}', "");
    Expect(1, 66205, '\P{Is_Sc=		Lyci}', "");
    Expect(0, 66205, '\P{^Is_Sc=		Lyci}', "");
    Error('\p{Script:	/a/Lydian}');
    Error('\P{Script:	/a/Lydian}');
    Expect(1, 67903, '\p{Script=lydian}', "");
    Expect(0, 67903, '\p{^Script=lydian}', "");
    Expect(0, 67903, '\P{Script=lydian}', "");
    Expect(1, 67903, '\P{^Script=lydian}', "");
    Expect(0, 67904, '\p{Script=lydian}', "");
    Expect(1, 67904, '\p{^Script=lydian}', "");
    Expect(1, 67904, '\P{Script=lydian}', "");
    Expect(0, 67904, '\P{^Script=lydian}', "");
    Expect(1, 67903, '\p{Script=	_LYDIAN}', "");
    Expect(0, 67903, '\p{^Script=	_LYDIAN}', "");
    Expect(0, 67903, '\P{Script=	_LYDIAN}', "");
    Expect(1, 67903, '\P{^Script=	_LYDIAN}', "");
    Expect(0, 67904, '\p{Script=	_LYDIAN}', "");
    Expect(1, 67904, '\p{^Script=	_LYDIAN}', "");
    Expect(1, 67904, '\P{Script=	_LYDIAN}', "");
    Expect(0, 67904, '\P{^Script=	_LYDIAN}', "");
    Error('\p{Sc:	:=	 Lydi}');
    Error('\P{Sc:	:=	 Lydi}');
    Expect(1, 67903, '\p{Sc:	lydi}', "");
    Expect(0, 67903, '\p{^Sc:	lydi}', "");
    Expect(0, 67903, '\P{Sc:	lydi}', "");
    Expect(1, 67903, '\P{^Sc:	lydi}', "");
    Expect(0, 67904, '\p{Sc:	lydi}', "");
    Expect(1, 67904, '\p{^Sc:	lydi}', "");
    Expect(1, 67904, '\P{Sc:	lydi}', "");
    Expect(0, 67904, '\P{^Sc:	lydi}', "");
    Expect(1, 67903, '\p{Sc=-Lydi}', "");
    Expect(0, 67903, '\p{^Sc=-Lydi}', "");
    Expect(0, 67903, '\P{Sc=-Lydi}', "");
    Expect(1, 67903, '\P{^Sc=-Lydi}', "");
    Expect(0, 67904, '\p{Sc=-Lydi}', "");
    Expect(1, 67904, '\p{^Sc=-Lydi}', "");
    Expect(1, 67904, '\P{Sc=-Lydi}', "");
    Expect(0, 67904, '\P{^Sc=-Lydi}', "");
    Error('\p{Is_Script= -Lydian/a/}');
    Error('\P{Is_Script= -Lydian/a/}');
    Expect(1, 67903, '\p{Is_Script=lydian}', "");
    Expect(0, 67903, '\p{^Is_Script=lydian}', "");
    Expect(0, 67903, '\P{Is_Script=lydian}', "");
    Expect(1, 67903, '\P{^Is_Script=lydian}', "");
    Expect(0, 67904, '\p{Is_Script=lydian}', "");
    Expect(1, 67904, '\p{^Is_Script=lydian}', "");
    Expect(1, 67904, '\P{Is_Script=lydian}', "");
    Expect(0, 67904, '\P{^Is_Script=lydian}', "");
    Expect(1, 67903, '\p{Is_Script=	-LYDIAN}', "");
    Expect(0, 67903, '\p{^Is_Script=	-LYDIAN}', "");
    Expect(0, 67903, '\P{Is_Script=	-LYDIAN}', "");
    Expect(1, 67903, '\P{^Is_Script=	-LYDIAN}', "");
    Expect(0, 67904, '\p{Is_Script=	-LYDIAN}', "");
    Expect(1, 67904, '\p{^Is_Script=	-LYDIAN}', "");
    Expect(1, 67904, '\P{Is_Script=	-LYDIAN}', "");
    Expect(0, 67904, '\P{^Is_Script=	-LYDIAN}', "");
    Error('\p{Is_Sc=-/a/lydi}');
    Error('\P{Is_Sc=-/a/lydi}');
    Expect(1, 67903, '\p{Is_Sc=lydi}', "");
    Expect(0, 67903, '\p{^Is_Sc=lydi}', "");
    Expect(0, 67903, '\P{Is_Sc=lydi}', "");
    Expect(1, 67903, '\P{^Is_Sc=lydi}', "");
    Expect(0, 67904, '\p{Is_Sc=lydi}', "");
    Expect(1, 67904, '\p{^Is_Sc=lydi}', "");
    Expect(1, 67904, '\P{Is_Sc=lydi}', "");
    Expect(0, 67904, '\P{^Is_Sc=lydi}', "");
    Expect(1, 67903, '\p{Is_Sc=_LYDI}', "");
    Expect(0, 67903, '\p{^Is_Sc=_LYDI}', "");
    Expect(0, 67903, '\P{Is_Sc=_LYDI}', "");
    Expect(1, 67903, '\P{^Is_Sc=_LYDI}', "");
    Expect(0, 67904, '\p{Is_Sc=_LYDI}', "");
    Expect(1, 67904, '\p{^Is_Sc=_LYDI}', "");
    Expect(1, 67904, '\P{Is_Sc=_LYDI}', "");
    Expect(0, 67904, '\P{^Is_Sc=_LYDI}', "");
    Error('\p{Script=/a/_-Mahajani}');
    Error('\P{Script=/a/_-Mahajani}');
    Expect(1, 70006, '\p{Script=mahajani}', "");
    Expect(0, 70006, '\p{^Script=mahajani}', "");
    Expect(0, 70006, '\P{Script=mahajani}', "");
    Expect(1, 70006, '\P{^Script=mahajani}', "");
    Expect(0, 70007, '\p{Script=mahajani}', "");
    Expect(1, 70007, '\p{^Script=mahajani}', "");
    Expect(1, 70007, '\P{Script=mahajani}', "");
    Expect(0, 70007, '\P{^Script=mahajani}', "");
    Expect(1, 70006, '\p{Script=_-MAHAJANI}', "");
    Expect(0, 70006, '\p{^Script=_-MAHAJANI}', "");
    Expect(0, 70006, '\P{Script=_-MAHAJANI}', "");
    Expect(1, 70006, '\P{^Script=_-MAHAJANI}', "");
    Expect(0, 70007, '\p{Script=_-MAHAJANI}', "");
    Expect(1, 70007, '\p{^Script=_-MAHAJANI}', "");
    Expect(1, 70007, '\P{Script=_-MAHAJANI}', "");
    Expect(0, 70007, '\P{^Script=_-MAHAJANI}', "");
    Error('\p{Sc=	_mahj:=}');
    Error('\P{Sc=	_mahj:=}');
    Expect(1, 70006, '\p{Sc=mahj}', "");
    Expect(0, 70006, '\p{^Sc=mahj}', "");
    Expect(0, 70006, '\P{Sc=mahj}', "");
    Expect(1, 70006, '\P{^Sc=mahj}', "");
    Expect(0, 70007, '\p{Sc=mahj}', "");
    Expect(1, 70007, '\p{^Sc=mahj}', "");
    Expect(1, 70007, '\P{Sc=mahj}', "");
    Expect(0, 70007, '\P{^Sc=mahj}', "");
    Expect(1, 70006, '\p{Sc: 	Mahj}', "");
    Expect(0, 70006, '\p{^Sc: 	Mahj}', "");
    Expect(0, 70006, '\P{Sc: 	Mahj}', "");
    Expect(1, 70006, '\P{^Sc: 	Mahj}', "");
    Expect(0, 70007, '\p{Sc: 	Mahj}', "");
    Expect(1, 70007, '\p{^Sc: 	Mahj}', "");
    Expect(1, 70007, '\P{Sc: 	Mahj}', "");
    Expect(0, 70007, '\P{^Sc: 	Mahj}', "");
    Error('\p{Is_Script=/a/Mahajani}');
    Error('\P{Is_Script=/a/Mahajani}');
    Expect(1, 70006, '\p{Is_Script=mahajani}', "");
    Expect(0, 70006, '\p{^Is_Script=mahajani}', "");
    Expect(0, 70006, '\P{Is_Script=mahajani}', "");
    Expect(1, 70006, '\P{^Is_Script=mahajani}', "");
    Expect(0, 70007, '\p{Is_Script=mahajani}', "");
    Expect(1, 70007, '\p{^Is_Script=mahajani}', "");
    Expect(1, 70007, '\P{Is_Script=mahajani}', "");
    Expect(0, 70007, '\P{^Is_Script=mahajani}', "");
    Expect(1, 70006, '\p{Is_Script=_ Mahajani}', "");
    Expect(0, 70006, '\p{^Is_Script=_ Mahajani}', "");
    Expect(0, 70006, '\P{Is_Script=_ Mahajani}', "");
    Expect(1, 70006, '\P{^Is_Script=_ Mahajani}', "");
    Expect(0, 70007, '\p{Is_Script=_ Mahajani}', "");
    Expect(1, 70007, '\p{^Is_Script=_ Mahajani}', "");
    Expect(1, 70007, '\P{Is_Script=_ Mahajani}', "");
    Expect(0, 70007, '\P{^Is_Script=_ Mahajani}', "");
    Error('\p{Is_Sc=:= _MAHJ}');
    Error('\P{Is_Sc=:= _MAHJ}');
    Expect(1, 70006, '\p{Is_Sc=mahj}', "");
    Expect(0, 70006, '\p{^Is_Sc=mahj}', "");
    Expect(0, 70006, '\P{Is_Sc=mahj}', "");
    Expect(1, 70006, '\P{^Is_Sc=mahj}', "");
    Expect(0, 70007, '\p{Is_Sc=mahj}', "");
    Expect(1, 70007, '\p{^Is_Sc=mahj}', "");
    Expect(1, 70007, '\P{Is_Sc=mahj}', "");
    Expect(0, 70007, '\P{^Is_Sc=mahj}', "");
    Expect(1, 70006, '\p{Is_Sc=_ Mahj}', "");
    Expect(0, 70006, '\p{^Is_Sc=_ Mahj}', "");
    Expect(0, 70006, '\P{Is_Sc=_ Mahj}', "");
    Expect(1, 70006, '\P{^Is_Sc=_ Mahj}', "");
    Expect(0, 70007, '\p{Is_Sc=_ Mahj}', "");
    Expect(1, 70007, '\p{^Is_Sc=_ Mahj}', "");
    Expect(1, 70007, '\P{Is_Sc=_ Mahj}', "");
    Expect(0, 70007, '\P{^Is_Sc=_ Mahj}', "");
    Error('\p{Script=:=	Mandaic}');
    Error('\P{Script=:=	Mandaic}');
    Expect(1, 2142, '\p{Script=mandaic}', "");
    Expect(0, 2142, '\p{^Script=mandaic}', "");
    Expect(0, 2142, '\P{Script=mandaic}', "");
    Expect(1, 2142, '\P{^Script=mandaic}', "");
    Expect(0, 2143, '\p{Script=mandaic}', "");
    Expect(1, 2143, '\p{^Script=mandaic}', "");
    Expect(1, 2143, '\P{Script=mandaic}', "");
    Expect(0, 2143, '\P{^Script=mandaic}', "");
    Expect(1, 2142, '\p{Script=		mandaic}', "");
    Expect(0, 2142, '\p{^Script=		mandaic}', "");
    Expect(0, 2142, '\P{Script=		mandaic}', "");
    Expect(1, 2142, '\P{^Script=		mandaic}', "");
    Expect(0, 2143, '\p{Script=		mandaic}', "");
    Expect(1, 2143, '\p{^Script=		mandaic}', "");
    Expect(1, 2143, '\P{Script=		mandaic}', "");
    Expect(0, 2143, '\P{^Script=		mandaic}', "");
    Error('\p{Sc=-	mand/a/}');
    Error('\P{Sc=-	mand/a/}');
    Expect(1, 2142, '\p{Sc: mand}', "");
    Expect(0, 2142, '\p{^Sc: mand}', "");
    Expect(0, 2142, '\P{Sc: mand}', "");
    Expect(1, 2142, '\P{^Sc: mand}', "");
    Expect(0, 2143, '\p{Sc: mand}', "");
    Expect(1, 2143, '\p{^Sc: mand}', "");
    Expect(1, 2143, '\P{Sc: mand}', "");
    Expect(0, 2143, '\P{^Sc: mand}', "");
    Expect(1, 2142, '\p{Sc:	_MAND}', "");
    Expect(0, 2142, '\p{^Sc:	_MAND}', "");
    Expect(0, 2142, '\P{Sc:	_MAND}', "");
    Expect(1, 2142, '\P{^Sc:	_MAND}', "");
    Expect(0, 2143, '\p{Sc:	_MAND}', "");
    Expect(1, 2143, '\p{^Sc:	_MAND}', "");
    Expect(1, 2143, '\P{Sc:	_MAND}', "");
    Expect(0, 2143, '\P{^Sc:	_MAND}', "");
    Error('\p{Is_Script=:=-Mandaic}');
    Error('\P{Is_Script=:=-Mandaic}');
    Expect(1, 2142, '\p{Is_Script:	mandaic}', "");
    Expect(0, 2142, '\p{^Is_Script:	mandaic}', "");
    Expect(0, 2142, '\P{Is_Script:	mandaic}', "");
    Expect(1, 2142, '\P{^Is_Script:	mandaic}', "");
    Expect(0, 2143, '\p{Is_Script:	mandaic}', "");
    Expect(1, 2143, '\p{^Is_Script:	mandaic}', "");
    Expect(1, 2143, '\P{Is_Script:	mandaic}', "");
    Expect(0, 2143, '\P{^Is_Script:	mandaic}', "");
    Expect(1, 2142, '\p{Is_Script=		MANDAIC}', "");
    Expect(0, 2142, '\p{^Is_Script=		MANDAIC}', "");
    Expect(0, 2142, '\P{Is_Script=		MANDAIC}', "");
    Expect(1, 2142, '\P{^Is_Script=		MANDAIC}', "");
    Expect(0, 2143, '\p{Is_Script=		MANDAIC}', "");
    Expect(1, 2143, '\p{^Is_Script=		MANDAIC}', "");
    Expect(1, 2143, '\P{Is_Script=		MANDAIC}', "");
    Expect(0, 2143, '\P{^Is_Script=		MANDAIC}', "");
    Error('\p{Is_Sc= :=Mand}');
    Error('\P{Is_Sc= :=Mand}');
    Expect(1, 2142, '\p{Is_Sc=mand}', "");
    Expect(0, 2142, '\p{^Is_Sc=mand}', "");
    Expect(0, 2142, '\P{Is_Sc=mand}', "");
    Expect(1, 2142, '\P{^Is_Sc=mand}', "");
    Expect(0, 2143, '\p{Is_Sc=mand}', "");
    Expect(1, 2143, '\p{^Is_Sc=mand}', "");
    Expect(1, 2143, '\P{Is_Sc=mand}', "");
    Expect(0, 2143, '\P{^Is_Sc=mand}', "");
    Expect(1, 2142, '\p{Is_Sc=	Mand}', "");
    Expect(0, 2142, '\p{^Is_Sc=	Mand}', "");
    Expect(0, 2142, '\P{Is_Sc=	Mand}', "");
    Expect(1, 2142, '\P{^Is_Sc=	Mand}', "");
    Expect(0, 2143, '\p{Is_Sc=	Mand}', "");
    Expect(1, 2143, '\p{^Is_Sc=	Mand}', "");
    Expect(1, 2143, '\P{Is_Sc=	Mand}', "");
    Expect(0, 2143, '\P{^Is_Sc=	Mand}', "");
    Error('\p{Script=	MANICHAEAN/a/}');
    Error('\P{Script=	MANICHAEAN/a/}');
    Expect(1, 68342, '\p{Script=manichaean}', "");
    Expect(0, 68342, '\p{^Script=manichaean}', "");
    Expect(0, 68342, '\P{Script=manichaean}', "");
    Expect(1, 68342, '\P{^Script=manichaean}', "");
    Expect(0, 68343, '\p{Script=manichaean}', "");
    Expect(1, 68343, '\p{^Script=manichaean}', "");
    Expect(1, 68343, '\P{Script=manichaean}', "");
    Expect(0, 68343, '\P{^Script=manichaean}', "");
    Expect(1, 68342, '\p{Script=	Manichaean}', "");
    Expect(0, 68342, '\p{^Script=	Manichaean}', "");
    Expect(0, 68342, '\P{Script=	Manichaean}', "");
    Expect(1, 68342, '\P{^Script=	Manichaean}', "");
    Expect(0, 68343, '\p{Script=	Manichaean}', "");
    Expect(1, 68343, '\p{^Script=	Manichaean}', "");
    Expect(1, 68343, '\P{Script=	Manichaean}', "");
    Expect(0, 68343, '\P{^Script=	Manichaean}', "");
    Error('\p{Sc=/a/Mani}');
    Error('\P{Sc=/a/Mani}');
    Expect(1, 68342, '\p{Sc=mani}', "");
    Expect(0, 68342, '\p{^Sc=mani}', "");
    Expect(0, 68342, '\P{Sc=mani}', "");
    Expect(1, 68342, '\P{^Sc=mani}', "");
    Expect(0, 68343, '\p{Sc=mani}', "");
    Expect(1, 68343, '\p{^Sc=mani}', "");
    Expect(1, 68343, '\P{Sc=mani}', "");
    Expect(0, 68343, '\P{^Sc=mani}', "");
    Expect(1, 68342, '\p{Sc=	-MANI}', "");
    Expect(0, 68342, '\p{^Sc=	-MANI}', "");
    Expect(0, 68342, '\P{Sc=	-MANI}', "");
    Expect(1, 68342, '\P{^Sc=	-MANI}', "");
    Expect(0, 68343, '\p{Sc=	-MANI}', "");
    Expect(1, 68343, '\p{^Sc=	-MANI}', "");
    Expect(1, 68343, '\P{Sc=	-MANI}', "");
    Expect(0, 68343, '\P{^Sc=	-MANI}', "");
    Error('\p{Is_Script=__Manichaean/a/}');
    Error('\P{Is_Script=__Manichaean/a/}');
    Expect(1, 68342, '\p{Is_Script=manichaean}', "");
    Expect(0, 68342, '\p{^Is_Script=manichaean}', "");
    Expect(0, 68342, '\P{Is_Script=manichaean}', "");
    Expect(1, 68342, '\P{^Is_Script=manichaean}', "");
    Expect(0, 68343, '\p{Is_Script=manichaean}', "");
    Expect(1, 68343, '\p{^Is_Script=manichaean}', "");
    Expect(1, 68343, '\P{Is_Script=manichaean}', "");
    Expect(0, 68343, '\P{^Is_Script=manichaean}', "");
    Expect(1, 68342, '\p{Is_Script=_ Manichaean}', "");
    Expect(0, 68342, '\p{^Is_Script=_ Manichaean}', "");
    Expect(0, 68342, '\P{Is_Script=_ Manichaean}', "");
    Expect(1, 68342, '\P{^Is_Script=_ Manichaean}', "");
    Expect(0, 68343, '\p{Is_Script=_ Manichaean}', "");
    Expect(1, 68343, '\p{^Is_Script=_ Manichaean}', "");
    Expect(1, 68343, '\P{Is_Script=_ Manichaean}', "");
    Expect(0, 68343, '\P{^Is_Script=_ Manichaean}', "");
    Error('\p{Is_Sc=_mani:=}');
    Error('\P{Is_Sc=_mani:=}');
    Expect(1, 68342, '\p{Is_Sc=mani}', "");
    Expect(0, 68342, '\p{^Is_Sc=mani}', "");
    Expect(0, 68342, '\P{Is_Sc=mani}', "");
    Expect(1, 68342, '\P{^Is_Sc=mani}', "");
    Expect(0, 68343, '\p{Is_Sc=mani}', "");
    Expect(1, 68343, '\p{^Is_Sc=mani}', "");
    Expect(1, 68343, '\P{Is_Sc=mani}', "");
    Expect(0, 68343, '\P{^Is_Sc=mani}', "");
    Expect(1, 68342, '\p{Is_Sc=	_Mani}', "");
    Expect(0, 68342, '\p{^Is_Sc=	_Mani}', "");
    Expect(0, 68342, '\P{Is_Sc=	_Mani}', "");
    Expect(1, 68342, '\P{^Is_Sc=	_Mani}', "");
    Expect(0, 68343, '\p{Is_Sc=	_Mani}', "");
    Expect(1, 68343, '\p{^Is_Sc=	_Mani}', "");
    Expect(1, 68343, '\P{Is_Sc=	_Mani}', "");
    Expect(0, 68343, '\P{^Is_Sc=	_Mani}', "");
    Error('\p{Script=-:=Marchen}');
    Error('\P{Script=-:=Marchen}');
    Expect(1, 72886, '\p{Script=marchen}', "");
    Expect(0, 72886, '\p{^Script=marchen}', "");
    Expect(0, 72886, '\P{Script=marchen}', "");
    Expect(1, 72886, '\P{^Script=marchen}', "");
    Expect(0, 72887, '\p{Script=marchen}', "");
    Expect(1, 72887, '\p{^Script=marchen}', "");
    Expect(1, 72887, '\P{Script=marchen}', "");
    Expect(0, 72887, '\P{^Script=marchen}', "");
    Expect(1, 72886, '\p{Script=	_marchen}', "");
    Expect(0, 72886, '\p{^Script=	_marchen}', "");
    Expect(0, 72886, '\P{Script=	_marchen}', "");
    Expect(1, 72886, '\P{^Script=	_marchen}', "");
    Expect(0, 72887, '\p{Script=	_marchen}', "");
    Expect(1, 72887, '\p{^Script=	_marchen}', "");
    Expect(1, 72887, '\P{Script=	_marchen}', "");
    Expect(0, 72887, '\P{^Script=	_marchen}', "");
    Error('\p{Sc=_/a/MARC}');
    Error('\P{Sc=_/a/MARC}');
    Expect(1, 72886, '\p{Sc=marc}', "");
    Expect(0, 72886, '\p{^Sc=marc}', "");
    Expect(0, 72886, '\P{Sc=marc}', "");
    Expect(1, 72886, '\P{^Sc=marc}', "");
    Expect(0, 72887, '\p{Sc=marc}', "");
    Expect(1, 72887, '\p{^Sc=marc}', "");
    Expect(1, 72887, '\P{Sc=marc}', "");
    Expect(0, 72887, '\P{^Sc=marc}', "");
    Expect(1, 72886, '\p{Sc=_marc}', "");
    Expect(0, 72886, '\p{^Sc=_marc}', "");
    Expect(0, 72886, '\P{Sc=_marc}', "");
    Expect(1, 72886, '\P{^Sc=_marc}', "");
    Expect(0, 72887, '\p{Sc=_marc}', "");
    Expect(1, 72887, '\p{^Sc=_marc}', "");
    Expect(1, 72887, '\P{Sc=_marc}', "");
    Expect(0, 72887, '\P{^Sc=_marc}', "");
    Error('\p{Is_Script=:=  MARCHEN}');
    Error('\P{Is_Script=:=  MARCHEN}');
    Expect(1, 72886, '\p{Is_Script=marchen}', "");
    Expect(0, 72886, '\p{^Is_Script=marchen}', "");
    Expect(0, 72886, '\P{Is_Script=marchen}', "");
    Expect(1, 72886, '\P{^Is_Script=marchen}', "");
    Expect(0, 72887, '\p{Is_Script=marchen}', "");
    Expect(1, 72887, '\p{^Is_Script=marchen}', "");
    Expect(1, 72887, '\P{Is_Script=marchen}', "");
    Expect(0, 72887, '\P{^Is_Script=marchen}', "");
    Expect(1, 72886, '\p{Is_Script:			Marchen}', "");
    Expect(0, 72886, '\p{^Is_Script:			Marchen}', "");
    Expect(0, 72886, '\P{Is_Script:			Marchen}', "");
    Expect(1, 72886, '\P{^Is_Script:			Marchen}', "");
    Expect(0, 72887, '\p{Is_Script:			Marchen}', "");
    Expect(1, 72887, '\p{^Is_Script:			Marchen}', "");
    Expect(1, 72887, '\P{Is_Script:			Marchen}', "");
    Expect(0, 72887, '\P{^Is_Script:			Marchen}', "");
    Error('\p{Is_Sc=:=marc}');
    Error('\P{Is_Sc=:=marc}');
    Expect(1, 72886, '\p{Is_Sc=marc}', "");
    Expect(0, 72886, '\p{^Is_Sc=marc}', "");
    Expect(0, 72886, '\P{Is_Sc=marc}', "");
    Expect(1, 72886, '\P{^Is_Sc=marc}', "");
    Expect(0, 72887, '\p{Is_Sc=marc}', "");
    Expect(1, 72887, '\p{^Is_Sc=marc}', "");
    Expect(1, 72887, '\P{Is_Sc=marc}', "");
    Expect(0, 72887, '\P{^Is_Sc=marc}', "");
    Expect(1, 72886, '\p{Is_Sc=_	Marc}', "");
    Expect(0, 72886, '\p{^Is_Sc=_	Marc}', "");
    Expect(0, 72886, '\P{Is_Sc=_	Marc}', "");
    Expect(1, 72886, '\P{^Is_Sc=_	Marc}', "");
    Expect(0, 72887, '\p{Is_Sc=_	Marc}', "");
    Expect(1, 72887, '\p{^Is_Sc=_	Marc}', "");
    Expect(1, 72887, '\P{Is_Sc=_	Marc}', "");
    Expect(0, 72887, '\P{^Is_Sc=_	Marc}', "");
    Error('\p{Script=	:=mende_Kikakui}');
    Error('\P{Script=	:=mende_Kikakui}');
    Expect(1, 125142, '\p{Script=mendekikakui}', "");
    Expect(0, 125142, '\p{^Script=mendekikakui}', "");
    Expect(0, 125142, '\P{Script=mendekikakui}', "");
    Expect(1, 125142, '\P{^Script=mendekikakui}', "");
    Expect(0, 125143, '\p{Script=mendekikakui}', "");
    Expect(1, 125143, '\p{^Script=mendekikakui}', "");
    Expect(1, 125143, '\P{Script=mendekikakui}', "");
    Expect(0, 125143, '\P{^Script=mendekikakui}', "");
    Expect(1, 125142, '\p{Script=__mende_Kikakui}', "");
    Expect(0, 125142, '\p{^Script=__mende_Kikakui}', "");
    Expect(0, 125142, '\P{Script=__mende_Kikakui}', "");
    Expect(1, 125142, '\P{^Script=__mende_Kikakui}', "");
    Expect(0, 125143, '\p{Script=__mende_Kikakui}', "");
    Expect(1, 125143, '\p{^Script=__mende_Kikakui}', "");
    Expect(1, 125143, '\P{Script=__mende_Kikakui}', "");
    Expect(0, 125143, '\P{^Script=__mende_Kikakui}', "");
    Error('\p{Sc=:=mend}');
    Error('\P{Sc=:=mend}');
    Expect(1, 125142, '\p{Sc=mend}', "");
    Expect(0, 125142, '\p{^Sc=mend}', "");
    Expect(0, 125142, '\P{Sc=mend}', "");
    Expect(1, 125142, '\P{^Sc=mend}', "");
    Expect(0, 125143, '\p{Sc=mend}', "");
    Expect(1, 125143, '\p{^Sc=mend}', "");
    Expect(1, 125143, '\P{Sc=mend}', "");
    Expect(0, 125143, '\P{^Sc=mend}', "");
    Expect(1, 125142, '\p{Sc= 	Mend}', "");
    Expect(0, 125142, '\p{^Sc= 	Mend}', "");
    Expect(0, 125142, '\P{Sc= 	Mend}', "");
    Expect(1, 125142, '\P{^Sc= 	Mend}', "");
    Expect(0, 125143, '\p{Sc= 	Mend}', "");
    Expect(1, 125143, '\p{^Sc= 	Mend}', "");
    Expect(1, 125143, '\P{Sc= 	Mend}', "");
    Expect(0, 125143, '\P{^Sc= 	Mend}', "");
    Error('\p{Is_Script=	:=Mende_KIKAKUI}');
    Error('\P{Is_Script=	:=Mende_KIKAKUI}');
    Expect(1, 125142, '\p{Is_Script=mendekikakui}', "");
    Expect(0, 125142, '\p{^Is_Script=mendekikakui}', "");
    Expect(0, 125142, '\P{Is_Script=mendekikakui}', "");
    Expect(1, 125142, '\P{^Is_Script=mendekikakui}', "");
    Expect(0, 125143, '\p{Is_Script=mendekikakui}', "");
    Expect(1, 125143, '\p{^Is_Script=mendekikakui}', "");
    Expect(1, 125143, '\P{Is_Script=mendekikakui}', "");
    Expect(0, 125143, '\P{^Is_Script=mendekikakui}', "");
    Expect(1, 125142, '\p{Is_Script= 	Mende_Kikakui}', "");
    Expect(0, 125142, '\p{^Is_Script= 	Mende_Kikakui}', "");
    Expect(0, 125142, '\P{Is_Script= 	Mende_Kikakui}', "");
    Expect(1, 125142, '\P{^Is_Script= 	Mende_Kikakui}', "");
    Expect(0, 125143, '\p{Is_Script= 	Mende_Kikakui}', "");
    Expect(1, 125143, '\p{^Is_Script= 	Mende_Kikakui}', "");
    Expect(1, 125143, '\P{Is_Script= 	Mende_Kikakui}', "");
    Expect(0, 125143, '\P{^Is_Script= 	Mende_Kikakui}', "");
    Error('\p{Is_Sc=:=Mend}');
    Error('\P{Is_Sc=:=Mend}');
    Expect(1, 125142, '\p{Is_Sc=mend}', "");
    Expect(0, 125142, '\p{^Is_Sc=mend}', "");
    Expect(0, 125142, '\P{Is_Sc=mend}', "");
    Expect(1, 125142, '\P{^Is_Sc=mend}', "");
    Expect(0, 125143, '\p{Is_Sc=mend}', "");
    Expect(1, 125143, '\p{^Is_Sc=mend}', "");
    Expect(1, 125143, '\P{Is_Sc=mend}', "");
    Expect(0, 125143, '\P{^Is_Sc=mend}', "");
    Expect(1, 125142, '\p{Is_Sc= -MEND}', "");
    Expect(0, 125142, '\p{^Is_Sc= -MEND}', "");
    Expect(0, 125142, '\P{Is_Sc= -MEND}', "");
    Expect(1, 125142, '\P{^Is_Sc= -MEND}', "");
    Expect(0, 125143, '\p{Is_Sc= -MEND}', "");
    Expect(1, 125143, '\p{^Is_Sc= -MEND}', "");
    Expect(1, 125143, '\P{Is_Sc= -MEND}', "");
    Expect(0, 125143, '\P{^Is_Sc= -MEND}', "");
    Error('\p{Script: := -meroitic_Cursive}');
    Error('\P{Script: := -meroitic_Cursive}');
    Expect(1, 68095, '\p{Script=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Script=meroiticcursive}', "");
    Expect(0, 68095, '\P{Script=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Script=meroiticcursive}', "");
    Expect(0, 68096, '\p{Script=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Script=meroiticcursive}', "");
    Expect(1, 68096, '\P{Script=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Script=meroiticcursive}', "");
    Expect(1, 68095, '\p{Script= -MEROITIC_CURSIVE}', "");
    Expect(0, 68095, '\p{^Script= -MEROITIC_CURSIVE}', "");
    Expect(0, 68095, '\P{Script= -MEROITIC_CURSIVE}', "");
    Expect(1, 68095, '\P{^Script= -MEROITIC_CURSIVE}', "");
    Expect(0, 68096, '\p{Script= -MEROITIC_CURSIVE}', "");
    Expect(1, 68096, '\p{^Script= -MEROITIC_CURSIVE}', "");
    Expect(1, 68096, '\P{Script= -MEROITIC_CURSIVE}', "");
    Expect(0, 68096, '\P{^Script= -MEROITIC_CURSIVE}', "");
    Error('\p{Sc=:= Merc}');
    Error('\P{Sc=:= Merc}');
    Expect(1, 68095, '\p{Sc=merc}', "");
    Expect(0, 68095, '\p{^Sc=merc}', "");
    Expect(0, 68095, '\P{Sc=merc}', "");
    Expect(1, 68095, '\P{^Sc=merc}', "");
    Expect(0, 68096, '\p{Sc=merc}', "");
    Expect(1, 68096, '\p{^Sc=merc}', "");
    Expect(1, 68096, '\P{Sc=merc}', "");
    Expect(0, 68096, '\P{^Sc=merc}', "");
    Expect(1, 68095, '\p{Sc=-Merc}', "");
    Expect(0, 68095, '\p{^Sc=-Merc}', "");
    Expect(0, 68095, '\P{Sc=-Merc}', "");
    Expect(1, 68095, '\P{^Sc=-Merc}', "");
    Expect(0, 68096, '\p{Sc=-Merc}', "");
    Expect(1, 68096, '\p{^Sc=-Merc}', "");
    Expect(1, 68096, '\P{Sc=-Merc}', "");
    Expect(0, 68096, '\P{^Sc=-Merc}', "");
    Error('\p{Is_Script=/a/ MEROITIC_Cursive}');
    Error('\P{Is_Script=/a/ MEROITIC_Cursive}');
    Expect(1, 68095, '\p{Is_Script:	meroiticcursive}', "");
    Expect(0, 68095, '\p{^Is_Script:	meroiticcursive}', "");
    Expect(0, 68095, '\P{Is_Script:	meroiticcursive}', "");
    Expect(1, 68095, '\P{^Is_Script:	meroiticcursive}', "");
    Expect(0, 68096, '\p{Is_Script:	meroiticcursive}', "");
    Expect(1, 68096, '\p{^Is_Script:	meroiticcursive}', "");
    Expect(1, 68096, '\P{Is_Script:	meroiticcursive}', "");
    Expect(0, 68096, '\P{^Is_Script:	meroiticcursive}', "");
    Expect(1, 68095, '\p{Is_Script=	 Meroitic_cursive}', "");
    Expect(0, 68095, '\p{^Is_Script=	 Meroitic_cursive}', "");
    Expect(0, 68095, '\P{Is_Script=	 Meroitic_cursive}', "");
    Expect(1, 68095, '\P{^Is_Script=	 Meroitic_cursive}', "");
    Expect(0, 68096, '\p{Is_Script=	 Meroitic_cursive}', "");
    Expect(1, 68096, '\p{^Is_Script=	 Meroitic_cursive}', "");
    Expect(1, 68096, '\P{Is_Script=	 Meroitic_cursive}', "");
    Expect(0, 68096, '\P{^Is_Script=	 Meroitic_cursive}', "");
    Error('\p{Is_Sc=:=	Merc}');
    Error('\P{Is_Sc=:=	Merc}');
    Expect(1, 68095, '\p{Is_Sc=merc}', "");
    Expect(0, 68095, '\p{^Is_Sc=merc}', "");
    Expect(0, 68095, '\P{Is_Sc=merc}', "");
    Expect(1, 68095, '\P{^Is_Sc=merc}', "");
    Expect(0, 68096, '\p{Is_Sc=merc}', "");
    Expect(1, 68096, '\p{^Is_Sc=merc}', "");
    Expect(1, 68096, '\P{Is_Sc=merc}', "");
    Expect(0, 68096, '\P{^Is_Sc=merc}', "");
    Expect(1, 68095, '\p{Is_Sc=-merc}', "");
    Expect(0, 68095, '\p{^Is_Sc=-merc}', "");
    Expect(0, 68095, '\P{Is_Sc=-merc}', "");
    Expect(1, 68095, '\P{^Is_Sc=-merc}', "");
    Expect(0, 68096, '\p{Is_Sc=-merc}', "");
    Expect(1, 68096, '\p{^Is_Sc=-merc}', "");
    Expect(1, 68096, '\P{Is_Sc=-merc}', "");
    Expect(0, 68096, '\P{^Is_Sc=-merc}', "");
    Error('\p{Script=/a/	_Meroitic_Hieroglyphs}');
    Error('\P{Script=/a/	_Meroitic_Hieroglyphs}');
    Expect(1, 67999, '\p{Script=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Script=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Script=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Script=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Script=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Script=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Script=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Script=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Script=	_Meroitic_HIEROGLYPHS}', "");
    Expect(0, 67999, '\p{^Script=	_Meroitic_HIEROGLYPHS}', "");
    Expect(0, 67999, '\P{Script=	_Meroitic_HIEROGLYPHS}', "");
    Expect(1, 67999, '\P{^Script=	_Meroitic_HIEROGLYPHS}', "");
    Expect(0, 68000, '\p{Script=	_Meroitic_HIEROGLYPHS}', "");
    Expect(1, 68000, '\p{^Script=	_Meroitic_HIEROGLYPHS}', "");
    Expect(1, 68000, '\P{Script=	_Meroitic_HIEROGLYPHS}', "");
    Expect(0, 68000, '\P{^Script=	_Meroitic_HIEROGLYPHS}', "");
    Error('\p{Sc=	/a/Mero}');
    Error('\P{Sc=	/a/Mero}');
    Expect(1, 67999, '\p{Sc=mero}', "");
    Expect(0, 67999, '\p{^Sc=mero}', "");
    Expect(0, 67999, '\P{Sc=mero}', "");
    Expect(1, 67999, '\P{^Sc=mero}', "");
    Expect(0, 68000, '\p{Sc=mero}', "");
    Expect(1, 68000, '\p{^Sc=mero}', "");
    Expect(1, 68000, '\P{Sc=mero}', "");
    Expect(0, 68000, '\P{^Sc=mero}', "");
    Expect(1, 67999, '\p{Sc=- Mero}', "");
    Expect(0, 67999, '\p{^Sc=- Mero}', "");
    Expect(0, 67999, '\P{Sc=- Mero}', "");
    Expect(1, 67999, '\P{^Sc=- Mero}', "");
    Expect(0, 68000, '\p{Sc=- Mero}', "");
    Expect(1, 68000, '\p{^Sc=- Mero}', "");
    Expect(1, 68000, '\P{Sc=- Mero}', "");
    Expect(0, 68000, '\P{^Sc=- Mero}', "");
    Error('\p{Is_Script=:=-meroitic_Hieroglyphs}');
    Error('\P{Is_Script=:=-meroitic_Hieroglyphs}');
    Expect(1, 67999, '\p{Is_Script:   meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Script:   meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Script:   meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Script:   meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Script:   meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Script:   meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Script:   meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Script:   meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Is_Script=-Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Script=-Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Script=-Meroitic_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Script=-Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Script=-Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Script=-Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Script=-Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Script=-Meroitic_Hieroglyphs}', "");
    Error('\p{Is_Sc= 	MERO:=}');
    Error('\P{Is_Sc= 	MERO:=}');
    Expect(1, 67999, '\p{Is_Sc=mero}', "");
    Expect(0, 67999, '\p{^Is_Sc=mero}', "");
    Expect(0, 67999, '\P{Is_Sc=mero}', "");
    Expect(1, 67999, '\P{^Is_Sc=mero}', "");
    Expect(0, 68000, '\p{Is_Sc=mero}', "");
    Expect(1, 68000, '\p{^Is_Sc=mero}', "");
    Expect(1, 68000, '\P{Is_Sc=mero}', "");
    Expect(0, 68000, '\P{^Is_Sc=mero}', "");
    Expect(1, 67999, '\p{Is_Sc:_ Mero}', "");
    Expect(0, 67999, '\p{^Is_Sc:_ Mero}', "");
    Expect(0, 67999, '\P{Is_Sc:_ Mero}', "");
    Expect(1, 67999, '\P{^Is_Sc:_ Mero}', "");
    Expect(0, 68000, '\p{Is_Sc:_ Mero}', "");
    Expect(1, 68000, '\p{^Is_Sc:_ Mero}', "");
    Expect(1, 68000, '\P{Is_Sc:_ Mero}', "");
    Expect(0, 68000, '\P{^Is_Sc:_ Mero}', "");
    Error('\p{Script=:=malayalam}');
    Error('\P{Script=:=malayalam}');
    Expect(1, 3455, '\p{Script:malayalam}', "");
    Expect(0, 3455, '\p{^Script:malayalam}', "");
    Expect(0, 3455, '\P{Script:malayalam}', "");
    Expect(1, 3455, '\P{^Script:malayalam}', "");
    Expect(0, 3456, '\p{Script:malayalam}', "");
    Expect(1, 3456, '\p{^Script:malayalam}', "");
    Expect(1, 3456, '\P{Script:malayalam}', "");
    Expect(0, 3456, '\P{^Script:malayalam}', "");
    Expect(1, 3455, '\p{Script=_ Malayalam}', "");
    Expect(0, 3455, '\p{^Script=_ Malayalam}', "");
    Expect(0, 3455, '\P{Script=_ Malayalam}', "");
    Expect(1, 3455, '\P{^Script=_ Malayalam}', "");
    Expect(0, 3456, '\p{Script=_ Malayalam}', "");
    Expect(1, 3456, '\p{^Script=_ Malayalam}', "");
    Expect(1, 3456, '\P{Script=_ Malayalam}', "");
    Expect(0, 3456, '\P{^Script=_ Malayalam}', "");
    Error('\p{Sc=	:=Mlym}');
    Error('\P{Sc=	:=Mlym}');
    Expect(1, 3455, '\p{Sc=mlym}', "");
    Expect(0, 3455, '\p{^Sc=mlym}', "");
    Expect(0, 3455, '\P{Sc=mlym}', "");
    Expect(1, 3455, '\P{^Sc=mlym}', "");
    Expect(0, 3456, '\p{Sc=mlym}', "");
    Expect(1, 3456, '\p{^Sc=mlym}', "");
    Expect(1, 3456, '\P{Sc=mlym}', "");
    Expect(0, 3456, '\P{^Sc=mlym}', "");
    Expect(1, 3455, '\p{Sc:   _mlym}', "");
    Expect(0, 3455, '\p{^Sc:   _mlym}', "");
    Expect(0, 3455, '\P{Sc:   _mlym}', "");
    Expect(1, 3455, '\P{^Sc:   _mlym}', "");
    Expect(0, 3456, '\p{Sc:   _mlym}', "");
    Expect(1, 3456, '\p{^Sc:   _mlym}', "");
    Expect(1, 3456, '\P{Sc:   _mlym}', "");
    Expect(0, 3456, '\P{^Sc:   _mlym}', "");
    Error('\p{Is_Script=/a/Malayalam}');
    Error('\P{Is_Script=/a/Malayalam}');
    Expect(1, 3455, '\p{Is_Script=malayalam}', "");
    Expect(0, 3455, '\p{^Is_Script=malayalam}', "");
    Expect(0, 3455, '\P{Is_Script=malayalam}', "");
    Expect(1, 3455, '\P{^Is_Script=malayalam}', "");
    Expect(0, 3456, '\p{Is_Script=malayalam}', "");
    Expect(1, 3456, '\p{^Is_Script=malayalam}', "");
    Expect(1, 3456, '\P{Is_Script=malayalam}', "");
    Expect(0, 3456, '\P{^Is_Script=malayalam}', "");
    Expect(1, 3455, '\p{Is_Script=	-Malayalam}', "");
    Expect(0, 3455, '\p{^Is_Script=	-Malayalam}', "");
    Expect(0, 3455, '\P{Is_Script=	-Malayalam}', "");
    Expect(1, 3455, '\P{^Is_Script=	-Malayalam}', "");
    Expect(0, 3456, '\p{Is_Script=	-Malayalam}', "");
    Expect(1, 3456, '\p{^Is_Script=	-Malayalam}', "");
    Expect(1, 3456, '\P{Is_Script=	-Malayalam}', "");
    Expect(0, 3456, '\P{^Is_Script=	-Malayalam}', "");
    Error('\p{Is_Sc= 	MLYM:=}');
    Error('\P{Is_Sc= 	MLYM:=}');
    Expect(1, 3455, '\p{Is_Sc=mlym}', "");
    Expect(0, 3455, '\p{^Is_Sc=mlym}', "");
    Expect(0, 3455, '\P{Is_Sc=mlym}', "");
    Expect(1, 3455, '\P{^Is_Sc=mlym}', "");
    Expect(0, 3456, '\p{Is_Sc=mlym}', "");
    Expect(1, 3456, '\p{^Is_Sc=mlym}', "");
    Expect(1, 3456, '\P{Is_Sc=mlym}', "");
    Expect(0, 3456, '\P{^Is_Sc=mlym}', "");
    Expect(1, 3455, '\p{Is_Sc=	mlym}', "");
    Expect(0, 3455, '\p{^Is_Sc=	mlym}', "");
    Expect(0, 3455, '\P{Is_Sc=	mlym}', "");
    Expect(1, 3455, '\P{^Is_Sc=	mlym}', "");
    Expect(0, 3456, '\p{Is_Sc=	mlym}', "");
    Expect(1, 3456, '\p{^Is_Sc=	mlym}', "");
    Expect(1, 3456, '\P{Is_Sc=	mlym}', "");
    Expect(0, 3456, '\P{^Is_Sc=	mlym}', "");
    Error('\p{Script=-_MODI/a/}');
    Error('\P{Script=-_MODI/a/}');
    Expect(1, 71257, '\p{Script=modi}', "");
    Expect(0, 71257, '\p{^Script=modi}', "");
    Expect(0, 71257, '\P{Script=modi}', "");
    Expect(1, 71257, '\P{^Script=modi}', "");
    Expect(0, 71258, '\p{Script=modi}', "");
    Expect(1, 71258, '\p{^Script=modi}', "");
    Expect(1, 71258, '\P{Script=modi}', "");
    Expect(0, 71258, '\P{^Script=modi}', "");
    Expect(1, 71257, '\p{Script=	Modi}', "");
    Expect(0, 71257, '\p{^Script=	Modi}', "");
    Expect(0, 71257, '\P{Script=	Modi}', "");
    Expect(1, 71257, '\P{^Script=	Modi}', "");
    Expect(0, 71258, '\p{Script=	Modi}', "");
    Expect(1, 71258, '\p{^Script=	Modi}', "");
    Expect(1, 71258, '\P{Script=	Modi}', "");
    Expect(0, 71258, '\P{^Script=	Modi}', "");
    Error('\p{Sc= 	modi/a/}');
    Error('\P{Sc= 	modi/a/}');
    Expect(1, 71257, '\p{Sc=modi}', "");
    Expect(0, 71257, '\p{^Sc=modi}', "");
    Expect(0, 71257, '\P{Sc=modi}', "");
    Expect(1, 71257, '\P{^Sc=modi}', "");
    Expect(0, 71258, '\p{Sc=modi}', "");
    Expect(1, 71258, '\p{^Sc=modi}', "");
    Expect(1, 71258, '\P{Sc=modi}', "");
    Expect(0, 71258, '\P{^Sc=modi}', "");
    Expect(1, 71257, '\p{Sc=  Modi}', "");
    Expect(0, 71257, '\p{^Sc=  Modi}', "");
    Expect(0, 71257, '\P{Sc=  Modi}', "");
    Expect(1, 71257, '\P{^Sc=  Modi}', "");
    Expect(0, 71258, '\p{Sc=  Modi}', "");
    Expect(1, 71258, '\p{^Sc=  Modi}', "");
    Expect(1, 71258, '\P{Sc=  Modi}', "");
    Expect(0, 71258, '\P{^Sc=  Modi}', "");
    Error('\p{Is_Script=/a/-_Modi}');
    Error('\P{Is_Script=/a/-_Modi}');
    Expect(1, 71257, '\p{Is_Script=modi}', "");
    Expect(0, 71257, '\p{^Is_Script=modi}', "");
    Expect(0, 71257, '\P{Is_Script=modi}', "");
    Expect(1, 71257, '\P{^Is_Script=modi}', "");
    Expect(0, 71258, '\p{Is_Script=modi}', "");
    Expect(1, 71258, '\p{^Is_Script=modi}', "");
    Expect(1, 71258, '\P{Is_Script=modi}', "");
    Expect(0, 71258, '\P{^Is_Script=modi}', "");
    Expect(1, 71257, '\p{Is_Script:	--modi}', "");
    Expect(0, 71257, '\p{^Is_Script:	--modi}', "");
    Expect(0, 71257, '\P{Is_Script:	--modi}', "");
    Expect(1, 71257, '\P{^Is_Script:	--modi}', "");
    Expect(0, 71258, '\p{Is_Script:	--modi}', "");
    Expect(1, 71258, '\p{^Is_Script:	--modi}', "");
    Expect(1, 71258, '\P{Is_Script:	--modi}', "");
    Expect(0, 71258, '\P{^Is_Script:	--modi}', "");
    Error('\p{Is_Sc:_-modi:=}');
    Error('\P{Is_Sc:_-modi:=}');
    Expect(1, 71257, '\p{Is_Sc:modi}', "");
    Expect(0, 71257, '\p{^Is_Sc:modi}', "");
    Expect(0, 71257, '\P{Is_Sc:modi}', "");
    Expect(1, 71257, '\P{^Is_Sc:modi}', "");
    Expect(0, 71258, '\p{Is_Sc:modi}', "");
    Expect(1, 71258, '\p{^Is_Sc:modi}', "");
    Expect(1, 71258, '\P{Is_Sc:modi}', "");
    Expect(0, 71258, '\P{^Is_Sc:modi}', "");
    Expect(1, 71257, '\p{Is_Sc=_ MODI}', "");
    Expect(0, 71257, '\p{^Is_Sc=_ MODI}', "");
    Expect(0, 71257, '\P{Is_Sc=_ MODI}', "");
    Expect(1, 71257, '\P{^Is_Sc=_ MODI}', "");
    Expect(0, 71258, '\p{Is_Sc=_ MODI}', "");
    Expect(1, 71258, '\p{^Is_Sc=_ MODI}', "");
    Expect(1, 71258, '\P{Is_Sc=_ MODI}', "");
    Expect(0, 71258, '\P{^Is_Sc=_ MODI}', "");
    Error('\p{Script=:=mongolian}');
    Error('\P{Script=:=mongolian}');
    Expect(1, 71276, '\p{Script=mongolian}', "");
    Expect(0, 71276, '\p{^Script=mongolian}', "");
    Expect(0, 71276, '\P{Script=mongolian}', "");
    Expect(1, 71276, '\P{^Script=mongolian}', "");
    Expect(0, 71277, '\p{Script=mongolian}', "");
    Expect(1, 71277, '\p{^Script=mongolian}', "");
    Expect(1, 71277, '\P{Script=mongolian}', "");
    Expect(0, 71277, '\P{^Script=mongolian}', "");
    Expect(1, 71276, '\p{Script= -MONGOLIAN}', "");
    Expect(0, 71276, '\p{^Script= -MONGOLIAN}', "");
    Expect(0, 71276, '\P{Script= -MONGOLIAN}', "");
    Expect(1, 71276, '\P{^Script= -MONGOLIAN}', "");
    Expect(0, 71277, '\p{Script= -MONGOLIAN}', "");
    Expect(1, 71277, '\p{^Script= -MONGOLIAN}', "");
    Expect(1, 71277, '\P{Script= -MONGOLIAN}', "");
    Expect(0, 71277, '\P{^Script= -MONGOLIAN}', "");
    Error('\p{Sc=_:=Mong}');
    Error('\P{Sc=_:=Mong}');
    Expect(1, 71276, '\p{Sc=mong}', "");
    Expect(0, 71276, '\p{^Sc=mong}', "");
    Expect(0, 71276, '\P{Sc=mong}', "");
    Expect(1, 71276, '\P{^Sc=mong}', "");
    Expect(0, 71277, '\p{Sc=mong}', "");
    Expect(1, 71277, '\p{^Sc=mong}', "");
    Expect(1, 71277, '\P{Sc=mong}', "");
    Expect(0, 71277, '\P{^Sc=mong}', "");
    Expect(1, 71276, '\p{Sc= 	MONG}', "");
    Expect(0, 71276, '\p{^Sc= 	MONG}', "");
    Expect(0, 71276, '\P{Sc= 	MONG}', "");
    Expect(1, 71276, '\P{^Sc= 	MONG}', "");
    Expect(0, 71277, '\p{Sc= 	MONG}', "");
    Expect(1, 71277, '\p{^Sc= 	MONG}', "");
    Expect(1, 71277, '\P{Sc= 	MONG}', "");
    Expect(0, 71277, '\P{^Sc= 	MONG}', "");
    Error('\p{Is_Script=_/a/Mongolian}');
    Error('\P{Is_Script=_/a/Mongolian}');
    Expect(1, 71276, '\p{Is_Script: mongolian}', "");
    Expect(0, 71276, '\p{^Is_Script: mongolian}', "");
    Expect(0, 71276, '\P{Is_Script: mongolian}', "");
    Expect(1, 71276, '\P{^Is_Script: mongolian}', "");
    Expect(0, 71277, '\p{Is_Script: mongolian}', "");
    Expect(1, 71277, '\p{^Is_Script: mongolian}', "");
    Expect(1, 71277, '\P{Is_Script: mongolian}', "");
    Expect(0, 71277, '\P{^Is_Script: mongolian}', "");
    Expect(1, 71276, '\p{Is_Script=_ MONGOLIAN}', "");
    Expect(0, 71276, '\p{^Is_Script=_ MONGOLIAN}', "");
    Expect(0, 71276, '\P{Is_Script=_ MONGOLIAN}', "");
    Expect(1, 71276, '\P{^Is_Script=_ MONGOLIAN}', "");
    Expect(0, 71277, '\p{Is_Script=_ MONGOLIAN}', "");
    Expect(1, 71277, '\p{^Is_Script=_ MONGOLIAN}', "");
    Expect(1, 71277, '\P{Is_Script=_ MONGOLIAN}', "");
    Expect(0, 71277, '\P{^Is_Script=_ MONGOLIAN}', "");
    Error('\p{Is_Sc=--Mong/a/}');
    Error('\P{Is_Sc=--Mong/a/}');
    Expect(1, 71276, '\p{Is_Sc=mong}', "");
    Expect(0, 71276, '\p{^Is_Sc=mong}', "");
    Expect(0, 71276, '\P{Is_Sc=mong}', "");
    Expect(1, 71276, '\P{^Is_Sc=mong}', "");
    Expect(0, 71277, '\p{Is_Sc=mong}', "");
    Expect(1, 71277, '\p{^Is_Sc=mong}', "");
    Expect(1, 71277, '\P{Is_Sc=mong}', "");
    Expect(0, 71277, '\P{^Is_Sc=mong}', "");
    Expect(1, 71276, '\p{Is_Sc= Mong}', "");
    Expect(0, 71276, '\p{^Is_Sc= Mong}', "");
    Expect(0, 71276, '\P{Is_Sc= Mong}', "");
    Expect(1, 71276, '\P{^Is_Sc= Mong}', "");
    Expect(0, 71277, '\p{Is_Sc= Mong}', "");
    Expect(1, 71277, '\p{^Is_Sc= Mong}', "");
    Expect(1, 71277, '\P{Is_Sc= Mong}', "");
    Expect(0, 71277, '\P{^Is_Sc= Mong}', "");
    Error('\p{Script= /a/mro}');
    Error('\P{Script= /a/mro}');
    Expect(1, 92783, '\p{Script=mro}', "");
    Expect(0, 92783, '\p{^Script=mro}', "");
    Expect(0, 92783, '\P{Script=mro}', "");
    Expect(1, 92783, '\P{^Script=mro}', "");
    Expect(0, 92784, '\p{Script=mro}', "");
    Expect(1, 92784, '\p{^Script=mro}', "");
    Expect(1, 92784, '\P{Script=mro}', "");
    Expect(0, 92784, '\P{^Script=mro}', "");
    Expect(1, 92783, '\p{Script=	mro}', "");
    Expect(0, 92783, '\p{^Script=	mro}', "");
    Expect(0, 92783, '\P{Script=	mro}', "");
    Expect(1, 92783, '\P{^Script=	mro}', "");
    Expect(0, 92784, '\p{Script=	mro}', "");
    Expect(1, 92784, '\p{^Script=	mro}', "");
    Expect(1, 92784, '\P{Script=	mro}', "");
    Expect(0, 92784, '\P{^Script=	mro}', "");
    Error('\p{Sc=		MROO/a/}');
    Error('\P{Sc=		MROO/a/}');
    Expect(1, 92783, '\p{Sc=mroo}', "");
    Expect(0, 92783, '\p{^Sc=mroo}', "");
    Expect(0, 92783, '\P{Sc=mroo}', "");
    Expect(1, 92783, '\P{^Sc=mroo}', "");
    Expect(0, 92784, '\p{Sc=mroo}', "");
    Expect(1, 92784, '\p{^Sc=mroo}', "");
    Expect(1, 92784, '\P{Sc=mroo}', "");
    Expect(0, 92784, '\P{^Sc=mroo}', "");
    Expect(1, 92783, '\p{Sc:   - MROO}', "");
    Expect(0, 92783, '\p{^Sc:   - MROO}', "");
    Expect(0, 92783, '\P{Sc:   - MROO}', "");
    Expect(1, 92783, '\P{^Sc:   - MROO}', "");
    Expect(0, 92784, '\p{Sc:   - MROO}', "");
    Expect(1, 92784, '\p{^Sc:   - MROO}', "");
    Expect(1, 92784, '\P{Sc:   - MROO}', "");
    Expect(0, 92784, '\P{^Sc:   - MROO}', "");
    Error('\p{Is_Script= /a/MRO}');
    Error('\P{Is_Script= /a/MRO}');
    Expect(1, 92783, '\p{Is_Script=mro}', "");
    Expect(0, 92783, '\p{^Is_Script=mro}', "");
    Expect(0, 92783, '\P{Is_Script=mro}', "");
    Expect(1, 92783, '\P{^Is_Script=mro}', "");
    Expect(0, 92784, '\p{Is_Script=mro}', "");
    Expect(1, 92784, '\p{^Is_Script=mro}', "");
    Expect(1, 92784, '\P{Is_Script=mro}', "");
    Expect(0, 92784, '\P{^Is_Script=mro}', "");
    Expect(1, 92783, '\p{Is_Script=-Mro}', "");
    Expect(0, 92783, '\p{^Is_Script=-Mro}', "");
    Expect(0, 92783, '\P{Is_Script=-Mro}', "");
    Expect(1, 92783, '\P{^Is_Script=-Mro}', "");
    Expect(0, 92784, '\p{Is_Script=-Mro}', "");
    Expect(1, 92784, '\p{^Is_Script=-Mro}', "");
    Expect(1, 92784, '\P{Is_Script=-Mro}', "");
    Expect(0, 92784, '\P{^Is_Script=-Mro}', "");
    Error('\p{Is_Sc=__MROO:=}');
    Error('\P{Is_Sc=__MROO:=}');
    Expect(1, 92783, '\p{Is_Sc=mroo}', "");
    Expect(0, 92783, '\p{^Is_Sc=mroo}', "");
    Expect(0, 92783, '\P{Is_Sc=mroo}', "");
    Expect(1, 92783, '\P{^Is_Sc=mroo}', "");
    Expect(0, 92784, '\p{Is_Sc=mroo}', "");
    Expect(1, 92784, '\p{^Is_Sc=mroo}', "");
    Expect(1, 92784, '\P{Is_Sc=mroo}', "");
    Expect(0, 92784, '\P{^Is_Sc=mroo}', "");
    Expect(1, 92783, '\p{Is_Sc:   _	Mroo}', "");
    Expect(0, 92783, '\p{^Is_Sc:   _	Mroo}', "");
    Expect(0, 92783, '\P{Is_Sc:   _	Mroo}', "");
    Expect(1, 92783, '\P{^Is_Sc:   _	Mroo}', "");
    Expect(0, 92784, '\p{Is_Sc:   _	Mroo}', "");
    Expect(1, 92784, '\p{^Is_Sc:   _	Mroo}', "");
    Expect(1, 92784, '\P{Is_Sc:   _	Mroo}', "");
    Expect(0, 92784, '\P{^Is_Sc:   _	Mroo}', "");
    Error('\p{Script=/a/_Meetei_Mayek}');
    Error('\P{Script=/a/_Meetei_Mayek}');
    Expect(1, 44025, '\p{Script=meeteimayek}', "");
    Expect(0, 44025, '\p{^Script=meeteimayek}', "");
    Expect(0, 44025, '\P{Script=meeteimayek}', "");
    Expect(1, 44025, '\P{^Script=meeteimayek}', "");
    Expect(0, 44026, '\p{Script=meeteimayek}', "");
    Expect(1, 44026, '\p{^Script=meeteimayek}', "");
    Expect(1, 44026, '\P{Script=meeteimayek}', "");
    Expect(0, 44026, '\P{^Script=meeteimayek}', "");
    Expect(1, 44025, '\p{Script=	_Meetei_MAYEK}', "");
    Expect(0, 44025, '\p{^Script=	_Meetei_MAYEK}', "");
    Expect(0, 44025, '\P{Script=	_Meetei_MAYEK}', "");
    Expect(1, 44025, '\P{^Script=	_Meetei_MAYEK}', "");
    Expect(0, 44026, '\p{Script=	_Meetei_MAYEK}', "");
    Expect(1, 44026, '\p{^Script=	_Meetei_MAYEK}', "");
    Expect(1, 44026, '\P{Script=	_Meetei_MAYEK}', "");
    Expect(0, 44026, '\P{^Script=	_Meetei_MAYEK}', "");
    Error('\p{Sc=_Mtei:=}');
    Error('\P{Sc=_Mtei:=}');
    Expect(1, 44025, '\p{Sc=mtei}', "");
    Expect(0, 44025, '\p{^Sc=mtei}', "");
    Expect(0, 44025, '\P{Sc=mtei}', "");
    Expect(1, 44025, '\P{^Sc=mtei}', "");
    Expect(0, 44026, '\p{Sc=mtei}', "");
    Expect(1, 44026, '\p{^Sc=mtei}', "");
    Expect(1, 44026, '\P{Sc=mtei}', "");
    Expect(0, 44026, '\P{^Sc=mtei}', "");
    Expect(1, 44025, '\p{Sc=-Mtei}', "");
    Expect(0, 44025, '\p{^Sc=-Mtei}', "");
    Expect(0, 44025, '\P{Sc=-Mtei}', "");
    Expect(1, 44025, '\P{^Sc=-Mtei}', "");
    Expect(0, 44026, '\p{Sc=-Mtei}', "");
    Expect(1, 44026, '\p{^Sc=-Mtei}', "");
    Expect(1, 44026, '\P{Sc=-Mtei}', "");
    Expect(0, 44026, '\P{^Sc=-Mtei}', "");
    Error('\p{Is_Script::=- Meetei_mayek}');
    Error('\P{Is_Script::=- Meetei_mayek}');
    Expect(1, 44025, '\p{Is_Script:	meeteimayek}', "");
    Expect(0, 44025, '\p{^Is_Script:	meeteimayek}', "");
    Expect(0, 44025, '\P{Is_Script:	meeteimayek}', "");
    Expect(1, 44025, '\P{^Is_Script:	meeteimayek}', "");
    Expect(0, 44026, '\p{Is_Script:	meeteimayek}', "");
    Expect(1, 44026, '\p{^Is_Script:	meeteimayek}', "");
    Expect(1, 44026, '\P{Is_Script:	meeteimayek}', "");
    Expect(0, 44026, '\P{^Is_Script:	meeteimayek}', "");
    Expect(1, 44025, '\p{Is_Script=	_meetei_MAYEK}', "");
    Expect(0, 44025, '\p{^Is_Script=	_meetei_MAYEK}', "");
    Expect(0, 44025, '\P{Is_Script=	_meetei_MAYEK}', "");
    Expect(1, 44025, '\P{^Is_Script=	_meetei_MAYEK}', "");
    Expect(0, 44026, '\p{Is_Script=	_meetei_MAYEK}', "");
    Expect(1, 44026, '\p{^Is_Script=	_meetei_MAYEK}', "");
    Expect(1, 44026, '\P{Is_Script=	_meetei_MAYEK}', "");
    Expect(0, 44026, '\P{^Is_Script=	_meetei_MAYEK}', "");
    Error('\p{Is_Sc=/a/MTEI}');
    Error('\P{Is_Sc=/a/MTEI}');
    Expect(1, 44025, '\p{Is_Sc=mtei}', "");
    Expect(0, 44025, '\p{^Is_Sc=mtei}', "");
    Expect(0, 44025, '\P{Is_Sc=mtei}', "");
    Expect(1, 44025, '\P{^Is_Sc=mtei}', "");
    Expect(0, 44026, '\p{Is_Sc=mtei}', "");
    Expect(1, 44026, '\p{^Is_Sc=mtei}', "");
    Expect(1, 44026, '\P{Is_Sc=mtei}', "");
    Expect(0, 44026, '\P{^Is_Sc=mtei}', "");
    Expect(1, 44025, '\p{Is_Sc=		MTEI}', "");
    Expect(0, 44025, '\p{^Is_Sc=		MTEI}', "");
    Expect(0, 44025, '\P{Is_Sc=		MTEI}', "");
    Expect(1, 44025, '\P{^Is_Sc=		MTEI}', "");
    Expect(0, 44026, '\p{Is_Sc=		MTEI}', "");
    Expect(1, 44026, '\p{^Is_Sc=		MTEI}', "");
    Expect(1, 44026, '\P{Is_Sc=		MTEI}', "");
    Expect(0, 44026, '\P{^Is_Sc=		MTEI}', "");
    Error('\p{Script:  _multani/a/}');
    Error('\P{Script:  _multani/a/}');
    Expect(1, 70313, '\p{Script: multani}', "");
    Expect(0, 70313, '\p{^Script: multani}', "");
    Expect(0, 70313, '\P{Script: multani}', "");
    Expect(1, 70313, '\P{^Script: multani}', "");
    Expect(0, 70314, '\p{Script: multani}', "");
    Expect(1, 70314, '\p{^Script: multani}', "");
    Expect(1, 70314, '\P{Script: multani}', "");
    Expect(0, 70314, '\P{^Script: multani}', "");
    Expect(1, 70313, '\p{Script= multani}', "");
    Expect(0, 70313, '\p{^Script= multani}', "");
    Expect(0, 70313, '\P{Script= multani}', "");
    Expect(1, 70313, '\P{^Script= multani}', "");
    Expect(0, 70314, '\p{Script= multani}', "");
    Expect(1, 70314, '\p{^Script= multani}', "");
    Expect(1, 70314, '\P{Script= multani}', "");
    Expect(0, 70314, '\P{^Script= multani}', "");
    Error('\p{Sc=	_Mult:=}');
    Error('\P{Sc=	_Mult:=}');
    Expect(1, 70313, '\p{Sc=mult}', "");
    Expect(0, 70313, '\p{^Sc=mult}', "");
    Expect(0, 70313, '\P{Sc=mult}', "");
    Expect(1, 70313, '\P{^Sc=mult}', "");
    Expect(0, 70314, '\p{Sc=mult}', "");
    Expect(1, 70314, '\p{^Sc=mult}', "");
    Expect(1, 70314, '\P{Sc=mult}', "");
    Expect(0, 70314, '\P{^Sc=mult}', "");
    Expect(1, 70313, '\p{Sc=	 MULT}', "");
    Expect(0, 70313, '\p{^Sc=	 MULT}', "");
    Expect(0, 70313, '\P{Sc=	 MULT}', "");
    Expect(1, 70313, '\P{^Sc=	 MULT}', "");
    Expect(0, 70314, '\p{Sc=	 MULT}', "");
    Expect(1, 70314, '\p{^Sc=	 MULT}', "");
    Expect(1, 70314, '\P{Sc=	 MULT}', "");
    Expect(0, 70314, '\P{^Sc=	 MULT}', "");
    Error('\p{Is_Script=	 multani/a/}');
    Error('\P{Is_Script=	 multani/a/}');
    Expect(1, 70313, '\p{Is_Script=multani}', "");
    Expect(0, 70313, '\p{^Is_Script=multani}', "");
    Expect(0, 70313, '\P{Is_Script=multani}', "");
    Expect(1, 70313, '\P{^Is_Script=multani}', "");
    Expect(0, 70314, '\p{Is_Script=multani}', "");
    Expect(1, 70314, '\p{^Is_Script=multani}', "");
    Expect(1, 70314, '\P{Is_Script=multani}', "");
    Expect(0, 70314, '\P{^Is_Script=multani}', "");
    Expect(1, 70313, '\p{Is_Script=_ multani}', "");
    Expect(0, 70313, '\p{^Is_Script=_ multani}', "");
    Expect(0, 70313, '\P{Is_Script=_ multani}', "");
    Expect(1, 70313, '\P{^Is_Script=_ multani}', "");
    Expect(0, 70314, '\p{Is_Script=_ multani}', "");
    Expect(1, 70314, '\p{^Is_Script=_ multani}', "");
    Expect(1, 70314, '\P{Is_Script=_ multani}', "");
    Expect(0, 70314, '\P{^Is_Script=_ multani}', "");
    Error('\p{Is_Sc= MULT/a/}');
    Error('\P{Is_Sc= MULT/a/}');
    Expect(1, 70313, '\p{Is_Sc=mult}', "");
    Expect(0, 70313, '\p{^Is_Sc=mult}', "");
    Expect(0, 70313, '\P{Is_Sc=mult}', "");
    Expect(1, 70313, '\P{^Is_Sc=mult}', "");
    Expect(0, 70314, '\p{Is_Sc=mult}', "");
    Expect(1, 70314, '\p{^Is_Sc=mult}', "");
    Expect(1, 70314, '\P{Is_Sc=mult}', "");
    Expect(0, 70314, '\P{^Is_Sc=mult}', "");
    Expect(1, 70313, '\p{Is_Sc= -mult}', "");
    Expect(0, 70313, '\p{^Is_Sc= -mult}', "");
    Expect(0, 70313, '\P{Is_Sc= -mult}', "");
    Expect(1, 70313, '\P{^Is_Sc= -mult}', "");
    Expect(0, 70314, '\p{Is_Sc= -mult}', "");
    Expect(1, 70314, '\p{^Is_Sc= -mult}', "");
    Expect(1, 70314, '\P{Is_Sc= -mult}', "");
    Expect(0, 70314, '\P{^Is_Sc= -mult}', "");
    Error('\p{Script=:=	myanmar}');
    Error('\P{Script=:=	myanmar}');
    Expect(1, 43647, '\p{Script=myanmar}', "");
    Expect(0, 43647, '\p{^Script=myanmar}', "");
    Expect(0, 43647, '\P{Script=myanmar}', "");
    Expect(1, 43647, '\P{^Script=myanmar}', "");
    Expect(0, 43648, '\p{Script=myanmar}', "");
    Expect(1, 43648, '\p{^Script=myanmar}', "");
    Expect(1, 43648, '\P{Script=myanmar}', "");
    Expect(0, 43648, '\P{^Script=myanmar}', "");
    Expect(1, 43647, '\p{Script=-_MYANMAR}', "");
    Expect(0, 43647, '\p{^Script=-_MYANMAR}', "");
    Expect(0, 43647, '\P{Script=-_MYANMAR}', "");
    Expect(1, 43647, '\P{^Script=-_MYANMAR}', "");
    Expect(0, 43648, '\p{Script=-_MYANMAR}', "");
    Expect(1, 43648, '\p{^Script=-_MYANMAR}', "");
    Expect(1, 43648, '\P{Script=-_MYANMAR}', "");
    Expect(0, 43648, '\P{^Script=-_MYANMAR}', "");
    Error('\p{Sc=	MYMR/a/}');
    Error('\P{Sc=	MYMR/a/}');
    Expect(1, 43647, '\p{Sc=mymr}', "");
    Expect(0, 43647, '\p{^Sc=mymr}', "");
    Expect(0, 43647, '\P{Sc=mymr}', "");
    Expect(1, 43647, '\P{^Sc=mymr}', "");
    Expect(0, 43648, '\p{Sc=mymr}', "");
    Expect(1, 43648, '\p{^Sc=mymr}', "");
    Expect(1, 43648, '\P{Sc=mymr}', "");
    Expect(0, 43648, '\P{^Sc=mymr}', "");
    Expect(1, 43647, '\p{Sc= Mymr}', "");
    Expect(0, 43647, '\p{^Sc= Mymr}', "");
    Expect(0, 43647, '\P{Sc= Mymr}', "");
    Expect(1, 43647, '\P{^Sc= Mymr}', "");
    Expect(0, 43648, '\p{Sc= Mymr}', "");
    Expect(1, 43648, '\p{^Sc= Mymr}', "");
    Expect(1, 43648, '\P{Sc= Mymr}', "");
    Expect(0, 43648, '\P{^Sc= Mymr}', "");
    Error('\p{Is_Script=-_myanmar:=}');
    Error('\P{Is_Script=-_myanmar:=}');
    Expect(1, 43647, '\p{Is_Script=myanmar}', "");
    Expect(0, 43647, '\p{^Is_Script=myanmar}', "");
    Expect(0, 43647, '\P{Is_Script=myanmar}', "");
    Expect(1, 43647, '\P{^Is_Script=myanmar}', "");
    Expect(0, 43648, '\p{Is_Script=myanmar}', "");
    Expect(1, 43648, '\p{^Is_Script=myanmar}', "");
    Expect(1, 43648, '\P{Is_Script=myanmar}', "");
    Expect(0, 43648, '\P{^Is_Script=myanmar}', "");
    Expect(1, 43647, '\p{Is_Script:	_	myanmar}', "");
    Expect(0, 43647, '\p{^Is_Script:	_	myanmar}', "");
    Expect(0, 43647, '\P{Is_Script:	_	myanmar}', "");
    Expect(1, 43647, '\P{^Is_Script:	_	myanmar}', "");
    Expect(0, 43648, '\p{Is_Script:	_	myanmar}', "");
    Expect(1, 43648, '\p{^Is_Script:	_	myanmar}', "");
    Expect(1, 43648, '\P{Is_Script:	_	myanmar}', "");
    Expect(0, 43648, '\P{^Is_Script:	_	myanmar}', "");
    Error('\p{Is_Sc:   _/a/Mymr}');
    Error('\P{Is_Sc:   _/a/Mymr}');
    Expect(1, 43647, '\p{Is_Sc=mymr}', "");
    Expect(0, 43647, '\p{^Is_Sc=mymr}', "");
    Expect(0, 43647, '\P{Is_Sc=mymr}', "");
    Expect(1, 43647, '\P{^Is_Sc=mymr}', "");
    Expect(0, 43648, '\p{Is_Sc=mymr}', "");
    Expect(1, 43648, '\p{^Is_Sc=mymr}', "");
    Expect(1, 43648, '\P{Is_Sc=mymr}', "");
    Expect(0, 43648, '\P{^Is_Sc=mymr}', "");
    Expect(1, 43647, '\p{Is_Sc=-Mymr}', "");
    Expect(0, 43647, '\p{^Is_Sc=-Mymr}', "");
    Expect(0, 43647, '\P{Is_Sc=-Mymr}', "");
    Expect(1, 43647, '\P{^Is_Sc=-Mymr}', "");
    Expect(0, 43648, '\p{Is_Sc=-Mymr}', "");
    Expect(1, 43648, '\p{^Is_Sc=-Mymr}', "");
    Expect(1, 43648, '\P{Is_Sc=-Mymr}', "");
    Expect(0, 43648, '\P{^Is_Sc=-Mymr}', "");
    Error('\p{Script=-_Old_north_Arabian/a/}');
    Error('\P{Script=-_Old_north_Arabian/a/}');
    Expect(1, 68255, '\p{Script=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Script=oldnortharabian}', "");
    Expect(0, 68255, '\P{Script=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Script=oldnortharabian}', "");
    Expect(0, 68256, '\p{Script=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Script=oldnortharabian}', "");
    Expect(1, 68256, '\P{Script=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Script=oldnortharabian}', "");
    Expect(1, 68255, '\p{Script=	 old_NORTH_Arabian}', "");
    Expect(0, 68255, '\p{^Script=	 old_NORTH_Arabian}', "");
    Expect(0, 68255, '\P{Script=	 old_NORTH_Arabian}', "");
    Expect(1, 68255, '\P{^Script=	 old_NORTH_Arabian}', "");
    Expect(0, 68256, '\p{Script=	 old_NORTH_Arabian}', "");
    Expect(1, 68256, '\p{^Script=	 old_NORTH_Arabian}', "");
    Expect(1, 68256, '\P{Script=	 old_NORTH_Arabian}', "");
    Expect(0, 68256, '\P{^Script=	 old_NORTH_Arabian}', "");
    Error('\p{Sc=:=-	NARB}');
    Error('\P{Sc=:=-	NARB}');
    Expect(1, 68255, '\p{Sc=narb}', "");
    Expect(0, 68255, '\p{^Sc=narb}', "");
    Expect(0, 68255, '\P{Sc=narb}', "");
    Expect(1, 68255, '\P{^Sc=narb}', "");
    Expect(0, 68256, '\p{Sc=narb}', "");
    Expect(1, 68256, '\p{^Sc=narb}', "");
    Expect(1, 68256, '\P{Sc=narb}', "");
    Expect(0, 68256, '\P{^Sc=narb}', "");
    Expect(1, 68255, '\p{Sc=-narb}', "");
    Expect(0, 68255, '\p{^Sc=-narb}', "");
    Expect(0, 68255, '\P{Sc=-narb}', "");
    Expect(1, 68255, '\P{^Sc=-narb}', "");
    Expect(0, 68256, '\p{Sc=-narb}', "");
    Expect(1, 68256, '\p{^Sc=-narb}', "");
    Expect(1, 68256, '\P{Sc=-narb}', "");
    Expect(0, 68256, '\P{^Sc=-narb}', "");
    Error('\p{Is_Script=/a/ OLD_North_Arabian}');
    Error('\P{Is_Script=/a/ OLD_North_Arabian}');
    Expect(1, 68255, '\p{Is_Script=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Is_Script=oldnortharabian}', "");
    Expect(0, 68255, '\P{Is_Script=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Is_Script=oldnortharabian}', "");
    Expect(0, 68256, '\p{Is_Script=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Is_Script=oldnortharabian}', "");
    Expect(1, 68256, '\P{Is_Script=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Is_Script=oldnortharabian}', "");
    Expect(1, 68255, '\p{Is_Script=OLD_North_Arabian}', "");
    Expect(0, 68255, '\p{^Is_Script=OLD_North_Arabian}', "");
    Expect(0, 68255, '\P{Is_Script=OLD_North_Arabian}', "");
    Expect(1, 68255, '\P{^Is_Script=OLD_North_Arabian}', "");
    Expect(0, 68256, '\p{Is_Script=OLD_North_Arabian}', "");
    Expect(1, 68256, '\p{^Is_Script=OLD_North_Arabian}', "");
    Expect(1, 68256, '\P{Is_Script=OLD_North_Arabian}', "");
    Expect(0, 68256, '\P{^Is_Script=OLD_North_Arabian}', "");
    Error('\p{Is_Sc=/a/ _narb}');
    Error('\P{Is_Sc=/a/ _narb}');
    Expect(1, 68255, '\p{Is_Sc: narb}', "");
    Expect(0, 68255, '\p{^Is_Sc: narb}', "");
    Expect(0, 68255, '\P{Is_Sc: narb}', "");
    Expect(1, 68255, '\P{^Is_Sc: narb}', "");
    Expect(0, 68256, '\p{Is_Sc: narb}', "");
    Expect(1, 68256, '\p{^Is_Sc: narb}', "");
    Expect(1, 68256, '\P{Is_Sc: narb}', "");
    Expect(0, 68256, '\P{^Is_Sc: narb}', "");
    Expect(1, 68255, '\p{Is_Sc=__Narb}', "");
    Expect(0, 68255, '\p{^Is_Sc=__Narb}', "");
    Expect(0, 68255, '\P{Is_Sc=__Narb}', "");
    Expect(1, 68255, '\P{^Is_Sc=__Narb}', "");
    Expect(0, 68256, '\p{Is_Sc=__Narb}', "");
    Expect(1, 68256, '\p{^Is_Sc=__Narb}', "");
    Expect(1, 68256, '\P{Is_Sc=__Narb}', "");
    Expect(0, 68256, '\P{^Is_Sc=__Narb}', "");
    Error('\p{Script=-Nabataean:=}');
    Error('\P{Script=-Nabataean:=}');
    Expect(1, 67759, '\p{Script=nabataean}', "");
    Expect(0, 67759, '\p{^Script=nabataean}', "");
    Expect(0, 67759, '\P{Script=nabataean}', "");
    Expect(1, 67759, '\P{^Script=nabataean}', "");
    Expect(0, 67760, '\p{Script=nabataean}', "");
    Expect(1, 67760, '\p{^Script=nabataean}', "");
    Expect(1, 67760, '\P{Script=nabataean}', "");
    Expect(0, 67760, '\P{^Script=nabataean}', "");
    Expect(1, 67759, '\p{Script= 	Nabataean}', "");
    Expect(0, 67759, '\p{^Script= 	Nabataean}', "");
    Expect(0, 67759, '\P{Script= 	Nabataean}', "");
    Expect(1, 67759, '\P{^Script= 	Nabataean}', "");
    Expect(0, 67760, '\p{Script= 	Nabataean}', "");
    Expect(1, 67760, '\p{^Script= 	Nabataean}', "");
    Expect(1, 67760, '\P{Script= 	Nabataean}', "");
    Expect(0, 67760, '\P{^Script= 	Nabataean}', "");
    Error('\p{Sc=/a/-Nbat}');
    Error('\P{Sc=/a/-Nbat}');
    Expect(1, 67759, '\p{Sc=nbat}', "");
    Expect(0, 67759, '\p{^Sc=nbat}', "");
    Expect(0, 67759, '\P{Sc=nbat}', "");
    Expect(1, 67759, '\P{^Sc=nbat}', "");
    Expect(0, 67760, '\p{Sc=nbat}', "");
    Expect(1, 67760, '\p{^Sc=nbat}', "");
    Expect(1, 67760, '\P{Sc=nbat}', "");
    Expect(0, 67760, '\P{^Sc=nbat}', "");
    Expect(1, 67759, '\p{Sc= nbat}', "");
    Expect(0, 67759, '\p{^Sc= nbat}', "");
    Expect(0, 67759, '\P{Sc= nbat}', "");
    Expect(1, 67759, '\P{^Sc= nbat}', "");
    Expect(0, 67760, '\p{Sc= nbat}', "");
    Expect(1, 67760, '\p{^Sc= nbat}', "");
    Expect(1, 67760, '\P{Sc= nbat}', "");
    Expect(0, 67760, '\P{^Sc= nbat}', "");
    Error('\p{Is_Script:   -:=Nabataean}');
    Error('\P{Is_Script:   -:=Nabataean}');
    Expect(1, 67759, '\p{Is_Script=nabataean}', "");
    Expect(0, 67759, '\p{^Is_Script=nabataean}', "");
    Expect(0, 67759, '\P{Is_Script=nabataean}', "");
    Expect(1, 67759, '\P{^Is_Script=nabataean}', "");
    Expect(0, 67760, '\p{Is_Script=nabataean}', "");
    Expect(1, 67760, '\p{^Is_Script=nabataean}', "");
    Expect(1, 67760, '\P{Is_Script=nabataean}', "");
    Expect(0, 67760, '\P{^Is_Script=nabataean}', "");
    Expect(1, 67759, '\p{Is_Script= Nabataean}', "");
    Expect(0, 67759, '\p{^Is_Script= Nabataean}', "");
    Expect(0, 67759, '\P{Is_Script= Nabataean}', "");
    Expect(1, 67759, '\P{^Is_Script= Nabataean}', "");
    Expect(0, 67760, '\p{Is_Script= Nabataean}', "");
    Expect(1, 67760, '\p{^Is_Script= Nabataean}', "");
    Expect(1, 67760, '\P{Is_Script= Nabataean}', "");
    Expect(0, 67760, '\P{^Is_Script= Nabataean}', "");
    Error('\p{Is_Sc= :=Nbat}');
    Error('\P{Is_Sc= :=Nbat}');
    Expect(1, 67759, '\p{Is_Sc=nbat}', "");
    Expect(0, 67759, '\p{^Is_Sc=nbat}', "");
    Expect(0, 67759, '\P{Is_Sc=nbat}', "");
    Expect(1, 67759, '\P{^Is_Sc=nbat}', "");
    Expect(0, 67760, '\p{Is_Sc=nbat}', "");
    Expect(1, 67760, '\p{^Is_Sc=nbat}', "");
    Expect(1, 67760, '\P{Is_Sc=nbat}', "");
    Expect(0, 67760, '\P{^Is_Sc=nbat}', "");
    Expect(1, 67759, '\p{Is_Sc=_-Nbat}', "");
    Expect(0, 67759, '\p{^Is_Sc=_-Nbat}', "");
    Expect(0, 67759, '\P{Is_Sc=_-Nbat}', "");
    Expect(1, 67759, '\P{^Is_Sc=_-Nbat}', "");
    Expect(0, 67760, '\p{Is_Sc=_-Nbat}', "");
    Expect(1, 67760, '\p{^Is_Sc=_-Nbat}', "");
    Expect(1, 67760, '\P{Is_Sc=_-Nbat}', "");
    Expect(0, 67760, '\P{^Is_Sc=_-Nbat}', "");
    Error('\p{Script: :=newa}');
    Error('\P{Script: :=newa}');
    Expect(1, 70749, '\p{Script=newa}', "");
    Expect(0, 70749, '\p{^Script=newa}', "");
    Expect(0, 70749, '\P{Script=newa}', "");
    Expect(1, 70749, '\P{^Script=newa}', "");
    Expect(0, 70750, '\p{Script=newa}', "");
    Expect(1, 70750, '\p{^Script=newa}', "");
    Expect(1, 70750, '\P{Script=newa}', "");
    Expect(0, 70750, '\P{^Script=newa}', "");
    Expect(1, 70749, '\p{Script= 	NEWA}', "");
    Expect(0, 70749, '\p{^Script= 	NEWA}', "");
    Expect(0, 70749, '\P{Script= 	NEWA}', "");
    Expect(1, 70749, '\P{^Script= 	NEWA}', "");
    Expect(0, 70750, '\p{Script= 	NEWA}', "");
    Expect(1, 70750, '\p{^Script= 	NEWA}', "");
    Expect(1, 70750, '\P{Script= 	NEWA}', "");
    Expect(0, 70750, '\P{^Script= 	NEWA}', "");
    Error('\p{Sc=:=Newa}');
    Error('\P{Sc=:=Newa}');
    Expect(1, 70749, '\p{Sc=newa}', "");
    Expect(0, 70749, '\p{^Sc=newa}', "");
    Expect(0, 70749, '\P{Sc=newa}', "");
    Expect(1, 70749, '\P{^Sc=newa}', "");
    Expect(0, 70750, '\p{Sc=newa}', "");
    Expect(1, 70750, '\p{^Sc=newa}', "");
    Expect(1, 70750, '\P{Sc=newa}', "");
    Expect(0, 70750, '\P{^Sc=newa}', "");
    Expect(1, 70749, '\p{Sc:		NEWA}', "");
    Expect(0, 70749, '\p{^Sc:		NEWA}', "");
    Expect(0, 70749, '\P{Sc:		NEWA}', "");
    Expect(1, 70749, '\P{^Sc:		NEWA}', "");
    Expect(0, 70750, '\p{Sc:		NEWA}', "");
    Expect(1, 70750, '\p{^Sc:		NEWA}', "");
    Expect(1, 70750, '\P{Sc:		NEWA}', "");
    Expect(0, 70750, '\P{^Sc:		NEWA}', "");
    Error('\p{Is_Script: := _newa}');
    Error('\P{Is_Script: := _newa}');
    Expect(1, 70749, '\p{Is_Script=newa}', "");
    Expect(0, 70749, '\p{^Is_Script=newa}', "");
    Expect(0, 70749, '\P{Is_Script=newa}', "");
    Expect(1, 70749, '\P{^Is_Script=newa}', "");
    Expect(0, 70750, '\p{Is_Script=newa}', "");
    Expect(1, 70750, '\p{^Is_Script=newa}', "");
    Expect(1, 70750, '\P{Is_Script=newa}', "");
    Expect(0, 70750, '\P{^Is_Script=newa}', "");
    Expect(1, 70749, '\p{Is_Script=	Newa}', "");
    Expect(0, 70749, '\p{^Is_Script=	Newa}', "");
    Expect(0, 70749, '\P{Is_Script=	Newa}', "");
    Expect(1, 70749, '\P{^Is_Script=	Newa}', "");
    Expect(0, 70750, '\p{Is_Script=	Newa}', "");
    Expect(1, 70750, '\p{^Is_Script=	Newa}', "");
    Expect(1, 70750, '\P{Is_Script=	Newa}', "");
    Expect(0, 70750, '\P{^Is_Script=	Newa}', "");
    Error('\p{Is_Sc=/a/	_newa}');
    Error('\P{Is_Sc=/a/	_newa}');
    Expect(1, 70749, '\p{Is_Sc=newa}', "");
    Expect(0, 70749, '\p{^Is_Sc=newa}', "");
    Expect(0, 70749, '\P{Is_Sc=newa}', "");
    Expect(1, 70749, '\P{^Is_Sc=newa}', "");
    Expect(0, 70750, '\p{Is_Sc=newa}', "");
    Expect(1, 70750, '\p{^Is_Sc=newa}', "");
    Expect(1, 70750, '\P{Is_Sc=newa}', "");
    Expect(0, 70750, '\P{^Is_Sc=newa}', "");
    Expect(1, 70749, '\p{Is_Sc=-_Newa}', "");
    Expect(0, 70749, '\p{^Is_Sc=-_Newa}', "");
    Expect(0, 70749, '\P{Is_Sc=-_Newa}', "");
    Expect(1, 70749, '\P{^Is_Sc=-_Newa}', "");
    Expect(0, 70750, '\p{Is_Sc=-_Newa}', "");
    Expect(1, 70750, '\p{^Is_Sc=-_Newa}', "");
    Expect(1, 70750, '\P{Is_Sc=-_Newa}', "");
    Expect(0, 70750, '\P{^Is_Sc=-_Newa}', "");
    Error('\p{Script=--Nko:=}');
    Error('\P{Script=--Nko:=}');
    Expect(1, 2042, '\p{Script=nko}', "");
    Expect(0, 2042, '\p{^Script=nko}', "");
    Expect(0, 2042, '\P{Script=nko}', "");
    Expect(1, 2042, '\P{^Script=nko}', "");
    Expect(0, 2043, '\p{Script=nko}', "");
    Expect(1, 2043, '\p{^Script=nko}', "");
    Expect(1, 2043, '\P{Script=nko}', "");
    Expect(0, 2043, '\P{^Script=nko}', "");
    Expect(1, 2042, '\p{Script= Nko}', "");
    Expect(0, 2042, '\p{^Script= Nko}', "");
    Expect(0, 2042, '\P{Script= Nko}', "");
    Expect(1, 2042, '\P{^Script= Nko}', "");
    Expect(0, 2043, '\p{Script= Nko}', "");
    Expect(1, 2043, '\p{^Script= Nko}', "");
    Expect(1, 2043, '\P{Script= Nko}', "");
    Expect(0, 2043, '\P{^Script= Nko}', "");
    Error('\p{Sc=	 nkoo/a/}');
    Error('\P{Sc=	 nkoo/a/}');
    Expect(1, 2042, '\p{Sc=nkoo}', "");
    Expect(0, 2042, '\p{^Sc=nkoo}', "");
    Expect(0, 2042, '\P{Sc=nkoo}', "");
    Expect(1, 2042, '\P{^Sc=nkoo}', "");
    Expect(0, 2043, '\p{Sc=nkoo}', "");
    Expect(1, 2043, '\p{^Sc=nkoo}', "");
    Expect(1, 2043, '\P{Sc=nkoo}', "");
    Expect(0, 2043, '\P{^Sc=nkoo}', "");
    Expect(1, 2042, '\p{Sc= 	Nkoo}', "");
    Expect(0, 2042, '\p{^Sc= 	Nkoo}', "");
    Expect(0, 2042, '\P{Sc= 	Nkoo}', "");
    Expect(1, 2042, '\P{^Sc= 	Nkoo}', "");
    Expect(0, 2043, '\p{Sc= 	Nkoo}', "");
    Expect(1, 2043, '\p{^Sc= 	Nkoo}', "");
    Expect(1, 2043, '\P{Sc= 	Nkoo}', "");
    Expect(0, 2043, '\P{^Sc= 	Nkoo}', "");
    Error('\p{Is_Script=__nko/a/}');
    Error('\P{Is_Script=__nko/a/}');
    Expect(1, 2042, '\p{Is_Script=nko}', "");
    Expect(0, 2042, '\p{^Is_Script=nko}', "");
    Expect(0, 2042, '\P{Is_Script=nko}', "");
    Expect(1, 2042, '\P{^Is_Script=nko}', "");
    Expect(0, 2043, '\p{Is_Script=nko}', "");
    Expect(1, 2043, '\p{^Is_Script=nko}', "");
    Expect(1, 2043, '\P{Is_Script=nko}', "");
    Expect(0, 2043, '\P{^Is_Script=nko}', "");
    Expect(1, 2042, '\p{Is_Script=-	Nko}', "");
    Expect(0, 2042, '\p{^Is_Script=-	Nko}', "");
    Expect(0, 2042, '\P{Is_Script=-	Nko}', "");
    Expect(1, 2042, '\P{^Is_Script=-	Nko}', "");
    Expect(0, 2043, '\p{Is_Script=-	Nko}', "");
    Expect(1, 2043, '\p{^Is_Script=-	Nko}', "");
    Expect(1, 2043, '\P{Is_Script=-	Nko}', "");
    Expect(0, 2043, '\P{^Is_Script=-	Nko}', "");
    Error('\p{Is_Sc=:=nkoo}');
    Error('\P{Is_Sc=:=nkoo}');
    Expect(1, 2042, '\p{Is_Sc=nkoo}', "");
    Expect(0, 2042, '\p{^Is_Sc=nkoo}', "");
    Expect(0, 2042, '\P{Is_Sc=nkoo}', "");
    Expect(1, 2042, '\P{^Is_Sc=nkoo}', "");
    Expect(0, 2043, '\p{Is_Sc=nkoo}', "");
    Expect(1, 2043, '\p{^Is_Sc=nkoo}', "");
    Expect(1, 2043, '\P{Is_Sc=nkoo}', "");
    Expect(0, 2043, '\P{^Is_Sc=nkoo}', "");
    Expect(1, 2042, '\p{Is_Sc=__nkoo}', "");
    Expect(0, 2042, '\p{^Is_Sc=__nkoo}', "");
    Expect(0, 2042, '\P{Is_Sc=__nkoo}', "");
    Expect(1, 2042, '\P{^Is_Sc=__nkoo}', "");
    Expect(0, 2043, '\p{Is_Sc=__nkoo}', "");
    Expect(1, 2043, '\p{^Is_Sc=__nkoo}', "");
    Expect(1, 2043, '\P{Is_Sc=__nkoo}', "");
    Expect(0, 2043, '\P{^Is_Sc=__nkoo}', "");
    Error('\p{Script=	:=Nushu}');
    Error('\P{Script=	:=Nushu}');
    Expect(1, 111355, '\p{Script=nushu}', "");
    Expect(0, 111355, '\p{^Script=nushu}', "");
    Expect(0, 111355, '\P{Script=nushu}', "");
    Expect(1, 111355, '\P{^Script=nushu}', "");
    Expect(0, 111356, '\p{Script=nushu}', "");
    Expect(1, 111356, '\p{^Script=nushu}', "");
    Expect(1, 111356, '\P{Script=nushu}', "");
    Expect(0, 111356, '\P{^Script=nushu}', "");
    Expect(1, 111355, '\p{Script=	Nushu}', "");
    Expect(0, 111355, '\p{^Script=	Nushu}', "");
    Expect(0, 111355, '\P{Script=	Nushu}', "");
    Expect(1, 111355, '\P{^Script=	Nushu}', "");
    Expect(0, 111356, '\p{Script=	Nushu}', "");
    Expect(1, 111356, '\p{^Script=	Nushu}', "");
    Expect(1, 111356, '\P{Script=	Nushu}', "");
    Expect(0, 111356, '\P{^Script=	Nushu}', "");
    Error('\p{Sc=	:=Nshu}');
    Error('\P{Sc=	:=Nshu}');
    Expect(1, 111355, '\p{Sc=nshu}', "");
    Expect(0, 111355, '\p{^Sc=nshu}', "");
    Expect(0, 111355, '\P{Sc=nshu}', "");
    Expect(1, 111355, '\P{^Sc=nshu}', "");
    Expect(0, 111356, '\p{Sc=nshu}', "");
    Expect(1, 111356, '\p{^Sc=nshu}', "");
    Expect(1, 111356, '\P{Sc=nshu}', "");
    Expect(0, 111356, '\P{^Sc=nshu}', "");
    Expect(1, 111355, '\p{Sc=_	NSHU}', "");
    Expect(0, 111355, '\p{^Sc=_	NSHU}', "");
    Expect(0, 111355, '\P{Sc=_	NSHU}', "");
    Expect(1, 111355, '\P{^Sc=_	NSHU}', "");
    Expect(0, 111356, '\p{Sc=_	NSHU}', "");
    Expect(1, 111356, '\p{^Sc=_	NSHU}', "");
    Expect(1, 111356, '\P{Sc=_	NSHU}', "");
    Expect(0, 111356, '\P{^Sc=_	NSHU}', "");
    Error('\p{Is_Script=	_Nushu/a/}');
    Error('\P{Is_Script=	_Nushu/a/}');
    Expect(1, 111355, '\p{Is_Script=nushu}', "");
    Expect(0, 111355, '\p{^Is_Script=nushu}', "");
    Expect(0, 111355, '\P{Is_Script=nushu}', "");
    Expect(1, 111355, '\P{^Is_Script=nushu}', "");
    Expect(0, 111356, '\p{Is_Script=nushu}', "");
    Expect(1, 111356, '\p{^Is_Script=nushu}', "");
    Expect(1, 111356, '\P{Is_Script=nushu}', "");
    Expect(0, 111356, '\P{^Is_Script=nushu}', "");
    Expect(1, 111355, '\p{Is_Script=  nushu}', "");
    Expect(0, 111355, '\p{^Is_Script=  nushu}', "");
    Expect(0, 111355, '\P{Is_Script=  nushu}', "");
    Expect(1, 111355, '\P{^Is_Script=  nushu}', "");
    Expect(0, 111356, '\p{Is_Script=  nushu}', "");
    Expect(1, 111356, '\p{^Is_Script=  nushu}', "");
    Expect(1, 111356, '\P{Is_Script=  nushu}', "");
    Expect(0, 111356, '\P{^Is_Script=  nushu}', "");
    Error('\p{Is_Sc: _Nshu/a/}');
    Error('\P{Is_Sc: _Nshu/a/}');
    Expect(1, 111355, '\p{Is_Sc=nshu}', "");
    Expect(0, 111355, '\p{^Is_Sc=nshu}', "");
    Expect(0, 111355, '\P{Is_Sc=nshu}', "");
    Expect(1, 111355, '\P{^Is_Sc=nshu}', "");
    Expect(0, 111356, '\p{Is_Sc=nshu}', "");
    Expect(1, 111356, '\p{^Is_Sc=nshu}', "");
    Expect(1, 111356, '\P{Is_Sc=nshu}', "");
    Expect(0, 111356, '\P{^Is_Sc=nshu}', "");
    Expect(1, 111355, '\p{Is_Sc= Nshu}', "");
    Expect(0, 111355, '\p{^Is_Sc= Nshu}', "");
    Expect(0, 111355, '\P{Is_Sc= Nshu}', "");
    Expect(1, 111355, '\P{^Is_Sc= Nshu}', "");
    Expect(0, 111356, '\p{Is_Sc= Nshu}', "");
    Expect(1, 111356, '\p{^Is_Sc= Nshu}', "");
    Expect(1, 111356, '\P{Is_Sc= Nshu}', "");
    Expect(0, 111356, '\P{^Is_Sc= Nshu}', "");
    Error('\p{Script= _OGHAM:=}');
    Error('\P{Script= _OGHAM:=}');
    Expect(1, 5788, '\p{Script=ogham}', "");
    Expect(0, 5788, '\p{^Script=ogham}', "");
    Expect(0, 5788, '\P{Script=ogham}', "");
    Expect(1, 5788, '\P{^Script=ogham}', "");
    Expect(0, 5789, '\p{Script=ogham}', "");
    Expect(1, 5789, '\p{^Script=ogham}', "");
    Expect(1, 5789, '\P{Script=ogham}', "");
    Expect(0, 5789, '\P{^Script=ogham}', "");
    Expect(1, 5788, '\p{Script=_-OGHAM}', "");
    Expect(0, 5788, '\p{^Script=_-OGHAM}', "");
    Expect(0, 5788, '\P{Script=_-OGHAM}', "");
    Expect(1, 5788, '\P{^Script=_-OGHAM}', "");
    Expect(0, 5789, '\p{Script=_-OGHAM}', "");
    Expect(1, 5789, '\p{^Script=_-OGHAM}', "");
    Expect(1, 5789, '\P{Script=_-OGHAM}', "");
    Expect(0, 5789, '\P{^Script=_-OGHAM}', "");
    Error('\p{Sc=	:=ogam}');
    Error('\P{Sc=	:=ogam}');
    Expect(1, 5788, '\p{Sc=ogam}', "");
    Expect(0, 5788, '\p{^Sc=ogam}', "");
    Expect(0, 5788, '\P{Sc=ogam}', "");
    Expect(1, 5788, '\P{^Sc=ogam}', "");
    Expect(0, 5789, '\p{Sc=ogam}', "");
    Expect(1, 5789, '\p{^Sc=ogam}', "");
    Expect(1, 5789, '\P{Sc=ogam}', "");
    Expect(0, 5789, '\P{^Sc=ogam}', "");
    Expect(1, 5788, '\p{Sc=_ogam}', "");
    Expect(0, 5788, '\p{^Sc=_ogam}', "");
    Expect(0, 5788, '\P{Sc=_ogam}', "");
    Expect(1, 5788, '\P{^Sc=_ogam}', "");
    Expect(0, 5789, '\p{Sc=_ogam}', "");
    Expect(1, 5789, '\p{^Sc=_ogam}', "");
    Expect(1, 5789, '\P{Sc=_ogam}', "");
    Expect(0, 5789, '\P{^Sc=_ogam}', "");
    Error('\p{Is_Script=	/a/OGHAM}');
    Error('\P{Is_Script=	/a/OGHAM}');
    Expect(1, 5788, '\p{Is_Script=ogham}', "");
    Expect(0, 5788, '\p{^Is_Script=ogham}', "");
    Expect(0, 5788, '\P{Is_Script=ogham}', "");
    Expect(1, 5788, '\P{^Is_Script=ogham}', "");
    Expect(0, 5789, '\p{Is_Script=ogham}', "");
    Expect(1, 5789, '\p{^Is_Script=ogham}', "");
    Expect(1, 5789, '\P{Is_Script=ogham}', "");
    Expect(0, 5789, '\P{^Is_Script=ogham}', "");
    Expect(1, 5788, '\p{Is_Script=-Ogham}', "");
    Expect(0, 5788, '\p{^Is_Script=-Ogham}', "");
    Expect(0, 5788, '\P{Is_Script=-Ogham}', "");
    Expect(1, 5788, '\P{^Is_Script=-Ogham}', "");
    Expect(0, 5789, '\p{Is_Script=-Ogham}', "");
    Expect(1, 5789, '\p{^Is_Script=-Ogham}', "");
    Expect(1, 5789, '\P{Is_Script=-Ogham}', "");
    Expect(0, 5789, '\P{^Is_Script=-Ogham}', "");
    Error('\p{Is_Sc=--ogam:=}');
    Error('\P{Is_Sc=--ogam:=}');
    Expect(1, 5788, '\p{Is_Sc:	ogam}', "");
    Expect(0, 5788, '\p{^Is_Sc:	ogam}', "");
    Expect(0, 5788, '\P{Is_Sc:	ogam}', "");
    Expect(1, 5788, '\P{^Is_Sc:	ogam}', "");
    Expect(0, 5789, '\p{Is_Sc:	ogam}', "");
    Expect(1, 5789, '\p{^Is_Sc:	ogam}', "");
    Expect(1, 5789, '\P{Is_Sc:	ogam}', "");
    Expect(0, 5789, '\P{^Is_Sc:	ogam}', "");
    Expect(1, 5788, '\p{Is_Sc=__Ogam}', "");
    Expect(0, 5788, '\p{^Is_Sc=__Ogam}', "");
    Expect(0, 5788, '\P{Is_Sc=__Ogam}', "");
    Expect(1, 5788, '\P{^Is_Sc=__Ogam}', "");
    Expect(0, 5789, '\p{Is_Sc=__Ogam}', "");
    Expect(1, 5789, '\p{^Is_Sc=__Ogam}', "");
    Expect(1, 5789, '\P{Is_Sc=__Ogam}', "");
    Expect(0, 5789, '\P{^Is_Sc=__Ogam}', "");
    Error('\p{Script= 	OL_Chiki/a/}');
    Error('\P{Script= 	OL_Chiki/a/}');
    Expect(1, 7295, '\p{Script=olchiki}', "");
    Expect(0, 7295, '\p{^Script=olchiki}', "");
    Expect(0, 7295, '\P{Script=olchiki}', "");
    Expect(1, 7295, '\P{^Script=olchiki}', "");
    Expect(0, 7296, '\p{Script=olchiki}', "");
    Expect(1, 7296, '\p{^Script=olchiki}', "");
    Expect(1, 7296, '\P{Script=olchiki}', "");
    Expect(0, 7296, '\P{^Script=olchiki}', "");
    Expect(1, 7295, '\p{Script=	_Ol_Chiki}', "");
    Expect(0, 7295, '\p{^Script=	_Ol_Chiki}', "");
    Expect(0, 7295, '\P{Script=	_Ol_Chiki}', "");
    Expect(1, 7295, '\P{^Script=	_Ol_Chiki}', "");
    Expect(0, 7296, '\p{Script=	_Ol_Chiki}', "");
    Expect(1, 7296, '\p{^Script=	_Ol_Chiki}', "");
    Expect(1, 7296, '\P{Script=	_Ol_Chiki}', "");
    Expect(0, 7296, '\P{^Script=	_Ol_Chiki}', "");
    Error('\p{Sc=_:=olck}');
    Error('\P{Sc=_:=olck}');
    Expect(1, 7295, '\p{Sc=olck}', "");
    Expect(0, 7295, '\p{^Sc=olck}', "");
    Expect(0, 7295, '\P{Sc=olck}', "");
    Expect(1, 7295, '\P{^Sc=olck}', "");
    Expect(0, 7296, '\p{Sc=olck}', "");
    Expect(1, 7296, '\p{^Sc=olck}', "");
    Expect(1, 7296, '\P{Sc=olck}', "");
    Expect(0, 7296, '\P{^Sc=olck}', "");
    Expect(1, 7295, '\p{Sc=	Olck}', "");
    Expect(0, 7295, '\p{^Sc=	Olck}', "");
    Expect(0, 7295, '\P{Sc=	Olck}', "");
    Expect(1, 7295, '\P{^Sc=	Olck}', "");
    Expect(0, 7296, '\p{Sc=	Olck}', "");
    Expect(1, 7296, '\p{^Sc=	Olck}', "");
    Expect(1, 7296, '\P{Sc=	Olck}', "");
    Expect(0, 7296, '\P{^Sc=	Olck}', "");
    Error('\p{Is_Script: 	Ol_CHIKI/a/}');
    Error('\P{Is_Script: 	Ol_CHIKI/a/}');
    Expect(1, 7295, '\p{Is_Script=olchiki}', "");
    Expect(0, 7295, '\p{^Is_Script=olchiki}', "");
    Expect(0, 7295, '\P{Is_Script=olchiki}', "");
    Expect(1, 7295, '\P{^Is_Script=olchiki}', "");
    Expect(0, 7296, '\p{Is_Script=olchiki}', "");
    Expect(1, 7296, '\p{^Is_Script=olchiki}', "");
    Expect(1, 7296, '\P{Is_Script=olchiki}', "");
    Expect(0, 7296, '\P{^Is_Script=olchiki}', "");
    Expect(1, 7295, '\p{Is_Script=	-Ol_Chiki}', "");
    Expect(0, 7295, '\p{^Is_Script=	-Ol_Chiki}', "");
    Expect(0, 7295, '\P{Is_Script=	-Ol_Chiki}', "");
    Expect(1, 7295, '\P{^Is_Script=	-Ol_Chiki}', "");
    Expect(0, 7296, '\p{Is_Script=	-Ol_Chiki}', "");
    Expect(1, 7296, '\p{^Is_Script=	-Ol_Chiki}', "");
    Expect(1, 7296, '\P{Is_Script=	-Ol_Chiki}', "");
    Expect(0, 7296, '\P{^Is_Script=	-Ol_Chiki}', "");
    Error('\p{Is_Sc=:=	OLCK}');
    Error('\P{Is_Sc=:=	OLCK}');
    Expect(1, 7295, '\p{Is_Sc=olck}', "");
    Expect(0, 7295, '\p{^Is_Sc=olck}', "");
    Expect(0, 7295, '\P{Is_Sc=olck}', "");
    Expect(1, 7295, '\P{^Is_Sc=olck}', "");
    Expect(0, 7296, '\p{Is_Sc=olck}', "");
    Expect(1, 7296, '\p{^Is_Sc=olck}', "");
    Expect(1, 7296, '\P{Is_Sc=olck}', "");
    Expect(0, 7296, '\P{^Is_Sc=olck}', "");
    Expect(1, 7295, '\p{Is_Sc= 	Olck}', "");
    Expect(0, 7295, '\p{^Is_Sc= 	Olck}', "");
    Expect(0, 7295, '\P{Is_Sc= 	Olck}', "");
    Expect(1, 7295, '\P{^Is_Sc= 	Olck}', "");
    Expect(0, 7296, '\p{Is_Sc= 	Olck}', "");
    Expect(1, 7296, '\p{^Is_Sc= 	Olck}', "");
    Expect(1, 7296, '\P{Is_Sc= 	Olck}', "");
    Expect(0, 7296, '\P{^Is_Sc= 	Olck}', "");
    Error('\p{Script=_:=OLD_turkic}');
    Error('\P{Script=_:=OLD_turkic}');
    Expect(1, 68680, '\p{Script=oldturkic}', "");
    Expect(0, 68680, '\p{^Script=oldturkic}', "");
    Expect(0, 68680, '\P{Script=oldturkic}', "");
    Expect(1, 68680, '\P{^Script=oldturkic}', "");
    Expect(0, 68681, '\p{Script=oldturkic}', "");
    Expect(1, 68681, '\p{^Script=oldturkic}', "");
    Expect(1, 68681, '\P{Script=oldturkic}', "");
    Expect(0, 68681, '\P{^Script=oldturkic}', "");
    Expect(1, 68680, '\p{Script:	Old_Turkic}', "");
    Expect(0, 68680, '\p{^Script:	Old_Turkic}', "");
    Expect(0, 68680, '\P{Script:	Old_Turkic}', "");
    Expect(1, 68680, '\P{^Script:	Old_Turkic}', "");
    Expect(0, 68681, '\p{Script:	Old_Turkic}', "");
    Expect(1, 68681, '\p{^Script:	Old_Turkic}', "");
    Expect(1, 68681, '\P{Script:	Old_Turkic}', "");
    Expect(0, 68681, '\P{^Script:	Old_Turkic}', "");
    Error('\p{Sc=  orkh/a/}');
    Error('\P{Sc=  orkh/a/}');
    Expect(1, 68680, '\p{Sc=orkh}', "");
    Expect(0, 68680, '\p{^Sc=orkh}', "");
    Expect(0, 68680, '\P{Sc=orkh}', "");
    Expect(1, 68680, '\P{^Sc=orkh}', "");
    Expect(0, 68681, '\p{Sc=orkh}', "");
    Expect(1, 68681, '\p{^Sc=orkh}', "");
    Expect(1, 68681, '\P{Sc=orkh}', "");
    Expect(0, 68681, '\P{^Sc=orkh}', "");
    Expect(1, 68680, '\p{Sc= _Orkh}', "");
    Expect(0, 68680, '\p{^Sc= _Orkh}', "");
    Expect(0, 68680, '\P{Sc= _Orkh}', "");
    Expect(1, 68680, '\P{^Sc= _Orkh}', "");
    Expect(0, 68681, '\p{Sc= _Orkh}', "");
    Expect(1, 68681, '\p{^Sc= _Orkh}', "");
    Expect(1, 68681, '\P{Sc= _Orkh}', "");
    Expect(0, 68681, '\P{^Sc= _Orkh}', "");
    Error('\p{Is_Script=/a/__old_Turkic}');
    Error('\P{Is_Script=/a/__old_Turkic}');
    Expect(1, 68680, '\p{Is_Script:   oldturkic}', "");
    Expect(0, 68680, '\p{^Is_Script:   oldturkic}', "");
    Expect(0, 68680, '\P{Is_Script:   oldturkic}', "");
    Expect(1, 68680, '\P{^Is_Script:   oldturkic}', "");
    Expect(0, 68681, '\p{Is_Script:   oldturkic}', "");
    Expect(1, 68681, '\p{^Is_Script:   oldturkic}', "");
    Expect(1, 68681, '\P{Is_Script:   oldturkic}', "");
    Expect(0, 68681, '\P{^Is_Script:   oldturkic}', "");
    Expect(1, 68680, '\p{Is_Script=__OLD_Turkic}', "");
    Expect(0, 68680, '\p{^Is_Script=__OLD_Turkic}', "");
    Expect(0, 68680, '\P{Is_Script=__OLD_Turkic}', "");
    Expect(1, 68680, '\P{^Is_Script=__OLD_Turkic}', "");
    Expect(0, 68681, '\p{Is_Script=__OLD_Turkic}', "");
    Expect(1, 68681, '\p{^Is_Script=__OLD_Turkic}', "");
    Expect(1, 68681, '\P{Is_Script=__OLD_Turkic}', "");
    Expect(0, 68681, '\P{^Is_Script=__OLD_Turkic}', "");
    Error('\p{Is_Sc= _orkh:=}');
    Error('\P{Is_Sc= _orkh:=}');
    Expect(1, 68680, '\p{Is_Sc=orkh}', "");
    Expect(0, 68680, '\p{^Is_Sc=orkh}', "");
    Expect(0, 68680, '\P{Is_Sc=orkh}', "");
    Expect(1, 68680, '\P{^Is_Sc=orkh}', "");
    Expect(0, 68681, '\p{Is_Sc=orkh}', "");
    Expect(1, 68681, '\p{^Is_Sc=orkh}', "");
    Expect(1, 68681, '\P{Is_Sc=orkh}', "");
    Expect(0, 68681, '\P{^Is_Sc=orkh}', "");
    Expect(1, 68680, '\p{Is_Sc=-	Orkh}', "");
    Expect(0, 68680, '\p{^Is_Sc=-	Orkh}', "");
    Expect(0, 68680, '\P{Is_Sc=-	Orkh}', "");
    Expect(1, 68680, '\P{^Is_Sc=-	Orkh}', "");
    Expect(0, 68681, '\p{Is_Sc=-	Orkh}', "");
    Expect(1, 68681, '\p{^Is_Sc=-	Orkh}', "");
    Expect(1, 68681, '\P{Is_Sc=-	Orkh}', "");
    Expect(0, 68681, '\P{^Is_Sc=-	Orkh}', "");
    Error('\p{Script=	-ORIYA:=}');
    Error('\P{Script=	-ORIYA:=}');
    Expect(1, 2935, '\p{Script=oriya}', "");
    Expect(0, 2935, '\p{^Script=oriya}', "");
    Expect(0, 2935, '\P{Script=oriya}', "");
    Expect(1, 2935, '\P{^Script=oriya}', "");
    Expect(0, 2936, '\p{Script=oriya}', "");
    Expect(1, 2936, '\p{^Script=oriya}', "");
    Expect(1, 2936, '\P{Script=oriya}', "");
    Expect(0, 2936, '\P{^Script=oriya}', "");
    Expect(1, 2935, '\p{Script=_oriya}', "");
    Expect(0, 2935, '\p{^Script=_oriya}', "");
    Expect(0, 2935, '\P{Script=_oriya}', "");
    Expect(1, 2935, '\P{^Script=_oriya}', "");
    Expect(0, 2936, '\p{Script=_oriya}', "");
    Expect(1, 2936, '\p{^Script=_oriya}', "");
    Expect(1, 2936, '\P{Script=_oriya}', "");
    Expect(0, 2936, '\P{^Script=_oriya}', "");
    Error('\p{Sc=:=-	Orya}');
    Error('\P{Sc=:=-	Orya}');
    Expect(1, 2935, '\p{Sc=orya}', "");
    Expect(0, 2935, '\p{^Sc=orya}', "");
    Expect(0, 2935, '\P{Sc=orya}', "");
    Expect(1, 2935, '\P{^Sc=orya}', "");
    Expect(0, 2936, '\p{Sc=orya}', "");
    Expect(1, 2936, '\p{^Sc=orya}', "");
    Expect(1, 2936, '\P{Sc=orya}', "");
    Expect(0, 2936, '\P{^Sc=orya}', "");
    Expect(1, 2935, '\p{Sc=  Orya}', "");
    Expect(0, 2935, '\p{^Sc=  Orya}', "");
    Expect(0, 2935, '\P{Sc=  Orya}', "");
    Expect(1, 2935, '\P{^Sc=  Orya}', "");
    Expect(0, 2936, '\p{Sc=  Orya}', "");
    Expect(1, 2936, '\p{^Sc=  Orya}', "");
    Expect(1, 2936, '\P{Sc=  Orya}', "");
    Expect(0, 2936, '\P{^Sc=  Orya}', "");
    Error('\p{Is_Script=:=-Oriya}');
    Error('\P{Is_Script=:=-Oriya}');
    Expect(1, 2935, '\p{Is_Script=oriya}', "");
    Expect(0, 2935, '\p{^Is_Script=oriya}', "");
    Expect(0, 2935, '\P{Is_Script=oriya}', "");
    Expect(1, 2935, '\P{^Is_Script=oriya}', "");
    Expect(0, 2936, '\p{Is_Script=oriya}', "");
    Expect(1, 2936, '\p{^Is_Script=oriya}', "");
    Expect(1, 2936, '\P{Is_Script=oriya}', "");
    Expect(0, 2936, '\P{^Is_Script=oriya}', "");
    Expect(1, 2935, '\p{Is_Script=-	ORIYA}', "");
    Expect(0, 2935, '\p{^Is_Script=-	ORIYA}', "");
    Expect(0, 2935, '\P{Is_Script=-	ORIYA}', "");
    Expect(1, 2935, '\P{^Is_Script=-	ORIYA}', "");
    Expect(0, 2936, '\p{Is_Script=-	ORIYA}', "");
    Expect(1, 2936, '\p{^Is_Script=-	ORIYA}', "");
    Expect(1, 2936, '\P{Is_Script=-	ORIYA}', "");
    Expect(0, 2936, '\P{^Is_Script=-	ORIYA}', "");
    Error('\p{Is_Sc=__ORYA/a/}');
    Error('\P{Is_Sc=__ORYA/a/}');
    Expect(1, 2935, '\p{Is_Sc=orya}', "");
    Expect(0, 2935, '\p{^Is_Sc=orya}', "");
    Expect(0, 2935, '\P{Is_Sc=orya}', "");
    Expect(1, 2935, '\P{^Is_Sc=orya}', "");
    Expect(0, 2936, '\p{Is_Sc=orya}', "");
    Expect(1, 2936, '\p{^Is_Sc=orya}', "");
    Expect(1, 2936, '\P{Is_Sc=orya}', "");
    Expect(0, 2936, '\P{^Is_Sc=orya}', "");
    Expect(1, 2935, '\p{Is_Sc=	_Orya}', "");
    Expect(0, 2935, '\p{^Is_Sc=	_Orya}', "");
    Expect(0, 2935, '\P{Is_Sc=	_Orya}', "");
    Expect(1, 2935, '\P{^Is_Sc=	_Orya}', "");
    Expect(0, 2936, '\p{Is_Sc=	_Orya}', "");
    Expect(1, 2936, '\p{^Is_Sc=	_Orya}', "");
    Expect(1, 2936, '\P{Is_Sc=	_Orya}', "");
    Expect(0, 2936, '\P{^Is_Sc=	_Orya}', "");
    Error('\p{Script=:=osage}');
    Error('\P{Script=:=osage}');
    Expect(1, 66811, '\p{Script=osage}', "");
    Expect(0, 66811, '\p{^Script=osage}', "");
    Expect(0, 66811, '\P{Script=osage}', "");
    Expect(1, 66811, '\P{^Script=osage}', "");
    Expect(0, 66812, '\p{Script=osage}', "");
    Expect(1, 66812, '\p{^Script=osage}', "");
    Expect(1, 66812, '\P{Script=osage}', "");
    Expect(0, 66812, '\P{^Script=osage}', "");
    Expect(1, 66811, '\p{Script=_ Osage}', "");
    Expect(0, 66811, '\p{^Script=_ Osage}', "");
    Expect(0, 66811, '\P{Script=_ Osage}', "");
    Expect(1, 66811, '\P{^Script=_ Osage}', "");
    Expect(0, 66812, '\p{Script=_ Osage}', "");
    Expect(1, 66812, '\p{^Script=_ Osage}', "");
    Expect(1, 66812, '\P{Script=_ Osage}', "");
    Expect(0, 66812, '\P{^Script=_ Osage}', "");
    Error('\p{Sc=/a/ 	osge}');
    Error('\P{Sc=/a/ 	osge}');
    Expect(1, 66811, '\p{Sc=osge}', "");
    Expect(0, 66811, '\p{^Sc=osge}', "");
    Expect(0, 66811, '\P{Sc=osge}', "");
    Expect(1, 66811, '\P{^Sc=osge}', "");
    Expect(0, 66812, '\p{Sc=osge}', "");
    Expect(1, 66812, '\p{^Sc=osge}', "");
    Expect(1, 66812, '\P{Sc=osge}', "");
    Expect(0, 66812, '\P{^Sc=osge}', "");
    Expect(1, 66811, '\p{Sc=Osge}', "");
    Expect(0, 66811, '\p{^Sc=Osge}', "");
    Expect(0, 66811, '\P{Sc=Osge}', "");
    Expect(1, 66811, '\P{^Sc=Osge}', "");
    Expect(0, 66812, '\p{Sc=Osge}', "");
    Expect(1, 66812, '\p{^Sc=Osge}', "");
    Expect(1, 66812, '\P{Sc=Osge}', "");
    Expect(0, 66812, '\P{^Sc=Osge}', "");
    Error('\p{Is_Script=  Osage/a/}');
    Error('\P{Is_Script=  Osage/a/}');
    Expect(1, 66811, '\p{Is_Script=osage}', "");
    Expect(0, 66811, '\p{^Is_Script=osage}', "");
    Expect(0, 66811, '\P{Is_Script=osage}', "");
    Expect(1, 66811, '\P{^Is_Script=osage}', "");
    Expect(0, 66812, '\p{Is_Script=osage}', "");
    Expect(1, 66812, '\p{^Is_Script=osage}', "");
    Expect(1, 66812, '\P{Is_Script=osage}', "");
    Expect(0, 66812, '\P{^Is_Script=osage}', "");
    Expect(1, 66811, '\p{Is_Script=	-OSAGE}', "");
    Expect(0, 66811, '\p{^Is_Script=	-OSAGE}', "");
    Expect(0, 66811, '\P{Is_Script=	-OSAGE}', "");
    Expect(1, 66811, '\P{^Is_Script=	-OSAGE}', "");
    Expect(0, 66812, '\p{Is_Script=	-OSAGE}', "");
    Expect(1, 66812, '\p{^Is_Script=	-OSAGE}', "");
    Expect(1, 66812, '\P{Is_Script=	-OSAGE}', "");
    Expect(0, 66812, '\P{^Is_Script=	-OSAGE}', "");
    Error('\p{Is_Sc=_-osge/a/}');
    Error('\P{Is_Sc=_-osge/a/}');
    Expect(1, 66811, '\p{Is_Sc=osge}', "");
    Expect(0, 66811, '\p{^Is_Sc=osge}', "");
    Expect(0, 66811, '\P{Is_Sc=osge}', "");
    Expect(1, 66811, '\P{^Is_Sc=osge}', "");
    Expect(0, 66812, '\p{Is_Sc=osge}', "");
    Expect(1, 66812, '\p{^Is_Sc=osge}', "");
    Expect(1, 66812, '\P{Is_Sc=osge}', "");
    Expect(0, 66812, '\P{^Is_Sc=osge}', "");
    Expect(1, 66811, '\p{Is_Sc= OSGE}', "");
    Expect(0, 66811, '\p{^Is_Sc= OSGE}', "");
    Expect(0, 66811, '\P{Is_Sc= OSGE}', "");
    Expect(1, 66811, '\P{^Is_Sc= OSGE}', "");
    Expect(0, 66812, '\p{Is_Sc= OSGE}', "");
    Expect(1, 66812, '\p{^Is_Sc= OSGE}', "");
    Expect(1, 66812, '\P{Is_Sc= OSGE}', "");
    Expect(0, 66812, '\P{^Is_Sc= OSGE}', "");
    Error('\p{Script: :=-Osmanya}');
    Error('\P{Script: :=-Osmanya}');
    Expect(1, 66729, '\p{Script=osmanya}', "");
    Expect(0, 66729, '\p{^Script=osmanya}', "");
    Expect(0, 66729, '\P{Script=osmanya}', "");
    Expect(1, 66729, '\P{^Script=osmanya}', "");
    Expect(0, 66730, '\p{Script=osmanya}', "");
    Expect(1, 66730, '\p{^Script=osmanya}', "");
    Expect(1, 66730, '\P{Script=osmanya}', "");
    Expect(0, 66730, '\P{^Script=osmanya}', "");
    Expect(1, 66729, '\p{Script=  osmanya}', "");
    Expect(0, 66729, '\p{^Script=  osmanya}', "");
    Expect(0, 66729, '\P{Script=  osmanya}', "");
    Expect(1, 66729, '\P{^Script=  osmanya}', "");
    Expect(0, 66730, '\p{Script=  osmanya}', "");
    Expect(1, 66730, '\p{^Script=  osmanya}', "");
    Expect(1, 66730, '\P{Script=  osmanya}', "");
    Expect(0, 66730, '\P{^Script=  osmanya}', "");
    Error('\p{Sc=	/a/osma}');
    Error('\P{Sc=	/a/osma}');
    Expect(1, 66729, '\p{Sc:osma}', "");
    Expect(0, 66729, '\p{^Sc:osma}', "");
    Expect(0, 66729, '\P{Sc:osma}', "");
    Expect(1, 66729, '\P{^Sc:osma}', "");
    Expect(0, 66730, '\p{Sc:osma}', "");
    Expect(1, 66730, '\p{^Sc:osma}', "");
    Expect(1, 66730, '\P{Sc:osma}', "");
    Expect(0, 66730, '\P{^Sc:osma}', "");
    Expect(1, 66729, '\p{Sc=__Osma}', "");
    Expect(0, 66729, '\p{^Sc=__Osma}', "");
    Expect(0, 66729, '\P{Sc=__Osma}', "");
    Expect(1, 66729, '\P{^Sc=__Osma}', "");
    Expect(0, 66730, '\p{Sc=__Osma}', "");
    Expect(1, 66730, '\p{^Sc=__Osma}', "");
    Expect(1, 66730, '\P{Sc=__Osma}', "");
    Expect(0, 66730, '\P{^Sc=__Osma}', "");
    Error('\p{Is_Script= osmanya:=}');
    Error('\P{Is_Script= osmanya:=}');
    Expect(1, 66729, '\p{Is_Script=osmanya}', "");
    Expect(0, 66729, '\p{^Is_Script=osmanya}', "");
    Expect(0, 66729, '\P{Is_Script=osmanya}', "");
    Expect(1, 66729, '\P{^Is_Script=osmanya}', "");
    Expect(0, 66730, '\p{Is_Script=osmanya}', "");
    Expect(1, 66730, '\p{^Is_Script=osmanya}', "");
    Expect(1, 66730, '\P{Is_Script=osmanya}', "");
    Expect(0, 66730, '\P{^Is_Script=osmanya}', "");
    Expect(1, 66729, '\p{Is_Script=	-osmanya}', "");
    Expect(0, 66729, '\p{^Is_Script=	-osmanya}', "");
    Expect(0, 66729, '\P{Is_Script=	-osmanya}', "");
    Expect(1, 66729, '\P{^Is_Script=	-osmanya}', "");
    Expect(0, 66730, '\p{Is_Script=	-osmanya}', "");
    Expect(1, 66730, '\p{^Is_Script=	-osmanya}', "");
    Expect(1, 66730, '\P{Is_Script=	-osmanya}', "");
    Expect(0, 66730, '\P{^Is_Script=	-osmanya}', "");
    Error('\p{Is_Sc: 		Osma/a/}');
    Error('\P{Is_Sc: 		Osma/a/}');
    Expect(1, 66729, '\p{Is_Sc=osma}', "");
    Expect(0, 66729, '\p{^Is_Sc=osma}', "");
    Expect(0, 66729, '\P{Is_Sc=osma}', "");
    Expect(1, 66729, '\P{^Is_Sc=osma}', "");
    Expect(0, 66730, '\p{Is_Sc=osma}', "");
    Expect(1, 66730, '\p{^Is_Sc=osma}', "");
    Expect(1, 66730, '\P{Is_Sc=osma}', "");
    Expect(0, 66730, '\P{^Is_Sc=osma}', "");
    Expect(1, 66729, '\p{Is_Sc=-	osma}', "");
    Expect(0, 66729, '\p{^Is_Sc=-	osma}', "");
    Expect(0, 66729, '\P{Is_Sc=-	osma}', "");
    Expect(1, 66729, '\P{^Is_Sc=-	osma}', "");
    Expect(0, 66730, '\p{Is_Sc=-	osma}', "");
    Expect(1, 66730, '\p{^Is_Sc=-	osma}', "");
    Expect(1, 66730, '\P{Is_Sc=-	osma}', "");
    Expect(0, 66730, '\P{^Is_Sc=-	osma}', "");
    Error('\p{Script=	-palmyrene/a/}');
    Error('\P{Script=	-palmyrene/a/}');
    Expect(1, 67711, '\p{Script=palmyrene}', "");
    Expect(0, 67711, '\p{^Script=palmyrene}', "");
    Expect(0, 67711, '\P{Script=palmyrene}', "");
    Expect(1, 67711, '\P{^Script=palmyrene}', "");
    Expect(0, 67712, '\p{Script=palmyrene}', "");
    Expect(1, 67712, '\p{^Script=palmyrene}', "");
    Expect(1, 67712, '\P{Script=palmyrene}', "");
    Expect(0, 67712, '\P{^Script=palmyrene}', "");
    Expect(1, 67711, '\p{Script= PALMYRENE}', "");
    Expect(0, 67711, '\p{^Script= PALMYRENE}', "");
    Expect(0, 67711, '\P{Script= PALMYRENE}', "");
    Expect(1, 67711, '\P{^Script= PALMYRENE}', "");
    Expect(0, 67712, '\p{Script= PALMYRENE}', "");
    Expect(1, 67712, '\p{^Script= PALMYRENE}', "");
    Expect(1, 67712, '\P{Script= PALMYRENE}', "");
    Expect(0, 67712, '\P{^Script= PALMYRENE}', "");
    Error('\p{Sc=_:=Palm}');
    Error('\P{Sc=_:=Palm}');
    Expect(1, 67711, '\p{Sc=palm}', "");
    Expect(0, 67711, '\p{^Sc=palm}', "");
    Expect(0, 67711, '\P{Sc=palm}', "");
    Expect(1, 67711, '\P{^Sc=palm}', "");
    Expect(0, 67712, '\p{Sc=palm}', "");
    Expect(1, 67712, '\p{^Sc=palm}', "");
    Expect(1, 67712, '\P{Sc=palm}', "");
    Expect(0, 67712, '\P{^Sc=palm}', "");
    Expect(1, 67711, '\p{Sc=- PALM}', "");
    Expect(0, 67711, '\p{^Sc=- PALM}', "");
    Expect(0, 67711, '\P{Sc=- PALM}', "");
    Expect(1, 67711, '\P{^Sc=- PALM}', "");
    Expect(0, 67712, '\p{Sc=- PALM}', "");
    Expect(1, 67712, '\p{^Sc=- PALM}', "");
    Expect(1, 67712, '\P{Sc=- PALM}', "");
    Expect(0, 67712, '\P{^Sc=- PALM}', "");
    Error('\p{Is_Script=:=  Palmyrene}');
    Error('\P{Is_Script=:=  Palmyrene}');
    Expect(1, 67711, '\p{Is_Script:palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Script:palmyrene}', "");
    Expect(0, 67711, '\P{Is_Script:palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Script:palmyrene}', "");
    Expect(0, 67712, '\p{Is_Script:palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Script:palmyrene}', "");
    Expect(1, 67712, '\P{Is_Script:palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Script:palmyrene}', "");
    Expect(1, 67711, '\p{Is_Script=--palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Script=--palmyrene}', "");
    Expect(0, 67711, '\P{Is_Script=--palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Script=--palmyrene}', "");
    Expect(0, 67712, '\p{Is_Script=--palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Script=--palmyrene}', "");
    Expect(1, 67712, '\P{Is_Script=--palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Script=--palmyrene}', "");
    Error('\p{Is_Sc= _Palm/a/}');
    Error('\P{Is_Sc= _Palm/a/}');
    Expect(1, 67711, '\p{Is_Sc=palm}', "");
    Expect(0, 67711, '\p{^Is_Sc=palm}', "");
    Expect(0, 67711, '\P{Is_Sc=palm}', "");
    Expect(1, 67711, '\P{^Is_Sc=palm}', "");
    Expect(0, 67712, '\p{Is_Sc=palm}', "");
    Expect(1, 67712, '\p{^Is_Sc=palm}', "");
    Expect(1, 67712, '\P{Is_Sc=palm}', "");
    Expect(0, 67712, '\P{^Is_Sc=palm}', "");
    Expect(1, 67711, '\p{Is_Sc=	Palm}', "");
    Expect(0, 67711, '\p{^Is_Sc=	Palm}', "");
    Expect(0, 67711, '\P{Is_Sc=	Palm}', "");
    Expect(1, 67711, '\P{^Is_Sc=	Palm}', "");
    Expect(0, 67712, '\p{Is_Sc=	Palm}', "");
    Expect(1, 67712, '\p{^Is_Sc=	Palm}', "");
    Expect(1, 67712, '\P{Is_Sc=	Palm}', "");
    Expect(0, 67712, '\P{^Is_Sc=	Palm}', "");
    Error('\p{Script=-Pau_cin_Hau/a/}');
    Error('\P{Script=-Pau_cin_Hau/a/}');
    Expect(1, 72440, '\p{Script: paucinhau}', "");
    Expect(0, 72440, '\p{^Script: paucinhau}', "");
    Expect(0, 72440, '\P{Script: paucinhau}', "");
    Expect(1, 72440, '\P{^Script: paucinhau}', "");
    Expect(0, 72441, '\p{Script: paucinhau}', "");
    Expect(1, 72441, '\p{^Script: paucinhau}', "");
    Expect(1, 72441, '\P{Script: paucinhau}', "");
    Expect(0, 72441, '\P{^Script: paucinhau}', "");
    Expect(1, 72440, '\p{Script:  Pau_Cin_HAU}', "");
    Expect(0, 72440, '\p{^Script:  Pau_Cin_HAU}', "");
    Expect(0, 72440, '\P{Script:  Pau_Cin_HAU}', "");
    Expect(1, 72440, '\P{^Script:  Pau_Cin_HAU}', "");
    Expect(0, 72441, '\p{Script:  Pau_Cin_HAU}', "");
    Expect(1, 72441, '\p{^Script:  Pau_Cin_HAU}', "");
    Expect(1, 72441, '\P{Script:  Pau_Cin_HAU}', "");
    Expect(0, 72441, '\P{^Script:  Pau_Cin_HAU}', "");
    Error('\p{Sc=-_PAUC/a/}');
    Error('\P{Sc=-_PAUC/a/}');
    Expect(1, 72440, '\p{Sc=pauc}', "");
    Expect(0, 72440, '\p{^Sc=pauc}', "");
    Expect(0, 72440, '\P{Sc=pauc}', "");
    Expect(1, 72440, '\P{^Sc=pauc}', "");
    Expect(0, 72441, '\p{Sc=pauc}', "");
    Expect(1, 72441, '\p{^Sc=pauc}', "");
    Expect(1, 72441, '\P{Sc=pauc}', "");
    Expect(0, 72441, '\P{^Sc=pauc}', "");
    Expect(1, 72440, '\p{Sc=__pauc}', "");
    Expect(0, 72440, '\p{^Sc=__pauc}', "");
    Expect(0, 72440, '\P{Sc=__pauc}', "");
    Expect(1, 72440, '\P{^Sc=__pauc}', "");
    Expect(0, 72441, '\p{Sc=__pauc}', "");
    Expect(1, 72441, '\p{^Sc=__pauc}', "");
    Expect(1, 72441, '\P{Sc=__pauc}', "");
    Expect(0, 72441, '\P{^Sc=__pauc}', "");
    Error('\p{Is_Script=Pau_Cin_Hau/a/}');
    Error('\P{Is_Script=Pau_Cin_Hau/a/}');
    Expect(1, 72440, '\p{Is_Script=paucinhau}', "");
    Expect(0, 72440, '\p{^Is_Script=paucinhau}', "");
    Expect(0, 72440, '\P{Is_Script=paucinhau}', "");
    Expect(1, 72440, '\P{^Is_Script=paucinhau}', "");
    Expect(0, 72441, '\p{Is_Script=paucinhau}', "");
    Expect(1, 72441, '\p{^Is_Script=paucinhau}', "");
    Expect(1, 72441, '\P{Is_Script=paucinhau}', "");
    Expect(0, 72441, '\P{^Is_Script=paucinhau}', "");
    Expect(1, 72440, '\p{Is_Script=	-pau_Cin_Hau}', "");
    Expect(0, 72440, '\p{^Is_Script=	-pau_Cin_Hau}', "");
    Expect(0, 72440, '\P{Is_Script=	-pau_Cin_Hau}', "");
    Expect(1, 72440, '\P{^Is_Script=	-pau_Cin_Hau}', "");
    Expect(0, 72441, '\p{Is_Script=	-pau_Cin_Hau}', "");
    Expect(1, 72441, '\p{^Is_Script=	-pau_Cin_Hau}', "");
    Expect(1, 72441, '\P{Is_Script=	-pau_Cin_Hau}', "");
    Expect(0, 72441, '\P{^Is_Script=	-pau_Cin_Hau}', "");
    Error('\p{Is_Sc=	/a/PAUC}');
    Error('\P{Is_Sc=	/a/PAUC}');
    Expect(1, 72440, '\p{Is_Sc=pauc}', "");
    Expect(0, 72440, '\p{^Is_Sc=pauc}', "");
    Expect(0, 72440, '\P{Is_Sc=pauc}', "");
    Expect(1, 72440, '\P{^Is_Sc=pauc}', "");
    Expect(0, 72441, '\p{Is_Sc=pauc}', "");
    Expect(1, 72441, '\p{^Is_Sc=pauc}', "");
    Expect(1, 72441, '\P{Is_Sc=pauc}', "");
    Expect(0, 72441, '\P{^Is_Sc=pauc}', "");
    Expect(1, 72440, '\p{Is_Sc=-	Pauc}', "");
    Expect(0, 72440, '\p{^Is_Sc=-	Pauc}', "");
    Expect(0, 72440, '\P{Is_Sc=-	Pauc}', "");
    Expect(1, 72440, '\P{^Is_Sc=-	Pauc}', "");
    Expect(0, 72441, '\p{Is_Sc=-	Pauc}', "");
    Expect(1, 72441, '\p{^Is_Sc=-	Pauc}', "");
    Expect(1, 72441, '\P{Is_Sc=-	Pauc}', "");
    Expect(0, 72441, '\P{^Is_Sc=-	Pauc}', "");
    Error('\p{Script:/a/	old_Permic}');
    Error('\P{Script:/a/	old_Permic}');
    Expect(1, 66426, '\p{Script=oldpermic}', "");
    Expect(0, 66426, '\p{^Script=oldpermic}', "");
    Expect(0, 66426, '\P{Script=oldpermic}', "");
    Expect(1, 66426, '\P{^Script=oldpermic}', "");
    Expect(0, 66427, '\p{Script=oldpermic}', "");
    Expect(1, 66427, '\p{^Script=oldpermic}', "");
    Expect(1, 66427, '\P{Script=oldpermic}', "");
    Expect(0, 66427, '\P{^Script=oldpermic}', "");
    Expect(1, 66426, '\p{Script= 	Old_PERMIC}', "");
    Expect(0, 66426, '\p{^Script= 	Old_PERMIC}', "");
    Expect(0, 66426, '\P{Script= 	Old_PERMIC}', "");
    Expect(1, 66426, '\P{^Script= 	Old_PERMIC}', "");
    Expect(0, 66427, '\p{Script= 	Old_PERMIC}', "");
    Expect(1, 66427, '\p{^Script= 	Old_PERMIC}', "");
    Expect(1, 66427, '\P{Script= 	Old_PERMIC}', "");
    Expect(0, 66427, '\P{^Script= 	Old_PERMIC}', "");
    Error('\p{Sc=Perm/a/}');
    Error('\P{Sc=Perm/a/}');
    Expect(1, 66426, '\p{Sc:   perm}', "");
    Expect(0, 66426, '\p{^Sc:   perm}', "");
    Expect(0, 66426, '\P{Sc:   perm}', "");
    Expect(1, 66426, '\P{^Sc:   perm}', "");
    Expect(0, 66427, '\p{Sc:   perm}', "");
    Expect(1, 66427, '\p{^Sc:   perm}', "");
    Expect(1, 66427, '\P{Sc:   perm}', "");
    Expect(0, 66427, '\P{^Sc:   perm}', "");
    Expect(1, 66426, '\p{Sc=	Perm}', "");
    Expect(0, 66426, '\p{^Sc=	Perm}', "");
    Expect(0, 66426, '\P{Sc=	Perm}', "");
    Expect(1, 66426, '\P{^Sc=	Perm}', "");
    Expect(0, 66427, '\p{Sc=	Perm}', "");
    Expect(1, 66427, '\p{^Sc=	Perm}', "");
    Expect(1, 66427, '\P{Sc=	Perm}', "");
    Expect(0, 66427, '\P{^Sc=	Perm}', "");
    Error('\p{Is_Script=/a/  old_permic}');
    Error('\P{Is_Script=/a/  old_permic}');
    Expect(1, 66426, '\p{Is_Script:   oldpermic}', "");
    Expect(0, 66426, '\p{^Is_Script:   oldpermic}', "");
    Expect(0, 66426, '\P{Is_Script:   oldpermic}', "");
    Expect(1, 66426, '\P{^Is_Script:   oldpermic}', "");
    Expect(0, 66427, '\p{Is_Script:   oldpermic}', "");
    Expect(1, 66427, '\p{^Is_Script:   oldpermic}', "");
    Expect(1, 66427, '\P{Is_Script:   oldpermic}', "");
    Expect(0, 66427, '\P{^Is_Script:   oldpermic}', "");
    Expect(1, 66426, '\p{Is_Script=-	Old_PERMIC}', "");
    Expect(0, 66426, '\p{^Is_Script=-	Old_PERMIC}', "");
    Expect(0, 66426, '\P{Is_Script=-	Old_PERMIC}', "");
    Expect(1, 66426, '\P{^Is_Script=-	Old_PERMIC}', "");
    Expect(0, 66427, '\p{Is_Script=-	Old_PERMIC}', "");
    Expect(1, 66427, '\p{^Is_Script=-	Old_PERMIC}', "");
    Expect(1, 66427, '\P{Is_Script=-	Old_PERMIC}', "");
    Expect(0, 66427, '\P{^Is_Script=-	Old_PERMIC}', "");
    Error('\p{Is_Sc=Perm:=}');
    Error('\P{Is_Sc=Perm:=}');
    Expect(1, 66426, '\p{Is_Sc=perm}', "");
    Expect(0, 66426, '\p{^Is_Sc=perm}', "");
    Expect(0, 66426, '\P{Is_Sc=perm}', "");
    Expect(1, 66426, '\P{^Is_Sc=perm}', "");
    Expect(0, 66427, '\p{Is_Sc=perm}', "");
    Expect(1, 66427, '\p{^Is_Sc=perm}', "");
    Expect(1, 66427, '\P{Is_Sc=perm}', "");
    Expect(0, 66427, '\P{^Is_Sc=perm}', "");
    Expect(1, 66426, '\p{Is_Sc=_	Perm}', "");
    Expect(0, 66426, '\p{^Is_Sc=_	Perm}', "");
    Expect(0, 66426, '\P{Is_Sc=_	Perm}', "");
    Expect(1, 66426, '\P{^Is_Sc=_	Perm}', "");
    Expect(0, 66427, '\p{Is_Sc=_	Perm}', "");
    Expect(1, 66427, '\p{^Is_Sc=_	Perm}', "");
    Expect(1, 66427, '\P{Is_Sc=_	Perm}', "");
    Expect(0, 66427, '\P{^Is_Sc=_	Perm}', "");
    Error('\p{Script=/a/ Phags_pa}');
    Error('\P{Script=/a/ Phags_pa}');
    Expect(1, 43127, '\p{Script:phagspa}', "");
    Expect(0, 43127, '\p{^Script:phagspa}', "");
    Expect(0, 43127, '\P{Script:phagspa}', "");
    Expect(1, 43127, '\P{^Script:phagspa}', "");
    Expect(0, 43128, '\p{Script:phagspa}', "");
    Expect(1, 43128, '\p{^Script:phagspa}', "");
    Expect(1, 43128, '\P{Script:phagspa}', "");
    Expect(0, 43128, '\P{^Script:phagspa}', "");
    Expect(1, 43127, '\p{Script=-Phags_PA}', "");
    Expect(0, 43127, '\p{^Script=-Phags_PA}', "");
    Expect(0, 43127, '\P{Script=-Phags_PA}', "");
    Expect(1, 43127, '\P{^Script=-Phags_PA}', "");
    Expect(0, 43128, '\p{Script=-Phags_PA}', "");
    Expect(1, 43128, '\p{^Script=-Phags_PA}', "");
    Expect(1, 43128, '\P{Script=-Phags_PA}', "");
    Expect(0, 43128, '\P{^Script=-Phags_PA}', "");
    Error('\p{Sc= 	Phag/a/}');
    Error('\P{Sc= 	Phag/a/}');
    Expect(1, 43127, '\p{Sc:phag}', "");
    Expect(0, 43127, '\p{^Sc:phag}', "");
    Expect(0, 43127, '\P{Sc:phag}', "");
    Expect(1, 43127, '\P{^Sc:phag}', "");
    Expect(0, 43128, '\p{Sc:phag}', "");
    Expect(1, 43128, '\p{^Sc:phag}', "");
    Expect(1, 43128, '\P{Sc:phag}', "");
    Expect(0, 43128, '\P{^Sc:phag}', "");
    Expect(1, 43127, '\p{Sc=		phag}', "");
    Expect(0, 43127, '\p{^Sc=		phag}', "");
    Expect(0, 43127, '\P{Sc=		phag}', "");
    Expect(1, 43127, '\P{^Sc=		phag}', "");
    Expect(0, 43128, '\p{Sc=		phag}', "");
    Expect(1, 43128, '\p{^Sc=		phag}', "");
    Expect(1, 43128, '\P{Sc=		phag}', "");
    Expect(0, 43128, '\P{^Sc=		phag}', "");
    Error('\p{Is_Script=:=  PHAGS_pa}');
    Error('\P{Is_Script=:=  PHAGS_pa}');
    Expect(1, 43127, '\p{Is_Script=phagspa}', "");
    Expect(0, 43127, '\p{^Is_Script=phagspa}', "");
    Expect(0, 43127, '\P{Is_Script=phagspa}', "");
    Expect(1, 43127, '\P{^Is_Script=phagspa}', "");
    Expect(0, 43128, '\p{Is_Script=phagspa}', "");
    Expect(1, 43128, '\p{^Is_Script=phagspa}', "");
    Expect(1, 43128, '\P{Is_Script=phagspa}', "");
    Expect(0, 43128, '\P{^Is_Script=phagspa}', "");
    Expect(1, 43127, '\p{Is_Script=_-Phags_Pa}', "");
    Expect(0, 43127, '\p{^Is_Script=_-Phags_Pa}', "");
    Expect(0, 43127, '\P{Is_Script=_-Phags_Pa}', "");
    Expect(1, 43127, '\P{^Is_Script=_-Phags_Pa}', "");
    Expect(0, 43128, '\p{Is_Script=_-Phags_Pa}', "");
    Expect(1, 43128, '\p{^Is_Script=_-Phags_Pa}', "");
    Expect(1, 43128, '\P{Is_Script=_-Phags_Pa}', "");
    Expect(0, 43128, '\P{^Is_Script=_-Phags_Pa}', "");
    Error('\p{Is_Sc=/a/-_phag}');
    Error('\P{Is_Sc=/a/-_phag}');
    Expect(1, 43127, '\p{Is_Sc=phag}', "");
    Expect(0, 43127, '\p{^Is_Sc=phag}', "");
    Expect(0, 43127, '\P{Is_Sc=phag}', "");
    Expect(1, 43127, '\P{^Is_Sc=phag}', "");
    Expect(0, 43128, '\p{Is_Sc=phag}', "");
    Expect(1, 43128, '\p{^Is_Sc=phag}', "");
    Expect(1, 43128, '\P{Is_Sc=phag}', "");
    Expect(0, 43128, '\P{^Is_Sc=phag}', "");
    Expect(1, 43127, '\p{Is_Sc= phag}', "");
    Expect(0, 43127, '\p{^Is_Sc= phag}', "");
    Expect(0, 43127, '\P{Is_Sc= phag}', "");
    Expect(1, 43127, '\P{^Is_Sc= phag}', "");
    Expect(0, 43128, '\p{Is_Sc= phag}', "");
    Expect(1, 43128, '\p{^Is_Sc= phag}', "");
    Expect(1, 43128, '\P{Is_Sc= phag}', "");
    Expect(0, 43128, '\P{^Is_Sc= phag}', "");
    Error('\p{Script=:=	INSCRIPTIONAL_pahlavi}');
    Error('\P{Script=:=	INSCRIPTIONAL_pahlavi}');
    Expect(1, 68479, '\p{Script:inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Script:inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Script:inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Script:inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Script:inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Script:inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Script:inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Script:inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Script=- Inscriptional_PAHLAVI}', "");
    Expect(0, 68479, '\p{^Script=- Inscriptional_PAHLAVI}', "");
    Expect(0, 68479, '\P{Script=- Inscriptional_PAHLAVI}', "");
    Expect(1, 68479, '\P{^Script=- Inscriptional_PAHLAVI}', "");
    Expect(0, 68480, '\p{Script=- Inscriptional_PAHLAVI}', "");
    Expect(1, 68480, '\p{^Script=- Inscriptional_PAHLAVI}', "");
    Expect(1, 68480, '\P{Script=- Inscriptional_PAHLAVI}', "");
    Expect(0, 68480, '\P{^Script=- Inscriptional_PAHLAVI}', "");
    Error('\p{Sc=/a/--Phli}');
    Error('\P{Sc=/a/--Phli}');
    Expect(1, 68479, '\p{Sc=phli}', "");
    Expect(0, 68479, '\p{^Sc=phli}', "");
    Expect(0, 68479, '\P{Sc=phli}', "");
    Expect(1, 68479, '\P{^Sc=phli}', "");
    Expect(0, 68480, '\p{Sc=phli}', "");
    Expect(1, 68480, '\p{^Sc=phli}', "");
    Expect(1, 68480, '\P{Sc=phli}', "");
    Expect(0, 68480, '\P{^Sc=phli}', "");
    Expect(1, 68479, '\p{Sc= phli}', "");
    Expect(0, 68479, '\p{^Sc= phli}', "");
    Expect(0, 68479, '\P{Sc= phli}', "");
    Expect(1, 68479, '\P{^Sc= phli}', "");
    Expect(0, 68480, '\p{Sc= phli}', "");
    Expect(1, 68480, '\p{^Sc= phli}', "");
    Expect(1, 68480, '\P{Sc= phli}', "");
    Expect(0, 68480, '\P{^Sc= phli}', "");
    Error('\p{Is_Script= _Inscriptional_pahlavi:=}');
    Error('\P{Is_Script= _Inscriptional_pahlavi:=}');
    Expect(1, 68479, '\p{Is_Script: inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Is_Script: inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Is_Script: inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Is_Script: inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Is_Script: inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Is_Script: inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Is_Script: inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Is_Script: inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Is_Script=_-Inscriptional_pahlavi}', "");
    Expect(0, 68479, '\p{^Is_Script=_-Inscriptional_pahlavi}', "");
    Expect(0, 68479, '\P{Is_Script=_-Inscriptional_pahlavi}', "");
    Expect(1, 68479, '\P{^Is_Script=_-Inscriptional_pahlavi}', "");
    Expect(0, 68480, '\p{Is_Script=_-Inscriptional_pahlavi}', "");
    Expect(1, 68480, '\p{^Is_Script=_-Inscriptional_pahlavi}', "");
    Expect(1, 68480, '\P{Is_Script=_-Inscriptional_pahlavi}', "");
    Expect(0, 68480, '\P{^Is_Script=_-Inscriptional_pahlavi}', "");
    Error('\p{Is_Sc=-_Phli/a/}');
    Error('\P{Is_Sc=-_Phli/a/}');
    Expect(1, 68479, '\p{Is_Sc: phli}', "");
    Expect(0, 68479, '\p{^Is_Sc: phli}', "");
    Expect(0, 68479, '\P{Is_Sc: phli}', "");
    Expect(1, 68479, '\P{^Is_Sc: phli}', "");
    Expect(0, 68480, '\p{Is_Sc: phli}', "");
    Expect(1, 68480, '\p{^Is_Sc: phli}', "");
    Expect(1, 68480, '\P{Is_Sc: phli}', "");
    Expect(0, 68480, '\P{^Is_Sc: phli}', "");
    Expect(1, 68479, '\p{Is_Sc=_PHLI}', "");
    Expect(0, 68479, '\p{^Is_Sc=_PHLI}', "");
    Expect(0, 68479, '\P{Is_Sc=_PHLI}', "");
    Expect(1, 68479, '\P{^Is_Sc=_PHLI}', "");
    Expect(0, 68480, '\p{Is_Sc=_PHLI}', "");
    Expect(1, 68480, '\p{^Is_Sc=_PHLI}', "");
    Expect(1, 68480, '\P{Is_Sc=_PHLI}', "");
    Expect(0, 68480, '\P{^Is_Sc=_PHLI}', "");
    Error('\p{Script=		Psalter_Pahlavi:=}');
    Error('\P{Script=		Psalter_Pahlavi:=}');
    Expect(1, 68527, '\p{Script=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Script=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Script=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Script=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Script=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Script=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Script=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Script=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Script=  Psalter_Pahlavi}', "");
    Expect(0, 68527, '\p{^Script=  Psalter_Pahlavi}', "");
    Expect(0, 68527, '\P{Script=  Psalter_Pahlavi}', "");
    Expect(1, 68527, '\P{^Script=  Psalter_Pahlavi}', "");
    Expect(0, 68528, '\p{Script=  Psalter_Pahlavi}', "");
    Expect(1, 68528, '\p{^Script=  Psalter_Pahlavi}', "");
    Expect(1, 68528, '\P{Script=  Psalter_Pahlavi}', "");
    Expect(0, 68528, '\P{^Script=  Psalter_Pahlavi}', "");
    Error('\p{Sc=_-Phlp:=}');
    Error('\P{Sc=_-Phlp:=}');
    Expect(1, 68527, '\p{Sc=phlp}', "");
    Expect(0, 68527, '\p{^Sc=phlp}', "");
    Expect(0, 68527, '\P{Sc=phlp}', "");
    Expect(1, 68527, '\P{^Sc=phlp}', "");
    Expect(0, 68528, '\p{Sc=phlp}', "");
    Expect(1, 68528, '\p{^Sc=phlp}', "");
    Expect(1, 68528, '\P{Sc=phlp}', "");
    Expect(0, 68528, '\P{^Sc=phlp}', "");
    Expect(1, 68527, '\p{Sc=-phlp}', "");
    Expect(0, 68527, '\p{^Sc=-phlp}', "");
    Expect(0, 68527, '\P{Sc=-phlp}', "");
    Expect(1, 68527, '\P{^Sc=-phlp}', "");
    Expect(0, 68528, '\p{Sc=-phlp}', "");
    Expect(1, 68528, '\p{^Sc=-phlp}', "");
    Expect(1, 68528, '\P{Sc=-phlp}', "");
    Expect(0, 68528, '\P{^Sc=-phlp}', "");
    Error('\p{Is_Script=/a/ Psalter_pahlavi}');
    Error('\P{Is_Script=/a/ Psalter_pahlavi}');
    Expect(1, 68527, '\p{Is_Script=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Is_Script=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Is_Script=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Is_Script=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Is_Script=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Is_Script=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Is_Script=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Is_Script=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Is_Script=--psalter_Pahlavi}', "");
    Expect(0, 68527, '\p{^Is_Script=--psalter_Pahlavi}', "");
    Expect(0, 68527, '\P{Is_Script=--psalter_Pahlavi}', "");
    Expect(1, 68527, '\P{^Is_Script=--psalter_Pahlavi}', "");
    Expect(0, 68528, '\p{Is_Script=--psalter_Pahlavi}', "");
    Expect(1, 68528, '\p{^Is_Script=--psalter_Pahlavi}', "");
    Expect(1, 68528, '\P{Is_Script=--psalter_Pahlavi}', "");
    Expect(0, 68528, '\P{^Is_Script=--psalter_Pahlavi}', "");
    Error('\p{Is_Sc= :=Phlp}');
    Error('\P{Is_Sc= :=Phlp}');
    Expect(1, 68527, '\p{Is_Sc=phlp}', "");
    Expect(0, 68527, '\p{^Is_Sc=phlp}', "");
    Expect(0, 68527, '\P{Is_Sc=phlp}', "");
    Expect(1, 68527, '\P{^Is_Sc=phlp}', "");
    Expect(0, 68528, '\p{Is_Sc=phlp}', "");
    Expect(1, 68528, '\p{^Is_Sc=phlp}', "");
    Expect(1, 68528, '\P{Is_Sc=phlp}', "");
    Expect(0, 68528, '\P{^Is_Sc=phlp}', "");
    Expect(1, 68527, '\p{Is_Sc=_ PHLP}', "");
    Expect(0, 68527, '\p{^Is_Sc=_ PHLP}', "");
    Expect(0, 68527, '\P{Is_Sc=_ PHLP}', "");
    Expect(1, 68527, '\P{^Is_Sc=_ PHLP}', "");
    Expect(0, 68528, '\p{Is_Sc=_ PHLP}', "");
    Expect(1, 68528, '\p{^Is_Sc=_ PHLP}', "");
    Expect(1, 68528, '\P{Is_Sc=_ PHLP}', "");
    Expect(0, 68528, '\P{^Is_Sc=_ PHLP}', "");
    Error('\p{Script= -phoenician/a/}');
    Error('\P{Script= -phoenician/a/}');
    Expect(1, 67871, '\p{Script=phoenician}', "");
    Expect(0, 67871, '\p{^Script=phoenician}', "");
    Expect(0, 67871, '\P{Script=phoenician}', "");
    Expect(1, 67871, '\P{^Script=phoenician}', "");
    Expect(0, 67872, '\p{Script=phoenician}', "");
    Expect(1, 67872, '\p{^Script=phoenician}', "");
    Expect(1, 67872, '\P{Script=phoenician}', "");
    Expect(0, 67872, '\P{^Script=phoenician}', "");
    Expect(1, 67871, '\p{Script=_phoenician}', "");
    Expect(0, 67871, '\p{^Script=_phoenician}', "");
    Expect(0, 67871, '\P{Script=_phoenician}', "");
    Expect(1, 67871, '\P{^Script=_phoenician}', "");
    Expect(0, 67872, '\p{Script=_phoenician}', "");
    Expect(1, 67872, '\p{^Script=_phoenician}', "");
    Expect(1, 67872, '\P{Script=_phoenician}', "");
    Expect(0, 67872, '\P{^Script=_phoenician}', "");
    Error('\p{Sc=	:=PHNX}');
    Error('\P{Sc=	:=PHNX}');
    Expect(1, 67871, '\p{Sc=phnx}', "");
    Expect(0, 67871, '\p{^Sc=phnx}', "");
    Expect(0, 67871, '\P{Sc=phnx}', "");
    Expect(1, 67871, '\P{^Sc=phnx}', "");
    Expect(0, 67872, '\p{Sc=phnx}', "");
    Expect(1, 67872, '\p{^Sc=phnx}', "");
    Expect(1, 67872, '\P{Sc=phnx}', "");
    Expect(0, 67872, '\P{^Sc=phnx}', "");
    Expect(1, 67871, '\p{Sc=-phnx}', "");
    Expect(0, 67871, '\p{^Sc=-phnx}', "");
    Expect(0, 67871, '\P{Sc=-phnx}', "");
    Expect(1, 67871, '\P{^Sc=-phnx}', "");
    Expect(0, 67872, '\p{Sc=-phnx}', "");
    Expect(1, 67872, '\p{^Sc=-phnx}', "");
    Expect(1, 67872, '\P{Sc=-phnx}', "");
    Expect(0, 67872, '\P{^Sc=-phnx}', "");
    Error('\p{Is_Script=/a/_Phoenician}');
    Error('\P{Is_Script=/a/_Phoenician}');
    Expect(1, 67871, '\p{Is_Script=phoenician}', "");
    Expect(0, 67871, '\p{^Is_Script=phoenician}', "");
    Expect(0, 67871, '\P{Is_Script=phoenician}', "");
    Expect(1, 67871, '\P{^Is_Script=phoenician}', "");
    Expect(0, 67872, '\p{Is_Script=phoenician}', "");
    Expect(1, 67872, '\p{^Is_Script=phoenician}', "");
    Expect(1, 67872, '\P{Is_Script=phoenician}', "");
    Expect(0, 67872, '\P{^Is_Script=phoenician}', "");
    Expect(1, 67871, '\p{Is_Script:-Phoenician}', "");
    Expect(0, 67871, '\p{^Is_Script:-Phoenician}', "");
    Expect(0, 67871, '\P{Is_Script:-Phoenician}', "");
    Expect(1, 67871, '\P{^Is_Script:-Phoenician}', "");
    Expect(0, 67872, '\p{Is_Script:-Phoenician}', "");
    Expect(1, 67872, '\p{^Is_Script:-Phoenician}', "");
    Expect(1, 67872, '\P{Is_Script:-Phoenician}', "");
    Expect(0, 67872, '\P{^Is_Script:-Phoenician}', "");
    Error('\p{Is_Sc=:=	_PHNX}');
    Error('\P{Is_Sc=:=	_PHNX}');
    Expect(1, 67871, '\p{Is_Sc=phnx}', "");
    Expect(0, 67871, '\p{^Is_Sc=phnx}', "");
    Expect(0, 67871, '\P{Is_Sc=phnx}', "");
    Expect(1, 67871, '\P{^Is_Sc=phnx}', "");
    Expect(0, 67872, '\p{Is_Sc=phnx}', "");
    Expect(1, 67872, '\p{^Is_Sc=phnx}', "");
    Expect(1, 67872, '\P{Is_Sc=phnx}', "");
    Expect(0, 67872, '\P{^Is_Sc=phnx}', "");
    Expect(1, 67871, '\p{Is_Sc:		-Phnx}', "");
    Expect(0, 67871, '\p{^Is_Sc:		-Phnx}', "");
    Expect(0, 67871, '\P{Is_Sc:		-Phnx}', "");
    Expect(1, 67871, '\P{^Is_Sc:		-Phnx}', "");
    Expect(0, 67872, '\p{Is_Sc:		-Phnx}', "");
    Expect(1, 67872, '\p{^Is_Sc:		-Phnx}', "");
    Expect(1, 67872, '\P{Is_Sc:		-Phnx}', "");
    Expect(0, 67872, '\P{^Is_Sc:		-Phnx}', "");
    Error('\p{Script:	 :=miao}');
    Error('\P{Script:	 :=miao}');
    Expect(1, 94111, '\p{Script=miao}', "");
    Expect(0, 94111, '\p{^Script=miao}', "");
    Expect(0, 94111, '\P{Script=miao}', "");
    Expect(1, 94111, '\P{^Script=miao}', "");
    Expect(0, 94112, '\p{Script=miao}', "");
    Expect(1, 94112, '\p{^Script=miao}', "");
    Expect(1, 94112, '\P{Script=miao}', "");
    Expect(0, 94112, '\P{^Script=miao}', "");
    Expect(1, 94111, '\p{Script=_ Miao}', "");
    Expect(0, 94111, '\p{^Script=_ Miao}', "");
    Expect(0, 94111, '\P{Script=_ Miao}', "");
    Expect(1, 94111, '\P{^Script=_ Miao}', "");
    Expect(0, 94112, '\p{Script=_ Miao}', "");
    Expect(1, 94112, '\p{^Script=_ Miao}', "");
    Expect(1, 94112, '\P{Script=_ Miao}', "");
    Expect(0, 94112, '\P{^Script=_ Miao}', "");
    Error('\p{Sc=:=-Plrd}');
    Error('\P{Sc=:=-Plrd}');
    Expect(1, 94111, '\p{Sc=plrd}', "");
    Expect(0, 94111, '\p{^Sc=plrd}', "");
    Expect(0, 94111, '\P{Sc=plrd}', "");
    Expect(1, 94111, '\P{^Sc=plrd}', "");
    Expect(0, 94112, '\p{Sc=plrd}', "");
    Expect(1, 94112, '\p{^Sc=plrd}', "");
    Expect(1, 94112, '\P{Sc=plrd}', "");
    Expect(0, 94112, '\P{^Sc=plrd}', "");
    Expect(1, 94111, '\p{Sc=	Plrd}', "");
    Expect(0, 94111, '\p{^Sc=	Plrd}', "");
    Expect(0, 94111, '\P{Sc=	Plrd}', "");
    Expect(1, 94111, '\P{^Sc=	Plrd}', "");
    Expect(0, 94112, '\p{Sc=	Plrd}', "");
    Expect(1, 94112, '\p{^Sc=	Plrd}', "");
    Expect(1, 94112, '\P{Sc=	Plrd}', "");
    Expect(0, 94112, '\P{^Sc=	Plrd}', "");
    Error('\p{Is_Script=_/a/Miao}');
    Error('\P{Is_Script=_/a/Miao}');
    Expect(1, 94111, '\p{Is_Script=miao}', "");
    Expect(0, 94111, '\p{^Is_Script=miao}', "");
    Expect(0, 94111, '\P{Is_Script=miao}', "");
    Expect(1, 94111, '\P{^Is_Script=miao}', "");
    Expect(0, 94112, '\p{Is_Script=miao}', "");
    Expect(1, 94112, '\p{^Is_Script=miao}', "");
    Expect(1, 94112, '\P{Is_Script=miao}', "");
    Expect(0, 94112, '\P{^Is_Script=miao}', "");
    Expect(1, 94111, '\p{Is_Script= Miao}', "");
    Expect(0, 94111, '\p{^Is_Script= Miao}', "");
    Expect(0, 94111, '\P{Is_Script= Miao}', "");
    Expect(1, 94111, '\P{^Is_Script= Miao}', "");
    Expect(0, 94112, '\p{Is_Script= Miao}', "");
    Expect(1, 94112, '\p{^Is_Script= Miao}', "");
    Expect(1, 94112, '\P{Is_Script= Miao}', "");
    Expect(0, 94112, '\P{^Is_Script= Miao}', "");
    Error('\p{Is_Sc=-plrd/a/}');
    Error('\P{Is_Sc=-plrd/a/}');
    Expect(1, 94111, '\p{Is_Sc=plrd}', "");
    Expect(0, 94111, '\p{^Is_Sc=plrd}', "");
    Expect(0, 94111, '\P{Is_Sc=plrd}', "");
    Expect(1, 94111, '\P{^Is_Sc=plrd}', "");
    Expect(0, 94112, '\p{Is_Sc=plrd}', "");
    Expect(1, 94112, '\p{^Is_Sc=plrd}', "");
    Expect(1, 94112, '\P{Is_Sc=plrd}', "");
    Expect(0, 94112, '\P{^Is_Sc=plrd}', "");
    Expect(1, 94111, '\p{Is_Sc=_ Plrd}', "");
    Expect(0, 94111, '\p{^Is_Sc=_ Plrd}', "");
    Expect(0, 94111, '\P{Is_Sc=_ Plrd}', "");
    Expect(1, 94111, '\P{^Is_Sc=_ Plrd}', "");
    Expect(0, 94112, '\p{Is_Sc=_ Plrd}', "");
    Expect(1, 94112, '\p{^Is_Sc=_ Plrd}', "");
    Expect(1, 94112, '\P{Is_Sc=_ Plrd}', "");
    Expect(0, 94112, '\P{^Is_Sc=_ Plrd}', "");
    Error('\p{Script=-INSCRIPTIONAL_Parthian/a/}');
    Error('\P{Script=-INSCRIPTIONAL_Parthian/a/}');
    Expect(1, 68447, '\p{Script=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Script=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Script=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Script=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Script=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Script=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Script=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Script=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Script:   -	inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\p{^Script:   -	inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\P{Script:   -	inscriptional_PARTHIAN}', "");
    Expect(1, 68447, '\P{^Script:   -	inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\p{Script:   -	inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\p{^Script:   -	inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\P{Script:   -	inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\P{^Script:   -	inscriptional_PARTHIAN}', "");
    Error('\p{Sc=:=-	Prti}');
    Error('\P{Sc=:=-	Prti}');
    Expect(1, 68447, '\p{Sc:   prti}', "");
    Expect(0, 68447, '\p{^Sc:   prti}', "");
    Expect(0, 68447, '\P{Sc:   prti}', "");
    Expect(1, 68447, '\P{^Sc:   prti}', "");
    Expect(0, 68448, '\p{Sc:   prti}', "");
    Expect(1, 68448, '\p{^Sc:   prti}', "");
    Expect(1, 68448, '\P{Sc:   prti}', "");
    Expect(0, 68448, '\P{^Sc:   prti}', "");
    Expect(1, 68447, '\p{Sc=-prti}', "");
    Expect(0, 68447, '\p{^Sc=-prti}', "");
    Expect(0, 68447, '\P{Sc=-prti}', "");
    Expect(1, 68447, '\P{^Sc=-prti}', "");
    Expect(0, 68448, '\p{Sc=-prti}', "");
    Expect(1, 68448, '\p{^Sc=-prti}', "");
    Expect(1, 68448, '\P{Sc=-prti}', "");
    Expect(0, 68448, '\P{^Sc=-prti}', "");
    Error('\p{Is_Script=/a/	-inscriptional_Parthian}');
    Error('\P{Is_Script=/a/	-inscriptional_Parthian}');
    Expect(1, 68447, '\p{Is_Script=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Is_Script=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Is_Script=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Is_Script=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Is_Script=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Is_Script=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Is_Script=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Is_Script=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Is_Script=	-inscriptional_Parthian}', "");
    Expect(0, 68447, '\p{^Is_Script=	-inscriptional_Parthian}', "");
    Expect(0, 68447, '\P{Is_Script=	-inscriptional_Parthian}', "");
    Expect(1, 68447, '\P{^Is_Script=	-inscriptional_Parthian}', "");
    Expect(0, 68448, '\p{Is_Script=	-inscriptional_Parthian}', "");
    Expect(1, 68448, '\p{^Is_Script=	-inscriptional_Parthian}', "");
    Expect(1, 68448, '\P{Is_Script=	-inscriptional_Parthian}', "");
    Expect(0, 68448, '\P{^Is_Script=	-inscriptional_Parthian}', "");
    Error('\p{Is_Sc=/a/ -PRTI}');
    Error('\P{Is_Sc=/a/ -PRTI}');
    Expect(1, 68447, '\p{Is_Sc=prti}', "");
    Expect(0, 68447, '\p{^Is_Sc=prti}', "");
    Expect(0, 68447, '\P{Is_Sc=prti}', "");
    Expect(1, 68447, '\P{^Is_Sc=prti}', "");
    Expect(0, 68448, '\p{Is_Sc=prti}', "");
    Expect(1, 68448, '\p{^Is_Sc=prti}', "");
    Expect(1, 68448, '\P{Is_Sc=prti}', "");
    Expect(0, 68448, '\P{^Is_Sc=prti}', "");
    Expect(1, 68447, '\p{Is_Sc=  Prti}', "");
    Expect(0, 68447, '\p{^Is_Sc=  Prti}', "");
    Expect(0, 68447, '\P{Is_Sc=  Prti}', "");
    Expect(1, 68447, '\P{^Is_Sc=  Prti}', "");
    Expect(0, 68448, '\p{Is_Sc=  Prti}', "");
    Expect(1, 68448, '\p{^Is_Sc=  Prti}', "");
    Expect(1, 68448, '\P{Is_Sc=  Prti}', "");
    Expect(0, 68448, '\P{^Is_Sc=  Prti}', "");
    Error('\p{Script=/a/-rejang}');
    Error('\P{Script=/a/-rejang}');
    Expect(1, 43359, '\p{Script:rejang}', "");
    Expect(0, 43359, '\p{^Script:rejang}', "");
    Expect(0, 43359, '\P{Script:rejang}', "");
    Expect(1, 43359, '\P{^Script:rejang}', "");
    Expect(0, 43360, '\p{Script:rejang}', "");
    Expect(1, 43360, '\p{^Script:rejang}', "");
    Expect(1, 43360, '\P{Script:rejang}', "");
    Expect(0, 43360, '\P{^Script:rejang}', "");
    Expect(1, 43359, '\p{Script=	_Rejang}', "");
    Expect(0, 43359, '\p{^Script=	_Rejang}', "");
    Expect(0, 43359, '\P{Script=	_Rejang}', "");
    Expect(1, 43359, '\P{^Script=	_Rejang}', "");
    Expect(0, 43360, '\p{Script=	_Rejang}', "");
    Expect(1, 43360, '\p{^Script=	_Rejang}', "");
    Expect(1, 43360, '\P{Script=	_Rejang}', "");
    Expect(0, 43360, '\P{^Script=	_Rejang}', "");
    Error('\p{Sc=  Rjng/a/}');
    Error('\P{Sc=  Rjng/a/}');
    Expect(1, 43359, '\p{Sc=rjng}', "");
    Expect(0, 43359, '\p{^Sc=rjng}', "");
    Expect(0, 43359, '\P{Sc=rjng}', "");
    Expect(1, 43359, '\P{^Sc=rjng}', "");
    Expect(0, 43360, '\p{Sc=rjng}', "");
    Expect(1, 43360, '\p{^Sc=rjng}', "");
    Expect(1, 43360, '\P{Sc=rjng}', "");
    Expect(0, 43360, '\P{^Sc=rjng}', "");
    Expect(1, 43359, '\p{Sc=_	Rjng}', "");
    Expect(0, 43359, '\p{^Sc=_	Rjng}', "");
    Expect(0, 43359, '\P{Sc=_	Rjng}', "");
    Expect(1, 43359, '\P{^Sc=_	Rjng}', "");
    Expect(0, 43360, '\p{Sc=_	Rjng}', "");
    Expect(1, 43360, '\p{^Sc=_	Rjng}', "");
    Expect(1, 43360, '\P{Sc=_	Rjng}', "");
    Expect(0, 43360, '\P{^Sc=_	Rjng}', "");
    Error('\p{Is_Script=:=Rejang}');
    Error('\P{Is_Script=:=Rejang}');
    Expect(1, 43359, '\p{Is_Script=rejang}', "");
    Expect(0, 43359, '\p{^Is_Script=rejang}', "");
    Expect(0, 43359, '\P{Is_Script=rejang}', "");
    Expect(1, 43359, '\P{^Is_Script=rejang}', "");
    Expect(0, 43360, '\p{Is_Script=rejang}', "");
    Expect(1, 43360, '\p{^Is_Script=rejang}', "");
    Expect(1, 43360, '\P{Is_Script=rejang}', "");
    Expect(0, 43360, '\P{^Is_Script=rejang}', "");
    Expect(1, 43359, '\p{Is_Script=REJANG}', "");
    Expect(0, 43359, '\p{^Is_Script=REJANG}', "");
    Expect(0, 43359, '\P{Is_Script=REJANG}', "");
    Expect(1, 43359, '\P{^Is_Script=REJANG}', "");
    Expect(0, 43360, '\p{Is_Script=REJANG}', "");
    Expect(1, 43360, '\p{^Is_Script=REJANG}', "");
    Expect(1, 43360, '\P{Is_Script=REJANG}', "");
    Expect(0, 43360, '\P{^Is_Script=REJANG}', "");
    Error('\p{Is_Sc=_	rjng/a/}');
    Error('\P{Is_Sc=_	rjng/a/}');
    Expect(1, 43359, '\p{Is_Sc=rjng}', "");
    Expect(0, 43359, '\p{^Is_Sc=rjng}', "");
    Expect(0, 43359, '\P{Is_Sc=rjng}', "");
    Expect(1, 43359, '\P{^Is_Sc=rjng}', "");
    Expect(0, 43360, '\p{Is_Sc=rjng}', "");
    Expect(1, 43360, '\p{^Is_Sc=rjng}', "");
    Expect(1, 43360, '\P{Is_Sc=rjng}', "");
    Expect(0, 43360, '\P{^Is_Sc=rjng}', "");
    Expect(1, 43359, '\p{Is_Sc=	 RJNG}', "");
    Expect(0, 43359, '\p{^Is_Sc=	 RJNG}', "");
    Expect(0, 43359, '\P{Is_Sc=	 RJNG}', "");
    Expect(1, 43359, '\P{^Is_Sc=	 RJNG}', "");
    Expect(0, 43360, '\p{Is_Sc=	 RJNG}', "");
    Expect(1, 43360, '\p{^Is_Sc=	 RJNG}', "");
    Expect(1, 43360, '\P{Is_Sc=	 RJNG}', "");
    Expect(0, 43360, '\P{^Is_Sc=	 RJNG}', "");
    Error('\p{Script=_runic/a/}');
    Error('\P{Script=_runic/a/}');
    Expect(1, 5880, '\p{Script=runic}', "");
    Expect(0, 5880, '\p{^Script=runic}', "");
    Expect(0, 5880, '\P{Script=runic}', "");
    Expect(1, 5880, '\P{^Script=runic}', "");
    Expect(0, 5881, '\p{Script=runic}', "");
    Expect(1, 5881, '\p{^Script=runic}', "");
    Expect(1, 5881, '\P{Script=runic}', "");
    Expect(0, 5881, '\P{^Script=runic}', "");
    Expect(1, 5880, '\p{Script=_-Runic}', "");
    Expect(0, 5880, '\p{^Script=_-Runic}', "");
    Expect(0, 5880, '\P{Script=_-Runic}', "");
    Expect(1, 5880, '\P{^Script=_-Runic}', "");
    Expect(0, 5881, '\p{Script=_-Runic}', "");
    Expect(1, 5881, '\p{^Script=_-Runic}', "");
    Expect(1, 5881, '\P{Script=_-Runic}', "");
    Expect(0, 5881, '\P{^Script=_-Runic}', "");
    Error('\p{Sc=- runr:=}');
    Error('\P{Sc=- runr:=}');
    Expect(1, 5880, '\p{Sc=runr}', "");
    Expect(0, 5880, '\p{^Sc=runr}', "");
    Expect(0, 5880, '\P{Sc=runr}', "");
    Expect(1, 5880, '\P{^Sc=runr}', "");
    Expect(0, 5881, '\p{Sc=runr}', "");
    Expect(1, 5881, '\p{^Sc=runr}', "");
    Expect(1, 5881, '\P{Sc=runr}', "");
    Expect(0, 5881, '\P{^Sc=runr}', "");
    Expect(1, 5880, '\p{Sc=-	Runr}', "");
    Expect(0, 5880, '\p{^Sc=-	Runr}', "");
    Expect(0, 5880, '\P{Sc=-	Runr}', "");
    Expect(1, 5880, '\P{^Sc=-	Runr}', "");
    Expect(0, 5881, '\p{Sc=-	Runr}', "");
    Expect(1, 5881, '\p{^Sc=-	Runr}', "");
    Expect(1, 5881, '\P{Sc=-	Runr}', "");
    Expect(0, 5881, '\P{^Sc=-	Runr}', "");
    Error('\p{Is_Script=	/a/runic}');
    Error('\P{Is_Script=	/a/runic}');
    Expect(1, 5880, '\p{Is_Script: runic}', "");
    Expect(0, 5880, '\p{^Is_Script: runic}', "");
    Expect(0, 5880, '\P{Is_Script: runic}', "");
    Expect(1, 5880, '\P{^Is_Script: runic}', "");
    Expect(0, 5881, '\p{Is_Script: runic}', "");
    Expect(1, 5881, '\p{^Is_Script: runic}', "");
    Expect(1, 5881, '\P{Is_Script: runic}', "");
    Expect(0, 5881, '\P{^Is_Script: runic}', "");
    Expect(1, 5880, '\p{Is_Script= RUNIC}', "");
    Expect(0, 5880, '\p{^Is_Script= RUNIC}', "");
    Expect(0, 5880, '\P{Is_Script= RUNIC}', "");
    Expect(1, 5880, '\P{^Is_Script= RUNIC}', "");
    Expect(0, 5881, '\p{Is_Script= RUNIC}', "");
    Expect(1, 5881, '\p{^Is_Script= RUNIC}', "");
    Expect(1, 5881, '\P{Is_Script= RUNIC}', "");
    Expect(0, 5881, '\P{^Is_Script= RUNIC}', "");
    Error('\p{Is_Sc=/a/runr}');
    Error('\P{Is_Sc=/a/runr}');
    Expect(1, 5880, '\p{Is_Sc: runr}', "");
    Expect(0, 5880, '\p{^Is_Sc: runr}', "");
    Expect(0, 5880, '\P{Is_Sc: runr}', "");
    Expect(1, 5880, '\P{^Is_Sc: runr}', "");
    Expect(0, 5881, '\p{Is_Sc: runr}', "");
    Expect(1, 5881, '\p{^Is_Sc: runr}', "");
    Expect(1, 5881, '\P{Is_Sc: runr}', "");
    Expect(0, 5881, '\P{^Is_Sc: runr}', "");
    Expect(1, 5880, '\p{Is_Sc=	Runr}', "");
    Expect(0, 5880, '\p{^Is_Sc=	Runr}', "");
    Expect(0, 5880, '\P{Is_Sc=	Runr}', "");
    Expect(1, 5880, '\P{^Is_Sc=	Runr}', "");
    Expect(0, 5881, '\p{Is_Sc=	Runr}', "");
    Expect(1, 5881, '\p{^Is_Sc=	Runr}', "");
    Expect(1, 5881, '\P{Is_Sc=	Runr}', "");
    Expect(0, 5881, '\P{^Is_Sc=	Runr}', "");
    Error('\p{Script=_/a/SAMARITAN}');
    Error('\P{Script=_/a/SAMARITAN}');
    Expect(1, 2110, '\p{Script=samaritan}', "");
    Expect(0, 2110, '\p{^Script=samaritan}', "");
    Expect(0, 2110, '\P{Script=samaritan}', "");
    Expect(1, 2110, '\P{^Script=samaritan}', "");
    Expect(0, 2111, '\p{Script=samaritan}', "");
    Expect(1, 2111, '\p{^Script=samaritan}', "");
    Expect(1, 2111, '\P{Script=samaritan}', "");
    Expect(0, 2111, '\P{^Script=samaritan}', "");
    Expect(1, 2110, '\p{Script:	  SAMARITAN}', "");
    Expect(0, 2110, '\p{^Script:	  SAMARITAN}', "");
    Expect(0, 2110, '\P{Script:	  SAMARITAN}', "");
    Expect(1, 2110, '\P{^Script:	  SAMARITAN}', "");
    Expect(0, 2111, '\p{Script:	  SAMARITAN}', "");
    Expect(1, 2111, '\p{^Script:	  SAMARITAN}', "");
    Expect(1, 2111, '\P{Script:	  SAMARITAN}', "");
    Expect(0, 2111, '\P{^Script:	  SAMARITAN}', "");
    Error('\p{Sc: -/a/Samr}');
    Error('\P{Sc: -/a/Samr}');
    Expect(1, 2110, '\p{Sc=samr}', "");
    Expect(0, 2110, '\p{^Sc=samr}', "");
    Expect(0, 2110, '\P{Sc=samr}', "");
    Expect(1, 2110, '\P{^Sc=samr}', "");
    Expect(0, 2111, '\p{Sc=samr}', "");
    Expect(1, 2111, '\p{^Sc=samr}', "");
    Expect(1, 2111, '\P{Sc=samr}', "");
    Expect(0, 2111, '\P{^Sc=samr}', "");
    Expect(1, 2110, '\p{Sc=  SAMR}', "");
    Expect(0, 2110, '\p{^Sc=  SAMR}', "");
    Expect(0, 2110, '\P{Sc=  SAMR}', "");
    Expect(1, 2110, '\P{^Sc=  SAMR}', "");
    Expect(0, 2111, '\p{Sc=  SAMR}', "");
    Expect(1, 2111, '\p{^Sc=  SAMR}', "");
    Expect(1, 2111, '\P{Sc=  SAMR}', "");
    Expect(0, 2111, '\P{^Sc=  SAMR}', "");
    Error('\p{Is_Script=/a/	_SAMARITAN}');
    Error('\P{Is_Script=/a/	_SAMARITAN}');
    Expect(1, 2110, '\p{Is_Script=samaritan}', "");
    Expect(0, 2110, '\p{^Is_Script=samaritan}', "");
    Expect(0, 2110, '\P{Is_Script=samaritan}', "");
    Expect(1, 2110, '\P{^Is_Script=samaritan}', "");
    Expect(0, 2111, '\p{Is_Script=samaritan}', "");
    Expect(1, 2111, '\p{^Is_Script=samaritan}', "");
    Expect(1, 2111, '\P{Is_Script=samaritan}', "");
    Expect(0, 2111, '\P{^Is_Script=samaritan}', "");
    Expect(1, 2110, '\p{Is_Script= 	Samaritan}', "");
    Expect(0, 2110, '\p{^Is_Script= 	Samaritan}', "");
    Expect(0, 2110, '\P{Is_Script= 	Samaritan}', "");
    Expect(1, 2110, '\P{^Is_Script= 	Samaritan}', "");
    Expect(0, 2111, '\p{Is_Script= 	Samaritan}', "");
    Expect(1, 2111, '\p{^Is_Script= 	Samaritan}', "");
    Expect(1, 2111, '\P{Is_Script= 	Samaritan}', "");
    Expect(0, 2111, '\P{^Is_Script= 	Samaritan}', "");
    Error('\p{Is_Sc=/a/__Samr}');
    Error('\P{Is_Sc=/a/__Samr}');
    Expect(1, 2110, '\p{Is_Sc=samr}', "");
    Expect(0, 2110, '\p{^Is_Sc=samr}', "");
    Expect(0, 2110, '\P{Is_Sc=samr}', "");
    Expect(1, 2110, '\P{^Is_Sc=samr}', "");
    Expect(0, 2111, '\p{Is_Sc=samr}', "");
    Expect(1, 2111, '\p{^Is_Sc=samr}', "");
    Expect(1, 2111, '\P{Is_Sc=samr}', "");
    Expect(0, 2111, '\P{^Is_Sc=samr}', "");
    Expect(1, 2110, '\p{Is_Sc:	-SAMR}', "");
    Expect(0, 2110, '\p{^Is_Sc:	-SAMR}', "");
    Expect(0, 2110, '\P{Is_Sc:	-SAMR}', "");
    Expect(1, 2110, '\P{^Is_Sc:	-SAMR}', "");
    Expect(0, 2111, '\p{Is_Sc:	-SAMR}', "");
    Expect(1, 2111, '\p{^Is_Sc:	-SAMR}', "");
    Expect(1, 2111, '\P{Is_Sc:	-SAMR}', "");
    Expect(0, 2111, '\P{^Is_Sc:	-SAMR}', "");
    Error('\p{Script=/a/	_OLD_South_Arabian}');
    Error('\P{Script=/a/	_OLD_South_Arabian}');
    Expect(1, 68223, '\p{Script=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Script=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Script=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Script=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Script=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Script=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Script=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Script=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Script=_	Old_South_ARABIAN}', "");
    Expect(0, 68223, '\p{^Script=_	Old_South_ARABIAN}', "");
    Expect(0, 68223, '\P{Script=_	Old_South_ARABIAN}', "");
    Expect(1, 68223, '\P{^Script=_	Old_South_ARABIAN}', "");
    Expect(0, 68224, '\p{Script=_	Old_South_ARABIAN}', "");
    Expect(1, 68224, '\p{^Script=_	Old_South_ARABIAN}', "");
    Expect(1, 68224, '\P{Script=_	Old_South_ARABIAN}', "");
    Expect(0, 68224, '\P{^Script=_	Old_South_ARABIAN}', "");
    Error('\p{Sc=-	SARB:=}');
    Error('\P{Sc=-	SARB:=}');
    Expect(1, 68223, '\p{Sc=sarb}', "");
    Expect(0, 68223, '\p{^Sc=sarb}', "");
    Expect(0, 68223, '\P{Sc=sarb}', "");
    Expect(1, 68223, '\P{^Sc=sarb}', "");
    Expect(0, 68224, '\p{Sc=sarb}', "");
    Expect(1, 68224, '\p{^Sc=sarb}', "");
    Expect(1, 68224, '\P{Sc=sarb}', "");
    Expect(0, 68224, '\P{^Sc=sarb}', "");
    Expect(1, 68223, '\p{Sc= SARB}', "");
    Expect(0, 68223, '\p{^Sc= SARB}', "");
    Expect(0, 68223, '\P{Sc= SARB}', "");
    Expect(1, 68223, '\P{^Sc= SARB}', "");
    Expect(0, 68224, '\p{Sc= SARB}', "");
    Expect(1, 68224, '\p{^Sc= SARB}', "");
    Expect(1, 68224, '\P{Sc= SARB}', "");
    Expect(0, 68224, '\P{^Sc= SARB}', "");
    Error('\p{Is_Script=/a/Old_South_ARABIAN}');
    Error('\P{Is_Script=/a/Old_South_ARABIAN}');
    Expect(1, 68223, '\p{Is_Script=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Is_Script=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Is_Script=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Is_Script=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Is_Script=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Is_Script=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Is_Script=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Is_Script=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Is_Script=-OLD_SOUTH_Arabian}', "");
    Expect(0, 68223, '\p{^Is_Script=-OLD_SOUTH_Arabian}', "");
    Expect(0, 68223, '\P{Is_Script=-OLD_SOUTH_Arabian}', "");
    Expect(1, 68223, '\P{^Is_Script=-OLD_SOUTH_Arabian}', "");
    Expect(0, 68224, '\p{Is_Script=-OLD_SOUTH_Arabian}', "");
    Expect(1, 68224, '\p{^Is_Script=-OLD_SOUTH_Arabian}', "");
    Expect(1, 68224, '\P{Is_Script=-OLD_SOUTH_Arabian}', "");
    Expect(0, 68224, '\P{^Is_Script=-OLD_SOUTH_Arabian}', "");
    Error('\p{Is_Sc= :=SARB}');
    Error('\P{Is_Sc= :=SARB}');
    Expect(1, 68223, '\p{Is_Sc=sarb}', "");
    Expect(0, 68223, '\p{^Is_Sc=sarb}', "");
    Expect(0, 68223, '\P{Is_Sc=sarb}', "");
    Expect(1, 68223, '\P{^Is_Sc=sarb}', "");
    Expect(0, 68224, '\p{Is_Sc=sarb}', "");
    Expect(1, 68224, '\p{^Is_Sc=sarb}', "");
    Expect(1, 68224, '\P{Is_Sc=sarb}', "");
    Expect(0, 68224, '\P{^Is_Sc=sarb}', "");
    Expect(1, 68223, '\p{Is_Sc=_Sarb}', "");
    Expect(0, 68223, '\p{^Is_Sc=_Sarb}', "");
    Expect(0, 68223, '\P{Is_Sc=_Sarb}', "");
    Expect(1, 68223, '\P{^Is_Sc=_Sarb}', "");
    Expect(0, 68224, '\p{Is_Sc=_Sarb}', "");
    Expect(1, 68224, '\p{^Is_Sc=_Sarb}', "");
    Expect(1, 68224, '\P{Is_Sc=_Sarb}', "");
    Expect(0, 68224, '\P{^Is_Sc=_Sarb}', "");
    Error('\p{Script=/a/	-Saurashtra}');
    Error('\P{Script=/a/	-Saurashtra}');
    Expect(1, 43225, '\p{Script=saurashtra}', "");
    Expect(0, 43225, '\p{^Script=saurashtra}', "");
    Expect(0, 43225, '\P{Script=saurashtra}', "");
    Expect(1, 43225, '\P{^Script=saurashtra}', "");
    Expect(0, 43226, '\p{Script=saurashtra}', "");
    Expect(1, 43226, '\p{^Script=saurashtra}', "");
    Expect(1, 43226, '\P{Script=saurashtra}', "");
    Expect(0, 43226, '\P{^Script=saurashtra}', "");
    Expect(1, 43225, '\p{Script=-SAURASHTRA}', "");
    Expect(0, 43225, '\p{^Script=-SAURASHTRA}', "");
    Expect(0, 43225, '\P{Script=-SAURASHTRA}', "");
    Expect(1, 43225, '\P{^Script=-SAURASHTRA}', "");
    Expect(0, 43226, '\p{Script=-SAURASHTRA}', "");
    Expect(1, 43226, '\p{^Script=-SAURASHTRA}', "");
    Expect(1, 43226, '\P{Script=-SAURASHTRA}', "");
    Expect(0, 43226, '\P{^Script=-SAURASHTRA}', "");
    Error('\p{Sc:   	/a/SAUR}');
    Error('\P{Sc:   	/a/SAUR}');
    Expect(1, 43225, '\p{Sc=saur}', "");
    Expect(0, 43225, '\p{^Sc=saur}', "");
    Expect(0, 43225, '\P{Sc=saur}', "");
    Expect(1, 43225, '\P{^Sc=saur}', "");
    Expect(0, 43226, '\p{Sc=saur}', "");
    Expect(1, 43226, '\p{^Sc=saur}', "");
    Expect(1, 43226, '\P{Sc=saur}', "");
    Expect(0, 43226, '\P{^Sc=saur}', "");
    Expect(1, 43225, '\p{Sc:	-Saur}', "");
    Expect(0, 43225, '\p{^Sc:	-Saur}', "");
    Expect(0, 43225, '\P{Sc:	-Saur}', "");
    Expect(1, 43225, '\P{^Sc:	-Saur}', "");
    Expect(0, 43226, '\p{Sc:	-Saur}', "");
    Expect(1, 43226, '\p{^Sc:	-Saur}', "");
    Expect(1, 43226, '\P{Sc:	-Saur}', "");
    Expect(0, 43226, '\P{^Sc:	-Saur}', "");
    Error('\p{Is_Script=_:=Saurashtra}');
    Error('\P{Is_Script=_:=Saurashtra}');
    Expect(1, 43225, '\p{Is_Script=saurashtra}', "");
    Expect(0, 43225, '\p{^Is_Script=saurashtra}', "");
    Expect(0, 43225, '\P{Is_Script=saurashtra}', "");
    Expect(1, 43225, '\P{^Is_Script=saurashtra}', "");
    Expect(0, 43226, '\p{Is_Script=saurashtra}', "");
    Expect(1, 43226, '\p{^Is_Script=saurashtra}', "");
    Expect(1, 43226, '\P{Is_Script=saurashtra}', "");
    Expect(0, 43226, '\P{^Is_Script=saurashtra}', "");
    Expect(1, 43225, '\p{Is_Script=__Saurashtra}', "");
    Expect(0, 43225, '\p{^Is_Script=__Saurashtra}', "");
    Expect(0, 43225, '\P{Is_Script=__Saurashtra}', "");
    Expect(1, 43225, '\P{^Is_Script=__Saurashtra}', "");
    Expect(0, 43226, '\p{Is_Script=__Saurashtra}', "");
    Expect(1, 43226, '\p{^Is_Script=__Saurashtra}', "");
    Expect(1, 43226, '\P{Is_Script=__Saurashtra}', "");
    Expect(0, 43226, '\P{^Is_Script=__Saurashtra}', "");
    Error('\p{Is_Sc=  Saur:=}');
    Error('\P{Is_Sc=  Saur:=}');
    Expect(1, 43225, '\p{Is_Sc:   saur}', "");
    Expect(0, 43225, '\p{^Is_Sc:   saur}', "");
    Expect(0, 43225, '\P{Is_Sc:   saur}', "");
    Expect(1, 43225, '\P{^Is_Sc:   saur}', "");
    Expect(0, 43226, '\p{Is_Sc:   saur}', "");
    Expect(1, 43226, '\p{^Is_Sc:   saur}', "");
    Expect(1, 43226, '\P{Is_Sc:   saur}', "");
    Expect(0, 43226, '\P{^Is_Sc:   saur}', "");
    Expect(1, 43225, '\p{Is_Sc=_-Saur}', "");
    Expect(0, 43225, '\p{^Is_Sc=_-Saur}', "");
    Expect(0, 43225, '\P{Is_Sc=_-Saur}', "");
    Expect(1, 43225, '\P{^Is_Sc=_-Saur}', "");
    Expect(0, 43226, '\p{Is_Sc=_-Saur}', "");
    Expect(1, 43226, '\p{^Is_Sc=_-Saur}', "");
    Expect(1, 43226, '\P{Is_Sc=_-Saur}', "");
    Expect(0, 43226, '\P{^Is_Sc=_-Saur}', "");
    Error('\p{Script=	/a/SignWriting}');
    Error('\P{Script=	/a/SignWriting}');
    Expect(1, 121519, '\p{Script=signwriting}', "");
    Expect(0, 121519, '\p{^Script=signwriting}', "");
    Expect(0, 121519, '\P{Script=signwriting}', "");
    Expect(1, 121519, '\P{^Script=signwriting}', "");
    Expect(0, 121520, '\p{Script=signwriting}', "");
    Expect(1, 121520, '\p{^Script=signwriting}', "");
    Expect(1, 121520, '\P{Script=signwriting}', "");
    Expect(0, 121520, '\P{^Script=signwriting}', "");
    Expect(1, 121519, '\p{Script: -signwriting}', "");
    Expect(0, 121519, '\p{^Script: -signwriting}', "");
    Expect(0, 121519, '\P{Script: -signwriting}', "");
    Expect(1, 121519, '\P{^Script: -signwriting}', "");
    Expect(0, 121520, '\p{Script: -signwriting}', "");
    Expect(1, 121520, '\p{^Script: -signwriting}', "");
    Expect(1, 121520, '\P{Script: -signwriting}', "");
    Expect(0, 121520, '\P{^Script: -signwriting}', "");
    Error('\p{Sc=	:=SGNW}');
    Error('\P{Sc=	:=SGNW}');
    Expect(1, 121519, '\p{Sc=sgnw}', "");
    Expect(0, 121519, '\p{^Sc=sgnw}', "");
    Expect(0, 121519, '\P{Sc=sgnw}', "");
    Expect(1, 121519, '\P{^Sc=sgnw}', "");
    Expect(0, 121520, '\p{Sc=sgnw}', "");
    Expect(1, 121520, '\p{^Sc=sgnw}', "");
    Expect(1, 121520, '\P{Sc=sgnw}', "");
    Expect(0, 121520, '\P{^Sc=sgnw}', "");
    Expect(1, 121519, '\p{Sc=	Sgnw}', "");
    Expect(0, 121519, '\p{^Sc=	Sgnw}', "");
    Expect(0, 121519, '\P{Sc=	Sgnw}', "");
    Expect(1, 121519, '\P{^Sc=	Sgnw}', "");
    Expect(0, 121520, '\p{Sc=	Sgnw}', "");
    Expect(1, 121520, '\p{^Sc=	Sgnw}', "");
    Expect(1, 121520, '\P{Sc=	Sgnw}', "");
    Expect(0, 121520, '\P{^Sc=	Sgnw}', "");
    Error('\p{Is_Script=  SignWriting/a/}');
    Error('\P{Is_Script=  SignWriting/a/}');
    Expect(1, 121519, '\p{Is_Script=signwriting}', "");
    Expect(0, 121519, '\p{^Is_Script=signwriting}', "");
    Expect(0, 121519, '\P{Is_Script=signwriting}', "");
    Expect(1, 121519, '\P{^Is_Script=signwriting}', "");
    Expect(0, 121520, '\p{Is_Script=signwriting}', "");
    Expect(1, 121520, '\p{^Is_Script=signwriting}', "");
    Expect(1, 121520, '\P{Is_Script=signwriting}', "");
    Expect(0, 121520, '\P{^Is_Script=signwriting}', "");
    Expect(1, 121519, '\p{Is_Script= -signwriting}', "");
    Expect(0, 121519, '\p{^Is_Script= -signwriting}', "");
    Expect(0, 121519, '\P{Is_Script= -signwriting}', "");
    Expect(1, 121519, '\P{^Is_Script= -signwriting}', "");
    Expect(0, 121520, '\p{Is_Script= -signwriting}', "");
    Expect(1, 121520, '\p{^Is_Script= -signwriting}', "");
    Expect(1, 121520, '\P{Is_Script= -signwriting}', "");
    Expect(0, 121520, '\P{^Is_Script= -signwriting}', "");
    Error('\p{Is_Sc= SGNW:=}');
    Error('\P{Is_Sc= SGNW:=}');
    Expect(1, 121519, '\p{Is_Sc:sgnw}', "");
    Expect(0, 121519, '\p{^Is_Sc:sgnw}', "");
    Expect(0, 121519, '\P{Is_Sc:sgnw}', "");
    Expect(1, 121519, '\P{^Is_Sc:sgnw}', "");
    Expect(0, 121520, '\p{Is_Sc:sgnw}', "");
    Expect(1, 121520, '\p{^Is_Sc:sgnw}', "");
    Expect(1, 121520, '\P{Is_Sc:sgnw}', "");
    Expect(0, 121520, '\P{^Is_Sc:sgnw}', "");
    Expect(1, 121519, '\p{Is_Sc:  Sgnw}', "");
    Expect(0, 121519, '\p{^Is_Sc:  Sgnw}', "");
    Expect(0, 121519, '\P{Is_Sc:  Sgnw}', "");
    Expect(1, 121519, '\P{^Is_Sc:  Sgnw}', "");
    Expect(0, 121520, '\p{Is_Sc:  Sgnw}', "");
    Expect(1, 121520, '\p{^Is_Sc:  Sgnw}', "");
    Expect(1, 121520, '\P{Is_Sc:  Sgnw}', "");
    Expect(0, 121520, '\P{^Is_Sc:  Sgnw}', "");
    Error('\p{Script=_Shavian:=}');
    Error('\P{Script=_Shavian:=}');
    Expect(1, 66687, '\p{Script=shavian}', "");
    Expect(0, 66687, '\p{^Script=shavian}', "");
    Expect(0, 66687, '\P{Script=shavian}', "");
    Expect(1, 66687, '\P{^Script=shavian}', "");
    Expect(0, 66688, '\p{Script=shavian}', "");
    Expect(1, 66688, '\p{^Script=shavian}', "");
    Expect(1, 66688, '\P{Script=shavian}', "");
    Expect(0, 66688, '\P{^Script=shavian}', "");
    Expect(1, 66687, '\p{Script=- SHAVIAN}', "");
    Expect(0, 66687, '\p{^Script=- SHAVIAN}', "");
    Expect(0, 66687, '\P{Script=- SHAVIAN}', "");
    Expect(1, 66687, '\P{^Script=- SHAVIAN}', "");
    Expect(0, 66688, '\p{Script=- SHAVIAN}', "");
    Expect(1, 66688, '\p{^Script=- SHAVIAN}', "");
    Expect(1, 66688, '\P{Script=- SHAVIAN}', "");
    Expect(0, 66688, '\P{^Script=- SHAVIAN}', "");
    Error('\p{Sc=  SHAW/a/}');
    Error('\P{Sc=  SHAW/a/}');
    Expect(1, 66687, '\p{Sc=shaw}', "");
    Expect(0, 66687, '\p{^Sc=shaw}', "");
    Expect(0, 66687, '\P{Sc=shaw}', "");
    Expect(1, 66687, '\P{^Sc=shaw}', "");
    Expect(0, 66688, '\p{Sc=shaw}', "");
    Expect(1, 66688, '\p{^Sc=shaw}', "");
    Expect(1, 66688, '\P{Sc=shaw}', "");
    Expect(0, 66688, '\P{^Sc=shaw}', "");
    Expect(1, 66687, '\p{Sc: 	shaw}', "");
    Expect(0, 66687, '\p{^Sc: 	shaw}', "");
    Expect(0, 66687, '\P{Sc: 	shaw}', "");
    Expect(1, 66687, '\P{^Sc: 	shaw}', "");
    Expect(0, 66688, '\p{Sc: 	shaw}', "");
    Expect(1, 66688, '\p{^Sc: 	shaw}', "");
    Expect(1, 66688, '\P{Sc: 	shaw}', "");
    Expect(0, 66688, '\P{^Sc: 	shaw}', "");
    Error('\p{Is_Script=_/a/shavian}');
    Error('\P{Is_Script=_/a/shavian}');
    Expect(1, 66687, '\p{Is_Script=shavian}', "");
    Expect(0, 66687, '\p{^Is_Script=shavian}', "");
    Expect(0, 66687, '\P{Is_Script=shavian}', "");
    Expect(1, 66687, '\P{^Is_Script=shavian}', "");
    Expect(0, 66688, '\p{Is_Script=shavian}', "");
    Expect(1, 66688, '\p{^Is_Script=shavian}', "");
    Expect(1, 66688, '\P{Is_Script=shavian}', "");
    Expect(0, 66688, '\P{^Is_Script=shavian}', "");
    Expect(1, 66687, '\p{Is_Script: 	-Shavian}', "");
    Expect(0, 66687, '\p{^Is_Script: 	-Shavian}', "");
    Expect(0, 66687, '\P{Is_Script: 	-Shavian}', "");
    Expect(1, 66687, '\P{^Is_Script: 	-Shavian}', "");
    Expect(0, 66688, '\p{Is_Script: 	-Shavian}', "");
    Expect(1, 66688, '\p{^Is_Script: 	-Shavian}', "");
    Expect(1, 66688, '\P{Is_Script: 	-Shavian}', "");
    Expect(0, 66688, '\P{^Is_Script: 	-Shavian}', "");
    Error('\p{Is_Sc=-	SHAW:=}');
    Error('\P{Is_Sc=-	SHAW:=}');
    Expect(1, 66687, '\p{Is_Sc=shaw}', "");
    Expect(0, 66687, '\p{^Is_Sc=shaw}', "");
    Expect(0, 66687, '\P{Is_Sc=shaw}', "");
    Expect(1, 66687, '\P{^Is_Sc=shaw}', "");
    Expect(0, 66688, '\p{Is_Sc=shaw}', "");
    Expect(1, 66688, '\p{^Is_Sc=shaw}', "");
    Expect(1, 66688, '\P{Is_Sc=shaw}', "");
    Expect(0, 66688, '\P{^Is_Sc=shaw}', "");
    Expect(1, 66687, '\p{Is_Sc=		SHAW}', "");
    Expect(0, 66687, '\p{^Is_Sc=		SHAW}', "");
    Expect(0, 66687, '\P{Is_Sc=		SHAW}', "");
    Expect(1, 66687, '\P{^Is_Sc=		SHAW}', "");
    Expect(0, 66688, '\p{Is_Sc=		SHAW}', "");
    Expect(1, 66688, '\p{^Is_Sc=		SHAW}', "");
    Expect(1, 66688, '\P{Is_Sc=		SHAW}', "");
    Expect(0, 66688, '\P{^Is_Sc=		SHAW}', "");
    Error('\p{Script=:=_ sharada}');
    Error('\P{Script=:=_ sharada}');
    Expect(1, 70111, '\p{Script=sharada}', "");
    Expect(0, 70111, '\p{^Script=sharada}', "");
    Expect(0, 70111, '\P{Script=sharada}', "");
    Expect(1, 70111, '\P{^Script=sharada}', "");
    Expect(0, 70112, '\p{Script=sharada}', "");
    Expect(1, 70112, '\p{^Script=sharada}', "");
    Expect(1, 70112, '\P{Script=sharada}', "");
    Expect(0, 70112, '\P{^Script=sharada}', "");
    Expect(1, 70111, '\p{Script= -SHARADA}', "");
    Expect(0, 70111, '\p{^Script= -SHARADA}', "");
    Expect(0, 70111, '\P{Script= -SHARADA}', "");
    Expect(1, 70111, '\P{^Script= -SHARADA}', "");
    Expect(0, 70112, '\p{Script= -SHARADA}', "");
    Expect(1, 70112, '\p{^Script= -SHARADA}', "");
    Expect(1, 70112, '\P{Script= -SHARADA}', "");
    Expect(0, 70112, '\P{^Script= -SHARADA}', "");
    Error('\p{Sc=	:=shrd}');
    Error('\P{Sc=	:=shrd}');
    Expect(1, 70111, '\p{Sc=shrd}', "");
    Expect(0, 70111, '\p{^Sc=shrd}', "");
    Expect(0, 70111, '\P{Sc=shrd}', "");
    Expect(1, 70111, '\P{^Sc=shrd}', "");
    Expect(0, 70112, '\p{Sc=shrd}', "");
    Expect(1, 70112, '\p{^Sc=shrd}', "");
    Expect(1, 70112, '\P{Sc=shrd}', "");
    Expect(0, 70112, '\P{^Sc=shrd}', "");
    Expect(1, 70111, '\p{Sc:_Shrd}', "");
    Expect(0, 70111, '\p{^Sc:_Shrd}', "");
    Expect(0, 70111, '\P{Sc:_Shrd}', "");
    Expect(1, 70111, '\P{^Sc:_Shrd}', "");
    Expect(0, 70112, '\p{Sc:_Shrd}', "");
    Expect(1, 70112, '\p{^Sc:_Shrd}', "");
    Expect(1, 70112, '\P{Sc:_Shrd}', "");
    Expect(0, 70112, '\P{^Sc:_Shrd}', "");
    Error('\p{Is_Script=-Sharada:=}');
    Error('\P{Is_Script=-Sharada:=}');
    Expect(1, 70111, '\p{Is_Script:   sharada}', "");
    Expect(0, 70111, '\p{^Is_Script:   sharada}', "");
    Expect(0, 70111, '\P{Is_Script:   sharada}', "");
    Expect(1, 70111, '\P{^Is_Script:   sharada}', "");
    Expect(0, 70112, '\p{Is_Script:   sharada}', "");
    Expect(1, 70112, '\p{^Is_Script:   sharada}', "");
    Expect(1, 70112, '\P{Is_Script:   sharada}', "");
    Expect(0, 70112, '\P{^Is_Script:   sharada}', "");
    Expect(1, 70111, '\p{Is_Script=_-SHARADA}', "");
    Expect(0, 70111, '\p{^Is_Script=_-SHARADA}', "");
    Expect(0, 70111, '\P{Is_Script=_-SHARADA}', "");
    Expect(1, 70111, '\P{^Is_Script=_-SHARADA}', "");
    Expect(0, 70112, '\p{Is_Script=_-SHARADA}', "");
    Expect(1, 70112, '\p{^Is_Script=_-SHARADA}', "");
    Expect(1, 70112, '\P{Is_Script=_-SHARADA}', "");
    Expect(0, 70112, '\P{^Is_Script=_-SHARADA}', "");
    Error('\p{Is_Sc= -Shrd/a/}');
    Error('\P{Is_Sc= -Shrd/a/}');
    Expect(1, 70111, '\p{Is_Sc=shrd}', "");
    Expect(0, 70111, '\p{^Is_Sc=shrd}', "");
    Expect(0, 70111, '\P{Is_Sc=shrd}', "");
    Expect(1, 70111, '\P{^Is_Sc=shrd}', "");
    Expect(0, 70112, '\p{Is_Sc=shrd}', "");
    Expect(1, 70112, '\p{^Is_Sc=shrd}', "");
    Expect(1, 70112, '\P{Is_Sc=shrd}', "");
    Expect(0, 70112, '\P{^Is_Sc=shrd}', "");
    Expect(1, 70111, '\p{Is_Sc=-	SHRD}', "");
    Expect(0, 70111, '\p{^Is_Sc=-	SHRD}', "");
    Expect(0, 70111, '\P{Is_Sc=-	SHRD}', "");
    Expect(1, 70111, '\P{^Is_Sc=-	SHRD}', "");
    Expect(0, 70112, '\p{Is_Sc=-	SHRD}', "");
    Expect(1, 70112, '\p{^Is_Sc=-	SHRD}', "");
    Expect(1, 70112, '\P{Is_Sc=-	SHRD}', "");
    Expect(0, 70112, '\P{^Is_Sc=-	SHRD}', "");
    Error('\p{Script=	_Siddham:=}');
    Error('\P{Script=	_Siddham:=}');
    Expect(1, 71133, '\p{Script=siddham}', "");
    Expect(0, 71133, '\p{^Script=siddham}', "");
    Expect(0, 71133, '\P{Script=siddham}', "");
    Expect(1, 71133, '\P{^Script=siddham}', "");
    Expect(0, 71134, '\p{Script=siddham}', "");
    Expect(1, 71134, '\p{^Script=siddham}', "");
    Expect(1, 71134, '\P{Script=siddham}', "");
    Expect(0, 71134, '\P{^Script=siddham}', "");
    Expect(1, 71133, '\p{Script=- SIDDHAM}', "");
    Expect(0, 71133, '\p{^Script=- SIDDHAM}', "");
    Expect(0, 71133, '\P{Script=- SIDDHAM}', "");
    Expect(1, 71133, '\P{^Script=- SIDDHAM}', "");
    Expect(0, 71134, '\p{Script=- SIDDHAM}', "");
    Expect(1, 71134, '\p{^Script=- SIDDHAM}', "");
    Expect(1, 71134, '\P{Script=- SIDDHAM}', "");
    Expect(0, 71134, '\P{^Script=- SIDDHAM}', "");
    Error('\p{Sc=/a/--Sidd}');
    Error('\P{Sc=/a/--Sidd}');
    Expect(1, 71133, '\p{Sc=sidd}', "");
    Expect(0, 71133, '\p{^Sc=sidd}', "");
    Expect(0, 71133, '\P{Sc=sidd}', "");
    Expect(1, 71133, '\P{^Sc=sidd}', "");
    Expect(0, 71134, '\p{Sc=sidd}', "");
    Expect(1, 71134, '\p{^Sc=sidd}', "");
    Expect(1, 71134, '\P{Sc=sidd}', "");
    Expect(0, 71134, '\P{^Sc=sidd}', "");
    Expect(1, 71133, '\p{Sc=	 sidd}', "");
    Expect(0, 71133, '\p{^Sc=	 sidd}', "");
    Expect(0, 71133, '\P{Sc=	 sidd}', "");
    Expect(1, 71133, '\P{^Sc=	 sidd}', "");
    Expect(0, 71134, '\p{Sc=	 sidd}', "");
    Expect(1, 71134, '\p{^Sc=	 sidd}', "");
    Expect(1, 71134, '\P{Sc=	 sidd}', "");
    Expect(0, 71134, '\P{^Sc=	 sidd}', "");
    Error('\p{Is_Script=/a/SIDDHAM}');
    Error('\P{Is_Script=/a/SIDDHAM}');
    Expect(1, 71133, '\p{Is_Script:siddham}', "");
    Expect(0, 71133, '\p{^Is_Script:siddham}', "");
    Expect(0, 71133, '\P{Is_Script:siddham}', "");
    Expect(1, 71133, '\P{^Is_Script:siddham}', "");
    Expect(0, 71134, '\p{Is_Script:siddham}', "");
    Expect(1, 71134, '\p{^Is_Script:siddham}', "");
    Expect(1, 71134, '\P{Is_Script:siddham}', "");
    Expect(0, 71134, '\P{^Is_Script:siddham}', "");
    Expect(1, 71133, '\p{Is_Script=_ SIDDHAM}', "");
    Expect(0, 71133, '\p{^Is_Script=_ SIDDHAM}', "");
    Expect(0, 71133, '\P{Is_Script=_ SIDDHAM}', "");
    Expect(1, 71133, '\P{^Is_Script=_ SIDDHAM}', "");
    Expect(0, 71134, '\p{Is_Script=_ SIDDHAM}', "");
    Expect(1, 71134, '\p{^Is_Script=_ SIDDHAM}', "");
    Expect(1, 71134, '\P{Is_Script=_ SIDDHAM}', "");
    Expect(0, 71134, '\P{^Is_Script=_ SIDDHAM}', "");
    Error('\p{Is_Sc=/a/ 	Sidd}');
    Error('\P{Is_Sc=/a/ 	Sidd}');
    Expect(1, 71133, '\p{Is_Sc=sidd}', "");
    Expect(0, 71133, '\p{^Is_Sc=sidd}', "");
    Expect(0, 71133, '\P{Is_Sc=sidd}', "");
    Expect(1, 71133, '\P{^Is_Sc=sidd}', "");
    Expect(0, 71134, '\p{Is_Sc=sidd}', "");
    Expect(1, 71134, '\p{^Is_Sc=sidd}', "");
    Expect(1, 71134, '\P{Is_Sc=sidd}', "");
    Expect(0, 71134, '\P{^Is_Sc=sidd}', "");
    Expect(1, 71133, '\p{Is_Sc=Sidd}', "");
    Expect(0, 71133, '\p{^Is_Sc=Sidd}', "");
    Expect(0, 71133, '\P{Is_Sc=Sidd}', "");
    Expect(1, 71133, '\P{^Is_Sc=Sidd}', "");
    Expect(0, 71134, '\p{Is_Sc=Sidd}', "");
    Expect(1, 71134, '\p{^Is_Sc=Sidd}', "");
    Expect(1, 71134, '\P{Is_Sc=Sidd}', "");
    Expect(0, 71134, '\P{^Is_Sc=Sidd}', "");
    Error('\p{Script=-	khudawadi:=}');
    Error('\P{Script=-	khudawadi:=}');
    Expect(1, 70393, '\p{Script=khudawadi}', "");
    Expect(0, 70393, '\p{^Script=khudawadi}', "");
    Expect(0, 70393, '\P{Script=khudawadi}', "");
    Expect(1, 70393, '\P{^Script=khudawadi}', "");
    Expect(0, 70394, '\p{Script=khudawadi}', "");
    Expect(1, 70394, '\p{^Script=khudawadi}', "");
    Expect(1, 70394, '\P{Script=khudawadi}', "");
    Expect(0, 70394, '\P{^Script=khudawadi}', "");
    Expect(1, 70393, '\p{Script=_	KHUDAWADI}', "");
    Expect(0, 70393, '\p{^Script=_	KHUDAWADI}', "");
    Expect(0, 70393, '\P{Script=_	KHUDAWADI}', "");
    Expect(1, 70393, '\P{^Script=_	KHUDAWADI}', "");
    Expect(0, 70394, '\p{Script=_	KHUDAWADI}', "");
    Expect(1, 70394, '\p{^Script=_	KHUDAWADI}', "");
    Expect(1, 70394, '\P{Script=_	KHUDAWADI}', "");
    Expect(0, 70394, '\P{^Script=_	KHUDAWADI}', "");
    Error('\p{Sc: /a/  sind}');
    Error('\P{Sc: /a/  sind}');
    Expect(1, 70393, '\p{Sc=sind}', "");
    Expect(0, 70393, '\p{^Sc=sind}', "");
    Expect(0, 70393, '\P{Sc=sind}', "");
    Expect(1, 70393, '\P{^Sc=sind}', "");
    Expect(0, 70394, '\p{Sc=sind}', "");
    Expect(1, 70394, '\p{^Sc=sind}', "");
    Expect(1, 70394, '\P{Sc=sind}', "");
    Expect(0, 70394, '\P{^Sc=sind}', "");
    Expect(1, 70393, '\p{Sc=_SIND}', "");
    Expect(0, 70393, '\p{^Sc=_SIND}', "");
    Expect(0, 70393, '\P{Sc=_SIND}', "");
    Expect(1, 70393, '\P{^Sc=_SIND}', "");
    Expect(0, 70394, '\p{Sc=_SIND}', "");
    Expect(1, 70394, '\p{^Sc=_SIND}', "");
    Expect(1, 70394, '\P{Sc=_SIND}', "");
    Expect(0, 70394, '\P{^Sc=_SIND}', "");
    Error('\p{Is_Script=:= Khudawadi}');
    Error('\P{Is_Script=:= Khudawadi}');
    Expect(1, 70393, '\p{Is_Script=khudawadi}', "");
    Expect(0, 70393, '\p{^Is_Script=khudawadi}', "");
    Expect(0, 70393, '\P{Is_Script=khudawadi}', "");
    Expect(1, 70393, '\P{^Is_Script=khudawadi}', "");
    Expect(0, 70394, '\p{Is_Script=khudawadi}', "");
    Expect(1, 70394, '\p{^Is_Script=khudawadi}', "");
    Expect(1, 70394, '\P{Is_Script=khudawadi}', "");
    Expect(0, 70394, '\P{^Is_Script=khudawadi}', "");
    Expect(1, 70393, '\p{Is_Script= khudawadi}', "");
    Expect(0, 70393, '\p{^Is_Script= khudawadi}', "");
    Expect(0, 70393, '\P{Is_Script= khudawadi}', "");
    Expect(1, 70393, '\P{^Is_Script= khudawadi}', "");
    Expect(0, 70394, '\p{Is_Script= khudawadi}', "");
    Expect(1, 70394, '\p{^Is_Script= khudawadi}', "");
    Expect(1, 70394, '\P{Is_Script= khudawadi}', "");
    Expect(0, 70394, '\P{^Is_Script= khudawadi}', "");
    Error('\p{Is_Sc=/a/ Sind}');
    Error('\P{Is_Sc=/a/ Sind}');
    Expect(1, 70393, '\p{Is_Sc=sind}', "");
    Expect(0, 70393, '\p{^Is_Sc=sind}', "");
    Expect(0, 70393, '\P{Is_Sc=sind}', "");
    Expect(1, 70393, '\P{^Is_Sc=sind}', "");
    Expect(0, 70394, '\p{Is_Sc=sind}', "");
    Expect(1, 70394, '\p{^Is_Sc=sind}', "");
    Expect(1, 70394, '\P{Is_Sc=sind}', "");
    Expect(0, 70394, '\P{^Is_Sc=sind}', "");
    Expect(1, 70393, '\p{Is_Sc=  Sind}', "");
    Expect(0, 70393, '\p{^Is_Sc=  Sind}', "");
    Expect(0, 70393, '\P{Is_Sc=  Sind}', "");
    Expect(1, 70393, '\P{^Is_Sc=  Sind}', "");
    Expect(0, 70394, '\p{Is_Sc=  Sind}', "");
    Expect(1, 70394, '\p{^Is_Sc=  Sind}', "");
    Expect(1, 70394, '\P{Is_Sc=  Sind}', "");
    Expect(0, 70394, '\P{^Is_Sc=  Sind}', "");
    Error('\p{Script:   - Sinhala/a/}');
    Error('\P{Script:   - Sinhala/a/}');
    Expect(1, 70132, '\p{Script=sinhala}', "");
    Expect(0, 70132, '\p{^Script=sinhala}', "");
    Expect(0, 70132, '\P{Script=sinhala}', "");
    Expect(1, 70132, '\P{^Script=sinhala}', "");
    Expect(0, 70133, '\p{Script=sinhala}', "");
    Expect(1, 70133, '\p{^Script=sinhala}', "");
    Expect(1, 70133, '\P{Script=sinhala}', "");
    Expect(0, 70133, '\P{^Script=sinhala}', "");
    Expect(1, 70132, '\p{Script=_Sinhala}', "");
    Expect(0, 70132, '\p{^Script=_Sinhala}', "");
    Expect(0, 70132, '\P{Script=_Sinhala}', "");
    Expect(1, 70132, '\P{^Script=_Sinhala}', "");
    Expect(0, 70133, '\p{Script=_Sinhala}', "");
    Expect(1, 70133, '\p{^Script=_Sinhala}', "");
    Expect(1, 70133, '\P{Script=_Sinhala}', "");
    Expect(0, 70133, '\P{^Script=_Sinhala}', "");
    Error('\p{Sc=_Sinh/a/}');
    Error('\P{Sc=_Sinh/a/}');
    Expect(1, 70132, '\p{Sc=sinh}', "");
    Expect(0, 70132, '\p{^Sc=sinh}', "");
    Expect(0, 70132, '\P{Sc=sinh}', "");
    Expect(1, 70132, '\P{^Sc=sinh}', "");
    Expect(0, 70133, '\p{Sc=sinh}', "");
    Expect(1, 70133, '\p{^Sc=sinh}', "");
    Expect(1, 70133, '\P{Sc=sinh}', "");
    Expect(0, 70133, '\P{^Sc=sinh}', "");
    Expect(1, 70132, '\p{Sc=	 sinh}', "");
    Expect(0, 70132, '\p{^Sc=	 sinh}', "");
    Expect(0, 70132, '\P{Sc=	 sinh}', "");
    Expect(1, 70132, '\P{^Sc=	 sinh}', "");
    Expect(0, 70133, '\p{Sc=	 sinh}', "");
    Expect(1, 70133, '\p{^Sc=	 sinh}', "");
    Expect(1, 70133, '\P{Sc=	 sinh}', "");
    Expect(0, 70133, '\P{^Sc=	 sinh}', "");
    Error('\p{Is_Script=  sinhala:=}');
    Error('\P{Is_Script=  sinhala:=}');
    Expect(1, 70132, '\p{Is_Script=sinhala}', "");
    Expect(0, 70132, '\p{^Is_Script=sinhala}', "");
    Expect(0, 70132, '\P{Is_Script=sinhala}', "");
    Expect(1, 70132, '\P{^Is_Script=sinhala}', "");
    Expect(0, 70133, '\p{Is_Script=sinhala}', "");
    Expect(1, 70133, '\p{^Is_Script=sinhala}', "");
    Expect(1, 70133, '\P{Is_Script=sinhala}', "");
    Expect(0, 70133, '\P{^Is_Script=sinhala}', "");
    Expect(1, 70132, '\p{Is_Script=		sinhala}', "");
    Expect(0, 70132, '\p{^Is_Script=		sinhala}', "");
    Expect(0, 70132, '\P{Is_Script=		sinhala}', "");
    Expect(1, 70132, '\P{^Is_Script=		sinhala}', "");
    Expect(0, 70133, '\p{Is_Script=		sinhala}', "");
    Expect(1, 70133, '\p{^Is_Script=		sinhala}', "");
    Expect(1, 70133, '\P{Is_Script=		sinhala}', "");
    Expect(0, 70133, '\P{^Is_Script=		sinhala}', "");
    Error('\p{Is_Sc=:= Sinh}');
    Error('\P{Is_Sc=:= Sinh}');
    Expect(1, 70132, '\p{Is_Sc=sinh}', "");
    Expect(0, 70132, '\p{^Is_Sc=sinh}', "");
    Expect(0, 70132, '\P{Is_Sc=sinh}', "");
    Expect(1, 70132, '\P{^Is_Sc=sinh}', "");
    Expect(0, 70133, '\p{Is_Sc=sinh}', "");
    Expect(1, 70133, '\p{^Is_Sc=sinh}', "");
    Expect(1, 70133, '\P{Is_Sc=sinh}', "");
    Expect(0, 70133, '\P{^Is_Sc=sinh}', "");
    Expect(1, 70132, '\p{Is_Sc= 	SINH}', "");
    Expect(0, 70132, '\p{^Is_Sc= 	SINH}', "");
    Expect(0, 70132, '\P{Is_Sc= 	SINH}', "");
    Expect(1, 70132, '\P{^Is_Sc= 	SINH}', "");
    Expect(0, 70133, '\p{Is_Sc= 	SINH}', "");
    Expect(1, 70133, '\p{^Is_Sc= 	SINH}', "");
    Expect(1, 70133, '\P{Is_Sc= 	SINH}', "");
    Expect(0, 70133, '\P{^Is_Sc= 	SINH}', "");
    Error('\p{Script=:=Sora_Sompeng}');
    Error('\P{Script=:=Sora_Sompeng}');
    Expect(1, 69881, '\p{Script=sorasompeng}', "");
    Expect(0, 69881, '\p{^Script=sorasompeng}', "");
    Expect(0, 69881, '\P{Script=sorasompeng}', "");
    Expect(1, 69881, '\P{^Script=sorasompeng}', "");
    Expect(0, 69882, '\p{Script=sorasompeng}', "");
    Expect(1, 69882, '\p{^Script=sorasompeng}', "");
    Expect(1, 69882, '\P{Script=sorasompeng}', "");
    Expect(0, 69882, '\P{^Script=sorasompeng}', "");
    Expect(1, 69881, '\p{Script=_-Sora_Sompeng}', "");
    Expect(0, 69881, '\p{^Script=_-Sora_Sompeng}', "");
    Expect(0, 69881, '\P{Script=_-Sora_Sompeng}', "");
    Expect(1, 69881, '\P{^Script=_-Sora_Sompeng}', "");
    Expect(0, 69882, '\p{Script=_-Sora_Sompeng}', "");
    Expect(1, 69882, '\p{^Script=_-Sora_Sompeng}', "");
    Expect(1, 69882, '\P{Script=_-Sora_Sompeng}', "");
    Expect(0, 69882, '\P{^Script=_-Sora_Sompeng}', "");
    Error('\p{Sc=-/a/SORA}');
    Error('\P{Sc=-/a/SORA}');
    Expect(1, 69881, '\p{Sc: sora}', "");
    Expect(0, 69881, '\p{^Sc: sora}', "");
    Expect(0, 69881, '\P{Sc: sora}', "");
    Expect(1, 69881, '\P{^Sc: sora}', "");
    Expect(0, 69882, '\p{Sc: sora}', "");
    Expect(1, 69882, '\p{^Sc: sora}', "");
    Expect(1, 69882, '\P{Sc: sora}', "");
    Expect(0, 69882, '\P{^Sc: sora}', "");
    Expect(1, 69881, '\p{Sc=_ Sora}', "");
    Expect(0, 69881, '\p{^Sc=_ Sora}', "");
    Expect(0, 69881, '\P{Sc=_ Sora}', "");
    Expect(1, 69881, '\P{^Sc=_ Sora}', "");
    Expect(0, 69882, '\p{Sc=_ Sora}', "");
    Expect(1, 69882, '\p{^Sc=_ Sora}', "");
    Expect(1, 69882, '\P{Sc=_ Sora}', "");
    Expect(0, 69882, '\P{^Sc=_ Sora}', "");
    Error('\p{Is_Script=/a/	_SORA_SOMPENG}');
    Error('\P{Is_Script=/a/	_SORA_SOMPENG}');
    Expect(1, 69881, '\p{Is_Script=sorasompeng}', "");
    Expect(0, 69881, '\p{^Is_Script=sorasompeng}', "");
    Expect(0, 69881, '\P{Is_Script=sorasompeng}', "");
    Expect(1, 69881, '\P{^Is_Script=sorasompeng}', "");
    Expect(0, 69882, '\p{Is_Script=sorasompeng}', "");
    Expect(1, 69882, '\p{^Is_Script=sorasompeng}', "");
    Expect(1, 69882, '\P{Is_Script=sorasompeng}', "");
    Expect(0, 69882, '\P{^Is_Script=sorasompeng}', "");
    Expect(1, 69881, '\p{Is_Script=_Sora_SOMPENG}', "");
    Expect(0, 69881, '\p{^Is_Script=_Sora_SOMPENG}', "");
    Expect(0, 69881, '\P{Is_Script=_Sora_SOMPENG}', "");
    Expect(1, 69881, '\P{^Is_Script=_Sora_SOMPENG}', "");
    Expect(0, 69882, '\p{Is_Script=_Sora_SOMPENG}', "");
    Expect(1, 69882, '\p{^Is_Script=_Sora_SOMPENG}', "");
    Expect(1, 69882, '\P{Is_Script=_Sora_SOMPENG}', "");
    Expect(0, 69882, '\P{^Is_Script=_Sora_SOMPENG}', "");
    Error('\p{Is_Sc=-_SORA:=}');
    Error('\P{Is_Sc=-_SORA:=}');
    Expect(1, 69881, '\p{Is_Sc=sora}', "");
    Expect(0, 69881, '\p{^Is_Sc=sora}', "");
    Expect(0, 69881, '\P{Is_Sc=sora}', "");
    Expect(1, 69881, '\P{^Is_Sc=sora}', "");
    Expect(0, 69882, '\p{Is_Sc=sora}', "");
    Expect(1, 69882, '\p{^Is_Sc=sora}', "");
    Expect(1, 69882, '\P{Is_Sc=sora}', "");
    Expect(0, 69882, '\P{^Is_Sc=sora}', "");
    Expect(1, 69881, '\p{Is_Sc:		sora}', "");
    Expect(0, 69881, '\p{^Is_Sc:		sora}', "");
    Expect(0, 69881, '\P{Is_Sc:		sora}', "");
    Expect(1, 69881, '\P{^Is_Sc:		sora}', "");
    Expect(0, 69882, '\p{Is_Sc:		sora}', "");
    Expect(1, 69882, '\p{^Is_Sc:		sora}', "");
    Expect(1, 69882, '\P{Is_Sc:		sora}', "");
    Expect(0, 69882, '\P{^Is_Sc:		sora}', "");
    Error('\p{Script=-Soyombo/a/}');
    Error('\P{Script=-Soyombo/a/}');
    Expect(1, 72354, '\p{Script=soyombo}', "");
    Expect(0, 72354, '\p{^Script=soyombo}', "");
    Expect(0, 72354, '\P{Script=soyombo}', "");
    Expect(1, 72354, '\P{^Script=soyombo}', "");
    Expect(0, 72355, '\p{Script=soyombo}', "");
    Expect(1, 72355, '\p{^Script=soyombo}', "");
    Expect(1, 72355, '\P{Script=soyombo}', "");
    Expect(0, 72355, '\P{^Script=soyombo}', "");
    Expect(1, 72354, '\p{Script=-Soyombo}', "");
    Expect(0, 72354, '\p{^Script=-Soyombo}', "");
    Expect(0, 72354, '\P{Script=-Soyombo}', "");
    Expect(1, 72354, '\P{^Script=-Soyombo}', "");
    Expect(0, 72355, '\p{Script=-Soyombo}', "");
    Expect(1, 72355, '\p{^Script=-Soyombo}', "");
    Expect(1, 72355, '\P{Script=-Soyombo}', "");
    Expect(0, 72355, '\P{^Script=-Soyombo}', "");
    Error('\p{Sc:/a/SOYO}');
    Error('\P{Sc:/a/SOYO}');
    Expect(1, 72354, '\p{Sc=soyo}', "");
    Expect(0, 72354, '\p{^Sc=soyo}', "");
    Expect(0, 72354, '\P{Sc=soyo}', "");
    Expect(1, 72354, '\P{^Sc=soyo}', "");
    Expect(0, 72355, '\p{Sc=soyo}', "");
    Expect(1, 72355, '\p{^Sc=soyo}', "");
    Expect(1, 72355, '\P{Sc=soyo}', "");
    Expect(0, 72355, '\P{^Sc=soyo}', "");
    Expect(1, 72354, '\p{Sc=		soyo}', "");
    Expect(0, 72354, '\p{^Sc=		soyo}', "");
    Expect(0, 72354, '\P{Sc=		soyo}', "");
    Expect(1, 72354, '\P{^Sc=		soyo}', "");
    Expect(0, 72355, '\p{Sc=		soyo}', "");
    Expect(1, 72355, '\p{^Sc=		soyo}', "");
    Expect(1, 72355, '\P{Sc=		soyo}', "");
    Expect(0, 72355, '\P{^Sc=		soyo}', "");
    Error('\p{Is_Script: -SOYOMBO:=}');
    Error('\P{Is_Script: -SOYOMBO:=}');
    Expect(1, 72354, '\p{Is_Script=soyombo}', "");
    Expect(0, 72354, '\p{^Is_Script=soyombo}', "");
    Expect(0, 72354, '\P{Is_Script=soyombo}', "");
    Expect(1, 72354, '\P{^Is_Script=soyombo}', "");
    Expect(0, 72355, '\p{Is_Script=soyombo}', "");
    Expect(1, 72355, '\p{^Is_Script=soyombo}', "");
    Expect(1, 72355, '\P{Is_Script=soyombo}', "");
    Expect(0, 72355, '\P{^Is_Script=soyombo}', "");
    Expect(1, 72354, '\p{Is_Script:	--SOYOMBO}', "");
    Expect(0, 72354, '\p{^Is_Script:	--SOYOMBO}', "");
    Expect(0, 72354, '\P{Is_Script:	--SOYOMBO}', "");
    Expect(1, 72354, '\P{^Is_Script:	--SOYOMBO}', "");
    Expect(0, 72355, '\p{Is_Script:	--SOYOMBO}', "");
    Expect(1, 72355, '\p{^Is_Script:	--SOYOMBO}', "");
    Expect(1, 72355, '\P{Is_Script:	--SOYOMBO}', "");
    Expect(0, 72355, '\P{^Is_Script:	--SOYOMBO}', "");
    Error('\p{Is_Sc=_SOYO/a/}');
    Error('\P{Is_Sc=_SOYO/a/}');
    Expect(1, 72354, '\p{Is_Sc=soyo}', "");
    Expect(0, 72354, '\p{^Is_Sc=soyo}', "");
    Expect(0, 72354, '\P{Is_Sc=soyo}', "");
    Expect(1, 72354, '\P{^Is_Sc=soyo}', "");
    Expect(0, 72355, '\p{Is_Sc=soyo}', "");
    Expect(1, 72355, '\p{^Is_Sc=soyo}', "");
    Expect(1, 72355, '\P{Is_Sc=soyo}', "");
    Expect(0, 72355, '\P{^Is_Sc=soyo}', "");
    Expect(1, 72354, '\p{Is_Sc=--Soyo}', "");
    Expect(0, 72354, '\p{^Is_Sc=--Soyo}', "");
    Expect(0, 72354, '\P{Is_Sc=--Soyo}', "");
    Expect(1, 72354, '\P{^Is_Sc=--Soyo}', "");
    Expect(0, 72355, '\p{Is_Sc=--Soyo}', "");
    Expect(1, 72355, '\p{^Is_Sc=--Soyo}', "");
    Expect(1, 72355, '\P{Is_Sc=--Soyo}', "");
    Expect(0, 72355, '\P{^Is_Sc=--Soyo}', "");
    Error('\p{Script=-_SUNDANESE/a/}');
    Error('\P{Script=-_SUNDANESE/a/}');
    Expect(1, 7367, '\p{Script=sundanese}', "");
    Expect(0, 7367, '\p{^Script=sundanese}', "");
    Expect(0, 7367, '\P{Script=sundanese}', "");
    Expect(1, 7367, '\P{^Script=sundanese}', "");
    Expect(0, 7368, '\p{Script=sundanese}', "");
    Expect(1, 7368, '\p{^Script=sundanese}', "");
    Expect(1, 7368, '\P{Script=sundanese}', "");
    Expect(0, 7368, '\P{^Script=sundanese}', "");
    Expect(1, 7367, '\p{Script= 	Sundanese}', "");
    Expect(0, 7367, '\p{^Script= 	Sundanese}', "");
    Expect(0, 7367, '\P{Script= 	Sundanese}', "");
    Expect(1, 7367, '\P{^Script= 	Sundanese}', "");
    Expect(0, 7368, '\p{Script= 	Sundanese}', "");
    Expect(1, 7368, '\p{^Script= 	Sundanese}', "");
    Expect(1, 7368, '\P{Script= 	Sundanese}', "");
    Expect(0, 7368, '\P{^Script= 	Sundanese}', "");
    Error('\p{Sc=_-sund/a/}');
    Error('\P{Sc=_-sund/a/}');
    Expect(1, 7367, '\p{Sc=sund}', "");
    Expect(0, 7367, '\p{^Sc=sund}', "");
    Expect(0, 7367, '\P{Sc=sund}', "");
    Expect(1, 7367, '\P{^Sc=sund}', "");
    Expect(0, 7368, '\p{Sc=sund}', "");
    Expect(1, 7368, '\p{^Sc=sund}', "");
    Expect(1, 7368, '\P{Sc=sund}', "");
    Expect(0, 7368, '\P{^Sc=sund}', "");
    Expect(1, 7367, '\p{Sc= _sund}', "");
    Expect(0, 7367, '\p{^Sc= _sund}', "");
    Expect(0, 7367, '\P{Sc= _sund}', "");
    Expect(1, 7367, '\P{^Sc= _sund}', "");
    Expect(0, 7368, '\p{Sc= _sund}', "");
    Expect(1, 7368, '\p{^Sc= _sund}', "");
    Expect(1, 7368, '\P{Sc= _sund}', "");
    Expect(0, 7368, '\P{^Sc= _sund}', "");
    Error('\p{Is_Script=:=	_SUNDANESE}');
    Error('\P{Is_Script=:=	_SUNDANESE}');
    Expect(1, 7367, '\p{Is_Script=sundanese}', "");
    Expect(0, 7367, '\p{^Is_Script=sundanese}', "");
    Expect(0, 7367, '\P{Is_Script=sundanese}', "");
    Expect(1, 7367, '\P{^Is_Script=sundanese}', "");
    Expect(0, 7368, '\p{Is_Script=sundanese}', "");
    Expect(1, 7368, '\p{^Is_Script=sundanese}', "");
    Expect(1, 7368, '\P{Is_Script=sundanese}', "");
    Expect(0, 7368, '\P{^Is_Script=sundanese}', "");
    Expect(1, 7367, '\p{Is_Script= 	sundanese}', "");
    Expect(0, 7367, '\p{^Is_Script= 	sundanese}', "");
    Expect(0, 7367, '\P{Is_Script= 	sundanese}', "");
    Expect(1, 7367, '\P{^Is_Script= 	sundanese}', "");
    Expect(0, 7368, '\p{Is_Script= 	sundanese}', "");
    Expect(1, 7368, '\p{^Is_Script= 	sundanese}', "");
    Expect(1, 7368, '\P{Is_Script= 	sundanese}', "");
    Expect(0, 7368, '\P{^Is_Script= 	sundanese}', "");
    Error('\p{Is_Sc=_sund:=}');
    Error('\P{Is_Sc=_sund:=}');
    Expect(1, 7367, '\p{Is_Sc:sund}', "");
    Expect(0, 7367, '\p{^Is_Sc:sund}', "");
    Expect(0, 7367, '\P{Is_Sc:sund}', "");
    Expect(1, 7367, '\P{^Is_Sc:sund}', "");
    Expect(0, 7368, '\p{Is_Sc:sund}', "");
    Expect(1, 7368, '\p{^Is_Sc:sund}', "");
    Expect(1, 7368, '\P{Is_Sc:sund}', "");
    Expect(0, 7368, '\P{^Is_Sc:sund}', "");
    Expect(1, 7367, '\p{Is_Sc: -Sund}', "");
    Expect(0, 7367, '\p{^Is_Sc: -Sund}', "");
    Expect(0, 7367, '\P{Is_Sc: -Sund}', "");
    Expect(1, 7367, '\P{^Is_Sc: -Sund}', "");
    Expect(0, 7368, '\p{Is_Sc: -Sund}', "");
    Expect(1, 7368, '\p{^Is_Sc: -Sund}', "");
    Expect(1, 7368, '\P{Is_Sc: -Sund}', "");
    Expect(0, 7368, '\P{^Is_Sc: -Sund}', "");
    Error('\p{Script=/a/	syloti_Nagri}');
    Error('\P{Script=/a/	syloti_Nagri}');
    Expect(1, 43051, '\p{Script:sylotinagri}', "");
    Expect(0, 43051, '\p{^Script:sylotinagri}', "");
    Expect(0, 43051, '\P{Script:sylotinagri}', "");
    Expect(1, 43051, '\P{^Script:sylotinagri}', "");
    Expect(0, 43052, '\p{Script:sylotinagri}', "");
    Expect(1, 43052, '\p{^Script:sylotinagri}', "");
    Expect(1, 43052, '\P{Script:sylotinagri}', "");
    Expect(0, 43052, '\P{^Script:sylotinagri}', "");
    Expect(1, 43051, '\p{Script: _	syloti_nagri}', "");
    Expect(0, 43051, '\p{^Script: _	syloti_nagri}', "");
    Expect(0, 43051, '\P{Script: _	syloti_nagri}', "");
    Expect(1, 43051, '\P{^Script: _	syloti_nagri}', "");
    Expect(0, 43052, '\p{Script: _	syloti_nagri}', "");
    Expect(1, 43052, '\p{^Script: _	syloti_nagri}', "");
    Expect(1, 43052, '\P{Script: _	syloti_nagri}', "");
    Expect(0, 43052, '\P{^Script: _	syloti_nagri}', "");
    Error('\p{Sc=/a/- sylo}');
    Error('\P{Sc=/a/- sylo}');
    Expect(1, 43051, '\p{Sc=sylo}', "");
    Expect(0, 43051, '\p{^Sc=sylo}', "");
    Expect(0, 43051, '\P{Sc=sylo}', "");
    Expect(1, 43051, '\P{^Sc=sylo}', "");
    Expect(0, 43052, '\p{Sc=sylo}', "");
    Expect(1, 43052, '\p{^Sc=sylo}', "");
    Expect(1, 43052, '\P{Sc=sylo}', "");
    Expect(0, 43052, '\P{^Sc=sylo}', "");
    Expect(1, 43051, '\p{Sc=	-Sylo}', "");
    Expect(0, 43051, '\p{^Sc=	-Sylo}', "");
    Expect(0, 43051, '\P{Sc=	-Sylo}', "");
    Expect(1, 43051, '\P{^Sc=	-Sylo}', "");
    Expect(0, 43052, '\p{Sc=	-Sylo}', "");
    Expect(1, 43052, '\p{^Sc=	-Sylo}', "");
    Expect(1, 43052, '\P{Sc=	-Sylo}', "");
    Expect(0, 43052, '\P{^Sc=	-Sylo}', "");
    Error('\p{Is_Script=:=-SYLOTI_Nagri}');
    Error('\P{Is_Script=:=-SYLOTI_Nagri}');
    Expect(1, 43051, '\p{Is_Script=sylotinagri}', "");
    Expect(0, 43051, '\p{^Is_Script=sylotinagri}', "");
    Expect(0, 43051, '\P{Is_Script=sylotinagri}', "");
    Expect(1, 43051, '\P{^Is_Script=sylotinagri}', "");
    Expect(0, 43052, '\p{Is_Script=sylotinagri}', "");
    Expect(1, 43052, '\p{^Is_Script=sylotinagri}', "");
    Expect(1, 43052, '\P{Is_Script=sylotinagri}', "");
    Expect(0, 43052, '\P{^Is_Script=sylotinagri}', "");
    Expect(1, 43051, '\p{Is_Script=		Syloti_nagri}', "");
    Expect(0, 43051, '\p{^Is_Script=		Syloti_nagri}', "");
    Expect(0, 43051, '\P{Is_Script=		Syloti_nagri}', "");
    Expect(1, 43051, '\P{^Is_Script=		Syloti_nagri}', "");
    Expect(0, 43052, '\p{Is_Script=		Syloti_nagri}', "");
    Expect(1, 43052, '\p{^Is_Script=		Syloti_nagri}', "");
    Expect(1, 43052, '\P{Is_Script=		Syloti_nagri}', "");
    Expect(0, 43052, '\P{^Is_Script=		Syloti_nagri}', "");
    Error('\p{Is_Sc: -SYLO/a/}');
    Error('\P{Is_Sc: -SYLO/a/}');
    Expect(1, 43051, '\p{Is_Sc:	sylo}', "");
    Expect(0, 43051, '\p{^Is_Sc:	sylo}', "");
    Expect(0, 43051, '\P{Is_Sc:	sylo}', "");
    Expect(1, 43051, '\P{^Is_Sc:	sylo}', "");
    Expect(0, 43052, '\p{Is_Sc:	sylo}', "");
    Expect(1, 43052, '\p{^Is_Sc:	sylo}', "");
    Expect(1, 43052, '\P{Is_Sc:	sylo}', "");
    Expect(0, 43052, '\P{^Is_Sc:	sylo}', "");
    Expect(1, 43051, '\p{Is_Sc:_-Sylo}', "");
    Expect(0, 43051, '\p{^Is_Sc:_-Sylo}', "");
    Expect(0, 43051, '\P{Is_Sc:_-Sylo}', "");
    Expect(1, 43051, '\P{^Is_Sc:_-Sylo}', "");
    Expect(0, 43052, '\p{Is_Sc:_-Sylo}', "");
    Expect(1, 43052, '\p{^Is_Sc:_-Sylo}', "");
    Expect(1, 43052, '\P{Is_Sc:_-Sylo}', "");
    Expect(0, 43052, '\P{^Is_Sc:_-Sylo}', "");
    Error('\p{Script=-Syriac:=}');
    Error('\P{Script=-Syriac:=}');
    Expect(1, 2154, '\p{Script=syriac}', "");
    Expect(0, 2154, '\p{^Script=syriac}', "");
    Expect(0, 2154, '\P{Script=syriac}', "");
    Expect(1, 2154, '\P{^Script=syriac}', "");
    Expect(0, 2155, '\p{Script=syriac}', "");
    Expect(1, 2155, '\p{^Script=syriac}', "");
    Expect(1, 2155, '\P{Script=syriac}', "");
    Expect(0, 2155, '\P{^Script=syriac}', "");
    Expect(1, 2154, '\p{Script=-Syriac}', "");
    Expect(0, 2154, '\p{^Script=-Syriac}', "");
    Expect(0, 2154, '\P{Script=-Syriac}', "");
    Expect(1, 2154, '\P{^Script=-Syriac}', "");
    Expect(0, 2155, '\p{Script=-Syriac}', "");
    Expect(1, 2155, '\p{^Script=-Syriac}', "");
    Expect(1, 2155, '\P{Script=-Syriac}', "");
    Expect(0, 2155, '\P{^Script=-Syriac}', "");
    Error('\p{Sc=_ Syrc:=}');
    Error('\P{Sc=_ Syrc:=}');
    Expect(1, 2154, '\p{Sc=syrc}', "");
    Expect(0, 2154, '\p{^Sc=syrc}', "");
    Expect(0, 2154, '\P{Sc=syrc}', "");
    Expect(1, 2154, '\P{^Sc=syrc}', "");
    Expect(0, 2155, '\p{Sc=syrc}', "");
    Expect(1, 2155, '\p{^Sc=syrc}', "");
    Expect(1, 2155, '\P{Sc=syrc}', "");
    Expect(0, 2155, '\P{^Sc=syrc}', "");
    Expect(1, 2154, '\p{Sc=-_SYRC}', "");
    Expect(0, 2154, '\p{^Sc=-_SYRC}', "");
    Expect(0, 2154, '\P{Sc=-_SYRC}', "");
    Expect(1, 2154, '\P{^Sc=-_SYRC}', "");
    Expect(0, 2155, '\p{Sc=-_SYRC}', "");
    Expect(1, 2155, '\p{^Sc=-_SYRC}', "");
    Expect(1, 2155, '\P{Sc=-_SYRC}', "");
    Expect(0, 2155, '\P{^Sc=-_SYRC}', "");
    Error('\p{Is_Script=:=- Syriac}');
    Error('\P{Is_Script=:=- Syriac}');
    Expect(1, 2154, '\p{Is_Script=syriac}', "");
    Expect(0, 2154, '\p{^Is_Script=syriac}', "");
    Expect(0, 2154, '\P{Is_Script=syriac}', "");
    Expect(1, 2154, '\P{^Is_Script=syriac}', "");
    Expect(0, 2155, '\p{Is_Script=syriac}', "");
    Expect(1, 2155, '\p{^Is_Script=syriac}', "");
    Expect(1, 2155, '\P{Is_Script=syriac}', "");
    Expect(0, 2155, '\P{^Is_Script=syriac}', "");
    Expect(1, 2154, '\p{Is_Script:_	syriac}', "");
    Expect(0, 2154, '\p{^Is_Script:_	syriac}', "");
    Expect(0, 2154, '\P{Is_Script:_	syriac}', "");
    Expect(1, 2154, '\P{^Is_Script:_	syriac}', "");
    Expect(0, 2155, '\p{Is_Script:_	syriac}', "");
    Expect(1, 2155, '\p{^Is_Script:_	syriac}', "");
    Expect(1, 2155, '\P{Is_Script:_	syriac}', "");
    Expect(0, 2155, '\P{^Is_Script:_	syriac}', "");
    Error('\p{Is_Sc=:= _syrc}');
    Error('\P{Is_Sc=:= _syrc}');
    Expect(1, 2154, '\p{Is_Sc=syrc}', "");
    Expect(0, 2154, '\p{^Is_Sc=syrc}', "");
    Expect(0, 2154, '\P{Is_Sc=syrc}', "");
    Expect(1, 2154, '\P{^Is_Sc=syrc}', "");
    Expect(0, 2155, '\p{Is_Sc=syrc}', "");
    Expect(1, 2155, '\p{^Is_Sc=syrc}', "");
    Expect(1, 2155, '\P{Is_Sc=syrc}', "");
    Expect(0, 2155, '\P{^Is_Sc=syrc}', "");
    Expect(1, 2154, '\p{Is_Sc=--Syrc}', "");
    Expect(0, 2154, '\p{^Is_Sc=--Syrc}', "");
    Expect(0, 2154, '\P{Is_Sc=--Syrc}', "");
    Expect(1, 2154, '\P{^Is_Sc=--Syrc}', "");
    Expect(0, 2155, '\p{Is_Sc=--Syrc}', "");
    Expect(1, 2155, '\p{^Is_Sc=--Syrc}', "");
    Expect(1, 2155, '\P{Is_Sc=--Syrc}', "");
    Expect(0, 2155, '\P{^Is_Sc=--Syrc}', "");
    Error('\p{Script=:=	_Tagbanwa}');
    Error('\P{Script=:=	_Tagbanwa}');
    Expect(1, 6003, '\p{Script=tagbanwa}', "");
    Expect(0, 6003, '\p{^Script=tagbanwa}', "");
    Expect(0, 6003, '\P{Script=tagbanwa}', "");
    Expect(1, 6003, '\P{^Script=tagbanwa}', "");
    Expect(0, 6004, '\p{Script=tagbanwa}', "");
    Expect(1, 6004, '\p{^Script=tagbanwa}', "");
    Expect(1, 6004, '\P{Script=tagbanwa}', "");
    Expect(0, 6004, '\P{^Script=tagbanwa}', "");
    Expect(1, 6003, '\p{Script=_TAGBANWA}', "");
    Expect(0, 6003, '\p{^Script=_TAGBANWA}', "");
    Expect(0, 6003, '\P{Script=_TAGBANWA}', "");
    Expect(1, 6003, '\P{^Script=_TAGBANWA}', "");
    Expect(0, 6004, '\p{Script=_TAGBANWA}', "");
    Expect(1, 6004, '\p{^Script=_TAGBANWA}', "");
    Expect(1, 6004, '\P{Script=_TAGBANWA}', "");
    Expect(0, 6004, '\P{^Script=_TAGBANWA}', "");
    Error('\p{Sc=/a/-Tagb}');
    Error('\P{Sc=/a/-Tagb}');
    Expect(1, 6003, '\p{Sc=tagb}', "");
    Expect(0, 6003, '\p{^Sc=tagb}', "");
    Expect(0, 6003, '\P{Sc=tagb}', "");
    Expect(1, 6003, '\P{^Sc=tagb}', "");
    Expect(0, 6004, '\p{Sc=tagb}', "");
    Expect(1, 6004, '\p{^Sc=tagb}', "");
    Expect(1, 6004, '\P{Sc=tagb}', "");
    Expect(0, 6004, '\P{^Sc=tagb}', "");
    Expect(1, 6003, '\p{Sc= -Tagb}', "");
    Expect(0, 6003, '\p{^Sc= -Tagb}', "");
    Expect(0, 6003, '\P{Sc= -Tagb}', "");
    Expect(1, 6003, '\P{^Sc= -Tagb}', "");
    Expect(0, 6004, '\p{Sc= -Tagb}', "");
    Expect(1, 6004, '\p{^Sc= -Tagb}', "");
    Expect(1, 6004, '\P{Sc= -Tagb}', "");
    Expect(0, 6004, '\P{^Sc= -Tagb}', "");
    Error('\p{Is_Script=/a/ _TAGBANWA}');
    Error('\P{Is_Script=/a/ _TAGBANWA}');
    Expect(1, 6003, '\p{Is_Script=tagbanwa}', "");
    Expect(0, 6003, '\p{^Is_Script=tagbanwa}', "");
    Expect(0, 6003, '\P{Is_Script=tagbanwa}', "");
    Expect(1, 6003, '\P{^Is_Script=tagbanwa}', "");
    Expect(0, 6004, '\p{Is_Script=tagbanwa}', "");
    Expect(1, 6004, '\p{^Is_Script=tagbanwa}', "");
    Expect(1, 6004, '\P{Is_Script=tagbanwa}', "");
    Expect(0, 6004, '\P{^Is_Script=tagbanwa}', "");
    Expect(1, 6003, '\p{Is_Script=	-tagbanwa}', "");
    Expect(0, 6003, '\p{^Is_Script=	-tagbanwa}', "");
    Expect(0, 6003, '\P{Is_Script=	-tagbanwa}', "");
    Expect(1, 6003, '\P{^Is_Script=	-tagbanwa}', "");
    Expect(0, 6004, '\p{Is_Script=	-tagbanwa}', "");
    Expect(1, 6004, '\p{^Is_Script=	-tagbanwa}', "");
    Expect(1, 6004, '\P{Is_Script=	-tagbanwa}', "");
    Expect(0, 6004, '\P{^Is_Script=	-tagbanwa}', "");
    Error('\p{Is_Sc: 		TAGB:=}');
    Error('\P{Is_Sc: 		TAGB:=}');
    Expect(1, 6003, '\p{Is_Sc=tagb}', "");
    Expect(0, 6003, '\p{^Is_Sc=tagb}', "");
    Expect(0, 6003, '\P{Is_Sc=tagb}', "");
    Expect(1, 6003, '\P{^Is_Sc=tagb}', "");
    Expect(0, 6004, '\p{Is_Sc=tagb}', "");
    Expect(1, 6004, '\p{^Is_Sc=tagb}', "");
    Expect(1, 6004, '\P{Is_Sc=tagb}', "");
    Expect(0, 6004, '\P{^Is_Sc=tagb}', "");
    Expect(1, 6003, '\p{Is_Sc=-_TAGB}', "");
    Expect(0, 6003, '\p{^Is_Sc=-_TAGB}', "");
    Expect(0, 6003, '\P{Is_Sc=-_TAGB}', "");
    Expect(1, 6003, '\P{^Is_Sc=-_TAGB}', "");
    Expect(0, 6004, '\p{Is_Sc=-_TAGB}', "");
    Expect(1, 6004, '\p{^Is_Sc=-_TAGB}', "");
    Expect(1, 6004, '\P{Is_Sc=-_TAGB}', "");
    Expect(0, 6004, '\P{^Is_Sc=-_TAGB}', "");
    Error('\p{Script=/a/TAKRI}');
    Error('\P{Script=/a/TAKRI}');
    Expect(1, 71369, '\p{Script=takri}', "");
    Expect(0, 71369, '\p{^Script=takri}', "");
    Expect(0, 71369, '\P{Script=takri}', "");
    Expect(1, 71369, '\P{^Script=takri}', "");
    Expect(0, 71370, '\p{Script=takri}', "");
    Expect(1, 71370, '\p{^Script=takri}', "");
    Expect(1, 71370, '\P{Script=takri}', "");
    Expect(0, 71370, '\P{^Script=takri}', "");
    Expect(1, 71369, '\p{Script:	--takri}', "");
    Expect(0, 71369, '\p{^Script:	--takri}', "");
    Expect(0, 71369, '\P{Script:	--takri}', "");
    Expect(1, 71369, '\P{^Script:	--takri}', "");
    Expect(0, 71370, '\p{Script:	--takri}', "");
    Expect(1, 71370, '\p{^Script:	--takri}', "");
    Expect(1, 71370, '\P{Script:	--takri}', "");
    Expect(0, 71370, '\P{^Script:	--takri}', "");
    Error('\p{Sc=/a/  TAKR}');
    Error('\P{Sc=/a/  TAKR}');
    Expect(1, 71369, '\p{Sc=takr}', "");
    Expect(0, 71369, '\p{^Sc=takr}', "");
    Expect(0, 71369, '\P{Sc=takr}', "");
    Expect(1, 71369, '\P{^Sc=takr}', "");
    Expect(0, 71370, '\p{Sc=takr}', "");
    Expect(1, 71370, '\p{^Sc=takr}', "");
    Expect(1, 71370, '\P{Sc=takr}', "");
    Expect(0, 71370, '\P{^Sc=takr}', "");
    Expect(1, 71369, '\p{Sc=-takr}', "");
    Expect(0, 71369, '\p{^Sc=-takr}', "");
    Expect(0, 71369, '\P{Sc=-takr}', "");
    Expect(1, 71369, '\P{^Sc=-takr}', "");
    Expect(0, 71370, '\p{Sc=-takr}', "");
    Expect(1, 71370, '\p{^Sc=-takr}', "");
    Expect(1, 71370, '\P{Sc=-takr}', "");
    Expect(0, 71370, '\P{^Sc=-takr}', "");
    Error('\p{Is_Script= :=TAKRI}');
    Error('\P{Is_Script= :=TAKRI}');
    Expect(1, 71369, '\p{Is_Script=takri}', "");
    Expect(0, 71369, '\p{^Is_Script=takri}', "");
    Expect(0, 71369, '\P{Is_Script=takri}', "");
    Expect(1, 71369, '\P{^Is_Script=takri}', "");
    Expect(0, 71370, '\p{Is_Script=takri}', "");
    Expect(1, 71370, '\p{^Is_Script=takri}', "");
    Expect(1, 71370, '\P{Is_Script=takri}', "");
    Expect(0, 71370, '\P{^Is_Script=takri}', "");
    Expect(1, 71369, '\p{Is_Script=  Takri}', "");
    Expect(0, 71369, '\p{^Is_Script=  Takri}', "");
    Expect(0, 71369, '\P{Is_Script=  Takri}', "");
    Expect(1, 71369, '\P{^Is_Script=  Takri}', "");
    Expect(0, 71370, '\p{Is_Script=  Takri}', "");
    Expect(1, 71370, '\p{^Is_Script=  Takri}', "");
    Expect(1, 71370, '\P{Is_Script=  Takri}', "");
    Expect(0, 71370, '\P{^Is_Script=  Takri}', "");
    Error('\p{Is_Sc=	/a/TAKR}');
    Error('\P{Is_Sc=	/a/TAKR}');
    Expect(1, 71369, '\p{Is_Sc=takr}', "");
    Expect(0, 71369, '\p{^Is_Sc=takr}', "");
    Expect(0, 71369, '\P{Is_Sc=takr}', "");
    Expect(1, 71369, '\P{^Is_Sc=takr}', "");
    Expect(0, 71370, '\p{Is_Sc=takr}', "");
    Expect(1, 71370, '\p{^Is_Sc=takr}', "");
    Expect(1, 71370, '\P{Is_Sc=takr}', "");
    Expect(0, 71370, '\P{^Is_Sc=takr}', "");
    Expect(1, 71369, '\p{Is_Sc=__TAKR}', "");
    Expect(0, 71369, '\p{^Is_Sc=__TAKR}', "");
    Expect(0, 71369, '\P{Is_Sc=__TAKR}', "");
    Expect(1, 71369, '\P{^Is_Sc=__TAKR}', "");
    Expect(0, 71370, '\p{Is_Sc=__TAKR}', "");
    Expect(1, 71370, '\p{^Is_Sc=__TAKR}', "");
    Expect(1, 71370, '\P{Is_Sc=__TAKR}', "");
    Expect(0, 71370, '\P{^Is_Sc=__TAKR}', "");
    Error('\p{Script=	 Tai_Le:=}');
    Error('\P{Script=	 Tai_Le:=}');
    Expect(1, 6516, '\p{Script=taile}', "");
    Expect(0, 6516, '\p{^Script=taile}', "");
    Expect(0, 6516, '\P{Script=taile}', "");
    Expect(1, 6516, '\P{^Script=taile}', "");
    Expect(0, 6517, '\p{Script=taile}', "");
    Expect(1, 6517, '\p{^Script=taile}', "");
    Expect(1, 6517, '\P{Script=taile}', "");
    Expect(0, 6517, '\P{^Script=taile}', "");
    Expect(1, 6516, '\p{Script=--Tai_LE}', "");
    Expect(0, 6516, '\p{^Script=--Tai_LE}', "");
    Expect(0, 6516, '\P{Script=--Tai_LE}', "");
    Expect(1, 6516, '\P{^Script=--Tai_LE}', "");
    Expect(0, 6517, '\p{Script=--Tai_LE}', "");
    Expect(1, 6517, '\p{^Script=--Tai_LE}', "");
    Expect(1, 6517, '\P{Script=--Tai_LE}', "");
    Expect(0, 6517, '\P{^Script=--Tai_LE}', "");
    Error('\p{Sc=/a/-_tale}');
    Error('\P{Sc=/a/-_tale}');
    Expect(1, 6516, '\p{Sc=tale}', "");
    Expect(0, 6516, '\p{^Sc=tale}', "");
    Expect(0, 6516, '\P{Sc=tale}', "");
    Expect(1, 6516, '\P{^Sc=tale}', "");
    Expect(0, 6517, '\p{Sc=tale}', "");
    Expect(1, 6517, '\p{^Sc=tale}', "");
    Expect(1, 6517, '\P{Sc=tale}', "");
    Expect(0, 6517, '\P{^Sc=tale}', "");
    Expect(1, 6516, '\p{Sc=_	Tale}', "");
    Expect(0, 6516, '\p{^Sc=_	Tale}', "");
    Expect(0, 6516, '\P{Sc=_	Tale}', "");
    Expect(1, 6516, '\P{^Sc=_	Tale}', "");
    Expect(0, 6517, '\p{Sc=_	Tale}', "");
    Expect(1, 6517, '\p{^Sc=_	Tale}', "");
    Expect(1, 6517, '\P{Sc=_	Tale}', "");
    Expect(0, 6517, '\P{^Sc=_	Tale}', "");
    Error('\p{Is_Script= _Tai_Le/a/}');
    Error('\P{Is_Script= _Tai_Le/a/}');
    Expect(1, 6516, '\p{Is_Script=taile}', "");
    Expect(0, 6516, '\p{^Is_Script=taile}', "");
    Expect(0, 6516, '\P{Is_Script=taile}', "");
    Expect(1, 6516, '\P{^Is_Script=taile}', "");
    Expect(0, 6517, '\p{Is_Script=taile}', "");
    Expect(1, 6517, '\p{^Is_Script=taile}', "");
    Expect(1, 6517, '\P{Is_Script=taile}', "");
    Expect(0, 6517, '\P{^Is_Script=taile}', "");
    Expect(1, 6516, '\p{Is_Script=	Tai_Le}', "");
    Expect(0, 6516, '\p{^Is_Script=	Tai_Le}', "");
    Expect(0, 6516, '\P{Is_Script=	Tai_Le}', "");
    Expect(1, 6516, '\P{^Is_Script=	Tai_Le}', "");
    Expect(0, 6517, '\p{Is_Script=	Tai_Le}', "");
    Expect(1, 6517, '\p{^Is_Script=	Tai_Le}', "");
    Expect(1, 6517, '\P{Is_Script=	Tai_Le}', "");
    Expect(0, 6517, '\P{^Is_Script=	Tai_Le}', "");
    Error('\p{Is_Sc=TALE:=}');
    Error('\P{Is_Sc=TALE:=}');
    Expect(1, 6516, '\p{Is_Sc=tale}', "");
    Expect(0, 6516, '\p{^Is_Sc=tale}', "");
    Expect(0, 6516, '\P{Is_Sc=tale}', "");
    Expect(1, 6516, '\P{^Is_Sc=tale}', "");
    Expect(0, 6517, '\p{Is_Sc=tale}', "");
    Expect(1, 6517, '\p{^Is_Sc=tale}', "");
    Expect(1, 6517, '\P{Is_Sc=tale}', "");
    Expect(0, 6517, '\P{^Is_Sc=tale}', "");
    Expect(1, 6516, '\p{Is_Sc=	_Tale}', "");
    Expect(0, 6516, '\p{^Is_Sc=	_Tale}', "");
    Expect(0, 6516, '\P{Is_Sc=	_Tale}', "");
    Expect(1, 6516, '\P{^Is_Sc=	_Tale}', "");
    Expect(0, 6517, '\p{Is_Sc=	_Tale}', "");
    Expect(1, 6517, '\p{^Is_Sc=	_Tale}', "");
    Expect(1, 6517, '\P{Is_Sc=	_Tale}', "");
    Expect(0, 6517, '\P{^Is_Sc=	_Tale}', "");
    Error('\p{Script=/a/New_TAI_lue}');
    Error('\P{Script=/a/New_TAI_lue}');
    Expect(1, 6623, '\p{Script=newtailue}', "");
    Expect(0, 6623, '\p{^Script=newtailue}', "");
    Expect(0, 6623, '\P{Script=newtailue}', "");
    Expect(1, 6623, '\P{^Script=newtailue}', "");
    Expect(0, 6624, '\p{Script=newtailue}', "");
    Expect(1, 6624, '\p{^Script=newtailue}', "");
    Expect(1, 6624, '\P{Script=newtailue}', "");
    Expect(0, 6624, '\P{^Script=newtailue}', "");
    Expect(1, 6623, '\p{Script= _New_Tai_Lue}', "");
    Expect(0, 6623, '\p{^Script= _New_Tai_Lue}', "");
    Expect(0, 6623, '\P{Script= _New_Tai_Lue}', "");
    Expect(1, 6623, '\P{^Script= _New_Tai_Lue}', "");
    Expect(0, 6624, '\p{Script= _New_Tai_Lue}', "");
    Expect(1, 6624, '\p{^Script= _New_Tai_Lue}', "");
    Expect(1, 6624, '\P{Script= _New_Tai_Lue}', "");
    Expect(0, 6624, '\P{^Script= _New_Tai_Lue}', "");
    Error('\p{Sc=:=	Talu}');
    Error('\P{Sc=:=	Talu}');
    Expect(1, 6623, '\p{Sc=talu}', "");
    Expect(0, 6623, '\p{^Sc=talu}', "");
    Expect(0, 6623, '\P{Sc=talu}', "");
    Expect(1, 6623, '\P{^Sc=talu}', "");
    Expect(0, 6624, '\p{Sc=talu}', "");
    Expect(1, 6624, '\p{^Sc=talu}', "");
    Expect(1, 6624, '\P{Sc=talu}', "");
    Expect(0, 6624, '\P{^Sc=talu}', "");
    Expect(1, 6623, '\p{Sc= _Talu}', "");
    Expect(0, 6623, '\p{^Sc= _Talu}', "");
    Expect(0, 6623, '\P{Sc= _Talu}', "");
    Expect(1, 6623, '\P{^Sc= _Talu}', "");
    Expect(0, 6624, '\p{Sc= _Talu}', "");
    Expect(1, 6624, '\p{^Sc= _Talu}', "");
    Expect(1, 6624, '\P{Sc= _Talu}', "");
    Expect(0, 6624, '\P{^Sc= _Talu}', "");
    Error('\p{Is_Script= New_Tai_lue:=}');
    Error('\P{Is_Script= New_Tai_lue:=}');
    Expect(1, 6623, '\p{Is_Script=newtailue}', "");
    Expect(0, 6623, '\p{^Is_Script=newtailue}', "");
    Expect(0, 6623, '\P{Is_Script=newtailue}', "");
    Expect(1, 6623, '\P{^Is_Script=newtailue}', "");
    Expect(0, 6624, '\p{Is_Script=newtailue}', "");
    Expect(1, 6624, '\p{^Is_Script=newtailue}', "");
    Expect(1, 6624, '\P{Is_Script=newtailue}', "");
    Expect(0, 6624, '\P{^Is_Script=newtailue}', "");
    Expect(1, 6623, '\p{Is_Script= NEW_tai_LUE}', "");
    Expect(0, 6623, '\p{^Is_Script= NEW_tai_LUE}', "");
    Expect(0, 6623, '\P{Is_Script= NEW_tai_LUE}', "");
    Expect(1, 6623, '\P{^Is_Script= NEW_tai_LUE}', "");
    Expect(0, 6624, '\p{Is_Script= NEW_tai_LUE}', "");
    Expect(1, 6624, '\p{^Is_Script= NEW_tai_LUE}', "");
    Expect(1, 6624, '\P{Is_Script= NEW_tai_LUE}', "");
    Expect(0, 6624, '\P{^Is_Script= NEW_tai_LUE}', "");
    Error('\p{Is_Sc=-TALU/a/}');
    Error('\P{Is_Sc=-TALU/a/}');
    Expect(1, 6623, '\p{Is_Sc=talu}', "");
    Expect(0, 6623, '\p{^Is_Sc=talu}', "");
    Expect(0, 6623, '\P{Is_Sc=talu}', "");
    Expect(1, 6623, '\P{^Is_Sc=talu}', "");
    Expect(0, 6624, '\p{Is_Sc=talu}', "");
    Expect(1, 6624, '\p{^Is_Sc=talu}', "");
    Expect(1, 6624, '\P{Is_Sc=talu}', "");
    Expect(0, 6624, '\P{^Is_Sc=talu}', "");
    Expect(1, 6623, '\p{Is_Sc=- Talu}', "");
    Expect(0, 6623, '\p{^Is_Sc=- Talu}', "");
    Expect(0, 6623, '\P{Is_Sc=- Talu}', "");
    Expect(1, 6623, '\P{^Is_Sc=- Talu}', "");
    Expect(0, 6624, '\p{Is_Sc=- Talu}', "");
    Expect(1, 6624, '\p{^Is_Sc=- Talu}', "");
    Expect(1, 6624, '\P{Is_Sc=- Talu}', "");
    Expect(0, 6624, '\P{^Is_Sc=- Talu}', "");
    Error('\p{Script=/a/Tamil}');
    Error('\P{Script=/a/Tamil}');
    Expect(1, 3066, '\p{Script=tamil}', "");
    Expect(0, 3066, '\p{^Script=tamil}', "");
    Expect(0, 3066, '\P{Script=tamil}', "");
    Expect(1, 3066, '\P{^Script=tamil}', "");
    Expect(0, 3067, '\p{Script=tamil}', "");
    Expect(1, 3067, '\p{^Script=tamil}', "");
    Expect(1, 3067, '\P{Script=tamil}', "");
    Expect(0, 3067, '\P{^Script=tamil}', "");
    Expect(1, 3066, '\p{Script= 	tamil}', "");
    Expect(0, 3066, '\p{^Script= 	tamil}', "");
    Expect(0, 3066, '\P{Script= 	tamil}', "");
    Expect(1, 3066, '\P{^Script= 	tamil}', "");
    Expect(0, 3067, '\p{Script= 	tamil}', "");
    Expect(1, 3067, '\p{^Script= 	tamil}', "");
    Expect(1, 3067, '\P{Script= 	tamil}', "");
    Expect(0, 3067, '\P{^Script= 	tamil}', "");
    Error('\p{Sc= _taml:=}');
    Error('\P{Sc= _taml:=}');
    Expect(1, 3066, '\p{Sc=taml}', "");
    Expect(0, 3066, '\p{^Sc=taml}', "");
    Expect(0, 3066, '\P{Sc=taml}', "");
    Expect(1, 3066, '\P{^Sc=taml}', "");
    Expect(0, 3067, '\p{Sc=taml}', "");
    Expect(1, 3067, '\p{^Sc=taml}', "");
    Expect(1, 3067, '\P{Sc=taml}', "");
    Expect(0, 3067, '\P{^Sc=taml}', "");
    Expect(1, 3066, '\p{Sc=_	TAML}', "");
    Expect(0, 3066, '\p{^Sc=_	TAML}', "");
    Expect(0, 3066, '\P{Sc=_	TAML}', "");
    Expect(1, 3066, '\P{^Sc=_	TAML}', "");
    Expect(0, 3067, '\p{Sc=_	TAML}', "");
    Expect(1, 3067, '\p{^Sc=_	TAML}', "");
    Expect(1, 3067, '\P{Sc=_	TAML}', "");
    Expect(0, 3067, '\P{^Sc=_	TAML}', "");
    Error('\p{Is_Script=/a/ -Tamil}');
    Error('\P{Is_Script=/a/ -Tamil}');
    Expect(1, 3066, '\p{Is_Script=tamil}', "");
    Expect(0, 3066, '\p{^Is_Script=tamil}', "");
    Expect(0, 3066, '\P{Is_Script=tamil}', "");
    Expect(1, 3066, '\P{^Is_Script=tamil}', "");
    Expect(0, 3067, '\p{Is_Script=tamil}', "");
    Expect(1, 3067, '\p{^Is_Script=tamil}', "");
    Expect(1, 3067, '\P{Is_Script=tamil}', "");
    Expect(0, 3067, '\P{^Is_Script=tamil}', "");
    Expect(1, 3066, '\p{Is_Script= _Tamil}', "");
    Expect(0, 3066, '\p{^Is_Script= _Tamil}', "");
    Expect(0, 3066, '\P{Is_Script= _Tamil}', "");
    Expect(1, 3066, '\P{^Is_Script= _Tamil}', "");
    Expect(0, 3067, '\p{Is_Script= _Tamil}', "");
    Expect(1, 3067, '\p{^Is_Script= _Tamil}', "");
    Expect(1, 3067, '\P{Is_Script= _Tamil}', "");
    Expect(0, 3067, '\P{^Is_Script= _Tamil}', "");
    Error('\p{Is_Sc=/a/-TAML}');
    Error('\P{Is_Sc=/a/-TAML}');
    Expect(1, 3066, '\p{Is_Sc:taml}', "");
    Expect(0, 3066, '\p{^Is_Sc:taml}', "");
    Expect(0, 3066, '\P{Is_Sc:taml}', "");
    Expect(1, 3066, '\P{^Is_Sc:taml}', "");
    Expect(0, 3067, '\p{Is_Sc:taml}', "");
    Expect(1, 3067, '\p{^Is_Sc:taml}', "");
    Expect(1, 3067, '\P{Is_Sc:taml}', "");
    Expect(0, 3067, '\P{^Is_Sc:taml}', "");
    Expect(1, 3066, '\p{Is_Sc=-Taml}', "");
    Expect(0, 3066, '\p{^Is_Sc=-Taml}', "");
    Expect(0, 3066, '\P{Is_Sc=-Taml}', "");
    Expect(1, 3066, '\P{^Is_Sc=-Taml}', "");
    Expect(0, 3067, '\p{Is_Sc=-Taml}', "");
    Expect(1, 3067, '\p{^Is_Sc=-Taml}', "");
    Expect(1, 3067, '\P{Is_Sc=-Taml}', "");
    Expect(0, 3067, '\P{^Is_Sc=-Taml}', "");
    Error('\p{Script=_/a/Tangut}');
    Error('\P{Script=_/a/Tangut}');
    Expect(1, 101106, '\p{Script=tangut}', "");
    Expect(0, 101106, '\p{^Script=tangut}', "");
    Expect(0, 101106, '\P{Script=tangut}', "");
    Expect(1, 101106, '\P{^Script=tangut}', "");
    Expect(0, 101107, '\p{Script=tangut}', "");
    Expect(1, 101107, '\p{^Script=tangut}', "");
    Expect(1, 101107, '\P{Script=tangut}', "");
    Expect(0, 101107, '\P{^Script=tangut}', "");
    Expect(1, 101106, '\p{Script= _Tangut}', "");
    Expect(0, 101106, '\p{^Script= _Tangut}', "");
    Expect(0, 101106, '\P{Script= _Tangut}', "");
    Expect(1, 101106, '\P{^Script= _Tangut}', "");
    Expect(0, 101107, '\p{Script= _Tangut}', "");
    Expect(1, 101107, '\p{^Script= _Tangut}', "");
    Expect(1, 101107, '\P{Script= _Tangut}', "");
    Expect(0, 101107, '\P{^Script= _Tangut}', "");
    Error('\p{Sc= _Tang/a/}');
    Error('\P{Sc= _Tang/a/}');
    Expect(1, 101106, '\p{Sc=tang}', "");
    Expect(0, 101106, '\p{^Sc=tang}', "");
    Expect(0, 101106, '\P{Sc=tang}', "");
    Expect(1, 101106, '\P{^Sc=tang}', "");
    Expect(0, 101107, '\p{Sc=tang}', "");
    Expect(1, 101107, '\p{^Sc=tang}', "");
    Expect(1, 101107, '\P{Sc=tang}', "");
    Expect(0, 101107, '\P{^Sc=tang}', "");
    Expect(1, 101106, '\p{Sc=- TANG}', "");
    Expect(0, 101106, '\p{^Sc=- TANG}', "");
    Expect(0, 101106, '\P{Sc=- TANG}', "");
    Expect(1, 101106, '\P{^Sc=- TANG}', "");
    Expect(0, 101107, '\p{Sc=- TANG}', "");
    Expect(1, 101107, '\p{^Sc=- TANG}', "");
    Expect(1, 101107, '\P{Sc=- TANG}', "");
    Expect(0, 101107, '\P{^Sc=- TANG}', "");
    Error('\p{Is_Script:Tangut:=}');
    Error('\P{Is_Script:Tangut:=}');
    Expect(1, 101106, '\p{Is_Script=tangut}', "");
    Expect(0, 101106, '\p{^Is_Script=tangut}', "");
    Expect(0, 101106, '\P{Is_Script=tangut}', "");
    Expect(1, 101106, '\P{^Is_Script=tangut}', "");
    Expect(0, 101107, '\p{Is_Script=tangut}', "");
    Expect(1, 101107, '\p{^Is_Script=tangut}', "");
    Expect(1, 101107, '\P{Is_Script=tangut}', "");
    Expect(0, 101107, '\P{^Is_Script=tangut}', "");
    Expect(1, 101106, '\p{Is_Script=_TANGUT}', "");
    Expect(0, 101106, '\p{^Is_Script=_TANGUT}', "");
    Expect(0, 101106, '\P{Is_Script=_TANGUT}', "");
    Expect(1, 101106, '\P{^Is_Script=_TANGUT}', "");
    Expect(0, 101107, '\p{Is_Script=_TANGUT}', "");
    Expect(1, 101107, '\p{^Is_Script=_TANGUT}', "");
    Expect(1, 101107, '\P{Is_Script=_TANGUT}', "");
    Expect(0, 101107, '\P{^Is_Script=_TANGUT}', "");
    Error('\p{Is_Sc=_-Tang/a/}');
    Error('\P{Is_Sc=_-Tang/a/}');
    Expect(1, 101106, '\p{Is_Sc=tang}', "");
    Expect(0, 101106, '\p{^Is_Sc=tang}', "");
    Expect(0, 101106, '\P{Is_Sc=tang}', "");
    Expect(1, 101106, '\P{^Is_Sc=tang}', "");
    Expect(0, 101107, '\p{Is_Sc=tang}', "");
    Expect(1, 101107, '\p{^Is_Sc=tang}', "");
    Expect(1, 101107, '\P{Is_Sc=tang}', "");
    Expect(0, 101107, '\P{^Is_Sc=tang}', "");
    Expect(1, 101106, '\p{Is_Sc=--tang}', "");
    Expect(0, 101106, '\p{^Is_Sc=--tang}', "");
    Expect(0, 101106, '\P{Is_Sc=--tang}', "");
    Expect(1, 101106, '\P{^Is_Sc=--tang}', "");
    Expect(0, 101107, '\p{Is_Sc=--tang}', "");
    Expect(1, 101107, '\p{^Is_Sc=--tang}', "");
    Expect(1, 101107, '\P{Is_Sc=--tang}', "");
    Expect(0, 101107, '\P{^Is_Sc=--tang}', "");
    Error('\p{Script=_TAI_viet/a/}');
    Error('\P{Script=_TAI_viet/a/}');
    Expect(1, 43743, '\p{Script=taiviet}', "");
    Expect(0, 43743, '\p{^Script=taiviet}', "");
    Expect(0, 43743, '\P{Script=taiviet}', "");
    Expect(1, 43743, '\P{^Script=taiviet}', "");
    Expect(0, 43744, '\p{Script=taiviet}', "");
    Expect(1, 43744, '\p{^Script=taiviet}', "");
    Expect(1, 43744, '\P{Script=taiviet}', "");
    Expect(0, 43744, '\P{^Script=taiviet}', "");
    Expect(1, 43743, '\p{Script=	Tai_Viet}', "");
    Expect(0, 43743, '\p{^Script=	Tai_Viet}', "");
    Expect(0, 43743, '\P{Script=	Tai_Viet}', "");
    Expect(1, 43743, '\P{^Script=	Tai_Viet}', "");
    Expect(0, 43744, '\p{Script=	Tai_Viet}', "");
    Expect(1, 43744, '\p{^Script=	Tai_Viet}', "");
    Expect(1, 43744, '\P{Script=	Tai_Viet}', "");
    Expect(0, 43744, '\P{^Script=	Tai_Viet}', "");
    Error('\p{Sc= _tavt/a/}');
    Error('\P{Sc= _tavt/a/}');
    Expect(1, 43743, '\p{Sc=tavt}', "");
    Expect(0, 43743, '\p{^Sc=tavt}', "");
    Expect(0, 43743, '\P{Sc=tavt}', "");
    Expect(1, 43743, '\P{^Sc=tavt}', "");
    Expect(0, 43744, '\p{Sc=tavt}', "");
    Expect(1, 43744, '\p{^Sc=tavt}', "");
    Expect(1, 43744, '\P{Sc=tavt}', "");
    Expect(0, 43744, '\P{^Sc=tavt}', "");
    Expect(1, 43743, '\p{Sc=  tavt}', "");
    Expect(0, 43743, '\p{^Sc=  tavt}', "");
    Expect(0, 43743, '\P{Sc=  tavt}', "");
    Expect(1, 43743, '\P{^Sc=  tavt}', "");
    Expect(0, 43744, '\p{Sc=  tavt}', "");
    Expect(1, 43744, '\p{^Sc=  tavt}', "");
    Expect(1, 43744, '\P{Sc=  tavt}', "");
    Expect(0, 43744, '\P{^Sc=  tavt}', "");
    Error('\p{Is_Script= /a/Tai_VIET}');
    Error('\P{Is_Script= /a/Tai_VIET}');
    Expect(1, 43743, '\p{Is_Script=taiviet}', "");
    Expect(0, 43743, '\p{^Is_Script=taiviet}', "");
    Expect(0, 43743, '\P{Is_Script=taiviet}', "");
    Expect(1, 43743, '\P{^Is_Script=taiviet}', "");
    Expect(0, 43744, '\p{Is_Script=taiviet}', "");
    Expect(1, 43744, '\p{^Is_Script=taiviet}', "");
    Expect(1, 43744, '\P{Is_Script=taiviet}', "");
    Expect(0, 43744, '\P{^Is_Script=taiviet}', "");
    Expect(1, 43743, '\p{Is_Script= -TAI_VIET}', "");
    Expect(0, 43743, '\p{^Is_Script= -TAI_VIET}', "");
    Expect(0, 43743, '\P{Is_Script= -TAI_VIET}', "");
    Expect(1, 43743, '\P{^Is_Script= -TAI_VIET}', "");
    Expect(0, 43744, '\p{Is_Script= -TAI_VIET}', "");
    Expect(1, 43744, '\p{^Is_Script= -TAI_VIET}', "");
    Expect(1, 43744, '\P{Is_Script= -TAI_VIET}', "");
    Expect(0, 43744, '\P{^Is_Script= -TAI_VIET}', "");
    Error('\p{Is_Sc=/a/tavt}');
    Error('\P{Is_Sc=/a/tavt}');
    Expect(1, 43743, '\p{Is_Sc=tavt}', "");
    Expect(0, 43743, '\p{^Is_Sc=tavt}', "");
    Expect(0, 43743, '\P{Is_Sc=tavt}', "");
    Expect(1, 43743, '\P{^Is_Sc=tavt}', "");
    Expect(0, 43744, '\p{Is_Sc=tavt}', "");
    Expect(1, 43744, '\p{^Is_Sc=tavt}', "");
    Expect(1, 43744, '\P{Is_Sc=tavt}', "");
    Expect(0, 43744, '\P{^Is_Sc=tavt}', "");
    Expect(1, 43743, '\p{Is_Sc=	-tavt}', "");
    Expect(0, 43743, '\p{^Is_Sc=	-tavt}', "");
    Expect(0, 43743, '\P{Is_Sc=	-tavt}', "");
    Expect(1, 43743, '\P{^Is_Sc=	-tavt}', "");
    Expect(0, 43744, '\p{Is_Sc=	-tavt}', "");
    Expect(1, 43744, '\p{^Is_Sc=	-tavt}', "");
    Expect(1, 43744, '\P{Is_Sc=	-tavt}', "");
    Expect(0, 43744, '\P{^Is_Sc=	-tavt}', "");
    Error('\p{Script=-telugu/a/}');
    Error('\P{Script=-telugu/a/}');
    Expect(1, 3199, '\p{Script=telugu}', "");
    Expect(0, 3199, '\p{^Script=telugu}', "");
    Expect(0, 3199, '\P{Script=telugu}', "");
    Expect(1, 3199, '\P{^Script=telugu}', "");
    Expect(0, 3200, '\p{Script=telugu}', "");
    Expect(1, 3200, '\p{^Script=telugu}', "");
    Expect(1, 3200, '\P{Script=telugu}', "");
    Expect(0, 3200, '\P{^Script=telugu}', "");
    Expect(1, 3199, '\p{Script=-_TELUGU}', "");
    Expect(0, 3199, '\p{^Script=-_TELUGU}', "");
    Expect(0, 3199, '\P{Script=-_TELUGU}', "");
    Expect(1, 3199, '\P{^Script=-_TELUGU}', "");
    Expect(0, 3200, '\p{Script=-_TELUGU}', "");
    Expect(1, 3200, '\p{^Script=-_TELUGU}', "");
    Expect(1, 3200, '\P{Script=-_TELUGU}', "");
    Expect(0, 3200, '\P{^Script=-_TELUGU}', "");
    Error('\p{Sc=:=-TELU}');
    Error('\P{Sc=:=-TELU}');
    Expect(1, 3199, '\p{Sc=telu}', "");
    Expect(0, 3199, '\p{^Sc=telu}', "");
    Expect(0, 3199, '\P{Sc=telu}', "");
    Expect(1, 3199, '\P{^Sc=telu}', "");
    Expect(0, 3200, '\p{Sc=telu}', "");
    Expect(1, 3200, '\p{^Sc=telu}', "");
    Expect(1, 3200, '\P{Sc=telu}', "");
    Expect(0, 3200, '\P{^Sc=telu}', "");
    Expect(1, 3199, '\p{Sc=_Telu}', "");
    Expect(0, 3199, '\p{^Sc=_Telu}', "");
    Expect(0, 3199, '\P{Sc=_Telu}', "");
    Expect(1, 3199, '\P{^Sc=_Telu}', "");
    Expect(0, 3200, '\p{Sc=_Telu}', "");
    Expect(1, 3200, '\p{^Sc=_Telu}', "");
    Expect(1, 3200, '\P{Sc=_Telu}', "");
    Expect(0, 3200, '\P{^Sc=_Telu}', "");
    Error('\p{Is_Script=-:=Telugu}');
    Error('\P{Is_Script=-:=Telugu}');
    Expect(1, 3199, '\p{Is_Script:telugu}', "");
    Expect(0, 3199, '\p{^Is_Script:telugu}', "");
    Expect(0, 3199, '\P{Is_Script:telugu}', "");
    Expect(1, 3199, '\P{^Is_Script:telugu}', "");
    Expect(0, 3200, '\p{Is_Script:telugu}', "");
    Expect(1, 3200, '\p{^Is_Script:telugu}', "");
    Expect(1, 3200, '\P{Is_Script:telugu}', "");
    Expect(0, 3200, '\P{^Is_Script:telugu}', "");
    Expect(1, 3199, '\p{Is_Script=  telugu}', "");
    Expect(0, 3199, '\p{^Is_Script=  telugu}', "");
    Expect(0, 3199, '\P{Is_Script=  telugu}', "");
    Expect(1, 3199, '\P{^Is_Script=  telugu}', "");
    Expect(0, 3200, '\p{Is_Script=  telugu}', "");
    Expect(1, 3200, '\p{^Is_Script=  telugu}', "");
    Expect(1, 3200, '\P{Is_Script=  telugu}', "");
    Expect(0, 3200, '\P{^Is_Script=  telugu}', "");
    Error('\p{Is_Sc=:=_	telu}');
    Error('\P{Is_Sc=:=_	telu}');
    Expect(1, 3199, '\p{Is_Sc=telu}', "");
    Expect(0, 3199, '\p{^Is_Sc=telu}', "");
    Expect(0, 3199, '\P{Is_Sc=telu}', "");
    Expect(1, 3199, '\P{^Is_Sc=telu}', "");
    Expect(0, 3200, '\p{Is_Sc=telu}', "");
    Expect(1, 3200, '\p{^Is_Sc=telu}', "");
    Expect(1, 3200, '\P{Is_Sc=telu}', "");
    Expect(0, 3200, '\P{^Is_Sc=telu}', "");
    Expect(1, 3199, '\p{Is_Sc=-_Telu}', "");
    Expect(0, 3199, '\p{^Is_Sc=-_Telu}', "");
    Expect(0, 3199, '\P{Is_Sc=-_Telu}', "");
    Expect(1, 3199, '\P{^Is_Sc=-_Telu}', "");
    Expect(0, 3200, '\p{Is_Sc=-_Telu}', "");
    Expect(1, 3200, '\p{^Is_Sc=-_Telu}', "");
    Expect(1, 3200, '\P{Is_Sc=-_Telu}', "");
    Expect(0, 3200, '\P{^Is_Sc=-_Telu}', "");
    Error('\p{Script=:=	Tifinagh}');
    Error('\P{Script=:=	Tifinagh}');
    Expect(1, 11647, '\p{Script=tifinagh}', "");
    Expect(0, 11647, '\p{^Script=tifinagh}', "");
    Expect(0, 11647, '\P{Script=tifinagh}', "");
    Expect(1, 11647, '\P{^Script=tifinagh}', "");
    Expect(0, 11648, '\p{Script=tifinagh}', "");
    Expect(1, 11648, '\p{^Script=tifinagh}', "");
    Expect(1, 11648, '\P{Script=tifinagh}', "");
    Expect(0, 11648, '\P{^Script=tifinagh}', "");
    Expect(1, 11647, '\p{Script=	TIFINAGH}', "");
    Expect(0, 11647, '\p{^Script=	TIFINAGH}', "");
    Expect(0, 11647, '\P{Script=	TIFINAGH}', "");
    Expect(1, 11647, '\P{^Script=	TIFINAGH}', "");
    Expect(0, 11648, '\p{Script=	TIFINAGH}', "");
    Expect(1, 11648, '\p{^Script=	TIFINAGH}', "");
    Expect(1, 11648, '\P{Script=	TIFINAGH}', "");
    Expect(0, 11648, '\P{^Script=	TIFINAGH}', "");
    Error('\p{Sc= :=Tfng}');
    Error('\P{Sc= :=Tfng}');
    Expect(1, 11647, '\p{Sc=tfng}', "");
    Expect(0, 11647, '\p{^Sc=tfng}', "");
    Expect(0, 11647, '\P{Sc=tfng}', "");
    Expect(1, 11647, '\P{^Sc=tfng}', "");
    Expect(0, 11648, '\p{Sc=tfng}', "");
    Expect(1, 11648, '\p{^Sc=tfng}', "");
    Expect(1, 11648, '\P{Sc=tfng}', "");
    Expect(0, 11648, '\P{^Sc=tfng}', "");
    Expect(1, 11647, '\p{Sc=  tfng}', "");
    Expect(0, 11647, '\p{^Sc=  tfng}', "");
    Expect(0, 11647, '\P{Sc=  tfng}', "");
    Expect(1, 11647, '\P{^Sc=  tfng}', "");
    Expect(0, 11648, '\p{Sc=  tfng}', "");
    Expect(1, 11648, '\p{^Sc=  tfng}', "");
    Expect(1, 11648, '\P{Sc=  tfng}', "");
    Expect(0, 11648, '\P{^Sc=  tfng}', "");
    Error('\p{Is_Script=-	Tifinagh:=}');
    Error('\P{Is_Script=-	Tifinagh:=}');
    Expect(1, 11647, '\p{Is_Script=tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Script=tifinagh}', "");
    Expect(0, 11647, '\P{Is_Script=tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Script=tifinagh}', "");
    Expect(0, 11648, '\p{Is_Script=tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Script=tifinagh}', "");
    Expect(1, 11648, '\P{Is_Script=tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Script=tifinagh}', "");
    Expect(1, 11647, '\p{Is_Script=-Tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Script=-Tifinagh}', "");
    Expect(0, 11647, '\P{Is_Script=-Tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Script=-Tifinagh}', "");
    Expect(0, 11648, '\p{Is_Script=-Tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Script=-Tifinagh}', "");
    Expect(1, 11648, '\P{Is_Script=-Tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Script=-Tifinagh}', "");
    Error('\p{Is_Sc=_:=Tfng}');
    Error('\P{Is_Sc=_:=Tfng}');
    Expect(1, 11647, '\p{Is_Sc=tfng}', "");
    Expect(0, 11647, '\p{^Is_Sc=tfng}', "");
    Expect(0, 11647, '\P{Is_Sc=tfng}', "");
    Expect(1, 11647, '\P{^Is_Sc=tfng}', "");
    Expect(0, 11648, '\p{Is_Sc=tfng}', "");
    Expect(1, 11648, '\p{^Is_Sc=tfng}', "");
    Expect(1, 11648, '\P{Is_Sc=tfng}', "");
    Expect(0, 11648, '\P{^Is_Sc=tfng}', "");
    Expect(1, 11647, '\p{Is_Sc:	-TFNG}', "");
    Expect(0, 11647, '\p{^Is_Sc:	-TFNG}', "");
    Expect(0, 11647, '\P{Is_Sc:	-TFNG}', "");
    Expect(1, 11647, '\P{^Is_Sc:	-TFNG}', "");
    Expect(0, 11648, '\p{Is_Sc:	-TFNG}', "");
    Expect(1, 11648, '\p{^Is_Sc:	-TFNG}', "");
    Expect(1, 11648, '\P{Is_Sc:	-TFNG}', "");
    Expect(0, 11648, '\P{^Is_Sc:	-TFNG}', "");
    Error('\p{Script=:=_TAGALOG}');
    Error('\P{Script=:=_TAGALOG}');
    Expect(1, 5908, '\p{Script=tagalog}', "");
    Expect(0, 5908, '\p{^Script=tagalog}', "");
    Expect(0, 5908, '\P{Script=tagalog}', "");
    Expect(1, 5908, '\P{^Script=tagalog}', "");
    Expect(0, 5909, '\p{Script=tagalog}', "");
    Expect(1, 5909, '\p{^Script=tagalog}', "");
    Expect(1, 5909, '\P{Script=tagalog}', "");
    Expect(0, 5909, '\P{^Script=tagalog}', "");
    Expect(1, 5908, '\p{Script=	_tagalog}', "");
    Expect(0, 5908, '\p{^Script=	_tagalog}', "");
    Expect(0, 5908, '\P{Script=	_tagalog}', "");
    Expect(1, 5908, '\P{^Script=	_tagalog}', "");
    Expect(0, 5909, '\p{Script=	_tagalog}', "");
    Expect(1, 5909, '\p{^Script=	_tagalog}', "");
    Expect(1, 5909, '\P{Script=	_tagalog}', "");
    Expect(0, 5909, '\P{^Script=	_tagalog}', "");
    Error('\p{Sc=/a/ tglg}');
    Error('\P{Sc=/a/ tglg}');
    Expect(1, 5908, '\p{Sc=tglg}', "");
    Expect(0, 5908, '\p{^Sc=tglg}', "");
    Expect(0, 5908, '\P{Sc=tglg}', "");
    Expect(1, 5908, '\P{^Sc=tglg}', "");
    Expect(0, 5909, '\p{Sc=tglg}', "");
    Expect(1, 5909, '\p{^Sc=tglg}', "");
    Expect(1, 5909, '\P{Sc=tglg}', "");
    Expect(0, 5909, '\P{^Sc=tglg}', "");
    Expect(1, 5908, '\p{Sc=-tglg}', "");
    Expect(0, 5908, '\p{^Sc=-tglg}', "");
    Expect(0, 5908, '\P{Sc=-tglg}', "");
    Expect(1, 5908, '\P{^Sc=-tglg}', "");
    Expect(0, 5909, '\p{Sc=-tglg}', "");
    Expect(1, 5909, '\p{^Sc=-tglg}', "");
    Expect(1, 5909, '\P{Sc=-tglg}', "");
    Expect(0, 5909, '\P{^Sc=-tglg}', "");
    Error('\p{Is_Script=:=Tagalog}');
    Error('\P{Is_Script=:=Tagalog}');
    Expect(1, 5908, '\p{Is_Script=tagalog}', "");
    Expect(0, 5908, '\p{^Is_Script=tagalog}', "");
    Expect(0, 5908, '\P{Is_Script=tagalog}', "");
    Expect(1, 5908, '\P{^Is_Script=tagalog}', "");
    Expect(0, 5909, '\p{Is_Script=tagalog}', "");
    Expect(1, 5909, '\p{^Is_Script=tagalog}', "");
    Expect(1, 5909, '\P{Is_Script=tagalog}', "");
    Expect(0, 5909, '\P{^Is_Script=tagalog}', "");
    Expect(1, 5908, '\p{Is_Script=_	tagalog}', "");
    Expect(0, 5908, '\p{^Is_Script=_	tagalog}', "");
    Expect(0, 5908, '\P{Is_Script=_	tagalog}', "");
    Expect(1, 5908, '\P{^Is_Script=_	tagalog}', "");
    Expect(0, 5909, '\p{Is_Script=_	tagalog}', "");
    Expect(1, 5909, '\p{^Is_Script=_	tagalog}', "");
    Expect(1, 5909, '\P{Is_Script=_	tagalog}', "");
    Expect(0, 5909, '\P{^Is_Script=_	tagalog}', "");
    Error('\p{Is_Sc=/a/ TGLG}');
    Error('\P{Is_Sc=/a/ TGLG}');
    Expect(1, 5908, '\p{Is_Sc=tglg}', "");
    Expect(0, 5908, '\p{^Is_Sc=tglg}', "");
    Expect(0, 5908, '\P{Is_Sc=tglg}', "");
    Expect(1, 5908, '\P{^Is_Sc=tglg}', "");
    Expect(0, 5909, '\p{Is_Sc=tglg}', "");
    Expect(1, 5909, '\p{^Is_Sc=tglg}', "");
    Expect(1, 5909, '\P{Is_Sc=tglg}', "");
    Expect(0, 5909, '\P{^Is_Sc=tglg}', "");
    Expect(1, 5908, '\p{Is_Sc=-Tglg}', "");
    Expect(0, 5908, '\p{^Is_Sc=-Tglg}', "");
    Expect(0, 5908, '\P{Is_Sc=-Tglg}', "");
    Expect(1, 5908, '\P{^Is_Sc=-Tglg}', "");
    Expect(0, 5909, '\p{Is_Sc=-Tglg}', "");
    Expect(1, 5909, '\p{^Is_Sc=-Tglg}', "");
    Expect(1, 5909, '\P{Is_Sc=-Tglg}', "");
    Expect(0, 5909, '\P{^Is_Sc=-Tglg}', "");
    Error('\p{Script=:=-thaana}');
    Error('\P{Script=:=-thaana}');
    Expect(1, 1969, '\p{Script=thaana}', "");
    Expect(0, 1969, '\p{^Script=thaana}', "");
    Expect(0, 1969, '\P{Script=thaana}', "");
    Expect(1, 1969, '\P{^Script=thaana}', "");
    Expect(0, 1970, '\p{Script=thaana}', "");
    Expect(1, 1970, '\p{^Script=thaana}', "");
    Expect(1, 1970, '\P{Script=thaana}', "");
    Expect(0, 1970, '\P{^Script=thaana}', "");
    Expect(1, 1969, '\p{Script:  _THAANA}', "");
    Expect(0, 1969, '\p{^Script:  _THAANA}', "");
    Expect(0, 1969, '\P{Script:  _THAANA}', "");
    Expect(1, 1969, '\P{^Script:  _THAANA}', "");
    Expect(0, 1970, '\p{Script:  _THAANA}', "");
    Expect(1, 1970, '\p{^Script:  _THAANA}', "");
    Expect(1, 1970, '\P{Script:  _THAANA}', "");
    Expect(0, 1970, '\P{^Script:  _THAANA}', "");
    Error('\p{Sc=  thaa:=}');
    Error('\P{Sc=  thaa:=}');
    Expect(1, 1969, '\p{Sc=thaa}', "");
    Expect(0, 1969, '\p{^Sc=thaa}', "");
    Expect(0, 1969, '\P{Sc=thaa}', "");
    Expect(1, 1969, '\P{^Sc=thaa}', "");
    Expect(0, 1970, '\p{Sc=thaa}', "");
    Expect(1, 1970, '\p{^Sc=thaa}', "");
    Expect(1, 1970, '\P{Sc=thaa}', "");
    Expect(0, 1970, '\P{^Sc=thaa}', "");
    Expect(1, 1969, '\p{Sc=_	thaa}', "");
    Expect(0, 1969, '\p{^Sc=_	thaa}', "");
    Expect(0, 1969, '\P{Sc=_	thaa}', "");
    Expect(1, 1969, '\P{^Sc=_	thaa}', "");
    Expect(0, 1970, '\p{Sc=_	thaa}', "");
    Expect(1, 1970, '\p{^Sc=_	thaa}', "");
    Expect(1, 1970, '\P{Sc=_	thaa}', "");
    Expect(0, 1970, '\P{^Sc=_	thaa}', "");
    Error('\p{Is_Script= :=THAANA}');
    Error('\P{Is_Script= :=THAANA}');
    Expect(1, 1969, '\p{Is_Script=thaana}', "");
    Expect(0, 1969, '\p{^Is_Script=thaana}', "");
    Expect(0, 1969, '\P{Is_Script=thaana}', "");
    Expect(1, 1969, '\P{^Is_Script=thaana}', "");
    Expect(0, 1970, '\p{Is_Script=thaana}', "");
    Expect(1, 1970, '\p{^Is_Script=thaana}', "");
    Expect(1, 1970, '\P{Is_Script=thaana}', "");
    Expect(0, 1970, '\P{^Is_Script=thaana}', "");
    Expect(1, 1969, '\p{Is_Script=	Thaana}', "");
    Expect(0, 1969, '\p{^Is_Script=	Thaana}', "");
    Expect(0, 1969, '\P{Is_Script=	Thaana}', "");
    Expect(1, 1969, '\P{^Is_Script=	Thaana}', "");
    Expect(0, 1970, '\p{Is_Script=	Thaana}', "");
    Expect(1, 1970, '\p{^Is_Script=	Thaana}', "");
    Expect(1, 1970, '\P{Is_Script=	Thaana}', "");
    Expect(0, 1970, '\P{^Is_Script=	Thaana}', "");
    Error('\p{Is_Sc=/a/ _Thaa}');
    Error('\P{Is_Sc=/a/ _Thaa}');
    Expect(1, 1969, '\p{Is_Sc=thaa}', "");
    Expect(0, 1969, '\p{^Is_Sc=thaa}', "");
    Expect(0, 1969, '\P{Is_Sc=thaa}', "");
    Expect(1, 1969, '\P{^Is_Sc=thaa}', "");
    Expect(0, 1970, '\p{Is_Sc=thaa}', "");
    Expect(1, 1970, '\p{^Is_Sc=thaa}', "");
    Expect(1, 1970, '\P{Is_Sc=thaa}', "");
    Expect(0, 1970, '\P{^Is_Sc=thaa}', "");
    Expect(1, 1969, '\p{Is_Sc= 	Thaa}', "");
    Expect(0, 1969, '\p{^Is_Sc= 	Thaa}', "");
    Expect(0, 1969, '\P{Is_Sc= 	Thaa}', "");
    Expect(1, 1969, '\P{^Is_Sc= 	Thaa}', "");
    Expect(0, 1970, '\p{Is_Sc= 	Thaa}', "");
    Expect(1, 1970, '\p{^Is_Sc= 	Thaa}', "");
    Expect(1, 1970, '\P{Is_Sc= 	Thaa}', "");
    Expect(0, 1970, '\P{^Is_Sc= 	Thaa}', "");
    Error('\p{Script=  Thai/a/}');
    Error('\P{Script=  Thai/a/}');
    Expect(1, 3675, '\p{Script:	thai}', "");
    Expect(0, 3675, '\p{^Script:	thai}', "");
    Expect(0, 3675, '\P{Script:	thai}', "");
    Expect(1, 3675, '\P{^Script:	thai}', "");
    Expect(0, 3676, '\p{Script:	thai}', "");
    Expect(1, 3676, '\p{^Script:	thai}', "");
    Expect(1, 3676, '\P{Script:	thai}', "");
    Expect(0, 3676, '\P{^Script:	thai}', "");
    Expect(1, 3675, '\p{Script=-Thai}', "");
    Expect(0, 3675, '\p{^Script=-Thai}', "");
    Expect(0, 3675, '\P{Script=-Thai}', "");
    Expect(1, 3675, '\P{^Script=-Thai}', "");
    Expect(0, 3676, '\p{Script=-Thai}', "");
    Expect(1, 3676, '\p{^Script=-Thai}', "");
    Expect(1, 3676, '\P{Script=-Thai}', "");
    Expect(0, 3676, '\P{^Script=-Thai}', "");
    Error('\p{Sc=:=_Thai}');
    Error('\P{Sc=:=_Thai}');
    Expect(1, 3675, '\p{Sc=thai}', "");
    Expect(0, 3675, '\p{^Sc=thai}', "");
    Expect(0, 3675, '\P{Sc=thai}', "");
    Expect(1, 3675, '\P{^Sc=thai}', "");
    Expect(0, 3676, '\p{Sc=thai}', "");
    Expect(1, 3676, '\p{^Sc=thai}', "");
    Expect(1, 3676, '\P{Sc=thai}', "");
    Expect(0, 3676, '\P{^Sc=thai}', "");
    Expect(1, 3675, '\p{Sc=-_THAI}', "");
    Expect(0, 3675, '\p{^Sc=-_THAI}', "");
    Expect(0, 3675, '\P{Sc=-_THAI}', "");
    Expect(1, 3675, '\P{^Sc=-_THAI}', "");
    Expect(0, 3676, '\p{Sc=-_THAI}', "");
    Expect(1, 3676, '\p{^Sc=-_THAI}', "");
    Expect(1, 3676, '\P{Sc=-_THAI}', "");
    Expect(0, 3676, '\P{^Sc=-_THAI}', "");
    Error('\p{Is_Script=/a/	_Thai}');
    Error('\P{Is_Script=/a/	_Thai}');
    Expect(1, 3675, '\p{Is_Script=thai}', "");
    Expect(0, 3675, '\p{^Is_Script=thai}', "");
    Expect(0, 3675, '\P{Is_Script=thai}', "");
    Expect(1, 3675, '\P{^Is_Script=thai}', "");
    Expect(0, 3676, '\p{Is_Script=thai}', "");
    Expect(1, 3676, '\p{^Is_Script=thai}', "");
    Expect(1, 3676, '\P{Is_Script=thai}', "");
    Expect(0, 3676, '\P{^Is_Script=thai}', "");
    Expect(1, 3675, '\p{Is_Script=--Thai}', "");
    Expect(0, 3675, '\p{^Is_Script=--Thai}', "");
    Expect(0, 3675, '\P{Is_Script=--Thai}', "");
    Expect(1, 3675, '\P{^Is_Script=--Thai}', "");
    Expect(0, 3676, '\p{Is_Script=--Thai}', "");
    Expect(1, 3676, '\p{^Is_Script=--Thai}', "");
    Expect(1, 3676, '\P{Is_Script=--Thai}', "");
    Expect(0, 3676, '\P{^Is_Script=--Thai}', "");
    Error('\p{Is_Sc=	_Thai:=}');
    Error('\P{Is_Sc=	_Thai:=}');
    Expect(1, 3675, '\p{Is_Sc=thai}', "");
    Expect(0, 3675, '\p{^Is_Sc=thai}', "");
    Expect(0, 3675, '\P{Is_Sc=thai}', "");
    Expect(1, 3675, '\P{^Is_Sc=thai}', "");
    Expect(0, 3676, '\p{Is_Sc=thai}', "");
    Expect(1, 3676, '\p{^Is_Sc=thai}', "");
    Expect(1, 3676, '\P{Is_Sc=thai}', "");
    Expect(0, 3676, '\P{^Is_Sc=thai}', "");
    Expect(1, 3675, '\p{Is_Sc=- THAI}', "");
    Expect(0, 3675, '\p{^Is_Sc=- THAI}', "");
    Expect(0, 3675, '\P{Is_Sc=- THAI}', "");
    Expect(1, 3675, '\P{^Is_Sc=- THAI}', "");
    Expect(0, 3676, '\p{Is_Sc=- THAI}', "");
    Expect(1, 3676, '\p{^Is_Sc=- THAI}', "");
    Expect(1, 3676, '\P{Is_Sc=- THAI}', "");
    Expect(0, 3676, '\P{^Is_Sc=- THAI}', "");
    Error('\p{Script=:=  Tibetan}');
    Error('\P{Script=:=  Tibetan}');
    Expect(1, 4058, '\p{Script=tibetan}', "");
    Expect(0, 4058, '\p{^Script=tibetan}', "");
    Expect(0, 4058, '\P{Script=tibetan}', "");
    Expect(1, 4058, '\P{^Script=tibetan}', "");
    Expect(0, 4059, '\p{Script=tibetan}', "");
    Expect(1, 4059, '\p{^Script=tibetan}', "");
    Expect(1, 4059, '\P{Script=tibetan}', "");
    Expect(0, 4059, '\P{^Script=tibetan}', "");
    Expect(1, 4058, '\p{Script=_	tibetan}', "");
    Expect(0, 4058, '\p{^Script=_	tibetan}', "");
    Expect(0, 4058, '\P{Script=_	tibetan}', "");
    Expect(1, 4058, '\P{^Script=_	tibetan}', "");
    Expect(0, 4059, '\p{Script=_	tibetan}', "");
    Expect(1, 4059, '\p{^Script=_	tibetan}', "");
    Expect(1, 4059, '\P{Script=_	tibetan}', "");
    Expect(0, 4059, '\P{^Script=_	tibetan}', "");
    Error('\p{Sc=/a/ tibt}');
    Error('\P{Sc=/a/ tibt}');
    Expect(1, 4058, '\p{Sc=tibt}', "");
    Expect(0, 4058, '\p{^Sc=tibt}', "");
    Expect(0, 4058, '\P{Sc=tibt}', "");
    Expect(1, 4058, '\P{^Sc=tibt}', "");
    Expect(0, 4059, '\p{Sc=tibt}', "");
    Expect(1, 4059, '\p{^Sc=tibt}', "");
    Expect(1, 4059, '\P{Sc=tibt}', "");
    Expect(0, 4059, '\P{^Sc=tibt}', "");
    Expect(1, 4058, '\p{Sc=- Tibt}', "");
    Expect(0, 4058, '\p{^Sc=- Tibt}', "");
    Expect(0, 4058, '\P{Sc=- Tibt}', "");
    Expect(1, 4058, '\P{^Sc=- Tibt}', "");
    Expect(0, 4059, '\p{Sc=- Tibt}', "");
    Expect(1, 4059, '\p{^Sc=- Tibt}', "");
    Expect(1, 4059, '\P{Sc=- Tibt}', "");
    Expect(0, 4059, '\P{^Sc=- Tibt}', "");
    Error('\p{Is_Script=-	Tibetan/a/}');
    Error('\P{Is_Script=-	Tibetan/a/}');
    Expect(1, 4058, '\p{Is_Script=tibetan}', "");
    Expect(0, 4058, '\p{^Is_Script=tibetan}', "");
    Expect(0, 4058, '\P{Is_Script=tibetan}', "");
    Expect(1, 4058, '\P{^Is_Script=tibetan}', "");
    Expect(0, 4059, '\p{Is_Script=tibetan}', "");
    Expect(1, 4059, '\p{^Is_Script=tibetan}', "");
    Expect(1, 4059, '\P{Is_Script=tibetan}', "");
    Expect(0, 4059, '\P{^Is_Script=tibetan}', "");
    Expect(1, 4058, '\p{Is_Script=_-Tibetan}', "");
    Expect(0, 4058, '\p{^Is_Script=_-Tibetan}', "");
    Expect(0, 4058, '\P{Is_Script=_-Tibetan}', "");
    Expect(1, 4058, '\P{^Is_Script=_-Tibetan}', "");
    Expect(0, 4059, '\p{Is_Script=_-Tibetan}', "");
    Expect(1, 4059, '\p{^Is_Script=_-Tibetan}', "");
    Expect(1, 4059, '\P{Is_Script=_-Tibetan}', "");
    Expect(0, 4059, '\P{^Is_Script=_-Tibetan}', "");
    Error('\p{Is_Sc=  Tibt:=}');
    Error('\P{Is_Sc=  Tibt:=}');
    Expect(1, 4058, '\p{Is_Sc=tibt}', "");
    Expect(0, 4058, '\p{^Is_Sc=tibt}', "");
    Expect(0, 4058, '\P{Is_Sc=tibt}', "");
    Expect(1, 4058, '\P{^Is_Sc=tibt}', "");
    Expect(0, 4059, '\p{Is_Sc=tibt}', "");
    Expect(1, 4059, '\p{^Is_Sc=tibt}', "");
    Expect(1, 4059, '\P{Is_Sc=tibt}', "");
    Expect(0, 4059, '\P{^Is_Sc=tibt}', "");
    Expect(1, 4058, '\p{Is_Sc= TIBT}', "");
    Expect(0, 4058, '\p{^Is_Sc= TIBT}', "");
    Expect(0, 4058, '\P{Is_Sc= TIBT}', "");
    Expect(1, 4058, '\P{^Is_Sc= TIBT}', "");
    Expect(0, 4059, '\p{Is_Sc= TIBT}', "");
    Expect(1, 4059, '\p{^Is_Sc= TIBT}', "");
    Expect(1, 4059, '\P{Is_Sc= TIBT}', "");
    Expect(0, 4059, '\P{^Is_Sc= TIBT}', "");
    Error('\p{Script=	-Tirhuta:=}');
    Error('\P{Script=	-Tirhuta:=}');
    Expect(1, 70873, '\p{Script=tirhuta}', "");
    Expect(0, 70873, '\p{^Script=tirhuta}', "");
    Expect(0, 70873, '\P{Script=tirhuta}', "");
    Expect(1, 70873, '\P{^Script=tirhuta}', "");
    Expect(0, 70874, '\p{Script=tirhuta}', "");
    Expect(1, 70874, '\p{^Script=tirhuta}', "");
    Expect(1, 70874, '\P{Script=tirhuta}', "");
    Expect(0, 70874, '\P{^Script=tirhuta}', "");
    Expect(1, 70873, '\p{Script=__Tirhuta}', "");
    Expect(0, 70873, '\p{^Script=__Tirhuta}', "");
    Expect(0, 70873, '\P{Script=__Tirhuta}', "");
    Expect(1, 70873, '\P{^Script=__Tirhuta}', "");
    Expect(0, 70874, '\p{Script=__Tirhuta}', "");
    Expect(1, 70874, '\p{^Script=__Tirhuta}', "");
    Expect(1, 70874, '\P{Script=__Tirhuta}', "");
    Expect(0, 70874, '\P{^Script=__Tirhuta}', "");
    Error('\p{Sc=:=-_tirh}');
    Error('\P{Sc=:=-_tirh}');
    Expect(1, 70873, '\p{Sc=tirh}', "");
    Expect(0, 70873, '\p{^Sc=tirh}', "");
    Expect(0, 70873, '\P{Sc=tirh}', "");
    Expect(1, 70873, '\P{^Sc=tirh}', "");
    Expect(0, 70874, '\p{Sc=tirh}', "");
    Expect(1, 70874, '\p{^Sc=tirh}', "");
    Expect(1, 70874, '\P{Sc=tirh}', "");
    Expect(0, 70874, '\P{^Sc=tirh}', "");
    Expect(1, 70873, '\p{Sc=	 tirh}', "");
    Expect(0, 70873, '\p{^Sc=	 tirh}', "");
    Expect(0, 70873, '\P{Sc=	 tirh}', "");
    Expect(1, 70873, '\P{^Sc=	 tirh}', "");
    Expect(0, 70874, '\p{Sc=	 tirh}', "");
    Expect(1, 70874, '\p{^Sc=	 tirh}', "");
    Expect(1, 70874, '\P{Sc=	 tirh}', "");
    Expect(0, 70874, '\P{^Sc=	 tirh}', "");
    Error('\p{Is_Script= /a/Tirhuta}');
    Error('\P{Is_Script= /a/Tirhuta}');
    Expect(1, 70873, '\p{Is_Script=tirhuta}', "");
    Expect(0, 70873, '\p{^Is_Script=tirhuta}', "");
    Expect(0, 70873, '\P{Is_Script=tirhuta}', "");
    Expect(1, 70873, '\P{^Is_Script=tirhuta}', "");
    Expect(0, 70874, '\p{Is_Script=tirhuta}', "");
    Expect(1, 70874, '\p{^Is_Script=tirhuta}', "");
    Expect(1, 70874, '\P{Is_Script=tirhuta}', "");
    Expect(0, 70874, '\P{^Is_Script=tirhuta}', "");
    Expect(1, 70873, '\p{Is_Script=-TIRHUTA}', "");
    Expect(0, 70873, '\p{^Is_Script=-TIRHUTA}', "");
    Expect(0, 70873, '\P{Is_Script=-TIRHUTA}', "");
    Expect(1, 70873, '\P{^Is_Script=-TIRHUTA}', "");
    Expect(0, 70874, '\p{Is_Script=-TIRHUTA}', "");
    Expect(1, 70874, '\p{^Is_Script=-TIRHUTA}', "");
    Expect(1, 70874, '\P{Is_Script=-TIRHUTA}', "");
    Expect(0, 70874, '\P{^Is_Script=-TIRHUTA}', "");
    Error('\p{Is_Sc=	/a/Tirh}');
    Error('\P{Is_Sc=	/a/Tirh}');
    Expect(1, 70873, '\p{Is_Sc=tirh}', "");
    Expect(0, 70873, '\p{^Is_Sc=tirh}', "");
    Expect(0, 70873, '\P{Is_Sc=tirh}', "");
    Expect(1, 70873, '\P{^Is_Sc=tirh}', "");
    Expect(0, 70874, '\p{Is_Sc=tirh}', "");
    Expect(1, 70874, '\p{^Is_Sc=tirh}', "");
    Expect(1, 70874, '\P{Is_Sc=tirh}', "");
    Expect(0, 70874, '\P{^Is_Sc=tirh}', "");
    Expect(1, 70873, '\p{Is_Sc=-_tirh}', "");
    Expect(0, 70873, '\p{^Is_Sc=-_tirh}', "");
    Expect(0, 70873, '\P{Is_Sc=-_tirh}', "");
    Expect(1, 70873, '\P{^Is_Sc=-_tirh}', "");
    Expect(0, 70874, '\p{Is_Sc=-_tirh}', "");
    Expect(1, 70874, '\p{^Is_Sc=-_tirh}', "");
    Expect(1, 70874, '\P{Is_Sc=-_tirh}', "");
    Expect(0, 70874, '\P{^Is_Sc=-_tirh}', "");
    Error('\p{Script=_/a/UGARITIC}');
    Error('\P{Script=_/a/UGARITIC}');
    Expect(1, 66463, '\p{Script=ugaritic}', "");
    Expect(0, 66463, '\p{^Script=ugaritic}', "");
    Expect(0, 66463, '\P{Script=ugaritic}', "");
    Expect(1, 66463, '\P{^Script=ugaritic}', "");
    Expect(0, 66464, '\p{Script=ugaritic}', "");
    Expect(1, 66464, '\p{^Script=ugaritic}', "");
    Expect(1, 66464, '\P{Script=ugaritic}', "");
    Expect(0, 66464, '\P{^Script=ugaritic}', "");
    Expect(1, 66463, '\p{Script= 	UGARITIC}', "");
    Expect(0, 66463, '\p{^Script= 	UGARITIC}', "");
    Expect(0, 66463, '\P{Script= 	UGARITIC}', "");
    Expect(1, 66463, '\P{^Script= 	UGARITIC}', "");
    Expect(0, 66464, '\p{Script= 	UGARITIC}', "");
    Expect(1, 66464, '\p{^Script= 	UGARITIC}', "");
    Expect(1, 66464, '\P{Script= 	UGARITIC}', "");
    Expect(0, 66464, '\P{^Script= 	UGARITIC}', "");
    Error('\p{Sc=:=	 Ugar}');
    Error('\P{Sc=:=	 Ugar}');
    Expect(1, 66463, '\p{Sc=ugar}', "");
    Expect(0, 66463, '\p{^Sc=ugar}', "");
    Expect(0, 66463, '\P{Sc=ugar}', "");
    Expect(1, 66463, '\P{^Sc=ugar}', "");
    Expect(0, 66464, '\p{Sc=ugar}', "");
    Expect(1, 66464, '\p{^Sc=ugar}', "");
    Expect(1, 66464, '\P{Sc=ugar}', "");
    Expect(0, 66464, '\P{^Sc=ugar}', "");
    Expect(1, 66463, '\p{Sc= 	ugar}', "");
    Expect(0, 66463, '\p{^Sc= 	ugar}', "");
    Expect(0, 66463, '\P{Sc= 	ugar}', "");
    Expect(1, 66463, '\P{^Sc= 	ugar}', "");
    Expect(0, 66464, '\p{Sc= 	ugar}', "");
    Expect(1, 66464, '\p{^Sc= 	ugar}', "");
    Expect(1, 66464, '\P{Sc= 	ugar}', "");
    Expect(0, 66464, '\P{^Sc= 	ugar}', "");
    Error('\p{Is_Script=/a/ -Ugaritic}');
    Error('\P{Is_Script=/a/ -Ugaritic}');
    Expect(1, 66463, '\p{Is_Script=ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Script=ugaritic}', "");
    Expect(0, 66463, '\P{Is_Script=ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Script=ugaritic}', "");
    Expect(0, 66464, '\p{Is_Script=ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Script=ugaritic}', "");
    Expect(1, 66464, '\P{Is_Script=ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Script=ugaritic}', "");
    Expect(1, 66463, '\p{Is_Script: 	UGARITIC}', "");
    Expect(0, 66463, '\p{^Is_Script: 	UGARITIC}', "");
    Expect(0, 66463, '\P{Is_Script: 	UGARITIC}', "");
    Expect(1, 66463, '\P{^Is_Script: 	UGARITIC}', "");
    Expect(0, 66464, '\p{Is_Script: 	UGARITIC}', "");
    Expect(1, 66464, '\p{^Is_Script: 	UGARITIC}', "");
    Expect(1, 66464, '\P{Is_Script: 	UGARITIC}', "");
    Expect(0, 66464, '\P{^Is_Script: 	UGARITIC}', "");
    Error('\p{Is_Sc=-Ugar:=}');
    Error('\P{Is_Sc=-Ugar:=}');
    Expect(1, 66463, '\p{Is_Sc=ugar}', "");
    Expect(0, 66463, '\p{^Is_Sc=ugar}', "");
    Expect(0, 66463, '\P{Is_Sc=ugar}', "");
    Expect(1, 66463, '\P{^Is_Sc=ugar}', "");
    Expect(0, 66464, '\p{Is_Sc=ugar}', "");
    Expect(1, 66464, '\p{^Is_Sc=ugar}', "");
    Expect(1, 66464, '\P{Is_Sc=ugar}', "");
    Expect(0, 66464, '\P{^Is_Sc=ugar}', "");
    Expect(1, 66463, '\p{Is_Sc=_-Ugar}', "");
    Expect(0, 66463, '\p{^Is_Sc=_-Ugar}', "");
    Expect(0, 66463, '\P{Is_Sc=_-Ugar}', "");
    Expect(1, 66463, '\P{^Is_Sc=_-Ugar}', "");
    Expect(0, 66464, '\p{Is_Sc=_-Ugar}', "");
    Expect(1, 66464, '\p{^Is_Sc=_-Ugar}', "");
    Expect(1, 66464, '\P{Is_Sc=_-Ugar}', "");
    Expect(0, 66464, '\P{^Is_Sc=_-Ugar}', "");
    Error('\p{Script=/a/ VAI}');
    Error('\P{Script=/a/ VAI}');
    Expect(1, 42539, '\p{Script=vai}', "");
    Expect(0, 42539, '\p{^Script=vai}', "");
    Expect(0, 42539, '\P{Script=vai}', "");
    Expect(1, 42539, '\P{^Script=vai}', "");
    Expect(0, 42540, '\p{Script=vai}', "");
    Expect(1, 42540, '\p{^Script=vai}', "");
    Expect(1, 42540, '\P{Script=vai}', "");
    Expect(0, 42540, '\P{^Script=vai}', "");
    Expect(1, 42539, '\p{Script=_ VAI}', "");
    Expect(0, 42539, '\p{^Script=_ VAI}', "");
    Expect(0, 42539, '\P{Script=_ VAI}', "");
    Expect(1, 42539, '\P{^Script=_ VAI}', "");
    Expect(0, 42540, '\p{Script=_ VAI}', "");
    Expect(1, 42540, '\p{^Script=_ VAI}', "");
    Expect(1, 42540, '\P{Script=_ VAI}', "");
    Expect(0, 42540, '\P{^Script=_ VAI}', "");
    Error('\p{Sc=/a/ -Vaii}');
    Error('\P{Sc=/a/ -Vaii}');
    Expect(1, 42539, '\p{Sc=vaii}', "");
    Expect(0, 42539, '\p{^Sc=vaii}', "");
    Expect(0, 42539, '\P{Sc=vaii}', "");
    Expect(1, 42539, '\P{^Sc=vaii}', "");
    Expect(0, 42540, '\p{Sc=vaii}', "");
    Expect(1, 42540, '\p{^Sc=vaii}', "");
    Expect(1, 42540, '\P{Sc=vaii}', "");
    Expect(0, 42540, '\P{^Sc=vaii}', "");
    Expect(1, 42539, '\p{Sc=	_vaii}', "");
    Expect(0, 42539, '\p{^Sc=	_vaii}', "");
    Expect(0, 42539, '\P{Sc=	_vaii}', "");
    Expect(1, 42539, '\P{^Sc=	_vaii}', "");
    Expect(0, 42540, '\p{Sc=	_vaii}', "");
    Expect(1, 42540, '\p{^Sc=	_vaii}', "");
    Expect(1, 42540, '\P{Sc=	_vaii}', "");
    Expect(0, 42540, '\P{^Sc=	_vaii}', "");
    Error('\p{Is_Script=:= Vai}');
    Error('\P{Is_Script=:= Vai}');
    Expect(1, 42539, '\p{Is_Script: vai}', "");
    Expect(0, 42539, '\p{^Is_Script: vai}', "");
    Expect(0, 42539, '\P{Is_Script: vai}', "");
    Expect(1, 42539, '\P{^Is_Script: vai}', "");
    Expect(0, 42540, '\p{Is_Script: vai}', "");
    Expect(1, 42540, '\p{^Is_Script: vai}', "");
    Expect(1, 42540, '\P{Is_Script: vai}', "");
    Expect(0, 42540, '\P{^Is_Script: vai}', "");
    Expect(1, 42539, '\p{Is_Script=_Vai}', "");
    Expect(0, 42539, '\p{^Is_Script=_Vai}', "");
    Expect(0, 42539, '\P{Is_Script=_Vai}', "");
    Expect(1, 42539, '\P{^Is_Script=_Vai}', "");
    Expect(0, 42540, '\p{Is_Script=_Vai}', "");
    Expect(1, 42540, '\p{^Is_Script=_Vai}', "");
    Expect(1, 42540, '\P{Is_Script=_Vai}', "");
    Expect(0, 42540, '\P{^Is_Script=_Vai}', "");
    Error('\p{Is_Sc:/a/-	Vaii}');
    Error('\P{Is_Sc:/a/-	Vaii}');
    Expect(1, 42539, '\p{Is_Sc=vaii}', "");
    Expect(0, 42539, '\p{^Is_Sc=vaii}', "");
    Expect(0, 42539, '\P{Is_Sc=vaii}', "");
    Expect(1, 42539, '\P{^Is_Sc=vaii}', "");
    Expect(0, 42540, '\p{Is_Sc=vaii}', "");
    Expect(1, 42540, '\p{^Is_Sc=vaii}', "");
    Expect(1, 42540, '\P{Is_Sc=vaii}', "");
    Expect(0, 42540, '\P{^Is_Sc=vaii}', "");
    Expect(1, 42539, '\p{Is_Sc=	-VAII}', "");
    Expect(0, 42539, '\p{^Is_Sc=	-VAII}', "");
    Expect(0, 42539, '\P{Is_Sc=	-VAII}', "");
    Expect(1, 42539, '\P{^Is_Sc=	-VAII}', "");
    Expect(0, 42540, '\p{Is_Sc=	-VAII}', "");
    Expect(1, 42540, '\p{^Is_Sc=	-VAII}', "");
    Expect(1, 42540, '\P{Is_Sc=	-VAII}', "");
    Expect(0, 42540, '\P{^Is_Sc=	-VAII}', "");
    Error('\p{Script= :=WARANG_Citi}');
    Error('\P{Script= :=WARANG_Citi}');
    Expect(1, 71935, '\p{Script=warangciti}', "");
    Expect(0, 71935, '\p{^Script=warangciti}', "");
    Expect(0, 71935, '\P{Script=warangciti}', "");
    Expect(1, 71935, '\P{^Script=warangciti}', "");
    Expect(0, 71936, '\p{Script=warangciti}', "");
    Expect(1, 71936, '\p{^Script=warangciti}', "");
    Expect(1, 71936, '\P{Script=warangciti}', "");
    Expect(0, 71936, '\P{^Script=warangciti}', "");
    Expect(1, 71935, '\p{Script: 	 Warang_Citi}', "");
    Expect(0, 71935, '\p{^Script: 	 Warang_Citi}', "");
    Expect(0, 71935, '\P{Script: 	 Warang_Citi}', "");
    Expect(1, 71935, '\P{^Script: 	 Warang_Citi}', "");
    Expect(0, 71936, '\p{Script: 	 Warang_Citi}', "");
    Expect(1, 71936, '\p{^Script: 	 Warang_Citi}', "");
    Expect(1, 71936, '\P{Script: 	 Warang_Citi}', "");
    Expect(0, 71936, '\P{^Script: 	 Warang_Citi}', "");
    Error('\p{Sc= _WARA:=}');
    Error('\P{Sc= _WARA:=}');
    Expect(1, 71935, '\p{Sc=wara}', "");
    Expect(0, 71935, '\p{^Sc=wara}', "");
    Expect(0, 71935, '\P{Sc=wara}', "");
    Expect(1, 71935, '\P{^Sc=wara}', "");
    Expect(0, 71936, '\p{Sc=wara}', "");
    Expect(1, 71936, '\p{^Sc=wara}', "");
    Expect(1, 71936, '\P{Sc=wara}', "");
    Expect(0, 71936, '\P{^Sc=wara}', "");
    Expect(1, 71935, '\p{Sc=__Wara}', "");
    Expect(0, 71935, '\p{^Sc=__Wara}', "");
    Expect(0, 71935, '\P{Sc=__Wara}', "");
    Expect(1, 71935, '\P{^Sc=__Wara}', "");
    Expect(0, 71936, '\p{Sc=__Wara}', "");
    Expect(1, 71936, '\p{^Sc=__Wara}', "");
    Expect(1, 71936, '\P{Sc=__Wara}', "");
    Expect(0, 71936, '\P{^Sc=__Wara}', "");
    Error('\p{Is_Script=:=WARANG_CITI}');
    Error('\P{Is_Script=:=WARANG_CITI}');
    Expect(1, 71935, '\p{Is_Script=warangciti}', "");
    Expect(0, 71935, '\p{^Is_Script=warangciti}', "");
    Expect(0, 71935, '\P{Is_Script=warangciti}', "");
    Expect(1, 71935, '\P{^Is_Script=warangciti}', "");
    Expect(0, 71936, '\p{Is_Script=warangciti}', "");
    Expect(1, 71936, '\p{^Is_Script=warangciti}', "");
    Expect(1, 71936, '\P{Is_Script=warangciti}', "");
    Expect(0, 71936, '\P{^Is_Script=warangciti}', "");
    Expect(1, 71935, '\p{Is_Script= warang_Citi}', "");
    Expect(0, 71935, '\p{^Is_Script= warang_Citi}', "");
    Expect(0, 71935, '\P{Is_Script= warang_Citi}', "");
    Expect(1, 71935, '\P{^Is_Script= warang_Citi}', "");
    Expect(0, 71936, '\p{Is_Script= warang_Citi}', "");
    Expect(1, 71936, '\p{^Is_Script= warang_Citi}', "");
    Expect(1, 71936, '\P{Is_Script= warang_Citi}', "");
    Expect(0, 71936, '\P{^Is_Script= warang_Citi}', "");
    Error('\p{Is_Sc:   :=-Wara}');
    Error('\P{Is_Sc:   :=-Wara}');
    Expect(1, 71935, '\p{Is_Sc:wara}', "");
    Expect(0, 71935, '\p{^Is_Sc:wara}', "");
    Expect(0, 71935, '\P{Is_Sc:wara}', "");
    Expect(1, 71935, '\P{^Is_Sc:wara}', "");
    Expect(0, 71936, '\p{Is_Sc:wara}', "");
    Expect(1, 71936, '\p{^Is_Sc:wara}', "");
    Expect(1, 71936, '\P{Is_Sc:wara}', "");
    Expect(0, 71936, '\P{^Is_Sc:wara}', "");
    Expect(1, 71935, '\p{Is_Sc=-_Wara}', "");
    Expect(0, 71935, '\p{^Is_Sc=-_Wara}', "");
    Expect(0, 71935, '\P{Is_Sc=-_Wara}', "");
    Expect(1, 71935, '\P{^Is_Sc=-_Wara}', "");
    Expect(0, 71936, '\p{Is_Sc=-_Wara}', "");
    Expect(1, 71936, '\p{^Is_Sc=-_Wara}', "");
    Expect(1, 71936, '\P{Is_Sc=-_Wara}', "");
    Expect(0, 71936, '\P{^Is_Sc=-_Wara}', "");
    Error('\p{Script:	_Old_PERSIAN/a/}');
    Error('\P{Script:	_Old_PERSIAN/a/}');
    Expect(1, 66517, '\p{Script=oldpersian}', "");
    Expect(0, 66517, '\p{^Script=oldpersian}', "");
    Expect(0, 66517, '\P{Script=oldpersian}', "");
    Expect(1, 66517, '\P{^Script=oldpersian}', "");
    Expect(0, 66518, '\p{Script=oldpersian}', "");
    Expect(1, 66518, '\p{^Script=oldpersian}', "");
    Expect(1, 66518, '\P{Script=oldpersian}', "");
    Expect(0, 66518, '\P{^Script=oldpersian}', "");
    Expect(1, 66517, '\p{Script=__Old_PERSIAN}', "");
    Expect(0, 66517, '\p{^Script=__Old_PERSIAN}', "");
    Expect(0, 66517, '\P{Script=__Old_PERSIAN}', "");
    Expect(1, 66517, '\P{^Script=__Old_PERSIAN}', "");
    Expect(0, 66518, '\p{Script=__Old_PERSIAN}', "");
    Expect(1, 66518, '\p{^Script=__Old_PERSIAN}', "");
    Expect(1, 66518, '\P{Script=__Old_PERSIAN}', "");
    Expect(0, 66518, '\P{^Script=__Old_PERSIAN}', "");
    Error('\p{Sc=-	xpeo/a/}');
    Error('\P{Sc=-	xpeo/a/}');
    Expect(1, 66517, '\p{Sc:	xpeo}', "");
    Expect(0, 66517, '\p{^Sc:	xpeo}', "");
    Expect(0, 66517, '\P{Sc:	xpeo}', "");
    Expect(1, 66517, '\P{^Sc:	xpeo}', "");
    Expect(0, 66518, '\p{Sc:	xpeo}', "");
    Expect(1, 66518, '\p{^Sc:	xpeo}', "");
    Expect(1, 66518, '\P{Sc:	xpeo}', "");
    Expect(0, 66518, '\P{^Sc:	xpeo}', "");
    Expect(1, 66517, '\p{Sc=-XPEO}', "");
    Expect(0, 66517, '\p{^Sc=-XPEO}', "");
    Expect(0, 66517, '\P{Sc=-XPEO}', "");
    Expect(1, 66517, '\P{^Sc=-XPEO}', "");
    Expect(0, 66518, '\p{Sc=-XPEO}', "");
    Expect(1, 66518, '\p{^Sc=-XPEO}', "");
    Expect(1, 66518, '\P{Sc=-XPEO}', "");
    Expect(0, 66518, '\P{^Sc=-XPEO}', "");
    Error('\p{Is_Script=	-Old_persian/a/}');
    Error('\P{Is_Script=	-Old_persian/a/}');
    Expect(1, 66517, '\p{Is_Script=oldpersian}', "");
    Expect(0, 66517, '\p{^Is_Script=oldpersian}', "");
    Expect(0, 66517, '\P{Is_Script=oldpersian}', "");
    Expect(1, 66517, '\P{^Is_Script=oldpersian}', "");
    Expect(0, 66518, '\p{Is_Script=oldpersian}', "");
    Expect(1, 66518, '\p{^Is_Script=oldpersian}', "");
    Expect(1, 66518, '\P{Is_Script=oldpersian}', "");
    Expect(0, 66518, '\P{^Is_Script=oldpersian}', "");
    Expect(1, 66517, '\p{Is_Script=	Old_persian}', "");
    Expect(0, 66517, '\p{^Is_Script=	Old_persian}', "");
    Expect(0, 66517, '\P{Is_Script=	Old_persian}', "");
    Expect(1, 66517, '\P{^Is_Script=	Old_persian}', "");
    Expect(0, 66518, '\p{Is_Script=	Old_persian}', "");
    Expect(1, 66518, '\p{^Is_Script=	Old_persian}', "");
    Expect(1, 66518, '\P{Is_Script=	Old_persian}', "");
    Expect(0, 66518, '\P{^Is_Script=	Old_persian}', "");
    Error('\p{Is_Sc=:=	Xpeo}');
    Error('\P{Is_Sc=:=	Xpeo}');
    Expect(1, 66517, '\p{Is_Sc:xpeo}', "");
    Expect(0, 66517, '\p{^Is_Sc:xpeo}', "");
    Expect(0, 66517, '\P{Is_Sc:xpeo}', "");
    Expect(1, 66517, '\P{^Is_Sc:xpeo}', "");
    Expect(0, 66518, '\p{Is_Sc:xpeo}', "");
    Expect(1, 66518, '\p{^Is_Sc:xpeo}', "");
    Expect(1, 66518, '\P{Is_Sc:xpeo}', "");
    Expect(0, 66518, '\P{^Is_Sc:xpeo}', "");
    Expect(1, 66517, '\p{Is_Sc=_ Xpeo}', "");
    Expect(0, 66517, '\p{^Is_Sc=_ Xpeo}', "");
    Expect(0, 66517, '\P{Is_Sc=_ Xpeo}', "");
    Expect(1, 66517, '\P{^Is_Sc=_ Xpeo}', "");
    Expect(0, 66518, '\p{Is_Sc=_ Xpeo}', "");
    Expect(1, 66518, '\p{^Is_Sc=_ Xpeo}', "");
    Expect(1, 66518, '\P{Is_Sc=_ Xpeo}', "");
    Expect(0, 66518, '\P{^Is_Sc=_ Xpeo}', "");
    Error('\p{Script=/a/	 Cuneiform}');
    Error('\P{Script=/a/	 Cuneiform}');
    Expect(1, 75075, '\p{Script=cuneiform}', "");
    Expect(0, 75075, '\p{^Script=cuneiform}', "");
    Expect(0, 75075, '\P{Script=cuneiform}', "");
    Expect(1, 75075, '\P{^Script=cuneiform}', "");
    Expect(0, 75076, '\p{Script=cuneiform}', "");
    Expect(1, 75076, '\p{^Script=cuneiform}', "");
    Expect(1, 75076, '\P{Script=cuneiform}', "");
    Expect(0, 75076, '\P{^Script=cuneiform}', "");
    Expect(1, 75075, '\p{Script=_-Cuneiform}', "");
    Expect(0, 75075, '\p{^Script=_-Cuneiform}', "");
    Expect(0, 75075, '\P{Script=_-Cuneiform}', "");
    Expect(1, 75075, '\P{^Script=_-Cuneiform}', "");
    Expect(0, 75076, '\p{Script=_-Cuneiform}', "");
    Expect(1, 75076, '\p{^Script=_-Cuneiform}', "");
    Expect(1, 75076, '\P{Script=_-Cuneiform}', "");
    Expect(0, 75076, '\P{^Script=_-Cuneiform}', "");
    Error('\p{Sc: 	-xsux/a/}');
    Error('\P{Sc: 	-xsux/a/}');
    Expect(1, 75075, '\p{Sc=xsux}', "");
    Expect(0, 75075, '\p{^Sc=xsux}', "");
    Expect(0, 75075, '\P{Sc=xsux}', "");
    Expect(1, 75075, '\P{^Sc=xsux}', "");
    Expect(0, 75076, '\p{Sc=xsux}', "");
    Expect(1, 75076, '\p{^Sc=xsux}', "");
    Expect(1, 75076, '\P{Sc=xsux}', "");
    Expect(0, 75076, '\P{^Sc=xsux}', "");
    Expect(1, 75075, '\p{Sc=	xsux}', "");
    Expect(0, 75075, '\p{^Sc=	xsux}', "");
    Expect(0, 75075, '\P{Sc=	xsux}', "");
    Expect(1, 75075, '\P{^Sc=	xsux}', "");
    Expect(0, 75076, '\p{Sc=	xsux}', "");
    Expect(1, 75076, '\p{^Sc=	xsux}', "");
    Expect(1, 75076, '\P{Sc=	xsux}', "");
    Expect(0, 75076, '\P{^Sc=	xsux}', "");
    Error('\p{Is_Script=_-Cuneiform/a/}');
    Error('\P{Is_Script=_-Cuneiform/a/}');
    Expect(1, 75075, '\p{Is_Script=cuneiform}', "");
    Expect(0, 75075, '\p{^Is_Script=cuneiform}', "");
    Expect(0, 75075, '\P{Is_Script=cuneiform}', "");
    Expect(1, 75075, '\P{^Is_Script=cuneiform}', "");
    Expect(0, 75076, '\p{Is_Script=cuneiform}', "");
    Expect(1, 75076, '\p{^Is_Script=cuneiform}', "");
    Expect(1, 75076, '\P{Is_Script=cuneiform}', "");
    Expect(0, 75076, '\P{^Is_Script=cuneiform}', "");
    Expect(1, 75075, '\p{Is_Script=	CUNEIFORM}', "");
    Expect(0, 75075, '\p{^Is_Script=	CUNEIFORM}', "");
    Expect(0, 75075, '\P{Is_Script=	CUNEIFORM}', "");
    Expect(1, 75075, '\P{^Is_Script=	CUNEIFORM}', "");
    Expect(0, 75076, '\p{Is_Script=	CUNEIFORM}', "");
    Expect(1, 75076, '\p{^Is_Script=	CUNEIFORM}', "");
    Expect(1, 75076, '\P{Is_Script=	CUNEIFORM}', "");
    Expect(0, 75076, '\P{^Is_Script=	CUNEIFORM}', "");
    Error('\p{Is_Sc=/a/ 	Xsux}');
    Error('\P{Is_Sc=/a/ 	Xsux}');
    Expect(1, 75075, '\p{Is_Sc:	xsux}', "");
    Expect(0, 75075, '\p{^Is_Sc:	xsux}', "");
    Expect(0, 75075, '\P{Is_Sc:	xsux}', "");
    Expect(1, 75075, '\P{^Is_Sc:	xsux}', "");
    Expect(0, 75076, '\p{Is_Sc:	xsux}', "");
    Expect(1, 75076, '\p{^Is_Sc:	xsux}', "");
    Expect(1, 75076, '\P{Is_Sc:	xsux}', "");
    Expect(0, 75076, '\P{^Is_Sc:	xsux}', "");
    Expect(1, 75075, '\p{Is_Sc:	-xsux}', "");
    Expect(0, 75075, '\p{^Is_Sc:	-xsux}', "");
    Expect(0, 75075, '\P{Is_Sc:	-xsux}', "");
    Expect(1, 75075, '\P{^Is_Sc:	-xsux}', "");
    Expect(0, 75076, '\p{Is_Sc:	-xsux}', "");
    Expect(1, 75076, '\p{^Is_Sc:	-xsux}', "");
    Expect(1, 75076, '\P{Is_Sc:	-xsux}', "");
    Expect(0, 75076, '\P{^Is_Sc:	-xsux}', "");
    Error('\p{Script=:=_	yi}');
    Error('\P{Script=:=_	yi}');
    Expect(1, 42182, '\p{Script=yi}', "");
    Expect(0, 42182, '\p{^Script=yi}', "");
    Expect(0, 42182, '\P{Script=yi}', "");
    Expect(1, 42182, '\P{^Script=yi}', "");
    Expect(0, 42183, '\p{Script=yi}', "");
    Expect(1, 42183, '\p{^Script=yi}', "");
    Expect(1, 42183, '\P{Script=yi}', "");
    Expect(0, 42183, '\P{^Script=yi}', "");
    Expect(1, 42182, '\p{Script=	YI}', "");
    Expect(0, 42182, '\p{^Script=	YI}', "");
    Expect(0, 42182, '\P{Script=	YI}', "");
    Expect(1, 42182, '\P{^Script=	YI}', "");
    Expect(0, 42183, '\p{Script=	YI}', "");
    Expect(1, 42183, '\p{^Script=	YI}', "");
    Expect(1, 42183, '\P{Script=	YI}', "");
    Expect(0, 42183, '\P{^Script=	YI}', "");
    Error('\p{Sc=/a/-YIII}');
    Error('\P{Sc=/a/-YIII}');
    Expect(1, 42182, '\p{Sc=yiii}', "");
    Expect(0, 42182, '\p{^Sc=yiii}', "");
    Expect(0, 42182, '\P{Sc=yiii}', "");
    Expect(1, 42182, '\P{^Sc=yiii}', "");
    Expect(0, 42183, '\p{Sc=yiii}', "");
    Expect(1, 42183, '\p{^Sc=yiii}', "");
    Expect(1, 42183, '\P{Sc=yiii}', "");
    Expect(0, 42183, '\P{^Sc=yiii}', "");
    Expect(1, 42182, '\p{Sc= -YIII}', "");
    Expect(0, 42182, '\p{^Sc= -YIII}', "");
    Expect(0, 42182, '\P{Sc= -YIII}', "");
    Expect(1, 42182, '\P{^Sc= -YIII}', "");
    Expect(0, 42183, '\p{Sc= -YIII}', "");
    Expect(1, 42183, '\p{^Sc= -YIII}', "");
    Expect(1, 42183, '\P{Sc= -YIII}', "");
    Expect(0, 42183, '\P{^Sc= -YIII}', "");
    Error('\p{Is_Script=:=_ Yi}');
    Error('\P{Is_Script=:=_ Yi}');
    Expect(1, 42182, '\p{Is_Script=yi}', "");
    Expect(0, 42182, '\p{^Is_Script=yi}', "");
    Expect(0, 42182, '\P{Is_Script=yi}', "");
    Expect(1, 42182, '\P{^Is_Script=yi}', "");
    Expect(0, 42183, '\p{Is_Script=yi}', "");
    Expect(1, 42183, '\p{^Is_Script=yi}', "");
    Expect(1, 42183, '\P{Is_Script=yi}', "");
    Expect(0, 42183, '\P{^Is_Script=yi}', "");
    Expect(1, 42182, '\p{Is_Script=	Yi}', "");
    Expect(0, 42182, '\p{^Is_Script=	Yi}', "");
    Expect(0, 42182, '\P{Is_Script=	Yi}', "");
    Expect(1, 42182, '\P{^Is_Script=	Yi}', "");
    Expect(0, 42183, '\p{Is_Script=	Yi}', "");
    Expect(1, 42183, '\p{^Is_Script=	Yi}', "");
    Expect(1, 42183, '\P{Is_Script=	Yi}', "");
    Expect(0, 42183, '\P{^Is_Script=	Yi}', "");
    Error('\p{Is_Sc=/a/-	yiii}');
    Error('\P{Is_Sc=/a/-	yiii}');
    Expect(1, 42182, '\p{Is_Sc:yiii}', "");
    Expect(0, 42182, '\p{^Is_Sc:yiii}', "");
    Expect(0, 42182, '\P{Is_Sc:yiii}', "");
    Expect(1, 42182, '\P{^Is_Sc:yiii}', "");
    Expect(0, 42183, '\p{Is_Sc:yiii}', "");
    Expect(1, 42183, '\p{^Is_Sc:yiii}', "");
    Expect(1, 42183, '\P{Is_Sc:yiii}', "");
    Expect(0, 42183, '\P{^Is_Sc:yiii}', "");
    Expect(1, 42182, '\p{Is_Sc= _Yiii}', "");
    Expect(0, 42182, '\p{^Is_Sc= _Yiii}', "");
    Expect(0, 42182, '\P{Is_Sc= _Yiii}', "");
    Expect(1, 42182, '\P{^Is_Sc= _Yiii}', "");
    Expect(0, 42183, '\p{Is_Sc= _Yiii}', "");
    Expect(1, 42183, '\p{^Is_Sc= _Yiii}', "");
    Expect(1, 42183, '\P{Is_Sc= _Yiii}', "");
    Expect(0, 42183, '\P{^Is_Sc= _Yiii}', "");
    Error('\p{Script=/a/_zanabazar_SQUARE}');
    Error('\P{Script=/a/_zanabazar_SQUARE}');
    Expect(1, 72263, '\p{Script=zanabazarsquare}', "");
    Expect(0, 72263, '\p{^Script=zanabazarsquare}', "");
    Expect(0, 72263, '\P{Script=zanabazarsquare}', "");
    Expect(1, 72263, '\P{^Script=zanabazarsquare}', "");
    Expect(0, 72264, '\p{Script=zanabazarsquare}', "");
    Expect(1, 72264, '\p{^Script=zanabazarsquare}', "");
    Expect(1, 72264, '\P{Script=zanabazarsquare}', "");
    Expect(0, 72264, '\P{^Script=zanabazarsquare}', "");
    Expect(1, 72263, '\p{Script:   	zanabazar_Square}', "");
    Expect(0, 72263, '\p{^Script:   	zanabazar_Square}', "");
    Expect(0, 72263, '\P{Script:   	zanabazar_Square}', "");
    Expect(1, 72263, '\P{^Script:   	zanabazar_Square}', "");
    Expect(0, 72264, '\p{Script:   	zanabazar_Square}', "");
    Expect(1, 72264, '\p{^Script:   	zanabazar_Square}', "");
    Expect(1, 72264, '\P{Script:   	zanabazar_Square}', "");
    Expect(0, 72264, '\P{^Script:   	zanabazar_Square}', "");
    Error('\p{Sc=	/a/Zanb}');
    Error('\P{Sc=	/a/Zanb}');
    Expect(1, 72263, '\p{Sc=zanb}', "");
    Expect(0, 72263, '\p{^Sc=zanb}', "");
    Expect(0, 72263, '\P{Sc=zanb}', "");
    Expect(1, 72263, '\P{^Sc=zanb}', "");
    Expect(0, 72264, '\p{Sc=zanb}', "");
    Expect(1, 72264, '\p{^Sc=zanb}', "");
    Expect(1, 72264, '\P{Sc=zanb}', "");
    Expect(0, 72264, '\P{^Sc=zanb}', "");
    Expect(1, 72263, '\p{Sc=-Zanb}', "");
    Expect(0, 72263, '\p{^Sc=-Zanb}', "");
    Expect(0, 72263, '\P{Sc=-Zanb}', "");
    Expect(1, 72263, '\P{^Sc=-Zanb}', "");
    Expect(0, 72264, '\p{Sc=-Zanb}', "");
    Expect(1, 72264, '\p{^Sc=-Zanb}', "");
    Expect(1, 72264, '\P{Sc=-Zanb}', "");
    Expect(0, 72264, '\P{^Sc=-Zanb}', "");
    Error('\p{Is_Script=__Zanabazar_Square:=}');
    Error('\P{Is_Script=__Zanabazar_Square:=}');
    Expect(1, 72263, '\p{Is_Script=zanabazarsquare}', "");
    Expect(0, 72263, '\p{^Is_Script=zanabazarsquare}', "");
    Expect(0, 72263, '\P{Is_Script=zanabazarsquare}', "");
    Expect(1, 72263, '\P{^Is_Script=zanabazarsquare}', "");
    Expect(0, 72264, '\p{Is_Script=zanabazarsquare}', "");
    Expect(1, 72264, '\p{^Is_Script=zanabazarsquare}', "");
    Expect(1, 72264, '\P{Is_Script=zanabazarsquare}', "");
    Expect(0, 72264, '\P{^Is_Script=zanabazarsquare}', "");
    Expect(1, 72263, '\p{Is_Script=	 Zanabazar_Square}', "");
    Expect(0, 72263, '\p{^Is_Script=	 Zanabazar_Square}', "");
    Expect(0, 72263, '\P{Is_Script=	 Zanabazar_Square}', "");
    Expect(1, 72263, '\P{^Is_Script=	 Zanabazar_Square}', "");
    Expect(0, 72264, '\p{Is_Script=	 Zanabazar_Square}', "");
    Expect(1, 72264, '\p{^Is_Script=	 Zanabazar_Square}', "");
    Expect(1, 72264, '\P{Is_Script=	 Zanabazar_Square}', "");
    Expect(0, 72264, '\P{^Is_Script=	 Zanabazar_Square}', "");
    Error('\p{Is_Sc= _Zanb/a/}');
    Error('\P{Is_Sc= _Zanb/a/}');
    Expect(1, 72263, '\p{Is_Sc=zanb}', "");
    Expect(0, 72263, '\p{^Is_Sc=zanb}', "");
    Expect(0, 72263, '\P{Is_Sc=zanb}', "");
    Expect(1, 72263, '\P{^Is_Sc=zanb}', "");
    Expect(0, 72264, '\p{Is_Sc=zanb}', "");
    Expect(1, 72264, '\p{^Is_Sc=zanb}', "");
    Expect(1, 72264, '\P{Is_Sc=zanb}', "");
    Expect(0, 72264, '\P{^Is_Sc=zanb}', "");
    Error('\p{Script=:=	inherited}');
    Error('\P{Script=:=	inherited}');
    Expect(1, 917999, '\p{Script=inherited}', "");
    Expect(0, 917999, '\p{^Script=inherited}', "");
    Expect(0, 917999, '\P{Script=inherited}', "");
    Expect(1, 917999, '\P{^Script=inherited}', "");
    Expect(0, 918000, '\p{Script=inherited}', "");
    Expect(1, 918000, '\p{^Script=inherited}', "");
    Expect(1, 918000, '\P{Script=inherited}', "");
    Expect(0, 918000, '\P{^Script=inherited}', "");
    Expect(1, 917999, '\p{Script=	INHERITED}', "");
    Expect(0, 917999, '\p{^Script=	INHERITED}', "");
    Expect(0, 917999, '\P{Script=	INHERITED}', "");
    Expect(1, 917999, '\P{^Script=	INHERITED}', "");
    Expect(0, 918000, '\p{Script=	INHERITED}', "");
    Expect(1, 918000, '\p{^Script=	INHERITED}', "");
    Expect(1, 918000, '\P{Script=	INHERITED}', "");
    Expect(0, 918000, '\P{^Script=	INHERITED}', "");
    Error('\p{Sc=_ Zinh/a/}');
    Error('\P{Sc=_ Zinh/a/}');
    Expect(1, 917999, '\p{Sc=zinh}', "");
    Expect(0, 917999, '\p{^Sc=zinh}', "");
    Expect(0, 917999, '\P{Sc=zinh}', "");
    Expect(1, 917999, '\P{^Sc=zinh}', "");
    Expect(0, 918000, '\p{Sc=zinh}', "");
    Expect(1, 918000, '\p{^Sc=zinh}', "");
    Expect(1, 918000, '\P{Sc=zinh}', "");
    Expect(0, 918000, '\P{^Sc=zinh}', "");
    Expect(1, 917999, '\p{Sc=--ZINH}', "");
    Expect(0, 917999, '\p{^Sc=--ZINH}', "");
    Expect(0, 917999, '\P{Sc=--ZINH}', "");
    Expect(1, 917999, '\P{^Sc=--ZINH}', "");
    Expect(0, 918000, '\p{Sc=--ZINH}', "");
    Expect(1, 918000, '\p{^Sc=--ZINH}', "");
    Expect(1, 918000, '\P{Sc=--ZINH}', "");
    Expect(0, 918000, '\P{^Sc=--ZINH}', "");
    Error('\p{Is_Script:/a/qaai}');
    Error('\P{Is_Script:/a/qaai}');
    Expect(1, 917999, '\p{Is_Script=qaai}', "");
    Expect(0, 917999, '\p{^Is_Script=qaai}', "");
    Expect(0, 917999, '\P{Is_Script=qaai}', "");
    Expect(1, 917999, '\P{^Is_Script=qaai}', "");
    Expect(0, 918000, '\p{Is_Script=qaai}', "");
    Expect(1, 918000, '\p{^Is_Script=qaai}', "");
    Expect(1, 918000, '\P{Is_Script=qaai}', "");
    Expect(0, 918000, '\P{^Is_Script=qaai}', "");
    Expect(1, 917999, '\p{Is_Script= 	Qaai}', "");
    Expect(0, 917999, '\p{^Is_Script= 	Qaai}', "");
    Expect(0, 917999, '\P{Is_Script= 	Qaai}', "");
    Expect(1, 917999, '\P{^Is_Script= 	Qaai}', "");
    Expect(0, 918000, '\p{Is_Script= 	Qaai}', "");
    Expect(1, 918000, '\p{^Is_Script= 	Qaai}', "");
    Expect(1, 918000, '\P{Is_Script= 	Qaai}', "");
    Expect(0, 918000, '\P{^Is_Script= 	Qaai}', "");
    Error('\p{Is_Sc=/a/Inherited}');
    Error('\P{Is_Sc=/a/Inherited}');
    Expect(1, 917999, '\p{Is_Sc=inherited}', "");
    Expect(0, 917999, '\p{^Is_Sc=inherited}', "");
    Expect(0, 917999, '\P{Is_Sc=inherited}', "");
    Expect(1, 917999, '\P{^Is_Sc=inherited}', "");
    Expect(0, 918000, '\p{Is_Sc=inherited}', "");
    Expect(1, 918000, '\p{^Is_Sc=inherited}', "");
    Expect(1, 918000, '\P{Is_Sc=inherited}', "");
    Expect(0, 918000, '\P{^Is_Sc=inherited}', "");
    Expect(1, 917999, '\p{Is_Sc=	 Inherited}', "");
    Expect(0, 917999, '\p{^Is_Sc=	 Inherited}', "");
    Expect(0, 917999, '\P{Is_Sc=	 Inherited}', "");
    Expect(1, 917999, '\P{^Is_Sc=	 Inherited}', "");
    Expect(0, 918000, '\p{Is_Sc=	 Inherited}', "");
    Expect(1, 918000, '\p{^Is_Sc=	 Inherited}', "");
    Expect(1, 918000, '\P{Is_Sc=	 Inherited}', "");
    Expect(0, 918000, '\P{^Is_Sc=	 Inherited}', "");
    Error('\p{Script=:=Common}');
    Error('\P{Script=:=Common}');
    Expect(1, 917631, '\p{Script=common}', "");
    Expect(0, 917631, '\p{^Script=common}', "");
    Expect(0, 917631, '\P{Script=common}', "");
    Expect(1, 917631, '\P{^Script=common}', "");
    Expect(0, 917632, '\p{Script=common}', "");
    Expect(1, 917632, '\p{^Script=common}', "");
    Expect(1, 917632, '\P{Script=common}', "");
    Expect(0, 917632, '\P{^Script=common}', "");
    Expect(1, 917631, '\p{Script:	--Common}', "");
    Expect(0, 917631, '\p{^Script:	--Common}', "");
    Expect(0, 917631, '\P{Script:	--Common}', "");
    Expect(1, 917631, '\P{^Script:	--Common}', "");
    Expect(0, 917632, '\p{Script:	--Common}', "");
    Expect(1, 917632, '\p{^Script:	--Common}', "");
    Expect(1, 917632, '\P{Script:	--Common}', "");
    Expect(0, 917632, '\P{^Script:	--Common}', "");
    Error('\p{Sc=	:=zyyy}');
    Error('\P{Sc=	:=zyyy}');
    Expect(1, 917631, '\p{Sc=zyyy}', "");
    Expect(0, 917631, '\p{^Sc=zyyy}', "");
    Expect(0, 917631, '\P{Sc=zyyy}', "");
    Expect(1, 917631, '\P{^Sc=zyyy}', "");
    Expect(0, 917632, '\p{Sc=zyyy}', "");
    Expect(1, 917632, '\p{^Sc=zyyy}', "");
    Expect(1, 917632, '\P{Sc=zyyy}', "");
    Expect(0, 917632, '\P{^Sc=zyyy}', "");
    Expect(1, 917631, '\p{Sc=		ZYYY}', "");
    Expect(0, 917631, '\p{^Sc=		ZYYY}', "");
    Expect(0, 917631, '\P{Sc=		ZYYY}', "");
    Expect(1, 917631, '\P{^Sc=		ZYYY}', "");
    Expect(0, 917632, '\p{Sc=		ZYYY}', "");
    Expect(1, 917632, '\p{^Sc=		ZYYY}', "");
    Expect(1, 917632, '\P{Sc=		ZYYY}', "");
    Expect(0, 917632, '\P{^Sc=		ZYYY}', "");
    Error('\p{Is_Script=_:=Common}');
    Error('\P{Is_Script=_:=Common}');
    Expect(1, 917631, '\p{Is_Script=common}', "");
    Expect(0, 917631, '\p{^Is_Script=common}', "");
    Expect(0, 917631, '\P{Is_Script=common}', "");
    Expect(1, 917631, '\P{^Is_Script=common}', "");
    Expect(0, 917632, '\p{Is_Script=common}', "");
    Expect(1, 917632, '\p{^Is_Script=common}', "");
    Expect(1, 917632, '\P{Is_Script=common}', "");
    Expect(0, 917632, '\P{^Is_Script=common}', "");
    Expect(1, 917631, '\p{Is_Script=	COMMON}', "");
    Expect(0, 917631, '\p{^Is_Script=	COMMON}', "");
    Expect(0, 917631, '\P{Is_Script=	COMMON}', "");
    Expect(1, 917631, '\P{^Is_Script=	COMMON}', "");
    Expect(0, 917632, '\p{Is_Script=	COMMON}', "");
    Expect(1, 917632, '\p{^Is_Script=	COMMON}', "");
    Expect(1, 917632, '\P{Is_Script=	COMMON}', "");
    Expect(0, 917632, '\P{^Is_Script=	COMMON}', "");
    Error('\p{Is_Sc=:=	zyyy}');
    Error('\P{Is_Sc=:=	zyyy}');
    Expect(1, 917631, '\p{Is_Sc=zyyy}', "");
    Expect(0, 917631, '\p{^Is_Sc=zyyy}', "");
    Expect(0, 917631, '\P{Is_Sc=zyyy}', "");
    Expect(1, 917631, '\P{^Is_Sc=zyyy}', "");
    Expect(0, 917632, '\p{Is_Sc=zyyy}', "");
    Expect(1, 917632, '\p{^Is_Sc=zyyy}', "");
    Expect(1, 917632, '\P{Is_Sc=zyyy}', "");
    Expect(0, 917632, '\P{^Is_Sc=zyyy}', "");
    Expect(1, 917631, '\p{Is_Sc= 	ZYYY}', "");
    Expect(0, 917631, '\p{^Is_Sc= 	ZYYY}', "");
    Expect(0, 917631, '\P{Is_Sc= 	ZYYY}', "");
    Expect(1, 917631, '\P{^Is_Sc= 	ZYYY}', "");
    Expect(0, 917632, '\p{Is_Sc= 	ZYYY}', "");
    Expect(1, 917632, '\p{^Is_Sc= 	ZYYY}', "");
    Expect(1, 917632, '\P{Is_Sc= 	ZYYY}', "");
    Expect(0, 917632, '\P{^Is_Sc= 	ZYYY}', "");
    Error('\p{Script=_-unknown:=}');
    Error('\P{Script=_-unknown:=}');
    Expect(1, 918000, '\p{Script=unknown}', "");
    Expect(0, 918000, '\p{^Script=unknown}', "");
    Expect(0, 918000, '\P{Script=unknown}', "");
    Expect(1, 918000, '\P{^Script=unknown}', "");
    Expect(0, 917999, '\p{Script=unknown}', "");
    Expect(1, 917999, '\p{^Script=unknown}', "");
    Expect(1, 917999, '\P{Script=unknown}', "");
    Expect(0, 917999, '\P{^Script=unknown}', "");
    Expect(1, 918000, '\p{Script:__Unknown}', "");
    Expect(0, 918000, '\p{^Script:__Unknown}', "");
    Expect(0, 918000, '\P{Script:__Unknown}', "");
    Expect(1, 918000, '\P{^Script:__Unknown}', "");
    Expect(0, 917999, '\p{Script:__Unknown}', "");
    Expect(1, 917999, '\p{^Script:__Unknown}', "");
    Expect(1, 917999, '\P{Script:__Unknown}', "");
    Expect(0, 917999, '\P{^Script:__Unknown}', "");
    Error('\p{Sc=--Zzzz/a/}');
    Error('\P{Sc=--Zzzz/a/}');
    Expect(1, 918000, '\p{Sc=zzzz}', "");
    Expect(0, 918000, '\p{^Sc=zzzz}', "");
    Expect(0, 918000, '\P{Sc=zzzz}', "");
    Expect(1, 918000, '\P{^Sc=zzzz}', "");
    Expect(0, 917999, '\p{Sc=zzzz}', "");
    Expect(1, 917999, '\p{^Sc=zzzz}', "");
    Expect(1, 917999, '\P{Sc=zzzz}', "");
    Expect(0, 917999, '\P{^Sc=zzzz}', "");
    Expect(1, 918000, '\p{Sc=_-Zzzz}', "");
    Expect(0, 918000, '\p{^Sc=_-Zzzz}', "");
    Expect(0, 918000, '\P{Sc=_-Zzzz}', "");
    Expect(1, 918000, '\P{^Sc=_-Zzzz}', "");
    Expect(0, 917999, '\p{Sc=_-Zzzz}', "");
    Expect(1, 917999, '\p{^Sc=_-Zzzz}', "");
    Expect(1, 917999, '\P{Sc=_-Zzzz}', "");
    Expect(0, 917999, '\P{^Sc=_-Zzzz}', "");
    Error('\p{Is_Script=_/a/Unknown}');
    Error('\P{Is_Script=_/a/Unknown}');
    Expect(1, 918000, '\p{Is_Script:	unknown}', "");
    Expect(0, 918000, '\p{^Is_Script:	unknown}', "");
    Expect(0, 918000, '\P{Is_Script:	unknown}', "");
    Expect(1, 918000, '\P{^Is_Script:	unknown}', "");
    Expect(0, 917999, '\p{Is_Script:	unknown}', "");
    Expect(1, 917999, '\p{^Is_Script:	unknown}', "");
    Expect(1, 917999, '\P{Is_Script:	unknown}', "");
    Expect(0, 917999, '\P{^Is_Script:	unknown}', "");
    Expect(1, 918000, '\p{Is_Script= Unknown}', "");
    Expect(0, 918000, '\p{^Is_Script= Unknown}', "");
    Expect(0, 918000, '\P{Is_Script= Unknown}', "");
    Expect(1, 918000, '\P{^Is_Script= Unknown}', "");
    Expect(0, 917999, '\p{Is_Script= Unknown}', "");
    Expect(1, 917999, '\p{^Is_Script= Unknown}', "");
    Expect(1, 917999, '\P{Is_Script= Unknown}', "");
    Expect(0, 917999, '\P{^Is_Script= Unknown}', "");
    Error('\p{Is_Sc=/a/  zzzz}');
    Error('\P{Is_Sc=/a/  zzzz}');
    Expect(1, 918000, '\p{Is_Sc=zzzz}', "");
    Expect(0, 918000, '\p{^Is_Sc=zzzz}', "");
    Expect(0, 918000, '\P{Is_Sc=zzzz}', "");
    Expect(1, 918000, '\P{^Is_Sc=zzzz}', "");
    Expect(0, 917999, '\p{Is_Sc=zzzz}', "");
    Expect(1, 917999, '\p{^Is_Sc=zzzz}', "");
    Expect(1, 917999, '\P{Is_Sc=zzzz}', "");
    Expect(0, 917999, '\P{^Is_Sc=zzzz}', "");
    Expect(1, 918000, '\p{Is_Sc=	zzzz}', "");
    Expect(0, 918000, '\p{^Is_Sc=	zzzz}', "");
    Expect(0, 918000, '\P{Is_Sc=	zzzz}', "");
    Expect(1, 918000, '\P{^Is_Sc=	zzzz}', "");
    Expect(0, 917999, '\p{Is_Sc=	zzzz}', "");
    Expect(1, 917999, '\p{^Is_Sc=	zzzz}', "");
    Expect(1, 917999, '\P{Is_Sc=	zzzz}', "");
    Expect(0, 917999, '\P{^Is_Sc=	zzzz}', "");
    Error('\p{simplecasefolding}');
    Error('\P{simplecasefolding}');
    Error('\p{scf}');
    Error('\P{scf}');
    Error('\p{sfc}');
    Error('\P{sfc}');
    Error('\p{scriptextensions}');
    Error('\P{scriptextensions}');
    Error('\p{scx}');
    Error('\P{scx}');
    Error('\p{Script_Extensions=:=adlam}');
    Error('\P{Script_Extensions=:=adlam}');
    Expect(1, 125279, '\p{Script_Extensions=adlam}', "");
    Expect(0, 125279, '\p{^Script_Extensions=adlam}', "");
    Expect(0, 125279, '\P{Script_Extensions=adlam}', "");
    Expect(1, 125279, '\P{^Script_Extensions=adlam}', "");
    Expect(0, 125280, '\p{Script_Extensions=adlam}', "");
    Expect(1, 125280, '\p{^Script_Extensions=adlam}', "");
    Expect(1, 125280, '\P{Script_Extensions=adlam}', "");
    Expect(0, 125280, '\P{^Script_Extensions=adlam}', "");
    Expect(1, 125279, '\p{Script_Extensions= -Adlam}', "");
    Expect(0, 125279, '\p{^Script_Extensions= -Adlam}', "");
    Expect(0, 125279, '\P{Script_Extensions= -Adlam}', "");
    Expect(1, 125279, '\P{^Script_Extensions= -Adlam}', "");
    Expect(0, 125280, '\p{Script_Extensions= -Adlam}', "");
    Expect(1, 125280, '\p{^Script_Extensions= -Adlam}', "");
    Expect(1, 125280, '\P{Script_Extensions= -Adlam}', "");
    Expect(0, 125280, '\P{^Script_Extensions= -Adlam}', "");
    Error('\p{Scx=/a/__ADLM}');
    Error('\P{Scx=/a/__ADLM}');
    Expect(1, 125279, '\p{Scx=adlm}', "");
    Expect(0, 125279, '\p{^Scx=adlm}', "");
    Expect(0, 125279, '\P{Scx=adlm}', "");
    Expect(1, 125279, '\P{^Scx=adlm}', "");
    Expect(0, 125280, '\p{Scx=adlm}', "");
    Expect(1, 125280, '\p{^Scx=adlm}', "");
    Expect(1, 125280, '\P{Scx=adlm}', "");
    Expect(0, 125280, '\P{^Scx=adlm}', "");
    Expect(1, 125279, '\p{Scx= adlm}', "");
    Expect(0, 125279, '\p{^Scx= adlm}', "");
    Expect(0, 125279, '\P{Scx= adlm}', "");
    Expect(1, 125279, '\P{^Scx= adlm}', "");
    Expect(0, 125280, '\p{Scx= adlm}', "");
    Expect(1, 125280, '\p{^Scx= adlm}', "");
    Expect(1, 125280, '\P{Scx= adlm}', "");
    Expect(0, 125280, '\P{^Scx= adlm}', "");
    Error('\p{Is_Script_Extensions=:= adlam}');
    Error('\P{Is_Script_Extensions=:= adlam}');
    Expect(1, 125279, '\p{Is_Script_Extensions=adlam}', "");
    Expect(0, 125279, '\p{^Is_Script_Extensions=adlam}', "");
    Expect(0, 125279, '\P{Is_Script_Extensions=adlam}', "");
    Expect(1, 125279, '\P{^Is_Script_Extensions=adlam}', "");
    Expect(0, 125280, '\p{Is_Script_Extensions=adlam}', "");
    Expect(1, 125280, '\p{^Is_Script_Extensions=adlam}', "");
    Expect(1, 125280, '\P{Is_Script_Extensions=adlam}', "");
    Expect(0, 125280, '\P{^Is_Script_Extensions=adlam}', "");
    Expect(1, 125279, '\p{Is_Script_Extensions=	Adlam}', "");
    Expect(0, 125279, '\p{^Is_Script_Extensions=	Adlam}', "");
    Expect(0, 125279, '\P{Is_Script_Extensions=	Adlam}', "");
    Expect(1, 125279, '\P{^Is_Script_Extensions=	Adlam}', "");
    Expect(0, 125280, '\p{Is_Script_Extensions=	Adlam}', "");
    Expect(1, 125280, '\p{^Is_Script_Extensions=	Adlam}', "");
    Expect(1, 125280, '\P{Is_Script_Extensions=	Adlam}', "");
    Expect(0, 125280, '\P{^Is_Script_Extensions=	Adlam}', "");
    Error('\p{Is_Scx= Adlm:=}');
    Error('\P{Is_Scx= Adlm:=}');
    Expect(1, 125279, '\p{Is_Scx=adlm}', "");
    Expect(0, 125279, '\p{^Is_Scx=adlm}', "");
    Expect(0, 125279, '\P{Is_Scx=adlm}', "");
    Expect(1, 125279, '\P{^Is_Scx=adlm}', "");
    Expect(0, 125280, '\p{Is_Scx=adlm}', "");
    Expect(1, 125280, '\p{^Is_Scx=adlm}', "");
    Expect(1, 125280, '\P{Is_Scx=adlm}', "");
    Expect(0, 125280, '\P{^Is_Scx=adlm}', "");
    Expect(1, 125279, '\p{Is_Scx=-_Adlm}', "");
    Expect(0, 125279, '\p{^Is_Scx=-_Adlm}', "");
    Expect(0, 125279, '\P{Is_Scx=-_Adlm}', "");
    Expect(1, 125279, '\P{^Is_Scx=-_Adlm}', "");
    Expect(0, 125280, '\p{Is_Scx=-_Adlm}', "");
    Expect(1, 125280, '\p{^Is_Scx=-_Adlm}', "");
    Expect(1, 125280, '\P{Is_Scx=-_Adlm}', "");
    Expect(0, 125280, '\P{^Is_Scx=-_Adlm}', "");
    Error('\p{Script_Extensions=--Caucasian_albanian/a/}');
    Error('\P{Script_Extensions=--Caucasian_albanian/a/}');
    Expect(1, 66927, '\p{Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Script_Extensions=-CAUCASIAN_ALBANIAN}', "");
    Expect(0, 66927, '\p{^Script_Extensions=-CAUCASIAN_ALBANIAN}', "");
    Expect(0, 66927, '\P{Script_Extensions=-CAUCASIAN_ALBANIAN}', "");
    Expect(1, 66927, '\P{^Script_Extensions=-CAUCASIAN_ALBANIAN}', "");
    Expect(0, 66928, '\p{Script_Extensions=-CAUCASIAN_ALBANIAN}', "");
    Expect(1, 66928, '\p{^Script_Extensions=-CAUCASIAN_ALBANIAN}', "");
    Expect(1, 66928, '\P{Script_Extensions=-CAUCASIAN_ALBANIAN}', "");
    Expect(0, 66928, '\P{^Script_Extensions=-CAUCASIAN_ALBANIAN}', "");
    Error('\p{Scx=-/a/aghb}');
    Error('\P{Scx=-/a/aghb}');
    Expect(1, 66927, '\p{Scx=aghb}', "");
    Expect(0, 66927, '\p{^Scx=aghb}', "");
    Expect(0, 66927, '\P{Scx=aghb}', "");
    Expect(1, 66927, '\P{^Scx=aghb}', "");
    Expect(0, 66928, '\p{Scx=aghb}', "");
    Expect(1, 66928, '\p{^Scx=aghb}', "");
    Expect(1, 66928, '\P{Scx=aghb}', "");
    Expect(0, 66928, '\P{^Scx=aghb}', "");
    Expect(1, 66927, '\p{Scx=_-AGHB}', "");
    Expect(0, 66927, '\p{^Scx=_-AGHB}', "");
    Expect(0, 66927, '\P{Scx=_-AGHB}', "");
    Expect(1, 66927, '\P{^Scx=_-AGHB}', "");
    Expect(0, 66928, '\p{Scx=_-AGHB}', "");
    Expect(1, 66928, '\p{^Scx=_-AGHB}', "");
    Expect(1, 66928, '\P{Scx=_-AGHB}', "");
    Expect(0, 66928, '\P{^Scx=_-AGHB}', "");
    Error('\p{Is_Script_Extensions=- caucasian_ALBANIAN:=}');
    Error('\P{Is_Script_Extensions=- caucasian_ALBANIAN:=}');
    Expect(1, 66927, '\p{Is_Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Is_Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Is_Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Is_Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Is_Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Is_Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Is_Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Is_Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Is_Script_Extensions=- Caucasian_Albanian}', "");
    Expect(0, 66927, '\p{^Is_Script_Extensions=- Caucasian_Albanian}', "");
    Expect(0, 66927, '\P{Is_Script_Extensions=- Caucasian_Albanian}', "");
    Expect(1, 66927, '\P{^Is_Script_Extensions=- Caucasian_Albanian}', "");
    Expect(0, 66928, '\p{Is_Script_Extensions=- Caucasian_Albanian}', "");
    Expect(1, 66928, '\p{^Is_Script_Extensions=- Caucasian_Albanian}', "");
    Expect(1, 66928, '\P{Is_Script_Extensions=- Caucasian_Albanian}', "");
    Expect(0, 66928, '\P{^Is_Script_Extensions=- Caucasian_Albanian}', "");
    Error('\p{Is_Scx=/a/_AGHB}');
    Error('\P{Is_Scx=/a/_AGHB}');
    Expect(1, 66927, '\p{Is_Scx=aghb}', "");
    Expect(0, 66927, '\p{^Is_Scx=aghb}', "");
    Expect(0, 66927, '\P{Is_Scx=aghb}', "");
    Expect(1, 66927, '\P{^Is_Scx=aghb}', "");
    Expect(0, 66928, '\p{Is_Scx=aghb}', "");
    Expect(1, 66928, '\p{^Is_Scx=aghb}', "");
    Expect(1, 66928, '\P{Is_Scx=aghb}', "");
    Expect(0, 66928, '\P{^Is_Scx=aghb}', "");
    Expect(1, 66927, '\p{Is_Scx=Aghb}', "");
    Expect(0, 66927, '\p{^Is_Scx=Aghb}', "");
    Expect(0, 66927, '\P{Is_Scx=Aghb}', "");
    Expect(1, 66927, '\P{^Is_Scx=Aghb}', "");
    Expect(0, 66928, '\p{Is_Scx=Aghb}', "");
    Expect(1, 66928, '\p{^Is_Scx=Aghb}', "");
    Expect(1, 66928, '\P{Is_Scx=Aghb}', "");
    Expect(0, 66928, '\P{^Is_Scx=Aghb}', "");
    Error('\p{Script_Extensions=-ahom:=}');
    Error('\P{Script_Extensions=-ahom:=}');
    Expect(1, 71487, '\p{Script_Extensions=ahom}', "");
    Expect(0, 71487, '\p{^Script_Extensions=ahom}', "");
    Expect(0, 71487, '\P{Script_Extensions=ahom}', "");
    Expect(1, 71487, '\P{^Script_Extensions=ahom}', "");
    Expect(0, 71488, '\p{Script_Extensions=ahom}', "");
    Expect(1, 71488, '\p{^Script_Extensions=ahom}', "");
    Expect(1, 71488, '\P{Script_Extensions=ahom}', "");
    Expect(0, 71488, '\P{^Script_Extensions=ahom}', "");
    Expect(1, 71487, '\p{Script_Extensions:	  Ahom}', "");
    Expect(0, 71487, '\p{^Script_Extensions:	  Ahom}', "");
    Expect(0, 71487, '\P{Script_Extensions:	  Ahom}', "");
    Expect(1, 71487, '\P{^Script_Extensions:	  Ahom}', "");
    Expect(0, 71488, '\p{Script_Extensions:	  Ahom}', "");
    Expect(1, 71488, '\p{^Script_Extensions:	  Ahom}', "");
    Expect(1, 71488, '\P{Script_Extensions:	  Ahom}', "");
    Expect(0, 71488, '\P{^Script_Extensions:	  Ahom}', "");
    Error('\p{Scx=/a/_	ahom}');
    Error('\P{Scx=/a/_	ahom}');
    Expect(1, 71487, '\p{Scx=ahom}', "");
    Expect(0, 71487, '\p{^Scx=ahom}', "");
    Expect(0, 71487, '\P{Scx=ahom}', "");
    Expect(1, 71487, '\P{^Scx=ahom}', "");
    Expect(0, 71488, '\p{Scx=ahom}', "");
    Expect(1, 71488, '\p{^Scx=ahom}', "");
    Expect(1, 71488, '\P{Scx=ahom}', "");
    Expect(0, 71488, '\P{^Scx=ahom}', "");
    Expect(1, 71487, '\p{Scx:_ahom}', "");
    Expect(0, 71487, '\p{^Scx:_ahom}', "");
    Expect(0, 71487, '\P{Scx:_ahom}', "");
    Expect(1, 71487, '\P{^Scx:_ahom}', "");
    Expect(0, 71488, '\p{Scx:_ahom}', "");
    Expect(1, 71488, '\p{^Scx:_ahom}', "");
    Expect(1, 71488, '\P{Scx:_ahom}', "");
    Expect(0, 71488, '\P{^Scx:_ahom}', "");
    Error('\p{Is_Script_Extensions= :=Ahom}');
    Error('\P{Is_Script_Extensions= :=Ahom}');
    Expect(1, 71487, '\p{Is_Script_Extensions=ahom}', "");
    Expect(0, 71487, '\p{^Is_Script_Extensions=ahom}', "");
    Expect(0, 71487, '\P{Is_Script_Extensions=ahom}', "");
    Expect(1, 71487, '\P{^Is_Script_Extensions=ahom}', "");
    Expect(0, 71488, '\p{Is_Script_Extensions=ahom}', "");
    Expect(1, 71488, '\p{^Is_Script_Extensions=ahom}', "");
    Expect(1, 71488, '\P{Is_Script_Extensions=ahom}', "");
    Expect(0, 71488, '\P{^Is_Script_Extensions=ahom}', "");
    Expect(1, 71487, '\p{Is_Script_Extensions=_-AHOM}', "");
    Expect(0, 71487, '\p{^Is_Script_Extensions=_-AHOM}', "");
    Expect(0, 71487, '\P{Is_Script_Extensions=_-AHOM}', "");
    Expect(1, 71487, '\P{^Is_Script_Extensions=_-AHOM}', "");
    Expect(0, 71488, '\p{Is_Script_Extensions=_-AHOM}', "");
    Expect(1, 71488, '\p{^Is_Script_Extensions=_-AHOM}', "");
    Expect(1, 71488, '\P{Is_Script_Extensions=_-AHOM}', "");
    Expect(0, 71488, '\P{^Is_Script_Extensions=_-AHOM}', "");
    Error('\p{Is_Scx=- AHOM/a/}');
    Error('\P{Is_Scx=- AHOM/a/}');
    Expect(1, 71487, '\p{Is_Scx=ahom}', "");
    Expect(0, 71487, '\p{^Is_Scx=ahom}', "");
    Expect(0, 71487, '\P{Is_Scx=ahom}', "");
    Expect(1, 71487, '\P{^Is_Scx=ahom}', "");
    Expect(0, 71488, '\p{Is_Scx=ahom}', "");
    Expect(1, 71488, '\p{^Is_Scx=ahom}', "");
    Expect(1, 71488, '\P{Is_Scx=ahom}', "");
    Expect(0, 71488, '\P{^Is_Scx=ahom}', "");
    Expect(1, 71487, '\p{Is_Scx=_-Ahom}', "");
    Expect(0, 71487, '\p{^Is_Scx=_-Ahom}', "");
    Expect(0, 71487, '\P{Is_Scx=_-Ahom}', "");
    Expect(1, 71487, '\P{^Is_Scx=_-Ahom}', "");
    Expect(0, 71488, '\p{Is_Scx=_-Ahom}', "");
    Expect(1, 71488, '\p{^Is_Scx=_-Ahom}', "");
    Expect(1, 71488, '\P{Is_Scx=_-Ahom}', "");
    Expect(0, 71488, '\P{^Is_Scx=_-Ahom}', "");
    Error('\p{Script_Extensions=ARABIC:=}');
    Error('\P{Script_Extensions=ARABIC:=}');
    Expect(1, 126705, '\p{Script_Extensions=arabic}', "");
    Expect(0, 126705, '\p{^Script_Extensions=arabic}', "");
    Expect(0, 126705, '\P{Script_Extensions=arabic}', "");
    Expect(1, 126705, '\P{^Script_Extensions=arabic}', "");
    Expect(0, 126706, '\p{Script_Extensions=arabic}', "");
    Expect(1, 126706, '\p{^Script_Extensions=arabic}', "");
    Expect(1, 126706, '\P{Script_Extensions=arabic}', "");
    Expect(0, 126706, '\P{^Script_Extensions=arabic}', "");
    Expect(1, 126705, '\p{Script_Extensions=	Arabic}', "");
    Expect(0, 126705, '\p{^Script_Extensions=	Arabic}', "");
    Expect(0, 126705, '\P{Script_Extensions=	Arabic}', "");
    Expect(1, 126705, '\P{^Script_Extensions=	Arabic}', "");
    Expect(0, 126706, '\p{Script_Extensions=	Arabic}', "");
    Expect(1, 126706, '\p{^Script_Extensions=	Arabic}', "");
    Expect(1, 126706, '\P{Script_Extensions=	Arabic}', "");
    Expect(0, 126706, '\P{^Script_Extensions=	Arabic}', "");
    Error('\p{Scx=	_ARAB:=}');
    Error('\P{Scx=	_ARAB:=}');
    Expect(1, 126705, '\p{Scx:arab}', "");
    Expect(0, 126705, '\p{^Scx:arab}', "");
    Expect(0, 126705, '\P{Scx:arab}', "");
    Expect(1, 126705, '\P{^Scx:arab}', "");
    Expect(0, 126706, '\p{Scx:arab}', "");
    Expect(1, 126706, '\p{^Scx:arab}', "");
    Expect(1, 126706, '\P{Scx:arab}', "");
    Expect(0, 126706, '\P{^Scx:arab}', "");
    Expect(1, 126705, '\p{Scx=_	ARAB}', "");
    Expect(0, 126705, '\p{^Scx=_	ARAB}', "");
    Expect(0, 126705, '\P{Scx=_	ARAB}', "");
    Expect(1, 126705, '\P{^Scx=_	ARAB}', "");
    Expect(0, 126706, '\p{Scx=_	ARAB}', "");
    Expect(1, 126706, '\p{^Scx=_	ARAB}', "");
    Expect(1, 126706, '\P{Scx=_	ARAB}', "");
    Expect(0, 126706, '\P{^Scx=_	ARAB}', "");
    Error('\p{Is_Script_Extensions=:= arabic}');
    Error('\P{Is_Script_Extensions=:= arabic}');
    Expect(1, 126705, '\p{Is_Script_Extensions: arabic}', "");
    Expect(0, 126705, '\p{^Is_Script_Extensions: arabic}', "");
    Expect(0, 126705, '\P{Is_Script_Extensions: arabic}', "");
    Expect(1, 126705, '\P{^Is_Script_Extensions: arabic}', "");
    Expect(0, 126706, '\p{Is_Script_Extensions: arabic}', "");
    Expect(1, 126706, '\p{^Is_Script_Extensions: arabic}', "");
    Expect(1, 126706, '\P{Is_Script_Extensions: arabic}', "");
    Expect(0, 126706, '\P{^Is_Script_Extensions: arabic}', "");
    Expect(1, 126705, '\p{Is_Script_Extensions=_ARABIC}', "");
    Expect(0, 126705, '\p{^Is_Script_Extensions=_ARABIC}', "");
    Expect(0, 126705, '\P{Is_Script_Extensions=_ARABIC}', "");
    Expect(1, 126705, '\P{^Is_Script_Extensions=_ARABIC}', "");
    Expect(0, 126706, '\p{Is_Script_Extensions=_ARABIC}', "");
    Expect(1, 126706, '\p{^Is_Script_Extensions=_ARABIC}', "");
    Expect(1, 126706, '\P{Is_Script_Extensions=_ARABIC}', "");
    Expect(0, 126706, '\P{^Is_Script_Extensions=_ARABIC}', "");
    Error('\p{Is_Scx:    -Arab:=}');
    Error('\P{Is_Scx:    -Arab:=}');
    Expect(1, 126705, '\p{Is_Scx=arab}', "");
    Expect(0, 126705, '\p{^Is_Scx=arab}', "");
    Expect(0, 126705, '\P{Is_Scx=arab}', "");
    Expect(1, 126705, '\P{^Is_Scx=arab}', "");
    Expect(0, 126706, '\p{Is_Scx=arab}', "");
    Expect(1, 126706, '\p{^Is_Scx=arab}', "");
    Expect(1, 126706, '\P{Is_Scx=arab}', "");
    Expect(0, 126706, '\P{^Is_Scx=arab}', "");
    Expect(1, 126705, '\p{Is_Scx=	_ARAB}', "");
    Expect(0, 126705, '\p{^Is_Scx=	_ARAB}', "");
    Expect(0, 126705, '\P{Is_Scx=	_ARAB}', "");
    Expect(1, 126705, '\P{^Is_Scx=	_ARAB}', "");
    Expect(0, 126706, '\p{Is_Scx=	_ARAB}', "");
    Expect(1, 126706, '\p{^Is_Scx=	_ARAB}', "");
    Expect(1, 126706, '\P{Is_Scx=	_ARAB}', "");
    Expect(0, 126706, '\P{^Is_Scx=	_ARAB}', "");
    Error('\p{Script_Extensions=	 Imperial_Aramaic/a/}');
    Error('\P{Script_Extensions=	 Imperial_Aramaic/a/}');
    Expect(1, 67679, '\p{Script_Extensions=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Script_Extensions=imperialaramaic}', "");
    Expect(0, 67679, '\P{Script_Extensions=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Script_Extensions=imperialaramaic}', "");
    Expect(0, 67680, '\p{Script_Extensions=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Script_Extensions=imperialaramaic}', "");
    Expect(1, 67680, '\P{Script_Extensions=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Script_Extensions=imperialaramaic}', "");
    Expect(1, 67679, '\p{Script_Extensions=_Imperial_aramaic}', "");
    Expect(0, 67679, '\p{^Script_Extensions=_Imperial_aramaic}', "");
    Expect(0, 67679, '\P{Script_Extensions=_Imperial_aramaic}', "");
    Expect(1, 67679, '\P{^Script_Extensions=_Imperial_aramaic}', "");
    Expect(0, 67680, '\p{Script_Extensions=_Imperial_aramaic}', "");
    Expect(1, 67680, '\p{^Script_Extensions=_Imperial_aramaic}', "");
    Expect(1, 67680, '\P{Script_Extensions=_Imperial_aramaic}', "");
    Expect(0, 67680, '\P{^Script_Extensions=_Imperial_aramaic}', "");
    Error('\p{Scx=/a/Armi}');
    Error('\P{Scx=/a/Armi}');
    Expect(1, 67679, '\p{Scx=armi}', "");
    Expect(0, 67679, '\p{^Scx=armi}', "");
    Expect(0, 67679, '\P{Scx=armi}', "");
    Expect(1, 67679, '\P{^Scx=armi}', "");
    Expect(0, 67680, '\p{Scx=armi}', "");
    Expect(1, 67680, '\p{^Scx=armi}', "");
    Expect(1, 67680, '\P{Scx=armi}', "");
    Expect(0, 67680, '\P{^Scx=armi}', "");
    Expect(1, 67679, '\p{Scx= Armi}', "");
    Expect(0, 67679, '\p{^Scx= Armi}', "");
    Expect(0, 67679, '\P{Scx= Armi}', "");
    Expect(1, 67679, '\P{^Scx= Armi}', "");
    Expect(0, 67680, '\p{Scx= Armi}', "");
    Expect(1, 67680, '\p{^Scx= Armi}', "");
    Expect(1, 67680, '\P{Scx= Armi}', "");
    Expect(0, 67680, '\P{^Scx= Armi}', "");
    Error('\p{Is_Script_Extensions:   /a/_-Imperial_Aramaic}');
    Error('\P{Is_Script_Extensions:   /a/_-Imperial_Aramaic}');
    Expect(1, 67679, '\p{Is_Script_Extensions=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Is_Script_Extensions=imperialaramaic}', "");
    Expect(0, 67679, '\P{Is_Script_Extensions=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Is_Script_Extensions=imperialaramaic}', "");
    Expect(0, 67680, '\p{Is_Script_Extensions=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Is_Script_Extensions=imperialaramaic}', "");
    Expect(1, 67680, '\P{Is_Script_Extensions=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Is_Script_Extensions=imperialaramaic}', "");
    Expect(1, 67679, '\p{Is_Script_Extensions= 	Imperial_Aramaic}', "");
    Expect(0, 67679, '\p{^Is_Script_Extensions= 	Imperial_Aramaic}', "");
    Expect(0, 67679, '\P{Is_Script_Extensions= 	Imperial_Aramaic}', "");
    Expect(1, 67679, '\P{^Is_Script_Extensions= 	Imperial_Aramaic}', "");
    Expect(0, 67680, '\p{Is_Script_Extensions= 	Imperial_Aramaic}', "");
    Expect(1, 67680, '\p{^Is_Script_Extensions= 	Imperial_Aramaic}', "");
    Expect(1, 67680, '\P{Is_Script_Extensions= 	Imperial_Aramaic}', "");
    Expect(0, 67680, '\P{^Is_Script_Extensions= 	Imperial_Aramaic}', "");
    Error('\p{Is_Scx:/a/__ARMI}');
    Error('\P{Is_Scx:/a/__ARMI}');
    Expect(1, 67679, '\p{Is_Scx=armi}', "");
    Expect(0, 67679, '\p{^Is_Scx=armi}', "");
    Expect(0, 67679, '\P{Is_Scx=armi}', "");
    Expect(1, 67679, '\P{^Is_Scx=armi}', "");
    Expect(0, 67680, '\p{Is_Scx=armi}', "");
    Expect(1, 67680, '\p{^Is_Scx=armi}', "");
    Expect(1, 67680, '\P{Is_Scx=armi}', "");
    Expect(0, 67680, '\P{^Is_Scx=armi}', "");
    Expect(1, 67679, '\p{Is_Scx=	_armi}', "");
    Expect(0, 67679, '\p{^Is_Scx=	_armi}', "");
    Expect(0, 67679, '\P{Is_Scx=	_armi}', "");
    Expect(1, 67679, '\P{^Is_Scx=	_armi}', "");
    Expect(0, 67680, '\p{Is_Scx=	_armi}', "");
    Expect(1, 67680, '\p{^Is_Scx=	_armi}', "");
    Expect(1, 67680, '\P{Is_Scx=	_armi}', "");
    Expect(0, 67680, '\P{^Is_Scx=	_armi}', "");
    Error('\p{Script_Extensions:	:=  Armenian}');
    Error('\P{Script_Extensions:	:=  Armenian}');
    Expect(1, 64279, '\p{Script_Extensions=armenian}', "");
    Expect(0, 64279, '\p{^Script_Extensions=armenian}', "");
    Expect(0, 64279, '\P{Script_Extensions=armenian}', "");
    Expect(1, 64279, '\P{^Script_Extensions=armenian}', "");
    Expect(0, 64280, '\p{Script_Extensions=armenian}', "");
    Expect(1, 64280, '\p{^Script_Extensions=armenian}', "");
    Expect(1, 64280, '\P{Script_Extensions=armenian}', "");
    Expect(0, 64280, '\P{^Script_Extensions=armenian}', "");
    Expect(1, 64279, '\p{Script_Extensions= armenian}', "");
    Expect(0, 64279, '\p{^Script_Extensions= armenian}', "");
    Expect(0, 64279, '\P{Script_Extensions= armenian}', "");
    Expect(1, 64279, '\P{^Script_Extensions= armenian}', "");
    Expect(0, 64280, '\p{Script_Extensions= armenian}', "");
    Expect(1, 64280, '\p{^Script_Extensions= armenian}', "");
    Expect(1, 64280, '\P{Script_Extensions= armenian}', "");
    Expect(0, 64280, '\P{^Script_Extensions= armenian}', "");
    Error('\p{Scx=/a/-_armn}');
    Error('\P{Scx=/a/-_armn}');
    Expect(1, 64279, '\p{Scx=armn}', "");
    Expect(0, 64279, '\p{^Scx=armn}', "");
    Expect(0, 64279, '\P{Scx=armn}', "");
    Expect(1, 64279, '\P{^Scx=armn}', "");
    Expect(0, 64280, '\p{Scx=armn}', "");
    Expect(1, 64280, '\p{^Scx=armn}', "");
    Expect(1, 64280, '\P{Scx=armn}', "");
    Expect(0, 64280, '\P{^Scx=armn}', "");
    Expect(1, 64279, '\p{Scx=-_ARMN}', "");
    Expect(0, 64279, '\p{^Scx=-_ARMN}', "");
    Expect(0, 64279, '\P{Scx=-_ARMN}', "");
    Expect(1, 64279, '\P{^Scx=-_ARMN}', "");
    Expect(0, 64280, '\p{Scx=-_ARMN}', "");
    Expect(1, 64280, '\p{^Scx=-_ARMN}', "");
    Expect(1, 64280, '\P{Scx=-_ARMN}', "");
    Expect(0, 64280, '\P{^Scx=-_ARMN}', "");
    Error('\p{Is_Script_Extensions=:=		ARMENIAN}');
    Error('\P{Is_Script_Extensions=:=		ARMENIAN}');
    Expect(1, 64279, '\p{Is_Script_Extensions=armenian}', "");
    Expect(0, 64279, '\p{^Is_Script_Extensions=armenian}', "");
    Expect(0, 64279, '\P{Is_Script_Extensions=armenian}', "");
    Expect(1, 64279, '\P{^Is_Script_Extensions=armenian}', "");
    Expect(0, 64280, '\p{Is_Script_Extensions=armenian}', "");
    Expect(1, 64280, '\p{^Is_Script_Extensions=armenian}', "");
    Expect(1, 64280, '\P{Is_Script_Extensions=armenian}', "");
    Expect(0, 64280, '\P{^Is_Script_Extensions=armenian}', "");
    Expect(1, 64279, '\p{Is_Script_Extensions=	 Armenian}', "");
    Expect(0, 64279, '\p{^Is_Script_Extensions=	 Armenian}', "");
    Expect(0, 64279, '\P{Is_Script_Extensions=	 Armenian}', "");
    Expect(1, 64279, '\P{^Is_Script_Extensions=	 Armenian}', "");
    Expect(0, 64280, '\p{Is_Script_Extensions=	 Armenian}', "");
    Expect(1, 64280, '\p{^Is_Script_Extensions=	 Armenian}', "");
    Expect(1, 64280, '\P{Is_Script_Extensions=	 Armenian}', "");
    Expect(0, 64280, '\P{^Is_Script_Extensions=	 Armenian}', "");
    Error('\p{Is_Scx=	ARMN:=}');
    Error('\P{Is_Scx=	ARMN:=}');
    Expect(1, 64279, '\p{Is_Scx=armn}', "");
    Expect(0, 64279, '\p{^Is_Scx=armn}', "");
    Expect(0, 64279, '\P{Is_Scx=armn}', "");
    Expect(1, 64279, '\P{^Is_Scx=armn}', "");
    Expect(0, 64280, '\p{Is_Scx=armn}', "");
    Expect(1, 64280, '\p{^Is_Scx=armn}', "");
    Expect(1, 64280, '\P{Is_Scx=armn}', "");
    Expect(0, 64280, '\P{^Is_Scx=armn}', "");
    Expect(1, 64279, '\p{Is_Scx= Armn}', "");
    Expect(0, 64279, '\p{^Is_Scx= Armn}', "");
    Expect(0, 64279, '\P{Is_Scx= Armn}', "");
    Expect(1, 64279, '\P{^Is_Scx= Armn}', "");
    Expect(0, 64280, '\p{Is_Scx= Armn}', "");
    Expect(1, 64280, '\p{^Is_Scx= Armn}', "");
    Expect(1, 64280, '\P{Is_Scx= Armn}', "");
    Expect(0, 64280, '\P{^Is_Scx= Armn}', "");
    Error('\p{Script_Extensions=:= avestan}');
    Error('\P{Script_Extensions=:= avestan}');
    Expect(1, 68415, '\p{Script_Extensions=avestan}', "");
    Expect(0, 68415, '\p{^Script_Extensions=avestan}', "");
    Expect(0, 68415, '\P{Script_Extensions=avestan}', "");
    Expect(1, 68415, '\P{^Script_Extensions=avestan}', "");
    Expect(0, 68416, '\p{Script_Extensions=avestan}', "");
    Expect(1, 68416, '\p{^Script_Extensions=avestan}', "");
    Expect(1, 68416, '\P{Script_Extensions=avestan}', "");
    Expect(0, 68416, '\P{^Script_Extensions=avestan}', "");
    Expect(1, 68415, '\p{Script_Extensions=--Avestan}', "");
    Expect(0, 68415, '\p{^Script_Extensions=--Avestan}', "");
    Expect(0, 68415, '\P{Script_Extensions=--Avestan}', "");
    Expect(1, 68415, '\P{^Script_Extensions=--Avestan}', "");
    Expect(0, 68416, '\p{Script_Extensions=--Avestan}', "");
    Expect(1, 68416, '\p{^Script_Extensions=--Avestan}', "");
    Expect(1, 68416, '\P{Script_Extensions=--Avestan}', "");
    Expect(0, 68416, '\P{^Script_Extensions=--Avestan}', "");
    Error('\p{Scx=Avst:=}');
    Error('\P{Scx=Avst:=}');
    Expect(1, 68415, '\p{Scx=avst}', "");
    Expect(0, 68415, '\p{^Scx=avst}', "");
    Expect(0, 68415, '\P{Scx=avst}', "");
    Expect(1, 68415, '\P{^Scx=avst}', "");
    Expect(0, 68416, '\p{Scx=avst}', "");
    Expect(1, 68416, '\p{^Scx=avst}', "");
    Expect(1, 68416, '\P{Scx=avst}', "");
    Expect(0, 68416, '\P{^Scx=avst}', "");
    Expect(1, 68415, '\p{Scx=-_AVST}', "");
    Expect(0, 68415, '\p{^Scx=-_AVST}', "");
    Expect(0, 68415, '\P{Scx=-_AVST}', "");
    Expect(1, 68415, '\P{^Scx=-_AVST}', "");
    Expect(0, 68416, '\p{Scx=-_AVST}', "");
    Expect(1, 68416, '\p{^Scx=-_AVST}', "");
    Expect(1, 68416, '\P{Scx=-_AVST}', "");
    Expect(0, 68416, '\P{^Scx=-_AVST}', "");
    Error('\p{Is_Script_Extensions:	_Avestan:=}');
    Error('\P{Is_Script_Extensions:	_Avestan:=}');
    Expect(1, 68415, '\p{Is_Script_Extensions=avestan}', "");
    Expect(0, 68415, '\p{^Is_Script_Extensions=avestan}', "");
    Expect(0, 68415, '\P{Is_Script_Extensions=avestan}', "");
    Expect(1, 68415, '\P{^Is_Script_Extensions=avestan}', "");
    Expect(0, 68416, '\p{Is_Script_Extensions=avestan}', "");
    Expect(1, 68416, '\p{^Is_Script_Extensions=avestan}', "");
    Expect(1, 68416, '\P{Is_Script_Extensions=avestan}', "");
    Expect(0, 68416, '\P{^Is_Script_Extensions=avestan}', "");
    Expect(1, 68415, '\p{Is_Script_Extensions:   	AVESTAN}', "");
    Expect(0, 68415, '\p{^Is_Script_Extensions:   	AVESTAN}', "");
    Expect(0, 68415, '\P{Is_Script_Extensions:   	AVESTAN}', "");
    Expect(1, 68415, '\P{^Is_Script_Extensions:   	AVESTAN}', "");
    Expect(0, 68416, '\p{Is_Script_Extensions:   	AVESTAN}', "");
    Expect(1, 68416, '\p{^Is_Script_Extensions:   	AVESTAN}', "");
    Expect(1, 68416, '\P{Is_Script_Extensions:   	AVESTAN}', "");
    Expect(0, 68416, '\P{^Is_Script_Extensions:   	AVESTAN}', "");
    Error('\p{Is_Scx= AVST:=}');
    Error('\P{Is_Scx= AVST:=}');
    Expect(1, 68415, '\p{Is_Scx=avst}', "");
    Expect(0, 68415, '\p{^Is_Scx=avst}', "");
    Expect(0, 68415, '\P{Is_Scx=avst}', "");
    Expect(1, 68415, '\P{^Is_Scx=avst}', "");
    Expect(0, 68416, '\p{Is_Scx=avst}', "");
    Expect(1, 68416, '\p{^Is_Scx=avst}', "");
    Expect(1, 68416, '\P{Is_Scx=avst}', "");
    Expect(0, 68416, '\P{^Is_Scx=avst}', "");
    Expect(1, 68415, '\p{Is_Scx=- Avst}', "");
    Expect(0, 68415, '\p{^Is_Scx=- Avst}', "");
    Expect(0, 68415, '\P{Is_Scx=- Avst}', "");
    Expect(1, 68415, '\P{^Is_Scx=- Avst}', "");
    Expect(0, 68416, '\p{Is_Scx=- Avst}', "");
    Expect(1, 68416, '\p{^Is_Scx=- Avst}', "");
    Expect(1, 68416, '\P{Is_Scx=- Avst}', "");
    Expect(0, 68416, '\P{^Is_Scx=- Avst}', "");
    Error('\p{Script_Extensions=	 Balinese:=}');
    Error('\P{Script_Extensions=	 Balinese:=}');
    Expect(1, 7036, '\p{Script_Extensions=balinese}', "");
    Expect(0, 7036, '\p{^Script_Extensions=balinese}', "");
    Expect(0, 7036, '\P{Script_Extensions=balinese}', "");
    Expect(1, 7036, '\P{^Script_Extensions=balinese}', "");
    Expect(0, 7037, '\p{Script_Extensions=balinese}', "");
    Expect(1, 7037, '\p{^Script_Extensions=balinese}', "");
    Expect(1, 7037, '\P{Script_Extensions=balinese}', "");
    Expect(0, 7037, '\P{^Script_Extensions=balinese}', "");
    Expect(1, 7036, '\p{Script_Extensions=--Balinese}', "");
    Expect(0, 7036, '\p{^Script_Extensions=--Balinese}', "");
    Expect(0, 7036, '\P{Script_Extensions=--Balinese}', "");
    Expect(1, 7036, '\P{^Script_Extensions=--Balinese}', "");
    Expect(0, 7037, '\p{Script_Extensions=--Balinese}', "");
    Expect(1, 7037, '\p{^Script_Extensions=--Balinese}', "");
    Expect(1, 7037, '\P{Script_Extensions=--Balinese}', "");
    Expect(0, 7037, '\P{^Script_Extensions=--Balinese}', "");
    Error('\p{Scx=--BALI:=}');
    Error('\P{Scx=--BALI:=}');
    Expect(1, 7036, '\p{Scx=bali}', "");
    Expect(0, 7036, '\p{^Scx=bali}', "");
    Expect(0, 7036, '\P{Scx=bali}', "");
    Expect(1, 7036, '\P{^Scx=bali}', "");
    Expect(0, 7037, '\p{Scx=bali}', "");
    Expect(1, 7037, '\p{^Scx=bali}', "");
    Expect(1, 7037, '\P{Scx=bali}', "");
    Expect(0, 7037, '\P{^Scx=bali}', "");
    Expect(1, 7036, '\p{Scx=-	bali}', "");
    Expect(0, 7036, '\p{^Scx=-	bali}', "");
    Expect(0, 7036, '\P{Scx=-	bali}', "");
    Expect(1, 7036, '\P{^Scx=-	bali}', "");
    Expect(0, 7037, '\p{Scx=-	bali}', "");
    Expect(1, 7037, '\p{^Scx=-	bali}', "");
    Expect(1, 7037, '\P{Scx=-	bali}', "");
    Expect(0, 7037, '\P{^Scx=-	bali}', "");
    Error('\p{Is_Script_Extensions= -BALINESE/a/}');
    Error('\P{Is_Script_Extensions= -BALINESE/a/}');
    Expect(1, 7036, '\p{Is_Script_Extensions=balinese}', "");
    Expect(0, 7036, '\p{^Is_Script_Extensions=balinese}', "");
    Expect(0, 7036, '\P{Is_Script_Extensions=balinese}', "");
    Expect(1, 7036, '\P{^Is_Script_Extensions=balinese}', "");
    Expect(0, 7037, '\p{Is_Script_Extensions=balinese}', "");
    Expect(1, 7037, '\p{^Is_Script_Extensions=balinese}', "");
    Expect(1, 7037, '\P{Is_Script_Extensions=balinese}', "");
    Expect(0, 7037, '\P{^Is_Script_Extensions=balinese}', "");
    Expect(1, 7036, '\p{Is_Script_Extensions= balinese}', "");
    Expect(0, 7036, '\p{^Is_Script_Extensions= balinese}', "");
    Expect(0, 7036, '\P{Is_Script_Extensions= balinese}', "");
    Expect(1, 7036, '\P{^Is_Script_Extensions= balinese}', "");
    Expect(0, 7037, '\p{Is_Script_Extensions= balinese}', "");
    Expect(1, 7037, '\p{^Is_Script_Extensions= balinese}', "");
    Expect(1, 7037, '\P{Is_Script_Extensions= balinese}', "");
    Expect(0, 7037, '\P{^Is_Script_Extensions= balinese}', "");
    Error('\p{Is_Scx=_	BALI:=}');
    Error('\P{Is_Scx=_	BALI:=}');
    Expect(1, 7036, '\p{Is_Scx:bali}', "");
    Expect(0, 7036, '\p{^Is_Scx:bali}', "");
    Expect(0, 7036, '\P{Is_Scx:bali}', "");
    Expect(1, 7036, '\P{^Is_Scx:bali}', "");
    Expect(0, 7037, '\p{Is_Scx:bali}', "");
    Expect(1, 7037, '\p{^Is_Scx:bali}', "");
    Expect(1, 7037, '\P{Is_Scx:bali}', "");
    Expect(0, 7037, '\P{^Is_Scx:bali}', "");
    Expect(1, 7036, '\p{Is_Scx=--BALI}', "");
    Expect(0, 7036, '\p{^Is_Scx=--BALI}', "");
    Expect(0, 7036, '\P{Is_Scx=--BALI}', "");
    Expect(1, 7036, '\P{^Is_Scx=--BALI}', "");
    Expect(0, 7037, '\p{Is_Scx=--BALI}', "");
    Expect(1, 7037, '\p{^Is_Scx=--BALI}', "");
    Expect(1, 7037, '\P{Is_Scx=--BALI}', "");
    Expect(0, 7037, '\P{^Is_Scx=--BALI}', "");
    Error('\p{Script_Extensions=:=_bamum}');
    Error('\P{Script_Extensions=:=_bamum}');
    Expect(1, 92728, '\p{Script_Extensions=bamum}', "");
    Expect(0, 92728, '\p{^Script_Extensions=bamum}', "");
    Expect(0, 92728, '\P{Script_Extensions=bamum}', "");
    Expect(1, 92728, '\P{^Script_Extensions=bamum}', "");
    Expect(0, 92729, '\p{Script_Extensions=bamum}', "");
    Expect(1, 92729, '\p{^Script_Extensions=bamum}', "");
    Expect(1, 92729, '\P{Script_Extensions=bamum}', "");
    Expect(0, 92729, '\P{^Script_Extensions=bamum}', "");
    Expect(1, 92728, '\p{Script_Extensions=	Bamum}', "");
    Expect(0, 92728, '\p{^Script_Extensions=	Bamum}', "");
    Expect(0, 92728, '\P{Script_Extensions=	Bamum}', "");
    Expect(1, 92728, '\P{^Script_Extensions=	Bamum}', "");
    Expect(0, 92729, '\p{Script_Extensions=	Bamum}', "");
    Expect(1, 92729, '\p{^Script_Extensions=	Bamum}', "");
    Expect(1, 92729, '\P{Script_Extensions=	Bamum}', "");
    Expect(0, 92729, '\P{^Script_Extensions=	Bamum}', "");
    Error('\p{Scx: -	BAMU/a/}');
    Error('\P{Scx: -	BAMU/a/}');
    Expect(1, 92728, '\p{Scx=bamu}', "");
    Expect(0, 92728, '\p{^Scx=bamu}', "");
    Expect(0, 92728, '\P{Scx=bamu}', "");
    Expect(1, 92728, '\P{^Scx=bamu}', "");
    Expect(0, 92729, '\p{Scx=bamu}', "");
    Expect(1, 92729, '\p{^Scx=bamu}', "");
    Expect(1, 92729, '\P{Scx=bamu}', "");
    Expect(0, 92729, '\P{^Scx=bamu}', "");
    Expect(1, 92728, '\p{Scx=-Bamu}', "");
    Expect(0, 92728, '\p{^Scx=-Bamu}', "");
    Expect(0, 92728, '\P{Scx=-Bamu}', "");
    Expect(1, 92728, '\P{^Scx=-Bamu}', "");
    Expect(0, 92729, '\p{Scx=-Bamu}', "");
    Expect(1, 92729, '\p{^Scx=-Bamu}', "");
    Expect(1, 92729, '\P{Scx=-Bamu}', "");
    Expect(0, 92729, '\P{^Scx=-Bamu}', "");
    Error('\p{Is_Script_Extensions=-_Bamum:=}');
    Error('\P{Is_Script_Extensions=-_Bamum:=}');
    Expect(1, 92728, '\p{Is_Script_Extensions:bamum}', "");
    Expect(0, 92728, '\p{^Is_Script_Extensions:bamum}', "");
    Expect(0, 92728, '\P{Is_Script_Extensions:bamum}', "");
    Expect(1, 92728, '\P{^Is_Script_Extensions:bamum}', "");
    Expect(0, 92729, '\p{Is_Script_Extensions:bamum}', "");
    Expect(1, 92729, '\p{^Is_Script_Extensions:bamum}', "");
    Expect(1, 92729, '\P{Is_Script_Extensions:bamum}', "");
    Expect(0, 92729, '\P{^Is_Script_Extensions:bamum}', "");
    Expect(1, 92728, '\p{Is_Script_Extensions=	 bamum}', "");
    Expect(0, 92728, '\p{^Is_Script_Extensions=	 bamum}', "");
    Expect(0, 92728, '\P{Is_Script_Extensions=	 bamum}', "");
    Expect(1, 92728, '\P{^Is_Script_Extensions=	 bamum}', "");
    Expect(0, 92729, '\p{Is_Script_Extensions=	 bamum}', "");
    Expect(1, 92729, '\p{^Is_Script_Extensions=	 bamum}', "");
    Expect(1, 92729, '\P{Is_Script_Extensions=	 bamum}', "");
    Expect(0, 92729, '\P{^Is_Script_Extensions=	 bamum}', "");
    Error('\p{Is_Scx: :=Bamu}');
    Error('\P{Is_Scx: :=Bamu}');
    Expect(1, 92728, '\p{Is_Scx=bamu}', "");
    Expect(0, 92728, '\p{^Is_Scx=bamu}', "");
    Expect(0, 92728, '\P{Is_Scx=bamu}', "");
    Expect(1, 92728, '\P{^Is_Scx=bamu}', "");
    Expect(0, 92729, '\p{Is_Scx=bamu}', "");
    Expect(1, 92729, '\p{^Is_Scx=bamu}', "");
    Expect(1, 92729, '\P{Is_Scx=bamu}', "");
    Expect(0, 92729, '\P{^Is_Scx=bamu}', "");
    Expect(1, 92728, '\p{Is_Scx:	-Bamu}', "");
    Expect(0, 92728, '\p{^Is_Scx:	-Bamu}', "");
    Expect(0, 92728, '\P{Is_Scx:	-Bamu}', "");
    Expect(1, 92728, '\P{^Is_Scx:	-Bamu}', "");
    Expect(0, 92729, '\p{Is_Scx:	-Bamu}', "");
    Expect(1, 92729, '\p{^Is_Scx:	-Bamu}', "");
    Expect(1, 92729, '\P{Is_Scx:	-Bamu}', "");
    Expect(0, 92729, '\P{^Is_Scx:	-Bamu}', "");
    Error('\p{Script_Extensions= Bassa_vah/a/}');
    Error('\P{Script_Extensions= Bassa_vah/a/}');
    Expect(1, 92917, '\p{Script_Extensions=bassavah}', "");
    Expect(0, 92917, '\p{^Script_Extensions=bassavah}', "");
    Expect(0, 92917, '\P{Script_Extensions=bassavah}', "");
    Expect(1, 92917, '\P{^Script_Extensions=bassavah}', "");
    Expect(0, 92918, '\p{Script_Extensions=bassavah}', "");
    Expect(1, 92918, '\p{^Script_Extensions=bassavah}', "");
    Expect(1, 92918, '\P{Script_Extensions=bassavah}', "");
    Expect(0, 92918, '\P{^Script_Extensions=bassavah}', "");
    Expect(1, 92917, '\p{Script_Extensions=--bassa_Vah}', "");
    Expect(0, 92917, '\p{^Script_Extensions=--bassa_Vah}', "");
    Expect(0, 92917, '\P{Script_Extensions=--bassa_Vah}', "");
    Expect(1, 92917, '\P{^Script_Extensions=--bassa_Vah}', "");
    Expect(0, 92918, '\p{Script_Extensions=--bassa_Vah}', "");
    Expect(1, 92918, '\p{^Script_Extensions=--bassa_Vah}', "");
    Expect(1, 92918, '\P{Script_Extensions=--bassa_Vah}', "");
    Expect(0, 92918, '\P{^Script_Extensions=--bassa_Vah}', "");
    Error('\p{Scx: -:=BASS}');
    Error('\P{Scx: -:=BASS}');
    Expect(1, 92917, '\p{Scx=bass}', "");
    Expect(0, 92917, '\p{^Scx=bass}', "");
    Expect(0, 92917, '\P{Scx=bass}', "");
    Expect(1, 92917, '\P{^Scx=bass}', "");
    Expect(0, 92918, '\p{Scx=bass}', "");
    Expect(1, 92918, '\p{^Scx=bass}', "");
    Expect(1, 92918, '\P{Scx=bass}', "");
    Expect(0, 92918, '\P{^Scx=bass}', "");
    Expect(1, 92917, '\p{Scx= -BASS}', "");
    Expect(0, 92917, '\p{^Scx= -BASS}', "");
    Expect(0, 92917, '\P{Scx= -BASS}', "");
    Expect(1, 92917, '\P{^Scx= -BASS}', "");
    Expect(0, 92918, '\p{Scx= -BASS}', "");
    Expect(1, 92918, '\p{^Scx= -BASS}', "");
    Expect(1, 92918, '\P{Scx= -BASS}', "");
    Expect(0, 92918, '\P{^Scx= -BASS}', "");
    Error('\p{Is_Script_Extensions=/a/	bassa_Vah}');
    Error('\P{Is_Script_Extensions=/a/	bassa_Vah}');
    Expect(1, 92917, '\p{Is_Script_Extensions=bassavah}', "");
    Expect(0, 92917, '\p{^Is_Script_Extensions=bassavah}', "");
    Expect(0, 92917, '\P{Is_Script_Extensions=bassavah}', "");
    Expect(1, 92917, '\P{^Is_Script_Extensions=bassavah}', "");
    Expect(0, 92918, '\p{Is_Script_Extensions=bassavah}', "");
    Expect(1, 92918, '\p{^Is_Script_Extensions=bassavah}', "");
    Expect(1, 92918, '\P{Is_Script_Extensions=bassavah}', "");
    Expect(0, 92918, '\P{^Is_Script_Extensions=bassavah}', "");
    Expect(1, 92917, '\p{Is_Script_Extensions:	  Bassa_Vah}', "");
    Expect(0, 92917, '\p{^Is_Script_Extensions:	  Bassa_Vah}', "");
    Expect(0, 92917, '\P{Is_Script_Extensions:	  Bassa_Vah}', "");
    Expect(1, 92917, '\P{^Is_Script_Extensions:	  Bassa_Vah}', "");
    Expect(0, 92918, '\p{Is_Script_Extensions:	  Bassa_Vah}', "");
    Expect(1, 92918, '\p{^Is_Script_Extensions:	  Bassa_Vah}', "");
    Expect(1, 92918, '\P{Is_Script_Extensions:	  Bassa_Vah}', "");
    Expect(0, 92918, '\P{^Is_Script_Extensions:	  Bassa_Vah}', "");
    Error('\p{Is_Scx:	/a/-_bass}');
    Error('\P{Is_Scx:	/a/-_bass}');
    Expect(1, 92917, '\p{Is_Scx:   bass}', "");
    Expect(0, 92917, '\p{^Is_Scx:   bass}', "");
    Expect(0, 92917, '\P{Is_Scx:   bass}', "");
    Expect(1, 92917, '\P{^Is_Scx:   bass}', "");
    Expect(0, 92918, '\p{Is_Scx:   bass}', "");
    Expect(1, 92918, '\p{^Is_Scx:   bass}', "");
    Expect(1, 92918, '\P{Is_Scx:   bass}', "");
    Expect(0, 92918, '\P{^Is_Scx:   bass}', "");
    Expect(1, 92917, '\p{Is_Scx= -Bass}', "");
    Expect(0, 92917, '\p{^Is_Scx= -Bass}', "");
    Expect(0, 92917, '\P{Is_Scx= -Bass}', "");
    Expect(1, 92917, '\P{^Is_Scx= -Bass}', "");
    Expect(0, 92918, '\p{Is_Scx= -Bass}', "");
    Expect(1, 92918, '\p{^Is_Scx= -Bass}', "");
    Expect(1, 92918, '\P{Is_Scx= -Bass}', "");
    Expect(0, 92918, '\P{^Is_Scx= -Bass}', "");
    Error('\p{Script_Extensions=/a/	_Batak}');
    Error('\P{Script_Extensions=/a/	_Batak}');
    Expect(1, 7167, '\p{Script_Extensions:batak}', "");
    Expect(0, 7167, '\p{^Script_Extensions:batak}', "");
    Expect(0, 7167, '\P{Script_Extensions:batak}', "");
    Expect(1, 7167, '\P{^Script_Extensions:batak}', "");
    Expect(0, 7168, '\p{Script_Extensions:batak}', "");
    Expect(1, 7168, '\p{^Script_Extensions:batak}', "");
    Expect(1, 7168, '\P{Script_Extensions:batak}', "");
    Expect(0, 7168, '\P{^Script_Extensions:batak}', "");
    Expect(1, 7167, '\p{Script_Extensions=_ batak}', "");
    Expect(0, 7167, '\p{^Script_Extensions=_ batak}', "");
    Expect(0, 7167, '\P{Script_Extensions=_ batak}', "");
    Expect(1, 7167, '\P{^Script_Extensions=_ batak}', "");
    Expect(0, 7168, '\p{Script_Extensions=_ batak}', "");
    Expect(1, 7168, '\p{^Script_Extensions=_ batak}', "");
    Expect(1, 7168, '\P{Script_Extensions=_ batak}', "");
    Expect(0, 7168, '\P{^Script_Extensions=_ batak}', "");
    Error('\p{Scx=_ Batk:=}');
    Error('\P{Scx=_ Batk:=}');
    Expect(1, 7167, '\p{Scx=batk}', "");
    Expect(0, 7167, '\p{^Scx=batk}', "");
    Expect(0, 7167, '\P{Scx=batk}', "");
    Expect(1, 7167, '\P{^Scx=batk}', "");
    Expect(0, 7168, '\p{Scx=batk}', "");
    Expect(1, 7168, '\p{^Scx=batk}', "");
    Expect(1, 7168, '\P{Scx=batk}', "");
    Expect(0, 7168, '\P{^Scx=batk}', "");
    Expect(1, 7167, '\p{Scx=  batk}', "");
    Expect(0, 7167, '\p{^Scx=  batk}', "");
    Expect(0, 7167, '\P{Scx=  batk}', "");
    Expect(1, 7167, '\P{^Scx=  batk}', "");
    Expect(0, 7168, '\p{Scx=  batk}', "");
    Expect(1, 7168, '\p{^Scx=  batk}', "");
    Expect(1, 7168, '\P{Scx=  batk}', "");
    Expect(0, 7168, '\P{^Scx=  batk}', "");
    Error('\p{Is_Script_Extensions=/a/	_Batak}');
    Error('\P{Is_Script_Extensions=/a/	_Batak}');
    Expect(1, 7167, '\p{Is_Script_Extensions=batak}', "");
    Expect(0, 7167, '\p{^Is_Script_Extensions=batak}', "");
    Expect(0, 7167, '\P{Is_Script_Extensions=batak}', "");
    Expect(1, 7167, '\P{^Is_Script_Extensions=batak}', "");
    Expect(0, 7168, '\p{Is_Script_Extensions=batak}', "");
    Expect(1, 7168, '\p{^Is_Script_Extensions=batak}', "");
    Expect(1, 7168, '\P{Is_Script_Extensions=batak}', "");
    Expect(0, 7168, '\P{^Is_Script_Extensions=batak}', "");
    Expect(1, 7167, '\p{Is_Script_Extensions= Batak}', "");
    Expect(0, 7167, '\p{^Is_Script_Extensions= Batak}', "");
    Expect(0, 7167, '\P{Is_Script_Extensions= Batak}', "");
    Expect(1, 7167, '\P{^Is_Script_Extensions= Batak}', "");
    Expect(0, 7168, '\p{Is_Script_Extensions= Batak}', "");
    Expect(1, 7168, '\p{^Is_Script_Extensions= Batak}', "");
    Expect(1, 7168, '\P{Is_Script_Extensions= Batak}', "");
    Expect(0, 7168, '\P{^Is_Script_Extensions= Batak}', "");
    Error('\p{Is_Scx=/a/ 	batk}');
    Error('\P{Is_Scx=/a/ 	batk}');
    Expect(1, 7167, '\p{Is_Scx=batk}', "");
    Expect(0, 7167, '\p{^Is_Scx=batk}', "");
    Expect(0, 7167, '\P{Is_Scx=batk}', "");
    Expect(1, 7167, '\P{^Is_Scx=batk}', "");
    Expect(0, 7168, '\p{Is_Scx=batk}', "");
    Expect(1, 7168, '\p{^Is_Scx=batk}', "");
    Expect(1, 7168, '\P{Is_Scx=batk}', "");
    Expect(0, 7168, '\P{^Is_Scx=batk}', "");
    Expect(1, 7167, '\p{Is_Scx=- Batk}', "");
    Expect(0, 7167, '\p{^Is_Scx=- Batk}', "");
    Expect(0, 7167, '\P{Is_Scx=- Batk}', "");
    Expect(1, 7167, '\P{^Is_Scx=- Batk}', "");
    Expect(0, 7168, '\p{Is_Scx=- Batk}', "");
    Expect(1, 7168, '\p{^Is_Scx=- Batk}', "");
    Expect(1, 7168, '\P{Is_Scx=- Batk}', "");
    Expect(0, 7168, '\P{^Is_Scx=- Batk}', "");
    Error('\p{Script_Extensions=/a/- Bengali}');
    Error('\P{Script_Extensions=/a/- Bengali}');
    Expect(1, 43249, '\p{Script_Extensions=bengali}', "");
    Expect(0, 43249, '\p{^Script_Extensions=bengali}', "");
    Expect(0, 43249, '\P{Script_Extensions=bengali}', "");
    Expect(1, 43249, '\P{^Script_Extensions=bengali}', "");
    Expect(0, 43250, '\p{Script_Extensions=bengali}', "");
    Expect(1, 43250, '\p{^Script_Extensions=bengali}', "");
    Expect(1, 43250, '\P{Script_Extensions=bengali}', "");
    Expect(0, 43250, '\P{^Script_Extensions=bengali}', "");
    Expect(1, 43249, '\p{Script_Extensions:	 bengali}', "");
    Expect(0, 43249, '\p{^Script_Extensions:	 bengali}', "");
    Expect(0, 43249, '\P{Script_Extensions:	 bengali}', "");
    Expect(1, 43249, '\P{^Script_Extensions:	 bengali}', "");
    Expect(0, 43250, '\p{Script_Extensions:	 bengali}', "");
    Expect(1, 43250, '\p{^Script_Extensions:	 bengali}', "");
    Expect(1, 43250, '\P{Script_Extensions:	 bengali}', "");
    Expect(0, 43250, '\P{^Script_Extensions:	 bengali}', "");
    Error('\p{Scx=:= -Beng}');
    Error('\P{Scx=:= -Beng}');
    Expect(1, 43249, '\p{Scx=beng}', "");
    Expect(0, 43249, '\p{^Scx=beng}', "");
    Expect(0, 43249, '\P{Scx=beng}', "");
    Expect(1, 43249, '\P{^Scx=beng}', "");
    Expect(0, 43250, '\p{Scx=beng}', "");
    Expect(1, 43250, '\p{^Scx=beng}', "");
    Expect(1, 43250, '\P{Scx=beng}', "");
    Expect(0, 43250, '\P{^Scx=beng}', "");
    Expect(1, 43249, '\p{Scx:  _Beng}', "");
    Expect(0, 43249, '\p{^Scx:  _Beng}', "");
    Expect(0, 43249, '\P{Scx:  _Beng}', "");
    Expect(1, 43249, '\P{^Scx:  _Beng}', "");
    Expect(0, 43250, '\p{Scx:  _Beng}', "");
    Expect(1, 43250, '\p{^Scx:  _Beng}', "");
    Expect(1, 43250, '\P{Scx:  _Beng}', "");
    Expect(0, 43250, '\P{^Scx:  _Beng}', "");
    Error('\p{Is_Script_Extensions=/a/ -BENGALI}');
    Error('\P{Is_Script_Extensions=/a/ -BENGALI}');
    Expect(1, 43249, '\p{Is_Script_Extensions=bengali}', "");
    Expect(0, 43249, '\p{^Is_Script_Extensions=bengali}', "");
    Expect(0, 43249, '\P{Is_Script_Extensions=bengali}', "");
    Expect(1, 43249, '\P{^Is_Script_Extensions=bengali}', "");
    Expect(0, 43250, '\p{Is_Script_Extensions=bengali}', "");
    Expect(1, 43250, '\p{^Is_Script_Extensions=bengali}', "");
    Expect(1, 43250, '\P{Is_Script_Extensions=bengali}', "");
    Expect(0, 43250, '\P{^Is_Script_Extensions=bengali}', "");
    Expect(1, 43249, '\p{Is_Script_Extensions=_bengali}', "");
    Expect(0, 43249, '\p{^Is_Script_Extensions=_bengali}', "");
    Expect(0, 43249, '\P{Is_Script_Extensions=_bengali}', "");
    Expect(1, 43249, '\P{^Is_Script_Extensions=_bengali}', "");
    Expect(0, 43250, '\p{Is_Script_Extensions=_bengali}', "");
    Expect(1, 43250, '\p{^Is_Script_Extensions=_bengali}', "");
    Expect(1, 43250, '\P{Is_Script_Extensions=_bengali}', "");
    Expect(0, 43250, '\P{^Is_Script_Extensions=_bengali}', "");
    Error('\p{Is_Scx=	_beng:=}');
    Error('\P{Is_Scx=	_beng:=}');
    Expect(1, 43249, '\p{Is_Scx=beng}', "");
    Expect(0, 43249, '\p{^Is_Scx=beng}', "");
    Expect(0, 43249, '\P{Is_Scx=beng}', "");
    Expect(1, 43249, '\P{^Is_Scx=beng}', "");
    Expect(0, 43250, '\p{Is_Scx=beng}', "");
    Expect(1, 43250, '\p{^Is_Scx=beng}', "");
    Expect(1, 43250, '\P{Is_Scx=beng}', "");
    Expect(0, 43250, '\P{^Is_Scx=beng}', "");
    Expect(1, 43249, '\p{Is_Scx=__BENG}', "");
    Expect(0, 43249, '\p{^Is_Scx=__BENG}', "");
    Expect(0, 43249, '\P{Is_Scx=__BENG}', "");
    Expect(1, 43249, '\P{^Is_Scx=__BENG}', "");
    Expect(0, 43250, '\p{Is_Scx=__BENG}', "");
    Expect(1, 43250, '\p{^Is_Scx=__BENG}', "");
    Expect(1, 43250, '\P{Is_Scx=__BENG}', "");
    Expect(0, 43250, '\P{^Is_Scx=__BENG}', "");
    Error('\p{Script_Extensions=:=BHAIKSUKI}');
    Error('\P{Script_Extensions=:=BHAIKSUKI}');
    Expect(1, 72812, '\p{Script_Extensions: bhaiksuki}', "");
    Expect(0, 72812, '\p{^Script_Extensions: bhaiksuki}', "");
    Expect(0, 72812, '\P{Script_Extensions: bhaiksuki}', "");
    Expect(1, 72812, '\P{^Script_Extensions: bhaiksuki}', "");
    Expect(0, 72813, '\p{Script_Extensions: bhaiksuki}', "");
    Expect(1, 72813, '\p{^Script_Extensions: bhaiksuki}', "");
    Expect(1, 72813, '\P{Script_Extensions: bhaiksuki}', "");
    Expect(0, 72813, '\P{^Script_Extensions: bhaiksuki}', "");
    Expect(1, 72812, '\p{Script_Extensions= BHAIKSUKI}', "");
    Expect(0, 72812, '\p{^Script_Extensions= BHAIKSUKI}', "");
    Expect(0, 72812, '\P{Script_Extensions= BHAIKSUKI}', "");
    Expect(1, 72812, '\P{^Script_Extensions= BHAIKSUKI}', "");
    Expect(0, 72813, '\p{Script_Extensions= BHAIKSUKI}', "");
    Expect(1, 72813, '\p{^Script_Extensions= BHAIKSUKI}', "");
    Expect(1, 72813, '\P{Script_Extensions= BHAIKSUKI}', "");
    Expect(0, 72813, '\P{^Script_Extensions= BHAIKSUKI}', "");
    Error('\p{Scx=_bhks:=}');
    Error('\P{Scx=_bhks:=}');
    Expect(1, 72812, '\p{Scx=bhks}', "");
    Expect(0, 72812, '\p{^Scx=bhks}', "");
    Expect(0, 72812, '\P{Scx=bhks}', "");
    Expect(1, 72812, '\P{^Scx=bhks}', "");
    Expect(0, 72813, '\p{Scx=bhks}', "");
    Expect(1, 72813, '\p{^Scx=bhks}', "");
    Expect(1, 72813, '\P{Scx=bhks}', "");
    Expect(0, 72813, '\P{^Scx=bhks}', "");
    Expect(1, 72812, '\p{Scx= bhks}', "");
    Expect(0, 72812, '\p{^Scx= bhks}', "");
    Expect(0, 72812, '\P{Scx= bhks}', "");
    Expect(1, 72812, '\P{^Scx= bhks}', "");
    Expect(0, 72813, '\p{Scx= bhks}', "");
    Expect(1, 72813, '\p{^Scx= bhks}', "");
    Expect(1, 72813, '\P{Scx= bhks}', "");
    Expect(0, 72813, '\P{^Scx= bhks}', "");
    Error('\p{Is_Script_Extensions=- BHAIKSUKI:=}');
    Error('\P{Is_Script_Extensions=- BHAIKSUKI:=}');
    Expect(1, 72812, '\p{Is_Script_Extensions=bhaiksuki}', "");
    Expect(0, 72812, '\p{^Is_Script_Extensions=bhaiksuki}', "");
    Expect(0, 72812, '\P{Is_Script_Extensions=bhaiksuki}', "");
    Expect(1, 72812, '\P{^Is_Script_Extensions=bhaiksuki}', "");
    Expect(0, 72813, '\p{Is_Script_Extensions=bhaiksuki}', "");
    Expect(1, 72813, '\p{^Is_Script_Extensions=bhaiksuki}', "");
    Expect(1, 72813, '\P{Is_Script_Extensions=bhaiksuki}', "");
    Expect(0, 72813, '\P{^Is_Script_Extensions=bhaiksuki}', "");
    Expect(1, 72812, '\p{Is_Script_Extensions=_ BHAIKSUKI}', "");
    Expect(0, 72812, '\p{^Is_Script_Extensions=_ BHAIKSUKI}', "");
    Expect(0, 72812, '\P{Is_Script_Extensions=_ BHAIKSUKI}', "");
    Expect(1, 72812, '\P{^Is_Script_Extensions=_ BHAIKSUKI}', "");
    Expect(0, 72813, '\p{Is_Script_Extensions=_ BHAIKSUKI}', "");
    Expect(1, 72813, '\p{^Is_Script_Extensions=_ BHAIKSUKI}', "");
    Expect(1, 72813, '\P{Is_Script_Extensions=_ BHAIKSUKI}', "");
    Expect(0, 72813, '\P{^Is_Script_Extensions=_ BHAIKSUKI}', "");
    Error('\p{Is_Scx=/a/-	Bhks}');
    Error('\P{Is_Scx=/a/-	Bhks}');
    Expect(1, 72812, '\p{Is_Scx=bhks}', "");
    Expect(0, 72812, '\p{^Is_Scx=bhks}', "");
    Expect(0, 72812, '\P{Is_Scx=bhks}', "");
    Expect(1, 72812, '\P{^Is_Scx=bhks}', "");
    Expect(0, 72813, '\p{Is_Scx=bhks}', "");
    Expect(1, 72813, '\p{^Is_Scx=bhks}', "");
    Expect(1, 72813, '\P{Is_Scx=bhks}', "");
    Expect(0, 72813, '\P{^Is_Scx=bhks}', "");
    Expect(1, 72812, '\p{Is_Scx=-	Bhks}', "");
    Expect(0, 72812, '\p{^Is_Scx=-	Bhks}', "");
    Expect(0, 72812, '\P{Is_Scx=-	Bhks}', "");
    Expect(1, 72812, '\P{^Is_Scx=-	Bhks}', "");
    Expect(0, 72813, '\p{Is_Scx=-	Bhks}', "");
    Expect(1, 72813, '\p{^Is_Scx=-	Bhks}', "");
    Expect(1, 72813, '\P{Is_Scx=-	Bhks}', "");
    Expect(0, 72813, '\P{^Is_Scx=-	Bhks}', "");
    Error('\p{Script_Extensions:    	bopomofo:=}');
    Error('\P{Script_Extensions:    	bopomofo:=}');
    Expect(1, 65381, '\p{Script_Extensions=bopomofo}', "");
    Expect(0, 65381, '\p{^Script_Extensions=bopomofo}', "");
    Expect(0, 65381, '\P{Script_Extensions=bopomofo}', "");
    Expect(1, 65381, '\P{^Script_Extensions=bopomofo}', "");
    Expect(0, 65382, '\p{Script_Extensions=bopomofo}', "");
    Expect(1, 65382, '\p{^Script_Extensions=bopomofo}', "");
    Expect(1, 65382, '\P{Script_Extensions=bopomofo}', "");
    Expect(0, 65382, '\P{^Script_Extensions=bopomofo}', "");
    Expect(1, 65381, '\p{Script_Extensions=	Bopomofo}', "");
    Expect(0, 65381, '\p{^Script_Extensions=	Bopomofo}', "");
    Expect(0, 65381, '\P{Script_Extensions=	Bopomofo}', "");
    Expect(1, 65381, '\P{^Script_Extensions=	Bopomofo}', "");
    Expect(0, 65382, '\p{Script_Extensions=	Bopomofo}', "");
    Expect(1, 65382, '\p{^Script_Extensions=	Bopomofo}', "");
    Expect(1, 65382, '\P{Script_Extensions=	Bopomofo}', "");
    Expect(0, 65382, '\P{^Script_Extensions=	Bopomofo}', "");
    Error('\p{Scx=:=	BOPO}');
    Error('\P{Scx=:=	BOPO}');
    Expect(1, 65381, '\p{Scx=bopo}', "");
    Expect(0, 65381, '\p{^Scx=bopo}', "");
    Expect(0, 65381, '\P{Scx=bopo}', "");
    Expect(1, 65381, '\P{^Scx=bopo}', "");
    Expect(0, 65382, '\p{Scx=bopo}', "");
    Expect(1, 65382, '\p{^Scx=bopo}', "");
    Expect(1, 65382, '\P{Scx=bopo}', "");
    Expect(0, 65382, '\P{^Scx=bopo}', "");
    Expect(1, 65381, '\p{Scx=	 BOPO}', "");
    Expect(0, 65381, '\p{^Scx=	 BOPO}', "");
    Expect(0, 65381, '\P{Scx=	 BOPO}', "");
    Expect(1, 65381, '\P{^Scx=	 BOPO}', "");
    Expect(0, 65382, '\p{Scx=	 BOPO}', "");
    Expect(1, 65382, '\p{^Scx=	 BOPO}', "");
    Expect(1, 65382, '\P{Scx=	 BOPO}', "");
    Expect(0, 65382, '\P{^Scx=	 BOPO}', "");
    Error('\p{Is_Script_Extensions=_/a/bopomofo}');
    Error('\P{Is_Script_Extensions=_/a/bopomofo}');
    Expect(1, 65381, '\p{Is_Script_Extensions=bopomofo}', "");
    Expect(0, 65381, '\p{^Is_Script_Extensions=bopomofo}', "");
    Expect(0, 65381, '\P{Is_Script_Extensions=bopomofo}', "");
    Expect(1, 65381, '\P{^Is_Script_Extensions=bopomofo}', "");
    Expect(0, 65382, '\p{Is_Script_Extensions=bopomofo}', "");
    Expect(1, 65382, '\p{^Is_Script_Extensions=bopomofo}', "");
    Expect(1, 65382, '\P{Is_Script_Extensions=bopomofo}', "");
    Expect(0, 65382, '\P{^Is_Script_Extensions=bopomofo}', "");
    Expect(1, 65381, '\p{Is_Script_Extensions:   _ Bopomofo}', "");
    Expect(0, 65381, '\p{^Is_Script_Extensions:   _ Bopomofo}', "");
    Expect(0, 65381, '\P{Is_Script_Extensions:   _ Bopomofo}', "");
    Expect(1, 65381, '\P{^Is_Script_Extensions:   _ Bopomofo}', "");
    Expect(0, 65382, '\p{Is_Script_Extensions:   _ Bopomofo}', "");
    Expect(1, 65382, '\p{^Is_Script_Extensions:   _ Bopomofo}', "");
    Expect(1, 65382, '\P{Is_Script_Extensions:   _ Bopomofo}', "");
    Expect(0, 65382, '\P{^Is_Script_Extensions:   _ Bopomofo}', "");
    Error('\p{Is_Scx= /a/bopo}');
    Error('\P{Is_Scx= /a/bopo}');
    Expect(1, 65381, '\p{Is_Scx=bopo}', "");
    Expect(0, 65381, '\p{^Is_Scx=bopo}', "");
    Expect(0, 65381, '\P{Is_Scx=bopo}', "");
    Expect(1, 65381, '\P{^Is_Scx=bopo}', "");
    Expect(0, 65382, '\p{Is_Scx=bopo}', "");
    Expect(1, 65382, '\p{^Is_Scx=bopo}', "");
    Expect(1, 65382, '\P{Is_Scx=bopo}', "");
    Expect(0, 65382, '\P{^Is_Scx=bopo}', "");
    Expect(1, 65381, '\p{Is_Scx=	Bopo}', "");
    Expect(0, 65381, '\p{^Is_Scx=	Bopo}', "");
    Expect(0, 65381, '\P{Is_Scx=	Bopo}', "");
    Expect(1, 65381, '\P{^Is_Scx=	Bopo}', "");
    Expect(0, 65382, '\p{Is_Scx=	Bopo}', "");
    Expect(1, 65382, '\p{^Is_Scx=	Bopo}', "");
    Expect(1, 65382, '\P{Is_Scx=	Bopo}', "");
    Expect(0, 65382, '\P{^Is_Scx=	Bopo}', "");
    Error('\p{Script_Extensions= Brahmi:=}');
    Error('\P{Script_Extensions= Brahmi:=}');
    Expect(1, 69759, '\p{Script_Extensions=brahmi}', "");
    Expect(0, 69759, '\p{^Script_Extensions=brahmi}', "");
    Expect(0, 69759, '\P{Script_Extensions=brahmi}', "");
    Expect(1, 69759, '\P{^Script_Extensions=brahmi}', "");
    Expect(0, 69760, '\p{Script_Extensions=brahmi}', "");
    Expect(1, 69760, '\p{^Script_Extensions=brahmi}', "");
    Expect(1, 69760, '\P{Script_Extensions=brahmi}', "");
    Expect(0, 69760, '\P{^Script_Extensions=brahmi}', "");
    Expect(1, 69759, '\p{Script_Extensions:--Brahmi}', "");
    Expect(0, 69759, '\p{^Script_Extensions:--Brahmi}', "");
    Expect(0, 69759, '\P{Script_Extensions:--Brahmi}', "");
    Expect(1, 69759, '\P{^Script_Extensions:--Brahmi}', "");
    Expect(0, 69760, '\p{Script_Extensions:--Brahmi}', "");
    Expect(1, 69760, '\p{^Script_Extensions:--Brahmi}', "");
    Expect(1, 69760, '\P{Script_Extensions:--Brahmi}', "");
    Expect(0, 69760, '\P{^Script_Extensions:--Brahmi}', "");
    Error('\p{Scx= /a/BRAH}');
    Error('\P{Scx= /a/BRAH}');
    Expect(1, 69759, '\p{Scx=brah}', "");
    Expect(0, 69759, '\p{^Scx=brah}', "");
    Expect(0, 69759, '\P{Scx=brah}', "");
    Expect(1, 69759, '\P{^Scx=brah}', "");
    Expect(0, 69760, '\p{Scx=brah}', "");
    Expect(1, 69760, '\p{^Scx=brah}', "");
    Expect(1, 69760, '\P{Scx=brah}', "");
    Expect(0, 69760, '\P{^Scx=brah}', "");
    Expect(1, 69759, '\p{Scx=	Brah}', "");
    Expect(0, 69759, '\p{^Scx=	Brah}', "");
    Expect(0, 69759, '\P{Scx=	Brah}', "");
    Expect(1, 69759, '\P{^Scx=	Brah}', "");
    Expect(0, 69760, '\p{Scx=	Brah}', "");
    Expect(1, 69760, '\p{^Scx=	Brah}', "");
    Expect(1, 69760, '\P{Scx=	Brah}', "");
    Expect(0, 69760, '\P{^Scx=	Brah}', "");
    Error('\p{Is_Script_Extensions=:=_ Brahmi}');
    Error('\P{Is_Script_Extensions=:=_ Brahmi}');
    Expect(1, 69759, '\p{Is_Script_Extensions=brahmi}', "");
    Expect(0, 69759, '\p{^Is_Script_Extensions=brahmi}', "");
    Expect(0, 69759, '\P{Is_Script_Extensions=brahmi}', "");
    Expect(1, 69759, '\P{^Is_Script_Extensions=brahmi}', "");
    Expect(0, 69760, '\p{Is_Script_Extensions=brahmi}', "");
    Expect(1, 69760, '\p{^Is_Script_Extensions=brahmi}', "");
    Expect(1, 69760, '\P{Is_Script_Extensions=brahmi}', "");
    Expect(0, 69760, '\P{^Is_Script_Extensions=brahmi}', "");
    Expect(1, 69759, '\p{Is_Script_Extensions=	brahmi}', "");
    Expect(0, 69759, '\p{^Is_Script_Extensions=	brahmi}', "");
    Expect(0, 69759, '\P{Is_Script_Extensions=	brahmi}', "");
    Expect(1, 69759, '\P{^Is_Script_Extensions=	brahmi}', "");
    Expect(0, 69760, '\p{Is_Script_Extensions=	brahmi}', "");
    Expect(1, 69760, '\p{^Is_Script_Extensions=	brahmi}', "");
    Expect(1, 69760, '\P{Is_Script_Extensions=	brahmi}', "");
    Expect(0, 69760, '\P{^Is_Script_Extensions=	brahmi}', "");
    Error('\p{Is_Scx: :=	 BRAH}');
    Error('\P{Is_Scx: :=	 BRAH}');
    Expect(1, 69759, '\p{Is_Scx=brah}', "");
    Expect(0, 69759, '\p{^Is_Scx=brah}', "");
    Expect(0, 69759, '\P{Is_Scx=brah}', "");
    Expect(1, 69759, '\P{^Is_Scx=brah}', "");
    Expect(0, 69760, '\p{Is_Scx=brah}', "");
    Expect(1, 69760, '\p{^Is_Scx=brah}', "");
    Expect(1, 69760, '\P{Is_Scx=brah}', "");
    Expect(0, 69760, '\P{^Is_Scx=brah}', "");
    Expect(1, 69759, '\p{Is_Scx= -Brah}', "");
    Expect(0, 69759, '\p{^Is_Scx= -Brah}', "");
    Expect(0, 69759, '\P{Is_Scx= -Brah}', "");
    Expect(1, 69759, '\P{^Is_Scx= -Brah}', "");
    Expect(0, 69760, '\p{Is_Scx= -Brah}', "");
    Expect(1, 69760, '\p{^Is_Scx= -Brah}', "");
    Expect(1, 69760, '\P{Is_Scx= -Brah}', "");
    Expect(0, 69760, '\P{^Is_Scx= -Brah}', "");
    Error('\p{Script_Extensions=_Braille:=}');
    Error('\P{Script_Extensions=_Braille:=}');
    Expect(1, 10495, '\p{Script_Extensions=braille}', "");
    Expect(0, 10495, '\p{^Script_Extensions=braille}', "");
    Expect(0, 10495, '\P{Script_Extensions=braille}', "");
    Expect(1, 10495, '\P{^Script_Extensions=braille}', "");
    Expect(0, 10496, '\p{Script_Extensions=braille}', "");
    Expect(1, 10496, '\p{^Script_Extensions=braille}', "");
    Expect(1, 10496, '\P{Script_Extensions=braille}', "");
    Expect(0, 10496, '\P{^Script_Extensions=braille}', "");
    Expect(1, 10495, '\p{Script_Extensions=_BRAILLE}', "");
    Expect(0, 10495, '\p{^Script_Extensions=_BRAILLE}', "");
    Expect(0, 10495, '\P{Script_Extensions=_BRAILLE}', "");
    Expect(1, 10495, '\P{^Script_Extensions=_BRAILLE}', "");
    Expect(0, 10496, '\p{Script_Extensions=_BRAILLE}', "");
    Expect(1, 10496, '\p{^Script_Extensions=_BRAILLE}', "");
    Expect(1, 10496, '\P{Script_Extensions=_BRAILLE}', "");
    Expect(0, 10496, '\P{^Script_Extensions=_BRAILLE}', "");
    Error('\p{Scx=	:=BRAI}');
    Error('\P{Scx=	:=BRAI}');
    Expect(1, 10495, '\p{Scx=brai}', "");
    Expect(0, 10495, '\p{^Scx=brai}', "");
    Expect(0, 10495, '\P{Scx=brai}', "");
    Expect(1, 10495, '\P{^Scx=brai}', "");
    Expect(0, 10496, '\p{Scx=brai}', "");
    Expect(1, 10496, '\p{^Scx=brai}', "");
    Expect(1, 10496, '\P{Scx=brai}', "");
    Expect(0, 10496, '\P{^Scx=brai}', "");
    Expect(1, 10495, '\p{Scx=-	BRAI}', "");
    Expect(0, 10495, '\p{^Scx=-	BRAI}', "");
    Expect(0, 10495, '\P{Scx=-	BRAI}', "");
    Expect(1, 10495, '\P{^Scx=-	BRAI}', "");
    Expect(0, 10496, '\p{Scx=-	BRAI}', "");
    Expect(1, 10496, '\p{^Scx=-	BRAI}', "");
    Expect(1, 10496, '\P{Scx=-	BRAI}', "");
    Expect(0, 10496, '\P{^Scx=-	BRAI}', "");
    Error('\p{Is_Script_Extensions=_:=braille}');
    Error('\P{Is_Script_Extensions=_:=braille}');
    Expect(1, 10495, '\p{Is_Script_Extensions=braille}', "");
    Expect(0, 10495, '\p{^Is_Script_Extensions=braille}', "");
    Expect(0, 10495, '\P{Is_Script_Extensions=braille}', "");
    Expect(1, 10495, '\P{^Is_Script_Extensions=braille}', "");
    Expect(0, 10496, '\p{Is_Script_Extensions=braille}', "");
    Expect(1, 10496, '\p{^Is_Script_Extensions=braille}', "");
    Expect(1, 10496, '\P{Is_Script_Extensions=braille}', "");
    Expect(0, 10496, '\P{^Is_Script_Extensions=braille}', "");
    Expect(1, 10495, '\p{Is_Script_Extensions=-braille}', "");
    Expect(0, 10495, '\p{^Is_Script_Extensions=-braille}', "");
    Expect(0, 10495, '\P{Is_Script_Extensions=-braille}', "");
    Expect(1, 10495, '\P{^Is_Script_Extensions=-braille}', "");
    Expect(0, 10496, '\p{Is_Script_Extensions=-braille}', "");
    Expect(1, 10496, '\p{^Is_Script_Extensions=-braille}', "");
    Expect(1, 10496, '\P{Is_Script_Extensions=-braille}', "");
    Expect(0, 10496, '\P{^Is_Script_Extensions=-braille}', "");
    Error('\p{Is_Scx=:=--BRAI}');
    Error('\P{Is_Scx=:=--BRAI}');
    Expect(1, 10495, '\p{Is_Scx=brai}', "");
    Expect(0, 10495, '\p{^Is_Scx=brai}', "");
    Expect(0, 10495, '\P{Is_Scx=brai}', "");
    Expect(1, 10495, '\P{^Is_Scx=brai}', "");
    Expect(0, 10496, '\p{Is_Scx=brai}', "");
    Expect(1, 10496, '\p{^Is_Scx=brai}', "");
    Expect(1, 10496, '\P{Is_Scx=brai}', "");
    Expect(0, 10496, '\P{^Is_Scx=brai}', "");
    Expect(1, 10495, '\p{Is_Scx=_Brai}', "");
    Expect(0, 10495, '\p{^Is_Scx=_Brai}', "");
    Expect(0, 10495, '\P{Is_Scx=_Brai}', "");
    Expect(1, 10495, '\P{^Is_Scx=_Brai}', "");
    Expect(0, 10496, '\p{Is_Scx=_Brai}', "");
    Expect(1, 10496, '\p{^Is_Scx=_Brai}', "");
    Expect(1, 10496, '\P{Is_Scx=_Brai}', "");
    Expect(0, 10496, '\P{^Is_Scx=_Brai}', "");
    Error('\p{Script_Extensions=/a/Buginese}');
    Error('\P{Script_Extensions=/a/Buginese}');
    Expect(1, 43471, '\p{Script_Extensions=buginese}', "");
    Expect(0, 43471, '\p{^Script_Extensions=buginese}', "");
    Expect(0, 43471, '\P{Script_Extensions=buginese}', "");
    Expect(1, 43471, '\P{^Script_Extensions=buginese}', "");
    Expect(0, 43472, '\p{Script_Extensions=buginese}', "");
    Expect(1, 43472, '\p{^Script_Extensions=buginese}', "");
    Expect(1, 43472, '\P{Script_Extensions=buginese}', "");
    Expect(0, 43472, '\P{^Script_Extensions=buginese}', "");
    Expect(1, 43471, '\p{Script_Extensions=_Buginese}', "");
    Expect(0, 43471, '\p{^Script_Extensions=_Buginese}', "");
    Expect(0, 43471, '\P{Script_Extensions=_Buginese}', "");
    Expect(1, 43471, '\P{^Script_Extensions=_Buginese}', "");
    Expect(0, 43472, '\p{Script_Extensions=_Buginese}', "");
    Expect(1, 43472, '\p{^Script_Extensions=_Buginese}', "");
    Expect(1, 43472, '\P{Script_Extensions=_Buginese}', "");
    Expect(0, 43472, '\P{^Script_Extensions=_Buginese}', "");
    Error('\p{Scx=_Bugi:=}');
    Error('\P{Scx=_Bugi:=}');
    Expect(1, 43471, '\p{Scx=bugi}', "");
    Expect(0, 43471, '\p{^Scx=bugi}', "");
    Expect(0, 43471, '\P{Scx=bugi}', "");
    Expect(1, 43471, '\P{^Scx=bugi}', "");
    Expect(0, 43472, '\p{Scx=bugi}', "");
    Expect(1, 43472, '\p{^Scx=bugi}', "");
    Expect(1, 43472, '\P{Scx=bugi}', "");
    Expect(0, 43472, '\P{^Scx=bugi}', "");
    Expect(1, 43471, '\p{Scx=-BUGI}', "");
    Expect(0, 43471, '\p{^Scx=-BUGI}', "");
    Expect(0, 43471, '\P{Scx=-BUGI}', "");
    Expect(1, 43471, '\P{^Scx=-BUGI}', "");
    Expect(0, 43472, '\p{Scx=-BUGI}', "");
    Expect(1, 43472, '\p{^Scx=-BUGI}', "");
    Expect(1, 43472, '\P{Scx=-BUGI}', "");
    Expect(0, 43472, '\P{^Scx=-BUGI}', "");
    Error('\p{Is_Script_Extensions=/a/ buginese}');
    Error('\P{Is_Script_Extensions=/a/ buginese}');
    Expect(1, 43471, '\p{Is_Script_Extensions=buginese}', "");
    Expect(0, 43471, '\p{^Is_Script_Extensions=buginese}', "");
    Expect(0, 43471, '\P{Is_Script_Extensions=buginese}', "");
    Expect(1, 43471, '\P{^Is_Script_Extensions=buginese}', "");
    Expect(0, 43472, '\p{Is_Script_Extensions=buginese}', "");
    Expect(1, 43472, '\p{^Is_Script_Extensions=buginese}', "");
    Expect(1, 43472, '\P{Is_Script_Extensions=buginese}', "");
    Expect(0, 43472, '\P{^Is_Script_Extensions=buginese}', "");
    Expect(1, 43471, '\p{Is_Script_Extensions= _buginese}', "");
    Expect(0, 43471, '\p{^Is_Script_Extensions= _buginese}', "");
    Expect(0, 43471, '\P{Is_Script_Extensions= _buginese}', "");
    Expect(1, 43471, '\P{^Is_Script_Extensions= _buginese}', "");
    Expect(0, 43472, '\p{Is_Script_Extensions= _buginese}', "");
    Expect(1, 43472, '\p{^Is_Script_Extensions= _buginese}', "");
    Expect(1, 43472, '\P{Is_Script_Extensions= _buginese}', "");
    Expect(0, 43472, '\P{^Is_Script_Extensions= _buginese}', "");
    Error('\p{Is_Scx=:=_Bugi}');
    Error('\P{Is_Scx=:=_Bugi}');
    Expect(1, 43471, '\p{Is_Scx=bugi}', "");
    Expect(0, 43471, '\p{^Is_Scx=bugi}', "");
    Expect(0, 43471, '\P{Is_Scx=bugi}', "");
    Expect(1, 43471, '\P{^Is_Scx=bugi}', "");
    Expect(0, 43472, '\p{Is_Scx=bugi}', "");
    Expect(1, 43472, '\p{^Is_Scx=bugi}', "");
    Expect(1, 43472, '\P{Is_Scx=bugi}', "");
    Expect(0, 43472, '\P{^Is_Scx=bugi}', "");
    Expect(1, 43471, '\p{Is_Scx=- bugi}', "");
    Expect(0, 43471, '\p{^Is_Scx=- bugi}', "");
    Expect(0, 43471, '\P{Is_Scx=- bugi}', "");
    Expect(1, 43471, '\P{^Is_Scx=- bugi}', "");
    Expect(0, 43472, '\p{Is_Scx=- bugi}', "");
    Expect(1, 43472, '\p{^Is_Scx=- bugi}', "");
    Expect(1, 43472, '\P{Is_Scx=- bugi}', "");
    Expect(0, 43472, '\P{^Is_Scx=- bugi}', "");
    Error('\p{Script_Extensions:   := _Buhid}');
    Error('\P{Script_Extensions:   := _Buhid}');
    Expect(1, 5971, '\p{Script_Extensions:	buhid}', "");
    Expect(0, 5971, '\p{^Script_Extensions:	buhid}', "");
    Expect(0, 5971, '\P{Script_Extensions:	buhid}', "");
    Expect(1, 5971, '\P{^Script_Extensions:	buhid}', "");
    Expect(0, 5972, '\p{Script_Extensions:	buhid}', "");
    Expect(1, 5972, '\p{^Script_Extensions:	buhid}', "");
    Expect(1, 5972, '\P{Script_Extensions:	buhid}', "");
    Expect(0, 5972, '\P{^Script_Extensions:	buhid}', "");
    Expect(1, 5971, '\p{Script_Extensions= buhid}', "");
    Expect(0, 5971, '\p{^Script_Extensions= buhid}', "");
    Expect(0, 5971, '\P{Script_Extensions= buhid}', "");
    Expect(1, 5971, '\P{^Script_Extensions= buhid}', "");
    Expect(0, 5972, '\p{Script_Extensions= buhid}', "");
    Expect(1, 5972, '\p{^Script_Extensions= buhid}', "");
    Expect(1, 5972, '\P{Script_Extensions= buhid}', "");
    Expect(0, 5972, '\P{^Script_Extensions= buhid}', "");
    Error('\p{Scx=:=-Buhd}');
    Error('\P{Scx=:=-Buhd}');
    Expect(1, 5971, '\p{Scx=buhd}', "");
    Expect(0, 5971, '\p{^Scx=buhd}', "");
    Expect(0, 5971, '\P{Scx=buhd}', "");
    Expect(1, 5971, '\P{^Scx=buhd}', "");
    Expect(0, 5972, '\p{Scx=buhd}', "");
    Expect(1, 5972, '\p{^Scx=buhd}', "");
    Expect(1, 5972, '\P{Scx=buhd}', "");
    Expect(0, 5972, '\P{^Scx=buhd}', "");
    Expect(1, 5971, '\p{Scx=	 Buhd}', "");
    Expect(0, 5971, '\p{^Scx=	 Buhd}', "");
    Expect(0, 5971, '\P{Scx=	 Buhd}', "");
    Expect(1, 5971, '\P{^Scx=	 Buhd}', "");
    Expect(0, 5972, '\p{Scx=	 Buhd}', "");
    Expect(1, 5972, '\p{^Scx=	 Buhd}', "");
    Expect(1, 5972, '\P{Scx=	 Buhd}', "");
    Expect(0, 5972, '\P{^Scx=	 Buhd}', "");
    Error('\p{Is_Script_Extensions:   -	buhid/a/}');
    Error('\P{Is_Script_Extensions:   -	buhid/a/}');
    Expect(1, 5971, '\p{Is_Script_Extensions=buhid}', "");
    Expect(0, 5971, '\p{^Is_Script_Extensions=buhid}', "");
    Expect(0, 5971, '\P{Is_Script_Extensions=buhid}', "");
    Expect(1, 5971, '\P{^Is_Script_Extensions=buhid}', "");
    Expect(0, 5972, '\p{Is_Script_Extensions=buhid}', "");
    Expect(1, 5972, '\p{^Is_Script_Extensions=buhid}', "");
    Expect(1, 5972, '\P{Is_Script_Extensions=buhid}', "");
    Expect(0, 5972, '\P{^Is_Script_Extensions=buhid}', "");
    Expect(1, 5971, '\p{Is_Script_Extensions:	_buhid}', "");
    Expect(0, 5971, '\p{^Is_Script_Extensions:	_buhid}', "");
    Expect(0, 5971, '\P{Is_Script_Extensions:	_buhid}', "");
    Expect(1, 5971, '\P{^Is_Script_Extensions:	_buhid}', "");
    Expect(0, 5972, '\p{Is_Script_Extensions:	_buhid}', "");
    Expect(1, 5972, '\p{^Is_Script_Extensions:	_buhid}', "");
    Expect(1, 5972, '\P{Is_Script_Extensions:	_buhid}', "");
    Expect(0, 5972, '\P{^Is_Script_Extensions:	_buhid}', "");
    Error('\p{Is_Scx=:=buhd}');
    Error('\P{Is_Scx=:=buhd}');
    Expect(1, 5971, '\p{Is_Scx=buhd}', "");
    Expect(0, 5971, '\p{^Is_Scx=buhd}', "");
    Expect(0, 5971, '\P{Is_Scx=buhd}', "");
    Expect(1, 5971, '\P{^Is_Scx=buhd}', "");
    Expect(0, 5972, '\p{Is_Scx=buhd}', "");
    Expect(1, 5972, '\p{^Is_Scx=buhd}', "");
    Expect(1, 5972, '\P{Is_Scx=buhd}', "");
    Expect(0, 5972, '\P{^Is_Scx=buhd}', "");
    Expect(1, 5971, '\p{Is_Scx= buhd}', "");
    Expect(0, 5971, '\p{^Is_Scx= buhd}', "");
    Expect(0, 5971, '\P{Is_Scx= buhd}', "");
    Expect(1, 5971, '\P{^Is_Scx= buhd}', "");
    Expect(0, 5972, '\p{Is_Scx= buhd}', "");
    Expect(1, 5972, '\p{^Is_Scx= buhd}', "");
    Expect(1, 5972, '\P{Is_Scx= buhd}', "");
    Expect(0, 5972, '\P{^Is_Scx= buhd}', "");
    Error('\p{Script_Extensions=_CHAKMA/a/}');
    Error('\P{Script_Extensions=_CHAKMA/a/}');
    Expect(1, 69955, '\p{Script_Extensions=chakma}', "");
    Expect(0, 69955, '\p{^Script_Extensions=chakma}', "");
    Expect(0, 69955, '\P{Script_Extensions=chakma}', "");
    Expect(1, 69955, '\P{^Script_Extensions=chakma}', "");
    Expect(0, 69956, '\p{Script_Extensions=chakma}', "");
    Expect(1, 69956, '\p{^Script_Extensions=chakma}', "");
    Expect(1, 69956, '\P{Script_Extensions=chakma}', "");
    Expect(0, 69956, '\P{^Script_Extensions=chakma}', "");
    Expect(1, 69955, '\p{Script_Extensions=_CHAKMA}', "");
    Expect(0, 69955, '\p{^Script_Extensions=_CHAKMA}', "");
    Expect(0, 69955, '\P{Script_Extensions=_CHAKMA}', "");
    Expect(1, 69955, '\P{^Script_Extensions=_CHAKMA}', "");
    Expect(0, 69956, '\p{Script_Extensions=_CHAKMA}', "");
    Expect(1, 69956, '\p{^Script_Extensions=_CHAKMA}', "");
    Expect(1, 69956, '\P{Script_Extensions=_CHAKMA}', "");
    Expect(0, 69956, '\P{^Script_Extensions=_CHAKMA}', "");
    Error('\p{Scx=:= Cakm}');
    Error('\P{Scx=:= Cakm}');
    Expect(1, 69955, '\p{Scx:	cakm}', "");
    Expect(0, 69955, '\p{^Scx:	cakm}', "");
    Expect(0, 69955, '\P{Scx:	cakm}', "");
    Expect(1, 69955, '\P{^Scx:	cakm}', "");
    Expect(0, 69956, '\p{Scx:	cakm}', "");
    Expect(1, 69956, '\p{^Scx:	cakm}', "");
    Expect(1, 69956, '\P{Scx:	cakm}', "");
    Expect(0, 69956, '\P{^Scx:	cakm}', "");
    Expect(1, 69955, '\p{Scx= CAKM}', "");
    Expect(0, 69955, '\p{^Scx= CAKM}', "");
    Expect(0, 69955, '\P{Scx= CAKM}', "");
    Expect(1, 69955, '\P{^Scx= CAKM}', "");
    Expect(0, 69956, '\p{Scx= CAKM}', "");
    Expect(1, 69956, '\p{^Scx= CAKM}', "");
    Expect(1, 69956, '\P{Scx= CAKM}', "");
    Expect(0, 69956, '\P{^Scx= CAKM}', "");
    Error('\p{Is_Script_Extensions:	-:=CHAKMA}');
    Error('\P{Is_Script_Extensions:	-:=CHAKMA}');
    Expect(1, 69955, '\p{Is_Script_Extensions=chakma}', "");
    Expect(0, 69955, '\p{^Is_Script_Extensions=chakma}', "");
    Expect(0, 69955, '\P{Is_Script_Extensions=chakma}', "");
    Expect(1, 69955, '\P{^Is_Script_Extensions=chakma}', "");
    Expect(0, 69956, '\p{Is_Script_Extensions=chakma}', "");
    Expect(1, 69956, '\p{^Is_Script_Extensions=chakma}', "");
    Expect(1, 69956, '\P{Is_Script_Extensions=chakma}', "");
    Expect(0, 69956, '\P{^Is_Script_Extensions=chakma}', "");
    Expect(1, 69955, '\p{Is_Script_Extensions= 	Chakma}', "");
    Expect(0, 69955, '\p{^Is_Script_Extensions= 	Chakma}', "");
    Expect(0, 69955, '\P{Is_Script_Extensions= 	Chakma}', "");
    Expect(1, 69955, '\P{^Is_Script_Extensions= 	Chakma}', "");
    Expect(0, 69956, '\p{Is_Script_Extensions= 	Chakma}', "");
    Expect(1, 69956, '\p{^Is_Script_Extensions= 	Chakma}', "");
    Expect(1, 69956, '\P{Is_Script_Extensions= 	Chakma}', "");
    Expect(0, 69956, '\P{^Is_Script_Extensions= 	Chakma}', "");
    Error('\p{Is_Scx=	 Cakm:=}');
    Error('\P{Is_Scx=	 Cakm:=}');
    Expect(1, 69955, '\p{Is_Scx=cakm}', "");
    Expect(0, 69955, '\p{^Is_Scx=cakm}', "");
    Expect(0, 69955, '\P{Is_Scx=cakm}', "");
    Expect(1, 69955, '\P{^Is_Scx=cakm}', "");
    Expect(0, 69956, '\p{Is_Scx=cakm}', "");
    Expect(1, 69956, '\p{^Is_Scx=cakm}', "");
    Expect(1, 69956, '\P{Is_Scx=cakm}', "");
    Expect(0, 69956, '\P{^Is_Scx=cakm}', "");
    Expect(1, 69955, '\p{Is_Scx= 	CAKM}', "");
    Expect(0, 69955, '\p{^Is_Scx= 	CAKM}', "");
    Expect(0, 69955, '\P{Is_Scx= 	CAKM}', "");
    Expect(1, 69955, '\P{^Is_Scx= 	CAKM}', "");
    Expect(0, 69956, '\p{Is_Scx= 	CAKM}', "");
    Expect(1, 69956, '\p{^Is_Scx= 	CAKM}', "");
    Expect(1, 69956, '\P{Is_Scx= 	CAKM}', "");
    Expect(0, 69956, '\P{^Is_Scx= 	CAKM}', "");
    Error('\p{Script_Extensions=CANADIAN_aboriginal:=}');
    Error('\P{Script_Extensions=CANADIAN_aboriginal:=}');
    Expect(1, 6389, '\p{Script_Extensions=canadianaboriginal}', "");
    Expect(0, 6389, '\p{^Script_Extensions=canadianaboriginal}', "");
    Expect(0, 6389, '\P{Script_Extensions=canadianaboriginal}', "");
    Expect(1, 6389, '\P{^Script_Extensions=canadianaboriginal}', "");
    Expect(0, 6390, '\p{Script_Extensions=canadianaboriginal}', "");
    Expect(1, 6390, '\p{^Script_Extensions=canadianaboriginal}', "");
    Expect(1, 6390, '\P{Script_Extensions=canadianaboriginal}', "");
    Expect(0, 6390, '\P{^Script_Extensions=canadianaboriginal}', "");
    Expect(1, 6389, '\p{Script_Extensions=_	Canadian_Aboriginal}', "");
    Expect(0, 6389, '\p{^Script_Extensions=_	Canadian_Aboriginal}', "");
    Expect(0, 6389, '\P{Script_Extensions=_	Canadian_Aboriginal}', "");
    Expect(1, 6389, '\P{^Script_Extensions=_	Canadian_Aboriginal}', "");
    Expect(0, 6390, '\p{Script_Extensions=_	Canadian_Aboriginal}', "");
    Expect(1, 6390, '\p{^Script_Extensions=_	Canadian_Aboriginal}', "");
    Expect(1, 6390, '\P{Script_Extensions=_	Canadian_Aboriginal}', "");
    Expect(0, 6390, '\P{^Script_Extensions=_	Canadian_Aboriginal}', "");
    Error('\p{Scx:_/a/CANS}');
    Error('\P{Scx:_/a/CANS}');
    Expect(1, 6389, '\p{Scx=cans}', "");
    Expect(0, 6389, '\p{^Scx=cans}', "");
    Expect(0, 6389, '\P{Scx=cans}', "");
    Expect(1, 6389, '\P{^Scx=cans}', "");
    Expect(0, 6390, '\p{Scx=cans}', "");
    Expect(1, 6390, '\p{^Scx=cans}', "");
    Expect(1, 6390, '\P{Scx=cans}', "");
    Expect(0, 6390, '\P{^Scx=cans}', "");
    Expect(1, 6389, '\p{Scx=	Cans}', "");
    Expect(0, 6389, '\p{^Scx=	Cans}', "");
    Expect(0, 6389, '\P{Scx=	Cans}', "");
    Expect(1, 6389, '\P{^Scx=	Cans}', "");
    Expect(0, 6390, '\p{Scx=	Cans}', "");
    Expect(1, 6390, '\p{^Scx=	Cans}', "");
    Expect(1, 6390, '\P{Scx=	Cans}', "");
    Expect(0, 6390, '\P{^Scx=	Cans}', "");
    Error('\p{Is_Script_Extensions=	 CANADIAN_ABORIGINAL:=}');
    Error('\P{Is_Script_Extensions=	 CANADIAN_ABORIGINAL:=}');
    Expect(1, 6389, '\p{Is_Script_Extensions:	canadianaboriginal}', "");
    Expect(0, 6389, '\p{^Is_Script_Extensions:	canadianaboriginal}', "");
    Expect(0, 6389, '\P{Is_Script_Extensions:	canadianaboriginal}', "");
    Expect(1, 6389, '\P{^Is_Script_Extensions:	canadianaboriginal}', "");
    Expect(0, 6390, '\p{Is_Script_Extensions:	canadianaboriginal}', "");
    Expect(1, 6390, '\p{^Is_Script_Extensions:	canadianaboriginal}', "");
    Expect(1, 6390, '\P{Is_Script_Extensions:	canadianaboriginal}', "");
    Expect(0, 6390, '\P{^Is_Script_Extensions:	canadianaboriginal}', "");
    Expect(1, 6389, '\p{Is_Script_Extensions=-canadian_ABORIGINAL}', "");
    Expect(0, 6389, '\p{^Is_Script_Extensions=-canadian_ABORIGINAL}', "");
    Expect(0, 6389, '\P{Is_Script_Extensions=-canadian_ABORIGINAL}', "");
    Expect(1, 6389, '\P{^Is_Script_Extensions=-canadian_ABORIGINAL}', "");
    Expect(0, 6390, '\p{Is_Script_Extensions=-canadian_ABORIGINAL}', "");
    Expect(1, 6390, '\p{^Is_Script_Extensions=-canadian_ABORIGINAL}', "");
    Expect(1, 6390, '\P{Is_Script_Extensions=-canadian_ABORIGINAL}', "");
    Expect(0, 6390, '\P{^Is_Script_Extensions=-canadian_ABORIGINAL}', "");
    Error('\p{Is_Scx=-	Cans/a/}');
    Error('\P{Is_Scx=-	Cans/a/}');
    Expect(1, 6389, '\p{Is_Scx=cans}', "");
    Expect(0, 6389, '\p{^Is_Scx=cans}', "");
    Expect(0, 6389, '\P{Is_Scx=cans}', "");
    Expect(1, 6389, '\P{^Is_Scx=cans}', "");
    Expect(0, 6390, '\p{Is_Scx=cans}', "");
    Expect(1, 6390, '\p{^Is_Scx=cans}', "");
    Expect(1, 6390, '\P{Is_Scx=cans}', "");
    Expect(0, 6390, '\P{^Is_Scx=cans}', "");
    Expect(1, 6389, '\p{Is_Scx=-_Cans}', "");
    Expect(0, 6389, '\p{^Is_Scx=-_Cans}', "");
    Expect(0, 6389, '\P{Is_Scx=-_Cans}', "");
    Expect(1, 6389, '\P{^Is_Scx=-_Cans}', "");
    Expect(0, 6390, '\p{Is_Scx=-_Cans}', "");
    Expect(1, 6390, '\p{^Is_Scx=-_Cans}', "");
    Expect(1, 6390, '\P{Is_Scx=-_Cans}', "");
    Expect(0, 6390, '\P{^Is_Scx=-_Cans}', "");
    Error('\p{Script_Extensions= :=Carian}');
    Error('\P{Script_Extensions= :=Carian}');
    Expect(1, 66256, '\p{Script_Extensions=carian}', "");
    Expect(0, 66256, '\p{^Script_Extensions=carian}', "");
    Expect(0, 66256, '\P{Script_Extensions=carian}', "");
    Expect(1, 66256, '\P{^Script_Extensions=carian}', "");
    Expect(0, 66257, '\p{Script_Extensions=carian}', "");
    Expect(1, 66257, '\p{^Script_Extensions=carian}', "");
    Expect(1, 66257, '\P{Script_Extensions=carian}', "");
    Expect(0, 66257, '\P{^Script_Extensions=carian}', "");
    Expect(1, 66256, '\p{Script_Extensions= 	CARIAN}', "");
    Expect(0, 66256, '\p{^Script_Extensions= 	CARIAN}', "");
    Expect(0, 66256, '\P{Script_Extensions= 	CARIAN}', "");
    Expect(1, 66256, '\P{^Script_Extensions= 	CARIAN}', "");
    Expect(0, 66257, '\p{Script_Extensions= 	CARIAN}', "");
    Expect(1, 66257, '\p{^Script_Extensions= 	CARIAN}', "");
    Expect(1, 66257, '\P{Script_Extensions= 	CARIAN}', "");
    Expect(0, 66257, '\P{^Script_Extensions= 	CARIAN}', "");
    Error('\p{Scx=_/a/CARI}');
    Error('\P{Scx=_/a/CARI}');
    Expect(1, 66256, '\p{Scx=cari}', "");
    Expect(0, 66256, '\p{^Scx=cari}', "");
    Expect(0, 66256, '\P{Scx=cari}', "");
    Expect(1, 66256, '\P{^Scx=cari}', "");
    Expect(0, 66257, '\p{Scx=cari}', "");
    Expect(1, 66257, '\p{^Scx=cari}', "");
    Expect(1, 66257, '\P{Scx=cari}', "");
    Expect(0, 66257, '\P{^Scx=cari}', "");
    Expect(1, 66256, '\p{Scx=		CARI}', "");
    Expect(0, 66256, '\p{^Scx=		CARI}', "");
    Expect(0, 66256, '\P{Scx=		CARI}', "");
    Expect(1, 66256, '\P{^Scx=		CARI}', "");
    Expect(0, 66257, '\p{Scx=		CARI}', "");
    Expect(1, 66257, '\p{^Scx=		CARI}', "");
    Expect(1, 66257, '\P{Scx=		CARI}', "");
    Expect(0, 66257, '\P{^Scx=		CARI}', "");
    Error('\p{Is_Script_Extensions=_carian/a/}');
    Error('\P{Is_Script_Extensions=_carian/a/}');
    Expect(1, 66256, '\p{Is_Script_Extensions=carian}', "");
    Expect(0, 66256, '\p{^Is_Script_Extensions=carian}', "");
    Expect(0, 66256, '\P{Is_Script_Extensions=carian}', "");
    Expect(1, 66256, '\P{^Is_Script_Extensions=carian}', "");
    Expect(0, 66257, '\p{Is_Script_Extensions=carian}', "");
    Expect(1, 66257, '\p{^Is_Script_Extensions=carian}', "");
    Expect(1, 66257, '\P{Is_Script_Extensions=carian}', "");
    Expect(0, 66257, '\P{^Is_Script_Extensions=carian}', "");
    Expect(1, 66256, '\p{Is_Script_Extensions=  Carian}', "");
    Expect(0, 66256, '\p{^Is_Script_Extensions=  Carian}', "");
    Expect(0, 66256, '\P{Is_Script_Extensions=  Carian}', "");
    Expect(1, 66256, '\P{^Is_Script_Extensions=  Carian}', "");
    Expect(0, 66257, '\p{Is_Script_Extensions=  Carian}', "");
    Expect(1, 66257, '\p{^Is_Script_Extensions=  Carian}', "");
    Expect(1, 66257, '\P{Is_Script_Extensions=  Carian}', "");
    Expect(0, 66257, '\P{^Is_Script_Extensions=  Carian}', "");
    Error('\p{Is_Scx=-/a/Cari}');
    Error('\P{Is_Scx=-/a/Cari}');
    Expect(1, 66256, '\p{Is_Scx=cari}', "");
    Expect(0, 66256, '\p{^Is_Scx=cari}', "");
    Expect(0, 66256, '\P{Is_Scx=cari}', "");
    Expect(1, 66256, '\P{^Is_Scx=cari}', "");
    Expect(0, 66257, '\p{Is_Scx=cari}', "");
    Expect(1, 66257, '\p{^Is_Scx=cari}', "");
    Expect(1, 66257, '\P{Is_Scx=cari}', "");
    Expect(0, 66257, '\P{^Is_Scx=cari}', "");
    Expect(1, 66256, '\p{Is_Scx= CARI}', "");
    Expect(0, 66256, '\p{^Is_Scx= CARI}', "");
    Expect(0, 66256, '\P{Is_Scx= CARI}', "");
    Expect(1, 66256, '\P{^Is_Scx= CARI}', "");
    Expect(0, 66257, '\p{Is_Scx= CARI}', "");
    Expect(1, 66257, '\p{^Is_Scx= CARI}', "");
    Expect(1, 66257, '\P{Is_Scx= CARI}', "");
    Expect(0, 66257, '\P{^Is_Scx= CARI}', "");
    Error('\p{Script_Extensions=/a/--Cham}');
    Error('\P{Script_Extensions=/a/--Cham}');
    Expect(1, 43615, '\p{Script_Extensions=cham}', "");
    Expect(0, 43615, '\p{^Script_Extensions=cham}', "");
    Expect(0, 43615, '\P{Script_Extensions=cham}', "");
    Expect(1, 43615, '\P{^Script_Extensions=cham}', "");
    Expect(0, 43616, '\p{Script_Extensions=cham}', "");
    Expect(1, 43616, '\p{^Script_Extensions=cham}', "");
    Expect(1, 43616, '\P{Script_Extensions=cham}', "");
    Expect(0, 43616, '\P{^Script_Extensions=cham}', "");
    Expect(1, 43615, '\p{Script_Extensions=_CHAM}', "");
    Expect(0, 43615, '\p{^Script_Extensions=_CHAM}', "");
    Expect(0, 43615, '\P{Script_Extensions=_CHAM}', "");
    Expect(1, 43615, '\P{^Script_Extensions=_CHAM}', "");
    Expect(0, 43616, '\p{Script_Extensions=_CHAM}', "");
    Expect(1, 43616, '\p{^Script_Extensions=_CHAM}', "");
    Expect(1, 43616, '\P{Script_Extensions=_CHAM}', "");
    Expect(0, 43616, '\P{^Script_Extensions=_CHAM}', "");
    Error('\p{Scx= :=cham}');
    Error('\P{Scx= :=cham}');
    Expect(1, 43615, '\p{Scx=cham}', "");
    Expect(0, 43615, '\p{^Scx=cham}', "");
    Expect(0, 43615, '\P{Scx=cham}', "");
    Expect(1, 43615, '\P{^Scx=cham}', "");
    Expect(0, 43616, '\p{Scx=cham}', "");
    Expect(1, 43616, '\p{^Scx=cham}', "");
    Expect(1, 43616, '\P{Scx=cham}', "");
    Expect(0, 43616, '\P{^Scx=cham}', "");
    Expect(1, 43615, '\p{Scx:  Cham}', "");
    Expect(0, 43615, '\p{^Scx:  Cham}', "");
    Expect(0, 43615, '\P{Scx:  Cham}', "");
    Expect(1, 43615, '\P{^Scx:  Cham}', "");
    Expect(0, 43616, '\p{Scx:  Cham}', "");
    Expect(1, 43616, '\p{^Scx:  Cham}', "");
    Expect(1, 43616, '\P{Scx:  Cham}', "");
    Expect(0, 43616, '\P{^Scx:  Cham}', "");
    Error('\p{Is_Script_Extensions=	:=Cham}');
    Error('\P{Is_Script_Extensions=	:=Cham}');
    Expect(1, 43615, '\p{Is_Script_Extensions=cham}', "");
    Expect(0, 43615, '\p{^Is_Script_Extensions=cham}', "");
    Expect(0, 43615, '\P{Is_Script_Extensions=cham}', "");
    Expect(1, 43615, '\P{^Is_Script_Extensions=cham}', "");
    Expect(0, 43616, '\p{Is_Script_Extensions=cham}', "");
    Expect(1, 43616, '\p{^Is_Script_Extensions=cham}', "");
    Expect(1, 43616, '\P{Is_Script_Extensions=cham}', "");
    Expect(0, 43616, '\P{^Is_Script_Extensions=cham}', "");
    Expect(1, 43615, '\p{Is_Script_Extensions=_	Cham}', "");
    Expect(0, 43615, '\p{^Is_Script_Extensions=_	Cham}', "");
    Expect(0, 43615, '\P{Is_Script_Extensions=_	Cham}', "");
    Expect(1, 43615, '\P{^Is_Script_Extensions=_	Cham}', "");
    Expect(0, 43616, '\p{Is_Script_Extensions=_	Cham}', "");
    Expect(1, 43616, '\p{^Is_Script_Extensions=_	Cham}', "");
    Expect(1, 43616, '\P{Is_Script_Extensions=_	Cham}', "");
    Expect(0, 43616, '\P{^Is_Script_Extensions=_	Cham}', "");
    Error('\p{Is_Scx=-_cham/a/}');
    Error('\P{Is_Scx=-_cham/a/}');
    Expect(1, 43615, '\p{Is_Scx=cham}', "");
    Expect(0, 43615, '\p{^Is_Scx=cham}', "");
    Expect(0, 43615, '\P{Is_Scx=cham}', "");
    Expect(1, 43615, '\P{^Is_Scx=cham}', "");
    Expect(0, 43616, '\p{Is_Scx=cham}', "");
    Expect(1, 43616, '\p{^Is_Scx=cham}', "");
    Expect(1, 43616, '\P{Is_Scx=cham}', "");
    Expect(0, 43616, '\P{^Is_Scx=cham}', "");
    Expect(1, 43615, '\p{Is_Scx= -cham}', "");
    Expect(0, 43615, '\p{^Is_Scx= -cham}', "");
    Expect(0, 43615, '\P{Is_Scx= -cham}', "");
    Expect(1, 43615, '\P{^Is_Scx= -cham}', "");
    Expect(0, 43616, '\p{Is_Scx= -cham}', "");
    Expect(1, 43616, '\p{^Is_Scx= -cham}', "");
    Expect(1, 43616, '\P{Is_Scx= -cham}', "");
    Expect(0, 43616, '\P{^Is_Scx= -cham}', "");
    Error('\p{Script_Extensions=_/a/CHEROKEE}');
    Error('\P{Script_Extensions=_/a/CHEROKEE}');
    Expect(1, 43967, '\p{Script_Extensions=cherokee}', "");
    Expect(0, 43967, '\p{^Script_Extensions=cherokee}', "");
    Expect(0, 43967, '\P{Script_Extensions=cherokee}', "");
    Expect(1, 43967, '\P{^Script_Extensions=cherokee}', "");
    Expect(0, 43968, '\p{Script_Extensions=cherokee}', "");
    Expect(1, 43968, '\p{^Script_Extensions=cherokee}', "");
    Expect(1, 43968, '\P{Script_Extensions=cherokee}', "");
    Expect(0, 43968, '\P{^Script_Extensions=cherokee}', "");
    Expect(1, 43967, '\p{Script_Extensions:	-	Cherokee}', "");
    Expect(0, 43967, '\p{^Script_Extensions:	-	Cherokee}', "");
    Expect(0, 43967, '\P{Script_Extensions:	-	Cherokee}', "");
    Expect(1, 43967, '\P{^Script_Extensions:	-	Cherokee}', "");
    Expect(0, 43968, '\p{Script_Extensions:	-	Cherokee}', "");
    Expect(1, 43968, '\p{^Script_Extensions:	-	Cherokee}', "");
    Expect(1, 43968, '\P{Script_Extensions:	-	Cherokee}', "");
    Expect(0, 43968, '\P{^Script_Extensions:	-	Cherokee}', "");
    Error('\p{Scx=--Cher:=}');
    Error('\P{Scx=--Cher:=}');
    Expect(1, 43967, '\p{Scx=cher}', "");
    Expect(0, 43967, '\p{^Scx=cher}', "");
    Expect(0, 43967, '\P{Scx=cher}', "");
    Expect(1, 43967, '\P{^Scx=cher}', "");
    Expect(0, 43968, '\p{Scx=cher}', "");
    Expect(1, 43968, '\p{^Scx=cher}', "");
    Expect(1, 43968, '\P{Scx=cher}', "");
    Expect(0, 43968, '\P{^Scx=cher}', "");
    Expect(1, 43967, '\p{Scx=_Cher}', "");
    Expect(0, 43967, '\p{^Scx=_Cher}', "");
    Expect(0, 43967, '\P{Scx=_Cher}', "");
    Expect(1, 43967, '\P{^Scx=_Cher}', "");
    Expect(0, 43968, '\p{Scx=_Cher}', "");
    Expect(1, 43968, '\p{^Scx=_Cher}', "");
    Expect(1, 43968, '\P{Scx=_Cher}', "");
    Expect(0, 43968, '\P{^Scx=_Cher}', "");
    Error('\p{Is_Script_Extensions:  CHEROKEE/a/}');
    Error('\P{Is_Script_Extensions:  CHEROKEE/a/}');
    Expect(1, 43967, '\p{Is_Script_Extensions:cherokee}', "");
    Expect(0, 43967, '\p{^Is_Script_Extensions:cherokee}', "");
    Expect(0, 43967, '\P{Is_Script_Extensions:cherokee}', "");
    Expect(1, 43967, '\P{^Is_Script_Extensions:cherokee}', "");
    Expect(0, 43968, '\p{Is_Script_Extensions:cherokee}', "");
    Expect(1, 43968, '\p{^Is_Script_Extensions:cherokee}', "");
    Expect(1, 43968, '\P{Is_Script_Extensions:cherokee}', "");
    Expect(0, 43968, '\P{^Is_Script_Extensions:cherokee}', "");
    Expect(1, 43967, '\p{Is_Script_Extensions=  Cherokee}', "");
    Expect(0, 43967, '\p{^Is_Script_Extensions=  Cherokee}', "");
    Expect(0, 43967, '\P{Is_Script_Extensions=  Cherokee}', "");
    Expect(1, 43967, '\P{^Is_Script_Extensions=  Cherokee}', "");
    Expect(0, 43968, '\p{Is_Script_Extensions=  Cherokee}', "");
    Expect(1, 43968, '\p{^Is_Script_Extensions=  Cherokee}', "");
    Expect(1, 43968, '\P{Is_Script_Extensions=  Cherokee}', "");
    Expect(0, 43968, '\P{^Is_Script_Extensions=  Cherokee}', "");
    Error('\p{Is_Scx=	:=CHER}');
    Error('\P{Is_Scx=	:=CHER}');
    Expect(1, 43967, '\p{Is_Scx=cher}', "");
    Expect(0, 43967, '\p{^Is_Scx=cher}', "");
    Expect(0, 43967, '\P{Is_Scx=cher}', "");
    Expect(1, 43967, '\P{^Is_Scx=cher}', "");
    Expect(0, 43968, '\p{Is_Scx=cher}', "");
    Expect(1, 43968, '\p{^Is_Scx=cher}', "");
    Expect(1, 43968, '\P{Is_Scx=cher}', "");
    Expect(0, 43968, '\P{^Is_Scx=cher}', "");
    Expect(1, 43967, '\p{Is_Scx= Cher}', "");
    Expect(0, 43967, '\p{^Is_Scx= Cher}', "");
    Expect(0, 43967, '\P{Is_Scx= Cher}', "");
    Expect(1, 43967, '\P{^Is_Scx= Cher}', "");
    Expect(0, 43968, '\p{Is_Scx= Cher}', "");
    Expect(1, 43968, '\p{^Is_Scx= Cher}', "");
    Expect(1, 43968, '\P{Is_Scx= Cher}', "");
    Expect(0, 43968, '\P{^Is_Scx= Cher}', "");
    Error('\p{Script_Extensions=/a/_ Coptic}');
    Error('\P{Script_Extensions=/a/_ Coptic}');
    Expect(1, 66299, '\p{Script_Extensions=coptic}', "");
    Expect(0, 66299, '\p{^Script_Extensions=coptic}', "");
    Expect(0, 66299, '\P{Script_Extensions=coptic}', "");
    Expect(1, 66299, '\P{^Script_Extensions=coptic}', "");
    Expect(0, 66300, '\p{Script_Extensions=coptic}', "");
    Expect(1, 66300, '\p{^Script_Extensions=coptic}', "");
    Expect(1, 66300, '\P{Script_Extensions=coptic}', "");
    Expect(0, 66300, '\P{^Script_Extensions=coptic}', "");
    Expect(1, 66299, '\p{Script_Extensions=  coptic}', "");
    Expect(0, 66299, '\p{^Script_Extensions=  coptic}', "");
    Expect(0, 66299, '\P{Script_Extensions=  coptic}', "");
    Expect(1, 66299, '\P{^Script_Extensions=  coptic}', "");
    Expect(0, 66300, '\p{Script_Extensions=  coptic}', "");
    Expect(1, 66300, '\p{^Script_Extensions=  coptic}', "");
    Expect(1, 66300, '\P{Script_Extensions=  coptic}', "");
    Expect(0, 66300, '\P{^Script_Extensions=  coptic}', "");
    Error('\p{Scx=	Copt:=}');
    Error('\P{Scx=	Copt:=}');
    Expect(1, 66299, '\p{Scx=copt}', "");
    Expect(0, 66299, '\p{^Scx=copt}', "");
    Expect(0, 66299, '\P{Scx=copt}', "");
    Expect(1, 66299, '\P{^Scx=copt}', "");
    Expect(0, 66300, '\p{Scx=copt}', "");
    Expect(1, 66300, '\p{^Scx=copt}', "");
    Expect(1, 66300, '\P{Scx=copt}', "");
    Expect(0, 66300, '\P{^Scx=copt}', "");
    Expect(1, 66299, '\p{Scx= copt}', "");
    Expect(0, 66299, '\p{^Scx= copt}', "");
    Expect(0, 66299, '\P{Scx= copt}', "");
    Expect(1, 66299, '\P{^Scx= copt}', "");
    Expect(0, 66300, '\p{Scx= copt}', "");
    Expect(1, 66300, '\p{^Scx= copt}', "");
    Expect(1, 66300, '\P{Scx= copt}', "");
    Expect(0, 66300, '\P{^Scx= copt}', "");
    Error('\p{Is_Script_Extensions=-:=Qaac}');
    Error('\P{Is_Script_Extensions=-:=Qaac}');
    Expect(1, 66299, '\p{Is_Script_Extensions=qaac}', "");
    Expect(0, 66299, '\p{^Is_Script_Extensions=qaac}', "");
    Expect(0, 66299, '\P{Is_Script_Extensions=qaac}', "");
    Expect(1, 66299, '\P{^Is_Script_Extensions=qaac}', "");
    Expect(0, 66300, '\p{Is_Script_Extensions=qaac}', "");
    Expect(1, 66300, '\p{^Is_Script_Extensions=qaac}', "");
    Expect(1, 66300, '\P{Is_Script_Extensions=qaac}', "");
    Expect(0, 66300, '\P{^Is_Script_Extensions=qaac}', "");
    Expect(1, 66299, '\p{Is_Script_Extensions=_ QAAC}', "");
    Expect(0, 66299, '\p{^Is_Script_Extensions=_ QAAC}', "");
    Expect(0, 66299, '\P{Is_Script_Extensions=_ QAAC}', "");
    Expect(1, 66299, '\P{^Is_Script_Extensions=_ QAAC}', "");
    Expect(0, 66300, '\p{Is_Script_Extensions=_ QAAC}', "");
    Expect(1, 66300, '\p{^Is_Script_Extensions=_ QAAC}', "");
    Expect(1, 66300, '\P{Is_Script_Extensions=_ QAAC}', "");
    Expect(0, 66300, '\P{^Is_Script_Extensions=_ QAAC}', "");
    Error('\p{Is_Scx=- Coptic/a/}');
    Error('\P{Is_Scx=- Coptic/a/}');
    Expect(1, 66299, '\p{Is_Scx=coptic}', "");
    Expect(0, 66299, '\p{^Is_Scx=coptic}', "");
    Expect(0, 66299, '\P{Is_Scx=coptic}', "");
    Expect(1, 66299, '\P{^Is_Scx=coptic}', "");
    Expect(0, 66300, '\p{Is_Scx=coptic}', "");
    Expect(1, 66300, '\p{^Is_Scx=coptic}', "");
    Expect(1, 66300, '\P{Is_Scx=coptic}', "");
    Expect(0, 66300, '\P{^Is_Scx=coptic}', "");
    Expect(1, 66299, '\p{Is_Scx=_-Coptic}', "");
    Expect(0, 66299, '\p{^Is_Scx=_-Coptic}', "");
    Expect(0, 66299, '\P{Is_Scx=_-Coptic}', "");
    Expect(1, 66299, '\P{^Is_Scx=_-Coptic}', "");
    Expect(0, 66300, '\p{Is_Scx=_-Coptic}', "");
    Expect(1, 66300, '\p{^Is_Scx=_-Coptic}', "");
    Expect(1, 66300, '\P{Is_Scx=_-Coptic}', "");
    Expect(0, 66300, '\P{^Is_Scx=_-Coptic}', "");
    Error('\p{Script_Extensions=-_Cypriot/a/}');
    Error('\P{Script_Extensions=-_Cypriot/a/}');
    Expect(1, 67647, '\p{Script_Extensions=cypriot}', "");
    Expect(0, 67647, '\p{^Script_Extensions=cypriot}', "");
    Expect(0, 67647, '\P{Script_Extensions=cypriot}', "");
    Expect(1, 67647, '\P{^Script_Extensions=cypriot}', "");
    Expect(0, 67648, '\p{Script_Extensions=cypriot}', "");
    Expect(1, 67648, '\p{^Script_Extensions=cypriot}', "");
    Expect(1, 67648, '\P{Script_Extensions=cypriot}', "");
    Expect(0, 67648, '\P{^Script_Extensions=cypriot}', "");
    Expect(1, 67647, '\p{Script_Extensions=__Cypriot}', "");
    Expect(0, 67647, '\p{^Script_Extensions=__Cypriot}', "");
    Expect(0, 67647, '\P{Script_Extensions=__Cypriot}', "");
    Expect(1, 67647, '\P{^Script_Extensions=__Cypriot}', "");
    Expect(0, 67648, '\p{Script_Extensions=__Cypriot}', "");
    Expect(1, 67648, '\p{^Script_Extensions=__Cypriot}', "");
    Expect(1, 67648, '\P{Script_Extensions=__Cypriot}', "");
    Expect(0, 67648, '\P{^Script_Extensions=__Cypriot}', "");
    Error('\p{Scx=-:=cprt}');
    Error('\P{Scx=-:=cprt}');
    Expect(1, 67647, '\p{Scx=cprt}', "");
    Expect(0, 67647, '\p{^Scx=cprt}', "");
    Expect(0, 67647, '\P{Scx=cprt}', "");
    Expect(1, 67647, '\P{^Scx=cprt}', "");
    Expect(0, 67648, '\p{Scx=cprt}', "");
    Expect(1, 67648, '\p{^Scx=cprt}', "");
    Expect(1, 67648, '\P{Scx=cprt}', "");
    Expect(0, 67648, '\P{^Scx=cprt}', "");
    Expect(1, 67647, '\p{Scx=-CPRT}', "");
    Expect(0, 67647, '\p{^Scx=-CPRT}', "");
    Expect(0, 67647, '\P{Scx=-CPRT}', "");
    Expect(1, 67647, '\P{^Scx=-CPRT}', "");
    Expect(0, 67648, '\p{Scx=-CPRT}', "");
    Expect(1, 67648, '\p{^Scx=-CPRT}', "");
    Expect(1, 67648, '\P{Scx=-CPRT}', "");
    Expect(0, 67648, '\P{^Scx=-CPRT}', "");
    Error('\p{Is_Script_Extensions=	-cypriot:=}');
    Error('\P{Is_Script_Extensions=	-cypriot:=}');
    Expect(1, 67647, '\p{Is_Script_Extensions=cypriot}', "");
    Expect(0, 67647, '\p{^Is_Script_Extensions=cypriot}', "");
    Expect(0, 67647, '\P{Is_Script_Extensions=cypriot}', "");
    Expect(1, 67647, '\P{^Is_Script_Extensions=cypriot}', "");
    Expect(0, 67648, '\p{Is_Script_Extensions=cypriot}', "");
    Expect(1, 67648, '\p{^Is_Script_Extensions=cypriot}', "");
    Expect(1, 67648, '\P{Is_Script_Extensions=cypriot}', "");
    Expect(0, 67648, '\P{^Is_Script_Extensions=cypriot}', "");
    Expect(1, 67647, '\p{Is_Script_Extensions=  CYPRIOT}', "");
    Expect(0, 67647, '\p{^Is_Script_Extensions=  CYPRIOT}', "");
    Expect(0, 67647, '\P{Is_Script_Extensions=  CYPRIOT}', "");
    Expect(1, 67647, '\P{^Is_Script_Extensions=  CYPRIOT}', "");
    Expect(0, 67648, '\p{Is_Script_Extensions=  CYPRIOT}', "");
    Expect(1, 67648, '\p{^Is_Script_Extensions=  CYPRIOT}', "");
    Expect(1, 67648, '\P{Is_Script_Extensions=  CYPRIOT}', "");
    Expect(0, 67648, '\P{^Is_Script_Extensions=  CYPRIOT}', "");
    Error('\p{Is_Scx=:=	_cprt}');
    Error('\P{Is_Scx=:=	_cprt}');
    Expect(1, 67647, '\p{Is_Scx=cprt}', "");
    Expect(0, 67647, '\p{^Is_Scx=cprt}', "");
    Expect(0, 67647, '\P{Is_Scx=cprt}', "");
    Expect(1, 67647, '\P{^Is_Scx=cprt}', "");
    Expect(0, 67648, '\p{Is_Scx=cprt}', "");
    Expect(1, 67648, '\p{^Is_Scx=cprt}', "");
    Expect(1, 67648, '\P{Is_Scx=cprt}', "");
    Expect(0, 67648, '\P{^Is_Scx=cprt}', "");
    Expect(1, 67647, '\p{Is_Scx=	_cprt}', "");
    Expect(0, 67647, '\p{^Is_Scx=	_cprt}', "");
    Expect(0, 67647, '\P{Is_Scx=	_cprt}', "");
    Expect(1, 67647, '\P{^Is_Scx=	_cprt}', "");
    Expect(0, 67648, '\p{Is_Scx=	_cprt}', "");
    Expect(1, 67648, '\p{^Is_Scx=	_cprt}', "");
    Expect(1, 67648, '\P{Is_Scx=	_cprt}', "");
    Expect(0, 67648, '\P{^Is_Scx=	_cprt}', "");
    Error('\p{Script_Extensions=:=-Cyrillic}');
    Error('\P{Script_Extensions=:=-Cyrillic}');
    Expect(1, 65071, '\p{Script_Extensions=cyrillic}', "");
    Expect(0, 65071, '\p{^Script_Extensions=cyrillic}', "");
    Expect(0, 65071, '\P{Script_Extensions=cyrillic}', "");
    Expect(1, 65071, '\P{^Script_Extensions=cyrillic}', "");
    Expect(0, 65072, '\p{Script_Extensions=cyrillic}', "");
    Expect(1, 65072, '\p{^Script_Extensions=cyrillic}', "");
    Expect(1, 65072, '\P{Script_Extensions=cyrillic}', "");
    Expect(0, 65072, '\P{^Script_Extensions=cyrillic}', "");
    Expect(1, 65071, '\p{Script_Extensions:	-cyrillic}', "");
    Expect(0, 65071, '\p{^Script_Extensions:	-cyrillic}', "");
    Expect(0, 65071, '\P{Script_Extensions:	-cyrillic}', "");
    Expect(1, 65071, '\P{^Script_Extensions:	-cyrillic}', "");
    Expect(0, 65072, '\p{Script_Extensions:	-cyrillic}', "");
    Expect(1, 65072, '\p{^Script_Extensions:	-cyrillic}', "");
    Expect(1, 65072, '\P{Script_Extensions:	-cyrillic}', "");
    Expect(0, 65072, '\P{^Script_Extensions:	-cyrillic}', "");
    Error('\p{Scx:   	/a/Cyrl}');
    Error('\P{Scx:   	/a/Cyrl}');
    Expect(1, 65071, '\p{Scx=cyrl}', "");
    Expect(0, 65071, '\p{^Scx=cyrl}', "");
    Expect(0, 65071, '\P{Scx=cyrl}', "");
    Expect(1, 65071, '\P{^Scx=cyrl}', "");
    Expect(0, 65072, '\p{Scx=cyrl}', "");
    Expect(1, 65072, '\p{^Scx=cyrl}', "");
    Expect(1, 65072, '\P{Scx=cyrl}', "");
    Expect(0, 65072, '\P{^Scx=cyrl}', "");
    Expect(1, 65071, '\p{Scx=_	CYRL}', "");
    Expect(0, 65071, '\p{^Scx=_	CYRL}', "");
    Expect(0, 65071, '\P{Scx=_	CYRL}', "");
    Expect(1, 65071, '\P{^Scx=_	CYRL}', "");
    Expect(0, 65072, '\p{Scx=_	CYRL}', "");
    Expect(1, 65072, '\p{^Scx=_	CYRL}', "");
    Expect(1, 65072, '\P{Scx=_	CYRL}', "");
    Expect(0, 65072, '\P{^Scx=_	CYRL}', "");
    Error('\p{Is_Script_Extensions=-_Cyrillic/a/}');
    Error('\P{Is_Script_Extensions=-_Cyrillic/a/}');
    Expect(1, 65071, '\p{Is_Script_Extensions=cyrillic}', "");
    Expect(0, 65071, '\p{^Is_Script_Extensions=cyrillic}', "");
    Expect(0, 65071, '\P{Is_Script_Extensions=cyrillic}', "");
    Expect(1, 65071, '\P{^Is_Script_Extensions=cyrillic}', "");
    Expect(0, 65072, '\p{Is_Script_Extensions=cyrillic}', "");
    Expect(1, 65072, '\p{^Is_Script_Extensions=cyrillic}', "");
    Expect(1, 65072, '\P{Is_Script_Extensions=cyrillic}', "");
    Expect(0, 65072, '\P{^Is_Script_Extensions=cyrillic}', "");
    Expect(1, 65071, '\p{Is_Script_Extensions:			Cyrillic}', "");
    Expect(0, 65071, '\p{^Is_Script_Extensions:			Cyrillic}', "");
    Expect(0, 65071, '\P{Is_Script_Extensions:			Cyrillic}', "");
    Expect(1, 65071, '\P{^Is_Script_Extensions:			Cyrillic}', "");
    Expect(0, 65072, '\p{Is_Script_Extensions:			Cyrillic}', "");
    Expect(1, 65072, '\p{^Is_Script_Extensions:			Cyrillic}', "");
    Expect(1, 65072, '\P{Is_Script_Extensions:			Cyrillic}', "");
    Expect(0, 65072, '\P{^Is_Script_Extensions:			Cyrillic}', "");
    Error('\p{Is_Scx=	/a/Cyrl}');
    Error('\P{Is_Scx=	/a/Cyrl}');
    Expect(1, 65071, '\p{Is_Scx=cyrl}', "");
    Expect(0, 65071, '\p{^Is_Scx=cyrl}', "");
    Expect(0, 65071, '\P{Is_Scx=cyrl}', "");
    Expect(1, 65071, '\P{^Is_Scx=cyrl}', "");
    Expect(0, 65072, '\p{Is_Scx=cyrl}', "");
    Expect(1, 65072, '\p{^Is_Scx=cyrl}', "");
    Expect(1, 65072, '\P{Is_Scx=cyrl}', "");
    Expect(0, 65072, '\P{^Is_Scx=cyrl}', "");
    Expect(1, 65071, '\p{Is_Scx=--Cyrl}', "");
    Expect(0, 65071, '\p{^Is_Scx=--Cyrl}', "");
    Expect(0, 65071, '\P{Is_Scx=--Cyrl}', "");
    Expect(1, 65071, '\P{^Is_Scx=--Cyrl}', "");
    Expect(0, 65072, '\p{Is_Scx=--Cyrl}', "");
    Expect(1, 65072, '\p{^Is_Scx=--Cyrl}', "");
    Expect(1, 65072, '\P{Is_Scx=--Cyrl}', "");
    Expect(0, 65072, '\P{^Is_Scx=--Cyrl}', "");
    Error('\p{Script_Extensions=:= -Devanagari}');
    Error('\P{Script_Extensions=:= -Devanagari}');
    Expect(1, 43261, '\p{Script_Extensions=devanagari}', "");
    Expect(0, 43261, '\p{^Script_Extensions=devanagari}', "");
    Expect(0, 43261, '\P{Script_Extensions=devanagari}', "");
    Expect(1, 43261, '\P{^Script_Extensions=devanagari}', "");
    Expect(0, 43262, '\p{Script_Extensions=devanagari}', "");
    Expect(1, 43262, '\p{^Script_Extensions=devanagari}', "");
    Expect(1, 43262, '\P{Script_Extensions=devanagari}', "");
    Expect(0, 43262, '\P{^Script_Extensions=devanagari}', "");
    Expect(1, 43261, '\p{Script_Extensions= DEVANAGARI}', "");
    Expect(0, 43261, '\p{^Script_Extensions= DEVANAGARI}', "");
    Expect(0, 43261, '\P{Script_Extensions= DEVANAGARI}', "");
    Expect(1, 43261, '\P{^Script_Extensions= DEVANAGARI}', "");
    Expect(0, 43262, '\p{Script_Extensions= DEVANAGARI}', "");
    Expect(1, 43262, '\p{^Script_Extensions= DEVANAGARI}', "");
    Expect(1, 43262, '\P{Script_Extensions= DEVANAGARI}', "");
    Expect(0, 43262, '\P{^Script_Extensions= DEVANAGARI}', "");
    Error('\p{Scx= _Deva/a/}');
    Error('\P{Scx= _Deva/a/}');
    Expect(1, 43261, '\p{Scx=deva}', "");
    Expect(0, 43261, '\p{^Scx=deva}', "");
    Expect(0, 43261, '\P{Scx=deva}', "");
    Expect(1, 43261, '\P{^Scx=deva}', "");
    Expect(0, 43262, '\p{Scx=deva}', "");
    Expect(1, 43262, '\p{^Scx=deva}', "");
    Expect(1, 43262, '\P{Scx=deva}', "");
    Expect(0, 43262, '\P{^Scx=deva}', "");
    Expect(1, 43261, '\p{Scx=- deva}', "");
    Expect(0, 43261, '\p{^Scx=- deva}', "");
    Expect(0, 43261, '\P{Scx=- deva}', "");
    Expect(1, 43261, '\P{^Scx=- deva}', "");
    Expect(0, 43262, '\p{Scx=- deva}', "");
    Expect(1, 43262, '\p{^Scx=- deva}', "");
    Expect(1, 43262, '\P{Scx=- deva}', "");
    Expect(0, 43262, '\P{^Scx=- deva}', "");
    Error('\p{Is_Script_Extensions:-	Devanagari:=}');
    Error('\P{Is_Script_Extensions:-	Devanagari:=}');
    Expect(1, 43261, '\p{Is_Script_Extensions=devanagari}', "");
    Expect(0, 43261, '\p{^Is_Script_Extensions=devanagari}', "");
    Expect(0, 43261, '\P{Is_Script_Extensions=devanagari}', "");
    Expect(1, 43261, '\P{^Is_Script_Extensions=devanagari}', "");
    Expect(0, 43262, '\p{Is_Script_Extensions=devanagari}', "");
    Expect(1, 43262, '\p{^Is_Script_Extensions=devanagari}', "");
    Expect(1, 43262, '\P{Is_Script_Extensions=devanagari}', "");
    Expect(0, 43262, '\P{^Is_Script_Extensions=devanagari}', "");
    Expect(1, 43261, '\p{Is_Script_Extensions:   DEVANAGARI}', "");
    Expect(0, 43261, '\p{^Is_Script_Extensions:   DEVANAGARI}', "");
    Expect(0, 43261, '\P{Is_Script_Extensions:   DEVANAGARI}', "");
    Expect(1, 43261, '\P{^Is_Script_Extensions:   DEVANAGARI}', "");
    Expect(0, 43262, '\p{Is_Script_Extensions:   DEVANAGARI}', "");
    Expect(1, 43262, '\p{^Is_Script_Extensions:   DEVANAGARI}', "");
    Expect(1, 43262, '\P{Is_Script_Extensions:   DEVANAGARI}', "");
    Expect(0, 43262, '\P{^Is_Script_Extensions:   DEVANAGARI}', "");
    Error('\p{Is_Scx=	_Deva:=}');
    Error('\P{Is_Scx=	_Deva:=}');
    Expect(1, 43261, '\p{Is_Scx=deva}', "");
    Expect(0, 43261, '\p{^Is_Scx=deva}', "");
    Expect(0, 43261, '\P{Is_Scx=deva}', "");
    Expect(1, 43261, '\P{^Is_Scx=deva}', "");
    Expect(0, 43262, '\p{Is_Scx=deva}', "");
    Expect(1, 43262, '\p{^Is_Scx=deva}', "");
    Expect(1, 43262, '\P{Is_Scx=deva}', "");
    Expect(0, 43262, '\P{^Is_Scx=deva}', "");
    Expect(1, 43261, '\p{Is_Scx: deva}', "");
    Expect(0, 43261, '\p{^Is_Scx: deva}', "");
    Expect(0, 43261, '\P{Is_Scx: deva}', "");
    Expect(1, 43261, '\P{^Is_Scx: deva}', "");
    Expect(0, 43262, '\p{Is_Scx: deva}', "");
    Expect(1, 43262, '\p{^Is_Scx: deva}', "");
    Expect(1, 43262, '\P{Is_Scx: deva}', "");
    Expect(0, 43262, '\P{^Is_Scx: deva}', "");
    Error('\p{Script_Extensions=:=_ DESERET}');
    Error('\P{Script_Extensions=:=_ DESERET}');
    Expect(1, 66639, '\p{Script_Extensions=deseret}', "");
    Expect(0, 66639, '\p{^Script_Extensions=deseret}', "");
    Expect(0, 66639, '\P{Script_Extensions=deseret}', "");
    Expect(1, 66639, '\P{^Script_Extensions=deseret}', "");
    Expect(0, 66640, '\p{Script_Extensions=deseret}', "");
    Expect(1, 66640, '\p{^Script_Extensions=deseret}', "");
    Expect(1, 66640, '\P{Script_Extensions=deseret}', "");
    Expect(0, 66640, '\P{^Script_Extensions=deseret}', "");
    Expect(1, 66639, '\p{Script_Extensions=_DESERET}', "");
    Expect(0, 66639, '\p{^Script_Extensions=_DESERET}', "");
    Expect(0, 66639, '\P{Script_Extensions=_DESERET}', "");
    Expect(1, 66639, '\P{^Script_Extensions=_DESERET}', "");
    Expect(0, 66640, '\p{Script_Extensions=_DESERET}', "");
    Expect(1, 66640, '\p{^Script_Extensions=_DESERET}', "");
    Expect(1, 66640, '\P{Script_Extensions=_DESERET}', "");
    Expect(0, 66640, '\P{^Script_Extensions=_DESERET}', "");
    Error('\p{Scx=	:=Dsrt}');
    Error('\P{Scx=	:=Dsrt}');
    Expect(1, 66639, '\p{Scx=dsrt}', "");
    Expect(0, 66639, '\p{^Scx=dsrt}', "");
    Expect(0, 66639, '\P{Scx=dsrt}', "");
    Expect(1, 66639, '\P{^Scx=dsrt}', "");
    Expect(0, 66640, '\p{Scx=dsrt}', "");
    Expect(1, 66640, '\p{^Scx=dsrt}', "");
    Expect(1, 66640, '\P{Scx=dsrt}', "");
    Expect(0, 66640, '\P{^Scx=dsrt}', "");
    Expect(1, 66639, '\p{Scx:	_DSRT}', "");
    Expect(0, 66639, '\p{^Scx:	_DSRT}', "");
    Expect(0, 66639, '\P{Scx:	_DSRT}', "");
    Expect(1, 66639, '\P{^Scx:	_DSRT}', "");
    Expect(0, 66640, '\p{Scx:	_DSRT}', "");
    Expect(1, 66640, '\p{^Scx:	_DSRT}', "");
    Expect(1, 66640, '\P{Scx:	_DSRT}', "");
    Expect(0, 66640, '\P{^Scx:	_DSRT}', "");
    Error('\p{Is_Script_Extensions=/a/DESERET}');
    Error('\P{Is_Script_Extensions=/a/DESERET}');
    Expect(1, 66639, '\p{Is_Script_Extensions=deseret}', "");
    Expect(0, 66639, '\p{^Is_Script_Extensions=deseret}', "");
    Expect(0, 66639, '\P{Is_Script_Extensions=deseret}', "");
    Expect(1, 66639, '\P{^Is_Script_Extensions=deseret}', "");
    Expect(0, 66640, '\p{Is_Script_Extensions=deseret}', "");
    Expect(1, 66640, '\p{^Is_Script_Extensions=deseret}', "");
    Expect(1, 66640, '\P{Is_Script_Extensions=deseret}', "");
    Expect(0, 66640, '\P{^Is_Script_Extensions=deseret}', "");
    Expect(1, 66639, '\p{Is_Script_Extensions=--DESERET}', "");
    Expect(0, 66639, '\p{^Is_Script_Extensions=--DESERET}', "");
    Expect(0, 66639, '\P{Is_Script_Extensions=--DESERET}', "");
    Expect(1, 66639, '\P{^Is_Script_Extensions=--DESERET}', "");
    Expect(0, 66640, '\p{Is_Script_Extensions=--DESERET}', "");
    Expect(1, 66640, '\p{^Is_Script_Extensions=--DESERET}', "");
    Expect(1, 66640, '\P{Is_Script_Extensions=--DESERET}', "");
    Expect(0, 66640, '\P{^Is_Script_Extensions=--DESERET}', "");
    Error('\p{Is_Scx=/a/dsrt}');
    Error('\P{Is_Scx=/a/dsrt}');
    Expect(1, 66639, '\p{Is_Scx=dsrt}', "");
    Expect(0, 66639, '\p{^Is_Scx=dsrt}', "");
    Expect(0, 66639, '\P{Is_Scx=dsrt}', "");
    Expect(1, 66639, '\P{^Is_Scx=dsrt}', "");
    Expect(0, 66640, '\p{Is_Scx=dsrt}', "");
    Expect(1, 66640, '\p{^Is_Scx=dsrt}', "");
    Expect(1, 66640, '\P{Is_Scx=dsrt}', "");
    Expect(0, 66640, '\P{^Is_Scx=dsrt}', "");
    Expect(1, 66639, '\p{Is_Scx=	Dsrt}', "");
    Expect(0, 66639, '\p{^Is_Scx=	Dsrt}', "");
    Expect(0, 66639, '\P{Is_Scx=	Dsrt}', "");
    Expect(1, 66639, '\P{^Is_Scx=	Dsrt}', "");
    Expect(0, 66640, '\p{Is_Scx=	Dsrt}', "");
    Expect(1, 66640, '\p{^Is_Scx=	Dsrt}', "");
    Expect(1, 66640, '\P{Is_Scx=	Dsrt}', "");
    Expect(0, 66640, '\P{^Is_Scx=	Dsrt}', "");
    Error('\p{Script_Extensions=/a/-Duployan}');
    Error('\P{Script_Extensions=/a/-Duployan}');
    Expect(1, 113827, '\p{Script_Extensions=duployan}', "");
    Expect(0, 113827, '\p{^Script_Extensions=duployan}', "");
    Expect(0, 113827, '\P{Script_Extensions=duployan}', "");
    Expect(1, 113827, '\P{^Script_Extensions=duployan}', "");
    Expect(0, 113828, '\p{Script_Extensions=duployan}', "");
    Expect(1, 113828, '\p{^Script_Extensions=duployan}', "");
    Expect(1, 113828, '\P{Script_Extensions=duployan}', "");
    Expect(0, 113828, '\P{^Script_Extensions=duployan}', "");
    Expect(1, 113827, '\p{Script_Extensions=	-DUPLOYAN}', "");
    Expect(0, 113827, '\p{^Script_Extensions=	-DUPLOYAN}', "");
    Expect(0, 113827, '\P{Script_Extensions=	-DUPLOYAN}', "");
    Expect(1, 113827, '\P{^Script_Extensions=	-DUPLOYAN}', "");
    Expect(0, 113828, '\p{Script_Extensions=	-DUPLOYAN}', "");
    Expect(1, 113828, '\p{^Script_Extensions=	-DUPLOYAN}', "");
    Expect(1, 113828, '\P{Script_Extensions=	-DUPLOYAN}', "");
    Expect(0, 113828, '\P{^Script_Extensions=	-DUPLOYAN}', "");
    Error('\p{Scx=:=_Dupl}');
    Error('\P{Scx=:=_Dupl}');
    Expect(1, 113827, '\p{Scx=dupl}', "");
    Expect(0, 113827, '\p{^Scx=dupl}', "");
    Expect(0, 113827, '\P{Scx=dupl}', "");
    Expect(1, 113827, '\P{^Scx=dupl}', "");
    Expect(0, 113828, '\p{Scx=dupl}', "");
    Expect(1, 113828, '\p{^Scx=dupl}', "");
    Expect(1, 113828, '\P{Scx=dupl}', "");
    Expect(0, 113828, '\P{^Scx=dupl}', "");
    Expect(1, 113827, '\p{Scx=-_DUPL}', "");
    Expect(0, 113827, '\p{^Scx=-_DUPL}', "");
    Expect(0, 113827, '\P{Scx=-_DUPL}', "");
    Expect(1, 113827, '\P{^Scx=-_DUPL}', "");
    Expect(0, 113828, '\p{Scx=-_DUPL}', "");
    Expect(1, 113828, '\p{^Scx=-_DUPL}', "");
    Expect(1, 113828, '\P{Scx=-_DUPL}', "");
    Expect(0, 113828, '\P{^Scx=-_DUPL}', "");
    Error('\p{Is_Script_Extensions=:=--DUPLOYAN}');
    Error('\P{Is_Script_Extensions=:=--DUPLOYAN}');
    Expect(1, 113827, '\p{Is_Script_Extensions=duployan}', "");
    Expect(0, 113827, '\p{^Is_Script_Extensions=duployan}', "");
    Expect(0, 113827, '\P{Is_Script_Extensions=duployan}', "");
    Expect(1, 113827, '\P{^Is_Script_Extensions=duployan}', "");
    Expect(0, 113828, '\p{Is_Script_Extensions=duployan}', "");
    Expect(1, 113828, '\p{^Is_Script_Extensions=duployan}', "");
    Expect(1, 113828, '\P{Is_Script_Extensions=duployan}', "");
    Expect(0, 113828, '\P{^Is_Script_Extensions=duployan}', "");
    Expect(1, 113827, '\p{Is_Script_Extensions= DUPLOYAN}', "");
    Expect(0, 113827, '\p{^Is_Script_Extensions= DUPLOYAN}', "");
    Expect(0, 113827, '\P{Is_Script_Extensions= DUPLOYAN}', "");
    Expect(1, 113827, '\P{^Is_Script_Extensions= DUPLOYAN}', "");
    Expect(0, 113828, '\p{Is_Script_Extensions= DUPLOYAN}', "");
    Expect(1, 113828, '\p{^Is_Script_Extensions= DUPLOYAN}', "");
    Expect(1, 113828, '\P{Is_Script_Extensions= DUPLOYAN}', "");
    Expect(0, 113828, '\P{^Is_Script_Extensions= DUPLOYAN}', "");
    Error('\p{Is_Scx=_:=DUPL}');
    Error('\P{Is_Scx=_:=DUPL}');
    Expect(1, 113827, '\p{Is_Scx=dupl}', "");
    Expect(0, 113827, '\p{^Is_Scx=dupl}', "");
    Expect(0, 113827, '\P{Is_Scx=dupl}', "");
    Expect(1, 113827, '\P{^Is_Scx=dupl}', "");
    Expect(0, 113828, '\p{Is_Scx=dupl}', "");
    Expect(1, 113828, '\p{^Is_Scx=dupl}', "");
    Expect(1, 113828, '\P{Is_Scx=dupl}', "");
    Expect(0, 113828, '\P{^Is_Scx=dupl}', "");
    Expect(1, 113827, '\p{Is_Scx=-_Dupl}', "");
    Expect(0, 113827, '\p{^Is_Scx=-_Dupl}', "");
    Expect(0, 113827, '\P{Is_Scx=-_Dupl}', "");
    Expect(1, 113827, '\P{^Is_Scx=-_Dupl}', "");
    Expect(0, 113828, '\p{Is_Scx=-_Dupl}', "");
    Expect(1, 113828, '\p{^Is_Scx=-_Dupl}', "");
    Expect(1, 113828, '\P{Is_Scx=-_Dupl}', "");
    Expect(0, 113828, '\P{^Is_Scx=-_Dupl}', "");
    Error('\p{Script_Extensions=:=Egyptian_hieroglyphs}');
    Error('\P{Script_Extensions=:=Egyptian_hieroglyphs}');
    Expect(1, 78894, '\p{Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78894, '\p{^Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78894, '\P{Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78894, '\P{^Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{^Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{^Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78894, '\p{Script_Extensions= -Egyptian_HIEROGLYPHS}', "");
    Expect(0, 78894, '\p{^Script_Extensions= -Egyptian_HIEROGLYPHS}', "");
    Expect(0, 78894, '\P{Script_Extensions= -Egyptian_HIEROGLYPHS}', "");
    Expect(1, 78894, '\P{^Script_Extensions= -Egyptian_HIEROGLYPHS}', "");
    Expect(0, 78895, '\p{Script_Extensions= -Egyptian_HIEROGLYPHS}', "");
    Expect(1, 78895, '\p{^Script_Extensions= -Egyptian_HIEROGLYPHS}', "");
    Expect(1, 78895, '\P{Script_Extensions= -Egyptian_HIEROGLYPHS}', "");
    Expect(0, 78895, '\P{^Script_Extensions= -Egyptian_HIEROGLYPHS}', "");
    Error('\p{Scx=/a/ 	Egyp}');
    Error('\P{Scx=/a/ 	Egyp}');
    Expect(1, 78894, '\p{Scx=egyp}', "");
    Expect(0, 78894, '\p{^Scx=egyp}', "");
    Expect(0, 78894, '\P{Scx=egyp}', "");
    Expect(1, 78894, '\P{^Scx=egyp}', "");
    Expect(0, 78895, '\p{Scx=egyp}', "");
    Expect(1, 78895, '\p{^Scx=egyp}', "");
    Expect(1, 78895, '\P{Scx=egyp}', "");
    Expect(0, 78895, '\P{^Scx=egyp}', "");
    Expect(1, 78894, '\p{Scx= _Egyp}', "");
    Expect(0, 78894, '\p{^Scx= _Egyp}', "");
    Expect(0, 78894, '\P{Scx= _Egyp}', "");
    Expect(1, 78894, '\P{^Scx= _Egyp}', "");
    Expect(0, 78895, '\p{Scx= _Egyp}', "");
    Expect(1, 78895, '\p{^Scx= _Egyp}', "");
    Expect(1, 78895, '\P{Scx= _Egyp}', "");
    Expect(0, 78895, '\P{^Scx= _Egyp}', "");
    Error('\p{Is_Script_Extensions=_Egyptian_Hieroglyphs:=}');
    Error('\P{Is_Script_Extensions=_Egyptian_Hieroglyphs:=}');
    Expect(1, 78894, '\p{Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78894, '\p{^Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78894, '\P{Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78894, '\P{^Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{^Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{^Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78894, '\p{Is_Script_Extensions= Egyptian_Hieroglyphs}', "");
    Expect(0, 78894, '\p{^Is_Script_Extensions= Egyptian_Hieroglyphs}', "");
    Expect(0, 78894, '\P{Is_Script_Extensions= Egyptian_Hieroglyphs}', "");
    Expect(1, 78894, '\P{^Is_Script_Extensions= Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\p{Is_Script_Extensions= Egyptian_Hieroglyphs}', "");
    Expect(1, 78895, '\p{^Is_Script_Extensions= Egyptian_Hieroglyphs}', "");
    Expect(1, 78895, '\P{Is_Script_Extensions= Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\P{^Is_Script_Extensions= Egyptian_Hieroglyphs}', "");
    Error('\p{Is_Scx=	-Egyp:=}');
    Error('\P{Is_Scx=	-Egyp:=}');
    Expect(1, 78894, '\p{Is_Scx=egyp}', "");
    Expect(0, 78894, '\p{^Is_Scx=egyp}', "");
    Expect(0, 78894, '\P{Is_Scx=egyp}', "");
    Expect(1, 78894, '\P{^Is_Scx=egyp}', "");
    Expect(0, 78895, '\p{Is_Scx=egyp}', "");
    Expect(1, 78895, '\p{^Is_Scx=egyp}', "");
    Expect(1, 78895, '\P{Is_Scx=egyp}', "");
    Expect(0, 78895, '\P{^Is_Scx=egyp}', "");
    Expect(1, 78894, '\p{Is_Scx=	-egyp}', "");
    Expect(0, 78894, '\p{^Is_Scx=	-egyp}', "");
    Expect(0, 78894, '\P{Is_Scx=	-egyp}', "");
    Expect(1, 78894, '\P{^Is_Scx=	-egyp}', "");
    Expect(0, 78895, '\p{Is_Scx=	-egyp}', "");
    Expect(1, 78895, '\p{^Is_Scx=	-egyp}', "");
    Expect(1, 78895, '\P{Is_Scx=	-egyp}', "");
    Expect(0, 78895, '\P{^Is_Scx=	-egyp}', "");
    Error('\p{Script_Extensions=:=--ELBASAN}');
    Error('\P{Script_Extensions=:=--ELBASAN}');
    Expect(1, 66855, '\p{Script_Extensions=elbasan}', "");
    Expect(0, 66855, '\p{^Script_Extensions=elbasan}', "");
    Expect(0, 66855, '\P{Script_Extensions=elbasan}', "");
    Expect(1, 66855, '\P{^Script_Extensions=elbasan}', "");
    Expect(0, 66856, '\p{Script_Extensions=elbasan}', "");
    Expect(1, 66856, '\p{^Script_Extensions=elbasan}', "");
    Expect(1, 66856, '\P{Script_Extensions=elbasan}', "");
    Expect(0, 66856, '\P{^Script_Extensions=elbasan}', "");
    Expect(1, 66855, '\p{Script_Extensions=_	elbasan}', "");
    Expect(0, 66855, '\p{^Script_Extensions=_	elbasan}', "");
    Expect(0, 66855, '\P{Script_Extensions=_	elbasan}', "");
    Expect(1, 66855, '\P{^Script_Extensions=_	elbasan}', "");
    Expect(0, 66856, '\p{Script_Extensions=_	elbasan}', "");
    Expect(1, 66856, '\p{^Script_Extensions=_	elbasan}', "");
    Expect(1, 66856, '\P{Script_Extensions=_	elbasan}', "");
    Expect(0, 66856, '\P{^Script_Extensions=_	elbasan}', "");
    Error('\p{Scx=/a/_Elba}');
    Error('\P{Scx=/a/_Elba}');
    Expect(1, 66855, '\p{Scx:   elba}', "");
    Expect(0, 66855, '\p{^Scx:   elba}', "");
    Expect(0, 66855, '\P{Scx:   elba}', "");
    Expect(1, 66855, '\P{^Scx:   elba}', "");
    Expect(0, 66856, '\p{Scx:   elba}', "");
    Expect(1, 66856, '\p{^Scx:   elba}', "");
    Expect(1, 66856, '\P{Scx:   elba}', "");
    Expect(0, 66856, '\P{^Scx:   elba}', "");
    Expect(1, 66855, '\p{Scx=	ELBA}', "");
    Expect(0, 66855, '\p{^Scx=	ELBA}', "");
    Expect(0, 66855, '\P{Scx=	ELBA}', "");
    Expect(1, 66855, '\P{^Scx=	ELBA}', "");
    Expect(0, 66856, '\p{Scx=	ELBA}', "");
    Expect(1, 66856, '\p{^Scx=	ELBA}', "");
    Expect(1, 66856, '\P{Scx=	ELBA}', "");
    Expect(0, 66856, '\P{^Scx=	ELBA}', "");
    Error('\p{Is_Script_Extensions=:=	_Elbasan}');
    Error('\P{Is_Script_Extensions=:=	_Elbasan}');
    Expect(1, 66855, '\p{Is_Script_Extensions=elbasan}', "");
    Expect(0, 66855, '\p{^Is_Script_Extensions=elbasan}', "");
    Expect(0, 66855, '\P{Is_Script_Extensions=elbasan}', "");
    Expect(1, 66855, '\P{^Is_Script_Extensions=elbasan}', "");
    Expect(0, 66856, '\p{Is_Script_Extensions=elbasan}', "");
    Expect(1, 66856, '\p{^Is_Script_Extensions=elbasan}', "");
    Expect(1, 66856, '\P{Is_Script_Extensions=elbasan}', "");
    Expect(0, 66856, '\P{^Is_Script_Extensions=elbasan}', "");
    Expect(1, 66855, '\p{Is_Script_Extensions=_-elbasan}', "");
    Expect(0, 66855, '\p{^Is_Script_Extensions=_-elbasan}', "");
    Expect(0, 66855, '\P{Is_Script_Extensions=_-elbasan}', "");
    Expect(1, 66855, '\P{^Is_Script_Extensions=_-elbasan}', "");
    Expect(0, 66856, '\p{Is_Script_Extensions=_-elbasan}', "");
    Expect(1, 66856, '\p{^Is_Script_Extensions=_-elbasan}', "");
    Expect(1, 66856, '\P{Is_Script_Extensions=_-elbasan}', "");
    Expect(0, 66856, '\P{^Is_Script_Extensions=_-elbasan}', "");
    Error('\p{Is_Scx=	/a/ELBA}');
    Error('\P{Is_Scx=	/a/ELBA}');
    Expect(1, 66855, '\p{Is_Scx=elba}', "");
    Expect(0, 66855, '\p{^Is_Scx=elba}', "");
    Expect(0, 66855, '\P{Is_Scx=elba}', "");
    Expect(1, 66855, '\P{^Is_Scx=elba}', "");
    Expect(0, 66856, '\p{Is_Scx=elba}', "");
    Expect(1, 66856, '\p{^Is_Scx=elba}', "");
    Expect(1, 66856, '\P{Is_Scx=elba}', "");
    Expect(0, 66856, '\P{^Is_Scx=elba}', "");
    Expect(1, 66855, '\p{Is_Scx: --Elba}', "");
    Expect(0, 66855, '\p{^Is_Scx: --Elba}', "");
    Expect(0, 66855, '\P{Is_Scx: --Elba}', "");
    Expect(1, 66855, '\P{^Is_Scx: --Elba}', "");
    Expect(0, 66856, '\p{Is_Scx: --Elba}', "");
    Expect(1, 66856, '\p{^Is_Scx: --Elba}', "");
    Expect(1, 66856, '\P{Is_Scx: --Elba}', "");
    Expect(0, 66856, '\P{^Is_Scx: --Elba}', "");
    Error('\p{Script_Extensions=-/a/ETHIOPIC}');
    Error('\P{Script_Extensions=-/a/ETHIOPIC}');
    Expect(1, 43822, '\p{Script_Extensions:ethiopic}', "");
    Expect(0, 43822, '\p{^Script_Extensions:ethiopic}', "");
    Expect(0, 43822, '\P{Script_Extensions:ethiopic}', "");
    Expect(1, 43822, '\P{^Script_Extensions:ethiopic}', "");
    Expect(0, 43823, '\p{Script_Extensions:ethiopic}', "");
    Expect(1, 43823, '\p{^Script_Extensions:ethiopic}', "");
    Expect(1, 43823, '\P{Script_Extensions:ethiopic}', "");
    Expect(0, 43823, '\P{^Script_Extensions:ethiopic}', "");
    Expect(1, 43822, '\p{Script_Extensions=	 ETHIOPIC}', "");
    Expect(0, 43822, '\p{^Script_Extensions=	 ETHIOPIC}', "");
    Expect(0, 43822, '\P{Script_Extensions=	 ETHIOPIC}', "");
    Expect(1, 43822, '\P{^Script_Extensions=	 ETHIOPIC}', "");
    Expect(0, 43823, '\p{Script_Extensions=	 ETHIOPIC}', "");
    Expect(1, 43823, '\p{^Script_Extensions=	 ETHIOPIC}', "");
    Expect(1, 43823, '\P{Script_Extensions=	 ETHIOPIC}', "");
    Expect(0, 43823, '\P{^Script_Extensions=	 ETHIOPIC}', "");
    Error('\p{Scx=/a/		ethi}');
    Error('\P{Scx=/a/		ethi}');
    Expect(1, 43822, '\p{Scx=ethi}', "");
    Expect(0, 43822, '\p{^Scx=ethi}', "");
    Expect(0, 43822, '\P{Scx=ethi}', "");
    Expect(1, 43822, '\P{^Scx=ethi}', "");
    Expect(0, 43823, '\p{Scx=ethi}', "");
    Expect(1, 43823, '\p{^Scx=ethi}', "");
    Expect(1, 43823, '\P{Scx=ethi}', "");
    Expect(0, 43823, '\P{^Scx=ethi}', "");
    Expect(1, 43822, '\p{Scx=_-ETHI}', "");
    Expect(0, 43822, '\p{^Scx=_-ETHI}', "");
    Expect(0, 43822, '\P{Scx=_-ETHI}', "");
    Expect(1, 43822, '\P{^Scx=_-ETHI}', "");
    Expect(0, 43823, '\p{Scx=_-ETHI}', "");
    Expect(1, 43823, '\p{^Scx=_-ETHI}', "");
    Expect(1, 43823, '\P{Scx=_-ETHI}', "");
    Expect(0, 43823, '\P{^Scx=_-ETHI}', "");
    Error('\p{Is_Script_Extensions=/a/ 	Ethiopic}');
    Error('\P{Is_Script_Extensions=/a/ 	Ethiopic}');
    Expect(1, 43822, '\p{Is_Script_Extensions:	ethiopic}', "");
    Expect(0, 43822, '\p{^Is_Script_Extensions:	ethiopic}', "");
    Expect(0, 43822, '\P{Is_Script_Extensions:	ethiopic}', "");
    Expect(1, 43822, '\P{^Is_Script_Extensions:	ethiopic}', "");
    Expect(0, 43823, '\p{Is_Script_Extensions:	ethiopic}', "");
    Expect(1, 43823, '\p{^Is_Script_Extensions:	ethiopic}', "");
    Expect(1, 43823, '\P{Is_Script_Extensions:	ethiopic}', "");
    Expect(0, 43823, '\P{^Is_Script_Extensions:	ethiopic}', "");
    Expect(1, 43822, '\p{Is_Script_Extensions=_	ETHIOPIC}', "");
    Expect(0, 43822, '\p{^Is_Script_Extensions=_	ETHIOPIC}', "");
    Expect(0, 43822, '\P{Is_Script_Extensions=_	ETHIOPIC}', "");
    Expect(1, 43822, '\P{^Is_Script_Extensions=_	ETHIOPIC}', "");
    Expect(0, 43823, '\p{Is_Script_Extensions=_	ETHIOPIC}', "");
    Expect(1, 43823, '\p{^Is_Script_Extensions=_	ETHIOPIC}', "");
    Expect(1, 43823, '\P{Is_Script_Extensions=_	ETHIOPIC}', "");
    Expect(0, 43823, '\P{^Is_Script_Extensions=_	ETHIOPIC}', "");
    Error('\p{Is_Scx=:=-_Ethi}');
    Error('\P{Is_Scx=:=-_Ethi}');
    Expect(1, 43822, '\p{Is_Scx=ethi}', "");
    Expect(0, 43822, '\p{^Is_Scx=ethi}', "");
    Expect(0, 43822, '\P{Is_Scx=ethi}', "");
    Expect(1, 43822, '\P{^Is_Scx=ethi}', "");
    Expect(0, 43823, '\p{Is_Scx=ethi}', "");
    Expect(1, 43823, '\p{^Is_Scx=ethi}', "");
    Expect(1, 43823, '\P{Is_Scx=ethi}', "");
    Expect(0, 43823, '\P{^Is_Scx=ethi}', "");
    Expect(1, 43822, '\p{Is_Scx=_ethi}', "");
    Expect(0, 43822, '\p{^Is_Scx=_ethi}', "");
    Expect(0, 43822, '\P{Is_Scx=_ethi}', "");
    Expect(1, 43822, '\P{^Is_Scx=_ethi}', "");
    Expect(0, 43823, '\p{Is_Scx=_ethi}', "");
    Expect(1, 43823, '\p{^Is_Scx=_ethi}', "");
    Expect(1, 43823, '\P{Is_Scx=_ethi}', "");
    Expect(0, 43823, '\P{^Is_Scx=_ethi}', "");
    Error('\p{Script_Extensions=/a/_georgian}');
    Error('\P{Script_Extensions=/a/_georgian}');
    Expect(1, 11565, '\p{Script_Extensions:	georgian}', "");
    Expect(0, 11565, '\p{^Script_Extensions:	georgian}', "");
    Expect(0, 11565, '\P{Script_Extensions:	georgian}', "");
    Expect(1, 11565, '\P{^Script_Extensions:	georgian}', "");
    Expect(0, 11566, '\p{Script_Extensions:	georgian}', "");
    Expect(1, 11566, '\p{^Script_Extensions:	georgian}', "");
    Expect(1, 11566, '\P{Script_Extensions:	georgian}', "");
    Expect(0, 11566, '\P{^Script_Extensions:	georgian}', "");
    Error('\p{Scx=	Geor/a/}');
    Error('\P{Scx=	Geor/a/}');
    Expect(1, 11565, '\p{Scx=geor}', "");
    Expect(0, 11565, '\p{^Scx=geor}', "");
    Expect(0, 11565, '\P{Scx=geor}', "");
    Expect(1, 11565, '\P{^Scx=geor}', "");
    Expect(0, 11566, '\p{Scx=geor}', "");
    Expect(1, 11566, '\p{^Scx=geor}', "");
    Expect(1, 11566, '\P{Scx=geor}', "");
    Expect(0, 11566, '\P{^Scx=geor}', "");
    Expect(1, 11565, '\p{Scx=	_GEOR}', "");
    Expect(0, 11565, '\p{^Scx=	_GEOR}', "");
    Expect(0, 11565, '\P{Scx=	_GEOR}', "");
    Expect(1, 11565, '\P{^Scx=	_GEOR}', "");
    Expect(0, 11566, '\p{Scx=	_GEOR}', "");
    Expect(1, 11566, '\p{^Scx=	_GEOR}', "");
    Expect(1, 11566, '\P{Scx=	_GEOR}', "");
    Expect(0, 11566, '\P{^Scx=	_GEOR}', "");
    Error('\p{Is_Script_Extensions=:= georgian}');
    Error('\P{Is_Script_Extensions=:= georgian}');
    Expect(1, 11565, '\p{Is_Script_Extensions: georgian}', "");
    Expect(0, 11565, '\p{^Is_Script_Extensions: georgian}', "");
    Expect(0, 11565, '\P{Is_Script_Extensions: georgian}', "");
    Expect(1, 11565, '\P{^Is_Script_Extensions: georgian}', "");
    Expect(0, 11566, '\p{Is_Script_Extensions: georgian}', "");
    Expect(1, 11566, '\p{^Is_Script_Extensions: georgian}', "");
    Expect(1, 11566, '\P{Is_Script_Extensions: georgian}', "");
    Expect(0, 11566, '\P{^Is_Script_Extensions: georgian}', "");
    Expect(1, 11565, '\p{Is_Script_Extensions= GEORGIAN}', "");
    Expect(0, 11565, '\p{^Is_Script_Extensions= GEORGIAN}', "");
    Expect(0, 11565, '\P{Is_Script_Extensions= GEORGIAN}', "");
    Expect(1, 11565, '\P{^Is_Script_Extensions= GEORGIAN}', "");
    Expect(0, 11566, '\p{Is_Script_Extensions= GEORGIAN}', "");
    Expect(1, 11566, '\p{^Is_Script_Extensions= GEORGIAN}', "");
    Expect(1, 11566, '\P{Is_Script_Extensions= GEORGIAN}', "");
    Expect(0, 11566, '\P{^Is_Script_Extensions= GEORGIAN}', "");
    Error('\p{Is_Scx=:=		Geor}');
    Error('\P{Is_Scx=:=		Geor}');
    Expect(1, 11565, '\p{Is_Scx=geor}', "");
    Expect(0, 11565, '\p{^Is_Scx=geor}', "");
    Expect(0, 11565, '\P{Is_Scx=geor}', "");
    Expect(1, 11565, '\P{^Is_Scx=geor}', "");
    Expect(0, 11566, '\p{Is_Scx=geor}', "");
    Expect(1, 11566, '\p{^Is_Scx=geor}', "");
    Expect(1, 11566, '\P{Is_Scx=geor}', "");
    Expect(0, 11566, '\P{^Is_Scx=geor}', "");
    Expect(1, 11565, '\p{Is_Scx=	geor}', "");
    Expect(0, 11565, '\p{^Is_Scx=	geor}', "");
    Expect(0, 11565, '\P{Is_Scx=	geor}', "");
    Expect(1, 11565, '\P{^Is_Scx=	geor}', "");
    Expect(0, 11566, '\p{Is_Scx=	geor}', "");
    Expect(1, 11566, '\p{^Is_Scx=	geor}', "");
    Expect(1, 11566, '\P{Is_Scx=	geor}', "");
    Expect(0, 11566, '\P{^Is_Scx=	geor}', "");
    Error('\p{Script_Extensions=	Glagolitic:=}');
    Error('\P{Script_Extensions=	Glagolitic:=}');
    Expect(1, 122922, '\p{Script_Extensions=glagolitic}', "");
    Expect(0, 122922, '\p{^Script_Extensions=glagolitic}', "");
    Expect(0, 122922, '\P{Script_Extensions=glagolitic}', "");
    Expect(1, 122922, '\P{^Script_Extensions=glagolitic}', "");
    Expect(0, 122923, '\p{Script_Extensions=glagolitic}', "");
    Expect(1, 122923, '\p{^Script_Extensions=glagolitic}', "");
    Expect(1, 122923, '\P{Script_Extensions=glagolitic}', "");
    Expect(0, 122923, '\P{^Script_Extensions=glagolitic}', "");
    Expect(1, 122922, '\p{Script_Extensions=-Glagolitic}', "");
    Expect(0, 122922, '\p{^Script_Extensions=-Glagolitic}', "");
    Expect(0, 122922, '\P{Script_Extensions=-Glagolitic}', "");
    Expect(1, 122922, '\P{^Script_Extensions=-Glagolitic}', "");
    Expect(0, 122923, '\p{Script_Extensions=-Glagolitic}', "");
    Expect(1, 122923, '\p{^Script_Extensions=-Glagolitic}', "");
    Expect(1, 122923, '\P{Script_Extensions=-Glagolitic}', "");
    Expect(0, 122923, '\P{^Script_Extensions=-Glagolitic}', "");
    Error('\p{Scx=	:=Glag}');
    Error('\P{Scx=	:=Glag}');
    Expect(1, 122922, '\p{Scx=glag}', "");
    Expect(0, 122922, '\p{^Scx=glag}', "");
    Expect(0, 122922, '\P{Scx=glag}', "");
    Expect(1, 122922, '\P{^Scx=glag}', "");
    Expect(0, 122923, '\p{Scx=glag}', "");
    Expect(1, 122923, '\p{^Scx=glag}', "");
    Expect(1, 122923, '\P{Scx=glag}', "");
    Expect(0, 122923, '\P{^Scx=glag}', "");
    Expect(1, 122922, '\p{Scx=	 Glag}', "");
    Expect(0, 122922, '\p{^Scx=	 Glag}', "");
    Expect(0, 122922, '\P{Scx=	 Glag}', "");
    Expect(1, 122922, '\P{^Scx=	 Glag}', "");
    Expect(0, 122923, '\p{Scx=	 Glag}', "");
    Expect(1, 122923, '\p{^Scx=	 Glag}', "");
    Expect(1, 122923, '\P{Scx=	 Glag}', "");
    Expect(0, 122923, '\P{^Scx=	 Glag}', "");
    Error('\p{Is_Script_Extensions=	_Glagolitic:=}');
    Error('\P{Is_Script_Extensions=	_Glagolitic:=}');
    Expect(1, 122922, '\p{Is_Script_Extensions=glagolitic}', "");
    Expect(0, 122922, '\p{^Is_Script_Extensions=glagolitic}', "");
    Expect(0, 122922, '\P{Is_Script_Extensions=glagolitic}', "");
    Expect(1, 122922, '\P{^Is_Script_Extensions=glagolitic}', "");
    Expect(0, 122923, '\p{Is_Script_Extensions=glagolitic}', "");
    Expect(1, 122923, '\p{^Is_Script_Extensions=glagolitic}', "");
    Expect(1, 122923, '\P{Is_Script_Extensions=glagolitic}', "");
    Expect(0, 122923, '\P{^Is_Script_Extensions=glagolitic}', "");
    Expect(1, 122922, '\p{Is_Script_Extensions= -GLAGOLITIC}', "");
    Expect(0, 122922, '\p{^Is_Script_Extensions= -GLAGOLITIC}', "");
    Expect(0, 122922, '\P{Is_Script_Extensions= -GLAGOLITIC}', "");
    Expect(1, 122922, '\P{^Is_Script_Extensions= -GLAGOLITIC}', "");
    Expect(0, 122923, '\p{Is_Script_Extensions= -GLAGOLITIC}', "");
    Expect(1, 122923, '\p{^Is_Script_Extensions= -GLAGOLITIC}', "");
    Expect(1, 122923, '\P{Is_Script_Extensions= -GLAGOLITIC}', "");
    Expect(0, 122923, '\P{^Is_Script_Extensions= -GLAGOLITIC}', "");
    Error('\p{Is_Scx=	-Glag:=}');
    Error('\P{Is_Scx=	-Glag:=}');
    Expect(1, 122922, '\p{Is_Scx=glag}', "");
    Expect(0, 122922, '\p{^Is_Scx=glag}', "");
    Expect(0, 122922, '\P{Is_Scx=glag}', "");
    Expect(1, 122922, '\P{^Is_Scx=glag}', "");
    Expect(0, 122923, '\p{Is_Scx=glag}', "");
    Expect(1, 122923, '\p{^Is_Scx=glag}', "");
    Expect(1, 122923, '\P{Is_Scx=glag}', "");
    Expect(0, 122923, '\P{^Is_Scx=glag}', "");
    Expect(1, 122922, '\p{Is_Scx: _ glag}', "");
    Expect(0, 122922, '\p{^Is_Scx: _ glag}', "");
    Expect(0, 122922, '\P{Is_Scx: _ glag}', "");
    Expect(1, 122922, '\P{^Is_Scx: _ glag}', "");
    Expect(0, 122923, '\p{Is_Scx: _ glag}', "");
    Expect(1, 122923, '\p{^Is_Scx: _ glag}', "");
    Expect(1, 122923, '\P{Is_Scx: _ glag}', "");
    Expect(0, 122923, '\P{^Is_Scx: _ glag}', "");
    Error('\p{Script_Extensions=	masaram_Gondi/a/}');
    Error('\P{Script_Extensions=	masaram_Gondi/a/}');
    Expect(1, 73049, '\p{Script_Extensions=masaramgondi}', "");
    Expect(0, 73049, '\p{^Script_Extensions=masaramgondi}', "");
    Expect(0, 73049, '\P{Script_Extensions=masaramgondi}', "");
    Expect(1, 73049, '\P{^Script_Extensions=masaramgondi}', "");
    Expect(0, 73050, '\p{Script_Extensions=masaramgondi}', "");
    Expect(1, 73050, '\p{^Script_Extensions=masaramgondi}', "");
    Expect(1, 73050, '\P{Script_Extensions=masaramgondi}', "");
    Expect(0, 73050, '\P{^Script_Extensions=masaramgondi}', "");
    Expect(1, 73049, '\p{Script_Extensions=	 MASARAM_Gondi}', "");
    Expect(0, 73049, '\p{^Script_Extensions=	 MASARAM_Gondi}', "");
    Expect(0, 73049, '\P{Script_Extensions=	 MASARAM_Gondi}', "");
    Expect(1, 73049, '\P{^Script_Extensions=	 MASARAM_Gondi}', "");
    Expect(0, 73050, '\p{Script_Extensions=	 MASARAM_Gondi}', "");
    Expect(1, 73050, '\p{^Script_Extensions=	 MASARAM_Gondi}', "");
    Expect(1, 73050, '\P{Script_Extensions=	 MASARAM_Gondi}', "");
    Expect(0, 73050, '\P{^Script_Extensions=	 MASARAM_Gondi}', "");
    Error('\p{Scx= gonm:=}');
    Error('\P{Scx= gonm:=}');
    Expect(1, 73049, '\p{Scx=gonm}', "");
    Expect(0, 73049, '\p{^Scx=gonm}', "");
    Expect(0, 73049, '\P{Scx=gonm}', "");
    Expect(1, 73049, '\P{^Scx=gonm}', "");
    Expect(0, 73050, '\p{Scx=gonm}', "");
    Expect(1, 73050, '\p{^Scx=gonm}', "");
    Expect(1, 73050, '\P{Scx=gonm}', "");
    Expect(0, 73050, '\P{^Scx=gonm}', "");
    Expect(1, 73049, '\p{Scx=_ Gonm}', "");
    Expect(0, 73049, '\p{^Scx=_ Gonm}', "");
    Expect(0, 73049, '\P{Scx=_ Gonm}', "");
    Expect(1, 73049, '\P{^Scx=_ Gonm}', "");
    Expect(0, 73050, '\p{Scx=_ Gonm}', "");
    Expect(1, 73050, '\p{^Scx=_ Gonm}', "");
    Expect(1, 73050, '\P{Scx=_ Gonm}', "");
    Expect(0, 73050, '\P{^Scx=_ Gonm}', "");
    Error('\p{Is_Script_Extensions=-MASARAM_Gondi:=}');
    Error('\P{Is_Script_Extensions=-MASARAM_Gondi:=}');
    Expect(1, 73049, '\p{Is_Script_Extensions=masaramgondi}', "");
    Expect(0, 73049, '\p{^Is_Script_Extensions=masaramgondi}', "");
    Expect(0, 73049, '\P{Is_Script_Extensions=masaramgondi}', "");
    Expect(1, 73049, '\P{^Is_Script_Extensions=masaramgondi}', "");
    Expect(0, 73050, '\p{Is_Script_Extensions=masaramgondi}', "");
    Expect(1, 73050, '\p{^Is_Script_Extensions=masaramgondi}', "");
    Expect(1, 73050, '\P{Is_Script_Extensions=masaramgondi}', "");
    Expect(0, 73050, '\P{^Is_Script_Extensions=masaramgondi}', "");
    Expect(1, 73049, '\p{Is_Script_Extensions=_Masaram_GONDI}', "");
    Expect(0, 73049, '\p{^Is_Script_Extensions=_Masaram_GONDI}', "");
    Expect(0, 73049, '\P{Is_Script_Extensions=_Masaram_GONDI}', "");
    Expect(1, 73049, '\P{^Is_Script_Extensions=_Masaram_GONDI}', "");
    Expect(0, 73050, '\p{Is_Script_Extensions=_Masaram_GONDI}', "");
    Expect(1, 73050, '\p{^Is_Script_Extensions=_Masaram_GONDI}', "");
    Expect(1, 73050, '\P{Is_Script_Extensions=_Masaram_GONDI}', "");
    Expect(0, 73050, '\P{^Is_Script_Extensions=_Masaram_GONDI}', "");
    Error('\p{Is_Scx=-:=gonm}');
    Error('\P{Is_Scx=-:=gonm}');
    Expect(1, 73049, '\p{Is_Scx=gonm}', "");
    Expect(0, 73049, '\p{^Is_Scx=gonm}', "");
    Expect(0, 73049, '\P{Is_Scx=gonm}', "");
    Expect(1, 73049, '\P{^Is_Scx=gonm}', "");
    Expect(0, 73050, '\p{Is_Scx=gonm}', "");
    Expect(1, 73050, '\p{^Is_Scx=gonm}', "");
    Expect(1, 73050, '\P{Is_Scx=gonm}', "");
    Expect(0, 73050, '\P{^Is_Scx=gonm}', "");
    Expect(1, 73049, '\p{Is_Scx=- Gonm}', "");
    Expect(0, 73049, '\p{^Is_Scx=- Gonm}', "");
    Expect(0, 73049, '\P{Is_Scx=- Gonm}', "");
    Expect(1, 73049, '\P{^Is_Scx=- Gonm}', "");
    Expect(0, 73050, '\p{Is_Scx=- Gonm}', "");
    Expect(1, 73050, '\p{^Is_Scx=- Gonm}', "");
    Expect(1, 73050, '\P{Is_Scx=- Gonm}', "");
    Expect(0, 73050, '\P{^Is_Scx=- Gonm}', "");
    Error('\p{Script_Extensions=/a/ _Gothic}');
    Error('\P{Script_Extensions=/a/ _Gothic}');
    Expect(1, 66378, '\p{Script_Extensions=gothic}', "");
    Expect(0, 66378, '\p{^Script_Extensions=gothic}', "");
    Expect(0, 66378, '\P{Script_Extensions=gothic}', "");
    Expect(1, 66378, '\P{^Script_Extensions=gothic}', "");
    Expect(0, 66379, '\p{Script_Extensions=gothic}', "");
    Expect(1, 66379, '\p{^Script_Extensions=gothic}', "");
    Expect(1, 66379, '\P{Script_Extensions=gothic}', "");
    Expect(0, 66379, '\P{^Script_Extensions=gothic}', "");
    Expect(1, 66378, '\p{Script_Extensions=-Gothic}', "");
    Expect(0, 66378, '\p{^Script_Extensions=-Gothic}', "");
    Expect(0, 66378, '\P{Script_Extensions=-Gothic}', "");
    Expect(1, 66378, '\P{^Script_Extensions=-Gothic}', "");
    Expect(0, 66379, '\p{Script_Extensions=-Gothic}', "");
    Expect(1, 66379, '\p{^Script_Extensions=-Gothic}', "");
    Expect(1, 66379, '\P{Script_Extensions=-Gothic}', "");
    Expect(0, 66379, '\P{^Script_Extensions=-Gothic}', "");
    Error('\p{Scx= GOTH/a/}');
    Error('\P{Scx= GOTH/a/}');
    Expect(1, 66378, '\p{Scx=goth}', "");
    Expect(0, 66378, '\p{^Scx=goth}', "");
    Expect(0, 66378, '\P{Scx=goth}', "");
    Expect(1, 66378, '\P{^Scx=goth}', "");
    Expect(0, 66379, '\p{Scx=goth}', "");
    Expect(1, 66379, '\p{^Scx=goth}', "");
    Expect(1, 66379, '\P{Scx=goth}', "");
    Expect(0, 66379, '\P{^Scx=goth}', "");
    Expect(1, 66378, '\p{Scx=	goth}', "");
    Expect(0, 66378, '\p{^Scx=	goth}', "");
    Expect(0, 66378, '\P{Scx=	goth}', "");
    Expect(1, 66378, '\P{^Scx=	goth}', "");
    Expect(0, 66379, '\p{Scx=	goth}', "");
    Expect(1, 66379, '\p{^Scx=	goth}', "");
    Expect(1, 66379, '\P{Scx=	goth}', "");
    Expect(0, 66379, '\P{^Scx=	goth}', "");
    Error('\p{Is_Script_Extensions= -gothic:=}');
    Error('\P{Is_Script_Extensions= -gothic:=}');
    Expect(1, 66378, '\p{Is_Script_Extensions=gothic}', "");
    Expect(0, 66378, '\p{^Is_Script_Extensions=gothic}', "");
    Expect(0, 66378, '\P{Is_Script_Extensions=gothic}', "");
    Expect(1, 66378, '\P{^Is_Script_Extensions=gothic}', "");
    Expect(0, 66379, '\p{Is_Script_Extensions=gothic}', "");
    Expect(1, 66379, '\p{^Is_Script_Extensions=gothic}', "");
    Expect(1, 66379, '\P{Is_Script_Extensions=gothic}', "");
    Expect(0, 66379, '\P{^Is_Script_Extensions=gothic}', "");
    Expect(1, 66378, '\p{Is_Script_Extensions= gothic}', "");
    Expect(0, 66378, '\p{^Is_Script_Extensions= gothic}', "");
    Expect(0, 66378, '\P{Is_Script_Extensions= gothic}', "");
    Expect(1, 66378, '\P{^Is_Script_Extensions= gothic}', "");
    Expect(0, 66379, '\p{Is_Script_Extensions= gothic}', "");
    Expect(1, 66379, '\p{^Is_Script_Extensions= gothic}', "");
    Expect(1, 66379, '\P{Is_Script_Extensions= gothic}', "");
    Expect(0, 66379, '\P{^Is_Script_Extensions= gothic}', "");
    Error('\p{Is_Scx=-:=Goth}');
    Error('\P{Is_Scx=-:=Goth}');
    Expect(1, 66378, '\p{Is_Scx=goth}', "");
    Expect(0, 66378, '\p{^Is_Scx=goth}', "");
    Expect(0, 66378, '\P{Is_Scx=goth}', "");
    Expect(1, 66378, '\P{^Is_Scx=goth}', "");
    Expect(0, 66379, '\p{Is_Scx=goth}', "");
    Expect(1, 66379, '\p{^Is_Scx=goth}', "");
    Expect(1, 66379, '\P{Is_Scx=goth}', "");
    Expect(0, 66379, '\P{^Is_Scx=goth}', "");
    Expect(1, 66378, '\p{Is_Scx= -Goth}', "");
    Expect(0, 66378, '\p{^Is_Scx= -Goth}', "");
    Expect(0, 66378, '\P{Is_Scx= -Goth}', "");
    Expect(1, 66378, '\P{^Is_Scx= -Goth}', "");
    Expect(0, 66379, '\p{Is_Scx= -Goth}', "");
    Expect(1, 66379, '\p{^Is_Scx= -Goth}', "");
    Expect(1, 66379, '\P{Is_Scx= -Goth}', "");
    Expect(0, 66379, '\P{^Is_Scx= -Goth}', "");
    Error('\p{Script_Extensions:   --Grantha/a/}');
    Error('\P{Script_Extensions:   --Grantha/a/}');
    Expect(1, 70516, '\p{Script_Extensions=grantha}', "");
    Expect(0, 70516, '\p{^Script_Extensions=grantha}', "");
    Expect(0, 70516, '\P{Script_Extensions=grantha}', "");
    Expect(1, 70516, '\P{^Script_Extensions=grantha}', "");
    Expect(0, 70517, '\p{Script_Extensions=grantha}', "");
    Expect(1, 70517, '\p{^Script_Extensions=grantha}', "");
    Expect(1, 70517, '\P{Script_Extensions=grantha}', "");
    Expect(0, 70517, '\P{^Script_Extensions=grantha}', "");
    Expect(1, 70516, '\p{Script_Extensions=-	grantha}', "");
    Expect(0, 70516, '\p{^Script_Extensions=-	grantha}', "");
    Expect(0, 70516, '\P{Script_Extensions=-	grantha}', "");
    Expect(1, 70516, '\P{^Script_Extensions=-	grantha}', "");
    Expect(0, 70517, '\p{Script_Extensions=-	grantha}', "");
    Expect(1, 70517, '\p{^Script_Extensions=-	grantha}', "");
    Expect(1, 70517, '\P{Script_Extensions=-	grantha}', "");
    Expect(0, 70517, '\P{^Script_Extensions=-	grantha}', "");
    Error('\p{Scx=/a/	-gran}');
    Error('\P{Scx=/a/	-gran}');
    Expect(1, 70516, '\p{Scx=gran}', "");
    Expect(0, 70516, '\p{^Scx=gran}', "");
    Expect(0, 70516, '\P{Scx=gran}', "");
    Expect(1, 70516, '\P{^Scx=gran}', "");
    Expect(0, 70517, '\p{Scx=gran}', "");
    Expect(1, 70517, '\p{^Scx=gran}', "");
    Expect(1, 70517, '\P{Scx=gran}', "");
    Expect(0, 70517, '\P{^Scx=gran}', "");
    Expect(1, 70516, '\p{Scx=-_Gran}', "");
    Expect(0, 70516, '\p{^Scx=-_Gran}', "");
    Expect(0, 70516, '\P{Scx=-_Gran}', "");
    Expect(1, 70516, '\P{^Scx=-_Gran}', "");
    Expect(0, 70517, '\p{Scx=-_Gran}', "");
    Expect(1, 70517, '\p{^Scx=-_Gran}', "");
    Expect(1, 70517, '\P{Scx=-_Gran}', "");
    Expect(0, 70517, '\P{^Scx=-_Gran}', "");
    Error('\p{Is_Script_Extensions=--Grantha:=}');
    Error('\P{Is_Script_Extensions=--Grantha:=}');
    Expect(1, 70516, '\p{Is_Script_Extensions=grantha}', "");
    Expect(0, 70516, '\p{^Is_Script_Extensions=grantha}', "");
    Expect(0, 70516, '\P{Is_Script_Extensions=grantha}', "");
    Expect(1, 70516, '\P{^Is_Script_Extensions=grantha}', "");
    Expect(0, 70517, '\p{Is_Script_Extensions=grantha}', "");
    Expect(1, 70517, '\p{^Is_Script_Extensions=grantha}', "");
    Expect(1, 70517, '\P{Is_Script_Extensions=grantha}', "");
    Expect(0, 70517, '\P{^Is_Script_Extensions=grantha}', "");
    Expect(1, 70516, '\p{Is_Script_Extensions=	 Grantha}', "");
    Expect(0, 70516, '\p{^Is_Script_Extensions=	 Grantha}', "");
    Expect(0, 70516, '\P{Is_Script_Extensions=	 Grantha}', "");
    Expect(1, 70516, '\P{^Is_Script_Extensions=	 Grantha}', "");
    Expect(0, 70517, '\p{Is_Script_Extensions=	 Grantha}', "");
    Expect(1, 70517, '\p{^Is_Script_Extensions=	 Grantha}', "");
    Expect(1, 70517, '\P{Is_Script_Extensions=	 Grantha}', "");
    Expect(0, 70517, '\P{^Is_Script_Extensions=	 Grantha}', "");
    Error('\p{Is_Scx=_/a/GRAN}');
    Error('\P{Is_Scx=_/a/GRAN}');
    Expect(1, 70516, '\p{Is_Scx=gran}', "");
    Expect(0, 70516, '\p{^Is_Scx=gran}', "");
    Expect(0, 70516, '\P{Is_Scx=gran}', "");
    Expect(1, 70516, '\P{^Is_Scx=gran}', "");
    Expect(0, 70517, '\p{Is_Scx=gran}', "");
    Expect(1, 70517, '\p{^Is_Scx=gran}', "");
    Expect(1, 70517, '\P{Is_Scx=gran}', "");
    Expect(0, 70517, '\P{^Is_Scx=gran}', "");
    Expect(1, 70516, '\p{Is_Scx=- gran}', "");
    Expect(0, 70516, '\p{^Is_Scx=- gran}', "");
    Expect(0, 70516, '\P{Is_Scx=- gran}', "");
    Expect(1, 70516, '\P{^Is_Scx=- gran}', "");
    Expect(0, 70517, '\p{Is_Scx=- gran}', "");
    Expect(1, 70517, '\p{^Is_Scx=- gran}', "");
    Expect(1, 70517, '\P{Is_Scx=- gran}', "");
    Expect(0, 70517, '\P{^Is_Scx=- gran}', "");
    Error('\p{Script_Extensions=/a/Greek}');
    Error('\P{Script_Extensions=/a/Greek}');
    Expect(1, 119365, '\p{Script_Extensions=greek}', "");
    Expect(0, 119365, '\p{^Script_Extensions=greek}', "");
    Expect(0, 119365, '\P{Script_Extensions=greek}', "");
    Expect(1, 119365, '\P{^Script_Extensions=greek}', "");
    Expect(0, 119366, '\p{Script_Extensions=greek}', "");
    Expect(1, 119366, '\p{^Script_Extensions=greek}', "");
    Expect(1, 119366, '\P{Script_Extensions=greek}', "");
    Expect(0, 119366, '\P{^Script_Extensions=greek}', "");
    Expect(1, 119365, '\p{Script_Extensions:- GREEK}', "");
    Expect(0, 119365, '\p{^Script_Extensions:- GREEK}', "");
    Expect(0, 119365, '\P{Script_Extensions:- GREEK}', "");
    Expect(1, 119365, '\P{^Script_Extensions:- GREEK}', "");
    Expect(0, 119366, '\p{Script_Extensions:- GREEK}', "");
    Expect(1, 119366, '\p{^Script_Extensions:- GREEK}', "");
    Expect(1, 119366, '\P{Script_Extensions:- GREEK}', "");
    Expect(0, 119366, '\P{^Script_Extensions:- GREEK}', "");
    Error('\p{Scx:	/a/- Grek}');
    Error('\P{Scx:	/a/- Grek}');
    Expect(1, 119365, '\p{Scx=grek}', "");
    Expect(0, 119365, '\p{^Scx=grek}', "");
    Expect(0, 119365, '\P{Scx=grek}', "");
    Expect(1, 119365, '\P{^Scx=grek}', "");
    Expect(0, 119366, '\p{Scx=grek}', "");
    Expect(1, 119366, '\p{^Scx=grek}', "");
    Expect(1, 119366, '\P{Scx=grek}', "");
    Expect(0, 119366, '\P{^Scx=grek}', "");
    Expect(1, 119365, '\p{Scx=-grek}', "");
    Expect(0, 119365, '\p{^Scx=-grek}', "");
    Expect(0, 119365, '\P{Scx=-grek}', "");
    Expect(1, 119365, '\P{^Scx=-grek}', "");
    Expect(0, 119366, '\p{Scx=-grek}', "");
    Expect(1, 119366, '\p{^Scx=-grek}', "");
    Expect(1, 119366, '\P{Scx=-grek}', "");
    Expect(0, 119366, '\P{^Scx=-grek}', "");
    Error('\p{Is_Script_Extensions=-/a/Greek}');
    Error('\P{Is_Script_Extensions=-/a/Greek}');
    Expect(1, 119365, '\p{Is_Script_Extensions=greek}', "");
    Expect(0, 119365, '\p{^Is_Script_Extensions=greek}', "");
    Expect(0, 119365, '\P{Is_Script_Extensions=greek}', "");
    Expect(1, 119365, '\P{^Is_Script_Extensions=greek}', "");
    Expect(0, 119366, '\p{Is_Script_Extensions=greek}', "");
    Expect(1, 119366, '\p{^Is_Script_Extensions=greek}', "");
    Expect(1, 119366, '\P{Is_Script_Extensions=greek}', "");
    Expect(0, 119366, '\P{^Is_Script_Extensions=greek}', "");
    Expect(1, 119365, '\p{Is_Script_Extensions=_-greek}', "");
    Expect(0, 119365, '\p{^Is_Script_Extensions=_-greek}', "");
    Expect(0, 119365, '\P{Is_Script_Extensions=_-greek}', "");
    Expect(1, 119365, '\P{^Is_Script_Extensions=_-greek}', "");
    Expect(0, 119366, '\p{Is_Script_Extensions=_-greek}', "");
    Expect(1, 119366, '\p{^Is_Script_Extensions=_-greek}', "");
    Expect(1, 119366, '\P{Is_Script_Extensions=_-greek}', "");
    Expect(0, 119366, '\P{^Is_Script_Extensions=_-greek}', "");
    Error('\p{Is_Scx=GREK:=}');
    Error('\P{Is_Scx=GREK:=}');
    Expect(1, 119365, '\p{Is_Scx=grek}', "");
    Expect(0, 119365, '\p{^Is_Scx=grek}', "");
    Expect(0, 119365, '\P{Is_Scx=grek}', "");
    Expect(1, 119365, '\P{^Is_Scx=grek}', "");
    Expect(0, 119366, '\p{Is_Scx=grek}', "");
    Expect(1, 119366, '\p{^Is_Scx=grek}', "");
    Expect(1, 119366, '\P{Is_Scx=grek}', "");
    Expect(0, 119366, '\P{^Is_Scx=grek}', "");
    Expect(1, 119365, '\p{Is_Scx=	Grek}', "");
    Expect(0, 119365, '\p{^Is_Scx=	Grek}', "");
    Expect(0, 119365, '\P{Is_Scx=	Grek}', "");
    Expect(1, 119365, '\P{^Is_Scx=	Grek}', "");
    Expect(0, 119366, '\p{Is_Scx=	Grek}', "");
    Expect(1, 119366, '\p{^Is_Scx=	Grek}', "");
    Expect(1, 119366, '\P{Is_Scx=	Grek}', "");
    Expect(0, 119366, '\P{^Is_Scx=	Grek}', "");
    Error('\p{Script_Extensions= :=Gujarati}');
    Error('\P{Script_Extensions= :=Gujarati}');
    Expect(1, 43065, '\p{Script_Extensions=gujarati}', "");
    Expect(0, 43065, '\p{^Script_Extensions=gujarati}', "");
    Expect(0, 43065, '\P{Script_Extensions=gujarati}', "");
    Expect(1, 43065, '\P{^Script_Extensions=gujarati}', "");
    Expect(0, 43066, '\p{Script_Extensions=gujarati}', "");
    Expect(1, 43066, '\p{^Script_Extensions=gujarati}', "");
    Expect(1, 43066, '\P{Script_Extensions=gujarati}', "");
    Expect(0, 43066, '\P{^Script_Extensions=gujarati}', "");
    Expect(1, 43065, '\p{Script_Extensions:	 GUJARATI}', "");
    Expect(0, 43065, '\p{^Script_Extensions:	 GUJARATI}', "");
    Expect(0, 43065, '\P{Script_Extensions:	 GUJARATI}', "");
    Expect(1, 43065, '\P{^Script_Extensions:	 GUJARATI}', "");
    Expect(0, 43066, '\p{Script_Extensions:	 GUJARATI}', "");
    Expect(1, 43066, '\p{^Script_Extensions:	 GUJARATI}', "");
    Expect(1, 43066, '\P{Script_Extensions:	 GUJARATI}', "");
    Expect(0, 43066, '\P{^Script_Extensions:	 GUJARATI}', "");
    Error('\p{Scx= :=GUJR}');
    Error('\P{Scx= :=GUJR}');
    Expect(1, 43065, '\p{Scx=gujr}', "");
    Expect(0, 43065, '\p{^Scx=gujr}', "");
    Expect(0, 43065, '\P{Scx=gujr}', "");
    Expect(1, 43065, '\P{^Scx=gujr}', "");
    Expect(0, 43066, '\p{Scx=gujr}', "");
    Expect(1, 43066, '\p{^Scx=gujr}', "");
    Expect(1, 43066, '\P{Scx=gujr}', "");
    Expect(0, 43066, '\P{^Scx=gujr}', "");
    Expect(1, 43065, '\p{Scx=	 gujr}', "");
    Expect(0, 43065, '\p{^Scx=	 gujr}', "");
    Expect(0, 43065, '\P{Scx=	 gujr}', "");
    Expect(1, 43065, '\P{^Scx=	 gujr}', "");
    Expect(0, 43066, '\p{Scx=	 gujr}', "");
    Expect(1, 43066, '\p{^Scx=	 gujr}', "");
    Expect(1, 43066, '\P{Scx=	 gujr}', "");
    Expect(0, 43066, '\P{^Scx=	 gujr}', "");
    Error('\p{Is_Script_Extensions= :=Gujarati}');
    Error('\P{Is_Script_Extensions= :=Gujarati}');
    Expect(1, 43065, '\p{Is_Script_Extensions=gujarati}', "");
    Expect(0, 43065, '\p{^Is_Script_Extensions=gujarati}', "");
    Expect(0, 43065, '\P{Is_Script_Extensions=gujarati}', "");
    Expect(1, 43065, '\P{^Is_Script_Extensions=gujarati}', "");
    Expect(0, 43066, '\p{Is_Script_Extensions=gujarati}', "");
    Expect(1, 43066, '\p{^Is_Script_Extensions=gujarati}', "");
    Expect(1, 43066, '\P{Is_Script_Extensions=gujarati}', "");
    Expect(0, 43066, '\P{^Is_Script_Extensions=gujarati}', "");
    Expect(1, 43065, '\p{Is_Script_Extensions=	 GUJARATI}', "");
    Expect(0, 43065, '\p{^Is_Script_Extensions=	 GUJARATI}', "");
    Expect(0, 43065, '\P{Is_Script_Extensions=	 GUJARATI}', "");
    Expect(1, 43065, '\P{^Is_Script_Extensions=	 GUJARATI}', "");
    Expect(0, 43066, '\p{Is_Script_Extensions=	 GUJARATI}', "");
    Expect(1, 43066, '\p{^Is_Script_Extensions=	 GUJARATI}', "");
    Expect(1, 43066, '\P{Is_Script_Extensions=	 GUJARATI}', "");
    Expect(0, 43066, '\P{^Is_Script_Extensions=	 GUJARATI}', "");
    Error('\p{Is_Scx=/a/Gujr}');
    Error('\P{Is_Scx=/a/Gujr}');
    Expect(1, 43065, '\p{Is_Scx=gujr}', "");
    Expect(0, 43065, '\p{^Is_Scx=gujr}', "");
    Expect(0, 43065, '\P{Is_Scx=gujr}', "");
    Expect(1, 43065, '\P{^Is_Scx=gujr}', "");
    Expect(0, 43066, '\p{Is_Scx=gujr}', "");
    Expect(1, 43066, '\p{^Is_Scx=gujr}', "");
    Expect(1, 43066, '\P{Is_Scx=gujr}', "");
    Expect(0, 43066, '\P{^Is_Scx=gujr}', "");
    Expect(1, 43065, '\p{Is_Scx=--gujr}', "");
    Expect(0, 43065, '\p{^Is_Scx=--gujr}', "");
    Expect(0, 43065, '\P{Is_Scx=--gujr}', "");
    Expect(1, 43065, '\P{^Is_Scx=--gujr}', "");
    Expect(0, 43066, '\p{Is_Scx=--gujr}', "");
    Expect(1, 43066, '\p{^Is_Scx=--gujr}', "");
    Expect(1, 43066, '\P{Is_Scx=--gujr}', "");
    Expect(0, 43066, '\P{^Is_Scx=--gujr}', "");
    Error('\p{Script_Extensions=-Gurmukhi:=}');
    Error('\P{Script_Extensions=-Gurmukhi:=}');
    Expect(1, 43065, '\p{Script_Extensions:	gurmukhi}', "");
    Expect(0, 43065, '\p{^Script_Extensions:	gurmukhi}', "");
    Expect(0, 43065, '\P{Script_Extensions:	gurmukhi}', "");
    Expect(1, 43065, '\P{^Script_Extensions:	gurmukhi}', "");
    Expect(0, 43066, '\p{Script_Extensions:	gurmukhi}', "");
    Expect(1, 43066, '\p{^Script_Extensions:	gurmukhi}', "");
    Expect(1, 43066, '\P{Script_Extensions:	gurmukhi}', "");
    Expect(0, 43066, '\P{^Script_Extensions:	gurmukhi}', "");
    Expect(1, 43065, '\p{Script_Extensions= Gurmukhi}', "");
    Expect(0, 43065, '\p{^Script_Extensions= Gurmukhi}', "");
    Expect(0, 43065, '\P{Script_Extensions= Gurmukhi}', "");
    Expect(1, 43065, '\P{^Script_Extensions= Gurmukhi}', "");
    Expect(0, 43066, '\p{Script_Extensions= Gurmukhi}', "");
    Expect(1, 43066, '\p{^Script_Extensions= Gurmukhi}', "");
    Expect(1, 43066, '\P{Script_Extensions= Gurmukhi}', "");
    Expect(0, 43066, '\P{^Script_Extensions= Gurmukhi}', "");
    Error('\p{Scx=		GURU/a/}');
    Error('\P{Scx=		GURU/a/}');
    Expect(1, 43065, '\p{Scx=guru}', "");
    Expect(0, 43065, '\p{^Scx=guru}', "");
    Expect(0, 43065, '\P{Scx=guru}', "");
    Expect(1, 43065, '\P{^Scx=guru}', "");
    Expect(0, 43066, '\p{Scx=guru}', "");
    Expect(1, 43066, '\p{^Scx=guru}', "");
    Expect(1, 43066, '\P{Scx=guru}', "");
    Expect(0, 43066, '\P{^Scx=guru}', "");
    Expect(1, 43065, '\p{Scx=_Guru}', "");
    Expect(0, 43065, '\p{^Scx=_Guru}', "");
    Expect(0, 43065, '\P{Scx=_Guru}', "");
    Expect(1, 43065, '\P{^Scx=_Guru}', "");
    Expect(0, 43066, '\p{Scx=_Guru}', "");
    Expect(1, 43066, '\p{^Scx=_Guru}', "");
    Expect(1, 43066, '\P{Scx=_Guru}', "");
    Expect(0, 43066, '\P{^Scx=_Guru}', "");
    Error('\p{Is_Script_Extensions=/a/-Gurmukhi}');
    Error('\P{Is_Script_Extensions=/a/-Gurmukhi}');
    Expect(1, 43065, '\p{Is_Script_Extensions=gurmukhi}', "");
    Expect(0, 43065, '\p{^Is_Script_Extensions=gurmukhi}', "");
    Expect(0, 43065, '\P{Is_Script_Extensions=gurmukhi}', "");
    Expect(1, 43065, '\P{^Is_Script_Extensions=gurmukhi}', "");
    Expect(0, 43066, '\p{Is_Script_Extensions=gurmukhi}', "");
    Expect(1, 43066, '\p{^Is_Script_Extensions=gurmukhi}', "");
    Expect(1, 43066, '\P{Is_Script_Extensions=gurmukhi}', "");
    Expect(0, 43066, '\P{^Is_Script_Extensions=gurmukhi}', "");
    Expect(1, 43065, '\p{Is_Script_Extensions=_Gurmukhi}', "");
    Expect(0, 43065, '\p{^Is_Script_Extensions=_Gurmukhi}', "");
    Expect(0, 43065, '\P{Is_Script_Extensions=_Gurmukhi}', "");
    Expect(1, 43065, '\P{^Is_Script_Extensions=_Gurmukhi}', "");
    Expect(0, 43066, '\p{Is_Script_Extensions=_Gurmukhi}', "");
    Expect(1, 43066, '\p{^Is_Script_Extensions=_Gurmukhi}', "");
    Expect(1, 43066, '\P{Is_Script_Extensions=_Gurmukhi}', "");
    Expect(0, 43066, '\P{^Is_Script_Extensions=_Gurmukhi}', "");
    Error('\p{Is_Scx=:=  guru}');
    Error('\P{Is_Scx=:=  guru}');
    Expect(1, 43065, '\p{Is_Scx=guru}', "");
    Expect(0, 43065, '\p{^Is_Scx=guru}', "");
    Expect(0, 43065, '\P{Is_Scx=guru}', "");
    Expect(1, 43065, '\P{^Is_Scx=guru}', "");
    Expect(0, 43066, '\p{Is_Scx=guru}', "");
    Expect(1, 43066, '\p{^Is_Scx=guru}', "");
    Expect(1, 43066, '\P{Is_Scx=guru}', "");
    Expect(0, 43066, '\P{^Is_Scx=guru}', "");
    Expect(1, 43065, '\p{Is_Scx= _GURU}', "");
    Expect(0, 43065, '\p{^Is_Scx= _GURU}', "");
    Expect(0, 43065, '\P{Is_Scx= _GURU}', "");
    Expect(1, 43065, '\P{^Is_Scx= _GURU}', "");
    Expect(0, 43066, '\p{Is_Scx= _GURU}', "");
    Expect(1, 43066, '\p{^Is_Scx= _GURU}', "");
    Expect(1, 43066, '\P{Is_Scx= _GURU}', "");
    Expect(0, 43066, '\P{^Is_Scx= _GURU}', "");
    Error('\p{Script_Extensions= Hangul/a/}');
    Error('\P{Script_Extensions= Hangul/a/}');
    Expect(1, 65500, '\p{Script_Extensions=hangul}', "");
    Expect(0, 65500, '\p{^Script_Extensions=hangul}', "");
    Expect(0, 65500, '\P{Script_Extensions=hangul}', "");
    Expect(1, 65500, '\P{^Script_Extensions=hangul}', "");
    Expect(0, 65501, '\p{Script_Extensions=hangul}', "");
    Expect(1, 65501, '\p{^Script_Extensions=hangul}', "");
    Expect(1, 65501, '\P{Script_Extensions=hangul}', "");
    Expect(0, 65501, '\P{^Script_Extensions=hangul}', "");
    Expect(1, 65500, '\p{Script_Extensions=	hangul}', "");
    Expect(0, 65500, '\p{^Script_Extensions=	hangul}', "");
    Expect(0, 65500, '\P{Script_Extensions=	hangul}', "");
    Expect(1, 65500, '\P{^Script_Extensions=	hangul}', "");
    Expect(0, 65501, '\p{Script_Extensions=	hangul}', "");
    Expect(1, 65501, '\p{^Script_Extensions=	hangul}', "");
    Expect(1, 65501, '\P{Script_Extensions=	hangul}', "");
    Expect(0, 65501, '\P{^Script_Extensions=	hangul}', "");
    Error('\p{Scx=	:=Hang}');
    Error('\P{Scx=	:=Hang}');
    Expect(1, 65500, '\p{Scx=hang}', "");
    Expect(0, 65500, '\p{^Scx=hang}', "");
    Expect(0, 65500, '\P{Scx=hang}', "");
    Expect(1, 65500, '\P{^Scx=hang}', "");
    Expect(0, 65501, '\p{Scx=hang}', "");
    Expect(1, 65501, '\p{^Scx=hang}', "");
    Expect(1, 65501, '\P{Scx=hang}', "");
    Expect(0, 65501, '\P{^Scx=hang}', "");
    Expect(1, 65500, '\p{Scx= HANG}', "");
    Expect(0, 65500, '\p{^Scx= HANG}', "");
    Expect(0, 65500, '\P{Scx= HANG}', "");
    Expect(1, 65500, '\P{^Scx= HANG}', "");
    Expect(0, 65501, '\p{Scx= HANG}', "");
    Expect(1, 65501, '\p{^Scx= HANG}', "");
    Expect(1, 65501, '\P{Scx= HANG}', "");
    Expect(0, 65501, '\P{^Scx= HANG}', "");
    Error('\p{Is_Script_Extensions:   := -hangul}');
    Error('\P{Is_Script_Extensions:   := -hangul}');
    Expect(1, 65500, '\p{Is_Script_Extensions=hangul}', "");
    Expect(0, 65500, '\p{^Is_Script_Extensions=hangul}', "");
    Expect(0, 65500, '\P{Is_Script_Extensions=hangul}', "");
    Expect(1, 65500, '\P{^Is_Script_Extensions=hangul}', "");
    Expect(0, 65501, '\p{Is_Script_Extensions=hangul}', "");
    Expect(1, 65501, '\p{^Is_Script_Extensions=hangul}', "");
    Expect(1, 65501, '\P{Is_Script_Extensions=hangul}', "");
    Expect(0, 65501, '\P{^Is_Script_Extensions=hangul}', "");
    Expect(1, 65500, '\p{Is_Script_Extensions= hangul}', "");
    Expect(0, 65500, '\p{^Is_Script_Extensions= hangul}', "");
    Expect(0, 65500, '\P{Is_Script_Extensions= hangul}', "");
    Expect(1, 65500, '\P{^Is_Script_Extensions= hangul}', "");
    Expect(0, 65501, '\p{Is_Script_Extensions= hangul}', "");
    Expect(1, 65501, '\p{^Is_Script_Extensions= hangul}', "");
    Expect(1, 65501, '\P{Is_Script_Extensions= hangul}', "");
    Expect(0, 65501, '\P{^Is_Script_Extensions= hangul}', "");
    Error('\p{Is_Scx=-:=Hang}');
    Error('\P{Is_Scx=-:=Hang}');
    Expect(1, 65500, '\p{Is_Scx=hang}', "");
    Expect(0, 65500, '\p{^Is_Scx=hang}', "");
    Expect(0, 65500, '\P{Is_Scx=hang}', "");
    Expect(1, 65500, '\P{^Is_Scx=hang}', "");
    Expect(0, 65501, '\p{Is_Scx=hang}', "");
    Expect(1, 65501, '\p{^Is_Scx=hang}', "");
    Expect(1, 65501, '\P{Is_Scx=hang}', "");
    Expect(0, 65501, '\P{^Is_Scx=hang}', "");
    Expect(1, 65500, '\p{Is_Scx=--Hang}', "");
    Expect(0, 65500, '\p{^Is_Scx=--Hang}', "");
    Expect(0, 65500, '\P{Is_Scx=--Hang}', "");
    Expect(1, 65500, '\P{^Is_Scx=--Hang}', "");
    Expect(0, 65501, '\p{Is_Scx=--Hang}', "");
    Expect(1, 65501, '\p{^Is_Scx=--Hang}', "");
    Expect(1, 65501, '\P{Is_Scx=--Hang}', "");
    Expect(0, 65501, '\P{^Is_Scx=--Hang}', "");
    Error('\p{Script_Extensions=/a/ han}');
    Error('\P{Script_Extensions=/a/ han}');
    Expect(1, 195101, '\p{Script_Extensions=han}', "");
    Expect(0, 195101, '\p{^Script_Extensions=han}', "");
    Expect(0, 195101, '\P{Script_Extensions=han}', "");
    Expect(1, 195101, '\P{^Script_Extensions=han}', "");
    Expect(0, 195102, '\p{Script_Extensions=han}', "");
    Expect(1, 195102, '\p{^Script_Extensions=han}', "");
    Expect(1, 195102, '\P{Script_Extensions=han}', "");
    Expect(0, 195102, '\P{^Script_Extensions=han}', "");
    Expect(1, 195101, '\p{Script_Extensions=-	Han}', "");
    Expect(0, 195101, '\p{^Script_Extensions=-	Han}', "");
    Expect(0, 195101, '\P{Script_Extensions=-	Han}', "");
    Expect(1, 195101, '\P{^Script_Extensions=-	Han}', "");
    Expect(0, 195102, '\p{Script_Extensions=-	Han}', "");
    Expect(1, 195102, '\p{^Script_Extensions=-	Han}', "");
    Expect(1, 195102, '\P{Script_Extensions=-	Han}', "");
    Expect(0, 195102, '\P{^Script_Extensions=-	Han}', "");
    Error('\p{Scx=	-HANI:=}');
    Error('\P{Scx=	-HANI:=}');
    Expect(1, 195101, '\p{Scx:hani}', "");
    Expect(0, 195101, '\p{^Scx:hani}', "");
    Expect(0, 195101, '\P{Scx:hani}', "");
    Expect(1, 195101, '\P{^Scx:hani}', "");
    Expect(0, 195102, '\p{Scx:hani}', "");
    Expect(1, 195102, '\p{^Scx:hani}', "");
    Expect(1, 195102, '\P{Scx:hani}', "");
    Expect(0, 195102, '\P{^Scx:hani}', "");
    Expect(1, 195101, '\p{Scx=_Hani}', "");
    Expect(0, 195101, '\p{^Scx=_Hani}', "");
    Expect(0, 195101, '\P{Scx=_Hani}', "");
    Expect(1, 195101, '\P{^Scx=_Hani}', "");
    Expect(0, 195102, '\p{Scx=_Hani}', "");
    Expect(1, 195102, '\p{^Scx=_Hani}', "");
    Expect(1, 195102, '\P{Scx=_Hani}', "");
    Expect(0, 195102, '\P{^Scx=_Hani}', "");
    Error('\p{Is_Script_Extensions: __Han/a/}');
    Error('\P{Is_Script_Extensions: __Han/a/}');
    Expect(1, 195101, '\p{Is_Script_Extensions=han}', "");
    Expect(0, 195101, '\p{^Is_Script_Extensions=han}', "");
    Expect(0, 195101, '\P{Is_Script_Extensions=han}', "");
    Expect(1, 195101, '\P{^Is_Script_Extensions=han}', "");
    Expect(0, 195102, '\p{Is_Script_Extensions=han}', "");
    Expect(1, 195102, '\p{^Is_Script_Extensions=han}', "");
    Expect(1, 195102, '\P{Is_Script_Extensions=han}', "");
    Expect(0, 195102, '\P{^Is_Script_Extensions=han}', "");
    Expect(1, 195101, '\p{Is_Script_Extensions: __HAN}', "");
    Expect(0, 195101, '\p{^Is_Script_Extensions: __HAN}', "");
    Expect(0, 195101, '\P{Is_Script_Extensions: __HAN}', "");
    Expect(1, 195101, '\P{^Is_Script_Extensions: __HAN}', "");
    Expect(0, 195102, '\p{Is_Script_Extensions: __HAN}', "");
    Expect(1, 195102, '\p{^Is_Script_Extensions: __HAN}', "");
    Expect(1, 195102, '\P{Is_Script_Extensions: __HAN}', "");
    Expect(0, 195102, '\P{^Is_Script_Extensions: __HAN}', "");
    Error('\p{Is_Scx=:=HANI}');
    Error('\P{Is_Scx=:=HANI}');
    Expect(1, 195101, '\p{Is_Scx:hani}', "");
    Expect(0, 195101, '\p{^Is_Scx:hani}', "");
    Expect(0, 195101, '\P{Is_Scx:hani}', "");
    Expect(1, 195101, '\P{^Is_Scx:hani}', "");
    Expect(0, 195102, '\p{Is_Scx:hani}', "");
    Expect(1, 195102, '\p{^Is_Scx:hani}', "");
    Expect(1, 195102, '\P{Is_Scx:hani}', "");
    Expect(0, 195102, '\P{^Is_Scx:hani}', "");
    Expect(1, 195101, '\p{Is_Scx=_Hani}', "");
    Expect(0, 195101, '\p{^Is_Scx=_Hani}', "");
    Expect(0, 195101, '\P{Is_Scx=_Hani}', "");
    Expect(1, 195101, '\P{^Is_Scx=_Hani}', "");
    Expect(0, 195102, '\p{Is_Scx=_Hani}', "");
    Expect(1, 195102, '\p{^Is_Scx=_Hani}', "");
    Expect(1, 195102, '\P{Is_Scx=_Hani}', "");
    Expect(0, 195102, '\P{^Is_Scx=_Hani}', "");
    Error('\p{Script_Extensions= :=Hanunoo}');
    Error('\P{Script_Extensions= :=Hanunoo}');
    Expect(1, 5942, '\p{Script_Extensions:   hanunoo}', "");
    Expect(0, 5942, '\p{^Script_Extensions:   hanunoo}', "");
    Expect(0, 5942, '\P{Script_Extensions:   hanunoo}', "");
    Expect(1, 5942, '\P{^Script_Extensions:   hanunoo}', "");
    Expect(0, 5943, '\p{Script_Extensions:   hanunoo}', "");
    Expect(1, 5943, '\p{^Script_Extensions:   hanunoo}', "");
    Expect(1, 5943, '\P{Script_Extensions:   hanunoo}', "");
    Expect(0, 5943, '\P{^Script_Extensions:   hanunoo}', "");
    Expect(1, 5942, '\p{Script_Extensions=	Hanunoo}', "");
    Expect(0, 5942, '\p{^Script_Extensions=	Hanunoo}', "");
    Expect(0, 5942, '\P{Script_Extensions=	Hanunoo}', "");
    Expect(1, 5942, '\P{^Script_Extensions=	Hanunoo}', "");
    Expect(0, 5943, '\p{Script_Extensions=	Hanunoo}', "");
    Expect(1, 5943, '\p{^Script_Extensions=	Hanunoo}', "");
    Expect(1, 5943, '\P{Script_Extensions=	Hanunoo}', "");
    Expect(0, 5943, '\P{^Script_Extensions=	Hanunoo}', "");
    Error('\p{Scx=/a/		Hano}');
    Error('\P{Scx=/a/		Hano}');
    Expect(1, 5942, '\p{Scx: hano}', "");
    Expect(0, 5942, '\p{^Scx: hano}', "");
    Expect(0, 5942, '\P{Scx: hano}', "");
    Expect(1, 5942, '\P{^Scx: hano}', "");
    Expect(0, 5943, '\p{Scx: hano}', "");
    Expect(1, 5943, '\p{^Scx: hano}', "");
    Expect(1, 5943, '\P{Scx: hano}', "");
    Expect(0, 5943, '\P{^Scx: hano}', "");
    Expect(1, 5942, '\p{Scx=- hano}', "");
    Expect(0, 5942, '\p{^Scx=- hano}', "");
    Expect(0, 5942, '\P{Scx=- hano}', "");
    Expect(1, 5942, '\P{^Scx=- hano}', "");
    Expect(0, 5943, '\p{Scx=- hano}', "");
    Expect(1, 5943, '\p{^Scx=- hano}', "");
    Expect(1, 5943, '\P{Scx=- hano}', "");
    Expect(0, 5943, '\P{^Scx=- hano}', "");
    Error('\p{Is_Script_Extensions= hanunoo:=}');
    Error('\P{Is_Script_Extensions= hanunoo:=}');
    Expect(1, 5942, '\p{Is_Script_Extensions=hanunoo}', "");
    Expect(0, 5942, '\p{^Is_Script_Extensions=hanunoo}', "");
    Expect(0, 5942, '\P{Is_Script_Extensions=hanunoo}', "");
    Expect(1, 5942, '\P{^Is_Script_Extensions=hanunoo}', "");
    Expect(0, 5943, '\p{Is_Script_Extensions=hanunoo}', "");
    Expect(1, 5943, '\p{^Is_Script_Extensions=hanunoo}', "");
    Expect(1, 5943, '\P{Is_Script_Extensions=hanunoo}', "");
    Expect(0, 5943, '\P{^Is_Script_Extensions=hanunoo}', "");
    Expect(1, 5942, '\p{Is_Script_Extensions=	HANUNOO}', "");
    Expect(0, 5942, '\p{^Is_Script_Extensions=	HANUNOO}', "");
    Expect(0, 5942, '\P{Is_Script_Extensions=	HANUNOO}', "");
    Expect(1, 5942, '\P{^Is_Script_Extensions=	HANUNOO}', "");
    Expect(0, 5943, '\p{Is_Script_Extensions=	HANUNOO}', "");
    Expect(1, 5943, '\p{^Is_Script_Extensions=	HANUNOO}', "");
    Expect(1, 5943, '\P{Is_Script_Extensions=	HANUNOO}', "");
    Expect(0, 5943, '\P{^Is_Script_Extensions=	HANUNOO}', "");
    Error('\p{Is_Scx=_	Hano/a/}');
    Error('\P{Is_Scx=_	Hano/a/}');
    Expect(1, 5942, '\p{Is_Scx=hano}', "");
    Expect(0, 5942, '\p{^Is_Scx=hano}', "");
    Expect(0, 5942, '\P{Is_Scx=hano}', "");
    Expect(1, 5942, '\P{^Is_Scx=hano}', "");
    Expect(0, 5943, '\p{Is_Scx=hano}', "");
    Expect(1, 5943, '\p{^Is_Scx=hano}', "");
    Expect(1, 5943, '\P{Is_Scx=hano}', "");
    Expect(0, 5943, '\P{^Is_Scx=hano}', "");
    Expect(1, 5942, '\p{Is_Scx=		HANO}', "");
    Expect(0, 5942, '\p{^Is_Scx=		HANO}', "");
    Expect(0, 5942, '\P{Is_Scx=		HANO}', "");
    Expect(1, 5942, '\P{^Is_Scx=		HANO}', "");
    Expect(0, 5943, '\p{Is_Scx=		HANO}', "");
    Expect(1, 5943, '\p{^Is_Scx=		HANO}', "");
    Expect(1, 5943, '\P{Is_Scx=		HANO}', "");
    Expect(0, 5943, '\P{^Is_Scx=		HANO}', "");
    Error('\p{Script_Extensions=-_Hatran/a/}');
    Error('\P{Script_Extensions=-_Hatran/a/}');
    Expect(1, 67839, '\p{Script_Extensions=hatran}', "");
    Expect(0, 67839, '\p{^Script_Extensions=hatran}', "");
    Expect(0, 67839, '\P{Script_Extensions=hatran}', "");
    Expect(1, 67839, '\P{^Script_Extensions=hatran}', "");
    Expect(0, 67840, '\p{Script_Extensions=hatran}', "");
    Expect(1, 67840, '\p{^Script_Extensions=hatran}', "");
    Expect(1, 67840, '\P{Script_Extensions=hatran}', "");
    Expect(0, 67840, '\P{^Script_Extensions=hatran}', "");
    Expect(1, 67839, '\p{Script_Extensions=_HATRAN}', "");
    Expect(0, 67839, '\p{^Script_Extensions=_HATRAN}', "");
    Expect(0, 67839, '\P{Script_Extensions=_HATRAN}', "");
    Expect(1, 67839, '\P{^Script_Extensions=_HATRAN}', "");
    Expect(0, 67840, '\p{Script_Extensions=_HATRAN}', "");
    Expect(1, 67840, '\p{^Script_Extensions=_HATRAN}', "");
    Expect(1, 67840, '\P{Script_Extensions=_HATRAN}', "");
    Expect(0, 67840, '\P{^Script_Extensions=_HATRAN}', "");
    Error('\p{Scx=/a/_-hatr}');
    Error('\P{Scx=/a/_-hatr}');
    Expect(1, 67839, '\p{Scx:hatr}', "");
    Expect(0, 67839, '\p{^Scx:hatr}', "");
    Expect(0, 67839, '\P{Scx:hatr}', "");
    Expect(1, 67839, '\P{^Scx:hatr}', "");
    Expect(0, 67840, '\p{Scx:hatr}', "");
    Expect(1, 67840, '\p{^Scx:hatr}', "");
    Expect(1, 67840, '\P{Scx:hatr}', "");
    Expect(0, 67840, '\P{^Scx:hatr}', "");
    Expect(1, 67839, '\p{Scx=  HATR}', "");
    Expect(0, 67839, '\p{^Scx=  HATR}', "");
    Expect(0, 67839, '\P{Scx=  HATR}', "");
    Expect(1, 67839, '\P{^Scx=  HATR}', "");
    Expect(0, 67840, '\p{Scx=  HATR}', "");
    Expect(1, 67840, '\p{^Scx=  HATR}', "");
    Expect(1, 67840, '\P{Scx=  HATR}', "");
    Expect(0, 67840, '\P{^Scx=  HATR}', "");
    Error('\p{Is_Script_Extensions= HATRAN:=}');
    Error('\P{Is_Script_Extensions= HATRAN:=}');
    Expect(1, 67839, '\p{Is_Script_Extensions=hatran}', "");
    Expect(0, 67839, '\p{^Is_Script_Extensions=hatran}', "");
    Expect(0, 67839, '\P{Is_Script_Extensions=hatran}', "");
    Expect(1, 67839, '\P{^Is_Script_Extensions=hatran}', "");
    Expect(0, 67840, '\p{Is_Script_Extensions=hatran}', "");
    Expect(1, 67840, '\p{^Is_Script_Extensions=hatran}', "");
    Expect(1, 67840, '\P{Is_Script_Extensions=hatran}', "");
    Expect(0, 67840, '\P{^Is_Script_Extensions=hatran}', "");
    Expect(1, 67839, '\p{Is_Script_Extensions=- HATRAN}', "");
    Expect(0, 67839, '\p{^Is_Script_Extensions=- HATRAN}', "");
    Expect(0, 67839, '\P{Is_Script_Extensions=- HATRAN}', "");
    Expect(1, 67839, '\P{^Is_Script_Extensions=- HATRAN}', "");
    Expect(0, 67840, '\p{Is_Script_Extensions=- HATRAN}', "");
    Expect(1, 67840, '\p{^Is_Script_Extensions=- HATRAN}', "");
    Expect(1, 67840, '\P{Is_Script_Extensions=- HATRAN}', "");
    Expect(0, 67840, '\P{^Is_Script_Extensions=- HATRAN}', "");
    Error('\p{Is_Scx=_HATR/a/}');
    Error('\P{Is_Scx=_HATR/a/}');
    Expect(1, 67839, '\p{Is_Scx: hatr}', "");
    Expect(0, 67839, '\p{^Is_Scx: hatr}', "");
    Expect(0, 67839, '\P{Is_Scx: hatr}', "");
    Expect(1, 67839, '\P{^Is_Scx: hatr}', "");
    Expect(0, 67840, '\p{Is_Scx: hatr}', "");
    Expect(1, 67840, '\p{^Is_Scx: hatr}', "");
    Expect(1, 67840, '\P{Is_Scx: hatr}', "");
    Expect(0, 67840, '\P{^Is_Scx: hatr}', "");
    Expect(1, 67839, '\p{Is_Scx=_-HATR}', "");
    Expect(0, 67839, '\p{^Is_Scx=_-HATR}', "");
    Expect(0, 67839, '\P{Is_Scx=_-HATR}', "");
    Expect(1, 67839, '\P{^Is_Scx=_-HATR}', "");
    Expect(0, 67840, '\p{Is_Scx=_-HATR}', "");
    Expect(1, 67840, '\p{^Is_Scx=_-HATR}', "");
    Expect(1, 67840, '\P{Is_Scx=_-HATR}', "");
    Expect(0, 67840, '\P{^Is_Scx=_-HATR}', "");
    Error('\p{Script_Extensions=/a/	hebrew}');
    Error('\P{Script_Extensions=/a/	hebrew}');
    Expect(1, 64335, '\p{Script_Extensions=hebrew}', "");
    Expect(0, 64335, '\p{^Script_Extensions=hebrew}', "");
    Expect(0, 64335, '\P{Script_Extensions=hebrew}', "");
    Expect(1, 64335, '\P{^Script_Extensions=hebrew}', "");
    Expect(0, 64336, '\p{Script_Extensions=hebrew}', "");
    Expect(1, 64336, '\p{^Script_Extensions=hebrew}', "");
    Expect(1, 64336, '\P{Script_Extensions=hebrew}', "");
    Expect(0, 64336, '\P{^Script_Extensions=hebrew}', "");
    Expect(1, 64335, '\p{Script_Extensions=Hebrew}', "");
    Expect(0, 64335, '\p{^Script_Extensions=Hebrew}', "");
    Expect(0, 64335, '\P{Script_Extensions=Hebrew}', "");
    Expect(1, 64335, '\P{^Script_Extensions=Hebrew}', "");
    Expect(0, 64336, '\p{Script_Extensions=Hebrew}', "");
    Expect(1, 64336, '\p{^Script_Extensions=Hebrew}', "");
    Expect(1, 64336, '\P{Script_Extensions=Hebrew}', "");
    Expect(0, 64336, '\P{^Script_Extensions=Hebrew}', "");
    Error('\p{Scx=:= hebr}');
    Error('\P{Scx=:= hebr}');
    Expect(1, 64335, '\p{Scx=hebr}', "");
    Expect(0, 64335, '\p{^Scx=hebr}', "");
    Expect(0, 64335, '\P{Scx=hebr}', "");
    Expect(1, 64335, '\P{^Scx=hebr}', "");
    Expect(0, 64336, '\p{Scx=hebr}', "");
    Expect(1, 64336, '\p{^Scx=hebr}', "");
    Expect(1, 64336, '\P{Scx=hebr}', "");
    Expect(0, 64336, '\P{^Scx=hebr}', "");
    Expect(1, 64335, '\p{Scx= hebr}', "");
    Expect(0, 64335, '\p{^Scx= hebr}', "");
    Expect(0, 64335, '\P{Scx= hebr}', "");
    Expect(1, 64335, '\P{^Scx= hebr}', "");
    Expect(0, 64336, '\p{Scx= hebr}', "");
    Expect(1, 64336, '\p{^Scx= hebr}', "");
    Expect(1, 64336, '\P{Scx= hebr}', "");
    Expect(0, 64336, '\P{^Scx= hebr}', "");
    Error('\p{Is_Script_Extensions=/a/-Hebrew}');
    Error('\P{Is_Script_Extensions=/a/-Hebrew}');
    Expect(1, 64335, '\p{Is_Script_Extensions=hebrew}', "");
    Expect(0, 64335, '\p{^Is_Script_Extensions=hebrew}', "");
    Expect(0, 64335, '\P{Is_Script_Extensions=hebrew}', "");
    Expect(1, 64335, '\P{^Is_Script_Extensions=hebrew}', "");
    Expect(0, 64336, '\p{Is_Script_Extensions=hebrew}', "");
    Expect(1, 64336, '\p{^Is_Script_Extensions=hebrew}', "");
    Expect(1, 64336, '\P{Is_Script_Extensions=hebrew}', "");
    Expect(0, 64336, '\P{^Is_Script_Extensions=hebrew}', "");
    Expect(1, 64335, '\p{Is_Script_Extensions=	Hebrew}', "");
    Expect(0, 64335, '\p{^Is_Script_Extensions=	Hebrew}', "");
    Expect(0, 64335, '\P{Is_Script_Extensions=	Hebrew}', "");
    Expect(1, 64335, '\P{^Is_Script_Extensions=	Hebrew}', "");
    Expect(0, 64336, '\p{Is_Script_Extensions=	Hebrew}', "");
    Expect(1, 64336, '\p{^Is_Script_Extensions=	Hebrew}', "");
    Expect(1, 64336, '\P{Is_Script_Extensions=	Hebrew}', "");
    Expect(0, 64336, '\P{^Is_Script_Extensions=	Hebrew}', "");
    Error('\p{Is_Scx=- hebr/a/}');
    Error('\P{Is_Scx=- hebr/a/}');
    Expect(1, 64335, '\p{Is_Scx=hebr}', "");
    Expect(0, 64335, '\p{^Is_Scx=hebr}', "");
    Expect(0, 64335, '\P{Is_Scx=hebr}', "");
    Expect(1, 64335, '\P{^Is_Scx=hebr}', "");
    Expect(0, 64336, '\p{Is_Scx=hebr}', "");
    Expect(1, 64336, '\p{^Is_Scx=hebr}', "");
    Expect(1, 64336, '\P{Is_Scx=hebr}', "");
    Expect(0, 64336, '\P{^Is_Scx=hebr}', "");
    Expect(1, 64335, '\p{Is_Scx=_ Hebr}', "");
    Expect(0, 64335, '\p{^Is_Scx=_ Hebr}', "");
    Expect(0, 64335, '\P{Is_Scx=_ Hebr}', "");
    Expect(1, 64335, '\P{^Is_Scx=_ Hebr}', "");
    Expect(0, 64336, '\p{Is_Scx=_ Hebr}', "");
    Expect(1, 64336, '\p{^Is_Scx=_ Hebr}', "");
    Expect(1, 64336, '\P{Is_Scx=_ Hebr}', "");
    Expect(0, 64336, '\P{^Is_Scx=_ Hebr}', "");
    Error('\p{Script_Extensions=_ Hiragana/a/}');
    Error('\P{Script_Extensions=_ Hiragana/a/}');
    Expect(1, 127488, '\p{Script_Extensions=hiragana}', "");
    Expect(0, 127488, '\p{^Script_Extensions=hiragana}', "");
    Expect(0, 127488, '\P{Script_Extensions=hiragana}', "");
    Expect(1, 127488, '\P{^Script_Extensions=hiragana}', "");
    Expect(0, 127489, '\p{Script_Extensions=hiragana}', "");
    Expect(1, 127489, '\p{^Script_Extensions=hiragana}', "");
    Expect(1, 127489, '\P{Script_Extensions=hiragana}', "");
    Expect(0, 127489, '\P{^Script_Extensions=hiragana}', "");
    Expect(1, 127488, '\p{Script_Extensions=		hiragana}', "");
    Expect(0, 127488, '\p{^Script_Extensions=		hiragana}', "");
    Expect(0, 127488, '\P{Script_Extensions=		hiragana}', "");
    Expect(1, 127488, '\P{^Script_Extensions=		hiragana}', "");
    Expect(0, 127489, '\p{Script_Extensions=		hiragana}', "");
    Expect(1, 127489, '\p{^Script_Extensions=		hiragana}', "");
    Expect(1, 127489, '\P{Script_Extensions=		hiragana}', "");
    Expect(0, 127489, '\P{^Script_Extensions=		hiragana}', "");
    Error('\p{Scx=:=HIRA}');
    Error('\P{Scx=:=HIRA}');
    Expect(1, 127488, '\p{Scx=hira}', "");
    Expect(0, 127488, '\p{^Scx=hira}', "");
    Expect(0, 127488, '\P{Scx=hira}', "");
    Expect(1, 127488, '\P{^Scx=hira}', "");
    Expect(0, 127489, '\p{Scx=hira}', "");
    Expect(1, 127489, '\p{^Scx=hira}', "");
    Expect(1, 127489, '\P{Scx=hira}', "");
    Expect(0, 127489, '\P{^Scx=hira}', "");
    Expect(1, 127488, '\p{Scx=--hira}', "");
    Expect(0, 127488, '\p{^Scx=--hira}', "");
    Expect(0, 127488, '\P{Scx=--hira}', "");
    Expect(1, 127488, '\P{^Scx=--hira}', "");
    Expect(0, 127489, '\p{Scx=--hira}', "");
    Expect(1, 127489, '\p{^Scx=--hira}', "");
    Expect(1, 127489, '\P{Scx=--hira}', "");
    Expect(0, 127489, '\P{^Scx=--hira}', "");
    Error('\p{Is_Script_Extensions=_ hiragana:=}');
    Error('\P{Is_Script_Extensions=_ hiragana:=}');
    Expect(1, 127488, '\p{Is_Script_Extensions=hiragana}', "");
    Expect(0, 127488, '\p{^Is_Script_Extensions=hiragana}', "");
    Expect(0, 127488, '\P{Is_Script_Extensions=hiragana}', "");
    Expect(1, 127488, '\P{^Is_Script_Extensions=hiragana}', "");
    Expect(0, 127489, '\p{Is_Script_Extensions=hiragana}', "");
    Expect(1, 127489, '\p{^Is_Script_Extensions=hiragana}', "");
    Expect(1, 127489, '\P{Is_Script_Extensions=hiragana}', "");
    Expect(0, 127489, '\P{^Is_Script_Extensions=hiragana}', "");
    Expect(1, 127488, '\p{Is_Script_Extensions=-	HIRAGANA}', "");
    Expect(0, 127488, '\p{^Is_Script_Extensions=-	HIRAGANA}', "");
    Expect(0, 127488, '\P{Is_Script_Extensions=-	HIRAGANA}', "");
    Expect(1, 127488, '\P{^Is_Script_Extensions=-	HIRAGANA}', "");
    Expect(0, 127489, '\p{Is_Script_Extensions=-	HIRAGANA}', "");
    Expect(1, 127489, '\p{^Is_Script_Extensions=-	HIRAGANA}', "");
    Expect(1, 127489, '\P{Is_Script_Extensions=-	HIRAGANA}', "");
    Expect(0, 127489, '\P{^Is_Script_Extensions=-	HIRAGANA}', "");
    Error('\p{Is_Scx=/a/_Hira}');
    Error('\P{Is_Scx=/a/_Hira}');
    Expect(1, 127488, '\p{Is_Scx=hira}', "");
    Expect(0, 127488, '\p{^Is_Scx=hira}', "");
    Expect(0, 127488, '\P{Is_Scx=hira}', "");
    Expect(1, 127488, '\P{^Is_Scx=hira}', "");
    Expect(0, 127489, '\p{Is_Scx=hira}', "");
    Expect(1, 127489, '\p{^Is_Scx=hira}', "");
    Expect(1, 127489, '\P{Is_Scx=hira}', "");
    Expect(0, 127489, '\P{^Is_Scx=hira}', "");
    Expect(1, 127488, '\p{Is_Scx: 	hira}', "");
    Expect(0, 127488, '\p{^Is_Scx: 	hira}', "");
    Expect(0, 127488, '\P{Is_Scx: 	hira}', "");
    Expect(1, 127488, '\P{^Is_Scx: 	hira}', "");
    Expect(0, 127489, '\p{Is_Scx: 	hira}', "");
    Expect(1, 127489, '\p{^Is_Scx: 	hira}', "");
    Expect(1, 127489, '\P{Is_Scx: 	hira}', "");
    Expect(0, 127489, '\P{^Is_Scx: 	hira}', "");
    Error('\p{Script_Extensions=--anatolian_Hieroglyphs:=}');
    Error('\P{Script_Extensions=--anatolian_Hieroglyphs:=}');
    Expect(1, 83526, '\p{Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{Script_Extensions=	_Anatolian_hieroglyphs}', "");
    Expect(0, 83526, '\p{^Script_Extensions=	_Anatolian_hieroglyphs}', "");
    Expect(0, 83526, '\P{Script_Extensions=	_Anatolian_hieroglyphs}', "");
    Expect(1, 83526, '\P{^Script_Extensions=	_Anatolian_hieroglyphs}', "");
    Expect(0, 83527, '\p{Script_Extensions=	_Anatolian_hieroglyphs}', "");
    Expect(1, 83527, '\p{^Script_Extensions=	_Anatolian_hieroglyphs}', "");
    Expect(1, 83527, '\P{Script_Extensions=	_Anatolian_hieroglyphs}', "");
    Expect(0, 83527, '\P{^Script_Extensions=	_Anatolian_hieroglyphs}', "");
    Error('\p{Scx=-HLUW/a/}');
    Error('\P{Scx=-HLUW/a/}');
    Expect(1, 83526, '\p{Scx=hluw}', "");
    Expect(0, 83526, '\p{^Scx=hluw}', "");
    Expect(0, 83526, '\P{Scx=hluw}', "");
    Expect(1, 83526, '\P{^Scx=hluw}', "");
    Expect(0, 83527, '\p{Scx=hluw}', "");
    Expect(1, 83527, '\p{^Scx=hluw}', "");
    Expect(1, 83527, '\P{Scx=hluw}', "");
    Expect(0, 83527, '\P{^Scx=hluw}', "");
    Expect(1, 83526, '\p{Scx=_Hluw}', "");
    Expect(0, 83526, '\p{^Scx=_Hluw}', "");
    Expect(0, 83526, '\P{Scx=_Hluw}', "");
    Expect(1, 83526, '\P{^Scx=_Hluw}', "");
    Expect(0, 83527, '\p{Scx=_Hluw}', "");
    Expect(1, 83527, '\p{^Scx=_Hluw}', "");
    Expect(1, 83527, '\P{Scx=_Hluw}', "");
    Expect(0, 83527, '\P{^Scx=_Hluw}', "");
    Error('\p{Is_Script_Extensions=/a/_	ANATOLIAN_Hieroglyphs}');
    Error('\P{Is_Script_Extensions=/a/_	ANATOLIAN_Hieroglyphs}');
    Expect(1, 83526, '\p{Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{Is_Script_Extensions=	anatolian_Hieroglyphs}', "");
    Expect(0, 83526, '\p{^Is_Script_Extensions=	anatolian_Hieroglyphs}', "");
    Expect(0, 83526, '\P{Is_Script_Extensions=	anatolian_Hieroglyphs}', "");
    Expect(1, 83526, '\P{^Is_Script_Extensions=	anatolian_Hieroglyphs}', "");
    Expect(0, 83527, '\p{Is_Script_Extensions=	anatolian_Hieroglyphs}', "");
    Expect(1, 83527, '\p{^Is_Script_Extensions=	anatolian_Hieroglyphs}', "");
    Expect(1, 83527, '\P{Is_Script_Extensions=	anatolian_Hieroglyphs}', "");
    Expect(0, 83527, '\P{^Is_Script_Extensions=	anatolian_Hieroglyphs}', "");
    Error('\p{Is_Scx=_:=hluw}');
    Error('\P{Is_Scx=_:=hluw}');
    Expect(1, 83526, '\p{Is_Scx=hluw}', "");
    Expect(0, 83526, '\p{^Is_Scx=hluw}', "");
    Expect(0, 83526, '\P{Is_Scx=hluw}', "");
    Expect(1, 83526, '\P{^Is_Scx=hluw}', "");
    Expect(0, 83527, '\p{Is_Scx=hluw}', "");
    Expect(1, 83527, '\p{^Is_Scx=hluw}', "");
    Expect(1, 83527, '\P{Is_Scx=hluw}', "");
    Expect(0, 83527, '\P{^Is_Scx=hluw}', "");
    Expect(1, 83526, '\p{Is_Scx=-	Hluw}', "");
    Expect(0, 83526, '\p{^Is_Scx=-	Hluw}', "");
    Expect(0, 83526, '\P{Is_Scx=-	Hluw}', "");
    Expect(1, 83526, '\P{^Is_Scx=-	Hluw}', "");
    Expect(0, 83527, '\p{Is_Scx=-	Hluw}', "");
    Expect(1, 83527, '\p{^Is_Scx=-	Hluw}', "");
    Expect(1, 83527, '\P{Is_Scx=-	Hluw}', "");
    Expect(0, 83527, '\P{^Is_Scx=-	Hluw}', "");
    Error('\p{Script_Extensions= -PAHAWH_HMONG:=}');
    Error('\P{Script_Extensions= -PAHAWH_HMONG:=}');
    Expect(1, 93071, '\p{Script_Extensions=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Script_Extensions=pahawhhmong}', "");
    Expect(0, 93071, '\P{Script_Extensions=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Script_Extensions=pahawhhmong}', "");
    Expect(0, 93072, '\p{Script_Extensions=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Script_Extensions=pahawhhmong}', "");
    Expect(1, 93072, '\P{Script_Extensions=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Script_Extensions=pahawhhmong}', "");
    Expect(1, 93071, '\p{Script_Extensions=	Pahawh_Hmong}', "");
    Expect(0, 93071, '\p{^Script_Extensions=	Pahawh_Hmong}', "");
    Expect(0, 93071, '\P{Script_Extensions=	Pahawh_Hmong}', "");
    Expect(1, 93071, '\P{^Script_Extensions=	Pahawh_Hmong}', "");
    Expect(0, 93072, '\p{Script_Extensions=	Pahawh_Hmong}', "");
    Expect(1, 93072, '\p{^Script_Extensions=	Pahawh_Hmong}', "");
    Expect(1, 93072, '\P{Script_Extensions=	Pahawh_Hmong}', "");
    Expect(0, 93072, '\P{^Script_Extensions=	Pahawh_Hmong}', "");
    Error('\p{Scx=/a/hmng}');
    Error('\P{Scx=/a/hmng}');
    Expect(1, 93071, '\p{Scx=hmng}', "");
    Expect(0, 93071, '\p{^Scx=hmng}', "");
    Expect(0, 93071, '\P{Scx=hmng}', "");
    Expect(1, 93071, '\P{^Scx=hmng}', "");
    Expect(0, 93072, '\p{Scx=hmng}', "");
    Expect(1, 93072, '\p{^Scx=hmng}', "");
    Expect(1, 93072, '\P{Scx=hmng}', "");
    Expect(0, 93072, '\P{^Scx=hmng}', "");
    Expect(1, 93071, '\p{Scx=	Hmng}', "");
    Expect(0, 93071, '\p{^Scx=	Hmng}', "");
    Expect(0, 93071, '\P{Scx=	Hmng}', "");
    Expect(1, 93071, '\P{^Scx=	Hmng}', "");
    Expect(0, 93072, '\p{Scx=	Hmng}', "");
    Expect(1, 93072, '\p{^Scx=	Hmng}', "");
    Expect(1, 93072, '\P{Scx=	Hmng}', "");
    Expect(0, 93072, '\P{^Scx=	Hmng}', "");
    Error('\p{Is_Script_Extensions=:=Pahawh_Hmong}');
    Error('\P{Is_Script_Extensions=:=Pahawh_Hmong}');
    Expect(1, 93071, '\p{Is_Script_Extensions=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Is_Script_Extensions=pahawhhmong}', "");
    Expect(0, 93071, '\P{Is_Script_Extensions=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Is_Script_Extensions=pahawhhmong}', "");
    Expect(0, 93072, '\p{Is_Script_Extensions=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Is_Script_Extensions=pahawhhmong}', "");
    Expect(1, 93072, '\P{Is_Script_Extensions=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Is_Script_Extensions=pahawhhmong}', "");
    Expect(1, 93071, '\p{Is_Script_Extensions=  pahawh_Hmong}', "");
    Expect(0, 93071, '\p{^Is_Script_Extensions=  pahawh_Hmong}', "");
    Expect(0, 93071, '\P{Is_Script_Extensions=  pahawh_Hmong}', "");
    Expect(1, 93071, '\P{^Is_Script_Extensions=  pahawh_Hmong}', "");
    Expect(0, 93072, '\p{Is_Script_Extensions=  pahawh_Hmong}', "");
    Expect(1, 93072, '\p{^Is_Script_Extensions=  pahawh_Hmong}', "");
    Expect(1, 93072, '\P{Is_Script_Extensions=  pahawh_Hmong}', "");
    Expect(0, 93072, '\P{^Is_Script_Extensions=  pahawh_Hmong}', "");
    Error('\p{Is_Scx=__Hmng:=}');
    Error('\P{Is_Scx=__Hmng:=}');
    Expect(1, 93071, '\p{Is_Scx=hmng}', "");
    Expect(0, 93071, '\p{^Is_Scx=hmng}', "");
    Expect(0, 93071, '\P{Is_Scx=hmng}', "");
    Expect(1, 93071, '\P{^Is_Scx=hmng}', "");
    Expect(0, 93072, '\p{Is_Scx=hmng}', "");
    Expect(1, 93072, '\p{^Is_Scx=hmng}', "");
    Expect(1, 93072, '\P{Is_Scx=hmng}', "");
    Expect(0, 93072, '\P{^Is_Scx=hmng}', "");
    Expect(1, 93071, '\p{Is_Scx= -hmng}', "");
    Expect(0, 93071, '\p{^Is_Scx= -hmng}', "");
    Expect(0, 93071, '\P{Is_Scx= -hmng}', "");
    Expect(1, 93071, '\P{^Is_Scx= -hmng}', "");
    Expect(0, 93072, '\p{Is_Scx= -hmng}', "");
    Expect(1, 93072, '\p{^Is_Scx= -hmng}', "");
    Expect(1, 93072, '\P{Is_Scx= -hmng}', "");
    Expect(0, 93072, '\P{^Is_Scx= -hmng}', "");
    Error('\p{Script_Extensions=Katakana_Or_Hiragana}');
    Error('\P{Script_Extensions=Katakana_Or_Hiragana}');
    Error('\p{Scx=Hrkt}');
    Error('\P{Scx=Hrkt}');
    Error('\p{Is_Script_Extensions=Katakana_Or_Hiragana}');
    Error('\P{Is_Script_Extensions=Katakana_Or_Hiragana}');
    Error('\p{Is_Scx=Hrkt}');
    Error('\P{Is_Scx=Hrkt}');
    Error('\p{Script_Extensions:	_:=Old_hungarian}');
    Error('\P{Script_Extensions:	_:=Old_hungarian}');
    Expect(1, 68863, '\p{Script_Extensions=oldhungarian}', "");
    Expect(0, 68863, '\p{^Script_Extensions=oldhungarian}', "");
    Expect(0, 68863, '\P{Script_Extensions=oldhungarian}', "");
    Expect(1, 68863, '\P{^Script_Extensions=oldhungarian}', "");
    Expect(0, 68864, '\p{Script_Extensions=oldhungarian}', "");
    Expect(1, 68864, '\p{^Script_Extensions=oldhungarian}', "");
    Expect(1, 68864, '\P{Script_Extensions=oldhungarian}', "");
    Expect(0, 68864, '\P{^Script_Extensions=oldhungarian}', "");
    Expect(1, 68863, '\p{Script_Extensions=		old_hungarian}', "");
    Expect(0, 68863, '\p{^Script_Extensions=		old_hungarian}', "");
    Expect(0, 68863, '\P{Script_Extensions=		old_hungarian}', "");
    Expect(1, 68863, '\P{^Script_Extensions=		old_hungarian}', "");
    Expect(0, 68864, '\p{Script_Extensions=		old_hungarian}', "");
    Expect(1, 68864, '\p{^Script_Extensions=		old_hungarian}', "");
    Expect(1, 68864, '\P{Script_Extensions=		old_hungarian}', "");
    Expect(0, 68864, '\P{^Script_Extensions=		old_hungarian}', "");
    Error('\p{Scx= :=Hung}');
    Error('\P{Scx= :=Hung}');
    Expect(1, 68863, '\p{Scx=hung}', "");
    Expect(0, 68863, '\p{^Scx=hung}', "");
    Expect(0, 68863, '\P{Scx=hung}', "");
    Expect(1, 68863, '\P{^Scx=hung}', "");
    Expect(0, 68864, '\p{Scx=hung}', "");
    Expect(1, 68864, '\p{^Scx=hung}', "");
    Expect(1, 68864, '\P{Scx=hung}', "");
    Expect(0, 68864, '\P{^Scx=hung}', "");
    Expect(1, 68863, '\p{Scx:   -_HUNG}', "");
    Expect(0, 68863, '\p{^Scx:   -_HUNG}', "");
    Expect(0, 68863, '\P{Scx:   -_HUNG}', "");
    Expect(1, 68863, '\P{^Scx:   -_HUNG}', "");
    Expect(0, 68864, '\p{Scx:   -_HUNG}', "");
    Expect(1, 68864, '\p{^Scx:   -_HUNG}', "");
    Expect(1, 68864, '\P{Scx:   -_HUNG}', "");
    Expect(0, 68864, '\P{^Scx:   -_HUNG}', "");
    Error('\p{Is_Script_Extensions=  OLD_hungarian/a/}');
    Error('\P{Is_Script_Extensions=  OLD_hungarian/a/}');
    Expect(1, 68863, '\p{Is_Script_Extensions=oldhungarian}', "");
    Expect(0, 68863, '\p{^Is_Script_Extensions=oldhungarian}', "");
    Expect(0, 68863, '\P{Is_Script_Extensions=oldhungarian}', "");
    Expect(1, 68863, '\P{^Is_Script_Extensions=oldhungarian}', "");
    Expect(0, 68864, '\p{Is_Script_Extensions=oldhungarian}', "");
    Expect(1, 68864, '\p{^Is_Script_Extensions=oldhungarian}', "");
    Expect(1, 68864, '\P{Is_Script_Extensions=oldhungarian}', "");
    Expect(0, 68864, '\P{^Is_Script_Extensions=oldhungarian}', "");
    Expect(1, 68863, '\p{Is_Script_Extensions=	 Old_Hungarian}', "");
    Expect(0, 68863, '\p{^Is_Script_Extensions=	 Old_Hungarian}', "");
    Expect(0, 68863, '\P{Is_Script_Extensions=	 Old_Hungarian}', "");
    Expect(1, 68863, '\P{^Is_Script_Extensions=	 Old_Hungarian}', "");
    Expect(0, 68864, '\p{Is_Script_Extensions=	 Old_Hungarian}', "");
    Expect(1, 68864, '\p{^Is_Script_Extensions=	 Old_Hungarian}', "");
    Expect(1, 68864, '\P{Is_Script_Extensions=	 Old_Hungarian}', "");
    Expect(0, 68864, '\P{^Is_Script_Extensions=	 Old_Hungarian}', "");
    Error('\p{Is_Scx=-Hung/a/}');
    Error('\P{Is_Scx=-Hung/a/}');
    Expect(1, 68863, '\p{Is_Scx=hung}', "");
    Expect(0, 68863, '\p{^Is_Scx=hung}', "");
    Expect(0, 68863, '\P{Is_Scx=hung}', "");
    Expect(1, 68863, '\P{^Is_Scx=hung}', "");
    Expect(0, 68864, '\p{Is_Scx=hung}', "");
    Expect(1, 68864, '\p{^Is_Scx=hung}', "");
    Expect(1, 68864, '\P{Is_Scx=hung}', "");
    Expect(0, 68864, '\P{^Is_Scx=hung}', "");
    Expect(1, 68863, '\p{Is_Scx=_HUNG}', "");
    Expect(0, 68863, '\p{^Is_Scx=_HUNG}', "");
    Expect(0, 68863, '\P{Is_Scx=_HUNG}', "");
    Expect(1, 68863, '\P{^Is_Scx=_HUNG}', "");
    Expect(0, 68864, '\p{Is_Scx=_HUNG}', "");
    Expect(1, 68864, '\p{^Is_Scx=_HUNG}', "");
    Expect(1, 68864, '\P{Is_Scx=_HUNG}', "");
    Expect(0, 68864, '\P{^Is_Scx=_HUNG}', "");
    Error('\p{Script_Extensions= 	old_ITALIC/a/}');
    Error('\P{Script_Extensions= 	old_ITALIC/a/}');
    Expect(1, 66351, '\p{Script_Extensions=olditalic}', "");
    Expect(0, 66351, '\p{^Script_Extensions=olditalic}', "");
    Expect(0, 66351, '\P{Script_Extensions=olditalic}', "");
    Expect(1, 66351, '\P{^Script_Extensions=olditalic}', "");
    Expect(0, 66352, '\p{Script_Extensions=olditalic}', "");
    Expect(1, 66352, '\p{^Script_Extensions=olditalic}', "");
    Expect(1, 66352, '\P{Script_Extensions=olditalic}', "");
    Expect(0, 66352, '\P{^Script_Extensions=olditalic}', "");
    Expect(1, 66351, '\p{Script_Extensions:   _-old_italic}', "");
    Expect(0, 66351, '\p{^Script_Extensions:   _-old_italic}', "");
    Expect(0, 66351, '\P{Script_Extensions:   _-old_italic}', "");
    Expect(1, 66351, '\P{^Script_Extensions:   _-old_italic}', "");
    Expect(0, 66352, '\p{Script_Extensions:   _-old_italic}', "");
    Expect(1, 66352, '\p{^Script_Extensions:   _-old_italic}', "");
    Expect(1, 66352, '\P{Script_Extensions:   _-old_italic}', "");
    Expect(0, 66352, '\P{^Script_Extensions:   _-old_italic}', "");
    Error('\p{Scx=/a/	_Ital}');
    Error('\P{Scx=/a/	_Ital}');
    Expect(1, 66351, '\p{Scx=ital}', "");
    Expect(0, 66351, '\p{^Scx=ital}', "");
    Expect(0, 66351, '\P{Scx=ital}', "");
    Expect(1, 66351, '\P{^Scx=ital}', "");
    Expect(0, 66352, '\p{Scx=ital}', "");
    Expect(1, 66352, '\p{^Scx=ital}', "");
    Expect(1, 66352, '\P{Scx=ital}', "");
    Expect(0, 66352, '\P{^Scx=ital}', "");
    Expect(1, 66351, '\p{Scx=Ital}', "");
    Expect(0, 66351, '\p{^Scx=Ital}', "");
    Expect(0, 66351, '\P{Scx=Ital}', "");
    Expect(1, 66351, '\P{^Scx=Ital}', "");
    Expect(0, 66352, '\p{Scx=Ital}', "");
    Expect(1, 66352, '\p{^Scx=Ital}', "");
    Expect(1, 66352, '\P{Scx=Ital}', "");
    Expect(0, 66352, '\P{^Scx=Ital}', "");
    Error('\p{Is_Script_Extensions= /a/OLD_Italic}');
    Error('\P{Is_Script_Extensions= /a/OLD_Italic}');
    Expect(1, 66351, '\p{Is_Script_Extensions=olditalic}', "");
    Expect(0, 66351, '\p{^Is_Script_Extensions=olditalic}', "");
    Expect(0, 66351, '\P{Is_Script_Extensions=olditalic}', "");
    Expect(1, 66351, '\P{^Is_Script_Extensions=olditalic}', "");
    Expect(0, 66352, '\p{Is_Script_Extensions=olditalic}', "");
    Expect(1, 66352, '\p{^Is_Script_Extensions=olditalic}', "");
    Expect(1, 66352, '\P{Is_Script_Extensions=olditalic}', "");
    Expect(0, 66352, '\P{^Is_Script_Extensions=olditalic}', "");
    Expect(1, 66351, '\p{Is_Script_Extensions: -Old_ITALIC}', "");
    Expect(0, 66351, '\p{^Is_Script_Extensions: -Old_ITALIC}', "");
    Expect(0, 66351, '\P{Is_Script_Extensions: -Old_ITALIC}', "");
    Expect(1, 66351, '\P{^Is_Script_Extensions: -Old_ITALIC}', "");
    Expect(0, 66352, '\p{Is_Script_Extensions: -Old_ITALIC}', "");
    Expect(1, 66352, '\p{^Is_Script_Extensions: -Old_ITALIC}', "");
    Expect(1, 66352, '\P{Is_Script_Extensions: -Old_ITALIC}', "");
    Expect(0, 66352, '\P{^Is_Script_Extensions: -Old_ITALIC}', "");
    Error('\p{Is_Scx= _Ital:=}');
    Error('\P{Is_Scx= _Ital:=}');
    Expect(1, 66351, '\p{Is_Scx=ital}', "");
    Expect(0, 66351, '\p{^Is_Scx=ital}', "");
    Expect(0, 66351, '\P{Is_Scx=ital}', "");
    Expect(1, 66351, '\P{^Is_Scx=ital}', "");
    Expect(0, 66352, '\p{Is_Scx=ital}', "");
    Expect(1, 66352, '\p{^Is_Scx=ital}', "");
    Expect(1, 66352, '\P{Is_Scx=ital}', "");
    Expect(0, 66352, '\P{^Is_Scx=ital}', "");
    Expect(1, 66351, '\p{Is_Scx=_	Ital}', "");
    Expect(0, 66351, '\p{^Is_Scx=_	Ital}', "");
    Expect(0, 66351, '\P{Is_Scx=_	Ital}', "");
    Expect(1, 66351, '\P{^Is_Scx=_	Ital}', "");
    Expect(0, 66352, '\p{Is_Scx=_	Ital}', "");
    Expect(1, 66352, '\p{^Is_Scx=_	Ital}', "");
    Expect(1, 66352, '\P{Is_Scx=_	Ital}', "");
    Expect(0, 66352, '\P{^Is_Scx=_	Ital}', "");
    Error('\p{Script_Extensions=	/a/Javanese}');
    Error('\P{Script_Extensions=	/a/Javanese}');
    Expect(1, 43487, '\p{Script_Extensions=javanese}', "");
    Expect(0, 43487, '\p{^Script_Extensions=javanese}', "");
    Expect(0, 43487, '\P{Script_Extensions=javanese}', "");
    Expect(1, 43487, '\P{^Script_Extensions=javanese}', "");
    Expect(0, 43488, '\p{Script_Extensions=javanese}', "");
    Expect(1, 43488, '\p{^Script_Extensions=javanese}', "");
    Expect(1, 43488, '\P{Script_Extensions=javanese}', "");
    Expect(0, 43488, '\P{^Script_Extensions=javanese}', "");
    Expect(1, 43487, '\p{Script_Extensions=	 JAVANESE}', "");
    Expect(0, 43487, '\p{^Script_Extensions=	 JAVANESE}', "");
    Expect(0, 43487, '\P{Script_Extensions=	 JAVANESE}', "");
    Expect(1, 43487, '\P{^Script_Extensions=	 JAVANESE}', "");
    Expect(0, 43488, '\p{Script_Extensions=	 JAVANESE}', "");
    Expect(1, 43488, '\p{^Script_Extensions=	 JAVANESE}', "");
    Expect(1, 43488, '\P{Script_Extensions=	 JAVANESE}', "");
    Expect(0, 43488, '\P{^Script_Extensions=	 JAVANESE}', "");
    Error('\p{Scx=-java:=}');
    Error('\P{Scx=-java:=}');
    Expect(1, 43487, '\p{Scx=java}', "");
    Expect(0, 43487, '\p{^Scx=java}', "");
    Expect(0, 43487, '\P{Scx=java}', "");
    Expect(1, 43487, '\P{^Scx=java}', "");
    Expect(0, 43488, '\p{Scx=java}', "");
    Expect(1, 43488, '\p{^Scx=java}', "");
    Expect(1, 43488, '\P{Scx=java}', "");
    Expect(0, 43488, '\P{^Scx=java}', "");
    Expect(1, 43487, '\p{Scx=	Java}', "");
    Expect(0, 43487, '\p{^Scx=	Java}', "");
    Expect(0, 43487, '\P{Scx=	Java}', "");
    Expect(1, 43487, '\P{^Scx=	Java}', "");
    Expect(0, 43488, '\p{Scx=	Java}', "");
    Expect(1, 43488, '\p{^Scx=	Java}', "");
    Expect(1, 43488, '\P{Scx=	Java}', "");
    Expect(0, 43488, '\P{^Scx=	Java}', "");
    Error('\p{Is_Script_Extensions=  javanese/a/}');
    Error('\P{Is_Script_Extensions=  javanese/a/}');
    Expect(1, 43487, '\p{Is_Script_Extensions=javanese}', "");
    Expect(0, 43487, '\p{^Is_Script_Extensions=javanese}', "");
    Expect(0, 43487, '\P{Is_Script_Extensions=javanese}', "");
    Expect(1, 43487, '\P{^Is_Script_Extensions=javanese}', "");
    Expect(0, 43488, '\p{Is_Script_Extensions=javanese}', "");
    Expect(1, 43488, '\p{^Is_Script_Extensions=javanese}', "");
    Expect(1, 43488, '\P{Is_Script_Extensions=javanese}', "");
    Expect(0, 43488, '\P{^Is_Script_Extensions=javanese}', "");
    Expect(1, 43487, '\p{Is_Script_Extensions=		javanese}', "");
    Expect(0, 43487, '\p{^Is_Script_Extensions=		javanese}', "");
    Expect(0, 43487, '\P{Is_Script_Extensions=		javanese}', "");
    Expect(1, 43487, '\P{^Is_Script_Extensions=		javanese}', "");
    Expect(0, 43488, '\p{Is_Script_Extensions=		javanese}', "");
    Expect(1, 43488, '\p{^Is_Script_Extensions=		javanese}', "");
    Expect(1, 43488, '\P{Is_Script_Extensions=		javanese}', "");
    Expect(0, 43488, '\P{^Is_Script_Extensions=		javanese}', "");
    Error('\p{Is_Scx=:=Java}');
    Error('\P{Is_Scx=:=Java}');
    Expect(1, 43487, '\p{Is_Scx=java}', "");
    Expect(0, 43487, '\p{^Is_Scx=java}', "");
    Expect(0, 43487, '\P{Is_Scx=java}', "");
    Expect(1, 43487, '\P{^Is_Scx=java}', "");
    Expect(0, 43488, '\p{Is_Scx=java}', "");
    Expect(1, 43488, '\p{^Is_Scx=java}', "");
    Expect(1, 43488, '\P{Is_Scx=java}', "");
    Expect(0, 43488, '\P{^Is_Scx=java}', "");
    Expect(1, 43487, '\p{Is_Scx: -	Java}', "");
    Expect(0, 43487, '\p{^Is_Scx: -	Java}', "");
    Expect(0, 43487, '\P{Is_Scx: -	Java}', "");
    Expect(1, 43487, '\P{^Is_Scx: -	Java}', "");
    Expect(0, 43488, '\p{Is_Scx: -	Java}', "");
    Expect(1, 43488, '\p{^Is_Scx: -	Java}', "");
    Expect(1, 43488, '\P{Is_Scx: -	Java}', "");
    Expect(0, 43488, '\P{^Is_Scx: -	Java}', "");
    Error('\p{Script_Extensions=:=_Kayah_li}');
    Error('\P{Script_Extensions=:=_Kayah_li}');
    Expect(1, 43311, '\p{Script_Extensions=kayahli}', "");
    Expect(0, 43311, '\p{^Script_Extensions=kayahli}', "");
    Expect(0, 43311, '\P{Script_Extensions=kayahli}', "");
    Expect(1, 43311, '\P{^Script_Extensions=kayahli}', "");
    Expect(0, 43312, '\p{Script_Extensions=kayahli}', "");
    Expect(1, 43312, '\p{^Script_Extensions=kayahli}', "");
    Expect(1, 43312, '\P{Script_Extensions=kayahli}', "");
    Expect(0, 43312, '\P{^Script_Extensions=kayahli}', "");
    Expect(1, 43311, '\p{Script_Extensions=-	kayah_li}', "");
    Expect(0, 43311, '\p{^Script_Extensions=-	kayah_li}', "");
    Expect(0, 43311, '\P{Script_Extensions=-	kayah_li}', "");
    Expect(1, 43311, '\P{^Script_Extensions=-	kayah_li}', "");
    Expect(0, 43312, '\p{Script_Extensions=-	kayah_li}', "");
    Expect(1, 43312, '\p{^Script_Extensions=-	kayah_li}', "");
    Expect(1, 43312, '\P{Script_Extensions=-	kayah_li}', "");
    Expect(0, 43312, '\P{^Script_Extensions=-	kayah_li}', "");
    Error('\p{Scx=-KALI/a/}');
    Error('\P{Scx=-KALI/a/}');
    Expect(1, 43311, '\p{Scx=kali}', "");
    Expect(0, 43311, '\p{^Scx=kali}', "");
    Expect(0, 43311, '\P{Scx=kali}', "");
    Expect(1, 43311, '\P{^Scx=kali}', "");
    Expect(0, 43312, '\p{Scx=kali}', "");
    Expect(1, 43312, '\p{^Scx=kali}', "");
    Expect(1, 43312, '\P{Scx=kali}', "");
    Expect(0, 43312, '\P{^Scx=kali}', "");
    Expect(1, 43311, '\p{Scx=	-Kali}', "");
    Expect(0, 43311, '\p{^Scx=	-Kali}', "");
    Expect(0, 43311, '\P{Scx=	-Kali}', "");
    Expect(1, 43311, '\P{^Scx=	-Kali}', "");
    Expect(0, 43312, '\p{Scx=	-Kali}', "");
    Expect(1, 43312, '\p{^Scx=	-Kali}', "");
    Expect(1, 43312, '\P{Scx=	-Kali}', "");
    Expect(0, 43312, '\P{^Scx=	-Kali}', "");
    Error('\p{Is_Script_Extensions=:= -Kayah_Li}');
    Error('\P{Is_Script_Extensions=:= -Kayah_Li}');
    Expect(1, 43311, '\p{Is_Script_Extensions=kayahli}', "");
    Expect(0, 43311, '\p{^Is_Script_Extensions=kayahli}', "");
    Expect(0, 43311, '\P{Is_Script_Extensions=kayahli}', "");
    Expect(1, 43311, '\P{^Is_Script_Extensions=kayahli}', "");
    Expect(0, 43312, '\p{Is_Script_Extensions=kayahli}', "");
    Expect(1, 43312, '\p{^Is_Script_Extensions=kayahli}', "");
    Expect(1, 43312, '\P{Is_Script_Extensions=kayahli}', "");
    Expect(0, 43312, '\P{^Is_Script_Extensions=kayahli}', "");
    Expect(1, 43311, '\p{Is_Script_Extensions=_ kayah_li}', "");
    Expect(0, 43311, '\p{^Is_Script_Extensions=_ kayah_li}', "");
    Expect(0, 43311, '\P{Is_Script_Extensions=_ kayah_li}', "");
    Expect(1, 43311, '\P{^Is_Script_Extensions=_ kayah_li}', "");
    Expect(0, 43312, '\p{Is_Script_Extensions=_ kayah_li}', "");
    Expect(1, 43312, '\p{^Is_Script_Extensions=_ kayah_li}', "");
    Expect(1, 43312, '\P{Is_Script_Extensions=_ kayah_li}', "");
    Expect(0, 43312, '\P{^Is_Script_Extensions=_ kayah_li}', "");
    Error('\p{Is_Scx=	Kali:=}');
    Error('\P{Is_Scx=	Kali:=}');
    Expect(1, 43311, '\p{Is_Scx=kali}', "");
    Expect(0, 43311, '\p{^Is_Scx=kali}', "");
    Expect(0, 43311, '\P{Is_Scx=kali}', "");
    Expect(1, 43311, '\P{^Is_Scx=kali}', "");
    Expect(0, 43312, '\p{Is_Scx=kali}', "");
    Expect(1, 43312, '\p{^Is_Scx=kali}', "");
    Expect(1, 43312, '\P{Is_Scx=kali}', "");
    Expect(0, 43312, '\P{^Is_Scx=kali}', "");
    Expect(1, 43311, '\p{Is_Scx=-	Kali}', "");
    Expect(0, 43311, '\p{^Is_Scx=-	Kali}', "");
    Expect(0, 43311, '\P{Is_Scx=-	Kali}', "");
    Expect(1, 43311, '\P{^Is_Scx=-	Kali}', "");
    Expect(0, 43312, '\p{Is_Scx=-	Kali}', "");
    Expect(1, 43312, '\p{^Is_Scx=-	Kali}', "");
    Expect(1, 43312, '\P{Is_Scx=-	Kali}', "");
    Expect(0, 43312, '\P{^Is_Scx=-	Kali}', "");
    Error('\p{Script_Extensions= /a/Katakana}');
    Error('\P{Script_Extensions= /a/Katakana}');
    Expect(1, 110592, '\p{Script_Extensions=katakana}', "");
    Expect(0, 110592, '\p{^Script_Extensions=katakana}', "");
    Expect(0, 110592, '\P{Script_Extensions=katakana}', "");
    Expect(1, 110592, '\P{^Script_Extensions=katakana}', "");
    Expect(0, 110593, '\p{Script_Extensions=katakana}', "");
    Expect(1, 110593, '\p{^Script_Extensions=katakana}', "");
    Expect(1, 110593, '\P{Script_Extensions=katakana}', "");
    Expect(0, 110593, '\P{^Script_Extensions=katakana}', "");
    Expect(1, 110592, '\p{Script_Extensions=-Katakana}', "");
    Expect(0, 110592, '\p{^Script_Extensions=-Katakana}', "");
    Expect(0, 110592, '\P{Script_Extensions=-Katakana}', "");
    Expect(1, 110592, '\P{^Script_Extensions=-Katakana}', "");
    Expect(0, 110593, '\p{Script_Extensions=-Katakana}', "");
    Expect(1, 110593, '\p{^Script_Extensions=-Katakana}', "");
    Expect(1, 110593, '\P{Script_Extensions=-Katakana}', "");
    Expect(0, 110593, '\P{^Script_Extensions=-Katakana}', "");
    Error('\p{Scx:_Kana:=}');
    Error('\P{Scx:_Kana:=}');
    Expect(1, 110592, '\p{Scx=kana}', "");
    Expect(0, 110592, '\p{^Scx=kana}', "");
    Expect(0, 110592, '\P{Scx=kana}', "");
    Expect(1, 110592, '\P{^Scx=kana}', "");
    Expect(0, 110593, '\p{Scx=kana}', "");
    Expect(1, 110593, '\p{^Scx=kana}', "");
    Expect(1, 110593, '\P{Scx=kana}', "");
    Expect(0, 110593, '\P{^Scx=kana}', "");
    Expect(1, 110592, '\p{Scx:   -_kana}', "");
    Expect(0, 110592, '\p{^Scx:   -_kana}', "");
    Expect(0, 110592, '\P{Scx:   -_kana}', "");
    Expect(1, 110592, '\P{^Scx:   -_kana}', "");
    Expect(0, 110593, '\p{Scx:   -_kana}', "");
    Expect(1, 110593, '\p{^Scx:   -_kana}', "");
    Expect(1, 110593, '\P{Scx:   -_kana}', "");
    Expect(0, 110593, '\P{^Scx:   -_kana}', "");
    Error('\p{Is_Script_Extensions= :=katakana}');
    Error('\P{Is_Script_Extensions= :=katakana}');
    Expect(1, 110592, '\p{Is_Script_Extensions=katakana}', "");
    Expect(0, 110592, '\p{^Is_Script_Extensions=katakana}', "");
    Expect(0, 110592, '\P{Is_Script_Extensions=katakana}', "");
    Expect(1, 110592, '\P{^Is_Script_Extensions=katakana}', "");
    Expect(0, 110593, '\p{Is_Script_Extensions=katakana}', "");
    Expect(1, 110593, '\p{^Is_Script_Extensions=katakana}', "");
    Expect(1, 110593, '\P{Is_Script_Extensions=katakana}', "");
    Expect(0, 110593, '\P{^Is_Script_Extensions=katakana}', "");
    Expect(1, 110592, '\p{Is_Script_Extensions:    Katakana}', "");
    Expect(0, 110592, '\p{^Is_Script_Extensions:    Katakana}', "");
    Expect(0, 110592, '\P{Is_Script_Extensions:    Katakana}', "");
    Expect(1, 110592, '\P{^Is_Script_Extensions:    Katakana}', "");
    Expect(0, 110593, '\p{Is_Script_Extensions:    Katakana}', "");
    Expect(1, 110593, '\p{^Is_Script_Extensions:    Katakana}', "");
    Expect(1, 110593, '\P{Is_Script_Extensions:    Katakana}', "");
    Expect(0, 110593, '\P{^Is_Script_Extensions:    Katakana}', "");
    Error('\p{Is_Scx=/a/__kana}');
    Error('\P{Is_Scx=/a/__kana}');
    Expect(1, 110592, '\p{Is_Scx=kana}', "");
    Expect(0, 110592, '\p{^Is_Scx=kana}', "");
    Expect(0, 110592, '\P{Is_Scx=kana}', "");
    Expect(1, 110592, '\P{^Is_Scx=kana}', "");
    Expect(0, 110593, '\p{Is_Scx=kana}', "");
    Expect(1, 110593, '\p{^Is_Scx=kana}', "");
    Expect(1, 110593, '\P{Is_Scx=kana}', "");
    Expect(0, 110593, '\P{^Is_Scx=kana}', "");
    Expect(1, 110592, '\p{Is_Scx=	_KANA}', "");
    Expect(0, 110592, '\p{^Is_Scx=	_KANA}', "");
    Expect(0, 110592, '\P{Is_Scx=	_KANA}', "");
    Expect(1, 110592, '\P{^Is_Scx=	_KANA}', "");
    Expect(0, 110593, '\p{Is_Scx=	_KANA}', "");
    Expect(1, 110593, '\p{^Is_Scx=	_KANA}', "");
    Expect(1, 110593, '\P{Is_Scx=	_KANA}', "");
    Expect(0, 110593, '\P{^Is_Scx=	_KANA}', "");
    Error('\p{Script_Extensions=	:=Kharoshthi}');
    Error('\P{Script_Extensions=	:=Kharoshthi}');
    Expect(1, 68184, '\p{Script_Extensions=kharoshthi}', "");
    Expect(0, 68184, '\p{^Script_Extensions=kharoshthi}', "");
    Expect(0, 68184, '\P{Script_Extensions=kharoshthi}', "");
    Expect(1, 68184, '\P{^Script_Extensions=kharoshthi}', "");
    Expect(0, 68185, '\p{Script_Extensions=kharoshthi}', "");
    Expect(1, 68185, '\p{^Script_Extensions=kharoshthi}', "");
    Expect(1, 68185, '\P{Script_Extensions=kharoshthi}', "");
    Expect(0, 68185, '\P{^Script_Extensions=kharoshthi}', "");
    Expect(1, 68184, '\p{Script_Extensions=  Kharoshthi}', "");
    Expect(0, 68184, '\p{^Script_Extensions=  Kharoshthi}', "");
    Expect(0, 68184, '\P{Script_Extensions=  Kharoshthi}', "");
    Expect(1, 68184, '\P{^Script_Extensions=  Kharoshthi}', "");
    Expect(0, 68185, '\p{Script_Extensions=  Kharoshthi}', "");
    Expect(1, 68185, '\p{^Script_Extensions=  Kharoshthi}', "");
    Expect(1, 68185, '\P{Script_Extensions=  Kharoshthi}', "");
    Expect(0, 68185, '\P{^Script_Extensions=  Kharoshthi}', "");
    Error('\p{Scx=_/a/Khar}');
    Error('\P{Scx=_/a/Khar}');
    Expect(1, 68184, '\p{Scx=khar}', "");
    Expect(0, 68184, '\p{^Scx=khar}', "");
    Expect(0, 68184, '\P{Scx=khar}', "");
    Expect(1, 68184, '\P{^Scx=khar}', "");
    Expect(0, 68185, '\p{Scx=khar}', "");
    Expect(1, 68185, '\p{^Scx=khar}', "");
    Expect(1, 68185, '\P{Scx=khar}', "");
    Expect(0, 68185, '\P{^Scx=khar}', "");
    Expect(1, 68184, '\p{Scx= _Khar}', "");
    Expect(0, 68184, '\p{^Scx= _Khar}', "");
    Expect(0, 68184, '\P{Scx= _Khar}', "");
    Expect(1, 68184, '\P{^Scx= _Khar}', "");
    Expect(0, 68185, '\p{Scx= _Khar}', "");
    Expect(1, 68185, '\p{^Scx= _Khar}', "");
    Expect(1, 68185, '\P{Scx= _Khar}', "");
    Expect(0, 68185, '\P{^Scx= _Khar}', "");
    Error('\p{Is_Script_Extensions=-KHAROSHTHI:=}');
    Error('\P{Is_Script_Extensions=-KHAROSHTHI:=}');
    Expect(1, 68184, '\p{Is_Script_Extensions=kharoshthi}', "");
    Expect(0, 68184, '\p{^Is_Script_Extensions=kharoshthi}', "");
    Expect(0, 68184, '\P{Is_Script_Extensions=kharoshthi}', "");
    Expect(1, 68184, '\P{^Is_Script_Extensions=kharoshthi}', "");
    Expect(0, 68185, '\p{Is_Script_Extensions=kharoshthi}', "");
    Expect(1, 68185, '\p{^Is_Script_Extensions=kharoshthi}', "");
    Expect(1, 68185, '\P{Is_Script_Extensions=kharoshthi}', "");
    Expect(0, 68185, '\P{^Is_Script_Extensions=kharoshthi}', "");
    Expect(1, 68184, '\p{Is_Script_Extensions=--Kharoshthi}', "");
    Expect(0, 68184, '\p{^Is_Script_Extensions=--Kharoshthi}', "");
    Expect(0, 68184, '\P{Is_Script_Extensions=--Kharoshthi}', "");
    Expect(1, 68184, '\P{^Is_Script_Extensions=--Kharoshthi}', "");
    Expect(0, 68185, '\p{Is_Script_Extensions=--Kharoshthi}', "");
    Expect(1, 68185, '\p{^Is_Script_Extensions=--Kharoshthi}', "");
    Expect(1, 68185, '\P{Is_Script_Extensions=--Kharoshthi}', "");
    Expect(0, 68185, '\P{^Is_Script_Extensions=--Kharoshthi}', "");
    Error('\p{Is_Scx=:=khar}');
    Error('\P{Is_Scx=:=khar}');
    Expect(1, 68184, '\p{Is_Scx=khar}', "");
    Expect(0, 68184, '\p{^Is_Scx=khar}', "");
    Expect(0, 68184, '\P{Is_Scx=khar}', "");
    Expect(1, 68184, '\P{^Is_Scx=khar}', "");
    Expect(0, 68185, '\p{Is_Scx=khar}', "");
    Expect(1, 68185, '\p{^Is_Scx=khar}', "");
    Expect(1, 68185, '\P{Is_Scx=khar}', "");
    Expect(0, 68185, '\P{^Is_Scx=khar}', "");
    Expect(1, 68184, '\p{Is_Scx=		Khar}', "");
    Expect(0, 68184, '\p{^Is_Scx=		Khar}', "");
    Expect(0, 68184, '\P{Is_Scx=		Khar}', "");
    Expect(1, 68184, '\P{^Is_Scx=		Khar}', "");
    Expect(0, 68185, '\p{Is_Scx=		Khar}', "");
    Expect(1, 68185, '\p{^Is_Scx=		Khar}', "");
    Expect(1, 68185, '\P{Is_Scx=		Khar}', "");
    Expect(0, 68185, '\P{^Is_Scx=		Khar}', "");
    Error('\p{Script_Extensions=/a/_	Khmer}');
    Error('\P{Script_Extensions=/a/_	Khmer}');
    Expect(1, 6655, '\p{Script_Extensions=khmer}', "");
    Expect(0, 6655, '\p{^Script_Extensions=khmer}', "");
    Expect(0, 6655, '\P{Script_Extensions=khmer}', "");
    Expect(1, 6655, '\P{^Script_Extensions=khmer}', "");
    Expect(0, 6656, '\p{Script_Extensions=khmer}', "");
    Expect(1, 6656, '\p{^Script_Extensions=khmer}', "");
    Expect(1, 6656, '\P{Script_Extensions=khmer}', "");
    Expect(0, 6656, '\P{^Script_Extensions=khmer}', "");
    Expect(1, 6655, '\p{Script_Extensions= _Khmer}', "");
    Expect(0, 6655, '\p{^Script_Extensions= _Khmer}', "");
    Expect(0, 6655, '\P{Script_Extensions= _Khmer}', "");
    Expect(1, 6655, '\P{^Script_Extensions= _Khmer}', "");
    Expect(0, 6656, '\p{Script_Extensions= _Khmer}', "");
    Expect(1, 6656, '\p{^Script_Extensions= _Khmer}', "");
    Expect(1, 6656, '\P{Script_Extensions= _Khmer}', "");
    Expect(0, 6656, '\P{^Script_Extensions= _Khmer}', "");
    Error('\p{Scx=/a/Khmr}');
    Error('\P{Scx=/a/Khmr}');
    Expect(1, 6655, '\p{Scx=khmr}', "");
    Expect(0, 6655, '\p{^Scx=khmr}', "");
    Expect(0, 6655, '\P{Scx=khmr}', "");
    Expect(1, 6655, '\P{^Scx=khmr}', "");
    Expect(0, 6656, '\p{Scx=khmr}', "");
    Expect(1, 6656, '\p{^Scx=khmr}', "");
    Expect(1, 6656, '\P{Scx=khmr}', "");
    Expect(0, 6656, '\P{^Scx=khmr}', "");
    Expect(1, 6655, '\p{Scx= -khmr}', "");
    Expect(0, 6655, '\p{^Scx= -khmr}', "");
    Expect(0, 6655, '\P{Scx= -khmr}', "");
    Expect(1, 6655, '\P{^Scx= -khmr}', "");
    Expect(0, 6656, '\p{Scx= -khmr}', "");
    Expect(1, 6656, '\p{^Scx= -khmr}', "");
    Expect(1, 6656, '\P{Scx= -khmr}', "");
    Expect(0, 6656, '\P{^Scx= -khmr}', "");
    Error('\p{Is_Script_Extensions:/a/  Khmer}');
    Error('\P{Is_Script_Extensions:/a/  Khmer}');
    Expect(1, 6655, '\p{Is_Script_Extensions=khmer}', "");
    Expect(0, 6655, '\p{^Is_Script_Extensions=khmer}', "");
    Expect(0, 6655, '\P{Is_Script_Extensions=khmer}', "");
    Expect(1, 6655, '\P{^Is_Script_Extensions=khmer}', "");
    Expect(0, 6656, '\p{Is_Script_Extensions=khmer}', "");
    Expect(1, 6656, '\p{^Is_Script_Extensions=khmer}', "");
    Expect(1, 6656, '\P{Is_Script_Extensions=khmer}', "");
    Expect(0, 6656, '\P{^Is_Script_Extensions=khmer}', "");
    Expect(1, 6655, '\p{Is_Script_Extensions=_-Khmer}', "");
    Expect(0, 6655, '\p{^Is_Script_Extensions=_-Khmer}', "");
    Expect(0, 6655, '\P{Is_Script_Extensions=_-Khmer}', "");
    Expect(1, 6655, '\P{^Is_Script_Extensions=_-Khmer}', "");
    Expect(0, 6656, '\p{Is_Script_Extensions=_-Khmer}', "");
    Expect(1, 6656, '\p{^Is_Script_Extensions=_-Khmer}', "");
    Expect(1, 6656, '\P{Is_Script_Extensions=_-Khmer}', "");
    Expect(0, 6656, '\P{^Is_Script_Extensions=_-Khmer}', "");
    Error('\p{Is_Scx=-_khmr:=}');
    Error('\P{Is_Scx=-_khmr:=}');
    Expect(1, 6655, '\p{Is_Scx=khmr}', "");
    Expect(0, 6655, '\p{^Is_Scx=khmr}', "");
    Expect(0, 6655, '\P{Is_Scx=khmr}', "");
    Expect(1, 6655, '\P{^Is_Scx=khmr}', "");
    Expect(0, 6656, '\p{Is_Scx=khmr}', "");
    Expect(1, 6656, '\p{^Is_Scx=khmr}', "");
    Expect(1, 6656, '\P{Is_Scx=khmr}', "");
    Expect(0, 6656, '\P{^Is_Scx=khmr}', "");
    Expect(1, 6655, '\p{Is_Scx=-	KHMR}', "");
    Expect(0, 6655, '\p{^Is_Scx=-	KHMR}', "");
    Expect(0, 6655, '\P{Is_Scx=-	KHMR}', "");
    Expect(1, 6655, '\P{^Is_Scx=-	KHMR}', "");
    Expect(0, 6656, '\p{Is_Scx=-	KHMR}', "");
    Expect(1, 6656, '\p{^Is_Scx=-	KHMR}', "");
    Expect(1, 6656, '\P{Is_Scx=-	KHMR}', "");
    Expect(0, 6656, '\P{^Is_Scx=-	KHMR}', "");
    Error('\p{Script_Extensions=/a/- khojki}');
    Error('\P{Script_Extensions=/a/- khojki}');
    Expect(1, 70206, '\p{Script_Extensions=khojki}', "");
    Expect(0, 70206, '\p{^Script_Extensions=khojki}', "");
    Expect(0, 70206, '\P{Script_Extensions=khojki}', "");
    Expect(1, 70206, '\P{^Script_Extensions=khojki}', "");
    Expect(0, 70207, '\p{Script_Extensions=khojki}', "");
    Expect(1, 70207, '\p{^Script_Extensions=khojki}', "");
    Expect(1, 70207, '\P{Script_Extensions=khojki}', "");
    Expect(0, 70207, '\P{^Script_Extensions=khojki}', "");
    Expect(1, 70206, '\p{Script_Extensions= 	Khojki}', "");
    Expect(0, 70206, '\p{^Script_Extensions= 	Khojki}', "");
    Expect(0, 70206, '\P{Script_Extensions= 	Khojki}', "");
    Expect(1, 70206, '\P{^Script_Extensions= 	Khojki}', "");
    Expect(0, 70207, '\p{Script_Extensions= 	Khojki}', "");
    Expect(1, 70207, '\p{^Script_Extensions= 	Khojki}', "");
    Expect(1, 70207, '\P{Script_Extensions= 	Khojki}', "");
    Expect(0, 70207, '\P{^Script_Extensions= 	Khojki}', "");
    Error('\p{Scx=/a/KHOJ}');
    Error('\P{Scx=/a/KHOJ}');
    Expect(1, 70206, '\p{Scx:khoj}', "");
    Expect(0, 70206, '\p{^Scx:khoj}', "");
    Expect(0, 70206, '\P{Scx:khoj}', "");
    Expect(1, 70206, '\P{^Scx:khoj}', "");
    Expect(0, 70207, '\p{Scx:khoj}', "");
    Expect(1, 70207, '\p{^Scx:khoj}', "");
    Expect(1, 70207, '\P{Scx:khoj}', "");
    Expect(0, 70207, '\P{^Scx:khoj}', "");
    Expect(1, 70206, '\p{Scx=-khoj}', "");
    Expect(0, 70206, '\p{^Scx=-khoj}', "");
    Expect(0, 70206, '\P{Scx=-khoj}', "");
    Expect(1, 70206, '\P{^Scx=-khoj}', "");
    Expect(0, 70207, '\p{Scx=-khoj}', "");
    Expect(1, 70207, '\p{^Scx=-khoj}', "");
    Expect(1, 70207, '\P{Scx=-khoj}', "");
    Expect(0, 70207, '\P{^Scx=-khoj}', "");
    Error('\p{Is_Script_Extensions=/a/--Khojki}');
    Error('\P{Is_Script_Extensions=/a/--Khojki}');
    Expect(1, 70206, '\p{Is_Script_Extensions=khojki}', "");
    Expect(0, 70206, '\p{^Is_Script_Extensions=khojki}', "");
    Expect(0, 70206, '\P{Is_Script_Extensions=khojki}', "");
    Expect(1, 70206, '\P{^Is_Script_Extensions=khojki}', "");
    Expect(0, 70207, '\p{Is_Script_Extensions=khojki}', "");
    Expect(1, 70207, '\p{^Is_Script_Extensions=khojki}', "");
    Expect(1, 70207, '\P{Is_Script_Extensions=khojki}', "");
    Expect(0, 70207, '\P{^Is_Script_Extensions=khojki}', "");
    Expect(1, 70206, '\p{Is_Script_Extensions=  Khojki}', "");
    Expect(0, 70206, '\p{^Is_Script_Extensions=  Khojki}', "");
    Expect(0, 70206, '\P{Is_Script_Extensions=  Khojki}', "");
    Expect(1, 70206, '\P{^Is_Script_Extensions=  Khojki}', "");
    Expect(0, 70207, '\p{Is_Script_Extensions=  Khojki}', "");
    Expect(1, 70207, '\p{^Is_Script_Extensions=  Khojki}', "");
    Expect(1, 70207, '\P{Is_Script_Extensions=  Khojki}', "");
    Expect(0, 70207, '\P{^Is_Script_Extensions=  Khojki}', "");
    Error('\p{Is_Scx=/a/ _Khoj}');
    Error('\P{Is_Scx=/a/ _Khoj}');
    Expect(1, 70206, '\p{Is_Scx=khoj}', "");
    Expect(0, 70206, '\p{^Is_Scx=khoj}', "");
    Expect(0, 70206, '\P{Is_Scx=khoj}', "");
    Expect(1, 70206, '\P{^Is_Scx=khoj}', "");
    Expect(0, 70207, '\p{Is_Scx=khoj}', "");
    Expect(1, 70207, '\p{^Is_Scx=khoj}', "");
    Expect(1, 70207, '\P{Is_Scx=khoj}', "");
    Expect(0, 70207, '\P{^Is_Scx=khoj}', "");
    Expect(1, 70206, '\p{Is_Scx=-_Khoj}', "");
    Expect(0, 70206, '\p{^Is_Scx=-_Khoj}', "");
    Expect(0, 70206, '\P{Is_Scx=-_Khoj}', "");
    Expect(1, 70206, '\P{^Is_Scx=-_Khoj}', "");
    Expect(0, 70207, '\p{Is_Scx=-_Khoj}', "");
    Expect(1, 70207, '\p{^Is_Scx=-_Khoj}', "");
    Expect(1, 70207, '\P{Is_Scx=-_Khoj}', "");
    Expect(0, 70207, '\P{^Is_Scx=-_Khoj}', "");
    Error('\p{Script_Extensions=-KANNADA:=}');
    Error('\P{Script_Extensions=-KANNADA:=}');
    Expect(1, 43061, '\p{Script_Extensions=kannada}', "");
    Expect(0, 43061, '\p{^Script_Extensions=kannada}', "");
    Expect(0, 43061, '\P{Script_Extensions=kannada}', "");
    Expect(1, 43061, '\P{^Script_Extensions=kannada}', "");
    Expect(0, 43062, '\p{Script_Extensions=kannada}', "");
    Expect(1, 43062, '\p{^Script_Extensions=kannada}', "");
    Expect(1, 43062, '\P{Script_Extensions=kannada}', "");
    Expect(0, 43062, '\P{^Script_Extensions=kannada}', "");
    Expect(1, 43061, '\p{Script_Extensions=-_Kannada}', "");
    Expect(0, 43061, '\p{^Script_Extensions=-_Kannada}', "");
    Expect(0, 43061, '\P{Script_Extensions=-_Kannada}', "");
    Expect(1, 43061, '\P{^Script_Extensions=-_Kannada}', "");
    Expect(0, 43062, '\p{Script_Extensions=-_Kannada}', "");
    Expect(1, 43062, '\p{^Script_Extensions=-_Kannada}', "");
    Expect(1, 43062, '\P{Script_Extensions=-_Kannada}', "");
    Expect(0, 43062, '\P{^Script_Extensions=-_Kannada}', "");
    Error('\p{Scx::=Knda}');
    Error('\P{Scx::=Knda}');
    Expect(1, 43061, '\p{Scx=knda}', "");
    Expect(0, 43061, '\p{^Scx=knda}', "");
    Expect(0, 43061, '\P{Scx=knda}', "");
    Expect(1, 43061, '\P{^Scx=knda}', "");
    Expect(0, 43062, '\p{Scx=knda}', "");
    Expect(1, 43062, '\p{^Scx=knda}', "");
    Expect(1, 43062, '\P{Scx=knda}', "");
    Expect(0, 43062, '\P{^Scx=knda}', "");
    Error('\p{Is_Script_Extensions=:= -kannada}');
    Error('\P{Is_Script_Extensions=:= -kannada}');
    Expect(1, 43061, '\p{Is_Script_Extensions:	kannada}', "");
    Expect(0, 43061, '\p{^Is_Script_Extensions:	kannada}', "");
    Expect(0, 43061, '\P{Is_Script_Extensions:	kannada}', "");
    Expect(1, 43061, '\P{^Is_Script_Extensions:	kannada}', "");
    Expect(0, 43062, '\p{Is_Script_Extensions:	kannada}', "");
    Expect(1, 43062, '\p{^Is_Script_Extensions:	kannada}', "");
    Expect(1, 43062, '\P{Is_Script_Extensions:	kannada}', "");
    Expect(0, 43062, '\P{^Is_Script_Extensions:	kannada}', "");
    Expect(1, 43061, '\p{Is_Script_Extensions=  Kannada}', "");
    Expect(0, 43061, '\p{^Is_Script_Extensions=  Kannada}', "");
    Expect(0, 43061, '\P{Is_Script_Extensions=  Kannada}', "");
    Expect(1, 43061, '\P{^Is_Script_Extensions=  Kannada}', "");
    Expect(0, 43062, '\p{Is_Script_Extensions=  Kannada}', "");
    Expect(1, 43062, '\p{^Is_Script_Extensions=  Kannada}', "");
    Expect(1, 43062, '\P{Is_Script_Extensions=  Kannada}', "");
    Expect(0, 43062, '\P{^Is_Script_Extensions=  Kannada}', "");
    Error('\p{Is_Scx=Knda:=}');
    Error('\P{Is_Scx=Knda:=}');
    Expect(1, 43061, '\p{Is_Scx: knda}', "");
    Expect(0, 43061, '\p{^Is_Scx: knda}', "");
    Expect(0, 43061, '\P{Is_Scx: knda}', "");
    Expect(1, 43061, '\P{^Is_Scx: knda}', "");
    Expect(0, 43062, '\p{Is_Scx: knda}', "");
    Expect(1, 43062, '\p{^Is_Scx: knda}', "");
    Expect(1, 43062, '\P{Is_Scx: knda}', "");
    Expect(0, 43062, '\P{^Is_Scx: knda}', "");
    Expect(1, 43061, '\p{Is_Scx= knda}', "");
    Expect(0, 43061, '\p{^Is_Scx= knda}', "");
    Expect(0, 43061, '\P{Is_Scx= knda}', "");
    Expect(1, 43061, '\P{^Is_Scx= knda}', "");
    Expect(0, 43062, '\p{Is_Scx= knda}', "");
    Expect(1, 43062, '\p{^Is_Scx= knda}', "");
    Expect(1, 43062, '\P{Is_Scx= knda}', "");
    Expect(0, 43062, '\P{^Is_Scx= knda}', "");
    Error('\p{Script_Extensions=	/a/Kaithi}');
    Error('\P{Script_Extensions=	/a/Kaithi}');
    Expect(1, 69825, '\p{Script_Extensions:kaithi}', "");
    Expect(0, 69825, '\p{^Script_Extensions:kaithi}', "");
    Expect(0, 69825, '\P{Script_Extensions:kaithi}', "");
    Expect(1, 69825, '\P{^Script_Extensions:kaithi}', "");
    Expect(0, 69826, '\p{Script_Extensions:kaithi}', "");
    Expect(1, 69826, '\p{^Script_Extensions:kaithi}', "");
    Expect(1, 69826, '\P{Script_Extensions:kaithi}', "");
    Expect(0, 69826, '\P{^Script_Extensions:kaithi}', "");
    Expect(1, 69825, '\p{Script_Extensions=		Kaithi}', "");
    Expect(0, 69825, '\p{^Script_Extensions=		Kaithi}', "");
    Expect(0, 69825, '\P{Script_Extensions=		Kaithi}', "");
    Expect(1, 69825, '\P{^Script_Extensions=		Kaithi}', "");
    Expect(0, 69826, '\p{Script_Extensions=		Kaithi}', "");
    Expect(1, 69826, '\p{^Script_Extensions=		Kaithi}', "");
    Expect(1, 69826, '\P{Script_Extensions=		Kaithi}', "");
    Expect(0, 69826, '\P{^Script_Extensions=		Kaithi}', "");
    Error('\p{Scx:	:=Kthi}');
    Error('\P{Scx:	:=Kthi}');
    Expect(1, 69825, '\p{Scx=kthi}', "");
    Expect(0, 69825, '\p{^Scx=kthi}', "");
    Expect(0, 69825, '\P{Scx=kthi}', "");
    Expect(1, 69825, '\P{^Scx=kthi}', "");
    Expect(0, 69826, '\p{Scx=kthi}', "");
    Expect(1, 69826, '\p{^Scx=kthi}', "");
    Expect(1, 69826, '\P{Scx=kthi}', "");
    Expect(0, 69826, '\P{^Scx=kthi}', "");
    Expect(1, 69825, '\p{Scx=__Kthi}', "");
    Expect(0, 69825, '\p{^Scx=__Kthi}', "");
    Expect(0, 69825, '\P{Scx=__Kthi}', "");
    Expect(1, 69825, '\P{^Scx=__Kthi}', "");
    Expect(0, 69826, '\p{Scx=__Kthi}', "");
    Expect(1, 69826, '\p{^Scx=__Kthi}', "");
    Expect(1, 69826, '\P{Scx=__Kthi}', "");
    Expect(0, 69826, '\P{^Scx=__Kthi}', "");
    Error('\p{Is_Script_Extensions=-	kaithi:=}');
    Error('\P{Is_Script_Extensions=-	kaithi:=}');
    Expect(1, 69825, '\p{Is_Script_Extensions=kaithi}', "");
    Expect(0, 69825, '\p{^Is_Script_Extensions=kaithi}', "");
    Expect(0, 69825, '\P{Is_Script_Extensions=kaithi}', "");
    Expect(1, 69825, '\P{^Is_Script_Extensions=kaithi}', "");
    Expect(0, 69826, '\p{Is_Script_Extensions=kaithi}', "");
    Expect(1, 69826, '\p{^Is_Script_Extensions=kaithi}', "");
    Expect(1, 69826, '\P{Is_Script_Extensions=kaithi}', "");
    Expect(0, 69826, '\P{^Is_Script_Extensions=kaithi}', "");
    Expect(1, 69825, '\p{Is_Script_Extensions= KAITHI}', "");
    Expect(0, 69825, '\p{^Is_Script_Extensions= KAITHI}', "");
    Expect(0, 69825, '\P{Is_Script_Extensions= KAITHI}', "");
    Expect(1, 69825, '\P{^Is_Script_Extensions= KAITHI}', "");
    Expect(0, 69826, '\p{Is_Script_Extensions= KAITHI}', "");
    Expect(1, 69826, '\p{^Is_Script_Extensions= KAITHI}', "");
    Expect(1, 69826, '\P{Is_Script_Extensions= KAITHI}', "");
    Expect(0, 69826, '\P{^Is_Script_Extensions= KAITHI}', "");
    Error('\p{Is_Scx=-/a/Kthi}');
    Error('\P{Is_Scx=-/a/Kthi}');
    Expect(1, 69825, '\p{Is_Scx=kthi}', "");
    Expect(0, 69825, '\p{^Is_Scx=kthi}', "");
    Expect(0, 69825, '\P{Is_Scx=kthi}', "");
    Expect(1, 69825, '\P{^Is_Scx=kthi}', "");
    Expect(0, 69826, '\p{Is_Scx=kthi}', "");
    Expect(1, 69826, '\p{^Is_Scx=kthi}', "");
    Expect(1, 69826, '\P{Is_Scx=kthi}', "");
    Expect(0, 69826, '\P{^Is_Scx=kthi}', "");
    Expect(1, 69825, '\p{Is_Scx= Kthi}', "");
    Expect(0, 69825, '\p{^Is_Scx= Kthi}', "");
    Expect(0, 69825, '\P{Is_Scx= Kthi}', "");
    Expect(1, 69825, '\P{^Is_Scx= Kthi}', "");
    Expect(0, 69826, '\p{Is_Scx= Kthi}', "");
    Expect(1, 69826, '\p{^Is_Scx= Kthi}', "");
    Expect(1, 69826, '\P{Is_Scx= Kthi}', "");
    Expect(0, 69826, '\P{^Is_Scx= Kthi}', "");
    Error('\p{Script_Extensions=/a/ _TAI_Tham}');
    Error('\P{Script_Extensions=/a/ _TAI_Tham}');
    Expect(1, 6829, '\p{Script_Extensions=taitham}', "");
    Expect(0, 6829, '\p{^Script_Extensions=taitham}', "");
    Expect(0, 6829, '\P{Script_Extensions=taitham}', "");
    Expect(1, 6829, '\P{^Script_Extensions=taitham}', "");
    Expect(0, 6830, '\p{Script_Extensions=taitham}', "");
    Expect(1, 6830, '\p{^Script_Extensions=taitham}', "");
    Expect(1, 6830, '\P{Script_Extensions=taitham}', "");
    Expect(0, 6830, '\P{^Script_Extensions=taitham}', "");
    Expect(1, 6829, '\p{Script_Extensions= _Tai_Tham}', "");
    Expect(0, 6829, '\p{^Script_Extensions= _Tai_Tham}', "");
    Expect(0, 6829, '\P{Script_Extensions= _Tai_Tham}', "");
    Expect(1, 6829, '\P{^Script_Extensions= _Tai_Tham}', "");
    Expect(0, 6830, '\p{Script_Extensions= _Tai_Tham}', "");
    Expect(1, 6830, '\p{^Script_Extensions= _Tai_Tham}', "");
    Expect(1, 6830, '\P{Script_Extensions= _Tai_Tham}', "");
    Expect(0, 6830, '\P{^Script_Extensions= _Tai_Tham}', "");
    Error('\p{Scx=-/a/lana}');
    Error('\P{Scx=-/a/lana}');
    Expect(1, 6829, '\p{Scx=lana}', "");
    Expect(0, 6829, '\p{^Scx=lana}', "");
    Expect(0, 6829, '\P{Scx=lana}', "");
    Expect(1, 6829, '\P{^Scx=lana}', "");
    Expect(0, 6830, '\p{Scx=lana}', "");
    Expect(1, 6830, '\p{^Scx=lana}', "");
    Expect(1, 6830, '\P{Scx=lana}', "");
    Expect(0, 6830, '\P{^Scx=lana}', "");
    Expect(1, 6829, '\p{Scx:	__lana}', "");
    Expect(0, 6829, '\p{^Scx:	__lana}', "");
    Expect(0, 6829, '\P{Scx:	__lana}', "");
    Expect(1, 6829, '\P{^Scx:	__lana}', "");
    Expect(0, 6830, '\p{Scx:	__lana}', "");
    Expect(1, 6830, '\p{^Scx:	__lana}', "");
    Expect(1, 6830, '\P{Scx:	__lana}', "");
    Expect(0, 6830, '\P{^Scx:	__lana}', "");
    Error('\p{Is_Script_Extensions= -TAI_THAM/a/}');
    Error('\P{Is_Script_Extensions= -TAI_THAM/a/}');
    Expect(1, 6829, '\p{Is_Script_Extensions:   taitham}', "");
    Expect(0, 6829, '\p{^Is_Script_Extensions:   taitham}', "");
    Expect(0, 6829, '\P{Is_Script_Extensions:   taitham}', "");
    Expect(1, 6829, '\P{^Is_Script_Extensions:   taitham}', "");
    Expect(0, 6830, '\p{Is_Script_Extensions:   taitham}', "");
    Expect(1, 6830, '\p{^Is_Script_Extensions:   taitham}', "");
    Expect(1, 6830, '\P{Is_Script_Extensions:   taitham}', "");
    Expect(0, 6830, '\P{^Is_Script_Extensions:   taitham}', "");
    Expect(1, 6829, '\p{Is_Script_Extensions=__tai_THAM}', "");
    Expect(0, 6829, '\p{^Is_Script_Extensions=__tai_THAM}', "");
    Expect(0, 6829, '\P{Is_Script_Extensions=__tai_THAM}', "");
    Expect(1, 6829, '\P{^Is_Script_Extensions=__tai_THAM}', "");
    Expect(0, 6830, '\p{Is_Script_Extensions=__tai_THAM}', "");
    Expect(1, 6830, '\p{^Is_Script_Extensions=__tai_THAM}', "");
    Expect(1, 6830, '\P{Is_Script_Extensions=__tai_THAM}', "");
    Expect(0, 6830, '\P{^Is_Script_Extensions=__tai_THAM}', "");
    Error('\p{Is_Scx=		Lana/a/}');
    Error('\P{Is_Scx=		Lana/a/}');
    Expect(1, 6829, '\p{Is_Scx:	lana}', "");
    Expect(0, 6829, '\p{^Is_Scx:	lana}', "");
    Expect(0, 6829, '\P{Is_Scx:	lana}', "");
    Expect(1, 6829, '\P{^Is_Scx:	lana}', "");
    Expect(0, 6830, '\p{Is_Scx:	lana}', "");
    Expect(1, 6830, '\p{^Is_Scx:	lana}', "");
    Expect(1, 6830, '\P{Is_Scx:	lana}', "");
    Expect(0, 6830, '\P{^Is_Scx:	lana}', "");
    Expect(1, 6829, '\p{Is_Scx=Lana}', "");
    Expect(0, 6829, '\p{^Is_Scx=Lana}', "");
    Expect(0, 6829, '\P{Is_Scx=Lana}', "");
    Expect(1, 6829, '\P{^Is_Scx=Lana}', "");
    Expect(0, 6830, '\p{Is_Scx=Lana}', "");
    Expect(1, 6830, '\p{^Is_Scx=Lana}', "");
    Expect(1, 6830, '\P{Is_Scx=Lana}', "");
    Expect(0, 6830, '\P{^Is_Scx=Lana}', "");
    Error('\p{Script_Extensions=	:=Lao}');
    Error('\P{Script_Extensions=	:=Lao}');
    Expect(1, 3807, '\p{Script_Extensions=lao}', "");
    Expect(0, 3807, '\p{^Script_Extensions=lao}', "");
    Expect(0, 3807, '\P{Script_Extensions=lao}', "");
    Expect(1, 3807, '\P{^Script_Extensions=lao}', "");
    Expect(0, 3808, '\p{Script_Extensions=lao}', "");
    Expect(1, 3808, '\p{^Script_Extensions=lao}', "");
    Expect(1, 3808, '\P{Script_Extensions=lao}', "");
    Expect(0, 3808, '\P{^Script_Extensions=lao}', "");
    Expect(1, 3807, '\p{Script_Extensions=_lao}', "");
    Expect(0, 3807, '\p{^Script_Extensions=_lao}', "");
    Expect(0, 3807, '\P{Script_Extensions=_lao}', "");
    Expect(1, 3807, '\P{^Script_Extensions=_lao}', "");
    Expect(0, 3808, '\p{Script_Extensions=_lao}', "");
    Expect(1, 3808, '\p{^Script_Extensions=_lao}', "");
    Expect(1, 3808, '\P{Script_Extensions=_lao}', "");
    Expect(0, 3808, '\P{^Script_Extensions=_lao}', "");
    Error('\p{Scx:LAOO:=}');
    Error('\P{Scx:LAOO:=}');
    Expect(1, 3807, '\p{Scx=laoo}', "");
    Expect(0, 3807, '\p{^Scx=laoo}', "");
    Expect(0, 3807, '\P{Scx=laoo}', "");
    Expect(1, 3807, '\P{^Scx=laoo}', "");
    Expect(0, 3808, '\p{Scx=laoo}', "");
    Expect(1, 3808, '\p{^Scx=laoo}', "");
    Expect(1, 3808, '\P{Scx=laoo}', "");
    Expect(0, 3808, '\P{^Scx=laoo}', "");
    Expect(1, 3807, '\p{Scx=	 LAOO}', "");
    Expect(0, 3807, '\p{^Scx=	 LAOO}', "");
    Expect(0, 3807, '\P{Scx=	 LAOO}', "");
    Expect(1, 3807, '\P{^Scx=	 LAOO}', "");
    Expect(0, 3808, '\p{Scx=	 LAOO}', "");
    Expect(1, 3808, '\p{^Scx=	 LAOO}', "");
    Expect(1, 3808, '\P{Scx=	 LAOO}', "");
    Expect(0, 3808, '\P{^Scx=	 LAOO}', "");
    Error('\p{Is_Script_Extensions=-:=Lao}');
    Error('\P{Is_Script_Extensions=-:=Lao}');
    Expect(1, 3807, '\p{Is_Script_Extensions=lao}', "");
    Expect(0, 3807, '\p{^Is_Script_Extensions=lao}', "");
    Expect(0, 3807, '\P{Is_Script_Extensions=lao}', "");
    Expect(1, 3807, '\P{^Is_Script_Extensions=lao}', "");
    Expect(0, 3808, '\p{Is_Script_Extensions=lao}', "");
    Expect(1, 3808, '\p{^Is_Script_Extensions=lao}', "");
    Expect(1, 3808, '\P{Is_Script_Extensions=lao}', "");
    Expect(0, 3808, '\P{^Is_Script_Extensions=lao}', "");
    Expect(1, 3807, '\p{Is_Script_Extensions: -Lao}', "");
    Expect(0, 3807, '\p{^Is_Script_Extensions: -Lao}', "");
    Expect(0, 3807, '\P{Is_Script_Extensions: -Lao}', "");
    Expect(1, 3807, '\P{^Is_Script_Extensions: -Lao}', "");
    Expect(0, 3808, '\p{Is_Script_Extensions: -Lao}', "");
    Expect(1, 3808, '\p{^Is_Script_Extensions: -Lao}', "");
    Expect(1, 3808, '\P{Is_Script_Extensions: -Lao}', "");
    Expect(0, 3808, '\P{^Is_Script_Extensions: -Lao}', "");
    Error('\p{Is_Scx=	 LAOO/a/}');
    Error('\P{Is_Scx=	 LAOO/a/}');
    Expect(1, 3807, '\p{Is_Scx=laoo}', "");
    Expect(0, 3807, '\p{^Is_Scx=laoo}', "");
    Expect(0, 3807, '\P{Is_Scx=laoo}', "");
    Expect(1, 3807, '\P{^Is_Scx=laoo}', "");
    Expect(0, 3808, '\p{Is_Scx=laoo}', "");
    Expect(1, 3808, '\p{^Is_Scx=laoo}', "");
    Expect(1, 3808, '\P{Is_Scx=laoo}', "");
    Expect(0, 3808, '\P{^Is_Scx=laoo}', "");
    Expect(1, 3807, '\p{Is_Scx=_LAOO}', "");
    Expect(0, 3807, '\p{^Is_Scx=_LAOO}', "");
    Expect(0, 3807, '\P{Is_Scx=_LAOO}', "");
    Expect(1, 3807, '\P{^Is_Scx=_LAOO}', "");
    Expect(0, 3808, '\p{Is_Scx=_LAOO}', "");
    Expect(1, 3808, '\p{^Is_Scx=_LAOO}', "");
    Expect(1, 3808, '\P{Is_Scx=_LAOO}', "");
    Expect(0, 3808, '\P{^Is_Scx=_LAOO}', "");
    Error('\p{Script_Extensions= /a/Latin}');
    Error('\P{Script_Extensions= /a/Latin}');
    Expect(1, 65370, '\p{Script_Extensions=latin}', "");
    Expect(0, 65370, '\p{^Script_Extensions=latin}', "");
    Expect(0, 65370, '\P{Script_Extensions=latin}', "");
    Expect(1, 65370, '\P{^Script_Extensions=latin}', "");
    Expect(0, 65371, '\p{Script_Extensions=latin}', "");
    Expect(1, 65371, '\p{^Script_Extensions=latin}', "");
    Expect(1, 65371, '\P{Script_Extensions=latin}', "");
    Expect(0, 65371, '\P{^Script_Extensions=latin}', "");
    Expect(1, 65370, '\p{Script_Extensions= -Latin}', "");
    Expect(0, 65370, '\p{^Script_Extensions= -Latin}', "");
    Expect(0, 65370, '\P{Script_Extensions= -Latin}', "");
    Expect(1, 65370, '\P{^Script_Extensions= -Latin}', "");
    Expect(0, 65371, '\p{Script_Extensions= -Latin}', "");
    Expect(1, 65371, '\p{^Script_Extensions= -Latin}', "");
    Expect(1, 65371, '\P{Script_Extensions= -Latin}', "");
    Expect(0, 65371, '\P{^Script_Extensions= -Latin}', "");
    Error('\p{Scx=_Latn:=}');
    Error('\P{Scx=_Latn:=}');
    Expect(1, 65370, '\p{Scx=latn}', "");
    Expect(0, 65370, '\p{^Scx=latn}', "");
    Expect(0, 65370, '\P{Scx=latn}', "");
    Expect(1, 65370, '\P{^Scx=latn}', "");
    Expect(0, 65371, '\p{Scx=latn}', "");
    Expect(1, 65371, '\p{^Scx=latn}', "");
    Expect(1, 65371, '\P{Scx=latn}', "");
    Expect(0, 65371, '\P{^Scx=latn}', "");
    Expect(1, 65370, '\p{Scx=	 Latn}', "");
    Expect(0, 65370, '\p{^Scx=	 Latn}', "");
    Expect(0, 65370, '\P{Scx=	 Latn}', "");
    Expect(1, 65370, '\P{^Scx=	 Latn}', "");
    Expect(0, 65371, '\p{Scx=	 Latn}', "");
    Expect(1, 65371, '\p{^Scx=	 Latn}', "");
    Expect(1, 65371, '\P{Scx=	 Latn}', "");
    Expect(0, 65371, '\P{^Scx=	 Latn}', "");
    Error('\p{Is_Script_Extensions=:=		Latin}');
    Error('\P{Is_Script_Extensions=:=		Latin}');
    Expect(1, 65370, '\p{Is_Script_Extensions=latin}', "");
    Expect(0, 65370, '\p{^Is_Script_Extensions=latin}', "");
    Expect(0, 65370, '\P{Is_Script_Extensions=latin}', "");
    Expect(1, 65370, '\P{^Is_Script_Extensions=latin}', "");
    Expect(0, 65371, '\p{Is_Script_Extensions=latin}', "");
    Expect(1, 65371, '\p{^Is_Script_Extensions=latin}', "");
    Expect(1, 65371, '\P{Is_Script_Extensions=latin}', "");
    Expect(0, 65371, '\P{^Is_Script_Extensions=latin}', "");
    Expect(1, 65370, '\p{Is_Script_Extensions=_Latin}', "");
    Expect(0, 65370, '\p{^Is_Script_Extensions=_Latin}', "");
    Expect(0, 65370, '\P{Is_Script_Extensions=_Latin}', "");
    Expect(1, 65370, '\P{^Is_Script_Extensions=_Latin}', "");
    Expect(0, 65371, '\p{Is_Script_Extensions=_Latin}', "");
    Expect(1, 65371, '\p{^Is_Script_Extensions=_Latin}', "");
    Expect(1, 65371, '\P{Is_Script_Extensions=_Latin}', "");
    Expect(0, 65371, '\P{^Is_Script_Extensions=_Latin}', "");
    Error('\p{Is_Scx= -Latn/a/}');
    Error('\P{Is_Scx= -Latn/a/}');
    Expect(1, 65370, '\p{Is_Scx=latn}', "");
    Expect(0, 65370, '\p{^Is_Scx=latn}', "");
    Expect(0, 65370, '\P{Is_Scx=latn}', "");
    Expect(1, 65370, '\P{^Is_Scx=latn}', "");
    Expect(0, 65371, '\p{Is_Scx=latn}', "");
    Expect(1, 65371, '\p{^Is_Scx=latn}', "");
    Expect(1, 65371, '\P{Is_Scx=latn}', "");
    Expect(0, 65371, '\P{^Is_Scx=latn}', "");
    Expect(1, 65370, '\p{Is_Scx=-Latn}', "");
    Expect(0, 65370, '\p{^Is_Scx=-Latn}', "");
    Expect(0, 65370, '\P{Is_Scx=-Latn}', "");
    Expect(1, 65370, '\P{^Is_Scx=-Latn}', "");
    Expect(0, 65371, '\p{Is_Scx=-Latn}', "");
    Expect(1, 65371, '\p{^Is_Scx=-Latn}', "");
    Expect(1, 65371, '\P{Is_Scx=-Latn}', "");
    Expect(0, 65371, '\P{^Is_Scx=-Latn}', "");
    Error('\p{Script_Extensions=-	Lepcha/a/}');
    Error('\P{Script_Extensions=-	Lepcha/a/}');
    Expect(1, 7247, '\p{Script_Extensions=lepcha}', "");
    Expect(0, 7247, '\p{^Script_Extensions=lepcha}', "");
    Expect(0, 7247, '\P{Script_Extensions=lepcha}', "");
    Expect(1, 7247, '\P{^Script_Extensions=lepcha}', "");
    Expect(0, 7248, '\p{Script_Extensions=lepcha}', "");
    Expect(1, 7248, '\p{^Script_Extensions=lepcha}', "");
    Expect(1, 7248, '\P{Script_Extensions=lepcha}', "");
    Expect(0, 7248, '\P{^Script_Extensions=lepcha}', "");
    Expect(1, 7247, '\p{Script_Extensions=	Lepcha}', "");
    Expect(0, 7247, '\p{^Script_Extensions=	Lepcha}', "");
    Expect(0, 7247, '\P{Script_Extensions=	Lepcha}', "");
    Expect(1, 7247, '\P{^Script_Extensions=	Lepcha}', "");
    Expect(0, 7248, '\p{Script_Extensions=	Lepcha}', "");
    Expect(1, 7248, '\p{^Script_Extensions=	Lepcha}', "");
    Expect(1, 7248, '\P{Script_Extensions=	Lepcha}', "");
    Expect(0, 7248, '\P{^Script_Extensions=	Lepcha}', "");
    Error('\p{Scx= /a/LEPC}');
    Error('\P{Scx= /a/LEPC}');
    Expect(1, 7247, '\p{Scx=lepc}', "");
    Expect(0, 7247, '\p{^Scx=lepc}', "");
    Expect(0, 7247, '\P{Scx=lepc}', "");
    Expect(1, 7247, '\P{^Scx=lepc}', "");
    Expect(0, 7248, '\p{Scx=lepc}', "");
    Expect(1, 7248, '\p{^Scx=lepc}', "");
    Expect(1, 7248, '\P{Scx=lepc}', "");
    Expect(0, 7248, '\P{^Scx=lepc}', "");
    Expect(1, 7247, '\p{Scx=_ lepc}', "");
    Expect(0, 7247, '\p{^Scx=_ lepc}', "");
    Expect(0, 7247, '\P{Scx=_ lepc}', "");
    Expect(1, 7247, '\P{^Scx=_ lepc}', "");
    Expect(0, 7248, '\p{Scx=_ lepc}', "");
    Expect(1, 7248, '\p{^Scx=_ lepc}', "");
    Expect(1, 7248, '\P{Scx=_ lepc}', "");
    Expect(0, 7248, '\P{^Scx=_ lepc}', "");
    Error('\p{Is_Script_Extensions=_:=Lepcha}');
    Error('\P{Is_Script_Extensions=_:=Lepcha}');
    Expect(1, 7247, '\p{Is_Script_Extensions=lepcha}', "");
    Expect(0, 7247, '\p{^Is_Script_Extensions=lepcha}', "");
    Expect(0, 7247, '\P{Is_Script_Extensions=lepcha}', "");
    Expect(1, 7247, '\P{^Is_Script_Extensions=lepcha}', "");
    Expect(0, 7248, '\p{Is_Script_Extensions=lepcha}', "");
    Expect(1, 7248, '\p{^Is_Script_Extensions=lepcha}', "");
    Expect(1, 7248, '\P{Is_Script_Extensions=lepcha}', "");
    Expect(0, 7248, '\P{^Is_Script_Extensions=lepcha}', "");
    Expect(1, 7247, '\p{Is_Script_Extensions=	Lepcha}', "");
    Expect(0, 7247, '\p{^Is_Script_Extensions=	Lepcha}', "");
    Expect(0, 7247, '\P{Is_Script_Extensions=	Lepcha}', "");
    Expect(1, 7247, '\P{^Is_Script_Extensions=	Lepcha}', "");
    Expect(0, 7248, '\p{Is_Script_Extensions=	Lepcha}', "");
    Expect(1, 7248, '\p{^Is_Script_Extensions=	Lepcha}', "");
    Expect(1, 7248, '\P{Is_Script_Extensions=	Lepcha}', "");
    Expect(0, 7248, '\P{^Is_Script_Extensions=	Lepcha}', "");
    Error('\p{Is_Scx=Lepc/a/}');
    Error('\P{Is_Scx=Lepc/a/}');
    Expect(1, 7247, '\p{Is_Scx=lepc}', "");
    Expect(0, 7247, '\p{^Is_Scx=lepc}', "");
    Expect(0, 7247, '\P{Is_Scx=lepc}', "");
    Expect(1, 7247, '\P{^Is_Scx=lepc}', "");
    Expect(0, 7248, '\p{Is_Scx=lepc}', "");
    Expect(1, 7248, '\p{^Is_Scx=lepc}', "");
    Expect(1, 7248, '\P{Is_Scx=lepc}', "");
    Expect(0, 7248, '\P{^Is_Scx=lepc}', "");
    Expect(1, 7247, '\p{Is_Scx=	LEPC}', "");
    Expect(0, 7247, '\p{^Is_Scx=	LEPC}', "");
    Expect(0, 7247, '\P{Is_Scx=	LEPC}', "");
    Expect(1, 7247, '\P{^Is_Scx=	LEPC}', "");
    Expect(0, 7248, '\p{Is_Scx=	LEPC}', "");
    Expect(1, 7248, '\p{^Is_Scx=	LEPC}', "");
    Expect(1, 7248, '\P{Is_Scx=	LEPC}', "");
    Expect(0, 7248, '\P{^Is_Scx=	LEPC}', "");
    Error('\p{Script_Extensions= -LIMBU/a/}');
    Error('\P{Script_Extensions= -LIMBU/a/}');
    Expect(1, 6479, '\p{Script_Extensions=limbu}', "");
    Expect(0, 6479, '\p{^Script_Extensions=limbu}', "");
    Expect(0, 6479, '\P{Script_Extensions=limbu}', "");
    Expect(1, 6479, '\P{^Script_Extensions=limbu}', "");
    Expect(0, 6480, '\p{Script_Extensions=limbu}', "");
    Expect(1, 6480, '\p{^Script_Extensions=limbu}', "");
    Expect(1, 6480, '\P{Script_Extensions=limbu}', "");
    Expect(0, 6480, '\P{^Script_Extensions=limbu}', "");
    Expect(1, 6479, '\p{Script_Extensions:   _ LIMBU}', "");
    Expect(0, 6479, '\p{^Script_Extensions:   _ LIMBU}', "");
    Expect(0, 6479, '\P{Script_Extensions:   _ LIMBU}', "");
    Expect(1, 6479, '\P{^Script_Extensions:   _ LIMBU}', "");
    Expect(0, 6480, '\p{Script_Extensions:   _ LIMBU}', "");
    Expect(1, 6480, '\p{^Script_Extensions:   _ LIMBU}', "");
    Expect(1, 6480, '\P{Script_Extensions:   _ LIMBU}', "");
    Expect(0, 6480, '\P{^Script_Extensions:   _ LIMBU}', "");
    Error('\p{Scx=:=Limb}');
    Error('\P{Scx=:=Limb}');
    Expect(1, 6479, '\p{Scx=limb}', "");
    Expect(0, 6479, '\p{^Scx=limb}', "");
    Expect(0, 6479, '\P{Scx=limb}', "");
    Expect(1, 6479, '\P{^Scx=limb}', "");
    Expect(0, 6480, '\p{Scx=limb}', "");
    Expect(1, 6480, '\p{^Scx=limb}', "");
    Expect(1, 6480, '\P{Scx=limb}', "");
    Expect(0, 6480, '\P{^Scx=limb}', "");
    Expect(1, 6479, '\p{Scx=	 Limb}', "");
    Expect(0, 6479, '\p{^Scx=	 Limb}', "");
    Expect(0, 6479, '\P{Scx=	 Limb}', "");
    Expect(1, 6479, '\P{^Scx=	 Limb}', "");
    Expect(0, 6480, '\p{Scx=	 Limb}', "");
    Expect(1, 6480, '\p{^Scx=	 Limb}', "");
    Expect(1, 6480, '\P{Scx=	 Limb}', "");
    Expect(0, 6480, '\P{^Scx=	 Limb}', "");
    Error('\p{Is_Script_Extensions= _LIMBU/a/}');
    Error('\P{Is_Script_Extensions= _LIMBU/a/}');
    Expect(1, 6479, '\p{Is_Script_Extensions=limbu}', "");
    Expect(0, 6479, '\p{^Is_Script_Extensions=limbu}', "");
    Expect(0, 6479, '\P{Is_Script_Extensions=limbu}', "");
    Expect(1, 6479, '\P{^Is_Script_Extensions=limbu}', "");
    Expect(0, 6480, '\p{Is_Script_Extensions=limbu}', "");
    Expect(1, 6480, '\p{^Is_Script_Extensions=limbu}', "");
    Expect(1, 6480, '\P{Is_Script_Extensions=limbu}', "");
    Expect(0, 6480, '\P{^Is_Script_Extensions=limbu}', "");
    Expect(1, 6479, '\p{Is_Script_Extensions:	 -Limbu}', "");
    Expect(0, 6479, '\p{^Is_Script_Extensions:	 -Limbu}', "");
    Expect(0, 6479, '\P{Is_Script_Extensions:	 -Limbu}', "");
    Expect(1, 6479, '\P{^Is_Script_Extensions:	 -Limbu}', "");
    Expect(0, 6480, '\p{Is_Script_Extensions:	 -Limbu}', "");
    Expect(1, 6480, '\p{^Is_Script_Extensions:	 -Limbu}', "");
    Expect(1, 6480, '\P{Is_Script_Extensions:	 -Limbu}', "");
    Expect(0, 6480, '\P{^Is_Script_Extensions:	 -Limbu}', "");
    Error('\p{Is_Scx= Limb/a/}');
    Error('\P{Is_Scx= Limb/a/}');
    Expect(1, 6479, '\p{Is_Scx:limb}', "");
    Expect(0, 6479, '\p{^Is_Scx:limb}', "");
    Expect(0, 6479, '\P{Is_Scx:limb}', "");
    Expect(1, 6479, '\P{^Is_Scx:limb}', "");
    Expect(0, 6480, '\p{Is_Scx:limb}', "");
    Expect(1, 6480, '\p{^Is_Scx:limb}', "");
    Expect(1, 6480, '\P{Is_Scx:limb}', "");
    Expect(0, 6480, '\P{^Is_Scx:limb}', "");
    Expect(1, 6479, '\p{Is_Scx=_LIMB}', "");
    Expect(0, 6479, '\p{^Is_Scx=_LIMB}', "");
    Expect(0, 6479, '\P{Is_Scx=_LIMB}', "");
    Expect(1, 6479, '\P{^Is_Scx=_LIMB}', "");
    Expect(0, 6480, '\p{Is_Scx=_LIMB}', "");
    Expect(1, 6480, '\p{^Is_Scx=_LIMB}', "");
    Expect(1, 6480, '\P{Is_Scx=_LIMB}', "");
    Expect(0, 6480, '\P{^Is_Scx=_LIMB}', "");
    Error('\p{Script_Extensions=_/a/Linear_A}');
    Error('\P{Script_Extensions=_/a/Linear_A}');
    Expect(1, 67431, '\p{Script_Extensions: lineara}', "");
    Expect(0, 67431, '\p{^Script_Extensions: lineara}', "");
    Expect(0, 67431, '\P{Script_Extensions: lineara}', "");
    Expect(1, 67431, '\P{^Script_Extensions: lineara}', "");
    Expect(0, 67432, '\p{Script_Extensions: lineara}', "");
    Expect(1, 67432, '\p{^Script_Extensions: lineara}', "");
    Expect(1, 67432, '\P{Script_Extensions: lineara}', "");
    Expect(0, 67432, '\P{^Script_Extensions: lineara}', "");
    Expect(1, 67431, '\p{Script_Extensions=- LINEAR_A}', "");
    Expect(0, 67431, '\p{^Script_Extensions=- LINEAR_A}', "");
    Expect(0, 67431, '\P{Script_Extensions=- LINEAR_A}', "");
    Expect(1, 67431, '\P{^Script_Extensions=- LINEAR_A}', "");
    Expect(0, 67432, '\p{Script_Extensions=- LINEAR_A}', "");
    Expect(1, 67432, '\p{^Script_Extensions=- LINEAR_A}', "");
    Expect(1, 67432, '\P{Script_Extensions=- LINEAR_A}', "");
    Expect(0, 67432, '\P{^Script_Extensions=- LINEAR_A}', "");
    Error('\p{Scx=	:=lina}');
    Error('\P{Scx=	:=lina}');
    Expect(1, 67431, '\p{Scx=lina}', "");
    Expect(0, 67431, '\p{^Scx=lina}', "");
    Expect(0, 67431, '\P{Scx=lina}', "");
    Expect(1, 67431, '\P{^Scx=lina}', "");
    Expect(0, 67432, '\p{Scx=lina}', "");
    Expect(1, 67432, '\p{^Scx=lina}', "");
    Expect(1, 67432, '\P{Scx=lina}', "");
    Expect(0, 67432, '\P{^Scx=lina}', "");
    Expect(1, 67431, '\p{Scx=Lina}', "");
    Expect(0, 67431, '\p{^Scx=Lina}', "");
    Expect(0, 67431, '\P{Scx=Lina}', "");
    Expect(1, 67431, '\P{^Scx=Lina}', "");
    Expect(0, 67432, '\p{Scx=Lina}', "");
    Expect(1, 67432, '\p{^Scx=Lina}', "");
    Expect(1, 67432, '\P{Scx=Lina}', "");
    Expect(0, 67432, '\P{^Scx=Lina}', "");
    Error('\p{Is_Script_Extensions=_:=linear_a}');
    Error('\P{Is_Script_Extensions=_:=linear_a}');
    Expect(1, 67431, '\p{Is_Script_Extensions:	lineara}', "");
    Expect(0, 67431, '\p{^Is_Script_Extensions:	lineara}', "");
    Expect(0, 67431, '\P{Is_Script_Extensions:	lineara}', "");
    Expect(1, 67431, '\P{^Is_Script_Extensions:	lineara}', "");
    Expect(0, 67432, '\p{Is_Script_Extensions:	lineara}', "");
    Expect(1, 67432, '\p{^Is_Script_Extensions:	lineara}', "");
    Expect(1, 67432, '\P{Is_Script_Extensions:	lineara}', "");
    Expect(0, 67432, '\P{^Is_Script_Extensions:	lineara}', "");
    Expect(1, 67431, '\p{Is_Script_Extensions=_	LINEAR_A}', "");
    Expect(0, 67431, '\p{^Is_Script_Extensions=_	LINEAR_A}', "");
    Expect(0, 67431, '\P{Is_Script_Extensions=_	LINEAR_A}', "");
    Expect(1, 67431, '\P{^Is_Script_Extensions=_	LINEAR_A}', "");
    Expect(0, 67432, '\p{Is_Script_Extensions=_	LINEAR_A}', "");
    Expect(1, 67432, '\p{^Is_Script_Extensions=_	LINEAR_A}', "");
    Expect(1, 67432, '\P{Is_Script_Extensions=_	LINEAR_A}', "");
    Expect(0, 67432, '\P{^Is_Script_Extensions=_	LINEAR_A}', "");
    Error('\p{Is_Scx=	lina/a/}');
    Error('\P{Is_Scx=	lina/a/}');
    Expect(1, 67431, '\p{Is_Scx=lina}', "");
    Expect(0, 67431, '\p{^Is_Scx=lina}', "");
    Expect(0, 67431, '\P{Is_Scx=lina}', "");
    Expect(1, 67431, '\P{^Is_Scx=lina}', "");
    Expect(0, 67432, '\p{Is_Scx=lina}', "");
    Expect(1, 67432, '\p{^Is_Scx=lina}', "");
    Expect(1, 67432, '\P{Is_Scx=lina}', "");
    Expect(0, 67432, '\P{^Is_Scx=lina}', "");
    Expect(1, 67431, '\p{Is_Scx=_-Lina}', "");
    Expect(0, 67431, '\p{^Is_Scx=_-Lina}', "");
    Expect(0, 67431, '\P{Is_Scx=_-Lina}', "");
    Expect(1, 67431, '\P{^Is_Scx=_-Lina}', "");
    Expect(0, 67432, '\p{Is_Scx=_-Lina}', "");
    Expect(1, 67432, '\p{^Is_Scx=_-Lina}', "");
    Expect(1, 67432, '\P{Is_Scx=_-Lina}', "");
    Expect(0, 67432, '\P{^Is_Scx=_-Lina}', "");
    Error('\p{Script_Extensions=/a/-Linear_b}');
    Error('\P{Script_Extensions=/a/-Linear_b}');
    Expect(1, 65855, '\p{Script_Extensions=linearb}', "");
    Expect(0, 65855, '\p{^Script_Extensions=linearb}', "");
    Expect(0, 65855, '\P{Script_Extensions=linearb}', "");
    Expect(1, 65855, '\P{^Script_Extensions=linearb}', "");
    Expect(0, 65856, '\p{Script_Extensions=linearb}', "");
    Expect(1, 65856, '\p{^Script_Extensions=linearb}', "");
    Expect(1, 65856, '\P{Script_Extensions=linearb}', "");
    Expect(0, 65856, '\P{^Script_Extensions=linearb}', "");
    Expect(1, 65855, '\p{Script_Extensions: 	Linear_B}', "");
    Expect(0, 65855, '\p{^Script_Extensions: 	Linear_B}', "");
    Expect(0, 65855, '\P{Script_Extensions: 	Linear_B}', "");
    Expect(1, 65855, '\P{^Script_Extensions: 	Linear_B}', "");
    Expect(0, 65856, '\p{Script_Extensions: 	Linear_B}', "");
    Expect(1, 65856, '\p{^Script_Extensions: 	Linear_B}', "");
    Expect(1, 65856, '\P{Script_Extensions: 	Linear_B}', "");
    Expect(0, 65856, '\P{^Script_Extensions: 	Linear_B}', "");
    Error('\p{Scx=/a/_Linb}');
    Error('\P{Scx=/a/_Linb}');
    Expect(1, 65855, '\p{Scx=linb}', "");
    Expect(0, 65855, '\p{^Scx=linb}', "");
    Expect(0, 65855, '\P{Scx=linb}', "");
    Expect(1, 65855, '\P{^Scx=linb}', "");
    Expect(0, 65856, '\p{Scx=linb}', "");
    Expect(1, 65856, '\p{^Scx=linb}', "");
    Expect(1, 65856, '\P{Scx=linb}', "");
    Expect(0, 65856, '\P{^Scx=linb}', "");
    Expect(1, 65855, '\p{Scx= LINB}', "");
    Expect(0, 65855, '\p{^Scx= LINB}', "");
    Expect(0, 65855, '\P{Scx= LINB}', "");
    Expect(1, 65855, '\P{^Scx= LINB}', "");
    Expect(0, 65856, '\p{Scx= LINB}', "");
    Expect(1, 65856, '\p{^Scx= LINB}', "");
    Expect(1, 65856, '\P{Scx= LINB}', "");
    Expect(0, 65856, '\P{^Scx= LINB}', "");
    Error('\p{Is_Script_Extensions=:= -linear_B}');
    Error('\P{Is_Script_Extensions=:= -linear_B}');
    Expect(1, 65855, '\p{Is_Script_Extensions=linearb}', "");
    Expect(0, 65855, '\p{^Is_Script_Extensions=linearb}', "");
    Expect(0, 65855, '\P{Is_Script_Extensions=linearb}', "");
    Expect(1, 65855, '\P{^Is_Script_Extensions=linearb}', "");
    Expect(0, 65856, '\p{Is_Script_Extensions=linearb}', "");
    Expect(1, 65856, '\p{^Is_Script_Extensions=linearb}', "");
    Expect(1, 65856, '\P{Is_Script_Extensions=linearb}', "");
    Expect(0, 65856, '\P{^Is_Script_Extensions=linearb}', "");
    Expect(1, 65855, '\p{Is_Script_Extensions=	-linear_B}', "");
    Expect(0, 65855, '\p{^Is_Script_Extensions=	-linear_B}', "");
    Expect(0, 65855, '\P{Is_Script_Extensions=	-linear_B}', "");
    Expect(1, 65855, '\P{^Is_Script_Extensions=	-linear_B}', "");
    Expect(0, 65856, '\p{Is_Script_Extensions=	-linear_B}', "");
    Expect(1, 65856, '\p{^Is_Script_Extensions=	-linear_B}', "");
    Expect(1, 65856, '\P{Is_Script_Extensions=	-linear_B}', "");
    Expect(0, 65856, '\P{^Is_Script_Extensions=	-linear_B}', "");
    Error('\p{Is_Scx= -linb:=}');
    Error('\P{Is_Scx= -linb:=}');
    Expect(1, 65855, '\p{Is_Scx:	linb}', "");
    Expect(0, 65855, '\p{^Is_Scx:	linb}', "");
    Expect(0, 65855, '\P{Is_Scx:	linb}', "");
    Expect(1, 65855, '\P{^Is_Scx:	linb}', "");
    Expect(0, 65856, '\p{Is_Scx:	linb}', "");
    Expect(1, 65856, '\p{^Is_Scx:	linb}', "");
    Expect(1, 65856, '\P{Is_Scx:	linb}', "");
    Expect(0, 65856, '\P{^Is_Scx:	linb}', "");
    Expect(1, 65855, '\p{Is_Scx:		_LINB}', "");
    Expect(0, 65855, '\p{^Is_Scx:		_LINB}', "");
    Expect(0, 65855, '\P{Is_Scx:		_LINB}', "");
    Expect(1, 65855, '\P{^Is_Scx:		_LINB}', "");
    Expect(0, 65856, '\p{Is_Scx:		_LINB}', "");
    Expect(1, 65856, '\p{^Is_Scx:		_LINB}', "");
    Expect(1, 65856, '\P{Is_Scx:		_LINB}', "");
    Expect(0, 65856, '\P{^Is_Scx:		_LINB}', "");
    Error('\p{Script_Extensions=:=_ lisu}');
    Error('\P{Script_Extensions=:=_ lisu}');
    Expect(1, 42239, '\p{Script_Extensions=lisu}', "");
    Expect(0, 42239, '\p{^Script_Extensions=lisu}', "");
    Expect(0, 42239, '\P{Script_Extensions=lisu}', "");
    Expect(1, 42239, '\P{^Script_Extensions=lisu}', "");
    Expect(0, 42240, '\p{Script_Extensions=lisu}', "");
    Expect(1, 42240, '\p{^Script_Extensions=lisu}', "");
    Expect(1, 42240, '\P{Script_Extensions=lisu}', "");
    Expect(0, 42240, '\P{^Script_Extensions=lisu}', "");
    Expect(1, 42239, '\p{Script_Extensions=  Lisu}', "");
    Expect(0, 42239, '\p{^Script_Extensions=  Lisu}', "");
    Expect(0, 42239, '\P{Script_Extensions=  Lisu}', "");
    Expect(1, 42239, '\P{^Script_Extensions=  Lisu}', "");
    Expect(0, 42240, '\p{Script_Extensions=  Lisu}', "");
    Expect(1, 42240, '\p{^Script_Extensions=  Lisu}', "");
    Expect(1, 42240, '\P{Script_Extensions=  Lisu}', "");
    Expect(0, 42240, '\P{^Script_Extensions=  Lisu}', "");
    Error('\p{Scx=:=	_Lisu}');
    Error('\P{Scx=:=	_Lisu}');
    Expect(1, 42239, '\p{Scx=lisu}', "");
    Expect(0, 42239, '\p{^Scx=lisu}', "");
    Expect(0, 42239, '\P{Scx=lisu}', "");
    Expect(1, 42239, '\P{^Scx=lisu}', "");
    Expect(0, 42240, '\p{Scx=lisu}', "");
    Expect(1, 42240, '\p{^Scx=lisu}', "");
    Expect(1, 42240, '\P{Scx=lisu}', "");
    Expect(0, 42240, '\P{^Scx=lisu}', "");
    Expect(1, 42239, '\p{Scx=__lisu}', "");
    Expect(0, 42239, '\p{^Scx=__lisu}', "");
    Expect(0, 42239, '\P{Scx=__lisu}', "");
    Expect(1, 42239, '\P{^Scx=__lisu}', "");
    Expect(0, 42240, '\p{Scx=__lisu}', "");
    Expect(1, 42240, '\p{^Scx=__lisu}', "");
    Expect(1, 42240, '\P{Scx=__lisu}', "");
    Expect(0, 42240, '\P{^Scx=__lisu}', "");
    Error('\p{Is_Script_Extensions=/a/lisu}');
    Error('\P{Is_Script_Extensions=/a/lisu}');
    Expect(1, 42239, '\p{Is_Script_Extensions:lisu}', "");
    Expect(0, 42239, '\p{^Is_Script_Extensions:lisu}', "");
    Expect(0, 42239, '\P{Is_Script_Extensions:lisu}', "");
    Expect(1, 42239, '\P{^Is_Script_Extensions:lisu}', "");
    Expect(0, 42240, '\p{Is_Script_Extensions:lisu}', "");
    Expect(1, 42240, '\p{^Is_Script_Extensions:lisu}', "");
    Expect(1, 42240, '\P{Is_Script_Extensions:lisu}', "");
    Expect(0, 42240, '\P{^Is_Script_Extensions:lisu}', "");
    Expect(1, 42239, '\p{Is_Script_Extensions= lisu}', "");
    Expect(0, 42239, '\p{^Is_Script_Extensions= lisu}', "");
    Expect(0, 42239, '\P{Is_Script_Extensions= lisu}', "");
    Expect(1, 42239, '\P{^Is_Script_Extensions= lisu}', "");
    Expect(0, 42240, '\p{Is_Script_Extensions= lisu}', "");
    Expect(1, 42240, '\p{^Is_Script_Extensions= lisu}', "");
    Expect(1, 42240, '\P{Is_Script_Extensions= lisu}', "");
    Expect(0, 42240, '\P{^Is_Script_Extensions= lisu}', "");
    Error('\p{Is_Scx=:= 	Lisu}');
    Error('\P{Is_Scx=:= 	Lisu}');
    Expect(1, 42239, '\p{Is_Scx=lisu}', "");
    Expect(0, 42239, '\p{^Is_Scx=lisu}', "");
    Expect(0, 42239, '\P{Is_Scx=lisu}', "");
    Expect(1, 42239, '\P{^Is_Scx=lisu}', "");
    Expect(0, 42240, '\p{Is_Scx=lisu}', "");
    Expect(1, 42240, '\p{^Is_Scx=lisu}', "");
    Expect(1, 42240, '\P{Is_Scx=lisu}', "");
    Expect(0, 42240, '\P{^Is_Scx=lisu}', "");
    Expect(1, 42239, '\p{Is_Scx=-LISU}', "");
    Expect(0, 42239, '\p{^Is_Scx=-LISU}', "");
    Expect(0, 42239, '\P{Is_Scx=-LISU}', "");
    Expect(1, 42239, '\P{^Is_Scx=-LISU}', "");
    Expect(0, 42240, '\p{Is_Scx=-LISU}', "");
    Expect(1, 42240, '\p{^Is_Scx=-LISU}', "");
    Expect(1, 42240, '\P{Is_Scx=-LISU}', "");
    Expect(0, 42240, '\P{^Is_Scx=-LISU}', "");
    Error('\p{Script_Extensions=_:=LYCIAN}');
    Error('\P{Script_Extensions=_:=LYCIAN}');
    Expect(1, 66204, '\p{Script_Extensions=lycian}', "");
    Expect(0, 66204, '\p{^Script_Extensions=lycian}', "");
    Expect(0, 66204, '\P{Script_Extensions=lycian}', "");
    Expect(1, 66204, '\P{^Script_Extensions=lycian}', "");
    Expect(0, 66205, '\p{Script_Extensions=lycian}', "");
    Expect(1, 66205, '\p{^Script_Extensions=lycian}', "");
    Expect(1, 66205, '\P{Script_Extensions=lycian}', "");
    Expect(0, 66205, '\P{^Script_Extensions=lycian}', "");
    Expect(1, 66204, '\p{Script_Extensions=		Lycian}', "");
    Expect(0, 66204, '\p{^Script_Extensions=		Lycian}', "");
    Expect(0, 66204, '\P{Script_Extensions=		Lycian}', "");
    Expect(1, 66204, '\P{^Script_Extensions=		Lycian}', "");
    Expect(0, 66205, '\p{Script_Extensions=		Lycian}', "");
    Expect(1, 66205, '\p{^Script_Extensions=		Lycian}', "");
    Expect(1, 66205, '\P{Script_Extensions=		Lycian}', "");
    Expect(0, 66205, '\P{^Script_Extensions=		Lycian}', "");
    Error('\p{Scx=/a/Lyci}');
    Error('\P{Scx=/a/Lyci}');
    Expect(1, 66204, '\p{Scx:lyci}', "");
    Expect(0, 66204, '\p{^Scx:lyci}', "");
    Expect(0, 66204, '\P{Scx:lyci}', "");
    Expect(1, 66204, '\P{^Scx:lyci}', "");
    Expect(0, 66205, '\p{Scx:lyci}', "");
    Expect(1, 66205, '\p{^Scx:lyci}', "");
    Expect(1, 66205, '\P{Scx:lyci}', "");
    Expect(0, 66205, '\P{^Scx:lyci}', "");
    Expect(1, 66204, '\p{Scx=	 LYCI}', "");
    Expect(0, 66204, '\p{^Scx=	 LYCI}', "");
    Expect(0, 66204, '\P{Scx=	 LYCI}', "");
    Expect(1, 66204, '\P{^Scx=	 LYCI}', "");
    Expect(0, 66205, '\p{Scx=	 LYCI}', "");
    Expect(1, 66205, '\p{^Scx=	 LYCI}', "");
    Expect(1, 66205, '\P{Scx=	 LYCI}', "");
    Expect(0, 66205, '\P{^Scx=	 LYCI}', "");
    Error('\p{Is_Script_Extensions=	Lycian/a/}');
    Error('\P{Is_Script_Extensions=	Lycian/a/}');
    Expect(1, 66204, '\p{Is_Script_Extensions=lycian}', "");
    Expect(0, 66204, '\p{^Is_Script_Extensions=lycian}', "");
    Expect(0, 66204, '\P{Is_Script_Extensions=lycian}', "");
    Expect(1, 66204, '\P{^Is_Script_Extensions=lycian}', "");
    Expect(0, 66205, '\p{Is_Script_Extensions=lycian}', "");
    Expect(1, 66205, '\p{^Is_Script_Extensions=lycian}', "");
    Expect(1, 66205, '\P{Is_Script_Extensions=lycian}', "");
    Expect(0, 66205, '\P{^Is_Script_Extensions=lycian}', "");
    Expect(1, 66204, '\p{Is_Script_Extensions=Lycian}', "");
    Expect(0, 66204, '\p{^Is_Script_Extensions=Lycian}', "");
    Expect(0, 66204, '\P{Is_Script_Extensions=Lycian}', "");
    Expect(1, 66204, '\P{^Is_Script_Extensions=Lycian}', "");
    Expect(0, 66205, '\p{Is_Script_Extensions=Lycian}', "");
    Expect(1, 66205, '\p{^Is_Script_Extensions=Lycian}', "");
    Expect(1, 66205, '\P{Is_Script_Extensions=Lycian}', "");
    Expect(0, 66205, '\P{^Is_Script_Extensions=Lycian}', "");
    Error('\p{Is_Scx: _/a/Lyci}');
    Error('\P{Is_Scx: _/a/Lyci}');
    Expect(1, 66204, '\p{Is_Scx=lyci}', "");
    Expect(0, 66204, '\p{^Is_Scx=lyci}', "");
    Expect(0, 66204, '\P{Is_Scx=lyci}', "");
    Expect(1, 66204, '\P{^Is_Scx=lyci}', "");
    Expect(0, 66205, '\p{Is_Scx=lyci}', "");
    Expect(1, 66205, '\p{^Is_Scx=lyci}', "");
    Expect(1, 66205, '\P{Is_Scx=lyci}', "");
    Expect(0, 66205, '\P{^Is_Scx=lyci}', "");
    Expect(1, 66204, '\p{Is_Scx=  lyci}', "");
    Expect(0, 66204, '\p{^Is_Scx=  lyci}', "");
    Expect(0, 66204, '\P{Is_Scx=  lyci}', "");
    Expect(1, 66204, '\P{^Is_Scx=  lyci}', "");
    Expect(0, 66205, '\p{Is_Scx=  lyci}', "");
    Expect(1, 66205, '\p{^Is_Scx=  lyci}', "");
    Expect(1, 66205, '\P{Is_Scx=  lyci}', "");
    Expect(0, 66205, '\P{^Is_Scx=  lyci}', "");
    Error('\p{Script_Extensions=:=_ lydian}');
    Error('\P{Script_Extensions=:=_ lydian}');
    Expect(1, 67903, '\p{Script_Extensions=lydian}', "");
    Expect(0, 67903, '\p{^Script_Extensions=lydian}', "");
    Expect(0, 67903, '\P{Script_Extensions=lydian}', "");
    Expect(1, 67903, '\P{^Script_Extensions=lydian}', "");
    Expect(0, 67904, '\p{Script_Extensions=lydian}', "");
    Expect(1, 67904, '\p{^Script_Extensions=lydian}', "");
    Expect(1, 67904, '\P{Script_Extensions=lydian}', "");
    Expect(0, 67904, '\P{^Script_Extensions=lydian}', "");
    Expect(1, 67903, '\p{Script_Extensions= Lydian}', "");
    Expect(0, 67903, '\p{^Script_Extensions= Lydian}', "");
    Expect(0, 67903, '\P{Script_Extensions= Lydian}', "");
    Expect(1, 67903, '\P{^Script_Extensions= Lydian}', "");
    Expect(0, 67904, '\p{Script_Extensions= Lydian}', "");
    Expect(1, 67904, '\p{^Script_Extensions= Lydian}', "");
    Expect(1, 67904, '\P{Script_Extensions= Lydian}', "");
    Expect(0, 67904, '\P{^Script_Extensions= Lydian}', "");
    Error('\p{Scx=:=	_Lydi}');
    Error('\P{Scx=:=	_Lydi}');
    Expect(1, 67903, '\p{Scx=lydi}', "");
    Expect(0, 67903, '\p{^Scx=lydi}', "");
    Expect(0, 67903, '\P{Scx=lydi}', "");
    Expect(1, 67903, '\P{^Scx=lydi}', "");
    Expect(0, 67904, '\p{Scx=lydi}', "");
    Expect(1, 67904, '\p{^Scx=lydi}', "");
    Expect(1, 67904, '\P{Scx=lydi}', "");
    Expect(0, 67904, '\P{^Scx=lydi}', "");
    Expect(1, 67903, '\p{Scx: _Lydi}', "");
    Expect(0, 67903, '\p{^Scx: _Lydi}', "");
    Expect(0, 67903, '\P{Scx: _Lydi}', "");
    Expect(1, 67903, '\P{^Scx: _Lydi}', "");
    Expect(0, 67904, '\p{Scx: _Lydi}', "");
    Expect(1, 67904, '\p{^Scx: _Lydi}', "");
    Expect(1, 67904, '\P{Scx: _Lydi}', "");
    Expect(0, 67904, '\P{^Scx: _Lydi}', "");
    Error('\p{Is_Script_Extensions=/a/_lydian}');
    Error('\P{Is_Script_Extensions=/a/_lydian}');
    Expect(1, 67903, '\p{Is_Script_Extensions=lydian}', "");
    Expect(0, 67903, '\p{^Is_Script_Extensions=lydian}', "");
    Expect(0, 67903, '\P{Is_Script_Extensions=lydian}', "");
    Expect(1, 67903, '\P{^Is_Script_Extensions=lydian}', "");
    Expect(0, 67904, '\p{Is_Script_Extensions=lydian}', "");
    Expect(1, 67904, '\p{^Is_Script_Extensions=lydian}', "");
    Expect(1, 67904, '\P{Is_Script_Extensions=lydian}', "");
    Expect(0, 67904, '\P{^Is_Script_Extensions=lydian}', "");
    Expect(1, 67903, '\p{Is_Script_Extensions=-Lydian}', "");
    Expect(0, 67903, '\p{^Is_Script_Extensions=-Lydian}', "");
    Expect(0, 67903, '\P{Is_Script_Extensions=-Lydian}', "");
    Expect(1, 67903, '\P{^Is_Script_Extensions=-Lydian}', "");
    Expect(0, 67904, '\p{Is_Script_Extensions=-Lydian}', "");
    Expect(1, 67904, '\p{^Is_Script_Extensions=-Lydian}', "");
    Expect(1, 67904, '\P{Is_Script_Extensions=-Lydian}', "");
    Expect(0, 67904, '\P{^Is_Script_Extensions=-Lydian}', "");
    Error('\p{Is_Scx=/a/__Lydi}');
    Error('\P{Is_Scx=/a/__Lydi}');
    Expect(1, 67903, '\p{Is_Scx:	lydi}', "");
    Expect(0, 67903, '\p{^Is_Scx:	lydi}', "");
    Expect(0, 67903, '\P{Is_Scx:	lydi}', "");
    Expect(1, 67903, '\P{^Is_Scx:	lydi}', "");
    Expect(0, 67904, '\p{Is_Scx:	lydi}', "");
    Expect(1, 67904, '\p{^Is_Scx:	lydi}', "");
    Expect(1, 67904, '\P{Is_Scx:	lydi}', "");
    Expect(0, 67904, '\P{^Is_Scx:	lydi}', "");
    Expect(1, 67903, '\p{Is_Scx:- lydi}', "");
    Expect(0, 67903, '\p{^Is_Scx:- lydi}', "");
    Expect(0, 67903, '\P{Is_Scx:- lydi}', "");
    Expect(1, 67903, '\P{^Is_Scx:- lydi}', "");
    Expect(0, 67904, '\p{Is_Scx:- lydi}', "");
    Expect(1, 67904, '\p{^Is_Scx:- lydi}', "");
    Expect(1, 67904, '\P{Is_Scx:- lydi}', "");
    Expect(0, 67904, '\P{^Is_Scx:- lydi}', "");
    Error('\p{Script_Extensions=:=-_MAHAJANI}');
    Error('\P{Script_Extensions=:=-_MAHAJANI}');
    Expect(1, 70006, '\p{Script_Extensions: mahajani}', "");
    Expect(0, 70006, '\p{^Script_Extensions: mahajani}', "");
    Expect(0, 70006, '\P{Script_Extensions: mahajani}', "");
    Expect(1, 70006, '\P{^Script_Extensions: mahajani}', "");
    Expect(0, 70007, '\p{Script_Extensions: mahajani}', "");
    Expect(1, 70007, '\p{^Script_Extensions: mahajani}', "");
    Expect(1, 70007, '\P{Script_Extensions: mahajani}', "");
    Expect(0, 70007, '\P{^Script_Extensions: mahajani}', "");
    Expect(1, 70006, '\p{Script_Extensions= 	Mahajani}', "");
    Expect(0, 70006, '\p{^Script_Extensions= 	Mahajani}', "");
    Expect(0, 70006, '\P{Script_Extensions= 	Mahajani}', "");
    Expect(1, 70006, '\P{^Script_Extensions= 	Mahajani}', "");
    Expect(0, 70007, '\p{Script_Extensions= 	Mahajani}', "");
    Expect(1, 70007, '\p{^Script_Extensions= 	Mahajani}', "");
    Expect(1, 70007, '\P{Script_Extensions= 	Mahajani}', "");
    Expect(0, 70007, '\P{^Script_Extensions= 	Mahajani}', "");
    Error('\p{Scx=	:=Mahj}');
    Error('\P{Scx=	:=Mahj}');
    Expect(1, 70006, '\p{Scx=mahj}', "");
    Expect(0, 70006, '\p{^Scx=mahj}', "");
    Expect(0, 70006, '\P{Scx=mahj}', "");
    Expect(1, 70006, '\P{^Scx=mahj}', "");
    Expect(0, 70007, '\p{Scx=mahj}', "");
    Expect(1, 70007, '\p{^Scx=mahj}', "");
    Expect(1, 70007, '\P{Scx=mahj}', "");
    Expect(0, 70007, '\P{^Scx=mahj}', "");
    Expect(1, 70006, '\p{Scx=- Mahj}', "");
    Expect(0, 70006, '\p{^Scx=- Mahj}', "");
    Expect(0, 70006, '\P{Scx=- Mahj}', "");
    Expect(1, 70006, '\P{^Scx=- Mahj}', "");
    Expect(0, 70007, '\p{Scx=- Mahj}', "");
    Expect(1, 70007, '\p{^Scx=- Mahj}', "");
    Expect(1, 70007, '\P{Scx=- Mahj}', "");
    Expect(0, 70007, '\P{^Scx=- Mahj}', "");
    Error('\p{Is_Script_Extensions=- Mahajani:=}');
    Error('\P{Is_Script_Extensions=- Mahajani:=}');
    Expect(1, 70006, '\p{Is_Script_Extensions=mahajani}', "");
    Expect(0, 70006, '\p{^Is_Script_Extensions=mahajani}', "");
    Expect(0, 70006, '\P{Is_Script_Extensions=mahajani}', "");
    Expect(1, 70006, '\P{^Is_Script_Extensions=mahajani}', "");
    Expect(0, 70007, '\p{Is_Script_Extensions=mahajani}', "");
    Expect(1, 70007, '\p{^Is_Script_Extensions=mahajani}', "");
    Expect(1, 70007, '\P{Is_Script_Extensions=mahajani}', "");
    Expect(0, 70007, '\P{^Is_Script_Extensions=mahajani}', "");
    Expect(1, 70006, '\p{Is_Script_Extensions= 	MAHAJANI}', "");
    Expect(0, 70006, '\p{^Is_Script_Extensions= 	MAHAJANI}', "");
    Expect(0, 70006, '\P{Is_Script_Extensions= 	MAHAJANI}', "");
    Expect(1, 70006, '\P{^Is_Script_Extensions= 	MAHAJANI}', "");
    Expect(0, 70007, '\p{Is_Script_Extensions= 	MAHAJANI}', "");
    Expect(1, 70007, '\p{^Is_Script_Extensions= 	MAHAJANI}', "");
    Expect(1, 70007, '\P{Is_Script_Extensions= 	MAHAJANI}', "");
    Expect(0, 70007, '\P{^Is_Script_Extensions= 	MAHAJANI}', "");
    Error('\p{Is_Scx=-:=MAHJ}');
    Error('\P{Is_Scx=-:=MAHJ}');
    Expect(1, 70006, '\p{Is_Scx=mahj}', "");
    Expect(0, 70006, '\p{^Is_Scx=mahj}', "");
    Expect(0, 70006, '\P{Is_Scx=mahj}', "");
    Expect(1, 70006, '\P{^Is_Scx=mahj}', "");
    Expect(0, 70007, '\p{Is_Scx=mahj}', "");
    Expect(1, 70007, '\p{^Is_Scx=mahj}', "");
    Expect(1, 70007, '\P{Is_Scx=mahj}', "");
    Expect(0, 70007, '\P{^Is_Scx=mahj}', "");
    Expect(1, 70006, '\p{Is_Scx=_mahj}', "");
    Expect(0, 70006, '\p{^Is_Scx=_mahj}', "");
    Expect(0, 70006, '\P{Is_Scx=_mahj}', "");
    Expect(1, 70006, '\P{^Is_Scx=_mahj}', "");
    Expect(0, 70007, '\p{Is_Scx=_mahj}', "");
    Expect(1, 70007, '\p{^Is_Scx=_mahj}', "");
    Expect(1, 70007, '\P{Is_Scx=_mahj}', "");
    Expect(0, 70007, '\P{^Is_Scx=_mahj}', "");
    Error('\p{Script_Extensions:/a/ _Mandaic}');
    Error('\P{Script_Extensions:/a/ _Mandaic}');
    Expect(1, 2142, '\p{Script_Extensions=mandaic}', "");
    Expect(0, 2142, '\p{^Script_Extensions=mandaic}', "");
    Expect(0, 2142, '\P{Script_Extensions=mandaic}', "");
    Expect(1, 2142, '\P{^Script_Extensions=mandaic}', "");
    Expect(0, 2143, '\p{Script_Extensions=mandaic}', "");
    Expect(1, 2143, '\p{^Script_Extensions=mandaic}', "");
    Expect(1, 2143, '\P{Script_Extensions=mandaic}', "");
    Expect(0, 2143, '\P{^Script_Extensions=mandaic}', "");
    Expect(1, 2142, '\p{Script_Extensions=--Mandaic}', "");
    Expect(0, 2142, '\p{^Script_Extensions=--Mandaic}', "");
    Expect(0, 2142, '\P{Script_Extensions=--Mandaic}', "");
    Expect(1, 2142, '\P{^Script_Extensions=--Mandaic}', "");
    Expect(0, 2143, '\p{Script_Extensions=--Mandaic}', "");
    Expect(1, 2143, '\p{^Script_Extensions=--Mandaic}', "");
    Expect(1, 2143, '\P{Script_Extensions=--Mandaic}', "");
    Expect(0, 2143, '\P{^Script_Extensions=--Mandaic}', "");
    Error('\p{Scx=-/a/Mand}');
    Error('\P{Scx=-/a/Mand}');
    Expect(1, 2142, '\p{Scx=mand}', "");
    Expect(0, 2142, '\p{^Scx=mand}', "");
    Expect(0, 2142, '\P{Scx=mand}', "");
    Expect(1, 2142, '\P{^Scx=mand}', "");
    Expect(0, 2143, '\p{Scx=mand}', "");
    Expect(1, 2143, '\p{^Scx=mand}', "");
    Expect(1, 2143, '\P{Scx=mand}', "");
    Expect(0, 2143, '\P{^Scx=mand}', "");
    Expect(1, 2142, '\p{Scx=__Mand}', "");
    Expect(0, 2142, '\p{^Scx=__Mand}', "");
    Expect(0, 2142, '\P{Scx=__Mand}', "");
    Expect(1, 2142, '\P{^Scx=__Mand}', "");
    Expect(0, 2143, '\p{Scx=__Mand}', "");
    Expect(1, 2143, '\p{^Scx=__Mand}', "");
    Expect(1, 2143, '\P{Scx=__Mand}', "");
    Expect(0, 2143, '\P{^Scx=__Mand}', "");
    Error('\p{Is_Script_Extensions= -mandaic/a/}');
    Error('\P{Is_Script_Extensions= -mandaic/a/}');
    Expect(1, 2142, '\p{Is_Script_Extensions=mandaic}', "");
    Expect(0, 2142, '\p{^Is_Script_Extensions=mandaic}', "");
    Expect(0, 2142, '\P{Is_Script_Extensions=mandaic}', "");
    Expect(1, 2142, '\P{^Is_Script_Extensions=mandaic}', "");
    Expect(0, 2143, '\p{Is_Script_Extensions=mandaic}', "");
    Expect(1, 2143, '\p{^Is_Script_Extensions=mandaic}', "");
    Expect(1, 2143, '\P{Is_Script_Extensions=mandaic}', "");
    Expect(0, 2143, '\P{^Is_Script_Extensions=mandaic}', "");
    Expect(1, 2142, '\p{Is_Script_Extensions=- MANDAIC}', "");
    Expect(0, 2142, '\p{^Is_Script_Extensions=- MANDAIC}', "");
    Expect(0, 2142, '\P{Is_Script_Extensions=- MANDAIC}', "");
    Expect(1, 2142, '\P{^Is_Script_Extensions=- MANDAIC}', "");
    Expect(0, 2143, '\p{Is_Script_Extensions=- MANDAIC}', "");
    Expect(1, 2143, '\p{^Is_Script_Extensions=- MANDAIC}', "");
    Expect(1, 2143, '\P{Is_Script_Extensions=- MANDAIC}', "");
    Expect(0, 2143, '\P{^Is_Script_Extensions=- MANDAIC}', "");
    Error('\p{Is_Scx=/a/--Mand}');
    Error('\P{Is_Scx=/a/--Mand}');
    Expect(1, 2142, '\p{Is_Scx=mand}', "");
    Expect(0, 2142, '\p{^Is_Scx=mand}', "");
    Expect(0, 2142, '\P{Is_Scx=mand}', "");
    Expect(1, 2142, '\P{^Is_Scx=mand}', "");
    Expect(0, 2143, '\p{Is_Scx=mand}', "");
    Expect(1, 2143, '\p{^Is_Scx=mand}', "");
    Expect(1, 2143, '\P{Is_Scx=mand}', "");
    Expect(0, 2143, '\P{^Is_Scx=mand}', "");
    Expect(1, 2142, '\p{Is_Scx=_MAND}', "");
    Expect(0, 2142, '\p{^Is_Scx=_MAND}', "");
    Expect(0, 2142, '\P{Is_Scx=_MAND}', "");
    Expect(1, 2142, '\P{^Is_Scx=_MAND}', "");
    Expect(0, 2143, '\p{Is_Scx=_MAND}', "");
    Expect(1, 2143, '\p{^Is_Scx=_MAND}', "");
    Expect(1, 2143, '\P{Is_Scx=_MAND}', "");
    Expect(0, 2143, '\P{^Is_Scx=_MAND}', "");
    Error('\p{Script_Extensions:	:=Manichaean}');
    Error('\P{Script_Extensions:	:=Manichaean}');
    Expect(1, 68342, '\p{Script_Extensions=manichaean}', "");
    Expect(0, 68342, '\p{^Script_Extensions=manichaean}', "");
    Expect(0, 68342, '\P{Script_Extensions=manichaean}', "");
    Expect(1, 68342, '\P{^Script_Extensions=manichaean}', "");
    Expect(0, 68343, '\p{Script_Extensions=manichaean}', "");
    Expect(1, 68343, '\p{^Script_Extensions=manichaean}', "");
    Expect(1, 68343, '\P{Script_Extensions=manichaean}', "");
    Expect(0, 68343, '\P{^Script_Extensions=manichaean}', "");
    Expect(1, 68342, '\p{Script_Extensions=-	Manichaean}', "");
    Expect(0, 68342, '\p{^Script_Extensions=-	Manichaean}', "");
    Expect(0, 68342, '\P{Script_Extensions=-	Manichaean}', "");
    Expect(1, 68342, '\P{^Script_Extensions=-	Manichaean}', "");
    Expect(0, 68343, '\p{Script_Extensions=-	Manichaean}', "");
    Expect(1, 68343, '\p{^Script_Extensions=-	Manichaean}', "");
    Expect(1, 68343, '\P{Script_Extensions=-	Manichaean}', "");
    Expect(0, 68343, '\P{^Script_Extensions=-	Manichaean}', "");
    Error('\p{Scx=/a/_	Mani}');
    Error('\P{Scx=/a/_	Mani}');
    Expect(1, 68342, '\p{Scx=mani}', "");
    Expect(0, 68342, '\p{^Scx=mani}', "");
    Expect(0, 68342, '\P{Scx=mani}', "");
    Expect(1, 68342, '\P{^Scx=mani}', "");
    Expect(0, 68343, '\p{Scx=mani}', "");
    Expect(1, 68343, '\p{^Scx=mani}', "");
    Expect(1, 68343, '\P{Scx=mani}', "");
    Expect(0, 68343, '\P{^Scx=mani}', "");
    Expect(1, 68342, '\p{Scx=_ Mani}', "");
    Expect(0, 68342, '\p{^Scx=_ Mani}', "");
    Expect(0, 68342, '\P{Scx=_ Mani}', "");
    Expect(1, 68342, '\P{^Scx=_ Mani}', "");
    Expect(0, 68343, '\p{Scx=_ Mani}', "");
    Expect(1, 68343, '\p{^Scx=_ Mani}', "");
    Expect(1, 68343, '\P{Scx=_ Mani}', "");
    Expect(0, 68343, '\P{^Scx=_ Mani}', "");
    Error('\p{Is_Script_Extensions:_Manichaean:=}');
    Error('\P{Is_Script_Extensions:_Manichaean:=}');
    Expect(1, 68342, '\p{Is_Script_Extensions=manichaean}', "");
    Expect(0, 68342, '\p{^Is_Script_Extensions=manichaean}', "");
    Expect(0, 68342, '\P{Is_Script_Extensions=manichaean}', "");
    Expect(1, 68342, '\P{^Is_Script_Extensions=manichaean}', "");
    Expect(0, 68343, '\p{Is_Script_Extensions=manichaean}', "");
    Expect(1, 68343, '\p{^Is_Script_Extensions=manichaean}', "");
    Expect(1, 68343, '\P{Is_Script_Extensions=manichaean}', "");
    Expect(0, 68343, '\P{^Is_Script_Extensions=manichaean}', "");
    Expect(1, 68342, '\p{Is_Script_Extensions=	 MANICHAEAN}', "");
    Expect(0, 68342, '\p{^Is_Script_Extensions=	 MANICHAEAN}', "");
    Expect(0, 68342, '\P{Is_Script_Extensions=	 MANICHAEAN}', "");
    Expect(1, 68342, '\P{^Is_Script_Extensions=	 MANICHAEAN}', "");
    Expect(0, 68343, '\p{Is_Script_Extensions=	 MANICHAEAN}', "");
    Expect(1, 68343, '\p{^Is_Script_Extensions=	 MANICHAEAN}', "");
    Expect(1, 68343, '\P{Is_Script_Extensions=	 MANICHAEAN}', "");
    Expect(0, 68343, '\P{^Is_Script_Extensions=	 MANICHAEAN}', "");
    Error('\p{Is_Scx=/a/_Mani}');
    Error('\P{Is_Scx=/a/_Mani}');
    Expect(1, 68342, '\p{Is_Scx=mani}', "");
    Expect(0, 68342, '\p{^Is_Scx=mani}', "");
    Expect(0, 68342, '\P{Is_Scx=mani}', "");
    Expect(1, 68342, '\P{^Is_Scx=mani}', "");
    Expect(0, 68343, '\p{Is_Scx=mani}', "");
    Expect(1, 68343, '\p{^Is_Scx=mani}', "");
    Expect(1, 68343, '\P{Is_Scx=mani}', "");
    Expect(0, 68343, '\P{^Is_Scx=mani}', "");
    Expect(1, 68342, '\p{Is_Scx=_Mani}', "");
    Expect(0, 68342, '\p{^Is_Scx=_Mani}', "");
    Expect(0, 68342, '\P{Is_Scx=_Mani}', "");
    Expect(1, 68342, '\P{^Is_Scx=_Mani}', "");
    Expect(0, 68343, '\p{Is_Scx=_Mani}', "");
    Expect(1, 68343, '\p{^Is_Scx=_Mani}', "");
    Expect(1, 68343, '\P{Is_Scx=_Mani}', "");
    Expect(0, 68343, '\P{^Is_Scx=_Mani}', "");
    Error('\p{Script_Extensions=/a/	-Marchen}');
    Error('\P{Script_Extensions=/a/	-Marchen}');
    Expect(1, 72886, '\p{Script_Extensions=marchen}', "");
    Expect(0, 72886, '\p{^Script_Extensions=marchen}', "");
    Expect(0, 72886, '\P{Script_Extensions=marchen}', "");
    Expect(1, 72886, '\P{^Script_Extensions=marchen}', "");
    Expect(0, 72887, '\p{Script_Extensions=marchen}', "");
    Expect(1, 72887, '\p{^Script_Extensions=marchen}', "");
    Expect(1, 72887, '\P{Script_Extensions=marchen}', "");
    Expect(0, 72887, '\P{^Script_Extensions=marchen}', "");
    Expect(1, 72886, '\p{Script_Extensions=--marchen}', "");
    Expect(0, 72886, '\p{^Script_Extensions=--marchen}', "");
    Expect(0, 72886, '\P{Script_Extensions=--marchen}', "");
    Expect(1, 72886, '\P{^Script_Extensions=--marchen}', "");
    Expect(0, 72887, '\p{Script_Extensions=--marchen}', "");
    Expect(1, 72887, '\p{^Script_Extensions=--marchen}', "");
    Expect(1, 72887, '\P{Script_Extensions=--marchen}', "");
    Expect(0, 72887, '\P{^Script_Extensions=--marchen}', "");
    Error('\p{Scx:	/a/_Marc}');
    Error('\P{Scx:	/a/_Marc}');
    Expect(1, 72886, '\p{Scx=marc}', "");
    Expect(0, 72886, '\p{^Scx=marc}', "");
    Expect(0, 72886, '\P{Scx=marc}', "");
    Expect(1, 72886, '\P{^Scx=marc}', "");
    Expect(0, 72887, '\p{Scx=marc}', "");
    Expect(1, 72887, '\p{^Scx=marc}', "");
    Expect(1, 72887, '\P{Scx=marc}', "");
    Expect(0, 72887, '\P{^Scx=marc}', "");
    Expect(1, 72886, '\p{Scx=  Marc}', "");
    Expect(0, 72886, '\p{^Scx=  Marc}', "");
    Expect(0, 72886, '\P{Scx=  Marc}', "");
    Expect(1, 72886, '\P{^Scx=  Marc}', "");
    Expect(0, 72887, '\p{Scx=  Marc}', "");
    Expect(1, 72887, '\p{^Scx=  Marc}', "");
    Expect(1, 72887, '\P{Scx=  Marc}', "");
    Expect(0, 72887, '\P{^Scx=  Marc}', "");
    Error('\p{Is_Script_Extensions: -Marchen:=}');
    Error('\P{Is_Script_Extensions: -Marchen:=}');
    Expect(1, 72886, '\p{Is_Script_Extensions=marchen}', "");
    Expect(0, 72886, '\p{^Is_Script_Extensions=marchen}', "");
    Expect(0, 72886, '\P{Is_Script_Extensions=marchen}', "");
    Expect(1, 72886, '\P{^Is_Script_Extensions=marchen}', "");
    Expect(0, 72887, '\p{Is_Script_Extensions=marchen}', "");
    Expect(1, 72887, '\p{^Is_Script_Extensions=marchen}', "");
    Expect(1, 72887, '\P{Is_Script_Extensions=marchen}', "");
    Expect(0, 72887, '\P{^Is_Script_Extensions=marchen}', "");
    Expect(1, 72886, '\p{Is_Script_Extensions= marchen}', "");
    Expect(0, 72886, '\p{^Is_Script_Extensions= marchen}', "");
    Expect(0, 72886, '\P{Is_Script_Extensions= marchen}', "");
    Expect(1, 72886, '\P{^Is_Script_Extensions= marchen}', "");
    Expect(0, 72887, '\p{Is_Script_Extensions= marchen}', "");
    Expect(1, 72887, '\p{^Is_Script_Extensions= marchen}', "");
    Expect(1, 72887, '\P{Is_Script_Extensions= marchen}', "");
    Expect(0, 72887, '\P{^Is_Script_Extensions= marchen}', "");
    Error('\p{Is_Scx=__Marc/a/}');
    Error('\P{Is_Scx=__Marc/a/}');
    Expect(1, 72886, '\p{Is_Scx=marc}', "");
    Expect(0, 72886, '\p{^Is_Scx=marc}', "");
    Expect(0, 72886, '\P{Is_Scx=marc}', "");
    Expect(1, 72886, '\P{^Is_Scx=marc}', "");
    Expect(0, 72887, '\p{Is_Scx=marc}', "");
    Expect(1, 72887, '\p{^Is_Scx=marc}', "");
    Expect(1, 72887, '\P{Is_Scx=marc}', "");
    Expect(0, 72887, '\P{^Is_Scx=marc}', "");
    Expect(1, 72886, '\p{Is_Scx=	MARC}', "");
    Expect(0, 72886, '\p{^Is_Scx=	MARC}', "");
    Expect(0, 72886, '\P{Is_Scx=	MARC}', "");
    Expect(1, 72886, '\P{^Is_Scx=	MARC}', "");
    Expect(0, 72887, '\p{Is_Scx=	MARC}', "");
    Expect(1, 72887, '\p{^Is_Scx=	MARC}', "");
    Expect(1, 72887, '\P{Is_Scx=	MARC}', "");
    Expect(0, 72887, '\P{^Is_Scx=	MARC}', "");
    Error('\p{Script_Extensions=	/a/Mende_Kikakui}');
    Error('\P{Script_Extensions=	/a/Mende_Kikakui}');
    Expect(1, 125142, '\p{Script_Extensions=mendekikakui}', "");
    Expect(0, 125142, '\p{^Script_Extensions=mendekikakui}', "");
    Expect(0, 125142, '\P{Script_Extensions=mendekikakui}', "");
    Expect(1, 125142, '\P{^Script_Extensions=mendekikakui}', "");
    Expect(0, 125143, '\p{Script_Extensions=mendekikakui}', "");
    Expect(1, 125143, '\p{^Script_Extensions=mendekikakui}', "");
    Expect(1, 125143, '\P{Script_Extensions=mendekikakui}', "");
    Expect(0, 125143, '\P{^Script_Extensions=mendekikakui}', "");
    Expect(1, 125142, '\p{Script_Extensions=	MENDE_Kikakui}', "");
    Expect(0, 125142, '\p{^Script_Extensions=	MENDE_Kikakui}', "");
    Expect(0, 125142, '\P{Script_Extensions=	MENDE_Kikakui}', "");
    Expect(1, 125142, '\P{^Script_Extensions=	MENDE_Kikakui}', "");
    Expect(0, 125143, '\p{Script_Extensions=	MENDE_Kikakui}', "");
    Expect(1, 125143, '\p{^Script_Extensions=	MENDE_Kikakui}', "");
    Expect(1, 125143, '\P{Script_Extensions=	MENDE_Kikakui}', "");
    Expect(0, 125143, '\P{^Script_Extensions=	MENDE_Kikakui}', "");
    Error('\p{Scx:   :=-_Mend}');
    Error('\P{Scx:   :=-_Mend}');
    Expect(1, 125142, '\p{Scx=mend}', "");
    Expect(0, 125142, '\p{^Scx=mend}', "");
    Expect(0, 125142, '\P{Scx=mend}', "");
    Expect(1, 125142, '\P{^Scx=mend}', "");
    Expect(0, 125143, '\p{Scx=mend}', "");
    Expect(1, 125143, '\p{^Scx=mend}', "");
    Expect(1, 125143, '\P{Scx=mend}', "");
    Expect(0, 125143, '\P{^Scx=mend}', "");
    Expect(1, 125142, '\p{Scx=__MEND}', "");
    Expect(0, 125142, '\p{^Scx=__MEND}', "");
    Expect(0, 125142, '\P{Scx=__MEND}', "");
    Expect(1, 125142, '\P{^Scx=__MEND}', "");
    Expect(0, 125143, '\p{Scx=__MEND}', "");
    Expect(1, 125143, '\p{^Scx=__MEND}', "");
    Expect(1, 125143, '\P{Scx=__MEND}', "");
    Expect(0, 125143, '\P{^Scx=__MEND}', "");
    Error('\p{Is_Script_Extensions=:=	-mende_Kikakui}');
    Error('\P{Is_Script_Extensions=:=	-mende_Kikakui}');
    Expect(1, 125142, '\p{Is_Script_Extensions=mendekikakui}', "");
    Expect(0, 125142, '\p{^Is_Script_Extensions=mendekikakui}', "");
    Expect(0, 125142, '\P{Is_Script_Extensions=mendekikakui}', "");
    Expect(1, 125142, '\P{^Is_Script_Extensions=mendekikakui}', "");
    Expect(0, 125143, '\p{Is_Script_Extensions=mendekikakui}', "");
    Expect(1, 125143, '\p{^Is_Script_Extensions=mendekikakui}', "");
    Expect(1, 125143, '\P{Is_Script_Extensions=mendekikakui}', "");
    Expect(0, 125143, '\P{^Is_Script_Extensions=mendekikakui}', "");
    Expect(1, 125142, '\p{Is_Script_Extensions=-Mende_KIKAKUI}', "");
    Expect(0, 125142, '\p{^Is_Script_Extensions=-Mende_KIKAKUI}', "");
    Expect(0, 125142, '\P{Is_Script_Extensions=-Mende_KIKAKUI}', "");
    Expect(1, 125142, '\P{^Is_Script_Extensions=-Mende_KIKAKUI}', "");
    Expect(0, 125143, '\p{Is_Script_Extensions=-Mende_KIKAKUI}', "");
    Expect(1, 125143, '\p{^Is_Script_Extensions=-Mende_KIKAKUI}', "");
    Expect(1, 125143, '\P{Is_Script_Extensions=-Mende_KIKAKUI}', "");
    Expect(0, 125143, '\P{^Is_Script_Extensions=-Mende_KIKAKUI}', "");
    Error('\p{Is_Scx=_MEND/a/}');
    Error('\P{Is_Scx=_MEND/a/}');
    Expect(1, 125142, '\p{Is_Scx=mend}', "");
    Expect(0, 125142, '\p{^Is_Scx=mend}', "");
    Expect(0, 125142, '\P{Is_Scx=mend}', "");
    Expect(1, 125142, '\P{^Is_Scx=mend}', "");
    Expect(0, 125143, '\p{Is_Scx=mend}', "");
    Expect(1, 125143, '\p{^Is_Scx=mend}', "");
    Expect(1, 125143, '\P{Is_Scx=mend}', "");
    Expect(0, 125143, '\P{^Is_Scx=mend}', "");
    Expect(1, 125142, '\p{Is_Scx:   	Mend}', "");
    Expect(0, 125142, '\p{^Is_Scx:   	Mend}', "");
    Expect(0, 125142, '\P{Is_Scx:   	Mend}', "");
    Expect(1, 125142, '\P{^Is_Scx:   	Mend}', "");
    Expect(0, 125143, '\p{Is_Scx:   	Mend}', "");
    Expect(1, 125143, '\p{^Is_Scx:   	Mend}', "");
    Expect(1, 125143, '\P{Is_Scx:   	Mend}', "");
    Expect(0, 125143, '\P{^Is_Scx:   	Mend}', "");
    Error('\p{Script_Extensions= -Meroitic_CURSIVE/a/}');
    Error('\P{Script_Extensions= -Meroitic_CURSIVE/a/}');
    Expect(1, 68095, '\p{Script_Extensions: meroiticcursive}', "");
    Expect(0, 68095, '\p{^Script_Extensions: meroiticcursive}', "");
    Expect(0, 68095, '\P{Script_Extensions: meroiticcursive}', "");
    Expect(1, 68095, '\P{^Script_Extensions: meroiticcursive}', "");
    Expect(0, 68096, '\p{Script_Extensions: meroiticcursive}', "");
    Expect(1, 68096, '\p{^Script_Extensions: meroiticcursive}', "");
    Expect(1, 68096, '\P{Script_Extensions: meroiticcursive}', "");
    Expect(0, 68096, '\P{^Script_Extensions: meroiticcursive}', "");
    Expect(1, 68095, '\p{Script_Extensions=-	Meroitic_cursive}', "");
    Expect(0, 68095, '\p{^Script_Extensions=-	Meroitic_cursive}', "");
    Expect(0, 68095, '\P{Script_Extensions=-	Meroitic_cursive}', "");
    Expect(1, 68095, '\P{^Script_Extensions=-	Meroitic_cursive}', "");
    Expect(0, 68096, '\p{Script_Extensions=-	Meroitic_cursive}', "");
    Expect(1, 68096, '\p{^Script_Extensions=-	Meroitic_cursive}', "");
    Expect(1, 68096, '\P{Script_Extensions=-	Meroitic_cursive}', "");
    Expect(0, 68096, '\P{^Script_Extensions=-	Meroitic_cursive}', "");
    Error('\p{Scx=:=	merc}');
    Error('\P{Scx=:=	merc}');
    Expect(1, 68095, '\p{Scx=merc}', "");
    Expect(0, 68095, '\p{^Scx=merc}', "");
    Expect(0, 68095, '\P{Scx=merc}', "");
    Expect(1, 68095, '\P{^Scx=merc}', "");
    Expect(0, 68096, '\p{Scx=merc}', "");
    Expect(1, 68096, '\p{^Scx=merc}', "");
    Expect(1, 68096, '\P{Scx=merc}', "");
    Expect(0, 68096, '\P{^Scx=merc}', "");
    Expect(1, 68095, '\p{Scx= Merc}', "");
    Expect(0, 68095, '\p{^Scx= Merc}', "");
    Expect(0, 68095, '\P{Scx= Merc}', "");
    Expect(1, 68095, '\P{^Scx= Merc}', "");
    Expect(0, 68096, '\p{Scx= Merc}', "");
    Expect(1, 68096, '\p{^Scx= Merc}', "");
    Expect(1, 68096, '\P{Scx= Merc}', "");
    Expect(0, 68096, '\P{^Scx= Merc}', "");
    Error('\p{Is_Script_Extensions=_/a/meroitic_Cursive}');
    Error('\P{Is_Script_Extensions=_/a/meroitic_Cursive}');
    Expect(1, 68095, '\p{Is_Script_Extensions=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Is_Script_Extensions=meroiticcursive}', "");
    Expect(0, 68095, '\P{Is_Script_Extensions=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Is_Script_Extensions=meroiticcursive}', "");
    Expect(0, 68096, '\p{Is_Script_Extensions=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Is_Script_Extensions=meroiticcursive}', "");
    Expect(1, 68096, '\P{Is_Script_Extensions=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Is_Script_Extensions=meroiticcursive}', "");
    Expect(1, 68095, '\p{Is_Script_Extensions=	meroitic_CURSIVE}', "");
    Expect(0, 68095, '\p{^Is_Script_Extensions=	meroitic_CURSIVE}', "");
    Expect(0, 68095, '\P{Is_Script_Extensions=	meroitic_CURSIVE}', "");
    Expect(1, 68095, '\P{^Is_Script_Extensions=	meroitic_CURSIVE}', "");
    Expect(0, 68096, '\p{Is_Script_Extensions=	meroitic_CURSIVE}', "");
    Expect(1, 68096, '\p{^Is_Script_Extensions=	meroitic_CURSIVE}', "");
    Expect(1, 68096, '\P{Is_Script_Extensions=	meroitic_CURSIVE}', "");
    Expect(0, 68096, '\P{^Is_Script_Extensions=	meroitic_CURSIVE}', "");
    Error('\p{Is_Scx=_ merc:=}');
    Error('\P{Is_Scx=_ merc:=}');
    Expect(1, 68095, '\p{Is_Scx=merc}', "");
    Expect(0, 68095, '\p{^Is_Scx=merc}', "");
    Expect(0, 68095, '\P{Is_Scx=merc}', "");
    Expect(1, 68095, '\P{^Is_Scx=merc}', "");
    Expect(0, 68096, '\p{Is_Scx=merc}', "");
    Expect(1, 68096, '\p{^Is_Scx=merc}', "");
    Expect(1, 68096, '\P{Is_Scx=merc}', "");
    Expect(0, 68096, '\P{^Is_Scx=merc}', "");
    Expect(1, 68095, '\p{Is_Scx=-_MERC}', "");
    Expect(0, 68095, '\p{^Is_Scx=-_MERC}', "");
    Expect(0, 68095, '\P{Is_Scx=-_MERC}', "");
    Expect(1, 68095, '\P{^Is_Scx=-_MERC}', "");
    Expect(0, 68096, '\p{Is_Scx=-_MERC}', "");
    Expect(1, 68096, '\p{^Is_Scx=-_MERC}', "");
    Expect(1, 68096, '\P{Is_Scx=-_MERC}', "");
    Expect(0, 68096, '\P{^Is_Scx=-_MERC}', "");
    Error('\p{Script_Extensions=	:=Meroitic_Hieroglyphs}');
    Error('\P{Script_Extensions=	:=Meroitic_Hieroglyphs}');
    Expect(1, 67999, '\p{Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Script_Extensions=_-meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^Script_Extensions=_-meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\P{Script_Extensions=_-meroitic_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^Script_Extensions=_-meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\p{Script_Extensions=_-meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^Script_Extensions=_-meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\P{Script_Extensions=_-meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^Script_Extensions=_-meroitic_Hieroglyphs}', "");
    Error('\p{Scx=/a/Mero}');
    Error('\P{Scx=/a/Mero}');
    Expect(1, 67999, '\p{Scx=mero}', "");
    Expect(0, 67999, '\p{^Scx=mero}', "");
    Expect(0, 67999, '\P{Scx=mero}', "");
    Expect(1, 67999, '\P{^Scx=mero}', "");
    Expect(0, 68000, '\p{Scx=mero}', "");
    Expect(1, 68000, '\p{^Scx=mero}', "");
    Expect(1, 68000, '\P{Scx=mero}', "");
    Expect(0, 68000, '\P{^Scx=mero}', "");
    Expect(1, 67999, '\p{Scx=- mero}', "");
    Expect(0, 67999, '\p{^Scx=- mero}', "");
    Expect(0, 67999, '\P{Scx=- mero}', "");
    Expect(1, 67999, '\P{^Scx=- mero}', "");
    Expect(0, 68000, '\p{Scx=- mero}', "");
    Expect(1, 68000, '\p{^Scx=- mero}', "");
    Expect(1, 68000, '\P{Scx=- mero}', "");
    Expect(0, 68000, '\P{^Scx=- mero}', "");
    Error('\p{Is_Script_Extensions=/a/_Meroitic_Hieroglyphs}');
    Error('\P{Is_Script_Extensions=/a/_Meroitic_Hieroglyphs}');
    Expect(1, 67999, '\p{Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Is_Script_Extensions=	-MEROITIC_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Script_Extensions=	-MEROITIC_Hieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Script_Extensions=	-MEROITIC_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Script_Extensions=	-MEROITIC_Hieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Script_Extensions=	-MEROITIC_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Script_Extensions=	-MEROITIC_Hieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Script_Extensions=	-MEROITIC_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Script_Extensions=	-MEROITIC_Hieroglyphs}', "");
    Error('\p{Is_Scx=- Mero:=}');
    Error('\P{Is_Scx=- Mero:=}');
    Expect(1, 67999, '\p{Is_Scx=mero}', "");
    Expect(0, 67999, '\p{^Is_Scx=mero}', "");
    Expect(0, 67999, '\P{Is_Scx=mero}', "");
    Expect(1, 67999, '\P{^Is_Scx=mero}', "");
    Expect(0, 68000, '\p{Is_Scx=mero}', "");
    Expect(1, 68000, '\p{^Is_Scx=mero}', "");
    Expect(1, 68000, '\P{Is_Scx=mero}', "");
    Expect(0, 68000, '\P{^Is_Scx=mero}', "");
    Expect(1, 67999, '\p{Is_Scx=__MERO}', "");
    Expect(0, 67999, '\p{^Is_Scx=__MERO}', "");
    Expect(0, 67999, '\P{Is_Scx=__MERO}', "");
    Expect(1, 67999, '\P{^Is_Scx=__MERO}', "");
    Expect(0, 68000, '\p{Is_Scx=__MERO}', "");
    Expect(1, 68000, '\p{^Is_Scx=__MERO}', "");
    Expect(1, 68000, '\P{Is_Scx=__MERO}', "");
    Expect(0, 68000, '\P{^Is_Scx=__MERO}', "");
    Error('\p{Script_Extensions= _malayalam/a/}');
    Error('\P{Script_Extensions= _malayalam/a/}');
    Expect(1, 7386, '\p{Script_Extensions=malayalam}', "");
    Expect(0, 7386, '\p{^Script_Extensions=malayalam}', "");
    Expect(0, 7386, '\P{Script_Extensions=malayalam}', "");
    Expect(1, 7386, '\P{^Script_Extensions=malayalam}', "");
    Expect(0, 7387, '\p{Script_Extensions=malayalam}', "");
    Expect(1, 7387, '\p{^Script_Extensions=malayalam}', "");
    Expect(1, 7387, '\P{Script_Extensions=malayalam}', "");
    Expect(0, 7387, '\P{^Script_Extensions=malayalam}', "");
    Expect(1, 7386, '\p{Script_Extensions=--Malayalam}', "");
    Expect(0, 7386, '\p{^Script_Extensions=--Malayalam}', "");
    Expect(0, 7386, '\P{Script_Extensions=--Malayalam}', "");
    Expect(1, 7386, '\P{^Script_Extensions=--Malayalam}', "");
    Expect(0, 7387, '\p{Script_Extensions=--Malayalam}', "");
    Expect(1, 7387, '\p{^Script_Extensions=--Malayalam}', "");
    Expect(1, 7387, '\P{Script_Extensions=--Malayalam}', "");
    Expect(0, 7387, '\P{^Script_Extensions=--Malayalam}', "");
    Error('\p{Scx=_/a/Mlym}');
    Error('\P{Scx=_/a/Mlym}');
    Expect(1, 7386, '\p{Scx=mlym}', "");
    Expect(0, 7386, '\p{^Scx=mlym}', "");
    Expect(0, 7386, '\P{Scx=mlym}', "");
    Expect(1, 7386, '\P{^Scx=mlym}', "");
    Expect(0, 7387, '\p{Scx=mlym}', "");
    Expect(1, 7387, '\p{^Scx=mlym}', "");
    Expect(1, 7387, '\P{Scx=mlym}', "");
    Expect(0, 7387, '\P{^Scx=mlym}', "");
    Expect(1, 7386, '\p{Scx=-_mlym}', "");
    Expect(0, 7386, '\p{^Scx=-_mlym}', "");
    Expect(0, 7386, '\P{Scx=-_mlym}', "");
    Expect(1, 7386, '\P{^Scx=-_mlym}', "");
    Expect(0, 7387, '\p{Scx=-_mlym}', "");
    Expect(1, 7387, '\p{^Scx=-_mlym}', "");
    Expect(1, 7387, '\P{Scx=-_mlym}', "");
    Expect(0, 7387, '\P{^Scx=-_mlym}', "");
    Error('\p{Is_Script_Extensions=	-malayalam:=}');
    Error('\P{Is_Script_Extensions=	-malayalam:=}');
    Expect(1, 7386, '\p{Is_Script_Extensions:malayalam}', "");
    Expect(0, 7386, '\p{^Is_Script_Extensions:malayalam}', "");
    Expect(0, 7386, '\P{Is_Script_Extensions:malayalam}', "");
    Expect(1, 7386, '\P{^Is_Script_Extensions:malayalam}', "");
    Expect(0, 7387, '\p{Is_Script_Extensions:malayalam}', "");
    Expect(1, 7387, '\p{^Is_Script_Extensions:malayalam}', "");
    Expect(1, 7387, '\P{Is_Script_Extensions:malayalam}', "");
    Expect(0, 7387, '\P{^Is_Script_Extensions:malayalam}', "");
    Expect(1, 7386, '\p{Is_Script_Extensions=	 malayalam}', "");
    Expect(0, 7386, '\p{^Is_Script_Extensions=	 malayalam}', "");
    Expect(0, 7386, '\P{Is_Script_Extensions=	 malayalam}', "");
    Expect(1, 7386, '\P{^Is_Script_Extensions=	 malayalam}', "");
    Expect(0, 7387, '\p{Is_Script_Extensions=	 malayalam}', "");
    Expect(1, 7387, '\p{^Is_Script_Extensions=	 malayalam}', "");
    Expect(1, 7387, '\P{Is_Script_Extensions=	 malayalam}', "");
    Expect(0, 7387, '\P{^Is_Script_Extensions=	 malayalam}', "");
    Error('\p{Is_Scx=- Mlym:=}');
    Error('\P{Is_Scx=- Mlym:=}');
    Expect(1, 7386, '\p{Is_Scx:	mlym}', "");
    Expect(0, 7386, '\p{^Is_Scx:	mlym}', "");
    Expect(0, 7386, '\P{Is_Scx:	mlym}', "");
    Expect(1, 7386, '\P{^Is_Scx:	mlym}', "");
    Expect(0, 7387, '\p{Is_Scx:	mlym}', "");
    Expect(1, 7387, '\p{^Is_Scx:	mlym}', "");
    Expect(1, 7387, '\P{Is_Scx:	mlym}', "");
    Expect(0, 7387, '\P{^Is_Scx:	mlym}', "");
    Expect(1, 7386, '\p{Is_Scx=_MLYM}', "");
    Expect(0, 7386, '\p{^Is_Scx=_MLYM}', "");
    Expect(0, 7386, '\P{Is_Scx=_MLYM}', "");
    Expect(1, 7386, '\P{^Is_Scx=_MLYM}', "");
    Expect(0, 7387, '\p{Is_Scx=_MLYM}', "");
    Expect(1, 7387, '\p{^Is_Scx=_MLYM}', "");
    Expect(1, 7387, '\P{Is_Scx=_MLYM}', "");
    Expect(0, 7387, '\P{^Is_Scx=_MLYM}', "");
    Error('\p{Script_Extensions:/a/		modi}');
    Error('\P{Script_Extensions:/a/		modi}');
    Expect(1, 71257, '\p{Script_Extensions=modi}', "");
    Expect(0, 71257, '\p{^Script_Extensions=modi}', "");
    Expect(0, 71257, '\P{Script_Extensions=modi}', "");
    Expect(1, 71257, '\P{^Script_Extensions=modi}', "");
    Expect(0, 71258, '\p{Script_Extensions=modi}', "");
    Expect(1, 71258, '\p{^Script_Extensions=modi}', "");
    Expect(1, 71258, '\P{Script_Extensions=modi}', "");
    Expect(0, 71258, '\P{^Script_Extensions=modi}', "");
    Expect(1, 71257, '\p{Script_Extensions=-	MODI}', "");
    Expect(0, 71257, '\p{^Script_Extensions=-	MODI}', "");
    Expect(0, 71257, '\P{Script_Extensions=-	MODI}', "");
    Expect(1, 71257, '\P{^Script_Extensions=-	MODI}', "");
    Expect(0, 71258, '\p{Script_Extensions=-	MODI}', "");
    Expect(1, 71258, '\p{^Script_Extensions=-	MODI}', "");
    Expect(1, 71258, '\P{Script_Extensions=-	MODI}', "");
    Expect(0, 71258, '\P{^Script_Extensions=-	MODI}', "");
    Error('\p{Scx=:=	 MODI}');
    Error('\P{Scx=:=	 MODI}');
    Expect(1, 71257, '\p{Scx=modi}', "");
    Expect(0, 71257, '\p{^Scx=modi}', "");
    Expect(0, 71257, '\P{Scx=modi}', "");
    Expect(1, 71257, '\P{^Scx=modi}', "");
    Expect(0, 71258, '\p{Scx=modi}', "");
    Expect(1, 71258, '\p{^Scx=modi}', "");
    Expect(1, 71258, '\P{Scx=modi}', "");
    Expect(0, 71258, '\P{^Scx=modi}', "");
    Expect(1, 71257, '\p{Scx=_ Modi}', "");
    Expect(0, 71257, '\p{^Scx=_ Modi}', "");
    Expect(0, 71257, '\P{Scx=_ Modi}', "");
    Expect(1, 71257, '\P{^Scx=_ Modi}', "");
    Expect(0, 71258, '\p{Scx=_ Modi}', "");
    Expect(1, 71258, '\p{^Scx=_ Modi}', "");
    Expect(1, 71258, '\P{Scx=_ Modi}', "");
    Expect(0, 71258, '\P{^Scx=_ Modi}', "");
    Error('\p{Is_Script_Extensions=--Modi/a/}');
    Error('\P{Is_Script_Extensions=--Modi/a/}');
    Expect(1, 71257, '\p{Is_Script_Extensions=modi}', "");
    Expect(0, 71257, '\p{^Is_Script_Extensions=modi}', "");
    Expect(0, 71257, '\P{Is_Script_Extensions=modi}', "");
    Expect(1, 71257, '\P{^Is_Script_Extensions=modi}', "");
    Expect(0, 71258, '\p{Is_Script_Extensions=modi}', "");
    Expect(1, 71258, '\p{^Is_Script_Extensions=modi}', "");
    Expect(1, 71258, '\P{Is_Script_Extensions=modi}', "");
    Expect(0, 71258, '\P{^Is_Script_Extensions=modi}', "");
    Expect(1, 71257, '\p{Is_Script_Extensions= Modi}', "");
    Expect(0, 71257, '\p{^Is_Script_Extensions= Modi}', "");
    Expect(0, 71257, '\P{Is_Script_Extensions= Modi}', "");
    Expect(1, 71257, '\P{^Is_Script_Extensions= Modi}', "");
    Expect(0, 71258, '\p{Is_Script_Extensions= Modi}', "");
    Expect(1, 71258, '\p{^Is_Script_Extensions= Modi}', "");
    Expect(1, 71258, '\P{Is_Script_Extensions= Modi}', "");
    Expect(0, 71258, '\P{^Is_Script_Extensions= Modi}', "");
    Error('\p{Is_Scx= :=modi}');
    Error('\P{Is_Scx= :=modi}');
    Expect(1, 71257, '\p{Is_Scx=modi}', "");
    Expect(0, 71257, '\p{^Is_Scx=modi}', "");
    Expect(0, 71257, '\P{Is_Scx=modi}', "");
    Expect(1, 71257, '\P{^Is_Scx=modi}', "");
    Expect(0, 71258, '\p{Is_Scx=modi}', "");
    Expect(1, 71258, '\p{^Is_Scx=modi}', "");
    Expect(1, 71258, '\P{Is_Scx=modi}', "");
    Expect(0, 71258, '\P{^Is_Scx=modi}', "");
    Expect(1, 71257, '\p{Is_Scx=Modi}', "");
    Expect(0, 71257, '\p{^Is_Scx=Modi}', "");
    Expect(0, 71257, '\P{Is_Scx=Modi}', "");
    Expect(1, 71257, '\P{^Is_Scx=Modi}', "");
    Expect(0, 71258, '\p{Is_Scx=Modi}', "");
    Expect(1, 71258, '\p{^Is_Scx=Modi}', "");
    Expect(1, 71258, '\P{Is_Scx=Modi}', "");
    Expect(0, 71258, '\P{^Is_Scx=Modi}', "");
    Error('\p{Script_Extensions= Mongolian/a/}');
    Error('\P{Script_Extensions= Mongolian/a/}');
    Expect(1, 71276, '\p{Script_Extensions=mongolian}', "");
    Expect(0, 71276, '\p{^Script_Extensions=mongolian}', "");
    Expect(0, 71276, '\P{Script_Extensions=mongolian}', "");
    Expect(1, 71276, '\P{^Script_Extensions=mongolian}', "");
    Expect(0, 71277, '\p{Script_Extensions=mongolian}', "");
    Expect(1, 71277, '\p{^Script_Extensions=mongolian}', "");
    Expect(1, 71277, '\P{Script_Extensions=mongolian}', "");
    Expect(0, 71277, '\P{^Script_Extensions=mongolian}', "");
    Expect(1, 71276, '\p{Script_Extensions=-	mongolian}', "");
    Expect(0, 71276, '\p{^Script_Extensions=-	mongolian}', "");
    Expect(0, 71276, '\P{Script_Extensions=-	mongolian}', "");
    Expect(1, 71276, '\P{^Script_Extensions=-	mongolian}', "");
    Expect(0, 71277, '\p{Script_Extensions=-	mongolian}', "");
    Expect(1, 71277, '\p{^Script_Extensions=-	mongolian}', "");
    Expect(1, 71277, '\P{Script_Extensions=-	mongolian}', "");
    Expect(0, 71277, '\P{^Script_Extensions=-	mongolian}', "");
    Error('\p{Scx=/a/	MONG}');
    Error('\P{Scx=/a/	MONG}');
    Expect(1, 71276, '\p{Scx: mong}', "");
    Expect(0, 71276, '\p{^Scx: mong}', "");
    Expect(0, 71276, '\P{Scx: mong}', "");
    Expect(1, 71276, '\P{^Scx: mong}', "");
    Expect(0, 71277, '\p{Scx: mong}', "");
    Expect(1, 71277, '\p{^Scx: mong}', "");
    Expect(1, 71277, '\P{Scx: mong}', "");
    Expect(0, 71277, '\P{^Scx: mong}', "");
    Expect(1, 71276, '\p{Scx=	-Mong}', "");
    Expect(0, 71276, '\p{^Scx=	-Mong}', "");
    Expect(0, 71276, '\P{Scx=	-Mong}', "");
    Expect(1, 71276, '\P{^Scx=	-Mong}', "");
    Expect(0, 71277, '\p{Scx=	-Mong}', "");
    Expect(1, 71277, '\p{^Scx=	-Mong}', "");
    Expect(1, 71277, '\P{Scx=	-Mong}', "");
    Expect(0, 71277, '\P{^Scx=	-Mong}', "");
    Error('\p{Is_Script_Extensions=_ Mongolian/a/}');
    Error('\P{Is_Script_Extensions=_ Mongolian/a/}');
    Expect(1, 71276, '\p{Is_Script_Extensions=mongolian}', "");
    Expect(0, 71276, '\p{^Is_Script_Extensions=mongolian}', "");
    Expect(0, 71276, '\P{Is_Script_Extensions=mongolian}', "");
    Expect(1, 71276, '\P{^Is_Script_Extensions=mongolian}', "");
    Expect(0, 71277, '\p{Is_Script_Extensions=mongolian}', "");
    Expect(1, 71277, '\p{^Is_Script_Extensions=mongolian}', "");
    Expect(1, 71277, '\P{Is_Script_Extensions=mongolian}', "");
    Expect(0, 71277, '\P{^Is_Script_Extensions=mongolian}', "");
    Expect(1, 71276, '\p{Is_Script_Extensions=	Mongolian}', "");
    Expect(0, 71276, '\p{^Is_Script_Extensions=	Mongolian}', "");
    Expect(0, 71276, '\P{Is_Script_Extensions=	Mongolian}', "");
    Expect(1, 71276, '\P{^Is_Script_Extensions=	Mongolian}', "");
    Expect(0, 71277, '\p{Is_Script_Extensions=	Mongolian}', "");
    Expect(1, 71277, '\p{^Is_Script_Extensions=	Mongolian}', "");
    Expect(1, 71277, '\P{Is_Script_Extensions=	Mongolian}', "");
    Expect(0, 71277, '\P{^Is_Script_Extensions=	Mongolian}', "");
    Error('\p{Is_Scx:-:=mong}');
    Error('\P{Is_Scx:-:=mong}');
    Expect(1, 71276, '\p{Is_Scx=mong}', "");
    Expect(0, 71276, '\p{^Is_Scx=mong}', "");
    Expect(0, 71276, '\P{Is_Scx=mong}', "");
    Expect(1, 71276, '\P{^Is_Scx=mong}', "");
    Expect(0, 71277, '\p{Is_Scx=mong}', "");
    Expect(1, 71277, '\p{^Is_Scx=mong}', "");
    Expect(1, 71277, '\P{Is_Scx=mong}', "");
    Expect(0, 71277, '\P{^Is_Scx=mong}', "");
    Expect(1, 71276, '\p{Is_Scx=-	MONG}', "");
    Expect(0, 71276, '\p{^Is_Scx=-	MONG}', "");
    Expect(0, 71276, '\P{Is_Scx=-	MONG}', "");
    Expect(1, 71276, '\P{^Is_Scx=-	MONG}', "");
    Expect(0, 71277, '\p{Is_Scx=-	MONG}', "");
    Expect(1, 71277, '\p{^Is_Scx=-	MONG}', "");
    Expect(1, 71277, '\P{Is_Scx=-	MONG}', "");
    Expect(0, 71277, '\P{^Is_Scx=-	MONG}', "");
    Error('\p{Script_Extensions=:=	 Mro}');
    Error('\P{Script_Extensions=:=	 Mro}');
    Expect(1, 92783, '\p{Script_Extensions=mro}', "");
    Expect(0, 92783, '\p{^Script_Extensions=mro}', "");
    Expect(0, 92783, '\P{Script_Extensions=mro}', "");
    Expect(1, 92783, '\P{^Script_Extensions=mro}', "");
    Expect(0, 92784, '\p{Script_Extensions=mro}', "");
    Expect(1, 92784, '\p{^Script_Extensions=mro}', "");
    Expect(1, 92784, '\P{Script_Extensions=mro}', "");
    Expect(0, 92784, '\P{^Script_Extensions=mro}', "");
    Expect(1, 92783, '\p{Script_Extensions:   	mro}', "");
    Expect(0, 92783, '\p{^Script_Extensions:   	mro}', "");
    Expect(0, 92783, '\P{Script_Extensions:   	mro}', "");
    Expect(1, 92783, '\P{^Script_Extensions:   	mro}', "");
    Expect(0, 92784, '\p{Script_Extensions:   	mro}', "");
    Expect(1, 92784, '\p{^Script_Extensions:   	mro}', "");
    Expect(1, 92784, '\P{Script_Extensions:   	mro}', "");
    Expect(0, 92784, '\P{^Script_Extensions:   	mro}', "");
    Error('\p{Scx=	/a/Mroo}');
    Error('\P{Scx=	/a/Mroo}');
    Expect(1, 92783, '\p{Scx: mroo}', "");
    Expect(0, 92783, '\p{^Scx: mroo}', "");
    Expect(0, 92783, '\P{Scx: mroo}', "");
    Expect(1, 92783, '\P{^Scx: mroo}', "");
    Expect(0, 92784, '\p{Scx: mroo}', "");
    Expect(1, 92784, '\p{^Scx: mroo}', "");
    Expect(1, 92784, '\P{Scx: mroo}', "");
    Expect(0, 92784, '\P{^Scx: mroo}', "");
    Expect(1, 92783, '\p{Scx= 	MROO}', "");
    Expect(0, 92783, '\p{^Scx= 	MROO}', "");
    Expect(0, 92783, '\P{Scx= 	MROO}', "");
    Expect(1, 92783, '\P{^Scx= 	MROO}', "");
    Expect(0, 92784, '\p{Scx= 	MROO}', "");
    Expect(1, 92784, '\p{^Scx= 	MROO}', "");
    Expect(1, 92784, '\P{Scx= 	MROO}', "");
    Expect(0, 92784, '\P{^Scx= 	MROO}', "");
    Error('\p{Is_Script_Extensions=__Mro:=}');
    Error('\P{Is_Script_Extensions=__Mro:=}');
    Expect(1, 92783, '\p{Is_Script_Extensions=mro}', "");
    Expect(0, 92783, '\p{^Is_Script_Extensions=mro}', "");
    Expect(0, 92783, '\P{Is_Script_Extensions=mro}', "");
    Expect(1, 92783, '\P{^Is_Script_Extensions=mro}', "");
    Expect(0, 92784, '\p{Is_Script_Extensions=mro}', "");
    Expect(1, 92784, '\p{^Is_Script_Extensions=mro}', "");
    Expect(1, 92784, '\P{Is_Script_Extensions=mro}', "");
    Expect(0, 92784, '\P{^Is_Script_Extensions=mro}', "");
    Expect(1, 92783, '\p{Is_Script_Extensions= -mro}', "");
    Expect(0, 92783, '\p{^Is_Script_Extensions= -mro}', "");
    Expect(0, 92783, '\P{Is_Script_Extensions= -mro}', "");
    Expect(1, 92783, '\P{^Is_Script_Extensions= -mro}', "");
    Expect(0, 92784, '\p{Is_Script_Extensions= -mro}', "");
    Expect(1, 92784, '\p{^Is_Script_Extensions= -mro}', "");
    Expect(1, 92784, '\P{Is_Script_Extensions= -mro}', "");
    Expect(0, 92784, '\P{^Is_Script_Extensions= -mro}', "");
    Error('\p{Is_Scx=	_mroo/a/}');
    Error('\P{Is_Scx=	_mroo/a/}');
    Expect(1, 92783, '\p{Is_Scx=mroo}', "");
    Expect(0, 92783, '\p{^Is_Scx=mroo}', "");
    Expect(0, 92783, '\P{Is_Scx=mroo}', "");
    Expect(1, 92783, '\P{^Is_Scx=mroo}', "");
    Expect(0, 92784, '\p{Is_Scx=mroo}', "");
    Expect(1, 92784, '\p{^Is_Scx=mroo}', "");
    Expect(1, 92784, '\P{Is_Scx=mroo}', "");
    Expect(0, 92784, '\P{^Is_Scx=mroo}', "");
    Expect(1, 92783, '\p{Is_Scx=-_MROO}', "");
    Expect(0, 92783, '\p{^Is_Scx=-_MROO}', "");
    Expect(0, 92783, '\P{Is_Scx=-_MROO}', "");
    Expect(1, 92783, '\P{^Is_Scx=-_MROO}', "");
    Expect(0, 92784, '\p{Is_Scx=-_MROO}', "");
    Expect(1, 92784, '\p{^Is_Scx=-_MROO}', "");
    Expect(1, 92784, '\P{Is_Scx=-_MROO}', "");
    Expect(0, 92784, '\P{^Is_Scx=-_MROO}', "");
    Error('\p{Script_Extensions=- MEETEI_Mayek:=}');
    Error('\P{Script_Extensions=- MEETEI_Mayek:=}');
    Expect(1, 44025, '\p{Script_Extensions=meeteimayek}', "");
    Expect(0, 44025, '\p{^Script_Extensions=meeteimayek}', "");
    Expect(0, 44025, '\P{Script_Extensions=meeteimayek}', "");
    Expect(1, 44025, '\P{^Script_Extensions=meeteimayek}', "");
    Expect(0, 44026, '\p{Script_Extensions=meeteimayek}', "");
    Expect(1, 44026, '\p{^Script_Extensions=meeteimayek}', "");
    Expect(1, 44026, '\P{Script_Extensions=meeteimayek}', "");
    Expect(0, 44026, '\P{^Script_Extensions=meeteimayek}', "");
    Expect(1, 44025, '\p{Script_Extensions:    _MEETEI_MAYEK}', "");
    Expect(0, 44025, '\p{^Script_Extensions:    _MEETEI_MAYEK}', "");
    Expect(0, 44025, '\P{Script_Extensions:    _MEETEI_MAYEK}', "");
    Expect(1, 44025, '\P{^Script_Extensions:    _MEETEI_MAYEK}', "");
    Expect(0, 44026, '\p{Script_Extensions:    _MEETEI_MAYEK}', "");
    Expect(1, 44026, '\p{^Script_Extensions:    _MEETEI_MAYEK}', "");
    Expect(1, 44026, '\P{Script_Extensions:    _MEETEI_MAYEK}', "");
    Expect(0, 44026, '\P{^Script_Extensions:    _MEETEI_MAYEK}', "");
    Error('\p{Scx= :=mtei}');
    Error('\P{Scx= :=mtei}');
    Expect(1, 44025, '\p{Scx=mtei}', "");
    Expect(0, 44025, '\p{^Scx=mtei}', "");
    Expect(0, 44025, '\P{Scx=mtei}', "");
    Expect(1, 44025, '\P{^Scx=mtei}', "");
    Expect(0, 44026, '\p{Scx=mtei}', "");
    Expect(1, 44026, '\p{^Scx=mtei}', "");
    Expect(1, 44026, '\P{Scx=mtei}', "");
    Expect(0, 44026, '\P{^Scx=mtei}', "");
    Expect(1, 44025, '\p{Scx=	 Mtei}', "");
    Expect(0, 44025, '\p{^Scx=	 Mtei}', "");
    Expect(0, 44025, '\P{Scx=	 Mtei}', "");
    Expect(1, 44025, '\P{^Scx=	 Mtei}', "");
    Expect(0, 44026, '\p{Scx=	 Mtei}', "");
    Expect(1, 44026, '\p{^Scx=	 Mtei}', "");
    Expect(1, 44026, '\P{Scx=	 Mtei}', "");
    Expect(0, 44026, '\P{^Scx=	 Mtei}', "");
    Error('\p{Is_Script_Extensions=	/a/MEETEI_mayek}');
    Error('\P{Is_Script_Extensions=	/a/MEETEI_mayek}');
    Expect(1, 44025, '\p{Is_Script_Extensions=meeteimayek}', "");
    Expect(0, 44025, '\p{^Is_Script_Extensions=meeteimayek}', "");
    Expect(0, 44025, '\P{Is_Script_Extensions=meeteimayek}', "");
    Expect(1, 44025, '\P{^Is_Script_Extensions=meeteimayek}', "");
    Expect(0, 44026, '\p{Is_Script_Extensions=meeteimayek}', "");
    Expect(1, 44026, '\p{^Is_Script_Extensions=meeteimayek}', "");
    Expect(1, 44026, '\P{Is_Script_Extensions=meeteimayek}', "");
    Expect(0, 44026, '\P{^Is_Script_Extensions=meeteimayek}', "");
    Expect(1, 44025, '\p{Is_Script_Extensions=	-MEETEI_Mayek}', "");
    Expect(0, 44025, '\p{^Is_Script_Extensions=	-MEETEI_Mayek}', "");
    Expect(0, 44025, '\P{Is_Script_Extensions=	-MEETEI_Mayek}', "");
    Expect(1, 44025, '\P{^Is_Script_Extensions=	-MEETEI_Mayek}', "");
    Expect(0, 44026, '\p{Is_Script_Extensions=	-MEETEI_Mayek}', "");
    Expect(1, 44026, '\p{^Is_Script_Extensions=	-MEETEI_Mayek}', "");
    Expect(1, 44026, '\P{Is_Script_Extensions=	-MEETEI_Mayek}', "");
    Expect(0, 44026, '\P{^Is_Script_Extensions=	-MEETEI_Mayek}', "");
    Error('\p{Is_Scx::=_	Mtei}');
    Error('\P{Is_Scx::=_	Mtei}');
    Expect(1, 44025, '\p{Is_Scx=mtei}', "");
    Expect(0, 44025, '\p{^Is_Scx=mtei}', "");
    Expect(0, 44025, '\P{Is_Scx=mtei}', "");
    Expect(1, 44025, '\P{^Is_Scx=mtei}', "");
    Expect(0, 44026, '\p{Is_Scx=mtei}', "");
    Expect(1, 44026, '\p{^Is_Scx=mtei}', "");
    Expect(1, 44026, '\P{Is_Scx=mtei}', "");
    Expect(0, 44026, '\P{^Is_Scx=mtei}', "");
    Expect(1, 44025, '\p{Is_Scx=_-MTEI}', "");
    Expect(0, 44025, '\p{^Is_Scx=_-MTEI}', "");
    Expect(0, 44025, '\P{Is_Scx=_-MTEI}', "");
    Expect(1, 44025, '\P{^Is_Scx=_-MTEI}', "");
    Expect(0, 44026, '\p{Is_Scx=_-MTEI}', "");
    Expect(1, 44026, '\p{^Is_Scx=_-MTEI}', "");
    Expect(1, 44026, '\P{Is_Scx=_-MTEI}', "");
    Expect(0, 44026, '\P{^Is_Scx=_-MTEI}', "");
    Error('\p{Script_Extensions=/a/ _MULTANI}');
    Error('\P{Script_Extensions=/a/ _MULTANI}');
    Expect(1, 70313, '\p{Script_Extensions=multani}', "");
    Expect(0, 70313, '\p{^Script_Extensions=multani}', "");
    Expect(0, 70313, '\P{Script_Extensions=multani}', "");
    Expect(1, 70313, '\P{^Script_Extensions=multani}', "");
    Expect(0, 70314, '\p{Script_Extensions=multani}', "");
    Expect(1, 70314, '\p{^Script_Extensions=multani}', "");
    Expect(1, 70314, '\P{Script_Extensions=multani}', "");
    Expect(0, 70314, '\P{^Script_Extensions=multani}', "");
    Expect(1, 70313, '\p{Script_Extensions= Multani}', "");
    Expect(0, 70313, '\p{^Script_Extensions= Multani}', "");
    Expect(0, 70313, '\P{Script_Extensions= Multani}', "");
    Expect(1, 70313, '\P{^Script_Extensions= Multani}', "");
    Expect(0, 70314, '\p{Script_Extensions= Multani}', "");
    Expect(1, 70314, '\p{^Script_Extensions= Multani}', "");
    Expect(1, 70314, '\P{Script_Extensions= Multani}', "");
    Expect(0, 70314, '\P{^Script_Extensions= Multani}', "");
    Error('\p{Scx=:=-mult}');
    Error('\P{Scx=:=-mult}');
    Expect(1, 70313, '\p{Scx:   mult}', "");
    Expect(0, 70313, '\p{^Scx:   mult}', "");
    Expect(0, 70313, '\P{Scx:   mult}', "");
    Expect(1, 70313, '\P{^Scx:   mult}', "");
    Expect(0, 70314, '\p{Scx:   mult}', "");
    Expect(1, 70314, '\p{^Scx:   mult}', "");
    Expect(1, 70314, '\P{Scx:   mult}', "");
    Expect(0, 70314, '\P{^Scx:   mult}', "");
    Expect(1, 70313, '\p{Scx= _Mult}', "");
    Expect(0, 70313, '\p{^Scx= _Mult}', "");
    Expect(0, 70313, '\P{Scx= _Mult}', "");
    Expect(1, 70313, '\P{^Scx= _Mult}', "");
    Expect(0, 70314, '\p{Scx= _Mult}', "");
    Expect(1, 70314, '\p{^Scx= _Mult}', "");
    Expect(1, 70314, '\P{Scx= _Mult}', "");
    Expect(0, 70314, '\P{^Scx= _Mult}', "");
    Error('\p{Is_Script_Extensions=  Multani/a/}');
    Error('\P{Is_Script_Extensions=  Multani/a/}');
    Expect(1, 70313, '\p{Is_Script_Extensions=multani}', "");
    Expect(0, 70313, '\p{^Is_Script_Extensions=multani}', "");
    Expect(0, 70313, '\P{Is_Script_Extensions=multani}', "");
    Expect(1, 70313, '\P{^Is_Script_Extensions=multani}', "");
    Expect(0, 70314, '\p{Is_Script_Extensions=multani}', "");
    Expect(1, 70314, '\p{^Is_Script_Extensions=multani}', "");
    Expect(1, 70314, '\P{Is_Script_Extensions=multani}', "");
    Expect(0, 70314, '\P{^Is_Script_Extensions=multani}', "");
    Expect(1, 70313, '\p{Is_Script_Extensions=_ multani}', "");
    Expect(0, 70313, '\p{^Is_Script_Extensions=_ multani}', "");
    Expect(0, 70313, '\P{Is_Script_Extensions=_ multani}', "");
    Expect(1, 70313, '\P{^Is_Script_Extensions=_ multani}', "");
    Expect(0, 70314, '\p{Is_Script_Extensions=_ multani}', "");
    Expect(1, 70314, '\p{^Is_Script_Extensions=_ multani}', "");
    Expect(1, 70314, '\P{Is_Script_Extensions=_ multani}', "");
    Expect(0, 70314, '\P{^Is_Script_Extensions=_ multani}', "");
    Error('\p{Is_Scx=_ Mult:=}');
    Error('\P{Is_Scx=_ Mult:=}');
    Expect(1, 70313, '\p{Is_Scx=mult}', "");
    Expect(0, 70313, '\p{^Is_Scx=mult}', "");
    Expect(0, 70313, '\P{Is_Scx=mult}', "");
    Expect(1, 70313, '\P{^Is_Scx=mult}', "");
    Expect(0, 70314, '\p{Is_Scx=mult}', "");
    Expect(1, 70314, '\p{^Is_Scx=mult}', "");
    Expect(1, 70314, '\P{Is_Scx=mult}', "");
    Expect(0, 70314, '\P{^Is_Scx=mult}', "");
    Expect(1, 70313, '\p{Is_Scx= Mult}', "");
    Expect(0, 70313, '\p{^Is_Scx= Mult}', "");
    Expect(0, 70313, '\P{Is_Scx= Mult}', "");
    Expect(1, 70313, '\P{^Is_Scx= Mult}', "");
    Expect(0, 70314, '\p{Is_Scx= Mult}', "");
    Expect(1, 70314, '\p{^Is_Scx= Mult}', "");
    Expect(1, 70314, '\P{Is_Scx= Mult}', "");
    Expect(0, 70314, '\P{^Is_Scx= Mult}', "");
    Error('\p{Script_Extensions=:=-Myanmar}');
    Error('\P{Script_Extensions=:=-Myanmar}');
    Expect(1, 43647, '\p{Script_Extensions=myanmar}', "");
    Expect(0, 43647, '\p{^Script_Extensions=myanmar}', "");
    Expect(0, 43647, '\P{Script_Extensions=myanmar}', "");
    Expect(1, 43647, '\P{^Script_Extensions=myanmar}', "");
    Expect(0, 43648, '\p{Script_Extensions=myanmar}', "");
    Expect(1, 43648, '\p{^Script_Extensions=myanmar}', "");
    Expect(1, 43648, '\P{Script_Extensions=myanmar}', "");
    Expect(0, 43648, '\P{^Script_Extensions=myanmar}', "");
    Expect(1, 43647, '\p{Script_Extensions:	- myanmar}', "");
    Expect(0, 43647, '\p{^Script_Extensions:	- myanmar}', "");
    Expect(0, 43647, '\P{Script_Extensions:	- myanmar}', "");
    Expect(1, 43647, '\P{^Script_Extensions:	- myanmar}', "");
    Expect(0, 43648, '\p{Script_Extensions:	- myanmar}', "");
    Expect(1, 43648, '\p{^Script_Extensions:	- myanmar}', "");
    Expect(1, 43648, '\P{Script_Extensions:	- myanmar}', "");
    Expect(0, 43648, '\P{^Script_Extensions:	- myanmar}', "");
    Error('\p{Scx=	mymr/a/}');
    Error('\P{Scx=	mymr/a/}');
    Expect(1, 43647, '\p{Scx=mymr}', "");
    Expect(0, 43647, '\p{^Scx=mymr}', "");
    Expect(0, 43647, '\P{Scx=mymr}', "");
    Expect(1, 43647, '\P{^Scx=mymr}', "");
    Expect(0, 43648, '\p{Scx=mymr}', "");
    Expect(1, 43648, '\p{^Scx=mymr}', "");
    Expect(1, 43648, '\P{Scx=mymr}', "");
    Expect(0, 43648, '\P{^Scx=mymr}', "");
    Expect(1, 43647, '\p{Scx= MYMR}', "");
    Expect(0, 43647, '\p{^Scx= MYMR}', "");
    Expect(0, 43647, '\P{Scx= MYMR}', "");
    Expect(1, 43647, '\P{^Scx= MYMR}', "");
    Expect(0, 43648, '\p{Scx= MYMR}', "");
    Expect(1, 43648, '\p{^Scx= MYMR}', "");
    Expect(1, 43648, '\P{Scx= MYMR}', "");
    Expect(0, 43648, '\P{^Scx= MYMR}', "");
    Error('\p{Is_Script_Extensions=-myanmar/a/}');
    Error('\P{Is_Script_Extensions=-myanmar/a/}');
    Expect(1, 43647, '\p{Is_Script_Extensions=myanmar}', "");
    Expect(0, 43647, '\p{^Is_Script_Extensions=myanmar}', "");
    Expect(0, 43647, '\P{Is_Script_Extensions=myanmar}', "");
    Expect(1, 43647, '\P{^Is_Script_Extensions=myanmar}', "");
    Expect(0, 43648, '\p{Is_Script_Extensions=myanmar}', "");
    Expect(1, 43648, '\p{^Is_Script_Extensions=myanmar}', "");
    Expect(1, 43648, '\P{Is_Script_Extensions=myanmar}', "");
    Expect(0, 43648, '\P{^Is_Script_Extensions=myanmar}', "");
    Expect(1, 43647, '\p{Is_Script_Extensions=	Myanmar}', "");
    Expect(0, 43647, '\p{^Is_Script_Extensions=	Myanmar}', "");
    Expect(0, 43647, '\P{Is_Script_Extensions=	Myanmar}', "");
    Expect(1, 43647, '\P{^Is_Script_Extensions=	Myanmar}', "");
    Expect(0, 43648, '\p{Is_Script_Extensions=	Myanmar}', "");
    Expect(1, 43648, '\p{^Is_Script_Extensions=	Myanmar}', "");
    Expect(1, 43648, '\P{Is_Script_Extensions=	Myanmar}', "");
    Expect(0, 43648, '\P{^Is_Script_Extensions=	Myanmar}', "");
    Error('\p{Is_Scx=-Mymr:=}');
    Error('\P{Is_Scx=-Mymr:=}');
    Expect(1, 43647, '\p{Is_Scx=mymr}', "");
    Expect(0, 43647, '\p{^Is_Scx=mymr}', "");
    Expect(0, 43647, '\P{Is_Scx=mymr}', "");
    Expect(1, 43647, '\P{^Is_Scx=mymr}', "");
    Expect(0, 43648, '\p{Is_Scx=mymr}', "");
    Expect(1, 43648, '\p{^Is_Scx=mymr}', "");
    Expect(1, 43648, '\P{Is_Scx=mymr}', "");
    Expect(0, 43648, '\P{^Is_Scx=mymr}', "");
    Expect(1, 43647, '\p{Is_Scx=- Mymr}', "");
    Expect(0, 43647, '\p{^Is_Scx=- Mymr}', "");
    Expect(0, 43647, '\P{Is_Scx=- Mymr}', "");
    Expect(1, 43647, '\P{^Is_Scx=- Mymr}', "");
    Expect(0, 43648, '\p{Is_Scx=- Mymr}', "");
    Expect(1, 43648, '\p{^Is_Scx=- Mymr}', "");
    Expect(1, 43648, '\P{Is_Scx=- Mymr}', "");
    Expect(0, 43648, '\P{^Is_Scx=- Mymr}', "");
    Error('\p{Script_Extensions=__old_north_arabian/a/}');
    Error('\P{Script_Extensions=__old_north_arabian/a/}');
    Expect(1, 68255, '\p{Script_Extensions=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Script_Extensions=oldnortharabian}', "");
    Expect(0, 68255, '\P{Script_Extensions=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Script_Extensions=oldnortharabian}', "");
    Expect(0, 68256, '\p{Script_Extensions=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Script_Extensions=oldnortharabian}', "");
    Expect(1, 68256, '\P{Script_Extensions=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Script_Extensions=oldnortharabian}', "");
    Expect(1, 68255, '\p{Script_Extensions=	-Old_North_arabian}', "");
    Expect(0, 68255, '\p{^Script_Extensions=	-Old_North_arabian}', "");
    Expect(0, 68255, '\P{Script_Extensions=	-Old_North_arabian}', "");
    Expect(1, 68255, '\P{^Script_Extensions=	-Old_North_arabian}', "");
    Expect(0, 68256, '\p{Script_Extensions=	-Old_North_arabian}', "");
    Expect(1, 68256, '\p{^Script_Extensions=	-Old_North_arabian}', "");
    Expect(1, 68256, '\P{Script_Extensions=	-Old_North_arabian}', "");
    Expect(0, 68256, '\P{^Script_Extensions=	-Old_North_arabian}', "");
    Error('\p{Scx=/a/_Narb}');
    Error('\P{Scx=/a/_Narb}');
    Expect(1, 68255, '\p{Scx=narb}', "");
    Expect(0, 68255, '\p{^Scx=narb}', "");
    Expect(0, 68255, '\P{Scx=narb}', "");
    Expect(1, 68255, '\P{^Scx=narb}', "");
    Expect(0, 68256, '\p{Scx=narb}', "");
    Expect(1, 68256, '\p{^Scx=narb}', "");
    Expect(1, 68256, '\P{Scx=narb}', "");
    Expect(0, 68256, '\P{^Scx=narb}', "");
    Expect(1, 68255, '\p{Scx=	_NARB}', "");
    Expect(0, 68255, '\p{^Scx=	_NARB}', "");
    Expect(0, 68255, '\P{Scx=	_NARB}', "");
    Expect(1, 68255, '\P{^Scx=	_NARB}', "");
    Expect(0, 68256, '\p{Scx=	_NARB}', "");
    Expect(1, 68256, '\p{^Scx=	_NARB}', "");
    Expect(1, 68256, '\P{Scx=	_NARB}', "");
    Expect(0, 68256, '\P{^Scx=	_NARB}', "");
    Error('\p{Is_Script_Extensions=	/a/old_NORTH_ARABIAN}');
    Error('\P{Is_Script_Extensions=	/a/old_NORTH_ARABIAN}');
    Expect(1, 68255, '\p{Is_Script_Extensions=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Is_Script_Extensions=oldnortharabian}', "");
    Expect(0, 68255, '\P{Is_Script_Extensions=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Is_Script_Extensions=oldnortharabian}', "");
    Expect(0, 68256, '\p{Is_Script_Extensions=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Is_Script_Extensions=oldnortharabian}', "");
    Expect(1, 68256, '\P{Is_Script_Extensions=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Is_Script_Extensions=oldnortharabian}', "");
    Expect(1, 68255, '\p{Is_Script_Extensions=-Old_north_Arabian}', "");
    Expect(0, 68255, '\p{^Is_Script_Extensions=-Old_north_Arabian}', "");
    Expect(0, 68255, '\P{Is_Script_Extensions=-Old_north_Arabian}', "");
    Expect(1, 68255, '\P{^Is_Script_Extensions=-Old_north_Arabian}', "");
    Expect(0, 68256, '\p{Is_Script_Extensions=-Old_north_Arabian}', "");
    Expect(1, 68256, '\p{^Is_Script_Extensions=-Old_north_Arabian}', "");
    Expect(1, 68256, '\P{Is_Script_Extensions=-Old_north_Arabian}', "");
    Expect(0, 68256, '\P{^Is_Script_Extensions=-Old_north_Arabian}', "");
    Error('\p{Is_Scx: 	 narb/a/}');
    Error('\P{Is_Scx: 	 narb/a/}');
    Expect(1, 68255, '\p{Is_Scx=narb}', "");
    Expect(0, 68255, '\p{^Is_Scx=narb}', "");
    Expect(0, 68255, '\P{Is_Scx=narb}', "");
    Expect(1, 68255, '\P{^Is_Scx=narb}', "");
    Expect(0, 68256, '\p{Is_Scx=narb}', "");
    Expect(1, 68256, '\p{^Is_Scx=narb}', "");
    Expect(1, 68256, '\P{Is_Scx=narb}', "");
    Expect(0, 68256, '\P{^Is_Scx=narb}', "");
    Expect(1, 68255, '\p{Is_Scx=_-Narb}', "");
    Expect(0, 68255, '\p{^Is_Scx=_-Narb}', "");
    Expect(0, 68255, '\P{Is_Scx=_-Narb}', "");
    Expect(1, 68255, '\P{^Is_Scx=_-Narb}', "");
    Expect(0, 68256, '\p{Is_Scx=_-Narb}', "");
    Expect(1, 68256, '\p{^Is_Scx=_-Narb}', "");
    Expect(1, 68256, '\P{Is_Scx=_-Narb}', "");
    Expect(0, 68256, '\P{^Is_Scx=_-Narb}', "");
    Error('\p{Script_Extensions: /a/	_nabataean}');
    Error('\P{Script_Extensions: /a/	_nabataean}');
    Expect(1, 67759, '\p{Script_Extensions=nabataean}', "");
    Expect(0, 67759, '\p{^Script_Extensions=nabataean}', "");
    Expect(0, 67759, '\P{Script_Extensions=nabataean}', "");
    Expect(1, 67759, '\P{^Script_Extensions=nabataean}', "");
    Expect(0, 67760, '\p{Script_Extensions=nabataean}', "");
    Expect(1, 67760, '\p{^Script_Extensions=nabataean}', "");
    Expect(1, 67760, '\P{Script_Extensions=nabataean}', "");
    Expect(0, 67760, '\P{^Script_Extensions=nabataean}', "");
    Expect(1, 67759, '\p{Script_Extensions= -Nabataean}', "");
    Expect(0, 67759, '\p{^Script_Extensions= -Nabataean}', "");
    Expect(0, 67759, '\P{Script_Extensions= -Nabataean}', "");
    Expect(1, 67759, '\P{^Script_Extensions= -Nabataean}', "");
    Expect(0, 67760, '\p{Script_Extensions= -Nabataean}', "");
    Expect(1, 67760, '\p{^Script_Extensions= -Nabataean}', "");
    Expect(1, 67760, '\P{Script_Extensions= -Nabataean}', "");
    Expect(0, 67760, '\P{^Script_Extensions= -Nabataean}', "");
    Error('\p{Scx=	 Nbat:=}');
    Error('\P{Scx=	 Nbat:=}');
    Expect(1, 67759, '\p{Scx:nbat}', "");
    Expect(0, 67759, '\p{^Scx:nbat}', "");
    Expect(0, 67759, '\P{Scx:nbat}', "");
    Expect(1, 67759, '\P{^Scx:nbat}', "");
    Expect(0, 67760, '\p{Scx:nbat}', "");
    Expect(1, 67760, '\p{^Scx:nbat}', "");
    Expect(1, 67760, '\P{Scx:nbat}', "");
    Expect(0, 67760, '\P{^Scx:nbat}', "");
    Expect(1, 67759, '\p{Scx=	nbat}', "");
    Expect(0, 67759, '\p{^Scx=	nbat}', "");
    Expect(0, 67759, '\P{Scx=	nbat}', "");
    Expect(1, 67759, '\P{^Scx=	nbat}', "");
    Expect(0, 67760, '\p{Scx=	nbat}', "");
    Expect(1, 67760, '\p{^Scx=	nbat}', "");
    Expect(1, 67760, '\P{Scx=	nbat}', "");
    Expect(0, 67760, '\P{^Scx=	nbat}', "");
    Error('\p{Is_Script_Extensions:	_Nabataean/a/}');
    Error('\P{Is_Script_Extensions:	_Nabataean/a/}');
    Expect(1, 67759, '\p{Is_Script_Extensions:nabataean}', "");
    Expect(0, 67759, '\p{^Is_Script_Extensions:nabataean}', "");
    Expect(0, 67759, '\P{Is_Script_Extensions:nabataean}', "");
    Expect(1, 67759, '\P{^Is_Script_Extensions:nabataean}', "");
    Expect(0, 67760, '\p{Is_Script_Extensions:nabataean}', "");
    Expect(1, 67760, '\p{^Is_Script_Extensions:nabataean}', "");
    Expect(1, 67760, '\P{Is_Script_Extensions:nabataean}', "");
    Expect(0, 67760, '\P{^Is_Script_Extensions:nabataean}', "");
    Expect(1, 67759, '\p{Is_Script_Extensions=_	Nabataean}', "");
    Expect(0, 67759, '\p{^Is_Script_Extensions=_	Nabataean}', "");
    Expect(0, 67759, '\P{Is_Script_Extensions=_	Nabataean}', "");
    Expect(1, 67759, '\P{^Is_Script_Extensions=_	Nabataean}', "");
    Expect(0, 67760, '\p{Is_Script_Extensions=_	Nabataean}', "");
    Expect(1, 67760, '\p{^Is_Script_Extensions=_	Nabataean}', "");
    Expect(1, 67760, '\P{Is_Script_Extensions=_	Nabataean}', "");
    Expect(0, 67760, '\P{^Is_Script_Extensions=_	Nabataean}', "");
    Error('\p{Is_Scx=	-nbat/a/}');
    Error('\P{Is_Scx=	-nbat/a/}');
    Expect(1, 67759, '\p{Is_Scx=nbat}', "");
    Expect(0, 67759, '\p{^Is_Scx=nbat}', "");
    Expect(0, 67759, '\P{Is_Scx=nbat}', "");
    Expect(1, 67759, '\P{^Is_Scx=nbat}', "");
    Expect(0, 67760, '\p{Is_Scx=nbat}', "");
    Expect(1, 67760, '\p{^Is_Scx=nbat}', "");
    Expect(1, 67760, '\P{Is_Scx=nbat}', "");
    Expect(0, 67760, '\P{^Is_Scx=nbat}', "");
    Expect(1, 67759, '\p{Is_Scx=--NBAT}', "");
    Expect(0, 67759, '\p{^Is_Scx=--NBAT}', "");
    Expect(0, 67759, '\P{Is_Scx=--NBAT}', "");
    Expect(1, 67759, '\P{^Is_Scx=--NBAT}', "");
    Expect(0, 67760, '\p{Is_Scx=--NBAT}', "");
    Expect(1, 67760, '\p{^Is_Scx=--NBAT}', "");
    Expect(1, 67760, '\P{Is_Scx=--NBAT}', "");
    Expect(0, 67760, '\P{^Is_Scx=--NBAT}', "");
    Error('\p{Script_Extensions=	 newa/a/}');
    Error('\P{Script_Extensions=	 newa/a/}');
    Expect(1, 70749, '\p{Script_Extensions=newa}', "");
    Expect(0, 70749, '\p{^Script_Extensions=newa}', "");
    Expect(0, 70749, '\P{Script_Extensions=newa}', "");
    Expect(1, 70749, '\P{^Script_Extensions=newa}', "");
    Expect(0, 70750, '\p{Script_Extensions=newa}', "");
    Expect(1, 70750, '\p{^Script_Extensions=newa}', "");
    Expect(1, 70750, '\P{Script_Extensions=newa}', "");
    Expect(0, 70750, '\P{^Script_Extensions=newa}', "");
    Expect(1, 70749, '\p{Script_Extensions:		_Newa}', "");
    Expect(0, 70749, '\p{^Script_Extensions:		_Newa}', "");
    Expect(0, 70749, '\P{Script_Extensions:		_Newa}', "");
    Expect(1, 70749, '\P{^Script_Extensions:		_Newa}', "");
    Expect(0, 70750, '\p{Script_Extensions:		_Newa}', "");
    Expect(1, 70750, '\p{^Script_Extensions:		_Newa}', "");
    Expect(1, 70750, '\P{Script_Extensions:		_Newa}', "");
    Expect(0, 70750, '\P{^Script_Extensions:		_Newa}', "");
    Error('\p{Scx=	/a/newa}');
    Error('\P{Scx=	/a/newa}');
    Expect(1, 70749, '\p{Scx:newa}', "");
    Expect(0, 70749, '\p{^Scx:newa}', "");
    Expect(0, 70749, '\P{Scx:newa}', "");
    Expect(1, 70749, '\P{^Scx:newa}', "");
    Expect(0, 70750, '\p{Scx:newa}', "");
    Expect(1, 70750, '\p{^Scx:newa}', "");
    Expect(1, 70750, '\P{Scx:newa}', "");
    Expect(0, 70750, '\P{^Scx:newa}', "");
    Expect(1, 70749, '\p{Scx=__Newa}', "");
    Expect(0, 70749, '\p{^Scx=__Newa}', "");
    Expect(0, 70749, '\P{Scx=__Newa}', "");
    Expect(1, 70749, '\P{^Scx=__Newa}', "");
    Expect(0, 70750, '\p{Scx=__Newa}', "");
    Expect(1, 70750, '\p{^Scx=__Newa}', "");
    Expect(1, 70750, '\P{Scx=__Newa}', "");
    Expect(0, 70750, '\P{^Scx=__Newa}', "");
    Error('\p{Is_Script_Extensions=	newa:=}');
    Error('\P{Is_Script_Extensions=	newa:=}');
    Expect(1, 70749, '\p{Is_Script_Extensions=newa}', "");
    Expect(0, 70749, '\p{^Is_Script_Extensions=newa}', "");
    Expect(0, 70749, '\P{Is_Script_Extensions=newa}', "");
    Expect(1, 70749, '\P{^Is_Script_Extensions=newa}', "");
    Expect(0, 70750, '\p{Is_Script_Extensions=newa}', "");
    Expect(1, 70750, '\p{^Is_Script_Extensions=newa}', "");
    Expect(1, 70750, '\P{Is_Script_Extensions=newa}', "");
    Expect(0, 70750, '\P{^Is_Script_Extensions=newa}', "");
    Expect(1, 70749, '\p{Is_Script_Extensions=Newa}', "");
    Expect(0, 70749, '\p{^Is_Script_Extensions=Newa}', "");
    Expect(0, 70749, '\P{Is_Script_Extensions=Newa}', "");
    Expect(1, 70749, '\P{^Is_Script_Extensions=Newa}', "");
    Expect(0, 70750, '\p{Is_Script_Extensions=Newa}', "");
    Expect(1, 70750, '\p{^Is_Script_Extensions=Newa}', "");
    Expect(1, 70750, '\P{Is_Script_Extensions=Newa}', "");
    Expect(0, 70750, '\P{^Is_Script_Extensions=Newa}', "");
    Error('\p{Is_Scx= /a/Newa}');
    Error('\P{Is_Scx= /a/Newa}');
    Expect(1, 70749, '\p{Is_Scx=newa}', "");
    Expect(0, 70749, '\p{^Is_Scx=newa}', "");
    Expect(0, 70749, '\P{Is_Scx=newa}', "");
    Expect(1, 70749, '\P{^Is_Scx=newa}', "");
    Expect(0, 70750, '\p{Is_Scx=newa}', "");
    Expect(1, 70750, '\p{^Is_Scx=newa}', "");
    Expect(1, 70750, '\P{Is_Scx=newa}', "");
    Expect(0, 70750, '\P{^Is_Scx=newa}', "");
    Expect(1, 70749, '\p{Is_Scx=_ Newa}', "");
    Expect(0, 70749, '\p{^Is_Scx=_ Newa}', "");
    Expect(0, 70749, '\P{Is_Scx=_ Newa}', "");
    Expect(1, 70749, '\P{^Is_Scx=_ Newa}', "");
    Expect(0, 70750, '\p{Is_Scx=_ Newa}', "");
    Expect(1, 70750, '\p{^Is_Scx=_ Newa}', "");
    Expect(1, 70750, '\P{Is_Scx=_ Newa}', "");
    Expect(0, 70750, '\P{^Is_Scx=_ Newa}', "");
    Error('\p{Script_Extensions=/a/ 	Nko}');
    Error('\P{Script_Extensions=/a/ 	Nko}');
    Expect(1, 2042, '\p{Script_Extensions=nko}', "");
    Expect(0, 2042, '\p{^Script_Extensions=nko}', "");
    Expect(0, 2042, '\P{Script_Extensions=nko}', "");
    Expect(1, 2042, '\P{^Script_Extensions=nko}', "");
    Expect(0, 2043, '\p{Script_Extensions=nko}', "");
    Expect(1, 2043, '\p{^Script_Extensions=nko}', "");
    Expect(1, 2043, '\P{Script_Extensions=nko}', "");
    Expect(0, 2043, '\P{^Script_Extensions=nko}', "");
    Expect(1, 2042, '\p{Script_Extensions= 	NKO}', "");
    Expect(0, 2042, '\p{^Script_Extensions= 	NKO}', "");
    Expect(0, 2042, '\P{Script_Extensions= 	NKO}', "");
    Expect(1, 2042, '\P{^Script_Extensions= 	NKO}', "");
    Expect(0, 2043, '\p{Script_Extensions= 	NKO}', "");
    Expect(1, 2043, '\p{^Script_Extensions= 	NKO}', "");
    Expect(1, 2043, '\P{Script_Extensions= 	NKO}', "");
    Expect(0, 2043, '\P{^Script_Extensions= 	NKO}', "");
    Error('\p{Scx=/a/	-NKOO}');
    Error('\P{Scx=/a/	-NKOO}');
    Expect(1, 2042, '\p{Scx:   nkoo}', "");
    Expect(0, 2042, '\p{^Scx:   nkoo}', "");
    Expect(0, 2042, '\P{Scx:   nkoo}', "");
    Expect(1, 2042, '\P{^Scx:   nkoo}', "");
    Expect(0, 2043, '\p{Scx:   nkoo}', "");
    Expect(1, 2043, '\p{^Scx:   nkoo}', "");
    Expect(1, 2043, '\P{Scx:   nkoo}', "");
    Expect(0, 2043, '\P{^Scx:   nkoo}', "");
    Expect(1, 2042, '\p{Scx=_-Nkoo}', "");
    Expect(0, 2042, '\p{^Scx=_-Nkoo}', "");
    Expect(0, 2042, '\P{Scx=_-Nkoo}', "");
    Expect(1, 2042, '\P{^Scx=_-Nkoo}', "");
    Expect(0, 2043, '\p{Scx=_-Nkoo}', "");
    Expect(1, 2043, '\p{^Scx=_-Nkoo}', "");
    Expect(1, 2043, '\P{Scx=_-Nkoo}', "");
    Expect(0, 2043, '\P{^Scx=_-Nkoo}', "");
    Error('\p{Is_Script_Extensions= Nko:=}');
    Error('\P{Is_Script_Extensions= Nko:=}');
    Expect(1, 2042, '\p{Is_Script_Extensions=nko}', "");
    Expect(0, 2042, '\p{^Is_Script_Extensions=nko}', "");
    Expect(0, 2042, '\P{Is_Script_Extensions=nko}', "");
    Expect(1, 2042, '\P{^Is_Script_Extensions=nko}', "");
    Expect(0, 2043, '\p{Is_Script_Extensions=nko}', "");
    Expect(1, 2043, '\p{^Is_Script_Extensions=nko}', "");
    Expect(1, 2043, '\P{Is_Script_Extensions=nko}', "");
    Expect(0, 2043, '\P{^Is_Script_Extensions=nko}', "");
    Expect(1, 2042, '\p{Is_Script_Extensions= -Nko}', "");
    Expect(0, 2042, '\p{^Is_Script_Extensions= -Nko}', "");
    Expect(0, 2042, '\P{Is_Script_Extensions= -Nko}', "");
    Expect(1, 2042, '\P{^Is_Script_Extensions= -Nko}', "");
    Expect(0, 2043, '\p{Is_Script_Extensions= -Nko}', "");
    Expect(1, 2043, '\p{^Is_Script_Extensions= -Nko}', "");
    Expect(1, 2043, '\P{Is_Script_Extensions= -Nko}', "");
    Expect(0, 2043, '\P{^Is_Script_Extensions= -Nko}', "");
    Error('\p{Is_Scx=	/a/Nkoo}');
    Error('\P{Is_Scx=	/a/Nkoo}');
    Expect(1, 2042, '\p{Is_Scx=nkoo}', "");
    Expect(0, 2042, '\p{^Is_Scx=nkoo}', "");
    Expect(0, 2042, '\P{Is_Scx=nkoo}', "");
    Expect(1, 2042, '\P{^Is_Scx=nkoo}', "");
    Expect(0, 2043, '\p{Is_Scx=nkoo}', "");
    Expect(1, 2043, '\p{^Is_Scx=nkoo}', "");
    Expect(1, 2043, '\P{Is_Scx=nkoo}', "");
    Expect(0, 2043, '\P{^Is_Scx=nkoo}', "");
    Expect(1, 2042, '\p{Is_Scx=__nkoo}', "");
    Expect(0, 2042, '\p{^Is_Scx=__nkoo}', "");
    Expect(0, 2042, '\P{Is_Scx=__nkoo}', "");
    Expect(1, 2042, '\P{^Is_Scx=__nkoo}', "");
    Expect(0, 2043, '\p{Is_Scx=__nkoo}', "");
    Expect(1, 2043, '\p{^Is_Scx=__nkoo}', "");
    Expect(1, 2043, '\P{Is_Scx=__nkoo}', "");
    Expect(0, 2043, '\P{^Is_Scx=__nkoo}', "");
    Error('\p{Script_Extensions=	Nushu/a/}');
    Error('\P{Script_Extensions=	Nushu/a/}');
    Expect(1, 111355, '\p{Script_Extensions=nushu}', "");
    Expect(0, 111355, '\p{^Script_Extensions=nushu}', "");
    Expect(0, 111355, '\P{Script_Extensions=nushu}', "");
    Expect(1, 111355, '\P{^Script_Extensions=nushu}', "");
    Expect(0, 111356, '\p{Script_Extensions=nushu}', "");
    Expect(1, 111356, '\p{^Script_Extensions=nushu}', "");
    Expect(1, 111356, '\P{Script_Extensions=nushu}', "");
    Expect(0, 111356, '\P{^Script_Extensions=nushu}', "");
    Expect(1, 111355, '\p{Script_Extensions= 	NUSHU}', "");
    Expect(0, 111355, '\p{^Script_Extensions= 	NUSHU}', "");
    Expect(0, 111355, '\P{Script_Extensions= 	NUSHU}', "");
    Expect(1, 111355, '\P{^Script_Extensions= 	NUSHU}', "");
    Expect(0, 111356, '\p{Script_Extensions= 	NUSHU}', "");
    Expect(1, 111356, '\p{^Script_Extensions= 	NUSHU}', "");
    Expect(1, 111356, '\P{Script_Extensions= 	NUSHU}', "");
    Expect(0, 111356, '\P{^Script_Extensions= 	NUSHU}', "");
    Error('\p{Scx=/a/  nshu}');
    Error('\P{Scx=/a/  nshu}');
    Expect(1, 111355, '\p{Scx:   nshu}', "");
    Expect(0, 111355, '\p{^Scx:   nshu}', "");
    Expect(0, 111355, '\P{Scx:   nshu}', "");
    Expect(1, 111355, '\P{^Scx:   nshu}', "");
    Expect(0, 111356, '\p{Scx:   nshu}', "");
    Expect(1, 111356, '\p{^Scx:   nshu}', "");
    Expect(1, 111356, '\P{Scx:   nshu}', "");
    Expect(0, 111356, '\P{^Scx:   nshu}', "");
    Expect(1, 111355, '\p{Scx=--NSHU}', "");
    Expect(0, 111355, '\p{^Scx=--NSHU}', "");
    Expect(0, 111355, '\P{Scx=--NSHU}', "");
    Expect(1, 111355, '\P{^Scx=--NSHU}', "");
    Expect(0, 111356, '\p{Scx=--NSHU}', "");
    Expect(1, 111356, '\p{^Scx=--NSHU}', "");
    Expect(1, 111356, '\P{Scx=--NSHU}', "");
    Expect(0, 111356, '\P{^Scx=--NSHU}', "");
    Error('\p{Is_Script_Extensions= 	nushu/a/}');
    Error('\P{Is_Script_Extensions= 	nushu/a/}');
    Expect(1, 111355, '\p{Is_Script_Extensions=nushu}', "");
    Expect(0, 111355, '\p{^Is_Script_Extensions=nushu}', "");
    Expect(0, 111355, '\P{Is_Script_Extensions=nushu}', "");
    Expect(1, 111355, '\P{^Is_Script_Extensions=nushu}', "");
    Expect(0, 111356, '\p{Is_Script_Extensions=nushu}', "");
    Expect(1, 111356, '\p{^Is_Script_Extensions=nushu}', "");
    Expect(1, 111356, '\P{Is_Script_Extensions=nushu}', "");
    Expect(0, 111356, '\P{^Is_Script_Extensions=nushu}', "");
    Expect(1, 111355, '\p{Is_Script_Extensions= Nushu}', "");
    Expect(0, 111355, '\p{^Is_Script_Extensions= Nushu}', "");
    Expect(0, 111355, '\P{Is_Script_Extensions= Nushu}', "");
    Expect(1, 111355, '\P{^Is_Script_Extensions= Nushu}', "");
    Expect(0, 111356, '\p{Is_Script_Extensions= Nushu}', "");
    Expect(1, 111356, '\p{^Is_Script_Extensions= Nushu}', "");
    Expect(1, 111356, '\P{Is_Script_Extensions= Nushu}', "");
    Expect(0, 111356, '\P{^Is_Script_Extensions= Nushu}', "");
    Error('\p{Is_Scx=-_nshu:=}');
    Error('\P{Is_Scx=-_nshu:=}');
    Expect(1, 111355, '\p{Is_Scx=nshu}', "");
    Expect(0, 111355, '\p{^Is_Scx=nshu}', "");
    Expect(0, 111355, '\P{Is_Scx=nshu}', "");
    Expect(1, 111355, '\P{^Is_Scx=nshu}', "");
    Expect(0, 111356, '\p{Is_Scx=nshu}', "");
    Expect(1, 111356, '\p{^Is_Scx=nshu}', "");
    Expect(1, 111356, '\P{Is_Scx=nshu}', "");
    Expect(0, 111356, '\P{^Is_Scx=nshu}', "");
    Expect(1, 111355, '\p{Is_Scx=		Nshu}', "");
    Expect(0, 111355, '\p{^Is_Scx=		Nshu}', "");
    Expect(0, 111355, '\P{Is_Scx=		Nshu}', "");
    Expect(1, 111355, '\P{^Is_Scx=		Nshu}', "");
    Expect(0, 111356, '\p{Is_Scx=		Nshu}', "");
    Expect(1, 111356, '\p{^Is_Scx=		Nshu}', "");
    Expect(1, 111356, '\P{Is_Scx=		Nshu}', "");
    Expect(0, 111356, '\P{^Is_Scx=		Nshu}', "");
    Error('\p{Script_Extensions: 	-ogham/a/}');
    Error('\P{Script_Extensions: 	-ogham/a/}');
    Expect(1, 5788, '\p{Script_Extensions=ogham}', "");
    Expect(0, 5788, '\p{^Script_Extensions=ogham}', "");
    Expect(0, 5788, '\P{Script_Extensions=ogham}', "");
    Expect(1, 5788, '\P{^Script_Extensions=ogham}', "");
    Expect(0, 5789, '\p{Script_Extensions=ogham}', "");
    Expect(1, 5789, '\p{^Script_Extensions=ogham}', "");
    Expect(1, 5789, '\P{Script_Extensions=ogham}', "");
    Expect(0, 5789, '\P{^Script_Extensions=ogham}', "");
    Expect(1, 5788, '\p{Script_Extensions=-	Ogham}', "");
    Expect(0, 5788, '\p{^Script_Extensions=-	Ogham}', "");
    Expect(0, 5788, '\P{Script_Extensions=-	Ogham}', "");
    Expect(1, 5788, '\P{^Script_Extensions=-	Ogham}', "");
    Expect(0, 5789, '\p{Script_Extensions=-	Ogham}', "");
    Expect(1, 5789, '\p{^Script_Extensions=-	Ogham}', "");
    Expect(1, 5789, '\P{Script_Extensions=-	Ogham}', "");
    Expect(0, 5789, '\P{^Script_Extensions=-	Ogham}', "");
    Error('\p{Scx=/a/	OGAM}');
    Error('\P{Scx=/a/	OGAM}');
    Expect(1, 5788, '\p{Scx=ogam}', "");
    Expect(0, 5788, '\p{^Scx=ogam}', "");
    Expect(0, 5788, '\P{Scx=ogam}', "");
    Expect(1, 5788, '\P{^Scx=ogam}', "");
    Expect(0, 5789, '\p{Scx=ogam}', "");
    Expect(1, 5789, '\p{^Scx=ogam}', "");
    Expect(1, 5789, '\P{Scx=ogam}', "");
    Expect(0, 5789, '\P{^Scx=ogam}', "");
    Expect(1, 5788, '\p{Scx=__OGAM}', "");
    Expect(0, 5788, '\p{^Scx=__OGAM}', "");
    Expect(0, 5788, '\P{Scx=__OGAM}', "");
    Expect(1, 5788, '\P{^Scx=__OGAM}', "");
    Expect(0, 5789, '\p{Scx=__OGAM}', "");
    Expect(1, 5789, '\p{^Scx=__OGAM}', "");
    Expect(1, 5789, '\P{Scx=__OGAM}', "");
    Expect(0, 5789, '\P{^Scx=__OGAM}', "");
    Error('\p{Is_Script_Extensions=_/a/Ogham}');
    Error('\P{Is_Script_Extensions=_/a/Ogham}');
    Expect(1, 5788, '\p{Is_Script_Extensions:	ogham}', "");
    Expect(0, 5788, '\p{^Is_Script_Extensions:	ogham}', "");
    Expect(0, 5788, '\P{Is_Script_Extensions:	ogham}', "");
    Expect(1, 5788, '\P{^Is_Script_Extensions:	ogham}', "");
    Expect(0, 5789, '\p{Is_Script_Extensions:	ogham}', "");
    Expect(1, 5789, '\p{^Is_Script_Extensions:	ogham}', "");
    Expect(1, 5789, '\P{Is_Script_Extensions:	ogham}', "");
    Expect(0, 5789, '\P{^Is_Script_Extensions:	ogham}', "");
    Expect(1, 5788, '\p{Is_Script_Extensions=--Ogham}', "");
    Expect(0, 5788, '\p{^Is_Script_Extensions=--Ogham}', "");
    Expect(0, 5788, '\P{Is_Script_Extensions=--Ogham}', "");
    Expect(1, 5788, '\P{^Is_Script_Extensions=--Ogham}', "");
    Expect(0, 5789, '\p{Is_Script_Extensions=--Ogham}', "");
    Expect(1, 5789, '\p{^Is_Script_Extensions=--Ogham}', "");
    Expect(1, 5789, '\P{Is_Script_Extensions=--Ogham}', "");
    Expect(0, 5789, '\P{^Is_Script_Extensions=--Ogham}', "");
    Error('\p{Is_Scx: 	:=OGAM}');
    Error('\P{Is_Scx: 	:=OGAM}');
    Expect(1, 5788, '\p{Is_Scx=ogam}', "");
    Expect(0, 5788, '\p{^Is_Scx=ogam}', "");
    Expect(0, 5788, '\P{Is_Scx=ogam}', "");
    Expect(1, 5788, '\P{^Is_Scx=ogam}', "");
    Expect(0, 5789, '\p{Is_Scx=ogam}', "");
    Expect(1, 5789, '\p{^Is_Scx=ogam}', "");
    Expect(1, 5789, '\P{Is_Scx=ogam}', "");
    Expect(0, 5789, '\P{^Is_Scx=ogam}', "");
    Expect(1, 5788, '\p{Is_Scx=	 Ogam}', "");
    Expect(0, 5788, '\p{^Is_Scx=	 Ogam}', "");
    Expect(0, 5788, '\P{Is_Scx=	 Ogam}', "");
    Expect(1, 5788, '\P{^Is_Scx=	 Ogam}', "");
    Expect(0, 5789, '\p{Is_Scx=	 Ogam}', "");
    Expect(1, 5789, '\p{^Is_Scx=	 Ogam}', "");
    Expect(1, 5789, '\P{Is_Scx=	 Ogam}', "");
    Expect(0, 5789, '\P{^Is_Scx=	 Ogam}', "");
    Error('\p{Script_Extensions:/a/ Ol_Chiki}');
    Error('\P{Script_Extensions:/a/ Ol_Chiki}');
    Expect(1, 7295, '\p{Script_Extensions=olchiki}', "");
    Expect(0, 7295, '\p{^Script_Extensions=olchiki}', "");
    Expect(0, 7295, '\P{Script_Extensions=olchiki}', "");
    Expect(1, 7295, '\P{^Script_Extensions=olchiki}', "");
    Expect(0, 7296, '\p{Script_Extensions=olchiki}', "");
    Expect(1, 7296, '\p{^Script_Extensions=olchiki}', "");
    Expect(1, 7296, '\P{Script_Extensions=olchiki}', "");
    Expect(0, 7296, '\P{^Script_Extensions=olchiki}', "");
    Expect(1, 7295, '\p{Script_Extensions= OL_CHIKI}', "");
    Expect(0, 7295, '\p{^Script_Extensions= OL_CHIKI}', "");
    Expect(0, 7295, '\P{Script_Extensions= OL_CHIKI}', "");
    Expect(1, 7295, '\P{^Script_Extensions= OL_CHIKI}', "");
    Expect(0, 7296, '\p{Script_Extensions= OL_CHIKI}', "");
    Expect(1, 7296, '\p{^Script_Extensions= OL_CHIKI}', "");
    Expect(1, 7296, '\P{Script_Extensions= OL_CHIKI}', "");
    Expect(0, 7296, '\P{^Script_Extensions= OL_CHIKI}', "");
    Error('\p{Scx: 	:=OLCK}');
    Error('\P{Scx: 	:=OLCK}');
    Expect(1, 7295, '\p{Scx=olck}', "");
    Expect(0, 7295, '\p{^Scx=olck}', "");
    Expect(0, 7295, '\P{Scx=olck}', "");
    Expect(1, 7295, '\P{^Scx=olck}', "");
    Expect(0, 7296, '\p{Scx=olck}', "");
    Expect(1, 7296, '\p{^Scx=olck}', "");
    Expect(1, 7296, '\P{Scx=olck}', "");
    Expect(0, 7296, '\P{^Scx=olck}', "");
    Expect(1, 7295, '\p{Scx= Olck}', "");
    Expect(0, 7295, '\p{^Scx= Olck}', "");
    Expect(0, 7295, '\P{Scx= Olck}', "");
    Expect(1, 7295, '\P{^Scx= Olck}', "");
    Expect(0, 7296, '\p{Scx= Olck}', "");
    Expect(1, 7296, '\p{^Scx= Olck}', "");
    Expect(1, 7296, '\P{Scx= Olck}', "");
    Expect(0, 7296, '\P{^Scx= Olck}', "");
    Error('\p{Is_Script_Extensions=_:=OL_Chiki}');
    Error('\P{Is_Script_Extensions=_:=OL_Chiki}');
    Expect(1, 7295, '\p{Is_Script_Extensions=olchiki}', "");
    Expect(0, 7295, '\p{^Is_Script_Extensions=olchiki}', "");
    Expect(0, 7295, '\P{Is_Script_Extensions=olchiki}', "");
    Expect(1, 7295, '\P{^Is_Script_Extensions=olchiki}', "");
    Expect(0, 7296, '\p{Is_Script_Extensions=olchiki}', "");
    Expect(1, 7296, '\p{^Is_Script_Extensions=olchiki}', "");
    Expect(1, 7296, '\P{Is_Script_Extensions=olchiki}', "");
    Expect(0, 7296, '\P{^Is_Script_Extensions=olchiki}', "");
    Expect(1, 7295, '\p{Is_Script_Extensions= -Ol_CHIKI}', "");
    Expect(0, 7295, '\p{^Is_Script_Extensions= -Ol_CHIKI}', "");
    Expect(0, 7295, '\P{Is_Script_Extensions= -Ol_CHIKI}', "");
    Expect(1, 7295, '\P{^Is_Script_Extensions= -Ol_CHIKI}', "");
    Expect(0, 7296, '\p{Is_Script_Extensions= -Ol_CHIKI}', "");
    Expect(1, 7296, '\p{^Is_Script_Extensions= -Ol_CHIKI}', "");
    Expect(1, 7296, '\P{Is_Script_Extensions= -Ol_CHIKI}', "");
    Expect(0, 7296, '\P{^Is_Script_Extensions= -Ol_CHIKI}', "");
    Error('\p{Is_Scx=/a/ -Olck}');
    Error('\P{Is_Scx=/a/ -Olck}');
    Expect(1, 7295, '\p{Is_Scx=olck}', "");
    Expect(0, 7295, '\p{^Is_Scx=olck}', "");
    Expect(0, 7295, '\P{Is_Scx=olck}', "");
    Expect(1, 7295, '\P{^Is_Scx=olck}', "");
    Expect(0, 7296, '\p{Is_Scx=olck}', "");
    Expect(1, 7296, '\p{^Is_Scx=olck}', "");
    Expect(1, 7296, '\P{Is_Scx=olck}', "");
    Expect(0, 7296, '\P{^Is_Scx=olck}', "");
    Expect(1, 7295, '\p{Is_Scx=	 olck}', "");
    Expect(0, 7295, '\p{^Is_Scx=	 olck}', "");
    Expect(0, 7295, '\P{Is_Scx=	 olck}', "");
    Expect(1, 7295, '\P{^Is_Scx=	 olck}', "");
    Expect(0, 7296, '\p{Is_Scx=	 olck}', "");
    Expect(1, 7296, '\p{^Is_Scx=	 olck}', "");
    Expect(1, 7296, '\P{Is_Scx=	 olck}', "");
    Expect(0, 7296, '\P{^Is_Scx=	 olck}', "");
    Error('\p{Script_Extensions=-OLD_Turkic/a/}');
    Error('\P{Script_Extensions=-OLD_Turkic/a/}');
    Expect(1, 68680, '\p{Script_Extensions=oldturkic}', "");
    Expect(0, 68680, '\p{^Script_Extensions=oldturkic}', "");
    Expect(0, 68680, '\P{Script_Extensions=oldturkic}', "");
    Expect(1, 68680, '\P{^Script_Extensions=oldturkic}', "");
    Expect(0, 68681, '\p{Script_Extensions=oldturkic}', "");
    Expect(1, 68681, '\p{^Script_Extensions=oldturkic}', "");
    Expect(1, 68681, '\P{Script_Extensions=oldturkic}', "");
    Expect(0, 68681, '\P{^Script_Extensions=oldturkic}', "");
    Expect(1, 68680, '\p{Script_Extensions=-old_turkic}', "");
    Expect(0, 68680, '\p{^Script_Extensions=-old_turkic}', "");
    Expect(0, 68680, '\P{Script_Extensions=-old_turkic}', "");
    Expect(1, 68680, '\P{^Script_Extensions=-old_turkic}', "");
    Expect(0, 68681, '\p{Script_Extensions=-old_turkic}', "");
    Expect(1, 68681, '\p{^Script_Extensions=-old_turkic}', "");
    Expect(1, 68681, '\P{Script_Extensions=-old_turkic}', "");
    Expect(0, 68681, '\P{^Script_Extensions=-old_turkic}', "");
    Error('\p{Scx=/a/ 	Orkh}');
    Error('\P{Scx=/a/ 	Orkh}');
    Expect(1, 68680, '\p{Scx=orkh}', "");
    Expect(0, 68680, '\p{^Scx=orkh}', "");
    Expect(0, 68680, '\P{Scx=orkh}', "");
    Expect(1, 68680, '\P{^Scx=orkh}', "");
    Expect(0, 68681, '\p{Scx=orkh}', "");
    Expect(1, 68681, '\p{^Scx=orkh}', "");
    Expect(1, 68681, '\P{Scx=orkh}', "");
    Expect(0, 68681, '\P{^Scx=orkh}', "");
    Expect(1, 68680, '\p{Scx=	ORKH}', "");
    Expect(0, 68680, '\p{^Scx=	ORKH}', "");
    Expect(0, 68680, '\P{Scx=	ORKH}', "");
    Expect(1, 68680, '\P{^Scx=	ORKH}', "");
    Expect(0, 68681, '\p{Scx=	ORKH}', "");
    Expect(1, 68681, '\p{^Scx=	ORKH}', "");
    Expect(1, 68681, '\P{Scx=	ORKH}', "");
    Expect(0, 68681, '\P{^Scx=	ORKH}', "");
    Error('\p{Is_Script_Extensions= /a/Old_turkic}');
    Error('\P{Is_Script_Extensions= /a/Old_turkic}');
    Expect(1, 68680, '\p{Is_Script_Extensions:	oldturkic}', "");
    Expect(0, 68680, '\p{^Is_Script_Extensions:	oldturkic}', "");
    Expect(0, 68680, '\P{Is_Script_Extensions:	oldturkic}', "");
    Expect(1, 68680, '\P{^Is_Script_Extensions:	oldturkic}', "");
    Expect(0, 68681, '\p{Is_Script_Extensions:	oldturkic}', "");
    Expect(1, 68681, '\p{^Is_Script_Extensions:	oldturkic}', "");
    Expect(1, 68681, '\P{Is_Script_Extensions:	oldturkic}', "");
    Expect(0, 68681, '\P{^Is_Script_Extensions:	oldturkic}', "");
    Expect(1, 68680, '\p{Is_Script_Extensions=-	Old_Turkic}', "");
    Expect(0, 68680, '\p{^Is_Script_Extensions=-	Old_Turkic}', "");
    Expect(0, 68680, '\P{Is_Script_Extensions=-	Old_Turkic}', "");
    Expect(1, 68680, '\P{^Is_Script_Extensions=-	Old_Turkic}', "");
    Expect(0, 68681, '\p{Is_Script_Extensions=-	Old_Turkic}', "");
    Expect(1, 68681, '\p{^Is_Script_Extensions=-	Old_Turkic}', "");
    Expect(1, 68681, '\P{Is_Script_Extensions=-	Old_Turkic}', "");
    Expect(0, 68681, '\P{^Is_Script_Extensions=-	Old_Turkic}', "");
    Error('\p{Is_Scx= /a/Orkh}');
    Error('\P{Is_Scx= /a/Orkh}');
    Expect(1, 68680, '\p{Is_Scx: orkh}', "");
    Expect(0, 68680, '\p{^Is_Scx: orkh}', "");
    Expect(0, 68680, '\P{Is_Scx: orkh}', "");
    Expect(1, 68680, '\P{^Is_Scx: orkh}', "");
    Expect(0, 68681, '\p{Is_Scx: orkh}', "");
    Expect(1, 68681, '\p{^Is_Scx: orkh}', "");
    Expect(1, 68681, '\P{Is_Scx: orkh}', "");
    Expect(0, 68681, '\P{^Is_Scx: orkh}', "");
    Expect(1, 68680, '\p{Is_Scx=-_Orkh}', "");
    Expect(0, 68680, '\p{^Is_Scx=-_Orkh}', "");
    Expect(0, 68680, '\P{Is_Scx=-_Orkh}', "");
    Expect(1, 68680, '\P{^Is_Scx=-_Orkh}', "");
    Expect(0, 68681, '\p{Is_Scx=-_Orkh}', "");
    Expect(1, 68681, '\p{^Is_Scx=-_Orkh}', "");
    Expect(1, 68681, '\P{Is_Scx=-_Orkh}', "");
    Expect(0, 68681, '\P{^Is_Scx=-_Orkh}', "");
    Error('\p{Script_Extensions= 	Oriya:=}');
    Error('\P{Script_Extensions= 	Oriya:=}');
    Expect(1, 2935, '\p{Script_Extensions=oriya}', "");
    Expect(0, 2935, '\p{^Script_Extensions=oriya}', "");
    Expect(0, 2935, '\P{Script_Extensions=oriya}', "");
    Expect(1, 2935, '\P{^Script_Extensions=oriya}', "");
    Expect(0, 2936, '\p{Script_Extensions=oriya}', "");
    Expect(1, 2936, '\p{^Script_Extensions=oriya}', "");
    Expect(1, 2936, '\P{Script_Extensions=oriya}', "");
    Expect(0, 2936, '\P{^Script_Extensions=oriya}', "");
    Expect(1, 2935, '\p{Script_Extensions= Oriya}', "");
    Expect(0, 2935, '\p{^Script_Extensions= Oriya}', "");
    Expect(0, 2935, '\P{Script_Extensions= Oriya}', "");
    Expect(1, 2935, '\P{^Script_Extensions= Oriya}', "");
    Expect(0, 2936, '\p{Script_Extensions= Oriya}', "");
    Expect(1, 2936, '\p{^Script_Extensions= Oriya}', "");
    Expect(1, 2936, '\P{Script_Extensions= Oriya}', "");
    Expect(0, 2936, '\P{^Script_Extensions= Oriya}', "");
    Error('\p{Scx= :=Orya}');
    Error('\P{Scx= :=Orya}');
    Expect(1, 2935, '\p{Scx=orya}', "");
    Expect(0, 2935, '\p{^Scx=orya}', "");
    Expect(0, 2935, '\P{Scx=orya}', "");
    Expect(1, 2935, '\P{^Scx=orya}', "");
    Expect(0, 2936, '\p{Scx=orya}', "");
    Expect(1, 2936, '\p{^Scx=orya}', "");
    Expect(1, 2936, '\P{Scx=orya}', "");
    Expect(0, 2936, '\P{^Scx=orya}', "");
    Expect(1, 2935, '\p{Scx:-Orya}', "");
    Expect(0, 2935, '\p{^Scx:-Orya}', "");
    Expect(0, 2935, '\P{Scx:-Orya}', "");
    Expect(1, 2935, '\P{^Scx:-Orya}', "");
    Expect(0, 2936, '\p{Scx:-Orya}', "");
    Expect(1, 2936, '\p{^Scx:-Orya}', "");
    Expect(1, 2936, '\P{Scx:-Orya}', "");
    Expect(0, 2936, '\P{^Scx:-Orya}', "");
    Error('\p{Is_Script_Extensions=__oriya/a/}');
    Error('\P{Is_Script_Extensions=__oriya/a/}');
    Expect(1, 2935, '\p{Is_Script_Extensions:oriya}', "");
    Expect(0, 2935, '\p{^Is_Script_Extensions:oriya}', "");
    Expect(0, 2935, '\P{Is_Script_Extensions:oriya}', "");
    Expect(1, 2935, '\P{^Is_Script_Extensions:oriya}', "");
    Expect(0, 2936, '\p{Is_Script_Extensions:oriya}', "");
    Expect(1, 2936, '\p{^Is_Script_Extensions:oriya}', "");
    Expect(1, 2936, '\P{Is_Script_Extensions:oriya}', "");
    Expect(0, 2936, '\P{^Is_Script_Extensions:oriya}', "");
    Expect(1, 2935, '\p{Is_Script_Extensions=-oriya}', "");
    Expect(0, 2935, '\p{^Is_Script_Extensions=-oriya}', "");
    Expect(0, 2935, '\P{Is_Script_Extensions=-oriya}', "");
    Expect(1, 2935, '\P{^Is_Script_Extensions=-oriya}', "");
    Expect(0, 2936, '\p{Is_Script_Extensions=-oriya}', "");
    Expect(1, 2936, '\p{^Is_Script_Extensions=-oriya}', "");
    Expect(1, 2936, '\P{Is_Script_Extensions=-oriya}', "");
    Expect(0, 2936, '\P{^Is_Script_Extensions=-oriya}', "");
    Error('\p{Is_Scx= 	ORYA/a/}');
    Error('\P{Is_Scx= 	ORYA/a/}');
    Expect(1, 2935, '\p{Is_Scx=orya}', "");
    Expect(0, 2935, '\p{^Is_Scx=orya}', "");
    Expect(0, 2935, '\P{Is_Scx=orya}', "");
    Expect(1, 2935, '\P{^Is_Scx=orya}', "");
    Expect(0, 2936, '\p{Is_Scx=orya}', "");
    Expect(1, 2936, '\p{^Is_Scx=orya}', "");
    Expect(1, 2936, '\P{Is_Scx=orya}', "");
    Expect(0, 2936, '\P{^Is_Scx=orya}', "");
    Expect(1, 2935, '\p{Is_Scx=Orya}', "");
    Expect(0, 2935, '\p{^Is_Scx=Orya}', "");
    Expect(0, 2935, '\P{Is_Scx=Orya}', "");
    Expect(1, 2935, '\P{^Is_Scx=Orya}', "");
    Expect(0, 2936, '\p{Is_Scx=Orya}', "");
    Expect(1, 2936, '\p{^Is_Scx=Orya}', "");
    Expect(1, 2936, '\P{Is_Scx=Orya}', "");
    Expect(0, 2936, '\P{^Is_Scx=Orya}', "");
    Error('\p{Script_Extensions=:=_OSAGE}');
    Error('\P{Script_Extensions=:=_OSAGE}');
    Expect(1, 66811, '\p{Script_Extensions=osage}', "");
    Expect(0, 66811, '\p{^Script_Extensions=osage}', "");
    Expect(0, 66811, '\P{Script_Extensions=osage}', "");
    Expect(1, 66811, '\P{^Script_Extensions=osage}', "");
    Expect(0, 66812, '\p{Script_Extensions=osage}', "");
    Expect(1, 66812, '\p{^Script_Extensions=osage}', "");
    Expect(1, 66812, '\P{Script_Extensions=osage}', "");
    Expect(0, 66812, '\P{^Script_Extensions=osage}', "");
    Error('\p{Scx=-/a/osge}');
    Error('\P{Scx=-/a/osge}');
    Expect(1, 66811, '\p{Scx=osge}', "");
    Expect(0, 66811, '\p{^Scx=osge}', "");
    Expect(0, 66811, '\P{Scx=osge}', "");
    Expect(1, 66811, '\P{^Scx=osge}', "");
    Expect(0, 66812, '\p{Scx=osge}', "");
    Expect(1, 66812, '\p{^Scx=osge}', "");
    Expect(1, 66812, '\P{Scx=osge}', "");
    Expect(0, 66812, '\P{^Scx=osge}', "");
    Expect(1, 66811, '\p{Scx:			OSGE}', "");
    Expect(0, 66811, '\p{^Scx:			OSGE}', "");
    Expect(0, 66811, '\P{Scx:			OSGE}', "");
    Expect(1, 66811, '\P{^Scx:			OSGE}', "");
    Expect(0, 66812, '\p{Scx:			OSGE}', "");
    Expect(1, 66812, '\p{^Scx:			OSGE}', "");
    Expect(1, 66812, '\P{Scx:			OSGE}', "");
    Expect(0, 66812, '\P{^Scx:			OSGE}', "");
    Error('\p{Is_Script_Extensions=-:=OSAGE}');
    Error('\P{Is_Script_Extensions=-:=OSAGE}');
    Expect(1, 66811, '\p{Is_Script_Extensions=osage}', "");
    Expect(0, 66811, '\p{^Is_Script_Extensions=osage}', "");
    Expect(0, 66811, '\P{Is_Script_Extensions=osage}', "");
    Expect(1, 66811, '\P{^Is_Script_Extensions=osage}', "");
    Expect(0, 66812, '\p{Is_Script_Extensions=osage}', "");
    Expect(1, 66812, '\p{^Is_Script_Extensions=osage}', "");
    Expect(1, 66812, '\P{Is_Script_Extensions=osage}', "");
    Expect(0, 66812, '\P{^Is_Script_Extensions=osage}', "");
    Expect(1, 66811, '\p{Is_Script_Extensions=-	OSAGE}', "");
    Expect(0, 66811, '\p{^Is_Script_Extensions=-	OSAGE}', "");
    Expect(0, 66811, '\P{Is_Script_Extensions=-	OSAGE}', "");
    Expect(1, 66811, '\P{^Is_Script_Extensions=-	OSAGE}', "");
    Expect(0, 66812, '\p{Is_Script_Extensions=-	OSAGE}', "");
    Expect(1, 66812, '\p{^Is_Script_Extensions=-	OSAGE}', "");
    Expect(1, 66812, '\P{Is_Script_Extensions=-	OSAGE}', "");
    Expect(0, 66812, '\P{^Is_Script_Extensions=-	OSAGE}', "");
    Error('\p{Is_Scx=/a/-_Osge}');
    Error('\P{Is_Scx=/a/-_Osge}');
    Expect(1, 66811, '\p{Is_Scx=osge}', "");
    Expect(0, 66811, '\p{^Is_Scx=osge}', "");
    Expect(0, 66811, '\P{Is_Scx=osge}', "");
    Expect(1, 66811, '\P{^Is_Scx=osge}', "");
    Expect(0, 66812, '\p{Is_Scx=osge}', "");
    Expect(1, 66812, '\p{^Is_Scx=osge}', "");
    Expect(1, 66812, '\P{Is_Scx=osge}', "");
    Expect(0, 66812, '\P{^Is_Scx=osge}', "");
    Expect(1, 66811, '\p{Is_Scx=-_OSGE}', "");
    Expect(0, 66811, '\p{^Is_Scx=-_OSGE}', "");
    Expect(0, 66811, '\P{Is_Scx=-_OSGE}', "");
    Expect(1, 66811, '\P{^Is_Scx=-_OSGE}', "");
    Expect(0, 66812, '\p{Is_Scx=-_OSGE}', "");
    Expect(1, 66812, '\p{^Is_Scx=-_OSGE}', "");
    Expect(1, 66812, '\P{Is_Scx=-_OSGE}', "");
    Expect(0, 66812, '\P{^Is_Scx=-_OSGE}', "");
    Error('\p{Script_Extensions= :=OSMANYA}');
    Error('\P{Script_Extensions= :=OSMANYA}');
    Expect(1, 66729, '\p{Script_Extensions=osmanya}', "");
    Expect(0, 66729, '\p{^Script_Extensions=osmanya}', "");
    Expect(0, 66729, '\P{Script_Extensions=osmanya}', "");
    Expect(1, 66729, '\P{^Script_Extensions=osmanya}', "");
    Expect(0, 66730, '\p{Script_Extensions=osmanya}', "");
    Expect(1, 66730, '\p{^Script_Extensions=osmanya}', "");
    Expect(1, 66730, '\P{Script_Extensions=osmanya}', "");
    Expect(0, 66730, '\P{^Script_Extensions=osmanya}', "");
    Expect(1, 66729, '\p{Script_Extensions= _osmanya}', "");
    Expect(0, 66729, '\p{^Script_Extensions= _osmanya}', "");
    Expect(0, 66729, '\P{Script_Extensions= _osmanya}', "");
    Expect(1, 66729, '\P{^Script_Extensions= _osmanya}', "");
    Expect(0, 66730, '\p{Script_Extensions= _osmanya}', "");
    Expect(1, 66730, '\p{^Script_Extensions= _osmanya}', "");
    Expect(1, 66730, '\P{Script_Extensions= _osmanya}', "");
    Expect(0, 66730, '\P{^Script_Extensions= _osmanya}', "");
    Error('\p{Scx= :=Osma}');
    Error('\P{Scx= :=Osma}');
    Expect(1, 66729, '\p{Scx=osma}', "");
    Expect(0, 66729, '\p{^Scx=osma}', "");
    Expect(0, 66729, '\P{Scx=osma}', "");
    Expect(1, 66729, '\P{^Scx=osma}', "");
    Expect(0, 66730, '\p{Scx=osma}', "");
    Expect(1, 66730, '\p{^Scx=osma}', "");
    Expect(1, 66730, '\P{Scx=osma}', "");
    Expect(0, 66730, '\P{^Scx=osma}', "");
    Expect(1, 66729, '\p{Scx:   _	Osma}', "");
    Expect(0, 66729, '\p{^Scx:   _	Osma}', "");
    Expect(0, 66729, '\P{Scx:   _	Osma}', "");
    Expect(1, 66729, '\P{^Scx:   _	Osma}', "");
    Expect(0, 66730, '\p{Scx:   _	Osma}', "");
    Expect(1, 66730, '\p{^Scx:   _	Osma}', "");
    Expect(1, 66730, '\P{Scx:   _	Osma}', "");
    Expect(0, 66730, '\P{^Scx:   _	Osma}', "");
    Error('\p{Is_Script_Extensions=/a/Osmanya}');
    Error('\P{Is_Script_Extensions=/a/Osmanya}');
    Expect(1, 66729, '\p{Is_Script_Extensions=osmanya}', "");
    Expect(0, 66729, '\p{^Is_Script_Extensions=osmanya}', "");
    Expect(0, 66729, '\P{Is_Script_Extensions=osmanya}', "");
    Expect(1, 66729, '\P{^Is_Script_Extensions=osmanya}', "");
    Expect(0, 66730, '\p{Is_Script_Extensions=osmanya}', "");
    Expect(1, 66730, '\p{^Is_Script_Extensions=osmanya}', "");
    Expect(1, 66730, '\P{Is_Script_Extensions=osmanya}', "");
    Expect(0, 66730, '\P{^Is_Script_Extensions=osmanya}', "");
    Expect(1, 66729, '\p{Is_Script_Extensions:    OSMANYA}', "");
    Expect(0, 66729, '\p{^Is_Script_Extensions:    OSMANYA}', "");
    Expect(0, 66729, '\P{Is_Script_Extensions:    OSMANYA}', "");
    Expect(1, 66729, '\P{^Is_Script_Extensions:    OSMANYA}', "");
    Expect(0, 66730, '\p{Is_Script_Extensions:    OSMANYA}', "");
    Expect(1, 66730, '\p{^Is_Script_Extensions:    OSMANYA}', "");
    Expect(1, 66730, '\P{Is_Script_Extensions:    OSMANYA}', "");
    Expect(0, 66730, '\P{^Is_Script_Extensions:    OSMANYA}', "");
    Error('\p{Is_Scx=-:=Osma}');
    Error('\P{Is_Scx=-:=Osma}');
    Expect(1, 66729, '\p{Is_Scx=osma}', "");
    Expect(0, 66729, '\p{^Is_Scx=osma}', "");
    Expect(0, 66729, '\P{Is_Scx=osma}', "");
    Expect(1, 66729, '\P{^Is_Scx=osma}', "");
    Expect(0, 66730, '\p{Is_Scx=osma}', "");
    Expect(1, 66730, '\p{^Is_Scx=osma}', "");
    Expect(1, 66730, '\P{Is_Scx=osma}', "");
    Expect(0, 66730, '\P{^Is_Scx=osma}', "");
    Expect(1, 66729, '\p{Is_Scx= -Osma}', "");
    Expect(0, 66729, '\p{^Is_Scx= -Osma}', "");
    Expect(0, 66729, '\P{Is_Scx= -Osma}', "");
    Expect(1, 66729, '\P{^Is_Scx= -Osma}', "");
    Expect(0, 66730, '\p{Is_Scx= -Osma}', "");
    Expect(1, 66730, '\p{^Is_Scx= -Osma}', "");
    Expect(1, 66730, '\P{Is_Scx= -Osma}', "");
    Expect(0, 66730, '\P{^Is_Scx= -Osma}', "");
    Error('\p{Script_Extensions:	:=-_palmyrene}');
    Error('\P{Script_Extensions:	:=-_palmyrene}');
    Expect(1, 67711, '\p{Script_Extensions=palmyrene}', "");
    Expect(0, 67711, '\p{^Script_Extensions=palmyrene}', "");
    Expect(0, 67711, '\P{Script_Extensions=palmyrene}', "");
    Expect(1, 67711, '\P{^Script_Extensions=palmyrene}', "");
    Expect(0, 67712, '\p{Script_Extensions=palmyrene}', "");
    Expect(1, 67712, '\p{^Script_Extensions=palmyrene}', "");
    Expect(1, 67712, '\P{Script_Extensions=palmyrene}', "");
    Expect(0, 67712, '\P{^Script_Extensions=palmyrene}', "");
    Expect(1, 67711, '\p{Script_Extensions= palmyrene}', "");
    Expect(0, 67711, '\p{^Script_Extensions= palmyrene}', "");
    Expect(0, 67711, '\P{Script_Extensions= palmyrene}', "");
    Expect(1, 67711, '\P{^Script_Extensions= palmyrene}', "");
    Expect(0, 67712, '\p{Script_Extensions= palmyrene}', "");
    Expect(1, 67712, '\p{^Script_Extensions= palmyrene}', "");
    Expect(1, 67712, '\P{Script_Extensions= palmyrene}', "");
    Expect(0, 67712, '\P{^Script_Extensions= palmyrene}', "");
    Error('\p{Scx=	/a/palm}');
    Error('\P{Scx=	/a/palm}');
    Expect(1, 67711, '\p{Scx=palm}', "");
    Expect(0, 67711, '\p{^Scx=palm}', "");
    Expect(0, 67711, '\P{Scx=palm}', "");
    Expect(1, 67711, '\P{^Scx=palm}', "");
    Expect(0, 67712, '\p{Scx=palm}', "");
    Expect(1, 67712, '\p{^Scx=palm}', "");
    Expect(1, 67712, '\P{Scx=palm}', "");
    Expect(0, 67712, '\P{^Scx=palm}', "");
    Expect(1, 67711, '\p{Scx=  Palm}', "");
    Expect(0, 67711, '\p{^Scx=  Palm}', "");
    Expect(0, 67711, '\P{Scx=  Palm}', "");
    Expect(1, 67711, '\P{^Scx=  Palm}', "");
    Expect(0, 67712, '\p{Scx=  Palm}', "");
    Expect(1, 67712, '\p{^Scx=  Palm}', "");
    Expect(1, 67712, '\P{Scx=  Palm}', "");
    Expect(0, 67712, '\P{^Scx=  Palm}', "");
    Error('\p{Is_Script_Extensions=_ Palmyrene/a/}');
    Error('\P{Is_Script_Extensions=_ Palmyrene/a/}');
    Expect(1, 67711, '\p{Is_Script_Extensions=palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Script_Extensions=palmyrene}', "");
    Expect(0, 67711, '\P{Is_Script_Extensions=palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Script_Extensions=palmyrene}', "");
    Expect(0, 67712, '\p{Is_Script_Extensions=palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Script_Extensions=palmyrene}', "");
    Expect(1, 67712, '\P{Is_Script_Extensions=palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Script_Extensions=palmyrene}', "");
    Expect(1, 67711, '\p{Is_Script_Extensions=-	Palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Script_Extensions=-	Palmyrene}', "");
    Expect(0, 67711, '\P{Is_Script_Extensions=-	Palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Script_Extensions=-	Palmyrene}', "");
    Expect(0, 67712, '\p{Is_Script_Extensions=-	Palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Script_Extensions=-	Palmyrene}', "");
    Expect(1, 67712, '\P{Is_Script_Extensions=-	Palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Script_Extensions=-	Palmyrene}', "");
    Error('\p{Is_Scx=:=	PALM}');
    Error('\P{Is_Scx=:=	PALM}');
    Expect(1, 67711, '\p{Is_Scx=palm}', "");
    Expect(0, 67711, '\p{^Is_Scx=palm}', "");
    Expect(0, 67711, '\P{Is_Scx=palm}', "");
    Expect(1, 67711, '\P{^Is_Scx=palm}', "");
    Expect(0, 67712, '\p{Is_Scx=palm}', "");
    Expect(1, 67712, '\p{^Is_Scx=palm}', "");
    Expect(1, 67712, '\P{Is_Scx=palm}', "");
    Expect(0, 67712, '\P{^Is_Scx=palm}', "");
    Expect(1, 67711, '\p{Is_Scx=_Palm}', "");
    Expect(0, 67711, '\p{^Is_Scx=_Palm}', "");
    Expect(0, 67711, '\P{Is_Scx=_Palm}', "");
    Expect(1, 67711, '\P{^Is_Scx=_Palm}', "");
    Expect(0, 67712, '\p{Is_Scx=_Palm}', "");
    Expect(1, 67712, '\p{^Is_Scx=_Palm}', "");
    Expect(1, 67712, '\P{Is_Scx=_Palm}', "");
    Expect(0, 67712, '\P{^Is_Scx=_Palm}', "");
    Error('\p{Script_Extensions=__PAU_CIN_Hau/a/}');
    Error('\P{Script_Extensions=__PAU_CIN_Hau/a/}');
    Expect(1, 72440, '\p{Script_Extensions:paucinhau}', "");
    Expect(0, 72440, '\p{^Script_Extensions:paucinhau}', "");
    Expect(0, 72440, '\P{Script_Extensions:paucinhau}', "");
    Expect(1, 72440, '\P{^Script_Extensions:paucinhau}', "");
    Expect(0, 72441, '\p{Script_Extensions:paucinhau}', "");
    Expect(1, 72441, '\p{^Script_Extensions:paucinhau}', "");
    Expect(1, 72441, '\P{Script_Extensions:paucinhau}', "");
    Expect(0, 72441, '\P{^Script_Extensions:paucinhau}', "");
    Expect(1, 72440, '\p{Script_Extensions=Pau_Cin_Hau}', "");
    Expect(0, 72440, '\p{^Script_Extensions=Pau_Cin_Hau}', "");
    Expect(0, 72440, '\P{Script_Extensions=Pau_Cin_Hau}', "");
    Expect(1, 72440, '\P{^Script_Extensions=Pau_Cin_Hau}', "");
    Expect(0, 72441, '\p{Script_Extensions=Pau_Cin_Hau}', "");
    Expect(1, 72441, '\p{^Script_Extensions=Pau_Cin_Hau}', "");
    Expect(1, 72441, '\P{Script_Extensions=Pau_Cin_Hau}', "");
    Expect(0, 72441, '\P{^Script_Extensions=Pau_Cin_Hau}', "");
    Error('\p{Scx=/a/pauc}');
    Error('\P{Scx=/a/pauc}');
    Expect(1, 72440, '\p{Scx=pauc}', "");
    Expect(0, 72440, '\p{^Scx=pauc}', "");
    Expect(0, 72440, '\P{Scx=pauc}', "");
    Expect(1, 72440, '\P{^Scx=pauc}', "");
    Expect(0, 72441, '\p{Scx=pauc}', "");
    Expect(1, 72441, '\p{^Scx=pauc}', "");
    Expect(1, 72441, '\P{Scx=pauc}', "");
    Expect(0, 72441, '\P{^Scx=pauc}', "");
    Expect(1, 72440, '\p{Scx=__Pauc}', "");
    Expect(0, 72440, '\p{^Scx=__Pauc}', "");
    Expect(0, 72440, '\P{Scx=__Pauc}', "");
    Expect(1, 72440, '\P{^Scx=__Pauc}', "");
    Expect(0, 72441, '\p{Scx=__Pauc}', "");
    Expect(1, 72441, '\p{^Scx=__Pauc}', "");
    Expect(1, 72441, '\P{Scx=__Pauc}', "");
    Expect(0, 72441, '\P{^Scx=__Pauc}', "");
    Error('\p{Is_Script_Extensions=--Pau_cin_HAU:=}');
    Error('\P{Is_Script_Extensions=--Pau_cin_HAU:=}');
    Expect(1, 72440, '\p{Is_Script_Extensions=paucinhau}', "");
    Expect(0, 72440, '\p{^Is_Script_Extensions=paucinhau}', "");
    Expect(0, 72440, '\P{Is_Script_Extensions=paucinhau}', "");
    Expect(1, 72440, '\P{^Is_Script_Extensions=paucinhau}', "");
    Expect(0, 72441, '\p{Is_Script_Extensions=paucinhau}', "");
    Expect(1, 72441, '\p{^Is_Script_Extensions=paucinhau}', "");
    Expect(1, 72441, '\P{Is_Script_Extensions=paucinhau}', "");
    Expect(0, 72441, '\P{^Is_Script_Extensions=paucinhau}', "");
    Expect(1, 72440, '\p{Is_Script_Extensions=_ Pau_cin_HAU}', "");
    Expect(0, 72440, '\p{^Is_Script_Extensions=_ Pau_cin_HAU}', "");
    Expect(0, 72440, '\P{Is_Script_Extensions=_ Pau_cin_HAU}', "");
    Expect(1, 72440, '\P{^Is_Script_Extensions=_ Pau_cin_HAU}', "");
    Expect(0, 72441, '\p{Is_Script_Extensions=_ Pau_cin_HAU}', "");
    Expect(1, 72441, '\p{^Is_Script_Extensions=_ Pau_cin_HAU}', "");
    Expect(1, 72441, '\P{Is_Script_Extensions=_ Pau_cin_HAU}', "");
    Expect(0, 72441, '\P{^Is_Script_Extensions=_ Pau_cin_HAU}', "");
    Error('\p{Is_Scx=-_pauc/a/}');
    Error('\P{Is_Scx=-_pauc/a/}');
    Expect(1, 72440, '\p{Is_Scx=pauc}', "");
    Expect(0, 72440, '\p{^Is_Scx=pauc}', "");
    Expect(0, 72440, '\P{Is_Scx=pauc}', "");
    Expect(1, 72440, '\P{^Is_Scx=pauc}', "");
    Expect(0, 72441, '\p{Is_Scx=pauc}', "");
    Expect(1, 72441, '\p{^Is_Scx=pauc}', "");
    Expect(1, 72441, '\P{Is_Scx=pauc}', "");
    Expect(0, 72441, '\P{^Is_Scx=pauc}', "");
    Expect(1, 72440, '\p{Is_Scx:Pauc}', "");
    Expect(0, 72440, '\p{^Is_Scx:Pauc}', "");
    Expect(0, 72440, '\P{Is_Scx:Pauc}', "");
    Expect(1, 72440, '\P{^Is_Scx:Pauc}', "");
    Expect(0, 72441, '\p{Is_Scx:Pauc}', "");
    Expect(1, 72441, '\p{^Is_Scx:Pauc}', "");
    Expect(1, 72441, '\P{Is_Scx:Pauc}', "");
    Expect(0, 72441, '\P{^Is_Scx:Pauc}', "");
    Error('\p{Script_Extensions=	 OLD_Permic:=}');
    Error('\P{Script_Extensions=	 OLD_Permic:=}');
    Expect(1, 66426, '\p{Script_Extensions=oldpermic}', "");
    Expect(0, 66426, '\p{^Script_Extensions=oldpermic}', "");
    Expect(0, 66426, '\P{Script_Extensions=oldpermic}', "");
    Expect(1, 66426, '\P{^Script_Extensions=oldpermic}', "");
    Expect(0, 66427, '\p{Script_Extensions=oldpermic}', "");
    Expect(1, 66427, '\p{^Script_Extensions=oldpermic}', "");
    Expect(1, 66427, '\P{Script_Extensions=oldpermic}', "");
    Expect(0, 66427, '\P{^Script_Extensions=oldpermic}', "");
    Expect(1, 66426, '\p{Script_Extensions=_	Old_permic}', "");
    Expect(0, 66426, '\p{^Script_Extensions=_	Old_permic}', "");
    Expect(0, 66426, '\P{Script_Extensions=_	Old_permic}', "");
    Expect(1, 66426, '\P{^Script_Extensions=_	Old_permic}', "");
    Expect(0, 66427, '\p{Script_Extensions=_	Old_permic}', "");
    Expect(1, 66427, '\p{^Script_Extensions=_	Old_permic}', "");
    Expect(1, 66427, '\P{Script_Extensions=_	Old_permic}', "");
    Expect(0, 66427, '\P{^Script_Extensions=_	Old_permic}', "");
    Error('\p{Scx= Perm/a/}');
    Error('\P{Scx= Perm/a/}');
    Expect(1, 66426, '\p{Scx:   perm}', "");
    Expect(0, 66426, '\p{^Scx:   perm}', "");
    Expect(0, 66426, '\P{Scx:   perm}', "");
    Expect(1, 66426, '\P{^Scx:   perm}', "");
    Expect(0, 66427, '\p{Scx:   perm}', "");
    Expect(1, 66427, '\p{^Scx:   perm}', "");
    Expect(1, 66427, '\P{Scx:   perm}', "");
    Expect(0, 66427, '\P{^Scx:   perm}', "");
    Expect(1, 66426, '\p{Scx=-_Perm}', "");
    Expect(0, 66426, '\p{^Scx=-_Perm}', "");
    Expect(0, 66426, '\P{Scx=-_Perm}', "");
    Expect(1, 66426, '\P{^Scx=-_Perm}', "");
    Expect(0, 66427, '\p{Scx=-_Perm}', "");
    Expect(1, 66427, '\p{^Scx=-_Perm}', "");
    Expect(1, 66427, '\P{Scx=-_Perm}', "");
    Expect(0, 66427, '\P{^Scx=-_Perm}', "");
    Error('\p{Is_Script_Extensions=_	OLD_permic:=}');
    Error('\P{Is_Script_Extensions=_	OLD_permic:=}');
    Expect(1, 66426, '\p{Is_Script_Extensions=oldpermic}', "");
    Expect(0, 66426, '\p{^Is_Script_Extensions=oldpermic}', "");
    Expect(0, 66426, '\P{Is_Script_Extensions=oldpermic}', "");
    Expect(1, 66426, '\P{^Is_Script_Extensions=oldpermic}', "");
    Expect(0, 66427, '\p{Is_Script_Extensions=oldpermic}', "");
    Expect(1, 66427, '\p{^Is_Script_Extensions=oldpermic}', "");
    Expect(1, 66427, '\P{Is_Script_Extensions=oldpermic}', "");
    Expect(0, 66427, '\P{^Is_Script_Extensions=oldpermic}', "");
    Expect(1, 66426, '\p{Is_Script_Extensions=	Old_Permic}', "");
    Expect(0, 66426, '\p{^Is_Script_Extensions=	Old_Permic}', "");
    Expect(0, 66426, '\P{Is_Script_Extensions=	Old_Permic}', "");
    Expect(1, 66426, '\P{^Is_Script_Extensions=	Old_Permic}', "");
    Expect(0, 66427, '\p{Is_Script_Extensions=	Old_Permic}', "");
    Expect(1, 66427, '\p{^Is_Script_Extensions=	Old_Permic}', "");
    Expect(1, 66427, '\P{Is_Script_Extensions=	Old_Permic}', "");
    Expect(0, 66427, '\P{^Is_Script_Extensions=	Old_Permic}', "");
    Error('\p{Is_Scx:		:=PERM}');
    Error('\P{Is_Scx:		:=PERM}');
    Expect(1, 66426, '\p{Is_Scx:perm}', "");
    Expect(0, 66426, '\p{^Is_Scx:perm}', "");
    Expect(0, 66426, '\P{Is_Scx:perm}', "");
    Expect(1, 66426, '\P{^Is_Scx:perm}', "");
    Expect(0, 66427, '\p{Is_Scx:perm}', "");
    Expect(1, 66427, '\p{^Is_Scx:perm}', "");
    Expect(1, 66427, '\P{Is_Scx:perm}', "");
    Expect(0, 66427, '\P{^Is_Scx:perm}', "");
    Expect(1, 66426, '\p{Is_Scx:	-PERM}', "");
    Expect(0, 66426, '\p{^Is_Scx:	-PERM}', "");
    Expect(0, 66426, '\P{Is_Scx:	-PERM}', "");
    Expect(1, 66426, '\P{^Is_Scx:	-PERM}', "");
    Expect(0, 66427, '\p{Is_Scx:	-PERM}', "");
    Expect(1, 66427, '\p{^Is_Scx:	-PERM}', "");
    Expect(1, 66427, '\P{Is_Scx:	-PERM}', "");
    Expect(0, 66427, '\P{^Is_Scx:	-PERM}', "");
    Error('\p{Script_Extensions=	_PHAGS_Pa:=}');
    Error('\P{Script_Extensions=	_PHAGS_Pa:=}');
    Expect(1, 43127, '\p{Script_Extensions=phagspa}', "");
    Expect(0, 43127, '\p{^Script_Extensions=phagspa}', "");
    Expect(0, 43127, '\P{Script_Extensions=phagspa}', "");
    Expect(1, 43127, '\P{^Script_Extensions=phagspa}', "");
    Expect(0, 43128, '\p{Script_Extensions=phagspa}', "");
    Expect(1, 43128, '\p{^Script_Extensions=phagspa}', "");
    Expect(1, 43128, '\P{Script_Extensions=phagspa}', "");
    Expect(0, 43128, '\P{^Script_Extensions=phagspa}', "");
    Expect(1, 43127, '\p{Script_Extensions:   	Phags_PA}', "");
    Expect(0, 43127, '\p{^Script_Extensions:   	Phags_PA}', "");
    Expect(0, 43127, '\P{Script_Extensions:   	Phags_PA}', "");
    Expect(1, 43127, '\P{^Script_Extensions:   	Phags_PA}', "");
    Expect(0, 43128, '\p{Script_Extensions:   	Phags_PA}', "");
    Expect(1, 43128, '\p{^Script_Extensions:   	Phags_PA}', "");
    Expect(1, 43128, '\P{Script_Extensions:   	Phags_PA}', "");
    Expect(0, 43128, '\P{^Script_Extensions:   	Phags_PA}', "");
    Error('\p{Scx= 	Phag/a/}');
    Error('\P{Scx= 	Phag/a/}');
    Expect(1, 43127, '\p{Scx=phag}', "");
    Expect(0, 43127, '\p{^Scx=phag}', "");
    Expect(0, 43127, '\P{Scx=phag}', "");
    Expect(1, 43127, '\P{^Scx=phag}', "");
    Expect(0, 43128, '\p{Scx=phag}', "");
    Expect(1, 43128, '\p{^Scx=phag}', "");
    Expect(1, 43128, '\P{Scx=phag}', "");
    Expect(0, 43128, '\P{^Scx=phag}', "");
    Expect(1, 43127, '\p{Scx=-	phag}', "");
    Expect(0, 43127, '\p{^Scx=-	phag}', "");
    Expect(0, 43127, '\P{Scx=-	phag}', "");
    Expect(1, 43127, '\P{^Scx=-	phag}', "");
    Expect(0, 43128, '\p{Scx=-	phag}', "");
    Expect(1, 43128, '\p{^Scx=-	phag}', "");
    Expect(1, 43128, '\P{Scx=-	phag}', "");
    Expect(0, 43128, '\P{^Scx=-	phag}', "");
    Error('\p{Is_Script_Extensions: /a/	-PHAGS_PA}');
    Error('\P{Is_Script_Extensions: /a/	-PHAGS_PA}');
    Expect(1, 43127, '\p{Is_Script_Extensions=phagspa}', "");
    Expect(0, 43127, '\p{^Is_Script_Extensions=phagspa}', "");
    Expect(0, 43127, '\P{Is_Script_Extensions=phagspa}', "");
    Expect(1, 43127, '\P{^Is_Script_Extensions=phagspa}', "");
    Expect(0, 43128, '\p{Is_Script_Extensions=phagspa}', "");
    Expect(1, 43128, '\p{^Is_Script_Extensions=phagspa}', "");
    Expect(1, 43128, '\P{Is_Script_Extensions=phagspa}', "");
    Expect(0, 43128, '\P{^Is_Script_Extensions=phagspa}', "");
    Expect(1, 43127, '\p{Is_Script_Extensions= _Phags_Pa}', "");
    Expect(0, 43127, '\p{^Is_Script_Extensions= _Phags_Pa}', "");
    Expect(0, 43127, '\P{Is_Script_Extensions= _Phags_Pa}', "");
    Expect(1, 43127, '\P{^Is_Script_Extensions= _Phags_Pa}', "");
    Expect(0, 43128, '\p{Is_Script_Extensions= _Phags_Pa}', "");
    Expect(1, 43128, '\p{^Is_Script_Extensions= _Phags_Pa}', "");
    Expect(1, 43128, '\P{Is_Script_Extensions= _Phags_Pa}', "");
    Expect(0, 43128, '\P{^Is_Script_Extensions= _Phags_Pa}', "");
    Error('\p{Is_Scx=PHAG/a/}');
    Error('\P{Is_Scx=PHAG/a/}');
    Expect(1, 43127, '\p{Is_Scx:	phag}', "");
    Expect(0, 43127, '\p{^Is_Scx:	phag}', "");
    Expect(0, 43127, '\P{Is_Scx:	phag}', "");
    Expect(1, 43127, '\P{^Is_Scx:	phag}', "");
    Expect(0, 43128, '\p{Is_Scx:	phag}', "");
    Expect(1, 43128, '\p{^Is_Scx:	phag}', "");
    Expect(1, 43128, '\P{Is_Scx:	phag}', "");
    Expect(0, 43128, '\P{^Is_Scx:	phag}', "");
    Expect(1, 43127, '\p{Is_Scx=_ phag}', "");
    Expect(0, 43127, '\p{^Is_Scx=_ phag}', "");
    Expect(0, 43127, '\P{Is_Scx=_ phag}', "");
    Expect(1, 43127, '\P{^Is_Scx=_ phag}', "");
    Expect(0, 43128, '\p{Is_Scx=_ phag}', "");
    Expect(1, 43128, '\p{^Is_Scx=_ phag}', "");
    Expect(1, 43128, '\P{Is_Scx=_ phag}', "");
    Expect(0, 43128, '\P{^Is_Scx=_ phag}', "");
    Error('\p{Script_Extensions=_/a/Inscriptional_pahlavi}');
    Error('\P{Script_Extensions=_/a/Inscriptional_pahlavi}');
    Expect(1, 68479, '\p{Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Script_Extensions=	inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\p{^Script_Extensions=	inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\P{Script_Extensions=	inscriptional_Pahlavi}', "");
    Expect(1, 68479, '\P{^Script_Extensions=	inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\p{Script_Extensions=	inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\p{^Script_Extensions=	inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\P{Script_Extensions=	inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\P{^Script_Extensions=	inscriptional_Pahlavi}', "");
    Error('\p{Scx=-/a/phli}');
    Error('\P{Scx=-/a/phli}');
    Expect(1, 68479, '\p{Scx=phli}', "");
    Expect(0, 68479, '\p{^Scx=phli}', "");
    Expect(0, 68479, '\P{Scx=phli}', "");
    Expect(1, 68479, '\P{^Scx=phli}', "");
    Expect(0, 68480, '\p{Scx=phli}', "");
    Expect(1, 68480, '\p{^Scx=phli}', "");
    Expect(1, 68480, '\P{Scx=phli}', "");
    Expect(0, 68480, '\P{^Scx=phli}', "");
    Expect(1, 68479, '\p{Scx=--Phli}', "");
    Expect(0, 68479, '\p{^Scx=--Phli}', "");
    Expect(0, 68479, '\P{Scx=--Phli}', "");
    Expect(1, 68479, '\P{^Scx=--Phli}', "");
    Expect(0, 68480, '\p{Scx=--Phli}', "");
    Expect(1, 68480, '\p{^Scx=--Phli}', "");
    Expect(1, 68480, '\P{Scx=--Phli}', "");
    Expect(0, 68480, '\P{^Scx=--Phli}', "");
    Error('\p{Is_Script_Extensions=:=	 Inscriptional_PAHLAVI}');
    Error('\P{Is_Script_Extensions=:=	 Inscriptional_PAHLAVI}');
    Expect(1, 68479, '\p{Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Is_Script_Extensions=_	INSCRIPTIONAL_pahlavi}', "");
    Expect(0, 68479, '\p{^Is_Script_Extensions=_	INSCRIPTIONAL_pahlavi}', "");
    Expect(0, 68479, '\P{Is_Script_Extensions=_	INSCRIPTIONAL_pahlavi}', "");
    Expect(1, 68479, '\P{^Is_Script_Extensions=_	INSCRIPTIONAL_pahlavi}', "");
    Expect(0, 68480, '\p{Is_Script_Extensions=_	INSCRIPTIONAL_pahlavi}', "");
    Expect(1, 68480, '\p{^Is_Script_Extensions=_	INSCRIPTIONAL_pahlavi}', "");
    Expect(1, 68480, '\P{Is_Script_Extensions=_	INSCRIPTIONAL_pahlavi}', "");
    Expect(0, 68480, '\P{^Is_Script_Extensions=_	INSCRIPTIONAL_pahlavi}', "");
    Error('\p{Is_Scx=_PHLI/a/}');
    Error('\P{Is_Scx=_PHLI/a/}');
    Expect(1, 68479, '\p{Is_Scx=phli}', "");
    Expect(0, 68479, '\p{^Is_Scx=phli}', "");
    Expect(0, 68479, '\P{Is_Scx=phli}', "");
    Expect(1, 68479, '\P{^Is_Scx=phli}', "");
    Expect(0, 68480, '\p{Is_Scx=phli}', "");
    Expect(1, 68480, '\p{^Is_Scx=phli}', "");
    Expect(1, 68480, '\P{Is_Scx=phli}', "");
    Expect(0, 68480, '\P{^Is_Scx=phli}', "");
    Expect(1, 68479, '\p{Is_Scx=_PHLI}', "");
    Expect(0, 68479, '\p{^Is_Scx=_PHLI}', "");
    Expect(0, 68479, '\P{Is_Scx=_PHLI}', "");
    Expect(1, 68479, '\P{^Is_Scx=_PHLI}', "");
    Expect(0, 68480, '\p{Is_Scx=_PHLI}', "");
    Expect(1, 68480, '\p{^Is_Scx=_PHLI}', "");
    Expect(1, 68480, '\P{Is_Scx=_PHLI}', "");
    Expect(0, 68480, '\P{^Is_Scx=_PHLI}', "");
    Error('\p{Script_Extensions=-psalter_Pahlavi:=}');
    Error('\P{Script_Extensions=-psalter_Pahlavi:=}');
    Expect(1, 68527, '\p{Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Script_Extensions=_	Psalter_Pahlavi}', "");
    Expect(0, 68527, '\p{^Script_Extensions=_	Psalter_Pahlavi}', "");
    Expect(0, 68527, '\P{Script_Extensions=_	Psalter_Pahlavi}', "");
    Expect(1, 68527, '\P{^Script_Extensions=_	Psalter_Pahlavi}', "");
    Expect(0, 68528, '\p{Script_Extensions=_	Psalter_Pahlavi}', "");
    Expect(1, 68528, '\p{^Script_Extensions=_	Psalter_Pahlavi}', "");
    Expect(1, 68528, '\P{Script_Extensions=_	Psalter_Pahlavi}', "");
    Expect(0, 68528, '\P{^Script_Extensions=_	Psalter_Pahlavi}', "");
    Error('\p{Scx=	-PHLP/a/}');
    Error('\P{Scx=	-PHLP/a/}');
    Expect(1, 68527, '\p{Scx=phlp}', "");
    Expect(0, 68527, '\p{^Scx=phlp}', "");
    Expect(0, 68527, '\P{Scx=phlp}', "");
    Expect(1, 68527, '\P{^Scx=phlp}', "");
    Expect(0, 68528, '\p{Scx=phlp}', "");
    Expect(1, 68528, '\p{^Scx=phlp}', "");
    Expect(1, 68528, '\P{Scx=phlp}', "");
    Expect(0, 68528, '\P{^Scx=phlp}', "");
    Expect(1, 68527, '\p{Scx=_phlp}', "");
    Expect(0, 68527, '\p{^Scx=_phlp}', "");
    Expect(0, 68527, '\P{Scx=_phlp}', "");
    Expect(1, 68527, '\P{^Scx=_phlp}', "");
    Expect(0, 68528, '\p{Scx=_phlp}', "");
    Expect(1, 68528, '\p{^Scx=_phlp}', "");
    Expect(1, 68528, '\P{Scx=_phlp}', "");
    Expect(0, 68528, '\P{^Scx=_phlp}', "");
    Error('\p{Is_Script_Extensions=/a/	 Psalter_pahlavi}');
    Error('\P{Is_Script_Extensions=/a/	 Psalter_pahlavi}');
    Expect(1, 68527, '\p{Is_Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Is_Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Is_Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Is_Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Is_Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Is_Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Is_Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Is_Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Is_Script_Extensions= -PSALTER_PAHLAVI}', "");
    Expect(0, 68527, '\p{^Is_Script_Extensions= -PSALTER_PAHLAVI}', "");
    Expect(0, 68527, '\P{Is_Script_Extensions= -PSALTER_PAHLAVI}', "");
    Expect(1, 68527, '\P{^Is_Script_Extensions= -PSALTER_PAHLAVI}', "");
    Expect(0, 68528, '\p{Is_Script_Extensions= -PSALTER_PAHLAVI}', "");
    Expect(1, 68528, '\p{^Is_Script_Extensions= -PSALTER_PAHLAVI}', "");
    Expect(1, 68528, '\P{Is_Script_Extensions= -PSALTER_PAHLAVI}', "");
    Expect(0, 68528, '\P{^Is_Script_Extensions= -PSALTER_PAHLAVI}', "");
    Error('\p{Is_Scx=__phlp/a/}');
    Error('\P{Is_Scx=__phlp/a/}');
    Expect(1, 68527, '\p{Is_Scx=phlp}', "");
    Expect(0, 68527, '\p{^Is_Scx=phlp}', "");
    Expect(0, 68527, '\P{Is_Scx=phlp}', "");
    Expect(1, 68527, '\P{^Is_Scx=phlp}', "");
    Expect(0, 68528, '\p{Is_Scx=phlp}', "");
    Expect(1, 68528, '\p{^Is_Scx=phlp}', "");
    Expect(1, 68528, '\P{Is_Scx=phlp}', "");
    Expect(0, 68528, '\P{^Is_Scx=phlp}', "");
    Expect(1, 68527, '\p{Is_Scx: -Phlp}', "");
    Expect(0, 68527, '\p{^Is_Scx: -Phlp}', "");
    Expect(0, 68527, '\P{Is_Scx: -Phlp}', "");
    Expect(1, 68527, '\P{^Is_Scx: -Phlp}', "");
    Expect(0, 68528, '\p{Is_Scx: -Phlp}', "");
    Expect(1, 68528, '\p{^Is_Scx: -Phlp}', "");
    Expect(1, 68528, '\P{Is_Scx: -Phlp}', "");
    Expect(0, 68528, '\P{^Is_Scx: -Phlp}', "");
    Error('\p{Script_Extensions=:=PHOENICIAN}');
    Error('\P{Script_Extensions=:=PHOENICIAN}');
    Expect(1, 67871, '\p{Script_Extensions=phoenician}', "");
    Expect(0, 67871, '\p{^Script_Extensions=phoenician}', "");
    Expect(0, 67871, '\P{Script_Extensions=phoenician}', "");
    Expect(1, 67871, '\P{^Script_Extensions=phoenician}', "");
    Expect(0, 67872, '\p{Script_Extensions=phoenician}', "");
    Expect(1, 67872, '\p{^Script_Extensions=phoenician}', "");
    Expect(1, 67872, '\P{Script_Extensions=phoenician}', "");
    Expect(0, 67872, '\P{^Script_Extensions=phoenician}', "");
    Expect(1, 67871, '\p{Script_Extensions:   	_Phoenician}', "");
    Expect(0, 67871, '\p{^Script_Extensions:   	_Phoenician}', "");
    Expect(0, 67871, '\P{Script_Extensions:   	_Phoenician}', "");
    Expect(1, 67871, '\P{^Script_Extensions:   	_Phoenician}', "");
    Expect(0, 67872, '\p{Script_Extensions:   	_Phoenician}', "");
    Expect(1, 67872, '\p{^Script_Extensions:   	_Phoenician}', "");
    Expect(1, 67872, '\P{Script_Extensions:   	_Phoenician}', "");
    Expect(0, 67872, '\P{^Script_Extensions:   	_Phoenician}', "");
    Error('\p{Scx:	/a/ Phnx}');
    Error('\P{Scx:	/a/ Phnx}');
    Expect(1, 67871, '\p{Scx=phnx}', "");
    Expect(0, 67871, '\p{^Scx=phnx}', "");
    Expect(0, 67871, '\P{Scx=phnx}', "");
    Expect(1, 67871, '\P{^Scx=phnx}', "");
    Expect(0, 67872, '\p{Scx=phnx}', "");
    Expect(1, 67872, '\p{^Scx=phnx}', "");
    Expect(1, 67872, '\P{Scx=phnx}', "");
    Expect(0, 67872, '\P{^Scx=phnx}', "");
    Expect(1, 67871, '\p{Scx=-	PHNX}', "");
    Expect(0, 67871, '\p{^Scx=-	PHNX}', "");
    Expect(0, 67871, '\P{Scx=-	PHNX}', "");
    Expect(1, 67871, '\P{^Scx=-	PHNX}', "");
    Expect(0, 67872, '\p{Scx=-	PHNX}', "");
    Expect(1, 67872, '\p{^Scx=-	PHNX}', "");
    Expect(1, 67872, '\P{Scx=-	PHNX}', "");
    Expect(0, 67872, '\P{^Scx=-	PHNX}', "");
    Error('\p{Is_Script_Extensions=/a/_phoenician}');
    Error('\P{Is_Script_Extensions=/a/_phoenician}');
    Expect(1, 67871, '\p{Is_Script_Extensions=phoenician}', "");
    Expect(0, 67871, '\p{^Is_Script_Extensions=phoenician}', "");
    Expect(0, 67871, '\P{Is_Script_Extensions=phoenician}', "");
    Expect(1, 67871, '\P{^Is_Script_Extensions=phoenician}', "");
    Expect(0, 67872, '\p{Is_Script_Extensions=phoenician}', "");
    Expect(1, 67872, '\p{^Is_Script_Extensions=phoenician}', "");
    Expect(1, 67872, '\P{Is_Script_Extensions=phoenician}', "");
    Expect(0, 67872, '\P{^Is_Script_Extensions=phoenician}', "");
    Expect(1, 67871, '\p{Is_Script_Extensions=	-phoenician}', "");
    Expect(0, 67871, '\p{^Is_Script_Extensions=	-phoenician}', "");
    Expect(0, 67871, '\P{Is_Script_Extensions=	-phoenician}', "");
    Expect(1, 67871, '\P{^Is_Script_Extensions=	-phoenician}', "");
    Expect(0, 67872, '\p{Is_Script_Extensions=	-phoenician}', "");
    Expect(1, 67872, '\p{^Is_Script_Extensions=	-phoenician}', "");
    Expect(1, 67872, '\P{Is_Script_Extensions=	-phoenician}', "");
    Expect(0, 67872, '\P{^Is_Script_Extensions=	-phoenician}', "");
    Error('\p{Is_Scx: :=__Phnx}');
    Error('\P{Is_Scx: :=__Phnx}');
    Expect(1, 67871, '\p{Is_Scx=phnx}', "");
    Expect(0, 67871, '\p{^Is_Scx=phnx}', "");
    Expect(0, 67871, '\P{Is_Scx=phnx}', "");
    Expect(1, 67871, '\P{^Is_Scx=phnx}', "");
    Expect(0, 67872, '\p{Is_Scx=phnx}', "");
    Expect(1, 67872, '\p{^Is_Scx=phnx}', "");
    Expect(1, 67872, '\P{Is_Scx=phnx}', "");
    Expect(0, 67872, '\P{^Is_Scx=phnx}', "");
    Expect(1, 67871, '\p{Is_Scx=_PHNX}', "");
    Expect(0, 67871, '\p{^Is_Scx=_PHNX}', "");
    Expect(0, 67871, '\P{Is_Scx=_PHNX}', "");
    Expect(1, 67871, '\P{^Is_Scx=_PHNX}', "");
    Expect(0, 67872, '\p{Is_Scx=_PHNX}', "");
    Expect(1, 67872, '\p{^Is_Scx=_PHNX}', "");
    Expect(1, 67872, '\P{Is_Scx=_PHNX}', "");
    Expect(0, 67872, '\P{^Is_Scx=_PHNX}', "");
    Error('\p{Script_Extensions:	 :=Miao}');
    Error('\P{Script_Extensions:	 :=Miao}');
    Expect(1, 94111, '\p{Script_Extensions=miao}', "");
    Expect(0, 94111, '\p{^Script_Extensions=miao}', "");
    Expect(0, 94111, '\P{Script_Extensions=miao}', "");
    Expect(1, 94111, '\P{^Script_Extensions=miao}', "");
    Expect(0, 94112, '\p{Script_Extensions=miao}', "");
    Expect(1, 94112, '\p{^Script_Extensions=miao}', "");
    Expect(1, 94112, '\P{Script_Extensions=miao}', "");
    Expect(0, 94112, '\P{^Script_Extensions=miao}', "");
    Expect(1, 94111, '\p{Script_Extensions=- Miao}', "");
    Expect(0, 94111, '\p{^Script_Extensions=- Miao}', "");
    Expect(0, 94111, '\P{Script_Extensions=- Miao}', "");
    Expect(1, 94111, '\P{^Script_Extensions=- Miao}', "");
    Expect(0, 94112, '\p{Script_Extensions=- Miao}', "");
    Expect(1, 94112, '\p{^Script_Extensions=- Miao}', "");
    Expect(1, 94112, '\P{Script_Extensions=- Miao}', "");
    Expect(0, 94112, '\P{^Script_Extensions=- Miao}', "");
    Error('\p{Scx=  Plrd/a/}');
    Error('\P{Scx=  Plrd/a/}');
    Expect(1, 94111, '\p{Scx=plrd}', "");
    Expect(0, 94111, '\p{^Scx=plrd}', "");
    Expect(0, 94111, '\P{Scx=plrd}', "");
    Expect(1, 94111, '\P{^Scx=plrd}', "");
    Expect(0, 94112, '\p{Scx=plrd}', "");
    Expect(1, 94112, '\p{^Scx=plrd}', "");
    Expect(1, 94112, '\P{Scx=plrd}', "");
    Expect(0, 94112, '\P{^Scx=plrd}', "");
    Expect(1, 94111, '\p{Scx=Plrd}', "");
    Expect(0, 94111, '\p{^Scx=Plrd}', "");
    Expect(0, 94111, '\P{Scx=Plrd}', "");
    Expect(1, 94111, '\P{^Scx=Plrd}', "");
    Expect(0, 94112, '\p{Scx=Plrd}', "");
    Expect(1, 94112, '\p{^Scx=Plrd}', "");
    Expect(1, 94112, '\P{Scx=Plrd}', "");
    Expect(0, 94112, '\P{^Scx=Plrd}', "");
    Error('\p{Is_Script_Extensions=/a/MIAO}');
    Error('\P{Is_Script_Extensions=/a/MIAO}');
    Expect(1, 94111, '\p{Is_Script_Extensions=miao}', "");
    Expect(0, 94111, '\p{^Is_Script_Extensions=miao}', "");
    Expect(0, 94111, '\P{Is_Script_Extensions=miao}', "");
    Expect(1, 94111, '\P{^Is_Script_Extensions=miao}', "");
    Expect(0, 94112, '\p{Is_Script_Extensions=miao}', "");
    Expect(1, 94112, '\p{^Is_Script_Extensions=miao}', "");
    Expect(1, 94112, '\P{Is_Script_Extensions=miao}', "");
    Expect(0, 94112, '\P{^Is_Script_Extensions=miao}', "");
    Expect(1, 94111, '\p{Is_Script_Extensions=		miao}', "");
    Expect(0, 94111, '\p{^Is_Script_Extensions=		miao}', "");
    Expect(0, 94111, '\P{Is_Script_Extensions=		miao}', "");
    Expect(1, 94111, '\P{^Is_Script_Extensions=		miao}', "");
    Expect(0, 94112, '\p{Is_Script_Extensions=		miao}', "");
    Expect(1, 94112, '\p{^Is_Script_Extensions=		miao}', "");
    Expect(1, 94112, '\P{Is_Script_Extensions=		miao}', "");
    Expect(0, 94112, '\P{^Is_Script_Extensions=		miao}', "");
    Error('\p{Is_Scx=_	plrd:=}');
    Error('\P{Is_Scx=_	plrd:=}');
    Expect(1, 94111, '\p{Is_Scx=plrd}', "");
    Expect(0, 94111, '\p{^Is_Scx=plrd}', "");
    Expect(0, 94111, '\P{Is_Scx=plrd}', "");
    Expect(1, 94111, '\P{^Is_Scx=plrd}', "");
    Expect(0, 94112, '\p{Is_Scx=plrd}', "");
    Expect(1, 94112, '\p{^Is_Scx=plrd}', "");
    Expect(1, 94112, '\P{Is_Scx=plrd}', "");
    Expect(0, 94112, '\P{^Is_Scx=plrd}', "");
    Expect(1, 94111, '\p{Is_Scx=	Plrd}', "");
    Expect(0, 94111, '\p{^Is_Scx=	Plrd}', "");
    Expect(0, 94111, '\P{Is_Scx=	Plrd}', "");
    Expect(1, 94111, '\P{^Is_Scx=	Plrd}', "");
    Expect(0, 94112, '\p{Is_Scx=	Plrd}', "");
    Expect(1, 94112, '\p{^Is_Scx=	Plrd}', "");
    Expect(1, 94112, '\P{Is_Scx=	Plrd}', "");
    Expect(0, 94112, '\P{^Is_Scx=	Plrd}', "");
    Error('\p{Script_Extensions=--INSCRIPTIONAL_parthian/a/}');
    Error('\P{Script_Extensions=--INSCRIPTIONAL_parthian/a/}');
    Expect(1, 68447, '\p{Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Script_Extensions=_INSCRIPTIONAL_Parthian}', "");
    Expect(0, 68447, '\p{^Script_Extensions=_INSCRIPTIONAL_Parthian}', "");
    Expect(0, 68447, '\P{Script_Extensions=_INSCRIPTIONAL_Parthian}', "");
    Expect(1, 68447, '\P{^Script_Extensions=_INSCRIPTIONAL_Parthian}', "");
    Expect(0, 68448, '\p{Script_Extensions=_INSCRIPTIONAL_Parthian}', "");
    Expect(1, 68448, '\p{^Script_Extensions=_INSCRIPTIONAL_Parthian}', "");
    Expect(1, 68448, '\P{Script_Extensions=_INSCRIPTIONAL_Parthian}', "");
    Expect(0, 68448, '\P{^Script_Extensions=_INSCRIPTIONAL_Parthian}', "");
    Error('\p{Scx=:=PRTI}');
    Error('\P{Scx=:=PRTI}');
    Expect(1, 68447, '\p{Scx=prti}', "");
    Expect(0, 68447, '\p{^Scx=prti}', "");
    Expect(0, 68447, '\P{Scx=prti}', "");
    Expect(1, 68447, '\P{^Scx=prti}', "");
    Expect(0, 68448, '\p{Scx=prti}', "");
    Expect(1, 68448, '\p{^Scx=prti}', "");
    Expect(1, 68448, '\P{Scx=prti}', "");
    Expect(0, 68448, '\P{^Scx=prti}', "");
    Expect(1, 68447, '\p{Scx=--prti}', "");
    Expect(0, 68447, '\p{^Scx=--prti}', "");
    Expect(0, 68447, '\P{Scx=--prti}', "");
    Expect(1, 68447, '\P{^Scx=--prti}', "");
    Expect(0, 68448, '\p{Scx=--prti}', "");
    Expect(1, 68448, '\p{^Scx=--prti}', "");
    Expect(1, 68448, '\P{Scx=--prti}', "");
    Expect(0, 68448, '\P{^Scx=--prti}', "");
    Error('\p{Is_Script_Extensions=_:=Inscriptional_Parthian}');
    Error('\P{Is_Script_Extensions=_:=Inscriptional_Parthian}');
    Expect(1, 68447, '\p{Is_Script_Extensions: inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Is_Script_Extensions: inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Is_Script_Extensions: inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Is_Script_Extensions: inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Is_Script_Extensions: inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Is_Script_Extensions: inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Is_Script_Extensions: inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Is_Script_Extensions: inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Is_Script_Extensions= _Inscriptional_Parthian}', "");
    Expect(0, 68447, '\p{^Is_Script_Extensions= _Inscriptional_Parthian}', "");
    Expect(0, 68447, '\P{Is_Script_Extensions= _Inscriptional_Parthian}', "");
    Expect(1, 68447, '\P{^Is_Script_Extensions= _Inscriptional_Parthian}', "");
    Expect(0, 68448, '\p{Is_Script_Extensions= _Inscriptional_Parthian}', "");
    Expect(1, 68448, '\p{^Is_Script_Extensions= _Inscriptional_Parthian}', "");
    Expect(1, 68448, '\P{Is_Script_Extensions= _Inscriptional_Parthian}', "");
    Expect(0, 68448, '\P{^Is_Script_Extensions= _Inscriptional_Parthian}', "");
    Error('\p{Is_Scx=-/a/Prti}');
    Error('\P{Is_Scx=-/a/Prti}');
    Expect(1, 68447, '\p{Is_Scx=prti}', "");
    Expect(0, 68447, '\p{^Is_Scx=prti}', "");
    Expect(0, 68447, '\P{Is_Scx=prti}', "");
    Expect(1, 68447, '\P{^Is_Scx=prti}', "");
    Expect(0, 68448, '\p{Is_Scx=prti}', "");
    Expect(1, 68448, '\p{^Is_Scx=prti}', "");
    Expect(1, 68448, '\P{Is_Scx=prti}', "");
    Expect(0, 68448, '\P{^Is_Scx=prti}', "");
    Expect(1, 68447, '\p{Is_Scx=_Prti}', "");
    Expect(0, 68447, '\p{^Is_Scx=_Prti}', "");
    Expect(0, 68447, '\P{Is_Scx=_Prti}', "");
    Expect(1, 68447, '\P{^Is_Scx=_Prti}', "");
    Expect(0, 68448, '\p{Is_Scx=_Prti}', "");
    Expect(1, 68448, '\p{^Is_Scx=_Prti}', "");
    Expect(1, 68448, '\P{Is_Scx=_Prti}', "");
    Expect(0, 68448, '\P{^Is_Scx=_Prti}', "");
    Error('\p{Script_Extensions=__REJANG:=}');
    Error('\P{Script_Extensions=__REJANG:=}');
    Expect(1, 43359, '\p{Script_Extensions:rejang}', "");
    Expect(0, 43359, '\p{^Script_Extensions:rejang}', "");
    Expect(0, 43359, '\P{Script_Extensions:rejang}', "");
    Expect(1, 43359, '\P{^Script_Extensions:rejang}', "");
    Expect(0, 43360, '\p{Script_Extensions:rejang}', "");
    Expect(1, 43360, '\p{^Script_Extensions:rejang}', "");
    Expect(1, 43360, '\P{Script_Extensions:rejang}', "");
    Expect(0, 43360, '\P{^Script_Extensions:rejang}', "");
    Expect(1, 43359, '\p{Script_Extensions=_Rejang}', "");
    Expect(0, 43359, '\p{^Script_Extensions=_Rejang}', "");
    Expect(0, 43359, '\P{Script_Extensions=_Rejang}', "");
    Expect(1, 43359, '\P{^Script_Extensions=_Rejang}', "");
    Expect(0, 43360, '\p{Script_Extensions=_Rejang}', "");
    Expect(1, 43360, '\p{^Script_Extensions=_Rejang}', "");
    Expect(1, 43360, '\P{Script_Extensions=_Rejang}', "");
    Expect(0, 43360, '\P{^Script_Extensions=_Rejang}', "");
    Error('\p{Scx=-:=Rjng}');
    Error('\P{Scx=-:=Rjng}');
    Expect(1, 43359, '\p{Scx=rjng}', "");
    Expect(0, 43359, '\p{^Scx=rjng}', "");
    Expect(0, 43359, '\P{Scx=rjng}', "");
    Expect(1, 43359, '\P{^Scx=rjng}', "");
    Expect(0, 43360, '\p{Scx=rjng}', "");
    Expect(1, 43360, '\p{^Scx=rjng}', "");
    Expect(1, 43360, '\P{Scx=rjng}', "");
    Expect(0, 43360, '\P{^Scx=rjng}', "");
    Expect(1, 43359, '\p{Scx=_RJNG}', "");
    Expect(0, 43359, '\p{^Scx=_RJNG}', "");
    Expect(0, 43359, '\P{Scx=_RJNG}', "");
    Expect(1, 43359, '\P{^Scx=_RJNG}', "");
    Expect(0, 43360, '\p{Scx=_RJNG}', "");
    Expect(1, 43360, '\p{^Scx=_RJNG}', "");
    Expect(1, 43360, '\P{Scx=_RJNG}', "");
    Expect(0, 43360, '\P{^Scx=_RJNG}', "");
    Error('\p{Is_Script_Extensions=_	Rejang/a/}');
    Error('\P{Is_Script_Extensions=_	Rejang/a/}');
    Expect(1, 43359, '\p{Is_Script_Extensions=rejang}', "");
    Expect(0, 43359, '\p{^Is_Script_Extensions=rejang}', "");
    Expect(0, 43359, '\P{Is_Script_Extensions=rejang}', "");
    Expect(1, 43359, '\P{^Is_Script_Extensions=rejang}', "");
    Expect(0, 43360, '\p{Is_Script_Extensions=rejang}', "");
    Expect(1, 43360, '\p{^Is_Script_Extensions=rejang}', "");
    Expect(1, 43360, '\P{Is_Script_Extensions=rejang}', "");
    Expect(0, 43360, '\P{^Is_Script_Extensions=rejang}', "");
    Expect(1, 43359, '\p{Is_Script_Extensions=		rejang}', "");
    Expect(0, 43359, '\p{^Is_Script_Extensions=		rejang}', "");
    Expect(0, 43359, '\P{Is_Script_Extensions=		rejang}', "");
    Expect(1, 43359, '\P{^Is_Script_Extensions=		rejang}', "");
    Expect(0, 43360, '\p{Is_Script_Extensions=		rejang}', "");
    Expect(1, 43360, '\p{^Is_Script_Extensions=		rejang}', "");
    Expect(1, 43360, '\P{Is_Script_Extensions=		rejang}', "");
    Expect(0, 43360, '\P{^Is_Script_Extensions=		rejang}', "");
    Error('\p{Is_Scx:	/a/--Rjng}');
    Error('\P{Is_Scx:	/a/--Rjng}');
    Expect(1, 43359, '\p{Is_Scx=rjng}', "");
    Expect(0, 43359, '\p{^Is_Scx=rjng}', "");
    Expect(0, 43359, '\P{Is_Scx=rjng}', "");
    Expect(1, 43359, '\P{^Is_Scx=rjng}', "");
    Expect(0, 43360, '\p{Is_Scx=rjng}', "");
    Expect(1, 43360, '\p{^Is_Scx=rjng}', "");
    Expect(1, 43360, '\P{Is_Scx=rjng}', "");
    Expect(0, 43360, '\P{^Is_Scx=rjng}', "");
    Expect(1, 43359, '\p{Is_Scx=__RJNG}', "");
    Expect(0, 43359, '\p{^Is_Scx=__RJNG}', "");
    Expect(0, 43359, '\P{Is_Scx=__RJNG}', "");
    Expect(1, 43359, '\P{^Is_Scx=__RJNG}', "");
    Expect(0, 43360, '\p{Is_Scx=__RJNG}', "");
    Expect(1, 43360, '\p{^Is_Scx=__RJNG}', "");
    Expect(1, 43360, '\P{Is_Scx=__RJNG}', "");
    Expect(0, 43360, '\P{^Is_Scx=__RJNG}', "");
    Error('\p{Script_Extensions=-_runic:=}');
    Error('\P{Script_Extensions=-_runic:=}');
    Expect(1, 5880, '\p{Script_Extensions=runic}', "");
    Expect(0, 5880, '\p{^Script_Extensions=runic}', "");
    Expect(0, 5880, '\P{Script_Extensions=runic}', "");
    Expect(1, 5880, '\P{^Script_Extensions=runic}', "");
    Expect(0, 5881, '\p{Script_Extensions=runic}', "");
    Expect(1, 5881, '\p{^Script_Extensions=runic}', "");
    Expect(1, 5881, '\P{Script_Extensions=runic}', "");
    Expect(0, 5881, '\P{^Script_Extensions=runic}', "");
    Expect(1, 5880, '\p{Script_Extensions=	 Runic}', "");
    Expect(0, 5880, '\p{^Script_Extensions=	 Runic}', "");
    Expect(0, 5880, '\P{Script_Extensions=	 Runic}', "");
    Expect(1, 5880, '\P{^Script_Extensions=	 Runic}', "");
    Expect(0, 5881, '\p{Script_Extensions=	 Runic}', "");
    Expect(1, 5881, '\p{^Script_Extensions=	 Runic}', "");
    Expect(1, 5881, '\P{Script_Extensions=	 Runic}', "");
    Expect(0, 5881, '\P{^Script_Extensions=	 Runic}', "");
    Error('\p{Scx: 	/a/runr}');
    Error('\P{Scx: 	/a/runr}');
    Expect(1, 5880, '\p{Scx:runr}', "");
    Expect(0, 5880, '\p{^Scx:runr}', "");
    Expect(0, 5880, '\P{Scx:runr}', "");
    Expect(1, 5880, '\P{^Scx:runr}', "");
    Expect(0, 5881, '\p{Scx:runr}', "");
    Expect(1, 5881, '\p{^Scx:runr}', "");
    Expect(1, 5881, '\P{Scx:runr}', "");
    Expect(0, 5881, '\P{^Scx:runr}', "");
    Expect(1, 5880, '\p{Scx= -Runr}', "");
    Expect(0, 5880, '\p{^Scx= -Runr}', "");
    Expect(0, 5880, '\P{Scx= -Runr}', "");
    Expect(1, 5880, '\P{^Scx= -Runr}', "");
    Expect(0, 5881, '\p{Scx= -Runr}', "");
    Expect(1, 5881, '\p{^Scx= -Runr}', "");
    Expect(1, 5881, '\P{Scx= -Runr}', "");
    Expect(0, 5881, '\P{^Scx= -Runr}', "");
    Error('\p{Is_Script_Extensions=/a/runic}');
    Error('\P{Is_Script_Extensions=/a/runic}');
    Expect(1, 5880, '\p{Is_Script_Extensions=runic}', "");
    Expect(0, 5880, '\p{^Is_Script_Extensions=runic}', "");
    Expect(0, 5880, '\P{Is_Script_Extensions=runic}', "");
    Expect(1, 5880, '\P{^Is_Script_Extensions=runic}', "");
    Expect(0, 5881, '\p{Is_Script_Extensions=runic}', "");
    Expect(1, 5881, '\p{^Is_Script_Extensions=runic}', "");
    Expect(1, 5881, '\P{Is_Script_Extensions=runic}', "");
    Expect(0, 5881, '\P{^Is_Script_Extensions=runic}', "");
    Expect(1, 5880, '\p{Is_Script_Extensions=_	runic}', "");
    Expect(0, 5880, '\p{^Is_Script_Extensions=_	runic}', "");
    Expect(0, 5880, '\P{Is_Script_Extensions=_	runic}', "");
    Expect(1, 5880, '\P{^Is_Script_Extensions=_	runic}', "");
    Expect(0, 5881, '\p{Is_Script_Extensions=_	runic}', "");
    Expect(1, 5881, '\p{^Is_Script_Extensions=_	runic}', "");
    Expect(1, 5881, '\P{Is_Script_Extensions=_	runic}', "");
    Expect(0, 5881, '\P{^Is_Script_Extensions=_	runic}', "");
    Error('\p{Is_Scx=-_RUNR:=}');
    Error('\P{Is_Scx=-_RUNR:=}');
    Expect(1, 5880, '\p{Is_Scx=runr}', "");
    Expect(0, 5880, '\p{^Is_Scx=runr}', "");
    Expect(0, 5880, '\P{Is_Scx=runr}', "");
    Expect(1, 5880, '\P{^Is_Scx=runr}', "");
    Expect(0, 5881, '\p{Is_Scx=runr}', "");
    Expect(1, 5881, '\p{^Is_Scx=runr}', "");
    Expect(1, 5881, '\P{Is_Scx=runr}', "");
    Expect(0, 5881, '\P{^Is_Scx=runr}', "");
    Expect(1, 5880, '\p{Is_Scx=		runr}', "");
    Expect(0, 5880, '\p{^Is_Scx=		runr}', "");
    Expect(0, 5880, '\P{Is_Scx=		runr}', "");
    Expect(1, 5880, '\P{^Is_Scx=		runr}', "");
    Expect(0, 5881, '\p{Is_Scx=		runr}', "");
    Expect(1, 5881, '\p{^Is_Scx=		runr}', "");
    Expect(1, 5881, '\P{Is_Scx=		runr}', "");
    Expect(0, 5881, '\P{^Is_Scx=		runr}', "");
    Error('\p{Script_Extensions=_:=Samaritan}');
    Error('\P{Script_Extensions=_:=Samaritan}');
    Expect(1, 2110, '\p{Script_Extensions=samaritan}', "");
    Expect(0, 2110, '\p{^Script_Extensions=samaritan}', "");
    Expect(0, 2110, '\P{Script_Extensions=samaritan}', "");
    Expect(1, 2110, '\P{^Script_Extensions=samaritan}', "");
    Expect(0, 2111, '\p{Script_Extensions=samaritan}', "");
    Expect(1, 2111, '\p{^Script_Extensions=samaritan}', "");
    Expect(1, 2111, '\P{Script_Extensions=samaritan}', "");
    Expect(0, 2111, '\P{^Script_Extensions=samaritan}', "");
    Expect(1, 2110, '\p{Script_Extensions:	samaritan}', "");
    Expect(0, 2110, '\p{^Script_Extensions:	samaritan}', "");
    Expect(0, 2110, '\P{Script_Extensions:	samaritan}', "");
    Expect(1, 2110, '\P{^Script_Extensions:	samaritan}', "");
    Expect(0, 2111, '\p{Script_Extensions:	samaritan}', "");
    Expect(1, 2111, '\p{^Script_Extensions:	samaritan}', "");
    Expect(1, 2111, '\P{Script_Extensions:	samaritan}', "");
    Expect(0, 2111, '\P{^Script_Extensions:	samaritan}', "");
    Error('\p{Scx=/a/ -samr}');
    Error('\P{Scx=/a/ -samr}');
    Expect(1, 2110, '\p{Scx=samr}', "");
    Expect(0, 2110, '\p{^Scx=samr}', "");
    Expect(0, 2110, '\P{Scx=samr}', "");
    Expect(1, 2110, '\P{^Scx=samr}', "");
    Expect(0, 2111, '\p{Scx=samr}', "");
    Expect(1, 2111, '\p{^Scx=samr}', "");
    Expect(1, 2111, '\P{Scx=samr}', "");
    Expect(0, 2111, '\P{^Scx=samr}', "");
    Expect(1, 2110, '\p{Scx:   -	Samr}', "");
    Expect(0, 2110, '\p{^Scx:   -	Samr}', "");
    Expect(0, 2110, '\P{Scx:   -	Samr}', "");
    Expect(1, 2110, '\P{^Scx:   -	Samr}', "");
    Expect(0, 2111, '\p{Scx:   -	Samr}', "");
    Expect(1, 2111, '\p{^Scx:   -	Samr}', "");
    Expect(1, 2111, '\P{Scx:   -	Samr}', "");
    Expect(0, 2111, '\P{^Scx:   -	Samr}', "");
    Error('\p{Is_Script_Extensions=-/a/SAMARITAN}');
    Error('\P{Is_Script_Extensions=-/a/SAMARITAN}');
    Expect(1, 2110, '\p{Is_Script_Extensions=samaritan}', "");
    Expect(0, 2110, '\p{^Is_Script_Extensions=samaritan}', "");
    Expect(0, 2110, '\P{Is_Script_Extensions=samaritan}', "");
    Expect(1, 2110, '\P{^Is_Script_Extensions=samaritan}', "");
    Expect(0, 2111, '\p{Is_Script_Extensions=samaritan}', "");
    Expect(1, 2111, '\p{^Is_Script_Extensions=samaritan}', "");
    Expect(1, 2111, '\P{Is_Script_Extensions=samaritan}', "");
    Expect(0, 2111, '\P{^Is_Script_Extensions=samaritan}', "");
    Expect(1, 2110, '\p{Is_Script_Extensions=	-Samaritan}', "");
    Expect(0, 2110, '\p{^Is_Script_Extensions=	-Samaritan}', "");
    Expect(0, 2110, '\P{Is_Script_Extensions=	-Samaritan}', "");
    Expect(1, 2110, '\P{^Is_Script_Extensions=	-Samaritan}', "");
    Expect(0, 2111, '\p{Is_Script_Extensions=	-Samaritan}', "");
    Expect(1, 2111, '\p{^Is_Script_Extensions=	-Samaritan}', "");
    Expect(1, 2111, '\P{Is_Script_Extensions=	-Samaritan}', "");
    Expect(0, 2111, '\P{^Is_Script_Extensions=	-Samaritan}', "");
    Error('\p{Is_Scx=	SAMR/a/}');
    Error('\P{Is_Scx=	SAMR/a/}');
    Expect(1, 2110, '\p{Is_Scx=samr}', "");
    Expect(0, 2110, '\p{^Is_Scx=samr}', "");
    Expect(0, 2110, '\P{Is_Scx=samr}', "");
    Expect(1, 2110, '\P{^Is_Scx=samr}', "");
    Expect(0, 2111, '\p{Is_Scx=samr}', "");
    Expect(1, 2111, '\p{^Is_Scx=samr}', "");
    Expect(1, 2111, '\P{Is_Scx=samr}', "");
    Expect(0, 2111, '\P{^Is_Scx=samr}', "");
    Expect(1, 2110, '\p{Is_Scx=_Samr}', "");
    Expect(0, 2110, '\p{^Is_Scx=_Samr}', "");
    Expect(0, 2110, '\P{Is_Scx=_Samr}', "");
    Expect(1, 2110, '\P{^Is_Scx=_Samr}', "");
    Expect(0, 2111, '\p{Is_Scx=_Samr}', "");
    Expect(1, 2111, '\p{^Is_Scx=_Samr}', "");
    Expect(1, 2111, '\P{Is_Scx=_Samr}', "");
    Expect(0, 2111, '\P{^Is_Scx=_Samr}', "");
    Error('\p{Script_Extensions=	/a/OLD_south_arabian}');
    Error('\P{Script_Extensions=	/a/OLD_south_arabian}');
    Expect(1, 68223, '\p{Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Script_Extensions=-_Old_South_arabian}', "");
    Expect(0, 68223, '\p{^Script_Extensions=-_Old_South_arabian}', "");
    Expect(0, 68223, '\P{Script_Extensions=-_Old_South_arabian}', "");
    Expect(1, 68223, '\P{^Script_Extensions=-_Old_South_arabian}', "");
    Expect(0, 68224, '\p{Script_Extensions=-_Old_South_arabian}', "");
    Expect(1, 68224, '\p{^Script_Extensions=-_Old_South_arabian}', "");
    Expect(1, 68224, '\P{Script_Extensions=-_Old_South_arabian}', "");
    Expect(0, 68224, '\P{^Script_Extensions=-_Old_South_arabian}', "");
    Error('\p{Scx=	-Sarb/a/}');
    Error('\P{Scx=	-Sarb/a/}');
    Expect(1, 68223, '\p{Scx=sarb}', "");
    Expect(0, 68223, '\p{^Scx=sarb}', "");
    Expect(0, 68223, '\P{Scx=sarb}', "");
    Expect(1, 68223, '\P{^Scx=sarb}', "");
    Expect(0, 68224, '\p{Scx=sarb}', "");
    Expect(1, 68224, '\p{^Scx=sarb}', "");
    Expect(1, 68224, '\P{Scx=sarb}', "");
    Expect(0, 68224, '\P{^Scx=sarb}', "");
    Expect(1, 68223, '\p{Scx=__Sarb}', "");
    Expect(0, 68223, '\p{^Scx=__Sarb}', "");
    Expect(0, 68223, '\P{Scx=__Sarb}', "");
    Expect(1, 68223, '\P{^Scx=__Sarb}', "");
    Expect(0, 68224, '\p{Scx=__Sarb}', "");
    Expect(1, 68224, '\p{^Scx=__Sarb}', "");
    Expect(1, 68224, '\P{Scx=__Sarb}', "");
    Expect(0, 68224, '\P{^Scx=__Sarb}', "");
    Error('\p{Is_Script_Extensions=/a/-old_south_Arabian}');
    Error('\P{Is_Script_Extensions=/a/-old_south_Arabian}');
    Expect(1, 68223, '\p{Is_Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Is_Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Is_Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Is_Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Is_Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Is_Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Is_Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Is_Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Is_Script_Extensions=-_OLD_SOUTH_Arabian}', "");
    Expect(0, 68223, '\p{^Is_Script_Extensions=-_OLD_SOUTH_Arabian}', "");
    Expect(0, 68223, '\P{Is_Script_Extensions=-_OLD_SOUTH_Arabian}', "");
    Expect(1, 68223, '\P{^Is_Script_Extensions=-_OLD_SOUTH_Arabian}', "");
    Expect(0, 68224, '\p{Is_Script_Extensions=-_OLD_SOUTH_Arabian}', "");
    Expect(1, 68224, '\p{^Is_Script_Extensions=-_OLD_SOUTH_Arabian}', "");
    Expect(1, 68224, '\P{Is_Script_Extensions=-_OLD_SOUTH_Arabian}', "");
    Expect(0, 68224, '\P{^Is_Script_Extensions=-_OLD_SOUTH_Arabian}', "");
    Error('\p{Is_Scx=	:=Sarb}');
    Error('\P{Is_Scx=	:=Sarb}');
    Expect(1, 68223, '\p{Is_Scx:sarb}', "");
    Expect(0, 68223, '\p{^Is_Scx:sarb}', "");
    Expect(0, 68223, '\P{Is_Scx:sarb}', "");
    Expect(1, 68223, '\P{^Is_Scx:sarb}', "");
    Expect(0, 68224, '\p{Is_Scx:sarb}', "");
    Expect(1, 68224, '\p{^Is_Scx:sarb}', "");
    Expect(1, 68224, '\P{Is_Scx:sarb}', "");
    Expect(0, 68224, '\P{^Is_Scx:sarb}', "");
    Expect(1, 68223, '\p{Is_Scx: _sarb}', "");
    Expect(0, 68223, '\p{^Is_Scx: _sarb}', "");
    Expect(0, 68223, '\P{Is_Scx: _sarb}', "");
    Expect(1, 68223, '\P{^Is_Scx: _sarb}', "");
    Expect(0, 68224, '\p{Is_Scx: _sarb}', "");
    Expect(1, 68224, '\p{^Is_Scx: _sarb}', "");
    Expect(1, 68224, '\P{Is_Scx: _sarb}', "");
    Expect(0, 68224, '\P{^Is_Scx: _sarb}', "");
    Error('\p{Script_Extensions=:=saurashtra}');
    Error('\P{Script_Extensions=:=saurashtra}');
    Expect(1, 43225, '\p{Script_Extensions=saurashtra}', "");
    Expect(0, 43225, '\p{^Script_Extensions=saurashtra}', "");
    Expect(0, 43225, '\P{Script_Extensions=saurashtra}', "");
    Expect(1, 43225, '\P{^Script_Extensions=saurashtra}', "");
    Expect(0, 43226, '\p{Script_Extensions=saurashtra}', "");
    Expect(1, 43226, '\p{^Script_Extensions=saurashtra}', "");
    Expect(1, 43226, '\P{Script_Extensions=saurashtra}', "");
    Expect(0, 43226, '\P{^Script_Extensions=saurashtra}', "");
    Expect(1, 43225, '\p{Script_Extensions=- SAURASHTRA}', "");
    Expect(0, 43225, '\p{^Script_Extensions=- SAURASHTRA}', "");
    Expect(0, 43225, '\P{Script_Extensions=- SAURASHTRA}', "");
    Expect(1, 43225, '\P{^Script_Extensions=- SAURASHTRA}', "");
    Expect(0, 43226, '\p{Script_Extensions=- SAURASHTRA}', "");
    Expect(1, 43226, '\p{^Script_Extensions=- SAURASHTRA}', "");
    Expect(1, 43226, '\P{Script_Extensions=- SAURASHTRA}', "");
    Expect(0, 43226, '\P{^Script_Extensions=- SAURASHTRA}', "");
    Error('\p{Scx=	Saur:=}');
    Error('\P{Scx=	Saur:=}');
    Expect(1, 43225, '\p{Scx:saur}', "");
    Expect(0, 43225, '\p{^Scx:saur}', "");
    Expect(0, 43225, '\P{Scx:saur}', "");
    Expect(1, 43225, '\P{^Scx:saur}', "");
    Expect(0, 43226, '\p{Scx:saur}', "");
    Expect(1, 43226, '\p{^Scx:saur}', "");
    Expect(1, 43226, '\P{Scx:saur}', "");
    Expect(0, 43226, '\P{^Scx:saur}', "");
    Expect(1, 43225, '\p{Scx=	_saur}', "");
    Expect(0, 43225, '\p{^Scx=	_saur}', "");
    Expect(0, 43225, '\P{Scx=	_saur}', "");
    Expect(1, 43225, '\P{^Scx=	_saur}', "");
    Expect(0, 43226, '\p{Scx=	_saur}', "");
    Expect(1, 43226, '\p{^Scx=	_saur}', "");
    Expect(1, 43226, '\P{Scx=	_saur}', "");
    Expect(0, 43226, '\P{^Scx=	_saur}', "");
    Error('\p{Is_Script_Extensions=/a/Saurashtra}');
    Error('\P{Is_Script_Extensions=/a/Saurashtra}');
    Expect(1, 43225, '\p{Is_Script_Extensions=saurashtra}', "");
    Expect(0, 43225, '\p{^Is_Script_Extensions=saurashtra}', "");
    Expect(0, 43225, '\P{Is_Script_Extensions=saurashtra}', "");
    Expect(1, 43225, '\P{^Is_Script_Extensions=saurashtra}', "");
    Expect(0, 43226, '\p{Is_Script_Extensions=saurashtra}', "");
    Expect(1, 43226, '\p{^Is_Script_Extensions=saurashtra}', "");
    Expect(1, 43226, '\P{Is_Script_Extensions=saurashtra}', "");
    Expect(0, 43226, '\P{^Is_Script_Extensions=saurashtra}', "");
    Expect(1, 43225, '\p{Is_Script_Extensions= -saurashtra}', "");
    Expect(0, 43225, '\p{^Is_Script_Extensions= -saurashtra}', "");
    Expect(0, 43225, '\P{Is_Script_Extensions= -saurashtra}', "");
    Expect(1, 43225, '\P{^Is_Script_Extensions= -saurashtra}', "");
    Expect(0, 43226, '\p{Is_Script_Extensions= -saurashtra}', "");
    Expect(1, 43226, '\p{^Is_Script_Extensions= -saurashtra}', "");
    Expect(1, 43226, '\P{Is_Script_Extensions= -saurashtra}', "");
    Expect(0, 43226, '\P{^Is_Script_Extensions= -saurashtra}', "");
    Error('\p{Is_Scx=/a/- SAUR}');
    Error('\P{Is_Scx=/a/- SAUR}');
    Expect(1, 43225, '\p{Is_Scx=saur}', "");
    Expect(0, 43225, '\p{^Is_Scx=saur}', "");
    Expect(0, 43225, '\P{Is_Scx=saur}', "");
    Expect(1, 43225, '\P{^Is_Scx=saur}', "");
    Expect(0, 43226, '\p{Is_Scx=saur}', "");
    Expect(1, 43226, '\p{^Is_Scx=saur}', "");
    Expect(1, 43226, '\P{Is_Scx=saur}', "");
    Expect(0, 43226, '\P{^Is_Scx=saur}', "");
    Expect(1, 43225, '\p{Is_Scx= -saur}', "");
    Expect(0, 43225, '\p{^Is_Scx= -saur}', "");
    Expect(0, 43225, '\P{Is_Scx= -saur}', "");
    Expect(1, 43225, '\P{^Is_Scx= -saur}', "");
    Expect(0, 43226, '\p{Is_Scx= -saur}', "");
    Expect(1, 43226, '\p{^Is_Scx= -saur}', "");
    Expect(1, 43226, '\P{Is_Scx= -saur}', "");
    Expect(0, 43226, '\P{^Is_Scx= -saur}', "");
    Error('\p{Script_Extensions=--signwriting:=}');
    Error('\P{Script_Extensions=--signwriting:=}');
    Expect(1, 121519, '\p{Script_Extensions=signwriting}', "");
    Expect(0, 121519, '\p{^Script_Extensions=signwriting}', "");
    Expect(0, 121519, '\P{Script_Extensions=signwriting}', "");
    Expect(1, 121519, '\P{^Script_Extensions=signwriting}', "");
    Expect(0, 121520, '\p{Script_Extensions=signwriting}', "");
    Expect(1, 121520, '\p{^Script_Extensions=signwriting}', "");
    Expect(1, 121520, '\P{Script_Extensions=signwriting}', "");
    Expect(0, 121520, '\P{^Script_Extensions=signwriting}', "");
    Expect(1, 121519, '\p{Script_Extensions=	SIGNWRITING}', "");
    Expect(0, 121519, '\p{^Script_Extensions=	SIGNWRITING}', "");
    Expect(0, 121519, '\P{Script_Extensions=	SIGNWRITING}', "");
    Expect(1, 121519, '\P{^Script_Extensions=	SIGNWRITING}', "");
    Expect(0, 121520, '\p{Script_Extensions=	SIGNWRITING}', "");
    Expect(1, 121520, '\p{^Script_Extensions=	SIGNWRITING}', "");
    Expect(1, 121520, '\P{Script_Extensions=	SIGNWRITING}', "");
    Expect(0, 121520, '\P{^Script_Extensions=	SIGNWRITING}', "");
    Error('\p{Scx=:= 	Sgnw}');
    Error('\P{Scx=:= 	Sgnw}');
    Expect(1, 121519, '\p{Scx=sgnw}', "");
    Expect(0, 121519, '\p{^Scx=sgnw}', "");
    Expect(0, 121519, '\P{Scx=sgnw}', "");
    Expect(1, 121519, '\P{^Scx=sgnw}', "");
    Expect(0, 121520, '\p{Scx=sgnw}', "");
    Expect(1, 121520, '\p{^Scx=sgnw}', "");
    Expect(1, 121520, '\P{Scx=sgnw}', "");
    Expect(0, 121520, '\P{^Scx=sgnw}', "");
    Expect(1, 121519, '\p{Scx=	-Sgnw}', "");
    Expect(0, 121519, '\p{^Scx=	-Sgnw}', "");
    Expect(0, 121519, '\P{Scx=	-Sgnw}', "");
    Expect(1, 121519, '\P{^Scx=	-Sgnw}', "");
    Expect(0, 121520, '\p{Scx=	-Sgnw}', "");
    Expect(1, 121520, '\p{^Scx=	-Sgnw}', "");
    Expect(1, 121520, '\P{Scx=	-Sgnw}', "");
    Expect(0, 121520, '\P{^Scx=	-Sgnw}', "");
    Error('\p{Is_Script_Extensions= SignWriting:=}');
    Error('\P{Is_Script_Extensions= SignWriting:=}');
    Expect(1, 121519, '\p{Is_Script_Extensions=signwriting}', "");
    Expect(0, 121519, '\p{^Is_Script_Extensions=signwriting}', "");
    Expect(0, 121519, '\P{Is_Script_Extensions=signwriting}', "");
    Expect(1, 121519, '\P{^Is_Script_Extensions=signwriting}', "");
    Expect(0, 121520, '\p{Is_Script_Extensions=signwriting}', "");
    Expect(1, 121520, '\p{^Is_Script_Extensions=signwriting}', "");
    Expect(1, 121520, '\P{Is_Script_Extensions=signwriting}', "");
    Expect(0, 121520, '\P{^Is_Script_Extensions=signwriting}', "");
    Expect(1, 121519, '\p{Is_Script_Extensions=_	SignWriting}', "");
    Expect(0, 121519, '\p{^Is_Script_Extensions=_	SignWriting}', "");
    Expect(0, 121519, '\P{Is_Script_Extensions=_	SignWriting}', "");
    Expect(1, 121519, '\P{^Is_Script_Extensions=_	SignWriting}', "");
    Expect(0, 121520, '\p{Is_Script_Extensions=_	SignWriting}', "");
    Expect(1, 121520, '\p{^Is_Script_Extensions=_	SignWriting}', "");
    Expect(1, 121520, '\P{Is_Script_Extensions=_	SignWriting}', "");
    Expect(0, 121520, '\P{^Is_Script_Extensions=_	SignWriting}', "");
    Error('\p{Is_Scx=	:=sgnw}');
    Error('\P{Is_Scx=	:=sgnw}');
    Expect(1, 121519, '\p{Is_Scx:sgnw}', "");
    Expect(0, 121519, '\p{^Is_Scx:sgnw}', "");
    Expect(0, 121519, '\P{Is_Scx:sgnw}', "");
    Expect(1, 121519, '\P{^Is_Scx:sgnw}', "");
    Expect(0, 121520, '\p{Is_Scx:sgnw}', "");
    Expect(1, 121520, '\p{^Is_Scx:sgnw}', "");
    Expect(1, 121520, '\P{Is_Scx:sgnw}', "");
    Expect(0, 121520, '\P{^Is_Scx:sgnw}', "");
    Expect(1, 121519, '\p{Is_Scx=	_Sgnw}', "");
    Expect(0, 121519, '\p{^Is_Scx=	_Sgnw}', "");
    Expect(0, 121519, '\P{Is_Scx=	_Sgnw}', "");
    Expect(1, 121519, '\P{^Is_Scx=	_Sgnw}', "");
    Expect(0, 121520, '\p{Is_Scx=	_Sgnw}', "");
    Expect(1, 121520, '\p{^Is_Scx=	_Sgnw}', "");
    Expect(1, 121520, '\P{Is_Scx=	_Sgnw}', "");
    Expect(0, 121520, '\P{^Is_Scx=	_Sgnw}', "");
    Error('\p{Script_Extensions=_:=Shavian}');
    Error('\P{Script_Extensions=_:=Shavian}');
    Expect(1, 66687, '\p{Script_Extensions:   shavian}', "");
    Expect(0, 66687, '\p{^Script_Extensions:   shavian}', "");
    Expect(0, 66687, '\P{Script_Extensions:   shavian}', "");
    Expect(1, 66687, '\P{^Script_Extensions:   shavian}', "");
    Expect(0, 66688, '\p{Script_Extensions:   shavian}', "");
    Expect(1, 66688, '\p{^Script_Extensions:   shavian}', "");
    Expect(1, 66688, '\P{Script_Extensions:   shavian}', "");
    Expect(0, 66688, '\P{^Script_Extensions:   shavian}', "");
    Expect(1, 66687, '\p{Script_Extensions: _	shavian}', "");
    Expect(0, 66687, '\p{^Script_Extensions: _	shavian}', "");
    Expect(0, 66687, '\P{Script_Extensions: _	shavian}', "");
    Expect(1, 66687, '\P{^Script_Extensions: _	shavian}', "");
    Expect(0, 66688, '\p{Script_Extensions: _	shavian}', "");
    Expect(1, 66688, '\p{^Script_Extensions: _	shavian}', "");
    Expect(1, 66688, '\P{Script_Extensions: _	shavian}', "");
    Expect(0, 66688, '\P{^Script_Extensions: _	shavian}', "");
    Error('\p{Scx=	:=SHAW}');
    Error('\P{Scx=	:=SHAW}');
    Expect(1, 66687, '\p{Scx=shaw}', "");
    Expect(0, 66687, '\p{^Scx=shaw}', "");
    Expect(0, 66687, '\P{Scx=shaw}', "");
    Expect(1, 66687, '\P{^Scx=shaw}', "");
    Expect(0, 66688, '\p{Scx=shaw}', "");
    Expect(1, 66688, '\p{^Scx=shaw}', "");
    Expect(1, 66688, '\P{Scx=shaw}', "");
    Expect(0, 66688, '\P{^Scx=shaw}', "");
    Expect(1, 66687, '\p{Scx=	SHAW}', "");
    Expect(0, 66687, '\p{^Scx=	SHAW}', "");
    Expect(0, 66687, '\P{Scx=	SHAW}', "");
    Expect(1, 66687, '\P{^Scx=	SHAW}', "");
    Expect(0, 66688, '\p{Scx=	SHAW}', "");
    Expect(1, 66688, '\p{^Scx=	SHAW}', "");
    Expect(1, 66688, '\P{Scx=	SHAW}', "");
    Expect(0, 66688, '\P{^Scx=	SHAW}', "");
    Error('\p{Is_Script_Extensions:		SHAVIAN/a/}');
    Error('\P{Is_Script_Extensions:		SHAVIAN/a/}');
    Expect(1, 66687, '\p{Is_Script_Extensions:	shavian}', "");
    Expect(0, 66687, '\p{^Is_Script_Extensions:	shavian}', "");
    Expect(0, 66687, '\P{Is_Script_Extensions:	shavian}', "");
    Expect(1, 66687, '\P{^Is_Script_Extensions:	shavian}', "");
    Expect(0, 66688, '\p{Is_Script_Extensions:	shavian}', "");
    Expect(1, 66688, '\p{^Is_Script_Extensions:	shavian}', "");
    Expect(1, 66688, '\P{Is_Script_Extensions:	shavian}', "");
    Expect(0, 66688, '\P{^Is_Script_Extensions:	shavian}', "");
    Expect(1, 66687, '\p{Is_Script_Extensions:	  SHAVIAN}', "");
    Expect(0, 66687, '\p{^Is_Script_Extensions:	  SHAVIAN}', "");
    Expect(0, 66687, '\P{Is_Script_Extensions:	  SHAVIAN}', "");
    Expect(1, 66687, '\P{^Is_Script_Extensions:	  SHAVIAN}', "");
    Expect(0, 66688, '\p{Is_Script_Extensions:	  SHAVIAN}', "");
    Expect(1, 66688, '\p{^Is_Script_Extensions:	  SHAVIAN}', "");
    Expect(1, 66688, '\P{Is_Script_Extensions:	  SHAVIAN}', "");
    Expect(0, 66688, '\P{^Is_Script_Extensions:	  SHAVIAN}', "");
    Error('\p{Is_Scx=-Shaw/a/}');
    Error('\P{Is_Scx=-Shaw/a/}');
    Expect(1, 66687, '\p{Is_Scx=shaw}', "");
    Expect(0, 66687, '\p{^Is_Scx=shaw}', "");
    Expect(0, 66687, '\P{Is_Scx=shaw}', "");
    Expect(1, 66687, '\P{^Is_Scx=shaw}', "");
    Expect(0, 66688, '\p{Is_Scx=shaw}', "");
    Expect(1, 66688, '\p{^Is_Scx=shaw}', "");
    Expect(1, 66688, '\P{Is_Scx=shaw}', "");
    Expect(0, 66688, '\P{^Is_Scx=shaw}', "");
    Expect(1, 66687, '\p{Is_Scx= _shaw}', "");
    Expect(0, 66687, '\p{^Is_Scx= _shaw}', "");
    Expect(0, 66687, '\P{Is_Scx= _shaw}', "");
    Expect(1, 66687, '\P{^Is_Scx= _shaw}', "");
    Expect(0, 66688, '\p{Is_Scx= _shaw}', "");
    Expect(1, 66688, '\p{^Is_Scx= _shaw}', "");
    Expect(1, 66688, '\P{Is_Scx= _shaw}', "");
    Expect(0, 66688, '\P{^Is_Scx= _shaw}', "");
    Error('\p{Script_Extensions=	 sharada/a/}');
    Error('\P{Script_Extensions=	 sharada/a/}');
    Expect(1, 70111, '\p{Script_Extensions=sharada}', "");
    Expect(0, 70111, '\p{^Script_Extensions=sharada}', "");
    Expect(0, 70111, '\P{Script_Extensions=sharada}', "");
    Expect(1, 70111, '\P{^Script_Extensions=sharada}', "");
    Expect(0, 70112, '\p{Script_Extensions=sharada}', "");
    Expect(1, 70112, '\p{^Script_Extensions=sharada}', "");
    Expect(1, 70112, '\P{Script_Extensions=sharada}', "");
    Expect(0, 70112, '\P{^Script_Extensions=sharada}', "");
    Expect(1, 70111, '\p{Script_Extensions=	SHARADA}', "");
    Expect(0, 70111, '\p{^Script_Extensions=	SHARADA}', "");
    Expect(0, 70111, '\P{Script_Extensions=	SHARADA}', "");
    Expect(1, 70111, '\P{^Script_Extensions=	SHARADA}', "");
    Expect(0, 70112, '\p{Script_Extensions=	SHARADA}', "");
    Expect(1, 70112, '\p{^Script_Extensions=	SHARADA}', "");
    Expect(1, 70112, '\P{Script_Extensions=	SHARADA}', "");
    Expect(0, 70112, '\P{^Script_Extensions=	SHARADA}', "");
    Error('\p{Scx=/a/-shrd}');
    Error('\P{Scx=/a/-shrd}');
    Expect(1, 70111, '\p{Scx=shrd}', "");
    Expect(0, 70111, '\p{^Scx=shrd}', "");
    Expect(0, 70111, '\P{Scx=shrd}', "");
    Expect(1, 70111, '\P{^Scx=shrd}', "");
    Expect(0, 70112, '\p{Scx=shrd}', "");
    Expect(1, 70112, '\p{^Scx=shrd}', "");
    Expect(1, 70112, '\P{Scx=shrd}', "");
    Expect(0, 70112, '\P{^Scx=shrd}', "");
    Expect(1, 70111, '\p{Scx= _Shrd}', "");
    Expect(0, 70111, '\p{^Scx= _Shrd}', "");
    Expect(0, 70111, '\P{Scx= _Shrd}', "");
    Expect(1, 70111, '\P{^Scx= _Shrd}', "");
    Expect(0, 70112, '\p{Scx= _Shrd}', "");
    Expect(1, 70112, '\p{^Scx= _Shrd}', "");
    Expect(1, 70112, '\P{Scx= _Shrd}', "");
    Expect(0, 70112, '\P{^Scx= _Shrd}', "");
    Error('\p{Is_Script_Extensions=/a/SHARADA}');
    Error('\P{Is_Script_Extensions=/a/SHARADA}');
    Expect(1, 70111, '\p{Is_Script_Extensions=sharada}', "");
    Expect(0, 70111, '\p{^Is_Script_Extensions=sharada}', "");
    Expect(0, 70111, '\P{Is_Script_Extensions=sharada}', "");
    Expect(1, 70111, '\P{^Is_Script_Extensions=sharada}', "");
    Expect(0, 70112, '\p{Is_Script_Extensions=sharada}', "");
    Expect(1, 70112, '\p{^Is_Script_Extensions=sharada}', "");
    Expect(1, 70112, '\P{Is_Script_Extensions=sharada}', "");
    Expect(0, 70112, '\P{^Is_Script_Extensions=sharada}', "");
    Expect(1, 70111, '\p{Is_Script_Extensions= Sharada}', "");
    Expect(0, 70111, '\p{^Is_Script_Extensions= Sharada}', "");
    Expect(0, 70111, '\P{Is_Script_Extensions= Sharada}', "");
    Expect(1, 70111, '\P{^Is_Script_Extensions= Sharada}', "");
    Expect(0, 70112, '\p{Is_Script_Extensions= Sharada}', "");
    Expect(1, 70112, '\p{^Is_Script_Extensions= Sharada}', "");
    Expect(1, 70112, '\P{Is_Script_Extensions= Sharada}', "");
    Expect(0, 70112, '\P{^Is_Script_Extensions= Sharada}', "");
    Error('\p{Is_Scx=_Shrd/a/}');
    Error('\P{Is_Scx=_Shrd/a/}');
    Expect(1, 70111, '\p{Is_Scx=shrd}', "");
    Expect(0, 70111, '\p{^Is_Scx=shrd}', "");
    Expect(0, 70111, '\P{Is_Scx=shrd}', "");
    Expect(1, 70111, '\P{^Is_Scx=shrd}', "");
    Expect(0, 70112, '\p{Is_Scx=shrd}', "");
    Expect(1, 70112, '\p{^Is_Scx=shrd}', "");
    Expect(1, 70112, '\P{Is_Scx=shrd}', "");
    Expect(0, 70112, '\P{^Is_Scx=shrd}', "");
    Expect(1, 70111, '\p{Is_Scx=	SHRD}', "");
    Expect(0, 70111, '\p{^Is_Scx=	SHRD}', "");
    Expect(0, 70111, '\P{Is_Scx=	SHRD}', "");
    Expect(1, 70111, '\P{^Is_Scx=	SHRD}', "");
    Expect(0, 70112, '\p{Is_Scx=	SHRD}', "");
    Expect(1, 70112, '\p{^Is_Scx=	SHRD}', "");
    Expect(1, 70112, '\P{Is_Scx=	SHRD}', "");
    Expect(0, 70112, '\P{^Is_Scx=	SHRD}', "");
    Error('\p{Script_Extensions=:=_siddham}');
    Error('\P{Script_Extensions=:=_siddham}');
    Expect(1, 71133, '\p{Script_Extensions:siddham}', "");
    Expect(0, 71133, '\p{^Script_Extensions:siddham}', "");
    Expect(0, 71133, '\P{Script_Extensions:siddham}', "");
    Expect(1, 71133, '\P{^Script_Extensions:siddham}', "");
    Expect(0, 71134, '\p{Script_Extensions:siddham}', "");
    Expect(1, 71134, '\p{^Script_Extensions:siddham}', "");
    Expect(1, 71134, '\P{Script_Extensions:siddham}', "");
    Expect(0, 71134, '\P{^Script_Extensions:siddham}', "");
    Expect(1, 71133, '\p{Script_Extensions=	SIDDHAM}', "");
    Expect(0, 71133, '\p{^Script_Extensions=	SIDDHAM}', "");
    Expect(0, 71133, '\P{Script_Extensions=	SIDDHAM}', "");
    Expect(1, 71133, '\P{^Script_Extensions=	SIDDHAM}', "");
    Expect(0, 71134, '\p{Script_Extensions=	SIDDHAM}', "");
    Expect(1, 71134, '\p{^Script_Extensions=	SIDDHAM}', "");
    Expect(1, 71134, '\P{Script_Extensions=	SIDDHAM}', "");
    Expect(0, 71134, '\P{^Script_Extensions=	SIDDHAM}', "");
    Error('\p{Scx:-sidd:=}');
    Error('\P{Scx:-sidd:=}');
    Expect(1, 71133, '\p{Scx=sidd}', "");
    Expect(0, 71133, '\p{^Scx=sidd}', "");
    Expect(0, 71133, '\P{Scx=sidd}', "");
    Expect(1, 71133, '\P{^Scx=sidd}', "");
    Expect(0, 71134, '\p{Scx=sidd}', "");
    Expect(1, 71134, '\p{^Scx=sidd}', "");
    Expect(1, 71134, '\P{Scx=sidd}', "");
    Expect(0, 71134, '\P{^Scx=sidd}', "");
    Expect(1, 71133, '\p{Scx=_ SIDD}', "");
    Expect(0, 71133, '\p{^Scx=_ SIDD}', "");
    Expect(0, 71133, '\P{Scx=_ SIDD}', "");
    Expect(1, 71133, '\P{^Scx=_ SIDD}', "");
    Expect(0, 71134, '\p{Scx=_ SIDD}', "");
    Expect(1, 71134, '\p{^Scx=_ SIDD}', "");
    Expect(1, 71134, '\P{Scx=_ SIDD}', "");
    Expect(0, 71134, '\P{^Scx=_ SIDD}', "");
    Error('\p{Is_Script_Extensions: -/a/Siddham}');
    Error('\P{Is_Script_Extensions: -/a/Siddham}');
    Expect(1, 71133, '\p{Is_Script_Extensions:	siddham}', "");
    Expect(0, 71133, '\p{^Is_Script_Extensions:	siddham}', "");
    Expect(0, 71133, '\P{Is_Script_Extensions:	siddham}', "");
    Expect(1, 71133, '\P{^Is_Script_Extensions:	siddham}', "");
    Expect(0, 71134, '\p{Is_Script_Extensions:	siddham}', "");
    Expect(1, 71134, '\p{^Is_Script_Extensions:	siddham}', "");
    Expect(1, 71134, '\P{Is_Script_Extensions:	siddham}', "");
    Expect(0, 71134, '\P{^Is_Script_Extensions:	siddham}', "");
    Expect(1, 71133, '\p{Is_Script_Extensions=		SIDDHAM}', "");
    Expect(0, 71133, '\p{^Is_Script_Extensions=		SIDDHAM}', "");
    Expect(0, 71133, '\P{Is_Script_Extensions=		SIDDHAM}', "");
    Expect(1, 71133, '\P{^Is_Script_Extensions=		SIDDHAM}', "");
    Expect(0, 71134, '\p{Is_Script_Extensions=		SIDDHAM}', "");
    Expect(1, 71134, '\p{^Is_Script_Extensions=		SIDDHAM}', "");
    Expect(1, 71134, '\P{Is_Script_Extensions=		SIDDHAM}', "");
    Expect(0, 71134, '\P{^Is_Script_Extensions=		SIDDHAM}', "");
    Error('\p{Is_Scx=	/a/Sidd}');
    Error('\P{Is_Scx=	/a/Sidd}');
    Expect(1, 71133, '\p{Is_Scx=sidd}', "");
    Expect(0, 71133, '\p{^Is_Scx=sidd}', "");
    Expect(0, 71133, '\P{Is_Scx=sidd}', "");
    Expect(1, 71133, '\P{^Is_Scx=sidd}', "");
    Expect(0, 71134, '\p{Is_Scx=sidd}', "");
    Expect(1, 71134, '\p{^Is_Scx=sidd}', "");
    Expect(1, 71134, '\P{Is_Scx=sidd}', "");
    Expect(0, 71134, '\P{^Is_Scx=sidd}', "");
    Expect(1, 71133, '\p{Is_Scx=_	Sidd}', "");
    Expect(0, 71133, '\p{^Is_Scx=_	Sidd}', "");
    Expect(0, 71133, '\P{Is_Scx=_	Sidd}', "");
    Expect(1, 71133, '\P{^Is_Scx=_	Sidd}', "");
    Expect(0, 71134, '\p{Is_Scx=_	Sidd}', "");
    Expect(1, 71134, '\p{^Is_Scx=_	Sidd}', "");
    Expect(1, 71134, '\P{Is_Scx=_	Sidd}', "");
    Expect(0, 71134, '\P{^Is_Scx=_	Sidd}', "");
    Error('\p{Script_Extensions=__Khudawadi/a/}');
    Error('\P{Script_Extensions=__Khudawadi/a/}');
    Expect(1, 70393, '\p{Script_Extensions=khudawadi}', "");
    Expect(0, 70393, '\p{^Script_Extensions=khudawadi}', "");
    Expect(0, 70393, '\P{Script_Extensions=khudawadi}', "");
    Expect(1, 70393, '\P{^Script_Extensions=khudawadi}', "");
    Expect(0, 70394, '\p{Script_Extensions=khudawadi}', "");
    Expect(1, 70394, '\p{^Script_Extensions=khudawadi}', "");
    Expect(1, 70394, '\P{Script_Extensions=khudawadi}', "");
    Expect(0, 70394, '\P{^Script_Extensions=khudawadi}', "");
    Expect(1, 70393, '\p{Script_Extensions=-_Khudawadi}', "");
    Expect(0, 70393, '\p{^Script_Extensions=-_Khudawadi}', "");
    Expect(0, 70393, '\P{Script_Extensions=-_Khudawadi}', "");
    Expect(1, 70393, '\P{^Script_Extensions=-_Khudawadi}', "");
    Expect(0, 70394, '\p{Script_Extensions=-_Khudawadi}', "");
    Expect(1, 70394, '\p{^Script_Extensions=-_Khudawadi}', "");
    Expect(1, 70394, '\P{Script_Extensions=-_Khudawadi}', "");
    Expect(0, 70394, '\P{^Script_Extensions=-_Khudawadi}', "");
    Error('\p{Scx=_/a/Sind}');
    Error('\P{Scx=_/a/Sind}');
    Expect(1, 70393, '\p{Scx=sind}', "");
    Expect(0, 70393, '\p{^Scx=sind}', "");
    Expect(0, 70393, '\P{Scx=sind}', "");
    Expect(1, 70393, '\P{^Scx=sind}', "");
    Expect(0, 70394, '\p{Scx=sind}', "");
    Expect(1, 70394, '\p{^Scx=sind}', "");
    Expect(1, 70394, '\P{Scx=sind}', "");
    Expect(0, 70394, '\P{^Scx=sind}', "");
    Expect(1, 70393, '\p{Scx=	sind}', "");
    Expect(0, 70393, '\p{^Scx=	sind}', "");
    Expect(0, 70393, '\P{Scx=	sind}', "");
    Expect(1, 70393, '\P{^Scx=	sind}', "");
    Expect(0, 70394, '\p{Scx=	sind}', "");
    Expect(1, 70394, '\p{^Scx=	sind}', "");
    Expect(1, 70394, '\P{Scx=	sind}', "");
    Expect(0, 70394, '\P{^Scx=	sind}', "");
    Error('\p{Is_Script_Extensions=- Khudawadi/a/}');
    Error('\P{Is_Script_Extensions=- Khudawadi/a/}');
    Expect(1, 70393, '\p{Is_Script_Extensions=khudawadi}', "");
    Expect(0, 70393, '\p{^Is_Script_Extensions=khudawadi}', "");
    Expect(0, 70393, '\P{Is_Script_Extensions=khudawadi}', "");
    Expect(1, 70393, '\P{^Is_Script_Extensions=khudawadi}', "");
    Expect(0, 70394, '\p{Is_Script_Extensions=khudawadi}', "");
    Expect(1, 70394, '\p{^Is_Script_Extensions=khudawadi}', "");
    Expect(1, 70394, '\P{Is_Script_Extensions=khudawadi}', "");
    Expect(0, 70394, '\P{^Is_Script_Extensions=khudawadi}', "");
    Expect(1, 70393, '\p{Is_Script_Extensions= -khudawadi}', "");
    Expect(0, 70393, '\p{^Is_Script_Extensions= -khudawadi}', "");
    Expect(0, 70393, '\P{Is_Script_Extensions= -khudawadi}', "");
    Expect(1, 70393, '\P{^Is_Script_Extensions= -khudawadi}', "");
    Expect(0, 70394, '\p{Is_Script_Extensions= -khudawadi}', "");
    Expect(1, 70394, '\p{^Is_Script_Extensions= -khudawadi}', "");
    Expect(1, 70394, '\P{Is_Script_Extensions= -khudawadi}', "");
    Expect(0, 70394, '\P{^Is_Script_Extensions= -khudawadi}', "");
    Error('\p{Is_Scx= 	sind:=}');
    Error('\P{Is_Scx= 	sind:=}');
    Expect(1, 70393, '\p{Is_Scx=sind}', "");
    Expect(0, 70393, '\p{^Is_Scx=sind}', "");
    Expect(0, 70393, '\P{Is_Scx=sind}', "");
    Expect(1, 70393, '\P{^Is_Scx=sind}', "");
    Expect(0, 70394, '\p{Is_Scx=sind}', "");
    Expect(1, 70394, '\p{^Is_Scx=sind}', "");
    Expect(1, 70394, '\P{Is_Scx=sind}', "");
    Expect(0, 70394, '\P{^Is_Scx=sind}', "");
    Expect(1, 70393, '\p{Is_Scx=	-Sind}', "");
    Expect(0, 70393, '\p{^Is_Scx=	-Sind}', "");
    Expect(0, 70393, '\P{Is_Scx=	-Sind}', "");
    Expect(1, 70393, '\P{^Is_Scx=	-Sind}', "");
    Expect(0, 70394, '\p{Is_Scx=	-Sind}', "");
    Expect(1, 70394, '\p{^Is_Scx=	-Sind}', "");
    Expect(1, 70394, '\P{Is_Scx=	-Sind}', "");
    Expect(0, 70394, '\P{^Is_Scx=	-Sind}', "");
    Error('\p{Script_Extensions=/a/	sinhala}');
    Error('\P{Script_Extensions=/a/	sinhala}');
    Expect(1, 70132, '\p{Script_Extensions=sinhala}', "");
    Expect(0, 70132, '\p{^Script_Extensions=sinhala}', "");
    Expect(0, 70132, '\P{Script_Extensions=sinhala}', "");
    Expect(1, 70132, '\P{^Script_Extensions=sinhala}', "");
    Expect(0, 70133, '\p{Script_Extensions=sinhala}', "");
    Expect(1, 70133, '\p{^Script_Extensions=sinhala}', "");
    Expect(1, 70133, '\P{Script_Extensions=sinhala}', "");
    Expect(0, 70133, '\P{^Script_Extensions=sinhala}', "");
    Expect(1, 70132, '\p{Script_Extensions=	sinhala}', "");
    Expect(0, 70132, '\p{^Script_Extensions=	sinhala}', "");
    Expect(0, 70132, '\P{Script_Extensions=	sinhala}', "");
    Expect(1, 70132, '\P{^Script_Extensions=	sinhala}', "");
    Expect(0, 70133, '\p{Script_Extensions=	sinhala}', "");
    Expect(1, 70133, '\p{^Script_Extensions=	sinhala}', "");
    Expect(1, 70133, '\P{Script_Extensions=	sinhala}', "");
    Expect(0, 70133, '\P{^Script_Extensions=	sinhala}', "");
    Error('\p{Scx= /a/sinh}');
    Error('\P{Scx= /a/sinh}');
    Expect(1, 70132, '\p{Scx=sinh}', "");
    Expect(0, 70132, '\p{^Scx=sinh}', "");
    Expect(0, 70132, '\P{Scx=sinh}', "");
    Expect(1, 70132, '\P{^Scx=sinh}', "");
    Expect(0, 70133, '\p{Scx=sinh}', "");
    Expect(1, 70133, '\p{^Scx=sinh}', "");
    Expect(1, 70133, '\P{Scx=sinh}', "");
    Expect(0, 70133, '\P{^Scx=sinh}', "");
    Expect(1, 70132, '\p{Scx=-	Sinh}', "");
    Expect(0, 70132, '\p{^Scx=-	Sinh}', "");
    Expect(0, 70132, '\P{Scx=-	Sinh}', "");
    Expect(1, 70132, '\P{^Scx=-	Sinh}', "");
    Expect(0, 70133, '\p{Scx=-	Sinh}', "");
    Expect(1, 70133, '\p{^Scx=-	Sinh}', "");
    Expect(1, 70133, '\P{Scx=-	Sinh}', "");
    Expect(0, 70133, '\P{^Scx=-	Sinh}', "");
    Error('\p{Is_Script_Extensions=/a/Sinhala}');
    Error('\P{Is_Script_Extensions=/a/Sinhala}');
    Expect(1, 70132, '\p{Is_Script_Extensions=sinhala}', "");
    Expect(0, 70132, '\p{^Is_Script_Extensions=sinhala}', "");
    Expect(0, 70132, '\P{Is_Script_Extensions=sinhala}', "");
    Expect(1, 70132, '\P{^Is_Script_Extensions=sinhala}', "");
    Expect(0, 70133, '\p{Is_Script_Extensions=sinhala}', "");
    Expect(1, 70133, '\p{^Is_Script_Extensions=sinhala}', "");
    Expect(1, 70133, '\P{Is_Script_Extensions=sinhala}', "");
    Expect(0, 70133, '\P{^Is_Script_Extensions=sinhala}', "");
    Expect(1, 70132, '\p{Is_Script_Extensions=	_Sinhala}', "");
    Expect(0, 70132, '\p{^Is_Script_Extensions=	_Sinhala}', "");
    Expect(0, 70132, '\P{Is_Script_Extensions=	_Sinhala}', "");
    Expect(1, 70132, '\P{^Is_Script_Extensions=	_Sinhala}', "");
    Expect(0, 70133, '\p{Is_Script_Extensions=	_Sinhala}', "");
    Expect(1, 70133, '\p{^Is_Script_Extensions=	_Sinhala}', "");
    Expect(1, 70133, '\P{Is_Script_Extensions=	_Sinhala}', "");
    Expect(0, 70133, '\P{^Is_Script_Extensions=	_Sinhala}', "");
    Error('\p{Is_Scx=:=	_Sinh}');
    Error('\P{Is_Scx=:=	_Sinh}');
    Expect(1, 70132, '\p{Is_Scx=sinh}', "");
    Expect(0, 70132, '\p{^Is_Scx=sinh}', "");
    Expect(0, 70132, '\P{Is_Scx=sinh}', "");
    Expect(1, 70132, '\P{^Is_Scx=sinh}', "");
    Expect(0, 70133, '\p{Is_Scx=sinh}', "");
    Expect(1, 70133, '\p{^Is_Scx=sinh}', "");
    Expect(1, 70133, '\P{Is_Scx=sinh}', "");
    Expect(0, 70133, '\P{^Is_Scx=sinh}', "");
    Expect(1, 70132, '\p{Is_Scx= _SINH}', "");
    Expect(0, 70132, '\p{^Is_Scx= _SINH}', "");
    Expect(0, 70132, '\P{Is_Scx= _SINH}', "");
    Expect(1, 70132, '\P{^Is_Scx= _SINH}', "");
    Expect(0, 70133, '\p{Is_Scx= _SINH}', "");
    Expect(1, 70133, '\p{^Is_Scx= _SINH}', "");
    Expect(1, 70133, '\P{Is_Scx= _SINH}', "");
    Expect(0, 70133, '\P{^Is_Scx= _SINH}', "");
    Error('\p{Script_Extensions:	:=-	Sora_Sompeng}');
    Error('\P{Script_Extensions:	:=-	Sora_Sompeng}');
    Expect(1, 69881, '\p{Script_Extensions=sorasompeng}', "");
    Expect(0, 69881, '\p{^Script_Extensions=sorasompeng}', "");
    Expect(0, 69881, '\P{Script_Extensions=sorasompeng}', "");
    Expect(1, 69881, '\P{^Script_Extensions=sorasompeng}', "");
    Expect(0, 69882, '\p{Script_Extensions=sorasompeng}', "");
    Expect(1, 69882, '\p{^Script_Extensions=sorasompeng}', "");
    Expect(1, 69882, '\P{Script_Extensions=sorasompeng}', "");
    Expect(0, 69882, '\P{^Script_Extensions=sorasompeng}', "");
    Expect(1, 69881, '\p{Script_Extensions=	 sora_Sompeng}', "");
    Expect(0, 69881, '\p{^Script_Extensions=	 sora_Sompeng}', "");
    Expect(0, 69881, '\P{Script_Extensions=	 sora_Sompeng}', "");
    Expect(1, 69881, '\P{^Script_Extensions=	 sora_Sompeng}', "");
    Expect(0, 69882, '\p{Script_Extensions=	 sora_Sompeng}', "");
    Expect(1, 69882, '\p{^Script_Extensions=	 sora_Sompeng}', "");
    Expect(1, 69882, '\P{Script_Extensions=	 sora_Sompeng}', "");
    Expect(0, 69882, '\P{^Script_Extensions=	 sora_Sompeng}', "");
    Error('\p{Scx=  sora:=}');
    Error('\P{Scx=  sora:=}');
    Expect(1, 69881, '\p{Scx=sora}', "");
    Expect(0, 69881, '\p{^Scx=sora}', "");
    Expect(0, 69881, '\P{Scx=sora}', "");
    Expect(1, 69881, '\P{^Scx=sora}', "");
    Expect(0, 69882, '\p{Scx=sora}', "");
    Expect(1, 69882, '\p{^Scx=sora}', "");
    Expect(1, 69882, '\P{Scx=sora}', "");
    Expect(0, 69882, '\P{^Scx=sora}', "");
    Expect(1, 69881, '\p{Scx=_Sora}', "");
    Expect(0, 69881, '\p{^Scx=_Sora}', "");
    Expect(0, 69881, '\P{Scx=_Sora}', "");
    Expect(1, 69881, '\P{^Scx=_Sora}', "");
    Expect(0, 69882, '\p{Scx=_Sora}', "");
    Expect(1, 69882, '\p{^Scx=_Sora}', "");
    Expect(1, 69882, '\P{Scx=_Sora}', "");
    Expect(0, 69882, '\P{^Scx=_Sora}', "");
    Error('\p{Is_Script_Extensions=	/a/sora_sompeng}');
    Error('\P{Is_Script_Extensions=	/a/sora_sompeng}');
    Expect(1, 69881, '\p{Is_Script_Extensions=sorasompeng}', "");
    Expect(0, 69881, '\p{^Is_Script_Extensions=sorasompeng}', "");
    Expect(0, 69881, '\P{Is_Script_Extensions=sorasompeng}', "");
    Expect(1, 69881, '\P{^Is_Script_Extensions=sorasompeng}', "");
    Expect(0, 69882, '\p{Is_Script_Extensions=sorasompeng}', "");
    Expect(1, 69882, '\p{^Is_Script_Extensions=sorasompeng}', "");
    Expect(1, 69882, '\P{Is_Script_Extensions=sorasompeng}', "");
    Expect(0, 69882, '\P{^Is_Script_Extensions=sorasompeng}', "");
    Expect(1, 69881, '\p{Is_Script_Extensions= _SORA_SOMPENG}', "");
    Expect(0, 69881, '\p{^Is_Script_Extensions= _SORA_SOMPENG}', "");
    Expect(0, 69881, '\P{Is_Script_Extensions= _SORA_SOMPENG}', "");
    Expect(1, 69881, '\P{^Is_Script_Extensions= _SORA_SOMPENG}', "");
    Expect(0, 69882, '\p{Is_Script_Extensions= _SORA_SOMPENG}', "");
    Expect(1, 69882, '\p{^Is_Script_Extensions= _SORA_SOMPENG}', "");
    Expect(1, 69882, '\P{Is_Script_Extensions= _SORA_SOMPENG}', "");
    Expect(0, 69882, '\P{^Is_Script_Extensions= _SORA_SOMPENG}', "");
    Error('\p{Is_Scx=_:=SORA}');
    Error('\P{Is_Scx=_:=SORA}');
    Expect(1, 69881, '\p{Is_Scx=sora}', "");
    Expect(0, 69881, '\p{^Is_Scx=sora}', "");
    Expect(0, 69881, '\P{Is_Scx=sora}', "");
    Expect(1, 69881, '\P{^Is_Scx=sora}', "");
    Expect(0, 69882, '\p{Is_Scx=sora}', "");
    Expect(1, 69882, '\p{^Is_Scx=sora}', "");
    Expect(1, 69882, '\P{Is_Scx=sora}', "");
    Expect(0, 69882, '\P{^Is_Scx=sora}', "");
    Expect(1, 69881, '\p{Is_Scx= -Sora}', "");
    Expect(0, 69881, '\p{^Is_Scx= -Sora}', "");
    Expect(0, 69881, '\P{Is_Scx= -Sora}', "");
    Expect(1, 69881, '\P{^Is_Scx= -Sora}', "");
    Expect(0, 69882, '\p{Is_Scx= -Sora}', "");
    Expect(1, 69882, '\p{^Is_Scx= -Sora}', "");
    Expect(1, 69882, '\P{Is_Scx= -Sora}', "");
    Expect(0, 69882, '\P{^Is_Scx= -Sora}', "");
    Error('\p{Script_Extensions=/a/soyombo}');
    Error('\P{Script_Extensions=/a/soyombo}');
    Expect(1, 72354, '\p{Script_Extensions: soyombo}', "");
    Expect(0, 72354, '\p{^Script_Extensions: soyombo}', "");
    Expect(0, 72354, '\P{Script_Extensions: soyombo}', "");
    Expect(1, 72354, '\P{^Script_Extensions: soyombo}', "");
    Expect(0, 72355, '\p{Script_Extensions: soyombo}', "");
    Expect(1, 72355, '\p{^Script_Extensions: soyombo}', "");
    Expect(1, 72355, '\P{Script_Extensions: soyombo}', "");
    Expect(0, 72355, '\P{^Script_Extensions: soyombo}', "");
    Expect(1, 72354, '\p{Script_Extensions=	 SOYOMBO}', "");
    Expect(0, 72354, '\p{^Script_Extensions=	 SOYOMBO}', "");
    Expect(0, 72354, '\P{Script_Extensions=	 SOYOMBO}', "");
    Expect(1, 72354, '\P{^Script_Extensions=	 SOYOMBO}', "");
    Expect(0, 72355, '\p{Script_Extensions=	 SOYOMBO}', "");
    Expect(1, 72355, '\p{^Script_Extensions=	 SOYOMBO}', "");
    Expect(1, 72355, '\P{Script_Extensions=	 SOYOMBO}', "");
    Expect(0, 72355, '\P{^Script_Extensions=	 SOYOMBO}', "");
    Error('\p{Scx:	 /a/SOYO}');
    Error('\P{Scx:	 /a/SOYO}');
    Expect(1, 72354, '\p{Scx=soyo}', "");
    Expect(0, 72354, '\p{^Scx=soyo}', "");
    Expect(0, 72354, '\P{Scx=soyo}', "");
    Expect(1, 72354, '\P{^Scx=soyo}', "");
    Expect(0, 72355, '\p{Scx=soyo}', "");
    Expect(1, 72355, '\p{^Scx=soyo}', "");
    Expect(1, 72355, '\P{Scx=soyo}', "");
    Expect(0, 72355, '\P{^Scx=soyo}', "");
    Expect(1, 72354, '\p{Scx=_soyo}', "");
    Expect(0, 72354, '\p{^Scx=_soyo}', "");
    Expect(0, 72354, '\P{Scx=_soyo}', "");
    Expect(1, 72354, '\P{^Scx=_soyo}', "");
    Expect(0, 72355, '\p{Scx=_soyo}', "");
    Expect(1, 72355, '\p{^Scx=_soyo}', "");
    Expect(1, 72355, '\P{Scx=_soyo}', "");
    Expect(0, 72355, '\P{^Scx=_soyo}', "");
    Error('\p{Is_Script_Extensions= /a/Soyombo}');
    Error('\P{Is_Script_Extensions= /a/Soyombo}');
    Expect(1, 72354, '\p{Is_Script_Extensions=soyombo}', "");
    Expect(0, 72354, '\p{^Is_Script_Extensions=soyombo}', "");
    Expect(0, 72354, '\P{Is_Script_Extensions=soyombo}', "");
    Expect(1, 72354, '\P{^Is_Script_Extensions=soyombo}', "");
    Expect(0, 72355, '\p{Is_Script_Extensions=soyombo}', "");
    Expect(1, 72355, '\p{^Is_Script_Extensions=soyombo}', "");
    Expect(1, 72355, '\P{Is_Script_Extensions=soyombo}', "");
    Expect(0, 72355, '\P{^Is_Script_Extensions=soyombo}', "");
    Expect(1, 72354, '\p{Is_Script_Extensions=	_Soyombo}', "");
    Expect(0, 72354, '\p{^Is_Script_Extensions=	_Soyombo}', "");
    Expect(0, 72354, '\P{Is_Script_Extensions=	_Soyombo}', "");
    Expect(1, 72354, '\P{^Is_Script_Extensions=	_Soyombo}', "");
    Expect(0, 72355, '\p{Is_Script_Extensions=	_Soyombo}', "");
    Expect(1, 72355, '\p{^Is_Script_Extensions=	_Soyombo}', "");
    Expect(1, 72355, '\P{Is_Script_Extensions=	_Soyombo}', "");
    Expect(0, 72355, '\P{^Is_Script_Extensions=	_Soyombo}', "");
    Error('\p{Is_Scx=Soyo:=}');
    Error('\P{Is_Scx=Soyo:=}');
    Expect(1, 72354, '\p{Is_Scx:soyo}', "");
    Expect(0, 72354, '\p{^Is_Scx:soyo}', "");
    Expect(0, 72354, '\P{Is_Scx:soyo}', "");
    Expect(1, 72354, '\P{^Is_Scx:soyo}', "");
    Expect(0, 72355, '\p{Is_Scx:soyo}', "");
    Expect(1, 72355, '\p{^Is_Scx:soyo}', "");
    Expect(1, 72355, '\P{Is_Scx:soyo}', "");
    Expect(0, 72355, '\P{^Is_Scx:soyo}', "");
    Expect(1, 72354, '\p{Is_Scx=_	soyo}', "");
    Expect(0, 72354, '\p{^Is_Scx=_	soyo}', "");
    Expect(0, 72354, '\P{Is_Scx=_	soyo}', "");
    Expect(1, 72354, '\P{^Is_Scx=_	soyo}', "");
    Expect(0, 72355, '\p{Is_Scx=_	soyo}', "");
    Expect(1, 72355, '\p{^Is_Scx=_	soyo}', "");
    Expect(1, 72355, '\P{Is_Scx=_	soyo}', "");
    Expect(0, 72355, '\P{^Is_Scx=_	soyo}', "");
    Error('\p{Script_Extensions=-Sundanese/a/}');
    Error('\P{Script_Extensions=-Sundanese/a/}');
    Expect(1, 7367, '\p{Script_Extensions=sundanese}', "");
    Expect(0, 7367, '\p{^Script_Extensions=sundanese}', "");
    Expect(0, 7367, '\P{Script_Extensions=sundanese}', "");
    Expect(1, 7367, '\P{^Script_Extensions=sundanese}', "");
    Expect(0, 7368, '\p{Script_Extensions=sundanese}', "");
    Expect(1, 7368, '\p{^Script_Extensions=sundanese}', "");
    Expect(1, 7368, '\P{Script_Extensions=sundanese}', "");
    Expect(0, 7368, '\P{^Script_Extensions=sundanese}', "");
    Expect(1, 7367, '\p{Script_Extensions=	-Sundanese}', "");
    Expect(0, 7367, '\p{^Script_Extensions=	-Sundanese}', "");
    Expect(0, 7367, '\P{Script_Extensions=	-Sundanese}', "");
    Expect(1, 7367, '\P{^Script_Extensions=	-Sundanese}', "");
    Expect(0, 7368, '\p{Script_Extensions=	-Sundanese}', "");
    Expect(1, 7368, '\p{^Script_Extensions=	-Sundanese}', "");
    Expect(1, 7368, '\P{Script_Extensions=	-Sundanese}', "");
    Expect(0, 7368, '\P{^Script_Extensions=	-Sundanese}', "");
    Error('\p{Scx= 	SUND/a/}');
    Error('\P{Scx= 	SUND/a/}');
    Expect(1, 7367, '\p{Scx=sund}', "");
    Expect(0, 7367, '\p{^Scx=sund}', "");
    Expect(0, 7367, '\P{Scx=sund}', "");
    Expect(1, 7367, '\P{^Scx=sund}', "");
    Expect(0, 7368, '\p{Scx=sund}', "");
    Expect(1, 7368, '\p{^Scx=sund}', "");
    Expect(1, 7368, '\P{Scx=sund}', "");
    Expect(0, 7368, '\P{^Scx=sund}', "");
    Expect(1, 7367, '\p{Scx:   	_Sund}', "");
    Expect(0, 7367, '\p{^Scx:   	_Sund}', "");
    Expect(0, 7367, '\P{Scx:   	_Sund}', "");
    Expect(1, 7367, '\P{^Scx:   	_Sund}', "");
    Expect(0, 7368, '\p{Scx:   	_Sund}', "");
    Expect(1, 7368, '\p{^Scx:   	_Sund}', "");
    Expect(1, 7368, '\P{Scx:   	_Sund}', "");
    Expect(0, 7368, '\P{^Scx:   	_Sund}', "");
    Error('\p{Is_Script_Extensions=	 sundanese:=}');
    Error('\P{Is_Script_Extensions=	 sundanese:=}');
    Expect(1, 7367, '\p{Is_Script_Extensions=sundanese}', "");
    Expect(0, 7367, '\p{^Is_Script_Extensions=sundanese}', "");
    Expect(0, 7367, '\P{Is_Script_Extensions=sundanese}', "");
    Expect(1, 7367, '\P{^Is_Script_Extensions=sundanese}', "");
    Expect(0, 7368, '\p{Is_Script_Extensions=sundanese}', "");
    Expect(1, 7368, '\p{^Is_Script_Extensions=sundanese}', "");
    Expect(1, 7368, '\P{Is_Script_Extensions=sundanese}', "");
    Expect(0, 7368, '\P{^Is_Script_Extensions=sundanese}', "");
    Expect(1, 7367, '\p{Is_Script_Extensions=	 Sundanese}', "");
    Expect(0, 7367, '\p{^Is_Script_Extensions=	 Sundanese}', "");
    Expect(0, 7367, '\P{Is_Script_Extensions=	 Sundanese}', "");
    Expect(1, 7367, '\P{^Is_Script_Extensions=	 Sundanese}', "");
    Expect(0, 7368, '\p{Is_Script_Extensions=	 Sundanese}', "");
    Expect(1, 7368, '\p{^Is_Script_Extensions=	 Sundanese}', "");
    Expect(1, 7368, '\P{Is_Script_Extensions=	 Sundanese}', "");
    Expect(0, 7368, '\P{^Is_Script_Extensions=	 Sundanese}', "");
    Error('\p{Is_Scx=/a/-SUND}');
    Error('\P{Is_Scx=/a/-SUND}');
    Expect(1, 7367, '\p{Is_Scx=sund}', "");
    Expect(0, 7367, '\p{^Is_Scx=sund}', "");
    Expect(0, 7367, '\P{Is_Scx=sund}', "");
    Expect(1, 7367, '\P{^Is_Scx=sund}', "");
    Expect(0, 7368, '\p{Is_Scx=sund}', "");
    Expect(1, 7368, '\p{^Is_Scx=sund}', "");
    Expect(1, 7368, '\P{Is_Scx=sund}', "");
    Expect(0, 7368, '\P{^Is_Scx=sund}', "");
    Expect(1, 7367, '\p{Is_Scx= SUND}', "");
    Expect(0, 7367, '\p{^Is_Scx= SUND}', "");
    Expect(0, 7367, '\P{Is_Scx= SUND}', "");
    Expect(1, 7367, '\P{^Is_Scx= SUND}', "");
    Expect(0, 7368, '\p{Is_Scx= SUND}', "");
    Expect(1, 7368, '\p{^Is_Scx= SUND}', "");
    Expect(1, 7368, '\P{Is_Scx= SUND}', "");
    Expect(0, 7368, '\P{^Is_Scx= SUND}', "");
    Error('\p{Script_Extensions=-:=SYLOTI_NAGRI}');
    Error('\P{Script_Extensions=-:=SYLOTI_NAGRI}');
    Expect(1, 43051, '\p{Script_Extensions=sylotinagri}', "");
    Expect(0, 43051, '\p{^Script_Extensions=sylotinagri}', "");
    Expect(0, 43051, '\P{Script_Extensions=sylotinagri}', "");
    Expect(1, 43051, '\P{^Script_Extensions=sylotinagri}', "");
    Expect(0, 43052, '\p{Script_Extensions=sylotinagri}', "");
    Expect(1, 43052, '\p{^Script_Extensions=sylotinagri}', "");
    Expect(1, 43052, '\P{Script_Extensions=sylotinagri}', "");
    Expect(0, 43052, '\P{^Script_Extensions=sylotinagri}', "");
    Expect(1, 43051, '\p{Script_Extensions=__SYLOTI_NAGRI}', "");
    Expect(0, 43051, '\p{^Script_Extensions=__SYLOTI_NAGRI}', "");
    Expect(0, 43051, '\P{Script_Extensions=__SYLOTI_NAGRI}', "");
    Expect(1, 43051, '\P{^Script_Extensions=__SYLOTI_NAGRI}', "");
    Expect(0, 43052, '\p{Script_Extensions=__SYLOTI_NAGRI}', "");
    Expect(1, 43052, '\p{^Script_Extensions=__SYLOTI_NAGRI}', "");
    Expect(1, 43052, '\P{Script_Extensions=__SYLOTI_NAGRI}', "");
    Expect(0, 43052, '\P{^Script_Extensions=__SYLOTI_NAGRI}', "");
    Error('\p{Scx=-	SYLO/a/}');
    Error('\P{Scx=-	SYLO/a/}');
    Expect(1, 43051, '\p{Scx=sylo}', "");
    Expect(0, 43051, '\p{^Scx=sylo}', "");
    Expect(0, 43051, '\P{Scx=sylo}', "");
    Expect(1, 43051, '\P{^Scx=sylo}', "");
    Expect(0, 43052, '\p{Scx=sylo}', "");
    Expect(1, 43052, '\p{^Scx=sylo}', "");
    Expect(1, 43052, '\P{Scx=sylo}', "");
    Expect(0, 43052, '\P{^Scx=sylo}', "");
    Expect(1, 43051, '\p{Scx= Sylo}', "");
    Expect(0, 43051, '\p{^Scx= Sylo}', "");
    Expect(0, 43051, '\P{Scx= Sylo}', "");
    Expect(1, 43051, '\P{^Scx= Sylo}', "");
    Expect(0, 43052, '\p{Scx= Sylo}', "");
    Expect(1, 43052, '\p{^Scx= Sylo}', "");
    Expect(1, 43052, '\P{Scx= Sylo}', "");
    Expect(0, 43052, '\P{^Scx= Sylo}', "");
    Error('\p{Is_Script_Extensions=-_Syloti_NAGRI:=}');
    Error('\P{Is_Script_Extensions=-_Syloti_NAGRI:=}');
    Expect(1, 43051, '\p{Is_Script_Extensions=sylotinagri}', "");
    Expect(0, 43051, '\p{^Is_Script_Extensions=sylotinagri}', "");
    Expect(0, 43051, '\P{Is_Script_Extensions=sylotinagri}', "");
    Expect(1, 43051, '\P{^Is_Script_Extensions=sylotinagri}', "");
    Expect(0, 43052, '\p{Is_Script_Extensions=sylotinagri}', "");
    Expect(1, 43052, '\p{^Is_Script_Extensions=sylotinagri}', "");
    Expect(1, 43052, '\P{Is_Script_Extensions=sylotinagri}', "");
    Expect(0, 43052, '\P{^Is_Script_Extensions=sylotinagri}', "");
    Expect(1, 43051, '\p{Is_Script_Extensions=_syloti_Nagri}', "");
    Expect(0, 43051, '\p{^Is_Script_Extensions=_syloti_Nagri}', "");
    Expect(0, 43051, '\P{Is_Script_Extensions=_syloti_Nagri}', "");
    Expect(1, 43051, '\P{^Is_Script_Extensions=_syloti_Nagri}', "");
    Expect(0, 43052, '\p{Is_Script_Extensions=_syloti_Nagri}', "");
    Expect(1, 43052, '\p{^Is_Script_Extensions=_syloti_Nagri}', "");
    Expect(1, 43052, '\P{Is_Script_Extensions=_syloti_Nagri}', "");
    Expect(0, 43052, '\P{^Is_Script_Extensions=_syloti_Nagri}', "");
    Error('\p{Is_Scx=	:=SYLO}');
    Error('\P{Is_Scx=	:=SYLO}');
    Expect(1, 43051, '\p{Is_Scx=sylo}', "");
    Expect(0, 43051, '\p{^Is_Scx=sylo}', "");
    Expect(0, 43051, '\P{Is_Scx=sylo}', "");
    Expect(1, 43051, '\P{^Is_Scx=sylo}', "");
    Expect(0, 43052, '\p{Is_Scx=sylo}', "");
    Expect(1, 43052, '\p{^Is_Scx=sylo}', "");
    Expect(1, 43052, '\P{Is_Scx=sylo}', "");
    Expect(0, 43052, '\P{^Is_Scx=sylo}', "");
    Expect(1, 43051, '\p{Is_Scx=-SYLO}', "");
    Expect(0, 43051, '\p{^Is_Scx=-SYLO}', "");
    Expect(0, 43051, '\P{Is_Scx=-SYLO}', "");
    Expect(1, 43051, '\P{^Is_Scx=-SYLO}', "");
    Expect(0, 43052, '\p{Is_Scx=-SYLO}', "");
    Expect(1, 43052, '\p{^Is_Scx=-SYLO}', "");
    Expect(1, 43052, '\P{Is_Scx=-SYLO}', "");
    Expect(0, 43052, '\P{^Is_Scx=-SYLO}', "");
    Error('\p{Script_Extensions=_	Syriac/a/}');
    Error('\P{Script_Extensions=_	Syriac/a/}');
    Expect(1, 2154, '\p{Script_Extensions=syriac}', "");
    Expect(0, 2154, '\p{^Script_Extensions=syriac}', "");
    Expect(0, 2154, '\P{Script_Extensions=syriac}', "");
    Expect(1, 2154, '\P{^Script_Extensions=syriac}', "");
    Expect(0, 2155, '\p{Script_Extensions=syriac}', "");
    Expect(1, 2155, '\p{^Script_Extensions=syriac}', "");
    Expect(1, 2155, '\P{Script_Extensions=syriac}', "");
    Expect(0, 2155, '\P{^Script_Extensions=syriac}', "");
    Expect(1, 2154, '\p{Script_Extensions=-SYRIAC}', "");
    Expect(0, 2154, '\p{^Script_Extensions=-SYRIAC}', "");
    Expect(0, 2154, '\P{Script_Extensions=-SYRIAC}', "");
    Expect(1, 2154, '\P{^Script_Extensions=-SYRIAC}', "");
    Expect(0, 2155, '\p{Script_Extensions=-SYRIAC}', "");
    Expect(1, 2155, '\p{^Script_Extensions=-SYRIAC}', "");
    Expect(1, 2155, '\P{Script_Extensions=-SYRIAC}', "");
    Expect(0, 2155, '\P{^Script_Extensions=-SYRIAC}', "");
    Error('\p{Scx=	:=Syrc}');
    Error('\P{Scx=	:=Syrc}');
    Expect(1, 2154, '\p{Scx:	syrc}', "");
    Expect(0, 2154, '\p{^Scx:	syrc}', "");
    Expect(0, 2154, '\P{Scx:	syrc}', "");
    Expect(1, 2154, '\P{^Scx:	syrc}', "");
    Expect(0, 2155, '\p{Scx:	syrc}', "");
    Expect(1, 2155, '\p{^Scx:	syrc}', "");
    Expect(1, 2155, '\P{Scx:	syrc}', "");
    Expect(0, 2155, '\P{^Scx:	syrc}', "");
    Expect(1, 2154, '\p{Scx=-SYRC}', "");
    Expect(0, 2154, '\p{^Scx=-SYRC}', "");
    Expect(0, 2154, '\P{Scx=-SYRC}', "");
    Expect(1, 2154, '\P{^Scx=-SYRC}', "");
    Expect(0, 2155, '\p{Scx=-SYRC}', "");
    Expect(1, 2155, '\p{^Scx=-SYRC}', "");
    Expect(1, 2155, '\P{Scx=-SYRC}', "");
    Expect(0, 2155, '\P{^Scx=-SYRC}', "");
    Error('\p{Is_Script_Extensions=-/a/syriac}');
    Error('\P{Is_Script_Extensions=-/a/syriac}');
    Expect(1, 2154, '\p{Is_Script_Extensions=syriac}', "");
    Expect(0, 2154, '\p{^Is_Script_Extensions=syriac}', "");
    Expect(0, 2154, '\P{Is_Script_Extensions=syriac}', "");
    Expect(1, 2154, '\P{^Is_Script_Extensions=syriac}', "");
    Expect(0, 2155, '\p{Is_Script_Extensions=syriac}', "");
    Expect(1, 2155, '\p{^Is_Script_Extensions=syriac}', "");
    Expect(1, 2155, '\P{Is_Script_Extensions=syriac}', "");
    Expect(0, 2155, '\P{^Is_Script_Extensions=syriac}', "");
    Expect(1, 2154, '\p{Is_Script_Extensions= -Syriac}', "");
    Expect(0, 2154, '\p{^Is_Script_Extensions= -Syriac}', "");
    Expect(0, 2154, '\P{Is_Script_Extensions= -Syriac}', "");
    Expect(1, 2154, '\P{^Is_Script_Extensions= -Syriac}', "");
    Expect(0, 2155, '\p{Is_Script_Extensions= -Syriac}', "");
    Expect(1, 2155, '\p{^Is_Script_Extensions= -Syriac}', "");
    Expect(1, 2155, '\P{Is_Script_Extensions= -Syriac}', "");
    Expect(0, 2155, '\P{^Is_Script_Extensions= -Syriac}', "");
    Error('\p{Is_Scx=/a/syrc}');
    Error('\P{Is_Scx=/a/syrc}');
    Expect(1, 2154, '\p{Is_Scx=syrc}', "");
    Expect(0, 2154, '\p{^Is_Scx=syrc}', "");
    Expect(0, 2154, '\P{Is_Scx=syrc}', "");
    Expect(1, 2154, '\P{^Is_Scx=syrc}', "");
    Expect(0, 2155, '\p{Is_Scx=syrc}', "");
    Expect(1, 2155, '\p{^Is_Scx=syrc}', "");
    Expect(1, 2155, '\P{Is_Scx=syrc}', "");
    Expect(0, 2155, '\P{^Is_Scx=syrc}', "");
    Expect(1, 2154, '\p{Is_Scx:--syrc}', "");
    Expect(0, 2154, '\p{^Is_Scx:--syrc}', "");
    Expect(0, 2154, '\P{Is_Scx:--syrc}', "");
    Expect(1, 2154, '\P{^Is_Scx:--syrc}', "");
    Expect(0, 2155, '\p{Is_Scx:--syrc}', "");
    Expect(1, 2155, '\p{^Is_Scx:--syrc}', "");
    Expect(1, 2155, '\P{Is_Scx:--syrc}', "");
    Expect(0, 2155, '\P{^Is_Scx:--syrc}', "");
    Error('\p{Script_Extensions=/a/ TAGBANWA}');
    Error('\P{Script_Extensions=/a/ TAGBANWA}');
    Expect(1, 6003, '\p{Script_Extensions=tagbanwa}', "");
    Expect(0, 6003, '\p{^Script_Extensions=tagbanwa}', "");
    Expect(0, 6003, '\P{Script_Extensions=tagbanwa}', "");
    Expect(1, 6003, '\P{^Script_Extensions=tagbanwa}', "");
    Expect(0, 6004, '\p{Script_Extensions=tagbanwa}', "");
    Expect(1, 6004, '\p{^Script_Extensions=tagbanwa}', "");
    Expect(1, 6004, '\P{Script_Extensions=tagbanwa}', "");
    Expect(0, 6004, '\P{^Script_Extensions=tagbanwa}', "");
    Expect(1, 6003, '\p{Script_Extensions= -TAGBANWA}', "");
    Expect(0, 6003, '\p{^Script_Extensions= -TAGBANWA}', "");
    Expect(0, 6003, '\P{Script_Extensions= -TAGBANWA}', "");
    Expect(1, 6003, '\P{^Script_Extensions= -TAGBANWA}', "");
    Expect(0, 6004, '\p{Script_Extensions= -TAGBANWA}', "");
    Expect(1, 6004, '\p{^Script_Extensions= -TAGBANWA}', "");
    Expect(1, 6004, '\P{Script_Extensions= -TAGBANWA}', "");
    Expect(0, 6004, '\P{^Script_Extensions= -TAGBANWA}', "");
    Error('\p{Scx=:= _tagb}');
    Error('\P{Scx=:= _tagb}');
    Expect(1, 6003, '\p{Scx=tagb}', "");
    Expect(0, 6003, '\p{^Scx=tagb}', "");
    Expect(0, 6003, '\P{Scx=tagb}', "");
    Expect(1, 6003, '\P{^Scx=tagb}', "");
    Expect(0, 6004, '\p{Scx=tagb}', "");
    Expect(1, 6004, '\p{^Scx=tagb}', "");
    Expect(1, 6004, '\P{Scx=tagb}', "");
    Expect(0, 6004, '\P{^Scx=tagb}', "");
    Expect(1, 6003, '\p{Scx=_-Tagb}', "");
    Expect(0, 6003, '\p{^Scx=_-Tagb}', "");
    Expect(0, 6003, '\P{Scx=_-Tagb}', "");
    Expect(1, 6003, '\P{^Scx=_-Tagb}', "");
    Expect(0, 6004, '\p{Scx=_-Tagb}', "");
    Expect(1, 6004, '\p{^Scx=_-Tagb}', "");
    Expect(1, 6004, '\P{Scx=_-Tagb}', "");
    Expect(0, 6004, '\P{^Scx=_-Tagb}', "");
    Error('\p{Is_Script_Extensions=-:=TAGBANWA}');
    Error('\P{Is_Script_Extensions=-:=TAGBANWA}');
    Expect(1, 6003, '\p{Is_Script_Extensions=tagbanwa}', "");
    Expect(0, 6003, '\p{^Is_Script_Extensions=tagbanwa}', "");
    Expect(0, 6003, '\P{Is_Script_Extensions=tagbanwa}', "");
    Expect(1, 6003, '\P{^Is_Script_Extensions=tagbanwa}', "");
    Expect(0, 6004, '\p{Is_Script_Extensions=tagbanwa}', "");
    Expect(1, 6004, '\p{^Is_Script_Extensions=tagbanwa}', "");
    Expect(1, 6004, '\P{Is_Script_Extensions=tagbanwa}', "");
    Expect(0, 6004, '\P{^Is_Script_Extensions=tagbanwa}', "");
    Expect(1, 6003, '\p{Is_Script_Extensions:	_-Tagbanwa}', "");
    Expect(0, 6003, '\p{^Is_Script_Extensions:	_-Tagbanwa}', "");
    Expect(0, 6003, '\P{Is_Script_Extensions:	_-Tagbanwa}', "");
    Expect(1, 6003, '\P{^Is_Script_Extensions:	_-Tagbanwa}', "");
    Expect(0, 6004, '\p{Is_Script_Extensions:	_-Tagbanwa}', "");
    Expect(1, 6004, '\p{^Is_Script_Extensions:	_-Tagbanwa}', "");
    Expect(1, 6004, '\P{Is_Script_Extensions:	_-Tagbanwa}', "");
    Expect(0, 6004, '\P{^Is_Script_Extensions:	_-Tagbanwa}', "");
    Error('\p{Is_Scx= Tagb/a/}');
    Error('\P{Is_Scx= Tagb/a/}');
    Expect(1, 6003, '\p{Is_Scx=tagb}', "");
    Expect(0, 6003, '\p{^Is_Scx=tagb}', "");
    Expect(0, 6003, '\P{Is_Scx=tagb}', "");
    Expect(1, 6003, '\P{^Is_Scx=tagb}', "");
    Expect(0, 6004, '\p{Is_Scx=tagb}', "");
    Expect(1, 6004, '\p{^Is_Scx=tagb}', "");
    Expect(1, 6004, '\P{Is_Scx=tagb}', "");
    Expect(0, 6004, '\P{^Is_Scx=tagb}', "");
    Expect(1, 6003, '\p{Is_Scx=-tagb}', "");
    Expect(0, 6003, '\p{^Is_Scx=-tagb}', "");
    Expect(0, 6003, '\P{Is_Scx=-tagb}', "");
    Expect(1, 6003, '\P{^Is_Scx=-tagb}', "");
    Expect(0, 6004, '\p{Is_Scx=-tagb}', "");
    Expect(1, 6004, '\p{^Is_Scx=-tagb}', "");
    Expect(1, 6004, '\P{Is_Scx=-tagb}', "");
    Expect(0, 6004, '\P{^Is_Scx=-tagb}', "");
    Error('\p{Script_Extensions= _TAKRI:=}');
    Error('\P{Script_Extensions= _TAKRI:=}');
    Expect(1, 71369, '\p{Script_Extensions=takri}', "");
    Expect(0, 71369, '\p{^Script_Extensions=takri}', "");
    Expect(0, 71369, '\P{Script_Extensions=takri}', "");
    Expect(1, 71369, '\P{^Script_Extensions=takri}', "");
    Expect(0, 71370, '\p{Script_Extensions=takri}', "");
    Expect(1, 71370, '\p{^Script_Extensions=takri}', "");
    Expect(1, 71370, '\P{Script_Extensions=takri}', "");
    Expect(0, 71370, '\P{^Script_Extensions=takri}', "");
    Expect(1, 71369, '\p{Script_Extensions:    	takri}', "");
    Expect(0, 71369, '\p{^Script_Extensions:    	takri}', "");
    Expect(0, 71369, '\P{Script_Extensions:    	takri}', "");
    Expect(1, 71369, '\P{^Script_Extensions:    	takri}', "");
    Expect(0, 71370, '\p{Script_Extensions:    	takri}', "");
    Expect(1, 71370, '\p{^Script_Extensions:    	takri}', "");
    Expect(1, 71370, '\P{Script_Extensions:    	takri}', "");
    Expect(0, 71370, '\P{^Script_Extensions:    	takri}', "");
    Error('\p{Scx=:=-TAKR}');
    Error('\P{Scx=:=-TAKR}');
    Expect(1, 71369, '\p{Scx=takr}', "");
    Expect(0, 71369, '\p{^Scx=takr}', "");
    Expect(0, 71369, '\P{Scx=takr}', "");
    Expect(1, 71369, '\P{^Scx=takr}', "");
    Expect(0, 71370, '\p{Scx=takr}', "");
    Expect(1, 71370, '\p{^Scx=takr}', "");
    Expect(1, 71370, '\P{Scx=takr}', "");
    Expect(0, 71370, '\P{^Scx=takr}', "");
    Expect(1, 71369, '\p{Scx=	_Takr}', "");
    Expect(0, 71369, '\p{^Scx=	_Takr}', "");
    Expect(0, 71369, '\P{Scx=	_Takr}', "");
    Expect(1, 71369, '\P{^Scx=	_Takr}', "");
    Expect(0, 71370, '\p{Scx=	_Takr}', "");
    Expect(1, 71370, '\p{^Scx=	_Takr}', "");
    Expect(1, 71370, '\P{Scx=	_Takr}', "");
    Expect(0, 71370, '\P{^Scx=	_Takr}', "");
    Error('\p{Is_Script_Extensions=_:=Takri}');
    Error('\P{Is_Script_Extensions=_:=Takri}');
    Expect(1, 71369, '\p{Is_Script_Extensions=takri}', "");
    Expect(0, 71369, '\p{^Is_Script_Extensions=takri}', "");
    Expect(0, 71369, '\P{Is_Script_Extensions=takri}', "");
    Expect(1, 71369, '\P{^Is_Script_Extensions=takri}', "");
    Expect(0, 71370, '\p{Is_Script_Extensions=takri}', "");
    Expect(1, 71370, '\p{^Is_Script_Extensions=takri}', "");
    Expect(1, 71370, '\P{Is_Script_Extensions=takri}', "");
    Expect(0, 71370, '\P{^Is_Script_Extensions=takri}', "");
    Expect(1, 71369, '\p{Is_Script_Extensions= _Takri}', "");
    Expect(0, 71369, '\p{^Is_Script_Extensions= _Takri}', "");
    Expect(0, 71369, '\P{Is_Script_Extensions= _Takri}', "");
    Expect(1, 71369, '\P{^Is_Script_Extensions= _Takri}', "");
    Expect(0, 71370, '\p{Is_Script_Extensions= _Takri}', "");
    Expect(1, 71370, '\p{^Is_Script_Extensions= _Takri}', "");
    Expect(1, 71370, '\P{Is_Script_Extensions= _Takri}', "");
    Expect(0, 71370, '\P{^Is_Script_Extensions= _Takri}', "");
    Error('\p{Is_Scx=-takr:=}');
    Error('\P{Is_Scx=-takr:=}');
    Expect(1, 71369, '\p{Is_Scx=takr}', "");
    Expect(0, 71369, '\p{^Is_Scx=takr}', "");
    Expect(0, 71369, '\P{Is_Scx=takr}', "");
    Expect(1, 71369, '\P{^Is_Scx=takr}', "");
    Expect(0, 71370, '\p{Is_Scx=takr}', "");
    Expect(1, 71370, '\p{^Is_Scx=takr}', "");
    Expect(1, 71370, '\P{Is_Scx=takr}', "");
    Expect(0, 71370, '\P{^Is_Scx=takr}', "");
    Expect(1, 71369, '\p{Is_Scx=	Takr}', "");
    Expect(0, 71369, '\p{^Is_Scx=	Takr}', "");
    Expect(0, 71369, '\P{Is_Scx=	Takr}', "");
    Expect(1, 71369, '\P{^Is_Scx=	Takr}', "");
    Expect(0, 71370, '\p{Is_Scx=	Takr}', "");
    Expect(1, 71370, '\p{^Is_Scx=	Takr}', "");
    Expect(1, 71370, '\P{Is_Scx=	Takr}', "");
    Expect(0, 71370, '\P{^Is_Scx=	Takr}', "");
    Error('\p{Script_Extensions=:=	 TAI_le}');
    Error('\P{Script_Extensions=:=	 TAI_le}');
    Expect(1, 6516, '\p{Script_Extensions=taile}', "");
    Expect(0, 6516, '\p{^Script_Extensions=taile}', "");
    Expect(0, 6516, '\P{Script_Extensions=taile}', "");
    Expect(1, 6516, '\P{^Script_Extensions=taile}', "");
    Expect(0, 6517, '\p{Script_Extensions=taile}', "");
    Expect(1, 6517, '\p{^Script_Extensions=taile}', "");
    Expect(1, 6517, '\P{Script_Extensions=taile}', "");
    Expect(0, 6517, '\P{^Script_Extensions=taile}', "");
    Expect(1, 6516, '\p{Script_Extensions=_ Tai_Le}', "");
    Expect(0, 6516, '\p{^Script_Extensions=_ Tai_Le}', "");
    Expect(0, 6516, '\P{Script_Extensions=_ Tai_Le}', "");
    Expect(1, 6516, '\P{^Script_Extensions=_ Tai_Le}', "");
    Expect(0, 6517, '\p{Script_Extensions=_ Tai_Le}', "");
    Expect(1, 6517, '\p{^Script_Extensions=_ Tai_Le}', "");
    Expect(1, 6517, '\P{Script_Extensions=_ Tai_Le}', "");
    Expect(0, 6517, '\P{^Script_Extensions=_ Tai_Le}', "");
    Error('\p{Scx=_Tale:=}');
    Error('\P{Scx=_Tale:=}');
    Expect(1, 6516, '\p{Scx=tale}', "");
    Expect(0, 6516, '\p{^Scx=tale}', "");
    Expect(0, 6516, '\P{Scx=tale}', "");
    Expect(1, 6516, '\P{^Scx=tale}', "");
    Expect(0, 6517, '\p{Scx=tale}', "");
    Expect(1, 6517, '\p{^Scx=tale}', "");
    Expect(1, 6517, '\P{Scx=tale}', "");
    Expect(0, 6517, '\P{^Scx=tale}', "");
    Expect(1, 6516, '\p{Scx=--Tale}', "");
    Expect(0, 6516, '\p{^Scx=--Tale}', "");
    Expect(0, 6516, '\P{Scx=--Tale}', "");
    Expect(1, 6516, '\P{^Scx=--Tale}', "");
    Expect(0, 6517, '\p{Scx=--Tale}', "");
    Expect(1, 6517, '\p{^Scx=--Tale}', "");
    Expect(1, 6517, '\P{Scx=--Tale}', "");
    Expect(0, 6517, '\P{^Scx=--Tale}', "");
    Error('\p{Is_Script_Extensions=/a/_-Tai_LE}');
    Error('\P{Is_Script_Extensions=/a/_-Tai_LE}');
    Expect(1, 6516, '\p{Is_Script_Extensions:	taile}', "");
    Expect(0, 6516, '\p{^Is_Script_Extensions:	taile}', "");
    Expect(0, 6516, '\P{Is_Script_Extensions:	taile}', "");
    Expect(1, 6516, '\P{^Is_Script_Extensions:	taile}', "");
    Expect(0, 6517, '\p{Is_Script_Extensions:	taile}', "");
    Expect(1, 6517, '\p{^Is_Script_Extensions:	taile}', "");
    Expect(1, 6517, '\P{Is_Script_Extensions:	taile}', "");
    Expect(0, 6517, '\P{^Is_Script_Extensions:	taile}', "");
    Expect(1, 6516, '\p{Is_Script_Extensions=-	Tai_LE}', "");
    Expect(0, 6516, '\p{^Is_Script_Extensions=-	Tai_LE}', "");
    Expect(0, 6516, '\P{Is_Script_Extensions=-	Tai_LE}', "");
    Expect(1, 6516, '\P{^Is_Script_Extensions=-	Tai_LE}', "");
    Expect(0, 6517, '\p{Is_Script_Extensions=-	Tai_LE}', "");
    Expect(1, 6517, '\p{^Is_Script_Extensions=-	Tai_LE}', "");
    Expect(1, 6517, '\P{Is_Script_Extensions=-	Tai_LE}', "");
    Expect(0, 6517, '\P{^Is_Script_Extensions=-	Tai_LE}', "");
    Error('\p{Is_Scx=	:=TALE}');
    Error('\P{Is_Scx=	:=TALE}');
    Expect(1, 6516, '\p{Is_Scx=tale}', "");
    Expect(0, 6516, '\p{^Is_Scx=tale}', "");
    Expect(0, 6516, '\P{Is_Scx=tale}', "");
    Expect(1, 6516, '\P{^Is_Scx=tale}', "");
    Expect(0, 6517, '\p{Is_Scx=tale}', "");
    Expect(1, 6517, '\p{^Is_Scx=tale}', "");
    Expect(1, 6517, '\P{Is_Scx=tale}', "");
    Expect(0, 6517, '\P{^Is_Scx=tale}', "");
    Expect(1, 6516, '\p{Is_Scx: 	tale}', "");
    Expect(0, 6516, '\p{^Is_Scx: 	tale}', "");
    Expect(0, 6516, '\P{Is_Scx: 	tale}', "");
    Expect(1, 6516, '\P{^Is_Scx: 	tale}', "");
    Expect(0, 6517, '\p{Is_Scx: 	tale}', "");
    Expect(1, 6517, '\p{^Is_Scx: 	tale}', "");
    Expect(1, 6517, '\P{Is_Scx: 	tale}', "");
    Expect(0, 6517, '\P{^Is_Scx: 	tale}', "");
    Error('\p{Script_Extensions:		_NEW_Tai_lue/a/}');
    Error('\P{Script_Extensions:		_NEW_Tai_lue/a/}');
    Expect(1, 6623, '\p{Script_Extensions=newtailue}', "");
    Expect(0, 6623, '\p{^Script_Extensions=newtailue}', "");
    Expect(0, 6623, '\P{Script_Extensions=newtailue}', "");
    Expect(1, 6623, '\P{^Script_Extensions=newtailue}', "");
    Expect(0, 6624, '\p{Script_Extensions=newtailue}', "");
    Expect(1, 6624, '\p{^Script_Extensions=newtailue}', "");
    Expect(1, 6624, '\P{Script_Extensions=newtailue}', "");
    Expect(0, 6624, '\P{^Script_Extensions=newtailue}', "");
    Expect(1, 6623, '\p{Script_Extensions=  New_Tai_Lue}', "");
    Expect(0, 6623, '\p{^Script_Extensions=  New_Tai_Lue}', "");
    Expect(0, 6623, '\P{Script_Extensions=  New_Tai_Lue}', "");
    Expect(1, 6623, '\P{^Script_Extensions=  New_Tai_Lue}', "");
    Expect(0, 6624, '\p{Script_Extensions=  New_Tai_Lue}', "");
    Expect(1, 6624, '\p{^Script_Extensions=  New_Tai_Lue}', "");
    Expect(1, 6624, '\P{Script_Extensions=  New_Tai_Lue}', "");
    Expect(0, 6624, '\P{^Script_Extensions=  New_Tai_Lue}', "");
    Error('\p{Scx= /a/talu}');
    Error('\P{Scx= /a/talu}');
    Expect(1, 6623, '\p{Scx=talu}', "");
    Expect(0, 6623, '\p{^Scx=talu}', "");
    Expect(0, 6623, '\P{Scx=talu}', "");
    Expect(1, 6623, '\P{^Scx=talu}', "");
    Expect(0, 6624, '\p{Scx=talu}', "");
    Expect(1, 6624, '\p{^Scx=talu}', "");
    Expect(1, 6624, '\P{Scx=talu}', "");
    Expect(0, 6624, '\P{^Scx=talu}', "");
    Expect(1, 6623, '\p{Scx=	_TALU}', "");
    Expect(0, 6623, '\p{^Scx=	_TALU}', "");
    Expect(0, 6623, '\P{Scx=	_TALU}', "");
    Expect(1, 6623, '\P{^Scx=	_TALU}', "");
    Expect(0, 6624, '\p{Scx=	_TALU}', "");
    Expect(1, 6624, '\p{^Scx=	_TALU}', "");
    Expect(1, 6624, '\P{Scx=	_TALU}', "");
    Expect(0, 6624, '\P{^Scx=	_TALU}', "");
    Error('\p{Is_Script_Extensions= -NEW_Tai_LUE/a/}');
    Error('\P{Is_Script_Extensions= -NEW_Tai_LUE/a/}');
    Expect(1, 6623, '\p{Is_Script_Extensions=newtailue}', "");
    Expect(0, 6623, '\p{^Is_Script_Extensions=newtailue}', "");
    Expect(0, 6623, '\P{Is_Script_Extensions=newtailue}', "");
    Expect(1, 6623, '\P{^Is_Script_Extensions=newtailue}', "");
    Expect(0, 6624, '\p{Is_Script_Extensions=newtailue}', "");
    Expect(1, 6624, '\p{^Is_Script_Extensions=newtailue}', "");
    Expect(1, 6624, '\P{Is_Script_Extensions=newtailue}', "");
    Expect(0, 6624, '\P{^Is_Script_Extensions=newtailue}', "");
    Expect(1, 6623, '\p{Is_Script_Extensions=__New_Tai_Lue}', "");
    Expect(0, 6623, '\p{^Is_Script_Extensions=__New_Tai_Lue}', "");
    Expect(0, 6623, '\P{Is_Script_Extensions=__New_Tai_Lue}', "");
    Expect(1, 6623, '\P{^Is_Script_Extensions=__New_Tai_Lue}', "");
    Expect(0, 6624, '\p{Is_Script_Extensions=__New_Tai_Lue}', "");
    Expect(1, 6624, '\p{^Is_Script_Extensions=__New_Tai_Lue}', "");
    Expect(1, 6624, '\P{Is_Script_Extensions=__New_Tai_Lue}', "");
    Expect(0, 6624, '\P{^Is_Script_Extensions=__New_Tai_Lue}', "");
    Error('\p{Is_Scx=:=_Talu}');
    Error('\P{Is_Scx=:=_Talu}');
    Expect(1, 6623, '\p{Is_Scx=talu}', "");
    Expect(0, 6623, '\p{^Is_Scx=talu}', "");
    Expect(0, 6623, '\P{Is_Scx=talu}', "");
    Expect(1, 6623, '\P{^Is_Scx=talu}', "");
    Expect(0, 6624, '\p{Is_Scx=talu}', "");
    Expect(1, 6624, '\p{^Is_Scx=talu}', "");
    Expect(1, 6624, '\P{Is_Scx=talu}', "");
    Expect(0, 6624, '\P{^Is_Scx=talu}', "");
    Expect(1, 6623, '\p{Is_Scx=_TALU}', "");
    Expect(0, 6623, '\p{^Is_Scx=_TALU}', "");
    Expect(0, 6623, '\P{Is_Scx=_TALU}', "");
    Expect(1, 6623, '\P{^Is_Scx=_TALU}', "");
    Expect(0, 6624, '\p{Is_Scx=_TALU}', "");
    Expect(1, 6624, '\p{^Is_Scx=_TALU}', "");
    Expect(1, 6624, '\P{Is_Scx=_TALU}', "");
    Expect(0, 6624, '\P{^Is_Scx=_TALU}', "");
    Error('\p{Script_Extensions= /a/Tamil}');
    Error('\P{Script_Extensions= /a/Tamil}');
    Expect(1, 70460, '\p{Script_Extensions=tamil}', "");
    Expect(0, 70460, '\p{^Script_Extensions=tamil}', "");
    Expect(0, 70460, '\P{Script_Extensions=tamil}', "");
    Expect(1, 70460, '\P{^Script_Extensions=tamil}', "");
    Expect(0, 70461, '\p{Script_Extensions=tamil}', "");
    Expect(1, 70461, '\p{^Script_Extensions=tamil}', "");
    Expect(1, 70461, '\P{Script_Extensions=tamil}', "");
    Expect(0, 70461, '\P{^Script_Extensions=tamil}', "");
    Expect(1, 70460, '\p{Script_Extensions=_ tamil}', "");
    Expect(0, 70460, '\p{^Script_Extensions=_ tamil}', "");
    Expect(0, 70460, '\P{Script_Extensions=_ tamil}', "");
    Expect(1, 70460, '\P{^Script_Extensions=_ tamil}', "");
    Expect(0, 70461, '\p{Script_Extensions=_ tamil}', "");
    Expect(1, 70461, '\p{^Script_Extensions=_ tamil}', "");
    Expect(1, 70461, '\P{Script_Extensions=_ tamil}', "");
    Expect(0, 70461, '\P{^Script_Extensions=_ tamil}', "");
    Error('\p{Scx=/a/  Taml}');
    Error('\P{Scx=/a/  Taml}');
    Expect(1, 70460, '\p{Scx=taml}', "");
    Expect(0, 70460, '\p{^Scx=taml}', "");
    Expect(0, 70460, '\P{Scx=taml}', "");
    Expect(1, 70460, '\P{^Scx=taml}', "");
    Expect(0, 70461, '\p{Scx=taml}', "");
    Expect(1, 70461, '\p{^Scx=taml}', "");
    Expect(1, 70461, '\P{Scx=taml}', "");
    Expect(0, 70461, '\P{^Scx=taml}', "");
    Expect(1, 70460, '\p{Scx=		taml}', "");
    Expect(0, 70460, '\p{^Scx=		taml}', "");
    Expect(0, 70460, '\P{Scx=		taml}', "");
    Expect(1, 70460, '\P{^Scx=		taml}', "");
    Expect(0, 70461, '\p{Scx=		taml}', "");
    Expect(1, 70461, '\p{^Scx=		taml}', "");
    Expect(1, 70461, '\P{Scx=		taml}', "");
    Expect(0, 70461, '\P{^Scx=		taml}', "");
    Error('\p{Is_Script_Extensions=-:=tamil}');
    Error('\P{Is_Script_Extensions=-:=tamil}');
    Expect(1, 70460, '\p{Is_Script_Extensions=tamil}', "");
    Expect(0, 70460, '\p{^Is_Script_Extensions=tamil}', "");
    Expect(0, 70460, '\P{Is_Script_Extensions=tamil}', "");
    Expect(1, 70460, '\P{^Is_Script_Extensions=tamil}', "");
    Expect(0, 70461, '\p{Is_Script_Extensions=tamil}', "");
    Expect(1, 70461, '\p{^Is_Script_Extensions=tamil}', "");
    Expect(1, 70461, '\P{Is_Script_Extensions=tamil}', "");
    Expect(0, 70461, '\P{^Is_Script_Extensions=tamil}', "");
    Expect(1, 70460, '\p{Is_Script_Extensions= -Tamil}', "");
    Expect(0, 70460, '\p{^Is_Script_Extensions= -Tamil}', "");
    Expect(0, 70460, '\P{Is_Script_Extensions= -Tamil}', "");
    Expect(1, 70460, '\P{^Is_Script_Extensions= -Tamil}', "");
    Expect(0, 70461, '\p{Is_Script_Extensions= -Tamil}', "");
    Expect(1, 70461, '\p{^Is_Script_Extensions= -Tamil}', "");
    Expect(1, 70461, '\P{Is_Script_Extensions= -Tamil}', "");
    Expect(0, 70461, '\P{^Is_Script_Extensions= -Tamil}', "");
    Error('\p{Is_Scx= -Taml/a/}');
    Error('\P{Is_Scx= -Taml/a/}');
    Expect(1, 70460, '\p{Is_Scx=taml}', "");
    Expect(0, 70460, '\p{^Is_Scx=taml}', "");
    Expect(0, 70460, '\P{Is_Scx=taml}', "");
    Expect(1, 70460, '\P{^Is_Scx=taml}', "");
    Expect(0, 70461, '\p{Is_Scx=taml}', "");
    Expect(1, 70461, '\p{^Is_Scx=taml}', "");
    Expect(1, 70461, '\P{Is_Scx=taml}', "");
    Expect(0, 70461, '\P{^Is_Scx=taml}', "");
    Expect(1, 70460, '\p{Is_Scx=_taml}', "");
    Expect(0, 70460, '\p{^Is_Scx=_taml}', "");
    Expect(0, 70460, '\P{Is_Scx=_taml}', "");
    Expect(1, 70460, '\P{^Is_Scx=_taml}', "");
    Expect(0, 70461, '\p{Is_Scx=_taml}', "");
    Expect(1, 70461, '\p{^Is_Scx=_taml}', "");
    Expect(1, 70461, '\P{Is_Scx=_taml}', "");
    Expect(0, 70461, '\P{^Is_Scx=_taml}', "");
    Error('\p{Script_Extensions=-:=Tangut}');
    Error('\P{Script_Extensions=-:=Tangut}');
    Expect(1, 101106, '\p{Script_Extensions=tangut}', "");
    Expect(0, 101106, '\p{^Script_Extensions=tangut}', "");
    Expect(0, 101106, '\P{Script_Extensions=tangut}', "");
    Expect(1, 101106, '\P{^Script_Extensions=tangut}', "");
    Expect(0, 101107, '\p{Script_Extensions=tangut}', "");
    Expect(1, 101107, '\p{^Script_Extensions=tangut}', "");
    Expect(1, 101107, '\P{Script_Extensions=tangut}', "");
    Expect(0, 101107, '\P{^Script_Extensions=tangut}', "");
    Expect(1, 101106, '\p{Script_Extensions=	TANGUT}', "");
    Expect(0, 101106, '\p{^Script_Extensions=	TANGUT}', "");
    Expect(0, 101106, '\P{Script_Extensions=	TANGUT}', "");
    Expect(1, 101106, '\P{^Script_Extensions=	TANGUT}', "");
    Expect(0, 101107, '\p{Script_Extensions=	TANGUT}', "");
    Expect(1, 101107, '\p{^Script_Extensions=	TANGUT}', "");
    Expect(1, 101107, '\P{Script_Extensions=	TANGUT}', "");
    Expect(0, 101107, '\P{^Script_Extensions=	TANGUT}', "");
    Error('\p{Scx=-Tang:=}');
    Error('\P{Scx=-Tang:=}');
    Expect(1, 101106, '\p{Scx=tang}', "");
    Expect(0, 101106, '\p{^Scx=tang}', "");
    Expect(0, 101106, '\P{Scx=tang}', "");
    Expect(1, 101106, '\P{^Scx=tang}', "");
    Expect(0, 101107, '\p{Scx=tang}', "");
    Expect(1, 101107, '\p{^Scx=tang}', "");
    Expect(1, 101107, '\P{Scx=tang}', "");
    Expect(0, 101107, '\P{^Scx=tang}', "");
    Expect(1, 101106, '\p{Scx:  -TANG}', "");
    Expect(0, 101106, '\p{^Scx:  -TANG}', "");
    Expect(0, 101106, '\P{Scx:  -TANG}', "");
    Expect(1, 101106, '\P{^Scx:  -TANG}', "");
    Expect(0, 101107, '\p{Scx:  -TANG}', "");
    Expect(1, 101107, '\p{^Scx:  -TANG}', "");
    Expect(1, 101107, '\P{Scx:  -TANG}', "");
    Expect(0, 101107, '\P{^Scx:  -TANG}', "");
    Error('\p{Is_Script_Extensions:   _	TANGUT:=}');
    Error('\P{Is_Script_Extensions:   _	TANGUT:=}');
    Expect(1, 101106, '\p{Is_Script_Extensions=tangut}', "");
    Expect(0, 101106, '\p{^Is_Script_Extensions=tangut}', "");
    Expect(0, 101106, '\P{Is_Script_Extensions=tangut}', "");
    Expect(1, 101106, '\P{^Is_Script_Extensions=tangut}', "");
    Expect(0, 101107, '\p{Is_Script_Extensions=tangut}', "");
    Expect(1, 101107, '\p{^Is_Script_Extensions=tangut}', "");
    Expect(1, 101107, '\P{Is_Script_Extensions=tangut}', "");
    Expect(0, 101107, '\P{^Is_Script_Extensions=tangut}', "");
    Expect(1, 101106, '\p{Is_Script_Extensions= -Tangut}', "");
    Expect(0, 101106, '\p{^Is_Script_Extensions= -Tangut}', "");
    Expect(0, 101106, '\P{Is_Script_Extensions= -Tangut}', "");
    Expect(1, 101106, '\P{^Is_Script_Extensions= -Tangut}', "");
    Expect(0, 101107, '\p{Is_Script_Extensions= -Tangut}', "");
    Expect(1, 101107, '\p{^Is_Script_Extensions= -Tangut}', "");
    Expect(1, 101107, '\P{Is_Script_Extensions= -Tangut}', "");
    Expect(0, 101107, '\P{^Is_Script_Extensions= -Tangut}', "");
    Error('\p{Is_Scx=/a/Tang}');
    Error('\P{Is_Scx=/a/Tang}');
    Expect(1, 101106, '\p{Is_Scx=tang}', "");
    Expect(0, 101106, '\p{^Is_Scx=tang}', "");
    Expect(0, 101106, '\P{Is_Scx=tang}', "");
    Expect(1, 101106, '\P{^Is_Scx=tang}', "");
    Expect(0, 101107, '\p{Is_Scx=tang}', "");
    Expect(1, 101107, '\p{^Is_Scx=tang}', "");
    Expect(1, 101107, '\P{Is_Scx=tang}', "");
    Expect(0, 101107, '\P{^Is_Scx=tang}', "");
    Expect(1, 101106, '\p{Is_Scx=	Tang}', "");
    Expect(0, 101106, '\p{^Is_Scx=	Tang}', "");
    Expect(0, 101106, '\P{Is_Scx=	Tang}', "");
    Expect(1, 101106, '\P{^Is_Scx=	Tang}', "");
    Expect(0, 101107, '\p{Is_Scx=	Tang}', "");
    Expect(1, 101107, '\p{^Is_Scx=	Tang}', "");
    Expect(1, 101107, '\P{Is_Scx=	Tang}', "");
    Expect(0, 101107, '\P{^Is_Scx=	Tang}', "");
    Error('\p{Script_Extensions:			Tai_Viet:=}');
    Error('\P{Script_Extensions:			Tai_Viet:=}');
    Expect(1, 43743, '\p{Script_Extensions=taiviet}', "");
    Expect(0, 43743, '\p{^Script_Extensions=taiviet}', "");
    Expect(0, 43743, '\P{Script_Extensions=taiviet}', "");
    Expect(1, 43743, '\P{^Script_Extensions=taiviet}', "");
    Expect(0, 43744, '\p{Script_Extensions=taiviet}', "");
    Expect(1, 43744, '\p{^Script_Extensions=taiviet}', "");
    Expect(1, 43744, '\P{Script_Extensions=taiviet}', "");
    Expect(0, 43744, '\P{^Script_Extensions=taiviet}', "");
    Expect(1, 43743, '\p{Script_Extensions=	-tai_VIET}', "");
    Expect(0, 43743, '\p{^Script_Extensions=	-tai_VIET}', "");
    Expect(0, 43743, '\P{Script_Extensions=	-tai_VIET}', "");
    Expect(1, 43743, '\P{^Script_Extensions=	-tai_VIET}', "");
    Expect(0, 43744, '\p{Script_Extensions=	-tai_VIET}', "");
    Expect(1, 43744, '\p{^Script_Extensions=	-tai_VIET}', "");
    Expect(1, 43744, '\P{Script_Extensions=	-tai_VIET}', "");
    Expect(0, 43744, '\P{^Script_Extensions=	-tai_VIET}', "");
    Error('\p{Scx=-:=Tavt}');
    Error('\P{Scx=-:=Tavt}');
    Expect(1, 43743, '\p{Scx=tavt}', "");
    Expect(0, 43743, '\p{^Scx=tavt}', "");
    Expect(0, 43743, '\P{Scx=tavt}', "");
    Expect(1, 43743, '\P{^Scx=tavt}', "");
    Expect(0, 43744, '\p{Scx=tavt}', "");
    Expect(1, 43744, '\p{^Scx=tavt}', "");
    Expect(1, 43744, '\P{Scx=tavt}', "");
    Expect(0, 43744, '\P{^Scx=tavt}', "");
    Expect(1, 43743, '\p{Scx= -tavt}', "");
    Expect(0, 43743, '\p{^Scx= -tavt}', "");
    Expect(0, 43743, '\P{Scx= -tavt}', "");
    Expect(1, 43743, '\P{^Scx= -tavt}', "");
    Expect(0, 43744, '\p{Scx= -tavt}', "");
    Expect(1, 43744, '\p{^Scx= -tavt}', "");
    Expect(1, 43744, '\P{Scx= -tavt}', "");
    Expect(0, 43744, '\P{^Scx= -tavt}', "");
    Error('\p{Is_Script_Extensions=		TAI_Viet/a/}');
    Error('\P{Is_Script_Extensions=		TAI_Viet/a/}');
    Expect(1, 43743, '\p{Is_Script_Extensions=taiviet}', "");
    Expect(0, 43743, '\p{^Is_Script_Extensions=taiviet}', "");
    Expect(0, 43743, '\P{Is_Script_Extensions=taiviet}', "");
    Expect(1, 43743, '\P{^Is_Script_Extensions=taiviet}', "");
    Expect(0, 43744, '\p{Is_Script_Extensions=taiviet}', "");
    Expect(1, 43744, '\p{^Is_Script_Extensions=taiviet}', "");
    Expect(1, 43744, '\P{Is_Script_Extensions=taiviet}', "");
    Expect(0, 43744, '\P{^Is_Script_Extensions=taiviet}', "");
    Expect(1, 43743, '\p{Is_Script_Extensions=--tai_viet}', "");
    Expect(0, 43743, '\p{^Is_Script_Extensions=--tai_viet}', "");
    Expect(0, 43743, '\P{Is_Script_Extensions=--tai_viet}', "");
    Expect(1, 43743, '\P{^Is_Script_Extensions=--tai_viet}', "");
    Expect(0, 43744, '\p{Is_Script_Extensions=--tai_viet}', "");
    Expect(1, 43744, '\p{^Is_Script_Extensions=--tai_viet}', "");
    Expect(1, 43744, '\P{Is_Script_Extensions=--tai_viet}', "");
    Expect(0, 43744, '\P{^Is_Script_Extensions=--tai_viet}', "");
    Error('\p{Is_Scx=:=Tavt}');
    Error('\P{Is_Scx=:=Tavt}');
    Expect(1, 43743, '\p{Is_Scx=tavt}', "");
    Expect(0, 43743, '\p{^Is_Scx=tavt}', "");
    Expect(0, 43743, '\P{Is_Scx=tavt}', "");
    Expect(1, 43743, '\P{^Is_Scx=tavt}', "");
    Expect(0, 43744, '\p{Is_Scx=tavt}', "");
    Expect(1, 43744, '\p{^Is_Scx=tavt}', "");
    Expect(1, 43744, '\P{Is_Scx=tavt}', "");
    Expect(0, 43744, '\P{^Is_Scx=tavt}', "");
    Expect(1, 43743, '\p{Is_Scx: _tavt}', "");
    Expect(0, 43743, '\p{^Is_Scx: _tavt}', "");
    Expect(0, 43743, '\P{Is_Scx: _tavt}', "");
    Expect(1, 43743, '\P{^Is_Scx: _tavt}', "");
    Expect(0, 43744, '\p{Is_Scx: _tavt}', "");
    Expect(1, 43744, '\p{^Is_Scx: _tavt}', "");
    Expect(1, 43744, '\P{Is_Scx: _tavt}', "");
    Expect(0, 43744, '\P{^Is_Scx: _tavt}', "");
    Error('\p{Script_Extensions: :=	-TELUGU}');
    Error('\P{Script_Extensions: :=	-TELUGU}');
    Expect(1, 7386, '\p{Script_Extensions=telugu}', "");
    Expect(0, 7386, '\p{^Script_Extensions=telugu}', "");
    Expect(0, 7386, '\P{Script_Extensions=telugu}', "");
    Expect(1, 7386, '\P{^Script_Extensions=telugu}', "");
    Expect(0, 7387, '\p{Script_Extensions=telugu}', "");
    Expect(1, 7387, '\p{^Script_Extensions=telugu}', "");
    Expect(1, 7387, '\P{Script_Extensions=telugu}', "");
    Expect(0, 7387, '\P{^Script_Extensions=telugu}', "");
    Expect(1, 7386, '\p{Script_Extensions=-TELUGU}', "");
    Expect(0, 7386, '\p{^Script_Extensions=-TELUGU}', "");
    Expect(0, 7386, '\P{Script_Extensions=-TELUGU}', "");
    Expect(1, 7386, '\P{^Script_Extensions=-TELUGU}', "");
    Expect(0, 7387, '\p{Script_Extensions=-TELUGU}', "");
    Expect(1, 7387, '\p{^Script_Extensions=-TELUGU}', "");
    Expect(1, 7387, '\P{Script_Extensions=-TELUGU}', "");
    Expect(0, 7387, '\P{^Script_Extensions=-TELUGU}', "");
    Error('\p{Scx=/a/-telu}');
    Error('\P{Scx=/a/-telu}');
    Expect(1, 7386, '\p{Scx=telu}', "");
    Expect(0, 7386, '\p{^Scx=telu}', "");
    Expect(0, 7386, '\P{Scx=telu}', "");
    Expect(1, 7386, '\P{^Scx=telu}', "");
    Expect(0, 7387, '\p{Scx=telu}', "");
    Expect(1, 7387, '\p{^Scx=telu}', "");
    Expect(1, 7387, '\P{Scx=telu}', "");
    Expect(0, 7387, '\P{^Scx=telu}', "");
    Expect(1, 7386, '\p{Scx:   - Telu}', "");
    Expect(0, 7386, '\p{^Scx:   - Telu}', "");
    Expect(0, 7386, '\P{Scx:   - Telu}', "");
    Expect(1, 7386, '\P{^Scx:   - Telu}', "");
    Expect(0, 7387, '\p{Scx:   - Telu}', "");
    Expect(1, 7387, '\p{^Scx:   - Telu}', "");
    Expect(1, 7387, '\P{Scx:   - Telu}', "");
    Expect(0, 7387, '\P{^Scx:   - Telu}', "");
    Error('\p{Is_Script_Extensions=/a/-TELUGU}');
    Error('\P{Is_Script_Extensions=/a/-TELUGU}');
    Expect(1, 7386, '\p{Is_Script_Extensions=telugu}', "");
    Expect(0, 7386, '\p{^Is_Script_Extensions=telugu}', "");
    Expect(0, 7386, '\P{Is_Script_Extensions=telugu}', "");
    Expect(1, 7386, '\P{^Is_Script_Extensions=telugu}', "");
    Expect(0, 7387, '\p{Is_Script_Extensions=telugu}', "");
    Expect(1, 7387, '\p{^Is_Script_Extensions=telugu}', "");
    Expect(1, 7387, '\P{Is_Script_Extensions=telugu}', "");
    Expect(0, 7387, '\P{^Is_Script_Extensions=telugu}', "");
    Expect(1, 7386, '\p{Is_Script_Extensions= -Telugu}', "");
    Expect(0, 7386, '\p{^Is_Script_Extensions= -Telugu}', "");
    Expect(0, 7386, '\P{Is_Script_Extensions= -Telugu}', "");
    Expect(1, 7386, '\P{^Is_Script_Extensions= -Telugu}', "");
    Expect(0, 7387, '\p{Is_Script_Extensions= -Telugu}', "");
    Expect(1, 7387, '\p{^Is_Script_Extensions= -Telugu}', "");
    Expect(1, 7387, '\P{Is_Script_Extensions= -Telugu}', "");
    Expect(0, 7387, '\P{^Is_Script_Extensions= -Telugu}', "");
    Error('\p{Is_Scx=/a/	_Telu}');
    Error('\P{Is_Scx=/a/	_Telu}');
    Expect(1, 7386, '\p{Is_Scx=telu}', "");
    Expect(0, 7386, '\p{^Is_Scx=telu}', "");
    Expect(0, 7386, '\P{Is_Scx=telu}', "");
    Expect(1, 7386, '\P{^Is_Scx=telu}', "");
    Expect(0, 7387, '\p{Is_Scx=telu}', "");
    Expect(1, 7387, '\p{^Is_Scx=telu}', "");
    Expect(1, 7387, '\P{Is_Scx=telu}', "");
    Expect(0, 7387, '\P{^Is_Scx=telu}', "");
    Expect(1, 7386, '\p{Is_Scx=_-Telu}', "");
    Expect(0, 7386, '\p{^Is_Scx=_-Telu}', "");
    Expect(0, 7386, '\P{Is_Scx=_-Telu}', "");
    Expect(1, 7386, '\P{^Is_Scx=_-Telu}', "");
    Expect(0, 7387, '\p{Is_Scx=_-Telu}', "");
    Expect(1, 7387, '\p{^Is_Scx=_-Telu}', "");
    Expect(1, 7387, '\P{Is_Scx=_-Telu}', "");
    Expect(0, 7387, '\P{^Is_Scx=_-Telu}', "");
    Error('\p{Script_Extensions=:=_	TIFINAGH}');
    Error('\P{Script_Extensions=:=_	TIFINAGH}');
    Expect(1, 11647, '\p{Script_Extensions:   tifinagh}', "");
    Expect(0, 11647, '\p{^Script_Extensions:   tifinagh}', "");
    Expect(0, 11647, '\P{Script_Extensions:   tifinagh}', "");
    Expect(1, 11647, '\P{^Script_Extensions:   tifinagh}', "");
    Expect(0, 11648, '\p{Script_Extensions:   tifinagh}', "");
    Expect(1, 11648, '\p{^Script_Extensions:   tifinagh}', "");
    Expect(1, 11648, '\P{Script_Extensions:   tifinagh}', "");
    Expect(0, 11648, '\P{^Script_Extensions:   tifinagh}', "");
    Expect(1, 11647, '\p{Script_Extensions=TIFINAGH}', "");
    Expect(0, 11647, '\p{^Script_Extensions=TIFINAGH}', "");
    Expect(0, 11647, '\P{Script_Extensions=TIFINAGH}', "");
    Expect(1, 11647, '\P{^Script_Extensions=TIFINAGH}', "");
    Expect(0, 11648, '\p{Script_Extensions=TIFINAGH}', "");
    Expect(1, 11648, '\p{^Script_Extensions=TIFINAGH}', "");
    Expect(1, 11648, '\P{Script_Extensions=TIFINAGH}', "");
    Expect(0, 11648, '\P{^Script_Extensions=TIFINAGH}', "");
    Error('\p{Scx= /a/Tfng}');
    Error('\P{Scx= /a/Tfng}');
    Expect(1, 11647, '\p{Scx=tfng}', "");
    Expect(0, 11647, '\p{^Scx=tfng}', "");
    Expect(0, 11647, '\P{Scx=tfng}', "");
    Expect(1, 11647, '\P{^Scx=tfng}', "");
    Expect(0, 11648, '\p{Scx=tfng}', "");
    Expect(1, 11648, '\p{^Scx=tfng}', "");
    Expect(1, 11648, '\P{Scx=tfng}', "");
    Expect(0, 11648, '\P{^Scx=tfng}', "");
    Expect(1, 11647, '\p{Scx=-_TFNG}', "");
    Expect(0, 11647, '\p{^Scx=-_TFNG}', "");
    Expect(0, 11647, '\P{Scx=-_TFNG}', "");
    Expect(1, 11647, '\P{^Scx=-_TFNG}', "");
    Expect(0, 11648, '\p{Scx=-_TFNG}', "");
    Expect(1, 11648, '\p{^Scx=-_TFNG}', "");
    Expect(1, 11648, '\P{Scx=-_TFNG}', "");
    Expect(0, 11648, '\P{^Scx=-_TFNG}', "");
    Error('\p{Is_Script_Extensions=/a/-	Tifinagh}');
    Error('\P{Is_Script_Extensions=/a/-	Tifinagh}');
    Expect(1, 11647, '\p{Is_Script_Extensions=tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Script_Extensions=tifinagh}', "");
    Expect(0, 11647, '\P{Is_Script_Extensions=tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Script_Extensions=tifinagh}', "");
    Expect(0, 11648, '\p{Is_Script_Extensions=tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Script_Extensions=tifinagh}', "");
    Expect(1, 11648, '\P{Is_Script_Extensions=tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Script_Extensions=tifinagh}', "");
    Expect(1, 11647, '\p{Is_Script_Extensions=Tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Script_Extensions=Tifinagh}', "");
    Expect(0, 11647, '\P{Is_Script_Extensions=Tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Script_Extensions=Tifinagh}', "");
    Expect(0, 11648, '\p{Is_Script_Extensions=Tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Script_Extensions=Tifinagh}', "");
    Expect(1, 11648, '\P{Is_Script_Extensions=Tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Script_Extensions=Tifinagh}', "");
    Error('\p{Is_Scx= TFNG/a/}');
    Error('\P{Is_Scx= TFNG/a/}');
    Expect(1, 11647, '\p{Is_Scx=tfng}', "");
    Expect(0, 11647, '\p{^Is_Scx=tfng}', "");
    Expect(0, 11647, '\P{Is_Scx=tfng}', "");
    Expect(1, 11647, '\P{^Is_Scx=tfng}', "");
    Expect(0, 11648, '\p{Is_Scx=tfng}', "");
    Expect(1, 11648, '\p{^Is_Scx=tfng}', "");
    Expect(1, 11648, '\P{Is_Scx=tfng}', "");
    Expect(0, 11648, '\P{^Is_Scx=tfng}', "");
    Expect(1, 11647, '\p{Is_Scx=_-TFNG}', "");
    Expect(0, 11647, '\p{^Is_Scx=_-TFNG}', "");
    Expect(0, 11647, '\P{Is_Scx=_-TFNG}', "");
    Expect(1, 11647, '\P{^Is_Scx=_-TFNG}', "");
    Expect(0, 11648, '\p{Is_Scx=_-TFNG}', "");
    Expect(1, 11648, '\p{^Is_Scx=_-TFNG}', "");
    Expect(1, 11648, '\P{Is_Scx=_-TFNG}', "");
    Expect(0, 11648, '\P{^Is_Scx=_-TFNG}', "");
    Error('\p{Script_Extensions=/a/-tagalog}');
    Error('\P{Script_Extensions=/a/-tagalog}');
    Expect(1, 5942, '\p{Script_Extensions=tagalog}', "");
    Expect(0, 5942, '\p{^Script_Extensions=tagalog}', "");
    Expect(0, 5942, '\P{Script_Extensions=tagalog}', "");
    Expect(1, 5942, '\P{^Script_Extensions=tagalog}', "");
    Expect(0, 5943, '\p{Script_Extensions=tagalog}', "");
    Expect(1, 5943, '\p{^Script_Extensions=tagalog}', "");
    Expect(1, 5943, '\P{Script_Extensions=tagalog}', "");
    Expect(0, 5943, '\P{^Script_Extensions=tagalog}', "");
    Expect(1, 5942, '\p{Script_Extensions=__Tagalog}', "");
    Expect(0, 5942, '\p{^Script_Extensions=__Tagalog}', "");
    Expect(0, 5942, '\P{Script_Extensions=__Tagalog}', "");
    Expect(1, 5942, '\P{^Script_Extensions=__Tagalog}', "");
    Expect(0, 5943, '\p{Script_Extensions=__Tagalog}', "");
    Expect(1, 5943, '\p{^Script_Extensions=__Tagalog}', "");
    Expect(1, 5943, '\P{Script_Extensions=__Tagalog}', "");
    Expect(0, 5943, '\P{^Script_Extensions=__Tagalog}', "");
    Error('\p{Scx=-:=Tglg}');
    Error('\P{Scx=-:=Tglg}');
    Expect(1, 5942, '\p{Scx=tglg}', "");
    Expect(0, 5942, '\p{^Scx=tglg}', "");
    Expect(0, 5942, '\P{Scx=tglg}', "");
    Expect(1, 5942, '\P{^Scx=tglg}', "");
    Expect(0, 5943, '\p{Scx=tglg}', "");
    Expect(1, 5943, '\p{^Scx=tglg}', "");
    Expect(1, 5943, '\P{Scx=tglg}', "");
    Expect(0, 5943, '\P{^Scx=tglg}', "");
    Expect(1, 5942, '\p{Scx=_-tglg}', "");
    Expect(0, 5942, '\p{^Scx=_-tglg}', "");
    Expect(0, 5942, '\P{Scx=_-tglg}', "");
    Expect(1, 5942, '\P{^Scx=_-tglg}', "");
    Expect(0, 5943, '\p{Scx=_-tglg}', "");
    Expect(1, 5943, '\p{^Scx=_-tglg}', "");
    Expect(1, 5943, '\P{Scx=_-tglg}', "");
    Expect(0, 5943, '\P{^Scx=_-tglg}', "");
    Error('\p{Is_Script_Extensions=_:=Tagalog}');
    Error('\P{Is_Script_Extensions=_:=Tagalog}');
    Expect(1, 5942, '\p{Is_Script_Extensions=tagalog}', "");
    Expect(0, 5942, '\p{^Is_Script_Extensions=tagalog}', "");
    Expect(0, 5942, '\P{Is_Script_Extensions=tagalog}', "");
    Expect(1, 5942, '\P{^Is_Script_Extensions=tagalog}', "");
    Expect(0, 5943, '\p{Is_Script_Extensions=tagalog}', "");
    Expect(1, 5943, '\p{^Is_Script_Extensions=tagalog}', "");
    Expect(1, 5943, '\P{Is_Script_Extensions=tagalog}', "");
    Expect(0, 5943, '\P{^Is_Script_Extensions=tagalog}', "");
    Expect(1, 5942, '\p{Is_Script_Extensions=_-Tagalog}', "");
    Expect(0, 5942, '\p{^Is_Script_Extensions=_-Tagalog}', "");
    Expect(0, 5942, '\P{Is_Script_Extensions=_-Tagalog}', "");
    Expect(1, 5942, '\P{^Is_Script_Extensions=_-Tagalog}', "");
    Expect(0, 5943, '\p{Is_Script_Extensions=_-Tagalog}', "");
    Expect(1, 5943, '\p{^Is_Script_Extensions=_-Tagalog}', "");
    Expect(1, 5943, '\P{Is_Script_Extensions=_-Tagalog}', "");
    Expect(0, 5943, '\P{^Is_Script_Extensions=_-Tagalog}', "");
    Error('\p{Is_Scx=-_Tglg:=}');
    Error('\P{Is_Scx=-_Tglg:=}');
    Expect(1, 5942, '\p{Is_Scx:tglg}', "");
    Expect(0, 5942, '\p{^Is_Scx:tglg}', "");
    Expect(0, 5942, '\P{Is_Scx:tglg}', "");
    Expect(1, 5942, '\P{^Is_Scx:tglg}', "");
    Expect(0, 5943, '\p{Is_Scx:tglg}', "");
    Expect(1, 5943, '\p{^Is_Scx:tglg}', "");
    Expect(1, 5943, '\P{Is_Scx:tglg}', "");
    Expect(0, 5943, '\P{^Is_Scx:tglg}', "");
    Expect(1, 5942, '\p{Is_Scx=	_Tglg}', "");
    Expect(0, 5942, '\p{^Is_Scx=	_Tglg}', "");
    Expect(0, 5942, '\P{Is_Scx=	_Tglg}', "");
    Expect(1, 5942, '\P{^Is_Scx=	_Tglg}', "");
    Expect(0, 5943, '\p{Is_Scx=	_Tglg}', "");
    Expect(1, 5943, '\p{^Is_Scx=	_Tglg}', "");
    Expect(1, 5943, '\P{Is_Scx=	_Tglg}', "");
    Expect(0, 5943, '\P{^Is_Scx=	_Tglg}', "");
    Error('\p{Script_Extensions: :=-Thaana}');
    Error('\P{Script_Extensions: :=-Thaana}');
    Expect(1, 65021, '\p{Script_Extensions=thaana}', "");
    Expect(0, 65021, '\p{^Script_Extensions=thaana}', "");
    Expect(0, 65021, '\P{Script_Extensions=thaana}', "");
    Expect(1, 65021, '\P{^Script_Extensions=thaana}', "");
    Expect(0, 65022, '\p{Script_Extensions=thaana}', "");
    Expect(1, 65022, '\p{^Script_Extensions=thaana}', "");
    Expect(1, 65022, '\P{Script_Extensions=thaana}', "");
    Expect(0, 65022, '\P{^Script_Extensions=thaana}', "");
    Expect(1, 65021, '\p{Script_Extensions=Thaana}', "");
    Expect(0, 65021, '\p{^Script_Extensions=Thaana}', "");
    Expect(0, 65021, '\P{Script_Extensions=Thaana}', "");
    Expect(1, 65021, '\P{^Script_Extensions=Thaana}', "");
    Expect(0, 65022, '\p{Script_Extensions=Thaana}', "");
    Expect(1, 65022, '\p{^Script_Extensions=Thaana}', "");
    Expect(1, 65022, '\P{Script_Extensions=Thaana}', "");
    Expect(0, 65022, '\P{^Script_Extensions=Thaana}', "");
    Error('\p{Scx=/a/_Thaa}');
    Error('\P{Scx=/a/_Thaa}');
    Expect(1, 65021, '\p{Scx=thaa}', "");
    Expect(0, 65021, '\p{^Scx=thaa}', "");
    Expect(0, 65021, '\P{Scx=thaa}', "");
    Expect(1, 65021, '\P{^Scx=thaa}', "");
    Expect(0, 65022, '\p{Scx=thaa}', "");
    Expect(1, 65022, '\p{^Scx=thaa}', "");
    Expect(1, 65022, '\P{Scx=thaa}', "");
    Expect(0, 65022, '\P{^Scx=thaa}', "");
    Expect(1, 65021, '\p{Scx=_thaa}', "");
    Expect(0, 65021, '\p{^Scx=_thaa}', "");
    Expect(0, 65021, '\P{Scx=_thaa}', "");
    Expect(1, 65021, '\P{^Scx=_thaa}', "");
    Expect(0, 65022, '\p{Scx=_thaa}', "");
    Expect(1, 65022, '\p{^Scx=_thaa}', "");
    Expect(1, 65022, '\P{Scx=_thaa}', "");
    Expect(0, 65022, '\P{^Scx=_thaa}', "");
    Error('\p{Is_Script_Extensions=/a/ THAANA}');
    Error('\P{Is_Script_Extensions=/a/ THAANA}');
    Expect(1, 65021, '\p{Is_Script_Extensions=thaana}', "");
    Expect(0, 65021, '\p{^Is_Script_Extensions=thaana}', "");
    Expect(0, 65021, '\P{Is_Script_Extensions=thaana}', "");
    Expect(1, 65021, '\P{^Is_Script_Extensions=thaana}', "");
    Expect(0, 65022, '\p{Is_Script_Extensions=thaana}', "");
    Expect(1, 65022, '\p{^Is_Script_Extensions=thaana}', "");
    Expect(1, 65022, '\P{Is_Script_Extensions=thaana}', "");
    Expect(0, 65022, '\P{^Is_Script_Extensions=thaana}', "");
    Expect(1, 65021, '\p{Is_Script_Extensions=- THAANA}', "");
    Expect(0, 65021, '\p{^Is_Script_Extensions=- THAANA}', "");
    Expect(0, 65021, '\P{Is_Script_Extensions=- THAANA}', "");
    Expect(1, 65021, '\P{^Is_Script_Extensions=- THAANA}', "");
    Expect(0, 65022, '\p{Is_Script_Extensions=- THAANA}', "");
    Expect(1, 65022, '\p{^Is_Script_Extensions=- THAANA}', "");
    Expect(1, 65022, '\P{Is_Script_Extensions=- THAANA}', "");
    Expect(0, 65022, '\P{^Is_Script_Extensions=- THAANA}', "");
    Error('\p{Is_Scx=-THAA:=}');
    Error('\P{Is_Scx=-THAA:=}');
    Expect(1, 65021, '\p{Is_Scx: thaa}', "");
    Expect(0, 65021, '\p{^Is_Scx: thaa}', "");
    Expect(0, 65021, '\P{Is_Scx: thaa}', "");
    Expect(1, 65021, '\P{^Is_Scx: thaa}', "");
    Expect(0, 65022, '\p{Is_Scx: thaa}', "");
    Expect(1, 65022, '\p{^Is_Scx: thaa}', "");
    Expect(1, 65022, '\P{Is_Scx: thaa}', "");
    Expect(0, 65022, '\P{^Is_Scx: thaa}', "");
    Expect(1, 65021, '\p{Is_Scx=-	THAA}', "");
    Expect(0, 65021, '\p{^Is_Scx=-	THAA}', "");
    Expect(0, 65021, '\P{Is_Scx=-	THAA}', "");
    Expect(1, 65021, '\P{^Is_Scx=-	THAA}', "");
    Expect(0, 65022, '\p{Is_Scx=-	THAA}', "");
    Expect(1, 65022, '\p{^Is_Scx=-	THAA}', "");
    Expect(1, 65022, '\P{Is_Scx=-	THAA}', "");
    Expect(0, 65022, '\P{^Is_Scx=-	THAA}', "");
    Error('\p{Script_Extensions=		thai/a/}');
    Error('\P{Script_Extensions=		thai/a/}');
    Expect(1, 3675, '\p{Script_Extensions=thai}', "");
    Expect(0, 3675, '\p{^Script_Extensions=thai}', "");
    Expect(0, 3675, '\P{Script_Extensions=thai}', "");
    Expect(1, 3675, '\P{^Script_Extensions=thai}', "");
    Expect(0, 3676, '\p{Script_Extensions=thai}', "");
    Expect(1, 3676, '\p{^Script_Extensions=thai}', "");
    Expect(1, 3676, '\P{Script_Extensions=thai}', "");
    Expect(0, 3676, '\P{^Script_Extensions=thai}', "");
    Expect(1, 3675, '\p{Script_Extensions=  thai}', "");
    Expect(0, 3675, '\p{^Script_Extensions=  thai}', "");
    Expect(0, 3675, '\P{Script_Extensions=  thai}', "");
    Expect(1, 3675, '\P{^Script_Extensions=  thai}', "");
    Expect(0, 3676, '\p{Script_Extensions=  thai}', "");
    Expect(1, 3676, '\p{^Script_Extensions=  thai}', "");
    Expect(1, 3676, '\P{Script_Extensions=  thai}', "");
    Expect(0, 3676, '\P{^Script_Extensions=  thai}', "");
    Error('\p{Scx=/a/	_thai}');
    Error('\P{Scx=/a/	_thai}');
    Expect(1, 3675, '\p{Scx=thai}', "");
    Expect(0, 3675, '\p{^Scx=thai}', "");
    Expect(0, 3675, '\P{Scx=thai}', "");
    Expect(1, 3675, '\P{^Scx=thai}', "");
    Expect(0, 3676, '\p{Scx=thai}', "");
    Expect(1, 3676, '\p{^Scx=thai}', "");
    Expect(1, 3676, '\P{Scx=thai}', "");
    Expect(0, 3676, '\P{^Scx=thai}', "");
    Expect(1, 3675, '\p{Scx=- thai}', "");
    Expect(0, 3675, '\p{^Scx=- thai}', "");
    Expect(0, 3675, '\P{Scx=- thai}', "");
    Expect(1, 3675, '\P{^Scx=- thai}', "");
    Expect(0, 3676, '\p{Scx=- thai}', "");
    Expect(1, 3676, '\p{^Scx=- thai}', "");
    Expect(1, 3676, '\P{Scx=- thai}', "");
    Expect(0, 3676, '\P{^Scx=- thai}', "");
    Error('\p{Is_Script_Extensions=_/a/thai}');
    Error('\P{Is_Script_Extensions=_/a/thai}');
    Expect(1, 3675, '\p{Is_Script_Extensions=thai}', "");
    Expect(0, 3675, '\p{^Is_Script_Extensions=thai}', "");
    Expect(0, 3675, '\P{Is_Script_Extensions=thai}', "");
    Expect(1, 3675, '\P{^Is_Script_Extensions=thai}', "");
    Expect(0, 3676, '\p{Is_Script_Extensions=thai}', "");
    Expect(1, 3676, '\p{^Is_Script_Extensions=thai}', "");
    Expect(1, 3676, '\P{Is_Script_Extensions=thai}', "");
    Expect(0, 3676, '\P{^Is_Script_Extensions=thai}', "");
    Expect(1, 3675, '\p{Is_Script_Extensions=-	Thai}', "");
    Expect(0, 3675, '\p{^Is_Script_Extensions=-	Thai}', "");
    Expect(0, 3675, '\P{Is_Script_Extensions=-	Thai}', "");
    Expect(1, 3675, '\P{^Is_Script_Extensions=-	Thai}', "");
    Expect(0, 3676, '\p{Is_Script_Extensions=-	Thai}', "");
    Expect(1, 3676, '\p{^Is_Script_Extensions=-	Thai}', "");
    Expect(1, 3676, '\P{Is_Script_Extensions=-	Thai}', "");
    Expect(0, 3676, '\P{^Is_Script_Extensions=-	Thai}', "");
    Error('\p{Is_Scx=-:=thai}');
    Error('\P{Is_Scx=-:=thai}');
    Expect(1, 3675, '\p{Is_Scx=thai}', "");
    Expect(0, 3675, '\p{^Is_Scx=thai}', "");
    Expect(0, 3675, '\P{Is_Scx=thai}', "");
    Expect(1, 3675, '\P{^Is_Scx=thai}', "");
    Expect(0, 3676, '\p{Is_Scx=thai}', "");
    Expect(1, 3676, '\p{^Is_Scx=thai}', "");
    Expect(1, 3676, '\P{Is_Scx=thai}', "");
    Expect(0, 3676, '\P{^Is_Scx=thai}', "");
    Expect(1, 3675, '\p{Is_Scx=_ THAI}', "");
    Expect(0, 3675, '\p{^Is_Scx=_ THAI}', "");
    Expect(0, 3675, '\P{Is_Scx=_ THAI}', "");
    Expect(1, 3675, '\P{^Is_Scx=_ THAI}', "");
    Expect(0, 3676, '\p{Is_Scx=_ THAI}', "");
    Expect(1, 3676, '\p{^Is_Scx=_ THAI}', "");
    Expect(1, 3676, '\P{Is_Scx=_ THAI}', "");
    Expect(0, 3676, '\P{^Is_Scx=_ THAI}', "");
    Error('\p{Script_Extensions=/a/TIBETAN}');
    Error('\P{Script_Extensions=/a/TIBETAN}');
    Expect(1, 4058, '\p{Script_Extensions=tibetan}', "");
    Expect(0, 4058, '\p{^Script_Extensions=tibetan}', "");
    Expect(0, 4058, '\P{Script_Extensions=tibetan}', "");
    Expect(1, 4058, '\P{^Script_Extensions=tibetan}', "");
    Expect(0, 4059, '\p{Script_Extensions=tibetan}', "");
    Expect(1, 4059, '\p{^Script_Extensions=tibetan}', "");
    Expect(1, 4059, '\P{Script_Extensions=tibetan}', "");
    Expect(0, 4059, '\P{^Script_Extensions=tibetan}', "");
    Expect(1, 4058, '\p{Script_Extensions=	 Tibetan}', "");
    Expect(0, 4058, '\p{^Script_Extensions=	 Tibetan}', "");
    Expect(0, 4058, '\P{Script_Extensions=	 Tibetan}', "");
    Expect(1, 4058, '\P{^Script_Extensions=	 Tibetan}', "");
    Expect(0, 4059, '\p{Script_Extensions=	 Tibetan}', "");
    Expect(1, 4059, '\p{^Script_Extensions=	 Tibetan}', "");
    Expect(1, 4059, '\P{Script_Extensions=	 Tibetan}', "");
    Expect(0, 4059, '\P{^Script_Extensions=	 Tibetan}', "");
    Error('\p{Scx:	:=_	Tibt}');
    Error('\P{Scx:	:=_	Tibt}');
    Expect(1, 4058, '\p{Scx=tibt}', "");
    Expect(0, 4058, '\p{^Scx=tibt}', "");
    Expect(0, 4058, '\P{Scx=tibt}', "");
    Expect(1, 4058, '\P{^Scx=tibt}', "");
    Expect(0, 4059, '\p{Scx=tibt}', "");
    Expect(1, 4059, '\p{^Scx=tibt}', "");
    Expect(1, 4059, '\P{Scx=tibt}', "");
    Expect(0, 4059, '\P{^Scx=tibt}', "");
    Expect(1, 4058, '\p{Scx= TIBT}', "");
    Expect(0, 4058, '\p{^Scx= TIBT}', "");
    Expect(0, 4058, '\P{Scx= TIBT}', "");
    Expect(1, 4058, '\P{^Scx= TIBT}', "");
    Expect(0, 4059, '\p{Scx= TIBT}', "");
    Expect(1, 4059, '\p{^Scx= TIBT}', "");
    Expect(1, 4059, '\P{Scx= TIBT}', "");
    Expect(0, 4059, '\P{^Scx= TIBT}', "");
    Error('\p{Is_Script_Extensions=-	Tibetan/a/}');
    Error('\P{Is_Script_Extensions=-	Tibetan/a/}');
    Expect(1, 4058, '\p{Is_Script_Extensions=tibetan}', "");
    Expect(0, 4058, '\p{^Is_Script_Extensions=tibetan}', "");
    Expect(0, 4058, '\P{Is_Script_Extensions=tibetan}', "");
    Expect(1, 4058, '\P{^Is_Script_Extensions=tibetan}', "");
    Expect(0, 4059, '\p{Is_Script_Extensions=tibetan}', "");
    Expect(1, 4059, '\p{^Is_Script_Extensions=tibetan}', "");
    Expect(1, 4059, '\P{Is_Script_Extensions=tibetan}', "");
    Expect(0, 4059, '\P{^Is_Script_Extensions=tibetan}', "");
    Expect(1, 4058, '\p{Is_Script_Extensions=_-TIBETAN}', "");
    Expect(0, 4058, '\p{^Is_Script_Extensions=_-TIBETAN}', "");
    Expect(0, 4058, '\P{Is_Script_Extensions=_-TIBETAN}', "");
    Expect(1, 4058, '\P{^Is_Script_Extensions=_-TIBETAN}', "");
    Expect(0, 4059, '\p{Is_Script_Extensions=_-TIBETAN}', "");
    Expect(1, 4059, '\p{^Is_Script_Extensions=_-TIBETAN}', "");
    Expect(1, 4059, '\P{Is_Script_Extensions=_-TIBETAN}', "");
    Expect(0, 4059, '\P{^Is_Script_Extensions=_-TIBETAN}', "");
    Error('\p{Is_Scx=:=  TIBT}');
    Error('\P{Is_Scx=:=  TIBT}');
    Expect(1, 4058, '\p{Is_Scx=tibt}', "");
    Expect(0, 4058, '\p{^Is_Scx=tibt}', "");
    Expect(0, 4058, '\P{Is_Scx=tibt}', "");
    Expect(1, 4058, '\P{^Is_Scx=tibt}', "");
    Expect(0, 4059, '\p{Is_Scx=tibt}', "");
    Expect(1, 4059, '\p{^Is_Scx=tibt}', "");
    Expect(1, 4059, '\P{Is_Scx=tibt}', "");
    Expect(0, 4059, '\P{^Is_Scx=tibt}', "");
    Expect(1, 4058, '\p{Is_Scx=	-tibt}', "");
    Expect(0, 4058, '\p{^Is_Scx=	-tibt}', "");
    Expect(0, 4058, '\P{Is_Scx=	-tibt}', "");
    Expect(1, 4058, '\P{^Is_Scx=	-tibt}', "");
    Expect(0, 4059, '\p{Is_Scx=	-tibt}', "");
    Expect(1, 4059, '\p{^Is_Scx=	-tibt}', "");
    Expect(1, 4059, '\P{Is_Scx=	-tibt}', "");
    Expect(0, 4059, '\P{^Is_Scx=	-tibt}', "");
    Error('\p{Script_Extensions=:=	-Tirhuta}');
    Error('\P{Script_Extensions=:=	-Tirhuta}');
    Expect(1, 70873, '\p{Script_Extensions=tirhuta}', "");
    Expect(0, 70873, '\p{^Script_Extensions=tirhuta}', "");
    Expect(0, 70873, '\P{Script_Extensions=tirhuta}', "");
    Expect(1, 70873, '\P{^Script_Extensions=tirhuta}', "");
    Expect(0, 70874, '\p{Script_Extensions=tirhuta}', "");
    Expect(1, 70874, '\p{^Script_Extensions=tirhuta}', "");
    Expect(1, 70874, '\P{Script_Extensions=tirhuta}', "");
    Expect(0, 70874, '\P{^Script_Extensions=tirhuta}', "");
    Expect(1, 70873, '\p{Script_Extensions=		tirhuta}', "");
    Expect(0, 70873, '\p{^Script_Extensions=		tirhuta}', "");
    Expect(0, 70873, '\P{Script_Extensions=		tirhuta}', "");
    Expect(1, 70873, '\P{^Script_Extensions=		tirhuta}', "");
    Expect(0, 70874, '\p{Script_Extensions=		tirhuta}', "");
    Expect(1, 70874, '\p{^Script_Extensions=		tirhuta}', "");
    Expect(1, 70874, '\P{Script_Extensions=		tirhuta}', "");
    Expect(0, 70874, '\P{^Script_Extensions=		tirhuta}', "");
    Error('\p{Scx=_	Tirh:=}');
    Error('\P{Scx=_	Tirh:=}');
    Expect(1, 70873, '\p{Scx=tirh}', "");
    Expect(0, 70873, '\p{^Scx=tirh}', "");
    Expect(0, 70873, '\P{Scx=tirh}', "");
    Expect(1, 70873, '\P{^Scx=tirh}', "");
    Expect(0, 70874, '\p{Scx=tirh}', "");
    Expect(1, 70874, '\p{^Scx=tirh}', "");
    Expect(1, 70874, '\P{Scx=tirh}', "");
    Expect(0, 70874, '\P{^Scx=tirh}', "");
    Expect(1, 70873, '\p{Scx= tirh}', "");
    Expect(0, 70873, '\p{^Scx= tirh}', "");
    Expect(0, 70873, '\P{Scx= tirh}', "");
    Expect(1, 70873, '\P{^Scx= tirh}', "");
    Expect(0, 70874, '\p{Scx= tirh}', "");
    Expect(1, 70874, '\p{^Scx= tirh}', "");
    Expect(1, 70874, '\P{Scx= tirh}', "");
    Expect(0, 70874, '\P{^Scx= tirh}', "");
    Error('\p{Is_Script_Extensions=-	tirhuta/a/}');
    Error('\P{Is_Script_Extensions=-	tirhuta/a/}');
    Expect(1, 70873, '\p{Is_Script_Extensions=tirhuta}', "");
    Expect(0, 70873, '\p{^Is_Script_Extensions=tirhuta}', "");
    Expect(0, 70873, '\P{Is_Script_Extensions=tirhuta}', "");
    Expect(1, 70873, '\P{^Is_Script_Extensions=tirhuta}', "");
    Expect(0, 70874, '\p{Is_Script_Extensions=tirhuta}', "");
    Expect(1, 70874, '\p{^Is_Script_Extensions=tirhuta}', "");
    Expect(1, 70874, '\P{Is_Script_Extensions=tirhuta}', "");
    Expect(0, 70874, '\P{^Is_Script_Extensions=tirhuta}', "");
    Expect(1, 70873, '\p{Is_Script_Extensions:    tirhuta}', "");
    Expect(0, 70873, '\p{^Is_Script_Extensions:    tirhuta}', "");
    Expect(0, 70873, '\P{Is_Script_Extensions:    tirhuta}', "");
    Expect(1, 70873, '\P{^Is_Script_Extensions:    tirhuta}', "");
    Expect(0, 70874, '\p{Is_Script_Extensions:    tirhuta}', "");
    Expect(1, 70874, '\p{^Is_Script_Extensions:    tirhuta}', "");
    Expect(1, 70874, '\P{Is_Script_Extensions:    tirhuta}', "");
    Expect(0, 70874, '\P{^Is_Script_Extensions:    tirhuta}', "");
    Error('\p{Is_Scx=_:=Tirh}');
    Error('\P{Is_Scx=_:=Tirh}');
    Expect(1, 70873, '\p{Is_Scx=tirh}', "");
    Expect(0, 70873, '\p{^Is_Scx=tirh}', "");
    Expect(0, 70873, '\P{Is_Scx=tirh}', "");
    Expect(1, 70873, '\P{^Is_Scx=tirh}', "");
    Expect(0, 70874, '\p{Is_Scx=tirh}', "");
    Expect(1, 70874, '\p{^Is_Scx=tirh}', "");
    Expect(1, 70874, '\P{Is_Scx=tirh}', "");
    Expect(0, 70874, '\P{^Is_Scx=tirh}', "");
    Expect(1, 70873, '\p{Is_Scx=	 Tirh}', "");
    Expect(0, 70873, '\p{^Is_Scx=	 Tirh}', "");
    Expect(0, 70873, '\P{Is_Scx=	 Tirh}', "");
    Expect(1, 70873, '\P{^Is_Scx=	 Tirh}', "");
    Expect(0, 70874, '\p{Is_Scx=	 Tirh}', "");
    Expect(1, 70874, '\p{^Is_Scx=	 Tirh}', "");
    Expect(1, 70874, '\P{Is_Scx=	 Tirh}', "");
    Expect(0, 70874, '\P{^Is_Scx=	 Tirh}', "");
    Error('\p{Script_Extensions=_/a/ugaritic}');
    Error('\P{Script_Extensions=_/a/ugaritic}');
    Expect(1, 66463, '\p{Script_Extensions=ugaritic}', "");
    Expect(0, 66463, '\p{^Script_Extensions=ugaritic}', "");
    Expect(0, 66463, '\P{Script_Extensions=ugaritic}', "");
    Expect(1, 66463, '\P{^Script_Extensions=ugaritic}', "");
    Expect(0, 66464, '\p{Script_Extensions=ugaritic}', "");
    Expect(1, 66464, '\p{^Script_Extensions=ugaritic}', "");
    Expect(1, 66464, '\P{Script_Extensions=ugaritic}', "");
    Expect(0, 66464, '\P{^Script_Extensions=ugaritic}', "");
    Expect(1, 66463, '\p{Script_Extensions=-	Ugaritic}', "");
    Expect(0, 66463, '\p{^Script_Extensions=-	Ugaritic}', "");
    Expect(0, 66463, '\P{Script_Extensions=-	Ugaritic}', "");
    Expect(1, 66463, '\P{^Script_Extensions=-	Ugaritic}', "");
    Expect(0, 66464, '\p{Script_Extensions=-	Ugaritic}', "");
    Expect(1, 66464, '\p{^Script_Extensions=-	Ugaritic}', "");
    Expect(1, 66464, '\P{Script_Extensions=-	Ugaritic}', "");
    Expect(0, 66464, '\P{^Script_Extensions=-	Ugaritic}', "");
    Error('\p{Scx=/a/_	Ugar}');
    Error('\P{Scx=/a/_	Ugar}');
    Expect(1, 66463, '\p{Scx=ugar}', "");
    Expect(0, 66463, '\p{^Scx=ugar}', "");
    Expect(0, 66463, '\P{Scx=ugar}', "");
    Expect(1, 66463, '\P{^Scx=ugar}', "");
    Expect(0, 66464, '\p{Scx=ugar}', "");
    Expect(1, 66464, '\p{^Scx=ugar}', "");
    Expect(1, 66464, '\P{Scx=ugar}', "");
    Expect(0, 66464, '\P{^Scx=ugar}', "");
    Expect(1, 66463, '\p{Scx=_	Ugar}', "");
    Expect(0, 66463, '\p{^Scx=_	Ugar}', "");
    Expect(0, 66463, '\P{Scx=_	Ugar}', "");
    Expect(1, 66463, '\P{^Scx=_	Ugar}', "");
    Expect(0, 66464, '\p{Scx=_	Ugar}', "");
    Expect(1, 66464, '\p{^Scx=_	Ugar}', "");
    Expect(1, 66464, '\P{Scx=_	Ugar}', "");
    Expect(0, 66464, '\P{^Scx=_	Ugar}', "");
    Error('\p{Is_Script_Extensions=/a/	 UGARITIC}');
    Error('\P{Is_Script_Extensions=/a/	 UGARITIC}');
    Expect(1, 66463, '\p{Is_Script_Extensions=ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Script_Extensions=ugaritic}', "");
    Expect(0, 66463, '\P{Is_Script_Extensions=ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Script_Extensions=ugaritic}', "");
    Expect(0, 66464, '\p{Is_Script_Extensions=ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Script_Extensions=ugaritic}', "");
    Expect(1, 66464, '\P{Is_Script_Extensions=ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Script_Extensions=ugaritic}', "");
    Expect(1, 66463, '\p{Is_Script_Extensions= Ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Script_Extensions= Ugaritic}', "");
    Expect(0, 66463, '\P{Is_Script_Extensions= Ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Script_Extensions= Ugaritic}', "");
    Expect(0, 66464, '\p{Is_Script_Extensions= Ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Script_Extensions= Ugaritic}', "");
    Expect(1, 66464, '\P{Is_Script_Extensions= Ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Script_Extensions= Ugaritic}', "");
    Error('\p{Is_Scx=		Ugar/a/}');
    Error('\P{Is_Scx=		Ugar/a/}');
    Expect(1, 66463, '\p{Is_Scx:   ugar}', "");
    Expect(0, 66463, '\p{^Is_Scx:   ugar}', "");
    Expect(0, 66463, '\P{Is_Scx:   ugar}', "");
    Expect(1, 66463, '\P{^Is_Scx:   ugar}', "");
    Expect(0, 66464, '\p{Is_Scx:   ugar}', "");
    Expect(1, 66464, '\p{^Is_Scx:   ugar}', "");
    Expect(1, 66464, '\P{Is_Scx:   ugar}', "");
    Expect(0, 66464, '\P{^Is_Scx:   ugar}', "");
    Expect(1, 66463, '\p{Is_Scx=  Ugar}', "");
    Expect(0, 66463, '\p{^Is_Scx=  Ugar}', "");
    Expect(0, 66463, '\P{Is_Scx=  Ugar}', "");
    Expect(1, 66463, '\P{^Is_Scx=  Ugar}', "");
    Expect(0, 66464, '\p{Is_Scx=  Ugar}', "");
    Expect(1, 66464, '\p{^Is_Scx=  Ugar}', "");
    Expect(1, 66464, '\P{Is_Scx=  Ugar}', "");
    Expect(0, 66464, '\P{^Is_Scx=  Ugar}', "");
    Error('\p{Script_Extensions=/a/--vai}');
    Error('\P{Script_Extensions=/a/--vai}');
    Expect(1, 42539, '\p{Script_Extensions=vai}', "");
    Expect(0, 42539, '\p{^Script_Extensions=vai}', "");
    Expect(0, 42539, '\P{Script_Extensions=vai}', "");
    Expect(1, 42539, '\P{^Script_Extensions=vai}', "");
    Expect(0, 42540, '\p{Script_Extensions=vai}', "");
    Expect(1, 42540, '\p{^Script_Extensions=vai}', "");
    Expect(1, 42540, '\P{Script_Extensions=vai}', "");
    Expect(0, 42540, '\P{^Script_Extensions=vai}', "");
    Expect(1, 42539, '\p{Script_Extensions=_	vai}', "");
    Expect(0, 42539, '\p{^Script_Extensions=_	vai}', "");
    Expect(0, 42539, '\P{Script_Extensions=_	vai}', "");
    Expect(1, 42539, '\P{^Script_Extensions=_	vai}', "");
    Expect(0, 42540, '\p{Script_Extensions=_	vai}', "");
    Expect(1, 42540, '\p{^Script_Extensions=_	vai}', "");
    Expect(1, 42540, '\P{Script_Extensions=_	vai}', "");
    Expect(0, 42540, '\P{^Script_Extensions=_	vai}', "");
    Error('\p{Scx=--VAII:=}');
    Error('\P{Scx=--VAII:=}');
    Expect(1, 42539, '\p{Scx=vaii}', "");
    Expect(0, 42539, '\p{^Scx=vaii}', "");
    Expect(0, 42539, '\P{Scx=vaii}', "");
    Expect(1, 42539, '\P{^Scx=vaii}', "");
    Expect(0, 42540, '\p{Scx=vaii}', "");
    Expect(1, 42540, '\p{^Scx=vaii}', "");
    Expect(1, 42540, '\P{Scx=vaii}', "");
    Expect(0, 42540, '\P{^Scx=vaii}', "");
    Expect(1, 42539, '\p{Scx=-VAII}', "");
    Expect(0, 42539, '\p{^Scx=-VAII}', "");
    Expect(0, 42539, '\P{Scx=-VAII}', "");
    Expect(1, 42539, '\P{^Scx=-VAII}', "");
    Expect(0, 42540, '\p{Scx=-VAII}', "");
    Expect(1, 42540, '\p{^Scx=-VAII}', "");
    Expect(1, 42540, '\P{Scx=-VAII}', "");
    Expect(0, 42540, '\P{^Scx=-VAII}', "");
    Error('\p{Is_Script_Extensions=  vai/a/}');
    Error('\P{Is_Script_Extensions=  vai/a/}');
    Expect(1, 42539, '\p{Is_Script_Extensions=vai}', "");
    Expect(0, 42539, '\p{^Is_Script_Extensions=vai}', "");
    Expect(0, 42539, '\P{Is_Script_Extensions=vai}', "");
    Expect(1, 42539, '\P{^Is_Script_Extensions=vai}', "");
    Expect(0, 42540, '\p{Is_Script_Extensions=vai}', "");
    Expect(1, 42540, '\p{^Is_Script_Extensions=vai}', "");
    Expect(1, 42540, '\P{Is_Script_Extensions=vai}', "");
    Expect(0, 42540, '\P{^Is_Script_Extensions=vai}', "");
    Expect(1, 42539, '\p{Is_Script_Extensions=		Vai}', "");
    Expect(0, 42539, '\p{^Is_Script_Extensions=		Vai}', "");
    Expect(0, 42539, '\P{Is_Script_Extensions=		Vai}', "");
    Expect(1, 42539, '\P{^Is_Script_Extensions=		Vai}', "");
    Expect(0, 42540, '\p{Is_Script_Extensions=		Vai}', "");
    Expect(1, 42540, '\p{^Is_Script_Extensions=		Vai}', "");
    Expect(1, 42540, '\P{Is_Script_Extensions=		Vai}', "");
    Expect(0, 42540, '\P{^Is_Script_Extensions=		Vai}', "");
    Error('\p{Is_Scx= 	VAII:=}');
    Error('\P{Is_Scx= 	VAII:=}');
    Expect(1, 42539, '\p{Is_Scx=vaii}', "");
    Expect(0, 42539, '\p{^Is_Scx=vaii}', "");
    Expect(0, 42539, '\P{Is_Scx=vaii}', "");
    Expect(1, 42539, '\P{^Is_Scx=vaii}', "");
    Expect(0, 42540, '\p{Is_Scx=vaii}', "");
    Expect(1, 42540, '\p{^Is_Scx=vaii}', "");
    Expect(1, 42540, '\P{Is_Scx=vaii}', "");
    Expect(0, 42540, '\P{^Is_Scx=vaii}', "");
    Expect(1, 42539, '\p{Is_Scx=		VAII}', "");
    Expect(0, 42539, '\p{^Is_Scx=		VAII}', "");
    Expect(0, 42539, '\P{Is_Scx=		VAII}', "");
    Expect(1, 42539, '\P{^Is_Scx=		VAII}', "");
    Expect(0, 42540, '\p{Is_Scx=		VAII}', "");
    Expect(1, 42540, '\p{^Is_Scx=		VAII}', "");
    Expect(1, 42540, '\P{Is_Scx=		VAII}', "");
    Expect(0, 42540, '\P{^Is_Scx=		VAII}', "");
    Error('\p{Script_Extensions=  Warang_Citi:=}');
    Error('\P{Script_Extensions=  Warang_Citi:=}');
    Expect(1, 71935, '\p{Script_Extensions=warangciti}', "");
    Expect(0, 71935, '\p{^Script_Extensions=warangciti}', "");
    Expect(0, 71935, '\P{Script_Extensions=warangciti}', "");
    Expect(1, 71935, '\P{^Script_Extensions=warangciti}', "");
    Expect(0, 71936, '\p{Script_Extensions=warangciti}', "");
    Expect(1, 71936, '\p{^Script_Extensions=warangciti}', "");
    Expect(1, 71936, '\P{Script_Extensions=warangciti}', "");
    Expect(0, 71936, '\P{^Script_Extensions=warangciti}', "");
    Expect(1, 71935, '\p{Script_Extensions=__Warang_CITI}', "");
    Expect(0, 71935, '\p{^Script_Extensions=__Warang_CITI}', "");
    Expect(0, 71935, '\P{Script_Extensions=__Warang_CITI}', "");
    Expect(1, 71935, '\P{^Script_Extensions=__Warang_CITI}', "");
    Expect(0, 71936, '\p{Script_Extensions=__Warang_CITI}', "");
    Expect(1, 71936, '\p{^Script_Extensions=__Warang_CITI}', "");
    Expect(1, 71936, '\P{Script_Extensions=__Warang_CITI}', "");
    Expect(0, 71936, '\P{^Script_Extensions=__Warang_CITI}', "");
    Error('\p{Scx=_-Wara:=}');
    Error('\P{Scx=_-Wara:=}');
    Expect(1, 71935, '\p{Scx=wara}', "");
    Expect(0, 71935, '\p{^Scx=wara}', "");
    Expect(0, 71935, '\P{Scx=wara}', "");
    Expect(1, 71935, '\P{^Scx=wara}', "");
    Expect(0, 71936, '\p{Scx=wara}', "");
    Expect(1, 71936, '\p{^Scx=wara}', "");
    Expect(1, 71936, '\P{Scx=wara}', "");
    Expect(0, 71936, '\P{^Scx=wara}', "");
    Expect(1, 71935, '\p{Scx=	wara}', "");
    Expect(0, 71935, '\p{^Scx=	wara}', "");
    Expect(0, 71935, '\P{Scx=	wara}', "");
    Expect(1, 71935, '\P{^Scx=	wara}', "");
    Expect(0, 71936, '\p{Scx=	wara}', "");
    Expect(1, 71936, '\p{^Scx=	wara}', "");
    Expect(1, 71936, '\P{Scx=	wara}', "");
    Expect(0, 71936, '\P{^Scx=	wara}', "");
    Error('\p{Is_Script_Extensions=:=  Warang_Citi}');
    Error('\P{Is_Script_Extensions=:=  Warang_Citi}');
    Expect(1, 71935, '\p{Is_Script_Extensions=warangciti}', "");
    Expect(0, 71935, '\p{^Is_Script_Extensions=warangciti}', "");
    Expect(0, 71935, '\P{Is_Script_Extensions=warangciti}', "");
    Expect(1, 71935, '\P{^Is_Script_Extensions=warangciti}', "");
    Expect(0, 71936, '\p{Is_Script_Extensions=warangciti}', "");
    Expect(1, 71936, '\p{^Is_Script_Extensions=warangciti}', "");
    Expect(1, 71936, '\P{Is_Script_Extensions=warangciti}', "");
    Expect(0, 71936, '\P{^Is_Script_Extensions=warangciti}', "");
    Expect(1, 71935, '\p{Is_Script_Extensions=__WARANG_CITI}', "");
    Expect(0, 71935, '\p{^Is_Script_Extensions=__WARANG_CITI}', "");
    Expect(0, 71935, '\P{Is_Script_Extensions=__WARANG_CITI}', "");
    Expect(1, 71935, '\P{^Is_Script_Extensions=__WARANG_CITI}', "");
    Expect(0, 71936, '\p{Is_Script_Extensions=__WARANG_CITI}', "");
    Expect(1, 71936, '\p{^Is_Script_Extensions=__WARANG_CITI}', "");
    Expect(1, 71936, '\P{Is_Script_Extensions=__WARANG_CITI}', "");
    Expect(0, 71936, '\P{^Is_Script_Extensions=__WARANG_CITI}', "");
    Error('\p{Is_Scx= /a/wara}');
    Error('\P{Is_Scx= /a/wara}');
    Expect(1, 71935, '\p{Is_Scx=wara}', "");
    Expect(0, 71935, '\p{^Is_Scx=wara}', "");
    Expect(0, 71935, '\P{Is_Scx=wara}', "");
    Expect(1, 71935, '\P{^Is_Scx=wara}', "");
    Expect(0, 71936, '\p{Is_Scx=wara}', "");
    Expect(1, 71936, '\p{^Is_Scx=wara}', "");
    Expect(1, 71936, '\P{Is_Scx=wara}', "");
    Expect(0, 71936, '\P{^Is_Scx=wara}', "");
    Expect(1, 71935, '\p{Is_Scx=  Wara}', "");
    Expect(0, 71935, '\p{^Is_Scx=  Wara}', "");
    Expect(0, 71935, '\P{Is_Scx=  Wara}', "");
    Expect(1, 71935, '\P{^Is_Scx=  Wara}', "");
    Expect(0, 71936, '\p{Is_Scx=  Wara}', "");
    Expect(1, 71936, '\p{^Is_Scx=  Wara}', "");
    Expect(1, 71936, '\P{Is_Scx=  Wara}', "");
    Expect(0, 71936, '\P{^Is_Scx=  Wara}', "");
    Error('\p{Script_Extensions:	/a/Old_Persian}');
    Error('\P{Script_Extensions:	/a/Old_Persian}');
    Expect(1, 66517, '\p{Script_Extensions=oldpersian}', "");
    Expect(0, 66517, '\p{^Script_Extensions=oldpersian}', "");
    Expect(0, 66517, '\P{Script_Extensions=oldpersian}', "");
    Expect(1, 66517, '\P{^Script_Extensions=oldpersian}', "");
    Expect(0, 66518, '\p{Script_Extensions=oldpersian}', "");
    Expect(1, 66518, '\p{^Script_Extensions=oldpersian}', "");
    Expect(1, 66518, '\P{Script_Extensions=oldpersian}', "");
    Expect(0, 66518, '\P{^Script_Extensions=oldpersian}', "");
    Expect(1, 66517, '\p{Script_Extensions=	_old_PERSIAN}', "");
    Expect(0, 66517, '\p{^Script_Extensions=	_old_PERSIAN}', "");
    Expect(0, 66517, '\P{Script_Extensions=	_old_PERSIAN}', "");
    Expect(1, 66517, '\P{^Script_Extensions=	_old_PERSIAN}', "");
    Expect(0, 66518, '\p{Script_Extensions=	_old_PERSIAN}', "");
    Expect(1, 66518, '\p{^Script_Extensions=	_old_PERSIAN}', "");
    Expect(1, 66518, '\P{Script_Extensions=	_old_PERSIAN}', "");
    Expect(0, 66518, '\P{^Script_Extensions=	_old_PERSIAN}', "");
    Error('\p{Scx= _Xpeo/a/}');
    Error('\P{Scx= _Xpeo/a/}');
    Expect(1, 66517, '\p{Scx=xpeo}', "");
    Expect(0, 66517, '\p{^Scx=xpeo}', "");
    Expect(0, 66517, '\P{Scx=xpeo}', "");
    Expect(1, 66517, '\P{^Scx=xpeo}', "");
    Expect(0, 66518, '\p{Scx=xpeo}', "");
    Expect(1, 66518, '\p{^Scx=xpeo}', "");
    Expect(1, 66518, '\P{Scx=xpeo}', "");
    Expect(0, 66518, '\P{^Scx=xpeo}', "");
    Expect(1, 66517, '\p{Scx=-_Xpeo}', "");
    Expect(0, 66517, '\p{^Scx=-_Xpeo}', "");
    Expect(0, 66517, '\P{Scx=-_Xpeo}', "");
    Expect(1, 66517, '\P{^Scx=-_Xpeo}', "");
    Expect(0, 66518, '\p{Scx=-_Xpeo}', "");
    Expect(1, 66518, '\p{^Scx=-_Xpeo}', "");
    Expect(1, 66518, '\P{Scx=-_Xpeo}', "");
    Expect(0, 66518, '\P{^Scx=-_Xpeo}', "");
    Error('\p{Is_Script_Extensions=:=	 Old_Persian}');
    Error('\P{Is_Script_Extensions=:=	 Old_Persian}');
    Expect(1, 66517, '\p{Is_Script_Extensions=oldpersian}', "");
    Expect(0, 66517, '\p{^Is_Script_Extensions=oldpersian}', "");
    Expect(0, 66517, '\P{Is_Script_Extensions=oldpersian}', "");
    Expect(1, 66517, '\P{^Is_Script_Extensions=oldpersian}', "");
    Expect(0, 66518, '\p{Is_Script_Extensions=oldpersian}', "");
    Expect(1, 66518, '\p{^Is_Script_Extensions=oldpersian}', "");
    Expect(1, 66518, '\P{Is_Script_Extensions=oldpersian}', "");
    Expect(0, 66518, '\P{^Is_Script_Extensions=oldpersian}', "");
    Expect(1, 66517, '\p{Is_Script_Extensions=  Old_Persian}', "");
    Expect(0, 66517, '\p{^Is_Script_Extensions=  Old_Persian}', "");
    Expect(0, 66517, '\P{Is_Script_Extensions=  Old_Persian}', "");
    Expect(1, 66517, '\P{^Is_Script_Extensions=  Old_Persian}', "");
    Expect(0, 66518, '\p{Is_Script_Extensions=  Old_Persian}', "");
    Expect(1, 66518, '\p{^Is_Script_Extensions=  Old_Persian}', "");
    Expect(1, 66518, '\P{Is_Script_Extensions=  Old_Persian}', "");
    Expect(0, 66518, '\P{^Is_Script_Extensions=  Old_Persian}', "");
    Error('\p{Is_Scx=/a/__XPEO}');
    Error('\P{Is_Scx=/a/__XPEO}');
    Expect(1, 66517, '\p{Is_Scx=xpeo}', "");
    Expect(0, 66517, '\p{^Is_Scx=xpeo}', "");
    Expect(0, 66517, '\P{Is_Scx=xpeo}', "");
    Expect(1, 66517, '\P{^Is_Scx=xpeo}', "");
    Expect(0, 66518, '\p{Is_Scx=xpeo}', "");
    Expect(1, 66518, '\p{^Is_Scx=xpeo}', "");
    Expect(1, 66518, '\P{Is_Scx=xpeo}', "");
    Expect(0, 66518, '\P{^Is_Scx=xpeo}', "");
    Expect(1, 66517, '\p{Is_Scx=	xpeo}', "");
    Expect(0, 66517, '\p{^Is_Scx=	xpeo}', "");
    Expect(0, 66517, '\P{Is_Scx=	xpeo}', "");
    Expect(1, 66517, '\P{^Is_Scx=	xpeo}', "");
    Expect(0, 66518, '\p{Is_Scx=	xpeo}', "");
    Expect(1, 66518, '\p{^Is_Scx=	xpeo}', "");
    Expect(1, 66518, '\P{Is_Scx=	xpeo}', "");
    Expect(0, 66518, '\P{^Is_Scx=	xpeo}', "");
    Error('\p{Script_Extensions=_	CUNEIFORM/a/}');
    Error('\P{Script_Extensions=_	CUNEIFORM/a/}');
    Expect(1, 75075, '\p{Script_Extensions=cuneiform}', "");
    Expect(0, 75075, '\p{^Script_Extensions=cuneiform}', "");
    Expect(0, 75075, '\P{Script_Extensions=cuneiform}', "");
    Expect(1, 75075, '\P{^Script_Extensions=cuneiform}', "");
    Expect(0, 75076, '\p{Script_Extensions=cuneiform}', "");
    Expect(1, 75076, '\p{^Script_Extensions=cuneiform}', "");
    Expect(1, 75076, '\P{Script_Extensions=cuneiform}', "");
    Expect(0, 75076, '\P{^Script_Extensions=cuneiform}', "");
    Expect(1, 75075, '\p{Script_Extensions=_ Cuneiform}', "");
    Expect(0, 75075, '\p{^Script_Extensions=_ Cuneiform}', "");
    Expect(0, 75075, '\P{Script_Extensions=_ Cuneiform}', "");
    Expect(1, 75075, '\P{^Script_Extensions=_ Cuneiform}', "");
    Expect(0, 75076, '\p{Script_Extensions=_ Cuneiform}', "");
    Expect(1, 75076, '\p{^Script_Extensions=_ Cuneiform}', "");
    Expect(1, 75076, '\P{Script_Extensions=_ Cuneiform}', "");
    Expect(0, 75076, '\P{^Script_Extensions=_ Cuneiform}', "");
    Error('\p{Scx=/a/_Xsux}');
    Error('\P{Scx=/a/_Xsux}');
    Expect(1, 75075, '\p{Scx=xsux}', "");
    Expect(0, 75075, '\p{^Scx=xsux}', "");
    Expect(0, 75075, '\P{Scx=xsux}', "");
    Expect(1, 75075, '\P{^Scx=xsux}', "");
    Expect(0, 75076, '\p{Scx=xsux}', "");
    Expect(1, 75076, '\p{^Scx=xsux}', "");
    Expect(1, 75076, '\P{Scx=xsux}', "");
    Expect(0, 75076, '\P{^Scx=xsux}', "");
    Expect(1, 75075, '\p{Scx= xsux}', "");
    Expect(0, 75075, '\p{^Scx= xsux}', "");
    Expect(0, 75075, '\P{Scx= xsux}', "");
    Expect(1, 75075, '\P{^Scx= xsux}', "");
    Expect(0, 75076, '\p{Scx= xsux}', "");
    Expect(1, 75076, '\p{^Scx= xsux}', "");
    Expect(1, 75076, '\P{Scx= xsux}', "");
    Expect(0, 75076, '\P{^Scx= xsux}', "");
    Error('\p{Is_Script_Extensions=:=-	cuneiform}');
    Error('\P{Is_Script_Extensions=:=-	cuneiform}');
    Expect(1, 75075, '\p{Is_Script_Extensions=cuneiform}', "");
    Expect(0, 75075, '\p{^Is_Script_Extensions=cuneiform}', "");
    Expect(0, 75075, '\P{Is_Script_Extensions=cuneiform}', "");
    Expect(1, 75075, '\P{^Is_Script_Extensions=cuneiform}', "");
    Expect(0, 75076, '\p{Is_Script_Extensions=cuneiform}', "");
    Expect(1, 75076, '\p{^Is_Script_Extensions=cuneiform}', "");
    Expect(1, 75076, '\P{Is_Script_Extensions=cuneiform}', "");
    Expect(0, 75076, '\P{^Is_Script_Extensions=cuneiform}', "");
    Expect(1, 75075, '\p{Is_Script_Extensions=--CUNEIFORM}', "");
    Expect(0, 75075, '\p{^Is_Script_Extensions=--CUNEIFORM}', "");
    Expect(0, 75075, '\P{Is_Script_Extensions=--CUNEIFORM}', "");
    Expect(1, 75075, '\P{^Is_Script_Extensions=--CUNEIFORM}', "");
    Expect(0, 75076, '\p{Is_Script_Extensions=--CUNEIFORM}', "");
    Expect(1, 75076, '\p{^Is_Script_Extensions=--CUNEIFORM}', "");
    Expect(1, 75076, '\P{Is_Script_Extensions=--CUNEIFORM}', "");
    Expect(0, 75076, '\P{^Is_Script_Extensions=--CUNEIFORM}', "");
    Error('\p{Is_Scx=:=	-Xsux}');
    Error('\P{Is_Scx=:=	-Xsux}');
    Expect(1, 75075, '\p{Is_Scx=xsux}', "");
    Expect(0, 75075, '\p{^Is_Scx=xsux}', "");
    Expect(0, 75075, '\P{Is_Scx=xsux}', "");
    Expect(1, 75075, '\P{^Is_Scx=xsux}', "");
    Expect(0, 75076, '\p{Is_Scx=xsux}', "");
    Expect(1, 75076, '\p{^Is_Scx=xsux}', "");
    Expect(1, 75076, '\P{Is_Scx=xsux}', "");
    Expect(0, 75076, '\P{^Is_Scx=xsux}', "");
    Expect(1, 75075, '\p{Is_Scx= _XSUX}', "");
    Expect(0, 75075, '\p{^Is_Scx= _XSUX}', "");
    Expect(0, 75075, '\P{Is_Scx= _XSUX}', "");
    Expect(1, 75075, '\P{^Is_Scx= _XSUX}', "");
    Expect(0, 75076, '\p{Is_Scx= _XSUX}', "");
    Expect(1, 75076, '\p{^Is_Scx= _XSUX}', "");
    Expect(1, 75076, '\P{Is_Scx= _XSUX}', "");
    Expect(0, 75076, '\P{^Is_Scx= _XSUX}', "");
    Error('\p{Script_Extensions=/a/Yi}');
    Error('\P{Script_Extensions=/a/Yi}');
    Expect(1, 65381, '\p{Script_Extensions=yi}', "");
    Expect(0, 65381, '\p{^Script_Extensions=yi}', "");
    Expect(0, 65381, '\P{Script_Extensions=yi}', "");
    Expect(1, 65381, '\P{^Script_Extensions=yi}', "");
    Expect(0, 65382, '\p{Script_Extensions=yi}', "");
    Expect(1, 65382, '\p{^Script_Extensions=yi}', "");
    Expect(1, 65382, '\P{Script_Extensions=yi}', "");
    Expect(0, 65382, '\P{^Script_Extensions=yi}', "");
    Expect(1, 65381, '\p{Script_Extensions=_	Yi}', "");
    Expect(0, 65381, '\p{^Script_Extensions=_	Yi}', "");
    Expect(0, 65381, '\P{Script_Extensions=_	Yi}', "");
    Expect(1, 65381, '\P{^Script_Extensions=_	Yi}', "");
    Expect(0, 65382, '\p{Script_Extensions=_	Yi}', "");
    Expect(1, 65382, '\p{^Script_Extensions=_	Yi}', "");
    Expect(1, 65382, '\P{Script_Extensions=_	Yi}', "");
    Expect(0, 65382, '\P{^Script_Extensions=_	Yi}', "");
    Error('\p{Scx=  Yiii:=}');
    Error('\P{Scx=  Yiii:=}');
    Expect(1, 65381, '\p{Scx=yiii}', "");
    Expect(0, 65381, '\p{^Scx=yiii}', "");
    Expect(0, 65381, '\P{Scx=yiii}', "");
    Expect(1, 65381, '\P{^Scx=yiii}', "");
    Expect(0, 65382, '\p{Scx=yiii}', "");
    Expect(1, 65382, '\p{^Scx=yiii}', "");
    Expect(1, 65382, '\P{Scx=yiii}', "");
    Expect(0, 65382, '\P{^Scx=yiii}', "");
    Expect(1, 65381, '\p{Scx=_-Yiii}', "");
    Expect(0, 65381, '\p{^Scx=_-Yiii}', "");
    Expect(0, 65381, '\P{Scx=_-Yiii}', "");
    Expect(1, 65381, '\P{^Scx=_-Yiii}', "");
    Expect(0, 65382, '\p{Scx=_-Yiii}', "");
    Expect(1, 65382, '\p{^Scx=_-Yiii}', "");
    Expect(1, 65382, '\P{Scx=_-Yiii}', "");
    Expect(0, 65382, '\P{^Scx=_-Yiii}', "");
    Error('\p{Is_Script_Extensions= :=YI}');
    Error('\P{Is_Script_Extensions= :=YI}');
    Expect(1, 65381, '\p{Is_Script_Extensions=yi}', "");
    Expect(0, 65381, '\p{^Is_Script_Extensions=yi}', "");
    Expect(0, 65381, '\P{Is_Script_Extensions=yi}', "");
    Expect(1, 65381, '\P{^Is_Script_Extensions=yi}', "");
    Expect(0, 65382, '\p{Is_Script_Extensions=yi}', "");
    Expect(1, 65382, '\p{^Is_Script_Extensions=yi}', "");
    Expect(1, 65382, '\P{Is_Script_Extensions=yi}', "");
    Expect(0, 65382, '\P{^Is_Script_Extensions=yi}', "");
    Expect(1, 65381, '\p{Is_Script_Extensions=	_Yi}', "");
    Expect(0, 65381, '\p{^Is_Script_Extensions=	_Yi}', "");
    Expect(0, 65381, '\P{Is_Script_Extensions=	_Yi}', "");
    Expect(1, 65381, '\P{^Is_Script_Extensions=	_Yi}', "");
    Expect(0, 65382, '\p{Is_Script_Extensions=	_Yi}', "");
    Expect(1, 65382, '\p{^Is_Script_Extensions=	_Yi}', "");
    Expect(1, 65382, '\P{Is_Script_Extensions=	_Yi}', "");
    Expect(0, 65382, '\P{^Is_Script_Extensions=	_Yi}', "");
    Error('\p{Is_Scx=- Yiii:=}');
    Error('\P{Is_Scx=- Yiii:=}');
    Expect(1, 65381, '\p{Is_Scx=yiii}', "");
    Expect(0, 65381, '\p{^Is_Scx=yiii}', "");
    Expect(0, 65381, '\P{Is_Scx=yiii}', "");
    Expect(1, 65381, '\P{^Is_Scx=yiii}', "");
    Expect(0, 65382, '\p{Is_Scx=yiii}', "");
    Expect(1, 65382, '\p{^Is_Scx=yiii}', "");
    Expect(1, 65382, '\P{Is_Scx=yiii}', "");
    Expect(0, 65382, '\P{^Is_Scx=yiii}', "");
    Expect(1, 65381, '\p{Is_Scx: - yiii}', "");
    Expect(0, 65381, '\p{^Is_Scx: - yiii}', "");
    Expect(0, 65381, '\P{Is_Scx: - yiii}', "");
    Expect(1, 65381, '\P{^Is_Scx: - yiii}', "");
    Expect(0, 65382, '\p{Is_Scx: - yiii}', "");
    Expect(1, 65382, '\p{^Is_Scx: - yiii}', "");
    Expect(1, 65382, '\P{Is_Scx: - yiii}', "");
    Expect(0, 65382, '\P{^Is_Scx: - yiii}', "");
    Error('\p{Script_Extensions=:=-	zanabazar_Square}');
    Error('\P{Script_Extensions=:=-	zanabazar_Square}');
    Expect(1, 72263, '\p{Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72263, '\p{^Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72263, '\P{Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72263, '\P{^Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72264, '\p{Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72264, '\p{^Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72264, '\P{Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72264, '\P{^Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72263, '\p{Script_Extensions=_zanabazar_Square}', "");
    Expect(0, 72263, '\p{^Script_Extensions=_zanabazar_Square}', "");
    Expect(0, 72263, '\P{Script_Extensions=_zanabazar_Square}', "");
    Expect(1, 72263, '\P{^Script_Extensions=_zanabazar_Square}', "");
    Expect(0, 72264, '\p{Script_Extensions=_zanabazar_Square}', "");
    Expect(1, 72264, '\p{^Script_Extensions=_zanabazar_Square}', "");
    Expect(1, 72264, '\P{Script_Extensions=_zanabazar_Square}', "");
    Expect(0, 72264, '\P{^Script_Extensions=_zanabazar_Square}', "");
    Error('\p{Scx=/a/__Zanb}');
    Error('\P{Scx=/a/__Zanb}');
    Expect(1, 72263, '\p{Scx=zanb}', "");
    Expect(0, 72263, '\p{^Scx=zanb}', "");
    Expect(0, 72263, '\P{Scx=zanb}', "");
    Expect(1, 72263, '\P{^Scx=zanb}', "");
    Expect(0, 72264, '\p{Scx=zanb}', "");
    Expect(1, 72264, '\p{^Scx=zanb}', "");
    Expect(1, 72264, '\P{Scx=zanb}', "");
    Expect(0, 72264, '\P{^Scx=zanb}', "");
    Expect(1, 72263, '\p{Scx=__Zanb}', "");
    Expect(0, 72263, '\p{^Scx=__Zanb}', "");
    Expect(0, 72263, '\P{Scx=__Zanb}', "");
    Expect(1, 72263, '\P{^Scx=__Zanb}', "");
    Expect(0, 72264, '\p{Scx=__Zanb}', "");
    Expect(1, 72264, '\p{^Scx=__Zanb}', "");
    Expect(1, 72264, '\P{Scx=__Zanb}', "");
    Expect(0, 72264, '\P{^Scx=__Zanb}', "");
    Error('\p{Is_Script_Extensions=	:=Zanabazar_Square}');
    Error('\P{Is_Script_Extensions=	:=Zanabazar_Square}');
    Expect(1, 72263, '\p{Is_Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72263, '\p{^Is_Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72263, '\P{Is_Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72263, '\P{^Is_Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72264, '\p{Is_Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72264, '\p{^Is_Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72264, '\P{Is_Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72264, '\P{^Is_Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72263, '\p{Is_Script_Extensions=	-zanabazar_SQUARE}', "");
    Expect(0, 72263, '\p{^Is_Script_Extensions=	-zanabazar_SQUARE}', "");
    Expect(0, 72263, '\P{Is_Script_Extensions=	-zanabazar_SQUARE}', "");
    Expect(1, 72263, '\P{^Is_Script_Extensions=	-zanabazar_SQUARE}', "");
    Expect(0, 72264, '\p{Is_Script_Extensions=	-zanabazar_SQUARE}', "");
    Expect(1, 72264, '\p{^Is_Script_Extensions=	-zanabazar_SQUARE}', "");
    Expect(1, 72264, '\P{Is_Script_Extensions=	-zanabazar_SQUARE}', "");
    Expect(0, 72264, '\P{^Is_Script_Extensions=	-zanabazar_SQUARE}', "");
    Error('\p{Is_Scx= -ZANB/a/}');
    Error('\P{Is_Scx= -ZANB/a/}');
    Expect(1, 72263, '\p{Is_Scx=zanb}', "");
    Expect(0, 72263, '\p{^Is_Scx=zanb}', "");
    Expect(0, 72263, '\P{Is_Scx=zanb}', "");
    Expect(1, 72263, '\P{^Is_Scx=zanb}', "");
    Expect(0, 72264, '\p{Is_Scx=zanb}', "");
    Expect(1, 72264, '\p{^Is_Scx=zanb}', "");
    Expect(1, 72264, '\P{Is_Scx=zanb}', "");
    Expect(0, 72264, '\P{^Is_Scx=zanb}', "");
    Expect(1, 72263, '\p{Is_Scx=	zanb}', "");
    Expect(0, 72263, '\p{^Is_Scx=	zanb}', "");
    Expect(0, 72263, '\P{Is_Scx=	zanb}', "");
    Expect(1, 72263, '\P{^Is_Scx=	zanb}', "");
    Expect(0, 72264, '\p{Is_Scx=	zanb}', "");
    Expect(1, 72264, '\p{^Is_Scx=	zanb}', "");
    Expect(1, 72264, '\P{Is_Scx=	zanb}', "");
    Expect(0, 72264, '\P{^Is_Scx=	zanb}', "");
    Error('\p{Script_Extensions=_:=INHERITED}');
    Error('\P{Script_Extensions=_:=INHERITED}');
    Expect(1, 917999, '\p{Script_Extensions=inherited}', "");
    Expect(0, 917999, '\p{^Script_Extensions=inherited}', "");
    Expect(0, 917999, '\P{Script_Extensions=inherited}', "");
    Expect(1, 917999, '\P{^Script_Extensions=inherited}', "");
    Expect(0, 918000, '\p{Script_Extensions=inherited}', "");
    Expect(1, 918000, '\p{^Script_Extensions=inherited}', "");
    Expect(1, 918000, '\P{Script_Extensions=inherited}', "");
    Expect(0, 918000, '\P{^Script_Extensions=inherited}', "");
    Expect(1, 917999, '\p{Script_Extensions=		INHERITED}', "");
    Expect(0, 917999, '\p{^Script_Extensions=		INHERITED}', "");
    Expect(0, 917999, '\P{Script_Extensions=		INHERITED}', "");
    Expect(1, 917999, '\P{^Script_Extensions=		INHERITED}', "");
    Expect(0, 918000, '\p{Script_Extensions=		INHERITED}', "");
    Expect(1, 918000, '\p{^Script_Extensions=		INHERITED}', "");
    Expect(1, 918000, '\P{Script_Extensions=		INHERITED}', "");
    Expect(0, 918000, '\P{^Script_Extensions=		INHERITED}', "");
    Error('\p{Scx=_:=Zinh}');
    Error('\P{Scx=_:=Zinh}');
    Expect(1, 917999, '\p{Scx=zinh}', "");
    Expect(0, 917999, '\p{^Scx=zinh}', "");
    Expect(0, 917999, '\P{Scx=zinh}', "");
    Expect(1, 917999, '\P{^Scx=zinh}', "");
    Expect(0, 918000, '\p{Scx=zinh}', "");
    Expect(1, 918000, '\p{^Scx=zinh}', "");
    Expect(1, 918000, '\P{Scx=zinh}', "");
    Expect(0, 918000, '\P{^Scx=zinh}', "");
    Expect(1, 917999, '\p{Scx:	_ZINH}', "");
    Expect(0, 917999, '\p{^Scx:	_ZINH}', "");
    Expect(0, 917999, '\P{Scx:	_ZINH}', "");
    Expect(1, 917999, '\P{^Scx:	_ZINH}', "");
    Expect(0, 918000, '\p{Scx:	_ZINH}', "");
    Expect(1, 918000, '\p{^Scx:	_ZINH}', "");
    Expect(1, 918000, '\P{Scx:	_ZINH}', "");
    Expect(0, 918000, '\P{^Scx:	_ZINH}', "");
    Error('\p{Is_Script_Extensions=:=-QAAI}');
    Error('\P{Is_Script_Extensions=:=-QAAI}');
    Expect(1, 917999, '\p{Is_Script_Extensions=qaai}', "");
    Expect(0, 917999, '\p{^Is_Script_Extensions=qaai}', "");
    Expect(0, 917999, '\P{Is_Script_Extensions=qaai}', "");
    Expect(1, 917999, '\P{^Is_Script_Extensions=qaai}', "");
    Expect(0, 918000, '\p{Is_Script_Extensions=qaai}', "");
    Expect(1, 918000, '\p{^Is_Script_Extensions=qaai}', "");
    Expect(1, 918000, '\P{Is_Script_Extensions=qaai}', "");
    Expect(0, 918000, '\P{^Is_Script_Extensions=qaai}', "");
    Error('\p{Is_Scx=_/a/Inherited}');
    Error('\P{Is_Scx=_/a/Inherited}');
    Expect(1, 917999, '\p{Is_Scx=inherited}', "");
    Expect(0, 917999, '\p{^Is_Scx=inherited}', "");
    Expect(0, 917999, '\P{Is_Scx=inherited}', "");
    Expect(1, 917999, '\P{^Is_Scx=inherited}', "");
    Expect(0, 918000, '\p{Is_Scx=inherited}', "");
    Expect(1, 918000, '\p{^Is_Scx=inherited}', "");
    Expect(1, 918000, '\P{Is_Scx=inherited}', "");
    Expect(0, 918000, '\P{^Is_Scx=inherited}', "");
    Expect(1, 917999, '\p{Is_Scx=_-inherited}', "");
    Expect(0, 917999, '\p{^Is_Scx=_-inherited}', "");
    Expect(0, 917999, '\P{Is_Scx=_-inherited}', "");
    Expect(1, 917999, '\P{^Is_Scx=_-inherited}', "");
    Expect(0, 918000, '\p{Is_Scx=_-inherited}', "");
    Expect(1, 918000, '\p{^Is_Scx=_-inherited}', "");
    Expect(1, 918000, '\P{Is_Scx=_-inherited}', "");
    Expect(0, 918000, '\P{^Is_Scx=_-inherited}', "");
    Error('\p{Script_Extensions=:=__common}');
    Error('\P{Script_Extensions=:=__common}');
    Expect(1, 917631, '\p{Script_Extensions=common}', "");
    Expect(0, 917631, '\p{^Script_Extensions=common}', "");
    Expect(0, 917631, '\P{Script_Extensions=common}', "");
    Expect(1, 917631, '\P{^Script_Extensions=common}', "");
    Expect(0, 917632, '\p{Script_Extensions=common}', "");
    Expect(1, 917632, '\p{^Script_Extensions=common}', "");
    Expect(1, 917632, '\P{Script_Extensions=common}', "");
    Expect(0, 917632, '\P{^Script_Extensions=common}', "");
    Expect(1, 917631, '\p{Script_Extensions=		COMMON}', "");
    Expect(0, 917631, '\p{^Script_Extensions=		COMMON}', "");
    Expect(0, 917631, '\P{Script_Extensions=		COMMON}', "");
    Expect(1, 917631, '\P{^Script_Extensions=		COMMON}', "");
    Expect(0, 917632, '\p{Script_Extensions=		COMMON}', "");
    Expect(1, 917632, '\p{^Script_Extensions=		COMMON}', "");
    Expect(1, 917632, '\P{Script_Extensions=		COMMON}', "");
    Expect(0, 917632, '\P{^Script_Extensions=		COMMON}', "");
    Error('\p{Scx= _ZYYY:=}');
    Error('\P{Scx= _ZYYY:=}');
    Expect(1, 917631, '\p{Scx=zyyy}', "");
    Expect(0, 917631, '\p{^Scx=zyyy}', "");
    Expect(0, 917631, '\P{Scx=zyyy}', "");
    Expect(1, 917631, '\P{^Scx=zyyy}', "");
    Expect(0, 917632, '\p{Scx=zyyy}', "");
    Expect(1, 917632, '\p{^Scx=zyyy}', "");
    Expect(1, 917632, '\P{Scx=zyyy}', "");
    Expect(0, 917632, '\P{^Scx=zyyy}', "");
    Expect(1, 917631, '\p{Scx=_-Zyyy}', "");
    Expect(0, 917631, '\p{^Scx=_-Zyyy}', "");
    Expect(0, 917631, '\P{Scx=_-Zyyy}', "");
    Expect(1, 917631, '\P{^Scx=_-Zyyy}', "");
    Expect(0, 917632, '\p{Scx=_-Zyyy}', "");
    Expect(1, 917632, '\p{^Scx=_-Zyyy}', "");
    Expect(1, 917632, '\P{Scx=_-Zyyy}', "");
    Expect(0, 917632, '\P{^Scx=_-Zyyy}', "");
    Error('\p{Is_Script_Extensions=:=_ COMMON}');
    Error('\P{Is_Script_Extensions=:=_ COMMON}');
    Expect(1, 917631, '\p{Is_Script_Extensions=common}', "");
    Expect(0, 917631, '\p{^Is_Script_Extensions=common}', "");
    Expect(0, 917631, '\P{Is_Script_Extensions=common}', "");
    Expect(1, 917631, '\P{^Is_Script_Extensions=common}', "");
    Expect(0, 917632, '\p{Is_Script_Extensions=common}', "");
    Expect(1, 917632, '\p{^Is_Script_Extensions=common}', "");
    Expect(1, 917632, '\P{Is_Script_Extensions=common}', "");
    Expect(0, 917632, '\P{^Is_Script_Extensions=common}', "");
    Expect(1, 917631, '\p{Is_Script_Extensions= 	COMMON}', "");
    Expect(0, 917631, '\p{^Is_Script_Extensions= 	COMMON}', "");
    Expect(0, 917631, '\P{Is_Script_Extensions= 	COMMON}', "");
    Expect(1, 917631, '\P{^Is_Script_Extensions= 	COMMON}', "");
    Expect(0, 917632, '\p{Is_Script_Extensions= 	COMMON}', "");
    Expect(1, 917632, '\p{^Is_Script_Extensions= 	COMMON}', "");
    Expect(1, 917632, '\P{Is_Script_Extensions= 	COMMON}', "");
    Expect(0, 917632, '\P{^Is_Script_Extensions= 	COMMON}', "");
    Error('\p{Is_Scx= /a/ZYYY}');
    Error('\P{Is_Scx= /a/ZYYY}');
    Expect(1, 917631, '\p{Is_Scx=zyyy}', "");
    Expect(0, 917631, '\p{^Is_Scx=zyyy}', "");
    Expect(0, 917631, '\P{Is_Scx=zyyy}', "");
    Expect(1, 917631, '\P{^Is_Scx=zyyy}', "");
    Expect(0, 917632, '\p{Is_Scx=zyyy}', "");
    Expect(1, 917632, '\p{^Is_Scx=zyyy}', "");
    Expect(1, 917632, '\P{Is_Scx=zyyy}', "");
    Expect(0, 917632, '\P{^Is_Scx=zyyy}', "");
    Expect(1, 917631, '\p{Is_Scx= ZYYY}', "");
    Expect(0, 917631, '\p{^Is_Scx= ZYYY}', "");
    Expect(0, 917631, '\P{Is_Scx= ZYYY}', "");
    Expect(1, 917631, '\P{^Is_Scx= ZYYY}', "");
    Expect(0, 917632, '\p{Is_Scx= ZYYY}', "");
    Expect(1, 917632, '\p{^Is_Scx= ZYYY}', "");
    Expect(1, 917632, '\P{Is_Scx= ZYYY}', "");
    Expect(0, 917632, '\P{^Is_Scx= ZYYY}', "");
    Error('\p{Script_Extensions=	 Unknown:=}');
    Error('\P{Script_Extensions=	 Unknown:=}');
    Expect(1, 918000, '\p{Script_Extensions=unknown}', "");
    Expect(0, 918000, '\p{^Script_Extensions=unknown}', "");
    Expect(0, 918000, '\P{Script_Extensions=unknown}', "");
    Expect(1, 918000, '\P{^Script_Extensions=unknown}', "");
    Expect(0, 917999, '\p{Script_Extensions=unknown}', "");
    Expect(1, 917999, '\p{^Script_Extensions=unknown}', "");
    Expect(1, 917999, '\P{Script_Extensions=unknown}', "");
    Expect(0, 917999, '\P{^Script_Extensions=unknown}', "");
    Expect(1, 918000, '\p{Script_Extensions=_Unknown}', "");
    Expect(0, 918000, '\p{^Script_Extensions=_Unknown}', "");
    Expect(0, 918000, '\P{Script_Extensions=_Unknown}', "");
    Expect(1, 918000, '\P{^Script_Extensions=_Unknown}', "");
    Expect(0, 917999, '\p{Script_Extensions=_Unknown}', "");
    Expect(1, 917999, '\p{^Script_Extensions=_Unknown}', "");
    Expect(1, 917999, '\P{Script_Extensions=_Unknown}', "");
    Expect(0, 917999, '\P{^Script_Extensions=_Unknown}', "");
    Error('\p{Scx=--Zzzz:=}');
    Error('\P{Scx=--Zzzz:=}');
    Expect(1, 918000, '\p{Scx=zzzz}', "");
    Expect(0, 918000, '\p{^Scx=zzzz}', "");
    Expect(0, 918000, '\P{Scx=zzzz}', "");
    Expect(1, 918000, '\P{^Scx=zzzz}', "");
    Expect(0, 917999, '\p{Scx=zzzz}', "");
    Expect(1, 917999, '\p{^Scx=zzzz}', "");
    Expect(1, 917999, '\P{Scx=zzzz}', "");
    Expect(0, 917999, '\P{^Scx=zzzz}', "");
    Expect(1, 918000, '\p{Scx=_ZZZZ}', "");
    Expect(0, 918000, '\p{^Scx=_ZZZZ}', "");
    Expect(0, 918000, '\P{Scx=_ZZZZ}', "");
    Expect(1, 918000, '\P{^Scx=_ZZZZ}', "");
    Expect(0, 917999, '\p{Scx=_ZZZZ}', "");
    Expect(1, 917999, '\p{^Scx=_ZZZZ}', "");
    Expect(1, 917999, '\P{Scx=_ZZZZ}', "");
    Expect(0, 917999, '\P{^Scx=_ZZZZ}', "");
    Error('\p{Is_Script_Extensions=	 Unknown/a/}');
    Error('\P{Is_Script_Extensions=	 Unknown/a/}');
    Expect(1, 918000, '\p{Is_Script_Extensions=unknown}', "");
    Expect(0, 918000, '\p{^Is_Script_Extensions=unknown}', "");
    Expect(0, 918000, '\P{Is_Script_Extensions=unknown}', "");
    Expect(1, 918000, '\P{^Is_Script_Extensions=unknown}', "");
    Expect(0, 917999, '\p{Is_Script_Extensions=unknown}', "");
    Expect(1, 917999, '\p{^Is_Script_Extensions=unknown}', "");
    Expect(1, 917999, '\P{Is_Script_Extensions=unknown}', "");
    Expect(0, 917999, '\P{^Is_Script_Extensions=unknown}', "");
    Expect(1, 918000, '\p{Is_Script_Extensions=	Unknown}', "");
    Expect(0, 918000, '\p{^Is_Script_Extensions=	Unknown}', "");
    Expect(0, 918000, '\P{Is_Script_Extensions=	Unknown}', "");
    Expect(1, 918000, '\P{^Is_Script_Extensions=	Unknown}', "");
    Expect(0, 917999, '\p{Is_Script_Extensions=	Unknown}', "");
    Expect(1, 917999, '\p{^Is_Script_Extensions=	Unknown}', "");
    Expect(1, 917999, '\P{Is_Script_Extensions=	Unknown}', "");
    Expect(0, 917999, '\P{^Is_Script_Extensions=	Unknown}', "");
    Error('\p{Is_Scx=:=_-Zzzz}');
    Error('\P{Is_Scx=:=_-Zzzz}');
    Expect(1, 918000, '\p{Is_Scx=zzzz}', "");
    Expect(0, 918000, '\p{^Is_Scx=zzzz}', "");
    Expect(0, 918000, '\P{Is_Scx=zzzz}', "");
    Expect(1, 918000, '\P{^Is_Scx=zzzz}', "");
    Expect(0, 917999, '\p{Is_Scx=zzzz}', "");
    Expect(1, 917999, '\p{^Is_Scx=zzzz}', "");
    Expect(1, 917999, '\P{Is_Scx=zzzz}', "");
    Expect(0, 917999, '\P{^Is_Scx=zzzz}', "");
    Expect(1, 918000, '\p{Is_Scx=Zzzz}', "");
    Expect(0, 918000, '\p{^Is_Scx=Zzzz}', "");
    Expect(0, 918000, '\P{Is_Scx=Zzzz}', "");
    Expect(1, 918000, '\P{^Is_Scx=Zzzz}', "");
    Expect(0, 917999, '\p{Is_Scx=Zzzz}', "");
    Expect(1, 917999, '\p{^Is_Scx=Zzzz}', "");
    Expect(1, 917999, '\P{Is_Scx=Zzzz}', "");
    Expect(0, 917999, '\P{^Is_Scx=Zzzz}', "");
    Error('\p{Soft_Dotted:	/a/-No}');
    Error('\P{Soft_Dotted:	/a/-No}');
    Expect(1, 120468, '\p{Soft_Dotted=no}', "");
    Expect(0, 120468, '\p{^Soft_Dotted=no}', "");
    Expect(0, 120468, '\P{Soft_Dotted=no}', "");
    Expect(1, 120468, '\P{^Soft_Dotted=no}', "");
    Expect(0, 120467, '\p{Soft_Dotted=no}', "");
    Expect(1, 120467, '\p{^Soft_Dotted=no}', "");
    Expect(1, 120467, '\P{Soft_Dotted=no}', "");
    Expect(0, 120467, '\P{^Soft_Dotted=no}', "");
    Expect(1, 120468, '\p{Soft_Dotted=	-no}', "");
    Expect(0, 120468, '\p{^Soft_Dotted=	-no}', "");
    Expect(0, 120468, '\P{Soft_Dotted=	-no}', "");
    Expect(1, 120468, '\P{^Soft_Dotted=	-no}', "");
    Expect(0, 120467, '\p{Soft_Dotted=	-no}', "");
    Expect(1, 120467, '\p{^Soft_Dotted=	-no}', "");
    Expect(1, 120467, '\P{Soft_Dotted=	-no}', "");
    Expect(0, 120467, '\P{^Soft_Dotted=	-no}', "");
    Error('\p{SD: :=__N}');
    Error('\P{SD: :=__N}');
    Expect(1, 120468, '\p{SD=n}', "");
    Expect(0, 120468, '\p{^SD=n}', "");
    Expect(0, 120468, '\P{SD=n}', "");
    Expect(1, 120468, '\P{^SD=n}', "");
    Expect(0, 120467, '\p{SD=n}', "");
    Expect(1, 120467, '\p{^SD=n}', "");
    Expect(1, 120467, '\P{SD=n}', "");
    Expect(0, 120467, '\P{^SD=n}', "");
    Expect(1, 120468, '\p{SD: N}', "");
    Expect(0, 120468, '\p{^SD: N}', "");
    Expect(0, 120468, '\P{SD: N}', "");
    Expect(1, 120468, '\P{^SD: N}', "");
    Expect(0, 120467, '\p{SD: N}', "");
    Expect(1, 120467, '\p{^SD: N}', "");
    Expect(1, 120467, '\P{SD: N}', "");
    Expect(0, 120467, '\P{^SD: N}', "");
    Error('\p{Is_Soft_Dotted=/a/_-F}');
    Error('\P{Is_Soft_Dotted=/a/_-F}');
    Expect(1, 120468, '\p{Is_Soft_Dotted=f}', "");
    Expect(0, 120468, '\p{^Is_Soft_Dotted=f}', "");
    Expect(0, 120468, '\P{Is_Soft_Dotted=f}', "");
    Expect(1, 120468, '\P{^Is_Soft_Dotted=f}', "");
    Expect(0, 120467, '\p{Is_Soft_Dotted=f}', "");
    Expect(1, 120467, '\p{^Is_Soft_Dotted=f}', "");
    Expect(1, 120467, '\P{Is_Soft_Dotted=f}', "");
    Expect(0, 120467, '\P{^Is_Soft_Dotted=f}', "");
    Expect(1, 120468, '\p{Is_Soft_Dotted=	F}', "");
    Expect(0, 120468, '\p{^Is_Soft_Dotted=	F}', "");
    Expect(0, 120468, '\P{Is_Soft_Dotted=	F}', "");
    Expect(1, 120468, '\P{^Is_Soft_Dotted=	F}', "");
    Expect(0, 120467, '\p{Is_Soft_Dotted=	F}', "");
    Expect(1, 120467, '\p{^Is_Soft_Dotted=	F}', "");
    Expect(1, 120467, '\P{Is_Soft_Dotted=	F}', "");
    Expect(0, 120467, '\P{^Is_Soft_Dotted=	F}', "");
    Error('\p{Is_SD= -false:=}');
    Error('\P{Is_SD= -false:=}');
    Expect(1, 120468, '\p{Is_SD=false}', "");
    Expect(0, 120468, '\p{^Is_SD=false}', "");
    Expect(0, 120468, '\P{Is_SD=false}', "");
    Expect(1, 120468, '\P{^Is_SD=false}', "");
    Expect(0, 120467, '\p{Is_SD=false}', "");
    Expect(1, 120467, '\p{^Is_SD=false}', "");
    Expect(1, 120467, '\P{Is_SD=false}', "");
    Expect(0, 120467, '\P{^Is_SD=false}', "");
    Expect(1, 120468, '\p{Is_SD=-	False}', "");
    Expect(0, 120468, '\p{^Is_SD=-	False}', "");
    Expect(0, 120468, '\P{Is_SD=-	False}', "");
    Expect(1, 120468, '\P{^Is_SD=-	False}', "");
    Expect(0, 120467, '\p{Is_SD=-	False}', "");
    Expect(1, 120467, '\p{^Is_SD=-	False}', "");
    Expect(1, 120467, '\P{Is_SD=-	False}', "");
    Expect(0, 120467, '\P{^Is_SD=-	False}', "");
    Error('\p{Soft_Dotted=-_YES:=}');
    Error('\P{Soft_Dotted=-_YES:=}');
    Expect(1, 120467, '\p{Soft_Dotted=yes}', "");
    Expect(0, 120467, '\p{^Soft_Dotted=yes}', "");
    Expect(0, 120467, '\P{Soft_Dotted=yes}', "");
    Expect(1, 120467, '\P{^Soft_Dotted=yes}', "");
    Expect(0, 120468, '\p{Soft_Dotted=yes}', "");
    Expect(1, 120468, '\p{^Soft_Dotted=yes}', "");
    Expect(1, 120468, '\P{Soft_Dotted=yes}', "");
    Expect(0, 120468, '\P{^Soft_Dotted=yes}', "");
    Expect(1, 120467, '\p{Soft_Dotted=_ yes}', "");
    Expect(0, 120467, '\p{^Soft_Dotted=_ yes}', "");
    Expect(0, 120467, '\P{Soft_Dotted=_ yes}', "");
    Expect(1, 120467, '\P{^Soft_Dotted=_ yes}', "");
    Expect(0, 120468, '\p{Soft_Dotted=_ yes}', "");
    Expect(1, 120468, '\p{^Soft_Dotted=_ yes}', "");
    Expect(1, 120468, '\P{Soft_Dotted=_ yes}', "");
    Expect(0, 120468, '\P{^Soft_Dotted=_ yes}', "");
    Error('\p{SD=_/a/Y}');
    Error('\P{SD=_/a/Y}');
    Expect(1, 120467, '\p{SD=y}', "");
    Expect(0, 120467, '\p{^SD=y}', "");
    Expect(0, 120467, '\P{SD=y}', "");
    Expect(1, 120467, '\P{^SD=y}', "");
    Expect(0, 120468, '\p{SD=y}', "");
    Expect(1, 120468, '\p{^SD=y}', "");
    Expect(1, 120468, '\P{SD=y}', "");
    Expect(0, 120468, '\P{^SD=y}', "");
    Expect(1, 120467, '\p{SD= Y}', "");
    Expect(0, 120467, '\p{^SD= Y}', "");
    Expect(0, 120467, '\P{SD= Y}', "");
    Expect(1, 120467, '\P{^SD= Y}', "");
    Expect(0, 120468, '\p{SD= Y}', "");
    Expect(1, 120468, '\p{^SD= Y}', "");
    Expect(1, 120468, '\P{SD= Y}', "");
    Expect(0, 120468, '\P{^SD= Y}', "");
    Error('\p{Is_Soft_Dotted:   	/a/T}');
    Error('\P{Is_Soft_Dotted:   	/a/T}');
    Expect(1, 120467, '\p{Is_Soft_Dotted=t}', "");
    Expect(0, 120467, '\p{^Is_Soft_Dotted=t}', "");
    Expect(0, 120467, '\P{Is_Soft_Dotted=t}', "");
    Expect(1, 120467, '\P{^Is_Soft_Dotted=t}', "");
    Expect(0, 120468, '\p{Is_Soft_Dotted=t}', "");
    Expect(1, 120468, '\p{^Is_Soft_Dotted=t}', "");
    Expect(1, 120468, '\P{Is_Soft_Dotted=t}', "");
    Expect(0, 120468, '\P{^Is_Soft_Dotted=t}', "");
    Expect(1, 120467, '\p{Is_Soft_Dotted:		 T}', "");
    Expect(0, 120467, '\p{^Is_Soft_Dotted:		 T}', "");
    Expect(0, 120467, '\P{Is_Soft_Dotted:		 T}', "");
    Expect(1, 120467, '\P{^Is_Soft_Dotted:		 T}', "");
    Expect(0, 120468, '\p{Is_Soft_Dotted:		 T}', "");
    Expect(1, 120468, '\p{^Is_Soft_Dotted:		 T}', "");
    Expect(1, 120468, '\P{Is_Soft_Dotted:		 T}', "");
    Expect(0, 120468, '\P{^Is_Soft_Dotted:		 T}', "");
    Error('\p{Is_SD=	/a/True}');
    Error('\P{Is_SD=	/a/True}');
    Expect(1, 120467, '\p{Is_SD=true}', "");
    Expect(0, 120467, '\p{^Is_SD=true}', "");
    Expect(0, 120467, '\P{Is_SD=true}', "");
    Expect(1, 120467, '\P{^Is_SD=true}', "");
    Expect(0, 120468, '\p{Is_SD=true}', "");
    Expect(1, 120468, '\p{^Is_SD=true}', "");
    Expect(1, 120468, '\P{Is_SD=true}', "");
    Expect(0, 120468, '\P{^Is_SD=true}', "");
    Expect(1, 120467, '\p{Is_SD= -True}', "");
    Expect(0, 120467, '\p{^Is_SD= -True}', "");
    Expect(0, 120467, '\P{Is_SD= -True}', "");
    Expect(1, 120467, '\P{^Is_SD= -True}', "");
    Expect(0, 120468, '\p{Is_SD= -True}', "");
    Expect(1, 120468, '\p{^Is_SD= -True}', "");
    Expect(1, 120468, '\P{Is_SD= -True}', "");
    Expect(0, 120468, '\P{^Is_SD= -True}', "");
    Error('\p{simplelowercasemapping}');
    Error('\P{simplelowercasemapping}');
    Error('\p{slc}');
    Error('\P{slc}');
    Error('\p{simpletitlecasemapping}');
    Error('\P{simpletitlecasemapping}');
    Error('\p{stc}');
    Error('\P{stc}');
    Error('\p{Sentence_Terminal: - NO/a/}');
    Error('\P{Sentence_Terminal: - NO/a/}');
    Expect(1, 121481, '\p{Sentence_Terminal=no}', "");
    Expect(0, 121481, '\p{^Sentence_Terminal=no}', "");
    Expect(0, 121481, '\P{Sentence_Terminal=no}', "");
    Expect(1, 121481, '\P{^Sentence_Terminal=no}', "");
    Expect(0, 121480, '\p{Sentence_Terminal=no}', "");
    Expect(1, 121480, '\p{^Sentence_Terminal=no}', "");
    Expect(1, 121480, '\P{Sentence_Terminal=no}', "");
    Expect(0, 121480, '\P{^Sentence_Terminal=no}', "");
    Expect(1, 121481, '\p{Sentence_Terminal:_No}', "");
    Expect(0, 121481, '\p{^Sentence_Terminal:_No}', "");
    Expect(0, 121481, '\P{Sentence_Terminal:_No}', "");
    Expect(1, 121481, '\P{^Sentence_Terminal:_No}', "");
    Expect(0, 121480, '\p{Sentence_Terminal:_No}', "");
    Expect(1, 121480, '\p{^Sentence_Terminal:_No}', "");
    Expect(1, 121480, '\P{Sentence_Terminal:_No}', "");
    Expect(0, 121480, '\P{^Sentence_Terminal:_No}', "");
    Error('\p{STerm=/a/--N}');
    Error('\P{STerm=/a/--N}');
    Expect(1, 121481, '\p{STerm=n}', "");
    Expect(0, 121481, '\p{^STerm=n}', "");
    Expect(0, 121481, '\P{STerm=n}', "");
    Expect(1, 121481, '\P{^STerm=n}', "");
    Expect(0, 121480, '\p{STerm=n}', "");
    Expect(1, 121480, '\p{^STerm=n}', "");
    Expect(1, 121480, '\P{STerm=n}', "");
    Expect(0, 121480, '\P{^STerm=n}', "");
    Expect(1, 121481, '\p{STerm= N}', "");
    Expect(0, 121481, '\p{^STerm= N}', "");
    Expect(0, 121481, '\P{STerm= N}', "");
    Expect(1, 121481, '\P{^STerm= N}', "");
    Expect(0, 121480, '\p{STerm= N}', "");
    Expect(1, 121480, '\p{^STerm= N}', "");
    Expect(1, 121480, '\P{STerm= N}', "");
    Expect(0, 121480, '\P{^STerm= N}', "");
    Error('\p{Is_Sentence_Terminal=:=	_f}');
    Error('\P{Is_Sentence_Terminal=:=	_f}');
    Expect(1, 121481, '\p{Is_Sentence_Terminal=f}', "");
    Expect(0, 121481, '\p{^Is_Sentence_Terminal=f}', "");
    Expect(0, 121481, '\P{Is_Sentence_Terminal=f}', "");
    Expect(1, 121481, '\P{^Is_Sentence_Terminal=f}', "");
    Expect(0, 121480, '\p{Is_Sentence_Terminal=f}', "");
    Expect(1, 121480, '\p{^Is_Sentence_Terminal=f}', "");
    Expect(1, 121480, '\P{Is_Sentence_Terminal=f}', "");
    Expect(0, 121480, '\P{^Is_Sentence_Terminal=f}', "");
    Expect(1, 121481, '\p{Is_Sentence_Terminal:   	_F}', "");
    Expect(0, 121481, '\p{^Is_Sentence_Terminal:   	_F}', "");
    Expect(0, 121481, '\P{Is_Sentence_Terminal:   	_F}', "");
    Expect(1, 121481, '\P{^Is_Sentence_Terminal:   	_F}', "");
    Expect(0, 121480, '\p{Is_Sentence_Terminal:   	_F}', "");
    Expect(1, 121480, '\p{^Is_Sentence_Terminal:   	_F}', "");
    Expect(1, 121480, '\P{Is_Sentence_Terminal:   	_F}', "");
    Expect(0, 121480, '\P{^Is_Sentence_Terminal:   	_F}', "");
    Error('\p{Is_STerm=:=	false}');
    Error('\P{Is_STerm=:=	false}');
    Expect(1, 121481, '\p{Is_STerm=false}', "");
    Expect(0, 121481, '\p{^Is_STerm=false}', "");
    Expect(0, 121481, '\P{Is_STerm=false}', "");
    Expect(1, 121481, '\P{^Is_STerm=false}', "");
    Expect(0, 121480, '\p{Is_STerm=false}', "");
    Expect(1, 121480, '\p{^Is_STerm=false}', "");
    Expect(1, 121480, '\P{Is_STerm=false}', "");
    Expect(0, 121480, '\P{^Is_STerm=false}', "");
    Expect(1, 121481, '\p{Is_STerm=__false}', "");
    Expect(0, 121481, '\p{^Is_STerm=__false}', "");
    Expect(0, 121481, '\P{Is_STerm=__false}', "");
    Expect(1, 121481, '\P{^Is_STerm=__false}', "");
    Expect(0, 121480, '\p{Is_STerm=__false}', "");
    Expect(1, 121480, '\p{^Is_STerm=__false}', "");
    Expect(1, 121480, '\P{Is_STerm=__false}', "");
    Expect(0, 121480, '\P{^Is_STerm=__false}', "");
    Error('\p{Sentence_Terminal=:=_yes}');
    Error('\P{Sentence_Terminal=:=_yes}');
    Expect(1, 121480, '\p{Sentence_Terminal=yes}', "");
    Expect(0, 121480, '\p{^Sentence_Terminal=yes}', "");
    Expect(0, 121480, '\P{Sentence_Terminal=yes}', "");
    Expect(1, 121480, '\P{^Sentence_Terminal=yes}', "");
    Expect(0, 121481, '\p{Sentence_Terminal=yes}', "");
    Expect(1, 121481, '\p{^Sentence_Terminal=yes}', "");
    Expect(1, 121481, '\P{Sentence_Terminal=yes}', "");
    Expect(0, 121481, '\P{^Sentence_Terminal=yes}', "");
    Expect(1, 121480, '\p{Sentence_Terminal=--Yes}', "");
    Expect(0, 121480, '\p{^Sentence_Terminal=--Yes}', "");
    Expect(0, 121480, '\P{Sentence_Terminal=--Yes}', "");
    Expect(1, 121480, '\P{^Sentence_Terminal=--Yes}', "");
    Expect(0, 121481, '\p{Sentence_Terminal=--Yes}', "");
    Expect(1, 121481, '\p{^Sentence_Terminal=--Yes}', "");
    Expect(1, 121481, '\P{Sentence_Terminal=--Yes}', "");
    Expect(0, 121481, '\P{^Sentence_Terminal=--Yes}', "");
    Error('\p{STerm=:=_Y}');
    Error('\P{STerm=:=_Y}');
    Expect(1, 121480, '\p{STerm=y}', "");
    Expect(0, 121480, '\p{^STerm=y}', "");
    Expect(0, 121480, '\P{STerm=y}', "");
    Expect(1, 121480, '\P{^STerm=y}', "");
    Expect(0, 121481, '\p{STerm=y}', "");
    Expect(1, 121481, '\p{^STerm=y}', "");
    Expect(1, 121481, '\P{STerm=y}', "");
    Expect(0, 121481, '\P{^STerm=y}', "");
    Expect(1, 121480, '\p{STerm=	Y}', "");
    Expect(0, 121480, '\p{^STerm=	Y}', "");
    Expect(0, 121480, '\P{STerm=	Y}', "");
    Expect(1, 121480, '\P{^STerm=	Y}', "");
    Expect(0, 121481, '\p{STerm=	Y}', "");
    Expect(1, 121481, '\p{^STerm=	Y}', "");
    Expect(1, 121481, '\P{STerm=	Y}', "");
    Expect(0, 121481, '\P{^STerm=	Y}', "");
    Error('\p{Is_Sentence_Terminal=-/a/T}');
    Error('\P{Is_Sentence_Terminal=-/a/T}');
    Expect(1, 121480, '\p{Is_Sentence_Terminal=t}', "");
    Expect(0, 121480, '\p{^Is_Sentence_Terminal=t}', "");
    Expect(0, 121480, '\P{Is_Sentence_Terminal=t}', "");
    Expect(1, 121480, '\P{^Is_Sentence_Terminal=t}', "");
    Expect(0, 121481, '\p{Is_Sentence_Terminal=t}', "");
    Expect(1, 121481, '\p{^Is_Sentence_Terminal=t}', "");
    Expect(1, 121481, '\P{Is_Sentence_Terminal=t}', "");
    Expect(0, 121481, '\P{^Is_Sentence_Terminal=t}', "");
    Expect(1, 121480, '\p{Is_Sentence_Terminal=	T}', "");
    Expect(0, 121480, '\p{^Is_Sentence_Terminal=	T}', "");
    Expect(0, 121480, '\P{Is_Sentence_Terminal=	T}', "");
    Expect(1, 121480, '\P{^Is_Sentence_Terminal=	T}', "");
    Expect(0, 121481, '\p{Is_Sentence_Terminal=	T}', "");
    Expect(1, 121481, '\p{^Is_Sentence_Terminal=	T}', "");
    Expect(1, 121481, '\P{Is_Sentence_Terminal=	T}', "");
    Expect(0, 121481, '\P{^Is_Sentence_Terminal=	T}', "");
    Error('\p{Is_STerm=/a/True}');
    Error('\P{Is_STerm=/a/True}');
    Expect(1, 121480, '\p{Is_STerm=true}', "");
    Expect(0, 121480, '\p{^Is_STerm=true}', "");
    Expect(0, 121480, '\P{Is_STerm=true}', "");
    Expect(1, 121480, '\P{^Is_STerm=true}', "");
    Expect(0, 121481, '\p{Is_STerm=true}', "");
    Expect(1, 121481, '\p{^Is_STerm=true}', "");
    Expect(1, 121481, '\P{Is_STerm=true}', "");
    Expect(0, 121481, '\P{^Is_STerm=true}', "");
    Expect(1, 121480, '\p{Is_STerm=	_true}', "");
    Expect(0, 121480, '\p{^Is_STerm=	_true}', "");
    Expect(0, 121480, '\P{Is_STerm=	_true}', "");
    Expect(1, 121480, '\P{^Is_STerm=	_true}', "");
    Expect(0, 121481, '\p{Is_STerm=	_true}', "");
    Expect(1, 121481, '\p{^Is_STerm=	_true}', "");
    Expect(1, 121481, '\P{Is_STerm=	_true}', "");
    Expect(0, 121481, '\P{^Is_STerm=	_true}', "");
    Error('\p{simpleuppercasemapping}');
    Error('\P{simpleuppercasemapping}');
    Error('\p{suc}');
    Error('\P{suc}');
    Error('\p{titlecasemapping}');
    Error('\P{titlecasemapping}');
    Error('\p{tc}');
    Error('\P{tc}');
    Error('\p{Terminal_Punctuation=:=	-No}');
    Error('\P{Terminal_Punctuation=:=	-No}');
    Expect(1, 121483, '\p{Terminal_Punctuation=no}', "");
    Expect(0, 121483, '\p{^Terminal_Punctuation=no}', "");
    Expect(0, 121483, '\P{Terminal_Punctuation=no}', "");
    Expect(1, 121483, '\P{^Terminal_Punctuation=no}', "");
    Expect(0, 121482, '\p{Terminal_Punctuation=no}', "");
    Expect(1, 121482, '\p{^Terminal_Punctuation=no}', "");
    Expect(1, 121482, '\P{Terminal_Punctuation=no}', "");
    Expect(0, 121482, '\P{^Terminal_Punctuation=no}', "");
    Expect(1, 121483, '\p{Terminal_Punctuation=		No}', "");
    Expect(0, 121483, '\p{^Terminal_Punctuation=		No}', "");
    Expect(0, 121483, '\P{Terminal_Punctuation=		No}', "");
    Expect(1, 121483, '\P{^Terminal_Punctuation=		No}', "");
    Expect(0, 121482, '\p{Terminal_Punctuation=		No}', "");
    Expect(1, 121482, '\p{^Terminal_Punctuation=		No}', "");
    Expect(1, 121482, '\P{Terminal_Punctuation=		No}', "");
    Expect(0, 121482, '\P{^Terminal_Punctuation=		No}', "");
    Error('\p{Term=:=-	N}');
    Error('\P{Term=:=-	N}');
    Expect(1, 121483, '\p{Term=n}', "");
    Expect(0, 121483, '\p{^Term=n}', "");
    Expect(0, 121483, '\P{Term=n}', "");
    Expect(1, 121483, '\P{^Term=n}', "");
    Expect(0, 121482, '\p{Term=n}', "");
    Expect(1, 121482, '\p{^Term=n}', "");
    Expect(1, 121482, '\P{Term=n}', "");
    Expect(0, 121482, '\P{^Term=n}', "");
    Expect(1, 121483, '\p{Term= N}', "");
    Expect(0, 121483, '\p{^Term= N}', "");
    Expect(0, 121483, '\P{Term= N}', "");
    Expect(1, 121483, '\P{^Term= N}', "");
    Expect(0, 121482, '\p{Term= N}', "");
    Expect(1, 121482, '\p{^Term= N}', "");
    Expect(1, 121482, '\P{Term= N}', "");
    Expect(0, 121482, '\P{^Term= N}', "");
    Error('\p{Is_Terminal_Punctuation=:=F}');
    Error('\P{Is_Terminal_Punctuation=:=F}');
    Expect(1, 121483, '\p{Is_Terminal_Punctuation=f}', "");
    Expect(0, 121483, '\p{^Is_Terminal_Punctuation=f}', "");
    Expect(0, 121483, '\P{Is_Terminal_Punctuation=f}', "");
    Expect(1, 121483, '\P{^Is_Terminal_Punctuation=f}', "");
    Expect(0, 121482, '\p{Is_Terminal_Punctuation=f}', "");
    Expect(1, 121482, '\p{^Is_Terminal_Punctuation=f}', "");
    Expect(1, 121482, '\P{Is_Terminal_Punctuation=f}', "");
    Expect(0, 121482, '\P{^Is_Terminal_Punctuation=f}', "");
    Expect(1, 121483, '\p{Is_Terminal_Punctuation:    _F}', "");
    Expect(0, 121483, '\p{^Is_Terminal_Punctuation:    _F}', "");
    Expect(0, 121483, '\P{Is_Terminal_Punctuation:    _F}', "");
    Expect(1, 121483, '\P{^Is_Terminal_Punctuation:    _F}', "");
    Expect(0, 121482, '\p{Is_Terminal_Punctuation:    _F}', "");
    Expect(1, 121482, '\p{^Is_Terminal_Punctuation:    _F}', "");
    Expect(1, 121482, '\P{Is_Terminal_Punctuation:    _F}', "");
    Expect(0, 121482, '\P{^Is_Terminal_Punctuation:    _F}', "");
    Error('\p{Is_Term=--False:=}');
    Error('\P{Is_Term=--False:=}');
    Expect(1, 121483, '\p{Is_Term=false}', "");
    Expect(0, 121483, '\p{^Is_Term=false}', "");
    Expect(0, 121483, '\P{Is_Term=false}', "");
    Expect(1, 121483, '\P{^Is_Term=false}', "");
    Expect(0, 121482, '\p{Is_Term=false}', "");
    Expect(1, 121482, '\p{^Is_Term=false}', "");
    Expect(1, 121482, '\P{Is_Term=false}', "");
    Expect(0, 121482, '\P{^Is_Term=false}', "");
    Expect(1, 121483, '\p{Is_Term= False}', "");
    Expect(0, 121483, '\p{^Is_Term= False}', "");
    Expect(0, 121483, '\P{Is_Term= False}', "");
    Expect(1, 121483, '\P{^Is_Term= False}', "");
    Expect(0, 121482, '\p{Is_Term= False}', "");
    Expect(1, 121482, '\p{^Is_Term= False}', "");
    Expect(1, 121482, '\P{Is_Term= False}', "");
    Expect(0, 121482, '\P{^Is_Term= False}', "");
    Error('\p{Terminal_Punctuation= /a/yes}');
    Error('\P{Terminal_Punctuation= /a/yes}');
    Expect(1, 121482, '\p{Terminal_Punctuation=yes}', "");
    Expect(0, 121482, '\p{^Terminal_Punctuation=yes}', "");
    Expect(0, 121482, '\P{Terminal_Punctuation=yes}', "");
    Expect(1, 121482, '\P{^Terminal_Punctuation=yes}', "");
    Expect(0, 121483, '\p{Terminal_Punctuation=yes}', "");
    Expect(1, 121483, '\p{^Terminal_Punctuation=yes}', "");
    Expect(1, 121483, '\P{Terminal_Punctuation=yes}', "");
    Expect(0, 121483, '\P{^Terminal_Punctuation=yes}', "");
    Expect(1, 121482, '\p{Terminal_Punctuation:   -_Yes}', "");
    Expect(0, 121482, '\p{^Terminal_Punctuation:   -_Yes}', "");
    Expect(0, 121482, '\P{Terminal_Punctuation:   -_Yes}', "");
    Expect(1, 121482, '\P{^Terminal_Punctuation:   -_Yes}', "");
    Expect(0, 121483, '\p{Terminal_Punctuation:   -_Yes}', "");
    Expect(1, 121483, '\p{^Terminal_Punctuation:   -_Yes}', "");
    Expect(1, 121483, '\P{Terminal_Punctuation:   -_Yes}', "");
    Expect(0, 121483, '\P{^Terminal_Punctuation:   -_Yes}', "");
    Error('\p{Term=-:=Y}');
    Error('\P{Term=-:=Y}');
    Expect(1, 121482, '\p{Term=y}', "");
    Expect(0, 121482, '\p{^Term=y}', "");
    Expect(0, 121482, '\P{Term=y}', "");
    Expect(1, 121482, '\P{^Term=y}', "");
    Expect(0, 121483, '\p{Term=y}', "");
    Expect(1, 121483, '\p{^Term=y}', "");
    Expect(1, 121483, '\P{Term=y}', "");
    Expect(0, 121483, '\P{^Term=y}', "");
    Expect(1, 121482, '\p{Term=__Y}', "");
    Expect(0, 121482, '\p{^Term=__Y}', "");
    Expect(0, 121482, '\P{Term=__Y}', "");
    Expect(1, 121482, '\P{^Term=__Y}', "");
    Expect(0, 121483, '\p{Term=__Y}', "");
    Expect(1, 121483, '\p{^Term=__Y}', "");
    Expect(1, 121483, '\P{Term=__Y}', "");
    Expect(0, 121483, '\P{^Term=__Y}', "");
    Error('\p{Is_Terminal_Punctuation= _T/a/}');
    Error('\P{Is_Terminal_Punctuation= _T/a/}');
    Expect(1, 121482, '\p{Is_Terminal_Punctuation=t}', "");
    Expect(0, 121482, '\p{^Is_Terminal_Punctuation=t}', "");
    Expect(0, 121482, '\P{Is_Terminal_Punctuation=t}', "");
    Expect(1, 121482, '\P{^Is_Terminal_Punctuation=t}', "");
    Expect(0, 121483, '\p{Is_Terminal_Punctuation=t}', "");
    Expect(1, 121483, '\p{^Is_Terminal_Punctuation=t}', "");
    Expect(1, 121483, '\P{Is_Terminal_Punctuation=t}', "");
    Expect(0, 121483, '\P{^Is_Terminal_Punctuation=t}', "");
    Expect(1, 121482, '\p{Is_Terminal_Punctuation=_T}', "");
    Expect(0, 121482, '\p{^Is_Terminal_Punctuation=_T}', "");
    Expect(0, 121482, '\P{Is_Terminal_Punctuation=_T}', "");
    Expect(1, 121482, '\P{^Is_Terminal_Punctuation=_T}', "");
    Expect(0, 121483, '\p{Is_Terminal_Punctuation=_T}', "");
    Expect(1, 121483, '\p{^Is_Terminal_Punctuation=_T}', "");
    Expect(1, 121483, '\P{Is_Terminal_Punctuation=_T}', "");
    Expect(0, 121483, '\P{^Is_Terminal_Punctuation=_T}', "");
    Error('\p{Is_Term=/a/-_True}');
    Error('\P{Is_Term=/a/-_True}');
    Expect(1, 121482, '\p{Is_Term=true}', "");
    Expect(0, 121482, '\p{^Is_Term=true}', "");
    Expect(0, 121482, '\P{Is_Term=true}', "");
    Expect(1, 121482, '\P{^Is_Term=true}', "");
    Expect(0, 121483, '\p{Is_Term=true}', "");
    Expect(1, 121483, '\p{^Is_Term=true}', "");
    Expect(1, 121483, '\P{Is_Term=true}', "");
    Expect(0, 121483, '\P{^Is_Term=true}', "");
    Expect(1, 121482, '\p{Is_Term=	true}', "");
    Expect(0, 121482, '\p{^Is_Term=	true}', "");
    Expect(0, 121482, '\P{Is_Term=	true}', "");
    Expect(1, 121482, '\P{^Is_Term=	true}', "");
    Expect(0, 121483, '\p{Is_Term=	true}', "");
    Expect(1, 121483, '\p{^Is_Term=	true}', "");
    Expect(1, 121483, '\P{Is_Term=	true}', "");
    Expect(0, 121483, '\P{^Is_Term=	true}', "");
    Error('\p{uppercasemapping}');
    Error('\P{uppercasemapping}');
    Error('\p{uc}');
    Error('\P{uc}');
    Error('\p{Unified_Ideograph=:= no}');
    Error('\P{Unified_Ideograph=:= no}');
    Expect(1, 191457, '\p{Unified_Ideograph=no}', "");
    Expect(0, 191457, '\p{^Unified_Ideograph=no}', "");
    Expect(0, 191457, '\P{Unified_Ideograph=no}', "");
    Expect(1, 191457, '\P{^Unified_Ideograph=no}', "");
    Expect(0, 191456, '\p{Unified_Ideograph=no}', "");
    Expect(1, 191456, '\p{^Unified_Ideograph=no}', "");
    Expect(1, 191456, '\P{Unified_Ideograph=no}', "");
    Expect(0, 191456, '\P{^Unified_Ideograph=no}', "");
    Expect(1, 191457, '\p{Unified_Ideograph=	 NO}', "");
    Expect(0, 191457, '\p{^Unified_Ideograph=	 NO}', "");
    Expect(0, 191457, '\P{Unified_Ideograph=	 NO}', "");
    Expect(1, 191457, '\P{^Unified_Ideograph=	 NO}', "");
    Expect(0, 191456, '\p{Unified_Ideograph=	 NO}', "");
    Expect(1, 191456, '\p{^Unified_Ideograph=	 NO}', "");
    Expect(1, 191456, '\P{Unified_Ideograph=	 NO}', "");
    Expect(0, 191456, '\P{^Unified_Ideograph=	 NO}', "");
    Error('\p{UIdeo=_/a/n}');
    Error('\P{UIdeo=_/a/n}');
    Expect(1, 191457, '\p{UIdeo=n}', "");
    Expect(0, 191457, '\p{^UIdeo=n}', "");
    Expect(0, 191457, '\P{UIdeo=n}', "");
    Expect(1, 191457, '\P{^UIdeo=n}', "");
    Expect(0, 191456, '\p{UIdeo=n}', "");
    Expect(1, 191456, '\p{^UIdeo=n}', "");
    Expect(1, 191456, '\P{UIdeo=n}', "");
    Expect(0, 191456, '\P{^UIdeo=n}', "");
    Expect(1, 191457, '\p{UIdeo= N}', "");
    Expect(0, 191457, '\p{^UIdeo= N}', "");
    Expect(0, 191457, '\P{UIdeo= N}', "");
    Expect(1, 191457, '\P{^UIdeo= N}', "");
    Expect(0, 191456, '\p{UIdeo= N}', "");
    Expect(1, 191456, '\p{^UIdeo= N}', "");
    Expect(1, 191456, '\P{UIdeo= N}', "");
    Expect(0, 191456, '\P{^UIdeo= N}', "");
    Error('\p{Is_Unified_Ideograph=:=-F}');
    Error('\P{Is_Unified_Ideograph=:=-F}');
    Expect(1, 191457, '\p{Is_Unified_Ideograph=f}', "");
    Expect(0, 191457, '\p{^Is_Unified_Ideograph=f}', "");
    Expect(0, 191457, '\P{Is_Unified_Ideograph=f}', "");
    Expect(1, 191457, '\P{^Is_Unified_Ideograph=f}', "");
    Expect(0, 191456, '\p{Is_Unified_Ideograph=f}', "");
    Expect(1, 191456, '\p{^Is_Unified_Ideograph=f}', "");
    Expect(1, 191456, '\P{Is_Unified_Ideograph=f}', "");
    Expect(0, 191456, '\P{^Is_Unified_Ideograph=f}', "");
    Expect(1, 191457, '\p{Is_Unified_Ideograph=__F}', "");
    Expect(0, 191457, '\p{^Is_Unified_Ideograph=__F}', "");
    Expect(0, 191457, '\P{Is_Unified_Ideograph=__F}', "");
    Expect(1, 191457, '\P{^Is_Unified_Ideograph=__F}', "");
    Expect(0, 191456, '\p{Is_Unified_Ideograph=__F}', "");
    Expect(1, 191456, '\p{^Is_Unified_Ideograph=__F}', "");
    Expect(1, 191456, '\P{Is_Unified_Ideograph=__F}', "");
    Expect(0, 191456, '\P{^Is_Unified_Ideograph=__F}', "");
    Error('\p{Is_UIdeo: /a/false}');
    Error('\P{Is_UIdeo: /a/false}');
    Expect(1, 191457, '\p{Is_UIdeo:false}', "");
    Expect(0, 191457, '\p{^Is_UIdeo:false}', "");
    Expect(0, 191457, '\P{Is_UIdeo:false}', "");
    Expect(1, 191457, '\P{^Is_UIdeo:false}', "");
    Expect(0, 191456, '\p{Is_UIdeo:false}', "");
    Expect(1, 191456, '\p{^Is_UIdeo:false}', "");
    Expect(1, 191456, '\P{Is_UIdeo:false}', "");
    Expect(0, 191456, '\P{^Is_UIdeo:false}', "");
    Expect(1, 191457, '\p{Is_UIdeo: 	-False}', "");
    Expect(0, 191457, '\p{^Is_UIdeo: 	-False}', "");
    Expect(0, 191457, '\P{Is_UIdeo: 	-False}', "");
    Expect(1, 191457, '\P{^Is_UIdeo: 	-False}', "");
    Expect(0, 191456, '\p{Is_UIdeo: 	-False}', "");
    Expect(1, 191456, '\p{^Is_UIdeo: 	-False}', "");
    Expect(1, 191456, '\P{Is_UIdeo: 	-False}', "");
    Expect(0, 191456, '\P{^Is_UIdeo: 	-False}', "");
    Error('\p{Unified_Ideograph: /a/YES}');
    Error('\P{Unified_Ideograph: /a/YES}');
    Expect(1, 191456, '\p{Unified_Ideograph:yes}', "");
    Expect(0, 191456, '\p{^Unified_Ideograph:yes}', "");
    Expect(0, 191456, '\P{Unified_Ideograph:yes}', "");
    Expect(1, 191456, '\P{^Unified_Ideograph:yes}', "");
    Expect(0, 191457, '\p{Unified_Ideograph:yes}', "");
    Expect(1, 191457, '\p{^Unified_Ideograph:yes}', "");
    Expect(1, 191457, '\P{Unified_Ideograph:yes}', "");
    Expect(0, 191457, '\P{^Unified_Ideograph:yes}', "");
    Expect(1, 191456, '\p{Unified_Ideograph: _ Yes}', "");
    Expect(0, 191456, '\p{^Unified_Ideograph: _ Yes}', "");
    Expect(0, 191456, '\P{Unified_Ideograph: _ Yes}', "");
    Expect(1, 191456, '\P{^Unified_Ideograph: _ Yes}', "");
    Expect(0, 191457, '\p{Unified_Ideograph: _ Yes}', "");
    Expect(1, 191457, '\p{^Unified_Ideograph: _ Yes}', "");
    Expect(1, 191457, '\P{Unified_Ideograph: _ Yes}', "");
    Expect(0, 191457, '\P{^Unified_Ideograph: _ Yes}', "");
    Error('\p{UIdeo:    	Y:=}');
    Error('\P{UIdeo:    	Y:=}');
    Expect(1, 191456, '\p{UIdeo=y}', "");
    Expect(0, 191456, '\p{^UIdeo=y}', "");
    Expect(0, 191456, '\P{UIdeo=y}', "");
    Expect(1, 191456, '\P{^UIdeo=y}', "");
    Expect(0, 191457, '\p{UIdeo=y}', "");
    Expect(1, 191457, '\p{^UIdeo=y}', "");
    Expect(1, 191457, '\P{UIdeo=y}', "");
    Expect(0, 191457, '\P{^UIdeo=y}', "");
    Expect(1, 191456, '\p{UIdeo=	Y}', "");
    Expect(0, 191456, '\p{^UIdeo=	Y}', "");
    Expect(0, 191456, '\P{UIdeo=	Y}', "");
    Expect(1, 191456, '\P{^UIdeo=	Y}', "");
    Expect(0, 191457, '\p{UIdeo=	Y}', "");
    Expect(1, 191457, '\p{^UIdeo=	Y}', "");
    Expect(1, 191457, '\P{UIdeo=	Y}', "");
    Expect(0, 191457, '\P{^UIdeo=	Y}', "");
    Error('\p{Is_Unified_Ideograph=_T/a/}');
    Error('\P{Is_Unified_Ideograph=_T/a/}');
    Expect(1, 191456, '\p{Is_Unified_Ideograph=t}', "");
    Expect(0, 191456, '\p{^Is_Unified_Ideograph=t}', "");
    Expect(0, 191456, '\P{Is_Unified_Ideograph=t}', "");
    Expect(1, 191456, '\P{^Is_Unified_Ideograph=t}', "");
    Expect(0, 191457, '\p{Is_Unified_Ideograph=t}', "");
    Expect(1, 191457, '\p{^Is_Unified_Ideograph=t}', "");
    Expect(1, 191457, '\P{Is_Unified_Ideograph=t}', "");
    Expect(0, 191457, '\P{^Is_Unified_Ideograph=t}', "");
    Expect(1, 191456, '\p{Is_Unified_Ideograph:	- T}', "");
    Expect(0, 191456, '\p{^Is_Unified_Ideograph:	- T}', "");
    Expect(0, 191456, '\P{Is_Unified_Ideograph:	- T}', "");
    Expect(1, 191456, '\P{^Is_Unified_Ideograph:	- T}', "");
    Expect(0, 191457, '\p{Is_Unified_Ideograph:	- T}', "");
    Expect(1, 191457, '\p{^Is_Unified_Ideograph:	- T}', "");
    Expect(1, 191457, '\P{Is_Unified_Ideograph:	- T}', "");
    Expect(0, 191457, '\P{^Is_Unified_Ideograph:	- T}', "");
    Error('\p{Is_UIdeo:   -/a/TRUE}');
    Error('\P{Is_UIdeo:   -/a/TRUE}');
    Expect(1, 191456, '\p{Is_UIdeo=true}', "");
    Expect(0, 191456, '\p{^Is_UIdeo=true}', "");
    Expect(0, 191456, '\P{Is_UIdeo=true}', "");
    Expect(1, 191456, '\P{^Is_UIdeo=true}', "");
    Expect(0, 191457, '\p{Is_UIdeo=true}', "");
    Expect(1, 191457, '\p{^Is_UIdeo=true}', "");
    Expect(1, 191457, '\P{Is_UIdeo=true}', "");
    Expect(0, 191457, '\P{^Is_UIdeo=true}', "");
    Expect(1, 191456, '\p{Is_UIdeo:   -True}', "");
    Expect(0, 191456, '\p{^Is_UIdeo:   -True}', "");
    Expect(0, 191456, '\P{Is_UIdeo:   -True}', "");
    Expect(1, 191456, '\P{^Is_UIdeo:   -True}', "");
    Expect(0, 191457, '\p{Is_UIdeo:   -True}', "");
    Expect(1, 191457, '\p{^Is_UIdeo:   -True}', "");
    Expect(1, 191457, '\P{Is_UIdeo:   -True}', "");
    Expect(0, 191457, '\P{^Is_UIdeo:   -True}', "");
    Error('\p{Uppercase=-NO:=}');
    Error('\P{Uppercase=-NO:=}');
    Expect(1, 127370, '\p{Uppercase=no}', "");
    Expect(0, 127370, '\p{^Uppercase=no}', "");
    Expect(0, 127370, '\P{Uppercase=no}', "");
    Expect(1, 127370, '\P{^Uppercase=no}', "");
    Expect(0, 127369, '\p{Uppercase=no}', "");
    Expect(1, 127369, '\p{^Uppercase=no}', "");
    Expect(1, 127369, '\P{Uppercase=no}', "");
    Expect(0, 127369, '\P{^Uppercase=no}', "");
    Error('\p{Upper=N:=}');
    Error('\P{Upper=N:=}');
    Expect(1, 127370, '\p{Upper=n}', "");
    Expect(0, 127370, '\p{^Upper=n}', "");
    Expect(0, 127370, '\P{Upper=n}', "");
    Expect(1, 127370, '\P{^Upper=n}', "");
    Expect(0, 127369, '\p{Upper=n}', "");
    Expect(1, 127369, '\p{^Upper=n}', "");
    Expect(1, 127369, '\P{Upper=n}', "");
    Expect(0, 127369, '\P{^Upper=n}', "");
    Expect(1, 127370, '\p{Upper=	_N}', "");
    Expect(0, 127370, '\p{^Upper=	_N}', "");
    Expect(0, 127370, '\P{Upper=	_N}', "");
    Expect(1, 127370, '\P{^Upper=	_N}', "");
    Expect(0, 127369, '\p{Upper=	_N}', "");
    Expect(1, 127369, '\p{^Upper=	_N}', "");
    Expect(1, 127369, '\P{Upper=	_N}', "");
    Expect(0, 127369, '\P{^Upper=	_N}', "");
    Error('\p{Is_Uppercase=_f:=}');
    Error('\P{Is_Uppercase=_f:=}');
    Expect(1, 127370, '\p{Is_Uppercase=f}', "");
    Expect(0, 127370, '\p{^Is_Uppercase=f}', "");
    Expect(0, 127370, '\P{Is_Uppercase=f}', "");
    Expect(1, 127370, '\P{^Is_Uppercase=f}', "");
    Expect(0, 127369, '\p{Is_Uppercase=f}', "");
    Expect(1, 127369, '\p{^Is_Uppercase=f}', "");
    Expect(1, 127369, '\P{Is_Uppercase=f}', "");
    Expect(0, 127369, '\P{^Is_Uppercase=f}', "");
    Expect(1, 127370, '\p{Is_Uppercase= _F}', "");
    Expect(0, 127370, '\p{^Is_Uppercase= _F}', "");
    Expect(0, 127370, '\P{Is_Uppercase= _F}', "");
    Expect(1, 127370, '\P{^Is_Uppercase= _F}', "");
    Expect(0, 127369, '\p{Is_Uppercase= _F}', "");
    Expect(1, 127369, '\p{^Is_Uppercase= _F}', "");
    Expect(1, 127369, '\P{Is_Uppercase= _F}', "");
    Expect(0, 127369, '\P{^Is_Uppercase= _F}', "");
    Error('\p{Is_Upper=:=--False}');
    Error('\P{Is_Upper=:=--False}');
    Expect(1, 127370, '\p{Is_Upper=false}', "");
    Expect(0, 127370, '\p{^Is_Upper=false}', "");
    Expect(0, 127370, '\P{Is_Upper=false}', "");
    Expect(1, 127370, '\P{^Is_Upper=false}', "");
    Expect(0, 127369, '\p{Is_Upper=false}', "");
    Expect(1, 127369, '\p{^Is_Upper=false}', "");
    Expect(1, 127369, '\P{Is_Upper=false}', "");
    Expect(0, 127369, '\P{^Is_Upper=false}', "");
    Expect(1, 127370, '\p{Is_Upper= _FALSE}', "");
    Expect(0, 127370, '\p{^Is_Upper= _FALSE}', "");
    Expect(0, 127370, '\P{Is_Upper= _FALSE}', "");
    Expect(1, 127370, '\P{^Is_Upper= _FALSE}', "");
    Expect(0, 127369, '\p{Is_Upper= _FALSE}', "");
    Expect(1, 127369, '\p{^Is_Upper= _FALSE}', "");
    Expect(1, 127369, '\P{Is_Upper= _FALSE}', "");
    Expect(0, 127369, '\P{^Is_Upper= _FALSE}', "");
    Error('\p{Uppercase: _Yes/a/}');
    Error('\P{Uppercase: _Yes/a/}');
    Expect(1, 127369, '\p{Uppercase=yes}', "");
    Expect(0, 127369, '\p{^Uppercase=yes}', "");
    Expect(0, 127369, '\P{Uppercase=yes}', "");
    Expect(1, 127369, '\P{^Uppercase=yes}', "");
    Expect(0, 127370, '\p{Uppercase=yes}', "");
    Expect(1, 127370, '\p{^Uppercase=yes}', "");
    Expect(1, 127370, '\P{Uppercase=yes}', "");
    Expect(0, 127370, '\P{^Uppercase=yes}', "");
    Expect(1, 127369, '\p{Uppercase=-_Yes}', "");
    Expect(0, 127369, '\p{^Uppercase=-_Yes}', "");
    Expect(0, 127369, '\P{Uppercase=-_Yes}', "");
    Expect(1, 127369, '\P{^Uppercase=-_Yes}', "");
    Expect(0, 127370, '\p{Uppercase=-_Yes}', "");
    Expect(1, 127370, '\p{^Uppercase=-_Yes}', "");
    Expect(1, 127370, '\P{Uppercase=-_Yes}', "");
    Expect(0, 127370, '\P{^Uppercase=-_Yes}', "");
    Error('\p{Upper=/a/- Y}');
    Error('\P{Upper=/a/- Y}');
    Expect(1, 127369, '\p{Upper=y}', "");
    Expect(0, 127369, '\p{^Upper=y}', "");
    Expect(0, 127369, '\P{Upper=y}', "");
    Expect(1, 127369, '\P{^Upper=y}', "");
    Expect(0, 127370, '\p{Upper=y}', "");
    Expect(1, 127370, '\p{^Upper=y}', "");
    Expect(1, 127370, '\P{Upper=y}', "");
    Expect(0, 127370, '\P{^Upper=y}', "");
    Expect(1, 127369, '\p{Upper=-	Y}', "");
    Expect(0, 127369, '\p{^Upper=-	Y}', "");
    Expect(0, 127369, '\P{Upper=-	Y}', "");
    Expect(1, 127369, '\P{^Upper=-	Y}', "");
    Expect(0, 127370, '\p{Upper=-	Y}', "");
    Expect(1, 127370, '\p{^Upper=-	Y}', "");
    Expect(1, 127370, '\P{Upper=-	Y}', "");
    Expect(0, 127370, '\P{^Upper=-	Y}', "");
    Error('\p{Is_Uppercase= _T:=}');
    Error('\P{Is_Uppercase= _T:=}');
    Expect(1, 127369, '\p{Is_Uppercase=t}', "");
    Expect(0, 127369, '\p{^Is_Uppercase=t}', "");
    Expect(0, 127369, '\P{Is_Uppercase=t}', "");
    Expect(1, 127369, '\P{^Is_Uppercase=t}', "");
    Expect(0, 127370, '\p{Is_Uppercase=t}', "");
    Expect(1, 127370, '\p{^Is_Uppercase=t}', "");
    Expect(1, 127370, '\P{Is_Uppercase=t}', "");
    Expect(0, 127370, '\P{^Is_Uppercase=t}', "");
    Expect(1, 127369, '\p{Is_Uppercase= T}', "");
    Expect(0, 127369, '\p{^Is_Uppercase= T}', "");
    Expect(0, 127369, '\P{Is_Uppercase= T}', "");
    Expect(1, 127369, '\P{^Is_Uppercase= T}', "");
    Expect(0, 127370, '\p{Is_Uppercase= T}', "");
    Expect(1, 127370, '\p{^Is_Uppercase= T}', "");
    Expect(1, 127370, '\P{Is_Uppercase= T}', "");
    Expect(0, 127370, '\P{^Is_Uppercase= T}', "");
    Error('\p{Is_Upper=	/a/true}');
    Error('\P{Is_Upper=	/a/true}');
    Expect(1, 127369, '\p{Is_Upper:	true}', "");
    Expect(0, 127369, '\p{^Is_Upper:	true}', "");
    Expect(0, 127369, '\P{Is_Upper:	true}', "");
    Expect(1, 127369, '\P{^Is_Upper:	true}', "");
    Expect(0, 127370, '\p{Is_Upper:	true}', "");
    Expect(1, 127370, '\p{^Is_Upper:	true}', "");
    Expect(1, 127370, '\P{Is_Upper:	true}', "");
    Expect(0, 127370, '\P{^Is_Upper:	true}', "");
    Expect(1, 127369, '\p{Is_Upper=__True}', "");
    Expect(0, 127369, '\p{^Is_Upper=__True}', "");
    Expect(0, 127369, '\P{Is_Upper=__True}', "");
    Expect(1, 127369, '\P{^Is_Upper=__True}', "");
    Expect(0, 127370, '\p{Is_Upper=__True}', "");
    Expect(1, 127370, '\p{^Is_Upper=__True}', "");
    Expect(1, 127370, '\P{Is_Upper=__True}', "");
    Expect(0, 127370, '\P{^Is_Upper=__True}', "");
    Error('\p{verticalorientation}');
    Error('\P{verticalorientation}');
    Error('\p{vo}');
    Error('\P{vo}');
    Error('\p{Vertical_Orientation=_ Rotated/a/}');
    Error('\P{Vertical_Orientation=_ Rotated/a/}');
    Expect(1, 262144, '\p{Vertical_Orientation=rotated}', "");
    Expect(0, 262144, '\p{^Vertical_Orientation=rotated}', "");
    Expect(0, 262144, '\P{Vertical_Orientation=rotated}', "");
    Expect(1, 262144, '\P{^Vertical_Orientation=rotated}', "");
    Expect(0, 1114109, '\p{Vertical_Orientation=rotated}', "");
    Expect(1, 1114109, '\p{^Vertical_Orientation=rotated}', "");
    Expect(1, 1114109, '\P{Vertical_Orientation=rotated}', "");
    Expect(0, 1114109, '\P{^Vertical_Orientation=rotated}', "");
    Expect(1, 262144, '\p{Vertical_Orientation=	ROTATED}', "");
    Expect(0, 262144, '\p{^Vertical_Orientation=	ROTATED}', "");
    Expect(0, 262144, '\P{Vertical_Orientation=	ROTATED}', "");
    Expect(1, 262144, '\P{^Vertical_Orientation=	ROTATED}', "");
    Expect(0, 1114109, '\p{Vertical_Orientation=	ROTATED}', "");
    Expect(1, 1114109, '\p{^Vertical_Orientation=	ROTATED}', "");
    Expect(1, 1114109, '\P{Vertical_Orientation=	ROTATED}', "");
    Expect(0, 1114109, '\P{^Vertical_Orientation=	ROTATED}', "");
    Error('\p{Vo=-R:=}');
    Error('\P{Vo=-R:=}');
    Expect(1, 262144, '\p{Vo=r}', "");
    Expect(0, 262144, '\p{^Vo=r}', "");
    Expect(0, 262144, '\P{Vo=r}', "");
    Expect(1, 262144, '\P{^Vo=r}', "");
    Expect(0, 1114109, '\p{Vo=r}', "");
    Expect(1, 1114109, '\p{^Vo=r}', "");
    Expect(1, 1114109, '\P{Vo=r}', "");
    Expect(0, 1114109, '\P{^Vo=r}', "");
    Expect(1, 262144, '\p{Vo=_	R}', "");
    Expect(0, 262144, '\p{^Vo=_	R}', "");
    Expect(0, 262144, '\P{Vo=_	R}', "");
    Expect(1, 262144, '\P{^Vo=_	R}', "");
    Expect(0, 1114109, '\p{Vo=_	R}', "");
    Expect(1, 1114109, '\p{^Vo=_	R}', "");
    Expect(1, 1114109, '\P{Vo=_	R}', "");
    Expect(0, 1114109, '\P{^Vo=_	R}', "");
    Error('\p{Is_Vertical_Orientation=:= ROTATED}');
    Error('\P{Is_Vertical_Orientation=:= ROTATED}');
    Expect(1, 262144, '\p{Is_Vertical_Orientation:   rotated}', "");
    Expect(0, 262144, '\p{^Is_Vertical_Orientation:   rotated}', "");
    Expect(0, 262144, '\P{Is_Vertical_Orientation:   rotated}', "");
    Expect(1, 262144, '\P{^Is_Vertical_Orientation:   rotated}', "");
    Expect(0, 1114109, '\p{Is_Vertical_Orientation:   rotated}', "");
    Expect(1, 1114109, '\p{^Is_Vertical_Orientation:   rotated}', "");
    Expect(1, 1114109, '\P{Is_Vertical_Orientation:   rotated}', "");
    Expect(0, 1114109, '\P{^Is_Vertical_Orientation:   rotated}', "");
    Expect(1, 262144, '\p{Is_Vertical_Orientation=- Rotated}', "");
    Expect(0, 262144, '\p{^Is_Vertical_Orientation=- Rotated}', "");
    Expect(0, 262144, '\P{Is_Vertical_Orientation=- Rotated}', "");
    Expect(1, 262144, '\P{^Is_Vertical_Orientation=- Rotated}', "");
    Expect(0, 1114109, '\p{Is_Vertical_Orientation=- Rotated}', "");
    Expect(1, 1114109, '\p{^Is_Vertical_Orientation=- Rotated}', "");
    Expect(1, 1114109, '\P{Is_Vertical_Orientation=- Rotated}', "");
    Expect(0, 1114109, '\P{^Is_Vertical_Orientation=- Rotated}', "");
    Error('\p{Is_Vo=-/a/r}');
    Error('\P{Is_Vo=-/a/r}');
    Expect(1, 262144, '\p{Is_Vo=r}', "");
    Expect(0, 262144, '\p{^Is_Vo=r}', "");
    Expect(0, 262144, '\P{Is_Vo=r}', "");
    Expect(1, 262144, '\P{^Is_Vo=r}', "");
    Expect(0, 1114109, '\p{Is_Vo=r}', "");
    Expect(1, 1114109, '\p{^Is_Vo=r}', "");
    Expect(1, 1114109, '\P{Is_Vo=r}', "");
    Expect(0, 1114109, '\P{^Is_Vo=r}', "");
    Expect(1, 262144, '\p{Is_Vo=_-r}', "");
    Expect(0, 262144, '\p{^Is_Vo=_-r}', "");
    Expect(0, 262144, '\P{Is_Vo=_-r}', "");
    Expect(1, 262144, '\P{^Is_Vo=_-r}', "");
    Expect(0, 1114109, '\p{Is_Vo=_-r}', "");
    Expect(1, 1114109, '\p{^Is_Vo=_-r}', "");
    Expect(1, 1114109, '\P{Is_Vo=_-r}', "");
    Expect(0, 1114109, '\P{^Is_Vo=_-r}', "");
    Error('\p{Vertical_Orientation= /a/transformed_ROTATED}');
    Error('\P{Vertical_Orientation= /a/transformed_ROTATED}');
    Expect(1, 65507, '\p{Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65507, '\p{^Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65507, '\P{Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65507, '\P{^Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65508, '\p{Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65508, '\p{^Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65508, '\P{Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65508, '\P{^Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65507, '\p{Vertical_Orientation=	 transformed_rotated}', "");
    Expect(0, 65507, '\p{^Vertical_Orientation=	 transformed_rotated}', "");
    Expect(0, 65507, '\P{Vertical_Orientation=	 transformed_rotated}', "");
    Expect(1, 65507, '\P{^Vertical_Orientation=	 transformed_rotated}', "");
    Expect(0, 65508, '\p{Vertical_Orientation=	 transformed_rotated}', "");
    Expect(1, 65508, '\p{^Vertical_Orientation=	 transformed_rotated}', "");
    Expect(1, 65508, '\P{Vertical_Orientation=	 transformed_rotated}', "");
    Expect(0, 65508, '\P{^Vertical_Orientation=	 transformed_rotated}', "");
    Error('\p{Vo=/a/		Tr}');
    Error('\P{Vo=/a/		Tr}');
    Expect(1, 65507, '\p{Vo=tr}', "");
    Expect(0, 65507, '\p{^Vo=tr}', "");
    Expect(0, 65507, '\P{Vo=tr}', "");
    Expect(1, 65507, '\P{^Vo=tr}', "");
    Expect(0, 65508, '\p{Vo=tr}', "");
    Expect(1, 65508, '\p{^Vo=tr}', "");
    Expect(1, 65508, '\P{Vo=tr}', "");
    Expect(0, 65508, '\P{^Vo=tr}', "");
    Expect(1, 65507, '\p{Vo=-TR}', "");
    Expect(0, 65507, '\p{^Vo=-TR}', "");
    Expect(0, 65507, '\P{Vo=-TR}', "");
    Expect(1, 65507, '\P{^Vo=-TR}', "");
    Expect(0, 65508, '\p{Vo=-TR}', "");
    Expect(1, 65508, '\p{^Vo=-TR}', "");
    Expect(1, 65508, '\P{Vo=-TR}', "");
    Expect(0, 65508, '\P{^Vo=-TR}', "");
    Error('\p{Is_Vertical_Orientation=	/a/transformed_Rotated}');
    Error('\P{Is_Vertical_Orientation=	/a/transformed_Rotated}');
    Expect(1, 65507, '\p{Is_Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65507, '\p{^Is_Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65507, '\P{Is_Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65507, '\P{^Is_Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65508, '\p{Is_Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65508, '\p{^Is_Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65508, '\P{Is_Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65508, '\P{^Is_Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65507, '\p{Is_Vertical_Orientation=_-Transformed_ROTATED}', "");
    Expect(0, 65507, '\p{^Is_Vertical_Orientation=_-Transformed_ROTATED}', "");
    Expect(0, 65507, '\P{Is_Vertical_Orientation=_-Transformed_ROTATED}', "");
    Expect(1, 65507, '\P{^Is_Vertical_Orientation=_-Transformed_ROTATED}', "");
    Expect(0, 65508, '\p{Is_Vertical_Orientation=_-Transformed_ROTATED}', "");
    Expect(1, 65508, '\p{^Is_Vertical_Orientation=_-Transformed_ROTATED}', "");
    Expect(1, 65508, '\P{Is_Vertical_Orientation=_-Transformed_ROTATED}', "");
    Expect(0, 65508, '\P{^Is_Vertical_Orientation=_-Transformed_ROTATED}', "");
    Error('\p{Is_Vo:   := -TR}');
    Error('\P{Is_Vo:   := -TR}');
    Expect(1, 65507, '\p{Is_Vo=tr}', "");
    Expect(0, 65507, '\p{^Is_Vo=tr}', "");
    Expect(0, 65507, '\P{Is_Vo=tr}', "");
    Expect(1, 65507, '\P{^Is_Vo=tr}', "");
    Expect(0, 65508, '\p{Is_Vo=tr}', "");
    Expect(1, 65508, '\p{^Is_Vo=tr}', "");
    Expect(1, 65508, '\P{Is_Vo=tr}', "");
    Expect(0, 65508, '\P{^Is_Vo=tr}', "");
    Expect(1, 65507, '\p{Is_Vo=_-Tr}', "");
    Expect(0, 65507, '\p{^Is_Vo=_-Tr}', "");
    Expect(0, 65507, '\P{Is_Vo=_-Tr}', "");
    Expect(1, 65507, '\P{^Is_Vo=_-Tr}', "");
    Expect(0, 65508, '\p{Is_Vo=_-Tr}', "");
    Expect(1, 65508, '\p{^Is_Vo=_-Tr}', "");
    Expect(1, 65508, '\P{Is_Vo=_-Tr}', "");
    Expect(0, 65508, '\P{^Is_Vo=_-Tr}', "");
    Error('\p{Vertical_Orientation: --Transformed_Upright/a/}');
    Error('\P{Vertical_Orientation: --Transformed_Upright/a/}');
    Expect(1, 127489, '\p{Vertical_Orientation=transformedupright}', "");
    Expect(0, 127489, '\p{^Vertical_Orientation=transformedupright}', "");
    Expect(0, 127489, '\P{Vertical_Orientation=transformedupright}', "");
    Expect(1, 127489, '\P{^Vertical_Orientation=transformedupright}', "");
    Expect(0, 127490, '\p{Vertical_Orientation=transformedupright}', "");
    Expect(1, 127490, '\p{^Vertical_Orientation=transformedupright}', "");
    Expect(1, 127490, '\P{Vertical_Orientation=transformedupright}', "");
    Expect(0, 127490, '\P{^Vertical_Orientation=transformedupright}', "");
    Expect(1, 127489, '\p{Vertical_Orientation=_ Transformed_upright}', "");
    Expect(0, 127489, '\p{^Vertical_Orientation=_ Transformed_upright}', "");
    Expect(0, 127489, '\P{Vertical_Orientation=_ Transformed_upright}', "");
    Expect(1, 127489, '\P{^Vertical_Orientation=_ Transformed_upright}', "");
    Expect(0, 127490, '\p{Vertical_Orientation=_ Transformed_upright}', "");
    Expect(1, 127490, '\p{^Vertical_Orientation=_ Transformed_upright}', "");
    Expect(1, 127490, '\P{Vertical_Orientation=_ Transformed_upright}', "");
    Expect(0, 127490, '\P{^Vertical_Orientation=_ Transformed_upright}', "");
    Error('\p{Vo=/a/_Tu}');
    Error('\P{Vo=/a/_Tu}');
    Expect(1, 127489, '\p{Vo=tu}', "");
    Expect(0, 127489, '\p{^Vo=tu}', "");
    Expect(0, 127489, '\P{Vo=tu}', "");
    Expect(1, 127489, '\P{^Vo=tu}', "");
    Expect(0, 127490, '\p{Vo=tu}', "");
    Expect(1, 127490, '\p{^Vo=tu}', "");
    Expect(1, 127490, '\P{Vo=tu}', "");
    Expect(0, 127490, '\P{^Vo=tu}', "");
    Expect(1, 127489, '\p{Vo=_	Tu}', "");
    Expect(0, 127489, '\p{^Vo=_	Tu}', "");
    Expect(0, 127489, '\P{Vo=_	Tu}', "");
    Expect(1, 127489, '\P{^Vo=_	Tu}', "");
    Expect(0, 127490, '\p{Vo=_	Tu}', "");
    Expect(1, 127490, '\p{^Vo=_	Tu}', "");
    Expect(1, 127490, '\P{Vo=_	Tu}', "");
    Expect(0, 127490, '\P{^Vo=_	Tu}', "");
    Error('\p{Is_Vertical_Orientation= -Transformed_UPRIGHT:=}');
    Error('\P{Is_Vertical_Orientation= -Transformed_UPRIGHT:=}');
    Expect(1, 127489, '\p{Is_Vertical_Orientation:transformedupright}', "");
    Expect(0, 127489, '\p{^Is_Vertical_Orientation:transformedupright}', "");
    Expect(0, 127489, '\P{Is_Vertical_Orientation:transformedupright}', "");
    Expect(1, 127489, '\P{^Is_Vertical_Orientation:transformedupright}', "");
    Expect(0, 127490, '\p{Is_Vertical_Orientation:transformedupright}', "");
    Expect(1, 127490, '\p{^Is_Vertical_Orientation:transformedupright}', "");
    Expect(1, 127490, '\P{Is_Vertical_Orientation:transformedupright}', "");
    Expect(0, 127490, '\P{^Is_Vertical_Orientation:transformedupright}', "");
    Expect(1, 127489, '\p{Is_Vertical_Orientation=	TRANSFORMED_Upright}', "");
    Expect(0, 127489, '\p{^Is_Vertical_Orientation=	TRANSFORMED_Upright}', "");
    Expect(0, 127489, '\P{Is_Vertical_Orientation=	TRANSFORMED_Upright}', "");
    Expect(1, 127489, '\P{^Is_Vertical_Orientation=	TRANSFORMED_Upright}', "");
    Expect(0, 127490, '\p{Is_Vertical_Orientation=	TRANSFORMED_Upright}', "");
    Expect(1, 127490, '\p{^Is_Vertical_Orientation=	TRANSFORMED_Upright}', "");
    Expect(1, 127490, '\P{Is_Vertical_Orientation=	TRANSFORMED_Upright}', "");
    Expect(0, 127490, '\P{^Is_Vertical_Orientation=	TRANSFORMED_Upright}', "");
    Error('\p{Is_Vo=:=  TU}');
    Error('\P{Is_Vo=:=  TU}');
    Expect(1, 127489, '\p{Is_Vo: tu}', "");
    Expect(0, 127489, '\p{^Is_Vo: tu}', "");
    Expect(0, 127489, '\P{Is_Vo: tu}', "");
    Expect(1, 127489, '\P{^Is_Vo: tu}', "");
    Expect(0, 127490, '\p{Is_Vo: tu}', "");
    Expect(1, 127490, '\p{^Is_Vo: tu}', "");
    Expect(1, 127490, '\P{Is_Vo: tu}', "");
    Expect(0, 127490, '\P{^Is_Vo: tu}', "");
    Expect(1, 127489, '\p{Is_Vo=	 Tu}', "");
    Expect(0, 127489, '\p{^Is_Vo=	 Tu}', "");
    Expect(0, 127489, '\P{Is_Vo=	 Tu}', "");
    Expect(1, 127489, '\P{^Is_Vo=	 Tu}', "");
    Expect(0, 127490, '\p{Is_Vo=	 Tu}', "");
    Expect(1, 127490, '\p{^Is_Vo=	 Tu}', "");
    Expect(1, 127490, '\P{Is_Vo=	 Tu}', "");
    Expect(0, 127490, '\P{^Is_Vo=	 Tu}', "");
    Error('\p{Vertical_Orientation=/a/--UPRIGHT}');
    Error('\P{Vertical_Orientation=/a/--UPRIGHT}');
    Expect(1, 1114109, '\p{Vertical_Orientation=upright}', "");
    Expect(0, 1114109, '\p{^Vertical_Orientation=upright}', "");
    Expect(0, 1114109, '\P{Vertical_Orientation=upright}', "");
    Expect(1, 1114109, '\P{^Vertical_Orientation=upright}', "");
    Expect(0, 262144, '\p{Vertical_Orientation=upright}', "");
    Expect(1, 262144, '\p{^Vertical_Orientation=upright}', "");
    Expect(1, 262144, '\P{Vertical_Orientation=upright}', "");
    Expect(0, 262144, '\P{^Vertical_Orientation=upright}', "");
    Expect(1, 1114109, '\p{Vertical_Orientation=-_Upright}', "");
    Expect(0, 1114109, '\p{^Vertical_Orientation=-_Upright}', "");
    Expect(0, 1114109, '\P{Vertical_Orientation=-_Upright}', "");
    Expect(1, 1114109, '\P{^Vertical_Orientation=-_Upright}', "");
    Expect(0, 262144, '\p{Vertical_Orientation=-_Upright}', "");
    Expect(1, 262144, '\p{^Vertical_Orientation=-_Upright}', "");
    Expect(1, 262144, '\P{Vertical_Orientation=-_Upright}', "");
    Expect(0, 262144, '\P{^Vertical_Orientation=-_Upright}', "");
    Error('\p{Vo=/a/_U}');
    Error('\P{Vo=/a/_U}');
    Expect(1, 1114109, '\p{Vo=u}', "");
    Expect(0, 1114109, '\p{^Vo=u}', "");
    Expect(0, 1114109, '\P{Vo=u}', "");
    Expect(1, 1114109, '\P{^Vo=u}', "");
    Expect(0, 262144, '\p{Vo=u}', "");
    Expect(1, 262144, '\p{^Vo=u}', "");
    Expect(1, 262144, '\P{Vo=u}', "");
    Expect(0, 262144, '\P{^Vo=u}', "");
    Expect(1, 1114109, '\p{Vo=	U}', "");
    Expect(0, 1114109, '\p{^Vo=	U}', "");
    Expect(0, 1114109, '\P{Vo=	U}', "");
    Expect(1, 1114109, '\P{^Vo=	U}', "");
    Expect(0, 262144, '\p{Vo=	U}', "");
    Expect(1, 262144, '\p{^Vo=	U}', "");
    Expect(1, 262144, '\P{Vo=	U}', "");
    Expect(0, 262144, '\P{^Vo=	U}', "");
    Error('\p{Is_Vertical_Orientation: upright:=}');
    Error('\P{Is_Vertical_Orientation: upright:=}');
    Expect(1, 1114109, '\p{Is_Vertical_Orientation=upright}', "");
    Expect(0, 1114109, '\p{^Is_Vertical_Orientation=upright}', "");
    Expect(0, 1114109, '\P{Is_Vertical_Orientation=upright}', "");
    Expect(1, 1114109, '\P{^Is_Vertical_Orientation=upright}', "");
    Expect(0, 262144, '\p{Is_Vertical_Orientation=upright}', "");
    Expect(1, 262144, '\p{^Is_Vertical_Orientation=upright}', "");
    Expect(1, 262144, '\P{Is_Vertical_Orientation=upright}', "");
    Expect(0, 262144, '\P{^Is_Vertical_Orientation=upright}', "");
    Expect(1, 1114109, '\p{Is_Vertical_Orientation:-Upright}', "");
    Expect(0, 1114109, '\p{^Is_Vertical_Orientation:-Upright}', "");
    Expect(0, 1114109, '\P{Is_Vertical_Orientation:-Upright}', "");
    Expect(1, 1114109, '\P{^Is_Vertical_Orientation:-Upright}', "");
    Expect(0, 262144, '\p{Is_Vertical_Orientation:-Upright}', "");
    Expect(1, 262144, '\p{^Is_Vertical_Orientation:-Upright}', "");
    Expect(1, 262144, '\P{Is_Vertical_Orientation:-Upright}', "");
    Expect(0, 262144, '\P{^Is_Vertical_Orientation:-Upright}', "");
    Error('\p{Is_Vo=:=	-U}');
    Error('\P{Is_Vo=:=	-U}');
    Expect(1, 1114109, '\p{Is_Vo=u}', "");
    Expect(0, 1114109, '\p{^Is_Vo=u}', "");
    Expect(0, 1114109, '\P{Is_Vo=u}', "");
    Expect(1, 1114109, '\P{^Is_Vo=u}', "");
    Expect(0, 262144, '\p{Is_Vo=u}', "");
    Expect(1, 262144, '\p{^Is_Vo=u}', "");
    Expect(1, 262144, '\P{Is_Vo=u}', "");
    Expect(0, 262144, '\P{^Is_Vo=u}', "");
    Expect(1, 1114109, '\p{Is_Vo:U}', "");
    Expect(0, 1114109, '\p{^Is_Vo:U}', "");
    Expect(0, 1114109, '\P{Is_Vo:U}', "");
    Expect(1, 1114109, '\P{^Is_Vo:U}', "");
    Expect(0, 262144, '\p{Is_Vo:U}', "");
    Expect(1, 262144, '\p{^Is_Vo:U}', "");
    Expect(1, 262144, '\P{Is_Vo:U}', "");
    Expect(0, 262144, '\P{^Is_Vo:U}', "");
    Error('\p{Variation_Selector: --No:=}');
    Error('\P{Variation_Selector: --No:=}');
    Expect(1, 918000, '\p{Variation_Selector=no}', "");
    Expect(0, 918000, '\p{^Variation_Selector=no}', "");
    Expect(0, 918000, '\P{Variation_Selector=no}', "");
    Expect(1, 918000, '\P{^Variation_Selector=no}', "");
    Expect(0, 917999, '\p{Variation_Selector=no}', "");
    Expect(1, 917999, '\p{^Variation_Selector=no}', "");
    Expect(1, 917999, '\P{Variation_Selector=no}', "");
    Expect(0, 917999, '\P{^Variation_Selector=no}', "");
    Expect(1, 918000, '\p{Variation_Selector=-No}', "");
    Expect(0, 918000, '\p{^Variation_Selector=-No}', "");
    Expect(0, 918000, '\P{Variation_Selector=-No}', "");
    Expect(1, 918000, '\P{^Variation_Selector=-No}', "");
    Expect(0, 917999, '\p{Variation_Selector=-No}', "");
    Expect(1, 917999, '\p{^Variation_Selector=-No}', "");
    Expect(1, 917999, '\P{Variation_Selector=-No}', "");
    Expect(0, 917999, '\P{^Variation_Selector=-No}', "");
    Error('\p{VS=:=_-n}');
    Error('\P{VS=:=_-n}');
    Expect(1, 918000, '\p{VS=n}', "");
    Expect(0, 918000, '\p{^VS=n}', "");
    Expect(0, 918000, '\P{VS=n}', "");
    Expect(1, 918000, '\P{^VS=n}', "");
    Expect(0, 917999, '\p{VS=n}', "");
    Expect(1, 917999, '\p{^VS=n}', "");
    Expect(1, 917999, '\P{VS=n}', "");
    Expect(0, 917999, '\P{^VS=n}', "");
    Expect(1, 918000, '\p{VS=__N}', "");
    Expect(0, 918000, '\p{^VS=__N}', "");
    Expect(0, 918000, '\P{VS=__N}', "");
    Expect(1, 918000, '\P{^VS=__N}', "");
    Expect(0, 917999, '\p{VS=__N}', "");
    Expect(1, 917999, '\p{^VS=__N}', "");
    Expect(1, 917999, '\P{VS=__N}', "");
    Expect(0, 917999, '\P{^VS=__N}', "");
    Error('\p{Is_Variation_Selector=_f:=}');
    Error('\P{Is_Variation_Selector=_f:=}');
    Expect(1, 918000, '\p{Is_Variation_Selector=f}', "");
    Expect(0, 918000, '\p{^Is_Variation_Selector=f}', "");
    Expect(0, 918000, '\P{Is_Variation_Selector=f}', "");
    Expect(1, 918000, '\P{^Is_Variation_Selector=f}', "");
    Expect(0, 917999, '\p{Is_Variation_Selector=f}', "");
    Expect(1, 917999, '\p{^Is_Variation_Selector=f}', "");
    Expect(1, 917999, '\P{Is_Variation_Selector=f}', "");
    Expect(0, 917999, '\P{^Is_Variation_Selector=f}', "");
    Expect(1, 918000, '\p{Is_Variation_Selector=	-f}', "");
    Expect(0, 918000, '\p{^Is_Variation_Selector=	-f}', "");
    Expect(0, 918000, '\P{Is_Variation_Selector=	-f}', "");
    Expect(1, 918000, '\P{^Is_Variation_Selector=	-f}', "");
    Expect(0, 917999, '\p{Is_Variation_Selector=	-f}', "");
    Expect(1, 917999, '\p{^Is_Variation_Selector=	-f}', "");
    Expect(1, 917999, '\P{Is_Variation_Selector=	-f}', "");
    Expect(0, 917999, '\P{^Is_Variation_Selector=	-f}', "");
    Error('\p{Is_VS=_-false/a/}');
    Error('\P{Is_VS=_-false/a/}');
    Expect(1, 918000, '\p{Is_VS=false}', "");
    Expect(0, 918000, '\p{^Is_VS=false}', "");
    Expect(0, 918000, '\P{Is_VS=false}', "");
    Expect(1, 918000, '\P{^Is_VS=false}', "");
    Expect(0, 917999, '\p{Is_VS=false}', "");
    Expect(1, 917999, '\p{^Is_VS=false}', "");
    Expect(1, 917999, '\P{Is_VS=false}', "");
    Expect(0, 917999, '\P{^Is_VS=false}', "");
    Expect(1, 918000, '\p{Is_VS=_FALSE}', "");
    Expect(0, 918000, '\p{^Is_VS=_FALSE}', "");
    Expect(0, 918000, '\P{Is_VS=_FALSE}', "");
    Expect(1, 918000, '\P{^Is_VS=_FALSE}', "");
    Expect(0, 917999, '\p{Is_VS=_FALSE}', "");
    Expect(1, 917999, '\p{^Is_VS=_FALSE}', "");
    Expect(1, 917999, '\P{Is_VS=_FALSE}', "");
    Expect(0, 917999, '\P{^Is_VS=_FALSE}', "");
    Error('\p{Variation_Selector=/a/  Yes}');
    Error('\P{Variation_Selector=/a/  Yes}');
    Expect(1, 917999, '\p{Variation_Selector=yes}', "");
    Expect(0, 917999, '\p{^Variation_Selector=yes}', "");
    Expect(0, 917999, '\P{Variation_Selector=yes}', "");
    Expect(1, 917999, '\P{^Variation_Selector=yes}', "");
    Expect(0, 918000, '\p{Variation_Selector=yes}', "");
    Expect(1, 918000, '\p{^Variation_Selector=yes}', "");
    Expect(1, 918000, '\P{Variation_Selector=yes}', "");
    Expect(0, 918000, '\P{^Variation_Selector=yes}', "");
    Expect(1, 917999, '\p{Variation_Selector=__YES}', "");
    Expect(0, 917999, '\p{^Variation_Selector=__YES}', "");
    Expect(0, 917999, '\P{Variation_Selector=__YES}', "");
    Expect(1, 917999, '\P{^Variation_Selector=__YES}', "");
    Expect(0, 918000, '\p{Variation_Selector=__YES}', "");
    Expect(1, 918000, '\p{^Variation_Selector=__YES}', "");
    Expect(1, 918000, '\P{Variation_Selector=__YES}', "");
    Expect(0, 918000, '\P{^Variation_Selector=__YES}', "");
    Error('\p{VS=:=_ Y}');
    Error('\P{VS=:=_ Y}');
    Expect(1, 917999, '\p{VS=y}', "");
    Expect(0, 917999, '\p{^VS=y}', "");
    Expect(0, 917999, '\P{VS=y}', "");
    Expect(1, 917999, '\P{^VS=y}', "");
    Expect(0, 918000, '\p{VS=y}', "");
    Expect(1, 918000, '\p{^VS=y}', "");
    Expect(1, 918000, '\P{VS=y}', "");
    Expect(0, 918000, '\P{^VS=y}', "");
    Error('\p{Is_Variation_Selector=	 t/a/}');
    Error('\P{Is_Variation_Selector=	 t/a/}');
    Expect(1, 917999, '\p{Is_Variation_Selector=t}', "");
    Expect(0, 917999, '\p{^Is_Variation_Selector=t}', "");
    Expect(0, 917999, '\P{Is_Variation_Selector=t}', "");
    Expect(1, 917999, '\P{^Is_Variation_Selector=t}', "");
    Expect(0, 918000, '\p{Is_Variation_Selector=t}', "");
    Expect(1, 918000, '\p{^Is_Variation_Selector=t}', "");
    Expect(1, 918000, '\P{Is_Variation_Selector=t}', "");
    Expect(0, 918000, '\P{^Is_Variation_Selector=t}', "");
    Expect(1, 917999, '\p{Is_Variation_Selector=-t}', "");
    Expect(0, 917999, '\p{^Is_Variation_Selector=-t}', "");
    Expect(0, 917999, '\P{Is_Variation_Selector=-t}', "");
    Expect(1, 917999, '\P{^Is_Variation_Selector=-t}', "");
    Expect(0, 918000, '\p{Is_Variation_Selector=-t}', "");
    Expect(1, 918000, '\p{^Is_Variation_Selector=-t}', "");
    Expect(1, 918000, '\P{Is_Variation_Selector=-t}', "");
    Expect(0, 918000, '\P{^Is_Variation_Selector=-t}', "");
    Error('\p{Is_VS:    TRUE:=}');
    Error('\P{Is_VS:    TRUE:=}');
    Expect(1, 917999, '\p{Is_VS=true}', "");
    Expect(0, 917999, '\p{^Is_VS=true}', "");
    Expect(0, 917999, '\P{Is_VS=true}', "");
    Expect(1, 917999, '\P{^Is_VS=true}', "");
    Expect(0, 918000, '\p{Is_VS=true}', "");
    Expect(1, 918000, '\p{^Is_VS=true}', "");
    Expect(1, 918000, '\P{Is_VS=true}', "");
    Expect(0, 918000, '\P{^Is_VS=true}', "");
    Expect(1, 917999, '\p{Is_VS=-	True}', "");
    Expect(0, 917999, '\p{^Is_VS=-	True}', "");
    Expect(0, 917999, '\P{Is_VS=-	True}', "");
    Expect(1, 917999, '\P{^Is_VS=-	True}', "");
    Expect(0, 918000, '\p{Is_VS=-	True}', "");
    Expect(1, 918000, '\p{^Is_VS=-	True}', "");
    Expect(1, 918000, '\P{Is_VS=-	True}', "");
    Expect(0, 918000, '\P{^Is_VS=-	True}', "");
    Error('\p{wordbreak}');
    Error('\P{wordbreak}');
    Error('\p{wb}');
    Error('\P{wb}');
    Error('\p{Word_Break=/a/cr}');
    Error('\P{Word_Break=/a/cr}');
    Expect(1, 13, '\p{Word_Break=cr}', "");
    Expect(0, 13, '\p{^Word_Break=cr}', "");
    Expect(0, 13, '\P{Word_Break=cr}', "");
    Expect(1, 13, '\P{^Word_Break=cr}', "");
    Expect(0, 14, '\p{Word_Break=cr}', "");
    Expect(1, 14, '\p{^Word_Break=cr}', "");
    Expect(1, 14, '\P{Word_Break=cr}', "");
    Expect(0, 14, '\P{^Word_Break=cr}', "");
    Expect(1, 13, '\p{Word_Break=_-CR}', "");
    Expect(0, 13, '\p{^Word_Break=_-CR}', "");
    Expect(0, 13, '\P{Word_Break=_-CR}', "");
    Expect(1, 13, '\P{^Word_Break=_-CR}', "");
    Expect(0, 14, '\p{Word_Break=_-CR}', "");
    Expect(1, 14, '\p{^Word_Break=_-CR}', "");
    Expect(1, 14, '\P{Word_Break=_-CR}', "");
    Expect(0, 14, '\P{^Word_Break=_-CR}', "");
    Error('\p{WB=_-CR:=}');
    Error('\P{WB=_-CR:=}');
    Expect(1, 13, '\p{WB=cr}', "");
    Expect(0, 13, '\p{^WB=cr}', "");
    Expect(0, 13, '\P{WB=cr}', "");
    Expect(1, 13, '\P{^WB=cr}', "");
    Expect(0, 14, '\p{WB=cr}', "");
    Expect(1, 14, '\p{^WB=cr}', "");
    Expect(1, 14, '\P{WB=cr}', "");
    Expect(0, 14, '\P{^WB=cr}', "");
    Expect(1, 13, '\p{WB=CR}', "");
    Expect(0, 13, '\p{^WB=CR}', "");
    Expect(0, 13, '\P{WB=CR}', "");
    Expect(1, 13, '\P{^WB=CR}', "");
    Expect(0, 14, '\p{WB=CR}', "");
    Expect(1, 14, '\p{^WB=CR}', "");
    Expect(1, 14, '\P{WB=CR}', "");
    Expect(0, 14, '\P{^WB=CR}', "");
    Error('\p{Is_Word_Break=:= _CR}');
    Error('\P{Is_Word_Break=:= _CR}');
    Expect(1, 13, '\p{Is_Word_Break:cr}', "");
    Expect(0, 13, '\p{^Is_Word_Break:cr}', "");
    Expect(0, 13, '\P{Is_Word_Break:cr}', "");
    Expect(1, 13, '\P{^Is_Word_Break:cr}', "");
    Expect(0, 14, '\p{Is_Word_Break:cr}', "");
    Expect(1, 14, '\p{^Is_Word_Break:cr}', "");
    Expect(1, 14, '\P{Is_Word_Break:cr}', "");
    Expect(0, 14, '\P{^Is_Word_Break:cr}', "");
    Expect(1, 13, '\p{Is_Word_Break=	CR}', "");
    Expect(0, 13, '\p{^Is_Word_Break=	CR}', "");
    Expect(0, 13, '\P{Is_Word_Break=	CR}', "");
    Expect(1, 13, '\P{^Is_Word_Break=	CR}', "");
    Expect(0, 14, '\p{Is_Word_Break=	CR}', "");
    Expect(1, 14, '\p{^Is_Word_Break=	CR}', "");
    Expect(1, 14, '\P{Is_Word_Break=	CR}', "");
    Expect(0, 14, '\P{^Is_Word_Break=	CR}', "");
    Error('\p{Is_WB=_CR/a/}');
    Error('\P{Is_WB=_CR/a/}');
    Expect(1, 13, '\p{Is_WB=cr}', "");
    Expect(0, 13, '\p{^Is_WB=cr}', "");
    Expect(0, 13, '\P{Is_WB=cr}', "");
    Expect(1, 13, '\P{^Is_WB=cr}', "");
    Expect(0, 14, '\p{Is_WB=cr}', "");
    Expect(1, 14, '\p{^Is_WB=cr}', "");
    Expect(1, 14, '\P{Is_WB=cr}', "");
    Expect(0, 14, '\P{^Is_WB=cr}', "");
    Expect(1, 13, '\p{Is_WB= cr}', "");
    Expect(0, 13, '\p{^Is_WB= cr}', "");
    Expect(0, 13, '\P{Is_WB= cr}', "");
    Expect(1, 13, '\P{^Is_WB= cr}', "");
    Expect(0, 14, '\p{Is_WB= cr}', "");
    Expect(1, 14, '\p{^Is_WB= cr}', "");
    Expect(1, 14, '\P{Is_WB= cr}', "");
    Expect(0, 14, '\P{^Is_WB= cr}', "");
    Error('\p{Word_Break=_/a/Double_QUOTE}');
    Error('\P{Word_Break=_/a/Double_QUOTE}');
    Expect(1, 34, '\p{Word_Break:doublequote}', "");
    Expect(0, 34, '\p{^Word_Break:doublequote}', "");
    Expect(0, 34, '\P{Word_Break:doublequote}', "");
    Expect(1, 34, '\P{^Word_Break:doublequote}', "");
    Expect(0, 35, '\p{Word_Break:doublequote}', "");
    Expect(1, 35, '\p{^Word_Break:doublequote}', "");
    Expect(1, 35, '\P{Word_Break:doublequote}', "");
    Expect(0, 35, '\P{^Word_Break:doublequote}', "");
    Expect(1, 34, '\p{Word_Break= double_Quote}', "");
    Expect(0, 34, '\p{^Word_Break= double_Quote}', "");
    Expect(0, 34, '\P{Word_Break= double_Quote}', "");
    Expect(1, 34, '\P{^Word_Break= double_Quote}', "");
    Expect(0, 35, '\p{Word_Break= double_Quote}', "");
    Expect(1, 35, '\p{^Word_Break= double_Quote}', "");
    Expect(1, 35, '\P{Word_Break= double_Quote}', "");
    Expect(0, 35, '\P{^Word_Break= double_Quote}', "");
    Error('\p{WB= -DQ:=}');
    Error('\P{WB= -DQ:=}');
    Expect(1, 34, '\p{WB=dq}', "");
    Expect(0, 34, '\p{^WB=dq}', "");
    Expect(0, 34, '\P{WB=dq}', "");
    Expect(1, 34, '\P{^WB=dq}', "");
    Expect(0, 35, '\p{WB=dq}', "");
    Expect(1, 35, '\p{^WB=dq}', "");
    Expect(1, 35, '\P{WB=dq}', "");
    Expect(0, 35, '\P{^WB=dq}', "");
    Expect(1, 34, '\p{WB:		DQ}', "");
    Expect(0, 34, '\p{^WB:		DQ}', "");
    Expect(0, 34, '\P{WB:		DQ}', "");
    Expect(1, 34, '\P{^WB:		DQ}', "");
    Expect(0, 35, '\p{WB:		DQ}', "");
    Expect(1, 35, '\p{^WB:		DQ}', "");
    Expect(1, 35, '\P{WB:		DQ}', "");
    Expect(0, 35, '\P{^WB:		DQ}', "");
    Error('\p{Is_Word_Break=/a/-double_Quote}');
    Error('\P{Is_Word_Break=/a/-double_Quote}');
    Expect(1, 34, '\p{Is_Word_Break=doublequote}', "");
    Expect(0, 34, '\p{^Is_Word_Break=doublequote}', "");
    Expect(0, 34, '\P{Is_Word_Break=doublequote}', "");
    Expect(1, 34, '\P{^Is_Word_Break=doublequote}', "");
    Expect(0, 35, '\p{Is_Word_Break=doublequote}', "");
    Expect(1, 35, '\p{^Is_Word_Break=doublequote}', "");
    Expect(1, 35, '\P{Is_Word_Break=doublequote}', "");
    Expect(0, 35, '\P{^Is_Word_Break=doublequote}', "");
    Expect(1, 34, '\p{Is_Word_Break: -DOUBLE_Quote}', "");
    Expect(0, 34, '\p{^Is_Word_Break: -DOUBLE_Quote}', "");
    Expect(0, 34, '\P{Is_Word_Break: -DOUBLE_Quote}', "");
    Expect(1, 34, '\P{^Is_Word_Break: -DOUBLE_Quote}', "");
    Expect(0, 35, '\p{Is_Word_Break: -DOUBLE_Quote}', "");
    Expect(1, 35, '\p{^Is_Word_Break: -DOUBLE_Quote}', "");
    Expect(1, 35, '\P{Is_Word_Break: -DOUBLE_Quote}', "");
    Expect(0, 35, '\P{^Is_Word_Break: -DOUBLE_Quote}', "");
    Error('\p{Is_WB=  DQ:=}');
    Error('\P{Is_WB=  DQ:=}');
    Expect(1, 34, '\p{Is_WB=dq}', "");
    Expect(0, 34, '\p{^Is_WB=dq}', "");
    Expect(0, 34, '\P{Is_WB=dq}', "");
    Expect(1, 34, '\P{^Is_WB=dq}', "");
    Expect(0, 35, '\p{Is_WB=dq}', "");
    Expect(1, 35, '\p{^Is_WB=dq}', "");
    Expect(1, 35, '\P{Is_WB=dq}', "");
    Expect(0, 35, '\P{^Is_WB=dq}', "");
    Expect(1, 34, '\p{Is_WB:    	dq}', "");
    Expect(0, 34, '\p{^Is_WB:    	dq}', "");
    Expect(0, 34, '\P{Is_WB:    	dq}', "");
    Expect(1, 34, '\P{^Is_WB:    	dq}', "");
    Expect(0, 35, '\p{Is_WB:    	dq}', "");
    Expect(1, 35, '\p{^Is_WB:    	dq}', "");
    Expect(1, 35, '\P{Is_WB:    	dq}', "");
    Expect(0, 35, '\P{^Is_WB:    	dq}', "");
    Error('\p{Word_Break=/a/E_base}');
    Error('\P{Word_Break=/a/E_base}');
    Expect(1, 129501, '\p{Word_Break=ebase}', "");
    Expect(0, 129501, '\p{^Word_Break=ebase}', "");
    Expect(0, 129501, '\P{Word_Break=ebase}', "");
    Expect(1, 129501, '\P{^Word_Break=ebase}', "");
    Expect(0, 129502, '\p{Word_Break=ebase}', "");
    Expect(1, 129502, '\p{^Word_Break=ebase}', "");
    Expect(1, 129502, '\P{Word_Break=ebase}', "");
    Expect(0, 129502, '\P{^Word_Break=ebase}', "");
    Expect(1, 129501, '\p{Word_Break=--E_Base}', "");
    Expect(0, 129501, '\p{^Word_Break=--E_Base}', "");
    Expect(0, 129501, '\P{Word_Break=--E_Base}', "");
    Expect(1, 129501, '\P{^Word_Break=--E_Base}', "");
    Expect(0, 129502, '\p{Word_Break=--E_Base}', "");
    Expect(1, 129502, '\p{^Word_Break=--E_Base}', "");
    Expect(1, 129502, '\P{Word_Break=--E_Base}', "");
    Expect(0, 129502, '\P{^Word_Break=--E_Base}', "");
    Error('\p{WB=_:=EB}');
    Error('\P{WB=_:=EB}');
    Expect(1, 129501, '\p{WB:eb}', "");
    Expect(0, 129501, '\p{^WB:eb}', "");
    Expect(0, 129501, '\P{WB:eb}', "");
    Expect(1, 129501, '\P{^WB:eb}', "");
    Expect(0, 129502, '\p{WB:eb}', "");
    Expect(1, 129502, '\p{^WB:eb}', "");
    Expect(1, 129502, '\P{WB:eb}', "");
    Expect(0, 129502, '\P{^WB:eb}', "");
    Expect(1, 129501, '\p{WB=-eb}', "");
    Expect(0, 129501, '\p{^WB=-eb}', "");
    Expect(0, 129501, '\P{WB=-eb}', "");
    Expect(1, 129501, '\P{^WB=-eb}', "");
    Expect(0, 129502, '\p{WB=-eb}', "");
    Expect(1, 129502, '\p{^WB=-eb}', "");
    Expect(1, 129502, '\P{WB=-eb}', "");
    Expect(0, 129502, '\P{^WB=-eb}', "");
    Error('\p{Is_Word_Break:   	-E_BASE:=}');
    Error('\P{Is_Word_Break:   	-E_BASE:=}');
    Expect(1, 129501, '\p{Is_Word_Break=ebase}', "");
    Expect(0, 129501, '\p{^Is_Word_Break=ebase}', "");
    Expect(0, 129501, '\P{Is_Word_Break=ebase}', "");
    Expect(1, 129501, '\P{^Is_Word_Break=ebase}', "");
    Expect(0, 129502, '\p{Is_Word_Break=ebase}', "");
    Expect(1, 129502, '\p{^Is_Word_Break=ebase}', "");
    Expect(1, 129502, '\P{Is_Word_Break=ebase}', "");
    Expect(0, 129502, '\P{^Is_Word_Break=ebase}', "");
    Expect(1, 129501, '\p{Is_Word_Break=-E_BASE}', "");
    Expect(0, 129501, '\p{^Is_Word_Break=-E_BASE}', "");
    Expect(0, 129501, '\P{Is_Word_Break=-E_BASE}', "");
    Expect(1, 129501, '\P{^Is_Word_Break=-E_BASE}', "");
    Expect(0, 129502, '\p{Is_Word_Break=-E_BASE}', "");
    Expect(1, 129502, '\p{^Is_Word_Break=-E_BASE}', "");
    Expect(1, 129502, '\P{Is_Word_Break=-E_BASE}', "");
    Expect(0, 129502, '\P{^Is_Word_Break=-E_BASE}', "");
    Error('\p{Is_WB=/a/-_EB}');
    Error('\P{Is_WB=/a/-_EB}');
    Expect(1, 129501, '\p{Is_WB=eb}', "");
    Expect(0, 129501, '\p{^Is_WB=eb}', "");
    Expect(0, 129501, '\P{Is_WB=eb}', "");
    Expect(1, 129501, '\P{^Is_WB=eb}', "");
    Expect(0, 129502, '\p{Is_WB=eb}', "");
    Expect(1, 129502, '\p{^Is_WB=eb}', "");
    Expect(1, 129502, '\P{Is_WB=eb}', "");
    Expect(0, 129502, '\P{^Is_WB=eb}', "");
    Expect(1, 129501, '\p{Is_WB=	_EB}', "");
    Expect(0, 129501, '\p{^Is_WB=	_EB}', "");
    Expect(0, 129501, '\P{Is_WB=	_EB}', "");
    Expect(1, 129501, '\P{^Is_WB=	_EB}', "");
    Expect(0, 129502, '\p{Is_WB=	_EB}', "");
    Expect(1, 129502, '\p{^Is_WB=	_EB}', "");
    Expect(1, 129502, '\P{Is_WB=	_EB}', "");
    Expect(0, 129502, '\P{^Is_WB=	_EB}', "");
    Error('\p{Word_Break:   /a/ 	E_Base_gaz}');
    Error('\P{Word_Break:   /a/ 	E_Base_gaz}');
    Expect(1, 128105, '\p{Word_Break=ebasegaz}', "");
    Expect(0, 128105, '\p{^Word_Break=ebasegaz}', "");
    Expect(0, 128105, '\P{Word_Break=ebasegaz}', "");
    Expect(1, 128105, '\P{^Word_Break=ebasegaz}', "");
    Expect(0, 128106, '\p{Word_Break=ebasegaz}', "");
    Expect(1, 128106, '\p{^Word_Break=ebasegaz}', "");
    Expect(1, 128106, '\P{Word_Break=ebasegaz}', "");
    Expect(0, 128106, '\P{^Word_Break=ebasegaz}', "");
    Expect(1, 128105, '\p{Word_Break=--e_BASE_GAZ}', "");
    Expect(0, 128105, '\p{^Word_Break=--e_BASE_GAZ}', "");
    Expect(0, 128105, '\P{Word_Break=--e_BASE_GAZ}', "");
    Expect(1, 128105, '\P{^Word_Break=--e_BASE_GAZ}', "");
    Expect(0, 128106, '\p{Word_Break=--e_BASE_GAZ}', "");
    Expect(1, 128106, '\p{^Word_Break=--e_BASE_GAZ}', "");
    Expect(1, 128106, '\P{Word_Break=--e_BASE_GAZ}', "");
    Expect(0, 128106, '\P{^Word_Break=--e_BASE_GAZ}', "");
    Error('\p{WB=/a/_-EBG}');
    Error('\P{WB=/a/_-EBG}');
    Expect(1, 128105, '\p{WB=ebg}', "");
    Expect(0, 128105, '\p{^WB=ebg}', "");
    Expect(0, 128105, '\P{WB=ebg}', "");
    Expect(1, 128105, '\P{^WB=ebg}', "");
    Expect(0, 128106, '\p{WB=ebg}', "");
    Expect(1, 128106, '\p{^WB=ebg}', "");
    Expect(1, 128106, '\P{WB=ebg}', "");
    Expect(0, 128106, '\P{^WB=ebg}', "");
    Expect(1, 128105, '\p{WB= 	ebg}', "");
    Expect(0, 128105, '\p{^WB= 	ebg}', "");
    Expect(0, 128105, '\P{WB= 	ebg}', "");
    Expect(1, 128105, '\P{^WB= 	ebg}', "");
    Expect(0, 128106, '\p{WB= 	ebg}', "");
    Expect(1, 128106, '\p{^WB= 	ebg}', "");
    Expect(1, 128106, '\P{WB= 	ebg}', "");
    Expect(0, 128106, '\P{^WB= 	ebg}', "");
    Error('\p{Is_Word_Break: E_Base_GAZ:=}');
    Error('\P{Is_Word_Break: E_Base_GAZ:=}');
    Expect(1, 128105, '\p{Is_Word_Break=ebasegaz}', "");
    Expect(0, 128105, '\p{^Is_Word_Break=ebasegaz}', "");
    Expect(0, 128105, '\P{Is_Word_Break=ebasegaz}', "");
    Expect(1, 128105, '\P{^Is_Word_Break=ebasegaz}', "");
    Expect(0, 128106, '\p{Is_Word_Break=ebasegaz}', "");
    Expect(1, 128106, '\p{^Is_Word_Break=ebasegaz}', "");
    Expect(1, 128106, '\P{Is_Word_Break=ebasegaz}', "");
    Expect(0, 128106, '\P{^Is_Word_Break=ebasegaz}', "");
    Expect(1, 128105, '\p{Is_Word_Break=_E_Base_GAZ}', "");
    Expect(0, 128105, '\p{^Is_Word_Break=_E_Base_GAZ}', "");
    Expect(0, 128105, '\P{Is_Word_Break=_E_Base_GAZ}', "");
    Expect(1, 128105, '\P{^Is_Word_Break=_E_Base_GAZ}', "");
    Expect(0, 128106, '\p{Is_Word_Break=_E_Base_GAZ}', "");
    Expect(1, 128106, '\p{^Is_Word_Break=_E_Base_GAZ}', "");
    Expect(1, 128106, '\P{Is_Word_Break=_E_Base_GAZ}', "");
    Expect(0, 128106, '\P{^Is_Word_Break=_E_Base_GAZ}', "");
    Error('\p{Is_WB=	:=EBG}');
    Error('\P{Is_WB=	:=EBG}');
    Expect(1, 128105, '\p{Is_WB=ebg}', "");
    Expect(0, 128105, '\p{^Is_WB=ebg}', "");
    Expect(0, 128105, '\P{Is_WB=ebg}', "");
    Expect(1, 128105, '\P{^Is_WB=ebg}', "");
    Expect(0, 128106, '\p{Is_WB=ebg}', "");
    Expect(1, 128106, '\p{^Is_WB=ebg}', "");
    Expect(1, 128106, '\P{Is_WB=ebg}', "");
    Expect(0, 128106, '\P{^Is_WB=ebg}', "");
    Expect(1, 128105, '\p{Is_WB=-EBG}', "");
    Expect(0, 128105, '\p{^Is_WB=-EBG}', "");
    Expect(0, 128105, '\P{Is_WB=-EBG}', "");
    Expect(1, 128105, '\P{^Is_WB=-EBG}', "");
    Expect(0, 128106, '\p{Is_WB=-EBG}', "");
    Expect(1, 128106, '\p{^Is_WB=-EBG}', "");
    Expect(1, 128106, '\P{Is_WB=-EBG}', "");
    Expect(0, 128106, '\P{^Is_WB=-EBG}', "");
    Error('\p{Word_Break= :=E_Modifier}');
    Error('\P{Word_Break= :=E_Modifier}');
    Expect(1, 127999, '\p{Word_Break=emodifier}', "");
    Expect(0, 127999, '\p{^Word_Break=emodifier}', "");
    Expect(0, 127999, '\P{Word_Break=emodifier}', "");
    Expect(1, 127999, '\P{^Word_Break=emodifier}', "");
    Expect(0, 128000, '\p{Word_Break=emodifier}', "");
    Expect(1, 128000, '\p{^Word_Break=emodifier}', "");
    Expect(1, 128000, '\P{Word_Break=emodifier}', "");
    Expect(0, 128000, '\P{^Word_Break=emodifier}', "");
    Expect(1, 127999, '\p{Word_Break=_E_Modifier}', "");
    Expect(0, 127999, '\p{^Word_Break=_E_Modifier}', "");
    Expect(0, 127999, '\P{Word_Break=_E_Modifier}', "");
    Expect(1, 127999, '\P{^Word_Break=_E_Modifier}', "");
    Expect(0, 128000, '\p{Word_Break=_E_Modifier}', "");
    Expect(1, 128000, '\p{^Word_Break=_E_Modifier}', "");
    Expect(1, 128000, '\P{Word_Break=_E_Modifier}', "");
    Expect(0, 128000, '\P{^Word_Break=_E_Modifier}', "");
    Error('\p{WB=_:=em}');
    Error('\P{WB=_:=em}');
    Expect(1, 127999, '\p{WB=em}', "");
    Expect(0, 127999, '\p{^WB=em}', "");
    Expect(0, 127999, '\P{WB=em}', "");
    Expect(1, 127999, '\P{^WB=em}', "");
    Expect(0, 128000, '\p{WB=em}', "");
    Expect(1, 128000, '\p{^WB=em}', "");
    Expect(1, 128000, '\P{WB=em}', "");
    Expect(0, 128000, '\P{^WB=em}', "");
    Expect(1, 127999, '\p{WB=-_EM}', "");
    Expect(0, 127999, '\p{^WB=-_EM}', "");
    Expect(0, 127999, '\P{WB=-_EM}', "");
    Expect(1, 127999, '\P{^WB=-_EM}', "");
    Expect(0, 128000, '\p{WB=-_EM}', "");
    Expect(1, 128000, '\p{^WB=-_EM}', "");
    Expect(1, 128000, '\P{WB=-_EM}', "");
    Expect(0, 128000, '\P{^WB=-_EM}', "");
    Error('\p{Is_Word_Break=:= -E_MODIFIER}');
    Error('\P{Is_Word_Break=:= -E_MODIFIER}');
    Expect(1, 127999, '\p{Is_Word_Break=emodifier}', "");
    Expect(0, 127999, '\p{^Is_Word_Break=emodifier}', "");
    Expect(0, 127999, '\P{Is_Word_Break=emodifier}', "");
    Expect(1, 127999, '\P{^Is_Word_Break=emodifier}', "");
    Expect(0, 128000, '\p{Is_Word_Break=emodifier}', "");
    Expect(1, 128000, '\p{^Is_Word_Break=emodifier}', "");
    Expect(1, 128000, '\P{Is_Word_Break=emodifier}', "");
    Expect(0, 128000, '\P{^Is_Word_Break=emodifier}', "");
    Expect(1, 127999, '\p{Is_Word_Break= E_MODIFIER}', "");
    Expect(0, 127999, '\p{^Is_Word_Break= E_MODIFIER}', "");
    Expect(0, 127999, '\P{Is_Word_Break= E_MODIFIER}', "");
    Expect(1, 127999, '\P{^Is_Word_Break= E_MODIFIER}', "");
    Expect(0, 128000, '\p{Is_Word_Break= E_MODIFIER}', "");
    Expect(1, 128000, '\p{^Is_Word_Break= E_MODIFIER}', "");
    Expect(1, 128000, '\P{Is_Word_Break= E_MODIFIER}', "");
    Expect(0, 128000, '\P{^Is_Word_Break= E_MODIFIER}', "");
    Error('\p{Is_WB=-/a/EM}');
    Error('\P{Is_WB=-/a/EM}');
    Expect(1, 127999, '\p{Is_WB=em}', "");
    Expect(0, 127999, '\p{^Is_WB=em}', "");
    Expect(0, 127999, '\P{Is_WB=em}', "");
    Expect(1, 127999, '\P{^Is_WB=em}', "");
    Expect(0, 128000, '\p{Is_WB=em}', "");
    Expect(1, 128000, '\p{^Is_WB=em}', "");
    Expect(1, 128000, '\P{Is_WB=em}', "");
    Expect(0, 128000, '\P{^Is_WB=em}', "");
    Expect(1, 127999, '\p{Is_WB=_-EM}', "");
    Expect(0, 127999, '\p{^Is_WB=_-EM}', "");
    Expect(0, 127999, '\P{Is_WB=_-EM}', "");
    Expect(1, 127999, '\P{^Is_WB=_-EM}', "");
    Expect(0, 128000, '\p{Is_WB=_-EM}', "");
    Expect(1, 128000, '\p{^Is_WB=_-EM}', "");
    Expect(1, 128000, '\P{Is_WB=_-EM}', "");
    Expect(0, 128000, '\P{^Is_WB=_-EM}', "");
    Error('\p{Word_Break:	_EXTENDNUMLET:=}');
    Error('\P{Word_Break:	_EXTENDNUMLET:=}');
    Expect(1, 65343, '\p{Word_Break=extendnumlet}', "");
    Expect(0, 65343, '\p{^Word_Break=extendnumlet}', "");
    Expect(0, 65343, '\P{Word_Break=extendnumlet}', "");
    Expect(1, 65343, '\P{^Word_Break=extendnumlet}', "");
    Expect(0, 65344, '\p{Word_Break=extendnumlet}', "");
    Expect(1, 65344, '\p{^Word_Break=extendnumlet}', "");
    Expect(1, 65344, '\P{Word_Break=extendnumlet}', "");
    Expect(0, 65344, '\P{^Word_Break=extendnumlet}', "");
    Expect(1, 65343, '\p{Word_Break=-ExtendNumLet}', "");
    Expect(0, 65343, '\p{^Word_Break=-ExtendNumLet}', "");
    Expect(0, 65343, '\P{Word_Break=-ExtendNumLet}', "");
    Expect(1, 65343, '\P{^Word_Break=-ExtendNumLet}', "");
    Expect(0, 65344, '\p{Word_Break=-ExtendNumLet}', "");
    Expect(1, 65344, '\p{^Word_Break=-ExtendNumLet}', "");
    Expect(1, 65344, '\P{Word_Break=-ExtendNumLet}', "");
    Expect(0, 65344, '\P{^Word_Break=-ExtendNumLet}', "");
    Error('\p{WB=	:=ex}');
    Error('\P{WB=	:=ex}');
    Expect(1, 65343, '\p{WB=ex}', "");
    Expect(0, 65343, '\p{^WB=ex}', "");
    Expect(0, 65343, '\P{WB=ex}', "");
    Expect(1, 65343, '\P{^WB=ex}', "");
    Expect(0, 65344, '\p{WB=ex}', "");
    Expect(1, 65344, '\p{^WB=ex}', "");
    Expect(1, 65344, '\P{WB=ex}', "");
    Expect(0, 65344, '\P{^WB=ex}', "");
    Expect(1, 65343, '\p{WB=--EX}', "");
    Expect(0, 65343, '\p{^WB=--EX}', "");
    Expect(0, 65343, '\P{WB=--EX}', "");
    Expect(1, 65343, '\P{^WB=--EX}', "");
    Expect(0, 65344, '\p{WB=--EX}', "");
    Expect(1, 65344, '\p{^WB=--EX}', "");
    Expect(1, 65344, '\P{WB=--EX}', "");
    Expect(0, 65344, '\P{^WB=--EX}', "");
    Error('\p{Is_Word_Break=-:=ExtendNumLet}');
    Error('\P{Is_Word_Break=-:=ExtendNumLet}');
    Expect(1, 65343, '\p{Is_Word_Break=extendnumlet}', "");
    Expect(0, 65343, '\p{^Is_Word_Break=extendnumlet}', "");
    Expect(0, 65343, '\P{Is_Word_Break=extendnumlet}', "");
    Expect(1, 65343, '\P{^Is_Word_Break=extendnumlet}', "");
    Expect(0, 65344, '\p{Is_Word_Break=extendnumlet}', "");
    Expect(1, 65344, '\p{^Is_Word_Break=extendnumlet}', "");
    Expect(1, 65344, '\P{Is_Word_Break=extendnumlet}', "");
    Expect(0, 65344, '\P{^Is_Word_Break=extendnumlet}', "");
    Expect(1, 65343, '\p{Is_Word_Break=-	extendnumlet}', "");
    Expect(0, 65343, '\p{^Is_Word_Break=-	extendnumlet}', "");
    Expect(0, 65343, '\P{Is_Word_Break=-	extendnumlet}', "");
    Expect(1, 65343, '\P{^Is_Word_Break=-	extendnumlet}', "");
    Expect(0, 65344, '\p{Is_Word_Break=-	extendnumlet}', "");
    Expect(1, 65344, '\p{^Is_Word_Break=-	extendnumlet}', "");
    Expect(1, 65344, '\P{Is_Word_Break=-	extendnumlet}', "");
    Expect(0, 65344, '\P{^Is_Word_Break=-	extendnumlet}', "");
    Error('\p{Is_WB= 	ex/a/}');
    Error('\P{Is_WB= 	ex/a/}');
    Expect(1, 65343, '\p{Is_WB=ex}', "");
    Expect(0, 65343, '\p{^Is_WB=ex}', "");
    Expect(0, 65343, '\P{Is_WB=ex}', "");
    Expect(1, 65343, '\P{^Is_WB=ex}', "");
    Expect(0, 65344, '\p{Is_WB=ex}', "");
    Expect(1, 65344, '\p{^Is_WB=ex}', "");
    Expect(1, 65344, '\P{Is_WB=ex}', "");
    Expect(0, 65344, '\P{^Is_WB=ex}', "");
    Expect(1, 65343, '\p{Is_WB:   _	EX}', "");
    Expect(0, 65343, '\p{^Is_WB:   _	EX}', "");
    Expect(0, 65343, '\P{Is_WB:   _	EX}', "");
    Expect(1, 65343, '\P{^Is_WB:   _	EX}', "");
    Expect(0, 65344, '\p{Is_WB:   _	EX}', "");
    Expect(1, 65344, '\p{^Is_WB:   _	EX}', "");
    Expect(1, 65344, '\P{Is_WB:   _	EX}', "");
    Expect(0, 65344, '\P{^Is_WB:   _	EX}', "");
    Error('\p{Word_Break=_/a/EXTEND}');
    Error('\P{Word_Break=_/a/EXTEND}');
    Expect(1, 917999, '\p{Word_Break=extend}', "");
    Expect(0, 917999, '\p{^Word_Break=extend}', "");
    Expect(0, 917999, '\P{Word_Break=extend}', "");
    Expect(1, 917999, '\P{^Word_Break=extend}', "");
    Expect(0, 918000, '\p{Word_Break=extend}', "");
    Expect(1, 918000, '\p{^Word_Break=extend}', "");
    Expect(1, 918000, '\P{Word_Break=extend}', "");
    Expect(0, 918000, '\P{^Word_Break=extend}', "");
    Expect(1, 917999, '\p{Word_Break=		EXTEND}', "");
    Expect(0, 917999, '\p{^Word_Break=		EXTEND}', "");
    Expect(0, 917999, '\P{Word_Break=		EXTEND}', "");
    Expect(1, 917999, '\P{^Word_Break=		EXTEND}', "");
    Expect(0, 918000, '\p{Word_Break=		EXTEND}', "");
    Expect(1, 918000, '\p{^Word_Break=		EXTEND}', "");
    Expect(1, 918000, '\P{Word_Break=		EXTEND}', "");
    Expect(0, 918000, '\P{^Word_Break=		EXTEND}', "");
    Error('\p{WB=:=_	Extend}');
    Error('\P{WB=:=_	Extend}');
    Expect(1, 917999, '\p{WB=extend}', "");
    Expect(0, 917999, '\p{^WB=extend}', "");
    Expect(0, 917999, '\P{WB=extend}', "");
    Expect(1, 917999, '\P{^WB=extend}', "");
    Expect(0, 918000, '\p{WB=extend}', "");
    Expect(1, 918000, '\p{^WB=extend}', "");
    Expect(1, 918000, '\P{WB=extend}', "");
    Expect(0, 918000, '\P{^WB=extend}', "");
    Expect(1, 917999, '\p{WB:_	Extend}', "");
    Expect(0, 917999, '\p{^WB:_	Extend}', "");
    Expect(0, 917999, '\P{WB:_	Extend}', "");
    Expect(1, 917999, '\P{^WB:_	Extend}', "");
    Expect(0, 918000, '\p{WB:_	Extend}', "");
    Expect(1, 918000, '\p{^WB:_	Extend}', "");
    Expect(1, 918000, '\P{WB:_	Extend}', "");
    Expect(0, 918000, '\P{^WB:_	Extend}', "");
    Error('\p{Is_Word_Break=/a/EXTEND}');
    Error('\P{Is_Word_Break=/a/EXTEND}');
    Expect(1, 917999, '\p{Is_Word_Break=extend}', "");
    Expect(0, 917999, '\p{^Is_Word_Break=extend}', "");
    Expect(0, 917999, '\P{Is_Word_Break=extend}', "");
    Expect(1, 917999, '\P{^Is_Word_Break=extend}', "");
    Expect(0, 918000, '\p{Is_Word_Break=extend}', "");
    Expect(1, 918000, '\p{^Is_Word_Break=extend}', "");
    Expect(1, 918000, '\P{Is_Word_Break=extend}', "");
    Expect(0, 918000, '\P{^Is_Word_Break=extend}', "");
    Expect(1, 917999, '\p{Is_Word_Break=	_EXTEND}', "");
    Expect(0, 917999, '\p{^Is_Word_Break=	_EXTEND}', "");
    Expect(0, 917999, '\P{Is_Word_Break=	_EXTEND}', "");
    Expect(1, 917999, '\P{^Is_Word_Break=	_EXTEND}', "");
    Expect(0, 918000, '\p{Is_Word_Break=	_EXTEND}', "");
    Expect(1, 918000, '\p{^Is_Word_Break=	_EXTEND}', "");
    Expect(1, 918000, '\P{Is_Word_Break=	_EXTEND}', "");
    Expect(0, 918000, '\P{^Is_Word_Break=	_EXTEND}', "");
    Error('\p{Is_WB=:=-_Extend}');
    Error('\P{Is_WB=:=-_Extend}');
    Expect(1, 917999, '\p{Is_WB=extend}', "");
    Expect(0, 917999, '\p{^Is_WB=extend}', "");
    Expect(0, 917999, '\P{Is_WB=extend}', "");
    Expect(1, 917999, '\P{^Is_WB=extend}', "");
    Expect(0, 918000, '\p{Is_WB=extend}', "");
    Expect(1, 918000, '\p{^Is_WB=extend}', "");
    Expect(1, 918000, '\P{Is_WB=extend}', "");
    Expect(0, 918000, '\P{^Is_WB=extend}', "");
    Expect(1, 917999, '\p{Is_WB:   	EXTEND}', "");
    Expect(0, 917999, '\p{^Is_WB:   	EXTEND}', "");
    Expect(0, 917999, '\P{Is_WB:   	EXTEND}', "");
    Expect(1, 917999, '\P{^Is_WB:   	EXTEND}', "");
    Expect(0, 918000, '\p{Is_WB:   	EXTEND}', "");
    Expect(1, 918000, '\p{^Is_WB:   	EXTEND}', "");
    Expect(1, 918000, '\P{Is_WB:   	EXTEND}', "");
    Expect(0, 918000, '\P{^Is_WB:   	EXTEND}', "");
    Error('\p{Word_Break=:=Format}');
    Error('\P{Word_Break=:=Format}');
    Expect(1, 917505, '\p{Word_Break=format}', "");
    Expect(0, 917505, '\p{^Word_Break=format}', "");
    Expect(0, 917505, '\P{Word_Break=format}', "");
    Expect(1, 917505, '\P{^Word_Break=format}', "");
    Expect(0, 917506, '\p{Word_Break=format}', "");
    Expect(1, 917506, '\p{^Word_Break=format}', "");
    Expect(1, 917506, '\P{Word_Break=format}', "");
    Expect(0, 917506, '\P{^Word_Break=format}', "");
    Expect(1, 917505, '\p{Word_Break=		FORMAT}', "");
    Expect(0, 917505, '\p{^Word_Break=		FORMAT}', "");
    Expect(0, 917505, '\P{Word_Break=		FORMAT}', "");
    Expect(1, 917505, '\P{^Word_Break=		FORMAT}', "");
    Expect(0, 917506, '\p{Word_Break=		FORMAT}', "");
    Expect(1, 917506, '\p{^Word_Break=		FORMAT}', "");
    Expect(1, 917506, '\P{Word_Break=		FORMAT}', "");
    Expect(0, 917506, '\P{^Word_Break=		FORMAT}', "");
    Error('\p{WB=:=fo}');
    Error('\P{WB=:=fo}');
    Expect(1, 917505, '\p{WB=fo}', "");
    Expect(0, 917505, '\p{^WB=fo}', "");
    Expect(0, 917505, '\P{WB=fo}', "");
    Expect(1, 917505, '\P{^WB=fo}', "");
    Expect(0, 917506, '\p{WB=fo}', "");
    Expect(1, 917506, '\p{^WB=fo}', "");
    Expect(1, 917506, '\P{WB=fo}', "");
    Expect(0, 917506, '\P{^WB=fo}', "");
    Expect(1, 917505, '\p{WB=-FO}', "");
    Expect(0, 917505, '\p{^WB=-FO}', "");
    Expect(0, 917505, '\P{WB=-FO}', "");
    Expect(1, 917505, '\P{^WB=-FO}', "");
    Expect(0, 917506, '\p{WB=-FO}', "");
    Expect(1, 917506, '\p{^WB=-FO}', "");
    Expect(1, 917506, '\P{WB=-FO}', "");
    Expect(0, 917506, '\P{^WB=-FO}', "");
    Error('\p{Is_Word_Break= /a/Format}');
    Error('\P{Is_Word_Break= /a/Format}');
    Expect(1, 917505, '\p{Is_Word_Break=format}', "");
    Expect(0, 917505, '\p{^Is_Word_Break=format}', "");
    Expect(0, 917505, '\P{Is_Word_Break=format}', "");
    Expect(1, 917505, '\P{^Is_Word_Break=format}', "");
    Expect(0, 917506, '\p{Is_Word_Break=format}', "");
    Expect(1, 917506, '\p{^Is_Word_Break=format}', "");
    Expect(1, 917506, '\P{Is_Word_Break=format}', "");
    Expect(0, 917506, '\P{^Is_Word_Break=format}', "");
    Expect(1, 917505, '\p{Is_Word_Break=_-Format}', "");
    Expect(0, 917505, '\p{^Is_Word_Break=_-Format}', "");
    Expect(0, 917505, '\P{Is_Word_Break=_-Format}', "");
    Expect(1, 917505, '\P{^Is_Word_Break=_-Format}', "");
    Expect(0, 917506, '\p{Is_Word_Break=_-Format}', "");
    Expect(1, 917506, '\p{^Is_Word_Break=_-Format}', "");
    Expect(1, 917506, '\P{Is_Word_Break=_-Format}', "");
    Expect(0, 917506, '\P{^Is_Word_Break=_-Format}', "");
    Error('\p{Is_WB=-_fo/a/}');
    Error('\P{Is_WB=-_fo/a/}');
    Expect(1, 917505, '\p{Is_WB=fo}', "");
    Expect(0, 917505, '\p{^Is_WB=fo}', "");
    Expect(0, 917505, '\P{Is_WB=fo}', "");
    Expect(1, 917505, '\P{^Is_WB=fo}', "");
    Expect(0, 917506, '\p{Is_WB=fo}', "");
    Expect(1, 917506, '\p{^Is_WB=fo}', "");
    Expect(1, 917506, '\P{Is_WB=fo}', "");
    Expect(0, 917506, '\P{^Is_WB=fo}', "");
    Expect(1, 917505, '\p{Is_WB=-	FO}', "");
    Expect(0, 917505, '\p{^Is_WB=-	FO}', "");
    Expect(0, 917505, '\P{Is_WB=-	FO}', "");
    Expect(1, 917505, '\P{^Is_WB=-	FO}', "");
    Expect(0, 917506, '\p{Is_WB=-	FO}', "");
    Expect(1, 917506, '\p{^Is_WB=-	FO}', "");
    Expect(1, 917506, '\P{Is_WB=-	FO}', "");
    Expect(0, 917506, '\P{^Is_WB=-	FO}', "");
    Error('\p{Word_Break:-Glue_after_ZWJ:=}');
    Error('\P{Word_Break:-Glue_after_ZWJ:=}');
    Expect(1, 128658, '\p{Word_Break=glueafterzwj}', "");
    Expect(0, 128658, '\p{^Word_Break=glueafterzwj}', "");
    Expect(0, 128658, '\P{Word_Break=glueafterzwj}', "");
    Expect(1, 128658, '\P{^Word_Break=glueafterzwj}', "");
    Expect(0, 128659, '\p{Word_Break=glueafterzwj}', "");
    Expect(1, 128659, '\p{^Word_Break=glueafterzwj}', "");
    Expect(1, 128659, '\P{Word_Break=glueafterzwj}', "");
    Expect(0, 128659, '\P{^Word_Break=glueafterzwj}', "");
    Expect(1, 128658, '\p{Word_Break: GLUE_After_ZWJ}', "");
    Expect(0, 128658, '\p{^Word_Break: GLUE_After_ZWJ}', "");
    Expect(0, 128658, '\P{Word_Break: GLUE_After_ZWJ}', "");
    Expect(1, 128658, '\P{^Word_Break: GLUE_After_ZWJ}', "");
    Expect(0, 128659, '\p{Word_Break: GLUE_After_ZWJ}', "");
    Expect(1, 128659, '\p{^Word_Break: GLUE_After_ZWJ}', "");
    Expect(1, 128659, '\P{Word_Break: GLUE_After_ZWJ}', "");
    Expect(0, 128659, '\P{^Word_Break: GLUE_After_ZWJ}', "");
    Error('\p{WB=_:=GAZ}');
    Error('\P{WB=_:=GAZ}');
    Expect(1, 128658, '\p{WB=gaz}', "");
    Expect(0, 128658, '\p{^WB=gaz}', "");
    Expect(0, 128658, '\P{WB=gaz}', "");
    Expect(1, 128658, '\P{^WB=gaz}', "");
    Expect(0, 128659, '\p{WB=gaz}', "");
    Expect(1, 128659, '\p{^WB=gaz}', "");
    Expect(1, 128659, '\P{WB=gaz}', "");
    Expect(0, 128659, '\P{^WB=gaz}', "");
    Expect(1, 128658, '\p{WB=	GAZ}', "");
    Expect(0, 128658, '\p{^WB=	GAZ}', "");
    Expect(0, 128658, '\P{WB=	GAZ}', "");
    Expect(1, 128658, '\P{^WB=	GAZ}', "");
    Expect(0, 128659, '\p{WB=	GAZ}', "");
    Expect(1, 128659, '\p{^WB=	GAZ}', "");
    Expect(1, 128659, '\P{WB=	GAZ}', "");
    Expect(0, 128659, '\P{^WB=	GAZ}', "");
    Error('\p{Is_Word_Break=:=_Glue_AFTER_Zwj}');
    Error('\P{Is_Word_Break=:=_Glue_AFTER_Zwj}');
    Expect(1, 128658, '\p{Is_Word_Break=glueafterzwj}', "");
    Expect(0, 128658, '\p{^Is_Word_Break=glueafterzwj}', "");
    Expect(0, 128658, '\P{Is_Word_Break=glueafterzwj}', "");
    Expect(1, 128658, '\P{^Is_Word_Break=glueafterzwj}', "");
    Expect(0, 128659, '\p{Is_Word_Break=glueafterzwj}', "");
    Expect(1, 128659, '\p{^Is_Word_Break=glueafterzwj}', "");
    Expect(1, 128659, '\P{Is_Word_Break=glueafterzwj}', "");
    Expect(0, 128659, '\P{^Is_Word_Break=glueafterzwj}', "");
    Expect(1, 128658, '\p{Is_Word_Break=-	Glue_AFTER_Zwj}', "");
    Expect(0, 128658, '\p{^Is_Word_Break=-	Glue_AFTER_Zwj}', "");
    Expect(0, 128658, '\P{Is_Word_Break=-	Glue_AFTER_Zwj}', "");
    Expect(1, 128658, '\P{^Is_Word_Break=-	Glue_AFTER_Zwj}', "");
    Expect(0, 128659, '\p{Is_Word_Break=-	Glue_AFTER_Zwj}', "");
    Expect(1, 128659, '\p{^Is_Word_Break=-	Glue_AFTER_Zwj}', "");
    Expect(1, 128659, '\P{Is_Word_Break=-	Glue_AFTER_Zwj}', "");
    Expect(0, 128659, '\P{^Is_Word_Break=-	Glue_AFTER_Zwj}', "");
    Error('\p{Is_WB=/a/_-gaz}');
    Error('\P{Is_WB=/a/_-gaz}');
    Expect(1, 128658, '\p{Is_WB=gaz}', "");
    Expect(0, 128658, '\p{^Is_WB=gaz}', "");
    Expect(0, 128658, '\P{Is_WB=gaz}', "");
    Expect(1, 128658, '\P{^Is_WB=gaz}', "");
    Expect(0, 128659, '\p{Is_WB=gaz}', "");
    Expect(1, 128659, '\p{^Is_WB=gaz}', "");
    Expect(1, 128659, '\P{Is_WB=gaz}', "");
    Expect(0, 128659, '\P{^Is_WB=gaz}', "");
    Expect(1, 128658, '\p{Is_WB=_-gaz}', "");
    Expect(0, 128658, '\p{^Is_WB=_-gaz}', "");
    Expect(0, 128658, '\P{Is_WB=_-gaz}', "");
    Expect(1, 128658, '\P{^Is_WB=_-gaz}', "");
    Expect(0, 128659, '\p{Is_WB=_-gaz}', "");
    Expect(1, 128659, '\p{^Is_WB=_-gaz}', "");
    Expect(1, 128659, '\P{Is_WB=_-gaz}', "");
    Expect(0, 128659, '\P{^Is_WB=_-gaz}', "");
    Error('\p{Word_Break=- Hebrew_Letter:=}');
    Error('\P{Word_Break=- Hebrew_Letter:=}');
    Expect(1, 64335, '\p{Word_Break=hebrewletter}', "");
    Expect(0, 64335, '\p{^Word_Break=hebrewletter}', "");
    Expect(0, 64335, '\P{Word_Break=hebrewletter}', "");
    Expect(1, 64335, '\P{^Word_Break=hebrewletter}', "");
    Expect(0, 64336, '\p{Word_Break=hebrewletter}', "");
    Expect(1, 64336, '\p{^Word_Break=hebrewletter}', "");
    Expect(1, 64336, '\P{Word_Break=hebrewletter}', "");
    Expect(0, 64336, '\P{^Word_Break=hebrewletter}', "");
    Expect(1, 64335, '\p{Word_Break=	-Hebrew_letter}', "");
    Expect(0, 64335, '\p{^Word_Break=	-Hebrew_letter}', "");
    Expect(0, 64335, '\P{Word_Break=	-Hebrew_letter}', "");
    Expect(1, 64335, '\P{^Word_Break=	-Hebrew_letter}', "");
    Expect(0, 64336, '\p{Word_Break=	-Hebrew_letter}', "");
    Expect(1, 64336, '\p{^Word_Break=	-Hebrew_letter}', "");
    Expect(1, 64336, '\P{Word_Break=	-Hebrew_letter}', "");
    Expect(0, 64336, '\P{^Word_Break=	-Hebrew_letter}', "");
    Error('\p{WB=-_HL/a/}');
    Error('\P{WB=-_HL/a/}');
    Expect(1, 64335, '\p{WB=hl}', "");
    Expect(0, 64335, '\p{^WB=hl}', "");
    Expect(0, 64335, '\P{WB=hl}', "");
    Expect(1, 64335, '\P{^WB=hl}', "");
    Expect(0, 64336, '\p{WB=hl}', "");
    Expect(1, 64336, '\p{^WB=hl}', "");
    Expect(1, 64336, '\P{WB=hl}', "");
    Expect(0, 64336, '\P{^WB=hl}', "");
    Expect(1, 64335, '\p{WB=- HL}', "");
    Expect(0, 64335, '\p{^WB=- HL}', "");
    Expect(0, 64335, '\P{WB=- HL}', "");
    Expect(1, 64335, '\P{^WB=- HL}', "");
    Expect(0, 64336, '\p{WB=- HL}', "");
    Expect(1, 64336, '\p{^WB=- HL}', "");
    Expect(1, 64336, '\P{WB=- HL}', "");
    Expect(0, 64336, '\P{^WB=- HL}', "");
    Error('\p{Is_Word_Break:		HEBREW_letter:=}');
    Error('\P{Is_Word_Break:		HEBREW_letter:=}');
    Expect(1, 64335, '\p{Is_Word_Break=hebrewletter}', "");
    Expect(0, 64335, '\p{^Is_Word_Break=hebrewletter}', "");
    Expect(0, 64335, '\P{Is_Word_Break=hebrewletter}', "");
    Expect(1, 64335, '\P{^Is_Word_Break=hebrewletter}', "");
    Expect(0, 64336, '\p{Is_Word_Break=hebrewletter}', "");
    Expect(1, 64336, '\p{^Is_Word_Break=hebrewletter}', "");
    Expect(1, 64336, '\P{Is_Word_Break=hebrewletter}', "");
    Expect(0, 64336, '\P{^Is_Word_Break=hebrewletter}', "");
    Expect(1, 64335, '\p{Is_Word_Break=-Hebrew_letter}', "");
    Expect(0, 64335, '\p{^Is_Word_Break=-Hebrew_letter}', "");
    Expect(0, 64335, '\P{Is_Word_Break=-Hebrew_letter}', "");
    Expect(1, 64335, '\P{^Is_Word_Break=-Hebrew_letter}', "");
    Expect(0, 64336, '\p{Is_Word_Break=-Hebrew_letter}', "");
    Expect(1, 64336, '\p{^Is_Word_Break=-Hebrew_letter}', "");
    Expect(1, 64336, '\P{Is_Word_Break=-Hebrew_letter}', "");
    Expect(0, 64336, '\P{^Is_Word_Break=-Hebrew_letter}', "");
    Error('\p{Is_WB=	/a/hl}');
    Error('\P{Is_WB=	/a/hl}');
    Expect(1, 64335, '\p{Is_WB=hl}', "");
    Expect(0, 64335, '\p{^Is_WB=hl}', "");
    Expect(0, 64335, '\P{Is_WB=hl}', "");
    Expect(1, 64335, '\P{^Is_WB=hl}', "");
    Expect(0, 64336, '\p{Is_WB=hl}', "");
    Expect(1, 64336, '\p{^Is_WB=hl}', "");
    Expect(1, 64336, '\P{Is_WB=hl}', "");
    Expect(0, 64336, '\P{^Is_WB=hl}', "");
    Expect(1, 64335, '\p{Is_WB=	-HL}', "");
    Expect(0, 64335, '\p{^Is_WB=	-HL}', "");
    Expect(0, 64335, '\P{Is_WB=	-HL}', "");
    Expect(1, 64335, '\P{^Is_WB=	-HL}', "");
    Expect(0, 64336, '\p{Is_WB=	-HL}', "");
    Expect(1, 64336, '\p{^Is_WB=	-HL}', "");
    Expect(1, 64336, '\P{Is_WB=	-HL}', "");
    Expect(0, 64336, '\P{^Is_WB=	-HL}', "");
    Error('\p{Word_Break=:=katakana}');
    Error('\P{Word_Break=:=katakana}');
    Expect(1, 110592, '\p{Word_Break=katakana}', "");
    Expect(0, 110592, '\p{^Word_Break=katakana}', "");
    Expect(0, 110592, '\P{Word_Break=katakana}', "");
    Expect(1, 110592, '\P{^Word_Break=katakana}', "");
    Expect(0, 110593, '\p{Word_Break=katakana}', "");
    Expect(1, 110593, '\p{^Word_Break=katakana}', "");
    Expect(1, 110593, '\P{Word_Break=katakana}', "");
    Expect(0, 110593, '\P{^Word_Break=katakana}', "");
    Expect(1, 110592, '\p{Word_Break=_-katakana}', "");
    Expect(0, 110592, '\p{^Word_Break=_-katakana}', "");
    Expect(0, 110592, '\P{Word_Break=_-katakana}', "");
    Expect(1, 110592, '\P{^Word_Break=_-katakana}', "");
    Expect(0, 110593, '\p{Word_Break=_-katakana}', "");
    Expect(1, 110593, '\p{^Word_Break=_-katakana}', "");
    Expect(1, 110593, '\P{Word_Break=_-katakana}', "");
    Expect(0, 110593, '\P{^Word_Break=_-katakana}', "");
    Error('\p{WB=_/a/KA}');
    Error('\P{WB=_/a/KA}');
    Expect(1, 110592, '\p{WB=ka}', "");
    Expect(0, 110592, '\p{^WB=ka}', "");
    Expect(0, 110592, '\P{WB=ka}', "");
    Expect(1, 110592, '\P{^WB=ka}', "");
    Expect(0, 110593, '\p{WB=ka}', "");
    Expect(1, 110593, '\p{^WB=ka}', "");
    Expect(1, 110593, '\P{WB=ka}', "");
    Expect(0, 110593, '\P{^WB=ka}', "");
    Expect(1, 110592, '\p{WB=-KA}', "");
    Expect(0, 110592, '\p{^WB=-KA}', "");
    Expect(0, 110592, '\P{WB=-KA}', "");
    Expect(1, 110592, '\P{^WB=-KA}', "");
    Expect(0, 110593, '\p{WB=-KA}', "");
    Expect(1, 110593, '\p{^WB=-KA}', "");
    Expect(1, 110593, '\P{WB=-KA}', "");
    Expect(0, 110593, '\P{^WB=-KA}', "");
    Error('\p{Is_Word_Break=	KATAKANA:=}');
    Error('\P{Is_Word_Break=	KATAKANA:=}');
    Expect(1, 110592, '\p{Is_Word_Break=katakana}', "");
    Expect(0, 110592, '\p{^Is_Word_Break=katakana}', "");
    Expect(0, 110592, '\P{Is_Word_Break=katakana}', "");
    Expect(1, 110592, '\P{^Is_Word_Break=katakana}', "");
    Expect(0, 110593, '\p{Is_Word_Break=katakana}', "");
    Expect(1, 110593, '\p{^Is_Word_Break=katakana}', "");
    Expect(1, 110593, '\P{Is_Word_Break=katakana}', "");
    Expect(0, 110593, '\P{^Is_Word_Break=katakana}', "");
    Expect(1, 110592, '\p{Is_Word_Break=	_Katakana}', "");
    Expect(0, 110592, '\p{^Is_Word_Break=	_Katakana}', "");
    Expect(0, 110592, '\P{Is_Word_Break=	_Katakana}', "");
    Expect(1, 110592, '\P{^Is_Word_Break=	_Katakana}', "");
    Expect(0, 110593, '\p{Is_Word_Break=	_Katakana}', "");
    Expect(1, 110593, '\p{^Is_Word_Break=	_Katakana}', "");
    Expect(1, 110593, '\P{Is_Word_Break=	_Katakana}', "");
    Expect(0, 110593, '\P{^Is_Word_Break=	_Katakana}', "");
    Error('\p{Is_WB=-/a/ka}');
    Error('\P{Is_WB=-/a/ka}');
    Expect(1, 110592, '\p{Is_WB=ka}', "");
    Expect(0, 110592, '\p{^Is_WB=ka}', "");
    Expect(0, 110592, '\P{Is_WB=ka}', "");
    Expect(1, 110592, '\P{^Is_WB=ka}', "");
    Expect(0, 110593, '\p{Is_WB=ka}', "");
    Expect(1, 110593, '\p{^Is_WB=ka}', "");
    Expect(1, 110593, '\P{Is_WB=ka}', "");
    Expect(0, 110593, '\P{^Is_WB=ka}', "");
    Expect(1, 110592, '\p{Is_WB=_KA}', "");
    Expect(0, 110592, '\p{^Is_WB=_KA}', "");
    Expect(0, 110592, '\P{Is_WB=_KA}', "");
    Expect(1, 110592, '\P{^Is_WB=_KA}', "");
    Expect(0, 110593, '\p{Is_WB=_KA}', "");
    Expect(1, 110593, '\p{^Is_WB=_KA}', "");
    Expect(1, 110593, '\P{Is_WB=_KA}', "");
    Expect(0, 110593, '\P{^Is_WB=_KA}', "");
    Error('\p{Word_Break=/a/-	ALetter}');
    Error('\P{Word_Break=/a/-	ALetter}');
    Expect(1, 127369, '\p{Word_Break=aletter}', "");
    Expect(0, 127369, '\p{^Word_Break=aletter}', "");
    Expect(0, 127369, '\P{Word_Break=aletter}', "");
    Expect(1, 127369, '\P{^Word_Break=aletter}', "");
    Expect(0, 127370, '\p{Word_Break=aletter}', "");
    Expect(1, 127370, '\p{^Word_Break=aletter}', "");
    Expect(1, 127370, '\P{Word_Break=aletter}', "");
    Expect(0, 127370, '\P{^Word_Break=aletter}', "");
    Expect(1, 127369, '\p{Word_Break=	_aletter}', "");
    Expect(0, 127369, '\p{^Word_Break=	_aletter}', "");
    Expect(0, 127369, '\P{Word_Break=	_aletter}', "");
    Expect(1, 127369, '\P{^Word_Break=	_aletter}', "");
    Expect(0, 127370, '\p{Word_Break=	_aletter}', "");
    Expect(1, 127370, '\p{^Word_Break=	_aletter}', "");
    Expect(1, 127370, '\P{Word_Break=	_aletter}', "");
    Expect(0, 127370, '\P{^Word_Break=	_aletter}', "");
    Error('\p{WB=:=_-LE}');
    Error('\P{WB=:=_-LE}');
    Expect(1, 127369, '\p{WB=le}', "");
    Expect(0, 127369, '\p{^WB=le}', "");
    Expect(0, 127369, '\P{WB=le}', "");
    Expect(1, 127369, '\P{^WB=le}', "");
    Expect(0, 127370, '\p{WB=le}', "");
    Expect(1, 127370, '\p{^WB=le}', "");
    Expect(1, 127370, '\P{WB=le}', "");
    Expect(0, 127370, '\P{^WB=le}', "");
    Expect(1, 127369, '\p{WB=-LE}', "");
    Expect(0, 127369, '\p{^WB=-LE}', "");
    Expect(0, 127369, '\P{WB=-LE}', "");
    Expect(1, 127369, '\P{^WB=-LE}', "");
    Expect(0, 127370, '\p{WB=-LE}', "");
    Expect(1, 127370, '\p{^WB=-LE}', "");
    Expect(1, 127370, '\P{WB=-LE}', "");
    Expect(0, 127370, '\P{^WB=-LE}', "");
    Error('\p{Is_Word_Break:_-aletter/a/}');
    Error('\P{Is_Word_Break:_-aletter/a/}');
    Expect(1, 127369, '\p{Is_Word_Break=aletter}', "");
    Expect(0, 127369, '\p{^Is_Word_Break=aletter}', "");
    Expect(0, 127369, '\P{Is_Word_Break=aletter}', "");
    Expect(1, 127369, '\P{^Is_Word_Break=aletter}', "");
    Expect(0, 127370, '\p{Is_Word_Break=aletter}', "");
    Expect(1, 127370, '\p{^Is_Word_Break=aletter}', "");
    Expect(1, 127370, '\P{Is_Word_Break=aletter}', "");
    Expect(0, 127370, '\P{^Is_Word_Break=aletter}', "");
    Expect(1, 127369, '\p{Is_Word_Break=	_aletter}', "");
    Expect(0, 127369, '\p{^Is_Word_Break=	_aletter}', "");
    Expect(0, 127369, '\P{Is_Word_Break=	_aletter}', "");
    Expect(1, 127369, '\P{^Is_Word_Break=	_aletter}', "");
    Expect(0, 127370, '\p{Is_Word_Break=	_aletter}', "");
    Expect(1, 127370, '\p{^Is_Word_Break=	_aletter}', "");
    Expect(1, 127370, '\P{Is_Word_Break=	_aletter}', "");
    Expect(0, 127370, '\P{^Is_Word_Break=	_aletter}', "");
    Error('\p{Is_WB=:=LE}');
    Error('\P{Is_WB=:=LE}');
    Expect(1, 127369, '\p{Is_WB=le}', "");
    Expect(0, 127369, '\p{^Is_WB=le}', "");
    Expect(0, 127369, '\P{Is_WB=le}', "");
    Expect(1, 127369, '\P{^Is_WB=le}', "");
    Expect(0, 127370, '\p{Is_WB=le}', "");
    Expect(1, 127370, '\p{^Is_WB=le}', "");
    Expect(1, 127370, '\P{Is_WB=le}', "");
    Expect(0, 127370, '\P{^Is_WB=le}', "");
    Expect(1, 127369, '\p{Is_WB= _le}', "");
    Expect(0, 127369, '\p{^Is_WB= _le}', "");
    Expect(0, 127369, '\P{Is_WB= _le}', "");
    Expect(1, 127369, '\P{^Is_WB= _le}', "");
    Expect(0, 127370, '\p{Is_WB= _le}', "");
    Expect(1, 127370, '\p{^Is_WB= _le}', "");
    Expect(1, 127370, '\P{Is_WB= _le}', "");
    Expect(0, 127370, '\P{^Is_WB= _le}', "");
    Error('\p{Word_Break=:= lf}');
    Error('\P{Word_Break=:= lf}');
    Expect(1, 10, '\p{Word_Break=lf}', "");
    Expect(0, 10, '\p{^Word_Break=lf}', "");
    Expect(0, 10, '\P{Word_Break=lf}', "");
    Expect(1, 10, '\P{^Word_Break=lf}', "");
    Expect(0, 11, '\p{Word_Break=lf}', "");
    Expect(1, 11, '\p{^Word_Break=lf}', "");
    Expect(1, 11, '\P{Word_Break=lf}', "");
    Expect(0, 11, '\P{^Word_Break=lf}', "");
    Expect(1, 10, '\p{Word_Break=_LF}', "");
    Expect(0, 10, '\p{^Word_Break=_LF}', "");
    Expect(0, 10, '\P{Word_Break=_LF}', "");
    Expect(1, 10, '\P{^Word_Break=_LF}', "");
    Expect(0, 11, '\p{Word_Break=_LF}', "");
    Expect(1, 11, '\p{^Word_Break=_LF}', "");
    Expect(1, 11, '\P{Word_Break=_LF}', "");
    Expect(0, 11, '\P{^Word_Break=_LF}', "");
    Error('\p{WB=/a/	_lf}');
    Error('\P{WB=/a/	_lf}');
    Expect(1, 10, '\p{WB=lf}', "");
    Expect(0, 10, '\p{^WB=lf}', "");
    Expect(0, 10, '\P{WB=lf}', "");
    Expect(1, 10, '\P{^WB=lf}', "");
    Expect(0, 11, '\p{WB=lf}', "");
    Expect(1, 11, '\p{^WB=lf}', "");
    Expect(1, 11, '\P{WB=lf}', "");
    Expect(0, 11, '\P{^WB=lf}', "");
    Expect(1, 10, '\p{WB= 	LF}', "");
    Expect(0, 10, '\p{^WB= 	LF}', "");
    Expect(0, 10, '\P{WB= 	LF}', "");
    Expect(1, 10, '\P{^WB= 	LF}', "");
    Expect(0, 11, '\p{WB= 	LF}', "");
    Expect(1, 11, '\p{^WB= 	LF}', "");
    Expect(1, 11, '\P{WB= 	LF}', "");
    Expect(0, 11, '\P{^WB= 	LF}', "");
    Error('\p{Is_Word_Break:   lf:=}');
    Error('\P{Is_Word_Break:   lf:=}');
    Expect(1, 10, '\p{Is_Word_Break=lf}', "");
    Expect(0, 10, '\p{^Is_Word_Break=lf}', "");
    Expect(0, 10, '\P{Is_Word_Break=lf}', "");
    Expect(1, 10, '\P{^Is_Word_Break=lf}', "");
    Expect(0, 11, '\p{Is_Word_Break=lf}', "");
    Expect(1, 11, '\p{^Is_Word_Break=lf}', "");
    Expect(1, 11, '\P{Is_Word_Break=lf}', "");
    Expect(0, 11, '\P{^Is_Word_Break=lf}', "");
    Expect(1, 10, '\p{Is_Word_Break=-lf}', "");
    Expect(0, 10, '\p{^Is_Word_Break=-lf}', "");
    Expect(0, 10, '\P{Is_Word_Break=-lf}', "");
    Expect(1, 10, '\P{^Is_Word_Break=-lf}', "");
    Expect(0, 11, '\p{Is_Word_Break=-lf}', "");
    Expect(1, 11, '\p{^Is_Word_Break=-lf}', "");
    Expect(1, 11, '\P{Is_Word_Break=-lf}', "");
    Expect(0, 11, '\P{^Is_Word_Break=-lf}', "");
    Error('\p{Is_WB=:=lf}');
    Error('\P{Is_WB=:=lf}');
    Expect(1, 10, '\p{Is_WB=lf}', "");
    Expect(0, 10, '\p{^Is_WB=lf}', "");
    Expect(0, 10, '\P{Is_WB=lf}', "");
    Expect(1, 10, '\P{^Is_WB=lf}', "");
    Expect(0, 11, '\p{Is_WB=lf}', "");
    Expect(1, 11, '\p{^Is_WB=lf}', "");
    Expect(1, 11, '\P{Is_WB=lf}', "");
    Expect(0, 11, '\P{^Is_WB=lf}', "");
    Expect(1, 10, '\p{Is_WB:    LF}', "");
    Expect(0, 10, '\p{^Is_WB:    LF}', "");
    Expect(0, 10, '\P{Is_WB:    LF}', "");
    Expect(1, 10, '\P{^Is_WB:    LF}', "");
    Expect(0, 11, '\p{Is_WB:    LF}', "");
    Expect(1, 11, '\p{^Is_WB:    LF}', "");
    Expect(1, 11, '\P{Is_WB:    LF}', "");
    Expect(0, 11, '\P{^Is_WB:    LF}', "");
    Error('\p{Word_Break: _-midnumlet/a/}');
    Error('\P{Word_Break: _-midnumlet/a/}');
    Expect(1, 65294, '\p{Word_Break:   midnumlet}', "");
    Expect(0, 65294, '\p{^Word_Break:   midnumlet}', "");
    Expect(0, 65294, '\P{Word_Break:   midnumlet}', "");
    Expect(1, 65294, '\P{^Word_Break:   midnumlet}', "");
    Expect(0, 65295, '\p{Word_Break:   midnumlet}', "");
    Expect(1, 65295, '\p{^Word_Break:   midnumlet}', "");
    Expect(1, 65295, '\P{Word_Break:   midnumlet}', "");
    Expect(0, 65295, '\P{^Word_Break:   midnumlet}', "");
    Expect(1, 65294, '\p{Word_Break= 	midnumlet}', "");
    Expect(0, 65294, '\p{^Word_Break= 	midnumlet}', "");
    Expect(0, 65294, '\P{Word_Break= 	midnumlet}', "");
    Expect(1, 65294, '\P{^Word_Break= 	midnumlet}', "");
    Expect(0, 65295, '\p{Word_Break= 	midnumlet}', "");
    Expect(1, 65295, '\p{^Word_Break= 	midnumlet}', "");
    Expect(1, 65295, '\P{Word_Break= 	midnumlet}', "");
    Expect(0, 65295, '\P{^Word_Break= 	midnumlet}', "");
    Error('\p{WB=	MB/a/}');
    Error('\P{WB=	MB/a/}');
    Expect(1, 65294, '\p{WB=mb}', "");
    Expect(0, 65294, '\p{^WB=mb}', "");
    Expect(0, 65294, '\P{WB=mb}', "");
    Expect(1, 65294, '\P{^WB=mb}', "");
    Expect(0, 65295, '\p{WB=mb}', "");
    Expect(1, 65295, '\p{^WB=mb}', "");
    Expect(1, 65295, '\P{WB=mb}', "");
    Expect(0, 65295, '\P{^WB=mb}', "");
    Expect(1, 65294, '\p{WB=	mb}', "");
    Expect(0, 65294, '\p{^WB=	mb}', "");
    Expect(0, 65294, '\P{WB=	mb}', "");
    Expect(1, 65294, '\P{^WB=	mb}', "");
    Expect(0, 65295, '\p{WB=	mb}', "");
    Expect(1, 65295, '\p{^WB=	mb}', "");
    Expect(1, 65295, '\P{WB=	mb}', "");
    Expect(0, 65295, '\P{^WB=	mb}', "");
    Error('\p{Is_Word_Break=:=	 MIDNUMLET}');
    Error('\P{Is_Word_Break=:=	 MIDNUMLET}');
    Expect(1, 65294, '\p{Is_Word_Break=midnumlet}', "");
    Expect(0, 65294, '\p{^Is_Word_Break=midnumlet}', "");
    Expect(0, 65294, '\P{Is_Word_Break=midnumlet}', "");
    Expect(1, 65294, '\P{^Is_Word_Break=midnumlet}', "");
    Expect(0, 65295, '\p{Is_Word_Break=midnumlet}', "");
    Expect(1, 65295, '\p{^Is_Word_Break=midnumlet}', "");
    Expect(1, 65295, '\P{Is_Word_Break=midnumlet}', "");
    Expect(0, 65295, '\P{^Is_Word_Break=midnumlet}', "");
    Expect(1, 65294, '\p{Is_Word_Break=_MidNumLet}', "");
    Expect(0, 65294, '\p{^Is_Word_Break=_MidNumLet}', "");
    Expect(0, 65294, '\P{Is_Word_Break=_MidNumLet}', "");
    Expect(1, 65294, '\P{^Is_Word_Break=_MidNumLet}', "");
    Expect(0, 65295, '\p{Is_Word_Break=_MidNumLet}', "");
    Expect(1, 65295, '\p{^Is_Word_Break=_MidNumLet}', "");
    Expect(1, 65295, '\P{Is_Word_Break=_MidNumLet}', "");
    Expect(0, 65295, '\P{^Is_Word_Break=_MidNumLet}', "");
    Error('\p{Is_WB:   /a/_-MB}');
    Error('\P{Is_WB:   /a/_-MB}');
    Expect(1, 65294, '\p{Is_WB=mb}', "");
    Expect(0, 65294, '\p{^Is_WB=mb}', "");
    Expect(0, 65294, '\P{Is_WB=mb}', "");
    Expect(1, 65294, '\P{^Is_WB=mb}', "");
    Expect(0, 65295, '\p{Is_WB=mb}', "");
    Expect(1, 65295, '\p{^Is_WB=mb}', "");
    Expect(1, 65295, '\P{Is_WB=mb}', "");
    Expect(0, 65295, '\P{^Is_WB=mb}', "");
    Expect(1, 65294, '\p{Is_WB:- MB}', "");
    Expect(0, 65294, '\p{^Is_WB:- MB}', "");
    Expect(0, 65294, '\P{Is_WB:- MB}', "");
    Expect(1, 65294, '\P{^Is_WB:- MB}', "");
    Expect(0, 65295, '\p{Is_WB:- MB}', "");
    Expect(1, 65295, '\p{^Is_WB:- MB}', "");
    Expect(1, 65295, '\P{Is_WB:- MB}', "");
    Expect(0, 65295, '\P{^Is_WB:- MB}', "");
    Error('\p{Word_Break=/a/midletter}');
    Error('\P{Word_Break=/a/midletter}');
    Expect(1, 65306, '\p{Word_Break=midletter}', "");
    Expect(0, 65306, '\p{^Word_Break=midletter}', "");
    Expect(0, 65306, '\P{Word_Break=midletter}', "");
    Expect(1, 65306, '\P{^Word_Break=midletter}', "");
    Expect(0, 65307, '\p{Word_Break=midletter}', "");
    Expect(1, 65307, '\p{^Word_Break=midletter}', "");
    Expect(1, 65307, '\P{Word_Break=midletter}', "");
    Expect(0, 65307, '\P{^Word_Break=midletter}', "");
    Expect(1, 65306, '\p{Word_Break=-MidLetter}', "");
    Expect(0, 65306, '\p{^Word_Break=-MidLetter}', "");
    Expect(0, 65306, '\P{Word_Break=-MidLetter}', "");
    Expect(1, 65306, '\P{^Word_Break=-MidLetter}', "");
    Expect(0, 65307, '\p{Word_Break=-MidLetter}', "");
    Expect(1, 65307, '\p{^Word_Break=-MidLetter}', "");
    Expect(1, 65307, '\P{Word_Break=-MidLetter}', "");
    Expect(0, 65307, '\P{^Word_Break=-MidLetter}', "");
    Error('\p{WB=	_ml/a/}');
    Error('\P{WB=	_ml/a/}');
    Expect(1, 65306, '\p{WB=ml}', "");
    Expect(0, 65306, '\p{^WB=ml}', "");
    Expect(0, 65306, '\P{WB=ml}', "");
    Expect(1, 65306, '\P{^WB=ml}', "");
    Expect(0, 65307, '\p{WB=ml}', "");
    Expect(1, 65307, '\p{^WB=ml}', "");
    Expect(1, 65307, '\P{WB=ml}', "");
    Expect(0, 65307, '\P{^WB=ml}', "");
    Expect(1, 65306, '\p{WB=	ML}', "");
    Expect(0, 65306, '\p{^WB=	ML}', "");
    Expect(0, 65306, '\P{WB=	ML}', "");
    Expect(1, 65306, '\P{^WB=	ML}', "");
    Expect(0, 65307, '\p{WB=	ML}', "");
    Expect(1, 65307, '\p{^WB=	ML}', "");
    Expect(1, 65307, '\P{WB=	ML}', "");
    Expect(0, 65307, '\P{^WB=	ML}', "");
    Error('\p{Is_Word_Break=/a/_ midletter}');
    Error('\P{Is_Word_Break=/a/_ midletter}');
    Expect(1, 65306, '\p{Is_Word_Break: midletter}', "");
    Expect(0, 65306, '\p{^Is_Word_Break: midletter}', "");
    Expect(0, 65306, '\P{Is_Word_Break: midletter}', "");
    Expect(1, 65306, '\P{^Is_Word_Break: midletter}', "");
    Expect(0, 65307, '\p{Is_Word_Break: midletter}', "");
    Expect(1, 65307, '\p{^Is_Word_Break: midletter}', "");
    Expect(1, 65307, '\P{Is_Word_Break: midletter}', "");
    Expect(0, 65307, '\P{^Is_Word_Break: midletter}', "");
    Expect(1, 65306, '\p{Is_Word_Break:    -MIDLETTER}', "");
    Expect(0, 65306, '\p{^Is_Word_Break:    -MIDLETTER}', "");
    Expect(0, 65306, '\P{Is_Word_Break:    -MIDLETTER}', "");
    Expect(1, 65306, '\P{^Is_Word_Break:    -MIDLETTER}', "");
    Expect(0, 65307, '\p{Is_Word_Break:    -MIDLETTER}', "");
    Expect(1, 65307, '\p{^Is_Word_Break:    -MIDLETTER}', "");
    Expect(1, 65307, '\P{Is_Word_Break:    -MIDLETTER}', "");
    Expect(0, 65307, '\P{^Is_Word_Break:    -MIDLETTER}', "");
    Error('\p{Is_WB= /a/ML}');
    Error('\P{Is_WB= /a/ML}');
    Expect(1, 65306, '\p{Is_WB=ml}', "");
    Expect(0, 65306, '\p{^Is_WB=ml}', "");
    Expect(0, 65306, '\P{Is_WB=ml}', "");
    Expect(1, 65306, '\P{^Is_WB=ml}', "");
    Expect(0, 65307, '\p{Is_WB=ml}', "");
    Expect(1, 65307, '\p{^Is_WB=ml}', "");
    Expect(1, 65307, '\P{Is_WB=ml}', "");
    Expect(0, 65307, '\P{^Is_WB=ml}', "");
    Expect(1, 65306, '\p{Is_WB= -ML}', "");
    Expect(0, 65306, '\p{^Is_WB= -ML}', "");
    Expect(0, 65306, '\P{Is_WB= -ML}', "");
    Expect(1, 65306, '\P{^Is_WB= -ML}', "");
    Expect(0, 65307, '\p{Is_WB= -ML}', "");
    Expect(1, 65307, '\p{^Is_WB= -ML}', "");
    Expect(1, 65307, '\P{Is_WB= -ML}', "");
    Expect(0, 65307, '\P{^Is_WB= -ML}', "");
    Error('\p{Word_Break=	/a/MIDNUM}');
    Error('\P{Word_Break=	/a/MIDNUM}');
    Expect(1, 65307, '\p{Word_Break=midnum}', "");
    Expect(0, 65307, '\p{^Word_Break=midnum}', "");
    Expect(0, 65307, '\P{Word_Break=midnum}', "");
    Expect(1, 65307, '\P{^Word_Break=midnum}', "");
    Expect(0, 65308, '\p{Word_Break=midnum}', "");
    Expect(1, 65308, '\p{^Word_Break=midnum}', "");
    Expect(1, 65308, '\P{Word_Break=midnum}', "");
    Expect(0, 65308, '\P{^Word_Break=midnum}', "");
    Expect(1, 65307, '\p{Word_Break=_-MidNum}', "");
    Expect(0, 65307, '\p{^Word_Break=_-MidNum}', "");
    Expect(0, 65307, '\P{Word_Break=_-MidNum}', "");
    Expect(1, 65307, '\P{^Word_Break=_-MidNum}', "");
    Expect(0, 65308, '\p{Word_Break=_-MidNum}', "");
    Expect(1, 65308, '\p{^Word_Break=_-MidNum}', "");
    Expect(1, 65308, '\P{Word_Break=_-MidNum}', "");
    Expect(0, 65308, '\P{^Word_Break=_-MidNum}', "");
    Error('\p{WB= /a/MN}');
    Error('\P{WB= /a/MN}');
    Expect(1, 65307, '\p{WB:   mn}', "");
    Expect(0, 65307, '\p{^WB:   mn}', "");
    Expect(0, 65307, '\P{WB:   mn}', "");
    Expect(1, 65307, '\P{^WB:   mn}', "");
    Expect(0, 65308, '\p{WB:   mn}', "");
    Expect(1, 65308, '\p{^WB:   mn}', "");
    Expect(1, 65308, '\P{WB:   mn}', "");
    Expect(0, 65308, '\P{^WB:   mn}', "");
    Expect(1, 65307, '\p{WB=__MN}', "");
    Expect(0, 65307, '\p{^WB=__MN}', "");
    Expect(0, 65307, '\P{WB=__MN}', "");
    Expect(1, 65307, '\P{^WB=__MN}', "");
    Expect(0, 65308, '\p{WB=__MN}', "");
    Expect(1, 65308, '\p{^WB=__MN}', "");
    Expect(1, 65308, '\P{WB=__MN}', "");
    Expect(0, 65308, '\P{^WB=__MN}', "");
    Error('\p{Is_Word_Break=-:=midnum}');
    Error('\P{Is_Word_Break=-:=midnum}');
    Expect(1, 65307, '\p{Is_Word_Break:	midnum}', "");
    Expect(0, 65307, '\p{^Is_Word_Break:	midnum}', "");
    Expect(0, 65307, '\P{Is_Word_Break:	midnum}', "");
    Expect(1, 65307, '\P{^Is_Word_Break:	midnum}', "");
    Expect(0, 65308, '\p{Is_Word_Break:	midnum}', "");
    Expect(1, 65308, '\p{^Is_Word_Break:	midnum}', "");
    Expect(1, 65308, '\P{Is_Word_Break:	midnum}', "");
    Expect(0, 65308, '\P{^Is_Word_Break:	midnum}', "");
    Expect(1, 65307, '\p{Is_Word_Break=_	midnum}', "");
    Expect(0, 65307, '\p{^Is_Word_Break=_	midnum}', "");
    Expect(0, 65307, '\P{Is_Word_Break=_	midnum}', "");
    Expect(1, 65307, '\P{^Is_Word_Break=_	midnum}', "");
    Expect(0, 65308, '\p{Is_Word_Break=_	midnum}', "");
    Expect(1, 65308, '\p{^Is_Word_Break=_	midnum}', "");
    Expect(1, 65308, '\P{Is_Word_Break=_	midnum}', "");
    Expect(0, 65308, '\P{^Is_Word_Break=_	midnum}', "");
    Error('\p{Is_WB= mn/a/}');
    Error('\P{Is_WB= mn/a/}');
    Expect(1, 65307, '\p{Is_WB=mn}', "");
    Expect(0, 65307, '\p{^Is_WB=mn}', "");
    Expect(0, 65307, '\P{Is_WB=mn}', "");
    Expect(1, 65307, '\P{^Is_WB=mn}', "");
    Expect(0, 65308, '\p{Is_WB=mn}', "");
    Expect(1, 65308, '\p{^Is_WB=mn}', "");
    Expect(1, 65308, '\P{Is_WB=mn}', "");
    Expect(0, 65308, '\P{^Is_WB=mn}', "");
    Expect(1, 65307, '\p{Is_WB= _mn}', "");
    Expect(0, 65307, '\p{^Is_WB= _mn}', "");
    Expect(0, 65307, '\P{Is_WB= _mn}', "");
    Expect(1, 65307, '\P{^Is_WB= _mn}', "");
    Expect(0, 65308, '\p{Is_WB= _mn}', "");
    Expect(1, 65308, '\p{^Is_WB= _mn}', "");
    Expect(1, 65308, '\P{Is_WB= _mn}', "");
    Expect(0, 65308, '\P{^Is_WB= _mn}', "");
    Error('\p{Word_Break=	/a/Newline}');
    Error('\P{Word_Break=	/a/Newline}');
    Expect(1, 8233, '\p{Word_Break:newline}', "");
    Expect(0, 8233, '\p{^Word_Break:newline}', "");
    Expect(0, 8233, '\P{Word_Break:newline}', "");
    Expect(1, 8233, '\P{^Word_Break:newline}', "");
    Expect(0, 8234, '\p{Word_Break:newline}', "");
    Expect(1, 8234, '\p{^Word_Break:newline}', "");
    Expect(1, 8234, '\P{Word_Break:newline}', "");
    Expect(0, 8234, '\P{^Word_Break:newline}', "");
    Expect(1, 8233, '\p{Word_Break=--NEWLINE}', "");
    Expect(0, 8233, '\p{^Word_Break=--NEWLINE}', "");
    Expect(0, 8233, '\P{Word_Break=--NEWLINE}', "");
    Expect(1, 8233, '\P{^Word_Break=--NEWLINE}', "");
    Expect(0, 8234, '\p{Word_Break=--NEWLINE}', "");
    Expect(1, 8234, '\p{^Word_Break=--NEWLINE}', "");
    Expect(1, 8234, '\P{Word_Break=--NEWLINE}', "");
    Expect(0, 8234, '\P{^Word_Break=--NEWLINE}', "");
    Error('\p{WB=_	NL/a/}');
    Error('\P{WB=_	NL/a/}');
    Expect(1, 8233, '\p{WB:	nl}', "");
    Expect(0, 8233, '\p{^WB:	nl}', "");
    Expect(0, 8233, '\P{WB:	nl}', "");
    Expect(1, 8233, '\P{^WB:	nl}', "");
    Expect(0, 8234, '\p{WB:	nl}', "");
    Expect(1, 8234, '\p{^WB:	nl}', "");
    Expect(1, 8234, '\P{WB:	nl}', "");
    Expect(0, 8234, '\P{^WB:	nl}', "");
    Expect(1, 8233, '\p{WB=-_NL}', "");
    Expect(0, 8233, '\p{^WB=-_NL}', "");
    Expect(0, 8233, '\P{WB=-_NL}', "");
    Expect(1, 8233, '\P{^WB=-_NL}', "");
    Expect(0, 8234, '\p{WB=-_NL}', "");
    Expect(1, 8234, '\p{^WB=-_NL}', "");
    Expect(1, 8234, '\P{WB=-_NL}', "");
    Expect(0, 8234, '\P{^WB=-_NL}', "");
    Error('\p{Is_Word_Break=  NEWLINE:=}');
    Error('\P{Is_Word_Break=  NEWLINE:=}');
    Expect(1, 8233, '\p{Is_Word_Break=newline}', "");
    Expect(0, 8233, '\p{^Is_Word_Break=newline}', "");
    Expect(0, 8233, '\P{Is_Word_Break=newline}', "");
    Expect(1, 8233, '\P{^Is_Word_Break=newline}', "");
    Expect(0, 8234, '\p{Is_Word_Break=newline}', "");
    Expect(1, 8234, '\p{^Is_Word_Break=newline}', "");
    Expect(1, 8234, '\P{Is_Word_Break=newline}', "");
    Expect(0, 8234, '\P{^Is_Word_Break=newline}', "");
    Expect(1, 8233, '\p{Is_Word_Break= 	newline}', "");
    Expect(0, 8233, '\p{^Is_Word_Break= 	newline}', "");
    Expect(0, 8233, '\P{Is_Word_Break= 	newline}', "");
    Expect(1, 8233, '\P{^Is_Word_Break= 	newline}', "");
    Expect(0, 8234, '\p{Is_Word_Break= 	newline}', "");
    Expect(1, 8234, '\p{^Is_Word_Break= 	newline}', "");
    Expect(1, 8234, '\P{Is_Word_Break= 	newline}', "");
    Expect(0, 8234, '\P{^Is_Word_Break= 	newline}', "");
    Error('\p{Is_WB=/a/_	NL}');
    Error('\P{Is_WB=/a/_	NL}');
    Expect(1, 8233, '\p{Is_WB=nl}', "");
    Expect(0, 8233, '\p{^Is_WB=nl}', "");
    Expect(0, 8233, '\P{Is_WB=nl}', "");
    Expect(1, 8233, '\P{^Is_WB=nl}', "");
    Expect(0, 8234, '\p{Is_WB=nl}', "");
    Expect(1, 8234, '\p{^Is_WB=nl}', "");
    Expect(1, 8234, '\P{Is_WB=nl}', "");
    Expect(0, 8234, '\P{^Is_WB=nl}', "");
    Expect(1, 8233, '\p{Is_WB:  	nl}', "");
    Expect(0, 8233, '\p{^Is_WB:  	nl}', "");
    Expect(0, 8233, '\P{Is_WB:  	nl}', "");
    Expect(1, 8233, '\P{^Is_WB:  	nl}', "");
    Expect(0, 8234, '\p{Is_WB:  	nl}', "");
    Expect(1, 8234, '\p{^Is_WB:  	nl}', "");
    Expect(1, 8234, '\P{Is_WB:  	nl}', "");
    Expect(0, 8234, '\P{^Is_WB:  	nl}', "");
    Error('\p{Word_Break=/a/numeric}');
    Error('\P{Word_Break=/a/numeric}');
    Expect(1, 125273, '\p{Word_Break=numeric}', "");
    Expect(0, 125273, '\p{^Word_Break=numeric}', "");
    Expect(0, 125273, '\P{Word_Break=numeric}', "");
    Expect(1, 125273, '\P{^Word_Break=numeric}', "");
    Expect(0, 125274, '\p{Word_Break=numeric}', "");
    Expect(1, 125274, '\p{^Word_Break=numeric}', "");
    Expect(1, 125274, '\P{Word_Break=numeric}', "");
    Expect(0, 125274, '\P{^Word_Break=numeric}', "");
    Expect(1, 125273, '\p{Word_Break=_-Numeric}', "");
    Expect(0, 125273, '\p{^Word_Break=_-Numeric}', "");
    Expect(0, 125273, '\P{Word_Break=_-Numeric}', "");
    Expect(1, 125273, '\P{^Word_Break=_-Numeric}', "");
    Expect(0, 125274, '\p{Word_Break=_-Numeric}', "");
    Expect(1, 125274, '\p{^Word_Break=_-Numeric}', "");
    Expect(1, 125274, '\P{Word_Break=_-Numeric}', "");
    Expect(0, 125274, '\P{^Word_Break=_-Numeric}', "");
    Error('\p{WB=	/a/NU}');
    Error('\P{WB=	/a/NU}');
    Expect(1, 125273, '\p{WB=nu}', "");
    Expect(0, 125273, '\p{^WB=nu}', "");
    Expect(0, 125273, '\P{WB=nu}', "");
    Expect(1, 125273, '\P{^WB=nu}', "");
    Expect(0, 125274, '\p{WB=nu}', "");
    Expect(1, 125274, '\p{^WB=nu}', "");
    Expect(1, 125274, '\P{WB=nu}', "");
    Expect(0, 125274, '\P{^WB=nu}', "");
    Expect(1, 125273, '\p{WB= 	nu}', "");
    Expect(0, 125273, '\p{^WB= 	nu}', "");
    Expect(0, 125273, '\P{WB= 	nu}', "");
    Expect(1, 125273, '\P{^WB= 	nu}', "");
    Expect(0, 125274, '\p{WB= 	nu}', "");
    Expect(1, 125274, '\p{^WB= 	nu}', "");
    Expect(1, 125274, '\P{WB= 	nu}', "");
    Expect(0, 125274, '\P{^WB= 	nu}', "");
    Error('\p{Is_Word_Break=/a/-NUMERIC}');
    Error('\P{Is_Word_Break=/a/-NUMERIC}');
    Expect(1, 125273, '\p{Is_Word_Break=numeric}', "");
    Expect(0, 125273, '\p{^Is_Word_Break=numeric}', "");
    Expect(0, 125273, '\P{Is_Word_Break=numeric}', "");
    Expect(1, 125273, '\P{^Is_Word_Break=numeric}', "");
    Expect(0, 125274, '\p{Is_Word_Break=numeric}', "");
    Expect(1, 125274, '\p{^Is_Word_Break=numeric}', "");
    Expect(1, 125274, '\P{Is_Word_Break=numeric}', "");
    Expect(0, 125274, '\P{^Is_Word_Break=numeric}', "");
    Expect(1, 125273, '\p{Is_Word_Break=-	Numeric}', "");
    Expect(0, 125273, '\p{^Is_Word_Break=-	Numeric}', "");
    Expect(0, 125273, '\P{Is_Word_Break=-	Numeric}', "");
    Expect(1, 125273, '\P{^Is_Word_Break=-	Numeric}', "");
    Expect(0, 125274, '\p{Is_Word_Break=-	Numeric}', "");
    Expect(1, 125274, '\p{^Is_Word_Break=-	Numeric}', "");
    Expect(1, 125274, '\P{Is_Word_Break=-	Numeric}', "");
    Expect(0, 125274, '\P{^Is_Word_Break=-	Numeric}', "");
    Error('\p{Is_WB=_/a/nu}');
    Error('\P{Is_WB=_/a/nu}');
    Expect(1, 125273, '\p{Is_WB=nu}', "");
    Expect(0, 125273, '\p{^Is_WB=nu}', "");
    Expect(0, 125273, '\P{Is_WB=nu}', "");
    Expect(1, 125273, '\P{^Is_WB=nu}', "");
    Expect(0, 125274, '\p{Is_WB=nu}', "");
    Expect(1, 125274, '\p{^Is_WB=nu}', "");
    Expect(1, 125274, '\P{Is_WB=nu}', "");
    Expect(0, 125274, '\P{^Is_WB=nu}', "");
    Expect(1, 125273, '\p{Is_WB=-	nu}', "");
    Expect(0, 125273, '\p{^Is_WB=-	nu}', "");
    Expect(0, 125273, '\P{Is_WB=-	nu}', "");
    Expect(1, 125273, '\P{^Is_WB=-	nu}', "");
    Expect(0, 125274, '\p{Is_WB=-	nu}', "");
    Expect(1, 125274, '\p{^Is_WB=-	nu}', "");
    Expect(1, 125274, '\P{Is_WB=-	nu}', "");
    Expect(0, 125274, '\P{^Is_WB=-	nu}', "");
    Error('\p{Word_Break=:=	 Regional_Indicator}');
    Error('\P{Word_Break=:=	 Regional_Indicator}');
    Expect(1, 127487, '\p{Word_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Word_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Word_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Word_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Word_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Word_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Word_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Word_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Word_Break= _Regional_INDICATOR}', "");
    Expect(0, 127487, '\p{^Word_Break= _Regional_INDICATOR}', "");
    Expect(0, 127487, '\P{Word_Break= _Regional_INDICATOR}', "");
    Expect(1, 127487, '\P{^Word_Break= _Regional_INDICATOR}', "");
    Expect(0, 127488, '\p{Word_Break= _Regional_INDICATOR}', "");
    Expect(1, 127488, '\p{^Word_Break= _Regional_INDICATOR}', "");
    Expect(1, 127488, '\P{Word_Break= _Regional_INDICATOR}', "");
    Expect(0, 127488, '\P{^Word_Break= _Regional_INDICATOR}', "");
    Error('\p{WB=- RI/a/}');
    Error('\P{WB=- RI/a/}');
    Expect(1, 127487, '\p{WB=ri}', "");
    Expect(0, 127487, '\p{^WB=ri}', "");
    Expect(0, 127487, '\P{WB=ri}', "");
    Expect(1, 127487, '\P{^WB=ri}', "");
    Expect(0, 127488, '\p{WB=ri}', "");
    Expect(1, 127488, '\p{^WB=ri}', "");
    Expect(1, 127488, '\P{WB=ri}', "");
    Expect(0, 127488, '\P{^WB=ri}', "");
    Expect(1, 127487, '\p{WB:	 	ri}', "");
    Expect(0, 127487, '\p{^WB:	 	ri}', "");
    Expect(0, 127487, '\P{WB:	 	ri}', "");
    Expect(1, 127487, '\P{^WB:	 	ri}', "");
    Expect(0, 127488, '\p{WB:	 	ri}', "");
    Expect(1, 127488, '\p{^WB:	 	ri}', "");
    Expect(1, 127488, '\P{WB:	 	ri}', "");
    Expect(0, 127488, '\P{^WB:	 	ri}', "");
    Error('\p{Is_Word_Break=/a/		Regional_Indicator}');
    Error('\P{Is_Word_Break=/a/		Regional_Indicator}');
    Expect(1, 127487, '\p{Is_Word_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Is_Word_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Is_Word_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Is_Word_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Is_Word_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Is_Word_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Is_Word_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Is_Word_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Is_Word_Break=_-REGIONAL_Indicator}', "");
    Expect(0, 127487, '\p{^Is_Word_Break=_-REGIONAL_Indicator}', "");
    Expect(0, 127487, '\P{Is_Word_Break=_-REGIONAL_Indicator}', "");
    Expect(1, 127487, '\P{^Is_Word_Break=_-REGIONAL_Indicator}', "");
    Expect(0, 127488, '\p{Is_Word_Break=_-REGIONAL_Indicator}', "");
    Expect(1, 127488, '\p{^Is_Word_Break=_-REGIONAL_Indicator}', "");
    Expect(1, 127488, '\P{Is_Word_Break=_-REGIONAL_Indicator}', "");
    Expect(0, 127488, '\P{^Is_Word_Break=_-REGIONAL_Indicator}', "");
    Error('\p{Is_WB=/a/RI}');
    Error('\P{Is_WB=/a/RI}');
    Expect(1, 127487, '\p{Is_WB=ri}', "");
    Expect(0, 127487, '\p{^Is_WB=ri}', "");
    Expect(0, 127487, '\P{Is_WB=ri}', "");
    Expect(1, 127487, '\P{^Is_WB=ri}', "");
    Expect(0, 127488, '\p{Is_WB=ri}', "");
    Expect(1, 127488, '\p{^Is_WB=ri}', "");
    Expect(1, 127488, '\P{Is_WB=ri}', "");
    Expect(0, 127488, '\P{^Is_WB=ri}', "");
    Expect(1, 127487, '\p{Is_WB=__RI}', "");
    Expect(0, 127487, '\p{^Is_WB=__RI}', "");
    Expect(0, 127487, '\P{Is_WB=__RI}', "");
    Expect(1, 127487, '\P{^Is_WB=__RI}', "");
    Expect(0, 127488, '\p{Is_WB=__RI}', "");
    Expect(1, 127488, '\p{^Is_WB=__RI}', "");
    Expect(1, 127488, '\P{Is_WB=__RI}', "");
    Expect(0, 127488, '\P{^Is_WB=__RI}', "");
    Error('\p{Word_Break=- single_Quote/a/}');
    Error('\P{Word_Break=- single_Quote/a/}');
    Expect(1, 39, '\p{Word_Break:singlequote}', "");
    Expect(0, 39, '\p{^Word_Break:singlequote}', "");
    Expect(0, 39, '\P{Word_Break:singlequote}', "");
    Expect(1, 39, '\P{^Word_Break:singlequote}', "");
    Expect(0, 40, '\p{Word_Break:singlequote}', "");
    Expect(1, 40, '\p{^Word_Break:singlequote}', "");
    Expect(1, 40, '\P{Word_Break:singlequote}', "");
    Expect(0, 40, '\P{^Word_Break:singlequote}', "");
    Expect(1, 39, '\p{Word_Break=--Single_Quote}', "");
    Expect(0, 39, '\p{^Word_Break=--Single_Quote}', "");
    Expect(0, 39, '\P{Word_Break=--Single_Quote}', "");
    Expect(1, 39, '\P{^Word_Break=--Single_Quote}', "");
    Expect(0, 40, '\p{Word_Break=--Single_Quote}', "");
    Expect(1, 40, '\p{^Word_Break=--Single_Quote}', "");
    Expect(1, 40, '\P{Word_Break=--Single_Quote}', "");
    Expect(0, 40, '\P{^Word_Break=--Single_Quote}', "");
    Error('\p{WB=-SQ/a/}');
    Error('\P{WB=-SQ/a/}');
    Expect(1, 39, '\p{WB=sq}', "");
    Expect(0, 39, '\p{^WB=sq}', "");
    Expect(0, 39, '\P{WB=sq}', "");
    Expect(1, 39, '\P{^WB=sq}', "");
    Expect(0, 40, '\p{WB=sq}', "");
    Expect(1, 40, '\p{^WB=sq}', "");
    Expect(1, 40, '\P{WB=sq}', "");
    Expect(0, 40, '\P{^WB=sq}', "");
    Expect(1, 39, '\p{WB=	_sq}', "");
    Expect(0, 39, '\p{^WB=	_sq}', "");
    Expect(0, 39, '\P{WB=	_sq}', "");
    Expect(1, 39, '\P{^WB=	_sq}', "");
    Expect(0, 40, '\p{WB=	_sq}', "");
    Expect(1, 40, '\p{^WB=	_sq}', "");
    Expect(1, 40, '\P{WB=	_sq}', "");
    Expect(0, 40, '\P{^WB=	_sq}', "");
    Error('\p{Is_Word_Break=:=	-Single_Quote}');
    Error('\P{Is_Word_Break=:=	-Single_Quote}');
    Expect(1, 39, '\p{Is_Word_Break=singlequote}', "");
    Expect(0, 39, '\p{^Is_Word_Break=singlequote}', "");
    Expect(0, 39, '\P{Is_Word_Break=singlequote}', "");
    Expect(1, 39, '\P{^Is_Word_Break=singlequote}', "");
    Expect(0, 40, '\p{Is_Word_Break=singlequote}', "");
    Expect(1, 40, '\p{^Is_Word_Break=singlequote}', "");
    Expect(1, 40, '\P{Is_Word_Break=singlequote}', "");
    Expect(0, 40, '\P{^Is_Word_Break=singlequote}', "");
    Expect(1, 39, '\p{Is_Word_Break=_	SINGLE_Quote}', "");
    Expect(0, 39, '\p{^Is_Word_Break=_	SINGLE_Quote}', "");
    Expect(0, 39, '\P{Is_Word_Break=_	SINGLE_Quote}', "");
    Expect(1, 39, '\P{^Is_Word_Break=_	SINGLE_Quote}', "");
    Expect(0, 40, '\p{Is_Word_Break=_	SINGLE_Quote}', "");
    Expect(1, 40, '\p{^Is_Word_Break=_	SINGLE_Quote}', "");
    Expect(1, 40, '\P{Is_Word_Break=_	SINGLE_Quote}', "");
    Expect(0, 40, '\P{^Is_Word_Break=_	SINGLE_Quote}', "");
    Error('\p{Is_WB=	 SQ:=}');
    Error('\P{Is_WB=	 SQ:=}');
    Expect(1, 39, '\p{Is_WB=sq}', "");
    Expect(0, 39, '\p{^Is_WB=sq}', "");
    Expect(0, 39, '\P{Is_WB=sq}', "");
    Expect(1, 39, '\P{^Is_WB=sq}', "");
    Expect(0, 40, '\p{Is_WB=sq}', "");
    Expect(1, 40, '\p{^Is_WB=sq}', "");
    Expect(1, 40, '\P{Is_WB=sq}', "");
    Expect(0, 40, '\P{^Is_WB=sq}', "");
    Expect(1, 39, '\p{Is_WB=	sq}', "");
    Expect(0, 39, '\p{^Is_WB=	sq}', "");
    Expect(0, 39, '\P{Is_WB=	sq}', "");
    Expect(1, 39, '\P{^Is_WB=	sq}', "");
    Expect(0, 40, '\p{Is_WB=	sq}', "");
    Expect(1, 40, '\p{^Is_WB=	sq}', "");
    Expect(1, 40, '\P{Is_WB=	sq}', "");
    Expect(0, 40, '\P{^Is_WB=	sq}', "");
    Error('\p{Word_Break=:=Other}');
    Error('\P{Word_Break=:=Other}');
    Expect(1, 918000, '\p{Word_Break=other}', "");
    Expect(0, 918000, '\p{^Word_Break=other}', "");
    Expect(0, 918000, '\P{Word_Break=other}', "");
    Expect(1, 918000, '\P{^Word_Break=other}', "");
    Expect(0, 917999, '\p{Word_Break=other}', "");
    Expect(1, 917999, '\p{^Word_Break=other}', "");
    Expect(1, 917999, '\P{Word_Break=other}', "");
    Expect(0, 917999, '\P{^Word_Break=other}', "");
    Expect(1, 918000, '\p{Word_Break=_	Other}', "");
    Expect(0, 918000, '\p{^Word_Break=_	Other}', "");
    Expect(0, 918000, '\P{Word_Break=_	Other}', "");
    Expect(1, 918000, '\P{^Word_Break=_	Other}', "");
    Expect(0, 917999, '\p{Word_Break=_	Other}', "");
    Expect(1, 917999, '\p{^Word_Break=_	Other}', "");
    Expect(1, 917999, '\P{Word_Break=_	Other}', "");
    Expect(0, 917999, '\P{^Word_Break=_	Other}', "");
    Error('\p{WB=:=-xx}');
    Error('\P{WB=:=-xx}');
    Expect(1, 918000, '\p{WB=xx}', "");
    Expect(0, 918000, '\p{^WB=xx}', "");
    Expect(0, 918000, '\P{WB=xx}', "");
    Expect(1, 918000, '\P{^WB=xx}', "");
    Expect(0, 917999, '\p{WB=xx}', "");
    Expect(1, 917999, '\p{^WB=xx}', "");
    Expect(1, 917999, '\P{WB=xx}', "");
    Expect(0, 917999, '\P{^WB=xx}', "");
    Expect(1, 918000, '\p{WB=__XX}', "");
    Expect(0, 918000, '\p{^WB=__XX}', "");
    Expect(0, 918000, '\P{WB=__XX}', "");
    Expect(1, 918000, '\P{^WB=__XX}', "");
    Expect(0, 917999, '\p{WB=__XX}', "");
    Expect(1, 917999, '\p{^WB=__XX}', "");
    Expect(1, 917999, '\P{WB=__XX}', "");
    Expect(0, 917999, '\P{^WB=__XX}', "");
    Error('\p{Is_Word_Break=:=_-Other}');
    Error('\P{Is_Word_Break=:=_-Other}');
    Expect(1, 918000, '\p{Is_Word_Break=other}', "");
    Expect(0, 918000, '\p{^Is_Word_Break=other}', "");
    Expect(0, 918000, '\P{Is_Word_Break=other}', "");
    Expect(1, 918000, '\P{^Is_Word_Break=other}', "");
    Expect(0, 917999, '\p{Is_Word_Break=other}', "");
    Expect(1, 917999, '\p{^Is_Word_Break=other}', "");
    Expect(1, 917999, '\P{Is_Word_Break=other}', "");
    Expect(0, 917999, '\P{^Is_Word_Break=other}', "");
    Expect(1, 918000, '\p{Is_Word_Break=__other}', "");
    Expect(0, 918000, '\p{^Is_Word_Break=__other}', "");
    Expect(0, 918000, '\P{Is_Word_Break=__other}', "");
    Expect(1, 918000, '\P{^Is_Word_Break=__other}', "");
    Expect(0, 917999, '\p{Is_Word_Break=__other}', "");
    Expect(1, 917999, '\p{^Is_Word_Break=__other}', "");
    Expect(1, 917999, '\P{Is_Word_Break=__other}', "");
    Expect(0, 917999, '\P{^Is_Word_Break=__other}', "");
    Error('\p{Is_WB=-:=xx}');
    Error('\P{Is_WB=-:=xx}');
    Expect(1, 918000, '\p{Is_WB=xx}', "");
    Expect(0, 918000, '\p{^Is_WB=xx}', "");
    Expect(0, 918000, '\P{Is_WB=xx}', "");
    Expect(1, 918000, '\P{^Is_WB=xx}', "");
    Expect(0, 917999, '\p{Is_WB=xx}', "");
    Expect(1, 917999, '\p{^Is_WB=xx}', "");
    Expect(1, 917999, '\P{Is_WB=xx}', "");
    Expect(0, 917999, '\P{^Is_WB=xx}', "");
    Expect(1, 918000, '\p{Is_WB:   		XX}', "");
    Expect(0, 918000, '\p{^Is_WB:   		XX}', "");
    Expect(0, 918000, '\P{Is_WB:   		XX}', "");
    Expect(1, 918000, '\P{^Is_WB:   		XX}', "");
    Expect(0, 917999, '\p{Is_WB:   		XX}', "");
    Expect(1, 917999, '\p{^Is_WB:   		XX}', "");
    Expect(1, 917999, '\P{Is_WB:   		XX}', "");
    Expect(0, 917999, '\P{^Is_WB:   		XX}', "");
    Error('\p{Word_Break=:=  ZWJ}');
    Error('\P{Word_Break=:=  ZWJ}');
    Expect(1, 8205, '\p{Word_Break=zwj}', "");
    Expect(0, 8205, '\p{^Word_Break=zwj}', "");
    Expect(0, 8205, '\P{Word_Break=zwj}', "");
    Expect(1, 8205, '\P{^Word_Break=zwj}', "");
    Expect(0, 8206, '\p{Word_Break=zwj}', "");
    Expect(1, 8206, '\p{^Word_Break=zwj}', "");
    Expect(1, 8206, '\P{Word_Break=zwj}', "");
    Expect(0, 8206, '\P{^Word_Break=zwj}', "");
    Expect(1, 8205, '\p{Word_Break=_ ZWJ}', "");
    Expect(0, 8205, '\p{^Word_Break=_ ZWJ}', "");
    Expect(0, 8205, '\P{Word_Break=_ ZWJ}', "");
    Expect(1, 8205, '\P{^Word_Break=_ ZWJ}', "");
    Expect(0, 8206, '\p{Word_Break=_ ZWJ}', "");
    Expect(1, 8206, '\p{^Word_Break=_ ZWJ}', "");
    Expect(1, 8206, '\P{Word_Break=_ ZWJ}', "");
    Expect(0, 8206, '\P{^Word_Break=_ ZWJ}', "");
    Error('\p{WB=:=	ZWJ}');
    Error('\P{WB=:=	ZWJ}');
    Expect(1, 8205, '\p{WB=zwj}', "");
    Expect(0, 8205, '\p{^WB=zwj}', "");
    Expect(0, 8205, '\P{WB=zwj}', "");
    Expect(1, 8205, '\P{^WB=zwj}', "");
    Expect(0, 8206, '\p{WB=zwj}', "");
    Expect(1, 8206, '\p{^WB=zwj}', "");
    Expect(1, 8206, '\P{WB=zwj}', "");
    Expect(0, 8206, '\P{^WB=zwj}', "");
    Expect(1, 8205, '\p{WB=-ZWJ}', "");
    Expect(0, 8205, '\p{^WB=-ZWJ}', "");
    Expect(0, 8205, '\P{WB=-ZWJ}', "");
    Expect(1, 8205, '\P{^WB=-ZWJ}', "");
    Expect(0, 8206, '\p{WB=-ZWJ}', "");
    Expect(1, 8206, '\p{^WB=-ZWJ}', "");
    Expect(1, 8206, '\P{WB=-ZWJ}', "");
    Expect(0, 8206, '\P{^WB=-ZWJ}', "");
    Error('\p{Is_Word_Break=/a/ 	ZWJ}');
    Error('\P{Is_Word_Break=/a/ 	ZWJ}');
    Expect(1, 8205, '\p{Is_Word_Break=zwj}', "");
    Expect(0, 8205, '\p{^Is_Word_Break=zwj}', "");
    Expect(0, 8205, '\P{Is_Word_Break=zwj}', "");
    Expect(1, 8205, '\P{^Is_Word_Break=zwj}', "");
    Expect(0, 8206, '\p{Is_Word_Break=zwj}', "");
    Expect(1, 8206, '\p{^Is_Word_Break=zwj}', "");
    Expect(1, 8206, '\P{Is_Word_Break=zwj}', "");
    Expect(0, 8206, '\P{^Is_Word_Break=zwj}', "");
    Expect(1, 8205, '\p{Is_Word_Break=-ZWJ}', "");
    Expect(0, 8205, '\p{^Is_Word_Break=-ZWJ}', "");
    Expect(0, 8205, '\P{Is_Word_Break=-ZWJ}', "");
    Expect(1, 8205, '\P{^Is_Word_Break=-ZWJ}', "");
    Expect(0, 8206, '\p{Is_Word_Break=-ZWJ}', "");
    Expect(1, 8206, '\p{^Is_Word_Break=-ZWJ}', "");
    Expect(1, 8206, '\P{Is_Word_Break=-ZWJ}', "");
    Expect(0, 8206, '\P{^Is_Word_Break=-ZWJ}', "");
    Error('\p{Is_WB=/a/_ZWJ}');
    Error('\P{Is_WB=/a/_ZWJ}');
    Expect(1, 8205, '\p{Is_WB=zwj}', "");
    Expect(0, 8205, '\p{^Is_WB=zwj}', "");
    Expect(0, 8205, '\P{Is_WB=zwj}', "");
    Expect(1, 8205, '\P{^Is_WB=zwj}', "");
    Expect(0, 8206, '\p{Is_WB=zwj}', "");
    Expect(1, 8206, '\p{^Is_WB=zwj}', "");
    Expect(1, 8206, '\P{Is_WB=zwj}', "");
    Expect(0, 8206, '\P{^Is_WB=zwj}', "");
    Expect(1, 8205, '\p{Is_WB:    _ZWJ}', "");
    Expect(0, 8205, '\p{^Is_WB:    _ZWJ}', "");
    Expect(0, 8205, '\P{Is_WB:    _ZWJ}', "");
    Expect(1, 8205, '\P{^Is_WB:    _ZWJ}', "");
    Expect(0, 8206, '\p{Is_WB:    _ZWJ}', "");
    Expect(1, 8206, '\p{^Is_WB:    _ZWJ}', "");
    Expect(1, 8206, '\P{Is_WB:    _ZWJ}', "");
    Expect(0, 8206, '\P{^Is_WB:    _ZWJ}', "");
    Error('\p{White_Space=_:=No}');
    Error('\P{White_Space=_:=No}');
    Expect(1, 12289, '\p{White_Space=no}', "");
    Expect(0, 12289, '\p{^White_Space=no}', "");
    Expect(0, 12289, '\P{White_Space=no}', "");
    Expect(1, 12289, '\P{^White_Space=no}', "");
    Expect(0, 12288, '\p{White_Space=no}', "");
    Expect(1, 12288, '\p{^White_Space=no}', "");
    Expect(1, 12288, '\P{White_Space=no}', "");
    Expect(0, 12288, '\P{^White_Space=no}', "");
    Expect(1, 12289, '\p{White_Space=		No}', "");
    Expect(0, 12289, '\p{^White_Space=		No}', "");
    Expect(0, 12289, '\P{White_Space=		No}', "");
    Expect(1, 12289, '\P{^White_Space=		No}', "");
    Expect(0, 12288, '\p{White_Space=		No}', "");
    Expect(1, 12288, '\p{^White_Space=		No}', "");
    Expect(1, 12288, '\P{White_Space=		No}', "");
    Expect(0, 12288, '\P{^White_Space=		No}', "");
    Error('\p{WSpace=	/a/N}');
    Error('\P{WSpace=	/a/N}');
    Expect(1, 12289, '\p{WSpace=n}', "");
    Expect(0, 12289, '\p{^WSpace=n}', "");
    Expect(0, 12289, '\P{WSpace=n}', "");
    Expect(1, 12289, '\P{^WSpace=n}', "");
    Expect(0, 12288, '\p{WSpace=n}', "");
    Expect(1, 12288, '\p{^WSpace=n}', "");
    Expect(1, 12288, '\P{WSpace=n}', "");
    Expect(0, 12288, '\P{^WSpace=n}', "");
    Expect(1, 12289, '\p{WSpace=	_N}', "");
    Expect(0, 12289, '\p{^WSpace=	_N}', "");
    Expect(0, 12289, '\P{WSpace=	_N}', "");
    Expect(1, 12289, '\P{^WSpace=	_N}', "");
    Expect(0, 12288, '\p{WSpace=	_N}', "");
    Expect(1, 12288, '\p{^WSpace=	_N}', "");
    Expect(1, 12288, '\P{WSpace=	_N}', "");
    Expect(0, 12288, '\P{^WSpace=	_N}', "");
    Error('\p{Space=:=  f}');
    Error('\P{Space=:=  f}');
    Expect(1, 12289, '\p{Space=f}', "");
    Expect(0, 12289, '\p{^Space=f}', "");
    Expect(0, 12289, '\P{Space=f}', "");
    Expect(1, 12289, '\P{^Space=f}', "");
    Expect(0, 12288, '\p{Space=f}', "");
    Expect(1, 12288, '\p{^Space=f}', "");
    Expect(1, 12288, '\P{Space=f}', "");
    Expect(0, 12288, '\P{^Space=f}', "");
    Expect(1, 12289, '\p{Space=-F}', "");
    Expect(0, 12289, '\p{^Space=-F}', "");
    Expect(0, 12289, '\P{Space=-F}', "");
    Expect(1, 12289, '\P{^Space=-F}', "");
    Expect(0, 12288, '\p{Space=-F}', "");
    Expect(1, 12288, '\p{^Space=-F}', "");
    Expect(1, 12288, '\P{Space=-F}', "");
    Expect(0, 12288, '\P{^Space=-F}', "");
    Error('\p{Is_White_Space=	false/a/}');
    Error('\P{Is_White_Space=	false/a/}');
    Expect(1, 12289, '\p{Is_White_Space=false}', "");
    Expect(0, 12289, '\p{^Is_White_Space=false}', "");
    Expect(0, 12289, '\P{Is_White_Space=false}', "");
    Expect(1, 12289, '\P{^Is_White_Space=false}', "");
    Expect(0, 12288, '\p{Is_White_Space=false}', "");
    Expect(1, 12288, '\p{^Is_White_Space=false}', "");
    Expect(1, 12288, '\P{Is_White_Space=false}', "");
    Expect(0, 12288, '\P{^Is_White_Space=false}', "");
    Expect(1, 12289, '\p{Is_White_Space=_False}', "");
    Expect(0, 12289, '\p{^Is_White_Space=_False}', "");
    Expect(0, 12289, '\P{Is_White_Space=_False}', "");
    Expect(1, 12289, '\P{^Is_White_Space=_False}', "");
    Expect(0, 12288, '\p{Is_White_Space=_False}', "");
    Expect(1, 12288, '\p{^Is_White_Space=_False}', "");
    Expect(1, 12288, '\P{Is_White_Space=_False}', "");
    Expect(0, 12288, '\P{^Is_White_Space=_False}', "");
    Error('\p{Is_WSpace=:=_	No}');
    Error('\P{Is_WSpace=:=_	No}');
    Expect(1, 12289, '\p{Is_WSpace:   no}', "");
    Expect(0, 12289, '\p{^Is_WSpace:   no}', "");
    Expect(0, 12289, '\P{Is_WSpace:   no}', "");
    Expect(1, 12289, '\P{^Is_WSpace:   no}', "");
    Expect(0, 12288, '\p{Is_WSpace:   no}', "");
    Expect(1, 12288, '\p{^Is_WSpace:   no}', "");
    Expect(1, 12288, '\P{Is_WSpace:   no}', "");
    Expect(0, 12288, '\P{^Is_WSpace:   no}', "");
    Expect(1, 12289, '\p{Is_WSpace:-	No}', "");
    Expect(0, 12289, '\p{^Is_WSpace:-	No}', "");
    Expect(0, 12289, '\P{Is_WSpace:-	No}', "");
    Expect(1, 12289, '\P{^Is_WSpace:-	No}', "");
    Expect(0, 12288, '\p{Is_WSpace:-	No}', "");
    Expect(1, 12288, '\p{^Is_WSpace:-	No}', "");
    Expect(1, 12288, '\P{Is_WSpace:-	No}', "");
    Expect(0, 12288, '\P{^Is_WSpace:-	No}', "");
    Error('\p{Is_Space=/a/_	N}');
    Error('\P{Is_Space=/a/_	N}');
    Expect(1, 12289, '\p{Is_Space=n}', "");
    Expect(0, 12289, '\p{^Is_Space=n}', "");
    Expect(0, 12289, '\P{Is_Space=n}', "");
    Expect(1, 12289, '\P{^Is_Space=n}', "");
    Expect(0, 12288, '\p{Is_Space=n}', "");
    Expect(1, 12288, '\p{^Is_Space=n}', "");
    Expect(1, 12288, '\P{Is_Space=n}', "");
    Expect(0, 12288, '\P{^Is_Space=n}', "");
    Expect(1, 12289, '\p{Is_Space= n}', "");
    Expect(0, 12289, '\p{^Is_Space= n}', "");
    Expect(0, 12289, '\P{Is_Space= n}', "");
    Expect(1, 12289, '\P{^Is_Space= n}', "");
    Expect(0, 12288, '\p{Is_Space= n}', "");
    Expect(1, 12288, '\p{^Is_Space= n}', "");
    Expect(1, 12288, '\P{Is_Space= n}', "");
    Expect(0, 12288, '\P{^Is_Space= n}', "");
    Error('\p{White_Space=/a/yes}');
    Error('\P{White_Space=/a/yes}');
    Expect(1, 12288, '\p{White_Space=yes}', "");
    Expect(0, 12288, '\p{^White_Space=yes}', "");
    Expect(0, 12288, '\P{White_Space=yes}', "");
    Expect(1, 12288, '\P{^White_Space=yes}', "");
    Expect(0, 12289, '\p{White_Space=yes}', "");
    Expect(1, 12289, '\p{^White_Space=yes}', "");
    Expect(1, 12289, '\P{White_Space=yes}', "");
    Expect(0, 12289, '\P{^White_Space=yes}', "");
    Expect(1, 12288, '\p{White_Space=-yes}', "");
    Expect(0, 12288, '\p{^White_Space=-yes}', "");
    Expect(0, 12288, '\P{White_Space=-yes}', "");
    Expect(1, 12288, '\P{^White_Space=-yes}', "");
    Expect(0, 12289, '\p{White_Space=-yes}', "");
    Expect(1, 12289, '\p{^White_Space=-yes}', "");
    Expect(1, 12289, '\P{White_Space=-yes}', "");
    Expect(0, 12289, '\P{^White_Space=-yes}', "");
    Error('\p{WSpace=_Y/a/}');
    Error('\P{WSpace=_Y/a/}');
    Expect(1, 12288, '\p{WSpace=y}', "");
    Expect(0, 12288, '\p{^WSpace=y}', "");
    Expect(0, 12288, '\P{WSpace=y}', "");
    Expect(1, 12288, '\P{^WSpace=y}', "");
    Expect(0, 12289, '\p{WSpace=y}', "");
    Expect(1, 12289, '\p{^WSpace=y}', "");
    Expect(1, 12289, '\P{WSpace=y}', "");
    Expect(0, 12289, '\P{^WSpace=y}', "");
    Expect(1, 12288, '\p{WSpace= -y}', "");
    Expect(0, 12288, '\p{^WSpace= -y}', "");
    Expect(0, 12288, '\P{WSpace= -y}', "");
    Expect(1, 12288, '\P{^WSpace= -y}', "");
    Expect(0, 12289, '\p{WSpace= -y}', "");
    Expect(1, 12289, '\p{^WSpace= -y}', "");
    Expect(1, 12289, '\P{WSpace= -y}', "");
    Expect(0, 12289, '\P{^WSpace= -y}', "");
    Error('\p{Space=	/a/T}');
    Error('\P{Space=	/a/T}');
    Expect(1, 12288, '\p{Space=t}', "");
    Expect(0, 12288, '\p{^Space=t}', "");
    Expect(0, 12288, '\P{Space=t}', "");
    Expect(1, 12288, '\P{^Space=t}', "");
    Expect(0, 12289, '\p{Space=t}', "");
    Expect(1, 12289, '\p{^Space=t}', "");
    Expect(1, 12289, '\P{Space=t}', "");
    Expect(0, 12289, '\P{^Space=t}', "");
    Expect(1, 12288, '\p{Space=_T}', "");
    Expect(0, 12288, '\p{^Space=_T}', "");
    Expect(0, 12288, '\P{Space=_T}', "");
    Expect(1, 12288, '\P{^Space=_T}', "");
    Expect(0, 12289, '\p{Space=_T}', "");
    Expect(1, 12289, '\p{^Space=_T}', "");
    Expect(1, 12289, '\P{Space=_T}', "");
    Expect(0, 12289, '\P{^Space=_T}', "");
    Error('\p{Is_White_Space: /a/_ True}');
    Error('\P{Is_White_Space: /a/_ True}');
    Expect(1, 12288, '\p{Is_White_Space=true}', "");
    Expect(0, 12288, '\p{^Is_White_Space=true}', "");
    Expect(0, 12288, '\P{Is_White_Space=true}', "");
    Expect(1, 12288, '\P{^Is_White_Space=true}', "");
    Expect(0, 12289, '\p{Is_White_Space=true}', "");
    Expect(1, 12289, '\p{^Is_White_Space=true}', "");
    Expect(1, 12289, '\P{Is_White_Space=true}', "");
    Expect(0, 12289, '\P{^Is_White_Space=true}', "");
    Expect(1, 12288, '\p{Is_White_Space= true}', "");
    Expect(0, 12288, '\p{^Is_White_Space= true}', "");
    Expect(0, 12288, '\P{Is_White_Space= true}', "");
    Expect(1, 12288, '\P{^Is_White_Space= true}', "");
    Expect(0, 12289, '\p{Is_White_Space= true}', "");
    Expect(1, 12289, '\p{^Is_White_Space= true}', "");
    Expect(1, 12289, '\P{Is_White_Space= true}', "");
    Expect(0, 12289, '\P{^Is_White_Space= true}', "");
    Error('\p{Is_WSpace=/a/Yes}');
    Error('\P{Is_WSpace=/a/Yes}');
    Expect(1, 12288, '\p{Is_WSpace=yes}', "");
    Expect(0, 12288, '\p{^Is_WSpace=yes}', "");
    Expect(0, 12288, '\P{Is_WSpace=yes}', "");
    Expect(1, 12288, '\P{^Is_WSpace=yes}', "");
    Expect(0, 12289, '\p{Is_WSpace=yes}', "");
    Expect(1, 12289, '\p{^Is_WSpace=yes}', "");
    Expect(1, 12289, '\P{Is_WSpace=yes}', "");
    Expect(0, 12289, '\P{^Is_WSpace=yes}', "");
    Expect(1, 12288, '\p{Is_WSpace=- yes}', "");
    Expect(0, 12288, '\p{^Is_WSpace=- yes}', "");
    Expect(0, 12288, '\P{Is_WSpace=- yes}', "");
    Expect(1, 12288, '\P{^Is_WSpace=- yes}', "");
    Expect(0, 12289, '\p{Is_WSpace=- yes}', "");
    Expect(1, 12289, '\p{^Is_WSpace=- yes}', "");
    Expect(1, 12289, '\P{Is_WSpace=- yes}', "");
    Expect(0, 12289, '\P{^Is_WSpace=- yes}', "");
    Error('\p{Is_Space=	_Y/a/}');
    Error('\P{Is_Space=	_Y/a/}');
    Expect(1, 12288, '\p{Is_Space=y}', "");
    Expect(0, 12288, '\p{^Is_Space=y}', "");
    Expect(0, 12288, '\P{Is_Space=y}', "");
    Expect(1, 12288, '\P{^Is_Space=y}', "");
    Expect(0, 12289, '\p{Is_Space=y}', "");
    Expect(1, 12289, '\p{^Is_Space=y}', "");
    Expect(1, 12289, '\P{Is_Space=y}', "");
    Expect(0, 12289, '\P{^Is_Space=y}', "");
    Expect(1, 12288, '\p{Is_Space=_Y}', "");
    Expect(0, 12288, '\p{^Is_Space=_Y}', "");
    Expect(0, 12288, '\P{Is_Space=_Y}', "");
    Expect(1, 12288, '\P{^Is_Space=_Y}', "");
    Expect(0, 12289, '\p{Is_Space=_Y}', "");
    Expect(1, 12289, '\p{^Is_Space=_Y}', "");
    Expect(1, 12289, '\P{Is_Space=_Y}', "");
    Expect(0, 12289, '\P{^Is_Space=_Y}', "");
    Error('\p{XID_Continue=_No/a/}');
    Error('\P{XID_Continue=_No/a/}');
    Expect(1, 918000, '\p{XID_Continue=no}', "");
    Expect(0, 918000, '\p{^XID_Continue=no}', "");
    Expect(0, 918000, '\P{XID_Continue=no}', "");
    Expect(1, 918000, '\P{^XID_Continue=no}', "");
    Expect(0, 917999, '\p{XID_Continue=no}', "");
    Expect(1, 917999, '\p{^XID_Continue=no}', "");
    Expect(1, 917999, '\P{XID_Continue=no}', "");
    Expect(0, 917999, '\P{^XID_Continue=no}', "");
    Expect(1, 918000, '\p{XID_Continue:	-_NO}', "");
    Expect(0, 918000, '\p{^XID_Continue:	-_NO}', "");
    Expect(0, 918000, '\P{XID_Continue:	-_NO}', "");
    Expect(1, 918000, '\P{^XID_Continue:	-_NO}', "");
    Expect(0, 917999, '\p{XID_Continue:	-_NO}', "");
    Expect(1, 917999, '\p{^XID_Continue:	-_NO}', "");
    Expect(1, 917999, '\P{XID_Continue:	-_NO}', "");
    Expect(0, 917999, '\P{^XID_Continue:	-_NO}', "");
    Error('\p{XIDC:/a/ N}');
    Error('\P{XIDC:/a/ N}');
    Expect(1, 918000, '\p{XIDC=n}', "");
    Expect(0, 918000, '\p{^XIDC=n}', "");
    Expect(0, 918000, '\P{XIDC=n}', "");
    Expect(1, 918000, '\P{^XIDC=n}', "");
    Expect(0, 917999, '\p{XIDC=n}', "");
    Expect(1, 917999, '\p{^XIDC=n}', "");
    Expect(1, 917999, '\P{XIDC=n}', "");
    Expect(0, 917999, '\P{^XIDC=n}', "");
    Expect(1, 918000, '\p{XIDC=_	N}', "");
    Expect(0, 918000, '\p{^XIDC=_	N}', "");
    Expect(0, 918000, '\P{XIDC=_	N}', "");
    Expect(1, 918000, '\P{^XIDC=_	N}', "");
    Expect(0, 917999, '\p{XIDC=_	N}', "");
    Expect(1, 917999, '\p{^XIDC=_	N}', "");
    Expect(1, 917999, '\P{XIDC=_	N}', "");
    Expect(0, 917999, '\P{^XIDC=_	N}', "");
    Error('\p{Is_XID_Continue:   /a/_-F}');
    Error('\P{Is_XID_Continue:   /a/_-F}');
    Expect(1, 918000, '\p{Is_XID_Continue=f}', "");
    Expect(0, 918000, '\p{^Is_XID_Continue=f}', "");
    Expect(0, 918000, '\P{Is_XID_Continue=f}', "");
    Expect(1, 918000, '\P{^Is_XID_Continue=f}', "");
    Expect(0, 917999, '\p{Is_XID_Continue=f}', "");
    Expect(1, 917999, '\p{^Is_XID_Continue=f}', "");
    Expect(1, 917999, '\P{Is_XID_Continue=f}', "");
    Expect(0, 917999, '\P{^Is_XID_Continue=f}', "");
    Expect(1, 918000, '\p{Is_XID_Continue= _F}', "");
    Expect(0, 918000, '\p{^Is_XID_Continue= _F}', "");
    Expect(0, 918000, '\P{Is_XID_Continue= _F}', "");
    Expect(1, 918000, '\P{^Is_XID_Continue= _F}', "");
    Expect(0, 917999, '\p{Is_XID_Continue= _F}', "");
    Expect(1, 917999, '\p{^Is_XID_Continue= _F}', "");
    Expect(1, 917999, '\P{Is_XID_Continue= _F}', "");
    Expect(0, 917999, '\P{^Is_XID_Continue= _F}', "");
    Error('\p{Is_XIDC=	-False/a/}');
    Error('\P{Is_XIDC=	-False/a/}');
    Expect(1, 918000, '\p{Is_XIDC=false}', "");
    Expect(0, 918000, '\p{^Is_XIDC=false}', "");
    Expect(0, 918000, '\P{Is_XIDC=false}', "");
    Expect(1, 918000, '\P{^Is_XIDC=false}', "");
    Expect(0, 917999, '\p{Is_XIDC=false}', "");
    Expect(1, 917999, '\p{^Is_XIDC=false}', "");
    Expect(1, 917999, '\P{Is_XIDC=false}', "");
    Expect(0, 917999, '\P{^Is_XIDC=false}', "");
    Expect(1, 918000, '\p{Is_XIDC=_FALSE}', "");
    Expect(0, 918000, '\p{^Is_XIDC=_FALSE}', "");
    Expect(0, 918000, '\P{Is_XIDC=_FALSE}', "");
    Expect(1, 918000, '\P{^Is_XIDC=_FALSE}', "");
    Expect(0, 917999, '\p{Is_XIDC=_FALSE}', "");
    Expect(1, 917999, '\p{^Is_XIDC=_FALSE}', "");
    Expect(1, 917999, '\P{Is_XIDC=_FALSE}', "");
    Expect(0, 917999, '\P{^Is_XIDC=_FALSE}', "");
    Error('\p{XID_Continue=/a/-_YES}');
    Error('\P{XID_Continue=/a/-_YES}');
    Expect(1, 917999, '\p{XID_Continue=yes}', "");
    Expect(0, 917999, '\p{^XID_Continue=yes}', "");
    Expect(0, 917999, '\P{XID_Continue=yes}', "");
    Expect(1, 917999, '\P{^XID_Continue=yes}', "");
    Expect(0, 918000, '\p{XID_Continue=yes}', "");
    Expect(1, 918000, '\p{^XID_Continue=yes}', "");
    Expect(1, 918000, '\P{XID_Continue=yes}', "");
    Expect(0, 918000, '\P{^XID_Continue=yes}', "");
    Expect(1, 917999, '\p{XID_Continue=-Yes}', "");
    Expect(0, 917999, '\p{^XID_Continue=-Yes}', "");
    Expect(0, 917999, '\P{XID_Continue=-Yes}', "");
    Expect(1, 917999, '\P{^XID_Continue=-Yes}', "");
    Expect(0, 918000, '\p{XID_Continue=-Yes}', "");
    Expect(1, 918000, '\p{^XID_Continue=-Yes}', "");
    Expect(1, 918000, '\P{XID_Continue=-Yes}', "");
    Expect(0, 918000, '\P{^XID_Continue=-Yes}', "");
    Error('\p{XIDC=_:=y}');
    Error('\P{XIDC=_:=y}');
    Expect(1, 917999, '\p{XIDC=y}', "");
    Expect(0, 917999, '\p{^XIDC=y}', "");
    Expect(0, 917999, '\P{XIDC=y}', "");
    Expect(1, 917999, '\P{^XIDC=y}', "");
    Expect(0, 918000, '\p{XIDC=y}', "");
    Expect(1, 918000, '\p{^XIDC=y}', "");
    Expect(1, 918000, '\P{XIDC=y}', "");
    Expect(0, 918000, '\P{^XIDC=y}', "");
    Expect(1, 917999, '\p{XIDC= Y}', "");
    Expect(0, 917999, '\p{^XIDC= Y}', "");
    Expect(0, 917999, '\P{XIDC= Y}', "");
    Expect(1, 917999, '\P{^XIDC= Y}', "");
    Expect(0, 918000, '\p{XIDC= Y}', "");
    Expect(1, 918000, '\p{^XIDC= Y}', "");
    Expect(1, 918000, '\P{XIDC= Y}', "");
    Expect(0, 918000, '\P{^XIDC= Y}', "");
    Error('\p{Is_XID_Continue:	/a/-	T}');
    Error('\P{Is_XID_Continue:	/a/-	T}');
    Expect(1, 917999, '\p{Is_XID_Continue=t}', "");
    Expect(0, 917999, '\p{^Is_XID_Continue=t}', "");
    Expect(0, 917999, '\P{Is_XID_Continue=t}', "");
    Expect(1, 917999, '\P{^Is_XID_Continue=t}', "");
    Expect(0, 918000, '\p{Is_XID_Continue=t}', "");
    Expect(1, 918000, '\p{^Is_XID_Continue=t}', "");
    Expect(1, 918000, '\P{Is_XID_Continue=t}', "");
    Expect(0, 918000, '\P{^Is_XID_Continue=t}', "");
    Expect(1, 917999, '\p{Is_XID_Continue=_T}', "");
    Expect(0, 917999, '\p{^Is_XID_Continue=_T}', "");
    Expect(0, 917999, '\P{Is_XID_Continue=_T}', "");
    Expect(1, 917999, '\P{^Is_XID_Continue=_T}', "");
    Expect(0, 918000, '\p{Is_XID_Continue=_T}', "");
    Expect(1, 918000, '\p{^Is_XID_Continue=_T}', "");
    Expect(1, 918000, '\P{Is_XID_Continue=_T}', "");
    Expect(0, 918000, '\P{^Is_XID_Continue=_T}', "");
    Error('\p{Is_XIDC=	/a/TRUE}');
    Error('\P{Is_XIDC=	/a/TRUE}');
    Expect(1, 917999, '\p{Is_XIDC=true}', "");
    Expect(0, 917999, '\p{^Is_XIDC=true}', "");
    Expect(0, 917999, '\P{Is_XIDC=true}', "");
    Expect(1, 917999, '\P{^Is_XIDC=true}', "");
    Expect(0, 918000, '\p{Is_XIDC=true}', "");
    Expect(1, 918000, '\p{^Is_XIDC=true}', "");
    Expect(1, 918000, '\P{Is_XIDC=true}', "");
    Expect(0, 918000, '\P{^Is_XIDC=true}', "");
    Expect(1, 917999, '\p{Is_XIDC=-True}', "");
    Expect(0, 917999, '\p{^Is_XIDC=-True}', "");
    Expect(0, 917999, '\P{Is_XIDC=-True}', "");
    Expect(1, 917999, '\P{^Is_XIDC=-True}', "");
    Expect(0, 918000, '\p{Is_XIDC=-True}', "");
    Expect(1, 918000, '\p{^Is_XIDC=-True}', "");
    Expect(1, 918000, '\P{Is_XIDC=-True}', "");
    Expect(0, 918000, '\P{^Is_XIDC=-True}', "");
    Error('\p{XID_Start=_No/a/}');
    Error('\P{XID_Start=_No/a/}');
    Expect(1, 195102, '\p{XID_Start=no}', "");
    Expect(0, 195102, '\p{^XID_Start=no}', "");
    Expect(0, 195102, '\P{XID_Start=no}', "");
    Expect(1, 195102, '\P{^XID_Start=no}', "");
    Expect(0, 195101, '\p{XID_Start=no}', "");
    Expect(1, 195101, '\p{^XID_Start=no}', "");
    Expect(1, 195101, '\P{XID_Start=no}', "");
    Expect(0, 195101, '\P{^XID_Start=no}', "");
    Expect(1, 195102, '\p{XID_Start=	No}', "");
    Expect(0, 195102, '\p{^XID_Start=	No}', "");
    Expect(0, 195102, '\P{XID_Start=	No}', "");
    Expect(1, 195102, '\P{^XID_Start=	No}', "");
    Expect(0, 195101, '\p{XID_Start=	No}', "");
    Expect(1, 195101, '\p{^XID_Start=	No}', "");
    Expect(1, 195101, '\P{XID_Start=	No}', "");
    Expect(0, 195101, '\P{^XID_Start=	No}', "");
    Error('\p{XIDS= :=N}');
    Error('\P{XIDS= :=N}');
    Expect(1, 195102, '\p{XIDS=n}', "");
    Expect(0, 195102, '\p{^XIDS=n}', "");
    Expect(0, 195102, '\P{XIDS=n}', "");
    Expect(1, 195102, '\P{^XIDS=n}', "");
    Expect(0, 195101, '\p{XIDS=n}', "");
    Expect(1, 195101, '\p{^XIDS=n}', "");
    Expect(1, 195101, '\P{XIDS=n}', "");
    Expect(0, 195101, '\P{^XIDS=n}', "");
    Expect(1, 195102, '\p{XIDS=_-n}', "");
    Expect(0, 195102, '\p{^XIDS=_-n}', "");
    Expect(0, 195102, '\P{XIDS=_-n}', "");
    Expect(1, 195102, '\P{^XIDS=_-n}', "");
    Expect(0, 195101, '\p{XIDS=_-n}', "");
    Expect(1, 195101, '\p{^XIDS=_-n}', "");
    Expect(1, 195101, '\P{XIDS=_-n}', "");
    Expect(0, 195101, '\P{^XIDS=_-n}', "");
    Error('\p{Is_XID_Start=	_F/a/}');
    Error('\P{Is_XID_Start=	_F/a/}');
    Expect(1, 195102, '\p{Is_XID_Start=f}', "");
    Expect(0, 195102, '\p{^Is_XID_Start=f}', "");
    Expect(0, 195102, '\P{Is_XID_Start=f}', "");
    Expect(1, 195102, '\P{^Is_XID_Start=f}', "");
    Expect(0, 195101, '\p{Is_XID_Start=f}', "");
    Expect(1, 195101, '\p{^Is_XID_Start=f}', "");
    Expect(1, 195101, '\P{Is_XID_Start=f}', "");
    Expect(0, 195101, '\P{^Is_XID_Start=f}', "");
    Expect(1, 195102, '\p{Is_XID_Start=- F}', "");
    Expect(0, 195102, '\p{^Is_XID_Start=- F}', "");
    Expect(0, 195102, '\P{Is_XID_Start=- F}', "");
    Expect(1, 195102, '\P{^Is_XID_Start=- F}', "");
    Expect(0, 195101, '\p{Is_XID_Start=- F}', "");
    Expect(1, 195101, '\p{^Is_XID_Start=- F}', "");
    Expect(1, 195101, '\P{Is_XID_Start=- F}', "");
    Expect(0, 195101, '\P{^Is_XID_Start=- F}', "");
    Error('\p{Is_XIDS=:=-_false}');
    Error('\P{Is_XIDS=:=-_false}');
    Expect(1, 195102, '\p{Is_XIDS=false}', "");
    Expect(0, 195102, '\p{^Is_XIDS=false}', "");
    Expect(0, 195102, '\P{Is_XIDS=false}', "");
    Expect(1, 195102, '\P{^Is_XIDS=false}', "");
    Expect(0, 195101, '\p{Is_XIDS=false}', "");
    Expect(1, 195101, '\p{^Is_XIDS=false}', "");
    Expect(1, 195101, '\P{Is_XIDS=false}', "");
    Expect(0, 195101, '\P{^Is_XIDS=false}', "");
    Expect(1, 195102, '\p{Is_XIDS=FALSE}', "");
    Expect(0, 195102, '\p{^Is_XIDS=FALSE}', "");
    Expect(0, 195102, '\P{Is_XIDS=FALSE}', "");
    Expect(1, 195102, '\P{^Is_XIDS=FALSE}', "");
    Expect(0, 195101, '\p{Is_XIDS=FALSE}', "");
    Expect(1, 195101, '\p{^Is_XIDS=FALSE}', "");
    Expect(1, 195101, '\P{Is_XIDS=FALSE}', "");
    Expect(0, 195101, '\P{^Is_XIDS=FALSE}', "");
    Error('\p{XID_Start=/a/Yes}');
    Error('\P{XID_Start=/a/Yes}');
    Expect(1, 195101, '\p{XID_Start=yes}', "");
    Expect(0, 195101, '\p{^XID_Start=yes}', "");
    Expect(0, 195101, '\P{XID_Start=yes}', "");
    Expect(1, 195101, '\P{^XID_Start=yes}', "");
    Expect(0, 195102, '\p{XID_Start=yes}', "");
    Expect(1, 195102, '\p{^XID_Start=yes}', "");
    Expect(1, 195102, '\P{XID_Start=yes}', "");
    Expect(0, 195102, '\P{^XID_Start=yes}', "");
    Expect(1, 195101, '\p{XID_Start=_	yes}', "");
    Expect(0, 195101, '\p{^XID_Start=_	yes}', "");
    Expect(0, 195101, '\P{XID_Start=_	yes}', "");
    Expect(1, 195101, '\P{^XID_Start=_	yes}', "");
    Expect(0, 195102, '\p{XID_Start=_	yes}', "");
    Expect(1, 195102, '\p{^XID_Start=_	yes}', "");
    Expect(1, 195102, '\P{XID_Start=_	yes}', "");
    Expect(0, 195102, '\P{^XID_Start=_	yes}', "");
    Error('\p{XIDS=/a/_y}');
    Error('\P{XIDS=/a/_y}');
    Expect(1, 195101, '\p{XIDS=y}', "");
    Expect(0, 195101, '\p{^XIDS=y}', "");
    Expect(0, 195101, '\P{XIDS=y}', "");
    Expect(1, 195101, '\P{^XIDS=y}', "");
    Expect(0, 195102, '\p{XIDS=y}', "");
    Expect(1, 195102, '\p{^XIDS=y}', "");
    Expect(1, 195102, '\P{XIDS=y}', "");
    Expect(0, 195102, '\P{^XIDS=y}', "");
    Expect(1, 195101, '\p{XIDS=_	Y}', "");
    Expect(0, 195101, '\p{^XIDS=_	Y}', "");
    Expect(0, 195101, '\P{XIDS=_	Y}', "");
    Expect(1, 195101, '\P{^XIDS=_	Y}', "");
    Expect(0, 195102, '\p{XIDS=_	Y}', "");
    Expect(1, 195102, '\p{^XIDS=_	Y}', "");
    Expect(1, 195102, '\P{XIDS=_	Y}', "");
    Expect(0, 195102, '\P{^XIDS=_	Y}', "");
    Error('\p{Is_XID_Start=	T/a/}');
    Error('\P{Is_XID_Start=	T/a/}');
    Expect(1, 195101, '\p{Is_XID_Start=t}', "");
    Expect(0, 195101, '\p{^Is_XID_Start=t}', "");
    Expect(0, 195101, '\P{Is_XID_Start=t}', "");
    Expect(1, 195101, '\P{^Is_XID_Start=t}', "");
    Expect(0, 195102, '\p{Is_XID_Start=t}', "");
    Expect(1, 195102, '\p{^Is_XID_Start=t}', "");
    Expect(1, 195102, '\P{Is_XID_Start=t}', "");
    Expect(0, 195102, '\P{^Is_XID_Start=t}', "");
    Expect(1, 195101, '\p{Is_XID_Start=_	T}', "");
    Expect(0, 195101, '\p{^Is_XID_Start=_	T}', "");
    Expect(0, 195101, '\P{Is_XID_Start=_	T}', "");
    Expect(1, 195101, '\P{^Is_XID_Start=_	T}', "");
    Expect(0, 195102, '\p{Is_XID_Start=_	T}', "");
    Expect(1, 195102, '\p{^Is_XID_Start=_	T}', "");
    Expect(1, 195102, '\P{Is_XID_Start=_	T}', "");
    Expect(0, 195102, '\P{^Is_XID_Start=_	T}', "");
    Error('\p{Is_XIDS= :=True}');
    Error('\P{Is_XIDS= :=True}');
    Expect(1, 195101, '\p{Is_XIDS=true}', "");
    Expect(0, 195101, '\p{^Is_XIDS=true}', "");
    Expect(0, 195101, '\P{Is_XIDS=true}', "");
    Expect(1, 195101, '\P{^Is_XIDS=true}', "");
    Expect(0, 195102, '\p{Is_XIDS=true}', "");
    Expect(1, 195102, '\p{^Is_XIDS=true}', "");
    Expect(1, 195102, '\P{Is_XIDS=true}', "");
    Expect(0, 195102, '\P{^Is_XIDS=true}', "");
    Expect(1, 195101, '\p{Is_XIDS=-_True}', "");
    Expect(0, 195101, '\p{^Is_XIDS=-_True}', "");
    Expect(0, 195101, '\P{Is_XIDS=-_True}', "");
    Expect(1, 195101, '\P{^Is_XIDS=-_True}', "");
    Expect(0, 195102, '\p{Is_XIDS=-_True}', "");
    Expect(1, 195102, '\p{^Is_XIDS=-_True}', "");
    Expect(1, 195102, '\P{Is_XIDS=-_True}', "");
    Expect(0, 195102, '\P{^Is_XIDS=-_True}', "");
    Error('\p{Expands_On_NFC=No}');
    Error('\P{Expands_On_NFC=No}');
    Error('\p{XO_NFC=N}');
    Error('\P{XO_NFC=N}');
    Error('\p{Is_Expands_On_NFC=F}');
    Error('\P{Is_Expands_On_NFC=F}');
    Error('\p{Is_XO_NFC=False}');
    Error('\P{Is_XO_NFC=False}');
    Error('\p{Expands_On_NFC:   Yes}');
    Error('\P{Expands_On_NFC:   Yes}');
    Error('\p{XO_NFC=Y}');
    Error('\P{XO_NFC=Y}');
    Error('\p{Is_Expands_On_NFC=T}');
    Error('\P{Is_Expands_On_NFC=T}');
    Error('\p{Is_XO_NFC=True}');
    Error('\P{Is_XO_NFC=True}');
    Error('\p{Expands_On_NFD=No}');
    Error('\P{Expands_On_NFD=No}');
    Error('\p{XO_NFD=N}');
    Error('\P{XO_NFD=N}');
    Error('\p{Is_Expands_On_NFD=F}');
    Error('\P{Is_Expands_On_NFD=F}');
    Error('\p{Is_XO_NFD=False}');
    Error('\P{Is_XO_NFD=False}');
    Error('\p{Expands_On_NFD=Yes}');
    Error('\P{Expands_On_NFD=Yes}');
    Error('\p{XO_NFD=Y}');
    Error('\P{XO_NFD=Y}');
    Error('\p{Is_Expands_On_NFD=T}');
    Error('\P{Is_Expands_On_NFD=T}');
    Error('\p{Is_XO_NFD=True}');
    Error('\P{Is_XO_NFD=True}');
    Error('\p{Expands_On_NFKC=No}');
    Error('\P{Expands_On_NFKC=No}');
    Error('\p{XO_NFKC=N}');
    Error('\P{XO_NFKC=N}');
    Error('\p{Is_Expands_On_NFKC: F}');
    Error('\P{Is_Expands_On_NFKC: F}');
    Error('\p{Is_XO_NFKC=False}');
    Error('\P{Is_XO_NFKC=False}');
    Error('\p{Expands_On_NFKC: Yes}');
    Error('\P{Expands_On_NFKC: Yes}');
    Error('\p{XO_NFKC=Y}');
    Error('\P{XO_NFKC=Y}');
    Error('\p{Is_Expands_On_NFKC=T}');
    Error('\P{Is_Expands_On_NFKC=T}');
    Error('\p{Is_XO_NFKC: True}');
    Error('\P{Is_XO_NFKC: True}');
    Error('\p{Expands_On_NFKD=No}');
    Error('\P{Expands_On_NFKD=No}');
    Error('\p{XO_NFKD=N}');
    Error('\P{XO_NFKD=N}');
    Error('\p{Is_Expands_On_NFKD=F}');
    Error('\P{Is_Expands_On_NFKD=F}');
    Error('\p{Is_XO_NFKD=False}');
    Error('\P{Is_XO_NFKD=False}');
    Error('\p{Expands_On_NFKD=Yes}');
    Error('\P{Expands_On_NFKD=Yes}');
    Error('\p{XO_NFKD=Y}');
    Error('\P{XO_NFKD=Y}');
    Error('\p{Is_Expands_On_NFKD=T}');
    Error('\P{Is_Expands_On_NFKD=T}');
    Error('\p{Is_XO_NFKD=True}');
    Error('\P{Is_XO_NFKD=True}');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 5) {
    Test_GCB('÷ 0020 ÷ 0020 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 0020 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 000D ÷	#  ÷ [0.2] SPACE (Other) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 000D ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 000A ÷	#  ÷ [0.2] SPACE (Other) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 000A ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 0001 ÷	#  ÷ [0.2] SPACE (Other) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 0001 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0300 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 × 0300 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 0600 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 0600 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0903 ÷	#  ÷ [0.2] SPACE (Other) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 × 0903 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 1100 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 1100 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 1160 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 1160 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 11A8 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ AC00 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ AC00 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ AC01 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ AC01 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 1F1E6 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 261D ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 261D ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 1F3FB ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 0020 × 200D ÷	#  ÷ [0.2] SPACE (Other) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 × 200D ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 2640 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 2640 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 1F466 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 0378 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 0378 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ D800 ÷	#  ÷ [0.2] SPACE (Other) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ D800 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0020 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 000D × 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 × 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0600 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 0600 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0903 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 × 0903 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 1100 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 1100 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 1160 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 1160 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 11A8 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 11A8 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ AC00 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ AC00 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ AC01 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ AC01 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 1F1E6 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 261D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 261D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 1F3FB ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 1F3FB ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 200D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 × 200D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 2640 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 2640 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 1F466 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 1F466 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0378 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 0378 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ D800 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ D800 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0020 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 × 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0600 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 0600 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0903 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 × 0903 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 1100 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 1100 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 1160 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 1160 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 11A8 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 11A8 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ AC00 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ AC00 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ AC01 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ AC01 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 261D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 261D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 1F3FB ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 1F3FB ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 200D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 × 200D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 2640 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 2640 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 1F466 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 1F466 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0378 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 0378 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ D800 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ D800 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0020 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 000D ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 000A ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 × 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0600 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 0600 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0903 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 × 0903 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 1100 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 1100 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 1160 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 1160 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 11A8 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 11A8 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ AC00 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ AC00 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ AC01 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ AC01 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 1F1E6 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 261D ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 261D ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 1F3FB ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 1F3FB ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 200D ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 × 200D ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 2640 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 2640 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 1F466 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 1F466 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0378 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 0378 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ D800 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ D800 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 0020 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 0020 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 0600 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 0600 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0903 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 × 0903 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] COMBINING DIAERESIS (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 1100 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 1100 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 1160 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 1160 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 11A8 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ AC00 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ AC00 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ AC01 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ AC01 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 261D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 261D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 1F3FB ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 0300 × 200D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 × 200D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 2640 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 2640 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 1F466 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 0378 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 0378 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ D800 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ D800 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0020 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 0020 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0600 ÷ 000D ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 000D ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0600 ÷ 000A ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 000A ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0600 ÷ 0001 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 0001 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0300 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 × 0300 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0600 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 0600 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0903 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 × 0903 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0600 × 1100 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 1100 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0600 × 1160 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 1160 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0600 × 11A8 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0600 × AC00 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ AC00 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0600 × AC01 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ AC01 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0600 × 1F1E6 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0600 × 261D ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 261D ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 0600 × 1F3FB ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 0600 × 200D ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 × 200D ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 0600 × 2640 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 2640 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 0600 × 1F466 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0378 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 0378 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0600 ÷ D800 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ D800 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 0020 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 0020 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 000D ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 000D ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 000A ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 000A ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 0001 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 0001 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0300 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 × 0300 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 0600 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 0600 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0903 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 × 0903 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 1100 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 1100 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 1160 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 1160 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 11A8 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ AC00 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ AC00 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ AC01 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ AC01 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 1F1E6 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 261D ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 261D ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 1F3FB ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 0903 × 200D ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 × 200D ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 2640 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 2640 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 1F466 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 0378 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 0378 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ D800 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ D800 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 0020 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 000D ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 000D ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 000A ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 000A ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 0001 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0300 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 × 0300 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 0600 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 0600 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0903 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 × 0903 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1100 × 1100 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [6.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 1100 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1100 × 1160 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [6.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 1160 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1100 × AC00 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [6.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ AC00 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1100 × AC01 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [6.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ AC01 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 261D ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 261D ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 1F3FB ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 1100 × 200D ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 × 200D ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 2640 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 2640 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 1F466 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 0378 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 0378 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ D800 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ D800 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 0020 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 000D ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 000D ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 000A ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 000A ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 0001 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0300 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 × 0300 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 0600 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 0600 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0903 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 × 0903 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 1100 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 1100 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1160 × 1160 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [7.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 1160 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1160 × 11A8 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [7.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ AC00 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ AC00 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ AC01 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ AC01 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 261D ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 261D ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 1F3FB ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 1160 × 200D ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 × 200D ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 2640 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 2640 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 1F466 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 0378 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 0378 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ D800 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ D800 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 0020 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 000D ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 000D ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 000A ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 000A ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 0001 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0300 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 × 0300 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 0600 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 0600 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0903 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 × 0903 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 1100 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 1100 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 1160 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 1160 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 11A8 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [8.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ AC00 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ AC00 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ AC01 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ AC01 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 261D ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 261D ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 1F3FB ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 200D ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 × 200D ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 2640 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 2640 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 1F466 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 0378 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 0378 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ D800 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ D800 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 0020 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 000D ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 000D ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 000A ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 000A ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 0001 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0300 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 × 0300 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 0600 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 0600 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0903 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 × 0903 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC00 × 1160 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [7.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 1160 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ AC00 × 11A8 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [7.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ AC00 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ AC00 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ AC01 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ AC01 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 261D ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 261D ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 1F3FB ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ AC00 × 200D ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 × 200D ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 2640 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 2640 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 1F466 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 0378 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 0378 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ D800 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ D800 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 0020 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 000D ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 000D ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 000A ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 000A ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 0001 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0300 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 × 0300 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 0600 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 0600 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0903 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 × 0903 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 1160 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 1160 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ AC01 × 11A8 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [8.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ AC00 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ AC00 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ AC01 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ AC01 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 261D ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 261D ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 1F3FB ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ AC01 × 200D ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 × 200D ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 2640 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 2640 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 1F466 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 0378 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 0378 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ D800 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ D800 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 0020 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 0020 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 000D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 000D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 000A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 000A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 0001 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 0001 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0300 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 × 0300 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 0600 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 0600 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0903 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 × 0903 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 1100 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 1100 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 1160 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 1160 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 11A8 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ AC00 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ AC00 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ AC01 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ AC01 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 1F1E6 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [12.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 261D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 261D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 1F3FB ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 200D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 × 200D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 2640 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 2640 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 1F466 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 0378 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 0378 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ D800 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ D800 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 261D ÷ 0020 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 261D × 0308 ÷ 0020 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 261D ÷ 000D ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 261D × 0308 ÷ 000D ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 261D ÷ 000A ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 261D × 0308 ÷ 000A ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 261D ÷ 0001 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 261D × 0308 ÷ 0001 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 261D × 0300 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 261D × 0308 × 0300 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 261D ÷ 0600 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 261D × 0308 ÷ 0600 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 261D × 0903 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 261D × 0308 × 0903 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] COMBINING DIAERESIS (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 261D ÷ 1100 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 261D × 0308 ÷ 1100 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 261D ÷ 1160 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 261D × 0308 ÷ 1160 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 261D ÷ 11A8 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 261D × 0308 ÷ 11A8 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 261D ÷ AC00 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 261D × 0308 ÷ AC00 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 261D ÷ AC01 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 261D × 0308 ÷ AC01 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 261D ÷ 1F1E6 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 261D × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 261D ÷ 261D ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 261D × 0308 ÷ 261D ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 261D × 1F3FB ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [10.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 261D × 0308 × 1F3FB ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] COMBINING DIAERESIS (Extend) × [10.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 261D × 200D ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 261D × 0308 × 200D ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 261D ÷ 2640 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 261D × 0308 ÷ 2640 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 261D ÷ 1F466 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 261D × 0308 ÷ 1F466 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 261D ÷ 0378 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 261D × 0308 ÷ 0378 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 261D ÷ D800 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 261D × 0308 ÷ D800 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 1F3FB ÷ 0020 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0308 ÷ 0020 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1F3FB ÷ 000D ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0308 ÷ 000D ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1F3FB ÷ 000A ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0308 ÷ 000A ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1F3FB ÷ 0001 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0308 ÷ 0001 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0300 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0308 × 0300 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 1F3FB ÷ 0600 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0308 ÷ 0600 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0903 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0308 × 0903 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] COMBINING DIAERESIS (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1F3FB ÷ 1100 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0308 ÷ 1100 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1F3FB ÷ 1160 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0308 ÷ 1160 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1F3FB ÷ 11A8 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0308 ÷ 11A8 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1F3FB ÷ AC00 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0308 ÷ AC00 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1F3FB ÷ AC01 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0308 ÷ AC01 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1F3FB ÷ 1F1E6 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1F3FB ÷ 261D ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0308 ÷ 261D ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 1F3FB ÷ 1F3FB ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 200D ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0308 × 200D ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 1F3FB ÷ 2640 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0308 ÷ 2640 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 1F3FB ÷ 1F466 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0308 ÷ 1F466 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 1F3FB ÷ 0378 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0308 ÷ 0378 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1F3FB ÷ D800 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 1F3FB × 0308 ÷ D800 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 0020 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 0020 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 000D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 000D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 000A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 000A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 0001 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 0001 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 200D × 0300 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 × 0300 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 0600 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 0600 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 200D × 0903 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 × 0903 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] COMBINING DIAERESIS (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 1100 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 1100 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 1160 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 1160 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 11A8 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 11A8 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ AC00 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ AC00 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ AC01 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ AC01 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 1F1E6 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 261D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 261D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 1F3FB ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 200D × 200D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 × 200D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 200D × 2640 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [11.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 2640 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 200D × 1F466 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [11.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 1F466 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 0378 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 0378 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ D800 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ D800 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 2640 ÷ 0020 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0308 ÷ 0020 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 2640 ÷ 000D ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0308 ÷ 000D ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 2640 ÷ 000A ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0308 ÷ 000A ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 2640 ÷ 0001 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0308 ÷ 0001 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0300 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0308 × 0300 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 2640 ÷ 0600 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0308 ÷ 0600 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0903 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0308 × 0903 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] COMBINING DIAERESIS (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 2640 ÷ 1100 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0308 ÷ 1100 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 2640 ÷ 1160 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0308 ÷ 1160 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 2640 ÷ 11A8 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 2640 ÷ AC00 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0308 ÷ AC00 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 2640 ÷ AC01 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0308 ÷ AC01 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 2640 ÷ 1F1E6 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 2640 ÷ 261D ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0308 ÷ 261D ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 2640 ÷ 1F3FB ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 2640 × 200D ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0308 × 200D ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 2640 ÷ 2640 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0308 ÷ 2640 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 2640 ÷ 1F466 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 2640 ÷ 0378 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0308 ÷ 0378 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 2640 ÷ D800 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 2640 × 0308 ÷ D800 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 1F466 ÷ 0020 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0308 ÷ 0020 ÷	#  ÷ [0.2] BOY (EBG) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1F466 ÷ 000D ÷	#  ÷ [0.2] BOY (EBG) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0308 ÷ 000D ÷	#  ÷ [0.2] BOY (EBG) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1F466 ÷ 000A ÷	#  ÷ [0.2] BOY (EBG) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0308 ÷ 000A ÷	#  ÷ [0.2] BOY (EBG) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1F466 ÷ 0001 ÷	#  ÷ [0.2] BOY (EBG) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0308 ÷ 0001 ÷	#  ÷ [0.2] BOY (EBG) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0300 ÷	#  ÷ [0.2] BOY (EBG) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0308 × 0300 ÷	#  ÷ [0.2] BOY (EBG) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 1F466 ÷ 0600 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0308 ÷ 0600 ÷	#  ÷ [0.2] BOY (EBG) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0903 ÷	#  ÷ [0.2] BOY (EBG) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0308 × 0903 ÷	#  ÷ [0.2] BOY (EBG) × [9.0] COMBINING DIAERESIS (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1F466 ÷ 1100 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0308 ÷ 1100 ÷	#  ÷ [0.2] BOY (EBG) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1F466 ÷ 1160 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0308 ÷ 1160 ÷	#  ÷ [0.2] BOY (EBG) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1F466 ÷ 11A8 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] BOY (EBG) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1F466 ÷ AC00 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0308 ÷ AC00 ÷	#  ÷ [0.2] BOY (EBG) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1F466 ÷ AC01 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0308 ÷ AC01 ÷	#  ÷ [0.2] BOY (EBG) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1F466 ÷ 1F1E6 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] BOY (EBG) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1F466 ÷ 261D ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0308 ÷ 261D ÷	#  ÷ [0.2] BOY (EBG) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 1F3FB ÷	#  ÷ [0.2] BOY (EBG) × [10.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0308 × 1F3FB ÷	#  ÷ [0.2] BOY (EBG) × [9.0] COMBINING DIAERESIS (Extend) × [10.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 200D ÷	#  ÷ [0.2] BOY (EBG) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0308 × 200D ÷	#  ÷ [0.2] BOY (EBG) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 1F466 ÷ 2640 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0308 ÷ 2640 ÷	#  ÷ [0.2] BOY (EBG) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 1F466 ÷ 1F466 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] BOY (EBG) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 1F466 ÷ 0378 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0308 ÷ 0378 ÷	#  ÷ [0.2] BOY (EBG) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1F466 ÷ D800 ÷	#  ÷ [0.2] BOY (EBG) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 0308 ÷ D800 ÷	#  ÷ [0.2] BOY (EBG) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 0020 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 0020 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 000D ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 000D ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 000A ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 000A ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 0001 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 0001 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0300 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 × 0300 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 0600 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 0600 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0903 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 × 0903 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 1100 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 1100 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 1160 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 1160 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 11A8 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ AC00 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ AC00 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ AC01 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ AC01 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 1F1E6 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 261D ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 261D ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 1F3FB ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 0378 × 200D ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 × 200D ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 2640 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 2640 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 1F466 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 0378 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 0378 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ D800 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ D800 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0020 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 000D ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 000A ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0001 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0300 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0308 × 0300 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0600 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0308 ÷ 0600 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0903 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0308 × 0903 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 1100 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0308 ÷ 1100 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 1160 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0308 ÷ 1160 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 11A8 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0308 ÷ 11A8 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ AC00 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0308 ÷ AC00 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ AC01 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0308 ÷ AC01 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 1F1E6 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 261D ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0308 ÷ 261D ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 1F3FB ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0308 ÷ 1F3FB ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 200D ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0308 × 200D ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 2640 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0308 ÷ 2640 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 1F466 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0308 ÷ 1F466 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0378 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0308 ÷ 0378 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ D800 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ D800 ÷ 0308 ÷ D800 ÷	#  ÷ [0.2] <surrogate-D800> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [5.0] <surrogate-D800> (Control) ÷ [0.3]');
    Test_GCB('÷ 000D × 000A ÷ 0061 ÷ 000A ÷ 0308 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [4.0] LATIN SMALL LETTER A (Other) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend) ÷ [0.3]');
    Test_GCB('÷ 0061 × 0308 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [0.3]');
    Test_GCB('÷ 0020 × 200D ÷ 0646 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [999.0] ARABIC LETTER NOON (Other) ÷ [0.3]');
    Test_GCB('÷ 0646 × 200D ÷ 0020 ÷	#  ÷ [0.2] ARABIC LETTER NOON (Other) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1100 × 1100 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [6.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC00 × 11A8 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [7.0] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC01 × 11A8 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [8.0] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 1F1E7 ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [12.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 ÷ 1F1E6 × 1F1E7 ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 ÷ 1F1E6 × 1F1E7 × 200D ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 ÷ 1F1E6 × 200D ÷ 1F1E7 × 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) × [13.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 ÷ 1F1E6 × 1F1E7 ÷ 1F1E8 × 1F1E9 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) × [13.0] REGIONAL INDICATOR SYMBOL LETTER D (RI) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] ZERO WIDTH JOINER (ZWJ) ÷ [0.3]');
    Test_GCB('÷ 0061 × 0308 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] COMBINING DIAERESIS (Extend) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 × 0903 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 ÷ 0600 × 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) × [9.2] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 261D × 1F3FB ÷ 261D ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [10.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_GCB('÷ 1F466 × 1F3FB ÷	#  ÷ [0.2] BOY (EBG) × [10.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 200D × 1F466 × 1F3FB ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [11.0] BOY (EBG) × [10.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_GCB('÷ 200D × 2640 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [11.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_GCB('÷ 200D × 1F466 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ) × [11.0] BOY (EBG) ÷ [0.3]');
    Test_GCB('÷ 1F466 ÷ 1F466 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_SB('÷ 0001 × 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0001 × 000D ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 000D ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0001 × 000A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 000A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0001 × 0085 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0085 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0001 × 0009 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0009 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0001 × 0061 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0061 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0001 × 0041 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0041 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0001 × 01BB ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 01BB ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0001 × 0030 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0030 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0001 × 002E ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 002E ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0001 × 0021 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0021 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0001 × 0022 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0022 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0001 × 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0001 × 00AD ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 00AD ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0001 × 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 000D × 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0085 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0085 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0009 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0009 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0061 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0061 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0041 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0041 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 01BB ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 01BB ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0030 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0030 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 002E ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 002E ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0021 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0021 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0022 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0022 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 00AD ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 00AD ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0085 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0085 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0009 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0009 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0061 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0061 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0041 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0041 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 01BB ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 01BB ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0030 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0030 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 002E ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 002E ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0021 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0021 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0022 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0022 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 00AD ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 00AD ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0001 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0001 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 000D ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 000D ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 000A ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 000A ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0085 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0085 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0009 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0009 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0061 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0061 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0041 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0041 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 01BB ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 01BB ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0030 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0030 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 002E ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 002E ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0021 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0021 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0022 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0022 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 002C ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 002C ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 00AD ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 00AD ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0300 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0300 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0009 × 0001 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0001 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0009 × 000D ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 000D ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0009 × 000A ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 000A ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0009 × 0085 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0085 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0009 × 0009 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0009 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0009 × 0061 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0061 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0009 × 0041 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0041 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0009 × 01BB ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 01BB ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0009 × 0030 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0030 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0009 × 002E ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 002E ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0009 × 0021 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0021 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0009 × 0022 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0022 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0009 × 002C ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 002C ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0009 × 00AD ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 00AD ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0009 × 0300 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0300 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0061 × 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0061 × 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0061 × 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0061 × 0085 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0085 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0061 × 0009 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0009 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0061 × 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0061 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0061 × 01BB ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 01BB ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0061 × 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0061 × 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0061 × 0021 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0021 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0061 × 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0061 × 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0061 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0061 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0041 × 0001 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0001 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0041 × 000D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 000D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0041 × 000A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 000A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0041 × 0085 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0085 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0041 × 0009 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0009 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0041 × 0061 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0061 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0041 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0041 × 01BB ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 01BB ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0041 × 0030 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0030 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0041 × 002E ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 002E ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0041 × 0021 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0021 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0041 × 0022 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0022 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0041 × 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0041 × 00AD ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0041 × 0300 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 01BB × 0001 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0001 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 01BB × 000D ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 000D ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 01BB × 000A ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 000A ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 01BB × 0085 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0085 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 01BB × 0009 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0009 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 01BB × 0061 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0061 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 01BB × 0041 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0041 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 01BB × 01BB ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 01BB ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 01BB × 0030 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0030 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 01BB × 002E ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 002E ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 01BB × 0021 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0021 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 01BB × 0022 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0022 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 01BB × 002C ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 002C ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 01BB × 00AD ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 00AD ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 01BB × 0300 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0300 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0030 × 0001 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0001 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0030 × 000D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 000D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0030 × 000A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 000A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0030 × 0085 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0085 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0030 × 0009 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0009 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0030 × 0061 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0061 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0030 × 0041 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0041 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0030 × 01BB ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 01BB ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0030 × 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0030 × 002E ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 002E ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0030 × 0021 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0021 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0030 × 0022 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0022 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0030 × 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0030 × 00AD ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0030 × 0300 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 002E ÷ 0001 ÷	#  ÷ [0.2] FULL STOP (ATerm) ÷ [11.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 ÷ 0001 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 002E × 000D ÷	#  ÷ [0.2] FULL STOP (ATerm) × [9.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 000D ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 002E × 000A ÷	#  ÷ [0.2] FULL STOP (ATerm) × [9.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 000A ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 002E × 0085 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [9.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0085 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 002E × 0009 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [9.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0009 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 002E × 0061 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [8.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0061 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 002E ÷ 0041 ÷	#  ÷ [0.2] FULL STOP (ATerm) ÷ [11.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 ÷ 0041 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 002E ÷ 01BB ÷	#  ÷ [0.2] FULL STOP (ATerm) ÷ [11.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 ÷ 01BB ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 002E × 0030 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [6.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0030 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [6.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 002E × 002E ÷	#  ÷ [0.2] FULL STOP (ATerm) × [8.1] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 002E ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 002E × 0021 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [8.1] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0021 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 002E × 0022 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [9.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0022 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 002E × 002C ÷	#  ÷ [0.2] FULL STOP (ATerm) × [8.1] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 002C ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 002E × 00AD ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 00AD ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 002E × 0300 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0300 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0021 ÷ 0001 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) ÷ [11.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 ÷ 0001 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0021 × 000D ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 000D ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0021 × 000A ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 000A ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0021 × 0085 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 0085 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0021 × 0009 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 0009 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0021 ÷ 0061 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) ÷ [11.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 ÷ 0061 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0021 ÷ 0041 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) ÷ [11.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 ÷ 0041 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0021 ÷ 01BB ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) ÷ [11.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 ÷ 01BB ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0021 ÷ 0030 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) ÷ [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 ÷ 0030 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0021 × 002E ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [8.1] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 002E ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0021 × 0021 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [8.1] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 0021 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0021 × 0022 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 0022 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0021 × 002C ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [8.1] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 002C ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0021 × 00AD ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 00AD ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0021 × 0300 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 0300 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0022 × 0001 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0001 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0022 × 000D ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 000D ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0022 × 000A ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 000A ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0022 × 0085 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0085 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0022 × 0009 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0009 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0022 × 0061 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0061 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0022 × 0041 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0041 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0022 × 01BB ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 01BB ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0022 × 0030 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0030 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0022 × 002E ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 002E ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0022 × 0021 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0021 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0022 × 0022 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0022 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0022 × 002C ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 002C ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0022 × 00AD ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 00AD ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0022 × 0300 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0300 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 002C × 0001 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0001 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 002C × 000D ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 000D ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 002C × 000A ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 000A ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 002C × 0085 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0085 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 002C × 0009 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0009 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 002C × 0061 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0061 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 002C × 0041 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0041 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 002C × 01BB ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 01BB ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 002C × 0030 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0030 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 002C × 002E ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 002E ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 002C × 0021 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0021 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 002C × 0022 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0022 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 002C × 002C ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 002C ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 002C × 00AD ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 00AD ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 002C × 0300 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0300 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 00AD × 0001 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0001 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 00AD × 000D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 000D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 00AD × 000A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 000A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 00AD × 0085 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0085 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 00AD × 0009 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0009 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 00AD × 0061 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0061 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 00AD × 0041 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0041 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 00AD × 01BB ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 01BB ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 00AD × 0030 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0030 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 00AD × 002E ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 002E ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 00AD × 0021 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0021 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 00AD × 0022 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0022 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 00AD × 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 00AD × 00AD ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 00AD ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 00AD × 0300 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0300 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0300 × 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0300 × 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0300 × 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0300 × 0085 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0085 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0300 × 0009 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0009 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0300 × 0061 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0061 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0300 × 0041 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0041 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0300 × 01BB ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 01BB ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0300 × 0030 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0030 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0300 × 002E ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 002E ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0300 × 0021 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0021 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0300 × 0022 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0022 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0300 × 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0300 × 00AD ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 00AD ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0300 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 000D × 000A ÷ 0061 × 000A ÷ 0308 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [4.0] LATIN SMALL LETTER A (Lower) × [998.0] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0020 × 200D × 0646 ÷	#  ÷ [0.2] SPACE (Sp) × [5.0] ZERO WIDTH JOINER (Extend_FE) × [998.0] ARABIC LETTER NOON (OLetter) ÷ [0.3]');
    Test_SB('÷ 0646 × 200D × 0020 ÷	#  ÷ [0.2] ARABIC LETTER NOON (OLetter) × [5.0] ZERO WIDTH JOINER (Extend_FE) × [998.0] SPACE (Sp) ÷ [0.3]');
    Test_SB('÷ 0028 × 0022 × 0047 × 006F × 002E × 0022 × 0029 × 0020 ÷ 0028 × 0048 × 0065 × 0020 × 0064 × 0069 × 0064 × 002E × 0029 ÷	#  ÷ [0.2] LEFT PARENTHESIS (Close) × [998.0] QUOTATION MARK (Close) × [998.0] LATIN CAPITAL LETTER G (Upper) × [998.0] LATIN SMALL LETTER O (Lower) × [998.0] FULL STOP (ATerm) × [9.0] QUOTATION MARK (Close) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] SPACE (Sp) ÷ [11.0] LEFT PARENTHESIS (Close) × [998.0] LATIN CAPITAL LETTER H (Upper) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] SPACE (Sp) × [998.0] LATIN SMALL LETTER D (Lower) × [998.0] LATIN SMALL LETTER I (Lower) × [998.0] LATIN SMALL LETTER D (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) ÷ [0.3]');
    Test_SB('÷ 0028 × 201C × 0047 × 006F × 003F × 201D × 0029 × 0020 ÷ 0028 × 0048 × 0065 × 0020 × 0064 × 0069 × 0064 × 002E × 0029 ÷	#  ÷ [0.2] LEFT PARENTHESIS (Close) × [998.0] LEFT DOUBLE QUOTATION MARK (Close) × [998.0] LATIN CAPITAL LETTER G (Upper) × [998.0] LATIN SMALL LETTER O (Lower) × [998.0] QUESTION MARK (STerm) × [9.0] RIGHT DOUBLE QUOTATION MARK (Close) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] SPACE (Sp) ÷ [11.0] LEFT PARENTHESIS (Close) × [998.0] LATIN CAPITAL LETTER H (Upper) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] SPACE (Sp) × [998.0] LATIN SMALL LETTER D (Lower) × [998.0] LATIN SMALL LETTER I (Lower) × [998.0] LATIN SMALL LETTER D (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) ÷ [0.3]');
    Test_SB('÷ 0055 × 002E × 0053 × 002E × 0041 × 0300 × 002E × 0020 × 0069 × 0073 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER U (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER S (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] FULL STOP (ATerm) × [8.0] SPACE (Sp) × [8.0] LATIN SMALL LETTER I (Lower) × [998.0] LATIN SMALL LETTER S (Lower) ÷ [0.3]');
    Test_SB('÷ 0055 × 002E × 0053 × 002E × 0041 × 0300 × 003F × 0020 ÷ 0048 × 0065 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER U (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER S (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] QUESTION MARK (STerm) × [9.0] SPACE (Sp) ÷ [11.0] LATIN CAPITAL LETTER H (Upper) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0055 × 002E × 0053 × 002E × 0041 × 0300 × 002E ÷	#  ÷ [0.2] LATIN CAPITAL LETTER U (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER S (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0033 × 002E × 0034 ÷	#  ÷ [0.2] DIGIT THREE (Numeric) × [998.0] FULL STOP (ATerm) × [6.0] DIGIT FOUR (Numeric) ÷ [0.3]');
    Test_SB('÷ 0063 × 002E × 0064 ÷	#  ÷ [0.2] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [8.0] LATIN SMALL LETTER D (Lower) ÷ [0.3]');
    Test_SB('÷ 0043 × 002E × 0064 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER C (Upper) × [998.0] FULL STOP (ATerm) × [8.0] LATIN SMALL LETTER D (Lower) ÷ [0.3]');
    Test_SB('÷ 0063 × 002E × 0044 ÷	#  ÷ [0.2] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER D (Upper) ÷ [0.3]');
    Test_SB('÷ 0043 × 002E × 0044 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER C (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER D (Upper) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 × 0074 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [8.0] RIGHT PARENTHESIS (Close) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [8.0] NO-BREAK SPACE (Sp) × [8.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 ÷ 0054 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [9.0] NO-BREAK SPACE (Sp) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 × 2018 × 0028 × 0074 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [8.0] RIGHT PARENTHESIS (Close) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [8.0] NO-BREAK SPACE (Sp) × [8.0] LEFT SINGLE QUOTATION MARK (Close) × [998.0] LEFT PARENTHESIS (Close) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 ÷ 2018 × 0028 × 0054 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [9.0] NO-BREAK SPACE (Sp) ÷ [11.0] LEFT SINGLE QUOTATION MARK (Close) × [998.0] LEFT PARENTHESIS (Close) × [998.0] LATIN CAPITAL LETTER T (Upper) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 × 0308 × 0074 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [8.0] RIGHT PARENTHESIS (Close) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [8.0] NO-BREAK SPACE (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 × 0308 ÷ 0054 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [9.0] NO-BREAK SPACE (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 0308 ÷ 0054 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 000A ÷ 0308 × 0054 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER T (Upper) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0074 × 0068 × 0065 × 0020 × 0072 × 0065 × 0073 × 0070 × 002E × 0020 × 006C × 0065 × 0061 × 0064 × 0065 × 0072 × 0073 × 0020 × 0061 × 0072 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] SPACE (Sp) × [998.0] LATIN SMALL LETTER R (Lower) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER S (Lower) × [998.0] LATIN SMALL LETTER P (Lower) × [998.0] FULL STOP (ATerm) × [8.0] SPACE (Sp) × [8.0] LATIN SMALL LETTER L (Lower) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER A (Lower) × [998.0] LATIN SMALL LETTER D (Lower) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER R (Lower) × [998.0] LATIN SMALL LETTER S (Lower) × [998.0] SPACE (Sp) × [998.0] LATIN SMALL LETTER A (Lower) × [998.0] LATIN SMALL LETTER R (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 5B57 × 002E ÷ 5B57 ÷	#  ÷ [0.2] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) × [998.0] FULL STOP (ATerm) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E ÷ 5B83 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B83 (OLetter) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 3002 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [8.1] IDEOGRAPHIC FULL STOP (STerm) ÷ [0.3]');
    Test_SB('÷ 5B57 × 3002 ÷ 5B83 ÷	#  ÷ [0.2] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) × [998.0] IDEOGRAPHIC FULL STOP (STerm) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B83 (OLetter) ÷ [0.3]');
    Test_SB('÷ 0021 × 0020 × 0020 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] SPACE (Sp) × [10.0] SPACE (Sp) ÷ [0.3]');
    Test_SB('÷ 2060 × 0028 × 2060 × 0022 × 2060 × 0047 × 2060 × 006F × 2060 × 002E × 2060 × 0022 × 2060 × 0029 × 2060 × 0020 × 2060 ÷ 0028 × 2060 × 0048 × 2060 × 0065 × 2060 × 0020 × 2060 × 0064 × 2060 × 0069 × 2060 × 0064 × 2060 × 002E × 2060 × 0029 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER G (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER O (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER H (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER I (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0028 × 2060 × 201C × 2060 × 0047 × 2060 × 006F × 2060 × 003F × 2060 × 201D × 2060 × 0029 × 2060 × 0020 × 2060 ÷ 0028 × 2060 × 0048 × 2060 × 0065 × 2060 × 0020 × 2060 × 0064 × 2060 × 0069 × 2060 × 0064 × 2060 × 002E × 2060 × 0029 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LEFT DOUBLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER G (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER O (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] QUESTION MARK (STerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT DOUBLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER H (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER I (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0055 × 2060 × 002E × 2060 × 0053 × 2060 × 002E × 2060 × 0041 × 2060 × 0300 × 002E × 2060 × 0020 × 2060 × 0069 × 2060 × 0073 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER U (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER S (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [8.0] LATIN SMALL LETTER I (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER S (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0055 × 2060 × 002E × 2060 × 0053 × 2060 × 002E × 2060 × 0041 × 2060 × 0300 × 003F × 2060 × 0020 × 2060 ÷ 0048 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER U (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER S (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] QUESTION MARK (STerm) × [5.0] WORD JOINER (Format_FE) × [9.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] LATIN CAPITAL LETTER H (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0055 × 2060 × 002E × 2060 × 0053 × 2060 × 002E × 2060 × 0041 × 2060 × 0300 × 002E × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER U (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER S (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0033 × 2060 × 002E × 2060 × 0034 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] DIGIT THREE (Numeric) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [6.0] DIGIT FOUR (Numeric) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0063 × 2060 × 002E × 2060 × 0064 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0043 × 2060 × 002E × 2060 × 0064 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER C (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0063 × 2060 × 002E × 2060 × 0044 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER D (Upper) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0043 × 2060 × 002E × 2060 × 0044 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER C (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER D (Upper) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 × 0074 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [8.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 ÷ 0054 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 × 2018 × 2060 × 0028 × 2060 × 0074 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [8.0] LEFT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 ÷ 2018 × 2060 × 0028 × 2060 × 0054 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] LEFT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER T (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 × 0308 × 0074 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 × 0308 ÷ 0054 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 0308 ÷ 0054 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 000A ÷ 2060 × 0308 × 2060 × 0054 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] <LINE FEED (LF)> (LF) ÷ [4.0] WORD JOINER (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER T (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0074 × 2060 × 0068 × 2060 × 0065 × 2060 × 0020 × 2060 × 0072 × 2060 × 0065 × 2060 × 0073 × 2060 × 0070 × 2060 × 002E × 2060 × 0020 × 2060 × 006C × 2060 × 0065 × 2060 × 0061 × 2060 × 0064 × 2060 × 0065 × 2060 × 0072 × 2060 × 0073 × 2060 × 0020 × 2060 × 0061 × 2060 × 0072 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER R (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER S (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER P (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [8.0] LATIN SMALL LETTER L (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER A (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER R (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER S (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER A (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER R (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 5B57 × 2060 × 002E × 2060 ÷ 5B57 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 ÷ 5B83 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B83 (OLetter) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 3002 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.1] IDEOGRAPHIC FULL STOP (STerm) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 5B57 × 2060 × 3002 × 2060 ÷ 5B83 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) × [5.0] WORD JOINER (Format_FE) × [998.0] IDEOGRAPHIC FULL STOP (STerm) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B83 (OLetter) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0021 × 2060 × 0020 × 2060 × 0020 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] EXCLAMATION MARK (STerm) × [5.0] WORD JOINER (Format_FE) × [9.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [10.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 6) {
    Test_LB('× 0023 × 0023 ÷	#  × [0.3] NUMBER SIGN (AL) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0023 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0023 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0023 ÷ 2014 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 2014 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 2014 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0023 × 0009 ÷	#  × [0.3] NUMBER SIGN (AL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0009 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0009 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0023 ÷ 00B4 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 00B4 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 00B4 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0023 × 000B ÷	#  × [0.3] NUMBER SIGN (AL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 000B ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 000B ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 000B ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0023 ÷ FFFC ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ FFFC ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ FFFC ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0023 × 007D ÷	#  × [0.3] NUMBER SIGN (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 007D ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 007D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 007D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0023 × 0029 ÷	#  × [0.3] NUMBER SIGN (AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 0029 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0029 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 0029 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0023 × 000D ÷	#  × [0.3] NUMBER SIGN (AL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 000D ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 000D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 000D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0023 × 0021 ÷	#  × [0.3] NUMBER SIGN (AL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 0021 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0021 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 0021 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0023 × 00A0 ÷	#  × [0.3] NUMBER SIGN (AL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 00A0 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 00A0 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0023 ÷ AC00 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ AC00 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ AC00 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0023 ÷ AC01 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ AC01 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ AC01 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0023 × 05D0 ÷	#  × [0.3] NUMBER SIGN (AL) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 05D0 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 05D0 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0023 × 002D ÷	#  × [0.3] NUMBER SIGN (AL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 002D ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 002D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0023 ÷ 231A ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 231A ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 231A ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0023 × 2024 ÷	#  × [0.3] NUMBER SIGN (AL) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 2024 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 2024 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0023 × 002C ÷	#  × [0.3] NUMBER SIGN (AL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 002C ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 002C ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 002C ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0023 ÷ 1100 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 1100 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 1100 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0023 ÷ 11A8 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 11A8 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 11A8 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0023 ÷ 1160 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 1160 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 1160 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0023 × 000A ÷	#  × [0.3] NUMBER SIGN (AL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 000A ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 000A ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 000A ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0023 × 0085 ÷	#  × [0.3] NUMBER SIGN (AL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 0085 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0085 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 0085 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0023 × 17D6 ÷	#  × [0.3] NUMBER SIGN (AL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 17D6 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 17D6 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0023 × 0030 ÷	#  × [0.3] NUMBER SIGN (AL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0030 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0030 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0023 × 0028 ÷	#  × [0.3] NUMBER SIGN (AL) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0028 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0028 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0023 × 0025 ÷	#  × [0.3] NUMBER SIGN (AL) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0025 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0025 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0023 × 0024 ÷	#  × [0.3] NUMBER SIGN (AL) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0024 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0024 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0023 × 0022 ÷	#  × [0.3] NUMBER SIGN (AL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0022 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0022 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 0020 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 0020 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0023 × 002F ÷	#  × [0.3] NUMBER SIGN (AL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 002F ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 002F ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 002F ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0023 × 2060 ÷	#  × [0.3] NUMBER SIGN (AL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 2060 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 2060 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 2060 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0023 × 200B ÷	#  × [0.3] NUMBER SIGN (AL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 200B ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 200B ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 200B ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0023 ÷ 1F1E6 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 1F1E6 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 1F1E6 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0023 ÷ 261D ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 261D ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 261D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0023 ÷ 1F3FB ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 1F3FB ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 1F3FB ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0023 × 0001 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0001 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0001 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0023 × 200D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 200D ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 200D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0023 × 00A7 ÷	#  × [0.3] NUMBER SIGN (AL) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 00A7 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 00A7 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0023 × 50005 ÷	#  × [0.3] NUMBER SIGN (AL) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 50005 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 50005 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0E01 ÷	#  × [0.3] NUMBER SIGN (AL) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0E01 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0E01 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0023 × 3041 ÷	#  × [0.3] NUMBER SIGN (AL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 3041 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 3041 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0023 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0023 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0023 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2014 × 2014 ÷	#  × [0.3] EM DASH (B2) × [17.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 2014 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [17.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 2014 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [17.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 2014 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [17.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2014 × 0009 ÷	#  × [0.3] EM DASH (B2) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0009 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0009 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2014 ÷ 00B4 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 00B4 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 00B4 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2014 × 000B ÷	#  × [0.3] EM DASH (B2) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 000B ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 000B ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 000B ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2014 ÷ FFFC ÷	#  × [0.3] EM DASH (B2) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ FFFC ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ FFFC ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2014 × 007D ÷	#  × [0.3] EM DASH (B2) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 007D ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 007D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 007D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2014 × 0029 ÷	#  × [0.3] EM DASH (B2) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 0029 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0029 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 0029 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2014 × 000D ÷	#  × [0.3] EM DASH (B2) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 000D ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 000D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 000D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2014 × 0021 ÷	#  × [0.3] EM DASH (B2) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 0021 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0021 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 0021 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2014 × 00A0 ÷	#  × [0.3] EM DASH (B2) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 00A0 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 00A0 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2014 ÷ AC00 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ AC00 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ AC00 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2014 ÷ AC01 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ AC01 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ AC01 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2014 ÷ 05D0 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 05D0 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 05D0 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2014 × 002D ÷	#  × [0.3] EM DASH (B2) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 002D ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 002D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2014 ÷ 231A ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 231A ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 231A ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2014 ÷ 2024 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 2024 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 2024 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2014 × 002C ÷	#  × [0.3] EM DASH (B2) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 002C ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 002C ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 002C ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2014 ÷ 1100 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 1100 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 1100 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2014 ÷ 11A8 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 11A8 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 11A8 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2014 ÷ 1160 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 1160 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 1160 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2014 × 000A ÷	#  × [0.3] EM DASH (B2) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 000A ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 000A ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 000A ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2014 × 0085 ÷	#  × [0.3] EM DASH (B2) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 0085 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0085 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 0085 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2014 × 17D6 ÷	#  × [0.3] EM DASH (B2) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 17D6 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 17D6 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0030 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0030 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0030 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0028 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0028 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0028 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0025 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0025 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0025 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0024 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0024 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0024 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2014 × 0022 ÷	#  × [0.3] EM DASH (B2) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0022 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0022 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 0020 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 0020 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2014 × 002F ÷	#  × [0.3] EM DASH (B2) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 002F ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 002F ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 002F ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2014 × 2060 ÷	#  × [0.3] EM DASH (B2) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 2060 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 2060 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 2060 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2014 × 200B ÷	#  × [0.3] EM DASH (B2) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 200B ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 200B ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 200B ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2014 ÷ 1F1E6 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 1F1E6 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 1F1E6 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2014 ÷ 261D ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 261D ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 261D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2014 ÷ 1F3FB ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 1F3FB ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 1F3FB ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2014 × 0001 ÷	#  × [0.3] EM DASH (B2) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0001 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0001 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2014 × 200D ÷	#  × [0.3] EM DASH (B2) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 200D ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 200D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2014 ÷ 00A7 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 00A7 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 00A7 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2014 ÷ 50005 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 50005 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 50005 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0E01 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0E01 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0E01 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2014 × 3041 ÷	#  × [0.3] EM DASH (B2) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 3041 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 3041 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0023 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0023 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0023 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0009 ÷ 2014 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 2014 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 2014 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0009 × 0009 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0009 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0009 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0009 ÷ 00B4 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 00B4 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 00B4 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0009 × 000B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 000B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 000B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 000B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0009 ÷ FFFC ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ FFFC ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ FFFC ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0009 × 007D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 007D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 007D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 007D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0009 × 0029 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 0029 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0029 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 0029 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0009 × 000D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 000D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 000D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 000D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0009 × 0021 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 0021 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0021 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 0021 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0009 ÷ 00A0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 00A0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 00A0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0009 ÷ AC00 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ AC00 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ AC00 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0009 ÷ AC01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ AC01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ AC01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0009 ÷ 05D0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 05D0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 05D0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0009 × 002D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 002D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 002D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0009 ÷ 231A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 231A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 231A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0009 ÷ 2024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 2024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 2024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0009 × 002C ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 002C ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 002C ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 002C ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0009 ÷ 1100 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 1100 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 1100 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0009 ÷ 11A8 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 11A8 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 11A8 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0009 ÷ 1160 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 1160 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 1160 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0009 × 000A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 000A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 000A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 000A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0009 × 0085 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 0085 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0085 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 0085 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0009 × 17D6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 17D6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 17D6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0030 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0030 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0030 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0028 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0028 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0028 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0025 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0025 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0025 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0009 × 0022 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0022 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0022 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 0020 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 0020 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0009 × 002F ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 002F ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 002F ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 002F ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0009 × 2060 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 2060 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 2060 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 2060 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0009 × 200B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 200B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 200B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 200B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0009 ÷ 1F1E6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 1F1E6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0009 ÷ 261D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 261D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 261D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0009 ÷ 1F3FB ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 1F3FB ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 1F3FB ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0009 × 0001 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0001 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0001 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0009 × 200D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 200D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 200D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0009 ÷ 00A7 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 00A7 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 00A7 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0009 ÷ 50005 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 50005 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 50005 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0E01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0E01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0E01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0009 × 3041 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 3041 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 3041 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0023 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0023 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0023 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00B4 × 2014 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 2014 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 2014 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00B4 × 0009 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0009 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0009 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00B4 × 00B4 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 00B4 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 00B4 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00B4 × 000B ÷	#  × [0.3] ACUTE ACCENT (BB) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 000B ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 000B ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 000B ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00B4 ÷ FFFC ÷	#  × [0.3] ACUTE ACCENT (BB) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ FFFC ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 ÷ FFFC ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00B4 × 007D ÷	#  × [0.3] ACUTE ACCENT (BB) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 007D ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 007D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 007D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00B4 × 0029 ÷	#  × [0.3] ACUTE ACCENT (BB) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 0029 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0029 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 0029 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00B4 × 000D ÷	#  × [0.3] ACUTE ACCENT (BB) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 000D ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 000D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 000D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00B4 × 0021 ÷	#  × [0.3] ACUTE ACCENT (BB) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 0021 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0021 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 0021 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00B4 × 00A0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 00A0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 00A0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00B4 × AC00 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ AC00 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × AC00 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00B4 × AC01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ AC01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × AC01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00B4 × 05D0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 05D0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 05D0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00B4 × 002D ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 002D ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 002D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00B4 × 231A ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 231A ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 231A ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00B4 × 2024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 2024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 2024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00B4 × 002C ÷	#  × [0.3] ACUTE ACCENT (BB) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 002C ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 002C ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 002C ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00B4 × 1100 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 1100 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 1100 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00B4 × 11A8 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 11A8 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 11A8 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00B4 × 1160 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 1160 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 1160 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00B4 × 000A ÷	#  × [0.3] ACUTE ACCENT (BB) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 000A ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 000A ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 000A ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00B4 × 0085 ÷	#  × [0.3] ACUTE ACCENT (BB) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 0085 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0085 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 0085 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00B4 × 17D6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 17D6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 17D6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0030 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0030 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0030 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00B4 × 0028 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0028 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0028 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00B4 × 0025 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0025 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0025 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00B4 × 0024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00B4 × 0022 ÷	#  × [0.3] ACUTE ACCENT (BB) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0022 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0022 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 0020 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 0020 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00B4 × 002F ÷	#  × [0.3] ACUTE ACCENT (BB) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 002F ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 002F ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 002F ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00B4 × 2060 ÷	#  × [0.3] ACUTE ACCENT (BB) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 2060 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 2060 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 2060 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00B4 × 200B ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 200B ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 200B ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 200B ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00B4 × 1F1E6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 1F1E6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00B4 × 261D ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 261D ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 261D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00B4 × 1F3FB ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 1F3FB ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 1F3FB ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00B4 × 0001 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0001 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0001 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 200D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 200D ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 200D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 00A7 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 00A7 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 00A7 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 50005 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 50005 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 50005 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0E01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0E01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0E01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 3041 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 3041 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 3041 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0023 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0023 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0023 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 2014 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 2014 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 2014 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0009 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0009 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0009 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000B ÷ 00B4 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 00B4 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 00B4 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000B ÷ 000B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 000B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 000B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 000B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000B ÷ FFFC ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ FFFC ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ FFFC ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000B ÷ 007D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 007D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 007D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 007D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0029 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 0029 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0029 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000B ÷ 000D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 000D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 000D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 000D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0021 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 0021 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0021 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000B ÷ 00A0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 00A0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 00A0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000B ÷ AC00 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ AC00 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ AC00 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000B ÷ AC01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ AC01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ AC01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000B ÷ 05D0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 05D0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 05D0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000B ÷ 002D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 002D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 002D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000B ÷ 231A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 231A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 231A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000B ÷ 2024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 2024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 2024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000B ÷ 002C ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 002C ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 002C ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 002C ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000B ÷ 1100 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 1100 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 1100 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000B ÷ 11A8 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 11A8 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 11A8 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000B ÷ 1160 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 1160 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 1160 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000B ÷ 000A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 000A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 000A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 000A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000B ÷ 0085 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 0085 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0085 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000B ÷ 17D6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 17D6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 17D6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0030 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0030 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0030 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0028 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0028 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0028 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0025 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0025 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0025 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000B ÷ 0024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0022 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0022 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0022 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 0020 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000B ÷ 002F ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 002F ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 002F ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 002F ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000B ÷ 2060 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 2060 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 2060 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000B ÷ 200B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 200B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 200B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 200B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000B ÷ 1F1E6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 1F1E6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000B ÷ 261D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 261D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 261D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000B ÷ 1F3FB ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 1F3FB ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0001 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0001 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0001 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 200D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 200D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 200D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 00A7 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 00A7 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 00A7 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 50005 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 50005 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 50005 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0E01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0E01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0E01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 3041 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 3041 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 3041 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0023 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0023 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0023 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 2014 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 2014 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 2014 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0009 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0009 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0009 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× FFFC ÷ 00B4 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 00B4 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 00B4 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× FFFC × 000B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 000B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 000B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 000B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× FFFC ÷ FFFC ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ FFFC ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ FFFC ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× FFFC × 007D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 007D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 007D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 007D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× FFFC × 0029 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 0029 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0029 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 0029 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× FFFC × 000D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 000D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 000D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 000D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× FFFC × 0021 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 0021 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0021 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 0021 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× FFFC × 00A0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 00A0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 00A0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× FFFC ÷ AC00 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ AC00 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ AC00 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× FFFC ÷ AC01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ AC01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ AC01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× FFFC ÷ 05D0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 05D0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 05D0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 002D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 002D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 002D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 002D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× FFFC ÷ 231A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 231A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 231A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 231A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× FFFC ÷ 2024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 2024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 2024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× FFFC × 002C ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 002C ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 002C ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 002C ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× FFFC ÷ 1100 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 1100 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 1100 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 11A8 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 11A8 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 11A8 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× FFFC ÷ 1160 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 1160 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 1160 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× FFFC × 000A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 000A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 000A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 000A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× FFFC × 0085 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 0085 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0085 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 0085 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 17D6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 17D6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 17D6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0030 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0030 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0030 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0028 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0028 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0028 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0025 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0025 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0025 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× FFFC × 0022 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0022 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0022 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 0020 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 0020 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× FFFC × 002F ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 002F ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 002F ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 002F ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× FFFC × 2060 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 2060 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 2060 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 2060 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× FFFC × 200B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 200B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 200B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 200B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× FFFC ÷ 1F1E6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 1F1E6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 1F1E6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× FFFC ÷ 261D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 261D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 261D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 261D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× FFFC ÷ 1F3FB ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 1F3FB ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 1F3FB ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× FFFC × 0001 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0001 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0001 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× FFFC × 200D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 200D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 200D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 200D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× FFFC ÷ 00A7 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 00A7 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 00A7 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 50005 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 50005 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 50005 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0E01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0E01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0E01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 3041 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 3041 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 3041 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 007D ÷ 0023 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0023 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0023 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 007D ÷ 2014 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 2014 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 2014 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 007D × 0009 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0009 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0009 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 007D ÷ 00B4 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 00B4 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 00B4 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 007D × 000B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 000B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 000B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 000B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 007D ÷ FFFC ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ FFFC ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ FFFC ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 007D × 007D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 007D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 007D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 007D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 007D × 0029 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 0029 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0029 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 0029 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 007D × 000D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 000D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 000D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 000D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 007D × 0021 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 0021 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0021 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 0021 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 007D × 00A0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 00A0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 00A0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 007D ÷ AC00 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ AC00 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ AC00 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 007D ÷ AC01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ AC01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ AC01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 007D ÷ 05D0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 05D0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 05D0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 007D × 002D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 002D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 002D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 002D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 007D ÷ 231A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 231A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 231A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 231A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 007D ÷ 2024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 2024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 2024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 007D × 002C ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 002C ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 002C ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 002C ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 007D ÷ 1100 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 1100 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 1100 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 007D ÷ 11A8 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 11A8 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 11A8 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 007D ÷ 1160 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 1160 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 1160 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 007D × 000A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 000A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 000A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 000A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 007D × 0085 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 0085 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0085 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 0085 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 007D × 17D6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 17D6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 17D6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 17D6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 007D ÷ 0030 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0030 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0030 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 007D ÷ 0028 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0028 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0028 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 007D ÷ 0025 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0025 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0025 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 007D ÷ 0024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 007D × 0022 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0022 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0022 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 0020 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 0020 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 007D × 002F ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 002F ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 002F ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 002F ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 007D × 2060 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 2060 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 2060 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 2060 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 007D × 200B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 200B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 200B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 200B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 007D ÷ 1F1E6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 1F1E6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 1F1E6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 007D ÷ 261D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 261D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 261D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 261D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 007D ÷ 1F3FB ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 1F3FB ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 1F3FB ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 007D × 0001 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0001 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0001 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 007D × 200D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 200D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 200D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 200D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 007D ÷ 00A7 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 00A7 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 00A7 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 007D ÷ 50005 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 50005 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 50005 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 007D ÷ 0E01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0E01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0E01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 007D × 3041 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 3041 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 3041 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 3041 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0029 × 0023 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [30.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0023 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0023 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0029 ÷ 2014 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 2014 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 2014 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0029 × 0009 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0009 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0009 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0029 ÷ 00B4 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 00B4 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 00B4 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0029 × 000B ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 000B ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 000B ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 000B ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0029 ÷ FFFC ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ FFFC ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ FFFC ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0029 × 007D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 007D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 007D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 007D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0029 × 0029 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 0029 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0029 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 0029 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0029 × 000D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 000D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 000D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 000D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0029 × 0021 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 0021 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0021 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 0021 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0029 × 00A0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 00A0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 00A0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0029 ÷ AC00 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ AC00 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ AC00 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0029 ÷ AC01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ AC01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ AC01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0029 × 05D0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [30.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 05D0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 05D0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0029 × 002D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 002D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 002D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0029 ÷ 231A ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 231A ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 231A ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0029 ÷ 2024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 2024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 2024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0029 × 002C ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 002C ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 002C ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 002C ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0029 ÷ 1100 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 1100 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 1100 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0029 ÷ 11A8 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 11A8 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 11A8 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0029 ÷ 1160 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 1160 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 1160 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0029 × 000A ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 000A ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 000A ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 000A ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0029 × 0085 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 0085 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0085 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 0085 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0029 × 17D6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 17D6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 17D6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 17D6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0029 × 0030 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [30.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0030 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0030 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0029 ÷ 0028 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0028 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 0028 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0029 ÷ 0025 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0025 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 0025 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0029 ÷ 0024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 0024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0029 × 0022 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0022 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0022 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 0020 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 0020 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0029 × 002F ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 002F ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 002F ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 002F ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0029 × 2060 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 2060 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 2060 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 2060 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0029 × 200B ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 200B ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 200B ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 200B ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0029 ÷ 1F1E6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 1F1E6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 1F1E6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0029 ÷ 261D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 261D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 261D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0029 ÷ 1F3FB ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 1F3FB ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 1F3FB ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0029 × 0001 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0001 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0001 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0029 × 200D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 200D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 200D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0029 × 00A7 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [30.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 00A7 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 00A7 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0029 × 50005 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [30.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 50005 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 50005 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0E01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [30.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0E01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0E01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0029 × 3041 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 3041 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 3041 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 3041 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0023 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0023 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0023 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 2014 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 2014 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 2014 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0009 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0009 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0009 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000D ÷ 00B4 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 00B4 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 00B4 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000D ÷ 000B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 000B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 000B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 000B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000D ÷ FFFC ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ FFFC ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ FFFC ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000D ÷ 007D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 007D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 007D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 007D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0029 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 0029 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0029 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000D ÷ 000D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 000D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 000D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 000D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0021 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 0021 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0021 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000D ÷ 00A0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 00A0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 00A0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000D ÷ AC00 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ AC00 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ AC00 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000D ÷ AC01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ AC01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ AC01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000D ÷ 05D0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 05D0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 05D0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000D ÷ 002D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 002D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 002D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000D ÷ 231A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 231A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 231A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000D ÷ 2024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 2024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 2024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000D ÷ 002C ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 002C ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 002C ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 002C ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000D ÷ 1100 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 1100 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 1100 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000D ÷ 11A8 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 11A8 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 11A8 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000D ÷ 1160 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 1160 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 1160 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000D × 000A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) × [5.01] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 000A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 000A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 000A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000D ÷ 0085 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 0085 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0085 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000D ÷ 17D6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 17D6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 17D6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0030 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0030 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0030 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0028 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0028 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0028 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0025 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0025 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0025 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000D ÷ 0024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0022 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0022 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0022 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 0020 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000D ÷ 002F ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 002F ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 002F ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 002F ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000D ÷ 2060 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 2060 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 2060 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000D ÷ 200B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 200B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 200B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 200B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000D ÷ 1F1E6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 1F1E6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000D ÷ 261D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 261D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 261D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000D ÷ 1F3FB ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 1F3FB ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0001 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0001 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0001 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 200D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 200D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 200D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 00A7 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 00A7 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 00A7 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 50005 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 50005 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 50005 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0E01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0E01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0E01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 3041 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 3041 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 3041 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0023 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0023 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0023 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0021 ÷ 2014 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 2014 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 2014 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0021 × 0009 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0009 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0009 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0021 ÷ 00B4 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 00B4 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 00B4 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0021 × 000B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 000B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 000B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 000B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0021 ÷ FFFC ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ FFFC ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ FFFC ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0021 × 007D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 007D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 007D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 007D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0021 × 0029 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 0029 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0029 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 0029 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0021 × 000D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 000D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 000D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 000D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0021 × 0021 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 0021 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0021 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 0021 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0021 × 00A0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 00A0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 00A0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0021 ÷ AC00 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ AC00 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ AC00 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0021 ÷ AC01 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ AC01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ AC01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0021 ÷ 05D0 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 05D0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 05D0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0021 × 002D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 002D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 002D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0021 ÷ 231A ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 231A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 231A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0021 × 2024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [22.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 2024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 2024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0021 × 002C ÷	#  × [0.3] EXCLAMATION MARK (EX) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 002C ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 002C ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 002C ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0021 ÷ 1100 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 1100 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 1100 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0021 ÷ 11A8 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 11A8 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 11A8 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0021 ÷ 1160 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 1160 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 1160 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0021 × 000A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 000A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 000A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 000A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0021 × 0085 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 0085 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0085 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 0085 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0021 × 17D6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 17D6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 17D6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0030 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0030 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0030 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0028 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0028 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0028 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0025 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0025 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0025 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0024 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0021 × 0022 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0022 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0022 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 0020 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 0020 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0021 × 002F ÷	#  × [0.3] EXCLAMATION MARK (EX) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 002F ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 002F ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 002F ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0021 × 2060 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 2060 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 2060 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 2060 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0021 × 200B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 200B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 200B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 200B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0021 ÷ 1F1E6 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 1F1E6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 1F1E6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0021 ÷ 261D ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 261D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 261D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0021 ÷ 1F3FB ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 1F3FB ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 1F3FB ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0021 × 0001 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0001 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0001 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0021 × 200D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 200D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 200D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0021 ÷ 00A7 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 00A7 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 00A7 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0021 ÷ 50005 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 50005 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 50005 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0E01 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0E01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0E01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0021 × 3041 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 3041 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 3041 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0023 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0023 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0023 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A0 × 2014 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 2014 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 2014 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A0 × 0009 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0009 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0009 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A0 × 00B4 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 00B4 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 00B4 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A0 × 000B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 000B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 000B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 000B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A0 × FFFC ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ FFFC ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × FFFC ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A0 × 007D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 007D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 007D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 007D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A0 × 0029 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 0029 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0029 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 0029 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00A0 × 000D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 000D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 000D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 000D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A0 × 0021 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 0021 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0021 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 0021 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A0 × 00A0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 00A0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 00A0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A0 × AC00 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ AC00 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × AC00 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A0 × AC01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ AC01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × AC01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A0 × 05D0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 05D0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 05D0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A0 × 002D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 002D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 002D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A0 × 231A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 231A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 231A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A0 × 2024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 2024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 2024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A0 × 002C ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 002C ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 002C ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 002C ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A0 × 1100 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 1100 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 1100 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A0 × 11A8 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 11A8 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 11A8 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A0 × 1160 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 1160 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 1160 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A0 × 000A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 000A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 000A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 000A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A0 × 0085 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 0085 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0085 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 0085 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A0 × 17D6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 17D6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 17D6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0030 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0030 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0030 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A0 × 0028 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0028 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0028 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00A0 × 0025 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0025 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0025 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A0 × 0024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A0 × 0022 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0022 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0022 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 0020 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 0020 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A0 × 002F ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 002F ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 002F ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 002F ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A0 × 2060 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 2060 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 2060 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 2060 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A0 × 200B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 200B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 200B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 200B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A0 × 1F1E6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 1F1E6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 1F1E6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A0 × 261D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 261D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 261D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A0 × 1F3FB ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 1F3FB ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 1F3FB ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A0 × 0001 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0001 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0001 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 200D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 7) {
    Test_LB('× 00A0 × 0020 ÷ 200D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 200D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 00A7 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 00A7 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 00A7 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 50005 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 50005 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 50005 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0E01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0E01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0E01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 3041 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 3041 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 3041 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC00 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC00 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC00 × 0009 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0009 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC00 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC00 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC00 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC00 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC00 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× AC00 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC00 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC00 × 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC00 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC00 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC00 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC00 × 002D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 002D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC00 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC00 × 2024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 2024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC00 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC00 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC00 × 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [26.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC00 × 1160 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [26.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 1160 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC00 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC00 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC00 × 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC00 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC00 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× AC00 × 0025 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0025 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC00 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC00 × 0022 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0022 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC00 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC00 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC00 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC00 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC00 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC00 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC00 × 0001 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0001 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC00 × 200D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 200D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC00 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC00 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC00 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC00 × 3041 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 3041 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC01 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC01 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC01 × 0009 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0009 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC01 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC01 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC01 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC01 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC01 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× AC01 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC01 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC01 × 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC01 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC01 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC01 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC01 × 002D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 002D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC01 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC01 × 2024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 2024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC01 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC01 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC01 × 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [26.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC01 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC01 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC01 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC01 × 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC01 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC01 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× AC01 × 0025 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0025 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC01 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC01 × 0022 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0022 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC01 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC01 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC01 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC01 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC01 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC01 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC01 × 0001 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0001 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC01 × 200D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 200D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC01 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC01 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC01 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC01 × 3041 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 3041 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0023 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0023 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0023 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 2014 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 2014 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 2014 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 05D0 × 0009 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0009 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0009 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 00B4 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 00B4 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 00B4 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 05D0 × 000B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 000B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 000B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 000B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 05D0 ÷ FFFC ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ FFFC ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ FFFC ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 05D0 × 007D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 007D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 007D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 007D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 05D0 × 0029 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 0029 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0029 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 0029 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 05D0 × 000D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 000D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 000D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 000D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 05D0 × 0021 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 0021 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0021 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 0021 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 05D0 × 00A0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 00A0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 00A0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 05D0 ÷ AC00 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ AC00 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ AC00 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 05D0 ÷ AC01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ AC01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ AC01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 05D0 × 05D0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 05D0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 05D0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 05D0 × 002D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 002D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 002D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 231A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 231A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 231A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 05D0 × 2024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 2024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 2024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 05D0 × 002C ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 002C ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 002C ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 002C ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 1100 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 1100 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 1100 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 11A8 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 11A8 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 11A8 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 1160 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 1160 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 1160 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 05D0 × 000A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 000A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 000A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 000A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 05D0 × 0085 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 0085 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0085 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 0085 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 05D0 × 17D6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 17D6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 17D6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0030 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0030 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0030 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 05D0 × 0028 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0028 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0028 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 05D0 × 0025 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0025 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0025 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 05D0 × 0024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 05D0 × 0022 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0022 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0022 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 0020 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 0020 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 05D0 × 002F ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 002F ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 002F ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 002F ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 05D0 × 2060 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 2060 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 2060 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 2060 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 05D0 × 200B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 200B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 200B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 200B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 1F1E6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 261D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 261D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 261D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 1F3FB ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 1F3FB ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 1F3FB ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 05D0 × 0001 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0001 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0001 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 200D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 200D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 200D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 00A7 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 00A7 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 00A7 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 50005 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 50005 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 50005 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0E01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0E01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0E01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 3041 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 3041 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 3041 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002D ÷ 0023 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0023 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 0023 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002D ÷ 2014 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 2014 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 2014 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002D × 0009 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0009 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0009 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002D ÷ 00B4 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 00B4 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 00B4 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002D × 000B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 000B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 000B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 000B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002D ÷ FFFC ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ FFFC ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ FFFC ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002D × 007D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 007D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 007D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 007D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002D × 0029 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 0029 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0029 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 0029 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002D × 000D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 000D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 000D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 000D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002D × 0021 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 0021 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0021 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 0021 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002D ÷ 00A0 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 00A0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 00A0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002D ÷ AC00 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ AC00 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ AC00 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002D ÷ AC01 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ AC01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ AC01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002D ÷ 05D0 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 05D0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 05D0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002D × 002D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 002D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 002D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002D ÷ 231A ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 231A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 231A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002D ÷ 2024 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 2024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 2024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002D × 002C ÷	#  × [0.3] HYPHEN-MINUS (HY) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 002C ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 002C ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 002C ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002D ÷ 1100 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 1100 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 1100 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002D ÷ 11A8 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 11A8 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 11A8 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002D ÷ 1160 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 1160 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 1160 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002D × 000A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 000A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 000A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 000A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002D × 0085 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 0085 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0085 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 0085 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002D × 17D6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 17D6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 17D6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002D × 0030 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [25.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0030 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0030 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002D ÷ 0028 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0028 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 0028 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002D ÷ 0025 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0025 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 0025 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002D ÷ 0024 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 0024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002D × 0022 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0022 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0022 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 0020 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 0020 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002D × 002F ÷	#  × [0.3] HYPHEN-MINUS (HY) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 002F ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 002F ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 002F ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002D × 2060 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 2060 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 2060 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 2060 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002D × 200B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 200B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 200B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 200B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002D ÷ 1F1E6 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 1F1E6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 1F1E6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002D ÷ 261D ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 261D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 261D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002D ÷ 1F3FB ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 1F3FB ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 1F3FB ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002D × 0001 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0001 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0001 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002D × 200D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 200D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 200D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002D ÷ 00A7 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 00A7 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 00A7 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002D ÷ 50005 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 50005 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 50005 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002D ÷ 0E01 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0E01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 0E01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002D × 3041 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 3041 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 3041 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 231A ÷ 0023 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0023 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 0023 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 231A ÷ 2014 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 2014 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 2014 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 231A × 0009 ÷	#  × [0.3] WATCH (ID) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0009 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0009 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 231A ÷ 00B4 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 00B4 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 00B4 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 231A × 000B ÷	#  × [0.3] WATCH (ID) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 000B ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 000B ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 000B ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 231A ÷ FFFC ÷	#  × [0.3] WATCH (ID) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ FFFC ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ FFFC ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 231A × 007D ÷	#  × [0.3] WATCH (ID) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 007D ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 007D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 007D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 231A × 0029 ÷	#  × [0.3] WATCH (ID) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 0029 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0029 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 0029 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 231A × 000D ÷	#  × [0.3] WATCH (ID) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 000D ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 000D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 000D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 231A × 0021 ÷	#  × [0.3] WATCH (ID) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 0021 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0021 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 0021 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 231A × 00A0 ÷	#  × [0.3] WATCH (ID) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 00A0 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 00A0 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 231A ÷ AC00 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ AC00 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ AC00 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 231A ÷ AC01 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ AC01 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ AC01 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 231A ÷ 05D0 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 05D0 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 05D0 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 231A × 002D ÷	#  × [0.3] WATCH (ID) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 002D ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 002D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 002D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 231A ÷ 231A ÷	#  × [0.3] WATCH (ID) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 231A ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 231A ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 231A ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 231A × 2024 ÷	#  × [0.3] WATCH (ID) × [22.03] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 2024 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 2024 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.03] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 231A × 002C ÷	#  × [0.3] WATCH (ID) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 002C ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 002C ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 002C ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 231A ÷ 1100 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 1100 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 1100 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 231A ÷ 11A8 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 11A8 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 11A8 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 231A ÷ 1160 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 1160 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 1160 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 231A × 000A ÷	#  × [0.3] WATCH (ID) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 000A ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 000A ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 000A ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 231A × 0085 ÷	#  × [0.3] WATCH (ID) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 0085 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0085 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 0085 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 231A × 17D6 ÷	#  × [0.3] WATCH (ID) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 17D6 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 17D6 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 231A ÷ 0030 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0030 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 0030 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 231A ÷ 0028 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0028 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 0028 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 231A × 0025 ÷	#  × [0.3] WATCH (ID) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0025 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0025 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 231A ÷ 0024 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0024 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 0024 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 231A × 0022 ÷	#  × [0.3] WATCH (ID) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0022 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0022 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 0020 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 0020 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 231A × 002F ÷	#  × [0.3] WATCH (ID) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 002F ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 002F ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 002F ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 231A × 2060 ÷	#  × [0.3] WATCH (ID) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 2060 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 2060 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 2060 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 231A × 200B ÷	#  × [0.3] WATCH (ID) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 200B ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 200B ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 200B ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 231A ÷ 1F1E6 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 1F1E6 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 1F1E6 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 231A ÷ 261D ÷	#  × [0.3] WATCH (ID) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 261D ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 261D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 261D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 231A ÷ 1F3FB ÷	#  × [0.3] WATCH (ID) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 1F3FB ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 1F3FB ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 231A × 0001 ÷	#  × [0.3] WATCH (ID) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0001 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0001 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 231A × 200D ÷	#  × [0.3] WATCH (ID) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 200D ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 200D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 200D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 231A ÷ 00A7 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 00A7 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 00A7 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 231A ÷ 50005 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 50005 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 50005 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 231A ÷ 0E01 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0E01 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 0E01 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 231A × 3041 ÷	#  × [0.3] WATCH (ID) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 3041 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 3041 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0023 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0023 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0023 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2024 ÷ 2014 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 2014 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 2014 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2024 × 0009 ÷	#  × [0.3] ONE DOT LEADER (IN) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0009 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0009 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2024 ÷ 00B4 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 00B4 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 00B4 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2024 × 000B ÷	#  × [0.3] ONE DOT LEADER (IN) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 000B ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 000B ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 000B ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2024 ÷ FFFC ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ FFFC ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ FFFC ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2024 × 007D ÷	#  × [0.3] ONE DOT LEADER (IN) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 007D ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 007D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 007D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2024 × 0029 ÷	#  × [0.3] ONE DOT LEADER (IN) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 0029 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0029 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 0029 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2024 × 000D ÷	#  × [0.3] ONE DOT LEADER (IN) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 000D ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 000D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 000D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2024 × 0021 ÷	#  × [0.3] ONE DOT LEADER (IN) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 0021 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0021 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 0021 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2024 × 00A0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 00A0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 00A0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2024 ÷ AC00 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ AC00 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ AC00 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2024 ÷ AC01 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ AC01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ AC01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2024 ÷ 05D0 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 05D0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 05D0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2024 × 002D ÷	#  × [0.3] ONE DOT LEADER (IN) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 002D ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 002D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2024 ÷ 231A ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 231A ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 231A ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2024 × 2024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [22.04] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 2024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 2024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.04] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2024 × 002C ÷	#  × [0.3] ONE DOT LEADER (IN) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 002C ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 002C ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 002C ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2024 ÷ 1100 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 1100 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 1100 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2024 ÷ 11A8 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 11A8 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 11A8 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2024 ÷ 1160 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 1160 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 1160 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2024 × 000A ÷	#  × [0.3] ONE DOT LEADER (IN) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 000A ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 000A ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 000A ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2024 × 0085 ÷	#  × [0.3] ONE DOT LEADER (IN) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 0085 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0085 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 0085 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2024 × 17D6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 17D6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 17D6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0030 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0030 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0030 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0028 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0028 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0028 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0025 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0025 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0025 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0024 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2024 × 0022 ÷	#  × [0.3] ONE DOT LEADER (IN) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0022 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0022 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 0020 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 0020 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2024 × 002F ÷	#  × [0.3] ONE DOT LEADER (IN) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 002F ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 002F ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 002F ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2024 × 2060 ÷	#  × [0.3] ONE DOT LEADER (IN) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 2060 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 2060 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 2060 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2024 × 200B ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 200B ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 200B ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 200B ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2024 ÷ 1F1E6 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 1F1E6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2024 ÷ 261D ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 261D ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 261D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2024 ÷ 1F3FB ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 1F3FB ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 1F3FB ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2024 × 0001 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0001 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0001 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2024 × 200D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 200D ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 200D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2024 ÷ 00A7 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 00A7 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 00A7 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2024 ÷ 50005 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 50005 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 50005 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0E01 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0E01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0E01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2024 × 3041 ÷	#  × [0.3] ONE DOT LEADER (IN) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 3041 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 3041 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002C × 0023 ÷	#  × [0.3] COMMA (IS) × [29.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0023 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0023 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [29.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002C ÷ 2014 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 2014 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 2014 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002C × 0009 ÷	#  × [0.3] COMMA (IS) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0009 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0009 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002C ÷ 00B4 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 00B4 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 00B4 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002C × 000B ÷	#  × [0.3] COMMA (IS) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 000B ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 000B ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 000B ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002C ÷ FFFC ÷	#  × [0.3] COMMA (IS) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ FFFC ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ FFFC ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002C × 007D ÷	#  × [0.3] COMMA (IS) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 007D ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 007D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 007D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002C × 0029 ÷	#  × [0.3] COMMA (IS) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 0029 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0029 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 0029 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002C × 000D ÷	#  × [0.3] COMMA (IS) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 000D ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 000D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 000D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002C × 0021 ÷	#  × [0.3] COMMA (IS) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 0021 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0021 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 0021 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002C × 00A0 ÷	#  × [0.3] COMMA (IS) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 00A0 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 00A0 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002C ÷ AC00 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ AC00 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ AC00 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002C ÷ AC01 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ AC01 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ AC01 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002C × 05D0 ÷	#  × [0.3] COMMA (IS) × [29.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 05D0 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 05D0 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [29.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002C × 002D ÷	#  × [0.3] COMMA (IS) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 002D ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 002D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 002D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002C ÷ 231A ÷	#  × [0.3] COMMA (IS) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 231A ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 231A ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 231A ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002C ÷ 2024 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 2024 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 2024 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002C × 002C ÷	#  × [0.3] COMMA (IS) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 002C ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 002C ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 002C ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002C ÷ 1100 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 1100 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 1100 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002C ÷ 11A8 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 11A8 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 11A8 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002C ÷ 1160 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 1160 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 1160 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002C × 000A ÷	#  × [0.3] COMMA (IS) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 000A ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 000A ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 000A ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002C × 0085 ÷	#  × [0.3] COMMA (IS) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 0085 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0085 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 0085 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002C × 17D6 ÷	#  × [0.3] COMMA (IS) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 17D6 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 17D6 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002C ÷ 0030 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0030 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 0030 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002C ÷ 0028 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0028 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 0028 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002C ÷ 0025 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0025 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 0025 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002C ÷ 0024 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0024 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 0024 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002C × 0022 ÷	#  × [0.3] COMMA (IS) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0022 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0022 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 0020 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 0020 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002C × 002F ÷	#  × [0.3] COMMA (IS) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 002F ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 002F ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 002F ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002C × 2060 ÷	#  × [0.3] COMMA (IS) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 2060 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 2060 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 2060 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002C × 200B ÷	#  × [0.3] COMMA (IS) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 200B ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 200B ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 200B ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002C ÷ 1F1E6 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 1F1E6 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 1F1E6 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002C ÷ 261D ÷	#  × [0.3] COMMA (IS) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 261D ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 261D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 261D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002C ÷ 1F3FB ÷	#  × [0.3] COMMA (IS) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 1F3FB ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 1F3FB ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002C × 0001 ÷	#  × [0.3] COMMA (IS) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0001 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0001 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002C × 200D ÷	#  × [0.3] COMMA (IS) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 200D ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 200D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 200D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002C × 00A7 ÷	#  × [0.3] COMMA (IS) × [29.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 00A7 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 00A7 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [29.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002C × 50005 ÷	#  × [0.3] COMMA (IS) × [29.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 50005 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 50005 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [29.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002C × 0E01 ÷	#  × [0.3] COMMA (IS) × [29.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0E01 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0E01 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [29.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002C × 3041 ÷	#  × [0.3] COMMA (IS) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 3041 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 3041 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1100 ÷ 0023 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 0023 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1100 ÷ 2014 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 2014 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1100 × 0009 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0009 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1100 ÷ 00B4 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 00B4 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1100 × 000B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 000B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 000B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 000B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1100 ÷ FFFC ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ FFFC ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1100 × 007D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 007D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 007D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 007D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1100 × 0029 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 0029 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0029 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 0029 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1100 × 000D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 000D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 000D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 000D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1100 × 0021 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 0021 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0021 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 0021 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1100 × 00A0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 00A0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1100 × AC00 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [26.01] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × AC00 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.01] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1100 × AC01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [26.01] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × AC01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.01] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1100 ÷ 05D0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 05D0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1100 × 002D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 002D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1100 ÷ 231A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 231A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1100 × 2024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 2024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1100 × 002C ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 002C ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 002C ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 002C ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1100 × 1100 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [26.01] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 1100 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.01] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1100 ÷ 11A8 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 11A8 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1100 × 1160 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [26.01] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 1160 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.01] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1100 × 000A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 000A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 000A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 000A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1100 × 0085 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 0085 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0085 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 0085 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1100 × 17D6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 17D6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1100 ÷ 0030 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 0030 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1100 ÷ 0028 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 0028 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1100 × 0025 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0025 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1100 ÷ 0024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 0024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1100 × 0022 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0022 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 0020 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 0020 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1100 × 002F ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 002F ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 002F ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 002F ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1100 × 2060 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 2060 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 2060 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 2060 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1100 × 200B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 200B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 200B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 200B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1100 ÷ 1F1E6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1100 ÷ 261D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 261D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1100 ÷ 1F3FB ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 1F3FB ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1100 × 0001 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0001 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1100 × 200D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 200D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1100 ÷ 00A7 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 00A7 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1100 ÷ 50005 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 50005 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1100 ÷ 0E01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 0E01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1100 × 3041 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 3041 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 0023 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 0023 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 2014 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 2014 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 11A8 × 0009 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0009 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 00B4 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 00B4 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 11A8 × 000B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 000B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 000B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 000B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 11A8 ÷ FFFC ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ FFFC ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 11A8 × 007D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 007D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 007D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 007D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 11A8 × 0029 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 0029 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0029 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 0029 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 11A8 × 000D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 000D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 000D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 000D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 11A8 × 0021 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 0021 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0021 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 0021 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 11A8 × 00A0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 00A0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 11A8 ÷ AC00 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ AC00 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 11A8 ÷ AC01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ AC01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 05D0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 05D0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 11A8 × 002D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 002D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 231A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 231A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 11A8 × 2024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 2024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 11A8 × 002C ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 002C ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 002C ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 002C ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 1100 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 1100 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 11A8 × 11A8 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [26.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 11A8 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 1160 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 1160 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 11A8 × 000A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 000A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 000A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 000A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 11A8 × 0085 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 0085 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0085 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 0085 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 11A8 × 17D6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 17D6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 0030 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 0030 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 0028 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 0028 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 11A8 × 0025 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0025 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 0024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 0024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 11A8 × 0022 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0022 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 0020 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 0020 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 11A8 × 002F ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 002F ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 002F ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 002F ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 11A8 × 2060 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 2060 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 2060 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 2060 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 11A8 × 200B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 200B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 200B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 200B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 261D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 261D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 1F3FB ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 1F3FB ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 11A8 × 0001 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0001 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 200D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 200D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 00A7 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 00A7 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 50005 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 50005 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 0E01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 0E01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 3041 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 3041 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1160 ÷ 0023 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 0023 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1160 ÷ 2014 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 2014 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1160 × 0009 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0009 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1160 ÷ 00B4 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 00B4 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1160 × 000B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 000B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 000B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 000B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1160 ÷ FFFC ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ FFFC ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1160 × 007D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 007D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 007D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 007D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1160 × 0029 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 0029 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0029 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 0029 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1160 × 000D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 000D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 000D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 000D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1160 × 0021 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 0021 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0021 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 0021 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1160 × 00A0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 00A0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1160 ÷ AC00 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ AC00 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1160 ÷ AC01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ AC01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1160 ÷ 05D0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 05D0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1160 × 002D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 002D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1160 ÷ 231A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 231A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1160 × 2024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 2024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1160 × 002C ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 002C ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 002C ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 002C ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1160 ÷ 1100 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 1100 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1160 × 11A8 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [26.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 11A8 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1160 × 1160 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [26.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 1160 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1160 × 000A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 000A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 000A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 000A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1160 × 0085 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 0085 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0085 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 0085 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1160 × 17D6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 17D6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1160 ÷ 0030 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 0030 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1160 ÷ 0028 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 0028 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1160 × 0025 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0025 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1160 ÷ 0024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 0024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1160 × 0022 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0022 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 0020 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 0020 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1160 × 002F ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 002F ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 002F ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 002F ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1160 × 2060 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 2060 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 2060 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 2060 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1160 × 200B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 200B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 200B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 200B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1160 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1160 ÷ 261D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 261D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1160 ÷ 1F3FB ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 1F3FB ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1160 × 0001 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0001 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1160 × 200D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 200D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1160 ÷ 00A7 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 00A7 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1160 ÷ 50005 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 50005 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1160 ÷ 0E01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 0E01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1160 × 3041 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 3041 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0023 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0023 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0023 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 2014 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 2014 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 2014 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0009 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0009 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0009 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000A ÷ 00B4 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 00B4 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 00B4 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000A ÷ 000B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 000B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 000B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 000B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000A ÷ FFFC ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ FFFC ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ FFFC ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000A ÷ 007D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 007D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 007D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 007D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0029 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 0029 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0029 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000A ÷ 000D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 000D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 000D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 000D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0021 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 0021 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0021 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000A ÷ 00A0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 00A0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 00A0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000A ÷ AC00 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ AC00 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ AC00 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000A ÷ AC01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ AC01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ AC01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000A ÷ 05D0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 05D0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 05D0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000A ÷ 002D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 002D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 002D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000A ÷ 231A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 231A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 231A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000A ÷ 2024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 2024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 2024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000A ÷ 002C ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 002C ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 002C ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 002C ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000A ÷ 1100 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 1100 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 1100 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000A ÷ 11A8 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 11A8 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 11A8 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000A ÷ 1160 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 1160 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 1160 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000A ÷ 000A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 000A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 000A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 000A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000A ÷ 0085 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 0085 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0085 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000A ÷ 17D6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 17D6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 17D6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0030 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0030 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0030 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0028 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0028 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0028 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0025 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0025 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0025 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000A ÷ 0024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0022 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0022 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0022 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 0020 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000A ÷ 002F ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 002F ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 002F ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 002F ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000A ÷ 2060 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 2060 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 2060 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000A ÷ 200B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 200B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 8) {
    Test_LB('× 000A ÷ 0308 × 200B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 200B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000A ÷ 1F1E6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 1F1E6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000A ÷ 261D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 261D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 261D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000A ÷ 1F3FB ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 1F3FB ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0001 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0001 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0001 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 200D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 200D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 200D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 00A7 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 00A7 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 00A7 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 50005 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 50005 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 50005 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0E01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0E01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0E01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 3041 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 3041 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 3041 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0023 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0023 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0023 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 2014 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 2014 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 2014 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0009 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0009 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0009 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0085 ÷ 00B4 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 00B4 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 00B4 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 000B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 000B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 000B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 000B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0085 ÷ FFFC ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ FFFC ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ FFFC ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 007D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 007D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 007D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 007D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0029 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 0029 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0029 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 000D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 000D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 000D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 000D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0021 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 0021 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0021 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0085 ÷ 00A0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 00A0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 00A0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0085 ÷ AC00 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ AC00 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ AC00 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0085 ÷ AC01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ AC01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ AC01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0085 ÷ 05D0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 05D0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 05D0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 002D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 002D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 002D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 231A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 231A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 231A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0085 ÷ 2024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 2024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 2024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0085 ÷ 002C ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 002C ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 002C ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 002C ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 1100 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 1100 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 1100 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 11A8 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 11A8 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 11A8 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0085 ÷ 1160 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 1160 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 1160 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0085 ÷ 000A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 000A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 000A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 000A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0085 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 0085 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0085 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 17D6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 17D6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 17D6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0030 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0030 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0030 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0028 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0028 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0028 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0025 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0025 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0025 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0022 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0022 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0022 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 0020 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 002F ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 002F ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 002F ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 002F ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 2060 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 2060 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 2060 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0085 ÷ 200B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 200B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 200B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 200B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0085 ÷ 1F1E6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 1F1E6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0085 ÷ 261D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 261D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 261D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 1F3FB ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 1F3FB ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0001 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0001 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0001 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 200D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 200D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 200D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 00A7 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 00A7 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 00A7 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 50005 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 50005 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 50005 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0E01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0E01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0E01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 3041 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 3041 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 3041 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0023 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0023 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0023 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 2014 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 2014 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 2014 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 17D6 × 0009 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0009 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0009 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 00B4 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 00B4 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 00B4 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 17D6 × 000B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 000B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 000B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 000B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 17D6 ÷ FFFC ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ FFFC ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ FFFC ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 17D6 × 007D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 007D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 007D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 007D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 17D6 × 0029 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 0029 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0029 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 0029 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 17D6 × 000D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 000D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 000D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 000D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 17D6 × 0021 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 0021 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0021 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 0021 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 17D6 × 00A0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 00A0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 00A0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 17D6 ÷ AC00 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ AC00 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ AC00 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 17D6 ÷ AC01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ AC01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ AC01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 05D0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 05D0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 05D0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 17D6 × 002D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 002D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 002D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 231A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 231A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 231A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 2024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 2024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 2024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 17D6 × 002C ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 002C ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 002C ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 002C ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 1100 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 1100 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 1100 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 11A8 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 11A8 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 11A8 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 1160 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 1160 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 1160 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 17D6 × 000A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 000A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 000A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 000A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 17D6 × 0085 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 0085 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0085 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 0085 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 17D6 × 17D6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 17D6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 17D6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0030 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0030 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0030 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0028 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0028 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0028 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0025 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0025 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0025 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 17D6 × 0022 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0022 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0022 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 0020 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 0020 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 17D6 × 002F ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 002F ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 002F ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 002F ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 17D6 × 2060 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 2060 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 2060 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 2060 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 17D6 × 200B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 200B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 200B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 200B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 1F1E6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 1F1E6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 1F1E6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 261D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 261D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 261D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 1F3FB ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 1F3FB ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 1F3FB ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 17D6 × 0001 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0001 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0001 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 200D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 200D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 200D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 00A7 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 00A7 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 00A7 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 50005 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 50005 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 50005 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0E01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0E01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0E01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 3041 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 3041 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 3041 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0030 × 0023 ÷	#  × [0.3] DIGIT ZERO (NU) × [23.03] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0023 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0023 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0030 ÷ 2014 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 2014 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 2014 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0030 × 0009 ÷	#  × [0.3] DIGIT ZERO (NU) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0009 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0009 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0030 ÷ 00B4 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 00B4 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 00B4 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0030 × 000B ÷	#  × [0.3] DIGIT ZERO (NU) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 000B ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 000B ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 000B ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0030 ÷ FFFC ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ FFFC ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ FFFC ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0030 × 007D ÷	#  × [0.3] DIGIT ZERO (NU) × [25.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 007D ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 007D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 007D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0030 × 0029 ÷	#  × [0.3] DIGIT ZERO (NU) × [25.04] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 0029 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0029 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.04] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 0029 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0030 × 000D ÷	#  × [0.3] DIGIT ZERO (NU) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 000D ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 000D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 000D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0030 × 0021 ÷	#  × [0.3] DIGIT ZERO (NU) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 0021 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0021 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 0021 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0030 × 00A0 ÷	#  × [0.3] DIGIT ZERO (NU) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 00A0 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 00A0 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0030 ÷ AC00 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ AC00 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ AC00 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0030 ÷ AC01 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ AC01 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ AC01 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0030 × 05D0 ÷	#  × [0.3] DIGIT ZERO (NU) × [23.03] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 05D0 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 05D0 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0030 × 002D ÷	#  × [0.3] DIGIT ZERO (NU) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 002D ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 002D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0030 ÷ 231A ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 231A ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 231A ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0030 × 2024 ÷	#  × [0.3] DIGIT ZERO (NU) × [22.05] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 2024 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 2024 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.05] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0030 × 002C ÷	#  × [0.3] DIGIT ZERO (NU) × [25.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 002C ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 002C ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 002C ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0030 ÷ 1100 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 1100 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 1100 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0030 ÷ 11A8 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 11A8 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 11A8 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0030 ÷ 1160 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 1160 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 1160 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0030 × 000A ÷	#  × [0.3] DIGIT ZERO (NU) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 000A ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 000A ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 000A ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0030 × 0085 ÷	#  × [0.3] DIGIT ZERO (NU) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 0085 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0085 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 0085 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0030 × 17D6 ÷	#  × [0.3] DIGIT ZERO (NU) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 17D6 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 17D6 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0030 × 0030 ÷	#  × [0.3] DIGIT ZERO (NU) × [25.03] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0030 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0030 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.03] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0030 × 0028 ÷	#  × [0.3] DIGIT ZERO (NU) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0028 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0028 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0030 × 0025 ÷	#  × [0.3] DIGIT ZERO (NU) × [25.05] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0025 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0025 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.05] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0030 × 0024 ÷	#  × [0.3] DIGIT ZERO (NU) × [25.05] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0024 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0024 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.05] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0030 × 0022 ÷	#  × [0.3] DIGIT ZERO (NU) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0022 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0022 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 0020 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 0020 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0030 × 002F ÷	#  × [0.3] DIGIT ZERO (NU) × [25.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 002F ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 002F ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 002F ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0030 × 2060 ÷	#  × [0.3] DIGIT ZERO (NU) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 2060 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 2060 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 2060 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0030 × 200B ÷	#  × [0.3] DIGIT ZERO (NU) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 200B ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 200B ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 200B ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0030 ÷ 1F1E6 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 1F1E6 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 1F1E6 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0030 ÷ 261D ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 261D ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 261D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0030 ÷ 1F3FB ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 1F3FB ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 1F3FB ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0030 × 0001 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0001 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0001 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0030 × 200D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 200D ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 200D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0030 × 00A7 ÷	#  × [0.3] DIGIT ZERO (NU) × [23.03] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 00A7 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 00A7 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0030 × 50005 ÷	#  × [0.3] DIGIT ZERO (NU) × [23.03] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 50005 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 50005 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0E01 ÷	#  × [0.3] DIGIT ZERO (NU) × [23.03] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0E01 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0E01 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0030 × 3041 ÷	#  × [0.3] DIGIT ZERO (NU) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 3041 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 3041 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0028 × 0023 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0023 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0023 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0023 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0028 × 2014 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 2014 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 2014 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 2014 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0028 × 0009 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0009 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0009 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0009 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0028 × 00B4 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 00B4 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 00B4 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 00B4 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0028 × 000B ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 000B ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 000B ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 000B ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0028 × FFFC ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × FFFC ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × FFFC ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × FFFC ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0028 × 007D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 007D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 007D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 007D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0028 × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0028 × 000D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 000D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 000D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 000D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0028 × 0021 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0021 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0021 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0021 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0028 × 00A0 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 00A0 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 00A0 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 00A0 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0028 × AC00 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × AC00 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × AC00 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × AC00 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0028 × AC01 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × AC01 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × AC01 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × AC01 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0028 × 05D0 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 05D0 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 05D0 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 05D0 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0028 × 002D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 002D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 002D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 002D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0028 × 231A ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 231A ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 231A ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 231A ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0028 × 2024 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 2024 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 2024 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 2024 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0028 × 002C ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 002C ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 002C ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 002C ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0028 × 1100 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 1100 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 1100 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 1100 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0028 × 11A8 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 11A8 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 11A8 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 11A8 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0028 × 1160 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 1160 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 1160 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 1160 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0028 × 000A ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 000A ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 000A ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 000A ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0028 × 0085 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0085 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0085 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0085 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0028 × 17D6 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 17D6 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 17D6 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 17D6 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0028 × 0030 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0030 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0030 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0030 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0028 × 0028 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0028 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0028 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0028 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0028 × 0025 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0025 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0025 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0025 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0028 × 0024 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0024 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0024 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0024 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0028 × 0022 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0022 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0022 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0022 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0028 × 0020 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0020 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0020 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0028 × 002F ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 002F ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 002F ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 002F ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0028 × 2060 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 2060 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 2060 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 2060 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0028 × 200B ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 200B ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 200B ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 200B ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0028 × 1F1E6 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 1F1E6 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 1F1E6 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 1F1E6 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0028 × 261D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 261D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 261D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 261D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0028 × 1F3FB ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 1F3FB ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 1F3FB ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 1F3FB ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0028 × 0001 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0001 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0001 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0001 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 200D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 200D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 200D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 200D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0028 × 00A7 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 00A7 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 00A7 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 00A7 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0028 × 50005 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 50005 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 50005 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 50005 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0E01 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0E01 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0E01 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0E01 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0028 × 3041 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 3041 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 3041 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 3041 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0025 × 0023 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0023 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0023 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0025 ÷ 2014 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 2014 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 2014 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0025 × 0009 ÷	#  × [0.3] PERCENT SIGN (PO) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0009 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0009 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0025 ÷ 00B4 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 00B4 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 00B4 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0025 × 000B ÷	#  × [0.3] PERCENT SIGN (PO) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 000B ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 000B ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 000B ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0025 ÷ FFFC ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ FFFC ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ FFFC ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0025 × 007D ÷	#  × [0.3] PERCENT SIGN (PO) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 007D ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 007D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 007D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0025 × 0029 ÷	#  × [0.3] PERCENT SIGN (PO) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 0029 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0029 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 0029 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0025 × 000D ÷	#  × [0.3] PERCENT SIGN (PO) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 000D ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 000D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 000D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0025 × 0021 ÷	#  × [0.3] PERCENT SIGN (PO) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 0021 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0021 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 0021 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0025 × 00A0 ÷	#  × [0.3] PERCENT SIGN (PO) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 00A0 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 00A0 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0025 ÷ AC00 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ AC00 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ AC00 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0025 ÷ AC01 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ AC01 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ AC01 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0025 × 05D0 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 05D0 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 05D0 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0025 × 002D ÷	#  × [0.3] PERCENT SIGN (PO) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 002D ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 002D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0025 ÷ 231A ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 231A ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 231A ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0025 ÷ 2024 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 2024 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 2024 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0025 × 002C ÷	#  × [0.3] PERCENT SIGN (PO) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 002C ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 002C ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 002C ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0025 ÷ 1100 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 1100 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 1100 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0025 ÷ 11A8 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 11A8 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 11A8 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0025 ÷ 1160 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 1160 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 1160 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0025 × 000A ÷	#  × [0.3] PERCENT SIGN (PO) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 000A ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 000A ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 000A ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0025 × 0085 ÷	#  × [0.3] PERCENT SIGN (PO) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 0085 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0085 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 0085 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0025 × 17D6 ÷	#  × [0.3] PERCENT SIGN (PO) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 17D6 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 17D6 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0025 × 0030 ÷	#  × [0.3] PERCENT SIGN (PO) × [25.01] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0030 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0030 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.01] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0025 ÷ 0028 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0028 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 0028 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0025 ÷ 0025 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0025 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 0025 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0025 ÷ 0024 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0024 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 0024 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0025 × 0022 ÷	#  × [0.3] PERCENT SIGN (PO) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0022 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0022 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 0020 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 0020 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0025 × 002F ÷	#  × [0.3] PERCENT SIGN (PO) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 002F ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 002F ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 002F ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0025 × 2060 ÷	#  × [0.3] PERCENT SIGN (PO) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 2060 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 2060 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 2060 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0025 × 200B ÷	#  × [0.3] PERCENT SIGN (PO) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 200B ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 200B ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 200B ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0025 ÷ 1F1E6 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 1F1E6 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 1F1E6 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0025 ÷ 261D ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 261D ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 261D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0025 ÷ 1F3FB ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 1F3FB ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 1F3FB ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0025 × 0001 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0001 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0001 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0025 × 200D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 200D ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 200D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0025 × 00A7 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 00A7 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 00A7 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0025 × 50005 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 50005 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 50005 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0E01 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0E01 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0E01 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0025 × 3041 ÷	#  × [0.3] PERCENT SIGN (PO) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 3041 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 3041 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0024 × 0023 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0023 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0023 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0024 ÷ 2014 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 2014 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 2014 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0024 × 0009 ÷	#  × [0.3] DOLLAR SIGN (PR) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0009 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0009 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0024 ÷ 00B4 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 00B4 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 00B4 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0024 × 000B ÷	#  × [0.3] DOLLAR SIGN (PR) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 000B ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 000B ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 000B ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0024 ÷ FFFC ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ FFFC ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ FFFC ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0024 × 007D ÷	#  × [0.3] DOLLAR SIGN (PR) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 007D ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 007D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 007D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0024 × 0029 ÷	#  × [0.3] DOLLAR SIGN (PR) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 0029 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0029 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 0029 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0024 × 000D ÷	#  × [0.3] DOLLAR SIGN (PR) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 000D ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 000D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 000D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0024 × 0021 ÷	#  × [0.3] DOLLAR SIGN (PR) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 0021 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0021 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 0021 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0024 × 00A0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 00A0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 00A0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0024 × AC00 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.03] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ AC00 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × AC00 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.03] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0024 × AC01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.03] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ AC01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × AC01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.03] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0024 × 05D0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 05D0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 05D0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0024 × 002D ÷	#  × [0.3] DOLLAR SIGN (PR) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 002D ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 002D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0024 × 231A ÷	#  × [0.3] DOLLAR SIGN (PR) × [23.12] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 231A ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 231A ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.12] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0024 ÷ 2024 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 2024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 2024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0024 × 002C ÷	#  × [0.3] DOLLAR SIGN (PR) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 002C ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 002C ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 002C ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0024 × 1100 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.03] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 1100 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 1100 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.03] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0024 × 11A8 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 11A8 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 11A8 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0024 × 1160 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.03] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 1160 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 1160 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.03] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0024 × 000A ÷	#  × [0.3] DOLLAR SIGN (PR) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 000A ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 000A ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 000A ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0024 × 0085 ÷	#  × [0.3] DOLLAR SIGN (PR) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 0085 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0085 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 0085 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0024 × 17D6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 17D6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 17D6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0024 × 0030 ÷	#  × [0.3] DOLLAR SIGN (PR) × [25.01] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0030 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0030 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.01] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0024 ÷ 0028 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0028 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 0028 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0024 ÷ 0025 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0025 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 0025 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0024 ÷ 0024 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 0024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0024 × 0022 ÷	#  × [0.3] DOLLAR SIGN (PR) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0022 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0022 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 0020 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 0020 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0024 × 002F ÷	#  × [0.3] DOLLAR SIGN (PR) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 002F ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 002F ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 002F ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0024 × 2060 ÷	#  × [0.3] DOLLAR SIGN (PR) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 2060 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 2060 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 2060 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0024 × 200B ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 200B ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 200B ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 200B ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0024 ÷ 1F1E6 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 1F1E6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 1F1E6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0024 × 261D ÷	#  × [0.3] DOLLAR SIGN (PR) × [23.12] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 261D ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 261D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.12] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0024 × 1F3FB ÷	#  × [0.3] DOLLAR SIGN (PR) × [23.12] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 1F3FB ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 1F3FB ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.12] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0024 × 0001 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0001 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0001 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0024 × 200D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 200D ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 200D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0024 × 00A7 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 00A7 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 00A7 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0024 × 50005 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 50005 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 50005 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0E01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0E01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0E01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0024 × 3041 ÷	#  × [0.3] DOLLAR SIGN (PR) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 3041 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 3041 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0022 × 0023 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0023 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0023 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0022 × 2014 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 2014 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 2014 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0022 × 0009 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0009 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0009 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0022 × 00B4 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 00B4 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 00B4 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0022 × 000B ÷	#  × [0.3] QUOTATION MARK (QU) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 000B ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 000B ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 000B ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0022 × FFFC ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ FFFC ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × FFFC ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0022 × 007D ÷	#  × [0.3] QUOTATION MARK (QU) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 007D ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 007D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 007D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0022 × 0029 ÷	#  × [0.3] QUOTATION MARK (QU) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 0029 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0029 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 0029 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0022 × 000D ÷	#  × [0.3] QUOTATION MARK (QU) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 000D ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 000D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 000D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0022 × 0021 ÷	#  × [0.3] QUOTATION MARK (QU) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 0021 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0021 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 0021 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0022 × 00A0 ÷	#  × [0.3] QUOTATION MARK (QU) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 00A0 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 00A0 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0022 × AC00 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ AC00 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × AC00 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0022 × AC01 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ AC01 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × AC01 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0022 × 05D0 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 05D0 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 05D0 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0022 × 002D ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 002D ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 002D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0022 × 231A ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 231A ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 231A ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0022 × 2024 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 2024 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 2024 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0022 × 002C ÷	#  × [0.3] QUOTATION MARK (QU) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 002C ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 002C ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 002C ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0022 × 1100 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 1100 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 1100 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0022 × 11A8 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 11A8 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 11A8 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0022 × 1160 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 1160 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 1160 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0022 × 000A ÷	#  × [0.3] QUOTATION MARK (QU) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 000A ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 000A ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 000A ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0022 × 0085 ÷	#  × [0.3] QUOTATION MARK (QU) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 0085 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0085 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 0085 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0022 × 17D6 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 17D6 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 17D6 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0022 × 0030 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0030 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0030 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0022 × 0028 ÷	#  × [0.3] QUOTATION MARK (QU) × [15.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 0028 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [15.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0028 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [15.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 0028 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [15.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0022 × 0025 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0025 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0025 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0022 × 0024 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0024 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0024 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0022 × 0022 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0022 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0022 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 0020 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 0020 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0022 × 002F ÷	#  × [0.3] QUOTATION MARK (QU) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 002F ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 002F ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 002F ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0022 × 2060 ÷	#  × [0.3] QUOTATION MARK (QU) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 2060 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 2060 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 2060 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0022 × 200B ÷	#  × [0.3] QUOTATION MARK (QU) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 200B ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 200B ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 200B ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0022 × 1F1E6 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 1F1E6 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 1F1E6 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0022 × 261D ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 261D ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 261D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0022 × 1F3FB ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 1F3FB ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 1F3FB ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0022 × 0001 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0001 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0001 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0022 × 200D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 200D ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 200D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0022 × 00A7 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 00A7 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 00A7 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0022 × 50005 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 50005 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 50005 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0E01 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0E01 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0E01 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0022 × 3041 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 3041 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 3041 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0023 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0023 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0023 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 2014 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 2014 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 2014 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0009 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0009 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0009 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0020 ÷ 00B4 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 00B4 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 00B4 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0020 × 000B ÷	#  × [0.3] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 000B ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 000B ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 000B ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0020 ÷ FFFC ÷	#  × [0.3] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ FFFC ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ FFFC ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0020 × 007D ÷	#  × [0.3] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 007D ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 007D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 007D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0020 × 0029 ÷	#  × [0.3] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 0029 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0029 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0020 × 000D ÷	#  × [0.3] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 000D ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 000D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 000D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0020 × 0021 ÷	#  × [0.3] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 0021 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0021 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0020 ÷ 00A0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 00A0 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 00A0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0020 ÷ AC00 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ AC00 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ AC00 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0020 ÷ AC01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ AC01 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ AC01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0020 ÷ 05D0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 05D0 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 05D0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 002D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 002D ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 002D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0020 ÷ 231A ÷	#  × [0.3] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 231A ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 231A ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0020 ÷ 2024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 2024 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 2024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0020 × 002C ÷	#  × [0.3] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 002C ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 002C ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 002C ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 1100 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 1100 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 1100 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 11A8 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 11A8 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 11A8 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0020 ÷ 1160 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 1160 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 1160 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0020 × 000A ÷	#  × [0.3] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 000A ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 000A ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 000A ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0020 × 0085 ÷	#  × [0.3] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 0085 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0085 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 17D6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 17D6 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 17D6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0030 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0030 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0030 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0028 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0028 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0028 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0025 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0025 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0025 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0024 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0022 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0022 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0022 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 0020 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0020 × 002F ÷	#  × [0.3] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 002F ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 002F ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 002F ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0020 × 2060 ÷	#  × [0.3] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 2060 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 2060 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0020 × 200B ÷	#  × [0.3] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 200B ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 200B ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 200B ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0020 ÷ 1F1E6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 1F1E6 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0020 ÷ 261D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 261D ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 261D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 1F3FB ÷	#  × [0.3] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 1F3FB ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0001 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0001 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0001 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 200D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 200D ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 200D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 00A7 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 00A7 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 00A7 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 50005 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 50005 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 50005 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0E01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0E01 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0E01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 3041 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 3041 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 3041 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002F ÷ 0023 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0023 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0023 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002F ÷ 2014 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 2014 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 2014 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002F × 0009 ÷	#  × [0.3] SOLIDUS (SY) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0009 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0009 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002F ÷ 00B4 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 00B4 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 00B4 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002F × 000B ÷	#  × [0.3] SOLIDUS (SY) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 000B ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 000B ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 000B ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002F ÷ FFFC ÷	#  × [0.3] SOLIDUS (SY) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ FFFC ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ FFFC ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002F × 007D ÷	#  × [0.3] SOLIDUS (SY) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 007D ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 007D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 007D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002F × 0029 ÷	#  × [0.3] SOLIDUS (SY) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 0029 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0029 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 0029 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002F × 000D ÷	#  × [0.3] SOLIDUS (SY) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 000D ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 000D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 000D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002F × 0021 ÷	#  × [0.3] SOLIDUS (SY) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 0021 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0021 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 0021 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002F × 00A0 ÷	#  × [0.3] SOLIDUS (SY) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 00A0 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 00A0 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002F ÷ AC00 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ AC00 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ AC00 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002F ÷ AC01 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ AC01 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ AC01 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002F × 05D0 ÷	#  × [0.3] SOLIDUS (SY) × [21.2] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 05D0 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 05D0 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.2] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002F × 002D ÷	#  × [0.3] SOLIDUS (SY) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 002D ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 002D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 002D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002F ÷ 231A ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 231A ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 231A ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 231A ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002F ÷ 2024 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 2024 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 2024 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002F × 002C ÷	#  × [0.3] SOLIDUS (SY) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 002C ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 002C ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 002C ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002F ÷ 1100 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 1100 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 1100 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002F ÷ 11A8 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 11A8 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 11A8 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002F ÷ 1160 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 1160 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 1160 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002F × 000A ÷	#  × [0.3] SOLIDUS (SY) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 000A ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 000A ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 000A ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002F × 0085 ÷	#  × [0.3] SOLIDUS (SY) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 0085 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0085 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 0085 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002F × 17D6 ÷	#  × [0.3] SOLIDUS (SY) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 17D6 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 17D6 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002F ÷ 0030 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0030 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0030 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002F ÷ 0028 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0028 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0028 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002F ÷ 0025 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0025 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0025 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002F ÷ 0024 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0024 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0024 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002F × 0022 ÷	#  × [0.3] SOLIDUS (SY) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0022 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0022 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 0020 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 0020 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002F × 002F ÷	#  × [0.3] SOLIDUS (SY) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 002F ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 002F ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 002F ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002F × 2060 ÷	#  × [0.3] SOLIDUS (SY) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 2060 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 2060 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 2060 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002F × 200B ÷	#  × [0.3] SOLIDUS (SY) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 200B ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 200B ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 200B ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002F ÷ 1F1E6 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 1F1E6 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 1F1E6 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002F ÷ 261D ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 261D ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 261D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 261D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002F ÷ 1F3FB ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 1F3FB ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 1F3FB ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002F × 0001 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0001 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0001 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002F × 200D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 200D ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 200D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 200D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002F ÷ 00A7 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 00A7 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 00A7 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002F ÷ 50005 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 50005 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 50005 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002F ÷ 0E01 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0E01 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0E01 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002F × 3041 ÷	#  × [0.3] SOLIDUS (SY) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 3041 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 3041 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2060 × 0023 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0023 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0023 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2060 × 2014 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 2014 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 2014 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2060 × 0009 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0009 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0009 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2060 × 00B4 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 00B4 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 00B4 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2060 × 000B ÷	#  × [0.3] WORD JOINER (WJ) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 000B ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 000B ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 000B ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2060 × FFFC ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ FFFC ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × FFFC ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2060 × 007D ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 007D ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 007D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 007D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2060 × 0029 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 0029 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0029 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 0029 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2060 × 000D ÷	#  × [0.3] WORD JOINER (WJ) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 000D ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 000D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 000D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2060 × 0021 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 0021 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0021 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 0021 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2060 × 00A0 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 00A0 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 00A0 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2060 × AC00 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ AC00 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × AC00 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2060 × AC01 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ AC01 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × AC01 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2060 × 05D0 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 05D0 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 05D0 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2060 × 002D ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 002D ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 002D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2060 × 231A ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 231A ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 231A ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2060 × 2024 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 2024 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 2024 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2060 × 002C ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 002C ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 002C ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 002C ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2060 × 1100 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 1100 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 1100 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2060 × 11A8 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 11A8 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 11A8 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2060 × 1160 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 1160 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 1160 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2060 × 000A ÷	#  × [0.3] WORD JOINER (WJ) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 000A ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 000A ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 000A ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2060 × 0085 ÷	#  × [0.3] WORD JOINER (WJ) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 0085 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0085 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 0085 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2060 × 17D6 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 17D6 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 17D6 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2060 × 0030 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0030 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0030 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2060 × 0028 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0028 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0028 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2060 × 0025 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0025 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0025 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2060 × 0024 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0024 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0024 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2060 × 0022 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0022 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0022 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 0020 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 0020 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2060 × 002F ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 002F ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 002F ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 002F ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2060 × 2060 ÷	#  × [0.3] WORD JOINER (WJ) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 2060 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 2060 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 2060 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2060 × 200B ÷	#  × [0.3] WORD JOINER (WJ) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 200B ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 200B ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 200B ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2060 × 1F1E6 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 1F1E6 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 1F1E6 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2060 × 261D ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 261D ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 261D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2060 × 1F3FB ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 1F3FB ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 1F3FB ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2060 × 0001 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0001 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0001 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2060 × 200D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 200D ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 200D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2060 × 00A7 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 00A7 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 00A7 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2060 × 50005 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 50005 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 50005 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0E01 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0E01 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0E01 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2060 × 3041 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 3041 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 3041 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0023 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0023 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0023 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 2014 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200B ÷ 0009 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0009 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0009 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200B ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200B × 000B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 000B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 000B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 000B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200B ÷ FFFC ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200B ÷ 007D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 007D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 007D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 007D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0029 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0029 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0029 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 200B × 000D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 000D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 000D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 000D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0021 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0021 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0021 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200B ÷ 00A0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 00A0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 00A0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200B ÷ AC00 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200B ÷ AC01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200B ÷ 05D0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 05D0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 05D0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200B ÷ 002D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 002D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 002D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200B ÷ 231A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 231A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 231A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200B ÷ 2024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 2024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 2024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200B ÷ 002C ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 002C ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 002C ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 002C ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200B ÷ 1100 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200B ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200B ÷ 1160 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200B × 000A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 000A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 000A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 000A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200B × 0085 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 0085 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0085 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200B ÷ 17D6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 17D6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 17D6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0030 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0030 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0030 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200B ÷ 0028 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0028 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0028 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0025 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0025 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0025 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200B ÷ 0024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 9) {
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0022 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0022 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0022 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 0020 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200B ÷ 002F ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 002F ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 002F ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 002F ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200B ÷ 2060 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 2060 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 2060 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200B × 200B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 200B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 200B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 200B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200B ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200B ÷ 261D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 261D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 261D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200B ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0001 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0001 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0001 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 200D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 200D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 200D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 00A7 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 00A7 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 00A7 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 50005 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 50005 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 50005 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0E01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0E01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0E01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 3041 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 3041 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 3041 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0023 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0023 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0023 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 2014 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 2014 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 2014 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0009 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0009 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0009 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 00B4 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 00B4 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 00B4 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 000B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 000B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 000B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 000B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ FFFC ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ FFFC ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ FFFC ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 007D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 007D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 007D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 007D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0029 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 0029 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0029 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 0029 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 000D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 000D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 000D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 000D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0021 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 0021 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0021 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 0021 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F1E6 × 00A0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 00A0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 00A0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ AC00 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ AC00 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ AC00 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ AC01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ AC01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ AC01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 05D0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 05D0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 05D0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 002D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 002D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 002D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 231A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 231A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 231A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 2024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 2024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 2024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F1E6 × 002C ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 002C ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 002C ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 002C ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 1100 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 1100 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 1100 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 11A8 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 11A8 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 11A8 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 1160 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 1160 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 1160 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F1E6 × 000A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 000A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 000A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 000A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0085 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 0085 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0085 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 0085 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 17D6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 17D6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 17D6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0030 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0030 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0030 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0028 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0028 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0028 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0025 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0025 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0025 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0022 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0022 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0022 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 0020 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 0020 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 002F ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 002F ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 002F ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 002F ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 2060 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 2060 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 2060 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 2060 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F1E6 × 200B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 200B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 200B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 200B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F1E6 × 1F1E6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 1F1E6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 1F1E6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.11] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 261D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 261D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 261D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 1F3FB ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 1F3FB ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 1F3FB ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0001 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0001 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0001 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 200D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 200D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 200D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 00A7 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 00A7 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 00A7 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 50005 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 50005 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 50005 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0E01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0E01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0E01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 3041 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 3041 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 3041 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 261D ÷ 0023 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0023 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 0023 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 261D ÷ 2014 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 2014 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 2014 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 261D × 0009 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0009 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0009 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 261D ÷ 00B4 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 00B4 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 00B4 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 261D × 000B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 000B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 000B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 000B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 261D ÷ FFFC ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ FFFC ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ FFFC ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 261D × 007D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 007D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 007D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 007D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 261D × 0029 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 0029 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0029 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 0029 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 261D × 000D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 000D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 000D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 000D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 261D × 0021 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 0021 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0021 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 0021 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 261D × 00A0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 00A0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 00A0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 261D ÷ AC00 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ AC00 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ AC00 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 261D ÷ AC01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ AC01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ AC01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 261D ÷ 05D0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 05D0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 05D0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 261D × 002D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 002D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 002D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 002D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 261D ÷ 231A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 231A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 231A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 231A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 261D × 2024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [22.03] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 2024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 2024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.03] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 261D × 002C ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 002C ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 002C ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 002C ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 261D ÷ 1100 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 1100 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 1100 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 261D ÷ 11A8 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 11A8 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 11A8 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 261D ÷ 1160 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 1160 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 1160 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 261D × 000A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 000A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 000A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 000A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 261D × 0085 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 0085 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0085 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 0085 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 261D × 17D6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 17D6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 17D6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 261D ÷ 0030 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0030 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 0030 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 261D ÷ 0028 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0028 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 0028 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 261D × 0025 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0025 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0025 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 261D ÷ 0024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 0024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 261D × 0022 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0022 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0022 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 0020 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 0020 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 261D × 002F ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 002F ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 002F ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 002F ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 261D × 2060 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 2060 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 2060 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 2060 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 261D × 200B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 200B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 200B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 200B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 261D ÷ 1F1E6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 1F1E6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 1F1E6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 261D ÷ 261D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 261D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 261D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 261D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 261D × 1F3FB ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [30.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 1F3FB ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 1F3FB ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 261D × 0001 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0001 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0001 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 261D × 200D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 200D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 200D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 200D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 261D ÷ 00A7 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 00A7 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 00A7 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 261D ÷ 50005 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 50005 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 50005 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 261D ÷ 0E01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0E01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 0E01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 261D × 3041 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 3041 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 3041 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 0023 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0023 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 0023 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 2014 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 2014 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 2014 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0009 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0009 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0009 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 00B4 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 00B4 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 00B4 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F3FB × 000B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 000B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 000B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 000B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ FFFC ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ FFFC ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ FFFC ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F3FB × 007D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 007D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 007D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 007D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0029 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 0029 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0029 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 0029 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1F3FB × 000D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 000D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 000D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 000D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0021 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 0021 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0021 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 0021 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F3FB × 00A0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 00A0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 00A0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ AC00 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ AC00 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ AC00 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ AC01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ AC01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ AC01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 05D0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 05D0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 05D0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F3FB × 002D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 002D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 002D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 002D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 231A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 231A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 231A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 231A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F3FB × 2024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [22.03] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 2024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 2024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.03] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F3FB × 002C ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 002C ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 002C ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 002C ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 1100 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 1100 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 1100 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 11A8 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 11A8 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 11A8 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 1160 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 1160 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 1160 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F3FB × 000A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 000A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 000A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 000A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F3FB × 0085 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 0085 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0085 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 0085 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F3FB × 17D6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 17D6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 17D6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 0030 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0030 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 0030 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 0028 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0028 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 0028 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0025 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0025 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0025 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 0024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 0024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0022 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0022 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0022 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 0020 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 0020 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F3FB × 002F ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 002F ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 002F ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 002F ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F3FB × 2060 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 2060 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 2060 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 2060 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F3FB × 200B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 200B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 200B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 200B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 1F1E6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 1F1E6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 1F1E6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 261D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 261D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 261D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 261D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 1F3FB ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 1F3FB ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 1F3FB ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0001 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0001 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0001 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 200D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 200D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 200D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 200D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 00A7 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 00A7 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 00A7 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 50005 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 50005 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 50005 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 0E01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0E01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 0E01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 3041 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 3041 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 3041 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0001 × 0023 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0023 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0023 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0001 ÷ 2014 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 2014 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 2014 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0001 × 0009 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0009 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0009 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0001 ÷ 00B4 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 00B4 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 00B4 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0001 × 000B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 000B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 000B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 000B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0001 ÷ FFFC ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ FFFC ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ FFFC ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0001 × 007D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [13.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 007D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 007D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 007D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0001 × 0029 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [13.04] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 0029 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0029 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.04] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 0029 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0001 × 000D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 000D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 000D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 000D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0001 × 0021 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 0021 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0021 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 0021 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0001 × 00A0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [12.3] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 00A0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 00A0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.3] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0001 ÷ AC00 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ AC00 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ AC00 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0001 ÷ AC01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ AC01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ AC01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0001 × 05D0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 05D0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 05D0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0001 × 002D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 002D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 002D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0001 ÷ 231A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 231A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 231A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0001 × 2024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 2024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 2024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0001 × 002C ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [13.04] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 002C ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 002C ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.04] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 002C ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0001 ÷ 1100 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 1100 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 1100 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0001 ÷ 11A8 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 11A8 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 11A8 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0001 ÷ 1160 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 1160 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 1160 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0001 × 000A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 000A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 000A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 000A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0001 × 0085 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 0085 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0085 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 0085 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0001 × 17D6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 17D6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 17D6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0001 × 0030 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0030 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0030 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0001 × 0028 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0028 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0028 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0001 × 0025 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0025 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0025 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0001 × 0024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0001 × 0022 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0022 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0022 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 0020 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 0020 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0001 × 002F ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [13.04] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 002F ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 002F ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.04] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 002F ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0001 × 2060 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 2060 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 2060 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 2060 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0001 × 200B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 200B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 200B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 200B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0001 ÷ 1F1E6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 1F1E6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0001 ÷ 261D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 261D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 261D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0001 ÷ 1F3FB ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 1F3FB ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 1F3FB ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0001 × 0001 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0001 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0001 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0001 × 200D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 200D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 200D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0001 × 00A7 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 00A7 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 00A7 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0001 × 50005 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 50005 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 50005 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0E01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0E01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0E01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0001 × 3041 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 3041 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 3041 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200D × 0023 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0023 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0023 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200D ÷ 2014 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200D × 0009 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0009 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0009 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200D ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200D × 000B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 000B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 000B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 000B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200D ÷ FFFC ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200D × 007D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [13.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 007D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 007D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 007D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200D × 0029 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [13.04] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 0029 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0029 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.04] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 0029 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 200D × 000D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 000D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 000D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 000D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200D × 0021 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 0021 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0021 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 0021 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200D × 00A0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [12.3] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 00A0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 00A0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.3] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D ÷ AC00 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200D ÷ AC01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200D × 05D0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 05D0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 05D0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200D × 002D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 002D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 002D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 002D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200D × 231A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 231A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 231A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 231A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200D × 2024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 2024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 2024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200D × 002C ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [13.04] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 002C ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 002C ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.04] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 002C ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200D ÷ 1100 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200D ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200D ÷ 1160 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200D × 000A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 000A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 000A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 000A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200D × 0085 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 0085 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0085 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 0085 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200D × 17D6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 17D6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 17D6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200D × 0030 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0030 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0030 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200D × 0028 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0028 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0028 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 200D × 0025 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0025 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0025 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200D × 0024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200D × 0022 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0022 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0022 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 0020 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 0020 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200D × 002F ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [13.04] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 002F ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 002F ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.04] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 002F ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200D × 2060 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 2060 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 2060 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 2060 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200D × 200B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 200B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 200B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 200B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200D ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200D × 261D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 261D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 261D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 261D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200D × 1F3FB ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200D × 0001 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0001 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0001 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200D × 200D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 200D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 200D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 200D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200D × 00A7 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 00A7 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 00A7 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200D × 50005 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 50005 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 50005 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200D × 0E01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0E01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0E01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200D × 3041 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 3041 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 3041 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0023 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0023 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0023 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 2014 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 2014 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 2014 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A7 × 0009 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0009 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0009 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 00B4 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 00B4 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 00B4 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A7 × 000B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 000B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 000B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 000B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A7 ÷ FFFC ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ FFFC ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ FFFC ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A7 × 007D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 007D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 007D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 007D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A7 × 0029 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 0029 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0029 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 0029 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00A7 × 000D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 000D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 000D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 000D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A7 × 0021 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 0021 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0021 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 0021 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A7 × 00A0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 00A0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 00A0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A7 ÷ AC00 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ AC00 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ AC00 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A7 ÷ AC01 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ AC01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ AC01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A7 × 05D0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 05D0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 05D0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A7 × 002D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 002D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 002D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 231A ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 231A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 231A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A7 × 2024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 2024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 2024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A7 × 002C ÷	#  × [0.3] SECTION SIGN (AI_AL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 002C ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 002C ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 002C ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 1100 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 1100 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 1100 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 11A8 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 11A8 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 11A8 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 1160 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 1160 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 1160 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A7 × 000A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 000A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 000A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 000A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A7 × 0085 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 0085 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0085 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 0085 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A7 × 17D6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 17D6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 17D6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0030 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0030 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0030 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A7 × 0028 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0028 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0028 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00A7 × 0025 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0025 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0025 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A7 × 0024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A7 × 0022 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0022 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0022 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 0020 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 0020 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A7 × 002F ÷	#  × [0.3] SECTION SIGN (AI_AL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 002F ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 002F ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 002F ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A7 × 2060 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 2060 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 2060 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 2060 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A7 × 200B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 200B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 200B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 200B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 1F1E6 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 1F1E6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 1F1E6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 261D ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 261D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 261D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 1F3FB ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 1F3FB ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 1F3FB ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A7 × 0001 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0001 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0001 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 200D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 200D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 200D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 00A7 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 00A7 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 00A7 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 50005 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 50005 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 50005 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0E01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0E01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0E01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 3041 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 3041 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 3041 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 50005 × 0023 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0023 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0023 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 50005 ÷ 2014 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 2014 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 2014 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 50005 × 0009 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0009 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0009 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 50005 ÷ 00B4 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 00B4 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 00B4 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 50005 × 000B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 000B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 000B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 000B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 50005 ÷ FFFC ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ FFFC ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ FFFC ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 50005 × 007D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 007D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 007D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 007D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 50005 × 0029 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 0029 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0029 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 0029 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 50005 × 000D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 000D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 000D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 000D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 50005 × 0021 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 0021 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0021 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 0021 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 50005 × 00A0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 00A0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 00A0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 50005 ÷ AC00 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ AC00 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ AC00 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 50005 ÷ AC01 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ AC01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ AC01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 50005 × 05D0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 05D0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 05D0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 50005 × 002D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 002D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 002D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 50005 ÷ 231A ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 231A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 231A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 50005 × 2024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 2024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 2024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 50005 × 002C ÷	#  × [0.3] <reserved-50005> (XX_AL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 002C ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 002C ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 002C ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 50005 ÷ 1100 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 1100 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 1100 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 50005 ÷ 11A8 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 11A8 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 11A8 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 50005 ÷ 1160 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 1160 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 1160 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 50005 × 000A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 000A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 000A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 000A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 50005 × 0085 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 0085 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0085 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 0085 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 50005 × 17D6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 17D6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 17D6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 50005 × 0030 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0030 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0030 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 50005 × 0028 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0028 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0028 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 50005 × 0025 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0025 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0025 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 50005 × 0024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 50005 × 0022 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0022 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0022 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 0020 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 0020 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 50005 × 002F ÷	#  × [0.3] <reserved-50005> (XX_AL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 002F ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 002F ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 002F ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 50005 × 2060 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 2060 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 2060 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 2060 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 50005 × 200B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 200B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 200B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 200B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 50005 ÷ 1F1E6 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 1F1E6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 50005 ÷ 261D ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 261D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 261D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 50005 ÷ 1F3FB ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 1F3FB ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 1F3FB ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 50005 × 0001 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0001 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0001 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 50005 × 200D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 200D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 200D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 50005 × 00A7 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 00A7 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 00A7 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 50005 × 50005 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 50005 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 50005 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0E01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0E01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0E01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 50005 × 3041 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 3041 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 3041 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0023 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0023 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0023 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 2014 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 2014 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 2014 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0E01 × 0009 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0009 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0009 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 00B4 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 00B4 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 00B4 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0E01 × 000B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 000B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 000B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 000B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0E01 ÷ FFFC ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ FFFC ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ FFFC ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0E01 × 007D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 007D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 007D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 007D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0E01 × 0029 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 0029 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0029 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 0029 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0E01 × 000D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 000D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 000D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 000D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0E01 × 0021 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 0021 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0021 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 0021 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0E01 × 00A0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 00A0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 00A0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0E01 ÷ AC00 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ AC00 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ AC00 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0E01 ÷ AC01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ AC01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ AC01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0E01 × 05D0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 05D0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 05D0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0E01 × 002D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 002D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 002D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 231A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 231A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 231A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0E01 × 2024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 2024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 2024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0E01 × 002C ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 002C ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 002C ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 002C ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 1100 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 1100 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 1100 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 11A8 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 11A8 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 11A8 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 1160 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 1160 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 1160 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0E01 × 000A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 000A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 000A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 000A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0E01 × 0085 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 0085 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0085 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 0085 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0E01 × 17D6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 17D6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 17D6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0030 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0030 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0030 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0E01 × 0028 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0028 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0028 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0E01 × 0025 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0025 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0025 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0E01 × 0024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0E01 × 0022 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0022 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0022 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 0020 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 0020 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0E01 × 002F ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 002F ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 002F ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 002F ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0E01 × 2060 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 2060 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 2060 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 2060 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0E01 × 200B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 200B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 200B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 200B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 1F1E6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 1F1E6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 1F1E6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 261D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 261D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 261D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 1F3FB ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 1F3FB ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 1F3FB ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0E01 × 0001 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0001 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0001 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 200D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 200D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 200D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 00A7 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 00A7 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 00A7 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 50005 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 50005 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 50005 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0E01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0E01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0E01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 3041 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 3041 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 3041 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0023 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0023 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0023 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 3041 ÷ 2014 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 2014 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 2014 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 3041 × 0009 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0009 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0009 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 3041 ÷ 00B4 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 00B4 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 00B4 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 3041 × 000B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 000B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 000B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 000B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 3041 ÷ FFFC ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ FFFC ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ FFFC ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 3041 × 007D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 007D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 007D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 007D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 3041 × 0029 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 0029 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0029 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 0029 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 3041 × 000D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 000D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 000D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 000D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 3041 × 0021 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 0021 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0021 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 0021 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 3041 × 00A0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 00A0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 00A0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 3041 ÷ AC00 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ AC00 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ AC00 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 3041 ÷ AC01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ AC01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ AC01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 3041 ÷ 05D0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 05D0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 05D0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 3041 × 002D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 002D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 002D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 3041 ÷ 231A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 231A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 231A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 3041 ÷ 2024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 2024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 2024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 3041 × 002C ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 002C ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 002C ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 002C ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 3041 ÷ 1100 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 1100 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 1100 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 3041 ÷ 11A8 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 11A8 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 11A8 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 3041 ÷ 1160 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 1160 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 1160 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 3041 × 000A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 000A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 000A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 000A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 3041 × 0085 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 0085 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0085 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 0085 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 3041 × 17D6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 17D6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 17D6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0030 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0030 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0030 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0028 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0028 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0028 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0025 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0025 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0025 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 3041 × 0022 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0022 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0022 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 0020 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 0020 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3041 × 002F ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 002F ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 002F ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 002F ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 3041 × 2060 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 2060 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 2060 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 2060 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 3041 × 200B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 200B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 200B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 200B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 3041 ÷ 1F1E6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 3041 ÷ 261D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 261D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 261D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 3041 ÷ 1F3FB ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 1F3FB ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 1F3FB ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 3041 × 0001 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0001 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0001 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 3041 × 200D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 200D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 200D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 3041 ÷ 00A7 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 00A7 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 00A7 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 3041 ÷ 50005 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 50005 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 50005 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0E01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0E01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0E01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 3041 × 3041 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 3041 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 3041 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D × 000A ÷ 0061 × 000A ÷ 0308 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) × [5.01] <LINE FEED (LF)> (LF) ÷ [5.03] LATIN SMALL LETTER A (AL) × [6.0] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [0.3]');
    Test_LB('× 0061 × 0308 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 200D × 0646 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [28.0] ARABIC LETTER NOON (AL) ÷ [0.3]');
    Test_LB('× 0646 × 200D × 0020 ÷	#  × [0.3] ARABIC LETTER NOON (AL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000B ÷ 3041 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 3041 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 3041 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200D × 261D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 3041 × 2060 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2060 × 3041 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 00A0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × 00A0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [12.3] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × 002F ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [13.04] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2014 × 2014 ÷	#  × [0.3] EM DASH (B2) × [17.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 3041 ÷ FFFC ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× FFFC ÷ 3041 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 × 002D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0E01 × 2024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0021 × 2024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [22.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2024 × 2024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [22.04] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0030 × 2024 ÷	#  × [0.3] DIGIT ZERO (NU) × [22.05] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 261D × 0025 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0E01 × 0030 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0024 × 261D ÷	#  × [0.3] DOLLAR SIGN (PR) × [23.12] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0024 × 0E01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0E01 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1100 × 1160 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [26.01] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1160 × 1160 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [26.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 11A8 × 11A8 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [26.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1160 × 2024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1160 × 0025 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0024 × 1160 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.03] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 261D × 1F3FB ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [30.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0066 × 0069 × 006E × 0061 × 006C ÷	#  × [0.3] LATIN SMALL LETTER F (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER L (AL) ÷ [0.3]');
    Test_LB('× 0063 × 0061 × 006E × 0027 × 0074 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [19.01] APOSTROPHE (QU) × [19.02] LATIN SMALL LETTER T (AL) ÷ [0.3]');
    Test_LB('× 0063 × 0061 × 006E × 2019 × 0074 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [19.01] RIGHT SINGLE QUOTATION MARK (QU) × [19.02] LATIN SMALL LETTER T (AL) ÷ [0.3]');
    Test_LB('× 0027 × 0063 × 0061 × 006E × 0027 × 0020 ÷ 006E × 006F × 0074 ÷	#  × [0.3] APOSTROPHE (QU) × [19.02] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [19.01] APOSTROPHE (QU) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER T (AL) ÷ [0.3]');
    Test_LB('× 0063 × 0061 × 006E × 0020 ÷ 0027 × 006E × 006F × 0074 × 0027 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [7.01] SPACE (SP) ÷ [18.0] APOSTROPHE (QU) × [19.02] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER T (AL) × [19.01] APOSTROPHE (QU) ÷ [0.3]');
    Test_LB('× 0062 × 0075 × 0067 × 0028 × 0073 × 0029 × 0020 × 0020 × 0020 × 0020 × 0020 ÷	#  × [0.3] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER U (AL) × [28.0] LATIN SMALL LETTER G (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0062 × 0075 × 0067 × 0028 × 0073 × 0029 × 00A0 × 0020 × 0020 × 0020 × 0020 × 0020 ÷	#  × [0.3] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER U (AL) × [28.0] LATIN SMALL LETTER G (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [12.1] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002E × 002E ÷ 307E ÷ 3059 × 3002 ÷ 0058 × 004D × 004C ÷ 306E × 002E × 002E ÷	#  × [0.3] FULL STOP (IS) × [13.02] FULL STOP (IS) ÷ [999.0] HIRAGANA LETTER MA (ID) ÷ [999.0] HIRAGANA LETTER SU (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] LATIN CAPITAL LETTER X (AL) × [28.0] LATIN CAPITAL LETTER M (AL) × [28.0] LATIN CAPITAL LETTER L (AL) ÷ [999.0] HIRAGANA LETTER NO (ID) × [13.02] FULL STOP (IS) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × 00AD ÷ 0062 × 0079 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER Y (AL) ÷ [0.3]');
    Test_LB('× 002D × 0033 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [25.02] DIGIT THREE (NU) ÷ [0.3]');
    Test_LB('× 0065 × 002E × 0067 × 002E ÷	#  × [0.3] LATIN SMALL LETTER E (AL) × [13.02] FULL STOP (IS) × [29.0] LATIN SMALL LETTER G (AL) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 4E00 × 002E ÷ 4E00 × 002E ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-4E00 (ID) × [13.02] FULL STOP (IS) ÷ [999.0] CJK UNIFIED IDEOGRAPH-4E00 (ID) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 0061 × 0020 × 0020 ÷ 0062 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER B (AL) ÷ [0.3]');
    Test_LB('× 0061 × 0020 × 0020 × 200B ÷ 0062 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [8.0] LATIN SMALL LETTER B (AL) ÷ [0.3]');
    Test_LB('× 0061 × 0020 ÷ 0308 × 0062 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [7.01] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] LATIN SMALL LETTER B (AL) ÷ [0.3]');
    Test_LB('× 0031 × 0308 × 0062 × 0028 × 0061 × 0029 × 002D ÷ 0028 × 0062 × 0029 ÷	#  × [0.3] DIGIT ONE (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] LATIN SMALL LETTER B (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER A (AL) × [13.02] RIGHT PARENTHESIS (CP) × [21.02] HYPHEN-MINUS (HY) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER B (AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0067 × 0069 × 0076 × 0065 × 0020 ÷ 0062 × 006F × 006F × 006B × 0028 × 0073 × 0029 × 002E ÷	#  × [0.3] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER V (AL) × [28.0] LATIN SMALL LETTER E (AL) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER K (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 307E ÷ 0028 × 3059 × 0029 ÷	#  × [0.3] HIRAGANA LETTER MA (ID) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER SU (ID) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0066 × 0069 × 006E × 0064 × 0020 × 002E × 0063 × 006F × 006D ÷	#  × [0.3] LATIN SMALL LETTER F (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER D (AL) × [7.01] SPACE (SP) × [13.02] FULL STOP (IS) × [29.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER M (AL) ÷ [0.3]');
    Test_LB('× 0065 × 0071 × 0075 × 0061 × 006C × 0073 × 0020 × 002E ÷ 0033 × 0035 × 0020 ÷ 0063 × 0065 × 006E × 0074 × 0073 ÷	#  × [0.3] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER Q (AL) × [28.0] LATIN SMALL LETTER U (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER S (AL) × [7.01] SPACE (SP) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT THREE (NU) × [25.03] DIGIT FIVE (NU) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER S (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0073 × 0029 × 0068 × 0065 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [30.02] LATIN SMALL LETTER H (AL) × [28.0] LATIN SMALL LETTER E (AL) ÷ [0.3]');
    Test_LB('× 007B × 0073 × 007D ÷ 0068 × 0065 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER H (AL) × [28.0] LATIN SMALL LETTER E (AL) ÷ [0.3]');
    Test_LB('× 02C8 × 0073 × 0049 × 006C × 0259 × 0062 × 0028 × 0259 × 0029 × 006C ÷	#  × [0.3] MODIFIER LETTER VERTICAL LINE (BB) × [21.04] LATIN SMALL LETTER S (AL) × [28.0] LATIN CAPITAL LETTER I (AL) × [28.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER SCHWA (AL) × [28.0] LATIN SMALL LETTER B (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER SCHWA (AL) × [13.02] RIGHT PARENTHESIS (CP) × [30.02] LATIN SMALL LETTER L (AL) ÷ [0.3]');
    Test_LB('× 02C8 × 0073 × 0049 × 006C × 0259 × 0062 × 007B × 0259 × 007D ÷ 006C ÷	#  × [0.3] MODIFIER LETTER VERTICAL LINE (BB) × [21.04] LATIN SMALL LETTER S (AL) × [28.0] LATIN CAPITAL LETTER I (AL) × [28.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER SCHWA (AL) × [28.0] LATIN SMALL LETTER B (AL) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER SCHWA (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER L (AL) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 0028 × 0073 × 0029 × 002E ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 0028 × 0073 × 002E × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] FULL STOP (IS) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 0028 × 0073 × 0029 × 0021 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 0028 × 0073 × 0021 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.01] EXCLAMATION MARK (EX) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 005C ÷ 0028 × 0073 × 005C × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [24.03] REVERSE SOLIDUS (PR) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [24.03] REVERSE SOLIDUS (PR) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 0028 × 0020 × 0073 × 0020 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] LATIN SMALL LETTER S (AL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 007B × 0073 × 007D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 007B × 0073 × 007D × 002E ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 007B × 0073 × 007D × 0021 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 005C ÷ 007B × 0073 × 005C × 007D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [24.03] REVERSE SOLIDUS (PR) ÷ [999.0] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER S (AL) × [24.03] REVERSE SOLIDUS (PR) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 007B × 0020 × 0073 × 0020 × 007D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT CURLY BRACKET (OP) × [7.01] SPACE (SP) × [14.0] LATIN SMALL LETTER S (AL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0028 × 0065 × 0029 ÷ 2026 ÷ 0028 × 0073 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] HORIZONTAL ELLIPSIS (IN) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 0064 × 0028 × 0065 × 0029 ÷ 2026 × 0029 × 0073 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] HORIZONTAL ELLIPSIS (IN) × [13.02] RIGHT PARENTHESIS (CP) × [30.02] LATIN SMALL LETTER S (AL) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 007B × 0065 × 007D ÷ 2026 ÷ 007B × 0073 × 007D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] HORIZONTAL ELLIPSIS (IN) ÷ [999.0] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 0064 × 007B × 0065 × 007D ÷ 2026 × 007D ÷ 0073 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] HORIZONTAL ELLIPSIS (IN) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER S (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 002D × 0029 × 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.02] HYPHEN-MINUS (HY) × [13.02] RIGHT PARENTHESIS (CP) × [30.02] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 00AD × 0029 × 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.01] SOFT HYPHEN (BA) × [13.02] RIGHT PARENTHESIS (CP) × [30.02] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 2011 × 0029 × 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] RIGHT PARENTHESIS (CP) × [30.02] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 0029 × 002D ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT PARENTHESIS (CP) × [21.02] HYPHEN-MINUS (HY) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 0029 × 00AD ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT PARENTHESIS (CP) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 0029 × 2011 × 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT PARENTHESIS (CP) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 002D × 007D ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.02] HYPHEN-MINUS (HY) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 00AD × 007D ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.01] SOFT HYPHEN (BA) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 2011 × 007D ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 007D × 002D ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [21.02] HYPHEN-MINUS (HY) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 007D × 00AD ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 007D × 2011 × 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0063 × 0072 × 0065 × 0301 × 0028 × 0065 × 0301 × 0029 ÷ 0028 × 0065 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0063 × 0072 × 0065 × 0301 × 005B × 0065 × 0072 × 007C ÷ 0065 × 0301 × 0028 × 0065 × 0029 ÷ 0028 × 0073 × 0029 × 005D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [30.01] LEFT SQUARE BRACKET (OP) × [14.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [21.01] VERTICAL LINE (BA) ÷ [999.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] RIGHT SQUARE BRACKET (CP) ÷ [0.3]');
    Test_LB('× 0063 × 0072 × 0065 × 0301 × 007B × 0065 × 0072 × 007C ÷ 0065 × 0301 × 0028 × 0065 × 0029 ÷ 0028 × 0073 × 0029 × 007D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [21.01] VERTICAL LINE (BA) ÷ [999.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 0028 × 0308 × 0029 ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 0028 × 00AB × 0308 × 00BB × 0029 ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 0028 × 00AB × 0020 ÷ 0308 × 0020 ÷ 00BB × 0029 ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 00AB × 0020 × 0028 × 0020 × 0308 × 0020 × 0029 × 0020 ÷ 00BB × 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [19.01] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [7.01] SPACE (SP) × [15.0] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [15.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 00AB × 202F × 0028 × 0020 × 0308 × 0020 × 0029 × 202F × 00BB × 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [19.01] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [12.1] NARROW NO-BREAK SPACE (GL) × [12.0] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) × [12.1] NARROW NO-BREAK SPACE (GL) × [12.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [15.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 007B × 0308 × 007D ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT CURLY BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 007B × 00AB × 0308 × 00BB × 007D ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 007B × 00AB × 0020 ÷ 0308 × 0020 ÷ 00BB × 007D ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 00AB × 0020 × 007B × 0020 × 0308 × 0020 × 007D × 0020 ÷ 00BB × 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [19.01] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [7.01] SPACE (SP) × [15.0] LEFT CURLY BRACKET (OP) × [7.01] SPACE (SP) × [14.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [15.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 00AB × 202F × 007B × 0020 × 0308 × 0020 × 007D × 202F × 00BB × 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [19.01] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [12.1] NARROW NO-BREAK SPACE (GL) × [12.0] LEFT CURLY BRACKET (OP) × [7.01] SPACE (SP) × [14.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) × [12.1] NARROW NO-BREAK SPACE (GL) × [12.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [15.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 00AD ÷ 2011 × 0029 × 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] NON-BREAKING HYPHEN (GL) × [12.0] RIGHT PARENTHESIS (CP) × [30.02] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 00AD × 0029 × 2011 × 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [21.01] SOFT HYPHEN (BA) × [13.02] RIGHT PARENTHESIS (CP) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 0029 × 00AD ÷ 2011 × 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [13.02] RIGHT PARENTHESIS (CP) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 00AD ÷ 2011 × 007D ÷ 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] NON-BREAKING HYPHEN (GL) × [12.0] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 00AD × 007D × 2011 × 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [21.01] SOFT HYPHEN (BA) × [13.02] RIGHT CURLY BRACKET (CL) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 007D × 00AD ÷ 2011 × 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 006F × 0070 × 0065 × 0072 × 0061 × 0074 × 006F × 0072 × 005B × 005D ÷ 0028 × 0030 × 0029 × 003B ÷	#  × [0.3] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER P (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER R (AL) × [30.01] LEFT SQUARE BRACKET (OP) × [13.02] RIGHT SQUARE BRACKET (CP) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] DIGIT ZERO (NU) × [25.04] RIGHT PARENTHESIS (CP) × [13.02] SEMICOLON (IS) ÷ [0.3]');
    Test_LB('× 006F × 0070 × 0065 × 0072 × 0061 × 0074 × 006F × 0072 × 005B × 005D ÷ 0028 × 0029 ÷ 007B × 007D ÷	#  × [0.3] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER P (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER R (AL) × [30.01] LEFT SQUARE BRACKET (OP) × [13.02] RIGHT SQUARE BRACKET (CP) ÷ [999.0] LEFT PARENTHESIS (OP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] LEFT CURLY BRACKET (OP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 672C ÷ 0028 × 3092 × 0029 ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ 0028 × 300C × 3092 × 300D × 0029 ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LEFT CORNER BRACKET (OP) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ 300C × 0028 × 3092 × 0029 × 300D ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ 007B × 3092 × 007D ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT CURLY BRACKET (OP) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ 007B × 300C × 3092 × 300D × 007D ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT CURLY BRACKET (OP) × [14.0] LEFT CORNER BRACKET (OP) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ 005B × 0028 × 3092 × 0029 × 005D ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT SQUARE BRACKET (OP) × [14.0] LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] RIGHT SQUARE BRACKET (CP) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 0028 × 30CB × 30E5 × 30FC × 30FB × 0029 ÷ 30E8 × 30FC ÷ 30AF ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] KATAKANA LETTER NI (ID) × [21.03] KATAKANA LETTER SMALL YU (CJ_NS) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [21.03] KATAKANA MIDDLE DOT (NS) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] KATAKANA LETTER YO (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 0028 × 30CB × 30E5 × 30FC × 0029 × 30FB ÷ 30E8 × 30FC ÷ 30AF ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] KATAKANA LETTER NI (ID) × [21.03] KATAKANA LETTER SMALL YU (CJ_NS) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [13.02] RIGHT PARENTHESIS (CP) × [16.0] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER YO (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 007B × 30CB × 30E5 × 30FC × 30FB × 007D ÷ 30E8 × 30FC ÷ 30AF ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] KATAKANA LETTER NI (ID) × [21.03] KATAKANA LETTER SMALL YU (CJ_NS) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [21.03] KATAKANA MIDDLE DOT (NS) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] KATAKANA LETTER YO (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 007B × 30CB × 30E5 × 30FC × 007D × 30FB ÷ 30E8 × 30FC ÷ 30AF ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] KATAKANA LETTER NI (ID) × [21.03] KATAKANA LETTER SMALL YU (CJ_NS) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [13.02] RIGHT CURLY BRACKET (CL) × [16.0] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER YO (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 0028 × 1850 × 1846 × 1851 × 1846 ÷ 1806 × 0029 × 182A × 1822 × 1834 × 1822 × 182D × 180C ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] MONGOLIAN LETTER TODO TA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [28.0] MONGOLIAN LETTER TODO DA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) ÷ [999.0] MONGOLIAN TODO SOFT HYPHEN (BB) × [13.02] RIGHT PARENTHESIS (CP) × [30.02] MONGOLIAN LETTER BA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER CHA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER GA (AL) × [9.0] MONGOLIAN FREE VARIATION SELECTOR TWO (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 1850 × 1846 × 1851 × 1846 × 0029 ÷ 1806 × 182A × 1822 × 1834 × 1822 × 182D × 180C ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] MONGOLIAN LETTER TODO TA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [28.0] MONGOLIAN LETTER TODO DA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] MONGOLIAN TODO SOFT HYPHEN (BB) × [21.04] MONGOLIAN LETTER BA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER CHA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER GA (AL) × [9.0] MONGOLIAN FREE VARIATION SELECTOR TWO (CM1_CM) ÷ [0.3]');
    Test_LB('× 007B × 1850 × 1846 × 1851 × 1846 ÷ 1806 × 007D ÷ 182A × 1822 × 1834 × 1822 × 182D × 180C ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] MONGOLIAN LETTER TODO TA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [28.0] MONGOLIAN LETTER TODO DA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) ÷ [999.0] MONGOLIAN TODO SOFT HYPHEN (BB) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] MONGOLIAN LETTER BA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER CHA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER GA (AL) × [9.0] MONGOLIAN FREE VARIATION SELECTOR TWO (CM1_CM) ÷ [0.3]');
    Test_LB('× 007B × 1850 × 1846 × 1851 × 1846 × 007D ÷ 1806 × 182A × 1822 × 1834 × 1822 × 182D × 180C ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] MONGOLIAN LETTER TODO TA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [28.0] MONGOLIAN LETTER TODO DA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] MONGOLIAN TODO SOFT HYPHEN (BB) × [21.04] MONGOLIAN LETTER BA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER CHA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER GA (AL) × [9.0] MONGOLIAN FREE VARIATION SELECTOR TWO (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0068 × 0074 × 0074 × 0070 × 003A × 002F × 002F × 0029 × 0078 × 006E × 002D × 002D ÷ 0061 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER H (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER P (AL) × [13.02] COLON (IS) × [13.02] SOLIDUS (SY) × [13.02] SOLIDUS (SY) × [13.02] RIGHT PARENTHESIS (CP) × [30.02] LATIN SMALL LETTER X (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.02] HYPHEN-MINUS (HY) × [21.02] HYPHEN-MINUS (HY) ÷ [999.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 007B × 0068 × 0074 × 0074 × 0070 × 003A × 002F × 002F × 007D ÷ 0078 × 006E × 002D × 002D ÷ 0061 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER H (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER P (AL) × [13.02] COLON (IS) × [13.02] SOLIDUS (SY) × [13.02] SOLIDUS (SY) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER X (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.02] HYPHEN-MINUS (HY) × [21.02] HYPHEN-MINUS (HY) ÷ [999.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0030 × 002C × 0031 × 0029 × 002B × 0028 × 0032 × 002C × 0033 × 0029 × 2295 × 0028 × 2212 × 0034 × 002C × 0035 × 0029 × 2296 × 0028 × 0036 × 002C × 0037 × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] DIGIT ZERO (NU) × [25.03] COMMA (IS) × [25.04] DIGIT ONE (NU) × [25.04] RIGHT PARENTHESIS (CP) × [25.05] PLUS SIGN (PR) × [25.01] LEFT PARENTHESIS (OP) × [14.0] DIGIT TWO (NU) × [25.03] COMMA (IS) × [25.04] DIGIT THREE (NU) × [25.04] RIGHT PARENTHESIS (CP) × [30.02] CIRCLED PLUS (AI_AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] MINUS SIGN (PR) × [25.01] DIGIT FOUR (NU) × [25.03] COMMA (IS) × [25.04] DIGIT FIVE (NU) × [25.04] RIGHT PARENTHESIS (CP) × [30.02] CIRCLED MINUS (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] DIGIT SIX (NU) × [25.03] COMMA (IS) × [25.04] DIGIT SEVEN (NU) × [25.04] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 007B × 0030 × 002C × 0031 × 007D × 002B × 007B × 0032 × 002C × 0033 × 007D ÷ 2295 × 007B × 2212 × 0034 × 002C × 0035 × 007D ÷ 2296 × 007B × 0036 × 002C × 0037 × 007D ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] DIGIT ZERO (NU) × [25.03] COMMA (IS) × [25.04] DIGIT ONE (NU) × [25.04] RIGHT CURLY BRACKET (CL) × [25.05] PLUS SIGN (PR) × [25.01] LEFT CURLY BRACKET (OP) × [14.0] DIGIT TWO (NU) × [25.03] COMMA (IS) × [25.04] DIGIT THREE (NU) × [25.04] RIGHT CURLY BRACKET (CL) ÷ [999.0] CIRCLED PLUS (AI_AL) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] MINUS SIGN (PR) × [25.01] DIGIT FOUR (NU) × [25.03] COMMA (IS) × [25.04] DIGIT FIVE (NU) × [25.04] RIGHT CURLY BRACKET (CL) ÷ [999.0] CIRCLED MINUS (AL) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] DIGIT SIX (NU) × [25.03] COMMA (IS) × [25.04] DIGIT SEVEN (NU) × [25.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0061 × 0062 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × 0020 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × 0020 ÷ 0063 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER C (AL) ÷ [0.3]');
    Test_LB('× 0061 ÷ 307E ÷	#  × [0.3] LATIN SMALL LETTER A (AL) ÷ [999.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 0939 × 093F × 0928 × 094D × 0926 × 0940 × 0020 ÷	#  × [0.3] DEVANAGARI LETTER HA (AL) × [9.0] DEVANAGARI VOWEL SIGN I (CM1_CM) × [28.0] DEVANAGARI LETTER NA (AL) × [9.0] DEVANAGARI SIGN VIRAMA (CM1_CM) × [28.0] DEVANAGARI LETTER DA (AL) × [9.0] DEVANAGARI VOWEL SIGN II (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 092F × 0938 × 0917 × 0941 × 091A × 093F × 0924 × 0940 × 092F × 0938 × 093E × 0020 ÷	#  × [0.3] DEVANAGARI LETTER YA (AL) × [28.0] DEVANAGARI LETTER SA (AL) × [28.0] DEVANAGARI LETTER GA (AL) × [9.0] DEVANAGARI VOWEL SIGN U (CM1_CM) × [28.0] DEVANAGARI LETTER CA (AL) × [9.0] DEVANAGARI VOWEL SIGN I (CM1_CM) × [28.0] DEVANAGARI LETTER TA (AL) × [9.0] DEVANAGARI VOWEL SIGN II (CM1_CM) × [28.0] DEVANAGARI LETTER YA (AL) × [28.0] DEVANAGARI LETTER SA (AL) × [9.0] DEVANAGARI VOWEL SIGN AA (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 5370 ÷ 672C ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-5370 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 5165 ÷ 529B ÷ 3057 ÷ 30A8 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-5165 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-529B (ID) ÷ [999.0] HIRAGANA LETTER SI (ID) ÷ [999.0] KATAKANA LETTER E (ID) ÷ [0.3]');
    Test_LB('× 4F4D × 3002 ÷ 8A18 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-4F4D (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8A18 (ID) ÷ [0.3]');
    Test_LB('× 672C × 3002 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [0.3]');
    Test_LB('× 967A × 300D ÷ 306E ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-967A (ID) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [0.3]');
    Test_LB('× 3057 × 3087 ÷ 3046 ÷	#  × [0.3] HIRAGANA LETTER SI (ID) × [21.03] HIRAGANA LETTER SMALL YO (CJ_NS) ÷ [999.0] HIRAGANA LETTER U (ID) ÷ [0.3]');
    Test_LB('× 307E ÷ 0061 ÷ 672C ÷	#  × [0.3] HIRAGANA LETTER MA (ID) ÷ [999.0] LATIN SMALL LETTER A (AL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× C5C6 ÷ C5B4 ÷ C694 × 0020 ÷ 006F × 0072 × 0020 ÷ BABB ÷	#  × [0.3] HANGUL SYLLABLE EOBS (H3) ÷ [999.0] HANGUL SYLLABLE EO (H2) ÷ [999.0] HANGUL SYLLABLE YO (H2) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER R (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE MOS (H3) ÷ [0.3]');
    Test_LB('× 307E ÷ 0061 × 0062 × 0020 ÷	#  × [0.3] HIRAGANA LETTER MA (ID) ÷ [999.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3067 ÷ 4F7F ÷	#  × [0.3] HIRAGANA LETTER DE (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-4F7F (ID) ÷ [0.3]');
    Test_LB('× 3059 ÷ 308B ÷	#  × [0.3] HIRAGANA LETTER SU (ID) ÷ [999.0] HIRAGANA LETTER RU (ID) ÷ [0.3]');
    Test_LB('× 306E ÷ 30D1 ÷ 30F3 ÷	#  × [0.3] HIRAGANA LETTER NO (ID) ÷ [999.0] KATAKANA LETTER PA (ID) ÷ [999.0] KATAKANA LETTER N (ID) ÷ [0.3]');
    Test_LB('× 3046 × 3000 ÷ 3048 × 3000 ÷ 304A × 300D ÷	#  × [0.3] HIRAGANA LETTER U (ID) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] HIRAGANA LETTER E (ID) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] HIRAGANA LETTER O (ID) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [0.3]');
    Test_LB('× 308B × 0020 ÷ C740 ÷ C601 × 0020 ÷ 306B ÷	#  × [0.3] HIRAGANA LETTER RU (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE EUN (H3) ÷ [999.0] HANGUL SYLLABLE YEONG (H3) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER NI (ID) ÷ [0.3]');
    Test_LB('× 3057 × 3087 ÷ 3046 × 3002 ÷	#  × [0.3] HIRAGANA LETTER SI (ID) × [21.03] HIRAGANA LETTER SMALL YO (CJ_NS) ÷ [999.0] HIRAGANA LETTER U (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [0.3]');
    Test_LB('× 30E0 ÷ 306E ÷ 4E00 ÷	#  × [0.3] KATAKANA LETTER MU (ID) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-4E00 (ID) ÷ [0.3]');
    Test_LB('× 30D5 ÷ 30EA ÷	#  × [0.3] KATAKANA LETTER HU (ID) ÷ [999.0] KATAKANA LETTER RI (ID) ÷ [0.3]');
    Test_LB('× 30D5 ÷ 30EA × 30FC ÷ 767E ÷	#  × [0.3] KATAKANA LETTER HU (ID) ÷ [999.0] KATAKANA LETTER RI (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] CJK UNIFIED IDEOGRAPH-767E (ID) ÷ [0.3]');
    Test_LB('× 30D4 × 30E5 × 30FC ÷ 30BF ÷ 3067 ÷ 4F7F ÷ 7528 ÷ 3059 ÷ 308B ÷	#  × [0.3] KATAKANA LETTER PI (ID) × [21.03] KATAKANA LETTER SMALL YU (CJ_NS) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER TA (ID) ÷ [999.0] HIRAGANA LETTER DE (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-4F7F (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-7528 (ID) ÷ [999.0] HIRAGANA LETTER SU (ID) ÷ [999.0] HIRAGANA LETTER RU (ID) ÷ [0.3]');
    Test_LB('× 30BF × 30FC ÷ 30AD × 30FC ÷ 3092 ÷ 62BC ÷	#  × [0.3] KATAKANA LETTER TA (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KI (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] HIRAGANA LETTER WO (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-62BC (ID) ÷ [0.3]');
    Test_LB('× 30B7 × 30E7 ÷ 30F3 ÷	#  × [0.3] KATAKANA LETTER SI (ID) × [21.03] KATAKANA LETTER SMALL YO (CJ_NS) ÷ [999.0] KATAKANA LETTER N (ID) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 0020 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 0020 ÷ 0915 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [7.01] SPACE (SP) ÷ [18.0] DEVANAGARI LETTER KA (AL) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 0020 ÷ 672C ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [7.01] SPACE (SP) ÷ [18.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 3000 ÷ 672C ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 3000 ÷ 307E ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 3000 ÷ 0033 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] DIGIT THREE (NU) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × 002E × 0020 ÷ 0032 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [13.02] FULL STOP (IS) × [7.01] SPACE (SP) ÷ [18.0] DIGIT TWO (NU) ÷ [0.3]');
    Test_LB('× 0041 × 002E ÷ 0031 × 0020 ÷ BABB ÷	#  × [0.3] LATIN CAPITAL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT ONE (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE MOS (H3) ÷ [0.3]');
    Test_LB('× BD24 ÷ C5B4 × 002E × 0020 ÷ 0041 × 002E ÷ 0032 × 0020 ÷ BCFC ÷	#  × [0.3] HANGUL SYLLABLE BWASS (H3) ÷ [999.0] HANGUL SYLLABLE EO (H2) × [13.02] FULL STOP (IS) × [7.01] SPACE (SP) ÷ [18.0] LATIN CAPITAL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE BOL (H3) ÷ [0.3]');
    Test_LB('× BD10 ÷ C694 × 002E × 0020 ÷ 0041 × 002E ÷ 0033 × 0020 ÷ BABB ÷	#  × [0.3] HANGUL SYLLABLE BWA (H2) ÷ [999.0] HANGUL SYLLABLE YO (H2) × [13.02] FULL STOP (IS) × [7.01] SPACE (SP) ÷ [18.0] LATIN CAPITAL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT THREE (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE MOS (H3) ÷ [0.3]');
    Test_LB('× C694 × 002E × 0020 ÷ 0041 × 002E ÷ 0034 × 0020 ÷ BABB ÷	#  × [0.3] HANGUL SYLLABLE YO (H2) × [13.02] FULL STOP (IS) × [7.01] SPACE (SP) ÷ [18.0] LATIN CAPITAL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT FOUR (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE MOS (H3) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 3000 ÷ 300C ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] LEFT CORNER BRACKET (OP) ÷ [0.3]');
    Test_LB('× 306B ÷ 300C × 30D0 ÷ 0028 × 0062 × 0061 × 0029 × 300D ÷ 3084 ÷ 300C × 30B9 ÷	#  × [0.3] HIRAGANA LETTER NI (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] KATAKANA LETTER BA (ID) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER A (AL) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER YA (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] KATAKANA LETTER SU (ID) ÷ [0.3]');
    Test_LB('× 308B ÷ 300C × 0055 × 004B ÷ 30DD ÷ 30F3 ÷ 30C9 × 300D × FF09 × 3001 ÷ 30A8 ÷	#  × [0.3] HIRAGANA LETTER RU (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] LATIN CAPITAL LETTER U (AL) × [28.0] LATIN CAPITAL LETTER K (AL) ÷ [999.0] KATAKANA LETTER PO (ID) ÷ [999.0] KATAKANA LETTER N (ID) ÷ [999.0] KATAKANA LETTER DO (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] KATAKANA LETTER E (ID) ÷ [0.3]');
    Test_LB('× 306F × 3001 ÷ 300C × 003D × 0072 × 0061 × 006E × 0064 × 0028 × 0029 × 300D ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER HA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] EQUALS SIGN (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER D (AL) × [30.01] LEFT PARENTHESIS (OP) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 3067 × 3001 ÷ 300C × 0021 × 300D ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER DE (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] LEFT CORNER BRACKET (OP) × [13.01] EXCLAMATION MARK (EX) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 8A33 ÷ 300C × 3059 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-8A33 (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HIRAGANA LETTER SU (ID) ÷ [0.3]');
    Test_LB('× 3066 ÷ 300C × BD24 ÷ C5B4 × 003F × 300D ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER TE (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HANGUL SYLLABLE BWASS (H3) ÷ [999.0] HANGUL SYLLABLE EO (H2) × [13.01] QUESTION MARK (EX) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 306E ÷ 300C × 305D ÷	#  × [0.3] HIRAGANA LETTER NO (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HIRAGANA LETTER SO (ID) ÷ [0.3]');
    Test_LB('× 306F ÷ 300C × 30A8 ÷	#  × [0.3] HIRAGANA LETTER HA (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] KATAKANA LETTER E (ID) ÷ [0.3]');
    Test_LB('× 4F8B × FF1A ÷ 300C × 3042 × 3000 ÷ 3044 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-4F8B (ID) × [21.03] FULLWIDTH COLON (NS) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HIRAGANA LETTER A (ID) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] HIRAGANA LETTER I (ID) ÷ [0.3]');
    Test_LB('× 304F × 3001 ÷ 300C × D3C9 ÷ C591 ÷ C740 ÷	#  × [0.3] HIRAGANA LETTER KU (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HANGUL SYLLABLE PYEONG (H3) ÷ [999.0] HANGUL SYLLABLE YANG (H3) ÷ [999.0] HANGUL SYLLABLE EUN (H3) ÷ [0.3]');
    Test_LB('× 306B ÷ 300C × C81C ÷ BAA9 ÷ 0028 × 984C ÷ 540D × 0029 ÷ C740 ÷	#  × [0.3] HIRAGANA LETTER NI (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HANGUL SYLLABLE JE (H2) ÷ [999.0] HANGUL SYLLABLE MOG (H3) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] CJK UNIFIED IDEOGRAPH-984C (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-540D (ID) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] HANGUL SYLLABLE EUN (H3) ÷ [0.3]');
    Test_LB('× 5178 ÷ 300E × 30A6 × 30A3 ÷ 30AD ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-5178 (ID) ÷ [999.0] LEFT WHITE CORNER BRACKET (OP) × [14.0] KATAKANA LETTER U (ID) × [21.03] KATAKANA LETTER SMALL I (CJ_NS) ÷ [999.0] KATAKANA LETTER KI (ID) ÷ [0.3]');
    Test_LB('× 3067 ÷ 300E × 82F1 ÷ 8A9E ÷	#  × [0.3] HIRAGANA LETTER DE (ID) ÷ [999.0] LEFT WHITE CORNER BRACKET (OP) × [14.0] CJK UNIFIED IDEOGRAPH-82F1 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8A9E (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0073 × 0029 × 0020 ÷ 672C ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0073 × 0029 × 0020 ÷ 307E ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0073 × 0029 × 0020 ÷ 30AF ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 308B × 3002 ÷ 0064 × 006F × 0067 × FF08 × 72AC × FF09 ÷ 3092 ÷	#  × [0.3] HIRAGANA LETTER RU (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER G (AL) × [30.01] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] CJK UNIFIED IDEOGRAPH-72AC (ID) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) ÷ [999.0] HIRAGANA LETTER WO (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ FF08 × 307E ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 672C × 0020 ÷ 0028 × 0061 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 70B9 × 0020 ÷ 005B × 7DE8 ÷ 96C6 × 005D ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-70B9 (ID) × [7.01] SPACE (SP) ÷ [18.0] LEFT SQUARE BRACKET (OP) × [14.0] CJK UNIFIED IDEOGRAPH-7DE8 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-96C6 (ID) × [13.02] RIGHT SQUARE BRACKET (CP) ÷ [0.3]');
    Test_LB('× 0061 × 0028 × 0073 × 0029 × 0020 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× FF08 × 30B6 × 30FB ÷ 30AF ÷ 30A4 × 30C3 ÷ 30AF × 30FB ÷ 30D6 ÷	#  × [0.3] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] KATAKANA LETTER ZA (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [999.0] KATAKANA LETTER I (ID) × [21.03] KATAKANA LETTER SMALL TU (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER BU (ID) ÷ [0.3]');
    Test_LB('× 0070 × FF08 × 30AF ÷ 30A4 × 30C3 ÷ 30AF × 30FB ÷ 30D6 ÷	#  × [0.3] LATIN SMALL LETTER P (AL) × [30.01] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] KATAKANA LETTER KU (ID) ÷ [999.0] KATAKANA LETTER I (ID) × [21.03] KATAKANA LETTER SMALL TU (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER BU (ID) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × FF08 × 30AF ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [30.01] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 0028 × 5370 ÷ 672C × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] CJK UNIFIED IDEOGRAPH-5370 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 30B9 ÷ FF08 × 3044 ÷	#  × [0.3] KATAKANA LETTER SU (ID) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER I (ID) ÷ [0.3]');
    Test_LB('× 30C9 ÷ FF08 × 30DD ÷	#  × [0.3] KATAKANA LETTER DO (ID) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] KATAKANA LETTER PO (ID) ÷ [0.3]');
    Test_LB('× 30C9 × 0020 ÷ 0028 × 8CEA ÷	#  × [0.3] KATAKANA LETTER DO (ID) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) × [14.0] CJK UNIFIED IDEOGRAPH-8CEA (ID) ÷ [0.3]');
    Test_LB('× 0073 × 0029 × 300D ÷ 307E ÷	#  × [0.3] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 0061 × FF09 × 300F ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) × [13.02] RIGHT WHITE CORNER BRACKET (CL) ÷ [0.3]');
    Test_LB('× 308B × 300D × FF09 ÷ 306F ÷	#  × [0.3] HIRAGANA LETTER RU (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) ÷ [999.0] HIRAGANA LETTER HA (ID) ÷ [0.3]');
    Test_LB('× 30C9 × 300D × FF09 × 3001 ÷ 30A8 ÷	#  × [0.3] KATAKANA LETTER DO (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] KATAKANA LETTER E (ID) ÷ [0.3]');
    Test_LB('× 0072 × 006B × 0029 × 300D ÷ 3082 ÷	#  × [0.3] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER K (AL) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER MO (ID) ÷ [0.3]');
    Test_LB('× 30AF ÷ 0028 × 0061 × 0062 × 0020 ÷ 0063 × 0064 × 0029 × 300D ÷ 3082 ÷	#  × [0.3] KATAKANA LETTER KU (ID) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER D (AL) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER MO (ID) ÷ [0.3]');
    Test_LB('× 30F3 × 30FB ÷ 30DE × 30FC ÷ 30AF ÷ 0028 × 0065 × 0078 ÷	#  × [0.3] KATAKANA LETTER N (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER MA (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER X (AL) ÷ [0.3]');
    Test_LB('× 30DE × 30FC ÷ 0028 × 006D × 0061 × 0029 × 300D ÷ 306A ÷	#  × [0.3] KATAKANA LETTER MA (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER A (AL) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER NA (ID) ÷ [0.3]');
    Test_LB('× 30AC ÷ 30EF × 300D × 3002 ÷ 3053 ÷	#  × [0.3] KATAKANA LETTER GA (ID) ÷ [999.0] KATAKANA LETTER WA (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] HIRAGANA LETTER KO (ID) ÷ [0.3]');
    Test_LB('× 30AF × 300D ÷ 307E ÷	#  × [0.3] KATAKANA LETTER KU (ID) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 30EF × 300D × 3002 ÷ 3053 ÷	#  × [0.3] KATAKANA LETTER WA (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] HIRAGANA LETTER KO (ID) ÷ [0.3]');
    Test_LB('× 30AF × 300D ÷ 307E × 3001 ÷ 672C ÷	#  × [0.3] KATAKANA LETTER KU (ID) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER MA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 30AF × 300D × 3001 ÷ 30AF ÷	#  × [0.3] KATAKANA LETTER KU (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 30C7 × 30A3 ÷ 30A2 ÷ FF08 × 0061 × 0062 × FF09 × 300F ÷	#  × [0.3] KATAKANA LETTER DE (ID) × [21.03] KATAKANA LETTER SMALL I (CJ_NS) ÷ [999.0] KATAKANA LETTER A (ID) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) × [13.02] RIGHT WHITE CORNER BRACKET (CL) ÷ [0.3]');
    Test_LB('× CABD ÷ C774 ÷ C5D0 ÷ C694 × 003F × 300D ÷ 3068 ÷ 805E ÷	#  × [0.3] HANGUL SYLLABLE JJOG (H3) ÷ [999.0] HANGUL SYLLABLE I (H2) ÷ [999.0] HANGUL SYLLABLE E (H2) ÷ [999.0] HANGUL SYLLABLE YO (H2) × [13.01] QUESTION MARK (EX) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-805E (ID) ÷ [0.3]');
    Test_LB('× 540D × 0029 ÷ C740 × 0020 ÷ C54C ÷ C544 ÷ C694 × 003F × 300D ÷ 3068 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-540D (ID) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] HANGUL SYLLABLE EUN (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE AL (H3) ÷ [999.0] HANGUL SYLLABLE A (H2) ÷ [999.0] HANGUL SYLLABLE YO (H2) × [13.01] QUESTION MARK (EX) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 8CA8 × 0029 × 0020 ÷ 002D × 0020 ÷ 0028 × 0070 × 006F ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-8CA8 (ID) × [13.02] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER P (AL) × [28.0] LATIN SMALL LETTER O (AL) ÷ [0.3]');
    Test_LB('× 91CF × 0029 × 0020 × 301C × 0020 ÷ 0028 × 0070 × 006F ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-91CF (ID) × [13.02] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [16.0] WAVE DASH (NS) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER P (AL) × [28.0] LATIN SMALL LETTER O (AL) ÷ [0.3]');
    Test_LB('× 30C9 ÷ 91CD × FF09 × 0020 × 301C × 0020 ÷ 529B × 30FB ÷ 91CD ÷	#  × [0.3] KATAKANA LETTER DO (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-91CD (ID) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) × [7.01] SPACE (SP) × [16.0] WAVE DASH (NS) × [7.01] SPACE (SP) ÷ [18.0] CJK UNIFIED IDEOGRAPH-529B (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] CJK UNIFIED IDEOGRAPH-91CD (ID) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × 0022 × FF08 × 307E ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [19.01] QUOTATION MARK (QU) × [15.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 306F × 0020 ÷ 0022 × 0073 × 0022 × 0020 ÷	#  × [0.3] HIRAGANA LETTER HA (ID) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) × [19.02] LATIN SMALL LETTER S (AL) × [19.01] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 306F × 3001 × 0022 × 0054 × 0068 × 0065 × 0020 ÷	#  × [0.3] HIRAGANA LETTER HA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) × [19.01] QUOTATION MARK (QU) × [19.02] LATIN CAPITAL LETTER T (AL) × [28.0] LATIN SMALL LETTER H (AL) × [28.0] LATIN SMALL LETTER E (AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0064 × 006F × 0067 × 0022 × 0020 ÷ 3092 ÷	#  × [0.3] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER G (AL) × [19.01] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER WO (ID) ÷ [0.3]');
    Test_LB('× 0039 × 0030 × 0022 × 0020 ÷ 3068 ÷	#  × [0.3] DIGIT NINE (NU) × [25.03] DIGIT ZERO (NU) × [19.01] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 30B9 × 30FB ÷ 30AA × 30FC ÷ 30D0 × 30FC × 30FB ÷ 30B6 × 30FB ÷ 30EC ÷	#  × [0.3] KATAKANA LETTER SU (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER O (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER BA (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER ZA (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER RE (ID) ÷ [0.3]');
    Test_LB('× 30B9 × 30FB ÷ 30B8 × 30E3 ÷ 30F3 ÷	#  × [0.3] KATAKANA LETTER SU (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER ZI (ID) × [21.03] KATAKANA LETTER SMALL YA (CJ_NS) ÷ [999.0] KATAKANA LETTER N (ID) ÷ [0.3]');
    Test_LB('× 30F3 × 30FB ÷ 30D5 × 30A9 × 30C3 ÷ 30AF ÷	#  × [0.3] KATAKANA LETTER N (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER HU (ID) × [21.03] KATAKANA LETTER SMALL O (CJ_NS) × [21.03] KATAKANA LETTER SMALL TU (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 30A4 ÷ 30B8 × 30FC × 30FB ÷ 30C9 × 30C3 ÷ 30B0 × 3001 ÷ 548C ÷	#  × [0.3] KATAKANA LETTER I (ID) ÷ [999.0] KATAKANA LETTER ZI (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER DO (ID) × [21.03] KATAKANA LETTER SMALL TU (CJ_NS) ÷ [999.0] KATAKANA LETTER GU (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-548C (ID) ÷ [0.3]');
    Test_LB('× 30E1 × 30FC ÷ 30B7 × 30E7 ÷ 30F3 × 30FB ÷ 30DE × 30FC ÷ 30AF ÷	#  × [0.3] KATAKANA LETTER ME (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER SI (ID) × [21.03] KATAKANA LETTER SMALL YO (CJ_NS) ÷ [999.0] KATAKANA LETTER N (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER MA (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 30F3 × 30FB ÷ 30AF ÷ 0028 × 0061 ÷	#  × [0.3] KATAKANA LETTER N (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 30B7 × 30E7 ÷ 30F3 × 30FB ÷ 30DE ÷	#  × [0.3] KATAKANA LETTER SI (ID) × [21.03] KATAKANA LETTER SMALL YO (CJ_NS) ÷ [999.0] KATAKANA LETTER N (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 672C × 003A × 0020 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) × [13.02] COLON (IS) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 672C × 003A × 0020 ÷ 30AF ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) × [13.02] COLON (IS) × [7.01] SPACE (SP) ÷ [18.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 51FA ÷ 5178 × 003A × 0020 ÷ 30D5 ÷ 30EA × 30FC ÷ 767E ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-51FA (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-5178 (ID) × [13.02] COLON (IS) × [7.01] SPACE (SP) ÷ [18.0] KATAKANA LETTER HU (ID) ÷ [999.0] KATAKANA LETTER RI (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] CJK UNIFIED IDEOGRAPH-767E (ID) ÷ [0.3]');
    Test_LB('× 5F8C × 2026 ÷ 306B ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-5F8C (ID) × [22.03] HORIZONTAL ELLIPSIS (IN) ÷ [999.0] HIRAGANA LETTER NI (ID) ÷ [0.3]');
    Test_LB('× 3057 × 3087 ÷ 3046 × 3002 × 3002 × 3002 ÷	#  × [0.3] HIRAGANA LETTER SI (ID) × [21.03] HIRAGANA LETTER SMALL YO (CJ_NS) ÷ [999.0] HIRAGANA LETTER U (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) × [13.02] IDEOGRAPHIC FULL STOP (CL) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [0.3]');
    Test_LB('× 304D × 3001 × 0021 × 0021 × 3001 × 0021 × 0021 × 0021 ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER KI (ID) × [13.02] IDEOGRAPHIC COMMA (CL) × [13.01] EXCLAMATION MARK (EX) × [13.01] EXCLAMATION MARK (EX) × [13.02] IDEOGRAPHIC COMMA (CL) × [13.01] EXCLAMATION MARK (EX) × [13.01] EXCLAMATION MARK (EX) × [13.01] EXCLAMATION MARK (EX) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 306F × 3001 × 003F ÷ 3068 × 0021 ÷ 3092 ÷	#  × [0.3] HIRAGANA LETTER HA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) × [13.01] QUESTION MARK (EX) ÷ [999.0] HIRAGANA LETTER TO (ID) × [13.01] EXCLAMATION MARK (EX) ÷ [999.0] HIRAGANA LETTER WO (ID) ÷ [0.3]');
    Test_LB('× 305F × 3001 × 2049 ÷ 0028 × 0021 × 003F × 0029 ÷ 306E ÷	#  × [0.3] HIRAGANA LETTER TA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) × [16.0] EXCLAMATION QUESTION MARK (NS) ÷ [999.0] LEFT PARENTHESIS (OP) × [13.01] EXCLAMATION MARK (EX) × [13.01] QUESTION MARK (EX) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [0.3]');
    Test_LB('× 3084 × 3001 × 2048 ÷ 0028 × 003F × 0021 × 0029 ÷ 306E ÷	#  × [0.3] HIRAGANA LETTER YA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) × [16.0] QUESTION EXCLAMATION MARK (NS) ÷ [999.0] LEFT PARENTHESIS (OP) × [13.01] QUESTION MARK (EX) × [13.01] EXCLAMATION MARK (EX) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [0.3]');
    Test_LB('× 305F × 0020 ÷ 203D ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER TA (ID) × [7.01] SPACE (SP) ÷ [18.0] INTERROBANG (NS) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 305B × FF01 ÷ 0031 × 0030 × 0030 × 0025 ÷ 306E ÷ 5B8C ÷	#  × [0.3] HIRAGANA LETTER SE (ID) × [13.01] FULLWIDTH EXCLAMATION MARK (EX) ÷ [999.0] DIGIT ONE (NU) × [25.03] DIGIT ZERO (NU) × [25.03] DIGIT ZERO (NU) × [25.05] PERCENT SIGN (PO) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-5B8C (ID) ÷ [0.3]');
    Test_LB('× 0032 × 0033 ÷ 672C ÷	#  × [0.3] DIGIT TWO (NU) × [25.03] DIGIT THREE (NU) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 30A1 ÷ 30D9 × 30C3 ÷ 30C8 ÷ 0032 × 0036 ÷ 5B57 ÷ 3092 ÷	#  × [0.3] KATAKANA LETTER SMALL A (CJ_NS) ÷ [999.0] KATAKANA LETTER BE (ID) × [21.03] KATAKANA LETTER SMALL TU (CJ_NS) ÷ [999.0] KATAKANA LETTER TO (ID) ÷ [999.0] DIGIT TWO (NU) × [25.03] DIGIT SIX (NU) ÷ [999.0] CJK UNIFIED IDEOGRAPH-5B57 (ID) ÷ [999.0] HIRAGANA LETTER WO (ID) ÷ [0.3]');
    Test_LB('× 4F8B × FF1A ÷ 00A3 × 0032 × 0033 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-4F8B (ID) × [21.03] FULLWIDTH COLON (NS) ÷ [999.0] POUND SIGN (PR) × [25.01] DIGIT TWO (NU) × [25.03] DIGIT THREE (NU) ÷ [0.3]');
    Test_LB('× 8A18 ÷ 53F7 × 0020 ÷ 00A3 × 3002 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-8A18 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-53F7 (ID) × [7.01] SPACE (SP) ÷ [18.0] POUND SIGN (PR) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [0.3]');
    Test_LB('× 308C ÷ 308B × 3002 ÷ 0071 × 0075 ÷	#  × [0.3] HIRAGANA LETTER RE (ID) ÷ [999.0] HIRAGANA LETTER RU (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] LATIN SMALL LETTER Q (AL) × [28.0] LATIN SMALL LETTER U (AL) ÷ [0.3]');
    Test_LB('× 307E × 3002 ÷	#  × [0.3] HIRAGANA LETTER MA (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [0.3]');
    Test_LB('× 307E × 3002 ÷ 0061 × 0062 × 0020 ÷	#  × [0.3] HIRAGANA LETTER MA (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 308B × 3002 ÷ 6570 ÷	#  × [0.3] HIRAGANA LETTER RU (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-6570 (ID) ÷ [0.3]');
    Test_LB('× 308B × 3002 ÷ 3053 ÷	#  × [0.3] HIRAGANA LETTER RU (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] HIRAGANA LETTER KO (ID) ÷ [0.3]');
    Test_LB('× 3044 × 3002 ÷ 30D1 ÷	#  × [0.3] HIRAGANA LETTER I (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] KATAKANA LETTER PA (ID) ÷ [0.3]');
    Test_LB('× 30AC ÷ 30EF × 300D × 3002 ÷ 3053 ÷ 308C ÷	#  × [0.3] KATAKANA LETTER GA (ID) ÷ [999.0] KATAKANA LETTER WA (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] HIRAGANA LETTER KO (ID) ÷ [999.0] HIRAGANA LETTER RE (ID) ÷ [0.3]');
    Test_LB('× 8A9E ÷ 306E ÷ 0069 × 006F ÷ 306E × 3001 ÷ 0032 ÷ 5B57 ÷ 3092 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-8A9E (ID) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [999.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER O (AL) ÷ [999.0] HIRAGANA LETTER NO (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] DIGIT TWO (NU) ÷ [999.0] CJK UNIFIED IDEOGRAPH-5B57 (ID) ÷ [999.0] HIRAGANA LETTER WO (ID) ÷ [0.3]');
    Test_LB('× 3001 ÷ 548C ÷	#  × [0.3] IDEOGRAPHIC COMMA (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-548C (ID) ÷ [0.3]');
    Test_LB('× 3001 ÷ 30BF ÷	#  × [0.3] IDEOGRAPHIC COMMA (CL) ÷ [999.0] KATAKANA LETTER TA (ID) ÷ [0.3]');
    Test_LB('× 3001 ÷ 304B ÷	#  × [0.3] IDEOGRAPHIC COMMA (CL) ÷ [999.0] HIRAGANA LETTER KA (ID) ÷ [0.3]');
    Test_LB('× 3001 ÷ 3053 ÷ 308C ÷ 3067 ÷ 306F × 0020 ÷	#  × [0.3] IDEOGRAPHIC COMMA (CL) ÷ [999.0] HIRAGANA LETTER KO (ID) ÷ [999.0] HIRAGANA LETTER RE (ID) ÷ [999.0] HIRAGANA LETTER DE (ID) ÷ [999.0] HIRAGANA LETTER HA (ID) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3057 × 3001 ÷ 0061 × 0062 ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER SI (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 0061 ÷ 1F1E6 ÷ 0062 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER B (AL) ÷ [0.3]');
    Test_LB('× 1F1F7 × 1F1FA ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER R (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER U (RI) ÷ [0.3]');
    Test_LB('× 1F1F7 × 1F1FA ÷ 1F1F8 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER R (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER U (RI) ÷ [30.13] REGIONAL INDICATOR SYMBOL LETTER S (RI) ÷ [0.3]');
    Test_LB('× 1F1F7 × 1F1FA ÷ 1F1F8 × 1F1EA ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER R (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER U (RI) ÷ [30.13] REGIONAL INDICATOR SYMBOL LETTER S (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER E (RI) ÷ [0.3]');
    Test_LB('× 1F1F7 × 1F1FA × 200B ÷ 1F1F8 × 1F1EA ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER R (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER U (RI) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [8.0] REGIONAL INDICATOR SYMBOL LETTER S (RI) × [30.12] REGIONAL INDICATOR SYMBOL LETTER E (RI) ÷ [0.3]');
    Test_LB('× 05D0 × 002D × 05D0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [21.02] HYPHEN-MINUS (HY) × [21.1] HEBREW LETTER ALEF (HL) ÷ [0.3]');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 10) {
    Test_WB('÷ 0001 ÷ 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 000D ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 000D ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 000A ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 000A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 000B ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 000B ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 3031 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 3031 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0041 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0041 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 002E ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 002E ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0030 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0030 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 005F ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 005F ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 1F1E6 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 05D0 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0022 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0022 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 261D ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 261D ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 1F3FB ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 2640 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 2640 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 1F466 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0001 × 00AD ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 × 00AD ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 × 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 200D ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 × 200D ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0061 × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000D × 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 000B ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 000B ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 3031 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 3031 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0041 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0041 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 002E ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 002E ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0030 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0030 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 005F ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 005F ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 1F1E6 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 05D0 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 05D0 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0022 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0022 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 261D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 261D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 1F3FB ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 1F3FB ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 2640 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 2640 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 1F466 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 1F466 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 00AD ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 × 00AD ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 × 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 200D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 × 200D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0061 × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 000B ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 000B ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 3031 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 3031 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0041 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0041 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 002E ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 002E ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0030 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0030 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 005F ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 005F ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 05D0 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 05D0 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0022 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0022 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 261D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 261D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 1F3FB ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 1F3FB ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 2640 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 2640 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 1F466 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 1F466 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 00AD ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 × 00AD ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 × 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 200D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 × 200D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0061 × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0001 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 000D ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 000A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 000B ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 000B ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 3031 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 3031 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0041 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0041 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 002E ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 002E ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0030 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0030 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 005F ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 005F ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 05D0 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 05D0 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0022 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0022 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 261D ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 261D ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 1F3FB ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 1F3FB ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 2640 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 2640 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 1F466 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 1F466 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 00AD ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 × 00AD ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0300 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 × 0300 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 200D ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 × 200D ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0061 × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0001 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0001 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 000D ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 000D ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 000A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 000A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 000B ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 000B ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 3031 × 3031 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [13.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 × 3031 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0041 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0041 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 002E ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 002E ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0030 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0030 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 3031 × 005F ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 × 005F ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 1F1E6 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 05D0 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0022 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0022 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 261D ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 261D ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 1F3FB ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 2640 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 2640 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 1F466 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 3031 × 00AD ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 × 00AD ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0300 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 × 0300 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 200D ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 × 200D ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0061 × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 0001 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 000D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 000A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 000B ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 3031 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0041 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 002E ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0041 × 0030 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0030 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0041 × 005F ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 005F ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0041 × 05D0 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 05D0 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 0022 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 261D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 261D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 1F3FB ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 2640 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 2640 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 1F466 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0041 × 00AD ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0300 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 200D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 200D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 × 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0001 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0001 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 000D ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 000D ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 000A ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 000A ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 000B ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 000B ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 3031 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 3031 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0041 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0041 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 002E ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 002E ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0030 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0030 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 005F ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 005F ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 1F1E6 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 05D0 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 05D0 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0022 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0022 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 261D ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 261D ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 1F3FB ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 2640 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 2640 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 1F466 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 1F466 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 003A × 00AD ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 × 00AD ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0300 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 × 0300 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 200D ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 × 200D ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0061 × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0001 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0001 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 000D ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 000D ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 000A ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 000A ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 000B ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 000B ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 3031 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 3031 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0041 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0041 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 002E ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 002E ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0030 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0030 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 005F ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 005F ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 1F1E6 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 05D0 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 05D0 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0022 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0022 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 261D ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 261D ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 1F3FB ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 2640 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 2640 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 1F466 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 1F466 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 002C × 00AD ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 × 00AD ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0300 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 × 0300 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 200D ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 × 200D ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0061 × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0001 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0001 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 000D ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 000D ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 000A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 000A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 000B ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 000B ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 3031 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 3031 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0041 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0041 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 002E ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 002E ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0030 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0030 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 005F ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 005F ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 1F1E6 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 05D0 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 05D0 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0022 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0022 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 261D ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 261D ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 1F3FB ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 2640 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 2640 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 1F466 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 1F466 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 002E × 00AD ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 × 00AD ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0300 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 × 0300 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 200D ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 × 200D ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0061 × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 000D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 000D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 000A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 000A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 000B ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 000B ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0030 × 0041 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0041 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 002E ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 002E ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0030 × 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [8.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [8.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0030 × 005F ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 005F ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0030 × 05D0 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 05D0 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 261D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 261D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 1F3FB ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 2640 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 2640 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 1F466 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0030 × 00AD ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0300 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 200D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 200D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 0001 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 0001 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 000D ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 000D ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 000A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 000A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 000B ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 000B ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 005F × 3031 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 3031 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 005F × 0041 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0041 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 002E ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 002E ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 005F × 0030 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0030 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 005F × 005F ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 005F ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 1F1E6 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 005F × 05D0 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 05D0 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 0022 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 0022 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 261D ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 261D ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 1F3FB ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 2640 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 2640 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 1F466 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 1F466 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 005F × 00AD ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 00AD ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0300 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0300 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 200D ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 200D ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0061 × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0061 ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0061 ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0061 ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F × 0031 ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0031 ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0031 ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0001 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0001 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 000D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 000D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 000A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 000A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 000B ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 000B ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 3031 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 3031 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0041 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0041 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 002E ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 002E ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0030 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0030 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 005F ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 005F ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 1F1E6 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [15.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 × 1F1E6 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) × [15.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 05D0 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0022 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0022 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 261D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 261D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 1F3FB ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 2640 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 2640 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 1F466 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 00AD ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 × 00AD ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0300 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 × 0300 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 200D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 × 200D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0061 × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 0001 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 000D ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 000D ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 000A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 000A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 000B ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 000B ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 3031 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 3031 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0041 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0041 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 002E ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 002E ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0030 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0030 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 05D0 × 005F ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 005F ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 1F1E6 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 05D0 × 05D0 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 05D0 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 0022 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 0022 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [7.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 261D ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 261D ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 1F3FB ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 2640 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 2640 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 1F466 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 05D0 × 00AD ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 00AD ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0300 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0300 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 200D ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 200D ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0061 × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0061 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0061 ÷ 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0061 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0031 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0031 ÷ 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0031 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0001 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0001 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 000D ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 000D ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 000A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 000A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 000B ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 000B ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 3031 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 3031 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0041 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0041 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 002E ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 002E ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0030 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0030 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 005F ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 005F ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 1F1E6 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 05D0 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0022 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0022 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 261D ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 261D ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 1F3FB ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 2640 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 2640 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 1F466 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0022 × 00AD ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 × 00AD ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0300 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 × 0300 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 200D ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 × 200D ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0061 × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0001 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0001 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 000D ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 000D ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 000A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 000A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 000B ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 000B ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 3031 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 3031 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0041 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0041 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 002E ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 002E ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0030 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0030 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 005F ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 005F ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 1F1E6 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 05D0 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0022 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0022 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 261D ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 261D ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 1F3FB ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 2640 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 2640 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 1F466 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0027 × 00AD ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 × 00AD ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0300 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 × 0300 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 200D ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 × 200D ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0061 × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 0001 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 0001 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 000D ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 000D ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 000A ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 000A ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 000B ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 000B ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 3031 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 3031 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 0041 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 0041 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 003A ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 003A ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 002C ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 002C ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 002E ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 002E ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 0030 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 0030 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 005F ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 005F ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 1F1E6 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 05D0 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 05D0 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 0022 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 0022 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 0027 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 0027 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 261D ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 261D ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 261D × 1F3FB ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 × 1F3FB ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 2640 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 2640 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 1F466 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 1F466 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 261D × 00AD ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 × 00AD ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 261D × 0300 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 × 0300 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 261D × 200D ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 × 200D ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 0061 × 2060 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 261D ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 261D × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 0001 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 0001 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 000D ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 000D ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 000A ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 000A ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 000B ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 000B ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 3031 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 3031 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 0041 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 0041 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 003A ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 003A ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 002C ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 002C ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 002E ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 002E ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 0030 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 0030 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 005F ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 005F ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 1F1E6 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 05D0 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 05D0 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 0022 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 0022 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 0027 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 0027 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 261D ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 261D ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 1F3FB ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 2640 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 2640 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 1F466 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 1F466 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 00AD ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 × 00AD ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0300 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 × 0300 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 200D ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 × 200D ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 0061 × 2060 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F3FB ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F3FB × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 0001 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 0001 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 000D ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 000D ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 000A ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 000A ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 000B ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 000B ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 3031 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 3031 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 0041 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 0041 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 003A ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 003A ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 002C ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 002C ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 002E ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 002E ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 0030 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 0030 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 005F ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 005F ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 1F1E6 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 05D0 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 0022 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 0022 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 0027 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 0027 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 261D ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 261D ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 1F3FB ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 2640 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 2640 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 1F466 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 2640 × 00AD ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 × 00AD ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 2640 × 0300 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 × 0300 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 2640 × 200D ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 × 200D ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 0061 × 2060 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 2640 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 2640 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] FEMALE SIGN (Glue_After_Zwj) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 0001 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 0001 ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 000D ÷	#  ÷ [0.2] BOY (EBG) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 000D ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 000A ÷	#  ÷ [0.2] BOY (EBG) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 000A ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 000B ÷	#  ÷ [0.2] BOY (EBG) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 000B ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 3031 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 3031 ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 0041 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 0041 ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 003A ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 003A ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 002C ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 002C ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 002E ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 002E ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 0030 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 0030 ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 005F ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 005F ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 1F1E6 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 05D0 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 0022 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 0022 ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 0027 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 0027 ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 261D ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 261D ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 1F466 × 1F3FB ÷	#  ÷ [0.2] BOY (EBG) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 × 1F3FB ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 2640 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 2640 ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 1F466 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 1F466 × 00AD ÷	#  ÷ [0.2] BOY (EBG) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 × 00AD ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0300 ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 × 0300 ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 1F466 × 200D ÷	#  ÷ [0.2] BOY (EBG) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 × 200D ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 0061 × 2060 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F466 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] BOY (EBG) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0001 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0001 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 000D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 000D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 000A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 000A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 000B ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 000B ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 3031 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 3031 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0041 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0041 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 002E ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 002E ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0030 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0030 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 005F ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 005F ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 1F1E6 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 05D0 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 05D0 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0022 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0022 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 261D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 261D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 1F3FB ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 2640 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 2640 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 1F466 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 1F466 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 00AD × 00AD ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 × 00AD ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0300 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 × 0300 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 200D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 × 200D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0061 × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 000B ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 000B ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 3031 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 3031 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0041 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0041 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 002E ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 002E ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0030 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0030 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 005F ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 005F ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 05D0 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0022 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0022 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 261D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 261D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 1F3FB ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 2640 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 2640 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 1F466 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0300 × 00AD ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 × 00AD ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 200D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 × 200D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0061 × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0001 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0001 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 000D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 000D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 000A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 000A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 000B ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 000B ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 3031 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 3031 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0041 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0041 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 002E ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 002E ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0030 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0030 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 005F ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 005F ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 1F1E6 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 05D0 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 05D0 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0022 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0022 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 261D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 261D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 1F3FB ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 200D × 2640 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 2640 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 200D × 1F466 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 1F466 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 200D × 00AD ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 × 00AD ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0300 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 × 0300 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 200D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 × 200D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0061 × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 261D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 261D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 1F3FB ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 2640 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 2640 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 1F466 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 261D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 261D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 1F3FB ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 2640 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 2640 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 1F466 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 1F466 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 261D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 261D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 1F3FB ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 2640 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 2640 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 1F466 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 261D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 261D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 1F3FB ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 2640 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 2640 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 1F466 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 261D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 261D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 1F3FB ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 2640 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 2640 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 1F466 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 1F466 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 261D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 261D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 1F3FB ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 2640 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 2640 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 1F466 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 1F466 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0308 × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 261D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 261D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 1F3FB ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 2640 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 2640 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 1F466 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0308 × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 261D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 261D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 1F3FB ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 2640 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 2640 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 1F466 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 1F466 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0308 × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 261D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 261D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 1F3FB ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 1F3FB ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 2640 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 2640 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 1F466 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 1F466 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D × 000A ÷ 0061 ÷ 000A ÷ 0308 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0308 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 200D ÷ 0646 ÷	#  ÷ [0.2] SPACE (Other) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] ARABIC LETTER NOON (ALetter) ÷ [0.3]');
    Test_WB('÷ 0646 × 200D ÷ 0020 ÷	#  ÷ [0.2] ARABIC LETTER NOON (ALetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_WB('÷ 0041 × 0041 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 003A × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 003A ÷ 003A ÷ 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [7.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0022 × 05D0 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [7.2] QUOTATION MARK (Double_Quote) × [7.3] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0030 × 0030 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ZERO (Numeric) × [8.0] DIGIT ZERO (Numeric) × [10.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 002C × 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 002C ÷ 002C ÷ 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 3031 × 3031 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [13.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0041 × 005F × 0030 × 005F × 3031 × 005F ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ZERO (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] VERTICAL KANA REPEAT MARK (Katakana) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0041 × 005F × 005F × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 1F1E7 ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [15.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 1F1E6 × 1F1E7 ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [16.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 1F1E6 × 1F1E7 × 200D ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [16.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 1F1E6 × 200D × 1F1E7 ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [16.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 1F1E6 × 1F1E7 ÷ 1F1E8 × 1F1E9 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [16.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) × [16.0] REGIONAL INDICATOR SYMBOL LETTER D (RI) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 261D × 1F3FB ÷ 261D ÷	#  ÷ [0.2] WHITE UP POINTING INDEX (E_Base) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [999.0] WHITE UP POINTING INDEX (E_Base) ÷ [0.3]');
    Test_WB('÷ 1F466 × 1F3FB ÷	#  ÷ [0.2] BOY (EBG) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 200D × 1F466 × 1F3FB ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] BOY (EBG) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (E_Modifier) ÷ [0.3]');
    Test_WB('÷ 200D × 2640 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] FEMALE SIGN (Glue_After_Zwj) ÷ [0.3]');
    Test_WB('÷ 200D × 1F466 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 1F466 ÷ 1F466 ÷	#  ÷ [0.2] BOY (EBG) ÷ [999.0] BOY (EBG) ÷ [0.3]');
    Test_WB('÷ 0061 × 0308 × 200D × 0308 × 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
}
Finished();
